-- MySQL dump 10.13  Distrib 5.6.11-ndb-7.3.2, for linux-glibc2.5 (x86_64)
--
-- Host: 127.0.0.1    Database: edifilesdb
-- ------------------------------------------------------
-- Server version	5.6.11-ndb-7.3.2-cluster-commercial-advanced

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `edifiles23feb`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `edifiles23feb` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `edifiles23feb`;

--
-- Table structure for table `Address`
--

DROP TABLE IF EXISTS `Address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Address` (
  `AddressId` bigint(64) NOT NULL AUTO_INCREMENT,
  `AddressLine1` varchar(100) DEFAULT NULL,
  `AddressLine2` varchar(100) DEFAULT NULL,
  `City` varchar(100) DEFAULT NULL,
  `County` varchar(100) DEFAULT NULL,
  `CountyCode` varchar(5) DEFAULT NULL,
  `State` char(2) DEFAULT NULL,
  `ZipCode` char(10) DEFAULT NULL,
  `ZipCodePlusFour` char(4) DEFAULT NULL,
  `HomePhone` varchar(45) DEFAULT NULL,
  `CellPhone` varchar(45) DEFAULT NULL,
  `WorkPhone` varchar(45) DEFAULT NULL,
  `FriendPhone` varchar(45) DEFAULT NULL,
  `Employer` varchar(45) DEFAULT NULL,
  `Fax` varchar(45) DEFAULT NULL,
  `FFMAddressType` varchar(50) DEFAULT NULL,
  `FFMPriorityType` varchar(8) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`AddressId`)
) ENGINE=innodb AUTO_INCREMENT=237 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Address`
--

LOCK TABLES `Address` WRITE;
/*!40000 ALTER TABLE `Address` DISABLE KEYS */;
INSERT INTO `Address` VALUES (134,'S Main Street','','Akron','Summit',NULL,'OH','44333','1234',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'2008-01-08 10:52:32',NULL,NULL);
/*!40000 ALTER TABLE `Address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `AddressH`
--

DROP TABLE IF EXISTS `AddressH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `AddressH` (
  `AddressHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `AddressId` bigint(64) NOT NULL,
  `AddressLine1` varchar(100) DEFAULT NULL,
  `AddressLine2` varchar(100) DEFAULT NULL,
  `City` varchar(100) DEFAULT NULL,
  `County` varchar(100) DEFAULT NULL,
  `State` char(2) DEFAULT NULL,
  `ZipCode` char(10) DEFAULT NULL,
  `ZipCodePlusFour` char(4) DEFAULT NULL,
  `HomePhone` varchar(45) DEFAULT NULL,
  `CellPhone` varchar(45) DEFAULT NULL,
  `WorkPhone` varchar(45) DEFAULT NULL,
  `Fax` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`AddressHId`),
  KEY `AddressHRefAddress_fk` (`AddressId`)
) ENGINE=innodb AUTO_INCREMENT=180 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `AddressH`
--

LOCK TABLES `AddressH` WRITE;
/*!40000 ALTER TABLE `AddressH` DISABLE KEYS */;
/*!40000 ALTER TABLE `AddressH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `AppFunction`
--

DROP TABLE IF EXISTS `AppFunction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `AppFunction` (
  `FunctionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `ViewId` bigint(64) NOT NULL,
  `FunctionName` varchar(200) NOT NULL,
  `FunctionEntryURL` varchar(200) DEFAULT NULL,
  `IsExternalUrl` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FunctionId`),
  KEY `FunctionRefView_fk_idx` (`ViewId`)
) ENGINE=innodb AUTO_INCREMENT=151 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `AppFunction`
--

LOCK TABLES `AppFunction` WRITE;
/*!40000 ALTER TABLE `AppFunction` DISABLE KEYS */;
INSERT INTO `AppFunction` VALUES (12,7,34,'Manage Job Titles','Admin\\Controller\\JobTitle',0,1,'2013-05-07 12:16:41',1,'2014-02-26 13:58:48'),(25,3,2,'Contact Settings','GeneralAdmin\\Controller\\ContactSettings',0,1,'2013-05-10 12:05:44',NULL,NULL),(7,8,34,'Manage Domain Contact Info','Admin\\Controller\\DomainContactInfo',0,1,'2013-05-07 12:16:41',1,'2014-02-26 13:59:22'),(28,1,3,'Manage Locations','GeneralAdmin\\Controller\\ManageLocations',0,1,'2013-05-13 05:56:33',NULL,NULL),(69,2,18,'Beneficiary Information','Individual\\Controller\\Beneficiary',0,1,'2013-07-01 11:15:50',NULL,NULL),(36,0,5,'Company Documents','Employee\\Controller\\CompanyDocuments',0,1,'2013-05-15 03:00:12',NULL,NULL),(104,6,21,'Broker Administration','Provider\\Controller\\Brokers',0,1,'2013-08-12 15:46:10',1,'2013-08-12 16:05:29'),(54,0,10,'Plans','Employer\\Controller\\Plans',0,1,'2013-06-06 15:32:16',NULL,NULL),(124,2,31,'Provider Display Fields','Admin\\Controller\\DomainPlanDetailName',0,1,'2014-02-25 15:01:07',NULL,NULL),(86,8,31,'Provider Plan Template','Admin\\Controller\\ProviderPlanTemplate',0,1,'2013-07-15 06:17:33',1,'2014-02-25 14:57:19'),(129,3,33,'Broker Providers','Admin\\Controller\\BrokerProvider',0,1,'2014-02-26 13:53:25',NULL,NULL),(47,2,7,'Transaction Log','Employer\\Controller\\TransactionLog',0,1,'2013-05-30 00:09:10',NULL,NULL),(4,6,35,'Views','Admin\\Controller\\AppView',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:12:50'),(107,9,21,'Sales Metrics','Provider\\Controller\\SalesMetrics',0,1,'2013-08-12 16:09:50',NULL,NULL),(24,4,2,'General Settings','GeneralAdmin\\Controller\\GeneralSettings',0,1,'2013-05-10 12:05:23',NULL,NULL),(40,4,3,'Company Documents','GeneralAdmin\\Controller\\CompanyDocuments',0,1,'2013-05-18 16:22:14',NULL,NULL),(119,1,30,'Enrollments','Admin\\Controller\\Enrollments',0,1,'2014-02-25 14:44:42',NULL,NULL),(8,3,32,'Manage Domains','Admin\\Controller\\Domain',0,1,'2013-05-07 12:16:41',1,'2014-02-25 15:55:25'),(31,6,3,'Admin Signature','GeneralAdmin\\Controller\\AdminSignature',0,1,'2013-05-14 05:00:56',NULL,NULL),(126,1,31,'Provider Composite Rate','Admin\\Controller\\ProviderCompositeRate',0,1,'2014-02-25 15:42:46',NULL,NULL),(71,2,34,'Employer Age Rate','Admin\\Controller\\EmployerAgeRate',0,1,'2013-07-08 18:45:25',1,'2014-02-26 13:59:53'),(29,2,3,'Manage Departments','GeneralAdmin\\Controller\\ManageDepartments',0,1,'2013-05-13 13:49:08',NULL,NULL),(139,1,33,'Direct Enrollment','Admin\\Controller\\DirectEnrollment',0,1,'2014-02-27 09:48:15',NULL,NULL),(49,7,3,'Payroll Deduction Categories','GeneralAdmin\\Controller\\PayrollDeductionType',0,1,'2013-05-30 04:38:55',1,'2013-07-19 10:09:48'),(123,3,31,'Provider Display Fields - Categories','Admin\\Controller\\PlanDetailCategory',0,1,'2014-02-25 14:58:37',1,'2014-02-27 09:55:49'),(105,7,21,'Licensing','Provider\\Controller\\Licensing',0,1,'2013-08-12 16:08:35',NULL,NULL),(43,6,3,'Termination Reason','GeneralAdmin\\Controller\\TerminationReason',0,1,'2013-05-22 15:21:21',NULL,NULL),(98,3,19,'Healthcare Reform Tools','GetLicensed\\Controller\\ReformTools',0,1,'2013-08-01 04:49:51',NULL,NULL),(1,2,29,'Manage Addresses','Admin\\Controller\\Address',0,1,'2013-05-07 12:16:41',1,'2014-02-27 09:54:22'),(58,1,15,'Profile','Broker\\Controller\\ContactInformation',0,1,'2013-06-17 19:40:57',NULL,NULL),(120,2,30,'Export Public Quotes','Admin\\Controller\\ExportPublicQuotes',0,1,'2014-02-25 14:46:55',NULL,NULL),(92,2,8,'Manage Plans','Provider\\Controller\\Plans',0,1,'2013-07-29 07:00:27',NULL,NULL),(88,3,34,'Employer Child Age Rate','Admin\\Controller\\EmployerChildAgeRate',0,1,'2013-07-15 14:10:33',1,'2014-02-26 14:00:27'),(42,2,4,'Dependent Information','Employee\\Controller\\DependentInformation',0,1,'2013-05-21 18:39:45',NULL,NULL),(138,1,1,'Subdomain','Admin\\Controller\\Subdomain',0,1,'2014-02-27 09:47:31',NULL,NULL),(34,5,32,'Technical Support','Admin\\Controller\\TechnicalSupport',0,1,'2013-05-15 00:33:35',1,'2014-02-27 09:33:34'),(117,3,30,'Export Group Quotes','Admin\\Controller\\ExportGroupPublicQuotes',0,1,'2014-02-03 09:40:41',1,'2014-02-25 14:41:34'),(27,2,1,'User Settings','Admin\\Controller\\UserSettings',0,1,'2013-05-13 05:35:15',NULL,NULL),(16,2,32,'Assign Modules to Role','Admin\\Controller\\RoleModule',0,1,'2013-05-07 12:16:41',1,'2014-02-27 09:32:45'),(41,5,3,'Custom Fields','GeneralAdmin\\Controller\\CustomFields',0,1,'2013-05-18 17:00:19',NULL,NULL),(46,2,11,'Add / Drop Coverage','Employee\\Controller\\AddDropCoverageIndex',0,1,'2013-05-29 23:52:28',NULL,NULL),(101,2,20,'Manage Producers','GetLicensed\\Controller\\AgencyProducer',0,1,'2013-08-01 04:57:49',NULL,NULL),(133,9,34,'Export Covered Persons','Admin\\Controller\\ExportEnrolledPerson',0,1,'2014-02-27 09:35:49',NULL,NULL),(11,8,35,'Domain View Overrides','Admin\\Controller\\DomainViewOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:14:01'),(50,8,3,'Payroll Addition Categories','GeneralAdmin\\Controller\\PayrollAdditionsCategory',0,1,'2013-05-30 04:39:55',1,'2013-07-19 10:10:01'),(30,3,3,'Manage Classes','GeneralAdmin\\Controller\\ManageClasses',0,1,'2013-05-14 04:06:56',NULL,NULL),(150,2,9,'Technical Support','GlobalAdmin\\Controller\\TechnicalSupport',0,1,'2013-05-15 00:33:35',NULL,NULL),(15,10,35,'Role Function Overrides','Admin\\Controller\\RoleFunctionOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:15:55'),(94,4,8,'Plan Administration','Provider\\Controller\\PlanAdmin',0,1,'2013-07-29 07:01:21',1,'2013-07-30 08:04:49'),(48,6,3,'Job Titles','GeneralAdmin\\Controller\\JobTitle',0,1,'2013-05-30 04:01:27',NULL,NULL),(59,2,11,'Beneficiary Information','Employee\\Controller\\Beneficiary',0,1,'2013-06-19 15:29:30',NULL,NULL),(32,3,4,'Digital Signature','Employee\\Controller\\UserSignature',0,1,'2013-05-14 07:41:16',NULL,NULL),(5,3,29,'Contact Detail','Admin\\Controller\\ContactDetail',0,1,'2013-05-07 12:16:41',1,'2014-02-27 09:54:41'),(81,4,34,'Employer Composite Rate','Admin\\Controller\\EmployerCompositeRate',0,1,'2013-07-11 21:06:22',1,'2014-02-26 14:02:39'),(23,2,2,'Manage Users','GeneralAdmin\\Controller\\ManageUsers',0,1,'2013-05-10 12:04:58',NULL,NULL),(130,6,34,'Manage Locations','Admin\\Controller\\Location',0,1,'2014-02-26 13:54:23',NULL,NULL),(97,2,19,'Brochures and Plan Information','GetLicensed\\Controller\\BrochuresAndPlanInformation',0,1,'2013-08-01 04:48:43',NULL,NULL),(96,1,19,'Welcome to Broker Tools!','GetLicensed\\Controller\\HealthSpan',0,1,'2013-08-01 04:48:13',NULL,NULL),(6,5,34,'Manage Departments','Admin\\Controller\\Department',0,1,'2013-05-07 12:16:41',1,'2014-02-26 13:57:11'),(22,1,2,'Manage Roles','GeneralAdmin\\Controller\\ManageRoles',0,1,'2013-05-10 12:04:30',NULL,NULL),(73,6,31,'Provider Plan','Admin\\Controller\\ProviderPlan',0,1,'2013-07-08 18:46:49',1,'2014-02-27 09:57:06'),(57,2,13,'Plan Designs','Broker\\Controller\\Plans',0,1,'2013-06-14 00:41:42',NULL,NULL),(93,3,8,'Manage Rates','Provider\\Controller\\ManageRates',0,1,'2013-07-29 07:00:51',1,'2013-08-03 13:19:02'),(135,2,33,'Domain Package','Admin\\Controller\\DomainPackage',0,1,'2014-02-27 09:37:39',NULL,NULL),(3,1,35,'Modules','Admin\\Controller\\AppModule',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:07:23'),(74,7,31,'Provider Plan Documents','Admin\\Controller\\ProviderPlanDocument',0,1,'2013-07-11 12:58:03',1,'2014-02-27 09:56:30'),(10,4,32,'Assign Modules to Domain','Admin\\Controller\\DomainModule',0,1,'2013-05-07 12:16:41',1,'2014-02-25 15:55:59'),(90,10,31,'Manage Tiers','Admin\\Controller\\TierName',0,1,'2013-07-22 08:20:40',1,'2014-02-25 15:53:38'),(35,1,9,'Database List','GlobalAdmin\\Controller\\DatabaseList',0,1,'2013-05-15 00:34:08',NULL,NULL),(118,1,29,'Manage Users','Admin\\Controller\\User',0,1,'2014-02-25 14:16:36',1,'2014-02-27 09:54:57'),(65,1,17,'My Information','Individual\\Controller\\MyInformation',0,1,'2013-07-01 11:13:57',NULL,NULL),(68,1,18,'My Plans','Individual\\Controller\\MyPlans',0,1,'2013-07-01 11:15:30',NULL,NULL),(38,0,6,'Groups','Broker\\Controller\\Groups',0,1,'2013-05-15 03:47:33',NULL,NULL),(106,8,21,'Commissions','Provider\\Controller\\Commissions',0,1,'2013-08-12 16:09:15',NULL,NULL),(19,4,35,'User Function Overrides','Admin\\Controller\\UserFunctionOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:17:34'),(33,1,4,'My Information','Employee\\Controller\\MyInformation',0,1,'2013-05-14 11:49:58',NULL,NULL),(60,1,16,'Individual Mandate Calculator',' Employer\\Controller\\ResourcesIndividualMandate',0,1,'2013-06-27 14:17:37',NULL,NULL),(134,9,31,'Syncronize Plans','Admin\\Controller\\SyncPlans',0,1,'2014-02-27 09:37:01',NULL,NULL),(67,3,17,'Digital Signature','Individual\\Controller\\DigitalSignature',0,1,'2013-07-01 11:15:04',NULL,NULL),(89,0,13,'Quotes','Broker\\Controller\\Quotes',0,1,'2013-07-18 19:05:41',NULL,NULL),(99,4,19,'Quoting and Enrolling','GetLicensed\\Controller\\Quoting',0,1,'2013-08-01 04:56:21',NULL,NULL),(44,3,10,'Open Enrollment','Employer\\Controller\\OpenEnrollment',0,1,'2013-05-29 23:14:19',NULL,NULL),(82,5,31,'Lines of Coverage','Admin\\Controller\\LineOfCoverage',0,1,'2013-07-15 06:13:27',1,'2014-02-27 09:11:49'),(21,7,35,'User View Overrides','Admin\\Controller\\UserViewOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:17:07'),(55,0,10,'Make a Change','Employer\\Controller\\MakeAChange',0,1,'2013-06-06 15:33:03',NULL,NULL),(128,4,33,'View Producers','Admin\\Controller\\Producer',0,1,'2014-02-26 13:52:25',NULL,NULL),(127,1,32,'Manage Roles','Admin\\Controller\\Role',0,1,'2014-02-25 15:57:03',1,'2014-02-27 09:29:20'),(108,12,31,'Provider Insurance Companies','Admin\\Controller\\ProviderInsuranceCompany',0,1,'2013-05-07 12:16:41',1,'2014-02-27 09:12:19'),(121,4,31,'Provider Line Of Coverage','Admin\\Controller\\ProviderLineOfCoverage',0,1,'2014-02-25 14:51:33',NULL,NULL),(132,1,35,'Modules','Admin\\Controller\\AppModule',0,1,'2014-02-26 14:05:16',NULL,NULL),(17,9,35,'Role View Overrides','Admin\\Controller\\RoleViewOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:15:12'),(9,5,35,'Domain Function Overrides','Admin\\Controller\\DomainFunctionOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:14:38'),(2,3,35,'Functions','Admin\\Controller\\AppFunction',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:13:25'),(53,0,11,'My Plans','Employee\\Controller\\MyPlans',0,1,'2013-06-06 04:25:55',NULL,NULL),(95,5,8,'Global Administration','Provider\\Controller\\Global',0,1,'2013-07-29 07:01:47',NULL,NULL),(91,11,31,'Manage Tier Values','Admin\\Controller\\TierNameValue',0,1,'2013-07-22 14:32:33',1,'2014-02-25 15:54:00'),(63,2,6,'Individuals','Broker\\Controller\\Individuals',0,1,'2013-06-27 14:57:37',NULL,NULL),(100,1,20,'Get Appointed','GetLicensed\\Controller\\Index',0,1,'2013-08-01 04:56:56',NULL,NULL),(56,1,14,'Profile','Employer\\Controller\\ContactInformation',0,1,'2013-06-10 11:01:08',NULL,NULL),(136,6,33,'Activity Errors','Admin\\Controller\\ActivityErrors',0,1,'2014-02-27 09:38:30',1,'2014-02-27 09:59:12'),(45,3,11,'Open Enrollment','Employee\\Controller\\OpenEnrollmentMessage',0,1,'2013-05-29 23:17:18',NULL,NULL),(66,2,17,'Dependent Information','Individual\\Controller\\Dependents',0,1,'2013-07-01 11:14:41',NULL,NULL),(137,5,33,'User Tracking','Admin\\Controller\\Tracking',0,1,'2014-02-27 09:46:38',NULL,NULL),(37,1,7,'Manage Employees','Employer\\Controller\\ManageEmployees',0,1,'2013-05-15 03:47:09',NULL,NULL),(83,13,31,'Provider Display Fields','Admin\\Controller\\DomainPlanDetailName',0,1,'2013-07-15 06:15:04',1,'2014-02-25 15:29:05'),(131,1,34,'Employer Plans','Admin\\Controller\\EmployerPlan',0,1,'2014-02-26 14:03:56',NULL,NULL),(64,2,15,'Producers','Broker\\Controller\\Producers',0,1,'2013-06-27 14:57:54',NULL,NULL),(20,2,35,'User Module Overrides','Admin\\Controller\\UserModuleOverride',0,1,'2013-05-07 12:16:41',1,'2014-02-26 14:16:34'),(26,5,2,'Login History','GeneralAdmin\\Controller\\LoginHistory',0,1,'2013-05-10 12:06:01',NULL,NULL),(61,2,16,'Tax Credit Calculator','Employer\\Controller\\ResourcesSmallBusinessTaxCredit',0,1,'2013-06-27 14:18:08',NULL,NULL);
/*!40000 ALTER TABLE `AppFunction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `AppModule`
--

DROP TABLE IF EXISTS `AppModule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `AppModule` (
  `AppModuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `Resource` varchar(100) NOT NULL,
  `SortKey` int(11) NOT NULL,
  `ModuleName` varchar(200) NOT NULL,
  `ModuleType` enum('Provider','Broker','Employer','Site Admin','PTO','Employee','TimeKeeping','Individual') NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`AppModuleId`)
) ENGINE=innodb AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `AppModule`
--

LOCK TABLES `AppModule` WRITE;
/*!40000 ALTER TABLE `AppModule` DISABLE KEYS */;
INSERT INTO `AppModule` VALUES (7,'GlobalAdmin',7,'Global Admin','Site Admin',1,'2013-05-22 05:04:14',NULL,NULL),(4,'Employer',4,'Employer','Employer',1,'2013-05-14 22:57:55',NULL,NULL),(8,'Individual',0,'Individual','Individual',1,'2013-07-01 08:08:31',NULL,NULL),(1,'Admin',1,'Developer Admin','Provider',1,'2013-04-30 16:44:35',1,'2013-05-13 18:01:53'),(3,'Employee',3,'Employee','Employee',1,'2013-05-14 22:57:41',1,'2013-05-14 23:32:26'),(9,'GetLicensed',1,'Get Licensed','Provider',1,'2013-08-02 15:36:58',NULL,NULL),(2,'GeneralAdmin',2,'Admin','Provider',1,'2013-04-30 22:06:05',1,'2013-05-13 18:03:29'),(5,'Broker',5,'Broker','Broker',1,'2013-05-14 22:58:06',NULL,NULL),(6,'Provider',6,'Provider','Provider',1,'2013-05-14 22:58:17',NULL,NULL);
/*!40000 ALTER TABLE `AppModule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `AppView`
--

DROP TABLE IF EXISTS `AppView`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `AppView` (
  `ViewId` bigint(64) NOT NULL AUTO_INCREMENT,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `AppModuleId` bigint(64) DEFAULT NULL,
  `ViewName` varchar(100) DEFAULT NULL,
  `BootstrapIcon` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ViewId`),
  KEY `AppViewRefAppModule_fk_idx` (`AppModuleId`)
) ENGINE=innodb AUTO_INCREMENT=36 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `AppView`
--

LOCK TABLES `AppView` WRITE;
/*!40000 ALTER TABLE `AppView` DISABLE KEYS */;
INSERT INTO `AppView` VALUES (16,4,4,'Resources','iconic-home',1,'2013-06-27 11:16:58',NULL,NULL),(11,2,3,'Benefits','iconic-plus',1,'2013-05-29 20:16:46',1,'2013-06-13 20:17:39'),(30,2,1,'Reports','',1,'2014-02-25 14:25:49',1,'2014-02-27 09:49:23'),(15,3,5,'My Company Info','iconic-home',1,'2013-06-17 16:39:35',NULL,NULL),(13,2,5,'Quoting & Enrolling','iconic-home',1,'2013-06-07 19:32:38',NULL,NULL),(7,1,4,'Employees','iconic-user',1,'2013-05-15 00:46:08',1,'2013-06-13 20:17:09'),(4,1,3,'Profile','iconic-user',1,'2013-05-14 04:41:50',1,'2013-06-13 20:17:01'),(8,1,6,'Plans','iconic-home',1,'2013-05-15 00:46:15',1,'2013-07-30 18:28:26'),(31,4,1,'Provider Area','',1,'2014-02-25 14:26:18',1,'2014-02-27 09:49:55'),(29,1,1,'Users','',1,'2014-02-25 14:12:34',1,'2014-02-27 09:49:09'),(1,7,1,'Global Admin','iconic-home',1,'2013-05-07 09:04:59',1,'2014-02-27 09:50:43'),(34,5,1,'Employer Area','',1,'2014-02-25 14:27:46',1,'2014-02-27 09:50:13'),(27,1,1,'Resources','iconic-home',1,'2014-02-03 09:47:56',NULL,NULL),(3,2,2,'Company Management','iconic-home',1,'2013-05-13 04:29:53',1,'2013-05-30 01:07:25'),(10,2,4,'Benefits','iconic-plus',1,'2013-05-29 20:08:27',1,'2013-06-13 20:17:34'),(35,8,1,'Overrides & Setup','',1,'2014-02-25 14:28:13',1,'2014-02-27 09:51:05'),(19,1,9,'Resources','iconic-home',1,'2013-08-01 04:45:06',NULL,NULL),(33,3,1,'Broker Area','',1,'2014-02-25 14:27:23',1,'2014-02-27 09:49:39'),(20,2,9,'Licensing','iconic-home',1,'2013-08-01 04:45:26',NULL,NULL),(18,2,8,'Benefits','iconic-plus',1,'2013-07-01 08:13:31',NULL,NULL),(21,2,6,'Brokers','iconic-home',1,'2013-08-12 15:45:09',1,'2013-08-12 15:51:33'),(14,3,4,'Company Management','iconic-folder',1,'2013-06-10 08:00:15',1,'2013-06-13 20:17:24'),(17,1,8,'Profile','iconic-user',1,'2013-07-01 08:13:17',NULL,NULL),(9,1,7,'Global Admin','',1,'2013-05-22 05:39:07',NULL,NULL),(2,1,2,'Site Administration','iconic-home',1,'2013-05-10 09:03:57',1,'2013-05-30 02:09:32'),(5,3,3,'Company Documents','iconic-folder',1,'2013-05-14 23:59:45',1,'2013-06-13 20:17:17'),(32,6,1,'Administrative Area','',1,'2014-02-25 14:27:00',1,'2014-02-27 09:50:29'),(6,1,5,'Customers','iconic-home',1,'2013-05-15 00:46:00',1,'2013-06-07 19:32:24');
/*!40000 ALTER TABLE `AppView` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerInsurance`
--

DROP TABLE IF EXISTS `BrokerInsurance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerInsurance` (
  `BrokerInsuranceId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `EandOPolicyNumber` varchar(50) DEFAULT NULL,
  `EandOEffectiveDate` date DEFAULT NULL,
  `EandOInsuranceName` varchar(100) DEFAULT NULL,
  `HasAgreed` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`BrokerInsuranceId`),
  KEY `BrokerInsuranceRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerInsurance`
--

LOCK TABLES `BrokerInsurance` WRITE;
/*!40000 ALTER TABLE `BrokerInsurance` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerInsurance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerLicense`
--

DROP TABLE IF EXISTS `BrokerLicense`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerLicense` (
  `BrokerLicenseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `LicenseState` char(2) DEFAULT NULL,
  `License` varchar(50) DEFAULT NULL,
  `NPN` varchar(20) DEFAULT NULL,
  `PaymentObjectName` varchar(50) DEFAULT NULL,
  `AgreedToAssignCommissions` tinyint(1) NOT NULL DEFAULT '0',
  `SubmittedTimestamp` timestamp NULL DEFAULT NULL,
  `SignaturePath` varchar(100) DEFAULT NULL,
  `GracePeriod` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`BrokerLicenseId`),
  KEY `BrokerLicenseRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerLicense`
--

LOCK TABLES `BrokerLicense` WRITE;
/*!40000 ALTER TABLE `BrokerLicense` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerLicense` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerNote`
--

DROP TABLE IF EXISTS `BrokerNote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerNote` (
  `BrokerNoteId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `NoteTitle` varchar(100) DEFAULT NULL,
  `NoteText` varchar(2000) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`BrokerNoteId`),
  KEY `BrokerNoteRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerNote`
--

LOCK TABLES `BrokerNote` WRITE;
/*!40000 ALTER TABLE `BrokerNote` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerNote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerNoteH`
--

DROP TABLE IF EXISTS `BrokerNoteH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerNoteH` (
  `BrokerNoteHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `BrokerNoteId` bigint(64) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `NoteTitle` varchar(100) DEFAULT NULL,
  `NoteText` varchar(2000) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`BrokerNoteHId`),
  KEY `BrokerNoteRefDomain_fk_idx` (`DomainId`),
  KEY `BrokerNoteHRefBrokerNote_fk_idx` (`BrokerNoteId`)
) ENGINE=innodb AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerNoteH`
--

LOCK TABLES `BrokerNoteH` WRITE;
/*!40000 ALTER TABLE `BrokerNoteH` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerNoteH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerProvider`
--

DROP TABLE IF EXISTS `BrokerProvider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerProvider` (
  `BrokerProviderId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ProviderDomainId` bigint(64) NOT NULL,
  `ClickedOnUserAgreement` tinyint(1) NOT NULL DEFAULT '0',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`BrokerProviderId`),
  KEY `BrokerPlanRefDomain_fk_idx` (`DomainId`),
  KEY `BrokerProviderRefProviderDomain_fk_idx` (`ProviderDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerProvider`
--

LOCK TABLES `BrokerProvider` WRITE;
/*!40000 ALTER TABLE `BrokerProvider` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerProvider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerQuestionnaireResponse`
--

DROP TABLE IF EXISTS `BrokerQuestionnaireResponse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerQuestionnaireResponse` (
  `BrokerQuestionnaireResponseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `UserId` bigint(64) DEFAULT NULL,
  `ProviderQuestionnaireId` bigint(64) NOT NULL,
  `Response` enum('Yes','No') NOT NULL DEFAULT 'No',
  `ResponseReason` varchar(2000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`BrokerQuestionnaireResponseId`),
  KEY `BrokerQuestionnaireResponseRefDomainId_fk_idx` (`DomainId`),
  KEY `BrokerQuestionnaireResponseRefProviderQuestionnaire_fk_idx` (`ProviderQuestionnaireId`),
  KEY `BrokerQuestionnaireResponseRefUser_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=92 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerQuestionnaireResponse`
--

LOCK TABLES `BrokerQuestionnaireResponse` WRITE;
/*!40000 ALTER TABLE `BrokerQuestionnaireResponse` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerQuestionnaireResponse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `BrokerQuote`
--

DROP TABLE IF EXISTS `BrokerQuote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `BrokerQuote` (
  `BrokerQuoteId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `QuoteDisplayName` varchar(100) DEFAULT NULL,
  `IsIndividualQuote` tinyint(1) NOT NULL DEFAULT '0',
  `QuoteDate` date NOT NULL,
  `ProducerWhoQuotedUserId` bigint(64) DEFAULT NULL,
  `SicCode` varchar(100) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`BrokerQuoteId`),
  KEY `BrokerQuoteRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `BrokerQuote`
--

LOCK TABLES `BrokerQuote` WRITE;
/*!40000 ALTER TABLE `BrokerQuote` DISABLE KEYS */;
/*!40000 ALTER TABLE `BrokerQuote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ContactDetail`
--

DROP TABLE IF EXISTS `ContactDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ContactDetail` (
  `ContactDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `AddressId` bigint(64) DEFAULT NULL,
  `MailingAddressId` bigint(64) DEFAULT NULL,
  `FirstName` char(100) NOT NULL,
  `LastName` char(100) NOT NULL,
  `MiddleName` char(100) DEFAULT NULL,
  `Suffix` varchar(50) DEFAULT NULL,
  `Email` char(100) NOT NULL,
  `Gender` enum('Male','Female') NOT NULL DEFAULT 'Male',
  `SSN` varchar(108) DEFAULT NULL,
  `LastFourSSN` varchar(4) DEFAULT NULL,
  `Birthdate` date DEFAULT NULL,
  `MaritalStatus` enum('Single','Married','Divorced','Widowed','Legally Separated') DEFAULT NULL,
  `ObjectName` varchar(200) DEFAULT NULL,
  `Smokes` tinyint(1) DEFAULT NULL,
  `LastDateSmoking` date DEFAULT NULL,
  `FFMLastDateOfTobaccoUse` date DEFAULT NULL,
  `DriversLicense` varchar(100) DEFAULT NULL,
  `IssueState` char(2) DEFAULT NULL,
  `TIN` varchar(20) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ContactDetailId`),
  KEY `ContactDetailAddressId_uq` (`AddressId`),
  KEY `ContactDetailRefMailingAddress_fk_idx` (`MailingAddressId`),
  KEY `ContactDetail_LastName` (`LastName`),
  KEY `ContactDetal_FirstName` (`FirstName`)
) ENGINE=innodb AUTO_INCREMENT=70 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ContactDetail`
--

LOCK TABLES `ContactDetail` WRITE;
/*!40000 ALTER TABLE `ContactDetail` DISABLE KEYS */;
INSERT INTO `ContactDetail` VALUES (4,NULL,NULL,'Norma','Noe',NULL,NULL,'norma@insxcloud.com','Male','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'2008-01-08 10:56:29',NULL,NULL),(1,NULL,NULL,'John','Smith',NULL,NULL,'admin@insxcloud.com','Male','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'2013-08-13 11:29:19',NULL,NULL),(2,NULL,NULL,'John','Doe','',NULL,'john.doe@insxcloud.com','Male','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'2008-01-08 10:55:01',80,'2008-01-08 10:58:08'),(3,NULL,NULL,'Larry','Loe',NULL,NULL,'larry.loe@insxcloud.com','Male','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'2008-01-08 10:55:58',NULL,NULL);
/*!40000 ALTER TABLE `ContactDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ContactDetailAddress`
--

DROP TABLE IF EXISTS `ContactDetailAddress`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ContactDetailAddress` (
  `ContactDetailAddressId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ContactDetailId` bigint(64) NOT NULL,
  `AddressId` bigint(64) NOT NULL,
  `FFMContactInformationCategory` varchar(50) DEFAULT NULL,
  `FFMAddressType` varchar(50) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ContactDetailAddressId`),
  KEY `ContactDetail_ContactDetailAdress_FK_idx` (`ContactDetailId`),
  KEY `Address_ContactDetail_FK_idx` (`AddressId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ContactDetailAddress`
--

LOCK TABLES `ContactDetailAddress` WRITE;
/*!40000 ALTER TABLE `ContactDetailAddress` DISABLE KEYS */;
/*!40000 ALTER TABLE `ContactDetailAddress` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ContactDetailH`
--

DROP TABLE IF EXISTS `ContactDetailH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ContactDetailH` (
  `ContactDetailHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `ContactDetailId` bigint(64) NOT NULL,
  `AddressHId` bigint(64) DEFAULT NULL,
  `MailingAddressHId` bigint(64) DEFAULT NULL,
  `FirstName` char(100) NOT NULL,
  `LastName` char(100) NOT NULL,
  `MiddleName` char(100) DEFAULT NULL,
  `Suffix` varchar(100) DEFAULT NULL,
  `Email` char(100) NOT NULL,
  `Gender` enum('Male','Female') NOT NULL DEFAULT 'Male',
  `SSN` char(108) NOT NULL,
  `LastFourSSN` varchar(4) DEFAULT NULL,
  `Birthdate` date DEFAULT NULL,
  `MaritalStatus` enum('Single','Married','Divorced','Widowed','Legally Separated') DEFAULT NULL,
  `ObjectName` varchar(200) NOT NULL,
  `Smokes` tinyint(1) DEFAULT NULL,
  `LastDateSmoking` date DEFAULT NULL,
  `IssueState` char(2) DEFAULT NULL,
  `DriversLicense` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ContactDetailHId`),
  KEY `ContactDetailHRefContactDetail_fk` (`ContactDetailId`)
) ENGINE=innodb AUTO_INCREMENT=523 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ContactDetailH`
--

LOCK TABLES `ContactDetailH` WRITE;
/*!40000 ALTER TABLE `ContactDetailH` DISABLE KEYS */;
/*!40000 ALTER TABLE `ContactDetailH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonBeneficiary`
--

DROP TABLE IF EXISTS `CoveredPersonBeneficiary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonBeneficiary` (
  `CoveredPersonBeneficiaryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `CoveredPersonPlanId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) DEFAULT NULL,
  `PercentageAssigned` smallint(16) NOT NULL,
  `Relationship` tinytext,
  `BeneficiaryType` enum('Primary','Contingent') NOT NULL,
  `CoverageAmount` decimal(10,2) DEFAULT NULL,
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `ReasonForWaivingType` bigint(64) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonBeneficiaryId`),
  KEY `CoveredPersonBeneficiaryRefCoveredPersonPlan_fk_idx` (`CoveredPersonPlanId`),
  KEY `CoveredPersonBeneficiaryRefContactDetail_fk_idx` (`ContactDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonBeneficiary`
--

LOCK TABLES `CoveredPersonBeneficiary` WRITE;
/*!40000 ALTER TABLE `CoveredPersonBeneficiary` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonBeneficiary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonBeneficiaryH`
--

DROP TABLE IF EXISTS `CoveredPersonBeneficiaryH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonBeneficiaryH` (
  `CoveredPersonBeneficiaryHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CoveredPersonBeneficiaryId` bigint(64) NOT NULL,
  `CoveredPersonPlanId` bigint(64) NOT NULL,
  `ContactDetailHId` bigint(64) DEFAULT NULL,
  `PercentageAssigned` smallint(16) NOT NULL,
  `Relationship` varchar(100) DEFAULT NULL,
  `BeneficiaryType` enum('Primary','Contingent') NOT NULL,
  `CoverageAmount` decimal(10,2) DEFAULT NULL,
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `ReasonForWaivingType` bigint(64) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonBeneficiaryHId`),
  KEY `CoveredPersonBeneficiaryHRefCoveredPersonBeneficiary_fk_idx` (`CoveredPersonBeneficiaryId`),
  KEY `CoveredPersonBeneficiaryHRefContactDetailHId_fk_idx` (`ContactDetailHId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonBeneficiaryH`
--

LOCK TABLES `CoveredPersonBeneficiaryH` WRITE;
/*!40000 ALTER TABLE `CoveredPersonBeneficiaryH` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonBeneficiaryH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonDependent`
--

DROP TABLE IF EXISTS `CoveredPersonDependent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonDependent` (
  `CoveredPersonDependentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `IsFullTimeStudent` tinyint(1) NOT NULL DEFAULT '0',
  `DependentType` enum('Spouse','Niece','Nephew','Son','Daughter','Other') NOT NULL DEFAULT 'Spouse',
  `IsDisabled` tinyint(1) NOT NULL DEFAULT '0',
  `SchoolName` varchar(200) DEFAULT NULL,
  `LivesAtDifferentAddress` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonDependentId`),
  KEY `CoveredPersonDependentRefContactDetail_fk_idx` (`ContactDetailId`),
  KEY `CoveredPersonDependentRefUser_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonDependent`
--

LOCK TABLES `CoveredPersonDependent` WRITE;
/*!40000 ALTER TABLE `CoveredPersonDependent` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonDependent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonDependentH`
--

DROP TABLE IF EXISTS `CoveredPersonDependentH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonDependentH` (
  `CoveredPersonDependentHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CoveredPersonDependentId` bigint(64) NOT NULL,
  `UserId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `IsFullTimeStudent` tinyint(1) NOT NULL DEFAULT '0',
  `DependentType` enum('Spouse','Niece','Nephew','Son','Daughter','Other') CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'Spouse',
  `IsDisabled` tinyint(1) NOT NULL DEFAULT '0',
  `SchoolName` varchar(200) DEFAULT NULL,
  `LivesAtDifferentAddress` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonDependentHId`),
  KEY `CoveredPersonDependentHRefCoveredPersonDependent_fk_idx` (`CoveredPersonDependentId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonDependentH`
--

LOCK TABLES `CoveredPersonDependentH` WRITE;
/*!40000 ALTER TABLE `CoveredPersonDependentH` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonDependentH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonDependentPlan`
--

DROP TABLE IF EXISTS `CoveredPersonDependentPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonDependentPlan` (
  `CoveredPersonDependentPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `CoveredPersonDependentId` bigint(64) NOT NULL,
  `CoveredPersonPlanId` bigint(64) NOT NULL,
  `WaivedCoverage` tinyint(1) NOT NULL,
  `IdentificationNumber` varchar(50) DEFAULT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `DeductionAmount` decimal(10,2) DEFAULT NULL,
  `PlanAmount` decimal(10,2) DEFAULT NULL,
  `Cost` decimal(10,2) DEFAULT NULL,
  `EventDate` date DEFAULT NULL,
  `DomainReasonForWaivingTypeId` bigint(64) DEFAULT NULL,
  `AddedCoverageDate` date DEFAULT NULL,
  `DroppedCoverageDate` date DEFAULT NULL,
  `CertificateOfCoverageObjectName` varchar(200) DEFAULT NULL,
  `ReasonForWaiving` enum('Medicare','Medicaid','Covered Under Spouse''s Group Plan','Other Group Coverage Through Another Employer','Individual Coverage','No Coverage','Other') DEFAULT NULL,
  `OtherReasonForWaivingComment` varchar(300) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonDependentPlanId`),
  KEY `CoveredPersonPlanDependantRefCoveredPersonPlan_fk_idx` (`CoveredPersonPlanId`),
  KEY `CoveredPersonPlanDependantRefCoveredPersonDependant_fk_idx` (`CoveredPersonDependentId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonDependentPlan`
--

LOCK TABLES `CoveredPersonDependentPlan` WRITE;
/*!40000 ALTER TABLE `CoveredPersonDependentPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonDependentPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonDependentPlanH`
--

DROP TABLE IF EXISTS `CoveredPersonDependentPlanH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonDependentPlanH` (
  `CoveredPersonDependentPlanHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CoveredPersonDependentId` bigint(64) NOT NULL,
  `CoveredPersonPlanHId` bigint(64) NOT NULL,
  `CoveredPersonDependentPlanId` bigint(64) NOT NULL,
  `WaivedCoverage` tinyint(1) NOT NULL,
  `IdentificationNumber` varchar(50) DEFAULT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `DeductionAmount` decimal(10,2) DEFAULT NULL,
  `PlanAmount` decimal(10,2) DEFAULT NULL,
  `Cost` decimal(10,2) DEFAULT NULL,
  `EventDate` date DEFAULT NULL,
  `DomainReasonForWaivingTypeId` bigint(64) DEFAULT NULL,
  `AddedCoverageDate` date DEFAULT NULL,
  `DroppedCoverageDate` date DEFAULT NULL,
  `CertificateOfCoverageObjectName` varchar(200) DEFAULT NULL,
  `ReasonForWaiving` enum('Medicare','Medicaid','Covered Under Spouse''s Group Plan','Other Group Coverage Through Another Employer','Individual Coverage','No Coverage','Other') DEFAULT NULL,
  `OtherReasonForWaivingComment` varchar(300) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonDependentPlanHId`),
  KEY `CoveredPersonDependentPlanHRefCoveredPersonDependentPlan_fk_idx` (`CoveredPersonDependentPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonDependentPlanH`
--

LOCK TABLES `CoveredPersonDependentPlanH` WRITE;
/*!40000 ALTER TABLE `CoveredPersonDependentPlanH` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonDependentPlanH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonEnrollment`
--

DROP TABLE IF EXISTS `CoveredPersonEnrollment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonEnrollment` (
  `CoveredPersonEnrollmentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerEnrollmentId` bigint(64) DEFAULT NULL,
  `UserId` bigint(64) NOT NULL,
  `CurrentEnrollmentStatus` enum('Completed','Started','Not Started') NOT NULL DEFAULT 'Not Started',
  `StartedDateTime` datetime DEFAULT NULL,
  `CompletedDateTime` datetime DEFAULT NULL,
  `LastSavedStep` varchar(100) DEFAULT NULL,
  `DateNotified` date DEFAULT NULL,
  `IsNewEnrollment` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonEnrollmentId`),
  KEY `CoveredPersonEnrollmentRefEmployerOpenEnrollment_fk_idx` (`EmployerEnrollmentId`),
  KEY `CoveredPersonEnrollmentRefUser_fk` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonEnrollment`
--

LOCK TABLES `CoveredPersonEnrollment` WRITE;
/*!40000 ALTER TABLE `CoveredPersonEnrollment` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonEnrollment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonOtherCoverage`
--

DROP TABLE IF EXISTS `CoveredPersonOtherCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonOtherCoverage` (
  `CoveredPersonPlanOtherId` bigint(64) NOT NULL AUTO_INCREMENT,
  `CoveredPersonPlanId` bigint(64) NOT NULL,
  `CoveredPersonDependentId` bigint(64) DEFAULT NULL,
  `OtherPlanTypes` enum('Covered under Spouse','Medicare','Medicaid','Other Group Coverage','ndividual Plan','Other') CHARACTER SET latin1 DEFAULT NULL,
  `OtherCoverageType` enum('Group Medical','Medicare','Medicaid/CHIP','Individual Medical','Retiree Coverage','COBRA','Other') DEFAULT NULL,
  `MedicareReason` enum('Age','ESRD','Disability','Other') DEFAULT NULL,
  `MedicareOtherReason` varchar(200) DEFAULT NULL,
  `OtherReasonComment` varchar(300) DEFAULT NULL,
  `MedicareClaimNumber` varchar(50) DEFAULT NULL,
  `MedicarePartAEffectiveDate` date DEFAULT NULL,
  `MedicarePartBEffectiveDate` date DEFAULT NULL,
  `InsuranceCompany` varchar(100) DEFAULT NULL,
  `PolicyNumber` varchar(50) DEFAULT NULL,
  `MemberId` varchar(100) DEFAULT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `MedicaidIdNumber` varchar(50) DEFAULT NULL,
  `MedicaidEffectiveDate` date DEFAULT NULL,
  `MedicaidState` varchar(2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonPlanOtherId`),
  KEY `CoveredPersonPlanOtherRefCoveredPersonPlan_fk_idx` (`CoveredPersonPlanId`),
  KEY `CoveredPersonOtherCoverageRefCoveredPersonDependentPlanId_idx` (`CoveredPersonDependentId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonOtherCoverage`
--

LOCK TABLES `CoveredPersonOtherCoverage` WRITE;
/*!40000 ALTER TABLE `CoveredPersonOtherCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonOtherCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonPlan`
--

DROP TABLE IF EXISTS `CoveredPersonPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonPlan` (
  `CoveredPersonPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `EmployerPlanId` bigint(64) DEFAULT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `TierNameValueId` bigint(64) DEFAULT NULL,
  `IdentificationNumber` varchar(50) DEFAULT NULL,
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `CertificateOfCoverageObjectName` varchar(200) DEFAULT NULL,
  `EventDate` date DEFAULT NULL,
  `DropOrAddCoverage` enum('Drop Coverage','Add Coverage') DEFAULT NULL,
  `CertificateObjectName` varchar(200) DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `DateSentToProvider` date DEFAULT NULL,
  `ReasonForWaiving` enum('Medicare','Medicaid','Covered Under Spouse''s Group Plan','Other Group Coverage Through Another Employer','Individual Coverage','No Coverage','Other') DEFAULT NULL,
  `OtherReasonForWaivingComment` varchar(300) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `PayFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') NOT NULL,
  `Cost` decimal(10,2) NOT NULL,
  `FilingType` enum('Single','Separate') DEFAULT NULL,
  `PolicyNumber` varchar(45) DEFAULT NULL,
  `FFEMemberId` varchar(45) DEFAULT NULL,
  `SubscriberId` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonPlanId`),
  KEY `CoverPersonPlanRefCoveredPerson_fk_idx` (`UserId`),
  KEY `CoveredPersonPlanRefEmployerPlan_fk_idx` (`EmployerPlanId`),
  KEY `CoveredPersonPlanDomainType_fk_idx` (`LineOfCoverageId`),
  KEY `CoveredPersonPlanRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonPlan`
--

LOCK TABLES `CoveredPersonPlan` WRITE;
/*!40000 ALTER TABLE `CoveredPersonPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonPlanH`
--

DROP TABLE IF EXISTS `CoveredPersonPlanH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonPlanH` (
  `CoveredPersonPlanHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CoveredPersonPlanId` bigint(64) NOT NULL,
  `UserId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `BrokerDomainQuoteId` bigint(64) NOT NULL,
  `EmployerPlanId` bigint(64) DEFAULT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `TierNameValueId` bigint(64) DEFAULT NULL,
  `IdentificationNumber` varchar(50) DEFAULT NULL,
  `PlanDecision` enum('Elect','Waive') DEFAULT NULL,
  `CertificateOfCoverageObjectName` varchar(200) DEFAULT NULL,
  `EventDate` date DEFAULT NULL,
  `DropOrAddCoverage` enum('Drop Coverage','Add Coverage') DEFAULT NULL,
  `CertificateObjectName` varchar(200) DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `DateSentToProvider` date DEFAULT NULL,
  `ReasonForWaiving` enum('Medicare','Medicaid','Covered Under Spouse''s Group Plan','Other Group Coverage Through Another Employer','Individual Coverage','No Coverage','Other') DEFAULT NULL,
  `OtherReasonForWaivingComment` varchar(300) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `PayFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') NOT NULL,
  `Cost` decimal(10,2) NOT NULL,
  `IsCurrentlyAQuote` bigint(64) DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT '2013-01-01 00:00:00',
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonPlanHId`),
  KEY `CoveredPersonPlanHRefCoveredPersonPlan_fk_idx` (`CoveredPersonPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonPlanH`
--

LOCK TABLES `CoveredPersonPlanH` WRITE;
/*!40000 ALTER TABLE `CoveredPersonPlanH` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonPlanH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `CoveredPersonPlanTypeWaived`
--

DROP TABLE IF EXISTS `CoveredPersonPlanTypeWaived`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `CoveredPersonPlanTypeWaived` (
  `CoveredPersonPlanTypeWaivedId` bigint(64) NOT NULL AUTO_INCREMENT,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `UserId` bigint(64) NOT NULL,
  `StartDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `ReasonForWaiving` enum('Medicare','Medicaid','Covered Under Spouse''s Group Plan','Other Group Coverage Through Another Employer','Individual Coverage','No Coverage','Other') DEFAULT NULL,
  `OtherReasonForWaivingComment` varchar(300) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`CoveredPersonPlanTypeWaivedId`),
  KEY `CoveredPersonPlanTypeRefUser_fk_idx` (`UserId`),
  KEY `CoveredPersonPlanTypeRefDomainPlanType_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `CoveredPersonPlanTypeWaived`
--

LOCK TABLES `CoveredPersonPlanTypeWaived` WRITE;
/*!40000 ALTER TABLE `CoveredPersonPlanTypeWaived` DISABLE KEYS */;
/*!40000 ALTER TABLE `CoveredPersonPlanTypeWaived` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DatabaseList`
--

DROP TABLE IF EXISTS `DatabaseList`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DatabaseList` (
  `DatabaseListId` bigint(20) NOT NULL AUTO_INCREMENT,
  `DBDisplayName` varchar(100) DEFAULT NULL,
  `DBUserName` varchar(100) NOT NULL,
  `DBPassword` varchar(100) NOT NULL,
  `DBDatabaseName` varchar(100) NOT NULL,
  `DBHostName` varchar(200) NOT NULL,
  `DBPortNumber` int(11) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DatabaseListId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DatabaseList`
--

LOCK TABLES `DatabaseList` WRITE;
/*!40000 ALTER TABLE `DatabaseList` DISABLE KEYS */;
/*!40000 ALTER TABLE `DatabaseList` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Department`
--

DROP TABLE IF EXISTS `Department`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Department` (
  `DepartmentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `LocationId` bigint(64) NOT NULL,
  `DepartmentName` varchar(200) NOT NULL,
  `DepartmentCode` varchar(40) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DepartmentId`),
  KEY `DepartmentRefLocation_fk_idx` (`LocationId`)
) ENGINE=innodb AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Department`
--

LOCK TABLES `Department` WRITE;
/*!40000 ALTER TABLE `Department` DISABLE KEYS */;
INSERT INTO `Department` VALUES (21,30,'Default Department','001','Active',1,'2008-01-08 10:53:12',NULL,NULL);
/*!40000 ALTER TABLE `Department` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DepartmentCustomField`
--

DROP TABLE IF EXISTS `DepartmentCustomField`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DepartmentCustomField` (
  `DepartmentCustomFieldId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DepartmentId` bigint(64) NOT NULL,
  `DomainCustomFieldId` bigint(65) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DepartmentCustomFieldId`),
  KEY `DeparmentCustomFieldRefDepartment_fk_idx` (`DepartmentId`),
  KEY `DepartmentCustomFieldRefDomainCustomField_fk_idx` (`DomainCustomFieldId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DepartmentCustomField`
--

LOCK TABLES `DepartmentCustomField` WRITE;
/*!40000 ALTER TABLE `DepartmentCustomField` DISABLE KEYS */;
/*!40000 ALTER TABLE `DepartmentCustomField` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DepartmentDocument`
--

DROP TABLE IF EXISTS `DepartmentDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DepartmentDocument` (
  `DepartmentDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DepartmentId` bigint(64) NOT NULL,
  `DocumentId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DepartmentDocumentId`),
  KEY `DeparmentDocumentRefDepartment_fk_idx` (`DepartmentId`),
  KEY `DepartmentDocumentRefDocument_fk_idx` (`DocumentId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DepartmentDocument`
--

LOCK TABLES `DepartmentDocument` WRITE;
/*!40000 ALTER TABLE `DepartmentDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `DepartmentDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DisabilityRule`
--

DROP TABLE IF EXISTS `DisabilityRule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DisabilityRule` (
  `DisabilityRuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `PercentOfSalary` decimal(10,4) DEFAULT NULL,
  `MaximumWeeklyAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DisabilityRuleId`),
  KEY `DisabilityRuleRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DisabilityRule`
--

LOCK TABLES `DisabilityRule` WRITE;
/*!40000 ALTER TABLE `DisabilityRule` DISABLE KEYS */;
/*!40000 ALTER TABLE `DisabilityRule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Document`
--

DROP TABLE IF EXISTS `Document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Document` (
  `DocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `DocumentName` varchar(100) DEFAULT NULL,
  `ObjectName` varchar(150) NOT NULL,
  `IsAvailableToAll` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DocumentId`),
  KEY `DocumentRefDomain_fk_idx` (`DomainId`),
  KEY `Document_DocumentName_idx` (`DocumentName`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Document`
--

LOCK TABLES `Document` WRITE;
/*!40000 ALTER TABLE `Document` DISABLE KEYS */;
/*!40000 ALTER TABLE `Document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Domain`
--

DROP TABLE IF EXISTS `Domain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Domain` (
  `DomainId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainParentId` bigint(64) DEFAULT NULL,
  `ProviderParentEntityId` bigint(64) DEFAULT NULL,
  `PrimaryContactDetailId` bigint(64) DEFAULT NULL,
  `BillingContactDetailId` bigint(64) DEFAULT NULL,
  `DomainName` varchar(200) NOT NULL,
  `AmazonBucketName` varchar(200) DEFAULT NULL,
  `DomainLogoURL` varchar(200) DEFAULT NULL,
  `Status` enum('Active','Suspended','Deleted','Pending') NOT NULL DEFAULT 'Active',
  `LogoffTimeInMinutes` smallint(16) NOT NULL DEFAULT '30',
  `MaxLoginAttemptsAllowed` smallint(16) NOT NULL DEFAULT '3',
  `DaysBetweenPasswordChange` smallint(16) NOT NULL DEFAULT '60',
  `ParentHasChildPermission` tinyint(1) NOT NULL DEFAULT '0',
  `Theme` enum('orange','blue','green','yellow','red','pink','purple','darkcyan','darkblue','gray','mediumblue','lightblue','lightbrown') NOT NULL DEFAULT 'blue',
  `SignaturePath` varchar(100) DEFAULT NULL,
  `PrimaryContactWebsite` varchar(200) DEFAULT NULL,
  `SICCode` varchar(10) DEFAULT NULL,
  `DomainType` enum('Exchange','Provider','Broker','Employer') DEFAULT 'Employer',
  `TypeOfEntity` enum('Individual/Sole Proprietor','Partnership','C Corporation','S Corporation','Limited Liability Company','Trust/Estate','Other') DEFAULT NULL,
  `SubDomain` varchar(100) DEFAULT NULL,
  `FFEUserId` varchar(50) DEFAULT NULL,
  `FFEInternalId` varchar(13) DEFAULT NULL,
  `BusinessRule4DigitPlanNumber` enum('14DigitNumber','RatingArea') DEFAULT NULL,
  `CreatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainId`),
  KEY `Domain_DomainParentId_idx` (`DomainParentId`),
  KEY `DomainRefProviderParentEntity_fk_idx` (`ProviderParentEntityId`),
  KEY `DomainRefPrimaryContactDetail_fk_idx` (`PrimaryContactDetailId`),
  KEY `DomainRefBillingContactDetail_fk_idx` (`BillingContactDetailId`)
) ENGINE=innodb AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Domain`
--

LOCK TABLES `Domain` WRITE;
/*!40000 ALTER TABLE `Domain` DISABLE KEYS */;
INSERT INTO `Domain` VALUES (1,NULL,NULL,NULL,NULL,'INSXCloud','my1outsourcing2-bucket',NULL,'Active',30,3,60,0,'blue',NULL,NULL,NULL,'Provider',NULL,NULL,NULL,NULL,NULL,1,'2013-08-13 11:24:38',NULL,NULL),(2,1,NULL,NULL,NULL,'HealthSpan','healthspanprovider','','Active',30,5,30,1,'blue',NULL,NULL,NULL,'Provider',NULL,NULL,NULL,NULL,NULL,1,'2008-01-08 10:20:45',NULL,NULL);
/*!40000 ALTER TABLE `Domain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainClassCustomField`
--

DROP TABLE IF EXISTS `DomainClassCustomField`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainClassCustomField` (
  `DomainClassCustomFieldId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassId` bigint(64) NOT NULL,
  `DomainCustomFieldId` bigint(65) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainClassCustomFieldId`),
  KEY `DomainClassCustomFieldRefDomainClass_fk_idx` (`EmployerClassId`),
  KEY `DomainClassCustomFieldRefDomainCustomField_fk_idx` (`DomainCustomFieldId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainClassCustomField`
--

LOCK TABLES `DomainClassCustomField` WRITE;
/*!40000 ALTER TABLE `DomainClassCustomField` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainClassCustomField` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainContactInfo`
--

DROP TABLE IF EXISTS `DomainContactInfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainContactInfo` (
  `DomainContactInfoId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `SortOrder` int(11) NOT NULL,
  `DisplayTitle` varchar(200) NOT NULL,
  `Row1` varchar(200) DEFAULT NULL,
  `Row2` varchar(200) DEFAULT NULL,
  `Row3` varchar(200) DEFAULT NULL,
  `Row4` varchar(200) DEFAULT NULL,
  `Row5` varchar(200) DEFAULT NULL,
  `Email` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainContactInfoId`),
  KEY `DomainContactInfo_Ref_Domain_fk_idx` (`DomainId`),
  KEY `DomainId_Domain_Type_Sort Order` (`DomainId`,`SortOrder`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainContactInfo`
--

LOCK TABLES `DomainContactInfo` WRITE;
/*!40000 ALTER TABLE `DomainContactInfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainContactInfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainCustomField`
--

DROP TABLE IF EXISTS `DomainCustomField`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainCustomField` (
  `DomainCustomFieldId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `FieldName` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `FieldType` enum('Numeric','Text','Currency','Date','DateTime','Drop Down') CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `KeepHistory` tinyint(1) NOT NULL DEFAULT '0',
  `CustomType` enum('User','Plan') CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'User',
  `DomainPlanId` bigint(64) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `IsEnabled` tinyint(1) NOT NULL DEFAULT '1',
  `DefaultValue` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `MaxTextLength` smallint(16) DEFAULT NULL COMMENT 'Drop Down is a list of values (text) Like Enums',
  `Status` enum('Active','Deleted') CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainCustomFieldId`),
  KEY `CustomrFieldRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainCustomField`
--

LOCK TABLES `DomainCustomField` WRITE;
/*!40000 ALTER TABLE `DomainCustomField` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainCustomField` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainFunctionOverride`
--

DROP TABLE IF EXISTS `DomainFunctionOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainFunctionOverride` (
  `DomainFunctionOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) DEFAULT NULL,
  `ViewId` bigint(64) DEFAULT NULL,
  `FunctionId` bigint(64) NOT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `FunctionName` varchar(200) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `FunctionEntryURL` varchar(200) DEFAULT NULL,
  `AllowToUpdate` tinyint(1) DEFAULT '1',
  `AllowToAdd` tinyint(1) DEFAULT '1',
  `AllowToDelete` tinyint(1) DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainFunctionOverrideId`),
  KEY `DomainFunctionOverride_DomainId_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainFunctionOverride`
--

LOCK TABLES `DomainFunctionOverride` WRITE;
/*!40000 ALTER TABLE `DomainFunctionOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainFunctionOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainModule`
--

DROP TABLE IF EXISTS `DomainModule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainModule` (
  `DomainModuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `IsHidden` bigint(32) NOT NULL DEFAULT '0',
  `ModuleName` varchar(100) DEFAULT NULL,
  `AppModuleId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainModuleId`),
  KEY `DomainModuleRefAppModule_fk_idx` (`AppModuleId`),
  KEY `DomainModuleRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=110 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainModule`
--

LOCK TABLES `DomainModule` WRITE;
/*!40000 ALTER TABLE `DomainModule` DISABLE KEYS */;
INSERT INTO `DomainModule` VALUES (7,2,0,'',8,1,'2008-01-08 10:25:47',NULL,NULL),(4,2,0,'',5,1,'2008-01-08 10:24:56',NULL,NULL),(8,2,0,'',9,1,'2008-01-08 10:25:55',NULL,NULL),(5,2,0,'',4,1,'2008-01-08 10:25:09',NULL,NULL),(6,2,0,'',3,1,'2008-01-08 10:25:17',NULL,NULL),(9,2,0,'',2,1,'2008-01-08 10:26:07',NULL,NULL),(2,1,0,'Developer Admin',1,1,'2013-08-13 11:26:42',NULL,NULL),(3,2,0,'',6,1,'2008-01-08 10:23:43',NULL,NULL);
/*!40000 ALTER TABLE `DomainModule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPackage`
--

DROP TABLE IF EXISTS `DomainPackage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPackage` (
  `DomainPackageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `PackageBought` enum('Broker Model','Agency Model') NOT NULL DEFAULT 'Broker Model',
  `PaymentAmount` decimal(10,2) DEFAULT NULL,
  `TrialTimePeriod` enum('15 Days','30 Days') DEFAULT '15 Days',
  `TrialPeriodEndDate` date DEFAULT NULL,
  `NumberOfLicensesIncluded` int(11) DEFAULT NULL,
  `PurchasedMonths` enum('6 Months','12 Months') DEFAULT NULL,
  `BasePriceMonthly` decimal(10,2) DEFAULT NULL,
  `ReferralCode` varchar(40) DEFAULT NULL,
  `StripeCustomerId` varchar(30) DEFAULT NULL,
  `Discount` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPackageId`),
  KEY `DomainPackageRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPackage`
--

LOCK TABLES `DomainPackage` WRITE;
/*!40000 ALTER TABLE `DomainPackage` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPackage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPackageH`
--

DROP TABLE IF EXISTS `DomainPackageH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPackageH` (
  `DomainPackageH` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainPackageId` bigint(64) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `PackageBought` enum('Broker Model','Agency Model') NOT NULL DEFAULT 'Broker Model',
  `PaymentAmount` decimal(10,2) DEFAULT NULL,
  `TrialTimePeriod` enum('15 Days','30 Days') DEFAULT '15 Days',
  `TrialPeriodEndDate` date DEFAULT NULL,
  `NumberOfLicensesIncluded` int(11) DEFAULT NULL,
  `PurchasedMonths` enum('6 Months','12 Months') DEFAULT NULL,
  `BasePriceMonthly` decimal(10,2) DEFAULT NULL,
  `ReferralCode` varchar(40) DEFAULT NULL,
  `StripeCustomerId` varchar(30) DEFAULT NULL,
  `Discount` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPackageH`),
  KEY `DomainPackageHRefDomainPackage_fk_idx` (`DomainPackageId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPackageH`
--

LOCK TABLES `DomainPackageH` WRITE;
/*!40000 ALTER TABLE `DomainPackageH` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPackageH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPayrollAdditionCategory`
--

DROP TABLE IF EXISTS `DomainPayrollAdditionCategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPayrollAdditionCategory` (
  `DomainPayrollAdditionCategoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `CategoryName` varchar(200) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPayrollAdditionCategoryId`),
  KEY `DomainPayrollAdditionCategoryRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPayrollAdditionCategory`
--

LOCK TABLES `DomainPayrollAdditionCategory` WRITE;
/*!40000 ALTER TABLE `DomainPayrollAdditionCategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPayrollAdditionCategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPayrollAdditionSubCategory`
--

DROP TABLE IF EXISTS `DomainPayrollAdditionSubCategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPayrollAdditionSubCategory` (
  `DomainPayrollAdditionSubCategoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainPayrollAdditionCategoryId` bigint(64) NOT NULL,
  `SubCategoryName` varchar(200) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPayrollAdditionSubCategoryId`),
  KEY `PayrollAddSubCategoryRefPayrollAddCat_idx` (`DomainPayrollAdditionCategoryId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPayrollAdditionSubCategory`
--

LOCK TABLES `DomainPayrollAdditionSubCategory` WRITE;
/*!40000 ALTER TABLE `DomainPayrollAdditionSubCategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPayrollAdditionSubCategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPayrollDeductionType`
--

DROP TABLE IF EXISTS `DomainPayrollDeductionType`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPayrollDeductionType` (
  `DomainPayrollDeductionTypeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DeductionName` varchar(200) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `Status` enum('Active','Deleted') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPayrollDeductionTypeId`),
  KEY `DomainPayrollDeductionTypeRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPayrollDeductionType`
--

LOCK TABLES `DomainPayrollDeductionType` WRITE;
/*!40000 ALTER TABLE `DomainPayrollDeductionType` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPayrollDeductionType` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainPlanDetailName`
--

DROP TABLE IF EXISTS `DomainPlanDetailName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainPlanDetailName` (
  `DomainPlanDetailNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PlanDetailCategoryId` bigint(64) NOT NULL,
  `DomainPlanDetailName` varchar(100) DEFAULT NULL,
  `NumberOfColumns` int(11) DEFAULT NULL,
  `QuickGlance` tinyint(1) NOT NULL DEFAULT '0',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `IsSortable` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainPlanDetailNameId`),
  KEY `DomainPlanDetailNameRefPlanDetailCategory_fk_idx` (`PlanDetailCategoryId`)
) ENGINE=innodb AUTO_INCREMENT=59 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainPlanDetailName`
--

LOCK TABLES `DomainPlanDetailName` WRITE;
/*!40000 ALTER TABLE `DomainPlanDetailName` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainPlanDetailName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainTerminationReason`
--

DROP TABLE IF EXISTS `DomainTerminationReason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainTerminationReason` (
  `DomainTerminationReasonId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `TerminationReasonName` varchar(200) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainTerminationReasonId`),
  KEY `DomainTerminationReasonRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainTerminationReason`
--

LOCK TABLES `DomainTerminationReason` WRITE;
/*!40000 ALTER TABLE `DomainTerminationReason` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainTerminationReason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `DomainViewOverride`
--

DROP TABLE IF EXISTS `DomainViewOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `DomainViewOverride` (
  `DomainViewOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ViewId` bigint(64) NOT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `ViewName` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`DomainViewOverrideId`),
  KEY `DomainViewOverrideRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `DomainViewOverride`
--

LOCK TABLES `DomainViewOverride` WRITE;
/*!40000 ALTER TABLE `DomainViewOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `DomainViewOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Edi834`
--

DROP TABLE IF EXISTS `Edi834`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Edi834` (
  `Edi834Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiTransactionId` bigint(64) NOT NULL,
  `SegmentDate` date NOT NULL COMMENT 'Example: 11/29/2013',
  `TimeCode` varchar(45) NOT NULL COMMENT 'Example Eastern Time',
  `ActionCode` varchar(45) NOT NULL COMMENT 'Example: Change (Update)',
  `ParticipantsTotal` int(11) NOT NULL COMMENT 'Example:  Total',
  `DependentsTotal` int(11) DEFAULT NULL COMMENT 'Example:  1',
  `PlanSponsorName` varchar(100) NOT NULL COMMENT 'Example Stanton FitzSimmons',
  `SponsorIdentificationCodeQualifier` varchar(100) NOT NULL COMMENT 'Example Federal Taxpayer''s Identification.  Can be NULL',
  `SponsorIdentificationCode` varchar(100) NOT NULL COMMENT 'Example Federal Taxpayer''s Identification.  Can be NULL',
  `InsurerName` varchar(100) NOT NULL COMMENT 'Example: Starmount Life Insurance Company',
  `InsurerIdentificationCodeQualifier` varchar(45) NOT NULL COMMENT 'Example 720977315.  This should be the TaxId',
  `InsurerIdentificationNumber` varchar(45) NOT NULL COMMENT 'Example 720977315.  This should be the TaxId',
  `BrokerName` varchar(100) DEFAULT NULL,
  `BrokerIdentificationCodeQualifier` varchar(45) DEFAULT NULL,
  `BrokerIdentificationCode` varchar(45) DEFAULT NULL,
  `DateTimeQualifier` varchar(45) NOT NULL COMMENT 'Example: Eligibility Begin',
  `DateTimePeriod` date NOT NULL COMMENT 'Example:  20140101',
  `SyncStatus` enum('Received','Sync Success','Sync Failed') NOT NULL DEFAULT 'Received',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`Edi834Id`),
  KEY `Edi834RefEdiTransaction_fk_idx` (`EdiTransactionId`)
) ENGINE=innodb AUTO_INCREMENT=23121 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Edi834`
--

LOCK TABLES `Edi834` WRITE;
/*!40000 ALTER TABLE `Edi834` DISABLE KEYS */;
INSERT INTO `Edi834` VALUES (5702,5702,'2014-01-01','ET','2',1,NULL,'mark bregar','FI','289927487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:30',0,'2014-03-01 15:48:04'),(2508,2508,'2014-01-01','ET','2',1,0,'Duncan Freeman','FI','277138467','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:18',0,'2014-03-01 15:05:09'),(3808,3808,'2014-01-01','ET','2',1,NULL,'DOROTHY SHAW ROBINSON','FI','435903675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:37',0,'2014-03-01 23:10:52'),(3886,3886,'2014-01-01','ET','2',4,3,'Shannon Stennett','FI','291722766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:45',0,'2014-03-01 15:05:09'),(4002,4002,'2014-01-01','ET','2',1,NULL,'peggy jackson','FI','444781011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:14',0,'2014-03-02 03:09:49'),(5433,5433,'2014-01-01','ET','2',1,0,'Lisa McGurk','FI','331748977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:26',0,'2014-03-01 15:05:09'),(13650,14006,'2014-01-01','ET','2',1,NULL,'Denise Ellams','FI','112425698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:09',0,'2014-03-02 05:24:45'),(12152,12152,'2014-01-01','ET','2',2,1,'yvonne L Jones','FI','318482580','Starmount Life Insurance Company','FI','720977315','Timothy Darrel Bell','94','3716124','348','2014-02-01','Sync Success',0,'2014-01-01 12:07:31',0,'2014-03-02 05:03:29'),(16088,16737,'0000-00-00','ET','2',1,NULL,'Ryan Martini','FI','295901885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:08',0,'2014-03-01 16:56:22'),(17123,17773,'0000-00-00','ET','2',5,4,'elise haddad','94','0000904297','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:14',0,'2014-03-10 14:20:26'),(20201,20851,'0000-00-00','ET','2',1,NULL,'Danita Green','FI','453818200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:31',0,'2014-03-02 07:10:28'),(21810,22460,'0000-00-00','ET','2',1,NULL,'Calvin Taylor','FI','452799244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:10',0,'2014-03-05 21:25:24'),(22128,22778,'0000-00-00','ET','2',1,NULL,'DIANE M RODRIGEUZ','94','0001397438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:49',0,'2014-03-06 21:27:26'),(22139,22789,'0000-00-00','ET','2',1,NULL,'Heather Hutto','FI','439774698','Starmount Life Insurance Company','FI','720977315','mary  siggers','94','15257239','357','2014-04-01','Sync Success',0,'2014-03-06 21:00:57',0,'2014-03-06 21:27:26'),(22273,22923,'0000-00-00','ET','2',1,NULL,'KATHY MASTIN','FI','270548165','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:33',0,'2014-03-10 14:45:25'),(13987,14343,'2014-01-01','ET','2',2,1,'VIVIAN ARMSTRONG','FI','439025175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:20',0,'2014-03-02 05:31:31'),(3344,3344,'2014-01-01','ET','2',1,NULL,'ELIDA HERNANDEZ','FI','467947712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:01',0,'2014-03-02 02:10:49'),(7611,7611,'2014-01-01','ET','2',1,NULL,'Lauress Morris','FI','273540631','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:37',0,'2014-03-10 15:59:47'),(19874,20524,'0000-00-00','ET','2',1,NULL,'GERALD JOHNSTON','FI','270521455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:23',0,'2014-03-01 17:47:19'),(22144,22794,'0000-00-00','ET','2',1,NULL,'Chris Breaux','FI','436533119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:01',0,'2014-03-06 21:27:26'),(14357,14808,'2014-01-01','ET','2',1,NULL,'Bryan Becker','FI','207505402','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:48',0,'2014-03-10 16:17:47'),(493,493,'2014-01-01','ET','2',1,NULL,'RENEE KAY CLARK','FI','273563596','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:17',0,'2014-03-01 15:48:04'),(855,855,'2014-01-01','ET','2',1,NULL,'MIKE  KOPYCINSKI','FI','454130257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:48',0,'2014-03-01 22:10:55'),(1474,1474,'2014-01-01','ET','2',1,NULL,'Maria Getz','FI','301680204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:37',0,'2014-03-01 16:23:43'),(13617,13973,'2014-01-01','ET','2',1,NULL,'AUDREY ROZACK','FI','302487856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:20:38',0,'2014-03-10 16:10:34'),(13061,13417,'2014-01-01','ET','2',1,NULL,'Channtanza Fontenot','FI','433831659','Starmount Life Insurance Company','FI','720977315','abram  freeman','94','1219092','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:28',0,'2014-03-02 05:17:40'),(12802,12802,'2014-01-01','ET','2',2,1,'John McGee','FI','459939691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:20',0,'2014-03-02 05:10:52'),(5309,5309,'2014-01-01','ET','2',1,NULL,'Susan Douglas','FI','415113035','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:46',0,'2014-03-10 15:39:19'),(12536,12536,'2014-01-01','ET','2',5,4,'Jeremy Ayers','94','0000910535','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:39',0,'2014-03-10 13:59:38'),(4670,4670,'2014-01-01','ET','2',1,NULL,'Dean Maxey','FI','276548147','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:35',0,'2014-03-01 16:15:39'),(10469,10469,'2014-01-01','ET','2',1,NULL,'timothy hiser','FI','295845878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:55',0,'2014-03-01 16:10:36'),(15241,15692,'0000-00-00','ET','2',1,NULL,'Terry Hayes','FI','436175979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:22',0,'2014-03-02 05:52:31'),(16284,16934,'0000-00-00','ET','2',1,NULL,'Emma Sorcini','FI','526944334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:12',0,'2014-03-02 06:10:30'),(17847,18497,'0000-00-00','ET','2',1,NULL,'NATHANIEL PURDIE JUNIOR','FI','284522026','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:12',0,'2014-03-10 16:24:30'),(18644,19294,'0000-00-00','ET','2',1,NULL,'Michelle DeForest','FI','285782737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:08',0,'2014-03-01 17:26:36'),(20733,21383,'0000-00-00','ET','2',1,NULL,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:30:28',0,'2014-03-01 18:10:11'),(6010,6010,'2014-01-01','ET','2',1,NULL,'Tammy Burrows','FI','283648544','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:14',0,'2014-03-01 15:10:22'),(4623,4623,'2014-01-01','ET','2',1,NULL,'Alesse Chisum','FI','628036403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:00',0,'2014-03-02 04:31:46'),(15409,15860,'0000-00-00','ET','2',1,NULL,'Empress Pando','FI','454757238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-22 03:22:15',0,'2014-03-02 05:59:43'),(16709,17359,'0000-00-00','ET','2',2,1,'Bernard Franks','FI','283487313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:23',0,'2014-03-01 17:00:58'),(17115,17765,'0000-00-00','ET','2',1,NULL,'Nathalie Leger','94','0000695670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:09',0,'2014-03-01 17:20:55'),(17364,18014,'0000-00-00','ET','2',1,NULL,'melissa griffith','FI','449844226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:17',0,'2014-03-02 06:24:38'),(17504,18154,'0000-00-00','ET','2',1,NULL,'Beatrica Rice','FI','644018598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:03',0,'2014-03-02 06:31:45'),(17970,18620,'0000-00-00','ET','2',1,NULL,'Katherine M Black','FI','301922689','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:18',0,'2014-03-10 14:24:38'),(19176,19826,'0000-00-00','ET','2',2,1,'Melvin Moton','FI','435845668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:44',0,'2014-03-02 06:52:12'),(20253,20903,'0000-00-00','ET','2',1,NULL,'CELESTE SANTOS','FI','465690846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:04',0,'2014-03-02 07:03:25'),(21259,21909,'0000-00-00','ET','2',1,NULL,'lynn maritim','FI','699389751','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:36',0,'2014-03-01 21:35:40'),(21576,22226,'0000-00-00','ET','2',1,NULL,'Tai Collins','FI','458817273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:52',0,'2014-03-03 22:26:43'),(14904,15355,'2014-01-01','ET','2',2,1,'Amy Dannel','FI','437410908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:25',0,'2014-03-02 05:52:31'),(4975,4975,'2014-01-01','ET','2',1,NULL,'REGINA ALINO','FI','277135735','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:12',0,'2014-03-01 15:31:33'),(14469,14920,'2014-01-01','ET','2',1,NULL,'Jeffrey Davis','FI','298828455','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:39',0,'2014-03-10 16:17:47'),(12251,12251,'2014-01-01','ET','2',1,NULL,'nolberto Pedroza','FI','457634178','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:28',0,'2014-03-02 05:03:29'),(15593,16044,'0000-00-00','ET','2',2,1,'ELLIS LANDRY','FI','434883086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:33',0,'2014-03-02 05:59:43'),(16645,17295,'0000-00-00','ET','2',1,NULL,'Gaye carmen Ictech','FI','434578346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:38',0,'2014-03-02 06:17:30'),(14086,14537,'2014-01-01','ET','2',1,NULL,'Alexandra Schuur Sousa','FI','027744245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:27',0,'2014-03-02 05:38:34'),(494,494,'2014-01-01','ET','2',1,NULL,'Alicia Melasecca','FI','589949122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:19',0,'2014-03-01 15:48:04'),(5967,5967,'2014-01-01','ET','2',1,NULL,'Shelly L Van Overborg','FI','449713840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:53',0,'2014-03-02 02:10:49'),(14901,15352,'2014-01-01','ET','2',1,NULL,'Connie Boudreaux','FI','436252475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:24',0,'2014-03-02 05:52:31'),(2143,2143,'2014-01-01','ET','2',1,NULL,'Beth Palange','FI','277809593','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:16',0,'2014-03-01 15:16:37'),(12515,12515,'2014-01-01','ET','2',1,NULL,'Larry Charles Johnson','FI','427114240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:54',0,'2014-03-02 05:03:29'),(7762,7762,'2014-01-01','ET','2',1,NULL,'laura bair','FI','295680336','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 05:01:17',0,'2014-03-10 13:03:33'),(7133,7133,'2014-01-01','ET','2',1,NULL,'Michelle Rammel','FI','296668687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:34',0,'2014-03-01 15:52:44'),(7475,7475,'2014-01-01','ET','2',1,NULL,'Christopher Drapala','FI','525634125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:08',0,'2014-03-02 04:15:49'),(17590,18240,'0000-00-00','ET','2',1,NULL,'Bruce Young','FI','297508395','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:05',0,'2014-03-10 14:24:38'),(21103,21753,'0000-00-00','ET','2',2,1,'Cynthia Gaona','FI','888537838','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-02-28 21:30:48',0,'2014-03-02 07:23:39'),(14751,15202,'2014-01-01','ET','2',1,NULL,'Victor Marsilio','FI','275609676','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:27',0,'2014-03-10 16:17:47'),(13455,13811,'2014-01-01','ET','2',1,NULL,'Tony Street','FI','428615622','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-02-01','Received',0,'2014-01-13 02:18:22',NULL,NULL),(2576,2576,'2014-01-01','ET','2',1,NULL,'donna grau','FI','273768479','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:11',0,'2014-03-01 15:05:09'),(12999,12999,'2014-01-01','ET','2',2,1,'MICHAEL PAUL SMITH','FI','301447117','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:04',0,'2014-03-10 16:10:34'),(11072,11072,'2014-01-01','ET','2',1,NULL,'Jennifer Goodson','FI','233317643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:10',0,'2014-03-10 16:03:49'),(4540,4540,'2014-01-01','ET','2',1,NULL,'Conrad Penman Shelby','FI','403944431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:20',0,'2014-03-02 04:31:46'),(10534,10534,'2014-01-01','ET','2',1,NULL,'savannah bednar','FI','520236420','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:56',0,'2014-03-02 04:24:47'),(21780,22430,'0000-00-00','ET','2',1,NULL,'William Peterson','FI','292707311','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:02:46',0,'2014-03-10 14:45:25'),(14455,14906,'2014-01-01','ET','2',1,NULL,'Christopher Porche','FI','434571662','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:32',0,'2014-03-02 05:38:34'),(5643,5643,'2014-01-01','ET','2',1,NULL,'Elizabeth Lane','FI','460916539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:06',0,'2014-03-02 04:45:37'),(13202,13558,'2014-01-01','ET','2',1,NULL,'Carol Mertens','FI','283643399','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:52',0,'2014-03-10 13:59:38'),(1212,1212,'2014-01-01','ET','2',1,NULL,'Brandon John Martin','FI','298804861','Dental Care Plus, Inc.','FI','311185262','Joseph R Worland','94','2825067','348','2014-01-01','Sync Success',0,'2013-12-25 18:48:08',0,'2014-03-01 16:15:39'),(1258,1258,'2014-01-01','ET','2',1,NULL,'JEFF  SEEMANN','FI','297747213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:27',0,'2014-03-01 16:15:39'),(1531,1531,'2014-01-01','ET','2',1,NULL,'James Drodouski','FI','297529374','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:23',0,'2014-03-10 16:03:49'),(12389,12389,'2014-01-01','ET','2',1,NULL,'Darlene Knott','FI','287664518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:17',0,'2014-03-01 16:30:17'),(11882,11882,'2014-01-01','ET','2',1,NULL,'Christy Pham','FI','455456103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:27',0,'2014-03-02 04:59:36'),(7651,7651,'2014-01-01','ET','2',3,2,'William Alva Logan','FI','317602099','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:53',0,'2014-03-10 13:39:10'),(10533,10533,'2014-01-01','ET','2',1,NULL,'Leslie McLean','FI','457111143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:55',0,'2014-03-02 04:24:47'),(10887,10887,'2014-01-01','ET','2',1,NULL,'Charnell Tademy','FI','439797011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:12',0,'2014-03-02 04:15:49'),(16685,17335,'0000-00-00','ET','2',1,NULL,'ANGELA GRAVES','FI','438152611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:05',0,'2014-03-02 06:17:30'),(17720,18370,'0000-00-00','ET','2',2,1,'CHARLES FLATT','FI','519947439','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:15',0,'2014-03-01 17:20:55'),(18715,19365,'0000-00-00','ET','2',1,NULL,'ANGELA WILLEY','FI','276644018','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:04',0,'2014-03-10 14:31:05'),(21326,21976,'0000-00-00','ET','2',1,NULL,'CHESTER HUVAL','FI','435293140','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:10',0,'2014-03-03 01:07:25'),(22159,22809,'0000-00-00','ET','2',1,NULL,'Ana DENUNZIO','FI','302117948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:10',0,'2014-03-06 21:36:23'),(22746,23396,'0000-00-00','ET','2',1,NULL,'Timothy Higgins','FI','421378182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:08',0,'2014-03-09 21:26:00'),(5170,5170,'2014-01-01','ET','2',1,NULL,'James Jennison','FI','295821539','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:23',0,'2014-03-10 13:20:27'),(14978,15429,'2014-01-01','ET','2',1,NULL,'Camille Ward','FI','279846765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:01',0,'2014-03-01 16:50:53'),(411,411,'2014-01-01','ET','2',1,NULL,'Willis Hill','FI','289561682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:48:45',0,'2014-03-01 15:21:15'),(7629,7629,'2014-01-01','ET','2',1,NULL,'Howard Skillman','FI','308643546','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:12',0,'2014-03-10 15:59:47'),(19127,19777,'0000-00-00','ET','2',2,1,'FLORENCE M GILBERT','FI','302805567','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:03',0,'2014-03-01 17:34:07'),(20765,21415,'0000-00-00','ET','2',1,NULL,'Shanae Latrice Middlebrooks','FI','272800199','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:42',0,'2014-03-01 18:08:07'),(14409,14860,'2014-01-01','ET','2',1,NULL,'Myung Cho','FI','223396249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:10',0,'2014-03-01 16:46:19'),(614,614,'2014-01-01','ET','2',1,NULL,'Kristine Anderson','FI','458815643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:03',0,'2014-03-02 02:10:49'),(5896,5896,'2014-01-01','ET','2',1,NULL,'Stacey Johnson','FI','299903762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:38',0,'2014-03-01 15:48:04'),(13551,13907,'2014-01-01','ET','2',1,NULL,'Kaila Bellas','94','0002259036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:50',0,'2014-03-02 05:24:45'),(16548,17198,'0000-00-00','ET','2',1,NULL,'Ivy Lynch','FI','458834263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:08',0,'2014-03-02 06:10:30'),(17045,17695,'0000-00-00','ET','2',1,NULL,'Thomas Gilchrist','FI','298525568','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:27',0,'2014-03-10 16:24:30'),(17894,18544,'0000-00-00','ET','2',1,NULL,'Magen Tardo','FI','439759721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:25',0,'2014-03-02 06:38:05'),(20212,20862,'0000-00-00','ET','2',1,NULL,'Cindy Ostert','FI','533649720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:40',0,'2014-03-02 07:10:28'),(6196,6196,'2014-01-01','ET','2',1,NULL,'Silvia Shing','FI','555933733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:12',0,'2014-03-02 04:10:25'),(5347,5347,'2014-01-01','ET','2',2,1,'Gary Vestal','FI','294560083','Summa Insurance Company, Inc.','FI','341809108','Scott  Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 01:15:45',0,'2014-03-10 15:39:19'),(4987,4987,'2014-01-01','ET','2',1,NULL,'Diane Nott','FI','298768534','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:34',0,'2014-03-01 15:31:33'),(3141,3141,'2014-01-01','ET','2',2,1,'RHONDA RAE MANUEL','FI','270542591','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:26',0,'2014-03-10 13:24:34'),(2209,2209,'2014-01-01','ET','2',1,NULL,'Latanja T Fazande','FI','433596218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:29',0,'2014-03-01 21:11:04'),(18168,18818,'0000-00-00','ET','2',1,NULL,'Tiffany Johnson','FI','439799079','Starmount Life Insurance Company','FI','720977315','Keith C  Smith','94','4698601','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:29',0,'2014-03-02 06:38:05'),(20236,20886,'0000-00-00','ET','2',2,1,'William Meeks','FI','286646872','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:58',0,'2014-03-10 16:38:05'),(21320,21970,'0000-00-00','ET','2',1,NULL,'Eduwiges Villarreal','FI','645106396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:07',0,'2014-03-03 01:07:25'),(7222,7222,'2014-01-01','ET','2',1,NULL,'REBECCA DIETER','FI','288744737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:17',0,'2014-03-01 15:52:44'),(14182,14633,'2014-01-01','ET','2',1,NULL,'Ed Shepherd','FI','297604478','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:27',0,'2014-03-10 14:03:26'),(3108,3108,'2014-01-01','ET','2',1,NULL,'Patricia Venezia Gibbons','FI','439826346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:25',0,'2014-03-02 01:10:33'),(5115,5115,'2014-01-01','ET','2',1,NULL,'Tracy Dardenne','FI','268806202','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:43',0,'2014-03-10 15:45:56'),(7247,7247,'2014-01-01','ET','2',2,1,'William Deckman','FI','268465541','HealthSpan','FI','311431434','Kimberly   Hoecker','94','1792499','348','2014-01-01','Sync Success',0,'2013-12-26 04:08:07',0,'2014-03-10 13:32:15'),(18324,18974,'0000-00-00','ET','2',1,NULL,'Dan Rodabaugh','FI','568318041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:10',0,'2014-03-01 17:26:36'),(19601,20251,'0000-00-00','ET','2',1,NULL,'Basel Jalal Musharbash','FI','641988141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:32:34',0,'2014-03-02 06:59:07'),(20642,21292,'0000-00-00','ET','2',2,1,'Rosa Mendez','FI','352544221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:18',0,'2014-03-02 07:10:28'),(22929,23579,'0000-00-00','ET','2',1,NULL,'Robin Flemings','FI','439616806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:02',0,'2014-03-10 21:27:11'),(1415,1415,'2014-01-01','ET','2',1,NULL,'david kolberg','FI','294680874','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:33',0,'2014-03-10 13:45:57'),(11705,11705,'2014-01-01','ET','2',1,NULL,'Gudalupe Garcia','FI','466949778','Starmount Life Insurance Company','FI','720977315','michelle  gomez vela','94','3128498','348','2014-02-01','Sync Success',1,'2013-12-29 11:08:03',0,'2014-03-02 04:59:36'),(10953,10953,'2014-01-01','ET','2',1,NULL,'Michael Collins','FI','291829754','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:18',0,'2014-03-10 16:03:49'),(10926,10926,'2014-01-01','ET','2',1,NULL,'GAYLE E MARTIN','FI','300625451','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:08:31',0,'2014-03-10 16:03:49'),(4832,4832,'2014-01-01','ET','2',1,NULL,'EDITH L SENEGAL','FI','439042886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:03',0,'2014-03-01 20:10:57'),(15690,16339,'0000-00-00','ET','2',1,NULL,'Kimberly Vasquez','FI','600800442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:00:41',0,'2014-03-02 05:59:43'),(15707,16356,'0000-00-00','ET','2',2,1,'Patricia Vergil','FI','569022643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:52',0,'2014-03-02 05:59:43'),(17821,18471,'0000-00-00','ET','2',1,NULL,'Sarah LeBlanc','FI','437817115','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:52',0,'2014-03-02 06:17:30'),(20350,21000,'0000-00-00','ET','2',1,NULL,'Rachael Schneider','FI','284880705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:39',0,'2014-03-01 17:47:19'),(21689,22339,'0000-00-00','ET','2',4,3,'Rebecca Rowland','FI','377826912','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:29',0,'2014-03-04 21:36:30'),(22301,22951,'0000-00-00','ET','2',1,NULL,'Brandy Garcia','FI','482045527','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:55',0,'2014-03-10 14:50:59'),(13652,14008,'2014-01-01','ET','2',1,NULL,'Rebeca Martinez','FI','457617491','Starmount Life Insurance Company','FI','720977315','MARIA  E VALENCIA GONZALEZ','94','15740460','348','2014-02-01','Sync Success',0,'2014-01-13 02:21:10',0,'2014-03-02 05:24:45'),(10406,10406,'2014-01-01','ET','2',3,2,'David Danner','FI','299649604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:53',0,'2014-03-01 16:10:36'),(870,870,'2014-01-01','ET','2',1,NULL,'DAVID RAYOUM','FI','294464969','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:19',0,'2014-03-10 13:10:24'),(15060,15511,'2014-01-01','ET','2',1,NULL,'sandra mcintosh','FI','271483929','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:36',0,'2014-03-10 14:10:12'),(19294,19944,'0000-00-00','ET','2',1,NULL,'MICHELLE L COHEN','FI','273761670','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:14',0,'2014-03-10 14:31:05'),(22450,23100,'0000-00-00','ET','2',1,NULL,'Sandra Fisher','FI','289527097','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:34',0,'2014-03-10 14:50:59'),(22976,23626,'0000-00-00','ET','2',1,NULL,'Dwain Smith','FI','279583676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:34',0,'2014-03-10 21:36:25'),(16598,17248,'0000-00-00','ET','2',2,1,'Robin Hawkins','FI','465658246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:05',0,'2014-03-02 06:17:30'),(16672,17322,'0000-00-00','ET','2',4,3,'Christine Destefano','FI','274745050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:56',0,'2014-03-01 17:00:58'),(14335,14786,'2014-01-01','ET','2',1,NULL,'Hong Tran','FI','730267654','Starmount Life Insurance Company','FI','720977315','Julie  Nguyen','94','6040941','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:39',0,'2014-03-02 05:38:34'),(4492,4492,'2014-01-01','ET','2',1,NULL,'Stephen Marquart','FI','276787971','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:48',0,'2014-03-10 15:39:19'),(11601,11601,'2014-01-01','ET','2',1,NULL,'MARY WILLIAMS','FI','587262705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:44',0,'2014-03-02 04:52:44'),(11523,11523,'2014-01-01','ET','2',1,NULL,'NAEEM CLARK','FI','437598175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:20',0,'2014-03-02 04:52:44'),(3232,3232,'2014-01-01','ET','2',1,NULL,'TYLER JOHNSON','FI','297806021','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:18',0,'2014-03-01 15:52:44'),(2624,2624,'2014-01-01','ET','2',1,NULL,'Colleen Creamer','FI','292901607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:44',0,'2014-03-01 15:16:37'),(2329,2329,'2014-01-01','ET','2',1,0,'Joseph Dalora','FI','593863270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:15',0,'2014-03-01 19:11:03'),(15668,16317,'0000-00-00','ET','2',1,NULL,'Brandon Kilby','FI','275889977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:25',0,'2014-03-01 16:56:22'),(17205,17855,'0000-00-00','ET','2',4,3,'Thomas MacCarthy','FI','272118403','Dental Care Plus, Inc.','FI','311185262','Jemari  James','94','17045637','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:08',0,'2014-03-01 17:20:55'),(22984,23634,'0000-00-00','ET','2',1,NULL,'Rebecca Griffiths','FI','054746861','Dental Care Plus, Inc.','FI','311185262','Dean Scott Hettesheimer','94','510468','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:39',0,'2014-03-10 21:36:25'),(11745,11745,'2014-01-01','ET','2',1,NULL,'Jennifer Leever','FI','243573675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:17',0,'2014-03-01 16:30:17'),(7563,7563,'2014-01-01','ET','2',2,1,'Robert Kobistek','FI','283568853','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:04',0,'2014-03-01 16:05:34'),(678,678,'2014-01-01','ET','2',1,NULL,'Tricia Warren','FI','284881072','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:02',0,'2014-03-10 15:52:36'),(910,910,'2014-01-01','ET','2',1,NULL,'CINDY KATHRYN ZIMMER','FI','302588354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:23',0,'2014-03-01 15:21:15'),(19702,20352,'0000-00-00','ET','2',2,1,'Alan Weber','FI','284445659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:55:15',0,'2014-03-10 14:37:47'),(20653,21303,'0000-00-00','ET','2',3,2,'KATHLEEN TAYLOR','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:27',0,'2014-03-10 16:38:05'),(21677,22327,'0000-00-00','ET','2',2,1,'CRYSTAL BARNES','FI','427310492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:19',0,'2014-03-04 21:27:16'),(22618,23268,'0000-00-00','ET','2',1,NULL,'Ebony Marie Smith','FI','437850656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:07',0,'2014-03-08 21:25:11'),(23000,23650,'0000-00-00','ET','2',1,NULL,'AIMEE LYNN KOOSH','FI','280884988','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:51',0,'2014-03-10 21:36:25'),(514,514,'2014-01-01','ET','2',1,NULL,'Michael Key','FI','253652393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:53',0,'2014-03-01 15:48:04'),(533,533,'2014-01-01','ET','2',1,NULL,'Crystal Kay Wheeler','FI','288641891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:28',0,'2014-03-01 15:48:04'),(1710,1710,'2014-01-01','ET','2',1,NULL,'Rhonda Theriot','FI','436352560','Starmount Life Insurance Company','FI','720977315','JACQUELINE S PARRISH','94','4734109','348','2014-01-01','Sync Success',0,'2013-12-25 19:16:49',0,'2014-03-02 00:10:48'),(2067,2067,'2014-01-01','ET','2',1,NULL,'SULTANEH A OBEID','FI','291702833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:01',0,'2014-03-10 13:20:27'),(2196,2196,'2014-01-01','ET','2',1,NULL,'william young','FI','287480956','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:02',0,'2014-03-10 15:39:19'),(12704,12704,'2014-01-01','ET','2',1,NULL,'XAVIER MILES','FI','587103430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:56',0,'2014-03-02 05:10:52'),(20442,21092,'0000-00-00','ET','2',1,NULL,'Lenard Davis','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 09:30:58',0,'2014-03-02 07:10:28'),(21598,22248,'0000-00-00','ET','2',1,NULL,'SHERRY TAYLOR','FI','466909397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:18',0,'2014-03-04 21:27:16'),(22329,22979,'0000-00-00','ET','2',2,1,'Teresa Ferguson','FI','286662595','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:18',0,'2014-03-06 21:36:23'),(11682,11682,'2014-01-01','ET','2',1,NULL,'Pamela Holley','FI','317622556','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:37:22',0,'2014-03-10 13:52:32'),(10999,10999,'2014-01-01','ET','2',2,1,'ANDREA WHITE','FI','587257910','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:45',0,'2014-03-02 04:31:46'),(1714,1714,'2014-01-01','ET','2',1,NULL,'SHARON ELKINS','FI','437159400','Starmount Life Insurance Company','FI','720977315','DAVID   SNYDER','94','4747813','348','2014-01-01','Sync Success',0,'2013-12-25 19:16:56',0,'2014-03-02 00:10:48'),(1825,1825,'2014-01-01','ET','2',1,NULL,'Tamara Lynn Baker','FI','300662132','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:24',0,'2014-03-10 15:45:56'),(15337,15788,'0000-00-00','ET','2',1,NULL,'wendy reed','FI','587495491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:41',0,'2014-03-02 05:52:31'),(16714,17364,'0000-00-00','ET','2',1,NULL,'Roger Richey','FI','280683857','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:26',0,'2014-03-10 14:20:26'),(21120,21770,'0000-00-00','ET','2',1,NULL,'LUCIA CERVANTES','FI','451974257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:00',0,'2014-03-02 07:23:39'),(21261,21911,'0000-00-00','ET','2',1,NULL,'Dominic Anthony Musarra','FI','292904949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:37',0,'2014-03-01 21:35:40'),(22684,23334,'0000-00-00','ET','2',1,NULL,'Loreene Washington','FI','562852763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:46',0,'2014-03-08 22:26:18'),(11424,11424,'2014-01-01','ET','2',1,NULL,'daniel cuthbert','FI','283569013','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:19',0,'2014-03-10 16:03:49'),(5340,5340,'2014-01-01','ET','2',1,NULL,'MICHAEL GIURBINO','FI','289509713','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:30',0,'2014-03-01 15:10:22'),(3231,3231,'2014-01-01','ET','2',1,NULL,'Mary Alice Schneider','FI','297502373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:16',0,'2014-03-01 15:52:44'),(3427,3427,'2014-01-01','ET','2',1,NULL,'Jacqueline Christine Wilson','FI','292903410','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:33',0,'2014-03-10 15:52:36'),(5004,5004,'2014-01-01','ET','2',1,NULL,'Eva Culbert','FI','587467518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:06',0,'2014-03-01 15:31:33'),(11423,11423,'2014-01-01','ET','2',1,NULL,'Patricia Sullivan','FI','299862176','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:17',0,'2014-03-10 16:03:49'),(3736,3736,'2014-01-01','ET','2',1,NULL,'Helen Rode','FI','285481814','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:44',0,'2014-03-10 13:20:27'),(6173,6173,'2014-01-01','ET','2',1,NULL,'janet torres casillas','FI','462378262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:30',0,'2014-03-02 04:10:25'),(6156,6156,'2014-01-01','ET','2',1,NULL,'Ruth Hamilton','FI','463138608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:02',0,'2014-03-02 04:10:25'),(3258,3258,'2014-01-01','ET','2',1,NULL,'David J Foerster','FI','071389678','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:04',0,'2014-03-10 15:52:36'),(2951,2951,'2014-01-01','ET','2',2,1,'Richard Robbins','FI','291562419','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:35',0,'2014-03-01 15:37:30'),(16049,16698,'0000-00-00','ET','2',1,NULL,'Ryan Hancock','94','0000559467','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:42',0,'2014-03-01 16:56:22'),(16094,16743,'0000-00-00','ET','2',1,NULL,'AMANDA EHRHARDT','FI','284920559','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:01:13',0,'2014-03-10 14:20:26'),(17372,18022,'0000-00-00','ET','2',2,1,'virginia Contreras','FI','641289940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:23',0,'2014-03-02 06:31:45'),(17824,18474,'0000-00-00','ET','2',1,NULL,'Sergio A Perez','FI','439653733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:55',0,'2014-03-02 06:17:30'),(18257,18907,'0000-00-00','ET','2',1,NULL,'denise pankratz','FI','276546224','HealthSpan','FI','311431434','Mary  Lodge','94','11976263','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:44',0,'2014-03-10 14:24:38'),(19692,20342,'0000-00-00','ET','2',1,NULL,'Janice Marie Smith','FI','426337150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:53:13',0,'2014-03-02 06:59:07'),(6346,6346,'2014-01-01','ET','2',1,NULL,'David Rockey','FI','274442247','HealthSpan','FI','311431434','Linda  Sawyers','94','2095238','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:48',0,'2014-03-10 13:39:10'),(6041,6041,'2014-01-01','ET','2',1,0,'Casey Beruete','FI','230595100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:16',0,'2014-03-01 19:11:03'),(13740,14096,'2014-01-01','ET','2',3,2,'Stephanie Gail Gussler','FI','276761497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:07',0,'2014-03-01 16:40:16'),(13598,13954,'2014-01-01','ET','2',1,NULL,'Laurie Preston','FI','279529789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:23',0,'2014-03-02 05:31:31'),(4605,4605,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','348','2014-01-01','Sync Success',0,'2013-12-25 23:47:24',0,'2014-03-01 16:15:39'),(2518,2518,'2014-01-01','ET','2',1,0,'Steven Shupp','FI','294609847','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:35',0,'2014-03-10 13:03:33'),(19831,20481,'0000-00-00','ET','2',2,1,'GIOVANNY FRANCISCO ESCRIBANO','FI','597204898','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:49',0,'2014-03-10 16:38:05'),(20237,20887,'0000-00-00','ET','2',1,NULL,'Emily Harden','FI','260736497','HealthSpan','FI','311431434','Ty  Cramer','94','8741868','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:59',0,'2014-03-10 14:37:47'),(22455,23105,'0000-00-00','ET','2',1,NULL,'David Shilinski','FI','278545049','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:38',0,'2014-03-10 16:44:18'),(14326,14777,'2014-01-01','ET','2',1,NULL,'ROSARIO R AYALA','FI','639544555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:35',0,'2014-03-02 05:38:34'),(3843,3843,'2014-01-01','ET','2',1,NULL,'Marya Robinson','FI','291868416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:21',0,'2014-03-01 15:05:09'),(2161,2161,'2014-01-01','ET','2',2,1,'MALAKIZH VARIATH S WARRIER','FI','292137689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:49',0,'2014-03-01 15:16:37'),(10856,10856,'2014-01-01','ET','2',1,NULL,'JANET BESSENBACHER','FI','297545452','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:42',0,'2014-03-10 13:45:57'),(12632,12632,'2014-01-01','ET','2',1,NULL,'Luke Costilow','FI','640107037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:11',0,'2014-03-02 05:10:52'),(13320,13676,'2014-01-01','ET','2',1,NULL,'helen travis','FI','436888199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:20',0,'2014-03-02 05:24:45'),(17015,17665,'0000-00-00','ET','2',1,NULL,'Barbara Dugger','FI','448545772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:08',0,'2014-03-02 06:24:38'),(17591,18241,'0000-00-00','ET','2',1,NULL,'Diane Danzig','FI','295567652','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:06',0,'2014-03-10 14:24:38'),(18218,18868,'0000-00-00','ET','2',1,NULL,'TERRY  L PARKER','FI','267900381','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:08',0,'2014-03-10 16:31:33'),(20595,21245,'0000-00-00','ET','2',2,1,'CYNTHIA GRILLI','FI','298485387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:45',0,'2014-03-01 18:08:07'),(20976,21626,'0000-00-00','ET','2',1,NULL,'EDWARD GERARD WARREN','FI','289620801','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:22',0,'2014-03-01 18:08:07'),(22582,23232,'0000-00-00','ET','2',1,NULL,'NANCY SCOTT','FI','292523694','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:09',0,'2014-03-10 14:50:59'),(11238,11238,'2014-01-01','ET','2',1,NULL,'Donnell Loury','FI','302703142','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:36',0,'2014-03-01 16:23:43'),(5167,5167,'2014-01-01','ET','2',1,NULL,'Carla Kampschmidt','FI','299745461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:18',0,'2014-03-10 13:20:27'),(2099,2099,'2014-01-01','ET','2',1,NULL,'CRAIG MCCOY','FI','482920167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:38:01',0,'2014-03-10 13:20:27'),(15975,16624,'0000-00-00','ET','2',1,NULL,'Heidi Crescioni','FI','438553458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:20',0,'2014-03-02 06:03:21'),(18945,19595,'0000-00-00','ET','2',1,NULL,'Annal Vyas','FI','295861435','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:34',0,'2014-03-10 16:31:33'),(19323,19973,'0000-00-00','ET','2',2,1,'ABEL ORTIZ MUNOZ','FI','054084637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:13',0,'2014-03-02 06:59:07'),(21957,22607,'0000-00-00','ET','2',1,NULL,'MARIO ESTUARDO DEL CASTILLO LOPEZ','FI','663128331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:23',0,'2014-03-05 22:27:33'),(22578,23228,'0000-00-00','ET','2',1,NULL,'Audrey Green','FI','340625160','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-04-01','Sync Success',0,'2014-03-07 21:32:06',0,'2014-03-07 22:26:59'),(15708,16357,'0000-00-00','ET','2',1,NULL,'Sonya Prado','FI','464833933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:00:53',0,'2014-03-02 05:59:43'),(5964,5964,'2014-01-01','ET','2',4,3,'Lynne Zander','FI','389744818','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:46',0,'2014-03-02 01:10:33'),(2866,2866,'2014-01-01','ET','2',1,NULL,'WILLIAM MEADOWS','FI','296564274','HealthSpan','FI','311431434','GERALD C CAMPBELL','94','966822','348','2014-01-01','Sync Success',0,'2013-12-25 21:22:29',0,'2014-03-10 13:39:10'),(6272,6272,'2014-01-01','ET','2',1,NULL,'esther trahan','FI','435274235','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:37',0,'2014-03-02 04:10:25'),(5521,5521,'2014-01-01','ET','2',1,NULL,'Donald Christoff','FI','301467074','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:03',0,'2014-03-01 16:23:43'),(4030,4030,'2014-01-01','ET','2',1,NULL,'TOMMIE VASQUES','FI','456782774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:02',0,'2014-03-02 03:09:49'),(17157,17807,'0000-00-00','ET','2',1,NULL,'erica anderson','FI','425615360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:37',0,'2014-03-02 06:24:38'),(20039,20689,'0000-00-00','ET','2',1,NULL,'zachary g poole','FI','632345867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:12',0,'2014-03-02 07:03:25'),(1704,1704,'2014-01-01','ET','2',1,NULL,'Elizabeth Canterbury','FI','434216690','Starmount Life Insurance Company','FI','720977315','Patricia  Freeman','94','4700588','348','2014-01-01','Sync Success',0,'2013-12-25 19:16:38',0,'2014-03-02 00:10:48'),(12084,12084,'2014-01-01','ET','2',1,NULL,'Katelyn Granneman','FI','270947831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:11',0,'2014-03-01 16:30:17'),(4795,4795,'2014-01-01','ET','2',1,NULL,'wayne petty','FI','287524568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:45',0,'2014-03-01 15:16:37'),(10779,10779,'2014-01-01','ET','2',1,NULL,'Meagan Young','FI','439695485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:12',0,'2014-03-02 04:24:47'),(7139,7139,'2014-01-01','ET','2',1,NULL,'ann kelly','FI','108468339','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:44',0,'2014-03-10 15:52:36'),(14680,15131,'2014-01-01','ET','2',5,4,'Shannon Smith','FI','404359813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:41',0,'2014-03-01 16:46:19'),(15460,15911,'0000-00-00','ET','2',1,NULL,'Natasha Wever','FI','446923249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:48',0,'2014-03-01 16:50:53'),(18755,19405,'0000-00-00','ET','2',1,NULL,'LUCAS  PAUL JOHNSON','FI','435512832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:33',0,'2014-03-02 06:45:14'),(19216,19866,'0000-00-00','ET','2',2,1,'MICKEY TURNER','FI','455218028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:13',0,'2014-03-02 06:52:12'),(19779,20429,'0000-00-00','ET','2',3,2,'CAROLINE HUGHES','FI','587473535','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:05',0,'2014-03-02 07:03:25'),(21424,22074,'0000-00-00','ET','2',5,4,'ANGELA GREEN','FI','278840124','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:27',0,'2014-03-10 14:45:25'),(16286,16936,'0000-00-00','ET','2',1,NULL,'Anns Poovathummoottil','FI','643133080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:14',0,'2014-03-02 06:10:30'),(13919,14275,'2014-01-01','ET','2',1,NULL,'DEBBIE BROOKS','FI','293562202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:13',0,'2014-03-01 16:40:16'),(778,778,'2014-01-01','ET','2',1,NULL,'Simon Tecle','FI','331748499','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:20',0,'2014-03-01 15:05:09'),(13709,14065,'2014-01-01','ET','2',1,NULL,'CYNTHIA L STUTZ','FI','271722990','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:46',0,'2014-03-01 16:40:16'),(13588,13944,'2014-01-01','ET','2',1,NULL,'Lilia Picazo','FI','426994296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:20:17',0,'2014-03-02 05:31:31'),(3969,3969,'2014-01-01','ET','2',1,NULL,'michael RUSHIN','FI','294788149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:13',0,'2014-03-01 15:26:40'),(15103,15554,'0000-00-00','ET','2',1,NULL,'Jennifer Moore','FI','461576876','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:52',0,'2014-03-02 05:52:31'),(15284,15735,'0000-00-00','ET','2',1,NULL,'Kim Lee-Johnson','FI','287748068','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:09',0,'2014-03-02 05:52:31'),(16717,17367,'0000-00-00','ET','2',2,1,'Kenneth Meyer','FI','270782740','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:28',0,'2014-03-10 16:24:30'),(16872,17522,'0000-00-00','ET','2',1,NULL,'Ronnie Lloyd','FI','466198326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:10',0,'2014-03-02 06:17:30'),(17685,18335,'0000-00-00','ET','2',1,NULL,'Gary Bentley','FI','278563586','HealthSpan','FI','311431434','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:57',0,'2014-03-10 14:24:38'),(17989,18639,'0000-00-00','ET','2',1,NULL,'Tara Brock','FI','425655891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:31',0,'2014-03-02 06:31:45'),(22681,23331,'0000-00-00','ET','2',1,NULL,'megan comeaux','FI','437555825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:44',0,'2014-03-08 22:26:18'),(5377,5377,'2014-01-01','ET','2',1,NULL,'jessica starner','FI','293841342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:47',0,'2014-03-01 15:10:22'),(13222,13578,'2014-01-01','ET','2',2,1,'Angela Clark','FI','456550495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:57',0,'2014-03-02 05:17:40'),(10648,10648,'2014-01-01','ET','2',1,NULL,'ANNETTE G RIOS','FI','465171625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:44',0,'2014-03-02 04:31:46'),(604,604,'2014-01-01','ET','2',1,NULL,'MICHELLE  ANGUS','FI','231903618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:43',0,'2014-03-02 02:10:49'),(3698,3698,'2014-01-01','ET','2',1,NULL,'Natasha Washington','FI','438530816','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:28',0,'2014-03-02 00:10:48'),(1768,1768,'2014-01-01','ET','2',1,NULL,'Kwang Kim','FI','406533053','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:18:33',0,'2014-03-10 13:20:27'),(7255,7255,'2014-01-01','ET','2',1,NULL,'Susan Douglas','FI','415113035','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:21',0,'2014-03-10 15:59:47'),(7120,7120,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:12',0,'2014-03-01 15:52:44'),(7143,7143,'2014-01-01','ET','2',1,NULL,'Douglas Smith','FI','234846351','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:54',0,'2014-03-10 15:59:47'),(16468,17118,'0000-00-00','ET','2',1,NULL,'MARY GERTRUDE CEGELSKI','FI','299469711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:17',0,'2014-03-01 17:00:58'),(22127,22777,'0000-00-00','ET','2',1,NULL,'Peggy B Castille','FI','438885736','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:49',0,'2014-03-06 21:27:26'),(22964,23614,'0000-00-00','ET','2',1,NULL,'AMANUEL F AREGAY','FI','156231960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:26',0,'2014-03-10 21:36:25'),(8,8,'2014-01-01','ET','2',4,3,'Bart Beal','FI','274607659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:15',0,'2014-03-01 15:21:15'),(14467,14918,'2014-01-01','ET','2',2,1,'Timothy Scroggins','FI','454419230','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:37',0,'2014-03-10 16:17:47'),(2435,2435,'2014-01-01','ET','2',1,NULL,'Stanley Davis','FI','587302947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:19',0,'2014-03-01 23:10:52'),(5019,5019,'2014-01-01','ET','2',1,NULL,'Lois Freed','FI','400709270','Dental Care Plus, Inc.','FI','311185262','Darwin  Carmichael','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-26 00:46:35',0,'2014-03-01 15:31:33'),(3216,3216,'2014-01-01','ET','2',1,NULL,'Geneva Bates','FI','407704489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:49',0,'2014-03-01 15:52:44'),(13590,13946,'2014-01-01','ET','2',1,NULL,'ROGER GRIFFIN','FI','587322480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:18',0,'2014-03-02 05:31:31'),(3880,3880,'2014-01-01','ET','2',1,0,'Wislande Bourdeau-Greene','FI','612078126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:33',0,'2014-03-01 19:11:03'),(7396,7396,'2014-01-01','ET','2',1,NULL,'Jonathan Retzlaff','FI','327829805','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:45',0,'2014-03-10 13:39:10'),(13532,13888,'2014-01-01','ET','2',1,NULL,'Wendy Jones','FI','298501239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:38',0,'2014-03-01 16:40:16'),(15941,16590,'0000-00-00','ET','2',1,NULL,'Patrick James McNeely','FI','289567553','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:17',0,'2014-03-10 14:10:12'),(16543,17193,'0000-00-00','ET','2',1,NULL,'THOMAS D BICKMAM','FI','434752467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:05',0,'2014-03-02 06:10:30'),(17366,18016,'0000-00-00','ET','2',1,NULL,'BLANCA FLORES','FI','463376520','Starmount Life Insurance Company','FI','720977315','VIANEY  MARTINEZ','94','15750460','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:18',0,'2014-03-02 06:24:38'),(19229,19879,'0000-00-00','ET','2',1,NULL,'Angelica Bethancourt','FI','545896077','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:23',0,'2014-03-02 06:52:12'),(21052,21702,'0000-00-00','ET','2',1,NULL,'Sheirida Dunn','FI','548531657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:14',0,'2014-03-01 18:10:11'),(5351,5351,'2014-01-01','ET','2',1,NULL,'MICHAEL GIURBINO','FI','289509713','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:53',0,'2014-03-10 15:39:19'),(12887,12887,'2014-01-01','ET','2',1,NULL,'PATRICIA GOFF','FI','264844057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:25',0,'2014-03-02 05:10:52'),(1479,1479,'2014-01-01','ET','2',1,NULL,'Tammy Meyer','FI','267453674','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:45',0,'2014-03-10 13:45:57'),(7534,7534,'2014-01-01','ET','2',1,NULL,'DARRINA KATHERYN LARKIN','FI','298583260','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:07',0,'2014-03-01 16:05:34'),(3659,3659,'2014-01-01','ET','2',1,NULL,'Brandon Malbrough','FI','433474304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:12',0,'2014-03-02 00:10:48'),(17018,17668,'0000-00-00','ET','2',1,NULL,'Angela Fine','FI','437572742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:09',0,'2014-03-02 06:24:38'),(18487,19137,'0000-00-00','ET','2',1,NULL,'Haley Cohn','FI','426734084','Starmount Life Insurance Company','FI','720977315','Tammy W Burns','94','16995809','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:01',0,'2014-03-02 06:45:14'),(19963,20613,'0000-00-00','ET','2',1,NULL,'Gabriel Cotruta','FI','285065390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-21 22:00:26',0,'2014-03-01 17:47:19'),(23042,23692,'0000-00-00','ET','2',1,NULL,'Scott P Sorensen','FI','433350059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:22',0,'2014-03-10 21:27:11'),(357,357,'2014-01-01','ET','2',1,NULL,'Jennifer Campbell','FI','280581680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:00',0,'2014-03-01 15:21:15'),(3949,3949,'2014-01-01','ET','2',2,1,'Kenneth Fuller','FI','456471496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:30',0,'2014-03-01 23:10:52'),(2989,2989,'2014-01-01','ET','2',1,NULL,'SYLVIA RULLAN','FI','633101492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:47',0,'2014-03-02 01:10:33'),(14514,14965,'2014-01-01','ET','2',1,NULL,'SUSAN RAFTERY','FI','287527520','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:59',0,'2014-03-10 14:03:26'),(14429,14880,'2014-01-01','ET','2',4,3,'Stacey Boone','FI','299909555','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:21',0,'2014-03-10 14:03:26'),(1922,1922,'2014-01-01','ET','2',1,NULL,'Angela Bartels-Behring','FI','298726253','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:24',0,'2014-03-01 15:26:40'),(13779,14135,'2014-01-01','ET','2',1,NULL,'PAMELA DILLARD','FI','428132575','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:32',0,'2014-03-02 05:24:45'),(2841,2841,'2014-01-01','ET','2',1,NULL,'Phillip Lowe','FI','306646256','Starmount Life Insurance Company','FI','720977315','Monacita  Montano','94','15736408','348','2014-01-01','Sync Success',0,'2013-12-25 21:21:42',0,'2014-03-02 04:15:49'),(7442,7442,'2014-01-01','ET','2',2,1,'Ramona Kaisar','FI','586109499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:10',0,'2014-03-02 04:10:25'),(12442,12442,'2014-01-01','ET','2',1,NULL,'AKIRA KHALIA COOPER','FI','439794373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:12',0,'2014-03-02 05:03:29'),(16652,17302,'0000-00-00','ET','2',1,NULL,'EUGENE BEATY','FI','284523771','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:42',0,'2014-03-10 16:24:30'),(17334,17984,'0000-00-00','ET','2',1,NULL,'Joe Collins','FI','587948931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:13',0,'2014-03-02 06:24:38'),(18727,19377,'0000-00-00','ET','2',1,NULL,'Laurieanne Abernathy','FI','460833658','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:13',0,'2014-03-02 06:52:12'),(23047,23697,'0000-00-00','ET','2',1,NULL,'Brian A Thompson','FI','427492299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:26',0,'2014-03-10 21:27:11'),(11797,11797,'2014-01-01','ET','2',1,NULL,'janet miranda miranda','FI','832450003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:13:02',0,'2014-03-02 04:31:46'),(2809,2809,'2014-01-01','ET','2',1,NULL,'Stanley C Vo','FI','554652596','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:36',0,'2014-03-01 16:05:34'),(3403,3403,'2014-01-01','ET','2',1,NULL,'Deborah Eversole','FI','287549922','HealthSpan','FI','311431434','Michael  Dougherty','94','8793711','348','2014-01-01','Sync Success',0,'2013-12-25 21:51:47',0,'2014-03-10 13:24:34'),(3212,3212,'2014-01-01','ET','2',1,NULL,'Kathryn Blake','FI','277688740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:42',0,'2014-03-01 15:48:04'),(15357,15808,'0000-00-00','ET','2',1,NULL,'STEVEN ELMER','FI','292602695','HealthSpan','FI','311431434','JOSEPH  T HESSLING','94','7320983','357','2014-03-01','Sync Success',0,'2014-01-21 08:46:53',0,'2014-03-10 14:10:12'),(21365,22015,'0000-00-00','ET','2',1,NULL,'Maria Ramirez','FI','372608915','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:33',0,'2014-03-03 01:07:25'),(13872,14228,'2014-01-01','ET','2',1,NULL,'alexia nichols','FI','425452632','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:03',0,'2014-03-02 05:31:31'),(11874,11874,'2014-01-01','ET','2',1,NULL,'Tracey Kearney','FI','253907395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:11',0,'2014-03-02 04:59:36'),(7757,7757,'2014-01-01','ET','2',1,NULL,'ORLANDO ALDANA','FI','609689457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:06',0,'2014-03-01 19:11:03'),(15659,16308,'0000-00-00','ET','2',5,4,'Margaret Bowman','FI','401177729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:19',0,'2014-03-01 16:56:22'),(21988,22638,'0000-00-00','ET','2',1,NULL,'Kevin Osborne','FI','281704322','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:45',0,'2014-03-10 16:44:18'),(17984,18634,'0000-00-00','ET','2',1,NULL,'Joy Marlow','FI','405969247','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:28',0,'2014-03-10 14:24:38'),(12308,12308,'2014-01-01','ET','2',2,1,'Adina Fox','FI','269722200','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:35',0,'2014-03-10 16:10:34'),(5735,5735,'2014-01-01','ET','2',1,NULL,'Silvana Leone','FI','288626764','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:28',0,'2014-03-01 15:48:04'),(5691,5691,'2014-01-01','ET','2',2,1,'Erica Barney','FI','285844199','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:06',0,'2014-03-01 15:37:30'),(4840,4840,'2014-01-01','ET','2',2,1,'Charles Saunders','FI','297587170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:18',0,'2014-03-01 15:10:22'),(10636,10636,'2014-01-01','ET','2',1,NULL,'Ernestina Garcia','FI','454319637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:22',0,'2014-03-02 04:31:46'),(4685,4685,'2014-01-01','ET','2',1,NULL,'RICHARD EAKENS','FI','585548328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:07',0,'2014-03-02 04:31:46'),(4668,4668,'2014-01-01','ET','2',1,NULL,'Kareema Williams','FI','296861429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:30',0,'2014-03-01 16:15:39'),(18131,18781,'0000-00-00','ET','2',1,NULL,'JARRETT JORDAN','FI','439719645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:01',0,'2014-03-02 06:45:14'),(20634,21284,'0000-00-00','ET','2',1,NULL,'Elizabeth McCollum','FI','585664867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:13',0,'2014-03-02 07:10:28'),(22380,23030,'0000-00-00','ET','2',2,1,'Natalia Deborah Skef Promoslovsky','FI','661057200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:25',0,'2014-03-07 21:25:22'),(178,178,'2014-01-01','ET','2',1,NULL,'Lee Sutton','FI','434676988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:31',0,'2014-03-01 22:10:55'),(5915,5915,'2014-01-01','ET','2',2,1,'Raymond Hattar','94','0000279532','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:16',0,'2014-03-01 15:48:04'),(14117,14568,'2014-01-01','ET','2',1,NULL,'David Connerth','FI','284662274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:46',0,'2014-03-01 16:46:19'),(15504,15955,'0000-00-00','ET','2',2,1,'SANDRA S SERGENT-MICHEL','FI','302501234','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:52',0,'2014-03-01 16:50:53'),(15716,16365,'0000-00-00','ET','2',2,1,'Kenneth Yambra','FI','433532585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:58',0,'2014-03-02 05:59:43'),(16487,17137,'0000-00-00','ET','2',1,NULL,'Candice Jackson','FI','456990499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:29',0,'2014-03-02 06:10:30'),(18120,18770,'0000-00-00','ET','2',1,NULL,'Isaac Fontenot-Amedee','FI','435579844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:53',0,'2014-03-02 06:38:05'),(19095,19745,'0000-00-00','ET','2',1,NULL,'ELIZABETH COMER','FI','275728501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:40',0,'2014-03-01 17:34:07'),(21368,22018,'0000-00-00','ET','2',1,NULL,'Mitchell Craft','FI','463947114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:34',0,'2014-03-03 01:07:25'),(6142,6142,'2014-01-01','ET','2',1,NULL,'LISA  SMITH','FI','287680105','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:34',0,'2014-03-01 16:00:27'),(5103,5103,'2014-01-01','ET','2',1,NULL,'Fred Casby','FI','433113802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:15',0,'2014-03-02 00:10:48'),(4659,4659,'2014-01-01','ET','2',1,NULL,'Carol Ridge','FI','303540499','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:14',0,'2014-03-10 13:45:57'),(16,16,'2014-01-01','ET','2',1,NULL,'Calvin M Singleton','FI','301508757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:30',0,'2014-03-01 15:21:15'),(12958,12958,'2014-01-01','ET','2',2,1,'Brenda G  Wilkerson','FI','460611113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:39',0,'2014-03-02 05:17:40'),(12622,12622,'2014-01-01','ET','2',1,NULL,'Judy Goodsheller','FI','452986593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:52',0,'2014-03-02 05:10:52'),(1798,1798,'2014-01-01','ET','2',1,NULL,'ray jones','FI','587111652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:35',0,'2014-03-02 00:10:48'),(3505,3505,'2014-01-01','ET','2',1,NULL,'FREDDY JAMES III THOMAS','FI','291806032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:23',0,'2014-03-01 15:37:30'),(5990,5990,'2014-01-01','ET','2',1,NULL,'Janet Dalrymple','FI','268584501','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:39',0,'2014-03-10 13:24:34'),(12352,12352,'2014-01-01','ET','2',1,NULL,'ANDREW BERNARD JENKINS','FI','454790693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:27:58',0,'2014-03-02 05:03:29'),(11769,11769,'2014-01-01','ET','2',1,NULL,'MARY ANDERSEN','FI','433749840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:59',0,'2014-03-02 04:59:36'),(14752,15203,'2014-01-01','ET','2',1,NULL,'Steven Purcell','FI','292863211','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Harkleroad','94','1772711','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:27',0,'2014-03-10 16:17:47'),(14865,15316,'2014-01-01','ET','2',1,NULL,'Joshua Barker','FI','640058191','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:08',0,'2014-03-02 05:52:31'),(18053,18703,'0000-00-00','ET','2',3,2,'THANH VU','FI','291828843','HealthSpan','FI','311431434','DARWIN  CARMICHAEL','94','1300095','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:17',0,'2014-03-10 14:24:38'),(19575,20225,'0000-00-00','ET','2',2,1,'margaretta johnson','FI','102609964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:24:50',0,'2014-03-10 14:37:47'),(19659,20308,'0000-00-00','ET','2',2,1,'EMILY GARZA','FI','280843026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:45:41',0,'2014-03-01 17:47:19'),(21362,22012,'0000-00-00','ET','2',1,NULL,'Ray Sohrabi','FI','577864342','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:31',0,'2014-03-10 16:38:05'),(22660,23310,'0000-00-00','ET','2',2,1,'TOMAS OVIEDO','FI','449939941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:27',0,'2014-03-08 22:26:18'),(22967,23617,'0000-00-00','ET','2',1,NULL,'TERESA TONYA','FI','280685251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:28',0,'2014-03-10 21:36:25'),(11734,11734,'2014-01-01','ET','2',1,NULL,'Cynthia Bidlencsik','FI','298525603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:57',0,'2014-03-01 16:30:17'),(10549,10549,'2014-01-01','ET','2',1,NULL,'OLGA HERNANDEZ','FI','585235937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:55:31',0,'2014-03-02 04:24:47'),(1029,1029,'2014-01-01','ET','2',1,NULL,'Jeffrey Sibberson','FI','276720773','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:09',0,'2014-03-10 13:10:24'),(17477,18127,'0000-00-00','ET','2',1,NULL,'Joseph Allen','FI','296865761','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:36',0,'2014-03-10 14:24:38'),(12551,12551,'2014-01-01','ET','2',1,NULL,'David Collier','FI','298869539','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:17',0,'2014-03-10 16:10:34'),(482,482,'2014-01-01','ET','2',1,NULL,'Pamela Roush','FI','292565045','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 17:51:05',0,'2014-03-10 13:10:24'),(846,846,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:15:32',0,'2014-03-01 22:10:55'),(5312,5312,'2014-01-01','ET','2',2,1,'Marilyn Hess','FI','571510608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:53',0,'2014-03-01 19:11:03'),(12945,12945,'2014-01-01','ET','2',1,NULL,'Kaneisha Manuel','FI','439695456','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-05 00:00:10',0,'2014-03-02 05:17:40'),(6343,6343,'2014-01-01','ET','2',1,NULL,'Anna Zacharias','FI','292849717','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:43',0,'2014-03-10 13:39:10'),(6301,6301,'2014-01-01','ET','2',1,NULL,'Jametria Irvin','FI','587656338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:07:26',0,'2014-03-02 04:10:25'),(3200,3200,'2014-01-01','ET','2',1,NULL,'Deborah Eversole','FI','287549922','Dental Care Plus, Inc.','FI','311185262','Michael  Dougherty','94','8793711','348','2014-01-01','Sync Success',0,'2013-12-25 21:45:17',0,'2014-03-01 15:48:04'),(5509,5509,'2014-01-01','ET','2',1,NULL,'Tammy Lynn Selick','FI','281649122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:43',0,'2014-03-01 16:23:43'),(14513,14964,'2014-01-01','ET','2',1,NULL,'Thelma B Trimble','FI','273505604','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:59',0,'2014-03-10 14:03:26'),(17665,18315,'0000-00-00','ET','2',1,NULL,'Pete Miller','FI','277082726','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3445388','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:44',0,'2014-03-01 17:20:55'),(17762,18412,'0000-00-00','ET','2',2,1,'ROBERT MCCOLLUM','FI','564316742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:44',0,'2014-03-02 06:31:45'),(18252,18902,'0000-00-00','ET','2',4,3,'Alison Huff','FI','296764146','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:38',0,'2014-03-10 14:24:38'),(20064,20714,'0000-00-00','ET','2',2,1,'RICHARD WOLF','FI','281546318','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:21',0,'2014-03-10 16:38:05'),(2690,2690,'2014-01-01','ET','2',2,1,'Dwayne Harless','FI','500701221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:52',0,'2014-03-02 04:15:49'),(14360,14811,'2014-01-01','ET','2',2,1,'Rubina Minhas','94','0001260031','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:49',0,'2014-03-10 16:17:47'),(1303,1303,'2014-01-01','ET','2',1,NULL,'Erich Kincaid','FI','526774668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:54',0,'2014-03-02 04:45:37'),(2267,2267,'2014-01-01','ET','2',1,0,'Amber Kirby-Rogers','FI','615460843','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:03',0,'2014-03-01 19:11:03'),(7216,7216,'2014-01-01','ET','2',1,NULL,'Joseph Bennett','FI','290562400','Dental Care Plus, Inc.','FI','311185262','William D Helser','94','1825544','348','2014-01-01','Sync Success',0,'2013-12-26 04:07:07',0,'2014-03-01 15:52:44'),(10381,10381,'2014-01-01','ET','2',1,NULL,'RICHARD A UHLENBROCK','FI','278468658','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:08',0,'2014-03-01 16:10:36'),(10450,10450,'2014-01-01','ET','2',1,NULL,'Robert Hamrick','FI','278766564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:18',0,'2014-03-01 16:10:36'),(14047,14498,'2014-01-01','ET','2',1,NULL,'DARLA TURNER','FI','288421921','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:00',0,'2014-03-01 16:40:16'),(15152,15603,'0000-00-00','ET','2',1,NULL,'Amanda Eddington','FI','604405824','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:27',0,'2014-03-02 05:52:31'),(17800,18450,'0000-00-00','ET','2',1,NULL,'David Chamberlain','FI','003528977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:34',0,'2014-03-01 16:56:22'),(11336,11336,'2014-01-01','ET','2',1,NULL,'Jerry L Alderson','FI','629053225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:38',0,'2014-03-02 04:52:44'),(628,628,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:33',0,'2014-03-02 02:10:49'),(7058,7058,'2014-01-01','ET','2',1,NULL,'Debra Waller','FI','278521991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:16',0,'2014-03-01 15:52:44'),(4508,4508,'2014-01-01','ET','2',1,NULL,'PAMELA CARNAHAN','FI','295521099','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:19',0,'2014-03-10 13:03:33'),(3592,3592,'2014-01-01','ET','2',1,NULL,'William Trevino','FI','460678224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:05',0,'2014-03-02 01:10:33'),(15154,15605,'0000-00-00','ET','2',1,NULL,'Julian Guilfoyle','FI','279889189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:29',0,'2014-03-10 14:10:12'),(16469,17119,'0000-00-00','ET','2',1,NULL,'David Weber','FI','274605061','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:17',0,'2014-03-01 17:00:58'),(17165,17815,'0000-00-00','ET','2',1,NULL,'BRITTANY TUCKER','FI','296825488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:43',0,'2014-03-01 17:00:58'),(18087,18737,'0000-00-00','ET','2',1,NULL,'Teresita Smith','FI','452296297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:28',0,'2014-03-02 06:38:05'),(20033,20683,'0000-00-00','ET','2',1,NULL,'Marquis Brannon','FI','289907128','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:15',0,'2014-03-10 16:38:05'),(20310,20960,'0000-00-00','ET','2',1,NULL,'CARLOS AVILES','FI','148581453','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:49',0,'2014-03-01 17:47:19'),(22234,22884,'0000-00-00','ET','2',1,NULL,'Janice Marie Smith','FI','426337150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:02:05',0,'2014-03-06 21:27:26'),(23051,23701,'0000-00-00','ET','2',1,NULL,'THELMA SMITH','FI','587239891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:28',0,'2014-03-10 21:27:11'),(14432,14883,'2014-01-01','ET','2',2,1,'Johnny Marbury','FI','439232312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:23',0,'2014-03-02 05:38:34'),(46,46,'2014-01-01','ET','2',1,NULL,'Charlotte Denise Love','FI','283669208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:23',0,'2014-03-01 15:21:15'),(297,297,'2014-01-01','ET','2',1,NULL,'Lori Hendrix','FI','456117308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:08',0,'2014-03-01 22:10:55'),(14108,14559,'2014-01-01','ET','2',2,1,'Robert Cogley','FI','480749084','Dental Care Plus, Inc.','FI','311185262','Lori  Wintering','94','1866961','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:40',0,'2014-03-01 16:40:16'),(13242,13598,'2014-01-01','ET','2',1,NULL,'ELLEN  GREEN','FI','436299746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:48',0,'2014-03-02 05:17:40'),(1904,1904,'2014-01-01','ET','2',1,NULL,'Wendy J Lugo','FI','798582861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:53',0,'2014-03-01 23:10:52'),(12611,12611,'2014-01-01','ET','2',1,NULL,'Mable K Burrier','FI','453966625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:29',0,'2014-03-02 05:10:52'),(12438,12438,'2014-01-01','ET','2',1,NULL,'LISA M BOURGEOIS','FI','439411161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:03',0,'2014-03-02 05:03:29'),(7427,7427,'2014-01-01','ET','2',1,NULL,'Karen Napoli','FI','434021453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:43',0,'2014-03-02 04:15:49'),(7661,7661,'2014-01-01','ET','2',2,1,'William M Beam','FI','287727302','HealthSpan','FI','311431434','Rod  Weller','94','2759353','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:10',0,'2014-03-10 13:39:10'),(10557,10557,'2014-01-01','ET','2',1,NULL,'Jaime Noyola','FI','459851177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:46',0,'2014-03-02 04:24:47'),(10937,10937,'2014-01-01','ET','2',1,NULL,'Micheal Hill','FI','365528774','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:51',0,'2014-03-10 16:03:49'),(12330,12330,'2014-01-01','ET','2',1,NULL,'Anthony Lee','FI','460399112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:12',0,'2014-03-02 05:03:29'),(17779,18429,'0000-00-00','ET','2',1,NULL,'Gregory D Harmison','FI','452796143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:16',0,'2014-03-02 06:17:30'),(19110,19760,'0000-00-00','ET','2',1,NULL,'Deborah Harrison','FI','295528942','HealthSpan','FI','311431434','Mary K Lodge','94','11976263','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:51',0,'2014-03-10 14:31:05'),(21793,22443,'0000-00-00','ET','2',1,NULL,'Delila Davila','FI','641010797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:12',0,'2014-03-04 22:25:23'),(1590,1590,'2014-01-01','ET','2',1,NULL,'harvey d mcgurer','FI','286507430','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:57',0,'2014-03-10 15:39:19'),(15891,16540,'0000-00-00','ET','2',1,NULL,'DORIS WELLS','FI','587609777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:07',0,'2014-03-02 06:03:21'),(22116,22766,'0000-00-00','ET','2',1,NULL,'SHARON JAMES','FI','439511137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:41',0,'2014-03-06 21:27:26'),(22195,22845,'0000-00-00','ET','2',1,NULL,'joshua ortiz','FI','071668416','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:36',0,'2014-03-06 21:27:26'),(2923,2923,'2014-01-01','ET','2',2,1,'JACK RONALD SPRADLING','FI','293504553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:39',0,'2014-03-01 15:37:30'),(13307,13663,'2014-01-01','ET','2',2,1,'David Meek','FI','232215634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:15',0,'2014-03-01 16:40:16'),(11425,11425,'2014-01-01','ET','2',1,NULL,'david russell beery','FI','275740459','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:21',0,'2014-03-10 16:03:49'),(15214,15665,'0000-00-00','ET','2',2,1,'Brenda Vance','94','0000373656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:35',0,'2014-03-01 16:50:53'),(17066,17716,'0000-00-00','ET','2',1,NULL,'Lisa Glodt','FI','463932218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:38',0,'2014-03-02 06:24:38'),(19222,19872,'0000-00-00','ET','2',1,NULL,'Adam Ranucci','FI','297888697','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:18',0,'2014-03-01 17:34:07'),(21138,21788,'0000-00-00','ET','2',1,NULL,'nadiyah Muhammad','FI','434336210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:13',0,'2014-03-02 07:23:39'),(21531,22181,'0000-00-00','ET','2',1,NULL,'LAWRENCE PRASEK','FI','461436133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:17',0,'2014-03-03 22:26:43'),(22189,22839,'0000-00-00','ET','2',1,NULL,'AMEER VURDUN','FI','328668916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:32',0,'2014-03-06 21:27:26'),(13944,14300,'2014-01-01','ET','2',1,NULL,'sonal pakvasa','FI','272744471','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:29',0,'2014-03-10 16:10:34'),(5216,5216,'2014-01-01','ET','2',1,NULL,'SANDRA R HEPPARD','FI','288728829','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:54',0,'2014-03-10 13:20:27'),(773,773,'2014-01-01','ET','2',1,NULL,'Jennifer Ann Rini','FI','296805161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 18:09:10',0,'2014-03-01 15:05:09'),(12691,12691,'2014-01-01','ET','2',1,NULL,'Harold Bright','FI','292542931','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:26',0,'2014-03-10 16:10:34'),(4177,4177,'2014-01-01','ET','2',1,NULL,'Robert Norris','FI','301682668','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Brett','94','2777121','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:28',0,'2014-03-10 15:59:47'),(2075,2075,'2014-01-01','ET','2',1,NULL,'Rhonda Hovan','FI','286481377','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:15',0,'2014-03-10 15:45:56'),(17744,18394,'0000-00-00','ET','2',1,NULL,'Jessica Briseno','FI','628328393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:31',0,'2014-03-02 06:31:45'),(18697,19347,'0000-00-00','ET','2',1,NULL,'kevin martin','FI','452635035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:50',0,'2014-03-02 06:52:12'),(16081,16730,'0000-00-00','ET','2',1,NULL,'richard brown','FI','280768832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:04',0,'2014-03-01 16:56:22'),(10861,10861,'2014-01-01','ET','2',1,NULL,'Matt Jordan','FI','286863329','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:53',0,'2014-03-10 13:45:57'),(5839,5839,'2014-01-01','ET','2',2,1,'terri williams','FI','300565128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:42',0,'2014-03-01 15:10:22'),(4999,4999,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:45:56',0,'2014-03-01 15:31:33'),(15246,15697,'0000-00-00','ET','2',1,NULL,'bertha nunez','FI','585029265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:26',0,'2014-03-02 05:52:31'),(15647,16296,'0000-00-00','ET','2',1,NULL,'lynn kennedy','FI','277528425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:09',0,'2014-03-01 16:56:22'),(17719,18369,'0000-00-00','ET','2',1,NULL,'Jeffery Swank','FI','288766718','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-09 19:00:14',0,'2014-03-01 17:20:55'),(20868,21518,'0000-00-00','ET','2',1,NULL,'Michael Birchfield','FI','453356782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:31:30',0,'2014-03-02 07:17:36'),(7711,7711,'2014-01-01','ET','2',1,NULL,'kenneth Childers','FI','549022704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:52',0,'2014-03-01 20:10:57'),(4243,4243,'2014-01-01','ET','2',1,NULL,'Juan D Jones','FI','285780248','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:35',0,'2014-03-10 15:59:47'),(5751,5751,'2014-01-01','ET','2',1,NULL,'LISA ALLEN','FI','438418691','Starmount Life Insurance Company','FI','720977315','ERNEST  LEBLANT Jr','94','9013983','348','2014-01-01','Sync Success',0,'2013-12-26 02:01:55',0,'2014-03-02 01:10:33'),(1981,1981,'2014-01-01','ET','2',1,NULL,'MARK GIORGIANNI','94','0000160759','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:14',0,'2014-03-10 15:45:56'),(3677,3677,'2014-01-01','ET','2',1,NULL,'JANE BLANKS STRICKLAND','FI','587704583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:45',0,'2014-03-02 00:10:48'),(3121,3121,'2014-01-01','ET','2',1,NULL,'Daniel Bricker','FI','276566730','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:49',0,'2014-03-10 15:52:36'),(2999,2999,'2014-01-01','ET','2',1,NULL,'timothy mccaffrey','FI','457979454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:06',0,'2014-03-02 01:10:33'),(18409,19059,'0000-00-00','ET','2',2,1,'Dean Podgorski','FI','284642933','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:07',0,'2014-03-01 17:26:36'),(18515,19165,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:21',0,'2014-03-10 14:31:05'),(18537,19187,'0000-00-00','ET','2',1,NULL,'CHARLOTTE BEVLY','FI','298485031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:06',0,'2014-03-01 17:26:36'),(20116,20766,'0000-00-00','ET','2',1,NULL,'Money Johnson','FI','439068562','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-03-31','Sync Success',0,'2014-02-25 21:30:31',0,'2014-03-02 07:10:28'),(13745,14101,'2014-01-01','ET','2',1,NULL,'James Trowbridge','FI','286626869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:11',0,'2014-03-01 16:40:16'),(303,303,'2014-01-01','ET','2',1,NULL,'carissa parks','FI','453854356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:18',0,'2014-03-01 22:10:55'),(13448,13804,'2014-01-01','ET','2',1,NULL,'Christi Cole','FI','540275629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:18:17',0,'2014-03-02 05:31:31'),(437,437,'2014-01-01','ET','2',1,NULL,'Deborah Spiers','FI','414941495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:33',0,'2014-03-01 22:10:55'),(2200,2200,'2014-01-01','ET','2',1,NULL,'Rica James','FI','438633882','Starmount Life Insurance Company','FI','720977315','Patrice  Dangerfield','94','7388530','348','2014-01-01','Sync Success',0,'2013-12-25 19:48:11',0,'2014-03-01 21:11:04'),(14698,15149,'2014-01-01','ET','2',1,NULL,'Reginald Mark','FI','436293090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:54',0,'2014-03-02 05:45:37'),(16168,16817,'0000-00-00','ET','2',3,2,'Tanzie Wood','FI','273722686','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:18',0,'2014-03-01 16:56:22'),(19752,20402,'0000-00-00','ET','2',1,NULL,'William Fowlkes','FI','316805554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:08',0,'2014-03-01 17:47:19'),(22284,22934,'0000-00-00','ET','2',2,1,'Wendy A Deubler','FI','280806340','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:41',0,'2014-03-10 14:50:59'),(670,670,'2014-01-01','ET','2',1,NULL,'CYNTHIA BEDNAR','FI','297424826','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:47',0,'2014-03-10 15:52:36'),(10679,10679,'2014-01-01','ET','2',1,NULL,'JASON MEEKER','FI','285866602','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:59:43',0,'2014-03-01 16:10:36'),(4549,4549,'2014-01-01','ET','2',1,NULL,'Kristen C Smith','FI','437850593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:41',0,'2014-03-02 04:31:46'),(4527,4527,'2014-01-01','ET','2',1,NULL,'Victoria Lemmond','FI','632441585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:33:00',0,'2014-03-01 21:11:04'),(4473,4473,'2014-01-01','ET','2',1,NULL,'Mark Love','FI','361668083','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:10',0,'2014-03-01 21:11:04'),(14453,14904,'2014-01-01','ET','2',1,NULL,'Trinette Lee','FI','561332481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:31',0,'2014-03-02 05:38:34'),(19882,20532,'0000-00-00','ET','2',1,NULL,'annette keltner','FI','298663984','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:29',0,'2014-03-10 14:37:47'),(22781,23431,'0000-00-00','ET','2',1,NULL,'Samuel Ayete','FI','660351067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:34',0,'2014-03-09 21:35:27'),(22823,23473,'0000-00-00','ET','2',2,1,'Debra Louise Messenger','FI','276566471','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:12',0,'2014-03-10 16:44:18'),(22830,23480,'0000-00-00','ET','2',1,NULL,'ERIN GUISINGER','FI','275886818','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:18',0,'2014-03-10 14:50:59'),(304,304,'2014-01-01','ET','2',1,NULL,'Ashley Chambers','FI','629588085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:20',0,'2014-03-01 22:10:55'),(13225,13581,'2014-01-01','ET','2',2,1,'CHARLES BRAY','FI','448687855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:04',0,'2014-03-02 05:17:40'),(2125,2125,'2014-01-01','ET','2',1,NULL,'Mark Wagher','FI','347549678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:41',0,'2014-03-01 15:16:37'),(2376,2376,'2014-01-01','ET','2',1,NULL,'Alan Bady','FI','301448116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:31',0,'2014-03-01 15:26:40'),(6016,6016,'2014-01-01','ET','2',1,NULL,'Melissa Bowers','FI','279740725','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:25',0,'2014-03-01 15:10:22'),(12273,12273,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:19',0,'2014-03-10 16:10:34'),(12183,12183,'2014-01-01','ET','2',1,NULL,'JUDY AMOS','FI','289421775','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:41',0,'2014-03-10 13:52:32'),(20162,20812,'0000-00-00','ET','2',1,NULL,'DONNA LYNN SQUICCIARINI','FI','292604143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:04',0,'2014-03-01 18:08:07'),(22185,22835,'0000-00-00','ET','2',1,NULL,'Russell Williams','FI','294741172','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:01:28',0,'2014-03-06 21:36:23'),(22562,23212,'0000-00-00','ET','2',1,NULL,'PAMELA JONES','FI','288689552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:54',0,'2014-03-10 16:44:18'),(5568,5568,'2014-01-01','ET','2',1,NULL,'beau finley','FI','644128932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:36',0,'2014-03-02 04:45:37'),(4899,4899,'2014-01-01','ET','2',1,NULL,'Christina Boyd','FI','274707128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:05',0,'2014-03-01 15:05:09'),(2661,2661,'2014-01-01','ET','2',5,4,'Denise Latscha','FI','272806586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:50',0,'2014-03-01 16:05:34'),(3923,3923,'2014-01-01','ET','2',1,NULL,'Marilyn Arora','FI','286382449','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:44',0,'2014-03-01 15:26:40'),(18974,19624,'0000-00-00','ET','2',1,NULL,'STEVEN B ENGLISH','FI','294723944','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:55',0,'2014-03-10 14:31:05'),(20472,21122,'0000-00-00','ET','2',1,NULL,'Zahra Ablaghi-Darian','FI','277966737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:25',0,'2014-03-01 18:08:07'),(22022,22672,'0000-00-00','ET','2',2,1,'Roberto Martin Avendano','FI','636165744','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:07',0,'2014-03-05 22:27:33'),(13959,14315,'2014-01-01','ET','2',1,NULL,'Joan Deidrick','FI','273429784','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:40',0,'2014-03-10 14:03:26'),(5101,5101,'2014-01-01','ET','2',1,NULL,'Gina Otzenberger Breaux','FI','433338821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:11',0,'2014-03-02 00:10:48'),(12576,12576,'2014-01-01','ET','2',5,4,'Jessika Jamison','FI','269025932','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:11',0,'2014-03-01 16:35:14'),(3987,3987,'2014-01-01','ET','2',2,1,'Jill Vaughn','FI','287464328','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:49',0,'2014-03-10 13:10:24'),(11865,11865,'2014-01-01','ET','2',1,NULL,'Dorothy Tingle','FI','587342958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:19',0,'2014-03-02 04:31:46'),(7506,7506,'2014-01-01','ET','2',1,NULL,'Richard Walker','FI','300565134','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:14',0,'2014-03-01 16:05:34'),(15929,16578,'0000-00-00','ET','2',1,NULL,'LINDA L MALTRY','FI','272687352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:10',0,'2014-03-01 16:56:22'),(17382,18032,'0000-00-00','ET','2',1,NULL,'Kathy Ann Crowe','FI','234860608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-21','Sync Success',0,'2014-02-06 21:00:30',0,'2014-03-01 17:20:55'),(21113,21763,'0000-00-00','ET','2',1,NULL,'RICKY  O RENFRO','FI','463339012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:55',0,'2014-03-02 07:23:39'),(21903,22553,'0000-00-00','ET','2',1,NULL,'MARLINDA O RODRIGUEZ','FI','462492184','Starmount Life Insurance Company','FI','720977315','MARIA ELIZA  HIGGINBOTHAM','94','1636407','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:46',0,'2014-03-05 22:27:33'),(22353,23003,'0000-00-00','ET','2',1,NULL,'CAROL ANN MILLER','FI','299508149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:13',0,'2014-03-07 21:36:32'),(582,582,'2014-01-01','ET','2',1,NULL,'Kathryn Leigh Nathan','FI','433742127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:00',0,'2014-03-02 02:10:49'),(13558,13914,'2014-01-01','ET','2',1,NULL,'Charles Johnson','FI','425479527','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:53',0,'2014-03-02 05:31:31'),(14681,15132,'2014-01-01','ET','2',1,NULL,'Linda Golupski','FI','274566756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:42',0,'2014-03-01 16:46:19'),(15120,15571,'0000-00-00','ET','2',1,NULL,'Michael Hummer','94','0000968239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:04',0,'2014-03-01 16:50:53'),(15176,15627,'0000-00-00','ET','2',1,NULL,'ROBERT LOVE','FI','278906806','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:46',0,'2014-03-10 16:17:47'),(16813,17463,'0000-00-00','ET','2',1,NULL,'Bonnie Austin','FI','453676584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:51',0,'2014-03-02 06:17:30'),(19227,19877,'0000-00-00','ET','2',1,NULL,'katheryn wilkinson','FI','466715160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:22',0,'2014-03-02 06:52:12'),(21494,22144,'0000-00-00','ET','2',1,NULL,'Patricia Hockett','FI','300587774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:51',0,'2014-03-03 21:36:16'),(819,819,'2014-01-01','ET','2',1,NULL,'Nicholas Franklin','FI','463550522','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:52',0,'2014-03-01 19:11:03'),(14347,14798,'2014-01-01','ET','2',1,NULL,'Diann Simien','FI','453063576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:44',0,'2014-03-02 05:45:37'),(4809,4809,'2014-01-01','ET','2',1,NULL,'Dionna Richardson','FI','287883408','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:08',0,'2014-03-01 15:16:37'),(4559,4559,'2014-01-01','ET','2',1,NULL,'Ava Smith','FI','435905027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:46:01',0,'2014-03-02 04:38:08'),(1932,1932,'2014-01-01','ET','2',2,1,'Donna Raymond','FI','289501127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:40',0,'2014-03-01 15:26:40'),(11845,11845,'2014-01-01','ET','2',1,NULL,'robin rude','FI','268841755','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:34',0,'2014-03-10 13:45:57'),(7293,7293,'2014-01-01','ET','2',1,NULL,'Megan Stangelo','FI','291808836','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:30',0,'2014-03-10 13:32:15'),(15552,16003,'0000-00-00','ET','2',1,NULL,'Lydia  Ellis','FI','450844301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:15',0,'2014-03-02 05:59:43'),(16720,17370,'0000-00-00','ET','2',1,NULL,'William McCarthy','94','0000710173','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:31',0,'2014-03-10 16:24:30'),(16856,17506,'0000-00-00','ET','2',1,NULL,'Kenji Nishimoto','FI','631123474','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-02 19:00:29',0,'2014-03-10 14:20:26'),(18685,19335,'0000-00-00','ET','2',2,1,'TERESA CARRERAS','FI','171549222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:40',0,'2014-03-02 06:45:14'),(19751,20401,'0000-00-00','ET','2',1,NULL,'Thomas Arthur Case','FI','283546600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:08',0,'2014-03-01 17:47:19'),(275,275,'2014-01-01','ET','2',1,0,'Everett Hollar','FI','457921051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:47',0,'2014-03-01 19:11:03'),(7066,7066,'2014-01-01','ET','2',1,NULL,'Aaron Friedman','FI','291604112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:31',0,'2014-03-01 15:52:44'),(5031,5031,'2014-01-01','ET','2',1,NULL,'KENYETTA FRAZIER','FI','283940108','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:58',0,'2014-03-01 15:31:33'),(5095,5095,'2014-01-01','ET','2',1,NULL,'Carl Green','FI','436715780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:01',0,'2014-03-02 00:10:48'),(3281,3281,'2014-01-01','ET','2',1,NULL,'Kara Andrade','FI','240570659','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:51',0,'2014-03-02 02:10:49'),(5953,5953,'2014-01-01','ET','2',1,NULL,'KENNETH WILLIAMS','FI','283544395','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:25',0,'2014-03-10 13:24:34'),(16039,16688,'0000-00-00','ET','2',1,NULL,'NICHOLE  RUFFIN','FI','433616307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:36',0,'2014-03-02 06:03:21'),(22175,22825,'0000-00-00','ET','2',1,NULL,'dennis yuellig','FI','299804736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:21',0,'2014-03-06 21:36:23'),(412,412,'2014-01-01','ET','2',1,NULL,'Willis Hill','FI','289561682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:46',0,'2014-03-01 15:21:15'),(12122,12122,'2014-01-01','ET','2',1,NULL,'Kimberley Diekmeyer','FI','275923641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:30',0,'2014-03-01 16:30:17'),(1952,1952,'2014-01-01','ET','2',1,NULL,'Siegfried  Diener','FI','300500716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:17',0,'2014-03-01 15:26:40'),(15067,15518,'2014-01-01','ET','2',1,NULL,'Mary Wright','FI','423684402','HealthSpan','FI','311431434','Rachael  Mears','94','15502736','348','2014-03-01','Sync Success',0,'2014-01-17 03:36:39',0,'2014-03-10 14:10:12'),(21401,22051,'0000-00-00','ET','2',1,NULL,'TAMMY MAROUS','FI','297664313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:11',0,'2014-03-03 21:36:16'),(11171,11171,'2014-01-01','ET','2',4,3,'KIM HUA','FI','290942732','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:40',0,'2014-03-10 13:45:57'),(3868,3868,'2014-01-01','ET','2',2,1,'Rhea Rasnic','FI','406883570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:10',0,'2014-03-01 19:11:03'),(3356,3356,'2014-01-01','ET','2',1,NULL,'Jane Rios','FI','458861419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:20',0,'2014-03-02 02:10:49'),(1570,1570,'2014-01-01','ET','2',2,1,'Sammy Geistweidt','FI','456766845','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 19:00:17',0,'2014-03-01 20:10:57'),(7211,7211,'2014-01-01','ET','2',1,NULL,'ROBIN BAISDEN','FI','297665151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:59',0,'2014-03-01 15:52:44'),(7415,7415,'2014-01-01','ET','2',1,NULL,'kalvin whitaker','FI','636148620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:21',0,'2014-03-02 04:10:25'),(19226,19876,'0000-00-00','ET','2',1,NULL,'ROBBY DUCOTE','FI','437550718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:21',0,'2014-03-02 06:52:12'),(63,63,'2014-01-01','ET','2',1,NULL,'kristy koerner','FI','295807280','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:54',0,'2014-03-01 15:21:15'),(12375,12375,'2014-01-01','ET','2',4,3,'TUAN TRAN','FI','277922314','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:45',0,'2014-03-10 13:59:38'),(1287,1287,'2014-01-01','ET','2',1,NULL,'SURYAKANT  PATEL','FI','165705417','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:23',0,'2014-03-01 16:23:43'),(2640,2640,'2014-01-01','ET','2',1,NULL,'Julie Anna Ring','FI','578962139','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:04',0,'2014-03-10 13:39:10'),(3000,3000,'2014-01-01','ET','2',1,NULL,'Mozell Ray','FI','463259623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:08',0,'2014-03-02 01:10:33'),(12342,12342,'2014-01-01','ET','2',1,NULL,'OLIVIA TREJO','94','0000969853','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',1,'2014-01-02 04:27:37',0,'2014-03-02 05:03:29'),(11929,11929,'2014-01-01','ET','2',1,NULL,'Robert Thomas','FI','463933558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:56',0,'2014-03-02 04:59:36'),(10435,10435,'2014-01-01','ET','2',2,1,'Richard Leighton','FI','279429339','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:47',0,'2014-03-01 16:10:36'),(18576,19226,'0000-00-00','ET','2',1,NULL,'Irving Chernoff','FI','245766030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:14',0,'2014-03-01 17:26:36'),(18930,19580,'0000-00-00','ET','2',2,1,'PAMELA BLACKWOOD','FI','277629376','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:23',0,'2014-03-10 16:31:33'),(21597,22247,'0000-00-00','ET','2',1,NULL,'Holly Moore','FI','489829133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:17',0,'2014-03-04 21:27:16'),(22458,23108,'0000-00-00','ET','2',2,1,'JACQUELYN D RAMSEY','FI','285601605','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN P KELLY','94','2516200','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:40',0,'2014-03-10 16:44:18'),(4451,4451,'2014-01-01','ET','2',1,NULL,'philip Whisner','FI','300804736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:29',0,'2014-03-01 15:16:37'),(14289,14740,'2014-01-01','ET','2',1,NULL,'sunnie distelhorst','94','0001191359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:19',0,'2014-03-01 16:46:19'),(2572,2572,'2014-01-01','ET','2',1,NULL,'Emma Menge','FI','295082972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:04',0,'2014-03-01 15:05:09'),(1378,1378,'2014-01-01','ET','2',2,1,'Roderick Rogers','FI','413064171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:18',0,'2014-03-02 04:45:37'),(1752,1752,'2014-01-01','ET','2',1,NULL,'NANCY CATHERINE LEIS','FI','273466100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:03',0,'2014-03-01 15:31:33'),(1856,1856,'2014-01-01','ET','2',1,NULL,'Patricia  L Throckmorton','FI','296544308','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:24',0,'2014-03-01 15:26:40'),(10512,10512,'2014-01-01','ET','2',1,NULL,'Ann Riggs','FI','512728932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:13',0,'2014-03-02 04:15:49'),(12827,12827,'2014-01-01','ET','2',1,NULL,'GALE GIMAGGIO','FI','497689926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:14',0,'2014-03-02 05:10:52'),(12739,12739,'2014-01-01','ET','2',2,1,'Andrew Frowine','FI','276428943','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:16',0,'2014-03-10 13:59:38'),(17883,18533,'0000-00-00','ET','2',1,NULL,'Nina Dehmel','FI','268600188','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:18',0,'2014-03-10 16:31:33'),(18730,19380,'0000-00-00','ET','2',1,NULL,'HERBERT ANDREWS','FI','587368062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:15',0,'2014-03-02 06:45:14'),(19712,20362,'0000-00-00','ET','2',1,NULL,'Jessica Castaneda','FI','464491987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:30:30',0,'2014-03-02 06:59:07'),(20355,21005,'0000-00-00','ET','2',1,NULL,'Ruth Stout','FI','298802492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:42',0,'2014-03-01 17:47:19'),(22551,23201,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:47',0,'2014-03-10 16:44:18'),(14898,15349,'2014-01-01','ET','2',1,NULL,'Barry Buttram','FI','252451896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:23',0,'2014-03-02 05:45:37'),(7238,7238,'2014-01-01','ET','2',1,NULL,'NELLIE EVERETT','FI','587682028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:53',0,'2014-03-02 02:10:49'),(93,93,'2014-01-01','ET','2',1,NULL,'Steven Elliott','FI','447903631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:50',0,'2014-03-01 22:10:55'),(538,538,'2014-01-01','ET','2',1,NULL,'Delbert McDonald','FI','236907845','Dental Care Plus, Inc.','FI','311185262','Daniel L Rankin','94','2095226','348','2014-01-01','Sync Success',0,'2013-12-25 18:01:39',0,'2014-03-01 15:48:04'),(4940,4940,'2014-01-01','ET','2',1,NULL,'CAROLYN REED','FI','464049062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:28',0,'2014-03-01 20:10:57'),(13541,13897,'2014-01-01','ET','2',1,NULL,'Isabelle Percy','FI','427318764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:43',0,'2014-03-02 05:24:45'),(13101,13457,'2014-01-01','ET','2',2,1,'Francisco Javier Coronado','FI','455871157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:03',0,'2014-03-02 05:17:40'),(11644,11644,'2014-01-01','ET','2',1,NULL,'Darcy Pescatrice','FI','274549266','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:04',0,'2014-03-10 16:03:49'),(6023,6023,'2014-01-01','ET','2',2,1,'liberty Warren','FI','449195649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:39',0,'2014-03-01 20:10:57'),(4041,4041,'2014-01-01','ET','2',2,1,'Barton Robinson','FI','463946706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:22',0,'2014-03-02 03:09:49'),(4356,4356,'2014-01-01','ET','2',1,NULL,'Judy Richards','FI','288562951','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 23:10:59',0,'2014-03-10 13:32:15'),(15401,15852,'0000-00-00','ET','2',1,NULL,'MICHAEL STONE','FI','027480698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:10',0,'2014-03-02 05:59:43'),(21334,21984,'0000-00-00','ET','2',1,NULL,'Jamie L Cobb','FI','295881008','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:14',0,'2014-03-03 01:35:37'),(22424,23074,'0000-00-00','ET','2',1,NULL,'Dana McKenzie Edgar','FI','454319556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:17',0,'2014-03-07 22:26:59'),(595,595,'2014-01-01','ET','2',1,NULL,'Vicki Steinbach','FI','450962940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:25',0,'2014-03-02 02:10:49'),(10392,10392,'2014-01-01','ET','2',1,NULL,'KAREN DANNER','FI','302503109','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:29',0,'2014-03-01 16:10:36'),(7610,7610,'2014-01-01','ET','2',1,NULL,'Tracey Baranowski','FI','298760656','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:35',0,'2014-03-10 15:59:47'),(5888,5888,'2014-01-01','ET','2',1,NULL,'Raymond A Dudek','FI','288581737','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:22',0,'2014-03-10 15:52:36'),(19467,20117,'0000-00-00','ET','2',1,NULL,'Toby Strong','FI','494926459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:51:01',0,'2014-03-02 06:59:07'),(19610,20260,'0000-00-00','ET','2',1,NULL,'riley tucker','94','0000172464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:03',0,'2014-03-01 17:34:07'),(13484,13840,'2014-01-01','ET','2',1,NULL,'RYAN VIERS','FI','283861512','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:42',0,'2014-03-10 14:03:26'),(5794,5794,'2014-01-01','ET','2',2,1,'Curtis Schrack','FI','297781975','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:19',0,'2014-03-10 15:52:36'),(3718,3718,'2014-01-01','ET','2',1,NULL,'SHARON L WALLACE','FI','285701200','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:08:09',0,'2014-03-10 13:24:34'),(2938,2938,'2014-01-01','ET','2',1,NULL,'Christopher Downs','FI','291902157','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:11',0,'2014-03-01 15:37:30'),(14071,14522,'2014-01-01','ET','2',2,1,'DUC LY','FI','608547911','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:17',0,'2014-03-02 05:31:31'),(7230,7230,'2014-01-01','ET','2',4,3,'Jason Hall','FI','296722467','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:33',0,'2014-03-01 15:52:44'),(13081,13437,'2014-01-01','ET','2',1,NULL,'Dexter Daugherty','FI','401372022','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:14',0,'2014-03-01 16:35:14'),(13275,13631,'2014-01-01','ET','2',1,NULL,'Jaquel Davis','FI','433718753','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:03',0,'2014-03-02 05:24:45'),(20418,21068,'0000-00-00','ET','2',2,1,'Robert Hughes','FI','274747071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:41',0,'2014-03-01 18:08:07'),(79,79,'2014-01-01','ET','2',1,NULL,'Mandy Taylor','FI','456899602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:17:24',0,'2014-03-01 22:10:55'),(12372,12372,'2014-01-01','ET','2',1,NULL,'Alan Ronda','FI','279822966','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:28:40',0,'2014-03-10 13:59:38'),(12068,12068,'2014-01-01','ET','2',1,NULL,'Trisha Lynn Byerly','FI','294904297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:38',0,'2014-03-01 16:30:17'),(11923,11923,'2014-01-01','ET','2',1,NULL,'Alice Petties','FI','439023185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:43',0,'2014-03-02 04:59:36'),(10459,10459,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:35',0,'2014-03-01 16:10:36'),(3199,3199,'2014-01-01','ET','2',1,NULL,'Deborah Eversole','FI','287549922','Dental Care Plus, Inc.','FI','311185262','Michael  Dougherty','94','8793711','348','2014-01-01','Sync Success',0,'2013-12-25 21:45:16',0,'2014-03-01 15:48:04'),(7032,7032,'2014-01-01','ET','2',1,NULL,'Gretchen Arian','FI','402800032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:30',0,'2014-03-02 03:09:49'),(2828,2828,'2014-01-01','ET','2',1,NULL,'Robert Goldstein','FI','125622712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:15',0,'2014-03-02 04:15:49'),(19125,19775,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','357','2014-03-01','Sync Success',0,'2014-02-15 22:01:02',0,'2014-03-01 17:34:07'),(3318,3318,'2014-01-01','ET','2',2,1,'Rick Shaffer','FI','290563409','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:07',0,'2014-03-01 15:52:44'),(14797,15248,'2014-01-01','ET','2',1,NULL,'robert gabers','FI','268501909','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:55',0,'2014-03-10 14:03:26'),(12524,12524,'2014-01-01','ET','2',1,NULL,'Ho Soon Hong','FI','289112800','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:13',0,'2014-03-10 13:59:38'),(2399,2399,'2014-01-01','ET','2',4,3,'John Isenbarger','FI','269821132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:10',0,'2014-03-01 15:26:40'),(16014,16663,'0000-00-00','ET','2',1,NULL,'MAURO TIJERINA','FI','454755821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:20',0,'2014-03-02 06:03:21'),(18414,19064,'0000-00-00','ET','2',1,NULL,'KATRINA M MILLER','FI','284861346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:11',0,'2014-03-01 17:26:36'),(18457,19107,'0000-00-00','ET','2',1,NULL,'Sally Wright','FI','293560676','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:42',0,'2014-03-10 14:24:38'),(22454,23104,'0000-00-00','ET','2',1,NULL,'John R Jones','FI','293521203','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:38',0,'2014-03-10 16:44:18'),(22463,23113,'0000-00-00','ET','2',1,NULL,'Chloe M Allen','FI','246973344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:45',0,'2014-03-07 21:36:32'),(16833,17483,'0000-00-00','ET','2',1,NULL,'Kristen Atzenhoefer','FI','289927183','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-02 19:00:14',0,'2014-03-01 17:00:58'),(3665,3665,'2014-01-01','ET','2',1,NULL,'Cathy G Taylor','FI','436823554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:22',0,'2014-03-02 01:10:33'),(11104,11104,'2014-01-01','ET','2',1,NULL,'Kim Thanh Nguyen','FI','619467970','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:14',0,'2014-03-10 13:45:57'),(10816,10816,'2014-01-01','ET','2',1,NULL,'Glenn Williams','FI','436823108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:24',0,'2014-03-02 04:31:46'),(15221,15672,'0000-00-00','ET','2',1,NULL,'Darius Akeem Boykins','FI','439776143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:40',0,'2014-03-02 05:52:31'),(15454,15905,'0000-00-00','ET','2',1,NULL,'JANE GREER','FI','286583187','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:45',0,'2014-03-01 16:50:53'),(19068,19718,'0000-00-00','ET','2',1,NULL,'Gary Butters','FI','587336029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:21',0,'2014-03-02 06:52:12'),(20451,21101,'0000-00-00','ET','2',1,NULL,'james montgomery','FI','456950375','HealthSpan','FI','311431434','Kirk   Bernhard','94','2828814','348','2014-04-01','Sync Success',0,'2014-02-26 09:31:07',0,'2014-03-10 14:37:47'),(21946,22596,'0000-00-00','ET','2',1,NULL,'Martin Jones','FI','458456112','Starmount Life Insurance Company','FI','720977315','Delores  Madrigal','94','924580','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:16',0,'2014-03-05 22:27:33'),(14364,14815,'2014-01-01','ET','2',1,NULL,'Erica Vallen','FI','287907348','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:51',0,'2014-03-10 16:17:47'),(644,644,'2014-01-01','ET','2',1,NULL,'Valerie Fontana','FI','079642387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:03',0,'2014-03-02 02:10:49'),(3768,3768,'2014-01-01','ET','2',1,NULL,'LAWRENCE LANDRENEAU','FI','433923479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:16',0,'2014-03-01 23:10:52'),(13673,14029,'2014-01-01','ET','2',1,NULL,'VERONICA MARTINEZ','FI','455656665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:24',0,'2014-03-02 05:24:45'),(7040,7040,'2014-01-01','ET','2',1,NULL,'dora v torres','FI','457902798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:44',0,'2014-03-02 03:09:49'),(16214,16863,'0000-00-00','ET','2',1,NULL,'Susan Alcibar','FI','591226371','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:49',0,'2014-03-02 06:10:30'),(17624,18274,'0000-00-00','ET','2',1,NULL,'DEXTER BASSAR','FI','438291662','Starmount Life Insurance Company','FI','720977315','michael  kirschman','94','16151038','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:18',0,'2014-03-02 06:31:45'),(19123,19773,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','357','2014-03-01','Sync Success',0,'2014-02-15 22:01:01',0,'2014-03-01 17:34:07'),(22738,23388,'0000-00-00','ET','2',1,NULL,'Breck McKeever','FI','439275879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:02',0,'2014-03-09 21:26:00'),(23087,23737,'0000-00-00','ET','2',1,NULL,'roger Bates','FI','299501252','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:57',0,'2014-03-10 21:17:52'),(13575,13931,'2014-01-01','ET','2',1,NULL,'Nancy Eder','FI','301561435','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:07',0,'2014-03-10 16:10:34'),(5169,5169,'2014-01-01','ET','2',1,NULL,'paul stefanelli','FI','282826962','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:51:22',0,'2014-03-10 13:20:27'),(12473,12473,'2014-01-01','ET','2',1,NULL,'Jessie Maxfield','FI','252530751','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:19',0,'2014-03-01 16:30:17'),(7514,7514,'2014-01-01','ET','2',1,NULL,'Donald  Daniels','FI','285526922','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:30',0,'2014-03-01 16:05:34'),(21439,22089,'0000-00-00','ET','2',2,1,'Karen Waldinger','FI','291866156','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:09',0,'2014-03-10 16:44:18'),(22919,23569,'0000-00-00','ET','2',1,NULL,'Doris Penn','FI','439983604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:55',0,'2014-03-10 21:27:11'),(13746,14102,'2014-01-01','ET','2',1,NULL,'PAMELA GREEN','FI','275784407','Dental Care Plus, Inc.','FI','311185262','JULIAN  LEE','94','7970773','357','2014-02-01','Sync Success',0,'2014-01-13 02:22:11',0,'2014-03-01 16:40:16'),(1800,1800,'2014-01-01','ET','2',1,NULL,'DIANA HILLIARD','FI','279629882','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:19:39',0,'2014-03-10 13:20:27'),(13074,13430,'2014-01-01','ET','2',1,NULL,'Hoa Nguyen','FI','659120544','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:56',0,'2014-03-02 05:17:40'),(4801,4801,'2014-01-01','ET','2',1,NULL,'Vickie Lawhon','FI','289527553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:01:55',0,'2014-03-01 15:16:37'),(10969,10969,'2014-01-01','ET','2',1,NULL,'Charlene Wolf','FI','291466497','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-26 13:09:42',0,'2014-03-10 16:03:49'),(15025,15476,'2014-01-01','ET','2',1,NULL,'NaQuin Gray','FI','414714730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:21',0,'2014-03-02 05:52:31'),(11604,11604,'2014-01-01','ET','2',2,1,'JOHN McNEAL','FI','587096526','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:49',0,'2014-03-02 04:52:44'),(17429,18079,'0000-00-00','ET','2',1,NULL,'Belinda G Burney','FI','454311351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:02',0,'2014-03-02 06:31:45'),(20434,21084,'0000-00-00','ET','2',1,NULL,'CLELIA WURGLER','FI','274885997','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:52',0,'2014-03-10 16:38:05'),(21787,22437,'0000-00-00','ET','2',1,NULL,'KIM HILL','FI','285625285','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:08',0,'2014-03-04 21:36:30'),(732,732,'2014-01-01','ET','2',1,NULL,'DEBORAH JOE WILLIAMS','FI','287464305','HealthSpan','FI','311431434','ROD  WELLER','94','2759353','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:49',0,'2014-03-10 13:24:34'),(6066,6066,'2014-01-01','ET','2',1,NULL,'Leland McCullough','FI','466758598','Starmount Life Insurance Company','FI','720977315','Wesley J Watkins','94','4710431','348','2014-01-01','Sync Success',0,'2013-12-26 03:00:14',0,'2014-03-02 04:10:25'),(5962,5962,'2014-01-01','ET','2',1,NULL,'Bryan Wack','FI','495966139','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:42',0,'2014-03-02 01:10:33'),(2653,2653,'2014-01-01','ET','2',1,NULL,'beth woyshville','FI','294588375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:29',0,'2014-03-01 16:05:34'),(5392,5392,'2014-01-01','ET','2',1,NULL,'Mary Kathern Martin','FI','271528454','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 01:17:17',0,'2014-03-10 13:03:33'),(4406,4406,'2014-01-01','ET','2',1,NULL,'Mandy Taylor','FI','456899602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:08',0,'2014-03-01 21:11:04'),(15329,15780,'0000-00-00','ET','2',1,NULL,'Frances Bragg','FI','271520666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:36',0,'2014-03-01 16:50:53'),(14705,15156,'2014-01-01','ET','2',1,NULL,'Bruce Payton','FI','439212781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:58',0,'2014-03-02 05:45:37'),(12292,12292,'2014-01-01','ET','2',2,1,'Evonne Philpot','FI','270881524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:58',0,'2014-03-01 16:35:14'),(17730,18380,'0000-00-00','ET','2',1,NULL,'RENATE BURGESS','FI','082604492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:21',0,'2014-03-02 06:31:45'),(22613,23263,'0000-00-00','ET','2',2,1,'MARCO ANTONIO CANALES','FI','453711394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:03',0,'2014-03-08 21:25:11'),(13792,14148,'2014-01-01','ET','2',1,NULL,'tyrone powell','FI','425270927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:41',0,'2014-03-02 05:24:45'),(420,420,'2014-01-01','ET','2',1,NULL,'Kelly Bragan','FI','275905674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:02',0,'2014-03-01 15:21:15'),(12603,12603,'2014-01-01','ET','2',1,NULL,'Dora Vong','FI','460498941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:13',0,'2014-03-02 05:10:52'),(12275,12275,'2014-01-01','ET','2',1,NULL,'cheryl cline','FI','275705498','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:23',0,'2014-03-10 16:10:34'),(3180,3180,'2014-01-01','ET','2',1,NULL,'Steven Troy Sims','FI','281828519','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:52',0,'2014-03-10 13:24:34'),(18023,18673,'0000-00-00','ET','2',1,NULL,'Georgiann Richley','FI','275747943','Dental Care Plus, Inc.','FI','311185262','Jason  Skillern','94','8698941','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:55',0,'2014-03-01 17:20:55'),(20365,21015,'0000-00-00','ET','2',1,NULL,'richard townend','FI','275785548','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:51',0,'2014-03-10 14:37:47'),(21841,22491,'0000-00-00','ET','2',1,NULL,'OLGA MARINA PORTILLO','FI','461955407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:31',0,'2014-03-05 21:25:24'),(14482,14933,'2014-01-01','ET','2',1,NULL,'Todd Phillips','FI','439457949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:45',0,'2014-03-02 05:38:34'),(935,935,'2014-01-01','ET','2',1,NULL,'PATSY CANDLER','FI','439047762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:13',0,'2014-03-01 22:10:55'),(13043,13399,'2014-01-01','ET','2',1,NULL,'MARK ALLAN SELL','FI','283567643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:52',0,'2014-03-01 16:35:14'),(5875,5875,'2014-01-01','ET','2',1,NULL,'Ray Saviciunas','FI','279500518','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:06',0,'2014-03-10 15:39:19'),(10663,10663,'2014-01-01','ET','2',1,NULL,'Elbert Pruitt','FI','456510382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:12',0,'2014-03-02 04:31:46'),(3894,3894,'2014-01-01','ET','2',1,NULL,'Michael Kroeger','FI','272447918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:01',0,'2014-03-01 15:05:09'),(16307,16957,'0000-00-00','ET','2',1,NULL,'SINDY ROBBINS','FI','171465851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:27',0,'2014-03-01 16:56:22'),(18173,18823,'0000-00-00','ET','2',1,NULL,'KATHLEEN PRUITT','FI','422808188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:33',0,'2014-03-01 17:26:36'),(18517,19167,'0000-00-00','ET','2',1,NULL,'james kevern','FI','298527454','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:22',0,'2014-03-10 14:31:05'),(7403,7403,'2014-01-01','ET','2',2,1,'WHITNEY ELLSWORTH','FI','438983402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:57',0,'2014-03-02 04:10:25'),(7695,7695,'2014-01-01','ET','2',2,1,'Stephen Michael Muncy','FI','299463293','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:16',0,'2014-03-01 15:10:22'),(2096,2096,'2014-01-01','ET','2',1,NULL,'michael koopman','FI','279900792','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:55',0,'2014-03-10 13:20:27'),(3615,3615,'2014-01-01','ET','2',1,NULL,'DEBORAH DORSEY','FI','460947031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:49',0,'2014-03-02 00:10:48'),(17059,17709,'0000-00-00','ET','2',2,1,'Lorenzo Lopez','FI','462047389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:35',0,'2014-03-02 06:24:38'),(588,588,'2014-01-01','ET','2',1,NULL,'Debra Depinet','FI','292565289','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:11',0,'2014-03-10 13:24:34'),(975,975,'2014-01-01','ET','2',1,NULL,'Roger Gill','FI','293621946','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:25',0,'2014-03-01 15:21:15'),(5479,5479,'2014-01-01','ET','2',1,NULL,'cheryl johnson','FI','434151139','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:44',0,'2014-03-02 04:45:37'),(12062,12062,'2014-01-01','ET','2',1,NULL,'Ellen Snyder','FI','283601764','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:04:26',0,'2014-03-01 16:30:17'),(3076,3076,'2014-01-01','ET','2',2,1,'Kara Hayes','FI','435650347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:28',0,'2014-03-02 01:10:33'),(5344,5344,'2014-01-01','ET','2',1,NULL,'Thomas GILHOOLY','FI','237946998','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:39',0,'2014-03-01 15:16:37'),(6129,6129,'2014-01-01','ET','2',1,NULL,'Lorraine Litvin','FI','279786913','Dental Care Plus, Inc.','FI','311185262','Michael   Kost','94','1924114','348','2014-01-01','Sync Success',0,'2013-12-26 03:02:13',0,'2014-03-01 16:00:27'),(7688,7688,'2014-01-01','ET','2',1,NULL,'Jered Brown','FI','310029387','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:02',0,'2014-03-10 15:39:19'),(11578,11578,'2014-01-01','ET','2',1,NULL,'Amran S Ali','FI','327338174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:04',0,'2014-03-02 04:52:44'),(15578,16029,'0000-00-00','ET','2',1,NULL,'JONAS HENDERSON','FI','420351502','Starmount Life Insurance Company','FI','720977315','VICKIE  HICKS','94','4766477','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:26',0,'2014-03-02 05:59:43'),(16167,16816,'0000-00-00','ET','2',1,NULL,'Theresa Highbaugh','FI','139589163','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:18',0,'2014-03-01 16:56:22'),(16561,17211,'0000-00-00','ET','2',2,1,'DEBORAH K PITSINGER','FI','291649431','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:17',0,'2014-03-10 16:24:30'),(16723,17373,'0000-00-00','ET','2',2,1,'Linda Brightbill','FI','278580170','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:33',0,'2014-03-10 16:24:30'),(17338,17988,'0000-00-00','ET','2',2,1,'Gregory Alan Stevens','FI','276646527','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:15',0,'2014-03-10 14:24:38'),(21739,22389,'0000-00-00','ET','2',2,1,'GREGORY FOWLER','FI','292668679','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:10',0,'2014-03-10 14:45:25'),(152,152,'2014-01-01','ET','2',1,NULL,'Lydia Freed','FI','301563885','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:44',0,'2014-03-10 15:45:56'),(14609,15060,'2014-01-01','ET','2',2,1,'Cynthia Klein','FI','287528841','Dental Care Plus, Inc.','FI','311185262','Sharon D Wingert','94','2446886','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:55',0,'2014-03-01 16:46:19'),(503,503,'2014-01-01','ET','2',1,NULL,'LINDA BUCHER','FI','302464616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:33',0,'2014-03-01 15:48:04'),(5720,5720,'2014-01-01','ET','2',2,1,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:02',0,'2014-03-01 15:48:04'),(14387,14838,'2014-01-01','ET','2',1,NULL,'LuAnn Fuller','FI','289686950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:01',0,'2014-03-01 16:46:19'),(14355,14806,'2014-01-01','ET','2',1,NULL,'Lien Tran','FI','730268617','Starmount Life Insurance Company','FI','720977315','Julie  Nguyen','94','6040941','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:47',0,'2014-03-02 05:45:37'),(12187,12187,'2014-01-01','ET','2',1,NULL,'scott wormell','FI','298689860','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:51',0,'2014-03-10 13:52:32'),(12081,12081,'2014-01-01','ET','2',1,NULL,'BRITTANY JO CLARK','FI','271926757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:03',0,'2014-03-01 16:30:17'),(3877,3877,'2014-01-01','ET','2',1,0,'Ronald Johnson','FI','453113971','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:31:27',0,'2014-03-01 19:11:03'),(4546,4546,'2014-01-01','ET','2',1,NULL,'Donald Sanders','FI','437829629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:34',0,'2014-03-02 04:31:46'),(4632,4632,'2014-01-01','ET','2',1,NULL,'PATRICIA ANN ORR','FI','485589670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:48:20',0,'2014-03-02 04:31:46'),(21566,22216,'0000-00-00','ET','2',1,NULL,'cody newman','FI','587619314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:44',0,'2014-03-03 22:26:43'),(134,134,'2014-01-01','ET','2',1,NULL,'John S Moye','FI','304629147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:09',0,'2014-03-01 22:10:55'),(14628,15079,'2014-01-01','ET','2',1,NULL,'Asmeret Mekonnen Asgede','FI','422179914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:07',0,'2014-03-01 16:46:19'),(13679,14035,'2014-01-01','ET','2',1,NULL,'Randal Williams','FI','455732942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:27',0,'2014-03-02 05:24:45'),(12044,12044,'2014-01-01','ET','2',2,1,'becky smith','FI','434590142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:44',0,'2014-03-02 05:03:29'),(7017,7017,'2014-01-01','ET','2',1,NULL,'BELINDA ANN FLOWERS','FI','254846944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:01',0,'2014-03-02 03:09:49'),(7712,7712,'2014-01-01','ET','2',1,NULL,'DIANNE WINN','FI','450791923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:54',0,'2014-03-01 20:10:57'),(11334,11334,'2014-01-01','ET','2',3,2,'Cammi Shea O\'neal','FI','461970766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:33',0,'2014-03-02 04:52:44'),(16895,17545,'0000-00-00','ET','2',1,NULL,'HEIDI NGUYEN','FI','586383419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:23',0,'2014-03-02 06:24:38'),(19812,20462,'0000-00-00','ET','2',1,NULL,'DONYA R SMITH','FI','465573699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:33',0,'2014-03-02 07:03:25'),(21204,21854,'0000-00-00','ET','2',2,1,'Kenneth Fuller','FI','456471496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 19:00:05',0,'2014-03-02 07:23:39'),(21371,22021,'0000-00-00','ET','2',1,NULL,'Daniel Bales','FI','286565563','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:37',0,'2014-03-10 14:45:25'),(14035,14391,'2014-01-01','ET','2',1,NULL,'Lisa Simes','FI','539620645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:56',0,'2014-03-10 14:03:26'),(3393,3393,'2014-01-01','ET','2',1,NULL,'DORIS TAYLOR','FI','281547441','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:28',0,'2014-03-10 15:52:36'),(1207,1207,'2014-01-01','ET','2',1,NULL,'Erica Jane Moore','FI','283820184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:48:00',0,'2014-03-01 16:15:39'),(12378,12378,'2014-01-01','ET','2',1,NULL,'Amy Elizabeth Garcia','FI','295786720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:53',0,'2014-03-01 16:30:17'),(11853,11853,'2014-01-01','ET','2',1,NULL,'Alison Gordon','FI','365112900','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:55',0,'2014-03-10 13:45:57'),(17927,18577,'0000-00-00','ET','2',1,NULL,'rosa trigo','FI','461132853','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:48',0,'2014-03-02 06:38:05'),(18698,19348,'0000-00-00','ET','2',1,NULL,'VIVIAN CRAYTON','FI','455495562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:51',0,'2014-03-02 06:52:12'),(19600,20250,'0000-00-00','ET','2',1,NULL,'Sergio Rivas','FI','637037504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:32:12',0,'2014-03-02 06:59:07'),(21694,22344,'0000-00-00','ET','2',4,3,'Tynetta Watkins','FI','295683607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:32',0,'2014-03-04 21:36:30'),(21732,22382,'0000-00-00','ET','2',2,1,'MARSHALL FRANKLIN','FI','301562968','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:04',0,'2014-03-10 16:44:18'),(22352,23002,'0000-00-00','ET','2',1,NULL,'CAROL MILLER','FI','299508149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:13',0,'2014-03-07 21:36:32'),(11749,11749,'2014-01-01','ET','2',1,NULL,'Diana P Winn','FI','268541511','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:25',0,'2014-03-01 16:30:17'),(2146,2146,'2014-01-01','ET','2',1,NULL,'Joe Lordi','FI','295868336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:21',0,'2014-03-01 15:16:37'),(743,743,'2014-01-01','ET','2',1,NULL,'Mary Kathern Martin','FI','271528454','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-01-01','Sync Success',0,'2013-12-25 18:08:08',0,'2014-03-10 13:24:34'),(15619,16070,'0000-00-00','ET','2',1,NULL,'Jessica Ramos','FI','446886255','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:45',0,'2014-03-02 05:59:43'),(18650,19300,'0000-00-00','ET','2',1,NULL,'Joseph Hanna','FI','299902059','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:13',0,'2014-03-01 17:26:36'),(18693,19343,'0000-00-00','ET','2',1,NULL,'anthony yelli','FI','357542154','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:47',0,'2014-03-02 06:52:12'),(19261,19911,'0000-00-00','ET','2',1,NULL,'Karla Rodriguez','FI','452636466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:07',0,'2014-03-02 06:52:12'),(20170,20820,'0000-00-00','ET','2',2,1,'BARRY BURKAY','FI','269545689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:08',0,'2014-03-01 18:08:07'),(20319,20969,'0000-00-00','ET','2',2,1,'JANICE GROCE','FI','445564667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:07',0,'2014-03-02 07:03:25'),(21701,22351,'0000-00-00','ET','2',1,NULL,'WENDELL KENNETH DAVIS','FI','435985837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:39',0,'2014-03-04 21:27:16'),(22050,22700,'0000-00-00','ET','2',1,NULL,'Gena Mcghee','FI','427497590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:28',0,'2014-03-05 22:27:33'),(22132,22782,'0000-00-00','ET','2',1,NULL,'NICHOLAS GUY HUGHES','FI','241634256','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:52',0,'2014-03-06 21:27:26'),(14354,14805,'2014-01-01','ET','2',1,NULL,'CAROLE BIEHL','FI','107562404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:46',0,'2014-03-02 05:45:37'),(14014,14370,'2014-01-01','ET','2',1,NULL,'DANIEL DORDICK','FI','130707015','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:41',0,'2014-03-01 16:40:16'),(1385,1385,'2014-01-01','ET','2',1,NULL,'joesph hilliard','FI','315020759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:32',0,'2014-03-02 04:45:37'),(1438,1438,'2014-01-01','ET','2',1,NULL,'Misty Morris','FI','275780488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:18',0,'2014-03-01 16:15:39'),(7101,7101,'2014-01-01','ET','2',1,NULL,'Robert Caul','FI','281507036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:38',0,'2014-03-01 15:52:44'),(2049,2049,'2014-01-01','ET','2',1,NULL,'Bonnie Walker','FI','426758550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:23',0,'2014-03-01 23:10:52'),(6025,6025,'2014-01-01','ET','2',1,NULL,'Regina Luttrell','FI','490547936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:43',0,'2014-03-01 20:10:57'),(11569,11569,'2014-01-01','ET','2',1,NULL,'CELIA GARCIA','FI','466836465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:48',0,'2014-03-02 04:52:44'),(10600,10600,'2014-01-01','ET','2',1,NULL,'Robert Javier Ceballos','FI','461674700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:11',0,'2014-03-02 04:24:47'),(5017,5017,'2014-01-01','ET','2',2,1,'RONDA WOLFORD','FI','286584659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:30',0,'2014-03-01 15:31:33'),(18013,18663,'0000-00-00','ET','2',1,NULL,'Nicholas Goers','FI','273846689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:48',0,'2014-03-01 17:20:55'),(18207,18857,'0000-00-00','ET','2',1,NULL,'Christopher Clark','94','0000425127','Dental Care Plus, Inc.','FI','311185262','Darwin  Carmichael','94','1300095','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:59',0,'2014-03-01 17:26:36'),(19020,19670,'0000-00-00','ET','2',1,NULL,'Joseph Holt','FI','259555920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:03',0,'2014-03-02 06:52:12'),(19917,20567,'0000-00-00','ET','2',1,NULL,'MARIA BULTER','FI','372609998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:14',0,'2014-03-02 07:03:25'),(22547,23197,'0000-00-00','ET','2',1,NULL,'GREG BERNARD CHATMAN','FI','425296197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:44',0,'2014-03-07 22:26:59'),(6442,6442,'2014-01-01','ET','2',1,NULL,'Betty Likovetz','FI','218545067','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:51',0,'2014-03-10 15:39:19'),(6280,6280,'2014-01-01','ET','2',1,NULL,'Ingrid Milo','FI','434887345','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-01-01','Sync Success',0,'2013-12-26 03:06:51',0,'2014-03-02 04:10:25'),(1689,1689,'2014-01-01','ET','2',1,NULL,'John Nelson','FI','301804575','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:10',0,'2014-03-01 15:31:33'),(15363,15814,'0000-00-00','ET','2',1,NULL,'mohammad tariq','FI','105769780','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:57',0,'2014-03-10 14:10:12'),(2973,2973,'2014-01-01','ET','2',2,1,'cheryl a grim','FI','295683578','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:20',0,'2014-03-01 15:37:30'),(14939,15390,'2014-01-01','ET','2',2,1,'Eddie Zarnick','FI','363649306','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:42',0,'2014-03-10 14:10:12'),(13186,13542,'2014-01-01','ET','2',1,NULL,'Anthony Ninni','FI','279501736','Summa Insurance Company, Inc.','FI','341809108','Trond  Backus','94','7236224','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:07',0,'2014-03-10 16:10:34'),(5824,5824,'2014-01-01','ET','2',1,NULL,'Rexana Bernal','FI','461792442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:12',0,'2014-03-01 20:10:57'),(12640,12640,'2014-01-01','ET','2',1,NULL,'Sean Dixon','FI','438598525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:31',0,'2014-03-02 05:10:52'),(4359,4359,'2014-01-01','ET','2',1,NULL,'Constance Slaughterbeck','FI','276546437','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-25 23:11:03',0,'2014-03-10 13:32:15'),(4402,4402,'2014-01-01','ET','2',1,NULL,'Christian Kuehm','FI','282742493','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:00',0,'2014-03-10 15:39:19'),(10550,10550,'2014-01-01','ET','2',1,NULL,'Tiana Jarmon','FI','644284981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:32',0,'2014-03-02 04:24:47'),(10399,10399,'2014-01-01','ET','2',1,NULL,'Meredith Melragon','FI','276789402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:42',0,'2014-03-01 16:10:36'),(18519,19169,'0000-00-00','ET','2',1,NULL,'Rebertha Tolbert','FI','416702706','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:24',0,'2014-03-10 14:31:05'),(20276,20926,'0000-00-00','ET','2',3,2,'Tim Dunning','94','0000929892','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 08:00:21',0,'2014-03-10 14:37:47'),(20899,21549,'0000-00-00','ET','2',1,NULL,'ALLAN W LAWMAN','FI','489524449','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:44',0,'2014-03-10 14:45:25'),(5560,5560,'2014-01-01','ET','2',2,1,'Mario Jarero','FI','461832480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:22',0,'2014-03-02 04:45:37'),(254,254,'2014-01-01','ET','2',1,NULL,'ANDREW lee PETTY','FI','460026293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:00',0,'2014-03-01 20:10:57'),(4753,4753,'2014-01-01','ET','2',1,NULL,'Gilbert Wilson','FI','205409711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:24',0,'2014-03-01 21:11:04'),(3871,3871,'2014-01-01','ET','2',1,0,'Karl Blench','FI','028688760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:15',0,'2014-03-01 19:11:03'),(19517,20167,'0000-00-00','ET','2',1,NULL,'William Kellerman','FI','285642786','Dental Care Plus, Inc.','FI','311185262','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-20 04:08:57',0,'2014-03-01 17:47:19'),(19865,20515,'0000-00-00','ET','2',3,2,'Russell Williams','FI','294741172','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:15',0,'2014-03-01 17:47:19'),(13858,14214,'2014-01-01','ET','2',1,NULL,'CYNTHIA APFFEL','FI','433985794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:53',0,'2014-03-02 05:31:31'),(3584,3584,'2014-01-01','ET','2',1,NULL,'Marc Newton','FI','602056141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:52',0,'2014-03-02 01:10:33'),(12695,12695,'2014-01-01','ET','2',1,NULL,'Dominique Simmons','FI','570935367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:04:35',0,'2014-03-10 16:10:34'),(12244,12244,'2014-01-01','ET','2',1,NULL,'Ronnie Bagwell','FI','452837121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:13',0,'2014-03-02 05:03:29'),(10949,10949,'2014-01-01','ET','2',2,1,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:11',0,'2014-03-10 16:03:49'),(21767,22417,'0000-00-00','ET','2',1,NULL,'patrice lawrence','FI','272728389','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:35',0,'2014-03-10 14:45:25'),(15605,16056,'0000-00-00','ET','2',1,NULL,'cortez davis','FI','434519789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:38',0,'2014-03-02 05:59:43'),(6201,6201,'2014-01-01','ET','2',1,NULL,'Mary Beth Petro','FI','291648080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:23',0,'2014-03-01 16:00:27'),(10506,10506,'2014-01-01','ET','2',2,1,'JOE B JUSTICE','FI','293768007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:03',0,'2014-03-01 16:15:39'),(5771,5771,'2014-01-01','ET','2',1,NULL,'CECELIA  ANN PHILLIPS','FI','458904645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:35',0,'2014-03-02 01:10:33'),(16285,16935,'0000-00-00','ET','2',1,NULL,'RONALD THORNTON','FI','455739803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:13',0,'2014-03-02 06:10:30'),(16436,17086,'0000-00-00','ET','2',1,NULL,'Tylor Reed','FI','268944854','HealthSpan','FI','311431434','Andrew  Gutierrez','94','16770974','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:49',0,'2014-03-10 14:20:26'),(18521,19171,'0000-00-00','ET','2',2,1,'Amanda Rybak','FI','272887189','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:26',0,'2014-03-10 14:24:38'),(19236,19886,'0000-00-00','ET','2',2,1,'Nicholas Bauer','FI','492824467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:29',0,'2014-03-02 06:52:12'),(19464,20114,'0000-00-00','ET','2',2,1,'janelle jones','FI','437804463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:48:44',0,'2014-03-02 06:59:07'),(12902,12902,'2014-01-01','ET','2',1,NULL,'Bobby  Ross','FI','434822561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:04:59',0,'2014-03-02 05:10:52'),(10967,10967,'2014-01-01','ET','2',1,NULL,'deborah witt','FI','286629709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:38',0,'2014-03-10 16:03:49'),(1933,1933,'2014-01-01','ET','2',1,NULL,'Darryl Robinson','FI','299502403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:43',0,'2014-03-01 15:26:40'),(15620,16071,'0000-00-00','ET','2',1,NULL,'Alonzo Washington','FI','287682085','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:45',0,'2014-03-10 16:17:47'),(16835,17485,'0000-00-00','ET','2',1,NULL,'Jill Spuzzillo','94','0000146920','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:15',0,'2014-03-01 17:00:58'),(20483,21133,'0000-00-00','ET','2',1,NULL,'LOUIS SALINAS','FI','291526270','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:33',0,'2014-03-10 14:37:47'),(20804,21454,'0000-00-00','ET','2',1,NULL,'Phung Tu','FI','638448891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:31:01',0,'2014-03-02 07:17:36'),(14202,14653,'2014-01-01','ET','2',1,NULL,'EDWARD PRATKA','FI','462270728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:40',0,'2014-03-02 05:38:34'),(669,669,'2014-01-01','ET','2',1,NULL,'Kim Blair','FI','006641474','Summa Insurance Company, Inc.','FI','341809108','Barry J Kerrigan','94','7236767','348','2014-01-01','Sync Success',0,'2013-12-25 18:05:46',0,'2014-03-10 15:52:36'),(811,811,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:37',0,'2014-03-01 15:10:22'),(4995,4995,'2014-01-01','ET','2',1,NULL,'Bonita Oliver','FI','172382719','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:49',0,'2014-03-01 15:31:33'),(3785,3785,'2014-01-01','ET','2',1,NULL,'Brenda Mullins','FI','289505362','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:49',0,'2014-03-01 15:26:40'),(3118,3118,'2014-01-01','ET','2',2,1,'Stephen Piesciuk','FI','066469661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:43',0,'2014-03-10 15:52:36'),(3069,3069,'2014-01-01','ET','2',2,1,'Sarah Dearie','FI','437733644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:16',0,'2014-03-02 01:10:33'),(13329,13685,'2014-01-01','ET','2',1,NULL,'alberta thornton','FI','438154300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:23',0,'2014-03-02 05:24:45'),(17355,18005,'0000-00-00','ET','2',1,NULL,'Trang Nguyen','FI','632862190','Starmount Life Insurance Company','FI','720977315','Kim N Kelly','94','14395949','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:10',0,'2014-03-02 06:31:45'),(17818,18468,'0000-00-00','ET','2',1,NULL,'Bruce August','FI','434395898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:50',0,'2014-03-02 06:10:30'),(18959,19609,'0000-00-00','ET','2',1,NULL,'Mary Lawrence','FI','608564743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:44',0,'2014-03-02 06:52:12'),(20138,20788,'0000-00-00','ET','2',2,1,'Joseph Morgan','FI','529083167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:47',0,'2014-03-02 07:10:28'),(22332,22982,'0000-00-00','ET','2',1,NULL,'ibrahim habli','94','0000971518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Received',0,'2014-03-06 21:30:20',NULL,NULL),(812,812,'2014-01-01','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:39',0,'2014-03-01 15:10:22'),(2112,2112,'2014-01-01','ET','2',1,NULL,'timothy anderson','FI','272505879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:18',0,'2014-03-01 15:16:37'),(14291,14742,'2014-01-01','ET','2',1,NULL,'Joseph Thomas','FI','297846988','Dental Care Plus, Inc.','FI','311185262','Gregory  DeMuesy','94','16756876','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:20',0,'2014-03-01 16:46:19'),(14092,14543,'2014-01-01','ET','2',1,NULL,'Miguel Alvarez','FI','466940629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:30',0,'2014-03-02 05:38:34'),(6991,6991,'2014-01-01','ET','2',1,NULL,'Brittany Bush','FI','275881223','HealthSpan','FI','311431434','Mark  Kofalt','94','1713316','348','2014-01-01','Sync Success',0,'2013-12-26 04:00:12',0,'2014-03-10 13:32:15'),(13853,14209,'2014-01-01','ET','2',1,NULL,'Nataly Torres King','FI','628062307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:50',0,'2014-03-02 05:31:31'),(13846,14202,'2014-01-01','ET','2',2,1,'Altagracia Silva','FI','566967587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:45',0,'2014-03-02 05:31:31'),(15010,15461,'2014-01-01','ET','2',2,1,'ZACH KISSELL','FI','273884057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:14',0,'2014-03-10 16:17:47'),(15727,16376,'0000-00-00','ET','2',1,NULL,'JEFFERY WINDER','FI','436476945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:07',0,'2014-03-02 05:59:43'),(16688,17338,'0000-00-00','ET','2',1,NULL,'JEFFREY L HIGH','FI','299640548','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:08',0,'2014-03-10 14:20:26'),(17633,18283,'0000-00-00','ET','2',1,NULL,'Rachelle S Cowans','FI','587535244','Starmount Life Insurance Company','FI','720977315','Vickie  Hicks','94','4766477','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:23',0,'2014-03-02 06:31:45'),(19284,19934,'0000-00-00','ET','2',1,NULL,'Dennis Barrington','FI','288583771','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-18 21:30:07',0,'2014-03-01 17:34:07'),(19448,20098,'0000-00-00','ET','2',1,NULL,'Carol Toft','FI','269568060','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:45',0,'2014-03-10 14:37:47'),(22020,22670,'0000-00-00','ET','2',1,NULL,'KERI FISH','FI','563797044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:06',0,'2014-03-05 22:27:33'),(22718,23368,'0000-00-00','ET','2',1,NULL,'JAMES EVEARITT','FI','290667742','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:12',0,'2014-03-10 14:50:59'),(11525,11525,'2014-01-01','ET','2',1,NULL,'ASHLEY PAIGE','FI','435550408','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:24',0,'2014-03-02 04:52:44'),(1354,1354,'2014-01-01','ET','2',2,1,'Colleen Contreras','FI','216640715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:33',0,'2014-03-02 04:38:08'),(7668,7668,'2014-01-01','ET','2',1,NULL,'Jerled A VanHoutte','FI','365507131','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:25',0,'2014-03-10 13:39:10'),(3954,3954,'2014-01-01','ET','2',1,NULL,'Felix Adan','FI','466514364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:41',0,'2014-03-01 23:10:52'),(1725,1725,'2014-01-01','ET','2',1,NULL,'Haley Bechler','FI','290926969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:15',0,'2014-03-01 15:31:33'),(16257,16906,'0000-00-00','ET','2',1,NULL,'RICHARD MILLER','FI','302741319','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:17',0,'2014-03-10 16:24:30'),(17702,18352,'0000-00-00','ET','2',1,NULL,'TOMMIE VASQUES','FI','456782774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-09 19:00:03',0,'2014-03-02 06:31:45'),(21927,22577,'0000-00-00','ET','2',1,NULL,'Lisa Coots','FI','640103287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:02',0,'2014-03-05 22:27:33'),(12567,12567,'2014-01-01','ET','2',3,2,'KAM NING','FI','318829712','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:59',0,'2014-03-10 13:59:38'),(14328,14779,'2014-01-01','ET','2',1,NULL,'andrew ashmore','FI','431699233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:36',0,'2014-03-02 05:38:34'),(6069,6069,'2014-01-01','ET','2',1,NULL,'Jessica Patterson','FI','439698997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:20',0,'2014-03-02 04:10:25'),(12258,12258,'2014-01-01','ET','2',1,NULL,'dora loya','FI','461578227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:45',0,'2014-03-02 05:10:52'),(4427,4427,'2014-01-01','ET','2',2,1,'john mcgee','FI','459939691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:57',0,'2014-03-01 19:11:03'),(5007,5007,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:11',0,'2014-03-01 15:31:33'),(5032,5032,'2014-01-01','ET','2',1,NULL,'Nicolle Cioffi','FI','284864486','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:01',0,'2014-03-01 15:31:33'),(11158,11158,'2014-01-01','ET','2',2,1,'Dorothy Bickerstaff','FI','300508823','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:12',0,'2014-03-10 13:45:57'),(10998,10998,'2014-01-01','ET','2',1,NULL,'Christopher Holmes','FI','109722273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:42',0,'2014-03-02 04:31:46'),(15129,15580,'0000-00-00','ET','2',3,2,'BRETT PODOLL','FI','188608465','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:12',0,'2014-03-10 16:17:47'),(16116,16765,'0000-00-00','ET','2',3,2,'willie perkins','FI','408157183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:29',0,'2014-03-02 06:03:21'),(23110,23760,'0000-00-00','ET','2',1,NULL,'TREASEA LOWMAN','FI','410474373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:10',0,'2014-03-10 22:25:11'),(111,111,'2014-01-01','ET','2',1,NULL,'Linda Dearman','FI','587549927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:23',0,'2014-03-01 22:10:55'),(6126,6126,'2014-01-01','ET','2',2,1,'Mary Kaufman','FI','297848783','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:07',0,'2014-03-01 16:00:27'),(5570,5570,'2014-01-01','ET','2',1,NULL,'Debra Baxter','FI','454213429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:40',0,'2014-03-02 04:45:37'),(5217,5217,'2014-01-01','ET','2',1,NULL,'Daniel Tuel','FI','270525614','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:56',0,'2014-03-10 13:20:27'),(12371,12371,'2014-01-01','ET','2',2,1,'AMADEO MONTERROZA','FI','555996494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:36',0,'2014-03-02 05:03:29'),(1224,1224,'2014-01-01','ET','2',1,NULL,'MICHAEL LANE','FI','294507618','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:31',0,'2014-03-01 16:15:39'),(3020,3020,'2014-01-01','ET','2',1,NULL,'Kristy Cottle','FI','286760114','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:43',0,'2014-03-10 15:52:36'),(1809,1809,'2014-01-01','ET','2',1,NULL,'Sheena Lee','FI','286829980','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:19:57',0,'2014-03-10 13:20:27'),(15317,15768,'0000-00-00','ET','2',1,NULL,'Claire Allen','FI','624508407','Dental Care Plus, Inc.','FI','311185262','Marie  Zuniga','94','1519795','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:28',0,'2014-03-01 16:50:53'),(18899,19549,'0000-00-00','ET','2',1,NULL,'Annal Vyas','FI','295861435','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:01',0,'2014-03-01 17:34:07'),(18905,19555,'0000-00-00','ET','2',2,1,'STEPHEN WALDRON','FI','058745911','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:04',0,'2014-03-01 17:34:07'),(19723,20373,'0000-00-00','ET','2',1,NULL,'MARGIE I GANTZ','FI','283505398','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:34:18',0,'2014-03-10 14:37:47'),(21387,22037,'0000-00-00','ET','2',1,NULL,'Dennis Brown','FI','270504376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:03',0,'2014-03-03 21:36:16'),(22310,22960,'0000-00-00','ET','2',1,NULL,'Maria Elena Barraza','FI','452821803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:05',0,'2014-03-06 22:25:29'),(22875,23525,'0000-00-00','ET','2',2,1,'ANA P VILLASENOR','FI','449512982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:20',0,'2014-03-10 21:27:11'),(13559,13915,'2014-01-01','ET','2',1,NULL,'Wanda Brown','FI','434883138','Starmount Life Insurance Company','FI','720977315','Delores   Madrigal','94','12397055','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:54',0,'2014-03-02 05:31:31'),(13145,13501,'2014-01-01','ET','2',2,1,'Delisa M Jackson','FI','433153447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:42',0,'2014-03-02 05:24:45'),(5306,5306,'2014-01-01','ET','2',1,NULL,'Pamela Wigington','FI','644307562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:40',0,'2014-03-01 19:11:03'),(2464,2464,'2014-01-01','ET','2',1,NULL,'paul stefanelli','FI','282826962','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:20',0,'2014-03-10 13:10:24'),(3693,3693,'2014-01-01','ET','2',1,NULL,'Kerry Hurt','94','0000268450','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:17',0,'2014-03-02 00:10:48'),(12310,12310,'2014-01-01','ET','2',1,NULL,'Martin Gilmer','FI','294900830','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:40',0,'2014-03-10 16:10:34'),(11689,11689,'2014-01-01','ET','2',1,NULL,'Debra Boatright','FI','324587625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:35',0,'2014-03-02 04:59:36'),(15732,16381,'0000-00-00','ET','2',1,NULL,'Alice Johnson','FI','435110112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:10',0,'2014-03-02 05:59:43'),(16590,17240,'0000-00-00','ET','2',1,NULL,'NICHOLAS STRIKE','FI','295842232','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:01:37',0,'2014-03-10 14:20:26'),(18007,18657,'0000-00-00','ET','2',1,NULL,'Kristine E Light','FI','071500015','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-24','Sync Success',0,'2014-02-10 21:31:44',0,'2014-03-10 14:24:38'),(19489,20139,'0000-00-00','ET','2',1,NULL,'Maria Ruiz','94','0000416993','Starmount Life Insurance Company','FI','720977315','William  Henry','94','17037077','348','2014-04-01','Sync Success',0,'2014-02-20 04:01:05',0,'2014-03-02 06:59:07'),(20874,21524,'0000-00-00','ET','2',1,NULL,'GWENDOLYN K WALKER','FI','450115213','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:33',0,'2014-03-02 07:17:36'),(22044,22694,'0000-00-00','ET','2',1,NULL,'JACKIE MEEKER','FI','272521965','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:24',0,'2014-03-10 14:45:25'),(22089,22739,'0000-00-00','ET','2',1,NULL,'Michelle Obale','FI','432953495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:00:22',0,'2014-03-06 21:27:26'),(22245,22895,'0000-00-00','ET','2',1,NULL,'Greg Stehler','FI','287484330','Summa Insurance Company, Inc.','FI','341809108','John  Masters','94','1791316','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:12',0,'2014-03-10 16:44:18'),(22870,23520,'0000-00-00','ET','2',1,NULL,'Deborah Gangsei','94','0000488163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:17',0,'2014-03-10 21:27:11'),(14480,14931,'2014-01-01','ET','2',2,1,'JEFFREY RAY HUGHETT','FI','295802221','HealthSpan','FI','311431434','BRADLEY  HETER','94','7285046','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:43',0,'2014-03-10 14:03:26'),(5030,5030,'2014-01-01','ET','2',1,NULL,'Nicholas Cioffi','FI','231433728','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:57',0,'2014-03-01 15:31:33'),(3458,3458,'2014-01-01','ET','2',1,NULL,'Robin Biggert','94','0000896951','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:36',0,'2014-03-10 13:32:15'),(12624,12624,'2014-01-01','ET','2',1,NULL,'david zurita','94','0001165419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:56',0,'2014-03-02 05:10:52'),(12311,12311,'2014-01-01','ET','2',1,NULL,'ELIZABETH RHOADES','FI','283483665','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:42',0,'2014-03-10 16:10:34'),(15965,16614,'0000-00-00','ET','2',1,NULL,'karen steeves','FI','452472866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:13',0,'2014-03-02 06:03:21'),(18978,19628,'0000-00-00','ET','2',3,2,'CHRISTINA POTTKOTTER','FI','272608899','HealthSpan','FI','311431434','BRUCE  BURNHOLD','94','1489213','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:58',0,'2014-03-10 14:31:05'),(19163,19813,'0000-00-00','ET','2',1,NULL,'Sandra Ezell','FI','461946295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:33',0,'2014-03-02 06:52:12'),(6148,6148,'2014-01-01','ET','2',2,1,'Ossie Blevins','FI','422709734','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:46',0,'2014-03-01 16:00:27'),(4897,4897,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:17',0,'2014-03-10 13:03:33'),(16024,16673,'0000-00-00','ET','2',1,NULL,'Brandon Malbrough','FI','433474304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:26',0,'2014-03-02 06:03:21'),(21819,22469,'0000-00-00','ET','2',1,NULL,'Garret Autrey','FI','466674099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:16',0,'2014-03-05 21:25:24'),(6264,6264,'2014-01-01','ET','2',1,NULL,'Marlon Roberts','FI','438881266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:21',0,'2014-03-02 04:10:25'),(3855,3855,'2014-01-01','ET','2',1,NULL,'Robert Hanna','FI','270445117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:46',0,'2014-03-01 15:05:09'),(464,464,'2014-01-01','ET','2',2,1,'Laura Barton','FI','277724505','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:27',0,'2014-03-10 13:10:24'),(3109,3109,'2014-01-01','ET','2',1,NULL,'Sylvia S Johnson','FI','434577272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:26',0,'2014-03-02 01:10:33'),(4319,4319,'2014-01-01','ET','2',1,NULL,'CYNTHIA WILLIAMS','FI','439758603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:49',0,'2014-03-02 03:09:49'),(5325,5325,'2014-01-01','ET','2',1,NULL,'Kelly Kowalski','FI','284883337','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:24',0,'2014-03-10 13:03:33'),(5445,5445,'2014-01-01','ET','2',1,NULL,'Gene Gardner','FI','464667612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:49',0,'2014-03-01 19:11:03'),(16643,17293,'0000-00-00','ET','2',1,NULL,'Carolyn Golden Watson','FI','437176254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:37',0,'2014-03-02 06:17:30'),(18170,18820,'0000-00-00','ET','2',1,NULL,'RICK CASE','FI','269706526','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:31',0,'2014-03-01 17:26:36'),(18248,18898,'0000-00-00','ET','2',1,NULL,'Gabriella V Osborne','94','0000017667','Dental Care Plus, Inc.','FI','311185262','John  Hazelbaker','94','2490070','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:34',0,'2014-03-01 17:26:36'),(18705,19355,'0000-00-00','ET','2',1,NULL,'STEPHANIE BREWER','FI','439714557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:56',0,'2014-03-02 06:45:14'),(18853,19503,'0000-00-00','ET','2',1,NULL,'Cynthia Stewart','FI','440704476','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:28',0,'2014-03-02 06:52:12'),(15270,15721,'0000-00-00','ET','2',1,NULL,'Rhonda Hertel','FI','452457414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:01',0,'2014-03-02 05:52:31'),(12888,12888,'2014-01-01','ET','2',1,NULL,'Linda Rester','FI','587768583','Starmount Life Insurance Company','FI','720977315','Robert N Stringer','94','557653','348','2014-02-01','Sync Success',0,'2014-01-04 02:04:27',0,'2014-03-02 05:17:40'),(17528,18178,'0000-00-00','ET','2',4,3,'JYOTIBEN PATEL','FI','456611391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:19',0,'2014-03-01 17:20:55'),(3033,3033,'2014-01-01','ET','2',1,NULL,'Mary Beth Petro','FI','291648080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:06',0,'2014-03-01 15:37:30'),(5015,5015,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:46:27',0,'2014-03-01 15:31:33'),(19367,20017,'0000-00-00','ET','2',2,1,'DAEBORAH CURTIS','FI','301442474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:45',0,'2014-03-01 17:34:07'),(19553,20203,'0000-00-00','ET','2',1,NULL,'LoLita  Hamilton Blazio','FI','436293736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:18:49',0,'2014-03-02 06:59:07'),(20047,20697,'0000-00-00','ET','2',1,NULL,'Alexis Korman','FI','625245872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:10',0,'2014-03-02 07:10:28'),(15164,15615,'0000-00-00','ET','2',1,NULL,'Robert Deering','FI','378545997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:37',0,'2014-03-10 14:10:12'),(14397,14848,'2014-01-01','ET','2',1,NULL,'VERNEVA BENTLEY','FI','272542462','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:06',0,'2014-03-01 16:46:19'),(4053,4053,'2014-01-01','ET','2',1,NULL,'William J Brand','FI','467883734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:47',0,'2014-03-02 04:10:25'),(2928,2928,'2014-01-01','ET','2',2,1,'ANTHONY WEBER','FI','296443177','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:51',0,'2014-03-01 15:37:30'),(2876,2876,'2014-01-01','ET','2',1,NULL,'MICHAEL QUINN','FI','299625941','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:51',0,'2014-03-10 13:39:10'),(13608,13964,'2014-01-01','ET','2',1,NULL,'David Bucurel','FI','272524498','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:31',0,'2014-03-01 16:40:16'),(12750,12750,'2014-01-01','ET','2',2,1,'Valerie Arrington','FI','427192120','Starmount Life Insurance Company','FI','720977315','Crystall  Washington','94','10820803','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:42',0,'2014-03-02 05:10:52'),(7122,7122,'2014-01-01','ET','2',1,NULL,'Kathy Hughes','FI','276687610','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:16',0,'2014-03-01 15:52:44'),(11283,11283,'2014-01-01','ET','2',2,1,'Xing Chen','FI','125928060','Starmount Life Insurance Company','FI','720977315','Feng  Xu','94','10354730','348','2014-02-01','Sync Success',0,'2013-12-27 02:02:58',0,'2014-03-02 04:52:44'),(18401,19051,'0000-00-00','ET','2',2,1,'Kevin Kossick','FI','278828943','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:01',0,'2014-03-10 16:31:33'),(20121,20771,'0000-00-00','ET','2',1,NULL,'lettie reid','FI','271580344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:34',0,'2014-03-01 18:08:07'),(20206,20856,'0000-00-00','ET','2',1,NULL,'Martha McLaurin','FI','467536439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:36',0,'2014-03-02 07:10:28'),(22396,23046,'0000-00-00','ET','2',1,NULL,'Hannah Julianna Bradford','94','0001341772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:34',0,'2014-03-07 21:25:22'),(2383,2383,'2014-01-01','ET','2',2,1,'Linda  Valdez Escobedo','FI','457987330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:42',0,'2014-03-01 23:10:52'),(12800,12800,'2014-01-01','ET','2',1,NULL,'QUANG ZAN','FI','634238455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:16',0,'2014-03-02 05:10:52'),(342,342,'2014-01-01','ET','2',1,NULL,'Adam Hamacher','FI','301600681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:31',0,'2014-03-01 15:21:15'),(22692,23342,'0000-00-00','ET','2',1,NULL,'LORI CAVEY','FI','570198023','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:52',0,'2014-03-10 14:50:59'),(22896,23546,'0000-00-00','ET','2',1,NULL,'Wendeline R Reda','FI','287505390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:37',0,'2014-03-10 21:36:25'),(22925,23575,'0000-00-00','ET','2',2,1,'WILLIE REESE','FI','436986144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:59',0,'2014-03-10 21:27:11'),(11,11,'2014-01-01','ET','2',1,NULL,'Donna Toney','FI','276549616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:22',0,'2014-03-01 15:21:15'),(7125,7125,'2014-01-01','ET','2',2,1,'Dana Carpenter','FI','284881849','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:22',0,'2014-03-01 15:52:44'),(13248,13604,'2014-01-01','ET','2',1,NULL,'Melinda Woodrow','FI','426332844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:58',0,'2014-03-02 05:17:40'),(12684,12684,'2014-01-01','ET','2',1,NULL,'susan hinkle','FI','294700974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:08',0,'2014-03-01 16:35:14'),(12005,12005,'2014-01-01','ET','2',1,NULL,'HILDA Moore','FI','434740113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:17',0,'2014-03-02 04:59:36'),(11379,11379,'2014-01-01','ET','2',1,NULL,'Mary Koch','FI','277583977','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:55',0,'2014-03-10 13:52:32'),(1593,1593,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:03',0,'2014-03-01 20:10:57'),(10791,10791,'2014-01-01','ET','2',1,NULL,'terrie chisholm','FI','435061344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:35',0,'2014-03-02 04:24:47'),(1754,1754,'2014-01-01','ET','2',1,NULL,'Roy Fletcher','94','0000309414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:06',0,'2014-03-01 15:31:33'),(10482,10482,'2014-01-01','ET','2',1,NULL,'Bernard Ibeh','FI','101862800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:20',0,'2014-03-01 16:10:36'),(1994,1994,'2014-01-01','ET','2',4,3,'Kenneth Michael Sabath','FI','141428373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:38',0,'2014-03-01 23:10:52'),(19351,20001,'0000-00-00','ET','2',1,NULL,'TERRY N ADAMS','FI','437279656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:34',0,'2014-03-02 06:59:07'),(15169,15620,'0000-00-00','ET','2',1,NULL,'Kevin Kramer','FI','292548616','HealthSpan','FI','311431434','Angela  Marlene Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:40',0,'2014-03-10 14:10:12'),(4878,4878,'2014-01-01','ET','2',1,NULL,'Denisha Foster','FI','467993111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:34',0,'2014-03-01 20:10:57'),(13116,13472,'2014-01-01','ET','2',1,NULL,'NORA RIVERA','FI','457453814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:33',0,'2014-03-02 05:17:40'),(932,932,'2014-01-01','ET','2',1,NULL,'LaKitta Marie Mayfield','FI','435675501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:06',0,'2014-03-01 21:11:04'),(12959,12959,'2014-01-01','ET','2',1,NULL,'Joe Soza','FI','461612549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:42',0,'2014-03-02 05:17:40'),(12861,12861,'2014-01-01','ET','2',1,NULL,'Amanda Jones','FI','288909909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:28',0,'2014-03-01 16:35:14'),(2048,2048,'2014-01-01','ET','2',1,NULL,'Luanne Valentine','FI','414040363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:21',0,'2014-03-01 23:10:52'),(10818,10818,'2014-01-01','ET','2',1,NULL,'Jessica Wren','FI','439574384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:28',0,'2014-03-02 04:31:46'),(16191,16840,'0000-00-00','ET','2',1,NULL,'CHRISTINA HRONEK','FI','287769149','Dental Care Plus, Inc.','FI','311185262','BERNARD  DAVIDSON','94','16914494','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:32',0,'2014-03-01 16:56:22'),(20488,21138,'0000-00-00','ET','2',1,NULL,'Kathryn Culpepper','FI','338766667','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 21:00:37',0,'2014-03-10 16:38:05'),(21658,22308,'0000-00-00','ET','2',1,NULL,'Constance SUGGS-WILSON','FI','273606254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:04',0,'2014-03-04 21:36:30'),(22808,23458,'0000-00-00','ET','2',1,NULL,'Randy Urbanowicz','FI','288786702','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:59',0,'2014-03-10 14:50:59'),(22997,23647,'0000-00-00','ET','2',1,NULL,'Amy Groya','FI','273901729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:01:49',0,'2014-03-10 21:36:25'),(13451,13807,'2014-01-01','ET','2',1,NULL,'cynthia corcoran','FI','225968891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:19',0,'2014-03-02 05:31:31'),(6115,6115,'2014-01-01','ET','2',1,NULL,'JESS HANKS','FI','281841731','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:45',0,'2014-03-01 16:00:27'),(13230,13586,'2014-01-01','ET','2',1,NULL,'Stephen DeBacco','FI','286786731','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:16',0,'2014-03-10 16:10:34'),(653,653,'2014-01-01','ET','2',1,NULL,'Princesa Alexander','FI','449021116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:18',0,'2014-03-02 02:10:49'),(668,668,'2014-01-01','ET','2',1,NULL,'CHERYL VELEZ','FI','302588483','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:44',0,'2014-03-10 15:52:36'),(5074,5074,'2014-01-01','ET','2',1,NULL,'Brandon Jeffery Kahny','FI','279767197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:22',0,'2014-03-01 15:31:33'),(1319,1319,'2014-01-01','ET','2',1,NULL,'MARCIE PURIFOY','FI','422153395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:25',0,'2014-03-02 04:38:08'),(3911,3911,'2014-01-01','ET','2',1,NULL,'Sabita Mojumdar','FI','289156034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:24',0,'2014-03-01 15:26:40'),(3898,3898,'2014-01-01','ET','2',1,NULL,'Karl Redmon','FI','426713813','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:11',0,'2014-03-01 19:11:03'),(2719,2719,'2014-01-01','ET','2',1,NULL,'Janice Fluitt','FI','438860626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:48',0,'2014-03-02 04:15:49'),(11803,11803,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:13:11',0,'2014-03-10 16:03:49'),(18784,19434,'0000-00-00','ET','2',1,NULL,'Russell Adams','FI','292423393','HealthSpan','FI','311431434','Daniel F Eckstein','94','2211061','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:55',0,'2014-03-10 14:31:05'),(19516,20166,'0000-00-00','ET','2',2,1,'Liberato Saladino','FI','299025254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:08:39',0,'2014-03-01 17:47:19'),(19792,20442,'0000-00-00','ET','2',1,NULL,'Jeannie Trent','FI','435908924','Starmount Life Insurance Company','FI','720977315','Lisa  M  Adams','94','4109783','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:17',0,'2014-03-02 07:03:25'),(22038,22688,'0000-00-00','ET','2',1,NULL,'marlene offutt','FI','301944621','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:19',0,'2014-03-10 14:45:25'),(22120,22770,'0000-00-00','ET','2',1,NULL,'Thao Thi Lam','FI','610236708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:44',0,'2014-03-06 21:27:26'),(22525,23175,'0000-00-00','ET','2',1,NULL,'Adam Alsept','FI','292980373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:29',0,'2014-03-07 21:36:32'),(6092,6092,'2014-01-01','ET','2',2,1,'Yu Ching Kou','FI','282845357','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:05',0,'2014-03-01 16:00:27'),(13362,13718,'2014-01-01','ET','2',1,NULL,'David Lerone Satcher','FI','411412704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:37',0,'2014-03-02 05:24:45'),(13122,13478,'2014-01-01','ET','2',1,NULL,'Stacie Nalls','FI','638120811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:50',0,'2014-03-02 05:17:40'),(1935,1935,'2014-01-01','ET','2',1,NULL,'LARAINE LIPIEC','FI','269504177','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:47',0,'2014-03-01 15:26:40'),(1831,1831,'2014-01-01','ET','2',1,NULL,'Rebecca Toth','FI','291585258','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:36',0,'2014-03-10 13:20:27'),(16985,17635,'0000-00-00','ET','2',1,NULL,'Margaret Schuster','FI','268523561','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:19',0,'2014-03-10 16:24:30'),(16998,17648,'0000-00-00','ET','2',1,NULL,'Ashley Kemper','FI','356824703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:01:29',0,'2014-03-02 06:24:38'),(17164,17814,'0000-00-00','ET','2',1,NULL,'Barbara Day','FI','279425023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:42',0,'2014-03-01 17:00:58'),(20403,21053,'0000-00-00','ET','2',1,NULL,'SETH GREGERSON','FI','433751252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:29',0,'2014-03-02 07:03:25'),(13615,13971,'2014-01-01','ET','2',4,3,'James Hurley','FI','016424683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:36',0,'2014-03-01 16:40:16'),(13396,13752,'2014-01-01','ET','2',1,NULL,'naeema khalid','FI','630255709','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:53',0,'2014-03-02 05:24:45'),(2688,2688,'2014-01-01','ET','2',1,NULL,'Thothsakanh Thongsavanh','FI','586120581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:47',0,'2014-03-02 04:15:49'),(12160,12160,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:07:47',0,'2014-03-10 13:52:32'),(10464,10464,'2014-01-01','ET','2',2,1,'Edward Packer','FI','281669197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:43',0,'2014-03-01 16:10:36'),(11429,11429,'2014-01-01','ET','2',1,NULL,'Bruce Fellabaum','FI','377662581','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:29',0,'2014-03-10 13:52:32'),(11728,11728,'2014-01-01','ET','2',2,1,'Gerald McKee','FI','285442955','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:45',0,'2014-03-01 16:30:17'),(16623,17273,'0000-00-00','ET','2',1,NULL,'MARIA R ORTIZ','FI','458860636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:23',0,'2014-03-02 06:17:30'),(19319,19969,'0000-00-00','ET','2',1,NULL,'AARON BLAINE POWELL','FI','446861961','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:11',0,'2014-03-02 06:59:07'),(23035,23685,'0000-00-00','ET','2',1,NULL,'Tammy Vance','FI','294788953','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:17',0,'2014-03-10 21:17:52'),(13560,13916,'2014-01-01','ET','2',1,NULL,'reina amaya calix','FI','682098692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:54',0,'2014-03-02 05:31:31'),(641,641,'2014-01-01','ET','2',1,NULL,'Erikalin Ashton','FI','223132719','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:57',0,'2014-03-02 02:10:49'),(7617,7617,'2014-01-01','ET','2',1,NULL,'Jin Dolney','FI','297045947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:48',0,'2014-03-10 13:39:10'),(1610,1610,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:28',0,'2014-03-01 20:10:57'),(5134,5134,'2014-01-01','ET','2',2,1,'DENNIS REED','FI','271464372','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:20',0,'2014-03-10 15:45:56'),(5744,5744,'2014-01-01','ET','2',1,NULL,'Lynn Isom','FI','437843997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:44',0,'2014-03-02 01:10:33'),(16742,17392,'0000-00-00','ET','2',1,NULL,'DANGEL OWENS','FI','467850163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:04',0,'2014-03-02 06:17:30'),(17764,18414,'0000-00-00','ET','2',1,NULL,'Tina Whitfield','FI','464238423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:04',0,'2014-03-02 06:24:38'),(17982,18632,'0000-00-00','ET','2',1,NULL,'Vernon Shively','FI','275727554','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:27',0,'2014-03-10 14:24:38'),(18160,18810,'0000-00-00','ET','2',1,NULL,'douglas stout','FI','310649074','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:23',0,'2014-03-10 14:24:38'),(18263,18913,'0000-00-00','ET','2',1,NULL,'Samuel Niblock','FI','555138346','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:48',0,'2014-03-10 14:24:38'),(20648,21298,'0000-00-00','ET','2',1,NULL,'Denise Farag','FI','313867692','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:23',0,'2014-03-10 14:37:47'),(21100,21750,'0000-00-00','ET','2',1,NULL,'KAMLESH PATEL','FI','642243234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:30:47',0,'2014-03-02 07:23:39'),(483,483,'2014-01-01','ET','2',1,NULL,'Melissa Ledsome','FI','277963877','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:51:06',0,'2014-03-10 15:45:56'),(15158,15609,'0000-00-00','ET','2',1,NULL,'Paul Perry','FI','302481241','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:32',0,'2014-03-10 14:10:12'),(13459,13815,'2014-01-01','ET','2',2,1,'Brian McGinnis','FI','282663025','Dental Care Plus, Inc.','FI','311185262','Carl  Lishing','94','2095192','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:26',0,'2014-03-01 16:40:16'),(12606,12606,'2014-01-01','ET','2',1,NULL,'Damion Washington','94','0000329351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:19',0,'2014-03-02 05:10:52'),(12131,12131,'2014-01-01','ET','2',2,1,'Joyce Hinds','FI','298563104','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:47',0,'2014-03-01 16:30:17'),(11977,11977,'2014-01-01','ET','2',1,NULL,'james kinard','FI','465945218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:15',0,'2014-03-02 05:03:29'),(3312,3312,'2014-01-01','ET','2',1,NULL,'COTTON NAKKA','FI','366237733','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:48:53',0,'2014-03-01 15:52:44'),(3529,3529,'2014-01-01','ET','2',3,2,'Krystyna Buczkowski','FI','280923017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:06',0,'2014-03-01 15:31:33'),(10545,10545,'2014-01-01','ET','2',2,1,'OLGA HERNANDEZ','FI','585235937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:20',0,'2014-03-02 04:24:47'),(16733,17383,'0000-00-00','ET','2',1,NULL,'Gene Lowe','FI','268525337','HealthSpan','FI','311431434','Brooke  Bowerman','94','1854510','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:41',0,'2014-03-10 14:20:26'),(18216,18866,'0000-00-00','ET','2',1,NULL,'Sylvia Ross','FI','279681766','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:06',0,'2014-03-10 16:31:33'),(11969,11969,'2014-01-01','ET','2',1,NULL,'LORIN BENJAMIN','FI','228969895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:55',0,'2014-03-02 04:59:36'),(527,527,'2014-01-01','ET','2',1,NULL,'Thomas Williams','FI','098443673','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:14',0,'2014-03-01 15:48:04'),(5153,5153,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000120057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:54',0,'2014-03-10 15:52:36'),(11881,11881,'2014-01-01','ET','2',1,NULL,'Charles Jones','FI','451968174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:25',0,'2014-03-02 04:59:36'),(11007,11007,'2014-01-01','ET','2',1,NULL,'Anne Stein','FI','456330167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:02',0,'2014-03-02 04:24:47'),(13923,14279,'2014-01-01','ET','2',1,NULL,'Kecia Dailey','FI','312947222','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:15',0,'2014-03-10 14:03:26'),(1949,1949,'2014-01-01','ET','2',1,NULL,'Chasity Conner','FI','285963927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:33:12',0,'2014-03-01 15:26:40'),(4509,4509,'2014-01-01','ET','2',2,1,'Antwon D Whitaker','FI','291909508','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:21',0,'2014-03-10 13:03:33'),(17788,18438,'0000-00-00','ET','2',1,NULL,'Andrew Brown','FI','405238483','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:23',0,'2014-03-01 16:56:22'),(17829,18479,'0000-00-00','ET','2',1,NULL,'David Chamberlain','FI','003528977','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:59',0,'2014-03-10 14:10:12'),(20069,20719,'0000-00-00','ET','2',1,NULL,'PADMAJA PAPKAR','FI','286767821','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:26',0,'2014-03-01 18:08:07'),(22640,23290,'0000-00-00','ET','2',1,NULL,'Ousmane NDiaye','FI','129823792','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:12',0,'2014-03-08 21:35:36'),(12692,12692,'2014-01-01','ET','2',1,NULL,'Robert Himmelright','FI','302404144','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-02-01','Sync Success',0,'2014-01-03 02:04:28',0,'2014-03-10 16:10:34'),(440,440,'2014-01-01','ET','2',1,NULL,'Scott Grigsby','94','0000338847','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:39',0,'2014-03-10 15:45:56'),(3819,3819,'2014-01-01','ET','2',1,NULL,'Catherine Mallett','FI','300529455','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:01',0,'2014-03-10 13:10:24'),(4120,4120,'2014-01-01','ET','2',2,1,'Quan Nguyen','FI','004968375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:50',0,'2014-03-01 16:00:27'),(4666,4666,'2014-01-01','ET','2',1,NULL,'Emily Woods','FI','282902773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:25',0,'2014-03-01 16:15:39'),(18128,18778,'0000-00-00','ET','2',1,NULL,'Maria de Los Angeles Davis','FI','547612361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:59',0,'2014-03-02 06:38:05'),(20470,21120,'0000-00-00','ET','2',1,NULL,'Aaron Kubicina','FI','268921034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:23',0,'2014-03-01 18:08:07'),(21506,22156,'0000-00-00','ET','2',1,NULL,'Charles Verdell','FI','461815803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:59',0,'2014-03-03 22:26:43'),(21585,22235,'0000-00-00','ET','2',1,NULL,'Catherine Templeton','FI','292586826','HealthSpan','FI','311431434','Daniel F Eckstein','94','2211061','348','2014-04-01','Sync Success',0,'2014-03-03 21:32:00',0,'2014-03-10 14:45:25'),(104,104,'2014-01-01','ET','2',1,NULL,'Noelia Mendez','FI','453948202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:09',0,'2014-03-01 22:10:55'),(3520,3520,'2014-01-01','ET','2',1,NULL,'JAMES KEVIN BIANTHINI','FI','284646953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:49',0,'2014-03-01 15:37:30'),(7680,7680,'2014-01-01','ET','2',1,NULL,'JOHN HOLTKAMP','FI','274540492','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:50',0,'2014-03-10 13:39:10'),(13421,13777,'2014-01-01','ET','2',3,2,'Sacha Ramirez Francis','FI','277801860','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:04',0,'2014-03-10 13:59:38'),(13390,13746,'2014-01-01','ET','2',5,4,'Dana Marty','FI','293725043','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:49',0,'2014-03-10 16:10:34'),(13342,13698,'2014-01-01','ET','2',1,NULL,'FREDRICK VEAUTHIER','FI','271788865','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:29',0,'2014-03-01 16:40:16'),(18027,18677,'0000-00-00','ET','2',1,NULL,'JODELL HILL','FI','276782608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:57',0,'2014-03-01 17:26:36'),(19835,20485,'0000-00-00','ET','2',2,1,'Kathy Beekman','FI','269586923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:52',0,'2014-03-01 17:47:19'),(22302,22952,'0000-00-00','ET','2',2,1,'Steven Brouman','FI','299687283','Summa Insurance Company, Inc.','FI','341809108','Jim  Fotiadis','94','1789502','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:56',0,'2014-03-10 16:44:18'),(22345,22995,'0000-00-00','ET','2',1,NULL,'Memphis Bregitzer','94','0000279607','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','357','2014-03-31','Sync Success',0,'2014-03-07 21:00:09',0,'2014-03-07 21:36:32'),(7429,7429,'2014-01-01','ET','2',1,NULL,'Rose Sanchez','FI','436760651','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:46',0,'2014-03-02 04:15:49'),(1601,1601,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:14',0,'2014-03-01 20:10:57'),(7087,7087,'2014-01-01','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:03:15',0,'2014-03-01 15:52:44'),(12142,12142,'2014-01-01','ET','2',1,NULL,'KATIE HOWARD','FI','587347326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:11',0,'2014-03-02 04:59:36'),(4615,4615,'2014-01-01','ET','2',1,NULL,'amy anderson','FI','440847801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:42',0,'2014-03-02 04:31:46'),(4564,4564,'2014-01-01','ET','2',1,NULL,'GWENDOLYN ALEXANDER','FI','433862569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:09',0,'2014-03-02 04:38:08'),(16901,17551,'0000-00-00','ET','2',1,NULL,'George Dabrowski','FI','283908320','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:27',0,'2014-03-01 17:00:58'),(17454,18104,'0000-00-00','ET','2',1,NULL,'Kathryn Mcghee','94','0000929872','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:19',0,'2014-03-01 17:20:55'),(17540,18190,'0000-00-00','ET','2',2,1,'laura hanson','FI','313947774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:27',0,'2014-03-01 17:20:55'),(17694,18344,'0000-00-00','ET','2',1,NULL,'PAMELA CARNAHAN','FI','295521099','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:30:03',0,'2014-03-10 14:24:38'),(19735,20385,'0000-00-00','ET','2',1,NULL,'BIPIN R PATEL','FI','314112645','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:38:48',0,'2014-03-10 14:37:47'),(19897,20547,'0000-00-00','ET','2',1,NULL,'Comcepcion Lopez','FI','548917705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:03',0,'2014-03-02 07:03:25'),(20376,21026,'0000-00-00','ET','2',1,NULL,'WILHELMINA WINSTON','FI','428081208','Starmount Life Insurance Company','FI','720977315','PAT  RILEY','94','6399188','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:05',0,'2014-03-02 07:10:28'),(7345,7345,'2014-01-01','ET','2',1,NULL,'Flora Goings','FI','433680422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:19',0,'2014-03-01 21:11:04'),(14264,14715,'2014-01-01','ET','2',1,NULL,'BONNIE WATKINS','FI','278563134','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:09',0,'2014-03-01 16:46:19'),(10853,10853,'2014-01-01','ET','2',1,NULL,'Michael Newland','FI','282585790','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-26 13:05:36',0,'2014-03-10 13:45:57'),(10666,10666,'2014-01-01','ET','2',1,NULL,'Brian Knueven','FI','300660118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:18',0,'2014-03-01 16:05:34'),(3624,3624,'2014-01-01','ET','2',2,1,'Michael D Wilkins','FI','505969018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:05',0,'2014-03-02 01:10:33'),(4170,4170,'2014-01-01','ET','2',1,NULL,'ALICE C RIDDLE','FI','301562771','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:17',0,'2014-03-10 15:59:47'),(16878,17528,'0000-00-00','ET','2',1,NULL,'KELLIE RAMSEY','FI','640502960','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:14',0,'2014-03-02 06:17:30'),(14084,14535,'2014-01-01','ET','2',1,NULL,'nevelyn rodriguez','FI','449942767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:26',0,'2014-03-02 05:38:34'),(4065,4065,'2014-01-01','ET','2',2,1,'THOMAS AIDAN STACK','FI','635328943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:10',0,'2014-03-02 03:09:49'),(4046,4046,'2014-01-01','ET','2',1,NULL,'Stephen FOO','FI','467136556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:33',0,'2014-03-02 03:09:49'),(13833,14189,'2014-01-01','ET','2',1,NULL,'Lisa Robbins','FI','259049317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:36',0,'2014-03-02 05:31:31'),(10514,10514,'2014-01-01','ET','2',1,NULL,'Matthew Wayne Day','FI','466933983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:17',0,'2014-03-02 04:24:47'),(2721,2721,'2014-01-01','ET','2',1,NULL,'Suzanne Greenwell','FI','305768850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:51',0,'2014-03-02 04:15:49'),(16065,16714,'0000-00-00','ET','2',1,NULL,'ELIZABETH PALL','FI','049564548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:52',0,'2014-03-01 16:56:22'),(16480,17130,'0000-00-00','ET','2',2,1,'ERIKA PORRAS','FI','466639137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:25',0,'2014-03-02 06:10:30'),(17741,18391,'0000-00-00','ET','2',1,NULL,'Emily Egan','FI','044748322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:29',0,'2014-03-02 06:31:45'),(21642,22292,'0000-00-00','ET','2',1,NULL,'KAREN PARKER','FI','403829796','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:52',0,'2014-03-04 21:36:30'),(22319,22969,'0000-00-00','ET','2',1,NULL,'Natalie Moser','FI','644149207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:10',0,'2014-03-06 22:25:29'),(15157,15608,'0000-00-00','ET','2',1,NULL,'JACQUELINE ARMSTRONG','FI','278504493','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:31',0,'2014-03-10 14:10:12'),(14729,15180,'2014-01-01','ET','2',1,NULL,'Owen Rhea','FI','434352141','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:13',0,'2014-03-02 05:45:37'),(13883,14239,'2014-01-01','ET','2',1,NULL,'Donna Paul','FI','433022391','Starmount Life Insurance Company','FI','720977315','Wesley James Watkins','94','4710431','348','2014-02-01','Sync Success',0,'2014-01-13 02:24:09',0,'2014-03-02 05:31:31'),(4943,4943,'2014-01-01','ET','2',2,1,'Michael King','FI','467294996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:33',0,'2014-03-01 20:10:57'),(12452,12452,'2014-01-01','ET','2',1,NULL,'JACK MAYFIELD','FI','278523377','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:35',0,'2014-03-10 16:10:34'),(11076,11076,'2014-01-01','ET','2',5,4,'Robert Todd Evans','FI','277744266','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:19',0,'2014-03-10 16:03:49'),(2130,2130,'2014-01-01','ET','2',1,NULL,'Ronald Roberts','FI','189549222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:50',0,'2014-03-01 15:16:37'),(3194,3194,'2014-01-01','ET','2',1,NULL,'Karen Cron','FI','284885450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:08',0,'2014-03-01 15:48:04'),(16326,16976,'0000-00-00','ET','2',1,NULL,'Tiffany Mason','FI','280867503','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:39',0,'2014-03-01 17:00:58'),(17326,17976,'0000-00-00','ET','2',1,NULL,'Terrence Chung','FI','470194959','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:09',0,'2014-03-10 16:24:30'),(17577,18227,'0000-00-00','ET','2',1,NULL,'Michelle Robbins','FI','278861342','HealthSpan','FI','311431434','Jeffrey  Battles','94','999412','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:55',0,'2014-03-10 14:24:38'),(21222,21872,'0000-00-00','ET','2',1,NULL,'RANDOLPH SARGEANT','FI','093582600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:11',0,'2014-03-02 07:23:39'),(22782,23432,'0000-00-00','ET','2',1,NULL,'ANTHONY VENUTO','FI','283541576','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:35',0,'2014-03-09 21:35:27'),(15607,16058,'0000-00-00','ET','2',2,1,'Tu Truong','FI','439897240','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:39',0,'2014-03-02 05:59:43'),(12657,12657,'2014-01-01','ET','2',1,NULL,'JEFFREY HANKS LINER','FI','438198505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:13',0,'2014-03-02 05:10:52'),(10770,10770,'2014-01-01','ET','2',1,NULL,'William Lavis','FI','437575504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:55',0,'2014-03-02 04:24:47'),(3317,3317,'2014-01-01','ET','2',2,1,'Richard Conley','FI','279546979','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:05',0,'2014-03-01 15:52:44'),(3618,3618,'2014-01-01','ET','2',1,NULL,'Kathy Lynn Barney','FI','463212918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:55',0,'2014-03-02 00:10:48'),(7045,7045,'2014-01-01','ET','2',1,NULL,'BILLY  MCFADDEN','FI','451862338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:53',0,'2014-03-02 03:09:49'),(17301,17951,'0000-00-00','ET','2',1,NULL,'Fredrick Johnson','FI','434557926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:55',0,'2014-03-02 06:24:38'),(19320,19970,'0000-00-00','ET','2',1,NULL,'Elizabeth Powell','FI','640185135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:11',0,'2014-03-02 06:59:07'),(21361,22011,'0000-00-00','ET','2',3,2,'LISA MOZINA','FI','288804045','Summa Insurance Company, Inc.','FI','341809108','JIM  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-03-03 01:00:30',0,'2014-03-10 16:38:05'),(22237,22887,'0000-00-00','ET','2',1,NULL,'Andrew Beauchamp','FI','436557090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:02:07',0,'2014-03-06 21:27:26'),(54,54,'2014-01-01','ET','2',2,1,'thomas sullivan','FI','219881425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:38',0,'2014-03-01 15:21:15'),(15364,15815,'0000-00-00','ET','2',1,NULL,'Ellen Schlatter','FI','316509933','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:57',0,'2014-03-10 14:10:12'),(4176,4176,'2014-01-01','ET','2',1,NULL,'TONYA L COOK','FI','281721871','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNAGAN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:27',0,'2014-03-10 15:59:47'),(7299,7299,'2014-01-01','ET','2',1,NULL,'Sharon K Rhoades','FI','274449739','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:41',0,'2014-03-10 13:32:15'),(16459,17109,'0000-00-00','ET','2',2,1,'JEFFERY L ALLISON','FI','287563627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:12',0,'2014-03-01 17:00:58'),(18369,19019,'0000-00-00','ET','2',1,NULL,'Elizabeth Ann Runge','FI','460132935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:39',0,'2014-03-02 06:45:14'),(18599,19249,'0000-00-00','ET','2',1,NULL,'David Handel','FI','282924566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:33',0,'2014-03-01 17:26:36'),(18880,19530,'0000-00-00','ET','2',1,NULL,'Phyllis Kourian','FI','290409839','Dental Care Plus, Inc.','FI','311185262','James  Kerrigan','94','1774555','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:47',0,'2014-03-01 17:34:07'),(1115,1115,'2014-01-01','ET','2',2,1,'Matthew Momoh','FI','233041486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:07',0,'2014-03-02 04:38:08'),(4529,4529,'2014-01-01','ET','2',1,NULL,'philip Whisner','FI','300804736','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:33:05',0,'2014-03-10 13:03:33'),(1846,1846,'2014-01-01','ET','2',1,NULL,'Tiffany Smith','FI','274848951','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:03',0,'2014-03-01 15:26:40'),(17716,18366,'0000-00-00','ET','2',2,1,'Mark Knight','FI','463691713','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:12',0,'2014-03-01 17:20:55'),(20469,21119,'0000-00-00','ET','2',1,NULL,'Jennifer Wells','FI','272807268','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:22',0,'2014-03-01 18:08:07'),(124,124,'2014-01-01','ET','2',1,NULL,'Janet Dinier','FI','075440782','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:48',0,'2014-03-10 15:45:56'),(14485,14936,'2014-01-01','ET','2',1,NULL,'Jerry Anthony Crockett','FI','278522154','Starmount Life Insurance Company','FI','720977315','William M Shirey','94','1675822','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:46',0,'2014-03-02 05:38:34'),(1410,1410,'2014-01-01','ET','2',1,NULL,'Sheryl Downs','FI','436252751','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-01-01','Sync Success',0,'2013-12-25 18:54:22',0,'2014-03-02 04:45:37'),(13906,14262,'2014-01-01','ET','2',1,NULL,'THERESE KALTENECKER','FI','289560530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:05',0,'2014-03-01 16:40:16'),(13404,13760,'2014-01-01','ET','2',1,NULL,'JANICE L PREVOST','FI','454295059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:56',0,'2014-03-02 05:24:45'),(4747,4747,'2014-01-01','ET','2',2,1,'leon wesley','FI','436809995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:11',0,'2014-03-01 21:11:04'),(12278,12278,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:28',0,'2014-03-10 16:10:34'),(5877,5877,'2014-01-01','ET','2',1,NULL,'cheryl stark','FI','284709967','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:11',0,'2014-03-10 13:03:33'),(18877,19527,'0000-00-00','ET','2',1,NULL,'NATALIE FAISON','FI','272885357','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:45',0,'2014-03-01 17:34:07'),(19022,19672,'0000-00-00','ET','2',4,3,'Jason Barr','FI','290863629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:05',0,'2014-03-01 17:34:07'),(10899,10899,'2014-01-01','ET','2',1,NULL,'Bobbie Moore','FI','433807112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:37',0,'2014-03-02 04:24:47'),(10570,10570,'2014-01-01','ET','2',1,NULL,'Sean Lavar Alexander','FI','573472177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:13',0,'2014-03-02 04:24:47'),(4489,4489,'2014-01-01','ET','2',1,NULL,'Marilyn  Hepler','FI','279545061','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:42',0,'2014-03-10 15:39:19'),(12530,12530,'2014-01-01','ET','2',1,NULL,'mark guzman','FI','467734333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:27',0,'2014-03-02 05:03:29'),(14271,14722,'2014-01-01','ET','2',2,1,'James Brooks','FI','277500368','Dental Care Plus, Inc.','FI','311185262','Kathy   Canlas','94','7407489','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:11',0,'2014-03-01 16:46:19'),(14325,14776,'2014-01-01','ET','2',1,NULL,'HALEY K GARRETT','FI','635101921','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:35',0,'2014-03-02 05:38:34'),(14550,15001,'2014-01-01','ET','2',1,NULL,'Brad Stone','FI','446928158','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:18',0,'2014-03-02 05:45:37'),(16948,17598,'0000-00-00','ET','2',2,1,'bon nguyen','FI','464777997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:57',0,'2014-03-02 06:17:30'),(19150,19800,'0000-00-00','ET','2',1,NULL,'Jennifer Jassem','FI','297784779','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:23',0,'2014-03-10 16:31:33'),(19318,19968,'0000-00-00','ET','2',2,1,'DONNA JEAN MILLNER','FI','465021303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:10',0,'2014-03-02 06:59:07'),(2778,2778,'2014-01-01','ET','2',1,NULL,'christopher spain','FI','271807969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:35',0,'2014-03-01 16:05:34'),(2217,2217,'2014-01-01','ET','2',1,NULL,'LORETTA M ROBINSON','FI','281587211','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:44',0,'2014-03-10 15:39:19'),(4974,4974,'2014-01-01','ET','2',1,NULL,'H Evelyn Bostic','FI','283520701','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:10',0,'2014-03-01 15:31:33'),(16154,16803,'0000-00-00','ET','2',1,NULL,'RAYMOND SIMONS','FI','282868603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:10',0,'2014-03-02 06:03:21'),(17938,18588,'0000-00-00','ET','2',1,NULL,'Alexis Arakelian','FI','012707462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:55',0,'2014-03-10 14:24:38'),(18518,19168,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:23',0,'2014-03-10 14:31:05'),(20196,20846,'0000-00-00','ET','2',2,1,'BONNIE REYES','FI','458594161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:27',0,'2014-03-02 07:10:28'),(146,146,'2014-01-01','ET','2',1,NULL,'Kathleen Boyle','FI','278544737','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:33',0,'2014-03-10 15:45:56'),(15694,16343,'0000-00-00','ET','2',2,1,'TRUNG VAN NGUYEN','FI','462719714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:44',0,'2014-03-02 05:59:43'),(13046,13402,'2014-01-01','ET','2',1,NULL,'shane sterling','FI','436232902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:59',0,'2014-03-02 05:17:40'),(4873,4873,'2014-01-01','ET','2',1,NULL,'Jennifer Neff','FI','297600007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:21',0,'2014-03-01 15:10:22'),(12475,12475,'2014-01-01','ET','2',1,NULL,'Evan Mecklenborg','FI','300980342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:32:23',0,'2014-03-01 16:30:17'),(10755,10755,'2014-01-01','ET','2',5,4,'Dominic Giovannazzo','FI','298606764','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:25',0,'2014-03-01 16:15:39'),(3694,3694,'2014-01-01','ET','2',1,NULL,'patrick arceneaux','FI','435351494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:19',0,'2014-03-02 00:10:48'),(1213,1213,'2014-01-01','ET','2',2,1,'Annamarie Pamphilis','FI','284749157','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:10',0,'2014-03-01 16:15:39'),(2250,2250,'2014-01-01','ET','2',1,NULL,'Sandra Huebner','FI','276489472','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:57',0,'2014-03-10 13:10:24'),(14695,15146,'2014-01-01','ET','2',1,NULL,'Catherine Breland','FI','587613556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:52',0,'2014-03-02 05:45:37'),(13867,14223,'2014-01-01','ET','2',1,NULL,'trelissa levi','FI','435711527','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:59',0,'2014-03-02 05:31:31'),(3401,3401,'2014-01-01','ET','2',1,NULL,'Tereasa Griffith','FI','275763673','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:51:44',0,'2014-03-10 13:24:34'),(3890,3890,'2014-01-01','ET','2',1,NULL,'Beau Dingler','FI','439390073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:54',0,'2014-03-01 19:11:03'),(18177,18827,'0000-00-00','ET','2',1,NULL,'Barbara Earhart','FI','297664527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:35',0,'2014-03-01 17:26:36'),(19546,20196,'0000-00-00','ET','2',2,1,'DENISE RENDELL CAREY','FI','438597142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:17:17',0,'2014-03-02 06:59:07'),(14657,15108,'2014-01-01','ET','2',2,1,'LISA AYERS','FI','274805391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:26',0,'2014-03-01 16:46:19'),(627,627,'2014-01-01','ET','2',2,1,'Matthew Titsworth','FI','627261218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:30',0,'2014-03-02 02:10:49'),(14144,14595,'2014-01-01','ET','2',1,NULL,'MELODIE A DUNN','FI','439047168','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:03',0,'2014-03-02 05:38:34'),(11011,11011,'2014-01-01','ET','2',1,NULL,'ROSEMARIE DAHL JAMES','FI','425236022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:11',0,'2014-03-02 04:24:47'),(20989,21639,'0000-00-00','ET','2',1,NULL,'paula leboeuf','FI','439356147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:31',0,'2014-03-02 07:17:36'),(22161,22811,'0000-00-00','ET','2',1,NULL,'jiair m hugley','FI','272023843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:12',0,'2014-03-06 21:36:23'),(7752,7752,'2014-01-01','ET','2',1,NULL,'Ryan Steller','FI','279829810','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:56',0,'2014-03-10 15:39:19'),(14419,14870,'2014-01-01','ET','2',1,NULL,'ROBIN LYNN LOVE','FI','425237801','Starmount Life Insurance Company','FI','720977315','VICKIE  HICKS','94','4766477','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:15',0,'2014-03-02 05:38:34'),(1044,1044,'2014-01-01','ET','2',1,NULL,'Peter Caceres','FI','452530017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:06',0,'2014-03-01 21:11:04'),(7145,7145,'2014-01-01','ET','2',2,1,'Alexandra Thorp','FI','288748056','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:57',0,'2014-03-10 15:59:47'),(7111,7111,'2014-01-01','ET','2',1,NULL,'Lynn Chau','FI','364963807','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:54',0,'2014-03-01 15:52:44'),(11047,11047,'2014-01-01','ET','2',1,NULL,'Carol A Franjesevic','FI','197468094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:21',0,'2014-03-10 16:03:49'),(3653,3653,'2014-01-01','ET','2',1,NULL,'Karin Collins','FI','297828643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:02',0,'2014-03-10 15:52:36'),(3907,3907,'2014-01-01','ET','2',1,NULL,'lillie ruth cistrunk','FI','587405853','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:14',0,'2014-03-01 15:26:40'),(17942,18592,'0000-00-00','ET','2',1,NULL,'LANCE WADE','FI','433111252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:58',0,'2014-03-02 06:38:05'),(19995,20645,'0000-00-00','ET','2',1,NULL,'CYNTHIA WALKER','FI','273484202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:49',0,'2014-03-01 17:47:19'),(14124,14575,'2014-01-01','ET','2',1,NULL,'joanie vidrine','FI','438256900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:50',0,'2014-03-02 05:38:34'),(6411,6411,'2014-01-01','ET','2',2,1,'JIN DOLNEY','FI','297045947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:55',0,'2014-03-10 13:39:10'),(11823,11823,'2014-01-01','ET','2',1,NULL,'DUDLEY PAYNE','FI','436980625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:50',0,'2014-03-02 04:31:46'),(17679,18329,'0000-00-00','ET','2',2,1,'Biagio Vittoria','FI','048521633','Summa Insurance Company, Inc.','FI','341809108','gary  bologna','94','1795854','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:52',0,'2014-03-10 16:24:30'),(19065,19715,'0000-00-00','ET','2',1,NULL,'Tina Bernard','FI','436724149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:19',0,'2014-03-02 06:52:12'),(20652,21302,'0000-00-00','ET','2',1,NULL,'James Ringler','FI','280823113','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:26',0,'2014-03-10 16:38:05'),(21160,21810,'0000-00-00','ET','2',1,NULL,'Suzanne Prock','FI','437650629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 21:31:27',0,'2014-03-02 07:23:39'),(22146,22796,'0000-00-00','ET','2',1,NULL,'OCTAVIA JONES','FI','433812208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:02',0,'2014-03-06 21:27:26'),(22213,22863,'0000-00-00','ET','2',1,NULL,'Wayne W Weimer','FI','273521157','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:49',0,'2014-03-06 21:36:23'),(15089,15540,'0000-00-00','ET','2',1,NULL,'MARILYN COWAN','FI','272507371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:41',0,'2014-03-01 16:50:53'),(10833,10833,'2014-01-01','ET','2',1,NULL,'Osmin Lemus','FI','437891204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:04:57',0,'2014-03-02 04:31:46'),(1129,1129,'2014-01-01','ET','2',2,1,'luis bonilla barrera','FI','643135944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:33',0,'2014-03-02 04:38:08'),(2110,2110,'2014-01-01','ET','2',1,NULL,'Terrence McCrary','FI','301624995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:15',0,'2014-03-01 15:16:37'),(1519,1519,'2014-01-01','ET','2',1,NULL,'Nancy Kopp','FI','300501249','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:01',0,'2014-03-10 13:52:32'),(16484,17134,'0000-00-00','ET','2',1,NULL,'FELIX FERNANDEZ','FI','430457942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:27',0,'2014-03-02 06:10:30'),(16666,17316,'0000-00-00','ET','2',1,NULL,'JEFFREY L HIGH','FI','299640548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:52',0,'2014-03-01 17:00:58'),(21589,22239,'0000-00-00','ET','2',1,NULL,'Michael White','FI','434809262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:11',0,'2014-03-04 21:27:16'),(22008,22658,'0000-00-00','ET','2',1,NULL,'John Lopez','FI','274562136','Dental Care Plus, Inc.','FI','311185262','Ronald  Martin','94','2432668','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:58',0,'2014-03-05 21:36:22'),(23015,23665,'0000-00-00','ET','2',1,NULL,'Summer Devail Roberson','FI','426359449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:02',0,'2014-03-10 21:27:11'),(16290,16940,'0000-00-00','ET','2',1,NULL,'Hugo Fuentes','FI','463270305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:16',0,'2014-03-02 06:10:30'),(16084,16733,'0000-00-00','ET','2',1,NULL,'Eric Vaiksnoras','FI','272740344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:06',0,'2014-03-01 16:56:22'),(16004,16653,'0000-00-00','ET','2',1,NULL,'QUANG ZAN','FI','634238455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:14',0,'2014-03-02 06:03:21'),(15966,16615,'0000-00-00','ET','2',2,1,'OSCAR O MEDRANO','FI','450499001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:13',0,'2014-03-02 06:03:21'),(900,900,'2014-01-01','ET','2',1,NULL,'MAXINE CALKINS','FI','298785097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:08',0,'2014-03-01 15:21:15'),(1769,1769,'2014-01-01','ET','2',1,NULL,'camile nelson','FI','438559290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:34',0,'2014-03-02 00:10:48'),(1069,1069,'2014-01-01','ET','2',1,NULL,'Beverly Clayton','FI','302648510','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:55',0,'2014-03-10 13:03:33'),(1680,1680,'2014-01-01','ET','2',1,NULL,'Barbara Miller','FI','403965160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:51',0,'2014-03-02 00:10:48'),(12732,12732,'2014-01-01','ET','2',1,NULL,'SANDRA MAZUK','FI','293564539','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:02',0,'2014-03-10 13:59:38'),(13099,13455,'2014-01-01','ET','2',1,NULL,'James Mudgett','FI','354440156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:56',0,'2014-03-02 05:17:40'),(14000,14356,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:30',0,'2014-03-01 16:40:16'),(15420,15871,'0000-00-00','ET','2',2,1,'Robert Bergdorf','FI','270500812','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:22',0,'2014-03-01 16:50:53'),(16816,17466,'0000-00-00','ET','2',1,NULL,'dolores ledesma','FI','455821656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:03',0,'2014-03-02 06:17:30'),(17543,18193,'0000-00-00','ET','2',1,NULL,'MAURA ANDERSON','FI','284923518','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:30',0,'2014-03-10 16:24:30'),(19770,20420,'0000-00-00','ET','2',1,NULL,'DENISE ANGERSTIEN','FI','292601297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 21:30:19',0,'2014-03-01 17:47:19'),(19955,20605,'0000-00-00','ET','2',2,1,'James Gordon','FI','511663265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:19',0,'2014-03-02 07:03:25'),(20178,20828,'0000-00-00','ET','2',1,NULL,'Ellen Arthur','FI','161768248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:14',0,'2014-03-02 07:10:28'),(15182,15633,'0000-00-00','ET','2',1,NULL,'Robert  Zur','FI','626382865','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:14',0,'2014-03-02 05:52:31'),(12083,12083,'2014-01-01','ET','2',1,NULL,'Michael Green','FI','227558347','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:08',0,'2014-03-01 16:30:17'),(10891,10891,'2014-01-01','ET','2',1,NULL,'Christi Barlow','94','0002346003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:20',0,'2014-03-02 04:24:47'),(7524,7524,'2014-01-01','ET','2',1,NULL,'Daniel Dermody','FI','299508793','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:48',0,'2014-03-01 16:05:34'),(11930,11930,'2014-01-01','ET','2',1,NULL,'ARMIDA TORRES','FI','632185196','Starmount Life Insurance Company','FI','720977315','alvaro  castellanos','94','3220736','348','2014-02-01','Sync Success',0,'2013-12-30 00:01:58',0,'2014-03-02 04:59:36'),(17283,17933,'0000-00-00','ET','2',1,NULL,'Tamiyah Fletcher','FI','457939848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:46',0,'2014-03-02 06:24:38'),(17581,18231,'0000-00-00','ET','2',1,NULL,'Leticia Harmon','FI','462298517','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:57',0,'2014-03-02 06:31:45'),(19872,20522,'0000-00-00','ET','2',1,NULL,'regina martin','FI','271582471','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:22',0,'2014-03-01 17:47:19'),(20828,21478,'0000-00-00','ET','2',1,NULL,'MICHELLE L GOMEZ','FI','463751090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:12',0,'2014-03-02 07:17:36'),(12762,12762,'2014-01-01','ET','2',1,NULL,'anna priest','FI','285501332','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:11',0,'2014-03-10 13:59:38'),(5454,5454,'2014-01-01','ET','2',1,NULL,'John  Metcalf','FI','270485716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:09',0,'2014-03-01 15:05:09'),(5060,5060,'2014-01-01','ET','2',1,NULL,'Wayne Roth','FI','159403942','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:56',0,'2014-03-01 15:31:33'),(2502,2502,'2014-01-01','ET','2',1,0,'Shannon Lamb','FI','452516656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:06',0,'2014-03-01 19:11:03'),(11471,11471,'2014-01-01','ET','2',2,1,'Ronnie Anderson','FI','271528170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:46',0,'2014-03-01 16:30:17'),(3014,3014,'2014-01-01','ET','2',1,NULL,'Tracey Baranowski','FI','298760656','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:33',0,'2014-03-10 15:52:36'),(17798,18448,'0000-00-00','ET','2',1,NULL,'Darrell Ditrick','FI','287449592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:32',0,'2014-03-01 16:50:53'),(18384,19034,'0000-00-00','ET','2',3,2,'Kim Shugars','FI','587352508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:50',0,'2014-03-02 06:45:14'),(20611,21261,'0000-00-00','ET','2',1,NULL,'Angela D Tullos','FI','428494747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:56',0,'2014-03-02 07:10:28'),(21652,22302,'0000-00-00','ET','2',1,NULL,'STEVE JOHN MCARTHUR','FI','279546208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:00',0,'2014-03-04 21:36:30'),(22392,23042,'0000-00-00','ET','2',1,NULL,'KAREN KALTENBACH','FI','273661164','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:32',0,'2014-03-10 16:44:18'),(15830,16479,'0000-00-00','ET','2',1,NULL,'marcela chavez','FI','772108352','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:29',0,'2014-03-10 14:10:12'),(3038,3038,'2014-01-01','ET','2',1,NULL,'Ruth Norton','FI','298505352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:15',0,'2014-03-01 15:37:30'),(10749,10749,'2014-01-01','ET','2',1,NULL,'amy keller','FI','284805361','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:12',0,'2014-03-01 16:15:39'),(14776,15227,'2014-01-01','ET','2',1,NULL,'Barbara Fahnle','FI','402646505','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:42',0,'2014-03-10 14:03:26'),(3938,3938,'2014-01-01','ET','2',1,NULL,'Jean Woods','FI','437110683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:10',0,'2014-03-01 23:10:52'),(11478,11478,'2014-01-01','ET','2',1,NULL,'Magdy Abulella','FI','271869369','Dental Care Plus, Inc.','FI','311185262','Jason  Harler','94','7398825','348','2014-02-01','Sync Success',0,'2013-12-28 03:31:00',0,'2014-03-01 16:30:17'),(13415,13771,'2014-01-01','ET','2',1,NULL,'Margaret Smith','FI','283508849','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:01',0,'2014-03-10 13:59:38'),(18159,18809,'0000-00-00','ET','2',1,NULL,'Kathy Thomas','FI','433214293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:22',0,'2014-03-02 06:38:05'),(19564,20214,'0000-00-00','ET','2',1,NULL,'Joseph Vancol','FI','070681655','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:21:40',0,'2014-03-02 06:59:07'),(11069,11069,'2014-01-01','ET','2',1,NULL,'Susan Wallin','FI','275746856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:06',0,'2014-03-10 16:03:49'),(5879,5879,'2014-01-01','ET','2',1,NULL,'Vickie Renee Preto','FI','291466884','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:30:06',0,'2014-03-10 15:52:36'),(5527,5527,'2014-01-01','ET','2',1,NULL,'Patricia Lester','FI','301504359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:16',0,'2014-03-01 16:23:43'),(16554,17204,'0000-00-00','ET','2',1,NULL,'roman bernal','FI','459298772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-30 21:01:12',NULL,NULL),(13786,14142,'2014-01-01','ET','2',1,NULL,'Harry Bailey','FI','281540480','HealthSpan','FI','311431434','Jay  Jordan','94','6747517','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:37',0,'2014-03-10 13:59:38'),(1797,1797,'2014-01-01','ET','2',1,NULL,'Kristi Goetz','FI','633090822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:33',0,'2014-03-02 00:10:48'),(22254,22904,'0000-00-00','ET','2',2,1,'Tyler J Rowland','FI','286829761','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:19',0,'2014-03-10 14:45:25'),(269,269,'2014-01-01','ET','2',1,NULL,'Richard Glass','FI','279548282','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:32',0,'2014-03-10 13:03:33'),(16692,17342,'0000-00-00','ET','2',1,NULL,'andrea FISHER','FI','272606272','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:11',0,'2014-03-01 17:00:58'),(579,579,'2014-01-01','ET','2',1,NULL,'patricia davis','FI','434907822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:55',0,'2014-03-02 02:10:49'),(14841,15292,'2014-01-01','ET','2',1,NULL,'Rocksand Hollinger','FI','271547843','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:47:26',0,'2014-03-10 14:03:26'),(12955,12955,'2014-01-01','ET','2',2,1,'JUSTIN  HOLT','FI','453859596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:32',0,'2014-03-02 05:17:40'),(3945,3945,'2014-01-01','ET','2',1,NULL,'Janice Jernigan','FI','435430034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:46:23',0,'2014-03-01 23:10:52'),(13155,13511,'2014-01-01','ET','2',1,NULL,'LISA BEEKMAN','FI','301484327','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:06',0,'2014-03-10 13:59:38'),(11616,11616,'2014-01-01','ET','2',2,1,'LISA  HENSAL','FI','281587708','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:14',0,'2014-03-10 16:03:49'),(20528,21178,'0000-00-00','ET','2',2,1,'NORMAN ROSZEL','FI','440480592','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:03',0,'2014-03-02 07:10:28'),(22412,23062,'0000-00-00','ET','2',1,NULL,'HYUN NAM SEO','FI','629209738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:07',0,'2014-03-07 22:26:59'),(22599,23249,'0000-00-00','ET','2',4,3,'VICTORIA WALTERS','FI','272888755','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:22',0,'2014-03-10 14:50:59'),(4837,4837,'2014-01-01','ET','2',1,NULL,'Wanda Cefalo','FI','304548193','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:12',0,'2014-03-01 15:10:22'),(14602,15053,'2014-01-01','ET','2',1,NULL,'susan zittle','FI','286600604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:52',0,'2014-03-01 16:46:19'),(14519,14970,'2014-01-01','ET','2',2,1,'Steven Line','FI','286665623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:02',0,'2014-03-10 14:03:26'),(2029,2029,'2014-01-01','ET','2',2,1,'PATRICIA T GRANGER','FI','437905424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:47',0,'2014-03-01 23:10:52'),(12889,12889,'2014-01-01','ET','2',1,NULL,'Harry Toussaint','FI','436846707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:30',0,'2014-03-02 05:17:40'),(3950,3950,'2014-01-01','ET','2',1,NULL,'Dennis Lewis','FI','462775515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:33',0,'2014-03-01 23:10:52'),(12332,12332,'2014-01-01','ET','2',1,NULL,'Marcos Cervantes Ramos','FI','463829275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:17',0,'2014-03-02 05:03:29'),(7432,7432,'2014-01-01','ET','2',1,NULL,'Christopher Bagneris','FI','435856966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:53',0,'2014-03-02 04:15:49'),(17404,18054,'0000-00-00','ET','2',1,NULL,'Shane Mueller','FI','298845901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:44',0,'2014-03-01 17:20:55'),(6130,6130,'2014-01-01','ET','2',2,1,'Tim  John Huesken','FI','199387589','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:15',0,'2014-03-01 16:00:27'),(5238,5238,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:53:38',0,'2014-03-10 13:20:27'),(395,395,'2014-01-01','ET','2',2,1,'Robert Chance','FI','437869251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:14',0,'2014-03-01 22:10:55'),(603,603,'2014-01-01','ET','2',1,NULL,'Marilynn M Nesmith','FI','466927468','Starmount Life Insurance Company','FI','720977315','Jeff  Derdiger','94','2127861','348','2014-01-01','Sync Success',0,'2013-12-25 18:03:42',0,'2014-03-02 02:10:49'),(14907,15358,'2014-01-01','ET','2',1,NULL,'Ricka  Johnson','FI','433177889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-17 03:35:27',0,'2014-03-02 05:52:31'),(1095,1095,'2014-01-01','ET','2',1,NULL,'dale barnes','FI','435843186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:50',0,'2014-03-01 19:11:03'),(11888,11888,'2014-01-01','ET','2',2,1,'Earl Williams','FI','438173666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:39',0,'2014-03-02 04:59:36'),(4417,4417,'2014-01-01','ET','2',1,NULL,'Benjamin Riley','FI','576667034','Starmount Life Insurance Company','FI','720977315','Don  Henry','94','7837890','348','2014-01-01','Sync Success',0,'2013-12-25 23:16:31',0,'2014-03-01 19:11:03'),(11868,11868,'2014-01-01','ET','2',1,NULL,'Dixie  Wright','FI','295625383','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:25',0,'2014-03-10 13:45:57'),(11870,11870,'2014-01-01','ET','2',1,NULL,'Ellen Schweers','FI','449117895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:05',0,'2014-03-02 04:59:36'),(15741,16390,'0000-00-00','ET','2',1,NULL,'Stacy Kocur','FI','455450920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:16',0,'2014-03-02 05:59:43'),(20031,20681,'0000-00-00','ET','2',1,NULL,'BOBBIE BATTLE','FI','587468213','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:13',0,'2014-03-02 07:03:25'),(20389,21039,'0000-00-00','ET','2',3,2,'MAGDA MARTINEZ RODRIGUEZ','FI','449959494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:18',0,'2014-03-02 07:03:25'),(15444,15895,'0000-00-00','ET','2',1,NULL,'Christine Ware','FI','501829638','Starmount Life Insurance Company','FI','720977315','revonno  burt','94','6401285','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:37',0,'2014-03-02 05:59:43'),(11700,11700,'2014-01-01','ET','2',1,NULL,'STACY GREEN','FI','525290227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:54',0,'2014-03-02 04:59:36'),(11684,11684,'2014-01-01','ET','2',1,NULL,'Dontavia Young','FI','452912465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:24',0,'2014-03-02 04:59:36'),(6122,6122,'2014-01-01','ET','2',1,NULL,'Ross Bochnek','FI','128607445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:58',0,'2014-03-01 16:00:27'),(5548,5548,'2014-01-01','ET','2',1,NULL,'Cherylanne Norwood','FI','281622007','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:00',0,'2014-03-10 13:52:32'),(4119,4119,'2014-01-01','ET','2',1,NULL,'Sharon M Ceena','FI','083442803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:49',0,'2014-03-01 16:00:27'),(5494,5494,'2014-01-01','ET','2',2,1,'KELSEY SHAMANSKY','FI','290806287','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:12',0,'2014-03-01 16:23:43'),(5058,5058,'2014-01-01','ET','2',1,NULL,'Lynn Frank','FI','272484601','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:52',0,'2014-03-01 15:31:33'),(15635,16086,'0000-00-00','ET','2',1,NULL,'Joseph Bradford','FI','287529981','HealthSpan','FI','311431434','Donn g Pahl','94','3237938','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:53',0,'2014-03-10 14:10:12'),(17006,17656,'0000-00-00','ET','2',1,NULL,'Kaitlin Jeziorowski','FI','281846178','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:36',0,'2014-03-10 14:20:26'),(17413,18063,'0000-00-00','ET','2',1,NULL,'Ty Sowry','FI','283844908','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:51',0,'2014-03-10 16:24:30'),(17623,18273,'0000-00-00','ET','2',2,1,'Fetene Gebremeskel','FI','660057262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:17',0,'2014-03-02 06:31:45'),(19060,19710,'0000-00-00','ET','2',2,1,'JOHN WICKER','FI','240116557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:16',0,'2014-03-02 06:52:12'),(20015,20665,'0000-00-00','ET','2',1,NULL,'Doria Daniels','FI','297420689','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:03',0,'2014-03-10 16:38:05'),(21727,22377,'0000-00-00','ET','2',1,NULL,'Tammie Smith','FI','302747119','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:01',0,'2014-03-10 14:45:25'),(22468,23118,'0000-00-00','ET','2',1,NULL,'Kathy Burress','FI','281541718','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:48',0,'2014-03-07 21:36:32'),(22801,23451,'0000-00-00','ET','2',2,1,'Kellee Wright','FI','288829205','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:51',0,'2014-03-10 16:44:18'),(14562,15013,'2014-01-01','ET','2',1,NULL,'Larissa Ellis','FI','463776846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:26',0,'2014-03-02 05:45:37'),(7422,7422,'2014-01-01','ET','2',2,1,'Benjamin Rongey','FI','439879424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:34',0,'2014-03-02 04:15:49'),(2027,2027,'2014-01-01','ET','2',1,NULL,'Treasure Tolliver','FI','418273931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:43',0,'2014-03-01 23:10:52'),(5450,5450,'2014-01-01','ET','2',1,NULL,'mikhail khalil','FI','383900644','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:02',0,'2014-03-01 15:05:09'),(2375,2375,'2014-01-01','ET','2',1,NULL,'EDWIN FARISH','FI','294823656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:30',0,'2014-03-01 15:26:40'),(3965,3965,'2014-01-01','ET','2',1,NULL,'Stephen R Geiger','FI','288466421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:06',0,'2014-03-01 15:26:40'),(2625,2625,'2014-01-01','ET','2',1,NULL,'Noelle McLure','FI','152681756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:45',0,'2014-03-01 15:16:37'),(22789,23439,'0000-00-00','ET','2',1,NULL,'CHRISTI GRIFFIN','FI','451370484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:41',0,'2014-03-09 21:26:00'),(539,539,'2014-01-01','ET','2',1,NULL,'BREANNA MICHELLE MACK','94','0000564194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:41',0,'2014-03-01 15:48:04'),(14394,14845,'2014-01-01','ET','2',1,NULL,'Gary Hayles','FI','290782203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:04',0,'2014-03-01 16:46:19'),(13591,13947,'2014-01-01','ET','2',2,1,'denny price','FI','297560014','HealthSpan','FI','311431434','timothy  mckeown','94','1640913','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:18',0,'2014-03-10 13:59:38'),(1083,1083,'2014-01-01','ET','2',1,NULL,'Terry White','FI','434474717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:23',0,'2014-03-01 19:11:03'),(1871,1871,'2014-01-01','ET','2',2,1,'Valerie Comas Coolidge','FI','234024569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:54',0,'2014-03-01 15:26:40'),(3198,3198,'2014-01-01','ET','2',1,NULL,'Jeffery Griffith','FI','277562485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:15',0,'2014-03-01 15:48:04'),(5493,5493,'2014-01-01','ET','2',1,NULL,'Sarah Snyder','FI','269780574','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:11',0,'2014-03-01 16:23:43'),(6062,6062,'2014-01-01','ET','2',1,NULL,'Keith Cornell Smith','FI','439436441','Starmount Life Insurance Company','FI','720977315','Keith Cornell Smith','94','4698601','348','2014-01-01','Sync Success',0,'2013-12-26 03:00:05',0,'2014-03-02 04:10:25'),(16737,17387,'0000-00-00','ET','2',1,NULL,'Joe Chambers','FI','457573938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:44',0,'2014-03-02 06:17:30'),(17609,18259,'0000-00-00','ET','2',1,NULL,'JAMES PETEET','FI','453866044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:09',0,'2014-03-02 06:31:45'),(17677,18327,'0000-00-00','ET','2',1,NULL,'Andrew Grisel','FI','296948969','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:51',0,'2014-03-10 16:24:30'),(19404,20054,'0000-00-00','ET','2',1,NULL,'Susan Kelly','FI','286484796','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:11',0,'2014-03-10 16:31:33'),(21107,21757,'0000-00-00','ET','2',1,NULL,'Maria Erma Caceres','FI','464897575','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:51',0,'2014-03-02 07:23:39'),(211,211,'2014-01-01','ET','2',1,NULL,'Rondle Hall','FI','524375373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:38',0,'2014-03-01 22:10:55'),(7010,7010,'2014-01-01','ET','2',1,NULL,'kristopher conrad joseph','FI','100724832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:50',0,'2014-03-02 03:09:49'),(12571,12571,'2014-01-01','ET','2',1,NULL,'DOUGLAS KELLER','FI','313841580','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:36:11',0,'2014-03-10 13:59:38'),(3353,3353,'2014-01-01','ET','2',1,NULL,'CARLIE ROSE HUTCHINSON','FI','633341054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:16',0,'2014-03-02 02:10:49'),(2086,2086,'2014-01-01','ET','2',1,NULL,'Nady El-Zayaty','FI','089687161','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:35',0,'2014-03-10 13:20:27'),(16132,16781,'0000-00-00','ET','2',1,NULL,'Deborah Alcorn','FI','298505642','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:43',0,'2014-03-10 14:20:26'),(17330,17980,'0000-00-00','ET','2',1,NULL,'Zeder Pough','FI','073441712','Starmount Life Insurance Company','FI','720977315','Dorian  Black','94','7680495','357','2014-03-01','Sync Success',0,'2014-02-05 21:31:11',0,'2014-03-02 06:24:38'),(18994,19644,'0000-00-00','ET','2',1,NULL,'gary michel','FI','297901446','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:09',0,'2014-03-10 14:31:05'),(19862,20512,'0000-00-00','ET','2',1,NULL,'Cassandra Gaul','FI','283924593','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:13',0,'2014-03-01 17:47:19'),(20264,20914,'0000-00-00','ET','2',1,NULL,'Mary Toth','FI','294549853','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:13',0,'2014-03-01 17:47:19'),(20839,21489,'0000-00-00','ET','2',1,NULL,'KIMBERLY WILLIAMS','FI','288725580','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:16',0,'2014-03-10 14:37:47'),(14412,14863,'2014-01-01','ET','2',1,NULL,'DEBRA BILLINGSLEA','FI','425276660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:12',0,'2014-03-02 05:38:34'),(7109,7109,'2014-01-01','ET','2',1,NULL,'Cyanthia S Collins','FI','300684219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:03:51',0,'2014-03-01 15:52:44'),(13080,13436,'2014-01-01','ET','2',4,3,'LAUREL CONRAD','FI','301606725','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:10',0,'2014-03-01 16:35:14'),(1268,1268,'2014-01-01','ET','2',3,2,'David Danner','FI','299649604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:46',0,'2014-03-01 16:23:43'),(12830,12830,'2014-01-01','ET','2',1,NULL,'LARRY TURNER','FI','435176680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:19',0,'2014-03-02 05:10:52'),(1780,1780,'2014-01-01','ET','2',1,NULL,'John Finley','FI','302446848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:57',0,'2014-03-10 15:45:56'),(11786,11786,'2014-01-01','ET','2',3,2,'LYDIA CHENG','FI','555938595','Starmount Life Insurance Company','FI','720977315','PATTY  CHEN','94','8385158','348','2014-01-01','Sync Success',1,'2013-12-29 11:12:42',0,'2014-03-02 04:31:46'),(2941,2941,'2014-01-01','ET','2',1,NULL,'Lauvern Hollingsworth','FI','132645646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:17',0,'2014-03-01 15:37:30'),(17486,18136,'0000-00-00','ET','2',1,NULL,'Jody Widmer','FI','292609527','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:44',0,'2014-03-10 16:24:30'),(17827,18477,'0000-00-00','ET','2',1,NULL,'Geno Frugoli','FI','530029894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:57',0,'2014-03-02 06:10:30'),(20784,21434,'0000-00-00','ET','2',1,NULL,'Denese Kniola','FI','282484705','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:51',0,'2014-03-10 16:38:05'),(22440,23090,'0000-00-00','ET','2',1,NULL,'Amy Scott','FI','458890002','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:28',0,'2014-03-07 22:26:59'),(762,762,'2014-01-01','ET','2',1,NULL,'Alex yakimoff','FI','285521505','HealthSpan','FI','311431434','Brenda  Williams','94','8389118','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:45',0,'2014-03-10 13:24:34'),(11350,11350,'2014-01-01','ET','2',1,NULL,'Ralph allen GREIWERA','FI','302527770','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:02',0,'2014-03-10 13:52:32'),(5453,5453,'2014-01-01','ET','2',1,NULL,'scott stidham','FI','274881300','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:07',0,'2014-03-01 15:05:09'),(17048,17698,'0000-00-00','ET','2',1,NULL,'Raquel Pena','FI','456968104','Starmount Life Insurance Company','FI','720977315','gerardo  garza','94','7335207','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:29',0,'2014-03-02 06:24:38'),(17270,17920,'0000-00-00','ET','2',1,NULL,'James Martin','FI','260212004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:40',0,'2014-03-02 06:24:38'),(18623,19273,'0000-00-00','ET','2',1,NULL,'JODI BRICKER','FI','282888741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:53',0,'2014-03-01 17:26:36'),(19106,19756,'0000-00-00','ET','2',1,NULL,'Arliss White','FI','290642430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:48',0,'2014-03-01 17:34:07'),(20343,20993,'0000-00-00','ET','2',1,NULL,'Walter Hagy-Ingramm','FI','291620845','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:32',0,'2014-03-10 16:38:05'),(15869,16518,'0000-00-00','ET','2',1,NULL,'Roger Mosley','FI','436393945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:53',0,'2014-03-02 06:03:21'),(10627,10627,'2014-01-01','ET','2',1,NULL,'DEBRA GARCIA','FI','465456800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:04',0,'2014-03-02 04:31:46'),(7740,7740,'2014-01-01','ET','2',1,NULL,'Latasha Archie','FI','433812138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:31',0,'2014-03-01 19:11:03'),(2669,2669,'2014-01-01','ET','2',1,NULL,'Scott Jensen','FI','023684488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:11',0,'2014-03-01 16:05:34'),(17156,17806,'0000-00-00','ET','2',1,NULL,'Jerry  Butler','FI','251354880','Starmount Life Insurance Company','FI','720977315','Sheila  Smith','94','8314747','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:37',0,'2014-03-02 06:24:38'),(21148,21798,'0000-00-00','ET','2',1,NULL,'RHONDA LITT','FI','435598777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:20',0,'2014-03-02 07:23:39'),(21680,22330,'0000-00-00','ET','2',1,NULL,'Shondra Gooden','FI','587554559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:22',0,'2014-03-04 21:27:16'),(22552,23202,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:47',0,'2014-03-10 16:44:18'),(7229,7229,'2014-01-01','ET','2',4,3,'shannon cremeans','FI','294728273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:31',0,'2014-03-01 15:52:44'),(15603,16054,'0000-00-00','ET','2',1,NULL,'Angelica Fuselier','FI','433390159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:37',0,'2014-03-02 05:59:43'),(4260,4260,'2014-01-01','ET','2',1,NULL,'Cheylon Woods','FI','621463379','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:08:08',0,'2014-03-02 03:09:49'),(5154,5154,'2014-01-01','ET','2',1,NULL,'EDWARD PELLSHAW','FI','302485408','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:56',0,'2014-03-10 15:45:56'),(12655,12655,'2014-01-01','ET','2',1,NULL,'VINCENT G HORNSBY','FI','439632924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:08',0,'2014-03-02 05:10:52'),(17501,18151,'0000-00-00','ET','2',1,NULL,'Leland McCullough','FI','466758598','Starmount Life Insurance Company','FI','720977315','Wesley J Watkins','94','4710431','357','2014-02-28','Sync Success',0,'2014-02-06 21:30:04',0,'2014-03-02 06:31:45'),(19030,19680,'0000-00-00','ET','2',2,1,'ELLEN ASHCRAFT','FI','288667053','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:03',0,'2014-03-01 17:34:07'),(21159,21809,'0000-00-00','ET','2',1,NULL,'wanda ashley','FI','464491155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:27',0,'2014-03-02 07:23:39'),(21174,21824,'0000-00-00','ET','2',2,1,'DEBRA BENNER','FI','298629653','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:38',0,'2014-03-10 14:45:25'),(7327,7327,'2014-01-01','ET','2',1,NULL,'joshua doughman','FI','276807533','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:33',0,'2014-03-10 13:32:15'),(5799,5799,'2014-01-01','ET','2',1,NULL,'LARA LEIGH LELEUX','FI','456477245','Starmount Life Insurance Company','FI','720977315','SHANON  WOOD','94','7960470','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:29',0,'2014-03-02 01:10:33'),(2848,2848,'2014-01-01','ET','2',1,NULL,'Kristy Cottle','FI','286760114','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:21:58',0,'2014-03-10 15:59:47'),(16638,17288,'0000-00-00','ET','2',1,NULL,'ELOUISE WILLIAMS','FI','439551790','Starmount Life Insurance Company','FI','720977315','MICHAEL   KIRSCHMAN','94','171145428','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:34',0,'2014-03-02 06:17:30'),(16017,16666,'0000-00-00','ET','2',2,1,'Kevin Nguyen','FI','564579672','Starmount Life Insurance Company','FI','720977315','Tony  Ly','94','7898204','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:21',0,'2014-03-02 06:03:21'),(11180,11180,'2014-01-01','ET','2',1,NULL,'Veronica Day','FI','279842908','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:58',0,'2014-03-10 13:45:57'),(11764,11764,'2014-01-01','ET','2',1,NULL,'Kristine Norris','FI','277601471','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:52',0,'2014-03-10 13:52:32'),(13687,14043,'2014-01-01','ET','2',1,NULL,'Samuel Street','FI','463895074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:32',0,'2014-03-02 05:24:45'),(13831,14187,'2014-01-01','ET','2',2,1,'Paul Lin','FI','012447630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:34',0,'2014-03-02 05:31:31'),(14654,15105,'2014-01-01','ET','2',1,NULL,'Robert Lowe','FI','300884122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:24',0,'2014-03-01 16:46:19'),(15370,15821,'0000-00-00','ET','2',1,NULL,'Mary L Traxler','FI','271602385','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:47:01',0,'2014-03-10 14:10:12'),(19032,19682,'0000-00-00','ET','2',1,NULL,'NANCY RUDISILL','FI','273684525','Dental Care Plus, Inc.','FI','311185262','Gwendolyn   Haven','94','11202931','348','2014-03-01','Sync Success',0,'2014-02-15 21:00:05',0,'2014-03-01 17:34:07'),(21564,22214,'0000-00-00','ET','2',3,2,'Delilah Montague','FI','295841346','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:41',0,'2014-03-10 14:45:25'),(22106,22756,'0000-00-00','ET','2',1,NULL,'ALLISON A STEELMAN','FI','466028868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:34',0,'2014-03-06 21:27:26'),(22228,22878,'0000-00-00','ET','2',1,NULL,'STEVEN ROGERS','FI','511649725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:00',0,'2014-03-06 21:27:26'),(16560,17210,'0000-00-00','ET','2',1,NULL,'Sandra Johnson','FI','272463561','Summa Insurance Company, Inc.','FI','341809108','Matt   Tharp','94','2779426','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:16',0,'2014-03-10 16:24:30'),(11173,11173,'2014-01-01','ET','2',1,NULL,'Anne Banks','FI','303044499','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:44',0,'2014-03-10 13:45:57'),(14897,15348,'2014-01-01','ET','2',2,1,'Amy Dannel','FI','437410908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:22',0,'2014-03-02 05:45:37'),(2993,2993,'2014-01-01','ET','2',1,NULL,'shane riley','FI','643095682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:55',0,'2014-03-02 01:10:33'),(14765,15216,'2014-01-01','ET','2',1,NULL,'Alexander Hill','FI','464883963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:36',0,'2014-03-02 05:45:37'),(13032,13388,'2014-01-01','ET','2',2,1,'Theresa Booker','FI','297828267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:26',0,'2014-03-01 16:35:14'),(12505,12505,'2014-01-01','ET','2',1,NULL,'CARRIE ROBIDEAUX','FI','439335634','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:33',0,'2014-03-02 05:03:29'),(4695,4695,'2014-01-01','ET','2',1,NULL,'Dennis J Galdamez','FI','461772678','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:29',0,'2014-03-02 04:38:08'),(17072,17722,'0000-00-00','ET','2',1,NULL,'Tyraniqua Payton','FI','434773885','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:42',0,'2014-03-02 06:24:38'),(17318,17968,'0000-00-00','ET','2',1,NULL,'Joseph Branch','FI','534942923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:05',0,'2014-03-02 06:24:38'),(21873,22523,'0000-00-00','ET','2',1,NULL,'Gerald Hetrick','FI','291641138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:23',0,'2014-03-05 21:36:22'),(263,263,'2014-01-01','ET','2',1,NULL,'Lindsey Tharpe','FI','436639588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 17:31:20',0,'2014-03-01 20:10:57'),(813,813,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 18:10:41',0,'2014-03-01 15:10:22'),(11367,11367,'2014-01-01','ET','2',1,NULL,'Nikita Castle','FI','438315643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:34',0,'2014-03-02 04:45:37'),(1476,1476,'2014-01-01','ET','2',1,NULL,'Remington  J Merry','FI','301821663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:40',0,'2014-03-01 16:23:43'),(2105,2105,'2014-01-01','ET','2',2,1,'Rick K Bayardi','FI','302524695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:02',0,'2014-03-01 15:16:37'),(3622,3622,'2014-01-01','ET','2',2,1,'Alfredo Medrano','FI','334646019','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:02',0,'2014-03-02 01:10:33'),(3001,3001,'2014-01-01','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:09',0,'2014-03-02 01:10:33'),(20169,20819,'0000-00-00','ET','2',1,NULL,'charles jones','FI','378783539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:08',0,'2014-03-01 18:08:07'),(15238,15689,'0000-00-00','ET','2',1,NULL,'thomas brown','FI','278748539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:19',0,'2014-03-01 16:50:53'),(2076,2076,'2014-01-01','ET','2',2,1,'Patsy Audino','FI','173364864','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:17',0,'2014-03-10 15:45:56'),(1487,1487,'2014-01-01','ET','2',1,NULL,'Deborah Gradomski','FI','263131323','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:58',0,'2014-03-10 16:03:49'),(21207,21857,'0000-00-00','ET','2',1,NULL,'Webb Wright','FI','454634086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:07',0,'2014-03-02 07:23:39'),(321,321,'2014-01-01','ET','2',3,2,'Margaret McRae-Gibson','FI','284624412','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:52',0,'2014-03-10 13:10:24'),(15186,15637,'0000-00-00','ET','2',1,NULL,'Shanna Hickle','FI','449271811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:16',0,'2014-03-02 05:52:31'),(12087,12087,'2014-01-01','ET','2',1,NULL,'Virgil Hannahs','FI','280847148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:18',0,'2014-03-01 16:30:17'),(11754,11754,'2014-01-01','ET','2',1,NULL,'SHENNA ANTOINETTE PARSON','FI','439635313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:34',0,'2014-03-02 04:59:36'),(4059,4059,'2014-01-01','ET','2',1,NULL,'Robert Lucero','FI','458778015','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:58',0,'2014-03-02 03:09:49'),(7082,7082,'2014-01-01','ET','2',1,NULL,'Jennifer Martin','FI','592280204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:05',0,'2014-03-01 15:52:44'),(2773,2773,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:19:27',0,'2014-03-01 16:05:34'),(3114,3114,'2014-01-01','ET','2',1,NULL,'Donald Zelasko','FI','293568040','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:36',0,'2014-03-10 15:52:36'),(19570,20220,'0000-00-00','ET','2',1,NULL,'Patricia Harris-Carr','FI','299421632','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:23:36',0,'2014-03-10 14:37:47'),(21467,22117,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:33',0,'2014-03-03 21:36:16'),(22990,23640,'0000-00-00','ET','2',1,NULL,'Amy Groya','FI','273901729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:44',0,'2014-03-10 21:36:25'),(16906,17556,'0000-00-00','ET','2',1,NULL,'Mark Dershimer','FI','291429072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:30',0,'2014-03-01 17:00:58'),(7350,7350,'2014-01-01','ET','2',1,NULL,'Linda McKee','FI','279528418','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:28',0,'2014-03-10 15:39:19'),(5371,5371,'2014-01-01','ET','2',1,NULL,'Toni Arnona','FI','437594305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:33',0,'2014-03-01 21:11:04'),(16538,17188,'0000-00-00','ET','2',1,NULL,'Janis Klunk','FI','280703625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-30 21:01:01',0,'2014-03-01 17:00:58'),(3821,3821,'2014-01-01','ET','2',1,NULL,'Hazel Emery','FI','382686257','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:05',0,'2014-03-10 15:45:56'),(14521,14972,'2014-01-01','ET','2',1,NULL,'mendelynn fisher','FI','301521156','HealthSpan','FI','311431434','alfred joseph patchin','94','7685243','348','2014-02-01','Sync Success',0,'2014-01-15 02:08:03',0,'2014-03-10 14:03:26'),(17823,18473,'0000-00-00','ET','2',1,NULL,'Elester Bingham','FI','438849806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:54',0,'2014-03-02 05:59:43'),(20132,20782,'0000-00-00','ET','2',1,NULL,'Lisa Marini','FI','273607141','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:30:43',0,'2014-03-01 18:08:07'),(21457,22107,'0000-00-00','ET','2',5,4,'victor mendoza','FI','349867308','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:24',0,'2014-03-03 21:36:16'),(16673,17323,'0000-00-00','ET','2',4,3,'Darshan Vyas','FI','566791396','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:57',0,'2014-03-01 17:00:58'),(1170,1170,'2014-01-01','ET','2',1,NULL,'WALTER LOURIE','FI','482667325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:49',0,'2014-03-02 04:38:08'),(12461,12461,'2014-01-01','ET','2',1,NULL,'James Ventura','FI','287622874','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:52',0,'2014-03-10 16:10:34'),(1829,1829,'2014-01-01','ET','2',2,1,'Pearline Shelton','FI','275603053','HealthSpan','FI','311431434','Michael  Bennett','94','8790924','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:31',0,'2014-03-10 13:20:27'),(7677,7677,'2014-01-01','ET','2',1,NULL,'Charles Warren','FI','271689421','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:44',0,'2014-03-10 13:39:10'),(11208,11208,'2014-01-01','ET','2',1,NULL,'Mary Koch','FI','277583977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:42',0,'2014-03-01 16:23:43'),(3884,3884,'2014-01-01','ET','2',1,0,'ALBERTA JONES','FI','280683950','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:39',0,'2014-03-10 15:39:19'),(17912,18562,'0000-00-00','ET','2',1,NULL,'Brandon Boyer','FI','459911900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:37',0,'2014-03-02 06:31:45'),(20335,20985,'0000-00-00','ET','2',1,NULL,'Sophia Loren Berry StVictor','FI','057608837','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:24',0,'2014-03-01 17:47:19'),(129,129,'2014-01-01','ET','2',1,NULL,'Melissa Escobar','FI','460714668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:01',0,'2014-03-01 23:10:52'),(11531,11531,'2014-01-01','ET','2',1,NULL,'Elden Domingo','FI','439358460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:33',0,'2014-03-02 04:52:44'),(13118,13474,'2014-01-01','ET','2',2,1,'David Penrod','FI','612038279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:39',0,'2014-03-02 05:17:40'),(2542,2542,'2014-01-01','ET','2',1,NULL,'Ann Robare','FI','297521966','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:17',0,'2014-03-01 15:10:22'),(5053,5053,'2014-01-01','ET','2',1,NULL,'Kevin Jackson','FI','284808401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:42',0,'2014-03-01 15:31:33'),(18760,19410,'0000-00-00','ET','2',2,1,'LESLIE GUZMAN','FI','450652957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:36',0,'2014-03-02 06:52:12'),(22492,23142,'0000-00-00','ET','2',1,NULL,'Richard A Moritz','FI','298624458','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:04',0,'2014-03-07 21:36:32'),(1307,1307,'2014-01-01','ET','2',1,NULL,'Eric Jensen','FI','216602795','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:03',0,'2014-03-02 04:38:08'),(2474,2474,'2014-01-01','ET','2',1,NULL,'Kevin Watt','FI','314502083','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:40',0,'2014-03-10 13:10:24'),(11114,11114,'2014-01-01','ET','2',1,NULL,'Amy Godwin','FI','293820408','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:34',0,'2014-03-10 13:45:57'),(3585,3585,'2014-01-01','ET','2',2,1,'Otto Q Sanchez','FI','462849326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:54',0,'2014-03-02 01:10:33'),(17335,17985,'0000-00-00','ET','2',2,1,'Rebecca Long','FI','279682577','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:14',0,'2014-03-10 14:24:38'),(14129,14580,'2014-01-01','ET','2',3,2,'richard  bratcher','FI','435907454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:54',0,'2014-03-02 05:38:34'),(12484,12484,'2014-01-01','ET','2',2,1,'Darren Armstrong','FI','633226634','Dental Care Plus, Inc.','FI','311185262','Susan  Fuller','94','3239014','348','2014-02-01','Sync Success',1,'2014-01-02 04:32:42',0,'2014-03-01 16:35:14'),(18817,19467,'0000-00-00','ET','2',2,1,'Dharmesh Bhakta','FI','783825814','Starmount Life Insurance Company','FI','720977315','Jimmy  Patterson','94','1195016','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:02',0,'2014-03-02 06:52:12'),(19646,20296,'0000-00-00','ET','2',4,3,'Vincent A Dugan','FI','196428448','Dental Care Plus, Inc.','FI','311185262','Ryan  Mulligan','94','8789743','348','2014-04-01','Sync Success',0,'2014-02-20 04:42:27',0,'2014-03-01 17:47:19'),(19707,20357,'0000-00-00','ET','2',1,NULL,'Jennifer Minnich','FI','277847370','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','357','2014-03-01','Sync Success',0,'2014-02-20 04:56:21',0,'2014-03-10 14:37:47'),(10446,10446,'2014-01-01','ET','2',1,NULL,'Lauren Dalton','FI','302905197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:10',0,'2014-03-01 16:10:36'),(15155,15606,'0000-00-00','ET','2',2,1,'Robin Mcwhorter','FI','276744651','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:30',0,'2014-03-10 14:10:12'),(4504,4504,'2014-01-01','ET','2',1,NULL,'EUGENE EDWARD HOWARD','FI','428811584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:12',0,'2014-03-01 21:11:04'),(730,730,'2014-01-01','ET','2',1,NULL,'JB EDWARDS','FI','587440665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:45',0,'2014-03-02 02:10:49'),(4576,4576,'2014-01-01','ET','2',1,NULL,'denna ann craig','FI','311721690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:31',0,'2014-03-01 16:15:39'),(1659,1659,'2014-01-01','ET','2',1,NULL,'EDDI STRAUSS','FI','051475112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:13',0,'2014-03-10 15:45:56'),(19111,19761,'0000-00-00','ET','2',1,NULL,'Ashley Siek','94','0000403706','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:51',0,'2014-03-10 14:31:05'),(20045,20695,'0000-00-00','ET','2',1,NULL,'Shannon Neal','FI','284769659','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-22 19:00:15',0,'2014-03-10 14:37:47'),(20179,20829,'0000-00-00','ET','2',2,1,'YOUNG GI HONG','FI','640847661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:15',0,'2014-03-02 07:10:28'),(20288,20938,'0000-00-00','ET','2',4,3,'Daniel Hirn','FI','302820358','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:32',0,'2014-03-10 14:37:47'),(21366,22016,'0000-00-00','ET','2',2,1,'IONEL GHIRONTE','FI','453735698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:33',0,'2014-03-03 01:07:25'),(23076,23726,'0000-00-00','ET','2',1,NULL,'Kathy Y Gawrych','FI','289441964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:48',0,'2014-03-10 21:17:52'),(16010,16659,'0000-00-00','ET','2',1,NULL,'Gracie Montes','FI','628108131','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:17',0,'2014-03-02 06:03:21'),(13525,13881,'2014-01-01','ET','2',1,NULL,'Donna Huber','FI','302523457','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:33',0,'2014-03-01 16:40:16'),(11267,11267,'2014-01-01','ET','2',1,NULL,'TYLENE GRAY','FI','434572128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:30',0,'2014-03-02 04:45:37'),(1927,1927,'2014-01-01','ET','2',1,NULL,'John Yurcik','FI','278501615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:32:33',0,'2014-03-01 15:26:40'),(12784,12784,'2014-01-01','ET','2',1,NULL,'ISELA LEDESMA','FI','464852050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:41',0,'2014-03-02 05:10:52'),(6274,6274,'2014-01-01','ET','2',1,NULL,'Trudy Williams','FI','433804674','Starmount Life Insurance Company','FI','720977315','James Stanton Hazlip','94','17097288','348','2014-01-01','Sync Success',0,'2013-12-26 03:06:40',0,'2014-03-02 04:10:25'),(7700,7700,'2014-01-01','ET','2',1,NULL,'Nicholas Morris','FI','286846246','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:29',0,'2014-03-01 15:10:22'),(3331,3331,'2014-01-01','ET','2',1,NULL,'Beth Tigelman','FI','284521282','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:33',0,'2014-03-10 15:52:36'),(18450,19100,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:38',0,'2014-03-10 16:31:33'),(20315,20965,'0000-00-00','ET','2',1,NULL,'khaled atallah','FI','645509985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:04',0,'2014-03-02 07:03:25'),(20677,21327,'0000-00-00','ET','2',2,1,'RODNEY URTON','FI','298762699','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:46',0,'2014-03-10 14:37:47'),(22787,23437,'0000-00-00','ET','2',1,NULL,'Jackie Slay','FI','272680965','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:39',0,'2014-03-10 14:50:59'),(12480,12480,'2014-01-01','ET','2',1,NULL,'RANDALL PATRICK ARLEDGE','FI','293623667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:30',0,'2014-03-01 16:30:17'),(939,939,'2014-01-01','ET','2',1,NULL,'paula paul','FI','436436402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:19',0,'2014-03-01 22:10:55'),(5258,5258,'2014-01-01','ET','2',1,NULL,'ANGELA GILBERT','FI','289047677','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:19',0,'2014-03-10 13:20:27'),(4935,4935,'2014-01-01','ET','2',1,NULL,'Pamela Riley','FI','276522647','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:18',0,'2014-03-01 15:10:22'),(21248,21898,'0000-00-00','ET','2',1,NULL,'Joann M Nichpor','FI','290520656','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:29',0,'2014-03-10 14:45:25'),(19896,20546,'0000-00-00','ET','2',1,NULL,'CONCION LOPEZ','FI','548917705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:03',0,'2014-03-02 07:03:25'),(20583,21233,'0000-00-00','ET','2',1,NULL,'GABRIEL DENIGRIS','FI','278665748','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-26 21:01:38',0,'2014-03-01 18:08:07'),(21021,21671,'0000-00-00','ET','2',5,4,'BRETT PODOLL','FI','188608465','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-03-01','Sync Success',0,'2014-02-28 21:00:14',0,'2014-03-10 16:38:05'),(22537,23187,'0000-00-00','ET','2',1,NULL,'laura colson','94','0000345641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:37',0,'2014-03-07 21:36:32'),(12737,12737,'2014-01-01','ET','2',1,NULL,'Tina Hubert','FI','404861162','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:12',0,'2014-03-10 13:59:38'),(954,954,'2014-01-01','ET','2',2,1,'LINDA BERGERON LANDRY','FI','437080125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:46',0,'2014-03-01 22:10:55'),(11341,11341,'2014-01-01','ET','2',1,NULL,'kim nguyen','FI','627262436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:46',0,'2014-03-02 04:52:44'),(3439,3439,'2014-01-01','ET','2',1,NULL,'JAMES GOULD','FI','278568964','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:52:58',0,'2014-03-10 13:24:34'),(6225,6225,'2014-01-01','ET','2',1,NULL,'amber henderson','FI','285881843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:06',0,'2014-03-01 16:00:27'),(6118,6118,'2014-01-01','ET','2',1,NULL,'Barbara Berry','FI','275541055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:50',0,'2014-03-01 16:00:27'),(17839,18489,'0000-00-00','ET','2',1,NULL,'Laura Buchholz','FI','214822889','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','348','2014-03-01','Sync Success',0,'2014-02-10 11:01:06',0,'2014-03-10 14:20:26'),(17937,18587,'0000-00-00','ET','2',1,NULL,'Harry Granoff','FI','061443497','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','357','2014-03-01','Sync Success',0,'2014-02-10 21:30:54',0,'2014-03-02 06:38:05'),(19091,19741,'0000-00-00','ET','2',1,NULL,'Jean Shredl','FI','289541274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:37',0,'2014-03-01 17:34:07'),(19483,20133,'0000-00-00','ET','2',1,NULL,'MARIE SMITH','FI','438923024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:58:56',0,'2014-03-02 06:59:07'),(20962,21612,'0000-00-00','ET','2',1,NULL,'GAYLENE SIGMAN','FI','270763238','Dental Care Plus, Inc.','FI','311185262','RICK C MCCLELLAND','94','2444519','348','2014-04-01','Sync Success',0,'2014-02-28 07:30:14',0,'2014-03-01 18:08:07'),(22571,23221,'0000-00-00','ET','2',1,NULL,'Jaiden Saddler','94','0000870687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:00',0,'2014-03-07 21:36:32'),(226,226,'2014-01-01','ET','2',1,0,'Leslie Mcdaniel','FI','457955870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:06',0,'2014-03-01 19:11:03'),(12052,12052,'2014-01-01','ET','2',2,1,'Penny Burns','FI','464110747','Starmount Life Insurance Company','FI','720977315','Michael  Dougherty','94','113160','348','2014-02-01','Sync Success',0,'2014-01-01 12:04:04',0,'2014-03-02 04:59:36'),(7406,7406,'2014-01-01','ET','2',2,1,'Syed Abbas','FI','433550983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:03',0,'2014-03-02 04:10:25'),(5983,5983,'2014-01-01','ET','2',1,NULL,'Cynthia Richardson','FI','280829594','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:26',0,'2014-03-10 13:24:34'),(5906,5906,'2014-01-01','ET','2',1,NULL,'JOHN MARTIN','FI','409882144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:59',0,'2014-03-02 01:10:33'),(10445,10445,'2014-01-01','ET','2',2,1,'sharon louis','FI','179441346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:08',0,'2014-03-01 16:10:36'),(7632,7632,'2014-01-01','ET','2',1,NULL,'Frances Richards','FI','296501947','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:17',0,'2014-03-10 15:59:47'),(7538,7538,'2014-01-01','ET','2',4,3,'Kimberly Shimpo','FI','444686439','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:13',0,'2014-03-01 16:05:34'),(14395,14846,'2014-01-01','ET','2',3,2,'Susan Ward','FI','294829689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:05',0,'2014-03-01 16:46:19'),(13266,13622,'2014-01-01','ET','2',1,NULL,'Pamela Bruhnke','FI','023463411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:58',0,'2014-03-02 05:24:45'),(2280,2280,'2014-01-01','ET','2',2,1,'David Heil','FI','278548743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:30',0,'2014-03-01 15:10:22'),(5020,5020,'2014-01-01','ET','2',1,NULL,'Courtney L Karadeniz','FI','275802257','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:46:36',0,'2014-03-01 15:31:33'),(17292,17942,'0000-00-00','ET','2',1,NULL,'Joseph Johnson','FI','438292453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:51',0,'2014-03-02 06:24:38'),(15802,16451,'0000-00-00','ET','2',1,NULL,'Christina K Wreyford','FI','639785749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:13',0,'2014-03-02 06:03:21'),(4486,4486,'2014-01-01','ET','2',1,NULL,'Michael S Baldwin','FI','302883796','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:38',0,'2014-03-10 15:39:19'),(2863,2863,'2014-01-01','ET','2',1,NULL,'Paula Oberhauser','FI','271526764','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:25',0,'2014-03-10 13:39:10'),(4230,4230,'2014-01-01','ET','2',1,NULL,'esther newell','FI','277542256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:09',0,'2014-03-01 16:00:27'),(3569,3569,'2014-01-01','ET','2',1,NULL,'amy anderson','FI','440847801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:24',0,'2014-03-02 00:10:48'),(11643,11643,'2014-01-01','ET','2',1,NULL,'David W Williams','FI','277880857','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:02',0,'2014-03-10 16:03:49'),(19758,20408,'0000-00-00','ET','2',1,NULL,'deborah witt','FI','286629709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:12',0,'2014-03-10 16:38:05'),(20949,21599,'0000-00-00','ET','2',1,NULL,'Shelley Anderson','FI','467539325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:03',0,'2014-03-02 07:17:36'),(12793,12793,'2014-01-01','ET','2',1,NULL,'Monica Stots','FI','467350697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:00',0,'2014-03-02 05:10:52'),(12703,12703,'2014-01-01','ET','2',1,NULL,'JAMES EDWARD BROWN','FI','428714433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:54',0,'2014-03-02 05:10:52'),(3589,3589,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:04:02',0,'2014-03-02 01:10:33'),(1917,1917,'2014-01-01','ET','2',1,NULL,'Teresa Hilburn','FI','450331888','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-25 19:32:15',0,'2014-03-01 23:10:52'),(11330,11330,'2014-01-01','ET','2',1,NULL,'james arnold','FI','454238704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:25',0,'2014-03-02 04:52:44'),(19703,20353,'0000-00-00','ET','2',1,NULL,'Camaree Stevens','FI','269761538','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-04-01','Sync Success',0,'2014-02-20 04:55:40',0,'2014-03-10 14:37:47'),(21792,22442,'0000-00-00','ET','2',1,NULL,'Delila Lisa Davila','FI','641010797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:11',0,'2014-03-04 22:25:23'),(22604,23254,'0000-00-00','ET','2',1,NULL,'Linda Meade','FI','283543382','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:32:26',0,'2014-03-10 14:50:59'),(12734,12734,'2014-01-01','ET','2',1,NULL,'Mary Bolan','FI','268220965','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:06',0,'2014-03-10 13:59:38'),(10896,10896,'2014-01-01','ET','2',1,NULL,'Aria Monette Mason','FI','436533253','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:30',0,'2014-03-02 04:24:47'),(11434,11434,'2014-01-01','ET','2',1,NULL,'Todd Vanatta','FI','282663682','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2013-12-27 02:07:40',0,'2014-03-10 13:52:32'),(17430,18080,'0000-00-00','ET','2',1,NULL,'jeremy warren','FI','449516684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:02',0,'2014-03-02 06:31:45'),(149,149,'2014-01-01','ET','2',1,NULL,'SILVIA E KEARNEY','FI','296962551','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:19:39',0,'2014-03-10 15:45:56'),(16565,17215,'0000-00-00','ET','2',1,NULL,'LAURA SCHEDLER','FI','287447717','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:19',0,'2014-03-10 16:24:30'),(856,856,'2014-01-01','ET','2',2,1,'TOM  PETERS','FI','503629767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:49',0,'2014-03-01 22:10:55'),(15765,16414,'0000-00-00','ET','2',2,1,'David Richardson','FI','288608824','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:31',0,'2014-03-10 14:10:12'),(7047,7047,'2014-01-01','ET','2',2,1,'MICHELLE VARGAS','FI','628122290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:56',0,'2014-03-02 03:09:49'),(14682,15133,'2014-01-01','ET','2',1,NULL,'Anthony Commarata','FI','290489457','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3345388','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:42',0,'2014-03-01 16:46:19'),(13305,13661,'2014-01-01','ET','2',1,NULL,'Rose Holbrook','FI','286822029','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:14',0,'2014-03-01 16:40:16'),(4104,4104,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:21',0,'2014-03-01 16:00:27'),(3348,3348,'2014-01-01','ET','2',1,NULL,'Alexandria Michelle Munoz','FI','627323695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:08',0,'2014-03-02 02:10:49'),(17826,18476,'0000-00-00','ET','2',1,NULL,'Aaron Damon Porter','FI','569970204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:56',0,'2014-03-02 06:17:30'),(18536,19186,'0000-00-00','ET','2',1,NULL,'CHARLOTTE BEVLY','FI','298485031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:05',0,'2014-03-01 17:26:36'),(21864,22514,'0000-00-00','ET','2',1,NULL,'HAROLD HOLTZ','FI','286563747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:17',0,'2014-03-05 21:36:22'),(11261,11261,'2014-01-01','ET','2',2,1,'Ernest G Morris','FI','439942279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:19',0,'2014-03-02 04:45:37'),(16809,17459,'0000-00-00','ET','2',1,NULL,'Kirk Shelton','FI','287806892','Summa Insurance Company, Inc.','FI','341809108','Rhonda Kay Jackson','94','1101549300','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:48',0,'2014-03-10 16:24:30'),(3697,3697,'2014-01-01','ET','2',2,1,'taher toom','FI','065726847','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:26',0,'2014-03-02 00:10:48'),(15652,16301,'0000-00-00','ET','2',1,NULL,'Gregory Mealka','FI','293645432','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:13',0,'2014-03-01 16:56:22'),(16812,17462,'0000-00-00','ET','2',1,NULL,'Bonnie Austin','FI','453676584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:51',0,'2014-03-02 06:17:30'),(473,473,'2014-01-01','ET','2',1,NULL,'Diane Kinner','FI','287447683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:46',0,'2014-03-10 13:10:24'),(7224,7224,'2014-01-01','ET','2',1,NULL,'Jerry Barlow','FI','301547929','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:22',0,'2014-03-01 15:52:44'),(15945,16594,'0000-00-00','ET','2',1,NULL,'Brandon Thomas','FI','438737018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:19',0,'2014-03-02 06:03:21'),(13783,14139,'2014-01-01','ET','2',1,NULL,'AUGUSTA WILSON','FI','276485542','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:35',0,'2014-03-10 13:59:38'),(4505,4505,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:14',0,'2014-03-10 13:03:33'),(13341,13697,'2014-01-01','ET','2',2,1,'David Meek','FI','232215634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:28',0,'2014-03-01 16:40:16'),(2554,2554,'2014-01-01','ET','2',1,NULL,'John Favaloro','FI','439394897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:41',0,'2014-03-01 20:10:57'),(12100,12100,'2014-01-01','ET','2',1,NULL,'MARTIN WILLIS','FI','298742774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:42',0,'2014-03-01 16:30:17'),(20038,20688,'0000-00-00','ET','2',1,NULL,'Kelli Funtulis','FI','292929578','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:12',0,'2014-03-01 17:47:19'),(20441,21091,'0000-00-00','ET','2',1,NULL,'JAMES MONTGOMERY','FI','435083405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:58',0,'2014-03-02 07:10:28'),(20841,21491,'0000-00-00','ET','2',1,NULL,'Stacie Suzette Crocker','FI','438678935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:17',0,'2014-03-02 07:17:36'),(20871,21521,'0000-00-00','ET','2',1,NULL,'ANTOINETTE GROMER','FI','452536292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:31',0,'2014-03-02 07:17:36'),(22811,23461,'0000-00-00','ET','2',1,NULL,'Larry Rodriguiez','FI','291642958','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:01',0,'2014-03-10 14:50:59'),(516,516,'2014-01-01','ET','2',1,NULL,'Edward Freeman','FI','281465082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:00:57',0,'2014-03-01 15:48:04'),(10678,10678,'2014-01-01','ET','2',1,NULL,'JASON MEEKER','FI','285866602','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:41',0,'2014-03-01 16:10:36'),(16840,17490,'0000-00-00','ET','2',1,NULL,'Michael Key','FI','253652393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-02 19:00:18',0,'2014-03-01 17:00:58'),(2564,2564,'2014-01-01','ET','2',1,NULL,'clementine olowu-briggs','FI','587242140','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:03',0,'2014-03-10 13:03:33'),(4882,4882,'2014-01-01','ET','2',1,NULL,'alicia laughlin','FI','587430248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:41',0,'2014-03-01 20:10:57'),(13612,13968,'2014-01-01','ET','2',1,NULL,'Andrew Jason Singer','FI','296846535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:34',0,'2014-03-01 16:40:16'),(3481,3481,'2014-01-01','ET','2',1,NULL,'Tara Brown','FI','274862699','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:35',0,'2014-03-01 15:37:30'),(12320,12320,'2014-01-01','ET','2',1,NULL,'SHEILAHE BROWN','FI','465472164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:48',0,'2014-03-02 05:03:29'),(19225,19875,'0000-00-00','ET','2',1,NULL,'Adam Keller','FI','033700084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:21',0,'2014-03-02 06:52:12'),(22932,23582,'0000-00-00','ET','2',1,NULL,'Natalie DeKeyzer','FI','438751597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:05',0,'2014-03-10 21:27:11'),(16005,16654,'0000-00-00','ET','2',1,NULL,'Erin Nicely','FI','630162201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:14',0,'2014-03-02 06:03:21'),(5705,5705,'2014-01-01','ET','2',1,NULL,'catherine anne burke','FI','437453822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:37',0,'2014-03-02 01:10:33'),(7383,7383,'2014-01-01','ET','2',1,NULL,'LaDonna Jones','FI','433453544','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:15',0,'2014-03-02 04:15:49'),(1552,1552,'2014-01-01','ET','2',2,1,'Heather Murray','FI','282788441','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:01',0,'2014-03-10 13:52:32'),(1697,1697,'2014-01-01','ET','2',1,NULL,'Scott Bodie','FI','431473091','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:24',0,'2014-03-02 00:10:48'),(3629,3629,'2014-01-01','ET','2',1,NULL,'Joe Lordi','FI','295868336','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:16',0,'2014-03-10 15:52:36'),(11102,11102,'2014-01-01','ET','2',2,1,'David Gilbert','FI','290445530','HealthSpan','FI','311431434','Mary Kay  Lodge','94','11976263','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:11',0,'2014-03-10 13:45:57'),(2304,2304,'2014-01-01','ET','2',1,NULL,'Barbara Barnes','FI','286507492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:21',0,'2014-03-01 15:05:09'),(1179,1179,'2014-01-01','ET','2',1,NULL,'Hayley Sampson','FI','523759624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:07',0,'2014-03-02 04:38:08'),(16270,16920,'0000-00-00','ET','2',1,NULL,'JESSE ANN KNIGHTEN','FI','545888423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:04',0,'2014-03-02 06:10:30'),(11551,11551,'2014-01-01','ET','2',1,NULL,'tracy doll','FI','459210626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:11',0,'2014-03-02 04:52:44'),(11318,11318,'2014-01-01','ET','2',1,NULL,'Brenda Riffey','FI','452907172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:02',0,'2014-03-02 04:52:44'),(2795,2795,'2014-01-01','ET','2',1,NULL,'Teresa Rivers','FI','367601756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:11',0,'2014-03-01 16:05:34'),(15621,16072,'0000-00-00','ET','2',1,NULL,'JOHN SCHRAMM','FI','298483657','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:46',0,'2014-03-10 16:17:47'),(5192,5192,'2014-01-01','ET','2',2,1,'RICHARD LAHAYE','FI','545338586','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:06',0,'2014-03-02 00:10:48'),(12948,12948,'2014-01-01','ET','2',1,NULL,'SARAH GRUBBS','FI','437855578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:15',0,'2014-03-02 05:17:40'),(3832,3832,'2014-01-01','ET','2',1,NULL,'Molly Sotherden','FI','120625841','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:03',0,'2014-03-10 15:39:19'),(4056,4056,'2014-01-01','ET','2',2,1,'Jimmy Schoonover','FI','455131842','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:52',0,'2014-03-02 04:10:25'),(4090,4090,'2014-01-01','ET','2',1,NULL,'Jennifer Martin','FI','592280204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:00',0,'2014-03-01 16:00:27'),(12623,12623,'2014-01-01','ET','2',1,NULL,'loveda taylor','FI','550083372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:54',0,'2014-03-02 05:10:52'),(20981,21631,'0000-00-00','ET','2',4,3,'david bretheim','FI','426391320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:26',0,'2014-03-02 07:17:36'),(16963,17613,'0000-00-00','ET','2',1,NULL,'Shannon Stegall','FI','279887763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-03 21:01:07',0,'2014-03-01 17:00:58'),(11260,11260,'2014-01-01','ET','2',1,NULL,'Derek Johnson','FI','436410309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:17',0,'2014-03-02 04:45:37'),(591,591,'2014-01-01','ET','2',2,1,'Katherine Smith','FI','279744946','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:18',0,'2014-03-10 13:24:34'),(1471,1471,'2014-01-01','ET','2',2,1,'Bernice Tigrett','FI','292782180','Dental Care Plus, Inc.','FI','311185262','MARIE  ZUNIGA','94','1519795','348','2014-01-01','Sync Success',0,'2013-12-25 18:56:29',0,'2014-03-01 16:23:43'),(5582,5582,'2014-01-01','ET','2',1,NULL,'Alexander Walker','FI','645123616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:04',0,'2014-03-02 04:45:37'),(2964,2964,'2014-01-01','ET','2',1,NULL,'susan wygum','FI','293447380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:02',0,'2014-03-01 15:37:30'),(11795,11795,'2014-01-01','ET','2',1,NULL,'Robert Saldana','FI','454411859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:58',0,'2014-03-02 04:31:46'),(3416,3416,'2014-01-01','ET','2',1,NULL,'Roosevelt Cross','FI','587326850','Starmount Life Insurance Company','FI','720977315','Martha  Simpson','94','7023623','348','2014-01-01','Sync Success',0,'2013-12-25 21:52:13',0,'2014-03-02 02:10:49'),(4026,4026,'2014-01-01','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:00:55',0,'2014-03-02 03:09:49'),(4298,4298,'2014-01-01','ET','2',1,NULL,'Divante Morton','FI','282986831','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:09:15',0,'2014-03-10 13:32:15'),(11580,11580,'2014-01-01','ET','2',1,NULL,'Dora A Ramirez De Finley','FI','446084369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:07',0,'2014-03-02 04:52:44'),(22257,22907,'0000-00-00','ET','2',1,NULL,'Berniel Grove','FI','565688115','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:21',0,'2014-03-10 16:44:18'),(16938,17588,'0000-00-00','ET','2',2,1,'JACQUELYN STEPHENS','FI','438533731','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:50',0,'2014-03-02 06:24:38'),(598,598,'2014-01-01','ET','2',1,NULL,'Jana Wilkerson','FI','456419856','Starmount Life Insurance Company','FI','720977315','lee  McCasland','94','1091021','348','2014-01-01','Sync Success',0,'2013-12-25 18:03:31',0,'2014-03-02 02:10:49'),(776,776,'2014-01-01','ET','2',2,1,'william means','FI','407179416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:15',0,'2014-03-01 15:05:09'),(15069,15520,'2014-01-01','ET','2',1,NULL,'Tanya V Anderson','FI','299588256','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:40',0,'2014-03-10 14:10:12'),(7536,7536,'2014-01-01','ET','2',1,NULL,'LAURA MAZAR','FI','217703646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:35:10',0,'2014-03-01 16:05:34'),(2013,2013,'2014-01-01','ET','2',1,NULL,'DAMON COLBY PRESLEY','FI','434770756','Starmount Life Insurance Company','FI','720977315','WILLIAM  ROSE','94','8446776','348','2014-01-01','Sync Success',0,'2013-12-25 19:35:17',0,'2014-03-01 23:10:52'),(7437,7437,'2014-01-01','ET','2',1,NULL,'Lauren Hamlin','FI','436490312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:02',0,'2014-03-02 04:15:49'),(5536,5536,'2014-01-01','ET','2',1,NULL,'James Vorwerck','FI','289488925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:34',0,'2014-03-01 16:23:43'),(12866,12866,'2014-01-01','ET','2',1,NULL,'Gerald Thorton','FI','285543298','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:38',0,'2014-03-01 16:35:14'),(4266,4266,'2014-01-01','ET','2',1,NULL,'IVY PERRY','FI','547152298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:18',0,'2014-03-02 03:09:49'),(12777,12777,'2014-01-01','ET','2',2,1,'BETH EGGERS','FI','284843438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:23',0,'2014-03-01 16:35:14'),(12209,12209,'2014-01-01','ET','2',1,NULL,'Angela Keith','FI','290847198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:50',0,'2014-03-01 16:35:14'),(5125,5125,'2014-01-01','ET','2',2,1,'Deborah Slayton','FI','285642650','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:03',0,'2014-03-10 15:45:56'),(11714,11714,'2014-01-01','ET','2',1,NULL,'Kima Lucille Richard','FI','436597863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:20',0,'2014-03-02 04:59:36'),(20566,21216,'0000-00-00','ET','2',1,NULL,'TITO CESAR ZENBEJAS','FI','603038396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:28',0,'2014-03-02 07:17:36'),(22770,23420,'0000-00-00','ET','2',1,NULL,'Jose Perez Guerra','FI','768961021','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:25',0,'2014-03-09 21:26:00'),(10948,10948,'2014-01-01','ET','2',1,NULL,'Traci James','FI','285581470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:09',0,'2014-03-10 16:03:49'),(998,998,'2014-01-01','ET','2',1,NULL,'Dianna Hornstein','FI','274568039','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:13',0,'2014-03-10 13:10:24'),(7690,7690,'2014-01-01','ET','2',2,1,'Diep Quang','FI','487021682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:06',0,'2014-03-01 20:10:57'),(15469,15920,'0000-00-00','ET','2',1,NULL,'Bhalinder Singh Chahal','FI','271176838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:53',0,'2014-03-01 16:50:53'),(4599,4599,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','348','2014-01-01','Sync Success',0,'2013-12-25 23:47:15',0,'2014-03-01 16:15:39'),(14661,15112,'2014-01-01','ET','2',3,2,'wanda abou-osman','FI','385707741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:28',0,'2014-03-01 16:46:19'),(12843,12843,'2014-01-01','ET','2',1,NULL,'Christopher Cook','FI','453952113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:48',0,'2014-03-02 05:10:52'),(13676,14032,'2014-01-01','ET','2',1,NULL,'VERONICA MARTINEZ','FI','455656665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:26',0,'2014-03-02 05:24:45'),(19360,20010,'0000-00-00','ET','2',1,NULL,'GAYATRI BHATT','FI','283741869','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:40',0,'2014-03-02 06:59:07'),(20883,21533,'0000-00-00','ET','2',1,NULL,'BRITTANY REED','FI','425699811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:37',0,'2014-03-02 07:17:36'),(22923,23573,'0000-00-00','ET','2',1,NULL,'QUANG VIET TRAN','FI','433890821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:58',0,'2014-03-10 21:27:11'),(23083,23733,'0000-00-00','ET','2',1,NULL,'JERRY GILLESPIE','FI','275602396','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:54',0,'2014-03-10 21:17:52'),(16713,17363,'0000-00-00','ET','2',1,NULL,'KEVIN CRONIN','FI','364560965','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:01:26',0,'2014-03-01 17:00:58'),(15543,15994,'0000-00-00','ET','2',1,NULL,'Susan Klein','FI','298482000','Summa Insurance Company, Inc.','FI','341809108','Carl  Lishing','94','2095192','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:10',0,'2014-03-10 16:17:47'),(2012,2012,'2014-01-01','ET','2',1,NULL,'Dora Phillips','FI','439849418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:15',0,'2014-03-01 23:10:52'),(11524,11524,'2014-01-01','ET','2',1,NULL,'GAIL MARIE GABRIEL','FI','438028636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:23',0,'2014-03-02 04:52:44'),(14495,14946,'2014-01-01','ET','2',1,NULL,'Karen Hollis','FI','433027816','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:50',0,'2014-03-02 05:45:37'),(12236,12236,'2014-01-01','ET','2',1,NULL,'Daniel Coleman','FI','436699547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:53',0,'2014-03-02 05:10:52'),(4790,4790,'2014-01-01','ET','2',1,NULL,'Michael Teggart','FI','292606131','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:35',0,'2014-03-01 15:16:37'),(18540,19190,'0000-00-00','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:07',0,'2014-03-10 16:31:33'),(19381,20031,'0000-00-00','ET','2',1,NULL,'Kathleen A Lowen','FI','297545896','Dental Care Plus, Inc.','FI','311185262','Maureen  Fowler','94','8188952','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:54',0,'2014-03-01 17:34:07'),(10592,10592,'2014-01-01','ET','2',1,NULL,'jeffrey williams','FI','453753228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:53',0,'2014-03-02 04:24:47'),(16377,17027,'0000-00-00','ET','2',1,NULL,'ABRAHAM J ZABACK','FI','114502808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:11',0,'2014-03-02 06:10:30'),(11650,11650,'2014-01-01','ET','2',1,NULL,'Shawn Gormley','FI','273726244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:17',0,'2014-03-01 16:30:17'),(4327,4327,'2014-01-01','ET','2',2,1,'ALEXANDER SPIVAK','FI','288920012','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:03',0,'2014-03-10 13:32:15'),(2190,2190,'2014-01-01','ET','2',1,NULL,'BRITTANY N BLAIR-SIMS','FI','459974821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:49',0,'2014-03-01 21:11:04'),(2221,2221,'2014-01-01','ET','2',1,NULL,'kevin heath','FI','298542487','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:52',0,'2014-03-10 15:39:19'),(4496,4496,'2014-01-01','ET','2',1,NULL,'Ryan Ramage','FI','277826408','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:56',0,'2014-03-10 15:39:19'),(5918,5918,'2014-01-01','ET','2',2,1,'Mark Orecchio','FI','275709763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:21',0,'2014-03-01 15:48:04'),(19079,19729,'0000-00-00','ET','2',1,NULL,'Peter Gorey','FI','436980314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:29',0,'2014-03-02 06:52:12'),(21938,22588,'0000-00-00','ET','2',3,2,'Timothy Zemenski','94','0000211062','HealthSpan','FI','311431434','Walter  Nelson','94','16462268','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:10',0,'2014-03-10 14:45:25'),(22926,23576,'0000-00-00','ET','2',1,NULL,'NATHANIEL PRESTON BENNETT','FI','434537672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:00',0,'2014-03-10 21:27:11'),(12230,12230,'2014-01-01','ET','2',1,NULL,'Shenae Gabrielle Morris','FI','435738947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:39',0,'2014-03-02 05:03:29'),(6113,6113,'2014-01-01','ET','2',1,NULL,'Edward Adams','FI','281660730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:01:42',0,'2014-03-01 16:00:27'),(11918,11918,'2014-01-01','ET','2',1,NULL,'Eric Intihar','FI','294889632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:34',0,'2014-03-01 16:30:17'),(1997,1997,'2014-01-01','ET','2',2,1,'GERALD BLACK','FI','525231522','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:45',0,'2014-03-01 23:10:52'),(2693,2693,'2014-01-01','ET','2',2,1,'Kenneth Reeise','FI','512946799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:57',0,'2014-03-02 04:15:49'),(17395,18045,'0000-00-00','ET','2',2,1,'William Loomis','FI','224118600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:38',0,'2014-03-01 17:20:55'),(18486,19136,'0000-00-00','ET','2',1,NULL,'CURTIS  AUSTIN','FI','410318466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:00',0,'2014-03-02 06:45:14'),(11184,11184,'2014-01-01','ET','2',1,NULL,'matt landock','FI','298724458','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:17:06',0,'2014-03-10 13:45:57'),(456,456,'2014-01-01','ET','2',1,NULL,'DELVIN HOWARD','FI','437710910','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:09',0,'2014-03-01 22:10:55'),(10934,10934,'2014-01-01','ET','2',1,NULL,'joseph seme','FI','300446369','Summa Insurance Company, Inc.','FI','341809108','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-26 13:08:45',0,'2014-03-10 16:03:49'),(21473,22123,'0000-00-00','ET','2',1,NULL,'tina howard','FI','268821628','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:37',0,'2014-03-10 14:45:25'),(21763,22413,'0000-00-00','ET','2',3,2,'Sandeep Gupta','FI','277827610','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:31',0,'2014-03-10 14:45:25'),(22389,23039,'0000-00-00','ET','2',1,NULL,'Paul Morris','FI','282806696','HealthSpan','FI','311431434','Thomas  Simyak','94','13275609','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:30',0,'2014-03-10 14:50:59'),(983,983,'2014-01-01','ET','2',1,NULL,'loretta heck','FI','288642410','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:41',0,'2014-03-01 15:21:15'),(1642,1642,'2014-01-01','ET','2',1,NULL,'BONNIE SUE BARNETT','FI','302440484','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:15',0,'2014-03-10 13:03:33'),(12942,12942,'2014-01-01','ET','2',1,NULL,'Hunter A Toups','FI','433794611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:02',0,'2014-03-02 05:17:40'),(6424,6424,'2014-01-01','ET','2',1,NULL,'lutushia lynn cecil','FI','273521500','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:17',0,'2014-03-01 15:10:22'),(5934,5934,'2014-01-01','ET','2',1,NULL,'Matthew Sanders','FI','296905144','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:52',0,'2014-03-01 15:48:04'),(19528,20178,'0000-00-00','ET','2',1,NULL,'Lisa Smith','FI','278828586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:12:07',0,'2014-03-01 17:47:19'),(14667,15118,'2014-01-01','ET','2',1,NULL,'Raymond Weisel','FI','269843030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:45:32',0,'2014-03-01 16:46:19'),(14557,15008,'2014-01-01','ET','2',1,NULL,'Tammy Liscano','FI','642489458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:23',0,'2014-03-02 05:45:37'),(10798,10798,'2014-01-01','ET','2',1,NULL,'Monica Mamon','FI','433451991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:48',0,'2014-03-02 04:24:47'),(13446,13802,'2014-01-01','ET','2',1,NULL,'sky maxfield','FI','449712789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:16',0,'2014-03-02 05:31:31'),(12574,12574,'2014-01-01','ET','2',1,NULL,'KIMBERLY GEAN MARTIN','FI','317703541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:06',0,'2014-03-01 16:35:14'),(3072,3072,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:35:21',0,'2014-03-02 01:10:33'),(3784,3784,'2014-01-01','ET','2',1,NULL,'Michael Scott','FI','300885189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:48',0,'2014-03-01 15:26:40'),(10390,10390,'2014-01-01','ET','2',1,NULL,'Ahmet Elbeyli','FI','293068871','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:50:26',0,'2014-03-01 16:10:36'),(7482,7482,'2014-01-01','ET','2',1,NULL,'Yvonne cult','FI','524765366','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:22',0,'2014-03-02 04:15:49'),(19884,20534,'0000-00-00','ET','2',3,2,'CHERYL MCDUNNELL','FI','253339058','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:31',0,'2014-03-10 14:37:47'),(21556,22206,'0000-00-00','ET','2',1,NULL,'MONICA TERRY','FI','587576696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:36',0,'2014-03-03 22:26:43'),(22232,22882,'0000-00-00','ET','2',1,NULL,'peggy l hale','FI','411924222','Starmount Life Insurance Company','FI','720977315','william h oden','94','2822598','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:04',0,'2014-03-06 21:27:26'),(4830,4830,'2014-01-01','ET','2',2,1,'YIU WAH FOK','FI','295929561','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:49',0,'2014-03-10 13:10:24'),(755,755,'2014-01-01','ET','2',1,NULL,'karen cramer','FI','272522073','HealthSpan','FI','311431434','Lauren  Hermiller','94','16945220','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:31',0,'2014-03-10 13:24:34'),(861,861,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:00',0,'2014-03-01 22:10:55'),(3236,3236,'2014-01-01','ET','2',1,NULL,'David Beckloff','FI','282560404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:25',0,'2014-03-01 15:52:44'),(1874,1874,'2014-01-01','ET','2',2,1,'Kenneth Kafcsak','FI','292526107','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:00',0,'2014-03-01 15:31:33'),(22593,23243,'0000-00-00','ET','2',1,NULL,'Gabriela Pietz','FI','302064131','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:18',0,'2014-03-10 14:50:59'),(17502,18152,'0000-00-00','ET','2',1,NULL,'Terrisha Harris','FI','429515506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-06 21:30:05',0,'2014-03-02 06:31:45'),(11414,11414,'2014-01-01','ET','2',2,1,'CARMEN RIFE','FI','291841230','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:00',0,'2014-03-10 13:52:32'),(14359,14810,'2014-01-01','ET','2',1,NULL,'Shamecka Nelson','FI','404085979','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:49',0,'2014-03-10 16:17:47'),(4945,4945,'2014-01-01','ET','2',3,2,'Chirstopher Lee Miller','FI','288769350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:38',0,'2014-03-01 15:10:22'),(13235,13591,'2014-01-01','ET','2',2,1,'MILDRED  COSS','FI','044682806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:29',0,'2014-03-01 16:35:14'),(12225,12225,'2014-01-01','ET','2',2,1,'SHEILA  RENA PIKES','FI','436139721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:25',0,'2014-03-02 05:03:29'),(19080,19730,'0000-00-00','ET','2',1,NULL,'Yana Fleming','FI','227133099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:30',0,'2014-03-02 06:52:12'),(4919,4919,'2014-01-01','ET','2',1,0,'JULIE POKORNY','FI','638101200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:47',0,'2014-03-01 19:11:03'),(293,293,'2014-01-01','ET','2',1,NULL,'Joseph Leroy Dobrowski','FI','427319549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:26',0,'2014-03-01 19:11:03'),(11534,11534,'2014-01-01','ET','2',1,NULL,'Mark Bolden','FI','438730700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:39',0,'2014-03-02 04:52:44'),(6995,6995,'2014-01-01','ET','2',1,NULL,'Sandra Harris','FI','441786989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:19',0,'2014-03-02 02:10:49'),(2698,2698,'2014-01-01','ET','2',1,NULL,'tarah malano','FI','336725057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:08',0,'2014-03-02 04:15:49'),(10651,10651,'2014-01-01','ET','2',1,NULL,'Elaine D Keezer','FI','463130887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:50',0,'2014-03-02 04:31:46'),(1243,1243,'2014-01-01','ET','2',1,NULL,'Milton  Juan Bascomb','FI','290743494','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:00',0,'2014-03-01 16:15:39'),(21632,22282,'0000-00-00','ET','2',1,NULL,'jessie garcia','FI','628016602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:45',0,'2014-03-04 21:27:16'),(22707,23357,'0000-00-00','ET','2',1,NULL,'diannia dunn','FI','439419177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:04',0,'2014-03-08 22:26:18'),(22833,23483,'0000-00-00','ET','2',1,NULL,'Todd E Jones','FI','298766195','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:20',0,'2014-03-10 14:50:59'),(1006,1006,'2014-01-01','ET','2',1,NULL,'Suzanne Lynn  Kim','FI','003502713','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:28',0,'2014-03-10 15:39:19'),(16111,16760,'0000-00-00','ET','2',1,NULL,'jackie gibson','FI','461216634','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:25',0,'2014-03-02 06:03:21'),(11270,11270,'2014-01-01','ET','2',1,NULL,'Marjorie Slay','FI','435844053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:35',0,'2014-03-02 04:45:37'),(19519,20169,'0000-00-00','ET','2',2,1,'LINDA BOGGAN','FI','289740464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:09:30',0,'2014-03-01 17:47:19'),(20147,20797,'0000-00-00','ET','2',1,NULL,'TINA KIETH','FI','285725698','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:53',0,'2014-03-10 16:38:05'),(20394,21044,'0000-00-00','ET','2',1,NULL,'MIGDALIA NINO','FI','626016870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:21',0,'2014-03-02 07:10:28'),(74,74,'2014-01-01','ET','2',1,NULL,'David Robert Kukielski','FI','506723887','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:15',0,'2014-03-01 15:21:15'),(5549,5549,'2014-01-01','ET','2',1,NULL,'ashley granger','FI','627056754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:48:02',0,'2014-03-02 04:45:37'),(15764,16413,'0000-00-00','ET','2',1,NULL,'Deborah Livers','FI','279584380','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','357','2014-01-01','Sync Success',0,'2014-01-23 21:01:30',0,'2014-03-10 14:10:12'),(15505,15956,'0000-00-00','ET','2',1,NULL,'Tiffany Hussong','FI','279723608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:53',0,'2014-03-01 16:50:53'),(2962,2962,'2014-01-01','ET','2',3,2,'Brian Williams','FI','301583863','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:58',0,'2014-03-01 15:37:30'),(2386,2386,'2014-01-01','ET','2',1,NULL,'PATRICIA CASE','FI','463411437','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:49',0,'2014-03-01 23:10:52'),(11352,11352,'2014-01-01','ET','2',1,NULL,'William Davis','FI','353445869','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:05',0,'2014-03-02 04:45:37'),(15495,15946,'0000-00-00','ET','2',4,3,'Melissa Ladd','FI','291864569','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:11',0,'2014-03-10 14:10:12'),(14697,15148,'2014-01-01','ET','2',1,NULL,'Wandrica Davis','FI','438671602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:53',0,'2014-03-02 05:45:37'),(16719,17369,'0000-00-00','ET','2',3,2,'Dawyn Small','FI','278829078','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:30',0,'2014-03-10 16:24:30'),(20025,20675,'0000-00-00','ET','2',1,NULL,'SUSAN J BEGGS','FI','276484375','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:09',0,'2014-03-10 14:37:47'),(20231,20881,'0000-00-00','ET','2',1,NULL,'Patrice Parsons','FI','449068250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:31:55',0,'2014-03-02 07:10:28'),(22388,23038,'0000-00-00','ET','2',3,2,'Jennifer Day','FI','291884850','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:29',0,'2014-03-10 14:50:59'),(897,897,'2014-01-01','ET','2',2,1,'Jeffrey Wills','FI','271686549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:02',0,'2014-03-01 15:21:15'),(1226,1226,'2014-01-01','ET','2',1,NULL,'Cynthia Jacobson','FI','262390196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:48:34',0,'2014-03-01 16:15:39'),(5698,5698,'2014-01-01','ET','2',1,NULL,'Deborah Ann Smith','FI','294441617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:22',0,'2014-03-01 15:48:04'),(2559,2559,'2014-01-01','ET','2',1,NULL,'Helen Reid','FI','433534334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:52',0,'2014-03-01 20:10:57'),(4479,4479,'2014-01-01','ET','2',1,NULL,'Patrick Cox','FI','405275313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:22',0,'2014-03-01 21:11:04'),(4156,4156,'2014-01-01','ET','2',1,NULL,'Sarah Adams','FI','296440348','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:54',0,'2014-03-10 15:59:47'),(5933,5933,'2014-01-01','ET','2',1,NULL,'Brian Grossman','FI','309767387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:50',0,'2014-03-01 15:48:04'),(16371,17021,'0000-00-00','ET','2',1,NULL,'shacqueline evans','FI','439698146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:07',0,'2014-03-02 06:10:30'),(20454,21104,'0000-00-00','ET','2',1,NULL,'JULIA NYE','FI','269683816','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:11',0,'2014-03-01 18:08:07'),(20462,21112,'0000-00-00','ET','2',1,NULL,'Brandi Freed','FI','275726180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:00:17',0,'2014-03-01 18:08:07'),(15431,15882,'0000-00-00','ET','2',1,NULL,'Jessica Bencie','FI','161700333','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:30',0,'2014-03-10 16:17:47'),(7382,7382,'2014-01-01','ET','2',1,NULL,'Susan Helene Neathamer','FI','433042757','Starmount Life Insurance Company','FI','720977315','Jeffrey  Merchant','94','16943760','348','2014-01-01','Sync Success',0,'2013-12-26 04:30:13',0,'2014-03-02 04:10:25'),(701,701,'2014-01-01','ET','2',1,NULL,'Lydell Emerson','FI','439351796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:06:47',0,'2014-03-02 02:10:49'),(15382,15833,'0000-00-00','ET','2',1,NULL,'REINA PAVON','FI','630682010','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:58',0,'2014-03-02 05:59:43'),(7334,7334,'2014-01-01','ET','2',1,NULL,'Jared Rammel','FI','286885633','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:47',0,'2014-03-10 13:32:15'),(6159,6159,'2014-01-01','ET','2',1,NULL,'Odeaa Aljabbari','FI','640195122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:08',0,'2014-03-02 04:10:25'),(17663,18313,'0000-00-00','ET','2',1,NULL,'Roberta Fishwick','FI','289685824','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:43',0,'2014-03-01 17:20:55'),(17678,18328,'0000-00-00','ET','2',1,NULL,'Fitore Musmurati','FI','136066915','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:52',0,'2014-03-10 16:24:30'),(20213,20863,'0000-00-00','ET','2',1,NULL,'kevin huber','FI','293742306','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:40',0,'2014-03-10 14:37:47'),(20741,21391,'0000-00-00','ET','2',1,NULL,'TABITHA CHATMAN','FI','405941349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:31',0,'2014-03-01 18:10:11'),(14440,14891,'2014-01-01','ET','2',1,NULL,'ERICA JONES','FI','434493756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:26',0,'2014-03-02 05:38:34'),(5684,5684,'2014-01-01','ET','2',5,4,'Wei Yang','FI','052788617','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:36',0,'2014-03-10 13:52:32'),(4235,4235,'2014-01-01','ET','2',1,NULL,'Angela Terrill','FI','279727800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:19',0,'2014-03-01 16:00:27'),(4208,4208,'2014-01-01','ET','2',1,NULL,'Marilyn Darlene Shaw','FI','587709932','Starmount Life Insurance Company','FI','720977315','Cindy L Wood','94','16356972','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:30',0,'2014-03-02 03:09:49'),(14070,14521,'2014-01-01','ET','2',2,1,'Hasmukhlal Patel','FI','640213044','Starmount Life Insurance Company','FI','720977315','Babu  Varghese','94','2188969','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:16',0,'2014-03-02 05:31:31'),(10638,10638,'2014-01-01','ET','2',1,NULL,'BENJAMIN RUSS','FI','460856438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:25',0,'2014-03-02 04:31:46'),(12318,12318,'2014-01-01','ET','2',1,NULL,'TAMARA N WILSON','FI','455068075','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:45',0,'2014-03-02 05:03:29'),(17622,18272,'0000-00-00','ET','2',1,NULL,'Bernita Stevenson','FI','435844509','Starmount Life Insurance Company','FI','720977315','Percy Paul McCraney','94','9000490','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:17',0,'2014-03-02 06:31:45'),(20680,21330,'0000-00-00','ET','2',1,NULL,'JUDY BAILEY','FI','437960972','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:03',0,'2014-03-02 07:17:36'),(7214,7214,'2014-01-01','ET','2',1,NULL,'Brian Leyh','FI','270884121','Dental Care Plus, Inc.','FI','311185262','Harvey  Ridley','94','16791486','348','2014-01-01','Sync Success',0,'2013-12-26 04:07:03',0,'2014-03-01 15:52:44'),(11061,11061,'2014-01-01','ET','2',3,2,'Debra Davis','FI','246350353','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:50',0,'2014-03-10 16:03:49'),(10990,10990,'2014-01-01','ET','2',1,NULL,'Barbara Harley','FI','587547092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:25',0,'2014-03-02 04:24:47'),(3426,3426,'2014-01-01','ET','2',1,NULL,'katrina bloemker','FI','404118255','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:32',0,'2014-03-10 13:32:15'),(18115,18765,'0000-00-00','ET','2',1,NULL,'Carol Dorsey','FI','449290057','Starmount Life Insurance Company','FI','720977315','Constance  Speed','94','16386345','348','2014-03-01','Sync Success',0,'2014-02-11 21:00:49',0,'2014-03-02 06:38:05'),(21299,21949,'0000-00-00','ET','2',1,NULL,'Roger Blair','FI','275584703','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:04',0,'2014-03-10 14:45:25'),(22386,23036,'0000-00-00','ET','2',3,2,'Jennifer Day','FI','291884850','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:28',0,'2014-03-10 14:50:59'),(15464,15915,'0000-00-00','ET','2',1,NULL,'elizabeth walker','FI','298600156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:51',0,'2014-03-01 16:50:53'),(3328,3328,'2014-01-01','ET','2',2,1,'Jerry Sheller','FI','296504325','Summa Insurance Company, Inc.','FI','341809108','Donald  Vought','94','2230276','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:27',0,'2014-03-10 15:52:36'),(2800,2800,'2014-01-01','ET','2',1,NULL,'Jeremy Loveridge','FI','271946481','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:21',0,'2014-03-01 16:05:34'),(10598,10598,'2014-01-01','ET','2',1,NULL,'Sandra Cruz','FI','453978610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:07',0,'2014-03-02 04:24:47'),(12950,12950,'2014-01-01','ET','2',1,NULL,'eric porter','FI','435111078','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:20',0,'2014-03-02 05:17:40'),(16579,17229,'0000-00-00','ET','2',1,NULL,'Jeffrey Wright','FI','286687126','HealthSpan','FI','311431434','Tamy  Hagan','94','3691584','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:29',0,'2014-03-10 14:20:26'),(16770,17420,'0000-00-00','ET','2',1,NULL,'Chris Brown','FI','436154429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:21',0,'2014-03-02 06:17:30'),(20955,21605,'0000-00-00','ET','2',1,NULL,'ENRIQUE MOLINA','FI','455968726','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:09',0,'2014-03-02 07:17:36'),(15673,16322,'0000-00-00','ET','2',1,NULL,'James Sandlin','FI','569370261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:29',0,'2014-03-02 05:59:43'),(5223,5223,'2014-01-01','ET','2',1,NULL,'Judith Schmitz','FI','282524477','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:10',0,'2014-03-10 13:20:27'),(13169,13525,'2014-01-01','ET','2',1,NULL,'CRISTINA MARIE UHRICK','FI','278646373','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:36',0,'2014-03-10 13:59:38'),(12163,12163,'2014-01-01','ET','2',1,NULL,'andrea danielle alvarado','FI','289887159','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:52',0,'2014-03-10 13:59:38'),(11640,11640,'2014-01-01','ET','2',1,NULL,'Katherine Daniel','FI','295589770','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:57',0,'2014-03-10 13:52:32'),(14759,15210,'2014-01-01','ET','2',2,1,'Bruce Goodell','FI','274461408','Summa Insurance Company, Inc.','FI','341809108','David  Auble','94','7083348','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:31',0,'2014-03-10 16:17:47'),(850,850,'2014-01-01','ET','2',2,1,'Leopoldo Reyes','FI','453902785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:38',0,'2014-03-01 22:10:55'),(14032,14388,'2014-01-01','ET','2',1,NULL,'JOANNE WHITE','FI','299585702','HealthSpan','FI','311431434','ANGELA  RICE','94','1821833','348','2014-02-01','Sync Success',0,'2014-01-13 03:01:54',0,'2014-03-10 14:03:26'),(1941,1941,'2014-01-01','ET','2',1,NULL,'ZARDIK HARUTHUNIAN','FI','564717768','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:58',0,'2014-03-01 15:26:40'),(12176,12176,'2014-01-01','ET','2',1,NULL,'Lee Ann Terilla','FI','278524859','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:21',0,'2014-03-10 16:10:34'),(4769,4769,'2014-01-01','ET','2',1,NULL,'maribel gonzalez','FI','457434633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:58',0,'2014-03-01 21:11:04'),(5620,5620,'2014-01-01','ET','2',1,NULL,'BOUBACAR IDE','FI','110906552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:22',0,'2014-03-10 16:03:49'),(5850,5850,'2014-01-01','ET','2',1,NULL,'Cassandra Padula','FI','273847429','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:08',0,'2014-03-10 15:39:19'),(17070,17720,'0000-00-00','ET','2',1,NULL,'Sandra Enriquez','FI','459271836','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:41',0,'2014-03-02 06:24:38'),(18828,19478,'0000-00-00','ET','2',1,NULL,'ERRAL DEVAULT','94','0000778265','Starmount Life Insurance Company','FI','720977315','MICHAEL  DAUGHERTY','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:10',0,'2014-03-02 06:52:12'),(18956,19606,'0000-00-00','ET','2',1,NULL,'Louis Morris','FI','427475315','Starmount Life Insurance Company','FI','720977315','Christopher  Wang','94','15980657','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:42',0,'2014-03-02 06:52:12'),(21509,22159,'0000-00-00','ET','2',2,1,'Ernest Canales','FI','462434478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:01',0,'2014-03-03 22:26:43'),(15423,15874,'0000-00-00','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:24',0,'2014-03-01 16:50:53'),(15137,15588,'0000-00-00','ET','2',1,NULL,'charlavell simon','FI','434239668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:18',0,'2014-03-02 05:52:31'),(13522,13878,'2014-01-01','ET','2',3,2,'Airica Murphy','FI','274949919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:31',0,'2014-03-01 16:40:16'),(1433,1433,'2014-01-01','ET','2',1,NULL,'Patricia Valentine','FI','277503170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:08',0,'2014-03-01 16:15:39'),(10603,10603,'2014-01-01','ET','2',2,1,'Richard Nordin','FI','320525063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:17',0,'2014-03-02 04:24:47'),(11046,11046,'2014-01-01','ET','2',1,NULL,'Jordon Michael Smith','94','0000870629','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:20',0,'2014-03-10 16:03:49'),(5301,5301,'2014-01-01','ET','2',2,1,'Bruce Fluharty','FI','271543180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:29',0,'2014-03-01 15:05:09'),(5096,5096,'2014-01-01','ET','2',1,NULL,'Doris Johnson','FI','436089704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:03',0,'2014-03-02 00:10:48'),(4498,4498,'2014-01-01','ET','2',2,1,'vicki wilson','FI','301528661','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:00',0,'2014-03-10 13:03:33'),(17411,18061,'0000-00-00','ET','2',3,2,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:49',0,'2014-03-10 14:24:38'),(14276,14727,'2014-01-01','ET','2',1,NULL,'RACHELLE GEANS','FI','297880154','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:13',0,'2014-03-01 16:46:19'),(484,484,'2014-01-01','ET','2',1,NULL,'Michelle Baumgardner','FI','280842136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:51:08',0,'2014-03-10 13:10:24'),(11028,11028,'2014-01-01','ET','2',1,NULL,'Michael Dasinger','FI','300589772','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:45',0,'2014-03-10 13:39:10'),(5519,5519,'2014-01-01','ET','2',1,NULL,'CATHY BONEWELL','FI','570963906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:59',0,'2014-03-01 16:23:43'),(4302,4302,'2014-01-01','ET','2',1,NULL,'Jawon McCray','FI','426530660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:22',0,'2014-03-02 03:09:49'),(3549,3549,'2014-01-01','ET','2',1,NULL,'kristin heffley','FI','290708000','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:44',0,'2014-03-01 15:37:30'),(18907,19557,'0000-00-00','ET','2',4,3,'Kelly Dahl','FI','373044961','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:06',0,'2014-03-01 17:34:07'),(19390,20040,'0000-00-00','ET','2',1,NULL,'MICHELLE GRACE','FI','280644747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:00',0,'2014-03-01 17:34:07'),(22954,23604,'0000-00-00','ET','2',1,NULL,'Kathryn Boggs','FI','173744076','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:20',0,'2014-03-10 21:07:22'),(1151,1151,'2014-01-01','ET','2',1,NULL,'LaShunda Williams','FI','439233737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:13',0,'2014-03-02 04:38:08'),(1740,1740,'2014-01-01','ET','2',1,NULL,'Lisa Maletz','FI','270765572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:41',0,'2014-03-01 15:31:33'),(10844,10844,'2014-01-01','ET','2',1,NULL,'Philip Seay','FI','592584945','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:17',0,'2014-03-10 13:39:10'),(14741,15192,'2014-01-01','ET','2',1,NULL,'Christina Gray','FI','590095830','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:20',0,'2014-03-10 16:17:47'),(14096,14547,'2014-01-01','ET','2',1,NULL,'MEDI SADEGHBEGI','FI','463777205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:33',0,'2014-03-02 05:38:34'),(2493,2493,'2014-01-01','ET','2',1,NULL,'Marcia Tomanicek','FI','291587280','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:19',0,'2014-03-10 13:10:24'),(3988,3988,'2014-01-01','ET','2',1,NULL,'Donna Jean Minge','FI','280540544','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:51',0,'2014-03-10 13:10:24'),(12768,12768,'2014-01-01','ET','2',1,NULL,'Sharon Gorman','FI','274440367','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:26',0,'2014-03-10 13:59:38'),(17099,17749,'0000-00-00','ET','2',1,NULL,'PADMAJA PAPKAR','FI','286767821','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:00',0,'2014-03-01 17:00:58'),(19512,20162,'0000-00-00','ET','2',1,NULL,'Cerra Wingo','FI','283845987','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:07:15',0,'2014-03-01 17:34:07'),(20026,20676,'0000-00-00','ET','2',1,NULL,'Tony Allan Swander','FI','296561121','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:10',0,'2014-03-10 14:37:47'),(20576,21226,'0000-00-00','ET','2',1,NULL,'Quan Nguyen','FI','004968375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:01:33',0,'2014-03-01 18:08:07'),(21179,21829,'0000-00-00','ET','2',2,1,'Hazel Kelly','FI','425063839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:42',0,'2014-03-02 07:23:39'),(21578,22228,'0000-00-00','ET','2',1,NULL,'Karmin Woodbury','94','0001198456','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:53',0,'2014-03-03 22:26:43'),(6345,6345,'2014-01-01','ET','2',1,NULL,'william mckean','FI','202629797','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:47',0,'2014-03-10 13:39:10'),(424,424,'2014-01-01','ET','2',1,NULL,'Joelle May','FI','290740752','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:09',0,'2014-03-01 15:21:15'),(15841,16490,'0000-00-00','ET','2',1,NULL,'TILBRUN JR BAREHERENY','FI','770427516','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:35',0,'2014-03-01 16:56:22'),(4329,4329,'2014-01-01','ET','2',1,NULL,'Matthew Hille','FI','268744793','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:07',0,'2014-03-10 13:32:15'),(955,955,'2014-01-01','ET','2',1,NULL,'Kennon J Hebert','FI','433860040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:48',0,'2014-03-01 22:10:55'),(21140,21790,'0000-00-00','ET','2',1,NULL,'LILLIAN A JENKINS','FI','439177805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:15',0,'2014-03-02 07:23:39'),(772,772,'2014-01-01','ET','2',2,1,'james harr','FI','233800998','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:07',0,'2014-03-01 15:05:09'),(1011,1011,'2014-01-01','ET','2',1,NULL,'DEBOHRA LEE YOUNG','FI','272561210','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:37',0,'2014-03-10 15:39:19'),(15020,15471,'2014-01-01','ET','2',1,NULL,'Tristan Hampton','FI','436691772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:19',0,'2014-03-02 05:45:37'),(12277,12277,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:24:26',0,'2014-03-10 16:10:34'),(19911,20561,'0000-00-00','ET','2',1,NULL,'ANTHONY W SMITH','FI','466135346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-21 21:30:11',0,'2014-03-02 07:03:25'),(22673,23323,'0000-00-00','ET','2',2,1,'Britanny Hall','FI','274924340','HealthSpan','FI','311431434','Mike  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:38',0,'2014-03-10 14:50:59'),(22890,23540,'0000-00-00','ET','2',3,2,'AMANDA BERNARD','FI','404636741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:31',0,'2014-03-10 21:36:25'),(7390,7390,'2014-01-01','ET','2',1,NULL,'MEGHAN HOOPER','FI','632245320','Starmount Life Insurance Company','FI','720977315','KEITH  SMITH','94','4698601','348','2014-01-01','Sync Success',0,'2013-12-26 04:30:31',0,'2014-03-02 04:15:49'),(15585,16036,'0000-00-00','ET','2',1,NULL,'Linda StJohns','FI','295528229','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:29',0,'2014-03-10 14:10:12'),(4851,4851,'2014-01-01','ET','2',1,NULL,'Andrea Nicole Davis','FI','286926819','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:38',0,'2014-03-10 15:39:19'),(15005,15456,'2014-01-01','ET','2',1,NULL,'Naz Older','FI','284888626','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:12',0,'2014-03-10 16:17:47'),(12811,12811,'2014-01-01','ET','2',1,NULL,'Diana Molina','FI','509060907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:40',0,'2014-03-02 05:17:40'),(12482,12482,'2014-01-01','ET','2',4,3,'Dale Rengel','FI','295584912','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:35',0,'2014-03-01 16:35:14'),(15868,16517,'0000-00-00','ET','2',1,NULL,'Julie Cook','FI','275644222','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-24 21:00:52',0,'2014-03-10 14:10:12'),(16159,16808,'0000-00-00','ET','2',1,NULL,'Richard Cunningam','FI','455151599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:00:12',0,'2014-03-02 06:10:30'),(21814,22464,'0000-00-00','ET','2',1,NULL,'DOROTHY GEORGETTE WILSON','FI','467574631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:13',0,'2014-03-05 21:25:24'),(551,551,'2014-01-01','ET','2',2,1,'DONNA  PUFFER','FI','299721024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:03',0,'2014-03-01 15:48:04'),(684,684,'2014-01-01','ET','2',1,NULL,'Andrea Marie Rodriguez','FI','270985118','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 18:06:13',0,'2014-03-10 15:52:36'),(1119,1119,'2014-01-01','ET','2',1,NULL,'Victor Kramitz','FI','111529505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:15',0,'2014-03-02 04:38:08'),(14009,14365,'2014-01-01','ET','2',1,NULL,'Anthony Glenn Byers','FI','277580673','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:37',0,'2014-03-01 16:40:16'),(11215,11215,'2014-01-01','ET','2',1,NULL,'ANTHONY COLEMAN','FI','298663185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:55',0,'2014-03-01 16:23:43'),(17666,18316,'0000-00-00','ET','2',1,NULL,'Jeffery Swank','FI','288766718','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:45',0,'2014-03-01 17:20:55'),(17759,18409,'0000-00-00','ET','2',2,1,'FRANCO CONTI','FI','278500559','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:42',0,'2014-03-10 16:24:30'),(7189,7189,'2014-01-01','ET','2',1,NULL,'STACEY MOORE','FI','572176571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:19',0,'2014-03-02 03:09:49'),(12061,12061,'2014-01-01','ET','2',1,NULL,'Tiffany Hanford','FI','308882178','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:24',0,'2014-03-01 16:30:17'),(10927,10927,'2014-01-01','ET','2',2,1,'GAYLE E MARTIN','FI','300625451','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:32',0,'2014-03-10 16:03:49'),(10384,10384,'2014-01-01','ET','2',2,1,'Michael Hurst','FI','291526417','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-26 12:50:14',0,'2014-03-01 16:10:36'),(7691,7691,'2014-01-01','ET','2',1,NULL,'Daniela Capistrano','FI','621036777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:08',0,'2014-03-01 20:10:57'),(2552,2552,'2014-01-01','ET','2',1,NULL,'Carol Broadwater','FI','272686844','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:37',0,'2014-03-10 15:39:19'),(19117,19767,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott D Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:57',0,'2014-03-01 17:34:07'),(20664,21314,'0000-00-00','ET','2',1,NULL,'Eliezer Hernandez','FI','583937625','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:36',0,'2014-03-10 16:38:05'),(2426,2426,'2014-01-01','ET','2',1,NULL,'Joan Moore','FI','280988392','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:04',0,'2014-03-10 15:45:56'),(5046,5046,'2014-01-01','ET','2',2,1,'FRED CLINTON MOORE','FI','302507948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:26',0,'2014-03-01 15:31:33'),(13436,13792,'2014-01-01','ET','2',2,1,'Stephan A Gnecco','FI','125424128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:09',0,'2014-03-02 05:31:31'),(3917,3917,'2014-01-01','ET','2',1,NULL,'Kristina Burns','FI','271906055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:33',0,'2014-03-01 15:26:40'),(13333,13689,'2014-01-01','ET','2',1,NULL,'Aldeaner Brass','FI','571111370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:25',0,'2014-03-02 05:24:45'),(20160,20810,'0000-00-00','ET','2',1,NULL,'Debra Hurst','FI','295643922','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:02',0,'2014-03-01 18:08:07'),(20724,21374,'0000-00-00','ET','2',3,2,'KIMBERLY DAVIS','FI','295725916','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:22',0,'2014-03-01 18:08:07'),(610,610,'2014-01-01','ET','2',1,NULL,'Bryan Hoffman','FI','513927737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:03:55',0,'2014-03-02 02:10:49'),(15512,15963,'0000-00-00','ET','2',1,NULL,'Shaun Maserang','FI','514046607','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:56',0,'2014-03-02 05:59:43'),(5831,5831,'2014-01-01','ET','2',1,NULL,'Quiton Garrett','FI','425591231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:27',0,'2014-03-01 21:11:04'),(3119,3119,'2014-01-01','ET','2',1,NULL,'LATONYA D MYERS','FI','295687092','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:45',0,'2014-03-10 15:52:36'),(16240,16889,'0000-00-00','ET','2',1,NULL,'Ricka  Johnson','FI','433177889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:01:05',0,'2014-03-02 06:10:30'),(17095,17745,'0000-00-00','ET','2',1,NULL,'CHERYL KING','FI','275549271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:57',0,'2014-03-01 17:00:58'),(19916,20566,'0000-00-00','ET','2',1,NULL,'DONYA R SMITH','FI','465573699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:13',0,'2014-03-02 07:03:25'),(20280,20930,'0000-00-00','ET','2',1,NULL,'Roger A Dingee','FI','048646324','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:25',0,'2014-03-10 16:38:05'),(6351,6351,'2014-01-01','ET','2',2,1,'Cecil Wells','FI','460789661','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:56',0,'2014-03-10 13:32:15'),(5801,5801,'2014-01-01','ET','2',1,NULL,'MIRANDA  HOLDEN','FI','421047074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:34',0,'2014-03-02 01:10:33'),(10904,10904,'2014-01-01','ET','2',1,NULL,'Lloyd Gervais','FI','437924359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:47',0,'2014-03-02 04:24:47'),(2126,2126,'2014-01-01','ET','2',1,NULL,'Kellen Ruth Elwell','FI','223575400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:43',0,'2014-03-01 15:16:37'),(4482,4482,'2014-01-01','ET','2',1,NULL,'JAMES GALLEN','FI','041545671','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:27',0,'2014-03-01 21:11:04'),(18743,19393,'0000-00-00','ET','2',1,NULL,'ANDREW BROWN','FI','439191616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:24',0,'2014-03-02 06:45:14'),(5385,5385,'2014-01-01','ET','2',1,NULL,'lsteifa butler','FI','589114092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:02',0,'2014-03-01 21:11:04'),(14010,14366,'2014-01-01','ET','2',1,NULL,'sharon shanahan','FI','282548983','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:38',0,'2014-03-01 16:40:16'),(2503,2503,'2014-01-01','ET','2',1,0,'Nancy Ann Baker','FI','350480350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:08',0,'2014-03-01 19:11:03'),(1374,1374,'2014-01-01','ET','2',1,NULL,'Gloria Harris','FI','459884879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:10',0,'2014-03-02 04:38:08'),(17296,17946,'0000-00-00','ET','2',1,NULL,'herman keller','FI','433436474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:52',0,'2014-03-02 06:24:38'),(19392,20042,'0000-00-00','ET','2',1,NULL,'Sakile Sala Chenzira','FI','291544321','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:02',0,'2014-03-01 17:34:07'),(22222,22872,'0000-00-00','ET','2',1,NULL,'Erica Diaz','FI','636182957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:55',0,'2014-03-06 21:27:26'),(22583,23233,'0000-00-00','ET','2',1,NULL,'CONNIE BROWN','FI','284563565','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:10',0,'2014-03-10 14:50:59'),(22899,23549,'0000-00-00','ET','2',1,NULL,'Carianne Nice','FI','299660063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:39',0,'2014-03-10 21:36:25'),(1504,1504,'2014-01-01','ET','2',2,1,'KATHLEEN BERNICE FOX','FI','291503006','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:30',0,'2014-03-10 16:03:49'),(11447,11447,'2014-01-01','ET','2',1,NULL,'PAMELA ARIDGE','FI','271528961','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:04',0,'2014-03-01 16:23:43'),(7245,7245,'2014-01-01','ET','2',2,1,'Ross Bishoff','FI','268769919','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:02',0,'2014-03-10 13:32:15'),(7009,7009,'2014-01-01','ET','2',1,NULL,'AYAAN AHMED','FI','108747473','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:48',0,'2014-03-02 03:09:49'),(5121,5121,'2014-01-01','ET','2',2,1,'STEPHEN L CARTER','FI','270567095','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:55',0,'2014-03-10 15:45:56'),(18684,19334,'0000-00-00','ET','2',1,NULL,'ROBERT JOHNSON','FI','452984438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:39',0,'2014-03-02 06:45:14'),(20960,21610,'0000-00-00','ET','2',1,NULL,'Sheila j powdrill','FI','455676997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:13',0,'2014-03-02 07:17:36'),(21959,22609,'0000-00-00','ET','2',2,1,'SYLVIA SHELBY','FI','436860815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:24',0,'2014-03-05 22:27:33'),(5710,5710,'2014-01-01','ET','2',1,NULL,'James McCarty','FI','280506066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:47',0,'2014-03-01 15:37:30'),(1409,1409,'2014-01-01','ET','2',1,NULL,'Daniel Hayes','FI','043609414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:20',0,'2014-03-02 04:45:37'),(3973,3973,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:47:21',0,'2014-03-10 13:10:24'),(4136,4136,'2014-01-01','ET','2',1,NULL,'Julie Downs','FI','300787709','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:16',0,'2014-03-01 16:00:27'),(16918,17568,'0000-00-00','ET','2',1,NULL,'Maura Anaya','FI','251843487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:00:37',0,'2014-03-01 17:00:58'),(17771,18421,'0000-00-00','ET','2',1,NULL,'Jennifer Amanda Garcia','FI','633079289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:10',0,'2014-03-02 06:03:21'),(19224,19874,'0000-00-00','ET','2',1,NULL,'DARNELL HAGGERTY','FI','436115233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:20',0,'2014-03-02 06:52:12'),(19852,20502,'0000-00-00','ET','2',1,NULL,'Brandon Carriveau','FI','384822485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:05',0,'2014-03-02 07:03:25'),(20269,20919,'0000-00-00','ET','2',1,NULL,'Brynn Martin','FI','302907286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:16',0,'2014-03-01 17:47:19'),(22367,23017,'0000-00-00','ET','2',1,NULL,'Thothsakanh Thongsavanh','FI','586120581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:19',0,'2014-03-07 21:25:22'),(15980,16629,'0000-00-00','ET','2',2,1,'Cindy Mize','FI','378641339','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:24',0,'2014-03-10 14:20:26'),(12141,12141,'2014-01-01','ET','2',1,NULL,'Michael Currie','FI','292540688','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:07:10',0,'2014-03-10 16:10:34'),(12108,12108,'2014-01-01','ET','2',1,NULL,'RICHARD SPENCER','FI','280689330','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:00',0,'2014-03-01 16:30:17'),(3475,3475,'2014-01-01','ET','2',1,NULL,'Harold Crew Mason','FI','276864032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:23',0,'2014-03-01 15:31:33'),(4741,4741,'2014-01-01','ET','2',1,NULL,'STEVEN ALAN SELKA','FI','287528520','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:09',0,'2014-03-10 13:45:57'),(18048,18698,'0000-00-00','ET','2',1,NULL,'Curtis Mullins','FI','302686590','HealthSpan','FI','311431434','Kirk  Bernhard','94','2828814','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:12',0,'2014-03-10 14:24:38'),(19928,20578,'0000-00-00','ET','2',1,NULL,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:22',0,'2014-03-10 14:37:47'),(22666,23316,'0000-00-00','ET','2',2,1,'Chad Patterson','FI','465878073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:32',0,'2014-03-08 22:26:18'),(167,167,'2014-01-01','ET','2',2,1,'Edgar Hanson','FI','296523564','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-25 17:20:12',0,'2014-03-10 13:10:24'),(822,822,'2014-01-01','ET','2',1,NULL,'Jacquelin Morey','FI','252864383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:59',0,'2014-03-01 19:11:03'),(3963,3963,'2014-01-01','ET','2',2,1,'Daksha R Shah','FI','297605518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:01',0,'2014-03-01 15:26:40'),(4126,4126,'2014-01-01','ET','2',1,NULL,'manfred meier','FI','286561917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:59',0,'2014-03-01 16:00:27'),(1861,1861,'2014-01-01','ET','2',4,3,'Carmen M Johnson','FI','348569726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:34',0,'2014-03-01 15:26:40'),(5407,5407,'2014-01-01','ET','2',2,1,'Deborah Poff','FI','298661008','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:29',0,'2014-03-10 15:39:19'),(21126,21776,'0000-00-00','ET','2',1,NULL,'Debra Milano','FI','300569802','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:04',0,'2014-03-10 16:38:05'),(21829,22479,'0000-00-00','ET','2',2,1,'Bryan D Emch','FI','275825613','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:22',0,'2014-03-10 16:44:18'),(1082,1082,'2014-01-01','ET','2',2,1,'Ashley Berry Allen','FI','438712044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:21',0,'2014-03-01 19:11:03'),(7364,7364,'2014-01-01','ET','2',1,NULL,'Spence Edward Odenbach','FI','290724631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:59',0,'2014-03-01 15:16:37'),(2924,2924,'2014-01-01','ET','2',2,1,'Alica Bosch','FI','272841770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:42',0,'2014-03-01 15:37:30'),(15611,16062,'0000-00-00','ET','2',1,NULL,'Kimbula Ducksworth','FI','425454434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:41',0,'2014-03-02 05:59:43'),(13651,14007,'2014-01-01','ET','2',1,NULL,'Tabatha Karvia','FI','544374987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:10',0,'2014-03-02 05:24:45'),(4385,4385,'2014-01-01','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:31',0,'2014-03-01 15:16:37'),(4918,4918,'2014-01-01','ET','2',2,1,'Erica Jane Moore','FI','283820184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:44',0,'2014-03-01 15:05:09'),(1700,1700,'2014-01-01','ET','2',1,NULL,'ronald arabie','FI','438531972','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:29',0,'2014-03-02 00:10:48'),(5558,5558,'2014-01-01','ET','2',1,NULL,'SARAH COHEN GLASS','FI','459737236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:17',0,'2014-03-02 04:45:37'),(5437,5437,'2014-01-01','ET','2',1,0,'Esther Morgan','FI','294686296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:34',0,'2014-03-01 15:05:09'),(3237,3237,'2014-01-01','ET','2',1,NULL,'Patricia L Minham','FI','302654555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:27',0,'2014-03-01 15:52:44'),(16262,16911,'0000-00-00','ET','2',1,NULL,'Richard A Niese','FI','268568108','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:20',0,'2014-03-10 14:20:26'),(571,571,'2014-01-01','ET','2',2,1,'Zachary Lawrence','FI','603103858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:41',0,'2014-03-01 15:48:04'),(15633,16084,'0000-00-00','ET','2',1,NULL,'John Latone','FI','290925192','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:52',0,'2014-03-10 16:17:47'),(10619,10619,'2014-01-01','ET','2',1,NULL,'Miata Monique Pride','FI','638101565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:49',0,'2014-03-02 04:24:47'),(14304,14755,'2014-01-01','ET','2',2,1,'LOLA WILLARD','FI','453477300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:26',0,'2014-03-02 05:38:34'),(3394,3394,'2014-01-01','ET','2',1,NULL,'DORIS TAYLOR','FI','281547441','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:51:29',0,'2014-03-10 15:52:36'),(14278,14729,'2014-01-01','ET','2',2,1,'David Kushner','FI','296686757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:14',0,'2014-03-01 16:46:19'),(1965,1965,'2014-01-01','ET','2',1,NULL,'LINDA J STARCHER','FI','272562346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:39',0,'2014-03-01 15:26:40'),(5333,5333,'2014-01-01','ET','2',1,NULL,'FRANCIS KRAJENKE','FI','377802094','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:16',0,'2014-03-01 15:16:37'),(3320,3320,'2014-01-01','ET','2',2,1,'Stephen Smith','FI','287502772','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:12',0,'2014-03-01 15:52:44'),(20449,21099,'0000-00-00','ET','2',1,NULL,'Christy Purnell','FI','270764362','Summa Insurance Company, Inc.','FI','341809108','carl  laurianti','94','2332836','348','2014-04-01','Sync Success',0,'2014-02-26 09:31:05',0,'2014-03-10 16:38:05'),(21517,22167,'0000-00-00','ET','2',1,NULL,'Wanda Smith','FI','550023957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:08',0,'2014-03-03 22:26:43'),(14834,15285,'2014-01-01','ET','2',1,NULL,'TERRY A WILSON-GENTRY','FI','295547172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:22',0,'2014-03-10 14:03:26'),(817,817,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 18:10:49',0,'2014-03-01 15:10:22'),(12727,12727,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:50',0,'2014-03-10 16:10:34'),(1893,1893,'2014-01-01','ET','2',1,NULL,'Audrey Edwards','FI','438020028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:34',0,'2014-03-01 23:10:52'),(4902,4902,'2014-01-01','ET','2',1,NULL,'Moses Robinson','FI','554876277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:11',0,'2014-03-01 19:11:03'),(12105,12105,'2014-01-01','ET','2',1,NULL,'Amanda Hartman','FI','288820775','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:53',0,'2014-03-01 16:30:17'),(11510,11510,'2014-01-01','ET','2',1,NULL,'Katrina Jackson','FI','438595690','Starmount Life Insurance Company','FI','720977315','greg  town','94','4637275','348','2014-02-01','Sync Success',0,'2013-12-28 03:31:58',0,'2014-03-02 04:52:44'),(10422,10422,'2014-01-01','ET','2',1,NULL,'LINDA FENNELL','FI','283505148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:23',0,'2014-03-01 16:10:36'),(16077,16726,'0000-00-00','ET','2',1,NULL,'Pamela Riley','FI','276522647','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:01',0,'2014-03-01 16:56:22'),(16660,17310,'0000-00-00','ET','2',1,NULL,'Thomas Campbell','FI','271880387','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:47',0,'2014-03-01 17:00:58'),(13494,13850,'2014-01-01','ET','2',1,NULL,'ERNESTINA CONSTANTE','FI','640035722','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:12',0,'2014-03-02 05:31:31'),(13143,13499,'2014-01-01','ET','2',1,NULL,'DEBORAH GREEN','FI','295506434','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:38',0,'2014-03-10 13:59:38'),(6332,6332,'2014-01-01','ET','2',1,NULL,'Jessica Clemons','94','0000825436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:23',0,'2014-03-02 04:10:25'),(3940,3940,'2014-01-01','ET','2',1,NULL,'SHARRON DAVIS','FI','434924321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:13',0,'2014-03-01 23:10:52'),(11942,11942,'2014-01-01','ET','2',1,NULL,'MICHELLE MEXICOTT','FI','269684811','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:22',0,'2014-03-10 13:52:32'),(880,880,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:16:35',0,'2014-03-01 15:21:15'),(10715,10715,'2014-01-01','ET','2',1,NULL,'Michael Skovich','FI','290468868','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:03',0,'2014-03-01 16:10:36'),(3249,3249,'2014-01-01','ET','2',1,NULL,'Saul Lamovsky','FI','273727389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:50',0,'2014-03-01 15:52:44'),(7663,7663,'2014-01-01','ET','2',1,NULL,'Jean Baker','FI','272686206','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:15',0,'2014-03-10 13:39:10'),(16558,17208,'0000-00-00','ET','2',1,NULL,'Debra Brinker','FI','301566341','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:15',0,'2014-03-10 16:24:30'),(17264,17914,'0000-00-00','ET','2',1,NULL,'LATEARRIA HERNDON','FI','453972760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:38',0,'2014-03-02 06:24:38'),(21284,21934,'0000-00-00','ET','2',1,NULL,'Kerri Brennan','FI','424193415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:52',0,'2014-03-02 07:23:39'),(11391,11391,'2014-01-01','ET','2',1,NULL,'MELISSA ROMINES','FI','587596265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:06:17',0,'2014-03-02 04:52:44'),(912,912,'2014-01-01','ET','2',2,1,'theodore deter','FI','300867133','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:26',0,'2014-03-01 15:21:15'),(6311,6311,'2014-01-01','ET','2',1,NULL,'Jennifer M Sehm','FI','269524917','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:44',0,'2014-03-10 15:59:47'),(4067,4067,'2014-01-01','ET','2',1,NULL,'padasamai vattana','FI','607489081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:15',0,'2014-03-02 03:09:49'),(2131,2131,'2014-01-01','ET','2',1,NULL,'Sameer Suri','FI','272023346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:52',0,'2014-03-01 15:16:37'),(6217,6217,'2014-01-01','ET','2',1,NULL,'William G Smith','FI','066387844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:49',0,'2014-03-01 16:00:27'),(21442,22092,'0000-00-00','ET','2',1,NULL,'Justin VonGunten','FI','277825207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:12',0,'2014-03-10 16:38:05'),(21910,22560,'0000-00-00','ET','2',1,NULL,'betty crosby','FI','454026892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:30:51',0,'2014-03-05 22:27:33'),(22726,23376,'0000-00-00','ET','2',2,1,'DAVE BROWNING','FI','292428391','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:18',0,'2014-03-10 14:50:59'),(17309,17959,'0000-00-00','ET','2',2,1,'JIMMY NGUYEN','FI','435512126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:00',0,'2014-03-02 06:24:38'),(6433,6433,'2014-01-01','ET','2',1,NULL,'SELESHI KEBEDE','FI','411630159','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:30',0,'2014-03-01 15:10:22'),(14305,14756,'2014-01-01','ET','2',1,NULL,'Pedro Deanda','FI','465332484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:26',0,'2014-03-02 05:38:34'),(15737,16386,'0000-00-00','ET','2',1,NULL,'GERARDO GONZALEZ','FI','467414537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:14',0,'2014-03-02 05:59:43'),(22226,22876,'0000-00-00','ET','2',1,NULL,'adrian sconiers','FI','523330298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:01:59',0,'2014-03-06 21:27:26'),(22278,22928,'0000-00-00','ET','2',1,NULL,'Dennis Stachowiak','FI','271525574','HealthSpan','FI','311431434','Gayle  Duling','94','1854661','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:36',0,'2014-03-10 14:45:25'),(14119,14570,'2014-01-01','ET','2',2,1,'Daniel Sarafin','FI','291548979','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:48',0,'2014-03-01 16:46:19'),(5776,5776,'2014-01-01','ET','2',2,1,'Tia Walker','FI','276704223','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:45',0,'2014-03-10 15:52:36'),(4280,4280,'2014-01-01','ET','2',1,NULL,'Charles Edward Moore','FI','437477307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:43',0,'2014-03-02 03:09:49'),(1276,1276,'2014-01-01','ET','2',2,1,'Annmarie Brasty','FI','281647557','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:02',0,'2014-03-01 16:23:43'),(3452,3452,'2014-01-01','ET','2',1,NULL,'Ronese Manley','FI','295628490','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:24',0,'2014-03-10 13:32:15'),(20088,20738,'0000-00-00','ET','2',1,NULL,'ROBBY DUCOTE','FI','437550718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:09',0,'2014-03-02 07:10:28'),(22744,23394,'0000-00-00','ET','2',1,NULL,'DUVURI JACKSON','FI','448623722','Starmount Life Insurance Company','FI','720977315','MICHAEL  KIRSCHMAN','94','171145428','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:07',0,'2014-03-09 21:26:00'),(14225,14676,'2014-01-01','ET','2',1,NULL,'KEVIN KEGG','FI','460138501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:51',0,'2014-03-02 05:38:34'),(12765,12765,'2014-01-01','ET','2',1,NULL,'BETHANY MILLER','FI','269746237','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:17',0,'2014-03-10 13:59:38'),(11043,11043,'2014-01-01','ET','2',1,NULL,'CAROLINE LOUISE PARKER','FI','271542513','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:14',0,'2014-03-10 16:03:49'),(3551,3551,'2014-01-01','ET','2',1,NULL,'Amanda Bodi','FI','300906228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:48',0,'2014-03-01 15:37:30'),(18078,18728,'0000-00-00','ET','2',1,NULL,'Thanh Phan','FI','586524263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:00:22',0,'2014-03-02 06:38:05'),(14935,15386,'2014-01-01','ET','2',1,NULL,'rebecca mooneyham','FI','300521065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:40',0,'2014-03-01 16:46:19'),(14664,15115,'2014-01-01','ET','2',2,1,'Jessica Sturgill','FI','630105144','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:30',0,'2014-03-01 16:46:19'),(2954,2954,'2014-01-01','ET','2',2,1,'GREGORY JOSEPH GOODMAN','FI','279680232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:43',0,'2014-03-01 15:37:30'),(16520,17170,'0000-00-00','ET','2',1,NULL,'Zeder Pough','FI','073441712','Starmount Life Insurance Company','FI','720977315','Dorian  Black','94','7680495','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:50',0,'2014-03-02 06:17:30'),(18999,19649,'0000-00-00','ET','2',1,NULL,'Pamela A Fioritto','FI','273645511','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:13',0,'2014-03-10 16:31:33'),(19909,20559,'0000-00-00','ET','2',1,NULL,'Santiago Cobos','FI','450270185','Starmount Life Insurance Company','FI','720977315','Christopher  Wang','94','15980657','348','2014-04-01','Sync Success',0,'2014-02-21 21:30:10',0,'2014-03-02 07:03:25'),(20729,21379,'0000-00-00','ET','2',1,NULL,'DEBBY DAVIS','FI','271580925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:26',0,'2014-03-01 18:10:11'),(5866,5866,'2014-01-01','ET','2',2,1,'ANTHONY GREENBERRY','FI','436941228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:47',0,'2014-03-01 19:11:03'),(14483,14934,'2014-01-01','ET','2',1,NULL,'Candace Herod','FI','434883430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:45',0,'2014-03-02 05:38:34'),(422,422,'2014-01-01','ET','2',1,NULL,'Joe Ott','FI','288528628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:05',0,'2014-03-01 15:21:15'),(11926,11926,'2014-01-01','ET','2',2,1,'Robert Swartz','FI','268527921','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:48',0,'2014-03-10 13:52:32'),(2927,2927,'2014-01-01','ET','2',1,NULL,'Gary Brandstetter','FI','298862359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:49',0,'2014-03-01 15:37:30'),(17587,18237,'0000-00-00','ET','2',5,4,'Kathrine Simmons','94','0001066019','Summa Insurance Company, Inc.','FI','341809108','Michael  Lemon','94','11578839','348','2014-03-01','Sync Success',0,'2014-02-07 19:01:03',0,'2014-03-10 16:24:30'),(17712,18362,'0000-00-00','ET','2',1,NULL,'Trung Thanh Vo','FI','612835257','Starmount Life Insurance Company','FI','720977315','Jimmy Hiep Dao','94','1175562','348','2014-03-01','Sync Success',0,'2014-02-09 19:00:10',0,'2014-03-02 06:31:45'),(21282,21932,'0000-00-00','ET','2',1,NULL,'SHIRLEY MARTIN','FI','428210631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:50',0,'2014-03-02 07:23:39'),(15193,15644,'0000-00-00','ET','2',1,NULL,'Robin Elaine January','FI','427197283','Starmount Life Insurance Company','FI','720977315','Hazel  Porter','94','4737919','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:20',0,'2014-03-02 05:52:31'),(332,332,'2014-01-01','ET','2',1,NULL,'Kurtis Witt','FI','301601671','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:14',0,'2014-03-01 15:21:15'),(14858,15309,'2014-01-01','ET','2',1,NULL,'don huey','FI','574765278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:05',0,'2014-03-02 05:45:37'),(11708,11708,'2014-01-01','ET','2',1,NULL,'Joshua Bybee','FI','548331201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:08',0,'2014-03-02 04:59:36'),(1205,1205,'2014-01-01','ET','2',1,NULL,'Nathaniel Merrill','FI','286643853','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:57',0,'2014-03-10 13:52:32'),(5949,5949,'2014-01-01','ET','2',1,NULL,'Camilo Harris','FI','437598745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:17',0,'2014-03-02 02:10:49'),(11295,11295,'2014-01-01','ET','2',1,NULL,'SAMANTHA DANGERFIELD','FI','438157344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:21',0,'2014-03-02 04:52:44'),(11058,11058,'2014-01-01','ET','2',1,NULL,'Lindsay Marrone','FI','288760213','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:44',0,'2014-03-10 15:59:47'),(4604,4604,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','357','2014-01-01','Sync Success',0,'2013-12-25 23:47:22',0,'2014-03-01 16:15:39'),(10963,10963,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:32',0,'2014-03-10 16:03:49'),(17572,18222,'0000-00-00','ET','2',1,NULL,'Martha Showalter','FI','302521978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:51',0,'2014-03-01 17:20:55'),(17950,18600,'0000-00-00','ET','2',1,NULL,'Terri Black','FI','293428695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:03',0,'2014-03-01 17:20:55'),(22164,22814,'0000-00-00','ET','2',1,NULL,'CURITIA V EMBRY','FI','272720747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:01:14',0,'2014-03-06 21:36:23'),(143,143,'2014-01-01','ET','2',1,NULL,'TERANCE GOTTWALT','FI','288544058','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:27',0,'2014-03-10 15:45:56'),(15265,15716,'0000-00-00','ET','2',2,1,'RUTH ANN BOLING','FI','300485249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:40',0,'2014-03-01 16:50:53'),(15160,15611,'0000-00-00','ET','2',1,NULL,'BECKEY SWEETLAND MACOY','FI','292824257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:33',0,'2014-03-02 05:52:31'),(5885,5885,'2014-01-01','ET','2',1,NULL,'Heidi Beane','FI','277847138','Summa Insurance Company, Inc.','FI','341809108','Michael  Backus','94','7236224','348','2014-01-01','Sync Success',0,'2013-12-26 02:30:16',0,'2014-03-10 15:52:36'),(5157,5157,'2014-01-01','ET','2',1,NULL,'Darryl Easterling','FI','226379625','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:01',0,'2014-03-10 15:45:56'),(11750,11750,'2014-01-01','ET','2',1,NULL,'Charles Jackson','FI','300700371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:27',0,'2014-03-01 16:30:17'),(5093,5093,'2014-01-01','ET','2',2,1,'Anne Morgan','FI','435532635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:57',0,'2014-03-02 00:10:48'),(4983,4983,'2014-01-01','ET','2',1,NULL,'Brandon Allen','FI','272920366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:26',0,'2014-03-01 15:31:33'),(4852,4852,'2014-01-01','ET','2',1,NULL,'Michael King','FI','467294996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:15:40',0,'2014-03-01 20:10:57'),(18847,19497,'0000-00-00','ET','2',1,NULL,'Sarah Mendoza','FI','635090745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:23',0,'2014-03-02 06:52:12'),(20457,21107,'0000-00-00','ET','2',1,NULL,'dorian lindsey','FI','355544303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:13',0,'2014-03-01 18:08:07'),(21648,22298,'0000-00-00','ET','2',1,NULL,'Gregory Arnold','FI','289540032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:57',0,'2014-03-04 21:36:30'),(13374,13730,'2014-01-01','ET','2',1,NULL,'Kevin Brodwick','FI','458451627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:42',0,'2014-03-02 05:24:45'),(824,824,'2014-01-01','ET','2',2,1,'tonjia reed','FI','459137144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:05',0,'2014-03-01 19:11:03'),(2869,2869,'2014-01-01','ET','2',1,NULL,'Denise Layton','FI','276644143','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:36',0,'2014-03-10 13:39:10'),(2798,2798,'2014-01-01','ET','2',1,NULL,'kelly withrow','FI','400040720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:17',0,'2014-03-01 16:05:34'),(16635,17285,'0000-00-00','ET','2',1,NULL,'Dwayne Crowe','FI','255536304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:31',0,'2014-03-02 06:17:30'),(16862,17512,'0000-00-00','ET','2',1,NULL,'Gregory Carter','FI','295782756','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:33',0,'2014-03-10 14:20:26'),(16867,17517,'0000-00-00','ET','2',1,NULL,'LaBreda Gray','FI','437518860','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:07',0,'2014-03-02 06:17:30'),(18818,19468,'0000-00-00','ET','2',1,NULL,'Vanessia Coulter','FI','450298265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:03',0,'2014-03-02 06:52:12'),(18851,19501,'0000-00-00','ET','2',1,NULL,'Robert Mitchell','FI','327623312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:26',0,'2014-03-02 06:52:12'),(18982,19632,'0000-00-00','ET','2',1,NULL,'Emily Egan','FI','044748322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:02',0,'2014-03-02 06:52:12'),(17144,17794,'0000-00-00','ET','2',2,1,'Nicole Hagerty','FI','273904812','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:28',0,'2014-03-10 16:24:30'),(19593,20243,'0000-00-00','ET','2',1,NULL,'Basel Jalal Musharbash','FI','641988141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:30:54',0,'2014-03-02 06:59:07'),(19755,20405,'0000-00-00','ET','2',1,NULL,'Diane m Cain','FI','297807583','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:10',0,'2014-03-10 16:38:05'),(19844,20494,'0000-00-00','ET','2',1,NULL,'Cori Leach','FI','451239226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:59',0,'2014-03-02 07:03:25'),(20050,20700,'0000-00-00','ET','2',1,NULL,'annette goldberg','FI','457884833','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:11',0,'2014-03-02 07:10:28'),(20475,21125,'0000-00-00','ET','2',2,1,'Michael Harty','FI','291866895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:26',0,'2014-03-01 18:08:07'),(3989,3989,'2014-01-01','ET','2',2,1,'Daniel Sharkey','FI','293504076','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:53',0,'2014-03-10 13:10:24'),(199,199,'2014-01-01','ET','2',1,NULL,'Julettia Cooper','FI','296588100','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:14',0,'2014-03-10 13:10:24'),(7633,7633,'2014-01-01','ET','2',1,NULL,'Javier A Torres','FI','463295304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:19',0,'2014-03-02 04:10:25'),(6303,6303,'2014-01-01','ET','2',1,NULL,'Mary Melissa Boone','FI','426372507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:07:29',0,'2014-03-02 04:10:25'),(2174,2174,'2014-01-01','ET','2',1,NULL,'Carla Housh','FI','462158691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:18',0,'2014-03-01 21:11:04'),(16347,16997,'0000-00-00','ET','2',1,NULL,'EVA S SHOOKS','FI','276567899','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:52',0,'2014-03-01 16:56:22'),(17046,17696,'0000-00-00','ET','2',1,NULL,'abram finfrock','FI','432697120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:28',0,'2014-03-02 06:24:38'),(19525,20175,'0000-00-00','ET','2',1,NULL,'Lisa Smith','FI','278828586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:11:25',0,'2014-03-01 17:47:19'),(113,113,'2014-01-01','ET','2',1,NULL,'Barbara DeFratis','FI','296480785','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:27',0,'2014-03-10 15:45:56'),(14110,14561,'2014-01-01','ET','2',1,NULL,'Mark A Loudermilk','FI','279725056','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:42',0,'2014-03-01 16:40:16'),(13738,14094,'2014-01-01','ET','2',1,NULL,'RAHIM ASHRAF','FI','437716085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:06',0,'2014-03-02 05:24:45'),(13497,13853,'2014-01-01','ET','2',2,1,'Andrew Jones','FI','455906626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:14',0,'2014-03-02 05:31:31'),(12798,12798,'2014-01-01','ET','2',1,NULL,'Robert Grace','FI','014449514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:12',0,'2014-03-02 05:10:52'),(7467,7467,'2014-01-01','ET','2',2,1,'Samuel Jimenez','FI','463131419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:52',0,'2014-03-02 04:15:49'),(7511,7511,'2014-01-01','ET','2',1,NULL,'Gillian Meadows','FI','283849407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:23',0,'2014-03-01 16:05:34'),(17420,18070,'0000-00-00','ET','2',2,1,'Julie Pryseski','FI','300601510','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:55',0,'2014-03-10 16:24:30'),(17840,18490,'0000-00-00','ET','2',1,NULL,'David L Bunnell','FI','287862354','HealthSpan','FI','311431434','Thomas  Konzen','94','7981943','348','2014-03-01','Sync Success',0,'2014-02-10 11:01:07',0,'2014-03-10 14:10:12'),(22737,23387,'0000-00-00','ET','2',1,NULL,'Charnell Tademy','FI','439797011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-09 21:00:01',0,'2014-03-09 21:26:00'),(11143,11143,'2014-01-01','ET','2',2,1,'Kenneth Day','FI','300489722','HealthSpan','FI','311431434','Michael  Webber Jr','94','968310','348','2014-01-01','Sync Success',0,'2013-12-26 13:15:42',0,'2014-03-10 13:45:57'),(11140,11140,'2014-01-01','ET','2',1,NULL,'Sarah Hyatt','FI','283904113','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:36',0,'2014-03-10 13:45:57'),(2506,2506,'2014-01-01','ET','2',1,0,'adam pesek','FI','269747521','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:14',0,'2014-03-01 15:05:09'),(1605,1605,'2014-01-01','ET','2',1,NULL,'Jeremy DeShazer','FI','445848555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:20',0,'2014-03-01 20:10:57'),(16381,17031,'0000-00-00','ET','2',1,NULL,'LaDeldrick Gillyard','FI','436712884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:14',0,'2014-03-02 06:10:30'),(19756,20406,'0000-00-00','ET','2',1,NULL,'Diane m Cain','FI','297807583','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:10',0,'2014-03-10 16:38:05'),(20405,21055,'0000-00-00','ET','2',1,NULL,'JERMAINE VENIBLE','FI','437373684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:31',0,'2014-03-02 07:10:28'),(22209,22859,'0000-00-00','ET','2',1,NULL,'Patricia Whipkey','FI','301447823','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:46',0,'2014-03-06 21:36:23'),(4568,4568,'2014-01-01','ET','2',1,NULL,'Clarence Johnson','FI','571118455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:46:16',0,'2014-03-02 04:38:08'),(4393,4393,'2014-01-01','ET','2',2,1,'Polly Ann Hill','FI','302766164','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:42',0,'2014-03-01 15:16:37'),(14592,15043,'2014-01-01','ET','2',1,NULL,'Fernando  Martinez','FI','637767379','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:45',0,'2014-03-02 05:45:37'),(1544,1544,'2014-01-01','ET','2',1,NULL,'Brenda  Johnson','FI','289589516','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:45',0,'2014-03-10 13:52:32'),(2155,2155,'2014-01-01','ET','2',1,NULL,'Cynthia Galvan','FI','456692387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:38',0,'2014-03-01 21:11:04'),(3502,3502,'2014-01-01','ET','2',1,NULL,'PASHULA L JOHNSON','FI','289788945','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:17',0,'2014-03-01 15:37:30'),(3099,3099,'2014-01-01','ET','2',2,1,'BARBARA LINDE','FI','439920749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:10',0,'2014-03-02 01:10:33'),(7419,7419,'2014-01-01','ET','2',1,NULL,'Laci Hayes','FI','433750484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:29',0,'2014-03-02 04:15:49'),(7593,7593,'2014-01-01','ET','2',1,NULL,'Rosie Jackson','FI','428904772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:05',0,'2014-03-02 04:15:49'),(11625,11625,'2014-01-01','ET','2',1,NULL,'Subrina Bennett - Long','FI','277802912','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:30',0,'2014-03-10 13:52:32'),(12281,12281,'2014-01-01','ET','2',1,NULL,'Jessica Kennedy','FI','296845342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:34',0,'2014-03-01 16:35:14'),(12426,12426,'2014-01-01','ET','2',1,NULL,'Byron Scott','FI','439531165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:37',0,'2014-03-02 05:03:29'),(12477,12477,'2014-01-01','ET','2',4,3,'Crystal McGuire','FI','402338190','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','348','2014-02-01','Sync Success',1,'2014-01-02 04:32:25',0,'2014-03-01 16:30:17'),(12712,12712,'2014-01-01','ET','2',1,NULL,'SOLEIL DELEON','FI','596263771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:12',0,'2014-03-02 05:10:52'),(13281,13637,'2014-01-01','ET','2',1,NULL,'Stacy Dedon','FI','437457897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:05',0,'2014-03-02 05:24:45'),(13420,13776,'2014-01-01','ET','2',1,NULL,'Brandi Buchenau','FI','295861168','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:03',0,'2014-03-10 13:59:38'),(15968,16617,'0000-00-00','ET','2',1,NULL,'Lee Roussel','FI','434592112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-26 19:00:15',NULL,NULL),(19526,20176,'0000-00-00','ET','2',1,NULL,'EDWIN MIKESELL','FI','274686953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:11:29',0,'2014-03-01 17:47:19'),(20753,21403,'0000-00-00','ET','2',1,NULL,'James McClung','FI','428672975','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:36',0,'2014-03-02 07:17:36'),(15604,16055,'0000-00-00','ET','2',1,NULL,'BETTY JEAN EDWARDS','FI','435941792','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:38',0,'2014-03-02 05:59:43'),(489,489,'2014-01-01','ET','2',1,NULL,'Mitchell Deffenbaugh','FI','274783135','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:08',0,'2014-03-01 15:48:04'),(726,726,'2014-01-01','ET','2',1,NULL,'Michael Hall','FI','286800763','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:38',0,'2014-03-10 13:24:34'),(13220,13576,'2014-01-01','ET','2',1,NULL,'Kelley Gilberry','FI','592180491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:52',0,'2014-03-02 05:17:40'),(5901,5901,'2014-01-01','ET','2',1,NULL,'Naomi Skeltis','FI','364062382','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:49',0,'2014-03-01 15:48:04'),(11339,11339,'2014-01-01','ET','2',1,NULL,'Eric Rodriguez','FI','456794287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:42',0,'2014-03-02 04:52:44'),(5546,5546,'2014-01-01','ET','2',1,NULL,'marco dimarco','FI','276444597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:56',0,'2014-03-01 16:23:43'),(15561,16012,'0000-00-00','ET','2',4,3,'Miguel Ventura','FI','299115616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:18',0,'2014-03-01 16:50:53'),(6387,6387,'2014-01-01','ET','2',1,NULL,'RORY COOK','FI','283549271','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:05',0,'2014-03-10 13:39:10'),(13089,13445,'2014-01-01','ET','2',3,2,'NORMA  BADER','FI','271845164','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:34',0,'2014-03-01 16:35:14'),(12881,12881,'2014-01-01','ET','2',1,NULL,'Jennifer Forcier','FI','295821325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:12',0,'2014-03-01 16:35:14'),(4565,4565,'2014-01-01','ET','2',1,NULL,'David Sterling','FI','438594053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:11',0,'2014-03-02 04:38:08'),(5168,5168,'2014-01-01','ET','2',1,NULL,'Richard Paul Caplinger','FI','286706026','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:20',0,'2014-03-10 13:20:27'),(7699,7699,'2014-01-01','ET','2',2,1,'debra  brosky','FI','300544448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:25',0,'2014-03-01 15:10:22'),(16700,17350,'0000-00-00','ET','2',1,NULL,'Kelly Bressler','FI','298901420','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:17',0,'2014-03-01 17:00:58'),(16968,17618,'0000-00-00','ET','2',1,NULL,'Sandra L Campbell','FI','285667579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:10',0,'2014-03-01 17:00:58'),(19157,19807,'0000-00-00','ET','2',1,NULL,'Sandra Beall','FI','452735641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:29',0,'2014-03-02 06:52:12'),(19648,20298,'0000-00-00','ET','2',1,NULL,'Nancy Moore','FI','277689072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:42:43',0,'2014-03-01 17:47:19'),(22717,23367,'0000-00-00','ET','2',1,NULL,'Kelly Jo Rorrer','FI','301560068','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:31:11',0,'2014-03-10 16:44:18'),(15666,16315,'0000-00-00','ET','2',1,NULL,'Haiyan Wu','FI','060981380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:24',0,'2014-03-01 16:56:22'),(15194,15645,'0000-00-00','ET','2',1,NULL,'ADA  D BALDWIN','FI','426199873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:44:21',0,'2014-03-02 05:52:31'),(12911,12911,'2014-01-01','ET','2',1,NULL,'Walter Burnom','FI','435118424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:05:19',0,'2014-03-02 05:10:52'),(3087,3087,'2014-01-01','ET','2',1,NULL,'Rose Foster','FI','436357271','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:48',0,'2014-03-02 01:10:33'),(11198,11198,'2014-01-01','ET','2',2,1,'ANGIE  DEMITRY','FI','291747243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:23',0,'2014-03-01 16:23:43'),(19109,19759,'0000-00-00','ET','2',1,NULL,'Fadi Al Baff','FI','297150377','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:50',0,'2014-03-10 14:31:05'),(20742,21392,'0000-00-00','ET','2',1,NULL,'JANE ERIKA FLETCHER','FI','277701911','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:31',0,'2014-03-01 18:10:11'),(14722,15173,'2014-01-01','ET','2',1,NULL,'Lenard Davis','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:09',0,'2014-03-02 05:45:37'),(4763,4763,'2014-01-01','ET','2',1,NULL,'Kara Louisa Lindelof','FI','027644543','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:45',0,'2014-03-01 15:16:37'),(6308,6308,'2014-01-01','ET','2',1,NULL,'clara mora','FI','111586594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:38',0,'2014-03-02 04:10:25'),(4236,4236,'2014-01-01','ET','2',2,1,'Douglas I Landry','FI','278547203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:21',0,'2014-03-01 16:00:27'),(5577,5577,'2014-01-01','ET','2',1,NULL,'Green Hall','FI','458920287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:55',0,'2014-03-02 04:45:37'),(18245,18895,'0000-00-00','ET','2',3,2,'Min Tsai','FI','622803805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:31',0,'2014-03-02 06:38:05'),(18663,19313,'0000-00-00','ET','2',2,1,'Teresa Lopez','FI','452133773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:23',0,'2014-03-02 06:45:14'),(22018,22668,'0000-00-00','ET','2',1,NULL,'Suzanne Renee Roth','FI','281504460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-05 21:32:04',0,'2014-03-05 21:36:22'),(14630,15081,'2014-01-01','ET','2',1,NULL,'tonya eismon','FI','278642531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:09',0,'2014-03-01 16:46:19'),(2521,2521,'2014-01-01','ET','2',1,NULL,'MARTIN CAVAZOS','FI','457881743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:41',0,'2014-03-01 20:10:57'),(13619,13975,'2014-01-01','ET','2',1,NULL,'Kelsey Allen','FI','278945925','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:39',0,'2014-03-10 16:10:34'),(2113,2113,'2014-01-01','ET','2',1,NULL,'Darryl Roberts','FI','289622356','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:20',0,'2014-03-01 15:16:37'),(10920,10920,'2014-01-01','ET','2',2,1,'joseph chick','FI','277821532','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:18',0,'2014-03-10 16:03:49'),(16536,17186,'0000-00-00','ET','2',1,NULL,'DEBORAH LEE VARGO','FI','287541072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:00',0,'2014-03-01 17:00:58'),(16570,17220,'0000-00-00','ET','2',1,NULL,'Steven Siler','FI','409271564','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:23',0,'2014-03-10 14:20:26'),(18179,18829,'0000-00-00','ET','2',1,NULL,'STEPHEN  A SELF','FI','293486538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:37',0,'2014-03-01 17:26:36'),(877,877,'2014-01-01','ET','2',1,NULL,'David Gedra','FI','272449802','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:31',0,'2014-03-01 15:21:15'),(15486,15937,'0000-00-00','ET','2',1,NULL,'Shirley Roberts','FI','276542072','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:04',0,'2014-03-10 14:10:12'),(15167,15618,'0000-00-00','ET','2',1,NULL,'Phillip Clayton','FI','294806960','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:39',0,'2014-03-10 14:10:12'),(7527,7527,'2014-01-01','ET','2',1,NULL,'JOHN HOLTKAMP','FI','274540492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:55',0,'2014-03-01 16:05:34'),(2365,2365,'2014-01-01','ET','2',1,NULL,'Matthew Conaway','FI','280926916','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:11',0,'2014-03-01 15:26:40'),(15102,15553,'0000-00-00','ET','2',1,NULL,'LEE GARCIA','FI','465310830','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:51',0,'2014-03-02 05:52:31'),(14659,15110,'2014-01-01','ET','2',1,NULL,'Josh salmons','FI','270923120','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:45:28',0,'2014-03-01 16:46:19'),(7459,7459,'2014-01-01','ET','2',1,NULL,'LINDA FERGUSON','FI','451883752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:39',0,'2014-03-02 04:15:49'),(4966,4966,'2014-01-01','ET','2',1,0,'John Wright','FI','642129254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:19',0,'2014-03-01 19:11:03'),(14285,14736,'2014-01-01','ET','2',1,NULL,'EUGENIA DAVIS','FI','288521369','Dental Care Plus, Inc.','FI','311185262','JULIAN  LEE','94','7970773','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:18',0,'2014-03-01 16:46:19'),(13270,13626,'2014-01-01','ET','2',1,NULL,'Rosemary Brundy','FI','433179508','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:00',0,'2014-03-02 05:24:45'),(12146,12146,'2014-01-01','ET','2',1,NULL,'Stephen  Lee Nolan','FI','426080661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:19',0,'2014-03-02 04:59:36'),(13055,13411,'2014-01-01','ET','2',1,NULL,'CIARA EZELL','FI','433719388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:01:16',0,'2014-03-02 05:17:40'),(13234,13590,'2014-01-01','ET','2',1,NULL,'david pierson','FI','464732716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:26',0,'2014-03-01 16:35:14'),(17455,18105,'0000-00-00','ET','2',1,NULL,'Marwan Kash','FI','290666631','Dental Care Plus, Inc.','FI','311185262','Matthew  Gundic','94','1751858','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:20',0,'2014-03-01 17:20:55'),(17893,18543,'0000-00-00','ET','2',2,1,'Magen Tardo','FI','439759721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:24',0,'2014-03-02 06:38:05'),(19143,19793,'0000-00-00','ET','2',1,NULL,'Mark Davis','FI','285840848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:16',0,'2014-03-10 16:31:33'),(20670,21320,'0000-00-00','ET','2',2,1,'ALFRED RUSSO','FI','056543670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:41',0,'2014-03-10 14:37:47'),(434,434,'2014-01-01','ET','2',2,1,'Lakeishia Johnson','FI','426238768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:29',0,'2014-03-01 22:10:55'),(7509,7509,'2014-01-01','ET','2',1,NULL,'Jerilyn Ernst','FI','292425846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:18',0,'2014-03-01 16:05:34'),(13759,14115,'2014-01-01','ET','2',1,NULL,'Anne Clark','FI','601649708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:20',0,'2014-03-02 05:24:45'),(7126,7126,'2014-01-01','ET','2',1,NULL,'Lamont Fayson','FI','292522693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:24',0,'2014-03-01 15:52:44'),(1322,1322,'2014-01-01','ET','2',1,NULL,'Sherry Nelson','FI','459881870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:31',0,'2014-03-02 04:38:08'),(4958,4958,'2014-01-01','ET','2',1,NULL,'christine durr','FI','587487469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:07',0,'2014-03-01 20:10:57'),(2934,2934,'2014-01-01','ET','2',1,NULL,'KARL WISEMAN','FI','233803137','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:04',0,'2014-03-01 15:37:30'),(11041,11041,'2014-01-01','ET','2',1,NULL,'Ron Rinella','FI','284524202','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-01-01','Sync Success',0,'2013-12-26 13:12:11',0,'2014-03-10 16:03:49'),(20161,20811,'0000-00-00','ET','2',1,NULL,'CHARLES J JONES','FI','278641234','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:03',0,'2014-03-01 18:08:07'),(21400,22050,'0000-00-00','ET','2',1,NULL,'TAMMY MAROUS','FI','297664313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:10',0,'2014-03-03 21:36:16'),(6987,6987,'2014-01-01','ET','2',2,1,'Tony Ginn','FI','286664879','HealthSpan','FI','311431434','John  Curry','94','10751792','348','2014-01-01','Sync Success',0,'2013-12-26 04:00:05',0,'2014-03-10 13:32:15'),(1113,1113,'2014-01-01','ET','2',1,NULL,'Jackie Cano','FI','451331765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:03',0,'2014-03-02 04:38:08'),(14559,15010,'2014-01-01','ET','2',1,NULL,'Dorinda Grizzle','FI','449412337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:24',0,'2014-03-02 05:45:37'),(337,337,'2014-01-01','ET','2',1,NULL,'QUANATA S STREAT','FI','290705828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:21',0,'2014-03-01 15:21:15'),(987,987,'2014-01-01','ET','2',1,NULL,'Bethany Lovell','FI','277880736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:47',0,'2014-03-01 15:21:15'),(15867,16516,'0000-00-00','ET','2',1,NULL,'Molly Schreiber','FI','292929903','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:52',0,'2014-03-10 14:10:12'),(7071,7071,'2014-01-01','ET','2',2,1,'Melissa Thompson','FI','284861505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:40',0,'2014-03-01 15:52:44'),(6047,6047,'2014-01-01','ET','2',1,0,'Jacob Briemel','FI','436892513','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:29',0,'2014-03-01 19:11:03'),(14704,15155,'2014-01-01','ET','2',1,NULL,'Emily Ann Price','FI','436796538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:57',0,'2014-03-02 05:45:37'),(14512,14963,'2014-01-01','ET','2',2,1,'JOHN EVES','FI','191400630','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:59',0,'2014-03-10 14:03:26'),(11004,11004,'2014-01-01','ET','2',1,NULL,'perry taylor','FI','509660116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:55',0,'2014-03-02 04:31:46'),(16149,16798,'0000-00-00','ET','2',1,NULL,'Dewayne Jones','FI','306807635','Starmount Life Insurance Company','FI','720977315','LaMonica  Stewart','94','6401868','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:07',0,'2014-03-02 06:10:30'),(20601,21251,'0000-00-00','ET','2',1,NULL,'LOUIS SALINAS','FI','291526270','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:49',0,'2014-03-01 18:08:07'),(21476,22126,'0000-00-00','ET','2',1,NULL,'Mildred Myles','FI','269607016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:30:38',0,'2014-03-03 21:36:16'),(22813,23463,'0000-00-00','ET','2',2,1,'kevin burley','FI','295529575','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:02',0,'2014-03-10 14:50:59'),(7199,7199,'2014-01-01','ET','2',1,NULL,'Trudy Bond','FI','442584137','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:35',0,'2014-03-10 13:32:15'),(5887,5887,'2014-01-01','ET','2',1,NULL,'THOMAS NETTING','FI','294580246','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:21',0,'2014-03-10 15:52:36'),(15310,15761,'0000-00-00','ET','2',2,1,'PABLITO DURO','FI','847665296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:24',0,'2014-03-01 16:50:53'),(4147,4147,'2014-01-01','ET','2',1,NULL,'Kristine Bougie','FI','288520364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:36',0,'2014-03-01 16:00:27'),(3111,3111,'2014-01-01','ET','2',1,NULL,'Robin L Anderson','FI','296501026','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:36:30',0,'2014-03-10 15:52:36'),(11706,11706,'2014-01-01','ET','2',1,NULL,'Jeff Abraham','FI','131744845','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:04',0,'2014-03-02 04:59:36'),(16328,16978,'0000-00-00','ET','2',1,NULL,'Steven Moran','FI','405110657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:41',0,'2014-03-02 06:10:30'),(19288,19938,'0000-00-00','ET','2',1,NULL,'Charlotte Robinson','FI','426138886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:10',0,'2014-03-02 06:59:07'),(20750,21400,'0000-00-00','ET','2',1,NULL,'Angela Erby','FI','427171770','Starmount Life Insurance Company','FI','720977315','christopher  bell','94','8004571','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:35',0,'2014-03-02 07:17:36'),(13508,13864,'2014-01-01','ET','2',1,NULL,'SHIRLEY M CLAYBURG','FI','467614545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:22',0,'2014-03-02 05:31:31'),(16395,17045,'0000-00-00','ET','2',1,NULL,'Vicki Steinbach','FI','450962940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-29 21:01:23',0,'2014-03-02 06:10:30'),(19713,20363,'0000-00-00','ET','2',1,NULL,'LISA NEJTEK','FI','467538061','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:30:50',0,'2014-03-02 06:59:07'),(19762,20412,'0000-00-00','ET','2',1,NULL,'thomas f hathcox','FI','434558801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:14',0,'2014-03-02 07:03:25'),(19848,20498,'0000-00-00','ET','2',1,NULL,'Jamal James-Leigh Burton','FI','434753935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:02',0,'2014-03-02 06:59:07'),(21295,21945,'0000-00-00','ET','2',1,NULL,'Terri Simones','FI','282566023','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:01:02',0,'2014-03-10 16:38:05'),(21978,22628,'0000-00-00','ET','2',1,NULL,'Manuel Sanchez','FI','425595471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:38',0,'2014-03-05 22:27:33'),(6305,6305,'2014-01-01','ET','2',2,1,'GAIL M BROWN','FI','587170080','Starmount Life Insurance Company','FI','720977315','SUTTER  SMITH','94','1655710','348','2014-01-01','Sync Success',0,'2013-12-26 03:07:31',0,'2014-03-02 04:10:25'),(15325,15776,'0000-00-00','ET','2',2,1,'Robert Collett','FI','275525116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:33',0,'2014-03-01 16:50:53'),(14457,14908,'2014-01-01','ET','2',2,1,'Mary Dennis','FI','434152141','Starmount Life Insurance Company','FI','720977315','John  T  Allen','94','4728680','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:33',0,'2014-03-02 05:38:34'),(2005,2005,'2014-01-01','ET','2',1,NULL,'Louis Sears','FI','439823535','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:02',0,'2014-03-01 23:10:52'),(13027,13383,'2014-01-01','ET','2',1,NULL,'CHARLOTTE  MOBLEY','FI','295500372','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:16',0,'2014-03-01 16:35:14'),(16620,17270,'0000-00-00','ET','2',1,NULL,'DANIEL TEED','FI','431636406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:21',0,'2014-03-02 06:17:30'),(17343,17993,'0000-00-00','ET','2',2,1,'ANGIE SMITH','FI','293823712','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:18',0,'2014-03-10 14:24:38'),(17549,18199,'0000-00-00','ET','2',1,NULL,'Jana Reiter','FI','281502635','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:00:33',0,'2014-03-10 14:24:38'),(12715,12715,'2014-01-01','ET','2',1,NULL,'Alvin dE gRATTE Stutts','FI','422746562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:21',0,'2014-03-02 05:10:52'),(10682,10682,'2014-01-01','ET','2',4,3,'MARISA JAKUPCA','FI','269869392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:51',0,'2014-03-01 16:10:36'),(11775,11775,'2014-01-01','ET','2',3,2,'misty branson','FI','270705754','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:11',0,'2014-03-10 13:52:32'),(2532,2532,'2014-01-01','ET','2',1,NULL,'Lester Rode','FI','452822981','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 20:30:58',0,'2014-03-01 20:10:57'),(16874,17524,'0000-00-00','ET','2',1,NULL,'VALERIE ANCHONDO','FI','634073230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:11',0,'2014-03-02 06:17:30'),(19243,19893,'0000-00-00','ET','2',1,NULL,'KIMM WELLS','FI','291423987','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:34',0,'2014-03-01 17:34:07'),(22066,22716,'0000-00-00','ET','2',1,NULL,'DANIEL AMBROSE','FI','300941969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:40',0,'2014-03-10 14:45:25'),(13849,14205,'2014-01-01','ET','2',1,NULL,'Anna M Clark','FI','456831458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:47',0,'2014-03-02 05:31:31'),(838,838,'2014-01-01','ET','2',1,NULL,'Kristen Doherty','FI','290926497','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:18',0,'2014-03-10 15:39:19'),(1776,1776,'2014-01-01','ET','2',1,NULL,'Cheron Holland','FI','352582071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:48',0,'2014-03-02 00:10:48'),(5241,5241,'2014-01-01','ET','2',2,1,'Cory McGuire','FI','463953250','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:43',0,'2014-03-10 13:20:27'),(6200,6200,'2014-01-01','ET','2',1,NULL,'Daniel Crawford','FI','272442348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:20',0,'2014-03-01 16:00:27'),(18197,18847,'0000-00-00','ET','2',1,NULL,'GERALD WILSON','FI','283782545','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:50',0,'2014-03-01 17:26:36'),(21798,22448,'0000-00-00','ET','2',1,NULL,'KATHY CONNER','FI','217880029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:15',0,'2014-03-04 22:25:23'),(22881,23531,'0000-00-00','ET','2',1,NULL,'gary kinnison','FI','572611088','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:24',0,'2014-03-10 21:36:25'),(14383,14834,'2014-01-01','ET','2',1,NULL,'uriah cain','FI','554310080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:59',0,'2014-03-01 16:46:19'),(10744,10744,'2014-01-01','ET','2',2,1,'Jacob Farmer','FI','281928682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:00',0,'2014-03-01 16:10:36'),(1003,1003,'2014-01-01','ET','2',1,NULL,'MAXINE CALKINS','FI','298785097','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:22',0,'2014-03-10 15:39:19'),(5562,5562,'2014-01-01','ET','2',1,NULL,'Krystal pipkin','FI','641265398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:26',0,'2014-03-02 04:45:37'),(2584,2584,'2014-01-01','ET','2',1,NULL,'maria aberman','FI','336540307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:27',0,'2014-03-01 19:11:03'),(5653,5653,'2014-01-01','ET','2',1,NULL,'Lisa Dennison','FI','428253168','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:24',0,'2014-03-02 04:45:37'),(6015,6015,'2014-01-01','ET','2',2,1,'tyler dodge','FI','299765662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:23',0,'2014-03-01 15:10:22'),(17107,17757,'0000-00-00','ET','2',1,NULL,'Michelle Weaver','FI','279821884','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:04',0,'2014-03-01 17:00:58'),(19504,20154,'0000-00-00','ET','2',1,NULL,'JUDITH BARNETTE','FI','448522568','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:04:59',0,'2014-03-10 16:38:05'),(20799,21449,'0000-00-00','ET','2',1,NULL,'Rebecca Lobato','FI','460457239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:58',0,'2014-03-02 07:17:36'),(21337,21987,'0000-00-00','ET','2',1,NULL,'Teresa Schweitzer','FI','272606391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:16',0,'2014-03-03 01:35:37'),(21512,22162,'0000-00-00','ET','2',1,NULL,'Long Nguyen','FI','629927040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:31:04',0,'2014-03-03 22:26:43'),(22233,22883,'0000-00-00','ET','2',1,NULL,'rita knox','94','0000355615','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:04',0,'2014-03-06 21:27:26'),(22265,22915,'0000-00-00','ET','2',1,NULL,'BROOKS DEMARCO','FI','279504093','Summa Insurance Company, Inc.','FI','341809108','ANTHONY  LANCIANESE','94','7462726','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:27',0,'2014-03-10 16:44:18'),(22405,23055,'0000-00-00','ET','2',1,NULL,'Katie Long','FI','640540595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:02',0,'2014-03-07 22:26:59'),(15700,16349,'0000-00-00','ET','2',1,NULL,'Christopher Paul Pruett','FI','630301659','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:48',0,'2014-03-02 05:59:43'),(5952,5952,'2014-01-01','ET','2',1,NULL,'Chandrakanthi Rajendran','FI','299885421','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:22',0,'2014-03-10 13:24:34'),(13657,14013,'2014-01-01','ET','2',2,1,'Javonne Deshye Eatmon','FI','642182014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:14',0,'2014-03-02 05:24:45'),(979,979,'2014-01-01','ET','2',1,NULL,'Lloyd Morris','FI','273566197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:19:34',0,'2014-03-01 15:21:15'),(5244,5244,'2014-01-01','ET','2',1,NULL,'Deborah Livers','FI','279584380','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:50',0,'2014-03-10 13:20:27'),(4905,4905,'2014-01-01','ET','2',1,NULL,'Dale Churchill','FI','450987297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:18',0,'2014-03-01 19:11:03'),(2766,2766,'2014-01-01','ET','2',1,NULL,'Timothy Krueger','FI','282824632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:19:14',0,'2014-03-01 16:05:34'),(4464,4464,'2014-01-01','ET','2',1,NULL,'philip Whisner','FI','300804736','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 23:30:53',NULL,NULL),(5763,5763,'2014-01-01','ET','2',1,NULL,'MYRA ESTHER RIVERA','FI','450833350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:20',0,'2014-03-02 01:10:33'),(19508,20158,'0000-00-00','ET','2',1,NULL,'Robert Parker','FI','289829447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:05:50',0,'2014-03-01 17:34:07'),(51,51,'2014-01-01','ET','2',1,NULL,'cynthia Jackson','FI','290466298','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:31',0,'2014-03-01 15:21:15'),(16702,17352,'0000-00-00','ET','2',1,NULL,'Darren Morrison','FI','297922609','Dental Care Plus, Inc.','FI','311185262','Adam  Cupp','94','8331078','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:18',0,'2014-03-01 17:00:58'),(16241,16890,'0000-00-00','ET','2',1,NULL,'Paige Crow','FI','434794368','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:06',0,'2014-03-02 06:10:30'),(724,724,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:32',0,'2014-03-10 13:24:34'),(4834,4834,'2014-01-01','ET','2',1,NULL,'Timothy Dirr','FI','286621629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:07',0,'2014-03-01 15:10:22'),(2256,2256,'2014-01-01','ET','2',1,NULL,'Laura Beth Harolds','FI','442889401','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:07',0,'2014-03-01 21:11:04'),(14552,15003,'2014-01-01','ET','2',1,NULL,'Heather Rawlins','FI','637308939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:19',0,'2014-03-02 05:45:37'),(4312,4312,'2014-01-01','ET','2',1,NULL,'Lydell Emerson','FI','439351796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:36',0,'2014-03-02 03:09:49'),(11731,11731,'2014-01-01','ET','2',1,NULL,'cythnia PHILBRICK','FI','295623227','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:51',0,'2014-03-01 16:30:17'),(14123,14574,'2014-01-01','ET','2',1,NULL,'Nathan Philson','FI','439534169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:50',0,'2014-03-02 05:38:34'),(18939,19589,'0000-00-00','ET','2',2,1,'Gary Craddock','FI','295444280','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:29',0,'2014-03-10 16:31:33'),(20181,20831,'0000-00-00','ET','2',2,1,'YU PAO LIN','FI','621380310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:16',0,'2014-03-02 07:10:28'),(22650,23300,'0000-00-00','ET','2',1,NULL,'eric nava','FI','464231467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:20',0,'2014-03-08 22:26:18'),(22827,23477,'0000-00-00','ET','2',1,NULL,'Diane Lynn Bellmore-Reeves','FI','292503283','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:15',0,'2014-03-10 14:50:59'),(10989,10989,'2014-01-01','ET','2',1,NULL,'Leon Harris','FI','587500950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:23',0,'2014-03-02 04:24:47'),(16206,16855,'0000-00-00','ET','2',1,NULL,'KRISTI SMITH  WOODS','FI','458199493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:43',0,'2014-03-02 06:03:21'),(15087,15538,'0000-00-00','ET','2',1,NULL,'DEBORAH BLYTHE','FI','268627118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:40',0,'2014-03-01 16:50:53'),(10845,10845,'2014-01-01','ET','2',3,2,'William Hodosko','FI','280462948','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:19',0,'2014-03-10 13:39:10'),(6372,6372,'2014-01-01','ET','2',1,NULL,'CLETUS PHOENIX','FI','302682548','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:38',0,'2014-03-10 13:39:10'),(14076,14527,'2014-01-01','ET','2',1,NULL,'Mary Evelyn Pundt','FI','458966641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:20',0,'2014-03-02 05:38:34'),(6019,6019,'2014-01-01','ET','2',2,1,'DENNIS DEITZ','FI','297589706','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:31',0,'2014-03-10 15:39:19'),(5785,5785,'2014-01-01','ET','2',1,NULL,'Aaron Sells','FI','268521963','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:05',0,'2014-03-10 15:52:36'),(12265,12265,'2014-01-01','ET','2',3,2,'Martin Johnson','FI','513646078','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:01',0,'2014-03-10 13:59:38'),(13838,14194,'2014-01-01','ET','2',2,1,'Michael Pitts','FI','466158728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:39',0,'2014-03-02 05:31:31'),(13356,13712,'2014-01-01','ET','2',1,NULL,'Christopher Sellers','FI','452750533','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:34',0,'2014-03-02 05:24:45'),(17212,17862,'0000-00-00','ET','2',2,1,'jessica mccarty','FI','282888050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:12',0,'2014-03-01 17:20:55'),(18399,19049,'0000-00-00','ET','2',1,NULL,'WEIBIN LU','FI','115941817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:59',0,'2014-03-02 06:45:14'),(20368,21018,'0000-00-00','ET','2',1,NULL,'BONNIE LEE','FI','272529176','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:53',0,'2014-03-10 14:37:47'),(20460,21110,'0000-00-00','ET','2',1,NULL,'Michael Peterson','FI','300744750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:16',0,'2014-03-01 18:08:07'),(21772,22422,'0000-00-00','ET','2',2,1,'qiao zheng','FI','054945151','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:39',0,'2014-03-10 14:45:25'),(22570,23220,'0000-00-00','ET','2',1,NULL,'MARSENA MARTINEZ','FI','460040427','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:00',0,'2014-03-10 14:50:59'),(22776,23426,'0000-00-00','ET','2',2,1,'ABDI YUSUF','FI','269044266','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:30',0,'2014-03-09 21:35:27'),(71,71,'2014-01-01','ET','2',1,NULL,'Tamara Whitehouse','FI','270680616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:10',0,'2014-03-01 15:26:40'),(15181,15632,'0000-00-00','ET','2',1,NULL,'Lawanda Ryals','FI','427372962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:13',0,'2014-03-02 05:52:31'),(11029,11029,'2014-01-01','ET','2',1,NULL,'Angelica Pozo','FI','103464017','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:11:47',0,'2014-03-10 13:39:10'),(14622,15073,'2014-01-01','ET','2',1,NULL,'Karen Holtkamp','FI','281866746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:03',0,'2014-03-01 16:46:19'),(7244,7244,'2014-01-01','ET','2',1,NULL,'DEREK BROWN','FI','425291754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:01',0,'2014-03-02 03:09:49'),(3299,3299,'2014-01-01','ET','2',1,NULL,'MICHAEL P DIAMOND','FI','286781615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:24',0,'2014-03-01 15:52:44'),(1828,1828,'2014-01-01','ET','2',1,NULL,'Kathleen Brinkman','FI','283503804','HealthSpan','FI','311431434','Lauren  Hermiller','94','16945220','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:29',0,'2014-03-10 13:20:27'),(22637,23287,'0000-00-00','ET','2',1,NULL,'JACQUELINE L MOON','FI','301562924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:10',0,'2014-03-08 21:35:36'),(11699,11699,'2014-01-01','ET','2',1,NULL,'STACY GREEN','FI','525290227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:07:53',0,'2014-03-02 04:59:36'),(17419,18069,'0000-00-00','ET','2',2,1,'Laura Chryst','FI','301727473','Summa Insurance Company, Inc.','FI','341809108','Jeff  Harkleroad','94','1772711','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:55',0,'2014-03-10 16:24:30'),(14866,15317,'2014-01-01','ET','2',1,NULL,'Joshua Barker','FI','640058191','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-17 03:35:08',0,'2014-03-02 05:52:31'),(1713,1713,'2014-01-01','ET','2',1,NULL,'Joelle Flaherty','FI','304641969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:54',0,'2014-03-02 00:10:48'),(2118,2118,'2014-01-01','ET','2',1,NULL,'VICTOR L BULLOCK','FI','298564282','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:29',0,'2014-03-01 15:16:37'),(4514,4514,'2014-01-01','ET','2',1,NULL,'DENISE MUSTAIN','FI','276541608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:32',0,'2014-03-01 15:16:37'),(2996,2996,'2014-01-01','ET','2',1,NULL,'Deborah Dillingham','FI','460909637','Starmount Life Insurance Company','FI','720977315','Greg  Myer','94','11145068','348','2014-01-01','Sync Success',0,'2013-12-25 21:33:00',0,'2014-03-02 01:10:33'),(3359,3359,'2014-01-01','ET','2',1,NULL,'Carrie Franklin','FI','456043664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:25',0,'2014-03-02 02:10:49'),(19395,20045,'0000-00-00','ET','2',1,NULL,'Amy Murphy','FI','288566487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:04',0,'2014-03-01 17:34:07'),(6020,6020,'2014-01-01','ET','2',1,NULL,'Sheri Harold','FI','282804532','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:34',0,'2014-03-10 15:39:19'),(17769,18419,'0000-00-00','ET','2',1,NULL,'MARIA D FLORES','FI','645429257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:08',0,'2014-03-02 06:17:30'),(15467,15918,'0000-00-00','ET','2',1,NULL,'Robert Schroer','FI','291484393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:52',0,'2014-03-01 16:50:53'),(14407,14858,'2014-01-01','ET','2',1,NULL,'Sheila Caynor','FI','301463843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:10',0,'2014-03-01 16:46:19'),(1711,1711,'2014-01-01','ET','2',1,NULL,'TIYAWNA AUGUSTUS','FI','436615291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:51',0,'2014-03-02 00:10:48'),(5076,5076,'2014-01-01','ET','2',1,NULL,'esther newell','FI','277542256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:26',0,'2014-03-01 15:31:33'),(13977,14333,'2014-01-01','ET','2',1,NULL,'Sabrina Daniels','FI','640186726','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:13',0,'2014-03-02 05:31:31'),(3289,3289,'2014-01-01','ET','2',1,NULL,'TINA YATES','FI','299764066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:06',0,'2014-03-01 15:48:04'),(20427,21077,'0000-00-00','ET','2',1,NULL,'Catherine Terrell','FI','587667368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:47',0,'2014-03-01 18:08:07'),(20830,21480,'0000-00-00','ET','2',1,NULL,'KAMLESH PATEL','FI','642243234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:13',0,'2014-03-02 07:17:36'),(21621,22271,'0000-00-00','ET','2',1,NULL,'James Trujillo','FI','458611339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:37',0,'2014-03-04 21:27:16'),(22078,22728,'0000-00-00','ET','2',1,NULL,'Asiah Morris','FI','644010576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:13',0,'2014-03-06 21:27:26'),(17121,17771,'0000-00-00','ET','2',1,NULL,'Rhonda Stoner','FI','301684815','HealthSpan','FI','311431434','Brooke  Bowerman','94','1854510','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:13',0,'2014-03-10 14:24:38'),(14549,15000,'2014-01-01','ET','2',1,NULL,'Brad Stone','FI','446928158','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:17',0,'2014-03-02 05:45:37'),(7346,7346,'2014-01-01','ET','2',1,NULL,'bret n gervais','FI','439775703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:21',0,'2014-03-01 21:11:04'),(1745,1745,'2014-01-01','ET','2',2,1,'TANVIR FAROOQ','FI','284028153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:49',0,'2014-03-01 15:31:33'),(12810,12810,'2014-01-01','ET','2',2,1,'ANGELA ZAMORA','FI','678831554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:37',0,'2014-03-02 05:17:40'),(5368,5368,'2014-01-01','ET','2',1,NULL,'Elizabeth Smith','FI','434339860','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:29',0,'2014-03-01 21:11:04'),(3835,3835,'2014-01-01','ET','2',1,NULL,'Michael Burke','FI','269903112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:07',0,'2014-03-10 15:39:19'),(3826,3826,'2014-01-01','ET','2',1,NULL,'Peter Trokan','FI','393948788','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:17',0,'2014-03-10 13:20:27'),(18614,19264,'0000-00-00','ET','2',1,NULL,'Kathy Smith','FI','282562864','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:45',0,'2014-03-10 16:31:33'),(18885,19535,'0000-00-00','ET','2',1,NULL,'Uriah Anderson','FI','474023862','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:51',0,'2014-03-01 17:34:07'),(20246,20896,'0000-00-00','ET','2',1,NULL,'Margaret Newton','FI','271525872','HealthSpan','FI','311431434','Britt  Parent','94','1888385','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:06',0,'2014-03-10 14:37:47'),(428,428,'2014-01-01','ET','2',1,NULL,'Susan Herchenroeder','FI','272562193','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:18',0,'2014-03-10 15:39:19'),(16294,16944,'0000-00-00','ET','2',1,NULL,'Mary Putman','FI','263863419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:19',0,'2014-03-02 06:10:30'),(2129,2129,'2014-01-01','ET','2',1,NULL,'Paul Williams','FI','406119033','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:48',0,'2014-03-01 15:16:37'),(7338,7338,'2014-01-01','ET','2',1,NULL,'Alicia P Ryan','FI','415848730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:04',0,'2014-03-01 21:11:04'),(15350,15801,'0000-00-00','ET','2',1,NULL,'Billy  Jones','FI','274808606','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:46:49',0,'2014-03-10 14:10:12'),(5461,5461,'2014-01-01','ET','2',1,NULL,'EDWARD R POPE','FI','477045043','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:11',0,'2014-03-02 04:45:37'),(7014,7014,'2014-01-01','ET','2',1,NULL,'letty armendariz','FI','449493779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:56',0,'2014-03-02 03:09:49'),(5941,5941,'2014-01-01','ET','2',1,NULL,'THOMAS J GASPER','FI','437674106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:32:04',0,'2014-03-02 01:10:33'),(18095,18745,'0000-00-00','ET','2',2,1,'Maria Carrizales','FI','461455485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:34',0,'2014-03-02 06:38:05'),(20055,20705,'0000-00-00','ET','2',2,1,'Jose Guajardo','FI','632182115','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:15',0,'2014-03-02 07:10:28'),(16486,17136,'0000-00-00','ET','2',1,NULL,'CLAYTON PACATTE','FI','645093987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:28',0,'2014-03-02 06:10:30'),(15870,16519,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:53',0,'2014-03-02 06:03:21'),(2901,2901,'2014-01-01','ET','2',1,NULL,'Elizabeth Stricker','FI','291509256','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:48',0,'2014-03-10 13:39:10'),(19335,19985,'0000-00-00','ET','2',1,NULL,'Lucero J NIETO DE BERLANGA','FI','640568777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:23',0,'2014-03-02 06:59:07'),(20728,21378,'0000-00-00','ET','2',1,NULL,'CAROL FOUT','FI','269589262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:30:26',0,'2014-03-01 18:10:11'),(21900,22550,'0000-00-00','ET','2',2,1,'Esperanza BELACYUEC','FI','462257367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:44',0,'2014-03-05 22:27:33'),(12421,12421,'2014-01-01','ET','2',1,NULL,'Jerry Stewart','FI','435639132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:26',0,'2014-03-02 05:03:29'),(14942,15393,'2014-01-01','ET','2',1,NULL,'Keith James Galbraith','FI','279587621','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:44',0,'2014-03-10 14:10:12'),(12848,12848,'2014-01-01','ET','2',1,NULL,'DELIA ESCOBEDO','FI','461371784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:59',0,'2014-03-02 05:10:52'),(21260,21910,'0000-00-00','ET','2',1,NULL,'Emily c maritim','FI','732249845','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:36',0,'2014-03-01 21:35:40'),(22460,23110,'0000-00-00','ET','2',2,1,'JESSICA JONES','FI','286840549','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:42',0,'2014-03-10 16:44:18'),(12494,12494,'2014-01-01','ET','2',1,NULL,'ANJOHNETTE W GIBBS','FI','343527955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:09',0,'2014-03-02 05:03:29'),(1023,1023,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:21:00',0,'2014-03-10 15:39:19'),(12073,12073,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:48',0,'2014-03-01 16:30:17'),(17174,17824,'0000-00-00','ET','2',4,3,'HELEN ON','FI','281111735','HealthSpan','FI','311431434','DARWIN  CARMICHAEL','94','1300095','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:49',0,'2014-03-10 14:20:26'),(1664,1664,'2014-01-01','ET','2',1,NULL,'ABRAHAM WINN','FI','451943387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:24',0,'2014-03-02 00:10:48'),(11508,11508,'2014-01-01','ET','2',1,NULL,'jonathon Sarmento','FI','556951358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:54',0,'2014-03-02 04:52:44'),(13137,13493,'2014-01-01','ET','2',1,NULL,'ryan fuda','FI','200629570','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:21',0,'2014-03-10 16:10:34'),(5817,5817,'2014-01-01','ET','2',1,NULL,'john kassan','FI','279481991','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:04:07',0,'2014-03-10 13:24:34'),(6291,6291,'2014-01-01','ET','2',1,NULL,'IVY PERRY','FI','547152298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:09',0,'2014-03-02 04:10:25'),(19682,20332,'0000-00-00','ET','2',1,NULL,'michael wilson','FI','243734736','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:51:10',0,'2014-03-10 14:37:47'),(20755,21405,'0000-00-00','ET','2',1,NULL,'Charley Mae Tart','FI','427278248','Starmount Life Insurance Company','FI','720977315','Kevin G Turner','94','7821904','357','2014-04-01','Sync Success',0,'2014-02-28 06:30:37',0,'2014-03-02 07:17:36'),(20966,21616,'0000-00-00','ET','2',1,NULL,'Andrew  Olinger','94','0001182479','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:17',0,'2014-03-01 18:08:07'),(821,821,'2014-01-01','ET','2',2,1,'Claire Spann','FI','267874344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:57',0,'2014-03-01 19:11:03'),(16738,17388,'0000-00-00','ET','2',1,NULL,'Nancy Kopp','FI','300501249','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:01:45',0,'2014-03-10 14:20:26'),(3490,3490,'2014-01-01','ET','2',1,NULL,'DON BRAND','FI','288521638','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:51',0,'2014-03-01 15:37:30'),(4677,4677,'2014-01-01','ET','2',1,NULL,'Navia Desiree Ferris','FI','200991496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:50',0,'2014-03-01 16:15:39'),(15101,15552,'0000-00-00','ET','2',2,1,'Lana Hoang','FI','537888696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:50',0,'2014-03-02 05:52:31'),(12578,12578,'2014-01-01','ET','2',1,NULL,'MARGARET TAKACH','FI','291527548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:19',0,'2014-03-01 16:35:14'),(10997,10997,'2014-01-01','ET','2',3,2,'Jason Scallions','FI','426236673','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:39',0,'2014-03-02 04:24:47'),(5859,5859,'2014-01-01','ET','2',1,NULL,'Andrew Mackay','FI','276849514','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:30',0,'2014-03-10 13:03:33'),(14141,14592,'2014-01-01','ET','2',1,NULL,'Kerry Watson','FI','434900569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:01',0,'2014-03-02 05:38:34'),(7203,7203,'2014-01-01','ET','2',2,1,'VICTORIA FLORES','FI','290624648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:43',0,'2014-03-01 15:52:44'),(13406,13762,'2014-01-01','ET','2',2,1,'Zong Ze Wang','FI','276964553','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:57',0,'2014-03-10 13:59:38'),(18778,19428,'0000-00-00','ET','2',1,NULL,'Steven M Glaze','FI','278849517','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:51',0,'2014-03-10 14:31:05'),(18898,19548,'0000-00-00','ET','2',1,NULL,'Emily Finsterwald','FI','278824625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:00',0,'2014-03-01 17:34:07'),(21325,21975,'0000-00-00','ET','2',1,NULL,'TIMOTHY LUWIS','FI','434432525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:10',0,'2014-03-03 01:07:25'),(16710,17360,'0000-00-00','ET','2',1,NULL,'Chelsea Sucher','FI','402273542','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:24',0,'2014-03-01 17:00:58'),(1402,1402,'2014-01-01','ET','2',1,NULL,'Anthony Beauchamp','FI','439086460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:07',0,'2014-03-02 04:38:08'),(2341,2341,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:25',0,'2014-03-01 15:26:40'),(6248,6248,'2014-01-01','ET','2',1,NULL,'chaco rathke','FI','433514884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:52',0,'2014-03-02 04:10:25'),(5003,5003,'2014-01-01','ET','2',2,1,'Betty Cordray','FI','276581838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:04',0,'2014-03-01 15:31:33'),(18225,18875,'0000-00-00','ET','2',1,NULL,'Will Nichols','FI','289520337','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:14',0,'2014-03-10 14:24:38'),(16754,17404,'0000-00-00','ET','2',2,1,'ERIC GONZALEZ','FI','547539623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:12',0,'2014-03-02 06:17:30'),(1813,1813,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:03',0,'2014-03-10 13:20:27'),(10476,10476,'2014-01-01','ET','2',2,1,'Ashley N Carlton','94','0001115938','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:05',0,'2014-03-01 16:10:36'),(1077,1077,'2014-01-01','ET','2',1,NULL,'Gregory Browne','FI','593685552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:10',0,'2014-03-01 19:11:03'),(6014,6014,'2014-01-01','ET','2',1,NULL,'Tricia Taubert','FI','295785408','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:21',0,'2014-03-01 15:10:22'),(20524,21174,'0000-00-00','ET','2',2,1,'MIKE J STANLEY','FI','454359657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:59',0,'2014-03-02 07:10:28'),(22409,23059,'0000-00-00','ET','2',1,NULL,'Ivonne Guadalupe Hernandez','FI','637103132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:05',0,'2014-03-07 22:26:59'),(22480,23130,'0000-00-00','ET','2',1,NULL,'TRAVIS STAPLETON','FI','271905844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:30:57',0,'2014-03-07 21:36:32'),(22876,23526,'0000-00-00','ET','2',1,NULL,'Jose Castillo','FI','630033802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:21',0,'2014-03-10 21:27:11'),(18349,18999,'0000-00-00','ET','2',1,NULL,'Kathlenn Sharon','FI','439941491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:25',0,'2014-03-02 06:45:14'),(17247,17897,'0000-00-00','ET','2',4,3,'Amy Sheeley','FI','295749807','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:29',0,'2014-03-01 17:20:55'),(4570,4570,'2014-01-01','ET','2',1,NULL,'Candace Ford','FI','274921600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:19',0,'2014-03-01 16:15:39'),(7461,7461,'2014-01-01','ET','2',1,NULL,'TONI COSTLEY','FI','217888175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:42',0,'2014-03-02 04:15:49'),(7278,7278,'2014-01-01','ET','2',1,NULL,'JOHN KINTZ','FI','275466084','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:03',0,'2014-03-10 13:32:15'),(5430,5430,'2014-01-01','ET','2',2,1,'Dawn Mewis','FI','533545674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:20',0,'2014-03-01 19:11:03'),(2726,2726,'2014-01-01','ET','2',1,NULL,'Andrea Boll','FI','546934135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:01',0,'2014-03-02 04:15:49'),(19172,19822,'0000-00-00','ET','2',2,1,'GUADALUPE R HERNANDEZ','FI','456044510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:40',0,'2014-03-02 06:52:12'),(22334,22984,'0000-00-00','ET','2',4,3,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:21',0,'2014-03-06 21:36:23'),(22471,23121,'0000-00-00','ET','2',1,NULL,'Raymond Quinn','FI','255556619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:50',0,'2014-03-07 21:36:32'),(16927,17577,'0000-00-00','ET','2',2,1,'KEVIN GWYN','FI','412618465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:43',0,'2014-03-02 06:17:30'),(6371,6371,'2014-01-01','ET','2',1,NULL,'CLETUS PHOENIX','FI','302682548','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:36',0,'2014-03-10 13:39:10'),(672,672,'2014-01-01','ET','2',1,NULL,'Teri Drake','FI','281546541','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:05:51',0,'2014-03-10 15:52:36'),(1389,1389,'2014-01-01','ET','2',1,NULL,'CYNTHIA BROWN','FI','449616825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:40',0,'2014-03-02 04:45:37'),(15874,16523,'0000-00-00','ET','2',1,NULL,'Tracy Oliver','FI','276820379','HealthSpan','FI','311431434','Ryan   Valek','94','8576784','357','2014-02-01','Sync Success',0,'2014-01-24 21:00:57',0,'2014-03-10 14:10:12'),(3681,3681,'2014-01-01','ET','2',1,NULL,'ARMETHIA PRESTON','FI','587802196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:51',0,'2014-03-02 00:10:48'),(20626,21276,'0000-00-00','ET','2',1,NULL,'CATHY J ST MYER','FI','297567747','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:07',0,'2014-03-10 14:37:47'),(10932,10932,'2014-01-01','ET','2',1,NULL,'Classie Miller-Jackson','FI','288822945','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:42',0,'2014-03-10 16:03:49'),(5373,5373,'2014-01-01','ET','2',1,NULL,'Christopher McMahon','FI','286784756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:38',0,'2014-03-01 15:10:22'),(11633,11633,'2014-01-01','ET','2',1,NULL,'Paula Starnes','FI','438230187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:45',0,'2014-03-02 04:52:44'),(2107,2107,'2014-01-01','ET','2',1,NULL,'Annette Render','FI','283867504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:08',0,'2014-03-01 15:16:37'),(13184,13540,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:05',0,'2014-03-10 16:10:34'),(2958,2958,'2014-01-01','ET','2',1,NULL,'Thomas Joseph Franko','FI','288448026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:50',0,'2014-03-01 15:37:30'),(3303,3303,'2014-01-01','ET','2',4,3,'COTTON NAKKA','FI','366237733','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:34',0,'2014-03-01 15:52:44'),(6279,6279,'2014-01-01','ET','2',1,NULL,'Margaret Whittington','FI','466714609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:49',0,'2014-03-02 04:10:25'),(4573,4573,'2014-01-01','ET','2',1,NULL,'Elizabeth Ann Hoover-Miller','FI','301523212','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:26',0,'2014-03-01 16:15:39'),(4957,4957,'2014-01-01','ET','2',1,NULL,'ELMER MALCOM MEADE','FI','284587638','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:05',0,'2014-03-10 13:03:33'),(11886,11886,'2014-01-01','ET','2',1,NULL,'Blair Quintana','FI','435536054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:35',0,'2014-03-02 04:59:36'),(12155,12155,'2014-01-01','ET','2',1,NULL,'John Nguyen','FI','603329881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:07:38',0,'2014-03-02 05:03:29'),(18256,18906,'0000-00-00','ET','2',2,1,'LYNNETTE STEPHENS','FI','275828886','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:43',0,'2014-03-10 14:24:38'),(20591,21241,'0000-00-00','ET','2',1,NULL,'Kathryn Culpepper','FI','338766667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 21:01:43',0,'2014-03-01 18:08:07'),(21331,21981,'0000-00-00','ET','2',1,NULL,'Jeffrey Dell','FI','294905340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:13',0,'2014-03-03 01:35:37'),(11404,11404,'2014-01-01','ET','2',1,NULL,'DEBORAH ALEXANDER','FI','273585642','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:41',0,'2014-03-10 16:03:49'),(692,692,'2014-01-01','ET','2',1,NULL,'Jennifer Reynolds','FI','295806509','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:06:30',0,'2014-03-10 13:24:34'),(6309,6309,'2014-01-01','ET','2',1,NULL,'Mary Ann SCALES','FI','587088046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:40',0,'2014-03-02 04:10:25'),(4835,4835,'2014-01-01','ET','2',1,NULL,'Jason Arzola','FI','301806537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:09',0,'2014-03-01 15:10:22'),(4718,4718,'2014-01-01','ET','2',1,NULL,'Alan Ronda','FI','279822966','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:17',0,'2014-03-10 13:45:57'),(3916,3916,'2014-01-01','ET','2',1,NULL,'Kristina Burns','FI','271906055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:45:32',0,'2014-03-01 15:26:40'),(13177,13533,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:51',0,'2014-03-10 16:10:34'),(14241,14692,'2014-01-01','ET','2',1,NULL,'Dung D Nguyen','FI','587712349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:58',0,'2014-03-02 05:38:34'),(16056,16705,'0000-00-00','ET','2',1,NULL,'Mary Koch','FI','277583977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:47',0,'2014-03-01 16:56:22'),(17918,18568,'0000-00-00','ET','2',1,NULL,'GUADALUPE GARZA','FI','459597780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:42',0,'2014-03-02 06:38:05'),(18525,19175,'0000-00-00','ET','2',1,NULL,'SHEILA ANN WALKER','FI','292724440','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:29',0,'2014-03-10 14:31:05'),(19302,19952,'0000-00-00','ET','2',1,NULL,'Nicholas Owen','FI','461132736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:20',0,'2014-03-02 06:59:07'),(22745,23395,'0000-00-00','ET','2',1,NULL,'Ray Schultz','FI','436940492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:08',0,'2014-03-09 21:26:00'),(11815,11815,'2014-01-01','ET','2',3,2,'Steven Payten','FI','302642350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:32',0,'2014-03-01 16:15:39'),(17396,18046,'0000-00-00','ET','2',1,NULL,'Melody Bluemel','FI','374601835','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:39',0,'2014-03-01 17:20:55'),(2127,2127,'2014-01-01','ET','2',2,1,'PATRICIA BALL','FI','301626291','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:44',0,'2014-03-01 15:16:37'),(2593,2593,'2014-01-01','ET','2',1,NULL,'Aaron Lawson','FI','291867354','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:46',0,'2014-03-10 15:39:19'),(16585,17235,'0000-00-00','ET','2',1,NULL,'Jeff Roessner','FI','280620989','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:01:34',0,'2014-03-10 14:20:26'),(3081,3081,'2014-01-01','ET','2',1,NULL,'Kerry Henry','FI','434578629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:38',0,'2014-03-02 01:10:33'),(7434,7434,'2014-01-01','ET','2',1,NULL,'Zachary cothren','FI','437770665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:57',0,'2014-03-02 04:15:49'),(3849,3849,'2014-01-01','ET','2',1,NULL,'Jamie English','FI','433377134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:34',0,'2014-03-01 19:11:03'),(15438,15889,'0000-00-00','ET','2',1,NULL,'Thomas Black','FI','282563984','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:34',0,'2014-03-10 16:17:47'),(4078,4078,'2014-01-01','ET','2',1,NULL,'Theodore Watson','FI','270865224','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:37',0,'2014-03-01 15:52:44'),(13851,14207,'2014-01-01','ET','2',1,NULL,'Pablo Vargas','FI','462960307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:49',0,'2014-03-02 05:31:31'),(13682,14038,'2014-01-01','ET','2',1,NULL,'Martha M Gomez','FI','450533543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:29',0,'2014-03-02 05:24:45'),(18555,19205,'0000-00-00','ET','2',1,NULL,'Barton Bradberry','94','0000582236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:14',0,'2014-03-02 06:45:14'),(19620,20270,'0000-00-00','ET','2',1,NULL,'Jordan Conti','FI','299846606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:55',0,'2014-03-01 17:47:19'),(20780,21430,'0000-00-00','ET','2',1,NULL,'MARIE WAGONER','FI','281585357','Summa Insurance Company, Inc.','FI','341809108','EDWARD  MORRISON','94','1923438','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:49',0,'2014-03-10 16:38:05'),(21231,21881,'0000-00-00','ET','2',1,NULL,'Dianne Henderson','FI','437020620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:17',0,'2014-03-02 07:23:39'),(15745,16394,'0000-00-00','ET','2',1,NULL,'Nicole Clark','FI','445544623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:19',0,'2014-03-10 14:10:12'),(10688,10688,'2014-01-01','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:05',0,'2014-03-01 16:10:36'),(7613,7613,'2014-01-01','ET','2',1,NULL,'Jeffrey Hall','FI','272884271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:37:41',0,'2014-03-10 15:59:47'),(17900,18550,'0000-00-00','ET','2',1,NULL,'Kenneth Yambra','FI','433532585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:29',0,'2014-03-02 06:38:05'),(22867,23517,'0000-00-00','ET','2',1,NULL,'YVONE SANDERS','FI','165440964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:00:15',0,'2014-03-10 21:27:11'),(11142,11142,'2014-01-01','ET','2',2,1,'Walter Seeman','FI','299502599','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:40',0,'2014-03-10 13:39:10'),(16958,17608,'0000-00-00','ET','2',1,NULL,'Angie Bryant','FI','435355626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:04',0,'2014-03-02 06:24:38'),(7212,7212,'2014-01-01','ET','2',1,NULL,'Jeffrey Thomas Susich','FI','477723934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:00',0,'2014-03-01 15:52:44'),(5366,5366,'2014-01-01','ET','2',1,NULL,'Jonathan Lege','FI','436615519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:25',0,'2014-03-01 21:11:04'),(12852,12852,'2014-01-01','ET','2',1,NULL,'Janelle Bair','FI','276762202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:09',0,'2014-03-01 16:35:14'),(4232,4232,'2014-01-01','ET','2',1,NULL,'Rausheen Rivers','FI','300765379','Dental Care Plus, Inc.','FI','311185262','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:12',0,'2014-03-01 16:00:27'),(23090,23740,'0000-00-00','ET','2',1,NULL,'Christopher Bann','FI','548850247','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:03:00',0,'2014-03-10 21:07:22'),(151,151,'2014-01-01','ET','2',1,NULL,'Joan Suffolk','FI','282563599','Summa Insurance Company, Inc.','FI','341809108','John t gillmor','94','9777900','348','2014-01-01','Sync Success',0,'2013-12-25 17:19:42',0,'2014-03-10 15:45:56'),(7201,7201,'2014-01-01','ET','2',1,NULL,'Daniel Crawford','FI','272442348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:38',0,'2014-03-01 15:52:44'),(11091,11091,'2014-01-01','ET','2',1,NULL,'Lori Collins','FI','268764117','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:50',0,'2014-03-10 13:39:10'),(10515,10515,'2014-01-01','ET','2',1,NULL,'Barry Luckie','FI','462336880','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:19',0,'2014-03-02 04:24:47'),(17782,18432,'0000-00-00','ET','2',1,NULL,'Jordan Fuller','FI','463911419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:18',0,'2014-03-02 05:52:31'),(18827,19477,'0000-00-00','ET','2',2,1,'CELESTE SANTOS','FI','465690846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:09',0,'2014-03-02 06:52:12'),(18910,19560,'0000-00-00','ET','2',2,1,'Nicolae Vulcan','FI','269027373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:09',0,'2014-03-01 17:34:07'),(20011,20661,'0000-00-00','ET','2',2,1,'Stephen Gardner','FI','283465176','Summa Insurance Company, Inc.','FI','341809108','Lori  Nagy','94','14928240','348','2014-04-01','Sync Success',0,'2014-02-21 22:01:00',0,'2014-03-10 16:38:05'),(20274,20924,'0000-00-00','ET','2',1,NULL,'TINICA L COLBERT','FI','435415148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:20',0,'2014-03-02 07:03:25'),(22325,22975,'0000-00-00','ET','2',1,NULL,'Terence Smith','FI','379786658','HealthSpan','FI','311431434','Philip  Dubois','94','2345683','357','2014-03-31','Sync Success',0,'2014-03-06 21:30:15',0,'2014-03-10 14:50:59'),(15014,15465,'2014-01-01','ET','2',1,NULL,'Douglas Morrison','FI','290643121','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:16',0,'2014-03-10 16:17:47'),(14265,14716,'2014-01-01','ET','2',1,NULL,'DAVID HAMMOND','FI','232358835','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:09',0,'2014-03-01 16:46:19'),(3354,3354,'2014-01-01','ET','2',1,NULL,'CARLIE ROSE HUTCHINSON','FI','633341054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:18',0,'2014-03-02 02:10:49'),(6418,6418,'2014-01-01','ET','2',1,NULL,'Marvin G Schexnider','FI','439846411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:04',0,'2014-03-01 20:10:57'),(5477,5477,'2014-01-01','ET','2',2,1,'hicks sellers','FI','433418050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:39',0,'2014-03-02 04:45:37'),(13432,13788,'2014-01-01','ET','2',1,NULL,'Mark Donnadio','FI','281729506','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:06',0,'2014-03-01 16:40:16'),(4815,4815,'2014-01-01','ET','2',1,NULL,'Kenneth Moy','FI','302521858','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:18',0,'2014-03-10 13:03:33'),(4818,4818,'2014-01-01','ET','2',1,NULL,'Dean Heberlein','FI','298844573','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:24',0,'2014-03-10 13:03:33'),(20106,20756,'0000-00-00','ET','2',1,NULL,'Lisa Curley','FI','433862842','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:24',0,'2014-03-02 07:10:28'),(20404,21054,'0000-00-00','ET','2',1,NULL,'sandra cruz','FI','663169492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:30',0,'2014-03-02 07:03:25'),(11226,11226,'2014-01-01','ET','2',2,1,'sharon louis','FI','179441346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:14',0,'2014-03-01 16:23:43'),(7604,7604,'2014-01-01','ET','2',1,NULL,'CINDY KOCH-MANTEGHI','FI','269507185','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:24',0,'2014-03-10 15:59:47'),(17563,18213,'0000-00-00','ET','2',2,1,'DUMIERU BOANCA','FI','446898779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:43',0,'2014-03-02 06:31:45'),(2544,2544,'2014-01-01','ET','2',1,NULL,'Eileen Jennings','FI','274569493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:20',0,'2014-03-01 15:10:22'),(2750,2750,'2014-01-01','ET','2',1,NULL,'Lila Wilson','94','0002149664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:44',0,'2014-03-02 04:15:49'),(3710,3710,'2014-01-01','ET','2',2,1,'howard hoffpauir','FI','434194462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:51',0,'2014-03-02 01:10:33'),(3433,3433,'2014-01-01','ET','2',1,NULL,'Helen Whitehead','FI','302483679','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:47',0,'2014-03-10 13:24:34'),(20091,20741,'0000-00-00','ET','2',1,NULL,'Mallory Maynard','FI','438754642','Starmount Life Insurance Company','FI','720977315','Mary  Siggers','94','15257239','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:11',0,'2014-03-02 07:10:28'),(20876,21526,'0000-00-00','ET','2',2,1,'DENNIS LITTLETON','FI','406924431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:34',0,'2014-03-10 14:37:47'),(21194,21844,'0000-00-00','ET','2',1,NULL,'Suzanne Harshman','94','0000906653','HealthSpan','FI','311431434','James  Rightnowar','94','967389','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:55',0,'2014-03-10 14:45:25'),(21279,21929,'0000-00-00','ET','2',1,NULL,'Shavonna Jones','FI','438393478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:48',0,'2014-03-02 07:23:39'),(22076,22726,'0000-00-00','ET','2',1,NULL,'HAZEL TOLIVER','FI','452802130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:11',0,'2014-03-06 21:27:26'),(22143,22793,'0000-00-00','ET','2',1,NULL,'Horace  Doresy','FI','438450563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:00',0,'2014-03-06 21:27:26'),(14971,15422,'2014-01-01','ET','2',1,NULL,'Jessie Sallie','FI','284640977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:58',0,'2014-03-01 16:50:53'),(377,377,'2014-01-01','ET','2',1,NULL,'Dannett Hind','FI','299581462','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:39',0,'2014-03-10 15:45:56'),(14439,14890,'2014-01-01','ET','2',1,NULL,'FRANCES RENEE MILLER','FI','434232871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:26',0,'2014-03-02 05:38:34'),(1437,1437,'2014-01-01','ET','2',4,3,'Maria Maisto','FI','578845881','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:15',0,'2014-03-01 16:15:39'),(11723,11723,'2014-01-01','ET','2',1,NULL,'Jessque Varner','FI','264830506','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:37',0,'2014-03-01 16:30:17'),(5697,5697,'2014-01-01','ET','2',2,1,'Tracy Kameoka','FI','296820363','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:19',0,'2014-03-01 15:37:30'),(7718,7718,'2014-01-01','ET','2',1,NULL,'Henry J Lee','FI','439020085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:06',0,'2014-03-01 20:10:57'),(6367,6367,'2014-01-01','ET','2',2,1,'Shannon Minnich Young','FI','284741839','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:26',0,'2014-03-10 15:59:47'),(20282,20932,'0000-00-00','ET','2',1,NULL,'Annette Harbaugh','FI','277841013','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:27',0,'2014-03-10 16:38:05'),(21445,22095,'0000-00-00','ET','2',2,1,'Lauri Cook','FI','288742501','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:15',0,'2014-03-10 16:44:18'),(796,796,'2014-01-01','ET','2',1,NULL,'Carla Watts','FI','438395559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:02',0,'2014-03-01 19:11:03'),(16568,17218,'0000-00-00','ET','2',1,NULL,'terry artman','FI','281444043','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:20',0,'2014-03-10 16:24:30'),(10589,10589,'2014-01-01','ET','2',1,NULL,'James Perez','FI','456779645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:48',0,'2014-03-02 04:24:47'),(15522,15973,'0000-00-00','ET','2',1,NULL,'SAVITRI R KAHLE','FI','643740332','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:00',0,'2014-03-02 05:59:43'),(2665,2665,'2014-01-01','ET','2',1,NULL,'Mary Tracy','FI','279721353','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:02',0,'2014-03-01 16:05:34'),(14016,14372,'2014-01-01','ET','2',1,NULL,'Stephanie Hardin','FI','587172865','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:42',0,'2014-03-02 05:31:31'),(18085,18735,'0000-00-00','ET','2',1,NULL,'Anne Nowland','FI','456451780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:27',0,'2014-03-02 06:38:05'),(19451,20101,'0000-00-00','ET','2',1,NULL,'MICHAEL HUDSON','FI','434846173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:41:54',0,'2014-03-02 06:59:07'),(19993,20643,'0000-00-00','ET','2',2,1,'FRANCESCA OAKLEY','FI','433276596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:47',0,'2014-03-02 07:03:25'),(22055,22705,'0000-00-00','ET','2',1,NULL,'mark klewer','FI','290849311','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:32',0,'2014-03-10 14:45:25'),(22671,23321,'0000-00-00','ET','2',1,NULL,'Beverly Hayes','FI','286703832','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-08 21:30:37',0,'2014-03-10 14:50:59'),(18110,18760,'0000-00-00','ET','2',2,1,'JULIO AGUILAR','FI','253690973','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:46',0,'2014-03-02 06:38:05'),(978,978,'2014-01-01','ET','2',2,1,'Lloyd Morris','FI','273566197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:32',0,'2014-03-01 15:21:15'),(1262,1262,'2014-01-01','ET','2',1,NULL,'Shawn Lupson','FI','284503535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:35',0,'2014-03-01 16:15:39'),(11392,11392,'2014-01-01','ET','2',1,NULL,'Willie Montgomery','FI','426292316','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:18',0,'2014-03-02 04:52:44'),(16370,17020,'0000-00-00','ET','2',1,NULL,'LILLIAN L BURISE','FI','439081036','Starmount Life Insurance Company','FI','720977315','JOHN T ALLEN','94','4728680','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:07',0,'2014-03-02 06:10:30'),(15583,16034,'0000-00-00','ET','2',1,NULL,'Donald Martinez','FI','523110858','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:28',0,'2014-03-10 14:10:12'),(15086,15537,'0000-00-00','ET','2',1,NULL,'Daniel Gump','FI','283862537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:39',0,'2014-03-01 16:50:53'),(18094,18744,'0000-00-00','ET','2',1,NULL,'SANDRA I BURAYE','FI','568574697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:33',0,'2014-03-02 06:38:05'),(19473,20123,'0000-00-00','ET','2',3,2,'Jacob Skinner','FI','642287155','Starmount Life Insurance Company','FI','720977315','Sean  Rekemeyer','94','1329285','348','2014-04-01','Sync Success',0,'2014-02-20 03:54:03',0,'2014-03-02 06:59:07'),(16986,17636,'0000-00-00','ET','2',2,1,'Phillip Werner','FI','288606405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:19',0,'2014-03-10 16:24:30'),(16731,17381,'0000-00-00','ET','2',2,1,'Lisa Morris','FI','302800971','HealthSpan','FI','311431434','Gary  Nelson','94','2346444','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:39',0,'2014-03-10 14:20:26'),(16095,16744,'0000-00-00','ET','2',1,NULL,'Joan Mack','FI','281689137','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:14',0,'2014-03-10 16:24:30'),(7721,7721,'2014-01-01','ET','2',1,NULL,'Dana Brandt','FI','291788539','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:13',0,'2014-03-10 15:39:19'),(7493,7493,'2014-01-01','ET','2',1,NULL,'Corey Mann','FI','295740136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:49',0,'2014-03-01 16:05:34'),(15686,16335,'0000-00-00','ET','2',1,NULL,'Stephanie Ceasar','FI','465437938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:38',0,'2014-03-02 05:59:43'),(15375,15826,'0000-00-00','ET','2',1,NULL,'Latricia Rodrigue','FI','433679549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:53',0,'2014-03-02 05:59:43'),(5284,5284,'2014-01-01','ET','2',1,NULL,'Ofeira Gazzaway','FI','575925207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:51',0,'2014-03-01 20:10:57'),(1227,1227,'2014-01-01','ET','2',1,NULL,'Daniel White','FI','299824924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:35',0,'2014-03-01 16:15:39'),(5253,5253,'2014-01-01','ET','2',1,NULL,'carol thabit','FI','286425450','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:08',0,'2014-03-10 13:20:27'),(2276,2276,'2014-01-01','ET','2',1,NULL,'Ashley Gonzales','FI','641100742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:21',0,'2014-03-01 21:11:04'),(4971,4971,'2014-01-01','ET','2',1,NULL,'PATTY BENNETT','FI','405065696','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:03',0,'2014-03-01 15:31:33'),(18287,18937,'0000-00-00','ET','2',1,NULL,'KRISTIN BAUER','FI','435416044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:16',0,'2014-03-02 06:38:05'),(19534,20184,'0000-00-00','ET','2',2,1,'CAROLYN WASHINGTON','FI','427110973','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:14:12',0,'2014-03-02 06:59:07'),(21223,21873,'0000-00-00','ET','2',1,NULL,'Kimberly Nguyen','FI','522356809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:12',0,'2014-03-02 07:23:39'),(12914,12914,'2014-01-01','ET','2',1,NULL,'Tracie L Davis','FI','438599139','Starmount Life Insurance Company','FI','720977315','Keith  Smith','94','4698601','348','2014-02-01','Sync Success',0,'2014-01-04 02:05:26',0,'2014-03-02 05:17:40'),(18591,19241,'0000-00-00','ET','2',1,NULL,'HALINA  ZATORSCKE','FI','274527590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:27',0,'2014-03-01 17:26:36'),(18679,19329,'0000-00-00','ET','2',2,1,'LEE CAROLSON','FI','865521924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:36',0,'2014-03-02 06:45:14'),(20361,21011,'0000-00-00','ET','2',1,NULL,'John Carte','FI','436736884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:47',0,'2014-03-02 07:03:25'),(17297,17947,'0000-00-00','ET','2',1,NULL,'Vicki Rogers','FI','434572938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:53',0,'2014-03-02 06:24:38'),(1004,1004,'2014-01-01','ET','2',1,NULL,'Robert Edward  Ashley','FI','276445191','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:25',0,'2014-03-10 15:39:19'),(5090,5090,'2014-01-01','ET','2',1,NULL,'Evelie Gravois','FI','433046457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:52',0,'2014-03-02 00:10:48'),(10718,10718,'2014-01-01','ET','2',2,1,'Scott Johnson','FI','590481299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:08',0,'2014-03-01 16:10:36'),(2990,2990,'2014-01-01','ET','2',1,NULL,'Nikole Jones','FI','601246748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:49',0,'2014-03-02 01:10:33'),(11175,11175,'2014-01-01','ET','2',1,NULL,'KEN R MERUNSKI','FI','289440458','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:49',0,'2014-03-10 13:45:57'),(3600,3600,'2014-01-01','ET','2',1,NULL,'JUANITA VALLEJO','FI','454905846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:20',0,'2014-03-02 01:10:33'),(18742,19392,'0000-00-00','ET','2',1,NULL,'Adria Ivey','FI','438117133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:24',0,'2014-03-02 06:45:14'),(20278,20928,'0000-00-00','ET','2',1,NULL,'Joel Wayne Rush','FI','460045281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:23',0,'2014-03-02 07:03:25'),(21065,21715,'0000-00-00','ET','2',1,NULL,'Logan J Kraus','FI','296085674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:24',0,'2014-03-01 18:10:11'),(15434,15885,'0000-00-00','ET','2',1,NULL,'Zenobia Johnson','FI','278687422','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:32',0,'2014-03-10 16:17:47'),(4355,4355,'2014-01-01','ET','2',2,1,'Randy Wright','FI','299663400','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:56',0,'2014-03-10 13:32:15'),(4535,4535,'2014-01-01','ET','2',1,NULL,'Allen Garrett','FI','269769563','Summa Insurance Company, Inc.','FI','341809108','Barbara  Silvey','94','8108024','348','2014-01-01','Sync Success',0,'2013-12-25 23:45:11',0,'2014-03-10 16:03:49'),(21513,22163,'0000-00-00','ET','2',2,1,'Long Nguyen','FI','629927040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:05',0,'2014-03-03 22:26:43'),(21762,22412,'0000-00-00','ET','2',1,NULL,'Cindy Horsey','FI','276664223','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-04 21:02:30',0,'2014-03-10 14:45:25'),(34,34,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:16:00',0,'2014-03-01 15:21:15'),(515,515,'2014-01-01','ET','2',1,NULL,'PATRICIA J CARLSON','FI','279721837','Dental Care Plus, Inc.','FI','311185262','BARBARA  KARAYAN','94','1776121','348','2014-01-01','Sync Success',0,'2013-12-25 18:00:55',0,'2014-03-01 15:48:04'),(15121,15572,'0000-00-00','ET','2',5,4,'CHARLEY E WHITLATCH','FI','295629045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:05',0,'2014-03-01 16:50:53'),(12264,12264,'2014-01-01','ET','2',1,NULL,'CARLOS FLORES','FI','287785316','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:59',0,'2014-03-10 13:59:38'),(12114,12114,'2014-01-01','ET','2',1,NULL,'kyriakos alexakis','FI','286861518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:06:10',0,'2014-03-01 16:30:17'),(11346,11346,'2014-01-01','ET','2',1,NULL,'Chris Brown','FI','461471507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:53',0,'2014-03-02 04:52:44'),(11227,11227,'2014-01-01','ET','2',1,NULL,'Ronald  Pankey','FI','271500539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:16',0,'2014-03-01 16:23:43'),(13393,13749,'2014-01-01','ET','2',2,1,'Mary  Lynne Mcquain','FI','283483566','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:51',0,'2014-03-10 16:10:34'),(4894,4894,'2014-01-01','ET','2',1,0,'ALBERTA JONES','FI','280683950','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:11',0,'2014-03-10 15:39:19'),(5447,5447,'2014-01-01','ET','2',2,1,'donna may graves','FI','465331233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:53',0,'2014-03-01 19:11:03'),(20090,20740,'0000-00-00','ET','2',1,NULL,'Tammie Ellis','FI','436313038','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:10',0,'2014-03-02 07:10:28'),(14641,15092,'2014-01-01','ET','2',1,NULL,'Karen Kempf','FI','406646443','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:14',0,'2014-03-01 16:46:19'),(11022,11022,'2014-01-01','ET','2',2,1,'Patrick Bartholomew','FI','227491613','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:33',0,'2014-03-10 13:39:10'),(1135,1135,'2014-01-01','ET','2',1,NULL,'EDDREA JOELLE PHILMON','FI','628078445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:44',0,'2014-03-02 04:45:37'),(7416,7416,'2014-01-01','ET','2',1,NULL,'Barbara W Carlton','FI','149400876','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:23',0,'2014-03-02 04:15:49'),(1658,1658,'2014-01-01','ET','2',2,1,'Jay Michael Austin','FI','280947981','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:09',0,'2014-03-10 15:45:56'),(13048,13404,'2014-01-01','ET','2',1,NULL,'Kim Smith','FI','433021239','Starmount Life Insurance Company','FI','720977315','Suzanne Denise Crick','94','8946819','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:02',0,'2014-03-02 05:17:40'),(3345,3345,'2014-01-01','ET','2',1,NULL,'Rebeca Anthon Denny','FI','464535422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:02',0,'2014-03-02 02:10:49'),(5328,5328,'2014-01-01','ET','2',1,NULL,'Richard Ludwig','FI','278443645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:06',0,'2014-03-01 15:10:22'),(18568,19218,'0000-00-00','ET','2',1,NULL,'Sandra Montgomery','FI','275482354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:07',0,'2014-03-01 17:26:36'),(21972,22622,'0000-00-00','ET','2',1,NULL,'MARY ARMBRUSTER','FI','274666214','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:34',0,'2014-03-10 16:44:18'),(16769,17419,'0000-00-00','ET','2',1,NULL,'LINDA  THOMAS','FI','436909856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:21',0,'2014-03-02 06:17:30'),(14873,15324,'2014-01-01','ET','2',1,NULL,'Larka Smallwood','FI','456137980','Starmount Life Insurance Company','FI','720977315','Mathew  Dahlen','94','16804332','348','2014-03-01','Sync Success',0,'2014-01-17 03:35:12',0,'2014-03-02 05:52:31'),(1839,1839,'2014-01-01','ET','2',1,NULL,'Tim Coates','FI','293526064','HealthSpan','FI','311431434','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:56',0,'2014-03-10 13:20:27'),(2384,2384,'2014-01-01','ET','2',1,NULL,'EUGENIA TOON','FI','455787326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:45',0,'2014-03-01 23:10:52'),(2445,2445,'2014-01-01','ET','2',2,1,'Richard Deger','FI','159383105','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:41',0,'2014-03-10 15:45:56'),(21079,21729,'0000-00-00','ET','2',1,NULL,'Gina McGraner','FI','271884541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:32',0,'2014-03-01 18:10:11'),(21102,21752,'0000-00-00','ET','2',1,NULL,'Sharon Haley','FI','465046219','Starmount Life Insurance Company','FI','720977315','Alan   Charring','94','801753','357','2014-04-01','Sync Success',0,'2014-02-28 21:30:48',0,'2014-03-02 07:23:39'),(21377,22027,'0000-00-00','ET','2',1,NULL,'Bianca Marie Picione','94','0000106770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:40',0,'2014-03-03 01:35:37'),(7039,7039,'2014-01-01','ET','2',1,NULL,'GENOVEVA ACOSTA MORALES','FI','506518308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:01:43',0,'2014-03-02 03:09:49'),(6313,6313,'2014-01-01','ET','2',1,NULL,'Charlotte J Sznajkart','FI','298486355','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:48',0,'2014-03-10 15:59:47'),(14064,14515,'2014-01-01','ET','2',1,NULL,'nikki taylor','FI','452753187','Starmount Life Insurance Company','FI','720977315','walter  taylor','94','16730260','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:12',0,'2014-03-02 05:31:31'),(16398,17048,'0000-00-00','ET','2',1,NULL,'kanzetta powell','FI','457590064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:25',0,'2014-03-02 06:10:30'),(16203,16852,'0000-00-00','ET','2',1,NULL,'MICHAEL D BASS','FI','438192218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:41',0,'2014-03-02 06:10:30'),(12864,12864,'2014-01-01','ET','2',1,NULL,'THERESA METZGER','FI','289501964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:34',0,'2014-03-01 16:35:14'),(12788,12788,'2014-01-01','ET','2',1,NULL,'Krystle Ornelas','FI','585738032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:49',0,'2014-03-02 05:10:52'),(15907,16556,'0000-00-00','ET','2',1,NULL,'KHADIJAH RAFHEED','FI','290547953','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:01:17',0,'2014-03-10 14:10:12'),(1905,1905,'2014-01-01','ET','2',1,NULL,'ROSA HERRERA','FI','546061986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:56',0,'2014-03-01 23:10:52'),(11012,11012,'2014-01-01','ET','2',1,NULL,'CEDRIC ALTON JAMES','FI','427575181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:12',0,'2014-03-02 04:24:47'),(2974,2974,'2014-01-01','ET','2',1,NULL,'Patti Fiorvanti','94','0000529423','Dental Care Plus, Inc.','FI','311185262','John  Curry','94','10751792','348','2014-01-01','Sync Success',0,'2013-12-25 21:32:23',0,'2014-03-01 15:37:30'),(20516,21166,'0000-00-00','ET','2',2,1,'Anh-Dao T Bui','FI','437953023','Starmount Life Insurance Company','FI','720977315','Glory B Toups','94','3664555','348','2014-04-01','Sync Success',0,'2014-02-26 21:00:53',0,'2014-03-02 07:17:36'),(7254,7254,'2014-01-01','ET','2',1,NULL,'Jody Kaplansky','FI','299744537','Summa Insurance Company, Inc.','FI','341809108','Ron J. Fleeter','94','1834226','348','2014-01-01','Sync Success',0,'2013-12-26 04:08:19',0,'2014-03-10 15:59:47'),(22184,22834,'0000-00-00','ET','2',1,NULL,'Adam Schaefer','FI','297662887','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:27',0,'2014-03-06 21:36:23'),(22565,23215,'0000-00-00','ET','2',2,1,'Anthony Cunningham','FI','294869900','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:56',0,'2014-03-10 14:50:59'),(14226,14677,'2014-01-01','ET','2',1,NULL,'James Jeffrey Cox','FI','451490038','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:52',0,'2014-03-02 05:38:34'),(12300,12300,'2014-01-01','ET','2',1,NULL,'danette harrison','FI','299601835','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:17',0,'2014-03-10 13:59:38'),(10802,10802,'2014-01-01','ET','2',1,NULL,'Donald Sanders','FI','437829629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:03:56',0,'2014-03-02 04:24:47'),(11963,11963,'2014-01-01','ET','2',1,NULL,'James Austin','FI','462477293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:41',0,'2014-03-02 04:59:36'),(20271,20921,'0000-00-00','ET','2',1,NULL,'DEONNE JONES','FI','434310611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:17',0,'2014-03-02 07:03:25'),(401,401,'2014-01-01','ET','2',1,NULL,'Carla Kennedy','FI','434379431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:24',0,'2014-03-01 22:10:55'),(16507,17157,'0000-00-00','ET','2',1,NULL,'TOMASA SOTO','FI','641785393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:41',0,'2014-03-02 06:10:30'),(16315,16965,'0000-00-00','ET','2',2,1,'Mohamed Touassi','FI','278861735','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:33',0,'2014-03-01 16:56:22'),(1249,1249,'2014-01-01','ET','2',1,NULL,'John Nicholas','FI','277685018','Dental Care Plus, Inc.','FI','311185262','Joseph  Dintino','94','2207884','348','2014-01-01','Sync Success',0,'2013-12-25 18:49:10',0,'2014-03-01 16:15:39'),(5073,5073,'2014-01-01','ET','2',1,NULL,'Janet Ann Whitaker','FI','292427145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:20',0,'2014-03-01 15:31:33'),(11572,11572,'2014-01-01','ET','2',1,NULL,'Corrine Leth','FI','528317737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:54',0,'2014-03-02 04:52:44'),(19264,19914,'0000-00-00','ET','2',1,NULL,'ELVIRA NAVARRO','FI','733052539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:09',0,'2014-03-02 06:52:12'),(20635,21285,'0000-00-00','ET','2',1,NULL,'rebecca davenport','FI','230880643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:02:14',0,'2014-03-02 07:10:28'),(20738,21388,'0000-00-00','ET','2',1,NULL,'Rita Estep','FI','268521717','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:30',0,'2014-03-01 18:10:11'),(21421,22071,'0000-00-00','ET','2',3,2,'Mostafa M Elkhatib','FI','578801403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:24',0,'2014-03-03 21:25:18'),(6013,6013,'2014-01-01','ET','2',1,NULL,'travis stephens','FI','308157207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:19',0,'2014-03-01 15:10:22'),(406,406,'2014-01-01','ET','2',1,NULL,'Robby Perot','FI','435493695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:34',0,'2014-03-01 22:10:55'),(1312,1312,'2014-01-01','ET','2',1,NULL,'Annette M Davis','FI','466237525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:12',0,'2014-03-02 04:38:08'),(1721,1721,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','357','2014-01-01','Sync Success',0,'2013-12-25 19:17:08',0,'2014-03-01 15:31:33'),(10787,10787,'2014-01-01','ET','2',1,NULL,'HAROLD E SHAW','FI','436175844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:27',0,'2014-03-02 04:24:47'),(3762,3762,'2014-01-01','ET','2',1,NULL,'rayvon hollins','FI','456158369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:04',0,'2014-03-01 23:10:52'),(3680,3680,'2014-01-01','ET','2',1,NULL,'ARMETHIA PRESTON','FI','587802196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:06:50',0,'2014-03-02 00:10:48'),(20502,21152,'0000-00-00','ET','2',1,NULL,'Kim Shugars','FI','587352508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 21:00:44',0,'2014-03-02 07:10:28'),(163,163,'2014-01-01','ET','2',3,2,'Patricia Anderson','FI','413375709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:04',0,'2014-03-10 15:45:56'),(13976,14332,'2014-01-01','ET','2',1,NULL,'MURLINE HUNTER','FI','133520301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:12',0,'2014-03-02 05:31:31'),(13643,13999,'2014-01-01','ET','2',1,NULL,'SARA RAMSKILL','FI','281503461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:57',0,'2014-03-10 14:03:26'),(12135,12135,'2014-01-01','ET','2',1,NULL,'Ericka Jordan','FI','270721456','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:56',0,'2014-03-10 13:52:32'),(12882,12882,'2014-01-01','ET','2',1,NULL,'Brandon Nehrkorn','FI','283866851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:14',0,'2014-03-01 16:35:14'),(12880,12880,'2014-01-01','ET','2',1,NULL,'Mark V Guthridge','FI','282820373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:10',0,'2014-03-01 16:35:14'),(20607,21257,'0000-00-00','ET','2',1,NULL,'IVAN GADSON','FI','180482579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:52',0,'2014-03-01 18:08:07'),(21118,21768,'0000-00-00','ET','2',2,1,'Jesse Monsivais','FI','459693477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:58',0,'2014-03-02 07:23:39'),(22703,23353,'0000-00-00','ET','2',1,NULL,'Steven Plant','FI','274461999','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:00',0,'2014-03-10 16:44:18'),(4281,4281,'2014-01-01','ET','2',1,NULL,'Patricia Ringo','FI','436784705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:45',0,'2014-03-02 03:09:49'),(12313,12313,'2014-01-01','ET','2',2,1,'Paul Carmichael','FI','301547268','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:47',0,'2014-03-10 16:10:34'),(17108,17758,'0000-00-00','ET','2',1,NULL,'Joseph Fink','FI','291823909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:05',0,'2014-03-01 17:20:55'),(19400,20050,'0000-00-00','ET','2',1,NULL,'Amy Dixon','FI','400374653','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:08',0,'2014-03-01 17:34:07'),(19826,20476,'0000-00-00','ET','2',1,NULL,'Judy Talley','FI','453350129','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:44',0,'2014-03-02 07:03:25'),(16802,17452,'0000-00-00','ET','2',3,2,'ANDREW CHAPPELL-DICK','FI','101785742','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:42',0,'2014-03-10 14:20:26'),(3163,3163,'2014-01-01','ET','2',1,NULL,'Daniel Tuel','FI','270525614','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:12',0,'2014-03-10 13:24:34'),(15354,15805,'0000-00-00','ET','2',1,NULL,'Hudson Hill','FI','428236320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:51',0,'2014-03-02 05:52:31'),(12415,12415,'2014-01-01','ET','2',1,NULL,'DEBRA  SIMMONS','FI','437961396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:14',0,'2014-03-02 05:03:29'),(18163,18813,'0000-00-00','ET','2',1,NULL,'Laura Jennings','FI','435572112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:26',0,'2014-03-02 06:38:05'),(10386,10386,'2014-01-01','ET','2',1,NULL,'Kristal Hawkins','FI','269722171','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:18',0,'2014-03-01 16:10:36'),(16025,16674,'0000-00-00','ET','2',1,NULL,'Louann Cashill','FI','438414334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:26',0,'2014-03-02 06:03:21'),(1759,1759,'2014-01-01','ET','2',1,NULL,'Mable Buxton-Piearce','FI','587520016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:16',0,'2014-03-02 00:10:48'),(1698,1698,'2014-01-01','ET','2',1,NULL,'Anthony Coleman','FI','436219873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:16:26',0,'2014-03-02 00:10:48'),(20816,21466,'0000-00-00','ET','2',1,NULL,'Patricia Butler','FI','452157626','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:06',0,'2014-03-02 07:17:36'),(12642,12642,'2014-01-01','ET','2',1,NULL,'carol roach','FI','435888248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:36',0,'2014-03-02 05:10:52'),(10722,10722,'2014-01-01','ET','2',1,NULL,'Luke Feerer','FI','299709539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:21',0,'2014-03-01 16:10:36'),(3153,3153,'2014-01-01','ET','2',1,NULL,'Brian Benschoter','FI','273707095','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:52',0,'2014-03-10 13:24:34'),(1284,1284,'2014-01-01','ET','2',1,NULL,'Amy Crombie','FI','290606051','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:17',0,'2014-03-01 16:23:43'),(19890,20540,'0000-00-00','ET','2',1,NULL,'Thomas Hogue','FI','295508787','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:37',0,'2014-03-10 14:37:47'),(23056,23706,'0000-00-00','ET','2',1,NULL,'Mark W McElrath','FI','293549275','HealthSpan','FI','311431434','William  Beck','94','966895','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:32',0,'2014-03-10 21:17:52'),(128,128,'2014-01-01','ET','2',2,1,'Grace Isaac','FI','450392647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:57',0,'2014-03-01 22:10:55'),(11133,11133,'2014-01-01','ET','2',1,NULL,'Kyle Roberts','FI','300741814','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:19',0,'2014-03-10 13:45:57'),(4293,4293,'2014-01-01','ET','2',2,1,'Steward Moss','FI','280560164','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:05',0,'2014-03-10 13:32:15'),(14413,14864,'2014-01-01','ET','2',1,NULL,'PHYLLIS LEE','FI','587230481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:13',0,'2014-03-02 05:38:34'),(12796,12796,'2014-01-01','ET','2',2,1,'Arnesto Rodriguez','FI','456968743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:07',0,'2014-03-02 05:10:52'),(13413,13769,'2014-01-01','ET','2',1,NULL,'SHERRY DAVIS','FI','289622429','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:00',0,'2014-03-10 13:59:38'),(21105,21755,'0000-00-00','ET','2',1,NULL,'Ruqiya Ahmed','FI','614451455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:50',0,'2014-03-02 07:23:39'),(127,127,'2014-01-01','ET','2',1,NULL,'Ronald W Roubique','FI','435906625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:56',0,'2014-03-01 22:10:55'),(6439,6439,'2014-01-01','ET','2',1,NULL,'Matthew Rizer','FI','286824262','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:42',0,'2014-03-10 13:03:33'),(10988,10988,'2014-01-01','ET','2',1,NULL,'PHILLIP MCNULTY','FI','427252717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:22',0,'2014-03-02 04:24:47'),(7363,7363,'2014-01-01','ET','2',1,NULL,'Kevin Wagner','FI','295607666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:57',0,'2014-03-01 15:16:37'),(1464,1464,'2014-01-01','ET','2',4,3,'scott miller','94','0000432762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:14',0,'2014-03-01 16:23:43'),(10646,10646,'2014-01-01','ET','2',1,NULL,'Margarita Chavez','FI','466677199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:40',0,'2014-03-02 04:31:46'),(10595,10595,'2014-01-01','ET','2',2,1,'Michael Moore','FI','464355855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:00',0,'2014-03-02 04:24:47'),(19138,19788,'0000-00-00','ET','2',1,NULL,'Steven Nathaniel Brewer','FI','289848077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:12',0,'2014-03-01 17:34:07'),(20258,20908,'0000-00-00','ET','2',1,NULL,'Crystal Gresham','FI','290709260','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:08',0,'2014-03-01 17:47:19'),(20926,21576,'0000-00-00','ET','2',2,1,'Dorey Lee Bates','FI','433738020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:18',0,'2014-03-02 07:10:28'),(22538,23188,'0000-00-00','ET','2',1,NULL,'Amanda Badertscher','FI','284805311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:38',0,'2014-03-07 21:36:32'),(22561,23211,'0000-00-00','ET','2',1,NULL,'Carolyn Sue Carli','FI','271487071','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:53',0,'2014-03-10 16:44:18'),(14837,15288,'2014-01-01','ET','2',1,NULL,'LEONARD MARKINS','FI','287787927','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:24',0,'2014-03-10 14:03:26'),(860,860,'2014-01-01','ET','2',2,1,'catina chau tran','FI','680683111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:57',0,'2014-03-01 22:10:55'),(2757,2757,'2014-01-01','ET','2',1,NULL,'Gary Rayford','FI','436864641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:58',0,'2014-03-02 04:15:49'),(14669,15120,'2014-01-01','ET','2',1,NULL,'DEBBIE MCCALLISTER','FI','280682843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:33',0,'2014-03-01 16:46:19'),(11195,11195,'2014-01-01','ET','2',1,NULL,'VANESSA JONES','FI','290705633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:16',0,'2014-03-01 16:23:43'),(6333,6333,'2014-01-01','ET','2',1,NULL,'Maria Martinez','FI','621882128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:24',0,'2014-03-02 04:10:25'),(18441,19091,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:32',0,'2014-03-10 16:31:33'),(18456,19106,'0000-00-00','ET','2',2,1,'James Bailey','FI','285680008','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:41',0,'2014-03-10 14:24:38'),(21199,21849,'0000-00-00','ET','2',1,NULL,'TERESA JAVIER','FI','733182080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 19:00:02',0,'2014-03-02 07:23:39'),(22859,23509,'0000-00-00','ET','2',1,NULL,'RAYMOND TORRES','FI','583891634','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:10',0,'2014-03-10 21:27:11'),(15811,16460,'0000-00-00','ET','2',1,NULL,'Frank Riley','FI','088584513','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:17',0,'2014-03-02 06:03:21'),(14425,14876,'2014-01-01','ET','2',1,NULL,'Patti Talamantez','FI','266293522','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:18',0,'2014-03-10 14:03:26'),(364,364,'2014-01-01','ET','2',1,NULL,'Ruby Hopkins','FI','301621730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:13',0,'2014-03-01 15:21:15'),(718,718,'2014-01-01','ET','2',2,1,'Tammy Vargas','FI','126543973','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:21',0,'2014-03-10 15:52:36'),(1056,1056,'2014-01-01','ET','2',1,NULL,'craig lemke','FI','271864161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:28',0,'2014-03-01 15:16:37'),(14205,14656,'2014-01-01','ET','2',1,NULL,'Mary Haynes','FI','273667382','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:42',0,'2014-03-10 14:03:26'),(4522,4522,'2014-01-01','ET','2',1,NULL,'Mark David Reis','FI','297643581','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:49',0,'2014-03-10 13:03:33'),(3996,3996,'2014-01-01','ET','2',1,NULL,'Angela Reyes','FI','453081392','Starmount Life Insurance Company','FI','720977315','Jessica   Verduzco','94','13455011','348','2014-01-01','Sync Success',0,'2013-12-25 23:00:03',0,'2014-03-02 03:09:49'),(17983,18633,'0000-00-00','ET','2',2,1,'Karen Waits','FI','276525389','HealthSpan','FI','311431434','Anthony   Selm','94','8788501','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:27',0,'2014-03-10 14:24:38'),(20344,20994,'0000-00-00','ET','2',1,NULL,'Rachael Schneider','FI','284880705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:34',0,'2014-03-01 17:47:19'),(21191,21841,'0000-00-00','ET','2',1,NULL,'Angela Donahue','FI','301862394','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-02-28 21:31:53',0,'2014-03-10 14:45:25'),(7545,7545,'2014-01-01','ET','2',1,NULL,'James Korner','FI','301566765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:28',0,'2014-03-01 16:05:34'),(5842,5842,'2014-01-01','ET','2',1,NULL,'Luljeta Dema','FI','013847304','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:50',0,'2014-03-01 15:10:22'),(15714,16363,'0000-00-00','ET','2',1,NULL,'Nancy Ann Helinski','FI','268547623','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:57',0,'2014-03-10 14:10:12'),(1388,1388,'2014-01-01','ET','2',1,NULL,'idena Taylor','FI','442904458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:38',0,'2014-03-02 04:45:37'),(1568,1568,'2014-01-01','ET','2',1,NULL,'Anthony Ancona','FI','096664380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:12',0,'2014-03-01 15:10:22'),(13620,13976,'2014-01-01','ET','2',3,2,'MICHELLE LEIGHTON','FI','282137117','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:39',0,'2014-03-10 16:10:34'),(2171,2171,'2014-01-01','ET','2',1,NULL,'william young','FI','287480956','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:12',0,'2014-03-01 15:16:37'),(3255,3255,'2014-01-01','ET','2',2,1,'Elihudi Robson','FI','288131590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:58',0,'2014-03-01 15:52:44'),(3404,3404,'2014-01-01','ET','2',1,NULL,'Deborah Eversole','FI','287549922','HealthSpan','FI','311431434','Michael  Dougherty','94','8793711','357','2014-01-01','Sync Success',0,'2013-12-25 21:51:48',0,'2014-03-10 13:24:34'),(187,187,'2014-01-01','ET','2',1,NULL,'Ryan Judice','FI','438048260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:48',0,'2014-03-01 22:10:55'),(16893,17543,'0000-00-00','ET','2',2,1,'UTANAH L CRAIN','FI','465024055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:22',0,'2014-03-02 06:24:38'),(495,495,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','357','2014-01-01','Sync Success',0,'2013-12-25 18:00:21',0,'2014-03-01 15:48:04'),(13964,14320,'2014-01-01','ET','2',1,NULL,'Sharon Glick','FI','294669337','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:43',0,'2014-03-10 14:03:26'),(13136,13492,'2014-01-01','ET','2',1,NULL,'Dexter Daugherty','FI','401372022','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:19',0,'2014-03-10 13:59:38'),(12938,12938,'2014-01-01','ET','2',1,NULL,'John Howard Gatiss','FI','385989418','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2014-01-04 06:00:03',0,'2014-03-01 15:48:04'),(4064,4064,'2014-01-01','ET','2',1,NULL,'Algernon Herron','FI','463699160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:08',0,'2014-03-02 03:09:49'),(5184,5184,'2014-01-01','ET','2',2,1,'steven mancine','FI','007469873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:50',0,'2014-03-02 00:10:48'),(17931,18581,'0000-00-00','ET','2',1,NULL,'Timothy Valenta','FI','449316301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:51',0,'2014-03-02 06:38:05'),(18507,19157,'0000-00-00','ET','2',1,NULL,'Barbara Apple White','FI','428273445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:16',0,'2014-03-02 06:45:14'),(3623,3623,'2014-01-01','ET','2',1,NULL,'Laura Lozano','FI','631077538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:05:03',0,'2014-03-02 01:10:33'),(11268,11268,'2014-01-01','ET','2',1,NULL,'lance irvin','FI','434694347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:31',0,'2014-03-02 04:45:37'),(5091,5091,'2014-01-01','ET','2',1,NULL,'Evelie Gravois','FI','433046457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:54',0,'2014-03-02 00:10:48'),(2756,2756,'2014-01-01','ET','2',1,NULL,'Kiera Hughes','FI','438799171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:55',0,'2014-03-02 04:15:49'),(10493,10493,'2014-01-01','ET','2',1,NULL,'Teresa Colbert','FI','274649221','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:39',0,'2014-03-01 16:15:39'),(2745,2745,'2014-01-01','ET','2',1,NULL,'Inez G Mckenzie','FI','436941918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:35',0,'2014-03-02 04:15:49'),(17939,18589,'0000-00-00','ET','2',1,NULL,'paul owens','FI','273645804','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:55',0,'2014-03-10 14:24:38'),(19568,20218,'0000-00-00','ET','2',1,NULL,'shelli friend','FI','294608233','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:22:54',0,'2014-03-10 14:37:47'),(21313,21963,'0000-00-00','ET','2',1,NULL,'Delta Morrison','FI','296766333','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:04',0,'2014-03-10 14:45:25'),(11305,11305,'2014-01-01','ET','2',2,1,'James Barrett','FI','438330255','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:40',0,'2014-03-02 04:45:37'),(3463,3463,'2014-01-01','ET','2',1,NULL,'Carolyn Barber','FI','305560917','HealthSpan','FI','311431434','Gregory B Burch','94','2776783','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:45',0,'2014-03-10 13:32:15'),(2905,2905,'2014-01-01','ET','2',1,NULL,'MICHAEL K COTTRELL','FI','270544369','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:08',0,'2014-03-10 13:24:34'),(5353,5353,'2014-01-01','ET','2',1,NULL,'JULIAN BRIDGES','FI','629283247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:57',0,'2014-03-01 21:11:04'),(2806,2806,'2014-01-01','ET','2',1,NULL,'Gary Riesenberg','FI','283509947','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:20:32',0,'2014-03-01 16:05:34'),(5160,5160,'2014-01-01','ET','2',1,NULL,'Robert Milan','FI','296501378','Summa Insurance Company, Inc.','FI','341809108','Deanna  M Cipriano','94','8479624','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:06',0,'2014-03-10 15:45:56'),(20481,21131,'0000-00-00','ET','2',2,1,'Jamie Hook','FI','296869572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:31',0,'2014-03-01 18:08:07'),(20679,21329,'0000-00-00','ET','2',1,NULL,'Ken Green','FI','273507752','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','348','2014-03-01','Sync Success',0,'2014-02-26 21:02:47',0,'2014-03-10 14:37:47'),(22147,22797,'0000-00-00','ET','2',1,NULL,'CUONG MANH DANG','FI','018706831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:03',0,'2014-03-06 21:36:23'),(17854,18504,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:05',0,'2014-03-02 06:38:05'),(17795,18445,'0000-00-00','ET','2',3,2,'Carol A Schmehl','FI','269741201','HealthSpan','FI','311431434','Steven M Schmitmeyer','94','2326455','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:29',0,'2014-03-10 14:10:12'),(11515,11515,'2014-01-01','ET','2',1,NULL,'Keith Rodney','FI','099605465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:06',0,'2014-03-02 04:52:44'),(5201,5201,'2014-01-01','ET','2',2,1,'OLGA HERNANDEZ','FI','585235937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:24',0,'2014-03-02 00:10:48'),(5117,5117,'2014-01-01','ET','2',2,1,'Donald Watson','FI','279501163','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:47',0,'2014-03-10 15:45:56'),(20920,21570,'0000-00-00','ET','2',1,NULL,'Nana  Hammond','FI','093593295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:13',0,'2014-03-01 18:08:07'),(22633,23283,'0000-00-00','ET','2',1,NULL,'Leann Landry','FI','458918307','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:07',0,'2014-03-08 21:35:36'),(17889,18539,'0000-00-00','ET','2',1,NULL,'Olivia Mancil','FI','433196613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:21',0,'2014-03-02 06:31:45'),(16777,17427,'0000-00-00','ET','2',1,NULL,'Susan Dick','FI','283604889','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:27',0,'2014-03-01 17:00:58'),(14444,14895,'2014-01-01','ET','2',1,NULL,'Eddy Villalta Guillen','FI','587851925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:28',0,'2014-03-02 05:38:34'),(1134,1134,'2014-01-01','ET','2',1,NULL,'Elinor Kosta','FI','561920376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:43',0,'2014-03-02 04:45:37'),(14113,14564,'2014-01-01','ET','2',2,1,'William Fisher','FI','297721016','Dental Care Plus, Inc.','FI','311185262','Timothy  McKeown','94','1640913','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:43',0,'2014-03-01 16:46:19'),(5406,5406,'2014-01-01','ET','2',1,NULL,'Eva Szasz','FI','270503864','Summa Insurance Company, Inc.','FI','341809108','Scott  Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 01:30:27',0,'2014-03-10 15:39:19'),(3748,3748,'2014-01-01','ET','2',1,NULL,'Tammie Warner','FI','270702525','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:08',0,'2014-03-10 13:20:27'),(5236,5236,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:35',0,'2014-03-10 13:20:27'),(6392,6392,'2014-01-01','ET','2',1,NULL,'Margaret Clark','FI','316580928','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:13',0,'2014-03-10 13:39:10'),(121,121,'2014-01-01','ET','2',1,NULL,'Kathleen Kelly','FI','101465469','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:43',0,'2014-03-10 15:45:56'),(3787,3787,'2014-01-01','ET','2',1,NULL,'Peter Trokan','FI','393948788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:52',0,'2014-03-01 15:26:40'),(6172,6172,'2014-01-01','ET','2',1,NULL,'jeanette skinner','FI','463559670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:28',0,'2014-03-02 04:10:25'),(4686,4686,'2014-01-01','ET','2',3,2,'Etienne Roets','FI','615258293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:09',0,'2014-03-02 04:38:08'),(2539,2539,'2014-01-01','ET','2',1,NULL,'Jeff Leggett','FI','299661137','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:11',0,'2014-03-01 15:10:22'),(16322,16972,'0000-00-00','ET','2',1,NULL,'CAROL JOYCE DELLIFANTI','FI','299528640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:37',0,'2014-03-01 17:00:58'),(16422,17072,'0000-00-00','ET','2',1,NULL,'Charolette  Wilson','FI','262529317','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:01:41',0,'2014-03-10 14:20:26'),(16779,17429,'0000-00-00','ET','2',1,NULL,'krystal tincher','FI','279804799','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:28',0,'2014-03-01 17:00:58'),(19988,20638,'0000-00-00','ET','2',1,NULL,'Jacob Adam Gold','FI','099722756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:44',0,'2014-03-02 07:03:25'),(22346,22996,'0000-00-00','ET','2',1,NULL,'Memphis Bregitzer','94','0000279607','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:10',0,'2014-03-07 21:36:32'),(391,391,'2014-01-01','ET','2',1,NULL,'Kathleen Cornin','FI','436962438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:06',0,'2014-03-01 22:10:55'),(15369,15820,'0000-00-00','ET','2',1,NULL,'troy kinman','FI','310761469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:47:00',0,'2014-03-10 14:10:12'),(10649,10649,'2014-01-01','ET','2',1,NULL,'SANTA HUERGA FLOREZ','FI','445523317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:47',0,'2014-03-02 04:31:46'),(3464,3464,'2014-01-01','ET','2',1,NULL,'Marsha Meddock','FI','292420726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:02',0,'2014-03-01 15:31:33'),(3052,3052,'2014-01-01','ET','2',1,NULL,'Michael Wilson','FI','280688633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:42',0,'2014-03-01 15:37:30'),(16678,17328,'0000-00-00','ET','2',1,NULL,'CHRISTI MIDDLETON','FI','428452618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:01',0,'2014-03-02 06:17:30'),(16781,17431,'0000-00-00','ET','2',1,NULL,'CAROLINE CARNEY','FI','415457464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:29',0,'2014-03-02 06:17:30'),(17102,17752,'0000-00-00','ET','2',1,NULL,'Eric Mason','FI','298748393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:02',0,'2014-03-01 17:00:58'),(17915,18565,'0000-00-00','ET','2',1,NULL,'MARY SMITH','FI','631085794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:39',0,'2014-03-02 06:38:05'),(18608,19258,'0000-00-00','ET','2',1,NULL,'Carolyn Selby','FI','301463309','Summa Insurance Company, Inc.','FI','341809108','Linda Marie Epperly','94','8798849','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:41',0,'2014-03-10 16:31:33'),(20837,21487,'0000-00-00','ET','2',1,NULL,'EDNA M DAVILA','FI','563434801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:15',0,'2014-03-02 07:17:36'),(21730,22380,'0000-00-00','ET','2',1,NULL,'Donald J Walker','FI','185381714','Summa Insurance Company, Inc.','FI','341809108','Deana  Alexander','94','2228297','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:03',0,'2014-03-10 16:44:18'),(22208,22858,'0000-00-00','ET','2',1,NULL,'MICHAEL WAYNE JAMES','FI','302644386','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:45',0,'2014-03-06 21:36:23'),(15523,15974,'0000-00-00','ET','2',1,NULL,'Jose Castaneda','FI','451498298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:01',0,'2014-03-02 05:59:43'),(742,742,'2014-01-01','ET','2',1,NULL,'Mary Kathern Martin','FI','271528454','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:06',0,'2014-03-10 13:24:34'),(14983,15434,'2014-01-01','ET','2',1,NULL,'JANET R SWISHER','FI','283502640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:03',0,'2014-03-01 16:50:53'),(10727,10727,'2014-01-01','ET','2',2,1,'Cosette Verga','FI','218491885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:32',0,'2014-03-01 16:10:36'),(14668,15119,'2014-01-01','ET','2',2,1,'Raymond Weisel','FI','269843030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:33',0,'2014-03-01 16:46:19'),(12359,12359,'2014-01-01','ET','2',1,NULL,'Patricia Bean','FI','464907321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:10',0,'2014-03-02 05:03:29'),(11002,11002,'2014-01-01','ET','2',1,NULL,'Tanner Lee Parson','FI','425574720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:51',0,'2014-03-02 04:31:46'),(3478,3478,'2014-01-01','ET','2',1,NULL,'David Atkins','FI','288541355','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:29',0,'2014-03-01 15:31:33'),(18695,19345,'0000-00-00','ET','2',2,1,'Elliott Craton','FI','463929725','Starmount Life Insurance Company','FI','720977315','Julie  Fortin','94','16508703','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:48',0,'2014-03-02 06:52:12'),(18979,19629,'0000-00-00','ET','2',1,NULL,'sue mclaughlin','FI','292686822','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:59',0,'2014-03-10 14:31:05'),(21142,21792,'0000-00-00','ET','2',1,NULL,'Amanda Stewart','FI','437795579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:16',0,'2014-03-02 07:23:39'),(21953,22603,'0000-00-00','ET','2',1,NULL,'Delia Anne Popovich','FI','433198045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:20',0,'2014-03-05 22:27:33'),(447,447,'2014-01-01','ET','2',1,NULL,'Gary Compton','FI','555984837','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:52',0,'2014-03-10 15:45:56'),(15691,16340,'0000-00-00','ET','2',2,1,'TANYA BAKER','FI','467983819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:42',0,'2014-03-02 06:03:21'),(4727,4727,'2014-01-01','ET','2',1,NULL,'Betty Atkinson','FI','427211490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:37',0,'2014-03-02 04:31:46'),(5355,5355,'2014-01-01','ET','2',1,NULL,'leneta bullock','FI','269583100','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:01',0,'2014-03-10 13:03:33'),(2220,2220,'2014-01-01','ET','2',1,NULL,'John Thompson','FI','291626079','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:50',0,'2014-03-10 15:39:19'),(3101,3101,'2014-01-01','ET','2',1,NULL,'Barbara Schilling','FI','435860082','Starmount Life Insurance Company','FI','720977315','John  Allen','94','4728680','348','2014-01-01','Sync Success',0,'2013-12-25 21:36:14',0,'2014-03-02 01:10:33'),(16546,17196,'0000-00-00','ET','2',2,1,'heather castleberry','FI','446840531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:06',0,'2014-03-02 06:10:30'),(16705,17355,'0000-00-00','ET','2',1,NULL,'Jessica Ziegler','FI','298848273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:20',0,'2014-03-01 17:00:58'),(18475,19125,'0000-00-00','ET','2',1,NULL,'Paul Morris','FI','282806696','HealthSpan','FI','311431434','Thomas  Simyak','94','13275609','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:53',0,'2014-03-10 14:31:05'),(19513,20164,'0000-00-00','ET','2',2,1,'Liberato Saladino','FI','299025254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:07:47',0,'2014-03-01 17:47:19'),(20700,21350,'0000-00-00','ET','2',1,NULL,'QUITION GOSS','FI','425060756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:12',0,'2014-03-02 07:17:36'),(6064,6064,'2014-01-01','ET','2',2,1,'TUAN VO','FI','433857995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:10',0,'2014-03-02 04:10:25'),(589,589,'2014-01-01','ET','2',2,1,'denise perkins','FI','237514148','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:14',0,'2014-03-10 13:24:34'),(10956,10956,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:23',0,'2014-03-10 16:03:49'),(1422,1422,'2014-01-01','ET','2',1,NULL,'travor Massey','FI','281803623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:47',0,'2014-03-10 13:45:57'),(2348,2348,'2014-01-01','ET','2',1,NULL,'KAREN ALFRED','FI','286481262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:35',0,'2014-03-01 15:26:40'),(17620,18270,'0000-00-00','ET','2',2,1,'Anthony tubbs','FI','434557415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:16',0,'2014-03-02 06:31:45'),(18065,18715,'0000-00-00','ET','2',1,NULL,'van chau','FI','604675205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:11',0,'2014-03-02 06:38:05'),(7149,7149,'2014-01-01','ET','2',1,NULL,'April Zaferopolos','FI','163686035','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:03',0,'2014-03-10 15:59:47'),(7107,7107,'2014-01-01','ET','2',1,NULL,'Mark  Wallen','FI','297548777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:49',0,'2014-03-01 15:52:44'),(10734,10734,'2014-01-01','ET','2',1,NULL,'Chloe Harris','94','0000723902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:43',0,'2014-03-01 16:10:36'),(15300,15751,'0000-00-00','ET','2',1,NULL,'Joseph Staruch','FI','295746073','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:18',0,'2014-03-10 16:17:47'),(3695,3695,'2014-01-01','ET','2',1,NULL,'LEVI JACOB','FI','439907117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:21',0,'2014-03-02 00:10:48'),(7447,7447,'2014-01-01','ET','2',1,NULL,'Joshua Rylander','FI','461699321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:20',0,'2014-03-02 04:10:25'),(14689,15140,'2014-01-01','ET','2',1,NULL,'Elsa Cano','FI','639307934','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:47',0,'2014-03-02 05:45:37'),(12526,12526,'2014-01-01','ET','2',1,NULL,'MELISSA KAY ALEXANDER','FI','278703710','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:16',0,'2014-03-10 13:59:38'),(17682,18332,'0000-00-00','ET','2',1,NULL,'TODD WHORTON','FI','299602258','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:54',0,'2014-03-10 16:24:30'),(20936,21586,'0000-00-00','ET','2',1,NULL,'Nicole Mollohan','FI','293748506','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:00:28',0,'2014-03-10 16:38:05'),(22842,23492,'0000-00-00','ET','2',1,NULL,'kevin owen','FI','086644126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-09 21:30:06',0,'2014-03-09 22:25:06'),(10689,10689,'2014-01-01','ET','2',1,NULL,'Cheryl Vadakin-Salvati','FI','290543953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:07',0,'2014-03-01 16:10:36'),(13243,13599,'2014-01-01','ET','2',1,NULL,'Lauren Hollier-Perkins','FI','437908099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:50',0,'2014-03-02 05:17:40'),(4306,4306,'2014-01-01','ET','2',1,NULL,'Jawon McCray','FI','426530660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:28',0,'2014-03-02 03:09:49'),(4227,4227,'2014-01-01','ET','2',2,1,'Mark LaForce','FI','271524251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:04',0,'2014-03-01 16:00:27'),(5791,5791,'2014-01-01','ET','2',1,NULL,'CAROL EMERUWA','FI','269544250','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:16',0,'2014-03-10 15:52:36'),(4978,4978,'2014-01-01','ET','2',1,NULL,'Carla Kampschmidt','FI','299745461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:18',0,'2014-03-01 15:31:33'),(2816,2816,'2014-01-01','ET','2',1,NULL,'Cena Glass','FI','437171166','Dental Care Plus, Inc.','FI','311185262','Michael Joseph Fitzpatrick','94','16875889','357','2014-01-01','Sync Success',0,'2013-12-25 21:20:49',0,'2014-03-01 16:05:34'),(17151,17801,'0000-00-00','ET','2',1,NULL,'Rachel Ebert','FI','276941157','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:33',0,'2014-03-10 16:24:30'),(17481,18131,'0000-00-00','ET','2',1,NULL,'Darald Polk','FI','426133037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:39',0,'2014-03-02 06:24:38'),(17910,18560,'0000-00-00','ET','2',1,NULL,'Maria Barrera','FI','643765073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:36',0,'2014-03-02 06:31:45'),(18386,19036,'0000-00-00','ET','2',1,NULL,'LILYOLANDA JOHNSON','FI','439538306','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:51',0,'2014-03-02 06:45:14'),(83,83,'2014-01-01','ET','2',1,NULL,'brijido rivas','FI','462318890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:30',0,'2014-03-01 22:10:55'),(13144,13500,'2014-01-01','ET','2',1,NULL,'Toshia Hyatt','FI','433656610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:41',0,'2014-03-02 05:17:40'),(13123,13479,'2014-01-01','ET','2',1,NULL,'Zachary Golman','FI','641223430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:52',0,'2014-03-02 05:17:40'),(1043,1043,'2014-01-01','ET','2',2,1,'Martin Hernandez','FI','455853268','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:04',0,'2014-03-01 21:11:04'),(12460,12460,'2014-01-01','ET','2',1,NULL,'Daniel James Ventura','FI','270946468','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:51',0,'2014-03-10 16:10:34'),(7670,7670,'2014-01-01','ET','2',2,1,'William Hall','FI','280668380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:30',0,'2014-03-10 13:39:10'),(6040,6040,'2014-01-01','ET','2',1,0,'David Clark','FI','285828868','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:14',0,'2014-03-10 15:39:19'),(12387,12387,'2014-01-01','ET','2',1,NULL,'Jeffrey Roy','FI','301622696','Dental Care Plus, Inc.','FI','311185262','Thomas  Paplaczyk','94','1925192','348','2014-02-01','Sync Success',1,'2014-01-02 04:29:12',0,'2014-03-01 16:30:17'),(3951,3951,'2014-01-01','ET','2',1,NULL,'MIYESHA JOHNSON','FI','604050829','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:35',0,'2014-03-01 23:10:52'),(16839,17489,'0000-00-00','ET','2',1,NULL,'suzanne legeza','FI','293421744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:18',0,'2014-03-01 17:00:58'),(15596,16047,'0000-00-00','ET','2',1,NULL,'JALONNICA CHUNTIERS WHITE','FI','434594941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:34',0,'2014-03-02 05:59:43'),(14801,15252,'2014-01-01','ET','2',2,1,'Xavier Workman','FI','401413149','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:58',0,'2014-03-10 14:03:26'),(14782,15233,'2014-01-01','ET','2',1,NULL,'William Doyle','FI','271561370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:46',0,'2014-03-10 14:03:26'),(12417,12417,'2014-01-01','ET','2',2,1,'Mann Nhan','FI','580181821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:18',0,'2014-03-02 05:03:29'),(1806,1806,'2014-01-01','ET','2',2,1,'Bonnie Brown','FI','278643030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:51',0,'2014-03-10 13:20:27'),(12271,12271,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:16',0,'2014-03-10 16:10:34'),(2619,2619,'2014-01-01','ET','2',1,NULL,'william james black','FI','278501400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:34',0,'2014-03-01 15:16:37'),(2883,2883,'2014-01-01','ET','2',2,1,'William Hall','FI','280668380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:05',0,'2014-03-10 13:39:10'),(19312,19962,'0000-00-00','ET','2',1,NULL,'Juan Trevino','FI','351428955','Starmount Life Insurance Company','FI','720977315','Esequiel  Garcia','94','16428563','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:06',0,'2014-03-02 06:59:07'),(6355,6355,'2014-01-01','ET','2',1,NULL,'Verkista Pittman','FI','428530129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:03',0,'2014-03-02 04:10:25'),(1148,1148,'2014-01-01','ET','2',1,NULL,'LISA GUICE','FI','434377082','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:08',0,'2014-03-02 04:38:08'),(16375,17025,'0000-00-00','ET','2',1,NULL,'JOYCE  MARIE NORRIS','FI','435212337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:10',0,'2014-03-02 06:10:30'),(1581,1581,'2014-01-01','ET','2',1,NULL,'Sheena Binion','FI','380943514','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:40',0,'2014-03-01 15:10:22'),(16193,16842,'0000-00-00','ET','2',1,NULL,'KEISHA FULLER','FI','438513409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:34',0,'2014-03-02 06:03:21'),(16576,17226,'0000-00-00','ET','2',1,NULL,'TIMOTHY MURPHY','FI','087724428','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:26',0,'2014-03-10 14:20:26'),(18376,19026,'0000-00-00','ET','2',1,NULL,'PATRICIA  MATHIS','FI','449961155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:44',0,'2014-03-02 06:45:14'),(21945,22595,'0000-00-00','ET','2',1,NULL,'Antoinette Poole','FI','436832119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:31:15',0,'2014-03-05 22:27:33'),(15893,16542,'0000-00-00','ET','2',1,NULL,'Shammery Whitelaw','FI','412575949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:01:08',0,'2014-03-02 06:03:21'),(12790,12790,'2014-01-01','ET','2',1,NULL,'TERRY BECKER','FI','464867259','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:53',0,'2014-03-02 05:10:52'),(3777,3777,'2014-01-01','ET','2',1,NULL,'JUANITA CURTIS','FI','386703994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:34',0,'2014-03-01 15:26:40'),(1009,1009,'2014-01-01','ET','2',1,NULL,'NANCY RIEGLER','FI','270504123','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:33',0,'2014-03-10 15:39:19'),(4219,4219,'2014-01-01','ET','2',1,NULL,'tenerina searles','FI','281488642','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:48',0,'2014-03-01 15:52:44'),(17629,18279,'0000-00-00','ET','2',1,NULL,'Jessica Parker','FI','438655144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:21',0,'2014-03-02 06:31:45'),(17941,18591,'0000-00-00','ET','2',1,NULL,'William Winter','FI','425696055','Starmount Life Insurance Company','FI','720977315','Vickie  Hicks','94','4766477','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:57',0,'2014-03-02 06:31:45'),(16092,16741,'0000-00-00','ET','2',1,NULL,'Dana Frederick','FI','280868315','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:12',0,'2014-03-10 14:20:26'),(7568,7568,'2014-01-01','ET','2',1,NULL,'Janell Renee Scott','FI','283649217','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:14',0,'2014-03-01 16:05:34'),(6993,6993,'2014-01-01','ET','2',1,NULL,'SHARON HAYNES','FI','463275961','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:16',0,'2014-03-02 02:10:49'),(13646,14002,'2014-01-01','ET','2',1,NULL,'CAROL BROMLEY-KWORTEK','FI','280505157','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:59',0,'2014-03-10 14:03:26'),(3947,3947,'2014-01-01','ET','2',1,NULL,'Kristy Tennant','FI','457614437','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:26',0,'2014-03-01 23:10:52'),(2272,2272,'2014-01-01','ET','2',1,0,'Bradley Combs','FI','311861626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:14',0,'2014-03-01 15:05:09'),(18906,19556,'0000-00-00','ET','2',5,4,'FATUMA MIDAMBA','FI','291967056','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:05',0,'2014-03-01 17:34:07'),(20242,20892,'0000-00-00','ET','2',2,1,'TRACY FREELAND','FI','293809013','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:02',0,'2014-03-10 14:37:47'),(15003,15454,'2014-01-01','ET','2',1,NULL,'Alan Meador','FI','281660872','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:11',0,'2014-03-10 16:17:47'),(372,372,'2014-01-01','ET','2',1,NULL,'Diane Muntz','FI','291769989','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:28',0,'2014-03-10 13:10:24'),(462,462,'2014-01-01','ET','2',1,NULL,'Sandra Frisch','FI','297662347','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:22',0,'2014-03-10 13:10:24'),(14712,15163,'2014-01-01','ET','2',2,1,'Khai Bui','FI','664074858','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:02',0,'2014-03-02 05:45:37'),(1130,1130,'2014-01-01','ET','2',1,NULL,'TAMMY SANDERSON','FI','458110851','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:35',0,'2014-03-02 04:38:08'),(5585,5585,'2014-01-01','ET','2',1,NULL,'Stephanie Cannon','FI','449474895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:10',0,'2014-03-02 04:45:37'),(13930,14286,'2014-01-01','ET','2',1,NULL,'OLGA  MARINA  PORTILLO','FI','461955407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:19',0,'2014-03-02 05:31:31'),(2711,2711,'2014-01-01','ET','2',1,NULL,'Ada Drews','FI','643445225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:33',0,'2014-03-02 04:15:49'),(12109,12109,'2014-01-01','ET','2',1,NULL,'glendon wright','FI','276847485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:01',0,'2014-03-01 16:30:17'),(5327,5327,'2014-01-01','ET','2',1,NULL,'Richard Ludwig','FI','278443645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:15:05',0,'2014-03-01 15:10:22'),(4256,4256,'2014-01-01','ET','2',1,NULL,'Angela Lyman','FI','027763774','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:01',0,'2014-03-10 13:32:15'),(4989,4989,'2014-01-01','ET','2',1,NULL,'Maurita Elam','FI','587584345','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:38',0,'2014-03-01 15:31:33'),(17039,17689,'0000-00-00','ET','2',1,NULL,'Amy Tucker','FI','439236831','Starmount Life Insurance Company','FI','720977315','Karen Ferguson Bruyninckx','94','4762708','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:23',0,'2014-03-02 06:24:38'),(18843,19493,'0000-00-00','ET','2',1,NULL,'Usman Vaid','FI','307707682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:21',0,'2014-03-02 06:52:12'),(20420,21070,'0000-00-00','ET','2',2,1,'LUCIANO HERNANDEZ','FI','280343550','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:43',0,'2014-03-01 18:08:07'),(22059,22709,'0000-00-00','ET','2',1,NULL,'Charles A Smith','FI','291683214','HealthSpan','FI','311431434','Tamara  Hagan','94','3691584','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:35',0,'2014-03-10 14:45:25'),(10373,10373,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:49:54',0,'2014-03-01 16:05:34'),(328,328,'2014-01-01','ET','2',1,NULL,'Joseph Bounce','FI','301561702','Dental Care Plus, Inc.','FI','311185262','Erik  Nelson','94','8337791','348','2014-01-01','Sync Success',0,'2013-12-25 17:46:06',0,'2014-03-01 15:21:15'),(16725,17375,'0000-00-00','ET','2',1,NULL,'LYDIA MONTANA','FI','585428662','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:35',0,'2014-03-02 06:17:30'),(5486,5486,'2014-01-01','ET','2',2,1,'Kimberly Smith-Jones','FI','439377728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:45:56',0,'2014-03-02 04:45:37'),(5026,5026,'2014-01-01','ET','2',1,NULL,'JOSEPH BAILEY','FI','580508743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:48',0,'2014-03-01 15:31:33'),(16273,16923,'0000-00-00','ET','2',1,NULL,'Brett LeBlanc','FI','436044985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:06',0,'2014-03-02 06:10:30'),(2912,2912,'2014-01-01','ET','2',1,NULL,'Deborah jean medina','FI','427239661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:19',0,'2014-03-02 01:10:33'),(2488,2488,'2014-01-01','ET','2',1,NULL,'jeffrey Korn','FI','114466728','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:08',0,'2014-03-10 13:10:24'),(11475,11475,'2014-01-01','ET','2',1,NULL,'Stephen Mckean','FI','300743430','Dental Care Plus, Inc.','FI','311185262','Julian  Lee','94','7970773','348','2014-02-01','Sync Success',0,'2013-12-28 03:30:54',0,'2014-03-01 16:30:17'),(12893,12893,'2014-01-01','ET','2',1,NULL,'Tracy Lee','FI','288846568','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:39',0,'2014-03-10 13:59:38'),(13707,14063,'2014-01-01','ET','2',2,1,'Anna Elsie See','FI','289509706','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:45',0,'2014-03-01 16:40:16'),(13664,14020,'2014-01-01','ET','2',1,NULL,'Tori Lawson','FI','437732574','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:19',0,'2014-03-02 05:24:45'),(21152,21802,'0000-00-00','ET','2',3,2,'Sandra grisby','FI','435175178','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:22',0,'2014-03-02 07:23:39'),(23065,23715,'0000-00-00','ET','2',2,1,'William Peterson','FI','292707311','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:39',0,'2014-03-10 21:17:52'),(11073,11073,'2014-01-01','ET','2',1,NULL,'Kimberly Mahota-Blessing','FI','021469762','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:13',0,'2014-03-10 16:03:49'),(518,518,'2014-01-01','ET','2',1,NULL,'Peter M Sekerak','FI','270589153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:00',0,'2014-03-01 15:48:04'),(1045,1045,'2014-01-01','ET','2',1,NULL,'Ruby Fancher','FI','461949153','Starmount Life Insurance Company','FI','720977315','Miranda  Kelley','94','7552567','348','2014-01-01','Sync Success',0,'2013-12-25 18:30:08',0,'2014-03-01 21:11:04'),(13562,13918,'2014-01-01','ET','2',1,NULL,'leora corney','FI','435271500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:56',0,'2014-03-02 05:31:31'),(12559,12559,'2014-01-01','ET','2',1,NULL,'LAURA ELLEN MAZAR','FI','217703646','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:38',0,'2014-03-10 13:59:38'),(4913,4913,'2014-01-01','ET','2',1,0,'Julie Goodhew','FI','276745674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:35',0,'2014-03-01 15:05:09'),(1381,1381,'2014-01-01','ET','2',1,NULL,'Maria S Lopez','FI','459590952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:24',0,'2014-03-02 04:45:37'),(19966,20616,'0000-00-00','ET','2',1,NULL,'Elizabeth Pennington','FI','383063292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:28',0,'2014-03-01 17:47:19'),(20446,21096,'0000-00-00','ET','2',1,NULL,'John Scardino','FI','295706380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:31:02',0,'2014-03-10 14:37:47'),(20999,21649,'0000-00-00','ET','2',1,NULL,'Emil Mitchell','FI','433046356','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','357','2014-04-01','Sync Success',0,'2014-02-28 07:30:39',0,'2014-03-02 07:17:36'),(10912,10912,'2014-01-01','ET','2',1,NULL,'charlene thompson','FI','289540212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:03',0,'2014-03-10 15:59:47'),(15474,15925,'0000-00-00','ET','2',1,NULL,'STANLEY J GRIFFIN','FI','382686817','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-22 03:22:56',0,'2014-03-10 14:10:12'),(14066,14517,'2014-01-01','ET','2',1,NULL,'Christopher Anthony','FI','425675765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:13',0,'2014-03-02 05:38:34'),(12819,12819,'2014-01-01','ET','2',1,NULL,'Paula Davis','FI','439277759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:57',0,'2014-03-02 05:10:52'),(5469,5469,'2014-01-01','ET','2',1,NULL,'Rhoeyce Dupre','FI','439715701','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:25',0,'2014-03-02 04:45:37'),(6250,6250,'2014-01-01','ET','2',1,NULL,'Al Jackson','FI','267775451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:56',0,'2014-03-02 04:10:25'),(6362,6362,'2014-01-01','ET','2',2,1,'Mary Kaufman','FI','297848783','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:16',0,'2014-03-10 13:39:10'),(2770,2770,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:21',0,'2014-03-01 16:05:34'),(11052,11052,'2014-01-01','ET','2',1,NULL,'Casey Bortles','FI','321725828','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:31',0,'2014-03-10 13:39:10'),(373,373,'2014-01-01','ET','2',1,NULL,'Roger John Mezger','FI','285485495','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:31',0,'2014-03-10 15:39:19'),(2920,2920,'2014-01-01','ET','2',2,1,'Will Sawatsky','FI','302700850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:34',0,'2014-03-01 15:37:30'),(10941,10941,'2014-01-01','ET','2',1,NULL,'Pamela Gelsinger','FI','271465835','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:58',0,'2014-03-10 16:03:49'),(13472,13828,'2014-01-01','ET','2',1,NULL,'ellen sands','FI','273448558','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:33',0,'2014-03-10 16:17:47'),(5228,5228,'2014-01-01','ET','2',1,NULL,'ELIZABETH RUTH GORDON','FI','426595779','Starmount Life Insurance Company','FI','720977315','FREDIA  YOUNG','94','15716571','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:21',0,'2014-03-02 00:10:48'),(19356,20006,'0000-00-00','ET','2',1,NULL,'Lora Foster','FI','438376142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:37',0,'2014-03-02 06:59:07'),(19950,20600,'0000-00-00','ET','2',1,NULL,'Miles Longbotham','FI','643050444','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:15',0,'2014-03-02 07:03:25'),(20008,20658,'0000-00-00','ET','2',1,NULL,'Bonnie Bostic','FI','301507379','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:58',0,'2014-03-10 16:38:05'),(22728,23378,'0000-00-00','ET','2',1,NULL,'LORALYN HAYNES','FI','310666312','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:19',0,'2014-03-10 14:50:59'),(1956,1956,'2014-01-01','ET','2',1,NULL,'Courtney L Karadeniz','FI','275802257','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:24',0,'2014-03-01 15:26:40'),(17406,18056,'0000-00-00','ET','2',1,NULL,'Krystian Hall','FI','300849981','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:46',0,'2014-03-01 17:20:55'),(2412,2412,'2014-01-01','ET','2',2,1,'stephen wahl','FI','272543809','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:37',0,'2014-03-01 15:26:40'),(12395,12395,'2014-01-01','ET','2',1,NULL,'Andrew N P Bennett','FI','300902392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:30',0,'2014-03-01 16:30:17'),(13467,13823,'2014-01-01','ET','2',1,NULL,'Matt Babcock','FI','048845088','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:30',0,'2014-03-10 14:03:26'),(13816,14172,'2014-01-01','ET','2',3,2,'Todd Kilpatrick','FI','272763864','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:22',0,'2014-03-10 16:10:34'),(15594,16045,'0000-00-00','ET','2',1,NULL,'August Gough','FI','438754670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:33',0,'2014-03-02 05:59:43'),(18649,19299,'0000-00-00','ET','2',1,NULL,'Kenneth Monahan','FI','277641575','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:13',0,'2014-03-01 17:34:07'),(19743,20393,'0000-00-00','ET','2',1,NULL,'maria olvera','FI','290508889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:03',0,'2014-03-02 06:59:07'),(20431,21081,'0000-00-00','ET','2',2,1,'William J Lehman','FI','294440814','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:50',0,'2014-03-10 14:37:47'),(22843,23493,'0000-00-00','ET','2',1,NULL,'VIOLETA ROMO','FI','630157773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:30:07',0,'2014-03-09 22:25:06'),(16068,16717,'0000-00-00','ET','2',1,NULL,'Kessandra Jackson','FI','233863247','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:54',0,'2014-03-01 16:56:22'),(14146,14597,'2014-01-01','ET','2',2,1,'EDUARD I  CESTEDES-MONTANO','FI','598544676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:05',0,'2014-03-02 05:38:34'),(13340,13696,'2014-01-01','ET','2',1,NULL,'DENISE ROBINSON','FI','293608584','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:28',0,'2014-03-01 16:40:16'),(7140,7140,'2014-01-01','ET','2',1,NULL,'jacob mattes','FI','299924952','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:47',0,'2014-03-10 15:52:36'),(5768,5768,'2014-01-01','ET','2',2,1,'CAROL MATTICK','FI','585948138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:29',0,'2014-03-02 01:10:33'),(3362,3362,'2014-01-01','ET','2',1,NULL,'ERIN MOSBAUGH','FI','254575613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:29',0,'2014-03-02 02:10:49'),(2860,2860,'2014-01-01','ET','2',1,NULL,'Cena Glass','FI','437171166','Summa Insurance Company, Inc.','FI','341809108','Michael Joseph Fitzpatrick','94','16875889','357','2014-01-01','Sync Success',0,'2013-12-25 21:22:20',0,'2014-03-10 15:59:47'),(20075,20725,'0000-00-00','ET','2',1,NULL,'Jennifer L\'Heureux','94','0000761132','Dental Care Plus, Inc.','FI','311185262','David  Loge','94','7559354','357','2014-02-28','Sync Success',0,'2014-02-25 21:00:29',0,'2014-03-01 18:08:07'),(21458,22108,'0000-00-00','ET','2',1,NULL,'Sarah Saleh El-Dabaja','FI','282927757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:26',0,'2014-03-03 21:36:16'),(21749,22399,'0000-00-00','ET','2',1,NULL,'Ian Michael Hughes','FI','281860615','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:19',0,'2014-03-10 14:45:25'),(22488,23138,'0000-00-00','ET','2',1,NULL,'Thelma M Gantt','FI','269723127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:02',0,'2014-03-07 21:36:32'),(22586,23236,'0000-00-00','ET','2',2,1,'ROBERT FUENTES','FI','462969846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:12',0,'2014-03-07 22:26:59'),(22989,23639,'0000-00-00','ET','2',1,NULL,'TERRY BALDRICK','FI','278688589','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:43',0,'2014-03-10 21:36:25'),(264,264,'2014-01-01','ET','2',1,NULL,'Lester Keys','FI','437987126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:21',0,'2014-03-01 20:10:57'),(15772,16421,'0000-00-00','ET','2',2,1,'James LaPlant','FI','290866124','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:36',0,'2014-03-10 16:24:30'),(3112,3112,'2014-01-01','ET','2',1,NULL,'Robin L Anderson','FI','296501026','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:31',0,'2014-03-10 15:52:36'),(2343,2343,'2014-01-01','ET','2',2,1,'Baffour Otchere','FI','291766180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:28',0,'2014-03-01 15:26:40'),(2116,2116,'2014-01-01','ET','2',1,NULL,'Deva Upshaw','FI','286684991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:26',0,'2014-03-01 15:16:37'),(22734,23384,'0000-00-00','ET','2',1,NULL,'Angela Petry','FI','435610289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 20:59:59',0,'2014-03-09 21:26:00'),(13526,13882,'2014-01-01','ET','2',1,NULL,'William Crist','FI','288822490','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:34',0,'2014-03-01 16:40:16'),(2833,2833,'2014-01-01','ET','2',1,NULL,'Mirabel Bridges','FI','645182877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:25',0,'2014-03-02 04:15:49'),(2374,2374,'2014-01-01','ET','2',1,NULL,'Anthony Boone','FI','269823308','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:28',0,'2014-03-01 15:26:40'),(1910,1910,'2014-01-01','ET','2',1,NULL,'BARBARA JANE BOURQUIN','FI','459257742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:04',0,'2014-03-01 23:10:52'),(18260,18910,'0000-00-00','ET','2',1,NULL,'JAMES KOPAC','FI','294764557','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:46',0,'2014-03-10 16:31:33'),(20554,21204,'0000-00-00','ET','2',1,NULL,'Benjamn Boyle-Court','FI','645205677','Starmount Life Insurance Company','FI','720977315','Charles  heinzelman','94','745305','357','2014-03-13','Sync Success',0,'2014-02-26 21:01:19',0,'2014-03-02 07:17:36'),(20650,21300,'0000-00-00','ET','2',2,1,'Lou Lintner','FI','288545907','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:25',0,'2014-03-10 16:38:05'),(15042,15493,'2014-01-01','ET','2',1,NULL,'Michael Eastin','FI','435314617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:28',0,'2014-03-02 05:52:31'),(10823,10823,'2014-01-01','ET','2',1,NULL,'yen n tran','FI','433997392','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:38',0,'2014-03-02 04:31:46'),(4606,4606,'2014-01-01','ET','2',1,NULL,'Kathleen Temple','FI','268502660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:25',0,'2014-03-01 16:15:39'),(946,946,'2014-01-01','ET','2',1,NULL,'Jane Ray','FI','437709320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:32',0,'2014-03-01 22:10:55'),(3765,3765,'2014-01-01','ET','2',1,NULL,'james campos','FI','461060590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:10',0,'2014-03-01 23:10:52'),(1980,1980,'2014-01-01','ET','2',2,1,'Vincent Dicintio','FI','293524043','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:10',0,'2014-03-10 15:45:56'),(2601,2601,'2014-01-01','ET','2',1,0,'kathy steffen','FI','122522385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:03',0,'2014-03-01 15:05:09'),(10694,10694,'2014-01-01','ET','2',3,2,'David Danner','FI','299649604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:19',0,'2014-03-01 16:10:36'),(22225,22875,'0000-00-00','ET','2',2,1,'CYNTHIA WALLACE','FI','466379748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:58',0,'2014-03-06 21:27:26'),(10782,10782,'2014-01-01','ET','2',1,NULL,'Harris Irvin','FI','437336700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:18',0,'2014-03-02 04:24:47'),(13482,13838,'2014-01-01','ET','2',1,NULL,'Karen Motz','FI','407114761','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:40',0,'2014-03-10 14:03:26'),(12535,12535,'2014-01-01','ET','2',1,NULL,'Charolette  Wilson','FI','262529317','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:37',0,'2014-03-10 13:59:38'),(68,68,'2014-01-01','ET','2',2,1,'Marie Lauer','FI','288521902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:04',0,'2014-03-01 15:26:40'),(16169,16818,'0000-00-00','ET','2',2,1,'ru huang','FI','097841563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:19',0,'2014-03-01 16:56:22'),(5573,5573,'2014-01-01','ET','2',1,NULL,'Samuel Neill','FI','630074639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:46',0,'2014-03-02 04:45:37'),(5363,5363,'2014-01-01','ET','2',3,2,'Sarah Joy Forrer','FI','294785981','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:17',0,'2014-03-10 15:39:19'),(2010,2010,'2014-01-01','ET','2',1,NULL,'Robert Clary','FI','506645006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:11',0,'2014-03-02 00:10:48'),(11543,11543,'2014-01-01','ET','2',1,NULL,'DEBORAH RODRIGUEZ','FI','460792950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:55',0,'2014-03-02 04:52:44'),(4655,4655,'2014-01-01','ET','2',3,2,'amy warnick','FI','299881078','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:06',0,'2014-03-10 16:03:49'),(3424,3424,'2014-01-01','ET','2',3,2,'teresa davis','FI','294745384','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:28',0,'2014-03-10 13:24:34'),(18840,19490,'0000-00-00','ET','2',3,2,'Lam Chui','FI','051766647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:19',0,'2014-03-02 06:52:12'),(20985,21635,'0000-00-00','ET','2',1,NULL,'Fred Casby','FI','433113802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:29',0,'2014-03-02 07:17:36'),(6031,6031,'2014-01-01','ET','2',1,NULL,'yat tung lau','FI','463159520','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-12-31','Received',0,'2013-12-26 02:45:55',NULL,NULL),(3850,3850,'2014-01-01','ET','2',1,NULL,'BIRDELL PICKENS','FI','439452342','Starmount Life Insurance Company','FI','720977315','Ledricka  Thierry','94','9445795','348','2014-01-01','Sync Success',0,'2013-12-25 22:30:37',0,'2014-03-01 19:11:03'),(2387,2387,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:16:50',0,'2014-03-01 23:10:52'),(4113,4113,'2014-01-01','ET','2',1,NULL,'Jason Gearin','FI','287605278','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:35',0,'2014-03-01 16:00:27'),(3990,3990,'2014-01-01','ET','2',1,NULL,'martha kasch','FI','271528133','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:56',0,'2014-03-10 13:10:24'),(2782,2782,'2014-01-01','ET','2',5,4,'Steven J Spieldenner','FI','279660135','Dental Care Plus, Inc.','FI','311185262','Melinda  Ciesielczyk','94','1801499','348','2014-01-01','Sync Success',0,'2013-12-25 21:19:43',0,'2014-03-01 16:05:34'),(17240,17890,'0000-00-00','ET','2',1,NULL,'Angela Miller','FI','277822586','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:26',0,'2014-03-10 16:24:30'),(19506,20156,'0000-00-00','ET','2',1,NULL,'Michael Smith','FI','290546413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-05','Sync Success',0,'2014-02-20 04:05:32',0,'2014-03-01 17:34:07'),(21039,21689,'0000-00-00','ET','2',1,NULL,'jacob carl mills','FI','532118302','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:28',0,'2014-03-02 07:23:39'),(13979,14335,'2014-01-01','ET','2',1,NULL,'Danyeil Hoy','FI','350809223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:14',0,'2014-03-02 05:31:31'),(116,116,'2014-01-01','ET','2',1,NULL,'Sherri Pieronek','FI','301560846','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:32',0,'2014-03-10 15:45:56'),(10888,10888,'2014-01-01','ET','2',1,NULL,'Cranston Leslie Valentine','FI','453998415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:14',0,'2014-03-02 04:24:47'),(11899,11899,'2014-01-01','ET','2',1,NULL,'Robert Zuchowski','FI','524699922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:59',0,'2014-03-02 04:59:36'),(11890,11890,'2014-01-01','ET','2',1,NULL,'Raven Darby','FI','249897274','Starmount Life Insurance Company','FI','720977315','Lisa  Prater','94','15945577','348','2014-02-01','Sync Success',0,'2013-12-30 00:00:42',0,'2014-03-02 04:59:36'),(3650,3650,'2014-01-01','ET','2',1,NULL,'christopher  mcmaster','FI','289783927','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:55',0,'2014-03-10 15:52:36'),(5736,5736,'2014-01-01','ET','2',1,NULL,'Khepra Anu','FI','272644017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:30',0,'2014-03-01 15:48:04'),(5286,5286,'2014-01-01','ET','2',2,1,'Lori Hedrick','FI','460652457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:56',0,'2014-03-01 20:10:57'),(11430,11430,'2014-01-01','ET','2',1,NULL,'deborah jones','FI','294687306','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:31',0,'2014-03-10 16:03:49'),(18022,18672,'0000-00-00','ET','2',1,NULL,'Quentin Dudeck','FI','323802788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:54',0,'2014-03-01 17:20:55'),(19361,20011,'0000-00-00','ET','2',1,NULL,'walter w hull','FI','433173406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:40',0,'2014-03-02 06:59:07'),(19524,20174,'0000-00-00','ET','2',1,NULL,'DONALD DOMENIC GAUDIO','FI','298667018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:10:54',0,'2014-03-01 17:47:19'),(19622,20272,'0000-00-00','ET','2',1,NULL,'stephen promen','FI','268569160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:36:02',0,'2014-03-01 17:47:19'),(20616,21266,'0000-00-00','ET','2',1,NULL,'Anthony Jackson','FI','426379017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:59',0,'2014-03-02 07:17:36'),(14967,15418,'2014-01-01','ET','2',1,NULL,'Vincent Licursi','FI','289484129','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:56',0,'2014-03-01 16:50:53'),(13585,13941,'2014-01-01','ET','2',1,NULL,'Tonia L Guthrie','FI','587492989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:14',0,'2014-03-02 05:31:31'),(191,191,'2014-01-01','ET','2',1,NULL,'Quentin Rod Brown','FI','434375903','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:57',0,'2014-03-01 22:10:55'),(451,451,'2014-01-01','ET','2',1,NULL,'Marcus D Bailey','FI','459316057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:00',0,'2014-03-01 22:10:55'),(907,907,'2014-01-01','ET','2',1,NULL,'Kimberly  Thompson','FI','269547828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:17:19',0,'2014-03-01 15:21:15'),(12228,12228,'2014-01-01','ET','2',1,NULL,'LORIA S WRIGHT','FI','433136802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:33',0,'2014-03-02 05:10:52'),(2498,2498,'2014-01-01','ET','2',1,NULL,'maureen a longworth','FI','269526138','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:30',0,'2014-03-10 13:10:24'),(1408,1408,'2014-01-01','ET','2',1,NULL,'Melissa Rimes','FI','433695823','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:18',0,'2014-03-02 04:38:08'),(1643,1643,'2014-01-01','ET','2',1,NULL,'BONNIE SUE BARNETT','FI','302440484','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:02:17',0,'2014-03-10 13:03:33'),(11147,11147,'2014-01-01','ET','2',1,NULL,'STACY  WARSAW','FI','366547546','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:15:49',0,'2014-03-10 13:45:57'),(2389,2389,'2014-01-01','ET','2',1,NULL,'MARIA ELENA MORENO','FI','464392714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:52',0,'2014-03-01 23:10:52'),(17336,17986,'0000-00-00','ET','2',1,NULL,'JACOB FISHBACK','FI','280964729','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:14',0,'2014-03-10 14:24:38'),(20665,21315,'0000-00-00','ET','2',1,NULL,'Cathryn Marie White','FI','285489213','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:36',0,'2014-03-10 14:37:47'),(23003,23653,'0000-00-00','ET','2',1,NULL,'cory zunk','FI','277882673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:53',0,'2014-03-10 21:17:52'),(14532,14983,'2014-01-01','ET','2',1,NULL,'bryan Coon','FI','290563137','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:08',0,'2014-03-10 14:03:26'),(3501,3501,'2014-01-01','ET','2',2,1,'Mark Hill','FI','076609009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:14',0,'2014-03-01 15:37:30'),(3459,3459,'2014-01-01','ET','2',1,NULL,'karen a okeeffe','FI','365507485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:37',0,'2014-03-10 13:32:15'),(1779,1779,'2014-01-01','ET','2',1,NULL,'STACEY ANN METZGER','FI','295828391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:55',0,'2014-03-10 15:45:56'),(17350,18000,'0000-00-00','ET','2',2,1,'Thanh Phan','FI','586524263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:07',0,'2014-03-02 06:31:45'),(21150,21800,'0000-00-00','ET','2',1,NULL,'Arthelma Thompson','FI','433821560','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-02-28 21:31:21',0,'2014-03-02 07:23:39'),(23032,23682,'0000-00-00','ET','2',1,NULL,'Susan Crooker','FI','286703278','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:15',0,'2014-03-10 21:17:52'),(15738,16387,'0000-00-00','ET','2',1,NULL,'maria nino','FI','632180426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:14',0,'2014-03-02 06:03:21'),(10832,10832,'2014-01-01','ET','2',1,NULL,'heather howe','FI','433796039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:55',0,'2014-03-02 04:31:46'),(1563,1563,'2014-01-01','ET','2',1,NULL,'vickie zarebi','FI','275788991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:02',0,'2014-03-01 15:10:22'),(13618,13974,'2014-01-01','ET','2',1,NULL,'Jill Hartong','FI','284523886','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:38',0,'2014-03-10 16:10:34'),(19867,20517,'0000-00-00','ET','2',1,NULL,'Eileen Zink','FI','272520462','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:18',0,'2014-03-01 17:47:19'),(20302,20952,'0000-00-00','ET','2',1,NULL,'Rebecca Alcala','FI','436732230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 08:00:43',0,'2014-03-02 07:10:28'),(21038,21688,'0000-00-00','ET','2',1,NULL,'jacob carl mills','FI','532118302','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:27',0,'2014-03-02 07:23:39'),(21431,22081,'0000-00-00','ET','2',1,NULL,'Steven D Gilbert','FI','434357480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:03',0,'2014-03-03 22:26:43'),(300,300,'2014-01-01','ET','2',1,NULL,'Mark Jones','FI','425454666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:14',0,'2014-03-01 22:10:55'),(16873,17523,'0000-00-00','ET','2',2,1,'Alisa Randolph','FI','312880285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:10',0,'2014-03-02 06:17:30'),(1233,1233,'2014-01-01','ET','2',1,NULL,'STEVEN  BLOCKER','FI','177581319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:45',0,'2014-03-01 16:15:39'),(10850,10850,'2014-01-01','ET','2',1,NULL,'aimee eaton','FI','314789224','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:30',0,'2014-03-10 13:45:57'),(2292,2292,'2014-01-01','ET','2',1,NULL,'Philip Carman','FI','301522155','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:54',0,'2014-03-10 15:39:19'),(14171,14622,'2014-01-01','ET','2',1,NULL,'Susanne Shoffner','FI','362682145','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:21',0,'2014-03-10 16:17:47'),(12957,12957,'2014-01-01','ET','2',1,NULL,'Justine Miller','FI','280505686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:37',0,'2014-03-02 05:17:40'),(7080,7080,'2014-01-01','ET','2',1,NULL,'GREGORY WEBER','FI','289442713','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:01',0,'2014-03-01 15:52:44'),(5050,5050,'2014-01-01','ET','2',1,NULL,'Deborah Phillips','FI','299508657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:35',0,'2014-03-01 15:31:33'),(22290,22940,'0000-00-00','ET','2',1,NULL,'Ashley Fernandez','FI','439492339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:46',0,'2014-03-06 21:27:26'),(10410,10410,'2014-01-01','ET','2',4,3,'Joanne Filina','FI','290603002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:00',0,'2014-03-01 16:10:36'),(1239,1239,'2014-01-01','ET','2',2,1,'Jack R Helmick','FI','286421593','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:53',0,'2014-03-01 16:15:39'),(1259,1259,'2014-01-01','ET','2',1,NULL,'Karin O Weltin','FI','300544119','Dental Care Plus, Inc.','FI','311185262','Mark  Swisher','94','15817320','348','2014-01-01','Sync Success',0,'2013-12-25 18:49:29',0,'2014-03-01 16:15:39'),(3642,3642,'2014-01-01','ET','2',1,NULL,'Bruce Lombardo','FI','299486645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:40',0,'2014-03-10 13:20:27'),(11967,11967,'2014-01-01','ET','2',1,NULL,'Debra Monkres','FI','453413831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:51',0,'2014-03-02 04:59:36'),(13017,13017,'2014-01-01','ET','2',1,NULL,'Cynthia Gaines','FI','278580274','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:51',0,'2014-03-10 16:10:34'),(17426,18076,'0000-00-00','ET','2',1,NULL,'Sherri Baughman','FI','299648149','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:59',0,'2014-03-10 14:24:38'),(17793,18443,'0000-00-00','ET','2',1,NULL,'Daniel Smith','FI','296909491','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:27',0,'2014-03-01 16:50:53'),(18028,18678,'0000-00-00','ET','2',1,NULL,'Jeffrey Upadia','FI','268828753','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:58',0,'2014-03-01 17:26:36'),(18681,19331,'0000-00-00','ET','2',1,NULL,'NOEL HURTADO','FI','562934432','Starmount Life Insurance Company','FI','720977315','VIANEY  MARTINEZ','94','15750460','357','2014-03-01','Sync Success',0,'2014-02-13 22:01:37',0,'2014-03-02 06:45:14'),(22282,22932,'0000-00-00','ET','2',1,NULL,'Kashawnna Gilmer','FI','290946902','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:40',0,'2014-03-10 14:50:59'),(22965,23615,'0000-00-00','ET','2',1,NULL,'Karen Scott','FI','273606162','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:26',0,'2014-03-10 21:36:25'),(15755,16404,'0000-00-00','ET','2',1,NULL,'WILLIAM BENTON','FI','426219363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:26',0,'2014-03-02 06:03:21'),(7640,7640,'2014-01-01','ET','2',1,NULL,'Deanie Polk','FI','459966538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:32',0,'2014-03-02 04:15:49'),(1536,1536,'2014-01-01','ET','2',1,NULL,'Kalin Smith','FI','292908550','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:58:30',0,'2014-03-10 13:52:32'),(15359,15810,'0000-00-00','ET','2',1,NULL,'Micheal Beam','FI','436557493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:54',0,'2014-03-02 05:52:31'),(14307,14758,'2014-01-01','ET','2',1,NULL,'Aimee Desilet','FI','594289651','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:27',0,'2014-03-02 05:38:34'),(7011,7011,'2014-01-01','ET','2',1,NULL,'Arthur Michon','FI','466832579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:51',0,'2014-03-02 03:09:49'),(13200,13556,'2014-01-01','ET','2',1,NULL,'SCOTT SMALL','FI','554339761','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:46',0,'2014-03-10 13:59:38'),(5502,5502,'2014-01-01','ET','2',1,NULL,'Lisa Colagross','FI','287668964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:29',0,'2014-03-01 16:23:43'),(3608,3608,'2014-01-01','ET','2',1,NULL,'Shelley Posante','FI','304528993','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:36',0,'2014-03-10 15:52:36'),(11474,11474,'2014-01-01','ET','2',1,NULL,'Nathaniel Love','FI','258083010','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:52',0,'2014-03-01 16:30:17'),(17427,18077,'0000-00-00','ET','2',4,3,'Jeremy Blackmon','FI','457690331','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:00',0,'2014-03-02 06:31:45'),(18211,18861,'0000-00-00','ET','2',2,1,'Roger Gruccio','FI','293523429','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:02',0,'2014-03-10 16:31:33'),(19182,19832,'0000-00-00','ET','2',3,2,'Penny Jones','FI','292608956','HealthSpan','FI','311431434','Michelle  Sweeney','94','2438648','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:49',0,'2014-03-10 14:31:05'),(20814,21464,'0000-00-00','ET','2',1,NULL,'ROBERTO RIVERA','FI','782358708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:05',0,'2014-03-02 07:17:36'),(12192,12192,'2014-01-01','ET','2',1,NULL,'Kim Parks','FI','288561997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:03',0,'2014-03-10 13:52:32'),(10946,10946,'2014-01-01','ET','2',1,NULL,'Robert Hagner','FI','275700096','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:06',0,'2014-03-10 16:03:49'),(3013,3013,'2014-01-01','ET','2',1,NULL,'Janet Spence','FI','268820327','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:32',0,'2014-03-10 15:52:36'),(3092,3092,'2014-01-01','ET','2',1,NULL,'Barbara Butler','FI','433942266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:57',0,'2014-03-02 01:10:33'),(3788,3788,'2014-01-01','ET','2',1,NULL,'Marquita Johnson','FI','283843291','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:54',0,'2014-03-01 15:26:40'),(10827,10827,'2014-01-01','ET','2',2,1,'Larry McGee','FI','434909404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:45',0,'2014-03-02 04:31:46'),(5747,5747,'2014-01-01','ET','2',1,NULL,'Albert R Oettli','FI','434841333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:01:48',0,'2014-03-02 01:10:33'),(19973,20623,'0000-00-00','ET','2',2,1,'Kathy Newburn','FI','277587112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:33',0,'2014-03-01 17:47:19'),(20610,21260,'0000-00-00','ET','2',1,NULL,'Lelama Alexander','FI','435173653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:55',0,'2014-03-02 07:10:28'),(681,681,'2014-01-01','ET','2',2,1,'Zachary Lawrence','FI','603103858','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:08',0,'2014-03-10 15:52:36'),(804,804,'2014-01-01','ET','2',1,NULL,'Gilda Miller','FI','450909105','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:19',0,'2014-03-01 19:11:03'),(1523,1523,'2014-01-01','ET','2',2,1,'Paula Moses','FI','547399158','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 18:58:10',0,'2014-03-10 16:03:49'),(11657,11657,'2014-01-01','ET','2',2,1,'Moustapha Salama','FI','260413906','Dental Care Plus, Inc.','FI','311185262','Mark  Kleiner','94','1494923','348','2014-02-01','Sync Success',0,'2013-12-28 03:36:30',0,'2014-03-01 16:30:17'),(11372,11372,'2014-01-01','ET','2',1,NULL,'James RIvas','FI','437198568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:43',0,'2014-03-02 04:45:37'),(2931,2931,'2014-01-01','ET','2',2,1,'Raymond Joseph Orf','FI','493805920','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:57',0,'2014-03-01 15:37:30'),(3259,3259,'2014-01-01','ET','2',1,NULL,'Helen White','FI','402761495','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:06',0,'2014-03-10 15:52:36'),(16009,16658,'0000-00-00','ET','2',1,NULL,'Stephanie Mayers','94','0000613887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:16',0,'2014-03-02 06:03:21'),(7729,7729,'2014-01-01','ET','2',2,1,'Steve Ditcher','FI','298521693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:11',0,'2014-03-01 15:05:09'),(5474,5474,'2014-01-01','ET','2',1,NULL,'Chanda Olivers','FI','086566538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:34',0,'2014-03-02 04:45:37'),(17671,18321,'0000-00-00','ET','2',1,NULL,'wendy barnett','FI','290742136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:48',0,'2014-03-10 16:24:30'),(2864,2864,'2014-01-01','ET','2',1,NULL,'WILLIAM MEADOWS','FI','296564274','HealthSpan','FI','311431434','GERALD C CAMPBELL','94','966822','348','2014-01-01','Sync Success',0,'2013-12-25 21:22:27',0,'2014-03-10 13:39:10'),(5968,5968,'2014-01-01','ET','2',1,NULL,'Maria Flores','FI','637164859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:55',0,'2014-03-02 02:10:49'),(4597,4597,'2014-01-01','ET','2',4,3,'Randal Harper','FI','282788666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:11',0,'2014-03-01 16:15:39'),(17974,18624,'0000-00-00','ET','2',2,1,'Barbara Whitley','FI','467066376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:21',0,'2014-03-02 06:38:05'),(19116,19766,'0000-00-00','ET','2',1,NULL,'Linda Watson','FI','298543668','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:56',0,'2014-03-01 17:34:07'),(19594,20244,'0000-00-00','ET','2',1,NULL,'Basel Jalal Musharbash','FI','641988141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:31:06',0,'2014-03-02 06:59:07'),(20486,21136,'0000-00-00','ET','2',2,1,'Mark T Baker','FI','297443998','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:36',0,'2014-03-10 16:38:05'),(12392,12392,'2014-01-01','ET','2',1,NULL,'NANCY VANCE','FI','224844172','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:23',0,'2014-03-01 16:30:17'),(547,547,'2014-01-01','ET','2',2,1,'Andrew Fineran','FI','199669784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:55',0,'2014-03-01 15:48:04'),(1208,1208,'2014-01-01','ET','2',1,NULL,'Richard Schwartz','FI','277726079','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:01',0,'2014-03-01 16:15:39'),(1220,1220,'2014-01-01','ET','2',2,1,'GEORGE ANN TENAGLIO','FI','289548895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:23',0,'2014-03-01 16:15:39'),(1602,1602,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:16',0,'2014-03-01 20:10:57'),(11325,11325,'2014-01-01','ET','2',1,NULL,'KRISTEN RAUCH','FI','539788595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:15',0,'2014-03-02 04:52:44'),(12140,12140,'2014-01-01','ET','2',1,NULL,'James Robertson','FI','310929710','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:07',0,'2014-03-10 16:10:34'),(6036,6036,'2014-01-01','ET','2',2,1,'shawn beaverson','FI','300749469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:04',0,'2014-03-10 13:03:33'),(17635,18285,'0000-00-00','ET','2',1,NULL,'Kendrick Hudson','FI','427131827','Starmount Life Insurance Company','FI','720977315','Bennie  Hudson','94','10034374','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:25',0,'2014-03-02 06:31:45'),(18501,19151,'0000-00-00','ET','2',1,NULL,'Gregory Macias','FI','268740029','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:10',0,'2014-03-10 14:31:05'),(19739,20389,'0000-00-00','ET','2',1,NULL,'patricia molina','FI','464430929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:40:14',0,'2014-03-02 06:59:07'),(22037,22687,'0000-00-00','ET','2',1,NULL,'Reginald Hodge','FI','301820337','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:19',0,'2014-03-10 14:45:25'),(12922,12922,'2014-01-01','ET','2',1,NULL,'KRISTINE A DAVIS','FI','297809827','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:43',0,'2014-03-10 16:10:34'),(3568,3568,'2014-01-01','ET','2',1,NULL,'Patrick Pryor','FI','147927445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:22',0,'2014-03-02 00:10:48'),(5220,5220,'2014-01-01','ET','2',1,NULL,'Courtney L Karadeniz','FI','275802257','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:02',0,'2014-03-10 13:20:27'),(2184,2184,'2014-01-01','ET','2',1,NULL,'Sheila Kalloor','FI','458276539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:37',0,'2014-03-01 21:11:04'),(5248,5248,'2014-01-01','ET','2',1,NULL,'david schwab','FI','270523087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:56',0,'2014-03-10 13:20:27'),(18192,18842,'0000-00-00','ET','2',1,NULL,'ROBIN SAMPLE','FI','505027007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:46',0,'2014-03-01 17:26:36'),(18781,19431,'0000-00-00','ET','2',1,NULL,'Bryan Anderson','FI','288940735','HealthSpan','FI','311431434','Michael  Webber Jr','94','968310','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:52',0,'2014-03-10 14:31:05'),(18819,19469,'0000-00-00','ET','2',2,1,'MARIA E CERRILLO','FI','632469225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:04',0,'2014-03-02 06:52:12'),(704,704,'2014-01-01','ET','2',1,NULL,'Amy Hanna','FI','295844922','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:52',0,'2014-03-10 15:52:36'),(7588,7588,'2014-01-01','ET','2',1,NULL,'Darlene Piatt','FI','292561711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:57',0,'2014-03-01 16:05:34'),(15834,16483,'0000-00-00','ET','2',1,NULL,'Theresa Latimore-Kennedy','FI','285522264','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:31',0,'2014-03-01 16:56:22'),(15199,15650,'0000-00-00','ET','2',1,NULL,'Ramona Bullard','FI','434159789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:24',0,'2014-03-02 05:52:31'),(19435,20085,'0000-00-00','ET','2',2,1,'Robert Mitchin','FI','288506781','Summa Insurance Company, Inc.','FI','341809108','Andrew S Fredrick','94','16538320','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:34',0,'2014-03-10 16:31:33'),(20191,20841,'0000-00-00','ET','2',1,NULL,'VALENTE MALDONADO','FI','462089210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:23',0,'2014-03-02 07:10:28'),(21583,22233,'0000-00-00','ET','2',3,2,'Gurli Branco','FI','300543763','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:57',0,'2014-03-10 14:45:25'),(22487,23137,'0000-00-00','ET','2',1,NULL,'Orlando Townsend','FI','296889628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:01',0,'2014-03-07 21:36:32'),(1142,1142,'2014-01-01','ET','2',1,NULL,'Kim Davidson','FI','435130910','Starmount Life Insurance Company','FI','720977315','William Jacob Butcher','94','16324598','348','2014-01-01','Sync Success',0,'2013-12-25 18:45:58',0,'2014-03-02 04:38:08'),(11661,11661,'2014-01-01','ET','2',1,NULL,'ALBERTA JONES','FI','280683950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:36:38',0,'2014-03-01 16:30:17'),(16806,17456,'0000-00-00','ET','2',2,1,'DEBORAH  GILLUM','FI','295589674','HealthSpan','FI','311431434','MARK   SWISSER','94','15817320','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:45',0,'2014-03-10 14:20:26'),(11924,11924,'2014-01-01','ET','2',1,NULL,'Walter Burnom','FI','435118424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:45',0,'2014-03-02 04:59:36'),(5633,5633,'2014-01-01','ET','2',1,NULL,'kimberly crawford','FI','566379101','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:47',0,'2014-03-10 13:52:32'),(3022,3022,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000120057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:47',0,'2014-03-10 15:52:36'),(3095,3095,'2014-01-01','ET','2',2,1,'John Annan','FI','402868667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:03',0,'2014-03-02 01:10:33'),(18774,19424,'0000-00-00','ET','2',1,NULL,'JoAnn Wietecha','FI','272607370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:47',0,'2014-03-10 14:31:05'),(19389,20039,'0000-00-00','ET','2',1,NULL,'Christopher Ragonesi','FI','041642831','Dental Care Plus, Inc.','FI','311185262','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:00',0,'2014-03-01 17:34:07'),(7705,7705,'2014-01-01','ET','2',2,1,'THOMAS DUANE SPISAK','FI','276523097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:38',0,'2014-03-01 15:10:22'),(7567,7567,'2014-01-01','ET','2',1,NULL,'Emily Huelskamp','FI','274924287','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:12',0,'2014-03-01 16:05:34'),(16359,17009,'0000-00-00','ET','2',1,NULL,'Robert Somers','FI','299946152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:59',0,'2014-03-01 17:00:58'),(14966,15417,'2014-01-01','ET','2',1,NULL,'Matthew Stein','FI','275981438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:56',0,'2014-03-01 16:50:53'),(14582,15033,'2014-01-01','ET','2',1,NULL,'Gudelia Sotelo','FI','466975157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:39',0,'2014-03-02 05:45:37'),(22166,22816,'0000-00-00','ET','2',1,NULL,'james pytlik','FI','279480684','Dental Care Plus, Inc.','FI','311185262','sarah  fisher','94','2343593854','348','2014-04-01','Sync Success',0,'2014-03-06 21:01:15',0,'2014-03-06 21:36:23'),(920,920,'2014-01-01','ET','2',1,NULL,'VANNY J NAL','FI','279803791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:41',0,'2014-03-01 15:21:15'),(15445,15896,'0000-00-00','ET','2',1,NULL,'lc simpson','FI','428083088','Starmount Life Insurance Company','FI','720977315','lex  everett','94','3395975','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:38',0,'2014-03-02 05:59:43'),(7465,7465,'2014-01-01','ET','2',1,NULL,'Christopher Deal','FI','237698962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:49',0,'2014-03-02 04:15:49'),(1926,1926,'2014-01-01','ET','2',1,NULL,'John Yurcik','FI','278501615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:31',0,'2014-03-01 15:26:40'),(5427,5427,'2014-01-01','ET','2',1,NULL,'Matthew J Adams','FI','273084473','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:14',0,'2014-03-10 13:03:33'),(14098,14549,'2014-01-01','ET','2',1,NULL,'KATHERINE  NASH','FI','224763765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:34',0,'2014-03-01 16:40:16'),(18627,19277,'0000-00-00','ET','2',2,1,'Connie Vansickle','FI','297627936','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:56',0,'2014-03-01 17:26:36'),(18718,19368,'0000-00-00','ET','2',2,1,'RONG HUANG','FI','634948124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:06',0,'2014-03-02 06:45:14'),(18941,19591,'0000-00-00','ET','2',2,1,'lori ast','FI','288583154','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:31',0,'2014-03-10 16:31:33'),(19970,20620,'0000-00-00','ET','2',1,NULL,'GLORIA BOHA','FI','288541807','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:31',0,'2014-03-01 17:47:19'),(20756,21406,'0000-00-00','ET','2',1,NULL,'Annie Rivers Sanders','FI','427256706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:37',0,'2014-03-02 07:17:36'),(15218,15669,'0000-00-00','ET','2',1,NULL,'NEMESIO  MATEO BRITO','FI','016929336','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:38',0,'2014-03-02 05:52:31'),(15203,15654,'0000-00-00','ET','2',1,NULL,'Tammy Mayne','FI','269706484','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:27',0,'2014-03-01 16:50:53'),(11181,11181,'2014-01-01','ET','2',1,NULL,'Jerrilyn Meeker','FI','288563276','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:17:01',0,'2014-03-10 13:45:57'),(10443,10443,'2014-01-01','ET','2',1,NULL,'Terrance Hillsman','FI','285762669','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:05',0,'2014-03-01 16:10:36'),(14645,15096,'2014-01-01','ET','2',3,2,'Roy Bourn','FI','297683419','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:16',0,'2014-03-01 16:46:19'),(5946,5946,'2014-01-01','ET','2',1,NULL,'Shannon Harris','FI','428593465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:13',0,'2014-03-02 02:10:49'),(4063,4063,'2014-01-01','ET','2',1,NULL,'William D Piper','FI','510625605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:06',0,'2014-03-02 03:09:49'),(12685,12685,'2014-01-01','ET','2',2,1,'Steven Line','FI','286665623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:10',0,'2014-03-01 16:35:14'),(4774,4774,'2014-01-01','ET','2',1,NULL,'James C Meadows','FI','450434550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:01:06',0,'2014-03-01 21:11:04'),(17525,18175,'0000-00-00','ET','2',1,NULL,'Katherine Gerding','FI','286883852','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:18',0,'2014-03-01 17:20:55'),(18708,19358,'0000-00-00','ET','2',1,NULL,'MICHAEL OSBON','FI','434630981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:58',0,'2014-03-02 06:45:14'),(23112,23762,'0000-00-00','ET','2',1,NULL,'Vena Moore','FI','277482609','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:30:12',0,'2014-03-10 22:17:01'),(15189,15640,'0000-00-00','ET','2',1,NULL,'Diana Buksdorf','FI','298929498','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:18',0,'2014-03-10 14:10:12'),(367,367,'2014-01-01','ET','2',1,NULL,'Daniel Harold Detrick','FI','298608869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:18',0,'2014-03-01 15:21:15'),(11632,11632,'2014-01-01','ET','2',1,NULL,'zachary taylor','FI','438377816','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:43',0,'2014-03-02 04:52:44'),(11152,11152,'2014-01-01','ET','2',2,1,'richard williams','FI','274567581','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:58',0,'2014-03-10 13:45:57'),(5774,5774,'2014-01-01','ET','2',1,NULL,'Robert Biggs','FI','463697150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:40',0,'2014-03-02 01:10:33'),(1912,1912,'2014-01-01','ET','2',1,NULL,'linda barckow','FI','092545918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:07',0,'2014-03-01 23:10:52'),(12185,12185,'2014-01-01','ET','2',1,NULL,'Chrishana Lynn Hopkins','FI','294749891','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:44',0,'2014-03-10 13:52:32'),(18018,18668,'0000-00-00','ET','2',1,NULL,'Keven James Sharpe','FI','288867509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-25','Sync Success',0,'2014-02-10 21:31:51',0,'2014-03-01 17:20:55'),(19536,20186,'0000-00-00','ET','2',1,NULL,'JUSTIN COURSE','FI','425634941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:14:45',0,'2014-03-02 06:59:07'),(22760,23410,'0000-00-00','ET','2',1,NULL,'Lauren Clifton','FI','465395878','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:19',0,'2014-03-09 21:26:00'),(13028,13384,'2014-01-01','ET','2',1,NULL,'ERIN BLEKNAP','FI','543983421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:18',0,'2014-03-01 16:35:14'),(12674,12674,'2014-01-01','ET','2',1,NULL,'Deborah Decker','FI','283603449','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:48',0,'2014-03-01 16:35:14'),(12133,12133,'2014-01-01','ET','2',1,NULL,'David Carson','FI','370061167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:52',0,'2014-03-10 13:52:32'),(4536,4536,'2014-01-01','ET','2',2,1,'Daniel Lewis','FI','290869812','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:12',0,'2014-03-10 16:03:49'),(4708,4708,'2014-01-01','ET','2',1,NULL,'Carmen Adams','FI','277522507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:55',0,'2014-03-10 13:45:57'),(20189,20839,'0000-00-00','ET','2',1,NULL,'Carla Gibson','FI','465117768','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:22',0,'2014-03-02 07:10:28'),(374,374,'2014-01-01','ET','2',2,1,'Zachary Lawrence','FI','603103858','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:32',0,'2014-03-10 15:45:56'),(16909,17559,'0000-00-00','ET','2',1,NULL,'DEANNA HARDIN','FI','302863159','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:32',0,'2014-03-01 17:00:58'),(1114,1114,'2014-01-01','ET','2',1,NULL,'Cynthia Hennig','FI','387640584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:05',0,'2014-03-02 04:38:08'),(10647,10647,'2014-01-01','ET','2',2,1,'MARY WASHINGTON','FI','461987262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:42',0,'2014-03-02 04:31:46'),(1387,1387,'2014-01-01','ET','2',1,NULL,'CECELIA WAYNE','FI','459335321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:37',0,'2014-03-02 04:45:37'),(19034,19684,'0000-00-00','ET','2',1,NULL,'SINDY ROBBINS','FI','171465851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:07',0,'2014-03-01 17:34:07'),(20559,21209,'0000-00-00','ET','2',1,NULL,'Crystal Grant','FI','462756659','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:22',0,'2014-03-02 07:17:36'),(320,320,'2014-01-01','ET','2',1,NULL,'Margaret McRae-Gibson','FI','284624412','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:45:51',0,'2014-03-10 13:10:24'),(12111,12111,'2014-01-01','ET','2',1,NULL,'TAMIKA HASAN','FI','294603165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:06:06',0,'2014-03-01 16:30:17'),(15762,16411,'0000-00-00','ET','2',1,NULL,'Richard McCune','FI','235760139','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:29',0,'2014-03-10 14:10:12'),(4589,4589,'2014-01-01','ET','2',1,NULL,'Diwona Kyles','FI','269600575','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:56',0,'2014-03-01 16:15:39'),(13397,13753,'2014-01-01','ET','2',1,NULL,'Anna Bell','FI','458250495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:53',0,'2014-03-02 05:24:45'),(4390,4390,'2014-01-01','ET','2',1,NULL,'Annamarie Eneix','FI','295483241','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:39',0,'2014-03-01 15:16:37'),(2987,2987,'2014-01-01','ET','2',1,NULL,'Nancy Neighbors','FI','451234201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:44',0,'2014-03-02 01:10:33'),(12556,12556,'2014-01-01','ET','2',1,NULL,'Patti Penhorwood','FI','273741282','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:29',0,'2014-03-10 13:59:38'),(17846,18496,'0000-00-00','ET','2',2,1,'Andrew Caruso','FI','276909154','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:11',0,'2014-03-10 16:24:30'),(18666,19316,'0000-00-00','ET','2',1,NULL,'Mary Ringo','FI','450088231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:27',0,'2014-03-02 06:45:14'),(18668,19318,'0000-00-00','ET','2',2,1,'ARACELI MENDOZA','FI','632843569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:28',0,'2014-03-02 06:45:14'),(19861,20511,'0000-00-00','ET','2',1,NULL,'Dylan Stewart','FI','296965838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:12',0,'2014-03-01 17:47:19'),(20881,21531,'0000-00-00','ET','2',2,1,'Brent Horwath','FI','288829038','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:36',0,'2014-03-10 14:45:25'),(22664,23314,'0000-00-00','ET','2',1,NULL,'ELIA Martinez','FI','396906532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:30',0,'2014-03-08 22:26:18'),(197,197,'2014-01-01','ET','2',1,NULL,'Dinh Phan','FI','609542194','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 17:21:09',0,'2014-03-10 13:10:24'),(17802,18452,'0000-00-00','ET','2',1,NULL,'lisa bailey','FI','768768441','Dental Care Plus, Inc.','FI','311185262','david  mcneil','94','2557508','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:35',0,'2014-03-01 16:56:22'),(7342,7342,'2014-01-01','ET','2',1,NULL,'SUSAN  L BRUNO','FI','455929344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:12',0,'2014-03-01 21:11:04'),(5471,5471,'2014-01-01','ET','2',1,NULL,'Chaz Cooper','FI','436859237','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:29',0,'2014-03-02 04:45:37'),(15684,16333,'0000-00-00','ET','2',2,1,'JUDIDIA CABRERA','FI','453532394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:37',0,'2014-03-02 05:59:43'),(5190,5190,'2014-01-01','ET','2',1,NULL,'RITA VICTORIA SIMPSON','FI','508785225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:02',0,'2014-03-02 00:10:48'),(4551,4551,'2014-01-01','ET','2',1,NULL,'Rhonda M Silva','FI','276582540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:44',0,'2014-03-02 04:31:46'),(18380,19030,'0000-00-00','ET','2',1,NULL,'Terrion Franklin','FI','436512285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:47',0,'2014-03-02 06:45:14'),(22384,23034,'0000-00-00','ET','2',2,1,'John Britenriker','FI','291585180','Summa Insurance Company, Inc.','FI','341809108','John C Dalziel','94','362362','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:27',0,'2014-03-10 16:44:18'),(11766,11766,'2014-01-01','ET','2',1,NULL,'Mitchell Smith','FI','290822329','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:55',0,'2014-03-10 16:10:34'),(960,960,'2014-01-01','ET','2',1,NULL,'marie Harney','FI','434158730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:57',0,'2014-03-01 22:10:55'),(1576,1576,'2014-01-01','ET','2',1,NULL,'Wendy Moser','FI','452815950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:30',0,'2014-03-01 20:10:57'),(2219,2219,'2014-01-01','ET','2',2,1,'candy christy','FI','293684566','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:47',0,'2014-03-10 15:39:19'),(13022,13378,'2014-01-01','ET','2',1,NULL,'Megan Tulodzieski','FI','292849663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:05',0,'2014-03-01 16:35:14'),(11211,11211,'2014-01-01','ET','2',1,NULL,'Willie M Marshall','FI','273481484','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:47',0,'2014-03-01 16:23:43'),(7279,7279,'2014-01-01','ET','2',1,NULL,'Brenda Finley','FI','281525051','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:04',0,'2014-03-10 13:32:15'),(6254,6254,'2014-01-01','ET','2',1,NULL,'nicholas fortuna','FI','382904202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:02',0,'2014-03-02 04:10:25'),(19409,20059,'0000-00-00','ET','2',2,1,'CHRISTOPHER GENE CARPENTER','FI','276721071','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGEIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:15',0,'2014-03-10 16:31:33'),(17605,18255,'0000-00-00','ET','2',1,NULL,'RUBERTHA  MORGAN','FI','454554725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:07',0,'2014-03-02 06:31:45'),(1194,1194,'2014-01-01','ET','2',1,NULL,'derek boissineau','FI','555952701','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:35',0,'2014-03-02 04:45:37'),(10568,10568,'2014-01-01','ET','2',1,NULL,'Amanda Broome','FI','452818185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:08',0,'2014-03-02 04:24:47'),(16949,17599,'0000-00-00','ET','2',1,NULL,'Lavelle Maine','FI','434869548','Starmount Life Insurance Company','FI','720977315','Jennifer  Zimmerman','94','4710332','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:58',0,'2014-03-02 06:17:30'),(4847,4847,'2014-01-01','ET','2',1,NULL,'Sarah Stefan-Wohlgamuth','FI','270747103','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:30',0,'2014-03-10 15:39:19'),(13023,13379,'2014-01-01','ET','2',1,NULL,'emily oquendo','FI','142822349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:07',0,'2014-03-01 16:35:14'),(14420,14871,'2014-01-01','ET','2',1,NULL,'Marqua Harris','FI','638861619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:16',0,'2014-03-02 05:38:34'),(16531,17181,'0000-00-00','ET','2',1,NULL,'Tanzie Wood','FI','273722686','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:58',0,'2014-03-01 17:00:58'),(18520,19170,'0000-00-00','ET','2',1,NULL,'Jaime Elizabeth Ramos','FI','182722710','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:25',0,'2014-03-10 16:31:33'),(19429,20079,'0000-00-00','ET','2',1,NULL,'KATHERINE BUSH','FI','426254251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:30',0,'2014-03-02 06:59:07'),(19984,20634,'0000-00-00','ET','2',1,NULL,'Whitney Alexander','FI','438670746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:41',0,'2014-03-02 07:03:25'),(21651,22301,'0000-00-00','ET','2',1,NULL,'DEE MILLER','FI','268544569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:59',0,'2014-03-04 21:36:30'),(21851,22501,'0000-00-00','ET','2',1,NULL,'John Alexander Lapushansky','FI','230433590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-05 21:30:07',0,'2014-03-05 21:36:22'),(12679,12679,'2014-01-01','ET','2',1,NULL,'REBECCA L MELLUSO','FI','297885759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:57',0,'2014-03-01 16:35:14'),(14553,15004,'2014-01-01','ET','2',1,NULL,'Catherine Jenevein','FI','433512676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:20',0,'2014-03-02 05:45:37'),(18659,19309,'0000-00-00','ET','2',1,NULL,'Efrain Jaimes','FI','629701456','Starmount Life Insurance Company','FI','720977315','Danielle   Abbott','94','16964484','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:20',0,'2014-03-02 06:45:14'),(18103,18753,'0000-00-00','ET','2',1,NULL,'Sirley Bratchett','FI','451594374','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:41',0,'2014-03-02 06:38:05'),(17887,18537,'0000-00-00','ET','2',1,NULL,'RANDALL BIVINS','FI','253806150','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:20',0,'2014-03-10 16:31:33'),(4231,4231,'2014-01-01','ET','2',1,NULL,'John Schmittauer','FI','287543622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:11',0,'2014-03-01 16:00:27'),(3997,3997,'2014-01-01','ET','2',1,NULL,'JAMES  HADLEY','FI','632264892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:05',0,'2014-03-02 03:09:49'),(1575,1575,'2014-01-01','ET','2',1,NULL,'Ovelia Morales','FI','449026373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:28',0,'2014-03-01 20:10:57'),(5275,5275,'2014-01-01','ET','2',4,3,'Jennifer Waugh','FI','590600500','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:31',0,'2014-03-10 13:03:33'),(3287,3287,'2014-01-01','ET','2',1,NULL,'Danielle Niccole Moss','FI','282845684','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:03',0,'2014-03-01 15:48:04'),(19556,20206,'0000-00-00','ET','2',1,NULL,'SAMUEL L DANIEL','FI','433880206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:19:40',0,'2014-03-02 06:59:07'),(21181,21831,'0000-00-00','ET','2',1,NULL,'Lewis Gaskew','FI','587329598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:44',0,'2014-03-02 07:23:39'),(11873,11873,'2014-01-01','ET','2',1,NULL,'CAROL CHIKA OGWUMIKE','FI','524634060','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:10',0,'2014-03-02 04:59:36'),(15792,16441,'0000-00-00','ET','2',1,NULL,'Mike Keating','FI','523785968','Starmount Life Insurance Company','FI','720977315','camweron  liljenquist','94','8328382','357','2014-03-01','Sync Success',0,'2014-01-24 21:00:07',0,'2014-03-02 06:03:21'),(13363,13719,'2014-01-01','ET','2',1,NULL,'SARAH DE LEON','FI','634296040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:37',0,'2014-03-02 05:24:45'),(13280,13636,'2014-01-01','ET','2',1,NULL,'Stacy Dedon','FI','437457897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:05',0,'2014-03-02 05:24:45'),(5079,5079,'2014-01-01','ET','2',1,NULL,'Karen Jean Vroman','FI','301625311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:31',0,'2014-03-01 15:31:33'),(4209,4209,'2014-01-01','ET','2',1,NULL,'ANGELA JEFFERSON','FI','426457033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:06:31',0,'2014-03-02 03:09:49'),(4188,4188,'2014-01-01','ET','2',2,1,'Douglas I Landry','FI','278547203','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:53',0,'2014-03-10 15:59:47'),(3692,3692,'2014-01-01','ET','2',1,NULL,'VIVIAN ANN CAWTHORNE','FI','436881258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:15',0,'2014-03-02 00:10:48'),(21404,22054,'0000-00-00','ET','2',1,NULL,'VINCENT SPEHAR','FI','285766564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:14',0,'2014-03-03 21:36:16'),(22863,23513,'0000-00-00','ET','2',1,NULL,'JANE CLARK','FI','318464320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:12',0,'2014-03-10 21:27:11'),(7564,7564,'2014-01-01','ET','2',1,NULL,'Colleen Williams','FI','280903823','Dental Care Plus, Inc.','FI','311185262','Robert  Burgett','94','8813497','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:07',0,'2014-03-01 16:05:34'),(584,584,'2014-01-01','ET','2',1,NULL,'Julie Green','FI','540043162','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:04',0,'2014-03-02 02:10:49'),(1086,1086,'2014-01-01','ET','2',1,NULL,'robert warner','FI','341627334','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:30',0,'2014-03-01 15:05:09'),(16293,16943,'0000-00-00','ET','2',1,NULL,'PATRICIA DELARION','FI','228749116','Starmount Life Insurance Company','FI','720977315','ELOISE  CHAPMAN','94','11296439','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:18',0,'2014-03-02 06:10:30'),(15864,16513,'0000-00-00','ET','2',2,1,'Gregory Casserman','FI','273588978','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:50',0,'2014-03-10 16:24:30'),(12907,12907,'2014-01-01','ET','2',1,NULL,'cheryl alexander','FI','425439947','Starmount Life Insurance Company','FI','720977315','Isaac  Ruiz','94','17029214','348','2014-02-01','Sync Success',0,'2014-01-04 02:05:08',0,'2014-03-02 05:17:40'),(788,788,'2014-01-01','ET','2',2,1,'Cindy duong','FI','438352486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:44',0,'2014-03-01 19:11:03'),(18224,18874,'0000-00-00','ET','2',3,2,'Gregory Reichenbach','FI','301821213','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:13',0,'2014-03-10 14:24:38'),(17210,17860,'0000-00-00','ET','2',1,NULL,'EUGENIA G CURLUTU','FI','274688278','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:11',0,'2014-03-01 17:20:55'),(12218,12218,'2014-01-01','ET','2',1,NULL,'Veronica Ford','FI','428272628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:09',0,'2014-03-02 05:03:29'),(11983,11983,'2014-01-01','ET','2',1,NULL,'Kirk Spruiell','FI','450989499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:28',0,'2014-03-02 05:03:29'),(5988,5988,'2014-01-01','ET','2',1,NULL,'Harold Fredrick Hardy','FI','270845177','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:35',0,'2014-03-10 13:24:34'),(2512,2512,'2014-01-01','ET','2',1,0,'Kristopher Lambert','FI','270807553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 20:30:24',0,'2014-03-01 15:05:09'),(10982,10982,'2014-01-01','ET','2',1,NULL,'alon johnson','FI','428133947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:10',0,'2014-03-02 04:24:47'),(20397,21047,'0000-00-00','ET','2',1,NULL,'MARIN FINKELMAN','FI','459981051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:24',0,'2014-03-02 07:10:28'),(17874,18524,'0000-00-00','ET','2',1,NULL,'PATRICIA MCCAUSLIN','FI','482781176','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:10',0,'2014-03-10 16:31:33'),(12615,12615,'2014-01-01','ET','2',1,NULL,'Alexander Grajeda','FI','467799951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:37',0,'2014-03-02 05:10:52'),(11054,11054,'2014-01-01','ET','2',1,NULL,'Matthew I Antoine','FI','299981812','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:37',0,'2014-03-10 13:39:10'),(17439,18089,'0000-00-00','ET','2',2,1,'Cynthia Reed','FI','280586304','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:08',0,'2014-03-10 14:24:38'),(16755,17405,'0000-00-00','ET','2',1,NULL,'Jose Russa','FI','152505537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:13',0,'2014-03-02 06:17:30'),(11020,11020,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:30',0,'2014-03-10 13:39:10'),(18893,19543,'0000-00-00','ET','2',1,NULL,'TAMMY LYN WEILNAU','FI','280726910','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:57',0,'2014-03-10 14:31:05'),(19737,20387,'0000-00-00','ET','2',1,NULL,'DENISE FERRELL','FI','301468210','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:39:36',0,'2014-03-10 16:31:33'),(22810,23460,'0000-00-00','ET','2',1,NULL,'matthew babcock','FI','273583796','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:00',0,'2014-03-10 14:50:59'),(22963,23613,'0000-00-00','ET','2',1,NULL,'Thomas Stephens','FI','302860967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:25',0,'2014-03-10 21:36:25'),(4205,4205,'2014-01-01','ET','2',1,NULL,'ZAKIA SIMPSON','FI','425594662','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:24',0,'2014-03-02 03:09:49'),(5001,5001,'2014-01-01','ET','2',1,NULL,'walter allan sell','FI','295488640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:59',0,'2014-03-01 15:31:33'),(5140,5140,'2014-01-01','ET','2',1,NULL,'Joseph Marochino','FI','270885716','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 00:50:31',0,'2014-03-10 15:45:56'),(10380,10380,'2014-01-01','ET','2',1,NULL,'david graham','FI','299806196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:05',0,'2014-03-01 16:10:36'),(11265,11265,'2014-01-01','ET','2',1,NULL,'Eugene Randle','FI','435518628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:26',0,'2014-03-02 04:45:37'),(1373,1373,'2014-01-01','ET','2',1,NULL,'Carlton Hollins','FI','436139343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:08',0,'2014-03-02 04:38:08'),(13259,13615,'2014-01-01','ET','2',1,NULL,'Jessica Gerken','FI','272964751','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:33',0,'2014-03-10 13:59:38'),(18492,19142,'0000-00-00','ET','2',1,NULL,'sherry frady','FI','297604610','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:32:04',0,'2014-03-10 16:31:33'),(5171,5171,'2014-01-01','ET','2',1,NULL,'Judith Eitniear','FI','290506356','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:25',0,'2014-03-10 13:20:27'),(16699,17349,'0000-00-00','ET','2',1,NULL,'Terri Lee Epley','FI','295589535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:16',0,'2014-03-01 17:00:58'),(21002,21652,'0000-00-00','ET','2',1,NULL,'Michael Duncan','FI','439298281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:02',0,'2014-03-02 07:23:39'),(22378,23028,'0000-00-00','ET','2',3,2,'Anthony Cunningham','FI','294869900','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:24',0,'2014-03-10 14:50:59'),(22766,23416,'0000-00-00','ET','2',1,NULL,'Johnduras Godbolt','FI','593128142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-09 21:00:23',0,'2014-03-09 21:26:00'),(14053,14504,'2014-01-01','ET','2',1,NULL,'KRIS MISEVSKI','FI','286764179','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:04',0,'2014-03-01 16:46:19'),(10692,10692,'2014-01-01','ET','2',2,1,'Marc Conter','FI','281622113','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:14',0,'2014-03-01 16:10:36'),(7607,7607,'2014-01-01','ET','2',3,2,'jeffrey wilde','FI','301446230','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:29',0,'2014-03-10 15:59:47'),(4084,4084,'2014-01-01','ET','2',1,NULL,'Ronald Thomas','FI','270504177','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:48',0,'2014-03-01 16:00:27'),(2523,2523,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:44',0,'2014-03-01 20:10:57'),(20541,21191,'0000-00-00','ET','2',1,NULL,'Carlette Holmes','FI','438514455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:11',0,'2014-03-02 07:10:28'),(17836,18486,'0000-00-00','ET','2',1,NULL,'Ronald Conley','FI','509520602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:04',0,'2014-03-02 06:24:38'),(16575,17225,'0000-00-00','ET','2',1,NULL,'Samantha Laub','FI','291946045','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:26',0,'2014-03-10 14:20:26'),(14261,14712,'2014-01-01','ET','2',2,1,'Matthew Moran','FI','268844447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:07',0,'2014-03-01 16:46:19'),(7235,7235,'2014-01-01','ET','2',1,NULL,'HELEN BLANDFORD','FI','297580585','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:44',0,'2014-03-01 15:52:44'),(14256,14707,'2014-01-01','ET','2',1,NULL,'Jeffrey Davis','FI','298828455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:05',0,'2014-03-01 16:46:19'),(5039,5039,'2014-01-01','ET','2',1,NULL,'Richard Lockett','FI','298620813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:14',0,'2014-03-01 15:31:33'),(2231,2231,'2014-01-01','ET','2',2,1,'tony royster','FI','289627789','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:14',0,'2014-03-10 15:39:19'),(13949,14305,'2014-01-01','ET','2',2,1,'Raymond Babcock','FI','011489376','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:32',0,'2014-03-10 14:03:26'),(3227,3227,'2014-01-01','ET','2',1,NULL,'Kristine Bougie','FI','288520364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:08',0,'2014-03-01 15:52:44'),(23068,23718,'0000-00-00','ET','2',2,1,'Joseph Killion','94','0000646075','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:42',0,'2014-03-10 21:17:52'),(16465,17115,'0000-00-00','ET','2',1,NULL,'Robin Morgan','FI','286680549','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:15',0,'2014-03-01 17:00:58'),(15866,16515,'0000-00-00','ET','2',1,NULL,'Susan K Haehn','FI','300527211','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:51',0,'2014-03-10 14:10:12'),(15353,15804,'0000-00-00','ET','2',1,NULL,'James Fields','FI','587487295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:51',0,'2014-03-02 05:52:31'),(7540,7540,'2014-01-01','ET','2',1,NULL,'Gary Bracone','FI','273563546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:19',0,'2014-03-01 16:05:34'),(5409,5409,'2014-01-01','ET','2',2,1,'michael nagy','FI','232085468','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:34',0,'2014-03-10 13:03:33'),(13258,13614,'2014-01-01','ET','2',1,NULL,'BRYAN BROWN','FI','297681212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:30',0,'2014-03-10 16:10:34'),(13817,14173,'2014-01-01','ET','2',2,1,'Virginia Iammarino','FI','199369758','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:23',0,'2014-03-10 16:10:34'),(21020,21670,'0000-00-00','ET','2',1,NULL,'BRETT PODOLL','FI','188608465','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','357','2014-03-01','Sync Success',0,'2014-02-28 21:00:14',0,'2014-03-10 16:38:05'),(22528,23178,'0000-00-00','ET','2',2,1,'Zhengang Xie','FI','081885622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:30',0,'2014-03-07 21:36:32'),(17484,18134,'0000-00-00','ET','2',1,NULL,'Kandise Fontaine','FI','272500006','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:42',0,'2014-03-10 16:24:30'),(11621,11621,'2014-01-01','ET','2',1,NULL,'Michael Soto','FI','293689381','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:23',0,'2014-03-10 13:52:32'),(11316,11316,'2014-01-01','ET','2',1,NULL,'Terri Edeline-Johnson','FI','200588970','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:59',0,'2014-03-02 04:52:44'),(3070,3070,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:35:18',0,'2014-03-02 01:10:33'),(11116,11116,'2014-01-01','ET','2',1,NULL,'Connie Strange','FI','376585342','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:38',0,'2014-03-10 13:45:57'),(19977,20627,'0000-00-00','ET','2',1,NULL,'Pamela Cowan','FI','282640663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:36',0,'2014-03-01 17:47:19'),(13942,14298,'2014-01-01','ET','2',1,NULL,'jennifer ruby','FI','278905499','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:27',0,'2014-03-10 16:10:34'),(13514,13870,'2014-01-01','ET','2',1,NULL,'ROSANA LOPEZ','FI','643126173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:26',0,'2014-03-02 05:31:31'),(1895,1895,'2014-01-01','ET','2',1,NULL,'David Barclay','FI','455216762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:37',0,'2014-03-01 23:10:52'),(20864,21514,'0000-00-00','ET','2',1,NULL,'charles griesinger','FI','279686455','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:28',0,'2014-03-10 14:37:47'),(18771,19421,'0000-00-00','ET','2',1,NULL,'DOUGLAS R HARTINGER','FI','296562395','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:45',0,'2014-03-10 14:31:05'),(11294,11294,'2014-01-01','ET','2',1,NULL,'Jeff McRae','FI','238818684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:19',0,'2014-03-02 04:52:44'),(1984,1984,'2014-01-01','ET','2',1,NULL,'Susan Harris','FI','287483985','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:17',0,'2014-03-10 15:45:56'),(18615,19265,'0000-00-00','ET','2',1,NULL,'Forrest Sharier','FI','281589695','Summa Insurance Company, Inc.','FI','341809108','Jeff  Brett','94','2777121','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:46',0,'2014-03-10 16:31:33'),(15501,15952,'0000-00-00','ET','2',1,NULL,'Anita Abrams','FI','298583401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:01:51',0,'2014-03-01 16:50:53'),(11279,11279,'2014-01-01','ET','2',1,NULL,'melody matthews','FI','323729421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:52',0,'2014-03-02 04:52:44'),(15404,15855,'0000-00-00','ET','2',1,NULL,'Monica Rocio Roa Pineda','FI','067611099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',1,'2014-01-22 03:22:13',0,'2014-03-02 05:59:43'),(14537,14988,'2014-01-01','ET','2',1,NULL,'Delia Rose','FI','291569892','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:11',0,'2014-03-10 14:03:26'),(5272,5272,'2014-01-01','ET','2',1,NULL,'Barbara Strackbein','FI','465023623','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-26 01:00:24',0,'2014-03-01 19:11:03'),(14313,14764,'2014-01-01','ET','2',1,NULL,'OMAR MURILLO','FI','628187831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:30',0,'2014-03-02 05:38:34'),(13686,14042,'2014-01-01','ET','2',2,1,'Patricia Pearson','FI','455453944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:32',0,'2014-03-02 05:24:45'),(22141,22791,'0000-00-00','ET','2',1,NULL,'Amberle Teets','FI','216083241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:59',0,'2014-03-06 21:27:26'),(22686,23336,'0000-00-00','ET','2',1,NULL,'Lakesha Williams','FI','435655835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:47',0,'2014-03-08 22:26:18'),(17485,18135,'0000-00-00','ET','2',1,NULL,'SHARON E SHAHEEN','FI','289542618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:43',0,'2014-03-10 16:24:30'),(13207,13563,'2014-01-01','ET','2',1,NULL,'billie levert','FI','291540655','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-07 10:21:19',0,'2014-03-01 16:35:14'),(15709,16358,'0000-00-00','ET','2',1,NULL,'Adam Faller','FI','297565545','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:54',0,'2014-03-10 14:10:12'),(7312,7312,'2014-01-01','ET','2',1,NULL,'jennifer bailey','FI','274785028','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:05',0,'2014-03-10 13:32:15'),(15368,15819,'0000-00-00','ET','2',1,NULL,'Alexis howell','FI','284541682','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-21 08:47:00',0,'2014-03-10 14:10:12'),(4022,4022,'2014-01-01','ET','2',1,NULL,'Theodore Williams','FI','227748484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:50',0,'2014-03-02 03:09:49'),(6231,6231,'2014-01-01','ET','2',2,1,'maury schindler','FI','167383279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:17',0,'2014-03-01 16:00:27'),(4071,4071,'2014-01-01','ET','2',1,NULL,'Lacy Whitt','FI','454590086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:23',0,'2014-03-02 04:10:25'),(19414,20064,'0000-00-00','ET','2',1,NULL,'Rita Amburgey','FI','277560832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:19',0,'2014-03-10 14:31:05'),(20436,21086,'0000-00-00','ET','2',1,NULL,'Thomas Murach','FI','292446842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 09:30:54',0,'2014-03-01 18:08:07'),(22407,23057,'0000-00-00','ET','2',1,NULL,'susan barry','FI','134444225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:04',0,'2014-03-07 22:26:59'),(15819,16468,'0000-00-00','ET','2',1,NULL,'Denise Ankney','FI','281540990','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:22',0,'2014-03-10 14:10:12'),(15261,15712,'0000-00-00','ET','2',1,NULL,'benjamin maslanka','FI','285963551','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:37',0,'2014-03-10 16:17:47'),(14962,15413,'2014-01-01','ET','2',1,NULL,'Michail Jackson','FI','283780168','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:54',0,'2014-03-01 16:50:53'),(14847,15298,'2014-01-01','ET','2',2,1,'Justin Couture','FI','280909794','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:29',0,'2014-03-10 14:03:26'),(6340,6340,'2014-01-01','ET','2',1,NULL,'Ronald W Roubique','FI','435906625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:37',0,'2014-03-02 04:10:25'),(5111,5111,'2014-01-01','ET','2',2,1,'Jennifer Farnsworth','FI','299865559','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:33',0,'2014-03-10 13:20:27'),(10742,10742,'2014-01-01','ET','2',1,NULL,'HORACE SHAW','FI','302482160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:57',0,'2014-03-01 16:10:36'),(12875,12875,'2014-01-01','ET','2',1,NULL,'Julie Moreo','FI','283648206','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:58',0,'2014-03-01 16:35:14'),(12569,12569,'2014-01-01','ET','2',2,1,'SYLVIA CARTER','FI','279648592','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:36:05',0,'2014-03-10 13:59:38'),(20517,21167,'0000-00-00','ET','2',1,NULL,'Spencer Edwards','FI','431691331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:54',0,'2014-03-02 07:17:36'),(20767,21417,'0000-00-00','ET','2',2,1,'Annette Schafer','FI','273823618','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:43',0,'2014-03-01 18:08:07'),(21886,22536,'0000-00-00','ET','2',2,1,'wenceslada c garza','FI','267279693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:32',0,'2014-03-05 22:27:33'),(22370,23020,'0000-00-00','ET','2',1,NULL,'JANET GARNER','FI','451060458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:20',0,'2014-03-07 21:25:22'),(15915,16564,'0000-00-00','ET','2',1,NULL,'timothy oneal','FI','436510299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-25 19:00:03',0,'2014-03-02 06:03:21'),(2294,2294,'2014-01-01','ET','2',2,1,'John Couch','FI','292423117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:59',0,'2014-03-01 15:10:22'),(3031,3031,'2014-01-01','ET','2',1,NULL,'Brandi Freed','FI','275726180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:03',0,'2014-03-01 15:37:30'),(13129,13485,'2014-01-01','ET','2',1,NULL,'BOBBY DAN VANDERDEER','FI','462022456','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:05',0,'2014-03-02 05:17:40'),(4175,4175,'2014-01-01','ET','2',1,NULL,'Te Youngblood','FI','503117601','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:26',0,'2014-03-10 15:59:47'),(12170,12170,'2014-01-01','ET','2',2,1,'Bennie Hebert','FI','434061287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:06',0,'2014-03-02 05:03:29'),(14398,14849,'2014-01-01','ET','2',1,NULL,'candice schiavi','FI','270686790','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:06',0,'2014-03-01 16:46:19'),(7210,7210,'2014-01-01','ET','2',1,NULL,'Justin Payne','FI','290785901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:56',0,'2014-03-01 15:52:44'),(7192,7192,'2014-01-01','ET','2',1,NULL,'RUTH  NOEMI PRUITT','FI','210481377','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:24',0,'2014-03-02 03:09:49'),(14208,14659,'2014-01-01','ET','2',2,1,'Glynnette Redden','FI','268845515','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:44',0,'2014-03-10 14:03:26'),(21496,22146,'0000-00-00','ET','2',1,NULL,'NORMA JEAN DANIELS','FI','362581904','Dental Care Plus, Inc.','FI','311185262','William H Clark','94','15708465','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:52',0,'2014-03-03 21:36:16'),(15670,16319,'0000-00-00','ET','2',1,NULL,'Dwayne Coleman','FI','436811769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:27',0,'2014-03-02 05:59:43'),(14503,14954,'2014-01-01','ET','2',2,1,'Steve Young','FI','294704814','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:54',0,'2014-03-10 14:03:26'),(13572,13928,'2014-01-01','ET','2',2,1,'ANTWONE JENKINS','FI','273683587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:04',0,'2014-03-10 16:10:34'),(13749,14105,'2014-01-01','ET','2',1,NULL,'JAMES  NEILSEN','FI','287480512','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:13',0,'2014-03-01 16:40:16'),(2632,2632,'2014-01-01','ET','2',1,NULL,'Angela Murtagh','FI','386661609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:01',0,'2014-03-01 21:11:04'),(13338,13694,'2014-01-01','ET','2',1,NULL,'Julie Schatzel','FI','269886186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:27',0,'2014-03-01 16:40:16'),(13279,13635,'2014-01-01','ET','2',1,NULL,'Kim Smith','FI','433021239','Starmount Life Insurance Company','FI','720977315','Suzanne Denise Crick','94','8946819','357','2014-02-01','Sync Success',0,'2014-01-08 18:24:04',0,'2014-03-02 05:24:45'),(523,523,'2014-01-01','ET','2',2,1,'Nhan Thanh Luu','FI','370255656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:07',0,'2014-03-01 15:48:04'),(12570,12570,'2014-01-01','ET','2',1,NULL,'Charles Kitchingham','FI','271749580','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',1,'2014-01-02 04:36:08',0,'2014-03-10 13:59:38'),(16566,17216,'0000-00-00','ET','2',1,NULL,'LAURA SCHEDLER','FI','287447717','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:01:20',0,'2014-03-10 16:24:30'),(10370,10370,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:49:48',0,'2014-03-01 16:05:34'),(14196,14647,'2014-01-01','ET','2',1,NULL,'THUY  t NGUYEN','FI','604539728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:36',0,'2014-03-02 05:38:34'),(3904,3904,'2014-01-01','ET','2',1,NULL,'Frederick Balogh','FI','293522496','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:08',0,'2014-03-10 15:45:56'),(5364,5364,'2014-01-01','ET','2',1,NULL,'jessica starner','FI','293841342','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:20',0,'2014-03-10 15:39:19'),(5889,5889,'2014-01-01','ET','2',1,NULL,'Matthew Boes','FI','294904624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:25',0,'2014-03-01 15:48:04'),(20452,21102,'0000-00-00','ET','2',1,NULL,'Katie Deerhake','FI','289828274','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-26 09:31:08',0,'2014-03-10 14:37:47'),(22107,22757,'0000-00-00','ET','2',2,1,'YVONE SANDERS','FI','165440964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:34',0,'2014-03-06 21:27:26'),(18396,19046,'0000-00-00','ET','2',1,NULL,'Suzanne Harper','FI','435886378','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:57',0,'2014-03-02 06:45:14'),(1502,1502,'2014-01-01','ET','2',1,NULL,'Kathleen J Snodgrass','FI','298545163','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:26',0,'2014-03-10 16:03:49'),(1551,1551,'2014-01-01','ET','2',1,NULL,'Brenda Kummerer','FI','301501299','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:59',0,'2014-03-10 13:52:32'),(4248,4248,'2014-01-01','ET','2',2,1,'William A Frogge','FI','268520250','Summa Insurance Company, Inc.','FI','341809108','Lenda  Sojourner','94','1862271','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:44',0,'2014-03-10 15:59:47'),(13014,13014,'2014-01-01','ET','2',2,1,'TINA PERRY','FI','425499344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:43',0,'2014-03-02 05:17:40'),(20570,21220,'0000-00-00','ET','2',2,1,'Billy  Floyd Ayers','FI','451173296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:30',0,'2014-03-02 07:17:36'),(19140,19790,'0000-00-00','ET','2',1,NULL,'Deborah White','FI','271542748','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:14',0,'2014-03-10 16:31:33'),(18464,19114,'0000-00-00','ET','2',1,NULL,'BRENDA JERNIGAN','FI','465966752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:47',0,'2014-03-02 06:45:14'),(7575,7575,'2014-01-01','ET','2',1,NULL,'Gloria Charlier','FI','296505648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:26',0,'2014-03-01 16:05:34'),(5871,5871,'2014-01-01','ET','2',1,NULL,'Luigi Armogida','FI','282742153','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-26 02:16:58',0,'2014-03-10 15:39:19'),(5331,5331,'2014-01-01','ET','2',1,NULL,'Alison Megan Kluckman','FI','274886218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:12',0,'2014-03-01 15:16:37'),(3905,3905,'2014-01-01','ET','2',2,1,'Romualdo Cipro','FI','298760256','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:10',0,'2014-03-10 15:45:56'),(14725,15176,'2014-01-01','ET','2',1,NULL,'Ellen Green','FI','436299746','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:11',0,'2014-03-02 05:45:37'),(17390,18040,'0000-00-00','ET','2',1,NULL,'DONALD ZIMMERS','FI','289644874','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:35',0,'2014-03-01 17:20:55'),(17958,18608,'0000-00-00','ET','2',2,1,'Jamie Frail','FI','293885648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:09',0,'2014-03-01 17:20:55'),(18084,18734,'0000-00-00','ET','2',1,NULL,'Philip Hollister','FI','462534545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:26',0,'2014-03-02 06:38:05'),(20789,21439,'0000-00-00','ET','2',1,NULL,'Laura Willson','FI','270501918','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-28 06:30:54',0,'2014-03-10 16:38:05'),(18764,19414,'0000-00-00','ET','2',1,NULL,'denise vantilburg','FI','290686516','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:39',0,'2014-03-10 14:31:05'),(13245,13601,'2014-01-01','ET','2',1,NULL,'Nichelle Carter','FI','437154596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:53',0,'2014-03-02 05:17:40'),(12453,12453,'2014-01-01','ET','2',1,NULL,'Cathy Joan Miller','FI','268520178','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:37',0,'2014-03-10 16:10:34'),(17016,17666,'0000-00-00','ET','2',1,NULL,'Lakeisha Williams','FI','436430510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:08',0,'2014-03-02 06:24:38'),(11555,11555,'2014-01-01','ET','2',1,NULL,'bobby fulton','FI','564177311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:20',0,'2014-03-02 04:52:44'),(16642,17292,'0000-00-00','ET','2',1,NULL,'Pam Roberson','FI','435572690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:36',0,'2014-03-02 06:17:30'),(4159,4159,'2014-01-01','ET','2',1,NULL,'Janet Spence','FI','268820327','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:04:58',0,'2014-03-10 15:59:47'),(4093,4093,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:05',0,'2014-03-01 16:00:27'),(3742,3742,'2014-01-01','ET','2',1,NULL,'Rachel Davis','FI','280586270','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 22:08:56',0,'2014-03-10 13:24:34'),(14167,14618,'2014-01-01','ET','2',1,NULL,'ellen sands','FI','273448558','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:19',0,'2014-03-10 16:17:47'),(15097,15548,'0000-00-00','ET','2',1,NULL,'micheal  franklin','FI','251277668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:46',0,'2014-03-02 05:52:31'),(17670,18320,'0000-00-00','ET','2',2,1,'STEPHEN  A SELF','FI','293486538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:47',0,'2014-03-01 17:20:55'),(17478,18128,'0000-00-00','ET','2',1,NULL,'Tony Shurelds','FI','277561975','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:36',0,'2014-03-10 14:24:38'),(1478,1478,'2014-01-01','ET','2',2,1,'John Unger','FI','312607403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:43',0,'2014-03-01 16:23:43'),(16799,17449,'0000-00-00','ET','2',1,NULL,'Isaac Gilkerson','FI','291625319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:40',0,'2014-03-01 17:00:58'),(15148,15599,'0000-00-00','ET','2',1,NULL,'Tony Reynolds','FI','508809014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:25',0,'2014-03-02 05:52:31'),(15073,15524,'2014-01-01','ET','2',1,NULL,'RACHEL E TOPP','FI','296722376','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:42',0,'2014-03-10 14:10:12'),(5463,5463,'2014-01-01','ET','2',1,NULL,'Denise deBrueys','FI','349527294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:15',0,'2014-03-02 04:45:37'),(10903,10903,'2014-01-01','ET','2',1,NULL,'Glenn Elzy','FI','433774584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:44',0,'2014-03-02 04:24:47'),(21416,22066,'0000-00-00','ET','2',2,1,'anna Bradford','FI','435533621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:21',0,'2014-03-03 21:25:18'),(19119,19769,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:58',0,'2014-03-01 17:34:07'),(13539,13895,'2014-01-01','ET','2',1,NULL,'Gloria Morman','FI','274489945','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:42',0,'2014-03-01 16:40:16'),(4262,4262,'2014-01-01','ET','2',1,NULL,'David Johnson','FI','437237568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:11',0,'2014-03-02 03:09:49'),(12521,12521,'2014-01-01','ET','2',1,NULL,'Dessie Hart','FI','426922655','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:06',0,'2014-03-02 05:03:29'),(1185,1185,'2014-01-01','ET','2',1,NULL,'june verdon','FI','433984839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:18',0,'2014-03-02 04:38:08'),(18379,19029,'0000-00-00','ET','2',1,NULL,'Erica Todesco','FI','439113338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:46',0,'2014-03-02 06:45:14'),(17743,18393,'0000-00-00','ET','2',1,NULL,'Nicolas Urton','94','0000183552','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:31',0,'2014-03-10 14:24:38'),(17518,18168,'0000-00-00','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-22','Sync Success',0,'2014-02-07 19:00:13',0,'2014-03-02 06:31:45'),(15940,16589,'0000-00-00','ET','2',1,NULL,'Jamie Diehl','FI','283809965','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:16',0,'2014-03-01 16:56:22'),(14917,15368,'2014-01-01','ET','2',1,NULL,'KATHERINE MCINTYRE','FI','199369953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:31',0,'2014-03-01 16:50:53'),(20293,20943,'0000-00-00','ET','2',1,NULL,'VERA DAVIS','FI','464060752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:37',0,'2014-03-02 07:10:28'),(18346,18996,'0000-00-00','ET','2',1,NULL,'JAMES MARSH CHAFFIN','FI','264694729','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:23',0,'2014-03-02 06:45:14'),(11912,11912,'2014-01-01','ET','2',1,NULL,'Jessy Zbeidy','FI','276112542','Dental Care Plus, Inc.','FI','311185262','Mike  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2013-12-30 00:01:24',0,'2014-03-01 16:30:17'),(1247,1247,'2014-01-01','ET','2',1,NULL,'Linda Lynch','FI','272643877','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:06',0,'2014-03-01 16:15:39'),(11582,11582,'2014-01-01','ET','2',1,NULL,'Ryan Church','FI','460157762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:11',0,'2014-03-02 04:52:44'),(15297,15748,'0000-00-00','ET','2',1,NULL,'Wendy Elayna Reskof','FI','205524648','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:16',0,'2014-03-10 16:17:47'),(13952,14308,'2014-01-01','ET','2',1,NULL,'justin bowers','FI','273927860','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:35',0,'2014-03-10 14:03:26'),(3500,3500,'2014-01-01','ET','2',2,1,'KYLE MARIE MEIDT','FI','283463904','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:11',0,'2014-03-01 15:37:30'),(20204,20854,'0000-00-00','ET','2',2,1,'Mercie Ratcliff','FI','460618375','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:33',0,'2014-03-02 07:10:28'),(18191,18841,'0000-00-00','ET','2',2,1,'Diane Garcia','FI','277567693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:45',0,'2014-03-01 17:26:36'),(280,280,'2014-01-01','ET','2',2,1,'stefan s roberts','FI','595063363','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:59',0,'2014-03-01 15:05:09'),(14508,14959,'2014-01-01','ET','2',1,NULL,'Debra Roy','FI','301584204','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:56',0,'2014-03-10 14:03:26'),(1801,1801,'2014-01-01','ET','2',1,NULL,'DIANA HILLIARD','FI','279629882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:40',0,'2014-03-10 13:20:27'),(5084,5084,'2014-01-01','ET','2',1,NULL,'Brittany Harmon','FI','300946809','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:41',0,'2014-03-10 13:20:27'),(19841,20491,'0000-00-00','ET','2',1,NULL,'Saif Ali','94','0000845949','Starmount Life Insurance Company','FI','720977315','Munira H Dhodiya','94','7987627','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:57',0,'2014-03-02 07:03:25'),(20261,20911,'0000-00-00','ET','2',1,NULL,'laura colson','94','0000345641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:10',0,'2014-03-01 17:47:19'),(176,176,'2014-01-01','ET','2',1,NULL,'Michael Walker','FI','006725968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:28',0,'2014-03-01 22:10:55'),(18146,18796,'0000-00-00','ET','2',3,2,'Bernardita Javier','FI','598382435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:12',0,'2014-03-02 06:38:05'),(17198,17848,'0000-00-00','ET','2',1,NULL,'Joe Chambers','FI','457573938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:04',0,'2014-03-02 06:24:38'),(16596,17246,'0000-00-00','ET','2',1,NULL,'Wanda Ritt','FI','271688073','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:40',0,'2014-03-10 14:20:26'),(6117,6117,'2014-01-01','ET','2',1,NULL,'Amanda Banchek','FI','277805738','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:48',0,'2014-03-01 16:00:27'),(13029,13385,'2014-01-01','ET','2',1,NULL,'Alem Bahta','FI','273130447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:00:20',0,'2014-03-01 16:35:14'),(13371,13727,'2014-01-01','ET','2',2,1,'Sarah Brassfield','FI','522434337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:41',0,'2014-03-02 05:24:45'),(19745,20395,'0000-00-00','ET','2',1,NULL,'JOSE DE SANTIAGO','FI','635807448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:04',0,'2014-03-02 07:03:25'),(20614,21264,'0000-00-00','ET','2',1,NULL,'Tyrone Davis','FI','425272976','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:58',0,'2014-03-02 07:17:36'),(21975,22625,'0000-00-00','ET','2',1,NULL,'BOMAN COLLINS','FI','587608862','Starmount Life Insurance Company','FI','720977315','REGINAL   BROWN','94','9358695','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:36',0,'2014-03-05 22:27:33'),(22725,23375,'0000-00-00','ET','2',1,NULL,'carole williams','FI','298506506','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:17',0,'2014-03-10 14:50:59'),(22804,23454,'0000-00-00','ET','2',2,1,'Richard McKee','FI','291429407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:54',0,'2014-03-10 16:44:18'),(10582,10582,'2014-01-01','ET','2',1,NULL,'michelle gomez','FI','454693986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:56:38',0,'2014-03-02 04:24:47'),(11275,11275,'2014-01-01','ET','2',1,NULL,'Jehad Kandous','FI','157703518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:02:46',0,'2014-03-02 04:52:44'),(992,992,'2014-01-01','ET','2',1,NULL,'Karen Brophy','FI','281669100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:59',0,'2014-03-01 15:21:15'),(2151,2151,'2014-01-01','ET','2',1,NULL,'VALERIE DANIEL','FI','244083284','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:29',0,'2014-03-01 21:11:04'),(1339,1339,'2014-01-01','ET','2',1,NULL,'OLIVIA VALDEZ CASTILLO','FI','456354944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:02',0,'2014-03-02 04:38:08'),(1623,1623,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:47',0,'2014-03-01 20:10:57'),(20802,21452,'0000-00-00','ET','2',1,NULL,'MARY JANE CRUZ','FI','219700278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:00',0,'2014-03-02 07:17:36'),(21984,22634,'0000-00-00','ET','2',1,NULL,'LISA FLOWERS','FI','570596949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:42',0,'2014-03-05 22:27:33'),(22377,23027,'0000-00-00','ET','2',1,NULL,'Anthony Cunningham','FI','294869900','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:24',0,'2014-03-10 14:50:59'),(18030,18680,'0000-00-00','ET','2',1,NULL,'DYLAN ESTEP','FI','281116545','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:59',0,'2014-03-10 14:24:38'),(16467,17117,'0000-00-00','ET','2',1,NULL,'Mary Cegelski','FI','299469711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:16',0,'2014-03-01 17:00:58'),(12033,12033,'2014-01-01','ET','2',1,NULL,'SHAYLYNN T DAVIS','FI','439811730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:21',0,'2014-03-02 05:03:29'),(1530,1530,'2014-01-01','ET','2',1,NULL,'john weletyk','FI','296584792','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:21',0,'2014-03-10 16:03:49'),(1787,1787,'2014-01-01','ET','2',1,NULL,'darcy l kutzli','FI','269548438','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:11',0,'2014-03-10 13:20:27'),(10921,10921,'2014-01-01','ET','2',1,NULL,'Jeffrey Prinz','FI','294561202','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:21',0,'2014-03-10 16:03:49'),(14134,14585,'2014-01-01','ET','2',1,NULL,'Justin Kennedy','FI','439698441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:57',0,'2014-03-02 05:31:31'),(21961,22611,'0000-00-00','ET','2',1,NULL,'DONALD SHEARRY','FI','570751391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:26',0,'2014-03-05 22:27:33'),(22563,23213,'0000-00-00','ET','2',1,NULL,'Linda Huston','FI','288509174','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:54',0,'2014-03-10 16:44:18'),(350,350,'2014-01-01','ET','2',1,NULL,'WINIFRED WEAVER','FI','296867867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:48',0,'2014-03-01 15:21:15'),(19089,19739,'0000-00-00','ET','2',1,NULL,'Charles Lenix','FI','299828692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:35',0,'2014-03-01 17:34:07'),(16356,17006,'0000-00-00','ET','2',1,NULL,'samuel david shaferly','94','0000718949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:57',0,'2014-03-01 17:00:58'),(15800,16449,'0000-00-00','ET','2',1,NULL,'Sandra Cruz','FI','453978610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:12',0,'2014-03-02 06:03:21'),(5916,5916,'2014-01-01','ET','2',1,NULL,'Teresa Scheetz','FI','277568034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 02:31:18',NULL,NULL),(11277,11277,'2014-01-01','ET','2',1,NULL,'Sean Murphy','FI','436596443','Starmount Life Insurance Company','FI','720977315','THOMAS  KLOTZ','94','2766547','357','2014-01-01','Sync Success',0,'2013-12-27 02:02:48',0,'2014-03-02 04:52:44'),(3597,3597,'2014-01-01','ET','2',1,NULL,'Victoriano Espinoza','FI','450948034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:15',0,'2014-03-02 01:10:33'),(20982,21632,'0000-00-00','ET','2',1,NULL,'Jesse Thompson','FI','212889347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:30:27',0,'2014-03-02 07:17:36'),(18408,19058,'0000-00-00','ET','2',1,NULL,'Raymonda King','FI','271584819','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:07',0,'2014-03-01 17:26:36'),(13391,13747,'2014-01-01','ET','2',5,4,'Carey Ferrari','FI','276888153','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:50',0,'2014-03-10 16:10:34'),(1436,1436,'2014-01-01','ET','2',1,NULL,'Shannon Myers','FI','286024519','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:13',0,'2014-03-01 16:15:39'),(12525,12525,'2014-01-01','ET','2',1,NULL,'BARBARA SHANK','FI','285802851','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:14',0,'2014-03-10 13:59:38'),(5174,5174,'2014-01-01','ET','2',1,NULL,'Michael Schneder','FI','291861206','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:32',0,'2014-03-10 13:20:27'),(21645,22295,'0000-00-00','ET','2',2,1,'DAVID WHITESIDE','FI','282947143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:55',0,'2014-03-04 21:36:30'),(5708,5708,'2014-01-01','ET','2',1,NULL,'Lathel Rainey','FI','298506306','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:43',0,'2014-03-01 15:37:30'),(7360,7360,'2014-01-01','ET','2',1,NULL,'Michelle Comello','FI','281721408','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:50',0,'2014-03-10 13:03:33'),(2277,2277,'2014-01-01','ET','2',1,NULL,'Michael Vomacka','FI','453753599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:23',0,'2014-03-01 21:11:04'),(2543,2543,'2014-01-01','ET','2',1,NULL,'Terrince Witherspoon','FI','284729880','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:19',0,'2014-03-01 15:10:22'),(3177,3177,'2014-01-01','ET','2',4,3,'Sheldon King','FI','280885050','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:43',0,'2014-03-10 13:24:34'),(21389,22039,'0000-00-00','ET','2',1,NULL,'ARTHUR JENKINS','FI','296646026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:04',0,'2014-03-03 21:36:16'),(480,480,'2014-01-01','ET','2',1,NULL,'Aundre Howard','FI','276805489','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:51:01',0,'2014-03-10 13:10:24'),(16941,17591,'0000-00-00','ET','2',1,NULL,'Steven Knape','FI','503904461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:53',0,'2014-03-10 14:20:26'),(587,587,'2014-01-01','ET','2',1,NULL,'Jonathan Lege','FI','436615519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:03:10',0,'2014-03-02 02:10:49'),(1790,1790,'2014-01-01','ET','2',1,NULL,'DEBORAH GAERTNER','FI','281528470','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:19:18',0,'2014-03-10 13:20:27'),(6004,6004,'2014-01-01','ET','2',1,NULL,'Lisa Ann Rock Higgins','FI','302582020','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:05',0,'2014-03-01 15:10:22'),(12095,12095,'2014-01-01','ET','2',1,NULL,'Kristiana Reeves','FI','278903743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:33',0,'2014-03-01 16:30:17'),(11675,11675,'2014-01-01','ET','2',1,NULL,'CATHY STIFT','FI','295520770','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:37:06',0,'2014-03-10 13:52:32'),(20380,21030,'0000-00-00','ET','2',1,NULL,'SHEILA CARTER','FI','587160289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:09',0,'2014-03-02 07:10:28'),(20672,21322,'0000-00-00','ET','2',1,NULL,'Elizabeth Eichelman','FI','347748184','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:42',0,'2014-03-10 14:37:47'),(20032,20682,'0000-00-00','ET','2',1,NULL,'BARBARA SMITH','FI','425213174','Starmount Life Insurance Company','FI','720977315','DEQUIT M WILLIAMS-CARTER','94','9450731','348','2014-04-01','Sync Success',0,'2014-02-21 22:01:14',0,'2014-03-02 07:03:25'),(11609,11609,'2014-01-01','ET','2',1,NULL,'EONNETTE HARRIS','FI','428215957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:59',0,'2014-03-02 04:59:36'),(13747,14103,'2014-01-01','ET','2',1,NULL,'Amy Elizabeth Wallace','FI','284760288','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:12',0,'2014-03-01 16:40:16'),(2104,2104,'2014-01-01','ET','2',1,NULL,'Teresa Ward','FI','283746050','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:38:12',0,'2014-03-10 13:20:27'),(6108,6108,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:34',0,'2014-03-01 16:00:27'),(5923,5923,'2014-01-01','ET','2',1,NULL,'Justin Mitchell','FI','378062314','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:30',0,'2014-03-01 15:48:04'),(20567,21217,'0000-00-00','ET','2',1,NULL,'Alice Sparks','FI','461922207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 21:01:29',0,'2014-03-02 07:17:36'),(14181,14632,'2014-01-01','ET','2',1,NULL,'Kenneth Mennell','FI','273605744','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:26',0,'2014-03-10 14:03:26'),(739,739,'2014-01-01','ET','2',1,NULL,'Ruth Louderback','FI','298505058','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:01',0,'2014-03-10 13:24:34'),(13283,13639,'2014-01-01','ET','2',1,NULL,'David Tutson','FI','437235554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:06',0,'2014-03-02 05:24:45'),(15518,15969,'0000-00-00','ET','2',1,NULL,'Dora  Dominguez','FI','462472411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:58',0,'2014-03-02 05:59:43'),(14833,15284,'2014-01-01','ET','2',4,3,'DANTE CAMPOLONGO','FI','282644839','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:21',0,'2014-03-10 14:10:12'),(7322,7322,'2014-01-01','ET','2',2,1,'Mary Ilhardt','FI','302722846','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:22',0,'2014-03-10 13:32:15'),(2417,2417,'2014-01-01','ET','2',1,NULL,'HARRY DAVIS','FI','283483838','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:48',0,'2014-03-10 15:45:56'),(3256,3256,'2014-01-01','ET','2',1,NULL,'timothy aylward','FI','275664997','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:01',0,'2014-03-10 15:52:36'),(4439,4439,'2014-01-01','ET','2',1,NULL,'Cheylon Woods','FI','621463379','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:02',0,'2014-03-01 21:11:04'),(5636,5636,'2014-01-01','ET','2',1,NULL,'LaShani Menyweather','FI','439713190','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:53',0,'2014-03-02 04:45:37'),(20463,21113,'0000-00-00','ET','2',1,NULL,'Thilagarajan Narayanan','FI','651143403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:17',0,'2014-03-01 18:08:07'),(21761,22411,'0000-00-00','ET','2',1,NULL,'Cindy Horsey','FI','276664223','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:30',0,'2014-03-10 14:45:25'),(18813,19463,'0000-00-00','ET','2',1,NULL,'Anise Algahmee','FI','277748537','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:19',0,'2014-03-10 14:31:05'),(18340,18990,'0000-00-00','ET','2',1,NULL,'Lawren mccandless','FI','167602850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:20',0,'2014-03-01 17:26:36'),(1649,1649,'2014-01-01','ET','2',1,NULL,'Tasha Malloy','FI','168565852','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:27',0,'2014-03-01 20:10:57'),(2519,2519,'2014-01-01','ET','2',1,0,'Cody Shook','FI','428619964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:36',0,'2014-03-01 19:11:03'),(5797,5797,'2014-01-01','ET','2',1,NULL,'alicia melissa zamora','FI','643056357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:03:26',0,'2014-03-02 01:10:33'),(7693,7693,'2014-01-01','ET','2',1,NULL,'cody powell','FI','295926787','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:13',0,'2014-03-01 15:10:22'),(21233,21883,'0000-00-00','ET','2',1,NULL,'William Sawdon','FI','369049663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:18',0,'2014-03-02 07:23:39'),(22915,23565,'0000-00-00','ET','2',1,NULL,'stephen michael phillips','FI','437659425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:00:52',0,'2014-03-10 21:27:11'),(27,27,'2014-01-01','ET','2',1,NULL,'River Manda Lay','FI','297139371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:50',0,'2014-03-01 15:26:40'),(17737,18387,'0000-00-00','ET','2',1,NULL,'Stephen Sawyer','FI','439797136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:26',0,'2014-03-02 06:31:45'),(3803,3803,'2014-01-01','ET','2',1,NULL,'Alaysha Robinson','FI','438652986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:26',0,'2014-03-01 23:10:52'),(3360,3360,'2014-01-01','ET','2',1,NULL,'Tonya Jolly','FI','458800414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:27',0,'2014-03-02 02:10:49'),(10855,10855,'2014-01-01','ET','2',1,NULL,'Gina Gail Huffman','FI','285743447','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:40',0,'2014-03-10 13:45:57'),(1651,1651,'2014-01-01','ET','2',1,NULL,'Susan Gremillion','FI','565478399','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:31',0,'2014-03-01 20:10:57'),(20347,20997,'0000-00-00','ET','2',1,NULL,'riley tucker','94','0000172464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:36',0,'2014-03-01 17:47:19'),(13085,13441,'2014-01-01','ET','2',2,1,'Horace Shephard','FI','196587708','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:22',0,'2014-03-01 16:35:14'),(15823,16472,'0000-00-00','ET','2',1,NULL,'KEITH L BELLAMORE','FI','436942827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:25',0,'2014-03-02 06:03:21'),(13203,13559,'2014-01-01','ET','2',2,1,'michael mandato','FI','295824315','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:55',0,'2014-03-10 13:59:38'),(12946,12946,'2014-01-01','ET','2',1,NULL,'MONIQUE BERRY','FI','437652460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:12',0,'2014-03-02 05:17:40'),(1819,1819,'2014-01-01','ET','2',2,1,'Tom E Wallace','FI','301463989','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:13',0,'2014-03-10 15:45:56'),(12699,12699,'2014-01-01','ET','2',1,NULL,'Mary Manning','FI','587647267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:44',0,'2014-03-02 05:10:52'),(2296,2296,'2014-01-01','ET','2',1,NULL,'joseph conn','FI','273765901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:03',0,'2014-03-01 15:10:22'),(17097,17747,'0000-00-00','ET','2',1,NULL,'DORIS LONG','FI','283707604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:59',0,'2014-03-01 17:00:58'),(10379,10379,'2014-01-01','ET','2',1,NULL,'Dorothy Yez','FI','198382626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:03',0,'2014-03-01 16:10:36'),(7565,7565,'2014-01-01','ET','2',1,NULL,'Theresa Dudley','FI','286649623','Dental Care Plus, Inc.','FI','311185262','John Daniel Scheller','94','16414709','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:09',0,'2014-03-01 16:05:34'),(3322,3322,'2014-01-01','ET','2',1,NULL,'William Wilt','FI','282426791','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:16',0,'2014-03-10 13:24:34'),(1453,1453,'2014-01-01','ET','2',1,NULL,'Linda Stampley','FI','298504891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:48',0,'2014-03-01 16:15:39'),(6027,6027,'2014-01-01','ET','2',2,1,'Randy Stephens','FI','270687166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:47',0,'2014-03-01 15:10:22'),(11313,11313,'2014-01-01','ET','2',1,NULL,'Angla Forester','FI','443867895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:55',0,'2014-03-02 04:52:44'),(19900,20550,'0000-00-00','ET','2',1,NULL,'Koviljka  Vegara','FI','731098091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-21 21:30:05',0,'2014-03-01 17:47:19'),(21941,22591,'0000-00-00','ET','2',1,NULL,'Tamakica Dorsey','FI','435831997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:12',0,'2014-03-05 22:27:33'),(649,649,'2014-01-01','ET','2',1,NULL,'Gloria Vasquez','FI','458044463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:12',0,'2014-03-02 02:10:49'),(1000,1000,'2014-01-01','ET','2',1,NULL,'william hopwood','FI','287425325','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:17',0,'2014-03-10 13:10:24'),(1324,1324,'2014-01-01','ET','2',1,NULL,'Joshua Cowan','FI','643059703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:35',0,'2014-03-02 04:38:08'),(1406,1406,'2014-01-01','ET','2',1,NULL,'Shalonda Bouie','FI','434710132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:15',0,'2014-03-02 04:38:08'),(17695,18345,'0000-00-00','ET','2',1,NULL,'Monnie Pilgrim','FI','450882470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:30:04',0,'2014-03-02 06:31:45'),(2701,2701,'2014-01-01','ET','2',1,NULL,'Holly Nicole Green-Parks','FI','464856498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:17:15',0,'2014-03-02 04:15:49'),(12468,12468,'2014-01-01','ET','2',1,NULL,'Ashish Pushkaran','FI','275065032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:32:11',0,'2014-03-01 16:30:17'),(4698,4698,'2014-01-01','ET','2',1,NULL,'Rebecca Duplantis','FI','433728367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:36',0,'2014-03-02 04:31:46'),(13941,14297,'2014-01-01','ET','2',2,1,'Teresa Hesson','FI','296846231','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:26',0,'2014-03-10 16:10:34'),(14245,14696,'2014-01-01','ET','2',1,NULL,'DILLARD HAMILTON','FI','587960042','Starmount Life Insurance Company','FI','720977315','PERRY  DUCKWORTH','94','6393415','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:00',0,'2014-03-02 05:38:34'),(17652,18302,'0000-00-00','ET','2',1,NULL,'Nancy Jaber','FI','577705996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:36',0,'2014-03-02 06:31:45'),(15951,16600,'0000-00-00','ET','2',1,NULL,'Gina Buccino','FI','302480988','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-26 19:00:03',0,'2014-03-01 16:56:22'),(17333,17983,'0000-00-00','ET','2',2,1,'sammy abdul hadi','FI','253479817','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:12',0,'2014-03-10 14:24:38'),(21335,21985,'0000-00-00','ET','2',4,3,'Stacey Marie Hamric','FI','270709081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:15',0,'2014-03-03 01:35:37'),(22953,23603,'0000-00-00','ET','2',1,NULL,'Brandon McElhaney','FI','285949154','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:19',0,'2014-03-10 21:07:22'),(16320,16970,'0000-00-00','ET','2',1,NULL,'Samuel Beya','94','0000954326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:36',0,'2014-03-01 17:00:58'),(16298,16948,'0000-00-00','ET','2',1,NULL,'barbara anderson','FI','464984029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:22',0,'2014-03-02 06:10:30'),(3407,3407,'2014-01-01','ET','2',1,NULL,'BILL FIFE','FI','290804787','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:54',0,'2014-03-10 13:32:15'),(19391,20041,'0000-00-00','ET','2',2,1,'SUSAN SNYDER','FI','278528830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:01',0,'2014-03-01 17:34:07'),(19555,20205,'0000-00-00','ET','2',1,NULL,'DONNA WALKER','FI','435256618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:19:15',0,'2014-03-02 06:59:07'),(16374,17024,'0000-00-00','ET','2',2,1,'Toan Thanh Pham','FI','627809302','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:09',0,'2014-03-02 06:10:30'),(12048,12048,'2014-01-01','ET','2',2,1,'SUSAN HOEFER','FI','462809419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:55',0,'2014-03-02 04:59:36'),(15008,15459,'2014-01-01','ET','2',1,NULL,'george hasrouni','FI','296668306','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:13',0,'2014-03-10 16:17:47'),(6463,6463,'2014-01-01','ET','2',2,1,'Rodney McKinley','FI','291762468','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:33',0,'2014-03-10 13:03:33'),(19814,20464,'0000-00-00','ET','2',1,NULL,'ROSA MARTINEZ','FI','457459418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:34',0,'2014-03-02 07:03:25'),(11980,11980,'2014-01-01','ET','2',1,NULL,'Martha M Gomez','FI','450533543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:21',0,'2014-03-02 05:03:29'),(1152,1152,'2014-01-01','ET','2',1,NULL,'Dina Garcia','FI','591879891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:15',0,'2014-03-02 04:38:08'),(5642,5642,'2014-01-01','ET','2',1,NULL,'Alice Martin','FI','492624888','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:04',0,'2014-03-02 04:45:37'),(2545,2545,'2014-01-01','ET','2',1,NULL,'STEVEN JOSEPH BECKETT','FI','299562298','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:22',0,'2014-03-01 15:10:22'),(17987,18637,'0000-00-00','ET','2',1,NULL,'Jesse Carr','FI','281907592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:30',0,'2014-03-10 16:31:33'),(17544,18194,'0000-00-00','ET','2',1,NULL,'hieu nguyen','FI','293942409','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:30',0,'2014-03-10 16:24:30'),(16445,17095,'0000-00-00','ET','2',6,5,'Sameer Shannawi','FI','603581086','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:03',0,'2014-03-01 17:00:58'),(16846,17496,'0000-00-00','ET','2',1,NULL,'Janet Solari','FI','333527569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-02 19:00:22',0,'2014-03-01 17:00:58'),(17312,17962,'0000-00-00','ET','2',1,NULL,'alicia battie','FI','433751220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:01',0,'2014-03-02 06:24:38'),(19643,20293,'0000-00-00','ET','2',2,1,'Melanie Dawn Lovingshimer','FI','289724784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:41:31',0,'2014-03-01 17:47:19'),(19802,20452,'0000-00-00','ET','2',1,NULL,'Jackie Hamilton','FI','457041965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:25',0,'2014-03-02 06:59:07'),(20005,20655,'0000-00-00','ET','2',1,NULL,'Lincoln Tate','FI','426614224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:56',0,'2014-03-02 07:03:25'),(19377,20027,'0000-00-00','ET','2',1,NULL,'Frank Civitarese','FI','289787703','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:51',0,'2014-03-01 17:34:07'),(11246,11246,'2014-01-01','ET','2',2,1,'Elizabeth  Ann Mathews','FI','269541175','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:51',0,'2014-03-01 16:23:43'),(1484,1484,'2014-01-01','ET','2',1,NULL,'David M Miller','FI','296424640','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:54',0,'2014-03-10 16:03:49'),(1592,1592,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:01',0,'2014-03-01 20:10:57'),(10503,10503,'2014-01-01','ET','2',1,NULL,'Jeremy Burne','FI','291889179','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:58',0,'2014-03-01 16:15:39'),(17188,17838,'0000-00-00','ET','2',1,NULL,'Margaret Schuster','FI','268523561','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-04 21:30:03',0,'2014-03-10 16:24:30'),(16226,16875,'0000-00-00','ET','2',1,NULL,'Kevin Black','FI','467858499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:00:57',0,'2014-03-02 06:10:30'),(13631,13987,'2014-01-01','ET','2',1,NULL,'LATASHA COFFEE','FI','434610685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:48',0,'2014-03-02 05:31:31'),(13565,13921,'2014-01-01','ET','2',1,NULL,'Tamika Johnson','FI','428591190','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:58',0,'2014-03-02 05:24:45'),(3683,3683,'2014-01-01','ET','2',2,1,'LATONYA TORNS','FI','425657554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:54',0,'2014-03-02 01:10:33'),(18067,18717,'0000-00-00','ET','2',1,NULL,'CECILIA TATY','FI','628921632','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:13',0,'2014-03-02 06:38:05'),(13799,14155,'2014-01-01','ET','2',2,1,'BOBBIE G KEAN','FI','270522832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:47',0,'2014-03-10 13:59:38'),(10594,10594,'2014-01-01','ET','2',2,1,'William Gutierrez','FI','467997185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:57',0,'2014-03-02 04:24:47'),(12159,12159,'2014-01-01','ET','2',1,NULL,'lesia  allen','FI','278667518','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:45',0,'2014-03-10 13:52:32'),(12075,12075,'2014-01-01','ET','2',1,NULL,'James Sivec','FI','269844934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:51',0,'2014-03-01 16:30:17'),(5398,5398,'2014-01-01','ET','2',2,1,'Kenyon Eugene Andrews','FI','628227718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:07',0,'2014-03-01 20:10:57'),(21306,21956,'0000-00-00','ET','2',1,NULL,'LIFEM HE','FI','282947122','HealthSpan','FI','311431434','BEIBEI   ALLEN','94','16509029','357','2014-03-16','Sync Success',0,'2014-03-01 21:01:10',0,'2014-03-10 14:45:25'),(22070,22720,'0000-00-00','ET','2',1,NULL,'Sonja Cropper','FI','298562071','HealthSpan','FI','311431434','Tim  McKeown','94','1640913','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:43',0,'2014-03-10 14:45:25'),(17321,17971,'0000-00-00','ET','2',1,NULL,'Vinetta Vault','FI','438883868','Starmount Life Insurance Company','FI','720977315','ROANITA  JENKINS','94','7138487','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:06',0,'2014-03-02 06:24:38'),(15580,16031,'0000-00-00','ET','2',1,NULL,'Adrianne Booker','FI','587492644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:27',0,'2014-03-02 05:59:43'),(444,444,'2014-01-01','ET','2',1,NULL,'taylor edwards','FI','295925637','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:47',0,'2014-03-10 15:39:19'),(16559,17209,'0000-00-00','ET','2',2,1,'TERRENCE GRADY','FI','297528728','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:15',0,'2014-03-10 16:24:30'),(3154,3154,'2014-01-01','ET','2',1,NULL,'NORMAN JOHN MERCER','FI','272444946','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:54',0,'2014-03-10 13:24:34'),(7294,7294,'2014-01-01','ET','2',1,NULL,'amber heaps','FI','286947603','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:31',0,'2014-03-10 13:32:15'),(5118,5118,'2014-01-01','ET','2',2,1,'GARRY RICHARDSON','FI','293524153','Summa Insurance Company, Inc.','FI','341809108','GREGORY JAMES CAUSMAN','94','519763','348','2014-01-01','Sync Success',0,'2013-12-26 00:49:49',0,'2014-03-10 15:45:56'),(6353,6353,'2014-01-01','ET','2',1,NULL,'Elizabeth B Scruggs','FI','428552688','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:00',0,'2014-03-02 04:10:25'),(12227,12227,'2014-01-01','ET','2',1,NULL,'Gamaliel Anderson','FI','437674863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:32',0,'2014-03-02 05:10:52'),(13823,14179,'2014-01-01','ET','2',1,NULL,'Michael Birchfield','FI','453356782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:27',0,'2014-03-02 05:31:31'),(19063,19713,'0000-00-00','ET','2',1,NULL,'Jacqueline Fox','FI','433651519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:18',0,'2014-03-02 06:52:12'),(22317,22967,'0000-00-00','ET','2',1,NULL,'CRISTIANA REYES','FI','082311308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:09',0,'2014-03-06 22:25:29'),(16007,16656,'0000-00-00','ET','2',1,NULL,'SHERTORA COOKS','FI','643128094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:15',0,'2014-03-02 06:03:21'),(2355,2355,'2014-01-01','ET','2',1,NULL,'winston staton','FI','296545640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:48',0,'2014-03-01 15:26:40'),(10376,10376,'2014-01-01','ET','2',1,NULL,'kathleen McGinty','FI','272842411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:58',0,'2014-03-01 16:10:36'),(11075,11075,'2014-01-01','ET','2',3,2,'ELLEN D RIEHM','FI','392488822','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:16',0,'2014-03-10 16:03:49'),(20331,20981,'0000-00-00','ET','2',1,NULL,'SANDRA CHESHIRE','FI','292587670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:20',0,'2014-03-01 17:47:19'),(20587,21237,'0000-00-00','ET','2',1,NULL,'JANET JW SMITH','FI','412023145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-26 21:01:39',0,'2014-03-01 18:08:07'),(18096,18746,'0000-00-00','ET','2',1,NULL,'Steven Hamblin','FI','464931204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:35',0,'2014-03-02 06:38:05'),(14004,14360,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:34',0,'2014-03-01 16:40:16'),(2553,2553,'2014-01-01','ET','2',1,NULL,'lisa murphy','FI','274782967','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:39',0,'2014-03-10 13:03:33'),(4378,4378,'2014-01-01','ET','2',2,1,'Laura Bredenfoerder','FI','287548996','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:16',0,'2014-03-01 15:16:37'),(19572,20222,'0000-00-00','ET','2',1,NULL,'Sharon Graham','FI','290522434','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:24:07',0,'2014-03-10 14:37:47'),(20478,21128,'0000-00-00','ET','2',4,3,'Elizabeth Weilnau','FI','400044535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:29',0,'2014-03-01 18:08:07'),(20492,21142,'0000-00-00','ET','2',2,1,'Kiana Koning','FI','193623266','Summa Insurance Company, Inc.','FI','341809108','Tara  Krol','94','3400836','348','2014-04-01','Sync Success',0,'2014-02-26 21:00:39',0,'2014-03-10 16:38:05'),(21551,22201,'0000-00-00','ET','2',1,NULL,'MONTREAL WOODS','FI','426396596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:33',0,'2014-03-03 22:26:43'),(18107,18757,'0000-00-00','ET','2',1,NULL,'Hilda Castillo','FI','635409661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:43',0,'2014-03-02 06:38:05'),(15719,16368,'0000-00-00','ET','2',1,NULL,'JAMES HARDAWAY','FI','327509006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:00',0,'2014-03-02 05:59:43'),(4400,4400,'2014-01-01','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:56',0,'2014-03-10 15:39:19'),(1528,1528,'2014-01-01','ET','2',1,NULL,'Alonna Adams','FI','298545476','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:19',0,'2014-03-10 16:03:49'),(15080,15531,'0000-00-00','ET','2',1,NULL,'Julie McKenzie','FI','404024470','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:35',0,'2014-03-01 16:50:53'),(4366,4366,'2014-01-01','ET','2',2,1,'Brian Dunn','FI','286808535','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:17',0,'2014-03-10 13:32:15'),(3046,3046,'2014-01-01','ET','2',1,NULL,'Kathleen Liotta','FI','273483631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:29',0,'2014-03-01 15:37:30'),(13424,13780,'2014-01-01','ET','2',1,NULL,'Donald Hill','FI','291600768','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:06',0,'2014-03-10 13:59:38'),(22752,23402,'0000-00-00','ET','2',1,NULL,'rotisha Murphy','FI','451717988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:13',0,'2014-03-09 21:26:00'),(15995,16644,'0000-00-00','ET','2',1,NULL,'OLIVIA VALDEZ CASTILLO','FI','456354944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:07',0,'2014-03-02 06:03:21'),(18411,19061,'0000-00-00','ET','2',3,2,'PATRICK PENNINGTON','FI','302602388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:09',0,'2014-03-01 17:26:36'),(1669,1669,'2014-01-01','ET','2',1,NULL,'Janice Jernigan','FI','435430034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:31',0,'2014-03-02 00:10:48'),(15416,15867,'0000-00-00','ET','2',1,NULL,'LEWIS GOTTLIEB','FI','453213519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:19',0,'2014-03-02 05:59:43'),(2760,2760,'2014-01-01','ET','2',1,NULL,'DOROTHY LOGAN','FI','437902864','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:03',0,'2014-03-02 04:15:49'),(10662,10662,'2014-01-01','ET','2',2,1,'Stephanie Morales','FI','453675518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:11',0,'2014-03-02 04:31:46'),(15358,15809,'0000-00-00','ET','2',1,NULL,'STEVEN ELMER','FI','292602695','HealthSpan','FI','311431434','JOSEPH T HESSLING','94','7320983','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:53',0,'2014-03-10 14:10:12'),(14579,15030,'2014-01-01','ET','2',1,NULL,'Yurij Bryndzia','FI','347823400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:37',0,'2014-03-02 05:45:37'),(11778,11778,'2014-01-01','ET','2',1,NULL,'Jeremy Hawkins','FI','290681520','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:18',0,'2014-03-10 13:52:32'),(565,565,'2014-01-01','ET','2',1,NULL,'Emily Butcher','FI','277885292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:32',0,'2014-03-01 15:48:04'),(1332,1332,'2014-01-01','ET','2',1,NULL,'William Blaine Thompson','FI','453753931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:51',0,'2014-03-02 04:38:08'),(1992,1992,'2014-01-01','ET','2',1,NULL,'Lois Clark','FI','403683336','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:34',0,'2014-03-10 13:20:27'),(3284,3284,'2014-01-01','ET','2',1,NULL,'Amanda Lee Rosales','FI','454835023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:47:56',0,'2014-03-02 02:10:49'),(3290,3290,'2014-01-01','ET','2',5,4,'Dawn Cipro','FI','288661665','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:08',0,'2014-03-01 15:48:04'),(17513,18163,'0000-00-00','ET','2',2,1,'MARGARITTA MORENO','FI','643384472','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:09',0,'2014-03-02 06:31:45'),(11528,11528,'2014-01-01','ET','2',1,NULL,'LORNA BUSSEY','FI','436193095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:29',0,'2014-03-02 04:52:44'),(13003,13003,'2014-01-01','ET','2',1,NULL,'Joshua Johnson','FI','436815635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:13',0,'2014-03-02 05:17:40'),(20803,21453,'0000-00-00','ET','2',1,NULL,'Rebecca Bickham','FI','454953936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:00',0,'2014-03-02 07:17:36'),(5704,5704,'2014-01-01','ET','2',3,2,'Rachel Shamy','FI','268885750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:34',0,'2014-03-01 15:48:04'),(4692,4692,'2014-01-01','ET','2',1,NULL,'Gloria Salas','FI','464087538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:22',0,'2014-03-02 04:38:08'),(12967,12967,'2014-01-01','ET','2',1,NULL,'Vicki  Crawford','FI','465783203','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:01',0,'2014-03-02 05:17:40'),(5631,5631,'2014-01-01','ET','2',1,NULL,'sandra jones','FI','307541256','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:50:43',0,'2014-03-10 16:03:49'),(12870,12870,'2014-01-01','ET','2',1,NULL,'KARIN THERESA GUTWILL','FI','294865034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:48',0,'2014-03-01 16:35:14'),(4587,4587,'2014-01-01','ET','2',1,NULL,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:46:52',0,'2014-03-01 16:15:39'),(7252,7252,'2014-01-01','ET','2',1,NULL,'Jane Nickerson','FI','294564059','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:16',0,'2014-03-10 15:59:47'),(3613,3613,'2014-01-01','ET','2',2,1,'Stephen Piesciuk','FI','066469661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:45',0,'2014-03-10 15:52:36'),(2465,2465,'2014-01-01','ET','2',1,NULL,'Mary Curry','FI','220604697','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:21',0,'2014-03-10 13:10:24'),(2769,2769,'2014-01-01','ET','2',2,1,'MICHAEL MYERS','FI','286823919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:19',0,'2014-03-01 16:05:34'),(20796,21446,'0000-00-00','ET','2',1,NULL,'JOYCENYN HENRY','FI','638152263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:57',0,'2014-03-02 07:17:36'),(12430,12430,'2014-01-01','ET','2',1,NULL,'Katherine Horton','FI','422212948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:46',0,'2014-03-02 05:03:29'),(17357,18007,'0000-00-00','ET','2',2,1,'Deborah Simpson','FI','402989482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:12',0,'2014-03-02 06:31:45'),(1833,1833,'2014-01-01','ET','2',1,NULL,'TERRY BISHOP','FI','270546819','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:41',0,'2014-03-10 13:20:27'),(15616,16067,'0000-00-00','ET','2',1,NULL,'Daniel Mckennis','FI','426179725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:43',0,'2014-03-02 05:59:43'),(15470,15921,'0000-00-00','ET','2',1,NULL,'Alison Megan Kluckman','FI','274886218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:54',0,'2014-03-01 16:50:53'),(20703,21353,'0000-00-00','ET','2',2,1,'Linda James','FI','278523742','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Pietrowski','94','1636529','348','2014-03-01','Sync Success',0,'2014-02-28 06:30:13',0,'2014-03-10 16:38:05'),(13915,14271,'2014-01-01','ET','2',1,NULL,'Kristie Peek','FI','104645662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:11',0,'2014-03-01 16:40:16'),(5515,5515,'2014-01-01','ET','2',1,NULL,'LOIS WILLIAMS','FI','297565122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:53',0,'2014-03-01 16:23:43'),(7720,7720,'2014-01-01','ET','2',2,1,'Paul Reich','FI','283482085','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:10',0,'2014-03-10 15:39:19'),(7062,7062,'2014-01-01','ET','2',1,NULL,'Amy Bangerter','FI','295863242','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:23',0,'2014-03-01 15:52:44'),(7409,7409,'2014-01-01','ET','2',2,1,'Doreen Ketchens','FI','437316035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:09',0,'2014-03-02 04:10:25'),(12698,12698,'2014-01-01','ET','2',1,NULL,'randall shearer','FI','272763670','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:04:42',0,'2014-03-10 13:59:38'),(11979,11979,'2014-01-01','ET','2',1,NULL,'Gloria Angelica Garcia','FI','453573569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:20',0,'2014-03-02 05:03:29'),(17559,18209,'0000-00-00','ET','2',1,NULL,'Maurice Harris','FI','259679605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:40',0,'2014-03-02 06:31:45'),(1515,1515,'2014-01-01','ET','2',1,NULL,'CECILIA DIANE FOX','FI','278547194','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:52',0,'2014-03-10 16:03:49'),(21617,22267,'0000-00-00','ET','2',1,NULL,'Adriana Alejandro','FI','640053692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:34',0,'2014-03-04 21:27:16'),(22511,23161,'0000-00-00','ET','2',1,NULL,'MARY ELLEN FONTENOT','FI','439176872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:18',0,'2014-03-07 22:26:59'),(11952,11952,'2014-01-01','ET','2',1,NULL,'ADELITH CLADIO','FI','636083016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:17',0,'2014-03-02 04:59:36'),(2890,2890,'2014-01-01','ET','2',1,NULL,'Thomas Kostoff','FI','286461861','Summa Insurance Company, Inc.','FI','341809108','Scott  Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-25 21:23:22',0,'2014-03-10 15:59:47'),(2998,2998,'2014-01-01','ET','2',2,1,'Robert Walsh','FI','547842274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:04',0,'2014-03-02 01:10:33'),(13989,14345,'2014-01-01','ET','2',1,NULL,'Adam Bernard','FI','433511682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:22',0,'2014-03-02 05:31:31'),(3879,3879,'2014-01-01','ET','2',1,0,'ALBERTA JONES','FI','280683950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:30',0,'2014-03-01 15:05:09'),(5688,5688,'2014-01-01','ET','2',1,NULL,'Bryan Gase','FI','301822980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:46',0,'2014-03-10 13:52:32'),(283,283,'2014-01-01','ET','2',1,NULL,'Shana Rains Barrera','FI','443941521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:06',0,'2014-03-01 19:11:03'),(18041,18691,'0000-00-00','ET','2',1,NULL,'Ariel Diamond','FI','344729683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:07',0,'2014-03-10 14:24:38'),(5529,5529,'2014-01-01','ET','2',4,3,'JONATHAN SYNDER','FI','279627299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:20',0,'2014-03-01 16:23:43'),(5738,5738,'2014-01-01','ET','2',1,NULL,'Michael Justice','FI','349646457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:34',0,'2014-03-02 01:10:33'),(20440,21090,'0000-00-00','ET','2',4,3,'Brian Karp','FI','275764159','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:56',0,'2014-03-01 18:08:07'),(21144,21794,'0000-00-00','ET','2',1,NULL,'Albert May','FI','462312893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:17',0,'2014-03-02 07:23:39'),(1283,1283,'2014-01-01','ET','2',1,NULL,'Martin Haas','FI','298749432','Dental Care Plus, Inc.','FI','311185262','Derek  Carnohan','94','2336334','348','2014-01-01','Sync Success',0,'2013-12-25 18:50:15',0,'2014-03-01 16:23:43'),(2362,2362,'2014-01-01','ET','2',2,1,'Douglas Raubenolt','FI','301566168','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:04',0,'2014-03-01 15:26:40'),(5699,5699,'2014-01-01','ET','2',3,2,'Giovanny Escribano','FI','597204898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:24',0,'2014-03-01 15:48:04'),(11756,11756,'2014-01-01','ET','2',1,NULL,'Kelly Boal','FI','472988484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:37',0,'2014-03-02 04:59:36'),(14799,15250,'2014-01-01','ET','2',1,NULL,'Levi Grooms','FI','297762498','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:56',0,'2014-03-10 14:03:26'),(6436,6436,'2014-01-01','ET','2',1,NULL,'Ellen Snyder','FI','283601764','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:36',0,'2014-03-01 15:10:22'),(20924,21574,'0000-00-00','ET','2',1,NULL,'Vada Mack','FI','294661624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:16',0,'2014-03-01 18:08:07'),(21862,22512,'0000-00-00','ET','2',1,NULL,'VIE ADAMS','FI','287705173','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:15',0,'2014-03-05 21:36:22'),(14593,15044,'2014-01-01','ET','2',1,NULL,'Sofia Salinas','FI','462454041','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:45',0,'2014-03-02 05:45:37'),(1739,1739,'2014-01-01','ET','2',1,NULL,'John Dorey','FI','430985024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:40',0,'2014-03-01 15:31:33'),(5927,5927,'2014-01-01','ET','2',1,NULL,'Naomi M Witt','FI','549795693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:38',0,'2014-03-01 15:48:04'),(3267,3267,'2014-01-01','ET','2',1,NULL,'DEBORAH A LADD','FI','289568228','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 21:47:23',0,'2014-03-10 13:32:15'),(14151,14602,'2014-01-01','ET','2',1,NULL,'Wayne Brown','FI','434157248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:08',0,'2014-03-02 05:38:34'),(12076,12076,'2014-01-01','ET','2',2,1,'WILLIAM DIPUCCIO','FI','295441062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:53',0,'2014-03-01 16:30:17'),(2617,2617,'2014-01-01','ET','2',1,NULL,'awes koshin','FI','611847422','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:30',0,'2014-03-01 15:16:37'),(7532,7532,'2014-01-01','ET','2',1,NULL,'Robin Brintnall James','FI','369585909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:04',0,'2014-03-01 16:05:34'),(13819,14175,'2014-01-01','ET','2',4,3,'Rita Schreiner','FI','291705939','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:24',0,'2014-03-10 16:17:47'),(19714,20364,'0000-00-00','ET','2',1,NULL,'Carol P Chavez','FI','462175164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:31:15',0,'2014-03-02 06:59:07'),(21272,21922,'0000-00-00','ET','2',1,NULL,'KEIANA MILLER','FI','437832465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:44',0,'2014-03-02 07:23:39'),(4011,4011,'2014-01-01','ET','2',1,NULL,'Charles Thornton','FI','547081590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:27',0,'2014-03-02 03:09:49'),(7242,7242,'2014-01-01','ET','2',1,NULL,'Adam Bourgeois','FI','433771925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:58',0,'2014-03-02 03:09:49'),(7265,7265,'2014-01-01','ET','2',1,NULL,'Gretchen Singh','FI','281626504','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:38',0,'2014-03-10 13:32:15'),(5734,5734,'2014-01-01','ET','2',1,NULL,'Kathy Harder','FI','268525228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:26',0,'2014-03-01 15:48:04'),(18284,18934,'0000-00-00','ET','2',1,NULL,'Danny Guitreau','FI','437118134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:14',0,'2014-03-02 06:38:05'),(14061,14512,'2014-01-01','ET','2',2,1,'Nora Marshall','FI','269602017','HealthSpan','FI','311431434','Mike  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:10',0,'2014-03-10 14:03:26'),(11407,11407,'2014-01-01','ET','2',1,NULL,'Joyce Myers','FI','276521978','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:48',0,'2014-03-10 13:52:32'),(4566,4566,'2014-01-01','ET','2',1,NULL,'Chasidy Morris','FI','428593199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:12',0,'2014-03-02 04:38:08'),(11286,11286,'2014-01-01','ET','2',1,NULL,'LETITIA COTTON','FI','433570344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:05',0,'2014-03-02 04:52:44'),(13625,13981,'2014-01-01','ET','2',1,NULL,'David Hudson','FI','300606135','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:43',0,'2014-03-10 14:03:26'),(19468,20118,'0000-00-00','ET','2',1,NULL,'Brittney nicole Stephens','FI','463810573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:51:40',0,'2014-03-02 06:59:07'),(7313,7313,'2014-01-01','ET','2',1,NULL,'jennifer bailey','FI','274785028','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:10:06',0,'2014-03-10 13:32:15'),(18711,19361,'0000-00-00','ET','2',1,NULL,'DOUGLAS STRICKLER','FI','294642181','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:00',0,'2014-03-10 14:31:05'),(1054,1054,'2014-01-01','ET','2',1,NULL,'Andrew Ervin','FI','461791777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:25',0,'2014-03-01 15:16:37'),(1728,1728,'2014-01-01','ET','2',2,1,'Brent Harris','FI','290729751','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:20',0,'2014-03-01 15:31:33'),(11500,11500,'2014-01-01','ET','2',2,1,'David Mirelez','FI','450158425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:38',0,'2014-03-02 04:52:44'),(2875,2875,'2014-01-01','ET','2',1,NULL,'Marilyn Margaret Wall','FI','283544243','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:49',0,'2014-03-10 13:39:10'),(17076,17726,'0000-00-00','ET','2',1,NULL,'Marcus manigo','FI','553716451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:45',0,'2014-03-02 06:24:38'),(13637,13993,'2014-01-01','ET','2',1,NULL,'Andrew Davidson','FI','280904146','HealthSpan','FI','311431434','Paul  Sullivan','94','3667671','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:52',0,'2014-03-10 14:03:26'),(5742,5742,'2014-01-01','ET','2',1,NULL,'David Nebret','FI','158462993','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:41',0,'2014-03-02 01:10:33'),(19576,20226,'0000-00-00','ET','2',1,NULL,'Jill Wilson','FI','366620143','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:25:11',0,'2014-03-10 14:37:47'),(19628,20278,'0000-00-00','ET','2',1,NULL,'Jordan Conti','FI','299846606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:37:27',0,'2014-03-01 17:47:19'),(7557,7557,'2014-01-01','ET','2',1,NULL,'Gregory M Trbovich','FI','294480273','Dental Care Plus, Inc.','FI','311185262','Deanna M Wells','94','7827930','348','2014-01-01','Sync Success',0,'2013-12-26 04:35:52',0,'2014-03-01 16:05:34'),(7157,7157,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:19',0,'2014-03-10 15:59:47'),(11742,11742,'2014-01-01','ET','2',1,NULL,'William Syrjanen','FI','280844485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:13',0,'2014-03-01 16:30:17'),(590,590,'2014-01-01','ET','2',1,NULL,'Kenneth Gooding','FI','270468185','HealthSpan','FI','311431434','Bernadine  Kirian','94','11391349','348','2014-01-01','Sync Success',0,'2013-12-25 18:03:16',0,'2014-03-10 13:24:34'),(905,905,'2014-01-01','ET','2',1,NULL,'PATRICIA PERLMUTER','FI','284503831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:16',0,'2014-03-01 15:21:15'),(18247,18897,'0000-00-00','ET','2',5,4,'Dung Nguyen','FI','556897866','Summa Insurance Company, Inc.','FI','341809108','Kim  Clark','94','753653','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:33',0,'2014-03-10 16:31:33'),(1560,1560,'2014-01-01','ET','2',1,NULL,'Michael Bassett','FI','280768416','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:20',0,'2014-03-10 13:52:32'),(15122,15573,'0000-00-00','ET','2',1,NULL,'MIREYA KHAWLI','FI','572021213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:06',0,'2014-03-01 16:50:53'),(23052,23702,'0000-00-00','ET','2',1,NULL,'Robert FLowers','FI','587179369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:29',0,'2014-03-10 21:27:11'),(570,570,'2014-01-01','ET','2',1,NULL,'Chrisann Byers','FI','287504151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:40',0,'2014-03-01 15:48:04'),(16388,17038,'0000-00-00','ET','2',1,NULL,'SHIRLEY ANN KNIGHTON','FI','433175212','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:19',0,'2014-03-02 06:10:30'),(1386,1386,'2014-01-01','ET','2',2,1,'Richard Nordin','FI','320525063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:34',0,'2014-03-02 04:45:37'),(13932,14288,'2014-01-01','ET','2',1,NULL,'Lisa Stout','FI','450799900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:20',0,'2014-03-02 05:31:31'),(2320,2320,'2014-01-01','ET','2',2,1,'Jerry Sylvester','FI','386620023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:55',0,'2014-03-01 19:11:03'),(13658,14014,'2014-01-01','ET','2',1,NULL,'Javonne Deshye Eatmon','FI','642182014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:15',0,'2014-03-02 05:24:45'),(2722,2722,'2014-01-01','ET','2',1,NULL,'Mariah Grant','FI','433670251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:53',0,'2014-03-02 04:15:49'),(7191,7191,'2014-01-01','ET','2',1,NULL,'Robbie Hunter','FI','467657323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:23',0,'2014-03-02 03:09:49'),(4234,4234,'2014-01-01','ET','2',2,1,'Tenola C Oliver','FI','296605213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:16',0,'2014-03-01 16:00:27'),(12824,12824,'2014-01-01','ET','2',1,NULL,'Brandon Leonard','FI','433757637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:02:08',0,'2014-03-02 05:10:52'),(10995,10995,'2014-01-01','ET','2',1,NULL,'Meta Braud','FI','537600605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:34',0,'2014-03-02 04:24:47'),(5123,5123,'2014-01-01','ET','2',1,NULL,'ROBERTA ROWLAND','FI','273589489','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:59',0,'2014-03-10 15:45:56'),(21132,21782,'0000-00-00','ET','2',1,NULL,'ERIC HUYNH','FI','295960182','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:09',0,'2014-03-10 16:38:05'),(18231,18881,'0000-00-00','ET','2',1,NULL,'Andrew Watkins','FI','280921394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:19',0,'2014-03-10 14:24:38'),(11156,11156,'2014-01-01','ET','2',1,NULL,'Ryan Tarpley','FI','281884799','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:07',0,'2014-03-10 13:45:57'),(5110,5110,'2014-01-01','ET','2',1,NULL,'Jackie Momenee','FI','276640605','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:31',0,'2014-03-10 13:20:27'),(3498,3498,'2014-01-01','ET','2',1,NULL,'Justin Alan Medley','FI','275907681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:07',0,'2014-03-01 15:37:30'),(6182,6182,'2014-01-01','ET','2',1,NULL,'colburn hunt','FI','382545975','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:46',0,'2014-03-02 04:10:25'),(3342,3342,'2014-01-01','ET','2',1,NULL,'Carlos Cancel','FI','583853566','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:55',0,'2014-03-02 02:10:49'),(18210,18860,'0000-00-00','ET','2',4,3,'Terry  White','FI','295547480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:01',0,'2014-03-10 14:24:38'),(11892,11892,'2014-01-01','ET','2',1,NULL,'chi tran','FI','241874511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:45',0,'2014-03-02 04:59:36'),(17758,18408,'0000-00-00','ET','2',1,NULL,'FRANCO CONTI','FI','278500559','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-09 19:00:42',0,'2014-03-10 16:24:30'),(16513,17163,'0000-00-00','ET','2',1,NULL,'Robin Hawkins','FI','465658246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:46',0,'2014-03-02 06:17:30'),(15576,16027,'0000-00-00','ET','2',1,NULL,'Steven Davis','FI','289464639','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:25',0,'2014-03-10 14:10:12'),(15565,16016,'0000-00-00','ET','2',1,NULL,'Kiet Tuan Phan','94','0000873260','Dental Care Plus, Inc.','FI','311185262','John A Dodd Jr','94','2433834','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:20',0,'2014-03-01 16:50:53'),(18134,18784,'0000-00-00','ET','2',2,1,'Kevin P McCann','FI','438700196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:03',0,'2014-03-02 06:38:05'),(18498,19148,'0000-00-00','ET','2',2,1,'Jennifer Minnich','FI','277847370','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:08',0,'2014-03-10 14:31:05'),(21756,22406,'0000-00-00','ET','2',1,NULL,'STEPHEN DOWDY','FI','287764447','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:26',0,'2014-03-10 16:44:18'),(17583,18233,'0000-00-00','ET','2',3,2,'Diane Hubbell','FI','298602051','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:59',0,'2014-03-10 14:24:38'),(14790,15241,'2014-01-01','ET','2',1,NULL,'Carla  Doubet','FI','337464995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:51',0,'2014-03-02 05:45:37'),(11225,11225,'2014-01-01','ET','2',1,NULL,'GREGORY DELPRINCE','FI','290640759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:13',0,'2014-03-01 16:23:43'),(10391,10391,'2014-01-01','ET','2',1,NULL,'ANGELA DAWN STEPHENS','FI','292684714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:27',0,'2014-03-01 16:10:36'),(12470,12470,'2014-01-01','ET','2',1,NULL,'Todd Smith','FI','286866405','Dental Care Plus, Inc.','FI','311185262','Heidi  McArthur','94','8621177','348','2014-02-01','Sync Success',1,'2014-01-02 04:32:14',0,'2014-03-01 16:30:17'),(18447,19097,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:36',0,'2014-03-10 16:31:33'),(19832,20482,'0000-00-00','ET','2',1,NULL,'GIOVANNY FRANCISCO ESCRIBANO','FI','597204898','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-20 22:00:50',0,'2014-03-10 16:38:05'),(20357,21007,'0000-00-00','ET','2',1,NULL,'DOUG BLAIR','FI','170485392','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:43',0,'2014-03-10 16:38:05'),(22904,23554,'0000-00-00','ET','2',1,NULL,'Arlene Stipe','FI','437904479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:44',0,'2014-03-10 21:27:11'),(12592,12592,'2014-01-01','ET','2',1,NULL,'Michelle Austin','FI','454392682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:49',0,'2014-03-02 05:10:52'),(11761,11761,'2014-01-01','ET','2',1,NULL,'Michelle Rammel','FI','296668687','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:46',0,'2014-03-10 13:52:32'),(7573,7573,'2014-01-01','ET','2',1,NULL,'John Garey','FI','270865428','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:23',0,'2014-03-01 16:05:34'),(7001,7001,'2014-01-01','ET','2',2,1,'Terra Stotler','FI','509044385','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:31',0,'2014-03-02 02:10:49'),(6124,6124,'2014-01-01','ET','2',1,NULL,'Michael BROOKS','FI','292747529','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:02',0,'2014-03-01 16:00:27'),(16080,16729,'0000-00-00','ET','2',1,NULL,'Brian Doyle','FI','275884283','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:03',0,'2014-03-01 16:56:22'),(19338,19988,'0000-00-00','ET','2',1,NULL,'Maria Esther Bonilla','FI','639150846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:25',0,'2014-03-02 06:59:07'),(22025,22675,'0000-00-00','ET','2',1,NULL,'MARIBEL PEREZ','FI','453839186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:10',0,'2014-03-05 22:27:33'),(22788,23438,'0000-00-00','ET','2',1,NULL,'Kathy White','FI','286583115','HealthSpan','FI','311431434','Donald  Larson','94','15784811','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:40',0,'2014-03-10 14:50:59'),(38,38,'2014-01-01','ET','2',1,NULL,'Brandon Kilby','FI','275889977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:07',0,'2014-03-01 15:21:15'),(13762,14118,'2014-01-01','ET','2',1,NULL,'brandon lee','FI','285847273','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:22',0,'2014-03-10 16:10:34'),(5760,5760,'2014-01-01','ET','2',1,NULL,'Noel Naizer','FI','631031926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:14',0,'2014-03-02 01:10:33'),(3066,3066,'2014-01-01','ET','2',2,1,'RHONDA RAE MANUEL','FI','270542591','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:07',0,'2014-03-01 15:37:30'),(1782,1782,'2014-01-01','ET','2',2,1,'edward kruger','FI','290648864','Summa Insurance Company, Inc.','FI','341809108','Rick Alan Lohr','94','15886837','348','2014-01-01','Sync Success',0,'2013-12-25 19:19:01',0,'2014-03-10 15:45:56'),(19869,20519,'0000-00-00','ET','2',2,1,'Ghulam M Yousas','FI','680309306','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:19',0,'2014-03-01 17:47:19'),(20244,20894,'0000-00-00','ET','2',1,NULL,'Richelle Bradley','FI','300902012','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:04',0,'2014-03-10 14:37:47'),(17947,18597,'0000-00-00','ET','2',1,NULL,'aletha ruggs','FI','276606309','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:01',0,'2014-03-01 17:20:55'),(14138,14589,'2014-01-01','ET','2',1,NULL,'Josh Luckett','FI','436479445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:59',0,'2014-03-02 05:38:34'),(5372,5372,'2014-01-01','ET','2',1,NULL,'CAROLYN A ELZY','FI','437967601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:35',0,'2014-03-01 21:11:04'),(7639,7639,'2014-01-01','ET','2',1,NULL,'Leah Polk','FI','636201623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:31',0,'2014-03-02 04:15:49'),(4900,4900,'2014-01-01','ET','2',2,1,'Samuel Burgess','FI','273526709','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:06',0,'2014-03-01 15:05:09'),(3269,3269,'2014-01-01','ET','2',1,NULL,'ANGELA JEFFERSON','FI','426457033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:28',0,'2014-03-02 02:10:49'),(4816,4816,'2014-01-01','ET','2',1,NULL,'Penny L Matthiesen','FI','349503294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:20',0,'2014-03-01 21:11:04'),(4590,4590,'2014-01-01','ET','2',1,NULL,'Joseph Shupe','FI','275605526','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:57',0,'2014-03-01 16:15:39'),(4476,4476,'2014-01-01','ET','2',2,1,'Richard Novak','FI','212603746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:16',0,'2014-03-01 21:11:04'),(23069,23719,'0000-00-00','ET','2',1,NULL,'Karen Emery','FI','369564919','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:43',0,'2014-03-10 21:17:52'),(17299,17949,'0000-00-00','ET','2',1,NULL,'August Gough','FI','438754670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:54',0,'2014-03-02 06:24:38'),(11297,11297,'2014-01-01','ET','2',1,NULL,'Darin Dison','FI','435672838','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:25',0,'2014-03-02 04:52:44'),(285,285,'2014-01-01','ET','2',1,NULL,'Nanette Roberts','FI','550330973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:10',0,'2014-03-01 15:05:09'),(17252,17902,'0000-00-00','ET','2',3,2,'Sherry Carver','FI','276820223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:32',0,'2014-03-01 17:20:55'),(10586,10586,'2014-01-01','ET','2',1,NULL,'Erikalin Ashton','FI','223132719','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:44',0,'2014-03-02 04:24:47'),(16489,17139,'0000-00-00','ET','2',2,1,'Callen R Bertrand','FI','434662169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:30',0,'2014-03-02 06:10:30'),(19544,20194,'0000-00-00','ET','2',1,NULL,'RICARDO GALMON','FI','435736617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:16:52',0,'2014-03-02 06:59:07'),(20455,21105,'0000-00-00','ET','2',3,2,'David Roth','FI','297528409','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:12',0,'2014-03-01 18:08:07'),(16180,16829,'0000-00-00','ET','2',1,NULL,'Edith Dean','FI','289663131','Dental Care Plus, Inc.','FI','311185262','Sharon  Wingert','94','2446886','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:26',0,'2014-03-01 16:56:22'),(2285,2285,'2014-01-01','ET','2',1,NULL,'Ashanti Smith','FI','439755859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:40',0,'2014-03-01 21:11:04'),(4304,4304,'2014-01-01','ET','2',1,NULL,'Jalisa Donald','FI','587714165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:25',0,'2014-03-02 03:09:49'),(14881,15332,'2014-01-01','ET','2',1,NULL,'Randy Christian','FI','467985814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:15',0,'2014-03-02 05:52:31'),(4058,4058,'2014-01-01','ET','2',1,NULL,'Susannah Lipsey','FI','643054155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:56',0,'2014-03-02 03:09:49'),(13051,13407,'2014-01-01','ET','2',2,1,'Dwayne Michael Palmisano','FI','436475286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:09',0,'2014-03-02 05:17:40'),(14548,14999,'2014-01-01','ET','2',2,1,'George Mock','FI','184363208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:17',0,'2014-03-02 05:45:37'),(5957,5957,'2014-01-01','ET','2',1,NULL,'Dalton Long','FI','442621613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:33',0,'2014-03-02 01:10:33'),(7116,7116,'2014-01-01','ET','2',4,3,'Camilia Ward','FI','293905556','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:04',0,'2014-03-01 15:52:44'),(22215,22865,'0000-00-00','ET','2',1,NULL,'Beverly Roach','FI','280547368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:50',0,'2014-03-06 21:36:23'),(3514,3514,'2014-01-01','ET','2',1,NULL,'Michael Shafitz','FI','420782243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:01:39',0,'2014-03-01 15:37:30'),(3364,3364,'2014-01-01','ET','2',1,NULL,'KIMBERLY GREEN','FI','457937363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:33',0,'2014-03-02 02:10:49'),(10993,10993,'2014-01-01','ET','2',2,1,'Mary Jean Reed','FI','427064381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:30',0,'2014-03-02 04:24:47'),(19223,19873,'0000-00-00','ET','2',1,NULL,'LISSETTE C MENENDEZ','FI','437087565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:19',0,'2014-03-02 06:52:12'),(20358,21008,'0000-00-00','ET','2',2,1,'GURPREET SINGH','FI','621684392','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:44',0,'2014-03-10 16:38:05'),(20503,21153,'0000-00-00','ET','2',1,NULL,'Irina Gorodnova','94','0001785186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:45',0,'2014-03-02 07:10:28'),(1925,1925,'2014-01-01','ET','2',1,NULL,'Dennis Ake','FI','282429427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:29',0,'2014-03-01 15:26:40'),(7676,7676,'2014-01-01','ET','2',1,NULL,'rodney Harsh','FI','279701564','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:42',0,'2014-03-10 13:39:10'),(4531,4531,'2014-01-01','ET','2',1,NULL,'MACKENVIE PFAHLER','FI','268880878','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:03',0,'2014-03-10 16:03:49'),(14217,14668,'2014-01-01','ET','2',1,NULL,'WILLIAM  SEDDENS','FI','268584836','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:52',0,'2014-03-10 14:03:26'),(12101,12101,'2014-01-01','ET','2',1,NULL,'ShonZia Sanders','FI','273922286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:44',0,'2014-03-01 16:30:17'),(16832,17482,'0000-00-00','ET','2',1,NULL,'Joseph Patrick Yaegel','FI','407196485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-02 19:00:14',0,'2014-03-01 17:00:58'),(11498,11498,'2014-01-01','ET','2',2,1,'David Mirelez','FI','450158425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:35',0,'2014-03-02 04:52:44'),(11222,11222,'2014-01-01','ET','2',1,NULL,'ANTHONY COLEMAN','FI','298663185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:01:07',0,'2014-03-01 16:23:43'),(22201,22851,'0000-00-00','ET','2',1,NULL,'rico hay','FI','426555030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:40',0,'2014-03-06 21:27:26'),(1878,1878,'2014-01-01','ET','2',1,NULL,'Hong Fan','FI','108339017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:09',0,'2014-03-01 23:10:52'),(16533,17183,'0000-00-00','ET','2',1,NULL,'Matthew Henry','FI','576629098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-30 21:00:58',0,'2014-03-01 17:00:58'),(6106,6106,'2014-01-01','ET','2',1,NULL,'Christopher Alvarado','FI','457210858','Dental Care Plus, Inc.','FI','311185262','Gregory  Myers','94','9074445','357','2014-01-01','Sync Success',0,'2013-12-26 03:01:31',0,'2014-03-01 16:00:27'),(5713,5713,'2014-01-01','ET','2',1,NULL,'Matthew Bliss','FI','270843943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:52',0,'2014-03-01 15:37:30'),(3376,3376,'2014-01-01','ET','2',1,NULL,'Glenda Monroe','FI','455811724','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:58',0,'2014-03-02 02:10:49'),(4887,4887,'2014-01-01','ET','2',2,1,'Angela McFerran','FI','300684286','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:52',0,'2014-03-10 13:03:33'),(6457,6457,'2014-01-01','ET','2',1,NULL,'Melissa Weaver','FI','299802009','HealthSpan','FI','311431434','Samuel  Brauen','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-26 03:16:23',0,'2014-03-10 13:03:33'),(19202,19852,'0000-00-00','ET','2',1,NULL,'Dana Williams','FI','427391952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:08',0,'2014-03-02 06:52:12'),(20725,21375,'0000-00-00','ET','2',4,3,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:23',0,'2014-03-01 18:08:07'),(22682,23332,'0000-00-00','ET','2',1,NULL,'KAREN SCOTT','FI','439435656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:30:45',0,'2014-03-08 22:26:18'),(10660,10660,'2014-01-01','ET','2',1,NULL,'Karen Green','FI','433418593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:07',0,'2014-03-02 04:31:46'),(1419,1419,'2014-01-01','ET','2',1,NULL,'Pamela Holley','FI','317622556','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:41',0,'2014-03-10 13:45:57'),(7249,7249,'2014-01-01','ET','2',1,NULL,'Margaret Gilbert','FI','291523181','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:11',0,'2014-03-10 15:59:47'),(1793,1793,'2014-01-01','ET','2',1,NULL,'Sandra Laus','FI','386523380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:24',0,'2014-03-10 13:20:27'),(18434,19084,'0000-00-00','ET','2',1,NULL,'Susan Vibbert','FI','276607475','Dental Care Plus, Inc.','FI','311185262','Dennis  Guillen','94','16688854','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:28',0,'2014-03-01 17:26:36'),(15925,16574,'0000-00-00','ET','2',1,NULL,'Cindy M Fisher','FI','272560252','Summa Insurance Company, Inc.','FI','341809108','Lenda  Sojourner','94','1862271','348','2014-03-01','Sync Success',0,'2014-01-25 19:00:08',0,'2014-03-10 16:24:30'),(4081,4081,'2014-01-01','ET','2',2,1,'James Murphey','FI','273521423','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:42',0,'2014-03-01 16:00:27'),(4157,4157,'2014-01-01','ET','2',1,NULL,'Cena Glass','FI','437171166','Summa Insurance Company, Inc.','FI','341809108','Michael Joseph Fitzpatrick','94','16875889','348','2014-01-01','Sync Success',0,'2013-12-25 23:04:56',0,'2014-03-10 15:59:47'),(15724,16373,'0000-00-00','ET','2',1,NULL,'STACY  SIMON','FI','433679782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:05',0,'2014-03-02 06:03:21'),(5541,5541,'2014-01-01','ET','2',1,NULL,'tracy smith','FI','284843934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:47',0,'2014-03-01 16:23:43'),(13680,14036,'2014-01-01','ET','2',3,2,'EDUARDO ARREDONDO CERVANTES','FI','644521314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:28',0,'2014-03-02 05:24:45'),(10527,10527,'2014-01-01','ET','2',1,NULL,'Kimberly Lee','FI','465912601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:44',0,'2014-03-02 04:24:47'),(1876,1876,'2014-01-01','ET','2',1,NULL,'John Isenbarger','FI','269821132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:31:06',0,'2014-03-01 15:31:33'),(3380,3380,'2014-01-01','ET','2',1,NULL,'PAUL HOLUB','FI','451253338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:05',0,'2014-03-02 02:10:49'),(4091,4091,'2014-01-01','ET','2',1,NULL,'Jennifer Martin','FI','592280204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:02',0,'2014-03-01 16:00:27'),(5294,5294,'2014-01-01','ET','2',2,1,'BARBARA LINDE','FI','439920749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:12',0,'2014-03-01 20:10:57'),(4609,4609,'2014-01-01','ET','2',2,1,'calvin toups','FI','433192763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:31',0,'2014-03-02 04:31:46'),(18611,19261,'0000-00-00','ET','2',1,NULL,'Jennifer  Taylor','FI','301806612','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:43',0,'2014-03-10 16:31:33'),(18435,19085,'0000-00-00','ET','2',1,NULL,'jerry christman','FI','605075032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:28',0,'2014-03-01 17:26:36'),(16364,17014,'0000-00-00','ET','2',1,NULL,'EVA S SHOOKS','FI','276567899','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:02',0,'2014-03-10 16:24:30'),(16074,16723,'0000-00-00','ET','2',2,1,'KOFI FOSU','FI','103844606','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:59',0,'2014-03-01 16:56:22'),(15947,16596,'0000-00-00','ET','2',1,NULL,'Ian Aleksandr Fowler','94','0000287123','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:20',0,'2014-03-01 16:56:22'),(3441,3441,'2014-01-01','ET','2',1,NULL,'DEBRA RAMEY','FI','270709350','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:02',0,'2014-03-10 13:24:34'),(20182,20832,'0000-00-00','ET','2',1,NULL,'YU PAO LIN','FI','621380310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:31:17',0,'2014-03-02 07:10:28'),(16394,17044,'0000-00-00','ET','2',1,NULL,'Steven Prochaska','FI','395902071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:23',0,'2014-03-02 06:10:30'),(15780,16429,'0000-00-00','ET','2',1,NULL,'Linda Harrah','FI','295546326','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:43',0,'2014-03-10 14:10:12'),(605,605,'2014-01-01','ET','2',1,NULL,'Gena S Hammonds','FI','458675349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:45',0,'2014-03-02 02:10:49'),(11594,11594,'2014-01-01','ET','2',1,NULL,'Rachel Darin','FI','385902364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:34',0,'2014-03-02 04:52:44'),(11389,11389,'2014-01-01','ET','2',1,NULL,'Latonya Earls','FI','097789301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:13',0,'2014-03-02 04:52:44'),(15581,16032,'0000-00-00','ET','2',1,NULL,'JAY JAGODZINSKI','FI','284666383','HealthSpan','FI','311431434','JOSEPH T HESSLING','94','7320983','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:27',0,'2014-03-10 14:10:12'),(4013,4013,'2014-01-01','ET','2',1,NULL,'linda wilson','FI','463909146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:31',0,'2014-03-02 03:09:49'),(4276,4276,'2014-01-01','ET','2',1,NULL,'ANGIE ARAUJO','94','0001218831','Starmount Life Insurance Company','FI','720977315','monica  folse','94','4710336','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:36',0,'2014-03-02 03:09:49'),(6096,6096,'2014-01-01','ET','2',1,NULL,'Earl Soden','FI','294466071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:12',0,'2014-03-01 16:00:27'),(7333,7333,'2014-01-01','ET','2',1,NULL,'Wendy Stahl-Frakes','FI','291448049','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:45',0,'2014-03-10 13:32:15'),(10477,10477,'2014-01-01','ET','2',1,NULL,'PHILIP BOLLER','FI','290605006','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:09',0,'2014-03-01 16:10:36'),(17704,18354,'0000-00-00','ET','2',1,NULL,'John Binz','FI','631322196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:04',0,'2014-03-02 06:31:45'),(18219,18869,'0000-00-00','ET','2',2,1,'Vicki Zanella','FI','277501443','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:08',0,'2014-03-10 16:31:33'),(19718,20368,'0000-00-00','ET','2',1,NULL,'MICHAEL THOMPSON','FI','301563679','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 05:32:34',0,'2014-03-01 17:47:19'),(11385,11385,'2014-01-01','ET','2',1,NULL,'DARRELL MOATON','FI','426437900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:04',0,'2014-03-02 04:52:44'),(16763,17413,'0000-00-00','ET','2',1,NULL,'ROSE BRYANT','FI','587544348','Starmount Life Insurance Company','FI','720977315','MADELYN M MATIJEVICH','94','2985167','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:18',0,'2014-03-02 06:17:30'),(635,635,'2014-01-01','ET','2',1,NULL,'Veronica Quintanilla','FI','453650981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:45',0,'2014-03-02 02:10:49'),(1081,1081,'2014-01-01','ET','2',1,NULL,'Jason Alan Morrow','FI','466833201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:19',0,'2014-03-01 19:11:03'),(5487,5487,'2014-01-01','ET','2',1,NULL,'Martha G Recio Torres','FI','436790908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:45:59',0,'2014-03-02 04:45:37'),(3021,3021,'2014-01-01','ET','2',1,NULL,'Ralph Severance','FI','268521370','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:45',0,'2014-03-10 15:52:36'),(14981,15432,'2014-01-01','ET','2',2,1,'John Boring','FI','288608799','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:02',0,'2014-03-01 16:50:53'),(13795,14151,'2014-01-01','ET','2',2,1,'zhihang dong','FI','087809594','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:43',0,'2014-03-10 13:59:38'),(11780,11780,'2014-01-01','ET','2',1,NULL,'randall shearer','FI','272763670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:22',0,'2014-03-10 13:52:32'),(12259,12259,'2014-01-01','ET','2',1,NULL,'marsha hill','FI','453131483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:46',0,'2014-03-02 05:10:52'),(17158,17808,'0000-00-00','ET','2',1,NULL,'WILLIAM BOCK','FI','292884574','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:38',0,'2014-03-10 14:20:26'),(17662,18312,'0000-00-00','ET','2',1,NULL,'SANDRA CROYLE','FI','287480594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:43',0,'2014-03-01 17:20:55'),(18278,18928,'0000-00-00','ET','2',1,NULL,'Vincent Spehar','FI','285766564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:08',0,'2014-03-01 17:26:36'),(21788,22438,'0000-00-00','ET','2',1,NULL,'INAE PARK','FI','292889425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:08',0,'2014-03-04 21:36:30'),(13300,13656,'2014-01-01','ET','2',1,NULL,'MARY ELIZABETH MILLS','FI','281544484','Dental Care Plus, Inc.','FI','311185262','LANCE   SPEARMAN','94','1817334','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:12',0,'2014-03-01 16:40:16'),(436,436,'2014-01-01','ET','2',1,NULL,'Shirley Clark','FI','587279926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:32',0,'2014-03-01 22:10:55'),(12542,12542,'2014-01-01','ET','2',1,NULL,'David Roehm','FI','287429174','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:34:56',0,'2014-03-10 13:59:38'),(4139,4139,'2014-01-01','ET','2',2,1,'George McNulty','FI','194423961','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:20',0,'2014-03-01 16:00:27'),(10667,10667,'2014-01-01','ET','2',1,NULL,'Philip Seay','FI','592584945','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:20',0,'2014-03-01 16:05:34'),(10375,10375,'2014-01-01','ET','2',1,NULL,'Michael Hermann','FI','339442450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:56',0,'2014-03-01 16:10:36'),(3873,3873,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:31:18',0,'2014-03-10 13:03:33'),(7351,7351,'2014-01-01','ET','2',1,NULL,'Christopher Zanin','FI','392722570','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:30',0,'2014-03-10 15:39:19'),(7474,7474,'2014-01-01','ET','2',1,NULL,'Lilian Olima','FI','634083962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:06',0,'2014-03-02 04:15:49'),(13934,14290,'2014-01-01','ET','2',2,1,'marilyn hill','FI','461350946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:21',0,'2014-03-02 05:31:31'),(10474,10474,'2014-01-01','ET','2',1,NULL,'Chris Jeffrey Trigg','FI','287749012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:03',0,'2014-03-01 16:10:36'),(10389,10389,'2014-01-01','ET','2',1,NULL,'Brent Kirby','FI','033488086','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:23',0,'2014-03-01 16:10:36'),(6990,6990,'2014-01-01','ET','2',1,NULL,'CONNIE HELBLING','FI','294508097','HealthSpan','FI','311431434','TIM  MCKEOWN','94','1640913','348','2014-01-01','Sync Success',0,'2013-12-26 04:00:10',0,'2014-03-10 13:32:15'),(4948,4948,'2014-01-01','ET','2',1,NULL,'Monica Koelsch','FI','283822529','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:45',0,'2014-03-01 15:10:22'),(7146,7146,'2014-01-01','ET','2',2,1,'ROBERT YOUNGBLOOD','FI','293501386','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:59',0,'2014-03-10 15:59:47'),(5832,5832,'2014-01-01','ET','2',1,NULL,'Edith Howard','FI','433551393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:28',0,'2014-03-01 20:10:57'),(20585,21235,'0000-00-00','ET','2',1,NULL,'Fha Love','FI','291543834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:38',0,'2014-03-01 18:08:07'),(21618,22268,'0000-00-00','ET','2',1,NULL,'Leroy Lopez','FI','450233062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:34',0,'2014-03-04 21:27:16'),(21669,22319,'0000-00-00','ET','2',1,NULL,'Timothy L Springer','FI','275588311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:12',0,'2014-03-04 21:36:30'),(22871,23521,'0000-00-00','ET','2',1,NULL,'CORY CARRIFEE','FI','459275565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:17',0,'2014-03-10 21:27:11'),(16634,17284,'0000-00-00','ET','2',1,NULL,'Derrick Williams','FI','437318547','Starmount Life Insurance Company','FI','720977315','Pat  Collins','94','4728680','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:31',0,'2014-03-02 06:17:30'),(16588,17238,'0000-00-00','ET','2',2,1,'MICHAEL LAMMERS','FI','268602849','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:35',0,'2014-03-10 14:20:26'),(13774,14130,'2014-01-01','ET','2',1,NULL,'SHERI LEE GALAT','FI','273587998','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:30',0,'2014-03-10 16:10:34'),(5296,5296,'2014-01-01','ET','2',1,NULL,'Terrence Vasari','FI','300980768','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:16',0,'2014-03-10 15:39:19'),(5418,5418,'2014-01-01','ET','2',1,NULL,'Janet Merkt','FI','287545380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:54',0,'2014-03-01 15:10:22'),(22931,23581,'0000-00-00','ET','2',2,1,'Antoinette Johnson','94','0001833728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:04',0,'2014-03-10 21:27:11'),(1103,1103,'2014-01-01','ET','2',2,1,'John S Chandler','FI','443548442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:08',0,'2014-03-10 13:03:33'),(11214,11214,'2014-01-01','ET','2',1,NULL,'Elizabeth Loring','FI','014649758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:53',0,'2014-03-01 16:23:43'),(16251,16900,'0000-00-00','ET','2',1,NULL,'Robert Swartz','FI','268527921','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:01:14',0,'2014-03-10 14:20:26'),(1958,1958,'2014-01-01','ET','2',1,NULL,'Terri Searfos','FI','450089103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:28',0,'2014-03-01 15:26:40'),(15698,16347,'0000-00-00','ET','2',1,NULL,'Beverly Acosta','FI','466874559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:47',0,'2014-03-02 05:59:43'),(7727,7727,'2014-01-01','ET','2',1,NULL,'Brandon Buck','FI','292865198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:07',0,'2014-03-01 15:05:09'),(4271,4271,'2014-01-01','ET','2',1,NULL,'Jerome Verges','FI','433726730','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:26',0,'2014-03-02 03:09:49'),(14914,15365,'2014-01-01','ET','2',1,NULL,'Robert MacMichael','FI','193447907','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:30',0,'2014-03-01 16:50:53'),(7652,7652,'2014-01-01','ET','2',1,NULL,'latoya marie hindsman','FI','288885756','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:56',0,'2014-03-10 13:39:10'),(12941,12941,'2014-01-01','ET','2',2,1,'michael barron','FI','463047669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2014-01-04 06:00:13',0,'2014-03-02 02:10:49'),(7187,7187,'2014-01-01','ET','2',1,NULL,'roger  evans','FI','553904345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:15',0,'2014-03-02 03:09:49'),(17725,18375,'0000-00-00','ET','2',1,NULL,'Elizabeth Mattingly','FI','403271825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:18',0,'2014-03-01 17:20:55'),(19419,20069,'0000-00-00','ET','2',1,NULL,'GLORIA WILLIAMS-QUINN','FI','436763802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:23',0,'2014-03-02 06:59:07'),(12952,12952,'2014-01-01','ET','2',1,NULL,'Edna McNeal','FI','140568887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:24',0,'2014-03-02 05:17:40'),(12420,12420,'2014-01-01','ET','2',1,NULL,'Jennifer Rouse','FI','438650195','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:23',0,'2014-03-02 05:03:29'),(556,556,'2014-01-01','ET','2',3,2,'Deborah Barlage','FI','282500876','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:13',0,'2014-03-01 15:48:04'),(2779,2779,'2014-01-01','ET','2',2,1,'chrystine baker','FI','269747375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:37',0,'2014-03-01 16:05:34'),(2674,2674,'2014-01-01','ET','2',5,4,'MATTHEW SMITH','FI','297863382','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:19',0,'2014-03-01 16:05:34'),(19639,20289,'0000-00-00','ET','2',4,3,'Vincent A Dugan','FI','196428448','Dental Care Plus, Inc.','FI','311185262','Ryan  Mulligan','94','8789743','348','2014-04-01','Sync Success',0,'2014-02-20 04:40:24',0,'2014-03-01 17:47:19'),(19680,20330,'0000-00-00','ET','2',1,NULL,'BRENDA DIANE VALLEE','FI','278583433','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:50:55',0,'2014-03-10 14:37:47'),(20174,20824,'0000-00-00','ET','2',1,NULL,'Jacqueline Rock','FI','280847223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:11',0,'2014-03-01 18:08:07'),(20565,21215,'0000-00-00','ET','2',2,1,'Elizabeth Beam','FI','460874299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:27',0,'2014-03-02 07:17:36'),(21413,22063,'0000-00-00','ET','2',1,NULL,'ALICIA N HARVEY PEACE','FI','463597272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:19',0,'2014-03-03 21:25:18'),(16891,17541,'0000-00-00','ET','2',1,NULL,'HEIDI NGUYEN','FI','586383419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:21',0,'2014-03-02 06:24:38'),(4972,4972,'2014-01-01','ET','2',2,1,'Eric Wheeler','FI','269929295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:05',0,'2014-03-01 15:31:33'),(17805,18455,'0000-00-00','ET','2',3,2,'Shanna Chamberlain','FI','257576096','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:38',0,'2014-03-01 16:56:22'),(17905,18555,'0000-00-00','ET','2',1,NULL,'Aura Mendez','FI','660144346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:32',0,'2014-03-02 06:38:05'),(18226,18876,'0000-00-00','ET','2',1,NULL,'Amanda J Beaulieu','FI','277783881','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:15',0,'2014-03-10 14:24:38'),(15676,16325,'0000-00-00','ET','2',1,NULL,'SANDRA REYNA','FI','638846143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:32',0,'2014-03-02 05:59:43'),(11358,11358,'2014-01-01','ET','2',1,NULL,'Rick Johnson','FI','450897808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:18',0,'2014-03-02 04:45:37'),(15406,15857,'0000-00-00','ET','2',1,NULL,'Timothy B White','FI','284621624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:14',0,'2014-03-02 05:59:43'),(15105,15556,'0000-00-00','ET','2',1,NULL,'Jasmine Spotswood','FI','499903573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:05:53',0,'2014-03-02 05:52:31'),(2590,2590,'2014-01-01','ET','2',1,NULL,'Noel Thomas','FI','229319036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:39',0,'2014-03-01 19:11:03'),(11240,11240,'2014-01-01','ET','2',1,NULL,'Valerie A Burkard','FI','277581258','Dental Care Plus, Inc.','FI','311185262','Randall L Spaulding','94','1854940','348','2014-02-01','Sync Success',0,'2013-12-27 02:01:40',0,'2014-03-01 16:23:43'),(4716,4716,'2014-01-01','ET','2',1,NULL,'Mary JANE Erard','FI','288604528','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:12',0,'2014-03-10 13:45:57'),(10776,10776,'2014-01-01','ET','2',1,NULL,'David Michael Hyde','FI','438800005','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:07',0,'2014-03-02 04:24:47'),(6402,6402,'2014-01-01','ET','2',1,NULL,'Michael BROOKS','FI','292747529','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:31',0,'2014-03-10 13:39:10'),(14546,14997,'2014-01-01','ET','2',1,NULL,'Eric Brannigan','FI','595609177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:15',0,'2014-03-02 05:45:37'),(19072,19722,'0000-00-00','ET','2',1,NULL,'Colleen Sue McCarthy','FI','312661913','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:23',0,'2014-03-02 06:52:12'),(22553,23203,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:48',0,'2014-03-10 16:44:18'),(14821,15272,'2014-01-01','ET','2',1,NULL,'James Kimbrell','FI','309985010','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:13',0,'2014-03-10 14:03:26'),(11154,11154,'2014-01-01','ET','2',1,NULL,'Joseph Ramps','FI','280507138','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:02',0,'2014-03-10 13:45:57'),(10916,10916,'2014-01-01','ET','2',1,NULL,'David Moore','FI','241553404','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:10',0,'2014-03-10 16:03:49'),(781,781,'2014-01-01','ET','2',1,NULL,'Sarah Collins','FI','285904879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:29',0,'2014-03-01 15:05:09'),(1106,1106,'2014-01-01','ET','2',2,1,'marlo silver','FI','544663136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:16',0,'2014-03-10 15:39:19'),(14173,14624,'2014-01-01','ET','2',1,NULL,'Janice Hein','FI','279568013','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Harkleroad','94','1772711','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:22',0,'2014-03-10 16:17:47'),(6038,6038,'2014-01-01','ET','2',1,NULL,'Timothy Schroer','FI','293824845','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:09',0,'2014-03-10 13:03:33'),(13018,13018,'2014-01-01','ET','2',1,NULL,'CYNTHIA FUSSELMAN','FI','293683736','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:54',0,'2014-03-10 16:10:34'),(2317,2317,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:47',0,'2014-03-10 13:03:33'),(17693,18343,'0000-00-00','ET','2',1,NULL,'PAMELA CARNAHAN','FI','295521099','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-08 19:30:03',0,'2014-03-10 14:24:38'),(17971,18621,'0000-00-00','ET','2',1,NULL,'Gina Gleason','FI','645034059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:19',0,'2014-03-02 06:31:45'),(22065,22715,'0000-00-00','ET','2',1,NULL,'Rico J Cox','FI','288704543','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:40',0,'2014-03-10 14:45:25'),(1173,1173,'2014-01-01','ET','2',1,NULL,'kimberly williams','FI','427459587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:55',0,'2014-03-02 04:38:08'),(17567,18217,'0000-00-00','ET','2',2,1,'ELIZABETH CHEN DIEU','FI','567935570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:46',0,'2014-03-02 06:31:45'),(16940,17590,'0000-00-00','ET','2',3,2,'Gregory Newell','FI','277700100','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:52',0,'2014-03-10 14:20:26'),(1724,1724,'2014-01-01','ET','2',1,NULL,'RICHSON ADU','FI','286067864','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:13',0,'2014-03-01 15:31:33'),(16417,17067,'0000-00-00','ET','2',1,NULL,'David Jones','FI','281829789','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:37',0,'2014-03-10 14:20:26'),(13324,13680,'2014-01-01','ET','2',1,NULL,'Thomas Aurelia','FI','165440298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:21',0,'2014-03-02 05:24:45'),(5441,5441,'2014-01-01','ET','2',1,0,'Jennifer Bracken','FI','193620839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 01:31:42',0,'2014-03-01 15:05:09'),(638,638,'2014-01-01','ET','2',1,NULL,'Carl Chapin','FI','458253694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:50',0,'2014-03-02 02:10:49'),(14928,15379,'2014-01-01','ET','2',1,NULL,'jessica llewellyn','FI','297863940','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:37',0,'2014-03-01 16:50:53'),(11382,11382,'2014-01-01','ET','2',1,NULL,'theo paparodis','FI','268507901','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:05:59',0,'2014-03-10 13:52:32'),(14849,15300,'2014-01-01','ET','2',1,NULL,'Margaret Weirich','FI','284508552','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:31',0,'2014-03-10 14:10:12'),(12357,12357,'2014-01-01','ET','2',1,NULL,'Patricia Bean','FI','464907321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:06',0,'2014-03-02 05:03:29'),(11841,11841,'2014-01-01','ET','2',2,1,'CHARLES JONES','FI','092408370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:27',0,'2014-03-10 13:45:57'),(3534,3534,'2014-01-01','ET','2',1,NULL,'Karen Bond','FI','282604372','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:17',0,'2014-03-01 15:37:30'),(3771,3771,'2014-01-01','ET','2',1,NULL,'Laura Lozano','FI','631077538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:22',0,'2014-03-01 23:10:52'),(20384,21034,'0000-00-00','ET','2',1,NULL,'William E Parrish','FI','466691590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:13',0,'2014-03-02 07:03:25'),(21215,21865,'0000-00-00','ET','2',1,NULL,'Joyce Giovannelli','FI','193566685','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 19:00:12',0,'2014-03-10 16:38:05'),(21774,22424,'0000-00-00','ET','2',1,NULL,'Laura Nelson Harrington','FI','511625671','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:41',0,'2014-03-10 14:45:25'),(21962,22612,'0000-00-00','ET','2',1,NULL,'Crystal Hardnett','FI','435576802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:27',0,'2014-03-05 22:27:33'),(16223,16872,'0000-00-00','ET','2',1,NULL,'Rebecca Medina','FI','451966324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:55',0,'2014-03-02 06:10:30'),(1327,1327,'2014-01-01','ET','2',1,NULL,'Virginia martin Goetz','FI','250134717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:41',0,'2014-03-02 04:38:08'),(10587,10587,'2014-01-01','ET','2',1,NULL,'Erikalin Ashton','FI','223132719','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:56:45',0,'2014-03-02 04:24:47'),(16087,16736,'0000-00-00','ET','2',1,NULL,'LYNETTE ZIEBRO','FI','273449532','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:07',0,'2014-03-01 16:56:22'),(14189,14640,'2014-01-01','ET','2',1,NULL,'ray collie','FI','287844118','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:32',0,'2014-03-10 14:03:26'),(13140,13496,'2014-01-01','ET','2',4,3,'Young Jin','FI','281686434','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:29',0,'2014-03-10 13:59:38'),(12446,12446,'2014-01-01','ET','2',1,NULL,'LARONDA ROBINSON','FI','438752830','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:21',0,'2014-03-02 05:03:29'),(12074,12074,'2014-01-01','ET','2',1,NULL,'Sasidhar Pullalarevu','FI','177808485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:04:50',0,'2014-03-01 16:30:17'),(18762,19412,'0000-00-00','ET','2',1,NULL,'MARLENE WEYAND','FI','449861657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:38',0,'2014-03-02 06:52:12'),(21443,22093,'0000-00-00','ET','2',1,NULL,'Dennis Strayer','FI','270506697','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:13',0,'2014-03-10 16:44:18'),(22731,23381,'0000-00-00','ET','2',1,NULL,'Melanie Pepin','FI','366783957','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:21',0,'2014-03-10 14:50:59'),(16789,17439,'0000-00-00','ET','2',2,1,'Tien Le','FI','289924402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:34',0,'2014-03-01 17:00:58'),(15644,16293,'0000-00-00','ET','2',2,1,'TINA  L  FLEISHER','FI','284700996','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:07',0,'2014-03-01 16:56:22'),(5056,5056,'2014-01-01','ET','2',1,NULL,'KEVIN BAILOSKY','FI','283862692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:48',0,'2014-03-01 15:31:33'),(4284,4284,'2014-01-01','ET','2',1,NULL,'Dexter White','FI','439048644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:50',0,'2014-03-02 04:10:25'),(3509,3509,'2014-01-01','ET','2',1,NULL,'Vicky Groflo','FI','282460626','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3345388','348','2014-01-01','Sync Success',0,'2013-12-25 22:01:31',0,'2014-03-01 15:37:30'),(3419,3419,'2014-01-01','ET','2',2,1,'Jason M Grant','FI','295564426','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:18',0,'2014-03-10 13:24:34'),(12353,12353,'2014-01-01','ET','2',1,NULL,'Gary Maier','FI','456574484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:59',0,'2014-03-02 05:03:29'),(13953,14309,'2014-01-01','ET','2',4,3,'DAWN DUFRESNE','FI','274809638','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:36',0,'2014-03-10 14:03:26'),(14809,15260,'2014-01-01','ET','2',1,NULL,'laura zodnik','FI','272648267','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:03',0,'2014-03-10 16:17:47'),(20362,21012,'0000-00-00','ET','2',1,NULL,'Jenalyn Elgarm','FI','431410445','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-02-26 08:30:48',0,'2014-03-02 07:03:25'),(11397,11397,'2014-01-01','ET','2',1,NULL,'Amy Kirkbride','FI','286442295','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:28',0,'2014-03-10 13:52:32'),(1188,1188,'2014-01-01','ET','2',1,NULL,'Devan Spears','FI','438311938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:24',0,'2014-03-02 04:45:37'),(17261,17911,'0000-00-00','ET','2',2,1,'Abebe Belew','FI','637986262','Starmount Life Insurance Company','FI','720977315','Archer  Summers','94','16993399','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:36',0,'2014-03-02 06:24:38'),(17249,17899,'0000-00-00','ET','2',6,5,'SHARIQ SAMI','FI','447049023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:31',0,'2014-03-01 17:20:55'),(13002,13002,'2014-01-01','ET','2',1,NULL,'Laurie Olcheski','FI','139567716','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:11',0,'2014-03-02 05:17:40'),(12939,12939,'2014-01-01','ET','2',2,1,'James Bloomfield','FI','272607979','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2014-01-04 06:00:06',0,'2014-03-01 15:48:04'),(5064,5064,'2014-01-01','ET','2',1,NULL,'Irene Motto','FI','282529162','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:02',0,'2014-03-01 15:31:33'),(19286,19936,'0000-00-00','ET','2',1,NULL,'Richard  A LaFargue','FI','436217266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:09',0,'2014-03-02 06:59:07'),(17109,17759,'0000-00-00','ET','2',1,NULL,'Mark Dershimer','FI','291429072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:06',0,'2014-03-01 17:20:55'),(6266,6266,'2014-01-01','ET','2',2,1,'Donald Johnson','FI','435557662','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:25',0,'2014-03-02 04:10:25'),(4152,4152,'2014-01-01','ET','2',1,NULL,'Nancy Props','FI','298484460','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:44',0,'2014-03-10 15:59:47'),(3457,3457,'2014-01-01','ET','2',1,NULL,'Robin Biggert','94','0000896951','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 21:53:35',NULL,NULL),(20598,21248,'0000-00-00','ET','2',1,NULL,'Shirley S Garringer','FI','280509930','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:47',0,'2014-03-01 18:08:07'),(16078,16727,'0000-00-00','ET','2',1,NULL,'Douglas Barletto','FI','277543317','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:02',0,'2014-03-01 16:56:22'),(15880,16529,'0000-00-00','ET','2',1,NULL,'DEBRA A MEYERS','FI','163385638','Summa Insurance Company, Inc.','FI','341809108','RANDY  ECREMENT','94','2827079','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:00',0,'2014-03-10 16:24:30'),(7589,7589,'2014-01-01','ET','2',1,NULL,'SHANNON JO GILBERT','FI','426670985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:59',0,'2014-03-02 04:10:25'),(13690,14046,'2014-01-01','ET','2',1,NULL,'tammy bennington','FI','302669060','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:34',0,'2014-03-10 13:59:38'),(7277,7277,'2014-01-01','ET','2',1,NULL,'Van Alan Smart','FI','293542796','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:01',0,'2014-03-10 13:32:15'),(12767,12767,'2014-01-01','ET','2',1,NULL,'jeanette cox','FI','421666026','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:23',0,'2014-03-10 13:59:38'),(18282,18932,'0000-00-00','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:12',0,'2014-03-10 14:24:38'),(19134,19784,'0000-00-00','ET','2',2,1,'kim phifer','FI','269706296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:09',0,'2014-03-01 17:34:07'),(19274,19924,'0000-00-00','ET','2',1,NULL,'Nasra I Ayoup','FI','659206314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:16',0,'2014-03-02 06:52:12'),(20102,20752,'0000-00-00','ET','2',2,1,'Melanie Jackson','FI','434418661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:21',0,'2014-03-02 07:10:28'),(722,722,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:29',0,'2014-03-10 13:24:34'),(13443,13799,'2014-01-01','ET','2',2,1,'sadaqat khan','FI','602683133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:14',0,'2014-03-02 05:31:31'),(2830,2830,'2014-01-01','ET','2',2,1,'Charles Dearman','FI','587642494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:18',0,'2014-03-02 04:15:49'),(10767,10767,'2014-01-01','ET','2',1,NULL,'Phuong Nguyen','FI','435792045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:50',0,'2014-03-02 04:24:47'),(12440,12440,'2014-01-01','ET','2',1,NULL,'Anita Hart','FI','435357709','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:08',0,'2014-03-02 05:03:29'),(3595,3595,'2014-01-01','ET','2',2,1,'DEBRA  SPIES','FI','464066070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:10',0,'2014-03-02 01:10:33'),(7083,7083,'2014-01-01','ET','2',1,NULL,'Arlene Blessing','FI','288684491','Dental Care Plus, Inc.','FI','311185262','Randy   Jones','94','516531','348','2014-01-01','Sync Success',0,'2013-12-26 04:03:07',0,'2014-03-01 15:52:44'),(6251,6251,'2014-01-01','ET','2',1,NULL,'Felicia Reynolds','FI','436135658','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:58',0,'2014-03-02 04:10:25'),(6193,6193,'2014-01-01','ET','2',1,NULL,'Timothy Reed','FI','636167595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:06',0,'2014-03-02 04:10:25'),(20793,21443,'0000-00-00','ET','2',1,NULL,'mandy fugate','FI','290744698','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:55',0,'2014-03-10 16:38:05'),(15435,15886,'0000-00-00','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:32',0,'2014-03-10 16:17:47'),(11458,11458,'2014-01-01','ET','2',1,NULL,'EDWARD BREWER','FI','282785475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:25',0,'2014-03-01 16:30:17'),(10892,10892,'2014-01-01','ET','2',1,NULL,'Leslie Lazard','FI','434953562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:22',0,'2014-03-02 04:24:47'),(13105,13461,'2014-01-01','ET','2',2,1,'DIAMANTINA MONTOYA','FI','456657931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:12',0,'2014-03-02 05:17:40'),(3719,3719,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:10',0,'2014-03-10 13:20:27'),(18311,18961,'0000-00-00','ET','2',1,NULL,'Debra Bryant','FI','286507627','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:13',0,'2014-03-10 16:31:33'),(18593,19243,'0000-00-00','ET','2',1,NULL,'Karen Gillespie','FI','272843517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:28',0,'2014-03-01 17:26:36'),(19067,19717,'0000-00-00','ET','2',1,NULL,'Vicki Rogers','FI','434572938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:20',0,'2014-03-02 06:52:12'),(20240,20890,'0000-00-00','ET','2',1,NULL,'Mary Shumway','FI','272440453','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:01',0,'2014-03-10 14:37:47'),(22039,22689,'0000-00-00','ET','2',1,NULL,'Bruce Zaccagnini','FI','280587712','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:20',0,'2014-03-10 16:44:18'),(16621,17271,'0000-00-00','ET','2',1,NULL,'Frances Lester','FI','466635953','Starmount Life Insurance Company','FI','720977315','Humayun  Afzal','94','1307168','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:21',0,'2014-03-02 06:17:30'),(1353,1353,'2014-01-01','ET','2',1,NULL,'Tony Urive','FI','449559226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:32',0,'2014-03-02 04:38:08'),(11228,11228,'2014-01-01','ET','2',1,NULL,'Dionne Pope','FI','268764214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:01:18',0,'2014-03-01 16:23:43'),(15729,16378,'0000-00-00','ET','2',2,1,'DEBBIE SMITH','FI','438133616','Starmount Life Insurance Company','FI','720977315','KIMBERLY  HUDSON','94','9055824','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:08',0,'2014-03-02 05:59:43'),(20786,21436,'0000-00-00','ET','2',2,1,'Autumn Terry','FI','494763464','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:52',0,'2014-03-10 16:38:05'),(5680,5680,'2014-01-01','ET','2',1,NULL,'Donald Christoff','FI','301467074','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:28',0,'2014-03-10 13:52:32'),(4459,4459,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:43',0,'2014-03-01 15:16:37'),(2717,2717,'2014-01-01','ET','2',1,NULL,'Angela Lee','FI','434295841','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-25 21:17:44',0,'2014-03-02 04:15:49'),(19218,19868,'0000-00-00','ET','2',1,NULL,'Elizabeth Bandy','FI','298687198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:15',0,'2014-03-01 17:34:07'),(19257,19907,'0000-00-00','ET','2',1,NULL,'janet green','FI','294444029','Summa Insurance Company, Inc.','FI','341809108','thomas   rice','94','8267754','348','2014-04-01','Sync Success',0,'2014-02-17 19:00:02',0,'2014-03-10 16:31:33'),(21037,21687,'0000-00-00','ET','2',1,NULL,'Harriet Jefferson','FI','284460089','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 21:00:27',0,'2014-03-01 18:10:11'),(21823,22473,'0000-00-00','ET','2',1,NULL,'Bentley M Peterson','94','0000647126','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:19',0,'2014-03-05 21:36:22'),(22359,23009,'0000-00-00','ET','2',1,NULL,'ibrahim habli','94','0000971518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:15',0,'2014-03-07 21:36:32'),(11470,11470,'2014-01-01','ET','2',1,NULL,'Hassan Ali','FI','610587379','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:45',0,'2014-03-01 16:30:17'),(17801,18451,'0000-00-00','ET','2',1,NULL,'Didar singh rai','FI','104728150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:34',0,'2014-03-01 16:50:53'),(10717,10717,'2014-01-01','ET','2',1,NULL,'DIANA KOHR','FI','274542984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:01:07',0,'2014-03-01 16:10:36'),(15032,15483,'2014-01-01','ET','2',1,NULL,'James Gilleland','FI','426967946','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','348','2014-03-01','Sync Success',0,'2014-01-17 03:36:23',0,'2014-03-02 05:52:31'),(7320,7320,'2014-01-01','ET','2',1,NULL,'Sheila Vajen','FI','279589822','HealthSpan','FI','311431434','Brooke J Bowerman','94','1854510','348','2014-01-01','Sync Success',0,'2013-12-26 04:10:19',0,'2014-03-10 13:32:15'),(14475,14926,'2014-01-01','ET','2',2,1,'Patricia Lord','FI','264177455','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:41',0,'2014-03-10 16:17:47'),(6155,6155,'2014-01-01','ET','2',1,NULL,'janet miranda miranda','FI','832450003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:00',0,'2014-03-02 04:10:25'),(18944,19594,'0000-00-00','ET','2',2,1,'michael wray gipe','FI','300709879','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:33',0,'2014-03-10 16:31:33'),(22235,22885,'0000-00-00','ET','2',1,NULL,'Janice Marie Smith','FI','426337150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:06',0,'2014-03-06 21:27:26'),(12746,12746,'2014-01-01','ET','2',1,NULL,'Cindy Sattler','FI','291585223','HealthSpan','FI','311431434','stephen  saenz','94','10572730','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:33',0,'2014-03-10 13:59:38'),(17966,18616,'0000-00-00','ET','2',1,NULL,'Amy Winters','FI','282880534','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:15',0,'2014-03-01 17:26:36'),(1264,1264,'2014-01-01','ET','2',1,NULL,'BENJAMIN DAVIS','FI','298883077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:37',0,'2014-03-01 16:15:39'),(10511,10511,'2014-01-01','ET','2',1,NULL,'Kendrick Olsheski','FI','627129142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:12',0,'2014-03-02 04:15:49'),(16704,17354,'0000-00-00','ET','2',1,NULL,'Annette Rickett','FI','288523228','Dental Care Plus, Inc.','FI','311185262','Adam  Hyers','94','2449599','357','2014-01-01','Sync Success',0,'2014-01-31 21:01:20',0,'2014-03-01 17:00:58'),(1840,1840,'2014-01-01','ET','2',1,NULL,'tighe yates','FI','529799626','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:58',0,'2014-03-10 13:20:27'),(4401,4401,'2014-01-01','ET','2',1,NULL,'ANN SANDERS','FI','287606048','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:58',0,'2014-03-10 15:39:19'),(17681,18331,'0000-00-00','ET','2',1,NULL,'John Jacobs','FI','279505431','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:54',0,'2014-03-10 16:24:30'),(16994,17644,'0000-00-00','ET','2',1,NULL,'robert sabel','FI','275608273','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:27',0,'2014-03-10 14:20:26'),(3543,3543,'2014-01-01','ET','2',1,NULL,'ROBERT BAYSORE','FI','280500076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:34',0,'2014-03-01 15:37:30'),(2154,2154,'2014-01-01','ET','2',1,NULL,'Mary Place','FI','502769156','Starmount Life Insurance Company','FI','720977315','Don  Henry','94','7837890','348','2014-01-01','Sync Success',0,'2013-12-25 19:46:36',0,'2014-03-01 21:11:04'),(18655,19305,'0000-00-00','ET','2',1,NULL,'VERONICA RAMIREZ','FI','451692218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:17',0,'2014-03-02 06:45:14'),(19470,20120,'0000-00-00','ET','2',1,NULL,'Ricardo Ramirez','FI','454815649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-20 03:52:33',0,'2014-03-02 06:59:07'),(3086,3086,'2014-01-01','ET','2',1,NULL,'Debra  Oneal','FI','436291895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:47',0,'2014-03-02 01:10:33'),(17991,18641,'0000-00-00','ET','2',1,NULL,'Lisa Luong','FI','409634863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:33',0,'2014-03-02 06:38:05'),(15450,15901,'0000-00-00','ET','2',2,1,'Angel Michelle-Harris Saltzman','FI','636286159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:41',0,'2014-03-02 05:59:43'),(5557,5557,'2014-01-01','ET','2',1,NULL,'Ricardo Cruz','FI','453897695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:16',0,'2014-03-02 04:45:37'),(2676,2676,'2014-01-01','ET','2',1,NULL,'Angelita Aguilar','FI','457159622','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:25',0,'2014-03-02 04:15:49'),(21913,22563,'0000-00-00','ET','2',1,NULL,'Gloria Hernandez','FI','460907294','Starmount Life Insurance Company','FI','720977315','Danielle  Abbott','94','16964484','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:53',0,'2014-03-05 22:27:33'),(22560,23210,'0000-00-00','ET','2',1,NULL,'DANIEL L BOOTH','FI','281726358','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN  P KELLY','94','2516200','348','2014-05-01','Sync Success',0,'2014-03-07 21:31:53',0,'2014-03-10 16:44:18'),(17473,18123,'0000-00-00','ET','2',1,NULL,'SANDRA BORDELON','FI','437232669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:32',0,'2014-03-02 06:24:38'),(1541,1541,'2014-01-01','ET','2',1,NULL,'David Sartin','FI','290883685','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:38',0,'2014-03-10 13:52:32'),(1634,1634,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:02',0,'2014-03-01 20:10:57'),(1948,1948,'2014-01-01','ET','2',1,NULL,'Patsy J Goddard','FI','295524635','Dental Care Plus, Inc.','FI','311185262','James  Dillon','94','1921787','348','2014-01-01','Sync Success',0,'2013-12-25 19:33:10',0,'2014-03-01 15:26:40'),(15124,15575,'0000-00-00','ET','2',1,NULL,'Tonya Andrews','FI','270789489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:06:07',0,'2014-03-01 16:50:53'),(12347,12347,'2014-01-01','ET','2',1,NULL,'WILLIAM C WILLIS','FI','567137966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:48',0,'2014-03-02 05:03:29'),(3702,3702,'2014-01-01','ET','2',1,NULL,'Dave Murdoch','FI','438880021','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:34',0,'2014-03-02 01:10:33'),(13419,13775,'2014-01-01','ET','2',1,NULL,'REGENIA TORREY','FI','427433117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:03',0,'2014-03-02 05:24:45'),(5733,5733,'2014-01-01','ET','2',1,NULL,'Gary D Weaver','FI','460984313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:24',0,'2014-03-01 15:48:04'),(14384,14835,'2014-01-01','ET','2',1,NULL,'Shamecka Nelson','FI','404085979','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:59',0,'2014-03-01 16:46:19'),(18767,19417,'0000-00-00','ET','2',1,NULL,'MARIE MURREY','FI','281788793','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:42',0,'2014-03-10 14:31:05'),(5387,5387,'2014-01-01','ET','2',1,NULL,'Scott William Clark','FI','228152467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:06',0,'2014-03-01 21:11:04'),(5555,5555,'2014-01-01','ET','2',1,NULL,'jose rojas','FI','633521559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:13',0,'2014-03-02 04:45:37'),(11507,11507,'2014-01-01','ET','2',1,NULL,'Jessie Silas','FI','587191725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:52',0,'2014-03-02 04:52:44'),(21069,21719,'0000-00-00','ET','2',1,NULL,'kevin holloway','FI','271829705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:26',0,'2014-03-01 18:10:11'),(18950,19600,'0000-00-00','ET','2',1,NULL,'Robert V Dible','FI','302602693','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-14 21:31:38',0,'2014-03-10 14:31:05'),(223,223,'2014-01-01','ET','2',1,NULL,'Bessie Turner','FI','268568220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:22:04',0,'2014-03-10 13:10:24'),(479,479,'2014-01-01','ET','2',1,NULL,'Erica Morris','FI','302841214','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 17:51:00',0,'2014-03-10 13:10:24'),(16966,17616,'0000-00-00','ET','2',3,2,'MARC L BLESSING','FI','303560627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:09',0,'2014-03-01 17:00:58'),(526,526,'2014-01-01','ET','2',1,NULL,'Gary Churchill','FI','298466825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:13',0,'2014-03-01 15:48:04'),(16825,17475,'0000-00-00','ET','2',1,NULL,'reneka washington','FI','436496863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:10',0,'2014-03-02 06:17:30'),(16735,17385,'0000-00-00','ET','2',4,3,'Stacy L Patel','FI','405042899','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:42',0,'2014-03-10 14:20:26'),(15443,15894,'0000-00-00','ET','2',1,NULL,'Shelly Holmes','FI','298543229','Summa Insurance Company, Inc.','FI','341809108','gary  bologna','94','1795854','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:37',0,'2014-03-10 16:17:47'),(14015,14371,'2014-01-01','ET','2',1,NULL,'DANIEL DAVIDSON','FI','207503411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:41',0,'2014-03-01 16:40:16'),(21304,21954,'0000-00-00','ET','2',1,NULL,'Barbara Louise Card','FI','298481930','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:09',0,'2014-03-10 16:38:05'),(14958,15409,'2014-01-01','ET','2',1,NULL,'RONALD SAYRE','FI','271528671','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:52',0,'2014-03-10 14:10:12'),(11976,11976,'2014-01-01','ET','2',1,NULL,'Diana Molina','FI','509060907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:13',0,'2014-03-02 05:03:29'),(3979,3979,'2014-01-01','ET','2',2,1,'TODD CURRY','FI','436066177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:31',0,'2014-03-01 23:10:52'),(5976,5976,'2014-01-01','ET','2',1,NULL,'Staci Lowell','FI','279906319','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:14',0,'2014-03-10 15:52:36'),(13757,14113,'2014-01-01','ET','2',1,NULL,'Benjamin Gullett','FI','292802004','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:19',0,'2014-03-10 13:59:38'),(1209,1209,'2014-01-01','ET','2',1,NULL,'matt kochersperger','FI','285785071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:48:03',0,'2014-03-01 16:15:39'),(16782,17432,'0000-00-00','ET','2',1,NULL,'REX ROSE','FI','266375092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:30',0,'2014-03-02 06:17:30'),(4154,4154,'2014-01-01','ET','2',2,1,'BONNIE JONES','FI','268663081','Summa Insurance Company, Inc.','FI','341809108','LAWRENCE  KACZMAREK','94','313913','348','2014-01-01','Sync Success',0,'2013-12-25 23:04:49',0,'2014-03-10 15:59:47'),(5109,5109,'2014-01-01','ET','2',1,NULL,'Robin Raitz','FI','302741334','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:29',0,'2014-03-10 13:20:27'),(1674,1674,'2014-01-01','ET','2',1,NULL,'Yolanda Rios','FI','154653187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:15:40',0,'2014-03-02 00:10:48'),(5304,5304,'2014-01-01','ET','2',1,NULL,'DONNA NELSON','FI','270687140','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:36',0,'2014-03-01 15:05:09'),(20197,20847,'0000-00-00','ET','2',1,NULL,'shannon jackson','FI','633200169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:29',0,'2014-03-02 07:10:28'),(5593,5593,'2014-01-01','ET','2',1,NULL,'Damon Muhammad','FI','565435003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:28',0,'2014-03-02 04:45:37'),(20165,20815,'0000-00-00','ET','2',1,NULL,'Catherine Catania','FI','283863556','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','357','2014-03-31','Sync Success',0,'2014-02-25 21:31:05',0,'2014-03-01 18:08:07'),(18193,18843,'0000-00-00','ET','2',1,NULL,'TERRI EVANS','FI','206442505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:47',0,'2014-03-01 17:26:36'),(10639,10639,'2014-01-01','ET','2',2,1,'Christina K Wreyford','FI','639785749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:27',0,'2014-03-02 04:31:46'),(11229,11229,'2014-01-01','ET','2',1,NULL,'ANTHONY COLEMAN','FI','298663185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:19',0,'2014-03-01 16:23:43'),(11522,11522,'2014-01-01','ET','2',1,NULL,'Anita Levy','FI','435410750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:18',0,'2014-03-02 04:52:44'),(18137,18787,'0000-00-00','ET','2',1,NULL,'Taylor Teresa Arroyo-Tabin','FI','607402617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:05',0,'2014-03-02 06:38:05'),(12020,12020,'2014-01-01','ET','2',1,NULL,'Jamie English','FI','433377134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:02:51',0,'2014-03-02 04:59:36'),(12498,12498,'2014-01-01','ET','2',1,NULL,'Elizabeth Gaspard','FI','439359511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:18',0,'2014-03-02 05:03:29'),(14011,14367,'2014-01-01','ET','2',1,NULL,'DANIEL DORDICK','FI','130707015','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:38',0,'2014-03-01 16:40:16'),(20558,21208,'0000-00-00','ET','2',1,NULL,'SHIRLEY BROWN','FI','458596370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:21',0,'2014-03-02 07:17:36'),(22741,23391,'0000-00-00','ET','2',1,NULL,'Debra Raby','FI','435332689','Starmount Life Insurance Company','FI','720977315','Patrick  Tyson','94','7409844','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:04',0,'2014-03-09 21:26:00'),(17033,17683,'0000-00-00','ET','2',1,NULL,'TAKASHIA SHAW','FI','435590358','Starmount Life Insurance Company','FI','720977315','MICHAEL  KIRSCHMAN','94','171145428','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:20',0,'2014-03-02 06:24:38'),(15926,16575,'0000-00-00','ET','2',1,NULL,'Eva Shooks','FI','276567899','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:08',0,'2014-03-10 16:24:30'),(14974,15425,'2014-01-01','ET','2',1,NULL,'Mary Simmons','FI','275449782','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:59',0,'2014-03-01 16:50:53'),(4702,4702,'2014-01-01','ET','2',1,NULL,'Billy Washington','FI','439679345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:43',0,'2014-03-02 04:31:46'),(3431,3431,'2014-01-01','ET','2',2,1,'Galen Waits','FI','274481668','HealthSpan','FI','311431434','John  Farlow','94','9538800','348','2014-01-01','Sync Success',0,'2013-12-25 21:52:43',0,'2014-03-10 13:24:34'),(399,399,'2014-01-01','ET','2',1,NULL,'Clyde Corley Medaries','FI','434869788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:21',0,'2014-03-01 22:10:55'),(2562,2562,'2014-01-01','ET','2',1,NULL,'Christopher Good','FI','270844912','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:59',0,'2014-03-10 15:39:19'),(2324,2324,'2014-01-01','ET','2',1,NULL,'Lou Portillo','FI','454962018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:03',0,'2014-03-01 19:11:03'),(2091,2091,'2014-01-01','ET','2',1,NULL,'Jennifer Dostall','FI','299788409','HealthSpan','FI','311431434','brenda  Williams','94','8389118','348','2014-01-01','Sync Success',0,'2013-12-25 19:37:46',0,'2014-03-10 13:20:27'),(21025,21675,'0000-00-00','ET','2',1,NULL,'Kristen Grande','FI','280841299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 21:00:18',0,'2014-03-01 18:10:11'),(17592,18242,'0000-00-00','ET','2',1,NULL,'Connie Conway','FI','313580636','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:01:07',0,'2014-03-10 14:24:38'),(3992,3992,'2014-01-01','ET','2',1,NULL,'James Reagan','FI','225887867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:48:01',0,'2014-03-01 23:10:52'),(4103,4103,'2014-01-01','ET','2',1,NULL,'Peter Trokan','FI','393948788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:20',0,'2014-03-01 16:00:27'),(7020,7020,'2014-01-01','ET','2',2,1,'Mario Quijano','FI','452531467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:06',0,'2014-03-02 03:09:49'),(17073,17723,'0000-00-00','ET','2',1,NULL,'BRENDA FLOWERS','FI','459968919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:43',0,'2014-03-02 06:24:38'),(16684,17334,'0000-00-00','ET','2',1,NULL,'JOHNNY  MORRIS','FI','587052094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:05',0,'2014-03-02 06:17:30'),(15667,16316,'0000-00-00','ET','2',1,NULL,'Nichole Peyton','FI','217049081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:25',0,'2014-03-01 16:56:22'),(14734,15185,'2014-01-01','ET','2',1,NULL,'Michael Newlands','FI','434451695','Starmount Life Insurance Company','FI','720977315','geg  town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:16',0,'2014-03-02 05:45:37'),(11364,11364,'2014-01-01','ET','2',2,1,'Candelario Gutierrez','FI','460922469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:27',0,'2014-03-02 04:52:44'),(14540,14991,'2014-01-01','ET','2',3,2,'ELIZABETH ROSENBROOK','FI','302620056','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:12',0,'2014-03-10 14:03:26'),(2378,2378,'2014-01-01','ET','2',1,NULL,'Jamal Fletcher','FI','636224425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:35',0,'2014-03-01 23:10:52'),(2471,2471,'2014-01-01','ET','2',1,NULL,'Lisa Alexander','FI','434172850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:34',0,'2014-03-01 23:10:52'),(19944,20594,'0000-00-00','ET','2',1,NULL,'Joyce  Chang','FI','602641189','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:10',0,'2014-03-02 07:03:25'),(2910,2910,'2014-01-01','ET','2',2,1,'Sandra McNeil','FI','427062422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:15',0,'2014-03-02 01:10:33'),(11030,11030,'2014-01-01','ET','2',1,NULL,'Scott Eckroad','FI','298828128','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:48',0,'2014-03-10 13:45:57'),(3178,3178,'2014-01-01','ET','2',1,NULL,'Patsy McKee','FI','300526016','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:47',0,'2014-03-10 13:24:34'),(4085,4085,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:51',0,'2014-03-01 16:00:27'),(3860,3860,'2014-01-01','ET','2',1,0,'John Farmer','FI','436737329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:57',0,'2014-03-01 19:11:03'),(20787,21437,'0000-00-00','ET','2',1,NULL,'Gail W Spade','FI','273506070','Summa Insurance Company, Inc.','FI','341809108','Lori  Magey','94','14928240','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:53',0,'2014-03-10 16:38:05'),(20801,21451,'0000-00-00','ET','2',1,NULL,'Catherine Bean','FI','230021219','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:59',0,'2014-03-02 07:17:36'),(22426,23076,'0000-00-00','ET','2',1,NULL,'rodrick bell','FI','459197182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:18',0,'2014-03-07 22:26:59'),(19741,20391,'0000-00-00','ET','2',4,3,'DANETTE MARTIN','FI','273843364','HealthSpan','FI','311431434','JOE  WORLIND','94','1967646','348','2014-01-01','Sync Success',0,'2014-02-20 05:40:52',0,'2014-03-10 14:37:47'),(6399,6399,'2014-01-01','ET','2',1,NULL,'Marlene Nichting','FI','288483238','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:27',0,'2014-03-10 13:39:10'),(18793,19443,'0000-00-00','ET','2',1,NULL,'DENNY P FREY','FI','269641662','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:02',0,'2014-03-10 16:31:33'),(550,550,'2014-01-01','ET','2',1,NULL,'Laura M Berry','FI','302708225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:02',0,'2014-03-01 15:48:04'),(17956,18606,'0000-00-00','ET','2',1,NULL,'Margaret Shaw','FI','176429931','Dental Care Plus, Inc.','FI','311185262','roni  bell','94','3345388','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:08',0,'2014-03-01 17:20:55'),(2566,2566,'2014-01-01','ET','2',1,NULL,'Paul W Holmer','FI','270468583','HealthSpan','FI','311431434','Gary L Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 20:32:06',0,'2014-03-10 13:03:33'),(3634,3634,'2014-01-01','ET','2',1,NULL,'gary miller','FI','270706049','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:25',0,'2014-03-10 15:52:36'),(7021,7021,'2014-01-01','ET','2',1,NULL,'Aurelia Nelms','FI','455176418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:08',0,'2014-03-02 03:09:49'),(10436,10436,'2014-01-01','ET','2',1,NULL,'reid abriani','FI','282882146','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:49',0,'2014-03-01 16:10:36'),(15109,15560,'0000-00-00','ET','2',1,NULL,'yanett harvey','FI','636848767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:56',0,'2014-03-02 05:52:31'),(1341,1341,'2014-01-01','ET','2',2,1,'TANNER STEGMAN','FI','585618435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:06',0,'2014-03-02 04:38:08'),(20684,21334,'0000-00-00','ET','2',1,NULL,'Kelotta Holiday','FI','439491579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:04',0,'2014-03-02 07:17:36'),(20388,21038,'0000-00-00','ET','2',2,1,'RASIK PATEL','FI','056768397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:17',0,'2014-03-02 07:03:25'),(17007,17657,'0000-00-00','ET','2',2,1,'Roger Bostelman','FI','291487125','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:37',0,'2014-03-10 14:20:26'),(5041,5041,'2014-01-01','ET','2',1,NULL,'Joyce A Langenbrunner','FI','281423784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:17',0,'2014-03-01 15:31:33'),(14295,14746,'2014-01-01','ET','2',1,NULL,'Marsha Griffith','FI','284689668','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:22',0,'2014-03-01 16:46:19'),(3395,3395,'2014-01-01','ET','2',2,1,'mary musil','94','0000968210','Summa Insurance Company, Inc.','FI','341809108','karen  cavasini','94','1800246','348','2014-01-01','Sync Success',0,'2013-12-25 21:51:30',0,'2014-03-10 15:52:36'),(14031,14387,'2014-01-01','ET','2',1,NULL,'DONALD M STONE','FI','280683701','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:53',0,'2014-03-10 14:03:26'),(11363,11363,'2014-01-01','ET','2',1,NULL,'Richard L Triska','FI','462985016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:25',0,'2014-03-02 04:52:44'),(20968,21618,'0000-00-00','ET','2',1,NULL,'Chris Bencar','FI','272909722','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:18',0,'2014-03-01 18:10:11'),(2574,2574,'2014-01-01','ET','2',1,NULL,'Natasha Ross','FI','300806038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:07',0,'2014-03-01 15:05:09'),(6167,6167,'2014-01-01','ET','2',2,1,'Juan David Valles','FI','459063233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:20',0,'2014-03-02 04:10:25'),(19571,20221,'0000-00-00','ET','2',1,NULL,'Patricia Harris-Carr','FI','299421632','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:23:44',0,'2014-03-10 14:37:47'),(2970,2970,'2014-01-01','ET','2',1,NULL,'Vicki Jo Carey','FI','313587590','Dental Care Plus, Inc.','FI','311185262','Randall  Carey','94','14969438','348','2014-01-01','Sync Success',0,'2013-12-25 21:32:13',0,'2014-03-01 15:37:30'),(19246,19896,'0000-00-00','ET','2',2,1,'DAVID LITTLE','94','0001034715','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:36',0,'2014-03-10 14:31:05'),(10681,10681,'2014-01-01','ET','2',2,1,'Patrick Bartholomew','FI','227491613','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:48',0,'2014-03-01 16:10:36'),(12858,12858,'2014-01-01','ET','2',1,NULL,'JOSEPH LENGEL','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:03:23',0,'2014-03-01 16:35:14'),(18923,19573,'0000-00-00','ET','2',1,NULL,'Tiffany Wiggins','FI','587492639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:18',0,'2014-03-02 06:52:12'),(17332,17982,'0000-00-00','ET','2',1,NULL,'Joey Marshall','FI','428457703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:12',0,'2014-03-02 06:24:38'),(10624,10624,'2014-01-01','ET','2',1,NULL,'Jnae Peterson','FI','461756424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:57',0,'2014-03-02 04:31:46'),(5805,5805,'2014-01-01','ET','2',1,NULL,'Bruce Davis','FI','276525355','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:43',0,'2014-03-10 13:24:34'),(7081,7081,'2014-01-01','ET','2',1,NULL,'Joseph Lawson','FI','299707150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:03',0,'2014-03-01 15:52:44'),(20086,20736,'0000-00-00','ET','2',1,NULL,'KAREN SCOTT','FI','439435656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:07',0,'2014-03-02 07:10:28'),(20621,21271,'0000-00-00','ET','2',1,NULL,'Brandon Lewis','FI','434630234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:03',0,'2014-03-02 07:10:28'),(21977,22627,'0000-00-00','ET','2',1,NULL,'Khambile Mercy Msonthi','FI','740863050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:31:38',0,'2014-03-05 22:27:33'),(18090,18740,'0000-00-00','ET','2',1,NULL,'Yolanda Robles','FI','634343560','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:30',0,'2014-03-02 06:38:05'),(16858,17508,'0000-00-00','ET','2',1,NULL,'Ian Carl','FI','275887355','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:30',0,'2014-03-10 14:20:26'),(468,468,'2014-01-01','ET','2',1,NULL,'Randall Carpenter','94','0000201900','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:36',0,'2014-03-10 13:10:24'),(16210,16859,'0000-00-00','ET','2',1,NULL,'Martha Barranco','FI','463431180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:46',0,'2014-03-02 06:10:30'),(13019,13019,'2014-01-01','ET','2',1,NULL,'LARISA BURLINGAME','FI','276068917','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:56',0,'2014-03-10 16:10:34'),(15520,15971,'0000-00-00','ET','2',1,NULL,'Isabel Serrano','FI','548638452','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:59',0,'2014-03-02 05:59:43'),(1709,1709,'2014-01-01','ET','2',1,NULL,'Lisa Paul','FI','568515118','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:47',0,'2014-03-02 00:10:48'),(4886,4886,'2014-01-01','ET','2',2,1,'Harrison Gibson','FI','403740443','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-26 00:16:50',0,'2014-03-10 13:03:33'),(3974,3974,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:22',0,'2014-03-10 13:10:24'),(19945,20595,'0000-00-00','ET','2',1,NULL,'John Lopez','FI','456255651','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:11',0,'2014-03-02 07:03:25'),(20322,20972,'0000-00-00','ET','2',1,NULL,'Nhien Mai','94','0000830665','Starmount Life Insurance Company','FI','720977315','Daniel  Paul','94','13410051','357','2014-04-01','Sync Success',0,'2014-02-26 08:30:11',0,'2014-03-02 07:03:25'),(21525,22175,'0000-00-00','ET','2',1,NULL,'Elizabeth Rudge','FI','534552977','Starmount Life Insurance Company','FI','720977315','Danielle  Abbott','94','16964484','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:13',0,'2014-03-03 22:26:43'),(21870,22520,'0000-00-00','ET','2',1,NULL,'Edward Fredericy','FI','299567973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:20',0,'2014-03-05 21:36:22'),(19273,19923,'0000-00-00','ET','2',1,NULL,'Allen Darby','FI','437028413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:15',0,'2014-03-02 06:52:12'),(17120,17770,'0000-00-00','ET','2',1,NULL,'Victoria Reyes','94','0000828271','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:12',0,'2014-03-10 14:20:26'),(15511,15962,'0000-00-00','ET','2',1,NULL,'BOBBY HOLMES','FI','451022950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:55',0,'2014-03-02 05:59:43'),(10828,10828,'2014-01-01','ET','2',1,NULL,'Osmin Lemus','FI','437891204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:47',0,'2014-03-02 04:31:46'),(2403,2403,'2014-01-01','ET','2',1,NULL,'Jennifer D Hieronimus','FI','286646015','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:19',0,'2014-03-01 15:26:40'),(10766,10766,'2014-01-01','ET','2',1,NULL,'Patricia Videau','FI','433822403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:48',0,'2014-03-02 04:24:47'),(14921,15372,'2014-01-01','ET','2',2,1,'John Ervin','FI','274662194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:33',0,'2014-03-01 16:50:53'),(14464,14915,'2014-01-01','ET','2',1,NULL,'monique patterson','FI','436278431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:36',0,'2014-03-02 05:45:37'),(22268,22918,'0000-00-00','ET','2',1,NULL,'Jamarr Equel Walker','FI','284905805','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:29',0,'2014-03-10 14:50:59'),(11387,11387,'2014-01-01','ET','2',1,NULL,'David Douglas Smith','FI','587633035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:08',0,'2014-03-02 04:52:44'),(10758,10758,'2014-01-01','ET','2',1,NULL,'Lashawnda Bufford','FI','401113043','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:31',0,'2014-03-01 16:15:39'),(18496,19146,'0000-00-00','ET','2',1,NULL,'angela mutti','FI','286641739','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:06',0,'2014-03-10 16:31:33'),(5324,5324,'2014-01-01','ET','2',1,NULL,'TINA WILSON','FI','428237141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:21',0,'2014-03-01 19:11:03'),(1328,1328,'2014-01-01','ET','2',1,NULL,'Jacob Willetts','FI','644249927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:42',0,'2014-03-02 04:38:08'),(2978,2978,'2014-01-01','ET','2',1,NULL,'KUK HWA BURCHETT','FI','527872916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:29',0,'2014-03-02 01:10:33'),(1500,1500,'2014-01-01','ET','2',1,NULL,'michelle robertswhitehead','FI','273665000','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:23',0,'2014-03-10 13:45:57'),(2765,2765,'2014-01-01','ET','2',1,NULL,'trang tran','FI','301089052','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:12',0,'2014-03-01 16:05:34'),(13962,14318,'2014-01-01','ET','2',1,NULL,'Christopher Bruskotter','FI','297921626','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:42',0,'2014-03-10 14:03:26'),(16163,16812,'0000-00-00','ET','2',1,NULL,'Jeanie Moore','FI','277702539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:15',0,'2014-03-01 16:56:22'),(17223,17873,'0000-00-00','ET','2',1,NULL,'Kristen Moreland','FI','268905189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:17',0,'2014-03-01 17:20:55'),(17401,18051,'0000-00-00','ET','2',1,NULL,'Alicia  Garcia','FI','581279013','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:42',0,'2014-03-01 17:20:55'),(17881,18531,'0000-00-00','ET','2',1,NULL,'Linda Curtis','FI','302447351','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:16',0,'2014-03-10 16:31:33'),(19926,20576,'0000-00-00','ET','2',2,1,'MACHAEL WILHELM','FI','287569894','Dental Care Plus, Inc.','FI','311185262','Beth  Reitler','94','9091870','348','2014-04-01','Sync Success',0,'2014-02-21 21:30:20',0,'2014-03-01 17:47:19'),(20424,21074,'0000-00-00','ET','2',1,NULL,'hannah rose shaferly','94','0000234081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 09:30:45',0,'2014-03-01 18:08:07'),(22002,22652,'0000-00-00','ET','2',4,3,'Heather Clark','94','0000878331','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:54',0,'2014-03-05 21:36:22'),(22047,22697,'0000-00-00','ET','2',1,NULL,'DIANNA SEALE','FI','359467831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:26',0,'2014-03-05 22:27:33'),(11902,11902,'2014-01-01','ET','2',1,NULL,'Elizabeth Rosenberg','FI','269888859','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:05',0,'2014-03-10 16:10:34'),(17888,18538,'0000-00-00','ET','2',2,1,'Carl Edward Morlan','FI','301460455','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:21',0,'2014-03-10 16:31:33'),(10751,10751,'2014-01-01','ET','2',1,NULL,'William Schilling','FI','285409601','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:15',0,'2014-03-01 16:15:39'),(10409,10409,'2014-01-01','ET','2',1,NULL,'David Danner','FI','299649604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:50:59',0,'2014-03-01 16:10:36'),(1995,1995,'2014-01-01','ET','2',1,NULL,'BRENDA PEREZ','FI','605623986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:41',0,'2014-03-01 23:10:52'),(2300,2300,'2014-01-01','ET','2',1,NULL,'ransom jones','FI','455459685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:12',0,'2014-03-01 19:11:03'),(2313,2313,'2014-01-01','ET','2',1,NULL,'lawrence d vaught','FI','235843693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:40',0,'2014-03-01 15:05:09'),(18592,19242,'0000-00-00','ET','2',1,NULL,'BETH WOYSHVILLE','FI','294588375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:27',0,'2014-03-01 17:26:36'),(7624,7624,'2014-01-01','ET','2',1,NULL,'Jonathan Jones','FI','276867738','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:38:03',0,'2014-03-10 15:59:47'),(2549,2549,'2014-01-01','ET','2',1,NULL,'Peggy Wainscott','FI','296526826','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:31',0,'2014-03-01 15:10:22'),(14633,15084,'2014-01-01','ET','2',1,NULL,'scott moore','FI','356524973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:10',0,'2014-03-01 16:46:19'),(20571,21221,'0000-00-00','ET','2',1,NULL,'KENIA ROCHA','FI','640964355','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:31',0,'2014-03-02 07:17:36'),(22489,23139,'0000-00-00','ET','2',1,NULL,'Brenda Bishop','FI','268542249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:03',0,'2014-03-07 21:36:32'),(18119,18769,'0000-00-00','ET','2',1,NULL,'Robert Botello','FI','456905809','Starmount Life Insurance Company','FI','720977315','Christopher  Wang','94','15980657','348','2014-03-01','Sync Success',0,'2014-02-11 21:00:53',0,'2014-03-02 06:38:05'),(17487,18137,'0000-00-00','ET','2',1,NULL,'Sherrie Cacioppo','94','0001045733','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:44',0,'2014-03-10 16:24:30'),(15876,16525,'0000-00-00','ET','2',1,NULL,'Hing Chan','FI','067705112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:58',0,'2014-03-10 16:24:30'),(5588,5588,'2014-01-01','ET','2',2,1,'Javier Reyes Castillo','FI','461258815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:15',0,'2014-03-02 04:45:37'),(2819,2819,'2014-01-01','ET','2',1,NULL,'cornelius james','FI','285624904','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:56',0,'2014-03-10 13:39:10'),(2497,2497,'2014-01-01','ET','2',1,NULL,'jeffery mangas','FI','295604524','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:28',0,'2014-03-10 13:10:24'),(20194,20844,'0000-00-00','ET','2',2,1,'CECILIA ESTRADA','FI','451251643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:26',0,'2014-03-02 07:10:28'),(21721,22371,'0000-00-00','ET','2',1,NULL,'William Michael Droppleman','FI','288580429','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:56',0,'2014-03-10 16:44:18'),(902,902,'2014-01-01','ET','2',1,NULL,'Arnold  G johnson','FI','277480498','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:12',0,'2014-03-01 15:21:15'),(1383,1383,'2014-01-01','ET','2',1,NULL,'floriberto sardina','FI','457998173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:29',0,'2014-03-02 04:45:37'),(1715,1715,'2014-01-01','ET','2',1,NULL,'SHARON K SCOTT','FI','273666820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:58',0,'2014-03-01 15:31:33'),(18605,19255,'0000-00-00','ET','2',1,NULL,'DEBORAH KAY OLSON','FI','302581547','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:39',0,'2014-03-10 16:31:33'),(11463,11463,'2014-01-01','ET','2',1,NULL,'Heather Teresa Nixon','FI','296863296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:33',0,'2014-03-01 16:30:17'),(18421,19071,'0000-00-00','ET','2',1,NULL,'Christine S Fiorello','FI','278461499','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:18',0,'2014-03-01 17:26:36'),(15072,15523,'2014-01-01','ET','2',3,2,'RACHEL E TOPP','FI','296722376','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:41',0,'2014-03-10 14:10:12'),(22206,22856,'0000-00-00','ET','2',2,1,'MYO SAN','FI','303310924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:44',0,'2014-03-06 21:36:23'),(16648,17298,'0000-00-00','ET','2',1,NULL,'Diane Goodman-Daniel','FI','556894266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:39',0,'2014-03-02 06:17:30'),(15058,15509,'2014-01-01','ET','2',1,NULL,'victoria dailey','FI','280520126','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:35',0,'2014-03-10 14:10:12'),(14796,15247,'2014-01-01','ET','2',1,NULL,'Megan Fritz','FI','280880493','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:55',0,'2014-03-10 14:03:26'),(6000,6000,'2014-01-01','ET','2',1,NULL,'Robert Russell','FI','456772618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:34:02',0,'2014-03-02 02:10:49'),(7075,7075,'2014-01-01','ET','2',1,NULL,'Dalaina Fisher','FI','125704468','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:50',0,'2014-03-01 15:52:44'),(10936,10936,'2014-01-01','ET','2',1,NULL,'james huntsman','FI','284522436','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:50',0,'2014-03-10 16:03:49'),(19750,20400,'0000-00-00','ET','2',1,NULL,'Floyd McCarver','FI','295660188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:07',0,'2014-03-01 17:47:19'),(2006,2006,'2014-01-01','ET','2',2,1,'Amanda Sibille','FI','458872358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:03',0,'2014-03-01 23:10:52'),(15035,15486,'2014-01-01','ET','2',1,NULL,'Bambi Penton','FI','439312516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:25',0,'2014-03-02 05:52:31'),(18058,18708,'0000-00-00','ET','2',1,NULL,'LADALE BARREE','FI','460964210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:06',0,'2014-03-02 06:38:05'),(12302,12302,'2014-01-01','ET','2',1,NULL,'William James Barlow','FI','281487772','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:21',0,'2014-03-10 13:59:38'),(12254,12254,'2014-01-01','ET','2',1,NULL,'Shovon Crenshaw','FI','571197949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:34',0,'2014-03-02 05:03:29'),(16854,17504,'0000-00-00','ET','2',1,NULL,'Candice Davis','FI','433671202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:27',0,'2014-03-02 06:17:30'),(7181,7181,'2014-01-01','ET','2',1,NULL,'Brianne Scott','FI','211703657','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-26 04:06:02',0,'2014-03-10 15:59:47'),(16104,16753,'0000-00-00','ET','2',1,NULL,'sandra hartung','FI','287669603','Summa Insurance Company, Inc.','FI','341809108','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:20',0,'2014-03-10 16:24:30'),(21491,22141,'0000-00-00','ET','2',1,NULL,'Dominic Anthony Musarra','FI','292904949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:49',0,'2014-03-03 21:36:16'),(21768,22418,'0000-00-00','ET','2',1,NULL,'Rico J Cox','FI','288704543','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:36',0,'2014-03-10 14:45:25'),(22940,23590,'0000-00-00','ET','2',1,NULL,'James Robinson','FI','288583556','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-10 21:01:10',0,'2014-03-10 21:07:22'),(17200,17850,'0000-00-00','ET','2',1,NULL,'randi batts','FI','627427859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:05',0,'2014-03-02 06:24:38'),(15070,15521,'2014-01-01','ET','2',1,NULL,'JANET R SWISHER','FI','283502640','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:40',0,'2014-03-10 14:10:12'),(15778,16427,'0000-00-00','ET','2',1,NULL,'Gregory Loder','FI','298621525','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:40',0,'2014-03-10 16:24:30'),(12987,12987,'2014-01-01','ET','2',1,NULL,'Sondra Scott','FI','270548054','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:40',0,'2014-03-01 16:35:14'),(5138,5138,'2014-01-01','ET','2',1,NULL,'Bradley Scheible','FI','294564344','Summa Insurance Company, Inc.','FI','341809108','Carl  Lishing','94','2095192','348','2014-01-01','Sync Success',0,'2013-12-26 00:50:28',0,'2014-03-10 15:45:56'),(1120,1120,'2014-01-01','ET','2',1,NULL,'Timber Barkley','FI','644187334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:17',0,'2014-03-02 04:38:08'),(10738,10738,'2014-01-01','ET','2',1,NULL,'David I Sherman','FI','044407412','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:49',0,'2014-03-01 16:10:36'),(10630,10630,'2014-01-01','ET','2',1,NULL,'William Pike','FI','635107130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:58:10',0,'2014-03-02 04:31:46'),(7760,7760,'2014-01-01','ET','2',2,1,'lynn weiner','FI','369801357','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:12',0,'2014-03-10 13:03:33'),(3185,3185,'2014-01-01','ET','2',1,NULL,'Pamela Jo Hill','FI','485724424','HealthSpan','FI','311431434','Dennis  Tucker','94','1780702','348','2014-01-01','Sync Success',0,'2013-12-25 21:39:03',0,'2014-03-10 13:24:34'),(1127,1127,'2014-01-01','ET','2',1,NULL,'Cathy Jean Morgan','FI','452065066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:29',0,'2014-03-02 04:38:08'),(3839,3839,'2014-01-01','ET','2',2,1,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:13',0,'2014-03-01 15:05:09'),(19855,20505,'0000-00-00','ET','2',1,NULL,'Susan Anderson','FI','304984550','HealthSpan','FI','311431434','Miguel  Martinez','94','17064179','348','2014-04-01','Sync Success',0,'2014-02-20 22:01:07',0,'2014-03-10 14:37:47'),(18713,19363,'0000-00-00','ET','2',1,NULL,'Jaime Elizabeth Ramos','FI','182722710','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:02',0,'2014-03-10 16:31:33'),(11887,11887,'2014-01-01','ET','2',1,NULL,'Eddy Villalta Guillen','FI','587851925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:37',0,'2014-03-02 04:59:36'),(15722,16371,'0000-00-00','ET','2',2,1,'Charles Edward Brown','FI','566177804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:04',0,'2014-03-02 05:59:43'),(795,795,'2014-01-01','ET','2',2,1,'John Wright','FI','270485030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:59',0,'2014-03-10 13:03:33'),(2404,2404,'2014-01-01','ET','2',1,NULL,'James Rutherford','FI','300566190','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:21',0,'2014-03-01 15:26:40'),(3616,3616,'2014-01-01','ET','2',1,NULL,'Bruce W Kirkland','FI','459988643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:51',0,'2014-03-02 00:10:48'),(20006,20656,'0000-00-00','ET','2',1,NULL,'Darlene Piper','FI','342686037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-21 22:00:57',0,'2014-03-02 07:03:25'),(20341,20991,'0000-00-00','ET','2',1,NULL,'Christopher Porche','FI','434571662','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-03-31','Sync Success',0,'2014-02-26 08:30:31',0,'2014-03-02 07:03:25'),(22516,23166,'0000-00-00','ET','2',3,2,'SUYAPA DE HERNANDEZ','94','0001974573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:22',0,'2014-03-07 22:26:59'),(21383,22033,'0000-00-00','ET','2',1,NULL,'Carol Burgett','FI','273583588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:00',0,'2014-03-03 21:36:16'),(22093,22743,'0000-00-00','ET','2',1,NULL,'ROSE WOOLBRIGHT','FI','459944449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:00:24',0,'2014-03-06 21:27:26'),(276,276,'2014-01-01','ET','2',1,0,'Patrick Higgins','FI','124743052','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:49',0,'2014-03-10 13:03:33'),(13556,13912,'2014-01-01','ET','2',1,NULL,'EUGENIA WILLIAMS','FI','438233890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:52',0,'2014-03-02 05:31:31'),(19531,20181,'0000-00-00','ET','2',1,NULL,'Barbara Day','FI','279425023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:13:17',0,'2014-03-01 17:47:19'),(19112,19762,'0000-00-00','ET','2',1,NULL,'larry woodruff','FI','290522347','HealthSpan','FI','311431434','james  hitchings','94','1866145','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:52',0,'2014-03-10 14:31:05'),(12581,12581,'2014-01-01','ET','2',1,NULL,'Rachel Williams','FI','285822089','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:26',0,'2014-03-01 16:35:14'),(11602,11602,'2014-01-01','ET','2',1,NULL,'George Davis','94','0000539931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:46',0,'2014-03-02 04:52:44'),(18302,18952,'0000-00-00','ET','2',1,NULL,'MaryJo Hall','FI','438238396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:05',0,'2014-03-02 06:45:14'),(2163,2163,'2014-01-01','ET','2',2,1,'Pamela J Braunstein','FI','280569077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:51',0,'2014-03-01 15:16:37'),(3301,3301,'2014-01-01','ET','2',2,1,'Clinton Rooley','FI','517561813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:29',0,'2014-03-01 15:52:44'),(11444,11444,'2014-01-01','ET','2',4,3,'Lixuan Zheng','FI','274968033','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:08:03',0,'2014-03-10 13:52:32'),(7388,7388,'2014-01-01','ET','2',2,1,'Mary Cooper','FI','439966968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:26',0,'2014-03-02 04:15:49'),(17444,18094,'0000-00-00','ET','2',1,NULL,'IRENE KNAPP','FI','297926640','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:11',0,'2014-03-10 14:24:38'),(6154,6154,'2014-01-01','ET','2',1,NULL,'alma esquivel','FI','455353873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:58',0,'2014-03-02 04:10:25'),(6318,6318,'2014-01-01','ET','2',1,NULL,'SARAH STIDD','FI','298480895','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:56',0,'2014-03-10 15:59:47'),(18465,19115,'0000-00-00','ET','2',1,NULL,'Alana Aldredge','FI','633039299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:48',0,'2014-03-02 06:45:14'),(18158,18808,'0000-00-00','ET','2',1,NULL,'zenda watson','FI','439199006','Starmount Life Insurance Company','FI','720977315','wayne  landwerlin','94','1632529','357','2014-03-01','Sync Success',0,'2014-02-11 21:01:21',0,'2014-03-02 06:38:05'),(12725,12725,'2014-01-01','ET','2',1,NULL,'AUDREY ROZACK','FI','302487856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:47',0,'2014-03-10 16:10:34'),(16609,17259,'0000-00-00','ET','2',1,NULL,'Bonnie Eisenman','FI','444483462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:00:13',0,'2014-03-02 06:17:30'),(13546,13902,'2014-01-01','ET','2',1,NULL,'Joan Woodard','FI','439965233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:46',0,'2014-03-02 05:31:31'),(14702,15153,'2014-01-01','ET','2',1,NULL,'Diane Goodman-Daniel','FI','556894266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:56',0,'2014-03-02 05:45:37'),(22991,23641,'0000-00-00','ET','2',1,NULL,'felicia smith','FI','292782613','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:45',0,'2014-03-10 21:36:25'),(3708,3708,'2014-01-01','ET','2',1,NULL,'ashley cage','FI','438774762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:48',0,'2014-03-02 01:10:33'),(19195,19845,'0000-00-00','ET','2',1,NULL,'Jeremy Cook','FI','301843494','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:01',0,'2014-03-10 14:31:05'),(17347,17997,'0000-00-00','ET','2',2,1,'Carleen Pope','FI','433454267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:04',0,'2014-03-02 06:31:45'),(16647,17297,'0000-00-00','ET','2',1,NULL,'Diane Goodman-Daniel','FI','556894266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:39',0,'2014-03-02 06:17:30'),(13135,13491,'2014-01-01','ET','2',1,NULL,'Jennifer Nugent','FI','454041169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:16',0,'2014-03-02 05:17:40'),(14259,14710,'2014-01-01','ET','2',1,NULL,'DONNA M OGLESBY','FI','286645220','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:06',0,'2014-03-01 16:46:19'),(15829,16478,'0000-00-00','ET','2',1,NULL,'Keith Brown','FI','436154884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:28',0,'2014-03-02 06:03:21'),(16317,16967,'0000-00-00','ET','2',1,NULL,'Savita Arora','FI','284082100','Dental Care Plus, Inc.','FI','311185262','Uday  Patil','94','16477715','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:34',0,'2014-03-01 16:56:22'),(21410,22060,'0000-00-00','ET','2',3,2,'John Francher','FI','634128779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:17',0,'2014-03-03 21:25:18'),(22387,23037,'0000-00-00','ET','2',1,NULL,'Jennifer Day','FI','291884850','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:29',0,'2014-03-10 14:50:59'),(19337,19987,'0000-00-00','ET','2',1,NULL,'Thomas Blair','FI','561777250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:25',0,'2014-03-02 06:59:07'),(10408,10408,'2014-01-01','ET','2',1,NULL,'LINDA BUCHER','FI','302464616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:57',0,'2014-03-01 16:10:36'),(4289,4289,'2014-01-01','ET','2',2,1,'John Sparough','FI','349564639','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:58',0,'2014-03-10 13:32:15'),(4624,4624,'2014-01-01','ET','2',2,1,'Minhoai Lam','FI','026603856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:02',0,'2014-03-02 04:31:46'),(1722,1722,'2014-01-01','ET','2',1,NULL,'Bruce Vanvelzel','FI','274541084','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:09',0,'2014-03-01 15:31:33'),(5191,5191,'2014-01-01','ET','2',1,NULL,'Paula Edler','FI','643091084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:04',0,'2014-03-02 00:10:48'),(14938,15389,'2014-01-01','ET','2',3,2,'Lisa Marini','FI','273607141','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:42',0,'2014-03-01 16:50:53'),(789,789,'2014-01-01','ET','2',1,NULL,'Donald Ball','FI','463113896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:46',0,'2014-03-01 19:11:03'),(634,634,'2014-01-01','ET','2',1,NULL,'LUIS MARTINEZ','FI','451027296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:44',0,'2014-03-02 02:10:49'),(11857,11857,'2014-01-01','ET','2',1,NULL,'Cheryl Burns','FI','284660742','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:02',0,'2014-03-10 13:45:57'),(13880,14236,'2014-01-01','ET','2',2,1,'TAMMY AHMOUDA','FI','289748623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:07',0,'2014-03-10 14:03:26'),(22091,22741,'0000-00-00','ET','2',1,NULL,'Theresa Scott','FI','454531260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:23',0,'2014-03-06 21:27:26'),(23041,23691,'0000-00-00','ET','2',1,NULL,'LISA A WILLIAMS','FI','435157638','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:22',0,'2014-03-10 21:27:11'),(19785,20435,'0000-00-00','ET','2',2,1,'ELSA GONZALEZ','FI','662229226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:10',0,'2014-03-02 07:03:25'),(16177,16826,'0000-00-00','ET','2',1,NULL,'Marsha  Redmond','FI','233905045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:24',0,'2014-03-01 16:56:22'),(794,794,'2014-01-01','ET','2',1,NULL,'Michael Morris','FI','427176466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:57',0,'2014-03-01 19:11:03'),(1184,1184,'2014-01-01','ET','2',1,NULL,'Donna Tillman','FI','263026711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:16',0,'2014-03-02 04:38:08'),(3343,3343,'2014-01-01','ET','2',2,1,'Kayla Lambert','FI','448623739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:57',0,'2014-03-02 02:10:49'),(15492,15943,'0000-00-00','ET','2',2,1,'megan rodarmel','FI','308066560','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:08',0,'2014-03-10 14:10:12'),(2359,2359,'2014-01-01','ET','2',1,NULL,'Alyssa Gannon','FI','285926087','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:56',0,'2014-03-01 15:26:40'),(7306,7306,'2014-01-01','ET','2',1,NULL,'Lorna Shird','94','0000707444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:54',0,'2014-03-02 03:09:49'),(21440,22090,'0000-00-00','ET','2',1,NULL,'Ia Hang','FI','580189652','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:10',0,'2014-03-10 16:44:18'),(22221,22871,'0000-00-00','ET','2',1,NULL,'Veronica Mejia','FI','318780779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:54',0,'2014-03-06 21:27:26'),(120,120,'2014-01-01','ET','2',1,NULL,'Mark Zaher','FI','288580404','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:41',0,'2014-03-10 15:45:56'),(18805,19455,'0000-00-00','ET','2',2,1,'TODD SHINALL','FI','287622215','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:11',0,'2014-03-10 14:31:05'),(17692,18342,'0000-00-00','ET','2',2,1,'Jennifer Colson','FI','299866749','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:01:02',0,'2014-03-10 14:24:38'),(14251,14702,'2014-01-01','ET','2',1,NULL,'Patrick McCleery','FI','272706039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:02',0,'2014-03-01 16:46:19'),(21374,22024,'0000-00-00','ET','2',2,1,'Matthew House','FI','018588682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:38',0,'2014-03-10 14:45:25'),(23071,23721,'0000-00-00','ET','2',1,NULL,'Jamour Burns','FI','490763969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:45',0,'2014-03-10 21:17:52'),(2288,2288,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:46',0,'2014-03-01 21:11:04'),(19645,20295,'0000-00-00','ET','2',1,NULL,'Benjamin Troendly','FI','282888063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:41:59',0,'2014-03-01 17:47:19'),(7495,7495,'2014-01-01','ET','2',1,NULL,'Kay Wilczak','FI','282789146','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:52',0,'2014-03-01 16:05:34'),(18957,19607,'0000-00-00','ET','2',1,NULL,'John Carter','FI','587620081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:42',0,'2014-03-02 06:52:12'),(3902,3902,'2014-01-01','ET','2',1,NULL,'ANDREW STEVEN PITTS','FI','269861428','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:04',0,'2014-03-10 15:45:56'),(18652,19302,'0000-00-00','ET','2',1,NULL,'Delila Davila','FI','641010797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:15',0,'2014-03-02 06:45:14'),(16990,17640,'0000-00-00','ET','2',1,NULL,'yolanda faye bennett','FI','428834514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:23',0,'2014-03-02 06:17:30'),(13773,14129,'2014-01-01','ET','2',2,1,'TANYA GRAVES','FI','268523083','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:29',0,'2014-03-10 16:10:34'),(13037,13393,'2014-01-01','ET','2',2,1,'Angela Duff','FI','407137135','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:39',0,'2014-03-01 16:35:14'),(18892,19542,'0000-00-00','ET','2',1,NULL,'MaryLouise Parker','FI','283545232','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:56',0,'2014-03-10 14:31:05'),(11671,11671,'2014-01-01','ET','2',1,NULL,'Geia Bledsoe','94','0000559444','HealthSpan','FI','311431434','John  Quinn','94','16994287','348','2014-02-01','Sync Success',0,'2013-12-28 03:36:57',0,'2014-03-10 13:52:32'),(16897,17547,'0000-00-00','ET','2',1,NULL,'Ester Tobar','FI','454087790','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:24',0,'2014-03-02 06:24:38'),(12618,12618,'2014-01-01','ET','2',2,1,'clifton magness','FI','464026132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:43',0,'2014-03-02 05:10:52'),(4543,4543,'2014-01-01','ET','2',1,NULL,'sheldon bennett','FI','438772974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:27',0,'2014-03-02 04:31:46'),(4145,4145,'2014-01-01','ET','2',2,1,'DEBRA MOTTLE','FI','272440794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:32',0,'2014-03-01 16:00:27'),(1842,1842,'2014-01-01','ET','2',1,NULL,'WILLETTA M PERRYMAN','FI','277588528','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:21:01',0,'2014-03-10 13:20:27'),(425,425,'2014-01-01','ET','2',1,NULL,'Maria Ursetti','FI','270809683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:11',0,'2014-03-01 15:21:15'),(13312,13668,'2014-01-01','ET','2',1,NULL,'Pamela Kay Prisbylla','FI','273562780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:17',0,'2014-03-01 16:40:16'),(11149,11149,'2014-01-01','ET','2',1,NULL,'Zachery Durnell','FI','274901975','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:52',0,'2014-03-10 13:45:57'),(20673,21323,'0000-00-00','ET','2',1,NULL,'Kathleen Johnson','FI','283662727','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:43',0,'2014-03-10 14:37:47'),(5466,5466,'2014-01-01','ET','2',1,NULL,'Belinda Wright','FI','434151699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:20',0,'2014-03-02 04:45:37'),(6095,6095,'2014-01-01','ET','2',1,NULL,'mildred hyndman','FI','281523635','Dental Care Plus, Inc.','FI','311185262','tracy  saylor','94','2762700','348','2014-01-01','Sync Success',0,'2013-12-26 03:01:11',0,'2014-03-01 16:00:27'),(4693,4693,'2014-01-01','ET','2',3,2,'steve ling','FI','521859808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:24',0,'2014-03-02 04:38:08'),(7049,7049,'2014-01-01','ET','2',1,NULL,'Pamela Landers','FI','457158041','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:00',0,'2014-03-02 03:09:49'),(20430,21080,'0000-00-00','ET','2',1,NULL,'TONG ZHOU','FI','638297799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:49',0,'2014-03-02 07:03:25'),(15807,16456,'0000-00-00','ET','2',1,NULL,'Victor Guajardo','FI','465391617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:15',0,'2014-03-02 06:03:21'),(15838,16487,'0000-00-00','ET','2',1,NULL,'HAROLD DIXON','FI','403926078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:33',0,'2014-03-01 16:56:22'),(17302,17952,'0000-00-00','ET','2',2,1,'SIDNEY  FARRELL','FI','433683748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:55',0,'2014-03-02 06:24:38'),(21665,22315,'0000-00-00','ET','2',1,NULL,'SARAH BROWN','FI','275880124','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:01:09',0,'2014-03-04 21:36:30'),(20140,20790,'0000-00-00','ET','2',1,NULL,'Jennifer Beers','FI','293868619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:48',0,'2014-03-10 16:38:05'),(14154,14605,'2014-01-01','ET','2',1,NULL,'Keiva Jackson','FI','438393045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:09',0,'2014-03-02 05:38:34'),(16492,17142,'0000-00-00','ET','2',1,NULL,'ANTHONY W SMITH','FI','466135346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:32',0,'2014-03-02 06:10:30'),(7330,7330,'2014-01-01','ET','2',1,NULL,'Paula Johnson','94','0000789658','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:39',0,'2014-03-10 13:32:15'),(7275,7275,'2014-01-01','ET','2',1,NULL,'marjorie brammer','FI','283469728','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:57',0,'2014-03-10 13:32:15'),(16387,17037,'0000-00-00','ET','2',1,NULL,'Linda Tedeton','FI','438358372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:18',0,'2014-03-02 06:10:30'),(661,661,'2014-01-01','ET','2',1,NULL,'Melissa Williams','FI','467518683','Starmount Life Insurance Company','FI','720977315','Glenda  Jefferies','94','1325264','357','2014-01-01','Sync Success',0,'2013-12-25 18:05:32',0,'2014-03-02 02:10:49'),(2599,2599,'2014-01-01','ET','2',1,0,'kathy steffen','FI','122522385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:00',0,'2014-03-01 15:05:09'),(22514,23164,'0000-00-00','ET','2',1,NULL,'eric kullman','FI','434740588','Starmount Life Insurance Company','FI','720977315','Neil S Williamson','94','3365871','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:20',0,'2014-03-07 22:26:59'),(20354,21004,'0000-00-00','ET','2',2,1,'KEVIN DECKER','FI','290685436','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:41',0,'2014-03-01 17:47:19'),(1596,1596,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:08',0,'2014-03-01 20:10:57'),(6147,6147,'2014-01-01','ET','2',1,NULL,'Kimberly A Whittridge','94','0000634800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:44',0,'2014-03-01 16:00:27'),(1457,1457,'2014-01-01','ET','2',2,1,'Anthony Rickert-Epstein','FI','288823652','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:58',0,'2014-03-01 16:15:39'),(18571,19221,'0000-00-00','ET','2',1,NULL,'Jeffrey Snyder','FI','280809833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:10',0,'2014-03-01 17:26:36'),(5755,5755,'2014-01-01','ET','2',1,NULL,'JACQUELINE BECKER','FI','295609482','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:04',0,'2014-03-10 13:24:34'),(18439,19089,'0000-00-00','ET','2',1,NULL,'Krystal Burchette','FI','300888793','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:31',0,'2014-03-10 16:31:33'),(17369,18019,'0000-00-00','ET','2',1,NULL,'John Belcher','FI','464596587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:20',0,'2014-03-02 06:24:38'),(14435,14886,'2014-01-01','ET','2',3,2,'MICHAEL D MOORE','FI','436192633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:24',0,'2014-03-02 05:38:34'),(2805,2805,'2014-01-01','ET','2',2,1,'Sharon Schwartz','FI','284486443','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:30',0,'2014-03-01 16:05:34'),(4116,4116,'2014-01-01','ET','2',1,NULL,'Joan Butler','FI','292446714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:43',0,'2014-03-01 16:00:27'),(3984,3984,'2014-01-01','ET','2',4,3,'Kellie Crehan','94','0000194026','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:40',0,'2014-03-10 13:10:24'),(3279,3279,'2014-01-01','ET','2',2,1,'Autry Williams','FI','464040546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:47',0,'2014-03-02 02:10:49'),(13730,14086,'2014-01-01','ET','2',1,NULL,'Janice Saxton','FI','423907073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:01',0,'2014-03-02 05:24:45'),(22825,23475,'0000-00-00','ET','2',2,1,'Rebecca Morris','FI','271865727','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:14',0,'2014-03-10 16:44:18'),(16823,17473,'0000-00-00','ET','2',1,NULL,'Heather LeDoux','94','0001646369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:09',0,'2014-03-02 06:17:30'),(15328,15779,'0000-00-00','ET','2',2,1,'Robert Powell','FI','292866618','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:35',0,'2014-03-01 16:50:53'),(14581,15032,'2014-01-01','ET','2',1,NULL,'sandra anaya','FI','351728221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:38',0,'2014-03-02 05:45:37'),(13518,13874,'2014-01-01','ET','2',1,NULL,'ANDREA MALDONADO','FI','460396860','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:28',0,'2014-03-02 05:31:31'),(11296,11296,'2014-01-01','ET','2',1,NULL,'Julia Castle','FI','434290380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:23',0,'2014-03-02 04:52:44'),(14269,14720,'2014-01-01','ET','2',1,NULL,'Jennifer Guzman','FI','484064488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:10',0,'2014-03-01 16:46:19'),(5307,5307,'2014-01-01','ET','2',1,NULL,'Jude Katt','FI','437213106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:41',0,'2014-03-01 19:11:03'),(4368,4368,'2014-01-01','ET','2',1,NULL,'Johnathan Berner','FI','300920266','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:21',0,'2014-03-10 13:32:15'),(20318,20968,'0000-00-00','ET','2',1,NULL,'Marsha Owens','FI','460177034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:06',0,'2014-03-02 07:03:25'),(18914,19564,'0000-00-00','ET','2',1,NULL,'NANCY OBRYAN','FI','460928148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:12',0,'2014-03-01 17:34:07'),(12934,12934,'2014-01-01','ET','2',1,NULL,'Aaron Garcia','FI','295862461','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-04 02:06:15',0,'2014-03-10 13:59:38'),(16350,17000,'0000-00-00','ET','2',1,NULL,'ERIC JOHNSON','FI','283808585','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:54',0,'2014-03-01 16:56:22'),(12634,12634,'2014-01-01','ET','2',1,NULL,'Michael J Van Dyke','FI','433276968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:16',0,'2014-03-02 05:10:52'),(12504,12504,'2014-01-01','ET','2',1,NULL,'KENESHA DWAN ANTOINE','FI','438411733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:31',0,'2014-03-02 05:03:29'),(6315,6315,'2014-01-01','ET','2',1,NULL,'Jennifer Kessen','FI','302845120','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:51',0,'2014-03-10 15:59:47'),(3390,3390,'2014-01-01','ET','2',1,NULL,'Donna K Zuelsdorf','FI','284524087','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:51:23',0,'2014-03-10 15:52:36'),(12173,12173,'2014-01-01','ET','2',4,3,'Keith Kuhnell','FI','278703995','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:14',0,'2014-03-10 13:52:32'),(4057,4057,'2014-01-01','ET','2',1,NULL,'Clinton Graham','FI','386980417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:55',0,'2014-03-02 03:09:49'),(11964,11964,'2014-01-01','ET','2',1,NULL,'Sara B Simpson','FI','515045156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:43',0,'2014-03-02 04:59:36'),(5229,5229,'2014-01-01','ET','2',1,NULL,'TRYSYN BUCKLEY','FI','425697665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:23',0,'2014-03-02 00:10:48'),(19654,20303,'0000-00-00','ET','2',1,NULL,'Benjamin Troendly','FI','282888063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:44:08',0,'2014-03-01 17:47:19'),(20268,20918,'0000-00-00','ET','2',1,NULL,'Thelma Lewis','FI','435989408','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:15',0,'2014-03-01 17:47:19'),(21603,22253,'0000-00-00','ET','2',2,1,'LUCIENNE MORCOS','FI','107809601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:22',0,'2014-03-04 21:27:16'),(23029,23679,'0000-00-00','ET','2',2,1,'KIMBERLY SINCLAIR','FI','458695487','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:12',0,'2014-03-10 21:27:11'),(17043,17693,'0000-00-00','ET','2',1,NULL,'Glenda Watts','FI','290588321','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:26',0,'2014-03-10 16:24:30'),(16871,17521,'0000-00-00','ET','2',1,NULL,'Joshua King','FI','466993241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:09',0,'2014-03-02 06:17:30'),(11603,11603,'2014-01-01','ET','2',3,2,'TASHA  MYERS','FI','428334796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:47',0,'2014-03-02 04:52:44'),(10563,10563,'2014-01-01','ET','2',1,NULL,'Larry Sorrell','FI','459310286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:58',0,'2014-03-02 04:24:47'),(21206,21856,'0000-00-00','ET','2',1,NULL,'Webb Wright','FI','454634086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-03-01 19:00:06',0,'2014-03-02 07:23:39'),(21745,22395,'0000-00-00','ET','2',2,1,'Evelyn Ferrell','FI','247673397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:16',0,'2014-03-04 21:27:16'),(22220,22870,'0000-00-00','ET','2',1,NULL,'Juan Pablo Moreno','FI','640180709','Starmount Life Insurance Company','FI','720977315','Beatriz  Monte','94','16878927','348','2014-04-01','Sync Success',0,'2014-03-06 21:01:54',0,'2014-03-06 21:27:26'),(18921,19571,'0000-00-00','ET','2',1,NULL,'CAROLYN POUNDERS','FI','587862127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:17',0,'2014-03-02 06:52:12'),(14586,15037,'2014-01-01','ET','2',1,NULL,'DENISE MARCEIL RINEHART','FI','452025239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:41',0,'2014-03-02 05:45:37'),(2907,2907,'2014-01-01','ET','2',1,NULL,'ED MYERS','FI','538527764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:11',0,'2014-03-02 01:10:33'),(2413,2413,'2014-01-01','ET','2',1,NULL,'Vanessa Thomas','FI','294668405','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:40',0,'2014-03-01 15:26:40'),(2082,2082,'2014-01-01','ET','2',2,1,'Barbara Bush','FI','206365316','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 19:37:28',0,'2014-03-10 13:20:27'),(22296,22946,'0000-00-00','ET','2',1,NULL,'RHEN AVNER','FI','299640712','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:50',0,'2014-03-10 14:50:59'),(19339,19989,'0000-00-00','ET','2',1,NULL,'Chantelle Johnson','FI','546636369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:26',0,'2014-03-02 06:59:07'),(361,361,'2014-01-01','ET','2',1,NULL,'Carla Taylor','FI','289848840','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:08',0,'2014-03-01 15:21:15'),(13704,14060,'2014-01-01','ET','2',1,NULL,'DREW DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:43',0,'2014-03-01 16:40:16'),(5156,5156,'2014-01-01','ET','2',1,NULL,'Crystal Hoover','FI','437358831','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:59',0,'2014-03-10 15:45:56'),(11583,11583,'2014-01-01','ET','2',2,1,'Juan Urquieta','FI','461412115','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:12',0,'2014-03-02 04:52:44'),(7510,7510,'2014-01-01','ET','2',2,1,'Terry Kiser','94','0000953243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:21',0,'2014-03-01 16:05:34'),(20419,21069,'0000-00-00','ET','2',1,NULL,'Kristin Nelvena Cato','FI','282761624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:42',0,'2014-03-01 18:08:07'),(174,174,'2014-01-01','ET','2',1,NULL,'Mariea Ross','FI','433495351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:24',0,'2014-03-01 22:10:55'),(19204,19854,'0000-00-00','ET','2',2,1,'Thomas Russell','FI','296562674','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:10',0,'2014-03-10 14:31:05'),(2206,2206,'2014-01-01','ET','2',1,NULL,'Staci Bruce','FI','425498836','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:23',0,'2014-03-01 21:11:04'),(10442,10442,'2014-01-01','ET','2',1,NULL,'Mark Burchett','FI','270702877','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:03',0,'2014-03-01 16:10:36'),(17348,17998,'0000-00-00','ET','2',1,NULL,'BROOKE GROUNDS','FI','631321251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:05',0,'2014-03-02 06:31:45'),(4500,4500,'2014-01-01','ET','2',2,1,'michael taylor','FI','289524672','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:04',0,'2014-03-10 13:03:33'),(4309,4309,'2014-01-01','ET','2',1,NULL,'EARL ALLEN','FI','587729261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:32',0,'2014-03-02 03:09:49'),(15613,16064,'0000-00-00','ET','2',2,1,'MARY DAMPIER','FI','587984103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:42',0,'2014-03-02 05:59:43'),(23038,23688,'0000-00-00','ET','2',1,NULL,'ELAINE CRAMER','FI','286566960','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:19',0,'2014-03-10 21:17:52'),(59,59,'2014-01-01','ET','2',1,NULL,'Matthew Reitman','FI','545799664','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:46',0,'2014-03-01 15:21:15'),(18872,19522,'0000-00-00','ET','2',4,3,'dan mccarthy','FI','290600527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:41',0,'2014-03-01 17:34:07'),(11844,11844,'2014-01-01','ET','2',1,NULL,'Mary Spencer','FI','216782079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:14:33',0,'2014-03-02 04:31:46'),(18091,18741,'0000-00-00','ET','2',1,NULL,'URSULA V VIGIL','FI','460219840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:31',0,'2014-03-02 06:38:05'),(14522,14973,'2014-01-01','ET','2',1,NULL,'PEGGY MURANKO','FI','272709118','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:03',0,'2014-03-10 16:17:47'),(5788,5788,'2014-01-01','ET','2',2,1,'LINDA STREET','FI','274461605','Summa Insurance Company, Inc.','FI','341809108','DONALD  VOUGHT','94','2230276','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:10',0,'2014-03-10 15:52:36'),(4432,4432,'2014-01-01','ET','2',1,NULL,'Iann Robinson','FI','104706202','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:08',0,'2014-03-10 13:03:33'),(20131,20781,'0000-00-00','ET','2',1,NULL,'VINCENT WHITE','FI','283704661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:42',0,'2014-03-01 18:08:07'),(21104,21754,'0000-00-00','ET','2',2,1,'JUAN FRANCISCO RIVERA ARROYO','FI','467478985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:49',0,'2014-03-02 07:23:39'),(1257,1257,'2014-01-01','ET','2',1,NULL,'Ismael Valles','FI','417068948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:25',0,'2014-03-01 16:15:39'),(19272,19922,'0000-00-00','ET','2',1,NULL,'Debra Dechant','94','0000066302','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-17 19:00:14',0,'2014-03-10 14:31:05'),(13130,13486,'2014-01-01','ET','2',1,NULL,'Dora Ortega','FI','630841393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:07',0,'2014-03-02 05:17:40'),(10952,10952,'2014-01-01','ET','2',2,1,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:16',0,'2014-03-10 16:03:49'),(7689,7689,'2014-01-01','ET','2',1,NULL,'Phil Eggeman','FI','274464246','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-01-01','Sync Success',0,'2013-12-26 04:45:04',0,'2014-03-10 15:39:19'),(2960,2960,'2014-01-01','ET','2',1,NULL,'DELORES BERNHART','FI','285567440','Dental Care Plus, Inc.','FI','311185262','Cory  Miller','94','2424710','348','2014-01-01','Sync Success',0,'2013-12-25 21:31:54',0,'2014-03-01 15:37:30'),(16595,17245,'0000-00-00','ET','2',1,NULL,'Barbara Carter','FI','292427425','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:40',0,'2014-03-10 14:20:26'),(2767,2767,'2014-01-01','ET','2',1,NULL,'FAYE MCMANN','FI','281587650','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:15',0,'2014-03-01 16:05:34'),(15503,15954,'0000-00-00','ET','2',2,1,'Ramona Rosario','FI','584192999','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:52',0,'2014-03-01 16:50:53'),(15372,15823,'0000-00-00','ET','2',1,NULL,'Melrose Richard','FI','434840698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:21:52',0,'2014-03-02 05:59:43'),(5316,5316,'2014-01-01','ET','2',2,1,'Danny Rigdon','FI','289700846','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:02',0,'2014-03-10 13:03:33'),(15260,15711,'0000-00-00','ET','2',1,NULL,'thomas brown','FI','278748539','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:36',0,'2014-03-10 16:17:47'),(20076,20726,'0000-00-00','ET','2',3,2,'Jennifer L\'Heureux','94','0000761132','Dental Care Plus, Inc.','FI','311185262','David  Loge','94','7559354','348','2014-03-01','Sync Success',0,'2014-02-25 21:00:30',0,'2014-03-01 18:08:07'),(18584,19234,'0000-00-00','ET','2',4,3,'NOSA OVIAHON','FI','296981617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:22',0,'2014-03-01 17:26:36'),(18412,19062,'0000-00-00','ET','2',2,1,'RICHARD S THOMPSON','FI','402883831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:10',0,'2014-03-01 17:26:36'),(11933,11933,'2014-01-01','ET','2',1,NULL,'Sander Schiller','94','0000024629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:05',0,'2014-03-02 04:59:36'),(18113,18763,'0000-00-00','ET','2',2,1,'Yucabed Ongesa','FI','455832426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:48',0,'2014-03-02 06:38:05'),(17706,18356,'0000-00-00','ET','2',2,1,'BARBARA LINDE','FI','439920749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:06',0,'2014-03-02 06:31:45'),(1571,1571,'2014-01-01','ET','2',1,NULL,'Linda Joyce Masters','FI','058443422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:19',0,'2014-03-01 20:10:57'),(17443,18093,'0000-00-00','ET','2',1,NULL,'Steven Stuart','FI','276647728','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:11',0,'2014-03-10 14:24:38'),(16805,17455,'0000-00-00','ET','2',1,NULL,'DIANE GILBERT','FI','295447885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:45',0,'2014-03-10 14:20:26'),(15320,15771,'0000-00-00','ET','2',1,NULL,'sheila buchanan','FI','288720813','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:30',0,'2014-03-10 14:10:12'),(4934,4934,'2014-01-01','ET','2',2,1,'Erica Jane Moore','FI','283820184','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:14',0,'2014-03-10 13:03:33'),(417,417,'2014-01-01','ET','2',2,1,'Jennifer Reynolds','FI','295806509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:55',0,'2014-03-01 15:21:15'),(16996,17646,'0000-00-00','ET','2',1,NULL,'KELLIE RAMSEY','FI','640502960','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-03 21:01:28',0,'2014-03-02 06:17:30'),(874,874,'2014-01-01','ET','2',1,NULL,'Brian Bowers','FI','289861399','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:26',0,'2014-03-01 15:21:15'),(14116,14567,'2014-01-01','ET','2',1,NULL,'Jennifer L\'Heureux','94','0000761132','Dental Care Plus, Inc.','FI','311185262','David  Loge','94','7559354','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:46',0,'2014-03-01 16:46:19'),(2331,2331,'2014-01-01','ET','2',1,0,'Ieasha Vaughn','FI','281787908','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:19',0,'2014-03-01 15:05:09'),(5851,5851,'2014-01-01','ET','2',1,NULL,'Stuart Mack','FI','425470309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:11',0,'2014-03-01 20:10:57'),(20911,21561,'0000-00-00','ET','2',1,NULL,'wendy barnett','FI','290742136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:06',0,'2014-03-01 18:08:07'),(22011,22661,'0000-00-00','ET','2',1,NULL,'Darlene Catanzaro','FI','107705992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:00',0,'2014-03-05 21:36:22'),(19907,20557,'0000-00-00','ET','2',1,NULL,'LUZ STELLA ZAVALA','FI','455371090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:09',0,'2014-03-02 07:03:25'),(14638,15089,'2014-01-01','ET','2',1,NULL,'LISA M ARRIGO','FI','297629493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:13',0,'2014-03-01 16:46:19'),(15335,15786,'0000-00-00','ET','2',1,NULL,'MATTIE WINTERS','FI','426152175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:40',0,'2014-03-02 05:52:31'),(5676,5676,'2014-01-01','ET','2',2,1,'ANDREA PUGH','FI','296809193','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:16',0,'2014-03-10 16:03:49'),(11988,11988,'2014-01-01','ET','2',1,NULL,'mario gomez','FI','545358515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:38',0,'2014-03-02 05:03:29'),(52,52,'2014-01-01','ET','2',2,1,'Elizabeth Mahone','FI','372989990','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:33',0,'2014-03-01 15:21:15'),(14736,15187,'2014-01-01','ET','2',3,2,'Shelly Trump','FI','285728592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:17',0,'2014-03-10 16:17:47'),(14374,14825,'2014-01-01','ET','2',1,NULL,'Lisa Steffan','FI','286808129','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:55',0,'2014-03-10 16:17:47'),(13873,14229,'2014-01-01','ET','2',1,NULL,'Darius Rice','FI','587611383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:24:03',0,'2014-03-02 05:31:31'),(19824,20474,'0000-00-00','ET','2',2,1,'JOSEFINA AGUIRRE','FI','449153774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:42',0,'2014-03-02 07:03:25'),(19787,20437,'0000-00-00','ET','2',1,NULL,'GREGORY  A BOWMAN','FI','569672558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:13',0,'2014-03-02 07:03:25'),(4133,4133,'2014-01-01','ET','2',1,NULL,'TADESSE HAGOS','FI','224913272','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:12',0,'2014-03-01 16:00:27'),(19094,19744,'0000-00-00','ET','2',1,NULL,'Mary Landrum','FI','293483462','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:39',0,'2014-03-01 17:34:07'),(16037,16686,'0000-00-00','ET','2',1,NULL,'Summer Suleiman','FI','436738788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:35',0,'2014-03-02 06:03:21'),(22708,23358,'0000-00-00','ET','2',1,NULL,'PEGGY TAYLOR','FI','436042963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:04',0,'2014-03-08 22:26:18'),(22831,23481,'0000-00-00','ET','2',2,1,'DENNIS P PETERSON','FI','476526714','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:19',0,'2014-03-10 14:50:59'),(41,41,'2014-01-01','ET','2',1,NULL,'Debra Hunter','FI','587134719','Starmount Life Insurance Company','FI','720977315','Jeffrey  Chance','94','2114967','348','2014-01-01','Sync Success',0,'2013-12-25 17:16:13',0,'2014-03-01 22:10:55'),(19729,20379,'0000-00-00','ET','2',1,NULL,'CAROL JOYCE DELLISANTI','FI','299528640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:36:28',0,'2014-03-01 17:47:19'),(13097,13453,'2014-01-01','ET','2',1,NULL,'Marceita Norvell','FI','288564221','Starmount Life Insurance Company','FI','720977315','revonno  Burt','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-07 04:02:53',0,'2014-03-02 05:17:40'),(18850,19500,'0000-00-00','ET','2',2,1,'Ronald Ennis','FI','463674823','Starmount Life Insurance Company','FI','720977315','Richard  Reese Jr','94','4693945','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:25',0,'2014-03-02 06:52:12'),(504,504,'2014-01-01','ET','2',1,NULL,'DENNIS CORNELIUS','FI','274449357','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:35',0,'2014-03-01 15:48:04'),(16908,17558,'0000-00-00','ET','2',1,NULL,'MARK EDWARD SMITH','FI','277683832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:31',0,'2014-03-01 17:00:58'),(12157,12157,'2014-01-01','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:07:42',0,'2014-03-10 13:52:32'),(7449,7449,'2014-01-01','ET','2',1,NULL,'Paul Rodriguez','FI','453493758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:24',0,'2014-03-02 04:10:25'),(21014,21664,'0000-00-00','ET','2',1,NULL,'LORNA BUSSEY','FI','436193095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:10',0,'2014-03-02 07:23:39'),(22117,22767,'0000-00-00','ET','2',1,NULL,'NAKEITRIA TWAN JOSEPH','FI','438198177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:42',0,'2014-03-06 21:27:26'),(11646,11646,'2014-01-01','ET','2',2,1,'charles rigby','FI','265634496','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:08',0,'2014-03-10 16:03:49'),(6430,6430,'2014-01-01','ET','2',1,NULL,'Eileen Jennings','FI','274569493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:15:27',0,'2014-03-01 15:10:22'),(18651,19301,'0000-00-00','ET','2',1,NULL,'Shawn Jaworski','FI','293889543','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:14',0,'2014-03-01 17:26:36'),(1277,1277,'2014-01-01','ET','2',1,NULL,'Heather Tayse','FI','301909676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:05',0,'2014-03-01 16:23:43'),(2823,2823,'2014-01-01','ET','2',1,NULL,'Jerome Wyatt','FI','426530084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:05',0,'2014-03-02 04:15:49'),(12596,12596,'2014-01-01','ET','2',1,NULL,'RAUL CISNEROS','FI','452911012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:58',0,'2014-03-02 05:10:52'),(17934,18584,'0000-00-00','ET','2',2,1,'James Michael Wheland','FI','467633384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:52',0,'2014-03-02 06:38:05'),(15527,15978,'0000-00-00','ET','2',2,1,'ARUNA GUNERATNE','FI','612250388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:02',0,'2014-03-02 05:59:43'),(15295,15746,'0000-00-00','ET','2',1,NULL,'Janet Mackey-Amador','FI','449453832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:15',0,'2014-03-02 05:52:31'),(20314,20964,'0000-00-00','ET','2',2,1,'Deborah Varnell','FI','456793767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:03',0,'2014-03-02 07:03:25'),(3986,3986,'2014-01-01','ET','2',2,1,'James Dunn','FI','285484995','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:47',0,'2014-03-10 13:10:24'),(15399,15850,'0000-00-00','ET','2',2,1,'jack wei','FI','639268272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:09',0,'2014-03-02 05:59:43'),(5375,5375,'2014-01-01','ET','2',2,1,'Brandon Fox','FI','287926798','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:43',0,'2014-03-01 15:10:22'),(2672,2672,'2014-01-01','ET','2',1,NULL,'Linda Carol Smothers','FI','271561879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:16',0,'2014-03-01 16:05:34'),(4688,4688,'2014-01-01','ET','2',1,NULL,'Lora Lynn Washington','FI','439271776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:14',0,'2014-03-02 04:38:08'),(3746,3746,'2014-01-01','ET','2',1,NULL,'Ricky Hester','FI','284524229','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:05',0,'2014-03-10 13:24:34'),(21015,21665,'0000-00-00','ET','2',1,NULL,'ROBBY DUCOTE','FI','437550718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:00:11',0,'2014-03-02 07:23:39'),(22758,23408,'0000-00-00','ET','2',1,NULL,'eric nava','FI','464231467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:18',0,'2014-03-09 21:26:00'),(19023,19673,'0000-00-00','ET','2',1,NULL,'Lorine Totten','FI','408920898','Starmount Life Insurance Company','FI','720977315','Lynnette  Jackson','94','772169','348','2014-03-01','Sync Success',0,'2014-02-14 22:00:06',0,'2014-03-02 06:52:12'),(1901,1901,'2014-01-01','ET','2',2,1,'Altagracia Garcia','FI','645967931','Starmount Life Insurance Company','FI','720977315','Linda  Carter','94','1033689','348','2014-01-01','Sync Success',0,'2013-12-25 19:31:48',0,'2014-03-01 23:10:52'),(13750,14106,'2014-01-01','ET','2',1,NULL,'sarah mullin','FI','176727121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:14',0,'2014-03-01 16:40:16'),(18967,19617,'0000-00-00','ET','2',1,NULL,'Marie Moore','FI','272765969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:50',0,'2014-03-10 14:31:05'),(2836,2836,'2014-01-01','ET','2',1,NULL,'CHRIS GRAHAM','FI','449252686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:32',0,'2014-03-02 04:15:49'),(12860,12860,'2014-01-01','ET','2',1,NULL,'Paula A Murphy','FI','298481187','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:26',0,'2014-03-01 16:35:14'),(5358,5358,'2014-01-01','ET','2',2,1,'Nicholas Scarlato','FI','286683690','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:07',0,'2014-03-10 13:03:33'),(12845,12845,'2014-01-01','ET','2',1,NULL,'Francisco Garcia','FI','449711486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:52',0,'2014-03-02 05:10:52'),(7051,7051,'2014-01-01','ET','2',1,NULL,'alan hanna','FI','427062732','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:04',0,'2014-03-02 03:09:49'),(15712,16361,'0000-00-00','ET','2',1,NULL,'KAY FORFMAN','FI','385629293','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:56',0,'2014-03-10 14:10:12'),(7158,7158,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:21',0,'2014-03-10 15:59:47'),(7264,7264,'2014-01-01','ET','2',1,NULL,'RANDALL  K  HAMILTON','FI','286449451','HealthSpan','FI','311431434','DARWIN  CARMICHAEL','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-26 04:08:36',0,'2014-03-10 13:32:15'),(10564,10564,'2014-01-01','ET','2',1,NULL,'debra rice','94','0000001114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:00',0,'2014-03-02 04:24:47'),(20760,21410,'0000-00-00','ET','2',1,NULL,'Melissa Borror','FI','286803674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:39',0,'2014-03-01 18:08:07'),(22724,23374,'0000-00-00','ET','2',1,NULL,'Katie Deerhake','FI','289828274','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:16',0,'2014-03-10 14:50:59'),(17892,18542,'0000-00-00','ET','2',1,NULL,'LESLIE THOMAS','FI','438963157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:23',0,'2014-03-02 06:38:05'),(4413,4413,'2014-01-01','ET','2',1,NULL,'Ronald Creighton','FI','271682904','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:22',0,'2014-03-10 13:03:33'),(12208,12208,'2014-01-01','ET','2',1,NULL,'Danita A Steele','FI','291669744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:47',0,'2014-03-01 16:35:14'),(5821,5821,'2014-01-01','ET','2',1,NULL,'Joshua Gilhaus','FI','438418089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:06',0,'2014-03-01 20:10:57'),(10393,10393,'2014-01-01','ET','2',1,NULL,'Walker Hodson','FI','210749840','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:31',0,'2014-03-01 16:10:36'),(1919,1919,'2014-01-01','ET','2',1,NULL,'Pamela Jo Mann','FI','454901877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:19',0,'2014-03-02 00:10:48'),(12900,12900,'2014-01-01','ET','2',1,NULL,'ZAHRA AFKHAMI-NOE','FI','266878375','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:55',0,'2014-03-02 05:10:52'),(11801,11801,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:09',0,'2014-03-10 16:03:49'),(16869,17519,'0000-00-00','ET','2',1,NULL,'James Davis','FI','437572488','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:08',0,'2014-03-02 06:17:30'),(13402,13758,'2014-01-01','ET','2',1,NULL,'Aurora Muro','FI','635109884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:55',0,'2014-03-02 05:24:45'),(2812,2812,'2014-01-01','ET','2',1,NULL,'Gregory Chapman','FI','279486962','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:42',0,'2014-03-01 16:05:34'),(5544,5544,'2014-01-01','ET','2',1,NULL,'Richard Bauer','FI','302527820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:52',0,'2014-03-01 16:23:43'),(3667,3667,'2014-01-01','ET','2',1,NULL,'KAWANDA JORDAN','FI','427559441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:26',0,'2014-03-02 00:10:48'),(19647,20297,'0000-00-00','ET','2',1,NULL,'Nancy Moore','FI','277689072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:42:35',0,'2014-03-01 17:47:19'),(21418,22068,'0000-00-00','ET','2',1,NULL,'MONIQUE BERRY','FI','437652460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:22',0,'2014-03-03 21:25:18'),(21633,22283,'0000-00-00','ET','2',1,NULL,'RICKEY FREEMAN','FI','463020229','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:46',0,'2014-03-04 21:27:16'),(17585,18235,'0000-00-00','ET','2',1,NULL,'john kinser','FI','300748721','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:01',0,'2014-03-10 14:24:38'),(16021,16670,'0000-00-00','ET','2',1,NULL,'Jess Walker','FI','547635839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:24',0,'2014-03-02 06:03:21'),(13555,13911,'2014-01-01','ET','2',1,NULL,'Jessie Moore','FI','434110798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:51',0,'2014-03-02 05:24:45'),(13131,13487,'2014-01-01','ET','2',1,NULL,'Melissa De Anda','FI','125604988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:09',0,'2014-03-02 05:17:40'),(14672,15123,'2014-01-01','ET','2',2,1,'Ashley Kirsch','FI','288906078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:35',0,'2014-03-01 16:46:19'),(5604,5604,'2014-01-01','ET','2',1,NULL,'francesca veitch','FI','297921748','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:46',0,'2014-03-01 16:23:43'),(14629,15080,'2014-01-01','ET','2',1,NULL,'Christina Valentine','FI','290706326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:08',0,'2014-03-01 16:46:19'),(4223,4223,'2014-01-01','ET','2',1,NULL,'courtney stalnaker','FI','274866517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:56',0,'2014-03-01 16:00:27'),(4990,4990,'2014-01-01','ET','2',1,NULL,'Kecia Lynn','FI','285761389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:40',0,'2014-03-01 15:31:33'),(21499,22149,'0000-00-00','ET','2',1,NULL,'Gurjant Singh','FI','288066555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:54',0,'2014-03-03 21:36:16'),(22799,23449,'0000-00-00','ET','2',1,NULL,'caren hall','FI','284946700','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:50',0,'2014-03-10 14:50:59'),(17863,18513,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:12',0,'2014-03-02 06:38:05'),(10743,10743,'2014-01-01','ET','2',1,NULL,'VIVIAN EDWARDS','FI','276600237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:58',0,'2014-03-01 16:10:36'),(5144,5144,'2014-01-01','ET','2',1,NULL,'Lisa Goldstein','FI','313668921','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:37',0,'2014-03-10 15:45:56'),(14150,14601,'2014-01-01','ET','2',1,NULL,'Valerie  Lange','FI','439827170','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:07',0,'2014-03-02 05:38:34'),(950,950,'2014-01-01','ET','2',1,NULL,'Steven Doucette','FI','434218653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:39',0,'2014-03-01 22:10:55'),(12672,12672,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:03:45',0,'2014-03-01 16:35:14'),(19618,20267,'0000-00-00','ET','2',1,NULL,'casey tucker','94','0000194106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:17',0,'2014-03-01 17:34:07'),(17786,18436,'0000-00-00','ET','2',1,NULL,'Ashaki Jerels','FI','284843607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:21',0,'2014-03-01 16:56:22'),(20205,20855,'0000-00-00','ET','2',2,1,'Jacquelyn Rios','FI','467375753','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:35',0,'2014-03-02 07:10:28'),(18508,19158,'0000-00-00','ET','2',1,NULL,'Sheena Diamond','FI','427473345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:17',0,'2014-03-02 06:45:14'),(13015,13015,'2014-01-01','ET','2',1,NULL,'Eddie Steward','FI','587512817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:47',0,'2014-03-02 05:17:40'),(1154,1154,'2014-01-01','ET','2',2,1,'Denise R Carey','FI','438597142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:19',0,'2014-03-02 04:38:08'),(1305,1305,'2014-01-01','ET','2',1,NULL,'Nichelle Rhem','FI','198643394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:59',0,'2014-03-02 04:38:08'),(1603,1603,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:17',0,'2014-03-01 20:10:57'),(18432,19082,'0000-00-00','ET','2',1,NULL,'CAROLYN MUNFORD','FI','296620442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:26',0,'2014-03-01 17:26:36'),(3541,3541,'2014-01-01','ET','2',1,NULL,'Danielle M Davidson','FI','298500836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:30',0,'2014-03-01 15:37:30'),(17748,18398,'0000-00-00','ET','2',1,NULL,'Maurice Uriegas','FI','467853124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:34',0,'2014-03-02 06:31:45'),(7151,7151,'2014-01-01','ET','2',1,NULL,'THOMAS G GAYLORD','FI','279501575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:06',0,'2014-03-10 15:59:47'),(4453,4453,'2014-01-01','ET','2',1,NULL,'Kristina Burns','FI','271906055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:32',0,'2014-03-01 15:16:37'),(16397,17047,'0000-00-00','ET','2',1,NULL,'ALMA VERA','FI','750110176','Starmount Life Insurance Company','FI','720977315','BARRY  DOBBS','94','756422','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:24',0,'2014-03-02 06:10:30'),(14996,15447,'2014-01-01','ET','2',1,NULL,'WANDA GEORGE','FI','426197926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:08',0,'2014-03-02 05:52:31'),(15074,15525,'2014-01-01','ET','2',3,2,'RACHEL E TOPP','FI','296722376','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:42',0,'2014-03-10 14:10:12'),(16028,16677,'0000-00-00','ET','2',1,NULL,'DEBRA MILLIGAN','FI','434047784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:28',0,'2014-03-02 06:03:21'),(23036,23686,'0000-00-00','ET','2',1,NULL,'Gustavo M Coutinho','FI','270988030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:18',0,'2014-03-10 21:17:52'),(426,426,'2014-01-01','ET','2',2,1,'Gary Shonebarger','FI','279424312','Dental Care Plus, Inc.','FI','311185262','Don  Larsen','94','15784811','348','2014-01-01','Sync Success',0,'2013-12-25 17:49:13',0,'2014-03-01 15:21:15'),(13190,13546,'2014-01-01','ET','2',2,1,'Christopher Laurianti','FI','298527159','Summa Insurance Company, Inc.','FI','341809108','carl  laurianti','94','2332836','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:16',0,'2014-03-10 16:10:34'),(19978,20628,'0000-00-00','ET','2',2,1,'Mohammad Alimi','FI','457576676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:37',0,'2014-03-02 07:03:25'),(7554,7554,'2014-01-01','ET','2',2,1,'KATHERINE M ROBINETTE','FI','289569565','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:45',0,'2014-03-01 16:05:34'),(17499,18149,'0000-00-00','ET','2',1,NULL,'BLANCHE COTTRELL','FI','297645863','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:53',0,'2014-03-10 14:24:38'),(17371,18021,'0000-00-00','ET','2',2,1,'FRANCISCO MIRANDA','FI','635545445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:21',0,'2014-03-02 06:31:45'),(5506,5506,'2014-01-01','ET','2',1,NULL,'Rayna McNairl','FI','415698513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:38',0,'2014-03-01 16:23:43'),(16349,16999,'0000-00-00','ET','2',4,3,'Christopher  Berlean','FI','278882127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:53',0,'2014-03-01 16:56:22'),(5005,5005,'2014-01-01','ET','2',1,NULL,'Pamela Markenson','FI','494586398','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:07',0,'2014-03-01 15:31:33'),(20487,21137,'0000-00-00','ET','2',1,NULL,'wilfred weaver','FI','300441047','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:36',0,'2014-03-10 16:38:05'),(22382,23032,'0000-00-00','ET','2',1,NULL,'anna Bradford','FI','435533621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:26',0,'2014-03-07 21:25:22'),(17482,18132,'0000-00-00','ET','2',1,NULL,'DENISE DAVIS','FI','427045782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:40',0,'2014-03-02 06:31:45'),(175,175,'2014-01-01','ET','2',1,NULL,'doris moore','FI','433134501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:26',0,'2014-03-01 22:10:55'),(2683,2683,'2014-01-01','ET','2',1,NULL,'ronald lambard','FI','463117627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:41',0,'2014-03-02 04:15:49'),(2849,2849,'2014-01-01','ET','2',1,NULL,'Kristy Cottle','FI','286760114','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:59',0,'2014-03-10 15:59:47'),(15914,16563,'0000-00-00','ET','2',1,NULL,'Lindsey Coons','FI','044901147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:03',0,'2014-03-02 06:03:21'),(11910,11910,'2014-01-01','ET','2',1,NULL,'Shionna Knight','FI','270923792','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:22',0,'2014-03-01 16:30:17'),(13011,13011,'2014-01-01','ET','2',1,NULL,'Quentin Rodriguez','FI','294864036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:34',0,'2014-03-01 16:35:14'),(12410,12410,'2014-01-01','ET','2',1,NULL,'Julie Jones','FI','514824262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:01',0,'2014-03-01 16:35:14'),(15636,16087,'0000-00-00','ET','2',1,NULL,'Diane Muntz','FI','291769989','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:53',0,'2014-03-10 14:10:12'),(18382,19032,'0000-00-00','ET','2',2,1,'Rusty D Russo','FI','439350342','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:48',0,'2014-03-02 06:45:14'),(19539,20188,'0000-00-00','ET','2',1,NULL,'Linda Scott','FI','587114454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:15:12',0,'2014-03-02 06:59:07'),(928,928,'2014-01-01','ET','2',1,NULL,'Maria Perez','FI','465988957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:57',0,'2014-03-01 22:10:55'),(17723,18373,'0000-00-00','ET','2',2,1,'susan darby','FI','185467040','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:17',0,'2014-03-01 17:20:55'),(16765,17415,'0000-00-00','ET','2',1,NULL,'Cheye Kambi','FI','438651682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-01 19:00:19',0,'2014-03-02 06:17:30'),(6163,6163,'2014-01-01','ET','2',1,NULL,'Helen Marx','FI','449875707','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-26 03:03:14',0,'2014-03-02 04:10:25'),(10975,10975,'2014-01-01','ET','2',2,1,'THOMAS EACHUS','FI','270828290','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-26 13:09:54',0,'2014-03-10 13:45:57'),(5245,5245,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:51',0,'2014-03-10 13:20:27'),(10478,10478,'2014-01-01','ET','2',2,1,'Pam Couch','FI','282586336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:11',0,'2014-03-01 16:10:36'),(18801,19451,'0000-00-00','ET','2',1,NULL,'deborah harlan','FI','302622375','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:03:08',0,'2014-03-10 14:31:05'),(20279,20929,'0000-00-00','ET','2',2,1,'Charlotte Mitchell Williams','FI','460195691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:24',0,'2014-03-02 07:03:25'),(659,659,'2014-01-01','ET','2',1,NULL,'Kathleen Mason','FI','449043962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:28',0,'2014-03-02 02:10:49'),(15917,16566,'0000-00-00','ET','2',1,NULL,'Austen Ngezelonye','FI','633983070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-25 19:00:04',0,'2014-03-02 06:03:21'),(15873,16522,'0000-00-00','ET','2',5,4,'Shannon Sherman','FI','284889987','HealthSpan','FI','311431434','Brooke  Bowerman','94','1854510','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:55',0,'2014-03-10 14:10:12'),(13826,14182,'2014-01-01','ET','2',1,NULL,'Jesse Abate','FI','042906004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:31',0,'2014-03-02 05:31:31'),(6366,6366,'2014-01-01','ET','2',1,NULL,'WILLIAM KOVALAK','FI','285587719','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:24',0,'2014-03-10 15:59:47'),(3084,3084,'2014-01-01','ET','2',1,NULL,'NANCY PIPPIT','FI','420764546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:43',0,'2014-03-02 01:10:33'),(18752,19402,'0000-00-00','ET','2',1,NULL,'JANE EDGAR','FI','615150549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:31',0,'2014-03-02 06:45:14'),(23106,23756,'0000-00-00','ET','2',3,2,'WARREN BRADFORD','FI','289804776','Dental Care Plus, Inc.','FI','311185262','KEVIN  BROUSSARD','94','16818376','348','2014-04-01','Sync Success',0,'2014-03-10 21:30:08',0,'2014-03-10 21:36:25'),(16910,17560,'0000-00-00','ET','2',1,NULL,'ASLEY NAPIER','FI','406354662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:33',0,'2014-03-01 17:00:58'),(16630,17280,'0000-00-00','ET','2',1,NULL,'Barbara Rena Stevenson','FI','467517645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:00:28',0,'2014-03-02 06:17:30'),(11664,11664,'2014-01-01','ET','2',2,1,'Donna Stamps','FI','374842996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:42',0,'2014-03-02 04:52:44'),(16108,16757,'0000-00-00','ET','2',4,3,'muhammad samaha','FI','443763155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:23',0,'2014-03-02 06:03:21'),(13485,13841,'2014-01-01','ET','2',1,NULL,'william parsley','FI','282847846','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:43',0,'2014-03-10 14:03:26'),(18612,19262,'0000-00-00','ET','2',3,2,'wendi koontz','FI','291668215','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:44',0,'2014-03-10 16:31:33'),(20461,21111,'0000-00-00','ET','2',1,NULL,'Don Xu','FI','509024297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:16',0,'2014-03-01 18:08:07'),(16936,17586,'0000-00-00','ET','2',1,NULL,'Dick Aanerud','FI','425493986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:48',0,'2014-03-02 06:17:30'),(16138,16787,'0000-00-00','ET','2',2,1,'Joseph Schlueter','94','0001250873','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:47',0,'2014-03-10 14:20:26'),(15228,15679,'0000-00-00','ET','2',1,NULL,'DIANE L MOBLEY','FI','272562258','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:45',0,'2014-03-10 16:17:47'),(1868,1868,'2014-01-01','ET','2',1,NULL,'Christopher Parker','FI','593187143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:47',0,'2014-03-01 15:26:40'),(4465,4465,'2014-01-01','ET','2',1,NULL,'CLARICE HUDSON','FI','298604554','Dental Care Plus, Inc.','FI','311185262','SAMUEL  LEARNED','94','16632472','348','2014-01-01','Sync Success',0,'2013-12-25 23:30:54',0,'2014-03-01 15:16:37'),(7614,7614,'2014-01-01','ET','2',1,NULL,'THOMAS M OBRIEN','FI','280680246','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:43',0,'2014-03-10 13:39:10'),(10581,10581,'2014-01-01','ET','2',2,1,'Rick Pipkin','FI','413928269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:36',0,'2014-03-02 04:24:47'),(21486,22136,'0000-00-00','ET','2',2,1,'CHRISTIAN OWUSU','FI','476433169','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:45',0,'2014-03-03 21:36:16'),(22596,23246,'0000-00-00','ET','2',1,NULL,'KENNETH SCHNEIDER','FI','295529024','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:20',0,'2014-03-10 14:50:59'),(17293,17943,'0000-00-00','ET','2',1,NULL,'Lazandra Hudson','FI','426331450','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:51',0,'2014-03-02 06:24:38'),(16969,17619,'0000-00-00','ET','2',4,3,'PANKAJ AERI','FI','096886549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:10',0,'2014-03-01 17:00:58'),(926,926,'2014-01-01','ET','2',1,NULL,'Chris charles','FI','400926478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:54',0,'2014-03-01 21:11:04'),(12293,12293,'2014-01-01','ET','2',1,NULL,'Ray Metzger','FI','272580741','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:03',0,'2014-03-10 13:59:38'),(11554,11554,'2014-01-01','ET','2',1,NULL,'Dann Gregory','FI','449536125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:18',0,'2014-03-02 04:52:44'),(16418,17068,'0000-00-00','ET','2',1,NULL,'Mary L Traxler','FI','271602385','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:01:38',0,'2014-03-10 14:20:26'),(2728,2728,'2014-01-01','ET','2',1,NULL,'William Levy','FI','222423549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:03',0,'2014-03-02 04:15:49'),(11340,11340,'2014-01-01','ET','2',2,1,'LAURA DENISE SMART','FI','460338397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:44',0,'2014-03-02 04:52:44'),(2904,2904,'2014-01-01','ET','2',1,NULL,'Teresa JEAN Flores','FI','431254557','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:06',0,'2014-03-10 13:24:34'),(15201,15652,'0000-00-00','ET','2',1,NULL,'THOMAS BERRY','FI','268620255','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:25',0,'2014-03-01 16:50:53'),(13445,13801,'2014-01-01','ET','2',1,NULL,'ALISON BOLTON','FI','466753179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:16',0,'2014-03-02 05:31:31'),(13581,13937,'2014-01-01','ET','2',1,NULL,'carla J  Herbert','FI','278522526','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:11',0,'2014-03-10 16:10:34'),(14854,15305,'2014-01-01','ET','2',1,NULL,'Steven Gonzales','FI','452879190','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:03',0,'2014-03-02 05:45:37'),(21868,22518,'0000-00-00','ET','2',1,NULL,'Margaret McConnell','FI','207668856','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:19',0,'2014-03-05 21:36:22'),(17431,18081,'0000-00-00','ET','2',1,NULL,'Tristan Hamlett','FI','641181361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:03',0,'2014-03-02 06:31:45'),(1834,1834,'2014-01-01','ET','2',1,NULL,'karen a okeeffe','FI','365507485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:43',0,'2014-03-10 13:20:27'),(11461,11461,'2014-01-01','ET','2',1,NULL,'Julia Sweazy','FI','270542075','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:30',0,'2014-03-01 16:30:17'),(14613,15064,'2014-01-01','ET','2',1,NULL,'Donald Borger','FI','283420431','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:58',0,'2014-03-01 16:46:19'),(14224,14675,'2014-01-01','ET','2',1,NULL,'rebecca davenport','FI','230880643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:51',0,'2014-03-02 05:38:34'),(7095,7095,'2014-01-01','ET','2',1,NULL,'DON BRAND','FI','288521638','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:03:28',0,'2014-03-01 15:52:44'),(21422,22072,'0000-00-00','ET','2',1,NULL,'Miriam smith','FI','282583910','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:25',0,'2014-03-10 14:45:25'),(11547,11547,'2014-01-01','ET','2',2,1,'Enrique Urquieta','FI','456731169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:02',0,'2014-03-02 04:52:44'),(11174,11174,'2014-01-01','ET','2',1,NULL,'Ideaner Brooks','FI','269487483','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:16:47',0,'2014-03-10 13:45:57'),(17860,18510,'0000-00-00','ET','2',1,NULL,'Neil Newman','FI','286562076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:10',0,'2014-03-01 17:20:55'),(10731,10731,'2014-01-01','ET','2',1,NULL,'Cosette Verga','FI','218491885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:01:40',0,'2014-03-01 16:10:36'),(15804,16453,'0000-00-00','ET','2',1,NULL,'CRISTIANA  REYES','FI','082311308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:14',0,'2014-03-02 06:03:21'),(5402,5402,'2014-01-01','ET','2',1,NULL,'Lonnie hicks','FI','461310516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:16',0,'2014-03-01 20:10:57'),(6404,6404,'2014-01-01','ET','2',1,NULL,'Susan Eaton','FI','369660017','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:36',0,'2014-03-10 13:39:10'),(20316,20966,'0000-00-00','ET','2',1,NULL,'Terri McWhorter','FI','453351364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-08','Sync Success',0,'2014-02-26 08:30:05',0,'2014-03-02 07:03:25'),(22064,22714,'0000-00-00','ET','2',1,NULL,'Marcia Hart','94','0000234116','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:39',0,'2014-03-10 14:45:25'),(22130,22780,'0000-00-00','ET','2',1,NULL,'CATHERINE HUGHES','FI','579641798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:51',0,'2014-03-06 21:27:26'),(11381,11381,'2014-01-01','ET','2',1,NULL,'Harold Hornschemeir','FI','275563403','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:58',0,'2014-03-10 13:52:32'),(7649,7649,'2014-01-01','ET','2',2,1,'ignacio perez','FI','268569788','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:38:48',0,'2014-03-10 13:39:10'),(3673,3673,'2014-01-01','ET','2',1,NULL,'Robert Jackson','FI','276749517','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:39',0,'2014-03-10 13:20:27'),(3976,3976,'2014-01-01','ET','2',1,NULL,'Thomas Edward Bonnington','FI','535729368','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:47:26',0,'2014-03-10 13:10:24'),(4049,4049,'2014-01-01','ET','2',1,NULL,'MARIANELA P GARZA','FI','452902423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:39',0,'2014-03-02 03:09:49'),(16208,16857,'0000-00-00','ET','2',2,1,'BLANCA   LOZANO','FI','467979227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:45',0,'2014-03-02 06:03:21'),(7570,7570,'2014-01-01','ET','2',1,NULL,'Courtney Lee Armentrout','FI','276942058','Dental Care Plus, Inc.','FI','311185262','William James Mcilroy','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:19',0,'2014-03-01 16:05:34'),(5626,5626,'2014-01-01','ET','2',3,2,'timothy bonifant','FI','274608090','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:34',0,'2014-03-10 16:03:49'),(5942,5942,'2014-01-01','ET','2',1,NULL,'KIRK DAVIS','FI','434711332','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:05',0,'2014-03-02 01:10:33'),(15373,15824,'0000-00-00','ET','2',1,NULL,'jacqueline antointte gresham','FI','550392904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:52',0,'2014-03-02 05:59:43'),(12976,12976,'2014-01-01','ET','2',1,NULL,'Vanessa Luna','FI','633500008','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:18',0,'2014-03-02 05:17:40');
INSERT INTO `Edi834` VALUES (14020,14376,'2014-01-01','ET','2',2,1,'damir usanovic','FI','270028859','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:45',0,'2014-03-10 16:17:47'),(18281,18931,'0000-00-00','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:10',0,'2014-03-10 14:24:38'),(18955,19605,'0000-00-00','ET','2',1,NULL,'HEATHER FOURNIER','FI','300909419','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:41',0,'2014-03-10 14:31:05'),(19352,20002,'0000-00-00','ET','2',1,NULL,'DENISE STEWART','FI','439040520','Starmount Life Insurance Company','FI','720977315','JOHN  ANNAN','94','4739112','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:34',0,'2014-03-02 06:59:07'),(20060,20710,'0000-00-00','ET','2',1,NULL,'AIDA TREVINO','FI','466172660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:18',0,'2014-03-02 07:10:28'),(20526,21176,'0000-00-00','ET','2',2,1,'Jose Ayala','FI','450574351','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:01',0,'2014-03-02 07:10:28'),(11520,11520,'2014-01-01','ET','2',1,NULL,'Audrey Newman','FI','216467335','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:15',0,'2014-03-02 04:52:44'),(17834,18484,'0000-00-00','ET','2',1,NULL,'adrian sconiers','FI','523330298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:02',0,'2014-03-02 06:03:21'),(17345,17995,'0000-00-00','ET','2',1,NULL,'ANGELICA   SMITH','FI','285680903','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:19',0,'2014-03-10 14:24:38'),(17231,17881,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:21',0,'2014-03-10 16:24:30'),(6431,6431,'2014-01-01','ET','2',1,NULL,'Eileen Jennings','FI','274569493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:28',0,'2014-03-01 15:10:22'),(6382,6382,'2014-01-01','ET','2',1,NULL,'Bonnie Brown','FI','278643030','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:55',0,'2014-03-10 13:39:10'),(3998,3998,'2014-01-01','ET','2',1,NULL,'Rosemary  Estrada','FI','626549830','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:07',0,'2014-03-02 03:09:49'),(21269,21919,'0000-00-00','ET','2',1,NULL,'Travis E Lilly','94','0000242765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:42',0,'2014-03-01 21:35:40'),(22198,22848,'0000-00-00','ET','2',1,NULL,'JOHNNIE KEYES','FI','427493219','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:38',0,'2014-03-06 21:27:26'),(22410,23060,'0000-00-00','ET','2',1,NULL,'MATILDE MARTINEZ','FI','633447502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:06',0,'2014-03-07 22:26:59'),(16396,17046,'0000-00-00','ET','2',1,NULL,'Neal Roberts','FI','641106150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:24',0,'2014-03-02 06:10:30'),(1015,1015,'2014-01-01','ET','2',1,NULL,'margaret mcgurk','FI','327428496','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:44',0,'2014-03-10 13:10:24'),(1320,1320,'2014-01-01','ET','2',1,NULL,'EMILIA LOPEZ','FI','585311756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:27',0,'2014-03-02 04:38:08'),(12566,12566,'2014-01-01','ET','2',1,NULL,'Melinda Rutkowski','FI','232237589','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:56',0,'2014-03-10 13:59:38'),(15226,15677,'0000-00-00','ET','2',1,NULL,'Brandy C Oliver','FI','285748755','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:44',0,'2014-03-10 16:17:47'),(4946,4946,'2014-01-01','ET','2',2,1,'Garret Hebenstreit','FI','298581902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:40',0,'2014-03-01 15:10:22'),(4711,4711,'2014-01-01','ET','2',2,1,'Robert Warren','FI','405980843','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:00',0,'2014-03-10 13:45:57'),(7672,7672,'2014-01-01','ET','2',1,NULL,'August Mackenbach','FI','279422759','HealthSpan','FI','311431434','Steve   Schmitmeyer','94','2326455','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:35',0,'2014-03-10 13:39:10'),(5124,5124,'2014-01-01','ET','2',1,NULL,'Diana Lynn Miller','FI','271540215','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:01',0,'2014-03-10 15:45:56'),(18633,19283,'0000-00-00','ET','2',1,NULL,'Matthew J Zecher','FI','297623925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:00',0,'2014-03-01 17:26:36'),(18736,19386,'0000-00-00','ET','2',1,NULL,'DAVID FRANKOWSKI','FI','292866647','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:19',0,'2014-03-10 16:31:33'),(21145,21795,'0000-00-00','ET','2',1,NULL,'HILGON GENON','FI','439170025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:18',0,'2014-03-02 07:23:39'),(22557,23207,'0000-00-00','ET','2',1,NULL,'Carol Lindsay','FI','297428298','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:51',0,'2014-03-10 16:44:18'),(144,144,'2014-01-01','ET','2',1,NULL,'Diane Hatch','FI','273464349','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:29',0,'2014-03-10 15:45:56'),(17013,17663,'0000-00-00','ET','2',1,NULL,'Vinetta Vault','FI','438883868','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:06',0,'2014-03-02 06:24:38'),(16518,17168,'0000-00-00','ET','2',1,NULL,'Kimberly Kimburbrough','FI','587211125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:49',0,'2014-03-02 06:10:30'),(1445,1445,'2014-01-01','ET','2',2,1,'Jeffrey George','FI','294521655','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:32',0,'2014-03-01 16:15:39'),(3519,3519,'2014-01-01','ET','2',1,NULL,'STANLEY HILL','FI','300460375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:47',0,'2014-03-01 15:37:30'),(4301,4301,'2014-01-01','ET','2',1,NULL,'Thomas Walker','FI','587599470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:20',0,'2014-03-02 03:09:49'),(15131,15582,'0000-00-00','ET','2',1,NULL,'Brandon Warman','FI','290900014','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:14',0,'2014-03-10 16:17:47'),(14919,15370,'2014-01-01','ET','2',2,1,'Paul Liccardi','FI','286786193','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:32',0,'2014-03-01 16:50:53'),(14772,15223,'2014-01-01','ET','2',1,NULL,'joseph holt','FI','259555920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:40',0,'2014-03-02 05:45:37'),(5534,5534,'2014-01-01','ET','2',1,NULL,'Vickie Smilanich','FI','269503858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:31',0,'2014-03-01 16:23:43'),(18740,19390,'0000-00-00','ET','2',1,NULL,'JANICE HAMILTON','FI','434150774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:22',0,'2014-03-02 06:45:14'),(19612,20262,'0000-00-00','ET','2',1,NULL,'riley tucker','94','0000172464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:18',0,'2014-03-01 17:34:07'),(16584,17234,'0000-00-00','ET','2',1,NULL,'KATHLENNE Labert','FI','293484973','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:33',0,'2014-03-10 14:20:26'),(5503,5503,'2014-01-01','ET','2',2,1,'Elizabeth Wallace','FI','278827640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:31',0,'2014-03-01 16:23:43'),(7150,7150,'2014-01-01','ET','2',1,NULL,'Jorge Machado','FI','590373618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:05',0,'2014-03-10 15:59:47'),(13739,14095,'2014-01-01','ET','2',1,NULL,'Margaret Turbett','FI','282467873','HealthSpan','FI','311431434','David   Randolph','94','2776924','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:07',0,'2014-03-10 13:59:38'),(14879,15330,'2014-01-01','ET','2',1,NULL,'LOUIS S CONSTANCIO','FI','638034477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:14',0,'2014-03-02 05:52:31'),(21109,21759,'0000-00-00','ET','2',3,2,'Dorothea Lillie Hunter Carter','FI','451439447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:52',0,'2014-03-02 07:23:39'),(22527,23177,'0000-00-00','ET','2',1,NULL,'VALARIE VARLAMOS','FI','298866740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:30',0,'2014-03-07 21:36:32'),(18201,18851,'0000-00-00','ET','2',1,NULL,'CHRISTINA  T  SHAMPTON','FI','268644448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:54',0,'2014-03-01 17:26:36'),(7405,7405,'2014-01-01','ET','2',1,NULL,'Yolanda Dogan','FI','436237626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:01',0,'2014-03-02 04:10:25'),(3840,3840,'2014-01-01','ET','2',2,1,'Terri Combs','FI','290602174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:15',0,'2014-03-01 15:05:09'),(3994,3994,'2014-01-01','ET','2',2,1,'Carltan Mohr','FI','293423015','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:48:06',0,'2014-03-10 15:45:56'),(1578,1578,'2014-01-01','ET','2',1,NULL,'Bruce Edwin Walker','FI','276684538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:34',0,'2014-03-01 15:10:22'),(2306,2306,'2014-01-01','ET','2',1,NULL,'james linson','FI','435794429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:26',0,'2014-03-01 19:11:03'),(17933,18583,'0000-00-00','ET','2',1,NULL,'BRENDA KING','FI','458041626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:52',0,'2014-03-02 06:38:05'),(1405,1405,'2014-01-01','ET','2',1,NULL,'DEANDRIA  WILSON','FI','433319164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:13',0,'2014-03-02 04:38:08'),(19922,20572,'0000-00-00','ET','2',1,NULL,'Zachary McCain','FI','415639064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:17',0,'2014-03-02 07:03:25'),(5465,5465,'2014-01-01','ET','2',1,NULL,'Benjamin Wright','FI','438980229','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:19',0,'2014-03-02 04:45:37'),(4618,4618,'2014-01-01','ET','2',2,1,'Travis Livingston','FI','452378250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:48',0,'2014-03-02 04:31:46'),(17647,18297,'0000-00-00','ET','2',1,NULL,'TODD WHORTON','FI','299602258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:33',0,'2014-03-01 17:20:55'),(11451,11451,'2014-01-01','ET','2',2,1,'Daniel Czaplicki','FI','415434641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:11',0,'2014-03-01 16:23:43'),(11327,11327,'2014-01-01','ET','2',1,NULL,'DANNY CULVER','FI','458841688','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:19',0,'2014-03-02 04:52:44'),(10836,10836,'2014-01-01','ET','2',1,NULL,'Oliver Pierre','FI','435880987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:01',0,'2014-03-02 04:31:46'),(7295,7295,'2014-01-01','ET','2',1,NULL,'Patricia Knitz','FI','281813390','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:33',0,'2014-03-10 13:32:15'),(6374,6374,'2014-01-01','ET','2',1,NULL,'Jerry Hosler','FI','274524941','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:41',0,'2014-03-10 13:39:10'),(2030,2030,'2014-01-01','ET','2',1,NULL,'thomas bruneau','FI','047767173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:49',0,'2014-03-01 23:10:52'),(17354,18004,'0000-00-00','ET','2',1,NULL,'Sarah Christine Golleher','FI','566943627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:10',0,'2014-03-02 06:31:45'),(20422,21072,'0000-00-00','ET','2',1,NULL,'MICHAEL LOJEWSKI','FI','291486302','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:44',0,'2014-03-01 18:08:07'),(21001,21651,'0000-00-00','ET','2',1,NULL,'Lowell Bentley','FI','529450421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:00:02',0,'2014-03-02 07:17:36'),(16955,17605,'0000-00-00','ET','2',1,NULL,'JULIO B AYALA','FI','624843310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:02',0,'2014-03-02 06:24:38'),(15994,16643,'0000-00-00','ET','2',1,NULL,'RICKY CASTILLO','FI','450533391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:07',0,'2014-03-02 06:03:21'),(22401,23051,'0000-00-00','ET','2',1,NULL,'Tyler Earl Cantrell','FI','286821936','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:36',0,'2014-03-10 14:50:59'),(15398,15849,'0000-00-00','ET','2',1,NULL,'angel carrazco','FI','561498100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:08',0,'2014-03-02 05:59:43'),(14937,15388,'2014-01-01','ET','2',1,NULL,'Christine Sleeper','FI','301541899','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:41',0,'2014-03-01 16:50:53'),(14778,15229,'2014-01-01','ET','2',1,NULL,'Kevin Gravett','FI','300825443','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:43',0,'2014-03-10 14:03:26'),(13737,14093,'2014-01-01','ET','2',1,NULL,'lugene spurgeon','FI','437022703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:06',0,'2014-03-02 05:24:45'),(13284,13640,'2014-01-01','ET','2',1,NULL,'heather dedon','FI','437631007','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:06',0,'2014-03-02 05:24:45'),(11783,11783,'2014-01-01','ET','2',1,NULL,'Jose osbaldo Contreras','FI','639261757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:35',0,'2014-03-02 04:31:46'),(11861,11861,'2014-01-01','ET','2',2,1,'Rhonda Prince','FI','300706628','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:11',0,'2014-03-10 16:03:49'),(17087,17737,'0000-00-00','ET','2',1,NULL,'David Johnson','FI','372821274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:52',0,'2014-03-01 17:00:58'),(12195,12195,'2014-01-01','ET','2',1,NULL,'sarah barnette','FI','297509896','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:09',0,'2014-03-10 13:52:32'),(16427,17077,'0000-00-00','ET','2',1,NULL,'KATHLEEN  CORNE','FI','378544819','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:01:44',0,'2014-03-10 14:20:26'),(5034,5034,'2014-01-01','ET','2',1,NULL,'LINDA JANSON','FI','276448198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:04',0,'2014-03-01 15:31:33'),(4969,4969,'2014-01-01','ET','2',1,0,'Frank C Rocca','FI','283441555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:24',0,'2014-03-01 15:05:09'),(3641,3641,'2014-01-01','ET','2',2,1,'CONNIE ARMSTRONG','FI','278522095','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:38',0,'2014-03-10 15:52:36'),(21811,22461,'0000-00-00','ET','2',1,NULL,'LILVIA TREMILLO','FI','640602666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:11',0,'2014-03-05 21:25:24'),(467,467,'2014-01-01','ET','2',2,1,'Jennifer Reynolds','FI','295806509','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:33',0,'2014-03-10 13:10:24'),(1028,1028,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:07',0,'2014-03-10 13:10:24'),(11422,11422,'2014-01-01','ET','2',1,NULL,'Ashley Brahler','FI','296902126','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:16',0,'2014-03-10 16:03:49'),(19353,20003,'0000-00-00','ET','2',1,NULL,'Albert Sanders','FI','437152721','Starmount Life Insurance Company','FI','720977315','Christine  Levy','94','4700527','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:35',0,'2014-03-02 06:59:07'),(16455,17105,'0000-00-00','ET','2',1,NULL,'Bonita Horton','FI','297885780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:09',0,'2014-03-01 17:00:58'),(16105,16754,'0000-00-00','ET','2',1,NULL,'MARY  DEMROVSKY','FI','276648162','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:20',0,'2014-03-10 16:24:30'),(19929,20579,'0000-00-00','ET','2',2,1,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:22',0,'2014-03-10 14:37:47'),(20078,20728,'0000-00-00','ET','2',1,NULL,'Gregory Macias','FI','268740029','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:31',0,'2014-03-10 14:37:47'),(20311,20961,'0000-00-00','ET','2',1,NULL,'CARLOS AVILES','FI','148581453','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:50',0,'2014-03-01 17:47:19'),(22838,23488,'0000-00-00','ET','2',1,NULL,'LeeAnna Stevens','FI','451026975','Starmount Life Insurance Company','FI','720977315','Daniel  Abrams','94','2717565','357','2014-03-31','Sync Success',0,'2014-03-09 21:30:03',0,'2014-03-09 22:25:06'),(4980,4980,'2014-01-01','ET','2',2,1,'randy miller','FI','289528760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:21',0,'2014-03-01 15:31:33'),(4396,4396,'2014-01-01','ET','2',1,NULL,'Karl Kalk','FI','271488012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:48',0,'2014-03-01 15:16:37'),(15237,15688,'0000-00-00','ET','2',2,1,'Chuanhong Wang','FI','298960872','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:18',0,'2014-03-01 16:50:53'),(14111,14562,'2014-01-01','ET','2',1,NULL,'kevin l gamiere','FI','297588804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:42',0,'2014-03-01 16:40:16'),(14572,15023,'2014-01-01','ET','2',1,NULL,'Ogechukwu Offor','FI','630602300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:32',0,'2014-03-02 05:45:37'),(19,19,'2014-01-01','ET','2',1,NULL,'Jeanne Wagner','FI','281585659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:35',0,'2014-03-01 15:21:15'),(14943,15394,'2014-01-01','ET','2',1,NULL,'Eddie Zarnick','FI','363649306','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:44',0,'2014-03-10 14:10:12'),(12831,12831,'2014-01-01','ET','2',1,NULL,'Randy Paille','FI','434379670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:22',0,'2014-03-02 05:10:52'),(2456,2456,'2014-01-01','ET','2',1,NULL,'KEITH JACKSON','FI','433710065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:03',0,'2014-03-01 23:10:52'),(10720,10720,'2014-01-01','ET','2',6,5,'DEBORAH STROUD','FI','092625858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:14',0,'2014-03-01 16:10:36'),(20818,21468,'0000-00-00','ET','2',1,NULL,'Richard Vincent Mazzolla','FI','145922807','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:07',0,'2014-03-02 07:17:36'),(22506,23156,'0000-00-00','ET','2',1,NULL,'Molly Cozad','FI','438671417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:15',0,'2014-03-07 22:26:59'),(995,995,'2014-01-01','ET','2',2,1,'Kim Carpenter','FI','273529325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:04',0,'2014-03-01 15:21:15'),(19260,19910,'0000-00-00','ET','2',1,NULL,'Co Vo','FI','731260218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:06',0,'2014-03-02 06:52:12'),(13375,13731,'2014-01-01','ET','2',1,NULL,'Jessica Mojica','FI','456812925','Starmount Life Insurance Company','FI','720977315','Jesse  Mojica','94','1103701','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:43',0,'2014-03-02 05:24:45'),(12150,12150,'2014-01-01','ET','2',1,NULL,'Yvonne Traylor','FI','587067923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:26',0,'2014-03-02 04:59:36'),(11217,11217,'2014-01-01','ET','2',1,NULL,'KIM B GAMBEL','FI','291607011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:58',0,'2014-03-01 16:23:43'),(3268,3268,'2014-01-01','ET','2',1,NULL,'Justin Edens','FI','426754086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:26',0,'2014-03-02 02:10:49'),(10994,10994,'2014-01-01','ET','2',2,1,'WT WALTON','FI','587609116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:33',0,'2014-03-02 04:24:47'),(19102,19752,'0000-00-00','ET','2',1,NULL,'Randal Johnson','FI','281801861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:45',0,'2014-03-01 17:34:07'),(18039,18689,'0000-00-00','ET','2',1,NULL,'MARILYN THOBE','FI','307703849','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:06',0,'2014-03-10 14:24:38'),(20110,20760,'0000-00-00','ET','2',1,NULL,'Jamey Purtty','FI','302827724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:27',0,'2014-03-10 16:38:05'),(21068,21718,'0000-00-00','ET','2',1,NULL,'DAEBORAH CURTIS','FI','301442474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:30:26',0,'2014-03-01 18:10:11'),(21447,22097,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:16',0,'2014-03-10 16:44:18'),(16534,17184,'0000-00-00','ET','2',4,3,'Matthew Henry','FI','576629098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:59',0,'2014-03-01 17:00:58'),(21861,22511,'0000-00-00','ET','2',1,NULL,'Heather Adams','FI','285789535','Dental Care Plus, Inc.','FI','311185262','John L Nelson','94','2256884','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:14',0,'2014-03-05 21:36:22'),(19541,20191,'0000-00-00','ET','2',2,1,'TYSHA TUCKER','FI','428494080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:15:45',0,'2014-03-02 06:59:07'),(19212,19862,'0000-00-00','ET','2',1,NULL,'Michelle Cole','FI','268861360','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:09',0,'2014-03-10 14:31:05'),(11898,11898,'2014-01-01','ET','2',1,NULL,'Jacqueline Johnson','FI','437796894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:57',0,'2014-03-02 04:59:36'),(502,502,'2014-01-01','ET','2',1,NULL,'CONSTANCE HUGHES','FI','286565506','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:32',0,'2014-03-01 15:48:04'),(11230,11230,'2014-01-01','ET','2',2,1,'MARK  WELAGE','FI','287623129','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:21',0,'2014-03-01 16:23:43'),(11070,11070,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:08',0,'2014-03-10 16:03:49'),(1449,1449,'2014-01-01','ET','2',1,NULL,'Stephen Kyle Green','FI','086783850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:41',0,'2014-03-01 16:15:39'),(1824,1824,'2014-01-01','ET','2',2,1,'Curtis Schrack','FI','297781975','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:22',0,'2014-03-10 15:45:56'),(1967,1967,'2014-01-01','ET','2',2,1,'Paula Elkins','FI','272642676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:42',0,'2014-03-01 15:26:40'),(2103,2103,'2014-01-01','ET','2',1,NULL,'ELLEN  L ESTEP','FI','274642702','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:38:11',0,'2014-03-10 13:20:27'),(2119,2119,'2014-01-01','ET','2',1,NULL,'VICTOR L BULLOCK','FI','298564282','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:45:31',0,'2014-03-01 15:16:37'),(11051,11051,'2014-01-01','ET','2',1,NULL,'Kathy McCarthy','FI','275485664','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:29',0,'2014-03-10 16:03:49'),(18936,19586,'0000-00-00','ET','2',2,1,'William Houck','FI','293521644','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:28',0,'2014-03-10 16:31:33'),(10739,10739,'2014-01-01','ET','2',1,NULL,'MALISSA L HUFF','FI','329765278','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:51',0,'2014-03-01 16:10:36'),(17311,17961,'0000-00-00','ET','2',1,NULL,'sheena wagner','FI','439559075','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:01',0,'2014-03-02 06:24:38'),(3260,3260,'2014-01-01','ET','2',1,NULL,'Michael Gingo','94','0001155094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:08',0,'2014-03-10 15:52:36'),(5281,5281,'2014-01-01','ET','2',1,NULL,'freddie travis davis','FI','268763143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:46',0,'2014-03-01 15:10:22'),(3900,3900,'2014-01-01','ET','2',1,NULL,'NITAYA Y MCDONALD','FI','301782994','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:15',0,'2014-03-10 15:39:19'),(4803,4803,'2014-01-01','ET','2',1,NULL,'Elise Gardner','FI','271860040','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:58',0,'2014-03-01 15:16:37'),(22391,23041,'0000-00-00','ET','2',1,NULL,'KAREN KALTENBACH','FI','273661164','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:31',0,'2014-03-10 16:44:18'),(12478,12478,'2014-01-01','ET','2',1,NULL,'RANDALL PATRICK ARLEDGE','FI','293623667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:32:28',0,'2014-03-01 16:30:17'),(13209,13565,'2014-01-01','ET','2',1,NULL,'MARSHA F EVANS','FI','557845054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:22',0,'2014-03-02 05:17:40'),(13181,13537,'2014-01-01','ET','2',1,NULL,'Mary Rosenberg','FI','276446352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:58',0,'2014-03-10 16:10:34'),(2284,2284,'2014-01-01','ET','2',1,NULL,'Helen Houghton','FI','288548643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:39',0,'2014-03-10 15:39:19'),(2850,2850,'2014-01-01','ET','2',1,NULL,'Amanda Little','FI','289683109','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:01',0,'2014-03-10 15:59:47'),(16691,17341,'0000-00-00','ET','2',1,NULL,'Lon Zaerr','FI','489704586','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:11',0,'2014-03-10 14:20:26'),(13035,13391,'2014-01-01','ET','2',1,NULL,'JANICE LYNN BARNHART','FI','269526310','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:34',0,'2014-03-01 16:35:14'),(7056,7056,'2014-01-01','ET','2',2,1,'JOYCE  ARTHEROUS  HURLEY','FI','292443860','Dental Care Plus, Inc.','FI','311185262','JOSEPH   LASKOSKY','94','618186','348','2014-01-01','Sync Success',0,'2013-12-26 04:02:12',0,'2014-03-01 15:52:44'),(4860,4860,'2014-01-01','ET','2',1,NULL,'JEFFREY  GERSON CORREA','FI','614608974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:55',0,'2014-03-01 20:10:57'),(22905,23555,'0000-00-00','ET','2',1,NULL,'Richard Howard','FI','434219861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:45',0,'2014-03-10 21:27:11'),(170,170,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:17',0,'2014-03-10 13:10:24'),(196,196,'2014-01-01','ET','2',1,NULL,'Michael P Meehan','FI','272442526','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:07',0,'2014-03-10 13:10:24'),(512,512,'2014-01-01','ET','2',1,NULL,'IRENE MAKRIDES','FI','292622632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:49',0,'2014-03-01 15:48:04'),(18099,18749,'0000-00-00','ET','2',1,NULL,'Amy Nichols','FI','467919254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:37',0,'2014-03-02 06:38:05'),(20930,21580,'0000-00-00','ET','2',1,NULL,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:00:22',0,'2014-03-10 16:38:05'),(14566,15017,'2014-01-01','ET','2',1,NULL,'ANABEL RIVERA','FI','451499643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:28',0,'2014-03-02 05:45:37'),(5501,5501,'2014-01-01','ET','2',1,NULL,'Elizabeth Rhodes','FI','320869386','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:27',0,'2014-03-01 16:23:43'),(5667,5667,'2014-01-01','ET','2',1,NULL,'anne sullivan','FI','219723111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:56',0,'2014-03-02 04:45:37'),(20133,20783,'0000-00-00','ET','2',1,NULL,'JULIE LEON','94','0000518455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:43',0,'2014-03-01 18:08:07'),(21008,21658,'0000-00-00','ET','2',1,NULL,'erlin crochet','FI','439942861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:06',0,'2014-03-02 07:23:39'),(21638,22288,'0000-00-00','ET','2',2,1,'Leandro Garza','FI','636448108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:49',0,'2014-03-04 21:27:16'),(11574,11574,'2014-01-01','ET','2',1,NULL,'Glenda Morales','FI','633181353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:58',0,'2014-03-02 04:52:44'),(17871,18521,'0000-00-00','ET','2',1,NULL,'KIMBALL LAURENCE NEILL','FI','268522107','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:07',0,'2014-03-10 16:31:33'),(13302,13658,'2014-01-01','ET','2',2,1,'ANTHONY DWERTMAN','FI','280706013','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:13',0,'2014-03-01 16:40:16'),(7386,7386,'2014-01-01','ET','2',2,1,'Tony Aulds','FI','437671985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:21',0,'2014-03-02 04:15:49'),(3455,3455,'2014-01-01','ET','2',1,NULL,'Stuart Nizny','FI','278707739','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:30',0,'2014-03-10 13:32:15'),(18896,19546,'0000-00-00','ET','2',1,NULL,'ASHLEY SIMS','FI','292802788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:59',0,'2014-03-01 17:34:07'),(19447,20097,'0000-00-00','ET','2',2,1,'Caleb Woods','FI','315881716','HealthSpan','FI','311431434','Dianne  Rudolph','94','13065591','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:44',0,'2014-03-10 14:31:05'),(16950,17600,'0000-00-00','ET','2',1,NULL,'Michael Jordan','FI','433419909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:59',0,'2014-03-02 06:17:30'),(2447,2447,'2014-01-01','ET','2',1,NULL,'KENNETH WADE STEGER','FI','585882324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:46',0,'2014-03-01 23:10:52'),(2679,2679,'2014-01-01','ET','2',1,NULL,'JOE VALLE','FI','364643238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:32',0,'2014-03-02 04:15:49'),(16493,17143,'0000-00-00','ET','2',1,NULL,'Linda Bonner','FI','366601345','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:32',0,'2014-03-02 06:10:30'),(4493,4493,'2014-01-01','ET','2',2,1,'Gregory Lee Burke','FI','299525000','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:50',0,'2014-03-10 15:39:19'),(11165,11165,'2014-01-01','ET','2',2,1,'Richard Root','FI','283680560','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:28',0,'2014-03-10 13:45:57'),(10539,10539,'2014-01-01','ET','2',1,NULL,'Rosalind Brown','FI','506964704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:07',0,'2014-03-02 04:31:46'),(20122,20772,'0000-00-00','ET','2',1,NULL,'John Saladino','FI','299025252','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:35',0,'2014-03-01 18:08:07'),(20656,21306,'0000-00-00','ET','2',1,NULL,'Gayle Miller','FI','271544523','Summa Insurance Company, Inc.','FI','341809108','Charles  Tennett','94','2778537','348','2014-03-01','Sync Success',0,'2014-02-26 21:02:29',0,'2014-03-10 16:38:05'),(17792,18442,'0000-00-00','ET','2',1,NULL,'Brandon Michael Woo','FI','290602298','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:26',0,'2014-03-01 16:50:53'),(16071,16720,'0000-00-00','ET','2',1,NULL,'Christopher Cooper','FI','275700340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:00:57',0,'2014-03-01 16:56:22'),(14563,15014,'2014-01-01','ET','2',1,NULL,'Maria D Gonzalez','FI','458231694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:27',0,'2014-03-02 05:45:37'),(13711,14067,'2014-01-01','ET','2',1,NULL,'kevin l gamiere','FI','297588804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:47',0,'2014-03-01 16:40:16'),(2824,2824,'2014-01-01','ET','2',1,NULL,'Robert Goldstein','FI','125622712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:06',0,'2014-03-02 04:15:49'),(7208,7208,'2014-01-01','ET','2',1,NULL,'Erik Shelton','FI','383823076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:54',0,'2014-03-01 15:52:44'),(4831,4831,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:51',0,'2014-03-10 13:10:24'),(5072,5072,'2014-01-01','ET','2',1,NULL,'Janet Ann Whitaker','FI','292427145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:48:19',0,'2014-03-01 15:31:33'),(21933,22583,'0000-00-00','ET','2',1,NULL,'deborah wooldridge','FI','451814911','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:06',0,'2014-03-05 22:27:33'),(13185,13541,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:06:06',0,'2014-03-10 16:10:34'),(1826,1826,'2014-01-01','ET','2',1,NULL,'Benjamin Starcher','FI','287749582','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:25',0,'2014-03-10 15:45:56'),(4665,4665,'2014-01-01','ET','2',1,NULL,'TONI SHORTS','FI','281445322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:24',0,'2014-03-01 16:15:39'),(11833,11833,'2014-01-01','ET','2',1,NULL,'Jarrod Hebert','FI','436798534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:09',0,'2014-03-02 04:31:46'),(608,608,'2014-01-01','ET','2',2,1,'Jean Joseph-Vanderpool','FI','081466744','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:52',0,'2014-03-02 02:10:49'),(10684,10684,'2014-01-01','ET','2',2,1,'Brian Homer','FI','277885161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:57',0,'2014-03-01 16:10:36'),(4706,4706,'2014-01-01','ET','2',1,NULL,'Michael Margoni','FI','378763520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:50',0,'2014-03-02 04:38:08'),(1068,1068,'2014-01-01','ET','2',2,1,'LLOYD HENRY','FI','306506515','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:52',0,'2014-03-01 15:16:37'),(15118,15569,'0000-00-00','ET','2',1,NULL,'amanda s cline','FI','592367878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:03',0,'2014-03-01 16:50:53'),(16843,17493,'0000-00-00','ET','2',1,NULL,'Keith Friedman','FI','549578769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:20',0,'2014-03-01 17:00:58'),(19166,19816,'0000-00-00','ET','2',1,NULL,'Margie Hartnett','FI','467081166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:36',0,'2014-03-02 06:52:12'),(20969,21619,'0000-00-00','ET','2',1,NULL,'Chris Bencar','FI','272909722','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:30:18',0,'2014-03-01 18:10:11'),(17425,18075,'0000-00-00','ET','2',1,NULL,'Delilah Meyers','FI','277808240','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:59',0,'2014-03-10 14:24:38'),(17094,17744,'0000-00-00','ET','2',1,NULL,'Beth Wittenauer','FI','271683322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:57',0,'2014-03-01 17:00:58'),(17053,17703,'0000-00-00','ET','2',1,NULL,'Jose Jaquez','FI','629907200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:32',0,'2014-03-02 06:24:38'),(16184,16833,'0000-00-00','ET','2',1,NULL,'Nancy LaFever','FI','281544844','Dental Care Plus, Inc.','FI','311185262','kerry  lang','94','2348800','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:28',0,'2014-03-01 16:56:22'),(21163,21813,'0000-00-00','ET','2',1,NULL,'Marvin Alexander','FI','437112322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:30',0,'2014-03-02 07:23:39'),(21816,22466,'0000-00-00','ET','2',1,NULL,'Adrian Pasaret','FI','626200022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:14',0,'2014-03-05 21:25:24'),(206,206,'2014-01-01','ET','2',2,1,'Tabitha Snyder','FI','272922088','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:27',0,'2014-03-10 13:10:24'),(18145,18795,'0000-00-00','ET','2',1,NULL,'James Webb','FI','437174456','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:11',0,'2014-03-02 06:38:05'),(14054,14505,'2014-01-01','ET','2',2,1,'Cheryl A Copley','FI','283665560','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:04',0,'2014-03-01 16:46:19'),(1228,1228,'2014-01-01','ET','2',1,NULL,'John Nicholas','FI','277685018','Dental Care Plus, Inc.','FI','311185262','Joseph  Dintino','94','2207884','348','2014-01-01','Sync Success',0,'2013-12-25 18:48:37',0,'2014-03-01 16:15:39'),(13578,13934,'2014-01-01','ET','2',1,NULL,'Jennifer Rivera','FI','302722978','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:09',0,'2014-03-10 16:10:34'),(1974,1974,'2014-01-01','ET','2',4,3,'Brenda Yablonsky','FI','298684684','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:56',0,'2014-03-01 15:26:40'),(6273,6273,'2014-01-01','ET','2',1,NULL,'Michelle George','FI','435291285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:39',0,'2014-03-02 04:10:25'),(2358,2358,'2014-01-01','ET','2',2,1,'Richard  johnson','FI','270548587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:53',0,'2014-03-01 15:26:40'),(2694,2694,'2014-01-01','ET','2',1,NULL,'pablo rodriguez','FI','456928485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:59',0,'2014-03-02 04:15:49'),(22691,23341,'0000-00-00','ET','2',1,NULL,'Robert Gajewicz','FI','296664455','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:52',0,'2014-03-10 14:50:59'),(13345,13701,'2014-01-01','ET','2',1,NULL,'Vanessa Meley','FI','302862119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:30',0,'2014-03-01 16:40:16'),(96,96,'2014-01-01','ET','2',1,NULL,'Sarah  Christine  Stillson','FI','453950186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:55',0,'2014-03-01 22:10:55'),(341,341,'2014-01-01','ET','2',1,NULL,'bryan mayle','FI','293940318','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:30',0,'2014-03-01 15:21:15'),(365,365,'2014-01-01','ET','2',2,1,'Michael Gephart','FI','277760118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:14',0,'2014-03-01 15:21:15'),(12626,12626,'2014-01-01','ET','2',1,NULL,'Peace Wilson','FI','463710265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:00',0,'2014-03-02 05:10:52'),(1124,1124,'2014-01-01','ET','2',1,NULL,'Brandi Johnson','FI','451998855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:25',0,'2014-03-02 04:38:08'),(11960,11960,'2014-01-01','ET','2',2,1,'Debbie Autrey','FI','215067345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:34',0,'2014-03-02 04:59:36'),(11464,11464,'2014-01-01','ET','2',1,NULL,'CYNTHIA R REINKE','FI','273465291','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:35',0,'2014-03-01 16:30:17'),(18667,19317,'0000-00-00','ET','2',1,NULL,'Lauren Alexander','FI','643280398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:27',0,'2014-03-02 06:45:14'),(4811,4811,'2014-01-01','ET','2',1,NULL,'TERRY L JONES','FI','290585424','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:12',0,'2014-03-10 13:03:33'),(22135,22785,'0000-00-00','ET','2',1,NULL,'Linda L Cannon','FI','221464194','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:55',0,'2014-03-06 21:27:26'),(22145,22795,'0000-00-00','ET','2',1,NULL,'ILENE BAKER','FI','433218123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:02',0,'2014-03-06 21:27:26'),(719,719,'2014-01-01','ET','2',1,NULL,'Leianne Heppner','FI','290866927','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Pietrowski','94','1636529','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:24',0,'2014-03-10 15:52:36'),(17721,18371,'0000-00-00','ET','2',1,NULL,'ARELLA  BERNARD-BROWNING','FI','280724606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:16',0,'2014-03-01 17:20:55'),(1169,1169,'2014-01-01','ET','2',1,NULL,'Kisha S Calix','FI','434593546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:46',0,'2014-03-02 04:38:08'),(1288,1288,'2014-01-01','ET','2',1,NULL,'ANNE SHELLER','FI','483740582','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:25',0,'2014-03-01 16:23:43'),(13346,13702,'2014-01-01','ET','2',1,NULL,'Vanessa Meley','FI','302862119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:30',0,'2014-03-01 16:40:16'),(17417,18067,'0000-00-00','ET','2',2,1,'John Leask','FI','284521928','Summa Insurance Company, Inc.','FI','341809108','Larry  Barkley','94','520478','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:53',0,'2014-03-10 16:24:30'),(16256,16905,'0000-00-00','ET','2',1,NULL,'Tony Sigler','FI','273640741','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:16',0,'2014-03-10 16:24:30'),(11167,11167,'2014-01-01','ET','2',1,NULL,'dorothy yelton','FI','289485596','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:31',0,'2014-03-10 13:45:57'),(19968,20618,'0000-00-00','ET','2',1,NULL,'kevin a bowden','FI','293868979','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:29',0,'2014-03-01 17:47:19'),(21117,21767,'0000-00-00','ET','2',1,NULL,'Amy Brady','FI','459974698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-28 21:30:58',0,'2014-03-02 07:23:39'),(22850,23500,'0000-00-00','ET','2',2,1,'Delores Joslin','FI','467871698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:03',0,'2014-03-10 21:27:11'),(23081,23731,'0000-00-00','ET','2',4,3,'RICHARD MITCHELL','FI','290607480','HealthSpan','FI','311431434','RICHARD  KNAPAE','94','15937801','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:52',0,'2014-03-10 21:17:52'),(23108,23758,'0000-00-00','ET','2',1,NULL,'SHARON CUPP','FI','077466994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:30:09',0,'2014-03-10 21:36:25'),(771,771,'2014-01-01','ET','2',1,NULL,'Everett smith','FI','274809923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:06',0,'2014-03-01 15:05:09'),(18603,19253,'0000-00-00','ET','2',1,NULL,'SARAH STONE','FI','589828303','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:37',0,'2014-03-10 16:31:33'),(1121,1121,'2014-01-01','ET','2',1,NULL,'Alice Angeline Zaccarello','FI','461921463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:19',0,'2014-03-02 04:38:08'),(6054,6054,'2014-01-01','ET','2',1,NULL,'Paul Converse','FI','365048633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:44',0,'2014-03-01 15:10:22'),(3371,3371,'2014-01-01','ET','2',1,NULL,'Kimberly Person','FI','459872760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:47',0,'2014-03-02 02:10:49'),(1628,1628,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:54',0,'2014-03-01 20:10:57'),(2138,2138,'2014-01-01','ET','2',1,NULL,'gary w rollins','FI','305647029','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:05',0,'2014-03-01 15:16:37'),(20072,20722,'0000-00-00','ET','2',1,NULL,'ELYSE CLARKE','FI','165629583','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:27',0,'2014-03-01 18:08:07'),(20613,21263,'0000-00-00','ET','2',1,NULL,'Marilyn Douglas','FI','425215727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:57',0,'2014-03-02 07:17:36'),(22973,23623,'0000-00-00','ET','2',1,NULL,'Michelle Stephens','FI','301880546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:32',0,'2014-03-10 21:36:25'),(10430,10430,'2014-01-01','ET','2',1,NULL,'Timothy Rawlings','FI','273549366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:38',0,'2014-03-01 16:10:36'),(7195,7195,'2014-01-01','ET','2',1,NULL,'Elizabeth C Hooper','FI','459212171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:29',0,'2014-03-02 03:09:49'),(16485,17135,'0000-00-00','ET','2',1,NULL,'MARIA HELENA SMITH','FI','634609751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:28',0,'2014-03-02 06:10:30'),(2188,2188,'2014-01-01','ET','2',1,NULL,'Leah Rawson','FI','449491776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:45',0,'2014-03-01 21:11:04'),(12196,12196,'2014-01-01','ET','2',1,NULL,'Kelly Kowalski','FI','284883337','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:09:11',0,'2014-03-10 13:52:32'),(13444,13800,'2014-01-01','ET','2',1,NULL,'Lane Carter','FI','590232805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:15',0,'2014-03-02 05:31:31'),(20020,20670,'0000-00-00','ET','2',1,NULL,'Robyn Pruitt','FI','279841321','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:06',0,'2014-03-10 14:37:47'),(21397,22047,'0000-00-00','ET','2',1,NULL,'Jennifer Faye Alsobrooks','FI','463690955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:09',0,'2014-03-03 21:25:18'),(21441,22091,'0000-00-00','ET','2',2,1,'Kellee Wright','FI','288829205','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:11',0,'2014-03-10 16:38:05'),(22035,22685,'0000-00-00','ET','2',1,NULL,'Debra Scott','FI','290569280','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:17',0,'2014-03-10 14:45:25'),(19328,19978,'0000-00-00','ET','2',1,NULL,'WILLIAM R WEBB','FI','300503622','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:18',0,'2014-03-02 06:59:07'),(615,615,'2014-01-01','ET','2',1,NULL,'Kristen Rejcek','FI','633073547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:05',0,'2014-03-02 02:10:49'),(3640,3640,'2014-01-01','ET','2',1,NULL,'KIMBERLY S HALES','FI','281746874','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:36',0,'2014-03-10 15:52:36'),(11864,11864,'2014-01-01','ET','2',1,NULL,'jason tarulli','FI','283687776','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:15:18',0,'2014-03-10 16:03:49'),(7381,7381,'2014-01-01','ET','2',1,NULL,'Thomas N Talbot','FI','454886280','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:11',0,'2014-03-02 04:10:25'),(7385,7385,'2014-01-01','ET','2',1,NULL,'Lisa Robinson','FI','436965655','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:19',0,'2014-03-02 04:15:49'),(19453,20103,'0000-00-00','ET','2',1,NULL,'Natashia Hills','FI','587453362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:42:42',0,'2014-03-02 06:59:07'),(18773,19423,'0000-00-00','ET','2',1,NULL,'Brian McCarthy','FI','279441480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:46',0,'2014-03-10 14:31:05'),(13708,14064,'2014-01-01','ET','2',1,NULL,'Susan  C Randolph','FI','291505103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:46',0,'2014-03-01 16:40:16'),(472,472,'2014-01-01','ET','2',1,NULL,'michael harris','FI','282508482','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:44',0,'2014-03-10 13:10:24'),(18845,19495,'0000-00-00','ET','2',1,NULL,'kevin martin','FI','452635035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:22',0,'2014-03-02 06:52:12'),(4331,4331,'2014-01-01','ET','2',1,NULL,'James Martin','FI','289889108','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:10:11',0,'2014-03-10 13:32:15'),(5262,5262,'2014-01-01','ET','2',1,NULL,'Brandi Steagall','FI','300929115','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:05',0,'2014-03-01 15:10:22'),(21019,21669,'0000-00-00','ET','2',1,NULL,'JENNIFER PALUMBO','FI','299926243','Summa Insurance Company, Inc.','FI','341809108','michael  kost','94','1924114','348','2014-03-01','Sync Success',0,'2014-02-28 21:00:13',0,'2014-03-10 16:38:05'),(21265,21915,'0000-00-00','ET','2',1,NULL,'April Dawn Civitarese','FI','268824546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:39',0,'2014-03-01 21:35:40'),(23064,23714,'0000-00-00','ET','2',1,NULL,'BONNIE A GREINER','FI','280584755','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:38',0,'2014-03-10 21:17:52'),(820,820,'2014-01-01','ET','2',1,NULL,'Thomas Lea','FI','283543464','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:55',0,'2014-03-10 13:03:33'),(13938,14294,'2014-01-01','ET','2',2,1,'ROBERT HUNDLEY','FI','263533272','HealthSpan','FI','311431434','CHARLES  BENDER','94','17057188','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:24',0,'2014-03-10 14:03:26'),(17002,17652,'0000-00-00','ET','2',2,1,'Elvie Loving','FI','296508857','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:32',0,'2014-03-10 16:24:30'),(15671,16320,'0000-00-00','ET','2',1,NULL,'Edward Brown','FI','435398771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:28',0,'2014-03-02 05:59:43'),(1093,1093,'2014-01-01','ET','2',1,NULL,'Kristine E Light','FI','071500015','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:46',0,'2014-03-10 13:03:33'),(10513,10513,'2014-01-01','ET','2',1,NULL,'Virginia Beauchamp','FI','453434128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:15',0,'2014-03-02 04:24:47'),(7561,7561,'2014-01-01','ET','2',1,NULL,'Thea M Jones-Stamets','FI','289606680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:01',0,'2014-03-01 16:05:34'),(7311,7311,'2014-01-01','ET','2',1,NULL,'Jessica Henderer','FI','279927665','HealthSpan','FI','311431434','Justin  Holbrook','94','8099860','348','2014-01-01','Sync Success',0,'2013-12-26 04:10:03',0,'2014-03-10 13:32:15'),(1349,1349,'2014-01-01','ET','2',1,NULL,'america villalobos','FI','630763620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:24',0,'2014-03-02 04:38:08'),(3392,3392,'2014-01-01','ET','2',1,NULL,'DORIS TAYLOR','FI','281547441','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:26',0,'2014-03-10 15:52:36'),(3858,3858,'2014-01-01','ET','2',1,0,'William Svatos','FI','281607391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:53',0,'2014-03-01 15:05:09'),(22856,23506,'0000-00-00','ET','2',1,NULL,'Tawanna Siglar','FI','455696493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:08',0,'2014-03-10 21:27:11'),(23097,23747,'0000-00-00','ET','2',1,NULL,'Shirley Perry','FI','101703579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:29:59',0,'2014-03-10 21:36:25'),(751,751,'2014-01-01','ET','2',1,NULL,'Mia Thompson','FI','286706480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:24',0,'2014-03-10 13:24:34'),(20142,20792,'0000-00-00','ET','2',1,NULL,'Jennifer Beers','FI','293868619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:49',0,'2014-03-10 16:38:05'),(13879,14235,'2014-01-01','ET','2',1,NULL,'Patricia Kelly','FI','295569446','HealthSpan','FI','311431434','Jamie  Ivory','94','8235167','348','2014-02-01','Sync Success',0,'2014-01-13 02:24:07',0,'2014-03-10 14:03:26'),(18289,18939,'0000-00-00','ET','2',2,1,'norman whitaker','FI','284624348','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:19',0,'2014-03-10 14:24:38'),(15600,16051,'0000-00-00','ET','2',2,1,'BLANCA APARICIO','FI','585726777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:36',0,'2014-03-02 05:59:43'),(11212,11212,'2014-01-01','ET','2',1,NULL,'Annette Ryan','FI','297606758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:49',0,'2014-03-01 16:23:43'),(4833,4833,'2014-01-01','ET','2',1,NULL,'KAREN L WILLIAMS','FI','272703891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:06',0,'2014-03-01 15:10:22'),(7240,7240,'2014-01-01','ET','2',1,NULL,'susan perrin','FI','438902402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:56',0,'2014-03-02 02:10:49'),(21036,21686,'0000-00-00','ET','2',3,2,'Gregory Alan Stevens','FI','276646527','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:00:26',0,'2014-03-10 14:45:25'),(101,101,'2014-01-01','ET','2',2,1,'PENNY KERVIN','FI','445549990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:04',0,'2014-03-01 22:10:55'),(14443,14894,'2014-01-01','ET','2',1,NULL,'Eddy Villalta Guillen','FI','587851925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:27',0,'2014-03-02 05:38:34'),(13999,14355,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:30',0,'2014-03-01 16:40:16'),(13725,14081,'2014-01-01','ET','2',1,NULL,'Clairesse Morse','FI','553614966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:58',0,'2014-03-02 05:24:45'),(13069,13425,'2014-01-01','ET','2',1,NULL,'Skye Labat','FI','434814816','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:45',0,'2014-03-02 05:17:40'),(12669,12669,'2014-01-01','ET','2',1,NULL,'Susan Sopp','FI','188449913','Dental Care Plus, Inc.','FI','311185262','Madeline  McGarey','94','16908654','348','2014-02-01','Sync Success',0,'2014-01-03 02:03:40',0,'2014-03-01 16:35:14'),(19715,20365,'0000-00-00','ET','2',1,NULL,'Carol P Chavez','FI','462175164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:31:27',0,'2014-03-02 06:59:07'),(6420,6420,'2014-01-01','ET','2',2,1,'THOMAS FISHER','FI','282506896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:10',0,'2014-03-01 15:10:22'),(19560,20210,'0000-00-00','ET','2',1,NULL,'LINDA SILAS','FI','436299221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:20:37',0,'2014-03-02 06:59:07'),(4097,4097,'2014-01-01','ET','2',1,NULL,'regina rox','FI','273708192','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:11',0,'2014-03-01 16:00:27'),(19165,19815,'0000-00-00','ET','2',2,1,'gloria lee holguin','FI','464027814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:34',0,'2014-03-02 06:52:12'),(18255,18905,'0000-00-00','ET','2',2,1,'Gregory Regina','FI','369927075','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:42',0,'2014-03-10 14:24:38'),(969,969,'2014-01-01','ET','2',1,NULL,'Radie Boleyn','FI','291484724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:15',0,'2014-03-10 15:39:19'),(4707,4707,'2014-01-01','ET','2',1,NULL,'Michael Taylor','FI','436532274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:53',0,'2014-03-02 04:38:08'),(4762,4762,'2014-01-01','ET','2',1,NULL,'thomas kelly','FI','299581238','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:44',0,'2014-03-01 15:16:37'),(17565,18215,'0000-00-00','ET','2',2,1,'Santa Almaguer','FI','660102529','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:45',0,'2014-03-02 06:31:45'),(421,421,'2014-01-01','ET','2',1,NULL,'Gary Compton','FI','555984837','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:04',0,'2014-03-01 15:21:15'),(21963,22613,'0000-00-00','ET','2',1,NULL,'David Ellis Andrews','FI','438459183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:27',0,'2014-03-05 22:27:33'),(22263,22913,'0000-00-00','ET','2',1,NULL,'Anthony Odlivak','FI','286800576','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:26',0,'2014-03-10 16:44:18'),(22494,23144,'0000-00-00','ET','2',1,NULL,'Brandon Chaffin','FI','273965286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:06',0,'2014-03-07 21:36:32'),(19459,20109,'0000-00-00','ET','2',1,NULL,'Laura Ouchley','FI','437674927','Starmount Life Insurance Company','FI','720977315','Mathew  Dahlen','94','16804332','348','2014-04-01','Sync Success',0,'2014-02-20 03:46:05',0,'2014-03-02 06:59:07'),(4198,4198,'2014-01-01','ET','2',1,NULL,'Nicholas Ruschau','FI','283861818','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:12',0,'2014-03-10 13:32:15'),(7414,7414,'2014-01-01','ET','2',1,NULL,'janice newman','FI','437849490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:19',0,'2014-03-02 04:10:25'),(13414,13770,'2014-01-01','ET','2',2,1,'andrea gerhart','FI','281843572','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:01',0,'2014-03-10 13:59:38'),(22026,22676,'0000-00-00','ET','2',2,1,'MARIBEL PEREZ','FI','453839186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:10',0,'2014-03-05 22:27:33'),(404,404,'2014-01-01','ET','2',1,NULL,'Dominic Jack','FI','433755383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:31',0,'2014-03-01 22:10:55'),(14017,14373,'2014-01-01','ET','2',2,1,'lisa g neal','FI','426252907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:43',0,'2014-03-02 05:31:31'),(20159,20809,'0000-00-00','ET','2',1,NULL,'JUDY STRINE','FI','284529896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:02',0,'2014-03-01 18:08:07'),(13569,13925,'2014-01-01','ET','2',1,NULL,'Brenda Hunter','FI','428064801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:01',0,'2014-03-02 05:24:45'),(11573,11573,'2014-01-01','ET','2',1,NULL,'CECILIA G RUIZ','FI','629381321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:56',0,'2014-03-02 04:52:44'),(11428,11428,'2014-01-01','ET','2',1,NULL,'Tabitha Snyder','FI','272922088','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:07:28',0,'2014-03-10 13:52:32'),(5522,5522,'2014-01-01','ET','2',1,NULL,'Lisa Colagross','FI','287668964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:05',0,'2014-03-01 16:23:43'),(20018,20668,'0000-00-00','ET','2',1,NULL,'Jeanette Vanetta','FI','347489538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:05',0,'2014-03-10 16:38:05'),(18383,19033,'0000-00-00','ET','2',1,NULL,'Donna Clark','FI','437475915','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:49',0,'2014-03-02 06:45:14'),(16939,17589,'0000-00-00','ET','2',2,1,'Wayne Goodine','FI','428437793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:51',0,'2014-03-02 06:24:38'),(1730,1730,'2014-01-01','ET','2',1,NULL,'donald j lowe','FI','280543846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:23',0,'2014-03-01 15:31:33'),(15473,15924,'0000-00-00','ET','2',1,NULL,'oletha mays','94','0001031479','HealthSpan','FI','311431434','brandon  wollrich','94','7276536','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:55',0,'2014-03-10 14:10:12'),(1993,1993,'2014-01-01','ET','2',1,NULL,'James  Walter  Slouffman','FI','290440485','HealthSpan','FI','311431434','Darwin   Carmichael','94','130095','348','2014-01-01','Sync Success',0,'2013-12-25 19:34:35',0,'2014-03-10 13:20:27'),(15021,15472,'2014-01-01','ET','2',1,NULL,'Cedric Jackson','FI','437599478','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:19',0,'2014-03-02 05:45:37'),(19584,20234,'0000-00-00','ET','2',1,NULL,'Walter Harper','FI','296646330','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:28:14',0,'2014-03-10 14:37:47'),(12030,12030,'2014-01-01','ET','2',2,1,'PATRICIA BURNS','FI','437413239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:14',0,'2014-03-02 04:59:36'),(18566,19216,'0000-00-00','ET','2',1,NULL,'Kyle Whitman','FI','269884274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:05',0,'2014-03-01 17:26:36'),(4444,4444,'2014-01-01','ET','2',2,1,'VIVIAN NGUYUEN','FI','604203436','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:13',0,'2014-03-01 15:16:37'),(2796,2796,'2014-01-01','ET','2',1,NULL,'Eileen Cicero','FI','291728416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:13',0,'2014-03-01 16:05:34'),(17944,18594,'0000-00-00','ET','2',1,NULL,'Stephanie Knoth','FI','541846322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:59',0,'2014-03-02 06:38:05'),(16529,17179,'0000-00-00','ET','2',1,NULL,'KRISTEN L LEE','FI','327742896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:56',0,'2014-03-01 17:00:58'),(15992,16641,'0000-00-00','ET','2',1,NULL,'Quentin Cunningham','FI','422198014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:06',0,'2014-03-02 06:03:21'),(15539,15990,'0000-00-00','ET','2',1,NULL,'Kile  Sanford','FI','299821682','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:08',0,'2014-03-10 16:17:47'),(21111,21761,'0000-00-00','ET','2',1,NULL,'LASANDRA BOWERS','FI','460439056','Starmount Life Insurance Company','FI','720977315','SHAY   DAVIS','94','16149610','357','2014-04-01','Sync Success',0,'2014-02-28 21:30:54',0,'2014-03-02 07:23:39'),(535,535,'2014-01-01','ET','2',2,1,'Cathy Hartman','FI','291443709','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:32',0,'2014-03-01 15:48:04'),(18314,18964,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:15',0,'2014-03-10 16:31:33'),(15096,15547,'0000-00-00','ET','2',1,NULL,'Monica Rocio Roa Pineda','FI','067611099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:46',0,'2014-03-02 05:52:31'),(14125,14576,'2014-01-01','ET','2',2,1,'Hy Tran','FI','260398169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:51',0,'2014-03-02 05:38:34'),(13072,13428,'2014-01-01','ET','2',1,NULL,'Leatrice Hollis','FI','433191576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:51',0,'2014-03-02 05:17:40'),(6177,6177,'2014-01-01','ET','2',1,NULL,'Luisa Sanchez','FI','642035995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:37',0,'2014-03-02 04:10:25'),(2328,2328,'2014-01-01','ET','2',1,0,'John Bibbs','FI','645073270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:13',0,'2014-03-01 19:11:03'),(3609,3609,'2014-01-01','ET','2',1,NULL,'Shirley Blagg','FI','298461986','Summa Insurance Company, Inc.','FI','341809108','deborah  gazey','94','2341750','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:38',0,'2014-03-10 15:52:36'),(1671,1671,'2014-01-01','ET','2',1,NULL,'Yolanda Rios','FI','154653187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:34',0,'2014-03-02 00:10:48'),(20954,21604,'0000-00-00','ET','2',1,NULL,'CAROL OLMSTEAD','FI','128429477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:08',0,'2014-03-02 07:17:36'),(21916,22566,'0000-00-00','ET','2',1,NULL,'CARMELINE LAMBERT','FI','459868228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:54',0,'2014-03-05 22:27:33'),(22288,22938,'0000-00-00','ET','2',1,NULL,'MICHAEL WAYNE JAMES','FI','302644386','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:44',0,'2014-03-10 14:45:25'),(23092,23742,'0000-00-00','ET','2',2,1,'DONNELL SNEED','FI','268745164','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:03:02',0,'2014-03-10 21:07:22'),(16268,16918,'0000-00-00','ET','2',1,NULL,'Tracy Antley','FI','435411238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:03',0,'2014-03-02 06:10:30'),(7168,7168,'2014-01-01','ET','2',1,NULL,'Roger Gal','FI','297747918','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:37',0,'2014-03-10 15:59:47'),(6244,6244,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:05:44',0,'2014-03-10 13:39:10'),(15550,16001,'0000-00-00','ET','2',1,NULL,'Bobby Bates','FI','632038333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:14',0,'2014-03-02 05:59:43'),(15022,15473,'2014-01-01','ET','2',1,NULL,'Brenda Shivers','FI','437925890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:19',0,'2014-03-02 05:52:31'),(5665,5665,'2014-01-01','ET','2',1,NULL,'Susan Matassa','FI','462908998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:52',0,'2014-03-02 04:45:37'),(14715,15166,'2014-01-01','ET','2',1,NULL,'MARIA MCMILLAN','FI','439119715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:04',0,'2014-03-02 05:45:37'),(4374,4374,'2014-01-01','ET','2',2,1,'ROBIN BAISDEN','FI','297665151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:08',0,'2014-03-01 15:16:37'),(3571,3571,'2014-01-01','ET','2',1,NULL,'Rhea Rasnic','FI','406883570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:03:28',0,'2014-03-02 00:10:48'),(22933,23583,'0000-00-00','ET','2',1,NULL,'EVA M PHILLIPS','FI','437046152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:05',0,'2014-03-10 21:27:11'),(779,779,'2014-01-01','ET','2',1,NULL,'Karen Theresa Moore','FI','268468063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:22',0,'2014-03-01 15:05:09'),(1462,1462,'2014-01-01','ET','2',1,NULL,'Michael Jackson','FI','283740589','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:11',0,'2014-03-01 16:23:43'),(1645,1645,'2014-01-01','ET','2',1,NULL,'Dorothy Kaminsky','FI','276528296','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:20',0,'2014-03-10 13:03:33'),(6203,6203,'2014-01-01','ET','2',1,NULL,'Melinda Hurlow','FI','269567163','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:26',0,'2014-03-01 16:00:27'),(19920,20570,'0000-00-00','ET','2',1,NULL,'CURMERA HARPER','FI','426591761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:16',0,'2014-03-02 07:03:25'),(2081,2081,'2014-01-01','ET','2',1,NULL,'M Ackerman','FI','436675749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:37:27',0,'2014-03-02 00:10:48'),(19914,20564,'0000-00-00','ET','2',1,NULL,'DONYA R SMITH','FI','465573699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:12',0,'2014-03-02 07:03:25'),(13091,13447,'2014-01-01','ET','2',2,1,'Joanie Marie Payton','FI','276829737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:39',0,'2014-03-01 16:35:14'),(15415,15866,'0000-00-00','ET','2',2,1,'donald lowe','FI','569497555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:18',0,'2014-03-02 05:59:43'),(21143,21793,'0000-00-00','ET','2',1,NULL,'JUSTIN RENDELL','FI','435653107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:17',0,'2014-03-02 07:23:39'),(680,680,'2014-01-01','ET','2',1,NULL,'ANNETTE A FRITZ','FI','039328263','Summa Insurance Company, Inc.','FI','341809108','BRIAN  WOLFF','94','1888678','348','2014-01-01','Sync Success',0,'2013-12-25 18:06:06',0,'2014-03-10 15:52:36'),(5996,5996,'2014-01-01','ET','2',5,4,'Debra Kienzle','FI','372729702','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:53',0,'2014-03-10 13:24:34'),(7026,7026,'2014-01-01','ET','2',1,NULL,'Belinda Stewart','FI','463793699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:18',0,'2014-03-02 03:09:49'),(20286,20936,'0000-00-00','ET','2',2,1,'James Dickerson','FI','268828662','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 08:00:30',0,'2014-03-10 14:37:47'),(16810,17460,'0000-00-00','ET','2',2,1,'Cheryl Lynn Hittle','FI','293820998','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:49',0,'2014-03-10 14:20:26'),(17274,17924,'0000-00-00','ET','2',1,NULL,'Debra Stork','FI','430023143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:42',0,'2014-03-02 06:24:38'),(20998,21648,'0000-00-00','ET','2',3,2,'Emil Mitchell','FI','433046356','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-02-28 07:30:38',0,'2014-03-02 07:17:36'),(286,286,'2014-01-01','ET','2',1,NULL,'Lori Wiessinger','FI','298668165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:12',0,'2014-03-01 15:10:22'),(380,380,'2014-01-01','ET','2',1,NULL,'Lisa Bertok','FI','297688327','Summa Insurance Company, Inc.','FI','341809108','Kathleen  Carvin','94','16822306','348','2014-01-01','Sync Success',0,'2013-12-25 17:47:44',0,'2014-03-10 15:45:56'),(20550,21200,'0000-00-00','ET','2',1,NULL,'tina baker','FI','459599616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:16',0,'2014-03-02 07:17:36'),(5329,5329,'2014-01-01','ET','2',1,NULL,'Dawn Brown','FI','298785653','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:08',0,'2014-03-01 15:10:22'),(5279,5279,'2014-01-01','ET','2',1,NULL,'THEODORE TALLIERE','FI','282528411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:42',0,'2014-03-01 15:10:22'),(18034,18684,'0000-00-00','ET','2',1,NULL,'BESSIE TURNER','FI','268568220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:02',0,'2014-03-10 14:24:38'),(16785,17435,'0000-00-00','ET','2',1,NULL,'Robert Kenard','FI','336466444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:31',0,'2014-03-02 06:17:30'),(16633,17283,'0000-00-00','ET','2',1,NULL,'Charlotte Boggs','FI','278644901','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:00:30',0,'2014-03-10 14:20:26'),(15422,15873,'0000-00-00','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:23',0,'2014-03-01 16:50:53'),(11472,11472,'2014-01-01','ET','2',1,NULL,'Erica Davis','FI','274869878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:48',0,'2014-03-01 16:30:17'),(13447,13803,'2014-01-01','ET','2',1,NULL,'Miguel Martinez','FI','384062539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:17',0,'2014-03-02 05:31:31'),(12231,12231,'2014-01-01','ET','2',1,NULL,'Patricia Mitchell','94','0001284858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:41',0,'2014-03-02 05:03:29'),(13025,13381,'2014-01-01','ET','2',1,NULL,'VIRGINIA SMITH','FI','295524643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:11',0,'2014-03-01 16:35:14'),(19674,20324,'0000-00-00','ET','2',1,NULL,'Jason Baker','FI','283765267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:49:07',0,'2014-03-01 17:47:19'),(18690,19340,'0000-00-00','ET','2',2,1,'Daniel Findley','FI','505626351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:43',0,'2014-03-02 06:45:14'),(13403,13759,'2014-01-01','ET','2',1,NULL,'Marjorie Correa','FI','466902810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:56',0,'2014-03-02 05:24:45'),(13290,13646,'2014-01-01','ET','2',1,NULL,'Kathleen L Caldwell','FI','274765295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:08',0,'2014-03-01 16:40:16'),(1618,1618,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:40',0,'2014-03-01 20:10:57'),(18024,18674,'0000-00-00','ET','2',1,NULL,'Sirisumana Dapane','FI','218619896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:55',0,'2014-03-01 17:20:55'),(2846,2846,'2014-01-01','ET','2',1,NULL,'Danni Wolcott','FI','457065923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:53',0,'2014-03-02 04:15:49'),(17687,18337,'0000-00-00','ET','2',4,3,'Timothy Hartwig','FI','290584923','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:58',0,'2014-03-10 14:24:38'),(15637,16088,'0000-00-00','ET','2',1,NULL,'Diane Muntz','FI','291769989','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:54',0,'2014-03-10 14:10:12'),(12379,12379,'2014-01-01','ET','2',4,3,'DREW DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:55',0,'2014-03-01 16:30:17'),(11445,11445,'2014-01-01','ET','2',1,NULL,'TODD ROBERT DWELLY','FI','300440180','HealthSpan','FI','311431434','TIMOTHY  MCKEOWN','94','1640913','348','2014-02-01','Sync Success',0,'2013-12-27 02:08:06',0,'2014-03-10 13:52:32'),(22104,22754,'0000-00-00','ET','2',1,NULL,'DAVID GARZA','FI','638283678','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:32',0,'2014-03-06 21:27:26'),(20625,21275,'0000-00-00','ET','2',1,NULL,'Beulah Wilson','FI','438909505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:06',0,'2014-03-02 07:17:36'),(19957,20607,'0000-00-00','ET','2',2,1,'KARINA MARISOL GONZALEZ','FI','642185828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:21',0,'2014-03-02 07:03:25'),(5861,5861,'2014-01-01','ET','2',1,NULL,'Alicia Fairchild','FI','436732163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:35',0,'2014-03-01 19:11:03'),(17864,18514,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:12',0,'2014-03-02 06:38:05'),(16992,17642,'0000-00-00','ET','2',1,NULL,'NICHOLAS MALLARD','FI','428497429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:24',0,'2014-03-02 06:17:30'),(16612,17262,'0000-00-00','ET','2',1,NULL,'ROMEIKA EASTER','FI','449692386','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:15',0,'2014-03-02 06:17:30'),(16478,17128,'0000-00-00','ET','2',2,1,'Warren Bruce Boyet','FI','434490749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:23',0,'2014-03-02 06:17:30'),(15389,15840,'0000-00-00','ET','2',1,NULL,'Ruby Grace','FI','438137380','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:03',0,'2014-03-02 05:59:43'),(4532,4532,'2014-01-01','ET','2',1,NULL,'JANET JULIANO','FI','019524130','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:05',0,'2014-03-10 16:03:49'),(12361,12361,'2014-01-01','ET','2',2,1,'Rickie S Brown','FI','462259540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:14',0,'2014-03-02 05:03:29'),(11635,11635,'2014-01-01','ET','2',1,NULL,'MONICA BLAKE','FI','439236431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:48',0,'2014-03-02 04:52:44'),(11199,11199,'2014-01-01','ET','2',1,NULL,'Lila Phillips','FI','302528826','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:25',0,'2014-03-01 16:23:43'),(2548,2548,'2014-01-01','ET','2',4,3,'Michael Truong','FI','298780493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:28',0,'2014-03-01 15:10:22'),(10841,10841,'2014-01-01','ET','2',1,NULL,'LOELLA LANDRY','FI','436278283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:11',0,'2014-03-02 04:31:46'),(22109,22759,'0000-00-00','ET','2',2,1,'Alfredo M Tobar','FI','520809627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:36',0,'2014-03-06 21:27:26'),(20887,21537,'0000-00-00','ET','2',1,NULL,'Frank Henry','FI','425755173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:38',0,'2014-03-02 07:17:36'),(20850,21500,'0000-00-00','ET','2',1,NULL,'Debra Johnson','FI','434947117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:22',0,'2014-03-02 07:17:36'),(20689,21339,'0000-00-00','ET','2',1,NULL,'Kyle Casler','FI','457698046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:07',0,'2014-03-02 07:17:36'),(7072,7072,'2014-01-01','ET','2',4,3,'Nicole Renee Turner','FI','301805693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:43',0,'2014-03-01 15:52:44'),(19503,20153,'0000-00-00','ET','2',1,NULL,'Michael Smith','FI','290546413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-05','Sync Success',0,'2014-02-20 04:04:52',0,'2014-03-01 17:34:07'),(5231,5231,'2014-01-01','ET','2',1,NULL,'Mary Spencer','FI','216782079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:26',0,'2014-03-02 00:10:48'),(2000,2000,'2014-01-01','ET','2',1,NULL,'Vicki Steinbach','FI','450962940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:52',0,'2014-03-01 23:10:52'),(16830,17480,'0000-00-00','ET','2',1,NULL,'Kari Sattler','FI','302844529','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:13',0,'2014-03-10 14:20:26'),(13520,13876,'2014-01-01','ET','2',1,NULL,'Linda Hayes','FI','299568853','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:29',0,'2014-03-01 16:40:16'),(15766,16415,'0000-00-00','ET','2',1,NULL,'Michael Slack','FI','282840956','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:31',0,'2014-03-10 14:10:12'),(15440,15891,'0000-00-00','ET','2',1,NULL,'Dianna Little','FI','282743100','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:35',0,'2014-03-10 16:17:47'),(21949,22599,'0000-00-00','ET','2',2,1,'GUADALUPE ROJAS RODRIGUEZ','FI','439676181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:17',0,'2014-03-05 22:27:33'),(2278,2278,'2014-01-01','ET','2',2,1,'Wanda Ann Parker','FI','426415354','Starmount Life Insurance Company','FI','720977315','Virginia  Bailey','94','8613861','348','2014-01-01','Sync Success',0,'2013-12-25 20:00:25',0,'2014-03-01 21:11:04'),(6465,6465,'2014-01-01','ET','2',1,NULL,'ROY KOCH','FI','285482899','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:37',0,'2014-03-10 13:03:33'),(20612,21262,'0000-00-00','ET','2',1,NULL,'Anthony Jackson','FI','426379017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:56',0,'2014-03-02 07:10:28'),(5700,5700,'2014-01-01','ET','2',1,NULL,'Jacquelyn Jucha','FI','163545591','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:26',0,'2014-03-01 15:48:04'),(3189,3189,'2014-01-01','ET','2',1,NULL,'Virginia Wolf','FI','286566032','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:11',0,'2014-03-10 13:24:34'),(20113,20763,'0000-00-00','ET','2',1,NULL,'SANDRA COOPER','FI','437982467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:29',0,'2014-03-02 07:10:28'),(14653,15104,'2014-01-01','ET','2',1,NULL,'Michael Koloskee','FI','297681491','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:23',0,'2014-03-01 16:46:19'),(14874,15325,'2014-01-01','ET','2',2,1,'elia  dominguz','FI','631542217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:12',0,'2014-03-02 05:52:31'),(19249,19899,'0000-00-00','ET','2',1,NULL,'Nowlhas Eurick Caseres','FI','276964235','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:39',0,'2014-03-10 14:31:05'),(16960,17610,'0000-00-00','ET','2',1,NULL,'Barbara J DiBacco','FI','283749962','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:05',0,'2014-03-10 14:20:26'),(5422,5422,'2014-01-01','ET','2',1,NULL,'Joshua Cox','FI','293921612','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:02',0,'2014-03-10 13:03:33'),(5517,5517,'2014-01-01','ET','2',1,NULL,'LOIS WILLIAMS','FI','297565122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:46:56',0,'2014-03-01 16:23:43'),(20234,20884,'0000-00-00','ET','2',1,NULL,'Lynn M Blakely','FI','276567388','Summa Insurance Company, Inc.','FI','341809108','Scott  Prior','94','8416481','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:57',0,'2014-03-10 16:38:05'),(10800,10800,'2014-01-01','ET','2',1,NULL,'Tonette Davis','FI','439399449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:52',0,'2014-03-02 04:24:47'),(19538,20189,'0000-00-00','ET','2',1,NULL,'WALTER BROWN','FI','587562965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:15:10',0,'2014-03-02 06:59:07'),(18190,18840,'0000-00-00','ET','2',1,NULL,'Amanda Dahlin','FI','095707783','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:45',0,'2014-03-01 17:26:36'),(17879,18529,'0000-00-00','ET','2',2,1,'Thomas Pillitiere','FI','288547574','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:15',0,'2014-03-10 16:31:33'),(17601,18251,'0000-00-00','ET','2',1,NULL,'Catherina Ofunre Lopez','FI','637285265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:04',0,'2014-03-02 06:31:45'),(12714,12714,'2014-01-01','ET','2',2,1,'Una West','FI','435236888','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:17',0,'2014-03-02 05:10:52'),(12791,12791,'2014-01-01','ET','2',1,NULL,'Veronica Bourque','FI','437657425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:55',0,'2014-03-02 05:10:52'),(17009,17659,'0000-00-00','ET','2',1,NULL,'Abbey Moore','FI','302843813','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-04 21:00:03',0,'2014-03-10 14:20:26'),(14235,14686,'2014-01-01','ET','2',1,NULL,'TERRY  BRIGHAM','FI','428291991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:56',0,'2014-03-02 05:38:34'),(14267,14718,'2014-01-01','ET','2',2,1,'Steven Line','FI','286665623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:10',0,'2014-03-01 16:46:19'),(14871,15322,'2014-01-01','ET','2',1,NULL,'Nancy Schmid','FI','456988004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:11',0,'2014-03-02 05:52:31'),(15881,16530,'0000-00-00','ET','2',1,NULL,'lisa g neal','FI','426252907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:01:00',0,'2014-03-02 06:03:21'),(21777,22427,'0000-00-00','ET','2',1,NULL,'Eloise M Barnhill','FI','270581587','HealthSpan','FI','311431434','Kirk  Bernhard','94','2828814','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:44',0,'2014-03-10 14:45:25'),(712,712,'2014-01-01','ET','2',1,NULL,'Lois Eickholt','FI','289520652','HealthSpan','FI','311431434','Laurie  Basinger','94','8287259','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:08',0,'2014-03-10 13:24:34'),(2023,2023,'2014-01-01','ET','2',1,NULL,'Ronald Robert','FI','438989855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:35',0,'2014-03-01 23:10:52'),(21271,21921,'0000-00-00','ET','2',1,NULL,'Marie Nguyen','FI','566899384','Starmount Life Insurance Company','FI','720977315','Christopher  Plater','94','16583480','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:43',0,'2014-03-02 07:23:39'),(20338,20988,'0000-00-00','ET','2',2,1,'Eloise David','FI','437081429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:28',0,'2014-03-02 07:03:25'),(5569,5569,'2014-01-01','ET','2',1,NULL,'Alissa McCants','FI','463832361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:38',0,'2014-03-02 04:45:37'),(7724,7724,'2014-01-01','ET','2',1,NULL,'rosa smith','FI','466908159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:18',0,'2014-03-01 20:10:57'),(12128,12128,'2014-01-01','ET','2',1,NULL,'Thomas Glascock','FI','400862767','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:06:43',0,'2014-03-01 16:30:17'),(12730,12730,'2014-01-01','ET','2',1,NULL,'Theresa Hines','FI','297686246','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:57',0,'2014-03-10 13:59:38'),(14005,14361,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:34',0,'2014-03-01 16:40:16'),(14375,14826,'2014-01-01','ET','2',1,NULL,'Rashaad Burton','FI','270748757','Summa Insurance Company, Inc.','FI','341809108','John  Christopher Dalziel','94','362362','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:56',0,'2014-03-10 16:17:47'),(19870,20520,'0000-00-00','ET','2',1,NULL,'Donte Murphy','FI','293887194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:20',0,'2014-03-01 17:47:19'),(15760,16409,'0000-00-00','ET','2',1,NULL,'Richard McCune','FI','235760139','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:01:28',0,'2014-03-10 14:10:12'),(15856,16505,'0000-00-00','ET','2',2,1,'Andrzej Zawisza','FI','014806004','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:44',0,'2014-03-01 16:56:22'),(18674,19324,'0000-00-00','ET','2',1,NULL,'DORA MARROQUIN','FI','451867840','Starmount Life Insurance Company','FI','720977315','ROLAND  CUELLAR','94','1094396','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:33',0,'2014-03-02 06:45:14'),(22713,23363,'0000-00-00','ET','2',1,NULL,'David Barry Chinn','FI','301584577','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:08',0,'2014-03-10 14:50:59'),(899,899,'2014-01-01','ET','2',1,NULL,'Coletta Adams','FI','269504066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:06',0,'2014-03-01 15:21:15'),(12336,12336,'2014-01-01','ET','2',1,NULL,'amy anderson','FI','440847801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:27:27',0,'2014-03-02 05:03:29'),(7424,7424,'2014-01-01','ET','2',1,NULL,'ANGELA  DENISE  SEMIEN','FI','439592459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:38',0,'2014-03-02 04:15:49'),(12212,12212,'2014-01-01','ET','2',1,NULL,'Daniel Phillips','FI','566027169','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:57',0,'2014-03-01 16:35:14'),(3926,3926,'2014-01-01','ET','2',1,NULL,'Alexander Rudolph','FI','302884410','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:50',0,'2014-03-01 15:26:40'),(3936,3936,'2014-01-01','ET','2',1,NULL,'Daniel Melia','FI','565814728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:07',0,'2014-03-01 23:10:52'),(12202,12202,'2014-01-01','ET','2',1,NULL,'Ariel Diamond','FI','344729683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:22',0,'2014-03-10 13:52:32'),(10590,10590,'2014-01-01','ET','2',1,NULL,'Robert Alan Long','FI','461530839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:50',0,'2014-03-02 04:24:47'),(11064,11064,'2014-01-01','ET','2',1,NULL,'DENISE ANGERSTIEN','FI','292601297','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:57',0,'2014-03-10 16:03:49'),(22140,22790,'0000-00-00','ET','2',1,NULL,'Karen Martin Dejean','FI','439274120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:58',0,'2014-03-06 21:27:26'),(1062,1062,'2014-01-01','ET','2',1,NULL,'JANET RITSON','FI','273643192','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:40',0,'2014-03-10 13:03:33'),(10460,10460,'2014-01-01','ET','2',1,NULL,'Patricia Ivory','FI','282881117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:52:36',0,'2014-03-01 16:10:36'),(19902,20552,'0000-00-00','ET','2',1,NULL,'Opal Stevens','FI','289582218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-21 21:30:06',0,'2014-03-01 17:47:19'),(17091,17741,'0000-00-00','ET','2',1,NULL,'GARY ZUCCO','FI','281623635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-02-04 21:00:55',NULL,NULL),(6412,6412,'2014-01-01','ET','2',1,NULL,'JIN DOLNEY','FI','297045947','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:58',0,'2014-03-10 13:39:10'),(15224,15675,'0000-00-00','ET','2',1,NULL,'Donald Frederick McAulay','FI','011761728','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:42',0,'2014-03-10 14:10:12'),(4812,4812,'2014-01-01','ET','2',1,NULL,'TERRY L JONES','FI','290585424','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 00:02:13',NULL,NULL),(4291,4291,'2014-01-01','ET','2',1,NULL,'Gregory Flaherty','FI','280486783','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-01-01','Sync Success',0,'2013-12-25 23:09:03',0,'2014-03-10 13:32:15'),(16242,16891,'0000-00-00','ET','2',2,1,'Patricia Fazzio','FI','434968431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:07',0,'2014-03-02 06:10:30'),(15710,16359,'0000-00-00','ET','2',1,NULL,'robert thomas','FI','285564478','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:54',0,'2014-03-10 14:10:12'),(12878,12878,'2014-01-01','ET','2',2,1,'charles amrose','FI','269860737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:04',0,'2014-03-01 16:35:14'),(12519,12519,'2014-01-01','ET','2',1,NULL,'BRENDA DENISE KYLE','FI','428043608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:02',0,'2014-03-02 05:03:29'),(4621,4621,'2014-01-01','ET','2',1,NULL,'Meghann Duncan','FI','259559883','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:57',0,'2014-03-02 04:31:46'),(4173,4173,'2014-01-01','ET','2',1,NULL,'SHARON L HAMRICK','FI','274600158','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNAGAN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:22',0,'2014-03-10 15:59:47'),(20584,21234,'0000-00-00','ET','2',1,NULL,'Marghrettia Kundrach','FI','232805237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:01:38',0,'2014-03-01 18:08:07'),(19145,19795,'0000-00-00','ET','2',1,NULL,'Barbara Vaughan','FI','283528782','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:18',0,'2014-03-10 16:31:33'),(18875,19525,'0000-00-00','ET','2',4,3,'JIN KIM','FI','381133529','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:43',0,'2014-03-01 17:34:07'),(13465,13821,'2014-01-01','ET','2',1,NULL,'John Satterfield','FI','606529579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:29',0,'2014-03-01 16:40:16'),(2744,2744,'2014-01-01','ET','2',1,NULL,'BARBARA PITTMAN','FI','437067547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:33',0,'2014-03-02 04:15:49'),(12865,12865,'2014-01-01','ET','2',1,NULL,'Harry Zerbe','FI','401395865','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:36',0,'2014-03-01 16:35:14'),(3604,3604,'2014-01-01','ET','2',1,NULL,'karen e warden','FI','234064178','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:28',0,'2014-03-10 15:52:36'),(20557,21207,'0000-00-00','ET','2',1,NULL,'ELENA M CASTILLO','FI','461457532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:21',0,'2014-03-02 07:17:36'),(16244,16893,'0000-00-00','ET','2',1,NULL,'Timothy J Prince','FI','287425149','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:09',0,'2014-03-10 16:24:30'),(4499,4499,'2014-01-01','ET','2',1,NULL,'vicki wilson','FI','301528661','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 23:32:03',NULL,NULL),(11190,11190,'2014-01-01','ET','2',2,1,'Phuong Dao','FI','612036269','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:08',0,'2014-03-01 16:23:43'),(7227,7227,'2014-01-01','ET','2',1,NULL,'Thomas Jordan','FI','281489820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:29',0,'2014-03-01 15:52:44'),(2649,2649,'2014-01-01','ET','2',1,NULL,'Rachel Shamy','FI','268885750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:15:23',0,'2014-03-01 16:05:34'),(20295,20945,'0000-00-00','ET','2',1,NULL,'Thomas R  Legan','94','0000813091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:38',0,'2014-03-01 18:08:07'),(20543,21193,'0000-00-00','ET','2',1,NULL,'Pedro Canava','FI','455574639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:12',0,'2014-03-02 07:17:36'),(22574,23224,'0000-00-00','ET','2',1,NULL,'jack king','FI','269768642','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:02',0,'2014-03-10 14:50:59'),(22698,23348,'0000-00-00','ET','2',1,NULL,'Marsha Ray','FI','297467437','Dental Care Plus, Inc.','FI','311185262','Mike  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:57',0,'2014-03-08 21:35:36'),(15173,15624,'0000-00-00','ET','2',1,NULL,'LEAH  BARACCO','FI','434533819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:43',0,'2014-03-02 05:52:31'),(15075,15526,'2014-01-01','ET','2',1,NULL,'Barbara Hiltbrunner','FI','296425906','HealthSpan','FI','311431434','Donald  Larson','94','15784811','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:43',0,'2014-03-10 14:10:12'),(1506,1506,'2014-01-01','ET','2',2,1,'john parr','FI','296783734','Summa Insurance Company, Inc.','FI','341809108','Kristen  Parr','94','15171016','348','2014-01-01','Sync Success',0,'2013-12-25 18:57:34',0,'2014-03-10 16:03:49'),(11828,11828,'2014-01-01','ET','2',1,NULL,'DEXTER JOSEPH GUIDRY','FI','439795254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:59',0,'2014-03-02 04:31:46'),(22053,22703,'0000-00-00','ET','2',1,NULL,'William Harden','FI','291521806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:30',0,'2014-03-10 14:45:25'),(19578,20228,'0000-00-00','ET','2',1,NULL,'Sharon Graham','FI','290522434','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:25:47',0,'2014-03-10 14:37:47'),(18455,19105,'0000-00-00','ET','2',1,NULL,'Stephanie Schiffbauer','FI','293907274','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:40',0,'2014-03-10 16:31:33'),(12368,12368,'2014-01-01','ET','2',1,NULL,'Gillian Thorne','FI','455632378','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:30',0,'2014-03-02 05:03:29'),(11398,11398,'2014-01-01','ET','2',1,NULL,'Scott R Koenitzer','FI','279529504','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:29',0,'2014-03-10 16:03:49'),(11271,11271,'2014-01-01','ET','2',1,NULL,'DONALD WILLIAMS','FI','436883804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:37',0,'2014-03-02 04:52:44'),(17584,18234,'0000-00-00','ET','2',2,1,'JOHN RICHARD HAGAN','FI','285600340','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:00',0,'2014-03-10 14:24:38'),(2886,2886,'2014-01-01','ET','2',1,NULL,'Jeffery Ward','FI','591167999','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:12',0,'2014-03-10 13:39:10'),(2347,2347,'2014-01-01','ET','2',2,1,'STANLEY ROBERTS','FI','268546880','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:34',0,'2014-03-01 15:26:40'),(21296,21946,'0000-00-00','ET','2',2,1,'Monica Morris','FI','276844547','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:02',0,'2014-03-10 16:38:05'),(21956,22606,'0000-00-00','ET','2',1,NULL,'Lieu Kim Nguyen','FI','439530015','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:22',0,'2014-03-05 22:27:33'),(18682,19332,'0000-00-00','ET','2',1,NULL,'Mary Longfellow','FI','001448447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:38',0,'2014-03-02 06:45:14'),(17981,18631,'0000-00-00','ET','2',1,NULL,'michelle davidson','FI','268847027','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:26',0,'2014-03-10 14:24:38'),(12268,12268,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:10',0,'2014-03-10 16:10:34'),(11323,11323,'2014-01-01','ET','2',2,1,'Marlon Chen','FI','451578554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:11',0,'2014-03-02 04:52:44'),(16780,17430,'0000-00-00','ET','2',1,NULL,'Sharon Wallace','FI','293766686','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:28',0,'2014-03-10 14:20:26'),(10429,10429,'2014-01-01','ET','2',1,NULL,'JACQUELINE BONARRIGO','FI','273501817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:36',0,'2014-03-01 16:10:36'),(15188,15639,'0000-00-00','ET','2',1,NULL,'Blanca Vasquez','FI','287809469','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:44:17',0,'2014-03-10 14:10:12'),(4086,4086,'2014-01-01','ET','2',1,NULL,'TERRY  ALLEN','FI','212727935','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:52',0,'2014-03-01 16:00:27'),(21303,21953,'0000-00-00','ET','2',1,NULL,'Frank Civitarese','FI','289787703','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-01 21:01:08',0,'2014-03-10 16:38:05'),(21827,22477,'0000-00-00','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:21',0,'2014-03-05 21:36:22'),(19300,19950,'0000-00-00','ET','2',2,1,'ALISHA FORD','FI','456633027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:18',0,'2014-03-02 06:59:07'),(14660,15111,'2014-01-01','ET','2',1,NULL,'wanda abou-osman','FI','385707741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:45:28',0,'2014-03-01 16:46:19'),(12283,12283,'2014-01-01','ET','2',5,4,'Richard L Toalston','FI','279741184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:39',0,'2014-03-01 16:35:14'),(18208,18858,'0000-00-00','ET','2',1,NULL,'Thomas Kirkpatrick','FI','302463739','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:59',0,'2014-03-01 17:26:36'),(10783,10783,'2014-01-01','ET','2',2,1,'Kevin Nunez','FI','434813913','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:20',0,'2014-03-02 04:24:47'),(16302,16952,'0000-00-00','ET','2',1,NULL,'Evelyn Smith','FI','480156292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:24',0,'2014-03-02 06:10:30'),(15933,16582,'0000-00-00','ET','2',1,NULL,'Todd Curtiss','FI','286829770','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:13',0,'2014-03-10 16:24:30'),(1991,1991,'2014-01-01','ET','2',3,2,'Lan Dinh','FI','279927307','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:31',0,'2014-03-10 13:20:27'),(15187,15638,'0000-00-00','ET','2',1,NULL,'maria sandoval ore','FI','621189137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:44:17',0,'2014-03-02 05:52:31'),(21676,22326,'0000-00-00','ET','2',5,4,'maria tran','FI','586448442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:18',0,'2014-03-04 21:27:16'),(22464,23114,'0000-00-00','ET','2',1,NULL,'Ty A Allen','94','0001002231','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:46',0,'2014-03-07 21:36:32'),(22626,23276,'0000-00-00','ET','2',1,NULL,'jennifer knights','FI','280827505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:02',0,'2014-03-08 21:35:36'),(1442,1442,'2014-01-01','ET','2',2,1,'michael turkish','FI','298728665','Dental Care Plus, Inc.','FI','311185262','stephanie  sine','94','8013059','348','2014-01-01','Sync Success',0,'2013-12-25 18:55:28',0,'2014-03-01 16:15:39'),(19075,19725,'0000-00-00','ET','2',1,NULL,'Chad Preston Barnhill','FI','439754706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:25',0,'2014-03-02 06:52:12'),(17616,18266,'0000-00-00','ET','2',2,1,'Kuntal Hazari','FI','632138653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:13',0,'2014-03-02 06:31:45'),(12891,12891,'2014-01-01','ET','2',1,NULL,'JASON HUTCHINSON','FI','271707457','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:34',0,'2014-03-10 13:59:38'),(12729,12729,'2014-01-01','ET','2',2,1,'William Geith','FI','293508402','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:54',0,'2014-03-10 16:10:34'),(17555,18205,'0000-00-00','ET','2',2,1,'TONY THAMPAGNE','FI','439829632','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:37',0,'2014-03-02 06:31:45'),(2321,2321,'2014-01-01','ET','2',1,NULL,'GERALDINE ERWIN','FI','459082112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:57',0,'2014-03-01 19:11:03'),(23037,23687,'0000-00-00','ET','2',1,NULL,'Andrew Reese','FI','289902007','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:19',0,'2014-03-10 21:17:52'),(15448,15899,'0000-00-00','ET','2',2,1,'Machanna S Taylor','FI','427237311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:40',0,'2014-03-02 05:59:43'),(4841,4841,'2014-01-01','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:20',0,'2014-03-01 15:10:22'),(13119,13475,'2014-01-01','ET','2',1,NULL,'Tasha Lang','FI','450711202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:43',0,'2014-03-02 05:17:40'),(12910,12910,'2014-01-01','ET','2',2,1,'Hussain Hemani','FI','454672273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:16',0,'2014-03-02 05:10:52'),(12588,12588,'2014-01-01','ET','2',1,NULL,'Ryan Thomas Shaffer','FI','302841669','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:41',0,'2014-03-01 16:35:14'),(7761,7761,'2014-01-01','ET','2',1,NULL,'Christopher Myers','FI','278924902','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:14',0,'2014-03-10 13:03:33'),(11784,11784,'2014-01-01','ET','2',1,NULL,'Navina Bhatkar','FI','464879633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:37',0,'2014-03-02 04:31:46'),(21740,22390,'0000-00-00','ET','2',2,1,'Toby Owens','FI','296522962','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:11',0,'2014-03-10 14:45:25'),(22970,23620,'0000-00-00','ET','2',1,NULL,'felecia dawn kennedy','FI','448989592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:30',0,'2014-03-10 21:36:25'),(17844,18494,'0000-00-00','ET','2',1,NULL,'William Sobieck','FI','282524315','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','348','2014-03-01','Sync Success',0,'2014-02-10 11:01:10',0,'2014-03-10 14:20:26'),(14760,15211,'2014-01-01','ET','2',3,2,'Roy Bourn','FI','297683419','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:31',0,'2014-03-10 16:17:47'),(14652,15103,'2014-01-01','ET','2',1,NULL,'Susan Deyarmin','FI','288720012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:22',0,'2014-03-01 16:46:19'),(15695,16344,'0000-00-00','ET','2',2,1,'Andrew Seymore','FI','458888852','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:45',0,'2014-03-02 05:59:43'),(11570,11570,'2014-01-01','ET','2',1,NULL,'Aracely Barron','FI','631141867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:50',0,'2014-03-02 04:52:44'),(7454,7454,'2014-01-01','ET','2',1,NULL,'Hector Ramirez','FI','642263869','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','357','2014-01-01','Sync Success',0,'2013-12-26 04:32:30',0,'2014-03-02 04:10:25'),(7236,7236,'2014-01-01','ET','2',5,4,'Terri Hornbach-Torres','FI','299522416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:46',0,'2014-03-01 15:52:44'),(5108,5108,'2014-01-01','ET','2',2,1,'Elton Hyndman','FI','395119890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:26',0,'2014-03-02 00:10:48'),(329,329,'2014-01-01','ET','2',1,NULL,'Martin Saenz','FI','457235077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:07',0,'2014-03-01 15:21:15'),(481,481,'2014-01-01','ET','2',1,NULL,'Linda Barnett','FI','281527930','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 17:51:04',0,'2014-03-10 13:10:24'),(20580,21230,'0000-00-00','ET','2',1,NULL,'DANIEL TARANTO','FI','294606361','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:36',0,'2014-03-01 18:08:07'),(13807,14163,'2014-01-01','ET','2',1,NULL,'jessica ann wilson','FI','277788775','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:14',0,'2014-03-01 16:40:16'),(15912,16561,'0000-00-00','ET','2',1,NULL,'TERESA BERNAL','FI','635664793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:02',0,'2014-03-02 06:03:21'),(15175,15626,'0000-00-00','ET','2',1,NULL,'Nicholas Chowning','FI','272928871','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:45',0,'2014-03-10 14:10:12'),(11481,11481,'2014-01-01','ET','2',1,NULL,'sheryl hannah','FI','272640566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:31:07',0,'2014-03-01 16:30:17'),(11413,11413,'2014-01-01','ET','2',1,NULL,'CARMEN RIFE','FI','291841230','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:06:59',0,'2014-03-10 13:52:32'),(11080,11080,'2014-01-01','ET','2',1,NULL,'MARY TULK','FI','368583578','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:27',0,'2014-03-10 13:45:57'),(2097,2097,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:57',0,'2014-03-10 13:20:27'),(3627,3627,'2014-01-01','ET','2',2,1,'REBECCA FLINNER','FI','269665664','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:11',0,'2014-03-10 15:52:36'),(4595,4595,'2014-01-01','ET','2',1,NULL,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:47:08',0,'2014-03-01 16:15:39'),(7326,7326,'2014-01-01','ET','2',1,NULL,'Jerry Barlow','FI','301547929','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:10:31',0,'2014-03-10 13:32:15'),(4721,4721,'2014-01-01','ET','2',5,4,'Amy Painter','FI','274828099','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:22',0,'2014-03-10 13:45:57'),(4687,4687,'2014-01-01','ET','2',1,NULL,'Elizabeth Feagins','FI','076527747','Starmount Life Insurance Company','FI','720977315','Dale  Mason','94','1182966','348','2014-01-01','Sync Success',0,'2013-12-25 23:50:12',0,'2014-03-02 04:38:08'),(20963,21613,'0000-00-00','ET','2',1,NULL,'Randy D Bender','FI','400881208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:15',0,'2014-03-01 18:08:07'),(20859,21509,'0000-00-00','ET','2',1,NULL,'Paul Silcox','FI','365644414','HealthSpan','FI','311431434','Robert  Zirker III','94','1005990','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:26',0,'2014-03-10 14:45:25'),(19775,20425,'0000-00-00','ET','2',1,NULL,'angel alonzo','FI','438250899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:23',0,'2014-03-02 07:03:25'),(18367,19017,'0000-00-00','ET','2',2,1,'TRUNG VAN NGUYEN','FI','462719714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:38',0,'2014-03-02 06:45:14'),(16032,16681,'0000-00-00','ET','2',2,1,'Ramsey Madere','FI','436752169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:31',0,'2014-03-02 06:03:21'),(12204,12204,'2014-01-01','ET','2',1,NULL,'ELIZABETH DETZEL','FI','285482807','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:09:28',0,'2014-03-10 13:52:32'),(11872,11872,'2014-01-01','ET','2',1,NULL,'Sharon Brown','FI','464291725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:09',0,'2014-03-02 04:59:36'),(10576,10576,'2014-01-01','ET','2',1,NULL,'Virginia Quiroga','FI','292545436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:25',0,'2014-03-02 04:24:47'),(3057,3057,'2014-01-01','ET','2',2,1,'Michelle Markielowski','FI','276867049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:50',0,'2014-03-01 15:37:30'),(3055,3055,'2014-01-01','ET','2',1,NULL,'Amanuel Gebremariam','FI','620196786','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:47',0,'2014-03-01 15:37:30'),(15418,15869,'0000-00-00','ET','2',1,NULL,'MELISSA  MENDEZ','FI','461857447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:21',0,'2014-03-02 05:59:43'),(2357,2357,'2014-01-01','ET','2',1,NULL,'Thomas Glascock','FI','400862767','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:51',0,'2014-03-01 15:26:40'),(3935,3935,'2014-01-01','ET','2',2,1,'Lo Bui','FI','659140620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:05',0,'2014-03-01 23:10:52'),(4528,4528,'2014-01-01','ET','2',1,NULL,'Mary Ridge','FI','281504384','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:33:02',0,'2014-03-10 13:03:33'),(7645,7645,'2014-01-01','ET','2',1,NULL,'Mary Robinett','FI','287800066','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:41',0,'2014-03-10 13:39:10'),(18635,19285,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:01:02',0,'2014-03-01 17:26:36'),(7290,7290,'2014-01-01','ET','2',1,NULL,'Laura Barton','FI','277724505','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:25',0,'2014-03-10 13:32:15'),(5936,5936,'2014-01-01','ET','2',1,NULL,'Timothy Krueger','FI','282824632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:54',0,'2014-03-01 15:48:04'),(1799,1799,'2014-01-01','ET','2',1,NULL,'Millie Durant','FI','425064323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:37',0,'2014-03-02 00:10:48'),(18472,19122,'0000-00-00','ET','2',1,NULL,'Jessenia Conde','FI','463852822','Starmount Life Insurance Company','FI','720977315','Esequiel  Garcia','94','16428563','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:52',0,'2014-03-02 06:45:14'),(2712,2712,'2014-01-01','ET','2',1,NULL,'Kendra Goolsby','FI','633100353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:34',0,'2014-03-02 04:15:49'),(2351,2351,'2014-01-01','ET','2',1,NULL,'Andrew  Olinger','FI','281026082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:41',0,'2014-03-01 15:26:40'),(11484,11484,'2014-01-01','ET','2',1,NULL,'ANDREY YEFREMOV','FI','284960829','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:31:12',0,'2014-03-01 16:30:17'),(11514,11514,'2014-01-01','ET','2',1,NULL,'Andrea Boll','FI','546934135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:32:04',0,'2014-03-02 04:52:44'),(18471,19121,'0000-00-00','ET','2',1,NULL,'ALana Arbor','FI','465132656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:51',0,'2014-03-02 06:45:14'),(13516,13872,'2014-01-01','ET','2',1,NULL,'Ralph Edward Hooper','FI','466252106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:27',0,'2014-03-02 05:31:31'),(14003,14359,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:33',0,'2014-03-01 16:40:16'),(14302,14753,'2014-01-01','ET','2',1,NULL,'SHEILA S KNOTT','FI','452216663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:25',0,'2014-03-02 05:38:34'),(585,585,'2014-01-01','ET','2',1,NULL,'DeAnna LaHaye','FI','438868322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:06',0,'2014-03-02 02:10:49'),(21101,21751,'0000-00-00','ET','2',1,NULL,'yanqin ni','FI','095900670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:47',0,'2014-03-02 07:23:39'),(6218,6218,'2014-01-01','ET','2',2,1,'Ronald H Lehman','FI','295423213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:51',0,'2014-03-01 16:00:27'),(5259,5259,'2014-01-01','ET','2',1,NULL,'Teresa Williams','FI','300821956','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:20',0,'2014-03-10 13:20:27'),(20783,21433,'0000-00-00','ET','2',1,NULL,'derek e allgyer','FI','275924352','Summa Insurance Company, Inc.','FI','341809108','d  finnegin','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:50',0,'2014-03-10 16:38:05'),(18763,19413,'0000-00-00','ET','2',1,NULL,'Lance Hostetler','FI','315967019','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 22:02:39',0,'2014-03-10 14:31:05'),(16225,16874,'0000-00-00','ET','2',1,NULL,'ALBA CISNEROS','FI','456938640','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:56',0,'2014-03-02 06:10:30'),(15571,16022,'0000-00-00','ET','2',1,NULL,'Sherry Scott','FI','558159988','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:23',0,'2014-03-10 14:10:12'),(21696,22346,'0000-00-00','ET','2',3,2,'Benjamin Russell Gandy','FI','283780349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:34',0,'2014-03-04 21:36:30'),(22835,23485,'0000-00-00','ET','2',1,NULL,'Ashley Owens','FI','272922836','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:29:59',0,'2014-03-10 14:50:59'),(21134,21784,'0000-00-00','ET','2',2,1,'Autumn Pearcy-Jennings','FI','275645239','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:11',0,'2014-03-10 16:38:05'),(13176,13532,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:50',0,'2014-03-10 16:10:34'),(10968,10968,'2014-01-01','ET','2',1,NULL,'Karen Crabtree','FI','301463542','Summa Insurance Company, Inc.','FI','341809108','DEANNA M WELLS','94','7827930','348','2014-01-01','Sync Success',0,'2013-12-26 13:09:40',0,'2014-03-10 16:03:49'),(2663,2663,'2014-01-01','ET','2',2,1,'Brian Burnette','FI','292868790','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:57',0,'2014-03-01 16:05:34'),(20498,21148,'0000-00-00','ET','2',1,NULL,'PRENTISS BORDELON','FI','437496029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:42',0,'2014-03-02 07:10:28'),(17117,17767,'0000-00-00','ET','2',1,NULL,'Dustin Greer','FI','295844441','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:10',0,'2014-03-10 14:20:26'),(2187,2187,'2014-01-01','ET','2',2,1,'Diane Lohman','FI','466805291','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 19:47:43',0,'2014-03-01 21:11:04'),(15842,16491,'0000-00-00','ET','2',1,NULL,'Christy McMurry','FI','300604108','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:35',0,'2014-03-01 16:56:22'),(6298,6298,'2014-01-01','ET','2',1,NULL,'MARY LOCKWOOD','FI','587764876','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:22',0,'2014-03-02 04:10:25'),(14106,14557,'2014-01-01','ET','2',1,NULL,'NIYRA R MUHAMMAD','FI','291760774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:39',0,'2014-03-01 16:40:16'),(14297,14748,'2014-01-01','ET','2',1,NULL,'CELESTE COOK','FI','291780521','Dental Care Plus, Inc.','FI','311185262','Benson  Jones','94','7890601','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:22',0,'2014-03-01 16:46:19'),(14810,15261,'2014-01-01','ET','2',1,NULL,'Michelle Stiles','FI','296888279','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:04',0,'2014-03-10 16:17:47'),(23028,23678,'0000-00-00','ET','2',1,NULL,'Donna Fleming','FI','455591690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:11',0,'2014-03-10 21:27:11'),(20443,21093,'0000-00-00','ET','2',1,NULL,'JOHNNETTA LEEFORT','FI','425066846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:59',0,'2014-03-02 07:10:28'),(18768,19418,'0000-00-00','ET','2',4,3,'NOSA OVIAHON','FI','296981617','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:42',0,'2014-03-10 14:31:05'),(18154,18804,'0000-00-00','ET','2',1,NULL,'barbara  smith','FI','437130533','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:19',0,'2014-03-02 06:38:05'),(17275,17925,'0000-00-00','ET','2',1,NULL,'Charles Milligan','FI','458392874','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:42',0,'2014-03-02 06:24:38'),(16929,17579,'0000-00-00','ET','2',1,NULL,'SHENIKA LOFTON','FI','426650923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:44',0,'2014-03-02 06:17:30'),(1609,1609,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:27',0,'2014-03-01 20:10:57'),(2307,2307,'2014-01-01','ET','2',2,1,'Jeralyn Ducote','FI','439132631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:28',0,'2014-03-01 19:11:03'),(22693,23343,'0000-00-00','ET','2',1,NULL,'Roy Newlon','FI','282545518','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:53',0,'2014-03-10 14:50:59'),(2534,2534,'2014-01-01','ET','2',1,NULL,'Patricia Davis','FI','208387209','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:01',0,'2014-03-01 20:10:57'),(17483,18133,'0000-00-00','ET','2',1,NULL,'laura mayall','FI','546557071','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:41',0,'2014-03-10 14:24:38'),(13956,14312,'2014-01-01','ET','2',4,3,'John Kennedy','FI','283808167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:38',0,'2014-03-10 14:03:26'),(13955,14311,'2014-01-01','ET','2',1,NULL,'LUCY DOOLAN','FI','182505845','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:37',0,'2014-03-10 16:10:34'),(12645,12645,'2014-01-01','ET','2',1,NULL,'theronyln wilson','FI','436853826','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:44',0,'2014-03-02 05:10:52'),(4308,4308,'2014-01-01','ET','2',1,NULL,'Crystal lugo','FI','439393692','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:31',0,'2014-03-02 03:09:49'),(12211,12211,'2014-01-01','ET','2',1,NULL,'Mary Ann Crocker','FI','191507204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:55',0,'2014-03-01 16:35:14'),(354,354,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:55',0,'2014-03-01 15:21:15'),(16811,17461,'0000-00-00','ET','2',2,1,'Christopher Gott','FI','564274613','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:50',0,'2014-03-10 14:20:26'),(7276,7276,'2014-01-01','ET','2',2,1,'Matthew McGrath','FI','289864972','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:59',0,'2014-03-10 13:32:15'),(16624,17274,'0000-00-00','ET','2',1,NULL,'Brian nnolim','FI','258679322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:23',0,'2014-03-02 06:17:30'),(15820,16469,'0000-00-00','ET','2',1,NULL,'sonja brooks','FI','439238495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:23',0,'2014-03-02 06:03:21'),(3503,3503,'2014-01-01','ET','2',4,3,'DREW  DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:18',0,'2014-03-01 15:37:30'),(13496,13852,'2014-01-01','ET','2',1,NULL,'Ellen Schweers','FI','449117895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:14',0,'2014-03-02 05:31:31'),(22448,23098,'0000-00-00','ET','2',1,NULL,'LINDSEY NORWOOD','FI','458945439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:33',0,'2014-03-07 22:26:59'),(790,790,'2014-01-01','ET','2',1,NULL,'Princesa Alexander','FI','449021116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:48',0,'2014-03-01 19:11:03'),(10593,10593,'2014-01-01','ET','2',1,NULL,'KRISTI SMITH  WOODS','FI','458199493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:56',0,'2014-03-02 04:24:47'),(5257,5257,'2014-01-01','ET','2',1,NULL,'KENNETH GILBERT','FI','368587455','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:17',0,'2014-03-10 13:20:27'),(1111,1111,'2014-01-01','ET','2',1,0,'Cory Nathan Shockey','FI','467651827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:28',0,'2014-03-01 19:11:03'),(3377,3377,'2014-01-01','ET','2',1,NULL,'Ernestina Longoria','FI','452196919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:00',0,'2014-03-02 02:10:49'),(3652,3652,'2014-01-01','ET','2',1,NULL,'lisa gabriel','FI','017462145','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:00',0,'2014-03-10 15:52:36'),(4724,4724,'2014-01-01','ET','2',1,NULL,'scott morrin','FI','271525446','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:31',0,'2014-03-10 13:45:57'),(5222,5222,'2014-01-01','ET','2',1,NULL,'Jerry Barlow','FI','301547929','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:07',0,'2014-03-10 13:20:27'),(20678,21328,'0000-00-00','ET','2',1,NULL,'MARIA URTON','FI','299604957','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:46',0,'2014-03-10 14:37:47'),(5880,5880,'2014-01-01','ET','2',1,NULL,'Matthew Boes','FI','294904624','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:07',0,'2014-03-10 15:52:36'),(2713,2713,'2014-01-01','ET','2',1,NULL,'harvey wheaton','FI','548824873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:17:36',0,'2014-03-02 04:15:49'),(1880,1880,'2014-01-01','ET','2',1,NULL,'JENNIFER JAEB','FI','473628022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:13',0,'2014-03-01 23:10:52'),(4635,4635,'2014-01-01','ET','2',1,NULL,'Monica DeBaun','FI','642091676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:25',0,'2014-03-02 04:31:46'),(11796,11796,'2014-01-01','ET','2',1,NULL,'phillip meili','FI','465518721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:00',0,'2014-03-02 04:31:46'),(12544,12544,'2014-01-01','ET','2',1,NULL,'Susan Leibold','FI','302620454','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:00',0,'2014-03-10 13:59:38'),(17604,18254,'0000-00-00','ET','2',2,1,'Jorge Chavira','FI','523731854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:06',0,'2014-03-02 06:31:45'),(18585,19235,'0000-00-00','ET','2',2,1,'Manilall Seebaluck','FI','785398729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:23',0,'2014-03-01 17:26:36'),(18362,19012,'0000-00-00','ET','2',3,2,'MIRIAM TAPIA','FI','645121435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:34',0,'2014-03-02 06:45:14'),(14056,14507,'2014-01-01','ET','2',5,4,'Sarah Hindel','FI','299601175','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:06',0,'2014-03-01 16:46:19'),(13334,13690,'2014-01-01','ET','2',1,NULL,'Danielle Washington','FI','438670976','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:25',0,'2014-03-02 05:24:45'),(16212,16861,'0000-00-00','ET','2',1,NULL,'ANNE WALSH','FI','465832157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:48',0,'2014-03-02 06:10:30'),(11561,11561,'2014-01-01','ET','2',2,1,'Patricia Smith','FI','457111138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:32',0,'2014-03-02 04:52:44'),(10796,10796,'2014-01-01','ET','2',1,NULL,'susan pittman stevens','FI','435137569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:44',0,'2014-03-02 04:24:47'),(496,496,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-25 18:00:22',0,'2014-03-01 15:48:04'),(14590,15041,'2014-01-01','ET','2',1,NULL,'Laura Chance','FI','430799238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:43',0,'2014-03-02 05:45:37'),(19658,20309,'0000-00-00','ET','2',1,NULL,'Karen Kopis','FI','291626186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:45:41',0,'2014-03-01 17:47:19'),(2443,2443,'2014-01-01','ET','2',1,NULL,'Jonathan Jones','FI','276867738','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:35',0,'2014-03-10 15:45:56'),(19484,20134,'0000-00-00','ET','2',2,1,'CAROLYN LOUISE TILLEY','FI','462068273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:59:23',0,'2014-03-02 06:59:07'),(17005,17655,'0000-00-00','ET','2',1,NULL,'CONNIE HEDGES','FI','273509683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:35',0,'2014-03-10 14:20:26'),(10669,10669,'2014-01-01','ET','2',2,1,'KEVIN JUNG','FI','478749786','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:23',0,'2014-03-01 16:10:36'),(10411,10411,'2014-01-01','ET','2',1,NULL,'charles miller','FI','287586646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:04',0,'2014-03-01 16:10:36'),(1360,1360,'2014-01-01','ET','2',2,1,'JUAN MARTINEZ','94','0000277730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:46',0,'2014-03-02 04:38:08'),(10745,10745,'2014-01-01','ET','2',3,2,'KRISTEN L LEE','FI','327742896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:02',0,'2014-03-01 16:10:36'),(20991,21641,'0000-00-00','ET','2',1,NULL,'JENNIFER PALUMBO','FI','299926243','Summa Insurance Company, Inc.','FI','341809108','michael  kost','94','1924114','348','2014-03-01','Sync Success',0,'2014-02-28 07:30:33',0,'2014-03-10 16:38:05'),(19363,20013,'0000-00-00','ET','2',1,NULL,'Ralph Grier','FI','230889174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:42',0,'2014-03-01 17:34:07'),(5458,5458,'2014-01-01','ET','2',1,NULL,'Teven Reed','FI','436811050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:05',0,'2014-03-02 04:45:37'),(22559,23209,'0000-00-00','ET','2',2,1,'John Britenriker','FI','291585180','Summa Insurance Company, Inc.','FI','341809108','John C Dalziel','94','362362','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:52',0,'2014-03-10 16:44:18'),(22913,23563,'0000-00-00','ET','2',1,NULL,'Jessica lynn Dugas','FI','438657231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:50',0,'2014-03-10 21:27:11'),(913,913,'2014-01-01','ET','2',1,NULL,'anne harvey','FI','268709174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:28',0,'2014-03-01 15:21:15'),(6060,6060,'2014-01-01','ET','2',1,NULL,'Carl Henry Johnson','FI','438376264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:03',0,'2014-03-02 04:10:25'),(20438,21088,'0000-00-00','ET','2',1,NULL,'torie thorne','FI','370924385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:55',0,'2014-03-01 18:08:07'),(17356,18006,'0000-00-00','ET','2',2,1,'VICTOR  HARRISON','FI','449088498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:11',0,'2014-03-02 06:31:45'),(2136,2136,'2014-01-01','ET','2',2,1,'CAROL JONES','FI','271507031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:00',0,'2014-03-01 15:16:37'),(2675,2675,'2014-01-01','ET','2',1,NULL,'Ronnie Eugene  Mack','FI','463238782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:23',0,'2014-03-02 04:15:49'),(16943,17593,'0000-00-00','ET','2',1,NULL,'COURTNEY FEARS','FI','608072685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:54',0,'2014-03-02 06:17:30'),(16219,16868,'0000-00-00','ET','2',1,NULL,'Betty Fragoso','FI','463986598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:52',0,'2014-03-02 06:10:30'),(22498,23148,'0000-00-00','ET','2',1,NULL,'DANIEL QUINN','FI','271606182','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:08',0,'2014-03-07 21:36:32'),(10634,10634,'2014-01-01','ET','2',1,NULL,'Kimberly Saeger','FI','525134175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:18',0,'2014-03-02 04:31:46'),(3921,3921,'2014-01-01','ET','2',1,NULL,'PAUL YANOVICH','FI','278503493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:39',0,'2014-03-01 15:26:40'),(21485,22135,'0000-00-00','ET','2',1,NULL,'felicia loaiza','FI','297048697','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:45',0,'2014-03-03 21:36:16'),(6376,6376,'2014-01-01','ET','2',1,NULL,'Gwendolyn Wilson','FI','386600148','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:45',0,'2014-03-10 13:39:10'),(5645,5645,'2014-01-01','ET','2',1,NULL,'Christine Collins','FI','438175908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:10',0,'2014-03-02 04:45:37'),(17817,18467,'0000-00-00','ET','2',1,NULL,'Carol E Morgan','FI','291505072','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:49',0,'2014-03-10 14:20:26'),(12763,12763,'2014-01-01','ET','2',2,1,'Mary Martin','FI','277648196','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:13',0,'2014-03-10 13:59:38'),(14136,14587,'2014-01-01','ET','2',1,NULL,'Eric Jenkins','FI','545613915','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:58',0,'2014-03-02 05:38:34'),(20094,20744,'0000-00-00','ET','2',1,NULL,'MARKKEITH ALLISON','FI','434835111','Starmount Life Insurance Company','FI','720977315','LISA  ADAMS','94','4109783','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:14',0,'2014-03-02 07:10:28'),(4800,4800,'2014-01-01','ET','2',1,NULL,'Vickie Lawhon','FI','289527553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:53',0,'2014-03-01 15:16:37'),(1034,1034,'2014-01-01','ET','2',1,NULL,'SHEILA  R HIRSCHFELD','FI','291483629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:21',0,'2014-03-10 13:10:24'),(4335,4335,'2014-01-01','ET','2',1,NULL,'timothy musil','94','0000418858','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 23:10:18',NULL,NULL),(19635,20285,'0000-00-00','ET','2',2,1,'Melanie Dawn Lovingshimer','FI','289724784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:39:32',0,'2014-03-01 17:47:19'),(2060,2060,'2014-01-01','ET','2',5,4,'Steve Andreadis','FI','292642644','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:45',0,'2014-03-10 13:20:27'),(17739,18389,'0000-00-00','ET','2',1,NULL,'JOELLE HENDRICK','FI','097385435','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:27',0,'2014-03-10 16:31:33'),(16252,16901,'0000-00-00','ET','2',1,NULL,'Edith Dean','FI','289663131','HealthSpan','FI','311431434','Sharon  Wingert','94','2446886','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:14',0,'2014-03-10 14:20:26'),(15582,16033,'0000-00-00','ET','2',1,NULL,'DAVID HAMMOND','FI','300489858','HealthSpan','FI','311431434','JOSEPH  HESSLING','94','7320983','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:28',0,'2014-03-10 14:10:12'),(10837,10837,'2014-01-01','ET','2',1,NULL,'SHENNA ANTOINETTE PARSON','FI','439635313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:03',0,'2014-03-02 04:31:46'),(11928,11928,'2014-01-01','ET','2',1,NULL,'Mitchell Antesky','FI','288705357','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:53',0,'2014-03-10 13:52:32'),(13537,13893,'2014-01-01','ET','2',1,NULL,'Diana Marie Royer','FI','289724675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:41',0,'2014-03-01 16:40:16'),(12188,12188,'2014-01-01','ET','2',3,2,'kent nicholas','FI','270785225','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:54',0,'2014-03-10 13:52:32'),(13024,13380,'2014-01-01','ET','2',2,1,'Shawn Mckee','FI','293923488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:09',0,'2014-03-01 16:35:14'),(16442,17092,'0000-00-00','ET','2',1,NULL,'AMY PITLER','FI','385882441','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:53',0,'2014-03-10 14:20:26'),(11832,11832,'2014-01-01','ET','2',1,NULL,'Aziz Akhtar','FI','436554025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:07',0,'2014-03-02 04:31:46'),(686,686,'2014-01-01','ET','2',1,NULL,'Annette Fritz','FI','039328263','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:17',0,'2014-03-10 15:52:36'),(21573,22223,'0000-00-00','ET','2',1,NULL,'ZELMA HILL','FI','460335858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:50',0,'2014-03-03 22:26:43'),(20600,21250,'0000-00-00','ET','2',1,NULL,'Andrew Fitzgerald','FI','224729400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:48',0,'2014-03-01 18:08:07'),(1075,1075,'2014-01-01','ET','2',1,NULL,'Susan Marie Kishel','FI','298486796','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:06',0,'2014-03-10 13:03:33'),(20183,20833,'0000-00-00','ET','2',1,NULL,'David Newsome','FI','238494879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:18',0,'2014-03-02 07:10:28'),(18983,19633,'0000-00-00','ET','2',1,NULL,'Emily Egan','FI','044748322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:03',0,'2014-03-02 06:52:12'),(3368,3368,'2014-01-01','ET','2',1,NULL,'DEBERA FLOWERS','FI','466432363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:41',0,'2014-03-02 02:10:49'),(17422,18072,'0000-00-00','ET','2',1,NULL,'Robin Watkins','FI','591179631','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:57',0,'2014-03-10 16:24:30'),(13715,14071,'2014-01-01','ET','2',1,NULL,'DANIEL OSBORN','FI','270560706','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:50',0,'2014-03-10 13:59:38'),(16618,17268,'0000-00-00','ET','2',1,NULL,'STEPHEN G HACKETT','FI','627489004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:19',0,'2014-03-02 06:17:30'),(15750,16399,'0000-00-00','ET','2',1,NULL,'Nancy Ann Helinski','FI','268547623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:01:22',0,'2014-03-01 16:50:53'),(15752,16401,'0000-00-00','ET','2',1,NULL,'RONALD RODGERS','FI','283565831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:23',0,'2014-03-01 16:56:22'),(21433,22083,'0000-00-00','ET','2',1,NULL,'KOSHA RICHARD','FI','435532402','Starmount Life Insurance Company','FI','720977315','LISA M ADAMS','94','4109783','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:04',0,'2014-03-03 22:26:43'),(22187,22837,'0000-00-00','ET','2',4,3,'MARIA KLUN','FI','287723564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:30',0,'2014-03-06 21:36:23'),(558,558,'2014-01-01','ET','2',1,NULL,'MARTIN JAMES MALLOY','FI','272689114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:18',0,'2014-03-01 15:48:04'),(3007,3007,'2014-01-01','ET','2',1,NULL,'Diane Boenker','FI','324580258','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:20',0,'2014-03-10 15:52:36'),(4704,4704,'2014-01-01','ET','2',1,NULL,'Danielle Nettles','FI','376117679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:46',0,'2014-03-02 04:31:46'),(19543,20193,'0000-00-00','ET','2',1,NULL,'RICARDO GALMON','FI','435736617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:16:37',0,'2014-03-02 06:59:07'),(18301,18951,'0000-00-00','ET','2',3,2,'Mary Braig','FI','271581695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:03',0,'2014-03-01 17:26:36'),(11617,11617,'2014-01-01','ET','2',1,NULL,'CAROLYN CLEMENT','FI','288507802','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:16',0,'2014-03-10 16:03:49'),(16814,17464,'0000-00-00','ET','2',1,NULL,'Bonnie Austin','FI','453676584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:52',0,'2014-03-02 06:17:30'),(21336,21986,'0000-00-00','ET','2',1,NULL,'Anne L Randles','FI','294445522','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-03 01:00:16',0,'2014-03-03 01:35:37'),(2637,2637,'2014-01-01','ET','2',1,NULL,'M Ackerman','FI','436675749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:12',0,'2014-03-01 21:11:04'),(18452,19102,'0000-00-00','ET','2',2,1,'Michael Geoffrey Gruesen','94','0000759741','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:39',0,'2014-03-10 16:31:33'),(13005,13005,'2014-01-01','ET','2',1,NULL,'LINDA MARIE HANKS','FI','345563635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:18',0,'2014-03-02 05:17:40'),(5378,5378,'2014-01-01','ET','2',1,NULL,'VICTOR CARNEL BARNER','FI','463392239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:49',0,'2014-03-01 21:11:04'),(11378,11378,'2014-01-01','ET','2',1,NULL,'Paulette Williams','FI','272506572','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-02-01','Sync Success',0,'2013-12-27 02:05:54',0,'2014-03-10 13:52:32'),(3468,3468,'2014-01-01','ET','2',1,NULL,'Katherine Stewart','FI','290905513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:10',0,'2014-03-01 15:31:33'),(17323,17973,'0000-00-00','ET','2',1,NULL,'Vaj Vang','FI','299966251','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:08',0,'2014-03-10 16:24:30'),(7709,7709,'2014-01-01','ET','2',2,1,'Vivian Tran','FI','065681006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:46',0,'2014-03-01 20:10:57'),(16041,16690,'0000-00-00','ET','2',1,NULL,'JAMES WOODARD','FI','439886863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:37',0,'2014-03-02 06:03:21'),(15413,15864,'0000-00-00','ET','2',1,NULL,'Martha talkington','FI','452923868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:17',0,'2014-03-02 05:59:43'),(12899,12899,'2014-01-01','ET','2',2,1,'Ryan T Russell','FI','270947566','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:52',0,'2014-03-10 13:59:38'),(3467,3467,'2014-01-01','ET','2',1,NULL,'Cindy Xin Fang Chen','FI','562879608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:08',0,'2014-03-01 15:31:33'),(12267,12267,'2014-01-01','ET','2',1,NULL,'Angela Keith','FI','290847198','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:08',0,'2014-03-10 16:10:34'),(22099,22749,'0000-00-00','ET','2',1,NULL,'CINDY  MORENO','FI','627162266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:28',0,'2014-03-06 21:27:26'),(22214,22864,'0000-00-00','ET','2',1,NULL,'Sloane Robison','FI','291940103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:49',0,'2014-03-06 21:36:23'),(22438,23088,'0000-00-00','ET','2',1,NULL,'Elisha K Holoman','FI','460273758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:27',0,'2014-03-07 22:26:59'),(20535,21185,'0000-00-00','ET','2',1,NULL,'Kimberly Ward','FI','465192364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:07',0,'2014-03-02 07:10:28'),(828,828,'2014-01-01','ET','2',1,NULL,'Timothy Trzcinski','FI','291587508','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:15',0,'2014-03-10 13:03:33'),(19177,19827,'0000-00-00','ET','2',1,NULL,'Lauren Boughton','FI','439699144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:45',0,'2014-03-02 06:52:12'),(15323,15774,'0000-00-00','ET','2',1,NULL,'Michael Hummer','94','0000968239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-21 08:46:32',0,'2014-03-01 16:50:53'),(15130,15581,'0000-00-00','ET','2',2,1,'ashley peet','FI','287805470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:13',0,'2014-03-10 16:17:47'),(12545,12545,'2014-01-01','ET','2',1,NULL,'Roy Boop','FI','300504991','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:03',0,'2014-03-10 13:59:38'),(22529,23179,'0000-00-00','ET','2',1,NULL,'Pamela Ramsier','FI','290749747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:31',0,'2014-03-07 21:36:32'),(21867,22517,'0000-00-00','ET','2',1,NULL,'Lisa Jackson','FI','107427033','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:18',0,'2014-03-05 21:36:22'),(20957,21607,'0000-00-00','ET','2',1,NULL,'Celeste Marie Gonzalez','FI','458794403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:10',0,'2014-03-02 07:17:36'),(15617,16068,'0000-00-00','ET','2',1,NULL,'EARNESTINE HARRIS','FI','587206954','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:44',0,'2014-03-02 05:59:43'),(12664,12664,'2014-01-01','ET','2',1,NULL,'Jacqueline Ellis','FI','293487632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:29',0,'2014-03-01 16:35:14'),(14526,14977,'2014-01-01','ET','2',1,NULL,'eric bardes','FI','312706724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:08:05',0,'2014-03-10 16:17:47'),(11530,11530,'2014-01-01','ET','2',1,NULL,'Staci Bruce','FI','425498836','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:32',0,'2014-03-02 04:52:44'),(255,255,'2014-01-01','ET','2',1,NULL,'Michael C Lombardino','FI','439212935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:03',0,'2014-03-01 20:10:57'),(18547,19197,'0000-00-00','ET','2',1,NULL,'Keri Klippel','FI','290925720','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:10',0,'2014-03-10 16:31:33'),(12191,12191,'2014-01-01','ET','2',1,NULL,'Doug Gallaspie','FI','280701347','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:00',0,'2014-03-10 13:52:32'),(1762,1762,'2014-01-01','ET','2',1,NULL,'Deborah Smith','FI','159449384','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:21',0,'2014-03-10 13:20:27'),(7124,7124,'2014-01-01','ET','2',1,NULL,'Annette Rickett','FI','288523228','Dental Care Plus, Inc.','FI','311185262','Adam  Hyers','94','2449599','348','2014-01-01','Sync Success',0,'2013-12-26 04:04:20',0,'2014-03-01 15:52:44'),(4875,4875,'2014-01-01','ET','2',2,1,'Victoria Strickland','FI','491980388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:25',0,'2014-03-01 15:10:22'),(17923,18573,'0000-00-00','ET','2',4,3,'Charlotte Townsend','FI','509866201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:44',0,'2014-03-02 06:38:05'),(10658,10658,'2014-01-01','ET','2',1,NULL,'pedro  willis-barbosa','FI','447844653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:04',0,'2014-03-02 04:31:46'),(10650,10650,'2014-01-01','ET','2',1,NULL,'MARCELINA R FERNANDEZ','FI','458636411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:48',0,'2014-03-02 04:31:46'),(16319,16969,'0000-00-00','ET','2',1,NULL,'edward anthony albers','FI','288886068','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:35',0,'2014-03-01 17:00:58'),(15053,15504,'2014-01-01','ET','2',1,NULL,'Treva Eihinger','FI','270501494','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:33',0,'2014-03-10 16:17:47'),(4254,4254,'2014-01-01','ET','2',2,1,'James Young','FI','289505676','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:56',0,'2014-03-10 13:32:15'),(14421,14872,'2014-01-01','ET','2',1,NULL,'ADA  D BALDWIN','FI','426199873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:16',0,'2014-03-02 05:38:34'),(12284,12284,'2014-01-01','ET','2',1,NULL,'cynthia italiano','FI','292507934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:43',0,'2014-03-01 16:35:14'),(534,534,'2014-01-01','ET','2',2,1,'John Van Deursen','FI','145449694','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:30',0,'2014-03-01 15:48:04'),(22100,22750,'0000-00-00','ET','2',1,NULL,'JANET JARNER','FI','451060458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:29',0,'2014-03-06 21:27:26'),(1063,1063,'2014-01-01','ET','2',1,NULL,'Jack Mayfield','FI','278523377','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:43',0,'2014-03-10 15:39:19'),(18038,18688,'0000-00-00','ET','2',1,NULL,'SAMARIOUS ISOM','94','0000318451','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:05',0,'2014-03-01 17:20:55'),(17669,18319,'0000-00-00','ET','2',1,NULL,'Kaleena Harpster','FI','299888504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:46',0,'2014-03-01 17:20:55'),(15669,16318,'0000-00-00','ET','2',1,NULL,'Lea Ann Blankenship','FI','604016302','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:26',0,'2014-03-10 16:24:30'),(15016,15467,'2014-01-01','ET','2',1,NULL,'Brittany Baker','FI','280944579','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:17',0,'2014-03-10 14:10:12'),(4891,4891,'2014-01-01','ET','2',1,0,'Allison Nickle','FI','466957564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:04',0,'2014-03-01 19:11:03'),(4669,4669,'2014-01-01','ET','2',5,4,'Shelley Walker','FI','291706601','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:32',0,'2014-03-01 16:15:39'),(11435,11435,'2014-01-01','ET','2',1,NULL,'Rocksand Hollinger','FI','271547843','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:42',0,'2014-03-10 13:52:32'),(11416,11416,'2014-01-01','ET','2',1,NULL,'Robin Jordan','FI','591967627','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:04',0,'2014-03-10 13:52:32'),(708,708,'2014-01-01','ET','2',1,NULL,'SHELLY SCHROEDER','FI','274681855','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:59',0,'2014-03-10 13:24:34'),(1566,1566,'2014-01-01','ET','2',1,NULL,'Julie Woodward','FI','269769512','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:08',0,'2014-03-01 15:10:22'),(20027,20677,'0000-00-00','ET','2',1,NULL,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-21 22:01:11',0,'2014-03-10 14:37:47'),(2009,2009,'2014-01-01','ET','2',1,NULL,'John Charles Ellis','FI','451841538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:09',0,'2014-03-02 00:10:48'),(13834,14190,'2014-01-01','ET','2',2,1,'Maricela Hernandez','FI','243258795','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:37',0,'2014-03-02 05:31:31'),(4362,4362,'2014-01-01','ET','2',1,NULL,'Paul Caryl Ropp','FI','299600761','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:08',0,'2014-03-10 13:32:15'),(3885,3885,'2014-01-01','ET','2',1,NULL,'Andrew Stableford','FI','299888171','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:42',0,'2014-03-10 13:03:33'),(13535,13891,'2014-01-01','ET','2',1,NULL,'Wendy Jones','FI','298501239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:40',0,'2014-03-01 16:40:16'),(12472,12472,'2014-01-01','ET','2',1,NULL,'Todd Smith','FI','286866405','Dental Care Plus, Inc.','FI','311185262','Heidi  McArthur','94','8621177','348','2014-02-01','Sync Success',1,'2014-01-02 04:32:17',0,'2014-03-01 16:30:17'),(3602,3602,'2014-01-01','ET','2',1,NULL,'WILLIAM HOEFLER','FI','290486779','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:24',0,'2014-03-10 13:20:27'),(12256,12256,'2014-01-01','ET','2',1,NULL,'MARILYN ARLAND','FI','466882193','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:40',0,'2014-03-02 05:03:29'),(2461,2461,'2014-01-01','ET','2',1,NULL,'Debra Jordan','FI','435359554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:13',0,'2014-03-01 23:10:52'),(220,220,'2014-01-01','ET','2',2,1,'Michael  Cole','FI','286508906','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:58',0,'2014-03-10 13:10:24'),(20037,20687,'0000-00-00','ET','2',1,NULL,'Richard Chambers','FI','279504115','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:11',0,'2014-03-10 16:38:05'),(10642,10642,'2014-01-01','ET','2',1,NULL,'Linda Morris','FI','467847243','Starmount Life Insurance Company','FI','720977315','Mary  Rodriguez','94','563485','348','2014-01-01','Sync Success',0,'2013-12-26 12:58:33',0,'2014-03-02 04:31:46'),(7284,7284,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:14',0,'2014-03-10 13:32:15'),(18321,18971,'0000-00-00','ET','2',2,1,'James Winchell','FI','293487720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:07',0,'2014-03-01 17:26:36'),(7004,7004,'2014-01-01','ET','2',1,NULL,'janet torres casillas','FI','462378262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:37',0,'2014-03-02 02:10:49'),(16592,17242,'0000-00-00','ET','2',1,NULL,'Magaret Boos','FI','292468315','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:38',0,'2014-03-10 14:20:26'),(6123,6123,'2014-01-01','ET','2',1,NULL,'LINDA LIPOVEC','FI','296582952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:00',0,'2014-03-01 16:00:27'),(15775,16424,'0000-00-00','ET','2',1,NULL,'Keith Anderson','FI','272865768','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:38',0,'2014-03-10 16:24:30'),(11658,11658,'2014-01-01','ET','2',1,NULL,'Emily Crum','FI','273925627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:32',0,'2014-03-01 16:30:17'),(13782,14138,'2014-01-01','ET','2',1,NULL,'Pamela Cross','FI','280606597','HealthSpan','FI','311431434','Tamy  Hagan','94','3691584','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:35',0,'2014-03-10 13:59:38'),(14262,14713,'2014-01-01','ET','2',1,NULL,'Ashley Poynter','FI','294929887','Dental Care Plus, Inc.','FI','311185262','Mike  Groh','94','2767799','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:08',0,'2014-03-01 16:46:19'),(85,85,'2014-01-01','ET','2',1,NULL,'Gregory Huber','FI','459351809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:35',0,'2014-03-01 22:10:55'),(181,181,'2014-01-01','ET','2',1,NULL,'Sarah Hanson','FI','434617857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:20:37',0,'2014-03-01 22:10:55'),(619,619,'2014-01-01','ET','2',1,NULL,'Odeaa Aljabbari','FI','640195122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:13',0,'2014-03-02 02:10:49'),(7692,7692,'2014-01-01','ET','2',1,NULL,'sheryl hannah','FI','272640566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:11',0,'2014-03-01 15:10:22'),(13168,13524,'2014-01-01','ET','2',1,NULL,'Glenn Dickens','FI','289745157','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:33',0,'2014-03-10 13:59:38'),(13070,13426,'2014-01-01','ET','2',1,NULL,'EUGENIA WILLIAMS','FI','438233890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:47',0,'2014-03-02 05:17:40'),(11850,11850,'2014-01-01','ET','2',2,1,'Tracy Golden','FI','287763882','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:46',0,'2014-03-01 16:15:39'),(22123,22773,'0000-00-00','ET','2',1,NULL,'lakeisha allen','FI','435738004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:47',0,'2014-03-06 21:27:26'),(19434,20084,'0000-00-00','ET','2',1,NULL,'Anna Candela','FI','523826988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:33',0,'2014-03-02 06:59:07'),(17787,18437,'0000-00-00','ET','2',1,NULL,'DAVID MCVEY','FI','622056902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:22',0,'2014-03-01 16:50:53'),(14853,15304,'2014-01-01','ET','2',1,NULL,'Jessica Street','FI','467731872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:03',0,'2014-03-02 05:45:37'),(11781,11781,'2014-01-01','ET','2',1,NULL,'Lonnie Gibson','FI','282521132','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:25',0,'2014-03-10 13:52:32'),(20577,21227,'0000-00-00','ET','2',1,NULL,'THOMAS MOREY','FI','136528049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:34',0,'2014-03-01 18:08:07'),(3365,3365,'2014-01-01','ET','2',1,NULL,'TERESA DELAFUENTE','FI','629096491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:35',0,'2014-03-02 02:10:49'),(3482,3482,'2014-01-01','ET','2',1,NULL,'DENISE KIPKER','FI','286520415','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:37',0,'2014-03-01 15:37:30'),(7138,7138,'2014-01-01','ET','2',1,NULL,'Gregory Williams','FI','269602495','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:42',0,'2014-03-01 15:52:44'),(6386,6386,'2014-01-01','ET','2',1,NULL,'Susan Eaton','FI','369660017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:03',0,'2014-03-10 13:39:10'),(19234,19884,'0000-00-00','ET','2',2,1,'FRANKIE FLORES','FI','453913735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:27',0,'2014-03-02 06:52:12'),(14454,14905,'2014-01-01','ET','2',1,NULL,'Erma Jones','FI','436259138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:32',0,'2014-03-02 05:38:34'),(14687,15138,'2014-01-01','ET','2',1,NULL,'Kent Matkowski','FI','530944396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:46',0,'2014-03-02 05:45:37'),(22727,23377,'0000-00-00','ET','2',1,NULL,'Todd E Jones','FI','298766195','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:18',0,'2014-03-10 14:50:59'),(2494,2494,'2014-01-01','ET','2',1,NULL,'Lavonne Dawson','FI','274682390','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 20:20:21',0,'2014-03-10 13:10:24'),(10655,10655,'2014-01-01','ET','2',1,NULL,'Elbert Pruitt','FI','456510382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:59',0,'2014-03-02 04:31:46'),(2730,2730,'2014-01-01','ET','2',1,NULL,'Cristina M Araiza','FI','466907296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:08',0,'2014-03-02 04:15:49'),(3685,3685,'2014-01-01','ET','2',1,NULL,'Mark Angel','FI','457714448','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 22:07:00',0,'2014-03-10 13:20:27'),(5556,5556,'2014-01-01','ET','2',1,NULL,'VERONICA CHUKWU','FI','463458065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:14',0,'2014-03-02 04:45:37'),(20877,21527,'0000-00-00','ET','2',2,1,'Elizabeth York','FI','548824087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:34',0,'2014-03-10 14:45:25'),(4082,4082,'2014-01-01','ET','2',1,NULL,'WILLIAM Gamble','FI','288523662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:44',0,'2014-03-01 16:00:27'),(18046,18696,'0000-00-00','ET','2',1,NULL,'HEATHER BENDER','FI','283620455','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:10',0,'2014-03-10 16:31:33'),(17755,18405,'0000-00-00','ET','2',1,NULL,'Janet Buckner','FI','274503530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:39',0,'2014-03-01 17:20:55'),(17514,18164,'0000-00-00','ET','2',2,1,'travis fails','FI','460571939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:11',0,'2014-03-02 06:31:45'),(4110,4110,'2014-01-01','ET','2',1,NULL,'Michael Truong','FI','298780493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:31',0,'2014-03-01 16:00:27'),(5383,5383,'2014-01-01','ET','2',2,1,'Peter Dzung Pham','FI','461477683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:00',0,'2014-03-01 21:11:04'),(10400,10400,'2014-01-01','ET','2',1,NULL,'KEVIN CRONIN','FI','364560965','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:44',0,'2014-03-01 16:10:36'),(11241,11241,'2014-01-01','ET','2',1,NULL,'Jan McFarland','FI','272689628','Dental Care Plus, Inc.','FI','311185262','Emily  Thomas','94','2448778','348','2014-02-01','Sync Success',0,'2013-12-27 02:01:41',0,'2014-03-01 16:23:43'),(11943,11943,'2014-01-01','ET','2',1,NULL,'Lucas Amato','FI','298901792','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:25',0,'2014-03-10 13:52:32'),(20594,21244,'0000-00-00','ET','2',1,NULL,'Tawnya Amos','FI','272609343','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:45',0,'2014-03-01 18:08:07'),(15251,15702,'0000-00-00','ET','2',3,2,'MARGARITA AGUIRRE','FI','551935789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:29',0,'2014-03-02 05:52:31'),(15455,15906,'0000-00-00','ET','2',1,NULL,'Evan  Thomas  Saul','FI','593491289','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:45',0,'2014-03-01 16:50:53'),(21273,21923,'0000-00-00','ET','2',3,2,'David Calcagno Sr','FI','434114707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:44',0,'2014-03-02 07:23:39'),(294,294,'2014-01-01','ET','2',1,NULL,'william hopwood','FI','287425325','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:02',0,'2014-03-10 13:10:24'),(16051,16700,'0000-00-00','ET','2',1,NULL,'Bryan Davis','FI','289845028','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:44',0,'2014-03-01 16:56:22'),(15882,16531,'0000-00-00','ET','2',1,NULL,'Julie Stevens','FI','220270434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:01:01',0,'2014-03-02 06:03:21'),(7747,7747,'2014-01-01','ET','2',1,NULL,'George Gilbert','FI','301700912','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:45',0,'2014-03-01 15:05:09'),(7226,7226,'2014-01-01','ET','2',1,NULL,'Robin  Lewis','FI','270505551','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:27',0,'2014-03-01 15:52:44'),(11946,11946,'2014-01-01','ET','2',1,NULL,'DANNY HERNANDEZ','FI','468862353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:05',0,'2014-03-02 04:59:36'),(6021,6021,'2014-01-01','ET','2',1,NULL,'robert L harvey','FI','045442185','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:35',0,'2014-03-10 15:39:19'),(5746,5746,'2014-01-01','ET','2',1,NULL,'SANDY LOU COSPOLOICH','FI','438133356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:47',0,'2014-03-02 01:10:33'),(22792,23442,'0000-00-00','ET','2',2,1,'MARIAN JURGENSEN','FI','450782681','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:43',0,'2014-03-09 21:26:00'),(14179,14630,'2014-01-01','ET','2',1,NULL,'Ericka Jordan','FI','270721456','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:33:26',0,'2014-03-10 14:03:26'),(13426,13782,'2014-01-01','ET','2',1,NULL,'Donald Hill','FI','291600768','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:25:07',0,'2014-03-10 13:59:38'),(12027,12027,'2014-01-01','ET','2',1,NULL,'Janice Turner','FI','436043236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:06',0,'2014-03-02 04:59:36'),(2431,2431,'2014-01-01','ET','2',1,NULL,'TRACI LEE BOSNYAK','FI','279841899','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:12',0,'2014-03-10 15:45:56'),(2312,2312,'2014-01-01','ET','2',1,NULL,'charles barnett','FI','295784747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:39',0,'2014-03-01 15:05:09'),(4758,4758,'2014-01-01','ET','2',2,1,'Pamela J Braunstein','FI','280569077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:35',0,'2014-03-01 15:16:37'),(17534,18184,'0000-00-00','ET','2',1,NULL,'sierra franklin','FI','376154604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:24',0,'2014-03-01 17:20:55'),(16697,17347,'0000-00-00','ET','2',1,NULL,'mary ann robinson','FI','279589069','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:15',0,'2014-03-01 17:00:58'),(11065,11065,'2014-01-01','ET','2',1,NULL,'Jan Bennett','FI','277467831','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-26 13:12:59',0,'2014-03-10 16:03:49'),(16457,17107,'0000-00-00','ET','2',2,1,'Jennie Rosier','FI','301508007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:11',0,'2014-03-01 17:00:58'),(4001,4001,'2014-01-01','ET','2',1,NULL,'michael barron','FI','463047669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:00:13',0,'2014-03-02 03:09:49'),(16228,16877,'0000-00-00','ET','2',1,NULL,'MARIA D VASQUEZ','FI','455834600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:00:58',0,'2014-03-02 06:10:30'),(5652,5652,'2014-01-01','ET','2',1,NULL,'Erich Kincaid','FI','526774668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:51:23',0,'2014-03-02 04:45:37'),(14690,15141,'2014-01-01','ET','2',2,1,'Vincent Chao','FI','434690286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:48',0,'2014-03-02 05:45:37'),(2738,2738,'2014-01-01','ET','2',1,NULL,'Wanda Conner','FI','438861389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:21',0,'2014-03-02 04:15:49'),(10858,10858,'2014-01-01','ET','2',1,NULL,'FREDERIC SEIBERT','FI','297488752','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:05:47',0,'2014-03-10 13:45:57'),(21268,21918,'0000-00-00','ET','2',1,NULL,'Barbara Louise Card','FI','298481930','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:41',0,'2014-03-01 21:35:40'),(21266,21916,'0000-00-00','ET','2',1,NULL,'Frank Civitarese','FI','289787703','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:39',0,'2014-03-01 21:35:40'),(15191,15642,'0000-00-00','ET','2',1,NULL,'Cinthia Gumpf','FI','292642502','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:19',0,'2014-03-10 14:10:12'),(21800,22450,'0000-00-00','ET','2',1,NULL,'Linda M Spencer','FI','292509830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:16',0,'2014-03-04 21:36:30'),(21177,21827,'0000-00-00','ET','2',1,NULL,'carolyn buckley','FI','428510035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:40',0,'2014-03-02 07:23:39'),(6265,6265,'2014-01-01','ET','2',1,NULL,'EMMANUEL EDWARDS','FI','436635953','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:22',0,'2014-03-02 04:10:25'),(17641,18291,'0000-00-00','ET','2',1,NULL,'wendy barnett','FI','290742136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:29',0,'2014-03-01 17:20:55'),(5249,5249,'2014-01-01','ET','2',1,NULL,'Holly Baker','FI','283663804','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:58',0,'2014-03-10 13:20:27'),(13218,13574,'2014-01-01','ET','2',1,NULL,'KRISTOPHER KRAHN','FI','453318012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:48',0,'2014-03-02 05:17:40'),(13688,14044,'2014-01-01','ET','2',2,1,'Ronald McInturff','FI','442509174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:33',0,'2014-03-02 05:24:45'),(16373,17023,'0000-00-00','ET','2',1,NULL,'VELMA GRISSOM','FI','437083295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:09',0,'2014-03-02 06:10:30'),(366,366,'2014-01-01','ET','2',1,NULL,'Mark Purdy','FI','302868388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:47:17',0,'2014-03-01 15:21:15'),(22343,22993,'0000-00-00','ET','2',1,NULL,'Madison Bregitzer','94','0000578830','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','357','2014-03-31','Sync Success',0,'2014-03-07 21:00:09',0,'2014-03-07 21:36:32'),(19187,19837,'0000-00-00','ET','2',2,1,'Mark Coffey','FI','278629870','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:54',0,'2014-03-10 14:31:05'),(2664,2664,'2014-01-01','ET','2',1,NULL,'Deborah Cook-Gorsuch','FI','270528970','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:00',0,'2014-03-01 16:05:34'),(3346,3346,'2014-01-01','ET','2',1,NULL,'Vahid Jameei','FI','640295757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:04',0,'2014-03-02 02:10:49'),(19029,19679,'0000-00-00','ET','2',1,NULL,'Gina Buccino','94','0000799917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:03',0,'2014-03-01 17:34:07'),(17618,18268,'0000-00-00','ET','2',2,1,'JOSE  PEDRO OLVERA','FI','452996933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:14',0,'2014-03-02 06:31:45'),(13474,13830,'2014-01-01','ET','2',1,NULL,'eric bardes','FI','312706724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:34',0,'2014-03-10 16:17:47'),(17610,18260,'0000-00-00','ET','2',1,NULL,'JAMES PETEET','FI','453866044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-08 19:00:09',0,'2014-03-02 06:31:45'),(14250,14701,'2014-01-01','ET','2',1,NULL,'Betty Semler','FI','284524926','Dental Care Plus, Inc.','FI','311185262','Linda  Gross','94','16787812','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:02',0,'2014-03-01 16:46:19'),(16463,17113,'0000-00-00','ET','2',2,1,'JULIE DELONG','FI','244116910','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:14',0,'2014-03-01 17:00:58'),(14588,15039,'2014-01-01','ET','2',1,NULL,'Guillermo  Fuentes','FI','628167445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:42',0,'2014-03-02 05:45:37'),(14726,15177,'2014-01-01','ET','2',2,1,'anthony burton','FI','436631620','Starmount Life Insurance Company','FI','720977315','brenda  burton','94','4709939','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:11',0,'2014-03-02 05:45:37'),(22602,23252,'0000-00-00','ET','2',1,NULL,'FANNIE M LEWES','FI','425041426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:24',0,'2014-03-07 22:26:59'),(22701,23351,'0000-00-00','ET','2',1,NULL,'kendreic hankston','FI','453938968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:59',0,'2014-03-08 22:26:18'),(23055,23705,'0000-00-00','ET','2',2,1,'Michael O\'Keefe','FI','350741821','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:31',0,'2014-03-10 21:17:52'),(2268,2268,'2014-01-01','ET','2',2,1,'Cortney Metcalf','FI','307024753','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:05',0,'2014-03-10 13:03:33'),(11369,11369,'2014-01-01','ET','2',1,NULL,'Brenda Paggett','FI','433027514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:37',0,'2014-03-02 04:45:37'),(7366,7366,'2014-01-01','ET','2',1,NULL,'YVONNE M MCCALL','FI','294548941','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:04',0,'2014-03-01 15:16:37'),(21562,22212,'0000-00-00','ET','2',1,NULL,'Huey Roberts','FI','438239383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:31:40',0,'2014-03-03 22:26:43'),(7231,7231,'2014-01-01','ET','2',2,1,'John Sand','FI','302487158','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:36',0,'2014-03-01 15:52:44'),(5928,5928,'2014-01-01','ET','2',2,1,'Todd Kleinpaste','FI','272906521','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:40',0,'2014-03-01 15:48:04'),(3572,3572,'2014-01-01','ET','2',2,1,'Vivian Tran','FI','065681006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:29',0,'2014-03-02 00:10:48'),(4636,4636,'2014-01-01','ET','2',1,NULL,'JAMEEL AHMED','FI','138962949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:27',0,'2014-03-02 04:31:46'),(14143,14594,'2014-01-01','ET','2',1,NULL,'Megan Miller','FI','433655769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:03',0,'2014-03-02 05:38:34'),(14529,14980,'2014-01-01','ET','2',1,NULL,'Ciara Hopkins','FI','272845389','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:07',0,'2014-03-10 14:03:26'),(15312,15763,'0000-00-00','ET','2',1,NULL,'TRISHA ROWLAND','FI','289702654','Dental Care Plus, Inc.','FI','311185262','CARL  BLOOMER','94','1792832','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:25',0,'2014-03-01 16:50:53'),(17926,18576,'0000-00-00','ET','2',2,1,'Luara  De la Rosa','FI','630604061','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:47',0,'2014-03-02 06:38:05'),(19017,19667,'0000-00-00','ET','2',1,NULL,'Rebecca Dunkelberger','FI','300523909','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:27',0,'2014-03-10 14:31:05'),(21128,21778,'0000-00-00','ET','2',3,2,'Gregory Kroh','FI','278745554','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-03-01','Sync Success',0,'2014-02-28 21:31:06',0,'2014-03-10 16:38:05'),(20769,21419,'0000-00-00','ET','2',1,NULL,'JAMES IZRAEL','FI','268727914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:43',0,'2014-03-01 18:08:07'),(18761,19411,'0000-00-00','ET','2',1,NULL,'dustin lafleur','FI','437556187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:37',0,'2014-03-02 06:52:12'),(17909,18559,'0000-00-00','ET','2',2,1,'Maria del socorro Almaguer','FI','631128805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:35',0,'2014-03-02 06:31:45'),(17613,18263,'0000-00-00','ET','2',1,NULL,'EDMERYL WILLIAMS','FI','467941510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:11',0,'2014-03-02 06:31:45'),(10919,10919,'2014-01-01','ET','2',1,NULL,'Terrie Lee Shaheen','FI','269605350','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:16',0,'2014-03-10 16:03:49'),(7512,7512,'2014-01-01','ET','2',2,1,'Bryant Smith','FI','272464219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:25',0,'2014-03-01 16:05:34'),(12981,12981,'2014-01-01','ET','2',1,NULL,'ANDREA GUIDRY','FI','453935603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:28',0,'2014-03-02 05:17:40'),(5071,5071,'2014-01-01','ET','2',1,NULL,'Maureen Conley','FI','279641055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:17',0,'2014-03-01 15:31:33'),(21760,22410,'0000-00-00','ET','2',1,NULL,'Cindy Horsey','FI','276664223','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-04 21:02:29',0,'2014-03-10 14:45:25'),(22704,23354,'0000-00-00','ET','2',1,NULL,'NATHANIEL LOPEZ','FI','122682981','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:01',0,'2014-03-10 16:44:18'),(22761,23411,'0000-00-00','ET','2',1,NULL,'James Skeen','FI','465795437','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:19',0,'2014-03-09 21:26:00'),(18677,19327,'0000-00-00','ET','2',1,NULL,'ROSE MEDDERS','FI','460061683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:35',0,'2014-03-02 06:45:14'),(16235,16884,'0000-00-00','ET','2',1,NULL,'Terrence Chung','FI','470194959','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:02',0,'2014-03-10 16:24:30'),(15296,15747,'0000-00-00','ET','2',1,NULL,'Shawn Caughey','FI','277567504','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:16',0,'2014-03-10 16:17:47'),(7484,7484,'2014-01-01','ET','2',2,1,'Joseph Lewis','FI','271507134','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:27',0,'2014-03-10 13:39:10'),(7420,7420,'2014-01-01','ET','2',1,NULL,'Daniel Ducote','FI','436695963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:31',0,'2014-03-02 04:15:49'),(1900,1900,'2014-01-01','ET','2',1,NULL,'Clarence Bullard','FI','458298987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:46',0,'2014-03-01 23:10:52'),(4080,4080,'2014-01-01','ET','2',1,NULL,'Sharon K Rhoades','FI','274449739','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:40',0,'2014-03-01 16:00:27'),(21438,22088,'0000-00-00','ET','2',1,NULL,'Hettie Frey','FI','279521730','Summa Insurance Company, Inc.','FI','341809108','Barry  Kerrigan','94','1766088','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:09',0,'2014-03-10 16:44:18'),(20444,21094,'0000-00-00','ET','2',1,NULL,'SHARELL WILSON','FI','279863035','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 09:31:00',0,'2014-03-10 14:37:47'),(14496,14947,'2014-01-01','ET','2',1,NULL,'Phillip Neff','FI','268909016','HealthSpan','FI','311431434','Andrew J Gutierrez','94','16770974','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:50',0,'2014-03-10 14:03:26'),(13968,14324,'2014-01-01','ET','2',2,1,'leonard tomcko','FI','282527717','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:06',0,'2014-03-01 16:40:16'),(4352,4352,'2014-01-01','ET','2',2,1,'patricia brinkman','FI','291484951','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:50',0,'2014-03-10 13:32:15'),(17919,18569,'0000-00-00','ET','2',1,NULL,'emmanuel osikpa','FI','247359367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:42',0,'2014-03-02 06:38:05'),(5359,5359,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:09',0,'2014-03-10 15:39:19'),(5905,5905,'2014-01-01','ET','2',2,1,'Jillian Jackson','FI','425755755','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:57',0,'2014-03-02 01:10:33'),(17328,17978,'0000-00-00','ET','2',1,NULL,'Katherine Murrell','FI','428577806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:10',0,'2014-03-02 06:24:38'),(2055,2055,'2014-01-01','ET','2',2,1,'LINDA HOPKINS','FI','284521836','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:34',0,'2014-03-10 15:45:56'),(1022,1022,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:58',0,'2014-03-10 15:39:19'),(17207,17857,'0000-00-00','ET','2',1,NULL,'Jim Napier','FI','286702426','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:09',0,'2014-03-01 17:20:55'),(22617,23267,'0000-00-00','ET','2',1,NULL,'Ma Angelica Fortanelli-Martinez','FI','459999610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:06',0,'2014-03-08 21:25:11'),(1206,1206,'2014-01-01','ET','2',1,NULL,'Erica Jane Moore','FI','283820184','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:47:59',0,'2014-03-10 13:45:57'),(12001,12001,'2014-01-01','ET','2',1,NULL,'Kathleen M Souza','FI','272663785','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:05',0,'2014-03-10 16:10:34'),(3883,3883,'2014-01-01','ET','2',1,0,'ALBERTA JONES','FI','280683950','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:31:38',0,'2014-03-10 15:39:19'),(21232,21882,'0000-00-00','ET','2',1,NULL,'Ranell Richoux','FI','437861097','Starmount Life Insurance Company','FI','720977315','John  Dyer','94','4725710','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:18',0,'2014-03-02 07:23:39'),(4976,4976,'2014-01-01','ET','2',1,NULL,'Randall Bryant','FI','273664824','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:14',0,'2014-03-01 15:31:33'),(20710,21360,'0000-00-00','ET','2',1,NULL,'William Loomis','FI','224118600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:30:17',0,'2014-03-01 18:08:07'),(2152,2152,'2014-01-01','ET','2',2,1,'Patrice Parsons','FI','449068250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:31',0,'2014-03-01 21:11:04'),(20243,20893,'0000-00-00','ET','2',1,NULL,'Joseph Dircksen','FI','283504338','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:04',0,'2014-03-10 14:37:47'),(18958,19608,'0000-00-00','ET','2',2,1,'Richard Jones','FI','426396135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:43',0,'2014-03-02 06:52:12'),(18873,19523,'0000-00-00','ET','2',1,NULL,'MARY BRIDGEFORD','FI','273666885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:42',0,'2014-03-01 17:34:07'),(17316,17966,'0000-00-00','ET','2',4,3,'Thomas MacCarthy','FI','272118403','HealthSpan','FI','311431434','Jemari  James','94','17045637','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:04',0,'2014-03-10 14:24:38'),(22779,23429,'0000-00-00','ET','2',1,NULL,'stephen brisbine','FI','278526317','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-09 21:00:33',0,'2014-03-09 21:35:27'),(31,31,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:15:55',0,'2014-03-01 15:21:15'),(15026,15477,'2014-01-01','ET','2',1,NULL,'kevin c nunez','FI','434813913','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:21',0,'2014-03-02 05:52:31'),(5172,5172,'2014-01-01','ET','2',1,NULL,'Keith Wernert','FI','299886806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:27',0,'2014-03-10 13:20:27'),(13468,13824,'2014-01-01','ET','2',1,NULL,'Andy Babcock','FI','048903228','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:31',0,'2014-03-10 14:03:26'),(448,448,'2014-01-01','ET','2',1,NULL,'Jorge Machado','FI','590373618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:54',0,'2014-03-10 15:45:56'),(12667,12667,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:35',0,'2014-03-01 16:35:14'),(12156,12156,'2014-01-01','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:40',0,'2014-03-10 13:52:32'),(12121,12121,'2014-01-01','ET','2',2,1,'Stephanie Smith','FI','276849834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:26',0,'2014-03-01 16:30:17'),(12112,12112,'2014-01-01','ET','2',1,NULL,'SHARRON KORNEGAY','FI','577764413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:06:07',0,'2014-03-01 16:30:17'),(11418,11418,'2014-01-01','ET','2',1,NULL,'joshua doughman','FI','276807533','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:07:09',0,'2014-03-10 13:52:32'),(10979,10979,'2014-01-01','ET','2',2,1,'Harish Patel','94','0000392500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:03',0,'2014-03-02 04:24:47'),(10484,10484,'2014-01-01','ET','2',1,NULL,'MIKE SMITH','FI','413943619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:23',0,'2014-03-01 16:10:36'),(10403,10403,'2014-01-01','ET','2',1,NULL,'yetunde okunoye','FI','294906913','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:49',0,'2014-03-01 16:10:36'),(1735,1735,'2014-01-01','ET','2',1,NULL,'Melanie Bushman','FI','301901303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:33',0,'2014-03-01 15:31:33'),(3219,3219,'2014-01-01','ET','2',1,NULL,'MARK RADER','FI','503683019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:54',0,'2014-03-01 15:52:44'),(1434,1434,'2014-01-01','ET','2',1,NULL,'Alison Myers','FI','269115674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:11',0,'2014-03-01 16:15:39'),(2784,2784,'2014-01-01','ET','2',2,1,'BONNIE B KAY','FI','273469394','Dental Care Plus, Inc.','FI','311185262','KENNETH  BROWN','94','1481512','348','2014-01-01','Sync Success',0,'2013-12-25 21:19:48',0,'2014-03-01 16:05:34'),(21918,22568,'0000-00-00','ET','2',1,NULL,'SERGIO PEREZ','FI','644032982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Received',0,'2014-03-05 21:30:55',NULL,NULL),(16622,17272,'0000-00-00','ET','2',1,NULL,'Maria Mejia','FI','463041456','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:22',0,'2014-03-02 06:17:30'),(15011,15462,'2014-01-01','ET','2',3,2,'JEFFERY DAVIS','FI','291666524','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:14',0,'2014-03-10 16:17:47'),(14342,14793,'2014-01-01','ET','2',1,NULL,'Sandra Simmons','FI','466840637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:42',0,'2014-03-02 05:45:37'),(16402,17052,'0000-00-00','ET','2',2,1,'Tiffany Budzinski','FI','291900309','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:28',0,'2014-03-10 14:20:26'),(10725,10725,'2014-01-01','ET','2',1,NULL,'Brandon adkins','FI','296928732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:27',0,'2014-03-01 16:10:36'),(10981,10981,'2014-01-01','ET','2',1,NULL,'yolanda faye bennett','FI','428834514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:07',0,'2014-03-02 04:24:47'),(22851,23501,'0000-00-00','ET','2',1,NULL,'BEATRIZ MORENO','FI','631349772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:04',0,'2014-03-10 21:27:11'),(1867,1867,'2014-01-01','ET','2',1,NULL,'Jennifer Krenisky','FI','280583138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:46',0,'2014-03-01 15:26:40'),(14321,14772,'2014-01-01','ET','2',1,NULL,'Megann Rodriguez','FI','462738155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:33',0,'2014-03-02 05:38:34'),(21309,21959,'0000-00-00','ET','2',1,NULL,'MELODY GAY','FI','272521647','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 01:00:01',0,'2014-03-10 14:45:25'),(21032,21682,'0000-00-00','ET','2',4,3,'Keith Dietrich','FI','298720882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:00:23',0,'2014-03-10 14:45:25'),(2709,2709,'2014-01-01','ET','2',1,NULL,'Melinda Peterson','FI','459575420','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:28',0,'2014-03-02 04:15:49'),(1934,1934,'2014-01-01','ET','2',1,NULL,'Chasity Conner','FI','285963927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:45',0,'2014-03-01 15:26:40'),(4162,4162,'2014-01-01','ET','2',1,NULL,'sean m merriman','FI','284503668','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:03',0,'2014-03-10 15:59:47'),(10808,10808,'2014-01-01','ET','2',1,NULL,'Karen Napoli','FI','434021453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:04:09',0,'2014-03-02 04:24:47'),(4760,4760,'2014-01-01','ET','2',2,1,'Melea Yaslovitz','FI','405157376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:38',0,'2014-03-01 15:16:37'),(5565,5565,'2014-01-01','ET','2',1,NULL,'roy guerra','FI','457272729','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:31',0,'2014-03-02 04:45:37'),(2633,2633,'2014-01-01','ET','2',1,NULL,'Theresa Perkins','FI','439064514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:03',0,'2014-03-01 21:11:04'),(13700,14056,'2014-01-01','ET','2',1,NULL,'Gillian  Rose Stupar','FI','295767460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:40',0,'2014-03-01 16:40:16'),(13489,13845,'2014-01-01','ET','2',1,NULL,'JONATHAN OLVERA','FI','386836479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:09',0,'2014-03-02 05:24:45'),(10951,10951,'2014-01-01','ET','2',1,NULL,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:15',0,'2014-03-10 16:03:49'),(21737,22387,'0000-00-00','ET','2',2,1,'Tia Alexander','FI','283788574','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:08',0,'2014-03-10 14:45:25'),(20381,21031,'0000-00-00','ET','2',1,NULL,'JANICE A SINGLETON','FI','428375129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:10',0,'2014-03-02 07:10:28'),(14323,14774,'2014-01-01','ET','2',1,NULL,'Joanna Wilson','FI','462918071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:34',0,'2014-03-02 05:38:34'),(15299,15750,'0000-00-00','ET','2',2,1,'Jerry Phillips','FI','283664012','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:17',0,'2014-03-10 16:17:47'),(5603,5603,'2014-01-01','ET','2',1,NULL,'kathleen norris','FI','282503768','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:45',0,'2014-03-01 16:23:43'),(4962,4962,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:32:14',0,'2014-03-01 15:05:09'),(21769,22419,'0000-00-00','ET','2',1,NULL,'Bronson Mock','FI','279868049','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:37',0,'2014-03-10 14:45:25'),(956,956,'2014-01-01','ET','2',1,NULL,'Riley Charters','FI','533171076','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:50',0,'2014-03-01 22:10:55'),(15054,15505,'2014-01-01','ET','2',1,NULL,'Francie Horn','FI','233880373','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:33',0,'2014-03-10 16:17:47'),(14090,14541,'2014-01-01','ET','2',1,NULL,'Alexandra Schuur Sousa','FI','027744245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:29',0,'2014-03-02 05:38:34'),(3025,3025,'2014-01-01','ET','2',1,NULL,'carolyn scippio','FI','128484903','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:52',0,'2014-03-01 15:37:30'),(2309,2309,'2014-01-01','ET','2',2,1,'Sankung Daffeh','FI','010331954','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:33',0,'2014-03-01 15:05:09'),(4637,4637,'2014-01-01','ET','2',1,NULL,'AFSHAN ANJUM','FI','733267916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:29',0,'2014-03-02 04:31:46'),(5709,5709,'2014-01-01','ET','2',1,NULL,'Keith Donaldson','FI','518766974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:44',0,'2014-03-01 15:37:30'),(7533,7533,'2014-01-01','ET','2',1,NULL,'LAURA MAZAR','FI','217703646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:06',0,'2014-03-01 16:05:34'),(22952,23602,'0000-00-00','ET','2',1,NULL,'JACK ALLISON','FI','302580945','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:18',0,'2014-03-10 21:07:22'),(19533,20183,'0000-00-00','ET','2',2,1,'CAROLYN WASHINGTON','FI','427110973','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:13:51',0,'2014-03-02 06:59:07'),(17049,17699,'0000-00-00','ET','2',1,NULL,'terry waller','FI','449020214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:30',0,'2014-03-02 06:24:38'),(14610,15061,'2014-01-01','ET','2',1,NULL,'Martha  Newsome','FI','593882680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:56',0,'2014-03-01 16:46:19'),(15815,16464,'0000-00-00','ET','2',1,NULL,'Gayle D Kline','FI','454115884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:00:20',0,'2014-03-02 06:03:21'),(12179,12179,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:08:28',0,'2014-03-10 13:52:32'),(11049,11049,'2014-01-01','ET','2',1,NULL,'Rosilynn Oakes','FI','273645351','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:24',0,'2014-03-10 16:03:49'),(15390,15841,'0000-00-00','ET','2',1,NULL,'Latosha Winn','FI','433551001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:03',0,'2014-03-02 05:59:43'),(1472,1472,'2014-01-01','ET','2',5,4,'James Landfair','FI','525554364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:32',0,'2014-03-01 16:23:43'),(2652,2652,'2014-01-01','ET','2',1,NULL,'JOHN CONNOLLY','FI','299542670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:27',0,'2014-03-01 16:05:34'),(3161,3161,'2014-01-01','ET','2',1,NULL,'GREGORY JOSEPH GOODMAN','FI','279680232','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:38:10',0,'2014-03-10 13:24:34'),(3400,3400,'2014-01-01','ET','2',2,1,'Tereasa Griffith','FI','275763673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:41',0,'2014-03-10 13:24:34'),(4447,4447,'2014-01-01','ET','2',1,NULL,'Arkadiy Gips','FI','294969962','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:20',0,'2014-03-01 15:16:37'),(6255,6255,'2014-01-01','ET','2',1,NULL,'James Donald Geraghty','FI','135821257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:05',0,'2014-03-02 04:10:25'),(1726,1726,'2014-01-01','ET','2',1,NULL,'WILLIO LACOMME','FI','770038507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:17',0,'2014-03-01 15:31:33'),(299,299,'2014-01-01','ET','2',1,NULL,'Vickie Smith','FI','453619775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:12',0,'2014-03-01 22:10:55'),(21098,21748,'0000-00-00','ET','2',1,NULL,'Adrian Aguilar','FI','631202882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:30:46',0,'2014-03-02 07:23:39'),(11794,11794,'2014-01-01','ET','2',1,NULL,'janet miranda miranda','FI','832450003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:55',0,'2014-03-02 04:31:46'),(20719,21369,'0000-00-00','ET','2',2,1,'KAREN ASBURY','FI','272664546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:20',0,'2014-03-01 18:08:07'),(17339,17989,'0000-00-00','ET','2',1,NULL,'CHARLES WILSON','FI','562398205','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:16',0,'2014-03-10 14:24:38'),(1681,1681,'2014-01-01','ET','2',1,NULL,'KIMBERLY PERSON','FI','293782071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:53',0,'2014-03-01 15:31:33'),(3649,3649,'2014-01-01','ET','2',1,NULL,'Valarie Jean Nesbitt','FI','291741146','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:54',0,'2014-03-10 15:52:36'),(15895,16544,'0000-00-00','ET','2',1,NULL,'MELODY J JACKSON','FI','284668834','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:08',0,'2014-03-10 14:10:12'),(4458,4458,'2014-01-01','ET','2',1,NULL,'Ankita Shah','FI','851051928','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:41',0,'2014-03-01 15:16:37'),(7013,7013,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:00:55',0,'2014-03-02 03:09:49'),(20306,20956,'0000-00-00','ET','2',1,NULL,'Kimberly Willis','FI','453672909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:46',0,'2014-03-02 07:10:28'),(14043,14494,'2014-01-01','ET','2',1,NULL,'Katharine Vetter','FI','298807903','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:31:58',0,'2014-03-01 16:40:16'),(11232,11232,'2014-01-01','ET','2',2,1,'norman whitaker','FI','284624348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:26',0,'2014-03-01 16:23:43'),(1693,1693,'2014-01-01','ET','2',1,NULL,'Amanda Wyatt','FI','268882289','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:17',0,'2014-03-01 15:31:33'),(5719,5719,'2014-01-01','ET','2',1,NULL,'Bruce Davis','FI','276525355','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:01',0,'2014-03-01 15:37:30'),(22368,23018,'0000-00-00','ET','2',1,NULL,'Thothsakanh Thongsavanh','FI','586120581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:19',0,'2014-03-07 21:25:22'),(11905,11905,'2014-01-01','ET','2',1,NULL,'Shoko Yoshimura','FI','575356512','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:11',0,'2014-03-01 16:30:17'),(3415,3415,'2014-01-01','ET','2',1,NULL,'Georgia M Jackson','FI','587266952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:11',0,'2014-03-02 02:10:49'),(19149,19799,'0000-00-00','ET','2',3,2,'DAVID J DRENNEN','FI','273766229','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:22',0,'2014-03-10 16:31:33'),(2476,2476,'2014-01-01','ET','2',1,NULL,'Poleena McPheron','FI','286585088','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:44',0,'2014-03-10 13:10:24'),(10457,10457,'2014-01-01','ET','2',1,NULL,'MARY HEINZ','FI','293489386','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:32',0,'2014-03-01 16:10:36'),(13128,13484,'2014-01-01','ET','2',1,NULL,'JANE HARRIS','FI','463411760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:04:04',0,'2014-03-02 05:17:40'),(14093,14544,'2014-01-01','ET','2',2,1,'ARUNA GUNERATNE','FI','612250388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:31',0,'2014-03-02 05:38:34'),(14114,14565,'2014-01-01','ET','2',1,NULL,'Patricia Brazelton','FI','295689067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:44',0,'2014-03-01 16:46:19'),(15806,16455,'0000-00-00','ET','2',1,NULL,'Carmen M Colin','FI','452532347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:15',0,'2014-03-02 06:03:21'),(18672,19322,'0000-00-00','ET','2',1,NULL,'ARLANA  PARRILL','FI','522157730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:32',0,'2014-03-02 06:45:14'),(23085,23735,'0000-00-00','ET','2',1,NULL,'Trista Hardy','FI','292788330','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:56',0,'2014-03-10 21:17:52'),(22900,23550,'0000-00-00','ET','2',1,NULL,'KELLEY TURNER','FI','289682256','Dental Care Plus, Inc.','FI','311185262','OMAR  BETANCOURT','94','9163435','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:40',0,'2014-03-10 21:36:25'),(15065,15516,'2014-01-01','ET','2',1,NULL,'Ryan Sole','94','0001060936','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:38',0,'2014-03-10 16:17:47'),(21472,22122,'0000-00-00','ET','2',1,NULL,'David Saunders','FI','297540323','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:36',0,'2014-03-10 14:45:25'),(19683,20333,'0000-00-00','ET','2',1,NULL,'michael wilson','FI','243734736','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:51:37',0,'2014-03-10 14:37:47'),(2434,2434,'2014-01-01','ET','2',1,NULL,'SAAMIA S THURMAN','FI','425138399','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:18',0,'2014-03-01 23:10:52'),(19210,19860,'0000-00-00','ET','2',1,NULL,'Carolyn May Kendall','FI','291845808','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:07',0,'2014-03-10 16:31:33'),(1611,1611,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:30',0,'2014-03-01 20:10:57'),(16890,17540,'0000-00-00','ET','2',2,1,'Arthur W Wann','FI','452251744','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:20',0,'2014-03-02 06:24:38'),(18975,19625,'0000-00-00','ET','2',1,NULL,'Leanna DeGroff','FI','083447988','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:56',0,'2014-03-10 14:31:05'),(23049,23699,'0000-00-00','ET','2',1,NULL,'MAURINE CATHERINE KING','FI','426025106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:27',0,'2014-03-10 21:27:11'),(209,209,'2014-01-01','ET','2',1,NULL,'Lynn Howard','FI','433787917','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:35',0,'2014-03-01 22:10:55'),(16924,17574,'0000-00-00','ET','2',2,1,'KATHLEEN MCGEE','FI','278523842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:40',0,'2014-03-01 17:00:58'),(13668,14024,'2014-01-01','ET','2',2,1,'david chavez','FI','465870474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:21',0,'2014-03-02 05:24:45'),(13082,13438,'2014-01-01','ET','2',1,NULL,'Mary Roby','FI','549313960','Dental Care Plus, Inc.','FI','311185262','jon  Beveridge','94','7897779','348','2014-02-01','Sync Success',0,'2014-01-07 04:02:16',0,'2014-03-01 16:35:14'),(12248,12248,'2014-01-01','ET','2',2,1,'Lori Barrientos','FI','455834163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:20',0,'2014-03-02 05:10:52'),(16674,17324,'0000-00-00','ET','2',1,NULL,'Jessika Jamison','FI','269025932','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:57',0,'2014-03-01 17:00:58'),(15477,15928,'0000-00-00','ET','2',1,NULL,'Ericka Jordan','FI','270721456','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:58',0,'2014-03-10 14:10:12'),(1554,1554,'2014-01-01','ET','2',2,1,'Steven Pack','FI','370702068','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 18:59:06',0,'2014-03-10 13:52:32'),(10714,10714,'2014-01-01','ET','2',1,NULL,'DENNIS LEGAN','FI','271606356','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:02',0,'2014-03-01 16:10:36'),(11443,11443,'2014-01-01','ET','2',2,1,'MARIE D HUBBARD','FI','401137409','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:08:00',0,'2014-03-10 13:52:32'),(18857,19507,'0000-00-00','ET','2',1,NULL,'James Murphy','FI','276769361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:30',0,'2014-03-02 06:52:12'),(13663,14019,'2014-01-01','ET','2',1,NULL,'KIMBERLY S ARMOND','FI','467535318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:18',0,'2014-03-02 05:24:45'),(18770,19420,'0000-00-00','ET','2',1,NULL,'JEREMY R KOLB','FI','288802413','HealthSpan','FI','311431434','GEORGE  ALLEY','94','12067476','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:44',0,'2014-03-10 14:31:05'),(17216,17866,'0000-00-00','ET','2',1,NULL,'VANESSA SMITH','FI','278600753','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:14',0,'2014-03-01 17:20:55'),(15112,15563,'0000-00-00','ET','2',1,NULL,'BETHANY VILLARREAL','FI','463570396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:58',0,'2014-03-02 05:52:31'),(11242,11242,'2014-01-01','ET','2',1,NULL,'Bernita Turner','FI','292665027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:42',0,'2014-03-01 16:23:43'),(492,492,'2014-01-01','ET','2',2,1,'Adam Steed','FI','503786846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:14',0,'2014-03-01 15:48:04'),(22181,22831,'0000-00-00','ET','2',1,NULL,'TRAVIS STAPLETON','FI','271905844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:25',0,'2014-03-06 21:36:23'),(13937,14293,'2014-01-01','ET','2',1,NULL,'ROBERT HUNDLEY','FI','263533272','HealthSpan','FI','311431434','CHARLES  BENDER','94','17057188','357','2014-02-01','Sync Success',0,'2014-01-13 03:00:23',0,'2014-03-10 14:03:26'),(21892,22542,'0000-00-00','ET','2',2,1,'jorge fortuna','FI','644420125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:37',0,'2014-03-05 22:27:33'),(17287,17937,'0000-00-00','ET','2',1,NULL,'MURSEL  LEON CARTER','FI','428048426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:48',0,'2014-03-02 06:24:38'),(12050,12050,'2014-01-01','ET','2',1,NULL,'Jeremy L Graves','FI','462614948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:04:00',0,'2014-03-02 04:59:36'),(17114,17764,'0000-00-00','ET','2',1,NULL,'jon scarborough','FI','300545501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:08',0,'2014-03-01 17:20:55'),(10672,10672,'2014-01-01','ET','2',1,NULL,'Brice Williams','FI','294845180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:29',0,'2014-03-01 16:05:34'),(937,937,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:15',0,'2014-03-01 22:10:55'),(2710,2710,'2014-01-01','ET','2',1,NULL,'harvey wheaton','FI','548824873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:30',0,'2014-03-02 04:15:49'),(4903,4903,'2014-01-01','ET','2',1,NULL,'Christopher Collander','FI','458853551','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:13',0,'2014-03-01 19:11:03'),(311,311,'2014-01-01','ET','2',1,NULL,'Carol Ann Odum','FI','460884211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:32',0,'2014-03-01 22:10:55'),(11182,11182,'2014-01-01','ET','2',1,NULL,'HEATHER GEESLIN','FI','296808602','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:17:03',0,'2014-03-10 13:45:57'),(419,419,'2014-01-01','ET','2',1,NULL,'Diane Kinner','FI','287447683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:00',0,'2014-03-01 15:21:15'),(10902,10902,'2014-01-01','ET','2',1,NULL,'Jeremy Stevens','FI','224157096','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:42',0,'2014-03-02 04:24:47'),(7344,7344,'2014-01-01','ET','2',1,NULL,'Cathy Fletchinger','FI','438945684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:17',0,'2014-03-01 21:11:04'),(6131,6131,'2014-01-01','ET','2',1,NULL,'Christopher Alexander','FI','290909508','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:17',0,'2014-03-01 16:00:27'),(2585,2585,'2014-01-01','ET','2',2,1,'Cathy Williams Hargrave','FI','403883548','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:28',0,'2014-03-01 19:11:03'),(5263,5263,'2014-01-01','ET','2',1,NULL,'Keven James Sharpe','FI','288867509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:07',0,'2014-03-01 15:10:22'),(4843,4843,'2014-01-01','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:15:23',0,'2014-03-01 15:10:22'),(2739,2739,'2014-01-01','ET','2',2,1,'Curtis Cavalier','FI','437215143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:23',0,'2014-03-02 04:15:49'),(4187,4187,'2014-01-01','ET','2',1,NULL,'ANNE CASTON','FI','284729234','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:51',0,'2014-03-10 15:59:47'),(2961,2961,'2014-01-01','ET','2',1,NULL,'Joseph Schneider','FI','289866239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:56',0,'2014-03-01 15:37:30'),(12434,12434,'2014-01-01','ET','2',1,NULL,'CAROLE AUBERT','FI','434804537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:54',0,'2014-03-02 05:03:29'),(12919,12919,'2014-01-01','ET','2',1,NULL,'Linda F Clift','FI','296527380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:36',0,'2014-03-10 13:59:38'),(12995,12995,'2014-01-01','ET','2',2,1,'AMY  ARNETT','FI','293709217','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:55',0,'2014-03-01 16:35:14'),(13416,13772,'2014-01-01','ET','2',1,NULL,'Fredrick Ashbrook','FI','286584889','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:01',0,'2014-03-10 13:59:38'),(14788,15239,'2014-01-01','ET','2',1,NULL,'Charles Romine','FI','448662644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:50',0,'2014-03-02 05:45:37'),(15331,15782,'0000-00-00','ET','2',1,NULL,'Jessica Butler','FI','271728309','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:37',0,'2014-03-01 16:50:53'),(15391,15842,'0000-00-00','ET','2',1,NULL,'Joseph Augustin','FI','668188447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:04',0,'2014-03-02 05:59:43'),(15897,16546,'0000-00-00','ET','2',1,NULL,'Barbara Stacy','FI','274805257','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:10',0,'2014-03-10 14:10:12'),(15982,16631,'0000-00-00','ET','2',1,NULL,'stephen stewart','FI','271705466','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:26',0,'2014-03-10 14:20:26'),(21991,22641,'0000-00-00','ET','2',2,1,'JIM MILLER','FI','290546901','Summa Insurance Company, Inc.','FI','341809108','GWENDOLYN  HAVEN','94','11202931','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:46',0,'2014-03-10 16:44:18'),(18106,18756,'0000-00-00','ET','2',2,1,'rolando manto','FI','730094602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:43',0,'2014-03-02 06:38:05'),(18588,19238,'0000-00-00','ET','2',1,NULL,'Frederick Barkman','FI','299544893','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:25',0,'2014-03-01 17:26:36'),(19036,19686,'0000-00-00','ET','2',1,NULL,'Shannon Neal','FI','284769659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:09',0,'2014-03-10 14:31:05'),(19365,20015,'0000-00-00','ET','2',2,1,'Charece Harris','FI','279888742','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:43',0,'2014-03-01 17:34:07'),(20795,21445,'0000-00-00','ET','2',1,NULL,'CARON EDWARDS','FI','461477450','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:57',0,'2014-03-02 07:17:36'),(21131,21781,'0000-00-00','ET','2',1,NULL,'Michelle Brannon','FI','281464292','Summa Insurance Company, Inc.','FI','341809108','Melissa  Wartman','94','15704453','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:09',0,'2014-03-10 16:38:05'),(21321,21971,'0000-00-00','ET','2',1,NULL,'Cheryl Crosby','FI','281568481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:07',0,'2014-03-03 01:07:25'),(145,145,'2014-01-01','ET','2',2,1,'thomas sullivan','FI','219881425','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:31',0,'2014-03-10 15:45:56'),(529,529,'2014-01-01','ET','2',1,NULL,'STANLEY HILL','FI','300460375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:20',0,'2014-03-01 15:48:04'),(11123,11123,'2014-01-01','ET','2',4,3,'Judy Vogel','FI','275820374','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:53',0,'2014-03-10 13:45:57'),(1483,1483,'2014-01-01','ET','2',1,NULL,'Douglas Rehbaum','FI','274482053','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:52',0,'2014-03-10 13:52:32'),(2930,2930,'2014-01-01','ET','2',1,NULL,'Hazel Schneider','FI','409825180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:56',0,'2014-03-01 15:37:30'),(6109,6109,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:01:35',0,'2014-03-01 16:00:27'),(4418,4418,'2014-01-01','ET','2',5,4,'Donald kenneth Coakley','FI','290865975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:34',0,'2014-03-01 15:05:09'),(3471,3471,'2014-01-01','ET','2',1,NULL,'Carl  Colegrove','FI','282649727','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:15',0,'2014-03-01 15:31:33'),(15482,15933,'0000-00-00','ET','2',3,2,'Christen Livingston','FI','302742697','HealthSpan','FI','311431434','Michael  Webber','94','968310','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:02',0,'2014-03-10 14:10:12'),(16018,16667,'0000-00-00','ET','2',1,NULL,'ANA MARIA AMAYA','FI','454831617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:23',0,'2014-03-02 06:03:21'),(16245,16894,'0000-00-00','ET','2',1,NULL,'Brett Wcislo','FI','296841477','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:09',0,'2014-03-10 16:24:30'),(19842,20492,'0000-00-00','ET','2',1,NULL,'Neha Ali','94','0000491899','Starmount Life Insurance Company','FI','720977315','Munira H Dhodiya','94','7987627','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:58',0,'2014-03-02 07:03:25'),(21293,21943,'0000-00-00','ET','2',1,NULL,'Joe Torres','FI','631126717','Starmount Life Insurance Company','FI','720977315','Elizabeth Correa Rayas','94','9205046','348','2014-04-01','Sync Success',0,'2014-03-01 21:01:00',0,'2014-03-02 07:23:39'),(22478,23128,'0000-00-00','ET','2',2,1,'REGINA ANNE PINO','FI','301406771','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:55',0,'2014-03-07 21:36:32'),(22935,23585,'0000-00-00','ET','2',1,NULL,'LYNN FRAZEE','FI','272564271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:01:07',0,'2014-03-10 21:07:22'),(3386,3386,'2014-01-01','ET','2',1,NULL,'PATRICIA CONRAD','FI','130620185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:17',0,'2014-03-02 02:10:49'),(10965,10965,'2014-01-01','ET','2',1,NULL,'DEBORAH LYNN HANLIN','FI','290504348','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:35',0,'2014-03-10 16:03:49'),(11726,11726,'2014-01-01','ET','2',1,NULL,'Jared Rammel','FI','286885633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:08:43',0,'2014-03-01 16:30:17'),(3814,3814,'2014-01-01','ET','2',1,NULL,'Hardwick Gundy','FI','269603112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:48',0,'2014-03-01 15:26:40'),(11985,11985,'2014-01-01','ET','2',2,1,'Joe Jolley','FI','457271951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:32',0,'2014-03-02 05:03:29'),(13561,13917,'2014-01-01','ET','2',2,1,'matthew john russo','FI','437883284','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:55',0,'2014-03-02 05:31:31'),(14030,14386,'2014-01-01','ET','2',1,NULL,'DONALD M STONE','FI','280683701','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:53',0,'2014-03-10 14:03:26'),(15233,15684,'0000-00-00','ET','2',1,NULL,'erin keller','FI','434694458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:16',0,'2014-03-02 05:52:31'),(15371,15822,'0000-00-00','ET','2',2,1,'Cheryl Walpon','FI','367982062','Starmount Life Insurance Company','FI','720977315','Derek  Babcock','94','7658231','348','2014-03-01','Sync Success',1,'2014-01-22 03:21:51',0,'2014-03-02 05:52:31'),(16323,16973,'0000-00-00','ET','2',1,NULL,'CHARLOTTE SMITH','FI','282527820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:37',0,'2014-03-01 17:00:58'),(17233,17883,'0000-00-00','ET','2',1,NULL,'Stephone Jeffries','94','0000999881','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:22',0,'2014-03-10 16:24:30'),(18175,18825,'0000-00-00','ET','2',1,NULL,'CHRISTINE PALOMBO','FI','268441512','Dental Care Plus, Inc.','FI','311185262','KAMIKA PAMIAA YARBROUGH','94','17174211','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:34',0,'2014-03-01 17:26:36'),(18297,18947,'0000-00-00','ET','2',1,NULL,'PATRICIA ROLLER','FI','147448027','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:26',0,'2014-03-10 16:31:33'),(18548,19198,'0000-00-00','ET','2',1,NULL,'John Sand','FI','302487158','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:10',0,'2014-03-01 17:26:36'),(18710,19360,'0000-00-00','ET','2',1,NULL,'Danny Frazier','FI','276746059','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-27','Sync Success',0,'2014-02-13 22:02:00',0,'2014-03-10 14:31:05'),(15885,16534,'0000-00-00','ET','2',3,2,'WILLIE E THOMPSON','FI','427112784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:04',0,'2014-03-02 06:03:21'),(12805,12805,'2014-01-01','ET','2',1,NULL,'Timothy Hill','FI','433394768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:26',0,'2014-03-02 05:17:40'),(14945,15396,'2014-01-01','ET','2',2,1,'David Mirelez','FI','450158425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:45',0,'2014-03-02 05:45:37'),(21657,22307,'0000-00-00','ET','2',1,NULL,'Christine Rice','FI','298905674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:01:04',0,'2014-03-04 21:36:30'),(22113,22763,'0000-00-00','ET','2',1,NULL,'Torrevio Hicks','FI','260371953','Starmount Life Insurance Company','FI','720977315','Andrew  Sivatjian','94','8975519','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:39',0,'2014-03-06 21:27:26'),(12072,12072,'2014-01-01','ET','2',1,NULL,'justin courtney','FI','279821699','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:45',0,'2014-03-01 16:30:17'),(1906,1906,'2014-01-01','ET','2',1,NULL,'Adam Matula','FI','461750322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:57',0,'2014-03-01 23:10:52'),(14608,15059,'2014-01-01','ET','2',1,NULL,'Gary Glener','FI','295922121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:55',0,'2014-03-01 16:46:19'),(17972,18622,'0000-00-00','ET','2',1,NULL,'DIEGO FIGUEROA','FI','758290770','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:19',0,'2014-03-02 06:31:45'),(7131,7131,'2014-01-01','ET','2',1,NULL,'Lindsay Lee','FI','284849523','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:31',0,'2014-03-01 15:52:44'),(15608,16059,'0000-00-00','ET','2',1,NULL,'GLORESTINE KENNER','FI','433081697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:40',0,'2014-03-02 05:59:43'),(16006,16655,'0000-00-00','ET','2',1,NULL,'DION ALLEN','FI','459479183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:00:14',0,'2014-03-02 06:03:21'),(388,388,'2014-01-01','ET','2',2,1,'Kiwana Reliford','FI','433453048','Starmount Life Insurance Company','FI','720977315','Clint  Martin','94','15792135','348','2014-01-01','Sync Success',0,'2013-12-25 17:47:58',0,'2014-03-01 22:10:55'),(14587,15038,'2014-01-01','ET','2',1,NULL,'Guillermo  Fuentes','FI','628167445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:42',0,'2014-03-02 05:45:37'),(883,883,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:39',0,'2014-03-01 15:21:15'),(974,974,'2014-01-01','ET','2',1,NULL,'Sidi Samba Elabd','FI','578310622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:24',0,'2014-03-01 15:21:15'),(4715,4715,'2014-01-01','ET','2',1,NULL,'Eddie Lewis','FI','587805736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:10',0,'2014-03-02 04:38:08'),(14493,14944,'2014-01-01','ET','2',1,NULL,'Donald George','FI','438252045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:49',0,'2014-03-02 05:38:34'),(3906,3906,'2014-01-01','ET','2',2,1,'Donald Whitman','FI','288500706','Summa Insurance Company, Inc.','FI','341809108','Thomas W Delligatti','94','2209240','348','2014-01-01','Sync Success',0,'2013-12-25 22:45:12',0,'2014-03-10 15:45:56'),(12671,12671,'2014-01-01','ET','2',1,NULL,'Cherylene Ravenscraft','FI','289488293','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:43',0,'2014-03-01 16:35:14'),(3152,3152,'2014-01-01','ET','2',1,NULL,'Michelle Simpkins','FI','268842451','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:50',0,'2014-03-10 13:24:34'),(3044,3044,'2014-01-01','ET','2',1,NULL,'Zachary Caserta','FI','292908152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:26',0,'2014-03-01 15:37:30'),(12090,12090,'2014-01-01','ET','2',1,NULL,'Crystal McGuire','FI','402338190','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','357','2014-02-01','Sync Success',0,'2014-01-01 12:05:23',0,'2014-03-01 16:30:17'),(20708,21358,'0000-00-00','ET','2',4,3,'Van Vo','FI','288968376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:15',0,'2014-03-01 18:08:07'),(21982,22632,'0000-00-00','ET','2',1,NULL,'MARY LEE LOVE','FI','426195337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:31:41',0,'2014-03-05 22:27:33'),(22882,23532,'0000-00-00','ET','2',1,NULL,'JACK ALLISON','FI','302580945','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:25',0,'2014-03-10 21:36:25'),(18542,19192,'0000-00-00','ET','2',1,NULL,'ADEEL MEMON','FI','645948623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:08',0,'2014-03-02 06:45:14'),(16189,16838,'0000-00-00','ET','2',1,NULL,'Jim Napier','FI','286702426','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:31',0,'2014-03-01 16:56:22'),(7596,7596,'2014-01-01','ET','2',1,NULL,'DARLENE DOLAN','FI','299443197','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:10',0,'2014-03-10 15:59:47'),(11652,11652,'2014-01-01','ET','2',1,NULL,'jacquelyn hammonds','FI','278623434','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:20',0,'2014-03-01 16:30:17'),(11991,11991,'2014-01-01','ET','2',1,NULL,'Debra Ninci','FI','449378996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:44',0,'2014-03-02 05:03:29'),(13647,14003,'2014-01-01','ET','2',1,NULL,'Stephen Fout','FI','283863666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:00',0,'2014-03-10 14:03:26'),(13940,14296,'2014-01-01','ET','2',1,NULL,'Nancy Rodgers','FI','290505537','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:26',0,'2014-03-10 14:03:26'),(20772,21422,'0000-00-00','ET','2',1,NULL,'SHANNON FRIEBEL','FI','293907534','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:45',0,'2014-03-01 18:10:11'),(21267,21917,'0000-00-00','ET','2',2,1,'Abdessadaq Raouidah','FI','090748064','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:40',0,'2014-03-01 21:35:40'),(521,521,'2014-01-01','ET','2',1,NULL,'Peggy Wainscott','FI','296526826','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:04',0,'2014-03-01 15:48:04'),(18719,19369,'0000-00-00','ET','2',2,1,'RANDY ROGERS','FI','458578226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:07',0,'2014-03-02 06:45:14'),(1567,1567,'2014-01-01','ET','2',2,1,'peter porter','FI','301888189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:10',0,'2014-03-01 15:10:22'),(16325,16975,'0000-00-00','ET','2',1,NULL,'VANESSA JONES','FI','290705633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:38',0,'2014-03-01 17:00:58'),(16089,16738,'0000-00-00','ET','2',1,NULL,'CHINESA WISE','FI','298583196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:09',0,'2014-03-01 16:56:22'),(15063,15514,'2014-01-01','ET','2',1,NULL,'Shayna Nay','FI','299888338','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:37',0,'2014-03-10 14:10:12'),(14337,14788,'2014-01-01','ET','2',1,NULL,'vanessa polanco','FI','466410105','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:40',0,'2014-03-02 05:38:34'),(2430,2430,'2014-01-01','ET','2',1,NULL,'Patricia Smith','FI','284504797','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:10',0,'2014-03-10 15:45:56'),(14331,14782,'2014-01-01','ET','2',1,NULL,'priscilla chavarria','FI','449731977','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:37',0,'2014-03-02 05:38:34'),(13614,13970,'2014-01-01','ET','2',2,1,'DIANE OCONNOR','FI','283609815','Dental Care Plus, Inc.','FI','311185262','DARWIN  CARMICHAEL','94','130095','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:35',0,'2014-03-01 16:40:16'),(3064,3064,'2014-01-01','ET','2',1,NULL,'Julie Rudd','FI','092729969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:04',0,'2014-03-01 15:37:30'),(10900,10900,'2014-01-01','ET','2',1,NULL,'Mark Folse','FI','434064028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:38',0,'2014-03-02 04:24:47'),(12297,12297,'2014-01-01','ET','2',1,NULL,'Dale Delancey','FI','427138649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:11',0,'2014-03-02 05:10:52'),(20902,21552,'0000-00-00','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:45',0,'2014-03-10 14:45:25'),(20950,21600,'0000-00-00','ET','2',1,NULL,'Demetra Robertson','FI','456539284','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','357','2014-03-31','Sync Success',0,'2014-02-28 07:30:04',0,'2014-03-02 07:17:36'),(21976,22626,'0000-00-00','ET','2',1,NULL,'DEXTER SPAN','FI','587511601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:37',0,'2014-03-05 22:27:33'),(259,259,'2014-01-01','ET','2',1,NULL,'Vernon L Sargent','FI','227869843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:11',0,'2014-03-10 15:39:19'),(19510,20160,'0000-00-00','ET','2',1,NULL,'Cerra Wingo','FI','283845987','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:06:34',0,'2014-03-01 17:34:07'),(3402,3402,'2014-01-01','ET','2',1,NULL,'ALYSHA D GROSS','FI','296760147','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:45',0,'2014-03-10 13:24:34'),(18079,18729,'0000-00-00','ET','2',1,NULL,'LIDIA  IBARRA GOMEZ','FI','458951043','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:22',0,'2014-03-02 06:38:05'),(7616,7616,'2014-01-01','ET','2',1,NULL,'Ethan  Stewart','FI','269084507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:47',0,'2014-03-10 13:39:10'),(11119,11119,'2014-01-01','ET','2',1,NULL,'RONALD SAGE','FI','273522699','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:46',0,'2014-03-10 13:45:57'),(11544,11544,'2014-01-01','ET','2',2,1,'amado gomez rodriguez','FI','466399023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:57',0,'2014-03-02 04:52:44'),(14065,14516,'2014-01-01','ET','2',1,NULL,'LACHATA ROBINSON','FI','427353114','Starmount Life Insurance Company','FI','720977315','DEMERICK  HARRIS','94','9416887','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:13',0,'2014-03-02 05:38:34'),(21943,22593,'0000-00-00','ET','2',1,NULL,'Debra Garrene','FI','437252491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:14',0,'2014-03-05 22:27:33'),(184,184,'2014-01-01','ET','2',1,NULL,'Damon Presley','FI','434770756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:42',0,'2014-03-01 22:10:55'),(18852,19502,'0000-00-00','ET','2',1,NULL,'Richelle Romero','FI','439922614','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:27',0,'2014-03-02 06:52:12'),(4273,4273,'2014-01-01','ET','2',1,NULL,'Ashley Nash','FI','467733887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:30',0,'2014-03-02 03:09:49'),(18757,19407,'0000-00-00','ET','2',1,NULL,'MARTHA ELIZABETH HERNANDEZ','FI','665033951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:34',0,'2014-03-02 06:45:14'),(2575,2575,'2014-01-01','ET','2',1,NULL,'Aaron Lawson','FI','291867354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:09',0,'2014-03-01 15:05:09'),(14677,15128,'2014-01-01','ET','2',2,1,'LORETTA G KNOTTS','FI','282564836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:38',0,'2014-03-01 16:46:19'),(22390,23040,'0000-00-00','ET','2',1,NULL,'Paul Morris','FI','282806696','HealthSpan','FI','311431434','Thomas  Simyak','94','13275609','357','2014-03-31','Sync Success',0,'2014-03-07 21:00:31',0,'2014-03-10 14:50:59'),(22400,23050,'0000-00-00','ET','2',1,NULL,'Heather Renee Seay','FI','467991771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:35',0,'2014-03-07 21:25:22'),(455,455,'2014-01-01','ET','2',1,NULL,'Justin Crowder','FI','254615790','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:08',0,'2014-03-01 22:10:55'),(17772,18422,'0000-00-00','ET','2',1,NULL,'Vincent Andre Mele','FI','153787891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:11',0,'2014-03-02 05:52:31'),(16752,17402,'0000-00-00','ET','2',2,1,'GLORIA PEDROZA','FI','451479559','Starmount Life Insurance Company','FI','720977315','Michael Dean Balmer','94','1189846','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:10',0,'2014-03-02 06:17:30'),(2444,2444,'2014-01-01','ET','2',3,2,'Colleen Cook','FI','301828510','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:37',0,'2014-03-10 15:45:56'),(3967,3967,'2014-01-01','ET','2',1,NULL,'Deborah Haren','FI','276660614','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:09',0,'2014-03-01 15:26:40'),(7088,7088,'2014-01-01','ET','2',1,NULL,'MERLE FUSS','FI','272602286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:16',0,'2014-03-01 15:52:44'),(12370,12370,'2014-01-01','ET','2',1,NULL,'Joseph French','FI','639447119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:34',0,'2014-03-02 05:03:29'),(1716,1716,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-25 19:17:00',0,'2014-03-01 15:31:33'),(2644,2644,'2014-01-01','ET','2',1,NULL,'Barbara Sue Hannan','FI','275587202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:13',0,'2014-03-01 16:05:34'),(19147,19797,'0000-00-00','ET','2',1,NULL,'Amber Marquardt','FI','292803985','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:20',0,'2014-03-10 16:31:33'),(12143,12143,'2014-01-01','ET','2',1,NULL,'Lorna  Shird','FI','587944532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:14',0,'2014-03-02 04:59:36'),(4780,4780,'2014-01-01','ET','2',1,NULL,'Lee Nesbitt','FI','434196051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:16',0,'2014-03-01 21:11:04'),(7186,7186,'2014-01-01','ET','2',1,NULL,'Brenda  Marie Pangelinan','FI','586745447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:13',0,'2014-03-02 03:09:49'),(10907,10907,'2014-01-01','ET','2',2,1,'ANGELIA TAYLOR','FI','410965110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:51',0,'2014-03-02 04:31:46'),(335,335,'2014-01-01','ET','2',1,NULL,'Pamela Piper','FI','281543683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:18',0,'2014-03-01 15:21:15'),(18505,19155,'0000-00-00','ET','2',2,1,'Angela K Duggins','FI','288807142','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:14',0,'2014-03-10 14:31:05'),(1248,1248,'2014-01-01','ET','2',1,NULL,'Michael Osborne','FI','289887040','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:08',0,'2014-03-01 16:15:39'),(18004,18654,'0000-00-00','ET','2',1,NULL,'Lisa Huynh','FI','437979240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:42',0,'2014-03-02 06:38:05'),(16483,17133,'0000-00-00','ET','2',1,NULL,'DAVID GUTIERREZ','FI','342728937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:27',0,'2014-03-02 06:10:30'),(15202,15653,'0000-00-00','ET','2',1,NULL,'Maijic Jackson','FI','522398272','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:26',0,'2014-03-01 16:50:53'),(15139,15590,'0000-00-00','ET','2',3,2,'Arnold F Leary','FI','437868233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:19',0,'2014-03-02 05:52:31'),(4680,4680,'2014-01-01','ET','2',1,NULL,'SHARON HOLLIFIELD','FI','300545148','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:57',0,'2014-03-10 13:45:57'),(7213,7213,'2014-01-01','ET','2',1,NULL,'Eric Johnson','FI','408947414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:01',0,'2014-03-01 15:52:44'),(7655,7655,'2014-01-01','ET','2',2,1,'Michael Box','FI','268526480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:01',0,'2014-03-10 13:39:10'),(12585,12585,'2014-01-01','ET','2',1,NULL,'MADISON HICKS','FI','270946896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:34',0,'2014-03-01 16:35:14'),(13287,13643,'2014-01-01','ET','2',1,NULL,'Randall Bishop','FI','271446607','Dental Care Plus, Inc.','FI','311185262','Paul j Moser','94','1738897','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:07',0,'2014-03-01 16:40:16'),(14804,15255,'2014-01-01','ET','2',1,NULL,'Melissa dehart','FI','269901971','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:00',0,'2014-03-10 14:10:12'),(21541,22191,'0000-00-00','ET','2',1,NULL,'Carole A Fletcher','FI','292502290','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:25',0,'2014-03-10 14:45:25'),(21817,22467,'0000-00-00','ET','2',1,NULL,'Adrian Pasaret','FI','626200022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:00:15',0,'2014-03-05 21:25:24'),(22124,22774,'0000-00-00','ET','2',1,NULL,'lakeisha allen','FI','435738004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:00:47',0,'2014-03-06 21:27:26'),(22688,23338,'0000-00-00','ET','2',2,1,'Sarah Huxen','FI','439759357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:48',0,'2014-03-08 22:26:18'),(22796,23446,'0000-00-00','ET','2',2,1,'James Robinson','FI','288583556','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-09 21:00:47',0,'2014-03-09 21:35:27'),(17990,18640,'0000-00-00','ET','2',1,NULL,'Eric Burnham','FI','427533900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:32',0,'2014-03-02 06:31:45'),(5197,5197,'2014-01-01','ET','2',1,NULL,'Gary Blake','FI','462787546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:17',0,'2014-03-02 00:10:48'),(15526,15977,'0000-00-00','ET','2',1,NULL,'ARUNA GUNERATNE','FI','612250388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 03:02:02',0,'2014-03-02 05:59:43'),(10490,10490,'2014-01-01','ET','2',1,NULL,'LEEANN CLARK','FI','273604228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:34',0,'2014-03-01 16:10:36'),(14060,14511,'2014-01-01','ET','2',1,NULL,'Genise Ellis','FI','376682808','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:09',0,'2014-03-01 16:46:19'),(23016,23666,'0000-00-00','ET','2',1,NULL,'TAMATHA THURMAN','FI','425217256','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:02',0,'2014-03-10 21:27:11'),(89,89,'2014-01-01','ET','2',1,NULL,'Randy L Teltschik','FI','454270080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:42',0,'2014-03-01 22:10:55'),(7239,7239,'2014-01-01','ET','2',1,NULL,'susan perrin','FI','438902402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:55',0,'2014-03-02 02:10:49'),(19137,19787,'0000-00-00','ET','2',1,NULL,'Jaqueta Alexander','FI','269927912','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:11',0,'2014-03-01 17:34:07'),(3818,3818,'2014-01-01','ET','2',2,1,'theo paparodis','FI','268507901','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:58',0,'2014-03-10 13:10:24'),(15485,15936,'0000-00-00','ET','2',1,NULL,'HEATHER Justice','FI','274769645','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:04',0,'2014-03-10 14:10:12'),(14350,14801,'2014-01-01','ET','2',1,NULL,'lupe arias','FI','549133612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:45',0,'2014-03-02 05:45:37'),(3398,3398,'2014-01-01','ET','2',2,1,'Tereasa Griffith','FI','275763673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:37',0,'2014-03-10 13:24:34'),(2213,2213,'2014-01-01','ET','2',1,NULL,'Tyler William Hawks','FI','399047828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:35',0,'2014-03-01 21:11:04'),(15774,16423,'0000-00-00','ET','2',1,NULL,'Justin Beasley','FI','237618806','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:01:38',0,'2014-03-10 14:10:12'),(15153,15604,'0000-00-00','ET','2',2,1,'Dean Miller','FI','301805725','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:28',0,'2014-03-10 14:10:12'),(14786,15237,'2014-01-01','ET','2',1,NULL,'Sandra Driskell','FI','427457051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:49',0,'2014-03-02 05:45:37'),(1894,1894,'2014-01-01','ET','2',1,NULL,'Alfonso Herrera','FI','450822518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:35',0,'2014-03-01 23:10:52'),(5884,5884,'2014-01-01','ET','2',1,NULL,'Tracey Lynn','FI','268702005','Summa Insurance Company, Inc.','FI','341809108','Jim  LaFleur','94','1643669','348','2014-01-01','Sync Success',0,'2013-12-26 02:30:14',0,'2014-03-10 15:52:36'),(2354,2354,'2014-01-01','ET','2',2,1,'John Kinloch','FI','300508942','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:46',0,'2014-03-01 15:26:40'),(2460,2460,'2014-01-01','ET','2',1,NULL,'GLORIA CEJA','FI','437982329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:12',0,'2014-03-01 23:10:52'),(2589,2589,'2014-01-01','ET','2',1,NULL,'Thomas Hawn','FI','364609402','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:37',0,'2014-03-10 15:39:19'),(21530,22180,'0000-00-00','ET','2',1,NULL,'Pheakdey Vong','FI','627272904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:16',0,'2014-03-03 22:26:43'),(17831,18481,'0000-00-00','ET','2',1,NULL,'SANDRA Z GONZALEZ','FI','454067400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:00',0,'2014-03-02 05:59:43'),(387,387,'2014-01-01','ET','2',1,NULL,'SUSAN PERCY','FI','583861231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:57',0,'2014-03-01 22:10:55'),(5563,5563,'2014-01-01','ET','2',1,NULL,'Sarah Gonzalez','FI','631365546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:27',0,'2014-03-02 04:45:37'),(596,596,'2014-01-01','ET','2',1,NULL,'Chance Shofner','FI','463697196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:27',0,'2014-03-02 02:10:49'),(4404,4404,'2014-01-01','ET','2',1,NULL,'Matt Wakelin','FI','292503558','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:04',0,'2014-03-10 13:03:33'),(6048,6048,'2014-01-01','ET','2',1,0,'Karla Moore','FI','296566731','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:30',0,'2014-03-10 13:03:33'),(6321,6321,'2014-01-01','ET','2',3,2,'Brandon Brown','FI','278969963','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:01',0,'2014-03-10 15:59:47'),(18903,19553,'0000-00-00','ET','2',1,NULL,'DELLA E RANKINS','FI','302444962','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:03',0,'2014-03-01 17:34:07'),(20515,21165,'0000-00-00','ET','2',1,NULL,'Florience Favorite','FI','435987657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:53',0,'2014-03-02 07:17:36'),(20892,21542,'0000-00-00','ET','2',1,NULL,'GLORIA JEAN LARRY','FI','281586857','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-28 06:31:41',0,'2014-03-10 16:38:05'),(21627,22277,'0000-00-00','ET','2',2,1,'ROBERTO BADILLO','FI','460410771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:41',0,'2014-03-04 21:27:16'),(21702,22352,'0000-00-00','ET','2',1,NULL,'Alorna Peyton','FI','434594033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:40',0,'2014-03-04 21:27:16'),(12345,12345,'2014-01-01','ET','2',1,NULL,'LINDA FAY HARRISON','FI','465083190','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:43',0,'2014-03-02 05:03:29'),(70,70,'2014-01-01','ET','2',1,NULL,'Nancy Ann Helinski','FI','268547623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:08',0,'2014-03-01 15:26:40'),(13298,13654,'2014-01-01','ET','2',1,NULL,'David Meek','FI','232215634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:12',0,'2014-03-01 16:40:16'),(18996,19646,'0000-00-00','ET','2',1,NULL,'Kathrine Simmons','94','0001066019','Summa Insurance Company, Inc.','FI','341809108','Michael  Lemon','94','11578839','357','2014-03-01','Sync Success',0,'2014-02-14 21:32:11',0,'2014-03-10 16:31:33'),(14607,15058,'2014-01-01','ET','2',1,NULL,'Gary Glener','FI','295922121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:54',0,'2014-03-01 16:46:19'),(7114,7114,'2014-01-01','ET','2',1,NULL,'Robert  M Hanahan','FI','279544039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:00',0,'2014-03-01 15:52:44'),(7174,7174,'2014-01-01','ET','2',1,NULL,'Christine M Smithnosky','FI','200407654','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:50',0,'2014-03-10 15:59:47'),(3740,3740,'2014-01-01','ET','2',3,2,'Barry Cooper','FI','298564971','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:52',0,'2014-03-10 13:20:27'),(3291,3291,'2014-01-01','ET','2',1,NULL,'Bonnie Thomas','FI','275749107','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:11',0,'2014-03-01 15:48:04'),(3167,3167,'2014-01-01','ET','2',1,NULL,'CYNTHIA LOUISE BENSON','FI','301460281','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:19',0,'2014-03-10 15:52:36'),(3068,3068,'2014-01-01','ET','2',1,NULL,'Torey Jay Horner','FI','273661184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:14',0,'2014-03-01 15:37:30'),(2594,2594,'2014-01-01','ET','2',1,NULL,'jack Hall','FI','302824161','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:48',0,'2014-03-10 13:03:33'),(19161,19811,'0000-00-00','ET','2',1,NULL,'SCOTT FAUST','FI','524354792','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:32',0,'2014-03-02 06:52:12'),(19877,20527,'0000-00-00','ET','2',1,NULL,'Rhonda Lackey','FI','283524319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:25',0,'2014-03-01 17:47:19'),(20035,20685,'0000-00-00','ET','2',2,1,'Victor Botton','FI','283665488','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:16',0,'2014-03-10 14:37:47'),(17281,17931,'0000-00-00','ET','2',1,NULL,'Kathleen Sullivan  Bell','FI','451907173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-20','Sync Success',0,'2014-02-05 21:30:45',0,'2014-03-02 06:24:38'),(403,403,'2014-01-01','ET','2',2,1,'Valerie Oakley','FI','094609136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:27',0,'2014-03-01 22:10:55'),(445,445,'2014-01-01','ET','2',1,NULL,'teron taylor','FI','302887612','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:49',0,'2014-03-10 15:45:56'),(16238,16887,'0000-00-00','ET','2',1,NULL,'Mark Garapic','FI','300647757','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:04',0,'2014-03-10 16:24:30'),(14112,14563,'2014-01-01','ET','2',1,NULL,'DIANA ADKINS','FI','286687906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:43',0,'2014-03-01 16:46:19'),(13847,14203,'2014-01-01','ET','2',1,NULL,'Summer Steinberger','FI','628149313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:46',0,'2014-03-02 05:31:31'),(3833,3833,'2014-01-01','ET','2',1,NULL,'Molly Sotherden','FI','120625841','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:04',0,'2014-03-10 15:39:19'),(575,575,'2014-01-01','ET','2',1,NULL,'Jason Lee Jones','FI','284744340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:49',0,'2014-03-01 15:48:04'),(16023,16672,'0000-00-00','ET','2',1,NULL,'VICKIE ROGERS','FI','433963172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:26',0,'2014-03-02 06:03:21'),(1545,1545,'2014-01-01','ET','2',1,NULL,'James Morse','FI','371964342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:47',0,'2014-03-10 13:45:57'),(13587,13943,'2014-01-01','ET','2',2,1,'Kembral Barrera','FI','587555948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:15',0,'2014-03-02 05:31:31'),(1911,1911,'2014-01-01','ET','2',1,NULL,'Lillie Coleman','FI','466943339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:05',0,'2014-03-01 23:10:52'),(2948,2948,'2014-01-01','ET','2',1,NULL,'milorad stojsavljevic','FI','295502702','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:30',0,'2014-03-01 15:37:30'),(11057,11057,'2014-01-01','ET','2',1,NULL,'Lucas McClain','FI','271861748','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:42',0,'2014-03-10 13:45:57'),(11747,11747,'2014-01-01','ET','2',1,NULL,'halla H Imam','FI','287964717','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:21',0,'2014-03-01 16:30:17'),(12826,12826,'2014-01-01','ET','2',2,1,'CONNIE A Williams','FI','438291192','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:12',0,'2014-03-02 05:10:52'),(11876,11876,'2014-01-01','ET','2',1,NULL,'michelle slater','FI','450971643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:14',0,'2014-03-02 04:59:36'),(1937,1937,'2014-01-01','ET','2',1,NULL,'Gary Churchill','FI','298466825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:51',0,'2014-03-01 15:26:40'),(17474,18124,'0000-00-00','ET','2',1,NULL,'Lillian Keber','FI','242415286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:33',0,'2014-03-02 06:31:45'),(16894,17544,'0000-00-00','ET','2',1,NULL,'HEIDI NGUYEN','FI','586383419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:23',0,'2014-03-02 06:24:38'),(13632,13988,'2014-01-01','ET','2',1,NULL,'Bradley Mundell','FI','433639529','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:49',0,'2014-03-02 05:31:31'),(16029,16678,'0000-00-00','ET','2',1,NULL,'DONNA M LACIURA','FI','434908750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:29',0,'2014-03-02 06:03:21'),(14956,15407,'2014-01-01','ET','2',4,3,'Jennifer Siebert','FI','277829901','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:50',0,'2014-03-10 14:10:12'),(5919,5919,'2014-01-01','ET','2',1,NULL,'Marjean Karr','FI','268504253','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:23',0,'2014-03-01 15:48:04'),(4322,4322,'2014-01-01','ET','2',2,1,'No Park','FI','434917211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:54',0,'2014-03-02 03:09:49'),(5662,5662,'2014-01-01','ET','2',1,NULL,'NEYSHA SANDERS','FI','428515989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:44',0,'2014-03-02 04:45:37'),(91,91,'2014-01-01','ET','2',2,1,'Marianne Lawson','FI','731124314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:45',0,'2014-03-01 23:10:52'),(14472,14923,'2014-01-01','ET','2',1,NULL,'COLLEEN WILBUR','FI','299464347','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:40',0,'2014-03-10 16:17:47'),(11074,11074,'2014-01-01','ET','2',2,1,'PENNY SEES','FI','294726041','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:14',0,'2014-03-10 16:03:49'),(552,552,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:05',0,'2014-03-01 15:48:04'),(3676,3676,'2014-01-01','ET','2',1,NULL,'CHARLES SAWYER','FI','427112244','Starmount Life Insurance Company','FI','720977315','VIRGINIA  BAILEY','94','8613861','357','2014-01-01','Sync Success',0,'2013-12-25 22:06:44',0,'2014-03-02 00:10:48'),(1850,1850,'2014-01-01','ET','2',1,NULL,'Ruth Lingafelter','FI','287588571','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:11',0,'2014-03-01 15:26:40'),(1197,1197,'2014-01-01','ET','2',1,NULL,'MICK CROCE','FI','016568215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:41',0,'2014-03-02 04:45:37'),(3247,3247,'2014-01-01','ET','2',1,NULL,'Linda Vuotto','FI','283509452','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:46',0,'2014-03-01 15:52:44'),(1600,1600,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:13',0,'2014-03-01 20:10:57'),(15555,16006,'0000-00-00','ET','2',1,NULL,'tina jodrey','FI','281808150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:16',0,'2014-03-01 16:50:53'),(4872,4872,'2014-01-01','ET','2',1,NULL,'Grant Goeters','FI','388762714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:20',0,'2014-03-01 15:10:22'),(14101,14552,'2014-01-01','ET','2',1,NULL,'HORACE ROBERSON','FI','302443031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:36',0,'2014-03-01 16:40:16'),(13742,14098,'2014-01-01','ET','2',2,1,'Raymond Weisel','FI','269843030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:09',0,'2014-03-01 16:40:16'),(13355,13711,'2014-01-01','ET','2',1,NULL,'richard baker','FI','467270364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:34',0,'2014-03-02 05:24:45'),(5712,5712,'2014-01-01','ET','2',1,NULL,'SONYA JONES','FI','294649123','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:50',0,'2014-03-01 15:37:30'),(12753,12753,'2014-01-01','ET','2',1,NULL,'Justin Campbell','FI','587617422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:47',0,'2014-03-02 05:10:52'),(11935,11935,'2014-01-01','ET','2',1,NULL,'diane ROTHHAAS','FI','272704962','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:09',0,'2014-03-10 16:10:34'),(19191,19841,'0000-00-00','ET','2',1,NULL,'Diane Mullins','FI','273661272','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:58',0,'2014-03-10 16:31:33'),(20019,20669,'0000-00-00','ET','2',1,NULL,'David Wilke','FI','271544624','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:05',0,'2014-03-10 16:38:05'),(1595,1595,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:06',0,'2014-03-01 20:10:57'),(13267,13623,'2014-01-01','ET','2',2,1,'Savanna Meekins','FI','177721028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:59',0,'2014-03-02 05:24:45'),(5043,5043,'2014-01-01','ET','2',1,NULL,'hemantha balasooriya','FI','279903408','Dental Care Plus, Inc.','FI','311185262','EUGENE  EUSANIO','94','776531','348','2014-01-01','Sync Success',0,'2013-12-26 00:47:21',0,'2014-03-01 15:31:33'),(4553,4553,'2014-01-01','ET','2',1,NULL,'MICHAEL ANDREW BATTERMAN','FI','074548904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:48',0,'2014-03-02 04:31:46'),(11678,11678,'2014-01-01','ET','2',2,1,'Ronnie Anderson','FI','271528170','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:37:12',0,'2014-03-10 13:52:32'),(5965,5965,'2014-01-01','ET','2',1,NULL,'kristi moniniger','FI','459490952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:49',0,'2014-03-02 02:10:49'),(11459,11459,'2014-01-01','ET','2',1,NULL,'Tina Eichman','FI','586544173','Dental Care Plus, Inc.','FI','311185262','Phil  Parks','94','8575634','348','2014-02-01','Sync Success',0,'2013-12-28 03:30:27',0,'2014-03-01 16:30:17'),(20974,21624,'0000-00-00','ET','2',2,1,'Mark Schmidt','FI','079487229','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:21',0,'2014-03-01 18:08:07'),(21051,21701,'0000-00-00','ET','2',1,NULL,'Mark Thomas','FI','291662598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:13',0,'2014-03-01 18:10:11'),(225,225,'2014-01-01','ET','2',1,0,'Brandon Allen','FI','272920366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:04',0,'2014-03-01 15:05:09'),(12700,12700,'2014-01-01','ET','2',1,NULL,'Kim Starks','FI','234886310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:46',0,'2014-03-02 05:10:52'),(11999,11999,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:01',0,'2014-03-10 16:10:34'),(6141,6141,'2014-01-01','ET','2',1,NULL,'Sylvia Paynter','FI','235844328','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:33',0,'2014-03-01 16:00:27'),(990,990,'2014-01-01','ET','2',2,1,'ben capretta','FI','286502727','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:54',0,'2014-03-01 15:21:15'),(19478,20128,'0000-00-00','ET','2',1,NULL,'DIANA LARA','FI','459694030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:56:45',0,'2014-03-02 06:59:07'),(20984,21634,'0000-00-00','ET','2',1,NULL,'Debra Rice','FI','371720888','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','348','2014-03-01','Sync Success',0,'2014-02-28 07:30:28',0,'2014-03-10 14:37:47'),(21250,21900,'0000-00-00','ET','2',1,NULL,'Kimberly A Whittridge','94','0000634800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-03-01 21:00:31',0,'2014-03-01 21:35:40'),(2156,2156,'2014-01-01','ET','2',1,NULL,'Curtis  Perkins','FI','296487431','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:39',0,'2014-03-01 15:16:37'),(3496,3496,'2014-01-01','ET','2',1,NULL,'Dawn Vest','FI','314664057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:03',0,'2014-03-01 15:37:30'),(5094,5094,'2014-01-01','ET','2',1,NULL,'Victor Pineda','FI','437951981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:00',0,'2014-03-02 00:10:48'),(4717,4717,'2014-01-01','ET','2',1,NULL,'James Ichrist','FI','293842886','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:14',0,'2014-03-10 13:45:57'),(18368,19018,'0000-00-00','ET','2',1,NULL,'Evelyn Lollar','FI','450707292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:39',0,'2014-03-02 06:45:14'),(7571,7571,'2014-01-01','ET','2',1,NULL,'Stacey Johnson','FI','299903762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:36:20',0,'2014-03-01 16:05:34'),(17175,17825,'0000-00-00','ET','2',2,1,'Thao Nguyen','FI','373351966','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:50',0,'2014-03-10 14:24:38'),(16761,17411,'0000-00-00','ET','2',1,NULL,'christoyua Gibbs','FI','427658163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:17',0,'2014-03-02 06:17:30'),(14703,15154,'2014-01-01','ET','2',1,NULL,'Deanna Dethloff','FI','587576303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:57',0,'2014-03-02 05:45:37'),(22304,22954,'0000-00-00','ET','2',1,NULL,'Leslie Sparks','FI','254597534','HealthSpan','FI','311431434','Jeffrey  Janosick','94','10935898','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:58',0,'2014-03-10 14:50:59'),(17691,18341,'0000-00-00','ET','2',1,NULL,'Heidi Kittle','FI','272608475','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:01:02',0,'2014-03-10 14:24:38'),(16904,17554,'0000-00-00','ET','2',1,NULL,'Keith Friedman','FI','549578769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:29',0,'2014-03-01 17:00:58'),(2787,2787,'2014-01-01','ET','2',1,NULL,'Michael Ray Bebout','FI','269520457','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:56',0,'2014-03-01 16:05:34'),(4601,4601,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','357','2014-01-01','Sync Success',0,'2013-12-25 23:47:18',0,'2014-03-01 16:15:39'),(20061,20711,'0000-00-00','ET','2',1,NULL,'AID TREVINO','FI','466172660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:19',0,'2014-03-02 07:10:28'),(21317,21967,'0000-00-00','ET','2',2,1,'Long Nguyen','FI','629927040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:05',0,'2014-03-03 01:07:25'),(14491,14942,'2014-01-01','ET','2',2,1,'DEBBIE L SKIPPER','FI','433118819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:48',0,'2014-03-02 05:38:34'),(6441,6441,'2014-01-01','ET','2',5,4,'Thomas Leis','FI','285644745','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:47',0,'2014-03-10 13:03:33'),(5081,5081,'2014-01-01','ET','2',1,NULL,'Irene Motto','FI','282529162','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:36',0,'2014-03-10 13:20:27'),(3756,3756,'2014-01-01','ET','2',1,NULL,'Lesha D Self-Stoehr','FI','307887141','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:27',0,'2014-03-10 13:20:27'),(14157,14608,'2014-01-01','ET','2',1,NULL,'andrew steele','FI','279948039','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:11',0,'2014-03-10 16:17:47'),(13149,13505,'2014-01-01','ET','2',1,NULL,'Mark Joseph Ficarra','FI','299723928','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-07 04:04:53',0,'2014-03-10 16:10:34'),(1460,1460,'2014-01-01','ET','2',4,3,'David Jellison','FI','280828416','Dental Care Plus, Inc.','FI','311185262','Dan  Keenan','94','1819615','348','2014-01-01','Sync Success',0,'2013-12-25 18:56:05',0,'2014-03-01 16:15:39'),(20012,20662,'0000-00-00','ET','2',1,NULL,'TODD VODRAZKA','FI','269563711','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:01',0,'2014-03-10 16:38:05'),(19410,20060,'0000-00-00','ET','2',1,NULL,'BRIAN EDWARD KURR','FI','247754618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:16',0,'2014-03-10 16:31:33'),(21287,21937,'0000-00-00','ET','2',5,4,'Duane Campton','FI','274721698','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:54',0,'2014-03-10 14:45:25'),(21563,22213,'0000-00-00','ET','2',1,NULL,'Daniel Van Slyke','FI','481087943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:31:40',0,'2014-03-03 22:26:43'),(22974,23624,'0000-00-00','ET','2',1,NULL,'MARYAM HALLEZ','FI','457553842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:33',0,'2014-03-10 21:36:25'),(18296,18946,'0000-00-00','ET','2',1,NULL,'Sikander Aziz','FI','635923204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:25',0,'2014-03-02 06:38:05'),(10601,10601,'2014-01-01','ET','2',1,NULL,'nelda chavez','FI','453459738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:13',0,'2014-03-02 04:24:47'),(5087,5087,'2014-01-01','ET','2',1,NULL,'Bonita Oliver','FI','172382719','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:48:45',0,'2014-03-10 13:20:27'),(17949,18599,'0000-00-00','ET','2',1,NULL,'Juanita Piper','FI','288502379','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:03',0,'2014-03-01 17:20:55'),(16793,17443,'0000-00-00','ET','2',1,NULL,'WILLIAM  B SMITH','FI','281848906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:36',0,'2014-03-01 17:00:58'),(1145,1145,'2014-01-01','ET','2',1,NULL,'William Daume','FI','411805199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:04',0,'2014-03-02 04:38:08'),(1365,1365,'2014-01-01','ET','2',1,NULL,'Shalonda Muldrew','94','0000988530','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:54',0,'2014-03-02 04:38:08'),(15587,16038,'0000-00-00','ET','2',1,NULL,'BRIAN  BOZEMAN','FI','439755951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:30',0,'2014-03-02 05:59:43'),(1989,1989,'2014-01-01','ET','2',2,1,'Vickie Renee Preto','FI','291466884','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:26',0,'2014-03-10 15:45:56'),(14570,15021,'2014-01-01','ET','2',1,NULL,'CHAUNCEY TOWNSEND','FI','456047741','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:30',0,'2014-03-02 05:45:37'),(2269,2269,'2014-01-01','ET','2',1,0,'Frederick Red','FI','427392110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:08',0,'2014-03-01 19:11:03'),(6111,6111,'2014-01-01','ET','2',1,NULL,'karry kaye beisner','FI','303826850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:38',0,'2014-03-01 16:00:27'),(3732,3732,'2014-01-01','ET','2',1,NULL,'Michael Gilbert','FI','287542183','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:37',0,'2014-03-10 13:20:27'),(21171,21821,'0000-00-00','ET','2',1,NULL,'Benilde Negrete','94','0000872106','HealthSpan','FI','311431434','Ty  Cramer','94','8741868','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:35',0,'2014-03-10 14:45:25'),(982,982,'2014-01-01','ET','2',1,NULL,'Tonya Fore','FI','278783869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:39',0,'2014-03-01 15:21:15'),(18756,19406,'0000-00-00','ET','2',1,NULL,'EDDIE ELLIS','FI','435987656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:34',0,'2014-03-02 06:45:14'),(1727,1727,'2014-01-01','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:19',0,'2014-03-01 15:31:33'),(2618,2618,'2014-01-01','ET','2',1,NULL,'Laverne Hollingsworth-Christian','FI','132645646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:32',0,'2014-03-01 15:16:37'),(17457,18107,'0000-00-00','ET','2',1,NULL,'James Hull','FI','302528861','HealthSpan','FI','311431434','Leon D Slusher','94','1492929','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:21',0,'2014-03-10 14:24:38'),(17204,17854,'0000-00-00','ET','2',1,NULL,'Edward Mansfield','FI','040709505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:08',0,'2014-03-01 17:20:55'),(6212,6212,'2014-01-01','ET','2',1,NULL,'Ruth Z Liptok','FI','279587019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:40',0,'2014-03-01 16:00:27'),(4155,4155,'2014-01-01','ET','2',3,2,'Arnold Buehl','FI','300446419','Summa Insurance Company, Inc.','FI','341809108','Tam  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:04:52',0,'2014-03-10 15:59:47'),(21209,21859,'0000-00-00','ET','2',1,NULL,'Mark Kerry Sutton','FI','268584664','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-03-01 19:00:08',0,'2014-03-10 14:45:25'),(23088,23738,'0000-00-00','ET','2',3,2,'Clint David Badowski','FI','198663113','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-10 21:02:58',0,'2014-03-10 21:07:22'),(625,625,'2014-01-01','ET','2',1,NULL,'Karen Kinnibrugh','FI','454154455','Starmount Life Insurance Company','FI','720977315','Danielle   Kunkle','94','8341406','348','2014-01-01','Sync Success',0,'2013-12-25 18:04:27',0,'2014-03-02 02:10:49'),(18927,19577,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:21',0,'2014-03-10 16:31:33'),(16355,17005,'0000-00-00','ET','2',1,NULL,'Nika Tolber','FI','270704297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:57',0,'2014-03-01 16:56:22'),(16291,16941,'0000-00-00','ET','2',2,1,'Marianna Tran','FI','580184088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:17',0,'2014-03-02 06:10:30'),(1877,1877,'2014-01-01','ET','2',2,1,'Grigore Cordos','FI','297026834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:07',0,'2014-03-01 15:31:33'),(1673,1673,'2014-01-01','ET','2',1,NULL,'Yolanda Rios','FI','154653187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:38',0,'2014-03-02 00:10:48'),(5352,5352,'2014-01-01','ET','2',1,NULL,'PATRICIA ROLLER','FI','147448027','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:55',0,'2014-03-10 15:39:19'),(1931,1931,'2014-01-01','ET','2',1,NULL,'Baffour Otchere','FI','291766180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:32:39',0,'2014-03-01 15:26:40'),(4028,4028,'2014-01-01','ET','2',2,1,'James Wall','FI','461023750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:58',0,'2014-03-02 03:09:49'),(4419,4419,'2014-01-01','ET','2',3,2,'Michael Scrivner','FI','288749878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:37',0,'2014-03-01 15:05:09'),(20283,20933,'0000-00-00','ET','2',1,NULL,'sarah ndagire','FI','297968417','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:28',0,'2014-03-10 16:38:05'),(11697,11697,'2014-01-01','ET','2',1,NULL,'Vanessa Garza','FI','463591597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:49',0,'2014-03-02 04:59:36'),(14789,15240,'2014-01-01','ET','2',1,NULL,'Charles Romine','FI','448662644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:50',0,'2014-03-02 05:45:37'),(19496,20146,'0000-00-00','ET','2',1,NULL,'ALVIN JOHNSON','FI','298486212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:02:49',0,'2014-03-10 16:31:33'),(17203,17853,'0000-00-00','ET','2',4,3,'Steven Bass','FI','568511502','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:07',0,'2014-03-10 14:24:38'),(16663,17313,'0000-00-00','ET','2',1,NULL,'Barbara K Jenkins','FI','300540251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:50',0,'2014-03-01 17:00:58'),(17096,17746,'0000-00-00','ET','2',1,NULL,'Albert Ofori','FI','276178944','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:58',0,'2014-03-01 17:00:58'),(22049,22699,'0000-00-00','ET','2',1,NULL,'Bobby Tutor','FI','587085822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:27',0,'2014-03-05 22:27:33'),(18313,18963,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:14',0,'2014-03-10 16:31:33'),(14798,15249,'2014-01-01','ET','2',1,NULL,'Lori Elliott','FI','295687898','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:56',0,'2014-03-10 14:03:26'),(14742,15193,'2014-01-01','ET','2',4,3,'William Ziss','FI','268785737','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:20',0,'2014-03-10 16:17:47'),(13257,13613,'2014-01-01','ET','2',2,1,'Linda Mensah','FI','454752965','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:26',0,'2014-03-10 16:10:34'),(1548,1548,'2014-01-01','ET','2',1,NULL,'Larry Hamilton','FI','274483955','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:54',0,'2014-03-10 13:52:32'),(3151,3151,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:47',0,'2014-03-10 13:24:34'),(1640,1640,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:11',0,'2014-03-01 20:10:57'),(11216,11216,'2014-01-01','ET','2',1,NULL,'Angel Hernandez','FI','331724891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:00:57',0,'2014-03-01 16:23:43'),(11680,11680,'2014-01-01','ET','2',2,1,'Eli Morris','FI','270669880','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:37:16',0,'2014-03-10 13:52:32'),(11681,11681,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:37:19',0,'2014-03-10 13:52:32'),(2051,2051,'2014-01-01','ET','2',1,NULL,'MAE FRANCES LINDSEY-BENNETT','FI','587269680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:27',0,'2014-03-02 00:10:48'),(2746,2746,'2014-01-01','ET','2',1,NULL,'Angela Akinniyi','FI','438450642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:36',0,'2014-03-02 04:15:49'),(18728,19378,'0000-00-00','ET','2',1,NULL,'EMORY CONNER','FI','423236439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:13',0,'2014-03-02 06:45:14'),(18105,18755,'0000-00-00','ET','2',1,NULL,'SILVIA MEDRANO','FI','623283402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:42',0,'2014-03-02 06:38:05'),(3999,3999,'2014-01-01','ET','2',1,NULL,'Paula R LaDue','FI','484620067','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:09',0,'2014-03-02 03:09:49'),(17733,18383,'0000-00-00','ET','2',1,NULL,'Jeffrey Evans','FI','438983808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:23',0,'2014-03-02 06:31:45'),(3272,3272,'2014-01-01','ET','2',1,NULL,'Ty T Foust','FI','291763281','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:47:34',0,'2014-03-10 13:24:34'),(15956,16605,'0000-00-00','ET','2',1,NULL,'MARVA DAVIS','FI','280686572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:07',0,'2014-03-01 16:56:22'),(12558,12558,'2014-01-01','ET','2',2,1,'Dale Goist','FI','286466298','HealthSpan','FI','311431434','Brenda  Williams','94','8389118','348','2014-02-01','Sync Success',1,'2014-01-02 04:35:35',0,'2014-03-10 13:59:38'),(20835,21485,'0000-00-00','ET','2',1,NULL,'Rex Thompson','FI','431299616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:15',0,'2014-03-02 07:17:36'),(296,296,'2014-01-01','ET','2',1,NULL,'Bryan Martin','FI','270962644','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:05',0,'2014-03-10 13:10:24'),(17227,17877,'0000-00-00','ET','2',4,3,'Christie Crabiel','FI','268867398','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:19',0,'2014-03-10 16:24:30'),(1898,1898,'2014-01-01','ET','2',1,NULL,'LETICIA BALINO','FI','457414410','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:43',0,'2014-03-01 23:10:52'),(2148,2148,'2014-01-01','ET','2',1,NULL,'Joe Lordi','FI','295868336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:46:24',0,'2014-03-01 15:16:37'),(11159,11159,'2014-01-01','ET','2',1,NULL,'David Grant Hill','FI','277845861','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:15',0,'2014-03-10 13:45:57'),(12414,12414,'2014-01-01','ET','2',2,1,'Nelson  Jones','FI','434925695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:12',0,'2014-03-02 05:03:29'),(22442,23092,'0000-00-00','ET','2',1,NULL,'MIGDALIA NINO','FI','626016870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:30:30',0,'2014-03-07 22:26:59'),(188,188,'2014-01-01','ET','2',1,NULL,'Scott Duffer','FI','093586914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:51',0,'2014-03-01 22:10:55'),(5599,5599,'2014-01-01','ET','2',1,NULL,'BOUBACAR IDE','FI','110906552','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:38',0,'2014-03-01 16:23:43'),(20533,21183,'0000-00-00','ET','2',2,1,'Marie V Tillman','FI','464940786','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:06',0,'2014-03-02 07:10:28'),(3750,3750,'2014-01-01','ET','2',1,NULL,'LAWREEN K GEESAMAN','FI','280522315','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:11',0,'2014-03-10 13:24:34'),(2839,2839,'2014-01-01','ET','2',1,NULL,'Amber Miller','FI','454959367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:38',0,'2014-03-02 04:15:49'),(19933,20583,'0000-00-00','ET','2',1,NULL,'Kathleen Masters','FI','274568745','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:25',0,'2014-03-10 14:37:47'),(21738,22388,'0000-00-00','ET','2',1,NULL,'Christopher Smith','FI','293822995','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:09',0,'2014-03-10 14:45:25'),(759,759,'2014-01-01','ET','2',1,NULL,'Antonio Camp','FI','299749155','HealthSpan','FI','311431434','Kevin  Schlotman','94','142172','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:38',0,'2014-03-10 13:24:34'),(19268,19918,'0000-00-00','ET','2',1,NULL,'Johnny Campos','FI','458656292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-17 19:00:12',0,'2014-03-02 06:52:12'),(4936,4936,'2014-01-01','ET','2',1,NULL,'Ashley Kunkel','FI','284965001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:20',0,'2014-03-01 15:10:22'),(18998,19648,'0000-00-00','ET','2',1,NULL,'Marilyn Crowe','FI','284523658','Summa Insurance Company, Inc.','FI','341809108','Deborah   Grazey','94','2341750','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:12',0,'2014-03-10 16:31:33'),(18165,18815,'0000-00-00','ET','2',1,NULL,'Amy Wang','FI','435573751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:27',0,'2014-03-02 06:38:05'),(3605,3605,'2014-01-01','ET','2',4,3,'Kevin Daugherty','FI','277686556','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:30',0,'2014-03-10 15:52:36'),(10652,10652,'2014-01-01','ET','2',1,NULL,'Raylene R Speed','FI','449822792','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:52',0,'2014-03-02 04:31:46'),(13634,13990,'2014-01-01','ET','2',1,NULL,'Larry Maye','FI','425319735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:50',0,'2014-03-02 05:31:31'),(13661,14017,'2014-01-01','ET','2',1,NULL,'Barbara thomas','FI','142583186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:17',0,'2014-03-02 05:24:45'),(17948,18598,'0000-00-00','ET','2',1,NULL,'Michael Taylor','FI','298767171','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:02',0,'2014-03-01 17:20:55'),(15809,16458,'0000-00-00','ET','2',1,NULL,'MARILYN GALE JONES','FI','462313005','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:00:16',0,'2014-03-02 06:03:21'),(15955,16604,'0000-00-00','ET','2',1,NULL,'Sara Beckrest','FI','291847310','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:06',0,'2014-03-01 16:56:22'),(21190,21840,'0000-00-00','ET','2',2,1,'Raymond Cappel','FI','291428621','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:52',0,'2014-03-10 14:45:25'),(513,513,'2014-01-01','ET','2',1,NULL,'Jacqueline Speaks','FI','273584870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:51',0,'2014-03-01 15:48:04'),(19868,20518,'0000-00-00','ET','2',1,NULL,'Dominique Ziroulo','FI','272969652','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:18',0,'2014-03-01 17:47:19'),(5844,5844,'2014-01-01','ET','2',2,1,'MICHAEL CLOSSON','FI','293468478','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:54',0,'2014-03-01 15:10:22'),(4625,4625,'2014-01-01','ET','2',1,NULL,'Edward McCoy','FI','452953540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:05',0,'2014-03-02 04:31:46'),(4283,4283,'2014-01-01','ET','2',1,NULL,'Donald Warren','FI','435960126','Starmount Life Insurance Company','FI','720977315','Melvin  Thomas','94','4745590','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:47',0,'2014-03-02 04:10:25'),(1923,1923,'2014-01-01','ET','2',2,1,'Michael Shafitz','FI','420782243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:26',0,'2014-03-01 15:26:40'),(18033,18683,'0000-00-00','ET','2',1,NULL,'Gerard Germani','FI','380824943','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:01',0,'2014-03-10 14:24:38'),(11590,11590,'2014-01-01','ET','2',1,NULL,'Ronald Mayfield','FI','452275952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:25',0,'2014-03-02 04:59:36'),(11944,11944,'2014-01-01','ET','2',1,NULL,'John David Peak','FI','250732408','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:27',0,'2014-03-10 13:52:32'),(13009,13009,'2014-01-01','ET','2',2,1,'kanak patel','FI','366234351','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:28',0,'2014-03-01 16:35:14'),(17398,18048,'0000-00-00','ET','2',1,NULL,'susan dominic','FI','275601888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:41',0,'2014-03-01 17:20:55'),(13208,13564,'2014-01-01','ET','2',2,1,'MICHAEL O MCINTIRE','FI','479709073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:20',0,'2014-03-02 05:17:40'),(16744,17394,'0000-00-00','ET','2',1,NULL,'Christopher Fischer','FI','594214099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:05',0,'2014-03-02 06:17:30'),(21201,21851,'0000-00-00','ET','2',1,NULL,'hongnga tran','FI','024683507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:03',0,'2014-03-02 07:23:39'),(5224,5224,'2014-01-01','ET','2',1,NULL,'Sara Baker','FI','224663322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:12',0,'2014-03-02 00:10:48'),(5100,5100,'2014-01-01','ET','2',2,1,'Thuy N Nguyen','FI','620188424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:09',0,'2014-03-02 00:10:48'),(12014,12014,'2014-01-01','ET','2',1,NULL,'Milton Jones','FI','437868943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:37',0,'2014-03-02 04:59:36'),(1221,1221,'2014-01-01','ET','2',1,NULL,'Raymond Hector Carbonell','FI','269724402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:25',0,'2014-03-01 16:15:39'),(4567,4567,'2014-01-01','ET','2',1,NULL,'Clarence Johnson','FI','571118455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:14',0,'2014-03-02 04:38:08'),(4471,4471,'2014-01-01','ET','2',1,NULL,'joseph turner','FI','445820312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:05',0,'2014-03-01 21:11:04'),(3480,3480,'2014-01-01','ET','2',1,NULL,'Reyhan Hoq','FI','514904864','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:32',0,'2014-03-01 15:31:33'),(21455,22105,'0000-00-00','ET','2',1,NULL,'jessica overbey','FI','304067321','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:23',0,'2014-03-03 21:36:16'),(368,368,'2014-01-01','ET','2',1,NULL,'Charles Kearney','FI','403151024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:20',0,'2014-03-01 15:21:15'),(18678,19328,'0000-00-00','ET','2',1,NULL,'Sadiq Sadruddin','FI','456735734','Starmount Life Insurance Company','FI','720977315','Gilberto  Lopez','94','16945680','357','2014-03-01','Sync Success',0,'2014-02-13 22:01:35',0,'2014-03-02 06:45:14'),(18254,18904,'0000-00-00','ET','2',1,NULL,'ROBIN SAMPLE','FI','505027007','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:41',0,'2014-03-10 14:24:38'),(1013,1013,'2014-01-01','ET','2',1,NULL,'Thomas Rains','FI','270949639','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:41',0,'2014-03-10 13:10:24'),(16120,16769,'0000-00-00','ET','2',2,1,'Holly Steinert','FI','292824341','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:33',0,'2014-03-10 14:20:26'),(1627,1627,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:53',0,'2014-03-01 20:10:57'),(15168,15619,'0000-00-00','ET','2',1,NULL,'Andrew Roth','FI','300725591','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:40',0,'2014-03-10 14:10:12'),(15146,15597,'0000-00-00','ET','2',1,NULL,'John Boring','FI','288608799','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:06:24',0,'2014-03-10 16:17:47'),(3822,3822,'2014-01-01','ET','2',2,1,'Joseph Robenalt','FI','268505221','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:07',0,'2014-03-10 13:10:24'),(10674,10674,'2014-01-01','ET','2',1,NULL,'Michele Smith','FI','286500916','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:33',0,'2014-03-01 16:05:34'),(3029,3029,'2014-01-01','ET','2',1,NULL,'Deborah Phillips','FI','299508657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:00',0,'2014-03-01 15:37:30'),(20259,20909,'0000-00-00','ET','2',1,NULL,'Torrie Coston','FI','298882856','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:09',0,'2014-03-01 17:47:19'),(21153,21803,'0000-00-00','ET','2',1,NULL,'Hang Minh Ly','FI','661055039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:23',0,'2014-03-02 07:23:39'),(22548,23198,'0000-00-00','ET','2',1,NULL,'Florine Mcqueen','FI','427048405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:45',0,'2014-03-07 22:26:59'),(491,491,'2014-01-01','ET','2',2,1,'Robert Wiley','FI','293489359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:12',0,'2014-03-01 15:48:04'),(600,600,'2014-01-01','ET','2',1,NULL,'Christie Armstrong','FI','449817113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:35',0,'2014-03-02 02:10:49'),(19354,20004,'0000-00-00','ET','2',1,NULL,'Kevin Junious Davis','FI','437498200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:36',0,'2014-03-02 06:59:07'),(18583,19233,'0000-00-00','ET','2',1,NULL,'MICHELLE BAGGETT','FI','298604678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:21',0,'2014-03-01 17:26:36'),(1585,1585,'2014-01-01','ET','2',1,NULL,'angela burnett','FI','403296188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:47',0,'2014-03-01 15:10:22'),(15612,16063,'0000-00-00','ET','2',1,NULL,'Brittney Richardson','FI','587695211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:42',0,'2014-03-02 05:59:43'),(6292,6292,'2014-01-01','ET','2',1,NULL,'Jonathan Patin','FI','437630602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:10',0,'2014-03-02 04:10:25'),(2955,2955,'2014-01-01','ET','2',1,NULL,'GREGORY JOSEPH GOODMAN','FI','279680232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:31:46',0,'2014-03-01 15:37:30'),(15601,16052,'0000-00-00','ET','2',1,NULL,'Paula Davis','FI','439277759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 03:02:36',0,'2014-03-02 05:59:43'),(5038,5038,'2014-01-01','ET','2',1,NULL,'DAVID  B DREETY','FI','275466732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:12',0,'2014-03-01 15:31:33'),(19220,19870,'0000-00-00','ET','2',1,NULL,'Paula Cochran-Styles','FI','280486207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:16',0,'2014-03-01 17:34:07'),(13701,14057,'2014-01-01','ET','2',2,1,'ROBERT E MATHEWS','FI','282505781','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:41',0,'2014-03-01 16:40:16'),(18371,19021,'0000-00-00','ET','2',1,NULL,'James Sadler','FI','465177172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:41',0,'2014-03-02 06:45:14'),(12776,12776,'2014-01-01','ET','2',2,1,'Jessica Clark','FI','278865861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:21',0,'2014-03-01 16:35:14'),(12193,12193,'2014-01-01','ET','2',1,NULL,'Ryan Mobley','FI','294882197','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:05',0,'2014-03-10 13:52:32'),(4484,4484,'2014-01-01','ET','2',2,1,'Estela Torres','FI','460450642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:31',0,'2014-03-01 21:11:04'),(7257,7257,'2014-01-01','ET','2',1,NULL,'FARRELL JEFFREY MARX','FI','276689285','Summa Insurance Company, Inc.','FI','341809108','RONI ANN BELL','94','3345388','348','2014-01-01','Sync Success',0,'2013-12-26 04:08:25',0,'2014-03-10 15:59:47'),(5944,5944,'2014-01-01','ET','2',1,NULL,'JONATHAN  BROWN','FI','046768208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:08',0,'2014-03-02 01:10:33'),(4703,4703,'2014-01-01','ET','2',1,NULL,'brandi Latino','FI','433638914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:45',0,'2014-03-02 04:31:46'),(14923,15374,'2014-01-01','ET','2',1,NULL,'Casey Smith','FI','286822925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:34',0,'2014-03-01 16:50:53'),(17041,17691,'0000-00-00','ET','2',1,NULL,'MICHELLE CANNATELLA','FI','434650948','Starmount Life Insurance Company','FI','720977315','PAUL  CARO','94','16940355','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:25',0,'2014-03-02 06:24:38'),(19734,20384,'0000-00-00','ET','2',2,1,'Melissa Irby','FI','226660459','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:38:27',0,'2014-03-10 14:37:47'),(797,797,'2014-01-01','ET','2',2,1,'James Lirette','FI','435554542','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:04',0,'2014-03-01 19:11:03'),(14234,14685,'2014-01-01','ET','2',1,NULL,'Valerie Arrington','FI','427192120','Starmount Life Insurance Company','FI','720977315','Crystall  Washington','94','10820803','357','2014-02-01','Sync Success',0,'2014-01-15 02:05:55',0,'2014-03-02 05:38:34'),(1855,1855,'2014-01-01','ET','2',1,NULL,'James Zimmer','FI','294527038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:22',0,'2014-03-01 15:26:40'),(2449,2449,'2014-01-01','ET','2',1,NULL,'Ava Pharr-Horne','FI','435451742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:49',0,'2014-03-01 23:10:52'),(5711,5711,'2014-01-01','ET','2',1,NULL,'Carole Niedzialkowski','FI','318905271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:48',0,'2014-03-01 15:37:30'),(7453,7453,'2014-01-01','ET','2',1,NULL,'Hector Ramirez','FI','642263869','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','348','2014-01-01','Sync Success',0,'2013-12-26 04:32:28',0,'2014-03-02 04:10:25'),(20154,20804,'0000-00-00','ET','2',1,NULL,'Richard Frenton','FI','279563149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-25 21:30:58',0,'2014-03-01 18:08:07'),(1196,1196,'2014-01-01','ET','2',1,NULL,'Berton Breaux','FI','438597809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:39',0,'2014-03-02 04:45:37'),(18108,18758,'0000-00-00','ET','2',1,NULL,'JUDY STEWART','FI','465980942','Starmount Life Insurance Company','FI','720977315','DAVID  BURNS','94','8328382','348','2014-03-01','Sync Success',0,'2014-02-11 21:00:44',0,'2014-03-02 06:38:05'),(14583,15034,'2014-01-01','ET','2',3,2,'Tara Smus','FI','368946108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:39',0,'2014-03-02 05:45:37'),(14352,14803,'2014-01-01','ET','2',1,NULL,'lupe arias','FI','549133612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:46',0,'2014-03-02 05:45:37'),(16732,17382,'0000-00-00','ET','2',1,NULL,'Julie Cook','FI','275644222','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:40',0,'2014-03-10 14:20:26'),(12242,12242,'2014-01-01','ET','2',1,NULL,'Jennifer FAZENDE','FI','433774979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:07',0,'2014-03-02 05:10:52'),(11894,11894,'2014-01-01','ET','2',1,NULL,'Sara Tan','FI','438656127','Starmount Life Insurance Company','FI','720977315','Wayne  Schellhaas','94','1255254','348','2014-02-01','Sync Success',0,'2013-12-30 00:00:49',0,'2014-03-02 04:59:36'),(15697,16346,'0000-00-00','ET','2',1,NULL,'Tonya S Vincent','FI','465591271','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:46',0,'2014-03-02 06:03:21'),(10943,10943,'2014-01-01','ET','2',1,NULL,'Pamela Gelsinger','FI','271465835','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:00',0,'2014-03-10 16:03:49'),(5336,5336,'2014-01-01','ET','2',1,NULL,'Neva Reece','FI','270508102','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:22',0,'2014-03-01 15:10:22'),(4134,4134,'2014-01-01','ET','2',1,NULL,'Paul N Arel','FI','296687348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:13',0,'2014-03-01 16:00:27'),(20450,21100,'0000-00-00','ET','2',1,NULL,'Richard Lehman','FI','296788314','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:31:06',0,'2014-03-10 16:38:05'),(20953,21603,'0000-00-00','ET','2',1,NULL,'Adriana Ramos','FI','558796470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:07',0,'2014-03-02 07:17:36'),(18266,18916,'0000-00-00','ET','2',1,NULL,'MARSHA NAVARRE','FI','299542274','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:51',0,'2014-03-10 14:24:38'),(15749,16398,'0000-00-00','ET','2',1,NULL,'Jessica Sturgill','FI','630105144','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','357','2014-02-01','Sync Success',0,'2014-01-23 21:01:21',0,'2014-03-01 16:56:22'),(15679,16328,'0000-00-00','ET','2',1,NULL,'Sandra Patricia Gonzales','FI','629243368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:34',0,'2014-03-02 05:59:43'),(13223,13579,'2014-01-01','ET','2',1,NULL,'norberto juarez','FI','452235764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-07 10:22:00',0,'2014-03-02 05:17:40'),(11914,11914,'2014-01-01','ET','2',1,NULL,'Samantha Haddix','FI','299925608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:27',0,'2014-03-01 16:30:17'),(15544,15995,'0000-00-00','ET','2',1,NULL,'alaa Iberahim','FI','278982915','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:11',0,'2014-03-10 16:17:47'),(10980,10980,'2014-01-01','ET','2',1,NULL,'Randall Fawcett','FI','259824124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:05',0,'2014-03-02 04:24:47'),(10703,10703,'2014-01-01','ET','2',1,NULL,'DENISE ANGERSTIEN','FI','292601297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:39',0,'2014-03-01 16:10:36'),(1527,1527,'2014-01-01','ET','2',1,NULL,'Deborah Vansickle','FI','270502843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:17',0,'2014-03-10 16:03:49'),(7232,7232,'2014-01-01','ET','2',1,NULL,'Terry Legros','FI','277482407','Dental Care Plus, Inc.','FI','311185262','Dominick A D\'Aurora','94','15936209','348','2014-01-01','Sync Success',0,'2013-12-26 04:07:38',0,'2014-03-01 15:52:44'),(5277,5277,'2014-01-01','ET','2',2,1,'Jeffrey Susich','FI','477723934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:37',0,'2014-03-01 15:10:22'),(4502,4502,'2014-01-01','ET','2',1,NULL,'philip Whisner','FI','300804736','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:09',0,'2014-03-10 13:03:33'),(3758,3758,'2014-01-01','ET','2',1,NULL,'Jacqueline Scott','FI','284742922','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:31',0,'2014-03-10 13:24:34'),(13671,14027,'2014-01-01','ET','2',2,1,'Tiburcio Arizpe','FI','457537298','Starmount Life Insurance Company','FI','720977315','Linda   Carter','94','1033689','348','2014-02-01','Sync Success',0,'2014-01-13 02:21:23',0,'2014-03-02 05:24:45'),(12872,12872,'2014-01-01','ET','2',1,NULL,'Nikul M Panchal','FI','407613492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:52',0,'2014-03-01 16:35:14'),(10676,10676,'2014-01-01','ET','2',1,NULL,'Laurence Barton Peters','FI','395561689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:37',0,'2014-03-01 16:10:36'),(7135,7135,'2014-01-01','ET','2',1,NULL,'Wendy Stahl-Frakes','FI','291448049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:37',0,'2014-03-01 15:52:44'),(19359,20009,'0000-00-00','ET','2',1,NULL,'Richard A LaFargue','FI','436217266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-18 22:00:39',0,'2014-03-02 06:59:07'),(20666,21316,'0000-00-00','ET','2',1,NULL,'Amy Pitler','FI','385882441','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:37',0,'2014-03-10 14:37:47'),(21490,22140,'0000-00-00','ET','2',1,NULL,'Derris Price','FI','289767160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:48',0,'2014-03-03 21:36:16'),(21504,22154,'0000-00-00','ET','2',1,NULL,'PHILIP MACNAMES','FI','335464278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:58',0,'2014-03-03 22:26:43'),(22658,23308,'0000-00-00','ET','2',1,NULL,'MARGARET SMITH','FI','480766048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:26',0,'2014-03-08 22:26:18'),(17932,18582,'0000-00-00','ET','2',1,NULL,'HUNG VO','FI','731260217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:51',0,'2014-03-02 06:38:05'),(17527,18177,'0000-00-00','ET','2',1,NULL,'Shirley Jones','FI','270542443','Dental Care Plus, Inc.','FI','311185262','Sharon  Wingert','94','2446886','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:19',0,'2014-03-01 17:20:55'),(1543,1543,'2014-01-01','ET','2',1,NULL,'Randall Tarvin','FI','279548104','HealthSpan','FI','311431434','Linda  Sawyers','94','2095238','348','2014-01-01','Sync Success',0,'2013-12-25 18:58:43',0,'2014-03-10 13:45:57'),(2353,2353,'2014-01-01','ET','2',2,1,'Rodney Curry','FI','291722798','Dental Care Plus, Inc.','FI','311185262','Thomas  Hawks','94','1761773','348','2014-01-01','Sync Success',0,'2013-12-25 20:15:44',0,'2014-03-01 15:26:40'),(6429,6429,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:26',0,'2014-03-01 15:10:22'),(10710,10710,'2014-01-01','ET','2',4,3,'Evan Mecklenborg','FI','300980342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:52',0,'2014-03-01 16:10:36'),(10559,10559,'2014-01-01','ET','2',1,NULL,'kathryn roos','FI','459904473','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:50',0,'2014-03-02 04:24:47'),(20931,21581,'0000-00-00','ET','2',3,2,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:22',0,'2014-03-10 16:38:05'),(3028,3028,'2014-01-01','ET','2',1,NULL,'Deborah Phillips','FI','299508657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:57',0,'2014-03-01 15:37:30'),(13151,13507,'2014-01-01','ET','2',3,2,'Timothy Kost','FI','295680922','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:58',0,'2014-03-10 16:10:34'),(11916,11916,'2014-01-01','ET','2',2,1,'derrick lambert','FI','396849206','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:30',0,'2014-03-01 16:30:17'),(20135,20785,'0000-00-00','ET','2',1,NULL,'MICHAEL LYNN WEIMER','FI','289824186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:45',0,'2014-03-01 18:08:07'),(11122,11122,'2014-01-01','ET','2',1,NULL,'Richard Johnson','FI','300644016','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:52',0,'2014-03-10 13:45:57'),(17735,18385,'0000-00-00','ET','2',1,NULL,'Emily Zametkin','FI','218080913','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:24',0,'2014-03-02 06:31:45'),(22623,23273,'0000-00-00','ET','2',4,3,'Stephanie Jarrett','FI','290680590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:29:59',0,'2014-03-08 21:35:36'),(19100,19750,'0000-00-00','ET','2',1,NULL,'Anthony Craver','FI','424940213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:44',0,'2014-03-01 17:34:07'),(17186,17836,'0000-00-00','ET','2',1,NULL,'Jami Young','FI','279820266','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:58',0,'2014-03-10 14:24:38'),(1943,1943,'2014-01-01','ET','2',1,NULL,'Samuel Smith','FI','309886858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:01',0,'2014-03-01 15:26:40'),(2172,2172,'2014-01-01','ET','2',1,NULL,'Thomas Horan','FI','102445121','Dental Care Plus, Inc.','FI','311185262','Warren  McDonald','94','7863806','348','2014-01-01','Sync Success',0,'2013-12-25 19:47:13',0,'2014-03-01 15:16:37'),(1921,1921,'2014-01-01','ET','2',1,NULL,'Kristi Pickup','FI','467555522','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-25 19:32:22',0,'2014-03-02 00:10:48'),(3250,3250,'2014-01-01','ET','2',1,NULL,'Luke J Zachrich','94','0000222384','Dental Care Plus, Inc.','FI','311185262','Chris  Junge','94','9794726','348','2014-01-01','Sync Success',0,'2013-12-25 21:46:52',0,'2014-03-01 15:52:44'),(1424,1424,'2014-01-01','ET','2',1,NULL,'Beverly Lynn Ingram','FI','280560753','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:51',0,'2014-03-10 13:45:57'),(5193,5193,'2014-01-01','ET','2',1,NULL,'Phil Dudley','FI','459138324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:08',0,'2014-03-02 00:10:48'),(17052,17702,'0000-00-00','ET','2',1,NULL,'Tiffany Giger','FI','601464924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:31',0,'2014-03-02 06:24:38'),(5298,5298,'2014-01-01','ET','2',1,NULL,'Ashley Felter','FI','301849893','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:20',0,'2014-03-10 13:03:33'),(622,622,'2014-01-01','ET','2',2,1,'Jennifer Kay Minard','FI','460737848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:20',0,'2014-03-02 02:10:49'),(390,390,'2014-01-01','ET','2',1,NULL,'Claudia Kheel','FI','110386781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:03',0,'2014-03-01 22:10:55'),(553,553,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:06',0,'2014-03-01 15:48:04'),(801,801,'2014-01-01','ET','2',2,1,'charlotte vickery','FI','289621670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:12',0,'2014-03-10 13:03:33'),(17726,18376,'0000-00-00','ET','2',1,NULL,'Anthony Delaet','FI','294722060','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:19',0,'2014-03-01 17:20:55'),(17594,18244,'0000-00-00','ET','2',2,1,'Mona Stallion','FI','587130783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:08',0,'2014-03-02 06:31:45'),(4828,4828,'2014-01-01','ET','2',1,NULL,'Kristina Schalk','FI','271885409','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:45',0,'2014-03-10 13:03:33'),(14228,14679,'2014-01-01','ET','2',1,NULL,'Karen MAGID','FI','364868495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:53',0,'2014-03-02 05:38:34'),(12677,12677,'2014-01-01','ET','2',1,NULL,'Sharon  Vaughn','FI','297508762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:54',0,'2014-03-01 16:35:14'),(12431,12431,'2014-01-01','ET','2',1,NULL,'patrick durbin','FI','536665137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:30:48',0,'2014-03-02 05:03:29'),(792,792,'2014-01-01','ET','2',2,1,'shrivatssa thiagarajan','FI','635966741','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:52',0,'2014-03-01 19:11:03'),(10929,10929,'2014-01-01','ET','2',1,NULL,'Kimberly Whitis','FI','293667882','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:36',0,'2014-03-10 16:03:49'),(20130,20780,'0000-00-00','ET','2',1,NULL,'dorian lindsey','FI','355544303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-25 21:30:42',0,'2014-03-01 18:08:07'),(1089,1089,'2014-01-01','ET','2',1,NULL,'James Toppel','FI','281901161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:36',0,'2014-03-01 15:05:09'),(22590,23240,'0000-00-00','ET','2',2,1,'Shannon Simmons','FI','288806618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:15',0,'2014-03-10 16:44:18'),(19901,20551,'0000-00-00','ET','2',1,NULL,'Koviljka  Vegara','FI','731098091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-21 21:30:05',0,'2014-03-01 17:47:19'),(18485,19135,'0000-00-00','ET','2',1,NULL,'Faris Walker Yarbrough','FI','428558501','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:59',0,'2014-03-02 06:45:14'),(18258,18908,'0000-00-00','ET','2',1,NULL,'Cynthia Lewis','FI','276488742','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:45',0,'2014-03-10 14:24:38'),(17539,18189,'0000-00-00','ET','2',1,NULL,'Sarah  McElroy','FI','286541975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:27',0,'2014-03-01 17:20:55'),(15854,16503,'0000-00-00','ET','2',1,NULL,'MARY  CARR','FI','281528331','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:43',0,'2014-03-01 16:56:22'),(13194,13550,'2014-01-01','ET','2',1,NULL,'Mary Stiles','FI','293444572','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:27',0,'2014-03-10 13:59:38'),(14576,15027,'2014-01-01','ET','2',1,NULL,'Abram Vara','FI','453922947','Starmount Life Insurance Company','FI','720977315','Natalie  Hetherly','94','1223661','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:34',0,'2014-03-02 05:45:37'),(15209,15660,'0000-00-00','ET','2',1,NULL,'CATHERINE  VINKA','FI','268663701','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:31',0,'2014-03-01 16:50:53'),(15551,16002,'0000-00-00','ET','2',1,NULL,'Doris Morrison','FI','440607330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:14',0,'2014-03-02 05:59:43'),(22096,22746,'0000-00-00','ET','2',1,NULL,'JUAN SANCHEZ','FI','460199670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:26',0,'2014-03-06 21:27:26'),(21647,22297,'0000-00-00','ET','2',1,NULL,'Gregory Arnold','FI','289540032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:00:57',0,'2014-03-04 21:36:30'),(7650,7650,'2014-01-01','ET','2',2,1,'Angela Montgomery','FI','275889430','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:51',0,'2014-03-10 13:39:10'),(17172,17822,'0000-00-00','ET','2',4,3,'Cynthia Lyons','FI','281785851','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:47',0,'2014-03-10 14:24:38'),(7397,7397,'2014-01-01','ET','2',1,NULL,'Betty Huff','FI','270527199','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:47',0,'2014-03-10 13:39:10'),(2867,2867,'2014-01-01','ET','2',1,NULL,'Frances Wuest','FI','283563683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:31',0,'2014-03-10 13:39:10'),(6304,6304,'2014-01-01','ET','2',1,NULL,'Mary Melissa Boone','FI','426372507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:30',0,'2014-03-02 04:10:25'),(5318,5318,'2014-01-01','ET','2',1,NULL,'Albert Padgett','FI','454980409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:08',0,'2014-03-01 19:11:03'),(15651,16300,'0000-00-00','ET','2',2,1,'MARK MCCAFFERTY','FI','270541694','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:12',0,'2014-03-01 16:56:22'),(13161,13517,'2014-01-01','ET','2',1,NULL,'Mary Erby','FI','587361791','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:18',0,'2014-03-02 05:17:40'),(12319,12319,'2014-01-01','ET','2',1,NULL,'TAMARA N WILSON','FI','455068075','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:26:47',0,'2014-03-02 05:03:29'),(3115,3115,'2014-01-01','ET','2',4,3,'Paula Hartzell','FI','281742244','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:38',0,'2014-03-10 15:52:36'),(19921,20571,'0000-00-00','ET','2',1,NULL,'CURMERA HARPER','FI','426591761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:17',0,'2014-03-02 07:03:25'),(11329,11329,'2014-01-01','ET','2',1,NULL,'Pablo Lozano','FI','453049165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:23',0,'2014-03-02 04:52:44'),(19851,20501,'0000-00-00','ET','2',1,NULL,'Dennis Navarro','FI','439218771','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-04-01','Sync Success',0,'2014-02-20 22:01:05',0,'2014-03-02 07:03:25'),(4249,4249,'2014-01-01','ET','2',1,NULL,'Karen Matthiesen','FI','286462125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:46',0,'2014-03-10 15:59:47'),(5752,5752,'2014-01-01','ET','2',1,NULL,'KRISTIN BAUER','FI','435416044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:57',0,'2014-03-02 01:10:33'),(18410,19060,'0000-00-00','ET','2',1,NULL,'michael anderson','FI','285669542','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:08',0,'2014-03-01 17:26:36'),(16547,17197,'0000-00-00','ET','2',2,1,'SHANNON SINGLETON','FI','438137646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:07',0,'2014-03-02 06:10:30'),(14446,14897,'2014-01-01','ET','2',1,NULL,'LONDA DYER','FI','436219357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:28',0,'2014-03-02 05:38:34'),(15721,16370,'0000-00-00','ET','2',1,NULL,'Lee Joyce Levon Davis','FI','433158866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:03',0,'2014-03-02 05:59:43'),(1810,1810,'2014-01-01','ET','2',1,NULL,'Sheena Lee','FI','286829980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:58',0,'2014-03-10 13:20:27'),(1929,1929,'2014-01-01','ET','2',1,NULL,'PETE CALCO','FI','278521467','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:36',0,'2014-03-01 15:26:40'),(20195,20845,'0000-00-00','ET','2',2,1,'ROSE WOOLBRIGHT','FI','459944449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:27',0,'2014-03-02 07:10:28'),(10978,10978,'2014-01-01','ET','2',1,NULL,'Sophia Bell-Madison','FI','426617347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:01',0,'2014-03-02 04:24:47'),(3557,3557,'2014-01-01','ET','2',4,3,'LaKisha Williams','FI','287888848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:02',0,'2014-03-01 15:37:30'),(17342,17992,'0000-00-00','ET','2',1,NULL,'Jessica Hoang','FI','623525462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:18',0,'2014-03-10 14:24:38'),(12787,12787,'2014-01-01','ET','2',1,NULL,'Meron Gashaw','FI','259959211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:47',0,'2014-03-02 05:10:52'),(4952,4952,'2014-01-01','ET','2',1,NULL,'Brenda Smith','FI','434928026','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:53',0,'2014-03-01 20:10:57'),(6222,6222,'2014-01-01','ET','2',1,NULL,'Torey Jay Horner','FI','273661184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:05:00',0,'2014-03-01 16:00:27'),(6089,6089,'2014-01-01','ET','2',2,1,'Steven Griffen','FI','407339325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:58',0,'2014-03-01 16:00:27'),(5847,5847,'2014-01-01','ET','2',1,NULL,'CECIL JONES','FI','284489630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:02',0,'2014-03-01 15:10:22'),(5561,5561,'2014-01-01','ET','2',1,NULL,'MICHELLE YOUNG','FI','434190998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:24',0,'2014-03-02 04:45:37'),(508,508,'2014-01-01','ET','2',1,NULL,'Terry Capuano','FI','047365057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:43',0,'2014-03-01 15:48:04'),(11433,11433,'2014-01-01','ET','2',1,NULL,'Robert Cherewick','FI','371846286','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:38',0,'2014-03-10 13:52:32'),(3540,3540,'2014-01-01','ET','2',1,NULL,'Danielle M Davidson','FI','298500836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:29',0,'2014-03-01 15:37:30'),(10712,10712,'2014-01-01','ET','2',2,1,'GAYLE E MARTIN','FI','300625451','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:57',0,'2014-03-01 16:10:36'),(10584,10584,'2014-01-01','ET','2',1,NULL,'Jose L Zavala','FI','579984048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:41',0,'2014-03-02 04:24:47'),(12029,12029,'2014-01-01','ET','2',1,NULL,'ALBERT WILLIAM','FI','438985442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:12',0,'2014-03-02 04:59:36'),(22342,22992,'0000-00-00','ET','2',1,NULL,'Corey Mann','FI','295740136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:09',0,'2014-03-07 21:36:32'),(20923,21573,'0000-00-00','ET','2',1,NULL,'Vada Mack','FI','294661624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:00:15',0,'2014-03-01 18:08:07'),(17349,17999,'0000-00-00','ET','2',1,NULL,'Beverly Nunn','FI','460027931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:06',0,'2014-03-02 06:31:45'),(359,359,'2014-01-01','ET','2',2,1,'David Glasser','FI','547888793','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:04',0,'2014-03-01 15:21:15'),(19614,20264,'0000-00-00','ET','2',1,NULL,'stephen promen','FI','268569160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:37',0,'2014-03-01 17:47:19'),(7377,7377,'2014-01-01','ET','2',1,NULL,'James Kubik','FI','138623691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:05',0,'2014-03-02 04:10:25'),(1743,1743,'2014-01-01','ET','2',1,NULL,'Freda Diane Dickinson','FI','294562079','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:46',0,'2014-03-01 15:31:33'),(5388,5388,'2014-01-01','ET','2',1,NULL,'Maria G Ramirez','FI','457156577','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:08',0,'2014-03-01 21:11:04'),(2193,2193,'2014-01-01','ET','2',1,NULL,'Kristine Douglas-Korber','FI','204626895','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:57',0,'2014-03-10 15:39:19'),(4748,4748,'2014-01-01','ET','2',1,NULL,'Anthony Coleman','FI','436219873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:13',0,'2014-03-01 21:11:04'),(20764,21414,'0000-00-00','ET','2',1,NULL,'DAVID JONATHAN','FI','292598994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:41',0,'2014-03-01 18:08:07'),(4068,4068,'2014-01-01','ET','2',2,1,'Jesus Cantu','FI','462111177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:17',0,'2014-03-02 03:09:49'),(18188,18838,'0000-00-00','ET','2',1,NULL,'KOFI FOSU','FI','103844606','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','357','2014-03-01','Sync Success',0,'2014-02-11 21:01:43',0,'2014-03-01 17:26:36'),(18118,18768,'0000-00-00','ET','2',1,NULL,'LINDA LATSON','FI','449980055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:52',0,'2014-03-02 06:38:05'),(16521,17171,'0000-00-00','ET','2',2,1,'alma kersh','FI','428114734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:51',0,'2014-03-02 06:10:30'),(20775,21425,'0000-00-00','ET','2',2,1,'Stacey Hamric','FI','270709081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:46',0,'2014-03-01 18:10:11'),(19931,20581,'0000-00-00','ET','2',1,NULL,'Tommy a Slocum','FI','434575266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:23',0,'2014-03-02 07:03:25'),(4040,4040,'2014-01-01','ET','2',1,NULL,'Jeffrey Betty','FI','096642787','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:21',0,'2014-03-02 03:09:49'),(4719,4719,'2014-01-01','ET','2',1,NULL,'thomas wallis','94','0000481082','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:19',0,'2014-03-10 13:45:57'),(19275,19925,'0000-00-00','ET','2',3,2,'Mahin Fakhravar','FI','363253574','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:16',0,'2014-03-10 14:31:05'),(6003,6003,'2014-01-01','ET','2',1,NULL,'Margaret Williams','FI','278584944','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:02',0,'2014-03-10 13:03:33'),(5584,5584,'2014-01-01','ET','2',1,NULL,'Christopher Drennon','FI','450699592','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:08',0,'2014-03-02 04:45:37'),(5180,5180,'2014-01-01','ET','2',1,NULL,'Rebecca G Deatherage','FI','459802742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:42',0,'2014-03-02 00:10:48'),(17537,18187,'0000-00-00','ET','2',1,NULL,'DONALD ZIMMERS','FI','289644874','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:00:26',0,'2014-03-01 17:20:55'),(1497,1497,'2014-01-01','ET','2',1,NULL,'Mark R Kamper','FI','292546610','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:18',0,'2014-03-10 13:52:32'),(11243,11243,'2014-01-01','ET','2',2,1,'JACK CAMBRON','FI','297701393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:44',0,'2014-03-01 16:23:43'),(21753,22403,'0000-00-00','ET','2',1,NULL,'LINDSAY SOLOMON','FI','288945533','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-05-01','Sync Success',0,'2014-03-04 21:02:23',0,'2014-03-10 16:44:18'),(19941,20591,'0000-00-00','ET','2',1,NULL,'BOBETTE BURKE','FI','461192798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:08',0,'2014-03-02 07:03:25'),(18003,18653,'0000-00-00','ET','2',1,NULL,'Sarah Stewart','FI','435630866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:41',0,'2014-03-02 06:38:05'),(5897,5897,'2014-01-01','ET','2',1,NULL,'Stacey Johnson','FI','299903762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:30:40',0,'2014-03-01 15:48:04'),(17996,18646,'0000-00-00','ET','2',1,NULL,'jerlean neal','FI','426356098','Starmount Life Insurance Company','FI','720977315','leo  flemming','94','10085604','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:37',0,'2014-03-02 06:38:05'),(5470,5470,'2014-01-01','ET','2',1,NULL,'Olivia Cotton','FI','439595469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:27',0,'2014-03-02 04:45:37'),(3523,3523,'2014-01-01','ET','2',1,NULL,'Matthew  Odonnell','FI','300801388','Dental Care Plus, Inc.','FI','311185262','Jim   Toth','94','2345855','348','2014-01-01','Sync Success',0,'2013-12-25 22:01:54',0,'2014-03-01 15:37:30'),(4838,4838,'2014-01-01','ET','2',2,1,'DAVID  D BREEST','FI','270465688','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:14',0,'2014-03-01 15:10:22'),(17711,18361,'0000-00-00','ET','2',1,NULL,'GERALDINE ERWIN','FI','459082112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-24','Sync Success',0,'2014-02-09 19:00:10',0,'2014-03-02 06:31:45'),(16036,16685,'0000-00-00','ET','2',1,NULL,'Meredith Mullins','FI','632125289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:34',0,'2014-03-02 06:03:21'),(15850,16499,'0000-00-00','ET','2',1,NULL,'GUIOMAR DUNHAM','FI','590471511','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:40',0,'2014-03-01 16:56:22'),(213,213,'2014-01-01','ET','2',1,NULL,'Yvette Rachelle Hyde','FI','434494285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:42',0,'2014-03-01 22:10:55'),(22656,23306,'0000-00-00','ET','2',2,1,'MARCO ANTONIO CANALES','FI','453711394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:25',0,'2014-03-08 22:26:18'),(22555,23205,'0000-00-00','ET','2',1,NULL,'Deborah Blanton','FI','280583987','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:49',0,'2014-03-10 16:44:18'),(1099,1099,'2014-01-01','ET','2',1,NULL,'Jacqueline Hardisty','FI','546773417','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:59',0,'2014-03-01 15:05:09'),(6162,6162,'2014-01-01','ET','2',1,NULL,'Carmen Lenz','FI','641081154','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:12',0,'2014-03-02 04:10:25'),(5424,5424,'2014-01-01','ET','2',1,NULL,'isiah gillum','FI','438411622','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:06',0,'2014-03-01 20:10:57'),(2842,2842,'2014-01-01','ET','2',1,NULL,'Priscilla Velasco','FI','525890369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:45',0,'2014-03-02 04:15:49'),(5113,5113,'2014-01-01','ET','2',1,NULL,'Janice Matthews','FI','281568676','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 00:49:39',0,'2014-03-10 13:20:27'),(12493,12493,'2014-01-01','ET','2',1,NULL,'Vallerie Whitten','FI','587332819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:06',0,'2014-03-02 05:03:29'),(22255,22905,'0000-00-00','ET','2',1,NULL,'Mary Parker','FI','283548464','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:20',0,'2014-03-10 14:45:25'),(15275,15726,'0000-00-00','ET','2',1,NULL,'BOBETTE BURKE','FI','461192798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:04',0,'2014-03-02 05:52:31'),(16046,16695,'0000-00-00','ET','2',1,NULL,'Tonya Bartley','FI','272825121','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:40',0,'2014-03-10 16:24:30'),(16429,17079,'0000-00-00','ET','2',2,1,'CHARLES JONES','FI','092408370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:45',0,'2014-03-10 14:20:26'),(21398,22048,'0000-00-00','ET','2',1,NULL,'Comcepcion Lopez','FI','548917705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:00:10',0,'2014-03-03 21:25:18'),(21013,21663,'0000-00-00','ET','2',1,NULL,'LORNA BUSSEY','FI','436193095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:09',0,'2014-03-02 07:23:39'),(18641,19291,'0000-00-00','ET','2',1,NULL,'Kristen Bihr','FI','288900721','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:06',0,'2014-03-01 17:26:36'),(13395,13751,'2014-01-01','ET','2',1,NULL,'Ebaristo Torres','FI','457739696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:53',0,'2014-03-02 05:24:45'),(16632,17282,'0000-00-00','ET','2',1,NULL,'Sandra Bloomfield','FI','274502237','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:29',0,'2014-03-10 14:20:26'),(14637,15088,'2014-01-01','ET','2',1,NULL,'JAMES  V ARRIGO','FI','287741235','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:12',0,'2014-03-01 16:46:19'),(15475,15926,'0000-00-00','ET','2',4,3,'Mark Gruich','FI','279501208','Summa Insurance Company, Inc.','FI','341809108','Tim  Walters','94','1852658','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:56',0,'2014-03-10 16:17:47'),(19811,20461,'0000-00-00','ET','2',1,NULL,'BEATRIZ BENAVIDES','94','0000270459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:32',0,'2014-03-02 07:03:25'),(4069,4069,'2014-01-01','ET','2',1,NULL,'Olga Zeno','FI','581211756','Starmount Life Insurance Company','FI','720977315','Brian  Mulligan','94','8789743','348','2014-01-01','Sync Success',0,'2013-12-25 23:02:20',0,'2014-03-02 03:09:49'),(11127,11127,'2014-01-01','ET','2',2,1,'Timothy Bartee','FI','302721756','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:05',0,'2014-03-10 13:39:10'),(19104,19754,'0000-00-00','ET','2',1,NULL,'Deborah Barker','FI','296521236','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:47',0,'2014-03-01 17:34:07'),(18011,18661,'0000-00-00','ET','2',1,NULL,'Jacqueline Goedel','FI','275547774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:47',0,'2014-03-01 17:20:55'),(5401,5401,'2014-01-01','ET','2',1,NULL,'Joe Gamero','FI','456865286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:15',0,'2014-03-01 20:10:57'),(17653,18303,'0000-00-00','ET','2',1,NULL,'Saige McDonald','FI','462914727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-08 19:00:37',0,'2014-03-02 06:31:45'),(14597,15048,'2014-01-01','ET','2',1,NULL,'Jacob Jakuszeit','FI','278884939','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:48',0,'2014-03-01 16:46:19'),(3339,3339,'2014-01-01','ET','2',1,NULL,'JOAN  HAMM','FI','287584642','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:49',0,'2014-03-10 15:52:36'),(22809,23459,'0000-00-00','ET','2',1,NULL,'COLEY M CATES','FI','429595735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:59',0,'2014-03-09 21:26:00'),(10452,10452,'2014-01-01','ET','2',1,NULL,'Cole Cottrill','FI','272925790','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:22',0,'2014-03-01 16:10:36'),(21182,21832,'0000-00-00','ET','2',2,1,'APRIL COLEMAN','FI','426533633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:44',0,'2014-03-02 07:23:39'),(4794,4794,'2014-01-01','ET','2',1,NULL,'cynthia jones','FI','293702434','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:43',0,'2014-03-01 15:16:37'),(21003,21653,'0000-00-00','ET','2',1,NULL,'Linda Kindle','FI','459157141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:03',0,'2014-03-02 07:23:39'),(5608,5608,'2014-01-01','ET','2',1,NULL,'Emily Van','FI','457712345','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:53',0,'2014-03-01 16:23:43'),(11739,11739,'2014-01-01','ET','2',1,NULL,'JOHN E STUDEBAKER','FI','286587211','Dental Care Plus, Inc.','FI','311185262','DANIEL S ROBINS','94','184904','348','2014-02-01','Sync Success',1,'2013-12-29 11:09:05',0,'2014-03-01 16:30:17'),(19825,20475,'0000-00-00','ET','2',2,1,'Richard Rettinger','FI','443601503','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:43',0,'2014-03-02 07:03:25'),(13111,13467,'2014-01-01','ET','2',3,2,'Quynh Nguyen','FI','586384514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:24',0,'2014-03-02 05:17:40'),(19650,20300,'0000-00-00','ET','2',2,1,'EMILY GARZA','FI','280843026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:43:22',0,'2014-03-01 17:47:19'),(17232,17882,'0000-00-00','ET','2',1,NULL,'DIANE BROWNNEHLEN','FI','276684578','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:22',0,'2014-03-10 16:24:30'),(19631,20281,'0000-00-00','ET','2',1,NULL,'tabitha kunsman','FI','301747143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:38:15',0,'2014-03-01 17:47:19'),(47,47,'2014-01-01','ET','2',1,NULL,'Maria Getz','FI','301680204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:24',0,'2014-03-01 15:21:15'),(19840,20490,'0000-00-00','ET','2',1,NULL,'kwame perry','FI','455876843','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-06','Sync Success',0,'2014-02-20 22:00:57',0,'2014-03-02 06:59:07'),(10574,10574,'2014-01-01','ET','2',1,NULL,'Beverly Lewis','FI','451960933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:20',0,'2014-03-02 04:24:47'),(1149,1149,'2014-01-01','ET','2',1,NULL,'Andrea Hale-Arnold','FI','290748958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:10',0,'2014-03-02 04:38:08'),(1321,1321,'2014-01-01','ET','2',1,NULL,'vera houser','FI','258497778','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:29',0,'2014-03-02 04:38:08'),(6300,6300,'2014-01-01','ET','2',1,NULL,'Jametria Irvin','FI','587656338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:25',0,'2014-03-02 04:10:25'),(14850,15301,'2014-01-01','ET','2',1,NULL,'Dianna Hendrix','FI','457799591','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:01',0,'2014-03-02 05:45:37'),(12408,12408,'2014-01-01','ET','2',1,NULL,'Theresa M Jones','FI','282504032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:56',0,'2014-03-01 16:35:14'),(122,122,'2014-01-01','ET','2',1,NULL,'Sheryl Bittinger','FI','299523758','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:45',0,'2014-03-10 15:45:56'),(1345,1345,'2014-01-01','ET','2',1,NULL,'Areniqua White','FI','464777281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:15',0,'2014-03-02 04:38:08'),(22849,23499,'0000-00-00','ET','2',1,NULL,'Monique Rodriguez','FI','462556793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:02',0,'2014-03-10 21:27:11'),(18101,18751,'0000-00-00','ET','2',1,NULL,'JOHN KELLY CHRISTENSEN','FI','529866236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:39',0,'2014-03-02 06:38:05'),(17243,17893,'0000-00-00','ET','2',3,2,'robert kennedy','FI','281800588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:27',0,'2014-03-01 17:20:55'),(10609,10609,'2014-01-01','ET','2',1,NULL,'Maria Castillo','FI','453892414','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','357','2014-01-01','Sync Success',0,'2013-12-26 12:57:28',0,'2014-03-02 04:24:47'),(16667,17317,'0000-00-00','ET','2',1,NULL,'TAFFY BRADFORD','FI','291806875','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:53',0,'2014-03-01 17:00:58'),(16275,16925,'0000-00-00','ET','2',1,NULL,'Oscar Moore','FI','435311327','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:07',0,'2014-03-02 06:10:30'),(7469,7469,'2014-01-01','ET','2',1,NULL,'IMOGENE ECKLAND','FI','569784024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:56',0,'2014-03-02 04:15:49'),(15500,15951,'0000-00-00','ET','2',1,NULL,'Kevin Moeller','FI','280887124','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:51',0,'2014-03-01 16:50:53'),(1273,1273,'2014-01-01','ET','2',1,NULL,'Cynthia Bailey','FI','271681938','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:56',0,'2014-03-01 16:23:43'),(11079,11079,'2014-01-01','ET','2',1,NULL,'Pearl Young','FI','268546206','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-26 13:13:26',0,'2014-03-10 13:45:57'),(11324,11324,'2014-01-01','ET','2',1,NULL,'nilofer virani','FI','629486845','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:14',0,'2014-03-02 04:52:44'),(11526,11526,'2014-01-01','ET','2',1,NULL,'AMELIA DAWN LAMBERT','FI','267571872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:26',0,'2014-03-02 04:52:44'),(11565,11565,'2014-01-01','ET','2',1,NULL,'Floydie Williams-Moore','94','0000371999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:40',0,'2014-03-02 04:52:44'),(5872,5872,'2014-01-01','ET','2',2,1,'Selwyn Cooper','FI','419965913','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:00',0,'2014-03-01 15:05:09'),(5800,5800,'2014-01-01','ET','2',1,NULL,'Tammy McKinney','FI','449335618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:31',0,'2014-03-02 01:10:33'),(1792,1792,'2014-01-01','ET','2',1,NULL,'JoAnna Hirt','FI','268646109','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:22',0,'2014-03-10 13:20:27'),(3399,3399,'2014-01-01','ET','2',1,NULL,'Tereasa Griffith','FI','275763673','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:51:40',0,'2014-03-10 13:24:34'),(4910,4910,'2014-01-01','ET','2',1,NULL,'JAMES MILLS','FI','289840193','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:29',0,'2014-03-10 13:03:33'),(3806,3806,'2014-01-01','ET','2',2,1,'Michelle Sanders  Turner','FI','433417719','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:31',0,'2014-03-01 23:10:52'),(4697,4697,'2014-01-01','ET','2',1,NULL,'Marguerite Kelly','FI','251022755','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:34',0,'2014-03-02 04:31:46'),(4651,4651,'2014-01-01','ET','2',2,1,'nathan lawson','FI','301726739','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:56',0,'2014-03-10 13:45:57'),(4443,4443,'2014-01-01','ET','2',2,1,'erlin crochet','FI','439942861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:10',0,'2014-03-01 21:11:04'),(12616,12616,'2014-01-01','ET','2',1,NULL,'Stephanie Cobb','FI','539909475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:40',0,'2014-03-02 05:10:52'),(12772,12772,'2014-01-01','ET','2',1,NULL,'Teena Stambaugh','FI','297661269','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:10',0,'2014-03-01 16:35:14'),(15113,15564,'0000-00-00','ET','2',1,NULL,'kenneth smalley','FI','273446258','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:05:59',0,'2014-03-10 14:10:12'),(20716,21366,'0000-00-00','ET','2',2,1,'linda hummel','FI','302687803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:19',0,'2014-03-01 18:08:07'),(20933,21583,'0000-00-00','ET','2',3,2,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:24',0,'2014-03-10 16:38:05'),(23045,23695,'0000-00-00','ET','2',1,NULL,'Valerie Jones','FI','426964947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:02:25',0,'2014-03-10 21:27:11'),(542,542,'2014-01-01','ET','2',1,NULL,'Michelle Furlong','FI','291882920','Dental Care Plus, Inc.','FI','311185262','Jennifer  Kauffman','94','8707930','348','2014-01-01','Sync Success',0,'2013-12-25 18:01:46',0,'2014-03-01 15:48:04'),(11937,11937,'2014-01-01','ET','2',1,NULL,'John Claiborne','FI','587987488','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:12',0,'2014-03-02 04:59:36'),(673,673,'2014-01-01','ET','2',2,1,'GAYLE E MARTIN','FI','300625451','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:52',0,'2014-03-10 15:52:36'),(1688,1688,'2014-01-01','ET','2',2,1,'Heather Renee Jolliff','FI','268804533','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:07',0,'2014-03-01 15:31:33'),(2807,2807,'2014-01-01','ET','2',1,NULL,'Hollie Stephens','FI','285864901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:20:33',0,'2014-03-01 16:05:34'),(6352,6352,'2014-01-01','ET','2',1,NULL,'billy myers','FI','280500499','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:57',0,'2014-03-10 13:39:10'),(5621,5621,'2014-01-01','ET','2',3,2,'kenneth devereux','FI','302582133','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:24',0,'2014-03-10 16:03:49'),(4720,4720,'2014-01-01','ET','2',1,NULL,'Donna Jensen','94','0000781906','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:20',0,'2014-03-10 13:45:57'),(3948,3948,'2014-01-01','ET','2',1,NULL,'Anna E Lopez','FI','639103929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:28',0,'2014-03-01 23:10:52'),(12678,12678,'2014-01-01','ET','2',1,NULL,'ROSEANN MCGURR','FI','301563577','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:56',0,'2014-03-01 16:35:14'),(13167,13523,'2014-01-01','ET','2',1,NULL,'STANLEY J GRIFFIN','FI','382686817','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:31',0,'2014-03-10 13:59:38'),(13226,13582,'2014-01-01','ET','2',1,NULL,'Andrea Branch','FI','385139519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:06',0,'2014-03-02 05:17:40'),(14497,14948,'2014-01-01','ET','2',1,NULL,'Craig Good','FI','271661745','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:51',0,'2014-03-10 14:03:26'),(19388,20038,'0000-00-00','ET','2',1,NULL,'LUIS ROJAS','FI','598070785','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:59',0,'2014-03-01 17:34:07'),(19569,20219,'0000-00-00','ET','2',1,NULL,'shelli friend','FI','294608233','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:23:05',0,'2014-03-10 14:37:47'),(19697,20347,'0000-00-00','ET','2',1,NULL,'ANTOINETTE M KOMYATI','FI','287642324','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:54:12',0,'2014-03-10 16:31:33'),(21720,22370,'0000-00-00','ET','2',2,1,'Gerald D Luttrell','FI','296501360','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:55',0,'2014-03-10 16:44:18'),(22045,22695,'0000-00-00','ET','2',1,NULL,'DEAN WOLFF','FI','364740976','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:24',0,'2014-03-10 14:45:25'),(22285,22935,'0000-00-00','ET','2',1,NULL,'Charles Goins','FI','290425417','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:42',0,'2014-03-10 14:50:59'),(4,4,'2014-01-01','ET','2',1,NULL,'Michael Baker','FI','310885469','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:08',0,'2014-03-01 15:21:15'),(11322,11322,'2014-01-01','ET','2',2,1,'KHIEM LE','FI','325901826','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:09',0,'2014-03-02 04:52:44'),(10917,10917,'2014-01-01','ET','2',1,NULL,'Jake B Ferlito','FI','302862367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:12',0,'2014-03-10 16:03:49'),(10546,10546,'2014-01-01','ET','2',4,3,'Michael Legg','FI','591706615','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:23',0,'2014-03-02 04:15:49'),(7683,7683,'2014-01-01','ET','2',1,NULL,'JOHN HOLTKAMP','FI','274540492','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:55',0,'2014-03-10 13:39:10'),(1591,1591,'2014-01-01','ET','2',2,1,'James Rich','FI','451851079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:59',0,'2014-03-01 20:10:57'),(5772,5772,'2014-01-01','ET','2',2,1,'jose barron','FI','636013030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:37',0,'2014-03-02 01:10:33'),(5641,5641,'2014-01-01','ET','2',1,NULL,'Bryson Creppel','FI','439611003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:02',0,'2014-03-02 04:45:37'),(2032,2032,'2014-01-01','ET','2',1,NULL,'DEREK BROWN','FI','425291754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:52',0,'2014-03-01 23:10:52'),(2068,2068,'2014-01-01','ET','2',2,1,'Daniel McCormick','FI','276486827','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:02',0,'2014-03-10 13:20:27'),(4466,4466,'2014-01-01','ET','2',5,4,'Douglas Holloway','FI','299600256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:55',0,'2014-03-01 15:16:37'),(4217,4217,'2014-01-01','ET','2',2,1,'Sara L Stein','FI','279421493','Dental Care Plus, Inc.','FI','311185262','Ronald J Fleeter','94','1834226','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:44',0,'2014-03-01 15:52:44'),(12612,12612,'2014-01-01','ET','2',1,NULL,'RAUL CISNEROS','FI','452911012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:31',0,'2014-03-02 05:10:52'),(14489,14940,'2014-01-01','ET','2',1,NULL,'kody king','FI','434735898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:47',0,'2014-03-02 05:38:34'),(16145,16794,'0000-00-00','ET','2',1,NULL,'brianna johnson','FI','409674283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:05',0,'2014-03-02 06:03:21'),(16461,17111,'0000-00-00','ET','2',1,NULL,'Daniel Harold Detrick','FI','298608869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:13',0,'2014-03-01 17:00:58'),(17036,17686,'0000-00-00','ET','2',1,NULL,'James Davis','FI','437572488','Starmount Life Insurance Company','FI','720977315','Mary  Siggers','94','15257239','357','2014-03-01','Sync Success',0,'2014-02-04 21:00:21',0,'2014-03-02 06:24:38'),(17835,18485,'0000-00-00','ET','2',1,NULL,'chanda stuard','FI','453810328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:03',0,'2014-03-02 06:10:30'),(18010,18660,'0000-00-00','ET','2',1,NULL,'Delilah Olena Jackson','FI','276548041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:46',0,'2014-03-01 17:20:55'),(18474,19124,'0000-00-00','ET','2',1,NULL,'Rae Wilson','FI','295865039','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:53',0,'2014-03-10 14:24:38'),(18569,19219,'0000-00-00','ET','2',1,NULL,'marna elzinga','94','0001205854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:08',0,'2014-03-01 17:26:36'),(19292,19942,'0000-00-00','ET','2',1,NULL,'LATOYA CHEATHAM','FI','275901991','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:13',0,'2014-03-10 16:31:33'),(19424,20074,'0000-00-00','ET','2',1,NULL,'MICHAEL A SAUCIER','FI','587386764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:27',0,'2014-03-02 06:59:07'),(19602,20252,'0000-00-00','ET','2',1,NULL,'joe george','FI','302529474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:32:49',0,'2014-03-01 17:34:07'),(21192,21842,'0000-00-00','ET','2',1,NULL,'Jacob King','FI','296781530','HealthSpan','FI','311431434','Bernadine  Kirian','94','11391349','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:53',0,'2014-03-10 14:45:25'),(21196,21846,'0000-00-00','ET','2',1,NULL,'JERRY SHOFFSTALL','FI','300482013','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:57',0,'2014-03-10 14:45:25'),(22472,23122,'0000-00-00','ET','2',1,NULL,'Natasha Gibson','FI','297943152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:51',0,'2014-03-07 21:36:32'),(823,823,'2014-01-01','ET','2',1,0,'lyra raimey','FI','280645170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:03',0,'2014-03-01 15:05:09'),(11355,11355,'2014-01-01','ET','2',1,NULL,'Tabatha Lyons','FI','425699362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:12',0,'2014-03-02 04:52:44'),(11134,11134,'2014-01-01','ET','2',2,1,'Brian Homer','FI','277885161','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:20',0,'2014-03-10 13:39:10'),(1252,1252,'2014-01-01','ET','2',2,1,'Tracy Jean Doeding','FI','277565943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:15',0,'2014-03-01 16:15:39'),(12172,12172,'2014-01-01','ET','2',1,NULL,'Jillian James','FI','439638158','Starmount Life Insurance Company','FI','720977315','Keith c Smith','94','4698601','348','2014-02-01','Sync Success',0,'2014-01-01 12:08:12',0,'2014-03-02 05:03:29'),(389,389,'2014-01-01','ET','2',1,NULL,'KARL MICHAEL OBYRON JONES','FI','439730747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:02',0,'2014-03-01 22:10:55'),(23103,23753,'0000-00-00','ET','2',1,NULL,'Maxine Brooks','FI','300487753','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:05',0,'2014-03-10 22:17:01'),(271,271,'2014-01-01','ET','2',2,1,'Harry Michael Covert','FI','274602791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:37',0,'2014-03-01 15:05:09'),(19073,19723,'0000-00-00','ET','2',1,NULL,'JANE EDGAR','FI','615150549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:24',0,'2014-03-02 06:52:12'),(13586,13942,'2014-01-01','ET','2',2,1,'Julie Stevens','FI','220270434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:14',0,'2014-03-02 05:31:31'),(18493,19143,'0000-00-00','ET','2',2,1,'Robert Walkerow','FI','283486765','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:04',0,'2014-03-10 16:31:33'),(13228,13584,'2014-01-01','ET','2',1,NULL,'willis lecorchick','FI','284728788','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:12',0,'2014-03-10 16:10:34'),(16988,17638,'0000-00-00','ET','2',1,NULL,'Michael Schackmann','FI','302881828','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-03 21:01:21',0,'2014-03-10 14:20:26'),(12015,12015,'2014-01-01','ET','2',1,NULL,'Virgil Horn','FI','323508358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:39',0,'2014-03-02 04:59:36'),(4181,4181,'2014-01-01','ET','2',2,1,'MICHELLE ANN BORES','FI','271807016','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:37',0,'2014-03-10 15:59:47'),(22778,23428,'0000-00-00','ET','2',2,1,'KEVIN STAIRS','FI','302782200','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:32',0,'2014-03-09 21:35:27'),(22848,23498,'0000-00-00','ET','2',1,NULL,'Francisca Davila','FI','595685657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:00:02',0,'2014-03-10 21:27:11'),(21897,22547,'0000-00-00','ET','2',1,NULL,'Blake Harris','FI','450758584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:42',0,'2014-03-05 22:27:33'),(20768,21418,'0000-00-00','ET','2',1,NULL,'Karen Metcalf','FI','290768647','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:43',0,'2014-03-01 18:08:07'),(16368,17018,'0000-00-00','ET','2',1,NULL,'BRIAN J WESTFALL','FI','286607306','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:05',0,'2014-03-10 16:24:30'),(12693,12693,'2014-01-01','ET','2',1,NULL,'Ronda Huff','FI','288560395','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:30',0,'2014-03-10 16:10:34'),(22661,23311,'0000-00-00','ET','2',1,NULL,'Catherine Hanyon','FI','098402347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:28',0,'2014-03-08 22:26:18'),(12419,12419,'2014-01-01','ET','2',1,NULL,'BOBBY K BURNLEY','FI','437945213','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:21',0,'2014-03-02 05:03:29'),(11370,11370,'2014-01-01','ET','2',1,NULL,'MANZY CLARK','FI','434765399','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:38',0,'2014-03-02 04:45:37'),(5349,5349,'2014-01-01','ET','2',1,NULL,'ROBIN L YOST','FI','294766777','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:50',0,'2014-03-10 15:39:19'),(505,505,'2014-01-01','ET','2',1,NULL,'philip g makar','FI','298725236','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:37',0,'2014-03-01 15:48:04'),(3454,3454,'2014-01-01','ET','2',2,1,'Timothy Mohon','FI','412232677','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:28',0,'2014-03-10 13:32:15'),(21801,22451,'0000-00-00','ET','2',2,1,'Linda M Spencer','FI','292509830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:17',0,'2014-03-04 21:36:30'),(21381,22031,'0000-00-00','ET','2',1,NULL,'Scott Grigsby','94','0000338847','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 01:30:00',0,'2014-03-10 16:38:05'),(20894,21544,'0000-00-00','ET','2',1,NULL,'Michael Brockman','FI','301469273','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:42',0,'2014-03-10 14:45:25'),(20821,21471,'0000-00-00','ET','2',1,NULL,'Angelica R Villa','FI','453212874','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:08',0,'2014-03-02 07:17:36'),(7302,7302,'2014-01-01','ET','2',2,1,'RAKESHKUMAR MAISURIA','FI','665774479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:46',0,'2014-03-02 03:09:49'),(18116,18766,'0000-00-00','ET','2',2,1,'Wayne Sweely','FI','301546496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:50',0,'2014-03-02 06:38:05'),(6183,6183,'2014-01-01','ET','2',1,NULL,'ELIDA HERNANDEZ','FI','467947712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:48',0,'2014-03-02 04:10:25'),(1706,1706,'2014-01-01','ET','2',1,NULL,'Elizabeth Canterbury','FI','434216690','NOT AVAILABLE','FI','123456789','Patricia  Freeman','94','4700588','348','2014-01-01','Received',0,'2013-12-25 19:16:41',NULL,NULL),(3293,3293,'2014-01-01','ET','2',2,1,'Andrew Fineran','FI','199669784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:14',0,'2014-03-01 15:48:04'),(4630,4630,'2014-01-01','ET','2',1,NULL,'Rene Flores','FI','467638707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:15',0,'2014-03-02 04:31:46'),(14769,15220,'2014-01-01','ET','2',1,NULL,'Aubrey Zeppa','FI','455715736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:38',0,'2014-03-02 05:45:37'),(11460,11460,'2014-01-01','ET','2',1,NULL,'Laverne Hollingsworth-Christian','FI','132645646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:30:29',0,'2014-03-01 16:30:17'),(11662,11662,'2014-01-01','ET','2',1,NULL,'Catherine Hier','FI','294543078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:39',0,'2014-03-01 16:30:17'),(11755,11755,'2014-01-01','ET','2',2,1,'ROSE MILLER','FI','439313819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:35',0,'2014-03-02 04:59:36'),(13276,13632,'2014-01-01','ET','2',1,NULL,'David Swallow','FI','439754069','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:03',0,'2014-03-02 05:24:45'),(13717,14073,'2014-01-01','ET','2',1,NULL,'Willard Thompson','FI','435855598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:52',0,'2014-03-02 05:24:45'),(222,222,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:22:02',0,'2014-03-10 13:10:24'),(21096,21746,'0000-00-00','ET','2',1,NULL,'Adrian Aguilar','FI','631202882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:44',0,'2014-03-02 07:23:39'),(892,892,'2014-01-01','ET','2',1,NULL,'Esther Curtis','FI','521820365','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:54',0,'2014-03-01 15:21:15'),(22373,23023,'0000-00-00','ET','2',1,NULL,'Linda Wynns','FI','446521441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:22',0,'2014-03-07 21:25:22'),(961,961,'2014-01-01','ET','2',1,NULL,'LANA DEANN RAMOS','FI','437534102','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:59',0,'2014-03-01 22:10:55'),(20560,21210,'0000-00-00','ET','2',2,1,'Toni Hurt','FI','464130671','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:23',0,'2014-03-02 07:17:36'),(20477,21127,'0000-00-00','ET','2',2,1,'ANN JACOBS','FI','269522652','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:28',0,'2014-03-01 18:08:07'),(17980,18630,'0000-00-00','ET','2',1,NULL,'Douglas Millman','FI','289486132','HealthSpan','FI','311431434','Paul  Sullivan','94','3667671','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:25',0,'2014-03-10 14:24:38'),(16279,16929,'0000-00-00','ET','2',2,1,'muhammad islah ud din','FI','504476614','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:09',0,'2014-03-02 06:10:30'),(15742,16391,'0000-00-00','ET','2',1,NULL,'Richard Riffle','FI','372589679','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:17',0,'2014-03-10 14:10:12'),(15084,15535,'0000-00-00','ET','2',1,NULL,'CECILIA LIPP','FI','269505572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:38',0,'2014-03-01 16:50:53'),(12780,12780,'2014-01-01','ET','2',1,NULL,'CHARLES  MAURICE  LIKE','FI','456786438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:31',0,'2014-03-02 05:10:52'),(12326,12326,'2014-01-01','ET','2',2,1,'Tuyen nguyen','FI','445821511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:03',0,'2014-03-02 05:03:29'),(5292,5292,'2014-01-01','ET','2',1,NULL,'Marco Napier','FI','290704939','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:08',0,'2014-03-01 15:10:22'),(22768,23418,'0000-00-00','ET','2',1,NULL,'Carl Taylor','FI','409947268','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:24',0,'2014-03-09 21:26:00'),(5853,5853,'2014-01-01','ET','2',2,1,'Robert DeCastro','FI','282806020','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:14',0,'2014-03-10 15:39:19'),(2391,2391,'2014-01-01','ET','2',2,1,'mattie ward','FI','449065015','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:55',0,'2014-03-01 23:10:52'),(10505,10505,'2014-01-01','ET','2',2,1,'alonzo tyler','FI','271583616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:02',0,'2014-03-01 16:15:39'),(1907,1907,'2014-01-01','ET','2',1,NULL,'Michael Duncan','FI','439298281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:59',0,'2014-03-01 23:10:52'),(21535,22185,'0000-00-00','ET','2',1,NULL,'Marcus Turella','FI','452879800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:20',0,'2014-03-03 22:26:43'),(10398,10398,'2014-01-01','ET','2',1,NULL,'CYNTHIA JEAN MILETI','FI','278604882','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:40',0,'2014-03-01 16:10:36'),(4751,4751,'2014-01-01','ET','2',2,1,'THOMAS J GASPER','FI','437674106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:20',0,'2014-03-01 21:11:04'),(6299,6299,'2014-01-01','ET','2',1,NULL,'Jerry Simmons','FI','587680870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:23',0,'2014-03-02 04:10:25'),(21247,21897,'0000-00-00','ET','2',1,NULL,'patricia flanagan','FI','558330427','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:29',0,'2014-03-10 14:45:25'),(19158,19808,'0000-00-00','ET','2',1,NULL,'Alesia Simpson','FI','431736195','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:30',0,'2014-03-02 06:52:12'),(17190,17840,'0000-00-00','ET','2',1,NULL,'Joseph Washock','FI','291661827','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:00:03',0,'2014-03-01 17:20:55'),(22930,23580,'0000-00-00','ET','2',1,NULL,'Marc Quiroz','FI','436432032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:03',0,'2014-03-10 21:27:11'),(458,458,'2014-01-01','ET','2',1,NULL,'Richard Tuttle','FI','288466333','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:14',0,'2014-03-10 13:10:24'),(21384,22034,'0000-00-00','ET','2',2,1,'APRIL MILLER','FI','521114881','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:01',0,'2014-03-03 21:36:16'),(19056,19706,'0000-00-00','ET','2',1,NULL,'susan beals','FI','420801183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:13',0,'2014-03-02 06:52:12'),(7417,7417,'2014-01-01','ET','2',1,NULL,'Liza Gascot-Barroso','FI','581612076','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:25',0,'2014-03-02 04:15:49'),(7148,7148,'2014-01-01','ET','2',1,NULL,'Timothy Aylward','FI','275664997','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:02',0,'2014-03-10 15:59:47'),(14785,15236,'2014-01-01','ET','2',1,NULL,'Joelle Knight','FI','425639407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:48',0,'2014-03-02 05:45:37'),(14388,14839,'2014-01-01','ET','2',1,NULL,'Remi Miller Holt','94','0001025514','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:01',0,'2014-03-01 16:46:19'),(11821,11821,'2014-01-01','ET','2',1,NULL,'Ryan Hohman','FI','299885646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:47',0,'2014-03-01 16:15:39'),(3590,3590,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:03',0,'2014-03-02 01:10:33'),(3535,3535,'2014-01-01','ET','2',1,NULL,'JUDITH SCHLIESMAN','FI','271501823','Dental Care Plus, Inc.','FI','311185262','SCOTT  HAGGARD','94','2755029','348','2014-01-01','Sync Success',0,'2013-12-25 22:02:19',0,'2014-03-01 15:37:30'),(22655,23305,'0000-00-00','ET','2',1,NULL,'Jaime Lerma','FI','467960079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:24',0,'2014-03-08 22:26:18'),(21327,21977,'0000-00-00','ET','2',1,NULL,'teresa crawford','FI','520928498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:11',0,'2014-03-03 01:07:25'),(21070,21720,'0000-00-00','ET','2',3,2,'Elizabeth Capotosto','FI','293681683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:27',0,'2014-03-01 18:10:11'),(1030,1030,'2014-01-01','ET','2',1,NULL,'Nancy Wilson','FI','269546541','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:11',0,'2014-03-10 13:10:24'),(1094,1094,'2014-01-01','ET','2',1,NULL,'helen calderone','FI','409374633','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:48',0,'2014-03-10 13:03:33'),(5416,5416,'2014-01-01','ET','2',1,NULL,'Jessica Gound','FI','438512625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:51',0,'2014-03-01 15:10:22'),(18621,19271,'0000-00-00','ET','2',1,NULL,'Lynn Miller','FI','286548993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:51',0,'2014-03-01 17:26:36'),(4370,4370,'2014-01-01','ET','2',1,NULL,'jayne kitzmiller','FI','290625333','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:11:25',0,'2014-03-10 13:32:15'),(3956,3956,'2014-01-01','ET','2',1,NULL,'Abraham Arreola','FI','642168754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:45',0,'2014-03-01 23:10:52'),(18122,18772,'0000-00-00','ET','2',1,NULL,'tawana bell','FI','452250119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:55',0,'2014-03-02 06:38:05'),(17222,17872,'0000-00-00','ET','2',1,NULL,'DIANA STIDHAM','FI','297507205','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:17',0,'2014-03-01 17:20:55'),(3015,3015,'2014-01-01','ET','2',1,NULL,'Teresa Johnson','FI','278501356','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:35',0,'2014-03-10 15:52:36'),(2436,2436,'2014-01-01','ET','2',2,1,'Dinesh Patel','FI','342686246','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:21',0,'2014-03-10 13:10:24'),(11674,11674,'2014-01-01','ET','2',1,NULL,'james held','FI','283686511','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-28 03:37:04',NULL,NULL),(15689,16338,'0000-00-00','ET','2',1,NULL,'Roel  Gonzalez','FI','461614462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:41',0,'2014-03-02 05:59:43'),(15236,15687,'0000-00-00','ET','2',1,NULL,'Tamera Joyce Gerhard','FI','293686173','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:17',0,'2014-03-10 14:10:12'),(14963,15414,'2014-01-01','ET','2',1,NULL,'Joshua Asher','FI','292806079','Dental Care Plus, Inc.','FI','311185262','Warren  McDonald','94','7863806','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:54',0,'2014-03-01 16:50:53'),(14982,15433,'2014-01-01','ET','2',1,NULL,'DANI YUN GROSSMAN','94','0001008967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:03',0,'2014-03-01 16:50:53'),(1343,1343,'2014-01-01','ET','2',2,1,'Tony Collins','FI','241848749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:10',0,'2014-03-02 04:38:08'),(1503,1503,'2014-01-01','ET','2',1,NULL,'Carolynda Dortch','FI','270503655','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:27',0,'2014-03-10 16:03:49'),(3941,3941,'2014-01-01','ET','2',1,NULL,'gladys mae dillard','FI','437981386','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:15',0,'2014-03-01 23:10:52'),(20239,20889,'0000-00-00','ET','2',2,1,'Michael Anders','FI','278663174','HealthSpan','FI','311431434','Ty  Cramer','94','8741868','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:00',0,'2014-03-10 14:37:47'),(5212,5212,'2014-01-01','ET','2',1,NULL,'Pamela Branning','FI','219583907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:45',0,'2014-03-02 00:10:48'),(14156,14607,'2014-01-01','ET','2',1,NULL,'ellender k tillman','FI','436350481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:10',0,'2014-03-02 05:38:34'),(14201,14652,'2014-01-01','ET','2',1,NULL,'Lois AUZENNE','FI','464047941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:40',0,'2014-03-02 05:38:34'),(18702,19352,'0000-00-00','ET','2',1,NULL,'Rebecca Duplantis','FI','433728367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:54',0,'2014-03-02 06:45:14'),(15836,16485,'0000-00-00','ET','2',1,NULL,'Angela christine haywood','FI','263993180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:32',0,'2014-03-01 16:56:22'),(16202,16851,'0000-00-00','ET','2',1,NULL,'Brenda Shivers','FI','437925890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:40',0,'2014-03-02 06:10:30'),(688,688,'2014-01-01','ET','2',2,1,'Robert Swanson','FI','185402971','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:21',0,'2014-03-10 15:52:36'),(11103,11103,'2014-01-01','ET','2',1,NULL,'Paul Egli','FI','482929244','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:14:13',0,'2014-03-10 13:45:57'),(11836,11836,'2014-01-01','ET','2',1,NULL,'Gayla Kirshner','FI','460815690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:15',0,'2014-03-02 04:31:46'),(1041,1041,'2014-01-01','ET','2',1,NULL,'nathaniel lomax','FI','268781546','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:34',0,'2014-03-10 13:10:24'),(7598,7598,'2014-01-01','ET','2',1,NULL,'James Martin','FI','289889108','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:14',0,'2014-03-10 15:59:47'),(1293,1293,'2014-01-01','ET','2',1,NULL,'Jimmy Lenaz','FI','587483019','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:35',0,'2014-03-02 04:38:08'),(20364,21014,'0000-00-00','ET','2',2,1,'Charley Mae Tart','FI','427278248','Starmount Life Insurance Company','FI','720977315','Kevin G Turner','94','7821904','348','2014-04-01','Sync Success',0,'2014-02-26 08:30:50',0,'2014-03-02 07:03:25'),(18624,19274,'0000-00-00','ET','2',1,NULL,'LATOYA A ALBERT','FI','284705889','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:54',0,'2014-03-01 17:26:36'),(15453,15904,'0000-00-00','ET','2',1,NULL,'COREY CHEEK','FI','294721593','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:44',0,'2014-03-01 16:50:53'),(3224,3224,'2014-01-01','ET','2',4,3,'Robert Kington','FI','284543189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:02',0,'2014-03-01 15:52:44'),(2879,2879,'2014-01-01','ET','2',1,NULL,'AMY HO','FI','284983742','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:58',0,'2014-03-10 13:39:10'),(1951,1951,'2014-01-01','ET','2',1,NULL,'stephen gillenwater','FI','280541887','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:15',0,'2014-03-01 15:26:40'),(20501,21151,'0000-00-00','ET','2',1,NULL,'Linh Nguyen','FI','659145151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:44',0,'2014-03-02 07:10:28'),(21446,22096,'0000-00-00','ET','2',2,1,'Robert Dugger','FI','270503432','Summa Insurance Company, Inc.','FI','341809108','William  Phillips','94','3237932','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:16',0,'2014-03-10 16:44:18'),(21505,22155,'0000-00-00','ET','2',1,NULL,'Stevie Joe Taylor','FI','461028487','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:58',0,'2014-03-03 22:26:43'),(21781,22431,'0000-00-00','ET','2',1,NULL,'wendy beane','FI','289903920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:46',0,'2014-03-10 16:44:18'),(22169,22819,'0000-00-00','ET','2',1,NULL,'AMY WINANS','FI','298869042','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:17',0,'2014-03-06 21:36:23'),(22644,23294,'0000-00-00','ET','2',1,NULL,'Sharon Shafer','FI','288447017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:15',0,'2014-03-08 21:35:36'),(23008,23658,'0000-00-00','ET','2',1,NULL,'Edward Russell','FI','299844799','HealthSpan','FI','311431434','Robert  Colaianni','94','16444219','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:57',0,'2014-03-10 21:17:52'),(312,312,'2014-01-01','ET','2',1,NULL,'Debra Lynn Foster','FI','461154539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:34',0,'2014-03-01 22:10:55'),(14554,15005,'2014-01-01','ET','2',1,NULL,'PAULA NOEL','FI','466762347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:21',0,'2014-03-02 05:45:37'),(13268,13624,'2014-01-01','ET','2',1,NULL,'Jesse Brooks','FI','434792013','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:59',0,'2014-03-02 05:24:45'),(13237,13593,'2014-01-01','ET','2',1,NULL,'Aaron Hodge','FI','277709962','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:34',0,'2014-03-01 16:35:14'),(13205,13561,'2014-01-01','ET','2',2,1,'DONALD  PARMITER','FI','277485398','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:14',0,'2014-03-01 16:35:14'),(12238,12238,'2014-01-01','ET','2',1,NULL,'David Mossey','FI','436632253','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:58',0,'2014-03-02 05:10:52'),(12003,12003,'2014-01-01','ET','2',2,1,'TESSA KANUCKLE','FI','278888617','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:09',0,'2014-03-10 16:10:34'),(4682,4682,'2014-01-01','ET','2',2,1,'DUMITRU MARACINE','FI','634092861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:01',0,'2014-03-02 04:31:46'),(4014,4014,'2014-01-01','ET','2',1,NULL,'Angelica Gonzales','FI','450939559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:33',0,'2014-03-02 03:09:49'),(720,720,'2014-01-01','ET','2',2,1,'Richard Whiteleather','FI','285520339','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:25',0,'2014-03-10 15:52:36'),(15843,16492,'0000-00-00','ET','2',1,NULL,'Sharon Bistrek','FI','300684695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:36',0,'2014-03-01 16:56:22'),(17298,17948,'0000-00-00','ET','2',1,NULL,'Timothy Odom','FI','437430313','Starmount Life Insurance Company','FI','720977315','Tabitha Talley Hendon','94','8931528','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:54',0,'2014-03-02 06:24:38'),(17511,18161,'0000-00-00','ET','2',1,NULL,'Seema Akhtar','FI','644629892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:08',0,'2014-03-02 06:31:45'),(17639,18289,'0000-00-00','ET','2',1,NULL,'ELIZABETH HOLMANN','FI','400868994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-08 19:00:28',0,'2014-03-01 17:20:55'),(18050,18700,'0000-00-00','ET','2',2,1,'SHARON MAYS','FI','291628246','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:14',0,'2014-03-10 14:24:38'),(21170,21820,'0000-00-00','ET','2',1,NULL,'AISLINN KRAUSE','FI','274905982','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:34',0,'2014-03-10 14:45:25'),(21297,21947,'0000-00-00','ET','2',2,1,'brian loveland','FI','274663231','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:03',0,'2014-03-10 16:38:05'),(21891,22541,'0000-00-00','ET','2',2,1,'ROBERT SHOEMAKER','FI','560926746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:37',0,'2014-03-05 22:27:33'),(21901,22551,'0000-00-00','ET','2',1,NULL,'Jessenia Estrada','FI','450831074','Starmount Life Insurance Company','FI','720977315','Roland  Guellar','94','1094396','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:44',0,'2014-03-05 22:27:33'),(362,362,'2014-01-01','ET','2',2,1,'Marghrettia Kundrach','FI','232805237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:09',0,'2014-03-01 15:21:15'),(13564,13920,'2014-01-01','ET','2',1,NULL,'Catherine Harveston','FI','427230282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:57',0,'2014-03-02 05:24:45'),(13211,13567,'2014-01-01','ET','2',2,1,'Felix Fuentes','FI','460558400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:27',0,'2014-03-02 05:17:40'),(12951,12951,'2014-01-01','ET','2',1,NULL,'James Boggs','FI','215319156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:23',0,'2014-03-02 05:17:40'),(2985,2985,'2014-01-01','ET','2',1,NULL,'jennifer ibarra','FI','449971280','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:40',0,'2014-03-02 01:10:33'),(4481,4481,'2014-01-01','ET','2',1,NULL,'Patricia Neal','FI','450395101','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:26',0,'2014-03-01 21:11:04'),(1594,1594,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:04',0,'2014-03-01 20:10:57'),(13695,14051,'2014-01-01','ET','2',1,NULL,'Robert Neiman','FI','279501531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:38',0,'2014-03-01 16:40:16'),(18490,19140,'0000-00-00','ET','2',1,NULL,'JOHN KAMMILLER','FI','296644402','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:03',0,'2014-03-10 16:31:33'),(19760,20410,'0000-00-00','ET','2',1,NULL,'Aimee F Wilson','FI','277805920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 21:30:13',0,'2014-03-10 16:38:05'),(20494,21144,'0000-00-00','ET','2',1,NULL,'chad hawkins','FI','438515342','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:40',0,'2014-03-02 07:10:28'),(20771,21421,'0000-00-00','ET','2',1,NULL,'THEODORE MONTER','FI','298461100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:44',0,'2014-03-01 18:10:11'),(20910,21560,'0000-00-00','ET','2',2,1,'brad bowling','FI','283607444','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:05',0,'2014-03-01 18:08:07'),(22227,22877,'0000-00-00','ET','2',1,NULL,'KRYSTA ALCALA','FI','630050804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:00',0,'2014-03-06 21:27:26'),(22294,22944,'0000-00-00','ET','2',1,NULL,'Diana Pierson','FI','290520028','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:49',0,'2014-03-10 14:50:59'),(22999,23649,'0000-00-00','ET','2',1,NULL,'george watson','FI','413824690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:50',0,'2014-03-10 21:36:25'),(691,691,'2014-01-01','ET','2',2,1,'James Kuhn','FI','272507848','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:28',0,'2014-03-10 13:24:34'),(14802,15253,'2014-01-01','ET','2',1,NULL,'doug e heyne','FI','299788299','HealthSpan','FI','311431434','Timothy E McKeown','94','1640913','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:59',0,'2014-03-10 14:03:26'),(13936,14292,'2014-01-01','ET','2',1,NULL,'Steven McIver','FI','309527453','HealthSpan','FI','311431434','Sandra S Kudolo','94','6809582','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:23',0,'2014-03-10 14:03:26'),(12781,12781,'2014-01-01','ET','2',1,NULL,'lorenzo franco','FI','465434119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:33',0,'2014-03-02 05:10:52'),(12733,12733,'2014-01-01','ET','2',1,NULL,'danette harrison','FI','299601835','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:06:05',0,'2014-03-10 13:59:38'),(12401,12401,'2014-01-01','ET','2',1,NULL,'Deborah Dockery','FI','271542016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:29:43',0,'2014-03-01 16:35:14'),(12235,12235,'2014-01-01','ET','2',1,NULL,'LAURIE PRATT','FI','439118089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:51',0,'2014-03-02 05:03:29'),(12226,12226,'2014-01-01','ET','2',1,NULL,'JOSEPH CASTLE','FI','439179317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:29',0,'2014-03-02 05:10:52'),(4388,4388,'2014-01-01','ET','2',1,NULL,'Rayshod Gray','FI','298902359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:35',0,'2014-03-01 15:16:37'),(2481,2481,'2014-01-01','ET','2',1,NULL,'Donna Clark','FI','280485244','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:53',0,'2014-03-10 13:10:24'),(7161,7161,'2014-01-01','ET','2',2,1,'Kathryn  Davisson','FI','279568859','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:25',0,'2014-03-10 15:59:47'),(10618,10618,'2014-01-01','ET','2',1,NULL,'TUAN NGUYEN','FI','462553109','Starmount Life Insurance Company','FI','720977315','PETER  TRAN','94','736644','348','2014-01-01','Sync Success',0,'2013-12-26 12:57:47',0,'2014-03-02 04:24:47'),(10626,10626,'2014-01-01','ET','2',1,NULL,'Peggy Bennett','FI','539620062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:01',0,'2014-03-02 04:31:46'),(10768,10768,'2014-01-01','ET','2',1,NULL,'William Lavis','FI','437575504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:02:52',0,'2014-03-02 04:24:47'),(1579,1579,'2014-01-01','ET','2',1,NULL,'Jermaine Lawson','FI','274908710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:36',0,'2014-03-01 15:10:22'),(1167,1167,'2014-01-01','ET','2',1,NULL,'Pearlie Mujaahid','FI','437927803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:43',0,'2014-03-02 04:38:08'),(11843,11843,'2014-01-01','ET','2',1,NULL,'Frances Jones','FI','587606603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:31',0,'2014-03-02 04:31:46'),(15961,16610,'0000-00-00','ET','2',1,NULL,'Javonne Deshye Eatmon','FI','642182014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-26 19:00:10',0,'2014-03-02 06:03:21'),(16991,17641,'0000-00-00','ET','2',1,NULL,'Jackie Robison','FI','587409731','Starmount Life Insurance Company','FI','720977315','Anna  Wyatt','94','16229855','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:24',0,'2014-03-02 06:17:30'),(18233,18883,'0000-00-00','ET','2',2,1,'Tiffany Jones','FI','274742875','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:20',0,'2014-03-10 14:24:38'),(20736,21386,'0000-00-00','ET','2',1,NULL,'George McNulty','FI','194423961','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:30:29',0,'2014-03-01 18:10:11'),(21000,21650,'0000-00-00','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 07:30:39',0,'2014-03-10 14:45:25'),(21048,21698,'0000-00-00','ET','2',1,NULL,'Angela Donahue','FI','301862394','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-02-28 21:30:10',0,'2014-03-01 18:10:11'),(21115,21765,'0000-00-00','ET','2',1,NULL,'virginia ezebuike','FI','629190488','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:57',0,'2014-03-02 07:23:39'),(21227,21877,'0000-00-00','ET','2',1,NULL,'JOHNNY DELEON','FI','465868991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:14',0,'2014-03-02 07:23:39'),(21582,22232,'0000-00-00','ET','2',1,NULL,'Timothy Martin','FI','287684526','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:56',0,'2014-03-10 14:45:25'),(757,757,'2014-01-01','ET','2',1,NULL,'Janice Matthews','FI','281568676','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-01-01','Sync Success',0,'2013-12-25 18:08:35',0,'2014-03-10 13:24:34'),(11900,11900,'2014-01-01','ET','2',1,NULL,'Cartez Lynch','FI','437639916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:01',0,'2014-03-02 04:59:36'),(1969,1969,'2014-01-01','ET','2',3,2,'mark lomack','FI','246196058','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:46',0,'2014-03-01 15:26:40'),(11220,11220,'2014-01-01','ET','2',1,NULL,'sharon louis','FI','179441346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:01:04',0,'2014-03-01 16:23:43'),(3511,3511,'2014-01-01','ET','2',1,NULL,'LAWREEN K GEESAMAN','FI','280522315','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:34',0,'2014-03-01 15:37:30'),(3957,3957,'2014-01-01','ET','2',1,NULL,'Abraham Arreola','FI','642168754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:46:47',0,'2014-03-01 23:10:52'),(4723,4723,'2014-01-01','ET','2',2,1,'kathy lashaway','FI','294742037','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:28',0,'2014-03-10 13:45:57'),(6368,6368,'2014-01-01','ET','2',2,1,'DAVID FRITZ','FI','297460429','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:29',0,'2014-03-10 15:59:47'),(12529,12529,'2014-01-01','ET','2',1,NULL,'YOLANDA TREVINO','FI','455310128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:25',0,'2014-03-02 05:03:29'),(13030,13386,'2014-01-01','ET','2',2,1,'Amber Dawn  Collins','FI','275882839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:21',0,'2014-03-01 16:35:14'),(13751,14107,'2014-01-01','ET','2',1,NULL,'KIEU QUACH','FI','452552610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:15',0,'2014-03-02 05:24:45'),(13970,14326,'2014-01-01','ET','2',1,NULL,'JUDY SMITH','FI','456945416','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:08',0,'2014-03-02 05:31:31'),(18037,18687,'0000-00-00','ET','2',1,NULL,'JoeAnne arnett-hall','FI','285663399','HealthSpan','FI','311431434','alfred joseph patchin','94','7685243','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:04',0,'2014-03-10 14:24:38'),(18808,19458,'0000-00-00','ET','2',2,1,'FLEIPE VELASQUEZ','FI','378664744','HealthSpan','FI','311431434','GEORGE  ALLEY','94','12067476','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:14',0,'2014-03-10 14:31:05'),(18940,19590,'0000-00-00','ET','2',1,NULL,'Colin Duffy','FI','296928574','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:30',0,'2014-03-10 16:31:33'),(19217,19867,'0000-00-00','ET','2',4,3,'Kimberley E Garrison','FI','301643829','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:14',0,'2014-03-01 17:34:07'),(20010,20660,'0000-00-00','ET','2',1,NULL,'ROBERT M BRELO','FI','289720798','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:00',0,'2014-03-10 16:38:05'),(20028,20678,'0000-00-00','ET','2',1,NULL,'GLORIA BOHA','FI','288541807','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:11',0,'2014-03-10 14:37:47'),(20036,20686,'0000-00-00','ET','2',1,NULL,'Jarod Rosebrock','FI','281841946','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:18',0,'2014-03-10 14:37:47'),(20825,21475,'0000-00-00','ET','2',1,NULL,'ELOY GARZA','FI','307580682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:10',0,'2014-03-02 07:17:36'),(22576,23226,'0000-00-00','ET','2',2,1,'eric delung','FI','297805017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:04',0,'2014-03-10 14:50:59'),(23054,23704,'0000-00-00','ET','2',1,NULL,'Jimmy Lawrence Klotz','FI','290699384','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:30',0,'2014-03-10 21:17:52'),(5758,5758,'2014-01-01','ET','2',1,NULL,'Violet Escamilla','FI','643031064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:10',0,'2014-03-02 01:10:33'),(5792,5792,'2014-01-01','ET','2',1,NULL,'Liga Zemesarajs','FI','270664879','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:17',0,'2014-03-10 15:52:36'),(7541,7541,'2014-01-01','ET','2',1,NULL,'JOHN HOLTKAMP','FI','274540492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:35:21',0,'2014-03-01 16:05:34'),(11746,11746,'2014-01-01','ET','2',2,1,'PAMELA GREEN','FI','275784407','Dental Care Plus, Inc.','FI','311185262','JULIAN  LEE','94','7970773','348','2014-02-01','Sync Success',1,'2013-12-29 11:09:19',0,'2014-03-01 16:30:17'),(7428,7428,'2014-01-01','ET','2',1,NULL,'Ashley Smith','FI','412611740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:45',0,'2014-03-02 04:15:49'),(6289,6289,'2014-01-01','ET','2',1,NULL,'PATRICIA MARIE HAWKINS','FI','435436891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:06',0,'2014-03-02 04:10:25'),(6053,6053,'2014-01-01','ET','2',1,NULL,'kwame perry','FI','455876843','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:42',0,'2014-03-01 19:11:03'),(13521,13877,'2014-01-01','ET','2',1,NULL,'Philitca Jennings','FI','272805388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:30',0,'2014-03-01 16:40:16'),(16379,17029,'0000-00-00','ET','2',1,NULL,'Deanna Delatte','FI','433553166','Starmount Life Insurance Company','FI','720977315','Thomas  Klechak Jr','94','3185396','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:12',0,'2014-03-02 06:10:30'),(16611,17261,'0000-00-00','ET','2',1,NULL,'Carol Trauthwein','FI','386609802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-31 21:00:14',0,'2014-03-02 06:17:30'),(17288,17938,'0000-00-00','ET','2',1,NULL,'monique parker','FI','435433936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:49',0,'2014-03-02 06:24:38'),(18860,19510,'0000-00-00','ET','2',1,NULL,'Louis J Fusco','FI','117504766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:33',0,'2014-03-01 17:34:07'),(18908,19558,'0000-00-00','ET','2',1,NULL,'Lacey L Brothers','FI','279881824','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:07',0,'2014-03-01 17:34:07'),(18913,19563,'0000-00-00','ET','2',1,NULL,'dorian lindsey','FI','355544303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:12',0,'2014-03-01 17:34:07'),(20098,20748,'0000-00-00','ET','2',1,NULL,'DAIYING ZHENG','FI','068844281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:17',0,'2014-03-02 07:10:28'),(20723,21373,'0000-00-00','ET','2',1,NULL,'Chase L Carmichael','94','0001241921','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:22',0,'2014-03-01 18:08:07'),(21536,22186,'0000-00-00','ET','2',1,NULL,'CORNELIUS LEON JOLIVETTE','FI','433538328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:21',0,'2014-03-03 22:26:43'),(138,138,'2014-01-01','ET','2',1,NULL,'MICHAEL MARSHALL','FI','270720948','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:16',0,'2014-03-10 13:10:24'),(5525,5525,'2014-01-01','ET','2',4,3,'TERRY MURPHY','FI','294624880','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:11',0,'2014-03-01 16:23:43'),(6434,6434,'2014-01-01','ET','2',1,NULL,'Constance Colleen Hoener','FI','267023201','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:32',0,'2014-03-01 15:10:22'),(1064,1064,'2014-01-01','ET','2',1,NULL,'Patricia Corbet','94','0001111631','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:44',0,'2014-03-10 15:39:19'),(953,953,'2014-01-01','ET','2',1,NULL,'Markus Richters','FI','463839914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:44',0,'2014-03-01 22:10:55'),(651,651,'2014-01-01','ET','2',1,NULL,'Kristin Miles','FI','438042132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:15',0,'2014-03-02 02:10:49'),(21502,22152,'0000-00-00','ET','2',1,NULL,'Rhonda Jane Judd','FI','271521623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:56',0,'2014-03-03 21:36:16'),(21802,22452,'0000-00-00','ET','2',3,2,'Walter Landow','FI','294502238','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:17',0,'2014-03-04 21:36:30'),(22032,22682,'0000-00-00','ET','2',1,NULL,'Kathie Bidwell','FI','464920365','Starmount Life Insurance Company','FI','720977315','Archer  Summers','94','16993399','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:15',0,'2014-03-05 22:27:33'),(20826,21476,'0000-00-00','ET','2',2,1,'Yolanda Gonzales','FI','564238689','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:11',0,'2014-03-02 07:17:36'),(2223,2223,'2014-01-01','ET','2',1,NULL,'David Greene','FI','285622142','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:57',0,'2014-03-10 13:10:24'),(15037,15488,'2014-01-01','ET','2',1,NULL,'MARTHA VONNET-CELESTINE','FI','435257157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:26',0,'2014-03-02 05:52:31'),(3449,3449,'2014-01-01','ET','2',2,1,'Frank Caprilla','FI','274807371','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:17',0,'2014-03-10 13:32:15'),(5120,5120,'2014-01-01','ET','2',1,NULL,'Karen Channel','FI','284522636','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:53',0,'2014-03-10 15:45:56'),(11707,11707,'2014-01-01','ET','2',2,1,'KAY BURGESS','FI','445549560','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:06',0,'2014-03-02 04:59:36'),(22846,23496,'0000-00-00','ET','2',1,NULL,'Francisca Davila','FI','595685657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:00',0,'2014-03-10 21:27:11'),(18329,18979,'0000-00-00','ET','2',1,NULL,'Octavio Colon','FI','582794840','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:13',0,'2014-03-01 17:26:36'),(14905,15356,'2014-01-01','ET','2',1,NULL,'Mary Elizabeth Wright','FI','433676969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:26',0,'2014-03-02 05:52:31'),(6086,6086,'2014-01-01','ET','2',2,1,'Lisa Ayers','FI','274805391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:53',0,'2014-03-01 16:00:27'),(14756,15207,'2014-01-01','ET','2',2,1,'James Grimm','FI','294681714','Summa Insurance Company, Inc.','FI','341809108','James  Finngin','94','2766031','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:29',0,'2014-03-10 16:17:47'),(2950,2950,'2014-01-01','ET','2',1,NULL,'Linda shepherd','FI','406257575','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:34',0,'2014-03-01 15:37:30'),(13789,14145,'2014-01-01','ET','2',1,NULL,'jim  lewis','FI','587061748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:39',0,'2014-03-02 05:24:45'),(7421,7421,'2014-01-01','ET','2',1,NULL,'Sandra Pearson','FI','436783523','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:32',0,'2014-03-02 04:15:49'),(7627,7627,'2014-01-01','ET','2',1,NULL,'Rexford Chancey','FI','293521348','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:09',0,'2014-03-10 15:59:47'),(2102,2102,'2014-01-01','ET','2',1,NULL,'Jessica Balmer','FI','301967308','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:38:08',0,'2014-03-10 13:20:27'),(2201,2201,'2014-01-01','ET','2',1,NULL,'Joseph Ecker','FI','300521999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:13',0,'2014-03-01 21:11:04'),(20143,20793,'0000-00-00','ET','2',1,NULL,'Wielanda Liejaya','FI','186803929','Summa Insurance Company, Inc.','FI','341809108','Michael  Prescott','94','3896115','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:50',0,'2014-03-10 16:38:05'),(19522,20172,'0000-00-00','ET','2',1,NULL,'DONALD DOMENIC GAUDIO','FI','298667018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:10:17',0,'2014-03-01 17:47:19'),(3059,3059,'2014-01-01','ET','2',2,1,'Michelle Markielowski','FI','276867049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:54',0,'2014-03-01 15:37:30'),(18104,18754,'0000-00-00','ET','2',1,NULL,'Anita Castro','FI','464024481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:41',0,'2014-03-02 06:38:05'),(17868,18518,'0000-00-00','ET','2',1,NULL,'DAVID SURNBROCK','FI','289502480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:04',0,'2014-03-10 14:24:38'),(16430,17080,'0000-00-00','ET','2',1,NULL,'MIA RAY','FI','287707307','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:46',0,'2014-03-10 14:20:26'),(7466,7466,'2014-01-01','ET','2',1,NULL,'Christopher Deal','FI','237698962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:51',0,'2014-03-02 04:15:49'),(15588,16039,'0000-00-00','ET','2',1,NULL,'Carolynne Tabary','FI','433390249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:30',0,'2014-03-02 05:59:43'),(12513,12513,'2014-01-01','ET','2',2,1,'Cynthia Lee','FI','587235352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:50',0,'2014-03-02 05:03:29'),(15093,15544,'0000-00-00','ET','2',1,NULL,'Geraldine Erwin','FI','459082112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:44',0,'2014-03-02 05:52:31'),(22743,23393,'0000-00-00','ET','2',3,2,'robert rutschilling','FI','270663632','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:06',0,'2014-03-10 14:50:59'),(21035,21685,'0000-00-00','ET','2',1,NULL,'Gregory Alan Stevens','FI','276646527','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:00:25',0,'2014-03-10 14:45:25'),(19719,20369,'0000-00-00','ET','2',3,2,'Tenola C Oliver','FI','296605213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 05:32:49',0,'2014-03-01 17:47:19'),(17943,18593,'0000-00-00','ET','2',1,NULL,'Joel Groshong','FI','541609343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:58',0,'2014-03-02 06:38:05'),(14606,15057,'2014-01-01','ET','2',1,NULL,'Timothy McLoughlin','FI','406316928','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:54',0,'2014-03-01 16:46:19'),(16103,16752,'0000-00-00','ET','2',1,NULL,'JENNA HUBER','FI','290849169','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:19',0,'2014-03-10 16:24:30'),(16239,16888,'0000-00-00','ET','2',1,NULL,'Travis Sutton','FI','437452950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:05',0,'2014-03-02 06:03:21'),(17895,18545,'0000-00-00','ET','2',1,NULL,'HARVEY  MIMS','FI','439199908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:26',0,'2014-03-02 06:38:05'),(21724,22374,'0000-00-00','ET','2',1,NULL,'Benjamin William Downing','FI','287884282','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:58',0,'2014-03-10 16:44:18'),(22669,23319,'0000-00-00','ET','2',4,3,'FONDA CHURCH','FI','587276241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:35',0,'2014-03-08 22:26:18'),(501,501,'2014-01-01','ET','2',1,NULL,'Tamaria Damron','FI','283744237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:30',0,'2014-03-01 15:48:04'),(7165,7165,'2014-01-01','ET','2',1,NULL,'mason healy','94','0000227042','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:32',0,'2014-03-10 15:59:47'),(3172,3172,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:34',0,'2014-03-10 13:24:34'),(19082,19732,'0000-00-00','ET','2',1,NULL,'DEBORAH KINKLE','FI','298549751','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:31',0,'2014-03-01 17:34:07'),(5660,5660,'2014-01-01','ET','2',1,NULL,'wendy reed','FI','587495491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:40',0,'2014-03-02 04:45:37'),(14948,15399,'2014-01-01','ET','2',2,1,'ALFONSO JAIME GARCIA','FI','576510422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:47',0,'2014-03-02 05:45:37'),(12807,12807,'2014-01-01','ET','2',1,NULL,'Antwanna Williams','FI','433656844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:31',0,'2014-03-02 05:17:40'),(3513,3513,'2014-01-01','ET','2',2,1,'Michael Shafitz','FI','420782243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:37',0,'2014-03-01 15:37:30'),(7707,7707,'2014-01-01','ET','2',2,1,'michael nagy','FI','232085468','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:43',0,'2014-03-10 13:03:33'),(21095,21745,'0000-00-00','ET','2',1,NULL,'Clyde Padgett','FI','498529505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:44',0,'2014-03-02 07:23:39'),(15465,15916,'0000-00-00','ET','2',1,NULL,'CHARLOTTE SHOULTS','FI','275505968','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:51',0,'2014-03-01 16:50:53'),(14618,15069,'2014-01-01','ET','2',1,NULL,'RONALD PERKEY','FI','293506822','Dental Care Plus, Inc.','FI','311185262','MARK  SWISHER','94','15817320','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:01',0,'2014-03-01 16:46:19'),(14180,14631,'2014-01-01','ET','2',1,NULL,'NIYRA R MUHAMMAD','FI','291760774','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:26',0,'2014-03-10 14:03:26'),(10653,10653,'2014-01-01','ET','2',1,NULL,'George Meeks','FI','426238032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:54',0,'2014-03-02 04:31:46'),(11176,11176,'2014-01-01','ET','2',1,NULL,'CLARA MAJOR','FI','295460581','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:51',0,'2014-03-10 13:45:57'),(11360,11360,'2014-01-01','ET','2',1,NULL,'Richard L Triska','FI','462985016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:22',0,'2014-03-02 04:45:37'),(19747,20397,'0000-00-00','ET','2',1,NULL,'Bettyann Virginia Kaiser','FI','275660036','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:05',0,'2014-03-10 14:37:47'),(891,891,'2014-01-01','ET','2',1,NULL,'Jeffrey Dean','FI','268684769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:52',0,'2014-03-01 15:21:15'),(1631,1631,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:58',0,'2014-03-01 20:10:57'),(4537,4537,'2014-01-01','ET','2',1,NULL,'Thomas Potkalitsky','FI','298482745','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:15',0,'2014-03-10 16:03:49'),(3560,3560,'2014-01-01','ET','2',2,1,'MARIA GUADALUPE ALEMAN','FI','635680788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:09',0,'2014-03-02 00:10:48'),(3552,3552,'2014-01-01','ET','2',8,7,'Alan Dail','FI','230829756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:49',0,'2014-03-01 15:37:30'),(2264,2264,'2014-01-01','ET','2',2,1,'Michael William King','FI','273908818','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:25',0,'2014-03-10 13:10:24'),(18283,18933,'0000-00-00','ET','2',1,NULL,'Mark Moses','FI','300941107','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:12',0,'2014-03-10 14:24:38'),(17352,18002,'0000-00-00','ET','2',1,NULL,'Pat Hill','FI','456199211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:08',0,'2014-03-02 06:31:45'),(16248,16897,'0000-00-00','ET','2',1,NULL,'Kevin Gravett','FI','300825443','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','357','2014-02-01','Sync Success',0,'2014-01-28 21:01:12',0,'2014-03-10 14:20:26'),(13781,14137,'2014-01-01','ET','2',1,NULL,'Rebecca Brandman','FI','286568915','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:34',0,'2014-03-10 13:59:38'),(14501,14952,'2014-01-01','ET','2',1,NULL,'BERTRAM KOHLER','FI','369560009','HealthSpan','FI','311431434','Kirk L Bernhard','94','2828814','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:53',0,'2014-03-10 14:03:26'),(23044,23694,'0000-00-00','ET','2',1,NULL,'Vu Hoang','FI','525417893','Starmount Life Insurance Company','FI','720977315','kanya c arntson','94','1272260','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:24',0,'2014-03-10 21:27:11'),(20531,21181,'0000-00-00','ET','2',1,NULL,'Dominique Lujan','FI','645166881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:04',0,'2014-03-02 07:10:28'),(15125,15576,'0000-00-00','ET','2',2,1,'Roger Manley','FI','272763358','Dental Care Plus, Inc.','FI','311185262','Donald  E Vaughan','94','3330979','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:08',0,'2014-03-01 16:50:53'),(3617,3617,'2014-01-01','ET','2',1,NULL,'Anthony Brown','FI','445607924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:53',0,'2014-03-02 00:10:48'),(6325,6325,'2014-01-01','ET','2',4,3,'Steven Hockstra','FI','216887989','Summa Insurance Company, Inc.','FI','341809108','Carl  Laurianti','94','2332836','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:09',0,'2014-03-10 15:59:47'),(3811,3811,'2014-01-01','ET','2',1,NULL,'Danny Miller','FI','280706048','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:43',0,'2014-03-01 15:26:40'),(4928,4928,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:04',0,'2014-03-10 13:03:33'),(7585,7585,'2014-01-01','ET','2',1,NULL,'Hani Elassal','FI','070645963','Dental Care Plus, Inc.','FI','311185262','John  Musca','94','2443789','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:50',0,'2014-03-01 16:05:34'),(10402,10402,'2014-01-01','ET','2',1,NULL,'karen everage','FI','268547620','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:47',0,'2014-03-01 16:10:36'),(22238,22888,'0000-00-00','ET','2',1,NULL,'JOHNNY JOHNSON','FI','439157798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:07',0,'2014-03-06 21:27:26'),(576,576,'2014-01-01','ET','2',1,NULL,'Jennifer Krenisky','FI','280583138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:51',0,'2014-03-01 15:48:04'),(1377,1377,'2014-01-01','ET','2',1,NULL,'JOSE HOLGUIN','FI','452967858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:16',0,'2014-03-02 04:38:08'),(1656,1656,'2014-01-01','ET','2',2,1,'Kathleen Chiofolo','FI','278523412','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:05',0,'2014-03-10 15:45:56'),(7162,7162,'2014-01-01','ET','2',1,NULL,'Craig Jerin','FI','300805578','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-01-01','Sync Success',0,'2013-12-26 04:05:27',0,'2014-03-10 15:59:47'),(18056,18706,'0000-00-00','ET','2',1,NULL,'Phillip Pounds','FI','633107794','Starmount Life Insurance Company','FI','720977315','Anna  Wyatt','94','16229855','348','2014-03-01','Sync Success',0,'2014-02-11 21:00:04',0,'2014-03-02 06:38:05'),(4211,4211,'2014-01-01','ET','2',1,NULL,'john dorgiewicz','FI','290646148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:34',0,'2014-03-01 15:52:44'),(13441,13797,'2014-01-01','ET','2',1,NULL,'SAMUEL RAMIEREZ','FI','460413217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:13',0,'2014-03-02 05:31:31'),(13254,13610,'2014-01-01','ET','2',1,NULL,'Samantha Hoot','FI','274901087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:18',0,'2014-03-10 13:59:38'),(12738,12738,'2014-01-01','ET','2',1,NULL,'nancy spencer','FI','289521143','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:13',0,'2014-03-10 13:59:38'),(20629,21279,'0000-00-00','ET','2',1,NULL,'JOSHUA COWAN','FI','269967480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:09',0,'2014-03-10 14:37:47'),(7367,7367,'2014-01-01','ET','2',5,4,'Robert Smith','FI','487904255','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:06',0,'2014-03-01 15:16:37'),(6458,6458,'2014-01-01','ET','2',1,NULL,'BOB CALLAHAN','FI','435942485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:24',0,'2014-03-01 20:10:57'),(17310,17960,'0000-00-00','ET','2',1,NULL,'mary mulkey','FI','437888074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:00',0,'2014-03-02 06:24:38'),(2438,2438,'2014-01-01','ET','2',1,NULL,'KENNETH W SORG','FI','276543748','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:25',0,'2014-03-10 13:10:24'),(11144,11144,'2014-01-01','ET','2',2,1,'MARGARET DOWELL TARRANT','FI','235154996','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:43',0,'2014-03-10 13:45:57'),(11059,11059,'2014-01-01','ET','2',2,1,'Brian Piecuch','FI','279725207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:46',0,'2014-03-10 15:59:47'),(10913,10913,'2014-01-01','ET','2',2,1,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:04',0,'2014-03-10 15:59:47'),(3625,3625,'2014-01-01','ET','2',1,NULL,'Hazel Ganze','FI','454980877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:07',0,'2014-03-02 01:10:33'),(3700,3700,'2014-01-01','ET','2',1,NULL,'Ida Bestman','FI','664093045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:31',0,'2014-03-02 01:10:33'),(825,825,'2014-01-01','ET','2',1,NULL,'Betty Matson','FI','546813880','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:07',0,'2014-03-01 19:11:03'),(21581,22231,'0000-00-00','ET','2',1,NULL,'Betty Fay Cooper','FI','403804852','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:55',0,'2014-03-10 14:45:25'),(1158,1158,'2014-01-01','ET','2',2,1,'VERONICA BLAKE','FI','433114958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:26',0,'2014-03-02 04:38:08'),(6377,6377,'2014-01-01','ET','2',1,NULL,'Marvin Shelton','94','0000820997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:47',0,'2014-03-10 13:39:10'),(1263,1263,'2014-01-01','ET','2',1,NULL,'Donna Jones','FI','279644815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:36',0,'2014-03-01 16:15:39'),(5164,5164,'2014-01-01','ET','2',1,NULL,'JoAnna Hirt','FI','268646109','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:51:13',0,'2014-03-10 13:20:27'),(21483,22133,'0000-00-00','ET','2',1,NULL,'Sherri Doty','FI','547678084','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:43',0,'2014-03-03 21:36:16'),(20180,20830,'0000-00-00','ET','2',1,NULL,'Elias Lopez','FI','512338661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:15',0,'2014-03-02 07:10:28'),(11333,11333,'2014-01-01','ET','2',1,NULL,'Maria Lopez','FI','458088776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:31',0,'2014-03-02 04:52:44'),(11619,11619,'2014-01-01','ET','2',2,1,'Oretha Barnett','FI','291540125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:19',0,'2014-03-10 16:10:34'),(12639,12639,'2014-01-01','ET','2',1,NULL,'Charles Hursey','FI','439114250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:29',0,'2014-03-02 05:10:52'),(19061,19711,'0000-00-00','ET','2',1,NULL,'Erin Gulbengay','FI','567657774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:16',0,'2014-03-02 06:52:12'),(16022,16671,'0000-00-00','ET','2',1,NULL,'MARK WILLIS','FI','437614368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:25',0,'2014-03-02 06:03:21'),(20399,21049,'0000-00-00','ET','2',1,NULL,'Kheresentha Brown','FI','463519878','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:26',0,'2014-03-02 07:10:28'),(1660,1660,'2014-01-01','ET','2',1,NULL,'Stephanie PieroneK','FI','298820394','Summa Insurance Company, Inc.','FI','341809108','Carl  Lishing','94','2095192','348','2014-01-01','Sync Success',0,'2013-12-25 19:15:14',0,'2014-03-10 15:45:56'),(5956,5956,'2014-01-01','ET','2',1,NULL,'Bhalinder Singh Chahal','FI','271176838','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:31',0,'2014-03-10 15:52:36'),(18863,19513,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:35',0,'2014-03-01 17:34:07'),(21907,22557,'0000-00-00','ET','2',1,NULL,'Marvin Iles','FI','455198110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:49',0,'2014-03-05 22:27:33'),(1202,1202,'2014-01-01','ET','2',2,1,'randall phipps','FI','278560239','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:50',0,'2014-03-10 13:45:57'),(16980,17630,'0000-00-00','ET','2',1,NULL,'James DeCrane','FI','269861949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:16',0,'2014-03-01 17:00:58'),(12017,12017,'2014-01-01','ET','2',1,NULL,'Charles Winston','FI','437083700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:44',0,'2014-03-02 04:59:36'),(2239,2239,'2014-01-01','ET','2',1,NULL,'Madison Hicks','FI','270946896','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:32',0,'2014-03-10 15:39:19'),(22740,23390,'0000-00-00','ET','2',1,NULL,'Rose Tademy','FI','436042000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:03',0,'2014-03-09 21:26:00'),(19197,19847,'0000-00-00','ET','2',1,NULL,'Jason Kenner','FI','274822519','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:03',0,'2014-03-10 14:31:05'),(3816,3816,'2014-01-01','ET','2',1,NULL,'Chukwuemeka Uzoma','FI','341980478','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:52',0,'2014-03-10 13:20:27'),(5943,5943,'2014-01-01','ET','2',1,NULL,'ALISHA DAVIS','FI','433815211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:06',0,'2014-03-02 01:10:33'),(18176,18826,'0000-00-00','ET','2',2,1,'BAKARY GALLEDOU','FI','093808734','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:35',0,'2014-03-01 17:26:36'),(7067,7067,'2014-01-01','ET','2',2,1,'GIOVANNI PAGANO','FI','302521547','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:33',0,'2014-03-01 15:52:44'),(7129,7129,'2014-01-01','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:04:29',0,'2014-03-01 15:52:44'),(17602,18252,'0000-00-00','ET','2',1,NULL,'MARIA CRISTINA MARTIN DEL CAMPO','FI','640409096','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:05',0,'2014-03-02 06:31:45'),(17258,17908,'0000-00-00','ET','2',1,NULL,'eva sanchez','FI','582839757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:35',0,'2014-03-02 06:24:38'),(16481,17131,'0000-00-00','ET','2',1,NULL,'Gregory Gray','FI','462809554','Starmount Life Insurance Company','FI','720977315','Kathy  Canlas','94','7407489','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:26',0,'2014-03-02 06:10:30'),(13601,13957,'2014-01-01','ET','2',1,NULL,'michael mccain','FI','336747050','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:25',0,'2014-03-10 14:03:26'),(12724,12724,'2014-01-01','ET','2',2,1,'SANDRA KAY SCOTT','FI','234027615','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:43',0,'2014-03-10 13:59:38'),(12841,12841,'2014-01-01','ET','2',1,NULL,'Tiffany Campbell','FI','462912724','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:44',0,'2014-03-02 05:10:52'),(13240,13596,'2014-01-01','ET','2',1,NULL,'ANGELA M DELVALLE','FI','437452243','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:42',0,'2014-03-02 05:17:40'),(20228,20878,'0000-00-00','ET','2',1,NULL,'Angel Coleman','FI','456510388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:52',0,'2014-03-02 07:10:28'),(511,511,'2014-01-01','ET','2',1,NULL,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:00:48',0,'2014-03-01 15:48:04'),(1061,1061,'2014-01-01','ET','2',1,NULL,'Anthony Thomas','FI','199585984','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:38',0,'2014-03-01 21:11:04'),(18271,18921,'0000-00-00','ET','2',1,NULL,'scott storey','FI','396809831','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:54',0,'2014-03-10 14:24:38'),(15942,16591,'0000-00-00','ET','2',1,NULL,'Cathleen L Domonkos','FI','280523401','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:17',0,'2014-03-10 14:20:26'),(10976,10976,'2014-01-01','ET','2',2,1,'Jerry Lambert','FI','276842272','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:55',0,'2014-03-10 13:45:57'),(10668,10668,'2014-01-01','ET','2',1,NULL,'Jessica Winner','FI','300606018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:21',0,'2014-03-01 16:05:34'),(378,378,'2014-01-01','ET','2',1,NULL,'gary ewing','FI','276566356','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:40',0,'2014-03-10 15:39:19'),(15159,15610,'0000-00-00','ET','2',1,NULL,'DARLENE HAYNES','FI','426398116','Starmount Life Insurance Company','FI','720977315','PERRY EUGENE DUCKWORTH','94','6393415','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:33',0,'2014-03-02 05:52:31'),(14459,14910,'2014-01-01','ET','2',1,NULL,'Lois thomas','FI','437883227','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:34',0,'2014-03-02 05:38:34'),(967,967,'2014-01-01','ET','2',2,1,'Don Smith','FI','268521448','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:12',0,'2014-03-10 15:39:19'),(1451,1451,'2014-01-01','ET','2',1,NULL,'Harriet Jefferson','FI','284460089','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:45',0,'2014-03-01 16:15:39'),(14068,14519,'2014-01-01','ET','2',1,NULL,'Justin Briggs','FI','425537426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:15',0,'2014-03-02 05:38:34'),(13659,14015,'2014-01-01','ET','2',2,1,'Javonne Deshye Eatmon','FI','642182014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:15',0,'2014-03-02 05:24:45'),(12915,12915,'2014-01-01','ET','2',1,NULL,'Michelle Brooks','FI','439512324','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-04 02:05:28',0,'2014-03-02 05:17:40'),(12638,12638,'2014-01-01','ET','2',1,NULL,'Yanesia Gambrell','FI','435593218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:27',0,'2014-03-02 05:10:52'),(21130,21780,'0000-00-00','ET','2',4,3,'Angela Christy','FI','284826023','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:08',0,'2014-03-10 16:38:05'),(21678,22328,'0000-00-00','ET','2',1,NULL,'Frank Miller','FI','352468009','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:20',0,'2014-03-04 21:27:16'),(22477,23127,'0000-00-00','ET','2',1,NULL,'Shannon Heskett','FI','297606167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:54',0,'2014-03-07 21:36:32'),(19133,19783,'0000-00-00','ET','2',1,NULL,'Debbie Cherry','FI','286500568','Dental Care Plus, Inc.','FI','311185262','Jeffrey  Morton','94','2211997','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:08',0,'2014-03-01 17:34:07'),(5995,5995,'2014-01-01','ET','2',1,NULL,'jayne kitzmiller','FI','290625333','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:51',0,'2014-03-10 13:24:34'),(11139,11139,'2014-01-01','ET','2',2,1,'Brenda Hawkins','FI','404761566','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:15:33',0,'2014-03-10 13:45:57'),(17904,18554,'0000-00-00','ET','2',1,NULL,'Jay Merrill Cox','FI','425578247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:31',0,'2014-03-02 06:38:05'),(12119,12119,'2014-01-01','ET','2',1,NULL,'Donna Ruland','FI','269449031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:21',0,'2014-03-01 16:30:17'),(15763,16412,'0000-00-00','ET','2',1,NULL,'Lynn Barman','FI','370787034','HealthSpan','FI','311431434','Thomas  Konzen','94','7981943','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:30',0,'2014-03-10 14:10:12'),(15256,15707,'0000-00-00','ET','2',1,NULL,'Lasonya Gatewood','FI','453595477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:33',0,'2014-03-02 05:52:31'),(21355,22005,'0000-00-00','ET','2',1,NULL,'MOLLY REEVES','FI','270567763','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:26',0,'2014-03-10 14:45:25'),(21461,22111,'0000-00-00','ET','2',1,NULL,'Robert Hall','FI','281841544','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:28',0,'2014-03-03 21:36:16'),(21524,22174,'0000-00-00','ET','2',1,NULL,'Robert Nieto','FI','454830415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:12',0,'2014-03-03 22:26:43'),(21881,22531,'0000-00-00','ET','2',1,NULL,'JESSICA KENNEDY','FI','269924328','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:28',0,'2014-03-05 21:36:22'),(18573,19223,'0000-00-00','ET','2',1,NULL,'Samantha Michelle Smith','94','0000643274','Dental Care Plus, Inc.','FI','311185262','Sarah  Bean','94','10334323','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:12',0,'2014-03-01 17:26:36'),(18292,18942,'0000-00-00','ET','2',1,NULL,'DONNA GROTENRATH','FI','396626977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:22',0,'2014-03-01 17:26:36'),(3856,3856,'2014-01-01','ET','2',1,NULL,'Willis Hill','FI','289561682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:47',0,'2014-03-01 15:05:09'),(7352,7352,'2014-01-01','ET','2',1,NULL,'TIMOTHY J BRAUER','FI','277823551','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:33',0,'2014-03-01 15:16:37'),(10566,10566,'2014-01-01','ET','2',1,NULL,'John K Hannan','FI','463980820','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:04',0,'2014-03-02 04:24:47'),(17978,18628,'0000-00-00','ET','2',1,NULL,'willie alexander','FI','450049188','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:23',0,'2014-03-02 06:38:05'),(17738,18388,'0000-00-00','ET','2',1,NULL,'Robert Norman','FI','272880256','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:27',0,'2014-03-10 16:24:30'),(11452,11452,'2014-01-01','ET','2',2,1,'MICHAEL SAMAS','FI','274864114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:13',0,'2014-03-01 16:23:43'),(11752,11752,'2014-01-01','ET','2',1,NULL,'Jared Rammel','FI','286885633','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:31',0,'2014-03-10 13:52:32'),(12071,12071,'2014-01-01','ET','2',2,1,'Katariina Lawson','FI','277528183','Dental Care Plus, Inc.','FI','311185262','Adam  Damrill','94','16802443','348','2014-02-01','Sync Success',0,'2014-01-01 12:04:44',0,'2014-03-01 16:30:17'),(12138,12138,'2014-01-01','ET','2',1,NULL,'Connie Workman','FI','289582310','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:07:03',0,'2014-03-10 16:10:34'),(15400,15851,'0000-00-00','ET','2',1,NULL,'MAGALI ROSA','FI','458619398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:10',0,'2014-03-02 05:59:43'),(20563,21213,'0000-00-00','ET','2',2,1,'ROLANDA WHITE','FI','465119994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:25',0,'2014-03-02 07:17:36'),(22074,22724,'0000-00-00','ET','2',2,1,'Diem To Nguyen','FI','610823077','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:09',0,'2014-03-06 21:27:26'),(22269,22919,'0000-00-00','ET','2',1,NULL,'Sahar F Rimawi','FI','067887879','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:30',0,'2014-03-10 14:45:25'),(23066,23716,'0000-00-00','ET','2',3,2,'Ronald Nisch','FI','297444556','HealthSpan','FI','311431434','Jason  Bradford','94','14299558','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:40',0,'2014-03-10 21:17:52'),(18497,19147,'0000-00-00','ET','2',1,NULL,'Adam Teutsch','FI','506130676','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:07',0,'2014-03-10 14:24:38'),(16196,16845,'0000-00-00','ET','2',1,NULL,'CLAUDETTE FILOMENO','FI','580121122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:36',0,'2014-03-02 06:10:30'),(2861,2861,'2014-01-01','ET','2',2,1,'marty bastien','FI','379681049','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:22',0,'2014-03-10 13:39:10'),(3434,3434,'2014-01-01','ET','2',1,NULL,'Helen Whitehead','FI','302483679','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:52:48',0,'2014-03-10 13:32:15'),(3300,3300,'2014-01-01','ET','2',4,3,'Ramzi Cater','FI','234923838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:26',0,'2014-03-01 15:52:44'),(11291,11291,'2014-01-01','ET','2',1,NULL,'QUENTIN LEOEIS SMITH','FI','435775837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:14',0,'2014-03-02 04:52:44'),(11441,11441,'2014-01-01','ET','2',2,1,'John France','FI','092445522','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:55',0,'2014-03-10 13:52:32'),(11817,11817,'2014-01-01','ET','2',1,NULL,'Alaina Cohen','FI','286929960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:38',0,'2014-03-01 16:15:39'),(15190,15641,'0000-00-00','ET','2',1,NULL,'Blanca Vasquez','FI','287809469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:18',0,'2014-03-10 14:10:12'),(14209,14660,'2014-01-01','ET','2',1,NULL,'JAY J MERKLE','FI','282485788','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:45',0,'2014-03-10 14:03:26'),(12390,12390,'2014-01-01','ET','2',1,NULL,'PHILLIP  GARNER','FI','345704102','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:19',0,'2014-03-01 16:30:17'),(21973,22623,'0000-00-00','ET','2',1,NULL,'Folser Ollie','FI','426027952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:35',0,'2014-03-05 22:27:33'),(18948,19598,'0000-00-00','ET','2',1,NULL,'Cathe Lawrentz','FI','301462993','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:36',0,'2014-03-10 16:31:33'),(2192,2192,'2014-01-01','ET','2',4,3,'Jeffrey Toth','FI','269783194','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:53',0,'2014-03-10 15:39:19'),(15655,16304,'0000-00-00','ET','2',1,NULL,'Brenda Symons','FI','288503981','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:16',0,'2014-03-01 16:56:22'),(5892,5892,'2014-01-01','ET','2',1,NULL,'Cynthia Richardson','FI','280829594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:30',0,'2014-03-01 15:48:04'),(13911,14267,'2014-01-01','ET','2',1,NULL,'Amanda Jones','FI','288909909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:09',0,'2014-03-01 16:40:16'),(13570,13926,'2014-01-01','ET','2',1,NULL,'Steve Omillian','FI','273665967','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:02',0,'2014-03-10 13:59:38'),(10695,10695,'2014-01-01','ET','2',1,NULL,'SUSAN LAMBERT','FI','473782172','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:22',0,'2014-03-01 16:10:36'),(10859,10859,'2014-01-01','ET','2',2,1,'FREDERIC SEIBERT','FI','297488752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:48',0,'2014-03-10 13:45:57'),(13352,13708,'2014-01-01','ET','2',1,NULL,'charlie wheeler','FI','456895235','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:33',0,'2014-03-02 05:24:45'),(836,836,'2014-01-01','ET','2',1,NULL,'Eleanor McGaffick','FI','171381877','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:14',0,'2014-03-10 15:39:19'),(13066,13422,'2014-01-01','ET','2',2,1,'Julie Arthur','FI','433899959','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:38',0,'2014-03-02 05:17:40'),(889,889,'2014-01-01','ET','2',1,NULL,'John Yurcik','FI','278501615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:49',0,'2014-03-01 15:21:15'),(11235,11235,'2014-01-01','ET','2',1,NULL,'Daniel Hank Potter','FI','272929624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:31',0,'2014-03-01 16:23:43'),(3338,3338,'2014-01-01','ET','2',1,NULL,'KATHLEEN BRENNAN','FI','278524761','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:47',0,'2014-03-10 15:52:36'),(3319,3319,'2014-01-01','ET','2',1,NULL,'JOHN CONNOLLY','FI','299542670','Dental Care Plus, Inc.','FI','311185262','GAIL  FINK','94','967574','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:10',0,'2014-03-01 15:52:44'),(1253,1253,'2014-01-01','ET','2',4,3,'Julie Canning-Hollenbeck','FI','285868119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:17',0,'2014-03-01 16:15:39'),(2871,2871,'2014-01-01','ET','2',2,1,'gerald joseph','FI','291484004','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:39',0,'2014-03-10 13:39:10'),(21569,22219,'0000-00-00','ET','2',3,2,'Anderson Blair','FI','400134096','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:46',0,'2014-03-03 22:26:43'),(22956,23606,'0000-00-00','ET','2',1,NULL,'BECKY EVANS-HENRY','FI','278524973','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:01:21',0,'2014-03-10 21:07:22'),(166,166,'2014-01-01','ET','2',1,NULL,'Diane King','FI','272542274','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:10',0,'2014-03-10 13:10:24'),(927,927,'2014-01-01','ET','2',1,NULL,'Ladonna Renee Odems','FI','463299078','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:56',0,'2014-03-01 21:11:04'),(7308,7308,'2014-01-01','ET','2',1,NULL,'Carolyn Butler','FI','587325993','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:57',0,'2014-03-02 03:09:49'),(7118,7118,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:09',0,'2014-03-01 15:52:44'),(2120,2120,'2014-01-01','ET','2',1,NULL,'Curits Benson','FI','297646065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:32',0,'2014-03-01 15:16:37'),(2459,2459,'2014-01-01','ET','2',1,NULL,'Loretta Gonzaque','FI','086462731','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:10',0,'2014-03-01 23:10:52'),(18790,19440,'0000-00-00','ET','2',2,1,'Cynthia Grogan','FI','405086654','HealthSpan','FI','311431434','Kristen  Barger','94','2444040','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:59',0,'2014-03-10 14:31:05'),(5963,5963,'2014-01-01','ET','2',2,1,'Syed Islam','FI','122632648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:44',0,'2014-03-02 01:10:33'),(5920,5920,'2014-01-01','ET','2',1,NULL,'Kari Blevins','FI','271804648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:25',0,'2014-03-01 15:48:04'),(5672,5672,'2014-01-01','ET','2',2,1,'Robert English','FI','467021877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:07',0,'2014-03-02 04:45:37'),(4985,4985,'2014-01-01','ET','2',1,NULL,'Josette White','FI','302700005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:30',0,'2014-03-01 15:31:33'),(2982,2982,'2014-01-01','ET','2',1,NULL,'Christina Martinez','FI','455130166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:35',0,'2014-03-02 01:10:33'),(4027,4027,'2014-01-01','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:57',0,'2014-03-02 03:09:49'),(17551,18201,'0000-00-00','ET','2',1,NULL,'anna Bradford','FI','435533621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:34',0,'2014-03-02 06:31:45'),(7735,7735,'2014-01-01','ET','2',1,NULL,'Anthony Main','FI','283760288','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:22',0,'2014-03-01 15:05:09'),(10691,10691,'2014-01-01','ET','2',5,4,'Esther Thomas','FI','283864459','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:11',0,'2014-03-01 16:10:36'),(12579,12579,'2014-01-01','ET','2',1,NULL,'Sean Lyons','FI','283906806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:21',0,'2014-03-01 16:35:14'),(14233,14684,'2014-01-01','ET','2',1,NULL,'Natalie King','FI','427579414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:55',0,'2014-03-02 05:38:34'),(14466,14917,'2014-01-01','ET','2',2,1,'jose flores','FI','260931840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:37',0,'2014-03-02 05:45:37'),(1131,1131,'2014-01-01','ET','2',1,NULL,'Lesley Land','FI','461351799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:37',0,'2014-03-02 04:38:08'),(2279,2279,'2014-01-01','ET','2',2,1,'Sharon Redmond','FI','426252177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:27',0,'2014-03-01 21:11:04'),(20661,21311,'0000-00-00','ET','2',2,1,'William Johnson','FI','343527108','Summa Insurance Company, Inc.','FI','341809108','Matthew G Harris','94','2041418','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:33',0,'2014-03-10 16:38:05'),(3145,3145,'2014-01-01','ET','2',1,NULL,'Christy Fahnestock','FI','296765921','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:36',0,'2014-03-10 13:24:34'),(19259,19909,'0000-00-00','ET','2',1,NULL,'winston staton','FI','296545640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-03','Sync Success',0,'2014-02-17 19:00:05',0,'2014-03-01 17:34:07'),(17192,17842,'0000-00-00','ET','2',1,NULL,'Dominique Robinson','FI','456794604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-05 21:00:05',0,'2014-03-02 06:24:38'),(16881,17531,'0000-00-00','ET','2',1,NULL,'Brandt Baars','FI','640102405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:15',0,'2014-03-02 06:17:30'),(13790,14146,'2014-01-01','ET','2',2,1,'Larry Scott','FI','427041704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:39',0,'2014-03-02 05:24:45'),(15252,15703,'0000-00-00','ET','2',1,NULL,'Shirl Einhaus','FI','465351950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:30',0,'2014-03-02 05:52:31'),(22522,23172,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:27',0,'2014-03-07 21:36:32'),(2451,2451,'2014-01-01','ET','2',1,NULL,'Bickford Joseph Cole','FI','433887571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:53',0,'2014-03-01 23:10:52'),(19820,20470,'0000-00-00','ET','2',2,1,'SHUFEN LIU','FI','642112575','Starmount Life Insurance Company','FI','720977315','DEQING  YANG','94','11179161','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:39',0,'2014-03-02 07:03:25'),(5825,5825,'2014-01-01','ET','2',2,1,'MYUNG SHIN','FI','632206512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:14',0,'2014-03-01 20:10:57'),(5143,5143,'2014-01-01','ET','2',1,NULL,'Karen A Treadway','FI','279500538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:36',0,'2014-03-10 15:45:56'),(3603,3603,'2014-01-01','ET','2',1,NULL,'Ed Ball','FI','274601003','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:27',0,'2014-03-10 15:52:36'),(10562,10562,'2014-01-01','ET','2',1,NULL,'charlet ann washburn','FI','455063849','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:57',0,'2014-03-02 04:24:47'),(11045,11045,'2014-01-01','ET','2',1,NULL,'James Rafferty','FI','279504293','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:18',0,'2014-03-10 16:03:49'),(12151,12151,'2014-01-01','ET','2',2,1,'ANDREA ROBINSON','FI','587485187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:28',0,'2014-03-02 04:59:36'),(19256,19906,'0000-00-00','ET','2',1,NULL,'Johnna Gustafson','FI','280808568','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-03','Sync Success',0,'2014-02-16 19:00:44',0,'2014-03-10 16:31:33'),(17965,18615,'0000-00-00','ET','2',2,1,'Carl Edward Morlan','FI','301460455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:14',0,'2014-03-01 17:26:36'),(82,82,'2014-01-01','ET','2',1,NULL,'Josephine Ruiz Healy','FI','455614413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:29',0,'2014-03-01 22:10:55'),(703,703,'2014-01-01','ET','2',1,NULL,'Anna Zacharias','FI','292849717','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:50',0,'2014-03-10 13:24:34'),(7050,7050,'2014-01-01','ET','2',1,NULL,'Angel Lambert','FI','419194031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:02',0,'2014-03-02 03:09:49'),(18849,19499,'0000-00-00','ET','2',1,NULL,'charlmayne theriot','FI','438063796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:25',0,'2014-03-02 06:52:12'),(4128,4128,'2014-01-01','ET','2',1,NULL,'Linda Randall','FI','048448215','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:03',0,'2014-03-01 16:00:27'),(17387,18037,'0000-00-00','ET','2',1,NULL,'Kimberly Bryant','FI','282520915','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:33',0,'2014-03-01 17:20:55'),(12066,12066,'2014-01-01','ET','2',2,1,'Katariina Lawson','FI','277528183','Dental Care Plus, Inc.','FI','311185262','Adam  Damrill','94','16802443','348','2014-02-01','Sync Success',0,'2014-01-01 12:04:35',0,'2014-03-01 16:30:17'),(11505,11505,'2014-01-01','ET','2',1,NULL,'Rafael delaflor','FI','385904382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:48',0,'2014-03-02 04:59:36'),(6140,6140,'2014-01-01','ET','2',1,NULL,'Will Sawatsky','FI','302700850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:32',0,'2014-03-01 16:00:27'),(21600,22250,'0000-00-00','ET','2',1,NULL,'Ruben Tavitas','FI','454316648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:19',0,'2014-03-04 21:27:16'),(11188,11188,'2014-01-01','ET','2',1,NULL,'Christine Corfield','FI','194522380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:04',0,'2014-03-01 16:23:43'),(11693,11693,'2014-01-01','ET','2',1,NULL,'MARY  J  SERVIN','FI','458886324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:43',0,'2014-03-02 04:59:36'),(12662,12662,'2014-01-01','ET','2',1,NULL,'REBECCA  CODER','FI','281529922','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:25',0,'2014-03-01 16:35:14'),(13148,13504,'2014-01-01','ET','2',1,NULL,'Paula Walters','FI','287782314','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:50',0,'2014-03-10 13:59:38'),(14186,14637,'2014-01-01','ET','2',1,NULL,'Claire Spann','FI','267874344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:33:30',0,'2014-03-02 05:38:34'),(14569,15020,'2014-01-01','ET','2',1,NULL,'Frank Grace','FI','352626942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:30',0,'2014-03-02 05:45:37'),(14909,15360,'2014-01-01','ET','2',1,NULL,'Ricka  Johnson','FI','433177889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:28',0,'2014-03-02 05:52:31'),(20534,21184,'0000-00-00','ET','2',1,NULL,'Ruby Banks','FI','464840714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:06',0,'2014-03-02 07:10:28'),(19860,20510,'0000-00-00','ET','2',1,NULL,'Kim McCarthy','FI','278023754','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:11',0,'2014-03-10 14:37:47'),(18307,18957,'0000-00-00','ET','2',1,NULL,'Reda Finney','FI','425117099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:10',0,'2014-03-02 06:45:14'),(18082,18732,'0000-00-00','ET','2',1,NULL,'Cyril  Friday','FI','635364505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:25',0,'2014-03-02 06:38:05'),(2880,2880,'2014-01-01','ET','2',1,NULL,'Conny Warren','FI','282503332','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:00',0,'2014-03-10 13:39:10'),(15426,15877,'0000-00-00','ET','2',1,NULL,'GERALD WILSON','FI','283782545','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:26',0,'2014-03-01 16:50:53'),(12299,12299,'2014-01-01','ET','2',1,NULL,'Patti Penhorwood','FI','273741282','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:25:16',0,'2014-03-10 13:59:38'),(10479,10479,'2014-01-01','ET','2',1,NULL,'KELLY EVANS','FI','277788113','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:14',0,'2014-03-01 16:10:36'),(17140,17790,'0000-00-00','ET','2',2,1,'Bevan Evans','FI','281587141','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:25',0,'2014-03-10 16:24:30'),(14848,15299,'2014-01-01','ET','2',4,3,'Roy Scott','FI','288645071','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:30',0,'2014-03-10 14:10:12'),(5206,5206,'2014-01-01','ET','2',1,NULL,'Jody Tucker','FI','527885307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:34',0,'2014-03-02 00:10:48'),(22439,23089,'0000-00-00','ET','2',1,NULL,'Kevin Walker','FI','467046959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:27',0,'2014-03-07 22:26:59'),(20123,20773,'0000-00-00','ET','2',1,NULL,'zeinab ali','FI','218045878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:30:36',0,'2014-03-01 18:08:07'),(15044,15495,'2014-01-01','ET','2',1,NULL,'Carrie Burford','FI','416231365','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:28',0,'2014-03-02 05:45:37'),(5119,5119,'2014-01-01','ET','2',2,1,'BRUCE TAKACH','FI','291567856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:51',0,'2014-03-10 15:45:56'),(4523,4523,'2014-01-01','ET','2',1,NULL,'LAJUNA CHANAIE CARTER','FI','427292160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:51',0,'2014-03-01 21:11:04'),(6039,6039,'2014-01-01','ET','2',1,0,'Darrell Crain','FI','285749790','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:12',0,'2014-03-01 15:05:09'),(16689,17339,'0000-00-00','ET','2',4,3,'Johnny Shaw','FI','296862970','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:09',0,'2014-03-10 14:20:26'),(16267,16916,'0000-00-00','ET','2',1,NULL,'Alberta  A Siegrist','FI','282580055','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:23',0,'2014-03-10 14:20:26'),(721,721,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:07:28',0,'2014-03-10 13:24:34'),(7630,7630,'2014-01-01','ET','2',1,NULL,'Suely Buller','FI','505113140','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:14',0,'2014-03-10 15:59:47'),(13221,13577,'2014-01-01','ET','2',1,NULL,'KATHY POWERS','FI','465929414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:55',0,'2014-03-02 05:17:40'),(2658,2658,'2014-01-01','ET','2',2,1,'Daniel Brown','FI','285648138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:43',0,'2014-03-01 16:05:34'),(5472,5472,'2014-01-01','ET','2',2,1,'Surnovia Tibbs','FI','437331829','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:30',0,'2014-03-02 04:45:37'),(12343,12343,'2014-01-01','ET','2',2,1,'Taylor Phan','FI','561676630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:39',0,'2014-03-02 05:03:29'),(3751,3751,'2014-01-01','ET','2',2,1,'NICOLE MOLONEY','FI','276742394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:14',0,'2014-03-10 13:24:34'),(11940,11940,'2014-01-01','ET','2',1,NULL,'RAYMOND SNOW','FI','308521238','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-30 00:02:18',0,'2014-03-10 13:52:32'),(19021,19671,'0000-00-00','ET','2',4,3,'Christopher Trimmer','FI','289866896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:04',0,'2014-03-01 17:34:07'),(15654,16303,'0000-00-00','ET','2',2,1,'angel marie priscilla hildreth','FI','004765074','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:15',0,'2014-03-01 16:56:22'),(10565,10565,'2014-01-01','ET','2',1,NULL,'HELEN  DAWSON','FI','461575053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:02',0,'2014-03-02 04:24:47'),(7218,7218,'2014-01-01','ET','2',1,NULL,'TAMMIE MAIDEN','FI','300662959','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:10',0,'2014-03-01 15:52:44'),(12809,12809,'2014-01-01','ET','2',1,NULL,'Diana Molina','FI','509060907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:01:35',0,'2014-03-02 05:17:40'),(5495,5495,'2014-01-01','ET','2',1,NULL,'Kristina Audette','FI','008700303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:15',0,'2014-03-01 16:23:43'),(887,887,'2014-01-01','ET','2',1,NULL,'Willis Jackson','FI','272549569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:46',0,'2014-03-01 15:21:15'),(5010,5010,'2014-01-01','ET','2',1,NULL,'CECIL JONES','FI','284489630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:46:19',0,'2014-03-01 15:31:33'),(19009,19659,'0000-00-00','ET','2',1,NULL,'KELLY J SANCHEZ','FI','295685673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:21',0,'2014-03-10 14:31:05'),(15726,16375,'0000-00-00','ET','2',1,NULL,'Dana Antoinette Mcafee','FI','436251708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:06',0,'2014-03-02 05:59:43'),(5628,5628,'2014-01-01','ET','2',1,NULL,'karen waheed','FI','295625097','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:39',0,'2014-03-10 16:03:49'),(14551,15002,'2014-01-01','ET','2',1,NULL,'olywatosin akinwole','FI','637159537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:18',0,'2014-03-02 05:45:37'),(12713,12713,'2014-01-01','ET','2',1,NULL,'marcus harris','FI','587233995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:15',0,'2014-03-02 05:10:52'),(14327,14778,'2014-01-01','ET','2',1,NULL,'DANIELA WOO','FI','645544654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:36',0,'2014-03-02 05:38:34'),(847,847,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:33',0,'2014-03-01 22:10:55'),(10741,10741,'2014-01-01','ET','2',1,NULL,'Maura Alyse Albers','FI','278909528','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:55',0,'2014-03-01 16:10:36'),(21803,22453,'0000-00-00','ET','2',1,NULL,'Benjamin Tupaz','FI','269703499','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:18',0,'2014-03-04 21:36:30'),(17803,18453,'0000-00-00','ET','2',1,NULL,'Cassie Screngi','FI','270829347','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:36',0,'2014-03-01 16:56:22'),(4942,4942,'2014-01-01','ET','2',1,NULL,'STEVEN ALVAREZ','FI','465793184','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:31',0,'2014-03-01 20:10:57'),(16264,16913,'0000-00-00','ET','2',1,NULL,'anthony bear','FI','302660201','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:21',0,'2014-03-10 14:20:26'),(15569,16020,'0000-00-00','ET','2',1,NULL,'alaa Iberahim','FI','278982915','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:22',0,'2014-03-01 16:50:53'),(11003,11003,'2014-01-01','ET','2',1,NULL,'CARRIE M COLLINS','FI','587505955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:53',0,'2014-03-02 04:31:46'),(14320,14771,'2014-01-01','ET','2',1,NULL,'Kim Gordoa','FI','265396060','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:33',0,'2014-03-02 05:38:34'),(22971,23621,'0000-00-00','ET','2',1,NULL,'Terry Atkinson','FI','300808130','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:31',0,'2014-03-10 21:36:25'),(827,827,'2014-01-01','ET','2',1,NULL,'Marcus John Turella','FI','452879800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:13',0,'2014-03-01 19:11:03'),(2981,2981,'2014-01-01','ET','2',1,NULL,'lauren tyrone','FI','466796585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:34',0,'2014-03-02 01:10:33'),(22173,22823,'0000-00-00','ET','2',1,NULL,'Donna SUPPLENUSBAUM','FI','278522850','Dental Care Plus, Inc.','FI','311185262','Cristopher  Alamo','94','12748504','357','2014-04-01','Sync Success',0,'2014-03-06 21:01:20',0,'2014-03-06 21:36:23'),(19047,19697,'0000-00-00','ET','2',1,NULL,'Bruno Jose Vinezof','FI','819408249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:05',0,'2014-03-02 06:52:12'),(12625,12625,'2014-01-01','ET','2',1,NULL,'DORA VONG','FI','460498941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:01:59',0,'2014-03-02 05:10:52'),(12983,12983,'2014-01-01','ET','2',1,NULL,'cheryl alexander','FI','425439947','Starmount Life Insurance Company','FI','720977315','Isaac  Ruiz','94','17029214','357','2014-02-01','Sync Success',0,'2014-01-05 00:01:33',0,'2014-03-02 05:17:40'),(16919,17569,'0000-00-00','ET','2',1,NULL,'Saundra Rudolph','FI','296627140','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:00:38',0,'2014-03-01 17:00:58'),(14192,14643,'2014-01-01','ET','2',1,NULL,'Clarian Honeycutt','FI','409826668','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:34',0,'2014-03-10 14:03:26'),(14916,15367,'2014-01-01','ET','2',4,3,'Matthew Henry','FI','576629098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:31',0,'2014-03-01 16:50:53'),(15759,16408,'0000-00-00','ET','2',1,NULL,'TENA DEVEREUX','FI','414940712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:01:28',0,'2014-03-02 05:59:43'),(21974,22624,'0000-00-00','ET','2',1,NULL,'Bathsheba Cole','FI','587411965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:35',0,'2014-03-05 22:27:33'),(7597,7597,'2014-01-01','ET','2',1,NULL,'Christine Rockwell','FI','287869405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:12',0,'2014-03-10 15:59:47'),(15516,15967,'0000-00-00','ET','2',2,1,'Carolyn Ray','FI','451130428','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-23 03:01:58',0,'2014-03-02 05:59:43'),(11968,11968,'2014-01-01','ET','2',1,NULL,'John Lambert','FI','464966511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:52',0,'2014-03-02 04:59:36'),(3262,3262,'2014-01-01','ET','2',4,3,'LINDA KAY CHESMAR','FI','276661335','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:11',0,'2014-03-10 15:52:36'),(4034,4034,'2014-01-01','ET','2',1,NULL,'CHARICE R INGRAM','FI','098563576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:11',0,'2014-03-02 03:09:49'),(3981,3981,'2014-01-01','ET','2',1,NULL,'Paula Griffin','FI','274745472','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:36',0,'2014-03-10 13:10:24'),(22860,23510,'0000-00-00','ET','2',1,NULL,'April Bryce','FI','385860603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:10',0,'2014-03-10 21:27:11'),(1475,1475,'2014-01-01','ET','2',1,NULL,'Maria Getz','FI','301680204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:56:39',0,'2014-03-01 16:23:43'),(2588,2588,'2014-01-01','ET','2',1,NULL,'paul w jackson','FI','287748486','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:36',0,'2014-03-10 15:39:19'),(10864,10864,'2014-01-01','ET','2',1,NULL,'DEBRA WAGNER','FI','272603406','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-26 13:05:58',0,'2014-03-10 13:45:57'),(21890,22540,'0000-00-00','ET','2',2,1,'rudy vilchis','FI','615461567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:36',0,'2014-03-05 22:27:33'),(19428,20078,'0000-00-00','ET','2',1,NULL,'TASHA FLEMONS','FI','587315672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:29',0,'2014-03-02 06:59:07'),(4186,4186,'2014-01-01','ET','2',1,NULL,'Michael T Powers','FI','274889007','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:49',0,'2014-03-10 15:59:47'),(18393,19043,'0000-00-00','ET','2',1,NULL,'ROGERICK WILSON','FI','426135404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:55',0,'2014-03-02 06:45:14'),(17914,18564,'0000-00-00','ET','2',1,NULL,'Myron Howard','FI','460455325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:39',0,'2014-03-02 06:38:05'),(21707,22357,'0000-00-00','ET','2',1,NULL,'KATHERINE TOLDEN','FI','587341390','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:44',0,'2014-03-04 21:27:16'),(22383,23033,'0000-00-00','ET','2',2,1,'Elizabeth Kline','FI','288544215','Summa Insurance Company, Inc.','FI','341809108','John C Dalziel','94','362362','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:27',0,'2014-03-10 16:44:18'),(23048,23698,'0000-00-00','ET','2',1,NULL,'MAURINE CATHERINE KING','FI','426025106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:02:26',0,'2014-03-10 21:27:11'),(19445,20095,'0000-00-00','ET','2',1,NULL,'Sydney Mendel','FI','274587620','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:42',0,'2014-03-10 16:31:33'),(19113,19763,'0000-00-00','ET','2',2,1,'shane dotson','FI','435534755','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:53',0,'2014-03-10 14:31:05'),(12779,12779,'2014-01-01','ET','2',2,1,'Jose  F Garcia','FI','346724313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:29',0,'2014-03-02 05:10:52'),(18919,19569,'0000-00-00','ET','2',1,NULL,'Regina Cleaves','FI','461817740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:16',0,'2014-03-02 06:52:12'),(16767,17417,'0000-00-00','ET','2',1,NULL,'sharanda Gibbs','FI','435699260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:20',0,'2014-03-02 06:17:30'),(1286,1286,'2014-01-01','ET','2',1,NULL,'Sandra Shepard','FI','287562555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:21',0,'2014-03-01 16:23:43'),(3088,3088,'2014-01-01','ET','2',1,NULL,'JOHN HOLMES','FI','436252032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:50',0,'2014-03-02 01:10:33'),(3726,3726,'2014-01-01','ET','2',1,NULL,'Gregory Gable','FI','297563920','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:24',0,'2014-03-10 13:20:27'),(22805,23455,'0000-00-00','ET','2',4,3,'LAURA CALVERT','FI','274644490','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:55',0,'2014-03-10 16:44:18'),(1463,1463,'2014-01-01','ET','2',1,NULL,'David Danner','FI','299649604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:56:13',0,'2014-03-01 16:23:43'),(16855,17505,'0000-00-00','ET','2',1,NULL,'Tonya Joanne Guggenheim','FI','452738652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:28',0,'2014-03-02 06:17:30'),(13260,13616,'2014-01-01','ET','2',1,NULL,'Tammy Perritt','FI','436438078','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:23:56',0,'2014-03-02 05:24:45'),(11062,11062,'2014-01-01','ET','2',2,1,'James Thompson','FI','299644575','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-26 13:12:53',0,'2014-03-10 16:03:49'),(11024,11024,'2014-01-01','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:37',0,'2014-03-10 13:45:57'),(5828,5828,'2014-01-01','ET','2',1,NULL,'Noreen Jackson','FI','461862664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:20',0,'2014-03-01 21:11:04'),(7286,7286,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:16',0,'2014-03-10 13:32:15'),(21716,22366,'0000-00-00','ET','2',1,NULL,'Ronnie Courtney','FI','438356900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:51',0,'2014-03-04 21:27:16'),(409,409,'2014-01-01','ET','2',1,NULL,'Elizabeth Keeney','FI','035325466','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:40',0,'2014-03-01 15:21:15'),(14324,14775,'2014-01-01','ET','2',1,NULL,'Jahlil Vandroff','FI','616765748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:34',0,'2014-03-02 05:38:34'),(19678,20328,'0000-00-00','ET','2',5,4,'Deanna Nowland','FI','301605166','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-20 04:49:58',0,'2014-03-10 14:37:47'),(5350,5350,'2014-01-01','ET','2',1,NULL,'Jeanne Keltz','FI','287482424','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:51',0,'2014-03-10 15:39:19'),(12751,12751,'2014-01-01','ET','2',1,NULL,'Kimberley Brown','FI','426354641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:44',0,'2014-03-02 05:10:52'),(3930,3930,'2014-01-01','ET','2',2,1,'Beau M Minson','FI','436857610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:56',0,'2014-03-01 23:10:52'),(10773,10773,'2014-01-01','ET','2',1,NULL,'Luke Layfield','FI','438718863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:02',0,'2014-03-02 04:24:47'),(4372,4372,'2014-01-01','ET','2',2,1,'Kathy Strickland','FI','456048108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:03',0,'2014-03-01 21:11:04'),(5,5,'2014-01-01','ET','2',1,NULL,'Laura Foster','FI','289749672','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:10',0,'2014-03-01 15:21:15'),(14631,15082,'2014-01-01','ET','2',1,NULL,'Deanna Pillsbury','FI','281861895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:09',0,'2014-03-01 16:46:19'),(12759,12759,'2014-01-01','ET','2',1,NULL,'Lindsey Waters','FI','281786492','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:04',0,'2014-03-10 13:59:38'),(12555,12555,'2014-01-01','ET','2',1,NULL,'Robin Nichpor','FI','300485308','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:28',0,'2014-03-10 13:59:38'),(12537,12537,'2014-01-01','ET','2',2,1,'Heather Haines','FI','286724532','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:43',0,'2014-03-10 13:59:38'),(12022,12022,'2014-01-01','ET','2',1,NULL,'Ha Nguyen','FI','433854160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:55',0,'2014-03-02 04:59:36'),(10687,10687,'2014-01-01','ET','2',1,NULL,'Donald Hoffman','FI','294540011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:00:04',0,'2014-03-01 16:10:36'),(2645,2645,'2014-01-01','ET','2',1,NULL,'Whitney Mantonya','FI','296767864','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:15:15',0,'2014-03-01 16:05:34'),(2233,2233,'2014-01-01','ET','2',2,1,'Keith Griggs','FI','269700920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:19',0,'2014-03-10 15:39:19'),(1982,1982,'2014-01-01','ET','2',1,NULL,'Cary A Davidson','FI','285766870','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:15',0,'2014-03-10 15:45:56'),(6198,6198,'2014-01-01','ET','2',2,1,'tuan diep','FI','084769983','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:17',0,'2014-03-01 16:00:27'),(21544,22194,'0000-00-00','ET','2',1,NULL,'Stephanie Ball','FI','282867258','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:27',0,'2014-03-10 14:45:25'),(22313,22963,'0000-00-00','ET','2',1,NULL,'CRISTIANA  REYES','FI','082311308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:07',0,'2014-03-06 22:25:29'),(2483,2483,'2014-01-01','ET','2',1,NULL,'Kimberly Jones','FI','301489370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:57',0,'2014-03-10 13:10:24'),(5605,5605,'2014-01-01','ET','2',2,1,'Andrew Koha','FI','282607681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:48',0,'2014-03-01 16:23:43'),(20030,20680,'0000-00-00','ET','2',1,NULL,'Gwendolyn Licciardi Everhardt','FI','436940793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:13',0,'2014-03-02 07:03:25'),(14699,15150,'2014-01-01','ET','2',2,1,'Meghan Hemingway','94','0001208246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:54',0,'2014-03-02 05:45:37'),(19595,20245,'0000-00-00','ET','2',1,NULL,'susan snider','FI','459926046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:31:19',0,'2014-03-02 06:59:07'),(13713,14069,'2014-01-01','ET','2',2,1,'Diana Carr','FI','282660861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:49',0,'2014-03-01 16:40:16'),(14121,14572,'2014-01-01','ET','2',1,NULL,'Gaines Gafford','FI','439471697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:49',0,'2014-03-02 05:38:34'),(3168,3168,'2014-01-01','ET','2',4,3,'Caroline Sokol','FI','275748421','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:21',0,'2014-03-10 15:52:36'),(2702,2702,'2014-01-01','ET','2',1,NULL,'Holly Nicole Green-Parks','FI','464856498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:16',0,'2014-03-02 04:15:49'),(22060,22710,'0000-00-00','ET','2',2,1,'Kay Wurns','FI','281500837','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:36',0,'2014-03-10 14:45:25'),(599,599,'2014-01-01','ET','2',1,NULL,'Candace Anderson','FI','458633094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:33',0,'2014-03-02 02:10:49'),(20220,20870,'0000-00-00','ET','2',4,3,'MICHAEL WELLS','FI','587411940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:46',0,'2014-03-02 07:10:28'),(11848,11848,'2014-01-01','ET','2',1,NULL,'DIANE ARMOUR','FI','299584575','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:41',0,'2014-03-01 16:15:39'),(15239,15690,'0000-00-00','ET','2',2,1,'AHMED  HASSAN','FI','600796927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:20',0,'2014-03-01 16:50:53'),(1370,1370,'2014-01-01','ET','2',1,NULL,'Victoriano Espinoza','FI','450948034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:03',0,'2014-03-02 04:38:08'),(5135,5135,'2014-01-01','ET','2',1,NULL,'Kelly Barriball','FI','298820731','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:22',0,'2014-03-10 15:45:56'),(21710,22360,'0000-00-00','ET','2',1,NULL,'Regina Washington','FI','384908103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:46',0,'2014-03-04 21:27:16'),(21937,22587,'0000-00-00','ET','2',1,NULL,'velna rodriguez','FI','461514811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:09',0,'2014-03-05 22:27:33'),(310,310,'2014-01-01','ET','2',1,NULL,'Bilindra Robinson','FI','454491889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:30',0,'2014-03-01 22:10:55'),(20715,21365,'0000-00-00','ET','2',1,NULL,'STEPHEN D CIANELLI','FI','293662470','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:18',0,'2014-03-01 18:08:07'),(5054,5054,'2014-01-01','ET','2',1,NULL,'Patricia Deloatch','FI','578900535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:44',0,'2014-03-01 15:31:33'),(19565,20215,'0000-00-00','ET','2',1,NULL,'MARCENETTE Carney','FI','436457746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:21:42',0,'2014-03-02 06:59:07'),(19269,19919,'0000-00-00','ET','2',1,NULL,'charles nelson','FI','463455742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:12',0,'2014-03-02 06:52:12'),(16631,17281,'0000-00-00','ET','2',1,NULL,'KATY HIRSCHFELD','FI','156889065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:28',0,'2014-03-02 06:17:30'),(16956,17606,'0000-00-00','ET','2',2,1,'James Davis','FI','437572488','Starmount Life Insurance Company','FI','720977315','Mary  Siggers','94','15257239','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:02',0,'2014-03-02 06:24:38'),(21084,21734,'0000-00-00','ET','2',4,3,'BREANNE  CAVILEER','FI','292784922','Summa Insurance Company, Inc.','FI','341809108','RICK  LOHR','94','15886837','348','2014-01-01','Sync Success',0,'2014-02-28 21:30:36',0,'2014-03-10 16:38:05'),(22769,23419,'0000-00-00','ET','2',1,NULL,'Allan Ray Moore','FI','457829859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:25',0,'2014-03-09 21:26:00'),(22966,23616,'0000-00-00','ET','2',1,NULL,'Jillian Kehr','FI','007904190','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:27',0,'2014-03-10 21:36:25'),(23033,23683,'0000-00-00','ET','2',1,NULL,'Phillip Dunseith','FI','274520256','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:16',0,'2014-03-10 21:17:52'),(20992,21642,'0000-00-00','ET','2',1,NULL,'jack givens','FI','278543243','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:33',0,'2014-03-10 16:38:05'),(20356,21006,'0000-00-00','ET','2',1,NULL,'Cherie Hornacek','FI','296503147','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:43',0,'2014-03-10 16:38:05'),(3518,3518,'2014-01-01','ET','2',1,NULL,'ERIN Johnston','FI','287821078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:45',0,'2014-03-01 15:37:30'),(3027,3027,'2014-01-01','ET','2',1,NULL,'Christy Fahnestock','FI','296765921','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:56',0,'2014-03-01 15:37:30'),(1421,1421,'2014-01-01','ET','2',1,NULL,'Lorie Hopkins','FI','274503968','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:45',0,'2014-03-10 13:45:57'),(725,725,'2014-01-01','ET','2',2,1,'Andrew Chadwick','FI','012704909','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:34',0,'2014-03-10 13:24:34'),(18625,19275,'0000-00-00','ET','2',1,NULL,'Connie Mayo','FI','283509204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:55',0,'2014-03-01 17:26:36'),(15827,16476,'0000-00-00','ET','2',1,NULL,'Shelly Galatas','FI','439677773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-24 21:00:27',0,'2014-03-02 06:03:21'),(15489,15940,'0000-00-00','ET','2',1,NULL,'DEBORAH LEE VARGO','FI','287541072','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:07',0,'2014-03-10 14:10:12'),(22457,23107,'0000-00-00','ET','2',1,NULL,'Cynthia Keough','FI','210546434','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:40',0,'2014-03-10 16:44:18'),(20529,21179,'0000-00-00','ET','2',1,NULL,'thu t le','FI','808336161','Starmount Life Insurance Company','FI','720977315','ngoc  tran','94','2144493807','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:03',0,'2014-03-02 07:10:28'),(17869,18519,'0000-00-00','ET','2',1,NULL,'Nancy Kopp','FI','300501249','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:05',0,'2014-03-10 14:24:38'),(16079,16728,'0000-00-00','ET','2',2,1,'JACQUELYN CARPENTER','FI','272800397','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:03',0,'2014-03-01 16:56:22'),(13471,13827,'2014-01-01','ET','2',1,NULL,'JOETTA JOHNSON','FI','278547065','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:33',0,'2014-03-10 16:17:47'),(11408,11408,'2014-01-01','ET','2',2,1,'Brian Strayer','FI','302728216','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:49',0,'2014-03-10 13:52:32'),(2273,2273,'2014-01-01','ET','2',1,NULL,'GENOVEVA ACOSTA MORALES','FI','506518308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:16',0,'2014-03-01 21:11:04'),(5551,5551,'2014-01-01','ET','2',2,1,'Marlene Vazquez','FI','640342969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:04',0,'2014-03-02 04:45:37'),(6278,6278,'2014-01-01','ET','2',1,NULL,'BRIANA DELANEUVILLE','FI','434906827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:47',0,'2014-03-02 04:10:25'),(19892,20542,'0000-00-00','ET','2',1,NULL,'DANA BUMSTED','FI','479921923','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:39',0,'2014-03-10 14:37:47'),(17850,18500,'0000-00-00','ET','2',1,NULL,'Delilah Meyers','FI','277808240','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-10 21:00:02',0,'2014-03-10 14:24:38'),(13056,13412,'2014-01-01','ET','2',1,NULL,'Nicole Fury','FI','437719112','Starmount Life Insurance Company','FI','720977315','Paul   Rogyom','94','1224483','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:18',0,'2014-03-02 05:17:40'),(12059,12059,'2014-01-01','ET','2',1,NULL,'Danute Minkovskaya','FI','641663026','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:19',0,'2014-03-02 05:03:29'),(12036,12036,'2014-01-01','ET','2',1,NULL,'Rena P Thomas','FI','433045702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:27',0,'2014-03-02 05:03:29'),(11025,11025,'2014-01-01','ET','2',1,NULL,'Christina Sevilla Stear','FI','301849481','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:39',0,'2014-03-10 13:45:57'),(16876,17526,'0000-00-00','ET','2',1,NULL,'James Lee','FI','458960270','Starmount Life Insurance Company','FI','720977315','Gregg Carter Givens','94','16805799','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:13',0,'2014-03-02 06:17:30'),(3801,3801,'2014-01-01','ET','2',1,NULL,'Erik Duncan','FI','294785494','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:21',0,'2014-03-10 15:45:56'),(799,799,'2014-01-01','ET','2',1,NULL,'christopher frantz','FI','277665752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:08',0,'2014-03-10 13:03:33'),(21435,22085,'0000-00-00','ET','2',1,NULL,'Gail L Berman','FI','271541436','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:06',0,'2014-03-10 16:38:05'),(21241,21891,'0000-00-00','ET','2',1,NULL,'MEITA TAMBI','FI','243112931','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:24',0,'2014-03-01 21:35:40'),(20124,20774,'0000-00-00','ET','2',1,NULL,'Dena Glasser','FI','281805739','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:36',0,'2014-03-01 18:08:07'),(19046,19696,'0000-00-00','ET','2',2,1,'Ted Woodruff','FI','456932148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:04',0,'2014-03-02 06:52:12'),(18616,19266,'0000-00-00','ET','2',1,NULL,'Beth Dawson','FI','272549911','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:47',0,'2014-03-10 16:31:33'),(11687,11687,'2014-01-01','ET','2',1,NULL,'Candy Garza','FI','451027720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:31',0,'2014-03-02 04:59:36'),(10736,10736,'2014-01-01','ET','2',1,NULL,'Billy Sage','FI','590887438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:45',0,'2014-03-01 16:10:36'),(18083,18733,'0000-00-00','ET','2',1,NULL,'Philip Hollister','FI','462534545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:00:26',0,'2014-03-02 06:38:05'),(882,882,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:16:38',0,'2014-03-01 15:21:15'),(3664,3664,'2014-01-01','ET','2',1,NULL,'Gary E Messina','FI','438043501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:21',0,'2014-03-02 01:10:33'),(4684,4684,'2014-01-01','ET','2',1,NULL,'Susan Smylie','FI','457198664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:06',0,'2014-03-02 04:31:46'),(3251,3251,'2014-01-01','ET','2',1,NULL,'Teresa Reusser','FI','281508245','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:53',0,'2014-03-01 15:52:44'),(21825,22475,'0000-00-00','ET','2',1,NULL,'EZEKIEL LESLIE WILSON','FI','294666967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:20',0,'2014-03-05 21:36:22'),(22326,22976,'0000-00-00','ET','2',3,2,'Terence Smith','FI','379786658','HealthSpan','FI','311431434','Philip  Dubois','94','2345683','348','2014-04-01','Sync Success',0,'2014-03-06 21:30:16',0,'2014-03-10 14:50:59'),(12169,12169,'2014-01-01','ET','2',1,NULL,'Frank Heuer','FI','439040131','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:08:05',0,'2014-03-02 05:03:29'),(12104,12104,'2014-01-01','ET','2',1,NULL,'Rebecca Zink','FI','291560167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:51',0,'2014-03-01 16:30:17'),(11160,11160,'2014-01-01','ET','2',2,1,'Melissa Boitnott','FI','294762476','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:17',0,'2014-03-10 13:45:57'),(18403,19053,'0000-00-00','ET','2',2,1,'Kevin Kossick','FI','278828943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:03',0,'2014-03-01 17:26:36'),(18344,18994,'0000-00-00','ET','2',1,NULL,'Whitney London','FI','435833914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-26','Sync Success',0,'2014-02-12 21:30:22',0,'2014-03-02 06:45:14'),(346,346,'2014-01-01','ET','2',2,1,'Lauren Obrien','FI','177483189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:40',0,'2014-03-01 15:21:15'),(12289,12289,'2014-01-01','ET','2',1,NULL,'Michele Irene Sommer','FI','275524795','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:52',0,'2014-03-01 16:35:14'),(11290,11290,'2014-01-01','ET','2',1,NULL,'Raquell Perry','FI','435236201','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','348','2014-02-01','Sync Success',0,'2013-12-27 02:03:12',0,'2014-03-02 04:52:44'),(11197,11197,'2014-01-01','ET','2',1,NULL,'Jeffrey Bohlmann','FI','294863389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:20',0,'2014-03-01 16:23:43'),(423,423,'2014-01-01','ET','2',1,NULL,'Cynthia Murrell','FI','272505315','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:08',0,'2014-03-01 15:21:15'),(11098,11098,'2014-01-01','ET','2',1,NULL,'KYLE FRANKLIN HILL','FI','278843235','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:01',0,'2014-03-10 13:45:57'),(2535,2535,'2014-01-01','ET','2',1,NULL,'JASON MEEKER','FI','285866602','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:04',0,'2014-03-01 15:10:22'),(2623,2623,'2014-01-01','ET','2',4,3,'Christopher Scott','FI','279661736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:41',0,'2014-03-01 15:16:37'),(2909,2909,'2014-01-01','ET','2',1,NULL,'Shemekisa Jobe','FI','553719706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:30:14',0,'2014-03-02 01:10:33'),(3686,3686,'2014-01-01','ET','2',1,NULL,'robert stewart','FI','334605123','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:02',0,'2014-03-10 13:20:27'),(3717,3717,'2014-01-01','ET','2',2,1,'SHARON L WALLACE','FI','285701200','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:06',0,'2014-03-10 13:24:34'),(5539,5539,'2014-01-01','ET','2',1,NULL,'Jamal Bailey','FI','160640680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:41',0,'2014-03-01 16:23:43'),(4102,4102,'2014-01-01','ET','2',1,NULL,'Falon Conti','FI','285861196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:18',0,'2014-03-01 16:00:27'),(4163,4163,'2014-01-01','ET','2',1,NULL,'courtney stalnaker','FI','274866517','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:05',0,'2014-03-10 15:59:47'),(12485,12485,'2014-01-01','ET','2',1,NULL,'LARRY WALKER','FI','297647657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:45',0,'2014-03-01 16:35:14'),(13115,13471,'2014-01-01','ET','2',1,NULL,'MARIA ROSARIO BARRERA','FI','553867089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:31',0,'2014-03-02 05:17:40'),(13629,13985,'2014-01-01','ET','2',1,NULL,'Jessica Hawkins','FI','438673343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:46',0,'2014-03-02 05:24:45'),(15031,15482,'2014-01-01','ET','2',1,NULL,'Timothy Wayne Galloway','FI','438152545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:23',0,'2014-03-02 05:52:31'),(16657,17307,'0000-00-00','ET','2',1,NULL,'john eichenberg','FI','190463868','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:45',0,'2014-03-10 16:24:30'),(17181,17831,'0000-00-00','ET','2',1,NULL,'Douglas L Crill','FI','302429569','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:55',0,'2014-03-10 14:24:38'),(18878,19528,'0000-00-00','ET','2',1,NULL,'Nana  Hammond','FI','093593295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:46',0,'2014-03-01 17:34:07'),(20023,20673,'0000-00-00','ET','2',1,NULL,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-21 22:01:08',0,'2014-03-10 14:37:47'),(1562,1562,'2014-01-01','ET','2',5,4,'Martin Schultz','FI','276465911','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:23',0,'2014-03-10 13:52:32'),(4392,4392,'2014-01-01','ET','2',1,NULL,'hawo a shirkoobiye','FI','634842032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:41',0,'2014-03-01 15:16:37'),(7756,7756,'2014-01-01','ET','2',1,NULL,'Kathryn Cotton','FI','510603564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:05',0,'2014-03-01 19:11:03'),(7315,7315,'2014-01-01','ET','2',1,NULL,'Pamela Borsa','FI','172461826','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:10',0,'2014-03-10 13:32:15'),(7137,7137,'2014-01-01','ET','2',1,NULL,'BETTY BROCKMAN','FI','278662080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:40',0,'2014-03-01 15:52:44'),(4394,4394,'2014-01-01','ET','2',1,NULL,'MICHAEL BUTTRAM','FI','269769865','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:45',0,'2014-03-01 15:16:37'),(6379,6379,'2014-01-01','ET','2',1,NULL,'STACY  WARSAW','FI','366547546','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:50',0,'2014-03-10 13:39:10'),(5554,5554,'2014-01-01','ET','2',1,NULL,'Tiffany Stowell','FI','570399970','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:10',0,'2014-03-02 04:45:37'),(4876,4876,'2014-01-01','ET','2',2,1,'Joseph L Kauffman','FI','273442587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:28',0,'2014-03-10 15:39:19'),(13007,13007,'2014-01-01','ET','2',2,1,'John Wieman','FI','293561354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:23',0,'2014-03-01 16:35:14'),(13593,13949,'2014-01-01','ET','2',1,NULL,'GEORGE  PRESTON HITT','FI','451866496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:20',0,'2014-03-02 05:24:45'),(14987,15438,'2014-01-01','ET','2',2,1,'nazih Shteiwi','FI','286907535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:04',0,'2014-03-01 16:50:53'),(15171,15622,'0000-00-00','ET','2',1,NULL,'Riciarda Rawls','FI','249672496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:42',0,'2014-03-02 05:52:31'),(18686,19336,'0000-00-00','ET','2',1,NULL,'Deanna Redic','FI','461493031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:41',0,'2014-03-02 06:45:14'),(21388,22038,'0000-00-00','ET','2',1,NULL,'Richard Leighton','FI','279429339','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:03',0,'2014-03-03 21:36:16'),(21484,22134,'0000-00-00','ET','2',1,NULL,'JoAnn Moody','FI','291503304','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:44',0,'2014-03-03 21:36:16'),(19026,19676,'0000-00-00','ET','2',1,NULL,'Jon Overfield','FI','301720107','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-14 22:00:08',0,'2014-03-10 16:31:33'),(1741,1741,'2014-01-01','ET','2',1,NULL,'Desarae Constance Horton','FI','603709720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:43',0,'2014-03-01 15:31:33'),(12103,12103,'2014-01-01','ET','2',1,NULL,'Berneice Parton','FI','406786889','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:49',0,'2014-03-01 16:30:17'),(11753,11753,'2014-01-01','ET','2',1,NULL,'Kimberly McEacharn','FI','436533577','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:32',0,'2014-03-02 04:59:36'),(1788,1788,'2014-01-01','ET','2',4,3,'William Loughridge','FI','299669518','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:14',0,'2014-03-10 13:20:27'),(3274,3274,'2014-01-01','ET','2',1,NULL,'ashley pozos','FI','626564434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:38',0,'2014-03-02 02:10:49'),(5148,5148,'2014-01-01','ET','2',1,NULL,'TERRY  L PRESTAS','FI','268606757','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:45',0,'2014-03-10 15:45:56'),(4201,4201,'2014-01-01','ET','2',1,NULL,'Angie  Maag','FI','298821886','HealthSpan','FI','311431434','Lynnette  Hovest','94','8059678','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:16',0,'2014-03-10 13:32:15'),(3971,3971,'2014-01-01','ET','2',2,1,'Kareem Smith','FI','301867607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:16',0,'2014-03-01 15:26:40'),(13255,13611,'2014-01-01','ET','2',1,NULL,'Joshua Fitzpatrick','FI','296828678','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:20',0,'2014-03-10 13:59:38'),(16501,17151,'0000-00-00','ET','2',1,NULL,'Gregory Bowden','FI','457314224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:38',0,'2014-03-02 06:10:30'),(17184,17834,'0000-00-00','ET','2',1,NULL,'ANTHONY SINGIAN','FI','291969648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:57',0,'2014-03-10 14:24:38'),(17815,18465,'0000-00-00','ET','2',1,NULL,'KENNY ROGERS','FI','433069331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:48',0,'2014-03-02 06:03:21'),(20862,21512,'0000-00-00','ET','2',1,NULL,'Robert Church','FI','538546294','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:27',0,'2014-03-10 14:45:25'),(20922,21572,'0000-00-00','ET','2',1,NULL,'Christina Neher','FI','301603625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:14',0,'2014-03-01 18:08:07'),(21189,21839,'0000-00-00','ET','2',1,NULL,'Charles F Ross','FI','289522034','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:51',0,'2014-03-10 14:45:25'),(21709,22359,'0000-00-00','ET','2',1,NULL,'Michael Heck','FI','408211357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:45',0,'2014-03-04 21:27:16'),(22736,23386,'0000-00-00','ET','2',1,NULL,'Rose Tademy','FI','436042000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-09 21:00:01',0,'2014-03-09 21:26:00'),(150,150,'2014-01-01','ET','2',1,NULL,'Katy McMahon','FI','284922787','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:40',0,'2014-03-10 15:45:56'),(12510,12510,'2014-01-01','ET','2',1,NULL,'Van Bui','FI','586145273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:45',0,'2014-03-02 05:03:29'),(459,459,'2014-01-01','ET','2',1,NULL,'Teri Such','FI','276549836','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:16',0,'2014-03-10 13:10:24'),(1584,1584,'2014-01-01','ET','2',1,NULL,'Patrick Dougherty','FI','287561203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:45',0,'2014-03-01 15:10:22'),(1736,1736,'2014-01-01','ET','2',1,NULL,'MARY L KING','FI','289628834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:36',0,'2014-03-01 15:31:33'),(11701,11701,'2014-01-01','ET','2',1,NULL,'Rene Flores','FI','467638707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:07:56',0,'2014-03-02 04:59:36'),(10417,10417,'2014-01-01','ET','2',1,NULL,'Lisadarling Davis','FI','283724028','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:15',0,'2014-03-01 16:10:36'),(3110,3110,'2014-01-01','ET','2',1,NULL,'NOAH BUTLER','FI','437087131','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:28',0,'2014-03-02 01:10:33'),(3891,3891,'2014-01-01','ET','2',1,NULL,'Jarrell Robertson','FI','436658947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:56',0,'2014-03-01 19:11:03'),(4916,4916,'2014-01-01','ET','2',1,0,'Diana DeJane','FI','275609605','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:39',0,'2014-03-01 15:05:09'),(5033,5033,'2014-01-01','ET','2',1,NULL,'LINDA JANSON','FI','276448198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:47:03',0,'2014-03-01 15:31:33'),(5917,5917,'2014-01-01','ET','2',1,NULL,'Teresa Scheetz','FI','277568034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:19',0,'2014-03-01 15:48:04'),(5566,5566,'2014-01-01','ET','2',1,NULL,'Myra Dural','FI','457197487','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:34',0,'2014-03-02 04:45:37'),(13306,13662,'2014-01-01','ET','2',1,NULL,'Barbara Tillman','FI','292689815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:15',0,'2014-03-01 16:40:16'),(13513,13869,'2014-01-01','ET','2',1,NULL,'Virginia Katherine Keily','FI','454110421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:25',0,'2014-03-02 05:31:31'),(13684,14040,'2014-01-01','ET','2',1,NULL,'Laurie Preston','FI','279529789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:30',0,'2014-03-02 05:24:45'),(15385,15836,'0000-00-00','ET','2',1,NULL,'Amy Edie','FI','433453553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:00',0,'2014-03-02 05:59:43'),(16019,16668,'0000-00-00','ET','2',1,NULL,'CARLOS GANDARA','FI','641168582','Starmount Life Insurance Company','FI','720977315','ARTURO  PADRON','94','11840129','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:23',0,'2014-03-02 06:03:21'),(16165,16814,'0000-00-00','ET','2',2,1,'GENE ANTAUER','FI','291501777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:16',0,'2014-03-01 16:56:22'),(17130,17780,'0000-00-00','ET','2',1,NULL,'Bonnie Austin','FI','453676584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:19',0,'2014-03-02 06:24:38'),(18442,19092,'0000-00-00','ET','2',1,NULL,'Rhonda  Kraus','FI','293701945','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:33',0,'2014-03-10 16:31:33'),(19523,20173,'0000-00-00','ET','2',1,NULL,'EDWIN MIKESELL','FI','274686953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:10:50',0,'2014-03-01 17:47:19'),(20215,20865,'0000-00-00','ET','2',1,NULL,'shelli friend','FI','294608233','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:31:42',0,'2014-03-10 14:37:47'),(22137,22787,'0000-00-00','ET','2',1,NULL,'JOANNA COTTRELL','FI','439021809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:56',0,'2014-03-06 21:27:26'),(1229,1229,'2014-01-01','ET','2',2,1,'Robert Schroer','FI','291484393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:38',0,'2014-03-01 16:15:39'),(12564,12564,'2014-01-01','ET','2',1,NULL,'julie pies','FI','297762988','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:52',0,'2014-03-10 13:59:38'),(12553,12553,'2014-01-01','ET','2',1,NULL,'Jeremy Bauman','FI','270847902','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:21',0,'2014-03-10 16:10:34'),(12037,12037,'2014-01-01','ET','2',1,NULL,'PAMELA POWELL','FI','435431775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:29',0,'2014-03-02 05:03:29'),(11096,11096,'2014-01-01','ET','2',1,NULL,'Sandra Hodgson','FI','377744997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:58',0,'2014-03-10 13:45:57'),(3933,3933,'2014-01-01','ET','2',1,NULL,'betty yang','FI','438776369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:01',0,'2014-03-01 23:10:52'),(5595,5595,'2014-01-01','ET','2',1,NULL,'Linda Gustafson','FI','456923055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:31',0,'2014-03-02 04:45:37'),(5716,5716,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','357','2014-01-01','Sync Success',0,'2013-12-26 02:00:58',0,'2014-03-01 15:37:30'),(13178,13534,'2014-01-01','ET','2',1,NULL,'Karen Mcgrady','FI','273588771','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:53',0,'2014-03-10 16:10:34'),(13349,13705,'2014-01-01','ET','2',1,NULL,'JOHN J RAIDA','FI','286505648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:31',0,'2014-03-01 16:40:16'),(13756,14112,'2014-01-01','ET','2',3,2,'Robert Veit','FI','280661585','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:18',0,'2014-03-10 13:59:38'),(14930,15381,'2014-01-01','ET','2',2,1,'PENNY  S  KOHUT','FI','301560031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:38',0,'2014-03-01 16:50:53'),(15615,16066,'0000-00-00','ET','2',1,NULL,'Terrisita Betts','FI','425139617','Starmount Life Insurance Company','FI','720977315','Kristy  Corey','94','15790666','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:43',0,'2014-03-02 05:59:43'),(17239,17889,'0000-00-00','ET','2',1,NULL,'Nick Ingarra','FI','288509110','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:25',0,'2014-03-10 16:24:30'),(17654,18304,'0000-00-00','ET','2',1,NULL,'Jeffrey Dodds','FI','512720733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:37',0,'2014-03-02 06:31:45'),(18111,18761,'0000-00-00','ET','2',1,NULL,'shantrell murphy','FI','451731427','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:47',0,'2014-03-02 06:38:05'),(19379,20029,'0000-00-00','ET','2',1,NULL,'Troy Nowak','FI','365925018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:53',0,'2014-03-01 17:34:07'),(19708,20358,'0000-00-00','ET','2',1,NULL,'Jennifer Minnich','FI','277847370','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','357','2014-03-01','Sync Success',0,'2014-02-20 04:56:26',0,'2014-03-10 14:37:47'),(21996,22646,'0000-00-00','ET','2',1,NULL,'Randall Gauss','FI','283528163','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:50',0,'2014-03-10 16:44:18'),(1647,1647,'2014-01-01','ET','2',1,NULL,'Tracey Brock','FI','435258146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:24',0,'2014-03-01 20:10:57'),(12835,12835,'2014-01-01','ET','2',1,NULL,'Marcus Nellum','FI','435134298','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-04 02:02:32',0,'2014-03-02 05:10:52'),(11417,11417,'2014-01-01','ET','2',2,1,'Lisa Youngless','FI','268822815','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2013-12-27 02:07:05',0,'2014-03-10 13:52:32'),(2479,2479,'2014-01-01','ET','2',1,NULL,'Michael Reinhart','FI','300860096','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:49',0,'2014-03-10 13:10:24'),(2692,2692,'2014-01-01','ET','2',1,NULL,'Daniel Londoff','FI','491708435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:16:56',0,'2014-03-02 04:15:49'),(5243,5243,'2014-01-01','ET','2',1,NULL,'marilyn louise holder','FI','299489308','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:48',0,'2014-03-10 13:20:27'),(3061,3061,'2014-01-01','ET','2',1,NULL,'Thomas  Blemenschutz','FI','278543816','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:59',0,'2014-03-01 15:37:30'),(4766,4766,'2014-01-01','ET','2',1,NULL,'Christian  Uribe','FI','640202309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:53',0,'2014-03-01 21:11:04'),(3863,3863,'2014-01-01','ET','2',1,0,'Armando Duran','FI','440929409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:02',0,'2014-03-01 19:11:03'),(13862,14218,'2014-01-01','ET','2',2,1,'Jessabella Brown','FI','426599187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:56',0,'2014-03-02 05:31:31'),(14051,14502,'2014-01-01','ET','2',1,NULL,'Pam Biddle','FI','293564482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:03',0,'2014-03-01 16:46:19'),(14087,14538,'2014-01-01','ET','2',1,NULL,'Elloytha Garcia','FI','463896276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:27',0,'2014-03-02 05:38:34'),(14951,15402,'2014-01-01','ET','2',1,NULL,'Yeni Medina','FI','456655397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:48',0,'2014-03-02 05:52:31'),(16569,17219,'0000-00-00','ET','2',4,3,'amy koons','94','0000977970','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:21',0,'2014-03-10 14:20:26'),(7605,7605,'2014-01-01','ET','2',1,NULL,'Gary Davis','FI','279507225','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:26',0,'2014-03-10 15:59:47'),(2530,2530,'2014-01-01','ET','2',1,NULL,'Alfredo Mejia','FI','457118430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:54',0,'2014-03-01 20:10:57'),(2862,2862,'2014-01-01','ET','2',1,NULL,'CHRISTINE ELAINE ELDRIDGE','FI','283463347','HealthSpan','FI','311431434','ROB   COLAIANNI','94','16444219','348','2014-01-01','Sync Success',0,'2013-12-25 21:22:23',0,'2014-03-10 13:39:10'),(7184,7184,'2014-01-01','ET','2',1,NULL,'GEOFFREY VAN DER WALL','FI','155704274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:09',0,'2014-03-02 03:09:49'),(3847,3847,'2014-01-01','ET','2',1,NULL,'Beverly Samons','FI','299641467','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:31',0,'2014-03-10 13:03:33'),(4610,4610,'2014-01-01','ET','2',1,NULL,'Francis Johnson','FI','466694112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:34',0,'2014-03-02 04:31:46'),(12388,12388,'2014-01-01','ET','2',1,NULL,'NEALE GENTILE','FI','271748530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:15',0,'2014-03-01 16:30:17'),(12918,12918,'2014-01-01','ET','2',3,2,'Matthew Jackson','FI','298962090','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:34',0,'2014-03-10 13:59:38'),(14708,15159,'2014-01-01','ET','2',1,NULL,'Dorothy Prudhomme','FI','034624769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:00',0,'2014-03-02 05:45:37'),(15287,15738,'0000-00-00','ET','2',1,NULL,'Michael T Manfroni','FI','263754011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:11',0,'2014-03-02 05:52:31'),(15411,15862,'0000-00-00','ET','2',1,NULL,'Harry Granoff','FI','061443497','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:16',0,'2014-03-02 05:59:43'),(15969,16618,'0000-00-00','ET','2',1,NULL,'Candise Sneed','FI','393983834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:15',0,'2014-03-02 06:03:21'),(17023,17673,'0000-00-00','ET','2',1,NULL,'whitney pouncey','FI','643108240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:14',0,'2014-03-02 06:24:38'),(17075,17725,'0000-00-00','ET','2',2,1,'Barbara Ortega','FI','572964937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:44',0,'2014-03-02 06:24:38'),(17811,18461,'0000-00-00','ET','2',1,NULL,'Travis Lorenza McClain','FI','426150552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:44',0,'2014-03-02 06:10:30'),(18237,18887,'0000-00-00','ET','2',1,NULL,'JESSICA THOMPSON','FI','433359308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:24',0,'2014-03-02 06:38:05'),(18712,19362,'0000-00-00','ET','2',2,1,'Erin Dodds','FI','268889762','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:01',0,'2014-03-10 14:31:05'),(19588,20238,'0000-00-00','ET','2',1,NULL,'David Park','FI','576433027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:29:45',0,'2014-03-02 06:59:07'),(20800,21450,'0000-00-00','ET','2',1,NULL,'Elizabeth Torres','FI','181984934','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:59',0,'2014-03-02 07:17:36'),(22385,23035,'0000-00-00','ET','2',1,NULL,'John Britenriker','FI','291585180','Summa Insurance Company, Inc.','FI','341809108','John C Dalziel','94','362362','357','2014-04-01','Sync Success',0,'2014-03-07 21:00:28',0,'2014-03-10 16:44:18'),(22722,23372,'0000-00-00','ET','2',1,NULL,'Arie Bogan','FI','587984340','Starmount Life Insurance Company','FI','720977315','Christopher  Bell','94','8004571','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:15',0,'2014-03-08 22:26:18'),(1947,1947,'2014-01-01','ET','2',1,NULL,'aniket vardhan','FI','112887092','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:33:09',0,'2014-03-01 15:26:40'),(12096,12096,'2014-01-01','ET','2',1,NULL,'Michael David  Pettyjohn','FI','281888375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:35',0,'2014-03-01 16:30:17'),(2145,2145,'2014-01-01','ET','2',1,NULL,'mark goyetche','FI','289749283','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:20',0,'2014-03-01 15:16:37'),(10605,10605,'2014-01-01','ET','2',1,NULL,'Bertha Simmons','FI','304909819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:21',0,'2014-03-02 04:24:47'),(10554,10554,'2014-01-01','ET','2',1,NULL,'david harrison','FI','438718056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:40',0,'2014-03-02 04:24:47'),(7441,7441,'2014-01-01','ET','2',1,NULL,'JOSE  LUIS  PARTIDA','FI','549130684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:09',0,'2014-03-02 04:10:25'),(2212,2212,'2014-01-01','ET','2',1,NULL,'Marie Ross','FI','436940114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:34',0,'2014-03-01 21:11:04'),(7323,7323,'2014-01-01','ET','2',2,1,'Charles Poole','FI','286727393','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:25',0,'2014-03-10 13:32:15'),(7285,7285,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:15',0,'2014-03-10 13:32:15'),(2899,2899,'2014-01-01','ET','2',4,3,'Ann Riegler','FI','298885594','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:42',0,'2014-03-10 15:59:47'),(3472,3472,'2014-01-01','ET','2',2,1,'Allison Golden','FI','337809902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:16',0,'2014-03-01 15:31:33'),(5984,5984,'2014-01-01','ET','2',1,NULL,'Ty T Foust','FI','291763281','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:33:28',0,'2014-03-10 13:24:34'),(5533,5533,'2014-01-01','ET','2',2,1,'Melisa Kennedy','FI','272903586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:28',0,'2014-03-01 16:23:43'),(13843,14199,'2014-01-01','ET','2',1,NULL,'victoria mickelson','FI','467436230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:43',0,'2014-03-02 05:31:31'),(14045,14496,'2014-01-01','ET','2',2,1,'YURI BABIOR','FI','731125429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:31:59',0,'2014-03-01 16:40:16'),(14126,14577,'2014-01-01','ET','2',1,NULL,'Milton Jones','FI','433064477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:52',0,'2014-03-02 05:38:34'),(14565,15016,'2014-01-01','ET','2',1,NULL,'CARLOS W TATUM','FI','452655558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:28',0,'2014-03-02 05:45:37'),(15414,15865,'0000-00-00','ET','2',1,NULL,'Esmeralda Garcia Castillo','FI','454908405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:18',0,'2014-03-02 05:59:43'),(15487,15938,'0000-00-00','ET','2',2,1,'Christopher Mercer','FI','501788467','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:05',0,'2014-03-10 14:10:12'),(16443,17093,'0000-00-00','ET','2',3,2,'AMY WILFERT','FI','281525281','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:54',0,'2014-03-10 14:20:26'),(17092,17742,'0000-00-00','ET','2',5,4,'Eric Mason','FI','298748393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:55',0,'2014-03-01 17:00:58'),(17152,17802,'0000-00-00','ET','2',4,3,'JOHN BERNATOVICZ','FI','296706062','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:34',0,'2014-03-10 16:24:30'),(18270,18920,'0000-00-00','ET','2',1,NULL,'Judy Vogel','FI','275820374','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-26','Sync Success',0,'2014-02-11 21:02:54',0,'2014-03-10 14:24:38'),(19325,19975,'0000-00-00','ET','2',2,1,'Linda Ransleben','FI','456026321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:15',0,'2014-03-02 06:59:07'),(19873,20523,'0000-00-00','ET','2',1,NULL,'DANA BUMSTED','FI','479921923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:22',0,'2014-03-01 17:47:19'),(20383,21033,'0000-00-00','ET','2',3,2,'Kimberly Geer','FI','273723097','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:12',0,'2014-03-10 14:37:47'),(20575,21225,'0000-00-00','ET','2',1,NULL,'mary borger','FI','275465241','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:33',0,'2014-03-01 18:08:07'),(107,107,'2014-01-01','ET','2',1,NULL,'Donna S Snider','FI','299481461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:15',0,'2014-03-10 13:10:24'),(2442,2442,'2014-01-01','ET','2',2,1,'Ronald Kelps','FI','279467552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:33',0,'2014-03-10 15:45:56'),(11605,11605,'2014-01-01','ET','2',2,1,'tammy derouen','FI','426575120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:51',0,'2014-03-02 04:52:44'),(7379,7379,'2014-01-01','ET','2',2,1,'Melanie H Rick','FI','433196933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:08',0,'2014-03-02 04:10:25'),(7152,7152,'2014-01-01','ET','2',1,NULL,'KAREN KALTENBACH','FI','273661164','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:08',0,'2014-03-10 15:59:47'),(5386,5386,'2014-01-01','ET','2',1,NULL,'JOY RUHMANN','FI','453155847','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:04',0,'2014-03-01 21:11:04'),(4376,4376,'2014-01-01','ET','2',1,NULL,'Andrew Nixon','FI','288880396','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:12',0,'2014-03-01 15:16:37'),(2780,2780,'2014-01-01','ET','2',2,1,'Jammie Hall','FI','271885017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:39',0,'2014-03-01 16:05:34'),(13197,13553,'2014-01-01','ET','2',2,1,'kimberly piwinski','FI','319688937','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:37',0,'2014-03-10 13:59:38'),(16384,17034,'0000-00-00','ET','2',1,NULL,'Jennifer Jackson','FI','439067887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:16',0,'2014-03-02 06:10:30'),(18051,18701,'0000-00-00','ET','2',2,1,'Jamie Frail','FI','293885648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:15',0,'2014-03-10 14:24:38'),(18243,18893,'0000-00-00','ET','2',4,3,'my son','FI','579219174','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:29',0,'2014-03-10 14:24:38'),(19805,20455,'0000-00-00','ET','2',1,NULL,'JOSE DE LEON','FI','459979636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:27',0,'2014-03-02 07:03:25'),(19819,20469,'0000-00-00','ET','2',2,1,'Nedal Abu-ashour','FI','643623260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:38',0,'2014-03-02 07:03:25'),(20561,21211,'0000-00-00','ET','2',2,1,'OMAR TREVIZO','FI','520966924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:24',0,'2014-03-02 07:17:36'),(20739,21389,'0000-00-00','ET','2',1,NULL,'Hui Chen','FI','220716071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:30',0,'2014-03-01 18:10:11'),(22641,23291,'0000-00-00','ET','2',1,NULL,'randy miller','FI','289528760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-08 21:30:13',0,'2014-03-08 21:35:36'),(1153,1153,'2014-01-01','ET','2',1,NULL,'Chad McCraine','FI','531968892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:17',0,'2014-03-02 04:38:08'),(1282,1282,'2014-01-01','ET','2',1,NULL,'Thomas R  Legan','94','0000813091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:14',0,'2014-03-01 16:23:43'),(11244,11244,'2014-01-01','ET','2',1,NULL,'Rob Maxwell','FI','272985630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:47',0,'2014-03-01 16:23:43'),(7673,7673,'2014-01-01','ET','2',1,NULL,'Jacob Gingerich','FI','308681346','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:37',0,'2014-03-10 13:39:10'),(5635,5635,'2014-01-01','ET','2',1,NULL,'Caron Reid','FI','293887595','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:51',0,'2014-03-10 13:52:32'),(1617,1617,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:38',0,'2014-03-01 20:10:57'),(3893,3893,'2014-01-01','ET','2',1,NULL,'Harry Netter','FI','445585148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:59',0,'2014-03-01 19:11:03'),(3731,3731,'2014-01-01','ET','2',1,NULL,'Michael Gilbert','FI','287542183','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:08:36',0,'2014-03-10 13:20:27'),(2510,2510,'2014-01-01','ET','2',2,1,'Donald Gronbeck','FI','473176102','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:20',0,'2014-03-01 15:05:09'),(12720,12720,'2014-01-01','ET','2',1,NULL,'CARLITHA LAMONICA HALL','FI','435730661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:33',0,'2014-03-02 05:10:52'),(13367,13723,'2014-01-01','ET','2',1,NULL,'JAMAAL TASBY','FI','449513875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:39',0,'2014-03-02 05:24:45'),(14505,14956,'2014-01-01','ET','2',2,1,'Minh Tran','FI','429877541','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:54',0,'2014-03-10 14:03:26'),(17136,17786,'0000-00-00','ET','2',1,NULL,'marilyn ann Washington','FI','425154025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:23',0,'2014-03-02 06:24:38'),(17524,18174,'0000-00-00','ET','2',1,NULL,'Irene Mascarenhas','FI','353989518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:17',0,'2014-03-02 06:31:45'),(21277,21927,'0000-00-00','ET','2',1,NULL,'Amber Danielle Robinson','FI','591258883','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:47',0,'2014-03-02 07:23:39'),(22028,22678,'0000-00-00','ET','2',1,NULL,'Adiel Mebrahtu','FI','629502735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:12',0,'2014-03-05 22:27:33'),(22105,22755,'0000-00-00','ET','2',1,NULL,'Donna Dudley','FI','456985751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:33',0,'2014-03-06 21:27:26'),(22821,23471,'0000-00-00','ET','2',2,1,'Charles Tolbert','FI','289505025','HealthSpan','FI','311431434','Keri  McPherson','94','17117656','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:11',0,'2014-03-10 14:50:59'),(569,569,'2014-01-01','ET','2',1,NULL,'Chrisann Byers','FI','287504151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:38',0,'2014-03-01 15:48:04'),(1191,1191,'2014-01-01','ET','2',1,NULL,'Jason Roberts','FI','453436303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:30',0,'2014-03-02 04:45:37'),(12323,12323,'2014-01-01','ET','2',1,NULL,'Phillip Garza','FI','450978218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:56',0,'2014-03-02 05:03:29'),(1219,1219,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','357','2014-01-01','Sync Success',0,'2013-12-25 18:48:21',0,'2014-03-01 16:15:39'),(11727,11727,'2014-01-01','ET','2',1,NULL,'Michelle Rammel','FI','296668687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:08:44',0,'2014-03-01 16:30:17'),(2966,2966,'2014-01-01','ET','2',1,NULL,'Stephen Piesciuk','FI','066469661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:32:06',0,'2014-03-01 15:37:30'),(4515,4515,'2014-01-01','ET','2',2,1,'Mary Brausch','FI','271560122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:34',0,'2014-03-01 15:16:37'),(11442,11442,'2014-01-01','ET','2',1,NULL,'Mary Gould','FI','288501698','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:57',0,'2014-03-10 13:52:32'),(7259,7259,'2014-01-01','ET','2',1,NULL,'Mary Barker','FI','295527213','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:28',0,'2014-03-10 15:59:47'),(5687,5687,'2014-01-01','ET','2',1,NULL,'Michelle Scott','FI','274746126','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:44',0,'2014-03-10 13:52:32'),(14236,14687,'2014-01-01','ET','2',1,NULL,'Justin A Briggs','FI','425537423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:56',0,'2014-03-02 05:38:34'),(14829,15280,'2014-01-01','ET','2',1,NULL,'ANGELA  RILEY','FI','428437222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:18',0,'2014-03-02 05:45:37'),(15133,15584,'0000-00-00','ET','2',1,NULL,'bruce kempe','FI','111423610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:16',0,'2014-03-02 05:52:31'),(16389,17039,'0000-00-00','ET','2',1,NULL,'SHANNON BERNARD','FI','435062113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:19',0,'2014-03-02 06:10:30'),(16607,17257,'0000-00-00','ET','2',1,NULL,'vanessa alanis','FI','450555132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:12',0,'2014-03-02 06:17:30'),(18579,19229,'0000-00-00','ET','2',2,1,'Dwayne Gordon','FI','301829603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:17',0,'2014-03-01 17:26:36'),(21172,21822,'0000-00-00','ET','2',2,1,'Steven Perry','FI','281623156','HealthSpan','FI','311431434','Ty  Cramer','94','8741868','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:36',0,'2014-03-10 14:45:25'),(22174,22824,'0000-00-00','ET','2',1,NULL,'Donna SUPPLENUSBAUM','FI','278522850','Dental Care Plus, Inc.','FI','311185262','Cristopher  Alamo','94','12748504','348','2014-04-01','Sync Success',0,'2014-03-06 21:01:20',0,'2014-03-06 21:36:23'),(22212,22862,'0000-00-00','ET','2',1,NULL,'SUSAN MICHELLE RALL','FI','302747207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:48',0,'2014-03-06 21:36:23'),(22603,23253,'0000-00-00','ET','2',1,NULL,'Paula Cramer','FI','296742621','HealthSpan','FI','311431434','Steve  Schmitmeyer','94','2326455','348','2014-04-01','Sync Success',0,'2014-03-07 21:32:25',0,'2014-03-10 14:50:59'),(19289,19939,'0000-00-00','ET','2',1,NULL,'Charlotte Robinson','FI','426138886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:10',0,'2014-03-02 06:59:07'),(4993,4993,'2014-01-01','ET','2',1,NULL,'John Yurcik','FI','278501615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:45:46',0,'2014-03-01 15:31:33'),(5099,5099,'2014-01-01','ET','2',1,NULL,'LISA NELSON','FI','530687945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:08',0,'2014-03-02 00:10:48'),(5165,5165,'2014-01-01','ET','2',1,NULL,'JoAnna Hirt','FI','268646109','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:14',0,'2014-03-10 13:20:27'),(11993,11993,'2014-01-01','ET','2',1,NULL,'Robin Middleton','FI','627206541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:49',0,'2014-03-02 05:03:29'),(11126,11126,'2014-01-01','ET','2',1,NULL,'catherine ann iding','FI','275507865','HealthSpan','FI','311431434','judith   wilson','94','3397333','348','2014-01-01','Sync Success',0,'2013-12-26 13:15:03',0,'2014-03-10 13:45:57'),(6100,6100,'2014-01-01','ET','2',1,NULL,'William Clarence Weber','FI','282827486','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:21',0,'2014-03-01 16:00:27'),(6268,6268,'2014-01-01','ET','2',1,NULL,'MARK GURIEVSKY','FI','436788278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:29',0,'2014-03-02 04:10:25'),(12854,12854,'2014-01-01','ET','2',1,NULL,'kellie boyer','FI','268648851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:14',0,'2014-03-01 16:35:14'),(14042,14398,'2014-01-01','ET','2',1,NULL,'Hussain Hemani','FI','454672273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:02:01',0,'2014-03-02 05:31:31'),(14535,14986,'2014-01-01','ET','2',1,NULL,'Ramona Elkins','FI','296705115','HealthSpan','FI','311431434','Thomas  Konzen','94','7981943','348','2014-02-01','Sync Success',0,'2014-01-15 02:08:10',0,'2014-03-10 14:03:26'),(2400,2400,'2014-01-01','ET','2',1,NULL,'John C Cleghorn','FI','307066883','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:17:13',0,'2014-03-01 15:26:40'),(14648,15099,'2014-01-01','ET','2',4,3,'David Damon','FI','234721817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:19',0,'2014-03-01 16:46:19'),(2164,2164,'2014-01-01','ET','2',2,1,'Michael Carnes','FI','310548586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:53',0,'2014-03-01 15:16:37'),(2124,2124,'2014-01-01','ET','2',1,NULL,'Ryan Dale','FI','268929498','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:39',0,'2014-03-01 15:16:37'),(12803,12803,'2014-01-01','ET','2',1,NULL,'DWIGHT COLLINS','FI','449943285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:22',0,'2014-03-02 05:10:52'),(19771,20421,'0000-00-00','ET','2',2,1,'DENISE ANGERSTIEN','FI','292601297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:20',0,'2014-03-01 17:47:19'),(11702,11702,'2014-01-01','ET','2',1,NULL,'Jasmine Chacon','FI','640103666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:57',0,'2014-03-02 04:59:36'),(17071,17721,'0000-00-00','ET','2',1,NULL,'ANH DOAN','FI','729281435','Starmount Life Insurance Company','FI','720977315','NAM  NGUYEN','94','7434624','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:42',0,'2014-03-02 06:24:38'),(12670,12670,'2014-01-01','ET','2',1,NULL,'michelle siwierka','FI','294784997','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:41',0,'2014-03-01 16:35:14'),(6361,6361,'2014-01-01','ET','2',1,NULL,'Charles Altman','FI','291845568','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:14',0,'2014-03-10 13:32:15'),(6205,6205,'2014-01-01','ET','2',1,NULL,'MICHAEL DZIAK','FI','270689680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:29',0,'2014-03-01 16:00:27'),(2496,2496,'2014-01-01','ET','2',2,1,'Connie Murray','FI','295446041','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:25',0,'2014-03-10 13:10:24'),(3939,3939,'2014-01-01','ET','2',1,NULL,'elaine mire','FI','150525127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:12',0,'2014-03-01 23:10:52'),(12495,12495,'2014-01-01','ET','2',1,NULL,'Dafina Skinner','FI','428591441','Starmount Life Insurance Company','FI','720977315','casedra  euell','94','14070191','348','2014-02-01','Sync Success',1,'2014-01-02 04:33:11',0,'2014-03-02 05:03:29'),(22918,23568,'0000-00-00','ET','2',1,NULL,'YAZA CLARK','FI','433273166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:54',0,'2014-03-10 21:27:11'),(20248,20898,'0000-00-00','ET','2',1,NULL,'Ronnie Black','FI','268780195','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:07',0,'2014-03-10 14:37:47'),(2160,2160,'2014-01-01','ET','2',1,NULL,'Ellina Khramova','FI','296117697','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:47',0,'2014-03-01 15:16:37'),(10846,10846,'2014-01-01','ET','2',1,NULL,'Rita Stetler','FI','304626038','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:22',0,'2014-03-10 13:45:57'),(4019,4019,'2014-01-01','ET','2',1,NULL,'Katie Harvell','FI','639102802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:43',0,'2014-03-02 03:09:49'),(6070,6070,'2014-01-01','ET','2',1,NULL,'Jessica Patterson','FI','439698997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:22',0,'2014-03-02 04:10:25'),(17351,18001,'0000-00-00','ET','2',1,NULL,'SYLVIA GARZA','FI','368529771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:08',0,'2014-03-02 06:31:45'),(5579,5579,'2014-01-01','ET','2',1,NULL,'Michelle Alejo','FI','454551537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:59',0,'2014-03-02 04:45:37'),(16928,17578,'0000-00-00','ET','2',1,NULL,'SHENIKA LOFTON','FI','426650923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:44',0,'2014-03-02 06:17:30'),(14200,14651,'2014-01-01','ET','2',1,NULL,'shannon martin','FI','467738808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:39',0,'2014-03-02 05:38:34'),(723,723,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:07:31',0,'2014-03-10 13:24:34'),(1393,1393,'2014-01-01','ET','2',1,NULL,'Lorinda Rangel','FI','457419482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:48',0,'2014-03-02 04:45:37'),(11453,11453,'2014-01-01','ET','2',1,NULL,'Charranda Lee','FI','424943186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:30:15',0,'2014-03-01 16:23:43'),(11202,11202,'2014-01-01','ET','2',1,NULL,'Donald Hetzer','FI','278883263','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:31',0,'2014-03-01 16:23:43'),(21004,21654,'0000-00-00','ET','2',1,NULL,'Linda Kindle','FI','459157141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:03',0,'2014-03-02 07:23:39'),(10922,10922,'2014-01-01','ET','2',1,NULL,'Anthony Piekarski','FI','279765141','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:23',0,'2014-03-10 16:03:49'),(19598,20248,'0000-00-00','ET','2',1,NULL,'Cimarron Gilson','FI','452539182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:31:54',0,'2014-03-02 06:59:07'),(6044,6044,'2014-01-01','ET','2',1,0,'Tina Wisneski','FI','286704500','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:22',0,'2014-03-10 13:03:33'),(18213,18863,'0000-00-00','ET','2',4,3,'Barbara Plum','94','0001182541','Summa Insurance Company, Inc.','FI','341809108','Mike  Sessor','94','2516402','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:04',0,'2014-03-10 16:31:33'),(16601,17251,'0000-00-00','ET','2',1,NULL,'Kathy Garrison','FI','453476407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:08',0,'2014-03-02 06:17:30'),(15672,16321,'0000-00-00','ET','2',1,NULL,'Charity Schaffer','FI','434733541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:29',0,'2014-03-02 05:59:43'),(14675,15126,'2014-01-01','ET','2',1,NULL,'IAN SANDERSON','FI','278805813','Dental Care Plus, Inc.','FI','311185262','DEANNA M WELLS','94','7827930','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:37',0,'2014-03-01 16:46:19'),(14492,14943,'2014-01-01','ET','2',1,NULL,'Huey Roberts','FI','438239383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:49',0,'2014-03-02 05:38:34'),(3453,3453,'2014-01-01','ET','2',1,NULL,'Dorothea Hutchinson','FI','584656533','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:27',0,'2014-03-10 13:32:15'),(7068,7068,'2014-01-01','ET','2',1,NULL,'patricia sherman','FI','280545595','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:35',0,'2014-03-01 15:52:44'),(11896,11896,'2014-01-01','ET','2',1,NULL,'reginald bell','FI','434115499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-30 00:00:53',0,'2014-03-02 04:59:36'),(11866,11866,'2014-01-01','ET','2',1,NULL,'JEFF CISCO','FI','301762593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:21',0,'2014-03-10 13:45:57'),(7641,7641,'2014-01-01','ET','2',1,NULL,'MARC ERICSON BRUBAKER','FI','465696814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:34',0,'2014-03-02 04:15:49'),(7697,7697,'2014-01-01','ET','2',1,NULL,'Steven d McCallum','FI','294480383','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:22',0,'2014-03-01 15:10:22'),(12954,12954,'2014-01-01','ET','2',2,1,'Timothy Chamness','FI','322465788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:28',0,'2014-03-02 05:17:40'),(13217,13573,'2014-01-01','ET','2',2,1,'Joshua Tracy','FI','451839234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:42',0,'2014-03-02 05:17:40'),(15484,15935,'0000-00-00','ET','2',1,NULL,'KAM NING','FI','318829712','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-22 03:23:03',0,'2014-03-10 14:10:12'),(16106,16755,'0000-00-00','ET','2',1,NULL,'Randall Moate','FI','164642431','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:21',0,'2014-03-10 16:24:30'),(16143,16792,'0000-00-00','ET','2',1,NULL,'CHERYL THOMAS','FI','526989697','Starmount Life Insurance Company','FI','720977315','MADELYN  MATIJEVICH','94','2985167','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:03',0,'2014-03-02 06:03:21'),(16778,17428,'0000-00-00','ET','2',3,2,'JENNIFER LAHEY','FI','289622654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:27',0,'2014-03-01 17:00:58'),(16795,17445,'0000-00-00','ET','2',1,NULL,'Douglas Bien','FI','289763142','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:38',0,'2014-03-01 17:00:58'),(20323,20973,'0000-00-00','ET','2',2,1,'Noemi  D Rodriguez','FI','464926121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:11',0,'2014-03-02 07:03:25'),(21022,21672,'0000-00-00','ET','2',1,NULL,'Timothy Jordan','FI','275808524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:15',0,'2014-03-01 18:10:11'),(22927,23577,'0000-00-00','ET','2',2,1,'priscilla Jolivette','FI','434043021','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:00',0,'2014-03-10 21:27:11'),(602,602,'2014-01-01','ET','2',1,NULL,'KELSEY WOODWARD','FI','642109361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:39',0,'2014-03-02 02:10:49'),(11827,11827,'2014-01-01','ET','2',1,NULL,'Dok May Philavong','FI','557917425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:58',0,'2014-03-02 04:31:46'),(1181,1181,'2014-01-01','ET','2',1,NULL,'MICHAEL BROWN','FI','435949683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:11',0,'2014-03-02 04:38:08'),(2335,2335,'2014-01-01','ET','2',1,NULL,'LISA MARIE SHEARER','FI','274543914','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:10',0,'2014-03-10 15:45:56'),(7188,7188,'2014-01-01','ET','2',1,NULL,'Barbara King','FI','463926311','Starmount Life Insurance Company','FI','720977315','Monacita  Montano','94','15736408','348','2014-01-01','Sync Success',0,'2013-12-26 04:06:17',0,'2014-03-02 03:09:49'),(3358,3358,'2014-01-01','ET','2',1,NULL,'Scott M Leavell','FI','372884837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:23',0,'2014-03-02 02:10:49'),(5473,5473,'2014-01-01','ET','2',1,NULL,'DERYL WICKS','FI','433744115','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:32',0,'2014-03-02 04:45:37'),(4820,4820,'2014-01-01','ET','2',2,1,'Gary Reindel','FI','287449933','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:28',0,'2014-03-10 13:10:24'),(4210,4210,'2014-01-01','ET','2',1,NULL,'WILLIE j JOHNSON','FI','302345312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:32',0,'2014-03-02 03:09:49'),(3567,3567,'2014-01-01','ET','2',1,NULL,'nancy vivero','FI','461418005','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:20',0,'2014-03-02 00:10:48'),(15436,15887,'0000-00-00','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:33',0,'2014-03-10 16:17:47'),(15653,16302,'0000-00-00','ET','2',1,NULL,'Clifton Sneed','FI','423295149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:14',0,'2014-03-01 16:56:22'),(16070,16719,'0000-00-00','ET','2',1,NULL,'JUDITH ROBINSON','FI','289685630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:56',0,'2014-03-01 16:56:22'),(16563,17213,'0000-00-00','ET','2',2,1,'Marshall Prince','FI','299761281','Summa Insurance Company, Inc.','FI','341809108','Lenda  Sojourner','94','1862271','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:18',0,'2014-03-10 16:24:30'),(16615,17265,'0000-00-00','ET','2',1,NULL,'Ernie Sanchez','FI','463950520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:17',0,'2014-03-02 06:17:30'),(17774,18424,'0000-00-00','ET','2',1,NULL,'Adriana Gonzalez','FI','806985821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:13',0,'2014-03-02 06:03:21'),(19097,19747,'0000-00-00','ET','2',1,NULL,'KAMESHA ACKON','FI','300741991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:41',0,'2014-03-01 17:34:07'),(19551,20201,'0000-00-00','ET','2',1,NULL,'LoLita  Hamilton Blazio','FI','436293736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:18:26',0,'2014-03-02 06:59:07'),(21316,21966,'0000-00-00','ET','2',1,NULL,'Regina Coleman','FI','522510972','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-16','Received',0,'2014-03-03 01:00:05',NULL,NULL),(21857,22507,'0000-00-00','ET','2',1,NULL,'Mary Vaughn','FI','298744286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:12',0,'2014-03-05 21:36:22'),(452,452,'2014-01-01','ET','2',1,NULL,'Maria Gonzales','FI','568848855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:02',0,'2014-03-01 22:10:55'),(943,943,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:18:27',0,'2014-03-01 22:10:55'),(10637,10637,'2014-01-01','ET','2',2,1,'JAYESH MANUBHAI PATEL','FI','635866730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:23',0,'2014-03-02 04:31:46'),(7389,7389,'2014-01-01','ET','2',3,2,'Marie Placide','FI','594095175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:28',0,'2014-03-02 04:15:49'),(1598,1598,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:10',0,'2014-03-01 20:10:57'),(11493,11493,'2014-01-01','ET','2',1,NULL,'Rashad Jones','FI','638128261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:27',0,'2014-03-02 04:52:44'),(5239,5239,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:39',0,'2014-03-10 13:20:27'),(4904,4904,'2014-01-01','ET','2',3,2,'ray kayati','FI','462655797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:15',0,'2014-03-01 19:11:03'),(2147,2147,'2014-01-01','ET','2',1,NULL,'Bruce Terrell','FI','192485555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:23',0,'2014-03-01 15:16:37'),(4429,4429,'2014-01-01','ET','2',1,NULL,'Patricia Fuenzalida','FI','433929855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:01',0,'2014-03-01 19:11:03'),(3561,3561,'2014-01-01','ET','2',2,1,'Noelia Flores','FI','452698880','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:11',0,'2014-03-02 00:10:48'),(15761,16410,'0000-00-00','ET','2',1,NULL,'Richard McCune','FI','235760139','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:01:29',0,'2014-03-10 14:10:12'),(16385,17035,'0000-00-00','ET','2',2,1,'LIEN TRAN','FI','543023895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:16',0,'2014-03-02 06:10:30'),(17724,18374,'0000-00-00','ET','2',1,NULL,'Jamie George Tuck','FI','296825265','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:17',0,'2014-03-01 17:20:55'),(22427,23077,'0000-00-00','ET','2',1,NULL,'audrey hollebeke','FI','627050893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:19',0,'2014-03-07 22:26:59'),(1687,1687,'2014-01-01','ET','2',2,1,'Joseph Macaluso','FI','272507690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:05',0,'2014-03-01 15:31:33'),(11489,11489,'2014-01-01','ET','2',1,NULL,'Daniel J Taylor','FI','728716744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:20',0,'2014-03-01 16:30:17'),(11375,11375,'2014-01-01','ET','2',1,NULL,'June Helen Mcclay','FI','119529549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:48',0,'2014-03-02 04:52:44'),(7537,7537,'2014-01-01','ET','2',1,NULL,'NOEL B HARRIS','FI','077469817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:11',0,'2014-03-01 16:05:34'),(2237,2237,'2014-01-01','ET','2',1,NULL,'Donald Leroy Clark','FI','224684692','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:26',0,'2014-03-10 15:39:19'),(2385,2385,'2014-01-01','ET','2',1,NULL,'Janice Jernigan','FI','435430034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:46',0,'2014-03-01 23:10:52'),(2608,2608,'2014-01-01','ET','2',1,0,'Molly Killen','FI','450915999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:14',0,'2014-03-01 19:11:03'),(4449,4449,'2014-01-01','ET','2',1,NULL,'Alexander Macke','FI','275942178','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:24',0,'2014-03-01 15:16:37'),(13429,13785,'2014-01-01','ET','2',1,NULL,'Earl Neal','FI','420823885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:08',0,'2014-03-10 13:59:38'),(13878,14234,'2014-01-01','ET','2',1,NULL,'Danae Williams','FI','469233842','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:06',0,'2014-03-10 14:03:26'),(15407,15858,'0000-00-00','ET','2',1,NULL,'Mike Keating','FI','523785968','Starmount Life Insurance Company','FI','720977315','camweron  liljenquist','94','8328382','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:14',0,'2014-03-02 05:59:43'),(18886,19536,'0000-00-00','ET','2',1,NULL,'Martin McHenry','FI','295801951','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:52',0,'2014-03-10 14:31:05'),(19491,20141,'0000-00-00','ET','2',1,NULL,'Beatriz Leandro','FI','457233630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:01:32',0,'2014-03-02 06:59:07'),(20217,20867,'0000-00-00','ET','2',1,NULL,'David W Brandenburg','94','0000824647','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:43',0,'2014-03-10 14:37:47'),(20588,21238,'0000-00-00','ET','2',1,NULL,'CAROL MILLER','FI','299508149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:40',0,'2014-03-01 18:08:07'),(257,257,'2014-01-01','ET','2',1,NULL,'Mark Sheats','FI','227399489','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:06',0,'2014-03-01 20:10:57'),(12298,12298,'2014-01-01','ET','2',1,NULL,'Patti Penhorwood','FI','273741282','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:14',0,'2014-03-10 13:59:38'),(1869,1869,'2014-01-01','ET','2',1,NULL,'Kevin McGovern','FI','287588603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:49',0,'2014-03-01 15:26:40'),(10716,10716,'2014-01-01','ET','2',1,NULL,'DIANA KOHR','FI','274542984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:05',0,'2014-03-01 16:10:36'),(1885,1885,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:31:22',0,'2014-03-01 23:10:52'),(4596,4596,'2014-01-01','ET','2',1,NULL,'Starlette Addison','FI','288863232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:09',0,'2014-03-01 16:15:39'),(3545,3545,'2014-01-01','ET','2',1,NULL,'BRENDA MITCHELL','FI','268686102','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:38',0,'2014-03-01 15:37:30'),(3483,3483,'2014-01-01','ET','2',1,NULL,'Rita Lynn Henderson','FI','286667901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:39',0,'2014-03-01 15:37:30'),(3024,3024,'2014-01-01','ET','2',1,NULL,'VIRGINIA A JESSEE','FI','293504784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:50',0,'2014-03-01 15:37:30'),(2891,2891,'2014-01-01','ET','2',1,NULL,'Lee Meyer','FI','279460744','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:24',0,'2014-03-10 15:59:47'),(2874,2874,'2014-01-01','ET','2',2,1,'John Taylor','FI','289526262','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:46',0,'2014-03-10 13:39:10'),(15989,16638,'0000-00-00','ET','2',1,NULL,'Barbara Gatian','FI','302746742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:03',0,'2014-03-02 06:03:21'),(623,623,'2014-01-01','ET','2',1,NULL,'Vicky Loven','FI','451293261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:23',0,'2014-03-02 02:10:49'),(5394,5394,'2014-01-01','ET','2',1,NULL,'Angelica Pozo','FI','103464017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:22',0,'2014-03-10 13:03:33'),(1289,1289,'2014-01-01','ET','2',1,NULL,'YANFEN SUN','FI','276040794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:27',0,'2014-03-01 16:23:43'),(5198,5198,'2014-01-01','ET','2',1,NULL,'JAMIE LYNNE DYER','FI','453578667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:19',0,'2014-03-02 00:10:48'),(12391,12391,'2014-01-01','ET','2',1,NULL,'JENNIFER OSBORNE','FI','298664436','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:21',0,'2014-03-01 16:30:17'),(12668,12668,'2014-01-01','ET','2',1,NULL,'Diane Jackman','FI','281528350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:37',0,'2014-03-01 16:35:14'),(13675,14031,'2014-01-01','ET','2',1,NULL,'VERONICA MARTINEZ','FI','455656665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:25',0,'2014-03-02 05:24:45'),(13946,14302,'2014-01-01','ET','2',1,NULL,'MAHMUD FARAH','FI','337465759','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:31',0,'2014-03-10 14:03:26'),(16817,17467,'0000-00-00','ET','2',1,NULL,'Achamma Abraham','FI','354705366','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:04',0,'2014-03-02 06:17:30'),(17133,17783,'0000-00-00','ET','2',1,NULL,'DIANE BARNETTE','FI','425026772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:21',0,'2014-03-02 06:24:38'),(17480,18130,'0000-00-00','ET','2',1,NULL,'PAULA EVANS','FI','587622065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:38',0,'2014-03-02 06:31:45'),(19016,19666,'0000-00-00','ET','2',1,NULL,'Cynthia Edwards','FI','591054531','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:26',0,'2014-03-10 14:31:05'),(21023,21673,'0000-00-00','ET','2',1,NULL,'Timothy Jordan','FI','275808524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:16',0,'2014-03-01 18:10:11'),(22090,22740,'0000-00-00','ET','2',1,NULL,'Dana Akeela Strauder','FI','425456993','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:22',0,'2014-03-06 21:27:26'),(22418,23068,'0000-00-00','ET','2',1,NULL,'Jennifer Konze','FI','557519761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:12',0,'2014-03-07 22:26:59'),(22461,23111,'0000-00-00','ET','2',1,NULL,'shannon mcginnis hosey','FI','346629486','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:43',0,'2014-03-10 16:44:18'),(22822,23472,'0000-00-00','ET','2',1,NULL,'Charles Tolbert','FI','289505025','HealthSpan','FI','311431434','Keri  McPherson','94','17117656','357','2014-04-01','Sync Success',0,'2014-03-09 21:01:11',0,'2014-03-10 14:50:59'),(1446,1446,'2014-01-01','ET','2',1,NULL,'DIANA KOHR','FI','274542984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:55:34',0,'2014-03-01 16:15:39'),(4992,4992,'2014-01-01','ET','2',1,NULL,'John Yurcik','FI','278501615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:44',0,'2014-03-01 15:31:33'),(2892,2892,'2014-01-01','ET','2',1,NULL,'Thomas Sherwood','94','0000844704','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:26',0,'2014-03-10 15:59:47'),(11077,11077,'2014-01-01','ET','2',1,NULL,'Erica Hall','FI','272905591','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:23',0,'2014-03-10 13:39:10'),(1812,1812,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:01',0,'2014-03-10 13:20:27'),(12454,12454,'2014-01-01','ET','2',2,1,'GRZEGORZ BOC','FI','290048097','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:39',0,'2014-03-10 16:10:34'),(6181,6181,'2014-01-01','ET','2',1,NULL,'Pamela Grayson','FI','525131608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:45',0,'2014-03-02 04:10:25'),(6176,6176,'2014-01-01','ET','2',1,NULL,'Jose Gonzalez','FI','451210510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:35',0,'2014-03-02 04:10:25'),(12641,12641,'2014-01-01','ET','2',1,NULL,'TAMMY WILLIS','FI','435553140','Starmount Life Insurance Company','FI','720977315','STEVE  WILLIS','94','17077577','348','2014-02-01','Sync Success',0,'2014-01-03 02:02:34',0,'2014-03-02 05:10:52'),(13589,13945,'2014-01-01','ET','2',1,NULL,'Khambile Mercy Msonthi','FI','740863050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:17',0,'2014-03-02 05:31:31'),(14745,15196,'2014-01-01','ET','2',1,NULL,'William Daywalt','FI','288566960','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:23',0,'2014-03-10 16:17:47'),(14774,15225,'2014-01-01','ET','2',1,NULL,'MARY VAN ZANT','FI','466333857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:41',0,'2014-03-02 05:45:37'),(15056,15507,'2014-01-01','ET','2',1,NULL,'Jason Meyers','FI','279902750','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:34',0,'2014-03-10 14:10:12'),(17131,17781,'0000-00-00','ET','2',1,NULL,'Bonnie Austin','FI','453676584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:20',0,'2014-03-02 06:24:38'),(17533,18183,'0000-00-00','ET','2',2,1,'GREGORY WILSON','FI','268484762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:23',0,'2014-03-01 17:20:55'),(17880,18530,'0000-00-00','ET','2',2,1,'ALLAN TEMPLE','FI','285882299','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:15',0,'2014-03-10 16:31:33'),(18253,18903,'0000-00-00','ET','2',1,NULL,'Patricia Schwab','FI','296581604','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:40',0,'2014-03-10 14:24:38'),(19843,20493,'0000-00-00','ET','2',1,NULL,'Nancy Brown','FI','462391552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:58',0,'2014-03-02 07:03:25'),(19990,20640,'0000-00-00','ET','2',2,1,'Margo Marshall','FI','436274927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:45',0,'2014-03-02 07:03:25'),(23009,23659,'0000-00-00','ET','2',1,NULL,'scott storey','FI','396809831','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:01:58',0,'2014-03-10 21:17:52'),(2259,2259,'2014-01-01','ET','2',1,NULL,'CYNTHIA J CORKERN','FI','434849474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:12',0,'2014-03-01 21:11:04'),(7462,7462,'2014-01-01','ET','2',1,NULL,'brian handal','FI','333728386','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:44',0,'2014-03-02 04:15:49'),(11060,11060,'2014-01-01','ET','2',1,NULL,'William Quast','FI','297500012','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:48',0,'2014-03-10 16:03:49'),(4869,4869,'2014-01-01','ET','2',1,NULL,'CYNTHIA ORGERON','FI','433923589','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:13',0,'2014-03-01 20:10:57'),(11863,11863,'2014-01-01','ET','2',1,NULL,'Erica Attewell','FI','128567855','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:15',0,'2014-03-10 16:03:49'),(3054,3054,'2014-01-01','ET','2',1,NULL,'LaKisha Williams','FI','287888848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:46',0,'2014-03-01 15:37:30'),(7470,7470,'2014-01-01','ET','2',2,1,'Gustavo Rios','FI','461630213','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:58',0,'2014-03-02 04:15:49'),(13731,14087,'2014-01-01','ET','2',1,NULL,'CARLOS R WILSON','FI','439459238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:02',0,'2014-03-02 05:24:45'),(14184,14635,'2014-01-01','ET','2',1,NULL,'Kammie Thompson','FI','428570164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:28',0,'2014-03-02 05:38:34'),(15229,15680,'0000-00-00','ET','2',1,NULL,'JANELLE MAY','FI','300906256','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:46',0,'2014-03-10 14:10:12'),(15336,15787,'0000-00-00','ET','2',1,NULL,'Stacy Williams','FI','436419310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:40',0,'2014-03-02 05:52:31'),(16058,16707,'0000-00-00','ET','2',1,NULL,'GARRY WILLIAMS','FI','530640535','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:48',0,'2014-03-01 16:56:22'),(18359,19009,'0000-00-00','ET','2',2,1,'georgina alejandra hernandez','FI','640280701','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:33',0,'2014-03-02 06:45:14'),(18988,19638,'0000-00-00','ET','2',1,NULL,'Patsy Grace','FI','099464508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:05',0,'2014-03-02 06:52:12'),(21539,22189,'0000-00-00','ET','2',2,1,'Mark Palm','FI','190586154','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:23',0,'2014-03-03 22:26:43'),(22730,23380,'0000-00-00','ET','2',1,NULL,'Shelia Vickrey','94','0000254606','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:21',0,'2014-03-10 14:50:59'),(3016,3016,'2014-01-01','ET','2',1,NULL,'Christine Paule','FI','281508679','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:37',0,'2014-03-10 15:52:36'),(4313,4313,'2014-01-01','ET','2',1,NULL,'Aaron Nguyen','FI','066767210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:39',0,'2014-03-02 03:09:49'),(4772,4772,'2014-01-01','ET','2',1,NULL,'James C Meadows','FI','450434550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:04',0,'2014-03-01 21:11:04'),(5159,5159,'2014-01-01','ET','2',1,NULL,'Justin Bell','FI','268868405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:04',0,'2014-03-10 15:45:56'),(5283,5283,'2014-01-01','ET','2',1,NULL,'jerome fletcher','FI','466517152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:50',0,'2014-03-01 20:10:57'),(5846,5846,'2014-01-01','ET','2',2,1,'Richard Frenton','FI','279563149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:00',0,'2014-03-01 15:10:22'),(6153,6153,'2014-01-01','ET','2',1,NULL,'VENEITRA COLSTONMACK','FI','443725577','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:56',0,'2014-03-02 04:10:25'),(3210,3210,'2014-01-01','ET','2',1,NULL,'Geneva Bates','FI','407704489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:38',0,'2014-03-01 15:48:04'),(11394,11394,'2014-01-01','ET','2',2,1,'Clarence Webster Dorsey','FI','587158620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:22',0,'2014-03-02 04:52:44'),(12221,12221,'2014-01-01','ET','2',1,NULL,'JERRY ROBERTSON','FI','587809230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:17',0,'2014-03-02 05:03:29'),(12963,12963,'2014-01-01','ET','2',1,NULL,'Cindy Hernandez','FI','643184135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:51',0,'2014-03-02 05:17:40'),(13073,13429,'2014-01-01','ET','2',1,NULL,'JULIO WALNER HECHAVARRIA','FI','434976475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:54',0,'2014-03-02 05:17:40'),(13212,13568,'2014-01-01','ET','2',1,NULL,'Julie Zapata','FI','346822387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:30',0,'2014-03-02 05:17:40'),(15478,15929,'0000-00-00','ET','2',2,1,'TIM TRUONG','FI','586149826','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:59',0,'2014-03-02 05:59:43'),(15514,15965,'0000-00-00','ET','2',2,1,'GUO KANG HUANG','FI','113965634','Starmount Life Insurance Company','FI','720977315','KENNETH  ROBERTS','94','1096932','348','2014-03-01','Sync Success',0,'2014-01-23 03:01:57',0,'2014-03-02 05:59:43'),(16301,16951,'0000-00-00','ET','2',1,NULL,'Philip Hollister','FI','462534545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:24',0,'2014-03-02 06:10:30'),(16661,17311,'0000-00-00','ET','2',1,NULL,'Christopher Krafty','FI','285881577','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:48',0,'2014-03-01 17:00:58'),(17008,17658,'0000-00-00','ET','2',1,NULL,'Terry Anderson','FI','284706196','HealthSpan','FI','311431434','Maribeth  Zaferopolos','94','16354316','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:38',0,'2014-03-10 14:20:26'),(18577,19227,'0000-00-00','ET','2',1,NULL,'CYNTHIA  WEBER','FI','283505366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:15',0,'2014-03-01 17:26:36'),(18669,19319,'0000-00-00','ET','2',1,NULL,'Michael Chumbley','FI','630077647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:29',0,'2014-03-02 06:45:14'),(19148,19798,'0000-00-00','ET','2',3,2,'John Mahlendorf','FI','508700865','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:20',0,'2014-03-10 16:31:33'),(20313,20963,'0000-00-00','ET','2',1,NULL,'ENEDILIA DURAN','FI','460456939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:03',0,'2014-03-02 07:03:25'),(22177,22827,'0000-00-00','ET','2',2,1,'CRISTIAN PADILLA','FI','598441091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:22',0,'2014-03-06 21:36:23'),(800,800,'2014-01-01','ET','2',1,NULL,'JENNIFER MOORE','FI','291788981','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:10',0,'2014-03-10 13:03:33'),(7732,7732,'2014-01-01','ET','2',1,NULL,'John Buczak','FI','280607623','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-01-01','Received',0,'2013-12-26 05:00:17',NULL,NULL),(3670,3670,'2014-01-01','ET','2',1,NULL,'Joseph Robinson','FI','587513153','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:33',0,'2014-03-02 01:10:33'),(3588,3588,'2014-01-01','ET','2',1,NULL,'Cody Bailey','FI','461879298','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:00',0,'2014-03-02 01:10:33'),(2843,2843,'2014-01-01','ET','2',1,NULL,'Lacey Woodruff','FI','473020927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:47',0,'2014-03-02 04:15:49'),(12064,12064,'2014-01-01','ET','2',2,1,'Quang Le','FI','500983241','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:29',0,'2014-03-01 16:30:17'),(1985,1985,'2014-01-01','ET','2',1,NULL,'Heather Lee Hall','FI','297721220','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:19',0,'2014-03-10 15:45:56'),(12247,12247,'2014-01-01','ET','2',1,NULL,'Patricia Duran-vigil','FI','450178956','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:19',0,'2014-03-02 05:10:52'),(1859,1859,'2014-01-01','ET','2',1,NULL,'Keith Jordan','FI','279645492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:30',0,'2014-03-01 15:26:40'),(1199,1199,'2014-01-01','ET','2',1,NULL,'Vincent Bass','FI','343441814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:44',0,'2014-03-02 04:38:08'),(5813,5813,'2014-01-01','ET','2',1,NULL,'David Collinge','FI','288706833','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:58',0,'2014-03-10 15:52:36'),(3913,3913,'2014-01-01','ET','2',1,NULL,'nancy lynn burns','FI','287680368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:27',0,'2014-03-01 15:26:40'),(12879,12879,'2014-01-01','ET','2',1,NULL,'Jennifer Radel','FI','287720131','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:07',0,'2014-03-01 16:35:14'),(13423,13779,'2014-01-01','ET','2',2,1,'Lindsay Gilliland','FI','289802189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:05',0,'2014-03-10 13:59:38'),(15797,16446,'0000-00-00','ET','2',1,NULL,'Samantha Williams','FI','467618493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:10',0,'2014-03-02 06:03:21'),(15857,16506,'0000-00-00','ET','2',1,NULL,'william kimbler','FI','285924763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:45',0,'2014-03-01 16:56:22'),(16979,17629,'0000-00-00','ET','2',1,NULL,'Terry Southwick','FI','280529036','Dental Care Plus, Inc.','FI','311185262','Marie  Trudeau','94','2762722','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:16',0,'2014-03-01 17:00:58'),(18005,18655,'0000-00-00','ET','2',1,NULL,'edna marange','FI','433592215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:42',0,'2014-03-02 06:38:05'),(19463,20113,'0000-00-00','ET','2',1,NULL,'BRITTANY HOYT','FI','461999686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:48:11',0,'2014-03-02 06:59:07'),(21695,22345,'0000-00-00','ET','2',2,1,'NIKOLE M LASKY','FI','273920320','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:33',0,'2014-03-04 21:36:30'),(22774,23424,'0000-00-00','ET','2',1,NULL,'Whitney McLain','FI','287862784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:28',0,'2014-03-09 21:35:27'),(307,307,'2014-01-01','ET','2',1,NULL,'Erika Moyer','FI','641092492','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:24',0,'2014-03-01 22:10:55'),(12449,12449,'2014-01-01','ET','2',2,1,'STEVEN MOSES','FI','553830580','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:28',0,'2014-03-10 16:10:34'),(555,555,'2014-01-01','ET','2',1,NULL,'Sheri Primm','FI','317869245','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:11',0,'2014-03-01 15:48:04'),(11598,11598,'2014-01-01','ET','2',1,NULL,'CHARLES ALDRIDGE','FI','587454127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:39',0,'2014-03-02 04:52:44'),(11221,11221,'2014-01-01','ET','2',1,NULL,'Tameka Jones','FI','296604590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:05',0,'2014-03-01 16:23:43'),(1236,1236,'2014-01-01','ET','2',1,NULL,'Eric Owens','FI','276808843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:49',0,'2014-03-01 16:15:39'),(11995,11995,'2014-01-01','ET','2',1,NULL,'JAMES MUFFET','FI','294442465','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:52',0,'2014-03-10 16:10:34'),(10661,10661,'2014-01-01','ET','2',1,NULL,'Jaime Dean','FI','229115063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:09',0,'2014-03-02 04:31:46'),(10599,10599,'2014-01-01','ET','2',1,NULL,'CHRSTAL GUTIRREZ','FI','457733824','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:09',0,'2014-03-02 04:24:47'),(1760,1760,'2014-01-01','ET','2',1,NULL,'Donald Egdorf','FI','436766734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:17',0,'2014-03-02 00:10:48'),(2789,2789,'2014-01-01','ET','2',3,2,'Phillip Sutherland','FI','293119904','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:00',0,'2014-03-01 16:05:34'),(2992,2992,'2014-01-01','ET','2',1,NULL,'William d Grambling','FI','463883768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:53',0,'2014-03-02 01:10:33'),(6314,6314,'2014-01-01','ET','2',1,NULL,'Lisa Mitchell','FI','291466820','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:49',0,'2014-03-10 15:59:47'),(5528,5528,'2014-01-01','ET','2',1,NULL,'Charranda Lee','FI','424943186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:18',0,'2014-03-01 16:23:43'),(5338,5338,'2014-01-01','ET','2',2,1,'Nancy Dawson','FI','327466186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:25',0,'2014-03-01 15:10:22'),(4114,4114,'2014-01-01','ET','2',1,NULL,'AMY JOAN VOGELGESANG','FI','269567893','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:38',0,'2014-03-01 16:00:27'),(5069,5069,'2014-01-01','ET','2',1,NULL,'Larry Ringler','FI','272502735','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:14',0,'2014-03-01 15:31:33'),(14644,15095,'2014-01-01','ET','2',1,NULL,'SCOT PILKINGTON','FI','280423685','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:16',0,'2014-03-01 16:46:19'),(15123,15574,'0000-00-00','ET','2',1,NULL,'DEBORAH L PRICE','FI','162488463','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:07',0,'2014-03-01 16:50:53'),(16676,17326,'0000-00-00','ET','2',1,NULL,'Deborah Augustine','FI','296566821','HealthSpan','FI','311431434','Kevin  Fifer','94','7946249','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:59',0,'2014-03-10 14:20:26'),(383,383,'2014-01-01','ET','2',1,NULL,'DEBORAH MAY KNOTTS','FI','268522746','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:49',0,'2014-03-10 15:45:56'),(485,485,'2014-01-01','ET','2',1,NULL,'Sanjae Duncan','FI','116788809','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:51:10',0,'2014-03-10 13:10:24'),(7316,7316,'2014-01-01','ET','2',1,NULL,'Cynthia Raspberry','FI','278506660','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:12',0,'2014-03-10 13:32:15'),(20429,21079,'0000-00-00','ET','2',1,NULL,'freddie travis davis','FI','268763143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-26 09:30:48',0,'2014-03-01 18:08:07'),(19520,20170,'0000-00-00','ET','2',1,NULL,'William Kellerman','FI','285642786','Dental Care Plus, Inc.','FI','311185262','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-20 04:09:42',0,'2014-03-01 17:47:19'),(2827,2827,'2014-01-01','ET','2',2,1,'CLAIRE WESLEY','FI','451040587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:13',0,'2014-03-02 04:15:49'),(18832,19482,'0000-00-00','ET','2',2,1,'Ahmed Siddig','FI','645700569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:13',0,'2014-03-02 06:52:12'),(14353,14804,'2014-01-01','ET','2',1,NULL,'Ralph Edward Hooper','FI','466252106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:46',0,'2014-03-02 05:45:37'),(5068,5068,'2014-01-01','ET','2',4,3,'David Allan Bressman','FI','040449354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:11',0,'2014-03-01 15:31:33'),(12203,12203,'2014-01-01','ET','2',1,NULL,'RONALD GERALD MILLER','FI','268702800','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:25',0,'2014-03-10 13:52:32'),(21860,22510,'0000-00-00','ET','2',1,NULL,'Marla Jones','FI','272882259','Dental Care Plus, Inc.','FI','311185262','Daniel   Rankin','94','2095226','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:14',0,'2014-03-05 21:36:22'),(1404,1404,'2014-01-01','ET','2',1,NULL,'GREGORY  KENNEDY','FI','434110355','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:11',0,'2014-03-02 04:38:08'),(10723,10723,'2014-01-01','ET','2',1,NULL,'James Yarshen','FI','293488902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:23',0,'2014-03-01 16:10:36'),(3722,3722,'2014-01-01','ET','2',2,1,'TROY MORGAN','FI','273882525','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:16',0,'2014-03-10 13:20:27'),(21042,21692,'0000-00-00','ET','2',1,NULL,'JOMAILE HOLLAND','FI','577082592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:04',0,'2014-03-01 18:10:11'),(5200,5200,'2014-01-01','ET','2',1,NULL,'DEANNA HOLDER','FI','461196051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:22',0,'2014-03-02 00:10:48'),(19271,19921,'0000-00-00','ET','2',1,NULL,'TERRANCE WILKINSON','FI','282700893','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:13',0,'2014-03-10 16:31:33'),(14839,15290,'2014-01-01','ET','2',1,NULL,'Mitzi Copas','FI','285569789','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:25',0,'2014-03-10 14:03:26'),(16090,16739,'0000-00-00','ET','2',3,2,'RUSSELL J KONCAN','FI','293567548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:09',0,'2014-03-01 16:56:22'),(17154,17804,'0000-00-00','ET','2',1,NULL,'Edward Hungerford','FI','433864029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:36',0,'2014-03-02 06:24:38'),(17458,18108,'0000-00-00','ET','2',1,NULL,'PEGGY  PAULEY','FI','271500876','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:22',0,'2014-03-10 14:24:38'),(18274,18924,'0000-00-00','ET','2',1,NULL,'Carrie Moss','FI','455412208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:04',0,'2014-03-02 06:38:05'),(23116,23766,'0000-00-00','ET','2',1,NULL,'Kriserpher Boone','FI','644010070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:14',0,'2014-03-10 22:25:11'),(21980,22630,'0000-00-00','ET','2',1,NULL,'ALBERTHA SWANSON','FI','587467825','Starmount Life Insurance Company','FI','720977315','ARTHUR  BROWN','94','6396453','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:39',0,'2014-03-05 22:27:33'),(4375,4375,'2014-01-01','ET','2',2,1,'Patrick Walsh','FI','269905659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:10',0,'2014-03-01 15:16:37'),(5104,5104,'2014-01-01','ET','2',1,NULL,'susan perrin','FI','438902402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:18',0,'2014-03-02 00:10:48'),(21628,22278,'0000-00-00','ET','2',1,NULL,'Lisa Renee Cooper','FI','466470483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:42',0,'2014-03-04 21:27:16'),(13454,13810,'2014-01-01','ET','2',1,NULL,'dineshea douglas','FI','439855027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:22',0,'2014-03-02 05:31:31'),(20407,21057,'0000-00-00','ET','2',2,1,'Cyndi Busby','FI','436651252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:32',0,'2014-03-02 07:10:28'),(15703,16352,'0000-00-00','ET','2',1,NULL,'BERNICE MARIE CAMPBELL','FI','466175929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:50',0,'2014-03-02 05:59:43'),(18792,19442,'0000-00-00','ET','2',2,1,'Sarah Thomas','FI','275821797','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:01',0,'2014-03-10 16:31:33'),(18261,18911,'0000-00-00','ET','2',1,NULL,'Terry Trump','FI','275485627','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:47',0,'2014-03-10 16:31:33'),(21063,21713,'0000-00-00','ET','2',1,NULL,'Shane Mueller','FI','298845901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:30:24',0,'2014-03-01 18:10:11'),(11377,11377,'2014-01-01','ET','2',1,NULL,'Toni Kirkland','FI','293666648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:52',0,'2014-03-10 13:52:32'),(10427,10427,'2014-01-01','ET','2',1,NULL,'Tenaya Erica Bolin-Devore','FI','302725611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:51:32',0,'2014-03-01 16:10:36'),(903,903,'2014-01-01','ET','2',1,NULL,'Dennis Klaiber','FI','295626129','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:13',0,'2014-03-01 15:21:15'),(18444,19094,'0000-00-00','ET','2',1,NULL,'MARGUERITE HARKLEROAD','FI','291529171','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:34',0,'2014-03-10 16:31:33'),(1088,1088,'2014-01-01','ET','2',4,3,'Mark Purdy','FI','302868388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:33',0,'2014-03-01 15:05:09'),(18438,19088,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:30',0,'2014-03-01 17:26:36'),(6344,6344,'2014-01-01','ET','2',1,NULL,'Richard Baker','FI','294687548','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:44',0,'2014-03-10 13:32:15'),(2210,2210,'2014-01-01','ET','2',1,NULL,'Trimeca Smith','FI','436599587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:30',0,'2014-03-01 21:11:04'),(3123,3123,'2014-01-01','ET','2',1,NULL,'Barbara Ray','FI','428196107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:53',0,'2014-03-02 01:10:33'),(4583,4583,'2014-01-01','ET','2',2,1,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:44',0,'2014-03-01 16:15:39'),(18130,18780,'0000-00-00','ET','2',1,NULL,'Joel Rush','FI','460045281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:00',0,'2014-03-02 06:38:05'),(4092,4092,'2014-01-01','ET','2',1,NULL,'CLARISSA ANN WEATHERSPOON','FI','279541556','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:03',0,'2014-03-01 16:00:27'),(14908,15359,'2014-01-01','ET','2',1,NULL,'Emma Sylvester-Emery','FI','587200440','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:27',0,'2014-03-02 05:52:31'),(750,750,'2014-01-01','ET','2',2,1,'Nhan Thanh Luu','FI','370255656','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:21',0,'2014-03-10 13:24:34'),(10839,10839,'2014-01-01','ET','2',1,NULL,'Scott Smith','FI','439454140','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:07',0,'2014-03-02 04:31:46'),(16099,16748,'0000-00-00','ET','2',1,NULL,'NORMA HALLER','FI','299584057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:17',0,'2014-03-10 16:24:30'),(2334,2334,'2014-01-01','ET','2',2,1,'stephen carter','FI','270567095','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:07',0,'2014-03-10 15:45:56'),(5836,5836,'2014-01-01','ET','2',1,NULL,'Wajeeh Irfan','FI','111823352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:36',0,'2014-03-01 20:10:57'),(5443,5443,'2014-01-01','ET','2',1,0,'Jennifer Bracken','FI','193620839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 01:31:44',0,'2014-03-01 15:05:09'),(1046,1046,'2014-01-01','ET','2',1,NULL,'tracy gibson','FI','458257396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:09',0,'2014-03-01 21:11:04'),(11357,11357,'2014-01-01','ET','2',1,NULL,'Danny Jones','FI','428496751','Starmount Life Insurance Company','FI','720977315','Casedra  Euell','94','14070191','348','2014-02-01','Sync Success',0,'2013-12-27 02:05:16',0,'2014-03-02 04:52:44'),(11177,11177,'2014-01-01','ET','2',2,1,'Dale Huffman','FI','291522066','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-26 13:16:53',0,'2014-03-10 13:45:57'),(1501,1501,'2014-01-01','ET','2',2,1,'Timothy Lycan','FI','306989908','Summa Insurance Company, Inc.','FI','341809108','Adam  Bologna','94','15708247','348','2014-01-01','Sync Success',0,'2013-12-25 18:57:24',0,'2014-03-10 16:03:49'),(7339,7339,'2014-01-01','ET','2',1,NULL,'alejandro de santiago','FI','450838413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:06',0,'2014-03-01 21:11:04'),(5524,5524,'2014-01-01','ET','2',2,1,'Tung Pau','FI','275069976','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:08',0,'2014-03-01 16:23:43'),(1707,1707,'2014-01-01','ET','2',2,1,'brett cervini','FI','439087082','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:43',0,'2014-03-02 00:10:48'),(4252,4252,'2014-01-01','ET','2',2,1,'James Young','FI','289505676','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:53',0,'2014-03-10 13:32:15'),(3631,3631,'2014-01-01','ET','2',1,NULL,'RONALD DEAN HAYES','FI','307640294','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:20',0,'2014-03-10 15:52:36'),(3382,3382,'2014-01-01','ET','2',1,NULL,'Latasha McGowan','FI','458775136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:09',0,'2014-03-02 02:10:49'),(2015,2015,'2014-01-01','ET','2',1,NULL,'Glenda Hafford','FI','439842893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:21',0,'2014-03-01 23:10:52'),(2485,2485,'2014-01-01','ET','2',2,1,'RONDA COPSEY','FI','285728244','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:02',0,'2014-03-10 13:10:24'),(2425,2425,'2014-01-01','ET','2',1,NULL,'Teri Drake','FI','281546541','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:02',0,'2014-03-10 15:45:56'),(12926,12926,'2014-01-01','ET','2',1,NULL,'Brian Strayer','FI','302728216','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:05:53',0,'2014-03-10 13:59:38'),(13339,13695,'2014-01-01','ET','2',1,NULL,'Crystal Bangura','FI','271785423','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:27',0,'2014-03-01 16:40:16'),(15832,16481,'0000-00-00','ET','2',1,NULL,'Paula Albright','FI','293482379','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:30',0,'2014-03-01 16:56:22'),(16441,17091,'0000-00-00','ET','2',1,NULL,'jasmine martin','FI','301920063','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:52',0,'2014-03-10 14:20:26'),(21453,22103,'0000-00-00','ET','2',2,1,'Kellee Wright','FI','288829205','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:21',0,'2014-03-03 21:36:16'),(20001,20651,'0000-00-00','ET','2',1,NULL,'Robert Collett','FI','275525116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-21 22:00:53',0,'2014-03-01 17:47:19'),(21091,21741,'0000-00-00','ET','2',1,NULL,'Hayden Carter','FI','629348913','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:41',0,'2014-03-02 07:23:39'),(1186,1186,'2014-01-01','ET','2',1,NULL,'Elizabeth Pasquier','FI','589449878','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:20',0,'2014-03-02 04:45:37'),(1348,1348,'2014-01-01','ET','2',1,NULL,'Maria Padron','FI','459177903','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:22',0,'2014-03-02 04:38:08'),(1853,1853,'2014-01-01','ET','2',3,2,'Brooke Dalton','FI','300601269','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:18',0,'2014-03-01 15:26:40'),(2639,2639,'2014-01-01','ET','2',1,NULL,'Vanessa Lee','FI','296803393','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:02',0,'2014-03-10 13:39:10'),(3246,3246,'2014-01-01','ET','2',2,1,'Jamal Bryant','FI','276869883','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:44',0,'2014-03-01 15:52:44'),(7723,7723,'2014-01-01','ET','2',1,NULL,'Steven d McCallum','FI','294480383','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:16',0,'2014-03-10 15:39:19'),(3651,3651,'2014-01-01','ET','2',2,1,'David Stoll','FI','286569427','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:57',0,'2014-03-10 15:52:36'),(7169,7169,'2014-01-01','ET','2',2,1,'Martha Schmidt','FI','280702082','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:40',0,'2014-03-10 15:59:47'),(3656,3656,'2014-01-01','ET','2',1,NULL,'Jeffrey buckey','FI','278703826','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:07',0,'2014-03-10 15:52:36'),(6242,6242,'2014-01-01','ET','2',4,3,'Susan McGuire','FI','268547597','HealthSpan','FI','311431434','Ryan  Valek','94','8576784','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:39',0,'2014-03-10 13:39:10'),(12317,12317,'2014-01-01','ET','2',1,NULL,'TAMARA N WILSON','FI','455068075','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:43',0,'2014-03-02 05:03:29'),(12341,12341,'2014-01-01','ET','2',1,NULL,'ASHLEY KYM DYE','FI','636107413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:35',0,'2014-03-02 05:03:29'),(12405,12405,'2014-01-01','ET','2',1,NULL,'TREGENIA  ARRIE WALTERS','FI','288523367','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:48',0,'2014-03-01 16:35:14'),(12433,12433,'2014-01-01','ET','2',1,NULL,'Jennifer Mayon','FI','434474673','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:52',0,'2014-03-02 05:03:29'),(13384,13740,'2014-01-01','ET','2',1,NULL,'JEFFREY JOHN LOCHER','FI','289742704','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:47',0,'2014-03-10 16:10:34'),(17305,17955,'0000-00-00','ET','2',2,1,'Magen Tardo','FI','439759721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:57',0,'2014-03-02 06:24:38'),(21895,22545,'0000-00-00','ET','2',1,NULL,'brian kirksey','FI','460938377','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:41',0,'2014-03-05 22:27:33'),(22564,23214,'0000-00-00','ET','2',1,NULL,'ADAM SALEH','FI','367199128','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:55',0,'2014-03-10 16:44:18'),(22694,23344,'0000-00-00','ET','2',1,NULL,'Robert Busler','FI','275708630','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:54',0,'2014-03-10 14:50:59'),(22800,23450,'0000-00-00','ET','2',1,NULL,'Elizabeth Keller','FI','279506443','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-09 21:00:51',0,'2014-03-10 16:44:18'),(17628,18278,'0000-00-00','ET','2',1,NULL,'DEBORAH CAROL HUMBLE','FI','439967285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:20',0,'2014-03-02 06:31:45'),(19371,20021,'0000-00-00','ET','2',1,NULL,'Sarah Molloy','FI','149807703','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:47',0,'2014-03-01 17:34:07'),(20177,20827,'0000-00-00','ET','2',1,NULL,'Ronald Garcia','FI','150860446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:13',0,'2014-03-02 07:10:28'),(21394,22044,'0000-00-00','ET','2',1,NULL,'susan hinkle','FI','294700974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:07',0,'2014-03-03 21:36:16'),(21537,22187,'0000-00-00','ET','2',1,NULL,'Luz Ochoa','FI','631274935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:22',0,'2014-03-03 22:26:43'),(21744,22394,'0000-00-00','ET','2',1,NULL,'sandra williams','FI','457555243','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:15',0,'2014-03-04 21:27:16'),(22903,23553,'0000-00-00','ET','2',1,NULL,'KYLE HORTON','FI','436759470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:43',0,'2014-03-10 21:27:11'),(22921,23571,'0000-00-00','ET','2',1,NULL,'Angela Hebert','FI','435292925','Starmount Life Insurance Company','FI','720977315','Gabriel  Janusa','94','7368360','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:56',0,'2014-03-10 21:27:11'),(23100,23750,'0000-00-00','ET','2',1,NULL,'George Svetlik','FI','283480127','Summa Insurance Company, Inc.','FI','341809108','John C  Dalziel','94','362362','348','2014-04-01','Sync Success',0,'2014-03-10 21:30:02',0,'2014-03-10 21:35:03'),(2926,2926,'2014-01-01','ET','2',2,1,'Paul Bailey','FI','296668342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:47',0,'2014-03-01 15:37:30'),(11846,11846,'2014-01-01','ET','2',2,1,'dan polk','FI','388525407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:37',0,'2014-03-01 16:15:39'),(11237,11237,'2014-01-01','ET','2',1,NULL,'Latricia Elliott','FI','298709485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:34',0,'2014-03-01 16:23:43'),(3576,3576,'2014-01-01','ET','2',2,1,'Jeremy Lovell','FI','454495540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:36',0,'2014-03-02 00:10:48'),(10382,10382,'2014-01-01','ET','2',1,NULL,'Branford Brown','FI','299625116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:09',0,'2014-03-01 16:10:36'),(10597,10597,'2014-01-01','ET','2',1,NULL,'DANIEL HARE','FI','634125396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:05',0,'2014-03-02 04:24:47'),(12295,12295,'2014-01-01','ET','2',1,NULL,'Priestly Creswell','FI','428613415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:25:07',0,'2014-03-02 05:10:52'),(13261,13617,'2014-01-01','ET','2',1,NULL,'Charles Heckard','FI','439928167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:56',0,'2014-03-02 05:24:45'),(13875,14231,'2014-01-01','ET','2',1,NULL,'jaymie riggs','FI','445723666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:04',0,'2014-03-02 05:31:31'),(14936,15387,'2014-01-01','ET','2',1,NULL,'William Chose','FI','285840539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:41',0,'2014-03-01 16:46:19'),(22321,22971,'0000-00-00','ET','2',1,NULL,'NORSHA MANNING','FI','426370272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:12',0,'2014-03-06 22:25:29'),(23025,23675,'0000-00-00','ET','2',1,NULL,'Nancy Jaimes','FI','453193560','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:09',0,'2014-03-10 21:27:11'),(2332,2332,'2014-01-01','ET','2',3,2,'david domer','FI','297582411','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:03',0,'2014-03-10 15:45:56'),(3611,3611,'2014-01-01','ET','2',1,NULL,'Lori Donaldson','FI','297606345','Summa Insurance Company, Inc.','FI','341809108','Vera  Miller','94','16448314','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:42',0,'2014-03-10 15:52:36'),(10894,10894,'2014-01-01','ET','2',1,NULL,'Deborah Miller','FI','433902506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:26',0,'2014-03-02 04:24:47'),(21129,21779,'0000-00-00','ET','2',1,NULL,'Steven Gidorkis','FI','306607361','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:07',0,'2014-03-10 16:38:05'),(19042,19692,'0000-00-00','ET','2',1,NULL,'Lori Elliott','FI','295687898','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-15 21:00:13',0,'2014-03-10 14:31:05'),(16964,17614,'0000-00-00','ET','2',1,NULL,'Qiana Quigg','FI','297601366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:07',0,'2014-03-01 17:00:58'),(12627,12627,'2014-01-01','ET','2',1,NULL,'Araceli Luna','FI','457539294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:02',0,'2014-03-02 05:10:52'),(13407,13763,'2014-01-01','ET','2',1,NULL,'Diana Miller','FI','297469967','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:58',0,'2014-03-10 13:59:38'),(15447,15898,'0000-00-00','ET','2',1,NULL,'Michelle Nelson','FI','428214196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:40',0,'2014-03-02 05:59:43'),(16305,16955,'0000-00-00','ET','2',1,NULL,'Scott Covill','FI','273769170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:26',0,'2014-03-01 16:56:22'),(16961,17611,'0000-00-00','ET','2',1,NULL,'Katherine Williams','FI','272705392','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:05',0,'2014-03-10 14:20:26'),(22110,22760,'0000-00-00','ET','2',1,NULL,'Valentin Ponce Galvan','FI','640242016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:37',0,'2014-03-06 21:27:26'),(2776,2776,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:19:32',0,'2014-03-01 16:05:34'),(18031,18681,'0000-00-00','ET','2',2,1,'julie munz','FI','276780155','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:59',0,'2014-03-10 14:24:38'),(17746,18396,'0000-00-00','ET','2',1,NULL,'Ashley Boone','FI','465791270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:33',0,'2014-03-02 06:31:45'),(17461,18111,'0000-00-00','ET','2',2,1,'zenda watson','FI','439199006','Starmount Life Insurance Company','FI','720977315','wayne  landwerlin','94','1632529','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:24',0,'2014-03-02 06:24:38'),(17253,17903,'0000-00-00','ET','2',2,1,'Ronald David','FI','422649420','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:33',0,'2014-03-01 17:20:55'),(17082,17732,'0000-00-00','ET','2',2,1,'Barbara Ortega','FI','572964937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:49',0,'2014-03-02 06:24:38'),(4539,4539,'2014-01-01','ET','2',1,NULL,'Ludwig Freeman','FI','435836686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:19',0,'2014-03-02 04:31:46'),(13170,13526,'2014-01-01','ET','2',2,1,'Michael Schackmann','FI','302881828','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:37',0,'2014-03-10 13:59:38'),(5421,5421,'2014-01-01','ET','2',1,NULL,'Patrick Dougherty','FI','287561203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:59',0,'2014-03-01 15:10:22'),(22829,23479,'0000-00-00','ET','2',1,NULL,'carnell gray','FI','290864009','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:17',0,'2014-03-10 14:50:59'),(1182,1182,'2014-01-01','ET','2',1,NULL,'Pamela Dulock','FI','437967314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:12',0,'2014-03-02 04:38:08'),(18398,19048,'0000-00-00','ET','2',2,1,'Frances LEE','FI','437062524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:59',0,'2014-03-02 06:45:14'),(2495,2495,'2014-01-01','ET','2',2,1,'DENNIS STEELE','FI','546130483','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 20:20:23',0,'2014-03-10 13:10:24'),(2611,2611,'2014-01-01','ET','2',1,0,'Mary Bonko','FI','293523683','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:20',0,'2014-03-10 15:39:19'),(15898,16547,'0000-00-00','ET','2',1,NULL,'Mark Bourcier','FI','368623525','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:11',0,'2014-03-10 14:10:12'),(13796,14152,'2014-01-01','ET','2',1,NULL,'Danny Frazier','FI','276746059','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:44',0,'2014-03-10 13:59:38'),(5389,5389,'2014-01-01','ET','2',2,1,'Thomas Durliat','FI','295527727','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:10',0,'2014-03-10 15:39:19'),(11319,11319,'2014-01-01','ET','2',1,NULL,'ALMA MOLINAR','FI','451416362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:04',0,'2014-03-02 04:52:44'),(12597,12597,'2014-01-01','ET','2',1,NULL,'RAUL CISNEROS','FI','452911012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:00:59',0,'2014-03-02 05:10:52'),(1685,1685,'2014-01-01','ET','2',2,1,'Brian Pauley','FI','297786625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:00',0,'2014-03-01 15:31:33'),(13788,14144,'2014-01-01','ET','2',1,NULL,'robiviere jones','FI','587396099','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:38',0,'2014-03-02 05:24:45'),(13492,13848,'2014-01-01','ET','2',2,1,'Mary Orr','FI','501111266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:11',0,'2014-03-02 05:31:31'),(11938,11938,'2014-01-01','ET','2',1,NULL,'Stacy Lee Lewis','FI','302809189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:14',0,'2014-03-10 13:52:32'),(5701,5701,'2014-01-01','ET','2',1,NULL,'MELINDA JONES','FI','346406245','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:29',0,'2014-03-01 15:48:04'),(4124,4124,'2014-01-01','ET','2',1,NULL,'Larissa Itomlenskis','FI','280909068','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:57',0,'2014-03-01 16:00:27'),(5311,5311,'2014-01-01','ET','2',1,NULL,'Janet Ann Whitaker','FI','292427145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:50',0,'2014-03-01 15:05:09'),(5619,5619,'2014-01-01','ET','2',1,NULL,'Rita Seals','FI','276580156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:50:20',0,'2014-03-01 16:23:43'),(4463,4463,'2014-01-01','ET','2',2,1,'Kevin Burrows','FI','291705088','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:50',0,'2014-03-01 15:16:37'),(22720,23370,'0000-00-00','ET','2',1,NULL,'aaron giffin','FI','290807236','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:13',0,'2014-03-10 14:50:59'),(22483,23133,'0000-00-00','ET','2',1,NULL,'michael loiselle','FI','037462847','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:58',0,'2014-03-07 21:36:32'),(2240,2240,'2014-01-01','ET','2',1,NULL,'Sarah I Rowe','FI','276825839','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:34',0,'2014-03-10 15:39:19'),(22048,22698,'0000-00-00','ET','2',1,NULL,'MARY ROBERTS','FI','587825776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:26',0,'2014-03-05 22:27:33'),(6247,6247,'2014-01-01','ET','2',1,NULL,'Debra Mato','FI','197420350','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:50',0,'2014-03-10 13:32:15'),(21944,22594,'0000-00-00','ET','2',1,NULL,'Rhonda K Sartin','FI','439946907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:15',0,'2014-03-05 22:27:33'),(19305,19955,'0000-00-00','ET','2',1,NULL,'William Bunton','FI','509643458','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:23',0,'2014-03-10 16:31:33'),(18397,19047,'0000-00-00','ET','2',1,NULL,'James Murphy','FI','276769361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:58',0,'2014-03-02 06:45:14'),(18166,18816,'0000-00-00','ET','2',1,NULL,'Marvin Brown','FI','433988325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:27',0,'2014-03-02 06:38:05'),(14767,15218,'2014-01-01','ET','2',2,1,'MARIAN VASILE','FI','511191300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:37',0,'2014-03-02 05:45:37'),(418,418,'2014-01-01','ET','2',1,NULL,'Barbara Dixon','FI','283541519','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:58',0,'2014-03-01 15:21:15'),(21173,21823,'0000-00-00','ET','2',3,2,'LISLIE MARSH','FI','404988546','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:37',0,'2014-03-10 14:45:25'),(20303,20953,'0000-00-00','ET','2',1,NULL,'Mary Faciane','FI','436906536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:00:43',0,'2014-03-02 07:10:28'),(19401,20051,'0000-00-00','ET','2',1,NULL,'Brittany Montgomery','FI','287928770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:09',0,'2014-03-01 17:34:07'),(19156,19806,'0000-00-00','ET','2',1,NULL,'Sharita Kincaid','FI','428658059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:29',0,'2014-03-02 06:52:12'),(13732,14088,'2014-01-01','ET','2',1,NULL,'JOSEFINA THEN','FI','664074016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:02',0,'2014-03-02 05:24:45'),(1742,1742,'2014-01-01','ET','2',1,NULL,'Nora Couch','FI','292507858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:44',0,'2014-03-01 15:31:33'),(11109,11109,'2014-01-01','ET','2',1,NULL,'HEATHER ELLIS','FI','275602683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:23',0,'2014-03-10 13:39:10'),(17254,17904,'0000-00-00','ET','2',1,NULL,'Mike McCue','FI','300588072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:33',0,'2014-03-01 17:20:55'),(12816,12816,'2014-01-01','ET','2',1,NULL,'Patricia Mitchell','94','0001284858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:01:51',0,'2014-03-02 05:10:52'),(7260,7260,'2014-01-01','ET','2',1,NULL,'Divante Morton','FI','282986831','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:29',0,'2014-03-10 13:32:15'),(7113,7113,'2014-01-01','ET','2',1,NULL,'REGINA SZEKELY','FI','290500083','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:59',0,'2014-03-01 15:52:44'),(5627,5627,'2014-01-01','ET','2',1,NULL,'Daniel Opalenik','FI','283481674','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:37',0,'2014-03-10 16:03:49'),(3327,3327,'2014-01-01','ET','2',1,NULL,'DAVID KING','FI','302586256','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:26',0,'2014-03-10 15:52:36'),(13378,13734,'2014-01-01','ET','2',2,1,'Jason Arcudi','FI','192701448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:44',0,'2014-03-02 05:24:45'),(10709,10709,'2014-01-01','ET','2',1,NULL,'Evan Mecklenborg','FI','300980342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:00:51',0,'2014-03-01 16:10:36'),(11989,11989,'2014-01-01','ET','2',1,NULL,'RODD GARCIA','FI','452392624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:40',0,'2014-03-02 05:03:29'),(3139,3139,'2014-01-01','ET','2',1,NULL,'Donald Ritter','FI','285442430','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:22',0,'2014-03-10 13:24:34'),(3978,3978,'2014-01-01','ET','2',1,NULL,'Gary Rayford','FI','436864641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:29',0,'2014-03-01 23:10:52'),(1147,1147,'2014-01-01','ET','2',1,NULL,'DEBORAH  ANN SHAFFETT','FI','439941151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:07',0,'2014-03-02 04:38:08'),(4577,4577,'2014-01-01','ET','2',1,NULL,'channin eldridge','FI','276863813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:32',0,'2014-03-01 16:15:39'),(155,155,'2014-01-01','ET','2',1,NULL,'PATRICIA FADEL','FI','130422001','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:49',0,'2014-03-10 15:45:56'),(22223,22873,'0000-00-00','ET','2',2,1,'James Gonzales','FI','452236537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:56',0,'2014-03-06 21:27:26'),(7321,7321,'2014-01-01','ET','2',1,NULL,'Abigail  Packard','FI','345067752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:21',0,'2014-03-10 13:32:15'),(21081,21731,'0000-00-00','ET','2',1,NULL,'Donna Rusher','FI','300660393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:34',0,'2014-03-01 18:10:11'),(4923,4923,'2014-01-01','ET','2',1,0,'Kathy McLain','FI','461358369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:55',0,'2014-03-01 19:11:03'),(3507,3507,'2014-01-01','ET','2',2,1,'VICKIE NASH','FI','288521916','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:26',0,'2014-03-01 15:37:30'),(4150,4150,'2014-01-01','ET','2',1,NULL,'SEEMA  CHELLATH','FI','616737041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:41',0,'2014-03-01 16:00:27'),(20907,21557,'0000-00-00','ET','2',1,NULL,'David Barnes','FI','273468966','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:48',0,'2014-03-10 14:45:25'),(20676,21326,'0000-00-00','ET','2',1,NULL,'KEITH WAGNER','FI','295526609','HealthSpan','FI','311431434','TIMOTHY  CHARRON','94','7944002','348','2014-03-01','Sync Success',0,'2014-02-26 21:02:45',0,'2014-03-10 14:37:47'),(11506,11506,'2014-01-01','ET','2',1,NULL,'Debra Pardee','FI','439332536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:51',0,'2014-03-02 04:52:44'),(11538,11538,'2014-01-01','ET','2',1,NULL,'Judith Nickelsen','FI','268523480','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:47',0,'2014-03-10 16:03:49'),(12031,12031,'2014-01-01','ET','2',1,NULL,'Chaz Goins','FI','117765834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:16',0,'2014-03-02 04:59:36'),(12547,12547,'2014-01-01','ET','2',1,NULL,'April Hemmer','FI','448840807','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',1,'2014-01-02 04:35:09',0,'2014-03-10 13:59:38'),(19293,19943,'0000-00-00','ET','2',1,NULL,'Yana Provitt','FI','277706773','Summa Insurance Company, Inc.','FI','341809108','Timothy   Miller','94','8007978','348','2014-04-01','Sync Success',0,'2014-02-18 21:30:13',0,'2014-03-10 16:31:33'),(18963,19613,'0000-00-00','ET','2',1,NULL,'christopher jelinek','FI','462673080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:46',0,'2014-03-02 06:52:12'),(18735,19385,'0000-00-00','ET','2',1,NULL,'Amanda Teague','FI','270847212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:18',0,'2014-03-10 16:31:33'),(21993,22643,'0000-00-00','ET','2',1,NULL,'CHERYL ANN ALLISON','FI','279500182','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:48',0,'2014-03-10 16:44:18'),(16490,17140,'0000-00-00','ET','2',1,NULL,'Linda Bonner','FI','366601345','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','357','2014-03-01','Received',0,'2014-01-30 21:00:31',NULL,NULL),(3083,3083,'2014-01-01','ET','2',1,NULL,'MARY B MILLER','FI','459901963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:41',0,'2014-03-02 01:10:33'),(2573,2573,'2014-01-01','ET','2',1,NULL,'Janet Liebenguth','FI','290805510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:06',0,'2014-03-01 15:05:09'),(17383,18033,'0000-00-00','ET','2',1,NULL,'TAIYA JOHNSON','94','0000783279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:30',0,'2014-03-01 17:20:55'),(2977,2977,'2014-01-01','ET','2',2,1,'Mark Vorhees','FI','301448153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:27',0,'2014-03-01 15:37:30'),(16504,17154,'0000-00-00','ET','2',1,NULL,'Debra Mitotes','FI','585423830','Starmount Life Insurance Company','FI','720977315','John  Romero','94','15750460','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:40',0,'2014-03-02 06:10:30'),(3406,3406,'2014-01-01','ET','2',2,1,'ELAINE COLLIER','FI','291423342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:52',0,'2014-03-10 13:32:15'),(6456,6456,'2014-01-01','ET','2',1,NULL,'Mary Ware','FI','296561817','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:21',0,'2014-03-10 13:03:33'),(6323,6323,'2014-01-01','ET','2',2,1,'JAMES HENDERSON','FI','283740410','Summa Insurance Company, Inc.','FI','341809108','SCOTT  DEMKO','94','1829571','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:05',0,'2014-03-10 15:59:47'),(3621,3621,'2014-01-01','ET','2',1,NULL,'HOLLY PATTERSON','FI','450556458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:05:01',0,'2014-03-02 01:10:33'),(12382,12382,'2014-01-01','ET','2',1,NULL,'Timothy Misch','FI','301583162','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:02',0,'2014-03-01 16:30:17'),(14574,15025,'2014-01-01','ET','2',1,NULL,'CARLOS W TATUM','FI','452655558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:33',0,'2014-03-02 05:45:37'),(13821,14177,'2014-01-01','ET','2',1,NULL,'Anna Malesky','FI','290823621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:26',0,'2014-03-02 05:31:31'),(2079,2079,'2014-01-01','ET','2',2,1,'Mack Bell','FI','425315624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:23',0,'2014-03-01 23:10:52'),(3660,3660,'2014-01-01','ET','2',1,NULL,'EDMOND L RICHARD','FI','438618777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:13',0,'2014-03-02 00:10:48'),(7300,7300,'2014-01-01','ET','2',1,NULL,'Brittani Agee','FI','275968708','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:43',0,'2014-03-10 13:32:15'),(5663,5663,'2014-01-01','ET','2',1,NULL,'Robert Schulte','FI','508642766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:46',0,'2014-03-02 04:45:37'),(5382,5382,'2014-01-01','ET','2',1,NULL,'Kirsten Rauch','FI','539788595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:57',0,'2014-03-01 21:11:04'),(5251,5251,'2014-01-01','ET','2',1,NULL,'ROSE  MARIE BARNES','FI','426115155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:03',0,'2014-03-02 00:10:48'),(5230,5230,'2014-01-01','ET','2',1,NULL,'Heather Renee Seay','FI','467991771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:25',0,'2014-03-02 00:10:48'),(3734,3734,'2014-01-01','ET','2',1,NULL,'Mark Kerry Sutton','FI','268584664','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:42',0,'2014-03-10 13:20:27'),(11763,11763,'2014-01-01','ET','2',1,NULL,'Lisa Marie Jundi','FI','287769820','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:50',0,'2014-03-10 16:10:34'),(12731,12731,'2014-01-01','ET','2',1,NULL,'Denise Noble','FI','272607964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:00',0,'2014-03-10 13:59:38'),(13062,13418,'2014-01-01','ET','2',1,NULL,'BARBARA  RICHARDSON','FI','022923657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:31',0,'2014-03-02 05:17:40'),(13196,13552,'2014-01-01','ET','2',4,3,'TRI TA','FI','415430607','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:33',0,'2014-03-10 13:59:38'),(13787,14143,'2014-01-01','ET','2',1,NULL,'Jamie Reynolds','FI','587548482','Starmount Life Insurance Company','FI','720977315','Revonno  Burt','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:38',0,'2014-03-02 05:24:45'),(15212,15663,'0000-00-00','ET','2',1,NULL,'Leslie Foster','FI','272701400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:33',0,'2014-03-01 16:50:53'),(16076,16725,'0000-00-00','ET','2',1,NULL,'JAMAL  GILLS','FI','295705745','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:01',0,'2014-03-01 16:56:22'),(17464,18114,'0000-00-00','ET','2',1,NULL,'Rebecca Shettlesworth','FI','590161493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:27',0,'2014-03-02 06:31:45'),(20773,21423,'0000-00-00','ET','2',1,NULL,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:30:45',0,'2014-03-01 18:10:11'),(22992,23642,'0000-00-00','ET','2',1,NULL,'theresa heart','FI','282648065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:45',0,'2014-03-10 21:36:25'),(305,305,'2014-01-01','ET','2',1,NULL,'Forest DeVore','FI','495601985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:22',0,'2014-03-01 22:10:55'),(19427,20077,'0000-00-00','ET','2',1,NULL,'Glenda Hunt','FI','413860156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:29',0,'2014-03-02 06:59:07'),(2072,2072,'2014-01-01','ET','2',1,NULL,'JAMES EBERT','FI','275489995','Summa Insurance Company, Inc.','FI','341809108','GINA  OBRODO','94','3340371','348','2014-01-01','Sync Success',0,'2013-12-25 19:37:09',0,'2014-03-10 15:45:56'),(19208,19858,'0000-00-00','ET','2',3,2,'Thomas Porter','FI','291448039','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:05',0,'2014-03-10 16:31:33'),(14118,14569,'2014-01-01','ET','2',2,1,'DELAYNO ROBINSON','FI','356541368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:47',0,'2014-03-01 16:46:19'),(10942,10942,'2014-01-01','ET','2',1,NULL,'Pamela Gelsinger','FI','271465835','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:08:59',0,'2014-03-10 16:03:49'),(12459,12459,'2014-01-01','ET','2',1,NULL,'Sarah Jo Ventura','FI','282967024','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:50',0,'2014-03-10 16:10:34'),(12316,12316,'2014-01-01','ET','2',1,NULL,'Brad Stone','FI','446928158','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:41',0,'2014-03-02 05:03:29'),(19837,20487,'0000-00-00','ET','2',4,3,'Miranda Camden','FI','271784147','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:54',0,'2014-03-01 17:47:19'),(7443,7443,'2014-01-01','ET','2',2,1,'EUNICE MARTIN','FI','454215113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:13',0,'2014-03-02 04:10:25'),(770,770,'2014-01-01','ET','2',2,1,'Sankung Daffeh','FI','010331954','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:03',0,'2014-03-01 15:05:09'),(16987,17637,'0000-00-00','ET','2',1,NULL,'Neil Jacobsen','FI','320781714','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:20',0,'2014-03-10 16:24:30'),(22178,22828,'0000-00-00','ET','2',1,NULL,'Edward DeMartin','FI','271641065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:23',0,'2014-03-06 21:36:23'),(17319,17969,'0000-00-00','ET','2',1,NULL,'CHARLES  AUBERT','FI','436865103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:05',0,'2014-03-02 06:24:38'),(7355,7355,'2014-01-01','ET','2',1,NULL,'Daniel Frazier','FI','283509982','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:39',0,'2014-03-01 15:16:37'),(15817,16466,'0000-00-00','ET','2',1,NULL,'STEPHANIE BORJAS','FI','638034088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:21',0,'2014-03-02 06:03:21'),(5945,5945,'2014-01-01','ET','2',1,NULL,'Sandra Jackson','FI','435432395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:11',0,'2014-03-02 01:10:33'),(15634,16085,'0000-00-00','ET','2',1,NULL,'dwayne a jordan','FI','278904910','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:52',0,'2014-03-10 16:17:47'),(20406,21056,'0000-00-00','ET','2',1,NULL,'Cyndi Busby','FI','436651252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 09:30:32',0,'2014-03-02 07:10:28'),(15298,15749,'0000-00-00','ET','2',1,NULL,'TANYA  WADE','FI','281720182','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:17',0,'2014-03-10 16:17:47'),(10526,10526,'2014-01-01','ET','2',1,NULL,'Carolyn Coleman','FI','456375225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:41',0,'2014-03-02 04:24:47'),(10425,10425,'2014-01-01','ET','2',1,NULL,'Robert Agosti','FI','182609696','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:27',0,'2014-03-01 16:10:36'),(21529,22179,'0000-00-00','ET','2',1,NULL,'SILVIA REYES DE CEDILLO','FI','648468921','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:16',0,'2014-03-03 22:26:43'),(22473,23123,'0000-00-00','ET','2',1,NULL,'HELENA SHERIDAN','FI','277506883','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:52',0,'2014-03-07 21:36:32'),(980,980,'2014-01-01','ET','2',1,NULL,'myree marshall','FI','401022062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:35',0,'2014-03-01 15:21:15'),(19925,20575,'0000-00-00','ET','2',1,NULL,'Robert Lantz','FI','090547898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:19',0,'2014-03-01 17:47:19'),(2080,2080,'2014-01-01','ET','2',2,1,'Michael Childers','FI','587286511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:24',0,'2014-03-01 23:10:52'),(3559,3559,'2014-01-01','ET','2',1,NULL,'Malerie Berger','FI','270582719','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:06',0,'2014-03-01 15:37:30'),(6049,6049,'2014-01-01','ET','2',1,0,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:32',0,'2014-03-10 13:03:33'),(19791,20441,'0000-00-00','ET','2',1,NULL,'Shamieka Jamerson','FI','434394273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:16',0,'2014-03-02 07:03:25'),(4255,4255,'2014-01-01','ET','2',1,NULL,'Nathaniel Schaffner','FI','585515129','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:59',0,'2014-03-10 13:32:15'),(13924,14280,'2014-01-01','ET','2',1,NULL,'Shirley Dawson','FI','425277427','Starmount Life Insurance Company','FI','720977315','Kenneth  Myricks','94','7275379','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:16',0,'2014-03-02 05:31:31'),(13689,14045,'2014-01-01','ET','2',1,NULL,'Stephanie Carrillo','FI','628034645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:33',0,'2014-03-02 05:24:45'),(21912,22562,'0000-00-00','ET','2',1,NULL,'Heath Elmore','FI','631033177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:52',0,'2014-03-05 22:27:33'),(258,258,'2014-01-01','ET','2',1,NULL,'Kimberly Marshall','FI','437693918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:09',0,'2014-03-01 20:10:57'),(18138,18788,'0000-00-00','ET','2',1,NULL,'Julia LeMense','FI','385642737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:06',0,'2014-03-02 06:38:05'),(5024,5024,'2014-01-01','ET','2',1,NULL,'Deborah Gunnell','FI','281466067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:44',0,'2014-03-01 15:31:33'),(3445,3445,'2014-01-01','ET','2',1,NULL,'LINDA J RAPPACH','FI','289523854','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:10',0,'2014-03-10 13:32:15'),(11537,11537,'2014-01-01','ET','2',1,NULL,'Russell Joseph Sonnier','FI','439787495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:45',0,'2014-03-02 04:59:36'),(13165,13521,'2014-01-01','ET','2',1,NULL,'Kyle Hancock','FI','412334301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:26',0,'2014-03-02 05:17:40'),(13381,13737,'2014-01-01','ET','2',1,NULL,'MARIO PENA','FI','455132610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:45',0,'2014-03-02 05:24:45'),(15463,15914,'0000-00-00','ET','2',1,NULL,'Mary Cegelski','FI','299469711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:50',0,'2014-03-01 16:50:53'),(17973,18623,'0000-00-00','ET','2',1,NULL,'Bobby Moore','FI','642106713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:20',0,'2014-03-02 06:31:45'),(16606,17256,'0000-00-00','ET','2',1,NULL,'GARLA SIMMS','FI','458844234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:11',0,'2014-03-02 06:17:30'),(16831,17481,'0000-00-00','ET','2',2,1,'rosemary czlapinski','FI','279444343','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:14',0,'2014-03-10 14:20:26'),(66,66,'2014-01-01','ET','2',2,1,'dorothy m daugherty','FI','291502826','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:59',0,'2014-03-01 15:26:40'),(525,525,'2014-01-01','ET','2',1,NULL,'Gary Churchill','FI','298466825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:01:12',0,'2014-03-01 15:48:04'),(20391,21041,'0000-00-00','ET','2',2,1,'Sharon Haley','FI','465046219','Starmount Life Insurance Company','FI','720977315','Alan   Charring','94','801753','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:19',0,'2014-03-02 07:10:28'),(662,662,'2014-01-01','ET','2',1,NULL,'Gloria Jimenez','FI','462848356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:33',0,'2014-03-02 02:10:49'),(2421,2421,'2014-01-01','ET','2',1,NULL,'MARY J BONKO','FI','293523683','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:55',0,'2014-03-10 15:45:56'),(7115,7115,'2014-01-01','ET','2',1,NULL,'NANCY B POTTER','FI','229867538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:02',0,'2014-03-01 15:52:44'),(20390,21040,'0000-00-00','ET','2',1,NULL,'Iaan Lucero','FI','449950110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:19',0,'2014-03-02 07:10:28'),(3766,3766,'2014-01-01','ET','2',1,NULL,'Theresa Rothschild','FI','447585269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:12',0,'2014-03-01 23:10:52'),(18366,19016,'0000-00-00','ET','2',1,NULL,'TRUNG VAN NGUYEN','FI','462719714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:37',0,'2014-03-02 06:45:14'),(17124,17774,'0000-00-00','ET','2',1,NULL,'David Thomas','FI','174747130','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:15',0,'2014-03-10 14:20:26'),(12199,12199,'2014-01-01','ET','2',1,NULL,'maureen a longworth','FI','269526138','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:09:16',0,'2014-03-10 13:52:32'),(12328,12328,'2014-01-01','ET','2',1,NULL,'VALERIE SATCHELL','FI','541706552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:08',0,'2014-03-02 05:03:29'),(16965,17615,'0000-00-00','ET','2',1,NULL,'Neil Jacobsen','FI','320781714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:08',0,'2014-03-01 17:00:58'),(15711,16360,'0000-00-00','ET','2',1,NULL,'Kay Forfman','FI','385629293','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:55',0,'2014-03-10 14:10:12'),(14418,14869,'2014-01-01','ET','2',1,NULL,'Carla Howe','FI','410021388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:15',0,'2014-03-02 05:38:34'),(20952,21602,'0000-00-00','ET','2',2,1,'NORMA FISHER-FLORES','FI','450371998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:06',0,'2014-03-02 07:17:36'),(14903,15354,'2014-01-01','ET','2',1,NULL,'Amy Dannel','FI','437410908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:25',0,'2014-03-02 05:52:31'),(14707,15158,'2014-01-01','ET','2',2,1,'Ruby French','FI','435062080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:59',0,'2014-03-02 05:45:37'),(3036,3036,'2014-01-01','ET','2',1,NULL,'Ruth Norton','FI','298505352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:12',0,'2014-03-01 15:37:30'),(5787,5787,'2014-01-01','ET','2',1,NULL,'VERONICA A FOSTER','FI','301545217','Summa Insurance Company, Inc.','FI','341809108','SHERI  DIBACCO','94','16808985','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:08',0,'2014-03-10 15:52:36'),(5285,5285,'2014-01-01','ET','2',1,NULL,'Jennifer Massey','FI','457298540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:53',0,'2014-03-01 20:10:57'),(13224,13580,'2014-01-01','ET','2',2,1,'norberto juarez','FI','452235764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:01',0,'2014-03-02 05:17:40'),(3914,3914,'2014-01-01','ET','2',1,NULL,'Michael Vernon Charette','FI','294643521','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:29',0,'2014-03-01 15:26:40'),(21752,22402,'0000-00-00','ET','2',4,3,'CAROL ZIMMERMAN','FI','272547076','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-05-01','Sync Success',0,'2014-03-04 21:02:22',0,'2014-03-10 16:44:18'),(4130,4130,'2014-01-01','ET','2',1,NULL,'Barbara Vance','FI','401025431','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:07',0,'2014-03-01 16:00:27'),(11090,11090,'2014-01-01','ET','2',1,NULL,'MICHAEL SNIDER','FI','275603151','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:47',0,'2014-03-10 13:39:10'),(13041,13397,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:48',0,'2014-03-01 16:35:14'),(19880,20530,'0000-00-00','ET','2',2,1,'marcus holland','FI','293843322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:28',0,'2014-03-01 17:47:19'),(16539,17189,'0000-00-00','ET','2',1,NULL,'Denise Gaines','FI','438590715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:02',0,'2014-03-02 06:10:30'),(7354,7354,'2014-01-01','ET','2',1,NULL,'Schuanch M Harris','FI','270669678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:37',0,'2014-03-01 15:16:37'),(21463,22113,'0000-00-00','ET','2',1,NULL,'Taundra LaVae Ezell','FI','270581606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:30',0,'2014-03-03 21:36:16'),(22395,23045,'0000-00-00','ET','2',1,NULL,'Karen Spray','FI','275662924','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:33',0,'2014-03-10 14:50:59'),(14172,14623,'2014-01-01','ET','2',1,NULL,'Rebecca Evans','FI','275489058','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:21',0,'2014-03-10 16:17:47'),(5116,5116,'2014-01-01','ET','2',1,NULL,'Matthew Bucklan','FI','275848558','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:45',0,'2014-03-10 15:45:56'),(13685,14041,'2014-01-01','ET','2',1,NULL,'Allison Burk','FI','456771684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:31',0,'2014-03-02 05:24:45'),(13437,13793,'2014-01-01','ET','2',1,NULL,'MARIA ROSARIO DIAZ','FI','629908210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:10',0,'2014-03-02 05:31:31'),(11412,11412,'2014-01-01','ET','2',2,1,'CARMEN RIFE','FI','291841230','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:57',0,'2014-03-10 13:52:32'),(19247,19897,'0000-00-00','ET','2',2,1,'Joni Privett','94','0000705202','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-16 19:00:37',0,'2014-03-10 14:31:05'),(15860,16509,'0000-00-00','ET','2',2,1,'Brian Ferguson','FI','287640558','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:47',0,'2014-03-10 16:24:30'),(12930,12930,'2014-01-01','ET','2',1,NULL,'randall shearer','FI','272763670','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:06:03',0,'2014-03-10 13:59:38'),(22138,22788,'0000-00-00','ET','2',1,NULL,'Heather Hutto','FI','439774698','Starmount Life Insurance Company','FI','720977315','mary  siggers','94','15257239','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:57',0,'2014-03-06 21:27:26'),(1461,1461,'2014-01-01','ET','2',1,NULL,'Katrina Wilson','FI','277827402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:09',0,'2014-03-01 16:15:39'),(6438,6438,'2014-01-01','ET','2',1,NULL,'Joe Patterson','FI','294527022','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:40',0,'2014-03-01 15:10:22'),(2897,2897,'2014-01-01','ET','2',1,NULL,'ROBIN J AHRMAN','FI','285662448','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:38',0,'2014-03-10 13:39:10'),(12663,12663,'2014-01-01','ET','2',2,1,'Geraldine Demoulin','FI','151489806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:26',0,'2014-03-01 16:35:14'),(5630,5630,'2014-01-01','ET','2',2,1,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:42',0,'2014-03-10 16:03:49'),(4347,4347,'2014-01-01','ET','2',1,NULL,'david baney','FI','284621335','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:42',0,'2014-03-10 13:32:15'),(22636,23286,'0000-00-00','ET','2',1,NULL,'THOMAS KURLAS','FI','271668100','Dental Care Plus, Inc.','FI','311185262','JOANNA  PFAFF','94','16849533','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:09',0,'2014-03-08 21:35:36'),(1509,1509,'2014-01-01','ET','2',1,NULL,'MELISSA ROHRER','FI','270503065','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:39',0,'2014-03-10 16:03:49'),(2825,2825,'2014-01-01','ET','2',2,1,'Hoang Tran','FI','586507852','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:08',0,'2014-03-02 04:15:49'),(19509,20159,'0000-00-00','ET','2',4,3,'danny grubb','FI','401278536','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:06:27',0,'2014-03-01 17:34:07'),(10371,10371,'2014-01-01','ET','2',1,NULL,'Tyrone Smith','FI','298701446','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:49',0,'2014-03-01 16:05:34'),(7503,7503,'2014-01-01','ET','2',1,NULL,'Kimberly Vivens','FI','302800161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:34:11',0,'2014-03-01 16:05:34'),(6101,6101,'2014-01-01','ET','2',1,NULL,'Alberta Harris','FI','272506145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:23',0,'2014-03-01 16:00:27'),(18595,19245,'0000-00-00','ET','2',1,NULL,'MARY ROTHENBUSH','FI','300883233','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:29',0,'2014-03-01 17:26:36'),(5547,5547,'2014-01-01','ET','2',1,NULL,'Joeseph Saviano','FI','283447233','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:58',0,'2014-03-01 16:23:43'),(18029,18679,'0000-00-00','ET','2',1,NULL,'lois holzhauser','FI','269703271','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:58',0,'2014-03-10 14:24:38'),(5208,5208,'2014-01-01','ET','2',1,NULL,'James White','94','0000400453','Starmount Life Insurance Company','FI','720977315','DALE  ADAMS','94','8330750','348','2014-01-01','Sync Success',0,'2013-12-26 00:52:37',0,'2014-03-02 00:10:48'),(11877,11877,'2014-01-01','ET','2',1,NULL,'Maria Villarreal','FI','467157100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:16',0,'2014-03-02 04:59:36'),(21094,21744,'0000-00-00','ET','2',1,NULL,'VICTOR  HARRISON','FI','449088498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:30:43',0,'2014-03-02 07:23:39'),(13319,13675,'2014-01-01','ET','2',2,1,'JOHN RHODES','FI','426946142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:19',0,'2014-03-02 05:24:45'),(20838,21488,'0000-00-00','ET','2',1,NULL,'Tiana Jarmon','FI','644284981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:31:16',0,'2014-03-02 07:17:36'),(16295,16945,'0000-00-00','ET','2',1,NULL,'Sylvia Lopez','FI','460316441','Starmount Life Insurance Company','FI','720977315','Nelda  Prince','94','1250086','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:19',0,'2014-03-02 06:10:30'),(20330,20980,'0000-00-00','ET','2',1,NULL,'Barbara Austin','FI','279604577','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:19',0,'2014-03-01 17:47:19'),(4199,4199,'2014-01-01','ET','2',1,NULL,'Harmony Warner','FI','536846193','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:06:14',0,'2014-03-10 13:32:15'),(5863,5863,'2014-01-01','ET','2',1,NULL,'Kyle Pinkerton','FI','466089192','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:40',0,'2014-03-01 19:11:03'),(5898,5898,'2014-01-01','ET','2',1,NULL,'JOHN GREENWALD','FI','275503097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:41',0,'2014-03-01 15:48:04'),(6116,6116,'2014-01-01','ET','2',1,NULL,'MARY LAMBCKE','FI','280500224','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:47',0,'2014-03-01 16:00:27'),(16954,17604,'0000-00-00','ET','2',1,NULL,'Sirmedra Tolliver','FI','433356116','Starmount Life Insurance Company','FI','720977315','Pamela  Price','94','4697079','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:01',0,'2014-03-02 06:17:30'),(7241,7241,'2014-01-01','ET','2',1,NULL,'brenda sue johnson','FI','434901494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:57',0,'2014-03-02 03:09:49'),(2878,2878,'2014-01-01','ET','2',1,NULL,'AMNE ORRA','FI','291741463','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:55',0,'2014-03-10 13:39:10'),(7398,7398,'2014-01-01','ET','2',1,NULL,'Larry Nicely','FI','299480607','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:48',0,'2014-03-10 13:39:10'),(1116,1116,'2014-01-01','ET','2',1,NULL,'Paul Rivas','FI','449317328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:09',0,'2014-03-02 04:38:08'),(14933,15384,'2014-01-01','ET','2',2,1,'NEAL SALING','FI','400048187','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:39',0,'2014-03-01 16:50:53'),(16190,16839,'0000-00-00','ET','2',1,NULL,'Lisa Simes','FI','539620645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:32',0,'2014-03-01 16:56:22'),(1490,1490,'2014-01-01','ET','2',1,NULL,'Hing Chan','FI','067705112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:04',0,'2014-03-10 16:03:49'),(20096,20746,'0000-00-00','ET','2',1,NULL,'MOLLY WORTH','FI','438610857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:16',0,'2014-03-02 07:10:28'),(2817,2817,'2014-01-01','ET','2',1,NULL,'Cena Glass','FI','437171166','Dental Care Plus, Inc.','FI','311185262','Michael Joseph Fitzpatrick','94','16875889','348','2014-01-01','Sync Success',0,'2013-12-25 21:20:50',0,'2014-03-01 16:05:34'),(17780,18430,'0000-00-00','ET','2',1,NULL,'FRANCISCO VASQUEZ','FI','457319767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:17',0,'2014-03-02 06:03:21'),(4241,4241,'2014-01-01','ET','2',1,NULL,'Paul Dent','FI','236844091','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Brett','94','2777121','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:32',0,'2014-03-10 15:59:47'),(16144,16793,'0000-00-00','ET','2',1,NULL,'Ginger Roberts','FI','587571965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:04',0,'2014-03-02 06:03:21'),(13653,14009,'2014-01-01','ET','2',2,1,'adolfo brindis','FI','609920518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:11',0,'2014-03-02 05:24:45'),(1753,1753,'2014-01-01','ET','2',1,NULL,'Tamara Lynn Baker','FI','300662132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:04',0,'2014-03-01 15:31:33'),(12307,12307,'2014-01-01','ET','2',1,NULL,'Holly Bonner','FI','289842352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:25:33',0,'2014-03-10 16:10:34'),(11157,11157,'2014-01-01','ET','2',1,NULL,'Matthew Becker','FI','300622127','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:10',0,'2014-03-10 13:45:57'),(1508,1508,'2014-01-01','ET','2',1,NULL,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:57:38',0,'2014-03-10 16:03:49'),(3599,3599,'2014-01-01','ET','2',1,NULL,'Rosa Fried','FI','467835413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:18',0,'2014-03-02 01:10:33'),(20202,20852,'0000-00-00','ET','2',2,1,'William Parrott','FI','510500611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:32',0,'2014-03-02 07:10:28'),(3521,3521,'2014-01-01','ET','2',1,NULL,'William Coulter','FI','291548883','Dental Care Plus, Inc.','FI','311185262','Kristina   Black','94','11138441','348','2014-01-01','Sync Success',0,'2013-12-25 22:01:51',0,'2014-03-01 15:37:30'),(2865,2865,'2014-01-01','ET','2',1,NULL,'WILLIAM MEADOWS','FI','296564274','HealthSpan','FI','311431434','GERALD C CAMPBELL','94','966822','357','2014-01-01','Sync Success',0,'2013-12-25 21:22:28',0,'2014-03-10 13:39:10'),(1955,1955,'2014-01-01','ET','2',1,NULL,'Gloria Ann Siffel','FI','402684482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:22',0,'2014-03-01 15:26:40'),(4544,4544,'2014-01-01','ET','2',1,NULL,'GENE  BUECHE','FI','435928262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:29',0,'2014-03-02 04:31:46'),(19764,20414,'0000-00-00','ET','2',1,NULL,'thomas f hathcox','FI','434558801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:15',0,'2014-03-02 07:03:25'),(17849,18499,'0000-00-00','ET','2',1,NULL,'DEBORAH SUE GRAHN','FI','085388827','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:14',0,'2014-03-10 14:20:26'),(15618,16069,'0000-00-00','ET','2',1,NULL,'JIMMY  L DOSS','FI','426416711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:44',0,'2014-03-02 05:59:43'),(12116,12116,'2014-01-01','ET','2',1,NULL,'Jacinta N Dunbar','FI','233617176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:06:16',0,'2014-03-01 16:30:17'),(13204,13560,'2014-01-01','ET','2',1,NULL,'billie levert','FI','291540655','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:12',0,'2014-03-01 16:35:14'),(13364,13720,'2014-01-01','ET','2',1,NULL,'Humberto Camacho','FI','565558172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:38',0,'2014-03-02 05:24:45'),(14220,14671,'2014-01-01','ET','2',1,NULL,'MICHELLE ANN MEXICOTT','FI','269684811','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:54',0,'2014-03-10 14:03:26'),(520,520,'2014-01-01','ET','2',1,NULL,'Peggy Wainscott','FI','296526826','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:01:03',0,'2014-03-01 15:48:04'),(15861,16510,'0000-00-00','ET','2',1,NULL,'Margaret Rita Wisniewski','FI','269489277','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:48',0,'2014-03-10 16:24:30'),(1193,1193,'2014-01-01','ET','2',1,NULL,'Lillian Nellon','FI','439087265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:33',0,'2014-03-02 04:45:37'),(1960,1960,'2014-01-01','ET','2',1,NULL,'Carol s SCHULER','FI','281509662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:31',0,'2014-03-01 15:26:40'),(12416,12416,'2014-01-01','ET','2',1,NULL,'kevin harrell','FI','439790147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:16',0,'2014-03-02 05:03:29'),(4487,4487,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:31:39',0,'2014-03-10 15:39:19'),(21664,22314,'0000-00-00','ET','2',1,NULL,'ANDREW WOOD','FI','269844196','Dental Care Plus, Inc.','FI','311185262','MATTHEW  WILLIAMS','94','17024435','348','2014-04-01','Sync Success',0,'2014-03-04 21:01:08',0,'2014-03-04 21:36:30'),(19996,20646,'0000-00-00','ET','2',1,NULL,'glenn alexander','FI','295508078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:50',0,'2014-03-01 17:47:19'),(17359,18009,'0000-00-00','ET','2',1,NULL,'Maxine Truesdale','FI','460113275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:14',0,'2014-03-02 06:31:45'),(5809,5809,'2014-01-01','ET','2',1,NULL,'Mark Brock','FI','282627471','HealthSpan','FI','311431434','Brad  Heter','94','7285046','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:52',0,'2014-03-10 13:24:34'),(16759,17409,'0000-00-00','ET','2',1,NULL,'Richard Conville','FI','033487846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:16',0,'2014-03-02 06:17:30'),(14894,15345,'2014-01-01','ET','2',1,NULL,'James F Zander','FI','455909808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:21',0,'2014-03-02 05:45:37'),(14970,15421,'2014-01-01','ET','2',4,3,'Ana Trinh','FI','298944966','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:58',0,'2014-03-01 16:50:53'),(10895,10895,'2014-01-01','ET','2',1,NULL,'abdalla abdalla','FI','439972054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:28',0,'2014-03-02 04:24:47'),(2834,2834,'2014-01-01','ET','2',3,2,'Steven Steormann','FI','112823626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:27',0,'2014-03-02 04:15:49'),(2480,2480,'2014-01-01','ET','2',1,NULL,'Paula Evans','FI','450113370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:50',0,'2014-03-10 13:10:24'),(4299,4299,'2014-01-01','ET','2',1,NULL,'Linda Hamilton','FI','284480754','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:16',0,'2014-03-10 13:32:15'),(1458,1458,'2014-01-01','ET','2',2,1,'RYAN ASHLEY RUTAN','FI','409319632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:01',0,'2014-03-01 16:15:39'),(21370,22020,'0000-00-00','ET','2',3,2,'Timothy Carmany','FI','289643056','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:36',0,'2014-03-10 16:38:05'),(5567,5567,'2014-01-01','ET','2',1,NULL,'hannah neill','FI','630165697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:35',0,'2014-03-02 04:45:37'),(17703,18353,'0000-00-00','ET','2',1,NULL,'TOMMIE VASQUEZ','FI','456782774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:04',0,'2014-03-02 06:31:45'),(17542,18192,'0000-00-00','ET','2',1,NULL,'Katherine Gerding','FI','286883852','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:29',0,'2014-03-10 14:24:38'),(6461,6461,'2014-01-01','ET','2',1,NULL,'Brandie Lawrence','FI','271806443','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:30',0,'2014-03-10 13:03:33'),(17367,18017,'0000-00-00','ET','2',1,NULL,'ERIKA PORRAS','FI','466639137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:19',0,'2014-03-02 06:24:38'),(4839,4839,'2014-01-01','ET','2',1,NULL,'Carole Harteis','FI','299543505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:17',0,'2014-03-01 15:10:22'),(10632,10632,'2014-01-01','ET','2',1,NULL,'DIAMOND ARRINGTON','FI','597249291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:14',0,'2014-03-02 04:31:46'),(1379,1379,'2014-01-01','ET','2',1,NULL,'SUNEETHA KATTA','FI','321114899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:20',0,'2014-03-02 04:45:37'),(1225,1225,'2014-01-01','ET','2',1,NULL,'JASON L SWEENEY','FI','283761902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:33',0,'2014-03-01 16:15:39'),(3577,3577,'2014-01-01','ET','2',1,NULL,'Bryan Wack','FI','495966139','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:38',0,'2014-03-02 00:10:48'),(3594,3594,'2014-01-01','ET','2',1,NULL,'Lonnie Thompson','FI','464907855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:09',0,'2014-03-02 01:10:33'),(21662,22312,'0000-00-00','ET','2',1,NULL,'Derek E Bersacola','FI','277867057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:07',0,'2014-03-04 21:36:30'),(1330,1330,'2014-01-01','ET','2',1,NULL,'Andrew Perez','FI','450935745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:46',0,'2014-03-02 04:38:08'),(4525,4525,'2014-01-01','ET','2',1,NULL,'MICHAEL  DIETRICH','FI','269869538','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:56',0,'2014-03-10 13:03:33'),(10809,10809,'2014-01-01','ET','2',1,NULL,'Albert Luis Vazquez','FI','583921602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:10',0,'2014-03-02 04:24:47'),(21545,22195,'0000-00-00','ET','2',1,NULL,'Kimberly Reser','FI','289749640','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:31:28',0,'2014-03-10 14:45:25'),(21488,22138,'0000-00-00','ET','2',1,NULL,'alicia lewis','FI','294826258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:47',0,'2014-03-03 21:36:16'),(21027,21677,'0000-00-00','ET','2',1,NULL,'Joshua Wayne Meek','94','0000418918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:19',0,'2014-03-01 18:10:11'),(14298,14749,'2014-01-01','ET','2',1,NULL,'Joseph Brouse','FI','287829191','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:23',0,'2014-03-01 16:46:19'),(16306,16956,'0000-00-00','ET','2',1,NULL,'JOHN  RITTERBACH','FI','269461288','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:27',0,'2014-03-01 16:56:22'),(20198,20848,'0000-00-00','ET','2',1,NULL,'COSSETTE KELLY-VUJANOV','FI','147864929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:29',0,'2014-03-02 07:10:28'),(18964,19614,'0000-00-00','ET','2',1,NULL,'Tiffany Wiggins','FI','587492639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:47',0,'2014-03-02 06:52:12'),(18812,19462,'0000-00-00','ET','2',2,1,'Michael Scott Vayda','FI','280742980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:18',0,'2014-03-10 14:31:05'),(17438,18088,'0000-00-00','ET','2',1,NULL,'Satiago Cobos','FI','450270185','Starmount Life Insurance Company','FI','720977315','Christopher  Wang','94','15980657','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:07',0,'2014-03-02 06:31:45'),(548,548,'2014-01-01','ET','2',1,NULL,'Kathryn DiBiagio','FI','213137681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:56',0,'2014-03-01 15:48:04'),(18952,19602,'0000-00-00','ET','2',1,NULL,'Juanita Grant','FI','249042251','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:39',0,'2014-03-10 14:31:05'),(18617,19267,'0000-00-00','ET','2',2,1,'Carol Kunzin','FI','296685236','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:48',0,'2014-03-10 16:31:33'),(11432,11432,'2014-01-01','ET','2',1,NULL,'Jonathan Meyers','FI','295886959','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:35',0,'2014-03-10 13:52:32'),(4018,4018,'2014-01-01','ET','2',2,1,'MARIA GUERRA','FI','637386113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:40',0,'2014-03-02 03:09:49'),(1677,1677,'2014-01-01','ET','2',2,1,'GABRIELA E DIAZ','FI','635277359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:44',0,'2014-03-02 00:10:48'),(7687,7687,'2014-01-01','ET','2',1,NULL,'MARY YOUNKER','FI','274565340','HealthSpan','FI','311431434','GERALD C CAMPBELL','94','966822','348','2014-01-01','Sync Success',0,'2013-12-26 04:40:05',0,'2014-03-10 13:39:10'),(16921,17571,'0000-00-00','ET','2',1,NULL,'Corey Caputo','FI','281945378','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:39',0,'2014-03-01 17:00:58'),(15430,15881,'0000-00-00','ET','2',2,1,'Robert Bergdorf','FI','270500812','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:29',0,'2014-03-10 16:17:47'),(14198,14649,'2014-01-01','ET','2',1,NULL,'Aleem Jaffer','FI','638036006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:38',0,'2014-03-02 05:38:34'),(15001,15452,'2014-01-01','ET','2',1,NULL,'john spellacy','FI','283829855','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:10',0,'2014-03-10 16:17:47'),(21885,22535,'0000-00-00','ET','2',1,NULL,'Laura Cowell','FI','585498858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:32',0,'2014-03-05 22:27:33'),(19662,20312,'0000-00-00','ET','2',5,4,'MAURA KENNEDY ANAYA','FI','251843487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:17',0,'2014-03-01 17:47:19'),(12927,12927,'2014-01-01','ET','2',1,NULL,'GREGORY P EPPS','FI','272607825','HealthSpan','FI','311431434','ROY  GULASA Jr','94','17055451','348','2014-02-01','Sync Success',0,'2014-01-04 02:05:55',0,'2014-03-10 13:59:38'),(5753,5753,'2014-01-01','ET','2',1,NULL,'Mike Mills','FI','271640963','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:59',0,'2014-03-10 13:24:34'),(2614,2614,'2014-01-01','ET','2',1,NULL,'Carolyn Knight','FI','273545376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:26',0,'2014-03-01 15:16:37'),(1844,1844,'2014-01-01','ET','2',2,1,'Rosemary Massie','FI','291744049','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:21:08',0,'2014-03-10 13:20:27'),(1655,1655,'2014-01-01','ET','2',1,NULL,'michael jesenovic','FI','288544886','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:03',0,'2014-03-10 15:45:56'),(20307,20957,'0000-00-00','ET','2',1,NULL,'Iann Robinson','FI','104706202','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:46',0,'2014-03-10 14:37:47'),(19700,20350,'0000-00-00','ET','2',1,NULL,'Wanda Spangler','FI','274568908','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:54:46',0,'2014-03-10 14:37:47'),(19332,19982,'0000-00-00','ET','2',1,NULL,'MARY MALOOLY','FI','462231050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:21',0,'2014-03-02 06:59:07'),(10377,10377,'2014-01-01','ET','2',1,NULL,'Joshua Basinger','FI','295820319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:59',0,'2014-03-01 16:10:36'),(3492,3492,'2014-01-01','ET','2',1,NULL,'Opal Stevens','FI','289582218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:56',0,'2014-03-01 15:37:30'),(15693,16342,'0000-00-00','ET','2',1,NULL,'Dorinda Grizzle','FI','449412337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:00:43',0,'2014-03-02 06:03:21'),(16751,17401,'0000-00-00','ET','2',1,NULL,'Rodolfo Paz','FI','462111581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:10',0,'2014-03-02 06:17:30'),(17608,18258,'0000-00-00','ET','2',1,NULL,'Ninfa Gonzales','FI','458758345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:08',0,'2014-03-02 06:31:45'),(22972,23622,'0000-00-00','ET','2',1,NULL,'Thomas Russell','FI','296562674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:01:31',0,'2014-03-10 21:36:25'),(17388,18038,'0000-00-00','ET','2',1,NULL,'Michele  Stamper','FI','299469371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:34',0,'2014-03-01 17:20:55'),(862,862,'2014-01-01','ET','2',1,NULL,'NORALBA ZAMORA','FI','452613447','Starmount Life Insurance Company','FI','720977315','Manuel  Bernal','94','9916517','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:02',0,'2014-03-01 22:10:55'),(20797,21447,'0000-00-00','ET','2',2,1,'angelica yedra hernandez','FI','642586837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:57',0,'2014-03-02 07:17:36'),(13295,13651,'2014-01-01','ET','2',1,NULL,'gracie gerhart','94','0000295510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:10',0,'2014-03-01 16:40:16'),(18194,18844,'0000-00-00','ET','2',1,NULL,'Cynthia Noethen','FI','289568870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:48',0,'2014-03-01 17:26:36'),(22286,22936,'0000-00-00','ET','2',1,NULL,'Judith Fedor','FI','291488512','HealthSpan','FI','311431434','Cameron   Liljenquist','94','8328382','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:43',0,'2014-03-10 14:45:25'),(12708,12708,'2014-01-01','ET','2',1,NULL,'GERRI F CARDWELL','FI','408151767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:03',0,'2014-03-02 05:10:52'),(22056,22706,'0000-00-00','ET','2',2,1,'Jennifer Scott','FI','297827536','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:32',0,'2014-03-10 14:45:25'),(12013,12013,'2014-01-01','ET','2',1,NULL,'paula r leblanc','FI','433841395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:35',0,'2014-03-02 04:59:36'),(17177,17827,'0000-00-00','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-19','Sync Success',0,'2014-02-04 21:01:52',0,'2014-03-10 14:24:38'),(17632,18282,'0000-00-00','ET','2',1,NULL,'Francesca Cigliola','FI','428710123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:23',0,'2014-03-02 06:31:45'),(17907,18557,'0000-00-00','ET','2',2,1,'VIDAL IBARRA','FI','449857800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:33',0,'2014-03-02 06:31:45'),(22328,22978,'0000-00-00','ET','2',1,NULL,'Teresa Ferguson','FI','286662595','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:30:18',0,'2014-03-06 21:36:23'),(22485,23135,'0000-00-00','ET','2',1,NULL,'JOANNE ARNETT','FI','548334476','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:00',0,'2014-03-07 21:36:32'),(22663,23313,'0000-00-00','ET','2',1,NULL,'Maria Gloria Vasquez','FI','465190469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:30',0,'2014-03-08 22:26:18'),(700,700,'2014-01-01','ET','2',1,NULL,'Hang Ha','FI','586426747','Starmount Life Insurance Company','FI','720977315','Wade  Perrin','94','2183318','348','2014-01-01','Sync Success',0,'2013-12-25 18:06:44',0,'2014-03-02 02:10:49'),(3385,3385,'2014-01-01','ET','2',1,NULL,'Laura Gillis','FI','449968340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:14',0,'2014-03-02 02:10:49'),(4310,4310,'2014-01-01','ET','2',1,NULL,'margaret molden','FI','526216009','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:34',0,'2014-03-02 04:10:25'),(5745,5745,'2014-01-01','ET','2',1,NULL,'DEBORAH SUE TIPPY','FI','428988567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:45',0,'2014-03-02 01:10:33'),(10665,10665,'2014-01-01','ET','2',1,NULL,'Melissa Fisher','FI','451257339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:15',0,'2014-03-02 04:31:46'),(13090,13446,'2014-01-01','ET','2',2,1,'TIMOTHY J WILLIAMS','FI','299787440','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:37',0,'2014-03-01 16:35:14'),(13606,13962,'2014-01-01','ET','2',1,NULL,'JACQUELINE A FIGHTER','FI','302440035','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:29',0,'2014-03-01 16:40:16'),(14604,15055,'2014-01-01','ET','2',1,NULL,'ELVIA  IBARRA JONES','FI','282787545','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:53',0,'2014-03-01 16:46:19'),(14840,15291,'2014-01-01','ET','2',1,NULL,'Sacha Ramirez Francis','FI','277801860','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:47:26',0,'2014-03-10 14:03:26'),(16888,17538,'0000-00-00','ET','2',3,2,'ABBAS PAHLAVAN','FI','456399563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:19',0,'2014-03-02 06:24:38'),(17081,17731,'0000-00-00','ET','2',1,NULL,'Barbara Ortega','FI','572964937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:48',0,'2014-03-02 06:24:38'),(18147,18797,'0000-00-00','ET','2',1,NULL,'AIMEE MEYER','FI','627126002','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:13',0,'2014-03-02 06:38:05'),(18217,18867,'0000-00-00','ET','2',1,NULL,'Brent Flickinger','FI','287725851','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:07',0,'2014-03-10 16:31:33'),(19086,19736,'0000-00-00','ET','2',1,NULL,'Gabrielle Best','94','0001168047','Dental Care Plus, Inc.','FI','311185262','Thomas  Theobald','94','1491614','348','2014-03-01','Sync Success',0,'2014-02-15 22:00:34',0,'2014-03-01 17:34:07'),(19904,20554,'0000-00-00','ET','2',1,NULL,'regina martin','FI','271582471','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:07',0,'2014-03-01 17:47:19'),(20063,20713,'0000-00-00','ET','2',1,NULL,'Holly Baker','FI','283663804','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-04-01','Sync Success',0,'2014-02-25 21:00:20',0,'2014-03-10 14:37:47'),(22911,23561,'0000-00-00','ET','2',1,NULL,'Amelia Giblin','FI','333569694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:49',0,'2014-03-10 21:27:11'),(15,15,'2014-01-01','ET','2',1,NULL,'Linda Moran','FI','290469504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:29',0,'2014-03-01 15:21:15'),(12546,12546,'2014-01-01','ET','2',1,NULL,'Stephanee Hart','FI','279940802','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:06',0,'2014-03-10 13:59:38'),(2522,2522,'2014-01-01','ET','2',1,NULL,'Oscar Bernache','FI','525812290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:43',0,'2014-03-01 20:10:57'),(11927,11927,'2014-01-01','ET','2',1,NULL,'Jessy Zbeidy','FI','276112542','HealthSpan','FI','311431434','Mike  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2013-12-30 00:01:52',0,'2014-03-10 13:52:32'),(11218,11218,'2014-01-01','ET','2',3,2,'Dionne Pope','FI','268764214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:00',0,'2014-03-01 16:23:43'),(3410,3410,'2014-01-01','ET','2',3,2,'Ricky Halker','FI','296645377','HealthSpan','FI','311431434','John A Guagenti','94','7990234','348','2014-01-01','Sync Success',0,'2013-12-25 21:52:01',0,'2014-03-10 13:32:15'),(10412,10412,'2014-01-01','ET','2',1,NULL,'Elihudi Robson','FI','288131590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:51:06',0,'2014-03-01 16:10:36'),(3889,3889,'2014-01-01','ET','2',1,NULL,'samuel logan','FI','277584401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:51',0,'2014-03-01 15:05:09'),(5142,5142,'2014-01-01','ET','2',1,NULL,'Brenda Hallam','FI','277621914','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:35',0,'2014-03-10 15:45:56'),(5139,5139,'2014-01-01','ET','2',1,NULL,'Dana Sue McCarty','FI','294560332','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:29',0,'2014-03-10 15:45:56'),(4220,4220,'2014-01-01','ET','2',1,NULL,'Danny Hizer','FI','302741736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:50',0,'2014-03-01 15:52:44'),(4825,4825,'2014-01-01','ET','2',1,NULL,'Stephone Hilliard','FI','279605450','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:38',0,'2014-03-10 15:39:19'),(4290,4290,'2014-01-01','ET','2',1,NULL,'Tom P Robinson','FI','290423048','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:01',0,'2014-03-10 13:32:15'),(13271,13627,'2014-01-01','ET','2',1,NULL,'Amanda Dailey','FI','441948441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:01',0,'2014-03-02 05:24:45'),(13501,13857,'2014-01-01','ET','2',1,NULL,'susan peralez','FI','451277649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:17',0,'2014-03-02 05:31:31'),(15088,15539,'0000-00-00','ET','2',1,NULL,'Kyle McKenzie','FI','364668496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:41',0,'2014-03-01 16:50:53'),(19314,19964,'0000-00-00','ET','2',1,NULL,'REMEGIO LIBARDO','FI','843541284','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:07',0,'2014-03-02 06:59:07'),(20499,21149,'0000-00-00','ET','2',1,NULL,'Phung Dien','FI','244732883','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:43',0,'2014-03-02 07:10:28'),(22550,23200,'0000-00-00','ET','2',1,NULL,'Florine Mcqueen','FI','427048405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:46',0,'2014-03-07 22:26:59'),(652,652,'2014-01-01','ET','2',1,NULL,'Princesa Alexander','FI','449021116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:05:17',0,'2014-03-02 02:10:49'),(12755,12755,'2014-01-01','ET','2',2,1,'June Ousley','FI','273568683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:54',0,'2014-03-10 13:59:38'),(706,706,'2014-01-01','ET','2',1,NULL,'KATHY L BREWER','FI','295666221','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:55',0,'2014-03-10 15:52:36'),(11716,11716,'2014-01-01','ET','2',1,NULL,'Priestly Creswell','FI','428613415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:24',0,'2014-03-02 04:59:36'),(10428,10428,'2014-01-01','ET','2',1,NULL,'Deborah Klemencic','FI','289727552','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:33',0,'2014-03-01 16:10:36'),(909,909,'2014-01-01','ET','2',1,NULL,'Donna Brown-Straits','FI','296487784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:22',0,'2014-03-01 15:21:15'),(962,962,'2014-01-01','ET','2',2,1,'Deborah Saucier','FI','438471475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:01',0,'2014-03-01 22:10:55'),(2144,2144,'2014-01-01','ET','2',2,1,'Connie Mae Fulkner','FI','272689408','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:18',0,'2014-03-01 15:16:37'),(5178,5178,'2014-01-01','ET','2',1,NULL,'Racheal Witt','FI','465814668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:38',0,'2014-03-02 00:10:48'),(4438,4438,'2014-01-01','ET','2',1,NULL,'Larry Watkins','FI','435985357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:19',0,'2014-03-01 19:11:03'),(3830,3830,'2014-01-01','ET','2',1,NULL,'Abbey Dewey','FI','274883802','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:27',0,'2014-03-10 13:20:27'),(3709,3709,'2014-01-01','ET','2',1,NULL,'KEITH PAIGE','FI','439312705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:49',0,'2014-03-02 01:10:33'),(13973,14329,'2014-01-01','ET','2',1,NULL,'Stephanie Adams','FI','464396079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:10',0,'2014-03-02 05:31:31'),(16437,17087,'0000-00-00','ET','2',1,NULL,'Tesia Ferrell','FI','301844922','HealthSpan','FI','311431434','Gary  Nelson','94','2346444','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:50',0,'2014-03-10 14:20:26'),(16690,17340,'0000-00-00','ET','2',1,NULL,'Linda Taylor','FI','282743545','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:10',0,'2014-03-10 14:20:26'),(16844,17494,'0000-00-00','ET','2',2,1,'Courtney L Bruder','FI','634098590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:20',0,'2014-03-02 06:17:30'),(18747,19397,'0000-00-00','ET','2',1,NULL,'BRITTANY COBBS','FI','638143000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:28',0,'2014-03-02 06:45:14'),(19763,20413,'0000-00-00','ET','2',1,NULL,'stacy hathcox','FI','428115613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:15',0,'2014-03-02 07:03:25'),(20101,20751,'0000-00-00','ET','2',1,NULL,'Alfred Weber','FI','436965384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:20',0,'2014-03-02 07:10:28'),(20353,21003,'0000-00-00','ET','2',1,NULL,'Heather Burchett','FI','276728674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:40',0,'2014-03-01 17:47:19'),(20928,21578,'0000-00-00','ET','2',1,NULL,'Baylor Looper Jewell','FI','435907159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:19',0,'2014-03-02 07:17:36'),(21202,21852,'0000-00-00','ET','2',1,NULL,'victor harrison','FI','449088498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-01 19:00:04',0,'2014-03-02 07:23:39'),(21770,22420,'0000-00-00','ET','2',1,NULL,'Clayton Randolph','FI','280629828','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:38',0,'2014-03-10 14:45:25'),(212,212,'2014-01-01','ET','2',1,NULL,'Hugh Aaron Ambeau','FI','436069447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:40',0,'2014-03-01 22:10:55'),(469,469,'2014-01-01','ET','2',3,2,'Katherine Wagner','FI','274743766','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:38',0,'2014-03-10 13:10:24'),(1333,1333,'2014-01-01','ET','2',1,NULL,'Deborah Diann Couey','FI','458943442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:53',0,'2014-03-02 04:38:08'),(10548,10548,'2014-01-01','ET','2',2,1,'Ik Kang','94','0000856983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:29',0,'2014-03-02 04:15:49'),(1439,1439,'2014-01-01','ET','2',1,NULL,'Ryan Zymler','FI','276926156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:20',0,'2014-03-01 16:15:39'),(2141,2141,'2014-01-01','ET','2',1,NULL,'Jeffrey Toth','FI','269783194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:46:11',0,'2014-03-01 15:16:37'),(5278,5278,'2014-01-01','ET','2',1,NULL,'Gerald Fulton','FI','287767052','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:41',0,'2014-03-01 15:10:22'),(7196,7196,'2014-01-01','ET','2',1,NULL,'MARIA  DE  VE LOS ANGELES CALZADA','FI','622993068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:30',0,'2014-03-02 03:09:49'),(3772,3772,'2014-01-01','ET','2',1,NULL,'Rebecca Cox','FI','462212279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:24',0,'2014-03-01 23:10:52'),(4386,4386,'2014-01-01','ET','2',1,NULL,'allan lantz','FI','269964380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:33',0,'2014-03-01 15:16:37'),(4955,4955,'2014-01-01','ET','2',1,NULL,'shannon ducote','FI','564758179','Starmount Life Insurance Company','FI','720977315','Amie N McLaughlin','94','4717745','348','2014-01-01','Sync Success',0,'2013-12-26 00:32:01',0,'2014-03-01 20:10:57'),(4725,4725,'2014-01-01','ET','2',1,NULL,'Courtney McCraney','FI','427471740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:33',0,'2014-03-02 04:31:46'),(14504,14955,'2014-01-01','ET','2',1,NULL,'Steve Young','FI','294704814','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:54',0,'2014-03-10 14:03:26'),(14691,15142,'2014-01-01','ET','2',1,NULL,'BRENDA J CARTER','FI','439259688','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:49',0,'2014-03-02 05:45:37'),(21468,22118,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:34',0,'2014-03-03 21:36:16'),(21952,22602,'0000-00-00','ET','2',2,1,'ONESIA WARD','FI','439773334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:19',0,'2014-03-05 22:27:33'),(22906,23556,'0000-00-00','ET','2',1,NULL,'Michael Reinauer','FI','437233607','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:45',0,'2014-03-10 21:27:11'),(13,13,'2014-01-01','ET','2',1,NULL,'JEFFERY FROMAN','FI','292629971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:25',0,'2014-03-01 15:21:15'),(397,397,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:48:18',0,'2014-03-01 22:10:55'),(11476,11476,'2014-01-01','ET','2',1,NULL,'BRENDA STEVENSON','FI','412864045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:56',0,'2014-03-01 16:30:17'),(1157,1157,'2014-01-01','ET','2',1,NULL,'Cinuray Rancifer','FI','435214599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:46:25',0,'2014-03-02 04:38:08'),(7694,7694,'2014-01-01','ET','2',1,NULL,'Kathleen Mary Weirick','FI','298487518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:14',0,'2014-03-01 15:10:22'),(6093,6093,'2014-01-01','ET','2',1,NULL,'Patricia Wood','FI','282489071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:07',0,'2014-03-01 16:00:27'),(6067,6067,'2014-01-01','ET','2',1,NULL,'Joshua Blanton','FI','315116761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:17',0,'2014-03-02 04:10:25'),(1498,1498,'2014-01-01','ET','2',1,NULL,'James Michael RAND','FI','285543584','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:20',0,'2014-03-10 13:52:32'),(2274,2274,'2014-01-01','ET','2',1,NULL,'Kris Sumantri','FI','633803624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:18',0,'2014-03-01 21:11:04'),(2667,2667,'2014-01-01','ET','2',4,3,'Ann Riegler','FI','298885594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:06',0,'2014-03-01 16:05:34'),(4141,4141,'2014-01-01','ET','2',2,1,'James R Currence','FI','296443390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:25',0,'2014-03-01 16:00:27'),(14878,15329,'2014-01-01','ET','2',1,NULL,'ROSA VARGAS','FI','372568585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:14',0,'2014-03-02 05:52:31'),(16327,16977,'0000-00-00','ET','2',1,NULL,'Richard L Shepard','FI','426176081','Starmount Life Insurance Company','FI','720977315','Revonno  Burt','94','6401285','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:40',0,'2014-03-02 06:10:30'),(17080,17730,'0000-00-00','ET','2',1,NULL,'Jose Chavira','FI','459431167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:48',0,'2014-03-02 06:24:38'),(17185,17835,'0000-00-00','ET','2',1,NULL,'Natasha Underwood','FI','574981806','HealthSpan','FI','311431434','James Ray Hill Jr','94','2306665','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:57',0,'2014-03-10 14:24:38'),(17215,17865,'0000-00-00','ET','2',1,NULL,'Darnell  Hurdle','FI','271682041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:13',0,'2014-03-01 17:20:55'),(19924,20574,'0000-00-00','ET','2',1,NULL,'Robert Lantz','FI','090547898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:19',0,'2014-03-01 17:47:19'),(21989,22639,'0000-00-00','ET','2',1,NULL,'TRACY MERVINE','FI','279629226','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:45',0,'2014-03-10 16:44:18'),(22129,22779,'0000-00-00','ET','2',1,NULL,'JORGE PORRUA','FI','435873360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:50',0,'2014-03-06 21:27:26'),(453,453,'2014-01-01','ET','2',2,1,'Donald  M  Halcomb','FI','463158396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:03',0,'2014-03-01 22:10:55'),(12853,12853,'2014-01-01','ET','2',2,1,'Jennifer Waterman','FI','286929900','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:10',0,'2014-03-01 16:35:14'),(12232,12232,'2014-01-01','ET','2',1,NULL,'Letha Major Batiste','FI','439352589','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',1,'2014-01-02 04:22:44',0,'2014-03-02 05:03:29'),(11535,11535,'2014-01-01','ET','2',1,NULL,'Charlotte Bright','FI','434254403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:32:41',0,'2014-03-02 04:52:44'),(10367,10367,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:42',0,'2014-03-01 16:05:34'),(3170,3170,'2014-01-01','ET','2',4,3,'Agnar Visvalbs Cickovskis','FI','106463312','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:28',0,'2014-03-10 15:52:36'),(4167,4167,'2014-01-01','ET','2',1,NULL,'Ronald Thomas','FI','270504177','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:10',0,'2014-03-10 15:59:47'),(4909,4909,'2014-01-01','ET','2',1,NULL,'Melissa Stanley','FI','454735559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:27',0,'2014-03-01 19:11:03'),(14399,14850,'2014-01-01','ET','2',3,2,'Tonya Andrews','FI','270789489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:06',0,'2014-03-01 16:46:19'),(15378,15829,'0000-00-00','ET','2',1,NULL,'Melodie Dunn','FI','439047168','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-03-01','Sync Success',1,'2014-01-22 03:21:55',0,'2014-03-02 05:59:43'),(15496,15947,'0000-00-00','ET','2',1,NULL,'Roy May','FI','281728001','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:12',0,'2014-03-10 14:10:12'),(15529,15980,'0000-00-00','ET','2',1,NULL,'Carol Ann Odum','FI','460884211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:04',0,'2014-03-02 05:59:43'),(16392,17042,'0000-00-00','ET','2',2,1,'Chad Doberson','FI','449657937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:21',0,'2014-03-02 06:10:30'),(17794,18444,'0000-00-00','ET','2',1,NULL,'Robin Sonstegard','FI','280600189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:28',0,'2014-03-10 14:20:26'),(20537,21187,'0000-00-00','ET','2',1,NULL,'BETTY MAYFIELD','FI','455840582','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:08',0,'2014-03-02 07:10:28'),(21087,21737,'0000-00-00','ET','2',1,NULL,'Vincent Mele','FI','153787891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:38',0,'2014-03-02 07:17:36'),(21459,22109,'0000-00-00','ET','2',1,NULL,'Jeremy Hasenbalg','FI','300929460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:27',0,'2014-03-03 21:36:16'),(22253,22903,'0000-00-00','ET','2',1,NULL,'Noreen Smith','FI','300506554','HealthSpan','FI','311431434','Shaun  Hunsaker','94','16201100','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:18',0,'2014-03-10 14:45:25'),(581,581,'2014-01-01','ET','2',1,NULL,'Kathryn Leigh Nathan','FI','433742127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:59',0,'2014-03-02 02:10:49'),(2475,2475,'2014-01-01','ET','2',1,NULL,'Janet Lee Jaeger','FI','281589138','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:41',0,'2014-03-10 13:10:24'),(2967,2967,'2014-01-01','ET','2',2,1,'Stephen Piesciuk','FI','066469661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:07',0,'2014-03-01 15:37:30'),(5764,5764,'2014-01-01','ET','2',1,NULL,'Thom Truong','FI','225775512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:21',0,'2014-03-02 01:10:33'),(5006,5006,'2014-01-01','ET','2',1,NULL,'AMY VANLANDINGHAM','FI','290743095','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:09',0,'2014-03-01 15:31:33'),(14286,14737,'2014-01-01','ET','2',1,NULL,'Candace Moxley','FI','297545870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:18',0,'2014-03-01 16:46:19'),(15098,15549,'0000-00-00','ET','2',1,NULL,'SHANDRA  C KELLY','FI','657288233','Starmount Life Insurance Company','FI','720977315','KEITH  PEDESCLEAUX','94','17101561','348','2014-03-01','Sync Success',0,'2014-01-20 08:05:47',0,'2014-03-02 05:52:31'),(15387,15838,'0000-00-00','ET','2',1,NULL,'DONALD RAY ENGLISH','FI','439046020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:01',0,'2014-03-02 05:59:43'),(15472,15923,'0000-00-00','ET','2',1,NULL,'Jerry Hosler','FI','274524941','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:55',0,'2014-03-10 14:10:12'),(21423,22073,'0000-00-00','ET','2',2,1,'Miriam Smith','FI','282583910','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:26',0,'2014-03-10 14:45:25'),(21572,22222,'0000-00-00','ET','2',2,1,'Terry A Malone','FI','274447537','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:49',0,'2014-03-10 14:45:25'),(21985,22635,'0000-00-00','ET','2',1,NULL,'Kellee Wright','FI','288829205','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:31:43',0,'2014-03-10 16:44:18'),(22543,23193,'0000-00-00','ET','2',1,NULL,'ABDELKARIM GOUDA','FI','714857781','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:41',0,'2014-03-07 21:36:32'),(22803,23453,'0000-00-00','ET','2',1,NULL,'LAURA HENSON','FI','278547952','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:54',0,'2014-03-10 16:44:18'),(22938,23588,'0000-00-00','ET','2',1,NULL,'MARIA HEAVNER','FI','297821656','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:09',0,'2014-03-10 21:07:22'),(19081,19731,'0000-00-00','ET','2',1,NULL,'Kevin Ross','FI','164420843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:30',0,'2014-03-01 17:34:07'),(19808,20458,'0000-00-00','ET','2',1,NULL,'BILLIE IVY','FI','445520402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:30',0,'2014-03-02 07:03:25'),(806,806,'2014-01-01','ET','2',3,2,'Joshua Scalia','FI','411336997','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:24',0,'2014-03-10 15:39:19'),(12239,12239,'2014-01-01','ET','2',1,NULL,'Brandon Leonard','FI','433757637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:00',0,'2014-03-02 05:10:52'),(10931,10931,'2014-01-01','ET','2',1,NULL,'ERICKA HAWKINS','FI','278701090','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:40',0,'2014-03-10 16:03:49'),(1059,1059,'2014-01-01','ET','2',1,NULL,'James Boyd Loveall','FI','300681883','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:33',0,'2014-03-01 15:16:37'),(1272,1272,'2014-01-01','ET','2',1,NULL,'Kimberly Vonhedemann','FI','290586023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:54',0,'2014-03-01 16:23:43'),(7134,7134,'2014-01-01','ET','2',1,NULL,'Jared Rammel','FI','286885633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:35',0,'2014-03-01 15:52:44'),(2660,2660,'2014-01-01','ET','2',4,3,'Christian Manansala','FI','667222742','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:47',0,'2014-03-01 16:05:34'),(5773,5773,'2014-01-01','ET','2',1,NULL,'Richard Hallett','FI','496521137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:02:39',0,'2014-03-02 01:10:33'),(4639,4639,'2014-01-01','ET','2',1,NULL,'jamie regian','FI','641093982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:32',0,'2014-03-02 04:31:46'),(2997,2997,'2014-01-01','ET','2',1,NULL,'TIFFANY HALEY','FI','459414745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:02',0,'2014-03-02 01:10:33'),(3241,3241,'2014-01-01','ET','2',1,NULL,'SHIRLEY DAVIS-BAILEY','FI','281485390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:35',0,'2014-03-01 15:52:44'),(3488,3488,'2014-01-01','ET','2',1,NULL,'Emily Runions','FI','299887600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:47',0,'2014-03-01 15:37:30'),(13314,13670,'2014-01-01','ET','2',1,NULL,'elizabeth stauter','FI','302886617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:17',0,'2014-03-01 16:40:16'),(15468,15919,'0000-00-00','ET','2',1,NULL,'ELIZABETH PALL','FI','049564548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:53',0,'2014-03-01 16:50:53'),(16516,17166,'0000-00-00','ET','2',1,NULL,'SEVILLE GREENFIELD','FI','427311465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:48',0,'2014-03-02 06:10:30'),(17031,17681,'0000-00-00','ET','2',1,NULL,'FRANK MITCHELL','FI','436021439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:18',0,'2014-03-02 06:24:38'),(18336,18986,'0000-00-00','ET','2',3,2,'Mark Watkins','FI','292581113','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:17',0,'2014-03-01 17:26:36'),(19276,19926,'0000-00-00','ET','2',1,NULL,'Mark Bamberger','FI','281601575','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:17',0,'2014-03-10 14:31:05'),(19297,19947,'0000-00-00','ET','2',1,NULL,'TAMARA TRAPNELL','FI','301549318','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:16',0,'2014-03-10 14:37:47'),(19684,20334,'0000-00-00','ET','2',1,NULL,'michael wilson','FI','243734736','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:51:47',0,'2014-03-10 14:37:47'),(20241,20891,'0000-00-00','ET','2',1,NULL,'Roberta Humphries','FI','288807003','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:02',0,'2014-03-10 14:37:47'),(20606,21256,'0000-00-00','ET','2',1,NULL,'Desirae Thompson','FI','281842009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 21:01:52',0,'2014-03-01 18:08:07'),(1183,1183,'2014-01-01','ET','2',1,NULL,'Ryan Landrieu','FI','433551419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:14',0,'2014-03-02 04:38:08'),(12745,12745,'2014-01-01','ET','2',1,NULL,'Lynnta Peralez','FI','459084406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:30',0,'2014-03-02 05:10:52'),(12057,12057,'2014-01-01','ET','2',1,NULL,'Marjorie Correa','FI','466902810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:15',0,'2014-03-02 04:59:36'),(11806,11806,'2014-01-01','ET','2',1,NULL,'AMY ELIZABETH FLECK','FI','268644674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:16',0,'2014-03-01 16:15:39'),(1266,1266,'2014-01-01','ET','2',2,1,'Kerri  Derecskey','FI','268865407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:41',0,'2014-03-01 16:23:43'),(10644,10644,'2014-01-01','ET','2',1,NULL,'Cameron Holmes','FI','319784643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:37',0,'2014-03-02 04:31:46'),(1635,1635,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:02:04',0,'2014-03-01 20:10:57'),(2327,2327,'2014-01-01','ET','2',1,0,'Courtney Withers','FI','316043141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:11',0,'2014-03-01 19:11:03'),(6317,6317,'2014-01-01','ET','2',1,NULL,'Richard Nowak','FI','300448827','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:54',0,'2014-03-10 15:59:47'),(6307,6307,'2014-01-01','ET','2',2,1,'Kingsley Akiti','FI','428556495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:36',0,'2014-03-02 04:10:25'),(4350,4350,'2014-01-01','ET','2',1,NULL,'Bonnie Brown','FI','278643030','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:10:47',0,'2014-03-10 13:32:15'),(5617,5617,'2014-01-01','ET','2',2,1,'Stacey Skaggs','FI','289860737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:50:15',0,'2014-03-01 16:23:43'),(15497,15948,'0000-00-00','ET','2',1,NULL,'SHAMECA JACKSON','FI','345827395','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:49',0,'2014-03-01 16:50:53'),(15592,16043,'0000-00-00','ET','2',1,NULL,'BRENDA ANN WILLIS','FI','439866362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:32',0,'2014-03-02 05:59:43'),(15610,16061,'0000-00-00','ET','2',1,NULL,'John O\'Neil','94','0001306121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:41',0,'2014-03-02 05:59:43'),(17103,17753,'0000-00-00','ET','2',1,NULL,'joan reiss','FI','268563080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:02',0,'2014-03-01 17:00:58'),(17384,18034,'0000-00-00','ET','2',1,NULL,'Gregory Marinelli','FI','298566041','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:31',0,'2014-03-01 17:20:55'),(17898,18548,'0000-00-00','ET','2',2,1,'MANUEL MONTERROSO','FI','434572536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:28',0,'2014-03-02 06:38:05'),(19198,19848,'0000-00-00','ET','2',4,3,'Lynn Hamrich','FI','300828963','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:04',0,'2014-03-10 16:31:33'),(19442,20092,'0000-00-00','ET','2',1,NULL,'sharell wilson','FI','279863035','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:40',0,'2014-03-10 14:37:47'),(19780,20430,'0000-00-00','ET','2',1,NULL,'RC Anderson','FI','427048956','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:06',0,'2014-03-02 07:03:25'),(20546,21196,'0000-00-00','ET','2',1,NULL,'ERIC HARMON','FI','633240799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:14',0,'2014-03-02 07:17:36'),(21507,22157,'0000-00-00','ET','2',1,NULL,'Long Nguyen','FI','629927040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:31:00',0,'2014-03-03 22:26:43'),(21550,22200,'0000-00-00','ET','2',1,NULL,'Schelerria Jackson','FI','427691495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:32',0,'2014-03-03 22:26:43'),(22432,23082,'0000-00-00','ET','2',2,1,'Rogelio R Banda','FI','593744785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:23',0,'2014-03-07 22:26:59'),(23053,23703,'0000-00-00','ET','2',1,NULL,'Gloria Williams','FI','587347423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:29',0,'2014-03-10 21:27:11'),(287,287,'2014-01-01','ET','2',1,NULL,'dolly debord','FI','301549113','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:14',0,'2014-03-01 15:10:22'),(12908,12908,'2014-01-01','ET','2',1,NULL,'Mona Seals','FI','587394451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:11',0,'2014-03-02 05:17:40'),(11099,11099,'2014-01-01','ET','2',2,1,'Roland Rayman','FI','287425736','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:04',0,'2014-03-10 13:39:10'),(10507,10507,'2014-01-01','ET','2',1,NULL,'Cathie Westcott','FI','270440238','Dental Care Plus, Inc.','FI','311185262','Jeffrey  Westcott','94','2263645','348','2014-01-01','Sync Success',0,'2013-12-26 12:54:05',0,'2014-03-01 16:15:39'),(457,457,'2014-01-01','ET','2',2,1,'FELIPE MOLINA','FI','433439522','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:11',0,'2014-03-01 22:10:55'),(3245,3245,'2014-01-01','ET','2',1,NULL,'nancy marie cravin/jado','FI','332583155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:42',0,'2014-03-01 15:52:44'),(6149,6149,'2014-01-01','ET','2',4,3,'Bomsik Lee','94','0000045757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:48',0,'2014-03-01 16:05:34'),(4099,4099,'2014-01-01','ET','2',1,NULL,'DREW  DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:13',0,'2014-03-01 16:00:27'),(4507,4507,'2014-01-01','ET','2',1,NULL,'Barbara Carter','FI','292427425','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 23:32:17',0,'2014-03-10 13:03:33'),(15040,15491,'2014-01-01','ET','2',1,NULL,'Floyd Espree','FI','439458415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:27',0,'2014-03-02 05:52:31'),(16451,17101,'0000-00-00','ET','2',1,NULL,'Tad Phipps','FI','297761178','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:07',0,'2014-03-01 17:00:58'),(17820,18470,'0000-00-00','ET','2',1,NULL,'LeeAnna Stevens','FI','451026975','Starmount Life Insurance Company','FI','720977315','Daniel  Abrams','94','2717565','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:52',0,'2014-03-02 05:59:43'),(18268,18918,'0000-00-00','ET','2',2,1,'Rae Wilson','FI','295865039','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:52',0,'2014-03-10 14:24:38'),(19098,19748,'0000-00-00','ET','2',1,NULL,'KRISTEN BLUST','FI','290906381','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:42',0,'2014-03-01 17:34:07'),(21357,22007,'0000-00-00','ET','2',1,NULL,'Teresa Schweitzer','FI','272606391','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:27',0,'2014-03-10 14:45:25'),(23074,23724,'0000-00-00','ET','2',1,NULL,'Nancy Carlier-Smyth','FI','296461763','HealthSpan','FI','311431434','Judy  Steelman','94','2342096','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:47',0,'2014-03-10 21:17:52'),(2173,2173,'2014-01-01','ET','2',1,NULL,'Todd Tinker','FI','279648279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:16',0,'2014-03-01 15:16:37'),(2203,2203,'2014-01-01','ET','2',1,NULL,'Judith Y Geystan','FI','434634423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:17',0,'2014-03-01 21:11:04'),(2282,2282,'2014-01-01','ET','2',1,NULL,'Timothy Congrove','FI','279924806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:34',0,'2014-03-01 15:10:22'),(2377,2377,'2014-01-01','ET','2',1,NULL,'ZEWDITU KASSA','FI','449597958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:33',0,'2014-03-01 23:10:52'),(3093,3093,'2014-01-01','ET','2',1,NULL,'Seth Dunlap','FI','439758120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:59',0,'2014-03-02 01:10:33'),(10489,10489,'2014-01-01','ET','2',1,NULL,'BERNITA BIRL','FI','287561027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:32',0,'2014-03-01 16:10:36'),(14859,15310,'2014-01-01','ET','2',1,NULL,'Lamphan Oudomvialy','FI','643130424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:06',0,'2014-03-02 05:45:37'),(21244,21894,'0000-00-00','ET','2',2,1,'NAZEK ALLAN','FI','068609305','Dental Care Plus, Inc.','FI','311185262','BRUCE  WESTLAKE','94','2761466','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:26',0,'2014-03-01 21:35:40'),(22205,22855,'0000-00-00','ET','2',1,NULL,'James McAlpin','FI','407112994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:43',0,'2014-03-06 21:36:23'),(1430,1430,'2014-01-01','ET','2',4,3,'David Handley','FI','302647180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:03',0,'2014-03-01 16:15:39'),(12032,12032,'2014-01-01','ET','2',2,1,'MARCUS W BRUNO','FI','439115743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:18',0,'2014-03-02 04:59:36'),(2046,2046,'2014-01-01','ET','2',1,NULL,'KHADIJAH RAFHEED','FI','290547953','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:18',0,'2014-03-10 13:20:27'),(7609,7609,'2014-01-01','ET','2',1,NULL,'robert lucius benedict','FI','275423686','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:33',0,'2014-03-10 15:59:47'),(7455,7455,'2014-01-01','ET','2',1,NULL,'Wayne Anthony Skoog','FI','465474003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:31',0,'2014-03-02 04:10:25'),(4161,4161,'2014-01-01','ET','2',2,1,'NORMAN D KVETENSKY','FI','297504466','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:01',0,'2014-03-10 15:59:47'),(3006,3006,'2014-01-01','ET','2',1,NULL,'KOREN WELLS','FI','008389695','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:18',0,'2014-03-10 15:52:36'),(14753,15204,'2014-01-01','ET','2',1,NULL,'Guadalupe Rodriguez','FI','274024690','Summa Insurance Company, Inc.','FI','341809108','Kurt  Jarcik','94','4564074','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:27',0,'2014-03-10 16:17:47'),(15386,15837,'0000-00-00','ET','2',1,NULL,'MARY ENGLISH','FI','439191089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:01',0,'2014-03-02 05:59:43'),(15396,15847,'0000-00-00','ET','2',1,NULL,'Phan Chiem','FI','637085306','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:07',0,'2014-03-02 05:59:43'),(647,647,'2014-01-01','ET','2',1,NULL,'Scott M Leavell','FI','372884837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:09',0,'2014-03-02 02:10:49'),(13370,13726,'2014-01-01','ET','2',2,1,'EMILY WILLIAMS','FI','462811858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:40',0,'2014-03-02 05:24:45'),(10778,10778,'2014-01-01','ET','2',2,1,'TANYA MARIA DAVIS-CURRY','FI','496707585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:10',0,'2014-03-02 04:24:47'),(1340,1340,'2014-01-01','ET','2',1,NULL,'brenda v sandoval','FI','518805382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:04',0,'2014-03-02 04:38:08'),(10528,10528,'2014-01-01','ET','2',1,NULL,'Patricia Duff','FI','353469632','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:46',0,'2014-03-02 04:24:47'),(12818,12818,'2014-01-01','ET','2',1,NULL,'James Garner','FI','434702284','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:55',0,'2014-03-02 05:10:52'),(11694,11694,'2014-01-01','ET','2',1,NULL,'Nixon Williams','FI','437713695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:44',0,'2014-03-02 04:59:36'),(11427,11427,'2014-01-01','ET','2',1,NULL,'Latricia Elliott','FI','298709485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:25',0,'2014-03-10 13:52:32'),(16393,17043,'0000-00-00','ET','2',1,NULL,'alvin whitaker','FI','509869848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:22',0,'2014-03-02 06:10:30'),(17890,18540,'0000-00-00','ET','2',1,NULL,'Graham White','FI','212213681','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:22',0,'2014-03-02 06:31:45'),(18204,18854,'0000-00-00','ET','2',2,1,'MANPREET KOHLI','FI','142043103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:56',0,'2014-03-01 17:26:36'),(18557,19207,'0000-00-00','ET','2',2,1,'Cleona Torres','FI','433772626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:15',0,'2014-03-02 06:45:14'),(19012,19662,'0000-00-00','ET','2',1,NULL,'LAURA MEYER','FI','285500034','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:23',0,'2014-03-10 14:31:05'),(20013,20663,'0000-00-00','ET','2',1,NULL,'william wagoner','FI','301563285','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:02',0,'2014-03-10 16:38:05'),(21854,22504,'0000-00-00','ET','2',1,NULL,'MICHAEL A BOYLE','FI','269601232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:09',0,'2014-03-05 21:36:22'),(22239,22889,'0000-00-00','ET','2',2,1,'ROBERT DUBOIS','FI','134628918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:08',0,'2014-03-06 21:27:26'),(29,29,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:15:53',0,'2014-03-01 15:21:15'),(195,195,'2014-01-01','ET','2',4,3,'jeanne reiser','FI','272509651','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:03',0,'2014-03-10 13:10:24'),(10438,10438,'2014-01-01','ET','2',1,NULL,'Denise Gettelfinger','FI','405901029','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:54',0,'2014-03-01 16:10:36'),(471,471,'2014-01-01','ET','2',1,NULL,'Anne Sketch','FI','290460421','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 17:50:43',0,'2014-03-10 13:10:24'),(1778,1778,'2014-01-01','ET','2',1,NULL,'debra harmony','FI','293787328','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:53',0,'2014-03-10 15:45:56'),(12079,12079,'2014-01-01','ET','2',1,NULL,'Ruth Lingafelter','FI','287588571','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:59',0,'2014-03-01 16:30:17'),(12010,12010,'2014-01-01','ET','2',1,NULL,'andre forbes','FI','303784692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:30',0,'2014-03-02 04:59:36'),(11819,11819,'2014-01-01','ET','2',2,1,'Michael Homan','FI','289647821','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:42',0,'2014-03-01 16:15:39'),(1815,1815,'2014-01-01','ET','2',1,NULL,'melvin w phipps','FI','279708293','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:06',0,'2014-03-10 13:20:27'),(11196,11196,'2014-01-01','ET','2',1,NULL,'Latonya Reese','FI','293741167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:19',0,'2014-03-01 16:23:43'),(7164,7164,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000120057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:31',0,'2014-03-10 15:59:47'),(2482,2482,'2014-01-01','ET','2',1,NULL,'Gary E Saunders','FI','126740343','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:55',0,'2014-03-10 13:10:24'),(5808,5808,'2014-01-01','ET','2',5,4,'Richard Aaron Maus','FI','291862249','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:48',0,'2014-03-10 13:24:34'),(3098,3098,'2014-01-01','ET','2',1,NULL,'BARBARA LINDE','FI','439920749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:36:09',0,'2014-03-02 01:10:33'),(12490,12490,'2014-01-01','ET','2',3,2,'Bobby  Ross','FI','434822561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:57',0,'2014-03-02 05:03:29'),(12799,12799,'2014-01-01','ET','2',1,NULL,'Michael Escareno','FI','461671889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:14',0,'2014-03-02 05:10:52'),(12924,12924,'2014-01-01','ET','2',1,NULL,'REBECCA L COSTILOW','FI','272648406','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:50',0,'2014-03-10 16:10:34'),(14621,15072,'2014-01-01','ET','2',1,NULL,'Barbara Fahnle','FI','402646505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:03',0,'2014-03-01 16:46:19'),(14944,15395,'2014-01-01','ET','2',1,NULL,'David Mirelez','FI','450158425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:45',0,'2014-03-02 05:45:37'),(15177,15628,'0000-00-00','ET','2',1,NULL,'TERRY NEWCOMB','FI','271523134','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:47',0,'2014-03-10 14:10:12'),(15909,16558,'0000-00-00','ET','2',1,NULL,'Nicholas Malloy','FI','299902808','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:01:18',0,'2014-03-10 14:10:12'),(16197,16846,'0000-00-00','ET','2',1,NULL,'Erica Maurin','FI','439615055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:36',0,'2014-03-02 06:10:30'),(16308,16958,'0000-00-00','ET','2',2,1,'Barbara Colbow','FI','284528350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:28',0,'2014-03-01 16:56:22'),(16331,16981,'0000-00-00','ET','2',1,NULL,'DIETRICH CLAUSELL','FI','425572272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:43',0,'2014-03-02 06:10:30'),(16882,17532,'0000-00-00','ET','2',1,NULL,'SHARON HARMON','FI','248292529','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:16',0,'2014-03-02 06:17:30'),(16999,17649,'0000-00-00','ET','2',1,NULL,'Ella Bennings','FI','456865763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:29',0,'2014-03-02 06:24:38'),(17441,18091,'0000-00-00','ET','2',1,NULL,'Julia Porter','FI','302625994','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:10',0,'2014-03-10 14:24:38'),(18139,18789,'0000-00-00','ET','2',2,1,'DU NGUYEN','FI','620184071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:07',0,'2014-03-02 06:38:05'),(20749,21399,'0000-00-00','ET','2',2,1,'tanya long','FI','587490883','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:35',0,'2014-03-02 07:17:36'),(22581,23231,'0000-00-00','ET','2',1,NULL,'DEBORAH L DEGEER','FI','303627850','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:08',0,'2014-03-10 14:50:59'),(3186,3186,'2014-01-01','ET','2',1,NULL,'darcy l kutzli','FI','269548438','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:05',0,'2014-03-10 13:24:34'),(3277,3277,'2014-01-01','ET','2',1,NULL,'John Wright','FI','642129254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:47:44',0,'2014-03-02 02:10:49'),(11078,11078,'2014-01-01','ET','2',1,NULL,'REBECCA BRADMAN','FI','286568915','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:25',0,'2014-03-10 13:45:57'),(10906,10906,'2014-01-01','ET','2',1,NULL,'Laura Nissel','FI','439156257','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:50',0,'2014-03-02 04:31:46'),(5305,5305,'2014-01-01','ET','2',1,NULL,'Ben Olds','FI','280666103','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:38',0,'2014-03-10 15:39:19'),(3448,3448,'2014-01-01','ET','2',1,NULL,'Frank Caprilla','FI','274807371','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:53:16',0,'2014-03-10 13:32:15'),(4321,4321,'2014-01-01','ET','2',1,NULL,'INDRA CHAKRAVARTY','FI','535900359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:53',0,'2014-03-02 03:09:49'),(13163,13519,'2014-01-01','ET','2',1,NULL,'Brianna German','FI','358883579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:22',0,'2014-03-02 05:17:40'),(14206,14657,'2014-01-01','ET','2',1,NULL,'Carmen Gray','FI','120569284','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:43',0,'2014-03-10 14:03:26'),(16475,17125,'0000-00-00','ET','2',1,NULL,'TINICA L COLBERT','FI','435415148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-30 21:00:21',0,'2014-03-02 06:10:30'),(16841,17491,'0000-00-00','ET','2',1,NULL,'Joshua Wayne Meek','94','0000418918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:19',0,'2014-03-01 17:00:58'),(17127,17777,'0000-00-00','ET','2',1,NULL,'Matthew Rider','FI','459935882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:18',0,'2014-03-02 06:24:38'),(19461,20111,'0000-00-00','ET','2',1,NULL,'Amber Kirby-Rogers','FI','615460843','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-05','Sync Success',0,'2014-02-20 03:47:19',0,'2014-03-02 06:59:07'),(20245,20895,'0000-00-00','ET','2',1,NULL,'JAMES RUSSELL ADKINS','FI','272932131','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:05',0,'2014-03-10 14:37:47'),(20348,20998,'0000-00-00','ET','2',1,NULL,'JONI RUNYON','FI','276548934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:37',0,'2014-03-01 17:47:19'),(20369,21019,'0000-00-00','ET','2',3,2,'Dumisani Mkhize','FI','395177252','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:54',0,'2014-03-10 14:37:47'),(20504,21154,'0000-00-00','ET','2',1,NULL,'MARY WILLIAMS','FI','434922657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:45',0,'2014-03-02 07:10:28'),(20698,21348,'0000-00-00','ET','2',1,NULL,'Alessandro Pieri','FI','436611147','Starmount Life Insurance Company','FI','720977315','Braden  Smith','94','16273937','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:11',0,'2014-03-02 07:17:36'),(20748,21398,'0000-00-00','ET','2',1,NULL,'Randall Fawcett','FI','259824124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-28 06:30:34',0,'2014-03-02 07:17:36'),(20842,21492,'0000-00-00','ET','2',1,NULL,'Kizzy Mcknight','FI','435350062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:18',0,'2014-03-02 07:17:36'),(3383,3383,'2014-01-01','ET','2',1,NULL,'Digole Williams','FI','436843655','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:10',0,'2014-03-02 02:10:49'),(3648,3648,'2014-01-01','ET','2',1,NULL,'Christopher McMaster','FI','289783927','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:51',0,'2014-03-10 15:52:36'),(4303,4303,'2014-01-01','ET','2',1,NULL,'Jawon McCray','FI','426530660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:09:24',0,'2014-03-02 03:09:49'),(4633,4633,'2014-01-01','ET','2',1,NULL,'Gabriel Cedillo','FI','454791162','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:21',0,'2014-03-02 04:31:46'),(4405,4405,'2014-01-01','ET','2',1,NULL,'Tavaushjane Ellsworth','FI','630325995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:06',0,'2014-03-01 21:11:04'),(4343,4343,'2014-01-01','ET','2',1,NULL,'Sharon Meiring','FI','298549443','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:33',0,'2014-03-10 13:32:15'),(14545,14996,'2014-01-01','ET','2',1,NULL,'Justin Gray','FI','641011869','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:15',0,'2014-03-02 05:45:37'),(16224,16873,'0000-00-00','ET','2',1,NULL,'Bianca Martinez','FI','525354736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:55',0,'2014-03-02 06:10:30'),(18935,19585,'0000-00-00','ET','2',2,1,'Natasia Metz','FI','292802810','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:26',0,'2014-03-10 16:31:33'),(139,139,'2014-01-01','ET','2',2,1,'Sibble Brown','FI','275708541','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 17:19:18',0,'2014-03-10 13:10:24'),(185,185,'2014-01-01','ET','2',1,NULL,'Agatha Ford','FI','438575594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:44',0,'2014-03-01 22:10:55'),(7528,7528,'2014-01-01','ET','2',1,NULL,'Samantha Gibson','FI','279888973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:57',0,'2014-03-01 16:05:34'),(12338,12338,'2014-01-01','ET','2',1,NULL,'amy anderson','FI','440847801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:30',0,'2014-03-02 05:03:29'),(3370,3370,'2014-01-01','ET','2',1,NULL,'Natalie Norman','FI','457896295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:45',0,'2014-03-02 02:10:49'),(4072,4072,'2014-01-01','ET','2',1,NULL,'Jamiliah Daniel','FI','299849537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:26',0,'2014-03-01 15:52:44'),(4365,4365,'2014-01-01','ET','2',1,NULL,'PEGGY SUE HOOT','FI','284582105','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:14',0,'2014-03-10 13:32:15'),(5938,5938,'2014-01-01','ET','2',1,NULL,'james shoffner','FI','437858872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:59',0,'2014-03-02 01:10:33'),(5837,5837,'2014-01-01','ET','2',2,1,'terri williams','FI','300565128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:38',0,'2014-03-01 15:10:22'),(13054,13410,'2014-01-01','ET','2',1,NULL,'CIARA EZELL','FI','433719388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:15',0,'2014-03-02 05:17:40'),(13412,13768,'2014-01-01','ET','2',1,NULL,'April Louise Hill','FI','298828107','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:00',0,'2014-03-10 13:59:38'),(13681,14037,'2014-01-01','ET','2',1,NULL,'Maria D Gonzalez','FI','458231694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:29',0,'2014-03-02 05:24:45'),(14615,15066,'2014-01-01','ET','2',1,NULL,'REBECCA L MELLUSO','FI','297885759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:59',0,'2014-03-01 16:46:19'),(14646,15097,'2014-01-01','ET','2',2,1,'KENNETH R BROWNING','FI','287865441','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:17',0,'2014-03-01 16:46:19'),(18098,18748,'0000-00-00','ET','2',1,NULL,'MARIA  ISABELLE TORRES','FI','627311032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:37',0,'2014-03-02 06:38:05'),(18200,18850,'0000-00-00','ET','2',4,3,'Brook Beshah','FI','220617332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:52',0,'2014-03-01 17:26:36'),(18205,18855,'0000-00-00','ET','2',2,1,'Sadie Etter','FI','272861130','Dental Care Plus, Inc.','FI','311185262','Heather R Yoder','94','2342722','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:57',0,'2014-03-01 17:26:36'),(18320,18970,'0000-00-00','ET','2',1,NULL,'Alice M Justice','FI','282560426','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:06',0,'2014-03-01 17:26:36'),(19790,20440,'0000-00-00','ET','2',1,NULL,'Laurel Pang','FI','576419261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:15',0,'2014-03-02 07:03:25'),(20744,21394,'0000-00-00','ET','2',1,NULL,'JUDY BROWN','FI','284544977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:32',0,'2014-03-01 18:10:11'),(20889,21539,'0000-00-00','ET','2',2,1,'Jonathan Sanders','FI','257750598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:39',0,'2014-03-02 07:17:36'),(21703,22353,'0000-00-00','ET','2',1,NULL,'CHRISTINA BRUGIER','FI','608321101','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:41',0,'2014-03-04 21:27:16'),(537,537,'2014-01-01','ET','2',1,NULL,'KATIE  CHEN','FI','293828058','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:37',0,'2014-03-01 15:48:04'),(12760,12760,'2014-01-01','ET','2',1,NULL,'CONNIE CORDY','FI','277483376','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:06',0,'2014-03-10 13:59:38'),(1344,1344,'2014-01-01','ET','2',2,1,'LESLIE CAMACHO','FI','461353065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:12',0,'2014-03-02 04:38:08'),(11254,11254,'2014-01-01','ET','2',1,NULL,'Susan Simpson','FI','301868329','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:02:06',0,'2014-03-01 16:23:43'),(7628,7628,'2014-01-01','ET','2',1,NULL,'Lynn Francek','FI','275489813','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Pietrowski','94','1636529','348','2014-01-01','Sync Success',0,'2013-12-26 04:38:11',0,'2014-03-10 15:59:47'),(5780,5780,'2014-01-01','ET','2',2,1,'Michael Pacifico','94','0000776411','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:56',0,'2014-03-10 15:52:36'),(1808,1808,'2014-01-01','ET','2',1,NULL,'Sheena Lee','FI','286829980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:55',0,'2014-03-10 13:20:27'),(5596,5596,'2014-01-01','ET','2',1,NULL,'Jared Thorbahn','FI','292823662','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:32',0,'2014-03-02 04:45:37'),(4138,4138,'2014-01-01','ET','2',1,NULL,'Joyce Bartlett','FI','401806995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:04:19',0,'2014-03-01 16:00:27'),(3924,3924,'2014-01-01','ET','2',1,NULL,'Maria Domin','FI','009782194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:46',0,'2014-03-01 15:26:40'),(3711,3711,'2014-01-01','ET','2',1,NULL,'REINA CANIZALES','FI','127461291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:54',0,'2014-03-02 01:10:33'),(3337,3337,'2014-01-01','ET','2',4,3,'Melissa  Gerber','FI','294820573','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:43',0,'2014-03-10 15:52:36'),(2194,2194,'2014-01-01','ET','2',2,1,'John Robert Korber','FI','276661456','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:59',0,'2014-03-10 15:39:19'),(13904,14260,'2014-01-01','ET','2',2,1,'SHARON M THIERET','FI','286682769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:04',0,'2014-03-01 16:40:16'),(13998,14354,'2014-01-01','ET','2',2,1,'DAVID DAVIS','FI','274649972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:29',0,'2014-03-01 16:40:16'),(16073,16722,'0000-00-00','ET','2',2,1,'Jade Darks','FI','295947723','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:58',0,'2014-03-01 16:56:22'),(16764,17414,'0000-00-00','ET','2',1,NULL,'ARLENE TILLEY SIMON','FI','438150696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:18',0,'2014-03-02 06:17:30'),(17561,18211,'0000-00-00','ET','2',1,NULL,'Bernita Stevenson','FI','435844509','Starmount Life Insurance Company','FI','720977315','Percy Paul McCraney','94','9000490','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:41',0,'2014-03-02 06:31:45'),(17906,18556,'0000-00-00','ET','2',1,NULL,'Patricia Walls','FI','433062272','Starmount Life Insurance Company','FI','720977315','Kathy   Canlas','94','7407489','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:33',0,'2014-03-02 06:38:05'),(17993,18643,'0000-00-00','ET','2',1,NULL,'Cosme Arana','FI','069544124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:34',0,'2014-03-02 06:38:05'),(18796,19446,'0000-00-00','ET','2',2,1,'tiffany blankenship','FI','287889398','HealthSpan','FI','311431434','Stephen James  Ray','94','1484647','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:05',0,'2014-03-10 14:31:05'),(21510,22160,'0000-00-00','ET','2',2,1,'Rebekka Berry','FI','463830504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:02',0,'2014-03-03 22:26:43'),(49,49,'2014-01-01','ET','2',1,NULL,'SARA MOSS','FI','453290401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:28',0,'2014-03-01 15:21:15'),(12782,12782,'2014-01-01','ET','2',1,NULL,'JONEVA ROGERSON','FI','449434991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:35',0,'2014-03-02 05:10:52'),(1653,1653,'2014-01-01','ET','2',2,1,'Barbara Hunsicker','FI','299525217','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:35',0,'2014-03-10 15:39:19'),(2070,2070,'2014-01-01','ET','2',1,NULL,'Thomas Bica','FI','269423506','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:06',0,'2014-03-10 15:45:56'),(14758,15209,'2014-01-01','ET','2',1,NULL,'PATRICIA KIGHTLINGER','FI','302485047','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:30',0,'2014-03-10 16:17:47'),(15560,16011,'0000-00-00','ET','2',1,NULL,'Kelley Nicholson','FI','298602100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 03:02:18',0,'2014-03-01 16:50:53'),(15665,16314,'0000-00-00','ET','2',1,NULL,'Carol s SCHULER','FI','281509662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:24',0,'2014-03-01 16:56:22'),(17446,18096,'0000-00-00','ET','2',1,NULL,'NINA L ATER','FI','275548508','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:13',0,'2014-03-01 17:20:55'),(20337,20987,'0000-00-00','ET','2',2,1,'ADAM ROBERTSON','FI','434773345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:26',0,'2014-03-02 07:03:25'),(21060,21710,'0000-00-00','ET','2',1,NULL,'ollie parker','FI','294500784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:21',0,'2014-03-01 18:10:11'),(21520,22170,'0000-00-00','ET','2',1,NULL,'colleen wise','FI','346626400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:10',0,'2014-03-03 22:26:43'),(1350,1350,'2014-01-01','ET','2',1,NULL,'Daniel Light','FI','462312154','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:26',0,'2014-03-02 04:38:08'),(2859,2859,'2014-01-01','ET','2',1,NULL,'Kathleen Fritz','FI','298760246','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:18',0,'2014-03-10 15:59:47'),(11809,11809,'2014-01-01','ET','2',1,NULL,'Lisa Knowles','FI','078521123','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:20',0,'2014-03-01 16:15:39'),(11053,11053,'2014-01-01','ET','2',4,3,'Michael Cavin','FI','302762990','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:33',0,'2014-03-10 13:45:57'),(10387,10387,'2014-01-01','ET','2',1,NULL,'VASHAWNA EMBRY-HUGHES','FI','290643490','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:21',0,'2014-03-01 16:10:36'),(3687,3687,'2014-01-01','ET','2',1,NULL,'Jesse Hamilton','FI','401119987','HealthSpan','FI','311431434','Kevin  Schlotman','94','1427172','348','2014-01-01','Sync Success',0,'2013-12-25 22:07:04',0,'2014-03-10 13:20:27'),(6381,6381,'2014-01-01','ET','2',1,NULL,'STACY  WARSAW','FI','366547546','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:53',0,'2014-03-10 13:39:10'),(5317,5317,'2014-01-01','ET','2',1,NULL,'Anastasia Seward','FI','381150682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:05',0,'2014-03-10 13:03:33'),(6277,6277,'2014-01-01','ET','2',1,NULL,'Robert Thomas','FI','435238899','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-26 03:06:46',0,'2014-03-02 04:10:25'),(5989,5989,'2014-01-01','ET','2',1,NULL,'john rist','FI','279527432','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:36',0,'2014-03-10 13:24:34'),(14081,14532,'2014-01-01','ET','2',2,1,'Jasmine Spotswood','FI','499903573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:23',0,'2014-03-02 05:38:34'),(15748,16397,'0000-00-00','ET','2',1,NULL,'Mary K Digman','FI','271645940','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:21',0,'2014-03-01 16:56:22'),(16263,16912,'0000-00-00','ET','2',1,NULL,'Bessie Turner','FI','268568220','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:01:21',0,'2014-03-10 14:20:26'),(16670,17320,'0000-00-00','ET','2',1,NULL,'Brandi White','FI','281920726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:55',0,'2014-03-01 17:00:58'),(17997,18647,'0000-00-00','ET','2',1,NULL,'Hue Truong','FI','661012368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:37',0,'2014-03-02 06:38:05'),(18350,19000,'0000-00-00','ET','2',1,NULL,'DANNY CRUZ POSAS','FI','872245606','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:26',0,'2014-03-02 06:45:14'),(18987,19637,'0000-00-00','ET','2',1,NULL,'Joseph Toman','FI','383044715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:05',0,'2014-03-02 06:52:12'),(19278,19928,'0000-00-00','ET','2',1,NULL,'Susan Kelby','FI','299684258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:03',0,'2014-03-01 17:34:07'),(19777,20427,'0000-00-00','ET','2',1,NULL,'Lawander L Richardson','FI','428276236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:03',0,'2014-03-02 06:59:07'),(21210,21860,'0000-00-00','ET','2',1,NULL,'SYNTHIA ELLEN POKORNY','FI','300660598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-03-01 19:00:09',0,'2014-03-01 19:35:05'),(21755,22405,'0000-00-00','ET','2',2,1,'Diana Kemp','FI','296765112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:24',0,'2014-03-10 16:44:18'),(21908,22558,'0000-00-00','ET','2',1,NULL,'Ronald Houghton','FI','466067867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:50',0,'2014-03-05 22:27:33'),(23062,23712,'0000-00-00','ET','2',1,NULL,'LINDA SCHETTER','FI','225947476','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:37',0,'2014-03-10 21:17:52'),(1401,1401,'2014-01-01','ET','2',1,NULL,'Dan Rousselle','FI','439827432','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:06',0,'2014-03-02 04:38:08'),(1407,1407,'2014-01-01','ET','2',1,NULL,'Theodora Chapman','FI','433751876','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:16',0,'2014-03-02 04:38:08'),(2546,2546,'2014-01-01','ET','2',1,NULL,'kyriakos alexakis','FI','286861518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:24',0,'2014-03-01 15:10:22'),(3221,3221,'2014-01-01','ET','2',1,NULL,'Melanie Bushman','FI','301901303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:57',0,'2014-03-01 15:52:44'),(12312,12312,'2014-01-01','ET','2',1,NULL,'LUCY DOOLAN','FI','182505845','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:45',0,'2014-03-10 16:10:34'),(4574,4574,'2014-01-01','ET','2',1,NULL,'Carol Winters','FI','277506074','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:27',0,'2014-03-01 16:15:39'),(7128,7128,'2014-01-01','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:27',0,'2014-03-01 15:52:44'),(14333,14784,'2014-01-01','ET','2',1,NULL,'lola strange','FI','433988362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:38',0,'2014-03-02 05:38:34'),(15517,15968,'0000-00-00','ET','2',1,NULL,'LISA R HART','FI','634090066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:58',0,'2014-03-02 05:59:43'),(15704,16353,'0000-00-00','ET','2',1,NULL,'ali delaram','FI','645429179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:50',0,'2014-03-02 05:59:43'),(17828,18478,'0000-00-00','ET','2',1,NULL,'shirley demint','FI','272662740','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:58',0,'2014-03-10 14:20:26'),(20518,21168,'0000-00-00','ET','2',1,NULL,'MUSTAFA MUSTAFA','FI','439737400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:55',0,'2014-03-02 07:17:36'),(20525,21175,'0000-00-00','ET','2',1,NULL,'TOMASITA ROJAS MONTOYA','FI','453474520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:01',0,'2014-03-02 07:10:28'),(20824,21474,'0000-00-00','ET','2',2,1,'SARAI IBARRA','FI','636186859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:10',0,'2014-03-02 07:17:36'),(20846,21496,'0000-00-00','ET','2',1,NULL,'JESSICA WILLAIMS','FI','438373433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:20',0,'2014-03-02 07:17:36'),(21028,21678,'0000-00-00','ET','2',1,NULL,'Steven Knape','FI','503904461','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:20',0,'2014-03-10 14:45:25'),(21639,22289,'0000-00-00','ET','2',1,NULL,'Dorothy Roberta Hernandez','FI','580045809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:50',0,'2014-03-04 21:27:16'),(21785,22435,'0000-00-00','ET','2',1,NULL,'August Bear','FI','425066182','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:06',0,'2014-03-04 21:36:30'),(1520,1520,'2014-01-01','ET','2',1,NULL,'JAMES MENNINGER','FI','273468750','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:03',0,'2014-03-10 13:52:32'),(13063,13419,'2014-01-01','ET','2',1,NULL,'MARY NEWELL','FI','434927904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:33',0,'2014-03-02 05:17:40'),(1564,1564,'2014-01-01','ET','2',3,2,'Michael leese','FI','299805799','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:04',0,'2014-03-01 15:10:22'),(4143,4143,'2014-01-01','ET','2',1,NULL,'Rainier Reyes','FI','296804793','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-25 23:04:29',0,'2014-03-01 16:00:27'),(4182,4182,'2014-01-01','ET','2',1,NULL,'Elizabeth Williams','FI','282829973','Summa Insurance Company, Inc.','FI','341809108','Lawrence  Kaczmarek','94','313913','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:40',0,'2014-03-10 15:59:47'),(11639,11639,'2014-01-01','ET','2',1,NULL,'Margie Ohmer','FI','439311857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:55',0,'2014-03-02 04:59:36'),(4678,4678,'2014-01-01','ET','2',1,NULL,'Gary Angel','FI','281485680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:51',0,'2014-03-01 16:15:39'),(10781,10781,'2014-01-01','ET','2',1,NULL,'Lanetta Smith','FI','437536958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:16',0,'2014-03-02 04:24:47'),(13408,13764,'2014-01-01','ET','2',2,1,'Dale Corfman','FI','349466300','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:58',0,'2014-03-10 16:10:34'),(14431,14882,'2014-01-01','ET','2',1,NULL,'demetrice ballom','FI','436518792','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:22',0,'2014-03-02 05:38:34'),(16352,17002,'0000-00-00','ET','2',1,NULL,'Anne Lois Haskins','FI','277726199','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:55',0,'2014-03-01 16:56:22'),(17129,17779,'0000-00-00','ET','2',1,NULL,'Jose  R  Nolasco','FI','644466297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:19',0,'2014-03-02 06:24:38'),(17150,17800,'0000-00-00','ET','2',2,1,'Jennifer Yasin','FI','286689875','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:33',0,'2014-03-10 16:24:30'),(18016,18666,'0000-00-00','ET','2',1,NULL,'TAYLOR R EVENSON','FI','282909823','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:50',0,'2014-03-01 17:20:55'),(19219,19869,'0000-00-00','ET','2',1,NULL,'Lauren Schroeder','FI','268863425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:16',0,'2014-03-01 17:34:07'),(19380,20030,'0000-00-00','ET','2',1,NULL,'William Lowen','FI','283544230','Dental Care Plus, Inc.','FI','311185262','Maureen  Fowler','94','8188952','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:53',0,'2014-03-01 17:34:07'),(20866,21516,'0000-00-00','ET','2',1,NULL,'Juanita Yost','FI','296505287','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:29',0,'2014-03-10 14:45:25'),(21427,22077,'0000-00-00','ET','2',1,NULL,'Shoy Brown','FI','435713900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:00',0,'2014-03-03 22:26:43'),(21451,22101,'0000-00-00','ET','2',1,NULL,'Terry Grimm','FI','300682440','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:19',0,'2014-03-10 16:44:18'),(22308,22958,'0000-00-00','ET','2',1,NULL,'Kevin Nguyen','FI','564579672','Starmount Life Insurance Company','FI','720977315','Tony  Ly','94','7898204','357','2014-03-31','Sync Success',0,'2014-03-06 21:30:04',0,'2014-03-06 22:25:29'),(1783,1783,'2014-01-01','ET','2',2,1,'Bradley Shrock','FI','268509486','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:04',0,'2014-03-10 15:45:56'),(11135,11135,'2014-01-01','ET','2',2,1,'Randall Earl McIntosh','FI','279703678','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:23',0,'2014-03-10 13:39:10'),(3094,3094,'2014-01-01','ET','2',1,NULL,'Donald Sanders','FI','437829629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:01',0,'2014-03-02 01:10:33'),(2128,2128,'2014-01-01','ET','2',1,NULL,'MAXINE MARIE CALKINS','FI','298785097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:46',0,'2014-03-01 15:16:37'),(6074,6074,'2014-01-01','ET','2',1,NULL,'Nicole Alleman','FI','433635040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:29',0,'2014-03-02 04:10:25'),(13394,13750,'2014-01-01','ET','2',2,1,'Douglas Bertison','FI','299584003','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:52',0,'2014-03-10 16:10:34'),(13830,14186,'2014-01-01','ET','2',1,NULL,'Danyeil Hoy','FI','350809223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:34',0,'2014-03-02 05:31:31'),(14396,14847,'2014-01-01','ET','2',1,NULL,'Laurie Henry','FI','251219081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:05',0,'2014-03-01 16:46:19'),(15641,16290,'0000-00-00','ET','2',2,1,'Sarjeet Singh','FI','225596577','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:04',0,'2014-03-01 16:50:53'),(16932,17582,'0000-00-00','ET','2',1,NULL,'NICHOLAS MALLARD','FI','428497429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:00:46',0,'2014-03-02 06:17:30'),(17617,18267,'0000-00-00','ET','2',2,1,'travonda wilson','FI','433411481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:13',0,'2014-03-02 06:31:45'),(18076,18726,'0000-00-00','ET','2',1,NULL,'Carolyn Lawrence','FI','451133398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:21',0,'2014-03-02 06:38:05'),(18240,18890,'0000-00-00','ET','2',1,NULL,'Karole Sessums','FI','587034906','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:27',0,'2014-03-02 06:38:05'),(19077,19727,'0000-00-00','ET','2',1,NULL,'Dawn Oliver','FI','562658356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:27',0,'2014-03-02 06:52:12'),(21168,21818,'0000-00-00','ET','2',1,NULL,'Grant Conwell','FI','279926845','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:33',0,'2014-03-10 16:38:05'),(21493,22143,'0000-00-00','ET','2',2,1,'SARAH BROWN','FI','275880124','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:50',0,'2014-03-03 21:36:16'),(21595,22245,'0000-00-00','ET','2',1,NULL,'EDWARD  LEE FAIRCHILD','FI','435040086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:00:16',0,'2014-03-04 21:27:16'),(22154,22804,'0000-00-00','ET','2',1,NULL,'Desirae Robinson','FI','286946972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:07',0,'2014-03-06 21:36:23'),(23046,23696,'0000-00-00','ET','2',1,NULL,'EDDIE JOHNSON','FI','438985499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:25',0,'2014-03-10 21:27:11'),(23050,23700,'0000-00-00','ET','2',1,NULL,'Jessica Jones','FI','425572240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:27',0,'2014-03-10 21:27:11'),(2258,2258,'2014-01-01','ET','2',1,NULL,'Jennifer Fulcher','FI','526815448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:10',0,'2014-03-01 21:11:04'),(11685,11685,'2014-01-01','ET','2',1,NULL,'Becky Alaniz','FI','457556612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:26',0,'2014-03-02 04:59:36'),(11466,11466,'2014-01-01','ET','2',1,NULL,'LINDA CIOTTI','FI','288502170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:38',0,'2014-03-01 16:30:17'),(4426,4426,'2014-01-01','ET','2',1,NULL,'regina burkett','FI','467353282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:55',0,'2014-03-01 19:11:03'),(10671,10671,'2014-01-01','ET','2',1,NULL,'Nancy Lignoski','FI','208664017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:26',0,'2014-03-01 16:10:36'),(7681,7681,'2014-01-01','ET','2',2,1,'MARILYN BELL','FI','302528909','HealthSpan','FI','311431434','ALAN  ZEFF','94','2759324','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:52',0,'2014-03-10 13:39:10'),(5029,5029,'2014-01-01','ET','2',1,NULL,'Nicolle Rubin','FI','273888127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:55',0,'2014-03-01 15:31:33'),(6375,6375,'2014-01-01','ET','2',1,NULL,'Karen Huber','FI','269645814','HealthSpan','FI','311431434','Chris  Junge','94','9794726','348','2014-01-01','Sync Success',0,'2013-12-26 03:09:43',0,'2014-03-10 13:39:10'),(14811,15262,'2014-01-01','ET','2',1,NULL,'Andrew Comstock Kitto','FI','293805324','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:04',0,'2014-03-10 16:17:47'),(16173,16822,'0000-00-00','ET','2',1,NULL,'Brice Williams','FI','294845180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:21',0,'2014-03-01 16:56:22'),(18169,18819,'0000-00-00','ET','2',1,NULL,'John Turner','FI','433532183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:30',0,'2014-03-02 06:38:05'),(18556,19206,'0000-00-00','ET','2',2,1,'BIPIN R PATEL','FI','314112645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:14',0,'2014-03-10 14:31:05'),(22157,22807,'0000-00-00','ET','2',1,NULL,'Jamika Lewis','FI','284843029','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:09',0,'2014-03-06 21:36:23'),(5367,5367,'2014-01-01','ET','2',1,NULL,'Deyanna Bourgeois','FI','438352365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:27',0,'2014-03-01 21:11:04'),(12991,12991,'2014-01-01','ET','2',2,1,'rebecca jo campbell','FI','279861984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:48',0,'2014-03-01 16:35:14'),(13067,13423,'2014-01-01','ET','2',2,1,'no nguyen','FI','439831403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:42',0,'2014-03-02 05:17:40'),(11469,11469,'2014-01-01','ET','2',2,1,'WILLIAM  AREHART','FI','268747549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:43',0,'2014-03-01 16:30:17'),(13110,13466,'2014-01-01','ET','2',1,NULL,'Rita Guerrero','FI','457533145','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:23',0,'2014-03-02 05:17:40'),(13348,13704,'2014-01-01','ET','2',5,4,'ANTHONY KNUTSON','FI','302705900','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:31',0,'2014-03-01 16:40:16'),(13694,14050,'2014-01-01','ET','2',1,NULL,'Kelvin Armon Ranford','FI','280849906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:37',0,'2014-03-01 16:40:16'),(14163,14614,'2014-01-01','ET','2',1,NULL,'Joseph Ogden','FI','297869850','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:16',0,'2014-03-10 14:03:26'),(14556,15007,'2014-01-01','ET','2',1,NULL,'CHAUNCEY TOWNSEND','FI','456047741','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:22',0,'2014-03-02 05:45:37'),(14575,15026,'2014-01-01','ET','2',1,NULL,'EDMOND FINCH','FI','416981121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:33',0,'2014-03-02 05:45:37'),(14627,15078,'2014-01-01','ET','2',2,1,'MICHELLE MARIE MCCUE','FI','299606635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:07',0,'2014-03-01 16:46:19'),(14988,15439,'2014-01-01','ET','2',1,NULL,'Harold Smith','FI','421214034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:05',0,'2014-03-01 16:50:53'),(17116,17766,'0000-00-00','ET','2',2,1,'Michael Reed','FI','283545620','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:10',0,'2014-03-10 14:20:26'),(15889,16538,'0000-00-00','ET','2',1,NULL,'Kimberly Smith','FI','428531152','Starmount Life Insurance Company','FI','720977315','LaMonica  Stewart','94','6401868','357','2014-03-01','Sync Success',0,'2014-01-24 21:01:06',0,'2014-03-02 06:03:21'),(16380,17030,'0000-00-00','ET','2',1,NULL,'Marisha Lirette','FI','434673095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:13',0,'2014-03-02 06:10:30'),(17415,18065,'0000-00-00','ET','2',1,NULL,'Thomas Bianco','FI','269864117','Summa Insurance Company, Inc.','FI','341809108','Steven  Clark','94','7596884','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:52',0,'2014-03-10 16:24:30'),(17920,18570,'0000-00-00','ET','2',1,NULL,'Khon Binh Tu','FI','586123364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:43',0,'2014-03-02 06:38:05'),(18127,18777,'0000-00-00','ET','2',1,NULL,'tam thuy thi dao','FI','642421911','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:58',0,'2014-03-02 06:38:05'),(18562,19212,'0000-00-00','ET','2',1,NULL,'Aaron Nguyen','FI','066767210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:17',0,'2014-03-02 06:52:12'),(20249,20899,'0000-00-00','ET','2',1,NULL,'John Brennan','FI','298609810','HealthSpan','FI','311431434','Maureen  Fowler','94','8188952','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:08',0,'2014-03-10 14:37:47'),(21270,21920,'0000-00-00','ET','2',1,NULL,'Mechelle Watts','FI','284804402','Dental Care Plus, Inc.','FI','311185262','Harvey  Ridley','94','16791486','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:42',0,'2014-03-01 21:35:40'),(21813,22463,'0000-00-00','ET','2',2,1,'Matthew William Curry','FI','452454305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:12',0,'2014-03-05 21:25:24'),(22855,23505,'0000-00-00','ET','2',1,NULL,'Tanner Gene Ellis','FI','630306604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:07',0,'2014-03-10 21:27:11'),(108,108,'2014-01-01','ET','2',2,1,'Marie Lauer','FI','288521902','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:16',0,'2014-03-10 13:10:24'),(326,326,'2014-01-01','ET','2',1,NULL,'Linda Denbow','FI','284504888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:02',0,'2014-03-01 15:21:15'),(2457,2457,'2014-01-01','ET','2',1,NULL,'Zachary Pontious','FI','183700325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:06',0,'2014-03-01 23:10:52'),(11736,11736,'2014-01-01','ET','2',1,NULL,'Cynthia Bidlencsik','FI','298525603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:00',0,'2014-03-01 16:30:17'),(10537,10537,'2014-01-01','ET','2',2,1,'Terry Kemper','FI','495663301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:02',0,'2014-03-02 04:31:46'),(2605,2605,'2014-01-01','ET','2',1,0,'Cathy Bennett','FI','232941027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:08',0,'2014-03-01 15:05:09'),(5025,5025,'2014-01-01','ET','2',2,1,'William Stec','FI','277527611','Dental Care Plus, Inc.','FI','311185262','Cameron  Liljenquist','94','8328382','348','2014-01-01','Sync Success',0,'2013-12-26 00:46:46',0,'2014-03-01 15:31:33'),(6378,6378,'2014-01-01','ET','2',1,NULL,'Kelton Mote','FI','311620837','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:48',0,'2014-03-10 13:39:10'),(5718,5718,'2014-01-01','ET','2',1,NULL,'Carolee Ann Davis','FI','522722156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:00',0,'2014-03-01 15:37:30'),(12867,12867,'2014-01-01','ET','2',2,1,'REBECCA  F PERIN','FI','432693679','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:40',0,'2014-03-01 16:35:14'),(13310,13666,'2014-01-01','ET','2',1,NULL,'Kristine Woolery','FI','099423273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:16',0,'2014-03-01 16:40:16'),(13865,14221,'2014-01-01','ET','2',1,NULL,'Mariam Muhammad','FI','766687559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:58',0,'2014-03-02 05:31:31'),(14386,14837,'2014-01-01','ET','2',1,NULL,'Janis Klunk','FI','280703625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:00',0,'2014-03-01 16:46:19'),(14883,15334,'2014-01-01','ET','2',1,NULL,'LaNetra Carther','FI','312844065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:16',0,'2014-03-02 05:52:31'),(16665,17315,'0000-00-00','ET','2',1,NULL,'John Albert','FI','270604905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:51',0,'2014-03-01 17:00:58'),(17209,17859,'0000-00-00','ET','2',1,NULL,'Joanne Cooper','FI','301700433','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:10',0,'2014-03-01 17:20:55'),(18074,18724,'0000-00-00','ET','2',2,1,'Emeterio Cardenas','FI','642033889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:18',0,'2014-03-02 06:38:05'),(18143,18793,'0000-00-00','ET','2',1,NULL,'SAIZUR RAHMAN','FI','149021846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:10',0,'2014-03-02 06:38:05'),(18288,18938,'0000-00-00','ET','2',1,NULL,'KRISTIN BAUER','FI','435416044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:18',0,'2014-03-02 06:38:05'),(18609,19259,'0000-00-00','ET','2',3,2,'Scott Smith','94','0000373671','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:41',0,'2014-03-10 16:31:33'),(18926,19576,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:21',0,'2014-03-10 16:31:33'),(19173,19823,'0000-00-00','ET','2',1,NULL,'Aaron Hawkins','FI','549714029','Starmount Life Insurance Company','FI','720977315','Wellington  Lopez','94','4452247','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:41',0,'2014-03-02 06:52:12'),(19721,20371,'0000-00-00','ET','2',1,NULL,'Michael Hurst','FI','291526417','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','357','2014-03-31','Sync Success',0,'2014-02-20 05:33:45',0,'2014-03-01 17:47:19'),(20325,20975,'0000-00-00','ET','2',1,NULL,'David J Greener','FI','464877101','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:13',0,'2014-03-02 07:03:25'),(22503,23153,'0000-00-00','ET','2',1,NULL,'ARLANDA WASHINGTON','FI','435969331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:13',0,'2014-03-07 22:26:59'),(386,386,'2014-01-01','ET','2',1,NULL,'Elijah E Henes','FI','867558910','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:56',0,'2014-03-10 13:10:24'),(798,798,'2014-01-01','ET','2',1,NULL,'Michael Melancon','FI','437845614','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:06',0,'2014-03-01 19:11:03'),(2487,2487,'2014-01-01','ET','2',2,1,'RANDALL STEPHENS','FI','296426118','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:06',0,'2014-03-10 13:10:24'),(2616,2616,'2014-01-01','ET','2',1,NULL,'awes koshin','FI','611847422','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:46:29',0,'2014-03-01 15:16:37'),(4961,4961,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:12',0,'2014-03-01 15:05:09'),(4683,4683,'2014-01-01','ET','2',1,NULL,'Marilyn Estelle Nolley','FI','455210773','Starmount Life Insurance Company','FI','720977315','Rodney T Watkins','94','4021485','348','2014-01-01','Sync Success',0,'2013-12-25 23:50:04',0,'2014-03-02 04:31:46'),(4647,4647,'2014-01-01','ET','2',1,NULL,'javier bazaldua','FI','455958060','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:47',0,'2014-03-02 04:38:08'),(4550,4550,'2014-01-01','ET','2',1,NULL,'Danny G Silva','FI','561150138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:43',0,'2014-03-02 04:31:46'),(3853,3853,'2014-01-01','ET','2',1,NULL,'STEVEN ALVAREZ','FI','465793184','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:42',0,'2014-03-01 19:11:03'),(3150,3150,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:37:46',0,'2014-03-10 13:24:34'),(12675,12675,'2014-01-01','ET','2',1,NULL,'GEORGE MEANEY','FI','090504809','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:51',0,'2014-03-01 16:35:14'),(13460,13816,'2014-01-01','ET','2',1,NULL,'Lashonda Everett-Hardy','FI','452794011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:27',0,'2014-03-01 16:40:16'),(13638,13994,'2014-01-01','ET','2',2,1,'Patricia Nuss','FI','271440678','Summa Insurance Company, Inc.','FI','341809108','Tim  Walters','94','1852658','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:53',0,'2014-03-10 16:10:34'),(14969,15420,'2014-01-01','ET','2',1,NULL,'Elizabeth Parkhouse','FI','297846690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:57',0,'2014-03-01 16:50:53'),(15384,15835,'0000-00-00','ET','2',1,NULL,'Angela Simmons','FI','436515608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:59',0,'2014-03-02 05:52:31'),(16382,17032,'0000-00-00','ET','2',1,NULL,'Nadeem S Arshad','FI','435838164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:15',0,'2014-03-02 06:10:30'),(16551,17201,'0000-00-00','ET','2',2,1,'vilma castillo','FI','089864210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:10',0,'2014-03-02 06:17:30'),(19001,19651,'0000-00-00','ET','2',4,3,'Emily Orue','FI','276744189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:14',0,'2014-03-10 14:31:05'),(19233,19883,'0000-00-00','ET','2',2,1,'Meena Bhatpuria','FI','631541471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:26',0,'2014-03-02 06:52:12'),(19952,20602,'0000-00-00','ET','2',1,NULL,'fernando fernandez','FI','460155806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:17',0,'2014-03-02 07:03:25'),(20192,20842,'0000-00-00','ET','2',1,NULL,'JEFF DAVISON','FI','551492603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:24',0,'2014-03-02 07:10:28'),(20214,20864,'0000-00-00','ET','2',1,NULL,'dawn sorter','FI','295742328','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:41',0,'2014-03-10 14:37:47'),(21154,21804,'0000-00-00','ET','2',1,NULL,'Dianna Myles','FI','437089707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:23',0,'2014-03-02 07:23:39'),(215,215,'2014-01-01','ET','2',3,2,'melissa mason','FI','286682333','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:47',0,'2014-03-10 13:10:24'),(793,793,'2014-01-01','ET','2',2,1,'Larry Ray','FI','456840646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:54',0,'2014-03-01 19:11:03'),(1033,1033,'2014-01-01','ET','2',2,1,'Cern Basher','FI','418336645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:18',0,'2014-03-10 13:10:24'),(3176,3176,'2014-01-01','ET','2',1,NULL,'John Mark Milano','FI','293769242','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:41',0,'2014-03-10 13:24:34'),(7171,7171,'2014-01-01','ET','2',3,2,'Kimberly Foust','FI','301669134','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:43',0,'2014-03-10 15:59:47'),(13769,14125,'2014-01-01','ET','2',2,1,'Raymond Weisel','FI','269843030','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:26',0,'2014-03-10 16:10:34'),(13770,14126,'2014-01-01','ET','2',2,1,'Steve Orton','FI','288582592','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:27',0,'2014-03-10 16:10:34'),(14338,14789,'2014-01-01','ET','2',3,2,'Debra Ann Rayas','FI','450577441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:40',0,'2014-03-02 05:38:34'),(14544,14995,'2014-01-01','ET','2',1,NULL,'PHILIP VANCE LEE','FI','459376751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:14',0,'2014-03-02 05:45:37'),(16020,16669,'0000-00-00','ET','2',1,NULL,'Ashley Mitchell','FI','450838737','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:24',0,'2014-03-02 06:03:21'),(17139,17789,'0000-00-00','ET','2',1,NULL,'ANN HARRIS','FI','288588944','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:25',0,'2014-03-10 16:24:30'),(20514,21164,'0000-00-00','ET','2',1,NULL,'ALMA MENDEZ DE VILLAGRAN','FI','663105841','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:52',0,'2014-03-02 07:17:36'),(20788,21438,'0000-00-00','ET','2',2,1,'Julie Ann Petersen','FI','291648163','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:53',0,'2014-03-10 16:38:05'),(1756,1756,'2014-01-01','ET','2',1,NULL,'Angel Hernandez','FI','331724891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:09',0,'2014-03-01 15:31:33'),(2748,2748,'2014-01-01','ET','2',1,NULL,'Patricia Ortiz','FI','557049685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:41',0,'2014-03-02 04:15:49'),(10615,10615,'2014-01-01','ET','2',1,NULL,'CLARENCE O MARLAR','FI','450784907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:41',0,'2014-03-02 04:24:47'),(2794,2794,'2014-01-01','ET','2',1,NULL,'Derek Watrous','94','0000137567','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:10',0,'2014-03-01 16:05:34'),(7623,7623,'2014-01-01','ET','2',1,NULL,'Stephen Douglas Paris','FI','275443922','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:01',0,'2014-03-10 15:59:47'),(7498,7498,'2014-01-01','ET','2',1,NULL,'matthew hamman','FI','279729488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:58',0,'2014-03-01 16:05:34'),(7078,7078,'2014-01-01','ET','2',1,NULL,'Emma Claire Sonek','FI','289889474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:56',0,'2014-03-01 15:52:44'),(5649,5649,'2014-01-01','ET','2',1,NULL,'Jonda Spurlock','FI','281782393','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:16',0,'2014-03-10 13:52:32'),(5247,5247,'2014-01-01','ET','2',1,NULL,'Donna McKean','FI','203527947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:55',0,'2014-03-10 13:20:27'),(3040,3040,'2014-01-01','ET','2',1,NULL,'Perry Allen Gibson','FI','287529051','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:18',0,'2014-03-01 15:37:30'),(3760,3760,'2014-01-01','ET','2',1,NULL,'karen shope','FI','283540308','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:35',0,'2014-03-10 13:24:34'),(4060,4060,'2014-01-01','ET','2',1,NULL,'Maria Anita Puente','FI','457082176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:59',0,'2014-03-02 03:09:49'),(12619,12619,'2014-01-01','ET','2',1,NULL,'Sarai Robles','FI','636485122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:46',0,'2014-03-02 05:10:52'),(13087,13443,'2014-01-01','ET','2',1,NULL,'THERESA KUHEN','FI','285885811','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:29',0,'2014-03-01 16:35:14'),(13842,14198,'2014-01-01','ET','2',1,NULL,'John Beard','FI','630053700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:42',0,'2014-03-02 05:31:31'),(14351,14802,'2014-01-01','ET','2',1,NULL,'Janet Warren','FI','449900899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:45',0,'2014-03-02 05:45:37'),(14424,14875,'2014-01-01','ET','2',2,1,'william fonville','FI','587469817','Starmount Life Insurance Company','FI','720977315','revonno  bert','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:17',0,'2014-03-02 05:38:34'),(14872,15323,'2014-01-01','ET','2',1,NULL,'Bobbie Bowden','FI','638425380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:11',0,'2014-03-02 05:52:31'),(15997,16646,'0000-00-00','ET','2',1,NULL,'Luther Layne','FI','412880621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:08',0,'2014-03-02 06:03:21'),(17405,18055,'0000-00-00','ET','2',1,NULL,'ANGELA WHITT','FI','286709710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:45',0,'2014-03-01 17:20:55'),(18824,19474,'0000-00-00','ET','2',1,NULL,'Patricia Almonrode','FI','003482870','Starmount Life Insurance Company','FI','720977315','Shane   Cantrell','94','17077162','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:08',0,'2014-03-02 06:52:12'),(19690,20340,'0000-00-00','ET','2',1,NULL,'JACQUELINE JONES','FI','426139033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:52:57',0,'2014-03-02 06:59:07'),(20317,20967,'0000-00-00','ET','2',1,NULL,'Abdul Aziz','FI','467812372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:05',0,'2014-03-02 07:03:25'),(78,78,'2014-01-01','ET','2',1,NULL,'Eugene Franklin','FI','459924794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:23',0,'2014-03-01 22:10:55'),(11777,11777,'2014-01-01','ET','2',1,NULL,'April King','FI','290744666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:16',0,'2014-03-10 13:52:32'),(1818,1818,'2014-01-01','ET','2',1,NULL,'Jesse Stephens','FI','298469693','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:12',0,'2014-03-10 15:45:56'),(11273,11273,'2014-01-01','ET','2',2,1,'HANNAH RORTVEDT','FI','537764323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:40',0,'2014-03-02 04:52:44'),(10580,10580,'2014-01-01','ET','2',1,NULL,'Sheldon Arnold','FI','452026650','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:34',0,'2014-03-02 04:24:47'),(7485,7485,'2014-01-01','ET','2',2,1,'Robert Merusi','FI','302660717','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:33:31',0,'2014-03-10 13:39:10'),(2716,2716,'2014-01-01','ET','2',1,NULL,'Amor Handy','FI','433611911','Starmount Life Insurance Company','FI','720977315','Percy  McCraney','94','9000490','348','2014-01-01','Sync Success',0,'2013-12-25 21:17:42',0,'2014-03-02 04:15:49'),(5612,5612,'2014-01-01','ET','2',1,NULL,'Sherri Seals','FI','297801288','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:03',0,'2014-03-01 16:23:43'),(2902,2902,'2014-01-01','ET','2',1,NULL,'Robert Carter','FI','299720634','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:03',0,'2014-03-10 13:24:34'),(3487,3487,'2014-01-01','ET','2',1,NULL,'Tiffany Myers','FI','272786254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:45',0,'2014-03-01 15:37:30'),(5147,5147,'2014-01-01','ET','2',1,NULL,'Christine M Smithnosky','FI','200407654','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:43',0,'2014-03-10 15:45:56'),(13691,14047,'2014-01-01','ET','2',2,1,'Vickie Null','FI','295584309','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:21:35',0,'2014-03-10 13:59:38'),(13743,14099,'2014-01-01','ET','2',1,NULL,'KIMBERLY DAWN COLE','FI','271725083','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:10',0,'2014-03-01 16:40:16'),(14152,14603,'2014-01-01','ET','2',1,NULL,'Walter Lafield','FI','438456667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:08',0,'2014-03-02 05:38:34'),(15210,15661,'0000-00-00','ET','2',1,NULL,'Thomas Murach','FI','292446842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:32',0,'2014-03-01 16:50:53'),(15558,16009,'0000-00-00','ET','2',3,2,'Eric Scott','FI','283806382','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:17',0,'2014-03-01 16:50:53'),(20145,20795,'0000-00-00','ET','2',2,1,'DENNIS KRANES','FI','293509483','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:51',0,'2014-03-10 16:38:05'),(21711,22361,'0000-00-00','ET','2',2,1,'ASHLEY GRIER','FI','452719638','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:47',0,'2014-03-04 21:27:16'),(21896,22546,'0000-00-00','ET','2',2,1,'Sandra Marie Cunningham','FI','450178928','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:41',0,'2014-03-05 22:27:33'),(14486,14937,'2014-01-01','ET','2',1,NULL,'COEL CARROLL','FI','439653691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:46',0,'2014-03-02 05:38:34'),(14555,15006,'2014-01-01','ET','2',1,NULL,'Jimmy Criswell','FI','627073440','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:21',0,'2014-03-02 05:45:37'),(16072,16721,'0000-00-00','ET','2',1,NULL,'RICHARD ALLEN PALLATT','FI','205445364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:57',0,'2014-03-01 16:56:22'),(16456,17106,'0000-00-00','ET','2',2,1,'Elizabeth Fragapane','FI','293569239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:10',0,'2014-03-01 17:00:58'),(17057,17707,'0000-00-00','ET','2',2,1,'Brandi Halladay','FI','645091342','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:33',0,'2014-03-02 06:24:38'),(17167,17817,'0000-00-00','ET','2',1,NULL,'Jason Weigand','FI','275849053','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:44',0,'2014-03-01 17:20:55'),(17225,17875,'0000-00-00','ET','2',1,NULL,'Gui Zhen Wu','FI','106968741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:18',0,'2014-03-01 17:20:55'),(17903,18553,'0000-00-00','ET','2',1,NULL,'Katondra Reddix','FI','433636400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:31',0,'2014-03-02 06:38:05'),(21553,22203,'0000-00-00','ET','2',1,NULL,'Michael K Martin','FI','587537361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:34',0,'2014-03-03 22:26:43'),(19201,19851,'0000-00-00','ET','2',1,NULL,'Calvin Day','FI','427135479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:07',0,'2014-03-02 06:52:12'),(19910,20560,'0000-00-00','ET','2',1,NULL,'Satiago Cobos','FI','450270185','Starmount Life Insurance Company','FI','720977315','Christopher  Wang','94','15980657','357','2014-03-31','Sync Success',0,'2014-02-21 21:30:11',0,'2014-03-02 07:03:25'),(20139,20789,'0000-00-00','ET','2',1,NULL,'Sharon Zornes','FI','288543094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:48',0,'2014-03-10 16:38:05'),(20934,21584,'0000-00-00','ET','2',1,NULL,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:00:26',0,'2014-03-10 16:38:05'),(438,438,'2014-01-01','ET','2',1,NULL,'JOSEPH TAYLOR','FI','587381460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:35',0,'2014-03-01 22:10:55'),(830,830,'2014-01-01','ET','2',1,NULL,'CALVIN JOSEPH FOX','FI','435275748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:02',0,'2014-03-01 21:11:04'),(11130,11130,'2014-01-01','ET','2',1,NULL,'Jamie Wilson','FI','272822473','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:15:12',0,'2014-03-10 13:45:57'),(924,924,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:51',0,'2014-03-10 13:10:24'),(11048,11048,'2014-01-01','ET','2',1,NULL,'Rita Estep','FI','268521717','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:23',0,'2014-03-10 16:03:49'),(10814,10814,'2014-01-01','ET','2',1,NULL,'Eden Liu','FI','245550888','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:19',0,'2014-03-02 04:31:46'),(7483,7483,'2014-01-01','ET','2',2,1,'Sheila Pfeiffer','FI','288786035','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-26 04:33:25',0,'2014-03-10 13:39:10'),(2301,2301,'2014-01-01','ET','2',2,1,'Shamsha Noorani','FI','338747506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:13',0,'2014-03-01 19:11:03'),(6417,6417,'2014-01-01','ET','2',1,NULL,'NANCY  HOLLOWAY','FI','438190633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:02',0,'2014-03-01 20:10:57'),(3495,3495,'2014-01-01','ET','2',1,NULL,'Susan Marshall','FI','281624191','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:02',0,'2014-03-01 15:37:30'),(4571,4571,'2014-01-01','ET','2',1,NULL,'carlo Buzzetta','FI','289825635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:22',0,'2014-03-01 16:15:39'),(12024,12024,'2014-01-01','ET','2',1,NULL,'Gail Hurst','FI','434881748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:59',0,'2014-03-02 04:59:36'),(13874,14230,'2014-01-01','ET','2',1,NULL,'john little','FI','587198740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:04',0,'2014-03-02 05:31:31'),(17004,17654,'0000-00-00','ET','2',2,1,'Ryan Hysell','FI','278865437','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:33',0,'2014-03-10 14:20:26'),(19071,19721,'0000-00-00','ET','2',1,NULL,'Danielle Derousselle','FI','437495228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:23',0,'2014-03-02 06:52:12'),(19142,19792,'0000-00-00','ET','2',1,NULL,'Gregory Rehs','FI','280644058','Summa Insurance Company, Inc.','FI','341809108','James  Finnegen','94','2766031','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:16',0,'2014-03-10 16:31:33'),(19303,19953,'0000-00-00','ET','2',1,NULL,'Viviana Rivera','FI','017580992','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','348','2014-04-01','Sync Success',0,'2014-02-18 21:30:21',0,'2014-03-10 14:37:47'),(20916,21566,'0000-00-00','ET','2',1,NULL,'Elizabeth Jacob','FI','269563461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:10',0,'2014-03-01 18:08:07'),(20082,20732,'0000-00-00','ET','2',1,NULL,'DEBBIE VILLAVASSO','FI','437512579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:04',0,'2014-03-02 07:10:28'),(20308,20958,'0000-00-00','ET','2',1,NULL,'William Sobieck','FI','282524315','HealthSpan','FI','311431434','Kenneth  Keller','94','1482906','357','2014-03-31','Sync Success',0,'2014-02-26 08:00:47',0,'2014-03-10 14:37:47'),(21688,22338,'0000-00-00','ET','2',1,NULL,'Valli F Kirkbride','FI','290526103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:28',0,'2014-03-04 21:36:30'),(22040,22690,'0000-00-00','ET','2',1,NULL,'Katie Mullins','FI','278523139','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:21',0,'2014-03-10 16:44:18'),(22354,23004,'0000-00-00','ET','2',1,NULL,'Nancy N Muraya','FI','419538001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:13',0,'2014-03-07 21:36:32'),(657,657,'2014-01-01','ET','2',1,NULL,'Bilindra Robinson','FI','454491889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:05:26',0,'2014-03-02 02:10:49'),(1565,1565,'2014-01-01','ET','2',1,NULL,'Brian Miller','FI','284848642','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:06',0,'2014-03-01 15:10:22'),(7635,7635,'2014-01-01','ET','2',1,NULL,'Charles Willman','FI','326484567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:22',0,'2014-03-02 04:15:49'),(7463,7463,'2014-01-01','ET','2',1,NULL,'Hector Ramirez','FI','642263869','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','348','2014-01-01','Sync Success',0,'2013-12-26 04:32:46',0,'2014-03-02 04:15:49'),(11634,11634,'2014-01-01','ET','2',1,NULL,'NORMAN BENTLEY','FI','403766085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:47',0,'2014-03-02 04:52:44'),(11527,11527,'2014-01-01','ET','2',1,NULL,'Gerald Huey Jacobs','FI','438393645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:28',0,'2014-03-02 04:52:44'),(7198,7198,'2014-01-01','ET','2',1,NULL,'TERRI ANN STEERS','FI','455111784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:34',0,'2014-03-02 03:09:49'),(5913,5913,'2014-01-01','ET','2',1,NULL,'SHAWNDA KIMMONS','FI','287701964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:12',0,'2014-03-01 15:48:04'),(2298,2298,'2014-01-01','ET','2',2,1,'KENNY  WOLFORD','FI','304663855','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:06',0,'2014-03-01 15:10:22'),(5510,5510,'2014-01-01','ET','2',1,NULL,'Nomphumelelo Mikela Enoch-Mtetwa','FI','219418286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:45',0,'2014-03-01 16:23:43'),(4545,4545,'2014-01-01','ET','2',2,1,'Baylor Looper Jewell','FI','435907159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:30',0,'2014-03-02 04:31:46'),(4648,4648,'2014-01-01','ET','2',2,1,'lawrence Mageto','FI','457439417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:49',0,'2014-03-02 04:38:08'),(12455,12455,'2014-01-01','ET','2',1,NULL,'Terrie Lee Shaheen','FI','269605350','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:31:42',0,'2014-03-10 16:10:34'),(12620,12620,'2014-01-01','ET','2',1,NULL,'Yvonne Quijas','FI','547490277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:48',0,'2014-03-02 05:10:52'),(18151,18801,'0000-00-00','ET','2',1,NULL,'Tommy a Slocum','FI','434575266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:16',0,'2014-03-02 06:38:05'),(21258,21908,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:35',0,'2014-03-01 21:35:40'),(22306,22956,'0000-00-00','ET','2',1,NULL,'Folser Ollie','FI','426027952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:30:03',0,'2014-03-06 22:25:29'),(18691,19341,'0000-00-00','ET','2',4,3,'PRISCA GONZALAS','FI','456938356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:44',0,'2014-03-02 06:45:14'),(18991,19641,'0000-00-00','ET','2',1,NULL,'NORMAN IRWIN','FI','295847993','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:07',0,'2014-03-10 14:31:05'),(19731,20381,'0000-00-00','ET','2',2,1,'Robert Kontout','FI','042460933','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 05:37:12',0,'2014-03-01 17:47:19'),(19847,20497,'0000-00-00','ET','2',1,NULL,'ardella buster','FI','452886806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:01',0,'2014-03-02 07:03:25'),(20017,20667,'0000-00-00','ET','2',1,NULL,'Bruce Bonheimer','FI','292588806','Summa Insurance Company, Inc.','FI','341809108','lINDA   epperly','94','8798849','348','2014-04-01','Sync Success',0,'2014-02-21 22:01:04',0,'2014-03-10 16:38:05'),(20265,20915,'0000-00-00','ET','2',1,NULL,'Andrew Toth','FI','288909284','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:13',0,'2014-03-01 17:47:19'),(1384,1384,'2014-01-01','ET','2',1,NULL,'CARMELO J PEREZ','FI','452710576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:31',0,'2014-03-02 04:45:37'),(11409,11409,'2014-01-01','ET','2',1,NULL,'FRANCINE SHANNON','FI','384748738','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:52',0,'2014-03-10 13:52:32'),(1858,1858,'2014-01-01','ET','2',2,1,'Robert Hater','FI','301901622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:28',0,'2014-03-01 15:26:40'),(1915,1915,'2014-01-01','ET','2',1,NULL,'Axel De La Vega','FI','637101976','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:11',0,'2014-03-01 23:10:52'),(7517,7517,'2014-01-01','ET','2',1,NULL,'Gary Davis','FI','279507225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:36',0,'2014-03-01 16:05:34'),(5790,5790,'2014-01-01','ET','2',1,NULL,'CAROL EMERUWA','FI','269544250','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:03:14',0,'2014-03-10 15:52:36'),(4631,4631,'2014-01-01','ET','2',1,NULL,'Griselda Rodriguez','FI','627264548','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:18',0,'2014-03-02 04:31:46'),(3143,3143,'2014-01-01','ET','2',1,NULL,'Lisa Berryman','FI','271468887','HealthSpan','FI','311431434','Andy  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 21:37:30',0,'2014-03-10 13:24:34'),(3442,3442,'2014-01-01','ET','2',1,NULL,'DEBRA RAMEY','FI','270709350','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-01-01','Sync Success',0,'2013-12-25 21:53:04',0,'2014-03-10 13:24:34'),(13990,14346,'2014-01-01','ET','2',1,NULL,'Adam Bernard','FI','433511682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:22',0,'2014-03-02 05:31:31'),(17505,18155,'0000-00-00','ET','2',1,NULL,'Peggy Collins','FI','457042942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:04',0,'2014-03-02 06:31:45'),(19653,20304,'0000-00-00','ET','2',5,4,'MAURA KENNEDY ANAYA','FI','251843487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:44:08',0,'2014-03-01 17:47:19'),(19866,20516,'0000-00-00','ET','2',1,NULL,'Robin Burnette','FI','281944970','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:17',0,'2014-03-01 17:47:19'),(540,540,'2014-01-01','ET','2',1,NULL,'James Sheard','FI','294527137','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:42',0,'2014-03-01 15:48:04'),(3324,3324,'2014-01-01','ET','2',1,NULL,'Suzanne Lynn  Kim','FI','003502713','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:49:20',0,'2014-03-10 15:52:36'),(4649,4649,'2014-01-01','ET','2',1,NULL,'Andrew Okokhere','FI','458535959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:52',0,'2014-03-02 04:38:08'),(4861,4861,'2014-01-01','ET','2',2,1,'john hornecker','FI','573956150','Starmount Life Insurance Company','FI','720977315','Jack C Martin','94','1204655','348','2014-01-01','Sync Success',0,'2013-12-26 00:15:57',0,'2014-03-01 20:10:57'),(7028,7028,'2014-01-01','ET','2',1,NULL,'Wilmer Robinson','FI','450884991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:21',0,'2014-03-02 03:09:49'),(5535,5535,'2014-01-01','ET','2',2,1,'Robin Rosholt','94','0000647078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:33',0,'2014-03-01 16:23:43'),(13754,14110,'2014-01-01','ET','2',1,NULL,'Amy Shaw','FI','455975222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:17',0,'2014-03-02 05:24:45'),(14044,14495,'2014-01-01','ET','2',2,1,'Nora Marshall','FI','269602017','Dental Care Plus, Inc.','FI','311185262','Mike  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-14 01:31:58',0,'2014-03-01 16:40:16'),(15688,16337,'0000-00-00','ET','2',2,1,'Rickey Newsome','FI','427088141','Starmount Life Insurance Company','FI','720977315','Kathy  Canlas','94','7407489','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:40',0,'2014-03-02 05:59:43'),(15983,16632,'0000-00-00','ET','2',1,NULL,'Johnathon Meier','FI','272982795','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:27',0,'2014-03-10 14:20:26'),(17183,17833,'0000-00-00','ET','2',1,NULL,'Terry Anderson','FI','284706196','HealthSpan','FI','311431434','Maribeth  Zaferopolos','94','16354316','357','2014-03-01','Sync Success',0,'2014-02-04 21:01:56',0,'2014-03-10 14:24:38'),(17582,18232,'0000-00-00','ET','2',1,NULL,'Vicky Campbell','FI','466274533','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:58',0,'2014-03-02 06:31:45'),(19309,19959,'0000-00-00','ET','2',1,NULL,'Karina Leon','FI','633947066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:03',0,'2014-03-02 06:59:07'),(21024,21674,'0000-00-00','ET','2',4,3,'Kristen Grande','FI','280841299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:00:17',0,'2014-03-01 18:10:11'),(22715,23365,'0000-00-00','ET','2',1,NULL,'LYNN FRAZEE','FI','272564271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:09',0,'2014-03-10 16:44:18'),(478,478,'2014-01-01','ET','2',1,NULL,'Joelle May','FI','290740752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:57',0,'2014-03-10 13:10:24'),(1613,1613,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:32',0,'2014-03-01 20:10:57'),(4726,4726,'2014-01-01','ET','2',1,NULL,'Cal Oatis','FI','425022189','Starmount Life Insurance Company','FI','720977315','Wayne Colby Moore Jr','94','17097315','348','2014-01-01','Sync Success',0,'2013-12-25 23:51:35',0,'2014-03-02 04:31:46'),(1747,1747,'2014-01-01','ET','2',2,1,'DANNY LEE DOWNING','FI','302521509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:53',0,'2014-03-01 15:31:33'),(13860,14216,'2014-01-01','ET','2',1,NULL,'Erik Saunders Wahl','FI','044849242','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:54',0,'2014-03-02 05:31:31'),(14008,14364,'2014-01-01','ET','2',2,1,'George w Warden','FI','273560661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:36',0,'2014-03-01 16:40:16'),(14902,15353,'2014-01-01','ET','2',1,NULL,'ALLISON HAGEN','FI','485047840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:25',0,'2014-03-02 05:52:31'),(15355,15806,'0000-00-00','ET','2',1,NULL,'STEVEN ELMER','FI','292602695','HealthSpan','FI','311431434','JOSEPH  T HESSLING','94','7320983','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:52',0,'2014-03-10 14:10:12'),(15998,16647,'0000-00-00','ET','2',1,NULL,'BOBBY HOLMES','FI','451022950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:00:09',0,'2014-03-02 06:03:21'),(19668,20318,'0000-00-00','ET','2',2,1,'APRIL MCGOWAN','FI','289905832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:47:37',0,'2014-03-01 17:47:19'),(21031,21681,'0000-00-00','ET','2',4,3,'Keith Dietrich','FI','298720882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:00:22',0,'2014-03-10 14:45:25'),(21200,21850,'0000-00-00','ET','2',1,NULL,'TERESA JAVIER','FI','733182080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-01 19:00:03',0,'2014-03-02 07:23:39'),(22523,23173,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:28',0,'2014-03-07 21:36:32'),(22907,23557,'0000-00-00','ET','2',1,NULL,'Daniel Hart','FI','434553881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:46',0,'2014-03-10 21:27:11'),(2254,2254,'2014-01-01','ET','2',1,NULL,'Abigail Bender','FI','296803345','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:03',0,'2014-03-10 13:10:24'),(11807,11807,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:13:17',0,'2014-03-01 16:15:39'),(11804,11804,'2014-01-01','ET','2',1,NULL,'Jessica Thomas','FI','288905063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:13',0,'2014-03-01 16:15:39'),(11400,11400,'2014-01-01','ET','2',1,NULL,'DIANA SHARPLES','FI','278664401','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:34',0,'2014-03-10 16:03:49'),(3003,3003,'2014-01-01','ET','2',1,NULL,'Davella Millsap','FI','466020635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:12',0,'2014-03-02 01:10:33'),(11017,11017,'2014-01-01','ET','2',1,NULL,'Randall Skolnik','FI','435023293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:23',0,'2014-03-02 04:31:46'),(3122,3122,'2014-01-01','ET','2',3,2,'Gail Pavliga','94','0001114511','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:50',0,'2014-03-10 15:52:36'),(4849,4849,'2014-01-01','ET','2',1,NULL,'Grant Goeters','FI','388762714','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:35',0,'2014-03-10 15:39:19'),(6437,6437,'2014-01-01','ET','2',1,NULL,'Samantha Borkovic','FI','172702741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:38',0,'2014-03-01 15:10:22'),(10908,10908,'2014-01-01','ET','2',1,NULL,'Kathy Marie McConnell','FI','462697819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:54',0,'2014-03-02 04:31:46'),(14166,14617,'2014-01-01','ET','2',2,1,'Patrick Babcock','FI','268907834','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:18',0,'2014-03-10 16:17:47'),(15894,16543,'0000-00-00','ET','2',1,NULL,'Susan Rainwater','FI','438967018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:01:08',0,'2014-03-02 06:03:21'),(15288,15739,'0000-00-00','ET','2',1,NULL,'BEATRIZ C MORALES','FI','541259890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:11',0,'2014-03-02 05:52:31'),(1403,1403,'2014-01-01','ET','2',1,NULL,'Donald F Parker','FI','421701272','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:10',0,'2014-03-02 04:38:08'),(20939,21589,'0000-00-00','ET','2',3,2,'Naz Older','FI','284888626','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:30',0,'2014-03-10 16:38:05'),(19430,20080,'0000-00-00','ET','2',1,NULL,'Jose Hurtado','FI','629109487','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:31',0,'2014-03-02 06:59:07'),(17327,17977,'0000-00-00','ET','2',1,NULL,'gloria sharp','FI','294560505','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:09',0,'2014-03-10 16:24:30'),(7037,7037,'2014-01-01','ET','2',1,NULL,'Salomon  Garrett Perez','FI','629261549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:41',0,'2014-03-02 03:09:49'),(6240,6240,'2014-01-01','ET','2',2,1,'Bonnie Brown','FI','278643030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:36',0,'2014-03-10 13:39:10'),(2700,2700,'2014-01-01','ET','2',1,NULL,'Holly Nicole Green-Parks','FI','464856498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:13',0,'2014-03-02 04:15:49'),(14591,15042,'2014-01-01','ET','2',1,NULL,'MARGARET DUSZIK','FI','639282614','Starmount Life Insurance Company','FI','720977315','WALLACE   FOX','94','9894772','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:44',0,'2014-03-02 05:45:37'),(4796,4796,'2014-01-01','ET','2',1,NULL,'Adam Weslek','FI','285805798','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:46',0,'2014-03-01 15:16:37'),(4480,4480,'2014-01-01','ET','2',2,1,'natividad pinon','FI','451953077','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:24',0,'2014-03-01 21:11:04'),(14153,14604,'2014-01-01','ET','2',1,NULL,'Charlotte Friedley','FI','260922523','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:09',0,'2014-03-02 05:38:34'),(22729,23379,'0000-00-00','ET','2',1,NULL,'Sharon Shafer','FI','288447017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:20',0,'2014-03-10 14:50:59'),(11303,11303,'2014-01-01','ET','2',1,NULL,'Joel Orsini','FI','451653270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:37',0,'2014-03-02 04:45:37'),(13000,13000,'2014-01-01','ET','2',1,NULL,'javaughn Jackson','FI','274942794','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:06',0,'2014-03-10 16:10:34'),(23034,23684,'0000-00-00','ET','2',1,NULL,'Mathew Crego','FI','298564762','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:16',0,'2014-03-10 21:17:52'),(807,807,'2014-01-01','ET','2',1,NULL,'Paul Egli','FI','482929244','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:28',0,'2014-03-10 13:03:33'),(1302,1302,'2014-01-01','ET','2',1,NULL,'Dianna Lacayo','FI','587869057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:52',0,'2014-03-02 04:45:37'),(6184,6184,'2014-01-01','ET','2',1,NULL,'ELIDA HERNANDEZ','FI','467947712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:49',0,'2014-03-02 04:10:25'),(18060,18710,'0000-00-00','ET','2',1,NULL,'hung le','FI','570758614','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:07',0,'2014-03-02 06:38:05'),(15376,15827,'0000-00-00','ET','2',1,NULL,'Jonathon Hooge','FI','437690191','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:54',0,'2014-03-02 05:59:43'),(4358,4358,'2014-01-01','ET','2',1,NULL,'Charlene Malicki','FI','276543692','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:02',0,'2014-03-10 13:32:15'),(13997,14353,'2014-01-01','ET','2',1,NULL,'Caitlin Anne Olenik','FI','285905948','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:28',0,'2014-03-10 16:17:47'),(21779,22429,'0000-00-00','ET','2',2,1,'William Peterson','FI','292707311','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:45',0,'2014-03-10 14:45:25'),(21840,22490,'0000-00-00','ET','2',1,NULL,'OLGA  MARINA  PORTILLO','FI','461955407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:30',0,'2014-03-05 21:25:24'),(20978,21628,'0000-00-00','ET','2',1,NULL,'yara habli','94','0000115550','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:24',0,'2014-03-01 18:10:11'),(2979,2979,'2014-01-01','ET','2',1,NULL,'Abraham Dershe','FI','375294706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:31',0,'2014-03-02 01:10:33'),(19203,19853,'0000-00-00','ET','2',1,NULL,'Karen Butler','FI','295549466','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:09',0,'2014-03-10 14:31:05'),(5048,5048,'2014-01-01','ET','2',1,NULL,'Diana  Wingate','FI','270564368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:30',0,'2014-03-01 15:31:33'),(5574,5574,'2014-01-01','ET','2',1,NULL,'James Escamia','FI','644037225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:48',0,'2014-03-02 04:45:37'),(5830,5830,'2014-01-01','ET','2',1,NULL,'Marquis Knight','FI','426514406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:25',0,'2014-03-01 20:10:57'),(17267,17917,'0000-00-00','ET','2',2,1,'Sadiq Sadruddin','FI','456735734','Starmount Life Insurance Company','FI','720977315','Gilberto  Lopez','94','16945680','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:39',0,'2014-03-02 06:24:38'),(12838,12838,'2014-01-01','ET','2',1,NULL,'xaicha lewis-green','FI','338880545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:02:38',0,'2014-03-02 05:17:40'),(13458,13814,'2014-01-01','ET','2',1,NULL,'Cindy Schomburg','FI','391664856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:25',0,'2014-03-02 05:31:31'),(16410,17060,'0000-00-00','ET','2',2,1,'Dolly Moffat','FI','269605250','Summa Insurance Company, Inc.','FI','341809108','Eric  Vought','94','16465976','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:33',0,'2014-03-10 16:24:30'),(21452,22102,'0000-00-00','ET','2',4,3,'Tina White','FI','290661842','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:20',0,'2014-03-10 16:44:18'),(16656,17306,'0000-00-00','ET','2',1,NULL,'JO ANN DONLEY','FI','236769532','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:45',0,'2014-03-10 16:24:30'),(16234,16883,'0000-00-00','ET','2',1,NULL,'Connie Conway','FI','313580636','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:01',0,'2014-03-10 14:20:26'),(2571,2571,'2014-01-01','ET','2',1,NULL,'mary wheeler','FI','283582805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:03',0,'2014-03-01 15:05:09'),(6397,6397,'2014-01-01','ET','2',1,NULL,'johanna arnold','FI','128540738','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:23',0,'2014-03-10 13:39:10'),(12123,12123,'2014-01-01','ET','2',2,1,'JAMES  WILLIAM DARBY','FI','161449734','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:32',0,'2014-03-01 16:30:17'),(3526,3526,'2014-01-01','ET','2',1,NULL,'Debora Moltz','FI','268649217','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:01',0,'2014-03-01 15:31:33'),(4314,4314,'2014-01-01','ET','2',1,NULL,'Frank Porrazzo','FI','436826889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:41',0,'2014-03-02 03:09:49'),(12120,12120,'2014-01-01','ET','2',1,NULL,'TIMOTHY T TAYLOR','FI','283906938','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:24',0,'2014-03-01 16:30:17'),(11773,11773,'2014-01-01','ET','2',1,NULL,'Sharon Wallis','FI','288660310','HealthSpan','FI','311431434','sheri  dibacco','94','16808985','348','2014-02-01','Sync Success',1,'2013-12-29 11:10:07',0,'2014-03-10 13:52:32'),(656,656,'2014-01-01','ET','2',1,NULL,'Melissa Williams','FI','467518683','Starmount Life Insurance Company','FI','720977315','Glenda  Jefferies','94','1325264','348','2014-01-01','Sync Success',0,'2013-12-25 18:05:24',0,'2014-03-02 02:10:49'),(767,767,'2014-01-01','ET','2',1,NULL,'Elizabeth LoGrande','FI','299763643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:56',0,'2014-03-01 15:05:09'),(22142,22792,'0000-00-00','ET','2',1,NULL,'DWANDA JONES','FI','435170692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:59',0,'2014-03-06 21:27:26'),(2439,2439,'2014-01-01','ET','2',1,NULL,'Kathleen Gant','FI','288721534','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:27',0,'2014-03-10 13:10:24'),(21650,22300,'0000-00-00','ET','2',2,1,'JEROME LEWIS','FI','300562598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:59',0,'2014-03-04 21:36:30'),(20685,21335,'0000-00-00','ET','2',1,NULL,'Kelotta Holiday','FI','439491579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:30:05',0,'2014-03-02 07:17:36'),(12979,12979,'2014-01-01','ET','2',1,NULL,'kathleen williams','FI','456250866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:24',0,'2014-03-02 05:17:40'),(20651,21301,'0000-00-00','ET','2',1,NULL,'theodore  g burkey','FI','288560417','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:26',0,'2014-03-10 16:38:05'),(20604,21254,'0000-00-00','ET','2',2,1,'Jennifer L Cook','FI','297726645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:51',0,'2014-03-01 18:08:07'),(19943,20593,'0000-00-00','ET','2',1,NULL,'JUDITH EDMUNDS','FI','492706281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:09',0,'2014-03-02 07:03:25'),(16602,17252,'0000-00-00','ET','2',1,NULL,'Adelfa Acobo','FI','720892339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:08',0,'2014-03-02 06:17:30'),(17085,17735,'0000-00-00','ET','2',1,NULL,'Robin Brintnall James','FI','369585909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-04 21:00:51',0,'2014-03-01 17:00:58'),(18524,19174,'0000-00-00','ET','2',1,NULL,'Mei Wong','FI','369902218','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:28',0,'2014-03-10 14:31:05'),(19550,20200,'0000-00-00','ET','2',1,NULL,'Jesse Scott','FI','437136504','Starmount Life Insurance Company','FI','720977315','Michael  Essex','94','17133170','348','2014-04-01','Sync Success',0,'2014-02-20 04:18:17',0,'2014-03-02 06:59:07'),(19394,20044,'0000-00-00','ET','2',1,NULL,'MICHAEL W BYRUM','FI','292827046','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:04',0,'2014-03-01 17:34:07'),(1027,1027,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:21:06',0,'2014-03-10 13:10:24'),(20225,20875,'0000-00-00','ET','2',1,NULL,'Joanna Smith','FI','298549765','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:50',0,'2014-03-10 14:37:47'),(17658,18308,'0000-00-00','ET','2',2,1,'Francis Weaver','FI','299809417','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:40',0,'2014-03-10 14:24:38'),(17137,17787,'0000-00-00','ET','2',1,NULL,'Jesse Thompson','FI','212889347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:23',0,'2014-03-02 06:24:38'),(17032,17682,'0000-00-00','ET','2',1,NULL,'Shannon Bryant','FI','433839877','Starmount Life Insurance Company','FI','720977315','Karen Ferguson Bruyninckx','94','4762708','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:19',0,'2014-03-02 06:24:38'),(16815,17465,'0000-00-00','ET','2',1,NULL,'gelila haileselassie','FI','212736059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-02 19:00:03',0,'2014-03-02 06:17:30'),(4938,4938,'2014-01-01','ET','2',1,NULL,'DEBORAH MARSHELLE TORRES','FI','284625294','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:24',0,'2014-03-01 15:10:22'),(5166,5166,'2014-01-01','ET','2',2,1,'Leah Rexford','FI','302783444','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:16',0,'2014-03-10 13:20:27'),(11563,11563,'2014-01-01','ET','2',2,1,'ANA M ACEVEDO','FI','450134365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:36',0,'2014-03-02 04:52:44'),(16150,16799,'0000-00-00','ET','2',1,NULL,'VICKI FEAZELL','FI','587063330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:07',0,'2014-03-02 06:10:30'),(15333,15784,'0000-00-00','ET','2',1,NULL,'Susan Calaway','FI','293520285','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:38',0,'2014-03-10 16:17:47'),(22229,22879,'0000-00-00','ET','2',1,NULL,'ELLEN LERNER','FI','090466524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:01',0,'2014-03-06 21:27:26'),(14404,14855,'2014-01-01','ET','2',1,NULL,'Beth Kilbane','FI','175668667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:08',0,'2014-03-01 16:46:19'),(14212,14663,'2014-01-01','ET','2',2,1,'Lisa Vodney','FI','284663313','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:48',0,'2014-03-10 16:17:47'),(4977,4977,'2014-01-01','ET','2',1,NULL,'Christopher Hanna','FI','284823388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:16',0,'2014-03-01 15:31:33'),(7479,7479,'2014-01-01','ET','2',1,NULL,'Justin Thomas','FI','466653157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:16',0,'2014-03-02 04:15:49'),(291,291,'2014-01-01','ET','2',1,NULL,'david baney','FI','284621335','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:22',0,'2014-03-10 13:03:33'),(1435,1435,'2014-01-01','ET','2',1,NULL,'David Myers','FI','288546271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:12',0,'2014-03-01 16:15:39'),(5862,5862,'2014-01-01','ET','2',2,1,'Suzanne Elyssia Cadena','FI','626260408','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:37',0,'2014-03-01 19:11:03'),(1767,1767,'2014-01-01','ET','2',1,NULL,'WILLIO LACOMME','FI','770038507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:31',0,'2014-03-10 13:20:27'),(4560,4560,'2014-01-01','ET','2',1,NULL,'Ava Smith','FI','435905027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:02',0,'2014-03-02 04:38:08'),(21604,22254,'0000-00-00','ET','2',2,1,'SHERLAY WHITE','FI','420927863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:23',0,'2014-03-04 21:27:16'),(2749,2749,'2014-01-01','ET','2',1,NULL,'Patricia Ortiz','FI','557049685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:18:43',0,'2014-03-02 04:15:49'),(20997,21647,'0000-00-00','ET','2',2,1,'julio alberto pardillo','FI','591167766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:37',0,'2014-03-02 07:17:36'),(12362,12362,'2014-01-01','ET','2',1,NULL,'crystal patterson','FI','451510941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:17',0,'2014-03-02 05:03:29'),(20686,21336,'0000-00-00','ET','2',1,NULL,'Crandall White','FI','433434606','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:05',0,'2014-03-02 07:17:36'),(19757,20407,'0000-00-00','ET','2',1,NULL,'GLENN BOWERS','FI','296428644','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:11',0,'2014-03-10 16:38:05'),(14674,15125,'2014-01-01','ET','2',1,NULL,'Brenda Sue Caley','FI','278509697','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:36',0,'2014-03-01 16:46:19'),(14784,15235,'2014-01-01','ET','2',1,NULL,'Jimmy Lee Wilson','FI','426670839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:47',0,'2014-03-02 05:45:37'),(1538,1538,'2014-01-01','ET','2',1,NULL,'jermaine may','FI','286723406','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:33',0,'2014-03-10 13:52:32'),(10420,10420,'2014-01-01','ET','2',1,NULL,'Emmanuel Catacutan','94','0000016612','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:20',0,'2014-03-01 16:10:36'),(5886,5886,'2014-01-01','ET','2',2,1,'MARCIA  WAGNER','FI','277745372','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:18',0,'2014-03-10 15:52:36'),(20505,21155,'0000-00-00','ET','2',1,NULL,'Denise Moore','FI','439080143','Starmount Life Insurance Company','FI','720977315','John  Allen','94','4728680','348','2014-04-01','Sync Success',0,'2014-02-26 21:00:46',0,'2014-03-02 07:10:28'),(22632,23282,'0000-00-00','ET','2',1,NULL,'Seth Glasgow','FI','293886232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:06',0,'2014-03-08 21:35:36'),(19011,19661,'0000-00-00','ET','2',1,NULL,'Brenda Thompson','FI','295369055','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:23',0,'2014-03-10 14:31:05'),(11588,11588,'2014-01-01','ET','2',2,1,'sadiq farishta','FI','345823918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:21',0,'2014-03-02 04:59:36'),(13478,13834,'2014-01-01','ET','2',1,NULL,'GLENN OLIVER','FI','276607016','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:38',0,'2014-03-10 14:03:26'),(1146,1146,'2014-01-01','ET','2',1,NULL,'Deanna Bernard','FI','436965267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:05',0,'2014-03-02 04:38:08'),(11467,11467,'2014-01-01','ET','2',1,NULL,'KELLY TITTLE','FI','288885695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:30:40',0,'2014-03-01 16:30:17'),(11118,11118,'2014-01-01','ET','2',5,4,'Rocco Poshedley','FI','290624439','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:43',0,'2014-03-10 13:39:10'),(10640,10640,'2014-01-01','ET','2',1,NULL,'Israel Alvarez','FI','465656110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:30',0,'2014-03-02 04:31:46'),(22155,22805,'0000-00-00','ET','2',2,1,'Robert Earhart','FI','285804583','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:07',0,'2014-03-06 21:36:23'),(19742,20392,'0000-00-00','ET','2',1,NULL,'maria olvera','FI','290508889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:02',0,'2014-03-02 06:59:07'),(7558,7558,'2014-01-01','ET','2',2,1,'Cheryl Hayes','FI','271703116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:53',0,'2014-03-01 16:05:34'),(7325,7325,'2014-01-01','ET','2',1,NULL,'Jerry Barlow','FI','301547929','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:29',0,'2014-03-10 13:32:15'),(1875,1875,'2014-01-01','ET','2',4,3,'John Isenbarger','FI','269821132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:03',0,'2014-03-01 15:31:33'),(4109,4109,'2014-01-01','ET','2',4,3,'Michael Truong','FI','298780493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:28',0,'2014-03-01 16:00:27'),(11904,11904,'2014-01-01','ET','2',1,NULL,'SHILPA PATEL','FI','274179638','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:09',0,'2014-03-01 16:30:17'),(15452,15903,'0000-00-00','ET','2',1,NULL,'Michael Birchfield','FI','453356782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:43',0,'2014-03-02 05:59:43'),(11837,11837,'2014-01-01','ET','2',1,NULL,'ASHLEY HOPPER RIZO','FI','642186609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:16',0,'2014-03-02 04:31:46'),(22441,23091,'0000-00-00','ET','2',1,NULL,'Ahmad Osman','FI','875435063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:29',0,'2014-03-07 22:26:59'),(22847,23497,'0000-00-00','ET','2',1,NULL,'michael harris','FI','461064935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:01',0,'2014-03-10 21:27:11'),(20709,21359,'0000-00-00','ET','2',1,NULL,'Cara Cox','FI','291609528','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:16',0,'2014-03-01 18:08:07'),(15036,15487,'2014-01-01','ET','2',1,NULL,'LATANYA BRITTON','FI','436352540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:25',0,'2014-03-02 05:52:31'),(17778,18428,'0000-00-00','ET','2',1,NULL,'Daniel Stewart','FI','460791463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:15',0,'2014-03-02 06:03:21'),(16136,16785,'0000-00-00','ET','2',1,NULL,'David Jones','FI','281829789','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:46',0,'2014-03-10 14:20:26'),(22518,23168,'0000-00-00','ET','2',1,NULL,'LATANYA BRITTON','FI','436352540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:23',0,'2014-03-07 22:26:59'),(1216,1216,'2014-01-01','ET','2',1,NULL,'juan subuyuj','FI','602641668','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:15',0,'2014-03-01 16:15:39'),(20188,20838,'0000-00-00','ET','2',1,NULL,'rose escovedo','FI','461798389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:22',0,'2014-03-02 07:10:28'),(19727,20377,'0000-00-00','ET','2',1,NULL,'Scott Johnson','FI','590481299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:35:39',0,'2014-03-01 17:47:19'),(2591,2591,'2014-01-01','ET','2',1,NULL,'Russell Groves','FI','459954508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:42',0,'2014-03-01 19:11:03'),(6063,6063,'2014-01-01','ET','2',1,NULL,'Willie Sullivan','FI','259359299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:08',0,'2014-03-02 04:10:25'),(4410,4410,'2014-01-01','ET','2',1,NULL,'Carl John Triola','FI','294564485','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:16',0,'2014-03-10 15:39:19'),(5408,5408,'2014-01-01','ET','2',1,NULL,'brianna johnson','FI','409674283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:32',0,'2014-03-01 20:10:57'),(19485,20135,'0000-00-00','ET','2',2,1,'RAFAEL MECINAS MESTAS','FI','620280605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:59:55',0,'2014-03-02 06:59:07'),(19040,19690,'0000-00-00','ET','2',1,NULL,'Tress Turner','FI','439378400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:12',0,'2014-03-02 06:52:12'),(22579,23229,'0000-00-00','ET','2',1,NULL,'Michele Elizabeth Toups','FI','433191494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:07',0,'2014-03-07 22:26:59'),(13596,13952,'2014-01-01','ET','2',1,NULL,'Ashley Corso','FI','641051335','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:22',0,'2014-03-02 05:31:31'),(18059,18709,'0000-00-00','ET','2',1,NULL,'Abigail Vidal','FI','638031763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:06',0,'2014-03-02 06:38:05'),(19765,20415,'0000-00-00','ET','2',1,NULL,'stacy L hathcox','FI','428115613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:16',0,'2014-03-02 07:03:25'),(21722,22372,'0000-00-00','ET','2',3,2,'Russell Davis Andrews','FI','260024244','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:57',0,'2014-03-10 16:44:18'),(4348,4348,'2014-01-01','ET','2',1,NULL,'david baney','FI','284621335','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:10:44',0,'2014-03-10 13:32:15'),(10811,10811,'2014-01-01','ET','2',1,NULL,'John Daigle','FI','439231294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:13',0,'2014-03-02 04:24:47'),(17500,18150,'0000-00-00','ET','2',2,1,'Analena Beate Bruce','FI','122662102','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:30:03',0,'2014-03-10 14:24:38'),(15878,16527,'0000-00-00','ET','2',1,NULL,'mary musil','94','0000968210','Summa Insurance Company, Inc.','FI','341809108','karen  cavasini','94','1800246','357','2014-01-01','Sync Success',0,'2014-01-24 21:00:58',0,'2014-03-10 16:24:30'),(7031,7031,'2014-01-01','ET','2',1,NULL,'HATTIE D NWEKE','FI','449752178','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:28',0,'2014-03-02 03:09:49'),(12213,12213,'2014-01-01','ET','2',1,NULL,'William James Barlow','FI','281487772','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:58',0,'2014-03-01 16:35:14'),(13529,13885,'2014-01-01','ET','2',1,NULL,'Nicholas Kramer','FI','294865729','Dental Care Plus, Inc.','FI','311185262','John  Curry','94','10751792','357','2014-02-01','Sync Success',0,'2014-01-13 02:19:36',0,'2014-03-01 16:40:16'),(22634,23284,'0000-00-00','ET','2',1,NULL,'Danielle Kolesar','FI','294849212','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2014-03-08 21:30:08',0,'2014-03-08 21:35:36'),(20636,21286,'0000-00-00','ET','2',1,NULL,'JOSE L TORRES','FI','453992231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:14',0,'2014-03-02 07:10:28'),(12636,12636,'2014-01-01','ET','2',2,1,'Akeen T Folse','FI','433274840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:21',0,'2014-03-02 05:10:52'),(19241,19891,'0000-00-00','ET','2',1,NULL,'Carla James','FI','437359903','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:32',0,'2014-03-01 17:34:07'),(7708,7708,'2014-01-01','ET','2',1,NULL,'michael nagy','FI','232085468','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 04:45:45',0,'2014-03-10 13:03:33'),(7507,7507,'2014-01-01','ET','2',1,NULL,'matt kochersperger','FI','285785071','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:16',0,'2014-03-01 16:05:34'),(14980,15431,'2014-01-01','ET','2',1,NULL,'narain singh thind','FI','059764062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:02',0,'2014-03-01 16:50:53'),(14414,14865,'2014-01-01','ET','2',1,NULL,'ALFRETTA  BURTON','FI','587415774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:13',0,'2014-03-02 05:38:34'),(13322,13678,'2014-01-01','ET','2',1,NULL,'MONCORIA LA SHAY TERRELL','FI','426634065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:20',0,'2014-03-02 05:24:45'),(1072,1072,'2014-01-01','ET','2',1,NULL,'Joseph Vanwie','FI','398084151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:31:00',0,'2014-03-01 21:11:04'),(12862,12862,'2014-01-01','ET','2',1,NULL,'linda Vetturini','FI','289783951','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:30',0,'2014-03-01 16:35:14'),(12820,12820,'2014-01-01','ET','2',1,NULL,'Cheye Kambi','FI','438651682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:00',0,'2014-03-02 05:10:52'),(12198,12198,'2014-01-01','ET','2',1,NULL,'TAMARA  TRAPNELL','FI','301549318','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:14',0,'2014-03-10 13:52:32'),(20218,20868,'0000-00-00','ET','2',4,3,'David Werring','FI','272662140','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:44',0,'2014-03-10 14:37:47'),(18707,19357,'0000-00-00','ET','2',1,NULL,'Joseph Toman','FI','383044715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:58',0,'2014-03-02 06:45:14'),(4591,4591,'2014-01-01','ET','2',1,NULL,'CARLOS AVILES','FI','148581453','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:59',0,'2014-03-01 16:15:39'),(18523,19173,'0000-00-00','ET','2',1,NULL,'Nicholas Walters','FI','294860337','HealthSpan','FI','311431434','shaun  hunsaker','94','16201100','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:27',0,'2014-03-10 14:31:05'),(18077,18727,'0000-00-00','ET','2',2,1,'Thanh Phan','FI','586524263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:21',0,'2014-03-02 06:38:05'),(7022,7022,'2014-01-01','ET','2',2,1,'Edison Howlett','FI','463786625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:10',0,'2014-03-02 03:09:49'),(7480,7480,'2014-01-01','ET','2',1,NULL,'Melody Kay Rice','FI','455886494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:18',0,'2014-03-02 04:15:49'),(2165,2165,'2014-01-01','ET','2',2,1,'Neal Mark Scharrer','FI','371483586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:56',0,'2014-03-01 15:16:37'),(1141,1141,'2014-01-01','ET','2',1,NULL,'Laurie Pratt','FI','439118089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:56',0,'2014-03-02 04:38:08'),(16401,17051,'0000-00-00','ET','2',1,NULL,'REBECCA BRADMAN','FI','286568915','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-29 21:01:27',0,'2014-03-10 14:20:26'),(22854,23504,'0000-00-00','ET','2',2,1,'JEANNETTE YBARRA','FI','462497447','Starmount Life Insurance Company','FI','720977315','MARIA ELIZA HIGGINBOTHAM','94','1636407','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:06',0,'2014-03-10 21:27:11'),(14479,14930,'2014-01-01','ET','2',1,NULL,'Dana Bowman','FI','292585362','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:43',0,'2014-03-10 14:03:26'),(14471,14922,'2014-01-01','ET','2',2,1,'Tania Reddick','FI','272561967','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:39',0,'2014-03-10 16:17:47'),(15677,16326,'0000-00-00','ET','2',1,NULL,'Gerren Demon Corprew','FI','457816860','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:33',0,'2014-03-02 05:59:43'),(10542,10542,'2014-01-01','ET','2',2,1,'Scott Mount','FI','435923494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:14',0,'2014-03-02 04:15:49'),(7739,7739,'2014-01-01','ET','2',1,NULL,'Rachel Schiff','FI','316063747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:29',0,'2014-03-01 19:11:03'),(7544,7544,'2014-01-01','ET','2',2,1,'Caroline Thompson','FI','296863940','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:25',0,'2014-03-01 16:05:34'),(5128,5128,'2014-01-01','ET','2',2,1,'Sarah  M Sayavich','FI','166526732','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:09',0,'2014-03-10 15:45:56'),(324,324,'2014-01-01','ET','2',1,NULL,'Bethany Murtland','FI','283862147','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:58',0,'2014-03-01 15:21:15'),(20693,21343,'0000-00-00','ET','2',1,NULL,'John Silcio','FI','436826547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:08',0,'2014-03-02 07:17:36'),(16836,17486,'0000-00-00','ET','2',1,NULL,'charles goddard','FI','271848148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:16',0,'2014-03-01 17:00:58'),(13912,14268,'2014-01-01','ET','2',2,1,'Amanda Jones','FI','288909909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:09',0,'2014-03-01 16:40:16'),(2855,2855,'2014-01-01','ET','2',2,1,'Daniel Brown','FI','285648138','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:10',0,'2014-03-10 15:59:47'),(23021,23671,'0000-00-00','ET','2',1,NULL,'Michael Drew Case','FI','499647946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:06',0,'2014-03-10 21:27:11'),(450,450,'2014-01-01','ET','2',1,NULL,'Laurie Drucker','FI','227661661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:58',0,'2014-03-01 22:10:55'),(2918,2918,'2014-01-01','ET','2',1,NULL,'Laura Morehead','FI','273905176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:30',0,'2014-03-01 15:37:30'),(3374,3374,'2014-01-01','ET','2',1,NULL,'ROBERT GRACE','FI','014449514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:54',0,'2014-03-02 02:10:49'),(10940,10940,'2014-01-01','ET','2',1,NULL,'Mary Lambert','FI','297527865','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:56',0,'2014-03-10 16:03:49'),(6398,6398,'2014-01-01','ET','2',4,3,'Paul Hoehn','FI','284647811','HealthSpan','FI','311431434','timothy  iori','94','517910','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:24',0,'2014-03-10 13:39:10'),(6390,6390,'2014-01-01','ET','2',1,NULL,'garrett wheeler','FI','281788466','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:09',0,'2014-03-10 13:39:10'),(4617,4617,'2014-01-01','ET','2',1,NULL,'Jesus Sifuentes','FI','467231630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:46',0,'2014-03-02 04:31:46'),(5021,5021,'2014-01-01','ET','2',1,NULL,'Courtney L Karadeniz','FI','275802257','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:37',0,'2014-03-01 15:31:33'),(5379,5379,'2014-01-01','ET','2',2,1,'HORACIO GONZALEZ','FI','459475945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:51',0,'2014-03-01 21:11:04'),(12145,12145,'2014-01-01','ET','2',1,NULL,'Juanita B Roundtree','FI','587326256','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:17',0,'2014-03-02 04:59:36'),(14474,14925,'2014-01-01','ET','2',1,NULL,'Cynthia Smith','FI','286505686','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:41',0,'2014-03-10 16:17:47'),(15858,16507,'0000-00-00','ET','2',1,NULL,'JODY VASEY','FI','302562517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:45',0,'2014-03-01 16:56:22'),(18276,18926,'0000-00-00','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:06',0,'2014-03-01 17:26:36'),(18700,19350,'0000-00-00','ET','2',1,NULL,'Kayle Houser','FI','291609817','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:52',0,'2014-03-10 14:31:05'),(19162,19812,'0000-00-00','ET','2',1,NULL,'Salina Roman','FI','465631793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:32',0,'2014-03-02 06:52:12'),(22192,22842,'0000-00-00','ET','2',2,1,'Don Stepteau','FI','436537510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:33',0,'2014-03-06 21:27:26'),(331,331,'2014-01-01','ET','2',1,NULL,'Joyce Boakye','FI','269085871','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:12',0,'2014-03-01 15:21:15'),(613,613,'2014-01-01','ET','2',1,NULL,'Patricia Tovar','FI','453677505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:01',0,'2014-03-02 02:10:49'),(10369,10369,'2014-01-01','ET','2',2,1,'Ahmet Elbeyli','FI','293068871','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:46',0,'2014-03-01 16:10:36'),(7307,7307,'2014-01-01','ET','2',1,NULL,'Regina Medlin','FI','425083658','Starmount Life Insurance Company','FI','720977315','Kristy  Corey','94','15790666','348','2014-01-01','Sync Success',0,'2013-12-26 04:09:55',0,'2014-03-02 03:09:49'),(3208,3208,'2014-01-01','ET','2',2,1,'Tereasa Griffith','FI','275763673','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:34',0,'2014-03-01 15:48:04'),(3755,3755,'2014-01-01','ET','2',2,1,'Randy Roe','FI','389781887','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:23',0,'2014-03-10 13:20:27'),(3763,3763,'2014-01-01','ET','2',1,NULL,'Steven Campbell','FI','458775298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:06',0,'2014-03-01 23:10:52'),(12694,12694,'2014-01-01','ET','2',1,NULL,'Dominique Simmons','FI','570935367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:33',0,'2014-03-10 16:10:34'),(13039,13395,'2014-01-01','ET','2',1,NULL,'Janet Geslak','FI','302645945','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:45',0,'2014-03-01 16:35:14'),(15751,16400,'0000-00-00','ET','2',1,NULL,'Caitlin Dennis','FI','277964227','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:22',0,'2014-03-01 16:56:22'),(15988,16637,'0000-00-00','ET','2',1,NULL,'Sharva Vasavada','FI','452658740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:02',0,'2014-03-02 06:03:21'),(16082,16731,'0000-00-00','ET','2',1,NULL,'robby west','FI','275863800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:04',0,'2014-03-01 16:56:22'),(16801,17451,'0000-00-00','ET','2',2,1,'julia draper','FI','267881614','Starmount Life Insurance Company','FI','720977315','Dillon  Widdows','94','17099744','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:41',0,'2014-03-02 06:17:30'),(17573,18223,'0000-00-00','ET','2',1,NULL,'Tracy Susan Luke','FI','274600222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:52',0,'2014-03-01 17:20:55'),(17727,18377,'0000-00-00','ET','2',1,NULL,'Sherry Kearns','FI','284622738','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-24','Sync Success',0,'2014-02-09 19:00:19',0,'2014-03-01 17:20:55'),(17969,18619,'0000-00-00','ET','2',1,NULL,'Carol E Morgan','FI','291505072','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:17',0,'2014-03-10 14:24:38'),(18315,18965,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-12 21:00:16',0,'2014-03-01 17:26:36'),(18500,19150,'0000-00-00','ET','2',1,NULL,'Kimberlee Ellis','FI','282701421','HealthSpan','FI','311431434','Bernadine  Kirian','94','11391349','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:09',0,'2014-03-10 14:31:05'),(18696,19346,'0000-00-00','ET','2',1,NULL,'John Decker','FI','452907958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:49',0,'2014-03-02 06:52:12'),(18874,19524,'0000-00-00','ET','2',1,NULL,'Beverly Brown','FI','271465955','Dental Care Plus, Inc.','FI','311185262','Julia  Weiss','94','16614751','348','2014-03-01','Sync Success',0,'2014-02-14 21:30:43',0,'2014-03-01 17:34:07'),(18883,19533,'0000-00-00','ET','2',2,1,'Austin Troxell','FI','132440126','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:49',0,'2014-03-01 17:34:07'),(20439,21089,'0000-00-00','ET','2',1,NULL,'Kimberly Price','FI','276827351','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:56',0,'2014-03-01 18:08:07'),(21611,22261,'0000-00-00','ET','2',1,NULL,'LUCY FANG','FI','572719138','Starmount Life Insurance Company','FI','720977315','DEQING  YANG','94','11179161','348','2014-04-01','Sync Success',0,'2014-03-04 21:00:29',0,'2014-03-04 21:27:16'),(21815,22465,'0000-00-00','ET','2',1,NULL,'DOROTHY GEORGETTE  WILSON','FI','467574631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:14',0,'2014-03-05 21:25:24'),(1770,1770,'2014-01-01','ET','2',1,NULL,'Kezie N Bruce','FI','433392299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:37',0,'2014-03-02 00:10:48'),(3991,3991,'2014-01-01','ET','2',2,1,'Ernest Riley','FI','496602022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:58',0,'2014-03-01 23:10:52'),(3975,3975,'2014-01-01','ET','2',1,NULL,'WILLIAM PIOTROWSKI','FI','283643374','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:25',0,'2014-03-10 13:10:24'),(2344,2344,'2014-01-01','ET','2',1,NULL,'Chasity Ellerhorst','FI','400295597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:29',0,'2014-03-01 15:26:40'),(11250,11250,'2014-01-01','ET','2',1,NULL,'Andrew James Toth','FI','288927013','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:59',0,'2014-03-01 16:23:43'),(11591,11591,'2014-01-01','ET','2',1,NULL,'Raphael Ramirez','FI','455536463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:27',0,'2014-03-02 04:59:36'),(6285,6285,'2014-01-01','ET','2',1,NULL,'Donald Warren','FI','435960126','Starmount Life Insurance Company','FI','720977315','Melvin  Thomas','94','4745590','348','2014-01-01','Sync Success',0,'2013-12-26 03:06:59',0,'2014-03-02 04:10:25'),(4213,4213,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:06:38',0,'2014-03-01 15:52:44'),(12465,12465,'2014-01-01','ET','2',1,NULL,'Mark Deeter','FI','300440970','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:05',0,'2014-03-10 16:10:34'),(12666,12666,'2014-01-01','ET','2',1,NULL,'Sean Fitzgerald','FI','286888659','Dental Care Plus, Inc.','FI','311185262','Angela  Elias','94','10676545','348','2014-02-01','Sync Success',0,'2014-01-03 02:03:32',0,'2014-03-01 16:35:14'),(12794,12794,'2014-01-01','ET','2',1,NULL,'ANNIE BROWN','FI','457982074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:02',0,'2014-03-02 05:10:52'),(14091,14542,'2014-01-01','ET','2',1,NULL,'Amy Pacharzina','FI','601201801','Starmount Life Insurance Company','FI','720977315','Justin  Leblanc','94','8485121','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:29',0,'2014-03-02 05:38:34'),(17229,17879,'0000-00-00','ET','2',2,1,'Lyn Weiss','FI','276569271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:20',0,'2014-03-10 16:24:30'),(17402,18052,'0000-00-00','ET','2',1,NULL,'Tamika Nicole Cole','FI','302926508','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:43',0,'2014-03-01 17:20:55'),(18021,18671,'0000-00-00','ET','2',2,1,'ALLAN TEMPLE','FI','285882299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:53',0,'2014-03-01 17:20:55'),(18310,18960,'0000-00-00','ET','2',1,NULL,'robert l miller','FI','160448709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-12 21:00:13',0,'2014-03-10 16:31:33'),(20092,20742,'0000-00-00','ET','2',1,NULL,'JERRI M LEE','FI','439298507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:12',0,'2014-03-02 07:10:28'),(20298,20948,'0000-00-00','ET','2',1,NULL,'DeAnna LaHaye','FI','438868322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:40',0,'2014-03-02 07:03:25'),(20774,21424,'0000-00-00','ET','2',1,NULL,'Linda Gray','FI','291582842','Dental Care Plus, Inc.','FI','311185262','Paul  Langley','94','16808283','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:46',0,'2014-03-01 18:10:11'),(21314,21964,'0000-00-00','ET','2',1,NULL,'Warde Mohamad El-Jaber','FI','634427091','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:04',0,'2014-03-03 01:07:25'),(21489,22139,'0000-00-00','ET','2',1,NULL,'Derris Price','FI','289767160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:48',0,'2014-03-03 21:36:16'),(21969,22619,'0000-00-00','ET','2',1,NULL,'Lisa Jackson','FI','107427033','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:32',0,'2014-03-10 16:44:18'),(22969,23619,'0000-00-00','ET','2',1,NULL,'STEPHEN BOSWELL','FI','172568987','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:29',0,'2014-03-10 21:36:25'),(23024,23674,'0000-00-00','ET','2',1,NULL,'Iris Idalia Jimenez','FI','451691147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:08',0,'2014-03-10 21:27:11'),(84,84,'2014-01-01','ET','2',1,NULL,'Janet McEowen','FI','461923260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:32',0,'2014-03-01 22:10:55'),(1832,1832,'2014-01-01','ET','2',1,NULL,'Judy Schank','FI','268506122','HealthSpan','FI','311431434','Donald  Pahl','94','3237938','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:39',0,'2014-03-10 13:20:27'),(1884,1884,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:21',0,'2014-03-01 23:10:52'),(2047,2047,'2014-01-01','ET','2',1,NULL,'ANITERA HOOD','FI','428373640','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:19',0,'2014-03-01 23:10:52'),(2078,2078,'2014-01-01','ET','2',1,NULL,'Kathryn Taylor','FI','428535927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:21',0,'2014-03-01 23:10:52'),(12035,12035,'2014-01-01','ET','2',1,NULL,'Aljilia Prelow','FI','437675674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:25',0,'2014-03-02 05:03:29'),(5252,5252,'2014-01-01','ET','2',2,1,'Nollen Elzie','FI','587464905','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:04',0,'2014-03-02 00:10:48'),(11647,11647,'2014-01-01','ET','2',2,1,'gary headrick','FI','297647104','Summa Insurance Company, Inc.','FI','341809108','Jared  Bologna','94','8927566','348','2014-02-01','Sync Success',0,'2013-12-28 03:36:10',0,'2014-03-10 16:03:49'),(5856,5856,'2014-01-01','ET','2',2,1,'RICKEY LAMAR PRESSLEY','FI','274569797','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:22',0,'2014-03-01 15:10:22'),(10777,10777,'2014-01-01','ET','2',1,NULL,'george durnin','FI','439689024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:03:09',0,'2014-03-02 04:24:47'),(6157,6157,'2014-01-01','ET','2',1,NULL,'lISA FRANKLIN','FI','462271400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:04',0,'2014-03-02 04:10:25'),(5966,5966,'2014-01-01','ET','2',1,NULL,'Stacy Hollingsworth','FI','557470516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:51',0,'2014-03-02 02:10:49'),(13326,13682,'2014-01-01','ET','2',1,NULL,'MICHAEL RAY WALKER','FI','430232464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:22',0,'2014-03-02 05:24:45'),(13907,14263,'2014-01-01','ET','2',1,NULL,'Nicholas Eichler','FI','430519827','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:06',0,'2014-03-01 16:40:16'),(15200,15651,'0000-00-00','ET','2',1,NULL,'SUZANNA  FOUCHE','FI','269845855','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:25',0,'2014-03-01 16:50:53'),(15553,16004,'0000-00-00','ET','2',1,NULL,'tina jodrey','FI','281808150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:15',0,'2014-03-01 16:50:53'),(16446,17096,'0000-00-00','ET','2',1,NULL,'Daniel Hitchcock','FI','274909774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:04',0,'2014-03-01 17:00:58'),(16476,17126,'0000-00-00','ET','2',1,NULL,'TINICA L COLBERT','FI','435415148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:22',0,'2014-03-02 06:10:30'),(21030,21680,'0000-00-00','ET','2',1,NULL,'Keith Dietrich','FI','298720882','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 21:00:21',0,'2014-03-10 14:45:25'),(22191,22841,'0000-00-00','ET','2',1,NULL,'Don Stepteau','FI','436537510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:01:33',0,'2014-03-06 21:27:26'),(22924,23574,'0000-00-00','ET','2',1,NULL,'Craig J Jefferson','FI','434316833','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:58',0,'2014-03-10 21:27:11'),(19738,20388,'0000-00-00','ET','2',1,NULL,'patricia molina','FI','464430929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:40:02',0,'2014-03-02 06:59:07'),(1928,1928,'2014-01-01','ET','2',1,NULL,'SAUNDRA LEAS','FI','302523150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:34',0,'2014-03-01 15:26:40'),(12871,12871,'2014-01-01','ET','2',1,NULL,'ROBERT L HALL','FI','282569538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:50',0,'2014-03-01 16:35:14'),(2024,2024,'2014-01-01','ET','2',1,NULL,'Linda Hedges','FI','439940428','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:37',0,'2014-03-01 23:10:52'),(2041,2041,'2014-01-01','ET','2',1,NULL,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:07',0,'2014-03-02 00:10:48'),(11462,11462,'2014-01-01','ET','2',1,NULL,'martha delvalle','FI','345662277','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:31',0,'2014-03-01 16:30:17'),(3323,3323,'2014-01-01','ET','2',1,NULL,'Suzanne Lynn  Kim','FI','003502713','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:19',0,'2014-03-10 15:52:36'),(5300,5300,'2014-01-01','ET','2',1,NULL,'David Simbeck','FI','271481591','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:27',0,'2014-03-01 15:05:09'),(6445,6445,'2014-01-01','ET','2',1,NULL,'Dianne Sowders','FI','439905602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:56',0,'2014-03-01 20:10:57'),(13438,13794,'2014-01-01','ET','2',1,NULL,'LaCresha Covin','FI','452958391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:10',0,'2014-03-02 05:31:31'),(14135,14586,'2014-01-01','ET','2',1,NULL,'FRANCES RENEE MILLER','FI','434232871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:57',0,'2014-03-02 05:38:34'),(14145,14596,'2014-01-01','ET','2',2,1,'Sherrie Pfefferman','FI','269569773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:04',0,'2014-03-02 05:38:34'),(15586,16037,'0000-00-00','ET','2',1,NULL,'JUANITA A FONTENOT','FI','438060370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:29',0,'2014-03-02 05:59:43'),(15921,16570,'0000-00-00','ET','2',1,NULL,'Sandra Johnson','FI','465354354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:06',0,'2014-03-02 06:03:21'),(16627,17277,'0000-00-00','ET','2',1,NULL,'Maria Luisa Casas','FI','459834468','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:26',0,'2014-03-02 06:17:30'),(16824,17474,'0000-00-00','ET','2',1,NULL,'Dimitria Bethancourt','FI','436252343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:09',0,'2014-03-02 06:17:30'),(17523,18173,'0000-00-00','ET','2',1,NULL,'Charles Kerr','FI','456962942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:16',0,'2014-03-02 06:31:45'),(19679,20329,'0000-00-00','ET','2',1,NULL,'BRENDA DIANE VALLEE','FI','278583433','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:50:29',0,'2014-03-10 14:37:47'),(19828,20478,'0000-00-00','ET','2',1,NULL,'Dianna Carbone','FI','279503681','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:46',0,'2014-03-10 16:38:05'),(19915,20565,'0000-00-00','ET','2',1,NULL,'DONYA R SMITH','FI','465573699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:13',0,'2014-03-02 07:03:25'),(21923,22573,'0000-00-00','ET','2',1,NULL,'Shaun-Patrice Williams','FI','622767485','Starmount Life Insurance Company','FI','720977315','Sergio E Garza','94','8188643','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:58',0,'2014-03-05 22:27:33'),(1107,1107,'2014-01-01','ET','2',1,NULL,'Susan Liller','FI','293581691','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:18',0,'2014-03-01 15:05:09'),(2802,2802,'2014-01-01','ET','2',1,NULL,'David Baker','FI','278780042','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:25',0,'2014-03-01 16:05:34'),(4258,4258,'2014-01-01','ET','2',2,1,'Richard Madill','FI','298505916','HealthSpan','FI','311431434','Gregory  B  Burch','94','2776783','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:03',0,'2014-03-10 13:32:15'),(5926,5926,'2014-01-01','ET','2',1,NULL,'Bhalinder Singh Chahal','FI','271176838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:36',0,'2014-03-01 15:48:04'),(12840,12840,'2014-01-01','ET','2',1,NULL,'ireon PITTMAN','FI','436653674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:41',0,'2014-03-02 05:17:40'),(13869,14225,'2014-01-01','ET','2',1,NULL,'LINDA BELLARD','FI','434215278','Starmount Life Insurance Company','FI','720977315','LEDRICKA  THIERRY','94','9445795','348','2014-02-01','Sync Success',0,'2014-01-13 02:24:00',0,'2014-03-02 05:31:31'),(14107,14558,'2014-01-01','ET','2',2,1,'Charles Boulton','FI','484724146','Dental Care Plus, Inc.','FI','311185262','DEANNA M WELLS','94','7827930','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:39',0,'2014-03-01 16:40:16'),(14194,14645,'2014-01-01','ET','2',1,NULL,'Diana M Gomez','FI','457210853','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:35',0,'2014-03-02 05:38:34'),(14568,15019,'2014-01-01','ET','2',1,NULL,'Akm Huq','FI','204844329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:29',0,'2014-03-02 05:45:37'),(16211,16860,'0000-00-00','ET','2',1,NULL,'jennifer wyatt','FI','455810194','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:47',0,'2014-03-02 06:10:30'),(17341,17991,'0000-00-00','ET','2',1,NULL,'Carol Florey','FI','268566610','HealthSpan','FI','311431434','Donald  Larson','94','15784811','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:17',0,'2014-03-10 14:24:38'),(17423,18073,'0000-00-00','ET','2',1,NULL,'BRENDA POLITSCH','FI','323545111','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:57',0,'2014-03-10 16:24:30'),(18626,19276,'0000-00-00','ET','2',2,1,'MICHAEL SARRIS','FI','294669624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:55',0,'2014-03-01 17:26:36'),(19279,19929,'0000-00-00','ET','2',1,NULL,'Susan Kelby','FI','299684258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:04',0,'2014-03-01 17:34:07'),(19403,20053,'0000-00-00','ET','2',3,2,'Paul Sebe','FI','285828552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:10',0,'2014-03-10 16:31:33'),(19582,20232,'0000-00-00','ET','2',1,NULL,'Robert Parker','FI','289829447','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:27:25',0,'2014-03-10 14:37:47'),(22258,22908,'0000-00-00','ET','2',2,1,'Tasha Johnson','FI','280904916','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:22',0,'2014-03-10 16:44:18'),(22670,23320,'0000-00-00','ET','2',1,NULL,'Thirada Litzkow','FI','416559646','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:36',0,'2014-03-08 22:26:18'),(23111,23761,'0000-00-00','ET','2',2,1,'JESSE LOWMAN','FI','545332663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:11',0,'2014-03-10 22:25:11'),(754,754,'2014-01-01','ET','2',1,NULL,'Mark Brosee','FI','300545201','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:29',0,'2014-03-10 13:24:34'),(11304,11304,'2014-01-01','ET','2',1,NULL,'SHERLONDA BOONE','FI','458196200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:38',0,'2014-03-02 04:45:37'),(1886,1886,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:23',0,'2014-03-01 23:10:52'),(2626,2626,'2014-01-01','ET','2',1,NULL,'Shellee Kotschwar','FI','507861158','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:48',0,'2014-03-01 21:11:04'),(3668,3668,'2014-01-01','ET','2',1,NULL,'Thad Jones','FI','427230989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:28',0,'2014-03-02 00:10:48'),(13800,14156,'2014-01-01','ET','2',1,NULL,'Duane Berger','FI','287548093','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:48',0,'2014-03-10 13:59:38'),(14390,14841,'2014-01-01','ET','2',1,NULL,'Daren Clapper','FI','268860278','Dental Care Plus, Inc.','FI','311185262','Lee A Brown','94','2219072','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:02',0,'2014-03-01 16:46:19'),(14573,15024,'2014-01-01','ET','2',1,NULL,'Guillermo  Fuentes','FI','628167445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:32',0,'2014-03-02 05:45:37'),(15211,15662,'0000-00-00','ET','2',1,NULL,'Jerico Cook','FI','236391122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:33',0,'2014-03-01 16:50:53'),(15348,15799,'0000-00-00','ET','2',1,NULL,'Joann Lewis','FI','436794303','Starmount Life Insurance Company','FI','720977315','Johm T Allen','94','4728680','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:48',0,'2014-03-02 05:52:31'),(15886,16535,'0000-00-00','ET','2',1,NULL,'WILLIAM  EDMOND','FI','587209934','Starmount Life Insurance Company','FI','720977315','REVONNO  BURT','94','6401285','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:04',0,'2014-03-02 06:03:21'),(16348,16998,'0000-00-00','ET','2',1,NULL,'LINDA MILLER','FI','297563914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:53',0,'2014-03-01 16:56:22'),(16884,17534,'0000-00-00','ET','2',1,NULL,'cully johnson','FI','457043708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:16',0,'2014-03-02 06:17:30'),(17416,18066,'0000-00-00','ET','2',1,NULL,'Carrie Croskey','FI','288769878','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:53',0,'2014-03-10 16:24:30'),(18181,18831,'0000-00-00','ET','2',1,NULL,'PATRICIA BROWN','FI','545925214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:39',0,'2014-03-01 17:26:36'),(18251,18901,'0000-00-00','ET','2',1,NULL,'JOANNE STOLL','FI','276546792','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:38',0,'2014-03-10 14:24:38'),(18448,19098,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:36',0,'2014-03-10 16:31:33'),(18912,19562,'0000-00-00','ET','2',1,NULL,'Athena Barbera','FI','283744880','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:11',0,'2014-03-01 17:34:07'),(20456,21106,'0000-00-00','ET','2',2,1,'Teresa Ferguson','FI','286662595','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:12',0,'2014-03-01 18:08:07'),(22126,22776,'0000-00-00','ET','2',1,NULL,'ANTOINETTE KING','FI','436697986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:48',0,'2014-03-06 21:27:26'),(22303,22953,'0000-00-00','ET','2',1,NULL,'SAMUEL FREDERICK ALLEN','FI','204580549','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:57',0,'2014-03-10 14:50:59'),(23079,23729,'0000-00-00','ET','2',2,1,'Thomas Hill','FI','289568428','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:51',0,'2014-03-10 21:17:52'),(316,316,'2014-01-01','ET','2',1,NULL,'Christopher Black','FI','452773656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:42',0,'2014-03-01 22:10:55'),(13142,13498,'2014-01-01','ET','2',2,1,'Robert Hendee','FI','288482611','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:34',0,'2014-03-10 13:59:38'),(12988,12988,'2014-01-01','ET','2',1,NULL,'Susan  C Randolph','FI','291505103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:42',0,'2014-03-01 16:35:14'),(640,640,'2014-01-01','ET','2',2,1,'Rodney Maestas','FI','218927832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:54',0,'2014-03-02 02:10:49'),(11957,11957,'2014-01-01','ET','2',1,NULL,'DONNA PETERSON','FI','552989323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:29',0,'2014-03-02 04:59:36'),(951,951,'2014-01-01','ET','2',1,NULL,'Johnathan Nichols','FI','436811750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:40',0,'2014-03-01 22:10:55'),(1060,1060,'2014-01-01','ET','2',2,1,'Brittany Holmes','FI','291905404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:35',0,'2014-03-01 15:16:37'),(1447,1447,'2014-01-01','ET','2',1,NULL,'Robert Ivory','FI','283722915','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:35',0,'2014-03-01 16:15:39'),(6338,6338,'2014-01-01','ET','2',1,NULL,'Patsy Sparkman','FI','445585288','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:34',0,'2014-03-02 04:10:25'),(5750,5750,'2014-01-01','ET','2',1,NULL,'barbara williams','FI','435827549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:53',0,'2014-03-02 01:10:33'),(1987,1987,'2014-01-01','ET','2',1,NULL,'Becky Kail','FI','278521405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:23',0,'2014-03-10 15:45:56'),(14195,14646,'2014-01-01','ET','2',1,NULL,'ZAIB AJANI','FI','644169284','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:36',0,'2014-03-02 05:38:34'),(14239,14690,'2014-01-01','ET','2',1,NULL,'srijana baral','FI','755014584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:57',0,'2014-03-02 05:38:34'),(14991,15442,'2014-01-01','ET','2',2,1,'FREDRICK W DAMPEER','FI','425552125','Starmount Life Insurance Company','FI','720977315','MICHAEL  DAUGHERTY','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:06',0,'2014-03-02 05:45:37'),(15293,15744,'0000-00-00','ET','2',4,3,'HOWARD WADE','FI','455048766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:14',0,'2014-03-02 05:52:31'),(15642,16291,'0000-00-00','ET','2',2,1,'dave zorn','FI','300625644','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:05',0,'2014-03-01 16:50:53'),(15920,16569,'0000-00-00','ET','2',1,NULL,'Agaytha Eads','FI','455868843','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:06',0,'2014-03-02 06:03:21'),(2932,2932,'2014-01-01','ET','2',1,NULL,'kirk hawthorne','FI','298667376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:00',0,'2014-03-01 15:37:30'),(3283,3283,'2014-01-01','ET','2',1,NULL,'Robert h Jackson','FI','281842741','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:55',0,'2014-03-02 02:10:49'),(4165,4165,'2014-01-01','ET','2',1,NULL,'Karen A Treadway','FI','279500538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:05:08',0,'2014-03-10 15:59:47'),(5274,5274,'2014-01-01','ET','2',2,1,'Juanita Arriaga','FI','467477878','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:27',0,'2014-03-01 20:10:57'),(13528,13884,'2014-01-01','ET','2',1,NULL,'Nicholas Kramer','FI','294865729','Dental Care Plus, Inc.','FI','311185262','John  Curry','94','10751792','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:36',0,'2014-03-01 16:40:16'),(13965,14321,'2014-01-01','ET','2',1,NULL,'Brian Lester','FI','330809552','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:44',0,'2014-03-10 14:03:26'),(15356,15807,'0000-00-00','ET','2',2,1,'Vera Crouch','FI','302620431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:52',0,'2014-03-10 14:10:12'),(16626,17276,'0000-00-00','ET','2',1,NULL,'Ariel Sherman','FI','454494992','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:25',0,'2014-03-02 06:17:30'),(17447,18097,'0000-00-00','ET','2',1,NULL,'Gloria Wilkins','FI','270443027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:14',0,'2014-03-01 17:20:55'),(22879,23529,'0000-00-00','ET','2',1,NULL,'CONOR MCANALLY','FI','632601244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:23',0,'2014-03-10 21:27:11'),(22894,23544,'0000-00-00','ET','2',1,NULL,'MARISHA HOLMAN','FI','280786771','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:35',0,'2014-03-10 21:36:25'),(1505,1505,'2014-01-01','ET','2',1,NULL,'james carper','FI','292800083','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:32',0,'2014-03-10 16:03:49'),(13353,13709,'2014-01-01','ET','2',1,NULL,'Robert Arnott','FI','610542427','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:33',0,'2014-03-02 05:24:45'),(1522,1522,'2014-01-01','ET','2',5,4,'Brian Wilke','FI','302727936','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:07',0,'2014-03-10 16:03:49'),(12929,12929,'2014-01-01','ET','2',1,NULL,'thomas pierce','FI','293707569','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:06:01',0,'2014-03-10 13:59:38'),(12797,12797,'2014-01-01','ET','2',1,NULL,'Elias Garriolo','FI','631208499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:10',0,'2014-03-02 05:10:52'),(11913,11913,'2014-01-01','ET','2',1,NULL,'Jesse Vroman','FI','299842610','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-30 00:01:26',0,'2014-03-01 16:30:17'),(11630,11630,'2014-01-01','ET','2',1,NULL,'Katherine Jack','FI','433370138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:40',0,'2014-03-02 04:52:44'),(11529,11529,'2014-01-01','ET','2',1,NULL,'Staci Bruce','FI','425498836','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:32:31',0,'2014-03-02 04:52:44'),(11105,11105,'2014-01-01','ET','2',1,NULL,'Amy Arps','FI','295684337','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:16',0,'2014-03-10 13:45:57'),(1841,1841,'2014-01-01','ET','2',1,NULL,'Tracee Perryman','FI','276768243','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:21:00',0,'2014-03-10 13:20:27'),(2478,2478,'2014-01-01','ET','2',2,1,'Pamela Leigh Post','FI','264847394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:47',0,'2014-03-10 13:10:24'),(3155,3155,'2014-01-01','ET','2',1,NULL,'Dorene Patton','FI','189521358','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:55',0,'2014-03-10 13:24:34'),(3182,3182,'2014-01-01','ET','2',2,1,'Jason Suttles','FI','282844912','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-25 21:38:56',0,'2014-03-10 13:24:34'),(6207,6207,'2014-01-01','ET','2',1,NULL,'Jeffrey Alan Jones','FI','286566746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:32',0,'2014-03-01 16:00:27'),(5980,5980,'2014-01-01','ET','2',1,NULL,'Kenneth Zelesnik','FI','284522030','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:21',0,'2014-03-10 15:52:36'),(5444,5444,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:47',0,'2014-03-10 13:03:33'),(5276,5276,'2014-01-01','ET','2',1,NULL,'Keven James Sharpe','FI','288867509','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:35',0,'2014-03-10 15:39:19'),(5267,5267,'2014-01-01','ET','2',1,NULL,'Pamela Beth Zoslov','FI','278660248','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:15',0,'2014-03-10 15:39:19'),(3960,3960,'2014-01-01','ET','2',1,NULL,'Ibtihaj Dingler','FI','283139604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:54',0,'2014-03-01 15:26:40'),(13837,14193,'2014-01-01','ET','2',1,NULL,'gail guthrie','FI','452511296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:39',0,'2014-03-02 05:31:31'),(13916,14272,'2014-01-01','ET','2',1,NULL,'Guyia Wilson','FI','287743643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:11',0,'2014-03-01 16:40:16'),(14713,15164,'2014-01-01','ET','2',1,NULL,'DIANNA  NETTERVILLE','FI','433855102','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:03',0,'2014-03-02 05:45:37'),(16494,17144,'0000-00-00','ET','2',2,1,'Terry Capiti','FI','463254351','Starmount Life Insurance Company','FI','720977315','colette  saigh','94','1008977','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:33',0,'2014-03-02 06:10:30'),(16791,17441,'0000-00-00','ET','2',1,NULL,'Crystal Strausbaugh','FI','283884442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:35',0,'2014-03-01 17:00:58'),(19280,19930,'0000-00-00','ET','2',1,NULL,'Hollis Wright Haggard','FI','284785842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:04',0,'2014-03-01 17:34:07'),(19308,19958,'0000-00-00','ET','2',1,NULL,'Laura Cohen','FI','453216156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:03',0,'2014-03-02 06:52:12'),(20128,20778,'0000-00-00','ET','2',2,1,'JENIFER SANDERS','FI','285847103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:40',0,'2014-03-01 18:08:07'),(20426,21076,'0000-00-00','ET','2',1,NULL,'EDWARD L OPDYCKE','FI','291526734','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:46',0,'2014-03-01 18:08:07'),(20657,21307,'0000-00-00','ET','2',1,NULL,'Stephanie Garrett','FI','287901843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:30',0,'2014-03-10 16:38:05'),(21041,21691,'0000-00-00','ET','2',1,NULL,'Stephen Smith','FI','287502772','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 21:30:04',0,'2014-03-01 18:10:11'),(4593,4593,'2014-01-01','ET','2',2,1,'KYLE ECK','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:03',0,'2014-03-01 16:15:39'),(13488,13844,'2014-01-01','ET','2',1,NULL,'Edwin Jerome Lynum','FI','457945411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:08',0,'2014-03-02 05:24:45'),(5532,5532,'2014-01-01','ET','2',1,NULL,'Melisa Kennedy','FI','272903586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:47:27',0,'2014-03-01 16:23:43'),(6215,6215,'2014-01-01','ET','2',1,NULL,'Lauren Damis','FI','270865291','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:45',0,'2014-03-01 16:00:27'),(6286,6286,'2014-01-01','ET','2',1,NULL,'toni clark','FI','439350077','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:01',0,'2014-03-02 04:10:25'),(12451,12451,'2014-01-01','ET','2',1,NULL,'VALERIE T DENGG','FI','274869575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:33',0,'2014-03-10 16:10:34'),(12394,12394,'2014-01-01','ET','2',1,NULL,'Catherine Catania','FI','283863556','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','348','2014-02-01','Sync Success',1,'2014-01-02 04:29:28',0,'2014-03-01 16:30:17'),(11642,11642,'2014-01-01','ET','2',1,NULL,'Christopher Bruskotter','FI','297921626','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:00',0,'2014-03-10 13:52:32'),(11511,11511,'2014-01-01','ET','2',1,NULL,'HAROLD BERRY','FI','437905896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:59',0,'2014-03-02 04:52:44'),(7372,7372,'2014-01-01','ET','2',1,NULL,'Francine Shannon','FI','384748738','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:16:19',0,'2014-03-10 13:03:33'),(15852,16501,'0000-00-00','ET','2',1,NULL,'Demetrus Malone','FI','300720975','Dental Care Plus, Inc.','FI','311185262','Ted A Biskind','94','364657','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:42',0,'2014-03-01 16:56:22'),(17180,17830,'0000-00-00','ET','2',1,NULL,'Laura Brown','FI','492921867','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:54',0,'2014-03-10 16:24:30'),(17664,18314,'0000-00-00','ET','2',1,NULL,'Gary Bentley','FI','278563586','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:44',0,'2014-03-01 17:20:55'),(18036,18686,'0000-00-00','ET','2',1,NULL,'KENNETH ALBERS','FI','285569858','HealthSpan','FI','311431434','BRAIN  ALBERS','94','2825035','357','2014-03-01','Sync Success',0,'2014-02-10 21:32:04',0,'2014-03-10 14:24:38'),(18182,18832,'0000-00-00','ET','2',1,NULL,'LORENE LEWIS','FI','282586296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:39',0,'2014-03-01 17:26:36'),(19616,20266,'0000-00-00','ET','2',1,NULL,'Rhonda Phillips','FI','284689766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:12',0,'2014-03-01 17:47:19'),(20148,20798,'0000-00-00','ET','2',1,NULL,'Robin Green','FI','193568690','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:54',0,'2014-03-10 16:38:05'),(20238,20888,'0000-00-00','ET','2',2,1,'TERRY ALLEN HOLSINGER','FI','279622399','HealthSpan','FI','311431434','SHAUN  HUNSAKER','94','16201100','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:00',0,'2014-03-10 14:37:47'),(20713,21363,'0000-00-00','ET','2',1,NULL,'Jacob Mattes','FI','299924952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:30:18',0,'2014-03-01 18:08:07'),(4029,4029,'2014-01-01','ET','2',1,NULL,'Andres Mireles','FI','635101291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:01',0,'2014-03-02 03:09:49'),(4603,4603,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','357','2014-01-01','Sync Success',0,'2013-12-25 23:47:21',0,'2014-03-01 16:15:39'),(12743,12743,'2014-01-01','ET','2',4,3,'pruitt  geloach','FI','465792624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:25',0,'2014-03-02 05:10:52'),(4855,4855,'2014-01-01','ET','2',2,1,'Walton Yuen','FI','576821873','Starmount Life Insurance Company','FI','720977315','cynthia  foreman','94','1145168','348','2014-01-01','Sync Success',0,'2013-12-26 00:15:45',0,'2014-03-01 20:10:57'),(6358,6358,'2014-01-01','ET','2',1,NULL,'Verkista Pittman','FI','428530129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:07',0,'2014-03-02 04:10:25'),(14732,15183,'2014-01-01','ET','2',1,NULL,'ALI ALESAWI','FI','109861512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:15',0,'2014-03-02 05:45:37'),(14876,15327,'2014-01-01','ET','2',1,NULL,'WESLEY NICHOLSON','FI','525519283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:13',0,'2014-03-02 05:52:31'),(14918,15369,'2014-01-01','ET','2',1,NULL,'Debra Hoehn','FI','016481986','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:32',0,'2014-03-01 16:50:53'),(15151,15602,'0000-00-00','ET','2',1,NULL,'DEBRA BILLINGSLEA','FI','425276660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:06:27',0,'2014-03-02 05:52:31'),(16126,16775,'0000-00-00','ET','2',2,1,'Michelle DePaolo','FI','271865252','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:37',0,'2014-03-10 16:24:30'),(17953,18603,'0000-00-00','ET','2',1,NULL,'Sarah Walker','FI','298780179','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:05',0,'2014-03-01 17:20:55'),(21141,21791,'0000-00-00','ET','2',1,NULL,'Tress Turner','FI','439378400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:31:15',0,'2014-03-02 07:23:39'),(21514,22164,'0000-00-00','ET','2',2,1,'Hung Thai','FI','023608395','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:06',0,'2014-03-03 22:26:43'),(21725,22375,'0000-00-00','ET','2',1,NULL,'Joann Davis','FI','291468978','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:59',0,'2014-03-10 16:44:18'),(17964,18614,'0000-00-00','ET','2',1,NULL,'TAMMY MAROUS','FI','297664313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:14',0,'2014-03-01 17:26:36'),(19965,20615,'0000-00-00','ET','2',1,NULL,'CLARA MCAFEE','FI','274844227','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:27',0,'2014-03-01 17:47:19'),(20281,20931,'0000-00-00','ET','2',1,NULL,'VINITA FIXX','FI','273508570','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:26',0,'2014-03-10 14:37:47'),(348,348,'2014-01-01','ET','2',1,NULL,'Bruce Gill','FI','282588030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:44',0,'2014-03-01 15:21:15'),(13660,14016,'2014-01-01','ET','2',1,NULL,'Tina Pham','FI','439799274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:16',0,'2014-03-02 05:24:45'),(633,633,'2014-01-01','ET','2',2,1,'Linda Susan Anderson','FI','465883281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:41',0,'2014-03-02 02:10:49'),(13457,13813,'2014-01-01','ET','2',1,NULL,'SILVIA VENEGAS','FI','435573332','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:24',0,'2014-03-02 05:31:31'),(12690,12690,'2014-01-01','ET','2',1,NULL,'kia  moncgomery','FI','286728176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:24',0,'2014-03-01 16:35:14'),(12270,12270,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:14',0,'2014-03-10 16:10:34'),(11975,11975,'2014-01-01','ET','2',1,NULL,'Brittany Logan','FI','639322945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:11',0,'2014-03-02 05:03:29'),(1271,1271,'2014-01-01','ET','2',2,1,'alfred xin','FI','278949157','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:52',0,'2014-03-01 16:23:43'),(5233,5233,'2014-01-01','ET','2',1,NULL,'Brent  Bourland','FI','425982855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:53:30',0,'2014-03-02 00:10:48'),(10970,10970,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:44',0,'2014-03-10 13:39:10'),(7569,7569,'2014-01-01','ET','2',2,1,'William M Beam','FI','287727302','Dental Care Plus, Inc.','FI','311185262','Rod  Weller','94','2759353','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:15',0,'2014-03-01 16:05:34'),(16304,16954,'0000-00-00','ET','2',1,NULL,'Carlos Ferreira-Lopes','FI','620167364','Starmount Life Insurance Company','FI','720977315','Rafael  Salgado','94','11548132','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:25',0,'2014-03-02 06:10:30'),(16868,17518,'0000-00-00','ET','2',1,NULL,'Ryan Martinez','FI','437618291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:07',0,'2014-03-02 06:17:30'),(18514,19164,'0000-00-00','ET','2',1,NULL,'Chinonye Akunne','FI','271945882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:20',0,'2014-03-10 14:31:05'),(19822,20472,'0000-00-00','ET','2',1,NULL,'AMANUEL FISSEHA','FI','636687895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:40',0,'2014-03-02 07:03:25'),(19908,20558,'0000-00-00','ET','2',2,1,'ATILIO ZAVALA','FI','643207676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:09',0,'2014-03-02 07:03:25'),(20352,21002,'0000-00-00','ET','2',1,NULL,'Jeremiah Bernard Stvictor','94','0000822104','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:40',0,'2014-03-01 17:47:19'),(20547,21197,'0000-00-00','ET','2',1,NULL,'Amelia Long','FI','579083885','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:14',0,'2014-03-02 07:17:36'),(20556,21206,'0000-00-00','ET','2',1,NULL,'Rose Lawrence','FI','466538851','Starmount Life Insurance Company','FI','720977315','Archer  Summer','94','16993399','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:20',0,'2014-03-02 07:17:36'),(20898,21548,'0000-00-00','ET','2',1,NULL,'MARKELIA CHAMBERS ROBERSON','FI','587811067','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:43',0,'2014-03-02 07:17:36'),(21064,21714,'0000-00-00','ET','2',1,NULL,'Cole A Taylor','FI','292041398','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:24',0,'2014-03-01 18:10:11'),(24,24,'2014-01-01','ET','2',1,NULL,'Jean McGreevy','FI','291546588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:44',0,'2014-03-01 15:21:15'),(13469,13825,'2014-01-01','ET','2',1,NULL,'Claudia Hilinski','FI','298604320','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:32',0,'2014-03-10 16:17:47'),(177,177,'2014-01-01','ET','2',1,NULL,'Susie Racheau','FI','433882514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:29',0,'2014-03-01 22:10:55'),(626,626,'2014-01-01','ET','2',1,NULL,'Pamela Supak','FI','456861998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:29',0,'2014-03-02 02:10:49'),(2578,2578,'2014-01-01','ET','2',1,NULL,'Whitney Hollins','FI','286949696','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:15',0,'2014-03-01 15:05:09'),(11879,11879,'2014-01-01','ET','2',1,NULL,'Rebecca Owens','FI','451830094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:21',0,'2014-03-02 04:59:36'),(10697,10697,'2014-01-01','ET','2',1,NULL,'jerry scott','FI','277667293','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:25',0,'2014-03-01 16:10:36'),(4129,4129,'2014-01-01','ET','2',1,NULL,'Kay Arthur','FI','203424482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:05',0,'2014-03-01 16:00:27'),(6161,6161,'2014-01-01','ET','2',1,NULL,'Hong Fan','FI','108339017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:11',0,'2014-03-02 04:10:25'),(14721,15172,'2014-01-01','ET','2',1,NULL,'Marlane Gaille','FI','438748436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:09',0,'2014-03-02 05:45:37'),(17408,18058,'0000-00-00','ET','2',1,NULL,'ronald wilkey','FI','279782829','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:47',0,'2014-03-01 17:20:55'),(17810,18460,'0000-00-00','ET','2',1,NULL,'Damein Rias','FI','425350478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:43',0,'2014-03-02 06:03:21'),(18202,18852,'0000-00-00','ET','2',1,NULL,'Samuel Niblock','FI','555138346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:54',0,'2014-03-01 17:26:36'),(18745,19395,'0000-00-00','ET','2',2,1,'James Delancy','FI','439215572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:26',0,'2014-03-02 06:45:14'),(18820,19470,'0000-00-00','ET','2',1,NULL,'Kathie Sue James','FI','458986745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:05',0,'2014-03-02 06:52:12'),(2089,2089,'2014-01-01','ET','2',2,1,'Robert Grega','FI','297660394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:41',0,'2014-03-10 13:20:27'),(7190,7190,'2014-01-01','ET','2',1,NULL,'Jasmine Hunt','FI','642264056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:20',0,'2014-03-02 03:09:49'),(6302,6302,'2014-01-01','ET','2',1,NULL,'Andrea Clincy','FI','426638496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:27',0,'2014-03-02 04:10:25'),(6175,6175,'2014-01-01','ET','2',1,NULL,'alma esquivel','FI','455353873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:34',0,'2014-03-02 04:10:25'),(4446,4446,'2014-01-01','ET','2',1,NULL,'KENNETH BAAFOUR-AMOAKO','FI','071761138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:18',0,'2014-03-01 15:16:37'),(4845,4845,'2014-01-01','ET','2',1,NULL,'Susan Tussing','FI','275788056','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:26',0,'2014-03-10 15:39:19'),(12383,12383,'2014-01-01','ET','2',1,NULL,'Constance Dekker','FI','345626207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:04',0,'2014-03-01 16:30:17'),(5419,5419,'2014-01-01','ET','2',1,NULL,'Janet Merkt','FI','287545380','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-12-31','Received',0,'2013-12-26 01:30:56',NULL,NULL),(5677,5677,'2014-01-01','ET','2',2,1,'John Hertzfeld','FI','284701266','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:19',0,'2014-03-10 13:52:32'),(13104,13460,'2014-01-01','ET','2',1,NULL,'ANDREA ORTEGA','FI','458754093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:09',0,'2014-03-02 05:17:40'),(15046,15497,'2014-01-01','ET','2',2,1,'Thomas Vicknair','FI','436376029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:29',0,'2014-03-02 05:45:37'),(15174,15625,'0000-00-00','ET','2',1,NULL,'Sharon Stennett','FI','436920468','Starmount Life Insurance Company','FI','720977315','Michael  Essex','94','17133170','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:44',0,'2014-03-02 05:52:31'),(15204,15655,'0000-00-00','ET','2',2,1,'Smita Patel','FI','334744039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:27',0,'2014-03-01 16:50:53'),(15249,15700,'0000-00-00','ET','2',1,NULL,'Annette Carson','FI','466158389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-21 08:45:28',0,'2014-03-02 05:52:31'),(15257,15708,'0000-00-00','ET','2',1,NULL,'NORA A STADLER','FI','287481123','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:45:34',0,'2014-03-10 16:17:47'),(16109,16758,'0000-00-00','ET','2',1,NULL,'Dana Robin Goldberg','FI','462838344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:24',0,'2014-03-02 06:03:21'),(17897,18547,'0000-00-00','ET','2',1,NULL,'ANA GUICARA','FI','051085945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:27',0,'2014-03-02 06:38:05'),(18954,19604,'0000-00-00','ET','2',1,NULL,'KAREN TIMSON','FI','271649665','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:41',0,'2014-03-10 14:31:05'),(19382,20032,'0000-00-00','ET','2',1,NULL,'Troy Nowak','FI','365925018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-18 22:00:54',0,'2014-03-01 17:34:07'),(19521,20171,'0000-00-00','ET','2',2,1,'LINDA BOGGAN','FI','289740464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:10:11',0,'2014-03-01 17:47:19'),(532,532,'2014-01-01','ET','2',2,1,'Eli Bates','FI','296907754','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:25',0,'2014-03-01 15:48:04'),(2064,2064,'2014-01-01','ET','2',1,NULL,'Theresa Johnson','FI','300503292','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:55',0,'2014-03-10 13:20:27'),(2108,2108,'2014-01-01','ET','2',1,NULL,'DEBORAH FRAUNFELTER','FI','268682769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:11',0,'2014-03-01 15:16:37'),(2513,2513,'2014-01-01','ET','2',1,0,'Daniel Lehmkuhl','FI','295523031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:25',0,'2014-03-01 15:05:09'),(5459,5459,'2014-01-01','ET','2',1,NULL,'JANICE MARIE BAZINET','FI','438801422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:07',0,'2014-03-02 04:45:37'),(6238,6238,'2014-01-01','ET','2',2,1,'JEANINE KHOURY','FI','269464542','HealthSpan','FI','311431434','KIRK  BERNHARD','94','2828814','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:32',0,'2014-03-10 13:32:15'),(7393,7393,'2014-01-01','ET','2',1,NULL,'Matthew Guercio','FI','547718785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:38',0,'2014-03-02 04:15:49'),(13856,14212,'2014-01-01','ET','2',1,NULL,'RONALD TAYLOR','FI','573755172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:51',0,'2014-03-02 05:31:31'),(13918,14274,'2014-01-01','ET','2',1,NULL,'ashley brittin','FI','274827176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:12',0,'2014-03-01 16:40:16'),(14678,15129,'2014-01-01','ET','2',1,NULL,'JACQUELINE ANDERSON','FI','269904692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:39',0,'2014-03-01 16:46:19'),(15887,16536,'0000-00-00','ET','2',1,NULL,'Kimberly Smith','FI','428531152','Starmount Life Insurance Company','FI','720977315','LaMonica  Stewart','94','6401868','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:05',0,'2014-03-02 06:03:21'),(16383,17033,'0000-00-00','ET','2',1,NULL,'george johnson','FI','322681624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:15',0,'2014-03-02 06:10:30'),(16473,17123,'0000-00-00','ET','2',1,NULL,'JOHNNY DUHON','FI','437517911','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:20',0,'2014-03-02 06:10:30'),(18601,19251,'0000-00-00','ET','2',2,1,'Lawren mccandless','FI','167602850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:35',0,'2014-03-01 17:26:36'),(109,109,'2014-01-01','ET','2',1,NULL,'Savannah Jones','FI','427652198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:19',0,'2014-03-01 22:10:55'),(5036,5036,'2014-01-01','ET','2',1,NULL,'Karen Browning','FI','287548468','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:08',0,'2014-03-01 15:31:33'),(6232,6232,'2014-01-01','ET','2',1,NULL,'ERNESTINE BYERS-LOWERY','FI','335508898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:21',0,'2014-03-01 16:00:27'),(12286,12286,'2014-01-01','ET','2',1,NULL,'Alexis Rodriguez','94','0001039760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:46',0,'2014-03-01 16:35:14'),(7380,7380,'2014-01-01','ET','2',1,NULL,'Melanie H Rick','FI','433196933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:30:10',0,'2014-03-02 04:10:25'),(12012,12012,'2014-01-01','ET','2',1,NULL,'Thomas Earl','FI','436139251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:33',0,'2014-03-02 04:59:36'),(11971,11971,'2014-01-01','ET','2',2,1,'CAROLINA CANTU','FI','099642322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:00',0,'2014-03-02 04:59:36'),(11920,11920,'2014-01-01','ET','2',1,NULL,'joan short','FI','415136034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:36',0,'2014-03-01 16:30:17'),(11897,11897,'2014-01-01','ET','2',1,NULL,'reginald bell','FI','434115499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:54',0,'2014-03-02 04:59:36'),(14815,15266,'2014-01-01','ET','2',2,1,'ronald cover','FI','284480007','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:08',0,'2014-03-10 16:17:47'),(16353,17003,'0000-00-00','ET','2',1,NULL,'Daniel Heaton','FI','309482582','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:56',0,'2014-03-01 16:56:22'),(17047,17697,'0000-00-00','ET','2',1,NULL,'Pearl Shelby','FI','433716159','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:29',0,'2014-03-02 06:24:38'),(17147,17797,'0000-00-00','ET','2',1,NULL,'Rebecca Lyttle','FI','291441711','Summa Insurance Company, Inc.','FI','341809108','john  Pequeno','94','9544739','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:31',0,'2014-03-10 16:24:30'),(17655,18305,'0000-00-00','ET','2',1,NULL,'Marynka Marquez','FI','629123231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:38',0,'2014-03-02 06:31:45'),(18552,19202,'0000-00-00','ET','2',5,4,'Theodore Nwanne','FI','084669590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:12',0,'2014-03-02 06:45:14'),(18732,19382,'0000-00-00','ET','2',1,NULL,'LaTonya Smith','FI','427617786','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:16',0,'2014-03-02 06:45:14'),(20794,21444,'0000-00-00','ET','2',1,NULL,'Rosemarie Vogel','FI','101423265','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:56',0,'2014-03-02 07:17:36'),(21672,22322,'0000-00-00','ET','2',1,NULL,'Amy Baggett','FI','426695258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:15',0,'2014-03-04 21:27:16'),(22365,23015,'0000-00-00','ET','2',1,NULL,'David Nevling','FI','293466225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:18',0,'2014-03-07 21:25:22'),(22702,23352,'0000-00-00','ET','2',1,NULL,'Nathan Lee','FI','270920094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:00',0,'2014-03-10 16:44:18'),(23004,23654,'0000-00-00','ET','2',4,3,'Brian Kerr','FI','296721946','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:54',0,'2014-03-10 21:17:52'),(5282,5282,'2014-01-01','ET','2',1,NULL,'ELIZABETH ROBERTS','FI','276422392','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:49',0,'2014-03-10 15:39:19'),(5321,5321,'2014-01-01','ET','2',1,NULL,'Deaneane DeLong','FI','281666455','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:15',0,'2014-03-10 13:03:33'),(7515,7515,'2014-01-01','ET','2',1,NULL,'reana barakakos','FI','142863238','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:31',0,'2014-03-01 16:05:34'),(10898,10898,'2014-01-01','ET','2',1,NULL,'kevin hanson','FI','426023527','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:34',0,'2014-03-02 04:24:47'),(6998,6998,'2014-01-01','ET','2',1,NULL,'Arman Torshizi','FI','729246724','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:24',0,'2014-03-02 02:10:49'),(13803,14159,'2014-01-01','ET','2',2,1,'jeffrey janovyak','FI','286945543','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:11',0,'2014-03-01 16:40:16'),(15646,16295,'0000-00-00','ET','2',3,2,'AMY HART','FI','460315403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:09',0,'2014-03-01 16:56:22'),(15892,16541,'0000-00-00','ET','2',1,NULL,'christoyua Gibbs','FI','427658163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:07',0,'2014-03-02 06:03:21'),(16140,16789,'0000-00-00','ET','2',2,1,'Patricia Bonifas','FI','280520047','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:49',0,'2014-03-10 14:20:26'),(17410,18060,'0000-00-00','ET','2',1,NULL,'Rebecca Brandt','FI','342482612','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:49',0,'2014-03-10 14:24:38'),(20097,20747,'0000-00-00','ET','2',1,NULL,'Tracie Thibodeaux','FI','437691708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:17',0,'2014-03-02 07:10:28'),(22403,23053,'0000-00-00','ET','2',1,NULL,'Jim Tillett','FI','008442500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:01',0,'2014-03-07 22:26:59'),(334,334,'2014-01-01','ET','2',1,NULL,'Paul Tankovich','FI','274744202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:16',0,'2014-03-01 15:21:15'),(12124,12124,'2014-01-01','ET','2',1,NULL,'DONNA GROTENRATH','FI','396626977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:35',0,'2014-03-01 16:30:17'),(11805,11805,'2014-01-01','ET','2',1,NULL,'candace kauntz','FI','270586776','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','348','2014-01-01','Sync Success',1,'2013-12-29 11:13:14',0,'2014-03-01 16:15:39'),(11772,11772,'2014-01-01','ET','2',1,NULL,'Brad Negrotto','FI','438619370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:04',0,'2014-03-02 04:59:36'),(1159,1159,'2014-01-01','ET','2',1,NULL,'adlina rivera','FI','583283516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:28',0,'2014-03-02 04:38:08'),(7634,7634,'2014-01-01','ET','2',1,NULL,'CAROYLN JEAN  SMITH','FI','567847362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:20',0,'2014-03-02 04:15:49'),(7271,7271,'2014-01-01','ET','2',1,NULL,'David Walker','FI','372681830','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:08:50',0,'2014-03-10 13:32:15'),(1883,1883,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:20',0,'2014-03-01 23:10:52'),(6444,6444,'2014-01-01','ET','2',1,NULL,'HOLLY PATTERSON','FI','450556458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:54',0,'2014-03-01 20:10:57'),(6083,6083,'2014-01-01','ET','2',1,NULL,'Megan Tatiana Kaye','FI','276044654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:49',0,'2014-03-01 16:00:27'),(6042,6042,'2014-01-01','ET','2',1,0,'Constance Karniotis','FI','281868975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:18',0,'2014-03-01 15:05:09'),(5748,5748,'2014-01-01','ET','2',1,NULL,'Albert R Oettli','FI','434841333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:49',0,'2014-03-02 01:10:33'),(4808,4808,'2014-01-01','ET','2',1,NULL,'Alana Johnson','FI','291506496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:06',0,'2014-03-01 15:16:37'),(2708,2708,'2014-01-01','ET','2',1,NULL,'Terrence J Smith','FI','452041161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:27',0,'2014-03-02 04:15:49'),(2919,2919,'2014-01-01','ET','2',1,NULL,'todd scalf','FI','281888111','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:32',0,'2014-03-01 15:37:30'),(14062,14513,'2014-01-01','ET','2',1,NULL,'Jeremy Plummer','FI','288865075','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:11',0,'2014-03-10 14:03:26'),(15890,16539,'0000-00-00','ET','2',1,NULL,'SHIRLEY GRANT','FI','425040737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:06',0,'2014-03-02 06:03:21'),(16852,17502,'0000-00-00','ET','2',1,NULL,'GWAYNE A BRISSETT','FI','279138468','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-02 19:00:26',0,'2014-03-10 14:20:26'),(18870,19520,'0000-00-00','ET','2',2,1,'Janet  Cunningham','FI','299888147','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:39',0,'2014-03-01 17:34:07'),(19369,20019,'0000-00-00','ET','2',1,NULL,'Douglas Holloway','FI','299600256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-05','Sync Success',0,'2014-02-18 22:00:46',0,'2014-03-01 17:34:07'),(20200,20850,'0000-00-00','ET','2',1,NULL,'Daniel Rothkrug','FI','451493611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:30',0,'2014-03-02 07:10:28'),(20637,21287,'0000-00-00','ET','2',1,NULL,'Jacqueline Osborn','FI','522723597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:15',0,'2014-03-02 07:10:28'),(22679,23329,'0000-00-00','ET','2',2,1,'CHRISTINA LEJEUNE','FI','051662792','Starmount Life Insurance Company','FI','720977315','ABRAM  FREEMAN','94','1219092','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:43',0,'2014-03-08 22:26:18'),(105,105,'2014-01-01','ET','2',1,NULL,'Thomas  Roemish','FI','450391971','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:11',0,'2014-03-01 22:10:55'),(7328,7328,'2014-01-01','ET','2',1,NULL,'MICHAEL ANTHONY RINELLA','FI','270965790','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:10:35',0,'2014-03-10 15:59:47'),(748,748,'2014-01-01','ET','2',2,1,'PHILLIP Q OWENS','FI','323486224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:17',0,'2014-03-02 02:10:49'),(5849,5849,'2014-01-01','ET','2',1,NULL,'April Reyes','FI','093722921','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:07',0,'2014-03-10 15:39:19'),(5045,5045,'2014-01-01','ET','2',1,NULL,'Amy Thorton','FI','299722733','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:25',0,'2014-03-01 15:31:33'),(2319,2319,'2014-01-01','ET','2',1,NULL,'Clark Beckett','FI','445945566','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:53',0,'2014-03-01 19:11:03'),(3688,3688,'2014-01-01','ET','2',1,NULL,'Dewey Warden','FI','277544735','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:06',0,'2014-03-10 13:24:34'),(3792,3792,'2014-01-01','ET','2',1,NULL,'Shemekisa Jobe','FI','553719706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:16:02',0,'2014-03-01 23:10:52'),(13982,14338,'2014-01-01','ET','2',1,NULL,'MARIA D NICOLAS','FI','453879659','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:17',0,'2014-03-02 05:31:31'),(15826,16475,'0000-00-00','ET','2',1,NULL,'timothy oneal','FI','436510299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:26',0,'2014-03-02 06:03:21'),(17153,17803,'0000-00-00','ET','2',1,NULL,'THOMAS TERRY','FI','427065944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:35',0,'2014-03-02 06:24:38'),(18174,18824,'0000-00-00','ET','2',1,NULL,'kimberly  a taylor','FI','276524541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:33',0,'2014-03-01 17:26:36'),(18694,19344,'0000-00-00','ET','2',1,NULL,'Thuy Le','FI','732186509','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:48',0,'2014-03-02 06:52:12'),(18855,19505,'0000-00-00','ET','2',1,NULL,'Myrthe Brown','FI','433597033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:29',0,'2014-03-02 06:52:12'),(21679,22329,'0000-00-00','ET','2',1,NULL,'CONNIE DENISE GARRISON','FI','428029027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:21',0,'2014-03-04 21:27:16'),(22530,23180,'0000-00-00','ET','2',2,1,'Kevin Ross','FI','164420843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:32',0,'2014-03-07 21:36:32'),(22797,23447,'0000-00-00','ET','2',1,NULL,'Larry Rodriguiez','FI','291642958','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:48',0,'2014-03-09 21:35:27'),(1361,1361,'2014-01-01','ET','2',1,NULL,'Jacob Willetts','FI','644249927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:52:47',0,'2014-03-02 04:38:08'),(13327,13683,'2014-01-01','ET','2',1,NULL,'Angela Burney','FI','416137804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:22',0,'2014-03-02 05:24:45'),(4115,4115,'2014-01-01','ET','2',2,1,'rosemarie morris','FI','271700665','Dental Care Plus, Inc.','FI','311185262','dennis  tucker','94','1780702','348','2014-01-01','Sync Success',0,'2013-12-25 23:03:40',0,'2014-03-01 16:00:27'),(11287,11287,'2014-01-01','ET','2',1,NULL,'Gene Fredericks','FI','152443702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:07',0,'2014-03-02 04:52:44'),(5280,5280,'2014-01-01','ET','2',1,NULL,'Taylor Fields','FI','061783200','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:44',0,'2014-03-01 15:10:22'),(5840,5840,'2014-01-01','ET','2',1,NULL,'Patricia Bagadion','FI','294649133','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:46',0,'2014-03-01 15:10:22'),(17952,18602,'0000-00-00','ET','2',1,NULL,'Charles Graf','FI','293880683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:05',0,'2014-03-01 17:20:55'),(21156,21806,'0000-00-00','ET','2',1,NULL,'CHENELLE CARR','FI','438496295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:25',0,'2014-03-02 07:23:39'),(21310,21960,'0000-00-00','ET','2',4,3,'Hollis Gaskill','FI','286806141','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:02',0,'2014-03-10 14:45:25'),(21742,22392,'0000-00-00','ET','2',3,2,'Myong Choe','FI','298829629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:13',0,'2014-03-10 14:45:25'),(21979,22629,'0000-00-00','ET','2',1,NULL,'ANN LOWERY','FI','425021252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:39',0,'2014-03-05 22:27:33'),(497,497,'2014-01-01','ET','2',1,NULL,'Mimi FALL','FI','293080665','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:23',0,'2014-03-01 15:48:04'),(1432,1432,'2014-01-01','ET','2',1,NULL,'Floyd Smith','FI','284708879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:55:07',0,'2014-03-01 16:15:39'),(12511,12511,'2014-01-01','ET','2',1,NULL,'Van Bui','FI','586145273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:33:48',0,'2014-03-02 05:03:29'),(2177,2177,'2014-01-01','ET','2',1,NULL,'Jessica Hernandez','FI','457598294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:23',0,'2014-03-01 21:11:04'),(2369,2369,'2014-01-01','ET','2',1,NULL,'Mae Nicholson','FI','288502076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:19',0,'2014-03-01 15:26:40'),(11502,11502,'2014-01-01','ET','2',2,1,'Benjamin Ayers','FI','438773980','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:43',0,'2014-03-02 04:52:44'),(11477,11477,'2014-01-01','ET','2',2,1,'philip robinson','FI','401985040','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:58',0,'2014-03-01 16:30:17'),(10690,10690,'2014-01-01','ET','2',1,NULL,'Pamela Sweet','FI','282621399','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:08',0,'2014-03-01 16:10:36'),(2536,2536,'2014-01-01','ET','2',1,NULL,'Lisa Zaret','FI','283505390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:06',0,'2014-03-01 15:10:22'),(7662,7662,'2014-01-01','ET','2',1,NULL,'jeanne smith','FI','262276087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:13',0,'2014-03-10 13:39:10'),(7582,7582,'2014-01-01','ET','2',2,1,'ngan nguyen','FI','443827485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:41',0,'2014-03-01 16:05:34'),(6452,6452,'2014-01-01','ET','2',2,1,'SHARON  LYNN HOFFMAN','FI','299525537','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:10',0,'2014-03-10 15:39:19'),(2707,2707,'2014-01-01','ET','2',1,NULL,'Sean Moran','FI','454253737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:25',0,'2014-03-02 04:15:49'),(15479,15930,'0000-00-00','ET','2',1,NULL,'sedgie foxworth','FI','428022174','Starmount Life Insurance Company','FI','720977315','sedgie  foxworth','94','6400105','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:00',0,'2014-03-02 05:59:43'),(16616,17266,'0000-00-00','ET','2',1,NULL,'Edelba Kercado','FI','583407577','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:18',0,'2014-03-02 06:17:30'),(16694,17344,'0000-00-00','ET','2',1,NULL,'Amanda Hoffmaster','FI','314967009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:13',0,'2014-03-01 17:00:58'),(18066,18716,'0000-00-00','ET','2',1,NULL,'Misty Romo','FI','454659470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:12',0,'2014-03-02 06:38:05'),(19160,19810,'0000-00-00','ET','2',1,NULL,'Demetra Robertson','FI','456539284','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:31',0,'2014-03-02 06:52:12'),(19923,20573,'0000-00-00','ET','2',1,NULL,'Zachary McCain','FI','415639064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:18',0,'2014-03-02 07:03:25'),(21238,21888,'0000-00-00','ET','2',2,1,'MARK EBERLE','FI','276564516','Dental Care Plus, Inc.','FI','311185262','REX  EBERLE','94','1477652','348','2014-03-01','Sync Success',0,'2014-03-01 21:00:22',0,'2014-03-01 21:35:40'),(22496,23146,'0000-00-00','ET','2',1,NULL,'CINDY RENTSCHLER','FI','296608590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:07',0,'2014-03-07 21:36:32'),(23118,23768,'0000-00-00','ET','2',1,NULL,'Alica Thomas','FI','452954900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:15',0,'2014-03-10 22:25:11'),(435,435,'2014-01-01','ET','2',1,NULL,'Rachell Bateman','FI','427477350','Starmount Life Insurance Company','FI','720977315','Mike  Patterson','94','7379777','348','2014-01-01','Sync Success',0,'2013-12-25 17:49:30',0,'2014-03-01 22:10:55'),(1110,1110,'2014-01-01','ET','2',1,0,'Raymond Edge','FI','459619281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:26',0,'2014-03-01 19:11:03');
INSERT INTO `Edi834` VALUES (1313,1313,'2014-01-01','ET','2',1,NULL,'GLENDA GIVENS','FI','466498713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:14',0,'2014-03-02 04:38:08'),(11878,11878,'2014-01-01','ET','2',2,1,'Carl Spyres','FI','446529484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:18',0,'2014-03-02 04:59:36'),(2689,2689,'2014-01-01','ET','2',1,NULL,'gelila haileselassie','FI','212736059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:49',0,'2014-03-02 04:15:49'),(2939,2939,'2014-01-01','ET','2',1,NULL,'Laura Eaton','FI','302660749','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:13',0,'2014-03-01 15:37:30'),(3565,3565,'2014-01-01','ET','2',1,NULL,'Donna Pate','FI','465498962','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-25 22:03:17',0,'2014-03-02 00:10:48'),(3964,3964,'2014-01-01','ET','2',3,2,'Harry  Kontos','FI','269545905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:03',0,'2014-03-01 15:26:40'),(5175,5175,'2014-01-01','ET','2',1,NULL,'Bonita Tipton','FI','276548215','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:33',0,'2014-03-10 13:20:27'),(13491,13847,'2014-01-01','ET','2',1,NULL,'Naomi Broadway','FI','245630965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:10',0,'2014-03-02 05:31:31'),(14067,14518,'2014-01-01','ET','2',1,NULL,'Bruce Lathon','FI','332508827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:14',0,'2014-03-02 05:38:34'),(15903,16552,'0000-00-00','ET','2',1,NULL,'Lawanda  Hall','FI','397783471','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:14',0,'2014-03-10 14:10:12'),(15950,16599,'0000-00-00','ET','2',2,1,'debra slone','FI','295582496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:02',0,'2014-03-01 16:56:22'),(20053,20703,'0000-00-00','ET','2',1,NULL,'Yvette Martinez','FI','464730077','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-03-01','Sync Success',0,'2014-02-25 21:00:14',0,'2014-03-02 07:10:28'),(21965,22615,'0000-00-00','ET','2',1,NULL,'Beth Teschan Ferguson','FI','297702421','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:29',0,'2014-03-10 16:44:18'),(169,169,'2014-01-01','ET','2',1,NULL,'Evelyn Crutcher','FI','415902461','HealthSpan','FI','311431434','Renia  Maxson','94','16508707','348','2014-01-01','Sync Success',0,'2013-12-25 17:20:16',0,'2014-03-10 13:10:24'),(13461,13817,'2014-01-01','ET','2',2,1,'DWIEGHT  JENNINGS','FI','302542726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:27',0,'2014-03-01 16:40:16'),(1454,1454,'2014-01-01','ET','2',6,5,'Gary Michael Bepler','FI','288784310','Dental Care Plus, Inc.','FI','311185262','Marie  Zuniga','94','1519795','348','2014-01-01','Sync Success',0,'2013-12-25 18:55:50',0,'2014-03-01 16:15:39'),(12580,12580,'2014-01-01','ET','2',1,NULL,'deven rine','FI','298920155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:23',0,'2014-03-01 16:35:14'),(11191,11191,'2014-01-01','ET','2',1,NULL,'VALERIE HOGAN-FULLER','FI','291582094','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:10',0,'2014-03-01 16:23:43'),(1879,1879,'2014-01-01','ET','2',1,NULL,'MARY H MOORE','FI','449929197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:12',0,'2014-03-01 23:10:52'),(7657,7657,'2014-01-01','ET','2',1,NULL,'Mary Morgan','FI','426026311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:04',0,'2014-03-02 04:15:49'),(1916,1916,'2014-01-01','ET','2',1,NULL,'Gabriel Alridge','FI','633166814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:13',0,'2014-03-01 23:10:52'),(6310,6310,'2014-01-01','ET','2',1,NULL,'Jennifer Lynn Gehring','FI','206660233','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:42',0,'2014-03-10 15:59:47'),(6097,6097,'2014-01-01','ET','2',1,NULL,'Elmer George Handy','FI','287708181','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:14',0,'2014-03-01 16:00:27'),(2736,2736,'2014-01-01','ET','2',1,NULL,'Kecia Brown','FI','436435845','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-25 21:18:18',0,'2014-03-02 04:15:49'),(13545,13901,'2014-01-01','ET','2',1,NULL,'Joan Woodard','FI','439965233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:46',0,'2014-03-02 05:31:31'),(15441,15892,'0000-00-00','ET','2',1,NULL,'Elizabeth Csepegi','FI','273902780','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:36',0,'2014-03-10 16:17:47'),(15664,16313,'0000-00-00','ET','2',1,NULL,'Brandon Kilby','FI','275889977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:23',0,'2014-03-01 16:56:22'),(17790,18440,'0000-00-00','ET','2',1,NULL,'Brenda Payne Riley','FI','288707541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:25',0,'2014-03-01 16:56:22'),(17809,18459,'0000-00-00','ET','2',1,NULL,'CHARLES MOORE','FI','587210661','Starmount Life Insurance Company','FI','720977315','DOROTHY  MILTON','94','8460655','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:42',0,'2014-03-02 06:03:21'),(18610,19260,'0000-00-00','ET','2',1,NULL,'MAURA ANDERSON','FI','284923518','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:00:43',0,'2014-03-10 16:31:33'),(19664,20314,'0000-00-00','ET','2',1,NULL,'Jason Baker','FI','283765267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:34',0,'2014-03-01 17:47:19'),(20752,21402,'0000-00-00','ET','2',1,NULL,'Corine Richards','FI','428080324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:36',0,'2014-03-02 07:17:36'),(21252,21902,'0000-00-00','ET','2',1,NULL,'PURNA POLISETTI','FI','278158742','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:32',0,'2014-03-01 21:35:40'),(21685,22335,'0000-00-00','ET','2',2,1,'JAMES GROVE','FI','282788433','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:26',0,'2014-03-04 21:36:30'),(3761,3761,'2014-01-01','ET','2',1,NULL,'Michelle Aucoin','FI','553854483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:02',0,'2014-03-01 23:10:52'),(10518,10518,'2014-01-01','ET','2',2,1,'Melody Lalime','FI','441624028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:24',0,'2014-03-02 04:24:47'),(7653,7653,'2014-01-01','ET','2',1,NULL,'WILLIAM PIOTROWSKI','FI','283643374','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:38:58',0,'2014-03-10 13:39:10'),(4149,4149,'2014-01-01','ET','2',1,NULL,'Olga Baron','FI','296081955','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:40',0,'2014-03-01 16:00:27'),(10616,10616,'2014-01-01','ET','2',1,NULL,'Stacey Cole','FI','429630480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:43',0,'2014-03-02 04:24:47'),(13905,14261,'2014-01-01','ET','2',1,NULL,'Paul Myers','FI','270884207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:05',0,'2014-03-01 16:40:16'),(14461,14912,'2014-01-01','ET','2',1,NULL,'Alicia Bodin','FI','434535541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:35',0,'2014-03-02 05:45:37'),(15220,15671,'0000-00-00','ET','2',1,NULL,'Audrey Claiborne','FI','433047606','Starmount Life Insurance Company','FI','720977315','Delores  Madrigal','94','12397055','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:39',0,'2014-03-02 05:52:31'),(15622,16073,'0000-00-00','ET','2',2,1,'FRANCO CONTI','FI','278500559','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:46',0,'2014-03-10 16:17:47'),(17044,17694,'0000-00-00','ET','2',1,NULL,'Karen Musleve','FI','295669583','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:27',0,'2014-03-10 16:24:30'),(18468,19118,'0000-00-00','ET','2',1,NULL,'danica benford','FI','568194355','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:49',0,'2014-03-02 06:45:14'),(18966,19616,'0000-00-00','ET','2',1,NULL,'MARY BRIDGEFORD','FI','273666885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:49',0,'2014-03-10 14:31:05'),(19599,20249,'0000-00-00','ET','2',1,NULL,'Cimarron Gilson','FI','452539182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:32:08',0,'2014-03-02 06:59:07'),(20273,20923,'0000-00-00','ET','2',1,NULL,'Lakendra Dunomes','FI','433739014','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-04-01','Sync Success',0,'2014-02-26 08:00:19',0,'2014-03-02 07:03:25'),(21184,21834,'0000-00-00','ET','2',4,3,'muhammad samaha','FI','443763155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:46',0,'2014-03-02 07:23:39'),(934,934,'2014-01-01','ET','2',2,1,'Robert Harper','FI','438983711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:10',0,'2014-03-01 21:11:04'),(1168,1168,'2014-01-01','ET','2',1,NULL,'Yvonne Stallings','FI','346703636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:44',0,'2014-03-02 04:38:08'),(12814,12814,'2014-01-01','ET','2',1,NULL,'regina middleton','FI','438435298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:46',0,'2014-03-02 05:10:52'),(3619,3619,'2014-01-01','ET','2',1,NULL,'Jeannfer Flowers','FI','639168738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:57',0,'2014-03-02 01:10:33'),(12331,12331,'2014-01-01','ET','2',1,NULL,'Stephen Nguyen','FI','482041130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:15',0,'2014-03-02 05:03:29'),(4460,4460,'2014-01-01','ET','2',1,NULL,'Baylee Nicole Rosfeld','FI','290964645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:45',0,'2014-03-01 15:16:37'),(5075,5075,'2014-01-01','ET','2',1,NULL,'Angela Donahue','FI','301862394','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:24',0,'2014-03-01 15:31:33'),(7714,7714,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:57',0,'2014-03-01 20:10:57'),(7710,7710,'2014-01-01','ET','2',2,1,'sherry guajardo','FI','452337714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:48',0,'2014-03-01 20:10:57'),(5439,5439,'2014-01-01','ET','2',2,1,'Tenaya Erica Bolin-Devore','FI','302725611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:37',0,'2014-03-01 15:05:09'),(15217,15668,'0000-00-00','ET','2',1,NULL,'DEMETRIOS FRUGA','FI','437833672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:37',0,'2014-03-02 05:52:31'),(15794,16443,'0000-00-00','ET','2',1,NULL,'Phyllis Roblow','FI','455136333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:08',0,'2014-03-02 06:03:21'),(16679,17329,'0000-00-00','ET','2',1,NULL,'ROBIN HARPER','FI','426433671','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:01',0,'2014-03-02 06:17:30'),(17211,17861,'0000-00-00','ET','2',1,NULL,'Donna Mathias','FI','270767021','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:11',0,'2014-03-01 17:20:55'),(17713,18363,'0000-00-00','ET','2',1,NULL,'bradley r crawford','FI','465811733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:11',0,'2014-03-02 06:31:45'),(17767,18417,'0000-00-00','ET','2',1,NULL,'Lisa Torres','FI','627301095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:07',0,'2014-03-02 06:03:21'),(19041,19691,'0000-00-00','ET','2',1,NULL,'Lori Elliott','FI','295687898','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:13',0,'2014-03-10 14:31:05'),(19514,20163,'0000-00-00','ET','2',5,4,'AUSTIN ONWUAGBA','FI','272176442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:07:47',0,'2014-03-01 17:34:07'),(21824,22474,'0000-00-00','ET','2',1,NULL,'EZEKIEL LESLIE WILSON','FI','294666967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:19',0,'2014-03-05 21:36:22'),(164,164,'2014-01-01','ET','2',1,NULL,'Marie Prock','FI','301467822','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:06',0,'2014-03-10 15:45:56'),(12933,12933,'2014-01-01','ET','2',2,1,'SANDRA HARTZEL','FI','280584077','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:06:12',0,'2014-03-10 13:59:38'),(832,832,'2014-01-01','ET','2',2,1,'Seth Sullivan','FI','426633354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:05',0,'2014-03-01 22:10:55'),(1940,1940,'2014-01-01','ET','2',1,NULL,'Michelle Murphy','FI','269807096','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:56',0,'2014-03-01 15:26:40'),(11546,11546,'2014-01-01','ET','2',2,1,'steven mancine','FI','007469873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:00',0,'2014-03-02 04:52:44'),(2019,2019,'2014-01-01','ET','2',1,NULL,'Brian Bradford','FI','433352695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:29',0,'2014-03-01 23:10:52'),(2310,2310,'2014-01-01','ET','2',1,NULL,'Ashley Donohoe','FI','292882815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:36',0,'2014-03-01 15:05:09'),(7669,7669,'2014-01-01','ET','2',3,2,'Adam Hayden','FI','305026306','HealthSpan','FI','311431434','Peggy  Yates','94','1877824','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:28',0,'2014-03-10 13:39:10'),(7666,7666,'2014-01-01','ET','2',3,2,'MICHAEL JULIUS','FI','280525544','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:21',0,'2014-03-10 13:39:10'),(7556,7556,'2014-01-01','ET','2',1,NULL,'DIANE PORTER COZART','FI','301525996','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:49',0,'2014-03-01 16:05:34'),(2490,2490,'2014-01-01','ET','2',1,NULL,'REBECCA KERSEY','FI','285547125','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:12',0,'2014-03-10 13:10:24'),(7473,7473,'2014-01-01','ET','2',2,1,'Jessica Brown','94','0000623645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:02',0,'2014-03-02 04:15:49'),(5706,5706,'2014-01-01','ET','2',2,1,'Terrie  Powell','FI','282604214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:39',0,'2014-03-01 15:37:30'),(16378,17028,'0000-00-00','ET','2',1,NULL,'JOSE L MEJIA','FI','632682730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:12',0,'2014-03-02 06:10:30'),(17701,18351,'0000-00-00','ET','2',1,NULL,'Isaac Quaye','FI','752134585','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:30:11',0,'2014-03-10 14:24:38'),(19987,20637,'0000-00-00','ET','2',1,NULL,'Sheryl Parent','FI','587384727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:43',0,'2014-03-02 07:03:25'),(16269,16919,'0000-00-00','ET','2',1,NULL,'Alexis Martinovich','FI','614189038','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:04',0,'2014-03-02 06:10:30'),(16594,17244,'0000-00-00','ET','2',1,NULL,'Susan Myers','FI','272828844','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:39',0,'2014-03-10 14:20:26'),(17106,17756,'0000-00-00','ET','2',1,NULL,'Michelle Weaver','FI','279821884','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:04',0,'2014-03-01 17:00:58'),(18884,19534,'0000-00-00','ET','2',1,NULL,'Lauren Jester','FI','291861934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:50',0,'2014-03-01 17:34:07'),(19441,20091,'0000-00-00','ET','2',1,NULL,'Pamela Jackson','FI','278729770','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:39',0,'2014-03-10 14:37:47'),(19992,20642,'0000-00-00','ET','2',1,NULL,'ROBERT BROWN','FI','437132181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:46',0,'2014-03-02 07:03:25'),(21049,21699,'0000-00-00','ET','2',4,3,'Angela Christy','FI','284826023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:10',0,'2014-03-01 18:10:11'),(21280,21930,'0000-00-00','ET','2',1,NULL,'Al Brennan','FI','440660956','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:49',0,'2014-03-02 07:23:39'),(21527,22177,'0000-00-00','ET','2',2,1,'MARIBEL PEREZ','FI','453839186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:14',0,'2014-03-03 22:26:43'),(21751,22401,'0000-00-00','ET','2',3,2,'REBECCA PHILLIPS','FI','286687942','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:21',0,'2014-03-10 16:44:18'),(21914,22564,'0000-00-00','ET','2',1,NULL,'MARIBEL PEREZ','FI','453839186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:54',0,'2014-03-05 22:27:33'),(4534,4534,'2014-01-01','ET','2',1,NULL,'Joan Soskin','FI','470192467','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:09',0,'2014-03-10 16:03:49'),(13359,13715,'2014-01-01','ET','2',1,NULL,'Mary Porras','FI','450130265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:36',0,'2014-03-02 05:24:45'),(7751,7751,'2014-01-01','ET','2',1,NULL,'William Chritton','FI','390062299','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:54',0,'2014-03-10 15:39:19'),(5429,5429,'2014-01-01','ET','2',1,0,'Justin Wilson','FI','519984110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:18',0,'2014-03-01 19:11:03'),(6110,6110,'2014-01-01','ET','2',1,NULL,'Joel Roewer','FI','273929166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:36',0,'2014-03-01 16:00:27'),(6306,6306,'2014-01-01','ET','2',1,NULL,'Zachary McCain','FI','415639064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:34',0,'2014-03-02 04:10:25'),(14368,14819,'2014-01-01','ET','2',1,NULL,'Valerie Howatt','FI','298882028','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:53',0,'2014-03-10 16:17:47'),(15862,16511,'0000-00-00','ET','2',2,1,'Shawn Caughey','FI','277567504','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:49',0,'2014-03-10 16:24:30'),(16589,17239,'0000-00-00','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-30 21:01:36',0,'2014-03-10 14:20:26'),(16834,17484,'0000-00-00','ET','2',1,NULL,'joseph yaegel','FI','407196485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:15',0,'2014-03-01 17:00:58'),(17054,17704,'0000-00-00','ET','2',1,NULL,'Jose Jaquez','FI','629907200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:32',0,'2014-03-02 06:24:38'),(17435,18085,'0000-00-00','ET','2',1,NULL,'Ever Bujanda Herrera','FI','523069309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:05',0,'2014-03-02 06:31:45'),(18480,19130,'0000-00-00','ET','2',1,NULL,'GEORGE ADAM WEBB','FI','425736569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:56',0,'2014-03-02 06:45:14'),(21333,21983,'0000-00-00','ET','2',1,NULL,'Geoffrey Estep','FI','272786732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:14',0,'2014-03-03 01:35:37'),(21367,22017,'0000-00-00','ET','2',1,NULL,'Quoc Pho','FI','632588496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:34',0,'2014-03-03 01:07:25'),(21516,22166,'0000-00-00','ET','2',1,NULL,'JESUS DURON LOPEZ','FI','454131565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:07',0,'2014-03-03 22:26:43'),(433,433,'2014-01-01','ET','2',1,NULL,'Mary Melissa Boone','FI','426372507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:28',0,'2014-03-01 22:10:55'),(713,713,'2014-01-01','ET','2',2,1,'Laura M Berry','FI','302708225','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:10',0,'2014-03-10 13:24:34'),(1662,1662,'2014-01-01','ET','2',2,1,'Everett Warren','FI','288508526','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:18',0,'2014-03-10 15:45:56'),(11959,11959,'2014-01-01','ET','2',1,NULL,'Danielle Autrey','FI','628340068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:32',0,'2014-03-02 04:59:36'),(2228,2228,'2014-01-01','ET','2',3,2,'ERIN ANNE LUOMA','FI','298867052','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:08',0,'2014-03-10 15:39:19'),(11056,11056,'2014-01-01','ET','2',1,NULL,'Josh Hamilton','FI','155626097','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:40',0,'2014-03-10 13:45:57'),(10685,10685,'2014-01-01','ET','2',2,1,'Vincent Spehar','FI','285766564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:59',0,'2014-03-01 16:10:36'),(4224,4224,'2014-01-01','ET','2',2,1,'JEREMY SPENCE','FI','421170204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:58',0,'2014-03-01 16:00:27'),(7042,7042,'2014-01-01','ET','2',2,1,'Sonya A Temple','FI','452731963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:48',0,'2014-03-02 03:09:49'),(6425,6425,'2014-01-01','ET','2',1,NULL,'LINDA JANSON','FI','276448198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:18',0,'2014-03-01 15:10:22'),(4660,4660,'2014-01-01','ET','2',2,1,'roy newberry','94','0000100065','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:15',0,'2014-03-10 13:45:57'),(4836,4836,'2014-01-01','ET','2',1,NULL,'CATHY WOOD','FI','279568347','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:11',0,'2014-03-01 15:10:22'),(14082,14533,'2014-01-01','ET','2',1,NULL,'Lee P Reynolds','FI','641093725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:24',0,'2014-03-02 05:38:34'),(16054,16703,'0000-00-00','ET','2',1,NULL,'Nathaniel Love','FI','258083010','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:46',0,'2014-03-01 16:56:22'),(16528,17178,'0000-00-00','ET','2',1,NULL,'Raul Ortiz','FI','457088267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:56',0,'2014-03-02 06:10:30'),(17508,18158,'0000-00-00','ET','2',2,1,'NOEL HURTADO','FI','562934432','Starmount Life Insurance Company','FI','720977315','VIANEY  MARTINEZ','94','15750460','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:06',0,'2014-03-02 06:31:45'),(17621,18271,'0000-00-00','ET','2',1,NULL,'Bernita Stevenson','FI','435844509','Starmount Life Insurance Company','FI','720977315','Percy Paul McCraney','94','9000490','357','2014-03-01','Sync Success',0,'2014-02-08 19:00:16',0,'2014-03-02 06:31:45'),(17857,18507,'0000-00-00','ET','2',1,NULL,'Christine Thornton','FI','299825891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-21','Sync Success',0,'2014-02-10 21:00:08',0,'2014-03-01 17:20:55'),(17870,18520,'0000-00-00','ET','2',1,NULL,'alex thomas','FI','290941331','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:06',0,'2014-03-10 16:31:33'),(19817,20467,'0000-00-00','ET','2',1,NULL,'colleen wise','FI','346626400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:36',0,'2014-03-02 07:03:25'),(20216,20866,'0000-00-00','ET','2',1,NULL,'JANEEN BRAUN','FI','290707675','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:31:42',0,'2014-03-10 14:37:47'),(20530,21180,'0000-00-00','ET','2',1,NULL,'Vernon Wear','FI','461374372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:04',0,'2014-03-02 07:10:28'),(22023,22673,'0000-00-00','ET','2',1,NULL,'PATRICIA TRICHEL','FI','454578331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:08',0,'2014-03-05 22:27:33'),(22982,23632,'0000-00-00','ET','2',1,NULL,'BECKY EVANS-HENRY','FI','278524973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:01:38',0,'2014-03-10 21:36:25'),(1441,1441,'2014-01-01','ET','2',4,3,'Amanda Pressel','FI','281762779','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:24',0,'2014-03-01 16:15:39'),(2290,2290,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:50',0,'2014-03-01 21:11:04'),(2504,2504,'2014-01-01','ET','2',2,1,'Patrick J Waldron','FI','488664526','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:10',0,'2014-03-01 19:11:03'),(12629,12629,'2014-01-01','ET','2',1,NULL,'aileen  anne  brom','FI','378194532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:05',0,'2014-03-02 05:10:52'),(3104,3104,'2014-01-01','ET','2',1,NULL,'Michael Ducote','FI','434790309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:18',0,'2014-03-02 01:10:33'),(3486,3486,'2014-01-01','ET','2',1,NULL,'ANGEL SPERMAN','FI','279700684','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:44',0,'2014-03-01 15:37:30'),(12263,12263,'2014-01-01','ET','2',1,NULL,'Erin Strackbein','FI','459930744','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:56',0,'2014-03-02 05:10:52'),(4956,4956,'2014-01-01','ET','2',1,NULL,'SHEILA  R HIRSCHFELD','FI','291483629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:03',0,'2014-03-10 13:03:33'),(7094,7094,'2014-01-01','ET','2',1,NULL,'Sharon M Ceena','FI','083442803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:26',0,'2014-03-01 15:52:44'),(11421,11421,'2014-01-01','ET','2',1,NULL,'Laura L Potts','FI','296468656','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:14',0,'2014-03-10 16:03:49'),(10831,10831,'2014-01-01','ET','2',2,1,'Glenda Bureau Gaines','FI','433046553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:53',0,'2014-03-02 04:31:46'),(7560,7560,'2014-01-01','ET','2',1,NULL,'Zachary Holcomb','FI','295905395','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:59',0,'2014-03-01 16:05:34'),(16171,16820,'0000-00-00','ET','2',1,NULL,'DIANE SMITH','FI','383560974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:20',0,'2014-03-01 16:56:22'),(19709,20359,'0000-00-00','ET','2',1,NULL,'Mathew Swingle','FI','280821022','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:56:36',0,'2014-03-10 16:38:05'),(19938,20588,'0000-00-00','ET','2',1,NULL,'khaled atallah','FI','645509985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:06',0,'2014-03-02 07:03:25'),(20706,21356,'0000-00-00','ET','2',1,NULL,'nathan nyhart','FI','298969737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:14',0,'2014-03-01 18:08:07'),(21568,22218,'0000-00-00','ET','2',1,NULL,'kenton cobb','FI','427353803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:45',0,'2014-03-03 22:26:43'),(22413,23063,'0000-00-00','ET','2',1,NULL,'Jayna E Denbow','FI','631178733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:30:08',0,'2014-03-07 22:26:59'),(23101,23751,'0000-00-00','ET','2',1,NULL,'Paul Sebe','FI','285828552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:30:03',0,'2014-03-10 21:35:03'),(1314,1314,'2014-01-01','ET','2',1,NULL,'DOROTHY JACKSON','FI','463961212','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:16',0,'2014-03-02 04:38:08'),(1641,1641,'2014-01-01','ET','2',1,NULL,'mary maassel','FI','292420593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:13',0,'2014-03-10 13:03:33'),(2634,2634,'2014-01-01','ET','2',1,NULL,'shane zeringue','FI','435736493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:05',0,'2014-03-01 21:11:04'),(13160,13516,'2014-01-01','ET','2',1,NULL,'Carole Lee','FI','587529258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:16',0,'2014-03-02 05:17:40'),(13083,13439,'2014-01-01','ET','2',2,1,'Nancy Butcher','FI','236847520','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:18',0,'2014-03-01 16:35:14'),(4746,4746,'2014-01-01','ET','2',1,NULL,'Timothy Symsek','FI','174523840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:09',0,'2014-03-01 21:11:04'),(6107,6107,'2014-01-01','ET','2',1,NULL,'HARRISE MOROSKY','FI','289523895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:32',0,'2014-03-01 16:00:27'),(14105,14556,'2014-01-01','ET','2',1,NULL,'Nathalie Baldwin','FI','344562059','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:38',0,'2014-03-01 16:40:16'),(16959,17609,'0000-00-00','ET','2',1,NULL,'JOE MAJOR','FI','454432145','Starmount Life Insurance Company','FI','720977315','PAMELA  PRICE','94','4697079','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:04',0,'2014-03-02 06:24:38'),(18335,18985,'0000-00-00','ET','2',1,NULL,'Michelle Opatka','FI','286782724','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:17',0,'2014-03-01 17:26:36'),(20568,21218,'0000-00-00','ET','2',1,NULL,'NORMA HICKMAN','FI','643021473','Starmount Life Insurance Company','FI','720977315','RAUL  RODRIGUEZ','94','11608743','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:29',0,'2014-03-02 07:17:36'),(20919,21569,'0000-00-00','ET','2',1,NULL,'Donna Mathias','FI','270767021','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:00:12',0,'2014-03-01 18:08:07'),(21479,22129,'0000-00-00','ET','2',1,NULL,'Derrick Cameron','94','0000893203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:40',0,'2014-03-03 21:36:16'),(22027,22677,'0000-00-00','ET','2',2,1,'Michele Waldoch','FI','025507035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:11',0,'2014-03-05 22:27:33'),(22504,23154,'0000-00-00','ET','2',1,NULL,'Georgius Claudet','FI','435861544','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:13',0,'2014-03-07 22:26:59'),(577,577,'2014-01-01','ET','2',1,NULL,'Jennifer Krenisky','FI','280583138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:52',0,'2014-03-01 15:48:04'),(12728,12728,'2014-01-01','ET','2',1,NULL,'katherine weaver','FI','283040437','Summa Insurance Company, Inc.','FI','341809108','james   zuccaro','94','12331','348','2014-02-01','Sync Success',0,'2014-01-03 02:05:52',0,'2014-03-10 16:10:34'),(12635,12635,'2014-01-01','ET','2',1,NULL,'Virgilia Hamilton','FI','436253138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:19',0,'2014-03-02 05:10:52'),(12182,12182,'2014-01-01','ET','2',2,1,'Tabitha Snyder','FI','272922088','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:37',0,'2014-03-10 13:52:32'),(11366,11366,'2014-01-01','ET','2',1,NULL,'San Juana Ibarra','FI','452995042','Starmount Life Insurance Company','FI','720977315','Judith  Maynard','94','3182717','348','2014-02-01','Sync Success',0,'2013-12-27 02:05:31',0,'2014-03-02 04:52:44'),(11362,11362,'2014-01-01','ET','2',1,NULL,'Richard L Triska','FI','462985016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:05:24',0,'2014-03-02 04:52:44'),(11326,11326,'2014-01-01','ET','2',1,NULL,'JUDITH A ODAY','FI','071548054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:17',0,'2014-03-02 04:52:44'),(11282,11282,'2014-01-01','ET','2',1,NULL,'Glenda Powell','FI','436194856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:02:57',0,'2014-03-02 04:52:44'),(10612,10612,'2014-01-01','ET','2',1,NULL,'John Henrikson','FI','634146737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:34',0,'2014-03-02 04:24:47'),(1986,1986,'2014-01-01','ET','2',1,NULL,'LINDA J STARCHER','FI','272562346','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:21',0,'2014-03-10 15:45:56'),(5822,5822,'2014-01-01','ET','2',1,NULL,'Deborah Elms','FI','461985784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:08',0,'2014-03-01 20:10:57'),(5600,5600,'2014-01-01','ET','2',1,NULL,'Joshua Gunsher','FI','149749632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:39',0,'2014-03-01 16:23:43'),(5360,5360,'2014-01-01','ET','2',1,NULL,'Christopher McMahon','FI','286784756','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:11',0,'2014-03-10 15:39:19'),(2157,2157,'2014-01-01','ET','2',1,NULL,'Michelle Savage','FI','294807054','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:41',0,'2014-03-01 15:16:37'),(3292,3292,'2014-01-01','ET','2',1,NULL,'Andrew Fineran','FI','199669784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:48:13',0,'2014-03-01 15:48:04'),(3313,3313,'2014-01-01','ET','2',4,3,'COTTON NAKKA','FI','366237733','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:54',0,'2014-03-01 15:52:44'),(14218,14669,'2014-01-01','ET','2',1,NULL,'Maria Hancher','FI','579747840','HealthSpan','FI','311431434','John  McAlpine','94','982468','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:52',0,'2014-03-10 14:03:26'),(14781,15232,'2014-01-01','ET','2',1,NULL,'Gary King','FI','286882493','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:45',0,'2014-03-10 14:03:26'),(16329,16979,'0000-00-00','ET','2',3,2,'TAMMIE T PAIGE','FI','427192882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:41',0,'2014-03-02 06:10:30'),(17040,17690,'0000-00-00','ET','2',2,1,'EDITH NANCY JARAMILLO','FI','437619809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:24',0,'2014-03-02 06:24:38'),(17557,18207,'0000-00-00','ET','2',2,1,'Michael Lucido','FI','433217747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:39',0,'2014-03-02 06:31:45'),(17625,18275,'0000-00-00','ET','2',1,NULL,'alan dawes','FI','435965757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:19',0,'2014-03-02 06:31:45'),(21338,21988,'0000-00-00','ET','2',1,NULL,'Ernest Michael Kersh','FI','427925581','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:16',0,'2014-03-03 01:35:37'),(22300,22950,'0000-00-00','ET','2',1,NULL,'elisa rios','FI','268549105','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:54',0,'2014-03-10 14:50:59'),(249,249,'2014-01-01','ET','2',3,2,'RICHARD H JOLLY','FI','276568203','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:49',0,'2014-03-10 15:39:19'),(1274,1274,'2014-01-01','ET','2',2,1,'Sherman Flakes','FI','280546495','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:58',0,'2014-03-01 16:23:43'),(1426,1426,'2014-01-01','ET','2',1,NULL,'Chris Gerrard','FI','282947666','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:54:55',0,'2014-03-10 13:52:32'),(13609,13965,'2014-01-01','ET','2',1,NULL,'Marie Engles','FI','287545992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:31',0,'2014-03-01 16:40:16'),(12279,12279,'2014-01-01','ET','2',1,NULL,'ANTHONY KOLCINKO','FI','275528620','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:30',0,'2014-03-01 16:35:14'),(19027,19677,'0000-00-00','ET','2',2,1,'Jon Overfield','FI','301720107','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:09',0,'2014-03-10 16:31:33'),(20790,21440,'0000-00-00','ET','2',1,NULL,'renee tribble','94','0000060323','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:54',0,'2014-03-10 16:38:05'),(22452,23102,'0000-00-00','ET','2',5,4,'Timothy Werring','FI','293726808','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:36',0,'2014-03-10 14:50:59'),(2159,2159,'2014-01-01','ET','2',2,1,'Michael Strang','FI','528619794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:45',0,'2014-03-01 15:16:37'),(2232,2232,'2014-01-01','ET','2',1,NULL,'MAXINE MARIE CALKINS','FI','298785097','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:17',0,'2014-03-10 15:39:19'),(2293,2293,'2014-01-01','ET','2',1,NULL,'Renee Strahler','FI','285881352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:56',0,'2014-03-10 15:39:19'),(12821,12821,'2014-01-01','ET','2',1,NULL,'Karla Glasper','FI','439110446','Starmount Life Insurance Company','FI','720977315','Greg   Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-04 02:02:02',0,'2014-03-02 05:10:52'),(2511,2511,'2014-01-01','ET','2',2,1,'Kristopher Lambert','FI','270807553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:23',0,'2014-03-01 15:05:09'),(11641,11641,'2014-01-01','ET','2',1,NULL,'Laura Siferd','FI','298645938','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:59',0,'2014-03-10 13:52:32'),(2668,2668,'2014-01-01','ET','2',1,NULL,'Nancy Wilson','FI','593165898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:09',0,'2014-03-01 16:05:34'),(2888,2888,'2014-01-01','ET','2',1,NULL,'BRENDA KAY COWELL','FI','298622892','HealthSpan','FI','311431434','DAVID J SPIESS','94','966951','348','2014-01-01','Sync Success',0,'2013-12-25 21:23:17',0,'2014-03-10 13:39:10'),(7246,7246,'2014-01-01','ET','2',2,1,'Harmony Warner','FI','536846193','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:05',0,'2014-03-10 13:32:15'),(6403,6403,'2014-01-01','ET','2',1,NULL,'Lori Creed','FI','283821058','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:34',0,'2014-03-10 13:39:10'),(3341,3341,'2014-01-01','ET','2',1,NULL,'Trevor Fawver','FI','464975407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:53',0,'2014-03-02 02:10:49'),(5874,5874,'2014-01-01','ET','2',1,NULL,'Matthew Edmondson','FI','560678425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:05',0,'2014-03-01 15:05:09'),(5499,5499,'2014-01-01','ET','2',1,NULL,'James Halbert','FI','289501244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:23',0,'2014-03-01 16:23:43'),(5122,5122,'2014-01-01','ET','2',1,NULL,'JONATHAN PHILLIP PROGOFF','FI','074482623','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:58',0,'2014-03-10 15:45:56'),(3866,3866,'2014-01-01','ET','2',1,0,'Kazimer Szymanski','FI','274909566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:07',0,'2014-03-01 15:05:09'),(4644,4644,'2014-01-01','ET','2',1,NULL,'Anna Chowdhury','FI','439650449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:41',0,'2014-03-02 04:38:08'),(14899,15350,'2014-01-01','ET','2',1,NULL,'Brandon Marks','FI','437370080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:23',0,'2014-03-02 05:45:37'),(15936,16585,'0000-00-00','ET','2',1,NULL,'TRACY M REEDY','FI','299681507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:15',0,'2014-03-01 16:56:22'),(17197,17847,'0000-00-00','ET','2',1,NULL,'Joe Chambers','FI','457573938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:04',0,'2014-03-02 06:24:38'),(17643,18293,'0000-00-00','ET','2',2,1,'Lawren mccandless','FI','167602850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:30',0,'2014-03-01 17:20:55'),(17882,18532,'0000-00-00','ET','2',1,NULL,'Margaret Shaw','FI','176429931','Summa Insurance Company, Inc.','FI','341809108','roni  bell','94','3345388','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:17',0,'2014-03-10 16:31:33'),(19171,19821,'0000-00-00','ET','2',1,NULL,'Brian Whitehead','FI','466997486','Starmount Life Insurance Company','FI','720977315','Peter P Berardino','94','1140620','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:40',0,'2014-03-02 06:52:12'),(20688,21338,'0000-00-00','ET','2',1,NULL,'Matthew Spanne','FI','550897991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:06',0,'2014-03-02 07:17:36'),(22261,22911,'0000-00-00','ET','2',1,NULL,'CAROLYN OROURKE','FI','290869653','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:24',0,'2014-03-10 16:44:18'),(22677,23327,'0000-00-00','ET','2',1,NULL,'Talasia edrice robinson','FI','437733434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:41',0,'2014-03-08 22:26:18'),(22802,23452,'0000-00-00','ET','2',2,1,'James Robinson','FI','288583556','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-09 21:00:53',0,'2014-03-10 16:44:18'),(23011,23661,'0000-00-00','ET','2',1,NULL,'Brandon Smith','94','0001107146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:59',0,'2014-03-10 21:27:11'),(398,398,'2014-01-01','ET','2',1,NULL,'Ken Sharp','FI','434021647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:20',0,'2014-03-01 22:10:55'),(12400,12400,'2014-01-01','ET','2',1,NULL,'DREW DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:29:42',0,'2014-03-01 16:35:14'),(1738,1738,'2014-01-01','ET','2',1,NULL,'Cindy Marie Jorgensen','FI','290564366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:17:39',0,'2014-03-01 15:31:33'),(11738,11738,'2014-01-01','ET','2',1,NULL,'Agnieszka Piwko','FI','523835563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:04',0,'2014-03-01 16:30:17'),(2486,2486,'2014-01-01','ET','2',1,NULL,'Charlotte Lacey','FI','286500753','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:04',0,'2014-03-10 13:10:24'),(2604,2604,'2014-01-01','ET','2',1,0,'Hamilton Pyle','FI','279505949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:07',0,'2014-03-01 15:05:09'),(7079,7079,'2014-01-01','ET','2',2,1,'richard serpette','FI','318421509','Dental Care Plus, Inc.','FI','311185262','Richard  Elsea','94','10137582','348','2014-01-01','Sync Success',0,'2013-12-26 04:02:58',0,'2014-03-01 15:52:44'),(3674,3674,'2014-01-01','ET','2',1,NULL,'DIANE ALISON','FI','396628859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:41',0,'2014-03-02 00:10:48'),(5516,5516,'2014-01-01','ET','2',1,NULL,'Teresa Gustin','FI','292586861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:54',0,'2014-03-01 16:23:43'),(14795,15246,'2014-01-01','ET','2',2,1,'albert tims','FI','428415380','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:54',0,'2014-03-02 05:45:37'),(14868,15319,'2014-01-01','ET','2',1,NULL,'christina n session','FI','453511739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:09',0,'2014-03-02 05:52:31'),(15685,16334,'0000-00-00','ET','2',1,NULL,'GERALD HOLMES','FI','585279535','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:38',0,'2014-03-02 05:59:43'),(17902,18552,'0000-00-00','ET','2',1,NULL,'JESSIE SNYDER','FI','433236217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:30',0,'2014-03-02 06:38:05'),(18692,19342,'0000-00-00','ET','2',1,NULL,'Debra Gonzales','FI','465214873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:46',0,'2014-03-02 06:45:14'),(20014,20664,'0000-00-00','ET','2',1,NULL,'Karen Uminski','FI','277643648','Summa Insurance Company, Inc.','FI','341809108','Stuart K Lubline','94','7613392','348','2014-04-01','Sync Success',0,'2014-02-21 22:01:02',0,'2014-03-10 16:38:05'),(896,896,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:01',0,'2014-03-01 15:21:15'),(13665,14021,'2014-01-01','ET','2',1,NULL,'Maria Mendoza','FI','450132059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:19',0,'2014-03-02 05:24:45'),(13573,13929,'2014-01-01','ET','2',2,1,'Brian James','FI','295766607','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:04',0,'2014-03-10 16:10:34'),(13288,13644,'2014-01-01','ET','2',1,NULL,'JEFFREY JOHN LOCHER','FI','289742704','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:08',0,'2014-03-01 16:40:16'),(1166,1166,'2014-01-01','ET','2',1,NULL,'SARAH BOLTON','FI','501174388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:41',0,'2014-03-02 04:38:08'),(1847,1847,'2014-01-01','ET','2',1,NULL,'daniel arnold','FI','299727849','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:04',0,'2014-03-01 15:26:40'),(2381,2381,'2014-01-01','ET','2',1,NULL,'Patricia Gay Pope','FI','459960076','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:39',0,'2014-03-01 23:10:52'),(2433,2433,'2014-01-01','ET','2',1,NULL,'Dorothy A Fields','FI','427136120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:17',0,'2014-03-01 23:10:52'),(5865,5865,'2014-01-01','ET','2',2,1,'Jeremy Tarver','FI','458334449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:44',0,'2014-03-01 19:11:03'),(4823,4823,'2014-01-01','ET','2',2,1,'Elizabeth Csepegi','FI','273902780','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:34',0,'2014-03-10 15:39:19'),(4336,4336,'2014-01-01','ET','2',2,1,'Loren C Sengstock','FI','283561603','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:19',0,'2014-03-10 15:59:47'),(2697,2697,'2014-01-01','ET','2',1,NULL,'MARIA GOMEZ','FI','263674589','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:06',0,'2014-03-02 04:15:49'),(2847,2847,'2014-01-01','ET','2',4,3,'Justin Wolfe','FI','631071703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:55',0,'2014-03-02 04:15:49'),(3892,3892,'2014-01-01','ET','2',1,NULL,'Randy Lee Whipkey','FI','455394809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:58',0,'2014-03-01 19:11:03'),(14426,14877,'2014-01-01','ET','2',2,1,'Andy Hill','FI','497584731','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:19',0,'2014-03-10 14:03:26'),(14534,14985,'2014-01-01','ET','2',1,NULL,'Carol Leever','FI','287645274','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:09',0,'2014-03-10 14:03:26'),(14860,15311,'2014-01-01','ET','2',1,NULL,'Naomi Broadway','FI','245630965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:06',0,'2014-03-02 05:52:31'),(15079,15530,'0000-00-00','ET','2',1,NULL,'nicholas james johnson','FI','298900375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:05:34',0,'2014-03-01 16:50:53'),(15767,16416,'0000-00-00','ET','2',1,NULL,'Jacquelyn Danchisen','FI','291604738','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:01:32',0,'2014-03-10 14:10:12'),(17199,17849,'0000-00-00','ET','2',2,1,'Cassandra Hutto','FI','457599693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:05',0,'2014-03-02 06:24:38'),(17324,17974,'0000-00-00','ET','2',1,NULL,'Susan Smith','FI','288508649','Summa Insurance Company, Inc.','FI','341809108','Deanna M Wells','94','7827930','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:08',0,'2014-03-10 16:24:30'),(19967,20617,'0000-00-00','ET','2',2,1,'Vickie Dillon','FI','302421611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:29',0,'2014-03-01 17:47:19'),(20857,21507,'0000-00-00','ET','2',1,NULL,'KRISTY MCKEE','FI','271706558','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:25',0,'2014-03-10 14:37:47'),(22877,23527,'0000-00-00','ET','2',1,NULL,'Virginia Morales','FI','452336091','Starmount Life Insurance Company','FI','720977315','Michelle  Davila','94','16083391','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:22',0,'2014-03-10 21:27:11'),(922,922,'2014-01-01','ET','2',1,NULL,'sarah odum','FI','427512034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:46',0,'2014-03-01 21:11:04'),(938,938,'2014-01-01','ET','2',1,NULL,'Jonnie LaHatte','FI','434964487','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:18',0,'2014-03-01 22:10:55'),(13857,14213,'2014-01-01','ET','2',1,NULL,'Hoang Yen Thi Dang','FI','667244590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:52',0,'2014-03-02 05:31:31'),(12608,12608,'2014-01-01','ET','2',1,NULL,'DORA VONG','FI','460498941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:22',0,'2014-03-02 05:10:52'),(1720,1720,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-25 19:17:06',0,'2014-03-01 15:31:33'),(2195,2195,'2014-01-01','ET','2',1,NULL,'Jeffrey Toth','FI','269783194','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:48:01',0,'2014-03-10 15:39:19'),(3418,3418,'2014-01-01','ET','2',2,1,'Eduardo Flechas','FI','425137600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:16',0,'2014-03-02 02:10:49'),(11567,11567,'2014-01-01','ET','2',1,NULL,'Jane Chan','FI','456734535','Starmount Life Insurance Company','FI','720977315','Yok  Choy','94','936652','348','2014-02-01','Sync Success',0,'2013-12-28 03:33:43',0,'2014-03-02 04:52:44'),(3447,3447,'2014-01-01','ET','2',2,1,'JoAnn Sexton','FI','290482495','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:14',0,'2014-03-10 13:32:15'),(4953,4953,'2014-01-01','ET','2',2,1,'HOLLY HUMPHREY','FI','285660929','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:55',0,'2014-03-10 13:03:33'),(6997,6997,'2014-01-01','ET','2',1,NULL,'susiette anderson','FI','587346161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:22',0,'2014-03-02 02:10:49'),(14257,14708,'2014-01-01','ET','2',1,NULL,'Jeffrey Davis','FI','298828455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:05',0,'2014-03-01 16:46:19'),(15013,15464,'2014-01-01','ET','2',1,NULL,'Danielle Milioni','FI','385086978','Summa Insurance Company, Inc.','FI','341809108','Eric   Vought','94','16465976','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:16',0,'2014-03-10 16:17:47'),(16712,17362,'0000-00-00','ET','2',1,NULL,'Brandon John Martin','FI','298804861','Dental Care Plus, Inc.','FI','311185262','Joseph R Worland','94','2825067','357','2014-01-01','Sync Success',0,'2014-01-31 21:01:25',0,'2014-03-01 17:00:58'),(18594,19244,'0000-00-00','ET','2',1,NULL,'sherry l frederick','FI','302680150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:29',0,'2014-03-01 17:26:36'),(18709,19359,'0000-00-00','ET','2',1,NULL,'Whitney Alexander','FI','438670746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:59',0,'2014-03-02 06:45:14'),(20758,21408,'0000-00-00','ET','2',1,NULL,'Jane Suveges','FI','282482366','Dental Care Plus, Inc.','FI','311185262','Thomas A Sesny','94','2772106','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:38',0,'2014-03-01 18:08:07'),(957,957,'2014-01-01','ET','2',1,NULL,'Vicky G Hebert','FI','436793672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:52',0,'2014-03-01 22:10:55'),(14057,14508,'2014-01-01','ET','2',2,1,'Michelle McCue','FI','299606635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:07',0,'2014-03-01 16:46:19'),(13699,14055,'2014-01-01','ET','2',1,NULL,'Gary Hunt','FI','305069820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:40',0,'2014-03-01 16:40:16'),(2062,2062,'2014-01-01','ET','2',2,1,'Ronald Eugene Price','FI','273580077','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:51',0,'2014-03-10 13:20:27'),(11955,11955,'2014-01-01','ET','2',2,1,'JON LUKE LEE','FI','446948527','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:23',0,'2014-03-02 04:59:36'),(2935,2935,'2014-01-01','ET','2',1,NULL,'PAMELA J MITCHELL','FI','273484324','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:06',0,'2014-03-01 15:37:30'),(10629,10629,'2014-01-01','ET','2',2,1,'Narendra Shah','FI','639621573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:08',0,'2014-03-02 04:31:46'),(10538,10538,'2014-01-01','ET','2',1,NULL,'Thach Tran','FI','586403034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:05',0,'2014-03-02 04:31:46'),(3175,3175,'2014-01-01','ET','2',1,NULL,'Jimmy Roberts','FI','293561213','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:39',0,'2014-03-10 13:24:34'),(3230,3230,'2014-01-01','ET','2',1,NULL,'Michelle Rathfelder','FI','296665170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:14',0,'2014-03-01 15:52:44'),(3663,3663,'2014-01-01','ET','2',1,NULL,'Teal Grue','FI','435617031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:19',0,'2014-03-02 00:10:48'),(15821,16470,'0000-00-00','ET','2',1,NULL,'DONALD D GIRTLEY','FI','434191827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:23',0,'2014-03-02 06:03:21'),(16055,16704,'0000-00-00','ET','2',1,NULL,'Gwyn A Montgomery','FI','274542411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:47',0,'2014-03-01 16:56:22'),(17353,18003,'0000-00-00','ET','2',1,NULL,'linda ruth jordan','FI','449064072','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:09',0,'2014-03-02 06:31:45'),(18640,19290,'0000-00-00','ET','2',1,NULL,'M SUSAN KLEIN','FI','275548555','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:05',0,'2014-03-01 17:26:36'),(20521,21171,'0000-00-00','ET','2',1,NULL,'Ernesto Solis','FI','450921384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:57',0,'2014-03-02 07:10:28'),(21987,22637,'0000-00-00','ET','2',1,NULL,'Claire Cottell','FI','286903982','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:44',0,'2014-03-10 16:44:18'),(4441,4441,'2014-01-01','ET','2',1,NULL,'Albert R Oettli','FI','434841333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:07',0,'2014-03-01 21:11:04'),(4822,4822,'2014-01-01','ET','2',1,NULL,'Charlene Malicki','FI','276543692','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:32',0,'2014-03-10 13:10:24'),(6414,6414,'2014-01-01','ET','2',2,1,'VIOLA ELIZABETH RICE','FI','299600365','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:11:01',0,'2014-03-10 13:39:10'),(7435,7435,'2014-01-01','ET','2',1,NULL,'Janie Meche','FI','433314297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:59',0,'2014-03-02 04:15:49'),(7625,7625,'2014-01-01','ET','2',1,NULL,'Jonathan Jones','FI','276867738','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:04',0,'2014-03-10 15:59:47'),(11213,11213,'2014-01-01','ET','2',1,NULL,'Mirna Stankovic','FI','276027995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:51',0,'2014-03-01 16:23:43'),(14977,15428,'2014-01-01','ET','2',1,NULL,'Kathryn Rice','FI','287507437','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:00',0,'2014-03-01 16:50:53'),(15222,15673,'0000-00-00','ET','2',2,1,'gina tomasella','FI','435395844','Starmount Life Insurance Company','FI','720977315','John  T Allen','94','4728680','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:41',0,'2014-03-02 05:52:31'),(18275,18925,'0000-00-00','ET','2',1,NULL,'Jennifer Sheal','FI','287801012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:05',0,'2014-03-01 17:26:36'),(6091,6091,'2014-01-01','ET','2',1,NULL,'David Fleischer','FI','133489787','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:03',0,'2014-03-01 16:00:27'),(7478,7478,'2014-01-01','ET','2',1,NULL,'Daniel Stewart','FI','627223958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:14',0,'2014-03-02 04:15:49'),(15000,15451,'2014-01-01','ET','2',2,1,'Naresh Subba','FI','300068034','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:10',0,'2014-03-10 16:17:47'),(16266,16915,'0000-00-00','ET','2',1,NULL,'Stephen J Donohoe','FI','269503020','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:23',0,'2014-03-10 14:20:26'),(18526,19176,'0000-00-00','ET','2',1,NULL,'deborah harlan','FI','302622375','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:29',0,'2014-03-10 14:31:05'),(20779,21429,'0000-00-00','ET','2',1,NULL,'Sherry Baker','FI','280968635','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:48',0,'2014-03-10 16:38:05'),(21352,22002,'0000-00-00','ET','2',1,NULL,'Geoffrey Estep','FI','272786732','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:24',0,'2014-03-10 14:45:25'),(43,43,'2014-01-01','ET','2',1,NULL,'Norma Vaughn','FI','457235850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:17',0,'2014-03-01 22:10:55'),(1335,1335,'2014-01-01','ET','2',1,NULL,'mary mcgee','FI','506689025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:55',0,'2014-03-02 04:38:08'),(1342,1342,'2014-01-01','ET','2',1,NULL,'DOROTHY GEORGETTE  WILSON','FI','467574631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:08',0,'2014-03-02 04:38:08'),(1764,1764,'2014-01-01','ET','2',1,NULL,'Jack Lewis','FI','285502772','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:25',0,'2014-03-10 13:20:27'),(12148,12148,'2014-01-01','ET','2',1,NULL,'Sherri Pitalo','FI','587429647','Starmount Life Insurance Company','FI','720977315','Cameron  Lilienquist','94','8328382','357','2014-02-01','Sync Success',0,'2014-01-01 12:07:23',0,'2014-03-02 04:59:36'),(3713,3713,'2014-01-01','ET','2',1,NULL,'SUSAN BRIDGES','FI','436828975','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:58',0,'2014-03-02 01:10:33'),(11599,11599,'2014-01-01','ET','2',1,NULL,'Roosevelt Cross','FI','587326850','Starmount Life Insurance Company','FI','720977315','Martha  Simpson','94','7023623','357','2014-01-01','Sync Success',0,'2013-12-28 03:34:41',0,'2014-03-02 04:52:44'),(11374,11374,'2014-01-01','ET','2',1,NULL,'Lois  Carter','FI','435880300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:46',0,'2014-03-02 04:52:44'),(11219,11219,'2014-01-01','ET','2',1,NULL,'Wanda Fette','FI','274481121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:03',0,'2014-03-01 16:23:43'),(10747,10747,'2014-01-01','ET','2',1,NULL,'Eric Glier','FI','310765831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:07',0,'2014-03-01 16:10:36'),(10726,10726,'2014-01-01','ET','2',1,NULL,'Theresa Ann Ford','FI','316860847','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:29',0,'2014-03-01 16:10:36'),(6208,6208,'2014-01-01','ET','2',2,1,'Tony Tincher','FI','290567069','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:33',0,'2014-03-01 16:00:27'),(5829,5829,'2014-01-01','ET','2',2,1,'Gerald Miracle','FI','270501508','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:22',0,'2014-03-10 15:39:19'),(5475,5475,'2014-01-01','ET','2',1,NULL,'Karen Cormier','FI','433333562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:36',0,'2014-03-02 04:45:37'),(14427,14878,'2014-01-01','ET','2',2,1,'James Schriner','FI','290840228','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:19',0,'2014-03-10 14:03:26'),(16015,16664,'0000-00-00','ET','2',1,NULL,'Reid Frederick','FI','457554716','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:20',0,'2014-03-02 06:03:21'),(16372,17022,'0000-00-00','ET','2',1,NULL,'Denise Anderson','FI','434611959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:08',0,'2014-03-02 06:10:30'),(16600,17250,'0000-00-00','ET','2',2,1,'Cynthia Aguilar','FI','450619230','Starmount Life Insurance Company','FI','720977315','RICHARD A MIER Jr','94','15750460','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:07',0,'2014-03-02 06:17:30'),(17619,18269,'0000-00-00','ET','2',1,NULL,'Michael Rapp','FI','587521402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:15',0,'2014-03-02 06:31:45'),(18915,19565,'0000-00-00','ET','2',4,3,'Nancy Corwin Record','FI','285561628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:13',0,'2014-03-01 17:34:07'),(20458,21108,'0000-00-00','ET','2',2,1,'chris robinson','FI','401273898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:14',0,'2014-03-01 18:08:07'),(21340,21990,'0000-00-00','ET','2',1,NULL,'Stephanie Schum-Smith','FI','298824119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:18',0,'2014-03-03 01:35:37'),(805,805,'2014-01-01','ET','2',1,NULL,'Carrie Lacey','FI','279785904','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:21',0,'2014-03-10 13:03:33'),(12658,12658,'2014-01-01','ET','2',1,NULL,'Elnora Griggs','FI','227744964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:15',0,'2014-03-02 05:10:52'),(1112,1112,'2014-01-01','ET','2',1,0,'Cory Nathan Shockey','FI','467651827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:29',0,'2014-03-01 19:11:03'),(1794,1794,'2014-01-01','ET','2',1,NULL,'Adam Buckley','FI','461816895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:26',0,'2014-03-02 00:10:48'),(3074,3074,'2014-01-01','ET','2',2,1,'ALEXANDER GEORGIEV','FI','249750630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:25',0,'2014-03-02 01:10:33'),(3504,3504,'2014-01-01','ET','2',1,NULL,'James Jennings','FI','274482726','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-25 22:01:21',0,'2014-03-01 15:37:30'),(10532,10532,'2014-01-01','ET','2',1,NULL,'CARLOS RIVERA','FI','060884421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:54:53',0,'2014-03-02 04:24:47'),(7132,7132,'2014-01-01','ET','2',1,NULL,'Julie Miles','FI','295880654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:04:33',0,'2014-03-01 15:52:44'),(3770,3770,'2014-01-01','ET','2',1,NULL,'Jerrod ODell','FI','463753651','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:20',0,'2014-03-01 23:10:52'),(5757,5757,'2014-01-01','ET','2',1,NULL,'Violet Escamilla','FI','643031064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:02:09',0,'2014-03-02 01:10:33'),(5899,5899,'2014-01-01','ET','2',6,5,'MICHAEL KOPPEL','FI','286705187','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:43',0,'2014-03-01 15:48:04'),(13758,14114,'2014-01-01','ET','2',1,NULL,'hope coleman','FI','409598580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:20',0,'2014-03-02 05:24:45'),(14027,14383,'2014-01-01','ET','2',3,2,'Viorel Rebrisorean','FI','288085854','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:50',0,'2014-03-10 14:03:26'),(14281,14732,'2014-01-01','ET','2',1,NULL,'MICHELLE RENEE WAKEFIELD','FI','302846397','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:16',0,'2014-03-01 16:46:19'),(14635,15086,'2014-01-01','ET','2',1,NULL,'Catherine Catania','FI','283863556','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:11',0,'2014-03-01 16:46:19'),(15029,15480,'2014-01-01','ET','2',1,NULL,'Brenda Ducote','FI','439330722','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:22',0,'2014-03-02 05:52:31'),(15064,15515,'2014-01-01','ET','2',1,NULL,'Shayna Nay','FI','299888338','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:38',0,'2014-03-10 14:10:12'),(17688,18338,'0000-00-00','ET','2',1,NULL,'Christopher Oder','FI','277900167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:59',0,'2014-03-10 14:24:38'),(19562,20212,'0000-00-00','ET','2',1,NULL,'Joseph Vancol','FI','070681655','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:21:06',0,'2014-03-02 06:59:07'),(20059,20709,'0000-00-00','ET','2',1,NULL,'Alicia Salazar','FI','463332946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:18',0,'2014-03-02 07:10:28'),(20730,21380,'0000-00-00','ET','2',2,1,'Larry Mount','FI','295429959','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:26',0,'2014-03-01 18:10:11'),(21243,21893,'0000-00-00','ET','2',1,NULL,'FRANCES E GULLY','FI','281827590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:26',0,'2014-03-01 21:35:40'),(21706,22356,'0000-00-00','ET','2',1,NULL,'DONNA BROWN','FI','435968731','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:43',0,'2014-03-04 21:27:16'),(22772,23422,'0000-00-00','ET','2',1,NULL,'Terrance Holbert','FI','276763303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:27',0,'2014-03-09 21:35:27'),(179,179,'2014-01-01','ET','2',1,NULL,'CARLOS  WAYNE FORD','FI','433219926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:33',0,'2014-03-01 22:10:55'),(13791,14147,'2014-01-01','ET','2',1,NULL,'PATRICIA TATE','FI','425399562','Starmount Life Insurance Company','FI','720977315','RUVONNO  BURT','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:40',0,'2014-03-02 05:24:45'),(252,252,'2014-01-01','ET','2',4,3,'Mike Marivani','FI','002604233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:55',0,'2014-03-01 20:10:57'),(272,272,'2014-01-01','ET','2',1,0,'Michael  Stuart Klaing','FI','272448661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:40',0,'2014-03-01 15:05:09'),(702,702,'2014-01-01','ET','2',1,NULL,'Lydell Emerson','FI','439351796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:48',0,'2014-03-02 02:10:49'),(5804,5804,'2014-01-01','ET','2',1,NULL,'Ashley Dewiel','FI','268849324','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:41',0,'2014-03-10 15:52:36'),(1482,1482,'2014-01-01','ET','2',1,NULL,'julia morris','FI','513378642','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:50',0,'2014-03-10 13:52:32'),(5132,5132,'2014-01-01','ET','2',1,NULL,'Jessie Carson','FI','300521813','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:50:18',0,'2014-03-10 15:45:56'),(2558,2558,'2014-01-01','ET','2',1,NULL,'trichelle lensey','FI','439615434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:50',0,'2014-03-01 20:10:57'),(14863,15314,'2014-01-01','ET','2',1,NULL,'Kasandra Palacios','FI','449477403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:07',0,'2014-03-02 05:52:31'),(16133,16782,'0000-00-00','ET','2',2,1,'Nelson Seip','FI','270440249','HealthSpan','FI','311431434','Carl  Bloomer','94','1782832','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:43',0,'2014-03-10 14:20:26'),(18102,18752,'0000-00-00','ET','2',2,1,'Larry Crane','FI','466984037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:40',0,'2014-03-02 06:38:05'),(19306,19956,'0000-00-00','ET','2',5,4,'ANGELA STEWART','FI','437233363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:23',0,'2014-03-02 06:59:07'),(19687,20337,'0000-00-00','ET','2',1,NULL,'James Hoyat Thomas','FI','587115418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:52:28',0,'2014-03-02 06:59:07'),(20888,21538,'0000-00-00','ET','2',1,NULL,'YONG TONG LI','FI','245891354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:39',0,'2014-03-02 07:17:36'),(21274,21924,'0000-00-00','ET','2',1,NULL,'latonya walker','FI','436750404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:45',0,'2014-03-02 07:23:39'),(21471,22121,'0000-00-00','ET','2',1,NULL,'Lakeisha Brent','FI','426397690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:35',0,'2014-03-03 21:36:16'),(21610,22260,'0000-00-00','ET','2',2,1,'Marissa Durham','FI','465908598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:28',0,'2014-03-04 21:27:16'),(22103,22753,'0000-00-00','ET','2',1,NULL,'LUZ MARIA ZAPATA','FI','455350084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:32',0,'2014-03-06 21:27:26'),(22420,23070,'0000-00-00','ET','2',1,NULL,'Damian Terry','FI','464233647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:13',0,'2014-03-07 22:26:59'),(22645,23295,'0000-00-00','ET','2',1,NULL,'Martha Morin','FI','462213957','Starmount Life Insurance Company','FI','720977315','Jose J Melendez Sr','94','1227800','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:16',0,'2014-03-08 22:26:18'),(76,76,'2014-01-01','ET','2',1,NULL,'Dianne King','FI','227744597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:19',0,'2014-03-01 22:10:55'),(13112,13468,'2014-01-01','ET','2',1,NULL,'Marcia Provence Dodge','FI','466155202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:27',0,'2014-03-02 05:17:40'),(13100,13456,'2014-01-01','ET','2',3,2,'Susanna Hooper','FI','460776583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:59',0,'2014-03-02 05:17:40'),(12844,12844,'2014-01-01','ET','2',1,NULL,'KELLIE RAMSEY','FI','640502960','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:50',0,'2014-03-02 05:10:52'),(499,499,'2014-01-01','ET','2',1,NULL,'JATAUN H HUNTER','FI','283808388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:26',0,'2014-03-01 15:48:04'),(667,667,'2014-01-01','ET','2',1,NULL,'Jane Zebari','FI','378642507','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:42',0,'2014-03-10 15:52:36'),(1137,1137,'2014-01-01','ET','2',1,NULL,'adriel hunt','FI','457352225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:48',0,'2014-03-02 04:45:37'),(2514,2514,'2014-01-01','ET','2',1,0,'Kristopher Lambert','FI','270807553','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-12-31','Received',0,'2013-12-25 20:30:27',NULL,NULL),(3778,3778,'2014-01-01','ET','2',1,NULL,'Donald Kirby','FI','592182676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:36',0,'2014-03-01 15:26:40'),(7460,7460,'2014-01-01','ET','2',1,NULL,'Mary Helen Serrano','FI','465986896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:41',0,'2014-03-02 04:15:49'),(6192,6192,'2014-01-01','ET','2',3,2,'alpesh patel','FI','644687641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:04',0,'2014-03-02 04:10:25'),(4949,4949,'2014-01-01','ET','2',1,NULL,'LARRY CULBERSON','FI','587069309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:48',0,'2014-03-01 20:10:57'),(4265,4265,'2014-01-01','ET','2',1,NULL,'Charles Layman','FI','434062398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:16',0,'2014-03-02 03:09:49'),(14950,15401,'2014-01-01','ET','2',1,NULL,'Alvey Willis','FI','549359191','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:47',0,'2014-03-02 05:52:31'),(15402,15853,'0000-00-00','ET','2',1,NULL,'Terrall Cox','FI','465253009','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:11',0,'2014-03-02 05:59:43'),(16641,17291,'0000-00-00','ET','2',1,NULL,'Gina Breaux','FI','433338821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:36',0,'2014-03-02 06:17:30'),(16973,17623,'0000-00-00','ET','2',1,NULL,'Jane Joseph','FI','281766218','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:13',0,'2014-03-01 17:00:58'),(22218,22868,'0000-00-00','ET','2',1,NULL,'Lisa Adams','FI','401379520','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:52',0,'2014-03-06 21:36:23'),(22937,23587,'0000-00-00','ET','2',1,NULL,'Dianna L Dipolito','FI','299525722','Summa Insurance Company, Inc.','FI','341809108','Curtis  S Chandler','94','8309159','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:08',0,'2014-03-10 21:07:22'),(18075,18725,'0000-00-00','ET','2',2,1,'MARIA  ESTER  PEREZ','FI','632863765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:19',0,'2014-03-02 06:38:05'),(1295,1295,'2014-01-01','ET','2',1,NULL,'JOE RUDD','FI','428477841','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:38',0,'2014-03-02 04:38:08'),(13285,13641,'2014-01-01','ET','2',1,NULL,'Tonya Michele Roberson','FI','433217334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:06',0,'2014-03-02 05:24:45'),(13164,13520,'2014-01-01','ET','2',1,NULL,'Annie M Roberson','FI','337507053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:24',0,'2014-03-02 05:17:40'),(12058,12058,'2014-01-01','ET','2',1,NULL,'Ventura Ortega','FI','466909217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:17',0,'2014-03-02 04:59:36'),(1298,1298,'2014-01-01','ET','2',2,1,'ELIZABETH LEE','FI','438733610','Starmount Life Insurance Company','FI','720977315','NINA  BRADY','94','6398530','348','2014-01-01','Sync Success',0,'2013-12-25 18:50:43',0,'2014-03-02 04:38:08'),(1588,1588,'2014-01-01','ET','2',1,NULL,'Michaeous collins','FI','592507374','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:53',0,'2014-03-01 20:10:57'),(10835,10835,'2014-01-01','ET','2',1,NULL,'Deyandra Harris','FI','436613720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:59',0,'2014-03-02 04:31:46'),(10487,10487,'2014-01-01','ET','2',1,NULL,'Carole Niedzialkowski','FI','318905271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:53:30',0,'2014-03-01 16:10:36'),(7703,7703,'2014-01-01','ET','2',1,NULL,'Charles Fritsch','FI','274783153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 04:45:34',0,'2014-03-01 15:10:22'),(21809,22459,'0000-00-00','ET','2',1,NULL,'Christine Mattice','FI','281768129','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:24',0,'2014-03-10 16:44:18'),(13692,14048,'2014-01-01','ET','2',1,NULL,'Elizabeth Dillion','FI','298685079','HealthSpan','FI','311431434','Kenneth K LaFountain','94','1495150','348','2014-02-01','Sync Success',0,'2014-01-13 02:21:35',0,'2014-03-10 13:59:38'),(6364,6364,'2014-01-01','ET','2',1,NULL,'Karen Matthiesen','FI','286462125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:21',0,'2014-03-10 15:59:47'),(3079,3079,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:34',0,'2014-03-02 01:10:33'),(3347,3347,'2014-01-01','ET','2',1,NULL,'STACY GREEN','FI','525290227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:06',0,'2014-03-02 02:10:49'),(5369,5369,'2014-01-01','ET','2',1,NULL,'William Louis Page','FI','261954064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:30',0,'2014-03-01 21:11:04'),(3384,3384,'2014-01-01','ET','2',2,1,'Gina Crepps','FI','547136355','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:12',0,'2014-03-02 02:10:49'),(3790,3790,'2014-01-01','ET','2',1,NULL,'Cheryl Housley','FI','286606442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:58',0,'2014-03-10 13:10:24'),(4008,4008,'2014-01-01','ET','2',1,NULL,'Alicia Allen','FI','464765199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:22',0,'2014-03-02 03:09:49'),(21176,21826,'0000-00-00','ET','2',1,NULL,'Tabitha Mallory','FI','425434759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:40',0,'2014-03-02 07:23:39'),(22690,23340,'0000-00-00','ET','2',1,NULL,'victor hiris','FI','271703672','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:51',0,'2014-03-10 14:50:59'),(2684,2684,'2014-01-01','ET','2',1,NULL,'Colleen McGuffey','94','0001129351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:43',0,'2014-03-02 04:15:49'),(3484,3484,'2014-01-01','ET','2',1,NULL,'Makayla Grier','FI','298960189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:40',0,'2014-03-01 15:37:30'),(12557,12557,'2014-01-01','ET','2',1,NULL,'RODNEY L MESSER','FI','285902361','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:32',0,'2014-03-10 13:59:38'),(3304,3304,'2014-01-01','ET','2',1,NULL,'Justin Arisman','FI','565671593','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:37',0,'2014-03-01 15:52:44'),(13166,13522,'2014-01-01','ET','2',1,NULL,'Clara Williamson','FI','634792843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:29',0,'2014-03-10 16:10:34'),(2751,2751,'2014-01-01','ET','2',2,1,'Umesh Upadhyay','FI','297983540','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:46',0,'2014-03-10 13:39:10'),(3774,3774,'2014-01-01','ET','2',1,NULL,'Patsy Sparkman','FI','445585288','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:29',0,'2014-03-01 23:10:52'),(3776,3776,'2014-01-01','ET','2',1,NULL,'Laura Fatute','FI','286821024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:33',0,'2014-03-01 15:26:40'),(11386,11386,'2014-01-01','ET','2',1,NULL,'Debra Jackson','FI','415927452','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:06',0,'2014-03-02 04:52:44'),(6385,6385,'2014-01-01','ET','2',1,NULL,'Melissa Holcombe','FI','210543465','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:01',0,'2014-03-10 13:39:10'),(7738,7738,'2014-01-01','ET','2',1,NULL,'Stella Johnson','FI','434020170','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:28',0,'2014-03-01 19:11:03'),(7715,7715,'2014-01-01','ET','2',1,NULL,'Norma Price','FI','236083573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:58',0,'2014-03-01 20:10:57'),(7477,7477,'2014-01-01','ET','2',2,1,'Mc PHAM','FI','479271409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:12',0,'2014-03-02 04:15:49'),(7451,7451,'2014-01-01','ET','2',1,NULL,'Maria E Marmokjo','FI','458089258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:26',0,'2014-03-02 04:10:25'),(7176,7176,'2014-01-01','ET','2',1,NULL,'James P Park','FI','274849709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:53',0,'2014-03-10 15:59:47'),(14925,15376,'2014-01-01','ET','2',2,1,'JUDITH TURNER-YAMAMOTO','FI','240941993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:35',0,'2014-03-01 16:50:53'),(15051,15502,'2014-01-01','ET','2',2,1,'John Boring','FI','288608799','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:31',0,'2014-03-10 16:17:47'),(15278,15729,'0000-00-00','ET','2',2,1,'Angel Michelle-Harris Saltzman','FI','636286159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:05',0,'2014-03-02 05:52:31'),(15833,16482,'0000-00-00','ET','2',1,NULL,'STEPHEN WISE','FI','221409885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:31',0,'2014-03-01 16:56:22'),(16861,17511,'0000-00-00','ET','2',1,NULL,'Robin Phillips','FI','290522132','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-02 19:00:33',0,'2014-03-10 14:20:26'),(17050,17700,'0000-00-00','ET','2',1,NULL,'Lucila Jimenez De Gomez','FI','629297709','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:30',0,'2014-03-02 06:24:38'),(17178,17828,'0000-00-00','ET','2',1,NULL,'LINDA MARIE KERN','FI','279647949','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:52',0,'2014-03-10 14:24:38'),(22425,23075,'0000-00-00','ET','2',1,NULL,'elaine mangum','FI','397723834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:17',0,'2014-03-07 22:26:59'),(22699,23349,'0000-00-00','ET','2',1,NULL,'Chithpaseuth Phonethephaseone','FI','461775216','Starmount Life Insurance Company','FI','720977315','Lisa  Le','94','15666408','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:58',0,'2014-03-08 22:26:18'),(22865,23515,'0000-00-00','ET','2',1,NULL,'Maria Palomarez','FI','464968905','Starmount Life Insurance Company','FI','720977315','Todd  Gunnels','94','1220434','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:14',0,'2014-03-10 21:27:11'),(18199,18849,'0000-00-00','ET','2',4,3,'Michelle Swisher','FI','282661844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:52',0,'2014-03-01 17:26:36'),(20257,20907,'0000-00-00','ET','2',1,NULL,'Mark Casburn','FI','453987071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:07',0,'2014-03-02 07:03:25'),(20861,21511,'0000-00-00','ET','2',1,NULL,'Nancy Slovak','FI','268527267','HealthSpan','FI','311431434','michael  daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:27',0,'2014-03-10 14:37:47'),(1308,1308,'2014-01-01','ET','2',1,NULL,'eliceo ortiz','FI','634466065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:04',0,'2014-03-02 04:38:08'),(13951,14307,'2014-01-01','ET','2',1,NULL,'Rhonda Matheny','FI','291721968','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:35',0,'2014-03-10 14:03:26'),(2484,2484,'2014-01-01','ET','2',2,1,'Barbara Marshall','FI','282506868','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:59',0,'2014-03-10 13:10:24'),(3314,3314,'2014-01-01','ET','2',1,NULL,'Leonard Cybulski','FI','268669991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:58',0,'2014-03-01 15:52:44'),(5878,5878,'2014-01-01','ET','2',2,1,'Vickie Renee Preto','FI','291466884','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:03',0,'2014-03-10 15:52:36'),(7314,7314,'2014-01-01','ET','2',1,NULL,'Alec Maier','FI','296940724','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:08',0,'2014-03-10 13:32:15'),(10974,10974,'2014-01-01','ET','2',1,NULL,'sandra bentley','FI','240826832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:52',0,'2014-03-10 13:45:57'),(11518,11518,'2014-01-01','ET','2',1,NULL,'Pamela Wheeler','FI','437864175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:11',0,'2014-03-02 04:52:44'),(11564,11564,'2014-01-01','ET','2',1,NULL,'Gerardo Gutierrez','FI','452572467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:38',0,'2014-03-02 04:52:44'),(15884,16533,'0000-00-00','ET','2',2,1,'Christina K Wreyford','FI','639785749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:02',0,'2014-03-02 06:03:21'),(17295,17945,'0000-00-00','ET','2',1,NULL,'Johanna Loupe','FI','433559216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:52',0,'2014-03-02 06:24:38'),(17979,18629,'0000-00-00','ET','2',1,NULL,'Leonard Rains','FI','278703596','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:24',0,'2014-03-10 14:24:38'),(18228,18878,'0000-00-00','ET','2',1,NULL,'Patti Dickey','FI','272604169','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:16',0,'2014-03-10 14:24:38'),(18953,19603,'0000-00-00','ET','2',2,1,'Joseph Greenler','FI','299602721','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:39',0,'2014-03-10 14:31:05'),(20002,20652,'0000-00-00','ET','2',2,1,'Robert Collett','FI','275525116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:54',0,'2014-03-01 17:47:19'),(23072,23722,'0000-00-00','ET','2',1,NULL,'Jamour Burns','FI','490763969','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:02:46',0,'2014-03-10 21:17:52'),(1604,1604,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:18',0,'2014-03-01 20:10:57'),(2820,2820,'2014-01-01','ET','2',1,NULL,'DEBORAH  GLUTZ','FI','270547953','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:58',0,'2014-03-10 13:39:10'),(3276,3276,'2014-01-01','ET','2',1,NULL,'Elizabeth Ann Branson','FI','522760567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:42',0,'2014-03-02 02:10:49'),(12577,12577,'2014-01-01','ET','2',1,NULL,'James Nugent','FI','302466948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:16',0,'2014-03-01 16:35:14'),(12257,12257,'2014-01-01','ET','2',1,NULL,'Carla Llewellyn','FI','456596248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:42',0,'2014-03-02 05:10:52'),(3417,3417,'2014-01-01','ET','2',2,1,'zaidan ahmed','FI','496989990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:14',0,'2014-03-02 02:10:49'),(3669,3669,'2014-01-01','ET','2',2,1,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:30',0,'2014-03-02 00:10:48'),(10918,10918,'2014-01-01','ET','2',1,NULL,'Katherine Allen','FI','294687892','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Lange','94','2442863','348','2014-01-01','Sync Success',0,'2013-12-26 13:08:14',0,'2014-03-10 16:03:49'),(3958,3958,'2014-01-01','ET','2',1,NULL,'Stephen David','FI','337723217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:48',0,'2014-03-01 23:10:52'),(4468,4468,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:00',0,'2014-03-01 15:16:37'),(6224,6224,'2014-01-01','ET','2',1,NULL,'MARY CINQUINA','FI','271564295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:04',0,'2014-03-01 16:00:27'),(14242,14693,'2014-01-01','ET','2',1,NULL,'LOI NGUYEN','FI','426697937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:58',0,'2014-03-02 05:38:34'),(14367,14818,'2014-01-01','ET','2',1,NULL,'DAWN CLAY','FI','297609219','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:52',0,'2014-03-10 16:17:47'),(14891,15342,'2014-01-01','ET','2',2,1,'James DeWitt','FI','463159855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:20',0,'2014-03-02 05:45:37'),(16574,17224,'0000-00-00','ET','2',1,NULL,'Thomas Scott Cluckey','FI','283726886','HealthSpan','FI','311431434','Dave  Spiess','94','966951','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:25',0,'2014-03-10 14:20:26'),(16654,17304,'0000-00-00','ET','2',2,1,'Cris Drugan','FI','273467246','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:43',0,'2014-03-10 16:24:30'),(17230,17880,'0000-00-00','ET','2',3,2,'SANDRA M MINOR','FI','302668097','Summa Insurance Company, Inc.','FI','341809108','RHONDA  WEST','94','9907081','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:20',0,'2014-03-10 16:24:30'),(18293,18943,'0000-00-00','ET','2',1,NULL,'SEEMA  CHELLATH','FI','616737041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:22',0,'2014-03-01 17:26:36'),(18911,19561,'0000-00-00','ET','2',5,4,'Paul DiMuzio','FI','298584621','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:10',0,'2014-03-01 17:34:07'),(21050,21700,'0000-00-00','ET','2',1,NULL,'DARLENE DICKERSON','FI','280567389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:12',0,'2014-03-01 18:10:11'),(21466,22116,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:32',0,'2014-03-03 21:36:16'),(21852,22502,'0000-00-00','ET','2',1,NULL,'Pamela Shrider','FI','299621430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:08',0,'2014-03-05 21:36:22'),(21958,22608,'0000-00-00','ET','2',1,NULL,'Larry Henley','FI','428317100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:24',0,'2014-03-05 22:27:33'),(22519,23169,'0000-00-00','ET','2',1,NULL,'William Evans','FI','436294749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:24',0,'2014-03-07 22:26:59'),(2337,2337,'2014-01-01','ET','2',3,2,'Jon Overfield','FI','301720107','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:15',0,'2014-03-10 15:45:56'),(12476,12476,'2014-01-01','ET','2',1,NULL,'Crystal McGuire','FI','402338190','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','357','2014-02-01','Sync Success',1,'2014-01-02 04:32:24',0,'2014-03-01 16:30:17'),(13948,14304,'2014-01-01','ET','2',1,NULL,'Richard McCune','FI','235760139','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:32',0,'2014-03-10 14:03:26'),(12975,12975,'2014-01-01','ET','2',1,NULL,'Ashley Hymel','FI','589463892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:15',0,'2014-03-02 05:17:40'),(12877,12877,'2014-01-01','ET','2',1,NULL,'ROBERT  LYNE  TRENT','FI','293803662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:02',0,'2014-03-01 16:35:14'),(12340,12340,'2014-01-01','ET','2',1,NULL,'Jeremy Tarver','FI','458334449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:27:34',0,'2014-03-02 05:03:29'),(3349,3349,'2014-01-01','ET','2',1,NULL,'EDWARDO CAVAZOS','FI','458531203','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:10',0,'2014-03-02 02:10:49'),(11798,11798,'2014-01-01','ET','2',1,NULL,'William Reidy','FI','123608128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:03',0,'2014-03-02 04:31:46'),(4506,4506,'2014-01-01','ET','2',1,NULL,'Shirley Boldman','FI','272849312','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 23:32:16',0,'2014-03-10 13:03:33'),(11501,11501,'2014-01-01','ET','2',1,NULL,'Maria Rodriguez-Fuentes','FI','631602079','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:41',0,'2014-03-02 04:52:44'),(10889,10889,'2014-01-01','ET','2',1,NULL,'Randi Sobelman','FI','048462555','Starmount Life Insurance Company','FI','720977315','Gregory  Corrente','94','1509634','348','2014-01-01','Sync Success',0,'2013-12-26 13:07:16',0,'2014-03-02 04:24:47'),(7144,7144,'2014-01-01','ET','2',1,NULL,'Paula Marsh','FI','288740186','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:04:56',0,'2014-03-10 15:59:47'),(5376,5376,'2014-01-01','ET','2',1,NULL,'Jeanne Keltz','FI','287482424','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:45',0,'2014-03-01 15:10:22'),(5935,5935,'2014-01-01','ET','2',1,NULL,'Timothy Krueger','FI','282824632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:31:53',0,'2014-03-01 15:48:04'),(14539,14990,'2014-01-01','ET','2',1,NULL,'Billy  Jones','FI','274808606','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:12',0,'2014-03-10 14:03:26'),(15347,15798,'0000-00-00','ET','2',1,NULL,'Ethel Strong','FI','436024611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-21 08:46:47',0,'2014-03-02 05:52:31'),(20914,21564,'0000-00-00','ET','2',1,NULL,'BRITTANY JO CLARK','FI','271926757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:00:09',0,'2014-03-01 18:08:07'),(21180,21830,'0000-00-00','ET','2',1,NULL,'Roshanda Street','FI','587337588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:43',0,'2014-03-02 07:23:39'),(21571,22221,'0000-00-00','ET','2',2,1,'Tina Owens','FI','279620409','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:48',0,'2014-03-10 14:45:25'),(22580,23230,'0000-00-00','ET','2',1,NULL,'Justin Haskins','FI','435857237','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:07',0,'2014-03-07 22:26:59'),(1695,1695,'2014-01-01','ET','2',1,NULL,'Joseph Whittenton Pierce','FI','431922982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:16:21',0,'2014-03-02 00:10:48'),(14109,14560,'2014-01-01','ET','2',3,2,'wanda abou-osman','FI','385707741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:41',0,'2014-03-01 16:40:16'),(1990,1990,'2014-01-01','ET','2',1,NULL,'Bonnie Ostervich','FI','278520996','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:29',0,'2014-03-10 15:45:56'),(2915,2915,'2014-01-01','ET','2',1,NULL,'kenton mangold','FI','299742869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:25',0,'2014-03-01 15:37:30'),(13172,13528,'2014-01-01','ET','2',1,NULL,'Douglas Webster','FI','280508996','HealthSpan','FI','311431434','Catalina  Archuleta','94','15141057','348','2014-02-01','Sync Success',0,'2014-01-07 04:05:43',0,'2014-03-10 13:59:38'),(4555,4555,'2014-01-01','ET','2',2,1,'Vonnie HAwkins','FI','437081177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:52',0,'2014-03-02 04:31:46'),(12590,12590,'2014-01-01','ET','2',1,NULL,'Maria Gloria Corral','FI','327524783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:45',0,'2014-03-02 05:10:52'),(6136,6136,'2014-01-01','ET','2',1,NULL,'Kristine Bougie','FI','288520364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:25',0,'2014-03-01 16:00:27'),(11711,11711,'2014-01-01','ET','2',1,NULL,'MARIA E JIMENEZ','FI','632013666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:13',0,'2014-03-02 04:59:36'),(7100,7100,'2014-01-01','ET','2',1,NULL,'America Ross','FI','313621254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:36',0,'2014-03-01 15:52:44'),(11608,11608,'2014-01-01','ET','2',1,NULL,'DAKOTA DOWE','FI','587619563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:57',0,'2014-03-02 04:52:44'),(11494,11494,'2014-01-01','ET','2',1,NULL,'Josephine Prado','FI','452821325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:29',0,'2014-03-02 04:52:44'),(10797,10797,'2014-01-01','ET','2',1,NULL,'CHARLIE D COBB','FI','437810380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:46',0,'2014-03-02 04:24:47'),(7590,7590,'2014-01-01','ET','2',1,NULL,'Amanda Hughie','FI','411577339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:37:01',0,'2014-03-02 04:10:25'),(14731,15182,'2014-01-01','ET','2',1,NULL,'Toni Edwards','FI','433132155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:14',0,'2014-03-02 05:45:37'),(17191,17841,'0000-00-00','ET','2',2,1,'Dominique Robinson','FI','456794604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:00:04',0,'2014-03-02 06:24:38'),(17825,18475,'0000-00-00','ET','2',1,NULL,'LISA SCHULMAN-ZABACK','FI','080508964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:55',0,'2014-03-02 06:10:30'),(19498,20148,'0000-00-00','ET','2',1,NULL,'Cerra Wingo','FI','283845987','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:03:16',0,'2014-03-10 16:31:33'),(19769,20419,'0000-00-00','ET','2',2,1,'DENISE ANGERSTIEN','FI','292601297','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:18',0,'2014-03-10 16:38:05'),(20396,21046,'0000-00-00','ET','2',3,2,'JOANN R LIRA','FI','585457503','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:23',0,'2014-03-02 07:10:28'),(21046,21696,'0000-00-00','ET','2',2,1,'Clyde Brown','FI','282427153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:08',0,'2014-03-01 18:10:11'),(21203,21853,'0000-00-00','ET','2',1,NULL,'Kenneth Fuller','FI','456471496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-01 19:00:04',0,'2014-03-02 07:23:39'),(233,233,'2014-01-01','ET','2',1,0,'marcus burdett','FI','259498786','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:19',0,'2014-03-10 13:03:33'),(16027,16676,'0000-00-00','ET','2',1,NULL,'Lenard Davis','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:28',0,'2014-03-02 06:03:21'),(16729,17379,'0000-00-00','ET','2',1,NULL,'Anita Shotts','FI','284547813','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:37',0,'2014-03-10 14:20:26'),(16860,17510,'0000-00-00','ET','2',1,NULL,'Kathleen Johns','FI','500607845','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:32',0,'2014-03-10 14:20:26'),(17381,18031,'0000-00-00','ET','2',2,1,'Nadia Flor','FI','548550232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:29',0,'2014-03-02 06:31:45'),(17471,18121,'0000-00-00','ET','2',1,NULL,'CHARLES  AUBERT','FI','436865103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:31',0,'2014-03-02 06:31:45'),(18203,18853,'0000-00-00','ET','2',2,1,'HOWARD DAVID BARRETT','FI','296464990','Dental Care Plus, Inc.','FI','311185262','TARA  KERSEY','94','17031053','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:55',0,'2014-03-01 17:26:36'),(18407,19057,'0000-00-00','ET','2',1,NULL,'MARGUERITE HARKLEROAD','FI','291529171','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:06',0,'2014-03-01 17:26:36'),(18731,19381,'0000-00-00','ET','2',1,NULL,'LATOYA DENISE SHEPHERD','FI','427678832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:15',0,'2014-03-02 06:45:14'),(18879,19529,'0000-00-00','ET','2',1,NULL,'Paul Vidal','FI','282660230','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:47',0,'2014-03-01 17:34:07'),(20056,20706,'0000-00-00','ET','2',2,1,'THOMAS AIDAN STACK','FI','635328943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:16',0,'2014-03-02 07:10:28'),(159,159,'2014-01-01','ET','2',1,NULL,'Deborah Allen','FI','289443361','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:56',0,'2014-03-10 15:45:56'),(2031,2031,'2014-01-01','ET','2',1,NULL,'thomas bruneau','FI','047767173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:35:51',0,'2014-03-01 23:10:52'),(11600,11600,'2014-01-01','ET','2',1,NULL,'PATSY MILLER','FI','425020381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:42',0,'2014-03-02 04:52:44'),(11579,11579,'2014-01-01','ET','2',1,NULL,'Debra Moss','FI','465924828','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-02-01','Sync Success',0,'2013-12-28 03:34:06',0,'2014-03-02 04:52:44'),(11577,11577,'2014-01-01','ET','2',1,NULL,'VALERIE PENA','FI','460673811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:02',0,'2014-03-02 04:52:44'),(10924,10924,'2014-01-01','ET','2',2,1,'Caleb Eckel','FI','108744773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:26',0,'2014-03-10 16:03:49'),(4676,4676,'2014-01-01','ET','2',1,NULL,'Leni Sheeks','FI','251451424','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:48',0,'2014-03-01 16:15:39'),(4754,4754,'2014-01-01','ET','2',2,1,'Ryan Helms','FI','287829206','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:27',0,'2014-03-01 15:16:37'),(5295,5295,'2014-01-01','ET','2',1,NULL,'Kyle Kellgren','FI','439815579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:14',0,'2014-03-01 20:10:57'),(13721,14077,'2014-01-01','ET','2',2,1,'christian castro','FI','434953468','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:55',0,'2014-03-02 05:24:45'),(13988,14344,'2014-01-01','ET','2',1,NULL,'Donna Franklin','FI','331521889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:21',0,'2014-03-02 05:31:31'),(14132,14583,'2014-01-01','ET','2',1,NULL,'Elizabeth Olson','FI','435715949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:55',0,'2014-03-02 05:38:34'),(14458,14909,'2014-01-01','ET','2',1,NULL,'Michael Irvin','FI','437534548','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:33',0,'2014-03-02 05:38:34'),(15568,16019,'0000-00-00','ET','2',1,NULL,'mellanese copeland','FI','299789324','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:21',0,'2014-03-01 16:50:53'),(16414,17064,'0000-00-00','ET','2',1,NULL,'ROBERT SHORTER','FI','271525738','HealthSpan','FI','311431434','DAVID  SPIESS','94','966951','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:35',0,'2014-03-10 14:20:26'),(16535,17185,'0000-00-00','ET','2',1,NULL,'Stephen Harless','FI','270865522','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:00',0,'2014-03-01 17:00:58'),(18117,18767,'0000-00-00','ET','2',3,2,'Ronald Hicks','FI','458790928','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:51',0,'2014-03-02 06:45:14'),(18385,19035,'0000-00-00','ET','2',1,NULL,'Thresea Gilmore','FI','436177357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:51',0,'2014-03-02 06:45:14'),(19299,19949,'0000-00-00','ET','2',1,NULL,'SAHR GBONIA','FI','630704392','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:17',0,'2014-03-02 06:59:07'),(21968,22618,'0000-00-00','ET','2',1,NULL,'Brittany Quidgeon','FI','250776774','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:31',0,'2014-03-10 16:44:18'),(22251,22901,'0000-00-00','ET','2',2,1,'MARY MUSIL','94','0000968210','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:17',0,'2014-03-10 16:44:18'),(507,507,'2014-01-01','ET','2',2,1,'ROBERT JOE MINTON','FI','296487658','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:42',0,'2014-03-01 15:48:04'),(12348,12348,'2014-01-01','ET','2',1,NULL,'debra cummings','FI','460803994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:49',0,'2014-03-02 05:03:29'),(1546,1546,'2014-01-01','ET','2',1,NULL,'Christine King','FI','298787926','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','357','2014-01-01','Sync Success',0,'2013-12-25 18:58:49',0,'2014-03-10 13:45:57'),(2724,2724,'2014-01-01','ET','2',1,NULL,'Brandy Grezaffi','94','0001315458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:57',0,'2014-03-02 04:15:49'),(7644,7644,'2014-01-01','ET','2',1,NULL,'gabriel paul','FI','270929732','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:39',0,'2014-03-10 13:39:10'),(3190,3190,'2014-01-01','ET','2',1,NULL,'Scott Dunham','FI','294525297','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:13',0,'2014-03-10 13:24:34'),(7359,7359,'2014-01-01','ET','2',1,NULL,'Diana Phillips','FI','292749748','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:47',0,'2014-03-01 15:16:37'),(6223,6223,'2014-01-01','ET','2',2,1,'DAVID FRITZ','FI','297460429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:02',0,'2014-03-01 16:00:27'),(6146,6146,'2014-01-01','ET','2',1,NULL,'BENJAMIN WHITE','FI','291845122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:42',0,'2014-03-01 16:00:27'),(4073,4073,'2014-01-01','ET','2',1,NULL,'Daneen S Madaras','FI','285563958','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:28',0,'2014-03-01 15:52:44'),(5858,5858,'2014-01-01','ET','2',1,NULL,'Kimberly Sharp','FI','493982225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:28',0,'2014-03-01 20:10:57'),(5186,5186,'2014-01-01','ET','2',2,1,'Jeffrey Palmer','FI','099603595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:55',0,'2014-03-02 00:10:48'),(4964,4964,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:16',0,'2014-03-01 15:05:09'),(12742,12742,'2014-01-01','ET','2',1,NULL,'DEBBIE LORAINE MITCHELL','FI','462639559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:23',0,'2014-03-02 05:10:52'),(13566,13922,'2014-01-01','ET','2',1,NULL,'Leon Ferrell','FI','587980672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:59',0,'2014-03-02 05:24:45'),(13832,14188,'2014-01-01','ET','2',1,NULL,'JENNIFER DOBBELS','FI','451352762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:35',0,'2014-03-02 05:31:31'),(14957,15408,'2014-01-01','ET','2',3,2,'Leslie Himes','FI','276647135','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:51',0,'2014-03-10 14:10:12'),(15141,15592,'0000-00-00','ET','2',1,NULL,'Taj Shackelford','FI','616226247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:21',0,'2014-03-02 05:52:31'),(18227,18877,'0000-00-00','ET','2',1,NULL,'Amanda Dahlin','FI','095707783','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:16',0,'2014-03-10 14:24:38'),(19013,19663,'0000-00-00','ET','2',2,1,'susan roof','FI','295669448','HealthSpan','FI','311431434','dean  miserandino','94','9274437','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:24',0,'2014-03-10 14:31:05'),(19154,19804,'0000-00-00','ET','2',2,1,'Colleen Doerrer','FI','276569781','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:26',0,'2014-03-10 16:31:33'),(20805,21455,'0000-00-00','ET','2',2,1,'Angel Aurelio Hernandez','FI','465658853','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:01',0,'2014-03-02 07:17:36'),(21165,21815,'0000-00-00','ET','2',1,NULL,'Deborah Jackson','FI','437065864','Starmount Life Insurance Company','FI','720977315','Byron   Alexander','94','12397055','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:32',0,'2014-03-02 07:23:39'),(21239,21889,'0000-00-00','ET','2',1,NULL,'ROSCOE MCCANTS','FI','299485547','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:23',0,'2014-03-01 21:35:40'),(21607,22257,'0000-00-00','ET','2',1,NULL,'Grace McIntosh','FI','632148879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:26',0,'2014-03-04 21:27:16'),(21855,22505,'0000-00-00','ET','2',1,NULL,'Beth Teschan Ferguson','FI','297702421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:10',0,'2014-03-05 21:36:22'),(22095,22745,'0000-00-00','ET','2',2,1,'Jayna E Denbow','FI','631178733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:25',0,'2014-03-06 21:27:26'),(22950,23600,'0000-00-00','ET','2',2,1,'heather mckinney','94','0000240423','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:17',0,'2014-03-10 21:17:52'),(864,864,'2014-01-01','ET','2',3,2,'William Watson','FI','213548401','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:06',0,'2014-03-01 22:10:55'),(3062,3062,'2014-01-01','ET','2',1,NULL,'Benjamin Starcher','FI','287749582','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:01',0,'2014-03-01 15:37:30'),(3789,3789,'2014-01-01','ET','2',1,NULL,'latrice anderson','FI','293587708','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:57',0,'2014-03-01 15:26:40'),(7754,7754,'2014-01-01','ET','2',2,1,'bridget dickson','FI','261634573','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-01-01','Received',0,'2013-12-26 05:01:00',NULL,NULL),(4653,4653,'2014-01-01','ET','2',4,3,'Randal Harper','FI','282788666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:00',0,'2014-03-10 13:45:57'),(7015,7015,'2014-01-01','ET','2',1,NULL,'Frank Mahaffey','FI','451906286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:58',0,'2014-03-02 03:09:49'),(12855,12855,'2014-01-01','ET','2',1,NULL,'Christopher Green','FI','289840617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:16',0,'2014-03-01 16:35:14'),(13697,14053,'2014-01-01','ET','2',1,NULL,'Robert Neiman','FI','279501531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:39',0,'2014-03-01 16:40:16'),(16542,17192,'0000-00-00','ET','2',1,NULL,'patricia cummings','FI','068500225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:04',0,'2014-03-02 06:10:30'),(16728,17378,'0000-00-00','ET','2',1,NULL,'Kimberly Lester','FI','290705998','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:37',0,'2014-03-10 14:20:26'),(18070,18720,'0000-00-00','ET','2',1,NULL,'JACQUELINE FIGUEROA','FI','031621328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:15',0,'2014-03-02 06:38:05'),(18337,18987,'0000-00-00','ET','2',2,1,'Thomas Van dusen','FI','302509572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:18',0,'2014-03-01 17:26:36'),(20067,20717,'0000-00-00','ET','2',1,NULL,'Deborah Barclay','FI','284549203','Dental Care Plus, Inc.','FI','311185262','John  May','94','2767857','348','2014-04-01','Sync Success',0,'2014-02-25 21:00:24',0,'2014-03-01 18:08:07'),(21106,21756,'0000-00-00','ET','2',1,NULL,'NICOLE WILLINGHAM','FI','464199330','Starmount Life Insurance Company','FI','720977315','NICOLE  COOK','94','5310198','348','2014-04-01','Sync Success',0,'2014-02-28 21:30:50',0,'2014-03-02 07:23:39'),(384,384,'2014-01-01','ET','2',1,NULL,'Paula Jean Chapman','FI','300628527','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:51',0,'2014-03-10 15:45:56'),(12082,12082,'2014-01-01','ET','2',2,1,'Joseph Butto','FI','279481191','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:05',0,'2014-03-01 16:30:17'),(11748,11748,'2014-01-01','ET','2',2,1,'Thomas H Jeffries','FI','300785531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:22',0,'2014-03-01 16:30:17'),(4757,4757,'2014-01-01','ET','2',2,1,'Kevin Gonyer','FI','279880228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:33',0,'2014-03-01 15:16:37'),(15276,15727,'0000-00-00','ET','2',1,NULL,'LAURA VASQUEZ','FI','627148972','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:04',0,'2014-03-02 05:52:31'),(17469,18119,'0000-00-00','ET','2',1,NULL,'CAROLYN MCGRAW','FI','316584932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:30',0,'2014-03-02 06:31:45'),(17754,18404,'0000-00-00','ET','2',1,NULL,'PEGGY  WHEELER','FI','279962696','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:39',0,'2014-03-01 17:20:55'),(17975,18625,'0000-00-00','ET','2',1,NULL,'ELIZABETH GARIBAY','FI','465976357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:22',0,'2014-03-02 06:38:05'),(19250,19900,'0000-00-00','ET','2',4,3,'Jerry Sexton','FI','293722737','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:39',0,'2014-03-10 14:31:05'),(19733,20383,'0000-00-00','ET','2',1,NULL,'Melissa Irby','FI','226660459','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:38:15',0,'2014-03-10 14:37:47'),(20417,21067,'0000-00-00','ET','2',1,NULL,'RUTH ELLEN WALKER','FI','273466494','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:40',0,'2014-03-01 18:08:07'),(21548,22198,'0000-00-00','ET','2',1,NULL,'Virginia steel','FI','425133053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:30',0,'2014-03-03 22:26:43'),(22042,22692,'0000-00-00','ET','2',2,1,'DON M WILKINS','FI','295801421','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:22',0,'2014-03-10 14:45:25'),(22084,22734,'0000-00-00','ET','2',2,1,'Miguel Angel Guerra','FI','455595706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:17',0,'2014-03-06 21:27:26'),(1323,1323,'2014-01-01','ET','2',1,NULL,'ANGELA WILLIAMS','FI','420047835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:33',0,'2014-03-02 04:38:08'),(10854,10854,'2014-01-01','ET','2',2,1,'Darlene Mack','FI','287545061','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:38',0,'2014-03-10 13:45:57'),(2095,2095,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:37:54',0,'2014-03-10 13:20:27'),(7684,7684,'2014-01-01','ET','2',2,1,'FREDERIC SEIBERT','FI','297488752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:57',0,'2014-03-10 13:39:10'),(2715,2715,'2014-01-01','ET','2',1,NULL,'MARY ANDERSEN','FI','433749840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:39',0,'2014-03-02 04:15:49'),(7121,7121,'2014-01-01','ET','2',1,NULL,'Michelle Flower','FI','268822818','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:14',0,'2014-03-01 15:52:44'),(5827,5827,'2014-01-01','ET','2',1,NULL,'Valerie Murphy','FI','463618228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:18',0,'2014-03-01 20:10:57'),(12497,12497,'2014-01-01','ET','2',1,NULL,'Claire Spann','FI','267874344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:33:16',0,'2014-03-02 05:03:29'),(3352,3352,'2014-01-01','ET','2',2,1,'MARCIA  VERETTE','FI','461788198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:14',0,'2014-03-02 02:10:49'),(4930,4930,'2014-01-01','ET','2',1,0,'Crystal Rodriguez','FI','455775476','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:07',0,'2014-03-10 13:03:33'),(13093,13449,'2014-01-01','ET','2',1,NULL,'Mary Roby','FI','549313960','Dental Care Plus, Inc.','FI','311185262','jon  Beveridge','94','7897779','357','2014-02-01','Sync Success',0,'2014-01-07 04:02:45',0,'2014-03-01 16:40:16'),(16491,17141,'0000-00-00','ET','2',2,1,'Fidel Nuno','FI','548674512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:31',0,'2014-03-02 06:10:30'),(18072,18722,'0000-00-00','ET','2',1,NULL,'Jerica Newhouse','FI','628165646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:17',0,'2014-03-02 06:38:05'),(19057,19707,'0000-00-00','ET','2',1,NULL,'sasha blalock','FI','462852350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:13',0,'2014-03-02 06:52:12'),(20210,20860,'0000-00-00','ET','2',1,NULL,'ERIKA LANDEROS','FI','521873610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:38',0,'2014-03-02 07:10:28'),(22889,23539,'0000-00-00','ET','2',1,NULL,'JAMES METCALF','FI','295583427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:30',0,'2014-03-10 21:36:25'),(106,106,'2014-01-01','ET','2',1,NULL,'DIANA HILLIARD','FI','279629882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:12',0,'2014-03-10 13:10:24'),(11589,11589,'2014-01-01','ET','2',1,NULL,'moises ortiz','FI','618501296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:23',0,'2014-03-02 04:59:36'),(999,999,'2014-01-01','ET','2',1,NULL,'marisa dover','FI','298705579','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:15',0,'2014-03-10 13:10:24'),(1352,1352,'2014-01-01','ET','2',2,1,'Paedric Rayburn','FI','459979490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:29',0,'2014-03-02 04:38:08'),(11266,11266,'2014-01-01','ET','2',1,NULL,'ACKER HARRY','FI','434539029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:28',0,'2014-03-02 04:45:37'),(2084,2084,'2014-01-01','ET','2',2,1,'James Carr','FI','276540635','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:31',0,'2014-03-10 13:20:27'),(10394,10394,'2014-01-01','ET','2',1,NULL,'Walker Hodson','FI','210749840','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:50:32',0,'2014-03-01 16:10:36'),(5571,5571,'2014-01-01','ET','2',1,NULL,'Alfredo Blanco','FI','459493584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:42',0,'2014-03-02 04:45:37'),(5337,5337,'2014-01-01','ET','2',2,1,'Nicholas Scarlato','FI','286683690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:23',0,'2014-03-01 15:10:22'),(2411,2411,'2014-01-01','ET','2',1,NULL,'Otto S Welborn','FI','297544183','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:36',0,'2014-03-01 15:26:40'),(4416,4416,'2014-01-01','ET','2',1,NULL,'MICHAEL BUTTRAM','FI','269769865','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:29',0,'2014-03-10 13:03:33'),(14310,14761,'2014-01-01','ET','2',1,NULL,'MISTY D SHIRLEY','FI','461279555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:29',0,'2014-03-02 05:38:34'),(6329,6329,'2014-01-01','ET','2',1,NULL,'Robert L Reiman','FI','273482782','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:18',0,'2014-03-10 15:59:47'),(13864,14220,'2014-01-01','ET','2',1,NULL,'Jonathan Lightell','FI','434831868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:58',0,'2014-03-02 05:31:31'),(3366,3366,'2014-01-01','ET','2',1,NULL,'jacqueline Nicole wisner','FI','459797566','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:37',0,'2014-03-02 02:10:49'),(1477,1477,'2014-01-01','ET','2',1,NULL,'Mark D Prout','FI','300723028','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 18:56:42',NULL,NULL),(21807,22457,'0000-00-00','ET','2',2,1,'Clarice Anderson','FI','279563936','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:22',0,'2014-03-10 14:45:25'),(563,563,'2014-01-01','ET','2',1,NULL,'Timothy Guest','FI','386800400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:28',0,'2014-03-01 15:48:04'),(11653,11653,'2014-01-01','ET','2',1,NULL,'Giovanny Escribano','FI','597204898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:36:22',0,'2014-03-01 16:30:17'),(18343,18993,'0000-00-00','ET','2',1,NULL,'Willie Curtis','FI','436047578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:22',0,'2014-03-02 06:45:14'),(11376,11376,'2014-01-01','ET','2',1,NULL,'MICAH BEACH','FI','436477475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:50',0,'2014-03-02 04:52:44'),(10752,10752,'2014-01-01','ET','2',1,NULL,'Amanda Cooper','FI','298807513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:16',0,'2014-03-01 16:15:39'),(1456,1456,'2014-01-01','ET','2',1,NULL,'Sharon McGill','FI','273804958','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:56',0,'2014-03-01 16:15:39'),(2265,2265,'2014-01-01','ET','2',1,NULL,'Robert Caudill','FI','297883226','HealthSpan','FI','311431434','Amy  Sheaks','94','15838390','348','2014-01-01','Sync Success',0,'2013-12-25 19:50:28',0,'2014-03-10 13:10:24'),(17340,17990,'0000-00-00','ET','2',1,NULL,'Michael Harmon','FI','379524888','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:17',0,'2014-03-10 14:24:38'),(3515,3515,'2014-01-01','ET','2',1,NULL,'JERRY LEE DILLINGHAM','FI','289489115','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:40',0,'2014-03-01 15:37:30'),(12543,12543,'2014-01-01','ET','2',1,NULL,'Robin Evans','FI','276546062','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:58',0,'2014-03-10 13:59:38'),(7418,7418,'2014-01-01','ET','2',1,NULL,'Peter Wilson','FI','439333068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:27',0,'2014-03-02 04:15:49'),(5012,5012,'2014-01-01','ET','2',1,NULL,'Mildred Myles','FI','269607016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:23',0,'2014-03-01 15:31:33'),(6435,6435,'2014-01-01','ET','2',1,NULL,'Tenee Martin','FI','294885450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:34',0,'2014-03-01 15:10:22'),(22163,22813,'0000-00-00','ET','2',1,NULL,'WANDA LOUISE LISEMBEE','FI','296667794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:13',0,'2014-03-06 21:36:23'),(20034,20684,'0000-00-00','ET','2',1,NULL,'Tim Alt','FI','618356675','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:15',0,'2014-03-10 16:38:05'),(14585,15036,'2014-01-01','ET','2',1,NULL,'RICHARD LABURDA','FI','465850177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:41',0,'2014-03-02 05:45:37'),(13010,13010,'2014-01-01','ET','2',3,2,'Phillip Chow','FI','093604016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:31',0,'2014-03-01 16:35:14'),(20851,21501,'0000-00-00','ET','2',1,NULL,'AMELIA LABEAUD','FI','435733993','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:22',0,'2014-03-02 07:17:36'),(18947,19597,'0000-00-00','ET','2',1,NULL,'Vicki Arnold','FI','296501428','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:36',0,'2014-03-10 16:31:33'),(14932,15383,'2014-01-01','ET','2',1,NULL,'Constance Ebelechukwu Okonkwo','94','0000110542','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:39',0,'2014-03-01 16:50:53'),(12098,12098,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:05:39',0,'2014-03-01 16:30:17'),(22861,23511,'0000-00-00','ET','2',1,NULL,'Carlota Martinez','FI','466839582','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:11',0,'2014-03-10 21:27:11'),(2980,2980,'2014-01-01','ET','2',1,NULL,'Mozell Ray','FI','463259623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:32:33',0,'2014-03-02 01:10:33'),(4462,4462,'2014-01-01','ET','2',1,NULL,'JOSEPH KANE','FI','271809138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:49',0,'2014-03-01 15:16:37'),(4556,4556,'2014-01-01','ET','2',1,NULL,'Charles Fisher','FI','437731291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:54',0,'2014-03-02 04:31:46'),(6226,6226,'2014-01-01','ET','2',5,4,'Timothy Miller','FI','300807095','Dental Care Plus, Inc.','FI','311185262','Deborah  Gazey','94','2341750','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:08',0,'2014-03-01 16:00:27'),(5426,5426,'2014-01-01','ET','2',1,NULL,'Cynthia Sanchez','FI','296681724','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:12',0,'2014-03-10 13:03:33'),(1357,1357,'2014-01-01','ET','2',2,1,'Peggy Kankonde','FI','800227595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:39',0,'2014-03-02 04:38:08'),(20819,21469,'0000-00-00','ET','2',1,NULL,'FANNIE GREEN','FI','455353609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:08',0,'2014-03-02 07:17:36'),(17118,17768,'0000-00-00','ET','2',1,NULL,'Corey Austin','FI','290886675','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:11',0,'2014-03-10 14:20:26'),(2516,2516,'2014-01-01','ET','2',1,0,'Monte Bradshaw','FI','277782194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:30',0,'2014-03-01 15:05:09'),(16207,16856,'0000-00-00','ET','2',1,NULL,'Jenee Ohrvall','FI','456513013','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:44',0,'2014-03-02 06:03:21'),(13113,13469,'2014-01-01','ET','2',1,NULL,'brenda a lara','FI','464089158','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:28',0,'2014-03-02 05:17:40'),(13263,13619,'2014-01-01','ET','2',1,NULL,'Kaytlynn Eddleman','FI','439716013','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:57',0,'2014-03-02 05:24:45'),(16192,16841,'0000-00-00','ET','2',1,NULL,'TAMMY MCKINLEY','FI','437373620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:33',0,'2014-03-02 06:03:21'),(15066,15517,'2014-01-01','ET','2',1,NULL,'Rekesha Harrell','FI','438516745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:38',0,'2014-03-02 05:52:31'),(22620,23270,'0000-00-00','ET','2',1,NULL,'Kathleen Ann Lewis','FI','302501326','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-08 21:00:08',0,'2014-03-10 14:50:59'),(15782,16431,'0000-00-00','ET','2',1,NULL,'JAMES BURT','FI','425312695','Starmount Life Insurance Company','FI','720977315','PEGGIE  TUTOR','94','6400618','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:45',0,'2014-03-02 06:03:21'),(72,72,'2014-01-01','ET','2',1,NULL,'Danielle M Davidson','FI','298500836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:12',0,'2014-03-01 15:26:40'),(22546,23196,'0000-00-00','ET','2',1,NULL,'Catia Davis','FI','428513481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:43',0,'2014-03-07 22:26:59'),(11559,11559,'2014-01-01','ET','2',1,NULL,'ANGELA LEWIS','FI','461434705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:28',0,'2014-03-02 04:52:44'),(1537,1537,'2014-01-01','ET','2',1,NULL,'Jenny L Riehm','FI','271682581','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:31',0,'2014-03-10 13:52:32'),(21119,21769,'0000-00-00','ET','2',1,NULL,'ALMA ANDERSON','FI','451732117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:59',0,'2014-03-02 07:23:39'),(22884,23534,'0000-00-00','ET','2',2,1,'Alejandro Arteaga','FI','562836806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:26',0,'2014-03-10 21:36:25'),(14875,15326,'2014-01-01','ET','2',1,NULL,'John Morris','FI','462257181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:13',0,'2014-03-02 05:52:31'),(12778,12778,'2014-01-01','ET','2',1,NULL,'Stephanie Dunn','FI','457239387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:27',0,'2014-03-02 05:10:52'),(2225,2225,'2014-01-01','ET','2',1,NULL,'Susan Jackman','FI','273468869','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:00',0,'2014-03-10 13:10:24'),(3058,3058,'2014-01-01','ET','2',1,NULL,'Michelle Markielowski','FI','276867049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:53',0,'2014-03-01 15:37:30'),(18725,19375,'0000-00-00','ET','2',1,NULL,'Etienne Roets','FI','615258293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 22:02:12',0,'2014-03-02 06:45:14'),(17331,17981,'0000-00-00','ET','2',1,NULL,'Kimberly Kimburbrough','FI','587211125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:31:11',0,'2014-03-02 06:24:38'),(11234,11234,'2014-01-01','ET','2',1,NULL,'christopher creatura','FI','287668695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:01:30',0,'2014-03-01 16:23:43'),(20046,20696,'0000-00-00','ET','2',1,NULL,'Shannon Neal','FI','284769659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:15',0,'2014-03-10 14:37:47'),(964,964,'2014-01-01','ET','2',1,NULL,'Miki Elizabeth Teer','FI','435595778','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:05',0,'2014-03-01 22:10:55'),(15771,16420,'0000-00-00','ET','2',1,NULL,'Donna Fabian','FI','272561476','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:35',0,'2014-03-10 16:24:30'),(7736,7736,'2014-01-01','ET','2',1,NULL,'Ella Geib','FI','293626587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:24',0,'2014-03-01 15:05:09'),(15769,16418,'0000-00-00','ET','2',1,NULL,'WENDY ZODY','FI','272683499','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:34',0,'2014-03-10 16:24:30'),(6335,6335,'2014-01-01','ET','2',1,NULL,'Elsa Decker','FI','456670358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:28',0,'2014-03-02 04:10:25'),(13045,13401,'2014-01-01','ET','2',1,NULL,'Debbie Matthews','FI','436116550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:57',0,'2014-03-02 05:17:40'),(12785,12785,'2014-01-01','ET','2',1,NULL,'PAUL ANTHONY BARNES','FI','451270196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:43',0,'2014-03-02 05:10:52'),(21528,22178,'0000-00-00','ET','2',1,NULL,'DESMOND SCOTT','FI','455659381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:15',0,'2014-03-03 22:26:43'),(20646,21296,'0000-00-00','ET','2',2,1,'TIMOTHY HAMPTON','FI','587397411','Starmount Life Insurance Company','FI','720977315','SUSANNE  BROWN','94','2172234','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:22',0,'2014-03-02 07:17:36'),(344,344,'2014-01-01','ET','2',2,1,'Paul Fisher','FI','166486038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:35',0,'2014-03-01 15:21:15'),(20300,20950,'0000-00-00','ET','2',1,NULL,'Rebecca Alcala','FI','436732230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 08:00:41',0,'2014-03-02 07:10:28'),(19773,20423,'0000-00-00','ET','2',1,NULL,'GLENDA TAYLOR','FI','587542507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:22',0,'2014-03-02 07:03:25'),(18596,19246,'0000-00-00','ET','2',2,1,'Richard Emery','FI','286585424','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:30',0,'2014-03-01 17:26:36'),(10608,10608,'2014-01-01','ET','2',1,NULL,'Eugene Franklin','FI','459924794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:27',0,'2014-03-02 04:24:47'),(12997,12997,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:02:01',0,'2014-03-10 16:10:34'),(13771,14127,'2014-01-01','ET','2',1,NULL,'Debra Loucks','FI','279507365','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:28',0,'2014-03-10 16:10:34'),(18338,18988,'0000-00-00','ET','2',1,NULL,'kevin bricker','FI','288505828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:19',0,'2014-03-01 17:26:36'),(18330,18980,'0000-00-00','ET','2',1,NULL,'Logan Polmanteer','FI','089767165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:14',0,'2014-03-01 17:26:36'),(21776,22426,'0000-00-00','ET','2',1,NULL,'joshua eisenhauer','FI','522945502','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:43',0,'2014-03-10 14:45:25'),(21133,21783,'0000-00-00','ET','2',1,NULL,'LONDON WILLIAMS','FI','280764769','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:10',0,'2014-03-10 16:38:05'),(12180,12180,'2014-01-01','ET','2',2,1,'Henricus Arts','FI','301040530','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:30',0,'2014-03-10 13:52:32'),(20820,21470,'0000-00-00','ET','2',1,NULL,'Catarina Roblez','FI','467153223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:08',0,'2014-03-02 07:17:36'),(1550,1550,'2014-01-01','ET','2',1,NULL,'Judy Ann Bender','FI','268601767','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:58',0,'2014-03-10 13:52:32'),(20305,20955,'0000-00-00','ET','2',1,NULL,'Kimberly Willis','FI','453672909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 08:00:45',0,'2014-03-02 07:10:28'),(12614,12614,'2014-01-01','ET','2',1,NULL,'JAIME  ARTURO MAGALLON','FI','607228922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:35',0,'2014-03-02 05:10:52'),(15784,16433,'0000-00-00','ET','2',1,NULL,'Cheryl Market','FI','268568620','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:46',0,'2014-03-10 14:10:12'),(15432,15883,'0000-00-00','ET','2',1,NULL,'Aron Gillis','FI','300825125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:31',0,'2014-03-10 16:17:47'),(3795,3795,'2014-01-01','ET','2',1,NULL,'Adra Berry','FI','412395645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:07',0,'2014-03-01 23:10:52'),(11921,11921,'2014-01-01','ET','2',1,NULL,'LOREN DODDS','FI','282647250','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:38',0,'2014-03-01 16:30:17'),(3937,3937,'2014-01-01','ET','2',2,1,'Michael Governale','FI','434842783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:08',0,'2014-03-01 23:10:52'),(5403,5403,'2014-01-01','ET','2',1,NULL,'Virgil Cornelison','FI','455317934','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:18',0,'2014-03-01 20:10:57'),(6989,6989,'2014-01-01','ET','2',1,NULL,'Robert Gerding','FI','270527282','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:08',0,'2014-03-10 13:32:15'),(5890,5890,'2014-01-01','ET','2',1,NULL,'Melinda Hurlow','FI','269567163','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:27',0,'2014-03-01 15:48:04'),(14870,15321,'2014-01-01','ET','2',2,1,'SHAWNTEL GOMEZ','FI','455937331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:10',0,'2014-03-02 05:52:31'),(18810,19460,'0000-00-00','ET','2',1,NULL,'ALBERT SPOERR','FI','296507478','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:16',0,'2014-03-10 14:31:05'),(19398,20048,'0000-00-00','ET','2',1,NULL,'Cynthia Smith','FI','301505537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:06',0,'2014-03-01 17:34:07'),(20918,21568,'0000-00-00','ET','2',1,NULL,'RENEE KAY CLARK','FI','273563596','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:11',0,'2014-03-01 18:08:07'),(20935,21585,'0000-00-00','ET','2',3,2,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:26',0,'2014-03-10 16:38:05'),(21044,21694,'0000-00-00','ET','2',1,NULL,'Letitia Williams','FI','271780312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:06',0,'2014-03-01 18:10:11'),(22371,23021,'0000-00-00','ET','2',1,NULL,'TOSHIA NEWSOME','FI','452910721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:21',0,'2014-03-07 21:25:22'),(1702,1702,'2014-01-01','ET','2',2,1,'Christopher Devillier','FI','433436104','Starmount Life Insurance Company','FI','720977315','Ricky  Blanton','94','8509275','348','2014-01-01','Sync Success',0,'2013-12-25 19:16:33',0,'2014-03-02 00:10:48'),(12290,12290,'2014-01-01','ET','2',2,1,'Smail Sejdic','FI','299020404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:55',0,'2014-03-01 16:35:14'),(3035,3035,'2014-01-01','ET','2',2,1,'Linda M Spencer','FI','292509830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:09',0,'2014-03-01 15:37:30'),(12168,12168,'2014-01-01','ET','2',1,NULL,'Troy Ducote','FI','438736018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:03',0,'2014-03-02 04:59:36'),(11860,11860,'2014-01-01','ET','2',1,NULL,'jason tarulli','FI','283687776','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:09',0,'2014-03-10 16:03:49'),(11825,11825,'2014-01-01','ET','2',1,NULL,'George Peterson','FI','437479707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:54',0,'2014-03-02 04:31:46'),(11085,11085,'2014-01-01','ET','2',2,1,'Mark Mckenzie','FI','567927369','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:37',0,'2014-03-10 13:39:10'),(10524,10524,'2014-01-01','ET','2',1,NULL,'Anita Forsman','FI','501542555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:37',0,'2014-03-02 04:24:47'),(7725,7725,'2014-01-01','ET','2',1,NULL,'Shahala Greyard','FI','565437904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:02',0,'2014-03-01 19:11:03'),(3942,3942,'2014-01-01','ET','2',1,NULL,'Theresa Louise Pittard','FI','013527796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:17',0,'2014-03-01 23:10:52'),(14103,14554,'2014-01-01','ET','2',1,NULL,'ellen sands','FI','273448558','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:37',0,'2014-03-01 16:40:16'),(14294,14745,'2014-01-01','ET','2',1,NULL,'Zachary William Graham','FI','255672224','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:21',0,'2014-03-01 16:46:19'),(15648,16297,'0000-00-00','ET','2',1,NULL,'John Marcus Thiel','FI','273647520','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:10',0,'2014-03-01 16:56:22'),(16360,17010,'0000-00-00','ET','2',1,NULL,'justin adams','FI','300842689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:59',0,'2014-03-01 17:00:58'),(16386,17036,'0000-00-00','ET','2',1,NULL,'Marilyn Barney','FI','447641881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:17',0,'2014-03-02 06:10:30'),(16946,17596,'0000-00-00','ET','2',1,NULL,'Joana Dumas','FI','437253923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:56',0,'2014-03-02 06:17:30'),(18156,18806,'0000-00-00','ET','2',2,1,'RUSSELL WILSON','FI','436906683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:20',0,'2014-03-02 06:38:05'),(22793,23443,'0000-00-00','ET','2',2,1,'JOHN BELEA','FI','353900628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:44',0,'2014-03-09 21:26:00'),(2235,2235,'2014-01-01','ET','2',2,1,'Deborah Poff','FI','298661008','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:23',0,'2014-03-10 15:39:19'),(12350,12350,'2014-01-01','ET','2',1,NULL,'Carla Housh','FI','462158691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:27:54',0,'2014-03-02 05:03:29'),(7704,7704,'2014-01-01','ET','2',2,1,'Jerry Stephens','FI','464084495','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:35',0,'2014-03-01 15:10:22'),(10571,10571,'2014-01-01','ET','2',1,NULL,'robert hamilton','FI','462612093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:15',0,'2014-03-02 04:24:47'),(12374,12374,'2014-01-01','ET','2',1,NULL,'Bryan Martin','FI','270962644','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:28:43',0,'2014-03-10 13:59:38'),(13026,13382,'2014-01-01','ET','2',2,1,'brent boots','FI','270864470','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:14',0,'2014-03-01 16:35:14'),(14197,14648,'2014-01-01','ET','2',2,1,'Mehboob Jaffer','FI','638037000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:37',0,'2014-03-02 05:38:34'),(14792,15243,'2014-01-01','ET','2',2,1,'UYEN DO','FI','449617367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:52',0,'2014-03-02 05:45:37'),(14946,15397,'2014-01-01','ET','2',1,NULL,'ELIZABETH WATERS','FI','465434613','Starmount Life Insurance Company','FI','720977315','MIKE  ALEXANDER','94','8402747','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:46',0,'2014-03-02 05:45:37'),(15332,15783,'0000-00-00','ET','2',2,1,'robert foit','FI','272560671','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:37',0,'2014-03-10 16:17:47'),(15900,16549,'0000-00-00','ET','2',1,NULL,'Mikki King','FI','276789335','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:01:12',0,'2014-03-10 14:10:12'),(16209,16858,'0000-00-00','ET','2',2,1,'Kevin Black','FI','467858499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:45',0,'2014-03-02 06:10:30'),(17718,18368,'0000-00-00','ET','2',1,NULL,'Nicole Hunter','FI','275880625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:14',0,'2014-03-01 17:20:55'),(18619,19269,'0000-00-00','ET','2',1,NULL,'DAN KENNA','FI','270681811','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:49',0,'2014-03-10 16:31:33'),(19455,20105,'0000-00-00','ET','2',1,NULL,'YOLANDA PEREZ','FI','454027708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:44:03',0,'2014-03-02 06:59:07'),(19854,20504,'0000-00-00','ET','2',1,NULL,'Donna Ancar','FI','434969792','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-04-01','Sync Success',0,'2014-02-20 22:01:07',0,'2014-03-02 07:03:25'),(20869,21519,'0000-00-00','ET','2',1,NULL,'Alicia Kahn','FI','463898047','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:30',0,'2014-03-02 07:17:36'),(21016,21666,'0000-00-00','ET','2',1,NULL,'Nhai Nguyen','FI','586507721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:11',0,'2014-03-02 07:23:39'),(21919,22569,'0000-00-00','ET','2',1,NULL,'LEONARD C ROBINSON','FI','467274603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:56',0,'2014-03-05 22:27:33'),(22112,22762,'0000-00-00','ET','2',1,NULL,'LEROYCE HAVINGS','FI','219620151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:38',0,'2014-03-06 21:27:26'),(707,707,'2014-01-01','ET','2',1,NULL,'WILLIAM R MIRON','FI','293689777','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:57',0,'2014-03-10 13:24:34'),(12503,12503,'2014-01-01','ET','2',1,NULL,'Kazeem Kashan','FI','437355612','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-02-01','Sync Success',1,'2014-01-02 04:33:30',0,'2014-03-02 05:03:29'),(1057,1057,'2014-01-01','ET','2',1,NULL,'Amanda Schornik','FI','288802060','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:30',0,'2014-03-01 15:16:37'),(11289,11289,'2014-01-01','ET','2',1,NULL,'Latrice Manning','FI','434678270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:10',0,'2014-03-02 04:52:44'),(10448,10448,'2014-01-01','ET','2',1,NULL,'TAMARA SHANAHAN','FI','295649359','Dental Care Plus, Inc.','FI','311185262','STEVE  GULAS','94','2210075','348','2014-01-01','Sync Success',0,'2013-12-26 12:52:14',0,'2014-03-01 16:10:36'),(7577,7577,'2014-01-01','ET','2',1,NULL,'Shirley Turner','FI','300504332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:30',0,'2014-03-01 16:05:34'),(5018,5018,'2014-01-01','ET','2',1,NULL,'Candeus McDowall','FI','296786971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:32',0,'2014-03-01 15:31:33'),(15808,16457,'0000-00-00','ET','2',1,NULL,'Jessica Batres','FI','243652430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:16',0,'2014-03-02 06:03:21'),(16488,17138,'0000-00-00','ET','2',1,NULL,'BREANNA SAULS','FI','634424568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:29',0,'2014-03-02 06:10:30'),(19547,20197,'0000-00-00','ET','2',1,NULL,'Shilonda Elie','FI','437370520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:17:35',0,'2014-03-02 06:59:07'),(19626,20276,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:37:15',0,'2014-03-01 17:47:19'),(20847,21497,'0000-00-00','ET','2',1,NULL,'Patrice Smith','FI','435706138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:20',0,'2014-03-02 07:17:36'),(21415,22065,'0000-00-00','ET','2',1,NULL,'Timothy Valenta','FI','449316301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:20',0,'2014-03-03 21:25:18'),(22398,23048,'0000-00-00','ET','2',2,1,'Susan Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:34',0,'2014-03-07 21:25:22'),(132,132,'2014-01-01','ET','2',1,NULL,'Kinsey Falaschi','FI','644260473','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:06',0,'2014-03-01 22:10:55'),(12523,12523,'2014-01-01','ET','2',1,NULL,'Charles Mack','FI','274946658','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:10',0,'2014-03-10 13:59:38'),(3570,3570,'2014-01-01','ET','2',2,1,'Rhea Rasnic','FI','406883570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:26',0,'2014-03-02 00:10:48'),(11740,11740,'2014-01-01','ET','2',2,1,'John Lowry','FI','282487385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:08',0,'2014-03-01 16:30:17'),(3703,3703,'2014-01-01','ET','2',1,NULL,'Sarah Courville','FI','439274564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:36',0,'2014-03-02 01:10:33'),(4387,4387,'2014-01-01','ET','2',1,NULL,'Lorene Twobulls','FI','282466047','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:34',0,'2014-03-01 15:16:37'),(5613,5613,'2014-01-01','ET','2',6,5,'Jeffrey Blair','FI','302709082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:04',0,'2014-03-01 16:23:43'),(13814,14170,'2014-01-01','ET','2',1,NULL,'LINDA KERNS','FI','280468696','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:20',0,'2014-03-10 16:10:34'),(15791,16440,'0000-00-00','ET','2',1,NULL,'Mike Keating','FI','523785968','Starmount Life Insurance Company','FI','720977315','camweron  liljenquist','94','8328382','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:07',0,'2014-03-02 06:03:21'),(16658,17308,'0000-00-00','ET','2',1,NULL,'Kathy J Hayes','FI','414178456','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:46',0,'2014-03-10 16:24:30'),(17414,18064,'0000-00-00','ET','2',1,NULL,'John Billick','FI','287481646','Summa Insurance Company, Inc.','FI','341809108','Eric  Vought','94','16465976','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:51',0,'2014-03-10 16:24:30'),(17642,18292,'0000-00-00','ET','2',1,NULL,'Christina Motz','FI','294902830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:29',0,'2014-03-01 17:20:55'),(19724,20374,'0000-00-00','ET','2',1,NULL,'MARGARET I GANTZ','FI','283505398','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:34:30',0,'2014-03-10 14:37:47'),(20808,21458,'0000-00-00','ET','2',1,NULL,'Isrella Ashby','FI','554824934','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:03',0,'2014-03-02 07:17:36'),(17,17,'2014-01-01','ET','2',2,1,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:31',0,'2014-03-01 15:21:15'),(1870,1870,'2014-01-01','ET','2',3,2,'Megan Thompson','FI','297769009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:51',0,'2014-03-01 15:26:40'),(12217,12217,'2014-01-01','ET','2',1,NULL,'kathy smith','FI','273648430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:06',0,'2014-03-01 16:35:14'),(11094,11094,'2014-01-01','ET','2',1,NULL,'Joan Skinner','94','0000062535','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:53',0,'2014-03-10 13:45:57'),(3783,3783,'2014-01-01','ET','2',1,NULL,'Richard Andrew Fredley','FI','297886132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:46',0,'2014-03-01 15:26:40'),(4101,4101,'2014-01-01','ET','2',1,NULL,'Christopher Creatura','FI','287668695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:17',0,'2014-03-01 16:00:27'),(6187,6187,'2014-01-01','ET','2',1,NULL,'Andrew Danna','FI','460736561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:55',0,'2014-03-02 04:10:25'),(14099,14550,'2014-01-01','ET','2',5,4,'Shmuel Yaakov Kessler','FI','147700761','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:34',0,'2014-03-01 16:40:16'),(14356,14807,'2014-01-01','ET','2',2,1,'DEBRA ANDREWS','FI','294561632','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:47',0,'2014-03-10 16:17:47'),(14979,15430,'2014-01-01','ET','2',1,NULL,'jack paytes','FI','299482203','Dental Care Plus, Inc.','FI','311185262','STACY  BUSH','94','16841135','348','2014-03-01','Sync Success',0,'2014-01-17 03:36:01',0,'2014-03-01 16:50:53'),(16215,16864,'0000-00-00','ET','2',1,NULL,'JAMES BALDWIN','FI','557430979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:50',0,'2014-03-02 06:10:30'),(16911,17561,'0000-00-00','ET','2',1,NULL,'Isabelle Goulding','94','0000027921','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:33',0,'2014-03-01 17:00:58'),(17265,17915,'0000-00-00','ET','2',1,NULL,'LATEARRIA HERNDON','FI','453972760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:38',0,'2014-03-02 06:24:38'),(19383,20033,'0000-00-00','ET','2',1,NULL,'TIMOTHY CARTINO','FI','273708093','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:55',0,'2014-03-01 17:34:07'),(20057,20707,'0000-00-00','ET','2',1,NULL,'PENNY KERVIN','FI','445549990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:16',0,'2014-03-02 07:10:28'),(21124,21774,'0000-00-00','ET','2',1,NULL,'Mariana Perez','FI','451870607','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:02',0,'2014-03-02 07:23:39'),(21283,21933,'0000-00-00','ET','2',1,NULL,'ELDORA JONES','FI','425048762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:51',0,'2014-03-02 07:23:39'),(22444,23094,'0000-00-00','ET','2',1,NULL,'anna inman','FI','457800876','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:31',0,'2014-03-07 22:26:59'),(1488,1488,'2014-01-01','ET','2',1,NULL,'Stephen Douglas Paris','FI','275443922','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:57:00',0,'2014-03-10 16:03:49'),(3654,3654,'2014-01-01','ET','2',1,NULL,'Deborah Gradomski','FI','263131323','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:04',0,'2014-03-10 15:52:36'),(4607,4607,'2014-01-01','ET','2',1,NULL,'Laura Landfeld','94','0000468103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:47:27',0,'2014-03-01 16:15:39'),(6384,6384,'2014-01-01','ET','2',2,1,'Samuel Wallace','FI','284688707','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 03:09:58',0,'2014-03-10 13:39:10'),(11258,11258,'2014-01-01','ET','2',1,NULL,'Hickman Morlie','FI','434216684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:13',0,'2014-03-02 04:45:37'),(10840,10840,'2014-01-01','ET','2',1,NULL,'Gary Butters','FI','587336029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:09',0,'2014-03-02 04:31:46'),(7369,7369,'2014-01-01','ET','2',1,NULL,'Charles Hill','FI','281905104','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:13',0,'2014-03-10 13:03:33'),(13499,13855,'2014-01-01','ET','2',2,1,'tanya mcfatridge','FI','467555682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:15',0,'2014-03-02 05:31:31'),(14280,14731,'2014-01-01','ET','2',2,1,'TONIMARIE F FENIMORE','FI','287807059','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:15',0,'2014-03-01 16:46:19'),(15041,15492,'2014-01-01','ET','2',1,NULL,'Adria Ivey','FI','438117133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:27',0,'2014-03-02 05:52:31'),(15099,15550,'0000-00-00','ET','2',2,1,'Michelle Steakley','FI','525252818','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:48',0,'2014-03-02 05:52:31'),(15932,16581,'0000-00-00','ET','2',1,NULL,'Douglas Born','FI','462299906','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:12',0,'2014-03-02 06:03:21'),(16741,17391,'0000-00-00','ET','2',1,NULL,'valorie ann bearden','FI','464884788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:04',0,'2014-03-02 06:17:30'),(16916,17566,'0000-00-00','ET','2',2,1,'CATHERINE MCQUEEN','FI','297561607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:36',0,'2014-03-01 17:00:58'),(17745,18395,'0000-00-00','ET','2',2,1,'Maria Golden','FI','466497283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:32',0,'2014-03-02 06:31:45'),(18856,19506,'0000-00-00','ET','2',1,NULL,'James Murphy','FI','276769361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:30',0,'2014-03-02 06:52:12'),(19122,19772,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:00',0,'2014-03-01 17:34:07'),(19399,20049,'0000-00-00','ET','2',1,NULL,'CHRISTOPHER CORNELIUS','FI','250872538','Dental Care Plus, Inc.','FI','311185262','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:07',0,'2014-03-01 17:34:07'),(19786,20436,'0000-00-00','ET','2',1,NULL,'Jose Salinas','FI','639010247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:12',0,'2014-03-02 07:03:25'),(20655,21305,'0000-00-00','ET','2',1,NULL,'Traci Crooks','FI','277785097','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:29',0,'2014-03-10 16:38:05'),(20853,21503,'0000-00-00','ET','2',1,NULL,'JESSIE LEE','FI','435987556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:23',0,'2014-03-02 07:17:36'),(21262,21912,'0000-00-00','ET','2',1,NULL,'XAVIER COLEY','FI','267573931','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:38',0,'2014-03-01 21:35:40'),(21322,21972,'0000-00-00','ET','2',1,NULL,'CAROLING  C LEE','FI','250156276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:08',0,'2014-03-03 01:07:25'),(21663,22313,'0000-00-00','ET','2',1,NULL,'tyrone goings','FI','280709201','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:07',0,'2014-03-04 21:36:30'),(814,814,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:42',0,'2014-03-01 15:10:22'),(1246,1246,'2014-01-01','ET','2',1,NULL,'Darlene Nelms','FI','298680845','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:04',0,'2014-03-01 16:15:39'),(12697,12697,'2014-01-01','ET','2',1,NULL,'randall shearer','FI','272763670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:39',0,'2014-03-10 13:59:38'),(2606,2606,'2014-01-01','ET','2',1,0,'Christopher Presley','FI','302821094','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:10',0,'2014-03-01 15:05:09'),(3193,3193,'2014-01-01','ET','2',1,NULL,'Nicolle Cioffi','FI','284864486','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:07',0,'2014-03-01 15:48:04'),(11891,11891,'2014-01-01','ET','2',1,NULL,'Jasmine Capers','FI','434797751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:43',0,'2014-03-02 04:59:36'),(11117,11117,'2014-01-01','ET','2',3,2,'James Maurer','FI','380864451','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:40',0,'2014-03-10 13:45:57'),(5334,5334,'2014-01-01','ET','2',1,NULL,'gary daye','FI','284668607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:18',0,'2014-03-01 15:16:37'),(5553,5553,'2014-01-01','ET','2',1,NULL,'Deborah Ledbetter','FI','450909499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:09',0,'2014-03-02 04:45:37'),(5721,5721,'2014-01-01','ET','2',1,NULL,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:01:04',0,'2014-03-01 15:48:04'),(13383,13739,'2014-01-01','ET','2',1,NULL,'Joseph Kohn','FI','465780712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:46',0,'2014-03-02 05:24:45'),(13801,14157,'2014-01-01','ET','2',1,NULL,'Melissa Fraser','FI','232044454','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:09',0,'2014-03-01 16:40:16'),(15009,15460,'2014-01-01','ET','2',2,1,'PENNY  S  KOHUT','FI','301560031','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:13',0,'2014-03-10 16:17:47'),(15267,15718,'0000-00-00','ET','2',2,1,'RUTH ANN BOLING','FI','300485249','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:42',0,'2014-03-10 14:10:12'),(15519,15970,'0000-00-00','ET','2',1,NULL,'jami harris','FI','213216092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:59',0,'2014-03-02 05:59:43'),(16605,17255,'0000-00-00','ET','2',1,NULL,'Cornel Suciu','FI','632420349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:10',0,'2014-03-02 06:17:30'),(16639,17289,'0000-00-00','ET','2',1,NULL,'STELLA M HOWARD','FI','436411932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:35',0,'2014-03-02 06:17:30'),(18069,18719,'0000-00-00','ET','2',1,NULL,'Melissa Hance','FI','235238996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:14',0,'2014-03-02 06:38:05'),(18402,19052,'0000-00-00','ET','2',1,NULL,'LEONARD FREED','FI','294469028','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:02',0,'2014-03-10 16:31:33'),(18799,19449,'0000-00-00','ET','2',1,NULL,'Deborah Copeland','FI','292543913','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:07',0,'2014-03-10 14:31:05'),(22152,22802,'0000-00-00','ET','2',2,1,'KEVIN DECKER','FI','290685436','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:05',0,'2014-03-06 21:36:23'),(1010,1010,'2014-01-01','ET','2',1,NULL,'Jeffrey Stroll','FI','274745800','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:35',0,'2014-03-10 15:39:19'),(1067,1067,'2014-01-01','ET','2',1,NULL,'Janet Solari','FI','333527569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:50',0,'2014-03-01 15:16:37'),(14423,14874,'2014-01-01','ET','2',1,NULL,'Carl Robinson','FI','587050115','Starmount Life Insurance Company','FI','720977315','Revonno  Burt','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:17',0,'2014-03-02 05:38:34'),(14995,15446,'2014-01-01','ET','2',2,1,'TAMMY DUKE','FI','428217273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:08',0,'2014-03-02 05:52:31'),(17392,18042,'0000-00-00','ET','2',1,NULL,'Ashley Williams','FI','272824615','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:36',0,'2014-03-01 17:20:55'),(18871,19521,'0000-00-00','ET','2',1,NULL,'Joseph Wentzel','FI','273844817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:40',0,'2014-03-01 17:34:07'),(19542,20192,'0000-00-00','ET','2',2,1,'TYSHA TUCKER','FI','428494080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:16:05',0,'2014-03-02 06:59:07'),(20856,21506,'0000-00-00','ET','2',1,NULL,'JANET BAER','FI','289704654','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:24',0,'2014-03-10 14:37:47'),(21994,22644,'0000-00-00','ET','2',1,NULL,'Margaret McConnell','FI','207668856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:48',0,'2014-03-10 16:44:18'),(2216,2216,'2014-01-01','ET','2',1,NULL,'Carol Elchert','FI','281528594','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-01-01','Sync Success',0,'2013-12-25 19:48:41',0,'2014-03-10 13:10:24'),(3920,3920,'2014-01-01','ET','2',1,NULL,'PAUL YANOVICH','FI','278503493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:45:38',0,'2014-03-01 15:26:40'),(10447,10447,'2014-01-01','ET','2',1,NULL,'timothy hiser','FI','295845878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:12',0,'2014-03-01 16:10:36'),(3412,3412,'2014-01-01','ET','2',1,NULL,'Lakeishia Johnson','FI','426238768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:52:07',0,'2014-03-02 02:10:49'),(3067,3067,'2014-01-01','ET','2',5,4,'Mark Scholten','FI','380884299','Dental Care Plus, Inc.','FI','311185262','Jeffrey  Novak','94','3240750','348','2014-01-01','Sync Success',0,'2013-12-25 21:35:09',0,'2014-03-01 15:37:30'),(4012,4012,'2014-01-01','ET','2',1,NULL,'tony elmi','FI','459310485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:29',0,'2014-03-02 03:09:49'),(4650,4650,'2014-01-01','ET','2',1,NULL,'Glen Patrick Hames','FI','558539599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:53',0,'2014-03-02 04:38:08'),(6219,6219,'2014-01-01','ET','2',1,NULL,'Ronald H Lehman','FI','295423213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:54',0,'2014-03-01 16:00:27'),(5678,5678,'2014-01-01','ET','2',2,1,'KIMBERLY FORSTER','FI','367869897','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:21',0,'2014-03-10 13:52:32'),(12744,12744,'2014-01-01','ET','2',1,NULL,'Edit  Morales','FI','637468517','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:28',0,'2014-03-02 05:10:52'),(12972,12972,'2014-01-01','ET','2',1,NULL,'Caroline  Vela','FI','458192851','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:09',0,'2014-03-02 05:17:40'),(16276,16926,'0000-00-00','ET','2',1,NULL,'Anne Clark','FI','601649708','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:00:08',0,'2014-03-02 06:10:30'),(17221,17871,'0000-00-00','ET','2',1,NULL,'Edward Heindl','FI','297680578','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:16',0,'2014-03-01 17:20:55'),(19387,20037,'0000-00-00','ET','2',1,NULL,'CATHERINE SMITH','FI','279600594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:58',0,'2014-03-01 17:34:07'),(19961,20611,'0000-00-00','ET','2',2,1,'WEN SIANG','FI','403374540','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:24',0,'2014-03-01 17:47:19'),(21356,22006,'0000-00-00','ET','2',1,NULL,'DEBORAH DOWNEY','FI','284507677','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:27',0,'2014-03-10 14:45:25'),(21771,22421,'0000-00-00','ET','2',1,NULL,'Clayton Randolph','FI','280629828','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:02:38',0,'2014-03-10 14:45:25'),(21843,22493,'0000-00-00','ET','2',1,NULL,'Juliean Hall','FI','275031342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:32',0,'2014-03-10 14:45:25'),(22041,22691,'0000-00-00','ET','2',1,NULL,'tara jewell','FI','595521558','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:22',0,'2014-03-10 14:45:25'),(22406,23056,'0000-00-00','ET','2',1,NULL,'Ebony Latracy Ward','FI','465794570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:03',0,'2014-03-07 22:26:59'),(23027,23677,'0000-00-00','ET','2',1,NULL,'Jereme Sanders','FI','625545052','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:10',0,'2014-03-10 21:27:11'),(1138,1138,'2014-01-01','ET','2',1,NULL,'marco bustos','FI','635228199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:50',0,'2014-03-02 04:45:37'),(7016,7016,'2014-01-01','ET','2',1,NULL,'M Lyn Salvany','FI','461196104','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:00',0,'2014-03-02 03:09:49'),(2858,2858,'2014-01-01','ET','2',1,NULL,'Spencer Davis','FI','287923845','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:17',0,'2014-03-10 15:59:47'),(10753,10753,'2014-01-01','ET','2',1,NULL,'Tracey Mays','FI','293889761','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:19',0,'2014-03-01 16:15:39'),(10759,10759,'2014-01-01','ET','2',2,1,'Amanda Gonzalez','FI','296803534','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:33',0,'2014-03-01 16:15:39'),(2835,2835,'2014-01-01','ET','2',1,NULL,'Ashleigh Thomas','FI','642262430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:30',0,'2014-03-02 04:15:49'),(2813,2813,'2014-01-01','ET','2',1,NULL,'Ralph Freeman','FI','350686825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:44',0,'2014-03-01 16:05:34'),(6068,6068,'2014-01-01','ET','2',1,NULL,'Jessica Patterson','FI','439698997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:00:19',0,'2014-03-02 04:10:25'),(5931,5931,'2014-01-01','ET','2',1,NULL,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:31:47',0,'2014-03-01 15:48:04'),(5833,5833,'2014-01-01','ET','2',1,NULL,'Tamoria Lowe','FI','437511572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:30',0,'2014-03-01 20:10:57'),(4614,4614,'2014-01-01','ET','2',1,NULL,'amy anderson','FI','440847801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:47:41',0,'2014-03-02 04:31:46'),(4526,4526,'2014-01-01','ET','2',1,NULL,'WILLIE  PAYNE','FI','587011321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:58',0,'2014-03-01 21:11:04'),(4032,4032,'2014-01-01','ET','2',1,NULL,'Timothy B White','FI','284621624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:07',0,'2014-03-02 03:09:49'),(2881,2881,'2014-01-01','ET','2',3,2,'orville davis','FI','406119320','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:02',0,'2014-03-10 13:39:10'),(3539,3539,'2014-01-01','ET','2',1,NULL,'Chrisann Byers','FI','287504151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:27',0,'2014-03-01 15:37:30'),(3315,3315,'2014-01-01','ET','2',2,1,'Jacquelyn Reser','FI','294807051','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:00',0,'2014-03-01 15:52:44'),(16460,17110,'0000-00-00','ET','2',1,NULL,'Sherri Fox','FI','287707038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:13',0,'2014-03-01 17:00:58'),(17284,17934,'0000-00-00','ET','2',1,NULL,'teresa zamora','FI','450924301','Starmount Life Insurance Company','FI','720977315','Jesse   Stambaugh','94','12869420','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:46',0,'2014-03-02 06:24:38'),(19839,20489,'0000-00-00','ET','2',1,NULL,'Alia Swanson','FI','234084099','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 22:00:56',0,'2014-03-01 17:47:19'),(21390,22040,'0000-00-00','ET','2',2,1,'Rodney Gay','FI','273589879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:04',0,'2014-03-03 21:36:16'),(23030,23680,'0000-00-00','ET','2',1,NULL,'Jennifer Marie Smoot','FI','404211136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:13',0,'2014-03-10 21:17:52'),(2428,2428,'2014-01-01','ET','2',1,NULL,'Bettye Acoff','FI','302704013','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:07',0,'2014-03-10 15:45:56'),(2914,2914,'2014-01-01','ET','2',1,NULL,'ROBERT WAYNE MOORE','FI','587642360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:23',0,'2014-03-02 01:10:33'),(10817,10817,'2014-01-01','ET','2',1,NULL,'Cheryl Taylor','FI','438028042','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:26',0,'2014-03-02 04:31:46'),(10424,10424,'2014-01-01','ET','2',1,NULL,'Judy Pierce','FI','268480964','Dental Care Plus, Inc.','FI','311185262','Tom  Paplaczyk','94','1925192','348','2014-01-01','Sync Success',0,'2013-12-26 12:51:26',0,'2014-03-01 16:10:36'),(3895,3895,'2014-01-01','ET','2',1,NULL,'Carrie Przeslak','FI','380989117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:04',0,'2014-03-01 19:11:03'),(5411,5411,'2014-01-01','ET','2',1,NULL,'Diane Frederick','FI','301726519','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:41',0,'2014-03-01 15:10:22'),(12403,12403,'2014-01-01','ET','2',1,NULL,'LAURA MAZAR','FI','217703646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:29:46',0,'2014-03-01 16:35:14'),(13229,13585,'2014-01-01','ET','2',1,NULL,'Barbara D\'Aurelio','FI','278521066','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:14',0,'2014-03-10 16:10:34'),(13358,13714,'2014-01-01','ET','2',1,NULL,'Bertha Navarro','FI','467139054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:35',0,'2014-03-02 05:24:45'),(13538,13894,'2014-01-01','ET','2',2,1,'Sharon Lynn Bell','FI','277581532','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:41',0,'2014-03-01 16:40:16'),(13992,14348,'2014-01-01','ET','2',2,1,'anthony pickett','FI','294709898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:23',0,'2014-03-02 05:31:31'),(16798,17448,'0000-00-00','ET','2',2,1,'Christopher Gott','FI','564274613','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:39',0,'2014-03-01 17:00:58'),(17035,17685,'0000-00-00','ET','2',1,NULL,'MELBA LEGGETT','FI','355561872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:21',0,'2014-03-02 06:24:38'),(17710,18360,'0000-00-00','ET','2',1,NULL,'marvin ramsey','FI','438829757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:08',0,'2014-03-02 06:31:45'),(3213,3213,'2014-01-01','ET','2',2,1,'Christopher Wallace','FI','234354564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:44',0,'2014-03-01 15:48:04'),(11504,11504,'2014-01-01','ET','2',2,1,'BRIDGETTE ANNETTE BALDWIN','FI','455231338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:46',0,'2014-03-02 04:59:36'),(10834,10834,'2014-01-01','ET','2',1,NULL,'Osmin Lemus','FI','437891204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:58',0,'2014-03-02 04:31:46'),(6395,6395,'2014-01-01','ET','2',2,1,'don ring','FI','363846718','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:19',0,'2014-03-10 13:39:10'),(7163,7163,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000120057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:29',0,'2014-03-10 15:59:47'),(7059,7059,'2014-01-01','ET','2',1,NULL,'Brenda Phillips','FI','268620475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:18',0,'2014-03-01 15:52:44'),(12761,12761,'2014-01-01','ET','2',3,2,'Thomas Fishback','FI','281686662','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:08',0,'2014-03-10 13:59:38'),(13153,13509,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:02',0,'2014-03-10 16:10:34'),(14502,14953,'2014-01-01','ET','2',1,NULL,'Valerie Stapleton','FI','288807874','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:53',0,'2014-03-10 14:03:26'),(14852,15303,'2014-01-01','ET','2',2,1,'ROBERT WAYNE DUNCAN','FI','575788516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:02',0,'2014-03-02 05:45:37'),(14882,15333,'2014-01-01','ET','2',1,NULL,'DEBORAH HUME','FI','458986534','Starmount Life Insurance Company','FI','720977315','CAMERO  LILJENQUIST','94','8328382','348','2014-03-01','Sync Success',0,'2014-01-17 03:35:16',0,'2014-03-02 05:52:31'),(16428,17078,'0000-00-00','ET','2',1,NULL,'CHARLES JONES','FI','092408370','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-29 21:01:44',0,'2014-03-10 14:20:26'),(16971,17621,'0000-00-00','ET','2',1,NULL,'JOYCE VERONICA MAST','FI','270508114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:12',0,'2014-03-01 17:00:58'),(19456,20106,'0000-00-00','ET','2',1,NULL,'Rosa Estrada Gonzalez','FI','643193628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:44:28',0,'2014-03-02 06:59:07'),(20809,21459,'0000-00-00','ET','2',2,1,'Mohammad Ali Hameed Tukdi','FI','348827191','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:03',0,'2014-03-02 07:17:36'),(22625,23275,'0000-00-00','ET','2',1,NULL,'Anthony Tyrrell','FI','294965527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:01',0,'2014-03-08 21:35:36'),(22975,23625,'0000-00-00','ET','2',4,3,'Savannah Hogan','FI','273926111','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:33',0,'2014-03-10 21:36:25'),(23020,23670,'0000-00-00','ET','2',1,NULL,'MALIYA NELSON','FI','363889505','Starmount Life Insurance Company','FI','720977315','LOTTIE  JONES','94','6212907','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:05',0,'2014-03-10 21:27:11'),(562,562,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:26',0,'2014-03-01 15:48:04'),(12354,12354,'2014-01-01','ET','2',1,NULL,'James Rackley','FI','450316783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:01',0,'2014-03-02 05:03:29'),(826,826,'2014-01-01','ET','2',2,1,'Ronald Eugene Meisner','FI','293482552','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:09',0,'2014-03-10 13:03:33'),(2059,2059,'2014-01-01','ET','2',1,NULL,'Lance Douglas Richmond','FI','600461243','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:43',0,'2014-03-10 15:45:56'),(2755,2755,'2014-01-01','ET','2',1,NULL,'Alexius Prejean','FI','436512454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:53',0,'2014-03-02 04:15:49'),(3705,3705,'2014-01-01','ET','2',1,NULL,'DAVID NASH','FI','437173130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:41',0,'2014-03-02 01:10:33'),(10558,10558,'2014-01-01','ET','2',1,NULL,'Joshua Rylander','FI','461699321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:48',0,'2014-03-02 04:24:47'),(4520,4520,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:45',0,'2014-03-10 15:39:19'),(7291,7291,'2014-01-01','ET','2',2,1,'Laura Barton','FI','277724505','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:26',0,'2014-03-10 13:32:15'),(5023,5023,'2014-01-01','ET','2',1,NULL,'Larry Ludington','FI','282504886','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:43',0,'2014-03-01 15:31:33'),(13331,13687,'2014-01-01','ET','2',1,NULL,'sonja a Davis','FI','436210092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:24',0,'2014-03-02 05:24:45'),(13967,14323,'2014-01-01','ET','2',1,NULL,'KATHLEEN EDWARDS','FI','292507919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:05',0,'2014-03-01 16:40:16'),(14929,15380,'2014-01-01','ET','2',1,NULL,'Lisa  Foraker','FI','299727983','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:38',0,'2014-03-01 16:50:53'),(15963,16612,'0000-00-00','ET','2',2,1,'uzma chaudhry','FI','045045647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:11',0,'2014-03-02 06:03:21'),(16499,17149,'0000-00-00','ET','2',2,1,'CRAIG DAVIS','FI','549412938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:36',0,'2014-03-02 06:10:30'),(16864,17514,'0000-00-00','ET','2',1,NULL,'Dennis Lange','FI','275485444','HealthSpan','FI','311431434','Nathan  Lewis','94','17100322','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:05',0,'2014-03-10 14:20:26'),(17568,18218,'0000-00-00','ET','2',4,3,'Janna Mennetti','94','0000658460','Dental Care Plus, Inc.','FI','311185262','Dave   Shindollar','94','3243878','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:48',0,'2014-03-01 17:20:55'),(20553,21203,'0000-00-00','ET','2',1,NULL,'HELEN KRENEK','FI','457963974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:18',0,'2014-03-02 07:17:36'),(21668,22318,'0000-00-00','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:01:11',0,'2014-03-04 21:36:30'),(22125,22775,'0000-00-00','ET','2',1,NULL,'LaKitta Marie Mayfield','FI','435675501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:00:48',0,'2014-03-06 21:27:26'),(22183,22833,'0000-00-00','ET','2',1,NULL,'vicki warner','FI','275505854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:27',0,'2014-03-06 21:36:23'),(267,267,'2014-01-01','ET','2',1,NULL,'athena jones','FI','296668677','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:28',0,'2014-03-10 13:03:33'),(1542,1542,'2014-01-01','ET','2',1,NULL,'THOMAS HARRISON','FI','294805273','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:41',0,'2014-03-10 13:45:57'),(1817,1817,'2014-01-01','ET','2',1,NULL,'Rodney Maas','FI','280580721','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:10',0,'2014-03-10 15:45:56'),(7253,7253,'2014-01-01','ET','2',1,NULL,'Susan Douglas','FI','415113035','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:18',0,'2014-03-10 15:59:47'),(3533,3533,'2014-01-01','ET','2',1,NULL,'Tammy Baker','FI','276665357','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:15',0,'2014-03-01 15:31:33'),(6263,6263,'2014-01-01','ET','2',1,NULL,'christopher magee','FI','438575244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:18',0,'2014-03-02 04:10:25'),(3804,3804,'2014-01-01','ET','2',1,NULL,'Joseph Chatham','FI','587564697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:28',0,'2014-03-01 23:10:52'),(4937,4937,'2014-01-01','ET','2',2,1,'Phillip Freeland','FI','276504426','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:21',0,'2014-03-01 15:10:22'),(4226,4226,'2014-01-01','ET','2',1,NULL,'SUSAN HUGUS','FI','186424872','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:03',0,'2014-03-01 16:00:27'),(4239,4239,'2014-01-01','ET','2',1,NULL,'Connie Ann Szabo','FI','273444244','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:28',0,'2014-03-10 15:59:47'),(13616,13972,'2014-01-01','ET','2',1,NULL,'LEAH POPOLIZIO','FI','073764455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:37',0,'2014-03-01 16:40:16'),(14400,14851,'2014-01-01','ET','2',2,1,'Michael Heiser','FI','289428349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:07',0,'2014-03-01 16:46:19'),(20941,21591,'0000-00-00','ET','2',1,NULL,'Douglas Grigg','FI','269667180','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:34',0,'2014-03-10 14:37:47'),(21108,21758,'0000-00-00','ET','2',1,NULL,'JOHN SALAZAR','FI','449572240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:52',0,'2014-03-02 07:23:39'),(21931,22581,'0000-00-00','ET','2',1,NULL,'Daniela Urrutia','FI','635643831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:05',0,'2014-03-05 22:27:33'),(22224,22874,'0000-00-00','ET','2',1,NULL,'Monisha Jackson','94','0001233321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:57',0,'2014-03-06 21:27:26'),(22892,23542,'0000-00-00','ET','2',1,NULL,'Laura Clarke','FI','301448959','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:33',0,'2014-03-10 21:36:25'),(477,477,'2014-01-01','ET','2',1,NULL,'JEFF VROOMAN','FI','107582744','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:55',0,'2014-03-10 13:10:24'),(3166,3166,'2014-01-01','ET','2',1,NULL,'CYNTHIA LOUISE BENSON','FI','301460281','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:38:18',0,'2014-03-10 15:52:36'),(14246,14697,'2014-01-01','ET','2',1,NULL,'Alena Frizell','FI','587575517','Starmount Life Insurance Company','FI','720977315','Lee B Akins III','94','8674235','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:00',0,'2014-03-02 05:38:34'),(4282,4282,'2014-01-01','ET','2',1,NULL,'patricia davis','FI','434907822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:08:46',0,'2014-03-02 03:09:49'),(12956,12956,'2014-01-01','ET','2',1,NULL,'ARACELY BARRAZA','FI','661699831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:35',0,'2014-03-02 05:17:40'),(11666,11666,'2014-01-01','ET','2',1,NULL,'mary lovejoy','FI','284744317','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:48',0,'2014-03-10 13:52:32'),(5082,5082,'2014-01-01','ET','2',1,NULL,'Michael  Cole','FI','286508906','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:48:39',0,'2014-03-10 13:20:27'),(11163,11163,'2014-01-01','ET','2',1,NULL,'DONNA J GROOMS','FI','285502658','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:25',0,'2014-03-10 13:45:57'),(7734,7734,'2014-01-01','ET','2',1,NULL,'laura bair','FI','295680336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 05:00:20',0,'2014-03-01 15:05:09'),(7085,7085,'2014-01-01','ET','2',1,NULL,'Theresa Richardson','FI','274728319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:11',0,'2014-03-01 15:52:44'),(5478,5478,'2014-01-01','ET','2',1,NULL,'Juan Barnes','FI','436658494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:42',0,'2014-03-02 04:45:37'),(15589,16040,'0000-00-00','ET','2',1,NULL,'DEBORAH ANN MEDINE','FI','435907098','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:31',0,'2014-03-02 05:59:43'),(16141,16790,'0000-00-00','ET','2',1,NULL,'Kirk Bonifas','FI','284921557','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:50',0,'2014-03-10 14:20:26'),(18239,18889,'0000-00-00','ET','2',1,NULL,'robert  r harris','FI','426217909','Starmount Life Insurance Company','FI','720977315','kevin d shearry','94','8938938','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:26',0,'2014-03-02 06:38:05'),(19179,19829,'0000-00-00','ET','2',4,3,'Charles Strohmeyer','FI','439430251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:46',0,'2014-03-02 06:52:12'),(19462,20112,'0000-00-00','ET','2',1,NULL,'Frederick Hurst','FI','456230180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:47:38',0,'2014-03-02 06:59:07'),(21323,21973,'0000-00-00','ET','2',1,NULL,'ledoux provosty','FI','436025423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:09',0,'2014-03-03 01:07:25'),(21673,22323,'0000-00-00','ET','2',1,NULL,'LEE LEWIS','FI','427210163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:16',0,'2014-03-04 21:27:16'),(1795,1795,'2014-01-01','ET','2',1,NULL,'gina vahalik','FI','546811484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:28',0,'2014-03-02 00:10:48'),(11259,11259,'2014-01-01','ET','2',1,NULL,'Robert Riche','FI','489902365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:14',0,'2014-03-02 04:45:37'),(1862,1862,'2014-01-01','ET','2',1,NULL,'Samuel Lippert','FI','371826117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:36',0,'2014-03-01 15:26:40'),(2180,2180,'2014-01-01','ET','2',1,NULL,'Charles Kerr','FI','456962942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:29',0,'2014-03-01 21:11:04'),(12993,12993,'2014-01-01','ET','2',1,NULL,'Robert Quinichett','FI','280805338','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:52',0,'2014-03-01 16:35:14'),(12443,12443,'2014-01-01','ET','2',1,NULL,'Bachyen Dang','FI','729120201','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',1,'2014-01-02 04:31:14',0,'2014-03-02 05:03:29'),(4422,4422,'2014-01-01','ET','2',1,NULL,'frederick painter','FI','232271176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:45',0,'2014-03-01 15:05:09'),(4457,4457,'2014-01-01','ET','2',1,NULL,'Cheryl Antonetz','FI','278507621','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:39',0,'2014-03-01 15:16:37'),(14867,15318,'2014-01-01','ET','2',2,1,'Thomas Marsh','FI','450890557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:09',0,'2014-03-02 05:52:31'),(15185,15636,'0000-00-00','ET','2',1,NULL,'GLANDA ALLEN','FI','456786204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:44:16',0,'2014-03-02 05:52:31'),(15978,16627,'0000-00-00','ET','2',1,NULL,'Tina M Wyatt','FI','275882749','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:22',0,'2014-03-01 16:56:22'),(16707,17357,'0000-00-00','ET','2',1,NULL,'Tyler Houchin','FI','284800559','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:21',0,'2014-03-01 17:00:58'),(21670,22320,'0000-00-00','ET','2',1,NULL,'Joann Davis','FI','291468978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:12',0,'2014-03-04 21:36:30'),(17885,18535,'0000-00-00','ET','2',1,NULL,'Kevin W McCall','FI','275743792','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:19',0,'2014-03-10 16:31:33'),(18420,19070,'0000-00-00','ET','2',5,4,'calvin tam','FI','534028218','Dental Care Plus, Inc.','FI','311185262','Maureen  Fowler','94','8188952','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:16',0,'2014-03-01 17:26:36'),(20127,20777,'0000-00-00','ET','2',2,1,'Katie Wilson','FI','272825750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:39',0,'2014-03-01 18:08:07'),(265,265,'2014-01-01','ET','2',2,1,'Kwang Kim','FI','406533053','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:23',0,'2014-03-10 13:03:33'),(1607,1607,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:24',0,'2014-03-01 20:10:57'),(13549,13905,'2014-01-01','ET','2',1,NULL,'Dorothy Knight','FI','433867513','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:49',0,'2014-03-02 05:31:31'),(13330,13686,'2014-01-01','ET','2',1,NULL,'Adenier Brass','FI','613568494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:23',0,'2014-03-02 05:24:45'),(1632,1632,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:59',0,'2014-03-01 20:10:57'),(2398,2398,'2014-01-01','ET','2',1,NULL,'SHARON MCENTIRE','FI','272443247','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:08',0,'2014-03-01 15:26:40'),(3203,3203,'2014-01-01','ET','2',2,1,'Tho Nguyen','FI','543613935','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:22',0,'2014-03-01 15:48:04'),(3330,3330,'2014-01-01','ET','2',1,NULL,'DWana Davis','FI','280666597','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:30',0,'2014-03-10 15:52:36'),(3846,3846,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:28',0,'2014-03-01 15:05:09'),(4788,4788,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:31',0,'2014-03-01 15:16:37'),(4061,4061,'2014-01-01','ET','2',1,NULL,'christina read','FI','466578904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:01',0,'2014-03-02 03:09:49'),(15207,15658,'0000-00-00','ET','2',1,NULL,'Pamela Burley','FI','573299785','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:30',0,'2014-03-01 16:50:53'),(15702,16351,'0000-00-00','ET','2',1,NULL,'Leticia Jimenez','FI','454251896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:49',0,'2014-03-02 05:59:43'),(17808,18458,'0000-00-00','ET','2',1,NULL,'LIZA EDWARDS','FI','428472841','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:41',0,'2014-03-02 06:24:38'),(22190,22840,'0000-00-00','ET','2',1,NULL,'Orise Joshua Ammons','FI','426652813','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:32',0,'2014-03-06 21:27:26'),(19694,20344,'0000-00-00','ET','2',1,NULL,'Janice Marie Smith','FI','426337150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:53:28',0,'2014-03-02 06:59:07'),(19722,20372,'0000-00-00','ET','2',1,NULL,'Susan Kay Hurst','FI','290481629','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-04-01','Sync Success',0,'2014-02-20 05:34:00',0,'2014-03-01 17:47:19'),(6391,6391,'2014-01-01','ET','2',1,NULL,'Barbara Gorsuch','FI','271528383','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:11',0,'2014-03-10 13:39:10'),(10486,10486,'2014-01-01','ET','2',1,NULL,'Tykisha Woods','FI','298848073','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:28',0,'2014-03-01 16:10:36'),(12229,12229,'2014-01-01','ET','2',1,NULL,'TAWANDA POWE','FI','433574147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:36',0,'2014-03-02 05:10:52'),(15076,15527,'0000-00-00','ET','2',1,NULL,'Brenda Mayo','FI','302465896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:33',0,'2014-03-01 16:50:53'),(15490,15941,'0000-00-00','ET','2',1,NULL,'RYAN  SAUNDERS','FI','275881782','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:07',0,'2014-03-10 14:10:12'),(17038,17688,'0000-00-00','ET','2',2,1,'James Davis','FI','437572488','Starmount Life Insurance Company','FI','720977315','Mary  Siggers','94','15257239','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:22',0,'2014-03-02 06:24:38'),(21255,21905,'0000-00-00','ET','2',1,NULL,'BERNADNE CHAMBERS','FI','299628641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:34',0,'2014-03-01 21:35:40'),(21748,22398,'0000-00-00','ET','2',1,NULL,'Marilyn Cobb','FI','379927205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:18',0,'2014-03-04 21:27:16'),(22665,23315,'0000-00-00','ET','2',2,1,'MARIA ELENA GARCIA','FI','629640945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:31',0,'2014-03-08 22:26:18'),(208,208,'2014-01-01','ET','2',2,1,'Wilson Cazes','FI','439842819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:33',0,'2014-03-01 22:10:55'),(12009,12009,'2014-01-01','ET','2',2,1,'Kathleen Dollar','FI','436516182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:26',0,'2014-03-02 04:59:36'),(11670,11670,'2014-01-01','ET','2',1,NULL,'Robin Jordan','FI','591967627','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:36:56',0,'2014-03-10 13:52:32'),(6008,6008,'2014-01-01','ET','2',1,NULL,'Jacinta N Dunbar','FI','233617176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:12',0,'2014-03-01 15:10:22'),(13313,13669,'2014-01-01','ET','2',1,NULL,'elizabeth stauter','FI','302886617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:17',0,'2014-03-01 16:40:16'),(15052,15503,'2014-01-01','ET','2',1,NULL,'Joanna Kopaniewski','FI','295110944','Summa Insurance Company, Inc.','FI','341809108','George  Popa','94','2256915','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:32',0,'2014-03-10 16:17:47'),(20619,21269,'0000-00-00','ET','2',1,NULL,'INEZ LEWIS','FI','433493894','Starmount Life Insurance Company','FI','720977315','KATHY  CANLAS','94','7407489','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:02',0,'2014-03-02 07:10:28'),(20988,21638,'0000-00-00','ET','2',1,NULL,'Raquell Perry','FI','435236201','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','348','2014-04-01','Sync Success',0,'2014-02-28 07:30:31',0,'2014-03-02 07:17:36'),(22436,23086,'0000-00-00','ET','2',1,NULL,'LAWANA ADGER','FI','493724390','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:25',0,'2014-03-07 22:26:59'),(12,12,'2014-01-01','ET','2',1,NULL,'Karen Moss','FI','286528614','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:24',0,'2014-03-01 15:21:15'),(5540,5540,'2014-01-01','ET','2',2,1,'Deborah Jean Hedges','FI','285629181','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:43',0,'2014-03-01 16:23:43'),(14073,14524,'2014-01-01','ET','2',1,NULL,'Gwendolyn Powell','FI','452213570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:18',0,'2014-03-02 05:31:31'),(2852,2852,'2014-01-01','ET','2',1,NULL,'KATHRYN EVERETT','FI','273585211','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:05',0,'2014-03-10 15:59:47'),(5504,5504,'2014-01-01','ET','2',1,NULL,'matthew sayre','FI','236317695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:35',0,'2014-03-01 16:23:43'),(4554,4554,'2014-01-01','ET','2',1,NULL,'hoa tran','FI','532236818','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:50',0,'2014-03-02 04:31:46'),(7297,7297,'2014-01-01','ET','2',1,NULL,'Cynthia Centers','FI','283701044','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:38',0,'2014-03-10 13:32:15'),(15735,16384,'0000-00-00','ET','2',1,NULL,'Brandon Kilby','FI','275889977','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:12',0,'2014-03-10 14:10:12'),(18064,18714,'0000-00-00','ET','2',1,NULL,'viet nguyen','FI','733100278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:11',0,'2014-03-02 06:38:05'),(20624,21274,'0000-00-00','ET','2',2,1,'Kanisha Watkins','FI','608222554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:05',0,'2014-03-02 07:10:28'),(21149,21799,'0000-00-00','ET','2',1,NULL,'Lisa Morgan','FI','263376781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:20',0,'2014-03-02 07:23:39'),(22247,22897,'0000-00-00','ET','2',1,NULL,'MARY BLOMGREN','FI','283485136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:13',0,'2014-03-10 16:44:18'),(4221,4221,'2014-01-01','ET','2',1,NULL,'Sharon Pickrel','FI','578843659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:06:53',0,'2014-03-01 16:00:27'),(14169,14620,'2014-01-01','ET','2',2,1,'Brian Sweigert','FI','274826171','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:20',0,'2014-03-10 16:17:47'),(10504,10504,'2014-01-01','ET','2',1,NULL,'David Scheiner','FI','301740819','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:00',0,'2014-03-01 16:15:39'),(18242,18892,'0000-00-00','ET','2',1,NULL,'barbara  simmons','FI','452215036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:28',0,'2014-03-02 06:38:05'),(5514,5514,'2014-01-01','ET','2',1,NULL,'Angelica Wooden','FI','272840791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:51',0,'2014-03-01 16:23:43'),(3720,3720,'2014-01-01','ET','2',1,NULL,'JERI JEANNE SIMMONS','FI','271587193','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:12',0,'2014-03-10 13:20:27'),(16411,17061,'0000-00-00','ET','2',1,NULL,'Charles Spahr','FI','296507701','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:34',0,'2014-03-10 16:24:30'),(18676,19326,'0000-00-00','ET','2',1,NULL,'melissa griffith','FI','449844226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:01:34',0,'2014-03-02 06:45:14'),(22958,23608,'0000-00-00','ET','2',1,NULL,'james blake','FI','275568207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:22',0,'2014-03-10 21:07:22'),(23019,23669,'0000-00-00','ET','2',1,NULL,'MAJOR NELSON','FI','587351852','Starmount Life Insurance Company','FI','720977315','LOTTIE  JONES','94','6212907','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:05',0,'2014-03-10 21:27:11'),(295,295,'2014-01-01','ET','2',1,NULL,'william hopwood','FI','287425325','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:45:04',0,'2014-03-10 13:10:24'),(7675,7675,'2014-01-01','ET','2',1,NULL,'rodney Harsh','FI','279701564','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:40',0,'2014-03-10 13:39:10'),(10793,10793,'2014-01-01','ET','2',1,NULL,'Cameron Calloway','FI','433815981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:38',0,'2014-03-02 04:24:47'),(12223,12223,'2014-01-01','ET','2',1,NULL,'Gina Breland','FI','437579290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:20',0,'2014-03-02 05:10:52'),(6992,6992,'2014-01-01','ET','2',1,NULL,'Arron Roysdon','FI','273943517','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:00:14',0,'2014-03-10 13:32:15'),(13274,13630,'2014-01-01','ET','2',2,1,'PAULA MARIE VALLIER','FI','438171815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:02',0,'2014-03-02 05:24:45'),(2615,2615,'2014-01-01','ET','2',1,NULL,'awes koshin','FI','611847422','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:27',0,'2014-03-01 15:16:37'),(1638,1638,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:02:09',0,'2014-03-01 20:10:57'),(15425,15876,'0000-00-00','ET','2',1,NULL,'YVONNE M MCCALL','FI','294548941','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:26',0,'2014-03-01 16:50:53'),(15645,16294,'0000-00-00','ET','2',1,NULL,'Robert Brown','FI','281445732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:08',0,'2014-03-01 16:56:22'),(18750,19400,'0000-00-00','ET','2',1,NULL,'SHARON CHAPMAN','FI','437063663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:30',0,'2014-03-02 06:45:14'),(20233,20883,'0000-00-00','ET','2',1,NULL,'BRENDA JACKSON','FI','451473001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:56',0,'2014-03-02 07:10:28'),(20346,20996,'0000-00-00','ET','2',1,NULL,'casey tucker','94','0000194106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:35',0,'2014-03-01 17:47:19'),(21622,22272,'0000-00-00','ET','2',1,NULL,'KAREEM COOK','FI','466875679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:38',0,'2014-03-04 21:27:16'),(23102,23752,'0000-00-00','ET','2',3,2,'Paul Sebe','FI','285828552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:03',0,'2014-03-10 21:35:03'),(1881,1881,'2014-01-01','ET','2',2,1,'Floyd Chaplin','FI','461572784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:15',0,'2014-03-01 23:10:52'),(5322,5322,'2014-01-01','ET','2',1,NULL,'joe wright','FI','451900723','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:17',0,'2014-03-01 19:11:03'),(4569,4569,'2014-01-01','ET','2',1,NULL,'Paul Patterson','FI','277541449','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:18',0,'2014-03-01 16:15:39'),(15656,16305,'0000-00-00','ET','2',2,1,'RALPH LEE MINAMYER','FI','298461188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:16',0,'2014-03-01 16:50:53'),(15970,16619,'0000-00-00','ET','2',2,1,'Johnny Britton','FI','249062042','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:16',0,'2014-03-02 06:03:21'),(16562,17212,'0000-00-00','ET','2',1,NULL,'Sharon Collins','FI','275485494','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:17',0,'2014-03-10 16:24:30'),(17027,17677,'0000-00-00','ET','2',1,NULL,'Oscille Baker','FI','435514742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:16',0,'2014-03-02 06:24:38'),(17237,17887,'0000-00-00','ET','2',1,NULL,'Linda Esterak','FI','270504378','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:24',0,'2014-03-10 16:24:30'),(2168,2168,'2014-01-01','ET','2',5,4,'heather silvers','FI','282809533','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:04',0,'2014-03-01 15:16:37'),(13008,13008,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:02:27',0,'2014-03-01 16:35:14'),(12346,12346,'2014-01-01','ET','2',1,NULL,'laderal coleman','FI','459295375','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:45',0,'2014-03-02 05:03:29'),(2349,2349,'2014-01-01','ET','2',1,NULL,'PATRICIA FORD','FI','278624851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:37',0,'2014-03-01 15:26:40'),(11908,11908,'2014-01-01','ET','2',1,NULL,'Patricia Alexander','FI','438357585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:18',0,'2014-03-02 04:59:36'),(3524,3524,'2014-01-01','ET','2',1,NULL,'MELANIE BIDDLE','FI','284426089','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:57',0,'2014-03-01 15:31:33'),(5835,5835,'2014-01-01','ET','2',2,1,'Natalia Skef','FI','661057200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:33',0,'2014-03-01 21:11:04'),(3643,3643,'2014-01-01','ET','2',1,NULL,'Diane Pettit','FI','283600920','HealthSpan','FI','311431434','John Daniel Farlow','94','9538800','348','2014-01-01','Sync Success',0,'2013-12-25 22:05:42',0,'2014-03-10 13:20:27'),(4108,4108,'2014-01-01','ET','2',1,NULL,'Mercy Asempa','FI','639456305','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:27',0,'2014-03-01 16:00:27'),(3743,3743,'2014-01-01','ET','2',2,1,'Lawrence Koosed','FI','273460024','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:58',0,'2014-03-10 13:20:27'),(14188,14639,'2014-01-01','ET','2',1,NULL,'Amanda West','FI','279882737','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:31',0,'2014-03-10 14:03:26'),(14441,14892,'2014-01-01','ET','2',2,1,'Roy  Ellis Miles','FI','436029295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:27',0,'2014-03-02 05:38:34'),(21376,22026,'0000-00-00','ET','2',1,NULL,'JULIE BROOKS','FI','269527406','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:39',0,'2014-03-10 14:45:25'),(21836,22486,'0000-00-00','ET','2',1,NULL,'JAUNITA D RICHARD','FI','433780949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:00:28',0,'2014-03-05 21:25:24'),(14771,15222,'2014-01-01','ET','2',1,NULL,'Krista Heaton','FI','449998155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:39',0,'2014-03-02 05:45:37'),(15481,15932,'0000-00-00','ET','2',2,1,'Patricia Fichtner','FI','278564931','HealthSpan','FI','311431434','Shaun  Hunsaker','94','16201100','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:01',0,'2014-03-10 14:10:12'),(15731,16380,'0000-00-00','ET','2',1,NULL,'Yaser Mousa','FI','064923737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:10',0,'2014-03-02 05:59:43'),(16775,17425,'0000-00-00','ET','2',1,NULL,'PAMELA ATKINSON','FI','278589759','Dental Care Plus, Inc.','FI','311185262','JOHN  DODD','94','2433834','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:25',0,'2014-03-01 17:00:58'),(18586,19236,'0000-00-00','ET','2',2,1,'stella  madonna  musselman','FI','293601588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:24',0,'2014-03-01 17:26:36'),(19417,20067,'0000-00-00','ET','2',1,NULL,'Jean Karen Eichert','FI','181388911','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:22',0,'2014-03-10 14:31:05'),(19623,20273,'0000-00-00','ET','2',1,NULL,'tabitha kunsman','FI','301747143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:36:33',0,'2014-03-01 17:47:19'),(20009,20659,'0000-00-00','ET','2',1,NULL,'Mark Manuppella','FI','274564920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:59',0,'2014-03-10 16:38:05'),(21121,21771,'0000-00-00','ET','2',1,NULL,'KHAC TRAN','FI','386359014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:00',0,'2014-03-02 07:23:39'),(119,119,'2014-01-01','ET','2',1,NULL,'erik Marquette','FI','298924483','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:39',0,'2014-03-10 15:45:56'),(12735,12735,'2014-01-01','ET','2',1,NULL,'Barbara Fahnle','FI','402646505','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:07',0,'2014-03-10 13:59:38'),(12587,12587,'2014-01-01','ET','2',2,1,'SHARON CUPP','FI','077466994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:39',0,'2014-03-01 16:35:14'),(11822,11822,'2014-01-01','ET','2',1,NULL,'Shawanna Nash','FI','644128409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:48',0,'2014-03-02 04:31:46'),(5291,5291,'2014-01-01','ET','2',1,NULL,'todd baldosser','FI','273642921','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:06',0,'2014-03-01 15:10:22'),(15931,16580,'0000-00-00','ET','2',2,1,'Betty Glambin','FI','279688161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:11',0,'2014-03-01 16:56:22'),(16042,16691,'0000-00-00','ET','2',2,1,'Dabne Whitemore','FI','045767695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:38',0,'2014-03-02 06:03:21'),(17494,18144,'0000-00-00','ET','2',1,NULL,'tina rias','FI','427316663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:50',0,'2014-03-02 06:31:45'),(19189,19839,'0000-00-00','ET','2',1,NULL,'Michael Jacques','FI','294905189','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:56',0,'2014-03-10 14:31:05'),(19385,20035,'0000-00-00','ET','2',1,NULL,'MICHEAL S JOO','FI','284566247','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:56',0,'2014-03-01 17:34:07'),(19549,20199,'0000-00-00','ET','2',1,NULL,'Jesse Scott','FI','437136504','Starmount Life Insurance Company','FI','720977315','Michael  Essex','94','17133170','348','2014-04-01','Sync Success',0,'2014-02-20 04:17:57',0,'2014-03-02 06:59:07'),(4965,4965,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:32:17',0,'2014-03-01 15:05:09'),(12315,12315,'2014-01-01','ET','2',3,2,'scott tone','FI','301825997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:51',0,'2014-03-10 13:59:38'),(6174,6174,'2014-01-01','ET','2',1,NULL,'Carol King','FI','585583012','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:31',0,'2014-03-02 04:10:25'),(11393,11393,'2014-01-01','ET','2',2,1,'Lou Claveau','FI','427355344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:20',0,'2014-03-02 04:52:44'),(13696,14052,'2014-01-01','ET','2',1,NULL,'Christopher Renn','FI','299843810','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:38',0,'2014-03-01 16:40:16'),(7269,7269,'2014-01-01','ET','2',1,NULL,'Steven Shupp','FI','294609847','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:47',0,'2014-03-10 13:32:15'),(10613,10613,'2014-01-01','ET','2',1,NULL,'Kathryn Withrow','FI','464236963','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:37',0,'2014-03-02 04:24:47'),(16512,17162,'0000-00-00','ET','2',2,1,'Robin Hawkins','FI','465658246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:44',0,'2014-03-02 06:17:30'),(18015,18665,'0000-00-00','ET','2',1,NULL,'Anna E Boggs','FI','294989934','Dental Care Plus, Inc.','FI','311185262','Laurie D Kelly','94','1837542','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:49',0,'2014-03-01 17:20:55'),(18587,19237,'0000-00-00','ET','2',1,NULL,'Donald G Wertz','FI','293567497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:25',0,'2014-03-01 17:26:36'),(19130,19780,'0000-00-00','ET','2',1,NULL,'SAKILE S CHENZIRA','FI','291544321','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:05',0,'2014-03-01 17:34:07'),(19237,19887,'0000-00-00','ET','2',1,NULL,'JACQUELINE WANG','FI','645224055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:30',0,'2014-03-02 06:52:12'),(4118,4118,'2014-01-01','ET','2',1,NULL,'Sharon M Ceena','FI','083442803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:47',0,'2014-03-01 16:00:27'),(854,854,'2014-01-01','ET','2',1,NULL,'maria ramirez','FI','631468423','Starmount Life Insurance Company','FI','720977315','manuel  bernal','94','9916517','348','2014-01-01','Sync Success',0,'2013-12-25 18:15:46',0,'2014-03-01 22:10:55'),(869,869,'2014-01-01','ET','2',1,NULL,'kelly breeden','FI','276845330','HealthSpan','FI','311431434','TIFFANY  MCCASKILL','94','6985403','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:17',0,'2014-03-10 13:10:24'),(3034,3034,'2014-01-01','ET','2',1,NULL,'Linda M Spencer','FI','292509830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:08',0,'2014-03-01 15:37:30'),(10824,10824,'2014-01-01','ET','2',1,NULL,'Gregory Diettel','FI','437232899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:40',0,'2014-03-02 04:31:46'),(1913,1913,'2014-01-01','ET','2',1,NULL,'STEPHEN HENDERSON','FI','455517994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:08',0,'2014-03-01 23:10:52'),(21375,22025,'0000-00-00','ET','2',1,NULL,'ERIN RICHARDSON','FI','298942950','HealthSpan','FI','311431434','JUDY  WILSON','94','3397333','348','2014-04-01','Sync Success',0,'2014-03-03 01:00:39',0,'2014-03-10 14:45:25'),(207,207,'2014-01-01','ET','2',1,NULL,'Diane S Smith','FI','435042585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:31',0,'2014-03-01 22:10:55'),(13925,14281,'2014-01-01','ET','2',1,NULL,'Jessie Mae McIntyre','FI','426029528','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:16',0,'2014-03-02 05:31:31'),(414,414,'2014-01-01','ET','2',1,NULL,'Adam Sorkin','FI','055623059','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:50',0,'2014-03-01 15:21:15'),(11729,11729,'2014-01-01','ET','2',1,NULL,'Tracy Gipson','FI','289604888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:47',0,'2014-03-01 16:30:17'),(1661,1661,'2014-01-01','ET','2',1,NULL,'Eleni Balasakis','FI','300724303','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:16',0,'2014-03-10 15:45:56'),(16044,16693,'0000-00-00','ET','2',1,NULL,'Robert Chance','FI','437869251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:39',0,'2014-03-02 06:03:21'),(19465,20115,'0000-00-00','ET','2',2,1,'Ricardo Ramirez','FI','454815649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:49:23',0,'2014-03-02 06:59:07'),(21508,22158,'0000-00-00','ET','2',2,1,'Long Nguyen','FI','629927040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:00',0,'2014-03-03 22:26:43'),(22672,23322,'0000-00-00','ET','2',1,NULL,'Keryl Stanley','94','0001116013','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:37',0,'2014-03-10 14:50:59'),(160,160,'2014-01-01','ET','2',1,NULL,'ANTHONY E YEAKLE','FI','302622458','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:58',0,'2014-03-10 13:10:24'),(4672,4672,'2014-01-01','ET','2',1,NULL,'Joseph Glover','FI','290568569','Dental Care Plus, Inc.','FI','311185262','Mike  Sessor','94','2516402','348','2014-01-01','Sync Success',0,'2013-12-25 23:49:38',0,'2014-03-01 16:15:39'),(17104,17754,'0000-00-00','ET','2',1,NULL,'DEBORAH COSTON','FI','299520629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:03',0,'2014-03-01 17:00:58'),(17418,18068,'0000-00-00','ET','2',1,NULL,'SUSAN SHUPPE','FI','270702718','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:54',0,'2014-03-10 16:24:30'),(20141,20791,'0000-00-00','ET','2',1,NULL,'Jennifer Beers','FI','293868619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:30:49',0,'2014-03-10 16:38:05'),(22600,23250,'0000-00-00','ET','2',1,NULL,'Mary Sherman','FI','272443546','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:23',0,'2014-03-10 14:50:59'),(1178,1178,'2014-01-01','ET','2',1,NULL,'Summer Suleiman','FI','436738788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:05',0,'2014-03-02 04:38:08'),(14617,15068,'2014-01-01','ET','2',2,1,'Rhonda Ryan','FI','281681758','Dental Care Plus, Inc.','FI','311185262','Derek D Carnohan','94','2336334','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:00',0,'2014-03-01 16:46:19'),(13483,13839,'2014-01-01','ET','2',1,NULL,'David Hoffman','FI','285821546','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:41',0,'2014-03-10 14:03:26'),(12974,12974,'2014-01-01','ET','2',1,NULL,'LAUREN MATA','FI','629099261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:13',0,'2014-03-02 05:17:40'),(1652,1652,'2014-01-01','ET','2',1,NULL,'Linda Stubbs','FI','296488183','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:33',0,'2014-03-10 13:03:33'),(11820,11820,'2014-01-01','ET','2',1,NULL,'Ilene Laskin','FI','294569244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:44',0,'2014-03-01 16:15:39'),(11659,11659,'2014-01-01','ET','2',1,NULL,'Frederick R Ziems','FI','276547357','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:34',0,'2014-03-01 16:30:17'),(2260,2260,'2014-01-01','ET','2',1,NULL,'Ian James','FI','519131805','Starmount Life Insurance Company','FI','720977315','Amie  McLaughlin','94','4717745','348','2014-01-01','Sync Success',0,'2013-12-25 19:50:14',0,'2014-03-01 21:11:04'),(4611,4611,'2014-01-01','ET','2',1,NULL,'Johnny Edward Sturdivant','FI','463191729','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:36',0,'2014-03-02 04:31:46'),(3494,3494,'2014-01-01','ET','2',2,1,'Carlos Mendez','FI','291807085','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:00',0,'2014-03-01 15:37:30'),(3430,3430,'2014-01-01','ET','2',3,2,'LUCILLE PANTON','FI','730104027','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:39',0,'2014-03-10 13:24:34'),(19194,19844,'0000-00-00','ET','2',1,NULL,'Bonita Swallow','FI','296669890','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:00',0,'2014-03-10 14:31:05'),(1066,1066,'2014-01-01','ET','2',1,NULL,'Gregory Connett','FI','295607347','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:48',0,'2014-03-01 15:16:37'),(14671,15122,'2014-01-01','ET','2',1,NULL,'CHERYL WALLACE','FI','248611980','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:34',0,'2014-03-01 16:46:19'),(1174,1174,'2014-01-01','ET','2',1,NULL,'william mayfield','FI','439513011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:57',0,'2014-03-02 04:38:08'),(2022,2022,'2014-01-01','ET','2',1,NULL,'Sharon Lomas','FI','435968053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:34',0,'2014-03-01 23:10:52'),(15923,16572,'0000-00-00','ET','2',1,NULL,'Mary Elizabeth Pena','FI','452778435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:07',0,'2014-03-02 06:03:21'),(17515,18165,'0000-00-00','ET','2',4,3,'RAYMOND SOWEMIMO','FI','467438562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:11',0,'2014-03-02 06:31:45'),(17657,18307,'0000-00-00','ET','2',2,1,'Jerry Clos','FI','284705240','HealthSpan','FI','311431434','Kim  Hoecker','94','1792499','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:39',0,'2014-03-10 14:24:38'),(18604,19254,'0000-00-00','ET','2',5,4,'Richard Bencina','FI','301440077','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Harkleroad','94','1772711','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:38',0,'2014-03-10 16:31:33'),(19420,20070,'0000-00-00','ET','2',1,NULL,'RONISHA JOHNSON','FI','523657329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:24',0,'2014-03-02 06:59:07'),(766,766,'2014-01-01','ET','2',1,NULL,'sarah knight','FI','275924744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:55',0,'2014-03-01 15:05:09'),(12184,12184,'2014-01-01','ET','2',1,NULL,'valerie Hull','FI','276686912','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:08:43',0,'2014-03-10 13:59:38'),(5520,5520,'2014-01-01','ET','2',2,1,'Mark Smith','FI','294608847','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:01',0,'2014-03-01 16:23:43'),(11005,11005,'2014-01-01','ET','2',1,NULL,'Fanchion Kenady','FI','337686967','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:57',0,'2014-03-02 04:31:46'),(15111,15562,'0000-00-00','ET','2',1,NULL,'LEE RHODES','FI','464061484','Starmount Life Insurance Company','FI','720977315','Debra  K Hill','94','16687053','348','2014-03-01','Sync Success',0,'2014-01-20 08:05:57',0,'2014-03-02 05:52:31'),(17799,18449,'0000-00-00','ET','2',1,NULL,'Robert Lantz','FI','090547898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:33',0,'2014-03-01 17:00:58'),(18305,18955,'0000-00-00','ET','2',1,NULL,'John Binz','FI','631322196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-12 21:00:08',0,'2014-03-02 06:45:14'),(19421,20071,'0000-00-00','ET','2',1,NULL,'Janet Bruins','FI','436047346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:25',0,'2014-03-02 06:59:07'),(4009,4009,'2014-01-01','ET','2',1,NULL,'Matthew White','FI','637303832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:24',0,'2014-03-02 03:09:49'),(3197,3197,'2014-01-01','ET','2',1,NULL,'Barbara Ginn','FI','338487968','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:14',0,'2014-03-01 15:48:04'),(13291,13647,'2014-01-01','ET','2',2,1,'KIMBERLY FLOYD','FI','297687670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:09',0,'2014-03-01 16:40:16'),(21533,22183,'0000-00-00','ET','2',1,NULL,'ELIZABETH MAQUEDA','FI','627228092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:18',0,'2014-03-03 22:26:43'),(22024,22674,'0000-00-00','ET','2',1,NULL,'MARIBEL PEREZ','FI','453839186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:09',0,'2014-03-05 22:27:33'),(22627,23277,'0000-00-00','ET','2',1,NULL,'ANDRE WILLIAMS','FI','275704130','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:03',0,'2014-03-08 21:35:36'),(1132,1132,'2014-01-01','ET','2',1,NULL,'Barbara Ann Baker','FI','458298193','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:39',0,'2014-03-02 04:38:08'),(3474,3474,'2014-01-01','ET','2',1,NULL,'JOSEPH MEKKER','FI','269580964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:22',0,'2014-03-01 15:31:33'),(6383,6383,'2014-01-01','ET','2',2,1,'James R Koenigseker','FI','297449159','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:57',0,'2014-03-10 13:39:10'),(10495,10495,'2014-01-01','ET','2',1,NULL,'Felicia Joan Vance','FI','273820045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:42',0,'2014-03-01 16:15:39'),(15567,16018,'0000-00-00','ET','2',2,1,'DELLA DUKETT','FI','268646884','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:21',0,'2014-03-01 16:50:53'),(17171,17821,'0000-00-00','ET','2',1,NULL,'RITA FIELDS','FI','293546947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:46',0,'2014-03-10 14:20:26'),(1325,1325,'2014-01-01','ET','2',1,NULL,'Jesus Jose Lerma','FI','449434800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:37',0,'2014-03-02 04:38:08'),(14177,14628,'2014-01-01','ET','2',1,NULL,'Elizabeth Stevens','FI','096465878','Summa Insurance Company, Inc.','FI','341809108','Jay  Jordan','94','6747517','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:24',0,'2014-03-10 16:17:47'),(2198,2198,'2014-01-01','ET','2',2,1,'brenda sue johnson','FI','434901494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:07',0,'2014-03-01 21:11:04'),(4734,4734,'2014-01-01','ET','2',1,NULL,'Douglas Latta','FI','564290596','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:56',0,'2014-03-10 13:45:57'),(6312,6312,'2014-01-01','ET','2',1,NULL,'Crystal Icke','FI','273905019','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:46',0,'2014-03-10 15:59:47'),(10509,10509,'2014-01-01','ET','2',1,NULL,'Ryan Johnson','FI','277867198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:09',0,'2014-03-01 16:15:39'),(11830,11830,'2014-01-01','ET','2',1,NULL,'NATHANIEL COLEMAN','FI','437511962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:03',0,'2014-03-02 04:31:46'),(11124,11124,'2014-01-01','ET','2',1,NULL,'ANGELETTA SHIPLEY','FI','300745276','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:57',0,'2014-03-10 13:45:57'),(11021,11021,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:11:32',0,'2014-03-10 13:39:10'),(10740,10740,'2014-01-01','ET','2',1,NULL,'CHRISTINA BALL','FI','279902012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:53',0,'2014-03-01 16:10:36'),(10623,10623,'2014-01-01','ET','2',1,NULL,'BERENICE  MUNOZ','FI','642188526','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:56',0,'2014-03-02 04:24:47'),(14533,14984,'2014-01-01','ET','2',1,NULL,'Kimberly Kuwatch','FI','285643867','HealthSpan','FI','311431434','Jamie  Charlton','94','1969502','348','2014-02-01','Sync Success',0,'2014-01-15 02:08:09',0,'2014-03-10 14:03:26'),(16121,16770,'0000-00-00','ET','2',2,1,'Ralph Moeller','FI','282549813','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:33',0,'2014-03-10 14:20:26'),(18055,18705,'0000-00-00','ET','2',2,1,'Bobby Hunter','FI','273569152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:18',0,'2014-03-10 14:24:38'),(18348,18998,'0000-00-00','ET','2',1,NULL,'LEE HYMEL','FI','437024046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:24',0,'2014-03-02 06:45:14'),(20699,21349,'0000-00-00','ET','2',1,NULL,'Jann Briesacher','FI','355480324','Starmount Life Insurance Company','FI','720977315','Delores  Madrigal','94','924580','348','2014-03-01','Sync Success',0,'2014-02-28 06:30:12',0,'2014-03-02 07:17:36'),(21998,22648,'0000-00-00','ET','2',1,NULL,'david sperner','FI','301643911','Summa Insurance Company, Inc.','FI','341809108','James  finnegin','94','2766031','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:51',0,'2014-03-10 16:44:18'),(22711,23361,'0000-00-00','ET','2',2,1,'MARTY STAGGS','FI','466558455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:06',0,'2014-03-08 22:26:18'),(929,929,'2014-01-01','ET','2',1,NULL,'Yanet Cardoma','FI','639266782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:59',0,'2014-03-01 21:11:04'),(13434,13790,'2014-01-01','ET','2',2,1,'LaToya Sterns','FI','449510179','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-02-01','Received',0,'2014-01-13 02:18:07',NULL,NULL),(12586,12586,'2014-01-01','ET','2',1,NULL,'Jonathan Kiphart','FI','289723174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:37',0,'2014-03-01 16:35:14'),(986,986,'2014-01-01','ET','2',1,NULL,'Caroline Sue Bier','FI','265631293','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:46',0,'2014-03-01 15:21:15'),(3554,3554,'2014-01-01','ET','2',1,NULL,'Amanda Bodi','FI','300906228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:55',0,'2014-03-01 15:37:30'),(4970,4970,'2014-01-01','ET','2',1,0,'ROBERT HARRISON','FI','499528313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:27',0,'2014-03-01 19:11:03'),(10986,10986,'2014-01-01','ET','2',1,NULL,'Mary Dodson','FI','304540165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:18',0,'2014-03-02 04:24:47'),(6034,6034,'2014-01-01','ET','2',1,NULL,'Tammy Burrows','FI','283648544','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:00',0,'2014-03-10 13:03:33'),(14612,15063,'2014-01-01','ET','2',2,1,'Kelley Nicholson','FI','298602100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:57',0,'2014-03-01 16:46:19'),(15215,15666,'0000-00-00','ET','2',1,NULL,'THOMAS BERRY','FI','268620255','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:36',0,'2014-03-10 14:10:12'),(15559,16010,'0000-00-00','ET','2',1,NULL,'Cassaundra Luca','FI','302902439','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:18',0,'2014-03-01 16:50:53'),(18152,18802,'0000-00-00','ET','2',3,2,'long nguyen','FI','480174498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:17',0,'2014-03-02 06:38:05'),(20320,20970,'0000-00-00','ET','2',1,NULL,'JENNIFER ARDILA LOPEZ','FI','435595754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:08',0,'2014-03-02 07:03:25'),(22597,23247,'0000-00-00','ET','2',1,NULL,'Sherrie Ramey','FI','277705553','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:21',0,'2014-03-10 14:50:59'),(22943,23593,'0000-00-00','ET','2',1,NULL,'ELIZABETH ROBERTS','FI','276422392','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-25','Sync Success',0,'2014-03-10 21:01:12',0,'2014-03-10 21:07:22'),(430,430,'2014-01-01','ET','2',1,NULL,'Michael Burtscher','FI','293524242','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:22',0,'2014-03-10 15:45:56'),(11893,11893,'2014-01-01','ET','2',1,NULL,'JAMES SMITH','FI','437638525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:47',0,'2014-03-02 04:59:36'),(11824,11824,'2014-01-01','ET','2',1,NULL,'Andrew Jackson','FI','438394017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:52',0,'2014-03-02 04:31:46'),(756,756,'2014-01-01','ET','2',1,NULL,'Janice Matthews','FI','281568676','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:33',0,'2014-03-10 13:24:34'),(1126,1126,'2014-01-01','ET','2',1,NULL,'susan murphy','FI','456230597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:28',0,'2014-03-02 04:38:08'),(2489,2489,'2014-01-01','ET','2',1,NULL,'Katherine Williams','FI','272705392','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:10',0,'2014-03-10 13:10:24'),(3671,3671,'2014-01-01','ET','2',1,NULL,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:06:35',0,'2014-03-02 01:10:33'),(4863,4863,'2014-01-01','ET','2',1,NULL,'Patricia s Webber','FI','463947430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:01',0,'2014-03-01 20:10:57'),(4853,4853,'2014-01-01','ET','2',2,1,'Michael King','FI','467294996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:41',0,'2014-03-01 20:10:57'),(15531,15982,'0000-00-00','ET','2',2,1,'Traycee Lillie','FI','460932420','Starmount Life Insurance Company','FI','720977315','James  Kirkpatrick','94','837900','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:04',0,'2014-03-02 05:59:43'),(18506,19156,'0000-00-00','ET','2',1,NULL,'Bert Friedman','FI','427292536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:15',0,'2014-03-02 06:45:14'),(18902,19552,'0000-00-00','ET','2',1,NULL,'Ava Misseldine','FI','291882804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:03',0,'2014-03-01 17:34:07'),(21347,21997,'0000-00-00','ET','2',2,1,'Timothy Kettler','FI','298483214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:21',0,'2014-03-03 01:35:37'),(21429,22079,'0000-00-00','ET','2',1,NULL,'DEMETRIUS BUSHNELL','FI','433472902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:02',0,'2014-03-03 22:26:43'),(22281,22931,'0000-00-00','ET','2',1,NULL,'Jodi Haas','94','0000710206','HealthSpan','FI','311431434','Matthew  Staten','94','4800224','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:39',0,'2014-03-10 14:50:59'),(22667,23317,'0000-00-00','ET','2',1,NULL,'melissa diles','FI','464656325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:33',0,'2014-03-08 22:26:18'),(23058,23708,'0000-00-00','ET','2',1,NULL,'Jonathan Bordner','FI','298806170','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:33',0,'2014-03-10 21:17:52'),(744,744,'2014-01-01','ET','2',1,NULL,'Linda Lou Van Slyke','FI','271527444','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:08:10',0,'2014-03-10 13:24:34'),(14584,15035,'2014-01-01','ET','2',1,NULL,'CINTHYA MORALES','FI','631583819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:44:40',0,'2014-03-02 05:45:37'),(14299,14750,'2014-01-01','ET','2',2,1,'jack willis','FI','548043551','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:23',0,'2014-03-02 05:38:34'),(1280,1280,'2014-01-01','ET','2',1,NULL,'Nathan Tandy','FI','307025210','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:10',0,'2014-03-01 16:23:43'),(1606,1606,'2014-01-01','ET','2',1,NULL,'Lupita Diggins','FI','456278578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:22',0,'2014-03-01 20:10:57'),(1663,1663,'2014-01-01','ET','2',2,1,'Ann Levin','FI','182422019','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:21',0,'2014-03-10 15:45:56'),(2134,2134,'2014-01-01','ET','2',1,NULL,'VICTOR L BULLOCK','FI','298564282','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:56',0,'2014-03-01 15:16:37'),(3841,3841,'2014-01-01','ET','2',1,NULL,'alisha brewer','FI','297868151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:18',0,'2014-03-01 15:05:09'),(3912,3912,'2014-01-01','ET','2',1,NULL,'Jamie Richard  Cahill','FI','270727955','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:25',0,'2014-03-01 15:26:40'),(11169,11169,'2014-01-01','ET','2',1,NULL,'Terry Tatman','FI','290564092','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:36',0,'2014-03-10 13:45:57'),(6282,6282,'2014-01-01','ET','2',1,NULL,'Sloan Dion','FI','660186572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:55',0,'2014-03-02 04:10:25'),(15268,15719,'0000-00-00','ET','2',1,NULL,'GARRY PERRY','FI','269583258','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:43',0,'2014-03-10 14:10:12'),(16134,16783,'0000-00-00','ET','2',1,NULL,'Michael Reiley','FI','268529665','HealthSpan','FI','311431434','Shaun  Hunsaker','94','16201100','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:45',0,'2014-03-10 14:20:26'),(17003,17653,'0000-00-00','ET','2',1,NULL,'Lisa Donato','FI','297668184','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-03 21:01:33',0,'2014-03-10 14:20:26'),(17160,17810,'0000-00-00','ET','2',4,3,'HELEN ON','FI','281111735','Dental Care Plus, Inc.','FI','311185262','DARWIN  CARMICHAEL','94','1300095','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:39',0,'2014-03-01 17:00:58'),(18026,18676,'0000-00-00','ET','2',1,NULL,'Kara Jakubec','FI','299800540','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:56',0,'2014-03-01 17:26:36'),(19304,19954,'0000-00-00','ET','2',2,1,'William Bunton','FI','509643458','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:22',0,'2014-03-10 16:31:33'),(19585,20235,'0000-00-00','ET','2',1,NULL,'Walter Harper','FI','296646330','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:28:26',0,'2014-03-10 14:37:47'),(20321,20971,'0000-00-00','ET','2',2,1,'Maria Rueda','94','0000834345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:09',0,'2014-03-02 07:03:25'),(7064,7064,'2014-01-01','ET','2',1,NULL,'Alma Haring','FI','292881316','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:27',0,'2014-03-01 15:52:44'),(12917,12917,'2014-01-01','ET','2',1,NULL,'Tisheka Melancon','FI','439738738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:31',0,'2014-03-02 05:17:40'),(12496,12496,'2014-01-01','ET','2',1,NULL,'GLENDA TAYLOR','FI','587542507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:14',0,'2014-03-02 05:03:29'),(10909,10909,'2014-01-01','ET','2',1,NULL,'Betty Lane','FI','433807480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:56',0,'2014-03-02 04:31:46'),(15292,15743,'0000-00-00','ET','2',1,NULL,'katanna lee moreno','FI','632321715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:13',0,'2014-03-02 05:52:31'),(22069,22719,'0000-00-00','ET','2',1,NULL,'Patricia Bryant','FI','285502681','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:42',0,'2014-03-10 14:45:25'),(2524,2524,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 20:30:45',0,'2014-03-01 20:10:57'),(12364,12364,'2014-01-01','ET','2',1,NULL,'Wendy Goeser','FI','105480690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:22',0,'2014-03-02 05:03:29'),(6001,6001,'2014-01-01','ET','2',1,NULL,'Grace Blair','FI','463967390','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:34:04',0,'2014-03-02 02:10:49'),(4174,4174,'2014-01-01','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:23',0,'2014-03-10 15:59:47'),(4646,4646,'2014-01-01','ET','2',1,NULL,'BLANCA HINOJOSA','FI','463080093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:45',0,'2014-03-02 04:38:08'),(19818,20468,'0000-00-00','ET','2',2,1,'JOSE RODOLFO GAMEZ','FI','461904176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:37',0,'2014-03-02 07:03:25'),(19857,20507,'0000-00-00','ET','2',1,NULL,'Eileen Zink','FI','272520462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:09',0,'2014-03-10 14:37:47'),(1,1,'2014-01-01','ET','2',2,1,'john robinson','FI','288500780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:02',0,'2014-03-01 15:21:15'),(5796,5796,'2014-01-01','ET','2',1,NULL,'Khin Thaw','FI','639805753','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:24',0,'2014-03-02 01:10:33'),(13278,13634,'2014-01-01','ET','2',1,NULL,'Kim Smith','FI','433021239','Starmount Life Insurance Company','FI','720977315','Suzanne Denise Crick','94','8946819','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:04',0,'2014-03-02 05:24:45'),(5609,5609,'2014-01-01','ET','2',1,NULL,'Dolores  C Hunt','FI','286581769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:56',0,'2014-03-01 16:23:43'),(7656,7656,'2014-01-01','ET','2',1,NULL,'Karen Zenner','FI','415176479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:03',0,'2014-03-02 04:15:49'),(7489,7489,'2014-01-01','ET','2',1,NULL,'Ashley Jenck','FI','271866472','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:40',0,'2014-03-10 13:39:10'),(3578,3578,'2014-01-01','ET','2',2,1,'daniel anaya','FI','463776392','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:40',0,'2014-03-02 00:10:48'),(5066,5066,'2014-01-01','ET','2',1,NULL,'Barry Robison','FI','285802520','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:07',0,'2014-03-01 15:31:33'),(16637,17287,'0000-00-00','ET','2',1,NULL,'JD Mohon','FI','587725025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:33',0,'2014-03-02 06:17:30'),(17683,18333,'0000-00-00','ET','2',1,NULL,'DEBRA A SEAGIN','FI','282562724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:55',0,'2014-03-10 16:24:30'),(18630,19280,'0000-00-00','ET','2',1,NULL,'Julie Rupley','FI','285849004','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:59',0,'2014-03-01 17:26:36'),(21462,22112,'0000-00-00','ET','2',1,NULL,'Mary McClain','FI','291482209','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:29',0,'2014-03-03 21:36:16'),(21964,22614,'0000-00-00','ET','2',1,NULL,'Mary Tuma','FI','273460385','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:28',0,'2014-03-10 16:44:18'),(5203,5203,'2014-01-01','ET','2',1,NULL,'Nancy Olguin','FI','627785436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:29',0,'2014-03-02 00:10:48'),(915,915,'2014-01-01','ET','2',1,NULL,'MARY ANN FITZPATRICK','FI','287509100','Dental Care Plus, Inc.','FI','311185262','MAUREEN  JUSTICE','94','15223445','348','2014-01-01','Sync Success',0,'2013-12-25 18:17:31',0,'2014-03-01 15:21:15'),(14817,15268,'2014-01-01','ET','2',1,NULL,'RUWANI KIRINGODA','FI','269882437','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:09',0,'2014-03-10 16:17:47'),(14100,14551,'2014-01-01','ET','2',2,1,'Jeffrey Mullin','FI','279702994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:35',0,'2014-03-01 16:40:16'),(1100,1100,'2014-01-01','ET','2',1,NULL,'Teresa Stump','FI','278728942','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 18:32:02',0,'2014-03-10 13:03:33'),(3149,3149,'2014-01-01','ET','2',2,1,'Robert Ross Dedo','FI','275500194','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:44',0,'2014-03-10 13:24:34'),(10801,10801,'2014-01-01','ET','2',1,NULL,'CHASITI LANDRY','FI','141840143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:54',0,'2014-03-02 04:24:47'),(18088,18738,'0000-00-00','ET','2',1,NULL,'KATJA LEAVITT','FI','639728529','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:29',0,'2014-03-02 06:38:05'),(18673,19323,'0000-00-00','ET','2',1,NULL,'Jim Gates','FI','451137644','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:32',0,'2014-03-02 06:45:14'),(19998,20648,'0000-00-00','ET','2',1,NULL,'Donald Modica','FI','274804725','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:51',0,'2014-03-01 17:47:19'),(58,58,'2014-01-01','ET','2',1,NULL,'Deborah Devlin','FI','270641541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:45',0,'2014-03-01 15:21:15'),(14665,15116,'2014-01-01','ET','2',1,NULL,'CLINTON JAMES HARDWAY','FI','296501902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:31',0,'2014-03-01 16:46:19'),(14187,14638,'2014-01-01','ET','2',2,1,'Claire Spann','FI','267874344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:30',0,'2014-03-02 05:38:34'),(6396,6396,'2014-01-01','ET','2',1,NULL,'Karen Levo','FI','283524864','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:22',0,'2014-03-10 13:39:10'),(11172,11172,'2014-01-01','ET','2',1,NULL,'David Greene','FI','285622142','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:16:43',0,'2014-03-10 13:45:57'),(1039,1039,'2014-01-01','ET','2',1,NULL,'Dennis Stumpf','FI','294527297','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:30',0,'2014-03-10 13:10:24'),(3435,3435,'2014-01-01','ET','2',1,NULL,'Adam Gibbs','FI','293924322','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:50',0,'2014-03-10 13:24:34'),(1851,1851,'2014-01-01','ET','2',5,4,'Steve Andreadis','FI','292642644','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:13',0,'2014-03-01 15:26:40'),(19285,19935,'0000-00-00','ET','2',2,1,'Harold Peaden','FI','437906118','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:08',0,'2014-03-02 06:59:07'),(6283,6283,'2014-01-01','ET','2',1,NULL,'NANCY LANDERS','FI','433925393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:56',0,'2014-03-02 04:10:25'),(12243,12243,'2014-01-01','ET','2',1,NULL,'Terrence Purnell','FI','426555206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:10',0,'2014-03-02 05:03:29'),(11760,11760,'2014-01-01','ET','2',1,NULL,'Heather Young','FI','436535534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:43',0,'2014-03-02 04:59:36'),(2808,2808,'2014-01-01','ET','2',1,NULL,'Terrance Moore','FI','271642062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:34',0,'2014-03-01 16:05:34'),(4202,4202,'2014-01-01','ET','2',1,NULL,'KATHY ANN GOSHE-COOK','FI','275648893','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:18',0,'2014-03-10 13:32:15'),(4658,4658,'2014-01-01','ET','2',1,NULL,'Javon Davis','FI','153846477','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:12',0,'2014-03-10 13:45:57'),(5107,5107,'2014-01-01','ET','2',1,NULL,'Roland Doubleday','FI','439881857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:24',0,'2014-03-02 00:10:48'),(14686,15137,'2014-01-01','ET','2',3,2,'Carey Menasian','FI','277668885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:46',0,'2014-03-01 16:46:19'),(15428,15879,'0000-00-00','ET','2',2,1,'DAVID IANNI','FI','286527676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:27',0,'2014-03-01 16:50:53'),(16399,17049,'0000-00-00','ET','2',1,NULL,'Stephen Austin','FI','437926119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:26',0,'2014-03-02 06:10:30'),(17168,17818,'0000-00-00','ET','2',1,NULL,'Jami Young','FI','279820266','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:45',0,'2014-03-01 17:20:55'),(17380,18030,'0000-00-00','ET','2',1,NULL,'June Trinh','FI','299747276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:28',0,'2014-03-02 06:31:45'),(18646,19296,'0000-00-00','ET','2',1,NULL,'DAN KENNA','FI','270681811','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:10',0,'2014-03-01 17:26:36'),(19579,20229,'0000-00-00','ET','2',1,NULL,'Sharon Graham','FI','290522434','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:26:01',0,'2014-03-10 14:37:47'),(19583,20233,'0000-00-00','ET','2',1,NULL,'Robert Parker','FI','289829447','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:27:40',0,'2014-03-10 14:37:47'),(20004,20654,'0000-00-00','ET','2',1,NULL,'leo flemming','FI','587050085','Starmount Life Insurance Company','FI','720977315','leo  flemming','94','10085604','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:56',0,'2014-03-02 07:03:25'),(20592,21242,'0000-00-00','ET','2',1,NULL,'ANNE ENGLE','FI','280669516','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:43',0,'2014-03-01 18:08:07'),(22936,23586,'0000-00-00','ET','2',1,NULL,'LYNN FRAZEE','FI','272564271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:07',0,'2014-03-10 21:07:22'),(1766,1766,'2014-01-01','ET','2',1,NULL,'michael dittiacur','FI','289785243','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:29',0,'2014-03-10 13:20:27'),(2372,2372,'2014-01-01','ET','2',1,NULL,'CHARLOTTE BEVLY','FI','298485031','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:25',0,'2014-03-01 15:26:40'),(13917,14273,'2014-01-01','ET','2',1,NULL,'Robert Manley','FI','297807811','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:12',0,'2014-03-01 16:40:16'),(12968,12968,'2014-01-01','ET','2',1,NULL,'Joycelyne A Fadojutimi','FI','463574726','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:03',0,'2014-03-02 05:17:40'),(12617,12617,'2014-01-01','ET','2',1,NULL,'jennifer andrews','FI','449571573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:41',0,'2014-03-02 05:10:52'),(11835,11835,'2014-01-01','ET','2',1,NULL,'Gayla Kirshner','FI','460815690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:14:14',0,'2014-03-02 04:31:46'),(11335,11335,'2014-01-01','ET','2',1,NULL,'IRENE GOIDE','FI','308295291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:36',0,'2014-03-02 04:52:44'),(10673,10673,'2014-01-01','ET','2',1,NULL,'Sara Smith','FI','282667060','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:30',0,'2014-03-01 16:05:34'),(3204,3204,'2014-01-01','ET','2',1,NULL,'Deborah Lawhorn','FI','276541342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:24',0,'2014-03-01 15:48:04'),(7262,7262,'2014-01-01','ET','2',1,NULL,'Jody Forman Fall','FI','291524752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:32',0,'2014-03-10 13:32:15'),(7258,7258,'2014-01-01','ET','2',1,NULL,'Mary Barker','FI','295527213','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:26',0,'2014-03-10 15:59:47'),(6322,6322,'2014-01-01','ET','2',1,NULL,'Keith Osborne','FI','293780563','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:03',0,'2014-03-10 15:59:47'),(6080,6080,'2014-01-01','ET','2',1,NULL,'Paul Dejager','FI','411065785','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:43',0,'2014-03-01 16:00:27'),(3536,3536,'2014-01-01','ET','2',1,NULL,'Sherry Vranich','FI','275507492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:20',0,'2014-03-01 15:37:30'),(3607,3607,'2014-01-01','ET','2',2,1,'Nada Alabakovski','FI','269606709','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:34',0,'2014-03-10 15:52:36'),(14843,15294,'2014-01-01','ET','2',1,NULL,'Sharon Gorman','FI','274440367','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:47:27',0,'2014-03-10 14:10:12'),(15395,15846,'0000-00-00','ET','2',2,1,'RAMON ANGULO','FI','635583096','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:06',0,'2014-03-02 05:59:43'),(15663,16312,'0000-00-00','ET','2',2,1,'Kimberly Lovill','FI','281644013','Dental Care Plus, Inc.','FI','311185262','Jeffrey  Morton','94','2211997','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:22',0,'2014-03-01 16:56:22'),(16151,16800,'0000-00-00','ET','2',1,NULL,'APRIL BALLARD','FI','426416793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:08',0,'2014-03-02 06:10:30'),(16174,16823,'0000-00-00','ET','2',1,NULL,'Gabriel Kirk Mudd','FI','258510568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:22',0,'2014-03-01 16:56:22'),(16984,17634,'0000-00-00','ET','2',1,NULL,'John A Bell','FI','283663965','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:18',0,'2014-03-10 16:24:30'),(17472,18122,'0000-00-00','ET','2',1,NULL,'CHARLES  AUBERT','FI','436865103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:01:32',0,'2014-03-02 06:31:45'),(17740,18390,'0000-00-00','ET','2',2,1,'Nora Stadler','FI','287481123','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:28',0,'2014-03-10 16:31:33'),(18057,18707,'0000-00-00','ET','2',2,1,'NURUL HOQUE','FI','628483581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:05',0,'2014-03-02 06:45:14'),(19062,19712,'0000-00-00','ET','2',1,NULL,'Erin Gulbengay','FI','567657774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:17',0,'2014-03-02 06:52:12'),(19188,19838,'0000-00-00','ET','2',1,NULL,'Karen Spray','FI','275662924','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:55',0,'2014-03-10 14:31:05'),(19829,20479,'0000-00-00','ET','2',2,1,'GIOVANNY FRANCISCO ESCRIBANO','FI','597204898','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:47',0,'2014-03-10 16:38:05'),(20479,21129,'0000-00-00','ET','2',3,2,'Heather Love','FI','269806281','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:30',0,'2014-03-01 18:08:07'),(21116,21766,'0000-00-00','ET','2',1,NULL,'Stephanie Mayers','94','0000613887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:30:57',0,'2014-03-02 07:23:39'),(21294,21944,'0000-00-00','ET','2',1,NULL,'MARY KIRK','FI','449750107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:01',0,'2014-03-02 07:23:39'),(21342,21992,'0000-00-00','ET','2',2,1,'tara jenkins','FI','594363675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:19',0,'2014-03-03 01:35:37'),(21591,22241,'0000-00-00','ET','2',1,NULL,'Matthew Mitchell','FI','434655121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:13',0,'2014-03-04 21:27:16'),(23104,23754,'0000-00-00','ET','2',2,1,'Sheila M Osburn','FI','433374086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:06',0,'2014-03-10 22:25:11'),(948,948,'2014-01-01','ET','2',1,NULL,'Maria A Palomin','FI','464239373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:35',0,'2014-03-01 22:10:55'),(1481,1481,'2014-01-01','ET','2',1,NULL,'Laurie Wright','FI','301763432','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:48',0,'2014-03-10 13:45:57'),(1573,1573,'2014-01-01','ET','2',1,NULL,'Julia Taylor','FI','455043087','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:23',0,'2014-03-01 20:10:57'),(1712,1712,'2014-01-01','ET','2',1,NULL,'harry breaux','FI','436231521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:52',0,'2014-03-02 00:10:48'),(7674,7674,'2014-01-01','ET','2',1,NULL,'Janell Renee Scott','FI','283649217','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:38',0,'2014-03-10 13:39:10'),(1777,1777,'2014-01-01','ET','2',1,NULL,'TEDDY MAY','FI','438741630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:51',0,'2014-03-02 00:10:48'),(3716,3716,'2014-01-01','ET','2',1,NULL,'Kristine L Mitchell','FI','289520284','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:04',0,'2014-03-10 13:20:27'),(5786,5786,'2014-01-01','ET','2',1,NULL,'ROBERT WHITE','FI','278546332','Summa Insurance Company, Inc.','FI','341809108','DONALD  VOUGHT','94','2230276','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:06',0,'2014-03-10 15:52:36'),(5707,5707,'2014-01-01','ET','2',1,NULL,'Brian Pallotta','FI','293765069','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 02:00:41',0,'2014-03-01 15:37:30'),(4895,4895,'2014-01-01','ET','2',2,1,'Michael Higham','FI','285745640','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:13',0,'2014-03-10 13:03:33'),(4031,4031,'2014-01-01','ET','2',2,1,'Wanda Leggett','FI','451191846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:04',0,'2014-03-02 03:09:49'),(14985,15436,'2014-01-01','ET','2',1,NULL,'Charlotte lutsy','FI','234865067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:04',0,'2014-03-01 16:46:19'),(20083,20733,'0000-00-00','ET','2',1,NULL,'BRITTANY WILLIAMS','FI','438753891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:05',0,'2014-03-02 07:10:28'),(16157,16806,'0000-00-00','ET','2',1,NULL,'Maria Valdez','FI','453270365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:11',0,'2014-03-02 06:10:30'),(17449,18099,'0000-00-00','ET','2',1,NULL,'Patricia Mikulan','FI','280741017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:15',0,'2014-03-01 17:20:55'),(20615,21265,'0000-00-00','ET','2',1,NULL,'Anthony Jackson','FI','426379017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 21:01:59',0,'2014-03-02 07:17:36'),(20707,21357,'0000-00-00','ET','2',1,NULL,'Robert Reese','FI','287640660','Dental Care Plus, Inc.','FI','311185262','Lou Ann  Madsen','94','1849491','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:15',0,'2014-03-01 18:08:07'),(21135,21785,'0000-00-00','ET','2',1,NULL,'MICHELLE TEKANCIC','FI','296863226','Summa Insurance Company, Inc.','FI','341809108','MARK  CARROLL','94','17081592','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:11',0,'2014-03-10 16:38:05'),(1025,1025,'2014-01-01','ET','2',1,NULL,'Jennifer Waugh','FI','590600500','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:21:03',0,'2014-03-10 13:10:24'),(4765,4765,'2014-01-01','ET','2',1,NULL,'Theresa Johnson','FI','300503292','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:50',0,'2014-03-10 13:03:33'),(11026,11026,'2014-01-01','ET','2',1,NULL,'Steven Edwards','FI','296448351','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:40',0,'2014-03-10 13:45:57'),(17509,18159,'0000-00-00','ET','2',2,1,'BENITO RIVERA','FI','633568599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:07',0,'2014-03-02 06:31:45'),(22834,23484,'0000-00-00','ET','2',1,NULL,'Camaree Stevens','FI','269761538','HealthSpan','FI','311431434','Timothy  Self','94','16166554','357','2014-04-01','Sync Success',0,'2014-03-09 21:01:21',0,'2014-03-10 14:50:59'),(23007,23657,'0000-00-00','ET','2',1,NULL,'Mary R Garrett','FI','274504489','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:56',0,'2014-03-10 21:17:52'),(4004,4004,'2014-01-01','ET','2',1,NULL,'Jesse Medina','FI','463437848','Starmount Life Insurance Company','FI','720977315','DAVID  EDWARDS','94','565219','348','2014-01-01','Sync Success',0,'2013-12-25 23:00:17',0,'2014-03-02 03:09:49'),(281,281,'2014-01-01','ET','2',1,NULL,'Christopher Powers','FI','274960425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:02',0,'2014-03-01 15:10:22'),(11247,11247,'2014-01-01','ET','2',1,NULL,'Elizabeth  Ann Mathews','FI','269541175','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:01:54',0,'2014-03-01 16:23:43'),(13649,14005,'2014-01-01','ET','2',1,NULL,'Will Christopher Freman','FI','572784297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:09',0,'2014-03-02 05:24:45'),(13244,13600,'2014-01-01','ET','2',1,NULL,'Patricia Mitchell','94','0001284858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-07 10:22:52',0,'2014-03-02 05:17:40'),(1245,1245,'2014-01-01','ET','2',1,NULL,'John Nicholas','FI','277685018','Dental Care Plus, Inc.','FI','311185262','Joseph  Dintino','94','2207884','357','2014-01-01','Sync Success',0,'2013-12-25 18:49:03',0,'2014-03-01 16:15:39'),(16407,17057,'0000-00-00','ET','2',1,NULL,'Rafael Green','FI','587534877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:31',0,'2014-03-02 06:10:30'),(18862,19512,'0000-00-00','ET','2',1,NULL,'COURTNEY COPPINS','FI','269924646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:34',0,'2014-03-01 17:34:07'),(19384,20034,'0000-00-00','ET','2',1,NULL,'Mary Roe','FI','274847375','Dental Care Plus, Inc.','FI','311185262','Tim  iroi','94','517910','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:55',0,'2014-03-01 17:34:07'),(19413,20063,'0000-00-00','ET','2',1,NULL,'sabrina bailey','94','0001074194','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:18',0,'2014-03-10 14:31:05'),(19960,20610,'0000-00-00','ET','2',1,NULL,'MAUREEN LYNN PORTWOOD','FI','301546170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:24',0,'2014-03-01 17:47:19'),(21242,21892,'0000-00-00','ET','2',1,NULL,'Mohamed Ibrahim','FI','230791909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:25',0,'2014-03-01 21:35:40'),(22414,23064,'0000-00-00','ET','2',2,1,'Jayna E Denbow','FI','631178733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:08',0,'2014-03-07 22:26:59'),(5345,5345,'2014-01-01','ET','2',1,NULL,'CYNTHIA JANE BLUBAUGH','FI','269646950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:40',0,'2014-03-01 15:16:37'),(4759,4759,'2014-01-01','ET','2',1,NULL,'Beth Morris','FI','270528156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:37',0,'2014-03-01 15:16:37'),(4275,4275,'2014-01-01','ET','2',1,NULL,'Melrose Richard','FI','434840698','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:34',0,'2014-03-02 03:09:49'),(10733,10733,'2014-01-01','ET','2',1,NULL,'Luke Feerer','FI','299709539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:01:42',0,'2014-03-01 16:10:36'),(2305,2305,'2014-01-01','ET','2',1,NULL,'Barbara Barnes','FI','286507492','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:24',0,'2014-03-10 15:39:19'),(6330,6330,'2014-01-01','ET','2',3,2,'Linda Jean Chasteen','FI','395667722','Summa Insurance Company, Inc.','FI','341809108','James  Finngian','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:19',0,'2014-03-10 15:59:47'),(20125,20775,'0000-00-00','ET','2',1,NULL,'ERNESTINE BYERS-LOWERY','FI','335508898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:30:37',0,'2014-03-01 18:08:07'),(22397,23047,'0000-00-00','ET','2',1,NULL,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:34',0,'2014-03-07 21:25:22'),(557,557,'2014-01-01','ET','2',1,NULL,'Sharon Hemsath','FI','287621050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:16',0,'2014-03-01 15:48:04'),(10578,10578,'2014-01-01','ET','2',1,NULL,'J Robert Ramon','FI','451795813','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:29',0,'2014-03-02 04:24:47'),(12813,12813,'2014-01-01','ET','2',1,NULL,'Perla Munoz','FI','455118237','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-04 02:01:44',0,'2014-03-02 05:17:40'),(14059,14510,'2014-01-01','ET','2',1,NULL,'Cornell Howard','FI','417027527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:09',0,'2014-03-01 16:46:19'),(10771,10771,'2014-01-01','ET','2',1,NULL,'Rachel Anne Shumate','FI','284863258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:58',0,'2014-03-02 04:24:47'),(10813,10813,'2014-01-01','ET','2',1,NULL,'Patricia Angell','FI','439886414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:17',0,'2014-03-02 04:31:46'),(18476,19126,'0000-00-00','ET','2',1,NULL,'Krystle Cook','FI','645245060','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:54',0,'2014-03-10 14:24:38'),(19051,19701,'0000-00-00','ET','2',1,NULL,'Robert Rousey','FI','438871357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:08',0,'2014-03-02 06:52:12'),(22360,23010,'0000-00-00','ET','2',1,NULL,'yara habli','94','0000115550','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:16',0,'2014-03-07 21:36:32'),(5320,5320,'2014-01-01','ET','2',1,NULL,'Matthew Bagoly','FI','292907956','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:13',0,'2014-03-10 13:03:33'),(1018,1018,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:49',0,'2014-03-01 22:10:55'),(3636,3636,'2014-01-01','ET','2',2,1,'John Watkins','FI','283480518','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-01-01','Sync Success',0,'2013-12-25 22:05:28',0,'2014-03-10 15:52:36'),(5998,5998,'2014-01-01','ET','2',1,NULL,'Joshua Minor','94','0000429019','Dental Care Plus, Inc.','FI','311185262','Rhonda K West','94','9907081','348','2014-01-01','Sync Success',0,'2013-12-26 02:33:59',0,'2014-03-01 15:48:04'),(17516,18166,'0000-00-00','ET','2',1,NULL,'Ricky Sires','FI','460218542','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:12',0,'2014-03-02 06:31:45'),(20590,21240,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:42',0,'2014-03-01 18:08:07'),(4973,4973,'2014-01-01','ET','2',2,1,'Cathy L Florgie Winkler','FI','272665054','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:07',0,'2014-03-01 15:31:33'),(4776,4776,'2014-01-01','ET','2',1,NULL,'Richard Myers','FI','456216929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:09',0,'2014-03-01 21:11:04'),(1744,1744,'2014-01-01','ET','2',1,NULL,'steven rodenberg','FI','286624777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:48',0,'2014-03-01 15:31:33'),(4744,4744,'2014-01-01','ET','2',1,NULL,'Charles Richard Miller','FI','280480974','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:04',0,'2014-03-10 13:03:33'),(7497,7497,'2014-01-01','ET','2',1,NULL,'Michael Moore','FI','273583923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:56',0,'2014-03-01 16:05:34'),(12097,12097,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:37',0,'2014-03-01 16:30:17'),(2743,2743,'2014-01-01','ET','2',1,NULL,'Barbara Harris','FI','439843321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:32',0,'2014-03-02 04:15:49'),(3477,3477,'2014-01-01','ET','2',1,NULL,'LINDA ANN BAN','FI','234867061','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:27',0,'2014-03-01 15:31:33'),(4363,4363,'2014-01-01','ET','2',1,NULL,'Roger L Smith','FI','297444724','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:11',0,'2014-03-10 13:32:15'),(5581,5581,'2014-01-01','ET','2',1,NULL,'NKECI AHUDIA CHUKWU','FI','460970639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:02',0,'2014-03-02 04:45:37'),(14614,15065,'2014-01-01','ET','2',1,NULL,'REBECCA L MELLUSO','FI','297885759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:59',0,'2014-03-01 16:46:19'),(16883,17533,'0000-00-00','ET','2',1,NULL,'Gayle D Kline','FI','454115884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:16',0,'2014-03-02 06:17:30'),(17394,18044,'0000-00-00','ET','2',1,NULL,'DAVID JANCEWICZ','FI','275525394','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:38',0,'2014-03-01 17:20:55'),(21054,21704,'0000-00-00','ET','2',5,4,'Kyle Supe','FI','396882505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:16',0,'2014-03-01 18:10:11'),(22311,22961,'0000-00-00','ET','2',1,NULL,'MELISSA HERNANDEZ','FI','466068478','Starmount Life Insurance Company','FI','720977315','CRAIG  SHAW','94','1215823','348','2014-04-01','Sync Success',0,'2014-03-06 21:30:05',0,'2014-03-06 22:25:29'),(22916,23566,'0000-00-00','ET','2',1,NULL,'stephen michael phillips','FI','437659425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:52',0,'2014-03-10 21:27:11'),(543,543,'2014-01-01','ET','2',1,NULL,'Carolyn Sanders','FI','299585893','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:48',0,'2014-03-01 15:48:04'),(12205,12205,'2014-01-01','ET','2',2,1,'Tracy Oliver','FI','276820379','HealthSpan','FI','311431434','Ryan   Valek','94','8576784','348','2014-02-01','Sync Success',0,'2014-01-01 12:09:29',0,'2014-03-10 13:52:32'),(12080,12080,'2014-01-01','ET','2',1,NULL,'kristen spicer','FI','289884462','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:01',0,'2014-03-01 16:30:17'),(894,894,'2014-01-01','ET','2',1,NULL,'Kimberly  Thompson','FI','269547828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:16:57',0,'2014-03-01 15:21:15'),(11179,11179,'2014-01-01','ET','2',1,NULL,'CARL  BREWSTER','FI','269463530','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:56',0,'2014-03-10 13:45:57'),(10510,10510,'2014-01-01','ET','2',1,NULL,'DAVID BURROUGHS','FI','510607244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:54:10',0,'2014-03-01 16:15:39'),(945,945,'2014-01-01','ET','2',1,NULL,'Summer Brown','FI','437798561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:30',0,'2014-03-01 22:10:55'),(7370,7370,'2014-01-01','ET','2',2,1,'TAMARA MCKINNEY','FI','285667400','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:15',0,'2014-03-10 15:39:19'),(7182,7182,'2014-01-01','ET','2',1,NULL,'Robert Kimbrell','FI','251989200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:05',0,'2014-03-02 02:10:49'),(5904,5904,'2014-01-01','ET','2',1,NULL,'Shirley Porter','FI','427133324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:55',0,'2014-03-02 01:10:33'),(6005,6005,'2014-01-01','ET','2',1,NULL,'Rhonda Kaye Shope','FI','298504348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:06',0,'2014-03-01 15:10:22'),(13317,13673,'2014-01-01','ET','2',1,NULL,'LISA SLATER','FI','300444502','Dental Care Plus, Inc.','FI','311185262','ISAAC  HERNANDEZ','94','16449702','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:18',0,'2014-03-01 16:40:16'),(14812,15263,'2014-01-01','ET','2',1,NULL,'DANE HAMMER','FI','277906594','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:05',0,'2014-03-10 16:17:47'),(16526,17176,'0000-00-00','ET','2',1,NULL,'GREGORY CHARLES BLACKWELL','FI','465156121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:55',0,'2014-03-02 06:10:30'),(16863,17513,'0000-00-00','ET','2',7,6,'Patrick Pylypuik','FI','271966171','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:03',0,'2014-03-10 14:20:26'),(16978,17628,'0000-00-00','ET','2',1,NULL,'Barbara Jenkins','FI','300540251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:15',0,'2014-03-01 17:00:58'),(16981,17631,'0000-00-00','ET','2',1,NULL,'Elizabeth Lee Chapman','FI','296544957','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:17',0,'2014-03-10 16:24:30'),(18100,18750,'0000-00-00','ET','2',1,NULL,'Vishal Patel','FI','637014635','Starmount Life Insurance Company','FI','720977315','Vikesh  Amin','94','15297691','348','2014-03-01','Sync Success',0,'2014-02-11 21:00:38',0,'2014-03-02 06:38:05'),(22079,22729,'0000-00-00','ET','2',1,NULL,'Debbie Deniese Jones','FI','453398579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:13',0,'2014-03-06 21:27:26'),(2392,2392,'2014-01-01','ET','2',1,NULL,'nancy sonnier','FI','589221105','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:57',0,'2014-03-01 23:10:52'),(3282,3282,'2014-01-01','ET','2',1,NULL,'Harlan Keith Toliver','FI','460233074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:53',0,'2014-03-02 02:10:49'),(11834,11834,'2014-01-01','ET','2',2,1,'Susan K Herrin','FI','299603824','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:11',0,'2014-03-10 13:45:57'),(11645,11645,'2014-01-01','ET','2',1,NULL,'Kimberly Whitis','FI','293667882','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:36:07',0,'2014-03-10 16:03:49'),(10378,10378,'2014-01-01','ET','2',1,NULL,'Raymond Gallo','FI','274742055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:01',0,'2014-03-01 16:10:36'),(4842,4842,'2014-01-01','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:15:21',0,'2014-03-01 15:10:22'),(5947,5947,'2014-01-01','ET','2',1,NULL,'Shameika Webb','FI','433712694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:14',0,'2014-03-02 02:10:49'),(13400,13756,'2014-01-01','ET','2',1,NULL,'Marjorie Correa','FI','466902810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:55',0,'2014-03-02 05:24:45'),(13980,14336,'2014-01-01','ET','2',1,NULL,'Laurie Baker','FI','439151826','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:15',0,'2014-03-02 05:31:31'),(14244,14695,'2014-01-01','ET','2',1,NULL,'VALERIE  COTTEN','FI','426271292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:59',0,'2014-03-02 05:38:34'),(14836,15287,'2014-01-01','ET','2',2,1,'BEN POLZIN','FI','384949845','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:23',0,'2014-03-10 14:03:26'),(14855,15306,'2014-01-01','ET','2',1,NULL,'Jackeline Velasquez','FI','639164465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:04',0,'2014-03-02 05:45:37'),(15078,15529,'0000-00-00','ET','2',1,NULL,'nicholas james johnson','FI','298900375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:34',0,'2014-03-01 16:50:53'),(15392,15843,'0000-00-00','ET','2',1,NULL,'Cruz Zubia','FI','585064310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:05',0,'2014-03-02 05:59:43'),(15577,16028,'0000-00-00','ET','2',1,NULL,'PATRICIA TRIPLETT','FI','426519290','Starmount Life Insurance Company','FI','720977315','REVONNO  BURT','94','6401285','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:25',0,'2014-03-02 05:59:43'),(16031,16680,'0000-00-00','ET','2',1,NULL,'Sandra Pearson','FI','436783523','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:31',0,'2014-03-02 06:03:21'),(19282,19932,'0000-00-00','ET','2',1,NULL,'ISABEL J REID','FI','123542496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:06',0,'2014-03-01 17:34:07'),(19333,19983,'0000-00-00','ET','2',1,NULL,'Pamela Ragan','FI','450061180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:22',0,'2014-03-02 06:59:07'),(20886,21536,'0000-00-00','ET','2',1,NULL,'SONYA MORTON','FI','367789925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:38',0,'2014-03-02 07:17:36'),(21924,22574,'0000-00-00','ET','2',1,NULL,'Jessica Trevino','FI','466795273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:59',0,'2014-03-05 22:27:33'),(22987,23637,'0000-00-00','ET','2',1,NULL,'HAZEL SPENCE','FI','270707850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:42',0,'2014-03-10 21:36:25'),(594,594,'2014-01-01','ET','2',1,NULL,'Vicki Steinbach','FI','450962940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:03:24',0,'2014-03-02 02:10:49'),(13173,13529,'2014-01-01','ET','2',1,NULL,'Armints Watkins','FI','407888491','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-07 04:05:45',0,'2014-03-10 13:59:38'),(1331,1331,'2014-01-01','ET','2',1,NULL,'Victoria Boyd','FI','455554835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:49',0,'2014-03-02 04:38:08'),(4272,4272,'2014-01-01','ET','2',1,NULL,'Maria Tarre','FI','047741153','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:28',0,'2014-03-02 03:09:49'),(4773,4773,'2014-01-01','ET','2',1,NULL,'James C Meadows','FI','450434550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:05',0,'2014-03-01 21:11:04'),(4786,4786,'2014-01-01','ET','2',1,NULL,'KIRBY DENSON','FI','301482910','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 00:01:27',NULL,NULL),(11146,11146,'2014-01-01','ET','2',1,NULL,'Raymond Gentile','FI','272604304','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:47',0,'2014-03-10 13:45:57'),(11008,11008,'2014-01-01','ET','2',1,NULL,'Adam Tyler','FI','412559737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:04',0,'2014-03-02 04:24:47'),(7658,7658,'2014-01-01','ET','2',1,NULL,'jacob w haas','FI','298506790','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:06',0,'2014-03-10 13:39:10'),(5137,5137,'2014-01-01','ET','2',1,NULL,'Melba Abufhele','FI','590447188','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:26',0,'2014-03-10 15:45:56'),(6320,6320,'2014-01-01','ET','2',1,NULL,'Florence Satina','FI','271540735','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:00',0,'2014-03-10 15:59:47'),(16297,16947,'0000-00-00','ET','2',3,2,'ANGEL ESTEBAN GARCIA','FI','458973245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:21',0,'2014-03-02 06:10:30'),(20112,20762,'0000-00-00','ET','2',1,NULL,'Quentin Little','FI','433495474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:28',0,'2014-03-02 07:10:28'),(21643,22293,'0000-00-00','ET','2',1,NULL,'Shelley Santana','FI','285642913','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:53',0,'2014-03-04 21:36:30'),(731,731,'2014-01-01','ET','2',1,NULL,'Linda Lou Bowman','FI','450028741','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:47',0,'2014-03-10 13:24:34'),(13036,13392,'2014-01-01','ET','2',1,NULL,'Joan Webster','FI','299509003','Dental Care Plus, Inc.','FI','311185262','Salma  Usman','94','16263332','348','2014-02-01','Sync Success',0,'2014-01-07 04:00:37',0,'2014-03-01 16:35:14'),(2450,2450,'2014-01-01','ET','2',1,NULL,'Cleve Simmons','FI','434920318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:51',0,'2014-03-01 23:10:52'),(12040,12040,'2014-01-01','ET','2',1,NULL,'Stephen Kirk','FI','444923951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:35',0,'2014-03-02 05:03:29'),(4212,4212,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:36',0,'2014-03-01 15:52:44'),(7594,7594,'2014-01-01','ET','2',1,NULL,'Theresa Kessler','FI','426439109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:06',0,'2014-03-02 04:15:49'),(4228,4228,'2014-01-01','ET','2',1,NULL,'Richard Jereb','94','0000433867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:07:07',0,'2014-03-01 16:00:27'),(4867,4867,'2014-01-01','ET','2',2,1,'Glenn MacDougall','FI','008426603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:10',0,'2014-03-01 20:10:57'),(6216,6216,'2014-01-01','ET','2',1,NULL,'Peggy Baker','FI','284662374','Dental Care Plus, Inc.','FI','311185262','Tiffany  Geiger','94','3241172','348','2014-01-01','Sync Success',0,'2013-12-26 03:04:47',0,'2014-03-01 16:00:27'),(5086,5086,'2014-01-01','ET','2',1,NULL,'Bonita Oliver','FI','172382719','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:44',0,'2014-03-10 13:20:27'),(5460,5460,'2014-01-01','ET','2',1,NULL,'Shanti Skidmore','FI','433851349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:09',0,'2014-03-02 04:45:37'),(13778,14134,'2014-01-01','ET','2',1,NULL,'Linda Jackson','FI','547862508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:32',0,'2014-03-02 05:24:45'),(13822,14178,'2014-01-01','ET','2',1,NULL,'STEPHEN FREDERICK RACE','FI','452925840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:27',0,'2014-03-02 05:31:31'),(14140,14591,'2014-01-01','ET','2',3,2,'Dawn Bowers','FI','437312091','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:00',0,'2014-03-02 05:38:34'),(16591,17241,'0000-00-00','ET','2',1,NULL,'JAMES QUINCY','FI','365804561','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:37',0,'2014-03-10 14:20:26'),(20107,20757,'0000-00-00','ET','2',1,NULL,'ARMANDO MEZA VILLANUEVA','FI','283131387','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:25',0,'2014-03-10 14:37:47'),(20667,21317,'0000-00-00','ET','2',3,2,'deitra fletcher','FI','275684182','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:38',0,'2014-03-10 14:37:47'),(21414,22064,'0000-00-00','ET','2',1,NULL,'Timothy Valenta','FI','449316301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:19',0,'2014-03-03 21:25:18'),(21475,22125,'0000-00-00','ET','2',1,NULL,'DAISY S SHARKEY','FI','282526455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:30:38',0,'2014-03-03 21:36:16'),(21557,22207,'0000-00-00','ET','2',1,NULL,'Daniel Duet','FI','437797734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:37',0,'2014-03-03 22:26:43'),(9,9,'2014-01-01','ET','2',1,NULL,'Mark Zaher','FI','288580404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:18',0,'2014-03-01 15:21:15'),(12756,12756,'2014-01-01','ET','2',1,NULL,'theodore bower','FI','282920172','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:57',0,'2014-03-10 16:10:34'),(971,971,'2014-01-01','ET','2',1,NULL,'TIFFANI THOMAS','FI','282820618','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:20',0,'2014-03-01 15:16:37'),(11034,11034,'2014-01-01','ET','2',1,NULL,'ANTHONY REGINALD GAY','FI','273702177','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:57',0,'2014-03-10 16:03:49'),(10947,10947,'2014-01-01','ET','2',1,NULL,'JASON STOUFFER','FI','262975210','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:08',0,'2014-03-10 16:03:49'),(4172,4172,'2014-01-01','ET','2',2,1,'Matthew Hoyt','FI','302600136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:19',0,'2014-03-10 15:59:47'),(4353,4353,'2014-01-01','ET','2',1,NULL,'TAMMY  M KEEFER','FI','286603399','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:52',0,'2014-03-10 13:32:15'),(5925,5925,'2014-01-01','ET','2',2,1,'Rhonda Allen Blair','FI','290506975','Dental Care Plus, Inc.','FI','311185262','Eric M. O\'Brien','94','10854100','348','2014-01-01','Sync Success',0,'2013-12-26 02:31:34',0,'2014-03-01 15:48:04'),(4858,4858,'2014-01-01','ET','2',1,NULL,'BOBBIE URIAS','FI','643103345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:52',0,'2014-03-01 20:10:57'),(17011,17661,'0000-00-00','ET','2',1,NULL,'Diane Parkman','FI','433172697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-04 21:00:05',0,'2014-03-02 06:24:38'),(17220,17870,'0000-00-00','ET','2',1,NULL,'Paul Allaer','FI','577117066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:16',0,'2014-03-01 17:20:55'),(18355,19005,'0000-00-00','ET','2',1,NULL,'Nicholas Italico','FI','085580314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:29',0,'2014-03-02 06:45:14'),(19251,19901,'0000-00-00','ET','2',1,NULL,'Aiden Romine','94','0000639571','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:40',0,'2014-03-01 17:34:07'),(21408,22058,'0000-00-00','ET','2',1,NULL,'ALBA CISNEROS','FI','456938640','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:16',0,'2014-03-03 21:25:18'),(4274,4274,'2014-01-01','ET','2',1,NULL,'Horatio Jason','FI','439274658','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:32',0,'2014-03-02 03:09:49'),(5883,5883,'2014-01-01','ET','2',1,NULL,'Rebecca Kay Parks','FI','301849086','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:12',0,'2014-03-10 15:52:36'),(6125,6125,'2014-01-01','ET','2',2,1,'JUSTIN BUSH','FI','281900738','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:04',0,'2014-03-01 16:00:27'),(11966,11966,'2014-01-01','ET','2',1,NULL,'Timothy White','FI','463997974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:48',0,'2014-03-02 04:59:36'),(11672,11672,'2014-01-01','ET','2',2,1,'Terri Francis','FI','286621924','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:59',0,'2014-03-10 13:52:32'),(11638,11638,'2014-01-01','ET','2',1,NULL,'PAULA HILL','FI','434311109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:54',0,'2014-03-02 04:59:36'),(7487,7487,'2014-01-01','ET','2',1,NULL,'Pamela  Ann Darnell','FI','276529949','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:35',0,'2014-03-10 13:39:10'),(10983,10983,'2014-01-01','ET','2',1,NULL,'EDDIE BERRY','FI','425235496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:12',0,'2014-03-02 04:24:47'),(13767,14123,'2014-01-01','ET','2',1,NULL,'Jessie Brandt','FI','283428355','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:25',0,'2014-03-10 16:10:34'),(14301,14752,'2014-01-01','ET','2',1,NULL,'Elissa  A Nadel','FI','460736739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:24',0,'2014-03-02 05:38:34'),(14603,15054,'2014-01-01','ET','2',2,1,'Sylvia Stein','FI','298748008','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:52',0,'2014-03-01 16:46:19'),(14740,15191,'2014-01-01','ET','2',1,NULL,'susan zittle','FI','286600604','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:19',0,'2014-03-10 16:17:47'),(15313,15764,'0000-00-00','ET','2',1,NULL,'River Manda Lay','FI','297139371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:26',0,'2014-03-01 16:50:53'),(15879,16528,'0000-00-00','ET','2',2,1,'gary sturm','FI','299524772','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:59',0,'2014-03-10 16:24:30'),(2908,2908,'2014-01-01','ET','2',1,NULL,'Mary Hearn','FI','587228352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:12',0,'2014-03-02 01:10:33'),(4238,4238,'2014-01-01','ET','2',1,NULL,'JUDITH THIRY','FI','280505258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:26',0,'2014-03-01 16:00:27'),(3450,3450,'2014-01-01','ET','2',4,3,'Shanna Schnipke','FI','277842593','HealthSpan','FI','311431434','lauren  hermiller','94','16945220','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:20',0,'2014-03-10 13:32:15'),(13641,13997,'2014-01-01','ET','2',1,NULL,'Marie Engles','FI','287545992','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:55',0,'2014-03-10 14:03:26'),(14541,14992,'2014-01-01','ET','2',1,NULL,'MIGUEL ORTIZ','FI','466818004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:12',0,'2014-03-02 05:45:37'),(14558,15009,'2014-01-01','ET','2',2,1,'QIONGBIN ZHU','FI','071940120','Starmount Life Insurance Company','FI','720977315','KENNETH  ROBERTS','94','1096932','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:23',0,'2014-03-02 05:45:37'),(15272,15723,'0000-00-00','ET','2',1,NULL,'David Nevling','FI','293466225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:02',0,'2014-03-02 05:52:31'),(16146,16795,'0000-00-00','ET','2',1,NULL,'Sandra Driskell','FI','427457051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:05',0,'2014-03-02 06:03:21'),(17750,18400,'0000-00-00','ET','2',1,NULL,'Larry King','94','0000723938','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:36',0,'2014-03-10 16:31:33'),(18358,19008,'0000-00-00','ET','2',2,1,'Patricia Levario','FI','455734028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:31',0,'2014-03-02 06:45:14'),(22986,23636,'0000-00-00','ET','2',1,NULL,'Bambi Bowman','FI','300687345','Dental Care Plus, Inc.','FI','311185262','John Daniel Farlow','94','9538800','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:41',0,'2014-03-10 21:36:25'),(19716,20366,'0000-00-00','ET','2',1,NULL,'Areniqua White','FI','464777281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:31:46',0,'2014-03-02 06:59:07'),(20336,20986,'0000-00-00','ET','2',1,NULL,'Richard Lawrence','FI','031447444','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:25',0,'2014-03-01 17:47:19'),(20465,21115,'0000-00-00','ET','2',1,NULL,'SHEA DAVIS','FI','299709757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:19',0,'2014-03-01 18:08:07'),(20617,21267,'0000-00-00','ET','2',1,NULL,'tekita franklin','FI','425696652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:00',0,'2014-03-02 07:17:36'),(20731,21381,'0000-00-00','ET','2',2,1,'JUDY HUBER','FI','294628870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:27',0,'2014-03-01 18:10:11'),(20852,21502,'0000-00-00','ET','2',1,NULL,'Chasity Rose','FI','434793797','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:23',0,'2014-03-02 07:17:36'),(21835,22485,'0000-00-00','ET','2',1,NULL,'Normita Bucalan','FI','436755264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:27',0,'2014-03-05 21:25:24'),(268,268,'2014-01-01','ET','2',1,NULL,'Valerie Gonzalez','FI','643017288','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:30',0,'2014-03-01 20:10:57'),(2887,2887,'2014-01-01','ET','2',2,1,'GLENN KIRCHENR','FI','283686361','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:14',0,'2014-03-10 13:39:10'),(12462,12462,'2014-01-01','ET','2',2,1,'STEPHANIE REED','FI','297847503','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:55',0,'2014-03-10 16:10:34'),(12327,12327,'2014-01-01','ET','2',1,NULL,'hanhdung thuy nguyen','FI','633313710','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:06',0,'2014-03-02 05:03:29'),(3010,3010,'2014-01-01','ET','2',1,NULL,'Robert Knoblock','FI','167408370','Summa Insurance Company, Inc.','FI','341809108','john  gillmor','94','9777900','348','2014-01-01','Sync Success',0,'2013-12-25 21:33:26',0,'2014-03-10 15:52:36'),(11399,11399,'2014-01-01','ET','2',2,1,'sharon louis','FI','179441346','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:32',0,'2014-03-10 16:03:49'),(11014,11014,'2014-01-01','ET','2',2,1,'Vernon Mack Taylor','FI','428080981','Starmount Life Insurance Company','FI','720977315','Robert  Rankin','94','11068141','348','2014-01-01','Sync Success',0,'2013-12-26 13:11:16',0,'2014-03-02 04:24:47'),(10769,10769,'2014-01-01','ET','2',1,NULL,'MIKEL SCOTT','FI','438437748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:53',0,'2014-03-02 04:24:47'),(3955,3955,'2014-01-01','ET','2',1,NULL,'vivian westmoreland','FI','545904518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:43',0,'2014-03-01 23:10:52'),(5723,5723,'2014-01-01','ET','2',1,NULL,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:01:08',0,'2014-03-01 15:48:04'),(12962,12962,'2014-01-01','ET','2',2,1,'THUY  THI  NGUYEN','FI','535534751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:48',0,'2014-03-02 05:17:40'),(13622,13978,'2014-01-01','ET','2',1,NULL,'Christine Middlecoop','FI','270501379','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:41',0,'2014-03-10 16:10:34'),(13626,13982,'2014-01-01','ET','2',1,NULL,'Elizabeth Wyss','FI','302620093','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:44',0,'2014-03-10 14:03:26'),(14013,14369,'2014-01-01','ET','2',1,NULL,'barbara weston','FI','294628793','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:40',0,'2014-03-01 16:40:16'),(15976,16625,'0000-00-00','ET','2',2,1,'Michael Sherman','FI','283504223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:21',0,'2014-03-01 16:56:22'),(17875,18525,'0000-00-00','ET','2',1,NULL,'Jamie Stocker','FI','289729906','Summa Insurance Company, Inc.','FI','341809108','Timothy  Charron','94','7944002','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:11',0,'2014-03-10 16:31:33'),(19092,19742,'0000-00-00','ET','2',1,NULL,'Janine Hill','FI','268641828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:37',0,'2014-03-01 17:34:07'),(20602,21252,'0000-00-00','ET','2',1,NULL,'BILLY R CRAWFORD','FI','273667450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:49',0,'2014-03-01 18:08:07'),(21789,22439,'0000-00-00','ET','2',2,1,'MILE BOSHKOZSKI','FI','831927849','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:08',0,'2014-03-04 21:36:30'),(1260,1260,'2014-01-01','ET','2',1,NULL,'Florence Betz','FI','273669376','Dental Care Plus, Inc.','FI','311185262','Richard C Mcclelland','94','2444519','348','2014-01-01','Sync Success',0,'2013-12-25 18:49:31',0,'2014-03-01 16:15:39'),(12998,12998,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:02',0,'2014-03-10 16:10:34'),(2670,2670,'2014-01-01','ET','2',1,NULL,'James McClelland','FI','286503924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:13',0,'2014-03-01 16:05:34'),(4791,4791,'2014-01-01','ET','2',1,NULL,'David Levine','FI','220600594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:37',0,'2014-03-01 15:16:37'),(7638,7638,'2014-01-01','ET','2',2,1,'EVELYN COOPER','FI','457914067','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:27',0,'2014-03-02 04:15:49'),(7204,7204,'2014-01-01','ET','2',1,NULL,'Nancy Lee Kildow','FI','292506208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:46',0,'2014-03-01 15:52:44'),(5655,5655,'2014-01-01','ET','2',1,NULL,'John Witcher','FI','428337929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:29',0,'2014-03-02 04:45:37'),(12314,12314,'2014-01-01','ET','2',1,NULL,'Amanda Walden','FI','269942603','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:49',0,'2014-03-10 13:59:38'),(6186,6186,'2014-01-01','ET','2',1,NULL,'Teresa Martinez','FI','463922933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:53',0,'2014-03-02 04:10:25'),(13109,13465,'2014-01-01','ET','2',1,NULL,'Yeon Won Kim','FI','460698739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:21',0,'2014-03-02 05:17:40'),(13316,13672,'2014-01-01','ET','2',2,1,'Kevin Ross','FI','164420843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:18',0,'2014-03-01 16:40:16'),(13523,13879,'2014-01-01','ET','2',1,NULL,'RENEE WOLLERMAN','FI','283887274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:32',0,'2014-03-01 16:40:16'),(13824,14180,'2014-01-01','ET','2',1,NULL,'juan quintanilla','FI','454536552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:28',0,'2014-03-02 05:31:31'),(14270,14721,'2014-01-01','ET','2',1,NULL,'marc johnson','FI','275600392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:11',0,'2014-03-01 16:46:19'),(15696,16345,'0000-00-00','ET','2',1,NULL,'RICHARD FRANCO HERNANDEZ','FI','643708821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:45',0,'2014-03-02 05:59:43'),(15824,16473,'0000-00-00','ET','2',1,NULL,'SANDRA L LIETEAU','FI','438927748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:25',0,'2014-03-02 06:03:21'),(15971,16620,'0000-00-00','ET','2',2,1,'Hai V Truong','FI','566595978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:17',0,'2014-03-02 06:03:21'),(16236,16885,'0000-00-00','ET','2',1,NULL,'Stanley Rydarowics','FI','300509677','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:03',0,'2014-03-10 16:24:30'),(17110,17760,'0000-00-00','ET','2',1,NULL,'Joseph Fink','FI','291823909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:06',0,'2014-03-01 17:20:55'),(17374,18024,'0000-00-00','ET','2',1,NULL,'EVELYN LEE','FI','463450120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:24',0,'2014-03-02 06:31:45'),(17548,18198,'0000-00-00','ET','2',1,NULL,'Shirley Jones','FI','270542443','HealthSpan','FI','311431434','Sharon  Wingert','94','2446886','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:32',0,'2014-03-10 14:24:38'),(18561,19211,'0000-00-00','ET','2',1,NULL,'Mark Hazelwood','FI','279840264','HealthSpan','FI','311431434','Michael  Bennett','94','8790924','348','2014-03-01','Sync Success',0,'2014-02-13 21:30:17',0,'2014-03-10 14:31:05'),(18867,19517,'0000-00-00','ET','2',2,1,'PAMELA BLACKWOOD','FI','277629376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:37',0,'2014-03-01 17:34:07'),(19265,19915,'0000-00-00','ET','2',1,NULL,'OSCAR PORTILLO','FI','460957181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:09',0,'2014-03-02 06:52:12'),(19749,20399,'0000-00-00','ET','2',1,NULL,'Floyd McCarver','FI','295660188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:06',0,'2014-03-01 17:47:19'),(19759,20409,'0000-00-00','ET','2',1,NULL,'deborah witt','FI','286629709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 21:30:13',0,'2014-03-10 16:38:05'),(20126,20776,'0000-00-00','ET','2',2,1,'NATHANIEL ELDRIDGE','FI','283846675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:38',0,'2014-03-01 18:08:07'),(21542,22192,'0000-00-00','ET','2',2,1,'Ruth Kuohn','FI','289565645','HealthSpan','FI','311431434','Daniel  Finkel','94','3273614','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:25',0,'2014-03-10 14:45:25'),(408,408,'2014-01-01','ET','2',1,NULL,'michelle schleppi','FI','285862300','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:38',0,'2014-03-01 15:21:15'),(12977,12977,'2014-01-01','ET','2',1,NULL,'Ashley Hymel','FI','589463892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:01:20',0,'2014-03-02 05:17:40'),(12631,12631,'2014-01-01','ET','2',1,NULL,'Ronald Dade Wright','FI','450812889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:10',0,'2014-03-02 05:10:52'),(11568,11568,'2014-01-01','ET','2',2,1,'lai la','FI','641900940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:45',0,'2014-03-02 04:52:44'),(1122,1122,'2014-01-01','ET','2',1,NULL,'Paul Schroeder','FI','453804481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:20',0,'2014-03-02 04:38:08'),(2008,2008,'2014-01-01','ET','2',1,NULL,'Judy L Thomson','FI','439949735','Starmount Life Insurance Company','FI','720977315','Wesley J Watkins','94','4710431','348','2014-01-01','Sync Success',0,'2013-12-25 19:35:07',0,'2014-03-02 00:10:48'),(4428,4428,'2014-01-01','ET','2',1,NULL,'Janelle Ries','FI','279504631','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:59',0,'2014-03-10 15:39:19'),(4862,4862,'2014-01-01','ET','2',1,NULL,'maria allison','FI','456796098','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:59',0,'2014-03-01 20:10:57'),(6408,6408,'2014-01-01','ET','2',5,4,'Timothy Miller','FI','300807095','Summa Insurance Company, Inc.','FI','341809108','Deborah  Gazey','94','2341750','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:45',0,'2014-03-10 15:59:47'),(13272,13628,'2014-01-01','ET','2',2,1,'William  Lee Dudley','FI','492765274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:01',0,'2014-03-02 05:24:45'),(14720,15171,'2014-01-01','ET','2',1,NULL,'Lenard DAVIS','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:08',0,'2014-03-02 05:45:37'),(14912,15363,'2014-01-01','ET','2',2,1,'Gory Zinn','FI','289781468','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:29',0,'2014-03-01 16:46:19'),(15250,15701,'0000-00-00','ET','2',2,1,'Manal Fahmy','FI','645462393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:28',0,'2014-03-02 05:52:31'),(16312,16962,'0000-00-00','ET','2',1,NULL,'Larry Yoder','FI','276509196','Dental Care Plus, Inc.','FI','311185262','Francie  Dunlop','94','997354','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:31',0,'2014-03-01 16:56:22'),(18020,18670,'0000-00-00','ET','2',1,NULL,'Doris Jean Long','FI','283707604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:52',0,'2014-03-01 17:20:55'),(19481,20131,'0000-00-00','ET','2',2,1,'PATRICIO MENDEZ','FI','455850766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:58:11',0,'2014-03-02 06:59:07'),(20500,21150,'0000-00-00','ET','2',1,NULL,'Alaysha Robinson','FI','438652986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:00:43',0,'2014-03-02 07:10:28'),(20605,21255,'0000-00-00','ET','2',1,NULL,'JOSEPHINE PROCHASKA','FI','286503815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:52',0,'2014-03-01 18:08:07'),(21631,22281,'0000-00-00','ET','2',1,NULL,'Juan M Polanco','FI','460395047','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:45',0,'2014-03-04 21:27:16'),(22193,22843,'0000-00-00','ET','2',1,NULL,'Parvie Jones','FI','587161689','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:34',0,'2014-03-06 21:27:26'),(22531,23181,'0000-00-00','ET','2',3,2,'Rachel Shamy','FI','268885750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:33',0,'2014-03-07 21:36:32'),(416,416,'2014-01-01','ET','2',1,NULL,'Susan Kathleen Wilson','FI','294522825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:54',0,'2014-03-01 15:21:15'),(12758,12758,'2014-01-01','ET','2',1,NULL,'Dennis Humm','FI','316500533','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:01',0,'2014-03-10 13:59:38'),(12224,12224,'2014-01-01','ET','2',1,NULL,'robinette rogers','FI','433556713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:23',0,'2014-03-02 05:03:29'),(11168,11168,'2014-01-01','ET','2',1,NULL,'David Cobb','FI','257439198','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:34',0,'2014-03-10 13:45:57'),(11050,11050,'2014-01-01','ET','2',1,NULL,'JACQUELINE LAUBENTHAL','FI','282562946','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:26',0,'2014-03-10 16:03:49'),(10829,10829,'2014-01-01','ET','2',1,NULL,'Nathan Thomas','FI','436908411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:49',0,'2014-03-02 04:31:46'),(1690,1690,'2014-01-01','ET','2',1,NULL,'Tracee Perryman','FI','276768243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:12',0,'2014-03-01 15:31:33'),(4191,4191,'2014-01-01','ET','2',1,NULL,'Rebecca Meers','FI','289667098','Summa Insurance Company, Inc.','FI','341809108','Mark A Herwick','94','7462692','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:58',0,'2014-03-10 15:59:47'),(13296,13652,'2014-01-01','ET','2',1,NULL,'Slavcia Toth','FI','297568169','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:11',0,'2014-03-01 16:40:16'),(13318,13674,'2014-01-01','ET','2',1,NULL,'Rose M Nguyen','FI','586264239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:19',0,'2014-03-02 05:24:45'),(14803,15254,'2014-01-01','ET','2',1,NULL,'kenneth smalley','FI','273446258','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:00',0,'2014-03-10 14:10:12'),(16474,17124,'0000-00-00','ET','2',1,NULL,'Calvin Short','FI','439372623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:21',0,'2014-03-02 06:10:30'),(17930,18580,'0000-00-00','ET','2',1,NULL,'Timothy Valenta','FI','449316301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:50',0,'2014-03-02 06:38:05'),(19836,20486,'0000-00-00','ET','2',1,NULL,'MATTHEW  DAVIS','FI','300965919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:53',0,'2014-03-01 17:47:19'),(21090,21740,'0000-00-00','ET','2',2,1,'Calvin Taylor','FI','452799244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:41',0,'2014-03-02 07:23:39'),(351,351,'2014-01-01','ET','2',1,NULL,'Edward Adams','FI','281660730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:49',0,'2014-03-01 15:21:15'),(4207,4207,'2014-01-01','ET','2',1,NULL,'Darryl Hoop','FI','427375411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:28',0,'2014-03-02 03:09:49'),(6073,6073,'2014-01-01','ET','2',1,NULL,'Linda Robinson','FI','436929486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:27',0,'2014-03-02 04:10:25'),(11934,11934,'2014-01-01','ET','2',2,1,'gary jacobs','FI','288509386','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:06',0,'2014-03-10 13:52:32'),(11614,11614,'2014-01-01','ET','2',1,NULL,'Martha Irene Partin','FI','278543587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:35:11',0,'2014-03-10 16:03:49'),(6134,6134,'2014-01-01','ET','2',1,NULL,'LISA SCHOFFNER','FI','293586564','Dental Care Plus, Inc.','FI','311185262','GREG  MEYERS','94','9074445','348','2014-01-01','Sync Success',0,'2013-12-26 03:02:23',0,'2014-03-01 16:00:27'),(13417,13773,'2014-01-01','ET','2',1,NULL,'MARY K HOPES','FI','393587321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:02',0,'2014-03-02 05:24:45'),(14595,15046,'2014-01-01','ET','2',1,NULL,'Benjamn Boyle-Court','FI','645205677','Starmount Life Insurance Company','FI','720977315','Charles  heinzelman','94','745305','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:47',0,'2014-03-02 05:45:37'),(17631,18281,'0000-00-00','ET','2',1,NULL,'LARIZA DIAZ','FI','768524614','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:22',0,'2014-03-02 06:31:45'),(17728,18378,'0000-00-00','ET','2',1,NULL,'TEWOLDE HAILE','FI','301904325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:20',0,'2014-03-01 17:20:55'),(19378,20028,'0000-00-00','ET','2',2,1,'ELIZABETH GRIFFIN','FI','233944262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:52',0,'2014-03-01 17:34:07'),(19502,20152,'0000-00-00','ET','2',1,NULL,'JUDITH BARNETTE','FI','448522568','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:04:20',0,'2014-03-10 16:38:05'),(19740,20390,'0000-00-00','ET','2',1,NULL,'DANETTE MARTIN','FI','273843364','HealthSpan','FI','311431434','JOE  WORLIND','94','1967646','357','2013-12-31','Sync Success',0,'2014-02-20 05:40:37',0,'2014-03-10 14:37:47'),(22061,22711,'0000-00-00','ET','2',1,NULL,'george lukasko','FI','278629201','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:37',0,'2014-03-10 14:45:25'),(22393,23043,'0000-00-00','ET','2',1,NULL,'George Svetlik','FI','283480127','Summa Insurance Company, Inc.','FI','341809108','John C  Dalziel','94','362362','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:32',0,'2014-03-10 16:44:18'),(22806,23456,'0000-00-00','ET','2',2,1,'TONYA ARKENBURG','FI','272560895','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:56',0,'2014-03-10 16:44:18'),(171,171,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:20:19',0,'2014-03-10 13:10:24'),(12572,12572,'2014-01-01','ET','2',1,NULL,'brenda danlap','FI','268505903','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:36:14',0,'2014-03-10 13:59:38'),(738,738,'2014-01-01','ET','2',1,NULL,'SANDRA K MCKEE','FI','302547927','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:59',0,'2014-03-10 13:24:34'),(764,764,'2014-01-01','ET','2',1,NULL,'STEVEN ALAN SELKA','FI','287528520','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:49',0,'2014-03-10 13:24:34'),(784,784,'2014-01-01','ET','2',4,3,'Jennifer Ann Rini','FI','296805161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:34',0,'2014-03-01 15:05:09'),(994,994,'2014-01-01','ET','2',2,1,'BORIS BELKIN','FI','289949231','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:03',0,'2014-03-01 15:21:15'),(1395,1395,'2014-01-01','ET','2',1,NULL,'Janice  Richards','FI','555862050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:52',0,'2014-03-02 04:45:37'),(3217,3217,'2014-01-01','ET','2',1,NULL,'Geneva Bates','FI','407704489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:50',0,'2014-03-01 15:52:44'),(3896,3896,'2014-01-01','ET','2',2,1,'Robby Farrell','FI','460331546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:06',0,'2014-03-01 19:11:03'),(3876,3876,'2014-01-01','ET','2',1,0,'Ronald Johnson','FI','453113971','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:25',0,'2014-03-01 19:11:03'),(13262,13618,'2014-01-01','ET','2',1,NULL,'Mohammed Fq Eljaan','FI','662071330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:57',0,'2014-03-02 05:24:45'),(13712,14068,'2014-01-01','ET','2',2,1,'Ellen McClain Ashcraft','FI','288667053','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:48',0,'2014-03-01 16:40:16'),(13714,14070,'2014-01-01','ET','2',1,NULL,'Alyssa Hoot','FI','268945791','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:50',0,'2014-03-10 13:59:38'),(14001,14357,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:32',0,'2014-03-01 16:40:16'),(15343,15794,'0000-00-00','ET','2',2,1,'Jorge Novoa','FI','660168892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:45',0,'2014-03-02 05:52:31'),(15591,16042,'0000-00-00','ET','2',1,NULL,'Cynthia Watson','FI','438610715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:32',0,'2014-03-02 05:59:43'),(18620,19270,'0000-00-00','ET','2',1,NULL,'M Kegelmeyer','FI','273583764','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:50',0,'2014-03-01 17:26:36'),(18636,19286,'0000-00-00','ET','2',1,NULL,'EZEKIEL LESLIE WILSON','FI','294666967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:02',0,'2014-03-01 17:26:36'),(19099,19749,'0000-00-00','ET','2',1,NULL,'Mai-Ly Nguyen','FI','586541656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:43',0,'2014-03-01 17:34:07'),(21343,21993,'0000-00-00','ET','2',1,NULL,'MARY SMITH','FI','451928043','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:19',0,'2014-03-03 01:35:37'),(22415,23065,'0000-00-00','ET','2',1,NULL,'Jayna E Denbow','FI','631178733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:30:09',0,'2014-03-07 22:26:59'),(22544,23194,'0000-00-00','ET','2',2,1,'Lacresia Murriel','FI','587371922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:41',0,'2014-03-07 22:26:59'),(22652,23302,'0000-00-00','ET','2',1,NULL,'Jermaine R Jones','FI','631344039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:22',0,'2014-03-08 22:26:18'),(23095,23745,'0000-00-00','ET','2',2,1,'Dominic Sabatino','FI','292441027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:29:57',0,'2014-03-10 21:36:25'),(573,573,'2014-01-01','ET','2',1,NULL,'Geralyn Hunt','94','0001210906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:46',0,'2014-03-01 15:48:04'),(1968,1968,'2014-01-01','ET','2',1,NULL,'Rick McDermott','FI','294508792','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:44',0,'2014-03-01 15:26:40'),(2333,2333,'2014-01-01','ET','2',1,NULL,'betty baughman','94','0000937244','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:05',0,'2014-03-10 15:45:56'),(11178,11178,'2014-01-01','ET','2',1,NULL,'Charlotte Boggs','FI','278644901','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:55',0,'2014-03-10 13:45:57'),(4098,4098,'2014-01-01','ET','2',1,NULL,'JEREMY SPENCE','FI','421170204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:12',0,'2014-03-01 16:00:27'),(5860,5860,'2014-01-01','ET','2',1,NULL,'Kathryn D Poyant','FI','013663834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:33',0,'2014-03-01 19:11:03'),(6422,6422,'2014-01-01','ET','2',1,NULL,'Phyllis Guinn','FI','298561445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:13',0,'2014-03-01 15:10:22'),(14926,15377,'2014-01-01','ET','2',2,1,'Claire Moseley','FI','410655890','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:36',0,'2014-03-01 16:50:53'),(15377,15828,'0000-00-00','ET','2',1,NULL,'HERBERT KING','FI','438177476','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:55',0,'2014-03-02 05:59:43'),(15734,16383,'0000-00-00','ET','2',1,NULL,'NEAL PLOTNICK','FI','294400683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:12',0,'2014-03-10 14:10:12'),(16951,17601,'0000-00-00','ET','2',1,NULL,'James Stewart','FI','414635366','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:59',0,'2014-03-02 06:17:30'),(17012,17662,'0000-00-00','ET','2',2,1,'STEVEN RAY HARTFIELD','FI','436733871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:05',0,'2014-03-02 06:24:38'),(18222,18872,'0000-00-00','ET','2',1,NULL,'Diane Richmond','FI','270501096','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:11',0,'2014-03-10 16:31:33'),(18339,18989,'0000-00-00','ET','2',1,NULL,'SUSAN BEASLEY','FI','509568325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:20',0,'2014-03-01 17:26:36'),(20262,20912,'0000-00-00','ET','2',1,NULL,'MICHAEL LOCKER','FI','281703478','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:11',0,'2014-03-01 17:47:19'),(21990,22640,'0000-00-00','ET','2',1,NULL,'Carol Paddy','FI','283481663','Summa Insurance Company, Inc.','FI','341809108','Lawrence  Kaczmarek','94','313913','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:46',0,'2014-03-10 16:44:18'),(22170,22820,'0000-00-00','ET','2',1,NULL,'Timothy Neff','FI','279522866','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:18',0,'2014-03-06 21:36:23'),(22513,23163,'0000-00-00','ET','2',1,NULL,'lakeisha allen','FI','435738004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:19',0,'2014-03-07 22:26:59'),(22610,23260,'0000-00-00','ET','2',1,NULL,'MINOON YEUNG','FI','431392465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:00:02',0,'2014-03-08 21:25:11'),(1489,1489,'2014-01-01','ET','2',4,3,'Christian Niklas','FI','298866478','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:01',0,'2014-03-10 16:03:49'),(1492,1492,'2014-01-01','ET','2',1,NULL,'william may','FI','284902812','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:08',0,'2014-03-10 13:45:57'),(12070,12070,'2014-01-01','ET','2',1,NULL,'Katariina Lawson','FI','277528183','Dental Care Plus, Inc.','FI','311185262','Adam  Damrill','94','16802443','357','2014-02-01','Sync Success',0,'2014-01-01 12:04:42',0,'2014-03-01 16:30:17'),(2793,2793,'2014-01-01','ET','2',1,NULL,'Alycia  n Watrous','94','0000418888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:09',0,'2014-03-01 16:05:34'),(7436,7436,'2014-01-01','ET','2',1,NULL,'patricia davis','FI','434907822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:00',0,'2014-03-02 04:15:49'),(11019,11019,'2014-01-01','ET','2',2,1,'tom swem','FI','298447729','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:27',0,'2014-03-10 13:39:10'),(10610,10610,'2014-01-01','ET','2',2,1,'thomas godfrey','FI','262961352','Starmount Life Insurance Company','FI','720977315','jefferson  gallegos','94','694127','348','2014-01-01','Sync Success',0,'2013-12-26 12:57:30',0,'2014-03-02 04:24:47'),(10434,10434,'2014-01-01','ET','2',1,NULL,'Cynthia Jacobson','FI','262390196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:45',0,'2014-03-01 16:10:36'),(12769,12769,'2014-01-01','ET','2',2,1,'Ralph Citro','FI','296468841','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:03',0,'2014-03-01 16:35:14'),(13427,13783,'2014-01-01','ET','2',1,NULL,'heidi kovach','FI','288549011','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:07',0,'2014-03-10 16:10:34'),(13772,14128,'2014-01-01','ET','2',1,NULL,'DEBRA LOUCKS','FI','279507365','Summa Insurance Company, Inc.','FI','341809108','SCOTT  DEMKO','94','1829571','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:28',0,'2014-03-10 16:10:34'),(14006,14362,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:35',0,'2014-03-01 16:40:16'),(14896,15347,'2014-01-01','ET','2',1,NULL,'PETER WATSON','FI','464759433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:22',0,'2014-03-02 05:45:37'),(15082,15533,'0000-00-00','ET','2',1,NULL,'Mary K Sterling','FI','405725523','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:36',0,'2014-03-01 16:50:53'),(15365,15816,'0000-00-00','ET','2',2,1,'Rob Jay Crutcher','FI','276687988','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:58',0,'2014-03-10 14:10:12'),(15573,16024,'0000-00-00','ET','2',1,NULL,'Nathan Wehrmeister','FI','278863081','HealthSpan','FI','311431434','Dave M Baum','94','9113981','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:24',0,'2014-03-10 14:10:12'),(15781,16430,'0000-00-00','ET','2',1,NULL,'Roxanne Fraley','FI','276868963','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:44',0,'2014-03-10 14:10:12'),(16807,17457,'0000-00-00','ET','2',1,NULL,'Donna Carnahan','FI','488747048','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:47',0,'2014-03-10 14:20:26'),(19153,19803,'0000-00-00','ET','2',4,3,'Patricia Krause','FI','300646510','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:25',0,'2014-03-10 16:31:33'),(20254,20904,'0000-00-00','ET','2',1,NULL,'Stan Oneal','FI','433693606','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:04',0,'2014-03-02 07:03:25'),(1397,1397,'2014-01-01','ET','2',1,NULL,'Megan Groh','FI','307046890','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:58',0,'2014-03-10 13:45:57'),(2222,2222,'2014-01-01','ET','2',2,1,'Steven Wells','FI','344467959','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:55',0,'2014-03-10 15:39:19'),(2501,2501,'2014-01-01','ET','2',1,0,'Robbie Hunter','FI','467657323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:05',0,'2014-03-01 19:11:03'),(3164,3164,'2014-01-01','ET','2',1,NULL,'Ray Mink','FI','290585164','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 21:38:14',0,'2014-03-10 13:24:34'),(7274,7274,'2014-01-01','ET','2',1,NULL,'John Shilton','FI','573801161','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:55',0,'2014-03-10 13:32:15'),(3813,3813,'2014-01-01','ET','2',1,NULL,'Tara owings','FI','300583322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:46',0,'2014-03-01 15:26:40'),(5765,5765,'2014-01-01','ET','2',1,NULL,'KRISTIE PERMENTER','FI','451827717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:23',0,'2014-03-02 01:10:33'),(3838,3838,'2014-01-01','ET','2',1,NULL,'Carrie Gambill','FI','302782044','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:12',0,'2014-03-01 15:05:09'),(15901,16550,'0000-00-00','ET','2',1,NULL,'Colleen Fisher','FI','279704045','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:01:12',0,'2014-03-10 14:10:12'),(16649,17299,'0000-00-00','ET','2',1,NULL,'Summer Suleiman','FI','436738788','Starmount Life Insurance Company','FI','720977315','Patrick  Tyson','94','7409844','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:40',0,'2014-03-02 06:17:30'),(17300,17950,'0000-00-00','ET','2',1,NULL,'Deborah Lamonte','FI','427619729','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:54',0,'2014-03-02 06:24:38'),(17957,18607,'0000-00-00','ET','2',1,NULL,'Sheri Besso','FI','286726041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:09',0,'2014-03-01 17:20:55'),(18171,18821,'0000-00-00','ET','2',1,NULL,'Linda Hooks','FI','277467202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:32',0,'2014-03-01 17:26:36'),(19287,19937,'0000-00-00','ET','2',1,NULL,'Richard A LaFargue','FI','436217266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:09',0,'2014-03-02 06:59:07'),(22639,23289,'0000-00-00','ET','2',1,NULL,'JON JEFFREY TOOKER','FI','305907466','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:12',0,'2014-03-08 21:35:36'),(115,115,'2014-01-01','ET','2',1,NULL,'Bennie Upton','FI','409515432','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:31',0,'2014-03-10 15:45:56'),(400,400,'2014-01-01','ET','2',1,NULL,'Randall Eharb','FI','560735337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:22',0,'2014-03-01 22:10:55'),(1261,1261,'2014-01-01','ET','2',1,NULL,'Natasha Perkins','FI','281844455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:32',0,'2014-03-01 16:15:39'),(11164,11164,'2014-01-01','ET','2',1,NULL,'Cosette Verga','FI','218491885','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:16:27',0,'2014-03-10 13:45:57'),(2166,2166,'2014-01-01','ET','2',2,1,'Laura M Berry','FI','302708225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:58',0,'2014-03-01 15:16:37'),(7562,7562,'2014-01-01','ET','2',1,NULL,'STEFANY CAMPBELL','FI','269527325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:02',0,'2014-03-01 16:05:34'),(2797,2797,'2014-01-01','ET','2',2,1,'James Tarkany','FI','295729510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:15',0,'2014-03-01 16:05:34'),(12644,12644,'2014-01-01','ET','2',2,1,'Hien Thi','FI','662077254','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-03 02:02:41',0,'2014-03-02 05:10:52'),(3002,3002,'2014-01-01','ET','2',1,NULL,'Daniel Castaneda','FI','466639861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:11',0,'2014-03-02 01:10:33'),(4770,4770,'2014-01-01','ET','2',1,NULL,'Leslie Wilson','FI','463957113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:01',0,'2014-03-01 21:11:04'),(5002,5002,'2014-01-01','ET','2',2,1,'Burgess Castle','FI','279522954','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-26 00:46:01',0,'2014-03-01 15:31:33'),(5961,5961,'2014-01-01','ET','2',1,NULL,'Bryan Wack','FI','495966139','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:32:40',0,'2014-03-02 01:10:33'),(5806,5806,'2014-01-01','ET','2',1,NULL,'Carolee Ann Davis','FI','522722156','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:44',0,'2014-03-10 13:24:34'),(5481,5481,'2014-01-01','ET','2',1,NULL,'Brenda Harris','FI','439885259','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:48',0,'2014-03-02 04:45:37'),(5440,5440,'2014-01-01','ET','2',1,0,'Jennifer Bracken','FI','193620839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:40',0,'2014-03-01 15:05:09'),(14941,15392,'2014-01-01','ET','2',1,NULL,'SHARON MOORE','FI','204423713','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:43',0,'2014-03-10 14:10:12'),(14947,15398,'2014-01-01','ET','2',1,NULL,'Rebecca Morris','FI','452279330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:46',0,'2014-03-02 05:45:37'),(14989,15440,'2014-01-01','ET','2',1,NULL,'Thomas Kallman','FI','286462758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:05',0,'2014-03-01 16:50:53'),(15219,15670,'0000-00-00','ET','2',1,NULL,'Brandi C Murray','FI','437672380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:39',0,'2014-03-02 05:52:31'),(15506,15957,'0000-00-00','ET','2',1,NULL,'LINDA L MALTRY','FI','272687352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:53',0,'2014-03-01 16:50:53'),(17656,18306,'0000-00-00','ET','2',1,NULL,'Debra Smith','FI','290564714','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:39',0,'2014-03-10 14:24:38'),(18080,18730,'0000-00-00','ET','2',4,3,'JOSEPH HOANG','FI','729039062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:23',0,'2014-03-02 06:38:05'),(18121,18771,'0000-00-00','ET','2',1,NULL,'rob righetti','FI','557843725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:54',0,'2014-03-02 06:38:05'),(18613,19263,'0000-00-00','ET','2',2,1,'George Maroun','FI','294883999','Summa Insurance Company, Inc.','FI','341809108','Michael J Rizk','94','8767323','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:45',0,'2014-03-10 16:31:33'),(19096,19746,'0000-00-00','ET','2',1,NULL,'Nancy Parish','FI','301681109','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:41',0,'2014-03-01 17:34:07'),(20447,21097,'0000-00-00','ET','2',2,1,'LUCIANO HERNANDEZ','FI','280343550','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:31:03',0,'2014-03-10 14:37:47'),(21558,22208,'0000-00-00','ET','2',1,NULL,'Charles Oliver','FI','433118172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:37',0,'2014-03-03 22:26:43'),(21682,22332,'0000-00-00','ET','2',1,NULL,'IDA RUSSELL','FI','587227576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:23',0,'2014-03-04 21:27:16'),(21834,22484,'0000-00-00','ET','2',1,NULL,'Normita Bucalan','FI','436755264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:26',0,'2014-03-05 21:25:24'),(21917,22567,'0000-00-00','ET','2',1,NULL,'ALICE SPARKS','FI','461922207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:55',0,'2014-03-05 22:27:33'),(18794,19444,'0000-00-00','ET','2',1,NULL,'Ruth Mannion','FI','282520518','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:03',0,'2014-03-10 16:31:33'),(19024,19674,'0000-00-00','ET','2',1,NULL,'Sharifah Yekani-Fard','FI','435550525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:06',0,'2014-03-02 06:52:12'),(14436,14887,'2014-01-01','ET','2',1,NULL,'Robert Seal','FI','436020258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:25',0,'2014-03-02 05:38:34'),(18462,19112,'0000-00-00','ET','2',2,1,'FRANCINE JULIA COHEN','FI','564080754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:45',0,'2014-03-02 06:45:14'),(18567,19217,'0000-00-00','ET','2',1,NULL,'Susan Donohue','FI','283420191','Dental Care Plus, Inc.','FI','311185262','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:07',0,'2014-03-01 17:26:36'),(18970,19620,'0000-00-00','ET','2',1,NULL,'MaryAnne Lopez','FI','041407922','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:52',0,'2014-03-10 14:31:05'),(20070,20720,'0000-00-00','ET','2',1,NULL,'Sharon M Ceena','FI','083442803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:26',0,'2014-03-01 18:08:07'),(20230,20880,'0000-00-00','ET','2',1,NULL,'ALECERA KEARNEY','FI','449497787','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:54',0,'2014-03-02 07:10:28'),(20712,21362,'0000-00-00','ET','2',1,NULL,'Jacob Mattes','FI','299924952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:18',0,'2014-03-01 18:08:07'),(22217,22867,'0000-00-00','ET','2',1,NULL,'Duane Bubsey','FI','277528294','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:52',0,'2014-03-06 21:36:23'),(22433,23083,'0000-00-00','ET','2',1,NULL,'Racquel Bennett','FI','130666920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:23',0,'2014-03-07 22:26:59'),(22674,23324,'0000-00-00','ET','2',1,NULL,'TORI SMITH','FI','437698366','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:39',0,'2014-03-08 22:26:18'),(140,140,'2014-01-01','ET','2',1,NULL,'Barbara Castillo','FI','273701380','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:20',0,'2014-03-10 15:45:56'),(12458,12458,'2014-01-01','ET','2',1,NULL,'Terrie Lee Shaheen','FI','269605350','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:48',0,'2014-03-10 16:10:34'),(958,958,'2014-01-01','ET','2',1,NULL,'Milam N Capes','FI','441909711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:53',0,'2014-03-01 22:10:55'),(7356,7356,'2014-01-01','ET','2',1,NULL,'Jennifer Perusek','FI','247670326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:41',0,'2014-03-01 15:16:37'),(7185,7185,'2014-01-01','ET','2',1,NULL,'LINDA ODELSON','FI','147463618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:11',0,'2014-03-02 03:09:49'),(989,989,'2014-01-01','ET','2',3,2,'Dwayne Pielech','FI','291689121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:52',0,'2014-03-01 15:21:15'),(4929,4929,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:31:05',0,'2014-03-10 13:03:33'),(4542,4542,'2014-01-01','ET','2',1,NULL,'byron caplan','FI','216608112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:25',0,'2014-03-02 04:31:46'),(4381,4381,'2014-01-01','ET','2',2,1,'Nancy N Muraya','FI','419538001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:22',0,'2014-03-01 15:16:37'),(1042,1042,'2014-01-01','ET','2',1,NULL,'Casey Joe Watts','FI','452713749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:02',0,'2014-03-01 21:11:04'),(2988,2988,'2014-01-01','ET','2',1,NULL,'Bobbie Wilson','94','0000396025','Starmount Life Insurance Company','FI','720977315','DALE  ADAMS','94','8330750','348','2014-01-01','Sync Success',0,'2013-12-25 21:32:46',0,'2014-03-02 01:10:33'),(14137,14588,'2014-01-01','ET','2',1,NULL,'FLORENCE M DUHORN','FI','434887751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:58',0,'2014-03-02 05:38:34'),(14773,15224,'2014-01-01','ET','2',1,NULL,'TIFFANY M LAVANE','FI','451551612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:40',0,'2014-03-02 05:45:37'),(14825,15276,'2014-01-01','ET','2',1,NULL,'Karleen Salmon','FI','290981616','HealthSpan','FI','311431434','Rose  Shiels','94','8398250','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:15',0,'2014-03-10 14:03:26'),(15059,15510,'2014-01-01','ET','2',2,1,'Tommy Leu','FI','277665157','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:35',0,'2014-03-10 14:10:12'),(15471,15922,'0000-00-00','ET','2',1,NULL,'JANE GREER','FI','286583187','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:54',0,'2014-03-10 14:10:12'),(16334,16984,'0000-00-00','ET','2',1,NULL,'SHIRLEY GRANT','FI','425040737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:44',0,'2014-03-02 06:10:30'),(17552,18202,'0000-00-00','ET','2',1,NULL,'Karen Smith','FI','434433023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:35',0,'2014-03-02 06:31:45'),(18381,19031,'0000-00-00','ET','2',1,NULL,'Nicholas Hatton','FI','305087779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:47',0,'2014-03-02 06:45:14'),(18481,19131,'0000-00-00','ET','2',1,NULL,'Kelsey Murray','FI','587691086','Starmount Life Insurance Company','FI','720977315','Sandra  Holland','94','10257339','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:57',0,'2014-03-02 06:45:14'),(18528,19178,'0000-00-00','ET','2',1,NULL,'Kristi Martin','FI','277906520','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:31',0,'2014-03-10 14:31:05'),(18949,19599,'0000-00-00','ET','2',2,1,'Nicholas Kreakie','FI','274904112','Summa Insurance Company, Inc.','FI','341809108','Deana  Alexander','94','2228297','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:37',0,'2014-03-10 16:31:33'),(19450,20100,'0000-00-00','ET','2',1,NULL,'brenda pittman','FI','295522319','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:47',0,'2014-03-10 14:37:47'),(21449,22099,'0000-00-00','ET','2',1,NULL,'Lorraine Litvin','FI','279786913','Summa Insurance Company, Inc.','FI','341809108','Michael  Kost','94','1924114','348','2014-04-01','Sync Success',0,'2014-03-03 21:30:18',0,'2014-03-10 16:44:18'),(21681,22331,'0000-00-00','ET','2',1,NULL,'ASHLEY CHAMBERS','FI','427616319','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:23',0,'2014-03-04 21:27:16'),(21894,22544,'0000-00-00','ET','2',2,1,'ITZEL LEYVA','FI','633096693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:39',0,'2014-03-05 22:27:33'),(22156,22806,'0000-00-00','ET','2',1,NULL,'Kyla jenee Carr','FI','294949905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:08',0,'2014-03-06 21:36:23'),(22248,22898,'0000-00-00','ET','2',5,4,'Kelly Badowski','FI','280645052','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:14',0,'2014-03-10 16:44:18'),(22271,22921,'0000-00-00','ET','2',1,NULL,'MARILYN JONES','FI','296564292','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:32',0,'2014-03-10 14:50:59'),(22853,23503,'0000-00-00','ET','2',1,NULL,'LATONYA LUCAS','FI','462250085','Starmount Life Insurance Company','FI','720977315','DOUG  BACON','94','2767555','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:05',0,'2014-03-10 21:27:11'),(3919,3919,'2014-01-01','ET','2',1,NULL,'Gregory L Porter','FI','300584444','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:37',0,'2014-03-01 15:26:40'),(12770,12770,'2014-01-01','ET','2',1,NULL,'Quang Ton','FI','281762337','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:05',0,'2014-03-01 16:35:14'),(4016,4016,'2014-01-01','ET','2',1,NULL,'Robert Burns','FI','452989010','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:37',0,'2014-03-02 03:09:49'),(12369,12369,'2014-01-01','ET','2',1,NULL,'ALFRED MORAIGN','FI','450297835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:32',0,'2014-03-02 05:03:29'),(12021,12021,'2014-01-01','ET','2',1,NULL,'Jamie English','FI','433377134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:52',0,'2014-03-02 04:59:36'),(11611,11611,'2014-01-01','ET','2',1,NULL,'Kimberly Whitis','FI','293667882','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:04',0,'2014-03-10 16:03:49'),(4035,4035,'2014-01-01','ET','2',1,NULL,'Karen Hailey','FI','459968161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:13',0,'2014-03-02 03:09:49'),(4051,4051,'2014-01-01','ET','2',1,NULL,'Elsa Atherton','FI','457082057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:43',0,'2014-03-02 04:10:25'),(7263,7263,'2014-01-01','ET','2',1,NULL,'Andrew Douglas','FI','301848375','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:34',0,'2014-03-10 13:32:15'),(5483,5483,'2014-01-01','ET','2',1,NULL,'dewan martin','FI','437040446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:45:52',0,'2014-03-02 04:45:37'),(7215,7215,'2014-01-01','ET','2',1,NULL,'ALECIA PICKEL','FI','400065295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:05',0,'2014-03-01 15:52:44'),(5999,5999,'2014-01-01','ET','2',1,NULL,'Susan Marie Kishel','FI','298486796','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:34:00',0,'2014-03-10 13:24:34'),(12978,12978,'2014-01-01','ET','2',1,NULL,'Afton Cooke','FI','634126291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:21',0,'2014-03-02 05:17:40'),(13021,13377,'2014-01-01','ET','2',1,NULL,'Douglas Caddell','FI','281606908','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:03',0,'2014-03-01 16:35:14'),(16198,16847,'0000-00-00','ET','2',1,NULL,'KONISHA BRUMFIELD','FI','436876712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:37',0,'2014-03-02 06:10:30'),(17155,17805,'0000-00-00','ET','2',1,NULL,'Zariale Thomas','FI','428650556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:36',0,'2014-03-02 06:24:38'),(17736,18386,'0000-00-00','ET','2',2,1,'Van Creel','FI','436901640','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:25',0,'2014-03-02 06:31:45'),(17865,18515,'0000-00-00','ET','2',1,NULL,'Sikander Aziz','FI','635923204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:13',0,'2014-03-02 06:38:05'),(18327,18977,'0000-00-00','ET','2',2,1,'Justina Rohr','FI','283862691','Dental Care Plus, Inc.','FI','311185262','Erin  Carbone','94','8152613','348','2014-03-01','Sync Success',0,'2014-02-12 21:30:12',0,'2014-03-01 17:26:36'),(20909,21559,'0000-00-00','ET','2',4,3,'Jody Wilder-Kulnane','FI','280861695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:03',0,'2014-03-01 18:08:07'),(460,460,'2014-01-01','ET','2',1,NULL,'DIANA HILLIARD','FI','279629882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:18',0,'2014-03-10 13:10:24'),(3638,3638,'2014-01-01','ET','2',2,1,'Nancy Babyak','FI','269509787','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:32',0,'2014-03-10 15:52:36'),(11087,11087,'2014-01-01','ET','2',2,1,'Cynthia Derian','FI','284581933','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:40',0,'2014-03-10 13:45:57'),(4521,4521,'2014-01-01','ET','2',1,NULL,'PAUL FINDLEY','FI','287861852','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:47',0,'2014-03-10 13:03:33'),(13487,13843,'2014-01-01','ET','2',1,NULL,'Karla Ingram','FI','463880028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:07',0,'2014-03-02 05:24:45'),(14542,14993,'2014-01-01','ET','2',1,NULL,'Judy Laurel','FI','462770955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:13',0,'2014-03-02 05:45:37'),(14623,15074,'2014-01-01','ET','2',2,1,'Lynn Greathouse','FI','280685002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:04',0,'2014-03-01 16:46:19'),(14884,15335,'2014-01-01','ET','2',2,1,'Josue Garcia Rodriguez','FI','640841672','Starmount Life Insurance Company','FI','720977315','Raul  Rodriguez','94','11608743','348','2014-03-01','Sync Success',0,'2014-01-17 03:35:17',0,'2014-03-02 05:52:31'),(15639,16288,'0000-00-00','ET','2',1,NULL,'ALISA SWISSA','FI','285883505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:03',0,'2014-03-01 16:50:53'),(16426,17076,'0000-00-00','ET','2',2,1,'Mary Crable','FI','284581497','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:43',0,'2014-03-10 14:20:26'),(16696,17346,'0000-00-00','ET','2',1,NULL,'JERRY DALE ACHESON','FI','295541276','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:14',0,'2014-03-01 17:00:58'),(17111,17761,'0000-00-00','ET','2',1,NULL,'Douglas Vignos','FI','294627675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:07',0,'2014-03-01 17:20:55'),(20675,21325,'0000-00-00','ET','2',2,1,'PATRICK J KNAPP','FI','296623370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-26 21:02:44',0,'2014-03-10 14:37:47'),(20973,21623,'0000-00-00','ET','2',1,NULL,'MITCHELL CALVIN ADAMS','FI','301506934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:30:21',0,'2014-03-01 18:08:07'),(21169,21819,'0000-00-00','ET','2',1,NULL,'antonette rivera','FI','282927234','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:34',0,'2014-03-10 16:38:05'),(1580,1580,'2014-01-01','ET','2',1,NULL,'Mary Lou Fillmore','FI','277684084','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:38',0,'2014-03-01 15:10:22'),(2788,2788,'2014-01-01','ET','2',1,NULL,'AMY HO','FI','284983742','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:58',0,'2014-03-01 16:05:34'),(3730,3730,'2014-01-01','ET','2',1,NULL,'DANIEL SAW','FI','217536124','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:34',0,'2014-03-10 13:20:27'),(4251,4251,'2014-01-01','ET','2',1,NULL,'Kathryn Vonderheide','FI','275561606','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:51',0,'2014-03-10 13:32:15'),(4369,4369,'2014-01-01','ET','2',1,NULL,'Sean Smith','FI','271764361','HealthSpan','FI','311431434','Anthony  Moore','94','1923821','348','2014-01-01','Sync Success',0,'2013-12-25 23:11:23',0,'2014-03-10 13:32:15'),(10933,10933,'2014-01-01','ET','2',1,NULL,'Sharon Meszaros','FI','298644026','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:43',0,'2014-03-10 16:03:49'),(10804,10804,'2014-01-01','ET','2',1,NULL,'Jessica Hubbard','FI','433699176','Starmount Life Insurance Company','FI','720977315','Daniel C Wilcox III','94','8212289','348','2014-01-01','Sync Success',0,'2013-12-26 13:04:00',0,'2014-03-02 04:24:47'),(4494,4494,'2014-01-01','ET','2',1,NULL,'helen spicer','FI','276504659','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:52',0,'2014-03-10 15:39:19'),(10404,10404,'2014-01-01','ET','2',1,NULL,'Roy Reynolds','FI','277869131','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:50',0,'2014-03-01 16:10:36'),(4731,4731,'2014-01-01','ET','2',2,1,'Lynn McSheehy','FI','290809677','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:46',0,'2014-03-10 16:03:49'),(7476,7476,'2014-01-01','ET','2',1,NULL,'LISA CARRIZALES','FI','461678281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:10',0,'2014-03-02 04:15:49'),(7206,7206,'2014-01-01','ET','2',1,NULL,'Gretchen Singh','FI','281626504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:51',0,'2014-03-01 15:52:44'),(5176,5176,'2014-01-01','ET','2',3,2,'George Heffner','FI','296846942','HealthSpan','FI','311431434','Kevin  Schlotman','94','1427172','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:35',0,'2014-03-10 13:20:27'),(5442,5442,'2014-01-01','ET','2',1,0,'Jennifer Bracken','FI','193620839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:43',0,'2014-03-01 15:05:09'),(13433,13789,'2014-01-01','ET','2',1,NULL,'Estella Garcia','FI','460921648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:07',0,'2014-03-02 05:31:31'),(13648,14004,'2014-01-01','ET','2',1,NULL,'Linda Conley','FI','277543593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:01',0,'2014-03-10 14:03:26'),(14448,14899,'2014-01-01','ET','2',1,NULL,'Lavonda S Lindsley','FI','414155216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:29',0,'2014-03-02 05:38:34'),(16034,16683,'0000-00-00','ET','2',1,NULL,'william mayfield','FI','439513011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:33',0,'2014-03-02 06:03:21'),(16669,17319,'0000-00-00','ET','2',1,NULL,'WILLIETTE ANDERSON JONES','FI','303780539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:54',0,'2014-03-01 17:00:58'),(17268,17918,'0000-00-00','ET','2',1,NULL,'John Morris','FI','462257181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:39',0,'2014-03-02 06:24:38'),(17851,18501,'0000-00-00','ET','2',1,NULL,'gerald jones','FI','433353817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:03',0,'2014-03-02 06:38:05'),(22019,22669,'0000-00-00','ET','2',1,NULL,'Suzanne Renee Roth','FI','281504460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-05 21:32:05',0,'2014-03-05 21:36:22'),(857,857,'2014-01-01','ET','2',1,NULL,'larry w dockery','FI','439047794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:52',0,'2014-03-01 22:10:55'),(3861,3861,'2014-01-01','ET','2',1,0,'John Farmer','FI','436737329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:30:58',0,'2014-03-01 19:11:03'),(11233,11233,'2014-01-01','ET','2',1,NULL,'KELLY TITTLE','FI','288885695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:28',0,'2014-03-01 16:23:43'),(7726,7726,'2014-01-01','ET','2',1,NULL,'Monica Glass','FI','455816414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:04',0,'2014-03-01 19:11:03'),(6035,6035,'2014-01-01','ET','2',1,NULL,'dorothy halloway','FI','587760754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:02',0,'2014-03-01 20:10:57'),(17202,17852,'0000-00-00','ET','2',1,NULL,'LATEARRIA HERNDON','FI','453972760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:06',0,'2014-03-02 06:24:38'),(18504,19154,'0000-00-00','ET','2',4,3,'Judy Vogel','FI','275820374','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:12',0,'2014-03-10 14:31:05'),(19025,19675,'0000-00-00','ET','2',2,1,'Rodney Gay','FI','273589879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 22:00:07',0,'2014-03-01 17:34:07'),(19458,20108,'0000-00-00','ET','2',1,NULL,'Alexandria Beck','FI','523899310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:45:30',0,'2014-03-02 06:59:07'),(21332,21982,'0000-00-00','ET','2',1,NULL,'Rebecca Estep','FI','275882944','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:14',0,'2014-03-03 01:35:37'),(21577,22227,'0000-00-00','ET','2',1,NULL,'Angel Maldonado','FI','461990008','Starmount Life Insurance Company','FI','720977315','Esequiel  Garcia','94','16428563','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:52',0,'2014-03-03 22:26:43'),(22287,22937,'0000-00-00','ET','2',1,NULL,'Mark Merriman','FI','276805443','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:44',0,'2014-03-10 14:45:25'),(22339,22989,'0000-00-00','ET','2',1,NULL,'Gillian  Rose Stupar','FI','295767460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:24',0,'2014-03-06 21:36:23'),(22609,23259,'0000-00-00','ET','2',1,NULL,'Ronald Hubbard','FI','271728612','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:30',0,'2014-03-10 14:50:59'),(130,130,'2014-01-01','ET','2',1,NULL,'Mae Marie Thompson','FI','450924132','Starmount Life Insurance Company','FI','720977315','Jay  Frank Claborn','94','14740337','348','2014-01-01','Sync Success',0,'2013-12-25 17:19:03',0,'2014-03-01 22:10:55'),(466,466,'2014-01-01','ET','2',1,NULL,'ahron accoo','FI','505276648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:30',0,'2014-03-10 13:10:24'),(13114,13470,'2014-01-01','ET','2',1,NULL,'Susana Suciu','FI','641483270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:30',0,'2014-03-02 05:17:40'),(6007,6007,'2014-01-01','ET','2',2,1,'Charles  Riley','FI','275448513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:10',0,'2014-03-01 15:10:22'),(5310,5310,'2014-01-01','ET','2',1,NULL,'Christina Williams','FI','278887703','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:48',0,'2014-03-01 15:05:09'),(12409,12409,'2014-01-01','ET','2',1,NULL,'Mark Deeter','FI','300440970','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:59',0,'2014-03-01 16:35:14'),(11676,11676,'2014-01-01','ET','2',1,NULL,'Greta Freeland','FI','311564168','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2013-12-28 03:37:08',0,'2014-03-10 13:52:32'),(3332,3332,'2014-01-01','ET','2',1,NULL,'Karen Bickerstaff','FI','302581856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:34',0,'2014-03-10 15:52:36'),(2882,2882,'2014-01-01','ET','2',1,NULL,'William Hall','FI','280668380','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:23:04',0,'2014-03-10 13:39:10'),(4756,4756,'2014-01-01','ET','2',1,NULL,'IRIS DAVENPORT','FI','276800189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:31',0,'2014-03-01 15:16:37'),(3672,3672,'2014-01-01','ET','2',2,1,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:36',0,'2014-03-02 01:10:33'),(16787,17437,'0000-00-00','ET','2',2,1,'Brett Rudduck','FI','291763180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:33',0,'2014-03-01 17:00:58'),(2818,2818,'2014-01-01','ET','2',2,1,'Diane M Sikora','FI','299663175','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:52',0,'2014-03-01 16:05:34'),(13132,13488,'2014-01-01','ET','2',1,NULL,'JUSTIN  HOLT','FI','453859596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:04:10',0,'2014-03-02 05:17:40'),(15597,16048,'0000-00-00','ET','2',1,NULL,'John Edwards','FI','260048468','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:35',0,'2014-03-02 05:59:43'),(16310,16960,'0000-00-00','ET','2',1,NULL,'Brenda Vance','94','0000373656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:29',0,'2014-03-01 16:56:22'),(22250,22900,'0000-00-00','ET','2',1,NULL,'Stacie Fisher','FI','295866543','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:16',0,'2014-03-10 16:44:18'),(6143,6143,'2014-01-01','ET','2',1,NULL,'LISA  SMITH','FI','287680105','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:36',0,'2014-03-01 16:00:27'),(4584,4584,'2014-01-01','ET','2',1,NULL,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:46:47',0,'2014-03-01 16:15:39'),(1020,1020,'2014-01-01','ET','2',1,NULL,'valerie hall','FI','438293384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:54',0,'2014-03-01 22:10:55'),(12428,12428,'2014-01-01','ET','2',1,NULL,'Mary Carleton','FI','435825349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:42',0,'2014-03-02 05:03:29'),(7173,7173,'2014-01-01','ET','2',1,NULL,'Christine M Smithnosky','FI','200407654','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:49',0,'2014-03-10 15:59:47'),(2020,2020,'2014-01-01','ET','2',1,NULL,'thomas bruneau','FI','047767173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:30',0,'2014-03-01 23:10:52'),(17329,17979,'0000-00-00','ET','2',1,NULL,'Brittany Taylor','FI','427677943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:11',0,'2014-03-02 06:24:38'),(19307,19957,'0000-00-00','ET','2',1,NULL,'veronica rios','FI','467953458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:02',0,'2014-03-02 06:52:12'),(19488,20138,'0000-00-00','ET','2',1,NULL,'JAMES LASSITTER','FI','263338620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:00:49',0,'2014-03-02 06:59:07'),(20041,20691,'0000-00-00','ET','2',1,NULL,'katanna lee moreno','FI','632321715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-22 19:00:13',0,'2014-03-02 07:03:25'),(23119,23769,'0000-00-00','ET','2',3,2,'HESHAM AYAD','FI','282842038','HealthSpan','FI','311431434','GAIL  FINK','94','967574','348','2014-04-01','Sync Success',0,'2014-03-10 21:30:16',0,'2014-03-10 22:17:01'),(379,379,'2014-01-01','ET','2',1,NULL,'SUSAN WOHLFORD','FI','298480437','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:42',0,'2014-03-10 15:39:19'),(7110,7110,'2014-01-01','ET','2',2,1,'rebecca carter','FI','279581442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:52',0,'2014-03-01 15:52:44'),(13253,13609,'2014-01-01','ET','2',3,2,'Ciara Johnson','FI','298785406','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',1,'2014-01-07 10:23:12',0,'2014-03-10 13:59:38'),(15028,15479,'2014-01-01','ET','2',1,NULL,'Carrie Roche','FI','434636929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:22',0,'2014-03-02 05:52:31'),(10472,10472,'2014-01-01','ET','2',1,NULL,'HOLLAND POLK','FI','268565151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:59',0,'2014-03-01 16:10:36'),(3781,3781,'2014-01-01','ET','2',1,NULL,'Patricia Ann Schultz','FI','150569452','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:41',0,'2014-03-01 15:26:40'),(12358,12358,'2014-01-01','ET','2',1,NULL,'Patricia Bean','FI','464907321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:28:09',0,'2014-03-02 05:03:29'),(3983,3983,'2014-01-01','ET','2',1,NULL,'Traimone Ishmael Valentine','FI','287969940','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:39',0,'2014-03-10 13:10:24'),(18470,19120,'0000-00-00','ET','2',2,1,'TOMMY KISHKIN','FI','642198045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:50',0,'2014-03-02 06:45:14'),(22453,23103,'0000-00-00','ET','2',1,NULL,'BONNIE DAVIS','FI','272489183','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:37',0,'2014-03-10 14:50:59'),(6195,6195,'2014-01-01','ET','2',2,1,'Gary Luckey','FI','493888526','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:10',0,'2014-03-02 04:10:25'),(11696,11696,'2014-01-01','ET','2',1,NULL,'Nixon Williams','FI','437713695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:07:48',0,'2014-03-02 04:59:36'),(14222,14673,'2014-01-01','ET','2',1,NULL,'Gregory Edgar','FI','175468080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:50',0,'2014-03-02 05:38:34'),(10547,10547,'2014-01-01','ET','2',1,NULL,'Barbara Daniel','FI','452943428','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:26',0,'2014-03-02 04:24:47'),(1376,1376,'2014-01-01','ET','2',2,1,'Crystal Rae McGee','FI','122720656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:13',0,'2014-03-02 04:38:08'),(7631,7631,'2014-01-01','ET','2',1,NULL,'Thomas Kostoff','FI','286461861','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','357','2014-01-01','Sync Success',0,'2013-12-26 04:38:16',0,'2014-03-10 15:59:47'),(5681,5681,'2014-01-01','ET','2',1,NULL,'Dolores  C Hunt','FI','286581769','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:30',0,'2014-03-10 13:52:32'),(4778,4778,'2014-01-01','ET','2',1,NULL,'Angus McCorquodale','FI','457296106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:12',0,'2014-03-01 21:11:04'),(2065,2065,'2014-01-01','ET','2',1,NULL,'Patti Dugger','FI','281521771','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:57',0,'2014-03-10 13:20:27'),(4203,4203,'2014-01-01','ET','2',1,NULL,'Michael Lemire','FI','286581700','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:20',0,'2014-03-10 13:32:15'),(2162,2162,'2014-01-01','ET','2',1,NULL,'Pamela J Braunstein','FI','280569077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:46:50',0,'2014-03-01 15:16:37'),(1549,1549,'2014-01-01','ET','2',1,NULL,'BRENDA S FISHER','FI','283642973','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:56',0,'2014-03-10 13:52:32'),(14391,14842,'2014-01-01','ET','2',1,NULL,'Denise Tenkotte','FI','285608213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:02',0,'2014-03-01 16:46:19'),(13722,14078,'2014-01-01','ET','2',1,NULL,'Danielle Boudreau','FI','032629110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:56',0,'2014-03-02 05:24:45'),(13336,13692,'2014-01-01','ET','2',1,NULL,'Gerri Costa','FI','437215978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:26',0,'2014-03-02 05:24:45'),(12839,12839,'2014-01-01','ET','2',1,NULL,'Chanell Jimerson','FI','437553419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:39',0,'2014-03-02 05:17:40'),(11974,11974,'2014-01-01','ET','2',1,NULL,'ISAIAH HARRIS','FI','458734205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:08',0,'2014-03-02 04:59:36'),(5293,5293,'2014-01-01','ET','2',1,NULL,'Gerald Fulton','FI','287767052','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:10',0,'2014-03-10 13:03:33'),(15491,15942,'0000-00-00','ET','2',1,NULL,'Richard Kiessling','FI','280886570','HealthSpan','FI','311431434','James  Hitching','94','1866145','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:08',0,'2014-03-10 14:10:12'),(17078,17728,'0000-00-00','ET','2',1,NULL,'MEGAN SHIMONEK','FI','228496347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:47',0,'2014-03-02 06:24:38'),(18513,19163,'0000-00-00','ET','2',1,NULL,'Laura Mansfield','FI','271682787','HealthSpan','FI','311431434','Lauren  Hermiller','94','16945220','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:20',0,'2014-03-10 14:31:05'),(19561,20211,'0000-00-00','ET','2',1,NULL,'JOSEPH JOLIVETTE','FI','434314902','Starmount Life Insurance Company','FI','720977315','ABRAM  FREEMAN','94','1219092','348','2014-04-01','Sync Success',0,'2014-02-20 04:20:42',0,'2014-03-02 06:59:07'),(5673,5673,'2014-01-01','ET','2',1,NULL,'gregory landerman','FI','272689825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:09',0,'2014-03-02 04:45:37'),(4777,4777,'2014-01-01','ET','2',1,NULL,'William Davis','FI','463755573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:11',0,'2014-03-01 21:11:04'),(1791,1791,'2014-01-01','ET','2',1,NULL,'DEBORAH GAERTNER','FI','281528470','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:19',0,'2014-03-10 13:20:27'),(14029,14385,'2014-01-01','ET','2',1,NULL,'DONALD M STONE','FI','280683701','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:52',0,'2014-03-10 14:03:26'),(7054,7054,'2014-01-01','ET','2',1,NULL,'Tonia Hale','FI','454153910','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:08',0,'2014-03-02 03:09:49'),(7481,7481,'2014-01-01','ET','2',1,NULL,'Monique Cummings','FI','434069195','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:20',0,'2014-03-02 04:15:49'),(17845,18495,'0000-00-00','ET','2',1,NULL,'Yvonne Baden','FI','276589589','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:10',0,'2014-03-10 14:20:26'),(18716,19366,'0000-00-00','ET','2',1,NULL,'Kristina Balogh','FI','542025966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:04',0,'2014-03-02 06:45:14'),(20754,21404,'0000-00-00','ET','2',1,NULL,'Linda Johson','FI','427190156','Starmount Life Insurance Company','FI','720977315','Brian  Caston','94','9699391','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:37',0,'2014-03-02 07:17:36'),(22942,23592,'0000-00-00','ET','2',1,NULL,'Rick D Archer','FI','287641114','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:11',0,'2014-03-10 21:07:22'),(23077,23727,'0000-00-00','ET','2',2,1,'Bobby Murphy','FI','289440927','HealthSpan','FI','311431434','Deborah  Gazey','94','2341750','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:49',0,'2014-03-10 21:17:52'),(875,875,'2014-01-01','ET','2',1,NULL,'Jane Hilf','FI','270520174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:27',0,'2014-03-01 15:21:15'),(15234,15685,'0000-00-00','ET','2',1,NULL,'ANGELA M DELVALLE','FI','437452243','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:45:16',0,'2014-03-02 05:52:31'),(12837,12837,'2014-01-01','ET','2',1,NULL,'Shelia Turner','FI','438857482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:35',0,'2014-03-02 05:17:40'),(10530,10530,'2014-01-01','ET','2',1,NULL,'Rudolph Martin','FI','467455659','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:50',0,'2014-03-02 04:24:47'),(14376,14827,'2014-01-01','ET','2',1,NULL,'eric bardes','FI','312706724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:56',0,'2014-03-10 16:17:47'),(12077,12077,'2014-01-01','ET','2',1,NULL,'Ruth Lingafelter','FI','287588571','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:04:56',0,'2014-03-01 16:30:17'),(11911,11911,'2014-01-01','ET','2',1,NULL,'Charise Savich','FI','268782548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:23',0,'2014-03-01 16:30:17'),(20900,21550,'0000-00-00','ET','2',1,NULL,'Kathleen Diederichs','FI','298643025','HealthSpan','FI','311431434','Tamara  Hagan','94','3691584','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:44',0,'2014-03-10 14:45:25'),(1035,1035,'2014-01-01','ET','2',1,NULL,'SHEILA  R HIRSCHFELD','FI','291483629','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:21:23',0,'2014-03-10 13:10:24'),(1109,1109,'2014-01-01','ET','2',1,0,'James Johnson','FI','300744187','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:24',0,'2014-03-01 15:05:09'),(13096,13452,'2014-01-01','ET','2',2,1,'John Barton','FI','425044291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:50',0,'2014-03-02 05:17:40'),(1399,1399,'2014-01-01','ET','2',1,NULL,'Verta Wright','FI','433752683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:02',0,'2014-03-02 04:38:08'),(7038,7038,'2014-01-01','ET','2',1,NULL,'AMIR AQEEL','FI','311064169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:01:42',0,'2014-03-02 03:09:49'),(11571,11571,'2014-01-01','ET','2',2,1,'Willy Montano','FI','449988570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:52',0,'2014-03-02 04:52:44'),(5726,5726,'2014-01-01','ET','2',1,NULL,'Michelle Smaltz','FI','294904804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:11',0,'2014-03-01 15:48:04'),(14074,14525,'2014-01-01','ET','2',1,NULL,'John Toombs','FI','450254388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:19',0,'2014-03-02 05:31:31'),(5531,5531,'2014-01-01','ET','2',2,1,'Susan Teeter','FI','180560240','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:25',0,'2014-03-01 16:23:43'),(4645,4645,'2014-01-01','ET','2',1,NULL,'Gerren Demon Corprew','FI','457816860','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:43',0,'2014-03-02 04:38:08'),(3187,3187,'2014-01-01','ET','2',1,NULL,'Joseph Joyce','FI','290801110','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:07',0,'2014-03-10 13:24:34'),(2245,2245,'2014-01-01','ET','2',1,NULL,'DEBRA  SHULTS','FI','431213957','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:44',0,'2014-03-01 21:11:04'),(18229,18879,'0000-00-00','ET','2',1,NULL,'Vicky L Richards','FI','272487339','HealthSpan','FI','311431434','Steve  Schmitmeyer','94','2326455','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:17',0,'2014-03-10 14:24:38'),(18920,19570,'0000-00-00','ET','2',1,NULL,'Tiffany Wiggins','FI','587492639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:17',0,'2014-03-02 06:52:12'),(21844,22494,'0000-00-00','ET','2',1,NULL,'Juliean Hall','FI','275561342','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:33',0,'2014-03-10 14:45:25'),(22366,23016,'0000-00-00','ET','2',1,NULL,'David Nevling','FI','293466225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:19',0,'2014-03-07 21:25:22'),(454,454,'2014-01-01','ET','2',1,NULL,'CHRISHUNDA LYNETTE HARRIS','FI','665053819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:06',0,'2014-03-01 22:10:55'),(4497,4497,'2014-01-01','ET','2',1,NULL,'lynda l lockett','FI','288508627','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:58',0,'2014-03-10 15:39:19'),(15144,15595,'0000-00-00','ET','2',1,NULL,'Caleb Zemrock','94','0000942016','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:23',0,'2014-03-10 16:17:47'),(13931,14287,'2014-01-01','ET','2',1,NULL,'SANTOS RAMOS','FI','452904587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:19',0,'2014-03-02 05:31:31'),(13479,13835,'2014-01-01','ET','2',1,NULL,'Sandra Rinehart','FI','283621533','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:38',0,'2014-03-10 16:17:47'),(4050,4050,'2014-01-01','ET','2',1,NULL,'Geraldine Doucet','FI','438922709','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:41',0,'2014-03-02 04:10:25'),(1574,1574,'2014-01-01','ET','2',2,1,'betty crosby','FI','454026892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:25',0,'2014-03-01 20:10:57'),(2448,2448,'2014-01-01','ET','2',1,NULL,'Tuyen Phan','FI','439453581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:48',0,'2014-03-01 23:10:52'),(17241,17891,'0000-00-00','ET','2',2,1,'Michael Barchalk','FI','276728809','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:26',0,'2014-03-10 16:24:30'),(19415,20065,'0000-00-00','ET','2',2,1,'SUSAN SNYDER','FI','278528830','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:20',0,'2014-03-10 14:31:05'),(21482,22132,'0000-00-00','ET','2',1,NULL,'patrick finnell','FI','293640929','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:42',0,'2014-03-03 21:36:16'),(22820,23470,'0000-00-00','ET','2',4,3,'John O\'Neal','FI','380825899','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:09',0,'2014-03-10 14:50:59'),(7303,7303,'2014-01-01','ET','2',1,NULL,'RAKESHKUMAR MAISURIA','FI','665774479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:49',0,'2014-03-02 03:09:49'),(15166,15617,'0000-00-00','ET','2',1,NULL,'Monique Forward','FI','456935921','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:38',0,'2014-03-02 05:52:31'),(261,261,'2014-01-01','ET','2',1,NULL,'Jackson Nevitt','FI','433577490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:15',0,'2014-03-01 20:10:57'),(13321,13677,'2014-01-01','ET','2',1,NULL,'Margaret Bailes','FI','556172081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:20',0,'2014-03-02 05:24:45'),(11907,11907,'2014-01-01','ET','2',1,NULL,'Brandon Bailey','FI','425677649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:16',0,'2014-03-02 04:59:36'),(15747,16396,'0000-00-00','ET','2',1,NULL,'Alia Swanson','FI','234084099','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:20',0,'2014-03-01 16:56:22'),(20416,21066,'0000-00-00','ET','2',1,NULL,'Gregory Arnold','FI','289540032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:40',0,'2014-03-01 18:08:07'),(20643,21293,'0000-00-00','ET','2',2,1,'JAMANDA WILLIAMS','FI','425593092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:19',0,'2014-03-02 07:10:28'),(21812,22462,'0000-00-00','ET','2',1,NULL,'Matthew William Curry','FI','452454305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:11',0,'2014-03-05 21:25:24'),(1058,1058,'2014-01-01','ET','2',1,NULL,'JAMES BEATTY','FI','276601294','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:32',0,'2014-03-01 15:16:37'),(3931,3931,'2014-01-01','ET','2',1,NULL,'Beau M Minson','FI','436857610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:45:59',0,'2014-03-01 23:10:52'),(12563,12563,'2014-01-01','ET','2',1,NULL,'Julie L Pies','FI','297762988','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:50',0,'2014-03-10 13:59:38'),(18357,19007,'0000-00-00','ET','2',3,2,'Cresencio Martinez','FI','585653537','Starmount Life Insurance Company','FI','720977315','Vianey  Martinez','94','15740460','348','2014-03-01','Sync Success',0,'2014-02-12 21:30:31',0,'2014-03-02 06:45:14'),(19849,20499,'0000-00-00','ET','2',1,NULL,'RUSSELL HODGES','FI','437886218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:03',0,'2014-03-02 07:03:25'),(21599,22249,'0000-00-00','ET','2',1,NULL,'Adrian Pasaret','FI','626200022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:19',0,'2014-03-04 21:27:16'),(21746,22396,'0000-00-00','ET','2',1,NULL,'Lynn Serrano Martin','FI','538085679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:17',0,'2014-03-04 21:27:16'),(22840,23490,'0000-00-00','ET','2',1,NULL,'James Smith','FI','434352567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:30:04',0,'2014-03-09 22:25:06'),(6261,6261,'2014-01-01','ET','2',1,NULL,'holly selva','FI','039549381','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','8783711','348','2014-01-01','Sync Success',0,'2013-12-26 03:06:14',0,'2014-03-02 04:10:25'),(833,833,'2014-01-01','ET','2',1,NULL,'David Clay','FI','587673037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:09',0,'2014-03-01 22:10:55'),(2410,2410,'2014-01-01','ET','2',1,NULL,'Cynthia Mihalek','FI','292624465','Dental Care Plus, Inc.','FI','311185262','Margaret M Hammond','94','7815088','348','2014-01-01','Sync Success',0,'2013-12-25 20:17:34',0,'2014-03-01 15:26:40'),(7179,7179,'2014-01-01','ET','2',1,NULL,'DOUGLAS LUCAK','FI','287665937','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:59',0,'2014-03-10 15:59:47'),(15352,15803,'0000-00-00','ET','2',1,NULL,'HENRY LEE BUTLER','FI','301769909','HealthSpan','FI','311431434','GEORGE W ALLEY','94','12067476','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:50',0,'2014-03-10 14:10:12'),(15902,16551,'0000-00-00','ET','2',2,1,'COLLEEN FISHER','FI','279704045','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:13',0,'2014-03-10 14:10:12'),(18300,18950,'0000-00-00','ET','2',1,NULL,'PATRICIA ROLLER','FI','147448027','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:29',0,'2014-03-10 16:31:33'),(19432,20082,'0000-00-00','ET','2',1,NULL,'Ramona Creel','FI','261891628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:32',0,'2014-03-02 06:59:07'),(244,244,'2014-01-01','ET','2',1,NULL,'Richard Ludwig','FI','278443645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:40',0,'2014-03-01 15:10:22'),(4146,4146,'2014-01-01','ET','2',1,NULL,'PEGGY SUE HOOT','FI','284582105','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:34',0,'2014-03-01 16:00:27'),(14906,15357,'2014-01-01','ET','2',1,NULL,'Ricka  Johnson','FI','433177889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:26',0,'2014-03-02 05:52:31'),(14309,14760,'2014-01-01','ET','2',1,NULL,'Vincent Liao','FI','644120848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:28',0,'2014-03-02 05:38:34'),(13577,13933,'2014-01-01','ET','2',1,NULL,'Lauren Bensie','FI','294888173','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:08',0,'2014-03-10 16:10:34'),(1390,1390,'2014-01-01','ET','2',2,1,'James Hollis','FI','431023754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:43',0,'2014-03-02 04:45:37'),(7502,7502,'2014-01-01','ET','2',2,1,'Susan Simpson','FI','301868329','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:08',0,'2014-03-01 16:05:34'),(2139,2139,'2014-01-01','ET','2',1,NULL,'DARLENE WASHINGTON','FI','284462353','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:07',0,'2014-03-01 15:16:37'),(3899,3899,'2014-01-01','ET','2',1,NULL,'latesha dent','FI','322664499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:13',0,'2014-03-01 19:11:03'),(15480,15931,'0000-00-00','ET','2',1,NULL,'WINNIE  EVANS','FI','344460800','HealthSpan','FI','311431434','ROBERT  COLAIANNI','94','16444219','348','2014-03-01','Sync Success',1,'2014-01-22 03:23:00',0,'2014-03-10 14:10:12'),(15547,15998,'0000-00-00','ET','2',1,NULL,'Toncha Thigpen','FI','457613886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 03:02:12',0,'2014-03-02 05:59:43'),(16771,17421,'0000-00-00','ET','2',1,NULL,'Larry Bailey','FI','278927350','HealthSpan','FI','311431434','Rodney  Kirkham','94','16105302','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:22',0,'2014-03-10 14:20:26'),(17206,17856,'0000-00-00','ET','2',1,NULL,'LYDIA DAVIS','FI','299548144','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:09',0,'2014-03-01 17:20:55'),(18295,18945,'0000-00-00','ET','2',1,NULL,'Ashley King','FI','428475701','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:24',0,'2014-03-02 06:38:05'),(19124,19774,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:01',0,'2014-03-01 17:34:07'),(21830,22480,'0000-00-00','ET','2',1,NULL,'Mary Ann Tuuri','FI','302627420','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:23',0,'2014-03-10 14:45:25'),(21877,22527,'0000-00-00','ET','2',1,NULL,'heather stuhldreher','FI','292600780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:26',0,'2014-03-05 21:36:22'),(22520,23170,'0000-00-00','ET','2',2,1,'Tammy D Robin','FI','438293434','Starmount Life Insurance Company','FI','720977315','Michael   Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:25',0,'2014-03-07 22:26:59'),(22790,23440,'0000-00-00','ET','2',1,NULL,'Kevin Bruno','FI','449291536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:41',0,'2014-03-09 21:26:00'),(7,7,'2014-01-01','ET','2',1,NULL,'Brian Abrams','FI','298843959','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:13',0,'2014-03-01 15:21:15'),(2315,2315,'2014-01-01','ET','2',1,NULL,'Brandon Puckett','FI','274842848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:43',0,'2014-03-01 15:05:09'),(5211,5211,'2014-01-01','ET','2',2,1,'John Cope','FI','264279157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:43',0,'2014-03-02 00:10:48'),(11170,11170,'2014-01-01','ET','2',1,NULL,'Alexa L Sharp','94','0001144768','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:38',0,'2014-03-01 16:10:36'),(16162,16811,'0000-00-00','ET','2',1,NULL,'Scott Covill','FI','273769170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:15',0,'2014-03-01 16:56:22'),(16783,17433,'0000-00-00','ET','2',1,NULL,'REX ROSE','FI','266375092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:30',0,'2014-03-02 06:17:30'),(18303,18953,'0000-00-00','ET','2',2,1,'Marialaina Horton','FI','437150864','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:06',0,'2014-03-02 06:45:14'),(18527,19177,'0000-00-00','ET','2',1,NULL,'Sheila Sweet','FI','289489526','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:30',0,'2014-03-10 14:31:05'),(20150,20800,'0000-00-00','ET','2',2,1,'JO  ZENDER','FI','273702442','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:55',0,'2014-03-10 16:38:05'),(20875,21525,'0000-00-00','ET','2',1,NULL,'Rosa Garza','FI','449797384','Starmount Life Insurance Company','FI','720977315','Esequiel  Garcia','94','16428563','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:33',0,'2014-03-02 07:17:36'),(1755,1755,'2014-01-01','ET','2',1,NULL,'Roy Fletcher','94','0000309414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:18:08',0,'2014-03-01 15:31:33'),(13793,14149,'2014-01-01','ET','2',2,1,'Florinda Geyer','FI','193425625','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:42',0,'2014-03-10 13:59:38'),(13777,14133,'2014-01-01','ET','2',1,NULL,'Racheal Jones','FI','587343297','Starmount Life Insurance Company','FI','720977315','Kristy  Corey','94','15790666','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:31',0,'2014-03-02 05:24:45'),(11044,11044,'2014-01-01','ET','2',2,1,'Jeffrey First','94','0000124207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:16',0,'2014-03-10 16:03:49'),(4178,4178,'2014-01-01','ET','2',1,NULL,'CAROLYN D HILTON','FI','652834880','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:30',0,'2014-03-10 15:59:47'),(1999,1999,'2014-01-01','ET','2',1,NULL,'JEFFREY SMITH','FI','449717620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:50',0,'2014-03-01 23:10:52'),(16746,17396,'0000-00-00','ET','2',2,1,'Barbara Whitley','FI','467066376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:06',0,'2014-03-02 06:17:30'),(18071,18721,'0000-00-00','ET','2',2,1,'Abdollah Mehdi-Kashi','FI','528214245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:16',0,'2014-03-02 06:38:05'),(18304,18954,'0000-00-00','ET','2',1,NULL,'John Binz','FI','631322196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:07',0,'2014-03-02 06:45:14'),(69,69,'2014-01-01','ET','2',3,2,'Mirko Tatic','FI','285986765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:06',0,'2014-03-01 15:26:40'),(230,230,'2014-01-01','ET','2',1,0,'Jared Ramsey','FI','467879715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:14',0,'2014-03-01 19:11:03'),(470,470,'2014-01-01','ET','2',1,NULL,'Melvin Parker','FI','272507379','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:41',0,'2014-03-10 13:10:24'),(10698,10698,'2014-01-01','ET','2',2,1,'ROBIN GUADIAN','FI','299725841','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:28',0,'2014-03-01 16:10:36'),(4430,4430,'2014-01-01','ET','2',1,NULL,'Suzanne Ashton Becker','FI','523172109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:03',0,'2014-03-01 19:11:03'),(7119,7119,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:04:11',0,'2014-03-01 15:52:44'),(19906,20556,'0000-00-00','ET','2',1,NULL,'Allie E Butler','FI','287506420','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:08',0,'2014-03-01 17:47:19'),(36,36,'2014-01-01','ET','2',1,NULL,'Billy Bradford','FI','415211529','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:03',0,'2014-03-01 15:21:15'),(13592,13948,'2014-01-01','ET','2',1,NULL,'Pauline Coffey','FI','295522085','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:19',0,'2014-03-10 14:03:26'),(13057,13413,'2014-01-01','ET','2',2,1,'Raymond Frasier','FI','433764531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:20',0,'2014-03-02 05:17:40'),(1096,1096,'2014-01-01','ET','2',1,NULL,'Richard Webster','FI','294708016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:53',0,'2014-03-01 15:05:09'),(12028,12028,'2014-01-01','ET','2',2,1,'LARRY D GALLOWAY','FI','435809540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:09',0,'2014-03-02 04:59:36'),(10825,10825,'2014-01-01','ET','2',2,1,'Eugene Allen','FI','438945303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:42',0,'2014-03-02 04:31:46'),(1123,1123,'2014-01-01','ET','2',3,2,'Craig Biddle','FI','047382081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:22',0,'2014-03-02 04:38:08'),(3307,3307,'2014-01-01','ET','2',2,1,'Michael Smith','FI','290546413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:42',0,'2014-03-01 15:52:44'),(1529,1529,'2014-01-01','ET','2',1,NULL,'Eric Galon','FI','298762948','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:20',0,'2014-03-10 16:03:49'),(3135,3135,'2014-01-01','ET','2',1,NULL,'emily maley','FI','455915121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:37:16',0,'2014-03-02 01:10:33'),(2628,2628,'2014-01-01','ET','2',1,NULL,'Derick Harris','FI','433776908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:53',0,'2014-03-01 21:11:04'),(18744,19394,'0000-00-00','ET','2',1,NULL,'Adria Ivey','FI','438117133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:25',0,'2014-03-02 06:45:14'),(20834,21484,'0000-00-00','ET','2',1,NULL,'DEBORAH MONROE','FI','463470896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:14',0,'2014-03-02 07:17:36'),(22852,23502,'0000-00-00','ET','2',1,NULL,'Jennifer Enzer','94','0000924004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:04',0,'2014-03-10 21:27:11'),(23060,23710,'0000-00-00','ET','2',1,NULL,'Joseph Schroeder','FI','278848455','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:35',0,'2014-03-10 21:17:52'),(14097,14548,'2014-01-01','ET','2',1,NULL,'Shawn Harrison','FI','629148304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:33',0,'2014-03-02 05:38:34'),(14655,15106,'2014-01-01','ET','2',2,1,'David M Schivelbein','FI','273781237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:25',0,'2014-03-01 16:46:19'),(12249,12249,'2014-01-01','ET','2',1,NULL,'david boyce','FI','451513016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:24',0,'2014-03-02 05:03:29'),(13120,13476,'2014-01-01','ET','2',2,1,'David Bondurant','FI','542868317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:45',0,'2014-03-02 05:17:40'),(19529,20179,'0000-00-00','ET','2',5,4,'Ryan Sexton','FI','286809279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:12:48',0,'2014-03-01 17:47:19'),(21026,21676,'0000-00-00','ET','2',1,NULL,'Joshua Wayne Meek','94','0000418918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:19',0,'2014-03-01 18:10:11'),(5580,5580,'2014-01-01','ET','2',1,NULL,'deborah rasbury','FI','453987785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:01',0,'2014-03-02 04:45:37'),(15662,16311,'0000-00-00','ET','2',1,NULL,'Jessica Thomas','FI','288905063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:21',0,'2014-03-01 16:56:22'),(15339,15790,'0000-00-00','ET','2',1,NULL,'Deidra Faulkner','FI','427738114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:42',0,'2014-03-02 05:52:31'),(14442,14893,'2014-01-01','ET','2',1,NULL,'ASHLEY HILTUNEN','FI','324885251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:27',0,'2014-03-02 05:38:34'),(13543,13899,'2014-01-01','ET','2',2,1,'Long Nguyen','FI','437416837','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:44',0,'2014-03-02 05:24:45'),(12894,12894,'2014-01-01','ET','2',1,NULL,'Tracy Lee','FI','288846568','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:04:40',0,'2014-03-10 13:59:38'),(3972,3972,'2014-01-01','ET','2',5,4,'david watkins','FI','301662024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:18',0,'2014-03-01 15:26:40'),(10374,10374,'2014-01-01','ET','2',1,NULL,'Kelly Bowman','FI','295788987','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:55',0,'2014-03-01 16:05:34'),(17029,17679,'0000-00-00','ET','2',3,2,'Joseph Steib','FI','438944807','Starmount Life Insurance Company','FI','720977315','Patrick  Tyson','94','7409844','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:17',0,'2014-03-02 06:24:38'),(17994,18644,'0000-00-00','ET','2',1,NULL,'Michael Stephenson','FI','219584338','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:35',0,'2014-03-02 06:38:05'),(20995,21645,'0000-00-00','ET','2',1,NULL,'Chris Bencar','FI','272909722','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:30:35',0,'2014-03-10 16:38:05'),(21211,21861,'0000-00-00','ET','2',2,1,'SYNTHIA ELLEN POKORNY','FI','300660598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:09',0,'2014-03-01 19:35:05'),(22542,23192,'0000-00-00','ET','2',1,NULL,'TANGER GREEN','FI','298602459','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:40',0,'2014-03-07 21:36:32'),(2242,2242,'2014-01-01','ET','2',1,NULL,'Donna Northrop','FI','437901591','Starmount Life Insurance Company','FI','720977315','Mitch  Davis','94','7668255','348','2014-01-01','Sync Success',0,'2013-12-25 19:49:39',0,'2014-03-01 21:11:04'),(2577,2577,'2014-01-01','ET','2',1,NULL,'Andrew Fortlage','FI','301889920','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:13',0,'2014-03-01 15:05:09'),(6413,6413,'2014-01-01','ET','2',1,NULL,'Mary Mason','FI','291465902','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:59',0,'2014-03-10 13:39:10'),(5722,5722,'2014-01-01','ET','2',2,1,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:05',0,'2014-03-01 15:48:04'),(5063,5063,'2014-01-01','ET','2',1,NULL,'Emily Knueven','FI','275900777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:01',0,'2014-03-01 15:31:33'),(4010,4010,'2014-01-01','ET','2',1,NULL,'MARCIA  VERETTE','FI','461788198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:00:26',0,'2014-03-02 03:09:49'),(22283,22933,'0000-00-00','ET','2',1,NULL,'PAULA JOHNSON','FI','338481671','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:41',0,'2014-03-10 14:45:25'),(831,831,'2014-01-01','ET','2',1,NULL,'ARMETHIA PRESTON','FI','587802196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:04',0,'2014-03-01 21:11:04'),(14219,14670,'2014-01-01','ET','2',2,1,'Hillary Schultz','FI','271820564','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:53',0,'2014-03-10 14:03:26'),(1682,1682,'2014-01-01','ET','2',1,NULL,'Kathryn Sargent','FI','554970331','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:55',0,'2014-03-01 15:31:33'),(2360,2360,'2014-01-01','ET','2',3,2,'Teresa  Perry','FI','299781763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:57',0,'2014-03-01 15:26:40'),(11585,11585,'2014-01-01','ET','2',1,NULL,'Felicia Hopkins','FI','467516684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:15',0,'2014-03-02 04:59:36'),(2393,2393,'2014-01-01','ET','2',2,1,'DEVEN LEE AVANT','FI','451835200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:59',0,'2014-03-01 23:10:52'),(16431,17081,'0000-00-00','ET','2',1,NULL,'shadley gill','FI','535114863','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:46',0,'2014-03-10 14:20:26'),(19327,19977,'0000-00-00','ET','2',1,NULL,'Alan Read','FI','462809929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:17',0,'2014-03-02 06:59:07'),(19438,20088,'0000-00-00','ET','2',2,1,'REBECCA ST GERMAIN','FI','291487182','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:37',0,'2014-03-10 14:31:05'),(20410,21060,'0000-00-00','ET','2',1,NULL,'patrix ferdinand','FI','592234947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:35',0,'2014-03-02 07:10:28'),(20536,21186,'0000-00-00','ET','2',1,NULL,'Sandra Kaye Ondreas','FI','449082939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:01:08',0,'2014-03-02 07:10:28'),(20970,21620,'0000-00-00','ET','2',1,NULL,'Thomas Richard Clein','FI','273447392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 07:30:19',0,'2014-03-01 18:10:11'),(17630,18280,'0000-00-00','ET','2',1,NULL,'IVAN CARDENTEY','FI','770345031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:22',0,'2014-03-02 06:31:45'),(17646,18296,'0000-00-00','ET','2',1,NULL,'Grace Hoffman','FI','279961798','Dental Care Plus, Inc.','FI','311185262','Robert   Whitmore','94','1487742','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:33',0,'2014-03-01 17:20:55'),(18807,19457,'0000-00-00','ET','2',1,NULL,'KYLIE GREEN','FI','628199001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:13',0,'2014-03-02 06:45:14'),(19985,20635,'0000-00-00','ET','2',1,NULL,'Adam Miller','FI','437414642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:41',0,'2014-03-02 07:03:25'),(7063,7063,'2014-01-01','ET','2',1,NULL,'jacob mattes','FI','299924952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:25',0,'2014-03-01 15:52:44'),(10492,10492,'2014-01-01','ET','2',2,1,'Barbara Teague','FI','293724660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:38',0,'2014-03-01 16:10:36'),(14838,15289,'2014-01-01','ET','2',1,NULL,'Joan Truax','FI','291623147','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:24',0,'2014-03-10 14:03:26'),(11516,11516,'2014-01-01','ET','2',1,NULL,'Belinda Oliver','FI','437116896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:07',0,'2014-03-02 04:52:44'),(13600,13956,'2014-01-01','ET','2',1,NULL,'chanda stuard','FI','453810328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:24',0,'2014-03-02 05:31:31'),(12833,12833,'2014-01-01','ET','2',1,NULL,'Stewart Ingram','FI','436736323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:27',0,'2014-03-02 05:10:52'),(11767,11767,'2014-01-01','ET','2',1,NULL,'Melanie H Rick','FI','433196933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:57',0,'2014-03-02 04:59:36'),(17998,18648,'0000-00-00','ET','2',1,NULL,'Laura Jennings','FI','435572112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:38',0,'2014-03-02 06:38:05'),(19058,19708,'0000-00-00','ET','2',1,NULL,'Jessica Banks','FI','435739469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:14',0,'2014-03-02 06:52:12'),(21198,21848,'0000-00-00','ET','2',1,NULL,'RAYMOND SOWEMIMO','FI','467438562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-01 19:00:02',0,'2014-03-02 07:23:39'),(2179,2179,'2014-01-01','ET','2',1,NULL,'Raul Martinez','FI','525197237','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:27',0,'2014-03-01 21:11:04'),(14730,15181,'2014-01-01','ET','2',1,NULL,'Donna Pardue','FI','437452855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:14',0,'2014-03-02 05:45:37'),(7248,7248,'2014-01-01','ET','2',1,NULL,'SARAH COMPTON','FI','401256529','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:09',0,'2014-03-10 13:32:15'),(7337,7337,'2014-01-01','ET','2',1,NULL,'Stanton FitzSimmons','FI','451336221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:03',0,'2014-03-01 21:11:04'),(15476,15927,'0000-00-00','ET','2',1,NULL,'george quaintance','FI','281502296','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:58',0,'2014-03-10 14:10:12'),(16296,16946,'0000-00-00','ET','2',2,1,'Reginald Ferris','FI','448648282','Starmount Life Insurance Company','FI','720977315','Mathew  Dahlen','94','16804332','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:20',0,'2014-03-02 06:10:30'),(18322,18972,'0000-00-00','ET','2',2,1,'devin holm','FI','301909758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:08',0,'2014-03-01 17:26:36'),(21212,21862,'0000-00-00','ET','2',1,NULL,'darrell martin','FI','298701206','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:10',0,'2014-03-01 19:35:05'),(21947,22597,'0000-00-00','ET','2',1,NULL,'wardell eames','FI','435298604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:16',0,'2014-03-05 22:27:33'),(1125,1125,'2014-01-01','ET','2',1,NULL,'Patricia Hutt','FI','580199255','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:27',0,'2014-03-02 04:38:08'),(4519,4519,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:32:44',0,'2014-03-10 15:39:19'),(3091,3091,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:35:56',0,'2014-03-02 01:10:33'),(14024,14380,'2014-01-01','ET','2',1,NULL,'Noel Wallbridge','FI','299928500','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:48',0,'2014-03-10 14:03:26'),(4333,4333,'2014-01-01','ET','2',2,1,'WILLIAM HATTON','FI','296489448','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:14',0,'2014-03-10 13:32:15'),(7018,7018,'2014-01-01','ET','2',1,NULL,'RICKY F LARSEN','FI','551133282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:03',0,'2014-03-02 03:09:49'),(11380,11380,'2014-01-01','ET','2',1,NULL,'Jan McFarland','FI','272689628','HealthSpan','FI','311431434','Emily  Thomas','94','2448778','348','2014-02-01','Sync Success',0,'2013-12-27 02:05:57',0,'2014-03-10 13:52:32'),(10449,10449,'2014-01-01','ET','2',1,NULL,'Nicole Bethel','FI','271760439','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:16',0,'2014-03-01 16:10:36'),(17126,17776,'0000-00-00','ET','2',1,NULL,'Jose  R  Nolasco','FI','644466297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:17',0,'2014-03-02 06:24:38'),(21655,22305,'0000-00-00','ET','2',1,NULL,'Margaret DeBusk','FI','276600382','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:02',0,'2014-03-04 21:36:30'),(23006,23656,'0000-00-00','ET','2',1,NULL,'Caitlin Kerr','FI','295921137','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:56',0,'2014-03-10 21:17:52'),(664,664,'2014-01-01','ET','2',1,NULL,'Alexandra Schwenke','FI','462691481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:36',0,'2014-03-02 02:10:49'),(15206,15657,'0000-00-00','ET','2',1,NULL,'Kayleigh  R Dale','FI','412950560','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:29',0,'2014-03-01 16:50:53'),(1423,1423,'2014-01-01','ET','2',1,NULL,'Marc Cassiere','FI','270549078','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:49',0,'2014-03-10 13:45:57'),(12812,12812,'2014-01-01','ET','2',1,NULL,'Pauline Willett','FI','258723968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:42',0,'2014-03-02 05:17:40'),(15847,16496,'0000-00-00','ET','2',2,1,'Chae Cho','FI','269866155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:38',0,'2014-03-01 16:56:22'),(18751,19401,'0000-00-00','ET','2',1,NULL,'PAT TURNER DANIELS','FI','436170360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:30',0,'2014-03-02 06:45:14'),(18791,19441,'0000-00-00','ET','2',4,3,'Peter Schanz','FI','292845796','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:00',0,'2014-03-10 16:31:33'),(19596,20246,'0000-00-00','ET','2',1,NULL,'David Park','FI','576433027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:31:26',0,'2014-03-02 06:59:07'),(20569,21219,'0000-00-00','ET','2',1,NULL,'Miles Varner','FI','459191716','Starmount Life Insurance Company','FI','720977315','Kathryn  Rojas','94','837994','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:30',0,'2014-03-02 07:17:36'),(20647,21297,'0000-00-00','ET','2',1,NULL,'GLORIA AMOS','FI','434782503','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:22',0,'2014-03-02 07:17:36'),(345,345,'2014-01-01','ET','2',1,NULL,'Kathleen L Jones','FI','301740927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:38',0,'2014-03-01 15:21:15'),(6407,6407,'2014-01-01','ET','2',1,NULL,'Lily Mulberry','FI','401218623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:43',0,'2014-03-10 13:39:10'),(11758,11758,'2014-01-01','ET','2',1,NULL,'ALONZO WHITE','FI','437573700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:40',0,'2014-03-02 04:59:36'),(671,671,'2014-01-01','ET','2',1,NULL,'Teri Drake','FI','281546541','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:49',0,'2014-03-10 15:52:36'),(16147,16796,'0000-00-00','ET','2',1,NULL,'LATOYA ARCHIE','FI','426534568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:05',0,'2014-03-02 06:10:30'),(19055,19705,'0000-00-00','ET','2',2,1,'Scott Stevens','FI','525333218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:11',0,'2014-03-02 06:52:12'),(19632,20282,'0000-00-00','ET','2',4,3,'KATRINA SUBER','FI','298709971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:38:37',0,'2014-03-01 17:47:19'),(20115,20765,'0000-00-00','ET','2',1,NULL,'Philip Delcambre','FI','436194728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:31',0,'2014-03-02 07:10:28'),(22016,22666,'0000-00-00','ET','2',1,NULL,'Suzanne Renee Roth','FI','281504460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-05 21:32:03',0,'2014-03-05 21:36:22'),(6059,6059,'2014-01-01','ET','2',1,NULL,'Thomas Edward Bonnington','FI','535729368','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:54',0,'2014-03-10 13:03:33'),(15417,15868,'0000-00-00','ET','2',2,1,'PAMELA  POWELL','FI','452494107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:20',0,'2014-03-02 05:59:43'),(2001,2001,'2014-01-01','ET','2',1,NULL,'Masoomeh Williams','FI','626597370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:54',0,'2014-03-01 23:10:52'),(12601,12601,'2014-01-01','ET','2',1,NULL,'JANET MCNUTT','FI','001462751','Starmount Life Insurance Company','FI','720977315','BARRY  DOBBS','94','756422','348','2014-02-01','Sync Success',0,'2014-01-03 02:01:08',0,'2014-03-02 05:10:52'),(10972,10972,'2014-01-01','ET','2',2,1,'Jacob Farmer','FI','281928682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:48',0,'2014-03-10 13:45:57'),(17891,18541,'0000-00-00','ET','2',1,NULL,'Casey Talbot','FI','433836487','Starmount Life Insurance Company','FI','720977315','Patrick  Marcello','94','9136870','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:23',0,'2014-03-02 06:31:45'),(19235,19885,'0000-00-00','ET','2',2,1,'Jessica Trevino','FI','466795273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:28',0,'2014-03-02 06:52:12'),(20044,20694,'0000-00-00','ET','2',1,NULL,'Mary Elizabeth Wright','FI','433676969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-22 19:00:14',0,'2014-03-02 07:03:25'),(734,734,'2014-01-01','ET','2',1,NULL,'John Jivoin','FI','300420021','HealthSpan','FI','311431434','Kevin  Schlotman','94','1427172','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:53',0,'2014-03-10 13:24:34'),(15262,15713,'0000-00-00','ET','2',1,NULL,'Julie Cook','FI','275644222','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:38',0,'2014-03-10 14:10:12'),(931,931,'2014-01-01','ET','2',2,1,'Rosario G Cordova','FI','458576036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:04',0,'2014-03-01 22:10:55'),(13705,14061,'2014-01-01','ET','2',1,NULL,'Therese Watkins','FI','281821254','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:43',0,'2014-03-01 16:40:16'),(11496,11496,'2014-01-01','ET','2',1,NULL,'Noemi Aguirre','FI','459822553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:31:32',0,'2014-03-02 04:52:44'),(7219,7219,'2014-01-01','ET','2',1,NULL,'Dorothy E Altemus','FI','287485035','Dental Care Plus, Inc.','FI','311185262','Kelly  Walter','94','2194057','348','2014-01-01','Sync Success',0,'2013-12-26 04:07:12',0,'2014-03-01 15:52:44'),(5195,5195,'2014-01-01','ET','2',1,NULL,'VICTOR  THOMPSON','FI','255964700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:12',0,'2014-03-02 00:10:48'),(4062,4062,'2014-01-01','ET','2',2,1,'Carol Mattick','FI','585948138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:03',0,'2014-03-02 03:09:49'),(4798,4798,'2014-01-01','ET','2',2,1,'Leonard Carr','FI','232170644','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:49',0,'2014-03-01 15:16:37'),(4263,4263,'2014-01-01','ET','2',1,NULL,'Locke Buras','FI','435044650','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:12',0,'2014-03-02 03:09:49'),(7202,7202,'2014-01-01','ET','2',4,3,'Richard Gohs','FI','286726470','Dental Care Plus, Inc.','FI','311185262','Sandra  Bartels','94','7863784','348','2014-01-01','Sync Success',0,'2013-12-26 04:06:40',0,'2014-03-01 15:52:44'),(15730,16379,'0000-00-00','ET','2',1,NULL,'SHU ZHEN WONG','FI','436633142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:09',0,'2014-03-02 05:59:43'),(16515,17165,'0000-00-00','ET','2',1,NULL,'Valerie Sutton','FI','427373649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:47',0,'2014-03-02 06:10:30'),(19443,20093,'0000-00-00','ET','2',1,NULL,'PRECIOUS ALLEN','FI','292921293','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:40',0,'2014-03-10 14:37:47'),(21396,22046,'0000-00-00','ET','2',1,NULL,'ALana Arbor','FI','465132656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:08',0,'2014-03-03 21:25:18'),(21997,22647,'0000-00-00','ET','2',1,NULL,'Dianna Lindsey Ferzzell','FI','290502941','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:51',0,'2014-03-10 16:44:18'),(22466,23116,'0000-00-00','ET','2',1,NULL,'Kristina Hatfield','FI','284862362','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:47',0,'2014-03-07 21:36:32'),(1218,1218,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','348','2014-01-01','Sync Success',0,'2013-12-25 18:48:20',0,'2014-03-01 16:15:39'),(15374,15825,'0000-00-00','ET','2',1,NULL,'COREY T WILLIAMS','FI','439060833','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:53',0,'2014-03-02 05:59:43'),(15327,15778,'0000-00-00','ET','2',1,NULL,'Megan Wilson','FI','282822500','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:35',0,'2014-03-01 16:50:53'),(14949,15400,'2014-01-01','ET','2',1,NULL,'Rebecca Morris','FI','452279330','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:47',0,'2014-03-02 05:45:37'),(7008,7008,'2014-01-01','ET','2',1,NULL,'William Pike','FI','635107130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:46',0,'2014-03-02 03:09:49'),(4602,4602,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','348','2014-01-01','Sync Success',0,'2013-12-25 23:47:20',0,'2014-03-01 16:15:39'),(3943,3943,'2014-01-01','ET','2',1,NULL,'Cesar Mendiola','FI','453332399','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:19',0,'2014-03-01 23:10:52'),(15979,16628,'0000-00-00','ET','2',2,1,'Corey Mason','FI','297702292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:23',0,'2014-03-01 16:56:22'),(18545,19195,'0000-00-00','ET','2',1,NULL,'MARCIE PURIFOY','FI','422153395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:09',0,'2014-03-02 06:45:14'),(19372,20022,'0000-00-00','ET','2',1,NULL,'LITTLE DEBORAH','FI','296541274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:48',0,'2014-03-01 17:34:07'),(19532,20182,'0000-00-00','ET','2',1,NULL,'Barbara Day','FI','279425023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:13:47',0,'2014-03-01 17:47:19'),(20482,21132,'0000-00-00','ET','2',2,1,'JOAN SHERWOOD','FI','300506442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:32',0,'2014-03-10 14:37:47'),(192,192,'2014-01-01','ET','2',1,NULL,'VICTOR GREATREX','FI','433868850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:58',0,'2014-03-01 23:10:52'),(15554,16005,'0000-00-00','ET','2',1,NULL,'tina jodrey','FI','281808150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 03:02:16',0,'2014-03-01 16:50:53'),(7092,7092,'2014-01-01','ET','2',1,NULL,'Carol Brown','94','0001258644','Dental Care Plus, Inc.','FI','311185262','Jason  Lucik','94','8876462','348','2014-01-01','Sync Success',0,'2013-12-26 04:03:24',0,'2014-03-01 15:52:44'),(1494,1494,'2014-01-01','ET','2',1,NULL,'Cuauhtemoc Perez','FI','451233716','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:11',0,'2014-03-10 13:45:57'),(12884,12884,'2014-01-01','ET','2',1,NULL,'NICOLE BURNS','FI','289807456','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:19',0,'2014-03-01 16:35:14'),(6127,6127,'2014-01-01','ET','2',1,NULL,'Barbara Mason','FI','273804065','Dental Care Plus, Inc.','FI','311185262','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-26 03:02:10',0,'2014-03-01 16:00:27'),(12474,12474,'2014-01-01','ET','2',1,NULL,'Ho Soon Hong','FI','289112800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:21',0,'2014-03-01 16:30:17'),(4516,4516,'2014-01-01','ET','2',1,NULL,'Kristina Burns','FI','271906055','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:38',0,'2014-03-10 13:03:33'),(10395,10395,'2014-01-01','ET','2',1,NULL,'Kathy Ann Crowe','FI','234860608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:33',0,'2014-03-01 16:10:36'),(2822,2822,'2014-01-01','ET','2',1,NULL,'Rachell Bateman','FI','427477350','Starmount Life Insurance Company','FI','720977315','Mike  Patterson','94','7379777','357','2014-01-01','Sync Success',0,'2013-12-25 21:21:03',0,'2014-03-02 04:15:49'),(2872,2872,'2014-01-01','ET','2',4,3,'Geoffrey Lowell','FI','299626430','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:42',0,'2014-03-10 13:39:10'),(19730,20380,'0000-00-00','ET','2',1,NULL,'CAROL JOYCE DELLIFANTI','FI','299528640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 05:36:57',0,'2014-03-01 17:47:19'),(22534,23184,'0000-00-00','ET','2',2,1,'Donald Davis','FI','292641276','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:35',0,'2014-03-07 21:36:32'),(22659,23309,'0000-00-00','ET','2',1,NULL,'MARTIN ROBERT RASMUSSEN','FI','465979464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:27',0,'2014-03-08 22:26:18'),(7392,7392,'2014-01-01','ET','2',1,NULL,'Nolfris Williams','FI','416173603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:36',0,'2014-03-02 04:15:49'),(13064,13420,'2014-01-01','ET','2',2,1,'ralph warner','FI','041747387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:34',0,'2014-03-02 05:17:40'),(12106,12106,'2014-01-01','ET','2',1,NULL,'TAMIKA HASAN','FI','294603165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:55',0,'2014-03-01 16:30:17'),(5266,5266,'2014-01-01','ET','2',1,NULL,'Deborah Barone','FI','282643719','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:13',0,'2014-03-10 15:39:19'),(11317,11317,'2014-01-01','ET','2',1,NULL,'sheldon john','FI','452755519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:01',0,'2014-03-02 04:52:44'),(19959,20609,'0000-00-00','ET','2',2,1,'Philip Decker','FI','278847123','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:23',0,'2014-03-01 17:47:19'),(3852,3852,'2014-01-01','ET','2',1,NULL,'Karen Bowie','FI','643019275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:40',0,'2014-03-01 19:11:03'),(3684,3684,'2014-01-01','ET','2',1,NULL,'Eric Scharf','FI','289745223','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:58',0,'2014-03-10 13:20:27'),(14408,14859,'2014-01-01','ET','2',1,NULL,'ReBecca Robinson','94','0000139035','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:10',0,'2014-03-01 16:46:19'),(14827,15278,'2014-01-01','ET','2',1,NULL,'jessie  williams','FI','587688988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:17',0,'2014-03-02 05:45:37'),(12953,12953,'2014-01-01','ET','2',1,NULL,'John Lee','FI','439275278','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-05 00:00:26',0,'2014-03-02 05:17:40'),(2415,2415,'2014-01-01','ET','2',1,NULL,'SHARON MCENTIRE','FI','272443247','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:45',0,'2014-03-10 13:10:24'),(12488,12488,'2014-01-01','ET','2',1,NULL,'Jill Donahue','FI','298567622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:52',0,'2014-03-01 16:35:14'),(4580,4580,'2014-01-01','ET','2',2,1,'David Lyttle','FI','278623856','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:37',0,'2014-03-01 16:15:39'),(15984,16633,'0000-00-00','ET','2',1,NULL,'Robert  Kelly','FI','421298030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:28',0,'2014-03-10 14:20:26'),(17714,18364,'0000-00-00','ET','2',1,NULL,'Alvin Ingram','FI','134502652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:11',0,'2014-03-02 06:31:45'),(18680,19330,'0000-00-00','ET','2',1,NULL,'Elizabeth Lara','FI','607345576','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:37',0,'2014-03-02 06:45:14'),(22297,22947,'0000-00-00','ET','2',1,NULL,'LYLY VONA','FI','857482129','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:51',0,'2014-03-10 16:44:18'),(141,141,'2014-01-01','ET','2',1,NULL,'Beverly Buchanan','FI','283483593','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:21',0,'2014-03-10 15:45:56'),(14780,15231,'2014-01-01','ET','2',1,NULL,'Megan Marie Taraschke','FI','272966643','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:45',0,'2014-03-10 14:03:26'),(6081,6081,'2014-01-01','ET','2',4,3,'Nicole Renee Turner','FI','301805693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:44',0,'2014-03-01 16:00:27'),(5052,5052,'2014-01-01','ET','2',1,NULL,'David Bailey','FI','293480758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:40',0,'2014-03-01 15:31:33'),(10573,10573,'2014-01-01','ET','2',2,1,'Patricia Guerrero','FI','632586857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:19',0,'2014-03-02 04:24:47'),(4944,4944,'2014-01-01','ET','2',2,1,'JESSE VALERIO','FI','464821939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:35',0,'2014-03-01 20:10:57'),(16496,17146,'0000-00-00','ET','2',1,NULL,'Mudather Ali','FI','438953202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:34',0,'2014-03-02 06:10:30'),(20393,21043,'0000-00-00','ET','2',1,NULL,'Raul Soria Montes','FI','458954919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:21',0,'2014-03-02 07:10:28'),(22862,23512,'0000-00-00','ET','2',1,NULL,'PORTER JR COGER','FI','342464381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:12',0,'2014-03-10 21:27:11'),(7130,7130,'2014-01-01','ET','2',1,NULL,'wilbert  johnson','FI','280702628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:30',0,'2014-03-01 15:52:44'),(14130,14581,'2014-01-01','ET','2',1,NULL,'EDNA DIANE WAMPLER','FI','415861631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:55',0,'2014-03-02 05:38:34'),(1372,1372,'2014-01-01','ET','2',1,NULL,'Maria Gomez','FI','263674589','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:06',0,'2014-03-02 04:38:08'),(7317,7317,'2014-01-01','ET','2',1,NULL,'TERRY BISHOP','FI','270546819','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:10:14',0,'2014-03-10 13:32:15'),(5578,5578,'2014-01-01','ET','2',1,NULL,'Oscar Orias','FI','450977258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:57',0,'2014-03-02 04:45:37'),(6269,6269,'2014-01-01','ET','2',1,NULL,'TRAN NGUYEN','FI','438519108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:31',0,'2014-03-02 04:10:25'),(5997,5997,'2014-01-01','ET','2',1,NULL,'Marty Gilmore','FI','291640625','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:57',0,'2014-03-10 13:24:34'),(4785,4785,'2014-01-01','ET','2',1,NULL,'KIRBY DENSON','FI','301482910','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 00:01:26',NULL,NULL),(16597,17247,'0000-00-00','ET','2',1,NULL,'larry stephens','FI','467067768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:04',0,'2014-03-02 06:17:30'),(16715,17365,'0000-00-00','ET','2',1,NULL,'tina glass','FI','279682727','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:27',0,'2014-03-10 14:20:26'),(19170,19820,'0000-00-00','ET','2',2,1,'Francisco Garza','FI','458410597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:39',0,'2014-03-02 06:52:12'),(22428,23078,'0000-00-00','ET','2',2,1,'JOSE LUIS RAMOS','FI','605038050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:19',0,'2014-03-07 22:26:59'),(210,210,'2014-01-01','ET','2',1,NULL,'Maureen Moise SCHEXNAYDER','FI','142382058','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:37',0,'2014-03-01 22:10:55'),(13761,14117,'2014-01-01','ET','2',1,NULL,'KIM SPENCE','FI','439294300','Starmount Life Insurance Company','FI','720977315','MONICA  FOLSE','94','4710336','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:22',0,'2014-03-02 05:24:45'),(13303,13659,'2014-01-01','ET','2',1,NULL,'Brandi Buchenau','FI','295861168','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:14',0,'2014-03-01 16:40:16'),(12925,12925,'2014-01-01','ET','2',1,NULL,'Brandon Gallion','FI','283903544','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:51',0,'2014-03-10 16:10:34'),(12377,12377,'2014-01-01','ET','2',1,NULL,'Christine Dresser','FI','282564842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:50',0,'2014-03-01 16:30:17'),(6373,6373,'2014-01-01','ET','2',1,NULL,'CLETUS PHOENIX','FI','302682548','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:39',0,'2014-03-10 13:39:10'),(1751,1751,'2014-01-01','ET','2',1,NULL,'Roy Fletcher','94','0000309414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:01',0,'2014-03-01 15:31:33'),(4371,4371,'2014-01-01','ET','2',1,NULL,'Teri Such','FI','276549836','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:11:26',0,'2014-03-10 13:32:15'),(2940,2940,'2014-01-01','ET','2',1,NULL,'INAE PARK','FI','292889425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:15',0,'2014-03-01 15:37:30'),(20156,20806,'0000-00-00','ET','2',1,NULL,'Desirae Thompson','FI','281842009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:59',0,'2014-03-01 18:08:07'),(20340,20990,'0000-00-00','ET','2',1,NULL,'VERA HINES','FI','434844251','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:30',0,'2014-03-02 07:03:25'),(20367,21017,'0000-00-00','ET','2',1,NULL,'Rosemarie Jones','FI','263377010','HealthSpan','FI','311431434','Robert  Colaianni','94','16444219','348','2014-04-01','Sync Success',0,'2014-02-26 08:30:53',0,'2014-03-10 14:37:47'),(22948,23598,'0000-00-00','ET','2',1,NULL,'Duane Campton','FI','274721698','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-10 21:01:15',0,'2014-03-10 21:17:52'),(4908,4908,'2014-01-01','ET','2',2,1,'Coree Lavone Corbin','FI','629248789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:24',0,'2014-03-01 19:11:03'),(14828,15279,'2014-01-01','ET','2',1,NULL,'Meko Jones','FI','587638022','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:17',0,'2014-03-02 05:45:37'),(14019,14375,'2014-01-01','ET','2',2,1,'Robert Champlin','FI','270529762','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:44',0,'2014-03-10 14:03:26'),(4789,4789,'2014-01-01','ET','2',2,1,'Baffour Otchere','FI','291766180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:33',0,'2014-03-01 15:16:37'),(11713,11713,'2014-01-01','ET','2',1,NULL,'CANDACE JEFFERSON','FI','425479120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:18',0,'2014-03-02 04:59:36'),(16506,17156,'0000-00-00','ET','2',1,NULL,'MARIANELA P GARZA','FI','452902423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:40',0,'2014-03-02 06:10:30'),(4257,4257,'2014-01-01','ET','2',1,NULL,'Peter Trokan','FI','393948788','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:08:02',0,'2014-03-10 13:32:15'),(13548,13904,'2014-01-01','ET','2',1,NULL,'Ivy Labyzon Douglas','FI','436642573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:48',0,'2014-03-02 05:31:31'),(13861,14217,'2014-01-01','ET','2',1,NULL,'Jonathan Lester','FI','415474056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:55',0,'2014-03-02 05:31:31'),(17988,18638,'0000-00-00','ET','2',1,NULL,'RICHARD REED','FI','299443334','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:31',0,'2014-03-10 16:31:33'),(18602,19252,'0000-00-00','ET','2',1,NULL,'SONA NIXON','FI','203633320','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:36',0,'2014-03-10 16:31:33'),(18965,19615,'0000-00-00','ET','2',3,2,'Tammy Kehling','FI','276800485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:48',0,'2014-03-10 14:31:05'),(92,92,'2014-01-01','ET','2',1,NULL,'Daniel McKinney','FI','457885702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:48',0,'2014-03-01 23:10:52'),(14826,15277,'2014-01-01','ET','2',2,1,'Teresa D Smith','FI','478684431','HealthSpan','FI','311431434','Charles  Short','94','1577375','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:16',0,'2014-03-10 14:03:26'),(12986,12986,'2014-01-01','ET','2',1,NULL,'April Glassner','FI','274705035','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:38',0,'2014-03-10 13:59:38'),(2094,2094,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:51',0,'2014-03-10 13:20:27'),(3436,3436,'2014-01-01','ET','2',1,NULL,'JOHN C THOMPSON','FI','285568838','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:52',0,'2014-03-10 13:24:34'),(4871,4871,'2014-01-01','ET','2',1,NULL,'RANDALL PATRICK ARLEDGE','FI','293623667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:17',0,'2014-03-01 15:10:22'),(17304,17954,'0000-00-00','ET','2',2,1,'Melissa Israel','FI','434570368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:57',0,'2014-03-02 06:24:38'),(21967,22617,'0000-00-00','ET','2',1,NULL,'Peggy Sponza','FI','294504521','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:31',0,'2014-03-10 16:44:18'),(22837,23487,'0000-00-00','ET','2',2,1,'Karen Gillespie','FI','272843517','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:30:01',0,'2014-03-10 14:50:59'),(1133,1133,'2014-01-01','ET','2',1,NULL,'Magdy Mounir Labib','FI','255697861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:40',0,'2014-03-02 04:38:08'),(1470,1470,'2014-01-01','ET','2',1,NULL,'KAYLA FULLER','FI','288582284','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:27',0,'2014-03-01 16:23:43'),(14530,14981,'2014-01-01','ET','2',2,1,'ashley renaud','FI','300925944','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:07',0,'2014-03-10 16:17:47'),(13677,14033,'2014-01-01','ET','2',1,NULL,'Shovon Crenshaw','FI','571197949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:26',0,'2014-03-02 05:24:45'),(12562,12562,'2014-01-01','ET','2',1,NULL,'Larry Walters','94','0000062547','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:47',0,'2014-03-10 16:10:34'),(12078,12078,'2014-01-01','ET','2',1,NULL,'Rachel Craft','FI','308868806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:57',0,'2014-03-01 16:30:17'),(7737,7737,'2014-01-01','ET','2',1,NULL,'Ella Geib','FI','293626587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:26',0,'2014-03-01 15:05:09'),(5542,5542,'2014-01-01','ET','2',2,1,'John Graven','FI','282483993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:48',0,'2014-03-01 16:23:43'),(2224,2224,'2014-01-01','ET','2',1,NULL,'Angela McFerran','FI','300684286','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:48:59',0,'2014-03-10 13:10:24'),(2916,2916,'2014-01-01','ET','2',1,NULL,'EVA L TAYLOR','FI','279505166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:26',0,'2014-03-01 15:37:30'),(20855,21505,'0000-00-00','ET','2',1,NULL,'LILLIAN JENKINS','FI','439177805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:31:24',0,'2014-03-02 07:17:36'),(5145,5145,'2014-01-01','ET','2',1,NULL,'Nancy Boeff','FI','271481853','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:39',0,'2014-03-10 15:45:56'),(15768,16417,'0000-00-00','ET','2',2,1,'Lindy Kaemming','FI','281821039','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:32',0,'2014-03-10 14:10:12'),(1310,1310,'2014-01-01','ET','2',1,NULL,'CHRIS A HATFIELD','FI','466115027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:08',0,'2014-03-02 04:38:08'),(3878,3878,'2014-01-01','ET','2',1,0,'Ronald Johnson','FI','453113971','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:28',0,'2014-03-01 19:11:03'),(1964,1964,'2014-01-01','ET','2',1,NULL,'Leonard Kramer','FI','291445999','Dental Care Plus, Inc.','FI','311185262','Ken   Jones','94','1888068','348','2014-01-01','Sync Success',0,'2013-12-25 19:33:38',0,'2014-03-01 15:26:40'),(3724,3724,'2014-01-01','ET','2',1,NULL,'Donna Thomas','FI','280541550','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:19',0,'2014-03-10 13:24:34'),(2325,2325,'2014-01-01','ET','2',1,NULL,'Jerry Ward','FI','284645454','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:05',0,'2014-03-01 15:05:09'),(17916,18566,'0000-00-00','ET','2',1,NULL,'Barbara Whitley','FI','467066376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:40',0,'2014-03-02 06:38:05'),(18997,19647,'0000-00-00','ET','2',5,4,'Kathrine Simmons','94','0001066019','Summa Insurance Company, Inc.','FI','341809108','Deborah  Gazey','94','2341750','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:11',0,'2014-03-10 16:31:33'),(21850,22500,'0000-00-00','ET','2',1,NULL,'joan kamau','FI','209769932','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:06',0,'2014-03-05 21:36:22'),(21863,22513,'0000-00-00','ET','2',1,NULL,'Maurice White','FI','271842838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:16',0,'2014-03-05 21:36:22'),(22812,23462,'0000-00-00','ET','2',1,NULL,'shelly cousino','94','0000413425','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-09 21:01:02',0,'2014-03-10 14:50:59'),(5970,5970,'2014-01-01','ET','2',1,NULL,'Raegan Courville','FI','439771468','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:00',0,'2014-03-02 02:10:49'),(14735,15186,'2014-01-01','ET','2',1,NULL,'Louis Peterson','FI','434355660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:16',0,'2014-03-02 05:45:37'),(5155,5155,'2014-01-01','ET','2',1,NULL,'Renee Nist','FI','268522134','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:57',0,'2014-03-10 15:45:56'),(2550,2550,'2014-01-01','ET','2',1,NULL,'WILLIAM MCILROY','FI','272768678','Summa Insurance Company, Inc.','FI','341809108','WILLIAM  MCILROY','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-25 20:31:33',0,'2014-03-10 15:39:19'),(4807,4807,'2014-01-01','ET','2',1,NULL,'George L Williamson','FI','204385228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:05',0,'2014-03-01 15:16:37'),(3030,3030,'2014-01-01','ET','2',2,1,'Michael Socciarelli','FI','286626344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:01',0,'2014-03-01 15:37:30'),(5632,5632,'2014-01-01','ET','2',1,NULL,'brian mcmahon','FI','050607987','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:45',0,'2014-03-10 13:52:32'),(14727,15178,'2014-01-01','ET','2',1,NULL,'Carolyn Webb','FI','434948123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:12',0,'2014-03-02 05:45:37'),(2629,2629,'2014-01-01','ET','2',1,NULL,'Heather Williams','FI','436797771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:55',0,'2014-03-01 21:11:04'),(13766,14122,'2014-01-01','ET','2',1,NULL,'Michael Litt','FI','141529828','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:24',0,'2014-03-10 16:10:34'),(16762,17412,'0000-00-00','ET','2',1,NULL,'Omari Friday','FI','425570376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:17',0,'2014-03-02 06:17:30'),(18924,19574,'0000-00-00','ET','2',1,NULL,'Tiffany Wiggins','FI','587492639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:19',0,'2014-03-02 06:52:12'),(19239,19889,'0000-00-00','ET','2',2,1,'Pramod Mahaseth','FI','730264366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:31',0,'2014-03-01 17:34:07'),(20171,20821,'0000-00-00','ET','2',1,NULL,'Chestene Bickle','FI','232905905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:09',0,'2014-03-01 18:08:07'),(20193,20843,'0000-00-00','ET','2',2,1,'LINDA DOZIER','FI','457086273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:25',0,'2014-03-02 07:10:28'),(7399,7399,'2014-01-01','ET','2',1,NULL,'Wilbert Davis','FI','437419265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:50',0,'2014-03-02 04:10:25'),(14831,15282,'2014-01-01','ET','2',1,NULL,'Janet Rigney','FI','246061684','HealthSpan','FI','311431434','Andre  Felton','94','16832006','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:20',0,'2014-03-10 14:03:26'),(14528,14979,'2014-01-01','ET','2',4,3,'Sarah Shaferly','FI','297740915','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:06',0,'2014-03-10 14:03:26'),(6237,6237,'2014-01-01','ET','2',1,NULL,'Gina McCoy','FI','297728366','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:30',0,'2014-03-10 13:32:15'),(11789,11789,'2014-01-01','ET','2',1,NULL,'CRISTAL HERNANDEZ','FI','645109170','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:47',0,'2014-03-02 04:31:46'),(4341,4341,'2014-01-01','ET','2',1,NULL,'Sharon K Rhoades','FI','274449739','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:10:31',0,'2014-03-10 13:32:15'),(5313,5313,'2014-01-01','ET','2',1,NULL,'Loretta Harris','FI','213822082','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:57',0,'2014-03-10 13:03:33'),(204,204,'2014-01-01','ET','2',1,NULL,'jason tippie','FI','243410984','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:22',0,'2014-03-10 13:10:24'),(14221,14672,'2014-01-01','ET','2',2,1,'Kris Evans Burt','FI','279483858','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:54',0,'2014-03-10 14:03:26'),(1666,1666,'2014-01-01','ET','2',1,NULL,'Eugene Franklin','FI','459924794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:27',0,'2014-03-02 00:10:48'),(13440,13796,'2014-01-01','ET','2',2,1,'Cristy Longnion','FI','464993995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:12',0,'2014-03-02 05:31:31'),(13360,13716,'2014-01-01','ET','2',1,NULL,'Brenda Hernandez','FI','630565854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:36',0,'2014-03-02 05:24:45'),(13187,13543,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:06:10',0,'2014-03-10 16:10:34'),(20690,21340,'0000-00-00','ET','2',1,NULL,'Shannon Hamlett','FI','436359211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:07',0,'2014-03-02 07:17:36'),(21666,22316,'0000-00-00','ET','2',3,2,'Pepa Iliev','FI','293983283','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:09',0,'2014-03-04 21:36:30'),(21842,22492,'0000-00-00','ET','2',1,NULL,'Kimberly Lee','FI','465912601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-21','Sync Success',0,'2014-03-05 21:00:31',0,'2014-03-05 21:25:24'),(22335,22985,'0000-00-00','ET','2',1,NULL,'deitra fletcher','FI','275684182','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-06 21:30:22',0,'2014-03-10 14:50:59'),(2244,2244,'2014-01-01','ET','2',1,NULL,'Timothy L Scales','FI','587119718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:43',0,'2014-03-01 21:11:04'),(2408,2408,'2014-01-01','ET','2',1,NULL,'John Isenbarger','FI','269821132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:17:29',0,'2014-03-01 15:26:40'),(4998,4998,'2014-01-01','ET','2',1,NULL,'Claude Wesser','FI','278483778','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:54',0,'2014-03-01 15:31:33'),(12702,12702,'2014-01-01','ET','2',2,1,'Jaimee Yeager','FI','426712628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:50',0,'2014-03-02 05:10:52'),(5037,5037,'2014-01-01','ET','2',1,NULL,'Nancy Pizir','FI','289760651','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:10',0,'2014-03-01 15:31:33'),(6145,6145,'2014-01-01','ET','2',2,1,'SALAH ABDILLE','FI','668098638','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:39',0,'2014-03-01 16:00:27'),(7529,7529,'2014-01-01','ET','2',1,NULL,'Stephanie LaShawn Radford','FI','282903778','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:59',0,'2014-03-01 16:05:34'),(13527,13883,'2014-01-01','ET','2',2,1,'wilson O Tweneboah','FI','590115190','Dental Care Plus, Inc.','FI','311185262','Donovan E Scott','94','4587540','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:35',0,'2014-03-01 16:40:16'),(14706,15157,'2014-01-01','ET','2',1,NULL,'Desiree Delandria Bernard','FI','433984558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:58',0,'2014-03-02 05:45:37'),(15967,16616,'0000-00-00','ET','2',1,NULL,'GINA GARDNER','FI','439754142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-26 19:00:14',0,'2014-03-02 06:03:21'),(16625,17275,'0000-00-00','ET','2',2,1,'raymond padia','FI','458551393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:24',0,'2014-03-02 06:17:30'),(19254,19904,'0000-00-00','ET','2',2,1,'Michael Schulze','FI','288421141','HealthSpan','FI','311431434','EMILY  THOMAS','94','2448778','348','2014-04-01','Sync Success',0,'2014-02-16 19:00:42',0,'2014-03-10 14:31:05'),(20932,21582,'0000-00-00','ET','2',1,NULL,'Kathleen Taylor','FI','277801472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:00:24',0,'2014-03-10 16:38:05'),(21728,22378,'0000-00-00','ET','2',1,NULL,'Marcia Berry','FI','273525467','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:02',0,'2014-03-10 16:44:18'),(22362,23012,'0000-00-00','ET','2',2,1,'Amy Scott','FI','280586611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:16',0,'2014-03-07 21:36:32'),(313,313,'2014-01-01','ET','2',2,1,'Daniel Londoff','FI','491708435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:35',0,'2014-03-01 22:10:55'),(606,606,'2014-01-01','ET','2',1,NULL,'Christopher Deal','FI','237698962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:48',0,'2014-03-02 02:10:49'),(11932,11932,'2014-01-01','ET','2',1,NULL,'SARAH BREZINA','FI','383065089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:02',0,'2014-03-02 04:59:36'),(7522,7522,'2014-01-01','ET','2',1,NULL,'Benjamin Howard','FI','295927686','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:45',0,'2014-03-01 16:05:34'),(1231,1231,'2014-01-01','ET','2',1,NULL,'Christopher N Onyeaghor','FI','281883421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:42',0,'2014-03-01 16:15:39'),(2696,2696,'2014-01-01','ET','2',2,1,'Wesley Manes','FI','525778301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:03',0,'2014-03-02 04:15:49'),(3261,3261,'2014-01-01','ET','2',1,NULL,'LEANNE FISHER','FI','280725077','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:09',0,'2014-03-10 15:52:36'),(3409,3409,'2014-01-01','ET','2',4,3,'Lance Hostetler','FI','315967019','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:59',0,'2014-03-10 13:32:15'),(3438,3438,'2014-01-01','ET','2',2,1,'JAMES GOULD','FI','278568964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:56',0,'2014-03-10 13:24:34'),(16510,17160,'0000-00-00','ET','2',2,1,'Humberto Soto','FI','457570926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:43',0,'2014-03-02 06:17:30'),(17385,18035,'0000-00-00','ET','2',1,NULL,'James Figley','FI','286860148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:31',0,'2014-03-01 17:20:55'),(18167,18817,'0000-00-00','ET','2',1,NULL,'MEGAN CASEY','FI','433776598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:28',0,'2014-03-02 06:38:05'),(18925,19575,'0000-00-00','ET','2',1,NULL,'Cory Blackburn','FI','610421635','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:20',0,'2014-03-10 14:31:05'),(18985,19635,'0000-00-00','ET','2',1,NULL,'CAROLINE CARNEY','FI','415457464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:04',0,'2014-03-02 06:52:12'),(19590,20240,'0000-00-00','ET','2',1,NULL,'Sergio Rivas','FI','637037504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:30:30',0,'2014-03-02 06:59:07'),(19672,20322,'0000-00-00','ET','2',1,NULL,'CINDY RENTSCHLER','FI','296608590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:48:44',0,'2014-03-01 17:47:19'),(20622,21272,'0000-00-00','ET','2',1,NULL,'Danielle Mariche','FI','434611137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:04',0,'2014-03-02 07:10:28'),(21420,22070,'0000-00-00','ET','2',1,NULL,'Mostafa M Elkhatib','FI','578801403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:24',0,'2014-03-03 21:25:18'),(21594,22244,'0000-00-00','ET','2',1,NULL,'Bettie Freeney','FI','451908220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:15',0,'2014-03-04 21:27:16'),(22773,23423,'0000-00-00','ET','2',1,NULL,'Viktor Stowell','FI','073809955','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:28',0,'2014-03-09 21:35:27'),(3078,3078,'2014-01-01','ET','2',1,NULL,'Carlette Christmas','FI','439454009','Starmount Life Insurance Company','FI','720977315','Wesley J Watkins','94','4710431','348','2014-01-01','Sync Success',0,'2013-12-25 21:35:33',0,'2014-03-02 01:10:33'),(12509,12509,'2014-01-01','ET','2',1,NULL,'Tina M Bergez','FI','437433323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:43',0,'2014-03-02 05:03:29'),(12139,12139,'2014-01-01','ET','2',2,1,'Jon  Hartney','FI','271661803','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:04',0,'2014-03-10 16:10:34'),(10491,10491,'2014-01-01','ET','2',1,NULL,'Coreta Snipes','FI','291785801','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:36',0,'2014-03-01 16:10:36'),(3179,3179,'2014-01-01','ET','2',2,1,'scott ludwig','FI','284748054','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:49',0,'2014-03-10 13:24:34'),(4771,4771,'2014-01-01','ET','2',1,NULL,'marcela reyes','FI','452295056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:02',0,'2014-03-01 21:11:04'),(4112,4112,'2014-01-01','ET','2',1,NULL,'JUDITH HAMPEL','FI','291729539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:34',0,'2014-03-01 16:00:27'),(15935,16584,'0000-00-00','ET','2',2,1,'David Stauffer','FI','269646810','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:14',0,'2014-03-01 16:56:22'),(15987,16636,'0000-00-00','ET','2',1,NULL,'HENRY GHOLSTON','FI','426029475','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:30',0,'2014-03-02 06:03:21'),(16061,16710,'0000-00-00','ET','2',1,NULL,'NANNETTE M LEWIS','FI','290567038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:50',0,'2014-03-01 16:56:22'),(16187,16836,'0000-00-00','ET','2',1,NULL,'Julie Canning-Hollenbeck','FI','285868119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:30',0,'2014-03-01 16:56:22'),(16842,17492,'0000-00-00','ET','2',1,NULL,'KATHLEEN SOMERVILLE','FI','298507817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:19',0,'2014-03-01 17:00:58'),(17707,18357,'0000-00-00','ET','2',1,NULL,'BARBARA LINDE','FI','439920749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-09 19:00:07',0,'2014-03-02 06:31:45'),(19797,20447,'0000-00-00','ET','2',1,NULL,'STEPHANIE TULL','FI','433414895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:20',0,'2014-03-02 07:03:25'),(22013,22663,'0000-00-00','ET','2',1,NULL,'JAMES METCALF','FI','295583427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:01',0,'2014-03-05 21:36:22'),(22961,23611,'0000-00-00','ET','2',3,2,'Katherine Rickett','FI','295785412','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:24',0,'2014-03-10 21:36:25'),(162,162,'2014-01-01','ET','2',2,1,'Debra Beverly','FI','269584063','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:01',0,'2014-03-10 13:10:24'),(13214,13570,'2014-01-01','ET','2',1,NULL,'BILLY W  SMITH','FI','459848592','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:34',0,'2014-03-02 05:17:40'),(13060,13416,'2014-01-01','ET','2',1,NULL,'Roselind Semien','FI','434391505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:26',0,'2014-03-02 05:17:40'),(12508,12508,'2014-01-01','ET','2',1,NULL,'matoya sherman','FI','605246750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:40',0,'2014-03-02 05:03:29'),(544,544,'2014-01-01','ET','2',1,NULL,'Emily Finke','FI','283888303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:50',0,'2014-03-01 15:48:04'),(1050,1050,'2014-01-01','ET','2',1,NULL,'Bonnie Godines','FI','466934435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:17',0,'2014-03-01 21:11:04'),(1785,1785,'2014-01-01','ET','2',1,NULL,'Bruce Vanvelzel','FI','274541084','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:08',0,'2014-03-10 13:20:27'),(1807,1807,'2014-01-01','ET','2',1,NULL,'donald j lowe','FI','280543846','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:53',0,'2014-03-10 13:20:27'),(4423,4423,'2014-01-01','ET','2',1,NULL,'jayson tomblin','FI','289745041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:48',0,'2014-03-01 15:05:09'),(4805,4805,'2014-01-01','ET','2',2,1,'Curtis A Lindhal','FI','274485986','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:01',0,'2014-03-01 15:16:37'),(14290,14741,'2014-01-01','ET','2',1,NULL,'Elana Harnish','FI','302909369','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:20',0,'2014-03-01 16:46:19'),(14430,14881,'2014-01-01','ET','2',2,1,'Frances George','FI','433116734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:22',0,'2014-03-02 05:38:34'),(14567,15018,'2014-01-01','ET','2',1,NULL,'DELEISHA EDWARDS','FI','462937713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:29',0,'2014-03-02 05:45:37'),(14620,15071,'2014-01-01','ET','2',1,NULL,'christopher queen','FI','268802185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:02',0,'2014-03-01 16:46:19'),(16258,16907,'0000-00-00','ET','2',1,NULL,'thomas dale','FI','295806321','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:01:18',0,'2014-03-10 16:24:30'),(16274,16924,'0000-00-00','ET','2',1,NULL,'Elmore Robinson','FI','587985941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:07',0,'2014-03-02 06:10:30'),(16367,17017,'0000-00-00','ET','2',1,NULL,'DANNY CASADO','FI','108666320','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:04',0,'2014-03-10 16:24:30'),(16413,17063,'0000-00-00','ET','2',1,NULL,'Michael Kackloudis','FI','278500357','Summa Insurance Company, Inc.','FI','341809108','Joyce  O\'Malley','94','1809941','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:35',0,'2014-03-10 16:24:30'),(16997,17647,'0000-00-00','ET','2',1,NULL,'JULIE POKORNY','FI','638101200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:28',0,'2014-03-02 06:17:30'),(18466,19116,'0000-00-00','ET','2',1,NULL,'Steven Kennedy','FI','425558352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:48',0,'2014-03-02 06:45:14'),(19322,19972,'0000-00-00','ET','2',2,1,'DONNA JEAN MILLNER','FI','465021303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:12',0,'2014-03-02 06:59:07'),(19704,20354,'0000-00-00','ET','2',1,NULL,'Camaree Stevens','FI','269761538','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-04-01','Sync Success',0,'2014-02-20 04:55:46',0,'2014-03-10 14:37:47'),(20549,21199,'0000-00-00','ET','2',1,NULL,'kathleen smith','FI','438907007','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:16',0,'2014-03-02 07:17:36'),(21450,22100,'0000-00-00','ET','2',1,NULL,'PAMELA JONES','FI','288689552','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:19',0,'2014-03-10 16:44:18'),(22430,23080,'0000-00-00','ET','2',1,NULL,'ANITA LOZANO','FI','467279142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:21',0,'2014-03-07 22:26:59'),(5639,5639,'2014-01-01','ET','2',1,NULL,'Amanda Sorenson','FI','247917398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:57',0,'2014-03-02 04:45:37'),(5940,5940,'2014-01-01','ET','2',2,1,'KATRESE BUTLER-GASPER','FI','438557317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:01',0,'2014-03-02 01:10:33'),(5993,5993,'2014-01-01','ET','2',1,NULL,'Jacob Gingerich','FI','308681346','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:48',0,'2014-03-10 13:24:34'),(10848,10848,'2014-01-01','ET','2',1,NULL,'Thomas Welch','FI','297900890','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:26',0,'2014-03-10 13:45:57'),(6357,6357,'2014-01-01','ET','2',1,NULL,'Verkista Pittman','FI','428530129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:06',0,'2014-03-02 04:10:25'),(10529,10529,'2014-01-01','ET','2',1,NULL,'Gary Martin','FI','433765875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:48',0,'2014-03-02 04:24:47'),(14494,14945,'2014-01-01','ET','2',1,NULL,'DARRICK TRUFANT','FI','437753842','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:50',0,'2014-03-02 05:45:37'),(14718,15169,'2014-01-01','ET','2',1,NULL,'Robert  T Johnson','FI','428450531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:07',0,'2014-03-02 05:45:37'),(17574,18224,'0000-00-00','ET','2',1,NULL,'Angela Nichols','FI','293927488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:53',0,'2014-03-01 17:20:55'),(19059,19709,'0000-00-00','ET','2',1,NULL,'BRENDA MAIDEN','FI','436884631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:15',0,'2014-03-02 06:52:12'),(19979,20629,'0000-00-00','ET','2',1,NULL,'Jason Vandriver','FI','451916272','Starmount Life Insurance Company','FI','720977315','justin  leblanc','94','8485121','357','2014-04-01','Sync Success',0,'2014-02-21 22:00:38',0,'2014-03-02 07:03:25'),(20627,21277,'0000-00-00','ET','2',1,NULL,'MOLLY RITTENHOUSE','FI','294824121','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:08',0,'2014-03-10 14:37:47'),(22742,23392,'0000-00-00','ET','2',1,NULL,'Charnell Tademy','FI','439797011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:05',0,'2014-03-09 21:26:00'),(733,733,'2014-01-01','ET','2',2,1,'Joesph Detwiler','FI','284482122','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:51',0,'2014-03-10 13:24:34'),(12398,12398,'2014-01-01','ET','2',1,NULL,'LILLIAN REES','94','0000772654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:37',0,'2014-03-01 16:35:14'),(1032,1032,'2014-01-01','ET','2',1,NULL,'Lesha D Self-Stoehr','FI','307887141','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:16',0,'2014-03-10 13:10:24'),(11257,11257,'2014-01-01','ET','2',1,NULL,'Jeffrey Wilson','FI','302544910','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:11',0,'2014-03-01 16:23:43'),(5085,5085,'2014-01-01','ET','2',1,NULL,'Bonita Oliver','FI','172382719','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:43',0,'2014-03-10 13:20:27'),(5332,5332,'2014-01-01','ET','2',1,NULL,'Katelynn Salyer','FI','540351263','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:14',0,'2014-03-01 15:16:37'),(5812,5812,'2014-01-01','ET','2',1,NULL,'Wade Johnson','FI','288507986','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:57',0,'2014-03-10 15:52:36'),(14050,14501,'2014-01-01','ET','2',1,NULL,'Paula Hays','FI','273762864','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:02',0,'2014-03-01 16:40:16'),(14147,14598,'2014-01-01','ET','2',1,NULL,'EDUARD I  CESTEDES-MONTANO','FI','598544676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:33:06',0,'2014-03-02 05:38:34'),(17749,18399,'0000-00-00','ET','2',1,NULL,'Jeffery Swank','FI','288766718','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-09 19:00:35',0,'2014-03-10 16:24:30'),(18172,18822,'0000-00-00','ET','2',2,1,'dina shah','FI','272868284','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:32',0,'2014-03-01 17:26:36'),(18183,18833,'0000-00-00','ET','2',1,NULL,'Jamie Diehl','FI','283809965','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:40',0,'2014-03-01 17:26:36'),(18551,19201,'0000-00-00','ET','2',1,NULL,'Michael Carnes','FI','310548586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:12',0,'2014-03-01 17:26:36'),(19706,20356,'0000-00-00','ET','2',1,NULL,'JORGE A MATA','FI','460976206','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:56:05',0,'2014-03-10 14:37:47'),(19875,20525,'0000-00-00','ET','2',1,NULL,'Thomas Haas','FI','301527393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:24',0,'2014-03-01 17:47:19'),(22949,23599,'0000-00-00','ET','2',5,4,'Duane Campton','FI','274721698','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:15',0,'2014-03-10 21:17:52'),(1085,1085,'2014-01-01','ET','2',1,NULL,'felicia thornton','FI','285803121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:28',0,'2014-03-01 15:05:09'),(13425,13781,'2014-01-01','ET','2',1,NULL,'Donald Hill','FI','291600768','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:07',0,'2014-03-10 13:59:38'),(11629,11629,'2014-01-01','ET','2',1,NULL,'Kristen Moreo','FI','564592696','HealthSpan','FI','311431434','melinda  ciesielczyk','94','1801499','348','2014-02-01','Sync Success',0,'2013-12-28 03:35:37',0,'2014-03-10 13:52:32'),(3248,3248,'2014-01-01','ET','2',1,NULL,'Sharon Drury','FI','410133427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:48',0,'2014-03-01 15:52:44'),(11187,11187,'2014-01-01','ET','2',1,NULL,'David Stebnicki','FI','307803665','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:03',0,'2014-03-01 16:23:43'),(3775,3775,'2014-01-01','ET','2',1,NULL,'Kathleen Smith','FI','275521635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:31',0,'2014-03-01 15:26:40'),(690,690,'2014-01-01','ET','2',1,NULL,'Deborah Strobel','FI','293524542','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:25',0,'2014-03-10 15:52:36'),(1315,1315,'2014-01-01','ET','2',2,1,'DAMON COOPER','FI','385887486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:17',0,'2014-03-02 04:38:08'),(11361,11361,'2014-01-01','ET','2',1,NULL,'ashley pozos','FI','626564434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:05:23',0,'2014-03-02 04:45:37'),(11356,11356,'2014-01-01','ET','2',1,NULL,'HENRIETTA CALLAHAN','FI','587431431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:14',0,'2014-03-02 04:52:44'),(10579,10579,'2014-01-01','ET','2',2,1,'Samuel Mack','FI','451047317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:31',0,'2014-03-02 04:24:47'),(5189,5189,'2014-01-01','ET','2',1,NULL,'celicia longoria','FI','464731722','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:01',0,'2014-03-02 00:10:48'),(13065,13421,'2014-01-01','ET','2',1,NULL,'CHERYL JARREAU','FI','439089555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:37',0,'2014-03-02 05:17:40'),(13672,14028,'2014-01-01','ET','2',1,NULL,'TERESA JAVIER','FI','733182080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:24',0,'2014-03-02 05:24:45'),(14339,14790,'2014-01-01','ET','2',1,NULL,'Kathy Haikenwaelder','FI','453922818','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:41',0,'2014-03-02 05:38:34'),(14642,15093,'2014-01-01','ET','2',1,NULL,'gail battisti','FI','163445078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:15',0,'2014-03-01 16:46:19'),(15231,15682,'0000-00-00','ET','2',1,NULL,'John Hutchinson','FI','281526306','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:47',0,'2014-03-10 14:10:12'),(15628,16079,'0000-00-00','ET','2',1,NULL,'Ray Saviciunas','FI','279500518','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:49',0,'2014-03-10 16:17:47'),(17867,18517,'0000-00-00','ET','2',1,NULL,'Frank Hull','FI','606033113','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:03',0,'2014-03-10 14:24:38'),(18363,19013,'0000-00-00','ET','2',1,NULL,'ANITA KING','FI','576565759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:35',0,'2014-03-02 06:45:14'),(18981,19631,'0000-00-00','ET','2',1,NULL,'Matthias Helfen','FI','259730111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:01',0,'2014-03-02 06:52:12'),(20172,20822,'0000-00-00','ET','2',1,NULL,'GREGORY L AGEE','FI','282586043','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:10',0,'2014-03-01 18:08:07'),(20414,21064,'0000-00-00','ET','2',1,NULL,'FRANCIS MICHAELS','FI','113588266','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:38',0,'2014-03-01 17:47:19'),(21292,21942,'0000-00-00','ET','2',1,NULL,'Deborah Chavarria','FI','451557870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:59',0,'2014-03-02 07:23:39'),(22230,22880,'0000-00-00','ET','2',1,NULL,'EVA SOTO','FI','462495116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:02',0,'2014-03-06 21:27:26'),(22885,23535,'0000-00-00','ET','2',4,3,'Cynthia Kolar','FI','277605398','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:27',0,'2014-03-10 21:36:25'),(564,564,'2014-01-01','ET','2',2,1,'samuel ferreri','FI','295542687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:30',0,'2014-03-01 15:48:04'),(1098,1098,'2014-01-01','ET','2',1,NULL,'Jamie L Gill','FI','275581563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:57',0,'2014-03-01 15:05:09'),(1398,1398,'2014-01-01','ET','2',1,NULL,'Cynthia HOCHSCHILD','FI','277565967','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:00',0,'2014-03-10 13:52:32'),(11083,11083,'2014-01-01','ET','2',2,1,'Stephen W  Dagg','FI','271505339','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:32',0,'2014-03-10 13:45:57'),(2135,2135,'2014-01-01','ET','2',1,NULL,'Sam Belden','FI','300745773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:58',0,'2014-03-01 15:16:37'),(2361,2361,'2014-01-01','ET','2',2,1,'Kimberly Ash','FI','285669346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:01',0,'2014-03-01 15:26:40'),(3129,3129,'2014-01-01','ET','2',1,NULL,'blanca cardenas','FI','455811024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:05',0,'2014-03-02 01:10:33'),(6102,6102,'2014-01-01','ET','2',1,NULL,'Christopher Sharp','FI','296809803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:25',0,'2014-03-01 16:00:27'),(5907,5907,'2014-01-01','ET','2',1,NULL,'Joseph Abbott','FI','428089861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:00',0,'2014-03-02 02:10:49'),(3586,3586,'2014-01-01','ET','2',1,NULL,'ADELA MORALES','FI','459069946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:56',0,'2014-03-02 01:10:33'),(4194,4194,'2014-01-01','ET','2',1,NULL,'Alice Crumb','FI','272746091','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:05',0,'2014-03-10 15:59:47'),(4160,4160,'2014-01-01','ET','2',1,NULL,'Amal Sliman','FI','298943247','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:00',0,'2014-03-10 15:59:47'),(13662,14018,'2014-01-01','ET','2',1,NULL,'Ernest Eugene Rucker','FI','464251081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:17',0,'2014-03-02 05:24:45'),(13854,14210,'2014-01-01','ET','2',1,NULL,'Obi Dhungana','FI','616693675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:50',0,'2014-03-02 05:31:31'),(16204,16853,'0000-00-00','ET','2',1,NULL,'SHANE JUMONVILLE','FI','435372543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:42',0,'2014-03-02 06:10:30'),(17361,18011,'0000-00-00','ET','2',1,NULL,'June Trinh','FI','299747276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:15',0,'2014-03-02 06:31:45'),(19044,19694,'0000-00-00','ET','2',1,NULL,'Curtis Wayne Williams','FI','460293590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:04',0,'2014-03-02 06:52:12'),(21089,21739,'0000-00-00','ET','2',1,NULL,'Maria Jesus Victoria Jones','FI','643526239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:40',0,'2014-03-02 07:17:36'),(2528,2528,'2014-01-01','ET','2',1,NULL,'Leigh Ann Craig','FI','450310545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:51',0,'2014-03-01 20:10:57'),(3587,3587,'2014-01-01','ET','2',2,1,'LLOYD ASTER LEE','FI','452786337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:57',0,'2014-03-02 01:10:33'),(12439,12439,'2014-01-01','ET','2',2,1,'STELLA M HOWARD','FI','436411932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:06',0,'2014-03-02 05:03:29'),(3662,3662,'2014-01-01','ET','2',1,NULL,'CHRISTY GILMORE','FI','439610310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:17',0,'2014-03-02 00:10:48'),(11961,11961,'2014-01-01','ET','2',1,NULL,'THELMA RATLIFF','FI','438767231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:36',0,'2014-03-02 04:59:36'),(11871,11871,'2014-01-01','ET','2',1,NULL,'francisco candelaria','FI','464951873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:07',0,'2014-03-02 04:59:36'),(7583,7583,'2014-01-01','ET','2',5,4,'Gregory Hinkle','FI','222549096','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:44',0,'2014-03-01 16:05:34'),(11743,11743,'2014-01-01','ET','2',2,1,'Kevin Christlieb','FI','269760980','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:14',0,'2014-03-01 16:30:17'),(4089,4089,'2014-01-01','ET','2',2,1,'PATRICIA ANN BETTS','FI','276665963','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:57',0,'2014-03-01 16:00:27'),(4640,4640,'2014-01-01','ET','2',1,NULL,'Richard Nordin','FI','320525063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:48:34',0,'2014-03-02 04:38:08'),(4681,4681,'2014-01-01','ET','2',1,NULL,'Rebecca Walker','FI','451351455','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:59',0,'2014-03-02 04:31:46'),(7546,7546,'2014-01-01','ET','2',1,NULL,'HERBERT SHARP','FI','287523943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:30',0,'2014-03-01 16:05:34'),(4864,4864,'2014-01-01','ET','2',2,1,'Glenn MacDougall','FI','008426603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:04',0,'2014-03-01 20:10:57'),(13195,13551,'2014-01-01','ET','2',2,1,'JOYCE CLARK','FI','294665074','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:29',0,'2014-03-10 13:59:38'),(16912,17562,'0000-00-00','ET','2',1,NULL,'Peggy Seifert','FI','402887521','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:34',0,'2014-03-01 17:00:58'),(18780,19430,'0000-00-00','ET','2',1,NULL,'JOANNE STOLL','FI','276546792','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:52',0,'2014-03-10 14:31:05'),(19505,20155,'0000-00-00','ET','2',1,NULL,'Robert Parker','FI','289829447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:05:12',0,'2014-03-01 17:34:07'),(19994,20644,'0000-00-00','ET','2',2,1,'JOSHUA BAGLAY','FI','435617953','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:48',0,'2014-03-02 07:03:25'),(20965,21615,'0000-00-00','ET','2',1,NULL,'James Figley','FI','286860148','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:30:16',0,'2014-03-01 18:08:07'),(22094,22744,'0000-00-00','ET','2',1,NULL,'MICHELLE OBALE','FI','432953495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:25',0,'2014-03-06 21:27:26'),(22289,22939,'0000-00-00','ET','2',1,NULL,'LaKitta Marie Mayfield','FI','435675501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:45',0,'2014-03-06 21:27:26'),(339,339,'2014-01-01','ET','2',1,NULL,'Melody  Gayle Wilson','FI','290462183','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:25',0,'2014-03-01 15:21:15'),(1080,1080,'2014-01-01','ET','2',2,1,'Crystal Rae McGee','FI','122720656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:15',0,'2014-03-01 19:11:03'),(5067,5067,'2014-01-01','ET','2',3,2,'RICHARD DREW ABBOTT','FI','261318899','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:09',0,'2014-03-01 15:31:33'),(5112,5112,'2014-01-01','ET','2',4,3,'Duane King','FI','280763757','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:36',0,'2014-03-10 13:20:27'),(10762,10762,'2014-01-01','ET','2',1,NULL,'edna johnson','FI','435944424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:40',0,'2014-03-02 04:24:47'),(5341,5341,'2014-01-01','ET','2',1,NULL,'Jeffery Korn','FI','114466728','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:32',0,'2014-03-01 15:10:22'),(5491,5491,'2014-01-01','ET','2',1,NULL,'Janna Perazzo','FI','297849235','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:07',0,'2014-03-01 16:23:43'),(6262,6262,'2014-01-01','ET','2',2,1,'Sharon Dian Williams','FI','438213396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:16',0,'2014-03-02 04:10:25'),(5682,5682,'2014-01-01','ET','2',1,NULL,'robert burke','FI','206402526','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:32',0,'2014-03-10 13:52:32'),(5538,5538,'2014-01-01','ET','2',1,NULL,'Joseph Thompson','FI','297643202','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:39',0,'2014-03-01 16:23:43'),(13071,13427,'2014-01-01','ET','2',1,NULL,'SHACQUELINE CRAWFORD','FI','437336177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:49',0,'2014-03-02 05:17:40'),(14547,14998,'2014-01-01','ET','2',1,NULL,'ALMA GUTIERREZ','FI','457812211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:16',0,'2014-03-02 05:45:37'),(14571,15022,'2014-01-01','ET','2',1,NULL,'Arthur  Joe  Hayes','FI','450153041','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:31',0,'2014-03-02 05:45:37'),(16608,17258,'0000-00-00','ET','2',1,NULL,'derek kennedy','FI','636164222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:12',0,'2014-03-02 06:17:30'),(18373,19023,'0000-00-00','ET','2',1,NULL,'LARRY WHITE','FI','458917604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:42',0,'2014-03-02 06:45:14'),(18766,19416,'0000-00-00','ET','2',1,NULL,'Juanita Lucke','FI','377564949','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:41',0,'2014-03-10 14:31:05'),(22307,22957,'0000-00-00','ET','2',1,NULL,'Folger Ollie','FI','426027952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:03',0,'2014-03-06 22:25:29'),(783,783,'2014-01-01','ET','2',1,NULL,'Sharon Pickrel','FI','578843659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:33',0,'2014-03-01 15:05:09'),(12786,12786,'2014-01-01','ET','2',1,NULL,'Bryant Fuentes','FI','461795466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:45',0,'2014-03-02 05:10:52'),(1108,1108,'2014-01-01','ET','2',1,NULL,'Zachary Exley','FI','183745759','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:21',0,'2014-03-10 13:03:33'),(2204,2204,'2014-01-01','ET','2',2,1,'Tommy E Corley','FI','437788326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:19',0,'2014-03-01 21:11:04'),(6401,6401,'2014-01-01','ET','2',1,NULL,'Sean Smith','FI','271764361','HealthSpan','FI','311431434','Anthony  Moore','94','1923821','357','2014-01-01','Sync Success',0,'2013-12-26 03:10:30',0,'2014-03-10 13:39:10'),(2889,2889,'2014-01-01','ET','2',4,3,'Alan Haven','FI','275706108','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Pietrowski','94','1636529','348','2014-01-01','Sync Success',0,'2013-12-25 21:23:19',0,'2014-03-10 15:59:47'),(14240,14691,'2014-01-01','ET','2',2,1,'LOYD DAVIS','FI','424880237','Starmount Life Insurance Company','FI','720977315','TAT  RILEY','94','6399188','348','2014-02-01','Sync Success',0,'2014-01-15 02:05:57',0,'2014-03-02 05:38:34'),(15457,15908,'0000-00-00','ET','2',1,NULL,'DENISE KIPKER','FI','286520415','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:47',0,'2014-03-01 16:50:53'),(15993,16642,'0000-00-00','ET','2',1,NULL,'Quinet Ginyard','94','0000831567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:06',0,'2014-03-02 06:03:21'),(16610,17260,'0000-00-00','ET','2',2,1,'Carol Trauthwein','FI','386609802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:13',0,'2014-03-02 06:17:30'),(18733,19383,'0000-00-00','ET','2',1,NULL,'mattie m lawson','FI','428271958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:17',0,'2014-03-02 06:52:12'),(18837,19487,'0000-00-00','ET','2',1,NULL,'Gary Boyd','FI','454152734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:17',0,'2014-03-02 06:52:12'),(21629,22279,'0000-00-00','ET','2',1,NULL,'Dora H Roman','FI','451856335','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:43',0,'2014-03-04 21:27:16'),(22567,23217,'0000-00-00','ET','2',1,NULL,'jessica landrum','FI','301840420','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-22','Sync Success',0,'2014-03-07 21:31:58',0,'2014-03-10 14:50:59'),(22748,23398,'0000-00-00','ET','2',1,NULL,'JENNIFER CARATTINI','FI','596389452','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:10',0,'2014-03-09 21:26:00'),(376,376,'2014-01-01','ET','2',1,NULL,'Melissa Myerson','FI','284880210','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:37',0,'2014-03-10 15:45:56'),(11997,11997,'2014-01-01','ET','2',2,1,'NORA A STADLER','FI','287481123','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:56',0,'2014-03-10 16:10:34'),(1238,1238,'2014-01-01','ET','2',1,NULL,'Christina Bucci','FI','294922776','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:52',0,'2014-03-01 16:15:39'),(11503,11503,'2014-01-01','ET','2',1,NULL,'Joan M Voisine-Allen','FI','525213462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:45',0,'2014-03-02 04:52:44'),(11042,11042,'2014-01-01','ET','2',1,NULL,'JACQUELINE BONARRIGO','FI','273501817','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:12',0,'2014-03-10 16:03:49'),(1920,1920,'2014-01-01','ET','2',1,NULL,'Robert Willett','FI','457067755','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-25 19:32:20',0,'2014-03-02 00:10:48'),(7357,7357,'2014-01-01','ET','2',1,NULL,'Louella M Stover','FI','292567127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:43',0,'2014-03-01 15:16:37'),(3544,3544,'2014-01-01','ET','2',3,2,'Edward Gerard Warren','FI','289620801','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:35',0,'2014-03-01 15:37:30'),(4959,4959,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:10',0,'2014-03-01 15:05:09'),(5826,5826,'2014-01-01','ET','2',1,NULL,'EARL RAY THOMPSON','FI','368766275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:16',0,'2014-03-01 21:11:04'),(5319,5319,'2014-01-01','ET','2',1,NULL,'Deirdre Watkins','FI','426490340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:10',0,'2014-03-01 19:11:03'),(15922,16571,'0000-00-00','ET','2',1,NULL,'Rosalina Alvarado','FI','460996260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-25 19:00:06',0,'2014-03-02 06:03:21'),(19108,19758,'0000-00-00','ET','2',1,NULL,'NICOLE BLOM','FI','290865762','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:49',0,'2014-03-10 14:31:05'),(20054,20704,'0000-00-00','ET','2',1,NULL,'Asmaa Abdelaziz Hernandez','FI','634250912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:00:14',0,'2014-03-02 07:10:28'),(20299,20949,'0000-00-00','ET','2',1,NULL,'Rebecca Alcala','FI','436732230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:41',0,'2014-03-02 07:10:28'),(22462,23112,'0000-00-00','ET','2',4,3,'Nicole Lantz','FI','291825219','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:44',0,'2014-03-10 16:44:18'),(1012,1012,'2014-01-01','ET','2',1,NULL,'Kyndal Sutton','FI','292828432','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:38',0,'2014-03-10 15:39:19'),(1976,1976,'2014-01-01','ET','2',1,NULL,'Pamela Weihrauch','FI','291508296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:01',0,'2014-03-01 15:26:40'),(13199,13555,'2014-01-01','ET','2',1,NULL,'Cheryl Annette Givens','FI','269661277','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:43',0,'2014-03-10 13:59:38'),(3308,3308,'2014-01-01','ET','2',1,NULL,'Jennifer Taylor','94','0001069309','Dental Care Plus, Inc.','FI','311185262','Tiffany  Geiger','94','3241172','348','2014-01-01','Sync Success',0,'2013-12-25 21:48:44',0,'2014-03-01 15:52:44'),(5658,5658,'2014-01-01','ET','2',1,NULL,'Karen Arvin','FI','296589469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:35',0,'2014-03-10 13:52:32'),(11137,11137,'2014-01-01','ET','2',1,NULL,'David L Davis','FI','279567349','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:29',0,'2014-03-10 13:45:57'),(11811,11811,'2014-01-01','ET','2',1,NULL,'Therese Litt','FI','297448073','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:24',0,'2014-03-01 16:15:39'),(16062,16711,'0000-00-00','ET','2',1,NULL,'AMY ELIZABETH FLECK','FI','268644674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:50',0,'2014-03-01 16:56:22'),(17279,17929,'0000-00-00','ET','2',1,NULL,'Taya Miller','FI','634128111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:44',0,'2014-03-02 06:24:38'),(17453,18103,'0000-00-00','ET','2',4,3,'ERNEST SETON','FI','275042935','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:18',0,'2014-03-01 17:20:55'),(18392,19042,'0000-00-00','ET','2',1,NULL,'Jessica Sheppard','FI','589826543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:55',0,'2014-03-02 06:45:14'),(18598,19248,'0000-00-00','ET','2',1,NULL,'Jamaal Kelly','FI','274784022','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:32',0,'2014-03-01 17:26:36'),(19317,19967,'0000-00-00','ET','2',1,NULL,'virginia Contreras','FI','641289940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-18 22:00:09',0,'2014-03-02 06:59:07'),(19821,20471,'0000-00-00','ET','2',1,NULL,'TALISHA LAMBERT','FI','456956073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:40',0,'2014-03-02 07:03:25'),(19913,20563,'0000-00-00','ET','2',1,NULL,'rosa r rayos','FI','452949664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:12',0,'2014-03-02 07:03:25'),(20694,21344,'0000-00-00','ET','2',1,NULL,'CANDIDO EMILIO RAMIREZ','FI','596207323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:09',0,'2014-03-02 07:17:36'),(1452,1452,'2014-01-01','ET','2',1,NULL,'JULIE SIGNER','FI','291648501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:47',0,'2014-03-01 16:15:39'),(12303,12303,'2014-01-01','ET','2',1,NULL,'Scott Keethler','FI','284808632','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:23',0,'2014-03-10 13:59:38'),(12189,12189,'2014-01-01','ET','2',1,NULL,'Allen Coovert','FI','270542498','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:56',0,'2014-03-10 13:52:32'),(3405,3405,'2014-01-01','ET','2',1,NULL,'greg hawkins','FI','280780271','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:49',0,'2014-03-10 13:32:15'),(4806,4806,'2014-01-01','ET','2',1,NULL,'George Williamson','FI','204385228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:03',0,'2014-03-01 15:16:37'),(7580,7580,'2014-01-01','ET','2',5,4,'Ashish Pushkaran','FI','275065032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:36',0,'2014-03-01 16:05:34'),(16687,17337,'0000-00-00','ET','2',1,NULL,'JAMES WILCOX','FI','285427015','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:07',0,'2014-03-10 14:20:26'),(16774,17424,'0000-00-00','ET','2',6,5,'Sameer Shannawi','FI','603581086','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:24',0,'2014-03-01 17:00:58'),(17149,17799,'0000-00-00','ET','2',1,NULL,'Kathryn Lommler','FI','299584951','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:32',0,'2014-03-10 16:24:30'),(18334,18984,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:16',0,'2014-03-01 17:26:36'),(19932,20582,'0000-00-00','ET','2',1,NULL,'Kathleen Masters','FI','274568745','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:24',0,'2014-03-10 14:37:47'),(19947,20597,'0000-00-00','ET','2',1,NULL,'ALICE SPARKS','FI','461922207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:13',0,'2014-03-02 07:03:25'),(20386,21036,'0000-00-00','ET','2',1,NULL,'guillermo rivera','FI','454435293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:15',0,'2014-03-02 07:03:25'),(20813,21463,'0000-00-00','ET','2',1,NULL,'HELEN KRENEK','FI','457963974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:31:05',0,'2014-03-02 07:17:36'),(22180,22830,'0000-00-00','ET','2',1,NULL,'JOHN ZAWISTOWSKI','FI','277466950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:25',0,'2014-03-06 21:36:23'),(22270,22920,'0000-00-00','ET','2',2,1,'Rajwinder Kaur','FI','272041215','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:31',0,'2014-03-10 14:50:59'),(22630,23280,'0000-00-00','ET','2',1,NULL,'Fredia Messer','FI','235822874','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:05',0,'2014-03-08 21:35:36'),(23014,23664,'0000-00-00','ET','2',1,NULL,'LINDA L WARD','FI','426111555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:01',0,'2014-03-10 21:27:11'),(2,2,'2014-01-01','ET','2',1,NULL,'Gary Fletcher','FI','283522272','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:04',0,'2014-03-01 15:21:15'),(3019,3019,'2014-01-01','ET','2',1,NULL,'Benjamin Starcher','FI','287749582','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:42',0,'2014-03-10 15:52:36'),(3350,3350,'2014-01-01','ET','2',1,NULL,'Theresa Louise Pittard','FI','013527796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:50:11',0,'2014-03-02 02:10:49'),(11922,11922,'2014-01-01','ET','2',1,NULL,'PAUL KERR','FI','302861873','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:40',0,'2014-03-01 16:30:17'),(3446,3446,'2014-01-01','ET','2',1,NULL,'Justin Arisman','FI','565671593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:12',0,'2014-03-10 13:32:15'),(7141,7141,'2014-01-01','ET','2',2,1,'Harold Wiant','FI','278521064','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:49',0,'2014-03-10 15:59:47'),(4332,4332,'2014-01-01','ET','2',1,NULL,'Erin Richardson','FI','298942950','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:12',0,'2014-03-10 13:32:15'),(5870,5870,'2014-01-01','ET','2',1,NULL,'Patricia Ivory','FI','282881117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:55',0,'2014-03-01 15:05:09'),(4738,4738,'2014-01-01','ET','2',1,NULL,'ELIZABETH BLAKE','FI','300748936','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:04',0,'2014-03-10 13:45:57'),(15949,16598,'0000-00-00','ET','2',2,1,'prakashsinh parmar','FI','406694050','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:20',0,'2014-03-10 14:10:12'),(15999,16648,'0000-00-00','ET','2',1,NULL,'NATASHA CARR','FI','643012886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:10',0,'2014-03-02 06:03:21'),(16646,17296,'0000-00-00','ET','2',1,NULL,'Gaye carmen Ictech','FI','434578346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-31 21:00:39',0,'2014-03-02 06:17:30'),(19357,20007,'0000-00-00','ET','2',1,NULL,'Mary Faciane','FI','436906536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:38',0,'2014-03-02 06:59:07'),(19798,20448,'0000-00-00','ET','2',1,NULL,'Valerie Richard','FI','438372214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:21',0,'2014-03-02 07:03:25'),(20146,20796,'0000-00-00','ET','2',4,3,'Jayma Mohr','FI','269704840','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:52',0,'2014-03-10 16:38:05'),(20863,21513,'0000-00-00','ET','2',1,NULL,'Richard Lanum','FI','298701443','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:27',0,'2014-03-10 14:37:47'),(809,809,'2014-01-01','ET','2',1,NULL,'Michael Perdue','FI','297508418','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:33',0,'2014-03-10 13:03:33'),(886,886,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:16:45',0,'2014-03-01 15:21:15'),(13246,13602,'2014-01-01','ET','2',1,NULL,'Nichelle Carter','FI','437154596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:55',0,'2014-03-02 05:17:40'),(12137,12137,'2014-01-01','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:07:01',0,'2014-03-10 13:52:32'),(6245,6245,'2014-01-01','ET','2',2,1,'David Luedeke','FI','289583677','HealthSpan','FI','311431434','Amy  Sheaks','94','15838390','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:45',0,'2014-03-10 13:39:10'),(5508,5508,'2014-01-01','ET','2',1,NULL,'carol penrod','FI','302584996','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:42',0,'2014-03-01 16:23:43'),(1198,1198,'2014-01-01','ET','2',1,NULL,'BETTY  MORRIS','FI','437024238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:43',0,'2014-03-02 04:45:37'),(5226,5226,'2014-01-01','ET','2',2,1,'karim Abed HAMID','FI','495803304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:16',0,'2014-03-02 00:10:48'),(2026,2026,'2014-01-01','ET','2',1,NULL,'sharon young','FI','269463749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:41',0,'2014-03-01 23:10:52'),(14808,15259,'2014-01-01','ET','2',2,1,'Joseph Purcell','FI','302664793','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Harkleroad','94','1772711','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:03',0,'2014-03-10 16:17:47'),(15135,15586,'0000-00-00','ET','2',1,NULL,'Christopher Savage','FI','436833627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:06:17',0,'2014-03-02 05:52:31'),(16040,16689,'0000-00-00','ET','2',1,NULL,'Monique Martin','FI','438351398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:36',0,'2014-03-02 06:03:21'),(16819,17469,'0000-00-00','ET','2',1,NULL,'Maria Guadalupe Perez','94','0000184863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:05',0,'2014-03-02 06:17:30'),(17490,18140,'0000-00-00','ET','2',1,NULL,'SUSAN MOON','FI','298426048','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:47',0,'2014-03-10 14:24:38'),(19449,20099,'0000-00-00','ET','2',2,1,'randy farwell','FI','373642861','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:45',0,'2014-03-10 14:37:47'),(19676,20326,'0000-00-00','ET','2',5,4,'Deanna Nowland','FI','301605166','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-20 04:49:30',0,'2014-03-10 14:37:47'),(21832,22482,'0000-00-00','ET','2',1,NULL,'KATHI R JOHNSON','FI','278605483','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:25',0,'2014-03-05 21:36:22'),(849,849,'2014-01-01','ET','2',1,NULL,'Jeffrey Lambert','FI','466941035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:37',0,'2014-03-01 22:10:55'),(2044,2044,'2014-01-01','ET','2',1,NULL,'Sarah Busack','FI','278943666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:14',0,'2014-03-10 13:20:27'),(3132,3132,'2014-01-01','ET','2',1,NULL,'Michael Hernandez','FI','456373293','Starmount Life Insurance Company','FI','720977315','Charles  Falgout','94','1074547','348','2014-01-01','Sync Success',0,'2013-12-25 21:37:11',0,'2014-03-02 01:10:33'),(13121,13477,'2014-01-01','ET','2',1,NULL,'JANE HARRIS','FI','463411760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:48',0,'2014-03-02 05:17:40'),(13094,13450,'2014-01-01','ET','2',1,NULL,'Lakeisha Monque Hill','FI','426433032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:47',0,'2014-03-02 05:17:40'),(6400,6400,'2014-01-01','ET','2',1,NULL,'Georgia Romer','FI','292664114','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:28',0,'2014-03-10 13:39:10'),(11151,11151,'2014-01-01','ET','2',2,1,'Robert Klinger','FI','276906575','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:56',0,'2014-03-10 13:45:57'),(11468,11468,'2014-01-01','ET','2',1,NULL,'Scott Johnson','FI','284801104','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:41',0,'2014-03-01 16:30:17'),(14168,14619,'2014-01-01','ET','2',1,NULL,'ellen sands','FI','273448558','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:33:19',0,'2014-03-10 16:17:47'),(14893,15344,'2014-01-01','ET','2',1,NULL,'Lindsay Landry','FI','642057594','Starmount Life Insurance Company','FI','720977315','Adam  Brown','94','9185603500','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:20',0,'2014-03-02 05:45:37'),(15953,16602,'0000-00-00','ET','2',5,4,'Jaclyn Pieffer','FI','302866687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:04',0,'2014-03-01 16:56:22'),(16339,16989,'0000-00-00','ET','2',1,NULL,'elizabeth hunter','FI','279783754','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:47',0,'2014-03-01 16:56:22'),(17122,17772,'0000-00-00','ET','2',1,NULL,'Nancy Kopp','FI','300501249','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:13',0,'2014-03-10 14:20:26'),(19298,19948,'0000-00-00','ET','2',1,NULL,'TAMARA  TRAPNELL','FI','301549318','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:17',0,'2014-03-10 14:37:47'),(20285,20935,'0000-00-00','ET','2',1,NULL,'Diedra Skye Smith','FI','269968134','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:29',0,'2014-03-10 14:37:47'),(20296,20946,'0000-00-00','ET','2',1,NULL,'Thomas R Legan','FI','274488743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:39',0,'2014-03-01 18:08:07'),(21889,22539,'0000-00-00','ET','2',2,1,'JOSE UBERTO BONDONI','FI','027084062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:35',0,'2014-03-05 22:27:33'),(22355,23005,'0000-00-00','ET','2',1,NULL,'CYNTHIA PHILBRICK','FI','295623227','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:14',0,'2014-03-07 21:36:32'),(22968,23618,'0000-00-00','ET','2',1,NULL,'Darren Morrison','FI','297922609','Dental Care Plus, Inc.','FI','311185262','Adam  Cupp','94','8331078','357','2014-03-31','Sync Success',0,'2014-03-10 21:01:29',0,'2014-03-10 21:36:25'),(996,996,'2014-01-01','ET','2',2,1,'LINDA DARLENE DOGGETT','FI','277524971','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:07',0,'2014-03-10 13:10:24'),(12501,12501,'2014-01-01','ET','2',3,2,'Steven Ferrand','FI','436314790','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:24',0,'2014-03-02 05:03:29'),(2202,2202,'2014-01-01','ET','2',1,NULL,'CHERRY ANN DAVENPORT','FI','437745189','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:15',0,'2014-03-01 21:11:04'),(13706,14062,'2014-01-01','ET','2',2,1,'nathan manning','FI','284709491','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:44',0,'2014-03-01 16:40:16'),(12936,12936,'2014-01-01','ET','2',1,NULL,'Tony Hoskins','FI','283669347','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-02-01','Sync Success',0,'2014-01-04 02:06:21',0,'2014-03-10 13:59:38'),(2725,2725,'2014-01-01','ET','2',1,NULL,'Domingo Elias-Soto','FI','584634765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:59',0,'2014-03-02 04:15:49'),(3097,3097,'2014-01-01','ET','2',1,NULL,'virginia stevens','FI','439965434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:07',0,'2014-03-02 01:10:33'),(10596,10596,'2014-01-01','ET','2',1,NULL,'Prima Mosi','FI','573850068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:03',0,'2014-03-02 04:24:47'),(4197,4197,'2014-01-01','ET','2',1,NULL,'MICHELLE L BAILEY','FI','276920833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:10',0,'2014-03-10 13:32:15'),(7745,7745,'2014-01-01','ET','2',2,1,'Mark D Prout','FI','300723028','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-01-01','Received',0,'2013-12-26 05:00:41',NULL,NULL),(7413,7413,'2014-01-01','ET','2',1,NULL,'Kimberly Mendez','FI','429410543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:17',0,'2014-03-02 04:10:25'),(7194,7194,'2014-01-01','ET','2',1,NULL,'John S Moye','FI','304629147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:28',0,'2014-03-02 03:09:49'),(5881,5881,'2014-01-01','ET','2',1,NULL,'Helen Deiters','FI','233906470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:30:09',0,'2014-03-10 15:52:36'),(14864,15315,'2014-01-01','ET','2',1,NULL,'Eloisa Mireles','FI','454969290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:08',0,'2014-03-02 05:52:31'),(15627,16078,'0000-00-00','ET','2',2,1,'James Ethridge','FI','284603932','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:49',0,'2014-03-10 16:17:47'),(15816,16465,'0000-00-00','ET','2',1,NULL,'Gayle D Kline','FI','454115884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:20',0,'2014-03-02 06:03:21'),(16026,16675,'0000-00-00','ET','2',1,NULL,'Lenard DAVIS','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:27',0,'2014-03-02 06:03:21'),(16523,17173,'0000-00-00','ET','2',1,NULL,'MARY REED','FI','425193748','Starmount Life Insurance Company','FI','720977315','TAMM W BURNS','94','16995809','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:52',0,'2014-03-02 06:10:30'),(16750,17400,'0000-00-00','ET','2',1,NULL,'CECILIA G RUIZ','FI','629381321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:09',0,'2014-03-02 06:17:30'),(18323,18973,'0000-00-00','ET','2',2,1,'Rae Wilson','FI','295865039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:08',0,'2014-03-01 17:26:36'),(20333,20983,'0000-00-00','ET','2',1,NULL,'JEREMY THOMPSON','FI','298865478','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:22',0,'2014-03-01 17:47:19'),(20620,21270,'0000-00-00','ET','2',1,NULL,'DOUGLAS ALBERTO FIGEROA','FI','433974980','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:02',0,'2014-03-02 07:10:28'),(21684,22334,'0000-00-00','ET','2',1,NULL,'MARY LEE LOVE','FI','426195337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:25',0,'2014-03-04 21:27:16'),(22985,23635,'0000-00-00','ET','2',4,3,'RICHARD MITCHELL','FI','290607480','Dental Care Plus, Inc.','FI','311185262','RICHARD  KNAPAE','94','15937801','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:40',0,'2014-03-10 21:36:25'),(405,405,'2014-01-01','ET','2',1,NULL,'Richard Fickling','FI','231319593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:32',0,'2014-03-01 22:10:55'),(13605,13961,'2014-01-01','ET','2',2,1,'Brian James','FI','295766607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:28',0,'2014-03-01 16:40:16'),(1534,1534,'2014-01-01','ET','2',1,NULL,'Kalin Smith','FI','292908550','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:28',0,'2014-03-10 13:45:57'),(3302,3302,'2014-01-01','ET','2',1,NULL,'JOYCE DOANE','FI','289465272','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:32',0,'2014-03-01 15:52:44'),(13239,13595,'2014-01-01','ET','2',1,NULL,'Patricia Mitchell','94','0001284858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:39',0,'2014-03-02 05:17:40'),(12822,12822,'2014-01-01','ET','2',1,NULL,'Linda Wilson','FI','434866898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:04',0,'2014-03-02 05:10:52'),(12399,12399,'2014-01-01','ET','2',4,3,'DREW DEVORE','FI','272902005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:38',0,'2014-03-01 16:35:14'),(11513,11513,'2014-01-01','ET','2',1,NULL,'Reginald Thomas Rivers','FI','439172394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:03',0,'2014-03-02 04:52:44'),(6389,6389,'2014-01-01','ET','2',1,NULL,'Megan Stangelo','FI','291808836','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:07',0,'2014-03-10 13:39:10'),(5749,5749,'2014-01-01','ET','2',1,NULL,'Virginia Bradstreet','FI','435948973','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-26 02:01:51',0,'2014-03-02 01:10:33'),(5346,5346,'2014-01-01','ET','2',1,NULL,'Barbara Ferrell','FI','294728924','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:43',0,'2014-03-10 15:39:19'),(15805,16454,'0000-00-00','ET','2',1,NULL,'Ramon Magallanes','FI','464199571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:14',0,'2014-03-02 06:03:21'),(13049,13405,'2014-01-01','ET','2',2,1,'ELAINE  HUDSON','FI','347549105','Starmount Life Insurance Company','FI','720977315','JACK   HOPKINS','94','2811453','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:04',0,'2014-03-02 05:17:40'),(12499,12499,'2014-01-01','ET','2',1,NULL,'naicole robinson','FI','438696496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:19',0,'2014-03-02 05:03:29'),(11084,11084,'2014-01-01','ET','2',2,1,'lawrence wilson','FI','284666629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:35',0,'2014-03-10 13:39:10'),(6419,6419,'2014-01-01','ET','2',2,1,'Marcie K McKay','FI','435612988','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:06',0,'2014-03-01 20:10:57'),(5302,5302,'2014-01-01','ET','2',5,4,'Boyd Palmer','FI','213211293','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:30',0,'2014-03-01 15:05:09'),(1294,1294,'2014-01-01','ET','2',1,NULL,'Timothy Benoit','FI','587867773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:36',0,'2014-03-02 04:38:08'),(13328,13684,'2014-01-01','ET','2',1,NULL,'RONALD H DOANE','FI','433131365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:23',0,'2014-03-02 05:24:45'),(14411,14862,'2014-01-01','ET','2',2,1,'CRYSTAL A GRAY','FI','291600883','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:11',0,'2014-03-10 14:03:26'),(15638,16089,'0000-00-00','ET','2',1,NULL,'JOAN DAY','FI','289526023','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:54',0,'2014-03-10 14:10:12'),(15911,16560,'0000-00-00','ET','2',1,NULL,'Mary Rohrer','FI','316705874','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:19',0,'2014-03-10 14:10:12'),(16085,16734,'0000-00-00','ET','2',1,NULL,'NICKOLAS POWELL','FI','118662583','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:06',0,'2014-03-01 16:56:22'),(18405,19055,'0000-00-00','ET','2',4,3,'John Stahl','FI','295807297','Dental Care Plus, Inc.','FI','311185262','Jeff  Markovic','94','2775844','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:05',0,'2014-03-01 17:26:36'),(19329,19979,'0000-00-00','ET','2',1,NULL,'Angelina Perez','FI','451815279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:18',0,'2014-03-02 06:59:07'),(21778,22428,'0000-00-00','ET','2',1,NULL,'Monica Tusing','FI','287528095','HealthSpan','FI','311431434','Catalina  Archuleta','94','15141057','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:44',0,'2014-03-10 14:45:25'),(22780,23430,'0000-00-00','ET','2',1,NULL,'Katrina Whitehead','FI','302868664','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:33',0,'2014-03-09 21:35:27'),(309,309,'2014-01-01','ET','2',2,1,'Phillip Thomas Fairbrother','FI','605303892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:28',0,'2014-03-01 22:10:55'),(632,632,'2014-01-01','ET','2',1,NULL,'Carl Chapin','FI','458253694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:40',0,'2014-03-02 02:10:49'),(736,736,'2014-01-01','ET','2',1,NULL,'Presley Sophia Surharski','FI','271133119','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:57',0,'2014-03-10 13:24:34'),(6128,6128,'2014-01-01','ET','2',1,NULL,'Kyle Nichol','FI','291763723','Dental Care Plus, Inc.','FI','311185262','Mike  Kost','94','1924114','348','2014-01-01','Sync Success',0,'2013-12-26 03:02:11',0,'2014-03-01 16:00:27'),(4749,4749,'2014-01-01','ET','2',1,NULL,'major joubert','FI','438794175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:15',0,'2014-03-01 21:11:04'),(4740,4740,'2014-01-01','ET','2',1,NULL,'STEVEN ALAN SELKA','FI','287528520','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:52:08',0,'2014-03-10 13:45:57'),(1371,1371,'2014-01-01','ET','2',1,NULL,'Dean Allam','FI','460217300','Starmount Life Insurance Company','FI','720977315','Jason  Farro','94','6998749','348','2014-01-01','Sync Success',0,'2013-12-25 18:53:04',0,'2014-03-02 04:38:08'),(4696,4696,'2014-01-01','ET','2',1,NULL,'Paris Michael Augustine','FI','434319675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:31',0,'2014-03-02 04:31:46'),(4600,4600,'2014-01-01','ET','2',1,NULL,'Nancy Lange','FI','283486985','Dental Care Plus, Inc.','FI','311185262','Joshua  Moeddel','94','3237101','348','2014-01-01','Sync Success',0,'2013-12-25 23:47:17',0,'2014-03-01 16:15:39'),(3548,3548,'2014-01-01','ET','2',1,NULL,'Susan Burgwald','FI','277527805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:43',0,'2014-03-01 15:37:30'),(3265,3265,'2014-01-01','ET','2',2,1,'Kathryn Humphrey','FI','283725360','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:20',0,'2014-03-10 13:24:34'),(2547,2547,'2014-01-01','ET','2',2,1,'Debby McHale-Taylor','FI','288425241','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:26',0,'2014-03-01 15:10:22'),(2367,2367,'2014-01-01','ET','2',1,NULL,'DONA ATZBACH','FI','280480977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:15',0,'2014-03-01 15:26:40'),(2011,2011,'2014-01-01','ET','2',1,NULL,'Adam Bourgeois','FI','433771925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:13',0,'2014-03-01 23:10:52'),(1954,1954,'2014-01-01','ET','2',1,NULL,'Kimberly Mindling','FI','563477498','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:21',0,'2014-03-01 15:26:40'),(1757,1757,'2014-01-01','ET','2',1,NULL,'Felicia Acton','FI','275828509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:11',0,'2014-03-01 15:31:33'),(15126,15577,'0000-00-00','ET','2',1,NULL,'Xander Bertison','FI','272925028','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:09',0,'2014-03-10 16:17:47'),(16944,17594,'0000-00-00','ET','2',1,NULL,'Nhai Nguyen','FI','586507721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:55',0,'2014-03-02 06:17:30'),(16952,17602,'0000-00-00','ET','2',2,1,'LAWRENCE DIKE','FI','663149006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:00',0,'2014-03-02 06:17:30'),(17010,17660,'0000-00-00','ET','2',4,3,'Analiesse Dacruz','FI','437915804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:04',0,'2014-03-02 06:24:38'),(17781,18431,'0000-00-00','ET','2',1,NULL,'adan Garcia','FI','451438283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:17',0,'2014-03-02 05:59:43'),(21276,21926,'0000-00-00','ET','2',1,NULL,'Eddie C Byers','FI','433965101','Starmount Life Insurance Company','FI','720977315','Daniel L Smith','94','9433528','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:47',0,'2014-03-02 07:23:39'),(21930,22580,'0000-00-00','ET','2',2,1,'JAIME GARCIA','FI','525040905','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:04',0,'2014-03-05 22:27:33'),(19245,19895,'0000-00-00','ET','2',1,NULL,'stacy hathcox','FI','428115613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:35',0,'2014-03-02 06:52:12'),(97,97,'2014-01-01','ET','2',2,1,'bill le','FI','586425269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:56',0,'2014-03-01 22:10:55'),(13001,13001,'2014-01-01','ET','2',1,NULL,'TAMI THOMAS','FI','288585680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:09',0,'2014-03-02 05:17:40'),(12980,12980,'2014-01-01','ET','2',1,NULL,'Maya Jackson','FI','570917282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:26',0,'2014-03-02 05:17:40'),(3678,3678,'2014-01-01','ET','2',1,NULL,'Amy Giust','FI','274540685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:47',0,'2014-03-02 00:10:48'),(11332,11332,'2014-01-01','ET','2',1,NULL,'Paula Rubio Gonzalez','FI','636262834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:29',0,'2014-03-02 04:52:44'),(10721,10721,'2014-01-01','ET','2',2,1,'Charles Campbell','FI','275607252','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:18',0,'2014-03-01 16:10:36'),(3738,3738,'2014-01-01','ET','2',1,NULL,'NICOLE MOLONEY','FI','276742394','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:08:49',0,'2014-03-10 13:24:34'),(5789,5789,'2014-01-01','ET','2',2,1,'Helen Deiters','FI','233906470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:12',0,'2014-03-10 15:52:36'),(5055,5055,'2014-01-01','ET','2',1,NULL,'MARY ANN RUTLEDGE','FI','273546368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:47',0,'2014-03-01 15:31:33'),(4490,4490,'2014-01-01','ET','2',1,NULL,'Kim Crawford','FI','292604006','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-01-01','Sync Success',0,'2013-12-25 23:31:43',0,'2014-03-10 15:39:19'),(13428,13784,'2014-01-01','ET','2',1,NULL,'Keith Anthony Genis','FI','296887242','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:08',0,'2014-03-10 16:10:34'),(16086,16735,'0000-00-00','ET','2',1,NULL,'Timothy Mark Skidmore','FI','288522421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:07',0,'2014-03-01 16:56:22'),(16129,16778,'0000-00-00','ET','2',2,1,'MARGARET MURDOCK ABBOTT','FI','298580905','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:40',0,'2014-03-10 14:20:26'),(18656,19306,'0000-00-00','ET','2',1,NULL,'NORMA JANES','FI','765235242','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:18',0,'2014-03-02 06:45:14'),(19043,19693,'0000-00-00','ET','2',1,NULL,'Ashley Kemper','FI','356824703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:03',0,'2014-03-02 06:52:12'),(20387,21037,'0000-00-00','ET','2',1,NULL,'MELINDA AGATEP','FI','635943050','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-04-01','Received',0,'2014-02-26 09:30:16',NULL,NULL),(20904,21554,'0000-00-00','ET','2',2,1,'tina howard','FI','268821628','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:47',0,'2014-03-10 14:45:25'),(21554,22204,'0000-00-00','ET','2',1,NULL,'GENISA HUGHES','FI','426717680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:35',0,'2014-03-03 22:26:43'),(21601,22251,'0000-00-00','ET','2',2,1,'MAYRA HAYDEE VALDEZ-ESPINOZA','FI','729286173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:20',0,'2014-03-04 21:27:16'),(1491,1491,'2014-01-01','ET','2',1,NULL,'WILLIAM CALVIN SCHAUFELE','FI','288485613','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:06',0,'2014-03-10 16:03:49'),(2197,2197,'2014-01-01','ET','2',2,1,'Jessica Amanda Toups','FI','433512457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:04',0,'2014-03-01 21:11:04'),(12565,12565,'2014-01-01','ET','2',1,NULL,'RICHARD E CRAIG','FI','270489479','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:55',0,'2014-03-10 13:59:38'),(12467,12467,'2014-01-01','ET','2',1,NULL,'RICHARD L GIBSON','FI','271564305','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:09',0,'2014-03-01 16:30:17'),(12056,12056,'2014-01-01','ET','2',1,NULL,'TERESITA BERNAL','FI','457118552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:13',0,'2014-03-02 04:59:36'),(13265,13621,'2014-01-01','ET','2',1,NULL,'GLORIA TOLLIVER','FI','437904668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:58',0,'2014-03-02 05:24:45'),(2416,2416,'2014-01-01','ET','2',1,NULL,'TAMMY HARROD','FI','282548208','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:46',0,'2014-03-10 13:10:24'),(14438,14889,'2014-01-01','ET','2',1,NULL,'Chelsi Brierley','FI','436811028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:26',0,'2014-03-02 05:38:34'),(15138,15589,'0000-00-00','ET','2',1,NULL,'Arnold F Leary','FI','437868233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:06:19',0,'2014-03-02 05:52:31'),(15657,16306,'0000-00-00','ET','2',2,1,'Elizabeth Costello','FI','266394911','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:17',0,'2014-03-01 16:50:53'),(16216,16865,'0000-00-00','ET','2',1,NULL,'JAMES BALDWIN','FI','557430979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:00:50',0,'2014-03-02 06:10:30'),(16366,17016,'0000-00-00','ET','2',2,1,'ANTHONY BANIC','FI','276762540','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:04',0,'2014-03-10 16:24:30'),(16464,17114,'0000-00-00','ET','2',1,NULL,'LISA KEISTER','FI','284745459','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:15',0,'2014-03-01 17:00:58'),(17529,18179,'0000-00-00','ET','2',1,NULL,'Kimberly Johnson','FI','288860915','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:21',0,'2014-03-01 17:20:55'),(19834,20484,'0000-00-00','ET','2',2,1,'linda jarrett','FI','302488489','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:51',0,'2014-03-10 16:38:05'),(21436,22086,'0000-00-00','ET','2',1,NULL,'John A Hanna','FI','292623903','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:07',0,'2014-03-10 16:38:05'),(22917,23567,'0000-00-00','ET','2',2,1,'Annette F Guillory','FI','459511264','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:53',0,'2014-03-10 21:27:11'),(19883,20533,'0000-00-00','ET','2',1,NULL,'karen christman','FI','297569629','HealthSpan','FI','311431434','james   hitchings','94','1866145','357','2014-03-01','Sync Success',0,'2014-02-20 22:01:30',0,'2014-03-10 14:37:47'),(6,6,'2014-01-01','ET','2',1,NULL,'kevin english','FI','293623312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:12',0,'2014-03-01 15:21:15'),(476,476,'2014-01-01','ET','2',1,NULL,'Janet Gniewkowski','FI','292428152','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 17:50:53',0,'2014-03-10 13:10:24'),(2014,2014,'2014-01-01','ET','2',1,NULL,'Ava Smith','FI','435905027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:19',0,'2014-03-01 23:10:52'),(2286,2286,'2014-01-01','ET','2',2,1,'george durnin','FI','439689024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:42',0,'2014-03-01 21:11:04'),(11816,11816,'2014-01-01','ET','2',1,NULL,'SETH KAUFMAN','FI','434550076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:35',0,'2014-03-01 16:15:39'),(4663,4663,'2014-01-01','ET','2',3,2,'Claudia Sandoval','94','0000055919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:20',0,'2014-03-01 16:15:39'),(10788,10788,'2014-01-01','ET','2',1,NULL,'Laura Elizabeth Steiner','FI','427552098','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:29',0,'2014-03-02 04:24:47'),(5436,5436,'2014-01-01','ET','2',1,0,'Maurus V Brown','FI','336587013','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:32',0,'2014-03-01 15:05:09'),(7177,7177,'2014-01-01','ET','2',4,3,'James Michael Yokie','FI','293529245','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:56',0,'2014-03-10 15:59:47'),(5902,5902,'2014-01-01','ET','2',1,NULL,'Phyllis Westerfield','FI','288483045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:51',0,'2014-03-01 15:48:04'),(13986,14342,'2014-01-01','ET','2',1,NULL,'Jessabella Brown','FI','426599187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:20',0,'2014-03-02 05:31:31'),(17517,18167,'0000-00-00','ET','2',1,NULL,'calvin toups','FI','433192763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-22','Sync Success',0,'2014-02-07 19:00:13',0,'2014-03-02 06:31:45'),(17999,18649,'0000-00-00','ET','2',1,NULL,'Angela Simmons','FI','436515608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:39',0,'2014-03-02 06:38:05'),(18544,19194,'0000-00-00','ET','2',1,NULL,'stefanie montanez','FI','639010774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:09',0,'2014-03-02 06:45:14'),(18546,19196,'0000-00-00','ET','2',1,NULL,'MARCIE PURIFOY','FI','422153395','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:09',0,'2014-03-02 06:45:14'),(18582,19232,'0000-00-00','ET','2',1,NULL,'Georgette Elias','FI','269607988','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:20',0,'2014-03-01 17:26:36'),(18776,19426,'0000-00-00','ET','2',1,NULL,'CHIQUITA GRIFFIN','FI','427576617','Starmount Life Insurance Company','FI','720977315','GWENDOLYN  BURT','94','1036021','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:49',0,'2014-03-02 06:45:14'),(18904,19554,'0000-00-00','ET','2',1,NULL,'Juanita Grant','FI','249042251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:04',0,'2014-03-01 17:34:07'),(19121,19771,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','357','2014-03-01','Sync Success',0,'2014-02-15 22:00:59',0,'2014-03-01 17:34:07'),(19242,19892,'0000-00-00','ET','2',1,NULL,'Rodney Gay','FI','273589879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-16 19:00:33',0,'2014-03-01 17:34:07'),(19766,20416,'0000-00-00','ET','2',1,NULL,'LEON GRIFFIN','FI','425551284','Starmount Life Insurance Company','FI','720977315','GWENDOLYN  BURT','94','1036021','348','2014-04-01','Sync Success',0,'2014-02-20 21:30:16',0,'2014-03-02 07:03:25'),(20659,21309,'0000-00-00','ET','2',1,NULL,'JANICE BELL','FI','284523493','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:32',0,'2014-03-10 16:38:05'),(21097,21747,'0000-00-00','ET','2',1,NULL,'Anthony Brutcher','FI','600020392','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:45',0,'2014-03-02 07:23:39'),(22909,23559,'0000-00-00','ET','2',1,NULL,'Donald James Guidry','FI','434983537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:48',0,'2014-03-10 21:27:11'),(22955,23605,'0000-00-00','ET','2',1,NULL,'Don Dawson','FI','299960894','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:20',0,'2014-03-10 21:07:22'),(23026,23676,'0000-00-00','ET','2',2,1,'Kevin Nguyen','FI','564579672','Starmount Life Insurance Company','FI','720977315','Tony  Ly','94','7898204','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:10',0,'2014-03-10 21:27:11'),(2018,2018,'2014-01-01','ET','2',1,NULL,'Keith Brown','FI','436154884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:27',0,'2014-03-01 23:10:52'),(13450,13806,'2014-01-01','ET','2',2,1,'LARRY PERRY','FI','428154031','Starmount Life Insurance Company','FI','720977315','ROBERT  RANKIN','94','11068141','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:18',0,'2014-03-02 05:31:31'),(13368,13724,'2014-01-01','ET','2',1,NULL,'Evangelina Ruiz','FI','571130733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:39',0,'2014-03-02 05:24:45'),(3295,3295,'2014-01-01','ET','2',2,1,'Patricia A Harmon','FI','280543902','Dental Care Plus, Inc.','FI','311185262','Patrick  Hill','94','9833181','348','2014-01-01','Sync Success',0,'2013-12-25 21:48:17',0,'2014-03-01 15:48:04'),(4334,4334,'2014-01-01','ET','2',2,1,'Linda Dussel','FI','272560397','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:16',0,'2014-03-10 15:59:47'),(4914,4914,'2014-01-01','ET','2',1,0,'Andrea Reed','FI','290821200','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:37',0,'2014-03-01 15:05:09'),(12158,12158,'2014-01-01','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:43',0,'2014-03-10 13:52:32'),(12136,12136,'2014-01-01','ET','2',1,NULL,'Alicia Quinter','FI','274789959','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:59',0,'2014-03-10 13:52:32'),(11698,11698,'2014-01-01','ET','2',1,NULL,'Nixon Williams','FI','437713695','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:51',0,'2014-03-02 04:59:36'),(5016,5016,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:28',0,'2014-03-01 15:31:33'),(15274,15725,'0000-00-00','ET','2',2,1,'Leonidas Mixon','FI','438598690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:03',0,'2014-03-02 05:52:31'),(14805,15256,'2014-01-01','ET','2',2,1,'Joby Fetters','FI','274788998','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:01',0,'2014-03-10 14:10:12'),(13885,14241,'2014-01-01','ET','2',1,NULL,'SHELLEY BRIGNAC','FI','436238456','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:11',0,'2014-03-02 05:31:31'),(4456,4456,'2014-01-01','ET','2',1,NULL,'Tina Haley','FI','272585279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:37',0,'2014-03-01 15:16:37'),(4066,4066,'2014-01-01','ET','2',1,NULL,'Nancy Gist Redhead','FI','532589741','Starmount Life Insurance Company','FI','720977315','Curtis  Finley','94','1123276','348','2014-01-01','Sync Success',0,'2013-12-25 23:02:13',0,'2014-03-02 03:09:49'),(11895,11895,'2014-01-01','ET','2',1,NULL,'reginald bell','FI','434115499','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:51',0,'2014-03-02 04:59:36'),(10706,10706,'2014-01-01','ET','2',2,1,'richard williams','FI','274567581','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:44',0,'2014-03-01 16:10:36'),(2153,2153,'2014-01-01','ET','2',1,NULL,'Judy Marie Davis','FI','572789534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:35',0,'2014-03-01 21:11:04'),(2877,2877,'2014-01-01','ET','2',1,NULL,'Ellen Schlatter','FI','316509933','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:53',0,'2014-03-10 13:39:10'),(16933,17583,'0000-00-00','ET','2',2,1,'Virgil Martin','FI','524680619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:47',0,'2014-03-02 06:17:30'),(21876,22526,'0000-00-00','ET','2',1,NULL,'Joshua Wilson','FI','302905854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:25',0,'2014-03-05 21:36:22'),(3901,3901,'2014-01-01','ET','2',1,NULL,'Erin R Sloan','FI','270843418','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:03',0,'2014-03-10 15:45:56'),(14283,14734,'2014-01-01','ET','2',1,NULL,'isaac zafuto','FI','285880672','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:17',0,'2014-03-01 16:46:19'),(674,674,'2014-01-01','ET','2',1,NULL,'Susan McQuigg','FI','281589189','Summa Insurance Company, Inc.','FI','341809108','Lawrence  Kaczmarek','94','313913','348','2014-01-01','Sync Success',0,'2013-12-25 18:05:54',0,'2014-03-10 15:52:36'),(13481,13837,'2014-01-01','ET','2',1,NULL,'stacey prezel-parker','FI','310946264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:40',0,'2014-03-02 05:31:31'),(3696,3696,'2014-01-01','ET','2',2,1,'Joyce Lowery','FI','434041834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:23',0,'2014-03-02 00:10:48'),(12538,12538,'2014-01-01','ET','2',1,NULL,'Lana Gentry','FI','236842798','HealthSpan','FI','311431434','Nichole  Gillenwater','94','16255582','348','2014-02-01','Sync Success',1,'2014-01-02 04:34:46',0,'2014-03-10 13:59:38'),(16524,17174,'0000-00-00','ET','2',1,NULL,'Kirby Alan Morris','FI','587841943','Starmount Life Insurance Company','FI','720977315','Harolyn C Light','94','7934326','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:53',0,'2014-03-02 06:10:30'),(19788,20438,'0000-00-00','ET','2',1,NULL,'NATHAN T STEVENS','FI','434276242','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:13',0,'2014-03-02 07:03:25'),(20873,21523,'0000-00-00','ET','2',1,NULL,'Darya Eldar gizi Hasanova','94','0000426457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:32',0,'2014-03-02 07:17:36'),(21330,21980,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 01:00:13',0,'2014-03-03 01:35:37'),(22242,22892,'0000-00-00','ET','2',1,NULL,'John Francis','FI','268741280','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:10',0,'2014-03-10 16:44:18'),(22344,22994,'0000-00-00','ET','2',1,NULL,'Madison Bregitzer','94','0000578830','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','348','2014-04-01','Sync Success',0,'2014-03-07 21:00:09',0,'2014-03-07 21:36:32'),(22515,23165,'0000-00-00','ET','2',1,NULL,'ALMIRE EL-AMIN','FI','439372759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:21',0,'2014-03-07 22:26:59'),(402,402,'2014-01-01','ET','2',1,NULL,'SHAWN JOHNSON','FI','436335616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:26',0,'2014-03-01 22:10:55'),(2581,2581,'2014-01-01','ET','2',1,NULL,'William Kuehn','FI','509526035','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:21',0,'2014-03-01 15:05:09'),(3825,3825,'2014-01-01','ET','2',1,NULL,'michael ickes','FI','289805918','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:15',0,'2014-03-10 13:10:24'),(17986,18636,'0000-00-00','ET','2',1,NULL,'SANDRA CROYLE','FI','287480594','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:30',0,'2014-03-10 16:31:33'),(21348,21998,'0000-00-00','ET','2',1,NULL,'Delta Morrison','FI','296766333','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:22',0,'2014-03-03 01:35:37'),(7378,7378,'2014-01-01','ET','2',1,NULL,'CHERYL HATCHERSON','FI','437177013','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:06',0,'2014-03-02 04:10:25'),(15161,15612,'0000-00-00','ET','2',1,NULL,'SONYA CLAUDETTE FLOWERS','94','0001157013','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:34',0,'2014-03-02 05:52:31'),(884,884,'2014-01-01','ET','2',1,NULL,'Elizabeth Kusak','FI','287829828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:41',0,'2014-03-01 15:21:15'),(14560,15011,'2014-01-01','ET','2',1,NULL,'MA HINOJOSA DE BOLANOS','FI','641040479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:25',0,'2014-03-02 05:45:37'),(13996,14352,'2014-01-01','ET','2',5,4,'Christine Lampert','FI','049663699','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:27',0,'2014-03-10 16:17:47'),(1443,1443,'2014-01-01','ET','2',1,NULL,'gina heckel','FI','291586997','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:29',0,'2014-03-01 16:15:39'),(12806,12806,'2014-01-01','ET','2',2,1,'Donna Griffin','FI','452193044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:28',0,'2014-03-02 05:17:40'),(5158,5158,'2014-01-01','ET','2',1,NULL,'Tony Taylor','FI','290501925','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:02',0,'2014-03-10 15:45:56'),(4690,4690,'2014-01-01','ET','2',2,1,'Chad Doberson','FI','449657937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:19',0,'2014-03-02 04:38:08'),(11396,11396,'2014-01-01','ET','2',1,NULL,'Monica Birsen','FI','281621036','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:26',0,'2014-03-10 13:52:32'),(16309,16959,'0000-00-00','ET','2',1,NULL,'Judy Mink','FI','404860497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:29',0,'2014-03-01 16:56:22'),(19192,19842,'0000-00-00','ET','2',2,1,'Alan Drum','FI','524968747','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:59',0,'2014-03-10 14:31:05'),(7319,7319,'2014-01-01','ET','2',1,NULL,'Joella Cleland','FI','383642362','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:17',0,'2014-03-10 13:32:15'),(14379,14830,'2014-01-01','ET','2',2,1,'DEBRA ANDREWS','FI','294561632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:57',0,'2014-03-01 16:46:19'),(14142,14593,'2014-01-01','ET','2',1,NULL,'STELLA DIXON','FI','436190405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:02',0,'2014-03-02 05:38:34'),(13377,13733,'2014-01-01','ET','2',1,NULL,'Duane Langshaw','FI','458025711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:44',0,'2014-03-02 05:24:45'),(5131,5131,'2014-01-01','ET','2',1,NULL,'Jessie Carson','FI','300521813','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:16',0,'2014-03-10 15:45:56'),(3872,3872,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:17',0,'2014-03-10 13:03:33'),(3321,3321,'2014-01-01','ET','2',1,NULL,'Randi Trimble','FI','269704892','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:15',0,'2014-03-10 13:24:34'),(18689,19339,'0000-00-00','ET','2',1,NULL,'Angela Burress','FI','456673917','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:43',0,'2014-03-02 06:45:14'),(19554,20204,'0000-00-00','ET','2',1,NULL,'LAVONDA CHARLES SIMIEN','FI','369789588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:19:11',0,'2014-03-02 06:59:07'),(19629,20279,'0000-00-00','ET','2',1,NULL,'ROSA LOPEZ DE PORTILLO','FI','289063548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:37:58',0,'2014-03-01 17:47:19'),(21619,22269,'0000-00-00','ET','2',2,1,'MIKE STANLEY','FI','530849525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:35',0,'2014-03-04 21:27:16'),(415,415,'2014-01-01','ET','2',2,1,'Gary Rogolsky','FI','283426781','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:52',0,'2014-03-01 15:21:15'),(13183,13539,'2014-01-01','ET','2',1,NULL,'Ronald Lee','FI','291467678','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:02',0,'2014-03-10 16:10:34'),(1204,1204,'2014-01-01','ET','2',1,NULL,'MARY HARPER','FI','301721292','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:54',0,'2014-03-10 13:52:32'),(11925,11925,'2014-01-01','ET','2',1,NULL,'Rebecca Duplantis','FI','433728367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-30 00:01:47',0,'2014-03-02 04:59:36'),(1495,1495,'2014-01-01','ET','2',1,NULL,'Mark L Spafford','FI','296564481','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:14',0,'2014-03-10 13:45:57'),(3922,3922,'2014-01-01','ET','2',2,1,'Miguel Reyes','FI','636205318','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:42',0,'2014-03-01 15:26:40'),(17412,18062,'0000-00-00','ET','2',1,NULL,'Abbey DeCurtins','FI','270861806','HealthSpan','FI','311431434','Steven M Schmitmeyer','94','2326455','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:50',0,'2014-03-10 14:24:38'),(19454,20104,'0000-00-00','ET','2',2,1,'Elizabeth Calzada','FI','449616020','Starmount Life Insurance Company','FI','720977315','Humayun  Afzal','94','1307168','348','2014-04-01','Sync Success',0,'2014-02-20 03:43:18',0,'2014-03-02 06:59:07'),(22878,23528,'0000-00-00','ET','2',1,NULL,'Kara Stovall','FI','460914019','Starmount Life Insurance Company','FI','720977315','Sandra  Longacre','94','1109583','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:22',0,'2014-03-10 21:27:11'),(7501,7501,'2014-01-01','ET','2',1,NULL,'Joyce Hood','FI','294425072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:06',0,'2014-03-01 16:05:34'),(15954,16603,'0000-00-00','ET','2',1,NULL,'CATHERINE  MCPETERS','FI','292463171','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:05',0,'2014-03-01 16:56:22'),(12748,12748,'2014-01-01','ET','2',1,NULL,'Jerald Renoil Dawson','FI','425718723','Starmount Life Insurance Company','FI','720977315','Bessie  Mclin','94','3722120','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:37',0,'2014-03-02 05:10:52'),(4673,4673,'2014-01-01','ET','2',2,1,'Lance Tucker','FI','278724008','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:40',0,'2014-03-01 16:15:39'),(14477,14928,'2014-01-01','ET','2',1,NULL,'Brooke Singleton','FI','293848646','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:42',0,'2014-03-10 14:03:26'),(10911,10911,'2014-01-01','ET','2',1,NULL,'Nancy Lignoski','FI','208664017','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:00',0,'2014-03-10 15:59:47'),(18836,19486,'0000-00-00','ET','2',1,NULL,'Alice Sparks','FI','461922207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:16',0,'2014-03-02 06:52:12'),(18894,19544,'0000-00-00','ET','2',1,NULL,'Karen Gillespie','FI','272843517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:57',0,'2014-03-01 17:34:07'),(18901,19551,'0000-00-00','ET','2',2,1,'John Nixon','FI','281781000','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:02',0,'2014-03-01 17:34:07'),(5221,5221,'2014-01-01','ET','2',2,1,'Melissa Myers','FI','274805763','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:05',0,'2014-03-10 13:20:27'),(16341,16991,'0000-00-00','ET','2',1,NULL,'Nancy McClary','FI','274602757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:49',0,'2014-03-01 16:56:22'),(15822,16471,'0000-00-00','ET','2',1,NULL,'TIFFANY N HOWARD','FI','437592902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:24',0,'2014-03-02 06:03:21'),(15183,15634,'0000-00-00','ET','2',2,1,'LAURENCIO BAZAN GARZA','FI','637549600','Starmount Life Insurance Company','FI','720977315','TRICHARD A MIER Jr','94','15750460','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:14',0,'2014-03-02 05:52:31'),(5027,5027,'2014-01-01','ET','2',1,NULL,'gregory jackson','FI','302560387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:50',0,'2014-03-01 15:31:33'),(13921,14277,'2014-01-01','ET','2',1,NULL,'TYLER TORREY','94','0001196829','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:14',0,'2014-03-10 14:03:26'),(3195,3195,'2014-01-01','ET','2',2,1,'Jesse Vroman','FI','299842610','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:10',0,'2014-03-01 15:48:04'),(4582,4582,'2014-01-01','ET','2',1,NULL,'Kareema Williams','FI','296861429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:42',0,'2014-03-01 16:15:39'),(3690,3690,'2014-01-01','ET','2',1,NULL,'William Lavis','FI','437575504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:11',0,'2014-03-02 00:10:48'),(4495,4495,'2014-01-01','ET','2',1,NULL,'Vanessa ANN BELVIN','FI','282564114','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:54',0,'2014-03-10 15:39:19'),(16110,16759,'0000-00-00','ET','2',1,NULL,'DERRICK Q MORGAN','FI','464570951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:25',0,'2014-03-02 06:03:21'),(19066,19716,'0000-00-00','ET','2',1,NULL,'Dawn Laufenberg','FI','396888578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:19',0,'2014-03-02 06:52:12'),(6057,6057,'2014-01-01','ET','2',1,NULL,'Josephine Caceres','FI','546591183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:49',0,'2014-03-01 19:11:03'),(16069,16718,'0000-00-00','ET','2',2,1,'Nelson Seip','FI','270440249','Dental Care Plus, Inc.','FI','311185262','Carl  Bloomer','94','1782832','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:55',0,'2014-03-01 16:56:22'),(14115,14566,'2014-01-01','ET','2',3,2,'zeinab ali','FI','218045878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:45',0,'2014-03-01 16:46:19'),(3844,3844,'2014-01-01','ET','2',2,1,'William Stout','FI','296604098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:23',0,'2014-03-01 15:05:09'),(18671,19321,'0000-00-00','ET','2',1,NULL,'victor kim','FI','622525410','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:31',0,'2014-03-02 06:45:14'),(19641,20291,'0000-00-00','ET','2',1,NULL,'ANTOINETTE M KOMYATI','FI','287642324','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:41:07',0,'2014-03-01 17:47:19'),(20485,21135,'0000-00-00','ET','2',1,NULL,'Stephanie Cline','FI','294764798','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:35',0,'2014-03-10 16:38:05'),(20542,21192,'0000-00-00','ET','2',1,NULL,'Pamela Jo Cody','FI','441626954','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:11',0,'2014-03-02 07:10:28'),(11189,11189,'2014-01-01','ET','2',1,NULL,'Robert Little','FI','268644708','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:06',0,'2014-03-01 16:23:43'),(14886,15337,'2014-01-01','ET','2',1,NULL,'NOEMIS RIVERA','FI','584193920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:17',0,'2014-03-02 05:45:37'),(11627,11627,'2014-01-01','ET','2',1,NULL,'IZABELLA KOYFMAN','FI','286948425','HealthSpan','FI','311431434','DAVID  SPIESS','94','966951','348','2014-02-01','Sync Success',0,'2013-12-28 03:35:34',0,'2014-03-10 13:52:32'),(12483,12483,'2014-01-01','ET','2',5,4,'Jill Mecklenborg','FI','280702833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:38',0,'2014-03-01 16:35:14'),(19720,20370,'0000-00-00','ET','2',1,NULL,'Melissa Irby','FI','226660459','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:33:32',0,'2014-03-01 17:47:19'),(22501,23151,'0000-00-00','ET','2',1,NULL,'DARLENE K FLYNN','FI','286566999','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:11',0,'2014-03-10 14:50:59'),(22512,23162,'0000-00-00','ET','2',1,NULL,'GEORGE NATHAN','FI','434594277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:31:19',0,'2014-03-07 22:26:59'),(22751,23401,'0000-00-00','ET','2',1,NULL,'LILLIAN IRENE BOSTON','FI','435197321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:12',0,'2014-03-09 21:26:00'),(11082,11082,'2014-01-01','ET','2',1,NULL,'Kurt Hanushek','FI','291566565','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:31',0,'2014-03-10 13:45:57'),(1864,1864,'2014-01-01','ET','2',1,NULL,'Roberta Davis','FI','268508183','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:40',0,'2014-03-01 15:26:40'),(6369,6369,'2014-01-01','ET','2',1,NULL,'Thomas Kostoff','FI','286461861','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 03:09:31',0,'2014-03-10 15:59:47'),(2316,2316,'2014-01-01','ET','2',1,NULL,'robert yeager','FI','298469758','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:46',0,'2014-03-10 13:03:33'),(5815,5815,'2014-01-01','ET','2',4,3,'Kevin Forsyth','FI','168541931','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:04:03',0,'2014-03-10 15:52:36'),(2943,2943,'2014-01-01','ET','2',2,1,'Dirk Allen Eckels','FI','298567022','Dental Care Plus, Inc.','FI','311185262','Joshua Michael Byrd','94','2264634','348','2014-01-01','Sync Success',0,'2013-12-25 21:31:21',0,'2014-03-01 15:37:30'),(17536,18186,'0000-00-00','ET','2',1,NULL,'WILLIAM  B SMITH','FI','281848906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:25',0,'2014-03-01 17:20:55'),(17752,18402,'0000-00-00','ET','2',2,1,'FRANCO CONTI','FI','278500559','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:37',0,'2014-03-01 17:20:55'),(19776,20426,'0000-00-00','ET','2',1,NULL,'angel alonzo','FI','438250899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:24',0,'2014-03-02 07:03:25'),(21970,22620,'0000-00-00','ET','2',1,NULL,'Kay Steiner','FI','300449617','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:33',0,'2014-03-10 16:44:18'),(22575,23225,'0000-00-00','ET','2',1,NULL,'ROBERTA LEE GILLIG','FI','281504894','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:03',0,'2014-03-10 14:50:59'),(10405,10405,'2014-01-01','ET','2',1,NULL,'Paula M Stump','FI','301466567','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:51',0,'2014-03-01 16:10:36'),(4294,4294,'2014-01-01','ET','2',4,3,'Keith Thomas Middleton','FI','292585611','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:07',0,'2014-03-10 13:32:15'),(7719,7719,'2014-01-01','ET','2',1,NULL,'Matthew Stephens','FI','232314198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:08',0,'2014-03-01 20:10:57'),(15100,15551,'0000-00-00','ET','2',1,NULL,'DEADIRA  CASTILLO','FI','457838127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:49',0,'2014-03-02 05:52:31'),(21624,22274,'0000-00-00','ET','2',1,NULL,'Morgan Wilcox','FI','590167941','Starmount Life Insurance Company','FI','720977315','Julie   Tooze','94','17073136','348','2014-04-01','Sync Success',0,'2014-03-04 21:00:39',0,'2014-03-04 21:27:16'),(22572,23222,'0000-00-00','ET','2',1,NULL,'Michael Peiples','FI','293749263','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:32:01',0,'2014-03-10 14:50:59'),(6164,6164,'2014-01-01','ET','2',1,NULL,'Swen Crone','FI','450479425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:15',0,'2014-03-02 04:10:25'),(7706,7706,'2014-01-01','ET','2',1,NULL,'David Peters','FI','279787933','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:41',0,'2014-03-01 15:10:22'),(5629,5629,'2014-01-01','ET','2',1,NULL,'Matt Wright','FI','284842286','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:40',0,'2014-03-10 16:03:49'),(14685,15136,'2014-01-01','ET','2',2,1,'joseph packo','FI','290540226','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:45',0,'2014-03-01 16:46:19'),(4598,4598,'2014-01-01','ET','2',1,NULL,'teferi feyisa','FI','365356649','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:14',0,'2014-03-01 16:15:39'),(1255,1255,'2014-01-01','ET','2',1,NULL,'Peter Moore','FI','280701078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:22',0,'2014-03-01 16:15:39'),(11880,11880,'2014-01-01','ET','2',1,NULL,'Janice Ponder','FI','466111681','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:23',0,'2014-03-02 04:59:36'),(2642,2642,'2014-01-01','ET','2',1,NULL,'Mary Bradley','FI','276523663','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:08',0,'2014-03-10 13:39:10'),(3798,3798,'2014-01-01','ET','2',1,NULL,'MARILYN HILTABIDEL','FI','284482577','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:14',0,'2014-03-10 15:45:56'),(20906,21556,'0000-00-00','ET','2',2,1,'Douglas Borntrager','FI','290825152','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:48',0,'2014-03-10 14:45:25'),(20990,21640,'0000-00-00','ET','2',1,NULL,'Erin Gulbengay','FI','567657774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:32',0,'2014-03-02 07:17:36'),(21073,21723,'0000-00-00','ET','2',1,NULL,'PETER SPASOFF','FI','377582263','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:29',0,'2014-03-01 18:10:11'),(22331,22981,'0000-00-00','ET','2',1,NULL,'ibrahim habli','94','0000971518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:20',0,'2014-03-06 21:36:23'),(22588,23238,'0000-00-00','ET','2',1,NULL,'Magdalena H Medina','FI','450191451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:13',0,'2014-03-07 22:26:59'),(157,157,'2014-01-01','ET','2',1,NULL,'David Dennison','FI','282729217','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:51',0,'2014-03-10 15:45:56'),(666,666,'2014-01-01','ET','2',1,NULL,'Michael Smith','FI','459372513','Starmount Life Insurance Company','FI','720977315','DAVID  EDWARDS','94','565219','348','2014-01-01','Sync Success',0,'2013-12-25 18:05:41',0,'2014-03-02 02:10:49'),(13509,13865,'2014-01-01','ET','2',1,NULL,'Laurie Preston','FI','279529789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:22',0,'2014-03-02 05:31:31'),(768,768,'2014-01-01','ET','2',1,NULL,'Sam Petruc','FI','288840669','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:58',0,'2014-03-01 15:05:09'),(11552,11552,'2014-01-01','ET','2',3,2,'Eduardo Arredondo Cervantes','FI','644521314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:14',0,'2014-03-02 04:52:44'),(11112,11112,'2014-01-01','ET','2',1,NULL,'John Carr','FI','291485216','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:30',0,'2014-03-10 13:45:57'),(3915,3915,'2014-01-01','ET','2',1,NULL,'Paula Griffin','FI','274745472','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:30',0,'2014-03-01 15:26:40'),(10556,10556,'2014-01-01','ET','2',1,NULL,'Thelma J Mixon','FI','462352112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:55:45',0,'2014-03-02 04:24:47'),(17325,17975,'0000-00-00','ET','2',1,NULL,'Terrence Chung','FI','470194959','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:31:09',0,'2014-03-10 16:24:30'),(17437,18087,'0000-00-00','ET','2',1,NULL,'Crystal Longoria','FI','631306621','Starmount Life Insurance Company','FI','720977315','Patricio  Hernandez Jr','94','1213642','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:07',0,'2014-03-02 06:31:45'),(21289,21939,'0000-00-00','ET','2',1,NULL,'Evelyn Merino','FI','639800215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:57',0,'2014-03-02 07:23:39'),(22556,23206,'0000-00-00','ET','2',1,NULL,'carol lindsay','FI','297428298','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-07 21:31:50',0,'2014-03-10 16:44:18'),(369,369,'2014-01-01','ET','2',1,NULL,'Szymon Kowalczyk','FI','302926505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:22',0,'2014-03-01 15:21:15'),(1073,1073,'2014-01-01','ET','2',1,NULL,'Joseph Vanwie','FI','398084151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:01',0,'2014-03-01 21:11:04'),(11509,11509,'2014-01-01','ET','2',1,NULL,'James Hardaway','FI','327509006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:56',0,'2014-03-02 04:52:44'),(1285,1285,'2014-01-01','ET','2',1,NULL,'ANNE TENISON DOUGLASS','FI','271748471','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:19',0,'2014-03-01 16:23:43'),(4877,4877,'2014-01-01','ET','2',2,1,'william marcus kuliska','FI','423273165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:30',0,'2014-03-01 20:10:57'),(3389,3389,'2014-01-01','ET','2',1,NULL,'Donna K Zuelsdorf','FI','284524087','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:21',0,'2014-03-10 15:52:36'),(2687,2687,'2014-01-01','ET','2',1,NULL,'Dennis Lewis','FI','462775515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:46',0,'2014-03-02 04:15:49'),(10415,10415,'2014-01-01','ET','2',1,NULL,'Dennis Wieland','FI','275448942','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:11',0,'2014-03-01 16:10:36'),(16519,17169,'0000-00-00','ET','2',1,NULL,'Morris Terrell Jackson','FI','587534563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:49',0,'2014-03-02 06:10:30'),(19801,20451,'0000-00-00','ET','2',1,NULL,'TEKINA MICHELLE WOODS','FI','431257982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:24',0,'2014-03-02 06:59:07'),(21623,22273,'0000-00-00','ET','2',1,NULL,'Michael Legg','FI','591706615','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:00:38',0,'2014-03-04 21:27:16'),(21641,22291,'0000-00-00','ET','2',1,NULL,'michael fishman','FI','287889425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:52',0,'2014-03-04 21:36:30'),(22274,22924,'0000-00-00','ET','2',1,NULL,'Sotiria Pastrikos','FI','297742889','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:34',0,'2014-03-10 14:45:25'),(1729,1729,'2014-01-01','ET','2',1,NULL,'Shannon Petrosky','FI','285745525','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:22',0,'2014-03-01 15:31:33'),(14747,15198,'2014-01-01','ET','2',1,NULL,'Raymond Weisel','FI','269843030','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:25',0,'2014-03-10 16:17:47'),(14701,15152,'2014-01-01','ET','2',1,NULL,'Travis Ponville','FI','439717788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:56',0,'2014-03-02 05:45:37'),(13159,13515,'2014-01-01','ET','2',1,NULL,'joshua dressner','FI','434573028','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','357','2014-02-01','Sync Success',0,'2014-01-07 04:05:15',0,'2014-03-02 05:17:40'),(11575,11575,'2014-01-01','ET','2',1,NULL,'GABRIELA  ESPINO OCHOA','FI','701464413','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:00',0,'2014-03-02 04:52:44'),(7452,7452,'2014-01-01','ET','2',1,NULL,'Joshua Rylander','FI','461699321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:27',0,'2014-03-02 04:10:25'),(7361,7361,'2014-01-01','ET','2',5,4,'LINDA TARELLARI','FI','291741137','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:52',0,'2014-03-01 15:16:37'),(20945,21595,'0000-00-00','ET','2',1,NULL,'Michelle Getz','FI','466983720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:38',0,'2014-03-02 07:17:36'),(21040,21690,'0000-00-00','ET','2',2,1,'Thelsherr Robinson','FI','293643818','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:02',0,'2014-03-01 18:10:11'),(21515,22165,'0000-00-00','ET','2',1,NULL,'JUANA CASTILLO','FI','456575506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:06',0,'2014-03-03 22:26:43'),(22236,22886,'0000-00-00','ET','2',1,NULL,'Marcus Aurelius Smith','FI','426131029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:06',0,'2014-03-06 21:27:26'),(156,156,'2014-01-01','ET','2',1,NULL,'David Dennison','FI','282729217','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:19:50',0,'2014-03-10 15:45:56'),(15165,15616,'0000-00-00','ET','2',1,NULL,'Cheryl Annette Givens','FI','269661277','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:06:37',0,'2014-03-10 14:10:12'),(3223,3223,'2014-01-01','ET','2',1,NULL,'Debra Pennock','FI','292569907','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:01',0,'2014-03-01 15:52:44'),(10789,10789,'2014-01-01','ET','2',1,NULL,'KENYARDA PERRY','FI','436258935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:31',0,'2014-03-02 04:24:47'),(4954,4954,'2014-01-01','ET','2',1,NULL,'CAROL EMERUWA','FI','269544250','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:59',0,'2014-03-10 15:39:19'),(12595,12595,'2014-01-01','ET','2',1,NULL,'DIANE D DAVIS','FI','457276440','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:56',0,'2014-03-02 05:10:52'),(10461,10461,'2014-01-01','ET','2',1,NULL,'Kathleen Repko','FI','278503842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:37',0,'2014-03-01 16:10:36'),(17187,17837,'0000-00-00','ET','2',1,NULL,'Margaret Schuster','FI','268523561','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:30:03',0,'2014-03-10 16:24:30'),(17901,18551,'0000-00-00','ET','2',2,1,'Kenneth Yambra','FI','433532585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:29',0,'2014-03-02 06:38:05'),(19074,19724,'0000-00-00','ET','2',1,NULL,'Janice Monk','FI','439868808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:24',0,'2014-03-02 06:52:12'),(14694,15145,'2014-01-01','ET','2',1,NULL,'nicholas giarratano','FI','436729095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:51',0,'2014-03-02 05:45:37'),(16362,17012,'0000-00-00','ET','2',1,NULL,'Claudia Brook','FI','267923502','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:01',0,'2014-03-10 16:24:30'),(19416,20066,'0000-00-00','ET','2',1,NULL,'Jane Akers','FI','294720094','HealthSpan','FI','311431434','Cameron  Liljenquist','94','8328382','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:21',0,'2014-03-10 14:31:05'),(21478,22128,'0000-00-00','ET','2',1,NULL,'Benjamin Stewart','FI','300925358','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:39',0,'2014-03-03 21:36:16'),(1555,1555,'2014-01-01','ET','2',1,NULL,'JOHN Rossi','94','0000988886','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:09',0,'2014-03-10 13:52:32'),(2039,2039,'2014-01-01','ET','2',2,1,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:04',0,'2014-03-02 00:10:48'),(14986,15437,'2014-01-01','ET','2',1,NULL,'Deborah Decker','FI','283603449','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:04',0,'2014-03-01 16:46:19'),(15283,15734,'0000-00-00','ET','2',2,1,'norberto juarez','FI','452235764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:09',0,'2014-03-02 05:52:31'),(18483,19133,'0000-00-00','ET','2',1,NULL,'d-andra gilmore','FI','587638433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:58',0,'2014-03-02 06:45:14'),(358,358,'2014-01-01','ET','2',1,NULL,'RICHARD R TRZASKOWSKI','FI','297525403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:02',0,'2014-03-01 15:21:15'),(7261,7261,'2014-01-01','ET','2',1,NULL,'Kristin McGinnis','FI','300846593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:30',0,'2014-03-10 13:32:15'),(7108,7108,'2014-01-01','ET','2',1,NULL,'Preston Turner','FI','678207992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:50',0,'2014-03-01 15:52:44'),(5910,5910,'2014-01-01','ET','2',1,NULL,'Tramango Roper','FI','269725504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:07',0,'2014-03-01 15:48:04'),(4045,4045,'2014-01-01','ET','2',1,NULL,'Robert Melton','FI','639053584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:31',0,'2014-03-02 03:09:49'),(4689,4689,'2014-01-01','ET','2',1,NULL,'Javier Vicuna','FI','456931120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:17',0,'2014-03-02 04:38:08'),(4868,4868,'2014-01-01','ET','2',1,NULL,'Glenn MacDougall','FI','008426603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:16:12',0,'2014-03-01 20:10:57'),(20108,20758,'0000-00-00','ET','2',1,NULL,'Jamey Purtty','FI','302827724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:26',0,'2014-03-10 16:38:05'),(1071,1071,'2014-01-01','ET','2',1,NULL,'Cesar Navarro','FI','458477811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:59',0,'2014-03-01 21:11:04'),(16734,17384,'0000-00-00','ET','2',1,NULL,'Shauna Riggins','FI','290749109','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:41',0,'2014-03-10 14:20:26'),(15393,15844,'0000-00-00','ET','2',1,NULL,'Angel Michelle-Harris Saltzman','FI','636286159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',1,'2014-01-22 03:22:05',0,'2014-03-02 05:59:43'),(12689,12689,'2014-01-01','ET','2',5,4,'Karen Bacon','FI','385883155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:19',0,'2014-03-01 16:35:14'),(12045,12045,'2014-01-01','ET','2',1,NULL,'Joyce  Milaton','FI','433862758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:47',0,'2014-03-02 05:03:29'),(10729,10729,'2014-01-01','ET','2',1,NULL,'Hannah V Feerer','FI','287135342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:36',0,'2014-03-01 16:10:36'),(6270,6270,'2014-01-01','ET','2',1,NULL,'Charles Guilbeau','FI','435868780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:33',0,'2014-03-02 04:10:25'),(5793,5793,'2014-01-01','ET','2',1,NULL,'Curtis Schrack','FI','297781975','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:03:18',0,'2014-03-10 15:52:36'),(20810,21460,'0000-00-00','ET','2',1,NULL,'Mary Ringo','FI','450088231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:31:04',0,'2014-03-02 07:17:36'),(22131,22781,'0000-00-00','ET','2',2,1,'Francine CANNON','FI','221465294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:52',0,'2014-03-06 21:27:26'),(86,86,'2014-01-01','ET','2',1,NULL,'JOSEPHINE H HENDERSON','FI','449801791','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:37',0,'2014-03-01 22:10:55'),(7155,7155,'2014-01-01','ET','2',3,2,'Daniel Kaye','FI','294561130','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-26 04:05:14',0,'2014-03-10 15:52:36'),(14791,15242,'2014-01-01','ET','2',1,NULL,'Patsy Taylor','FI','426251198','Starmount Life Insurance Company','FI','720977315','Clarence  Palmer','94','1906096','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:51',0,'2014-03-02 05:45:37'),(11668,11668,'2014-01-01','ET','2',1,NULL,'Angela Green','FI','278840124','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:36:53',0,'2014-03-10 13:52:32'),(4075,4075,'2014-01-01','ET','2',1,NULL,'glenna parker','FI','275720447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:32',0,'2014-03-01 15:52:44'),(2595,2595,'2014-01-01','ET','2',1,NULL,'debra a jackson','FI','273746683','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:50',0,'2014-03-10 15:39:19'),(2423,2423,'2014-01-01','ET','2',2,1,'Robert DeCastro','FI','282806020','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:58',0,'2014-03-10 15:45:56'),(1953,1953,'2014-01-01','ET','2',2,1,'Ronald Brown','FI','239806214','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:18',0,'2014-03-01 15:26:40'),(19573,20223,'0000-00-00','ET','2',1,NULL,'Sharon Graham','FI','290522434','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:24:17',0,'2014-03-10 14:37:47'),(21546,22196,'0000-00-00','ET','2',2,1,'BRIAN BROWN','FI','290663633','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:29',0,'2014-03-10 14:45:25'),(23010,23660,'0000-00-00','ET','2',1,NULL,'HERMAN REINHART','FI','285441909','HealthSpan','FI','311431434','GARY  SMITH','94','1766033','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:58',0,'2014-03-10 21:17:52'),(11262,11262,'2014-01-01','ET','2',1,NULL,'Liem Vu','FI','435570942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:21',0,'2014-03-02 04:45:37'),(16288,16938,'0000-00-00','ET','2',1,NULL,'Dora Sanchez','FI','451836968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:15',0,'2014-03-02 06:10:30'),(7123,7123,'2014-01-01','ET','2',1,NULL,'Daniel Powell','FI','289506737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:18',0,'2014-03-01 15:52:44'),(13498,13854,'2014-01-01','ET','2',1,NULL,'Delton Richard','FI','467794716','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:15',0,'2014-03-02 05:31:31'),(13256,13612,'2014-01-01','ET','2',2,1,'GREGORY EUGIN ALEXANDER','FI','276666688','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:23',0,'2014-03-10 13:59:38'),(1512,1512,'2014-01-01','ET','2',1,NULL,'Kristianna Meadows','FI','288967218','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:46',0,'2014-03-10 16:03:49'),(2379,2379,'2014-01-01','ET','2',2,1,'Calvin Hetrick','FI','441500925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:36',0,'2014-03-01 23:10:52'),(18430,19080,'0000-00-00','ET','2',1,NULL,'ANGELA CHAFFIN','FI','274649117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:25',0,'2014-03-01 17:26:36'),(19084,19734,'0000-00-00','ET','2',1,NULL,'Arliss White','FI','290642430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:32',0,'2014-03-01 17:34:07'),(21349,21999,'0000-00-00','ET','2',1,NULL,'Kaci Stearns','FI','021746094','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:22',0,'2014-03-03 01:35:37'),(1235,1235,'2014-01-01','ET','2',1,NULL,'TERRY CLAY','FI','268581631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:48:48',0,'2014-03-01 16:15:39'),(5242,5242,'2014-01-01','ET','2',1,NULL,'Teresa Wenning','FI','272641266','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:46',0,'2014-03-10 13:20:27'),(13304,13660,'2014-01-01','ET','2',1,NULL,'CHRISTINE MCKINNEY','FI','277540167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:14',0,'2014-03-01 16:40:16'),(12921,12921,'2014-01-01','ET','2',1,NULL,'Robert Sheer','FI','289543272','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','348','2014-02-01','Sync Success',0,'2014-01-04 02:05:41',0,'2014-03-10 16:10:34'),(6082,6082,'2014-01-01','ET','2',1,NULL,'Nicole Renee Turner','FI','301805693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:00:48',0,'2014-03-01 16:00:27'),(3462,3462,'2014-01-01','ET','2',1,NULL,'Theodore Mix','FI','283545741','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:43',0,'2014-03-10 13:32:15'),(5545,5545,'2014-01-01','ET','2',1,NULL,'Paul Wehlitz','FI','226338509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:54',0,'2014-03-01 16:23:43'),(22891,23541,'0000-00-00','ET','2',1,NULL,'Matthew Ryan Welch','FI','300908181','Dental Care Plus, Inc.','FI','311185262','Pat  Kern','94','518130','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:32',0,'2014-03-10 21:36:25'),(22962,23612,'0000-00-00','ET','2',1,NULL,'Lelith Willis','FI','288767844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:01:25',0,'2014-03-10 21:36:25'),(246,246,'2014-01-01','ET','2',1,NULL,'Lorenzo White','FI','268965578','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:43',0,'2014-03-01 15:10:22'),(815,815,'2014-01-01','ET','2',1,NULL,'Samantha Fraley','FI','452579167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:45',0,'2014-03-01 15:10:22'),(14048,14499,'2014-01-01','ET','2',1,NULL,'ray collie','FI','287844118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:01',0,'2014-03-01 16:40:16'),(12466,12466,'2014-01-01','ET','2',1,NULL,'DIAMOND TAYLOR','FI','280020834','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:07',0,'2014-03-10 16:10:34'),(5610,5610,'2014-01-01','ET','2',1,NULL,'jeffrey carnes','FI','298785453','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:58',0,'2014-03-01 16:23:43'),(5614,5614,'2014-01-01','ET','2',1,NULL,'Donna Suski','FI','061422705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:08',0,'2014-03-01 16:23:43'),(1392,1392,'2014-01-01','ET','2',1,NULL,'Nasim Vamdehvar','FI','642981733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:46',0,'2014-03-02 04:45:37'),(3288,3288,'2014-01-01','ET','2',1,NULL,'Jonathan Reiff','FI','297803698','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:04',0,'2014-03-01 15:48:04'),(2895,2895,'2014-01-01','ET','2',1,NULL,'Cheryl Perkins','FI','281661911','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:33',0,'2014-03-10 13:39:10'),(1630,1630,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:57',0,'2014-03-01 20:10:57'),(17166,17816,'0000-00-00','ET','2',1,NULL,'Tobius Grove','FI','299766479','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:44',0,'2014-03-01 17:20:55'),(18749,19399,'0000-00-00','ET','2',1,NULL,'Lisa A Toomer','FI','439210300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:29',0,'2014-03-02 06:45:14'),(21074,21724,'0000-00-00','ET','2',1,NULL,'Charles James Jahn','FI','291981694','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:30',0,'2014-03-01 18:10:11'),(22446,23096,'0000-00-00','ET','2',1,NULL,'Kathy Martin','FI','466378246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:32',0,'2014-03-07 22:26:59'),(22615,23265,'0000-00-00','ET','2',1,NULL,'MARTIN ROBERT RASMUSSEN','FI','465979464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:00:05',0,'2014-03-08 22:26:18'),(243,243,'2014-01-01','ET','2',1,NULL,'bonnie ross','FI','287662504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:38',0,'2014-03-01 15:10:22'),(439,439,'2014-01-01','ET','2',1,NULL,'DEBORAH NICOLE COWAN','FI','428878806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:37',0,'2014-03-01 22:10:55'),(7077,7077,'2014-01-01','ET','2',2,1,'KATHLEEN  MARIE VINCENT','FI','278785838','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:54',0,'2014-03-01 15:52:44'),(3516,3516,'2014-01-01','ET','2',1,NULL,'SALLY  MONCOL','FI','285461289','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:42',0,'2014-03-01 15:37:30'),(15888,16537,'0000-00-00','ET','2',1,NULL,'Kimberly Smith','FI','428531152','Starmount Life Insurance Company','FI','720977315','LaMonica  Stewart','94','6401868','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:05',0,'2014-03-02 06:03:21'),(17386,18036,'0000-00-00','ET','2',2,1,'LARRY CIMINI','FI','274521649','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:32',0,'2014-03-01 17:20:55'),(17434,18084,'0000-00-00','ET','2',1,NULL,'RAYMOND SIMONS','FI','282868603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:01:05',0,'2014-03-02 06:31:45'),(17917,18567,'0000-00-00','ET','2',2,1,'DEBRA EXCELL','FI','547496639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:41',0,'2014-03-02 06:38:05'),(18657,19307,'0000-00-00','ET','2',1,NULL,'DIANA QUIROZ','FI','462258961','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:19',0,'2014-03-02 06:45:14'),(18772,19422,'0000-00-00','ET','2',1,NULL,'Janet Wiechman','FI','280484049','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:46',0,'2014-03-10 14:31:05'),(19566,20216,'0000-00-00','ET','2',1,NULL,'Lenny Javier','FI','661209156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:22:15',0,'2014-03-02 06:59:07'),(21123,21773,'0000-00-00','ET','2',2,1,'JAVIER TERRAZAS','FI','451654226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:02',0,'2014-03-02 07:23:39'),(601,601,'2014-01-01','ET','2',1,NULL,'choanne  menkhosf','FI','454311144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:38',0,'2014-03-02 02:10:49'),(616,616,'2014-01-01','ET','2',4,3,'John Ibekwe','FI','638846686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:07',0,'2014-03-02 02:10:49'),(14636,15087,'2014-01-01','ET','2',1,NULL,'Amy VanAlmen','FI','280723049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:45:12',0,'2014-03-01 16:46:19'),(3285,3285,'2014-01-01','ET','2',2,1,'Gregory Henderson','FI','302709590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:58',0,'2014-03-01 15:48:04'),(11842,11842,'2014-01-01','ET','2',1,NULL,'Leanna DeGroff','FI','083447988','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:29',0,'2014-03-10 13:45:57'),(20351,21001,'0000-00-00','ET','2',1,NULL,'Rachael Schneider','FI','284880705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:39',0,'2014-03-01 17:47:19'),(20697,21347,'0000-00-00','ET','2',1,NULL,'regina duhe','FI','415175216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:11',0,'2014-03-02 07:17:36'),(88,88,'2014-01-01','ET','2',1,NULL,'MARIA JOSEFA SHARARA','FI','267789826','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:40',0,'2014-03-01 22:10:55'),(16128,16777,'0000-00-00','ET','2',1,NULL,'richard coakley','FI','283562682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:39',0,'2014-03-10 14:20:26'),(16003,16652,'0000-00-00','ET','2',1,NULL,'Linda F Emerson','FI','453372740','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:13',0,'2014-03-02 06:03:21'),(14139,14590,'2014-01-01','ET','2',1,NULL,'Myrna Collins','FI','433924583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:00',0,'2014-03-02 05:38:34'),(4996,4996,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:50',0,'2014-03-01 15:31:33'),(12253,12253,'2014-01-01','ET','2',1,NULL,'Gracie Harris','FI','467454654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:32',0,'2014-03-02 05:03:29'),(12102,12102,'2014-01-01','ET','2',2,1,'Rikki Davidson','FI','406215985','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:46',0,'2014-03-01 16:30:17'),(12019,12019,'2014-01-01','ET','2',1,NULL,'Beth Reniff','FI','540089110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:48',0,'2014-03-02 04:59:36'),(2771,2771,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:19:24',0,'2014-03-01 16:05:34'),(17554,18204,'0000-00-00','ET','2',1,NULL,'Wayne McCarthy','FI','436435466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:37',0,'2014-03-02 06:31:45'),(17596,18246,'0000-00-00','ET','2',1,NULL,'Elsa De Jesus','94','0000640964','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-07 19:01:10',0,'2014-03-10 14:24:38'),(21999,22649,'0000-00-00','ET','2',1,NULL,'JOHNNY SCROGGINS','FI','272808342','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:52',0,'2014-03-10 16:44:18'),(1957,1957,'2014-01-01','ET','2',1,NULL,'Kenneth Treharn','FI','288489475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:26',0,'2014-03-01 15:26:40'),(4434,4434,'2014-01-01','ET','2',1,NULL,'Lindsey Tharpe','FI','436639588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:11',0,'2014-03-01 19:11:03'),(17391,18041,'0000-00-00','ET','2',1,NULL,'MARY BRIDGEFORD','FI','273666885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:35',0,'2014-03-01 17:20:55'),(21256,21906,'0000-00-00','ET','2',1,NULL,'Jared Swain','FI','287889412','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:34',0,'2014-03-01 21:35:40'),(5225,5225,'2014-01-01','ET','2',1,NULL,'JUDY LAVERNE ROBLING','FI','459948609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:14',0,'2014-03-02 00:10:48'),(2252,2252,'2014-01-01','ET','2',1,NULL,'Garry Swick','94','0000207093','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:00',0,'2014-03-10 13:10:24'),(12653,12653,'2014-01-01','ET','2',2,1,'charles breaux','FI','437198236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:02',0,'2014-03-02 05:10:52'),(13273,13629,'2014-01-01','ET','2',1,NULL,'Quoc Tran','FI','437818912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:01',0,'2014-03-02 05:24:45'),(18316,18966,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:16',0,'2014-03-01 17:26:36'),(18701,19351,'0000-00-00','ET','2',2,1,'Jeremy Sullivan','FI','272768956','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:53',0,'2014-03-10 14:31:05'),(19348,19998,'0000-00-00','ET','2',1,NULL,'SETHDRIC LEE','FI','438435464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-18 22:00:31',0,'2014-03-02 06:59:07'),(21235,21885,'0000-00-00','ET','2',1,NULL,'Robert Light','FI','278602952','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:19',0,'2014-03-10 14:45:25'),(22676,23326,'0000-00-00','ET','2',1,NULL,'STEVE MICKLE','FI','437339185','Starmount Life Insurance Company','FI','720977315','MICHAEL  KIRSCHMAN','94','171145428','348','2014-04-01','Sync Success',0,'2014-03-08 21:30:41',0,'2014-03-08 22:26:18'),(7612,7612,'2014-01-01','ET','2',2,1,'David Riffle','FI','282564960','Summa Insurance Company, Inc.','FI','341809108','Jeffrey  Harkleroad','94','1772711','348','2014-01-01','Sync Success',0,'2013-12-26 04:37:39',0,'2014-03-10 15:59:47'),(16837,17487,'0000-00-00','ET','2',1,NULL,'Kelly Lewis','FI','290903625','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:17',0,'2014-03-01 17:00:58'),(1217,1217,'2014-01-01','ET','2',1,NULL,'DARRYL MUMPHREY','FI','297646553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:17',0,'2014-03-01 16:15:39'),(16675,17325,'0000-00-00','ET','2',1,NULL,'Jermaine Curry','FI','292848882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:58',0,'2014-03-10 14:20:26'),(15349,15800,'0000-00-00','ET','2',1,NULL,'Melvina Harris','FI','433943742','Starmount Life Insurance Company','FI','720977315','greg  Town','94','1637275','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:48',0,'2014-03-02 05:52:31'),(15291,15742,'0000-00-00','ET','2',1,NULL,'bethany conklin','FI','103740899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-21 08:46:13',0,'2014-03-02 05:52:31'),(2422,2422,'2014-01-01','ET','2',1,NULL,'Linda Novak','FI','521661272','Summa Insurance Company, Inc.','FI','341809108','Larry C Barkley','94','520478','348','2014-01-01','Sync Success',0,'2013-12-25 20:17:57',0,'2014-03-10 15:45:56'),(13655,14011,'2014-01-01','ET','2',1,NULL,'Laurence Michlin','FI','466537072','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:12',0,'2014-03-02 05:24:45'),(5070,5070,'2014-01-01','ET','2',1,NULL,'Stanley Condo','FI','289488607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:15',0,'2014-03-01 15:31:33'),(22587,23237,'0000-00-00','ET','2',1,NULL,'Jon Wheatley','FI','454958189','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:13',0,'2014-03-07 22:26:59'),(490,490,'2014-01-01','ET','2',1,NULL,'Daniel Momper','FI','275562624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:10',0,'2014-03-01 15:48:04'),(11249,11249,'2014-01-01','ET','2',1,NULL,'Elizabeth  Ann Mathews','FI','269541175','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:57',0,'2014-03-01 16:23:43'),(16246,16895,'0000-00-00','ET','2',1,NULL,'CHERYL STEVENS','FI','513565095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:10',0,'2014-03-02 06:03:21'),(15946,16595,'0000-00-00','ET','2',1,NULL,'REX ROSE','FI','266375092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:19',0,'2014-03-02 06:03:21'),(15865,16514,'0000-00-00','ET','2',1,NULL,'Susan A Sites','FI','300685295','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:51',0,'2014-03-10 14:10:12'),(4218,4218,'2014-01-01','ET','2',1,NULL,'Brandon adkins','FI','296928732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:46',0,'2014-03-01 15:52:44'),(14362,14813,'2014-01-01','ET','2',1,NULL,'Barbara Nemeth','FI','277766615','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:50',0,'2014-03-10 16:17:47'),(14273,14724,'2014-01-01','ET','2',1,NULL,'Linda Wehby','FI','281525222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:12',0,'2014-03-01 16:46:19'),(4485,4485,'2014-01-01','ET','2',2,1,'Fern Wear','FI','566062069','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:35',0,'2014-03-01 21:11:04'),(4804,4804,'2014-01-01','ET','2',1,NULL,'ALBERT D GARGANO','FI','294505967','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:59',0,'2014-03-01 15:16:37'),(18277,18927,'0000-00-00','ET','2',2,1,'VINCENT SPEHAR','FI','285766564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:07',0,'2014-03-01 17:26:36'),(18449,19099,'0000-00-00','ET','2',1,NULL,'Linda Armsey','FI','284523863','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:37',0,'2014-03-10 16:31:33'),(22349,22999,'0000-00-00','ET','2',3,2,'EMILY GARZA','FI','280843026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:11',0,'2014-03-07 21:36:32'),(22858,23508,'0000-00-00','ET','2',1,NULL,'Denise Wallace','FI','449968295','Starmount Life Insurance Company','FI','720977315','Archer  Summer','94','801774','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:09',0,'2014-03-10 21:27:11'),(6171,6171,'2014-01-01','ET','2',1,NULL,'THANH HO','FI','606236926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:03:27',0,'2014-03-02 04:10:25'),(2322,2322,'2014-01-01','ET','2',2,1,'Gabriel Farias','FI','462792220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:59',0,'2014-03-01 19:11:03'),(15314,15765,'0000-00-00','ET','2',1,NULL,'STACY  GRESHAM','FI','273600443','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:26',0,'2014-03-01 16:50:53'),(22635,23285,'0000-00-00','ET','2',1,NULL,'DONNA JEAN KEITH','FI','296706092','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:08',0,'2014-03-08 21:35:36'),(23096,23746,'0000-00-00','ET','2',1,NULL,'MICHALE A GOUBEAUX','FI','289448299','Dental Care Plus, Inc.','FI','311185262','DAVID  COUFE','94','7506284','348','2014-04-01','Sync Success',0,'2014-03-10 21:29:58',0,'2014-03-10 21:36:25'),(782,782,'2014-01-01','ET','2',1,NULL,'Jonathan Corson','FI','288801327','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:30',0,'2014-03-01 15:05:09'),(16829,17479,'0000-00-00','ET','2',1,NULL,'LINDA SMITH-PETERS','FI','437844318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:12',0,'2014-03-02 06:17:30'),(1296,1296,'2014-01-01','ET','2',1,NULL,'SARAH CUBLEY','FI','425590116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:40',0,'2014-03-02 04:38:08'),(11115,11115,'2014-01-01','ET','2',1,NULL,'Andrew Zaborowski','94','0000227057','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:35',0,'2014-03-10 13:45:57'),(15361,15812,'0000-00-00','ET','2',1,NULL,'Tammie Warner','FI','270702525','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:55',0,'2014-03-10 14:10:12'),(6056,6056,'2014-01-01','ET','2',1,NULL,'quang pham','FI','558696506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:48',0,'2014-03-01 19:11:03'),(4047,4047,'2014-01-01','ET','2',2,1,'Miguel Rodriguez','FI','467756505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:35',0,'2014-03-02 03:09:49'),(5467,5467,'2014-01-01','ET','2',1,NULL,'Sally Brown','FI','435840384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:22',0,'2014-03-02 04:45:37'),(18934,19584,'0000-00-00','ET','2',1,NULL,'Karen Brzeski','FI','280808152','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:26',0,'2014-03-10 16:31:33'),(21057,21707,'0000-00-00','ET','2',1,NULL,'Mary McMahan','FI','275842964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:19',0,'2014-03-01 18:10:11'),(22491,23141,'0000-00-00','ET','2',1,NULL,'Pamela J Moritz','FI','294506969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:04',0,'2014-03-07 21:36:32'),(7686,7686,'2014-01-01','ET','2',1,NULL,'Maria Steiner','FI','300769625','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:40:02',0,'2014-03-10 13:39:10'),(2181,2181,'2014-01-01','ET','2',2,1,'QUANG NGUYEN','FI','615841767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:31',0,'2014-03-01 21:11:04'),(12002,12002,'2014-01-01','ET','2',2,1,'KEMING LI','FI','284783402','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:07',0,'2014-03-10 16:10:34'),(7060,7060,'2014-01-01','ET','2',1,NULL,'Brenda Phillips','FI','268620475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:02:20',0,'2014-03-01 15:52:44'),(17822,18472,'0000-00-00','ET','2',1,NULL,'Trumaine Davis','FI','434634930','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:53',0,'2014-03-02 06:10:30'),(20644,21294,'0000-00-00','ET','2',1,NULL,'Martwain Williams','FI','428632088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:20',0,'2014-03-02 07:10:28'),(11533,11533,'2014-01-01','ET','2',1,NULL,'ELDEN DOMINGO','FI','439358460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:37',0,'2014-03-02 04:52:44'),(17020,17670,'0000-00-00','ET','2',2,1,'Leslie Nadjafi Sadati','FI','439150766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:11',0,'2014-03-02 06:24:38'),(13477,13833,'2014-01-01','ET','2',1,NULL,'PHILLIP A STEWART','FI','285542383','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:37',0,'2014-03-10 14:03:26'),(10819,10819,'2014-01-01','ET','2',1,NULL,'Roy Mack','FI','435866362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:29',0,'2014-03-02 04:31:46'),(3214,3214,'2014-01-01','ET','2',1,NULL,'randy ruggles','FI','284568258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:47',0,'2014-03-01 15:52:44'),(18706,19356,'0000-00-00','ET','2',1,NULL,'Garrett Mills','FI','005762462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:57',0,'2014-03-02 06:45:14'),(20836,21486,'0000-00-00','ET','2',1,NULL,'Apolonio Alvizo','FI','451977008','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:15',0,'2014-03-02 07:17:36'),(21592,22242,'0000-00-00','ET','2',1,NULL,'REBECCA BUTLER','FI','434966054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:14',0,'2014-03-04 21:27:16'),(21697,22347,'0000-00-00','ET','2',6,5,'Joseph Manning','FI','300809549','Dental Care Plus, Inc.','FI','311185262','David  Cunix','94','2228850','348','2014-04-01','Sync Success',0,'2014-03-04 21:01:36',0,'2014-03-04 21:36:30'),(5575,5575,'2014-01-01','ET','2',2,1,'SAJEETHA SALAHUDEEN','FI','638705044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:51',0,'2014-03-02 04:45:37'),(12055,12055,'2014-01-01','ET','2',1,NULL,'YOLANDA SEBAN','FI','457779914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:11',0,'2014-03-02 04:59:36'),(14122,14573,'2014-01-01','ET','2',1,NULL,'Lenard DAVIS','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:50',0,'2014-03-02 05:38:34'),(16118,16767,'0000-00-00','ET','2',1,NULL,'CALEB ARMSTRONG','FI','428530254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:31',0,'2014-03-02 06:03:21'),(20467,21117,'0000-00-00','ET','2',1,NULL,'Denise Davis','FI','272483742','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:21',0,'2014-03-01 18:08:07'),(22259,22909,'0000-00-00','ET','2',2,1,'Robert Crane','FI','278445175','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:23',0,'2014-03-10 16:44:18'),(1587,1587,'2014-01-01','ET','2',1,NULL,'LINDA BURROWS','FI','272769956','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:51',0,'2014-03-01 15:10:22'),(16053,16702,'0000-00-00','ET','2',1,NULL,'Cheryl Loudella Perdue','FI','553944087','Dental Care Plus, Inc.','FI','311185262','Tilman E McGibboney','94','8354593','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:46',0,'2014-03-01 16:56:22'),(5823,5823,'2014-01-01','ET','2',1,NULL,'Christopher Alan Boehme','FI','463770985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:10',0,'2014-03-01 20:10:57'),(10625,10625,'2014-01-01','ET','2',1,NULL,'DANN GREGORY','FI','449536125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:59',0,'2014-03-02 04:31:46'),(11166,11166,'2014-01-01','ET','2',1,NULL,'thomas young','FI','299868673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:30',0,'2014-03-10 13:45:57'),(14193,14644,'2014-01-01','ET','2',2,1,'Deborah Thompson','FI','190568285','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:34',0,'2014-03-10 14:03:26'),(13357,13713,'2014-01-01','ET','2',1,NULL,'Susan Nardi-Unger','FI','225667226','Starmount Life Insurance Company','FI','720977315','Matthew   Dahlen','94','16804332','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:35',0,'2014-03-02 05:24:45'),(12723,12723,'2014-01-01','ET','2',1,NULL,'John Robert Mann','FI','270527425','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:40',0,'2014-03-10 13:59:38'),(12660,12660,'2014-01-01','ET','2',1,NULL,'Renee Jordan','FI','269862994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:20',0,'2014-03-01 16:35:14'),(11667,11667,'2014-01-01','ET','2',2,1,'Jeffrey Kutz','FI','275563572','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:50',0,'2014-03-10 13:52:32'),(11405,11405,'2014-01-01','ET','2',1,NULL,'Chris Jones','FI','279484889','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:43',0,'2014-03-10 13:52:32'),(16220,16869,'0000-00-00','ET','2',1,NULL,'Emma Means','FI','464928822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:53',0,'2014-03-02 06:10:30'),(17651,18301,'0000-00-00','ET','2',1,NULL,'Neomarie Massa','FI','582971684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:36',0,'2014-03-02 06:31:45'),(18741,19391,'0000-00-00','ET','2',3,2,'LISA VASALLE','FI','334544084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:23',0,'2014-03-02 06:45:14'),(21086,21736,'0000-00-00','ET','2',1,NULL,'MARGARET FAYE TENNEY','FI','527156984','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:38',0,'2014-03-10 16:38:05'),(21481,22131,'0000-00-00','ET','2',1,NULL,'Michelle Madison','FI','291623252','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:42',0,'2014-03-03 21:36:16'),(1717,1717,'2014-01-01','ET','2',1,NULL,'Rosamunde Monika Wrann','FI','286540364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:01',0,'2014-03-01 15:31:33'),(15788,16437,'0000-00-00','ET','2',1,NULL,'STEPHANIE BORJAS','FI','638034088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-24 21:00:05',0,'2014-03-02 06:03:21'),(3469,3469,'2014-01-01','ET','2',1,NULL,'ANTHONY LEO DAMES','FI','268664354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:12',0,'2014-03-01 15:31:33'),(13146,13502,'2014-01-01','ET','2',1,NULL,'TINICA L COLBERT','FI','435415148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:46',0,'2014-03-02 05:17:40'),(17775,18425,'0000-00-00','ET','2',1,NULL,'Amber Lanham','FI','465859733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:13',0,'2014-03-02 06:17:30'),(19340,19990,'0000-00-00','ET','2',1,NULL,'ROBERT JOHNSON','FI','452984438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-18 22:00:26',0,'2014-03-02 06:59:07'),(19405,20055,'0000-00-00','ET','2',1,NULL,'Kathy Martin','FI','272564473','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:12',0,'2014-03-10 16:31:33'),(22338,22988,'0000-00-00','ET','2',1,NULL,'megan martin','FI','481131815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:24',0,'2014-03-06 21:36:23'),(4548,4548,'2014-01-01','ET','2',2,1,'Corandolia Taylor','FI','433923596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:38',0,'2014-03-02 04:31:46'),(13974,14330,'2014-01-01','ET','2',1,NULL,'DEBRA ELIZABETH MURCER','FI','449394149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:11',0,'2014-03-02 05:31:31'),(13583,13939,'2014-01-01','ET','2',2,1,'Leslie Mahoney','FI','301660730','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:12',0,'2014-03-10 16:10:34'),(3887,3887,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:48',0,'2014-03-01 15:05:09'),(12774,12774,'2014-01-01','ET','2',3,2,'LUIS  A HERNANDEZ','FI','406494980','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:15',0,'2014-03-01 16:35:14'),(16788,17438,'0000-00-00','ET','2',1,NULL,'Tien Le','FI','289924402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:33',0,'2014-03-01 17:00:58'),(16913,17563,'0000-00-00','ET','2',1,NULL,'Willie R Coleman','FI','269668517','Dental Care Plus, Inc.','FI','311185262','Renee A Terry-Wiggins','94','16417102','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:34',0,'2014-03-01 17:00:58'),(17161,17811,'0000-00-00','ET','2',2,1,'YOKO CRESSIE','FI','478152700','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:41',0,'2014-03-01 17:00:58'),(17571,18221,'0000-00-00','ET','2',1,NULL,'BONNIE ROCKWELL','FI','293542445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:50',0,'2014-03-01 17:20:55'),(17611,18261,'0000-00-00','ET','2',1,NULL,'JAMES  C PETEET','FI','453866004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:10',0,'2014-03-02 06:31:45'),(20915,21565,'0000-00-00','ET','2',1,NULL,'Elizabeth Jacob','FI','269563461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:09',0,'2014-03-01 18:08:07'),(5650,5650,'2014-01-01','ET','2',1,NULL,'Dennis Ford','FI','427026871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:19',0,'2014-03-02 04:45:37'),(15546,15997,'0000-00-00','ET','2',1,NULL,'Iovani Villegas','FI','639240282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:12',0,'2014-03-02 05:59:43'),(5496,5496,'2014-01-01','ET','2',1,NULL,'Garland Givens','FI','285803627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:18',0,'2014-03-01 16:23:43'),(16850,17500,'0000-00-00','ET','2',1,NULL,'Veronica Lindsey','FI','268589295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:24',0,'2014-03-01 17:00:58'),(17459,18109,'0000-00-00','ET','2',2,1,'BENJAMIN  MARRERO TORRES','FI','583341185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:23',0,'2014-03-02 06:31:45'),(18332,18982,'0000-00-00','ET','2',1,NULL,'David Anthony Smith','FI','293920363','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:15',0,'2014-03-01 17:26:36'),(19418,20068,'0000-00-00','ET','2',1,NULL,'Sheila Elliott','FI','281526449','HealthSpan','FI','311431434','Paul  Sullivan','94','3667671','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:23',0,'2014-03-10 14:37:47'),(21596,22246,'0000-00-00','ET','2',2,1,'EDWARD  LEE FAIRCHILD','FI','435040086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:16',0,'2014-03-04 21:27:16'),(126,126,'2014-01-01','ET','2',2,1,'Teresa Lynn Canterbury','FI','274708367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:53',0,'2014-03-10 15:45:56'),(15466,15917,'0000-00-00','ET','2',1,NULL,'Christopher Cooper','FI','275700340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:52',0,'2014-03-01 16:50:53'),(6326,6326,'2014-01-01','ET','2',1,NULL,'Kyle Nichol','FI','291763723','Summa Insurance Company, Inc.','FI','341809108','Mike  Kost','94','1924114','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:12',0,'2014-03-10 15:59:47'),(1369,1369,'2014-01-01','ET','2',1,NULL,'Victoriano Espinoza','FI','450948034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:53:01',0,'2014-03-02 04:38:08'),(2101,2101,'2014-01-01','ET','2',1,NULL,'William Spoor','FI','286466089','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:38:06',0,'2014-03-10 13:20:27'),(20284,20934,'0000-00-00','ET','2',1,NULL,'Deborah Gibson','FI','302607765','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:29',0,'2014-03-10 14:37:47'),(21205,21855,'0000-00-00','ET','2',1,NULL,'Marynka Marquez','FI','629123231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-01 19:00:06',0,'2014-03-02 07:23:39'),(10569,10569,'2014-01-01','ET','2',1,NULL,'Callena Smith','FI','612183545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:11',0,'2014-03-02 04:24:47'),(15258,15709,'0000-00-00','ET','2',1,NULL,'Charles Ward','FI','280602365','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-21 08:45:35',0,'2014-03-10 14:10:12'),(12130,12130,'2014-01-01','ET','2',1,NULL,'DONNY  JOHNSON','FI','274843975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:46',0,'2014-03-01 16:30:17'),(14818,15269,'2014-01-01','ET','2',3,2,'Randy Marmer','FI','292463379','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:10',0,'2014-03-10 14:03:26'),(2705,2705,'2014-01-01','ET','2',1,NULL,'Joyce K Woods','FI','452983986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:21',0,'2014-03-02 04:15:49'),(11826,11826,'2014-01-01','ET','2',1,NULL,'SHARONNE L STEVENSON','FI','438817297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:56',0,'2014-03-02 04:31:46'),(5950,5950,'2014-01-01','ET','2',1,NULL,'Joshua Henderson','FI','400332535','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:18',0,'2014-03-02 02:10:49'),(20229,20879,'0000-00-00','ET','2',1,NULL,'EVELYN SHARP','FI','223924786','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:53',0,'2014-03-02 07:10:28'),(20770,21420,'0000-00-00','ET','2',2,1,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:44',0,'2014-03-01 18:10:11'),(679,679,'2014-01-01','ET','2',2,1,'SAMUEL BURSAC','FI','299526199','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:04',0,'2014-03-10 15:52:36'),(1924,1924,'2014-01-01','ET','2',1,NULL,'John  Robert  Cimachowski','FI','280705773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:28',0,'2014-03-01 15:26:40'),(13557,13913,'2014-01-01','ET','2',1,NULL,'EUGENIA WILLIAMS','FI','438233890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:52',0,'2014-03-02 05:31:31'),(2622,2622,'2014-01-01','ET','2',1,NULL,'Rosanda Marija Neal','FI','272170364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:39',0,'2014-03-01 15:16:37'),(5951,5951,'2014-01-01','ET','2',1,NULL,'Steven Martin','FI','280487228','HealthSpan','FI','311431434','Michael  Groh','94','2767799','348','2014-01-01','Sync Success',0,'2013-12-26 02:32:21',0,'2014-03-10 13:24:34'),(19349,19999,'0000-00-00','ET','2',2,1,'ALLEN BROWN','FI','434657146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:32',0,'2014-03-02 06:59:07'),(20663,21313,'0000-00-00','ET','2',1,NULL,'LeAnna Berry','FI','286847724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:35',0,'2014-03-10 16:38:05'),(21687,22337,'0000-00-00','ET','2',1,NULL,'ALLEN HARKINS','FI','274461751','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:28',0,'2014-03-04 21:36:30'),(21794,22444,'0000-00-00','ET','2',2,1,'NORA G RAMIREZ','FI','467961152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:12',0,'2014-03-04 22:25:23'),(6006,6006,'2014-01-01','ET','2',1,NULL,'David Emig','FI','287861450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:08',0,'2014-03-01 15:10:22'),(16573,17223,'0000-00-00','ET','2',1,NULL,'JANET BRODBECK','FI','286602554','HealthSpan','FI','311431434','JOSEPH T HESSLING','94','7320983','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:25',0,'2014-03-10 14:20:26'),(15818,16467,'0000-00-00','ET','2',1,NULL,'Patricia Davis','FI','208387209','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:22',0,'2014-03-02 06:03:21'),(728,728,'2014-01-01','ET','2',1,NULL,'Teresa Edwards','FI','368824238','Starmount Life Insurance Company','FI','720977315','Wendy  Moore','94','17027080','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:43',0,'2014-03-02 02:10:49'),(5834,5834,'2014-01-01','ET','2',1,NULL,'Tamoria Lowe','FI','437511572','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 02:15:32',NULL,NULL),(2346,2346,'2014-01-01','ET','2',2,1,'ADAM SHORT','FI','292886274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:32',0,'2014-03-01 15:26:40'),(2952,2952,'2014-01-01','ET','2',1,NULL,'Jason Troyan','FI','278743672','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:38',0,'2014-03-01 15:37:30'),(5781,5781,'2014-01-01','ET','2',1,NULL,'JAMES MCCARTHY','FI','302482818','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:58',0,'2014-03-10 15:52:36'),(17553,18203,'0000-00-00','ET','2',1,NULL,'CATHERINE  VENABLE','FI','566112601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:36',0,'2014-03-02 06:31:45'),(19252,19902,'0000-00-00','ET','2',1,NULL,'Kathy Howard','FI','268605480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:41',0,'2014-03-10 14:31:05'),(19807,20457,'0000-00-00','ET','2',1,NULL,'Shirley Magness','FI','510708436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:29',0,'2014-03-02 07:03:25'),(21758,22408,'0000-00-00','ET','2',4,3,'Heather Elaine Wills','FI','282842126','HealthSpan','FI','311431434','Deborah   Kos','94','967498','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:27',0,'2014-03-10 14:45:25'),(4933,4933,'2014-01-01','ET','2',1,0,'Erica Jane Moore','FI','283820184','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:31:13',0,'2014-03-10 13:03:33'),(645,645,'2014-01-01','ET','2',2,1,'Dean Wood','FI','411454875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:04',0,'2014-03-02 02:10:49'),(2815,2815,'2014-01-01','ET','2',1,NULL,'THOMAS THOMPSON','FI','279928682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:48',0,'2014-03-01 16:05:34'),(12060,12060,'2014-01-01','ET','2',2,1,'Timothy Valluzzi','FI','141462628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:21',0,'2014-03-02 05:03:29'),(12633,12633,'2014-01-01','ET','2',1,NULL,'Alexander Nash','FI','396983101','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:14',0,'2014-03-02 05:10:52'),(18618,19268,'0000-00-00','ET','2',1,NULL,'BRENDA ABBOTT','FI','279528500','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:48',0,'2014-03-10 16:31:33'),(20232,20882,'0000-00-00','ET','2',1,NULL,'AMBER HUSCROFT','FI','466990799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:55',0,'2014-03-02 07:10:28'),(22750,23400,'0000-00-00','ET','2',1,NULL,'carolyn m hampton','FI','437296363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:11',0,'2014-03-09 21:26:00'),(10897,10897,'2014-01-01','ET','2',2,1,'Kimelia Wooten','FI','435069905','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:32',0,'2014-03-02 04:24:47'),(10886,10886,'2014-01-01','ET','2',1,NULL,'Rose Tademy','FI','436042000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:10',0,'2014-03-02 04:24:47'),(6087,6087,'2014-01-01','ET','2',1,NULL,'Saundra Rudolph','FI','296627140','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:56',0,'2014-03-01 16:00:27'),(12718,12718,'2014-01-01','ET','2',2,1,'Gaines Gafford','FI','439471697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:26',0,'2014-03-02 05:10:52'),(17963,18613,'0000-00-00','ET','2',1,NULL,'SINDY ROBBINS','FI','171465851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:13',0,'2014-03-01 17:20:55'),(19038,19688,'0000-00-00','ET','2',1,NULL,'chelbie turner','FI','632289868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:10',0,'2014-03-02 06:52:12'),(20043,20693,'0000-00-00','ET','2',1,NULL,'Mary Elizabeth Wright','FI','433676969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:14',0,'2014-03-02 07:03:25'),(21351,22001,'0000-00-00','ET','2',2,1,'Ricky William Neff','FI','288667237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:24',0,'2014-03-03 01:35:37'),(21729,22379,'0000-00-00','ET','2',1,NULL,'Brittany Quidgeon','FI','250776774','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:02',0,'2014-03-10 16:44:18'),(22262,22912,'0000-00-00','ET','2',1,NULL,'Becky J Shank','FI','285641153','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:25',0,'2014-03-10 16:44:18'),(22815,23465,'0000-00-00','ET','2',1,NULL,'MARY MAY','FI','291489172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:05',0,'2014-03-10 14:50:59'),(319,319,'2014-01-01','ET','2',3,2,'Margaret McRae-Gibson','FI','284624412','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:48',0,'2014-03-10 13:10:24'),(16887,17537,'0000-00-00','ET','2',1,NULL,'Ami Flores','FI','639032546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:18',0,'2014-03-02 06:24:38'),(16681,17331,'0000-00-00','ET','2',1,NULL,'Tonya Joanne Guggenheim','FI','452738652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:01:03',0,'2014-03-02 06:17:30'),(17272,17922,'0000-00-00','ET','2',1,NULL,'Timothy Valenta','FI','449316301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:41',0,'2014-03-02 06:24:38'),(18560,19210,'0000-00-00','ET','2',1,NULL,'Mark Hazelwood','FI','279840264','HealthSpan','FI','311431434','Michael  Bennett','94','8790924','357','2014-02-28','Sync Success',0,'2014-02-13 21:30:16',0,'2014-03-10 14:31:05'),(18989,19639,'0000-00-00','ET','2',2,1,'Nikola Alan Wells','94','0001157609','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:06',0,'2014-03-10 14:31:05'),(23012,23662,'0000-00-00','ET','2',1,NULL,'Nicholas Smith','94','0000475719','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:59',0,'2014-03-10 21:27:11'),(248,248,'2014-01-01','ET','2',1,NULL,'Carolyn Francis','FI','438902788','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 17:30:47',0,'2014-03-01 20:10:57'),(586,586,'2014-01-01','ET','2',1,NULL,'Jonathan Lege','FI','436615519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:08',0,'2014-03-02 02:10:49'),(13785,14141,'2014-01-01','ET','2',1,NULL,'Danny Plasterer','FI','271447727','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:37',0,'2014-03-10 13:59:38'),(2255,2255,'2014-01-01','ET','2',1,NULL,'Kathleen Hemmelgarn','FI','290486790','HealthSpan','FI','311431434','Amy  Sheaks','94','15838390','348','2014-01-01','Sync Success',0,'2013-12-25 19:50:05',0,'2014-03-10 13:10:24'),(13456,13812,'2014-01-01','ET','2',1,NULL,'Gloria Adams','FI','520279897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:24',0,'2014-03-02 05:31:31'),(13236,13592,'2014-01-01','ET','2',1,NULL,'Susan Lyn Jones','FI','294482483','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:32',0,'2014-03-01 16:35:14'),(3181,3181,'2014-01-01','ET','2',1,NULL,'Julie Rudd','FI','092729969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:54',0,'2014-03-10 13:24:34'),(11308,11308,'2014-01-01','ET','2',1,NULL,'Dotzie Davis','FI','551087230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:45',0,'2014-03-02 04:45:37'),(6076,6076,'2014-01-01','ET','2',1,NULL,'Marcy Watkins','FI','436040202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:33',0,'2014-03-02 04:10:25'),(4592,4592,'2014-01-01','ET','2',1,NULL,'ORLANDO HUGHES','FI','287927663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:01',0,'2014-03-01 16:15:39'),(5405,5405,'2014-01-01','ET','2',4,3,'Ashley Trainer Smas','FI','300868807','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:23',0,'2014-03-10 15:39:19'),(15150,15601,'0000-00-00','ET','2',1,NULL,'Daliska Bridgeman','FI','426192358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:27',0,'2014-03-02 05:52:31'),(16255,16904,'0000-00-00','ET','2',1,NULL,'Jessica Budd','FI','301907778','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:16',0,'2014-03-10 16:24:30'),(16415,17065,'0000-00-00','ET','2',1,NULL,'Karen Barhite','FI','283420855','HealthSpan','FI','311431434','David  Sickles','94','1787303','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:36',0,'2014-03-10 14:20:26'),(17862,18512,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:11',0,'2014-03-02 06:38:05'),(18549,19199,'0000-00-00','ET','2',1,NULL,'Cynthia Sand','FI','271489368','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','348','2014-03-01','Sync Success',0,'2014-02-13 21:30:11',0,'2014-03-01 17:26:36'),(20776,21426,'0000-00-00','ET','2',1,NULL,'Jane Suveges','FI','282482366','Summa Insurance Company, Inc.','FI','341809108','Thomas A Sesny','94','2772106','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:47',0,'2014-03-10 16:38:05'),(21875,22525,'0000-00-00','ET','2',1,NULL,'BETTY NAPIER','FI','285665117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:24',0,'2014-03-05 21:36:22'),(2801,2801,'2014-01-01','ET','2',1,NULL,'Stephan Richard Makowski','FI','284865055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:23',0,'2014-03-01 16:05:34'),(5432,5432,'2014-01-01','ET','2',1,0,'Vharmella Terrell','FI','288607909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:24',0,'2014-03-01 15:05:09'),(11648,11648,'2014-01-01','ET','2',1,NULL,'Randi Gail Fox','FI','282566117','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:13',0,'2014-03-10 16:03:49'),(12740,12740,'2014-01-01','ET','2',1,NULL,'ERIC ANTHONY HAYDEN','FI','293603752','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:19',0,'2014-03-10 13:59:38'),(15116,15567,'0000-00-00','ET','2',2,1,'TERESA GAJKOWSKI','FI','271887689','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:01',0,'2014-03-01 16:50:53'),(15170,15621,'0000-00-00','ET','2',1,NULL,'Jacquelyn Danchisen','FI','291604738','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:41',0,'2014-03-10 14:10:12'),(17377,18027,'0000-00-00','ET','2',1,NULL,'DANE CREECH','FI','616221648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:26',0,'2014-03-02 06:31:45'),(17856,18506,'0000-00-00','ET','2',1,NULL,'Jessamyn Farkas','FI','130682610','Starmount Life Insurance Company','FI','720977315','Linda  Carter','94','1033689','348','2014-03-01','Sync Success',0,'2014-02-10 21:00:07',0,'2014-03-02 06:38:05'),(18986,19636,'0000-00-00','ET','2',1,NULL,'CAROLINE CARNEY','FI','415457464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:04',0,'2014-03-02 06:52:12'),(19263,19913,'0000-00-00','ET','2',1,NULL,'Phung Tu','FI','638448891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:08',0,'2014-03-02 06:52:12'),(19355,20005,'0000-00-00','ET','2',1,NULL,'Richard  A LaFargue','FI','436217266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:36',0,'2014-03-02 06:59:07'),(22210,22860,'0000-00-00','ET','2',1,NULL,'Norman Tchorz','FI','274921559','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:47',0,'2014-03-06 21:36:23'),(488,488,'2014-01-01','ET','2',1,NULL,'william dunlap','FI','296408553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:06',0,'2014-03-01 15:48:04'),(1150,1150,'2014-01-01','ET','2',1,NULL,'Alice Hobbs','FI','436047098','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:12',0,'2014-03-02 04:38:08'),(2651,2651,'2014-01-01','ET','2',1,NULL,'Abigail Koon','FI','291887766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:26',0,'2014-03-01 16:05:34'),(12656,12656,'2014-01-01','ET','2',2,1,'Phuong Van','FI','374191965','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-03 02:03:09',0,'2014-03-02 05:10:52'),(4445,4445,'2014-01-01','ET','2',1,NULL,'Murad Hanna','FI','791044628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:16',0,'2014-03-01 15:16:37'),(5803,5803,'2014-01-01','ET','2',1,NULL,'richard mcnair','FI','425350639','Starmount Life Insurance Company','FI','720977315','leo  flemming','94','10085604','348','2014-01-01','Sync Success',0,'2013-12-26 02:03:39',0,'2014-03-02 01:10:33'),(15630,16081,'0000-00-00','ET','2',1,NULL,'James Quilty','FI','277748653','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:50',0,'2014-03-10 16:17:47'),(15877,16526,'0000-00-00','ET','2',1,NULL,'Richard Reed','FI','299443334','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:58',0,'2014-03-10 16:24:30'),(18317,18967,'0000-00-00','ET','2',2,1,'Kayla Prater','FI','427712848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:17',0,'2014-03-02 06:45:14'),(19535,20185,'0000-00-00','ET','2',1,NULL,'JUSTIN COURSE','FI','425634941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:14:22',0,'2014-03-02 06:59:07'),(20538,21188,'0000-00-00','ET','2',2,1,'CELESTE SANTOS','FI','465690846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:09',0,'2014-03-02 07:10:28'),(20927,21577,'0000-00-00','ET','2',1,NULL,'Dorey Lee Bates','FI','433738020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:19',0,'2014-03-02 07:10:28'),(21234,21884,'0000-00-00','ET','2',1,NULL,'Mona Elkhansa','FI','433777107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:19',0,'2014-03-02 07:23:39'),(858,858,'2014-01-01','ET','2',1,NULL,'stanley Whisenant','FI','443787505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:54',0,'2014-03-01 22:10:55'),(4169,4169,'2014-01-01','ET','2',1,NULL,'LARRELL RITENOUR','FI','268524480','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:15',0,'2014-03-10 15:59:47'),(13928,14284,'2014-01-01','ET','2',1,NULL,'Pamela Cross','FI','280606597','HealthSpan','FI','311431434','Tamy  Hagan','94','3691584','357','2014-02-01','Sync Success',0,'2014-01-13 03:00:18',0,'2014-03-10 14:03:26'),(11018,11018,'2014-01-01','ET','2',1,NULL,'Stanley Wesley','FI','426271200','Starmount Life Insurance Company','FI','720977315','Jeffrey  Chance','94','2114967','348','2014-01-01','Sync Success',0,'2013-12-26 13:11:25',0,'2014-03-02 04:31:46'),(10523,10523,'2014-01-01','ET','2',1,NULL,'Lee Lallier','FI','462805943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:35',0,'2014-03-02 04:24:47'),(5959,5959,'2014-01-01','ET','2',1,NULL,'Rebeka Renae Calhoun','FI','461833108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:37',0,'2014-03-02 01:10:33'),(7073,7073,'2014-01-01','ET','2',1,NULL,'Elio Brunicardi','FI','288133774','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:46',0,'2014-03-01 15:52:44'),(6009,6009,'2014-01-01','ET','2',1,NULL,'Ann Crock','FI','293862374','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:13',0,'2014-03-01 15:10:22'),(5969,5969,'2014-01-01','ET','2',1,NULL,'zainab fazalbhoy','FI','633489758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:57',0,'2014-03-02 02:10:49'),(15319,15770,'0000-00-00','ET','2',1,NULL,'Rachel Tara Krasinski','FI','300700513','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:29',0,'2014-03-10 14:10:12'),(16701,17351,'0000-00-00','ET','2',1,NULL,'Kimberly Lester','FI','290705998','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:18',0,'2014-03-01 17:00:58'),(18648,19298,'0000-00-00','ET','2',1,NULL,'WILLIAM KERMIT STOCKTON','FI','234175296','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:12',0,'2014-03-01 17:34:07'),(19800,20450,'0000-00-00','ET','2',2,1,'EDWARD  LEE FAIRCHILD','FI','435040086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:23',0,'2014-03-02 06:59:07'),(19948,20598,'0000-00-00','ET','2',2,1,'Guadalupe Guerra','FI','450899600','Starmount Life Insurance Company','FI','720977315','James  Kirkpatrick','94','837900','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:14',0,'2014-03-02 07:03:25'),(20453,21103,'0000-00-00','ET','2',1,NULL,'SANDRA LEE OSTENKAMP','FI','287548103','HealthSpan','FI','311431434','Micheal  Groh','94','2767799','348','2014-04-01','Sync Success',0,'2014-02-26 09:31:08',0,'2014-03-10 14:37:47'),(21077,21727,'0000-00-00','ET','2',1,NULL,'JUDY BLOOMFIELD','FI','284540688','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:31',0,'2014-03-01 18:10:11'),(461,461,'2014-01-01','ET','2',1,NULL,'Thomas Weiker','FI','287566569','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:21',0,'2014-03-10 13:10:24'),(697,697,'2014-01-01','ET','2',1,NULL,'Matthew Whittenbarger','FI','301663352','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:39',0,'2014-03-10 13:24:34'),(5814,5814,'2014-01-01','ET','2',2,1,'William Bunton','FI','509643458','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:04:00',0,'2014-03-10 15:52:36'),(6256,6256,'2014-01-01','ET','2',1,NULL,'David Ocasio','FI','594667345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:06',0,'2014-03-02 04:10:25'),(11576,11576,'2014-01-01','ET','2',1,NULL,'john mcgee','FI','459939691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:34:01',0,'2014-03-02 04:52:44'),(506,506,'2014-01-01','ET','2',1,NULL,'Melissa Wink','FI','220980978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:39',0,'2014-03-01 15:48:04'),(2873,2873,'2014-01-01','ET','2',1,NULL,'Gary Stephens','FI','280564096','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:45',0,'2014-03-10 13:39:10'),(3473,3473,'2014-01-01','ET','2',1,NULL,'Katie Taulbee','FI','298841167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:19',0,'2014-03-01 15:31:33'),(3510,3510,'2014-01-01','ET','2',1,NULL,'Eric Brown','FI','292803286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:32',0,'2014-03-01 15:37:30'),(4088,4088,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:02:56',0,'2014-03-01 16:00:27'),(4846,4846,'2014-01-01','ET','2',1,NULL,'Cynthia Kay Rawson','FI','301563844','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:28',0,'2014-03-10 15:39:19'),(16148,16797,'0000-00-00','ET','2',2,1,'ROY PERKINS','FI','433256220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:06',0,'2014-03-02 06:10:30'),(16915,17565,'0000-00-00','ET','2',1,NULL,'Mary Jane Jones','FI','271609077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-02-03 21:00:35',NULL,NULL),(18606,19256,'0000-00-00','ET','2',1,NULL,'Paulla Litten','FI','273542498','Summa Insurance Company, Inc.','FI','341809108','Timothy  Charron','94','7944002','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:40',0,'2014-03-10 16:31:33'),(19431,20081,'0000-00-00','ET','2',1,NULL,'Caron Cable','FI','461780621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:31',0,'2014-03-02 06:59:07'),(19918,20568,'0000-00-00','ET','2',1,NULL,'MARIA BUTLER','FI','372609998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:15',0,'2014-03-02 07:03:25'),(53,53,'2014-01-01','ET','2',1,NULL,'Jeffrey Cox','FI','284869286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:36',0,'2014-03-01 15:21:15'),(14329,14780,'2014-01-01','ET','2',1,NULL,'andrew ashmore','FI','431699233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:37',0,'2014-03-02 05:38:34'),(14199,14650,'2014-01-01','ET','2',1,NULL,'Robert Zayas','94','0001122211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:38',0,'2014-03-02 05:38:34'),(4814,4814,'2014-01-01','ET','2',1,NULL,'Wayne Thayer','FI','268522598','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:16',0,'2014-03-10 15:39:19'),(13410,13766,'2014-01-01','ET','2',1,NULL,'Mary Giannini','FI','028465341','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:59',0,'2014-03-10 16:10:34'),(13050,13406,'2014-01-01','ET','2',1,NULL,'RUBY ASHLEY','FI','438842149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:07',0,'2014-03-02 05:17:40'),(5994,5994,'2014-01-01','ET','2',1,NULL,'Kari Blevins','FI','271804648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:50',0,'2014-03-10 13:24:34'),(11490,11490,'2014-01-01','ET','2',1,NULL,'Matthew Wayne Day','FI','466933983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:31:22',0,'2014-03-02 04:52:44'),(6260,6260,'2014-01-01','ET','2',1,NULL,'SUILEMAN DOWED','FI','522471770','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:13',0,'2014-03-02 04:10:25'),(12457,12457,'2014-01-01','ET','2',1,NULL,'Donald  Guenther','FI','272547300','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:46',0,'2014-03-10 16:10:34'),(7142,7142,'2014-01-01','ET','2',1,NULL,'Elizabeth A Wilson','FI','279867587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:52',0,'2014-03-10 15:59:47'),(15273,15724,'0000-00-00','ET','2',2,1,'Rae Beaumont Provido  Guasa','FI','632311902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:02',0,'2014-03-02 05:52:31'),(15304,15755,'0000-00-00','ET','2',1,NULL,'John Chop','FI','321601567','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:20',0,'2014-03-01 16:50:53'),(15584,16035,'0000-00-00','ET','2',1,NULL,'Constance Haefner','FI','274566808','HealthSpan','FI','311431434','Steven A Truman','94','1926734','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:29',0,'2014-03-10 14:10:12'),(15744,16393,'0000-00-00','ET','2',1,NULL,'sandra bentley','FI','240826832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:18',0,'2014-03-10 14:10:12'),(16511,17161,'0000-00-00','ET','2',2,1,'Robin Hawkins','FI','465658246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:43',0,'2014-03-02 06:17:30'),(17135,17785,'0000-00-00','ET','2',2,1,'Charlotte Love','FI','413131183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:22',0,'2014-03-02 06:24:38'),(17924,18574,'0000-00-00','ET','2',1,NULL,'MARGARET HANCOCK','FI','467822574','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:46',0,'2014-03-02 06:38:05'),(19232,19882,'0000-00-00','ET','2',2,1,'CLAUDIA PEREZ','FI','635071419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:25',0,'2014-03-02 06:52:12'),(19423,20073,'0000-00-00','ET','2',1,NULL,'Shannon Cartier','FI','271882743','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:26',0,'2014-03-10 14:31:05'),(19999,20649,'0000-00-00','ET','2',1,NULL,'Tony Allan Swander','FI','296561121','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:52',0,'2014-03-01 17:47:19'),(20134,20784,'0000-00-00','ET','2',3,2,'Lawanna Barber','FI','299806505','Dental Care Plus, Inc.','FI','311185262','Patrick  Hill','94','9833181','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:44',0,'2014-03-01 18:08:07'),(20412,21062,'0000-00-00','ET','2',1,NULL,'Marie Anderson','FI','433151558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:36',0,'2014-03-02 07:10:28'),(172,172,'2014-01-01','ET','2',1,NULL,'Vickey Shoemichael','FI','437198616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:21',0,'2014-03-01 22:10:55'),(14478,14929,'2014-01-01','ET','2',4,3,'Tanya Ker','FI','287740884','HealthSpan','FI','311431434','Richard  Overbeck','94','999026','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:42',0,'2014-03-10 14:03:26'),(2991,2991,'2014-01-01','ET','2',1,NULL,'Peter Steeghs','FI','450591943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:51',0,'2014-03-02 01:10:33'),(3207,3207,'2014-01-01','ET','2',2,1,'ABBUL BOCKIE','FI','200780598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:31',0,'2014-03-01 15:48:04'),(13640,13996,'2014-01-01','ET','2',1,NULL,'susan brittain','FI','296504511','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:54',0,'2014-03-10 16:10:34'),(3222,3222,'2014-01-01','ET','2',1,NULL,'Melanie Bushman','FI','301901303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:58',0,'2014-03-01 15:52:44'),(3903,3903,'2014-01-01','ET','2',1,NULL,'Yvonne McLaughlin','FI','291443471','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:06',0,'2014-03-10 15:45:56'),(12710,12710,'2014-01-01','ET','2',1,NULL,'Robert Griffin','FI','428215992','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:09',0,'2014-03-02 05:10:52'),(11970,11970,'2014-01-01','ET','2',4,3,'Zimin Su','FI','490987692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:56',0,'2014-03-02 04:59:36'),(5602,5602,'2014-01-01','ET','2',1,NULL,'Linda Kunkel','FI','283585505','Dental Care Plus, Inc.','FI','311185262','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-26 01:49:42',0,'2014-03-01 16:23:43'),(16400,17050,'0000-00-00','ET','2',1,NULL,'Robin Morris','FI','277706577','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:26',0,'2014-03-10 14:20:26'),(16853,17503,'0000-00-00','ET','2',1,NULL,'Krystal Shelton','FI','410639321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:27',0,'2014-03-02 06:17:30'),(16953,17603,'0000-00-00','ET','2',1,NULL,'Ayca Bilici','FI','665166273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:00',0,'2014-03-02 06:17:30'),(18187,18837,'0000-00-00','ET','2',1,NULL,'Tangeana May','FI','301706740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:42',0,'2014-03-01 17:26:36'),(18787,19437,'0000-00-00','ET','2',2,1,'kevin bucher','FI','288563131','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:56',0,'2014-03-10 14:31:05'),(19313,19963,'0000-00-00','ET','2',2,1,'Jesse Ortega','FI','455298467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:06',0,'2014-03-02 06:59:07'),(21733,22383,'0000-00-00','ET','2',2,1,'Thomas Miller','94','0001113196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:05',0,'2014-03-10 16:44:18'),(22246,22896,'0000-00-00','ET','2',1,NULL,'RACHEL ANN MONROE','FI','278520325','Summa Insurance Company, Inc.','FI','341809108','MAGGIE  ROMUTIS','94','1719853','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:12',0,'2014-03-10 16:44:18'),(22893,23543,'0000-00-00','ET','2',1,NULL,'VIRGINIA LYDON','FI','379646825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:34',0,'2014-03-10 21:36:25'),(22979,23629,'0000-00-00','ET','2',1,NULL,'DEBRA JENNINGS','FI','291546519','Dental Care Plus, Inc.','FI','311185262','MOLLY  JOHNSON','94','17081916','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:36',0,'2014-03-10 21:36:25'),(566,566,'2014-01-01','ET','2',1,NULL,'Adam Schneider','FI','302902360','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:34',0,'2014-03-01 15:48:04'),(13813,14169,'2014-01-01','ET','2',1,NULL,'Melissa Fraser','FI','232044454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:19',0,'2014-03-10 16:10:34'),(13710,14066,'2014-01-01','ET','2',1,NULL,'ANGELA THOMAS','FI','297626286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:47',0,'2014-03-01 16:40:16'),(1493,1493,'2014-01-01','ET','2',1,NULL,'william may','FI','284902812','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:57:10',0,'2014-03-10 13:45:57'),(12092,12092,'2014-01-01','ET','2',1,NULL,'Cindy Xin Fang Chen','FI','562879608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:05:27',0,'2014-03-01 16:30:17'),(11814,11814,'2014-01-01','ET','2',2,1,'Timothy M Cummings','FI','281685383','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:30',0,'2014-03-01 16:15:39'),(11092,11092,'2014-01-01','ET','2',1,NULL,'Phillip Collins','FI','276688284','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:51',0,'2014-03-10 13:39:10'),(2452,2452,'2014-01-01','ET','2',1,NULL,'Carmon holland','FI','425152682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:55',0,'2014-03-01 23:10:52'),(3244,3244,'2014-01-01','ET','2',1,NULL,'Frank Stranscak','FI','277529260','Dental Care Plus, Inc.','FI','311185262','Carl  Cottingham','94','2221634','348','2014-01-01','Sync Success',0,'2013-12-25 21:46:41',0,'2014-03-01 15:52:44'),(10583,10583,'2014-01-01','ET','2',1,NULL,'SHELIA R STARKS','FI','467216250','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:39',0,'2014-03-02 04:24:47'),(6252,6252,'2014-01-01','ET','2',1,NULL,'Celeste Schmitt','FI','436374449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:00',0,'2014-03-02 04:10:25'),(6022,6022,'2014-01-01','ET','2',1,NULL,'Marie Elizabeth Tetzel','FI','270760878','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:37',0,'2014-03-10 15:39:19'),(5269,5269,'2014-01-01','ET','2',1,NULL,'Jason Alan Morrow','FI','466833201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 01:00:18',0,'2014-03-01 19:11:03'),(13836,14192,'2014-01-01','ET','2',1,NULL,'Yeon Won Kim','FI','460698739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:38',0,'2014-03-02 05:31:31'),(14651,15102,'2014-01-01','ET','2',1,NULL,'Korey Osborn','FI','302887235','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:22',0,'2014-03-01 16:46:19'),(15746,16395,'0000-00-00','ET','2',1,NULL,'REBECCA BOWSER','FI','277923450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:20',0,'2014-03-01 16:56:22'),(16792,17442,'0000-00-00','ET','2',1,NULL,'Krystian Hall','FI','300849981','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:36',0,'2014-03-01 17:00:58'),(18185,18835,'0000-00-00','ET','2',1,NULL,'ALEJANDRO  HERITIER','FI','081525725','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:41',0,'2014-03-01 17:26:36'),(18333,18983,'0000-00-00','ET','2',1,NULL,'Tenesha Hartgrove','FI','290784387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:15',0,'2014-03-01 17:26:36'),(19545,20195,'0000-00-00','ET','2',2,1,'DENISE RENDELL CAREY','FI','438597142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:17:01',0,'2014-03-02 06:59:07'),(19592,20242,'0000-00-00','ET','2',1,NULL,'Sergio Rivas','FI','637037504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:30:41',0,'2014-03-02 06:59:07'),(21088,21738,'0000-00-00','ET','2',2,1,'CLAUDIA PEREZ','FI','635071419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:39',0,'2014-03-02 07:17:36'),(21747,22397,'0000-00-00','ET','2',1,NULL,'CHRISTIAN PINZON','FI','589100545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:17',0,'2014-03-04 21:27:16'),(21906,22556,'0000-00-00','ET','2',4,3,'Kimberly Brooks','FI','466932364','Starmount Life Insurance Company','FI','720977315','Danielle  Abbott','94','16964484','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:48',0,'2014-03-05 22:27:33'),(1636,1636,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:05',0,'2014-03-01 20:10:57'),(13439,13795,'2014-01-01','ET','2',2,1,'courtney sheeley','FI','645149237','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:11',0,'2014-03-02 05:31:31'),(2033,2033,'2014-01-01','ET','2',1,NULL,'Charlotte Bright','FI','434254403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:53',0,'2014-03-01 23:10:52'),(13138,13494,'2014-01-01','ET','2',2,1,'Nancy Butcher','FI','236847520','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:23',0,'2014-03-10 16:10:34'),(2419,2419,'2014-01-01','ET','2',1,NULL,'PAMELA SUE GRUBB','FI','293521124','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:52',0,'2014-03-10 15:45:56'),(3753,3753,'2014-01-01','ET','2',1,NULL,'Sandra Stout','FI','268465501','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:19',0,'2014-03-10 13:20:27'),(5903,5903,'2014-01-01','ET','2',1,NULL,'Susan Rodriguez','FI','270588746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:53',0,'2014-03-01 15:48:04'),(15388,15839,'0000-00-00','ET','2',3,2,'Brad Hemenway','FI','578945563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:02',0,'2014-03-02 05:59:43'),(16060,16709,'0000-00-00','ET','2',1,NULL,'MICHAEL S LUDWIG','FI','277564927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:49',0,'2014-03-01 16:56:22'),(16544,17194,'0000-00-00','ET','2',1,NULL,'Rosia Jane Jackson','FI','434215936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:05',0,'2014-03-02 06:10:30'),(17421,18071,'0000-00-00','ET','2',1,NULL,'ron Papczun','FI','278660001','Summa Insurance Company, Inc.','FI','341809108','jason  farro','94','6998749','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:56',0,'2014-03-10 16:24:30'),(19120,19770,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott D Prior','94','8416481','357','2014-03-01','Sync Success',0,'2014-02-15 22:00:59',0,'2014-03-01 17:34:07'),(20510,21160,'0000-00-00','ET','2',1,NULL,'Toan Nguyen','FI','434694670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:49',0,'2014-03-02 07:17:36'),(21660,22310,'0000-00-00','ET','2',1,NULL,'karen everage','FI','268547620','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:01:06',0,'2014-03-04 21:36:30'),(60,60,'2014-01-01','ET','2',1,NULL,'JAMES STEDRONSKY','FI','286528533','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:48',0,'2014-03-01 15:21:15'),(251,251,'2014-01-01','ET','2',1,NULL,'Suzanne Patrick','FI','291441474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:53',0,'2014-03-01 15:10:22'),(947,947,'2014-01-01','ET','2',1,NULL,'Thomas Spell','FI','437356464','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-25 18:18:33',0,'2014-03-01 22:10:55'),(1306,1306,'2014-01-01','ET','2',1,NULL,'rebecca fenton','FI','460859067','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:00',0,'2014-03-02 04:38:08'),(2402,2402,'2014-01-01','ET','2',1,NULL,'Scott Stidham','FI','274881300','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:17',0,'2014-03-01 15:26:40'),(2600,2600,'2014-01-01','ET','2',1,0,'kathy steffen','FI','122522385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 20:46:02',0,'2014-03-01 15:05:09'),(3005,3005,'2014-01-01','ET','2',2,1,'charles mccroskey','FI','289502995','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:16',0,'2014-03-10 15:52:36'),(10863,10863,'2014-01-01','ET','2',1,NULL,'David L McElderry','FI','276484834','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:56',0,'2014-03-10 13:45:57'),(5028,5028,'2014-01-01','ET','2',2,1,'Marsha Kay Landrum','FI','281541341','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:52',0,'2014-03-01 15:31:33'),(10414,10414,'2014-01-01','ET','2',1,NULL,'Karen Hudson-strahorn','FI','283642174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:09',0,'2014-03-01 16:10:36'),(5679,5679,'2014-01-01','ET','2',1,NULL,'Amanda Calcutta','FI','281746568','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:25',0,'2014-03-10 13:52:32'),(5624,5624,'2014-01-01','ET','2',1,NULL,'Alonna Adams','FI','298545476','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:50:31',0,'2014-03-10 16:03:49'),(5133,5133,'2014-01-01','ET','2',1,NULL,'Jessie Carson','FI','300521813','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:19',0,'2014-03-10 15:45:56'),(15269,15720,'0000-00-00','ET','2',1,NULL,'Laura Janak','FI','631143974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:00',0,'2014-03-02 05:52:31'),(16011,16660,'0000-00-00','ET','2',1,NULL,'Rajesh Patel','FI','547537678','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:18',0,'2014-03-02 06:03:21'),(17055,17705,'0000-00-00','ET','2',1,NULL,'Jose Jaquez','FI','629907200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:32',0,'2014-03-02 06:24:38'),(17112,17762,'0000-00-00','ET','2',1,NULL,'Douglas Vignos','FI','294627675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:07',0,'2014-03-01 17:20:55'),(17256,17906,'0000-00-00','ET','2',1,NULL,'Catherine Rees','FI','288669510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:34',0,'2014-03-01 17:20:55'),(18180,18830,'0000-00-00','ET','2',2,1,'Kathy J Simonson','FI','291844620','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:37',0,'2014-03-01 17:26:36'),(19248,19898,'0000-00-00','ET','2',2,1,'Brian Clutter','FI','301864830','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:38',0,'2014-03-10 14:31:05'),(19487,20137,'0000-00-00','ET','2',1,NULL,'MICHAEL HUDSON','FI','434846173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:00:26',0,'2014-03-02 06:59:07'),(19783,20433,'0000-00-00','ET','2',1,NULL,'SUZETTE SCHEXNAIDER','FI','437983996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:09',0,'2014-03-02 06:59:07'),(19881,20531,'0000-00-00','ET','2',1,NULL,'Carlos R Garcia Diaz','FI','262857992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:29',0,'2014-03-01 17:47:19'),(20539,21189,'0000-00-00','ET','2',1,NULL,'jeremiah dunn','FI','450917559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:10',0,'2014-03-02 07:10:28'),(21006,21656,'0000-00-00','ET','2',1,NULL,'tarah malano','FI','336725057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:04',0,'2014-03-02 07:23:39'),(22314,22964,'0000-00-00','ET','2',1,NULL,'Suzan Montejano','FI','562518130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:07',0,'2014-03-06 22:25:29'),(944,944,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:28',0,'2014-03-01 22:10:55'),(12531,12531,'2014-01-01','ET','2',1,NULL,'Russell Sailors','FI','434639334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:34:29',0,'2014-03-02 05:03:29'),(1620,1620,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:42',0,'2014-03-01 20:10:57'),(13808,14164,'2014-01-01','ET','2',3,2,'HAROLD SCHEIENNER','FI','286548962','Dental Care Plus, Inc.','FI','311185262','james  finnegin','94','2766031','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:15',0,'2014-03-01 16:40:16'),(13628,13984,'2014-01-01','ET','2',1,NULL,'ANDRE HEBERT','FI','436799674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:46',0,'2014-03-02 05:31:31'),(1672,1672,'2014-01-01','ET','2',1,NULL,'SHERRI YOUNG','FI','464294899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:36',0,'2014-03-02 00:10:48'),(4389,4389,'2014-01-01','ET','2',1,NULL,'Chris Bencar','FI','272909722','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:37',0,'2014-03-01 15:16:37'),(5485,5485,'2014-01-01','ET','2',1,NULL,'Joyce Watts','FI','439843237','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:45:55',0,'2014-03-02 04:45:37'),(12842,12842,'2014-01-01','ET','2',1,NULL,'Stephanie Dawn Shimek','FI','452556296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:45',0,'2014-03-02 05:10:52'),(12113,12113,'2014-01-01','ET','2',1,NULL,'SHARRON KORNEGAY','FI','577764413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:08',0,'2014-03-01 16:30:17'),(7266,7266,'2014-01-01','ET','2',3,2,'Brandy Vickers','FI','294724613','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:40',0,'2014-03-10 13:32:15'),(11810,11810,'2014-01-01','ET','2',1,NULL,'Vaughn William Stull','FI','291866822','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:23',0,'2014-03-01 16:15:39'),(11431,11431,'2014-01-01','ET','2',1,NULL,'Gladys Holeton','FI','299505271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:33',0,'2014-03-10 16:03:49'),(7701,7701,'2014-01-01','ET','2',1,NULL,'Rachel L Berg','FI','300883775','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:31',0,'2014-03-01 15:10:22'),(10893,10893,'2014-01-01','ET','2',1,NULL,'Christopher Riggleman','FI','569872894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:24',0,'2014-03-02 04:24:47'),(15974,16623,'0000-00-00','ET','2',1,NULL,'gabrielle Johnson','FI','437834162','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:19',0,'2014-03-02 06:03:21'),(16743,17393,'0000-00-00','ET','2',2,1,'RENE LUNA','FI','467139464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:05',0,'2014-03-02 06:17:30'),(19558,20208,'0000-00-00','ET','2',1,NULL,'JOSEPH JOLIVETTE','FI','434314902','Starmount Life Insurance Company','FI','720977315','ABRAM  FREEMAN','94','1219092','348','2014-04-01','Sync Success',0,'2014-02-20 04:20:09',0,'2014-03-02 06:59:07'),(20522,21172,'0000-00-00','ET','2',1,NULL,'DAVID F WINBOURN','FI','466131587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:58',0,'2014-03-02 07:10:28'),(21911,22561,'0000-00-00','ET','2',3,2,'JANETH LOPEZ','FI','602268212','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:51',0,'2014-03-05 22:27:33'),(2123,2123,'2014-01-01','ET','2',1,NULL,'James Haydn','FI','300565579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:38',0,'2014-03-01 15:16:37'),(2218,2218,'2014-01-01','ET','2',1,NULL,'James Nofsinger','FI','283484544','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:46',0,'2014-03-10 15:39:19'),(13332,13688,'2014-01-01','ET','2',1,NULL,'Soraya Gallegos','FI','464975216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:24',0,'2014-03-02 05:24:45'),(12686,12686,'2014-01-01','ET','2',1,NULL,'David Ramun','FI','274585969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:11',0,'2014-03-01 16:35:14'),(12423,12423,'2014-01-01','ET','2',1,NULL,'carolyn bourque','FI','435908462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:31',0,'2014-03-02 05:03:29'),(7679,7679,'2014-01-01','ET','2',2,1,'Dennis J Wilson','FI','302487830','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:48',0,'2014-03-10 13:39:10'),(14498,14949,'2014-01-01','ET','2',1,NULL,'Gary Schubert','FI','293563084','HealthSpan','FI','311431434','Stephen James  Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:51',0,'2014-03-10 14:03:26'),(14737,15188,'2014-01-01','ET','2',1,NULL,'Stephanie Bilinovich','FI','280882132','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:18',0,'2014-03-10 16:17:47'),(15248,15699,'0000-00-00','ET','2',1,NULL,'Annette Carson','FI','466158389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:27',0,'2014-03-02 05:52:31'),(15661,16310,'0000-00-00','ET','2',1,NULL,'Jessica Thomas','FI','288905063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:00:21',0,'2014-03-01 16:56:22'),(16064,16713,'0000-00-00','ET','2',1,NULL,'Michael Truong','FI','298780493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:51',0,'2014-03-01 16:56:22'),(16537,17187,'0000-00-00','ET','2',1,NULL,'Peggy Feldhaus','FI','403747613','Dental Care Plus, Inc.','FI','311185262','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:01',0,'2014-03-01 17:00:58'),(17899,18549,'0000-00-00','ET','2',1,NULL,'Noel Thomas','FI','229319036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-25','Sync Success',0,'2014-02-10 21:30:28',0,'2014-03-02 06:38:05'),(18478,19128,'0000-00-00','ET','2',2,1,'JESSE SPENCER','FI','279881547','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:55',0,'2014-03-10 14:31:05'),(21872,22522,'0000-00-00','ET','2',1,NULL,'Tate Blanchard','FI','281901800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:22',0,'2014-03-05 21:36:22'),(20024,20674,'0000-00-00','ET','2',3,2,'peter ulrick','FI','271765322','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:09',0,'2014-03-10 14:37:47'),(20163,20813,'0000-00-00','ET','2',1,NULL,'Roy Fletcher','94','0000309414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:31:04',0,'2014-03-01 18:08:07'),(22533,23183,'0000-00-00','ET','2',2,1,'Robert Page','FI','385804971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:34',0,'2014-03-07 21:36:32'),(14317,14768,'2014-01-01','ET','2',1,NULL,'robert krpoun','FI','502902017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:32',0,'2014-03-02 05:38:34'),(14959,15410,'2014-01-01','ET','2',1,NULL,'Betty Ford','FI','294566126','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:52',0,'2014-03-10 14:10:12'),(15015,15466,'2014-01-01','ET','2',1,NULL,'Troy Penland','FI','270889620','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:16',0,'2014-03-10 16:17:47'),(16796,17446,'0000-00-00','ET','2',1,NULL,'jeanne hevener','FI','159448859','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:38',0,'2014-03-01 17:00:58'),(19953,20603,'0000-00-00','ET','2',1,NULL,'ABBAS PAHLAVAN','FI','456399563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-21 22:00:18',0,'2014-03-02 07:03:25'),(21307,21957,'0000-00-00','ET','2',1,NULL,'Andrew Thieken','FI','273929089','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:11',0,'2014-03-10 14:45:25'),(21743,22393,'0000-00-00','ET','2',1,NULL,'Melissa Kay Schollian','FI','452858008','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:14',0,'2014-03-04 21:27:16'),(22197,22847,'0000-00-00','ET','2',1,NULL,'JOHNNY C SMITH','FI','587584769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:37',0,'2014-03-06 21:27:26'),(22411,23061,'0000-00-00','ET','2',1,NULL,'Shameeka Griffin Harvey','FI','458797058','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:07',0,'2014-03-07 22:26:59'),(22777,23427,'0000-00-00','ET','2',1,NULL,'sarah krauss','FI','302743028','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:31',0,'2014-03-09 21:35:27'),(1128,1128,'2014-01-01','ET','2',1,NULL,'Mikal Dang','FI','466630547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:45:31',0,'2014-03-02 04:38:08'),(12773,12773,'2014-01-01','ET','2',2,1,'JOSEPH LENGEL','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:13',0,'2014-03-01 16:35:14'),(12520,12520,'2014-01-01','ET','2',1,NULL,'JUDY PEMAREST','FI','438760627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:04',0,'2014-03-02 05:03:29'),(12380,12380,'2014-01-01','ET','2',2,1,'MERELYN JONES','FI','296503045','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:59',0,'2014-03-01 16:30:17'),(11347,11347,'2014-01-01','ET','2',1,NULL,'Cathyrine Rockett','FI','639107464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:55',0,'2014-03-02 04:52:44'),(2563,2563,'2014-01-01','ET','2',1,NULL,'Susan Baughman','FI','266800690','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:01',0,'2014-03-10 15:39:19'),(10842,10842,'2014-01-01','ET','2',2,1,'Dorey Lee Bates','FI','433738020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:12',0,'2014-03-02 04:31:46'),(3582,3582,'2014-01-01','ET','2',2,1,'Maureen Courtney','FI','218702674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:49',0,'2014-03-02 00:10:48'),(12197,12197,'2014-01-01','ET','2',1,NULL,'Kelly Kowalski','FI','284883337','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:12',0,'2014-03-10 13:52:32'),(5234,5234,'2014-01-01','ET','2',1,NULL,'VICKI M PHILLIPS','FI','425021773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:31',0,'2014-03-02 00:10:48'),(11587,11587,'2014-01-01','ET','2',1,NULL,'Jane Rios','FI','458861419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:34:20',0,'2014-03-02 04:59:36'),(5482,5482,'2014-01-01','ET','2',1,NULL,'John Poche','FI','438863749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:45:50',0,'2014-03-02 04:45:37'),(5848,5848,'2014-01-01','ET','2',1,NULL,'PAUL MANNEY','FI','271644972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:04',0,'2014-03-01 15:10:22'),(6316,6316,'2014-01-01','ET','2',1,NULL,'Tara Heckert','FI','269905160','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-26 03:07:52',0,'2014-03-10 15:59:47'),(13490,13846,'2014-01-01','ET','2',1,NULL,'Dusty Madkins','FI','446789316','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:09',0,'2014-03-02 05:31:31'),(13517,13873,'2014-01-01','ET','2',1,NULL,'Teri Fleming','FI','453020346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:27',0,'2014-03-02 05:31:31'),(13908,14264,'2014-01-01','ET','2',1,NULL,'Amanda Jones','FI','288909909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:07',0,'2014-03-01 16:40:16'),(15848,16497,'0000-00-00','ET','2',1,NULL,'Harry Bradford','FI','300462740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:39',0,'2014-03-01 16:56:22'),(15849,16498,'0000-00-00','ET','2',1,NULL,'Miriam Mejia','FI','053786199','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:40',0,'2014-03-01 16:56:22'),(18019,18669,'0000-00-00','ET','2',2,1,'JEFFREY POWERS','FI','291648957','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:51',0,'2014-03-01 17:20:55'),(18714,19364,'0000-00-00','ET','2',1,NULL,'Tonyia Odell','FI','401110641','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:03',0,'2014-03-10 14:31:05'),(19603,20253,'0000-00-00','ET','2',1,NULL,'susan snider','FI','459926046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:32:53',0,'2014-03-02 06:59:07'),(20203,20853,'0000-00-00','ET','2',1,NULL,'James Martin','FI','260212004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-25 21:31:33',0,'2014-03-02 07:10:28'),(22841,23491,'0000-00-00','ET','2',1,NULL,'kevin owen','FI','086644126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:30:05',0,'2014-03-09 22:25:06'),(61,61,'2014-01-01','ET','2',1,NULL,'Stephen Uhl','FI','302527843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:50',0,'2014-03-01 15:21:15'),(12736,12736,'2014-01-01','ET','2',1,NULL,'Christina L Copeland','FI','298663527','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:10',0,'2014-03-10 13:59:38'),(1559,1559,'2014-01-01','ET','2',1,NULL,'Richard Carter','FI','298044943','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:17',0,'2014-03-10 13:52:32'),(12396,12396,'2014-01-01','ET','2',1,NULL,'Brian Riggle','FI','300744306','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:31',0,'2014-03-01 16:30:17'),(3786,3786,'2014-01-01','ET','2',1,NULL,'Hazel Emery','FI','382686257','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:50',0,'2014-03-01 15:26:40'),(10540,10540,'2014-01-01','ET','2',1,NULL,'Irma De La Cruz','FI','636165704','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:09',0,'2014-03-02 04:31:46'),(5669,5669,'2014-01-01','ET','2',1,NULL,'athinas atanda-salau','FI','160820936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:00',0,'2014-03-02 04:45:37'),(14619,15070,'2014-01-01','ET','2',1,NULL,'justine carare','FI','296676988','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:02',0,'2014-03-01 16:46:19'),(14846,15297,'2014-01-01','ET','2',1,NULL,'YONG NEE','FI','276806902','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:28',0,'2014-03-10 14:03:26'),(15598,16049,'0000-00-00','ET','2',1,NULL,'Byron Williams','FI','439697364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:35',0,'2014-03-02 05:59:43'),(15753,16402,'0000-00-00','ET','2',1,NULL,'MITCHELL CALVIN ADAMS','FI','301506934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:23',0,'2014-03-01 16:56:22'),(16444,17094,'0000-00-00','ET','2',1,NULL,'Betty Ford','FI','294566126','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:01:55',0,'2014-03-10 14:20:26'),(17162,17812,'0000-00-00','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-19','Sync Success',0,'2014-02-04 21:01:41',0,'2014-03-01 17:00:58'),(19499,20149,'0000-00-00','ET','2',2,1,'Celia Mahone','FI','278625417','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:03:42',0,'2014-03-10 16:38:05'),(19971,20621,'0000-00-00','ET','2',2,1,'Robert Newman','FI','292904386','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:31',0,'2014-03-01 17:47:19'),(20087,20737,'0000-00-00','ET','2',1,NULL,'KAREN SCOTT','FI','439435656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:08',0,'2014-03-02 07:10:28'),(20633,21283,'0000-00-00','ET','2',1,NULL,'Rebecca Belardi','FI','452964519','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:13',0,'2014-03-02 07:10:28'),(21712,22362,'0000-00-00','ET','2',2,1,'JOSUE CASILDO','FI','664125239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:48',0,'2014-03-04 21:27:16'),(22422,23072,'0000-00-00','ET','2',2,1,'Joe Bryce','FI','463258851','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:15',0,'2014-03-07 22:26:59'),(1654,1654,'2014-01-01','ET','2',1,NULL,'Donald Lowe','FI','268922894','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:38',0,'2014-03-10 15:39:19'),(3077,3077,'2014-01-01','ET','2',1,NULL,'Eula Lewis','FI','436430683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:31',0,'2014-03-02 01:10:33'),(13568,13924,'2014-01-01','ET','2',2,1,'linda council','FI','426454599','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:00',0,'2014-03-02 05:31:31'),(3870,3870,'2014-01-01','ET','2',1,0,'PURVIS HAMM','FI','594622361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:14',0,'2014-03-01 19:11:03'),(4642,4642,'2014-01-01','ET','2',2,1,'Jing Xue','FI','632565320','Starmount Life Insurance Company','FI','720977315','Huilan Ellen Tseng','94','10341657','348','2014-01-01','Sync Success',0,'2013-12-25 23:48:37',0,'2014-03-02 04:38:08'),(5489,5489,'2014-01-01','ET','2',1,NULL,'kenneth cooper','FI','259945203','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:46:02',0,'2014-03-02 04:45:37'),(6394,6394,'2014-01-01','ET','2',2,1,'RONALD JOSEPH STUDER','FI','273465327','HealthSpan','FI','311431434','AMY MARIE SHEAKS','94','15838390','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:17',0,'2014-03-10 13:39:10'),(11420,11420,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:12',0,'2014-03-10 16:03:49'),(15541,15992,'0000-00-00','ET','2',2,1,'Jonathan Caskey','FI','279541312','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:09',0,'2014-03-10 16:17:47'),(15713,16362,'0000-00-00','ET','2',1,NULL,'Sandra Brown','FI','280622228','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:56',0,'2014-03-10 14:10:12'),(16722,17372,'0000-00-00','ET','2',1,NULL,'Keith Anderson','FI','272865768','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:32',0,'2014-03-10 16:24:30'),(17201,17851,'0000-00-00','ET','2',1,NULL,'Brenda Dugan','FI','465274652','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:06',0,'2014-03-02 06:24:38'),(17489,18139,'0000-00-00','ET','2',2,1,'Gina Fox','FI','014649957','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:46',0,'2014-03-10 14:24:38'),(17676,18326,'0000-00-00','ET','2',1,NULL,'Christine Knerem','FI','293621708','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:50',0,'2014-03-10 16:24:30'),(18543,19193,'0000-00-00','ET','2',1,NULL,'stefanie montanez','FI','639010774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:08',0,'2014-03-02 06:45:14'),(20791,21441,'0000-00-00','ET','2',1,NULL,'Rita Estep','FI','268521717','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:55',0,'2014-03-10 16:38:05'),(21062,21712,'0000-00-00','ET','2',1,NULL,'DORNETTE STEWART','FI','283645103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:23',0,'2014-03-01 18:10:11'),(21099,21749,'0000-00-00','ET','2',1,NULL,'christopher dill','FI','463673992','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:46',0,'2014-03-02 07:23:39'),(21319,21969,'0000-00-00','ET','2',1,NULL,'Joshua Bobb','94','0000594593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:07',0,'2014-03-03 01:07:25'),(21372,22022,'0000-00-00','ET','2',1,NULL,'Erin Richardson','FI','298942950','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-17','Sync Success',0,'2014-03-03 01:00:37',0,'2014-03-10 14:45:25'),(21630,22280,'0000-00-00','ET','2',1,NULL,'Haley Harris','FI','632101840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:44',0,'2014-03-04 21:27:16'),(22030,22680,'0000-00-00','ET','2',1,NULL,'MARILYN CONNER','FI','453374872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:14',0,'2014-03-05 22:27:33'),(22203,22853,'0000-00-00','ET','2',1,NULL,'CORY N EHMAN','FI','279909670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:42',0,'2014-03-06 21:36:23'),(2947,2947,'2014-01-01','ET','2',1,NULL,'SHARON BENSON','FI','295702473','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:28',0,'2014-03-01 15:37:30'),(4229,4229,'2014-01-01','ET','2',1,NULL,'esther newell','FI','277542256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:07:08',0,'2014-03-01 16:00:27'),(12605,12605,'2014-01-01','ET','2',1,NULL,'Margie Supertzi','FI','462315457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:17',0,'2014-03-02 05:10:52'),(12129,12129,'2014-01-01','ET','2',1,NULL,'timothy hiser','FI','295845878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:06:44',0,'2014-03-01 16:30:17'),(4259,4259,'2014-01-01','ET','2',1,NULL,'Tamara Couch','FI','314768931','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:05',0,'2014-03-10 13:32:15'),(6337,6337,'2014-01-01','ET','2',1,NULL,'Patsy Sparkman','FI','445585288','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:32',0,'2014-03-02 04:10:25'),(7722,7722,'2014-01-01','ET','2',1,NULL,'PATRICIA TIPTON','FI','273441172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:15',0,'2014-03-10 13:03:33'),(7243,7243,'2014-01-01','ET','2',1,NULL,'DEREK BROWN','FI','425291754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:00',0,'2014-03-02 03:09:49'),(7027,7027,'2014-01-01','ET','2',1,NULL,'Beverly Jenkins','94','0000375342','Starmount Life Insurance Company','FI','720977315','DALE  ADAMS','94','8330750','348','2014-01-01','Sync Success',0,'2013-12-26 04:01:20',0,'2014-03-02 03:09:49'),(14856,15307,'2014-01-01','ET','2',1,NULL,'Kenisha Terry Williams','FI','567897340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:04',0,'2014-03-02 05:45:37'),(17280,17930,'0000-00-00','ET','2',1,NULL,'Sharlo Roth','FI','545877808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:45',0,'2014-03-02 06:24:38'),(18723,19373,'0000-00-00','ET','2',1,NULL,'Sandra Baldwin','FI','456906510','Starmount Life Insurance Company','FI','720977315','Mark A West','94','9179113','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:10',0,'2014-03-02 06:45:14'),(18789,19439,'0000-00-00','ET','2',1,NULL,'Joel Worley','FI','283820175','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:58',0,'2014-03-10 14:31:05'),(18868,19518,'0000-00-00','ET','2',1,NULL,'Christine Hays','FI','299745730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:38',0,'2014-03-01 17:34:07'),(19064,19714,'0000-00-00','ET','2',1,NULL,'Erin Gulbengay','FI','567657774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:18',0,'2014-03-02 06:52:12'),(19101,19751,'0000-00-00','ET','2',2,1,'Stephen Weeks','FI','249820354','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:44',0,'2014-03-01 17:34:07'),(20548,21198,'0000-00-00','ET','2',1,NULL,'MARGARET SMITH','FI','480766048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:15',0,'2014-03-02 07:17:36'),(20682,21332,'0000-00-00','ET','2',1,NULL,'Eartha Garner','FI','439117670','Starmount Life Insurance Company','FI','720977315','Matthew A Scoggins','94','4706259','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:03',0,'2014-03-02 07:17:36'),(5179,5179,'2014-01-01','ET','2',1,NULL,'Amber Rodriguez','FI','463796092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:41',0,'2014-03-02 00:10:48'),(4153,4153,'2014-01-01','ET','2',6,5,'Richard Kress','FI','276822520','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:45',0,'2014-03-10 15:59:47'),(3142,3142,'2014-01-01','ET','2',1,NULL,'Valerie Schmidt','FI','281487272','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:28',0,'2014-03-10 13:24:34'),(12573,12573,'2014-01-01','ET','2',1,NULL,'Brian Kilgallon','FI','055540185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:03',0,'2014-03-01 16:35:14'),(12491,12491,'2014-01-01','ET','2',1,NULL,'MELISSA PLAISANCE','FI','439574312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:01',0,'2014-03-02 05:03:29'),(11239,11239,'2014-01-01','ET','2',1,NULL,'deborah jones','FI','294687306','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:38',0,'2014-03-01 16:23:43'),(11100,11100,'2014-01-01','ET','2',2,1,'Kathleen Masters','FI','274568745','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:07',0,'2014-03-10 13:39:10'),(10812,10812,'2014-01-01','ET','2',2,1,'christina murray','FI','589461221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:15',0,'2014-03-02 04:31:46'),(10711,10711,'2014-01-01','ET','2',1,NULL,'Gary Hovey','FI','259901441','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:55',0,'2014-03-01 16:10:36'),(10437,10437,'2014-01-01','ET','2',1,NULL,'CAROLINE LOUISE PARKER','FI','271542513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:52',0,'2014-03-01 16:10:36'),(14976,15427,'2014-01-01','ET','2',1,NULL,'Deborah Crow','FI','288689326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:00',0,'2014-03-01 16:50:53'),(17448,18098,'0000-00-00','ET','2',1,NULL,'Rachel Whitacre','FI','235393763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:15',0,'2014-03-01 17:20:55'),(21257,21907,'0000-00-00','ET','2',1,NULL,'Christine Ann Zehring','FI','296546439','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:35',0,'2014-03-01 21:35:40'),(1396,1396,'2014-01-01','ET','2',4,3,'Martin Phelps','FI','296864092','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:54',0,'2014-03-10 13:45:57'),(11793,11793,'2014-01-01','ET','2',1,NULL,'Elbert Pruitt','FI','456510382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:12:54',0,'2014-03-02 04:31:46'),(7535,7535,'2014-01-01','ET','2',1,NULL,'LAURA MAZAR','FI','217703646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:09',0,'2014-03-01 16:05:34'),(14036,14392,'2014-01-01','ET','2',1,NULL,'Bruce Robinson','FI','544827187','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:57',0,'2014-03-02 05:31:31'),(15739,16388,'0000-00-00','ET','2',1,NULL,'Carlos Sanchez','FI','455968027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:15',0,'2014-03-02 05:59:43'),(16974,17624,'0000-00-00','ET','2',1,NULL,'DEANNA MANDLEY','FI','278487493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:14',0,'2014-03-01 17:00:58'),(21795,22445,'0000-00-00','ET','2',1,NULL,'NORA G RAMIREZ','FI','467961152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:13',0,'2014-03-04 22:25:23'),(22324,22974,'0000-00-00','ET','2',3,2,'Wendi Koontz','FI','291668215','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:14',0,'2014-03-10 16:44:18'),(13855,14211,'2014-01-01','ET','2',1,NULL,'Alexandra Schuur Sousa','FI','027744245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:51',0,'2014-03-02 05:31:31'),(13884,14240,'2014-01-01','ET','2',1,NULL,'Virginia Dainty','FI','435889555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:10',0,'2014-03-02 05:31:31'),(17674,18324,'0000-00-00','ET','2',1,NULL,'Kaleena Harpster','FI','299888504','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:49',0,'2014-03-10 16:24:30'),(19196,19846,'0000-00-00','ET','2',1,NULL,'david dryfka','FI','398628072','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:02',0,'2014-03-10 14:31:05'),(20084,20734,'0000-00-00','ET','2',1,NULL,'LORI SENEGAL','FI','437137784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:30:06',0,'2014-03-02 07:10:28'),(20798,21448,'0000-00-00','ET','2',1,NULL,'EARNESTINE MALONE','FI','429111418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:58',0,'2014-03-02 07:17:36'),(21653,22303,'0000-00-00','ET','2',1,NULL,'Nichole Knight','FI','283888410','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:01',0,'2014-03-04 21:36:30'),(21893,22543,'0000-00-00','ET','2',1,NULL,'CLARA GARCIA','FI','455110497','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:39',0,'2014-03-05 22:27:33'),(22172,22822,'0000-00-00','ET','2',1,NULL,'Andrew Miller','FI','291823390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:19',0,'2014-03-06 21:36:23'),(22629,23279,'0000-00-00','ET','2',1,NULL,'victor hiris','FI','271703672','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:04',0,'2014-03-08 21:35:36'),(1074,1074,'2014-01-01','ET','2',1,NULL,'Sara Justice','FI','273924741','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:03',0,'2014-03-10 15:39:19'),(12514,12514,'2014-01-01','ET','2',1,NULL,'Evan Parker','FI','233134937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:53',0,'2014-03-02 05:03:29'),(11947,11947,'2014-01-01','ET','2',1,NULL,'Steven Duemler','FI','461996506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:06',0,'2014-03-02 04:59:36'),(1589,1589,'2014-01-01','ET','2',1,NULL,'Emily Campbell','FI','288881383','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:55',0,'2014-03-10 15:39:19'),(10585,10585,'2014-01-01','ET','2',1,NULL,'NATHANIEL TAYLOR','FI','458274130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:42',0,'2014-03-02 04:24:47'),(7542,7542,'2014-01-01','ET','2',1,NULL,'Debra Kinkade','FI','276740794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:22',0,'2014-03-01 16:05:34'),(7310,7310,'2014-01-01','ET','2',1,NULL,'NICHOLAS STRIKE','FI','295842232','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:00',0,'2014-03-10 13:32:15'),(7019,7019,'2014-01-01','ET','2',1,NULL,'Gloria Bermudez','FI','463982291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:04',0,'2014-03-02 03:09:49'),(1615,1615,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:35',0,'2014-03-01 20:10:57'),(2650,2650,'2014-01-01','ET','2',1,NULL,'Thomas W Smith','FI','281743332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:24',0,'2014-03-01 16:05:34'),(5492,5492,'2014-01-01','ET','2',1,NULL,'Marletta Austin','FI','283645677','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:08',0,'2014-03-01 16:23:43'),(3749,3749,'2014-01-01','ET','2',2,1,'JANET S KEVER','FI','311500334','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:10',0,'2014-03-10 13:24:34'),(3707,3707,'2014-01-01','ET','2',2,1,'PAULA M JOESPH','FI','434251281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:45',0,'2014-03-02 01:10:33'),(14538,14989,'2014-01-01','ET','2',2,1,'Carrie German','FI','298846558','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:11',0,'2014-03-10 14:03:26'),(15640,16289,'0000-00-00','ET','2',1,NULL,'Wilma Maxwell','FI','286541824','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:04',0,'2014-03-01 16:50:53'),(16416,17066,'0000-00-00','ET','2',1,NULL,'Nancy Cajka','FI','292607670','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:37',0,'2014-03-10 14:20:26'),(16432,17082,'0000-00-00','ET','2',1,NULL,'Kenna Gill','FI','302064970','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:47',0,'2014-03-10 14:20:26'),(16664,17314,'0000-00-00','ET','2',1,NULL,'Erica Likens','FI','280825913','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:51',0,'2014-03-01 17:00:58'),(19609,20259,'0000-00-00','ET','2',1,NULL,'casey tucker','94','0000194106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:33:57',0,'2014-03-01 17:34:07'),(19846,20496,'0000-00-00','ET','2',1,NULL,'michael pooler','FI','484929789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:01',0,'2014-03-02 07:03:25'),(20267,20917,'0000-00-00','ET','2',1,NULL,'Ryan S Hester','FI','290988308','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:15',0,'2014-03-01 17:47:19'),(20395,21045,'0000-00-00','ET','2',2,1,'TIMOTHY GILBERT','FI','454715571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:22',0,'2014-03-02 07:10:28'),(21164,21814,'0000-00-00','ET','2',2,1,'Cheree Moffett','FI','443882352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:31',0,'2014-03-02 07:23:39'),(22,22,'2014-01-01','ET','2',1,NULL,'Karla Yuschak-Smith','FI','299443408','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:40',0,'2014-03-01 15:21:15'),(13473,13829,'2014-01-01','ET','2',1,NULL,'maxine mckeown','FI','294562579','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:34',0,'2014-03-10 16:17:47'),(410,410,'2014-01-01','ET','2',2,1,'David Peters','FI','297800141','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:42',0,'2014-03-01 15:21:15'),(7292,7292,'2014-01-01','ET','2',1,NULL,'Megan Stangelo','FI','291808836','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:28',0,'2014-03-10 13:32:15'),(4344,4344,'2014-01-01','ET','2',1,NULL,'RORY COOK','FI','283549271','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:35',0,'2014-03-10 13:32:15'),(5314,5314,'2014-01-01','ET','2',1,NULL,'carey beamish','FI','295786427','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:58',0,'2014-03-10 13:03:33'),(5777,5777,'2014-01-01','ET','2',2,1,'MARY F WERT','FI','268647113','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:47',0,'2014-03-10 15:52:36'),(12365,12365,'2014-01-01','ET','2',2,1,'Javier Cardenas','FI','457676515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:24',0,'2014-03-02 05:03:29'),(5894,5894,'2014-01-01','ET','2',1,NULL,'Amy Hardy','FI','276701812','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:34',0,'2014-03-01 15:48:04'),(15859,16508,'0000-00-00','ET','2',2,1,'DEBORAH JAMISON','FI','286565186','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:46',0,'2014-03-10 14:10:12'),(18220,18870,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:10',0,'2014-03-10 16:31:33'),(19810,20460,'0000-00-00','ET','2',2,1,'Mir  Alam  Ali','FI','641980517','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:31',0,'2014-03-02 07:03:25'),(20332,20982,'0000-00-00','ET','2',5,4,'Christopher Tucker','FI','284883934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:21',0,'2014-03-01 17:47:19'),(21804,22454,'0000-00-00','ET','2',4,3,'Benjamin Tupaz','FI','269703499','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:19',0,'2014-03-04 21:36:30'),(338,338,'2014-01-01','ET','2',1,NULL,'Margaret Geyer','FI','285529566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:23',0,'2014-03-01 15:21:15'),(13571,13927,'2014-01-01','ET','2',1,NULL,'Linda Hayes','FI','299568853','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:03',0,'2014-03-10 13:59:38'),(1723,1723,'2014-01-01','ET','2',1,NULL,'sarah haussler','FI','285860532','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:11',0,'2014-03-01 15:31:33'),(2208,2208,'2014-01-01','ET','2',1,NULL,'dwayne fazande','FI','512882053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:26',0,'2014-03-01 21:11:04'),(12589,12589,'2014-01-01','ET','2',1,NULL,'Mark Gallimore','FI','273509561','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:43',0,'2014-03-01 16:35:14'),(2613,2613,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:23',0,'2014-03-10 13:03:33'),(10810,10810,'2014-01-01','ET','2',1,NULL,'Donald Hilliard','FI','433256465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:12',0,'2014-03-02 04:24:47'),(7472,7472,'2014-01-01','ET','2',1,NULL,'William Davis','FI','463755573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:33:01',0,'2014-03-02 04:15:49'),(2735,2735,'2014-01-01','ET','2',1,NULL,'Dorothy Joseph','FI','437087071','Starmount Life Insurance Company','FI','720977315','Lisa  Prater','94','15945577','348','2014-01-01','Sync Success',0,'2013-12-25 21:18:17',0,'2014-03-02 04:15:49'),(3837,3837,'2014-01-01','ET','2',1,NULL,'Debra Deppen','FI','268666759','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:10',0,'2014-03-10 13:03:33'),(15483,15934,'0000-00-00','ET','2',1,NULL,'Daniel Haarburger','FI','287967792','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:02',0,'2014-03-10 14:10:12'),(17597,18247,'0000-00-00','ET','2',2,1,'Christopher Arthur Wilson','FI','275427439','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:10',0,'2014-03-10 14:24:38'),(17783,18433,'0000-00-00','ET','2',1,NULL,'Christine Gifford','FI','506024503','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:19',0,'2014-03-02 06:10:30'),(18553,19203,'0000-00-00','ET','2',1,NULL,'Barton Bradberry','94','0000582236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:13',0,'2014-03-02 06:45:14'),(20806,21456,'0000-00-00','ET','2',1,NULL,'Michael Birchfield','FI','453356782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:31:02',0,'2014-03-02 07:17:36'),(21225,21875,'0000-00-00','ET','2',2,1,'Juan Guerrero','FI','460906393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:13',0,'2014-03-02 07:23:39'),(21229,21879,'0000-00-00','ET','2',1,NULL,'Cameron Stephens','FI','627329987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:16',0,'2014-03-02 07:23:39'),(21402,22052,'0000-00-00','ET','2',2,1,'Kenneth Kerr','FI','274829554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:12',0,'2014-03-03 21:36:16'),(22456,23106,'0000-00-00','ET','2',1,NULL,'Theresa Walker','FI','275765315','Summa Insurance Company, Inc.','FI','341809108','Lenda  Sojourner','94','1862271','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:39',0,'2014-03-10 16:44:18'),(103,103,'2014-01-01','ET','2',1,NULL,'PENNY KERVIN','FI','445549990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:18:08',0,'2014-03-01 22:10:55'),(13733,14089,'2014-01-01','ET','2',1,NULL,'William Cooper','FI','436692675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:03',0,'2014-03-02 05:24:45'),(918,918,'2014-01-01','ET','2',1,NULL,'Sylvia Paynter','FI','235844328','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:37',0,'2014-03-01 15:21:15'),(1037,1037,'2014-01-01','ET','2',1,NULL,'Frances Wuest','FI','283563683','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:26',0,'2014-03-10 13:10:24'),(12274,12274,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:24:22',0,'2014-03-10 16:10:34'),(3845,3845,'2014-01-01','ET','2',1,NULL,'Alan Marcosson','FI','293488857','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:27',0,'2014-03-01 15:05:09'),(11536,11536,'2014-01-01','ET','2',1,NULL,'Lakuenya Devoe','FI','438691087','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:42',0,'2014-03-02 04:52:44'),(10696,10696,'2014-01-01','ET','2',1,NULL,'Laura Horn','FI','280865476','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:23',0,'2014-03-01 16:10:36'),(10466,10466,'2014-01-01','ET','2',1,NULL,'Julie Guilfoyle','FI','288847995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:49',0,'2014-03-01 16:10:36'),(7646,7646,'2014-01-01','ET','2',1,NULL,'Ronese Manley','FI','295628490','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-01-01','Sync Success',0,'2013-12-26 04:38:43',0,'2014-03-10 13:39:10'),(4917,4917,'2014-01-01','ET','2',2,1,'Erica Jane Moore','FI','283820184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:41',0,'2014-03-01 15:05:09'),(6169,6169,'2014-01-01','ET','2',1,NULL,'HENRIC REIL','FI','449879311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:24',0,'2014-03-02 04:10:25'),(5435,5435,'2014-01-01','ET','2',1,0,'kacie macaulay','FI','284984284','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:30',0,'2014-03-01 15:05:09'),(5597,5597,'2014-01-01','ET','2',1,NULL,'Maria Flores','FI','637164859','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:49:34',0,'2014-03-02 04:45:37'),(16265,16914,'0000-00-00','ET','2',1,NULL,'Lisa Simes','FI','539620645','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:01:22',0,'2014-03-10 14:20:26'),(17593,18243,'0000-00-00','ET','2',1,NULL,'Jacqueline Graves','FI','587146850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:07',0,'2014-03-02 06:31:45'),(18241,18891,'0000-00-00','ET','2',1,NULL,'Michelle Widener','FI','426516171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:27',0,'2014-03-02 06:38:05'),(18578,19228,'0000-00-00','ET','2',1,NULL,'min yue','FI','595633035','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:15',0,'2014-03-01 17:26:36'),(20062,20712,'0000-00-00','ET','2',1,NULL,'Holly Baker','FI','283663804','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','357','2014-03-31','Sync Success',0,'2014-02-25 21:00:20',0,'2014-03-10 14:37:47'),(20155,20805,'0000-00-00','ET','2',1,NULL,'ABDIFATAH M DOLAL','FI','474477770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:58',0,'2014-03-01 18:08:07'),(20224,20874,'0000-00-00','ET','2',1,NULL,'Ronald Rose','FI','272644914','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:49',0,'2014-03-10 14:37:47'),(20435,21085,'0000-00-00','ET','2',2,1,'REBECCA EHRMAN','FI','291440403','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:53',0,'2014-03-10 16:38:05'),(1391,1391,'2014-01-01','ET','2',1,NULL,'letitia gallier','FI','451399341','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:44',0,'2014-03-02 04:45:37'),(1676,1676,'2014-01-01','ET','2',1,NULL,'EUSTACIA T FERNANDEZ','FI','453338344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:42',0,'2014-03-02 00:10:48'),(1835,1835,'2014-01-01','ET','2',2,1,'Joseph Macaluso','FI','272507690','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:45',0,'2014-03-10 13:20:27'),(2440,2440,'2014-01-01','ET','2',2,1,'Peggy Lou Faulkner','FI','453574364','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:29',0,'2014-03-10 15:45:56'),(2630,2630,'2014-01-01','ET','2',1,NULL,'James Bidinger','FI','281704488','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:57',0,'2014-03-10 15:39:19'),(10520,10520,'2014-01-01','ET','2',1,NULL,'yolvalda jones','FI','449875391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:29',0,'2014-03-02 04:24:47'),(7586,7586,'2014-01-01','ET','2',1,NULL,'Nancy Lignoski','FI','208664017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:51',0,'2014-03-01 16:05:34'),(12164,12164,'2014-01-01','ET','2',1,NULL,'Theresa Terrell Remble','FI','434815936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:54',0,'2014-03-02 04:59:36'),(3682,3682,'2014-01-01','ET','2',1,NULL,'NANCY ROBINSON','FI','427986832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:53',0,'2014-03-02 01:10:33'),(4920,4920,'2014-01-01','ET','2',1,0,'David Allan Hudson','FI','453876264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:49',0,'2014-03-01 19:11:03'),(14183,14634,'2014-01-01','ET','2',1,NULL,'edward ricks','FI','425176545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:28',0,'2014-03-02 05:38:34'),(17813,18463,'0000-00-00','ET','2',1,NULL,'Melvin Walker','FI','414195645','Starmount Life Insurance Company','FI','720977315','Wayne Colby Moore Jr','94','17097315','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:45',0,'2014-03-02 05:59:43'),(17908,18558,'0000-00-00','ET','2',1,NULL,'Travis Klekar','FI','637246954','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:34',0,'2014-03-02 06:31:45'),(18081,18731,'0000-00-00','ET','2',1,NULL,'Gayle Bush','FI','467069582','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:24',0,'2014-03-02 06:38:05'),(19000,19650,'0000-00-00','ET','2',3,2,'Nathan Kiger','FI','268848283','HealthSpan','FI','311431434','Sally  Coberly-Hough','94','2262798','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:14',0,'2014-03-10 14:31:05'),(19018,19668,'0000-00-00','ET','2',5,4,'Tessa Vanculin','FI','296825442','HealthSpan','FI','311431434','Alfred Joseph Patchin','94','7685243','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:28',0,'2014-03-10 14:31:05'),(19209,19859,'0000-00-00','ET','2',1,NULL,'Adarsh Krishen','FI','284643919','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:06',0,'2014-03-10 16:31:33'),(19761,20411,'0000-00-00','ET','2',1,NULL,'Aimee susan Wilson','FI','277805920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:14',0,'2014-03-10 16:38:05'),(20052,20702,'0000-00-00','ET','2',1,NULL,'LISA ANN TAYLOR','FI','452415803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:13',0,'2014-03-02 07:10:28'),(20187,20837,'0000-00-00','ET','2',2,1,'MARIBEL SALGADO','FI','644721017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:21',0,'2014-03-02 07:10:28'),(20586,21236,'0000-00-00','ET','2',1,NULL,'Jean Shredl','FI','289541274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 21:01:39',0,'2014-03-01 18:08:07'),(21407,22057,'0000-00-00','ET','2',1,NULL,'Kimberly Nguyen','FI','522356809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:00:15',0,'2014-03-03 21:25:18'),(711,711,'2014-01-01','ET','2',1,NULL,'WAYNE A NEU','FI','294424546','HealthSpan','FI','311431434','Cheyenne  Lopez','94','3243025','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:06',0,'2014-03-10 13:24:34'),(808,808,'2014-01-01','ET','2',1,NULL,'Georgia Romer','FI','292664114','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:30',0,'2014-03-10 13:03:33'),(12132,12132,'2014-01-01','ET','2',1,NULL,'Rhonda Allen Blair','FI','290506975','Dental Care Plus, Inc.','FI','311185262','Eric M. O\'Brien','94','10854100','357','2014-01-01','Sync Success',0,'2014-01-01 12:06:50',0,'2014-03-01 16:30:17'),(11884,11884,'2014-01-01','ET','2',1,NULL,'Hilda R Sanchez','FI','630886497','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:31',0,'2014-03-02 04:59:36'),(11626,11626,'2014-01-01','ET','2',1,NULL,'Lauren Kirby','FI','274904779','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:31',0,'2014-03-10 13:52:32'),(13282,13638,'2014-01-01','ET','2',1,NULL,'Ana M Antunez','FI','056501917','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:05',0,'2014-03-02 05:24:45'),(13040,13396,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:00:47',0,'2014-03-01 16:35:14'),(4991,4991,'2014-01-01','ET','2',1,NULL,'James Grenier','FI','296526607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:42',0,'2014-03-01 15:31:33'),(5637,5637,'2014-01-01','ET','2',1,NULL,'Candace Sissac','FI','438332848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:54',0,'2014-03-02 04:45:37'),(21373,22023,'0000-00-00','ET','2',3,2,'Annetta Blessing','FI','276645788','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:37',0,'2014-03-10 14:45:25'),(110,110,'2014-01-01','ET','2',1,NULL,'Charlie Betts','FI','587627653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:21',0,'2014-03-01 22:10:55'),(5761,5761,'2014-01-01','ET','2',1,NULL,'PATRICIA ANN ORR','FI','485589670','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:15',0,'2014-03-02 01:10:33'),(16454,17104,'0000-00-00','ET','2',1,NULL,'Lawrence Paul Fox','FI','278646975','Dental Care Plus, Inc.','FI','311185262','Rene  Reinhard','94','2772368','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:08',0,'2014-03-01 17:00:58'),(5173,5173,'2014-01-01','ET','2',1,NULL,'Nicole Ftacnik','FI','372063666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:30',0,'2014-03-10 13:20:27'),(15801,16450,'0000-00-00','ET','2',1,NULL,'armida gil','FI','551634238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:12',0,'2014-03-02 06:03:21'),(15104,15555,'0000-00-00','ET','2',2,1,'Hua Sun','FI','627135723','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:53',0,'2014-03-02 05:52:31'),(14515,14966,'2014-01-01','ET','2',2,1,'DIANA L ELSTON','FI','294729544','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:00',0,'2014-03-10 14:03:26'),(14378,14829,'2014-01-01','ET','2',1,NULL,'Sheila Caynor','FI','301463843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:57',0,'2014-03-10 16:17:47'),(2885,2885,'2014-01-01','ET','2',1,NULL,'Frances Wuest','FI','283563683','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:23:10',0,'2014-03-10 13:39:10'),(17173,17823,'0000-00-00','ET','2',1,NULL,'Robert Warren','FI','284782709','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:48',0,'2014-03-10 14:24:38'),(18126,18776,'0000-00-00','ET','2',1,NULL,'Katie Shelton','FI','461971054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:58',0,'2014-03-02 06:38:05'),(19500,20150,'0000-00-00','ET','2',2,1,'DAVID JOHNSON','FI','282623831','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:03:44',0,'2014-03-10 16:31:33'),(7160,7160,'2014-01-01','ET','2',1,NULL,'Karen Treadway','FI','279500538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:24',0,'2014-03-10 15:59:47'),(3387,3387,'2014-01-01','ET','2',1,NULL,'Katelyn Shai','94','0000336396','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 21:51:19',NULL,NULL),(15115,15566,'0000-00-00','ET','2',1,NULL,'barbara johnson','FI','297720569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:01',0,'2014-03-01 16:50:53'),(4431,4431,'2014-01-01','ET','2',1,NULL,'Kevin Louderback','FI','276887111','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:05',0,'2014-03-10 13:03:33'),(12757,12757,'2014-01-01','ET','2',1,NULL,'Rebecca Moreno','FI','284508462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:59',0,'2014-03-10 13:59:38'),(18928,19578,'0000-00-00','ET','2',1,NULL,'DEBORAH WARD','FI','295443618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:22',0,'2014-03-10 16:31:33'),(21072,21722,'0000-00-00','ET','2',1,NULL,'Debra Evans','FI','297581568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:28',0,'2014-03-01 18:10:11'),(232,232,'2014-01-01','ET','2',2,1,'Nicholas Codispoti','FI','294483316','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:18',0,'2014-03-10 15:39:19'),(977,977,'2014-01-01','ET','2',2,1,'William Fleming','FI','404721636','Dental Care Plus, Inc.','FI','311185262','Brian  Wolff','94','1888678','348','2014-01-01','Sync Success',0,'2013-12-25 18:19:30',0,'2014-03-01 15:21:15'),(13515,13871,'2014-01-01','ET','2',1,NULL,'Ashley Hickman','FI','444869380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:26',0,'2014-03-02 05:31:31'),(13380,13736,'2014-01-01','ET','2',2,1,'Rodolfo Maldonado','FI','467413746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:45',0,'2014-03-02 05:24:45'),(1356,1356,'2014-01-01','ET','2',1,NULL,'Phillip  Ray Simmons','FI','446629950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:38',0,'2014-03-02 04:38:08'),(4461,4461,'2014-01-01','ET','2',1,NULL,'Christine Reiser','FI','282447841','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:47',0,'2014-03-01 15:16:37'),(6002,6002,'2014-01-01','ET','2',1,NULL,'Laura Johnson','FI','455946767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:34:06',0,'2014-03-02 02:10:49'),(1909,1909,'2014-01-01','ET','2',1,NULL,'Martin Sanchez','FI','565153682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:02',0,'2014-03-01 23:10:52'),(1945,1945,'2014-01-01','ET','2',1,NULL,'LINDA LINER','FI','160460322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:05',0,'2014-03-01 15:26:40'),(3558,3558,'2014-01-01','ET','2',2,1,'George Leyda','FI','278486753','Dental Care Plus, Inc.','FI','311185262','John L Nelson','94','2256884','348','2014-01-01','Sync Success',0,'2013-12-25 22:03:04',0,'2014-03-01 15:37:30'),(21017,21667,'0000-00-00','ET','2',1,NULL,'Nhai Nguyen','FI','586507721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 21:00:12',0,'2014-03-02 07:23:39'),(1775,1775,'2014-01-01','ET','2',1,NULL,'Monique Knichen','FI','438134308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:47',0,'2014-03-02 00:10:48'),(16450,17100,'0000-00-00','ET','2',1,NULL,'Sameer Shannawi','FI','603581086','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:06',0,'2014-03-01 17:00:58'),(10497,10497,'2014-01-01','ET','2',1,NULL,'Christine Rice','FI','298905674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:47',0,'2014-03-01 16:15:39'),(4354,4354,'2014-01-01','ET','2',2,1,'Paul M Johnson','FI','269568096','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:54',0,'2014-03-10 13:32:15'),(13607,13963,'2014-01-01','ET','2',2,1,'Patricia Nuss','FI','271440678','Dental Care Plus, Inc.','FI','311185262','Tim  Walters','94','1852658','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:30',0,'2014-03-01 16:40:16'),(12863,12863,'2014-01-01','ET','2',1,NULL,'Linda Hemmig','FI','283462737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:32',0,'2014-03-01 16:35:14'),(21690,22340,'0000-00-00','ET','2',1,NULL,'Mia Ramos','94','0000707674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:30',0,'2014-03-04 21:36:30'),(22696,23346,'0000-00-00','ET','2',1,NULL,'Lisa Michelle Peters','FI','519966065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:55',0,'2014-03-08 21:35:36'),(22721,23371,'0000-00-00','ET','2',1,NULL,'Bryan Speed','FI','587445299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:14',0,'2014-03-08 22:26:18'),(22739,23389,'0000-00-00','ET','2',1,NULL,'Celetta Walker','FI','434351623','Starmount Life Insurance Company','FI','720977315','Patrick  Tyson','94','7409844','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:03',0,'2014-03-09 21:26:00'),(23023,23673,'0000-00-00','ET','2',1,NULL,'rhonda neeley','FI','484807767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:08',0,'2014-03-10 21:27:11'),(30,30,'2014-01-01','ET','2',1,NULL,'BEN  B ARCHINAL','FI','275865475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:54',0,'2014-03-01 15:21:15'),(2469,2469,'2014-01-01','ET','2',2,1,'JULES A PRIESTLEY','FI','434988481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:30',0,'2014-03-01 23:10:52'),(16509,17159,'0000-00-00','ET','2',1,NULL,'MARIA BULTER','FI','372609998','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:42',0,'2014-03-02 06:17:30'),(15346,15797,'0000-00-00','ET','2',1,NULL,'Ronald Villegas','FI','545433579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:47',0,'2014-03-02 05:52:31'),(14955,15406,'2014-01-01','ET','2',1,NULL,'JUAN LOPEZ','FI','460830235','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:50',0,'2014-03-02 05:45:37'),(17451,18101,'0000-00-00','ET','2',2,1,'SHANNON RESER','FI','301809370','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:17',0,'2014-03-01 17:20:55'),(20572,21222,'0000-00-00','ET','2',1,NULL,'Domonitue Price','FI','456676245','Starmount Life Insurance Company','FI','720977315','Sherri  Paules','94','597218','348','2014-04-01','Sync Success',0,'2014-02-26 21:01:31',0,'2014-03-02 07:17:36'),(21405,22055,'0000-00-00','ET','2',1,NULL,'hongnga tran','FI','024683507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:14',0,'2014-03-03 21:25:18'),(21888,22538,'0000-00-00','ET','2',2,1,'Daniel Aguilar','FI','461153554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:34',0,'2014-03-05 22:27:33'),(14336,14787,'2014-01-01','ET','2',1,NULL,'KIMBINH T NGUYEN','FI','638545291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:40',0,'2014-03-02 05:38:34'),(15494,15945,'0000-00-00','ET','2',1,NULL,'Bhalinder Singh Chahal','FI','271176838','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:23:10',0,'2014-03-10 16:17:47'),(19748,20398,'0000-00-00','ET','2',1,NULL,'Bettyann Virginia Kaiser','FI','275660036','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:05',0,'2014-03-10 14:37:47'),(20507,21157,'0000-00-00','ET','2',1,NULL,'SHEILA MALBREW','FI','436355109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:47',0,'2014-03-02 07:17:36'),(21614,22264,'0000-00-00','ET','2',1,NULL,'MEGAN LYNCH','FI','632229733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:32',0,'2014-03-04 21:27:16'),(1866,1866,'2014-01-01','ET','2',1,NULL,'runata schanaun booker','FI','285848504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:44',0,'2014-03-01 15:26:40'),(2677,2677,'2014-01-01','ET','2',2,1,'NORMA I LEAL','FI','555357917','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:27',0,'2014-03-02 04:15:49'),(16917,17567,'0000-00-00','ET','2',1,NULL,'Allison Kytta','FI','274906141','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:37',0,'2014-03-01 17:00:58'),(7340,7340,'2014-01-01','ET','2',1,NULL,'Patricia Tovar','FI','645107125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:08',0,'2014-03-01 21:11:04'),(7046,7046,'2014-01-01','ET','2',1,NULL,'Ronald Jordan','FI','489528761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:54',0,'2014-03-02 03:09:49'),(19651,20301,'0000-00-00','ET','2',2,1,'EMILY GARZA','FI','280843026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:43:28',0,'2014-03-01 17:47:19'),(292,292,'2014-01-01','ET','2',1,NULL,'Linda Lou Van Slyke','FI','271527444','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:24',0,'2014-03-10 13:03:33'),(16161,16810,'0000-00-00','ET','2',1,NULL,'Webb Wright','FI','454634086','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:14',0,'2014-03-02 06:10:30'),(2230,2230,'2014-01-01','ET','2',1,NULL,'ROBERT JOHN HALL','FI','298483142','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:13',0,'2014-03-10 15:39:19'),(15545,15996,'0000-00-00','ET','2',1,NULL,'Synolin Clark','FI','457718127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:11',0,'2014-03-02 05:59:43'),(3593,3593,'2014-01-01','ET','2',1,NULL,'Brenda Pettis','FI','452470682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:07',0,'2014-03-02 01:10:33'),(5219,5219,'2014-01-01','ET','2',2,1,'Gregory Abrams','FI','278687799','HealthSpan','FI','311431434','Jason  Suchanek','94','1491309','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:01',0,'2014-03-10 13:20:27'),(5497,5497,'2014-01-01','ET','2',1,NULL,'Garland Givens','FI','285803627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:46:20',0,'2014-03-01 16:23:43'),(876,876,'2014-01-01','ET','2',1,NULL,'August Bear','FI','425066182','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:29',0,'2014-03-01 15:21:15'),(2453,2453,'2014-01-01','ET','2',2,1,'Joseph Whittenton Pierce','FI','431922982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:57',0,'2014-03-01 23:10:52'),(16934,17584,'0000-00-00','ET','2',1,NULL,'Allison Daniels','FI','426637697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:47',0,'2014-03-02 06:17:30'),(15208,15659,'0000-00-00','ET','2',1,NULL,'Phil Borshell','FI','571912091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:30',0,'2014-03-01 16:50:53'),(12960,12960,'2014-01-01','ET','2',1,NULL,'Alma Garcia','FI','463316361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:43',0,'2014-03-02 05:17:40'),(4755,4755,'2014-01-01','ET','2',1,NULL,'Donna Finke','FI','282548168','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:29',0,'2014-03-01 15:16:37'),(18328,18978,'0000-00-00','ET','2',2,1,'Tiffany Budzinski','FI','291900309','Dental Care Plus, Inc.','FI','311185262','Tiffany  Budzinski','94','17140606','348','2014-03-01','Sync Success',0,'2014-02-12 21:30:13',0,'2014-03-01 17:26:36'),(20071,20721,'0000-00-00','ET','2',1,NULL,'Sharon M Cenna','FI','083442803','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:26',0,'2014-03-01 18:08:07'),(20114,20764,'0000-00-00','ET','2',1,NULL,'TAMMY FLEMING','FI','434594218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:30',0,'2014-03-02 07:10:28'),(22275,22925,'0000-00-00','ET','2',2,1,'Karen Smith','FI','290522342','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:34',0,'2014-03-10 14:45:25'),(11106,11106,'2014-01-01','ET','2',1,NULL,'Celinda Pinson','FI','273485844','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:18',0,'2014-03-10 13:45:57'),(14625,15076,'2014-01-01','ET','2',1,NULL,'DEBORA ROBERTSON','FI','283589571','Dental Care Plus, Inc.','FI','311185262','FRANK  DOSCH','94','318226','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:06',0,'2014-03-01 16:46:19'),(13582,13938,'2014-01-01','ET','2',2,1,'Antonio Murdocco','FI','288580070','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:12',0,'2014-03-10 16:10:34'),(12846,12846,'2014-01-01','ET','2',1,NULL,'patricia molina','FI','464430929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:55',0,'2014-03-02 05:10:52'),(5431,5431,'2014-01-01','ET','2',1,0,'john byers','FI','455272816','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:22',0,'2014-03-01 19:11:03'),(5583,5583,'2014-01-01','ET','2',2,1,'George Leonard Spencer','FI','636074870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:06',0,'2014-03-02 04:45:37'),(10444,10444,'2014-01-01','ET','2',1,NULL,'Ryan Erwin','FI','295904704','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:07',0,'2014-03-01 16:10:36'),(17961,18611,'0000-00-00','ET','2',1,NULL,'Scott Hardy','FI','378942026','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:12',0,'2014-03-01 17:20:55'),(19321,19971,'0000-00-00','ET','2',1,NULL,'DONNA JEAN MILLNER','FI','465021303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-18 22:00:12',0,'2014-03-02 06:59:07'),(21700,22350,'0000-00-00','ET','2',1,NULL,'Madison Parker','FI','425690027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:39',0,'2014-03-04 21:27:16'),(22765,23415,'0000-00-00','ET','2',1,NULL,'Johnduras Godbolt','FI','593128142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:22',0,'2014-03-09 21:26:00'),(11532,11532,'2014-01-01','ET','2',1,NULL,'trang tran','FI','434850892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:36',0,'2014-03-02 04:52:44'),(1804,1804,'2014-01-01','ET','2',1,NULL,'Debra Crosby','FI','287549643','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:47',0,'2014-03-10 13:20:27'),(4586,4586,'2014-01-01','ET','2',1,NULL,'Kareema Williams','FI','296861429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:46:51',0,'2014-03-01 16:15:39'),(13909,14265,'2014-01-01','ET','2',2,1,'Ray Nissen','FI','280523587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:07',0,'2014-03-01 16:40:16'),(4890,4890,'2014-01-01','ET','2',1,0,'Patricia Gremillion','FI','439821424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:02',0,'2014-03-01 19:11:03'),(13075,13431,'2014-01-01','ET','2',1,NULL,'Mary Ellison','FI','433943142','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','163725','348','2014-02-01','Sync Success',0,'2014-01-07 04:01:58',0,'2014-03-02 05:17:40'),(18374,19024,'0000-00-00','ET','2',1,NULL,'Phyllis Catoe','FI','467865770','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:43',0,'2014-03-02 06:45:14'),(18503,19153,'0000-00-00','ET','2',1,NULL,'donna swearingen','FI','294441151','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:12',0,'2014-03-10 14:31:05'),(2468,2468,'2014-01-01','ET','2',1,NULL,'MYA HARRIS','FI','365782520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:19:29',0,'2014-03-01 23:10:52'),(14311,14762,'2014-01-01','ET','2',1,NULL,'Jennifer McCall','FI','467653287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:29',0,'2014-03-02 05:38:34'),(15023,15474,'2014-01-01','ET','2',1,NULL,'sharanda Gibbs','FI','435699260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:20',0,'2014-03-02 05:52:31'),(7070,7070,'2014-01-01','ET','2',1,NULL,'james a ryan','FI','284541280','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:39',0,'2014-03-01 15:52:44'),(12126,12126,'2014-01-01','ET','2',1,NULL,'PATRICIA FESTAGALLO','FI','272660082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:06:39',0,'2014-03-01 16:30:17'),(7731,7731,'2014-01-01','ET','2',1,NULL,'Neda Spears','FI','298746208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:15',0,'2014-03-01 15:05:09'),(13309,13665,'2014-01-01','ET','2',1,NULL,'Kristine Woolery','FI','099423273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:16',0,'2014-03-01 16:40:16'),(12804,12804,'2014-01-01','ET','2',1,NULL,'ALBERT ISASSI','FI','465153433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:25',0,'2014-03-02 05:17:40'),(3630,3630,'2014-01-01','ET','2',2,1,'MERCEDES RUBINO','FI','282543618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:17',0,'2014-03-10 15:52:36'),(6228,6228,'2014-01-01','ET','2',1,NULL,'KEVIN BAILOSKY','FI','283862692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:05:13',0,'2014-03-01 16:00:27'),(4710,4710,'2014-01-01','ET','2',1,NULL,'Rachael Schneider','94','0000384394','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-25 23:50:58',0,'2014-03-10 13:45:57'),(16391,17041,'0000-00-00','ET','2',1,NULL,'Anne Lois Haskins','FI','277726199','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:21',0,'2014-03-10 14:20:26'),(15831,16480,'0000-00-00','ET','2',1,NULL,'Peter Holland','FI','276822262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:29',0,'2014-03-01 16:56:22'),(13727,14083,'2014-01-01','ET','2',1,NULL,'ARLEEN LANDRY','FI','433354145','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:59',0,'2014-03-02 05:24:45'),(18404,19054,'0000-00-00','ET','2',2,1,'Nathan Redmond','FI','297903112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:04',0,'2014-03-01 17:26:36'),(18488,19138,'0000-00-00','ET','2',1,NULL,'Jennifer Lenahan','FI','268869914','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:01',0,'2014-03-10 16:31:33'),(19982,20632,'0000-00-00','ET','2',1,NULL,'Rachelle Lee','FI','620188371','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:40',0,'2014-03-02 07:03:25'),(442,442,'2014-01-01','ET','2',1,NULL,'Robin L Anderson','FI','296501026','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:43',0,'2014-03-10 15:45:56'),(16718,17368,'0000-00-00','ET','2',1,NULL,'Kenneth Kimberlin','FI','301464183','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:30',0,'2014-03-10 16:24:30'),(1420,1420,'2014-01-01','ET','2',1,NULL,'Kathi-Anne Kozlowski','FI','292503376','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:43',0,'2014-03-10 13:45:57'),(16514,17164,'0000-00-00','ET','2',1,NULL,'Trenton Rashard banks','FI','427473282','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:46',0,'2014-03-02 06:10:30'),(14456,14907,'2014-01-01','ET','2',1,NULL,'Annie Black','FI','439130536','Starmount Life Insurance Company','FI','720977315','Karen Ferguson Bruyninckx','94','4762708','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:33',0,'2014-03-02 05:38:34'),(13442,13798,'2014-01-01','ET','2',1,NULL,'Victor Rabago','FI','463512040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:14',0,'2014-03-02 05:31:31'),(11636,11636,'2014-01-01','ET','2',1,NULL,'Erica Day','FI','418375979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:50',0,'2014-03-02 04:59:36'),(5356,5356,'2014-01-01','ET','2',1,NULL,'MARY  NETH','FI','293467631','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:04',0,'2014-03-10 13:03:33'),(10849,10849,'2014-01-01','ET','2',2,1,'Anthony Smith','FI','300720606','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:28',0,'2014-03-10 13:45:57'),(22589,23239,'0000-00-00','ET','2',1,NULL,'Allyson Johnson','FI','455790700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:14',0,'2014-03-07 22:26:59'),(1796,1796,'2014-01-01','ET','2',1,NULL,'wade beesley','FI','454271289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:31',0,'2014-03-02 00:10:48'),(15119,15570,'0000-00-00','ET','2',1,NULL,'Karen Thacker','FI','289505271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:03',0,'2014-03-01 16:50:53'),(14377,14828,'2014-01-01','ET','2',1,NULL,'Jamie Forsch','FI','272743638','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:56',0,'2014-03-10 16:17:47'),(13768,14124,'2014-01-01','ET','2',1,NULL,'ANGELA DOUGLAS','FI','268666892','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:26',0,'2014-03-10 13:59:38'),(10915,10915,'2014-01-01','ET','2',1,NULL,'Roseanna Clark','FI','299525063','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:08',0,'2014-03-10 16:03:49'),(4268,4268,'2014-01-01','ET','2',1,NULL,'Elease Lewis','FI','433271629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:21',0,'2014-03-02 03:09:49'),(7581,7581,'2014-01-01','ET','2',3,2,'PETER  JOSEPH STUNTEBECK','FI','302528389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:39',0,'2014-03-01 16:05:34'),(19169,19819,'0000-00-00','ET','2',1,NULL,'Ismael Yanez','FI','454110561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:38',0,'2014-03-02 06:52:12'),(22706,23356,'0000-00-00','ET','2',2,1,'BECKY EVANS-HENRY','FI','278524973','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:03',0,'2014-03-10 16:44:18'),(7270,7270,'2014-01-01','ET','2',2,1,'gerald joseph','FI','291484004','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:48',0,'2014-03-10 13:32:15'),(11948,11948,'2014-01-01','ET','2',1,NULL,'Erik Little','FI','425111819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:08',0,'2014-03-02 04:59:36'),(17235,17885,'0000-00-00','ET','2',1,NULL,'Stephone Jeffries','94','0000999881','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','357','2014-03-01','Sync Success',0,'2014-02-05 21:30:23',0,'2014-03-10 16:24:30'),(15957,16606,'0000-00-00','ET','2',1,NULL,'Violet Frimel','94','0000722664','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:08',0,'2014-03-01 16:56:22'),(14149,14600,'2014-01-01','ET','2',1,NULL,'DOUGLAS CARTER','FI','439316536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:07',0,'2014-03-02 05:38:34'),(18511,19161,'0000-00-00','ET','2',1,NULL,'Cortney Whittington','FI','428672746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:19',0,'2014-03-02 06:45:14'),(19006,19656,'0000-00-00','ET','2',1,NULL,'Karl Schmid','FI','292505712','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:19',0,'2014-03-10 14:31:05'),(20726,21376,'0000-00-00','ET','2',2,1,'CAROL FOUT','FI','269589262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:24',0,'2014-03-01 18:08:07'),(21926,22576,'0000-00-00','ET','2',1,NULL,'Stephanie Grant','FI','608322205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:01',0,'2014-03-05 22:27:33'),(22675,23325,'0000-00-00','ET','2',1,NULL,'DERRICK KELLEY','FI','193560407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:40',0,'2014-03-08 22:26:18'),(487,487,'2014-01-01','ET','2',1,NULL,'william dunlap','FI','296408553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:00:05',0,'2014-03-01 15:48:04'),(17065,17715,'0000-00-00','ET','2',1,NULL,'Quynh Nguyen','FI','586384514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-19','Sync Success',0,'2014-02-04 21:00:38',0,'2014-03-02 06:24:38'),(16194,16843,'0000-00-00','ET','2',1,NULL,'Floyd Baham','FI','438646383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:34',0,'2014-03-02 06:03:21'),(15330,15781,'0000-00-00','ET','2',1,NULL,'Lisa Michelle Peters','FI','519966065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2014-01-21 08:46:36',NULL,NULL),(15178,15629,'0000-00-00','ET','2',1,NULL,'christy butler','FI','427498597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:11',0,'2014-03-02 05:52:31'),(536,536,'2014-01-01','ET','2',1,NULL,'Jessica Braine','FI','006564631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:35',0,'2014-03-01 15:48:04'),(7521,7521,'2014-01-01','ET','2',1,NULL,'Shannon Boedecker','FI','290908313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:43',0,'2014-03-01 16:05:34'),(5044,5044,'2014-01-01','ET','2',1,NULL,'Patricia Brown','FI','295541465','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:23',0,'2014-03-01 15:31:33'),(19311,19961,'0000-00-00','ET','2',1,NULL,'YOLANDA LUGO','FI','466945691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:05',0,'2014-03-02 06:59:07'),(11790,11790,'2014-01-01','ET','2',1,NULL,'sophia cao','FI','465531754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:49',0,'2014-03-02 04:31:46'),(16640,17290,'0000-00-00','ET','2',1,NULL,'betty johnson','FI','434157639','Starmount Life Insurance Company','FI','720977315','pamela  price','94','4697079','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:35',0,'2014-03-02 06:17:30'),(11486,11486,'2014-01-01','ET','2',1,NULL,'Joyce Whitehead','FI','278785539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:14',0,'2014-03-01 16:30:17'),(14998,15449,'2014-01-01','ET','2',1,NULL,'Alex Griffin','FI','426738125','Starmount Life Insurance Company','FI','720977315','Laura  Bilbrew','94','8968156','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:09',0,'2014-03-02 05:45:37'),(14605,15056,'2014-01-01','ET','2',1,NULL,'William Doyle','FI','271561370','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:53',0,'2014-03-01 16:46:19'),(14511,14962,'2014-01-01','ET','2',2,1,'Michael Peiples','FI','293749263','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:58',0,'2014-03-10 14:03:26'),(1996,1996,'2014-01-01','ET','2',1,NULL,'Jose Cardenas','FI','230439398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:43',0,'2014-03-01 23:10:52'),(11031,11031,'2014-01-01','ET','2',3,2,'Corey Kuntz','FI','285602784','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:50',0,'2014-03-10 15:59:47'),(5819,5819,'2014-01-01','ET','2',1,NULL,'Gavin Edwards','FI','331724879','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:02',0,'2014-03-10 13:03:33'),(7678,7678,'2014-01-01','ET','2',1,NULL,'John Patterson','FI','285524114','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:46',0,'2014-03-10 13:39:10'),(3791,3791,'2014-01-01','ET','2',1,NULL,'Shemekisa Jobe','FI','553719706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:01',0,'2014-03-01 23:10:52'),(279,279,'2014-01-01','ET','2',2,1,'Dave j Lagreca','FI','281627745','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:57',0,'2014-03-01 15:05:09'),(17313,17963,'0000-00-00','ET','2',1,NULL,'Jeff Kellerman','FI','284780657','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:02',0,'2014-03-10 14:24:38'),(14381,14832,'2014-01-01','ET','2',1,NULL,'David Duncan','FI','299482843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:58',0,'2014-03-01 16:46:19'),(13724,14080,'2014-01-01','ET','2',1,NULL,'Darren J Morse','FI','433732538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:57',0,'2014-03-02 05:24:45'),(2093,2093,'2014-01-01','ET','2',1,NULL,'Gina Maiorana','FI','124541792','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:49',0,'2014-03-10 13:20:27'),(12147,12147,'2014-01-01','ET','2',1,NULL,'Sherri Pitalo','FI','587429647','Starmount Life Insurance Company','FI','720977315','Cameron  Lilienquist','94','8328382','348','2014-02-01','Sync Success',0,'2014-01-01 12:07:21',0,'2014-03-02 04:59:36'),(3562,3562,'2014-01-01','ET','2',1,NULL,'stefanie montanez','FI','639010774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:13',0,'2014-03-02 00:10:48'),(4892,4892,'2014-01-01','ET','2',1,0,'Allison Nickle','FI','466957564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:06',0,'2014-03-01 19:11:03'),(3270,3270,'2014-01-01','ET','2',1,NULL,'NICHOLAS MALLARD','FI','428497429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:30',0,'2014-03-02 02:10:49'),(2832,2832,'2014-01-01','ET','2',2,1,'Cory Shockey','FI','467651827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:22',0,'2014-03-02 04:15:49'),(2733,2733,'2014-01-01','ET','2',1,NULL,'Glenda Lambert','FI','436792502','Starmount Life Insurance Company','FI','720977315','Lisa  Prater','94','15945577','348','2014-01-01','Sync Success',0,'2013-12-25 21:18:13',0,'2014-03-02 04:15:49'),(17838,18488,'0000-00-00','ET','2',1,NULL,'kenneth leslie','FI','279608228','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:05',0,'2014-03-10 14:20:26'),(21318,21968,'0000-00-00','ET','2',1,NULL,'FRANCISCO LUIS OPINA','FI','144745927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:06',0,'2014-03-03 01:07:25'),(21460,22110,'0000-00-00','ET','2',1,NULL,'Robert C Baer','FI','272827344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:28',0,'2014-03-03 21:36:16'),(21634,22284,'0000-00-00','ET','2',1,NULL,'Evelyn Olivia Lewis','FI','451210869','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:47',0,'2014-03-04 21:27:16'),(11457,11457,'2014-01-01','ET','2',1,NULL,'Crystal Pennick','FI','523317645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:24',0,'2014-03-01 16:30:17'),(7061,7061,'2014-01-01','ET','2',1,NULL,'Brenda Phillips','FI','268620475','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:21',0,'2014-03-01 15:52:44'),(16369,17019,'0000-00-00','ET','2',1,NULL,'STACI ORTOLANO','FI','435652084','Starmount Life Insurance Company','FI','720977315','PATRICK  TYSON','94','7409844','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:06',0,'2014-03-02 06:10:30'),(4472,4472,'2014-01-01','ET','2',2,1,'adam valderas','FI','463711398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:07',0,'2014-03-01 21:11:04'),(14779,15230,'2014-01-01','ET','2',3,2,'Craig Haley','94','0000432782','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:44',0,'2014-03-10 14:03:26'),(18286,18936,'0000-00-00','ET','2',1,NULL,'george johnson','FI','322681624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:16',0,'2014-03-02 06:38:05'),(19411,20061,'0000-00-00','ET','2',1,NULL,'CHRISTOPHER CORNELIUS','FI','250872538','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:17',0,'2014-03-10 16:31:33'),(993,993,'2014-01-01','ET','2',1,NULL,'LINDA  LEWIS','FI','302447964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:01',0,'2014-03-01 15:21:15'),(1316,1316,'2014-01-01','ET','2',1,NULL,'Cornelius Brown','FI','645053771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:20',0,'2014-03-02 04:38:08'),(17715,18365,'0000-00-00','ET','2',1,NULL,'melonie harmon','FI','464439388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:11',0,'2014-03-02 06:31:45'),(16271,16921,'0000-00-00','ET','2',1,NULL,'Jesse Ann Knighton','FI','545888423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:05',0,'2014-03-02 06:10:30'),(5523,5523,'2014-01-01','ET','2',1,NULL,'thomas tarsitano','FI','273688290','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:07',0,'2014-03-01 16:23:43'),(14598,15049,'2014-01-01','ET','2',1,NULL,'Teresa Early','FI','292845010','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:49',0,'2014-03-01 16:46:19'),(4171,4171,'2014-01-01','ET','2',1,NULL,'Jamie Allshouse','FI','280689387','Summa Insurance Company, Inc.','FI','341809108','Deana  Alexander','94','2228297','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:18',0,'2014-03-10 15:59:47'),(2207,2207,'2014-01-01','ET','2',1,NULL,'Tausha Spratlin','FI','427396209','Starmount Life Insurance Company','FI','720977315','Greg H Town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-25 19:48:24',0,'2014-03-01 21:11:04'),(12602,12602,'2014-01-01','ET','2',2,1,'CATARINO CABRERA','FI','453279470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:09',0,'2014-03-02 05:10:52'),(12296,12296,'2014-01-01','ET','2',1,NULL,'Alonzo Pollard','FI','426414398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:08',0,'2014-03-02 05:10:52'),(2734,2734,'2014-01-01','ET','2',1,NULL,'Tyrannie Page','FI','280923850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:14',0,'2014-03-02 04:15:49'),(18550,19200,'0000-00-00','ET','2',2,1,'Michael Carnes','FI','310548586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:11',0,'2014-03-01 17:26:36'),(214,214,'2014-01-01','ET','2',1,NULL,'Evelyn Dorothea Grace','FI','291509009','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:45',0,'2014-03-10 13:10:24'),(12324,12324,'2014-01-01','ET','2',1,NULL,'MARIA ELENA RAMIREZ','FI','458873470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:58',0,'2014-03-02 05:03:29'),(7205,7205,'2014-01-01','ET','2',2,1,'Brianna McIlvain','FI','290821605','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:48',0,'2014-03-01 15:52:44'),(14306,14757,'2014-01-01','ET','2',1,NULL,'Tonia Michelle Bingham','FI','464837846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:27',0,'2014-03-02 05:38:34'),(3530,3530,'2014-01-01','ET','2',2,1,'Jason Blake','FI','282825870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:09',0,'2014-03-01 15:31:33'),(18495,19145,'0000-00-00','ET','2',2,1,'Lisa Lupo','FI','288665366','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:05',0,'2014-03-10 16:31:33'),(19128,19778,'0000-00-00','ET','2',1,NULL,'ALBERTA HOLBERT','FI','285689255','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:04',0,'2014-03-01 17:34:07'),(22151,22801,'0000-00-00','ET','2',1,NULL,'KEVIN DECKER','FI','290685436','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:01:05',0,'2014-03-06 21:36:23'),(22814,23464,'0000-00-00','ET','2',1,NULL,'Benjamin Stafford Price','FI','282827762','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:04',0,'2014-03-10 14:50:59'),(12093,12093,'2014-01-01','ET','2',1,NULL,'John Doughty','94','0000636019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:29',0,'2014-03-01 16:30:17'),(17495,18145,'0000-00-00','ET','2',1,NULL,'gail brown','FI','470881558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:51',0,'2014-03-02 06:31:45'),(7102,7102,'2014-01-01','ET','2',1,NULL,'Sameer Suri','FI','272023346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:03:39',0,'2014-03-01 15:52:44'),(2627,2627,'2014-01-01','ET','2',1,NULL,'Carolyn Dunlavy','FI','271543705','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:50',0,'2014-03-10 15:39:19'),(13162,13518,'2014-01-01','ET','2',1,NULL,'Victorlynn Wince','FI','587542063','Starmount Life Insurance Company','FI','720977315','Revonno  Burt','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-07 04:05:19',0,'2014-03-02 05:17:40'),(12913,12913,'2014-01-01','ET','2',1,NULL,'RAY ANN CHERAMIE','FI','435069176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:23',0,'2014-03-02 05:10:52'),(5462,5462,'2014-01-01','ET','2',1,NULL,'Antoinette Poole','FI','436832119','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:13',0,'2014-03-02 04:45:37'),(3144,3144,'2014-01-01','ET','2',2,1,'Susan Hollington','FI','376566823','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:33',0,'2014-03-10 13:24:34'),(18782,19432,'0000-00-00','ET','2',2,1,'Jamie Mohr','FI','300823824','HealthSpan','FI','311431434','Dianne  Rudolph','94','13065591','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:53',0,'2014-03-10 14:31:05'),(21288,21938,'0000-00-00','ET','2',1,NULL,'SHERRY WARREN','FI','455845971','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:56',0,'2014-03-02 07:23:39'),(12425,12425,'2014-01-01','ET','2',1,NULL,'RICKY ENGLISH','FI','435865653','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:35',0,'2014-03-02 05:03:29'),(17452,18102,'0000-00-00','ET','2',1,NULL,'LINDA MILLER','FI','297563914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:01:18',0,'2014-03-01 17:20:55'),(2986,2986,'2014-01-01','ET','2',1,NULL,'Mickey Landers','FI','465805342','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:42',0,'2014-03-02 01:10:33'),(2761,2761,'2014-01-01','ET','2',1,NULL,'Jennifer Lee','FI','427874498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:05',0,'2014-03-02 04:15:49'),(12905,12905,'2014-01-01','ET','2',1,NULL,'richard gillman','FI','189425254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:04',0,'2014-03-02 05:17:40'),(16557,17207,'0000-00-00','ET','2',2,1,'Rebecca Baker','FI','271760553','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:13',0,'2014-03-10 14:20:26'),(15557,16008,'0000-00-00','ET','2',1,NULL,'Alonzo Washington','FI','287682085','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:17',0,'2014-03-01 16:50:53'),(15308,15759,'0000-00-00','ET','2',1,NULL,'Harry Michael Covert','FI','274602791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:23',0,'2014-03-01 16:50:53'),(612,612,'2014-01-01','ET','2',1,NULL,'Maria Aragon','FI','466351973','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:58',0,'2014-03-02 02:10:49'),(7154,7154,'2014-01-01','ET','2',1,NULL,'ALPHONSO KENT','FI','175583999','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:13',0,'2014-03-10 15:52:36'),(14465,14916,'2014-01-01','ET','2',2,1,'Thuy Nguyen','FI','603437158','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:36',0,'2014-03-02 05:45:37'),(12334,12334,'2014-01-01','ET','2',1,NULL,'Maricela Ramirez','FI','451559156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:22',0,'2014-03-02 05:03:29'),(11931,11931,'2014-01-01','ET','2',1,NULL,'Mark Hall','FI','462154343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:00',0,'2014-03-02 04:59:36'),(4225,4225,'2014-01-01','ET','2',1,NULL,'Bartholomew Sullivan','FI','269828832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:01',0,'2014-03-01 16:00:27'),(6071,6071,'2014-01-01','ET','2',1,NULL,'Jessica Patterson','FI','439698997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:00:23',0,'2014-03-02 04:10:25'),(18581,19231,'0000-00-00','ET','2',5,4,'Charles Walden','FI','276443304','Dental Care Plus, Inc.','FI','311185262','David B Scheller','94','8780359','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:19',0,'2014-03-01 17:26:36'),(19291,19941,'0000-00-00','ET','2',1,NULL,'LATOYA CHEATHAM','FI','275901991','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-18 21:30:12',0,'2014-03-10 16:31:33'),(20304,20954,'0000-00-00','ET','2',1,NULL,'Mary Faciane','FI','436906536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:44',0,'2014-03-02 07:10:28'),(343,343,'2014-01-01','ET','2',1,NULL,'DAVID BURROUGHS','FI','510607244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:33',0,'2014-03-01 15:21:15'),(15934,16583,'0000-00-00','ET','2',1,NULL,'Eva Shooks','FI','276567899','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:13',0,'2014-03-01 16:56:22'),(13636,13992,'2014-01-01','ET','2',2,1,'Cindy Mize','FI','378641339','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:51',0,'2014-03-10 13:59:38'),(2191,2191,'2014-01-01','ET','2',1,NULL,'Andres Mireles','FI','635101291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:51',0,'2014-03-01 21:11:04'),(7193,7193,'2014-01-01','ET','2',1,NULL,'Janie Ilfrey','FI','464827020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:26',0,'2014-03-02 03:09:49'),(11720,11720,'2014-01-01','ET','2',1,NULL,'alfred clark','FI','427370728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:31',0,'2014-03-02 04:59:36'),(4575,4575,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:29',0,'2014-03-01 16:15:39'),(5638,5638,'2014-01-01','ET','2',1,NULL,'Randall Daquanno','FI','437799290','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:56',0,'2014-03-02 04:45:37'),(6058,6058,'2014-01-01','ET','2',1,NULL,'Michel Willis','FI','453960959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:52',0,'2014-03-01 19:11:03'),(4713,4713,'2014-01-01','ET','2',1,NULL,'Rosalyn Morris','FI','426517739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:05',0,'2014-03-02 04:31:46'),(17024,17674,'0000-00-00','ET','2',1,NULL,'whitney pouncey','FI','643108240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:14',0,'2014-03-02 06:24:38'),(18212,18862,'0000-00-00','ET','2',1,NULL,'KYAW SAY','FI','292138772','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:03',0,'2014-03-10 16:31:33'),(21837,22487,'0000-00-00','ET','2',1,NULL,'JUANITA RICHARD','FI','433780949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:28',0,'2014-03-05 21:25:24'),(21874,22524,'0000-00-00','ET','2',2,1,'Rashmiben Patel','FI','148880320','Dental Care Plus, Inc.','FI','311185262','Timothy Allen Strand','94','1774499','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:24',0,'2014-03-05 21:36:22'),(21935,22585,'0000-00-00','ET','2',1,NULL,'pamela k webb','FI','264472483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:07',0,'2014-03-05 22:27:33'),(22419,23069,'0000-00-00','ET','2',1,NULL,'Crystal Barnes','FI','631107898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:13',0,'2014-03-07 22:26:59'),(23117,23767,'0000-00-00','ET','2',1,NULL,'Alica Thomas','FI','452954900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:30:15',0,'2014-03-10 22:25:11'),(10795,10795,'2014-01-01','ET','2',1,NULL,'BERROUET LOUIS','FI','437938909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:42',0,'2014-03-02 04:24:47'),(13744,14100,'2014-01-01','ET','2',1,NULL,'SHELLEY DAVIS','FI','181568304','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:10',0,'2014-03-01 16:40:16'),(5488,5488,'2014-01-01','ET','2',1,NULL,'Juan Tabora','FI','434813775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:46:00',0,'2014-03-02 04:45:37'),(12539,12539,'2014-01-01','ET','2',3,2,'Jennifer Milefchik','FI','296802411','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:48',0,'2014-03-10 13:59:38'),(3769,3769,'2014-01-01','ET','2',1,NULL,'Lianne Pereira','FI','289580951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:18',0,'2014-03-01 23:10:52'),(3573,3573,'2014-01-01','ET','2',1,NULL,'Vivian Tran','FI','065681006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:03:31',0,'2014-03-02 00:10:48'),(921,921,'2014-01-01','ET','2',1,NULL,'Sherokie Williams','FI','428692662','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:43',0,'2014-03-01 21:11:04'),(3162,3162,'2014-01-01','ET','2',1,NULL,'Daniel Tuel','FI','270525614','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:38:11',0,'2014-03-10 13:24:34'),(3202,3202,'2014-01-01','ET','2',1,NULL,'Christopher Alvarado','FI','457210858','Dental Care Plus, Inc.','FI','311185262','Gregory  Myers','94','9074445','348','2014-01-01','Sync Success',0,'2013-12-25 21:45:20',0,'2014-03-01 15:48:04'),(20696,21346,'0000-00-00','ET','2',2,1,'MARK ALLEN','FI','524531633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:10',0,'2014-03-02 07:17:36'),(23002,23652,'0000-00-00','ET','2',1,NULL,'SHYNIQUE WARREN','94','0000923383','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:52',0,'2014-03-10 21:17:52'),(5838,5838,'2014-01-01','ET','2',1,NULL,'terri williams','FI','300565128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:15:41',0,'2014-03-01 15:10:22'),(3704,3704,'2014-01-01','ET','2',2,1,'AMANDA DAUGHERTY','FI','437961470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:38',0,'2014-03-02 01:10:33'),(15536,15987,'0000-00-00','ET','2',3,2,'Sandra Kay Carpenter','FI','272769452','Summa Insurance Company, Inc.','FI','341809108','Sharon  Gibson','94','17076316','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:07',0,'2014-03-10 16:17:47'),(3411,3411,'2014-01-01','ET','2',3,2,'Blaze Wood','FI','291923244','HealthSpan','FI','311431434','Steven M  Schmitmeyer','94','2326455','348','2014-01-01','Sync Success',0,'2013-12-25 21:52:04',0,'2014-03-10 13:32:15'),(11903,11903,'2014-01-01','ET','2',1,NULL,'joan hauss','FI','291609961','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:08',0,'2014-03-01 16:30:17'),(17407,18057,'0000-00-00','ET','2',1,NULL,'DAISY S SHARKEY','FI','282526455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:46',0,'2014-03-01 17:20:55'),(19482,20132,'0000-00-00','ET','2',1,NULL,'Sylvia Martinez','FI','467232620','Starmount Life Insurance Company','FI','720977315','Kurt  Jarcik','94','4564074','348','2014-04-01','Sync Success',0,'2014-02-20 03:58:42',0,'2014-03-02 06:59:07'),(19501,20151,'0000-00-00','ET','2',2,1,'Celia Mahone','FI','278625417','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:04:17',0,'2014-03-10 16:38:05'),(22295,22945,'0000-00-00','ET','2',1,NULL,'Suzanne Harshman','FI','284505533','HealthSpan','FI','311431434','Patrick  Paule','94','1870642','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:49',0,'2014-03-10 14:50:59'),(22687,23337,'0000-00-00','ET','2',1,NULL,'Tonia Young','FI','436495336','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:48',0,'2014-03-08 22:26:18'),(11613,11613,'2014-01-01','ET','2',2,1,'Martha Irene Partin','FI','278543587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:08',0,'2014-03-10 16:03:49'),(1843,1843,'2014-01-01','ET','2',4,3,'Maureen Schriml','FI','270783054','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:21:04',0,'2014-03-10 13:20:27'),(16644,17294,'0000-00-00','ET','2',1,NULL,'Gaye carmen Ictech','FI','434578346','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:38',0,'2014-03-02 06:17:30'),(12153,12153,'2014-01-01','ET','2',1,NULL,'Richie Travis','FI','428338500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:35',0,'2014-03-02 05:03:29'),(2390,2390,'2014-01-01','ET','2',1,NULL,'Rosalina Alvarado','FI','460996260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:53',0,'2014-03-01 23:10:52'),(3379,3379,'2014-01-01','ET','2',1,NULL,'Martha Reveles Contreras','FI','568712486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:04',0,'2014-03-02 02:10:49'),(5061,5061,'2014-01-01','ET','2',2,1,'BRUCE TAKACH','FI','291567856','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:57',0,'2014-03-01 15:31:33'),(4185,4185,'2014-01-01','ET','2',1,NULL,'Cynthia Marie Carpenter','FI','289869101','Summa Insurance Company, Inc.','FI','341809108','Angela  Burlingame','94','8985993','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:47',0,'2014-03-10 15:59:47'),(5675,5675,'2014-01-01','ET','2',2,1,'Johnna Gustafson','FI','280808568','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:13',0,'2014-03-10 16:03:49'),(19853,20503,'0000-00-00','ET','2',1,NULL,'Donna Ancar','FI','434969792','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','357','2014-03-07','Sync Success',0,'2014-02-20 22:01:06',0,'2014-03-02 07:03:25'),(19927,20577,'0000-00-00','ET','2',3,2,'Bobbi Spofford','FI','369665885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-21 21:30:21',0,'2014-03-01 17:47:19'),(20149,20799,'0000-00-00','ET','2',1,NULL,'Julie Miller','FI','282789742','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:54',0,'2014-03-10 16:38:05'),(20977,21627,'0000-00-00','ET','2',1,NULL,'ibrahim habli','94','0000971518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:23',0,'2014-03-01 18:10:11'),(5640,5640,'2014-01-01','ET','2',1,NULL,'Joshua Vercher','FI','436697968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:00',0,'2014-03-02 04:45:37'),(17060,17710,'0000-00-00','ET','2',1,NULL,'Bonnie Munroe','FI','365568769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:35',0,'2014-03-02 06:24:38'),(1733,1733,'2014-01-01','ET','2',1,NULL,'Deborah Dockery','FI','271542016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:29',0,'2014-03-01 15:31:33'),(15197,15648,'0000-00-00','ET','2',2,1,'ROSIE JENKINS','FI','434250888','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:23',0,'2014-03-02 05:52:31'),(2777,2777,'2014-01-01','ET','2',1,NULL,'Julie Anna Ring','FI','578962139','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:33',0,'2014-03-01 16:05:34'),(2021,2021,'2014-01-01','ET','2',1,NULL,'KATHLEEN LEE','FI','435862961','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:32',0,'2014-03-01 23:10:52'),(12896,12896,'2014-01-01','ET','2',1,NULL,'Donna Adams','FI','192549485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:44',0,'2014-03-10 13:59:38'),(12607,12607,'2014-01-01','ET','2',1,NULL,'Damion Washington','94','0000329351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:01:21',0,'2014-03-02 05:10:52'),(21865,22515,'0000-00-00','ET','2',1,NULL,'April LeEllen Bernal','94','0000421530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:17',0,'2014-03-05 21:36:22'),(1679,1679,'2014-01-01','ET','2',1,NULL,'Mary Helen Serrano','FI','465986896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:48',0,'2014-03-02 00:10:48'),(17290,17940,'0000-00-00','ET','2',1,NULL,'hong do','FI','513844501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:49',0,'2014-03-02 06:24:38'),(4652,4652,'2014-01-01','ET','2',2,1,'DAVID SMART','FI','277589450','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:58',0,'2014-03-10 13:45:57'),(3733,3733,'2014-01-01','ET','2',1,NULL,'Janet Hunter','FI','363665480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:39',0,'2014-03-10 13:20:27'),(14034,14390,'2014-01-01','ET','2',1,NULL,'ZAMA HOWELL','FI','428352270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:55',0,'2014-03-02 05:31:31'),(12053,12053,'2014-01-01','ET','2',1,NULL,'DENISE NEWTON','FI','187462240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:07',0,'2014-03-02 04:59:36'),(20251,20901,'0000-00-00','ET','2',1,NULL,'Michael Krilivsky','FI','047769103','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:10',0,'2014-03-10 14:37:47'),(21497,22147,'0000-00-00','ET','2',1,NULL,'Marcia Crolley','FI','279503887','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:53',0,'2014-03-03 21:36:16'),(22092,22742,'0000-00-00','ET','2',1,NULL,'Terece Mugno','FI','455151426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:24',0,'2014-03-06 21:27:26'),(682,682,'2014-01-01','ET','2',1,NULL,'Zachary Lawrence','FI','603103858','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:06:10',0,'2014-03-10 15:52:36'),(11245,11245,'2014-01-01','ET','2',1,NULL,'elizabeth stauter','FI','302886617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:49',0,'2014-03-01 16:23:43'),(3316,3316,'2014-01-01','ET','2',1,NULL,'Jason Burkhart','FI','286765040','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:03',0,'2014-03-01 15:52:44'),(4330,4330,'2014-01-01','ET','2',1,NULL,'James Martin','FI','289889108','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:09',0,'2014-03-10 13:32:15'),(14308,14759,'2014-01-01','ET','2',1,NULL,'Amanda Devlin','FI','585790536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:28',0,'2014-03-02 05:38:34'),(13943,14299,'2014-01-01','ET','2',3,2,'Joseph Pitz','FI','277740839','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:28',0,'2014-03-10 16:10:34'),(13016,13016,'2014-01-01','ET','2',1,NULL,'shuan davis','FI','425235599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:48',0,'2014-03-02 05:17:40'),(5498,5498,'2014-01-01','ET','2',1,NULL,'LEE BAUMES','FI','298761343','Dental Care Plus, Inc.','FI','311185262','CHRISTOPHER  RUHM','94','3772700','348','2014-01-01','Sync Success',0,'2013-12-26 01:46:21',0,'2014-03-01 16:23:43'),(12661,12661,'2014-01-01','ET','2',1,NULL,'MARTHA  BIRT','FI','281483813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:22',0,'2014-03-01 16:35:14'),(18040,18690,'0000-00-00','ET','2',1,NULL,'Ariel Diamond','FI','344729683','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-25','Sync Success',0,'2014-02-10 21:32:07',0,'2014-03-10 14:24:38'),(18509,19159,'0000-00-00','ET','2',1,NULL,'Linda Cooper','FI','587116539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:17',0,'2014-03-02 06:45:14'),(19673,20323,'0000-00-00','ET','2',1,NULL,'DONALD RIBY WILLIAMS','FI','529211138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:48:49',0,'2014-03-01 17:47:19'),(20581,21231,'0000-00-00','ET','2',1,NULL,'Teresa Tope','FI','292764020','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:36',0,'2014-03-01 18:08:07'),(20781,21431,'0000-00-00','ET','2',1,NULL,'john fogler','FI','298540027','Summa Insurance Company, Inc.','FI','341809108','Deborah  Grazey','94','2341750','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:49',0,'2014-03-10 16:38:05'),(22085,22735,'0000-00-00','ET','2',4,3,'JESUS ALVARADO','FI','593709947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:18',0,'2014-03-06 21:27:26'),(22340,22990,'0000-00-00','ET','2',1,NULL,'Gillian Rose Stupar','FI','295767460','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:25',0,'2014-03-06 21:36:23'),(22614,23264,'0000-00-00','ET','2',1,NULL,'Stacey Hoshimiya','FI','615079691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:04',0,'2014-03-08 21:25:11'),(194,194,'2014-01-01','ET','2',1,NULL,'John Kachuba','FI','046441065','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:01',0,'2014-03-10 13:10:24'),(2727,2727,'2014-01-01','ET','2',1,NULL,'William Levy','FI','222423549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:18:02',0,'2014-03-02 04:15:49'),(14284,14735,'2014-01-01','ET','2',1,NULL,'Matthew Moran','FI','268844447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:17',0,'2014-03-01 16:46:19'),(17784,18434,'0000-00-00','ET','2',1,NULL,'rosaura m castro','FI','731124861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:20',0,'2014-03-02 05:59:43'),(20761,21411,'0000-00-00','ET','2',1,NULL,'Keishla Velez','FI','599268714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:40',0,'2014-03-01 18:08:07'),(21249,21899,'0000-00-00','ET','2',1,NULL,'THOMAS POLING','FI','288541626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:30',0,'2014-03-01 21:35:40'),(21920,22570,'0000-00-00','ET','2',1,NULL,'Laura Cohen','FI','453216156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:56',0,'2014-03-05 22:27:33'),(2911,2911,'2014-01-01','ET','2',2,1,'MAXINE TAYLOR','FI','427049362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:17',0,'2014-03-02 01:10:33'),(14385,14836,'2014-01-01','ET','2',1,NULL,'Sara Tackett','FI','294906706','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:00',0,'2014-03-01 16:46:19'),(3043,3043,'2014-01-01','ET','2',1,NULL,'John Mark Milano','FI','293769242','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:24',0,'2014-03-01 15:37:30'),(11321,11321,'2014-01-01','ET','2',1,NULL,'Yesenia Perez','FI','622461871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:07',0,'2014-03-02 04:52:44'),(19002,19652,'0000-00-00','ET','2',2,1,'Edward Jackson','FI','277582449','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:16',0,'2014-03-10 14:31:05'),(19809,20459,'0000-00-00','ET','2',1,NULL,'Bridgette Williams','FI','645074449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:30',0,'2014-03-02 07:03:25'),(22316,22966,'0000-00-00','ET','2',1,NULL,'LETICIA C BALINO','FI','457414410','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:08',0,'2014-03-06 22:25:29'),(12873,12873,'2014-01-01','ET','2',2,1,'Randy D Bender','FI','400881208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:53',0,'2014-03-01 16:35:14'),(12752,12752,'2014-01-01','ET','2',2,1,'Jimmy Temple','FI','426153161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:45',0,'2014-03-02 05:10:52'),(1686,1686,'2014-01-01','ET','2',2,1,'MARYANN SENDER','FI','286546782','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:03',0,'2014-03-01 15:31:33'),(4821,4821,'2014-01-01','ET','2',1,NULL,'Patti Mielziner','FI','283624933','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:31',0,'2014-03-10 13:10:24'),(11839,11839,'2014-01-01','ET','2',1,NULL,'Jason Christopher Halcrow','FI','202663116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:22',0,'2014-03-02 04:31:46'),(3159,3159,'2014-01-01','ET','2',2,1,'GREGORY JOSEPH GOODMAN','FI','279680232','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:04',0,'2014-03-10 13:24:34'),(17959,18609,'0000-00-00','ET','2',1,NULL,'RENEE K ALLEN','FI','288624145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:10',0,'2014-03-01 17:20:55'),(19090,19740,'0000-00-00','ET','2',1,NULL,'Hannah Reinhart','FI','220254888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:36',0,'2014-03-01 17:34:07'),(20374,21024,'0000-00-00','ET','2',1,NULL,'Mary Arthur','FI','290487266','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:03',0,'2014-03-10 14:37:47'),(21071,21721,'0000-00-00','ET','2',1,NULL,'IDDRISU SEIDU','FI','287081744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:28',0,'2014-03-01 18:10:11'),(23105,23755,'0000-00-00','ET','2',1,NULL,'PAULA KNAPP','FI','399524684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:07',0,'2014-03-10 22:25:11'),(7281,7281,'2014-01-01','ET','2',1,NULL,'JUDITH LUNSFORD','FI','293469940','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:09',0,'2014-03-10 13:32:15'),(14673,15124,'2014-01-01','ET','2',1,NULL,'SHANE WIGGINS','FI','400419929','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:36',0,'2014-03-01 16:46:19'),(12322,12322,'2014-01-01','ET','2',1,NULL,'Manuel Edward Jenkins','FI','567761352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:54',0,'2014-03-02 05:03:29'),(3647,3647,'2014-01-01','ET','2',1,NULL,'Patricia Wagner','FI','284527087','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:49',0,'2014-03-10 15:52:36'),(2906,2906,'2014-01-01','ET','2',1,NULL,'Evelyn Thompson','FI','300503614','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:09',0,'2014-03-10 13:24:34'),(1675,1675,'2014-01-01','ET','2',1,NULL,'Gayle Wooldridge','FI','630324893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:41',0,'2014-03-02 00:10:48'),(17951,18601,'0000-00-00','ET','2',2,1,'Timothy Headrick','FI','302549126','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:04',0,'2014-03-01 17:20:55'),(18109,18759,'0000-00-00','ET','2',1,NULL,'Kimberly  Richter','FI','466067178','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:45',0,'2014-03-02 06:38:05'),(19537,20187,'0000-00-00','ET','2',1,NULL,'WALTER BROWN','FI','587562965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:14:45',0,'2014-03-02 06:59:07'),(1872,1872,'2014-01-01','ET','2',1,NULL,'Angelica Maghiar','FI','272822331','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:56',0,'2014-03-01 15:31:33'),(17132,17782,'0000-00-00','ET','2',1,NULL,'Timothy Broadhead','FI','425043983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:20',0,'2014-03-02 06:24:38'),(14296,14747,'2014-01-01','ET','2',1,NULL,'Pamela  Cook','FI','298625657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:22',0,'2014-03-01 16:46:19'),(2205,2205,'2014-01-01','ET','2',1,NULL,'THERESA  FOWLER BATEMAN','FI','436112430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:21',0,'2014-03-01 21:11:04'),(12764,12764,'2014-01-01','ET','2',1,NULL,'DEBRA THARP','FI','305625983','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:15',0,'2014-03-10 13:59:38'),(2944,2944,'2014-01-01','ET','2',1,NULL,'GEORGE RICHARD KIRK','FI','285484735','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:24',0,'2014-03-01 15:37:30'),(11852,11852,'2014-01-01','ET','2',1,NULL,'Stephen Adams','FI','301861825','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:53',0,'2014-03-10 13:45:57'),(11637,11637,'2014-01-01','ET','2',1,NULL,'Jonathan Froeba','FI','433254252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:52',0,'2014-03-02 04:59:36'),(18451,19101,'0000-00-00','ET','2',1,NULL,'Vicki Himmelright','FI','298541998','Summa Insurance Company, Inc.','FI','341809108','Thomas  Rice','94','8267754','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:38',0,'2014-03-10 16:31:33'),(18538,19188,'0000-00-00','ET','2',1,NULL,'Timothy Jordan','FI','275808524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:06',0,'2014-03-01 17:26:36'),(22683,23333,'0000-00-00','ET','2',1,NULL,'Lisa Rogers','FI','434655080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:45',0,'2014-03-08 22:26:18'),(10815,10815,'2014-01-01','ET','2',2,1,'Nabil Qasem','FI','455552794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:22',0,'2014-03-02 04:31:46'),(17083,17733,'0000-00-00','ET','2',2,1,'Cindy McCarthy','FI','288584787','Dental Care Plus, Inc.','FI','311185262','Julie  Fortin','94','16508703','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:50',0,'2014-03-01 17:00:58'),(17037,17687,'0000-00-00','ET','2',1,NULL,'darlene johnson','FI','433042831','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:22',0,'2014-03-02 06:24:38'),(16063,16712,'0000-00-00','ET','2',1,NULL,'Carla  Williams','FI','079624523','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:51',0,'2014-03-01 16:56:22'),(16033,16682,'0000-00-00','ET','2',1,NULL,'Kaidismaris Newton','FI','662033551','Starmount Life Insurance Company','FI','720977315','Mary  McManus','94','9434688','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:32',0,'2014-03-02 06:03:21'),(15223,15674,'0000-00-00','ET','2',1,NULL,'Thomas Siebold','FI','389481757','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:42',0,'2014-03-10 14:10:12'),(381,381,'2014-01-01','ET','2',3,2,'Amanda Riggs','FI','299780915','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:46',0,'2014-03-10 15:45:56'),(988,988,'2014-01-01','ET','2',1,NULL,'Amanda Bodi','FI','300906228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:50',0,'2014-03-01 15:21:15'),(2025,2025,'2014-01-01','ET','2',1,NULL,'TINA MERRITT','FI','437156979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:39',0,'2014-03-01 23:10:52'),(13042,13398,'2014-01-01','ET','2',1,NULL,'Ann Brugger','FI','290683368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:50',0,'2014-03-01 16:35:14'),(12683,12683,'2014-01-01','ET','2',1,NULL,'SANDRA STOESSNER','FI','289509038','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:06',0,'2014-03-01 16:35:14'),(4373,4373,'2014-01-01','ET','2',5,4,'John Wayne Stamp','FI','284708782','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:06',0,'2014-03-01 15:16:37'),(4797,4797,'2014-01-01','ET','2',1,NULL,'WM Thomas Saygrover','FI','270460084','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:47',0,'2014-03-01 15:16:37'),(1326,1326,'2014-01-01','ET','2',1,NULL,'SUSAN MYATT','FI','461084862','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:38',0,'2014-03-02 04:38:08'),(17476,18126,'0000-00-00','ET','2',1,NULL,'Zachary Cramer','FI','302885815','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:35',0,'2014-03-10 14:24:38'),(14523,14974,'2014-01-01','ET','2',2,1,'Anthony Philip Alicea','FI','277884871','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:04',0,'2014-03-10 16:17:47'),(14358,14809,'2014-01-01','ET','2',2,1,'george hasrouni','FI','296668306','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:48',0,'2014-03-10 16:17:47'),(3491,3491,'2014-01-01','ET','2',2,1,'Dave Fontana','FI','272664247','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:53',0,'2014-03-01 15:37:30'),(17848,18498,'0000-00-00','ET','2',1,NULL,'eduardo venegas','FI','631485190','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:13',0,'2014-03-10 14:10:12'),(18765,19415,'0000-00-00','ET','2',1,NULL,'Elizabeth Gilene','FI','291701399','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:40',0,'2014-03-10 14:31:05'),(19772,20422,'0000-00-00','ET','2',1,NULL,'Linda Estes','FI','338461157','Starmount Life Insurance Company','FI','720977315','James  Eulo','94','15984578','348','2014-04-01','Sync Success',0,'2014-02-20 21:30:21',0,'2014-03-02 07:03:25'),(20312,20962,'0000-00-00','ET','2',1,NULL,'Kema Taylor','FI','434752610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 08:00:51',0,'2014-03-02 07:03:25'),(21605,22255,'0000-00-00','ET','2',1,NULL,'Maryleen Lisset Torres','FI','645167398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:24',0,'2014-03-04 21:27:16'),(11539,11539,'2014-01-01','ET','2',1,NULL,'BARBARA EAKIN','FI','292527843','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:49',0,'2014-03-10 16:03:49'),(1485,1485,'2014-01-01','ET','2',1,NULL,'George Hillery','FI','384709925','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:56',0,'2014-03-10 16:03:49'),(16338,16988,'0000-00-00','ET','2',1,NULL,'anthony waugh','FI','280523953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:47',0,'2014-03-01 16:56:22'),(15279,15730,'0000-00-00','ET','2',1,NULL,'Joe Carter','FI','451066094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:06',0,'2014-03-02 05:52:31'),(14869,15320,'2014-01-01','ET','2',1,NULL,'Kimberly May','FI','462718559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:10',0,'2014-03-02 05:52:31'),(14601,15052,'2014-01-01','ET','2',1,NULL,'SANAR AMIN','FI','272158055','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:51',0,'2014-03-01 16:46:19'),(2603,2603,'2014-01-01','ET','2',1,0,'kathy steffen','FI','122522385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:05',0,'2014-03-01 15:05:09'),(12834,12834,'2014-01-01','ET','2',1,NULL,'Gail Picou','FI','436965552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:30',0,'2014-03-02 05:10:52'),(18622,19272,'0000-00-00','ET','2',1,NULL,'Angela Hulett','FI','085723630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:52',0,'2014-03-01 17:26:36'),(18823,19473,'0000-00-00','ET','2',1,NULL,'Veronica Moreno','FI','629367764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:07',0,'2014-03-02 06:52:12'),(18960,19610,'0000-00-00','ET','2',1,NULL,'Dania Pearson','FI','587697429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:44',0,'2014-03-02 06:52:12'),(21880,22530,'0000-00-00','ET','2',1,NULL,'Pamela Spilker','FI','272460125','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:28',0,'2014-03-05 21:36:22'),(22176,22826,'0000-00-00','ET','2',1,NULL,'AMY WINANS','FI','298869042','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:01:22',0,'2014-03-06 21:36:23'),(42,42,'2014-01-01','ET','2',1,NULL,'Linda Gail McDowell','FI','426112969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:15',0,'2014-03-01 22:10:55'),(15326,15777,'0000-00-00','ET','2',1,NULL,'Kathryn Pittman','FI','273542139','Dental Care Plus, Inc.','FI','311185262','DEANNA MARIE WELLS','94','7827930','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:34',0,'2014-03-01 16:50:53'),(13669,14025,'2014-01-01','ET','2',1,NULL,'BILLIE  RAYE  EDWARDS','FI','430292305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:22',0,'2014-03-02 05:24:45'),(13554,13910,'2014-01-01','ET','2',1,NULL,'Meshonda Hurst','FI','437712956','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-02-01','Sync Success',0,'2014-01-13 02:19:51',0,'2014-03-02 05:24:45'),(12637,12637,'2014-01-01','ET','2',1,NULL,'Lillian Foley','FI','437313747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:24',0,'2014-03-02 05:10:52'),(963,963,'2014-01-01','ET','2',2,1,'Rachel  Elaine  Taylor','FI','437134619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:04',0,'2014-03-01 22:10:55'),(6454,6454,'2014-01-01','ET','2',1,NULL,'LINDA JANSON','FI','276448198','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:15',0,'2014-03-10 13:03:33'),(1136,1136,'2014-01-01','ET','2',1,NULL,'Alice Mark','FI','112724642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:46',0,'2014-03-02 04:45:37'),(1143,1143,'2014-01-01','ET','2',1,NULL,'Tiffany Banks','FI','434219082','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:01',0,'2014-03-02 04:38:08'),(1612,1612,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:31',0,'2014-03-01 20:10:57'),(18822,19472,'0000-00-00','ET','2',1,NULL,'jose rangel','FI','456873819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:07',0,'2014-03-02 06:52:12'),(19527,20177,'0000-00-00','ET','2',5,4,'Ryan Sexton','FI','286809279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:11:59',0,'2014-03-01 17:47:19'),(21324,21974,'0000-00-00','ET','2',2,1,'shadi kawafeha','FI','580355534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:09',0,'2014-03-03 01:07:25'),(4180,4180,'2014-01-01','ET','2',1,NULL,'LUCIOUS JOHNSON','FI','252041455','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:35',0,'2014-03-10 15:59:47'),(17409,18059,'0000-00-00','ET','2',3,2,'Mark Smith','FI','270721592','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:48',0,'2014-03-10 14:24:38'),(16156,16805,'0000-00-00','ET','2',1,NULL,'Patricia Arellano','FI','466988770','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:11',0,'2014-03-02 06:10:30'),(13947,14303,'2014-01-01','ET','2',2,1,'Jihad Niser','FI','275607589','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:31',0,'2014-03-10 14:03:26'),(15715,16364,'0000-00-00','ET','2',1,NULL,'AMANDA EHRHARDT','FI','284920559','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:58',0,'2014-03-10 14:10:12'),(15316,15767,'0000-00-00','ET','2',1,NULL,'LELIA MORTON','FI','418724922','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:27',0,'2014-03-01 16:50:53'),(11762,11762,'2014-01-01','ET','2',4,3,'Michael Jundi','FI','269783226','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:47',0,'2014-03-10 16:10:34'),(180,180,'2014-01-01','ET','2',1,NULL,'Sarah Hanson','FI','434617857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:35',0,'2014-03-01 22:10:55'),(363,363,'2014-01-01','ET','2',1,NULL,'Drena Kozlowski','FI','269549502','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:10',0,'2014-03-01 15:21:15'),(6996,6996,'2014-01-01','ET','2',1,NULL,'Veronica Nunez','FI','318661712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:21',0,'2014-03-02 02:10:49'),(959,959,'2014-01-01','ET','2',1,NULL,'KATHERINE ROSE ALBERT','FI','433710028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:55',0,'2014-03-01 22:10:55'),(14252,14703,'2014-01-01','ET','2',2,1,'Sherry Gassaway','FI','308800506','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:03',0,'2014-03-01 16:46:19'),(14723,15174,'2014-01-01','ET','2',1,NULL,'Valerie Jones','FI','426964947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:10',0,'2014-03-02 05:45:37'),(14452,14903,'2014-01-01','ET','2',1,NULL,'Ashley Jeanfreau','FI','435838339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:31',0,'2014-03-02 05:38:34'),(19190,19840,'0000-00-00','ET','2',1,NULL,'Darlene Houston','FI','413982793','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:57',0,'2014-03-10 14:31:05'),(21417,22067,'0000-00-00','ET','2',1,NULL,'James Murphy','FI','276769361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:22',0,'2014-03-03 21:25:18'),(568,568,'2014-01-01','ET','2',1,NULL,'AMANDA BARCUS','FI','287847153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:36',0,'2014-03-01 15:48:04'),(17141,17791,'0000-00-00','ET','2',1,NULL,'Crystal Ford','FI','294561447','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:26',0,'2014-03-10 16:24:30'),(15524,15975,'0000-00-00','ET','2',1,NULL,'Suong Nguyen','FI','638023100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:01',0,'2014-03-02 05:59:43'),(14287,14738,'2014-01-01','ET','2',1,NULL,'Candace Moxley','FI','297545870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:18',0,'2014-03-01 16:46:19'),(749,749,'2014-01-01','ET','2',1,NULL,'Javall Bridges','FI','426671464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:19',0,'2014-03-02 02:10:49'),(4076,4076,'2014-01-01','ET','2',1,NULL,'Cena Glass','FI','437171166','Dental Care Plus, Inc.','FI','311185262','Michael Joseph Fitzpatrick','94','16875889','348','2014-01-01','Sync Success',0,'2013-12-25 23:02:34',0,'2014-03-01 15:52:44'),(3827,3827,'2014-01-01','ET','2',3,2,'james richard henry','FI','281841680','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:20',0,'2014-03-10 13:20:27'),(3735,3735,'2014-01-01','ET','2',1,NULL,'ELAINE DAWN BARNT','FI','282601053','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:43',0,'2014-03-10 13:20:27'),(7053,7053,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:07',0,'2014-03-02 03:09:49'),(1973,1973,'2014-01-01','ET','2',1,NULL,'James  Walter  Slouffman','FI','290440485','Dental Care Plus, Inc.','FI','311185262','Darwin   Carmichael','94','130095','348','2014-01-01','Sync Success',0,'2013-12-25 19:33:53',0,'2014-03-01 15:26:40'),(7365,7365,'2014-01-01','ET','2',2,1,'shirley kleinschmidt','FI','553475057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:01',0,'2014-03-01 15:16:37'),(11497,11497,'2014-01-01','ET','2',1,NULL,'Noemi Aguirre','FI','459822553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:33',0,'2014-03-02 04:52:44'),(18564,19214,'0000-00-00','ET','2',1,NULL,'SONA NIXON','FI','203633320','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:03',0,'2014-03-01 17:26:36'),(21606,22256,'0000-00-00','ET','2',1,NULL,'Blake Harris','FI','450758584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:25',0,'2014-03-04 21:27:16'),(818,818,'2014-01-01','ET','2',1,NULL,'Meagan Adair','FI','627209823','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:50',0,'2014-03-01 19:11:03'),(17686,18336,'0000-00-00','ET','2',1,NULL,'Donald Schroeder','FI','280525773','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:57',0,'2014-03-10 14:24:38'),(1962,1962,'2014-01-01','ET','2',2,1,'Ronald Eugene Price','FI','273580077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:34',0,'2014-03-01 15:26:40'),(16682,17332,'0000-00-00','ET','2',1,NULL,'TONY  D GILBERT','FI','433255680','Starmount Life Insurance Company','FI','720977315','MICHAEL  DAUGHERTY','94','1131360','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:03',0,'2014-03-02 06:17:30'),(11063,11063,'2014-01-01','ET','2',1,NULL,'Paul Irving Averill','FI','287482662','Summa Insurance Company, Inc.','FI','341809108','Ronald  Hyre','94','16686883','348','2014-01-01','Sync Success',0,'2013-12-26 13:12:55',0,'2014-03-10 16:03:49'),(7025,7025,'2014-01-01','ET','2',1,NULL,'CARLA JACKSON','FI','466571032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:16',0,'2014-03-02 03:09:49'),(15379,15830,'0000-00-00','ET','2',1,NULL,'kylie rafidi','FI','438475460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:56',0,'2014-03-02 05:59:43'),(17479,18129,'0000-00-00','ET','2',1,NULL,'Kimberly Miller','FI','427516506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:37',0,'2014-03-02 06:31:45'),(17668,18318,'0000-00-00','ET','2',1,NULL,'Ann Gilmore','FI','285847186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:46',0,'2014-03-01 17:20:55'),(18195,18845,'0000-00-00','ET','2',2,1,'STEPHEN  A SELF','FI','293486538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:48',0,'2014-03-01 17:26:36'),(19240,19890,'0000-00-00','ET','2',1,NULL,'Minet Williamson','FI','272760371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:32',0,'2014-03-01 17:34:07'),(19552,20202,'0000-00-00','ET','2',1,NULL,'DONNA WALKER','FI','435256618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:18:47',0,'2014-03-02 06:59:07'),(20827,21477,'0000-00-00','ET','2',1,NULL,'Maria Ronquillo','FI','585192786','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:11',0,'2014-03-02 07:17:36'),(22133,22783,'0000-00-00','ET','2',1,NULL,'NORMA YAMILETH MARTINEZ','FI','435817231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:53',0,'2014-03-06 21:27:26'),(290,290,'2014-01-01','ET','2',1,NULL,'theresa sayre','FI','299581211','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:20',0,'2014-03-10 15:39:19'),(4270,4270,'2014-01-01','ET','2',1,NULL,'Jane Frierson','FI','433867629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:25',0,'2014-03-02 03:09:49'),(11677,11677,'2014-01-01','ET','2',1,NULL,'Sharon Davis','FI','272529424','HealthSpan','FI','311431434','Timothy P Self','94','16166554','348','2014-02-01','Sync Success',0,'2013-12-28 03:37:10',0,'2014-03-10 13:52:32'),(11411,11411,'2014-01-01','ET','2',1,NULL,'REBECCA SCHAFFER','FI','291508975','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:55',0,'2014-03-10 13:52:32'),(11309,11309,'2014-01-01','ET','2',1,NULL,'JACQULEINE FRY','FI','269928710','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:47',0,'2014-03-02 04:45:37'),(5769,5769,'2014-01-01','ET','2',1,NULL,'Richard Hallett','FI','496521137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:31',0,'2014-03-02 01:10:33'),(6334,6334,'2014-01-01','ET','2',1,NULL,'Carolina Garza','FI','459898805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:26',0,'2014-03-02 04:10:25'),(10462,10462,'2014-01-01','ET','2',1,NULL,'DONNA JEAN  NARTKER','FI','274520884','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:40',0,'2014-03-01 16:10:36'),(7103,7103,'2014-01-01','ET','2',1,NULL,'Todd Chaney','FI','297509416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:41',0,'2014-03-01 15:52:44'),(16865,17515,'0000-00-00','ET','2',1,NULL,'James Davis','FI','437572488','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:05',0,'2014-03-02 06:17:30'),(16947,17597,'0000-00-00','ET','2',1,NULL,'KATHERINE J LEWIS','FI','436118046','Starmount Life Insurance Company','FI','720977315','PAMELA  PRICE','94','4697079','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:57',0,'2014-03-02 06:17:30'),(17460,18110,'0000-00-00','ET','2',1,NULL,'Jesse Ogden','FI','373060591','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:23',0,'2014-03-02 06:31:45'),(20272,20922,'0000-00-00','ET','2',1,NULL,'RONETTA JONES','FI','437614055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:18',0,'2014-03-02 07:03:25'),(22007,22657,'0000-00-00','ET','2',1,NULL,'Joseph Anthony Lopez','FI','273988438','Dental Care Plus, Inc.','FI','311185262','Ronald  Martin','94','2432668','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:58',0,'2014-03-05 21:36:22'),(22819,23469,'0000-00-00','ET','2',1,NULL,'RENA WILLIAMS','FI','425351554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:08',0,'2014-03-09 21:26:00'),(868,868,'2014-01-01','ET','2',2,1,'Enrique Lopez','FI','303587240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:15',0,'2014-03-01 22:10:55'),(1214,1214,'2014-01-01','ET','2',1,NULL,'Tammy Meyer','FI','267453674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:13',0,'2014-03-01 16:15:39'),(14766,15217,'2014-01-01','ET','2',1,NULL,'Daniel Demond Sterling','FI','636091374','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:36',0,'2014-03-02 05:45:37'),(1614,1614,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:34',0,'2014-03-01 20:10:57'),(1758,1758,'2014-01-01','ET','2',1,NULL,'Greta Barnes','FI','428310209','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:13',0,'2014-03-02 00:10:48'),(13150,13506,'2014-01-01','ET','2',1,NULL,'VIRGINIA SMITH','FI','295524643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:55',0,'2014-03-10 16:10:34'),(2003,2003,'2014-01-01','ET','2',1,NULL,'Travis Jones','FI','439061923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:58',0,'2014-03-01 23:10:52'),(2281,2281,'2014-01-01','ET','2',1,NULL,'Adam Schneider','FI','302902360','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:32',0,'2014-03-01 15:10:22'),(5264,5264,'2014-01-01','ET','2',1,NULL,'Tana Samuels','FI','282868151','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:09',0,'2014-03-01 15:10:22'),(12026,12026,'2014-01-01','ET','2',2,1,'JOSE A MARTINEZ','FI','439311306','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:04',0,'2014-03-02 04:59:36'),(11987,11987,'2014-01-01','ET','2',1,NULL,'kathy ransom','FI','494622386','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:37',0,'2014-03-02 05:03:29'),(11962,11962,'2014-01-01','ET','2',2,1,'CYNTHIA YOUNG','FI','463136014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:38',0,'2014-03-02 04:59:36'),(11744,11744,'2014-01-01','ET','2',1,NULL,'Donald kenneth Coakley','FI','290865975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:16',0,'2014-03-01 16:30:17'),(7665,7665,'2014-01-01','ET','2',1,NULL,'Linda Stout','FI','295528686','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:20',0,'2014-03-10 13:39:10'),(7620,7620,'2014-01-01','ET','2',1,NULL,'Daniel Smith','FI','290424170','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:55',0,'2014-03-10 13:39:10'),(7234,7234,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:42',0,'2014-03-01 15:52:44'),(6230,6230,'2014-01-01','ET','2',1,NULL,'Emily Knueven','FI','275900777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:05:16',0,'2014-03-01 16:00:27'),(15149,15600,'0000-00-00','ET','2',1,NULL,'EARNESTINE TATUM','FI','434199396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:26',0,'2014-03-02 05:52:31'),(15758,16407,'0000-00-00','ET','2',1,NULL,'TENA DEVEREUX','FI','414940712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:27',0,'2014-03-02 05:59:43'),(16059,16708,'0000-00-00','ET','2',1,NULL,'Emily Runions','FI','299887600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:49',0,'2014-03-01 16:56:22'),(16222,16871,'0000-00-00','ET','2',1,NULL,'Celia R Espinosa','FI','378602114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:54',0,'2014-03-02 06:10:30'),(16261,16910,'0000-00-00','ET','2',1,NULL,'Rodney Pasker','FI','299588336','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:19',0,'2014-03-10 14:20:26'),(16466,17116,'0000-00-00','ET','2',1,NULL,'allan lantz','FI','269964380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:16',0,'2014-03-01 17:00:58'),(17466,18116,'0000-00-00','ET','2',1,NULL,'Jared David','FI','436477613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:28',0,'2014-03-02 06:31:45'),(17770,18420,'0000-00-00','ET','2',1,NULL,'Trevon Fields','FI','466690150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:09',0,'2014-03-02 05:59:43'),(19939,20589,'0000-00-00','ET','2',1,NULL,'JAIME ORTIZ','FI','606141185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:07',0,'2014-03-02 07:03:25'),(21112,21762,'0000-00-00','ET','2',1,NULL,'Alice Sparks','FI','461922207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:55',0,'2014-03-02 07:23:39'),(21847,22497,'0000-00-00','ET','2',1,NULL,'JESSICA PIPKINS','FI','438757239','Starmount Life Insurance Company','FI','720977315','abram  freeman','94','1219092','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:04',0,'2014-03-05 22:27:33'),(22592,23242,'0000-00-00','ET','2',2,1,'Annette Bragg','94','0001014439','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:17',0,'2014-03-10 16:44:18'),(22732,23382,'0000-00-00','ET','2',1,NULL,'Pari Hooven','FI','300605152','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:22',0,'2014-03-10 14:50:59'),(22764,23414,'0000-00-00','ET','2',1,NULL,'SUSIE LARA','FI','463023727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-09 21:00:22',0,'2014-03-09 21:26:00'),(1586,1586,'2014-01-01','ET','2',1,NULL,'ROBERT ALLEN LAWRENCE','FI','278600900','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:49',0,'2014-03-01 15:10:22'),(10567,10567,'2014-01-01','ET','2',1,NULL,'LISA HICKS','FI','456478377','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:06',0,'2014-03-02 04:24:47'),(12500,12500,'2014-01-01','ET','2',1,NULL,'john siebold','FI','463987985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:21',0,'2014-03-02 05:03:29'),(14279,14730,'2014-01-01','ET','2',6,5,'Daniel Vollmer','FI','286744952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:15',0,'2014-03-01 16:46:19'),(13311,13667,'2014-01-01','ET','2',1,NULL,'Erika Vosburg','FI','276706091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:16',0,'2014-03-01 16:40:16'),(16587,17237,'0000-00-00','ET','2',2,1,'LINDA SIMONS','FI','271529431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:35',0,'2014-03-10 14:20:26'),(17259,17909,'0000-00-00','ET','2',1,NULL,'Jose Jimenez','FI','452904114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:35',0,'2014-03-02 06:24:38'),(17660,18310,'0000-00-00','ET','2',1,NULL,'KELSEY M TAYLOR','FI','290923741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:42',0,'2014-03-01 17:20:55'),(22934,23584,'0000-00-00','ET','2',1,NULL,'Johnny Smatana','FI','595461432','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:06',0,'2014-03-10 21:07:22'),(431,431,'2014-01-01','ET','2',1,NULL,'JOHN E HUMES','FI','370603090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:24',0,'2014-03-01 22:10:55'),(693,693,'2014-01-01','ET','2',1,NULL,'Angelica Pozo','FI','103464017','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:06:32',0,'2014-03-10 13:24:34'),(14450,14901,'2014-01-01','ET','2',1,NULL,'misty blanson','FI','436758906','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:30',0,'2014-03-02 05:38:34'),(914,914,'2014-01-01','ET','2',1,NULL,'Sherry Kearns','FI','284622738','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:29',0,'2014-03-01 15:21:15'),(1514,1514,'2014-01-01','ET','2',1,NULL,'Pamala Parker','FI','288508867','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:50',0,'2014-03-10 16:03:49'),(14232,14683,'2014-01-01','ET','2',1,NULL,'derida mccarty','FI','425083292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:54',0,'2014-03-02 05:38:34'),(5141,5141,'2014-01-01','ET','2',1,NULL,'Larry Ringler','FI','272502735','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:33',0,'2014-03-10 15:45:56'),(4926,4926,'2014-01-01','ET','2',1,0,'YOLANDA TAYLOR','FI','262218904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:00',0,'2014-03-01 19:11:03'),(10418,10418,'2014-01-01','ET','2',1,NULL,'Yinitrus Wynn','FI','287525997','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:16',0,'2014-03-01 16:10:36'),(4912,4912,'2014-01-01','ET','2',1,0,'Julie Goodhew','FI','276745674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:30:34',0,'2014-03-01 15:05:09'),(15264,15715,'0000-00-00','ET','2',1,NULL,'Sara Greathouse','FI','380883544','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:40',0,'2014-03-01 16:50:53'),(16335,16985,'0000-00-00','ET','2',1,NULL,'JAMES KIRSCH','FI','277744184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:45',0,'2014-03-01 16:56:22'),(20433,21083,'0000-00-00','ET','2',1,NULL,'DAWN CHAFFIN','FI','287625089','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:51',0,'2014-03-10 16:38:05'),(21444,22094,'0000-00-00','ET','2',1,NULL,'JoAnn Moody','FI','291503304','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:14',0,'2014-03-10 16:44:18'),(22526,23176,'0000-00-00','ET','2',1,NULL,'Alana Reams','FI','298903997','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:29',0,'2014-03-07 21:36:32'),(22594,23244,'0000-00-00','ET','2',1,NULL,'CANDICE BRAXTON','FI','268925480','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:19',0,'2014-03-10 14:50:59'),(22981,23631,'0000-00-00','ET','2',1,NULL,'DENITA JACKSON','FI','286808135','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:37',0,'2014-03-10 21:36:25'),(4250,4250,'2014-01-01','ET','2',2,1,'LARRY ALSTROM','FI','290467020','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:48',0,'2014-03-10 15:59:47'),(10950,10950,'2014-01-01','ET','2',1,NULL,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:14',0,'2014-03-10 16:03:49'),(2656,2656,'2014-01-01','ET','2',1,NULL,'Beverly Worley','94','0000279546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:37',0,'2014-03-01 16:05:34'),(13723,14079,'2014-01-01','ET','2',2,1,'JEAN  JANVIER','FI','592217308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:57',0,'2014-03-02 05:24:45'),(2366,2366,'2014-01-01','ET','2',1,NULL,'Richard Stacy','FI','301489114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:13',0,'2014-03-01 15:26:40'),(12088,12088,'2014-01-01','ET','2',1,NULL,'CATHY PIDDUBETSKYY','FI','273745421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:20',0,'2014-03-01 16:30:17'),(19406,20056,'0000-00-00','ET','2',1,NULL,'Cynthia l rudes','FI','278521207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:13',0,'2014-03-10 16:31:33'),(5399,5399,'2014-01-01','ET','2',1,NULL,'suzanne yaws','FI','442706186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:11',0,'2014-03-01 20:10:57'),(11113,11113,'2014-01-01','ET','2',1,NULL,'James Burrington','FI','381703517','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:32',0,'2014-03-10 13:45:57'),(18645,19295,'0000-00-00','ET','2',7,6,'John Johnson','FI','297868670','Dental Care Plus, Inc.','FI','311185262','Rale  Markovic','94','2775844','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:09',0,'2014-03-01 17:26:36'),(21561,22211,'0000-00-00','ET','2',1,NULL,'Crystal Van Calsem','FI','435539978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:31:40',0,'2014-03-03 22:26:43'),(327,327,'2014-01-01','ET','2',2,1,'Mary Jo Ulam','FI','263116546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:04',0,'2014-03-01 15:21:15'),(11785,11785,'2014-01-01','ET','2',1,NULL,'William Mckenzie','FI','465040778','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:39',0,'2014-03-02 04:31:46'),(4634,4634,'2014-01-01','ET','2',2,1,'Joseph George Cisneros','FI','453965489','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:23',0,'2014-03-02 04:31:46'),(13462,13818,'2014-01-01','ET','2',1,NULL,'Tamara Roberts','FI','274888859','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:28',0,'2014-03-01 16:40:16'),(12464,12464,'2014-01-01','ET','2',1,NULL,'Carla Anderson','FI','268889171','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:03',0,'2014-03-10 16:10:34'),(12177,12177,'2014-01-01','ET','2',1,NULL,'NANCY FLOWER','FI','272446239','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:24',0,'2014-03-10 16:10:34'),(10987,10987,'2014-01-01','ET','2',1,NULL,'david edwards','FI','436358696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:20',0,'2014-03-02 04:24:47'),(16098,16747,'0000-00-00','ET','2',3,2,'CHARISSE ALI','FI','274829907','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:16',0,'2014-03-10 16:24:30'),(21822,22472,'0000-00-00','ET','2',1,NULL,'Maria Y Bowles','FI','368789418','Dental Care Plus, Inc.','FI','311185262','John  Kirk','94','1814407','348','2014-04-01','Sync Success',0,'2014-03-05 21:00:18',0,'2014-03-05 21:36:22'),(333,333,'2014-01-01','ET','2',1,NULL,'Harriet Glover','FI','272665936','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:15',0,'2014-03-01 15:21:15'),(597,597,'2014-01-01','ET','2',1,NULL,'elsa alcala','FI','464336555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:29',0,'2014-03-02 02:10:49'),(5207,5207,'2014-01-01','ET','2',1,NULL,'sylvia ramirez','FI','449316223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:35',0,'2014-03-02 00:10:48'),(13752,14108,'2014-01-01','ET','2',1,NULL,'Tracy Cooper','FI','573595444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:15',0,'2014-03-02 05:24:45'),(13411,13767,'2014-01-01','ET','2',1,NULL,'CONNIE RIEBESEHL','FI','277829709','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:59',0,'2014-03-10 13:59:38'),(11660,11660,'2014-01-01','ET','2',1,NULL,'Michael Charles Hill','FI','293743861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:36',0,'2014-03-01 16:30:17'),(3266,3266,'2014-01-01','ET','2',1,NULL,'RUTH ANN BIDLACK','FI','294428959','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:22',0,'2014-03-10 13:32:15'),(11150,11150,'2014-01-01','ET','2',1,NULL,'Zachery Durnell','FI','274901975','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:15:55',0,'2014-03-10 13:45:57'),(10750,10750,'2014-01-01','ET','2',1,NULL,'David Storey','FI','294821973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:14',0,'2014-03-01 16:15:39'),(7336,7336,'2014-01-01','ET','2',1,NULL,'Ryan Patrick Osborne','FI','268087837','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:50',0,'2014-03-10 13:32:15'),(22249,22899,'0000-00-00','ET','2',1,NULL,'JOHN ZAWISTOWSKI','FI','277466950','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:15',0,'2014-03-10 16:44:18'),(22759,23409,'0000-00-00','ET','2',1,NULL,'Thu A Le','FI','636045349','Starmount Life Insurance Company','FI','720977315','Cuong T Phan','94','16459082','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:18',0,'2014-03-09 21:26:00'),(22723,23373,'0000-00-00','ET','2',1,NULL,'Jason Abrams','FI','428678847','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:15',0,'2014-03-08 22:26:18'),(4357,4357,'2014-01-01','ET','2',1,NULL,'Charlene Malicki','FI','276543692','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:11:01',0,'2014-03-10 13:32:15'),(6287,6287,'2014-01-01','ET','2',1,NULL,'Vallery Martin','FI','439275155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:03',0,'2014-03-02 04:10:25'),(13033,13389,'2014-01-01','ET','2',1,NULL,'Venita Young','FI','290584295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:29',0,'2014-03-01 16:35:14'),(17273,17923,'0000-00-00','ET','2',1,NULL,'EVA ACUNA','FI','631244114','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:42',0,'2014-03-02 06:24:38'),(17606,18256,'0000-00-00','ET','2',1,NULL,'linda wilson','FI','463909146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-22','Sync Success',0,'2014-02-08 19:00:07',0,'2014-03-02 06:31:45'),(20392,21042,'0000-00-00','ET','2',2,1,'holly Carroll','FI','419255507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:20',0,'2014-03-02 07:10:28'),(20895,21545,'0000-00-00','ET','2',1,NULL,'Ken Green','FI','273507752','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','357','2014-03-01','Sync Success',0,'2014-02-28 06:31:42',0,'2014-03-10 14:37:47'),(22086,22736,'0000-00-00','ET','2',1,NULL,'YOUNG GI HONG','FI','640847661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-06 21:00:19',0,'2014-03-06 21:27:26'),(4288,4288,'2014-01-01','ET','2',1,NULL,'Robin Houser','FI','281502682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:56',0,'2014-03-10 13:32:15'),(12282,12282,'2014-01-01','ET','2',1,NULL,'Ruchi Bawa','FI','279800346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:37',0,'2014-03-01 16:35:14'),(2957,2957,'2014-01-01','ET','2',1,NULL,'Patricia Laughery','FI','280427490','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3345388','348','2014-01-01','Sync Success',0,'2013-12-25 21:31:49',0,'2014-03-01 15:37:30'),(3422,3422,'2014-01-01','ET','2',2,1,'Thomas Martin','FI','297487867','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:24',0,'2014-03-10 13:32:15'),(14363,14814,'2014-01-01','ET','2',1,NULL,'Laura Arnold','FI','280625395','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:51',0,'2014-03-10 16:17:47'),(16879,17529,'0000-00-00','ET','2',1,NULL,'Spencer Lanham','FI','449978924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:14',0,'2014-03-02 06:17:30'),(17245,17895,'0000-00-00','ET','2',1,NULL,'LATRICA ANN DOUBLIN','FI','298787020','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:28',0,'2014-03-01 17:20:55'),(20983,21633,'0000-00-00','ET','2',1,NULL,'Jesse Thompson','FI','212889347','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:27',0,'2014-03-02 07:17:36'),(21464,22114,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:31',0,'2014-03-03 21:36:16'),(643,643,'2014-01-01','ET','2',2,1,'Ingrid Bueno','FI','461438810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:00',0,'2014-03-02 02:10:49'),(4767,4767,'2014-01-01','ET','2',1,NULL,'Elias Walstrom','FI','629129668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:55',0,'2014-03-01 21:11:04'),(12643,12643,'2014-01-01','ET','2',1,NULL,'Martha Ryan','FI','224724983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:38',0,'2014-03-02 05:10:52'),(6213,6213,'2014-01-01','ET','2',3,2,'Rachael A Balanson','FI','575393517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:41',0,'2014-03-01 16:00:27'),(12397,12397,'2014-01-01','ET','2',1,NULL,'Paul Fiamengo','FI','040540163','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:34',0,'2014-03-01 16:35:14'),(7471,7471,'2014-01-01','ET','2',1,NULL,'Hector Ramirez','FI','642263869','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','357','2014-01-01','Sync Success',0,'2013-12-26 04:33:00',0,'2014-03-02 04:15:49'),(15030,15481,'2014-01-01','ET','2',1,NULL,'Guy Henoumont','FI','528431296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:23',0,'2014-03-02 05:52:31'),(16201,16850,'0000-00-00','ET','2',1,NULL,'LEE BELTON','FI','435233155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:39',0,'2014-03-02 06:10:30'),(18325,18975,'0000-00-00','ET','2',1,NULL,'Terri L Sanata','FI','193447252','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:11',0,'2014-03-01 17:26:36'),(20829,21479,'0000-00-00','ET','2',1,NULL,'AMANDA ROPER','FI','627018453','Starmount Life Insurance Company','FI','720977315','Marcos  Orozco','94','1438597','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:12',0,'2014-03-02 07:17:36'),(4963,4963,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:32:15',0,'2014-03-01 15:05:09'),(4025,4025,'2014-01-01','ET','2',1,NULL,'PATRICIA BENNIE','FI','456909666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:54',0,'2014-03-02 03:09:49'),(12448,12448,'2014-01-01','ET','2',1,NULL,'Darren Paul','FI','439234359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:26',0,'2014-03-02 05:03:29'),(11673,11673,'2014-01-01','ET','2',2,1,'Jennifer Koester','FI','290765264','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:37:01',0,'2014-03-10 13:52:32'),(10826,10826,'2014-01-01','ET','2',1,NULL,'Larry McGee','FI','434909404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:04:44',0,'2014-03-02 04:31:46'),(7331,7331,'2014-01-01','ET','2',2,1,'Gabriel Halton','94','0000755986','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:40',0,'2014-03-10 13:32:15'),(2646,2646,'2014-01-01','ET','2',2,1,'Stuart Dowling','FI','282766030','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:16',0,'2014-03-01 16:05:34'),(2541,2541,'2014-01-01','ET','2',1,NULL,'Robert Turner','FI','301746870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:15',0,'2014-03-01 15:10:22'),(16877,17527,'0000-00-00','ET','2',1,NULL,'BETTY AGEE','FI','464110531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:13',0,'2014-03-02 06:17:30'),(19597,20247,'0000-00-00','ET','2',1,NULL,'susan snider','FI','459926046','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:31:32',0,'2014-03-02 06:59:07'),(21588,22238,'0000-00-00','ET','2',1,NULL,'KIM WEBB','FI','435231277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:11',0,'2014-03-04 21:27:16'),(22719,23369,'0000-00-00','ET','2',1,NULL,'Shellie Corey','FI','301823830','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:13',0,'2014-03-10 14:50:59'),(4922,4922,'2014-01-01','ET','2',1,0,'David Allan Hudson','FI','453876264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:53',0,'2014-03-01 19:11:03'),(6994,6994,'2014-01-01','ET','2',1,NULL,'Griselda Estrada','FI','457856199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:00:18',0,'2014-03-02 02:10:49'),(13683,14039,'2014-01-01','ET','2',1,NULL,'Martha M Gomez','FI','450533543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:30',0,'2014-03-02 05:24:45'),(13597,13953,'2014-01-01','ET','2',1,NULL,'Kristin Mathis','FI','454919093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:22',0,'2014-03-02 05:31:31'),(12609,12609,'2014-01-01','ET','2',1,NULL,'Empress Pando','FI','454757238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:24',0,'2014-03-02 05:10:52'),(14800,15251,'2014-01-01','ET','2',1,NULL,'Joshua Catone','FI','173700302','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:57',0,'2014-03-10 14:03:26'),(21346,21996,'0000-00-00','ET','2',1,NULL,'DONNA KAY RANDOLPH','FI','282270843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:21',0,'2014-03-03 01:35:37'),(22709,23359,'0000-00-00','ET','2',1,NULL,'Bonnie Kirk','FI','439316796','Starmount Life Insurance Company','FI','720977315','Michael  Essex','94','17133170','348','2014-04-01','Sync Success',0,'2014-03-08 21:31:05',0,'2014-03-08 22:26:18'),(1070,1070,'2014-01-01','ET','2',1,NULL,'Joseph Vanwie','FI','398084151','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:57',0,'2014-03-01 21:11:04'),(13206,13562,'2014-01-01','ET','2',1,NULL,'Joshua Fitzpatrick','FI','296828678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:16',0,'2014-03-01 16:35:14'),(13154,13510,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:04',0,'2014-03-10 16:10:34'),(1857,1857,'2014-01-01','ET','2',4,3,'Allen Dunn','FI','415398364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:26',0,'2014-03-01 15:26:40'),(2262,2262,'2014-01-01','ET','2',2,1,'Laura M Berry','FI','302708225','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:20',0,'2014-03-10 13:10:24'),(3120,3120,'2014-01-01','ET','2',1,NULL,'Lindsey Barta','FI','272928772','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:47',0,'2014-03-10 15:52:36'),(5909,5909,'2014-01-01','ET','2',1,NULL,'Terri Clark','FI','271687407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:05',0,'2014-03-01 15:48:04'),(15525,15976,'0000-00-00','ET','2',1,NULL,'Rita Brooks','FI','432151361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:02',0,'2014-03-02 05:59:43'),(17028,17678,'0000-00-00','ET','2',1,NULL,'Dennis B McAuley','FI','436780675','Starmount Life Insurance Company','FI','720977315','Mathu  Johon','94','17060413','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:16',0,'2014-03-02 06:24:38'),(17315,17965,'0000-00-00','ET','2',2,1,'Sandra Rowe','FI','224136752','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:03',0,'2014-03-10 14:24:38'),(17368,18018,'0000-00-00','ET','2',1,NULL,'Crystal Belcher','FI','442840805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:19',0,'2014-03-02 06:24:38'),(22960,23610,'0000-00-00','ET','2',1,NULL,'Victoria Howell','FI','262458499','Summa Insurance Company, Inc.','FI','341809108','Dave  Auble','94','7083348','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:23',0,'2014-03-10 21:07:22'),(23107,23757,'0000-00-00','ET','2',2,1,'SHARON CUPP','FI','077466994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:09',0,'2014-03-10 21:36:25'),(5973,5973,'2014-01-01','ET','2',1,NULL,'MARK JAMES CALLAHAN','FI','439738561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:07',0,'2014-03-02 01:10:33'),(1657,1657,'2014-01-01','ET','2',4,3,'William C Ridgeway','FI','272568359','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:07',0,'2014-03-10 15:45:56'),(12065,12065,'2014-01-01','ET','2',1,NULL,'Jennifer Lanser','FI','295861211','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:32',0,'2014-03-01 16:30:17'),(11406,11406,'2014-01-01','ET','2',2,1,'TAMMY A BLACK','FI','274707087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:45',0,'2014-03-10 13:52:32'),(15720,16369,'0000-00-00','ET','2',1,NULL,'CHELSEA JONES','FI','437734564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:01',0,'2014-03-02 05:59:43'),(18394,19044,'0000-00-00','ET','2',1,NULL,'Marcie Tyler','FI','435616592','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:56',0,'2014-03-02 06:45:14'),(18499,19149,'0000-00-00','ET','2',4,3,'Tiffany Budzinski','FI','291900309','HealthSpan','FI','311431434','Tiffany  Budzinski','94','17140606','348','2014-03-01','Sync Success',0,'2014-02-12 21:32:08',0,'2014-03-10 14:24:38'),(21392,22042,'0000-00-00','ET','2',1,NULL,'Slavcia Toth','FI','297568169','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:06',0,'2014-03-03 21:36:16'),(5448,5448,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:57',0,'2014-03-01 15:05:09'),(14643,15094,'2014-01-01','ET','2',1,NULL,'Melissa dehart','FI','269901971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:15',0,'2014-03-01 16:46:19'),(15381,15832,'0000-00-00','ET','2',1,NULL,'MICHAEL WHITE','FI','437597174','Starmount Life Insurance Company','FI','720977315','STEVE  WILLIS','94','17077577','348','2014-03-01','Sync Success',1,'2014-01-22 03:21:57',0,'2014-03-02 05:59:43'),(15733,16382,'0000-00-00','ET','2',1,NULL,'Cameron Sigler','FI','641347458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:11',0,'2014-03-02 05:59:43'),(15793,16442,'0000-00-00','ET','2',1,NULL,'terry waller','FI','449020214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:08',0,'2014-03-02 06:03:21'),(16721,17371,'0000-00-00','ET','2',1,NULL,'Keith Anderson','FI','272865768','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-31 21:01:32',0,'2014-03-10 16:24:30'),(20996,21646,'0000-00-00','ET','2',1,NULL,'marisel sanderford','FI','261532017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:36',0,'2014-03-02 07:17:36'),(100,100,'2014-01-01','ET','2',1,NULL,'ernesto jimenez','FI','456892496','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:02',0,'2014-03-01 22:10:55'),(13812,14168,'2014-01-01','ET','2',4,3,'Rita Schreiner','FI','291705939','Dental Care Plus, Inc.','FI','311185262','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:18',0,'2014-03-01 16:40:16'),(13602,13958,'2014-01-01','ET','2',1,NULL,'Sara Gerdon','FI','270802867','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:26',0,'2014-03-10 14:03:26'),(13171,13527,'2014-01-01','ET','2',4,3,'DANTE CAMPOLONGO','FI','282644839','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:41',0,'2014-03-10 13:59:38'),(13102,13458,'2014-01-01','ET','2',1,NULL,'Robert Meazle','FI','466174634','Starmount Life Insurance Company','FI','720977315','Kevin  Ethridge','94','13857389','348','2014-02-01','Sync Success',0,'2014-01-07 04:03:05',0,'2014-03-02 05:17:40'),(4166,4166,'2014-01-01','ET','2',1,NULL,'Karen A Treadway','FI','279500538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:09',0,'2014-03-10 15:59:47'),(5265,5265,'2014-01-01','ET','2',1,NULL,'James Pemberton','FI','283826220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:12',0,'2014-03-10 13:03:33'),(11110,11110,'2014-01-01','ET','2',1,NULL,'John Kaszowski','FI','304042459','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:26',0,'2014-03-10 13:45:57'),(15446,15897,'0000-00-00','ET','2',1,NULL,'Andrew Beauchamp','FI','436557090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:39',0,'2014-03-02 05:59:43'),(15777,16426,'0000-00-00','ET','2',2,1,'Patricia Dennis','FI','281721202','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:40',0,'2014-03-10 16:24:30'),(17562,18212,'0000-00-00','ET','2',1,NULL,'Thomas LeBlanc','FI','433577035','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:42',0,'2014-03-02 06:31:45'),(20270,20920,'0000-00-00','ET','2',1,NULL,'Dianne Fulmer','FI','279527349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:17',0,'2014-03-01 17:47:19'),(21519,22169,'0000-00-00','ET','2',1,NULL,'Shivon Killebrew','FI','457858599','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:09',0,'2014-03-03 22:26:43'),(22087,22737,'0000-00-00','ET','2',3,2,'DIANA ZAMARRIPA','FI','451414123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:20',0,'2014-03-06 21:27:26'),(911,911,'2014-01-01','ET','2',1,NULL,'Maxwell Masarik','FI','298020639','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:25',0,'2014-03-01 15:21:15'),(14473,14924,'2014-01-01','ET','2',2,1,'Dennis Meyers','FI','191423809','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:40',0,'2014-03-10 16:17:47'),(11384,11384,'2014-01-01','ET','2',1,NULL,'sabrina zoukas','FI','428253722','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:02',0,'2014-03-02 04:52:44'),(12344,12344,'2014-01-01','ET','2',1,NULL,'DONALD WAYNE HARRISON','FI','453060728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:42',0,'2014-03-02 05:03:29'),(15027,15478,'2014-01-01','ET','2',1,NULL,'amanda sidora','FI','437771602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:22',0,'2014-03-02 05:52:31'),(19054,19704,'0000-00-00','ET','2',2,1,'Tahir Ahmed','FI','344765108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:10',0,'2014-03-02 06:52:12'),(20903,21553,'0000-00-00','ET','2',1,NULL,'Sandra Hibsman','FI','191424850','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:46',0,'2014-03-10 14:45:25'),(21521,22171,'0000-00-00','ET','2',1,NULL,'colleen wise','FI','346626400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:31:11',0,'2014-03-03 22:26:43'),(22006,22656,'0000-00-00','ET','2',1,NULL,'Gabrielle Marie Lopez','FI','299922905','Dental Care Plus, Inc.','FI','311185262','Ronald  Martin','94','2432668','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:57',0,'2014-03-05 21:36:22'),(22348,22998,'0000-00-00','ET','2',1,NULL,'EMILY GARZA','FI','280843026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:11',0,'2014-03-07 21:36:32'),(519,519,'2014-01-01','ET','2',1,NULL,'Robert Sweeney','FI','381582338','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:02',0,'2014-03-01 15:48:04'),(6988,6988,'2014-01-01','ET','2',1,NULL,'Jack Lewis','FI','285502772','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:00:07',0,'2014-03-10 13:32:15'),(12961,12961,'2014-01-01','ET','2',1,NULL,'Kelly Darr','FI','455257502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:46',0,'2014-03-02 05:17:40'),(7730,7730,'2014-01-01','ET','2',2,1,'Steve Ditcher','FI','298521693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:13',0,'2014-03-01 15:05:09'),(15306,15757,'0000-00-00','ET','2',1,NULL,'SCOT PILKINGTON','FI','280423685','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:46:22',0,'2014-03-01 16:50:53'),(16390,17040,'0000-00-00','ET','2',1,NULL,'Daniel Monnin','FI','278683593','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:20',0,'2014-03-10 14:20:26'),(18424,19074,'0000-00-00','ET','2',1,NULL,'THOMAS THOMPSON','FI','279928682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-12 21:31:21',0,'2014-03-01 17:26:36'),(19591,20241,'0000-00-00','ET','2',1,NULL,'Shelly Murphree','FI','459813320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:30:35',0,'2014-03-02 06:59:07'),(21480,22130,'0000-00-00','ET','2',1,NULL,'Mark Bailey','FI','297762160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:41',0,'2014-03-03 21:36:16'),(22467,23117,'0000-00-00','ET','2',1,NULL,'ROGER MARTIN','FI','287740490','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:48',0,'2014-03-07 21:36:32'),(136,136,'2014-01-01','ET','2',1,NULL,'Ernestina Torres','FI','457083898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:12',0,'2014-03-01 22:10:55'),(6026,6026,'2014-01-01','ET','2',1,NULL,'Karen North','FI','279764981','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:45',0,'2014-03-01 15:10:22'),(2762,2762,'2014-01-01','ET','2',1,NULL,'KEITH HOGAN','FI','434533500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:06',0,'2014-03-02 04:15:49'),(325,325,'2014-01-01','ET','2',1,NULL,'Brandon Evans','FI','284922051','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:00',0,'2014-03-01 15:21:15'),(14277,14728,'2014-01-01','ET','2',1,NULL,'TERESA KIRKLAND','FI','268607590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:14',0,'2014-03-01 16:46:19'),(1223,1223,'2014-01-01','ET','2',1,NULL,'Garland Givens','FI','285803627','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:29',0,'2014-03-01 16:15:39'),(13845,14201,'2014-01-01','ET','2',1,NULL,'Kayla Lindberg','FI','636019337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:44',0,'2014-03-02 05:31:31'),(1553,1553,'2014-01-01','ET','2',1,NULL,'Rocky Barnett','FI','227025101','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:04',0,'2014-03-10 13:52:32'),(12906,12906,'2014-01-01','ET','2',1,NULL,'ADDISON GONZALEZ','FI','425719166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:06',0,'2014-03-02 05:17:40'),(2786,2786,'2014-01-01','ET','2',1,NULL,'gerald joseph','FI','291484004','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:54',0,'2014-03-01 16:05:34'),(4377,4377,'2014-01-01','ET','2',1,NULL,'Elizabeth Jacob','FI','269563461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:14',0,'2014-03-01 15:16:37'),(5537,5537,'2014-01-01','ET','2',1,NULL,'dan mccarthy','FI','290600527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:37',0,'2014-03-01 16:23:43'),(7373,7373,'2014-01-01','ET','2',1,NULL,'Steven Bernola','FI','270468608','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:20',0,'2014-03-10 13:03:33'),(6348,6348,'2014-01-01','ET','2',1,NULL,'charlynn gampher','FI','270889397','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:51',0,'2014-03-10 13:39:10'),(6179,6179,'2014-01-01','ET','2',1,NULL,'Gabriela Daley','FI','392782163','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:40',0,'2014-03-02 04:10:25'),(14888,15339,'2014-01-01','ET','2',1,NULL,'Maria Cook','FI','463354450','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:18',0,'2014-03-02 05:45:37'),(18660,19310,'0000-00-00','ET','2',1,NULL,'Melissa Stanley','FI','454735559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-27','Sync Success',0,'2014-02-13 22:01:21',0,'2014-03-02 06:45:14'),(20401,21051,'0000-00-00','ET','2',2,1,'Roosevelt Fuller','FI','434822155','Starmount Life Insurance Company','FI','720977315','Audrey L Black','94','16906406','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:27',0,'2014-03-02 07:10:28'),(20638,21288,'0000-00-00','ET','2',1,NULL,'JERRY D RHODES','FI','463450885','Starmount Life Insurance Company','FI','720977315','GEARGE  BOYLAN','94','8759152','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:16',0,'2014-03-02 07:10:28'),(22832,23482,'0000-00-00','ET','2',1,NULL,'Todd E Jones','FI','298766195','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-09 21:01:20',0,'2014-03-10 14:50:59'),(1521,1521,'2014-01-01','ET','2',3,2,'Julie Biggs','FI','295847234','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:06',0,'2014-03-10 16:03:49'),(2527,2527,'2014-01-01','ET','2',1,NULL,'Andrew Ryan Craig','FI','645054881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:50',0,'2014-03-01 20:10:57'),(14072,14523,'2014-01-01','ET','2',1,NULL,'Brenda Mosley','FI','451088118','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:17',0,'2014-03-02 05:31:31'),(13476,13832,'2014-01-01','ET','2',1,NULL,'Jeanne Plakosh','FI','285581823','HealthSpan','FI','311431434','Robert  Colaianni','94','16444219','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:36',0,'2014-03-10 14:03:26'),(13053,13409,'2014-01-01','ET','2',1,NULL,'JIMMIE  MILLER','FI','436063313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:12',0,'2014-03-02 05:17:40'),(12912,12912,'2014-01-01','ET','2',2,1,'DARRELL  KEASLEY','FI','436948657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:21',0,'2014-03-02 05:10:52'),(10643,10643,'2014-01-01','ET','2',1,NULL,'Cynthia Lunsford','FI','462232917','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','348','2014-01-01','Sync Success',0,'2013-12-26 12:58:35',0,'2014-03-02 04:31:46'),(4450,4450,'2014-01-01','ET','2',1,NULL,'Teresa Rosa','FI','291740937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:27',0,'2014-03-01 15:16:37'),(6410,6410,'2014-01-01','ET','2',4,3,'Patrick Horrigan','FI','288580937','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:52',0,'2014-03-10 15:59:47'),(4518,4518,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:42',0,'2014-03-10 15:39:19'),(5661,5661,'2014-01-01','ET','2',1,NULL,'Helani Scurfield','FI','534045044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:41',0,'2014-03-02 04:45:37'),(5268,5268,'2014-01-01','ET','2',1,NULL,'dale scott','FI','449965639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:17',0,'2014-03-01 19:11:03'),(4775,4775,'2014-01-01','ET','2',1,NULL,'jeremy mohon','FI','636205690','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 00:01:07',NULL,NULL),(15341,15792,'0000-00-00','ET','2',1,NULL,'Lan Dinh','FI','279927307','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:43',0,'2014-03-10 14:10:12'),(15740,16389,'0000-00-00','ET','2',1,NULL,'Brigitte Anderson','FI','267636759','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:16',0,'2014-03-02 05:59:43'),(19605,20255,'0000-00-00','ET','2',1,NULL,'brady tucker','94','0000152036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:33:23',0,'2014-03-01 17:34:07'),(22240,22890,'0000-00-00','ET','2',1,NULL,'PATRIQIOUS DENNIS','FI','249811218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:08',0,'2014-03-06 21:27:26'),(22435,23085,'0000-00-00','ET','2',1,NULL,'SHARON ESQUIVEL','FI','159643953','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:25',0,'2014-03-07 22:26:59'),(1210,1210,'2014-01-01','ET','2',1,NULL,'Lance DeBault','FI','382760715','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:05',0,'2014-03-01 16:15:39'),(3333,3333,'2014-01-01','ET','2',2,1,'Sainath Vaidhyanath','FI','301068063','Summa Insurance Company, Inc.','FI','341809108','John Chirstopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:36',0,'2014-03-10 15:52:36'),(14012,14368,'2014-01-01','ET','2',1,NULL,'Lisa Simes','FI','539620645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:39',0,'2014-03-01 16:40:16'),(3970,3970,'2014-01-01','ET','2',1,NULL,'Cathy Bennett','FI','232941027','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:47:15',0,'2014-03-01 15:26:40'),(4006,4006,'2014-01-01','ET','2',1,NULL,'Nada Herbly','FI','436759462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:19',0,'2014-03-02 03:09:49'),(5348,5348,'2014-01-01','ET','2',1,NULL,'Traci Skillen','FI','288469247','Summa Insurance Company, Inc.','FI','341809108','WILLIAM  MCILROY','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-26 01:15:47',0,'2014-03-10 15:39:19'),(7667,7667,'2014-01-01','ET','2',1,NULL,'SANDRA L POTTER','FI','292503167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:23',0,'2014-03-10 13:39:10'),(10440,10440,'2014-01-01','ET','2',1,NULL,'Alberta Manzi','FI','297501103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:58',0,'2014-03-01 16:10:36'),(15939,16588,'0000-00-00','ET','2',1,NULL,'Ashaki Jerels','FI','284843607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-25 19:00:16',NULL,NULL),(17599,18249,'0000-00-00','ET','2',1,NULL,'Aaron Fisher','FI','291885283','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:30:05',0,'2014-03-10 14:24:38'),(18726,19376,'0000-00-00','ET','2',1,NULL,'MINA KASHANI','FI','495603617','Starmount Life Insurance Company','FI','720977315','Eric  Boutin','94','7724950','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:12',0,'2014-03-02 06:52:12'),(19005,19655,'0000-00-00','ET','2',1,NULL,'Gloria Moore','FI','283506331','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-03-01','Sync Success',0,'2014-02-14 21:32:19',0,'2014-03-10 14:31:05'),(21315,21965,'0000-00-00','ET','2',1,NULL,'Robert Olive','FI','467173182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:05',0,'2014-03-03 01:07:25'),(21437,22087,'0000-00-00','ET','2',4,3,'shannon douglas','FI','285601561','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:08',0,'2014-03-10 16:38:05'),(22081,22731,'0000-00-00','ET','2',1,NULL,'Julie Snow','FI','471721383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:15',0,'2014-03-06 21:27:26'),(22423,23073,'0000-00-00','ET','2',1,NULL,'KIN TING','FI','457992571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:16',0,'2014-03-07 22:26:59'),(1802,1802,'2014-01-01','ET','2',1,NULL,'TERRY L JONES','FI','290585424','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:42',0,'2014-03-10 13:20:27'),(14077,14528,'2014-01-01','ET','2',1,NULL,'Jose Gonzalez','FI','451210510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:21',0,'2014-03-02 05:38:34'),(7402,7402,'2014-01-01','ET','2',1,NULL,'RUBY PERRY','FI','435293415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:55',0,'2014-03-02 04:10:25'),(7256,7256,'2014-01-01','ET','2',1,NULL,'Mark Wyant','FI','279502230','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:23',0,'2014-03-10 15:59:47'),(3201,3201,'2014-01-01','ET','2',1,NULL,'Deborah Eversole','FI','287549922','Dental Care Plus, Inc.','FI','311185262','Michael  Dougherty','94','8793711','357','2014-01-01','Sync Success',0,'2013-12-25 21:45:18',0,'2014-03-01 15:48:04'),(5215,5215,'2014-01-01','ET','2',2,1,'Daniel Noertker','FI','289843353','HealthSpan','FI','311431434','Darwin  Carmichael','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-26 00:52:52',0,'2014-03-10 13:20:27'),(4906,4906,'2014-01-01','ET','2',1,NULL,'Dale Churchill','FI','450987297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:21',0,'2014-03-01 19:11:03'),(4884,4884,'2014-01-01','ET','2',1,NULL,'Michael Dean Houser','FI','269881438','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:45',0,'2014-03-10 15:39:19'),(3966,3966,'2014-01-01','ET','2',1,NULL,'tracy kellam','FI','298804773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:07',0,'2014-03-01 15:26:40'),(3918,3918,'2014-01-01','ET','2',2,1,'Alan James Hensley','FI','234880854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:35',0,'2014-03-01 15:26:40'),(3497,3497,'2014-01-01','ET','2',1,NULL,'Alyson Forbes Flynn','FI','345482246','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:05',0,'2014-03-01 15:37:30'),(3460,3460,'2014-01-01','ET','2',1,NULL,'karen a okeeffe','FI','365507485','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:53:39',0,'2014-03-10 13:32:15'),(16289,16939,'0000-00-00','ET','2',2,1,'Johnnie Pipes','FI','455924353','Starmount Life Insurance Company','FI','720977315','Michael  Kakires','94','1008977','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:15',0,'2014-03-02 06:10:30'),(17051,17701,'0000-00-00','ET','2',1,NULL,'Jose Jaquez','FI','629907200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:31',0,'2014-03-02 06:24:38'),(17689,18339,'0000-00-00','ET','2',1,NULL,'David Griffith','FI','276540260','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:01:00',0,'2014-03-10 14:24:38'),(20893,21543,'0000-00-00','ET','2',1,NULL,'David Walker','FI','372681830','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:41',0,'2014-03-10 14:37:47'),(21430,22080,'0000-00-00','ET','2',1,NULL,'Mary Conerly','FI','437929832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:02',0,'2014-03-03 22:26:43'),(21782,22432,'0000-00-00','ET','2',2,1,'Zachary Thomas Morgan','FI','352829610','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:47',0,'2014-03-10 14:45:25'),(22244,22894,'0000-00-00','ET','2',1,NULL,'Mary C Domer','FI','297443464','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:11',0,'2014-03-10 16:44:18'),(1705,1705,'2014-01-01','ET','2',1,NULL,'Elizabeth Canterbury','FI','434216690','Starmount Life Insurance Company','FI','720977315','Patricia  Freeman','94','4700588','357','2014-01-01','Sync Success',0,'2013-12-25 19:16:40',0,'2014-03-02 00:10:48'),(14389,14840,'2014-01-01','ET','2',1,NULL,'Shannon Stegall','FI','279887763','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:01',0,'2014-03-01 16:46:19'),(14164,14615,'2014-01-01','ET','2',1,NULL,'David Connerth','FI','284662274','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:16',0,'2014-03-10 14:03:26'),(1822,1822,'2014-01-01','ET','2',1,NULL,'Larry Keeton','FI','268484078','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:19',0,'2014-03-10 15:45:56'),(4874,4874,'2014-01-01','ET','2',2,1,'JOHN J WAGNER','FI','285625222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:23',0,'2014-03-01 15:10:22'),(4732,4732,'2014-01-01','ET','2',1,NULL,'Lester F Lowe','FI','268765189','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:50',0,'2014-03-10 16:03:49'),(10784,10784,'2014-01-01','ET','2',1,NULL,'APRIL DIANNE WILLIAMS','FI','435911953','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:22',0,'2014-03-02 04:24:47'),(7273,7273,'2014-01-01','ET','2',1,NULL,'JAMES MILLS','FI','289840193','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:54',0,'2014-03-10 13:32:15'),(7170,7170,'2014-01-01','ET','2',1,NULL,'Joe Lordi','FI','295868336','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:42',0,'2014-03-10 15:59:47'),(16278,16928,'0000-00-00','ET','2',1,NULL,'Wanda Dents','FI','458379331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:09',0,'2014-03-02 06:10:30'),(16821,17471,'0000-00-00','ET','2',1,NULL,'Rachael Johnson','FI','260615002','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:07',0,'2014-03-02 06:17:30'),(17699,18349,'0000-00-00','ET','2',2,1,'jessica landrum','FI','301840420','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:30:09',0,'2014-03-10 14:24:38'),(18025,18675,'0000-00-00','ET','2',1,NULL,'MARY BRIDGEFORD','FI','273666885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:56',0,'2014-03-01 17:26:36'),(19804,20454,'0000-00-00','ET','2',1,NULL,'kim schulze','FI','460572919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:26',0,'2014-03-02 07:03:25'),(19983,20633,'0000-00-00','ET','2',1,NULL,'Whitney Alexander','FI','438670746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-21 22:00:40',0,'2014-03-02 07:03:25'),(20947,21597,'0000-00-00','ET','2',1,NULL,'MICHAEL A COTTRELL','FI','270544369','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:41',0,'2014-03-10 14:37:47'),(4245,4245,'2014-01-01','ET','2',1,NULL,'Sheila Hepler','FI','282566417','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:39',0,'2014-03-10 15:59:47'),(10602,10602,'2014-01-01','ET','2',1,NULL,'Richard Viera','FI','452499995','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:15',0,'2014-03-02 04:24:47'),(13667,14023,'2014-01-01','ET','2',1,NULL,'Katherine Cocchiaro','94','0000374363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:20',0,'2014-03-02 05:24:45'),(3297,3297,'2014-01-01','ET','2',1,NULL,'MARJORIE ANN AMMON','FI','177522204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:21',0,'2014-03-01 15:48:04'),(16321,16971,'0000-00-00','ET','2',1,NULL,'SARI SILWANI','FI','285826933','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:36',0,'2014-03-01 17:00:58'),(18968,19618,'0000-00-00','ET','2',2,1,'Nathan Bailey','FI','277787749','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:51',0,'2014-03-10 14:31:05'),(19344,19994,'0000-00-00','ET','2',1,NULL,'ROBBY DUCOTE','FI','437550718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-18 22:00:29',0,'2014-03-02 06:59:07'),(21092,21742,'0000-00-00','ET','2',1,NULL,'Catherine Bean','FI','230021219','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:42',0,'2014-03-02 07:23:39'),(21286,21936,'0000-00-00','ET','2',1,NULL,'Beverly Hayes','FI','286703832','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:53',0,'2014-03-10 14:45:25'),(247,247,'2014-01-01','ET','2',2,1,'Aaron Veyon','FI','232272322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:44',0,'2014-03-01 15:10:22'),(6191,6191,'2014-01-01','ET','2',1,NULL,'Dianna Sue Schronk','FI','452888463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:02',0,'2014-03-02 04:10:25'),(18124,18774,'0000-00-00','ET','2',2,1,'LUIS A HILL','FI','512566242','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:56',0,'2014-03-02 06:38:05'),(22767,23417,'0000-00-00','ET','2',1,NULL,'Esperanza Castello Beatty','FI','541291226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:23',0,'2014-03-09 21:26:00'),(135,135,'2014-01-01','ET','2',1,NULL,'BARBRA JENKINS','FI','467373784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:11',0,'2014-03-01 22:10:55'),(165,165,'2014-01-01','ET','2',1,NULL,'Regina Yerian','FI','297508382','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:08',0,'2014-03-10 13:10:24'),(14814,15265,'2014-01-01','ET','2',1,NULL,'Justin Beasley','FI','237618806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:07',0,'2014-03-10 14:03:26'),(234,234,'2014-01-01','ET','2',1,0,'Peggy Grove','FI','292620834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:21',0,'2014-03-01 15:05:09'),(5078,5078,'2014-01-01','ET','2',1,NULL,'Candice Elliott','FI','281540073','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:30',0,'2014-03-01 15:31:33'),(2857,2857,'2014-01-01','ET','2',1,NULL,'Michael Lucas','FI','268523763','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:15',0,'2014-03-10 15:59:47'),(16048,16697,'0000-00-00','ET','2',1,NULL,'Tamra Weaver','FI','268963647','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:42',0,'2014-03-01 16:56:22'),(16540,17190,'0000-00-00','ET','2',1,NULL,'Charles Shropshire','FI','437619803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:03',0,'2014-03-02 06:10:30'),(1281,1281,'2014-01-01','ET','2',1,NULL,'hansaben patel','FI','198729218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:12',0,'2014-03-01 16:23:43'),(14783,15234,'2014-01-01','ET','2',1,NULL,'natasha durr','FI','427316207','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:47',0,'2014-03-02 05:45:37'),(2199,2199,'2014-01-01','ET','2',1,NULL,'Denise Dobbins','FI','439983564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:09',0,'2014-03-01 21:11:04'),(15289,15740,'0000-00-00','ET','2',1,NULL,'Toncha Thigpen','FI','457613886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:12',0,'2014-03-02 05:52:31'),(15451,15902,'0000-00-00','ET','2',1,NULL,'JOSEPH RODMAN','FI','463470220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:43',0,'2014-03-02 05:59:43'),(19607,20257,'0000-00-00','ET','2',1,NULL,'brady tucker','94','0000152036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:33:37',0,'2014-03-01 17:34:07'),(20544,21194,'0000-00-00','ET','2',1,NULL,'NATALY FERNANDEZ','FI','631106099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:13',0,'2014-03-02 07:17:36'),(11483,11483,'2014-01-01','ET','2',1,NULL,'Vickie Arrone','FI','294586944','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:10',0,'2014-03-01 16:30:17'),(2718,2718,'2014-01-01','ET','2',1,NULL,'Enoch Crosland','FI','089667512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:46',0,'2014-03-02 04:15:49'),(10555,10555,'2014-01-01','ET','2',2,1,'JAMES REED','FI','463907936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:43',0,'2014-03-02 04:24:47'),(7223,7223,'2014-01-01','ET','2',2,1,'Mary Ilhardt','FI','302722846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:19',0,'2014-03-01 15:52:44'),(2742,2742,'2014-01-01','ET','2',1,NULL,'Amy Bryan','FI','434837555','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:30',0,'2014-03-02 04:15:49'),(6423,6423,'2014-01-01','ET','2',2,1,'Jessica Best','FI','281764608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:14',0,'2014-03-01 15:10:22'),(3606,3606,'2014-01-01','ET','2',1,NULL,'Thomas Clark','FI','279501621','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:33',0,'2014-03-10 15:52:36'),(5985,5985,'2014-01-01','ET','2',1,NULL,'Ty T Foust','FI','291763281','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:29',0,'2014-03-10 13:24:34'),(5912,5912,'2014-01-01','ET','2',2,1,'Lugene Tompkins','FI','417727029','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:11',0,'2014-03-01 15:48:04'),(3780,3780,'2014-01-01','ET','2',1,NULL,'ANDREY YEFREMOV','FI','284960829','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:40',0,'2014-03-01 15:26:40'),(5484,5484,'2014-01-01','ET','2',1,NULL,'Chanda Olivers','FI','086566538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:45:54',0,'2014-03-02 04:45:37'),(5182,5182,'2014-01-01','ET','2',1,NULL,'Hwa Kim','FI','494725508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:47',0,'2014-03-02 00:10:48'),(4295,4295,'2014-01-01','ET','2',1,NULL,'Shannon Vontz','FI','281887420','HealthSpan','FI','311431434','Jerome R Harpring','94','1492960','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:10',0,'2014-03-10 13:32:15'),(5000,5000,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:57',0,'2014-03-01 15:31:33'),(4325,4325,'2014-01-01','ET','2',1,NULL,'Jeffrey Dupuis','FI','433294926','Starmount Life Insurance Company','FI','720977315','Wayne  C Landwerlin','94','1632529','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:59',0,'2014-03-02 03:09:49'),(14564,15015,'2014-01-01','ET','2',1,NULL,'Nanette Fodell','FI','465295641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:27',0,'2014-03-02 05:45:37'),(14632,15083,'2014-01-01','ET','2',1,NULL,'Amy VanAlmen','FI','280723049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:10',0,'2014-03-01 16:46:19'),(15360,15811,'0000-00-00','ET','2',1,NULL,'Jesse Ann Knighton','FI','545888423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:55',0,'2014-03-02 05:52:31'),(18632,19282,'0000-00-00','ET','2',1,NULL,'Donald G Wertz','FI','293567497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:01:00',0,'2014-03-01 17:26:36'),(19686,20336,'0000-00-00','ET','2',1,NULL,'James Hoyat Thomas','FI','587115418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:52:16',0,'2014-03-02 06:59:07'),(19937,20587,'0000-00-00','ET','2',1,NULL,'BARBARA MARTINEK','FI','464866751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:05',0,'2014-03-02 07:03:25'),(20118,20768,'0000-00-00','ET','2',4,3,'DAVID  STOGSDILL','FI','283728277','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:32',0,'2014-03-01 18:08:07'),(21010,21660,'0000-00-00','ET','2',1,NULL,'Tress Turner','FI','439378400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:07',0,'2014-03-02 07:23:39'),(21454,22104,'0000-00-00','ET','2',2,1,'Timothy McGuire','FI','300860217','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:22',0,'2014-03-03 21:36:16'),(245,245,'2014-01-01','ET','2',1,NULL,'Robert Bermingham','FI','149828006','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:42',0,'2014-03-01 15:10:22'),(13958,14314,'2014-01-01','ET','2',4,3,'John Kennedy','FI','283808167','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:39',0,'2014-03-10 14:03:26'),(528,528,'2014-01-01','ET','2',2,1,'kaylie lee','FI','285867511','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:17',0,'2014-03-01 15:48:04'),(1972,1972,'2014-01-01','ET','2',2,1,'Angela Porter','FI','279580155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:52',0,'2014-03-01 15:26:40'),(2531,2531,'2014-01-01','ET','2',2,1,'Roger Poe','FI','457844709','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 20:30:56',0,'2014-03-01 20:10:57'),(12705,12705,'2014-01-01','ET','2',1,NULL,'tiaonia williams','FI','236354766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:58',0,'2014-03-02 05:10:52'),(2587,2587,'2014-01-01','ET','2',1,NULL,'David Dennison','FI','282729217','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:34',0,'2014-03-10 15:39:19'),(2685,2685,'2014-01-01','ET','2',1,NULL,'socorro reyes','FI','456558598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:44',0,'2014-03-02 04:15:49'),(11255,11255,'2014-01-01','ET','2',1,NULL,'MUSTAFA SHEEL','FI','099741978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:07',0,'2014-03-01 16:23:43'),(10944,10944,'2014-01-01','ET','2',1,NULL,'Michelle Walder','FI','280868891','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:02',0,'2014-03-10 16:03:49'),(10441,10441,'2014-01-01','ET','2',1,NULL,'Kyle Mitchell','FI','301905669','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:01',0,'2014-03-01 16:10:36'),(7499,7499,'2014-01-01','ET','2',2,1,'Billy Bruns','FI','277861687','Dental Care Plus, Inc.','FI','311185262','Kurt  Jarcik','94','4564074','348','2014-01-01','Sync Success',0,'2013-12-26 04:34:00',0,'2014-03-01 16:05:34'),(3851,3851,'2014-01-01','ET','2',1,NULL,'Laura Jenkins','FI','419781713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:39',0,'2014-03-01 19:11:03'),(4237,4237,'2014-01-01','ET','2',1,NULL,'Margaret Paulin','FI','272561940','Dental Care Plus, Inc.','FI','311185262','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:24',0,'2014-03-01 16:00:27'),(5739,5739,'2014-01-01','ET','2',1,NULL,'Jerry Whatley','FI','438845580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:01:36',0,'2014-03-02 01:10:33'),(4437,4437,'2014-01-01','ET','2',1,NULL,'Thomas Mueller','FI','295441873','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 23:17:17',0,'2014-03-10 13:03:33'),(15405,15856,'0000-00-00','ET','2',3,2,'XUAN DANG','FI','434855958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:13',0,'2014-03-02 05:59:43'),(15548,15999,'0000-00-00','ET','2',2,1,'SANDRA ELIZABETH DIAZ','FI','628603763','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:13',0,'2014-03-02 05:59:43'),(20000,20650,'0000-00-00','ET','2',1,NULL,'KEVIN WARREN','FI','280784836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:53',0,'2014-03-01 17:47:19'),(21055,21705,'0000-00-00','ET','2',1,NULL,'Cameron Conley','FI','246258437','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:17',0,'2014-03-01 18:10:11'),(17541,18191,'0000-00-00','ET','2',2,1,'Steve Gates','FI','294542469','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:28',0,'2014-03-01 17:20:55'),(17578,18228,'0000-00-00','ET','2',1,NULL,'BILLY BLOODSAW','FI','587967682','Starmount Life Insurance Company','FI','720977315','VICKIE   HICKS','94','4766477','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:55',0,'2014-03-02 06:31:45'),(583,583,'2014-01-01','ET','2',1,NULL,'Carolyn Scott','FI','437888061','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:02',0,'2014-03-02 02:10:49'),(1048,1048,'2014-01-01','ET','2',1,NULL,'Gloria Cristobal','FI','460659777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:13',0,'2014-03-01 21:11:04'),(4824,4824,'2014-01-01','ET','2',1,NULL,'Gary Reams','FI','279645991','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:37',0,'2014-03-10 15:39:19'),(11253,11253,'2014-01-01','ET','2',1,NULL,'Jeff Asplin','FI','288661710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:04',0,'2014-03-01 16:23:43'),(10996,10996,'2014-01-01','ET','2',1,NULL,'Sheri Stockstill','FI','587533664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:37',0,'2014-03-02 04:24:47'),(10473,10473,'2014-01-01','ET','2',1,NULL,'AMELIA HARDING','FI','280862597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:01',0,'2014-03-01 16:10:36'),(7034,7034,'2014-01-01','ET','2',1,NULL,'James Cordova','FI','463738589','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:34',0,'2014-03-02 03:09:49'),(21300,21950,'0000-00-00','ET','2',2,1,'Yu Lai','FI','283067385','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:05',0,'2014-03-10 14:45:25'),(15345,15796,'0000-00-00','ET','2',1,NULL,'paula paul','FI','436436402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:46',0,'2014-03-02 05:52:31'),(16337,16987,'0000-00-00','ET','2',1,NULL,'JAMES KIRSCH','FI','277744184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:46',0,'2014-03-01 16:56:22'),(18460,19110,'0000-00-00','ET','2',1,NULL,'Jeanean Iredale','FI','273866964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:44',0,'2014-03-10 14:31:05'),(19477,20127,'0000-00-00','ET','2',1,NULL,'KRISTY DUGAN','FI','628039309','Starmount Life Insurance Company','FI','720977315','TOMMY  CHILCUTT','94','1122081','348','2014-04-01','Sync Success',0,'2014-02-20 03:56:18',0,'2014-03-02 06:59:07'),(19613,20263,'0000-00-00','ET','2',1,NULL,'stephen promen','FI','268569160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:23',0,'2014-03-01 17:47:19'),(561,561,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:02:25',0,'2014-03-01 15:48:04'),(13765,14121,'2014-01-01','ET','2',1,NULL,'GARY WILSON','FI','288508340','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:22:24',0,'2014-03-10 16:10:34'),(13180,13536,'2014-01-01','ET','2',1,NULL,'Johnson Zenobia','FI','278687422','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:57',0,'2014-03-10 16:10:34'),(2396,2396,'2014-01-01','ET','2',1,NULL,'Iris Stankorb','FI','463293641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:04',0,'2014-03-01 23:10:52'),(11733,11733,'2014-01-01','ET','2',2,1,'Joshua Hess','FI','295842376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:54',0,'2014-03-01 16:30:17'),(11584,11584,'2014-01-01','ET','2',1,NULL,'LaSanya Williams','FI','459531746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:14',0,'2014-03-02 04:52:44'),(11193,11193,'2014-01-01','ET','2',1,NULL,'DIANE SMITH','FI','383560974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:14',0,'2014-03-01 16:23:43'),(1971,1971,'2014-01-01','ET','2',1,NULL,'Gregory L Porter','FI','300584444','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:33:51',0,'2014-03-01 15:26:40'),(5922,5922,'2014-01-01','ET','2',1,NULL,'corey hupp','FI','296901468','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:29',0,'2014-03-01 15:48:04'),(5783,5783,'2014-01-01','ET','2',1,NULL,'Crystal lynn Davis','FI','302768018','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:02',0,'2014-03-10 15:52:36'),(22539,23189,'0000-00-00','ET','2',1,NULL,'David Stanley','FI','292603437','Dental Care Plus, Inc.','FI','311185262','David  Loge','94','7559354','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:38',0,'2014-03-07 21:36:32'),(22947,23597,'0000-00-00','ET','2',1,NULL,'Kimberly Townsend','FI','300708461','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:14',0,'2014-03-10 21:07:22'),(5530,5530,'2014-01-01','ET','2',1,NULL,'michael crawford','FI','271723643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:23',0,'2014-03-01 16:23:43'),(6416,6416,'2014-01-01','ET','2',1,NULL,'Alan Cole','FI','281700404','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 03:11:05',0,'2014-03-10 13:39:10'),(10730,10730,'2014-01-01','ET','2',1,NULL,'Luke Feerer','FI','299709539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:38',0,'2014-03-01 16:10:36'),(12094,12094,'2014-01-01','ET','2',1,NULL,'Benjamin Pettey','FI','388086430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:30',0,'2014-03-01 16:30:17'),(11982,11982,'2014-01-01','ET','2',1,NULL,'Raquel Abrego','FI','451139962','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:26',0,'2014-03-02 05:03:29'),(11131,11131,'2014-01-01','ET','2',2,1,'Lauren DeGrange','FI','497904646','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:14',0,'2014-03-10 13:39:10'),(17303,17953,'0000-00-00','ET','2',1,NULL,'JUAN FUENTES','FI','662012683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:56',0,'2014-03-02 06:24:38'),(17493,18143,'0000-00-00','ET','2',1,NULL,'ROLINE  SAUNDERS-AUSTIN','FI','345629942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:49',0,'2014-03-02 06:31:45'),(18425,19075,'0000-00-00','ET','2',1,NULL,'Lois Lukens','FI','282525098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:21',0,'2014-03-01 17:26:36'),(21354,22004,'0000-00-00','ET','2',1,NULL,'Daniel Ayotte','FI','283863026','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-03 01:00:26',0,'2014-03-10 14:45:25'),(3977,3977,'2014-01-01','ET','2',1,NULL,'Thomas Edward Bonnington','FI','535729368','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:27',0,'2014-03-10 13:10:24'),(14303,14754,'2014-01-01','ET','2',1,NULL,'LaNetra Carther','FI','312844065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:25',0,'2014-03-02 05:38:34'),(6459,6459,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:26',0,'2014-03-10 13:03:33'),(12038,12038,'2014-01-01','ET','2',1,NULL,'Quintessa Perry','FI','433718113','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:31',0,'2014-03-02 05:03:29'),(14243,14694,'2014-01-01','ET','2',2,1,'shana hardy','FI','587637682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:59',0,'2014-03-02 05:38:34'),(7643,7643,'2014-01-01','ET','2',1,NULL,'MARVEMA WOLF','FI','513683130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:37',0,'2014-03-02 04:15:49'),(14999,15450,'2014-01-01','ET','2',2,1,'TIM  J WAGNER','FI','301747287','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:09',0,'2014-03-10 14:10:12'),(15682,16331,'0000-00-00','ET','2',1,NULL,'Logan Boyd','FI','456950946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 21:00:36',0,'2014-03-02 05:59:43'),(15918,16567,'0000-00-00','ET','2',1,NULL,'Austen Ngezelonye','FI','633983070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:05',0,'2014-03-02 06:03:21'),(22839,23489,'0000-00-00','ET','2',1,NULL,'LeeAnna Stevens','FI','451026975','Starmount Life Insurance Company','FI','720977315','Daniel  Abrams','94','2717565','348','2014-04-01','Sync Success',0,'2014-03-09 21:30:03',0,'2014-03-09 22:25:06'),(4950,4950,'2014-01-01','ET','2',1,NULL,'ZINA S MULLIN','FI','433417524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:49',0,'2014-03-01 20:10:57'),(12285,12285,'2014-01-01','ET','2',1,NULL,'Brianna Rodriguez','94','0000926280','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:45',0,'2014-03-01 16:35:14'),(4436,4436,'2014-01-01','ET','2',1,NULL,'jayson tomblin','FI','289745041','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:16',0,'2014-03-10 13:03:33'),(11086,11086,'2014-01-01','ET','2',1,NULL,'valerie Hull','FI','276686912','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:39',0,'2014-03-10 13:45:57'),(1621,1621,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:44',0,'2014-03-01 20:10:57'),(3125,3125,'2014-01-01','ET','2',1,NULL,'NANCY  TESSONE','FI','353448995','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:58',0,'2014-03-10 13:24:34'),(1773,1773,'2014-01-01','ET','2',1,NULL,'BARRY WHITTEN','FI','435318870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:42',0,'2014-03-02 00:10:48'),(17282,17932,'0000-00-00','ET','2',1,NULL,'Stevquesha Burts','FI','392114063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:45',0,'2014-03-02 06:24:38'),(17456,18106,'0000-00-00','ET','2',1,NULL,'Jana Reiter','FI','281502635','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:20',0,'2014-03-10 14:24:38'),(1001,1001,'2014-01-01','ET','2',1,NULL,'SILVIA E KEARNEY','FI','296962551','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:19',0,'2014-03-10 15:39:19'),(12610,12610,'2014-01-01','ET','2',1,NULL,'IRMA HINOJOSA','FI','457236504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:27',0,'2014-03-02 05:10:52'),(1737,1737,'2014-01-01','ET','2',1,NULL,'Cindy Marie Jorgensen','FI','290564366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:37',0,'2014-03-01 15:31:33'),(3528,3528,'2014-01-01','ET','2',1,NULL,'Matthew Alan Hanzel','FI','277887924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:05',0,'2014-03-01 15:31:33'),(6190,6190,'2014-01-01','ET','2',1,NULL,'Scott  Biram','FI','452954123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:00',0,'2014-03-02 04:10:25'),(5183,5183,'2014-01-01','ET','2',1,NULL,'sonya evans','FI','553459773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:49',0,'2014-03-02 00:10:48'),(15338,15789,'0000-00-00','ET','2',1,NULL,'Earlean Bradley','FI','587766702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:42',0,'2014-03-02 05:52:31'),(17546,18196,'0000-00-00','ET','2',1,NULL,'Jonathan Yarbrough','FI','276824472','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:31',0,'2014-03-10 16:24:30'),(20695,21345,'0000-00-00','ET','2',1,NULL,'HEIDI VOELKER','FI','439882537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:09',0,'2014-03-02 07:17:36'),(3325,3325,'2014-01-01','ET','2',5,4,'Dawn Cipro','FI','288661665','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:21',0,'2014-03-10 15:52:36'),(13174,13530,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:05:47',0,'2014-03-10 16:10:34'),(13059,13415,'2014-01-01','ET','2',1,NULL,'GARY BAHAM','FI','435866661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:25',0,'2014-03-02 05:17:40'),(7426,7426,'2014-01-01','ET','2',1,NULL,'curtis woodard','FI','439198742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:42',0,'2014-03-02 04:15:49'),(19031,19681,'0000-00-00','ET','2',2,1,'Debra Wilcox','FI','234940392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:04',0,'2014-03-01 17:34:07'),(18530,19180,'0000-00-00','ET','2',1,NULL,'Annette McMullen','FI','271647773','Summa Insurance Company, Inc.','FI','341809108','Jan T Naso','94','2625957','348','2014-03-01','Sync Success',0,'2014-02-13 21:30:03',0,'2014-03-10 16:31:33'),(1180,1180,'2014-01-01','ET','2',1,NULL,'CAMILLE BURKHALTER','FI','434023292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:09',0,'2014-03-02 04:38:08'),(17807,18457,'0000-00-00','ET','2',1,NULL,'connor kabbes','FI','270989809','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:40',0,'2014-03-10 14:10:12'),(2406,2406,'2014-01-01','ET','2',1,NULL,'Laura Schmidtbauer','FI','138684802','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:24',0,'2014-03-01 15:26:40'),(2741,2741,'2014-01-01','ET','2',2,1,'Larry McGee','FI','434909404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:27',0,'2014-03-02 04:15:49'),(7104,7104,'2014-01-01','ET','2',1,NULL,'Terrence Rich','FI','276664600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:43',0,'2014-03-01 15:52:44'),(5049,5049,'2014-01-01','ET','2',1,NULL,'Peter Holland','FI','276822262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:32',0,'2014-03-01 15:31:33'),(18453,19103,'0000-00-00','ET','2',1,NULL,'Dean Cantrell','FI','295626568','Summa Insurance Company, Inc.','FI','341809108','Ronald J Fleeter','94','1834226','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:39',0,'2014-03-10 16:31:33'),(18825,19475,'0000-00-00','ET','2',1,NULL,'cedrick johnson','FI','450372806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:08',0,'2014-03-02 06:52:12'),(22642,23292,'0000-00-00','ET','2',1,NULL,'Scot Hafler','FI','278807493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:13',0,'2014-03-08 21:35:36'),(336,336,'2014-01-01','ET','2',1,NULL,'Barbara Rosenbauer','FI','269546507','Dental Care Plus, Inc.','FI','311185262','Stanley  Sieniawski','94','1766911','348','2014-01-01','Sync Success',0,'2013-12-25 17:46:20',0,'2014-03-01 15:21:15'),(2077,2077,'2014-01-01','ET','2',1,NULL,'John Thomas Kutcher','FI','270444871','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:19',0,'2014-03-10 13:20:27'),(17878,18528,'0000-00-00','ET','2',1,NULL,'linda fae phillips','FI','287484143','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:14',0,'2014-03-10 16:31:33'),(17717,18367,'0000-00-00','ET','2',1,NULL,'Renee Harbin','FI','280742401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:13',0,'2014-03-01 17:20:55'),(6235,6235,'2014-01-01','ET','2',2,1,'Christine Thornton','FI','299825891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:25',0,'2014-03-01 16:00:27'),(15718,16367,'0000-00-00','ET','2',1,NULL,'Ha Vo','FI','663033784','Starmount Life Insurance Company','FI','720977315','Karen Woods Turley','94','16938114','348','2014-03-01','Sync Success',0,'2014-01-23 21:01:00',0,'2014-03-02 05:59:43'),(2580,2580,'2014-01-01','ET','2',2,1,'Terence Mahone','FI','269528660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:19',0,'2014-03-01 15:05:09'),(15090,15541,'0000-00-00','ET','2',1,NULL,'John Boring','FI','288608799','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:05:42',0,'2014-03-01 16:50:53'),(18006,18656,'0000-00-00','ET','2',1,NULL,'Danny Guitreau','FI','437118134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:43',0,'2014-03-02 06:38:05'),(3355,3355,'2014-01-01','ET','2',1,NULL,'CARLIE ROSE HUTCHINSON','FI','633341054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:50:19',0,'2014-03-02 02:10:49'),(20497,21147,'0000-00-00','ET','2',1,NULL,'Edith Howard','FI','433551393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:00:42',0,'2014-03-02 07:10:28'),(22785,23435,'0000-00-00','ET','2',1,NULL,'Todd E Jones','FI','298766195','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:37',0,'2014-03-09 21:35:27'),(11312,11312,'2014-01-01','ET','2',1,NULL,'TERESA WINN','FI','261454025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:53',0,'2014-03-02 04:52:44'),(18054,18704,'0000-00-00','ET','2',1,NULL,'Nick Laporte','FI','283563982','HealthSpan','FI','311431434','Pedro  Herrera','94','16637016','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:18',0,'2014-03-10 14:24:38'),(16695,17345,'0000-00-00','ET','2',1,NULL,'Joseph Patrick Yaegel','FI','407196485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:14',0,'2014-03-01 17:00:58'),(13550,13906,'2014-01-01','ET','2',1,NULL,'Joana Laxina','94','0001368873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:49',0,'2014-03-02 05:24:45'),(4326,4326,'2014-01-01','ET','2',1,NULL,'JANET RITSON','FI','273643192','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:10:02',0,'2014-03-10 13:32:15'),(4478,4478,'2014-01-01','ET','2',1,NULL,'alan rawls','FI','456572161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:20',0,'2014-03-01 21:11:04'),(4783,4783,'2014-01-01','ET','2',1,NULL,'Zachary Domke','FI','439770705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:22',0,'2014-03-01 21:11:04'),(7376,7376,'2014-01-01','ET','2',1,NULL,'Suzanne Prock','FI','437650629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:03',0,'2014-03-02 04:10:25'),(4784,4784,'2014-01-01','ET','2',1,NULL,'KIRBY DENSON','FI','301482910','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 00:01:24',NULL,NULL),(18236,18886,'0000-00-00','ET','2',4,3,'Michelle Swisher','FI','282661844','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:23',0,'2014-03-10 14:24:38'),(12272,12272,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:24:18',0,'2014-03-10 16:10:34'),(6052,6052,'2014-01-01','ET','2',1,NULL,'Samantha Morrison','FI','284883303','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:40',0,'2014-03-10 15:39:19'),(15315,15766,'0000-00-00','ET','2',2,1,'KEITH GREEN','FI','285682232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:26',0,'2014-03-01 16:50:53'),(20370,21020,'0000-00-00','ET','2',1,NULL,'LAURA BARON-MEJIA','FI','632116467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:55',0,'2014-03-02 07:03:25'),(22888,23538,'0000-00-00','ET','2',1,NULL,'JAMES METCALF','FI','295583427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:00:30',0,'2014-03-10 21:36:25'),(7549,7549,'2014-01-01','ET','2',2,1,'ALBERT F STOFF','FI','286447336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:35',0,'2014-03-01 16:05:34'),(17600,18250,'0000-00-00','ET','2',1,NULL,'Casey Hamann','FI','466438969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:03',0,'2014-03-02 06:31:45'),(5449,5449,'2014-01-01','ET','2',2,1,'carlos del rio','FI','530191743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:59',0,'2014-03-01 15:05:09'),(13524,13880,'2014-01-01','ET','2',2,1,'Matthew Charek','FI','268884468','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:33',0,'2014-03-01 16:40:16'),(13182,13538,'2014-01-01','ET','2',1,NULL,'Dennis Pedro','FI','270507110','Summa Insurance Company, Inc.','FI','341809108','Christopher  Vanderzyden','94','8680174','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:00',0,'2014-03-10 16:10:34'),(13086,13442,'2014-01-01','ET','2',2,1,'Richard Thacker','FI','307809501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:26',0,'2014-03-01 16:35:14'),(5299,5299,'2014-01-01','ET','2',2,1,'Molly Ryan-fisher','FI','292769897','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:23',0,'2014-03-01 15:05:09'),(18639,19289,'0000-00-00','ET','2',1,NULL,'Neva Broderick','FI','283429835','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:04',0,'2014-03-01 17:26:36'),(18895,19545,'0000-00-00','ET','2',1,NULL,'Susan Rodriguez','FI','270588746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:58',0,'2014-03-01 17:34:07'),(18977,19627,'0000-00-00','ET','2',1,NULL,'Laura Kilpatrick','FI','237047857','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:57',0,'2014-03-10 14:31:05'),(19290,19940,'0000-00-00','ET','2',1,NULL,'Amanda McNeal','FI','295863602','HealthSpan','FI','311431434','Kristen  Barger','94','2444040','348','2014-04-01','Sync Success',0,'2014-02-18 21:30:11',0,'2014-03-10 14:31:05'),(12985,12985,'2014-01-01','ET','2',1,NULL,'Tony Edwards','FI','425190613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:36',0,'2014-03-02 05:17:40'),(12707,12707,'2014-01-01','ET','2',1,NULL,'PAMELA WILSON','FI','426277486','Starmount Life Insurance Company','FI','720977315','SEARS  WARD','94','10991858','348','2014-02-01','Sync Success',0,'2014-01-03 02:05:01',0,'2014-03-02 05:10:52'),(7637,7637,'2014-01-01','ET','2',1,NULL,'Steven Chrisenberry','FI','454139060','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:25',0,'2014-03-02 04:15:49'),(17182,17832,'0000-00-00','ET','2',1,NULL,'Thomas Rowley','FI','281423220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:56',0,'2014-03-10 14:24:38'),(16115,16764,'0000-00-00','ET','2',1,NULL,'willie perkins','FI','408157183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:01:29',0,'2014-03-02 06:03:21'),(13510,13866,'2014-01-01','ET','2',1,NULL,'Callie Hudson','FI','642526774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:23',0,'2014-03-02 05:31:31'),(4701,4701,'2014-01-01','ET','2',1,NULL,'Gloria Turner','FI','438828218','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-01-01','Sync Success',0,'2013-12-25 23:50:41',0,'2014-03-02 04:31:46'),(7518,7518,'2014-01-01','ET','2',1,NULL,'Sarah M Creech','FI','297949050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:38',0,'2014-03-01 16:05:34'),(3080,3080,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:35:37',0,'2014-03-02 01:10:33'),(5022,5022,'2014-01-01','ET','2',6,5,'Sara Jordan','FI','187640968','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:39',0,'2014-03-01 15:31:33'),(19559,20209,'0000-00-00','ET','2',1,NULL,'SAMUEL L DANIEL','FI','433880206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:20:14',0,'2014-03-02 06:59:07'),(20445,21095,'0000-00-00','ET','2',1,NULL,'Scott Sauer','FI','272922058','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:31:01',0,'2014-03-10 16:38:05'),(394,394,'2014-01-01','ET','2',1,NULL,'Elizabeth Gomes','FI','436735152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:12',0,'2014-03-01 22:10:55'),(18269,18919,'0000-00-00','ET','2',1,NULL,'TAMMY  FITE','FI','285785035','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:53',0,'2014-03-10 14:24:38'),(17566,18216,'0000-00-00','ET','2',1,NULL,'AMY LANTIER','FI','438496630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:45',0,'2014-03-02 06:31:45'),(10962,10962,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:31',0,'2014-03-10 16:03:49'),(15461,15912,'0000-00-00','ET','2',2,1,'Richard A Kunkler','FI','293784953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:49',0,'2014-03-01 16:50:53'),(14877,15328,'2014-01-01','ET','2',2,1,'LINH TRAN','FI','631955094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:13',0,'2014-03-02 05:52:31'),(5972,5972,'2014-01-01','ET','2',1,NULL,'Mikki King','FI','276789335','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:05',0,'2014-03-10 13:24:34'),(3444,3444,'2014-01-01','ET','2',2,1,'JOHN BENSMAN','FI','291483622','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:07',0,'2014-03-10 13:32:15'),(4168,4168,'2014-01-01','ET','2',3,2,'Joseph Haffner','FI','289507788','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:13',0,'2014-03-10 15:59:47'),(19326,19976,'0000-00-00','ET','2',1,NULL,'VERONICA GUZMAN','FI','644101279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:16',0,'2014-03-02 06:59:07'),(2838,2838,'2014-01-01','ET','2',2,1,'CARLOS RIVERA','FI','060884421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:36',0,'2014-03-02 04:15:49'),(16972,17622,'0000-00-00','ET','2',1,NULL,'Heather Renee Jolliff','FI','268804533','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:13',0,'2014-03-01 17:00:58'),(7387,7387,'2014-01-01','ET','2',1,NULL,'W   Keith Williams','FI','280546469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:24',0,'2014-03-02 04:15:49'),(5854,5854,'2014-01-01','ET','2',2,1,'Donald Hoffman','FI','294540011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:17',0,'2014-03-01 15:10:22'),(15773,16422,'0000-00-00','ET','2',1,NULL,'Etta Hamilton','FI','232864216','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:37',0,'2014-03-10 16:24:30'),(15572,16023,'0000-00-00','ET','2',1,NULL,'Janyce Tipton','FI','278468877','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:23',0,'2014-03-10 14:10:12'),(15114,15565,'0000-00-00','ET','2',1,NULL,'OLGA KOVACH','FI','270764517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:00',0,'2014-03-01 16:50:53'),(5743,5743,'2014-01-01','ET','2',1,NULL,'Tristan Hahn','FI','626425680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:42',0,'2014-03-02 01:10:33'),(4397,4397,'2014-01-01','ET','2',1,NULL,'Rovella Stoner','FI','587727357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:50',0,'2014-03-01 21:11:04'),(19681,20331,'0000-00-00','ET','2',1,NULL,'BRENDA DIANE VALLEE','FI','278583433','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:51:04',0,'2014-03-10 14:37:47'),(19871,20521,'0000-00-00','ET','2',1,NULL,'KATHLEEN  CORNE','FI','378544819','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:21',0,'2014-03-01 17:47:19'),(22202,22852,'0000-00-00','ET','2',2,1,'TIMOTHY WILLIAMS','FI','299787440','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:41',0,'2014-03-06 21:36:23'),(12701,12701,'2014-01-01','ET','2',1,NULL,'Wasaki Ducksworth','94','0000385179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:48',0,'2014-03-02 05:10:52'),(18516,19166,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:32:22',0,'2014-03-10 14:31:05'),(12288,12288,'2014-01-01','ET','2',1,NULL,'Vivian Spires','FI','303765831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:50',0,'2014-03-01 16:35:14'),(2271,2271,'2014-01-01','ET','2',1,0,'Bradley Combs','FI','311861626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:12',0,'2014-03-01 15:05:09'),(15340,15791,'0000-00-00','ET','2',1,NULL,'Martin Williams','FI','269480837','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:43',0,'2014-03-10 14:10:12'),(15196,15647,'0000-00-00','ET','2',1,NULL,'Cindy Bechstein','FI','290522109','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:22',0,'2014-03-10 14:10:12'),(15034,15485,'2014-01-01','ET','2',1,NULL,'Kathryn Young','FI','205682198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:24',0,'2014-03-02 05:52:31'),(13594,13950,'2014-01-01','ET','2',1,NULL,'brandon gorka','FI','346741258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:20',0,'2014-03-02 05:31:31'),(13388,13744,'2014-01-01','ET','2',1,NULL,'michael knutty','FI','287680885','Summa Insurance Company, Inc.','FI','341809108','scott  prior','94','8416481','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:49',0,'2014-03-10 16:10:34'),(5975,5975,'2014-01-01','ET','2',1,NULL,'PAMELA MOODY','FI','433040895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:11',0,'2014-03-02 01:10:33'),(2729,2729,'2014-01-01','ET','2',2,1,'Dennis Davis','FI','439020854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:05',0,'2014-03-02 04:15:49'),(5587,5587,'2014-01-01','ET','2',1,NULL,'Stephanie Cannon','FI','449474895','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:49:14',0,'2014-03-02 04:45:37'),(4588,4588,'2014-01-01','ET','2',2,1,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:53',0,'2014-03-01 16:15:39'),(4939,4939,'2014-01-01','ET','2',1,NULL,'DAVID  CANTU','FI','460833002','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:26',0,'2014-03-01 20:10:57'),(21616,22266,'0000-00-00','ET','2',1,NULL,'Paige Floyd','FI','474889144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:33',0,'2014-03-04 21:27:16'),(22122,22772,'0000-00-00','ET','2',2,1,'Thuy Bui','FI','480153601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:45',0,'2014-03-06 21:27:26'),(12792,12792,'2014-01-01','ET','2',1,NULL,'angela  stevens','FI','449298703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:58',0,'2014-03-02 05:10:52'),(2054,2054,'2014-01-01','ET','2',1,NULL,'VICKI LASLO','FI','279501572','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:32',0,'2014-03-10 15:45:56'),(2583,2583,'2014-01-01','ET','2',1,NULL,'Carol Levy','FI','427926611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:25',0,'2014-03-01 19:11:03'),(13292,13648,'2014-01-01','ET','2',1,NULL,'Arin Jay Moorehead','FI','296941616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:09',0,'2014-03-01 16:40:16'),(14026,14382,'2014-01-01','ET','2',1,NULL,'Raymond Rogers','FI','293703329','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:49',0,'2014-03-10 16:17:47'),(20137,20787,'0000-00-00','ET','2',1,NULL,'ESSIE L MCGEE','FI','587923870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:46',0,'2014-03-02 07:10:28'),(21311,21961,'0000-00-00','ET','2',1,NULL,'amanda williams','FI','284740187','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-16','Sync Success',0,'2014-03-03 01:00:03',0,'2014-03-10 14:45:25'),(21848,22498,'0000-00-00','ET','2',1,NULL,'Beverly White','FI','433984271','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:05',0,'2014-03-05 22:27:33'),(13227,13583,'2014-01-01','ET','2',2,1,'TERESA LEE','FI','298768923','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:09',0,'2014-03-10 16:10:34'),(5417,5417,'2014-01-01','ET','2',1,NULL,'lois norris','FI','279449859','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:53',0,'2014-03-01 15:10:22'),(17512,18162,'0000-00-00','ET','2',1,NULL,'RONALD D SIMON','FI','423646720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:09',0,'2014-03-02 06:31:45'),(16808,17458,'0000-00-00','ET','2',2,1,'Christopher Watson','FI','274527320','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:47',0,'2014-03-10 16:24:30');
INSERT INTO `Edi834` VALUES (12237,12237,'2014-01-01','ET','2',1,NULL,'CHARLES BROUSSARD','FI','437737567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:56',0,'2014-03-02 05:10:52'),(15872,16521,'0000-00-00','ET','2',1,NULL,'Glen  Allen  Neal','FI','587889269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:55',0,'2014-03-02 06:03:21'),(15458,15909,'0000-00-00','ET','2',1,NULL,'Evan  Thomas  Saul','FI','593491289','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',1,'2014-01-22 03:22:47',0,'2014-03-01 16:50:53'),(19711,20361,'0000-00-00','ET','2',1,NULL,'RICHARD PARKER','FI','453063866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 05:30:19',0,'2014-03-02 06:59:07'),(18533,19183,'0000-00-00','ET','2',1,NULL,'JODELL HILL','FI','276782608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:04',0,'2014-03-01 17:26:36'),(22305,22955,'0000-00-00','ET','2',1,NULL,'Mary Berger','FI','279626105','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:59',0,'2014-03-10 14:50:59'),(3993,3993,'2014-01-01','ET','2',1,NULL,'Marvin  Butler','FI','435849197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:48:04',0,'2014-03-01 23:10:52'),(13038,13394,'2014-01-01','ET','2',1,NULL,'Christy Bentley','FI','285823066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:43',0,'2014-03-01 16:35:14'),(22939,23589,'0000-00-00','ET','2',2,1,'James Robinson','FI','288583556','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-10 21:01:09',0,'2014-03-10 21:07:22'),(11618,11618,'2014-01-01','ET','2',1,NULL,'Oretha Barnett','FI','291540125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:35:18',0,'2014-03-10 16:10:34'),(2995,2995,'2014-01-01','ET','2',1,NULL,'AMELIA RAMIREZ','FI','429652580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:58',0,'2014-03-02 01:10:33'),(15614,16065,'0000-00-00','ET','2',1,NULL,'margaret molden','FI','526216009','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:43',0,'2014-03-02 05:59:43'),(3824,3824,'2014-01-01','ET','2',2,1,'Robert Cooper','FI','287461542','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:12',0,'2014-03-10 13:10:24'),(4106,4106,'2014-01-01','ET','2',1,NULL,'Vicki Dachtler','FI','278723080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:24',0,'2014-03-01 16:00:27'),(5059,5059,'2014-01-01','ET','2',1,NULL,'Rachelle Roth','FI','181427305','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:54',0,'2014-03-01 15:31:33'),(20603,21253,'0000-00-00','ET','2',2,1,'scott heald','FI','283924111','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:50',0,'2014-03-01 18:08:07'),(20896,21546,'0000-00-00','ET','2',1,NULL,'Ken Green','FI','273507752','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','348','2014-03-01','Sync Success',0,'2014-02-28 06:31:42',0,'2014-03-10 14:37:47'),(21683,22333,'0000-00-00','ET','2',1,NULL,'DONNELL HOBBS','FI','427114146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:24',0,'2014-03-04 21:27:16'),(1513,1513,'2014-01-01','ET','2',2,1,'JOHN KLINESMITH','FI','278844333','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:48',0,'2014-03-10 16:03:49'),(12604,12604,'2014-01-01','ET','2',1,NULL,'MARYANN GARCIA','FI','453254147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:15',0,'2014-03-02 05:10:52'),(16556,17206,'0000-00-00','ET','2',1,NULL,'MARY KOCH','FI','277583977','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:13',0,'2014-03-10 14:20:26'),(10451,10451,'2014-01-01','ET','2',1,NULL,'Karen  Lynn Dutton','FI','272500526','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:20',0,'2014-03-01 16:10:36'),(22003,22653,'0000-00-00','ET','2',1,NULL,'Amy McLaren','FI','276806239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:55',0,'2014-03-05 21:36:22'),(22469,23119,'0000-00-00','ET','2',1,NULL,'Karen Archie','FI','300580002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:49',0,'2014-03-07 21:36:32'),(11307,11307,'2014-01-01','ET','2',1,NULL,'Dotzie Davis','FI','551087230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:03:44',0,'2014-03-02 04:45:37'),(12990,12990,'2014-01-01','ET','2',1,NULL,'Donna Bezik','FI','279567873','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:46',0,'2014-03-01 16:35:14'),(15962,16611,'0000-00-00','ET','2',2,1,'ROSA  E  SAN MIGUEL','FI','631929590','Starmount Life Insurance Company','FI','720977315','FERNANDO  OROZCO','94','1438597','348','2014-03-01','Sync Success',0,'2014-01-26 19:00:10',0,'2014-03-02 06:03:21'),(15828,16477,'0000-00-00','ET','2',2,1,'Gary Leitch','FI','438570811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:28',0,'2014-03-02 06:03:21'),(15590,16041,'0000-00-00','ET','2',1,NULL,'Sandra Boudreaux','FI','437022685','Starmount Life Insurance Company','FI','720977315','Victoria B Leet','94','8047328','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:31',0,'2014-03-02 05:59:43'),(18769,19419,'0000-00-00','ET','2',1,NULL,'Margo Park','FI','302427862','HealthSpan','FI','311431434','David J Walrod','94','8433071','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:43',0,'2014-03-10 14:31:05'),(19699,20349,'0000-00-00','ET','2',1,NULL,'Wanda Spangler','FI','274568908','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:54:37',0,'2014-03-10 14:37:47'),(20848,21498,'0000-00-00','ET','2',1,NULL,'Jennifer Matlock','FI','433753563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:20',0,'2014-03-02 07:17:36'),(21056,21706,'0000-00-00','ET','2',1,NULL,'KARIFA KEITA','FI','066846858','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:18',0,'2014-03-01 18:10:11'),(277,277,'2014-01-01','ET','2',2,1,'Kyung Sook Cho','FI','324685966','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:52',0,'2014-03-01 15:10:22'),(650,650,'2014-01-01','ET','2',1,NULL,'Warren Smith','94','0000826817','Starmount Life Insurance Company','FI','720977315','David  Holmes','94','17089927','348','2014-01-01','Sync Success',0,'2013-12-25 18:05:14',0,'2014-03-02 02:10:49'),(17614,18264,'0000-00-00','ET','2',3,2,'Dayasagar Hazari','FI','631135832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:11',0,'2014-03-02 06:31:45'),(10905,10905,'2014-01-01','ET','2',1,NULL,'DEBRA KNOX','FI','020402370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:48',0,'2014-03-02 04:24:47'),(3712,3712,'2014-01-01','ET','2',1,NULL,'Alexandra Stroud','FI','365949478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:56',0,'2014-03-02 01:10:33'),(4285,4285,'2014-01-01','ET','2',1,NULL,'Neal Spencer','FI','285482100','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:52',0,'2014-03-10 13:32:15'),(4395,4395,'2014-01-01','ET','2',1,NULL,'Ricky Post','FI','302567631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:46',0,'2014-03-01 15:16:37'),(18890,19540,'0000-00-00','ET','2',2,1,'Thomas Corbett','FI','460026768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:54',0,'2014-03-02 06:52:12'),(19244,19894,'0000-00-00','ET','2',1,NULL,'thomas f hathcox','FI','434558801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:34',0,'2014-03-02 06:52:12'),(19878,20528,'0000-00-00','ET','2',1,NULL,'Larry Mckitrick','FI','292569438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 22:01:26',0,'2014-03-01 17:47:19'),(20328,20978,'0000-00-00','ET','2',1,NULL,'JOEL ORTIZ','FI','596055093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:17',0,'2014-03-02 07:03:25'),(20714,21364,'0000-00-00','ET','2',1,NULL,'Jacob Mattes','FI','299924952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:18',0,'2014-03-01 18:08:07'),(21186,21836,'0000-00-00','ET','2',3,2,'Michelle Hedrick','FI','301763384','HealthSpan','FI','311431434','Cameron  Liljenquist','94','8328382','348','2014-01-01','Sync Success',0,'2014-02-28 21:31:48',0,'2014-03-10 14:45:25'),(21501,22151,'0000-00-00','ET','2',1,NULL,'Dan W Korgan','FI','542802509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:55',0,'2014-03-03 21:36:16'),(22887,23537,'0000-00-00','ET','2',2,1,'Belinda Heller','FI','278766098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:29',0,'2014-03-10 21:36:25'),(330,330,'2014-01-01','ET','2',2,1,'Joan Fink','FI','278509262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:09',0,'2014-03-01 15:21:15'),(901,901,'2014-01-01','ET','2',1,NULL,'Rapheal Ollison','FI','465699923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:10',0,'2014-03-01 15:21:15'),(10806,10806,'2014-01-01','ET','2',1,NULL,'Karen Napoli','FI','434021453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:04',0,'2014-03-02 04:24:47'),(16477,17127,'0000-00-00','ET','2',1,NULL,'Ann Elizabeth Perryman','FI','437987815','Starmount Life Insurance Company','FI','720977315','Monica  Folse','94','4710336','348','2014-03-01','Sync Success',0,'2014-01-30 21:00:22',0,'2014-03-02 06:17:30'),(15924,16573,'0000-00-00','ET','2',1,NULL,'Beatriz Leandro','FI','457233630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:07',0,'2014-03-02 06:03:21'),(5900,5900,'2014-01-01','ET','2',1,NULL,'maryann j putman','FI','270666670','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:47',0,'2014-03-01 15:48:04'),(3728,3728,'2014-01-01','ET','2',2,1,'TAMMY STAFFEN','FI','277704717','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:29',0,'2014-03-10 13:20:27'),(22685,23335,'0000-00-00','ET','2',1,NULL,'Nairy A Chavez','FI','439537663','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:47',0,'2014-03-08 22:26:18'),(7539,7539,'2014-01-01','ET','2',1,NULL,'Lauren Luebbers','FI','403251106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:17',0,'2014-03-01 16:05:34'),(17675,18325,'0000-00-00','ET','2',1,NULL,'Keith Allen Knerem','FI','269503628','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:50',0,'2014-03-10 16:24:30'),(17564,18214,'0000-00-00','ET','2',2,1,'Cyndi Busby','FI','436651252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:43',0,'2014-03-02 06:31:45'),(17497,18147,'0000-00-00','ET','2',1,NULL,'Ronald Trubee','FI','293528699','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:52',0,'2014-03-10 14:24:38'),(2898,2898,'2014-01-01','ET','2',3,2,'Carmen Mendoza','FI','235867129','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:40',0,'2014-03-10 13:39:10'),(3242,3242,'2014-01-01','ET','2',1,NULL,'Amy Flesher','FI','271788792','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:37',0,'2014-03-01 15:52:44'),(5717,5717,'2014-01-01','ET','2',1,NULL,'joseph clausen','FI','297525815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:59',0,'2014-03-01 15:37:30'),(5841,5841,'2014-01-01','ET','2',1,NULL,'VIRGINIA CROSBY','FI','286589004','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:48',0,'2014-03-01 15:10:22'),(20372,21022,'0000-00-00','ET','2',1,NULL,'CONNIE CLAYVAUGH','FI','268583492','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:57',0,'2014-03-10 14:37:47'),(22337,22987,'0000-00-00','ET','2',1,NULL,'Rhonda Marsh','FI','299725901','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:23',0,'2014-03-10 14:50:59'),(22502,23152,'0000-00-00','ET','2',1,NULL,'RANDY LOWE','FI','292647415','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:12',0,'2014-03-10 14:50:59'),(23089,23739,'0000-00-00','ET','2',1,NULL,'Christopher Bann','FI','548850247','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:59',0,'2014-03-10 21:07:22'),(1977,1977,'2014-01-01','ET','2',1,NULL,'Cindy Marie Jorgensen','FI','290564366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:03',0,'2014-03-01 15:31:33'),(17872,18522,'0000-00-00','ET','2',1,NULL,'Karen Warnick','FI','268524886','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:08',0,'2014-03-10 16:31:33'),(16567,17217,'0000-00-00','ET','2',1,NULL,'Elizabeth Rock','FI','276588911','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:20',0,'2014-03-10 16:24:30'),(14626,15077,'2014-01-01','ET','2',1,NULL,'Michelle McCue','FI','299606635','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:45:06',0,'2014-03-01 16:46:19'),(11808,11808,'2014-01-01','ET','2',1,NULL,'Corey Sabo','FI','270863482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:18',0,'2014-03-01 16:15:39'),(5446,5446,'2014-01-01','ET','2',1,NULL,'Griselda Estrada','FI','457856199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:51',0,'2014-03-01 19:11:03'),(3867,3867,'2014-01-01','ET','2',2,1,'Rhea Rasnic','FI','406883570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:08',0,'2014-03-01 19:11:03'),(22775,23425,'0000-00-00','ET','2',1,NULL,'ALBERT S FREDERICK','FI','297440458','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:29',0,'2014-03-09 21:35:27'),(578,578,'2014-01-01','ET','2',1,NULL,'EDUARDO rene GONZALEZ','FI','665189138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:53',0,'2014-03-02 02:10:49'),(16680,17330,'0000-00-00','ET','2',2,1,'delores potts','FI','587238295','Starmount Life Insurance Company','FI','720977315','Sherri   Hardy','94','8415129','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:02',0,'2014-03-02 06:17:30'),(16545,17195,'0000-00-00','ET','2',1,NULL,'Vera Fowler','FI','438729752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:06',0,'2014-03-02 06:10:30'),(14624,15075,'2014-01-01','ET','2',1,NULL,'Francis Zhang','FI','471069563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:05',0,'2014-03-01 16:46:19'),(14434,14885,'2014-01-01','ET','2',2,1,'crystal bamburg','FI','438594531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:24',0,'2014-03-02 05:38:34'),(11383,11383,'2014-01-01','ET','2',1,NULL,'Linda Short','FI','261633948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:01',0,'2014-03-02 04:45:37'),(13726,14082,'2014-01-01','ET','2',1,NULL,'annette goldberg','FI','457884833','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:58',0,'2014-03-02 05:24:45'),(2659,2659,'2014-01-01','ET','2',1,NULL,'Todd Smith','FI','286866405','Dental Care Plus, Inc.','FI','311185262','Heidi  McArthur','94','8621177','348','2014-01-01','Sync Success',0,'2013-12-25 21:15:45',0,'2014-03-01 16:05:34'),(21522,22172,'0000-00-00','ET','2',2,1,'jose ledesma','FI','668668354','Starmount Life Insurance Company','FI','720977315','Adam  Gomez','94','8221989','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:11',0,'2014-03-03 22:26:43'),(21532,22182,'0000-00-00','ET','2',1,NULL,'Marcus John Turella','FI','452879800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:31:18',0,'2014-03-03 22:26:43'),(10757,10757,'2014-01-01','ET','2',1,NULL,'Karen Crabtree','FI','301463542','Dental Care Plus, Inc.','FI','311185262','DEANNA M WELLS','94','7827930','348','2014-01-01','Sync Success',0,'2013-12-26 13:02:29',0,'2014-03-01 16:15:39'),(17025,17675,'0000-00-00','ET','2',1,NULL,'Angie Bryant','FI','435355626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:15',0,'2014-03-02 06:24:38'),(16749,17399,'0000-00-00','ET','2',1,NULL,'AMELIA RAMIREZ','FI','429652580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-01 19:00:09',0,'2014-03-02 06:17:30'),(16541,17191,'0000-00-00','ET','2',1,NULL,'ESTRELLITA HUDSON','FI','436232837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:03',0,'2014-03-02 06:10:30'),(16142,16791,'0000-00-00','ET','2',1,NULL,'Regina Yerian','FI','297508382','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:50',0,'2014-03-10 14:20:26'),(2142,2142,'2014-01-01','ET','2',4,3,'Jeffrey Toth','FI','269783194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:12',0,'2014-03-01 15:16:37'),(2783,2783,'2014-01-01','ET','2',1,NULL,'Elizabeth Mays','FI','294709294','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:46',0,'2014-03-01 16:05:34'),(3008,3008,'2014-01-01','ET','2',1,NULL,'TRACEY JO FREIMAN','FI','272669090','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:22',0,'2014-03-10 15:52:36'),(7091,7091,'2014-01-01','ET','2',2,1,'Bonnie Clark','FI','378583451','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:21',0,'2014-03-01 15:52:44'),(4300,4300,'2014-01-01','ET','2',1,NULL,'Amanda Hughie','FI','411577339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:18',0,'2014-03-02 03:09:49'),(4714,4714,'2014-01-01','ET','2',1,NULL,'Kathy Bryant','FI','426618946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:07',0,'2014-03-02 04:31:46'),(5196,5196,'2014-01-01','ET','2',2,1,'ZEING SHIOU LEE','FI','238492550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:14',0,'2014-03-02 00:10:48'),(22993,23643,'0000-00-00','ET','2',1,NULL,'SANDRA JONES','FI','293529410','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:46',0,'2014-03-10 21:36:25'),(1448,1448,'2014-01-01','ET','2',5,4,'Samir Haikal','FI','284821386','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:37',0,'2014-03-01 16:15:39'),(10838,10838,'2014-01-01','ET','2',1,NULL,'RENE  LUNKINS','FI','439276421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:05',0,'2014-03-02 04:31:46'),(16292,16942,'0000-00-00','ET','2',2,1,'DEMETRIO GARCIA','FI','464917587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:17',0,'2014-03-02 06:10:30'),(1975,1975,'2014-01-01','ET','2',2,1,'ALAN HORVATH','FI','278848072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:59',0,'2014-03-01 15:26:40'),(7175,7175,'2014-01-01','ET','2',1,NULL,'Michelle Flower','FI','268822818','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:51',0,'2014-03-10 15:59:47'),(14716,15167,'2014-01-01','ET','2',4,3,'Andrea Link','FI','277783229','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:05',0,'2014-03-10 14:03:26'),(3451,3451,'2014-01-01','ET','2',1,NULL,'JAMES ALLEN MIHM','FI','300503884','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:22',0,'2014-03-10 13:32:15'),(19474,20124,'0000-00-00','ET','2',1,NULL,'JANICE GOINES','FI','439478768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:54:35',0,'2014-03-02 06:59:07'),(20540,21190,'0000-00-00','ET','2',1,NULL,'Larry Jefferson','FI','463118328','Starmount Life Insurance Company','FI','720977315','Alan   Charing','94','16800293','357','2014-03-01','Sync Success',0,'2014-02-26 21:01:11',0,'2014-03-02 07:10:28'),(22449,23099,'0000-00-00','ET','2',1,NULL,'Ramon Escobar','FI','462863003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:34',0,'2014-03-07 22:26:59'),(3336,3336,'2014-01-01','ET','2',1,NULL,'Eva Labocki','FI','278503403','Summa Insurance Company, Inc.','FI','341809108','Randy  Klein','94','520533','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:42',0,'2014-03-10 15:52:36'),(3375,3375,'2014-01-01','ET','2',1,NULL,'Devon Cameron','FI','464717311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:55',0,'2014-03-02 02:10:49'),(3610,3610,'2014-01-01','ET','2',4,3,'LaKisha Williams','FI','287888848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:40',0,'2014-03-10 15:52:36'),(13238,13594,'2014-01-01','ET','2',1,NULL,'Shelia Sturgis','FI','428195724','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:37',0,'2014-03-02 05:17:40'),(4819,4819,'2014-01-01','ET','2',1,NULL,'Clarissa Long','FI','279547693','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:27',0,'2014-03-10 13:10:24'),(13610,13966,'2014-01-01','ET','2',1,NULL,'Donna M Walker','FI','268801718','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:32',0,'2014-03-01 16:40:16'),(5455,5455,'2014-01-01','ET','2',1,NULL,'gerald jones','FI','433353817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:10',0,'2014-03-01 19:11:03'),(20042,20692,'0000-00-00','ET','2',1,NULL,'katanna lee moreno','FI','632321715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-22 19:00:14',0,'2014-03-02 07:03:25'),(2170,2170,'2014-01-01','ET','2',2,1,'ARTHUR GRAY','FI','269643827','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:09',0,'2014-03-01 15:16:37'),(22545,23195,'0000-00-00','ET','2',1,NULL,'Lorie L Irby','FI','425258275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:43',0,'2014-03-07 22:26:59'),(11320,11320,'2014-01-01','ET','2',1,NULL,'SHARON WILSON','FI','465885372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:06',0,'2014-03-02 04:52:44'),(5855,5855,'2014-01-01','ET','2',1,NULL,'MELINDA LYNN SOLOMON','FI','289961375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:20',0,'2014-03-01 15:10:22'),(15905,16554,'0000-00-00','ET','2',1,NULL,'DONNA CLEGG','FI','192483331','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:15',0,'2014-03-10 14:10:12'),(2870,2870,'2014-01-01','ET','2',1,NULL,'gerald joseph','FI','291484004','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:22:38',0,'2014-03-10 13:39:10'),(2342,2342,'2014-01-01','ET','2',1,NULL,'Baffour Otchere','FI','291766180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:15:26',0,'2014-03-01 15:26:40'),(20226,20876,'0000-00-00','ET','2',1,NULL,'HOLLY BAKER','FI','283663804','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:51',0,'2014-03-10 14:37:47'),(22631,23281,'0000-00-00','ET','2',2,1,'DEANN KRAMER','FI','296721088','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:06',0,'2014-03-08 21:35:36'),(22951,23601,'0000-00-00','ET','2',1,NULL,'Stephen Steinmetz','FI','279648220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:18',0,'2014-03-10 21:17:52'),(12069,12069,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:04:41',0,'2014-03-01 16:30:17'),(1626,1626,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:51',0,'2014-03-01 20:10:57'),(15705,16354,'0000-00-00','ET','2',3,2,'SUN PARK','FI','357782946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:51',0,'2014-03-02 05:59:43'),(15324,15775,'0000-00-00','ET','2',1,NULL,'Tenee Martin','FI','294885450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:32',0,'2014-03-01 16:50:53'),(15318,15769,'0000-00-00','ET','2',1,NULL,'Crystal Henry','FI','302824044','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:28',0,'2014-03-10 14:10:12'),(3048,3048,'2014-01-01','ET','2',1,NULL,'Cory DiDonato','FI','277927005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:32',0,'2014-03-01 15:37:30'),(18473,19123,'0000-00-00','ET','2',1,NULL,'BETTY SMITH','FI','288641471','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:52',0,'2014-03-10 14:24:38'),(19439,20089,'0000-00-00','ET','2',1,NULL,'YUE YUAN RONG','FI','370155947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:38',0,'2014-03-10 14:31:05'),(549,549,'2014-01-01','ET','2',2,1,'Laura M Berry','FI','302708225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:59',0,'2014-03-01 15:48:04'),(4547,4547,'2014-01-01','ET','2',2,1,'james pham','FI','435856522','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:36',0,'2014-03-02 04:31:46'),(2631,2631,'2014-01-01','ET','2',1,NULL,'Betty Barnhart','FI','294563914','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:00',0,'2014-03-10 15:39:19'),(15127,15578,'0000-00-00','ET','2',5,4,'Shari Bernstein','FI','286506337','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:10',0,'2014-03-10 16:17:47'),(13500,13856,'2014-01-01','ET','2',1,NULL,'Patrick Grossman','FI','449858369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:16',0,'2014-03-02 05:31:31'),(20683,21333,'0000-00-00','ET','2',1,NULL,'JUAN AREVALO HERNANDES','FI','065830699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:04',0,'2014-03-02 07:17:36'),(22179,22829,'0000-00-00','ET','2',1,NULL,'EMILY BARNES','FI','295902481','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:24',0,'2014-03-06 21:36:23'),(22622,23272,'0000-00-00','ET','2',1,NULL,'Kathleen Ann Lewis','FI','302501326','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-08 21:00:09',0,'2014-03-10 14:50:59'),(22794,23444,'0000-00-00','ET','2',1,NULL,'Jessica Meghan Ebert','FI','295903367','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-09 21:00:45',0,'2014-03-09 21:35:27'),(22995,23645,'0000-00-00','ET','2',2,1,'Nancy Jean Gangwisch','FI','273744630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:47',0,'2014-03-10 21:36:25'),(23031,23681,'0000-00-00','ET','2',1,NULL,'michael mclees II','FI','283905711','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:14',0,'2014-03-10 21:17:52'),(11348,11348,'2014-01-01','ET','2',1,NULL,'kyle pritchett','FI','631101733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:57',0,'2014-03-02 04:52:44'),(17440,18090,'0000-00-00','ET','2',1,NULL,'Isaac Quaye','FI','752134585','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:09',0,'2014-03-10 14:24:38'),(349,349,'2014-01-01','ET','2',1,NULL,'Connie Powell','FI','297583968','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:46',0,'2014-03-01 15:21:15'),(15632,16083,'0000-00-00','ET','2',1,NULL,'Gloria Moore','FI','283506331','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:51',0,'2014-03-10 14:10:12'),(15033,15484,'2014-01-01','ET','2',1,NULL,'Cameron Abbott Farquhar','FI','623343815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:24',0,'2014-03-02 05:52:31'),(1608,1608,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:25',0,'2014-03-01 20:10:57'),(5737,5737,'2014-01-01','ET','2',1,NULL,'Chasidity Williams','FI','437515550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:33',0,'2014-03-02 01:10:33'),(22747,23397,'0000-00-00','ET','2',1,NULL,'Shaun Lamonte','FI','434738333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:09',0,'2014-03-09 21:26:00'),(10501,10501,'2014-01-01','ET','2',1,NULL,'Haley Smeltzer','FI','403733865','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:56',0,'2014-03-01 16:15:39'),(17100,17750,'0000-00-00','ET','2',1,NULL,'Crystal Ford','FI','294561447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:01',0,'2014-03-01 17:00:58'),(1237,1237,'2014-01-01','ET','2',1,NULL,'Kathleen J Snodgrass','FI','298545163','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:51',0,'2014-03-01 16:15:39'),(16164,16813,'0000-00-00','ET','2',1,NULL,'Michel Clement','FI','270643673','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:16',0,'2014-03-01 16:56:22'),(1535,1535,'2014-01-01','ET','2',1,NULL,'JESSE FINCH','FI','268660071','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-25 18:58:29',0,'2014-03-10 13:45:57'),(3465,3465,'2014-01-01','ET','2',1,NULL,'manfred meier','FI','286561917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:04',0,'2014-03-01 15:31:33'),(1896,1896,'2014-01-01','ET','2',1,NULL,'Senia Gomez','FI','645106521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:39',0,'2014-03-01 23:10:52'),(1781,1781,'2014-01-01','ET','2',1,NULL,'David Benson','FI','270689987','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:59',0,'2014-03-10 15:45:56'),(18132,18782,'0000-00-00','ET','2',1,NULL,'Karen Quinn','FI','435763954','Starmount Life Insurance Company','FI','720977315','Tabitha Talley Hendon','94','8931528','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:01',0,'2014-03-02 06:38:05'),(14823,15274,'2014-01-01','ET','2',1,NULL,'Paula George','94','0000991564','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:14',0,'2014-03-10 14:03:26'),(17530,18180,'0000-00-00','ET','2',1,NULL,'hieu nguyen','FI','293942409','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:21',0,'2014-03-01 17:20:55'),(1899,1899,'2014-01-01','ET','2',1,NULL,'Lorenza Eugene Roye','FI','579840814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:44',0,'2014-03-01 23:10:52'),(16790,17440,'0000-00-00','ET','2',1,NULL,'Karen Cortes','FI','254693967','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-01 19:00:34',0,'2014-03-01 17:00:58'),(2132,2132,'2014-01-01','ET','2',1,NULL,'John Alexander Lapushansky','FI','230433590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:53',0,'2014-03-01 15:16:37'),(3173,3173,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:38:36',0,'2014-03-10 13:24:34'),(14739,15190,'2014-01-01','ET','2',1,NULL,'juanita bushner','FI','279762969','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:19',0,'2014-03-10 16:17:47'),(14500,14951,'2014-01-01','ET','2',2,1,'Joshua Alan Kunar','FI','290823608','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:52',0,'2014-03-10 14:03:26'),(12857,12857,'2014-01-01','ET','2',2,1,'JOSEPH LENGEL','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:21',0,'2014-03-01 16:35:14'),(7044,7044,'2014-01-01','ET','2',1,NULL,'MARIA TORRES','FI','463439823','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:51',0,'2014-03-02 03:09:49'),(11129,11129,'2014-01-01','ET','2',1,NULL,'Scarlet  Tannia  Gross','FI','269483435','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:11',0,'2014-03-10 13:45:57'),(20309,20959,'0000-00-00','ET','2',1,NULL,'Elijah Santiago','FI','299905672','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:47',0,'2014-03-10 14:37:47'),(20363,21013,'0000-00-00','ET','2',1,NULL,'DARIUS CUNNINGHAM','FI','425552578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:49',0,'2014-03-02 07:03:25'),(20944,21594,'0000-00-00','ET','2',2,1,'Hira Ahmad','FI','779296685','HealthSpan','FI','311431434','Laura  Payne','94','8060111','348','2014-04-01','Sync Success',0,'2014-02-28 07:00:36',0,'2014-03-10 14:37:47'),(10641,10641,'2014-01-01','ET','2',1,NULL,'LUIS SANCHEZ','FI','465452130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:32',0,'2014-03-02 04:31:46'),(18361,19011,'0000-00-00','ET','2',1,NULL,'GLORIA MEDELLIN JIMENEZ','FI','523275095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:34',0,'2014-03-02 06:45:14'),(17588,18238,'0000-00-00','ET','2',1,NULL,'Thomas Joseph Hall','FI','277786397','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:04',0,'2014-03-10 14:24:38'),(16794,17444,'0000-00-00','ET','2',1,NULL,'Jennifer Wolf','94','0000384435','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:37',0,'2014-03-01 17:00:58'),(7197,7197,'2014-01-01','ET','2',1,NULL,'TERRI ANN STEERS','FI','455111784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:32',0,'2014-03-02 03:09:49'),(16155,16804,'0000-00-00','ET','2',1,NULL,'Chad Doberson','FI','449657937','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:10',0,'2014-03-02 06:03:21'),(18482,19132,'0000-00-00','ET','2',1,NULL,'randall barnett','FI','426631825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:58',0,'2014-03-02 06:45:14'),(20413,21063,'0000-00-00','ET','2',1,NULL,'JAUNITA D RICHARD','FI','433780949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:37',0,'2014-03-02 07:10:28'),(20720,21370,'0000-00-00','ET','2',1,NULL,'ZAKK BRADEN TAYLOR','94','0000560603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:21',0,'2014-03-01 18:08:07'),(22944,23594,'0000-00-00','ET','2',1,NULL,'PETER J ROZZI','FI','271880077','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:12',0,'2014-03-10 21:07:22'),(1865,1865,'2014-01-01','ET','2',2,1,'CHARLES KINGSLEY PETERS','FI','375549820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:42',0,'2014-03-01 15:26:40'),(15904,16553,'0000-00-00','ET','2',1,NULL,'Matthew Schwieterman','FI','294669203','HealthSpan','FI','311431434','Amy  Sheaks','94','15838390','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:15',0,'2014-03-10 14:10:12'),(17763,18413,'0000-00-00','ET','2',1,NULL,'Chuncey McGowan','FI','427518363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:45',0,'2014-03-02 06:31:45'),(17262,17912,'0000-00-00','ET','2',2,1,'Terry Loehman','FI','466946199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:37',0,'2014-03-02 06:24:38'),(19577,20227,'0000-00-00','ET','2',1,NULL,'Jill Wilson','FI','366620143','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-20 04:25:26',0,'2014-03-10 14:37:47'),(20263,20913,'0000-00-00','ET','2',1,NULL,'Matthew Kemp McElroy','FI','293861391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:12',0,'2014-03-01 17:47:19'),(7621,7621,'2014-01-01','ET','2',1,NULL,'NORA NELSON','FI','276543679','HealthSpan','FI','311431434','Brooke  Bowerman','94','1854510','348','2014-01-01','Sync Success',0,'2013-12-26 04:37:57',0,'2014-03-10 13:39:10'),(6120,6120,'2014-01-01','ET','2',1,NULL,'Deborah  Ann  Golias','FI','302645100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:54',0,'2014-03-01 16:00:27'),(2903,2903,'2014-01-01','ET','2',1,NULL,'Gregory Flaherty','FI','280486783','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 21:30:04',0,'2014-03-10 13:24:34'),(2945,2945,'2014-01-01','ET','2',1,NULL,'TRACEY JO FREIMAN','FI','272669090','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:25',0,'2014-03-01 15:37:30'),(3864,3864,'2014-01-01','ET','2',1,0,'Anthony Slowik','FI','453559871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:03',0,'2014-03-01 19:11:03'),(5727,5727,'2014-01-01','ET','2',1,NULL,'Sarah Gaugh','FI','287840931','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:13',0,'2014-03-01 15:48:04'),(5932,5932,'2014-01-01','ET','2',1,NULL,'Timothy Krueger','FI','282824632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:48',0,'2014-03-01 15:48:04'),(5415,5415,'2014-01-01','ET','2',1,NULL,'Mary Singleton','FI','556024507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:49',0,'2014-03-01 15:10:22'),(5390,5390,'2014-01-01','ET','2',1,NULL,'Mary Barker','FI','295527213','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:13',0,'2014-03-10 15:39:19'),(11936,11936,'2014-01-01','ET','2',1,NULL,'Michelle Bramer','FI','277727661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:10',0,'2014-03-10 16:10:34'),(12522,12522,'2014-01-01','ET','2',1,NULL,'CURMERA HARPER','FI','426591761','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:08',0,'2014-03-02 05:03:29'),(21382,22032,'0000-00-00','ET','2',1,NULL,'Scott Grigsby','FI','273787896','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:30:00',0,'2014-03-10 16:38:05'),(22088,22738,'0000-00-00','ET','2',1,NULL,'Michelle Obale','FI','432953495','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:21',0,'2014-03-06 21:27:26'),(12992,12992,'2014-01-01','ET','2',1,NULL,'Sarah Farris','FI','283828648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:01:51',0,'2014-03-01 16:35:14'),(1719,1719,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','357','2014-01-01','Sync Success',0,'2013-12-25 19:17:05',0,'2014-03-01 15:31:33'),(17644,18294,'0000-00-00','ET','2',2,1,'Lawren mccandless','FI','167602850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:31',0,'2014-03-01 17:20:55'),(15232,15683,'0000-00-00','ET','2',1,NULL,'Valerie Bennett','FI','276524737','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:15',0,'2014-03-10 14:10:12'),(12367,12367,'2014-01-01','ET','2',1,NULL,'Victor Arney','FI','546130625','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',1,'2014-01-02 04:28:29',0,'2014-03-02 05:03:29'),(7728,7728,'2014-01-01','ET','2',2,1,'Debra Jones','FI','272565634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:08',0,'2014-03-01 15:05:09'),(7615,7615,'2014-01-01','ET','2',2,1,'JAMES STEWART','FI','292801013','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:45',0,'2014-03-10 13:39:10'),(7516,7516,'2014-01-01','ET','2',4,3,'Richard Bitonte','FI','289564580','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:33',0,'2014-03-01 16:05:34'),(3226,3226,'2014-01-01','ET','2',1,NULL,'Ariel Diamond','FI','344729683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:06',0,'2014-03-01 15:52:44'),(11757,11757,'2014-01-01','ET','2',1,NULL,'MARY ANDERSEN','FI','433749840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:09:39',0,'2014-03-02 04:59:36'),(11919,11919,'2014-01-01','ET','2',1,NULL,'dan mccarthy','FI','290600527','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-30 00:01:35',0,'2014-03-01 16:30:17'),(4641,4641,'2014-01-01','ET','2',2,1,'Catherine Mims','FI','460735249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:35',0,'2014-03-02 04:38:08'),(12808,12808,'2014-01-01','ET','2',1,NULL,'Robbie Kuykendall','FI','453454353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:33',0,'2014-03-02 05:17:40'),(18628,19278,'0000-00-00','ET','2',1,NULL,'Carol Howlett','FI','288564367','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:57',0,'2014-03-01 17:26:36'),(17698,18348,'0000-00-00','ET','2',2,1,'Edward Schimmel','FI','289601125','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:30:07',0,'2014-03-01 17:20:55'),(123,123,'2014-01-01','ET','2',1,NULL,'Juanita Corcodel','FI','294701729','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:47',0,'2014-03-10 15:45:56'),(17001,17651,'0000-00-00','ET','2',1,NULL,'Glenda Watts','FI','290588321','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-03 21:01:31',0,'2014-03-10 16:24:30'),(15699,16348,'0000-00-00','ET','2',1,NULL,'DELIA RODRIGUEZ','FI','309663751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:47',0,'2014-03-02 05:59:43'),(1701,1701,'2014-01-01','ET','2',1,NULL,'John Little','FI','434597889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:31',0,'2014-03-02 00:10:48'),(12568,12568,'2014-01-01','ET','2',1,NULL,'Theresa Gorski','FI','289760811','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:36:02',0,'2014-03-10 13:59:38'),(14813,15264,'2014-01-01','ET','2',4,3,'Nafisa Youssefi','FI','278909860','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:06',0,'2014-03-10 16:17:47'),(14670,15121,'2014-01-01','ET','2',1,NULL,'Josh salmons','FI','270923120','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:34',0,'2014-03-01 16:46:19'),(14649,15100,'2014-01-01','ET','2',3,2,'diane spence','FI','301804084','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:21',0,'2014-03-01 16:46:19'),(5218,5218,'2014-01-01','ET','2',1,NULL,'Stacy Steinspring','FI','480940306','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 00:52:58',0,'2014-03-10 13:20:27'),(6415,6415,'2014-01-01','ET','2',1,NULL,'Kathryn Petzold','FI','073440198','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:11:04',0,'2014-03-10 13:39:10'),(13511,13867,'2014-01-01','ET','2',1,NULL,'MEDI SADEGHBEGI','FI','463777205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:23',0,'2014-03-02 05:31:31'),(13595,13951,'2014-01-01','ET','2',1,NULL,'Dominique Robinson','FI','456794604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:21',0,'2014-03-02 05:31:31'),(15107,15558,'0000-00-00','ET','2',1,NULL,'JOHN R GODINEZ','FI','469690735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:55',0,'2014-03-02 05:52:31'),(12252,12252,'2014-01-01','ET','2',1,NULL,'Chamica Hamilton','FI','459374351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:30',0,'2014-03-02 05:03:29'),(4193,4193,'2014-01-01','ET','2',2,1,'Beverly Crowder','FI','406742977','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:02',0,'2014-03-10 15:59:47'),(21085,21735,'0000-00-00','ET','2',1,NULL,'Karon Klein','FI','283660484','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:37',0,'2014-03-10 16:38:05'),(1416,1416,'2014-01-01','ET','2',1,NULL,'MARK  KENNEDY','FI','286420221','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:34',0,'2014-03-10 13:45:57'),(17389,18039,'0000-00-00','ET','2',1,NULL,'Joseph Vogel','94','0000505767','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:34',0,'2014-03-01 17:20:55'),(15678,16327,'0000-00-00','ET','2',1,NULL,'michael springob','FI','466656429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:33',0,'2014-03-02 05:59:43'),(2764,2764,'2014-01-01','ET','2',1,NULL,'Diane Parkman','FI','433172697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:10',0,'2014-03-02 04:15:49'),(15397,15848,'0000-00-00','ET','2',1,NULL,'ANGELICA  GARZA','FI','459797329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:08',0,'2014-03-02 05:59:43'),(13623,13979,'2014-01-01','ET','2',5,4,'JEFFREY RUMMER','FI','275682719','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:41',0,'2014-03-10 16:10:34'),(7090,7090,'2014-01-01','ET','2',1,NULL,'Ellen Breitburg','FI','275523600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:20',0,'2014-03-01 15:52:44'),(3566,3566,'2014-01-01','ET','2',1,NULL,'Pedro F Martinez','FI','585669767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:19',0,'2014-03-02 00:10:48'),(20474,21124,'0000-00-00','ET','2',1,NULL,'Ieasha Vaughn','FI','281787908','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:00:26',0,'2014-03-01 18:08:07'),(12599,12599,'2014-01-01','ET','2',1,NULL,'Gayle D Kline','FI','454115884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:03',0,'2014-03-02 05:10:52'),(2894,2894,'2014-01-01','ET','2',1,NULL,'Derrick Horne','FI','300781808','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:31',0,'2014-03-10 13:39:10'),(14577,15028,'2014-01-01','ET','2',2,1,'TANYA FLORES','FI','571736368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:35',0,'2014-03-02 05:45:37'),(14178,14629,'2014-01-01','ET','2',1,NULL,'Aimee F Wilson','FI','277805920','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:25',0,'2014-03-10 16:17:47'),(10799,10799,'2014-01-01','ET','2',1,NULL,'vince riehl','FI','354605081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:50',0,'2014-03-02 04:24:47'),(13034,13390,'2014-01-01','ET','2',2,1,'JOYCE CLARK','FI','294665074','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:31',0,'2014-03-01 16:35:14'),(5670,5670,'2014-01-01','ET','2',1,NULL,'Jan Walters','FI','467905273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:03',0,'2014-03-02 04:45:37'),(12301,12301,'2014-01-01','ET','2',1,NULL,'danette harrison','FI','299601835','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:25:20',0,'2014-03-10 13:59:38'),(17378,18028,'0000-00-00','ET','2',1,NULL,'Alicia Spann','FI','459891054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:27',0,'2014-03-02 06:31:45'),(17373,18023,'0000-00-00','ET','2',1,NULL,'Mc PHAM','FI','479271409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-20','Sync Success',0,'2014-02-06 21:00:24',0,'2014-03-02 06:31:45'),(7207,7207,'2014-01-01','ET','2',1,NULL,'Nanette Roberts','FI','550330973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:52',0,'2014-03-01 15:52:44'),(13301,13657,'2014-01-01','ET','2',1,NULL,'Debbra Rakestraw','FI','273545502','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:13',0,'2014-03-01 16:40:16'),(13233,13589,'2014-01-01','ET','2',1,NULL,'DEBORAH LEE LANCE','FI','302585112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:24',0,'2014-03-01 16:35:14'),(13175,13531,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:48',0,'2014-03-10 16:10:34'),(1918,1918,'2014-01-01','ET','2',1,NULL,'maria olvera','FI','290508889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:17',0,'2014-03-02 00:10:48'),(6428,6428,'2014-01-01','ET','2',1,NULL,'SANDI K BARRINGER','FI','299565235','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:24',0,'2014-03-01 15:10:22'),(19581,20231,'0000-00-00','ET','2',4,3,'Rebecca Schulte','FI','294722750','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:26:35',0,'2014-03-10 14:37:47'),(20007,20657,'0000-00-00','ET','2',2,1,'EDWIN MCMILLION','FI','278543511','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:58',0,'2014-03-10 16:38:05'),(774,774,'2014-01-01','ET','2',1,NULL,'Jon Eicher','FI','283860450','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:11',0,'2014-03-01 15:05:09'),(12984,12984,'2014-01-01','ET','2',1,NULL,'Earline Johnson','FI','587136376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:34',0,'2014-03-02 05:17:40'),(16683,17333,'0000-00-00','ET','2',1,NULL,'Lonnie George','FI','439174172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:04',0,'2014-03-02 06:17:30'),(21971,22621,'0000-00-00','ET','2',1,NULL,'WILLIAM MCCAULEY','FI','286606212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:33',0,'2014-03-10 16:44:18'),(240,240,'2014-01-01','ET','2',1,0,'JOY VINSON','FI','433734340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:31',0,'2014-03-01 19:11:03'),(952,952,'2014-01-01','ET','2',1,NULL,'Annette Byrd','FI','433173267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:42',0,'2014-03-01 22:10:55'),(1848,1848,'2014-01-01','ET','2',5,4,'CESAR A MESONES','FI','276023886','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:06',0,'2014-03-01 15:26:40'),(12447,12447,'2014-01-01','ET','2',1,NULL,'Christopher Jackson','FI','436217860','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:24',0,'2014-03-02 05:03:29'),(15835,16484,'0000-00-00','ET','2',1,NULL,'Crystal Bangura','FI','271785423','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:00:32',0,'2014-03-01 16:56:22'),(15510,15961,'0000-00-00','ET','2',1,NULL,'Austen Ngezelonye','FI','633983070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:55',0,'2014-03-02 05:59:43'),(11688,11688,'2014-01-01','ET','2',1,NULL,'Consuelo Cortez','FI','454295855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:33',0,'2014-03-02 04:59:36'),(11365,11365,'2014-01-01','ET','2',1,NULL,'Patrick Adams','FI','156789952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:29',0,'2014-03-02 04:52:44'),(11040,11040,'2014-01-01','ET','2',1,NULL,'Carolyn Marstiller','FI','282628758','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:09',0,'2014-03-10 16:03:49'),(20476,21126,'0000-00-00','ET','2',1,NULL,'Desirae Thompson','FI','281842009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:27',0,'2014-03-01 18:08:07'),(1190,1190,'2014-01-01','ET','2',1,NULL,'cheryl lunn','FI','245270502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:28',0,'2014-03-02 04:45:37'),(17450,18100,'0000-00-00','ET','2',2,1,'JOHN WIDMANN','FI','179545159','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:16',0,'2014-03-01 17:20:55'),(16851,17501,'0000-00-00','ET','2',1,NULL,'Kathleen Johns','FI','500607845','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:25',0,'2014-03-01 17:00:58'),(15513,15964,'0000-00-00','ET','2',2,1,'WALTER TROUTMAN','FI','460739664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:56',0,'2014-03-02 05:59:43'),(14481,14932,'2014-01-01','ET','2',1,NULL,'JEFFREY RAY HUGHETT','FI','295802221','HealthSpan','FI','311431434','BRADLEY  HETER','94','7285046','357','2014-02-01','Sync Success',0,'2014-01-15 02:07:44',0,'2014-03-10 14:03:26'),(11994,11994,'2014-01-01','ET','2',1,NULL,'Kenneth Pitts','FI','317828182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:01:51',0,'2014-03-02 05:03:29'),(4737,4737,'2014-01-01','ET','2',1,NULL,'Anthony Oberhaus','FI','277866182','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:02',0,'2014-03-10 13:45:57'),(11401,11401,'2014-01-01','ET','2',1,NULL,'REBECCA L COSTILOW','FI','272648406','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:36',0,'2014-03-10 16:03:49'),(19856,20506,'0000-00-00','ET','2',1,NULL,'Eileen Zink','FI','272520462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:08',0,'2014-03-10 14:37:47'),(20109,20759,'0000-00-00','ET','2',1,NULL,'Jamey Purtty','FI','302827724','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:30:27',0,'2014-03-10 16:38:05'),(21230,21880,'0000-00-00','ET','2',1,NULL,'tracy gibson','FI','458257396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-16','Sync Success',0,'2014-03-01 21:00:16',0,'2014-03-02 07:23:39'),(21754,22404,'0000-00-00','ET','2',1,NULL,'Rick L McCullough','FI','302587380','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:24',0,'2014-03-10 16:44:18'),(574,574,'2014-01-01','ET','2',1,NULL,'DIANA KOHR','FI','274542984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:47',0,'2014-03-01 15:48:04'),(1165,1165,'2014-01-01','ET','2',1,NULL,'Robert Collignon','FI','435434879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:39',0,'2014-03-02 04:38:08'),(11862,11862,'2014-01-01','ET','2',1,NULL,'jason tarulli','FI','283687776','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:13',0,'2014-03-10 16:03:49'),(7035,7035,'2014-01-01','ET','2',2,1,'NORA G RAMIREZ','FI','467961152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:36',0,'2014-03-02 03:09:49'),(21059,21709,'0000-00-00','ET','2',1,NULL,'Tonia Murphy','FI','404137128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:20',0,'2014-03-01 18:10:11'),(21379,22029,'0000-00-00','ET','2',2,1,'Mark Stephen Boteler','FI','426252493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:42',0,'2014-03-03 01:07:25'),(117,117,'2014-01-01','ET','2',4,3,'Wendy Wiandt','FI','286787972','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:34',0,'2014-03-10 15:45:56'),(18502,19152,'0000-00-00','ET','2',1,NULL,'Andrew Hruska','FI','494065266','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:32:11',0,'2014-03-10 14:31:05'),(17884,18534,'0000-00-00','ET','2',3,2,'Regina Kaye','FI','286789495','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:18',0,'2014-03-10 16:31:33'),(17098,17748,'0000-00-00','ET','2',1,NULL,'BARBARA RATLIFF','FI','286500646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:00',0,'2014-03-01 17:00:58'),(3575,3575,'2014-01-01','ET','2',1,NULL,'Stella Turner','FI','456432147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:34',0,'2014-03-02 00:10:48'),(7587,7587,'2014-01-01','ET','2',2,1,'sacha tadros','FI','328863788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:53',0,'2014-03-01 16:05:34'),(20252,20902,'0000-00-00','ET','2',1,NULL,'LINDA TRIPLETT','FI','426432441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:03',0,'2014-03-02 07:03:25'),(393,393,'2014-01-01','ET','2',2,1,'Lisa Alexander','FI','435651680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:09',0,'2014-03-01 22:10:55'),(16505,17155,'0000-00-00','ET','2',1,NULL,'Paresh Patel','FI','731072354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:40',0,'2014-03-02 06:10:30'),(15235,15686,'0000-00-00','ET','2',1,NULL,'Janet Crow','FI','435152585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:17',0,'2014-03-02 05:52:31'),(1524,1524,'2014-01-01','ET','2',1,NULL,'Glenn Durbin','FI','279684575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:12',0,'2014-03-10 16:03:49'),(5930,5930,'2014-01-01','ET','2',2,1,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:45',0,'2014-03-01 15:48:04'),(12086,12086,'2014-01-01','ET','2',1,NULL,'Burldon Jones','FI','299863607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:15',0,'2014-03-01 16:30:17'),(21649,22299,'0000-00-00','ET','2',1,NULL,'joyce stewart','FI','293722920','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:58',0,'2014-03-04 21:36:30'),(11998,11998,'2014-01-01','ET','2',1,NULL,'SHAUN FERRELL','FI','272768407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:01:59',0,'2014-03-10 16:10:34'),(11737,11737,'2014-01-01','ET','2',1,NULL,'DEBORAH WARNER','FI','268700613','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:02',0,'2014-03-01 16:30:17'),(7742,7742,'2014-01-01','ET','2',1,NULL,'Sandra L Campbell','FI','285667579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:36',0,'2014-03-01 15:05:09'),(17603,18253,'0000-00-00','ET','2',1,NULL,'Alec Houck','FI','638245909','Starmount Life Insurance Company','FI','720977315','John  Holmes','94','1144517','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:05',0,'2014-03-02 06:31:45'),(5646,5646,'2014-01-01','ET','2',1,NULL,'ELIZABETH GODSEY','FI','293760136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:11',0,'2014-03-10 13:52:32'),(3188,3188,'2014-01-01','ET','2',1,NULL,'Thomas Vondenhuevel','FI','281928428','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:09',0,'2014-03-10 13:24:34'),(15845,16494,'0000-00-00','ET','2',2,1,'John E Bodeker','FI','301506070','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:37',0,'2014-03-01 16:56:22'),(15609,16060,'0000-00-00','ET','2',1,NULL,'Leon Huton','FI','123682635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:40',0,'2014-03-02 05:59:43'),(15424,15875,'0000-00-00','ET','2',4,3,'Karen McCoy','FI','157729287','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:25',0,'2014-03-01 16:50:53'),(15380,15831,'0000-00-00','ET','2',1,NULL,'JENNETTE KNIGHT','FI','434155035','Starmount Life Insurance Company','FI','720977315','JOHN T ALLEN','94','4728680','348','2014-03-01','Sync Success',1,'2014-01-22 03:21:56',0,'2014-03-02 05:59:43'),(19460,20110,'0000-00-00','ET','2',2,1,'Valentin Vargas','FI','457592053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:46:31',0,'2014-03-02 06:59:07'),(19736,20386,'0000-00-00','ET','2',2,1,'BIPIN R PATEL','FI','314112645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:39:02',0,'2014-03-10 14:37:47'),(19949,20599,'0000-00-00','ET','2',1,NULL,'Diana Elliott','FI','456941603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:15',0,'2014-03-02 07:03:25'),(20509,21159,'0000-00-00','ET','2',1,NULL,'roberta Morehouse','FI','484720776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:48',0,'2014-03-02 07:17:36'),(20942,21592,'0000-00-00','ET','2',1,NULL,'Wendy Barnett','FI','290742136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:34',0,'2014-03-10 16:38:05'),(12335,12335,'2014-01-01','ET','2',2,1,'AUBREY FICKEL','FI','633090835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:25',0,'2014-03-02 05:03:29'),(2466,2466,'2014-01-01','ET','2',1,NULL,'Shirley Bennett','FI','437907590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:24',0,'2014-03-01 23:10:52'),(7099,7099,'2014-01-01','ET','2',1,NULL,'LINDA LINER','FI','160460322','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:03:35',0,'2014-03-01 15:52:44'),(6139,6139,'2014-01-01','ET','2',1,NULL,'jack ransom','FI','279525553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:30',0,'2014-03-01 16:00:27'),(4233,4233,'2014-01-01','ET','2',1,NULL,'Janelle Gellermann','FI','483860072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:14',0,'2014-03-01 16:00:27'),(5714,5714,'2014-01-01','ET','2',1,NULL,'Katrina Miller','FI','284861346','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:54',0,'2014-03-01 15:37:30'),(5992,5992,'2014-01-01','ET','2',4,3,'Kyrie Lee','FI','273861597','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:43',0,'2014-03-10 13:24:34'),(13507,13863,'2014-01-01','ET','2',1,NULL,'Karla Ingram','FI','463880028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:21',0,'2014-03-02 05:31:31'),(11037,11037,'2014-01-01','ET','2',1,NULL,'moses earl willoughby','FI','578849851','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:01',0,'2014-03-10 16:03:49'),(16221,16870,'0000-00-00','ET','2',1,NULL,'Erin Malone','FI','635071150','Starmount Life Insurance Company','FI','720977315','Humayun  Afzal','94','1307168','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:53',0,'2014-03-02 06:10:30'),(6448,6448,'2014-01-01','ET','2',1,NULL,'Rhonda Hertel','FI','452457414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:01',0,'2014-03-01 20:10:57'),(4488,4488,'2014-01-01','ET','2',1,NULL,'Marilyn Hepler','FI','279545061','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:40',0,'2014-03-10 15:39:19'),(5273,5273,'2014-01-01','ET','2',1,NULL,'James Robert Adams','FI','618409493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:26',0,'2014-03-01 20:10:57'),(2655,2655,'2014-01-01','ET','2',1,NULL,'Thomas Solmo','FI','267273676','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:34',0,'2014-03-01 16:05:34'),(2247,2247,'2014-01-01','ET','2',1,NULL,'Timothy Brown','FI','280887292','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:49',0,'2014-03-10 13:10:24'),(20058,20708,'0000-00-00','ET','2',1,NULL,'PENNY KERVIN','FI','445549990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:17',0,'2014-03-02 07:10:28'),(21007,21657,'0000-00-00','ET','2',1,NULL,'tarah malano','FI','336725057','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:05',0,'2014-03-02 07:23:39'),(23078,23728,'0000-00-00','ET','2',2,1,'Karl Fink','FI','269848427','HealthSpan','FI','311431434','Deborah  GAZEY','94','2341750','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:50',0,'2014-03-10 21:17:52'),(11550,11550,'2014-01-01','ET','2',1,NULL,'Martin Bebout','FI','463238866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:09',0,'2014-03-02 04:52:44'),(18597,19247,'0000-00-00','ET','2',1,NULL,'walter mahovlich','FI','283527632','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:32',0,'2014-03-01 17:26:36'),(11521,11521,'2014-01-01','ET','2',1,NULL,'Nikia Beatrice Williams','FI','439473350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:16',0,'2014-03-02 04:52:44'),(4750,4750,'2014-01-01','ET','2',1,NULL,'April Brown','FI','438671252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:17',0,'2014-03-01 21:11:04'),(7280,7280,'2014-01-01','ET','2',2,1,'Dwight Lewis','FI','272808101','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:06',0,'2014-03-10 13:32:15'),(10500,10500,'2014-01-01','ET','2',2,1,'Robert A Markowitz','FI','302468387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:54',0,'2014-03-01 16:15:39'),(11141,11141,'2014-01-01','ET','2',1,NULL,'Gary Cornette','FI','295548962','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-26 13:15:38',0,'2014-03-10 13:45:57'),(16628,17278,'0000-00-00','ET','2',1,NULL,'RAYMOND GUERRERO','FI','381982278','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:27',0,'2014-03-02 06:17:30'),(23093,23743,'0000-00-00','ET','2',1,NULL,'CAROLYN BRUMBAUGH','FI','281482976','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:03:03',0,'2014-03-10 21:17:52'),(5977,5977,'2014-01-01','ET','2',1,NULL,'Karen Kline','FI','299427816','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:15',0,'2014-03-10 15:52:36'),(14684,15135,'2014-01-01','ET','2',2,1,'Shannon Reynolds','FI','407748275','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:44',0,'2014-03-01 16:46:19'),(1291,1291,'2014-01-01','ET','2',1,NULL,'Michael Howell','FI','426259765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:30',0,'2014-03-02 04:38:08'),(2753,2753,'2014-01-01','ET','2',1,NULL,'Rebecca Johnson','FI','463937247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:50',0,'2014-03-02 04:15:49'),(13504,13860,'2014-01-01','ET','2',1,NULL,'Alivia McEldowney','FI','233390980','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:19',0,'2014-03-02 05:24:45'),(11108,11108,'2014-01-01','ET','2',1,NULL,'karen sherburne','94','0000793469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:22',0,'2014-03-10 13:39:10'),(2158,2158,'2014-01-01','ET','2',1,NULL,'Sara Pardo','FI','273889991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:43',0,'2014-03-01 15:16:37'),(16181,16830,'0000-00-00','ET','2',1,NULL,'karen minotti','FI','293645631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:26',0,'2014-03-01 16:56:22'),(18687,19337,'0000-00-00','ET','2',1,NULL,'SILVIA NELLY PEREZ','FI','465272393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:42',0,'2014-03-02 06:45:14'),(19433,20083,'0000-00-00','ET','2',1,NULL,'Jason Vandriver','FI','451916272','Starmount Life Insurance Company','FI','720977315','justin  leblanc','94','8485121','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:33',0,'2014-03-02 06:59:07'),(19452,20102,'0000-00-00','ET','2',1,NULL,'JAMES LASSITTER','FI','263338620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:42:18',0,'2014-03-02 06:59:07'),(20929,21579,'0000-00-00','ET','2',2,1,'Baylor Looper Jewell','FI','435907159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:20',0,'2014-03-02 07:17:36'),(21691,22341,'0000-00-00','ET','2',1,NULL,'Jacob Ramos','94','0001036189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:31',0,'2014-03-04 21:36:30'),(6324,6324,'2014-01-01','ET','2',1,NULL,'Deborah Golub','FI','276825352','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:07',0,'2014-03-10 15:59:47'),(14820,15271,'2014-01-01','ET','2',2,1,'LISA AYERS','FI','274805391','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:12',0,'2014-03-10 14:03:26'),(14038,14394,'2014-01-01','ET','2',1,NULL,'Dustin carrizales','FI','634200464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:58',0,'2014-03-02 05:31:31'),(3715,3715,'2014-01-01','ET','2',1,NULL,'karen werline','FI','272507532','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:02',0,'2014-03-10 13:20:27'),(13231,13587,'2014-01-01','ET','2',1,NULL,'SUGUNA RAJU','FI','428023314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:19',0,'2014-03-02 05:17:40'),(11950,11950,'2014-01-01','ET','2',1,NULL,'mario iturralde','FI','461593211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:12',0,'2014-03-02 04:59:36'),(11901,11901,'2014-01-01','ET','2',1,NULL,'Patricia Lee Barnett','FI','235940378','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:04',0,'2014-03-10 16:10:34'),(10675,10675,'2014-01-01','ET','2',1,NULL,'Takeesha Carter','FI','198544888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:35',0,'2014-03-01 16:10:36'),(15757,16406,'0000-00-00','ET','2',1,NULL,'Jerry Lewis','FI','425081308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:27',0,'2014-03-02 05:59:43'),(15973,16622,'0000-00-00','ET','2',1,NULL,'QUINTIN  BRIDGES','FI','438259465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:18',0,'2014-03-02 06:03:21'),(16318,16968,'0000-00-00','ET','2',1,NULL,'Nancy Wilson','FI','593165898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-29 21:00:35',0,'2014-03-01 16:56:22'),(18206,18856,'0000-00-00','ET','2',1,NULL,'Jessica Mullen','FI','288828549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:01:58',0,'2014-03-01 17:26:36'),(19035,19685,'0000-00-00','ET','2',1,NULL,'Shannon Neal','FI','284769659','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-15 21:00:08',0,'2014-03-10 14:31:05'),(20371,21021,'0000-00-00','ET','2',1,NULL,'lucas groh','FI','270881451','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:56',0,'2014-03-10 14:37:47'),(20545,21195,'0000-00-00','ET','2',1,NULL,'Samar Diab','FI','461772669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:13',0,'2014-03-02 07:17:36'),(1265,1265,'2014-01-01','ET','2',1,NULL,'JEFF MCCLURG','FI','293627873','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:39',0,'2014-03-01 16:15:39'),(5077,5077,'2014-01-01','ET','2',2,1,'Jeffery Rodriguez','FI','272603687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:28',0,'2014-03-01 15:31:33'),(11281,11281,'2014-01-01','ET','2',1,NULL,'Trimeca Smith','FI','436599587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:02:56',0,'2014-03-02 04:52:44'),(12646,12646,'2014-01-01','ET','2',1,NULL,'Kristine E Shull','FI','533984718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:47',0,'2014-03-02 05:10:52'),(14216,14667,'2014-01-01','ET','2',2,1,'Pamela Baker','FI','298428637','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:51',0,'2014-03-10 14:03:26'),(4015,4015,'2014-01-01','ET','2',1,NULL,'Barbara Rena Stevenson','FI','467517645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:35',0,'2014-03-02 03:09:49'),(10654,10654,'2014-01-01','ET','2',1,NULL,'Linda Wynns','FI','446521441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:56',0,'2014-03-02 04:31:46'),(10901,10901,'2014-01-01','ET','2',1,NULL,'Tomika Sterling','FI','229497171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:40',0,'2014-03-02 04:24:47'),(12404,12404,'2014-01-01','ET','2',1,NULL,'Laura Mae Bengston','FI','277442846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:47',0,'2014-03-01 16:35:14'),(11492,11492,'2014-01-01','ET','2',1,NULL,'Darren Loli','FI','591584172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:25',0,'2014-03-02 04:52:44'),(22102,22752,'0000-00-00','ET','2',1,NULL,'Geremy Nance','FI','628280098','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:31',0,'2014-03-06 21:27:26'),(22350,23000,'0000-00-00','ET','2',1,NULL,'JANET JW SMITH','FI','412023145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-07 21:00:12',0,'2014-03-07 21:36:32'),(229,229,'2014-01-01','ET','2',2,1,'Maria Reyna','FI','465877633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:11',0,'2014-03-01 19:11:03'),(14300,14751,'2014-01-01','ET','2',2,1,'Stephen Wherry','FI','465067068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:24',0,'2014-03-02 05:38:34'),(2570,2570,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:16',0,'2014-03-10 13:03:33'),(13470,13826,'2014-01-01','ET','2',1,NULL,'Sharon Winer','FI','278545130','Summa Insurance Company, Inc.','FI','341809108','Tim  Walters','94','1852658','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:32',0,'2014-03-10 16:17:47'),(12680,12680,'2014-01-01','ET','2',1,NULL,'Moriah Leanne Stutler','FI','273901597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:00',0,'2014-03-01 16:35:14'),(7608,7608,'2014-01-01','ET','2',1,NULL,'Courtney Lee Armentrout','FI','276942058','Summa Insurance Company, Inc.','FI','341809108','William James Mcilroy','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-26 04:37:31',0,'2014-03-10 15:59:47'),(7159,7159,'2014-01-01','ET','2',1,NULL,'Melodie Rose Kinzel','FI','274544101','Summa Insurance Company, Inc.','FI','341809108','Mark A Herwick','94','7462692','348','2014-01-01','Sync Success',0,'2013-12-26 04:05:22',0,'2014-03-10 15:59:47'),(3106,3106,'2014-01-01','ET','2',1,NULL,'James Bergeron','FI','439949696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:21',0,'2014-03-02 01:10:33'),(16342,16992,'0000-00-00','ET','2',1,NULL,'Leslie  Cooper','FI','270708435','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:49',0,'2014-03-01 16:56:22'),(16408,17058,'0000-00-00','ET','2',1,NULL,'Michelle Stiles','FI','296888279','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:01:32',0,'2014-03-10 16:24:30'),(16502,17152,'0000-00-00','ET','2',1,NULL,'Edgar Govea','FI','644206349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:38',0,'2014-03-02 06:10:30'),(17812,18462,'0000-00-00','ET','2',1,NULL,'keith handy','FI','426358722','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:44',0,'2014-03-02 06:03:21'),(7006,7006,'2014-01-01','ET','2',1,NULL,'Frank Robinson','FI','262476844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:41',0,'2014-03-02 03:09:49'),(14688,15139,'2014-01-01','ET','2',1,NULL,'Patrick Obrien','FI','436270380','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:47',0,'2014-03-02 05:45:37'),(1691,1691,'2014-01-01','ET','2',1,NULL,'Carla Patrick','FI','277666448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:13',0,'2014-03-01 15:31:33'),(13784,14140,'2014-01-01','ET','2',1,NULL,'Therese Watkins','FI','281821254','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:36',0,'2014-03-10 13:59:38'),(4240,4240,'2014-01-01','ET','2',1,NULL,'Lisa Thornton','FI','268840778','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:30',0,'2014-03-10 15:59:47'),(20743,21393,'0000-00-00','ET','2',1,NULL,'veronica Flannigan','FI','275926906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:32',0,'2014-03-01 18:10:11'),(21590,22240,'0000-00-00','ET','2',1,NULL,'BARBARA V BARBER','FI','436847032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:12',0,'2014-03-04 21:27:16'),(4735,4735,'2014-01-01','ET','2',2,1,'Milojka Stanic','FI','286067310','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:57',0,'2014-03-10 13:45:57'),(12161,12161,'2014-01-01','ET','2',1,NULL,'JOANN HUTCHINSON','FI','282522270','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:49',0,'2014-03-10 13:52:32'),(11302,11302,'2014-01-01','ET','2',1,NULL,'Monica Marie Chapa','FI','453999138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:35',0,'2014-03-02 04:45:37'),(11280,11280,'2014-01-01','ET','2',1,NULL,'Sean Murphy','FI','436596443','Starmount Life Insurance Company','FI','720977315','THOMAS  KLOTZ','94','2766547','348','2014-02-01','Sync Success',0,'2013-12-27 02:02:54',0,'2014-03-02 04:52:44'),(3525,3525,'2014-01-01','ET','2',1,NULL,'Matthew Alan Hanzel','FI','277887924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:59',0,'2014-03-01 15:31:33'),(19997,20647,'0000-00-00','ET','2',4,3,'Edward Thrasher','94','0000471066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:50',0,'2014-03-01 17:47:19'),(5136,5136,'2014-01-01','ET','2',1,NULL,'JOHN MARTIN JANOVEC','FI','293421878','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:24',0,'2014-03-10 15:45:56'),(1572,1572,'2014-01-01','ET','2',1,NULL,'Shelly Lane','FI','467495514','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:21',0,'2014-03-01 20:10:57'),(12801,12801,'2014-01-01','ET','2',2,1,'David Coleman','FI','463370350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:18',0,'2014-03-02 05:10:52'),(13247,13603,'2014-01-01','ET','2',1,NULL,'Nichelle Carter','FI','437154596','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-07 10:22:57',0,'2014-03-02 05:17:40'),(16365,17015,'0000-00-00','ET','2',1,NULL,'JODI  DICKINSON','FI','293683275','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:03',0,'2014-03-10 16:24:30'),(19037,19687,'0000-00-00','ET','2',1,NULL,'SAMANTHA HARRIS','FI','436678192','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:10',0,'2014-03-10 14:31:05'),(19437,20087,'0000-00-00','ET','2',1,NULL,'Jerry Bryant','FI','330643108','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:36',0,'2014-03-10 14:31:05'),(20068,20718,'0000-00-00','ET','2',2,1,'SHAWN SATURDAY','FI','297729139','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:25',0,'2014-03-01 18:08:07'),(21432,22082,'0000-00-00','ET','2',2,1,'HENRY WEBB','FI','435825706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:04',0,'2014-03-03 22:26:43'),(21773,22423,'0000-00-00','ET','2',1,NULL,'qiao zheng','FI','054945151','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:02:40',0,'2014-03-10 14:45:25'),(7178,7178,'2014-01-01','ET','2',1,NULL,'Erik Duncan','FI','294785494','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:58',0,'2014-03-10 15:59:47'),(14476,14927,'2014-01-01','ET','2',1,NULL,'LINDA LOU MARTIN','FI','300447017','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:41',0,'2014-03-10 16:17:47'),(11236,11236,'2014-01-01','ET','2',1,NULL,'Suzanne Hartwick','FI','274983722','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:32',0,'2014-03-01 16:23:43'),(10785,10785,'2014-01-01','ET','2',1,NULL,'Gregory Gunther','FI','218069809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:24',0,'2014-03-02 04:24:47'),(7648,7648,'2014-01-01','ET','2',1,NULL,'rodney Harsh','FI','279701564','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:46',0,'2014-03-10 13:39:10'),(7055,7055,'2014-01-01','ET','2',1,NULL,'BEVERLY LANGLEY','FI','467451225','Starmount Life Insurance Company','FI','720977315','LINDA  CARTER','94','1033689','348','2014-01-01','Sync Success',0,'2013-12-26 04:02:10',0,'2014-03-02 03:09:49'),(4552,4552,'2014-01-01','ET','2',1,NULL,'Charles Wiegand','FI','625201707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:46',0,'2014-03-02 04:31:46'),(2925,2925,'2014-01-01','ET','2',1,NULL,'ANGELA SANDLIN','FI','282626901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:45',0,'2014-03-01 15:37:30'),(3367,3367,'2014-01-01','ET','2',1,NULL,'Rex Alton Falkenberg','FI','449969328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:39',0,'2014-03-02 02:10:49'),(6051,6051,'2014-01-01','ET','2',2,1,'Christopher Estridge','FI','404290349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:37',0,'2014-03-01 15:10:22'),(17842,18492,'0000-00-00','ET','2',1,NULL,'mahmoud yassine','FI','293119523','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:08',0,'2014-03-10 16:24:30'),(20104,20754,'0000-00-00','ET','2',2,1,'MARVIN FOWLER','FI','436258472','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:23',0,'2014-03-02 07:10:28'),(22272,22922,'0000-00-00','ET','2',1,NULL,'PATRICK J KNAPP','FI','296623370','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-06 21:02:33',0,'2014-03-10 14:45:25'),(441,441,'2014-01-01','ET','2',1,NULL,'Lee Brooker','FI','288549784','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:41',0,'2014-03-10 15:45:56'),(15701,16350,'0000-00-00','ET','2',1,NULL,'Lela Pruett','FI','452258374','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:48',0,'2014-03-02 05:59:43'),(15507,15958,'0000-00-00','ET','2',1,NULL,'LEWIS GOTTLIEB','FI','453213519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-23 03:01:54',0,'2014-03-02 05:59:43'),(970,970,'2014-01-01','ET','2',1,NULL,'Robert Cryder','FI','300841665','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:17',0,'2014-03-10 13:10:24'),(4055,4055,'2014-01-01','ET','2',1,NULL,'NOEL M NAIZER','FI','631031926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:50',0,'2014-03-02 04:10:25'),(22015,22665,'0000-00-00','ET','2',1,NULL,'APRIL SUTTON','FI','284703587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:02',0,'2014-03-05 21:36:22'),(22874,23524,'0000-00-00','ET','2',1,NULL,'George Boyd','FI','456904050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:20',0,'2014-03-10 21:27:11'),(5843,5843,'2014-01-01','ET','2',1,NULL,'SHARLENE ANNETTE ROSE','FI','556042401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:52',0,'2014-03-01 15:10:22'),(16035,16684,'0000-00-00','ET','2',1,NULL,'Gladys Ordonez','FI','439992513','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:33',0,'2014-03-02 06:03:21'),(10531,10531,'2014-01-01','ET','2',1,NULL,'Susan Rebecca Dunn','FI','457046230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:51',0,'2014-03-02 04:24:47'),(19893,20543,'0000-00-00','ET','2',2,1,'MANDY RINNER','FI','274788332','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:40',0,'2014-03-10 14:37:47'),(22605,23255,'0000-00-00','ET','2',4,3,'Jeffrey R Henderson','FI','273907879','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:26',0,'2014-03-10 14:50:59'),(6011,6011,'2014-01-01','ET','2',1,NULL,'Jason Groth','FI','507820186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:15',0,'2014-03-01 15:10:22'),(15790,16439,'0000-00-00','ET','2',2,1,'SOCORRO  ROMERO','FI','641381279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:06',0,'2014-03-02 06:03:21'),(12886,12886,'2014-01-01','ET','2',1,NULL,'TIMOTHY POWELL','FI','426734556','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:23',0,'2014-03-02 05:10:52'),(14816,15267,'2014-01-01','ET','2',1,NULL,'ALEXANDER  MENASSA','FI','270708889','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:08',0,'2014-03-10 16:17:47'),(4253,4253,'2014-01-01','ET','2',1,NULL,'James Young','FI','289505676','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:07:55',0,'2014-03-10 13:32:15'),(10852,10852,'2014-01-01','ET','2',1,NULL,'James Pemberton','FI','283826220','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:05:35',0,'2014-03-10 13:45:57'),(16651,17301,'0000-00-00','ET','2',1,NULL,'DAWANDA KEMP','FI','433718706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:41',0,'2014-03-02 06:17:30'),(17886,18536,'0000-00-00','ET','2',1,NULL,'Terri Smith','FI','281587399','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:20',0,'2014-03-10 16:31:33'),(19621,20271,'0000-00-00','ET','2',1,NULL,'Jordan Conti','FI','299846606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:58',0,'2014-03-01 17:47:19'),(19795,20445,'0000-00-00','ET','2',1,NULL,'Latonya Walker','FI','436750404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:19',0,'2014-03-02 07:03:25'),(3116,3116,'2014-01-01','ET','2',1,NULL,'LaKisha Williams','FI','287888848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:36:41',0,'2014-03-10 15:52:36'),(4342,4342,'2014-01-01','ET','2',1,NULL,'Sharon K Rhoades','FI','274449739','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:32',0,'2014-03-10 13:32:15'),(7468,7468,'2014-01-01','ET','2',1,NULL,'Shannon Woodruff','FI','437820489','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:54',0,'2014-03-02 04:15:49'),(15532,15983,'0000-00-00','ET','2',2,1,'MARIA D VASQUEZ','FI','455834600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:05',0,'2014-03-02 05:59:43'),(16075,16724,'0000-00-00','ET','2',1,NULL,'Oscar Dickerson','FI','275743814','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:00',0,'2014-03-01 16:56:22'),(17195,17845,'0000-00-00','ET','2',2,1,'Thomas Alexander','FI','277466738','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:00:07',0,'2014-03-10 14:24:38'),(18859,19509,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:32',0,'2014-03-01 17:34:07'),(19436,20086,'0000-00-00','ET','2',3,2,'Scott Carper','FI','285620375','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:35',0,'2014-03-10 16:31:33'),(22447,23097,'0000-00-00','ET','2',1,NULL,'Kim Lundgren','FI','321441432','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:33',0,'2014-03-07 22:26:59'),(289,289,'2014-01-01','ET','2',1,NULL,'Christopher Gray','FI','438613884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:18',0,'2014-03-01 19:11:03'),(3286,3286,'2014-01-01','ET','2',1,NULL,'Nicholas Moss','FI','278846634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:00',0,'2014-03-01 15:48:04'),(12548,12548,'2014-01-01','ET','2',1,NULL,'danette harrison','FI','299601835','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:11',0,'2014-03-10 13:59:38'),(853,853,'2014-01-01','ET','2',1,NULL,'CARLOS FRANCISCO GAONA','FI','459437071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:44',0,'2014-03-01 22:10:55'),(371,371,'2014-01-01','ET','2',1,NULL,'DEBRA RAMEY','FI','270709350','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 17:47:26',0,'2014-03-10 13:10:24'),(11248,11248,'2014-01-01','ET','2',1,NULL,'Baruch Puplampu','FI','269703018','Dental Care Plus, Inc.','FI','311185262','Rick  McClelland','94','2444519','348','2014-02-01','Sync Success',0,'2013-12-27 02:01:55',0,'2014-03-01 16:23:43'),(1814,1814,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:20:04',0,'2014-03-10 13:20:27'),(20879,21529,'0000-00-00','ET','2',1,NULL,'JOANN HUTCHINSON','FI','282522270','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:31:35',0,'2014-03-10 14:37:47'),(21155,21805,'0000-00-00','ET','2',1,NULL,'DENISE COLEMAN','FI','436946922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:24',0,'2014-03-02 07:23:39'),(22080,22730,'0000-00-00','ET','2',1,NULL,'EDUARDO CASTILLO','FI','463888200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:14',0,'2014-03-06 21:27:26'),(7407,7407,'2014-01-01','ET','2',1,NULL,'KEITH JOHNSON','FI','438984587','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:05',0,'2014-03-02 04:10:25'),(15050,15501,'2014-01-01','ET','2',1,NULL,'Lawrence Untch','FI','297466340','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:31',0,'2014-03-10 16:17:47'),(2754,2754,'2014-01-01','ET','2',1,NULL,'Gary Rayford','FI','436864641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:18:52',0,'2014-03-02 04:15:49'),(6220,6220,'2014-01-01','ET','2',1,NULL,'Thomas Blank','FI','163468682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:55',0,'2014-03-01 16:00:27'),(12815,12815,'2014-01-01','ET','2',1,NULL,'Shelly Tigler','FI','439905530','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:49',0,'2014-03-02 05:10:52'),(13047,13403,'2014-01-01','ET','2',1,NULL,'VIRGIE JONES','FI','433114138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:00',0,'2014-03-02 05:17:40'),(15810,16459,'0000-00-00','ET','2',1,NULL,'Melanie Bolton','FI','639039639','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:17',0,'2014-03-02 06:03:21'),(17276,17926,'0000-00-00','ET','2',1,NULL,'Maria Fraga','FI','640806501','Starmount Life Insurance Company','FI','720977315','james  hermosa','94','15914416','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:43',0,'2014-03-02 06:24:38'),(22994,23644,'0000-00-00','ET','2',1,NULL,'Karen Emery','FI','369564919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:46',0,'2014-03-10 21:36:25'),(1008,1008,'2014-01-01','ET','2',1,NULL,'Karen Brophy','FI','281669100','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:31',0,'2014-03-10 15:39:19'),(14531,14982,'2014-01-01','ET','2',1,NULL,'ashley renaud','FI','300925944','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:08:08',0,'2014-03-10 16:17:47'),(6365,6365,'2014-01-01','ET','2',2,1,'JAMES PAUL ZELLER','FI','286463464','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:22',0,'2014-03-10 15:59:47'),(10502,10502,'2014-01-01','ET','2',1,NULL,'Debra Robinson','FI','185507380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:53:57',0,'2014-03-01 16:15:39'),(4442,4442,'2014-01-01','ET','2',1,NULL,'Ravone A Smith','FI','434752794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:08',0,'2014-03-01 21:11:04'),(16898,17548,'0000-00-00','ET','2',1,NULL,'jason valenzuela','FI','451632267','Starmount Life Insurance Company','FI','720977315','fernando  orozco','94','1498597','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:25',0,'2014-03-02 06:24:38'),(45,45,'2014-01-01','ET','2',1,NULL,'Norma Vaughn','FI','457235850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:16:21',0,'2014-03-01 22:10:55'),(15083,15534,'0000-00-00','ET','2',2,1,'RENE G HUFFMAN','FI','262611417','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:37',0,'2014-03-01 16:50:53'),(14640,15091,'2014-01-01','ET','2',1,NULL,'Cenell Munford-Clark','FI','275862007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:13',0,'2014-03-01 16:46:19'),(1175,1175,'2014-01-01','ET','2',1,NULL,'Paul Williams','FI','439436459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:59',0,'2014-03-02 04:38:08'),(14094,14545,'2014-01-01','ET','2',1,NULL,'JENNIFER CHAPMAN','FI','457134080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:31',0,'2014-03-02 05:38:34'),(13127,13483,'2014-01-01','ET','2',1,NULL,'LAURA MACEIUNAS','FI','463419977','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:01',0,'2014-03-02 05:17:40'),(12445,12445,'2014-01-01','ET','2',1,NULL,'Mallory Prevost','FI','428657449','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:19',0,'2014-03-02 05:03:29'),(1684,1684,'2014-01-01','ET','2',1,NULL,'Linda Tanner','FI','232886147','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:58',0,'2014-03-01 15:31:33'),(20562,21212,'0000-00-00','ET','2',1,NULL,'ROBERTO ALVIAR','FI','451176718','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:25',0,'2014-03-02 07:17:36'),(21766,22416,'0000-00-00','ET','2',1,NULL,'DAVID K ANDRES','FI','302443393','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:34',0,'2014-03-10 14:45:25'),(21846,22496,'0000-00-00','ET','2',1,NULL,'Christina Park','FI','590892417','Starmount Life Insurance Company','FI','720977315','Sheila  Laraee','94','16121043','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:03',0,'2014-03-05 22:27:33'),(4881,4881,'2014-01-01','ET','2',2,1,'sam l butorsky','FI','179602197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:39',0,'2014-03-01 20:10:57'),(15004,15455,'2014-01-01','ET','2',1,NULL,'Kay Steiner','FI','300449617','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:12',0,'2014-03-10 16:17:47'),(14913,15364,'2014-01-01','ET','2',2,1,'Randall Dwillis','FI','288646827','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:29',0,'2014-03-01 16:50:53'),(4563,4563,'2014-01-01','ET','2',1,NULL,'LaKendrial Edwards','FI','436594107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:07',0,'2014-03-02 04:38:08'),(1051,1051,'2014-01-01','ET','2',1,NULL,'melissa reynaud','FI','439435325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:19',0,'2014-03-01 21:11:04'),(3133,3133,'2014-01-01','ET','2',1,NULL,'SCHOSKEY MILO','FI','436045692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:12',0,'2014-03-02 01:10:33'),(10957,10957,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:24',0,'2014-03-10 16:03:49'),(4122,4122,'2014-01-01','ET','2',1,NULL,'SUSAN HULS','FI','280500576','Dental Care Plus, Inc.','FI','311185262','DARWIN  CARMISHAEL','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-25 23:03:53',0,'2014-03-01 16:00:27'),(4204,4204,'2014-01-01','ET','2',1,NULL,'Evon Perkins','FI','587540088','Starmount Life Insurance Company','FI','720977315','Jeffrey  Chance','94','2114967','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:22',0,'2014-03-02 03:09:49'),(16351,17001,'0000-00-00','ET','2',1,NULL,'mary anne banning','FI','276461161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:55',0,'2014-03-01 16:56:22'),(16439,17089,'0000-00-00','ET','2',1,NULL,'virgnia day','FI','269568353','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:51',0,'2014-03-10 14:20:26'),(18522,19172,'0000-00-00','ET','2',1,NULL,'Theresa Gwiner','FI','297568820','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:26',0,'2014-03-10 14:24:38'),(637,637,'2014-01-01','ET','2',1,NULL,'Carl Chapin','FI','458253694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:04:49',0,'2014-03-02 02:10:49'),(6206,6206,'2014-01-01','ET','2',2,1,'MICHAEL DZIAK','FI','270689680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:30',0,'2014-03-01 16:00:27'),(6199,6199,'2014-01-01','ET','2',1,NULL,'Daniel Crawford','FI','272442348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:19',0,'2014-03-01 16:00:27'),(13978,14334,'2014-01-01','ET','2',1,NULL,'Danyeil Hoy','FI','350809223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:14',0,'2014-03-02 05:31:31'),(12676,12676,'2014-01-01','ET','2',1,NULL,'Deborah Brown','FI','281544576','Dental Care Plus, Inc.','FI','311185262','Donna M Boggs','94','4684184','348','2014-02-01','Sync Success',0,'2014-01-03 02:03:53',0,'2014-03-01 16:35:14'),(12534,12534,'2014-01-01','ET','2',1,NULL,'Janet Vann','FI','515606828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:34:35',0,'2014-03-02 05:03:29'),(3862,3862,'2014-01-01','ET','2',1,0,'John Farmer','FI','436737329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:59',0,'2014-03-01 19:11:03'),(4135,4135,'2014-01-01','ET','2',1,NULL,'Richard Stacy','FI','301489114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:04:15',0,'2014-03-01 16:00:27'),(2505,2505,'2014-01-01','ET','2',1,0,'Jarred Blackshear','FI','629013534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:12',0,'2014-03-01 19:11:03'),(4190,4190,'2014-01-01','ET','2',1,NULL,'Melba Abufhele','FI','590447188','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:05:57',0,'2014-03-10 15:59:47'),(15117,15568,'0000-00-00','ET','2',1,NULL,'barbara johnson','FI','297720569','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-20 08:06:02',0,'2014-03-01 16:50:53'),(15062,15513,'2014-01-01','ET','2',1,NULL,'Donna Perkins','FI','293548650','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-01-17 03:36:37',0,'2014-03-10 14:10:12'),(2299,2299,'2014-01-01','ET','2',1,NULL,'Clarence Simmons','FI','457967122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:10',0,'2014-03-01 19:11:03'),(12222,12222,'2014-01-01','ET','2',1,NULL,'Cory Catchings','FI','587617905','Starmount Life Insurance Company','FI','720977315','Larry  Smith','94','7475935','348','2014-02-01','Sync Success',1,'2014-01-02 04:22:19',0,'2014-03-02 05:10:52'),(2441,2441,'2014-01-01','ET','2',1,NULL,'Martha Watkins','FI','283484119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:32',0,'2014-03-10 15:45:56'),(11371,11371,'2014-01-01','ET','2',1,NULL,'Elizabeth Martin','FI','438818572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:40',0,'2014-03-02 04:45:37'),(18086,18736,'0000-00-00','ET','2',1,NULL,'DALE GALLAGHER','FI','437829304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:28',0,'2014-03-02 06:38:05'),(18433,19083,'0000-00-00','ET','2',1,NULL,'Deborah Young','FI','272564373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:27',0,'2014-03-01 17:26:36'),(22068,22718,'0000-00-00','ET','2',1,NULL,'michael harris','FI','282508482','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:32:42',0,'2014-03-10 14:45:25'),(7491,7491,'2014-01-01','ET','2',1,NULL,'MARY  HAWKE','FI','567155640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:44',0,'2014-03-01 16:05:34'),(7395,7395,'2014-01-01','ET','2',4,3,'Laura Arkus','FI','291684008','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:41',0,'2014-03-10 13:39:10'),(7166,7166,'2014-01-01','ET','2',1,NULL,'anthony  healy','94','0001055305','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:33',0,'2014-03-10 15:59:47'),(13719,14075,'2014-01-01','ET','2',2,1,'MARTIN ARMSTRONG','FI','435496189','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:53',0,'2014-03-02 05:24:45'),(12856,12856,'2014-01-01','ET','2',1,NULL,'KELI CATALANO','FI','314902659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:19',0,'2014-03-01 16:35:14'),(12749,12749,'2014-01-01','ET','2',1,NULL,'Kim Reed','FI','426257901','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:40',0,'2014-03-02 05:10:52'),(12429,12429,'2014-01-01','ET','2',1,NULL,'Marquis Heckard','FI','458670454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:43',0,'2014-03-02 05:03:29'),(11709,11709,'2014-01-01','ET','2',1,NULL,'Shannyn Taggart','FI','464911638','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:09',0,'2014-03-02 04:59:36'),(5802,5802,'2014-01-01','ET','2',4,3,'kevin dobbs','FI','418906944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:36',0,'2014-03-02 01:10:33'),(11436,11436,'2014-01-01','ET','2',1,NULL,'LINDA CARDENAS','FI','281541024','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:44',0,'2014-03-10 13:52:32'),(4898,4898,'2014-01-01','ET','2',1,NULL,'Quentin Lay','FI','279887550','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:03',0,'2014-03-01 15:05:09'),(15706,16355,'0000-00-00','ET','2',1,NULL,'LARRY WHITE','FI','458917604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:52',0,'2014-03-02 05:59:43'),(15908,16557,'0000-00-00','ET','2',1,NULL,'Patsy Craft','FI','296489732','HealthSpan','FI','311431434','Thomas   Konzen','94','7981943','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:17',0,'2014-03-10 14:10:12'),(16303,16953,'0000-00-00','ET','2',1,NULL,'DIAMANTINA RODRIGUEZ','FI','451339927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:25',0,'2014-03-02 06:10:30'),(17837,18487,'0000-00-00','ET','2',1,NULL,'Susan Hale','FI','291486635','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:05',0,'2014-03-10 14:20:26'),(18133,18783,'0000-00-00','ET','2',1,NULL,'RUDY LEE BELL','FI','434411215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:02',0,'2014-03-02 06:38:05'),(21902,22552,'0000-00-00','ET','2',1,NULL,'Julio Pacheto','FI','455533772','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:45',0,'2014-03-05 22:27:33'),(21955,22605,'0000-00-00','ET','2',1,NULL,'Glendora Gaspard','FI','425379412','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:22',0,'2014-03-05 22:27:33'),(23114,23764,'0000-00-00','ET','2',1,NULL,'George Svetlik','FI','283480127','Summa Insurance Company, Inc.','FI','341809108','John C  Dalziel','94','362362','357','2014-04-01','Sync Success',0,'2014-03-10 21:30:13',0,'2014-03-10 21:35:03'),(237,237,'2014-01-01','ET','2',1,0,'Terrance Bernard','FI','439754945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:25',0,'2014-03-01 19:11:03'),(871,871,'2014-01-01','ET','2',2,1,'Dean DeVincentis','FI','269506789','Dental Care Plus, Inc.','FI','311185262','Ronald L Haines','94','2759626','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:21',0,'2014-03-01 15:16:37'),(3527,3527,'2014-01-01','ET','2',1,NULL,'Matthew Alan Hanzel','FI','277887924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:03',0,'2014-03-01 15:31:33'),(15043,15494,'2014-01-01','ET','2',1,NULL,'Ethel Strong','FI','436024611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:28',0,'2014-03-02 05:52:31'),(11231,11231,'2014-01-01','ET','2',2,1,'JACKIE D LEA','FI','292647980','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:23',0,'2014-03-01 16:23:43'),(11593,11593,'2014-01-01','ET','2',1,NULL,'Maria Garcia','FI','464634737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:32',0,'2014-03-02 04:59:36'),(16333,16983,'0000-00-00','ET','2',1,NULL,'Earlean Bradley','FI','587766702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:44',0,'2014-03-02 06:10:30'),(22643,23293,'0000-00-00','ET','2',2,1,'BECKY EVANS-HENRY','FI','278524973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:14',0,'2014-03-08 21:35:36'),(10419,10419,'2014-01-01','ET','2',1,NULL,'Janice Simmons','FI','294526977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:18',0,'2014-03-01 16:10:36'),(15342,15793,'0000-00-00','ET','2',1,NULL,'paula paul','FI','436436402','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:44',0,'2014-03-02 05:52:31'),(15243,15694,'0000-00-00','ET','2',1,NULL,'James DANIELS','FI','436832865','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:23',0,'2014-03-02 05:52:31'),(1076,1076,'2014-01-01','ET','2',1,NULL,'jeremy mohon','FI','636205690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:08',0,'2014-03-01 19:11:03'),(16653,17303,'0000-00-00','ET','2',2,1,'Pamela Wright','FI','271767176','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:43',0,'2014-03-10 16:24:30'),(18929,19579,'0000-00-00','ET','2',1,NULL,'leslie graske','FI','360565754','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:22',0,'2014-03-10 16:31:33'),(19744,20394,'0000-00-00','ET','2',1,NULL,'Glenna Jeffreys','FI','461374857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:03',0,'2014-03-02 07:03:25'),(20687,21337,'0000-00-00','ET','2',2,1,'Nam Nguyen','FI','456793942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:06',0,'2014-03-02 07:17:36'),(20849,21499,'0000-00-00','ET','2',2,1,'BRANDON SHARP','FI','433691120','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:21',0,'2014-03-02 07:17:36'),(186,186,'2014-01-01','ET','2',2,1,'janice prine','FI','436355774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:46',0,'2014-03-01 22:10:55'),(2473,2473,'2014-01-01','ET','2',1,NULL,'David M Beck','FI','300540036','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:38',0,'2014-03-10 13:10:24'),(5982,5982,'2014-01-01','ET','2',1,NULL,'Rickie Siefert','FI','290524158','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:25',0,'2014-03-10 13:24:34'),(3479,3479,'2014-01-01','ET','2',1,NULL,'Nico Gonzalez','FI','361547771','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:31',0,'2014-03-01 15:31:33'),(4743,4743,'2014-01-01','ET','2',1,NULL,'rita williams','FI','293483926','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:03',0,'2014-03-10 13:03:33'),(7606,7606,'2014-01-01','ET','2',1,NULL,'Tracey Baranowski','FI','298760656','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:37:28',0,'2014-03-10 15:59:47'),(15789,16438,'0000-00-00','ET','2',1,NULL,'terry waller','FI','449020214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:00:05',0,'2014-03-02 06:03:21'),(15840,16489,'0000-00-00','ET','2',1,NULL,'Tina Anderson','FI','290568983','Dental Care Plus, Inc.','FI','311185262','Craig J Villwock','94','1859217','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:34',0,'2014-03-01 16:56:22'),(18062,18712,'0000-00-00','ET','2',2,1,'Randy Normann','FI','463062202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:09',0,'2014-03-02 06:38:05'),(20227,20877,'0000-00-00','ET','2',1,NULL,'ROBIN TEMPLE','FI','286622012','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:52',0,'2014-03-10 14:37:47'),(6275,6275,'2014-01-01','ET','2',1,NULL,'CARL ADAM GUILLORY','FI','435497227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:42',0,'2014-03-02 04:10:25'),(11715,11715,'2014-01-01','ET','2',1,NULL,'Michele Odom','FI','042524089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:22',0,'2014-03-02 04:59:36'),(10670,10670,'2014-01-01','ET','2',1,NULL,'Nancy Lignoski','FI','208664017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:59:25',0,'2014-03-01 16:10:36'),(14927,15378,'2014-01-01','ET','2',5,4,'Amy Winters','FI','282880534','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:36',0,'2014-03-01 16:50:53'),(5512,5512,'2014-01-01','ET','2',2,1,'MOHAMED MOHAMED','FI','029768376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:47',0,'2014-03-01 16:23:43'),(607,607,'2014-01-01','ET','2',1,NULL,'mary white','FI','453252175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:49',0,'2014-03-02 02:10:49'),(3831,3831,'2014-01-01','ET','2',1,NULL,'Molly Sotherden','FI','120625841','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:02',0,'2014-03-10 15:39:19'),(18675,19325,'0000-00-00','ET','2',3,2,'Sean Greenfield','FI','275724422','Starmount Life Insurance Company','FI','720977315','Kathy  Canlas','94','7407489','348','2014-03-01','Sync Success',0,'2014-02-13 22:01:33',0,'2014-03-02 06:45:14'),(19586,20236,'0000-00-00','ET','2',1,NULL,'Shelly Murphree','FI','459813320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:29:00',0,'2014-03-02 06:59:07'),(19608,20258,'0000-00-00','ET','2',1,NULL,'casey tucker','94','0000194106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:33:41',0,'2014-03-01 17:34:07'),(67,67,'2014-01-01','ET','2',1,NULL,'John C Cleghorn','FI','307066883','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:02',0,'2014-03-01 15:26:40'),(13859,14215,'2014-01-01','ET','2',1,NULL,'Jimmie Jackson','FI','435432870','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:54',0,'2014-03-02 05:31:31'),(99,99,'2014-01-01','ET','2',1,NULL,'Jamie Kungu','FI','466655477','Starmount Life Insurance Company','FI','720977315','John  Skomal','94','15877096','348','2014-01-01','Sync Success',0,'2013-12-25 17:18:01',0,'2014-03-01 23:10:52'),(13797,14153,'2014-01-01','ET','2',2,1,'Kelli Bowling','FI','301809855','HealthSpan','FI','311431434','Judy  Wilson','94','3397333','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:45',0,'2014-03-10 13:59:38'),(13192,13548,'2014-01-01','ET','2',3,2,'NORMA  BADER','FI','271845164','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:21',0,'2014-03-10 13:59:38'),(1425,1425,'2014-01-01','ET','2',1,NULL,'Chris Gerrard','FI','282947666','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:52',0,'2014-03-10 13:52:32'),(16970,17620,'0000-00-00','ET','2',1,NULL,'Aretha Chapamn','FI','290744717','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:11',0,'2014-03-01 17:00:58'),(22482,23132,'0000-00-00','ET','2',2,1,'Teresa Turner','FI','286666433','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:58',0,'2014-03-07 21:36:32'),(44,44,'2014-01-01','ET','2',1,NULL,'Norma Vaughn','FI','457235850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:19',0,'2014-03-01 22:10:55'),(1440,1440,'2014-01-01','ET','2',4,3,'Mirna Funkhouser','FI','271582911','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:21',0,'2014-03-01 16:15:39'),(11859,11859,'2014-01-01','ET','2',2,1,'Christopher Leising','FI','407925715','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:07',0,'2014-03-10 16:03:49'),(11426,11426,'2014-01-01','ET','2',1,NULL,'DAUREATHA HYTHON','FI','287668867','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:23',0,'2014-03-10 16:03:49'),(10635,10635,'2014-01-01','ET','2',1,NULL,'alireza zarghouni','FI','730180489','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:20',0,'2014-03-02 04:31:46'),(3183,3183,'2014-01-01','ET','2',1,NULL,'Gregory Skinner','FI','287429445','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:58',0,'2014-03-10 13:24:34'),(16195,16844,'0000-00-00','ET','2',1,NULL,'CRYSTAL  RENEE DAIRE','FI','433675122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:35',0,'2014-03-02 06:10:30'),(17145,17795,'0000-00-00','ET','2',1,NULL,'Crystal Ford','FI','294561447','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:29',0,'2014-03-10 16:24:30'),(19136,19786,'0000-00-00','ET','2',1,NULL,'Jacquelyn Eaver','FI','296909188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:11',0,'2014-03-01 17:34:07'),(22312,22962,'0000-00-00','ET','2',1,NULL,'Luther Layne','FI','412880621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:06',0,'2014-03-06 22:25:29'),(22417,23067,'0000-00-00','ET','2',1,NULL,'Chaime Breaux','FI','458711394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:11',0,'2014-03-07 22:26:59'),(1201,1201,'2014-01-01','ET','2',1,NULL,'Rosie  king','FI','587821856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:48',0,'2014-03-02 04:45:37'),(1311,1311,'2014-01-01','ET','2',2,1,'HongAnh Tran','FI','627485823','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:09',0,'2014-03-02 04:38:08'),(13621,13977,'2014-01-01','ET','2',1,NULL,'Lynn Johnston','FI','282722354','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:40',0,'2014-03-10 16:10:34'),(2106,2106,'2014-01-01','ET','2',4,3,'Jeffrey Toth','FI','269783194','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:04',0,'2014-03-01 15:16:37'),(4021,4021,'2014-01-01','ET','2',3,2,'ahmad majidi','FI','609942232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:47',0,'2014-03-02 03:09:49'),(6447,6447,'2014-01-01','ET','2',1,NULL,'Jose Daniel Arreaga','FI','644487316','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-26 03:16:00',NULL,NULL),(17363,18013,'0000-00-00','ET','2',1,NULL,'Louise Gibson','FI','465781414','Starmount Life Insurance Company','FI','720977315','Nicole   Winston','94','1921463','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:17',0,'2014-03-02 06:24:38'),(23063,23713,'0000-00-00','ET','2',1,NULL,'Chloe Estep','FI','285989284','Dental Care Plus, Inc.','FI','311185262','Michelle  Sweeney','94','2438648','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:38',0,'2014-03-10 21:36:25'),(6246,6246,'2014-01-01','ET','2',2,1,'Gary Reed','FI','268527805','HealthSpan','FI','311431434','Stephen J Ray','94','1484647','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:48',0,'2014-03-10 13:32:15'),(3107,3107,'2014-01-01','ET','2',1,NULL,'LEROY THOMAS','FI','434392369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:23',0,'2014-03-02 01:10:33'),(15439,15890,'0000-00-00','ET','2',1,NULL,'DIANA STONE','FI','283480161','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:34',0,'2014-03-10 16:17:47'),(4215,4215,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:06:41',0,'2014-03-01 15:52:44'),(14961,15412,'2014-01-01','ET','2',1,NULL,'MICHELE HENN','FI','297726402','Dental Care Plus, Inc.','FI','311185262','MICHAEL  LONGLAND','94','1891956','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:53',0,'2014-03-01 16:50:53'),(14484,14935,'2014-01-01','ET','2',2,1,'MARY JONES','FI','434410360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:45',0,'2014-03-02 05:38:34'),(13219,13575,'2014-01-01','ET','2',1,NULL,'SHERRIE BEDWELL','FI','429470900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:50',0,'2014-03-02 05:17:40'),(17777,18427,'0000-00-00','ET','2',1,NULL,'Ramon de Jesus Santoyo','FI','455933265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:15',0,'2014-03-02 06:10:30'),(21925,22575,'0000-00-00','ET','2',2,1,'Mary Davis','FI','455578081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:00',0,'2014-03-05 22:27:33'),(1211,1211,'2014-01-01','ET','2',3,2,'Shannon Knippen','FI','302747886','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:06',0,'2014-03-01 16:15:39'),(15537,15988,'0000-00-00','ET','2',1,NULL,'Erika Frankel','FI','182568693','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:07',0,'2014-03-10 16:17:47'),(14764,15215,'2014-01-01','ET','2',1,NULL,'Lisa Ann Frank','FI','293681695','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:35',0,'2014-03-10 14:03:26'),(14449,14900,'2014-01-01','ET','2',1,NULL,'JERRY COMEAUX','FI','439868324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:30',0,'2014-03-02 05:38:34'),(6029,6029,'2014-01-01','ET','2',1,NULL,'Daniel Warren','FI','589743314','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:50',0,'2014-03-01 15:10:22'),(13670,14026,'2014-01-01','ET','2',1,NULL,'ROBIN LYNN SHERETTE','FI','517826150','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:22',0,'2014-03-02 05:24:45'),(13369,13725,'2014-01-01','ET','2',1,NULL,'Kathy Maberry','FI','465049632','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:40',0,'2014-03-02 05:24:45'),(12832,12832,'2014-01-01','ET','2',1,NULL,'xaicha lewis-green','FI','338880545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:24',0,'2014-03-02 05:10:52'),(12444,12444,'2014-01-01','ET','2',1,NULL,'DAWANDA KEMP','FI','433718706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:16',0,'2014-03-02 05:03:29'),(11840,11840,'2014-01-01','ET','2',1,NULL,'Alexander Parent','FI','268886537','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:24',0,'2014-03-10 13:45:57'),(11542,11542,'2014-01-01','ET','2',1,NULL,'SUSAN SLEIGHTER','FI','290600370','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:53',0,'2014-03-10 16:10:34'),(11415,11415,'2014-01-01','ET','2',3,2,'Angela Green','FI','278840124','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:02',0,'2014-03-10 13:52:32'),(11328,11328,'2014-01-01','ET','2',2,1,'LISA SHARDON','FI','057446201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:21',0,'2014-03-02 04:52:44'),(19675,20325,'0000-00-00','ET','2',1,NULL,'DONALD RIBY WILLIAMS','FI','529211138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:49:12',0,'2014-03-01 17:47:19'),(6018,6018,'2014-01-01','ET','2',1,NULL,'Susan  Darlene Hunt','FI','433176320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:30',0,'2014-03-01 20:10:57'),(13095,13451,'2014-01-01','ET','2',1,NULL,'REGINA SCHAFFER','FI','427215246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:49',0,'2014-03-02 05:17:40'),(1230,1230,'2014-01-01','ET','2',1,NULL,'John Nicholas','FI','277685018','Dental Care Plus, Inc.','FI','311185262','Joseph  Dintino','94','2207884','357','2014-01-01','Sync Success',0,'2013-12-25 18:48:41',0,'2014-03-01 16:15:39'),(1511,1511,'2014-01-01','ET','2',1,NULL,'Susan Walk','FI','273522911','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:44',0,'2014-03-10 16:03:49'),(10830,10830,'2014-01-01','ET','2',1,NULL,'Eve Abrams','FI','212686447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:51',0,'2014-03-02 04:31:46'),(5457,5457,'2014-01-01','ET','2',2,1,'TOUFIK ESSED','FI','438913771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:03',0,'2014-03-02 04:45:37'),(17589,18239,'0000-00-00','ET','2',1,NULL,'Sherry Sharp','FI','299541820','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-02-07 19:01:04',0,'2014-03-10 14:24:38'),(18049,18699,'0000-00-00','ET','2',2,1,'Christopher Price','FI','285708816','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:13',0,'2014-03-10 14:24:38'),(22182,22832,'0000-00-00','ET','2',1,NULL,'MARILYN JONES','FI','296564292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:26',0,'2014-03-06 21:36:23'),(2949,2949,'2014-01-01','ET','2',1,NULL,'Donald Durbin','FI','048509261','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:32',0,'2014-03-01 15:37:30'),(14127,14578,'2014-01-01','ET','2',1,NULL,'Robert Richards','FI','415373471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:52',0,'2014-03-02 05:38:34'),(16724,17374,'0000-00-00','ET','2',4,3,'LISA SCOTT','FI','278821045','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:34',0,'2014-03-10 16:24:30'),(19408,20058,'0000-00-00','ET','2',3,2,'Susan Theodore','FI','280720866','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:14',0,'2014-03-10 16:31:33'),(19935,20585,'0000-00-00','ET','2',1,NULL,'Ramona Crandell','FI','457276894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:04',0,'2014-03-02 07:03:25'),(20681,21331,'0000-00-00','ET','2',1,NULL,'brittian knickerbocker','FI','438834551','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:03',0,'2014-03-02 07:17:36'),(775,775,'2014-01-01','ET','2',1,NULL,'Harold Bashor','FI','268485568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:13',0,'2014-03-01 15:05:09'),(4968,4968,'2014-01-01','ET','2',1,0,'CAROL JORDAN','FI','270501982','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:23',0,'2014-03-01 15:05:09'),(13755,14111,'2014-01-01','ET','2',1,NULL,'LILIAN LOPEZ','FI','508134332','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:17',0,'2014-03-02 05:24:45'),(13741,14097,'2014-01-01','ET','2',1,NULL,'Robert Neiman','FI','279501531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:08',0,'2014-03-01 16:40:16'),(13125,13481,'2014-01-01','ET','2',1,NULL,'ASTRID LACHELL ADAMS','FI','457618474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:57',0,'2014-03-02 05:17:40'),(12550,12550,'2014-01-01','ET','2',1,NULL,'REBECCA L COSTILOW','FI','272648406','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:35:16',0,'2014-03-10 16:10:34'),(10553,10553,'2014-01-01','ET','2',1,NULL,'Gregory Kolz','FI','550846448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:38',0,'2014-03-02 04:24:47'),(4848,4848,'2014-01-01','ET','2',1,NULL,'Debra Fraser','FI','264399892','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:32',0,'2014-03-10 15:39:19'),(16175,16824,'0000-00-00','ET','2',1,NULL,'Gabriel Kirk Mudd','FI','258510568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:22',0,'2014-03-01 16:56:22'),(17877,18527,'0000-00-00','ET','2',1,NULL,'MICHAEL MARRAS','FI','277904281','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:13',0,'2014-03-10 16:31:33'),(18454,19104,'0000-00-00','ET','2',1,NULL,'Deborah Young','FI','272564373','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:40',0,'2014-03-10 16:31:33'),(19370,20020,'0000-00-00','ET','2',3,2,'JAMAL STERLING','FI','443987951','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:46',0,'2014-03-01 17:34:07'),(19397,20047,'0000-00-00','ET','2',1,NULL,'Linda Jones','FI','276647376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:06',0,'2014-03-01 17:34:07'),(22357,23007,'0000-00-00','ET','2',1,NULL,'Corey Mann','FI','295740136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:14',0,'2014-03-07 21:36:32'),(22786,23436,'0000-00-00','ET','2',1,NULL,'Antwan Sparks','FI','299843934','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:38',0,'2014-03-09 21:35:27'),(5766,5766,'2014-01-01','ET','2',1,NULL,'warreneka simmons','FI','453679124','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:25',0,'2014-03-02 01:10:33'),(12591,12591,'2014-01-01','ET','2',1,NULL,'LETICIA BERNAL','FI','449373170','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:47',0,'2014-03-02 05:10:52'),(12041,12041,'2014-01-01','ET','2',1,NULL,'Lisa Burton','FI','433434465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:38',0,'2014-03-02 05:03:29'),(11695,11695,'2014-01-01','ET','2',2,1,'Bysmark A Acebo','FI','637014518','Starmount Life Insurance Company','FI','720977315','Robert  Stephen Bender','94','1160971','348','2014-02-01','Sync Success',1,'2013-12-29 11:07:46',0,'2014-03-02 04:59:36'),(5564,5564,'2014-01-01','ET','2',1,NULL,'Matthew Bruce','FI','439592277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:30',0,'2014-03-02 04:45:37'),(3661,3661,'2014-01-01','ET','2',1,NULL,'Betty Ware','FI','425452019','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:15',0,'2014-03-02 00:10:48'),(17214,17864,'0000-00-00','ET','2',1,NULL,'Trudy Jas','FI','260944393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:13',0,'2014-03-01 17:20:55'),(17260,17910,'0000-00-00','ET','2',1,NULL,'Nicholas Bell','FI','454978738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:36',0,'2014-03-02 06:24:38'),(18043,18693,'0000-00-00','ET','2',1,NULL,'Gregory Douglas','FI','366761483','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:08',0,'2014-03-10 14:24:38'),(21378,22028,'0000-00-00','ET','2',3,2,'Martin Ulrich','FI','296564088','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 01:00:40',0,'2014-03-10 14:45:25'),(4044,4044,'2014-01-01','ET','2',2,1,'Santa Munoz','FI','643825774','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:29',0,'2014-03-02 03:09:49'),(16091,16740,'0000-00-00','ET','2',2,1,'anwar matar','FI','300980657','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:10',0,'2014-03-01 16:56:22'),(14953,15404,'2014-01-01','ET','2',1,NULL,'Molly Long','FI','429713840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:49',0,'2014-03-02 05:45:37'),(1346,1346,'2014-01-01','ET','2',1,NULL,'Alissa Harrison','FI','509969084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:17',0,'2014-03-02 04:38:08'),(22101,22751,'0000-00-00','ET','2',2,1,'Sherrie Colligan','FI','460985625','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:30',0,'2014-03-06 21:27:26'),(6350,6350,'2014-01-01','ET','2',1,NULL,'SARAH L CONLY','FI','282503658','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:55',0,'2014-03-10 13:32:15'),(5370,5370,'2014-01-01','ET','2',1,NULL,'Michael Joseph Fontenot','FI','433782941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:32',0,'2014-03-01 21:11:04'),(7391,7391,'2014-01-01','ET','2',1,NULL,'Shelly Semien','FI','439690274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:34',0,'2014-03-02 04:15:49'),(11491,11491,'2014-01-01','ET','2',1,NULL,'Matthew Wayne Day','FI','466933983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:23',0,'2014-03-02 04:52:44'),(16016,16665,'0000-00-00','ET','2',1,NULL,'Tonya Jolly','FI','458800414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:21',0,'2014-03-02 06:03:21'),(17251,17901,'0000-00-00','ET','2',1,NULL,'Stephone Jeffries','94','0000873273','Dental Care Plus, Inc.','FI','311185262','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:32',0,'2014-03-01 17:20:55'),(20645,21295,'0000-00-00','ET','2',1,NULL,'randall barnett','FI','426631825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 21:02:21',0,'2014-03-02 07:17:36'),(22735,23385,'0000-00-00','ET','2',1,NULL,'CATHERINE MOORE','FI','434962789','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:00',0,'2014-03-09 21:26:00'),(1427,1427,'2014-01-01','ET','2',1,NULL,'Daniel Donkor','FI','072020555','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:56',0,'2014-03-10 13:52:32'),(13006,13006,'2014-01-01','ET','2',1,NULL,'Whitney London','FI','435833914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:20',0,'2014-03-02 05:17:40'),(14344,14795,'2014-01-01','ET','2',1,NULL,'Sandra Simmons','FI','466840637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:43',0,'2014-03-02 05:45:37'),(14415,14866,'2014-01-01','ET','2',1,NULL,'Robert Hydrick','FI','425653510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:14',0,'2014-03-02 05:38:34'),(11465,11465,'2014-01-01','ET','2',1,NULL,'Sandra Sarka','FI','284667030','Dental Care Plus, Inc.','FI','311185262','Benjamin  laugle','94','16778234','348','2014-02-01','Sync Success',0,'2013-12-28 03:30:37',0,'2014-03-01 16:30:17'),(15077,15528,'0000-00-00','ET','2',1,NULL,'DOLORES MARULANDA','FI','291063999','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:34',0,'2014-03-01 16:50:53'),(18326,18976,'0000-00-00','ET','2',1,NULL,'MICHELLE R HILDRETH','FI','297749391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:11',0,'2014-03-01 17:26:36'),(19619,20269,'0000-00-00','ET','2',1,NULL,'riley tucker','94','0000172464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:40',0,'2014-03-01 17:34:07'),(22322,22972,'0000-00-00','ET','2',1,NULL,'Denace Tims','FI','428235904','Starmount Life Insurance Company','FI','720977315','Reginald  Brown','94','9358615','348','2014-04-01','Sync Success',0,'2014-03-06 21:30:12',0,'2014-03-06 22:25:29'),(6055,6055,'2014-01-01','ET','2',1,NULL,'Joyce Kozopas','FI','289545001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:45',0,'2014-03-01 15:10:22'),(15071,15522,'2014-01-01','ET','2',2,1,'Gwen Neace','FI','459694909','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:40',0,'2014-03-10 14:10:12'),(11869,11869,'2014-01-01','ET','2',2,1,'jason manion','FI','453992561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:02',0,'2014-03-02 04:59:36'),(7548,7548,'2014-01-01','ET','2',1,NULL,'SHUBHRA NEIL AGARWAL','FI','281046375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:35:33',0,'2014-03-01 16:05:34'),(1816,1816,'2014-01-01','ET','2',1,NULL,'Linda Wallace','FI','271540278','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:08',0,'2014-03-10 15:45:56'),(15803,16452,'0000-00-00','ET','2',1,NULL,'Laurence Michlin','FI','466537072','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-24 21:00:13',0,'2014-03-02 06:03:21'),(17843,18493,'0000-00-00','ET','2',1,NULL,'Ted DiBacco','FI','269668281','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:09',0,'2014-03-10 14:20:26'),(21625,22275,'0000-00-00','ET','2',1,NULL,'Wissam Yousif','FI','766842870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:40',0,'2014-03-04 21:27:16'),(22998,23648,'0000-00-00','ET','2',2,1,'DIANNA WHITT','FI','278642035','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:49',0,'2014-03-10 21:36:25'),(32,32,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:56',0,'2014-03-01 15:21:15'),(11161,11161,'2014-01-01','ET','2',1,NULL,'nolan wright','FI','271748872','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:20',0,'2014-03-10 13:45:57'),(6046,6046,'2014-01-01','ET','2',1,0,'brandy schwertner','FI','452790939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:26',0,'2014-03-01 19:11:03'),(923,923,'2014-01-01','ET','2',4,3,'Jaime Winegardner','FI','291841745','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:47',0,'2014-03-10 13:10:24'),(2704,2704,'2014-01-01','ET','2',1,NULL,'Christopher Ward','FI','560775200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:20',0,'2014-03-02 04:15:49'),(1026,1026,'2014-01-01','ET','2',1,NULL,'gary grooms','FI','283469969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:04',0,'2014-03-10 13:10:24'),(2582,2582,'2014-01-01','ET','2',2,1,'Charles Fritsch','FI','274783153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:23',0,'2014-03-01 15:05:09'),(2579,2579,'2014-01-01','ET','2',1,NULL,'michael chinni','FI','286482509','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:17',0,'2014-03-01 15:05:09'),(1668,1668,'2014-01-01','ET','2',1,NULL,'TEAUNNA J STOKES','FI','338829609','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:30',0,'2014-03-02 00:10:48'),(16000,16649,'0000-00-00','ET','2',2,1,'James Sadler','FI','465177172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:11',0,'2014-03-02 06:03:21'),(17146,17796,'0000-00-00','ET','2',1,NULL,'Rebecca Lyttle','FI','291441711','Summa Insurance Company, Inc.','FI','341809108','John   Pequeno','94','9544739','357','2014-03-01','Sync Success',0,'2014-02-04 21:01:30',0,'2014-03-10 16:24:30'),(18469,19119,'0000-00-00','ET','2',1,NULL,'DAISY MERCADO','FI','582061461','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:50',0,'2014-03-02 06:45:14'),(21214,21864,'0000-00-00','ET','2',1,NULL,'Heather Platz-Rosenow','FI','274667346','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:11',0,'2014-03-10 16:38:05'),(6241,6241,'2014-01-01','ET','2',1,NULL,'Brenda  Robinson','FI','429117600','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:38',0,'2014-03-10 13:39:10'),(10775,10775,'2014-01-01','ET','2',1,NULL,'fred peloquin','FI','439081844','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:05',0,'2014-03-02 04:24:47'),(11548,11548,'2014-01-01','ET','2',1,NULL,'Veronica Avila','FI','342747675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:05',0,'2014-03-02 04:52:44'),(17680,18330,'0000-00-00','ET','2',1,NULL,'Aron Del Monte','FI','279944093','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:53',0,'2014-03-10 16:24:30'),(18352,19002,'0000-00-00','ET','2',1,NULL,'Cynthia Mix','FI','434214267','Starmount Life Insurance Company','FI','720977315','Wayne  Perritt','94','4717093','348','2014-03-01','Sync Success',0,'2014-02-12 21:30:27',0,'2014-03-02 06:45:14'),(19049,19699,'0000-00-00','ET','2',1,NULL,'Sylvia Gomez','FI','451432215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:06',0,'2014-03-02 06:52:12'),(21593,22243,'0000-00-00','ET','2',1,NULL,'ANTHONY LOUIS','FI','434191728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:14',0,'2014-03-04 21:27:16'),(21859,22509,'0000-00-00','ET','2',1,NULL,'John Doughty','94','0000636019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:30:13',0,'2014-03-05 21:36:22'),(22573,23223,'0000-00-00','ET','2',1,NULL,'Kathleen Ann Lewis','FI','302501326','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-07 21:32:01',0,'2014-03-10 14:50:59'),(1097,1097,'2014-01-01','ET','2',1,NULL,'Alan Witzke','FI','299880602','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:55',0,'2014-03-01 15:05:09'),(12424,12424,'2014-01-01','ET','2',1,NULL,'TRACY M PAYTON','FI','436252060','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:33',0,'2014-03-02 05:03:29'),(11206,11206,'2014-01-01','ET','2',1,NULL,'BYRDIE MCGEE','FI','281563496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:38',0,'2014-03-01 16:23:43'),(7296,7296,'2014-01-01','ET','2',1,NULL,'ROBIN S BIGGERT','FI','298627697','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:35',0,'2014-03-10 13:32:15'),(4264,4264,'2014-01-01','ET','2',1,NULL,'RAMONA METTS','FI','436863904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:14',0,'2014-03-02 03:09:49'),(7005,7005,'2014-01-01','ET','2',2,1,'ali delaram','FI','645429179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:38',0,'2014-03-02 02:10:49'),(18437,19087,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:29',0,'2014-03-01 17:26:36'),(19373,20023,'0000-00-00','ET','2',1,NULL,'Jamie Stahlman','FI','277863134','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:49',0,'2014-03-01 17:34:07'),(19974,20624,'0000-00-00','ET','2',1,NULL,'Carmen Curtis','FI','275703062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:34',0,'2014-03-01 17:47:19'),(154,154,'2014-01-01','ET','2',1,NULL,'lisa gabriel','FI','017462145','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:47',0,'2014-03-10 15:45:56'),(14911,15362,'2014-01-01','ET','2',1,NULL,'JACQUELINE ANDERSON','FI','269904692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:29',0,'2014-03-01 16:46:19'),(7225,7225,'2014-01-01','ET','2',1,NULL,'Mitchell Grattan','FI','290649949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:25',0,'2014-03-01 15:52:44'),(816,816,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:47',0,'2014-03-01 15:10:22'),(2338,2338,'2014-01-01','ET','2',1,NULL,'Vanessa Thomas','FI','294668405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:18',0,'2014-03-10 15:45:56'),(11088,11088,'2014-01-01','ET','2',1,NULL,'Nathan Price','FI','297785035','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:44',0,'2014-03-10 13:39:10'),(17789,18439,'0000-00-00','ET','2',1,NULL,'Karen Pavlis','FI','296540406','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:24',0,'2014-03-01 16:50:53'),(19940,20590,'0000-00-00','ET','2',1,NULL,'BOBETTE BURKE','FI','461192798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-21 22:00:07',0,'2014-03-02 07:03:25'),(22118,22768,'0000-00-00','ET','2',1,NULL,'MARTHA LAWSON','FI','437065045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:42',0,'2014-03-06 21:27:26'),(306,306,'2014-01-01','ET','2',1,NULL,'Kathleen Sullivan  Bell','FI','451907173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:23',0,'2014-03-01 22:10:55'),(14880,15331,'2014-01-01','ET','2',2,1,'Kimberly Vasquez','FI','600800442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:15',0,'2014-03-02 05:52:31'),(13840,14196,'2014-01-01','ET','2',1,NULL,'gail guthrie','FI','452511296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:41',0,'2014-03-02 05:31:31'),(5308,5308,'2014-01-01','ET','2',1,NULL,'Christina Williams','FI','278887703','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:44',0,'2014-03-10 13:03:33'),(1368,1368,'2014-01-01','ET','2',1,NULL,'larry scheib','FI','532821335','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:00',0,'2014-03-02 04:38:08'),(10591,10591,'2014-01-01','ET','2',1,NULL,'Edward Raymond Huffman','FI','450028922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:52',0,'2014-03-02 04:24:47'),(1480,1480,'2014-01-01','ET','2',1,NULL,'MICHELLE L COHEN','FI','273761670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:47',0,'2014-03-10 13:45:57'),(20496,21146,'0000-00-00','ET','2',1,NULL,'GERIC OSBORNE','FI','434867011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:41',0,'2014-03-02 07:10:28'),(4192,4192,'2014-01-01','ET','2',1,NULL,'Margaret Paulin','FI','272561940','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:06:00',0,'2014-03-10 15:59:47'),(14749,15200,'2014-01-01','ET','2',1,NULL,'Christine Wesie','FI','234941413','Summa Insurance Company, Inc.','FI','341809108','WILLIAM  MCILROY','94','8267605','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:26',0,'2014-03-10 16:17:47'),(16989,17639,'0000-00-00','ET','2',2,1,'Jeffrey Davis','FI','295740724','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:22',0,'2014-03-10 14:20:26'),(18032,18682,'0000-00-00','ET','2',1,NULL,'David Wilson','FI','290846014','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:00',0,'2014-03-10 14:24:38'),(20158,20808,'0000-00-00','ET','2',1,NULL,'ABDIRAHMAN DIRIYE','FI','605292650','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:01',0,'2014-03-01 18:08:07'),(20378,21028,'0000-00-00','ET','2',1,NULL,'Kenta Hamilton','FI','427138572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:07',0,'2014-03-02 07:10:28'),(20937,21587,'0000-00-00','ET','2',2,1,'Nicole Mollohan','FI','293748506','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:00:28',0,'2014-03-10 16:38:05'),(22298,22948,'0000-00-00','ET','2',3,2,'RACHEL MARIE RAFEEDIE','FI','282861702','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:52',0,'2014-03-10 14:50:59'),(22470,23120,'0000-00-00','ET','2',1,NULL,'NATHAN KIELSKI','94','0000858549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:50',0,'2014-03-07 21:36:32'),(7023,7023,'2014-01-01','ET','2',1,NULL,'VIRGINIA FERNANDEZ','FI','450552788','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:13',0,'2014-03-02 03:09:49'),(834,834,'2014-01-01','ET','2',2,1,'Levi Williams','FI','426239167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:10',0,'2014-03-01 22:10:55'),(13835,14191,'2014-01-01','ET','2',1,NULL,'Yeon Won Kim','FI','460698739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:38',0,'2014-03-02 05:31:31'),(3396,3396,'2014-01-01','ET','2',1,NULL,'Victoria Gabel','FI','294562193','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:32',0,'2014-03-10 15:52:36'),(3532,3532,'2014-01-01','ET','2',1,NULL,'Michael Santa','FI','275827937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:13',0,'2014-03-01 15:31:33'),(5618,5618,'2014-01-01','ET','2',2,1,'Colette Epple','FI','292749273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:50:18',0,'2014-03-01 16:23:43'),(18739,19389,'0000-00-00','ET','2',1,NULL,'Justin Coulter','FI','274928148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:21',0,'2014-03-02 06:45:14'),(19078,19728,'0000-00-00','ET','2',1,NULL,'NATASHA BROWN','FI','434438983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:28',0,'2014-03-02 06:52:12'),(19830,20480,'0000-00-00','ET','2',2,1,'GARY JONES','FI','294561430','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-20 22:00:48',0,'2014-03-10 16:38:05'),(21110,21760,'0000-00-00','ET','2',1,NULL,'VALERIE MARIE JUAREZ','FI','335105094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:53',0,'2014-03-02 07:23:39'),(62,62,'2014-01-01','ET','2',1,NULL,'catherine a phillips','FI','288521753','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:52',0,'2014-03-01 15:21:15'),(5775,5775,'2014-01-01','ET','2',1,NULL,'Linda Meade','FI','283543382','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:43',0,'2014-03-10 13:24:34'),(5694,5694,'2014-01-01','ET','2',1,NULL,'vickie dittmer','FI','292589122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:12',0,'2014-03-01 15:37:30'),(14460,14911,'2014-01-01','ET','2',3,2,'rosiland smith','FI','437456423','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:34',0,'2014-03-02 05:38:34'),(12149,12149,'2014-01-01','ET','2',1,NULL,'Sherri Pitalo','FI','587429647','Starmount Life Insurance Company','FI','720977315','Cameron  Lilienquist','94','8328382','348','2014-02-01','Sync Success',0,'2014-01-01 12:07:24',0,'2014-03-02 04:59:36'),(17722,18372,'0000-00-00','ET','2',1,NULL,'Yvonne Lindberg','FI','283605237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:16',0,'2014-03-01 17:20:55'),(17732,18382,'0000-00-00','ET','2',1,NULL,'sidney jasmin','FI','433330893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:23',0,'2014-03-02 06:31:45'),(17841,18491,'0000-00-00','ET','2',1,NULL,'LARRY MEYERS','FI','179405861','Summa Insurance Company, Inc.','FI','341809108','RANDY  ECREMENT','94','2827079','348','2014-03-01','Sync Success',0,'2014-02-10 11:01:07',0,'2014-03-10 16:24:30'),(20506,21156,'0000-00-00','ET','2',2,1,'GERALD TEMPLET','FI','434024159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:46',0,'2014-03-02 07:10:28'),(5507,5507,'2014-01-01','ET','2',1,NULL,'elizabeth totman','FI','548110573','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:40',0,'2014-03-01 16:23:43'),(5395,5395,'2014-01-01','ET','2',2,1,'Joe Crick','FI','290723700','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:24',0,'2014-03-10 13:03:33'),(1400,1400,'2014-01-01','ET','2',1,NULL,'Marilyn Johnson','FI','439942292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:04',0,'2014-03-02 04:38:08'),(14520,14971,'2014-01-01','ET','2',2,1,'Diane Brooks','FI','563784052','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:02',0,'2014-03-10 14:03:26'),(4764,4764,'2014-01-01','ET','2',2,1,'Christine Kelly','FI','144526056','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:48',0,'2014-03-01 15:16:37'),(12240,12240,'2014-01-01','ET','2',1,NULL,'DIANNA VENTERS','FI','449471485','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:03',0,'2014-03-02 05:10:52'),(4675,4675,'2014-01-01','ET','2',2,1,'Milojka Stanic','FI','286067310','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:46',0,'2014-03-01 16:15:39'),(10966,10966,'2014-01-01','ET','2',1,NULL,'Terry Weathers','FI','256827790','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:37',0,'2014-03-10 16:03:49'),(4277,4277,'2014-01-01','ET','2',1,NULL,'Diana Klein','FI','061642911','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:38',0,'2014-03-02 03:09:49'),(16756,17406,'0000-00-00','ET','2',2,1,'maria de leon','FI','459551480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:13',0,'2014-03-02 06:17:30'),(17022,17672,'0000-00-00','ET','2',1,NULL,'Andrew Edwards','FI','352720315','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:13',0,'2014-03-02 06:24:38'),(717,717,'2014-01-01','ET','2',1,NULL,'Priscilla Harkness','FI','295584410','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:19',0,'2014-03-10 15:52:36'),(16848,17498,'0000-00-00','ET','2',2,1,'DEBORAH L BURSTION-DONBRAYE','FI','295568059','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:23',0,'2014-03-01 17:00:58'),(16363,17013,'0000-00-00','ET','2',1,NULL,'Stacy Bechtel','FI','480868680','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:02',0,'2014-03-10 16:24:30'),(2420,2420,'2014-01-01','ET','2',1,NULL,'LESLIE  FRANCIS ZEISIG','FI','298482292','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:54',0,'2014-03-10 15:45:56'),(3275,3275,'2014-01-01','ET','2',2,1,'Dan Tucker','FI','455155773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:40',0,'2014-03-02 02:10:49'),(3146,3146,'2014-01-01','ET','2',1,NULL,'Ty T Foust','FI','291763281','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:38',0,'2014-03-10 13:24:34'),(19789,20439,'0000-00-00','ET','2',1,NULL,'JESSICA VIRGINIA HENSLEY','FI','219724831','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:14',0,'2014-03-02 07:03:25'),(20759,21409,'0000-00-00','ET','2',1,NULL,'Cherie Cook','FI','302860002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:39',0,'2014-03-01 18:08:07'),(22946,23596,'0000-00-00','ET','2',1,NULL,'JAMES HENDERSON','FI','283740410','Summa Insurance Company, Inc.','FI','341809108','SCOTT  DEMKO','94','1829571','357','2014-03-31','Sync Success',0,'2014-03-10 21:01:14',0,'2014-03-10 21:07:22'),(12450,12450,'2014-01-01','ET','2',2,1,'MERELYN JONES','FI','296503045','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:30',0,'2014-03-10 16:10:34'),(18972,19622,'0000-00-00','ET','2',1,NULL,'Todd Brown','FI','296904062','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:54',0,'2014-03-10 14:31:05'),(18387,19037,'0000-00-00','ET','2',1,NULL,'Giorgio Rodriguez','FI','438552240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:52',0,'2014-03-02 06:45:14'),(11592,11592,'2014-01-01','ET','2',2,1,'florina mendez','FI','548456539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:29',0,'2014-03-02 04:59:36'),(11185,11185,'2014-01-01','ET','2',1,NULL,'Garrett Openshaw','FI','622127191','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:17:09',0,'2014-03-10 16:03:49'),(16243,16892,'0000-00-00','ET','2',2,1,'Patricia Wcislo','FI','281605303','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:08',0,'2014-03-10 16:24:30'),(15134,15585,'0000-00-00','ET','2',3,2,'Arnold F Leary','FI','437868233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:16',0,'2014-03-02 05:52:31'),(5199,5199,'2014-01-01','ET','2',1,NULL,'Bradley Pierce','FI','459832618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:20',0,'2014-03-02 00:10:48'),(2844,2844,'2014-01-01','ET','2',1,NULL,'Neysa Powell','FI','585420371','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:49',0,'2014-03-02 04:15:49'),(13926,14282,'2014-01-01','ET','2',1,NULL,'Jordan Holcomb','FI','587719471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:17',0,'2014-03-02 05:31:31'),(22429,23079,'0000-00-00','ET','2',2,1,'Florence Lewis','FI','449536156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:20',0,'2014-03-07 22:26:59'),(1418,1418,'2014-01-01','ET','2',1,NULL,'Cynthia E Corwin','FI','283462200','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 18:54:38',0,'2014-03-10 13:52:32'),(1837,1837,'2014-01-01','ET','2',4,3,'Jonathan Clark','FI','269884568','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:50',0,'2014-03-10 13:20:27'),(2437,2437,'2014-01-01','ET','2',2,1,'Sandra Barrera','FI','277682165','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:23',0,'2014-03-10 13:10:24'),(15566,16017,'0000-00-00','ET','2',1,NULL,'KEVIN DANIELS','FI','278648039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:20',0,'2014-03-01 16:50:53'),(20260,20910,'0000-00-00','ET','2',1,NULL,'BRENDA SIMPSON','FI','299665528','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:10',0,'2014-03-01 17:47:19'),(20287,20937,'0000-00-00','ET','2',1,NULL,'MICHAEL LOCKER','FI','281703478','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:31',0,'2014-03-10 14:37:47'),(21921,22571,'0000-00-00','ET','2',1,NULL,'Laura Cohen','FI','453216156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:57',0,'2014-03-05 22:27:33'),(22231,22881,'0000-00-00','ET','2',1,NULL,'Ruth Cortinas','FI','466479762','Starmount Life Insurance Company','FI','720977315','Kurt  Jarcik','94','4564074','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:03',0,'2014-03-06 21:27:26'),(94,94,'2014-01-01','ET','2',1,NULL,'Eulonda Killebrew','FI','553117635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:52',0,'2014-03-01 22:10:55'),(216,216,'2014-01-01','ET','2',1,NULL,'Marcia Ann Cloud','FI','279509629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:50',0,'2014-03-10 13:10:24'),(12215,12215,'2014-01-01','ET','2',1,NULL,'Danette Mixer','FI','297600403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:02',0,'2014-03-01 16:35:14'),(624,624,'2014-01-01','ET','2',1,NULL,'TOM  PETERS','FI','503629767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:25',0,'2014-03-02 02:10:49'),(7268,7268,'2014-01-01','ET','2',2,1,'dale chiyoung  tai','FI','289788764','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:44',0,'2014-03-10 13:32:15'),(6234,6234,'2014-01-01','ET','2',1,NULL,'ADA COSME','FI','280741139','Dental Care Plus, Inc.','FI','311185262','BUD  ANDRAKO','94','2759861','348','2014-01-01','Sync Success',0,'2013-12-26 03:05:24',0,'2014-03-01 16:00:27'),(4941,4941,'2014-01-01','ET','2',1,NULL,'STEVEN ALVAREZ','FI','465793184','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:31:30',0,'2014-03-01 20:10:57'),(5891,5891,'2014-01-01','ET','2',1,NULL,'Staci Lowell','FI','279906319','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:29',0,'2014-03-01 15:48:04'),(21995,22645,'0000-00-00','ET','2',1,NULL,'heather stuhldreher','FI','292600780','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:49',0,'2014-03-10 16:44:18'),(23120,23770,'0000-00-00','ET','2',1,NULL,'TREASEA LOWMAN','FI','410474373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:30:18',0,'2014-03-10 22:25:11'),(1140,1140,'2014-01-01','ET','2',1,NULL,'Huong Dang','FI','585254715','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:54',0,'2014-03-02 04:45:37'),(2140,2140,'2014-01-01','ET','2',1,NULL,'Mary Wood-Andersen','FI','267577232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:08',0,'2014-03-01 15:16:37'),(12376,12376,'2014-01-01','ET','2',1,NULL,'jayson tomblin','FI','289745041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:28:49',0,'2014-03-01 16:30:17'),(14750,15201,'2014-01-01','ET','2',1,NULL,'MARY K ROCK','FI','275504012','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:26',0,'2014-03-10 16:17:47'),(19347,19997,'0000-00-00','ET','2',1,NULL,'SETHDRIC LEE','FI','438435464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:31',0,'2014-03-02 06:59:07'),(22569,23219,'0000-00-00','ET','2',1,NULL,'SUZANNE W ARMSTRONG','FI','275507956','HealthSpan','FI','311431434','CHARLES  COMBES','94','936850','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:59',0,'2014-03-10 14:50:59'),(13382,13738,'2014-01-01','ET','2',1,NULL,'Clarince Edwards','FI','455635326','Starmount Life Insurance Company','FI','720977315','Stewart  Kile','94','1105368','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:46',0,'2014-03-02 05:24:45'),(13735,14091,'2014-01-01','ET','2',1,NULL,'Daranise Davis','FI','434792902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:04',0,'2014-03-02 05:24:45'),(3065,3065,'2014-01-01','ET','2',1,NULL,'Raef Husseini','FI','457650471','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:06',0,'2014-03-01 15:37:30'),(16057,16706,'0000-00-00','ET','2',1,NULL,'JENNIFER MCCONNELL','FI','289485425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:48',0,'2014-03-01 16:56:22'),(14910,15361,'2014-01-01','ET','2',1,NULL,'Camary C Andrews','FI','436757000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:28',0,'2014-03-02 05:45:37'),(14403,14854,'2014-01-01','ET','2',1,NULL,'Beth Kilbane','FI','175668667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:08',0,'2014-03-01 16:46:19'),(13868,14224,'2014-01-01','ET','2',1,NULL,'melvin briggs','FI','435130458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:00',0,'2014-03-02 05:31:31'),(10498,10498,'2014-01-01','ET','2',1,NULL,'catherine ann iding','FI','275507865','Dental Care Plus, Inc.','FI','311185262','judith   wilson','94','3397333','348','2014-01-01','Sync Success',0,'2013-12-26 12:53:49',0,'2014-03-01 16:10:36'),(19472,20122,'0000-00-00','ET','2',1,NULL,'MARY M TROTT','FI','005546985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:53:23',0,'2014-03-02 06:59:07'),(19705,20355,'0000-00-00','ET','2',1,NULL,'JORGE A MATA','FI','460976206','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:56:00',0,'2014-03-10 14:37:47'),(48,48,'2014-01-01','ET','2',1,NULL,'Barbara Castillo','FI','273701380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:26',0,'2014-03-01 15:21:15'),(19185,19835,'0000-00-00','ET','2',1,NULL,'DANITA WOODWARD','FI','406087322','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:52',0,'2014-03-10 14:31:05'),(227,227,'2014-01-01','ET','2',1,0,'Alton Hoot','FI','464929029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:08',0,'2014-03-01 19:11:03'),(17077,17727,'0000-00-00','ET','2',1,NULL,'melissa griffith','FI','449844226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:46',0,'2014-03-02 06:24:38'),(7550,7550,'2014-01-01','ET','2',2,1,'Luke Kesson','FI','380087541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:37',0,'2014-03-01 16:05:34'),(5080,5080,'2014-01-01','ET','2',2,1,'Eric Wheeler','FI','269929295','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:34',0,'2014-03-10 13:20:27'),(2792,2792,'2014-01-01','ET','2',3,2,'Gary Riesenberg','FI','283509947','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:06',0,'2014-03-01 16:05:34'),(4994,4994,'2014-01-01','ET','2',2,1,'RICHARD J KACHMAR','FI','299460391','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:47',0,'2014-03-01 15:31:33'),(19815,20465,'0000-00-00','ET','2',1,NULL,'JUDY GONZALES','FI','449515699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:35',0,'2014-03-02 07:03:25'),(13828,14184,'2014-01-01','ET','2',1,NULL,'Heather Rawlins','FI','637308939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:32',0,'2014-03-02 05:31:31'),(1329,1329,'2014-01-01','ET','2',1,NULL,'eric graves','FI','237637214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:44',0,'2014-03-02 04:38:08'),(17731,18381,'0000-00-00','ET','2',1,NULL,'Michael Hester','FI','434534444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:22',0,'2014-03-02 06:31:45'),(15575,16026,'0000-00-00','ET','2',1,NULL,'Linda Gonzales','FI','290782538','HealthSpan','FI','311431434','Chris  Junge','94','9794726','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:24',0,'2014-03-10 14:10:12'),(2929,2929,'2014-01-01','ET','2',1,NULL,'Kimberly Vivens','FI','302800161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:54',0,'2014-03-01 15:37:30'),(6421,6421,'2014-01-01','ET','2',1,NULL,'Kaley Nicole Akerman','FI','681182100','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:12',0,'2014-03-01 15:10:22'),(3032,3032,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:04',0,'2014-03-01 15:37:30'),(2965,2965,'2014-01-01','ET','2',1,NULL,'Anthony Kiaski','FI','268500539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:05',0,'2014-03-01 15:37:30'),(13666,14022,'2014-01-01','ET','2',1,NULL,'SULUMA  SALDANA','FI','452902975','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:20',0,'2014-03-02 05:24:45'),(19376,20026,'0000-00-00','ET','2',1,NULL,'April Dawn Civitarese','FI','268824546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:50',0,'2014-03-01 17:34:07'),(5204,5204,'2014-01-01','ET','2',1,NULL,'JAMES PHILIP RINGENER','FI','457214853','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:30',0,'2014-03-02 00:10:48'),(18821,19471,'0000-00-00','ET','2',2,1,'JENNY BOULIGNY','FI','436777936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:05',0,'2014-03-02 06:52:12'),(14509,14960,'2014-01-01','ET','2',1,NULL,'Theresa Herbst','FI','299423008','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:57',0,'2014-03-10 14:03:26'),(20464,21114,'0000-00-00','ET','2',3,2,'David Fluegel','FI','041709195','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:18',0,'2014-03-01 18:08:07'),(21934,22584,'0000-00-00','ET','2',1,NULL,'Otis Smith','FI','451313787','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:07',0,'2014-03-05 22:27:33'),(22646,23296,'0000-00-00','ET','2',2,1,'PAULINA FLORES  TRUJILLO','FI','730262240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:17',0,'2014-03-08 22:26:18'),(13335,13691,'2014-01-01','ET','2',1,NULL,'Cassandra Lain','FI','439237772','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:25',0,'2014-03-02 05:24:45'),(19691,20341,'0000-00-00','ET','2',1,NULL,'JACQUELINE JONES','FI','426139033','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:53:08',0,'2014-03-02 06:59:07'),(10521,10521,'2014-01-01','ET','2',1,NULL,'rick elder','FI','466857110','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:31',0,'2014-03-02 04:24:47'),(18215,18865,'0000-00-00','ET','2',1,NULL,'Sally McKenzie','FI','295524025','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:05',0,'2014-03-10 16:31:33'),(7287,7287,'2014-01-01','ET','2',4,3,'Renku Yang','FI','062769590','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:17',0,'2014-03-10 13:32:15'),(22188,22838,'0000-00-00','ET','2',2,1,'Don Stepteau','FI','436537510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:31',0,'2014-03-06 21:27:26'),(22566,23216,'0000-00-00','ET','2',1,NULL,'Matthew William Browne','FI','285928603','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:57',0,'2014-03-10 14:50:59'),(22584,23234,'0000-00-00','ET','2',1,NULL,'Edward Lawson','FI','278563794','HealthSpan','FI','311431434','Troy  Rhoads','94','2263696','348','2014-05-01','Sync Success',0,'2014-03-07 21:32:10',0,'2014-03-10 14:50:59'),(14975,15426,'2014-01-01','ET','2',1,NULL,'RICHARD RAMSER','FI','282542563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:00',0,'2014-03-01 16:50:53'),(3023,3023,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000120057','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:33:49',0,'2014-03-10 15:52:36'),(18002,18652,'0000-00-00','ET','2',2,1,'CANDIE ROWTON','FI','434738316','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:41',0,'2014-03-02 06:38:05'),(17742,18392,'0000-00-00','ET','2',2,1,'Kelly Wright','FI','437416631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:30',0,'2014-03-02 06:31:45'),(1946,1946,'2014-01-01','ET','2',1,NULL,'ARLENE HONECK','FI','270502360','Dental Care Plus, Inc.','FI','311185262','BENJAMIN P KELLY','94','2516200','348','2014-01-01','Sync Success',0,'2013-12-25 19:33:07',0,'2014-03-01 15:26:40'),(4883,4883,'2014-01-01','ET','2',1,NULL,'Asa Bryant','FI','587543807','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:42',0,'2014-03-01 20:10:57'),(273,273,'2014-01-01','ET','2',2,1,'sammye barnett','FI','402132912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:41',0,'2014-03-01 19:11:03'),(13995,14351,'2014-01-01','ET','2',2,1,'Nora Krisha','FI','279867150','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:25',0,'2014-03-10 14:03:26'),(11446,11446,'2014-01-01','ET','2',1,NULL,'EDWARD KINDLE','FI','045780629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:02',0,'2014-03-01 16:23:43'),(18141,18791,'0000-00-00','ET','2',1,NULL,'Jerry Branch','FI','435233451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:08',0,'2014-03-02 06:38:05'),(863,863,'2014-01-01','ET','2',1,NULL,'Michael Jaksik','FI','451942925','Starmount Life Insurance Company','FI','720977315','Wendy  Collier','94','3129845','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:04',0,'2014-03-01 22:10:55'),(2074,2074,'2014-01-01','ET','2',2,1,'Gerald Miracle','FI','270501508','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:12',0,'2014-03-10 15:45:56'),(530,530,'2014-01-01','ET','2',1,NULL,'STANLEY HILL','FI','300460375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:01:22',0,'2014-03-01 15:48:04'),(4117,4117,'2014-01-01','ET','2',1,NULL,'Donna Harper','FI','295642942','Dental Care Plus, Inc.','FI','311185262','Angela  Elias','94','10676545','348','2014-01-01','Sync Success',0,'2013-12-25 23:03:45',0,'2014-03-01 16:00:27'),(21290,21940,'0000-00-00','ET','2',1,NULL,'Monica Rivera','FI','639129767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:58',0,'2014-03-02 07:23:39'),(15017,15468,'2014-01-01','ET','2',1,NULL,'Karen lee Weber','FI','299480359','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:17',0,'2014-03-10 14:10:12'),(14490,14941,'2014-01-01','ET','2',1,NULL,'Theresa Templeman','FI','436904458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:48',0,'2014-03-02 05:38:34'),(13216,13572,'2014-01-01','ET','2',1,NULL,'Bradly Hays','FI','410314480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:40',0,'2014-03-02 05:17:40'),(1189,1189,'2014-01-01','ET','2',1,NULL,'patrick durbin','FI','536665137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:26',0,'2014-03-02 04:45:37'),(5246,5246,'2014-01-01','ET','2',1,NULL,'Donald Wiechart','FI','299620870','HealthSpan','FI','311431434','Donald  Wiechart','94','1498942','348','2014-01-01','Sync Success',0,'2013-12-26 00:53:53',0,'2014-03-10 13:20:27'),(2248,2248,'2014-01-01','ET','2',1,NULL,'Karen Levo','FI','283524864','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:52',0,'2014-03-10 13:10:24'),(11690,11690,'2014-01-01','ET','2',1,NULL,'Michael Whitty','FI','485151954','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:37',0,'2014-03-02 04:59:36'),(3675,3675,'2014-01-01','ET','2',1,NULL,'CHARLES SAWYER','FI','427112244','Starmount Life Insurance Company','FI','720977315','VIRGINIA  BAILEY','94','8613861','348','2014-01-01','Sync Success',0,'2013-12-25 22:06:42',0,'2014-03-02 00:10:48'),(11285,11285,'2014-01-01','ET','2',1,NULL,'matthew armstrong','FI','428232810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:03',0,'2014-03-02 04:52:44'),(148,148,'2014-01-01','ET','2',1,NULL,'SILVIA E KEARNEY','FI','296962551','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:37',0,'2014-03-10 15:45:56'),(14254,14705,'2014-01-01','ET','2',1,NULL,'Carla  Williams','FI','079624523','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:04',0,'2014-03-01 16:46:19'),(11055,11055,'2014-01-01','ET','2',2,1,'Michael Ian Barrett','FI','282623118','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:38',0,'2014-03-10 13:39:10'),(14757,15208,'2014-01-01','ET','2',1,NULL,'Donald Rood','FI','286542225','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:30',0,'2014-03-10 16:17:47'),(13882,14238,'2014-01-01','ET','2',1,NULL,'Ozzie Cunningham','FI','436826076','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:09',0,'2014-03-02 05:31:31'),(14380,14831,'2014-01-01','ET','2',3,2,'Julie Maier','FI','284466904','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:58',0,'2014-03-01 16:46:19'),(21904,22554,'0000-00-00','ET','2',2,1,'clifford ray wiley','FI','450857345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:47',0,'2014-03-05 22:27:33'),(21986,22636,'0000-00-00','ET','2',2,1,'GEORGE BAJOR','FI','294665876','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:43',0,'2014-03-10 16:44:18'),(22509,23159,'0000-00-00','ET','2',1,NULL,'MARGOT E CRUZ','FI','661092749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:17',0,'2014-03-07 22:26:59'),(22607,23257,'0000-00-00','ET','2',2,1,'APRIL SHINDELDECKER','FI','275660954','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:29',0,'2014-03-10 14:50:59'),(239,239,'2014-01-01','ET','2',1,0,'Stephen Mobley','FI','636167211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:29',0,'2014-03-01 19:11:03'),(18319,18969,'0000-00-00','ET','2',2,1,'Adam Scherr','FI','413491321','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:04',0,'2014-03-01 17:26:36'),(323,323,'2014-01-01','ET','2',1,NULL,'Patrick McCreary','FI','305605797','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:56',0,'2014-03-01 15:21:15'),(11345,11345,'2014-01-01','ET','2',1,NULL,'Samuel Brian Franks','FI','452191240','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:51',0,'2014-03-02 04:52:44'),(11201,11201,'2014-01-01','ET','2',1,NULL,'Sarah Farris','FI','283828648','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:29',0,'2014-03-01 16:23:43'),(4927,4927,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:03',0,'2014-03-10 13:03:33'),(20250,20900,'0000-00-00','ET','2',4,3,'TED PLATTENBURG','FI','268685315','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:32:09',0,'2014-03-10 14:37:47'),(20297,20947,'0000-00-00','ET','2',1,NULL,'DeAnna LaHaye','FI','438868322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:40',0,'2014-03-02 07:03:25'),(20512,21162,'0000-00-00','ET','2',1,NULL,'Toni LaFountain','FI','009481325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:51',0,'2014-03-02 07:17:36'),(21428,22078,'0000-00-00','ET','2',1,NULL,'mattie taylor','FI','435960925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:01',0,'2014-03-03 22:26:43'),(1380,1380,'2014-01-01','ET','2',1,NULL,'TOSHIA NEWSOME','FI','452910721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:22',0,'2014-03-02 04:45:37'),(3580,3580,'2014-01-01','ET','2',1,NULL,'MARTIN CHAVEZ','FI','450454699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:44',0,'2014-03-02 00:10:48'),(16433,17083,'0000-00-00','ET','2',1,NULL,'Evan Gill','FI','302081572','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:47',0,'2014-03-10 14:20:26'),(4024,4024,'2014-01-01','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:00:53',0,'2014-03-02 03:09:49'),(20551,21201,'0000-00-00','ET','2',1,NULL,'catherine spoon','FI','452815797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:17',0,'2014-03-02 07:17:36'),(21419,22069,'0000-00-00','ET','2',4,3,'Teresa Drees','FI','294461325','HealthSpan','FI','311431434','Gail  Fink','94','967574','348','2014-04-01','Sync Success',0,'2014-03-03 21:00:22',0,'2014-03-10 14:45:25'),(201,201,'2014-01-01','ET','2',1,NULL,'Tabitha Snyder','FI','272922088','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:21:17',0,'2014-03-10 13:10:24'),(13124,13480,'2014-01-01','ET','2',1,NULL,'Jordan Reagan','FI','635075864','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:55',0,'2014-03-02 05:17:40'),(16281,16931,'0000-00-00','ET','2',1,NULL,'VERONICA FLORES','FI','449651796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:11',0,'2014-03-02 06:10:30'),(2251,2251,'2014-01-01','ET','2',2,1,'James Shultz','FI','275589947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:59',0,'2014-03-10 13:10:24'),(4674,4674,'2014-01-01','ET','2',6,5,'Rolanda Clark','FI','288743786','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:42',0,'2014-03-01 16:15:39'),(6133,6133,'2014-01-01','ET','2',1,NULL,'Kris Scheid','FI','273765626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:21',0,'2014-03-01 16:00:27'),(7301,7301,'2014-01-01','ET','2',1,NULL,'laquita Day','FI','425693953','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:45',0,'2014-03-02 03:09:49'),(10396,10396,'2014-01-01','ET','2',1,NULL,'James bryan Crook','FI','271504312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:35',0,'2014-03-01 16:10:36'),(12165,12165,'2014-01-01','ET','2',1,NULL,'Michelle Jordan','FI','551750562','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:56',0,'2014-03-02 04:59:36'),(20415,21065,'0000-00-00','ET','2',5,4,'MIESHA  WILLSON','FI','293744800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:39',0,'2014-03-01 18:08:07'),(12262,12262,'2014-01-01','ET','2',2,1,'norberto juarez','FI','452235764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:53',0,'2014-03-02 05:10:52'),(19440,20090,'0000-00-00','ET','2',1,NULL,'Terry Coger','FI','297446259','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:39',0,'2014-03-10 14:31:05'),(11719,11719,'2014-01-01','ET','2',1,NULL,'cyris brumfield','FI','428638827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:29',0,'2014-03-02 04:59:36'),(18415,19065,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:12',0,'2014-03-01 17:26:36'),(19838,20488,'0000-00-00','ET','2',1,NULL,'ALICE OLOUGHLIN','FI','289504948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:55',0,'2014-03-01 17:47:19'),(21587,22237,'0000-00-00','ET','2',1,NULL,'Samantha Hill','FI','439615500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:10',0,'2014-03-04 21:27:16'),(22111,22761,'0000-00-00','ET','2',1,NULL,'MICHEAL THOMAS','FI','640100593','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:37',0,'2014-03-06 21:27:26'),(22267,22917,'0000-00-00','ET','2',1,NULL,'Kim Hissong','FI','503943186','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:28',0,'2014-03-10 14:45:25'),(23099,23749,'0000-00-00','ET','2',1,NULL,'Cathy Berish','FI','297709266','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:01',0,'2014-03-10 21:35:03'),(270,270,'2014-01-01','ET','2',1,0,'Daniel Pryor','FI','277767568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:36',0,'2014-03-01 15:05:09'),(19052,19702,'0000-00-00','ET','2',1,NULL,'Joel Rush','FI','460045281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-15 22:00:09',0,'2014-03-02 06:52:12'),(1696,1696,'2014-01-01','ET','2',2,1,'Joseph Whittenton Pierce','FI','431922982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:22',0,'2014-03-02 00:10:48'),(10383,10383,'2014-01-01','ET','2',1,NULL,'Vada Mack','FI','294661624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:11',0,'2014-03-01 16:10:36'),(21329,21979,'0000-00-00','ET','2',3,2,'Fayzollah Ghashghaee','FI','447708877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:12',0,'2014-03-03 01:07:25'),(13971,14327,'2014-01-01','ET','2',1,NULL,'Erica mcelvany','FI','642057552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:09',0,'2014-03-02 05:31:31'),(19183,19833,'0000-00-00','ET','2',1,NULL,'Jason House','FI','283562684','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:50',0,'2014-03-10 14:31:05'),(12174,12174,'2014-01-01','ET','2',1,NULL,'Roger Lewis','FI','297583703','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:17',0,'2014-03-10 13:52:32'),(11973,11973,'2014-01-01','ET','2',1,NULL,'Marilyn Elliott','FI','467391104','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:06',0,'2014-03-02 04:59:36'),(11595,11595,'2014-01-01','ET','2',1,NULL,'Carolyn Johnson','FI','426060128','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:36',0,'2014-03-02 04:52:44'),(2311,2311,'2014-01-01','ET','2',1,NULL,'Rose Jung','FI','236827020','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:37',0,'2014-03-01 15:05:09'),(2597,2597,'2014-01-01','ET','2',1,0,'KAVEN PETTIES','FI','364641558','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:57',0,'2014-03-01 15:05:09'),(5396,5396,'2014-01-01','ET','2',1,NULL,'Barbara Eady','FI','302467067','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:02',0,'2014-03-10 13:03:33'),(11136,11136,'2014-01-01','ET','2',3,2,'VELVETTEE HUX','FI','262849045','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:26',0,'2014-03-10 13:39:10'),(933,933,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:08',0,'2014-03-01 21:11:04'),(1903,1903,'2014-01-01','ET','2',1,NULL,'Seth Newell','FI','459597539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:51',0,'2014-03-01 23:10:52'),(15394,15845,'0000-00-00','ET','2',1,NULL,'Chrissy Le','FI','630283244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:06',0,'2014-03-02 05:59:43'),(15277,15728,'0000-00-00','ET','2',1,NULL,'Bobette Burke','FI','461192798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:46:05',0,'2014-03-02 05:52:31'),(10803,10803,'2014-01-01','ET','2',1,NULL,'connie montgomery','FI','416884733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:57',0,'2014-03-02 04:24:47'),(4761,4761,'2014-01-01','ET','2',2,1,'Robert Perkoski','FI','278547960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:41',0,'2014-03-01 15:16:37'),(7335,7335,'2014-01-01','ET','2',1,NULL,'Michelle Rammel','FI','296668687','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:49',0,'2014-03-10 13:32:15'),(1338,1338,'2014-01-01','ET','2',1,NULL,'RICKY CASTILLO','FI','450533391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:00',0,'2014-03-02 04:38:08'),(19655,20305,'0000-00-00','ET','2',1,NULL,'Nancy Moore','FI','277689072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:44:51',0,'2014-03-01 17:47:19'),(2183,2183,'2014-01-01','ET','2',2,1,'Mohamed Habib','FI','329683615','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:35',0,'2014-03-01 21:11:04'),(17219,17869,'0000-00-00','ET','2',1,NULL,'JAY PAVLINAK','FI','301883725','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:15',0,'2014-03-01 17:20:55'),(15184,15635,'0000-00-00','ET','2',1,NULL,'Abel Perez Goiere','FI','635312208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:15',0,'2014-03-02 05:52:31'),(3429,3429,'2014-01-01','ET','2',3,2,'teresa davis','FI','294745384','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:37',0,'2014-03-10 13:24:34'),(11351,11351,'2014-01-01','ET','2',1,NULL,'Randall Skolnik','FI','435023293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:05:04',0,'2014-03-02 04:45:37'),(11829,11829,'2014-01-01','ET','2',1,NULL,'Quindell LeBeouf','FI','439578436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:01',0,'2014-03-02 04:31:46'),(4083,4083,'2014-01-01','ET','2',2,1,'WILLIAM HATTON','FI','296489448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:47',0,'2014-03-01 16:00:27'),(12876,12876,'2014-01-01','ET','2',1,NULL,'Saundra McIntosh','FI','284661595','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:00',0,'2014-03-01 16:35:14'),(7375,7375,'2014-01-01','ET','2',1,NULL,'Virginia Numbers','FI','273508063','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:25',0,'2014-03-10 13:03:33'),(14237,14688,'2014-01-01','ET','2',1,NULL,'MICHAEL RAY WALKER','FI','430232464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:05:56',0,'2014-03-02 05:38:34'),(13502,13858,'2014-01-01','ET','2',1,NULL,'Karla Ingram','FI','463880028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:18',0,'2014-03-02 05:24:45'),(5434,5434,'2014-01-01','ET','2',1,0,'MARY ANN RUTLEDGE','FI','273546368','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:28',0,'2014-03-01 15:05:09'),(20608,21258,'0000-00-00','ET','2',3,2,'James McKnight','FI','287444200','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:53',0,'2014-03-01 18:08:07'),(22063,22713,'0000-00-00','ET','2',1,NULL,'Maureen Hemenway','FI','298469195','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:32:38',0,'2014-03-10 14:45:25'),(787,787,'2014-01-01','ET','2',2,1,'Richard Molina','FI','573883870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:42',0,'2014-03-01 19:11:03'),(3090,3090,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:54',0,'2014-03-02 01:10:33'),(16330,16980,'0000-00-00','ET','2',2,1,'Alana Hughes','FI','426656775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:42',0,'2014-03-02 06:10:30'),(13385,13741,'2014-01-01','ET','2',1,NULL,'LINDSEY A CLARK','FI','294564003','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:47',0,'2014-03-10 16:10:34'),(3666,3666,'2014-01-01','ET','2',1,NULL,'Kenyatta Johnson','FI','426491626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:24',0,'2014-03-02 00:10:48'),(4477,4477,'2014-01-01','ET','2',1,NULL,'Carmen Coronado','FI','368588970','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:18',0,'2014-03-01 21:11:04'),(21158,21808,'0000-00-00','ET','2',1,NULL,'William Thomas','FI','439961674','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:26',0,'2014-03-02 07:23:39'),(40,40,'2014-01-01','ET','2',1,NULL,'Wanda  Evers Johnson','FI','326603008','Starmount Life Insurance Company','FI','720977315','Jeffrey  Chance','94','2114967','348','2014-01-01','Sync Success',0,'2013-12-25 17:16:11',0,'2014-03-01 22:10:55'),(517,517,'2014-01-01','ET','2',1,NULL,'Edward Freeman','FI','281465082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:58',0,'2014-03-01 15:48:04'),(18897,19547,'0000-00-00','ET','2',1,NULL,'BETTY F WEATHERS','FI','268766115','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:59',0,'2014-03-01 17:34:07'),(17940,18590,'0000-00-00','ET','2',1,NULL,'TODD D ROBINSON','FI','587479892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:56',0,'2014-03-02 06:31:45'),(966,966,'2014-01-01','ET','2',2,1,'Michelle Sandstrom','FI','292846554','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:10',0,'2014-03-10 15:39:19'),(1254,1254,'2014-01-01','ET','2',1,NULL,'Meredith Amann','FI','269886326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:20',0,'2014-03-01 16:15:39'),(14361,14812,'2014-01-01','ET','2',1,NULL,'Rubina Minhas','94','0001260031','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:50',0,'2014-03-10 16:17:47'),(16412,17062,'0000-00-00','ET','2',1,NULL,'Mary Winget','FI','283481806','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:34',0,'2014-03-10 16:24:30'),(2002,2002,'2014-01-01','ET','2',1,NULL,'LILLIAN JENKINS','FI','439177805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:56',0,'2014-03-01 23:10:52'),(15162,15613,'0000-00-00','ET','2',1,NULL,'Rosemary Brown','FI','587346780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:35',0,'2014-03-02 05:52:31'),(7153,7153,'2014-01-01','ET','2',2,1,'Gordon Garling','FI','268600130','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:10',0,'2014-03-10 15:52:36'),(4452,4452,'2014-01-01','ET','2',1,NULL,'Joseph Kane','FI','271809138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:30',0,'2014-03-01 15:16:37'),(7318,7318,'2014-01-01','ET','2',1,NULL,'SHARON SMITH','FI','302567156','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:10:15',0,'2014-03-10 13:32:15'),(19671,20321,'0000-00-00','ET','2',2,1,'Sukhdev Cheema','FI','296153683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:48:36',0,'2014-03-01 17:47:19'),(7156,7156,'2014-01-01','ET','2',1,NULL,'Donna Berbig','FI','283527184','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:17',0,'2014-03-10 15:59:47'),(15255,15706,'0000-00-00','ET','2',2,1,'Laura Sandoval','FI','222825721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:32',0,'2014-03-02 05:52:31'),(1772,1772,'2014-01-01','ET','2',1,NULL,'Amanda Fuller','FI','433673966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:40',0,'2014-03-02 00:10:48'),(3414,3414,'2014-01-01','ET','2',1,NULL,'MILGRED B WILLIAMS','FI','587366216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:10',0,'2014-03-02 02:10:49'),(6259,6259,'2014-01-01','ET','2',2,1,'brett cervini','FI','439087082','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:11',0,'2014-03-02 04:10:25'),(6061,6061,'2014-01-01','ET','2',1,NULL,'Jessica Patterson','FI','439698997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:04',0,'2014-03-02 04:10:25'),(2538,2538,'2014-01-01','ET','2',2,1,'Justen Seay','FI','364980960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:09',0,'2014-03-01 15:10:22'),(4562,4562,'2014-01-01','ET','2',1,NULL,'Alexis Korman','FI','625245872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:05',0,'2014-03-02 04:38:08'),(4346,4346,'2014-01-01','ET','2',6,5,'Syed Zafar','FI','591029242','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:38',0,'2014-03-10 13:32:15'),(7486,7486,'2014-01-01','ET','2',1,NULL,'Mary Merusi','FI','269743048','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:33:34',0,'2014-03-10 13:39:10'),(18647,19297,'0000-00-00','ET','2',1,NULL,'Siobhan Slone','FI','296840591','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:11',0,'2014-03-01 17:34:07'),(11800,11800,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2013-12-29 11:13:08',0,'2014-03-10 16:03:49'),(12681,12681,'2014-01-01','ET','2',1,NULL,'kenneth burns','FI','273705521','Dental Care Plus, Inc.','FI','311185262','Michael  Daughtery','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-03 02:04:02',0,'2014-03-01 16:35:14'),(20704,21354,'0000-00-00','ET','2',1,NULL,'Jacob Mattes','FI','299924952','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:14',0,'2014-03-10 16:38:05'),(2040,2040,'2014-01-01','ET','2',1,NULL,'Karen Kornbacher','FI','435339999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:06',0,'2014-03-02 00:10:48'),(16935,17585,'0000-00-00','ET','2',1,NULL,'DONNA WARDEN','FI','425027898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:48',0,'2014-03-02 06:17:30'),(16237,16886,'0000-00-00','ET','2',1,NULL,'Elizabeth Hrusovsky','FI','298904405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:01:04',0,'2014-03-10 16:24:30'),(3053,3053,'2014-01-01','ET','2',4,3,'LaKisha Williams','FI','287888848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:44',0,'2014-03-01 15:37:30'),(15303,15754,'0000-00-00','ET','2',1,NULL,'Margarite Jacobs','FI','270521726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:46:20',0,'2014-03-01 16:50:53'),(13603,13959,'2014-01-01','ET','2',1,NULL,'heather freytes','FI','049888917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:27',0,'2014-03-01 16:40:16'),(3802,3802,'2014-01-01','ET','2',4,3,'D Renee Pendleton','FI','292704101','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:23',0,'2014-03-10 15:45:56'),(10822,10822,'2014-01-01','ET','2',1,NULL,'John Wagnon','FI','433736445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:36',0,'2014-03-02 04:31:46'),(4662,4662,'2014-01-01','ET','2',2,1,'Gary Shell','FI','270527476','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:18',0,'2014-03-01 16:15:39'),(12973,12973,'2014-01-01','ET','2',1,NULL,'GERARDO GUTIERREZ','FI','452572467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:11',0,'2014-03-02 05:17:40'),(20746,21396,'0000-00-00','ET','2',1,NULL,'mandy fugate','FI','290744698','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:33',0,'2014-03-01 18:10:11'),(11223,11223,'2014-01-01','ET','2',1,NULL,'randy archer','FI','302420646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:08',0,'2014-03-01 16:23:43'),(7098,7098,'2014-01-01','ET','2',1,NULL,'James Still','FI','268509716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:33',0,'2014-03-01 15:52:44'),(17470,18120,'0000-00-00','ET','2',1,NULL,'CAROLYN MCGRAW','FI','316584932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:01:31',0,'2014-03-02 06:31:45'),(14158,14609,'2014-01-01','ET','2',1,NULL,'andrew steele','FI','279948039','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:33:12',0,'2014-03-10 16:17:47'),(1473,1473,'2014-01-01','ET','2',1,NULL,'Teresa Myrick','FI','285545800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:35',0,'2014-03-01 16:23:43'),(3361,3361,'2014-01-01','ET','2',1,NULL,'Connie Noel','FI','455190223','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:28',0,'2014-03-02 02:10:49'),(3836,3836,'2014-01-01','ET','2',1,NULL,'Deborah Busse','FI','287546692','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:08',0,'2014-03-10 13:03:33'),(19281,19931,'0000-00-00','ET','2',1,NULL,'Brandi Welch','FI','277786166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:05',0,'2014-03-01 17:34:07'),(20702,21352,'0000-00-00','ET','2',1,NULL,'Bradley Bourgeois','FI','434539631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:13',0,'2014-03-02 07:17:36'),(6085,6085,'2014-01-01','ET','2',1,NULL,'TIMOTHY SCOTT WOYAN','FI','278865219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:52',0,'2014-03-01 16:00:27'),(18734,19384,'0000-00-00','ET','2',1,NULL,'Margareta Moore','FI','587749176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:18',0,'2014-03-02 06:52:12'),(705,705,'2014-01-01','ET','2',1,NULL,'MARK RICH','FI','301561195','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:53',0,'2014-03-10 15:52:36'),(17061,17711,'0000-00-00','ET','2',1,NULL,'JASON RIDDLE','FI','461936303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:36',0,'2014-03-02 06:24:38'),(1789,1789,'2014-01-01','ET','2',1,NULL,'DEBORAH GAERTNER','FI','281528470','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:16',0,'2014-03-10 13:20:27'),(3432,3432,'2014-01-01','ET','2',1,NULL,'W Teague','FI','523725895','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:44',0,'2014-03-10 13:32:15'),(14155,14606,'2014-01-01','ET','2',1,NULL,'Penny  Miller','FI','306687507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:10',0,'2014-03-02 05:38:34'),(21708,22358,'0000-00-00','ET','2',1,NULL,'CHRISTIAN JONES','FI','433731053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:45',0,'2014-03-04 21:27:16'),(648,648,'2014-01-01','ET','2',1,NULL,'Scott M Leavell','FI','372884837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:05:10',0,'2014-03-02 02:10:49'),(16784,17434,'0000-00-00','ET','2',1,NULL,'Robert Kenard','FI','336466444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:31',0,'2014-03-02 06:17:30'),(12754,12754,'2014-01-01','ET','2',3,2,'LIFEM HE','FI','282947122','HealthSpan','FI','311431434','BEIBEI   ALLEN','94','16509029','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:50',0,'2014-03-10 13:59:38'),(2185,2185,'2014-01-01','ET','2',3,2,'irma rios','FI','460592116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:38',0,'2014-03-01 21:11:04'),(17218,17868,'0000-00-00','ET','2',1,NULL,'randall gabriel','FI','466934353','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:15',0,'2014-03-01 17:20:55'),(4474,4474,'2014-01-01','ET','2',1,NULL,'Bonnie Godines','FI','466934435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:12',0,'2014-03-01 21:11:04'),(5062,5062,'2014-01-01','ET','2',1,NULL,'Justin Bell','FI','268868405','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:59',0,'2014-03-01 15:31:33'),(7543,7543,'2014-01-01','ET','2',1,NULL,'KENT CALLAND','FI','275683225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:23',0,'2014-03-01 16:05:34'),(13117,13473,'2014-01-01','ET','2',2,1,'Ida Rodriguez','FI','467350471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:35',0,'2014-03-02 05:17:40'),(18990,19640,'0000-00-00','ET','2',1,NULL,'Gerard Germani','FI','380824943','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:07',0,'2014-03-10 14:31:05'),(18973,19623,'0000-00-00','ET','2',1,NULL,'Raquel Perez','FI','272887131','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:55',0,'2014-03-10 14:31:05'),(98,98,'2014-01-01','ET','2',1,NULL,'WALTER D BAILEY','FI','464886942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:59',0,'2014-03-01 22:10:55'),(17756,18406,'0000-00-00','ET','2',2,1,'LEOBARDO  RAMIREZ','FI','415951069','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:40',0,'2014-03-02 06:31:45'),(844,844,'2014-01-01','ET','2',2,1,'Laura Dorsey','FI','433710147','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:28',0,'2014-03-01 22:10:55'),(12982,12982,'2014-01-01','ET','2',1,NULL,'BRITTANY SMITH','FI','300924916','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:30',0,'2014-03-10 13:59:38'),(16124,16773,'0000-00-00','ET','2',1,NULL,'christine durr','FI','587487469','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:36',0,'2014-03-02 06:03:21'),(11654,11654,'2014-01-01','ET','2',1,NULL,'donna jacques','FI','285607156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:23',0,'2014-03-01 16:30:17'),(5692,5692,'2014-01-01','ET','2',1,NULL,'Sandra Massie','FI','284568461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:09',0,'2014-03-01 15:37:30'),(4866,4866,'2014-01-01','ET','2',1,NULL,'sharon barard','FI','434236625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:08',0,'2014-03-01 20:10:57'),(21369,22019,'0000-00-00','ET','2',2,1,'Maynard Randles','FI','283484777','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-03 01:00:35',0,'2014-03-10 16:38:05'),(193,193,'2014-01-01','ET','2',1,NULL,'kevin english','FI','293623312','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:00',0,'2014-03-10 13:10:24'),(11359,11359,'2014-01-01','ET','2',1,NULL,'Waymon Graves','FI','431900403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:20',0,'2014-03-02 04:45:37'),(11183,11183,'2014-01-01','ET','2',1,NULL,'Carol Hesser','FI','301685421','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:17:04',0,'2014-03-10 13:45:57'),(7024,7024,'2014-01-01','ET','2',1,NULL,'Margaret Woodward','FI','636015009','Starmount Life Insurance Company','FI','720977315','Daniel  C Haydin Jr','94','1129677','348','2014-01-01','Sync Success',0,'2013-12-26 04:01:14',0,'2014-03-02 03:09:49'),(6090,6090,'2014-01-01','ET','2',1,NULL,'GWENDOLYN EATHRIDGE','FI','292705117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:01',0,'2014-03-01 16:00:27'),(14580,15031,'2014-01-01','ET','2',1,NULL,'adan  orona','FI','627320393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:37',0,'2014-03-02 05:45:37'),(14536,14987,'2014-01-01','ET','2',1,NULL,'ALEX  CABIGON','FI','268904488','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:10',0,'2014-03-10 14:03:26'),(5981,5981,'2014-01-01','ET','2',1,NULL,'Madison Quesenberry','FI','272920773','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:23',0,'2014-03-10 13:24:34'),(14080,14531,'2014-01-01','ET','2',1,NULL,'LUCIA MARTINEZ VALDEZ','FI','008491943','Starmount Life Insurance Company','FI','720977315','MICHAEL  RAMM','94','228443','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:23',0,'2014-03-02 05:38:34'),(20660,21310,'0000-00-00','ET','2',1,NULL,'Elaine Coull','FI','299522792','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:32',0,'2014-03-10 16:38:05'),(20913,21563,'0000-00-00','ET','2',1,NULL,'Keisha Harp','FI','275900628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:08',0,'2014-03-01 18:08:07'),(21717,22367,'0000-00-00','ET','2',1,NULL,'Jodi Allen Parks','FI','311682387','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:52',0,'2014-03-04 21:27:16'),(10421,10421,'2014-01-01','ET','2',1,NULL,'vincent tom vespucci','FI','270964563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:22',0,'2014-03-01 16:10:36'),(19129,19779,'0000-00-00','ET','2',1,NULL,'IVY OSBORNE','FI','299828244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:05',0,'2014-03-01 17:34:07'),(18178,18828,'0000-00-00','ET','2',2,1,'Kay Cole','FI','269643360','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:36',0,'2014-03-01 17:26:36'),(20599,21249,'0000-00-00','ET','2',1,NULL,'RENEE WOLLERMAN','FI','283887274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-13','Sync Success',0,'2014-02-26 21:01:48',0,'2014-03-01 18:08:07'),(11856,11856,'2014-01-01','ET','2',1,NULL,'Barbara Miller','FI','298506070','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:00',0,'2014-03-10 13:45:57'),(19374,20024,'0000-00-00','ET','2',1,NULL,'OLGA FLICK','FI','300541224','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:49',0,'2014-03-01 17:34:07'),(2364,2364,'2014-01-01','ET','2',2,1,'RAJNIKANT PATEL','FI','298119269','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:08',0,'2014-03-01 15:26:40'),(2714,2714,'2014-01-01','ET','2',1,NULL,'harvey wheaton','FI','548824873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:37',0,'2014-03-02 04:15:49'),(16583,17233,'0000-00-00','ET','2',4,3,'Matthew Henry','FI','576629098','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:32',0,'2014-03-10 14:20:26'),(15624,16075,'0000-00-00','ET','2',1,NULL,'Kathleen Houstin','FI','276546427','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:47',0,'2014-03-10 14:10:12'),(753,753,'2014-01-01','ET','2',1,NULL,'Melissa Ledsome','FI','277963877','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:08:28',0,'2014-03-10 15:52:36'),(19336,19986,'0000-00-00','ET','2',1,NULL,'Veronica Ochoa','FI','455477299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:24',0,'2014-03-02 06:59:07'),(19331,19981,'0000-00-00','ET','2',2,1,'MARIA LUCERO','FI','525611613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:20',0,'2014-03-02 06:59:07'),(19228,19878,'0000-00-00','ET','2',1,NULL,'Jose Diaz','FI','609318056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:23',0,'2014-03-02 06:52:12'),(1078,1078,'2014-01-01','ET','2',1,NULL,'Maria Bautista','FI','464898141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:12',0,'2014-03-01 19:11:03'),(1241,1241,'2014-01-01','ET','2',1,NULL,'John Nicholas','FI','277685018','Dental Care Plus, Inc.','FI','311185262','Joseph  Dintino','94','2207884','348','2014-01-01','Sync Success',0,'2013-12-25 18:48:57',0,'2014-03-01 16:15:39'),(11849,11849,'2014-01-01','ET','2',2,1,'Ryan Kirchmer','FI','302749572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:44',0,'2014-03-01 16:15:39'),(4094,4094,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:06',0,'2014-03-01 16:00:27'),(5210,5210,'2014-01-01','ET','2',1,NULL,'MARLENE LEBOUEF','FI','439881156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:41',0,'2014-03-02 00:10:48'),(11342,11342,'2014-01-01','ET','2',1,NULL,'Eric Rodriguez','FI','456794287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:04:47',0,'2014-03-02 04:52:44'),(3050,3050,'2014-01-01','ET','2',2,1,'Benjamin Tupaz','FI','269703499','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:37',0,'2014-03-01 15:37:30'),(6284,6284,'2014-01-01','ET','2',1,NULL,'Donald Warren','FI','435960126','Starmount Life Insurance Company','FI','720977315','Melvin  Thomas','94','4745590','357','2014-01-01','Sync Success',0,'2013-12-26 03:06:58',0,'2014-03-02 04:10:25'),(21264,21914,'0000-00-00','ET','2',1,NULL,'April Dawn Civitarese','FI','268824546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-01 21:00:39',0,'2014-03-01 21:35:40'),(21359,22009,'0000-00-00','ET','2',4,3,'Stacey Marie Hamric','FI','270709081','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:28',0,'2014-03-10 16:38:05'),(12207,12207,'2014-01-01','ET','2',1,NULL,'William Fowlkes','FI','316805554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:45',0,'2014-03-01 16:35:14'),(19178,19828,'0000-00-00','ET','2',1,NULL,'Marsha Hammons','FI','438047952','Starmount Life Insurance Company','FI','720977315','David  Wade  Gilliland','94','1672953','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:45',0,'2014-03-02 06:52:12'),(5009,5009,'2014-01-01','ET','2',6,5,'Charles Adam Setser','FI','591076901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:15',0,'2014-03-01 15:31:33'),(16113,16762,'0000-00-00','ET','2',1,NULL,'Steven Moran','FI','405110657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:27',0,'2014-03-02 06:03:21'),(23061,23711,'0000-00-00','ET','2',2,1,'Jacqueline Estep','FI','293764111','HealthSpan','FI','311431434','Michelle  Sweeney','94','2438648','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:36',0,'2014-03-10 21:17:52'),(2678,2678,'2014-01-01','ET','2',2,1,'Scott Butler','FI','527155693','Starmount Life Insurance Company','FI','720977315','Jim  Boldin','94','1130394','348','2014-01-01','Sync Success',0,'2013-12-25 21:16:28',0,'2014-03-02 04:15:49'),(16975,17625,'0000-00-00','ET','2',1,NULL,'Jacob V Gurwell','94','0000374734','Dental Care Plus, Inc.','FI','311185262','Nicole  Katon','94','9025717','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:14',0,'2014-03-01 17:00:58'),(14322,14773,'2014-01-01','ET','2',1,NULL,'Olga Medina','FI','461865446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:34',0,'2014-03-02 05:38:34'),(5260,5260,'2014-01-01','ET','2',1,NULL,'Kevin Yates','FI','302602283','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:02',0,'2014-03-01 15:10:22'),(14174,14625,'2014-01-01','ET','2',5,4,'Sarah Hindel','FI','299601175','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:22',0,'2014-03-10 16:17:47'),(6455,6455,'2014-01-01','ET','2',2,1,'Deborah Olmstead','FI','283602010','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:18',0,'2014-03-10 13:03:33'),(11311,11311,'2014-01-01','ET','2',1,NULL,'EARL HILL','FI','435765363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:51',0,'2014-03-02 04:45:37'),(21175,21825,'0000-00-00','ET','2',1,NULL,'THAWANN TAYLOR','FI','426497466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:39',0,'2014-03-02 07:23:39'),(21492,22142,'0000-00-00','ET','2',1,NULL,'Dominic Anthony Musarra','FI','292904949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:49',0,'2014-03-03 21:36:16'),(14022,14378,'2014-01-01','ET','2',1,NULL,'Martin Gilmer','FI','294900830','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:47',0,'2014-03-10 16:17:47'),(7555,7555,'2014-01-01','ET','2',1,NULL,'Sarah Iammarino','FI','281743349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:48',0,'2014-03-01 16:05:34'),(3085,3085,'2014-01-01','ET','2',1,NULL,'ETHEL DAVIS','FI','439869436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:45',0,'2014-03-02 01:10:33'),(3082,3082,'2014-01-01','ET','2',1,NULL,'Shantel Fountain','FI','463619785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:39',0,'2014-03-02 01:10:33'),(20552,21202,'0000-00-00','ET','2',1,NULL,'TRACY EVANS','FI','456492871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:18',0,'2014-03-02 07:17:36'),(22320,22970,'0000-00-00','ET','2',4,3,'Natalie Moser','FI','644149207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:10',0,'2014-03-06 22:25:29'),(699,699,'2014-01-01','ET','2',1,NULL,'Linda Rougeau','FI','439980765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:42',0,'2014-03-02 02:10:49'),(18722,19372,'0000-00-00','ET','2',1,NULL,'david vest','FI','458827932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:09',0,'2014-03-02 06:45:14'),(14190,14641,'2014-01-01','ET','2',2,1,'MICHAEL TOLLE','FI','278560055','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:32',0,'2014-03-10 14:03:26'),(12471,12471,'2014-01-01','ET','2',1,NULL,'Todd Smith','FI','286866405','Dental Care Plus, Inc.','FI','311185262','Heidi  McArthur','94','8621177','357','2014-02-01','Sync Success',1,'2014-01-02 04:32:16',0,'2014-03-01 16:30:17'),(15736,16385,'0000-00-00','ET','2',1,NULL,'Young Jin','FI','281686434','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:01:13',0,'2014-03-10 14:10:12'),(10992,10992,'2014-01-01','ET','2',1,NULL,'Leon Harris','FI','587500950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:29',0,'2014-03-02 04:24:47'),(3206,3206,'2014-01-01','ET','2',2,1,'JEREMY SPENCE','FI','421170204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:28',0,'2014-03-01 15:48:04'),(20649,21299,'0000-00-00','ET','2',1,NULL,'Sharon Zornes','FI','288543094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:24',0,'2014-03-10 16:38:05'),(200,200,'2014-01-01','ET','2',1,NULL,'Terry Agner','FI','291507833','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 17:21:15',0,'2014-03-10 13:10:24'),(12517,12517,'2014-01-01','ET','2',1,NULL,'doristean mclaughlin','FI','587600465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:58',0,'2014-03-02 05:03:29'),(15433,15884,'0000-00-00','ET','2',1,NULL,'Shawn Caughey','FI','277567504','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',1,'2014-01-22 03:22:31',0,'2014-03-10 16:17:47'),(14965,15416,'2014-01-01','ET','2',1,NULL,'Brittany Baker','FI','280944579','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:55',0,'2014-03-01 16:50:53'),(11353,11353,'2014-01-01','ET','2',3,2,'Mostafa M Elkhatib','FI','578801403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:07',0,'2014-03-02 04:52:44'),(12518,12518,'2014-01-01','ET','2',1,NULL,'FELISSA COLEMAN','FI','425084634','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:00',0,'2014-03-02 05:03:29'),(20975,21625,'0000-00-00','ET','2',1,NULL,'Edward Gerard Warren','FI','289620801','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:22',0,'2014-03-01 18:08:07'),(205,205,'2014-01-01','ET','2',3,2,'George Brunner','FI','277421561','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:25',0,'2014-03-10 13:10:24'),(16052,16701,'0000-00-00','ET','2',2,1,'Allyssa Hixenbaugh','FI','274785092','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:45',0,'2014-03-01 16:56:22'),(15896,16545,'0000-00-00','ET','2',1,NULL,'Bradford DeLaura','FI','276723136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:09',0,'2014-03-10 16:24:30'),(14373,14824,'2014-01-01','ET','2',1,NULL,'kraig daniel roberts','FI','294644150','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:55',0,'2014-03-10 16:17:47'),(7127,7127,'2014-01-01','ET','2',1,NULL,'MARY PARISE','FI','298466887','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:26',0,'2014-03-01 15:52:44'),(12964,12964,'2014-01-01','ET','2',1,NULL,'BILLIE  RAYE  EDWARDS','FI','430292305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:53',0,'2014-03-02 05:17:40'),(12384,12384,'2014-01-01','ET','2',1,NULL,'Alem Bahta','FI','273130447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:06',0,'2014-03-01 16:30:17'),(1938,1938,'2014-01-01','ET','2',1,NULL,'Loretta  Cooke','FI','301608487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:53',0,'2014-03-01 15:26:40'),(12269,12269,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:24:13',0,'2014-03-10 16:10:34'),(375,375,'2014-01-01','ET','2',1,NULL,'Martin Saenz','FI','457235077','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:35',0,'2014-03-10 15:45:56'),(16636,17286,'0000-00-00','ET','2',1,NULL,'Brent Johnson','FI','476882579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:32',0,'2014-03-02 06:17:30'),(10820,10820,'2014-01-01','ET','2',1,NULL,'julio vallejos','FI','434431494','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:32',0,'2014-03-02 04:31:46'),(16403,17053,'0000-00-00','ET','2',2,1,'ELIZA JACKSON-WILLIAMS','FI','587255803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:29',0,'2014-03-02 06:10:30'),(7547,7547,'2014-01-01','ET','2',1,NULL,'KRISTINA PAULIC','FI','273908515','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:32',0,'2014-03-01 16:05:34'),(5811,5811,'2014-01-01','ET','2',1,NULL,'Gary Mest','FI','175709668','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:56',0,'2014-03-10 15:52:36'),(21358,22008,'0000-00-00','ET','2',1,NULL,'STEFFANI RAYBURN','FI','271928804','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:28',0,'2014-03-10 14:45:25'),(22451,23101,'0000-00-00','ET','2',1,NULL,'Doris Clock','FI','280742970','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:35',0,'2014-03-10 14:50:59'),(22908,23558,'0000-00-00','ET','2',1,NULL,'Jeffrey Carrier','FI','439150292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:47',0,'2014-03-10 21:27:11'),(1930,1930,'2014-01-01','ET','2',2,1,'Baffour Otchere','FI','291766180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:37',0,'2014-03-01 15:26:40'),(13210,13566,'2014-01-01','ET','2',1,NULL,'Amanda Foss','FI','541396111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:24',0,'2014-03-02 05:17:40'),(18264,18914,'0000-00-00','ET','2',1,NULL,'Kathryn Richards','FI','383524176','HealthSpan','FI','311431434','Ronald J Fleeter','94','1834226','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:49',0,'2014-03-10 14:24:38'),(18161,18811,'0000-00-00','ET','2',2,1,'Stanley Kummer','FI','403649879','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:23',0,'2014-03-10 14:24:38'),(13126,13482,'2014-01-01','ET','2',1,NULL,'Emilio Juarez','FI','449379805','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:59',0,'2014-03-02 05:17:40'),(12250,12250,'2014-01-01','ET','2',1,NULL,'ADRAINE M KIRBY','FI','464771246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:26',0,'2014-03-02 05:03:29'),(7112,7112,'2014-01-01','ET','2',2,1,'Donna Fidak','FI','290425759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:56',0,'2014-03-01 15:52:44'),(12214,12214,'2014-01-01','ET','2',1,NULL,'McKayla A Johnson','94','0000806363','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:00',0,'2014-03-01 16:35:14'),(5250,5250,'2014-01-01','ET','2',1,NULL,'Samantha Johnson','FI','284864349','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:00',0,'2014-03-10 15:45:56'),(11992,11992,'2014-01-01','ET','2',1,NULL,'Karen Liang','FI','634287055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:46',0,'2014-03-02 05:03:29'),(21302,21952,'0000-00-00','ET','2',1,NULL,'Gregory Hercik','FI','278605783','Summa Insurance Company, Inc.','FI','341809108','Duane  Chapman','94','16678655','348','2014-04-01','Sync Success',0,'2014-03-01 21:01:07',0,'2014-03-10 16:38:05'),(895,895,'2014-01-01','ET','2',1,NULL,'CHRISTINE L BRATKA','FI','284546723','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:59',0,'2014-03-01 15:21:15'),(12916,12916,'2014-01-01','ET','2',1,NULL,'DONALD  DUHON','FI','436709617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:29',0,'2014-03-02 05:17:40'),(18000,18650,'0000-00-00','ET','2',1,NULL,'Angela Simmons','FI','436515608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:40',0,'2014-03-02 06:38:05'),(14120,14571,'2014-01-01','ET','2',1,NULL,'Tonya Joanne Guggenheim','FI','452738652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:49',0,'2014-03-02 05:31:31'),(12047,12047,'2014-01-01','ET','2',2,1,'Rita M Santibanez','FI','541217619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:52',0,'2014-03-02 05:03:29'),(10772,10772,'2014-01-01','ET','2',1,NULL,'Deirdre Smith','FI','550978532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:00',0,'2014-03-02 04:24:47'),(12201,12201,'2014-01-01','ET','2',1,NULL,'Christopher Malsbury','FI','410435608','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:09:19',0,'2014-03-10 13:52:32'),(12741,12741,'2014-01-01','ET','2',1,NULL,'Anna Alvarado','FI','459231175','Starmount Life Insurance Company','FI','720977315','Patrick  Watkins','94','1192839','348','2014-02-01','Sync Success',0,'2014-01-03 02:06:21',0,'2014-03-02 05:10:52'),(3443,3443,'2014-01-01','ET','2',1,NULL,'Deborah Opaczewski','FI','295528692','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:05',0,'2014-03-10 13:32:15'),(20119,20769,'0000-00-00','ET','2',1,NULL,'Jamey Purtty','FI','302827724','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:33',0,'2014-03-01 18:08:07'),(14052,14503,'2014-01-01','ET','2',2,1,'Lisa Moore','FI','272686718','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:03',0,'2014-03-01 16:46:19'),(18909,19559,'0000-00-00','ET','2',4,3,'Amber Falck','FI','267670098','Dental Care Plus, Inc.','FI','311185262','Suzanne  Myers','94','2263021','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:08',0,'2014-03-01 17:34:07'),(15499,15950,'0000-00-00','ET','2',2,1,'Michele Brock','FI','272707240','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:50',0,'2014-03-01 16:50:53'),(2175,2175,'2014-01-01','ET','2',1,NULL,'Michael Spencer','FI','575234780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:20',0,'2014-03-01 21:11:04'),(2752,2752,'2014-01-01','ET','2',1,NULL,'STEVEN SHIPLETT','FI','282689352','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:48',0,'2014-03-10 13:39:10'),(10543,10543,'2014-01-01','ET','2',1,NULL,'John Deuel','FI','397963868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:16',0,'2014-03-02 04:15:49'),(11473,11473,'2014-01-01','ET','2',2,1,'ROBERT HUNDLEY','FI','263533272','Dental Care Plus, Inc.','FI','311185262','CHARLES  BENDER','94','17057188','348','2014-02-01','Sync Success',0,'2013-12-28 03:30:50',0,'2014-03-01 16:30:17'),(11558,11558,'2014-01-01','ET','2',2,1,'Dorothy Cheatham','FI','510400415','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:25',0,'2014-03-02 04:52:44'),(13435,13791,'2014-01-01','ET','2',1,NULL,'Obi Dhungana','FI','616693675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:08',0,'2014-03-02 05:31:31'),(3113,3113,'2014-01-01','ET','2',3,2,'John  M Heaton','FI','298644856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:33',0,'2014-03-10 15:52:36'),(22912,23562,'0000-00-00','ET','2',1,NULL,'Christopher Ruiz Mireles','FI','435675451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:49',0,'2014-03-10 21:27:11'),(572,572,'2014-01-01','ET','2',1,NULL,'Tyler Grano','FI','274905295','Dental Care Plus, Inc.','FI','311185262','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 18:02:44',0,'2014-03-01 15:48:04'),(16976,17626,'0000-00-00','ET','2',1,NULL,'richard brown','FI','280768832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:14',0,'2014-03-01 17:00:58'),(1966,1966,'2014-01-01','ET','2',2,1,'randy miller','FI','289528760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:40',0,'2014-03-01 15:26:40'),(5518,5518,'2014-01-01','ET','2',1,NULL,'LOIS WILLIAMS','FI','297565122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:57',0,'2014-03-01 16:23:43'),(6341,6341,'2014-01-01','ET','2',1,NULL,'Cyndy C Broadus','FI','466922039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:38',0,'2014-03-02 04:10:25'),(13780,14136,'2014-01-01','ET','2',3,2,'Mary K Lofton','FI','427112534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:33',0,'2014-03-02 05:24:45'),(1939,1939,'2014-01-01','ET','2',1,NULL,'Robert  emlinger','FI','283503349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:54',0,'2014-03-01 15:26:40'),(16280,16930,'0000-00-00','ET','2',1,NULL,'Fernando Carabajal','FI','639241741','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:10',0,'2014-03-02 06:10:30'),(7753,7753,'2014-01-01','ET','2',1,NULL,'curtis liverett','FI','435048038','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:58',0,'2014-03-01 19:11:03'),(6446,6446,'2014-01-01','ET','2',1,NULL,'Lupita Diggins','FI','456278578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:58',0,'2014-03-01 20:10:57'),(12947,12947,'2014-01-01','ET','2',1,NULL,'Meshonda Hurst','FI','437712956','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-05 00:00:13',0,'2014-03-02 05:17:40'),(11725,11725,'2014-01-01','ET','2',1,NULL,'Joseph Lengel','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:08:41',0,'2014-03-01 16:30:17'),(5929,5929,'2014-01-01','ET','2',2,1,'CHERYL SAXOUR','FI','268803477','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:42',0,'2014-03-01 15:48:04'),(5303,5303,'2014-01-01','ET','2',1,NULL,'anthony seguin','FI','300648863','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:34',0,'2014-03-01 15:05:09'),(1873,1873,'2014-01-01','ET','2',2,1,'David Skelley','FI','283529862','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:58',0,'2014-03-01 15:31:33'),(2053,2053,'2014-01-01','ET','2',1,NULL,'jamie laurie','FI','286845121','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:30',0,'2014-03-10 15:45:56'),(14931,15382,'2014-01-01','ET','2',1,NULL,'Brian Gregory Duckro','FI','279840872','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:39',0,'2014-03-01 16:50:53'),(12931,12931,'2014-01-01','ET','2',2,1,'MORGAN SHEPPARD','FI','292827158','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:06:05',0,'2014-03-10 13:59:38'),(12561,12561,'2014-01-01','ET','2',1,NULL,'Sarah Cumpston','FI','645449627','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:44',0,'2014-03-10 13:59:38'),(12000,12000,'2014-01-01','ET','2',1,NULL,'Mercades Hartney','FI','298942123','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:02',0,'2014-03-10 16:10:34'),(12554,12554,'2014-01-01','ET','2',2,1,'Dora Rogacki','FI','285725798','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-02-01','Sync Success',1,'2014-01-02 04:35:24',0,'2014-03-10 13:59:38'),(11831,11831,'2014-01-01','ET','2',1,NULL,'Baxter Philavong','FI','557917813','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:05',0,'2014-03-02 04:31:46'),(11274,11274,'2014-01-01','ET','2',2,1,'Jehad Kandous','FI','157703518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:43',0,'2014-03-02 04:52:44'),(17569,18219,'0000-00-00','ET','2',3,2,'Craig Harbeson','FI','285887942','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:49',0,'2014-03-01 17:20:55'),(7030,7030,'2014-01-01','ET','2',1,NULL,'Sarah Warren','FI','644329426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:26',0,'2014-03-02 03:09:49'),(4421,4421,'2014-01-01','ET','2',1,NULL,'frederick painter','FI','232271176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:43',0,'2014-03-01 15:05:09'),(4517,4517,'2014-01-01','ET','2',1,NULL,'DEVON LEITH HULBERT','FI','288542578','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:40',0,'2014-03-10 15:39:19'),(4859,4859,'2014-01-01','ET','2',1,NULL,'Debra Picard','FI','457866936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:53',0,'2014-03-01 20:10:57'),(21784,22434,'0000-00-00','ET','2',4,3,'SHARON M THIERET','FI','286682769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:05',0,'2014-03-04 21:36:30'),(13351,13707,'2014-01-01','ET','2',1,NULL,'Jennifer Nugent','FI','454041169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:32',0,'2014-03-02 05:24:45'),(18214,18864,'0000-00-00','ET','2',1,NULL,'Kathy Costello','FI','299484363','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:05',0,'2014-03-10 16:31:33'),(11145,11145,'2014-01-01','ET','2',1,NULL,'Kenneth Day','FI','300489722','HealthSpan','FI','311431434','Michael  Webber Jr','94','968310','357','2014-01-01','Sync Success',0,'2013-12-26 13:15:46',0,'2014-03-10 13:45:57'),(16982,17632,'0000-00-00','ET','2',1,NULL,'Scott Mittelman','FI','296541342','Summa Insurance Company, Inc.','FI','341809108','Lawrence  Kaczmarek','94','313913','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:17',0,'2014-03-10 16:24:30'),(16462,17112,'0000-00-00','ET','2',1,NULL,'JOANNE S HAYES','FI','078424118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:14',0,'2014-03-01 17:00:58'),(785,785,'2014-01-01','ET','2',1,NULL,'Zachary Caserta','FI','292908152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:38',0,'2014-03-01 15:05:09'),(4736,4736,'2014-01-01','ET','2',1,NULL,'Brenda Anderson','FI','301483510','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:00',0,'2014-03-10 13:45:57'),(1963,1963,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:35',0,'2014-03-01 15:26:40'),(2671,2671,'2014-01-01','ET','2',1,NULL,'Elizabeth Bartley','FI','285765863','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:14',0,'2014-03-01 16:05:34'),(6160,6160,'2014-01-01','ET','2',1,NULL,'Sammie Davis','FI','451353699','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-26 03:03:09',0,'2014-03-02 04:10:25'),(2648,2648,'2014-01-01','ET','2',1,NULL,'Christopher R Reid','FI','614097486','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:21',0,'2014-03-01 16:05:34'),(22009,22659,'0000-00-00','ET','2',1,NULL,'Hannah Victoria Lopez','94','0001199564','Dental Care Plus, Inc.','FI','311185262','Ronald  Martin','94','2432668','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:59',0,'2014-03-05 21:36:22'),(12783,12783,'2014-01-01','ET','2',2,1,'RAMON RODRIGUEZ','FI','459252697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:38',0,'2014-03-02 05:10:52'),(1351,1351,'2014-01-01','ET','2',1,NULL,'Haydee Cruz','FI','449198109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:27',0,'2014-03-02 04:38:08'),(11499,11499,'2014-01-01','ET','2',1,NULL,'David Mirelez','FI','450158425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:31:37',0,'2014-03-02 04:52:44'),(19045,19695,'0000-00-00','ET','2',1,NULL,'zachary g poole','FI','632345867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:04',0,'2014-03-02 06:52:12'),(4728,4728,'2014-01-01','ET','2',1,NULL,'Jacoquyn Rasco','FI','426735155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:39',0,'2014-03-02 04:38:08'),(17734,18384,'0000-00-00','ET','2',1,NULL,'Jackie Fontenot','FI','433637657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:24',0,'2014-03-02 06:31:45'),(15205,15656,'0000-00-00','ET','2',2,1,'BARBARA HAUPRICHT','FI','289649885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:29',0,'2014-03-01 16:50:53'),(4579,4579,'2014-01-01','ET','2',1,NULL,'VOYICE CLARK','FI','279808359','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:36',0,'2014-03-01 16:15:39'),(20266,20916,'0000-00-00','ET','2',1,NULL,'Deborah Gibson','FI','302607765','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:14',0,'2014-03-01 17:47:19'),(19412,20062,'0000-00-00','ET','2',1,NULL,'Rhonda Caudill','FI','268584771','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:18',0,'2014-03-10 14:31:05'),(5644,5644,'2014-01-01','ET','2',1,NULL,'Christopher Peterson','FI','469967476','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:08',0,'2014-03-02 04:45:37'),(13540,13896,'2014-01-01','ET','2',1,NULL,'Nicholas Kramer','FI','294865729','Dental Care Plus, Inc.','FI','311185262','John  Curry','94','10751792','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:43',0,'2014-03-01 16:40:16'),(17832,18482,'0000-00-00','ET','2',1,NULL,'James Curtis Foster','FI','456910204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:01',0,'2014-03-02 06:17:30'),(13961,14317,'2014-01-01','ET','2',1,NULL,'kenneth orzechowski','FI','270581521','HealthSpan','FI','311431434','Dennis  Tucker','94','1780702','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:41',0,'2014-03-10 14:03:26'),(20905,21555,'0000-00-00','ET','2',2,1,'Barbara Scott','FI','269666074','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-02-28 06:31:47',0,'2014-03-10 14:45:25'),(22568,23218,'0000-00-00','ET','2',1,NULL,'Kathy Burress','FI','281541718','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:58',0,'2014-03-10 14:50:59'),(22988,23638,'0000-00-00','ET','2',2,1,'DONNA OKERWALL','FI','275769329','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:42',0,'2014-03-10 21:36:25'),(15225,15676,'0000-00-00','ET','2',1,NULL,'Cindy Mize','FI','378641339','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-21 08:44:43',0,'2014-03-10 14:10:12'),(14997,15448,'2014-01-01','ET','2',1,NULL,'JAMES R ENGLAND','FI','311508176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:09',0,'2014-03-02 05:45:37'),(13852,14208,'2014-01-01','ET','2',1,NULL,'Richard Martin','FI','251639239','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:49',0,'2014-03-02 05:31:31'),(12969,12969,'2014-01-01','ET','2',1,NULL,'Gerardo Gutierrez','FI','452572467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:01:04',0,'2014-03-02 05:17:40'),(12647,12647,'2014-01-01','ET','2',1,NULL,'Joan Woodard','FI','439965233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:49',0,'2014-03-02 05:10:52'),(11402,11402,'2014-01-01','ET','2',1,NULL,'Michael Tartaglia','FI','113600755','Summa Insurance Company, Inc.','FI','341809108','Jay R Jordan','94','6747517','348','2014-02-01','Sync Success',0,'2013-12-27 02:06:37',0,'2014-03-10 16:03:49'),(10754,10754,'2014-01-01','ET','2',5,4,'Lyndsay McGuinness','FI','294866837','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:21',0,'2014-03-01 16:15:39'),(6464,6464,'2014-01-01','ET','2',1,NULL,'Nicholas Malloy','FI','299902808','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:35',0,'2014-03-10 13:03:33'),(4279,4279,'2014-01-01','ET','2',1,NULL,'Ana Maria Truax','FI','434979398','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:42',0,'2014-03-02 03:09:49'),(2069,2069,'2014-01-01','ET','2',1,NULL,'KENNETH W SORG','FI','276543748','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:04',0,'2014-03-10 13:20:27'),(5098,5098,'2014-01-01','ET','2',1,NULL,'JOHN R SINS','FI','557314898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:06',0,'2014-03-02 00:10:48'),(18052,18702,'0000-00-00','ET','2',1,NULL,'Nicole Taylor','FI','283846655','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:16',0,'2014-03-10 14:24:38'),(429,429,'2014-01-01','ET','2',2,1,'Maryann McLean','FI','291720838','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:20',0,'2014-03-10 15:45:56'),(10522,10522,'2014-01-01','ET','2',1,NULL,'Philip Graschel','94','0000038344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:34',0,'2014-03-02 04:24:47'),(12726,12726,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:05:49',0,'2014-03-10 16:10:34'),(12085,12085,'2014-01-01','ET','2',4,3,'Crystal McGuire','FI','402338190','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-01 12:05:13',0,'2014-03-01 16:30:17'),(11272,11272,'2014-01-01','ET','2',1,NULL,'TRAN NGUYEN','FI','438519108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:02:39',0,'2014-03-02 04:52:44'),(4533,4533,'2014-01-01','ET','2',1,NULL,'LaVail DeShaun Duncan','FI','456733400','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:07',0,'2014-03-10 16:03:49'),(4513,4513,'2014-01-01','ET','2',2,1,'Dion Adanich','FI','363112890','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:29',0,'2014-03-01 15:16:37'),(4813,4813,'2014-01-01','ET','2',1,NULL,'Michael Currie','FI','292540688','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:15',0,'2014-03-10 15:39:19'),(629,629,'2014-01-01','ET','2',1,NULL,'Patricia Scroggins','FI','431964416','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:35',0,'2014-03-02 02:10:49'),(1049,1049,'2014-01-01','ET','2',1,NULL,'Bonnie Godines','FI','466934435','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:30:15',0,'2014-03-01 21:11:04'),(5731,5731,'2014-01-01','ET','2',1,NULL,'Joyce Bartlett','FI','401806995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:20',0,'2014-03-01 15:48:04'),(1854,1854,'2014-01-01','ET','2',1,NULL,'Kevin  Robert  Cramer','FI','288740448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:21',0,'2014-03-01 15:26:40'),(14211,14662,'2014-01-01','ET','2',1,NULL,'Susan Vilardo','FI','275583575','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:47',0,'2014-03-10 14:03:26'),(14185,14636,'2014-01-01','ET','2',1,NULL,'Telisha Goree','FI','427554468','Starmount Life Insurance Company','FI','720977315','Christopher  Vell','94','8004571','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:29',0,'2014-03-02 05:38:34'),(4694,4694,'2014-01-01','ET','2',2,1,'Russell Sailors','FI','434639334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:26',0,'2014-03-02 04:38:08'),(11813,11813,'2014-01-01','ET','2',1,NULL,'Stephen Adams','FI','301861825','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:28',0,'2014-03-01 16:15:39'),(16313,16963,'0000-00-00','ET','2',2,1,'ROBERT  JONES','FI','283469524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:32',0,'2014-03-01 16:56:22'),(16458,17108,'0000-00-00','ET','2',1,NULL,'emily oquendo','FI','142822349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-30 21:00:11',0,'2014-03-01 17:00:58'),(18232,18882,'0000-00-00','ET','2',1,NULL,'Katlynn Dotson','FI','590966220','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:20',0,'2014-03-10 14:24:38'),(20199,20849,'0000-00-00','ET','2',1,NULL,'BONNIE REYES','FI','458594161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:31:30',0,'2014-03-02 07:10:28'),(10790,10790,'2014-01-01','ET','2',1,NULL,'Basilides Mcevilla','FI','563319349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:33',0,'2014-03-02 04:24:47'),(866,866,'2014-01-01','ET','2',1,NULL,'Pamela Griffin','FI','456511879','Starmount Life Insurance Company','FI','720977315','Linda  Carter','94','1033689','348','2014-01-01','Sync Success',0,'2013-12-25 18:16:11',0,'2014-03-01 22:10:55'),(13994,14350,'2014-01-01','ET','2',1,NULL,'JOHN  MATHEWS','FI','288507659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:25',0,'2014-03-10 14:03:26'),(13350,13706,'2014-01-01','ET','2',1,NULL,'nancylee Jacobs','FI','330465907','Dental Care Plus, Inc.','FI','311185262','Michael  Daughtery','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:32',0,'2014-03-01 16:40:16'),(17125,17775,'0000-00-00','ET','2',1,NULL,'ERIC BORMUTH','FI','271823556','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:16',0,'2014-03-10 14:20:26'),(37,37,'2014-01-01','ET','2',1,NULL,'Russell Gardner','94','0000785757','Dental Care Plus, Inc.','FI','311185262','Shalen Nicole Rucker','94','1643111','348','2014-01-01','Sync Success',0,'2013-12-25 17:16:05',0,'2014-03-01 15:21:15'),(14334,14785,'2014-01-01','ET','2',1,NULL,'Rosanna Meza','FI','098548676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:39',0,'2014-03-02 05:38:34'),(5991,5991,'2014-01-01','ET','2',2,1,'nicole cramer','FI','275768680','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:41',0,'2014-03-10 13:24:34'),(10704,10704,'2014-01-01','ET','2',1,NULL,'Shirley Ann Simon','FI','287482007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:41',0,'2014-03-01 16:10:36'),(7057,7057,'2014-01-01','ET','2',1,NULL,'ann kelly','FI','108468339','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:14',0,'2014-03-01 15:52:44'),(10385,10385,'2014-01-01','ET','2',2,1,'Shawn Haynes','FI','409477073','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:16',0,'2014-03-01 16:10:36'),(17234,17884,'0000-00-00','ET','2',1,NULL,'Stephone Jeffries','94','0000999881','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:23',0,'2014-03-10 16:24:30'),(22149,22799,'0000-00-00','ET','2',1,NULL,'Brenda Hunter','FI','275964155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:04',0,'2014-03-06 21:36:23'),(10453,10453,'2014-01-01','ET','2',1,NULL,'Mary Bonner','FI','285766193','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:24',0,'2014-03-01 16:10:36'),(5526,5526,'2014-01-01','ET','2',1,NULL,'Tanisha Jackson','FI','283840311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:47:14',0,'2014-03-01 16:23:43'),(11456,11456,'2014-01-01','ET','2',2,1,'Teryl Edwards','FI','289641260','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:20',0,'2014-03-01 16:30:17'),(12859,12859,'2014-01-01','ET','2',1,NULL,'KIM B GAMBEL','FI','291607011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:03:24',0,'2014-03-01 16:35:14'),(11683,11683,'2014-01-01','ET','2',1,NULL,'Michelle Mwaniki','FI','531558003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:22',0,'2014-03-02 04:59:36'),(14332,14783,'2014-01-01','ET','2',1,NULL,'Katie Wendt','FI','455939661','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:38',0,'2014-03-02 05:38:34'),(18089,18739,'0000-00-00','ET','2',1,NULL,'Erica Barnes','FI','462839095','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:29',0,'2014-03-02 06:38:05'),(20782,21432,'0000-00-00','ET','2',1,NULL,'JOSEPH DELUCA','FI','285585440','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:50',0,'2014-03-10 16:38:05'),(22757,23407,'0000-00-00','ET','2',1,NULL,'eric nava','FI','464231467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-09 21:00:17',0,'2014-03-09 21:26:00'),(658,658,'2014-01-01','ET','2',1,NULL,'Bilindra Robinson','FI','454491889','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:27',0,'2014-03-02 02:10:49'),(15344,15795,'0000-00-00','ET','2',1,NULL,'james  APOLLONIO','FI','297609446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:46',0,'2014-03-02 05:52:31'),(14561,15012,'2014-01-01','ET','2',1,NULL,'Bobette Burke','FI','461192798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:25',0,'2014-03-02 05:45:37'),(7520,7520,'2014-01-01','ET','2',1,NULL,'Chad Arthur','FI','298602070','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:41',0,'2014-03-01 16:05:34'),(2073,2073,'2014-01-01','ET','2',1,NULL,'Richard Reed','FI','299443334','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:11',0,'2014-03-10 15:45:56'),(2647,2647,'2014-01-01','ET','2',2,1,'Gerald Green','FI','301623073','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:18',0,'2014-03-01 16:05:34'),(20891,21541,'0000-00-00','ET','2',1,NULL,'DAVID FRANKOWSKI','FI','292866647','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:31:41',0,'2014-03-10 16:38:05'),(112,112,'2014-01-01','ET','2',1,NULL,'Louis Davis','FI','587320969','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:25',0,'2014-03-01 22:10:55'),(15294,15745,'0000-00-00','ET','2',1,NULL,'HOWARD WADE','FI','455048766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-21 08:46:15',0,'2014-03-02 05:52:31'),(11388,11388,'2014-01-01','ET','2',2,1,'MELISSA ROMINES','FI','587596265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:10',0,'2014-03-02 04:52:44'),(13134,13490,'2014-01-01','ET','2',1,NULL,'HUGO GONZALEZ','FI','628104307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:14',0,'2014-03-02 05:17:40'),(7741,7741,'2014-01-01','ET','2',2,1,'Deborah Dale','FI','315869309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:33',0,'2014-03-01 19:11:03'),(12486,12486,'2014-01-01','ET','2',1,NULL,'Melinda Rutkowski','FI','232237589','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:47',0,'2014-03-01 16:35:14'),(3369,3369,'2014-01-01','ET','2',2,1,'edward Li','FI','452718528','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:42',0,'2014-03-02 02:10:49'),(4364,4364,'2014-01-01','ET','2',1,NULL,'Denise Albrecht','FI','296563144','HealthSpan','FI','311431434','Michelle L Seymour','94','1924703','348','2014-01-01','Sync Success',0,'2013-12-25 23:11:12',0,'2014-03-10 13:32:15'),(5476,5476,'2014-01-01','ET','2',1,NULL,'Dominique Smith','FI','433759179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:37',0,'2014-03-02 04:45:37'),(18262,18912,'0000-00-00','ET','2',2,1,'Diana Scales','FI','299481458','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:47',0,'2014-03-10 14:24:38'),(20763,21413,'0000-00-00','ET','2',1,NULL,'Michael Fowler','FI','293865267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:41',0,'2014-03-01 18:08:07'),(21166,21816,'0000-00-00','ET','2',2,1,'Doug Grubb','FI','401883635','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:32',0,'2014-03-10 14:45:25'),(11093,11093,'2014-01-01','ET','2',1,NULL,'Robin Biggert','94','0000896951','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:13:52',0,'2014-03-10 13:45:57'),(5686,5686,'2014-01-01','ET','2',1,NULL,'Christine Ingrid Funk','FI','298660592','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:42',0,'2014-03-10 13:52:32'),(4017,4017,'2014-01-01','ET','2',1,NULL,'Joshua Rather','FI','601549668','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:38',0,'2014-03-02 03:09:49'),(3909,3909,'2014-01-01','ET','2',1,NULL,'CAREN HOLDERMAN','FI','290723531','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:20',0,'2014-03-01 15:26:40'),(2345,2345,'2014-01-01','ET','2',1,NULL,'GLORIA ANN SCHULTZ','FI','289503487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:30',0,'2014-03-01 15:26:40'),(2643,2643,'2014-01-01','ET','2',1,NULL,'Vanessa Lee','FI','296803393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:11',0,'2014-03-01 16:05:34'),(12089,12089,'2014-01-01','ET','2',1,NULL,'Hamilton Pyle','FI','279505949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:05:22',0,'2014-03-01 16:30:17'),(3264,3264,'2014-01-01','ET','2',1,NULL,'Karen Cron','FI','284885450','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:18',0,'2014-03-10 13:24:34'),(5425,5425,'2014-01-01','ET','2',3,2,'Tyler Earl Cantrell','FI','286821936','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:08',0,'2014-03-10 13:03:33'),(16508,17158,'0000-00-00','ET','2',1,NULL,'jack ritchie','FI','632289579','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:41',0,'2014-03-02 06:17:30'),(4000,4000,'2014-01-01','ET','2',1,NULL,'Maritza Sepulveda','FI','456713231','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:11',0,'2014-03-02 03:09:49'),(2226,2226,'2014-01-01','ET','2',1,NULL,'MELISSA HOLTON','FI','297683477','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:03',0,'2014-03-10 13:10:24'),(14940,15391,'2014-01-01','ET','2',1,NULL,'Lisa Donato','FI','297668184','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:43',0,'2014-03-10 14:10:12'),(14920,15371,'2014-01-01','ET','2',1,NULL,'JON SARICH','FI','271900740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:33',0,'2014-03-01 16:50:53'),(14794,15245,'2014-01-01','ET','2',1,NULL,'NORA MOORE','FI','425069458','Starmount Life Insurance Company','FI','720977315','REVONNO  BURT','94','6401285','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:53',0,'2014-03-02 05:45:37'),(3378,3378,'2014-01-01','ET','2',1,NULL,'Donald Whitney','FI','464897414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:01',0,'2014-03-02 02:10:49'),(3848,3848,'2014-01-01','ET','2',1,NULL,'Sierra Thatcher','FI','595786121','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 22:30:33',0,'2014-03-10 13:03:33'),(3874,3874,'2014-01-01','ET','2',1,0,'Teresa A Cook','FI','296545176','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:21',0,'2014-03-01 15:05:09'),(16828,17478,'0000-00-00','ET','2',1,NULL,'Stephanie Northrop','FI','461513915','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:11',0,'2014-03-02 06:17:30'),(19270,19920,'0000-00-00','ET','2',1,NULL,'SCHERRI PHILLIPS','FI','275721399','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-17 19:00:13',0,'2014-03-10 16:31:33'),(22824,23474,'0000-00-00','ET','2',1,NULL,'Debra Louise Messenger','FI','276566471','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-09 21:01:13',0,'2014-03-10 16:44:18'),(22959,23609,'0000-00-00','ET','2',1,NULL,'kathleen blake','FI','095464681','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:23',0,'2014-03-10 21:07:22'),(64,64,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:16:56',0,'2014-03-01 15:21:15'),(498,498,'2014-01-01','ET','2',1,NULL,'SHATILA MICHELLE BELL','FI','268902729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:24',0,'2014-03-01 15:48:04'),(12885,12885,'2014-01-01','ET','2',1,NULL,'ANNIE  K FLOOD','FI','587926473','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:21',0,'2014-03-02 05:10:52'),(676,676,'2014-01-01','ET','2',1,NULL,'Thomas Sigel','FI','294525179','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:58',0,'2014-03-10 15:52:36'),(12373,12373,'2014-01-01','ET','2',1,NULL,'jayson tomblin','FI','289745041','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:28:42',0,'2014-03-10 13:59:38'),(4629,4629,'2014-01-01','ET','2',1,NULL,'Gregorio Moreno','FI','507748645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:13',0,'2014-03-02 04:31:46'),(20979,21629,'0000-00-00','ET','2',2,1,'Nicholas Kreakie','FI','274904112','Summa Insurance Company, Inc.','FI','341809108','Deana  Alexander','94','2228297','348','2014-04-01','Sync Success',0,'2014-02-28 07:30:24',0,'2014-03-10 16:38:05'),(22168,22818,'0000-00-00','ET','2',1,NULL,'Sarah Renee Brouillard','FI','114702905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:17',0,'2014-03-06 21:36:23'),(158,158,'2014-01-01','ET','2',1,NULL,'THOMAS GLEGHORN','FI','278522343','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:53',0,'2014-03-10 15:45:56'),(16183,16832,'0000-00-00','ET','2',1,NULL,'Deborah Paige','FI','293468589','Dental Care Plus, Inc.','FI','311185262','Amanda  Skidmore','94','8557318','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:27',0,'2014-03-01 16:56:22'),(5102,5102,'2014-01-01','ET','2',1,NULL,'Crystal Vavasseur','FI','435949638','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:13',0,'2014-03-02 00:10:48'),(15383,15834,'0000-00-00','ET','2',2,1,'Vanesse Hall','FI','434212296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:21:58',0,'2014-03-02 05:59:43'),(15092,15543,'0000-00-00','ET','2',1,NULL,'MILDRED  COSS','FI','044682806','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-20 08:05:44',0,'2014-03-01 16:50:53'),(2186,2186,'2014-01-01','ET','2',1,NULL,'Karen Hailey','FI','459968161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:41',0,'2014-03-01 21:11:04'),(12241,12241,'2014-01-01','ET','2',1,NULL,'Cainan Mabou','FI','439753023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:05',0,'2014-03-02 05:10:52'),(4657,4657,'2014-01-01','ET','2',1,NULL,'Joseph Ferriot','FI','291885220','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:10',0,'2014-03-10 16:03:49'),(2972,2972,'2014-01-01','ET','2',5,4,'Maura Anaya','FI','251843487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:17',0,'2014-03-01 15:37:30'),(20737,21387,'0000-00-00','ET','2',1,NULL,'Michelle Rathfelder','FI','296665170','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:30:30',0,'2014-03-01 18:10:11'),(21125,21775,'0000-00-00','ET','2',1,NULL,'TONI ROBINSON','FI','268643151','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:03',0,'2014-03-10 16:38:05'),(13850,14206,'2014-01-01','ET','2',1,NULL,'Nam Nguyen','FI','642083436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:48',0,'2014-03-02 05:31:31'),(13373,13729,'2014-01-01','ET','2',1,NULL,'Amy Shuffield','FI','466951146','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:42',0,'2014-03-02 05:24:45'),(18631,19281,'0000-00-00','ET','2',1,NULL,'Leia West','FI','282742779','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:59',0,'2014-03-01 17:26:36'),(1616,1616,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:36',0,'2014-03-01 20:10:57'),(12665,12665,'2014-01-01','ET','2',1,NULL,'Alice K Webb','FI','285502899','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:31',0,'2014-03-01 16:35:14'),(12598,12598,'2014-01-01','ET','2',1,NULL,'LARA MICKENS','FI','497762690','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:01',0,'2014-03-02 05:10:52'),(11597,11597,'2014-01-01','ET','2',1,NULL,'Amanda Edwards','FI','425631858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:34:38',0,'2014-03-02 04:52:44'),(13580,13936,'2014-01-01','ET','2',1,NULL,'pamela rogalsky-cannon','FI','269621867','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:10',0,'2014-03-10 16:10:34'),(4039,4039,'2014-01-01','ET','2',2,1,'ENEDELIA SOLIAS','FI','384508205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:19',0,'2014-03-02 03:09:49'),(5651,5651,'2014-01-01','ET','2',1,NULL,'Earnest Bernard','FI','426416742','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:21',0,'2014-03-02 04:45:37'),(5869,5869,'2014-01-01','ET','2',1,NULL,'Marsha Scharpenberg','FI','268527687','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:53',0,'2014-03-01 15:05:09'),(18413,19063,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:11',0,'2014-03-01 17:26:36'),(22291,22941,'0000-00-00','ET','2',1,NULL,'CARLA A KERCHEVAL','FI','445684406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:47',0,'2014-03-06 21:27:26'),(22292,22942,'0000-00-00','ET','2',1,NULL,'Mona Montet','FI','433176456','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:47',0,'2014-03-06 21:27:26'),(7531,7531,'2014-01-01','ET','2',1,NULL,'Andrew Connor','FI','199640898','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:02',0,'2014-03-01 16:05:34'),(5895,5895,'2014-01-01','ET','2',1,NULL,'Stacey Johnson','FI','299903762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:36',0,'2014-03-01 15:48:04'),(17638,18288,'0000-00-00','ET','2',1,NULL,'Elizabeth Dugas','FI','295720925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:27',0,'2014-03-01 17:20:55'),(18445,19095,'0000-00-00','ET','2',1,NULL,'CANDACE FORAKER','FI','297701796','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:35',0,'2014-03-10 16:31:33'),(19833,20483,'0000-00-00','ET','2',1,NULL,'ELIZABETH LAWHORN','FI','280763080','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:50',0,'2014-03-10 16:38:05'),(20555,21205,'0000-00-00','ET','2',1,NULL,'EDUWEM ADELEYE','FI','634044085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:19',0,'2014-03-02 07:17:36'),(22649,23299,'0000-00-00','ET','2',1,NULL,'Alice Myrie Covington','FI','465772952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:20',0,'2014-03-08 22:26:18'),(55,55,'2014-01-01','ET','2',1,NULL,'Jennifer Neff','FI','297600007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:40',0,'2014-03-01 15:21:15'),(7106,7106,'2014-01-01','ET','2',1,NULL,'CYNTHIA SUE COLLINS','FI','300684219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:46',0,'2014-03-01 15:52:44'),(15799,16448,'0000-00-00','ET','2',1,NULL,'DION ALLEN','FI','459479183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:11',0,'2014-03-02 06:03:21'),(14088,14539,'2014-01-01','ET','2',1,NULL,'Terry  Lynn  Phillips','FI','462216183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:27',0,'2014-03-02 05:38:34'),(5810,5810,'2014-01-01','ET','2',1,NULL,'Elizabeth Stritenberger','FI','514546839','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:54',0,'2014-03-10 13:24:34'),(11710,11710,'2014-01-01','ET','2',1,NULL,'MAURO F GARCIA','FI','453748480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:11',0,'2014-03-02 04:59:36'),(18798,19448,'0000-00-00','ET','2',1,NULL,'Judy Smith','FI','235860558','HealthSpan','FI','311431434','Gary  Smith','94','1766033','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:06',0,'2014-03-10 14:31:05'),(7220,7220,'2014-01-01','ET','2',1,NULL,'RICKEY LAMAR PRESSLEY','FI','274569797','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:14',0,'2014-03-01 15:52:44'),(1394,1394,'2014-01-01','ET','2',1,NULL,'ashley granger','FI','627056754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:50',0,'2014-03-02 04:45:37'),(1748,1748,'2014-01-01','ET','2',1,NULL,'Brian J Seifert','FI','323589326','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:55',0,'2014-03-01 15:31:33'),(17833,18483,'0000-00-00','ET','2',1,NULL,'Margarito Arellano','FI','462961527','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:01:01',0,'2014-03-02 06:10:30'),(18891,19541,'0000-00-00','ET','2',2,1,'Ranjana Bhatia','FI','595041558','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:55',0,'2014-03-02 06:52:12'),(21011,21661,'0000-00-00','ET','2',1,NULL,'Tress Turner','FI','439378400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:00:08',0,'2014-03-02 07:23:39'),(21534,22184,'0000-00-00','ET','2',2,1,'HIEN NGUYEN','FI','636320031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:19',0,'2014-03-03 22:26:43'),(1090,1090,'2014-01-01','ET','2',1,NULL,'thadius jones','FI','427230989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:39',0,'2014-03-01 19:11:03'),(16232,16881,'0000-00-00','ET','2',1,NULL,'robert breisinger','FI','293549658','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:00',0,'2014-03-10 14:20:26'),(12043,12043,'2014-01-01','ET','2',1,NULL,'Eddie Harvey','FI','433178916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:42',0,'2014-03-02 05:03:29'),(12006,12006,'2014-01-01','ET','2',2,1,'no nguyen','FI','439831403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:18',0,'2014-03-02 04:59:36'),(11954,11954,'2014-01-01','ET','2',1,NULL,'John Tyrone Jones','FI','437476773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:22',0,'2014-03-02 04:59:36'),(11651,11651,'2014-01-01','ET','2',1,NULL,'Tonya Fore','FI','278783869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:36:19',0,'2014-03-01 16:30:17'),(4921,4921,'2014-01-01','ET','2',1,0,'David Allan Hudson','FI','453876264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:51',0,'2014-03-01 19:11:03'),(4469,4469,'2014-01-01','ET','2',1,NULL,'Janet Harris','FI','288547119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:31:02',0,'2014-03-01 15:16:37'),(4425,4425,'2014-01-01','ET','2',2,1,'Tabitha Snyder','FI','272922088','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:52',0,'2014-03-10 13:03:33'),(6204,6204,'2014-01-01','ET','2',1,NULL,'Melinda Hurlow','FI','269567163','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:27',0,'2014-03-01 16:00:27'),(7096,7096,'2014-01-01','ET','2',1,NULL,'DON BRAND','FI','288521638','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:29',0,'2014-03-01 15:52:44'),(11128,11128,'2014-01-01','ET','2',2,1,'gary bryant','FI','297507444','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:07',0,'2014-03-10 13:45:57'),(2470,2470,'2014-01-01','ET','2',1,NULL,'MYA HARRIS','FI','365782520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:32',0,'2014-03-01 23:10:52'),(10843,10843,'2014-01-01','ET','2',1,NULL,'shendrell  stewart','FI','438611732','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:15',0,'2014-03-02 04:31:46'),(18365,19015,'0000-00-00','ET','2',1,NULL,'Martha gonzalez','FI','463954152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:37',0,'2014-03-02 06:45:14'),(19181,19831,'0000-00-00','ET','2',1,NULL,'Isaac Jones','94','0001228106','Dental Care Plus, Inc.','FI','311185262','Michelle  Sweeney','94','2438648','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:48',0,'2014-03-01 17:34:07'),(21058,21708,'0000-00-00','ET','2',1,NULL,'DIANE WOEHRMEYER','FI','271563522','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:20',0,'2014-03-01 18:10:11'),(22052,22702,'0000-00-00','ET','2',1,NULL,'Leota Rowe','FI','286467320','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:30',0,'2014-03-10 14:45:25'),(189,189,'2014-01-01','ET','2',1,NULL,'Danielle LeBoeuf','FI','434495418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:53',0,'2014-03-01 22:10:55'),(228,228,'2014-01-01','ET','2',1,0,'Katherine Moulton','FI','133703335','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:10',0,'2014-03-01 19:11:03'),(13798,14154,'2014-01-01','ET','2',1,NULL,'Stephanie Brown','FI','271922237','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:46',0,'2014-03-10 13:59:38'),(7433,7433,'2014-01-01','ET','2',1,NULL,'shalonda willis','FI','433276602','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:55',0,'2014-03-02 04:15:49'),(7309,7309,'2014-01-01','ET','2',1,NULL,'Brenda Cole','FI','587542448','Starmount Life Insurance Company','FI','720977315','Robert N Stringer','94','557653','348','2014-01-01','Sync Success',0,'2013-12-26 04:09:58',0,'2014-03-02 03:09:49'),(5129,5129,'2014-01-01','ET','2',4,3,'Nora Cord','FI','298801457','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:11',0,'2014-03-10 15:45:56'),(21448,22098,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:17',0,'2014-03-10 16:44:18'),(545,545,'2014-01-01','ET','2',1,NULL,'leonard frey','FI','300584445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:51',0,'2014-03-01 15:48:04'),(11010,11010,'2014-01-01','ET','2',1,NULL,'Charlotte Robinson','FI','426138886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:08',0,'2014-03-02 04:24:47'),(1625,1625,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:50',0,'2014-03-01 20:10:57'),(15245,15696,'0000-00-00','ET','2',1,NULL,'Jessica Barnes','FI','623366143','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:25',0,'2014-03-10 14:10:12'),(14709,15160,'2014-01-01','ET','2',1,NULL,'PATRICK KAVANAUGH','FI','435044561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:01',0,'2014-03-02 05:45:37'),(10551,10551,'2014-01-01','ET','2',1,NULL,'Thelma J Mixon','FI','462352112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:34',0,'2014-03-02 04:24:47'),(4671,4671,'2014-01-01','ET','2',1,NULL,'Kareema Williams','FI','296861429','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:49:37',0,'2014-03-01 16:15:39'),(5816,5816,'2014-01-01','ET','2',1,NULL,'Robert Ross Dedo','FI','275500194','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:04:06',0,'2014-03-10 13:24:34'),(11721,11721,'2014-01-01','ET','2',1,NULL,'Billy  Ray Mclaughlin','FI','587903375','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:33',0,'2014-03-02 04:59:36'),(5592,5592,'2014-01-01','ET','2',2,1,'Julie Floyd','FI','535027157','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:25',0,'2014-03-02 04:45:37'),(18976,19626,'0000-00-00','ET','2',2,1,'TIEN PAO CHU','FI','293081828','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:57',0,'2014-03-10 14:31:05'),(20579,21229,'0000-00-00','ET','2',1,NULL,'Bentley Michael Berwsaugh','94','0000943472','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:35',0,'2014-03-01 18:08:07'),(20921,21571,'0000-00-00','ET','2',1,NULL,'Nana Hammond','FI','093593295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:13',0,'2014-03-01 18:08:07'),(21939,22589,'0000-00-00','ET','2',1,NULL,'Jeanne Miller','FI','285668039','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:11',0,'2014-03-10 14:45:25'),(5893,5893,'2014-01-01','ET','2',1,NULL,'Danneile Lagace','FI','115421174','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:32',0,'2014-03-01 15:48:04'),(3854,3854,'2014-01-01','ET','2',1,NULL,'Walid Kanj','FI','512118571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:43',0,'2014-03-01 19:11:03'),(5586,5586,'2014-01-01','ET','2',1,NULL,'Amanda Miller','FI','466891064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:12',0,'2014-03-02 04:45:37'),(14231,14682,'2014-01-01','ET','2',1,NULL,'Twyonda Wallace','FI','587294921','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:54',0,'2014-03-02 05:38:34'),(14083,14534,'2014-01-01','ET','2',1,NULL,'nevelyn rodriguez','FI','449942767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:25',0,'2014-03-02 05:38:34'),(4880,4880,'2014-01-01','ET','2',1,NULL,'James Piening','FI','289520260','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:37',0,'2014-03-10 13:03:33'),(12304,12304,'2014-01-01','ET','2',2,1,'Robert Chapman','FI','274889193','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:26',0,'2014-03-10 16:10:34'),(17761,18411,'0000-00-00','ET','2',1,NULL,'Chester Zimmer','FI','282881857','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:44',0,'2014-03-10 14:24:38'),(18063,18713,'0000-00-00','ET','2',1,NULL,'elan bills','FI','220170289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:10',0,'2014-03-02 06:38:05'),(22651,23301,'0000-00-00','ET','2',2,1,'ARGURO AVALOS','FI','643562649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:21',0,'2014-03-08 22:26:18'),(22697,23347,'0000-00-00','ET','2',1,NULL,'LYNN FRAZEE','FI','272564271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:56',0,'2014-03-08 21:35:36'),(7622,7622,'2014-01-01','ET','2',1,NULL,'Laura Freemal','FI','285626215','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:59',0,'2014-03-10 15:59:47'),(16119,16768,'0000-00-00','ET','2',1,NULL,'Mary Koch','FI','277583977','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:01:32',0,'2014-03-10 14:20:26'),(7619,7619,'2014-01-01','ET','2',1,NULL,'Jacquelyn Aldrich','FI','269827215','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:53',0,'2014-03-10 13:39:10'),(15403,15854,'0000-00-00','ET','2',1,NULL,'LOURDES MERAZ','FI','466376622','Starmount Life Insurance Company','FI','720977315','MICHAEL  RAMM','94','228443','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:12',0,'2014-03-02 05:59:43'),(13763,14119,'2014-01-01','ET','2',1,NULL,'GARY WILSON','FI','288508340','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:23',0,'2014-03-10 16:10:34'),(2540,2540,'2014-01-01','ET','2',1,NULL,'Mary Brackmann','FI','278843982','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:13',0,'2014-03-01 15:10:22'),(5126,5126,'2014-01-01','ET','2',2,1,'Denise Belair','FI','283749290','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:05',0,'2014-03-10 15:45:56'),(6236,6236,'2014-01-01','ET','2',3,2,'SHUBHRA NEIL AGARWAL','FI','281046375','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:28',0,'2014-03-01 16:05:34'),(1532,1532,'2014-01-01','ET','2',1,NULL,'Beatrice Boyd','FI','279505856','Summa Insurance Company, Inc.','FI','341809108','Rhonda K Jackson','94','1101549300','348','2014-01-01','Sync Success',0,'2013-12-25 18:58:25',0,'2014-03-10 16:03:49'),(17506,18156,'0000-00-00','ET','2',1,NULL,'WILHELMINA BYRD','FI','265966641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:05',0,'2014-03-02 06:31:45'),(18045,18695,'0000-00-00','ET','2',1,NULL,'Keven James Sharpe','FI','288867509','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-25','Sync Success',0,'2014-02-10 21:32:10',0,'2014-03-10 16:31:33'),(19085,19735,'0000-00-00','ET','2',1,NULL,'Jennifer Waters','FI','284806925','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:33',0,'2014-03-01 17:34:07'),(19567,20217,'0000-00-00','ET','2',1,NULL,'MARCENETTE Carney','FI','436457746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:22:22',0,'2014-03-02 06:59:07'),(20222,20872,'0000-00-00','ET','2',1,NULL,'PATRICIA CATCHINGS','FI','587069132','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:48',0,'2014-03-02 07:10:28'),(14,14,'2014-01-01','ET','2',1,NULL,'Donald Charles Dusseau','FI','288441926','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:27',0,'2014-03-01 15:21:15'),(13466,13822,'2014-01-01','ET','2',1,NULL,'Dennis Barrington','FI','288583771','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:30',0,'2014-03-01 16:40:16'),(13387,13743,'2014-01-01','ET','2',1,NULL,'Rhonda McBryer','FI','298543688','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:48',0,'2014-03-10 16:10:34'),(13213,13569,'2014-01-01','ET','2',1,NULL,'BRITNEY PLUMMER','FI','627103036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:32',0,'2014-03-02 05:17:40'),(2380,2380,'2014-01-01','ET','2',1,NULL,'SHANDRA NELSON','FI','459063687','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:38',0,'2014-03-01 23:10:52'),(18814,19464,'0000-00-00','ET','2',1,NULL,'Hellen Burden','FI','280585421','HealthSpan','FI','311431434','Paul  Sullivan','94','3667671','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:20',0,'2014-03-10 14:31:05'),(19039,19689,'0000-00-00','ET','2',1,NULL,'Normita Bucalan','FI','436755264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:11',0,'2014-03-02 06:52:12'),(20074,20724,'0000-00-00','ET','2',1,NULL,'EVELYN ANOKYE','FI','290131267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:29',0,'2014-03-01 18:08:07'),(2900,2900,'2014-01-01','ET','2',1,NULL,'troy kinman','FI','310761469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:46',0,'2014-03-10 13:39:10'),(15643,16292,'0000-00-00','ET','2',1,NULL,'SHANNON MECHLING','FI','296861970','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:06',0,'2014-03-01 16:50:53'),(14964,15415,'2014-01-01','ET','2',3,2,'Bernard Huelskamp','FI','298547968','Dental Care Plus, Inc.','FI','311185262','Aimee  Grieshop','94','3662265','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:54',0,'2014-03-01 16:50:53'),(14445,14896,'2014-01-01','ET','2',1,NULL,'Edward Coker','FI','437089348','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:28',0,'2014-03-02 05:38:34'),(1164,1164,'2014-01-01','ET','2',1,NULL,'Felton Ardoin','FI','433719795','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:37',0,'2014-03-02 04:38:08'),(17208,17858,'0000-00-00','ET','2',1,NULL,'RAYMONE SCOTT','FI','285787390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:10',0,'2014-03-01 17:20:55'),(15408,15859,'0000-00-00','ET','2',1,NULL,'JUANA LOZOYA','FI','562797873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:15',0,'2014-03-02 05:59:43'),(20100,20750,'0000-00-00','ET','2',1,NULL,'Eric Jackson','FI','435159853','Starmount Life Insurance Company','FI','720977315','Patrick B Tyson','94','7409844','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:19',0,'2014-03-02 07:10:28'),(20958,21608,'0000-00-00','ET','2',1,NULL,'BRENDA FRANCO','FI','643506225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:11',0,'2014-03-02 07:17:36'),(22012,22662,'0000-00-00','ET','2',1,NULL,'JAMES METCALF','FI','295583427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:00',0,'2014-03-05 21:36:22'),(22054,22704,'0000-00-00','ET','2',1,NULL,'Michael Brockman','FI','301469273','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:31',0,'2014-03-10 14:45:25'),(7513,7513,'2014-01-01','ET','2',2,1,'Carrie Curry','FI','305049395','Dental Care Plus, Inc.','FI','311185262','John  Curry','94','10751792','348','2014-01-01','Sync Success',0,'2013-12-26 04:34:27',0,'2014-03-01 16:05:34'),(11338,11338,'2014-01-01','ET','2',1,NULL,'LANITA WELCH','FI','449254256','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:40',0,'2014-03-02 04:52:44'),(15230,15681,'0000-00-00','ET','2',3,2,'Dustin Greer','FI','295844441','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:47',0,'2014-03-10 14:10:12'),(13848,14204,'2014-01-01','ET','2',1,NULL,'Christi Cole','FI','540275629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:47',0,'2014-03-02 05:31:31'),(11732,11732,'2014-01-01','ET','2',1,NULL,'Francis Zhang','FI','471069563','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:53',0,'2014-03-01 16:30:17'),(12719,12719,'2014-01-01','ET','2',2,1,'Randy P Gravois','FI','439375561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:29',0,'2014-03-02 05:10:52'),(12393,12393,'2014-01-01','ET','2',1,NULL,'angela stokes','FI','298583490','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:25',0,'2014-03-01 16:30:17'),(20489,21139,'0000-00-00','ET','2',1,NULL,'Linda M Gearhart','FI','288509577','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:38',0,'2014-03-10 16:38:05'),(20901,21551,'0000-00-00','ET','2',3,2,'KIMBERLY DAVIS','FI','295725916','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:45',0,'2014-03-10 14:45:25'),(741,741,'2014-01-01','ET','2',1,NULL,'Jennifer McFadden','FI','162706412','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:04',0,'2014-03-10 13:24:34'),(3574,3574,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:03:32',0,'2014-03-02 00:10:48'),(13844,14200,'2014-01-01','ET','2',1,NULL,'gail guthrie','FI','452511296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:44',0,'2014-03-02 05:31:31'),(10645,10645,'2014-01-01','ET','2',1,NULL,'RODOLFO  F JUAREZ','FI','467355273','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:39',0,'2014-03-02 04:31:46'),(10960,10960,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:28',0,'2014-03-10 16:03:49'),(16438,17088,'0000-00-00','ET','2',1,NULL,'karen christman','FI','297569629','HealthSpan','FI','311431434','james   hitchings','94','1866145','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:50',0,'2014-03-10 14:20:26'),(19135,19785,'0000-00-00','ET','2',1,NULL,'Keith Homeyer','FI','282924242','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:10',0,'2014-03-01 17:34:07'),(19661,20311,'0000-00-00','ET','2',1,NULL,'CINDY RENTSCHLER','FI','296608590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:12',0,'2014-03-01 17:47:19'),(21285,21935,'0000-00-00','ET','2',1,NULL,'Jillian Harper','FI','587579164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:52',0,'2014-03-02 07:23:39'),(769,769,'2014-01-01','ET','2',4,3,'Jennifer Ann Rini','FI','296805161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:59',0,'2014-03-01 15:05:09'),(14761,15212,'2014-01-01','ET','2',2,1,'Kyle Schwieterman','FI','273908716','HealthSpan','FI','311431434','Aimee  Grieshop','94','3662265','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:33',0,'2014-03-10 14:03:26'),(10664,10664,'2014-01-01','ET','2',1,NULL,'Elbert Pruitt','FI','456510382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:59:14',0,'2014-03-02 04:31:46'),(14518,14969,'2014-01-01','ET','2',1,NULL,'Larry Nye','FI','287443102','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:08:02',0,'2014-03-10 14:03:26'),(7508,7508,'2014-01-01','ET','2',2,1,'Timothy Pruner','FI','284647185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:17',0,'2014-03-01 16:05:34'),(13201,13557,'2014-01-01','ET','2',2,1,'Michael Schmidt','FI','293505311','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:49',0,'2014-03-10 13:59:38'),(12245,12245,'2014-01-01','ET','2',1,NULL,'Angela Williams','FI','433299279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:15',0,'2014-03-02 05:10:52'),(7086,7086,'2014-01-01','ET','2',1,NULL,'Debra McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:13',0,'2014-03-01 15:52:44'),(11101,11101,'2014-01-01','ET','2',2,1,'Danielle Baker','FI','191728579','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:09',0,'2014-03-10 13:39:10'),(4907,4907,'2014-01-01','ET','2',1,NULL,'Dale Churchill','FI','450987297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:30:23',0,'2014-03-01 19:11:03'),(6449,6449,'2014-01-01','ET','2',1,NULL,'Jay Kornhaber','FI','176463848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:03',0,'2014-03-01 20:10:57'),(4661,4661,'2014-01-01','ET','2',1,NULL,'Charlotte Conley','FI','292583990','HealthSpan','FI','311431434','WILLIAM  MCILROY','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-25 23:49:17',0,'2014-03-10 13:45:57'),(4246,4246,'2014-01-01','ET','2',2,1,'Julie Randolph','FI','287622287','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:40',0,'2014-03-10 15:59:47'),(17436,18086,'0000-00-00','ET','2',1,NULL,'Belinda Graves','FI','465881968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:06',0,'2014-03-02 06:31:45'),(20360,21010,'0000-00-00','ET','2',2,1,'MAURICIO ZULETA','FI','629601182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:46',0,'2014-03-02 07:03:25'),(21469,22119,'0000-00-00','ET','2',1,NULL,'IAN MACKENZIE-THURLEY','FI','678779875','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:34',0,'2014-03-03 21:36:16'),(559,559,'2014-01-01','ET','2',2,1,'Tammy Vargas','FI','126543973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:20',0,'2014-03-01 15:48:04'),(10611,10611,'2014-01-01','ET','2',1,NULL,'Billy Daniels','FI','451957325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:32',0,'2014-03-02 04:24:47'),(1192,1192,'2014-01-01','ET','2',1,NULL,'Elizabeth Pasquier','FI','589449878','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:47:32',0,'2014-03-02 04:45:37'),(14463,14914,'2014-01-01','ET','2',1,NULL,'Pamela Ardoin','FI','439082886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:35',0,'2014-03-02 05:45:37'),(10413,10413,'2014-01-01','ET','2',2,1,'Elihudi Robson','FI','288131590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:07',0,'2014-03-01 16:10:36'),(12333,12333,'2014-01-01','ET','2',1,NULL,'NANCY LARA','FI','466492325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:20',0,'2014-03-02 05:03:29'),(6079,6079,'2014-01-01','ET','2',1,NULL,'Tiffany Robinson','FI','290787240','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:41',0,'2014-03-01 16:00:27'),(3598,3598,'2014-01-01','ET','2',1,NULL,'MARIO RULLAN','FI','466491510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:16',0,'2014-03-02 01:10:33'),(5867,5867,'2014-01-01','ET','2',1,NULL,'patricia nerone','FI','270509057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:49',0,'2014-03-01 15:05:09'),(4792,4792,'2014-01-01','ET','2',1,NULL,'aniket vardhan','FI','112887092','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:39',0,'2014-03-01 15:16:37'),(5594,5594,'2014-01-01','ET','2',1,NULL,'Donald Hunter','FI','449435834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:29',0,'2014-03-02 04:45:37'),(19667,20317,'0000-00-00','ET','2',1,NULL,'Carlye Parks','FI','268961058','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:47:33',0,'2014-03-01 17:47:19'),(22194,22844,'0000-00-00','ET','2',1,NULL,'Ajankoo Greenfield','FI','426650199','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:35',0,'2014-03-06 21:27:26'),(10,10,'2014-01-01','ET','2',1,NULL,'Lois Creech','FI','288482760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:20',0,'2014-03-01 15:21:15'),(906,906,'2014-01-01','ET','2',1,NULL,'Kimberly  Thompson','FI','269547828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:18',0,'2014-03-01 15:21:15'),(14258,14709,'2014-01-01','ET','2',1,NULL,'Eric Gregus','FI','288944102','Dental Care Plus, Inc.','FI','311185262','Jacqueline  Greene','94','2778558','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:06',0,'2014-03-01 16:46:19'),(13552,13908,'2014-01-01','ET','2',1,NULL,'shondrica Dejoie','FI','435417868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:19:50',0,'2014-03-02 05:24:45'),(6229,6229,'2014-01-01','ET','2',1,NULL,'KEVIN BAILOSKY','FI','283862692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:15',0,'2014-03-01 16:00:27'),(5695,5695,'2014-01-01','ET','2',4,3,'ramzi abdallah','FI','292027746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:14',0,'2014-03-01 15:37:30'),(5647,5647,'2014-01-01','ET','2',1,NULL,'Lisa Tilton','FI','289800303','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:13',0,'2014-03-10 13:52:32'),(18937,19587,'0000-00-00','ET','2',1,NULL,'Neil Safran','FI','292425150','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:28',0,'2014-03-10 16:31:33'),(10475,10475,'2014-01-01','ET','2',1,NULL,'AMELIA HARDING','FI','280862597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:53:04',0,'2014-03-01 16:10:36'),(16614,17264,'0000-00-00','ET','2',2,1,'PHONG LE','FI','187704048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:16',0,'2014-03-02 06:17:30'),(16406,17056,'0000-00-00','ET','2',1,NULL,'RONNICA DENISE SMITH','FI','587452600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:31',0,'2014-03-02 06:10:30'),(16185,16834,'0000-00-00','ET','2',1,NULL,'ROBERT D LEONBERGER','FI','300524119','Dental Care Plus, Inc.','FI','311185262','PAUL  MOSER','94','1738897','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:28',0,'2014-03-01 16:56:22'),(2257,2257,'2014-01-01','ET','2',1,NULL,'GREG HENAGAN','FI','439948623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:09',0,'2014-03-01 21:11:04'),(14470,14921,'2014-01-01','ET','2',1,NULL,'michael kelly','FI','278526676','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:39',0,'2014-03-10 16:17:47'),(5505,5505,'2014-01-01','ET','2',1,NULL,'Matthew Ashby','FI','289883711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:46:37',0,'2014-03-01 16:23:43'),(21412,22062,'0000-00-00','ET','2',1,NULL,'MARTHA MENDIOLA','FI','458849779','Starmount Life Insurance Company','FI','720977315','Debbie  Cunningham','94','1291462','348','2014-04-01','Sync Success',0,'2014-03-03 21:00:18',0,'2014-03-03 21:25:18'),(5151,5151,'2014-01-01','ET','2',1,NULL,'TERRY  L PRESTAS','FI','268606757','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:50:50',0,'2014-03-10 15:52:36'),(5083,5083,'2014-01-01','ET','2',1,NULL,'LINDA JANSON','FI','276448198','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:48:40',0,'2014-03-10 13:20:27'),(3138,3138,'2014-01-01','ET','2',1,NULL,'Karen Schulze','FI','291509356','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:20',0,'2014-03-10 13:24:34'),(3184,3184,'2014-01-01','ET','2',2,1,'David Roehm','FI','287429174','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:39:01',0,'2014-03-10 13:24:34'),(3156,3156,'2014-01-01','ET','2',1,NULL,'Ethel  Smith','FI','291489729','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:57',0,'2014-03-10 13:24:34'),(19497,20147,'0000-00-00','ET','2',2,1,'DAVID JOHNSON','FI','282623831','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:03:11',0,'2014-03-10 16:31:33'),(19625,20275,'0000-00-00','ET','2',1,NULL,'Rhonda Phillips','FI','284689766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:36:43',0,'2014-03-01 17:47:19'),(20022,20672,'0000-00-00','ET','2',1,NULL,'EDWARD BACKS','FI','268762247','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:08',0,'2014-03-10 14:37:47'),(22082,22732,'0000-00-00','ET','2',1,NULL,'Virginia Sapp','FI','433809866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:16',0,'2014-03-06 21:27:26'),(302,302,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:17',0,'2014-03-01 22:10:55'),(15412,15863,'0000-00-00','ET','2',1,NULL,'Estela Torres','FI','460450642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:22:17',0,'2014-03-02 05:59:43'),(617,617,'2014-01-01','ET','2',1,NULL,'Tammy Kantor','FI','456955534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:10',0,'2014-03-02 02:10:49'),(2407,2407,'2014-01-01','ET','2',2,1,'Hyun Park','FI','282086350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:27',0,'2014-03-01 15:26:40'),(12994,12994,'2014-01-01','ET','2',1,NULL,'CHRIS A WASHER','FI','279447404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:54',0,'2014-03-01 16:35:14'),(12489,12489,'2014-01-01','ET','2',1,NULL,'Johnathan Williams','FI','587575431','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:54',0,'2014-03-02 05:03:29'),(5413,5413,'2014-01-01','ET','2',1,NULL,'Somvilay Keomany','FI','586581546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:45',0,'2014-03-01 15:10:22'),(4503,4503,'2014-01-01','ET','2',1,NULL,'philip Whisner','FI','300804736','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:32:11',0,'2014-03-10 13:03:33'),(17159,17809,'0000-00-00','ET','2',1,NULL,'justin courtney','FI','279821699','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-19','Sync Success',0,'2014-02-04 21:01:39',0,'2014-03-01 17:00:58'),(18806,19456,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:03:13',0,'2014-03-10 14:31:05'),(19069,19719,'0000-00-00','ET','2',1,NULL,'robin nelson','FI','437338794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:21',0,'2014-03-02 06:52:12'),(20844,21494,'0000-00-00','ET','2',3,2,'Emil Mitchell','FI','433046356','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:18',0,'2014-03-02 07:17:36'),(22608,23258,'0000-00-00','ET','2',1,NULL,'Penny Hitt','FI','281542325','HealthSpan','FI','311431434','William  Beck','94','966895','348','2014-04-01','Sync Success',0,'2014-03-07 21:32:30',0,'2014-03-10 14:50:59'),(7002,7002,'2014-01-01','ET','2',2,1,'Eduardo Ribeiro','FI','516372629','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:33',0,'2014-03-02 02:10:49'),(1499,1499,'2014-01-01','ET','2',1,NULL,'SHERRY  ROCHELLE SHENKMIN','FI','290506753','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:21',0,'2014-03-10 13:45:57'),(13576,13932,'2014-01-01','ET','2',1,NULL,'Victoria Williams','FI','278542971','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:08',0,'2014-03-10 16:10:34'),(14717,15168,'2014-01-01','ET','2',2,1,'Terri Newnam','FI','271520471','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:06',0,'2014-03-10 14:03:26'),(20823,21473,'0000-00-00','ET','2',1,NULL,'MELISSA PURSREY','FI','456692197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:09',0,'2014-03-02 07:17:36'),(21799,22449,'0000-00-00','ET','2',2,1,'KATHY CONNER','FI','217880029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:15',0,'2014-03-04 22:25:23'),(1101,1101,'2014-01-01','ET','2',1,NULL,'james crawford','FI','280602287','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:04',0,'2014-03-10 15:39:19'),(17058,17708,'0000-00-00','ET','2',1,NULL,'Stacey Keating','FI','457197723','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:34',0,'2014-03-02 06:24:38'),(1155,1155,'2014-01-01','ET','2',1,NULL,'Cinuray Rancifer','FI','435214599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:22',0,'2014-03-02 04:38:08'),(2472,2472,'2014-01-01','ET','2',1,NULL,'Deborah Streithorst','FI','286629083','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 20:19:37',0,'2014-03-10 13:10:24'),(4023,4023,'2014-01-01','ET','2',1,NULL,'Francisco Moreno','FI','451982648','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:52',0,'2014-03-02 03:09:49'),(4752,4752,'2014-01-01','ET','2',1,NULL,'Kayla Jackson','FI','438810430','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:22',0,'2014-03-01 21:11:04'),(2826,2826,'2014-01-01','ET','2',1,NULL,'HEATHER  LYNN OKEEFE','FI','268866541','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:11',0,'2014-03-10 13:39:10'),(17503,18153,'0000-00-00','ET','2',1,NULL,'Kaitlin Hemmer','FI','298947889','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:30:06',0,'2014-03-10 14:24:38'),(17637,18287,'0000-00-00','ET','2',1,NULL,'ELIZABETH HOLMANN','FI','400868994','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:26',0,'2014-03-01 17:20:55'),(18306,18956,'0000-00-00','ET','2',1,NULL,'PATRICIA  MATHIS','FI','449961155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:08',0,'2014-03-02 06:45:14'),(21185,21835,'0000-00-00','ET','2',1,NULL,'Letitia Williams','FI','271780312','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:47',0,'2014-03-10 14:45:25'),(301,301,'2014-01-01','ET','2',1,NULL,'Richard Kay','FI','493561657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:45:16',0,'2014-03-01 22:10:55'),(16405,17055,'0000-00-00','ET','2',1,NULL,'SALLIE MAE BOYD','FI','587308894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:30',0,'2014-03-02 06:10:30'),(10807,10807,'2014-01-01','ET','2',1,NULL,'asia porter','FI','435354442','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:07',0,'2014-03-02 04:24:47'),(14207,14658,'2014-01-01','ET','2',2,1,'Keith Dietrich','FI','298720882','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:43',0,'2014-03-10 14:03:26'),(735,735,'2014-01-01','ET','2',1,NULL,'Carol Maloney','FI','283523960','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:54',0,'2014-03-10 13:24:34'),(1467,1467,'2014-01-01','ET','2',1,NULL,'malissa muscatello','FI','280843963','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:21',0,'2014-03-01 16:23:43'),(12233,12233,'2014-01-01','ET','2',1,NULL,'Woodrow Zachariah','FI','439765928','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:45',0,'2014-03-02 05:03:29'),(4512,4512,'2014-01-01','ET','2',1,NULL,'Mary Ridge','FI','281504384','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:27',0,'2014-03-01 15:16:37'),(1750,1750,'2014-01-01','ET','2',1,NULL,'Susan Beeson','FI','279827832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:58',0,'2014-03-01 15:31:33'),(18389,19039,'0000-00-00','ET','2',1,NULL,'Zoe Lipman','FI','435631561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:53',0,'2014-03-02 06:45:14'),(19004,19654,'0000-00-00','ET','2',2,1,'MICHAEL NEFF','FI','304725423','HealthSpan','FI','311431434','MICHAEL   DAUGHERTY','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:17',0,'2014-03-10 14:31:05'),(19070,19720,'0000-00-00','ET','2',2,1,'David Orechwa','FI','433040706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:22',0,'2014-03-02 06:52:12'),(500,500,'2014-01-01','ET','2',2,1,'MARITU BERIHUN','FI','300906951','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:28',0,'2014-03-01 15:48:04'),(7353,7353,'2014-01-01','ET','2',1,NULL,'Corey Ryan','FI','276901271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:35',0,'2014-03-01 15:16:37'),(14268,14719,'2014-01-01','ET','2',1,NULL,'INDIRA VANGURI','FI','296962335','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:10',0,'2014-03-01 16:46:19'),(13147,13503,'2014-01-01','ET','2',1,NULL,'Debbie Reichert','FI','289565472','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:48',0,'2014-03-10 13:59:38'),(12007,12007,'2014-01-01','ET','2',1,NULL,'Mark Tavormina','FI','133580401','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:21',0,'2014-03-02 04:59:36'),(11854,11854,'2014-01-01','ET','2',2,1,'Melinda Schneider','FI','291608811','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',1,'2013-12-29 11:14:57',0,'2014-03-10 13:45:57'),(11759,11759,'2014-01-01','ET','2',1,NULL,'margo migues','FI','433190465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:42',0,'2014-03-02 04:59:36'),(11512,11512,'2014-01-01','ET','2',2,1,'Robert Austin Gregory','FI','236809015','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:00',0,'2014-03-02 04:52:44'),(11487,11487,'2014-01-01','ET','2',2,1,'Debra Keene','FI','233865312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:16',0,'2014-03-01 16:30:17'),(3351,3351,'2014-01-01','ET','2',1,NULL,'Theresa Louise Pittard','FI','013527796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:12',0,'2014-03-02 02:10:49'),(5659,5659,'2014-01-01','ET','2',1,NULL,'Michelle Nelson','FI','428214196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:37',0,'2014-03-02 04:45:37'),(20578,21228,'0000-00-00','ET','2',1,NULL,'cyle hesser','FI','289967484','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:34',0,'2014-03-01 18:08:07'),(21775,22425,'0000-00-00','ET','2',1,NULL,'Theresa Chapin','FI','279665544','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:42',0,'2014-03-10 14:45:25'),(22153,22803,'0000-00-00','ET','2',1,NULL,'michael crookall','FI','295903393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:06',0,'2014-03-06 21:36:23'),(6075,6075,'2014-01-01','ET','2',2,1,'Donald Otto Shaffer','FI','433046260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:31',0,'2014-03-02 04:10:25'),(1827,1827,'2014-01-01','ET','2',2,1,'Anthony Walters','FI','295460196','Summa Insurance Company, Inc.','FI','341809108','Matt  Perkins','94','15854158','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:27',0,'2014-03-10 15:45:56'),(14330,14781,'2014-01-01','ET','2',1,NULL,'andrew ashmore','FI','431699233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:37',0,'2014-03-02 05:38:34'),(2121,2121,'2014-01-01','ET','2',1,NULL,'Jeanne L Neumann','FI','298460520','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:34',0,'2014-03-01 15:16:37'),(12923,12923,'2014-01-01','ET','2',3,2,'JOHN MILLIK','FI','288489717','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:46',0,'2014-03-10 16:10:34'),(2454,2454,'2014-01-01','ET','2',1,NULL,'Robert Richard','FI','438861049','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:59',0,'2014-03-01 23:10:52'),(16786,17436,'0000-00-00','ET','2',1,NULL,'Robert Kenard','FI','336466444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:32',0,'2014-03-02 06:17:30'),(16857,17507,'0000-00-00','ET','2',1,NULL,'ALISA BRANDT','FI','325804518','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:29',0,'2014-03-10 14:20:26'),(17138,17788,'0000-00-00','ET','2',1,NULL,'Crystal Ford','FI','294561447','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:24',0,'2014-03-10 16:24:30'),(17242,17892,'0000-00-00','ET','2',1,NULL,'Debra L Nichols','FI','295661668','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:27',0,'2014-03-01 17:20:55'),(20425,21075,'0000-00-00','ET','2',1,NULL,'samuel david shaferly','94','0000718949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 09:30:46',0,'2014-03-01 18:08:07'),(20987,21637,'0000-00-00','ET','2',1,NULL,'Raquell Perry','FI','435236201','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','357','2014-03-31','Sync Success',0,'2014-02-28 07:30:30',0,'2014-03-02 07:17:36'),(21061,21711,'0000-00-00','ET','2',1,NULL,'DAVID RISK','FI','270523465','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:22',0,'2014-03-01 18:10:11'),(21157,21807,'0000-00-00','ET','2',1,NULL,'VICTORIA M HARDMAN','FI','433559883','Starmount Life Insurance Company','FI','720977315','CAMERON  LILJENQUIST','94','8328382','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:26',0,'2014-03-02 07:17:36'),(1117,1117,'2014-01-01','ET','2',1,NULL,'Perry Joiner','FI','404352228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:11',0,'2014-03-02 04:38:08'),(10463,10463,'2014-01-01','ET','2',1,NULL,'Virginia Boyd','FI','290788613','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:41',0,'2014-03-01 16:10:36'),(2785,2785,'2014-01-01','ET','2',1,NULL,'WALTER BILLOPS','FI','369905597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:52',0,'2014-03-01 16:05:34'),(2791,2791,'2014-01-01','ET','2',1,NULL,'Kathy Larsen','FI','286744207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:05',0,'2014-03-01 16:05:34'),(14889,15340,'2014-01-01','ET','2',2,1,'Luz Atilano','FI','454110166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:19',0,'2014-03-02 05:45:37'),(3782,3782,'2014-01-01','ET','2',2,1,'GRADY L HILL','FI','276562367','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:43',0,'2014-03-01 15:26:40'),(11148,11148,'2014-01-01','ET','2',1,NULL,'Cornelis van der Velde','FI','128607648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:50',0,'2014-03-10 13:45:57'),(17170,17820,'0000-00-00','ET','2',1,NULL,'SUSAN BEASLEY','FI','509568325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:46',0,'2014-03-01 17:20:55'),(21646,22296,'0000-00-00','ET','2',1,NULL,'Adam Wolf','FI','298845678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:56',0,'2014-03-04 21:36:30'),(1092,1092,'2014-01-01','ET','2',1,NULL,'Keith Sommerstad','FI','107663673','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:43',0,'2014-03-10 15:39:19'),(14844,15295,'2014-01-01','ET','2',1,NULL,'Cynthia Greathouse','FI','280507474','HealthSpan','FI','311431434','Brenda  Williams','94','8389118','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:27',0,'2014-03-10 14:03:26'),(13574,13930,'2014-01-01','ET','2',1,NULL,'AUDREY ROZACK','FI','302487856','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:06',0,'2014-03-10 16:10:34'),(17344,17994,'0000-00-00','ET','2',1,NULL,'Paul Allaer','FI','577117066','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:19',0,'2014-03-10 14:24:38'),(22033,22683,'0000-00-00','ET','2',1,NULL,'MARILYN CONNER','FI','453374872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:32:16',0,'2014-03-05 22:27:33'),(1863,1863,'2014-01-01','ET','2',1,NULL,'janet  l paul','FI','288521276','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:38',0,'2014-03-01 15:26:40'),(14954,15405,'2014-01-01','ET','2',2,1,'ROBIN SHERER','FI','319501890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:49',0,'2014-03-02 05:45:37'),(3147,3147,'2014-01-01','ET','2',1,NULL,'Brenda Leach','94','0000710115','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 21:37:40',0,'2014-03-10 13:24:34'),(13547,13903,'2014-01-01','ET','2',2,1,'EDUARD I  CESTEDES-MONTANO','FI','598544676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:47',0,'2014-03-02 05:31:31'),(16711,17361,'0000-00-00','ET','2',1,NULL,'ROSE JACKSON','FI','277643180','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:25',0,'2014-03-01 17:00:58'),(20077,20727,'0000-00-00','ET','2',1,NULL,'Gregory Macias','FI','268740029','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:31',0,'2014-03-10 14:37:47'),(20157,20807,'0000-00-00','ET','2',1,NULL,'Julia Eichenlaub','FI','275861711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:00',0,'2014-03-01 18:08:07'),(21806,22456,'0000-00-00','ET','2',3,2,'Willie R Jones','FI','587110456','Starmount Life Insurance Company','FI','720977315','Dennis  Ayeis','94','1711508986','348','2014-04-01','Sync Success',0,'2014-03-04 21:30:21',0,'2014-03-04 22:25:23'),(4200,4200,'2014-01-01','ET','2',2,1,'Harmony Warner','FI','536846193','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:15',0,'2014-03-10 13:32:15'),(15844,16493,'0000-00-00','ET','2',1,NULL,'THOMAS MCKINNEY','FI','273644758','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:37',0,'2014-03-01 16:56:22'),(12194,12194,'2014-01-01','ET','2',1,NULL,'Matthew Becker','FI','300622127','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:09:07',0,'2014-03-10 13:52:32'),(11349,11349,'2014-01-01','ET','2',1,NULL,'Robert Little','FI','268644708','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:00',0,'2014-03-10 13:52:32'),(2609,2609,'2014-01-01','ET','2',1,0,'Willie Morris','FI','461316856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:16',0,'2014-03-01 19:11:03'),(17074,17724,'0000-00-00','ET','2',2,1,'Peterson Carpenter','FI','458776428','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:44',0,'2014-03-02 06:24:38'),(17277,17927,'0000-00-00','ET','2',1,NULL,'Lauri Wittenstrom','FI','340523931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:43',0,'2014-03-02 06:24:38'),(17796,18446,'0000-00-00','ET','2',1,NULL,'Lucinda K Wolford','FI','487969681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:30',0,'2014-03-01 16:50:53'),(19103,19753,'0000-00-00','ET','2',1,NULL,'Okang Lindsey','FI','104068857','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:46',0,'2014-03-01 17:34:07'),(81,81,'2014-01-01','ET','2',1,NULL,'ALFREDO OBREGON','FI','463877498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:27',0,'2014-03-01 22:10:55'),(7660,7660,'2014-01-01','ET','2',1,NULL,'Donna Jean Minge','FI','280540544','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:39:09',0,'2014-03-10 13:39:10'),(7488,7488,'2014-01-01','ET','2',1,NULL,'Barbara Tucker','FI','114442304','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:37',0,'2014-03-10 13:39:10'),(5232,5232,'2014-01-01','ET','2',1,NULL,'Brent  Bourland','FI','425982855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:28',0,'2014-03-02 00:10:48'),(11479,11479,'2014-01-01','ET','2',1,NULL,'anthony Boakai','FI','493272938','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:02',0,'2014-03-01 16:30:17'),(18918,19568,'0000-00-00','ET','2',1,NULL,'MANDIE BARNES','FI','587543520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:15',0,'2014-03-02 06:52:12'),(20377,21027,'0000-00-00','ET','2',1,NULL,'Robby Piantanida','FI','641285910','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:06',0,'2014-03-02 07:10:28'),(23,23,'2014-01-01','ET','2',1,NULL,'Katherine Hattemer','FI','274921564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:42',0,'2014-03-01 15:21:15'),(16479,17129,'0000-00-00','ET','2',2,1,'victor jurado','FI','450551912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:24',0,'2014-03-02 06:10:30'),(16344,16994,'0000-00-00','ET','2',1,NULL,'NIKOLE MARIE FUQUA','FI','298906623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:50',0,'2014-03-01 16:56:22'),(190,190,'2014-01-01','ET','2',1,NULL,'KATHLEEN  WHITE','FI','437980037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:55',0,'2014-03-01 22:10:55'),(3980,3980,'2014-01-01','ET','2',1,NULL,'Michael Miller','FI','433747096','Starmount Life Insurance Company','FI','720977315','John  Chambaugh','94','4721894','348','2014-01-01','Sync Success',0,'2013-12-25 22:47:33',0,'2014-03-01 23:10:52'),(12356,12356,'2014-01-01','ET','2',1,NULL,'Kimberly Kothman','FI','447683085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:04',0,'2014-03-02 05:03:29'),(12351,12351,'2014-01-01','ET','2',1,NULL,'juan vega carmona','FI','732034565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:56',0,'2014-03-02 05:03:29'),(2100,2100,'2014-01-01','ET','2',2,1,'Diana Maria McCarty','FI','301582046','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 19:38:03',0,'2014-03-10 13:20:27'),(17307,17957,'0000-00-00','ET','2',3,2,'Arnold F Leary','FI','437868233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:59',0,'2014-03-02 06:24:38'),(21076,21726,'0000-00-00','ET','2',1,NULL,'ROGER MATTSCHECK','FI','279547663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:31',0,'2014-03-01 18:10:11'),(10470,10470,'2014-01-01','ET','2',1,NULL,'timothy hiser','FI','295845878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:52:57',0,'2014-03-01 16:10:36'),(15964,16613,'0000-00-00','ET','2',1,NULL,'Esmeralda Salazar','FI','462552486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:12',0,'2014-03-02 06:03:21'),(7093,7093,'2014-01-01','ET','2',1,NULL,'Brittani Agee','FI','275968708','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:25',0,'2014-03-01 15:52:44'),(12502,12502,'2014-01-01','ET','2',1,NULL,'Essie Richmond','FI','434175264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:27',0,'2014-03-02 05:03:29'),(11606,11606,'2014-01-01','ET','2',1,NULL,'Frederick Dymond','FI','433929432','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:54',0,'2014-03-02 04:52:44'),(4530,4530,'2014-01-01','ET','2',1,NULL,'Barry Bleichner','FI','438295635','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:33:06',0,'2014-03-01 21:11:04'),(4911,4911,'2014-01-01','ET','2',1,NULL,'Susan Burgwald','FI','277527805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:31',0,'2014-03-01 15:05:09'),(5664,5664,'2014-01-01','ET','2',4,3,'Cynthia Cage','FI','454373616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:48',0,'2014-03-02 04:45:37'),(20623,21273,'0000-00-00','ET','2',1,NULL,'LAWRENCE CARTER','FI','435353065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:04',0,'2014-03-02 07:10:28'),(242,242,'2014-01-01','ET','2',1,NULL,'TERRY CLAY','FI','268581631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:37',0,'2014-03-01 15:10:22'),(3564,3564,'2014-01-01','ET','2',1,NULL,'Jamie Kungu','FI','466655477','Starmount Life Insurance Company','FI','720977315','John  Skomal','94','15877096','348','2014-01-01','Sync Success',0,'2013-12-25 22:03:15',0,'2014-03-02 00:10:48'),(15419,15870,'0000-00-00','ET','2',1,NULL,'Matthew Brandon','FI','281902351','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:22',0,'2014-03-01 16:50:53'),(15038,15489,'2014-01-01','ET','2',1,NULL,'Lillian Foley','FI','437313747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:26',0,'2014-03-02 05:52:31'),(14851,15302,'2014-01-01','ET','2',1,NULL,'Kelsey McAlister','FI','644090581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:02',0,'2014-03-02 05:45:37'),(11655,11655,'2014-01-01','ET','2',2,1,'BENJAMIN R GRANDSTAFF','FI','277542598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:26',0,'2014-03-01 16:30:17'),(17248,17898,'0000-00-00','ET','2',1,NULL,'kevin bricker','FI','288505828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:30',0,'2014-03-01 17:20:55'),(1065,1065,'2014-01-01','ET','2',1,NULL,'Stephanie Burks','FI','273905942','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:46',0,'2014-03-01 15:16:37'),(2586,2586,'2014-01-01','ET','2',1,NULL,'Anne Ody','FI','374507345','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:32',0,'2014-03-10 15:39:19'),(15307,15758,'0000-00-00','ET','2',1,NULL,'Scot Pilkington','FI','280423685','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:22',0,'2014-03-01 16:50:53'),(14700,15151,'2014-01-01','ET','2',1,NULL,'allison bell','FI','433498238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:55',0,'2014-03-02 05:45:37'),(3196,3196,'2014-01-01','ET','2',1,NULL,'Linnette Neely','FI','299480651','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:12',0,'2014-03-01 15:48:04'),(14095,14546,'2014-01-01','ET','2',1,NULL,'Sandra Simmons','FI','466840637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:32',0,'2014-03-02 05:38:34'),(13674,14030,'2014-01-01','ET','2',1,NULL,'Rosario Davila','FI','464795152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:25',0,'2014-03-02 05:24:45'),(5852,5852,'2014-01-01','ET','2',2,1,'Lorry Ann Smith','FI','290601728','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:12',0,'2014-03-10 13:03:33'),(12850,12850,'2014-01-01','ET','2',1,NULL,'Verlyn Machicek','FI','463921045','Starmount Life Insurance Company','FI','720977315','Bobby  Plaster','94','565754','348','2014-02-01','Sync Success',0,'2014-01-04 02:03:04',0,'2014-03-02 05:17:40'),(12381,12381,'2014-01-01','ET','2',1,NULL,'Kristiana Reeves','FI','278903743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:29:01',0,'2014-03-01 16:30:17'),(4967,4967,'2014-01-01','ET','2',1,0,'Teri Hamilton','FI','292586136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:32:21',0,'2014-03-10 13:03:33'),(17467,18117,'0000-00-00','ET','2',1,NULL,'Sandra Myles','FI','433135226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:29',0,'2014-03-02 06:31:45'),(20207,20857,'0000-00-00','ET','2',1,NULL,'LIYA DING','FI','640403460','Starmount Life Insurance Company','FI','720977315','DEQING   YANG','94','11179161','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:36',0,'2014-03-02 07:10:28'),(20564,21214,'0000-00-00','ET','2',1,NULL,'TERRY ANN SMART','FI','461119508','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:26',0,'2014-03-02 07:17:36'),(13430,13786,'2014-01-01','ET','2',1,NULL,'TIMOTHY J WILLIAMS','FI','299787440','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:18:05',0,'2014-03-01 16:40:16'),(14819,15270,'2014-01-01','ET','2',1,NULL,'Jill Pinta','FI','295685519','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:11',0,'2014-03-10 14:03:26'),(19557,20207,'0000-00-00','ET','2',1,NULL,'LAVONDA CHARLES SIMIEN','FI','369789588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:19:42',0,'2014-03-02 06:59:07'),(20345,20995,'0000-00-00','ET','2',1,NULL,'brady tucker','94','0000152036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:35',0,'2014-03-01 17:47:19'),(1187,1187,'2014-01-01','ET','2',1,NULL,'PAUL CAMPBELL','FI','433175088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:22',0,'2014-03-02 04:45:37'),(15286,15737,'0000-00-00','ET','2',1,NULL,'SuzAnne Sisak','FI','189660229','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:10',0,'2014-03-02 05:52:31'),(22036,22686,'0000-00-00','ET','2',1,NULL,'Delilah Montague','FI','295841346','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-04-01','Sync Success',0,'2014-03-05 21:32:18',0,'2014-03-10 14:45:25'),(284,284,'2014-01-01','ET','2',1,NULL,'Violet Escamilla','FI','643031064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:08',0,'2014-03-01 19:11:03'),(18531,19181,'0000-00-00','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:03',0,'2014-03-01 17:26:36'),(5598,5598,'2014-01-01','ET','2',1,NULL,'kashonda moore','FI','460552249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:35',0,'2014-03-02 04:45:37'),(5380,5380,'2014-01-01','ET','2',2,1,'Bryan Marsh Bell','FI','453804353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:53',0,'2014-03-01 21:11:04'),(360,360,'2014-01-01','ET','2',1,NULL,'mark pavich','FI','291744776','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:05',0,'2014-03-01 15:21:15'),(7401,7401,'2014-01-01','ET','2',1,NULL,'Kenneth Barber','FI','434049310','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:54',0,'2014-03-02 04:10:25'),(1518,1518,'2014-01-01','ET','2',2,1,'Dennis Halpin','FI','295444911','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:58',0,'2014-03-10 13:52:32'),(21612,22262,'0000-00-00','ET','2',2,1,'David E Nunn','FI','540961633','Starmount Life Insurance Company','FI','720977315','Sean  Fletcher','94','15978217','348','2014-04-01','Sync Success',0,'2014-03-04 21:00:30',0,'2014-03-04 21:27:16'),(2455,2455,'2014-01-01','ET','2',2,1,'Michelle Ann Surritte-Armbruster','FI','149767433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:01',0,'2014-03-01 23:10:52'),(10614,10614,'2014-01-01','ET','2',1,NULL,'Maria Polo','FI','461952063','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:39',0,'2014-03-02 04:24:47'),(10735,10735,'2014-01-01','ET','2',1,NULL,'Danielle Moon','FI','282905340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:44',0,'2014-03-01 16:10:36'),(10760,10760,'2014-01-01','ET','2',2,1,'TILBRUN JR BAREHERENY','FI','770427516','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:35',0,'2014-03-01 16:10:36'),(16482,17132,'0000-00-00','ET','2',1,NULL,'ANNETE RIVERA','FI','465593968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:26',0,'2014-03-02 06:10:30'),(11203,11203,'2014-01-01','ET','2',1,NULL,'magersa bulti','FI','606138063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:32',0,'2014-03-01 16:23:43'),(12582,12582,'2014-01-01','ET','2',1,NULL,'Ugochi Madubata','FI','215270169','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:28',0,'2014-03-01 16:35:14'),(12706,12706,'2014-01-01','ET','2',1,NULL,'Jaimee Yeager','FI','426712628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:05:00',0,'2014-03-02 05:10:52'),(14162,14613,'2014-01-01','ET','2',2,1,'Karoline Trent','FI','290608087','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:14',0,'2014-03-10 16:17:47'),(13775,14131,'2014-01-01','ET','2',1,NULL,'Ronald Lee','FI','291467678','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:22:30',0,'2014-03-10 16:10:34'),(12825,12825,'2014-01-01','ET','2',1,NULL,'BRANDON LEONARD','FI','433757637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:09',0,'2014-03-02 05:10:52'),(4691,4691,'2014-01-01','ET','2',1,NULL,'Heather Hunsaker','94','0001235321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:21',0,'2014-03-02 04:38:08'),(20292,20942,'0000-00-00','ET','2',1,NULL,'VERA DAVIS','FI','464060752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:36',0,'2014-03-02 07:10:28'),(20049,20699,'0000-00-00','ET','2',1,NULL,'VICKI ATTAWAY','FI','436861952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:11',0,'2014-03-02 07:10:28'),(4561,4561,'2014-01-01','ET','2',2,1,'Quyen Vu','FI','612505907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:03',0,'2014-03-02 04:38:08'),(14775,15226,'2014-01-01','ET','2',1,NULL,'Paula Pavlyak','FI','117467827','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:42',0,'2014-03-10 14:03:26'),(14215,14666,'2014-01-01','ET','2',1,NULL,'LESLIE MILLER','FI','295467951','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:50',0,'2014-03-10 14:03:26'),(7362,7362,'2014-01-01','ET','2',1,NULL,'Steven Bernola','FI','270468608','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:55',0,'2014-03-01 15:16:37'),(10423,10423,'2014-01-01','ET','2',1,NULL,'HARRISE MOROSKY','FI','289523895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:51:24',0,'2014-03-01 16:10:36'),(22475,23125,'0000-00-00','ET','2',1,NULL,'Robert KUELLING','FI','295566447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:53',0,'2014-03-07 21:36:32'),(25,25,'2014-01-01','ET','2',1,NULL,'PATRICIA FADEL','FI','130422001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:46',0,'2014-03-01 15:21:15'),(6288,6288,'2014-01-01','ET','2',1,NULL,'IVY PERRY','FI','547152298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:07:05',0,'2014-03-02 04:10:25'),(1942,1942,'2014-01-01','ET','2',1,NULL,'RANDY THARP','FI','280428905','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:00',0,'2014-03-01 15:26:40'),(10604,10604,'2014-01-01','ET','2',1,NULL,'Maria Castillo','FI','453892414','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','348','2014-01-01','Sync Success',0,'2013-12-26 12:57:20',0,'2014-03-02 04:24:47'),(17861,18511,'0000-00-00','ET','2',1,NULL,'latoya marie hindsman','FI','288885756','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:10',0,'2014-03-10 14:24:38'),(16900,17550,'0000-00-00','ET','2',1,NULL,'Amanda Checco','FI','291825128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:27',0,'2014-03-01 17:00:58'),(11495,11495,'2014-01-01','ET','2',1,NULL,'Noemi Aguirre','FI','459822553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:30',0,'2014-03-02 04:52:44'),(21826,22476,'0000-00-00','ET','2',1,NULL,'Lauren Yancey','FI','273524407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:20',0,'2014-03-05 21:36:22'),(22136,22786,'0000-00-00','ET','2',1,NULL,'Carla J Cox','FI','429351207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:55',0,'2014-03-06 21:27:26'),(6363,6363,'2014-01-01','ET','2',1,NULL,'Robert Howard Moxley','FI','296483812','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:19',0,'2014-03-10 15:59:47'),(2283,2283,'2014-01-01','ET','2',2,1,'Karla Reynolds','FI','273643486','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:36',0,'2014-03-10 15:39:19'),(5185,5185,'2014-01-01','ET','2',1,NULL,'Scott M Leavell','FI','372884837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:53',0,'2014-03-02 00:10:48'),(19886,20536,'0000-00-00','ET','2',1,NULL,'REBECCA JACKSON','FI','279505781','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN P KELLY','94','2516200','348','2014-04-01','Sync Success',0,'2014-02-20 22:01:33',0,'2014-03-10 16:38:05'),(19213,19863,'0000-00-00','ET','2',2,1,'Bonnie Farr','FI','363623844','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:10',0,'2014-03-10 14:31:05'),(19193,19843,'0000-00-00','ET','2',1,NULL,'Patsy Craft','FI','296489732','HealthSpan','FI','311431434','Thomas   Konzen','94','7981943','357','2014-03-01','Sync Success',0,'2014-02-15 22:02:00',0,'2014-03-10 14:31:05'),(17946,18596,'0000-00-00','ET','2',6,5,'paul lindhorst','FI','302806472','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:00',0,'2014-03-01 17:20:55'),(3425,3425,'2014-01-01','ET','2',1,NULL,'teresa davis','FI','294745384','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:52:31',0,'2014-03-10 13:24:34'),(15787,16436,'0000-00-00','ET','2',1,NULL,'Alicia Salinas','FI','452904712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:04',0,'2014-03-02 06:03:21'),(15253,15704,'0000-00-00','ET','2',1,NULL,'Cynthia D Robenson','FI','456256873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:31',0,'2014-03-02 05:52:31'),(2893,2893,'2014-01-01','ET','2',5,4,'Patrice McDermott','FI','273684743','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:28',0,'2014-03-10 15:59:47'),(6426,6426,'2014-01-01','ET','2',1,NULL,'Cyanthia S Collins','FI','300684219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:20',0,'2014-03-01 15:10:22'),(12540,12540,'2014-01-01','ET','2',1,NULL,'NANCY VANCE','FI','224844172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:52',0,'2014-03-10 13:59:38'),(11081,11081,'2014-01-01','ET','2',1,NULL,'Janet Williams','FI','299504543','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:29',0,'2014-03-10 13:45:57'),(6032,6032,'2014-01-01','ET','2',1,NULL,'Tychesia Branden','FI','433319559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:56',0,'2014-03-01 20:10:57'),(20473,21123,'0000-00-00','ET','2',1,NULL,'LONI DOZIER','FI','300840798','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:25',0,'2014-03-01 18:08:07'),(6453,6453,'2014-01-01','ET','2',1,NULL,'Rocco Bonura','FI','436966559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:13',0,'2014-03-01 20:10:57'),(14990,15441,'2014-01-01','ET','2',1,NULL,'James Tatum','FI','587532816','Starmount Life Insurance Company','FI','720977315','Laura  Bilbrew','94','8968156','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:06',0,'2014-03-02 05:45:37'),(16766,17416,'0000-00-00','ET','2',1,NULL,'GEORGE NATHAN','FI','434594277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:19',0,'2014-03-02 06:17:30'),(17442,18092,'0000-00-00','ET','2',1,NULL,'Donna L Edmisten','FI','302463275','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:10',0,'2014-03-10 14:24:38'),(21147,21797,'0000-00-00','ET','2',2,1,'SARRELL JONES','FI','530705360','Starmount Life Insurance Company','FI','720977315','MELVIN  MCELWELL','94','17004683','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:19',0,'2014-03-02 07:23:39'),(21667,22317,'0000-00-00','ET','2',1,NULL,'James Johnson','FI','286506600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:11',0,'2014-03-04 21:36:30'),(22795,23445,'0000-00-00','ET','2',2,1,'Kellee Wright','FI','288829205','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:46',0,'2014-03-09 21:35:27'),(2253,2253,'2014-01-01','ET','2',1,NULL,'Jane Nunemaker','FI','268525324','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:02',0,'2014-03-10 13:10:24'),(3211,3211,'2014-01-01','ET','2',2,1,'randy ruggles','FI','284568258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:39',0,'2014-03-01 15:48:04'),(2356,2356,'2014-01-01','ET','2',1,NULL,'Emily Andregg','FI','282768564','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:50',0,'2014-03-01 15:26:40'),(10431,10431,'2014-01-01','ET','2',1,NULL,'John Thatcher','FI','291421337','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:39',0,'2014-03-01 16:10:36'),(10973,10973,'2014-01-01','ET','2',1,NULL,'Deborah Burk','FI','292429678','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:51',0,'2014-03-10 13:39:10'),(16152,16801,'0000-00-00','ET','2',1,NULL,'ANGELA BOYD','FI','428535312','Starmount Life Insurance Company','FI','720977315','RYAN  FRENCH','94','8161780','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:09',0,'2014-03-02 06:10:30'),(12178,12178,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:26',0,'2014-03-10 13:52:32'),(15006,15457,'2014-01-01','ET','2',1,NULL,'Jill Foster','FI','277862665','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:12',0,'2014-03-10 16:17:47'),(12481,12481,'2014-01-01','ET','2',1,NULL,'robert brinkman','FI','275508179','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:33',0,'2014-03-01 16:35:14'),(12659,12659,'2014-01-01','ET','2',1,NULL,'DON WAYNE YOUNG','FI','437086160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:17',0,'2014-03-02 05:10:52'),(238,238,'2014-01-01','ET','2',2,1,'Daniel Roselle','FI','634014436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:27',0,'2014-03-01 19:11:03'),(20631,21281,'0000-00-00','ET','2',3,2,'JENNIFER MILLER','FI','284804462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:11',0,'2014-03-10 14:37:47'),(19885,20535,'0000-00-00','ET','2',1,NULL,'Emma Young','FI','587113286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:32',0,'2014-03-02 07:03:25'),(1278,1278,'2014-01-01','ET','2',1,NULL,'MARY HARPER','FI','301721292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:07',0,'2014-03-01 16:23:43'),(19180,19830,'0000-00-00','ET','2',1,NULL,'Tania Hicks','FI','381966746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:47',0,'2014-03-02 06:52:12'),(18951,19601,'0000-00-00','ET','2',2,1,'Robert V Dible','FI','302602693','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:38',0,'2014-03-10 14:31:05'),(1629,1629,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:56',0,'2014-03-01 20:10:57'),(13957,14313,'2014-01-01','ET','2',1,NULL,'John Kennedy','FI','283808167','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:39',0,'2014-03-10 14:03:26'),(2968,2968,'2014-01-01','ET','2',2,1,'Michael Robert Hirst','FI','300509510','Dental Care Plus, Inc.','FI','311185262','Lisa  saltsgiver','94','2493771','348','2014-01-01','Sync Success',0,'2013-12-25 21:32:09',0,'2014-03-01 15:37:30'),(7716,7716,'2014-01-01','ET','2',2,1,'Margaret Estrada','FI','463920478','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:00',0,'2014-03-01 20:10:57'),(11656,11656,'2014-01-01','ET','2',1,NULL,'JONATHAN EHRENKRANTZ','FI','052648155','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:28',0,'2014-03-01 16:30:17'),(2397,2397,'2014-01-01','ET','2',1,NULL,'William Patterson','FI','453256407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:06',0,'2014-03-01 23:10:52'),(19511,20161,'0000-00-00','ET','2',5,4,'AUSTIN ONWUAGBA','FI','272176442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:07:01',0,'2014-03-01 17:34:07'),(5187,5187,'2014-01-01','ET','2',1,NULL,'Senia Gomez','FI','645106521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:58',0,'2014-03-02 00:10:48'),(17873,18523,'0000-00-00','ET','2',5,4,'John Cassiday','FI','294787814','Summa Insurance Company, Inc.','FI','341809108','Tim  Walters','94','1852658','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:09',0,'2014-03-10 16:31:33'),(7671,7671,'2014-01-01','ET','2',2,1,'keith caldwell','94','0000437967','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:32',0,'2014-03-10 13:39:10'),(10786,10786,'2014-01-01','ET','2',1,NULL,'Lisa Alexander','FI','435651680','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:03:26',0,'2014-03-02 04:24:47'),(14272,14723,'2014-01-01','ET','2',1,NULL,'Lynne Juric','FI','286527978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:12',0,'2014-03-01 16:46:19'),(13534,13890,'2014-01-01','ET','2',1,NULL,'TARA MILLER','FI','298842501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:39',0,'2014-03-01 16:40:16'),(21364,22014,'0000-00-00','ET','2',2,1,'MICHAEL SHOFFSTALL','FI','300482337','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:32',0,'2014-03-10 16:38:05'),(22705,23355,'0000-00-00','ET','2',2,1,'Tammy Coleman','FI','284725154','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:02',0,'2014-03-10 16:44:18'),(510,510,'2014-01-01','ET','2',1,NULL,'Karen Francis','FI','291525890','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:47',0,'2014-03-01 15:48:04'),(973,973,'2014-01-01','ET','2',1,NULL,'Tamera Barnes','FI','294723916','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:23',0,'2014-03-01 15:21:15'),(984,984,'2014-01-01','ET','2',1,NULL,'Joseph Charles Calio','FI','286482741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:43',0,'2014-03-01 15:21:15'),(5161,5161,'2014-01-01','ET','2',1,NULL,'dale cochoy','FI','298482682','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:07',0,'2014-03-10 15:45:56'),(5127,5127,'2014-01-01','ET','2',1,NULL,'Jeffrey Hall','FI','272884271','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:07',0,'2014-03-10 15:45:56'),(1823,1823,'2014-01-01','ET','2',1,NULL,'Kathleen Tomer','FI','298482936','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:20',0,'2014-03-10 15:45:56'),(4705,4705,'2014-01-01','ET','2',1,NULL,'jacob carl mills','FI','532118302','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:48',0,'2014-03-02 04:38:08'),(2289,2289,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:00:48',0,'2014-03-01 21:11:04'),(13983,14339,'2014-01-01','ET','2',1,NULL,'Cynthia rivera','FI','456436764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:18',0,'2014-03-02 05:31:31'),(3869,3869,'2014-01-01','ET','2',1,0,'Rhea Rasnic','FI','406883570','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:31:12',0,'2014-03-01 19:11:03'),(3228,3228,'2014-01-01','ET','2',1,NULL,'LINDA J RAPPACH','FI','289523854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:11',0,'2014-03-01 15:52:44'),(22784,23434,'0000-00-00','ET','2',1,NULL,'Briana Collins','FI','282969599','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:36',0,'2014-03-09 21:35:27'),(28,28,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:51',0,'2014-03-01 15:21:15'),(609,609,'2014-01-01','ET','2',1,NULL,'Trent Langford','FI','631090073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:53',0,'2014-03-02 02:10:49'),(1849,1849,'2014-01-01','ET','2',1,NULL,'Kimberly Sanders','FI','294561026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:09',0,'2014-03-01 15:26:40'),(6462,6462,'2014-01-01','ET','2',1,NULL,'Michael Gilbert','FI','287542183','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:31',0,'2014-03-10 13:03:33'),(19864,20514,'0000-00-00','ET','2',2,1,'ELDAR SABIROV','FI','271080228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:14',0,'2014-03-01 17:47:19'),(2326,2326,'2014-01-01','ET','2',2,1,'KATHERINE KAY NAGEL','FI','459022533','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:09',0,'2014-03-01 19:11:03'),(19083,19733,'0000-00-00','ET','2',1,NULL,'Joe Tayeh','FI','294927655','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:32',0,'2014-03-01 17:34:07'),(13530,13886,'2014-01-01','ET','2',1,NULL,'Paule Messac','FI','095504958','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:36',0,'2014-03-01 16:40:16'),(16578,17228,'0000-00-00','ET','2',1,NULL,'Juanita Lucke','FI','377564949','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:28',0,'2014-03-10 14:20:26'),(16135,16784,'0000-00-00','ET','2',1,NULL,'JUDITH ROBINSON','FI','289685630','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:45',0,'2014-03-10 14:20:26'),(19295,19945,'0000-00-00','ET','2',1,NULL,'MICHELLE L COHEN','FI','273761670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:15',0,'2014-03-10 14:31:05'),(18802,19452,'0000-00-00','ET','2',2,1,'MARGARET MOONEY','FI','283700185','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:09',0,'2014-03-10 14:31:05'),(18704,19354,'0000-00-00','ET','2',1,NULL,'Maarit Leppala','FI','104722454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:56',0,'2014-03-02 06:45:14'),(12847,12847,'2014-01-01','ET','2',1,NULL,'Clifton Thompson','FI','462697149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:56',0,'2014-03-02 05:10:52'),(7505,7505,'2014-01-01','ET','2',1,NULL,'ELAINA FARNSWORTH','FI','300684522','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:13',0,'2014-03-01 16:05:34'),(2395,2395,'2014-01-01','ET','2',1,NULL,'Natalie Jacqueline Fisher','FI','637124767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:02',0,'2014-03-01 23:10:52'),(2551,2551,'2014-01-01','ET','2',1,NULL,'Sharon Parker','FI','274487686','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:35',0,'2014-03-10 15:39:19'),(20495,21145,'0000-00-00','ET','2',1,NULL,'Jacques DeLisle','FI','595123891','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:41',0,'2014-03-02 07:10:28'),(20815,21465,'0000-00-00','ET','2',2,1,'Lam Tran','FI','730268615','Starmount Life Insurance Company','FI','720977315','Julie  Nguyen','94','6040941','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:05',0,'2014-03-02 07:17:36'),(21783,22433,'0000-00-00','ET','2',1,NULL,'SHARON M THIERET','FI','286682769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:04',0,'2014-03-04 21:36:30'),(22465,23115,'0000-00-00','ET','2',1,NULL,'Eric Morrow','FI','297927662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:46',0,'2014-03-07 21:36:32'),(13078,13434,'2014-01-01','ET','2',1,NULL,'corlinda l morrell','FI','137526467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:05',0,'2014-03-02 05:17:40'),(12276,12276,'2014-01-01','ET','2',1,NULL,'Andrew Shade','FI','201703865','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:25',0,'2014-03-10 16:10:34'),(2063,2063,'2014-01-01','ET','2',1,NULL,'Theresa Johnson','FI','300503292','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:36:54',0,'2014-03-10 13:20:27'),(19159,19809,'0000-00-00','ET','2',1,NULL,'RAMIRO QUIROZ','FI','635126289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:30',0,'2014-03-02 06:52:12'),(5065,5065,'2014-01-01','ET','2',2,1,'Thomas Clifford Timmons','FI','079448514','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:05',0,'2014-03-01 15:31:33'),(17705,18355,'0000-00-00','ET','2',1,NULL,'Chloe Retta Lyons','94','0000787233','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:05',0,'2014-03-01 17:20:55'),(5256,5256,'2014-01-01','ET','2',1,NULL,'Kimberly Jones','FI','301489370','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:54:16',0,'2014-03-10 13:20:27'),(1363,1363,'2014-01-01','ET','2',1,NULL,'LESLIE CAMACHO','FI','461353065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:52:51',0,'2014-03-02 04:38:08'),(14895,15346,'2014-01-01','ET','2',1,NULL,'REBECCA KELLAR','FI','377707631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:21',0,'2014-03-02 05:45:37'),(10890,10890,'2014-01-01','ET','2',1,NULL,'david delgado','FI','434733174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:18',0,'2014-03-02 04:24:47'),(6098,6098,'2014-01-01','ET','2',2,1,'steven robinson','FI','288522756','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:16',0,'2014-03-01 16:00:27'),(3103,3103,'2014-01-01','ET','2',1,NULL,'Brianna Wright','FI','433836232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:36:17',0,'2014-03-02 01:10:33'),(15795,16444,'0000-00-00','ET','2',1,NULL,'Theresa Louise Pittard','FI','013527796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-24 21:00:09',0,'2014-03-02 06:03:21'),(546,546,'2014-01-01','ET','2',1,NULL,'KATHLEEN BLAIR','FI','103664110','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:53',0,'2014-03-01 15:48:04'),(21291,21941,'0000-00-00','ET','2',1,NULL,'Michael Lucero','FI','466850055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:58',0,'2014-03-02 07:23:39'),(12989,12989,'2014-01-01','ET','2',1,NULL,'Timothy Burnette','FI','298604445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:45',0,'2014-03-01 16:35:14'),(20079,20729,'0000-00-00','ET','2',1,NULL,'THOMAS AIDAN STACK','FI','635328943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-25 21:00:32',0,'2014-03-02 07:10:28'),(17176,17826,'0000-00-00','ET','2',1,NULL,'Delilah Meyers','FI','277808240','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:51',0,'2014-03-10 14:24:38'),(12795,12795,'2014-01-01','ET','2',2,1,'tricia leann armour','FI','450819541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:05',0,'2014-03-02 05:10:52'),(16993,17643,'0000-00-00','ET','2',1,NULL,'JEFF SANDIDGE','FI','274580044','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:25',0,'2014-03-10 16:24:30'),(11251,11251,'2014-01-01','ET','2',1,NULL,'TERESA ELLIOTT','FI','280682543','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:00',0,'2014-03-01 16:23:43'),(15530,15981,'0000-00-00','ET','2',1,NULL,'Gloria A Jose','FI','449885159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:04',0,'2014-03-02 05:59:43'),(3655,3655,'2014-01-01','ET','2',2,1,'Joseph Frank','FI','271544160','Summa Insurance Company, Inc.','FI','341809108','Erin  Carbone','94','8152613','348','2014-01-01','Sync Success',0,'2013-12-25 22:06:05',0,'2014-03-10 15:52:36'),(3764,3764,'2014-01-01','ET','2',1,NULL,'Leticia Campos','FI','454337531','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:09',0,'2014-03-01 23:10:52'),(20247,20897,'0000-00-00','ET','2',1,NULL,'Paul urbanski','FI','299588810','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-25 21:32:06',0,'2014-03-10 14:37:47'),(21936,22586,'0000-00-00','ET','2',2,1,'Armandina Ponce','FI','456990814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:08',0,'2014-03-05 22:27:33'),(22200,22850,'0000-00-00','ET','2',1,NULL,'walter jacobs','FI','427473855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:39',0,'2014-03-06 21:27:26'),(22902,23552,'0000-00-00','ET','2',1,NULL,'Douglas Geib','FI','290665496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:42',0,'2014-03-10 21:36:25'),(23080,23730,'0000-00-00','ET','2',1,NULL,'Susan Eaton','FI','369660017','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:02:52',0,'2014-03-10 21:17:52'),(13933,14289,'2014-01-01','ET','2',1,NULL,'Michael Yee','FI','639206794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:20',0,'2014-03-02 05:31:31'),(13077,13433,'2014-01-01','ET','2',1,NULL,'Brandon Vo','FI','433834393','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-07 04:02:03',0,'2014-03-02 05:17:40'),(20129,20779,'0000-00-00','ET','2',2,1,'Jimmie Wallace','FI','306541953','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:41',0,'2014-03-01 18:08:07'),(19767,20417,'0000-00-00','ET','2',1,NULL,'Jolanta Chura','FI','497110870','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:17',0,'2014-03-10 16:38:05'),(19495,20145,'0000-00-00','ET','2',1,NULL,'Cerra Wingo','FI','283845987','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:02:41',0,'2014-03-10 16:31:33'),(12711,12711,'2014-01-01','ET','2',1,NULL,'LEANITRA WADLEY','FI','282749622','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:10',0,'2014-03-02 05:10:52'),(16361,17011,'0000-00-00','ET','2',2,1,'David Klippel','FI','272564470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:00',0,'2014-03-10 16:24:30'),(11066,11066,'2014-01-01','ET','2',1,NULL,'Angela Watkins','FI','595262800','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:01',0,'2014-03-10 16:03:49'),(15595,16046,'0000-00-00','ET','2',1,NULL,'harold white','FI','434471177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:33',0,'2014-03-02 05:59:43'),(11039,11039,'2014-01-01','ET','2',3,2,'Viengvilay Sisouphanh','FI','296845344','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-26 13:12:07',0,'2014-03-10 16:03:49'),(3235,3235,'2014-01-01','ET','2',1,NULL,'Winfield Brown','FI','300462244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:23',0,'2014-03-01 15:52:44'),(1763,1763,'2014-01-01','ET','2',1,NULL,'carla biddle','FI','282567990','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:22',0,'2014-03-10 13:20:27'),(6178,6178,'2014-01-01','ET','2',1,NULL,'LaDonna Lambert','FI','443521467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:38',0,'2014-03-02 04:10:25'),(10656,10656,'2014-01-01','ET','2',1,NULL,'Dvir Borik','FI','630056064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:00',0,'2014-03-02 04:31:46'),(7430,7430,'2014-01-01','ET','2',2,1,'KENNETH TAYLOR','FI','437021483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:48',0,'2014-03-02 04:15:49'),(10407,10407,'2014-01-01','ET','2',1,NULL,'LINDA BUCHER','FI','302464616','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:50:56',0,'2014-03-01 16:10:36'),(20717,21367,'0000-00-00','ET','2',1,NULL,'karen  reynolds','FI','280486222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:20',0,'2014-03-01 18:08:07'),(7394,7394,'2014-01-01','ET','2',1,NULL,'Trenell Jacobs','FI','439591904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:39',0,'2014-03-02 04:15:49'),(20040,20690,'0000-00-00','ET','2',1,NULL,'zachary g poole','FI','632345867','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-22 19:00:13',0,'2014-03-02 07:03:25'),(2983,2983,'2014-01-01','ET','2',1,NULL,'Marva Mitchell','FI','465881453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:37',0,'2014-03-02 01:10:33'),(19669,20319,'0000-00-00','ET','2',2,1,'Sukhdev Cheema','FI','296153683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:48:12',0,'2014-03-01 17:47:19'),(1749,1749,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:17:57',0,'2014-03-01 15:31:33'),(4318,4318,'2014-01-01','ET','2',1,NULL,'RENATTA TAYLOR','FI','433418950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:48',0,'2014-03-02 03:09:49'),(18777,19427,'0000-00-00','ET','2',1,NULL,'Regina Frances Delaney','FI','406133915','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:50',0,'2014-03-10 14:31:05'),(18729,19379,'0000-00-00','ET','2',2,1,'gwendolyn kennedy','FI','587620848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:14',0,'2014-03-02 06:45:14'),(942,942,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:18:25',0,'2014-03-01 22:10:55'),(14835,15286,'2014-01-01','ET','2',1,NULL,'Sandra Luce','FI','268549842','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:22',0,'2014-03-10 14:03:26'),(21034,21684,'0000-00-00','ET','2',1,NULL,'Rocco Poshedley','FI','290624439','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 21:00:25',0,'2014-03-10 14:45:25'),(21849,22499,'0000-00-00','ET','2',1,NULL,'Mary Harriger','FI','295566810','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:06',0,'2014-03-05 21:36:22'),(1171,1171,'2014-01-01','ET','2',1,NULL,'Ryan Dawson-Erdman','FI','610078256','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:51',0,'2014-03-02 04:38:08'),(14984,15435,'2014-01-01','ET','2',2,1,'JOHN WILSON','FI','274520863','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:03',0,'2014-03-01 16:46:19'),(16553,17203,'0000-00-00','ET','2',1,NULL,'TERESA BERNAL','FI','635664793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:01:11',0,'2014-03-02 06:17:30'),(16525,17175,'0000-00-00','ET','2',5,4,'Syed Hassan','FI','513060073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:53',0,'2014-03-02 06:10:30'),(14743,15194,'2014-01-01','ET','2',2,1,'Edward SehChang Won','FI','270787401','Summa Insurance Company, Inc.','FI','341809108','Trond Michael Backus','94','7236224','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:22',0,'2014-03-10 16:17:47'),(5703,5703,'2014-01-01','ET','2',1,NULL,'Matthew Lynch','FI','274803902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:32',0,'2014-03-01 15:48:04'),(4467,4467,'2014-01-01','ET','2',1,NULL,'Robert Davis','FI','273903508','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:58',0,'2014-03-01 15:16:37'),(14596,15047,'2014-01-01','ET','2',2,1,'CHAKRESHWAR  SHARMA','FI','289138622','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:47',0,'2014-03-01 16:46:19'),(7438,7438,'2014-01-01','ET','2',1,NULL,'Patrick Brown','FI','438068130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:03',0,'2014-03-02 04:15:49'),(14402,14853,'2014-01-01','ET','2',1,NULL,'SAAID MANSOUR','FI','283901567','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:08',0,'2014-03-01 16:46:19'),(20858,21508,'0000-00-00','ET','2',1,NULL,'Jimmie Phillips','FI','284783362','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:25',0,'2014-03-10 14:45:25'),(13991,14347,'2014-01-01','ET','2',1,NULL,'LYDIA ANN SPADONI','FI','436828811','Starmount Life Insurance Company','FI','720977315','LAVERN  MORTON','94','4728680','348','2014-02-01','Sync Success',0,'2014-01-13 03:01:23',0,'2014-03-02 05:31:31'),(5391,5391,'2014-01-01','ET','2',1,NULL,'david  rayon','FI','294464969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:15',0,'2014-03-10 13:03:33'),(5051,5051,'2014-01-01','ET','2',2,1,'Lawrence Becker','FI','272445571','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:37',0,'2014-03-01 15:31:33'),(6121,6121,'2014-01-01','ET','2',2,1,'Robert Blocher','FI','060464731','Dental Care Plus, Inc.','FI','311185262','George  Thompson','94','1730041','348','2014-01-01','Sync Success',0,'2013-12-26 03:01:55',0,'2014-03-01 16:00:27'),(17320,17970,'0000-00-00','ET','2',1,NULL,'Jake Chustz','FI','438531933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:06',0,'2014-03-02 06:24:38'),(21948,22598,'0000-00-00','ET','2',1,NULL,'SHERIANA ROBINSON','FI','434370074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:16',0,'2014-03-05 22:27:33'),(12355,12355,'2014-01-01','ET','2',1,NULL,'rayvon hollins','FI','456158369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:28:03',0,'2014-03-02 05:03:29'),(3807,3807,'2014-01-01','ET','2',1,NULL,'LINDA MORRIS','FI','435351918','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:34',0,'2014-03-01 23:10:52'),(2662,2662,'2014-01-01','ET','2',3,2,'Gary Riesenberg','FI','283509947','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:54',0,'2014-03-01 16:05:34'),(5428,5428,'2014-01-01','ET','2',1,0,'NATHANIEL LYLES','FI','249864582','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:17',0,'2014-03-01 19:11:03'),(15515,15966,'0000-00-00','ET','2',1,NULL,'Joel Caballero','FI','461450343','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:57',0,'2014-03-02 05:59:43'),(21385,22035,'0000-00-00','ET','2',1,NULL,'Carol Burgett','FI','273583588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:00:02',0,'2014-03-03 21:36:16'),(1459,1459,'2014-01-01','ET','2',1,NULL,'Linda Stampley','FI','298504891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:56:04',0,'2014-03-01 16:15:39'),(19446,20096,'0000-00-00','ET','2',1,NULL,'Dawne Fickert','FI','279506289','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:43',0,'2014-03-10 16:31:33'),(18494,19144,'0000-00-00','ET','2',1,NULL,'brandon lee','FI','285847273','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-27','Sync Success',0,'2014-02-12 21:32:05',0,'2014-03-10 16:31:33'),(18436,19086,'0000-00-00','ET','2',1,NULL,'jerry christman','FI','605075032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:29',0,'2014-03-01 17:26:36'),(18354,19004,'0000-00-00','ET','2',1,NULL,'tammy travis','FI','434117360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:29',0,'2014-03-02 06:45:14'),(985,985,'2014-01-01','ET','2',1,NULL,'Randy Hartley','FI','268522683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:44',0,'2014-03-01 15:21:15'),(17753,18403,'0000-00-00','ET','2',1,NULL,'MORGAN  WHEELER','FI','279963788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:38',0,'2014-03-01 17:20:55'),(5410,5410,'2014-01-01','ET','2',4,3,'Ashley Trainer Smas','FI','300868807','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:37',0,'2014-03-01 15:10:22'),(14282,14733,'2014-01-01','ET','2',1,NULL,'Charles R Johnson','FI','269601906','Dental Care Plus, Inc.','FI','311185262','Mike  Groh','94','2767799','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:16',0,'2014-03-01 16:46:19'),(630,630,'2014-01-01','ET','2',1,NULL,'Lisa M Martin','FI','261958238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:37',0,'2014-03-02 02:10:49'),(3881,3881,'2014-01-01','ET','2',1,0,'Terri Nakamura','FI','164463417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:34',0,'2014-03-01 19:11:03'),(11838,11838,'2014-01-01','ET','2',4,3,'Marjoe Quijano Borromeo','FI','241156204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:19',0,'2014-03-02 04:31:46'),(11310,11310,'2014-01-01','ET','2',1,NULL,'andres morales','FI','456352291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:49',0,'2014-03-02 04:45:37'),(2330,2330,'2014-01-01','ET','2',1,0,'Gary Saunders','FI','290844488','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:17',0,'2014-03-01 15:05:09'),(2790,2790,'2014-01-01','ET','2',1,NULL,'Phay Khammachone','FI','279765052','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:03',0,'2014-03-01 16:05:34'),(2810,2810,'2014-01-01','ET','2',1,NULL,'Melanie Green','FI','299869327','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:38',0,'2014-03-01 16:05:34'),(3421,3421,'2014-01-01','ET','2',1,NULL,'Larry allen Harper','FI','273503806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:22',0,'2014-03-10 13:32:15'),(21565,22215,'0000-00-00','ET','2',1,NULL,'Maria Craft','FI','427713750','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:43',0,'2014-03-03 22:26:43'),(133,133,'2014-01-01','ET','2',1,NULL,'Elizabeth C Hooper','FI','459212171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:08',0,'2014-03-01 22:10:55'),(19493,20143,'0000-00-00','ET','2',2,1,'Elizabeth Calzada','FI','449616020','Starmount Life Insurance Company','FI','720977315','Humayun  Afzal','94','1307168','348','2014-04-01','Sync Success',0,'2014-02-20 04:01:50',0,'2014-03-02 06:59:07'),(17925,18575,'0000-00-00','ET','2',1,NULL,'Annaeli Duran','FI','643328384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:46',0,'2014-03-02 06:38:05'),(23115,23765,'0000-00-00','ET','2',1,NULL,'Sherlonda Boone','FI','458196200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:14',0,'2014-03-10 22:25:11'),(4470,4470,'2014-01-01','ET','2',1,NULL,'Roya Said','FI','632341406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:04',0,'2014-03-01 21:11:04'),(20329,20979,'0000-00-00','ET','2',1,NULL,'TARA V HERNANDEZ','FI','631266003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:18',0,'2014-03-02 07:03:25'),(6253,6253,'2014-01-01','ET','2',1,NULL,'Ernest Ojong','FI','662221208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:01',0,'2014-03-02 04:10:25'),(10633,10633,'2014-01-01','ET','2',1,NULL,'Boris Mileykovskiy','FI','625089834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:16',0,'2014-03-02 04:31:46'),(16002,16651,'0000-00-00','ET','2',1,NULL,'JUAN MIGUEL LOPEZ-LARA','FI','457978619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:12',0,'2014-03-02 06:03:21'),(182,182,'2014-01-01','ET','2',1,NULL,'Sarah Hanson','FI','434617857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:38',0,'2014-03-01 22:10:55'),(19728,20378,'0000-00-00','ET','2',2,1,'Scott Johnson','FI','590481299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:35:52',0,'2014-03-01 17:47:19'),(5423,5423,'2014-01-01','ET','2',1,NULL,'david gordy','FI','439639516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:04',0,'2014-03-01 20:10:57'),(17393,18043,'0000-00-00','ET','2',2,1,'ronald shaffer','FI','276769002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:37',0,'2014-03-01 17:20:55'),(15462,15913,'0000-00-00','ET','2',1,NULL,'ROBERT BROYLES','FI','299709789','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:50',0,'2014-03-01 16:50:53'),(203,203,'2014-01-01','ET','2',1,NULL,'clifford hallett','FI','299504372','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:20',0,'2014-03-10 13:10:24'),(5270,5270,'2014-01-01','ET','2',1,NULL,'Jason Alan Morrow','FI','466833201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:20',0,'2014-03-01 19:11:03'),(19426,20076,'0000-00-00','ET','2',1,NULL,'SIDNEY M TILLIS','FI','427762519','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:28',0,'2014-03-02 06:59:07'),(17134,17784,'0000-00-00','ET','2',1,NULL,'George  J Mcgee','FI','335847302','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:22',0,'2014-03-02 06:24:38'),(16233,16882,'0000-00-00','ET','2',1,NULL,'tina breisinger','FI','300666690','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:01',0,'2014-03-10 14:20:26'),(1317,1317,'2014-01-01','ET','2',1,NULL,'Maria Rodriguez','FI','459927696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:21',0,'2014-03-02 04:38:08'),(12897,12897,'2014-01-01','ET','2',1,NULL,'Yvonne Campbell','FI','403883142','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:47',0,'2014-03-10 13:59:38'),(15179,15630,'0000-00-00','ET','2',1,NULL,'MICHAEL BURRELL','FI','587151418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:12',0,'2014-03-02 05:52:31'),(15085,15536,'0000-00-00','ET','2',1,NULL,'amika letcher','FI','275860387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:38',0,'2014-03-01 16:50:53'),(22075,22725,'0000-00-00','ET','2',1,NULL,'MARTHA MIRANDA','FI','560973246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:10',0,'2014-03-06 21:27:26'),(3799,3799,'2014-01-01','ET','2',2,1,'Michael A Chebra','FI','282482525','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:16',0,'2014-03-10 15:45:56'),(18916,19566,'0000-00-00','ET','2',1,NULL,'ALYCE NEFF','FI','217529310','Dental Care Plus, Inc.','FI','311185262','MICHAEL   DAUGHERTY','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:14',0,'2014-03-01 17:34:07'),(5404,5404,'2014-01-01','ET','2',2,1,'Ronald Jennings','FI','285624477','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:21',0,'2014-03-10 15:39:19'),(17806,18456,'0000-00-00','ET','2',1,NULL,'NATHANIEL PURDIE JUNIOR','FI','284522026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:39',0,'2014-03-01 16:56:22'),(4558,4558,'2014-01-01','ET','2',1,NULL,'Jo Minor','FI','263610877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:58',0,'2014-03-02 04:38:08'),(17089,17739,'0000-00-00','ET','2',2,1,'Michelle Vega','FI','370068328','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:53',0,'2014-03-01 17:00:58'),(15271,15722,'0000-00-00','ET','2',1,NULL,'Candy Beth Clary','FI','465711561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:01',0,'2014-03-02 05:52:31'),(15147,15598,'0000-00-00','ET','2',1,NULL,'TENA DEVEREUX','FI','414940712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:25',0,'2014-03-02 05:52:31'),(7036,7036,'2014-01-01','ET','2',2,1,'AMIR AQEEL','FI','311064169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:38',0,'2014-03-02 03:09:49'),(11519,11519,'2014-01-01','ET','2',1,NULL,'Jessica Brown','FI','435818051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:13',0,'2014-03-02 04:52:44'),(11186,11186,'2014-01-01','ET','2',1,NULL,'Scott A Miley','FI','276568927','HealthSpan','FI','311431434','Frank  Jarome','94','16102908','348','2014-01-01','Sync Success',0,'2013-12-26 13:17:11',0,'2014-03-10 13:45:57'),(7559,7559,'2014-01-01','ET','2',3,2,'Adam Hayden','FI','305026306','Dental Care Plus, Inc.','FI','311185262','Peggy  Yates','94','1877824','348','2014-01-01','Sync Success',0,'2013-12-26 04:35:56',0,'2014-03-01 16:05:34'),(19894,20544,'0000-00-00','ET','2',1,NULL,'Carlos R Garcia Diaz','FI','262857992','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:41',0,'2014-03-10 14:37:47'),(4384,4384,'2014-01-01','ET','2',1,NULL,'Bryan Blount','FI','254067497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:29',0,'2014-03-01 15:16:37'),(3809,3809,'2014-01-01','ET','2',1,NULL,'Bettyann Virginia Kaiser','FI','275660036','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:38',0,'2014-03-10 13:10:24'),(7755,7755,'2014-01-01','ET','2',1,NULL,'Alfredo III Obregon','FI','463877498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:03',0,'2014-03-01 19:11:03'),(18360,19010,'0000-00-00','ET','2',1,NULL,'CLARA M WILLIAMS','FI','449234941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:33',0,'2014-03-02 06:45:14'),(18155,18805,'0000-00-00','ET','2',1,NULL,'Gia Imbornone','FI','435657828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:19',0,'2014-03-02 06:38:05'),(17560,18210,'0000-00-00','ET','2',1,NULL,'WEIQING LU','FI','115942453','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:41',0,'2014-03-02 06:31:45'),(12167,12167,'2014-01-01','ET','2',1,NULL,'Jonathan Clark','FI','435458422','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:01',0,'2014-03-02 04:59:36'),(12971,12971,'2014-01-01','ET','2',1,NULL,'Ashley Hymel','FI','589463892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-05 00:01:08',0,'2014-03-02 05:17:40'),(865,865,'2014-01-01','ET','2',1,NULL,'wilma jones','FI','455313746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:10',0,'2014-03-01 22:10:55'),(21012,21662,'0000-00-00','ET','2',1,NULL,'Tress Turner','FI','439378400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:09',0,'2014-03-02 07:23:39'),(20117,20767,'0000-00-00','ET','2',1,NULL,'Patricia Brazelton','FI','295689067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-25 21:30:32',0,'2014-03-01 18:08:07'),(19386,20036,'0000-00-00','ET','2',2,1,'Kelley  Miller','FI','280887013','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:57',0,'2014-03-01 17:34:07'),(19118,19768,'0000-00-00','ET','2',1,NULL,'Joyce L Hillman','FI','330501740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:57',0,'2014-03-01 17:34:07'),(11485,11485,'2014-01-01','ET','2',1,NULL,'River Manda Lay','FI','297139371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:31:13',0,'2014-03-01 16:30:17'),(18186,18836,'0000-00-00','ET','2',1,NULL,'Maura Garin','FI','274583727','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:42',0,'2014-03-01 17:26:36'),(7595,7595,'2014-01-01','ET','2',1,NULL,'James Hanly','FI','437061524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:09',0,'2014-03-02 04:15:49'),(12909,12909,'2014-01-01','ET','2',1,NULL,'Sherita Narcisse','FI','433496549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:14',0,'2014-03-02 05:10:52'),(6137,6137,'2014-01-01','ET','2',1,NULL,'MERLE HENDERSON','FI','277569525','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:26',0,'2014-03-01 16:00:27'),(21654,22304,'0000-00-00','ET','2',1,NULL,'Kimberly Hansen','FI','190545343','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:01',0,'2014-03-04 21:36:30'),(11125,11125,'2014-01-01','ET','2',4,3,'Charles Foy','FI','273845622','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:59',0,'2014-03-10 13:45:57'),(4349,4349,'2014-01-01','ET','2',1,NULL,'LYDIA KAREN ALLEN','FI','271529927','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:45',0,'2014-03-10 13:32:15'),(16047,16696,'0000-00-00','ET','2',2,1,'david jusko','FI','292667821','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:41',0,'2014-03-01 16:56:22'),(19782,20432,'0000-00-00','ET','2',1,NULL,'Kim Anthony Kilchrist','FI','434047085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:08',0,'2014-03-02 06:59:07'),(16050,16699,'0000-00-00','ET','2',1,NULL,'Tammy Bobbitt','FI','299641328','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:43',0,'2014-03-01 16:56:22'),(17064,17714,'0000-00-00','ET','2',1,NULL,'Robert Kegel','FI','456060285','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:37',0,'2014-03-02 06:24:38'),(22162,22812,'0000-00-00','ET','2',1,NULL,'Oliver Rampello','FI','273907054','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:12',0,'2014-03-06 21:36:23'),(620,620,'2014-01-01','ET','2',2,1,'Mark Leslie Tappan','FI','480569174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:16',0,'2014-03-02 02:10:49'),(20870,21520,'0000-00-00','ET','2',1,NULL,'Luis Rivera','FI','466936509','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:31',0,'2014-03-02 07:17:36'),(7530,7530,'2014-01-01','ET','2',1,NULL,'Marcia Miller','FI','315724956','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:01',0,'2014-03-01 16:05:34'),(19793,20443,'0000-00-00','ET','2',1,NULL,'Michael Ladell Conley','FI','435635870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:17',0,'2014-03-02 07:03:25'),(19132,19782,'0000-00-00','ET','2',1,NULL,'Amber Marquardt','FI','292803985','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:07',0,'2014-03-01 17:34:07'),(17532,18182,'0000-00-00','ET','2',1,NULL,'Penny Wood','FI','280607284','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:22',0,'2014-03-01 17:20:55'),(4206,4206,'2014-01-01','ET','2',1,NULL,'CELESTE ANN JACKSON','FI','410452550','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:25',0,'2014-03-02 03:09:49'),(3946,3946,'2014-01-01','ET','2',1,NULL,'Jose Resendis','FI','637097540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:24',0,'2014-03-01 23:10:52'),(15855,16504,'0000-00-00','ET','2',1,NULL,'Patricia Frey','FI','285705762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:43',0,'2014-03-01 16:56:22'),(845,845,'2014-01-01','ET','2',1,NULL,'celia saldana','FI','458136129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:30',0,'2014-03-01 22:10:55'),(22836,23486,'0000-00-00','ET','2',1,NULL,'Jann Vasbinder','FI','290064903','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:30:00',0,'2014-03-09 21:35:27'),(22983,23633,'0000-00-00','ET','2',1,NULL,'MINA SOHRABI','FI','294864401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:39',0,'2014-03-10 21:36:25'),(231,231,'2014-01-01','ET','2',1,0,'Susan Eaton','FI','369660017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:16',0,'2014-03-10 13:03:33'),(7374,7374,'2014-01-01','ET','2',1,NULL,'Jamie Fall','FI','278764864','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:23',0,'2014-03-10 13:03:33'),(19981,20631,'0000-00-00','ET','2',1,NULL,'James Barbee','FI','225024008','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:39',0,'2014-03-02 07:03:25'),(4982,4982,'2014-01-01','ET','2',1,NULL,'Brandon Allen','FI','272920366','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:45:24',0,'2014-03-01 15:31:33'),(2061,2061,'2014-01-01','ET','2',2,1,'James Rickey','FI','269500172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:48',0,'2014-03-10 13:20:27'),(2418,2418,'2014-01-01','ET','2',1,NULL,'robert l miller','FI','160448709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:50',0,'2014-03-10 15:45:56'),(15012,15463,'2014-01-01','ET','2',1,NULL,'ANNE ST JOHN KODISH','FI','288548296','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:15',0,'2014-03-10 16:17:47'),(916,916,'2014-01-01','ET','2',1,NULL,'mike larr','FI','279702009','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:33',0,'2014-03-01 15:21:15'),(19778,20428,'0000-00-00','ET','2',1,NULL,'Darlene Piper','FI','342686037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:04',0,'2014-03-02 06:59:07'),(19656,20306,'0000-00-00','ET','2',1,NULL,'Carlye Parks','FI','268961058','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:45:00',0,'2014-03-01 17:47:19'),(2215,2215,'2014-01-01','ET','2',1,NULL,'DEBORAH FRAUNFELTER','FI','268682769','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:39',0,'2014-03-10 13:10:24'),(11622,11622,'2014-01-01','ET','2',1,NULL,'Michael Soto','FI','293689381','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-28 03:35:26',0,'2014-03-10 13:52:32'),(16942,17592,'0000-00-00','ET','2',1,NULL,'Darrell Mims','FI','438814400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:53',0,'2014-03-02 06:17:30'),(6460,6460,'2014-01-01','ET','2',1,NULL,'LAURIE STEINER','FI','299528161','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:28',0,'2014-03-10 13:03:33'),(21626,22276,'0000-00-00','ET','2',1,NULL,'Gloria Trujillo','FI','449066870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:40',0,'2014-03-04 21:27:16'),(2681,2681,'2014-01-01','ET','2',2,1,'Judy Kazuko Samudio','FI','418065675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:35',0,'2014-03-02 04:15:49'),(2953,2953,'2014-01-01','ET','2',2,1,'GREGORY JOSEPH GOODMAN','FI','279680232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:40',0,'2014-03-01 15:37:30'),(3612,3612,'2014-01-01','ET','2',1,NULL,'Teresa Lynn Canterbury','FI','274708367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:04:44',0,'2014-03-10 15:52:36'),(17816,18466,'0000-00-00','ET','2',1,NULL,'Johnnie Lacen','FI','433470705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:48',0,'2014-03-02 06:10:30'),(13193,13549,'2014-01-01','ET','2',1,NULL,'KATHLEEN  CORNE','FI','378544819','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:25',0,'2014-03-10 13:59:38'),(13633,13989,'2014-01-01','ET','2',1,NULL,'Donna Ancar','FI','434969792','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:49',0,'2014-03-02 05:31:31'),(14214,14665,'2014-01-01','ET','2',1,NULL,'James Woods','FI','298748216','HealthSpan','FI','311431434','Rale  Markovic','94','2775844','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:49',0,'2014-03-10 14:03:26'),(1144,1144,'2014-01-01','ET','2',1,NULL,'Bradford Noel','FI','434571613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:02',0,'2014-03-02 04:38:08'),(5414,5414,'2014-01-01','ET','2',1,NULL,'Amy Cole','FI','294762211','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:47',0,'2014-03-01 15:10:22'),(20908,21558,'0000-00-00','ET','2',1,NULL,'Yeo San Yi','FI','273764866','HealthSpan','FI','311431434','Gregory B Burch','94','2776783','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:49',0,'2014-03-10 14:45:25'),(2429,2429,'2014-01-01','ET','2',1,NULL,'GARY E LEONARD','FI','273609702','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:09',0,'2014-03-10 15:45:56'),(18267,18917,'0000-00-00','ET','2',1,NULL,'Kaitlin Hemmer','FI','298947889','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-11 21:02:51',0,'2014-03-10 14:24:38'),(17317,17967,'0000-00-00','ET','2',1,NULL,'Rita R Brenckle','FI','438117765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:04',0,'2014-03-02 06:24:38'),(6099,6099,'2014-01-01','ET','2',2,1,'Katie Cantrell','FI','428651209','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:18',0,'2014-03-01 16:00:27'),(15280,15731,'0000-00-00','ET','2',1,NULL,'Jude Katt','FI','437213106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:07',0,'2014-03-02 05:52:31'),(22928,23578,'0000-00-00','ET','2',1,NULL,'Margaret Landrum','FI','438171794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:01',0,'2014-03-10 21:27:11'),(1240,1240,'2014-01-01','ET','2',1,NULL,'Carolynda Dortch','FI','270503655','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:55',0,'2014-03-01 16:15:39'),(13012,13012,'2014-01-01','ET','2',4,3,'Robert m Bonenfant','FI','047561043','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:36',0,'2014-03-01 16:35:14'),(19014,19664,'0000-00-00','ET','2',1,NULL,'Roger Markley','FI','279645494','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:25',0,'2014-03-10 14:31:05'),(12594,12594,'2014-01-01','ET','2',1,NULL,'TONI LEWELLEN','FI','432519065','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:53',0,'2014-03-02 05:10:52'),(18280,18930,'0000-00-00','ET','2',1,NULL,'Danielle Niccole Moss','FI','282845684','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:10',0,'2014-03-01 17:26:36'),(11889,11889,'2014-01-01','ET','2',1,NULL,'Alexander Fleming','FI','428475532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:40',0,'2014-03-02 04:59:36'),(17760,18410,'0000-00-00','ET','2',1,NULL,'Tiffany Stiltner','FI','302861444','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:43',0,'2014-03-10 14:24:38'),(17757,18407,'0000-00-00','ET','2',2,1,'Patti Bihn','FI','302648052','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:41',0,'2014-03-10 14:24:38'),(3632,3632,'2014-01-01','ET','2',1,NULL,'E Hall','FI','299525687','Summa Insurance Company, Inc.','FI','341809108','Deanna M Cipriano','94','8479624','348','2014-01-01','Sync Success',0,'2013-12-25 22:05:21',0,'2014-03-10 15:52:36'),(3205,3205,'2014-01-01','ET','2',1,NULL,'CHARLENE  D FENNMORE','FI','312602119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:26',0,'2014-03-01 15:48:04'),(16757,17407,'0000-00-00','ET','2',1,NULL,'Michael Martinez','FI','628079877','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:14',0,'2014-03-02 06:17:30'),(14599,15050,'2014-01-01','ET','2',1,NULL,'Linda Mazur','FI','280468342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:49',0,'2014-03-01 16:46:19'),(19330,19980,'0000-00-00','ET','2',1,NULL,'CYTHIA P CARRILLO','FI','636421896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:19',0,'2014-03-02 06:59:07'),(10620,10620,'2014-01-01','ET','2',1,NULL,'Abelardo Garza','FI','467801130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:50',0,'2014-03-02 04:24:47'),(17000,17650,'0000-00-00','ET','2',1,NULL,'Julie Keener','FI','301802522','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:30',0,'2014-03-10 16:24:30'),(5845,5845,'2014-01-01','ET','2',4,3,'Christopher Cameron','FI','299769943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:56',0,'2014-03-01 15:10:22'),(5601,5601,'2014-01-01','ET','2',1,NULL,'Diane DAlbenzio','FI','268500110','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:41',0,'2014-03-01 16:23:43'),(618,618,'2014-01-01','ET','2',1,NULL,'Patrick Joseph Harrington','FI','506021243','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:11',0,'2014-03-02 02:10:49'),(4870,4870,'2014-01-01','ET','2',1,NULL,'Devin McGinnis','FI','366063150','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:15',0,'2014-03-01 15:10:22'),(4042,4042,'2014-01-01','ET','2',2,1,'ELVIN DUDLEY','FI','459552025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:25',0,'2014-03-02 03:09:49'),(2845,2845,'2014-01-01','ET','2',1,NULL,'Grant Dickey','FI','454799970','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:51',0,'2014-03-02 04:15:49'),(18922,19572,'0000-00-00','ET','2',1,NULL,'Tiffany Wiggins','FI','587492639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:18',0,'2014-03-02 06:52:12'),(16603,17253,'0000-00-00','ET','2',1,NULL,'Terry Potts','FI','452860932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:09',0,'2014-03-02 06:17:30'),(16453,17103,'0000-00-00','ET','2',2,1,'Tien Le','FI','289924402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:08',0,'2014-03-01 17:00:58'),(14085,14536,'2014-01-01','ET','2',1,NULL,'GLANDA ALLEN','FI','456786204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:26',0,'2014-03-02 05:38:34'),(10977,10977,'2014-01-01','ET','2',1,NULL,'Angela Kelly','FI','426490645','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:58',0,'2014-03-02 04:24:47'),(15631,16082,'0000-00-00','ET','2',1,NULL,'MONIKA COLLINS','FI','297500532','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:51',0,'2014-03-10 16:17:47'),(3691,3691,'2014-01-01','ET','2',2,1,'George Caraway','FI','436983679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:13',0,'2014-03-02 00:10:48'),(3865,3865,'2014-01-01','ET','2',1,0,'Anthony Slowik','FI','453559871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 22:31:05',0,'2014-03-01 19:11:03'),(6210,6210,'2014-01-01','ET','2',1,NULL,'KATHI R JOHNSON','FI','278605483','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:38',0,'2014-03-01 16:00:27'),(4557,4557,'2014-01-01','ET','2',1,NULL,'GAIL MATTHEWS','FI','439119581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:56',0,'2014-03-02 04:31:46'),(20051,20701,'0000-00-00','ET','2',1,NULL,'annette goldberg','FI','457884833','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:12',0,'2014-03-02 07:10:28'),(21224,21874,'0000-00-00','ET','2',1,NULL,'Carter Martyn Newey','FI','646093141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:12',0,'2014-03-02 07:23:39'),(392,392,'2014-01-01','ET','2',1,NULL,'Paul Weiss','FI','206487038','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:07',0,'2014-03-01 22:10:55'),(14160,14611,'2014-01-01','ET','2',4,3,'Jason Brown','FI','274602109','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:13',0,'2014-03-10 16:17:47'),(13452,13808,'2014-01-01','ET','2',2,1,'Dawn Beltran','FI','453259364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:20',0,'2014-03-02 05:31:31'),(17400,18050,'0000-00-00','ET','2',1,NULL,'Jeremy Roberts','FI','408291495','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:42',0,'2014-03-01 17:20:55'),(15110,15561,'0000-00-00','ET','2',1,NULL,'Kara Jones','FI','455978045','Starmount Life Insurance Company','FI','720977315','Jesse  Mojica','94','1103701','348','2014-03-01','Sync Success',0,'2014-01-20 08:05:56',0,'2014-03-02 05:52:31'),(12287,12287,'2014-01-01','ET','2',1,NULL,'Taurean David Dixon','FI','300883072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:47',0,'2014-03-01 16:35:14'),(7147,7147,'2014-01-01','ET','2',1,NULL,'Amy Hanna','FI','295844922','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:05:01',0,'2014-03-10 15:59:47'),(20209,20859,'0000-00-00','ET','2',1,NULL,'Jazmin Grant','FI','591883757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:38',0,'2014-03-02 07:10:28'),(554,554,'2014-01-01','ET','2',1,NULL,'Kyle Brown','FI','287922675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:09',0,'2014-03-01 15:48:04'),(12584,12584,'2014-01-01','ET','2',1,NULL,'Michele Irene Sommer','FI','275524795','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-03 02:00:33',0,'2014-03-01 16:35:14'),(4827,4827,'2014-01-01','ET','2',1,NULL,'Veronica Woods','FI','285548162','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:42',0,'2014-03-10 13:03:33'),(6197,6197,'2014-01-01','ET','2',2,1,'KATHY CONNER','FI','217880029','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:14',0,'2014-03-02 04:10:25'),(919,919,'2014-01-01','ET','2',1,NULL,'Dee Staten','FI','282766597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:39',0,'2014-03-01 15:21:15'),(21345,21995,'0000-00-00','ET','2',1,NULL,'Vanessa Shoffner','FI','280840114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:20',0,'2014-03-03 01:35:37'),(21726,22376,'0000-00-00','ET','2',1,NULL,'Michael Ress','FI','277563694','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:00',0,'2014-03-10 14:45:25'),(22497,23147,'0000-00-00','ET','2',2,1,'JESSICA JONES','FI','286840549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:07',0,'2014-03-07 21:36:32'),(1105,1105,'2014-01-01','ET','2',1,NULL,'Harold Bashor','FI','268485568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:13',0,'2014-03-01 15:05:09'),(19845,20495,'0000-00-00','ET','2',2,1,'MC PHAM','FI','479271409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:59',0,'2014-03-02 07:03:25'),(18804,19454,'0000-00-00','ET','2',1,NULL,'JAMIE LUCAS','FI','275823087','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:11',0,'2014-03-10 14:31:05'),(13544,13900,'2014-01-01','ET','2',1,NULL,'shondrica Dejoie','FI','435417868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:45',0,'2014-03-02 05:24:45'),(5590,5590,'2014-01-01','ET','2',1,NULL,'ryan james aivalis','FI','433814572','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:21',0,'2014-03-02 04:45:37'),(10561,10561,'2014-01-01','ET','2',1,NULL,'Christopher Duncan','FI','092681822','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:55',0,'2014-03-02 04:24:47'),(5177,5177,'2014-01-01','ET','2',1,NULL,'Dolores Robles','FI','454896337','Starmount Life Insurance Company','FI','720977315','Nicole  Winston','94','802154','348','2014-01-01','Sync Success',0,'2013-12-26 00:51:37',0,'2014-03-02 00:10:48'),(4261,4261,'2014-01-01','ET','2',1,NULL,'eddie hilliard','FI','433250112','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:09',0,'2014-03-02 03:09:49'),(1639,1639,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:02:10',0,'2014-03-01 20:10:57'),(7250,7250,'2014-01-01','ET','2',2,1,'Denise Ferguson','FI','186648535','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:13',0,'2014-03-10 15:59:47'),(20359,21009,'0000-00-00','ET','2',1,NULL,'Brian Stenger','FI','298806240','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:45',0,'2014-03-10 16:38:05'),(22058,22708,'0000-00-00','ET','2',1,NULL,'MARK FAY','FI','271525165','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:34',0,'2014-03-10 14:45:25'),(22333,22983,'0000-00-00','ET','2',1,NULL,'ibrahim habli','94','0000971518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Received',0,'2014-03-06 21:30:21',NULL,NULL),(997,997,'2014-01-01','ET','2',1,NULL,'Judith Hoy','FI','587761299','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:10',0,'2014-03-10 13:10:24'),(12613,12613,'2014-01-01','ET','2',1,NULL,'donna colman','FI','463960971','Starmount Life Insurance Company','FI','720977315','tereasa  cassidy','94','7025835','348','2014-02-01','Sync Success',0,'2014-01-03 02:01:33',0,'2014-03-02 05:10:52'),(19479,20129,'0000-00-00','ET','2',1,NULL,'ROSA M MARIA','FI','456994480','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:57:15',0,'2014-03-02 06:59:07'),(11194,11194,'2014-01-01','ET','2',1,NULL,'Amanda Cooper','FI','298807513','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:00:15',0,'2014-03-01 16:23:43'),(4403,4403,'2014-01-01','ET','2',1,NULL,'ROBERT GIBSON','FI','291486885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:02',0,'2014-03-10 13:03:33'),(5622,5622,'2014-01-01','ET','2',1,NULL,'PEARLEAN HARRIS','FI','281706946','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:27',0,'2014-03-10 16:03:49'),(21878,22528,'0000-00-00','ET','2',1,NULL,'KIMBERLY SHANNON','FI','294585222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:26',0,'2014-03-05 21:36:22'),(22416,23066,'0000-00-00','ET','2',3,2,'Jayna E Denbow','FI','631178733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:10',0,'2014-03-07 22:26:59'),(1891,1891,'2014-01-01','ET','2',1,NULL,'john scott slaughter','FI','457848368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:30',0,'2014-03-01 23:10:52'),(19774,20424,'0000-00-00','ET','2',1,NULL,'GLENDA TAYLOR','FI','587542507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:23',0,'2014-03-02 07:03:25'),(13698,14054,'2014-01-01','ET','2',2,1,'LORI LEE WAINSCOTT','FI','272662425','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:39',0,'2014-03-01 16:40:16'),(11315,11315,'2014-01-01','ET','2',1,NULL,'Molly Killen','FI','450915999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:03:58',0,'2014-03-02 04:52:44'),(7400,7400,'2014-01-01','ET','2',1,NULL,'KILWANNA M ROSE','FI','436455062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:53',0,'2014-03-02 04:10:25'),(4925,4925,'2014-01-01','ET','2',2,1,'Jose Daniel Arreaga','FI','644487316','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:58',0,'2014-03-01 19:11:03'),(5864,5864,'2014-01-01','ET','2',1,NULL,'TERRI SMITH','FI','457431305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:41',0,'2014-03-01 19:11:03'),(5782,5782,'2014-01-01','ET','2',1,NULL,'MATTHEW MILLIKIN','FI','302865500','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:00',0,'2014-03-10 15:52:36'),(2227,2227,'2014-01-01','ET','2',2,1,'Stewart Lean','FI','218521217','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:05',0,'2014-03-10 13:10:24'),(2706,2706,'2014-01-01','ET','2',2,1,'Kenneth Reeise','FI','512946799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:23',0,'2014-03-02 04:15:49'),(5552,5552,'2014-01-01','ET','2',1,NULL,'Reba DeCamp','FI','466295414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:07',0,'2014-03-02 04:45:37'),(5354,5354,'2014-01-01','ET','2',1,NULL,'Linda Forbess','FI','295427062','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:00',0,'2014-03-10 13:03:33'),(23067,23717,'0000-00-00','ET','2',1,NULL,'Timothy Edward Bates','FI','298720144','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:41',0,'2014-03-10 21:17:52'),(217,217,'2014-01-01','ET','2',2,1,'robert sabel','FI','275608273','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:52',0,'2014-03-10 13:10:24'),(11224,11224,'2014-01-01','ET','2',1,NULL,'randy archer','FI','302420646','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:01:11',0,'2014-03-01 16:23:43'),(18811,19461,'0000-00-00','ET','2',5,4,'Anne Schmidt','FI','298620193','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:16',0,'2014-03-10 14:31:05'),(18489,19139,'0000-00-00','ET','2',1,NULL,'Jennifer Lenahan','FI','268869914','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:32:02',0,'2014-03-10 16:31:33'),(10713,10713,'2014-01-01','ET','2',1,NULL,'Britt Hall','FI','292903249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:59',0,'2014-03-01 16:10:36'),(17498,18148,'0000-00-00','ET','2',1,NULL,'carol fowee','FI','295625891','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:53',0,'2014-03-10 14:24:38'),(16613,17263,'0000-00-00','ET','2',1,NULL,'Susan  Ball','FI','465418561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:15',0,'2014-03-02 06:17:30'),(10560,10560,'2014-01-01','ET','2',1,NULL,'Neal Duncan','FI','602098702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:52',0,'2014-03-02 04:24:47'),(2657,2657,'2014-01-01','ET','2',5,4,'Cheryl Murphy','FI','319647554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:38',0,'2014-03-01 16:05:34'),(1413,1413,'2014-01-01','ET','2',4,3,'Canchu Lin','FI','442110556','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:28',0,'2014-03-10 13:45:57'),(21161,21811,'0000-00-00','ET','2',1,NULL,'Helaine Wright','FI','437276775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:28',0,'2014-03-02 07:23:39'),(21602,22252,'0000-00-00','ET','2',1,NULL,'Rodolfo H Cantu','FI','452397032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:21',0,'2014-03-04 21:27:16'),(14510,14961,'2014-01-01','ET','2',2,1,'Brian S Taylor','FI','287427721','HealthSpan','FI','311431434','Rob  Ziker','94','1005990','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:57',0,'2014-03-10 14:03:26'),(13764,14120,'2014-01-01','ET','2',1,NULL,'GARY WILSON','FI','288508340','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:23',0,'2014-03-10 16:10:34'),(11615,11615,'2014-01-01','ET','2',1,NULL,'JUDITH VAGO','FI','286505328','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:12',0,'2014-03-10 16:03:49'),(10930,10930,'2014-01-01','ET','2',1,NULL,'Paul Markle','FI','289707682','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:38',0,'2014-03-10 16:03:49'),(16983,17633,'0000-00-00','ET','2',1,NULL,'Mark Bonvenuto','FI','195442207','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:18',0,'2014-03-10 16:24:30'),(16127,16776,'0000-00-00','ET','2',1,NULL,'Minnie Ervine','FI','224881193','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:38',0,'2014-03-10 16:24:30'),(1650,1650,'2014-01-01','ET','2',1,NULL,'Celeste Martin','FI','458917409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:29',0,'2014-03-01 20:10:57'),(6105,6105,'2014-01-01','ET','2',1,NULL,'Christopher Alvarado','FI','457210858','Dental Care Plus, Inc.','FI','311185262','Gregory  Myers','94','9074445','348','2014-01-01','Sync Success',0,'2013-12-26 03:01:29',0,'2014-03-01 16:00:27'),(1887,1887,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:31:25',0,'2014-03-01 23:10:52'),(2111,2111,'2014-01-01','ET','2',1,NULL,'Wesley Sizemore','FI','285820948','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:17',0,'2014-03-01 15:16:37'),(4095,4095,'2014-01-01','ET','2',1,NULL,'Jennifer Martin','FI','592280204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:08',0,'2014-03-01 16:00:27'),(3309,3309,'2014-01-01','ET','2',1,NULL,'Kenneth E Grubb','FI','296564017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:47',0,'2014-03-01 15:52:44'),(21570,22220,'0000-00-00','ET','2',1,NULL,'tara jewell','FI','595521558','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:47',0,'2014-03-10 14:45:25'),(153,153,'2014-01-01','ET','2',1,NULL,'FRANK BELACIC','FI','291466243','Summa Insurance Company, Inc.','FI','341809108','GREGORY JAMES CAUSMAN','94','519763','348','2014-01-01','Sync Success',0,'2013-12-25 17:19:45',0,'2014-03-10 15:45:56'),(20152,20802,'0000-00-00','ET','2',1,NULL,'Rhonda Prentiss','FI','280848054','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:56',0,'2014-03-10 16:38:05'),(13805,14161,'2014-01-01','ET','2',1,NULL,'LEAH POPOLIZIO','FI','073764455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:12',0,'2014-03-01 16:40:16'),(12234,12234,'2014-01-01','ET','2',2,1,'Edward Scott','FI','338809040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:47',0,'2014-03-02 05:03:29'),(1177,1177,'2014-01-01','ET','2',1,NULL,'Milton Henton','FI','424964903','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:03',0,'2014-03-02 04:38:08'),(22910,23560,'0000-00-00','ET','2',1,NULL,'Dejunna Holloway','FI','435291767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:48',0,'2014-03-10 21:27:11'),(77,77,'2014-01-01','ET','2',1,NULL,'Rick Kincaid','FI','638055265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:21',0,'2014-03-01 22:10:55'),(20065,20715,'0000-00-00','ET','2',3,2,'ERICK VON AHN','FI','063443241','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-25 21:00:22',0,'2014-03-10 16:38:05'),(19781,20431,'0000-00-00','ET','2',2,1,'DANIEL S HABANEK','FI','399789818','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:07',0,'2014-03-02 07:03:25'),(18830,19480,'0000-00-00','ET','2',1,NULL,'Brenda Rodriguez','FI','638163775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:12',0,'2014-03-02 06:52:12'),(17922,18572,'0000-00-00','ET','2',1,NULL,'Tiffany Tran','FI','068767264','Starmount Life Insurance Company','FI','720977315','Lienmai T Truong','94','1584551','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:44',0,'2014-03-02 06:38:05'),(11669,11669,'2014-01-01','ET','2',1,NULL,'JACCOB PAYNE','FI','273960939','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:54',0,'2014-03-10 13:52:32'),(16962,17612,'0000-00-00','ET','2',1,NULL,'MARK EDWARD SMITH','FI','277683832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:06',0,'2014-03-10 14:20:26'),(16926,17576,'0000-00-00','ET','2',2,1,'Angie Broughton','FI','286725438','Dental Care Plus, Inc.','FI','311185262','John  Scheller','94','16414709','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:42',0,'2014-03-01 17:00:58'),(15728,16377,'0000-00-00','ET','2',1,NULL,'Rudy Smith','FI','434185898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:08',0,'2014-03-02 05:59:43'),(4984,4984,'2014-01-01','ET','2',1,NULL,'Jerry Grossman','FI','271905762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:27',0,'2014-03-01 15:31:33'),(7084,7084,'2014-01-01','ET','2',1,NULL,'Thomas Mole','FI','083706757','Dental Care Plus, Inc.','FI','311185262','Benjamin   Katz','94','8986790','348','2014-01-01','Sync Success',0,'2013-12-26 04:03:09',0,'2014-03-01 15:52:44'),(5741,5741,'2014-01-01','ET','2',2,1,'Sharon Webster','FI','439961234','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:39',0,'2014-03-02 01:10:33'),(13366,13722,'2014-01-01','ET','2',1,NULL,'Martha Barranco','FI','463431180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:38',0,'2014-03-02 05:24:45'),(12008,12008,'2014-01-01','ET','2',1,NULL,'lannie williams','FI','439080921','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:23',0,'2014-03-02 04:59:36'),(4382,4382,'2014-01-01','ET','2',1,NULL,'Christina Barker','FI','270986497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:25',0,'2014-03-01 15:16:37'),(10985,10985,'2014-01-01','ET','2',2,1,'DENNIS DAQUIN','FI','427236315','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:15',0,'2014-03-02 04:24:47'),(21474,22124,'0000-00-00','ET','2',1,NULL,'patrick finnell','FI','293640929','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-03 21:30:37',0,'2014-03-03 21:36:16'),(716,716,'2014-01-01','ET','2',1,NULL,'amber heaps','FI','286947603','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:17',0,'2014-03-10 13:24:34'),(17042,17692,'0000-00-00','ET','2',1,NULL,'Sheila Rae Epley','FI','278543491','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:25',0,'2014-03-10 16:24:30'),(16902,17552,'0000-00-00','ET','2',2,1,'Decheng Huang','FI','230675438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:28',0,'2014-03-01 17:00:58'),(16199,16848,'0000-00-00','ET','2',1,NULL,'Khaled Amat Campa','FI','659164401','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:38',0,'2014-03-02 06:10:30'),(13806,14162,'2014-01-01','ET','2',1,NULL,'Nancy Rodgers','FI','290505537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:13',0,'2014-03-01 16:40:16'),(10372,10372,'2014-01-01','ET','2',1,NULL,'Carrie Crutcher','FI','291783160','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:51',0,'2014-03-01 16:05:34'),(2831,2831,'2014-01-01','ET','2',1,NULL,'Jeff Stevens','FI','426298179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:20',0,'2014-03-02 04:15:49'),(10631,10631,'2014-01-01','ET','2',2,1,'Katheryne Brown','FI','455895781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:11',0,'2014-03-02 04:31:46'),(14524,14975,'2014-01-01','ET','2',1,NULL,'Anthony Philip Alicea','FI','277884871','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:08:04',0,'2014-03-10 16:17:47'),(7764,7764,'2014-01-01','ET','2',1,NULL,'Gerone Teague','FI','403499482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:20',0,'2014-03-01 19:11:03'),(6104,6104,'2014-01-01','ET','2',1,NULL,'Jeffrey Engel','FI','297461042','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:28',0,'2014-03-01 16:00:27'),(20255,20905,'0000-00-00','ET','2',3,2,'Asmaa Abdelaziz Hernandez','FI','634250912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:05',0,'2014-03-02 07:03:25'),(20630,21280,'0000-00-00','ET','2',1,NULL,'Michael Schlechty','FI','299641576','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:10',0,'2014-03-10 14:37:47'),(21353,22003,'0000-00-00','ET','2',2,1,'Matthew Graham','FI','275868002','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:25',0,'2014-03-10 14:45:25'),(11986,11986,'2014-01-01','ET','2',1,NULL,'rickey ransom','FI','457022331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:35',0,'2014-03-02 05:03:29'),(16995,17645,'0000-00-00','ET','2',1,NULL,'Oanh Lam','FI','631346488','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:27',0,'2014-03-02 06:17:30'),(16254,16903,'0000-00-00','ET','2',1,NULL,'FLOYD A CARTER','FI','295689980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:15',0,'2014-03-10 14:20:26'),(11799,11799,'2014-01-01','ET','2',1,NULL,'DIANE ARMOUR','FI','299584575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:06',0,'2014-03-10 16:03:49'),(15563,16014,'0000-00-00','ET','2',1,NULL,'Tiffany Kren','FI','269907518','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-23 03:02:19',NULL,NULL),(14714,15165,'2014-01-01','ET','2',2,1,'Kevin Nguyen','FI','439516064','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:04',0,'2014-03-02 05:45:37'),(10480,10480,'2014-01-01','ET','2',1,NULL,'Susan Sweeney','FI','404820528','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-26 12:53:16',0,'2014-03-01 16:10:36'),(7576,7576,'2014-01-01','ET','2',1,NULL,'Torey Horner','FI','273661184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:28',0,'2014-03-01 16:05:34'),(13098,13454,'2014-01-01','ET','2',1,NULL,'Alesia Cowart','FI','426474297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:55',0,'2014-03-02 05:17:40'),(2666,2666,'2014-01-01','ET','2',1,NULL,'Kathleen Fritz','FI','298760246','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:04',0,'2014-03-01 16:05:34'),(3793,3793,'2014-01-01','ET','2',1,NULL,'Shemekisa Jobe','FI','553719706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:03',0,'2014-03-01 23:10:52'),(20484,21134,'0000-00-00','ET','2',1,NULL,'Johnny Adkins','FI','279541306','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:34',0,'2014-03-10 16:38:05'),(23013,23663,'0000-00-00','ET','2',2,1,'TREASEA LOWMAN','FI','410474373','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:00',0,'2014-03-10 21:27:11'),(872,872,'2014-01-01','ET','2',1,NULL,'Rodney Brady','FI','268823265','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:22',0,'2014-03-01 15:16:37'),(16277,16927,'0000-00-00','ET','2',1,NULL,'quynton earle','FI','461514583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:08',0,'2014-03-02 06:10:30'),(15779,16428,'0000-00-00','ET','2',1,NULL,'Nicole Taylor','FI','283846655','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:01:43',0,'2014-03-10 14:10:12'),(1667,1667,'2014-01-01','ET','2',1,NULL,'Eugene Franklin','FI','459924794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:15:29',0,'2014-03-02 00:10:48'),(14063,14514,'2014-01-01','ET','2',1,NULL,'Karen Suttle','FI','425116332','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:11',0,'2014-03-02 05:31:31'),(2339,2339,'2014-01-01','ET','2',2,1,'Anthony Facchiano','FI','272500388','Summa Insurance Company, Inc.','FI','341809108','Susan E Lux','94','1590799','348','2014-01-01','Sync Success',0,'2013-12-25 20:15:20',0,'2014-03-10 15:45:56'),(5047,5047,'2014-01-01','ET','2',1,NULL,'Betty J Hohn','FI','284560056','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:28',0,'2014-03-01 15:31:33'),(3546,3546,'2014-01-01','ET','2',2,1,'Lawrence Koosed','FI','273460024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:40',0,'2014-03-01 15:37:30'),(3096,3096,'2014-01-01','ET','2',1,NULL,'ralph stevens','FI','436808043','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:05',0,'2014-03-02 01:10:33'),(21498,22148,'0000-00-00','ET','2',1,NULL,'Richard Channing','FI','234061184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:53',0,'2014-03-03 21:36:16'),(22150,22800,'0000-00-00','ET','2',1,NULL,'Starlette Addison','FI','288863232','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-06 21:01:05',0,'2014-03-06 21:36:23'),(12127,12127,'2014-01-01','ET','2',2,1,'matthew wood','FI','291828066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:40',0,'2014-03-01 16:30:17'),(12067,12067,'2014-01-01','ET','2',1,NULL,'Diane Kay Hackman','FI','279426991','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:36',0,'2014-03-01 16:30:17'),(14223,14674,'2014-01-01','ET','2',1,NULL,'Jessica Pruett','FI','465998950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:50',0,'2014-03-02 05:38:34'),(10677,10677,'2014-01-01','ET','2',1,NULL,'Vicky Coleman','FI','268628897','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:39',0,'2014-03-01 16:10:36'),(6370,6370,'2014-01-01','ET','2',1,NULL,'Brian Johns','FI','282602090','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:34',0,'2014-03-10 13:39:10'),(18634,19284,'0000-00-00','ET','2',2,1,'KELLEY CONLEY','FI','275908080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:01',0,'2014-03-01 17:26:36'),(20532,21182,'0000-00-00','ET','2',1,NULL,'Sean Morgan Wimberley','FI','437630807','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:05',0,'2014-03-02 07:10:28'),(20940,21590,'0000-00-00','ET','2',2,1,'Amber Martin','FI','278823843','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:32',0,'2014-03-10 14:37:47'),(21575,22225,'0000-00-00','ET','2',1,NULL,'Kristen Chicoine','FI','644485796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:51',0,'2014-03-03 22:26:43'),(22399,23049,'0000-00-00','ET','2',1,NULL,'Heather Renee Seay','FI','467991771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:35',0,'2014-03-07 21:25:22'),(1172,1172,'2014-01-01','ET','2',1,NULL,'Sean Murphy','FI','436596443','Starmount Life Insurance Company','FI','720977315','THOMAS  KLOTZ','94','2766547','348','2014-01-01','Sync Success',0,'2013-12-25 18:46:53',0,'2014-03-02 04:38:08'),(16758,17408,'0000-00-00','ET','2',1,NULL,'alexis frausto','FI','625624287','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:15',0,'2014-03-02 06:17:30'),(15240,15691,'0000-00-00','ET','2',1,NULL,'Eva Terry','FI','613966394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:21',0,'2014-03-02 05:52:31'),(14634,15085,'2014-01-01','ET','2',1,NULL,'Catherine Catania','FI','283863556','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','357','2014-02-01','Sync Success',0,'2014-01-16 08:45:11',0,'2014-03-01 16:46:19'),(12441,12441,'2014-01-01','ET','2',1,NULL,'Steven Anderson','FI','476847471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:10',0,'2014-03-02 05:03:29'),(2405,2405,'2014-01-01','ET','2',1,NULL,'Richard Jereb','94','0000433867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:23',0,'2014-03-01 15:26:40'),(4320,4320,'2014-01-01','ET','2',1,NULL,'Gordon Naquin','FI','433742595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:51',0,'2014-03-02 03:09:49'),(2462,2462,'2014-01-01','ET','2',1,NULL,'vivian cole','FI','587785563','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:15',0,'2014-03-01 23:10:52'),(2720,2720,'2014-01-01','ET','2',1,NULL,'William Levy','FI','222423549','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:49',0,'2014-03-02 04:15:49'),(18148,18798,'0000-00-00','ET','2',1,NULL,'LEATRICE WARREN','FI','037369233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:14',0,'2014-03-02 06:38:05'),(18419,19069,'0000-00-00','ET','2',1,NULL,'Sandra Bradford','FI','283483603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:15',0,'2014-03-01 17:26:36'),(18558,19208,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:16',0,'2014-03-02 06:45:14'),(18848,19498,'0000-00-00','ET','2',1,NULL,'blaine devitt','FI','434962790','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:24',0,'2014-03-02 06:52:12'),(5740,5740,'2014-01-01','ET','2',1,NULL,'Ian Slattery','FI','436435358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:37',0,'2014-03-02 01:10:33'),(14992,15443,'2014-01-01','ET','2',1,NULL,'renda owens','FI','428712149','Starmount Life Insurance Company','FI','720977315','Brian  Caston','94','9699391','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:07',0,'2014-03-02 05:45:37'),(4654,4654,'2014-01-01','ET','2',1,NULL,'Jason Castle','FI','289782420','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:04',0,'2014-03-10 16:03:49'),(2178,2178,'2014-01-01','ET','2',1,NULL,'Angie Day','FI','442841779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:25',0,'2014-03-01 21:11:04'),(18092,18742,'0000-00-00','ET','2',1,NULL,'Manuela Herrera','FI','456041268','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:32',0,'2014-03-02 06:38:05'),(18458,19108,'0000-00-00','ET','2',1,NULL,'Brian Wright','FI','282884410','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:43',0,'2014-03-10 14:24:38'),(20089,20739,'0000-00-00','ET','2',1,NULL,'LaJerrika Carney','FI','435778887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:09',0,'2014-03-02 07:10:28'),(22733,23383,'0000-00-00','ET','2',2,1,'Michael D Kern','FI','267296135','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 20:59:59',0,'2014-03-09 21:26:00'),(1118,1118,'2014-01-01','ET','2',1,NULL,'SONYA KELLEY','FI','464911909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:12',0,'2014-03-02 04:38:08'),(2115,2115,'2014-01-01','ET','2',2,1,'Dennis Brown','FI','270504376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:23',0,'2014-03-01 15:16:37'),(4779,4779,'2014-01-01','ET','2',1,NULL,'Michael M Smith','FI','146449682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:15',0,'2014-03-01 21:11:04'),(10935,10935,'2014-01-01','ET','2',2,1,'Gregory Kinney','FI','293626408','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:48',0,'2014-03-10 16:03:49'),(20085,20735,'0000-00-00','ET','2',1,NULL,'brett rumball','FI','766098683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:06',0,'2014-03-02 07:10:28'),(385,385,'2014-01-01','ET','2',1,NULL,'James Gorsuch','FI','272469750','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:54',0,'2014-03-10 13:10:24'),(11776,11776,'2014-01-01','ET','2',1,NULL,'SuzAnne Pell','FI','282725765','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:14',0,'2014-03-10 13:52:32'),(17672,18322,'0000-00-00','ET','2',1,NULL,'SANDRA CROYLE','FI','287480594','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:48',0,'2014-03-10 16:24:30'),(7167,7167,'2014-01-01','ET','2',1,NULL,'Renee Strahler','FI','285881352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:05:35',0,'2014-03-10 15:59:47'),(16102,16751,'0000-00-00','ET','2',1,NULL,'Helen Weber','FI','275545464','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:18',0,'2014-03-10 16:24:30'),(2533,2533,'2014-01-01','ET','2',1,NULL,'Vanessa norman','FI','466331800','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:00',0,'2014-03-01 20:10:57'),(3134,3134,'2014-01-01','ET','2',1,NULL,'emily maley','FI','455915121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:14',0,'2014-03-02 01:10:33'),(5452,5452,'2014-01-01','ET','2',1,NULL,'Hayley Day','FI','296925184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:05',0,'2014-03-01 15:05:09'),(3812,3812,'2014-01-01','ET','2',2,1,'Kenneth Lowther','FI','298489951','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:44',0,'2014-03-01 15:26:40'),(18795,19445,'0000-00-00','ET','2',1,NULL,'DEBORA CRAINE','FI','273669421','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:04',0,'2014-03-10 14:31:05'),(21240,21890,'0000-00-00','ET','2',1,NULL,'Jessica Kennedy','FI','296845342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-03-01 21:00:24',0,'2014-03-01 21:35:40'),(22158,22808,'0000-00-00','ET','2',1,NULL,'Abigale Harding','FI','288968279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:10',0,'2014-03-06 21:36:23'),(3423,3423,'2014-01-01','ET','2',1,NULL,'CHARLENE  D FENNMORE','FI','312602119','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:26',0,'2014-03-10 13:24:34'),(18009,18659,'0000-00-00','ET','2',1,NULL,'Megan McGowan','FI','250738489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:46',0,'2014-03-01 17:20:55'),(17648,18298,'0000-00-00','ET','2',1,NULL,'DEBRA A SEAGIN','FI','282562724','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:34',0,'2014-03-01 17:20:55'),(7659,7659,'2014-01-01','ET','2',1,NULL,'Charles  Fritz','FI','288568358','HealthSpan','FI','311431434','Darwin  Carmichael','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-26 04:39:07',0,'2014-03-10 13:39:10'),(16139,16788,'0000-00-00','ET','2',1,NULL,'KEN R MERUNSKI','FI','289440458','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:48',0,'2014-03-10 14:20:26'),(15305,15756,'0000-00-00','ET','2',1,NULL,'Patrick Smith','FI','281743510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:21',0,'2014-03-01 16:50:53'),(4931,4931,'2014-01-01','ET','2',1,0,'janet glaesner','FI','265840767','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:09',0,'2014-03-10 13:03:33'),(18889,19539,'0000-00-00','ET','2',2,1,'james wassman','FI','344766516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:54',0,'2014-03-02 06:52:12'),(20080,20730,'0000-00-00','ET','2',1,NULL,'Thomas Alexander','FI','277466738','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-25 21:00:33',0,'2014-03-10 14:37:47'),(20669,21319,'0000-00-00','ET','2',3,2,'ron alsept','FI','272609123','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:40',0,'2014-03-10 14:37:47'),(20740,21390,'0000-00-00','ET','2',1,NULL,'MARIA G AREVALOS','FI','292020274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:30',0,'2014-03-01 18:10:11'),(21828,22478,'0000-00-00','ET','2',1,NULL,'Deborah McKinney','FI','291428895','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:21',0,'2014-03-05 21:36:22'),(21960,22610,'0000-00-00','ET','2',1,NULL,'Lauren Scorsone','FI','438175361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:25',0,'2014-03-05 22:27:33'),(22680,23330,'0000-00-00','ET','2',1,NULL,'Donna Migues','FI','437171121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:30:44',0,'2014-03-08 22:26:18'),(12479,12479,'2014-01-01','ET','2',1,NULL,'Terence Mahone','FI','269528660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:32:29',0,'2014-03-01 16:30:17'),(16745,17395,'0000-00-00','ET','2',1,NULL,'Maria Lopez','FI','458088776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-01 19:00:06',0,'2014-03-02 06:17:30'),(16703,17353,'0000-00-00','ET','2',1,NULL,'Meghan Miller','FI','589647428','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:19',0,'2014-03-01 17:00:58'),(4541,4541,'2014-01-01','ET','2',2,1,'Gregory Guy','FI','435178028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:22',0,'2014-03-02 04:31:46'),(4524,4524,'2014-01-01','ET','2',2,1,'Terry Miller','FI','436963054','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:53',0,'2014-03-01 21:11:04'),(4189,4189,'2014-01-01','ET','2',1,NULL,'Robert Thomas Williams','FI','185548626','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:56',0,'2014-03-10 15:59:47'),(2409,2409,'2014-01-01','ET','2',4,3,'John Isenbarger','FI','269821132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:30',0,'2014-03-01 15:26:40'),(4003,4003,'2014-01-01','ET','2',1,NULL,'Jack Ritchie','FI','632281579','Starmount Life Insurance Company','FI','720977315','DAVID  EDWARDS','94','565219','348','2014-01-01','Sync Success',0,'2013-12-25 23:00:16',0,'2014-03-02 03:09:49'),(6349,6349,'2014-01-01','ET','2',1,NULL,'Bradley Smith II','FI','294883874','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:52',0,'2014-03-10 13:39:10'),(18788,19438,'0000-00-00','ET','2',1,NULL,'William Topie','FI','279804049','HealthSpan','FI','311431434','Michael  Bennett','94','8790924','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:57',0,'2014-03-10 14:31:05'),(10577,10577,'2014-01-01','ET','2',1,NULL,'Katrina Givens','FI','467231246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:27',0,'2014-03-02 04:24:47'),(10454,10454,'2014-01-01','ET','2',1,NULL,'sonja lovelace','FI','294525659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:26',0,'2014-03-01 16:10:36'),(18463,19113,'0000-00-00','ET','2',1,NULL,'Chi Tran','FI','021905059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:46',0,'2014-03-02 06:45:14'),(21731,22381,'0000-00-00','ET','2',1,NULL,'Brittany Quidgeon','FI','250776774','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:02:04',0,'2014-03-10 16:44:18'),(22299,22949,'0000-00-00','ET','2',4,3,'Harold Hennies','FI','292425328','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:53',0,'2014-03-10 14:50:59'),(7457,7457,'2014-01-01','ET','2',1,NULL,'LORETTA A MCKENZIE','FI','629345166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:35',0,'2014-03-02 04:10:25'),(20409,21059,'0000-00-00','ET','2',1,NULL,'dennessa larose chentlen','FI','434578411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:34',0,'2014-03-02 07:10:28'),(20654,21304,'0000-00-00','ET','2',1,NULL,'jack givens','FI','278543243','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:28',0,'2014-03-10 16:38:05'),(22445,23095,'0000-00-00','ET','2',1,NULL,'Yulanda Kennedy','FI','464155521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:32',0,'2014-03-07 22:26:59'),(10945,10945,'2014-01-01','ET','2',1,NULL,'Robert Campbell','FI','285802225','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:04',0,'2014-03-10 16:03:49'),(15776,16425,'0000-00-00','ET','2',1,NULL,'Joey Dennis','FI','301729443','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:39',0,'2014-03-10 16:24:30'),(16314,16964,'0000-00-00','ET','2',1,NULL,'LINDA MILLER','FI','297563914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:32',0,'2014-03-01 16:56:22'),(18223,18873,'0000-00-00','ET','2',1,NULL,'Diane m Cain','FI','297807583','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:12',0,'2014-03-10 16:31:33'),(19174,19824,'0000-00-00','ET','2',2,1,'Kenneth Salazar','FI','458969657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:42',0,'2014-03-02 06:52:12'),(19507,20157,'0000-00-00','ET','2',4,3,'danny grubb','FI','401278536','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:05:50',0,'2014-03-01 17:34:07'),(20860,21510,'0000-00-00','ET','2',1,NULL,'Cheryl Rowe','FI','406925992','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:26',0,'2014-03-10 14:37:47'),(21574,22224,'0000-00-00','ET','2',1,NULL,'Brenda Hindman','FI','587907509','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:50',0,'2014-03-03 22:26:43'),(11549,11549,'2014-01-01','ET','2',1,NULL,'John Doucette','FI','032549321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:07',0,'2014-03-02 04:52:44'),(17358,18008,'0000-00-00','ET','2',2,1,'Rachel Hurtado','FI','638078585','Starmount Life Insurance Company','FI','720977315','William Ernest Berry III','94','1116897','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:13',0,'2014-03-02 06:31:45'),(522,522,'2014-01-01','ET','2',1,NULL,'DEBORAH JOE WILLIAMS','FI','287464305','Dental Care Plus, Inc.','FI','311185262','ROD  WELLER','94','2759353','348','2014-01-01','Sync Success',0,'2013-12-25 18:01:06',0,'2014-03-01 15:48:04'),(14191,14642,'2014-01-01','ET','2',2,1,'Verlie Hayes','FI','298560862','HealthSpan','FI','311431434','Carrie J Lockwood','94','15026639','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:33',0,'2014-03-10 14:03:26'),(11089,11089,'2014-01-01','ET','2',1,NULL,'Valerie Winterfield','FI','286881630','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:46',0,'2014-03-10 13:39:10'),(1694,1694,'2014-01-01','ET','2',1,NULL,'Keith Gordon','FI','435274210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:20',0,'2014-03-02 00:10:48'),(6185,6185,'2014-01-01','ET','2',1,NULL,'Amber Wilson','FI','534213062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:51',0,'2014-03-02 04:10:25'),(18720,19370,'0000-00-00','ET','2',1,NULL,'Becky Alaniz','FI','457556612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 22:02:08',0,'2014-03-02 06:45:14'),(19375,20025,'0000-00-00','ET','2',1,NULL,'Thomas Richard Clein','FI','273447392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:50',0,'2014-03-01 17:34:07'),(20762,21412,'0000-00-00','ET','2',1,NULL,'April Adams','FI','281806726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:40',0,'2014-03-01 18:08:07'),(21341,21991,'0000-00-00','ET','2',1,NULL,'EUGENE SMITH','FI','269627342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:18',0,'2014-03-03 01:35:37'),(10774,10774,'2014-01-01','ET','2',1,NULL,'Miki Elizabeth Teer','FI','435595778','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:03:04',0,'2014-03-02 04:24:47'),(15906,16555,'0000-00-00','ET','2',1,NULL,'Brandy Jackson','FI','287803426','HealthSpan','FI','311431434','Angela  Rice','94','1821833','348','2014-03-01','Sync Success',0,'2014-01-24 21:01:16',0,'2014-03-10 14:10:12'),(1104,1104,'2014-01-01','ET','2',1,NULL,'Sheila Sutton','FI','277807087','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 18:32:10',0,'2014-03-10 13:03:33'),(3644,3644,'2014-01-01','ET','2',1,NULL,'John Almond','FI','290502768','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:44',0,'2014-03-10 13:20:27'),(5767,5767,'2014-01-01','ET','2',1,NULL,'Dotzie Davis','FI','551087230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:27',0,'2014-03-02 01:10:33'),(5381,5381,'2014-01-01','ET','2',1,NULL,'Sophie Hernandez','FI','567335730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:56',0,'2014-03-01 21:11:04'),(904,904,'2014-01-01','ET','2',1,NULL,'Leslie Klaiber','FI','286740750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:14',0,'2014-03-01 15:21:15'),(17526,18176,'0000-00-00','ET','2',1,NULL,'LuAnn Topovski-Mason','FI','275485026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:18',0,'2014-03-01 17:20:55'),(15574,16025,'0000-00-00','ET','2',1,NULL,'Donald Crabtree','FI','271464667','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:24',0,'2014-03-10 14:10:12'),(14787,15238,'2014-01-01','ET','2',1,NULL,'Charles Romine','FI','448662644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:49',0,'2014-03-02 05:45:37'),(925,925,'2014-01-01','ET','2',1,NULL,'rickey bodiker','FI','295588540','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:52',0,'2014-03-10 13:10:24'),(12385,12385,'2014-01-01','ET','2',1,NULL,'Joeseph Saviano','FI','283447233','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-02 04:29:08',0,'2014-03-01 16:30:17'),(1007,1007,'2014-01-01','ET','2',1,NULL,'Kevin Everett','FI','288645175','Summa Insurance Company, Inc.','FI','341809108','John  Christopher Dalziel','94','362362','348','2014-01-01','Sync Success',0,'2013-12-25 18:20:29',0,'2014-03-10 15:39:19'),(11354,11354,'2014-01-01','ET','2',2,1,'HUI LI','FI','303191363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:10',0,'2014-03-02 04:52:44'),(3882,3882,'2014-01-01','ET','2',1,0,'Keith Magnon','FI','435310116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:37',0,'2014-03-01 19:11:03'),(7551,7551,'2014-01-01','ET','2',2,1,'BYRON BESECE','FI','273562666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:39',0,'2014-03-01 16:05:34'),(21043,21693,'0000-00-00','ET','2',2,1,'Elana Tyree','FI','297740580','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:05',0,'2014-03-01 18:10:11'),(21312,21962,'0000-00-00','ET','2',1,NULL,'amanda williams','FI','284740187','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:03',0,'2014-03-10 14:45:25'),(22207,22857,'0000-00-00','ET','2',1,NULL,'DELINTHIA ANNETTE MAY','FI','269660720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:45',0,'2014-03-06 21:36:23'),(22817,23467,'0000-00-00','ET','2',1,NULL,'Rebecca Ann Slone','FI','276902431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:07',0,'2014-03-10 14:50:59'),(22978,23628,'0000-00-00','ET','2',1,NULL,'Stephen Mabry','FI','290562526','Dental Care Plus, Inc.','FI','311185262','Greg  Stocksdale','94','2443930','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:35',0,'2014-03-10 21:36:25'),(65,65,'2014-01-01','ET','2',1,NULL,'Gary Alan Solomon','FI','300544777','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:57',0,'2014-03-01 15:21:15'),(17086,17736,'0000-00-00','ET','2',2,1,'Robin Elliott','FI','298546432','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:51',0,'2014-03-01 17:00:58'),(917,917,'2014-01-01','ET','2',1,NULL,'Teanna Jackson','FI','405176619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:35',0,'2014-03-01 15:21:15'),(7744,7744,'2014-01-01','ET','2',1,NULL,'HAROLD DIXON','FI','403926078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:40',0,'2014-03-01 15:05:09'),(1820,1820,'2014-01-01','ET','2',1,NULL,'Freda Diane Dickinson','FI','294562079','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:15',0,'2014-03-10 15:45:56'),(18834,19484,'0000-00-00','ET','2',1,NULL,'MIREYA Y ZUNIGA','FI','631318336','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:15',0,'2014-03-02 06:52:12'),(19492,20142,'0000-00-00','ET','2',1,NULL,'SYLVIA VALERIO','FI','360469991','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:01:47',0,'2014-03-02 06:59:07'),(21858,22508,'0000-00-00','ET','2',2,1,'Tat Ming Lam','FI','214025414','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:12',0,'2014-03-05 21:36:22'),(881,881,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:36',0,'2014-03-01 15:21:15'),(16797,17447,'0000-00-00','ET','2',1,NULL,'brian benjamin','FI','279701760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:39',0,'2014-03-01 17:00:58'),(13776,14132,'2014-01-01','ET','2',1,NULL,'Tremayne Durr','FI','324784745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:31',0,'2014-03-02 05:24:45'),(1162,1162,'2014-01-01','ET','2',1,NULL,'ROSE KELLY','FI','437862400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:34',0,'2014-03-02 04:38:08'),(2241,2241,'2014-01-01','ET','2',1,NULL,'kerry smith','FI','587925467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:37',0,'2014-03-01 21:11:04'),(12309,12309,'2014-01-01','ET','2',1,NULL,'Aaron Thompson','FI','273909848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:38',0,'2014-03-10 16:10:34'),(18012,18662,'0000-00-00','ET','2',1,NULL,'Stephan A Deaton','FI','389823871','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:47',0,'2014-03-01 17:20:55'),(19956,20606,'0000-00-00','ET','2',2,1,'BARBARA MAREK','FI','452027734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:20',0,'2014-03-02 07:03:25'),(19962,20612,'0000-00-00','ET','2',1,NULL,'Gabriel Cotruta','FI','285065390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:25',0,'2014-03-01 17:47:19'),(20016,20666,'0000-00-00','ET','2',1,NULL,'Joshua Fath','FI','279849234','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:04',0,'2014-03-10 16:38:05'),(22920,23570,'0000-00-00','ET','2',1,NULL,'Keith Bursntein','FI','150703760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:55',0,'2014-03-10 21:27:11'),(752,752,'2014-01-01','ET','2',1,NULL,'Melissa Ledsome','FI','277963877','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:27',0,'2014-03-10 15:52:36'),(1821,1821,'2014-01-01','ET','2',1,NULL,'Debra Keeton','FI','299500550','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:17',0,'2014-03-10 15:45:56'),(14892,15343,'2014-01-01','ET','2',1,NULL,'James DeWitt','FI','463159855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:20',0,'2014-03-02 05:45:37'),(14663,15114,'2014-01-01','ET','2',1,NULL,'Heather Tackett','FI','291644723','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:30',0,'2014-03-01 16:46:19'),(7267,7267,'2014-01-01','ET','2',1,NULL,'Nancy Ann Brewer','FI','299567614','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:43',0,'2014-03-10 13:32:15'),(2042,2042,'2014-01-01','ET','2',1,NULL,'jay keller','FI','275440778','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:10',0,'2014-03-10 13:20:27'),(2463,2463,'2014-01-01','ET','2',1,NULL,'KEVIN ANDREW GWYN','FI','412618465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:17',0,'2014-03-01 23:10:52'),(5194,5194,'2014-01-01','ET','2',2,1,'Kenneth Pitts','FI','317828182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:10',0,'2014-03-02 00:10:48'),(6331,6331,'2014-01-01','ET','2',1,NULL,'Lisa Goldstein','FI','313668921','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:21',0,'2014-03-10 15:59:47'),(5778,5778,'2014-01-01','ET','2',5,4,'Cynthia Rogers','FI','278543405','Summa Insurance Company, Inc.','FI','341809108','Matthew  Kruza','94','17049735','348','2014-01-01','Sync Success',0,'2013-12-26 02:02:51',0,'2014-03-10 15:52:36'),(4581,4581,'2014-01-01','ET','2',1,NULL,'Stephanie Jenkins','FI','287808256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:40',0,'2014-03-01 16:15:39'),(4142,4142,'2014-01-01','ET','2',1,NULL,'FRANCES DIANE OILER','FI','291503109','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:27',0,'2014-03-01 16:00:27'),(18882,19532,'0000-00-00','ET','2',2,1,'MARANDIA YOUNG','FI','225760614','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:48',0,'2014-03-01 17:34:07'),(21500,22150,'0000-00-00','ET','2',1,NULL,'KATHLEEN SOMERVILLE','FI','298507817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:30:55',0,'2014-03-03 21:36:16'),(221,221,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:22:01',0,'2014-03-10 13:10:24'),(17992,18642,'0000-00-00','ET','2',1,NULL,'james rodney watson','FI','461150854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:34',0,'2014-03-02 06:38:05'),(761,761,'2014-01-01','ET','2',3,2,'Maureen E Fowler','FI','114584175','HealthSpan','FI','311431434','Maureen E Fowler','94','8188952','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:40',0,'2014-03-10 13:24:34'),(1417,1417,'2014-01-01','ET','2',1,NULL,'Joyce  Overton','FI','300486136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:36',0,'2014-03-10 13:52:32'),(10622,10622,'2014-01-01','ET','2',1,NULL,'Carena van Riper','FI','573936123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:54',0,'2014-03-02 04:24:47'),(2071,2071,'2014-01-01','ET','2',1,NULL,'Claire Ann Voiers','FI','288549122','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:08',0,'2014-03-10 15:45:56'),(14161,14612,'2014-01-01','ET','2',1,NULL,'Mark J Ficarra','FI','299723928','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:14',0,'2014-03-10 16:17:47'),(6165,6165,'2014-01-01','ET','2',1,NULL,'Josefina S GARCILAZO','FI','451997217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:17',0,'2014-03-02 04:10:25'),(3550,3550,'2014-01-01','ET','2',1,NULL,'Amanda Bodi','FI','300906228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:46',0,'2014-03-01 15:37:30'),(75,75,'2014-01-01','ET','2',1,NULL,'Deborah Allen','FI','289443361','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:17',0,'2014-03-01 15:21:15'),(202,202,'2014-01-01','ET','2',1,NULL,'Nancy Ann Helinski','FI','268547623','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:18',0,'2014-03-10 13:10:24'),(17128,17778,'0000-00-00','ET','2',1,NULL,'Saige McDonald','FI','462914727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:18',0,'2014-03-02 06:24:38'),(16532,17182,'0000-00-00','ET','2',1,NULL,'ROXANA MAYLEEN COLON','FI','598220257','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:58',0,'2014-03-01 17:00:58'),(7591,7591,'2014-01-01','ET','2',2,1,'WILMER CARTER','FI','587620042','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:02',0,'2014-03-02 04:10:25'),(14165,14616,'2014-01-01','ET','2',1,NULL,'elizabeth herbell','FI','294588300','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:17',0,'2014-03-10 16:17:47'),(13825,14181,'2014-01-01','ET','2',1,NULL,'ANA CHAVEZ','FI','644502782','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:30',0,'2014-03-02 05:31:31'),(5924,5924,'2014-01-01','ET','2',1,NULL,'Dallas Moore','FI','269528855','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:32',0,'2014-03-01 15:48:04'),(3995,3995,'2014-01-01','ET','2',1,NULL,'Vicki Edwards','FI','428171720','Starmount Life Insurance Company','FI','720977315','Michael  Daughterty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-25 22:48:08',0,'2014-03-01 23:10:52'),(3737,3737,'2014-01-01','ET','2',2,1,'NICOLE MOLONEY','FI','276742394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:46',0,'2014-03-10 13:24:34'),(20151,20801,'0000-00-00','ET','2',1,NULL,'MICHAEL LYNN WEIMER','FI','289824186','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:56',0,'2014-03-10 16:38:05'),(21146,21796,'0000-00-00','ET','2',1,NULL,'Blaire Brown','FI','438756307','Starmount Life Insurance Company','FI','720977315','Rai Lynn  Jarabica','94','3715351','348','2014-05-01','Sync Success',0,'2014-02-28 21:31:18',0,'2014-03-02 07:23:39'),(21543,22193,'0000-00-00','ET','2',1,NULL,'Crystal Lynn McMahan','FI','271764437','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:26',0,'2014-03-10 14:45:25'),(21714,22364,'0000-00-00','ET','2',1,NULL,'edith a andrich','FI','412020623','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:50',0,'2014-03-04 21:27:16'),(13818,14174,'2014-01-01','ET','2',1,NULL,'Shavitress Carter','FI','411579718','Summa Insurance Company, Inc.','FI','341809108','Rhonda Kay Jackson','94','1101549300','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:24',0,'2014-03-10 16:10:34'),(18112,18762,'0000-00-00','ET','2',1,NULL,'Derek Plate','FI','453894576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:47',0,'2014-03-02 06:38:05'),(16818,17468,'0000-00-00','ET','2',1,NULL,'Edgar Hernandez','FI','629285914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:05',0,'2014-03-02 06:17:30'),(16708,17358,'0000-00-00','ET','2',1,NULL,'Lindsey Mitchell','94','0000349297','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3345488','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:22',0,'2014-03-01 17:00:58'),(13870,14226,'2014-01-01','ET','2',1,NULL,'Blanca Vasquez','FI','287809469','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:01',0,'2014-03-10 14:03:26'),(14341,14792,'2014-01-01','ET','2',2,1,'Sandra Kaye Ondreas','FI','449082939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:42',0,'2014-03-02 05:38:34'),(18683,19333,'0000-00-00','ET','2',2,1,'Micheal Armstrong','FI','464907801','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:39',0,'2014-03-02 06:45:14'),(20184,20834,'0000-00-00','ET','2',1,NULL,'Teresa Mccain','FI','452022656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:19',0,'2014-03-02 07:10:28'),(22364,23014,'0000-00-00','ET','2',1,NULL,'BILLY WINTERS','FI','436068994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:18',0,'2014-03-07 21:25:22'),(356,356,'2014-01-01','ET','2',1,NULL,'DARLENE CODA-MILLER','FI','279661182','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:59',0,'2014-03-01 15:21:15'),(509,509,'2014-01-01','ET','2',1,NULL,'SHELLY SCHROEDER','FI','274681855','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:45',0,'2014-03-01 15:48:04'),(16125,16774,'0000-00-00','ET','2',1,NULL,'Shameka  Murry','FI','426634187','Starmount Life Insurance Company','FI','720977315','Patricia   Donofrio Johnson','94','1927421','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:36',0,'2014-03-02 06:03:21'),(2291,2291,'2014-01-01','ET','2',1,NULL,'cedric figaro','FI','435692967','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:52',0,'2014-03-01 21:11:04'),(7444,7444,'2014-01-01','ET','2',1,NULL,'ELVIRA OBREGON','FI','459949990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:15',0,'2014-03-02 04:10:25'),(11722,11722,'2014-01-01','ET','2',1,NULL,'DEBRA SCOTT','FI','296545026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:35',0,'2014-03-01 16:30:17'),(17196,17846,'0000-00-00','ET','2',1,NULL,'NANCY CHU','FI','519786005','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:03',0,'2014-03-02 06:24:38'),(17432,18082,'0000-00-00','ET','2',1,NULL,'Carolyn Kershaw','FI','458764171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:04',0,'2014-03-02 06:24:38'),(17520,18170,'0000-00-00','ET','2',1,NULL,'Mary Helen Lopez','FI','463353361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:14',0,'2014-03-02 06:31:45'),(18484,19134,'0000-00-00','ET','2',1,NULL,'Sandra C White','FI','587266108','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:59',0,'2014-03-02 06:45:14'),(19316,19966,'0000-00-00','ET','2',1,NULL,'DANNY D GONZALES','FI','451086730','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:09',0,'2014-03-02 06:59:07'),(19652,20302,'0000-00-00','ET','2',5,4,'MAURA KENNEDY ANAYA','FI','251843487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:43:55',0,'2014-03-01 17:47:19'),(22549,23199,'0000-00-00','ET','2',1,NULL,'Florine Mcqueen','FI','427048405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:45',0,'2014-03-07 22:26:59'),(168,168,'2014-01-01','ET','2',1,NULL,'ETTA CLEVENGER','FI','291508433','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:14',0,'2014-03-10 13:10:24'),(1746,1746,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:51',0,'2014-03-01 15:31:33'),(15427,15878,'0000-00-00','ET','2',1,NULL,'SUSAN BEASLEY','FI','509568325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:27',0,'2014-03-01 16:50:53'),(15145,15596,'0000-00-00','ET','2',1,NULL,'Daniel Laurich','FI','297500533','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:24',0,'2014-03-10 16:17:47'),(3018,3018,'2014-01-01','ET','2',1,NULL,'Benjamin Starcher','FI','287749582','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:33:40',0,'2014-03-10 15:52:36'),(14832,15283,'2014-01-01','ET','2',1,NULL,'DANTE CAMPOLONGO','FI','282644839','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:47:20',0,'2014-03-10 14:10:12'),(18230,18880,'0000-00-00','ET','2',2,1,'PAULINE  SHAFFER','FI','283503650','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:18',0,'2014-03-10 14:24:38'),(21637,22287,'0000-00-00','ET','2',1,NULL,'JESUS DURON LOPEZ','FI','454131565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-04 21:00:49',0,'2014-03-04 21:27:16'),(22014,22664,'0000-00-00','ET','2',1,NULL,'CONNIE MCCOY','FI','276488594','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:01',0,'2014-03-05 21:36:22'),(11717,11717,'2014-01-01','ET','2',1,NULL,'Lemichal Drake','FI','425654959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:26',0,'2014-03-02 04:59:36'),(15002,15453,'2014-01-01','ET','2',1,NULL,'Jessca Nelson','FI','283888937','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:11',0,'2014-03-10 16:17:47'),(560,560,'2014-01-01','ET','2',1,NULL,'WANETA ETHEL KREPINA','FI','279507018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:23',0,'2014-03-01 15:48:04'),(11455,11455,'2014-01-01','ET','2',1,NULL,'LORI ZIMMERMAN','FI','299746464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:18',0,'2014-03-01 16:23:43'),(1569,1569,'2014-01-01','ET','2',3,2,'Kimberly Mathews McAllister','FI','225331512','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:14',0,'2014-03-01 15:10:22'),(3910,3910,'2014-01-01','ET','2',1,NULL,'terry whitis','FI','403705216','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:22',0,'2014-03-01 15:26:40'),(1983,1983,'2014-01-01','ET','2',1,NULL,'Carolyn Halton','FI','652834880','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:16',0,'2014-03-10 15:45:56'),(5205,5205,'2014-01-01','ET','2',1,NULL,'Benjamin Trevino','FI','458135717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:32',0,'2014-03-02 00:10:48'),(7458,7458,'2014-01-01','ET','2',1,NULL,'Robert Cantu','FI','463576265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:37',0,'2014-03-02 04:15:49'),(17612,18262,'0000-00-00','ET','2',1,NULL,'Debbie Blunt','FI','456459854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:10',0,'2014-03-02 06:31:45'),(19422,20072,'0000-00-00','ET','2',1,NULL,'WANDA DELANEY','FI','437961981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-18 22:01:25',0,'2014-03-02 06:59:07'),(20520,21170,'0000-00-00','ET','2',1,NULL,'Harry Dawson III','FI','434659724','Starmount Life Insurance Company','FI','720977315','Dorothy S Kenney','94','4696291','348','2014-03-01','Sync Success',0,'2014-02-26 21:00:57',0,'2014-03-02 07:17:36'),(593,593,'2014-01-01','ET','2',1,NULL,'Mary Jay','FI','137461785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:23',0,'2014-03-02 02:10:49'),(3820,3820,'2014-01-01','ET','2',1,NULL,'CAROLYN SUE HUMM','FI','291467790','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:03',0,'2014-03-10 15:45:56'),(13702,14058,'2014-01-01','ET','2',2,1,'ANNETTA F CRABTREE','FI','278560837','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:42',0,'2014-03-01 16:40:16'),(6388,6388,'2014-01-01','ET','2',1,NULL,'Marcia Tomanicek','FI','291587280','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:10:06',0,'2014-03-10 13:39:10'),(10939,10939,'2014-01-01','ET','2',1,NULL,'KIMBERLY PRINGLE','FI','288581484','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:54',0,'2014-03-10 16:03:49'),(20865,21515,'0000-00-00','ET','2',1,NULL,'JACQULIN NORRIS','FI','270506738','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:28',0,'2014-03-10 14:37:47'),(20897,21547,'0000-00-00','ET','2',3,2,'David Klucas','FI','286461137','HealthSpan','FI','311431434','Robert  Zirker III','94','1005990','348','2014-04-01','Sync Success',0,'2014-02-28 06:31:43',0,'2014-03-10 14:45:25'),(22791,23441,'0000-00-00','ET','2',1,NULL,'Nicholas Gaines','FI','449612333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:42',0,'2014-03-09 21:26:00'),(23086,23736,'0000-00-00','ET','2',1,NULL,'REBECCA J SUTHERLY','FI','300484369','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-10 21:02:56',0,'2014-03-10 21:17:52'),(1256,1256,'2014-01-01','ET','2',1,NULL,'michael molden','FI','298826122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:23',0,'2014-03-01 16:15:39'),(11782,11782,'2014-01-01','ET','2',2,1,'kenneth Knitz','FI','273746298','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:27',0,'2014-03-10 13:52:32'),(7324,7324,'2014-01-01','ET','2',2,1,'Francis Denehy','FI','285540033','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:27',0,'2014-03-10 13:32:15'),(6295,6295,'2014-01-01','ET','2',1,NULL,'JACKIE COLEMAN','FI','436881074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:16',0,'2014-03-02 04:10:25'),(3102,3102,'2014-01-01','ET','2',1,NULL,'Brianna Wright','FI','433836232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:15',0,'2014-03-02 01:10:33'),(4865,4865,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:06',0,'2014-03-01 20:10:57'),(3721,3721,'2014-01-01','ET','2',1,NULL,'Cynthia Macdonald','FI','370848938','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:14',0,'2014-03-10 13:20:27'),(6276,6276,'2014-01-01','ET','2',2,1,'Linda Shipp','FI','434902794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:43',0,'2014-03-02 04:10:25'),(18426,19076,'0000-00-00','ET','2',1,NULL,'a\'shaya richardson','FI','301949261','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:22',0,'2014-03-01 17:26:36'),(10432,10432,'2014-01-01','ET','2',1,NULL,'Billy Wayne Fleenor','FI','290969207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:41',0,'2014-03-01 16:10:36'),(16922,17572,'0000-00-00','ET','2',1,NULL,'Joshua Asher','FI','292806079','Dental Care Plus, Inc.','FI','311185262','Warren  McDonald','94','7863806','357','2014-02-01','Sync Success',0,'2014-02-03 21:00:39',0,'2014-03-01 17:00:58'),(16698,17348,'0000-00-00','ET','2',1,NULL,'susan dominic','FI','275601888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:16',0,'2014-03-01 17:00:58'),(2234,2234,'2014-01-01','ET','2',1,NULL,'Stephen Apple','FI','302460702','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:21',0,'2014-03-10 15:39:19'),(4340,4340,'2014-01-01','ET','2',1,NULL,'Robert Ray','FI','295607866','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:29',0,'2014-03-10 13:32:15'),(15692,16341,'0000-00-00','ET','2',1,NULL,'PABLO GARCIA','FI','645647123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:43',0,'2014-03-02 06:03:21'),(5456,5456,'2014-01-01','ET','2',1,NULL,'laquivia barbee','FI','397065918','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:13',0,'2014-03-10 13:03:33'),(7431,7431,'2014-01-01','ET','2',1,NULL,'LAMONICA MICHELLE JOHNSON','FI','438254929','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:51',0,'2014-03-02 04:15:49'),(18370,19020,'0000-00-00','ET','2',2,1,'James Sadler','FI','465177172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:40',0,'2014-03-02 06:45:14'),(11448,11448,'2014-01-01','ET','2',1,NULL,'BARBARA EAKIN','FI','292527843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:05',0,'2014-03-01 16:23:43'),(16013,16662,'0000-00-00','ET','2',1,NULL,'WENDY DANSORD','FI','458670368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-27 21:00:19',0,'2014-03-02 06:03:21'),(15944,16593,'0000-00-00','ET','2',1,NULL,'Jess Bundy','FI','270887682','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:18',0,'2014-03-10 14:10:12'),(322,322,'2014-01-01','ET','2',2,1,'Thomas Johnston','FI','286466845','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:54',0,'2014-03-10 13:10:24'),(12828,12828,'2014-01-01','ET','2',1,NULL,'Tammy Perritt','FI','436438078','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:16',0,'2014-03-02 05:10:52'),(11410,11410,'2014-01-01','ET','2',1,NULL,'TERRY WALKER','FI','384561132','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:53',0,'2014-03-10 13:52:32'),(4620,4620,'2014-01-01','ET','2',4,3,'Said Nimr Ghneim','FI','446780204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:53',0,'2014-03-02 04:31:46'),(5693,5693,'2014-01-01','ET','2',1,NULL,'KRISTIN WILLIAMS','FI','390409412','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:11',0,'2014-03-01 15:37:30'),(10471,10471,'2014-01-01','ET','2',1,NULL,'ABBUL BOCKIE','FI','200780598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:52:58',0,'2014-03-01 16:10:36'),(2829,2829,'2014-01-01','ET','2',1,NULL,'Robert Goldstein','FI','125622712','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:21:16',0,'2014-03-02 04:15:49'),(11038,11038,'2014-01-01','ET','2',4,3,'Joanne Filina','FI','290603002','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:03',0,'2014-03-10 16:03:49'),(10724,10724,'2014-01-01','ET','2',1,NULL,'thomas provenzale','FI','279621516','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:26',0,'2014-03-01 16:10:36'),(17955,18605,'0000-00-00','ET','2',1,NULL,'VERSIAL FREEMAN','FI','497900086','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:07',0,'2014-03-01 17:20:55'),(18221,18871,'0000-00-00','ET','2',1,NULL,'Josephine Ricciardi','FI','302642476','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:10',0,'2014-03-10 16:31:33'),(19732,20382,'0000-00-00','ET','2',2,1,'Melissa Irby','FI','226660459','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:37:57',0,'2014-03-10 14:37:47'),(10525,10525,'2014-01-01','ET','2',1,NULL,'Jessica valenzuela','FI','625202977','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:39',0,'2014-03-02 04:24:47'),(7759,7759,'2014-01-01','ET','2',2,1,'Kimberly Martinez','FI','465996714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:10',0,'2014-03-01 19:11:03'),(12255,12255,'2014-01-01','ET','2',1,NULL,'juan depina','FI','592474676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:37',0,'2014-03-02 05:03:29'),(1292,1292,'2014-01-01','ET','2',1,NULL,'Rudy Gonzales','FI','595091713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:33',0,'2014-03-02 04:38:08'),(6114,6114,'2014-01-01','ET','2',2,1,'Hoang Rowe','FI','284720024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:43',0,'2014-03-01 16:00:27'),(2038,2038,'2014-01-01','ET','2',1,NULL,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:36:03',0,'2014-03-02 00:10:48'),(1774,1774,'2014-01-01','ET','2',1,NULL,'freda nielsen','FI','439339808','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:44',0,'2014-03-02 00:10:48'),(7000,7000,'2014-01-01','ET','2',2,1,'Yolanda  Garza','FI','457439070','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:28',0,'2014-03-02 02:10:49'),(17696,18346,'0000-00-00','ET','2',1,NULL,'Monnie Pilgrim','FI','450882470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-08 19:30:05',0,'2014-03-02 06:31:45'),(20777,21427,'0000-00-00','ET','2',1,NULL,'Daniel J DePaul','FI','299523322','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:47',0,'2014-03-10 16:38:05'),(12023,12023,'2014-01-01','ET','2',1,NULL,'YVETTE A YOUNG','FI','434172304','Starmount Life Insurance Company','FI','720977315','JOHN T LLEN','94','4728680','348','2014-02-01','Sync Success',0,'2014-01-01 12:02:57',0,'2014-03-02 04:59:36'),(16730,17380,'0000-00-00','ET','2',1,NULL,'Thomas Mathew','FI','275928045','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:38',0,'2014-03-10 14:20:26'),(16067,16716,'0000-00-00','ET','2',1,NULL,'NORMA HALLER','FI','299584057','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:53',0,'2014-03-01 16:56:22'),(611,611,'2014-01-01','ET','2',2,1,'Bryan Hoffman','FI','513927737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:56',0,'2014-03-02 02:10:49'),(1516,1516,'2014-01-01','ET','2',1,NULL,'Kristi Gooch','FI','294820789','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 18:57:54',0,'2014-03-10 13:45:57'),(12944,12944,'2014-01-01','ET','2',2,1,'Soan Pham','FI','621500471','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-05 00:00:07',0,'2014-03-02 05:17:40'),(14594,15045,'2014-01-01','ET','2',2,1,'RUBEN LOPEZ','FI','628091011','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:46',0,'2014-03-02 05:45:37'),(13103,13459,'2014-01-01','ET','2',1,NULL,'nancy rangel','FI','449992783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:07',0,'2014-03-02 05:17:40'),(21790,22440,'0000-00-00','ET','2',1,NULL,'Kimberly Russ','FI','284845422','Dental Care Plus, Inc.','FI','311185262','Joseph F Turi','94','2258764','348','2014-04-01','Sync Success',0,'2014-03-04 21:30:09',0,'2014-03-04 21:36:30'),(12366,12366,'2014-01-01','ET','2',1,NULL,'Aarin M Ulanowski','FI','631585179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:27',0,'2014-03-02 05:03:29'),(15938,16587,'0000-00-00','ET','2',2,1,'John Pasternack','FI','301568418','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:15',0,'2014-03-01 16:56:22'),(1200,1200,'2014-01-01','ET','2',1,NULL,'MICHAEL WHATLEY','FI','216764647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:45',0,'2014-03-02 04:38:08'),(2037,2037,'2014-01-01','ET','2',1,NULL,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:36:02',0,'2014-03-02 00:10:48'),(13811,14167,'2014-01-01','ET','2',1,NULL,'LEAH POPOLIZIO','FI','073764455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:17',0,'2014-03-01 16:40:16'),(13405,13761,'2014-01-01','ET','2',1,NULL,'Lauren Powers','FI','274503859','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:57',0,'2014-03-10 13:59:38'),(13323,13679,'2014-01-01','ET','2',1,NULL,'Thomas Aurelia','FI','165440298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:21',0,'2014-03-02 05:24:45'),(2122,2122,'2014-01-01','ET','2',1,NULL,'Zachary Douglas','FI','300040454','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:35',0,'2014-03-01 15:16:37'),(12507,12507,'2014-01-01','ET','2',1,NULL,'CHARMAN LANDIX','FI','434906339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:39',0,'2014-03-02 05:03:29'),(5035,5035,'2014-01-01','ET','2',1,NULL,'James Meyer','FI','301745286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:06',0,'2014-03-01 15:31:33'),(19396,20046,'0000-00-00','ET','2',1,NULL,'MARIA V HAYES','FI','276663666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:05',0,'2014-03-01 17:34:07'),(19813,20463,'0000-00-00','ET','2',1,NULL,'MARIA GUERRA','FI','464844828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:33',0,'2014-03-02 07:03:25'),(20812,21462,'0000-00-00','ET','2',1,NULL,'FRANKIE FLORES','FI','453913735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:31:05',0,'2014-03-02 07:17:36'),(1414,1414,'2014-01-01','ET','2',1,NULL,'Michelle Gregg','FI','275865317','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:31',0,'2014-03-10 13:45:57'),(1431,1431,'2014-01-01','ET','2',1,NULL,'Floyd Smith','FI','284708879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:06',0,'2014-03-01 16:15:39'),(2432,2432,'2014-01-01','ET','2',1,NULL,'karen hasley','FI','369543857','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:14',0,'2014-03-10 15:45:56'),(2515,2515,'2014-01-01','ET','2',1,0,'Elizabeth Maurer','FI','291885461','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:28',0,'2014-03-01 15:05:09'),(14972,15423,'2014-01-01','ET','2',1,NULL,'Gina Buccino','FI','302480988','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:59',0,'2014-03-01 16:50:53'),(14807,15258,'2014-01-01','ET','2',1,NULL,'CHARLES KANDIKO','FI','295447483','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:02',0,'2014-03-10 16:17:47'),(6194,6194,'2014-01-01','ET','2',1,NULL,'Deidra Campbell','FI','455576941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:08',0,'2014-03-02 04:10:25'),(15927,16576,'0000-00-00','ET','2',2,1,'Nicholas Givens','FI','229861188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:09',0,'2014-03-01 16:56:22'),(5779,5779,'2014-01-01','ET','2',1,NULL,'Anthony DePaolo','FI','179443983','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:53',0,'2014-03-10 15:52:36'),(5114,5114,'2014-01-01','ET','2',1,NULL,'Amy Thorton','FI','299722733','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:41',0,'2014-03-10 15:45:56'),(14973,15424,'2014-01-01','ET','2',1,NULL,'Maria Burton','FI','284867046','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:59',0,'2014-03-01 16:50:53'),(142,142,'2014-01-01','ET','2',4,3,'Constance Anderholm','FI','281582360','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:23',0,'2014-03-10 15:45:56'),(1318,1318,'2014-01-01','ET','2',2,1,'Terry Carmona Leija','FI','467176752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:23',0,'2014-03-02 04:38:08'),(2238,2238,'2014-01-01','ET','2',4,3,'Jeffrey Toth','FI','269783194','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:28',0,'2014-03-10 15:39:19'),(22216,22866,'0000-00-00','ET','2',1,NULL,'MARILYN BARTON','FI','289505672','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:51',0,'2014-03-06 21:36:23'),(22895,23545,'0000-00-00','ET','2',4,3,'Ann Tepperman','FI','269905197','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:35',0,'2014-03-10 21:36:25'),(1936,1936,'2014-01-01','ET','2',1,NULL,'CALVIN MCINTYRE','FI','295484719','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:49',0,'2014-03-01 15:26:40'),(19954,20604,'0000-00-00','ET','2',1,NULL,'DONYA R SMITH','FI','465573699','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-21 22:00:18',0,'2014-03-02 07:03:25'),(11984,11984,'2014-01-01','ET','2',1,NULL,'RAQUEL MELESIO','FI','593098006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:31',0,'2014-03-02 05:03:29'),(15322,15773,'0000-00-00','ET','2',1,NULL,'ashraf haddad','FI','606901230','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:31',0,'2014-03-01 16:50:53'),(19088,19738,'0000-00-00','ET','2',1,NULL,'ROBIN SANFILLIPO','FI','287586641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:35',0,'2014-03-01 17:34:07'),(18995,19645,'0000-00-00','ET','2',1,NULL,'ALBERT SPOERR','FI','296507478','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:10',0,'2014-03-10 14:31:05'),(15883,16532,'0000-00-00','ET','2',3,2,'Sikander Aziz','FI','635923204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:01',0,'2014-03-02 06:03:21'),(21791,22441,'0000-00-00','ET','2',1,NULL,'Micheal Kitcko','FI','274547166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:10',0,'2014-03-04 21:36:30'),(21922,22572,'0000-00-00','ET','2',2,1,'jessica trevino','94','0000277951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:57',0,'2014-03-05 22:27:33'),(5958,5958,'2014-01-01','ET','2',2,1,'Bryan Hoffman','FI','513927737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:35',0,'2014-03-02 01:10:33'),(709,709,'2014-01-01','ET','2',2,1,'Jared Schumann','FI','290789203','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:01',0,'2014-03-10 13:24:34'),(20185,20835,'0000-00-00','ET','2',2,1,'LASANDRA BOWERS','FI','460439056','Starmount Life Insurance Company','FI','720977315','SHAY   DAVIS','94','16149610','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:19',0,'2014-03-02 07:10:28'),(4292,4292,'2014-01-01','ET','2',1,NULL,'Gregory Flaherty','FI','280486783','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:04',0,'2014-03-10 13:32:15'),(3985,3985,'2014-01-01','ET','2',2,1,'Zachary Harmon','FI','268903408','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:43',0,'2014-03-10 13:10:24'),(19010,19660,'0000-00-00','ET','2',1,NULL,'Amy Cherry','FI','307069952','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:22',0,'2014-03-10 14:31:05'),(3689,3689,'2014-01-01','ET','2',1,NULL,'Cecily Wilson','FI','301868777','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:09',0,'2014-03-10 13:20:27'),(10552,10552,'2014-01-01','ET','2',1,NULL,'Michael Campbell','FI','360487198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:36',0,'2014-03-02 04:24:47'),(16172,16821,'0000-00-00','ET','2',1,NULL,'DEANNA BLACKSTONE','FI','571041950','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:21',0,'2014-03-01 16:56:22'),(15675,16324,'0000-00-00','ET','2',2,1,'CRISTINA JASSO LOZOYA','FI','525080289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:31',0,'2014-03-02 05:59:43'),(12025,12025,'2014-01-01','ET','2',1,NULL,'Jennifer Young','FI','436088352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:01',0,'2014-03-02 04:59:36'),(14600,15051,'2014-01-01','ET','2',2,1,'RAYMOND ROBINSON','FI','272728965','Dental Care Plus, Inc.','FI','311185262','Benson  Jones','94','7890601','348','2014-02-01','Sync Success',0,'2014-01-16 08:44:50',0,'2014-03-01 16:46:19'),(13431,13787,'2014-01-01','ET','2',2,1,'Kimberly Reedy','FI','280605119','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:05',0,'2014-03-01 16:40:16'),(21661,22311,'0000-00-00','ET','2',1,NULL,'YOLANDA JOHNSON','FI','386545519','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:06',0,'2014-03-04 21:36:30'),(22585,23235,'0000-00-00','ET','2',1,NULL,'Scott Joseph Salem','FI','302861947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:11',0,'2014-03-10 14:50:59'),(39,39,'2014-01-01','ET','2',1,NULL,'Gwyn A Montgomery','FI','274542411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:09',0,'2014-03-01 15:26:40'),(21188,21838,'0000-00-00','ET','2',2,1,'debra hughes','FI','268729954','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:50',0,'2014-03-10 14:45:25'),(19494,20144,'0000-00-00','ET','2',1,NULL,'ALVIN JOHNSON','FI','298486212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:02:12',0,'2014-03-10 16:31:33'),(17189,17839,'0000-00-00','ET','2',1,NULL,'BETTY BROCKMAN','FI','278662080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-05 21:00:03',0,'2014-03-01 17:20:55'),(16470,17120,'0000-00-00','ET','2',1,NULL,'Renee Chiles','FI','301561082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:18',0,'2014-03-01 17:00:58'),(219,219,'2014-01-01','ET','2',2,1,'Frank Caprilla','FI','274807371','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:56',0,'2014-03-10 13:10:24'),(15660,16309,'0000-00-00','ET','2',1,NULL,'Janet Keyser','FI','286585986','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:20',0,'2014-03-01 16:56:22'),(13863,14219,'2014-01-01','ET','2',2,1,'TOMMY BREWSTER','FI','438192298','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:57',0,'2014-03-02 05:31:31'),(1510,1510,'2014-01-01','ET','2',2,1,'Christian Triola','FI','285869618','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:41',0,'2014-03-10 16:03:49'),(10971,10971,'2014-01-01','ET','2',1,NULL,'Susan Sweeney','FI','404820528','HealthSpan','FI','311431434','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-26 13:09:46',0,'2014-03-10 13:45:57'),(2529,2529,'2014-01-01','ET','2',1,NULL,'felicia bennett','FI','461435990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:53',0,'2014-03-01 20:10:57'),(4407,4407,'2014-01-01','ET','2',2,1,'gabriel ramos','FI','460061875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:11',0,'2014-03-01 21:11:04'),(21511,22161,'0000-00-00','ET','2',1,NULL,'Daisy D Perez','FI','525714500','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:03',0,'2014-03-03 22:26:43'),(22541,23191,'0000-00-00','ET','2',1,NULL,'TAMARA WILLIAMS','FI','274866334','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:39',0,'2014-03-07 21:36:32'),(715,715,'2014-01-01','ET','2',1,NULL,'george quaintance','FI','281502296','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:15',0,'2014-03-10 13:24:34'),(1156,1156,'2014-01-01','ET','2',1,NULL,'beverly robertson','FI','437866989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:23',0,'2014-03-02 04:38:08'),(1890,1890,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:31:29',0,'2014-03-01 23:10:52'),(19816,20466,'0000-00-00','ET','2',1,NULL,'Deanna Swoboda','FI','460877072','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:36',0,'2014-03-02 07:03:25'),(3243,3243,'2014-01-01','ET','2',1,NULL,'Ronald Hatcher','FI','264909079','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:39',0,'2014-03-01 15:52:44'),(17595,18245,'0000-00-00','ET','2',1,NULL,'Rita Crooks','FI','275626979','HealthSpan','FI','311431434','Laura A Lanter','94','4684889','348','2014-03-01','Sync Success',0,'2014-02-07 19:01:09',0,'2014-03-10 14:24:38'),(14131,14582,'2014-01-01','ET','2',1,NULL,'Nathan Philson','FI','439534169','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:55',0,'2014-03-02 05:38:34'),(21487,22137,'0000-00-00','ET','2',1,NULL,'NORMA DANIELS','FI','362581904','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:46',0,'2014-03-03 21:36:16'),(7272,7272,'2014-01-01','ET','2',1,NULL,'GLORIA M HOOVER','FI','295601706','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:08:52',0,'2014-03-10 13:32:15'),(11132,11132,'2014-01-01','ET','2',1,NULL,'Nicole Taylor','FI','283846655','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:15:16',0,'2014-03-10 13:45:57'),(11915,11915,'2014-01-01','ET','2',1,NULL,'Mark Thompson','FI','290748003','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:29',0,'2014-03-01 16:30:17'),(13198,13554,'2014-01-01','ET','2',1,NULL,'JANICE LYNN BARNHART','FI','269526310','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:41',0,'2014-03-10 13:59:38'),(14662,15113,'2014-01-01','ET','2',1,NULL,'Angela Wiley','FI','277763788','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:29',0,'2014-03-01 16:46:19'),(22115,22765,'0000-00-00','ET','2',1,NULL,'TUYEN TRAN','94','0000761226','Starmount Life Insurance Company','FI','720977315','becky  nguyen','94','16221499','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:40',0,'2014-03-06 21:27:26'),(1582,1582,'2014-01-01','ET','2',1,NULL,'Jennifer Dolejs','FI','284809660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:42',0,'2014-03-01 15:10:22'),(6078,6078,'2014-01-01','ET','2',1,NULL,'Eric Spackey','FI','295628681','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:39',0,'2014-03-01 16:00:27'),(19850,20500,'0000-00-00','ET','2',2,1,'Jennifer Ellzey','FI','437355870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:04',0,'2014-03-02 07:03:25'),(2804,2804,'2014-01-01','ET','2',1,NULL,'Audrey Renee Belcher','FI','290702462','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:28',0,'2014-03-01 16:05:34'),(17379,18029,'0000-00-00','ET','2',1,NULL,'Michele Arias','FI','451711700','Starmount Life Insurance Company','FI','720977315','Diana  Everman','94','1231764','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:27',0,'2014-03-02 06:31:45'),(14366,14817,'2014-01-01','ET','2',1,NULL,'SUSAN SURGEN','FI','268521650','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:52',0,'2014-03-10 16:17:47'),(14345,14796,'2014-01-01','ET','2',1,NULL,'Clarissa Perez','FI','637163134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:43',0,'2014-03-02 05:45:37'),(5181,5181,'2014-01-01','ET','2',2,1,'Chi Kwong','FI','632586952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:45',0,'2014-03-02 00:10:48'),(3959,3959,'2014-01-01','ET','2',4,3,'Chana Miller','FI','424086243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:51',0,'2014-03-01 15:26:40'),(10705,10705,'2014-01-01','ET','2',1,NULL,'Rhonda Kay Collier','FI','279663565','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:43',0,'2014-03-01 16:10:36'),(541,541,'2014-01-01','ET','2',1,NULL,'AMY NANGLE','FI','269781914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:43',0,'2014-03-01 15:48:04'),(18783,19433,'0000-00-00','ET','2',1,NULL,'Julie Hartten','FI','271700677','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:54',0,'2014-03-10 14:31:05'),(18135,18785,'0000-00-00','ET','2',1,NULL,'Rebecca Alcala','FI','436732230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:04',0,'2014-03-02 06:38:05'),(2090,2090,'2014-01-01','ET','2',1,NULL,'Mamie Ball','FI','289528806','HealthSpan','FI','311431434','Brenda  Williams','94','8389118','348','2014-01-01','Sync Success',0,'2013-12-25 19:37:43',0,'2014-03-10 13:20:27'),(16650,17300,'0000-00-00','ET','2',1,NULL,'Jessica Reeves','FI','439553922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:41',0,'2014-03-02 06:17:30'),(6319,6319,'2014-01-01','ET','2',1,NULL,'ross dille','FI','300685310','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:58',0,'2014-03-10 15:59:47'),(2695,2695,'2014-01-01','ET','2',1,NULL,'Shannon Wallschlaeger','FI','453893706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:01',0,'2014-03-02 04:15:49'),(13984,14340,'2014-01-01','ET','2',1,NULL,'AARON LOZIER','FI','451518850','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:19',0,'2014-03-02 05:31:31'),(13954,14310,'2014-01-01','ET','2',2,1,'Theresa Terrell','FI','270607817','HealthSpan','FI','311431434','Stephen  Saenz','94','10572730','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:37',0,'2014-03-10 14:03:26'),(4408,4408,'2014-01-01','ET','2',1,NULL,'madelynn nichole menchhofer','FI','291085952','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:13',0,'2014-03-10 13:03:33'),(21699,22349,'0000-00-00','ET','2',1,NULL,'angelica mejia','FI','436657202','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:38',0,'2014-03-04 21:27:16'),(23075,23725,'0000-00-00','ET','2',1,NULL,'Jacquelyn Ruberg','FI','288562938','HealthSpan','FI','311431434','Rose  Shiels','94','8398250','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:48',0,'2014-03-10 21:17:52'),(50,50,'2014-01-01','ET','2',1,NULL,'MARTHA RITTERBACH','FI','286746846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:30',0,'2014-03-01 15:21:15'),(21151,21801,'0000-00-00','ET','2',1,NULL,'MARILYN GRAY','FI','435319925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:21',0,'2014-03-02 07:23:39'),(6297,6297,'2014-01-01','ET','2',1,NULL,'Aundre Howard','FI','276805489','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:07:20',0,'2014-03-10 13:39:10'),(20382,21032,'0000-00-00','ET','2',1,NULL,'ivonne cooper','FI','269985507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:11',0,'2014-03-10 14:37:47'),(20221,20871,'0000-00-00','ET','2',1,NULL,'Harriet James','FI','153622735','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:47',0,'2014-03-02 07:10:28'),(2318,2318,'2014-01-01','ET','2',1,NULL,'marvin ramsey','FI','438829757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:50',0,'2014-03-01 19:11:03'),(19107,19757,'0000-00-00','ET','2',1,NULL,'Fadi Al Baff','FI','297150377','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:49',0,'2014-03-10 14:31:05'),(17291,17941,'0000-00-00','ET','2',1,NULL,'Patricia Benit-Laing','FI','437418857','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:50',0,'2014-03-02 06:24:38'),(16870,17520,'0000-00-00','ET','2',2,1,'Joshua King','FI','466993241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:08',0,'2014-03-02 06:17:30'),(16655,17305,'0000-00-00','ET','2',1,NULL,'MATTHEW SPECK','FI','298828020','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:44',0,'2014-03-10 16:24:30'),(16423,17073,'0000-00-00','ET','2',1,NULL,'DAVID ANDRA','FI','272520568','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:41',0,'2014-03-10 14:20:26'),(2913,2913,'2014-01-01','ET','2',1,NULL,'Jacqueline Cain','FI','427061768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:21',0,'2014-03-02 01:10:33'),(4951,4951,'2014-01-01','ET','2',1,NULL,'kim scott','FI','434458127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:51',0,'2014-03-01 20:10:57'),(15091,15542,'0000-00-00','ET','2',4,3,'gary post','FI','404767264','Dental Care Plus, Inc.','FI','311185262','mark  kofalt','94','1713316','348','2014-03-01','Sync Success',0,'2014-01-20 08:05:42',0,'2014-03-01 16:50:53'),(14861,15312,'2014-01-01','ET','2',1,NULL,'David Penrod','FI','612038279','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:35:06',0,'2014-03-02 05:52:31'),(12016,12016,'2014-01-01','ET','2',2,1,'brandon smith','FI','439653756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:41',0,'2014-03-02 04:59:36'),(2556,2556,'2014-01-01','ET','2',2,1,'Arianna Deadwyler','FI','286766035','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:46',0,'2014-03-10 13:03:33'),(19480,20130,'0000-00-00','ET','2',1,NULL,'Brenda Jakubowski','FI','430211733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:57:45',0,'2014-03-02 06:59:07'),(18658,19308,'0000-00-00','ET','2',1,NULL,'cedrick johnson','FI','450372806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:20',0,'2014-03-02 06:45:14'),(15410,15861,'0000-00-00','ET','2',1,NULL,'Erik Little','FI','425111819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2014-01-22 03:22:16',0,'2014-03-02 05:59:43'),(14755,15206,'2014-01-01','ET','2',1,NULL,'IAN SANDERSON','FI','278805813','Summa Insurance Company, Inc.','FI','341809108','DEANNA M WELLS','94','7827930','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:28',0,'2014-03-10 16:17:47'),(13927,14283,'2014-01-01','ET','2',1,NULL,'Kathryn Ann Cadle','FI','296468956','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:17',0,'2014-03-02 05:31:31'),(3823,3823,'2014-01-01','ET','2',2,1,'Joan Drake','FI','381485881','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:10',0,'2014-03-10 13:10:24'),(3934,3934,'2014-01-01','ET','2',1,NULL,'Tammy Lindsey','FI','439191733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:03',0,'2014-03-01 23:10:52'),(2732,2732,'2014-01-01','ET','2',1,NULL,'Oscar Alberto Canales','FI','632301122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:12',0,'2014-03-02 04:15:49'),(3397,3397,'2014-01-01','ET','2',2,1,'John Whitman','FI','292422936','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:34',0,'2014-03-10 15:52:36'),(4296,4296,'2014-01-01','ET','2',1,NULL,'Divante Morton','FI','282986831','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:13',0,'2014-03-10 13:32:15'),(1692,1692,'2014-01-01','ET','2',1,NULL,'MELISSA HOWANIK','FI','298884196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:15',0,'2014-03-01 15:31:33'),(21226,21876,'0000-00-00','ET','2',2,1,'Mark Polhemus','FI','467377176','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:14',0,'2014-03-02 07:23:39'),(21078,21728,'0000-00-00','ET','2',1,NULL,'MARGARET FAYE TENNEY','FI','527156984','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:32',0,'2014-03-01 18:10:11'),(13531,13887,'2014-01-01','ET','2',1,NULL,'Stephen Fout','FI','283863666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:37',0,'2014-03-01 16:40:16'),(14292,14743,'2014-01-01','ET','2',2,1,'Miranda  Mcbeath','FI','317984481','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:20',0,'2014-03-01 16:46:19'),(14041,14397,'2014-01-01','ET','2',1,NULL,'TIFFANY MCLEOD','FI','437838729','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:02:01',0,'2014-03-02 05:31:31'),(2507,2507,'2014-01-01','ET','2',1,0,'adam pesek','FI','269747521','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:16',0,'2014-03-01 15:05:09'),(1670,1670,'2014-01-01','ET','2',1,NULL,'Janice Jernigan','FI','435430034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:15:33',0,'2014-03-02 00:10:48'),(10388,10388,'2014-01-01','ET','2',1,NULL,'Matthew Hritz','FI','288608946','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:22',0,'2014-03-01 16:10:36'),(18876,19526,'0000-00-00','ET','2',1,NULL,'Lucas Dillingham','FI','380086485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:45',0,'2014-03-01 17:34:07'),(2537,2537,'2014-01-01','ET','2',1,NULL,'Anita Abrams','FI','298583401','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:07',0,'2014-03-01 15:10:22'),(15846,16495,'0000-00-00','ET','2',1,NULL,'MELODY J JACKSON','FI','284668834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:38',0,'2014-03-01 16:56:22'),(2654,2654,'2014-01-01','ET','2',4,3,'Geoffrey Lowell','FI','299626430','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:31',0,'2014-03-01 16:05:34'),(3056,3056,'2014-01-01','ET','2',1,NULL,'Max Burkhart','FI','289903512','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:49',0,'2014-03-01 15:37:30'),(3828,3828,'2014-01-01','ET','2',2,1,'Stephen Miller','FI','299480176','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:22',0,'2014-03-10 13:20:27'),(7642,7642,'2014-01-01','ET','2',1,NULL,'Valerie Renee Reichardt','FI','437790329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:36',0,'2014-03-02 04:15:49'),(21928,22578,'0000-00-00','ET','2',2,1,'nicandro delfin','FI','462978646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:02',0,'2014-03-05 22:27:33'),(1309,1309,'2014-01-01','ET','2',1,NULL,'Osiel Cantu','FI','457456140','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:06',0,'2014-03-02 04:38:08'),(4454,4454,'2014-01-01','ET','2',1,NULL,'Derik Stadtler','FI','276886831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:34',0,'2014-03-01 15:16:37'),(2336,2336,'2014-01-01','ET','2',4,3,'Jay Bodzin','FI','294788989','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:12',0,'2014-03-10 15:45:56'),(15180,15631,'0000-00-00','ET','2',1,NULL,'Ollie Jones','FI','426271773','Starmount Life Insurance Company','FI','720977315','Bennie  Hudson','94','10034374','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:12',0,'2014-03-02 05:52:31'),(12575,12575,'2014-01-01','ET','2',1,NULL,'Thomas Ivans','FI','276905592','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:09',0,'2014-03-01 16:35:14'),(12920,12920,'2014-01-01','ET','2',1,NULL,'Paula A Murphy','FI','298481187','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:38',0,'2014-03-10 16:10:34'),(803,803,'2014-01-01','ET','2',1,NULL,'NITAYA Y MCDONALD','FI','301782994','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:10:17',0,'2014-03-10 15:39:19'),(16471,17121,'0000-00-00','ET','2',1,NULL,'Richard Prevost','FI','309087246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:19',0,'2014-03-02 06:10:30'),(13486,13842,'2014-01-01','ET','2',1,NULL,'carolyn green','FI','562577152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:06',0,'2014-03-02 05:24:45'),(13058,13414,'2014-01-01','ET','2',1,NULL,'Charntel Baty','FI','439331803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:23',0,'2014-03-02 05:17:40'),(224,224,'2014-01-01','ET','2',1,0,'Chung Aun','FI','299789341','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:02',0,'2014-03-01 15:05:09'),(14346,14797,'2014-01-01','ET','2',1,NULL,'Gary Frame','FI','312561249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:43',0,'2014-03-02 05:45:37'),(18250,18900,'0000-00-00','ET','2',3,2,'Rosemary Alt','FI','281622498','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:36',0,'2014-03-10 14:24:38'),(22612,23262,'0000-00-00','ET','2',1,NULL,'MARCO ANTONIO CANALES','FI','453711394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:00:03',0,'2014-03-08 22:26:18'),(3508,3508,'2014-01-01','ET','2',1,NULL,'WILLIAM JORDAN','FI','293668659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:28',0,'2014-03-01 15:37:30'),(21786,22436,'0000-00-00','ET','2',4,3,'TEGAN STITT','FI','270781226','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:07',0,'2014-03-04 21:36:30'),(21237,21887,'0000-00-00','ET','2',5,4,'Mary Gonzalez','FI','294808191','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:21',0,'2014-03-10 14:45:25'),(18638,19288,'0000-00-00','ET','2',1,NULL,'MAUREEN DENNISON','FI','295485332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:04',0,'2014-03-01 17:26:36'),(14793,15244,'2014-01-01','ET','2',2,1,'WILLIAM MARTIN GILBERT','FI','237792681','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:53',0,'2014-03-02 05:45:37'),(12280,12280,'2014-01-01','ET','2',1,NULL,'Kathy Stubbs','FI','301480759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:32',0,'2014-03-01 16:35:14'),(17785,18435,'0000-00-00','ET','2',1,NULL,'BARBARA  RICHARDSON','FI','298562677','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:21',0,'2014-03-01 17:00:58'),(5130,5130,'2014-01-01','ET','2',1,NULL,'Beth Smith','FI','298740760','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:14',0,'2014-03-10 15:45:56'),(15785,16434,'0000-00-00','ET','2',1,NULL,'Herlinda Velazquez','FI','642236381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:03',0,'2014-03-02 06:03:21'),(1429,1429,'2014-01-01','ET','2',1,NULL,'Kara Ayers','FI','295863047','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:00',0,'2014-03-10 13:52:32'),(19898,20548,'0000-00-00','ET','2',1,NULL,'Koviljka  Vegara','FI','731098091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-21 21:30:04',0,'2014-03-01 17:47:19'),(940,940,'2014-01-01','ET','2',1,NULL,'Teresa Hooker','FI','437173686','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:22',0,'2014-03-01 22:10:55'),(3767,3767,'2014-01-01','ET','2',1,NULL,'Debora Young','FI','465040207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:14',0,'2014-03-01 23:10:52'),(17079,17729,'0000-00-00','ET','2',1,NULL,'Tracy Taylor','FI','461898639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:47',0,'2014-03-02 06:24:38'),(4007,4007,'2014-01-01','ET','2',1,NULL,'Nada Herbly','FI','436759462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:00:21',0,'2014-03-02 03:09:49'),(16259,16908,'0000-00-00','ET','2',1,NULL,'Gregory Vrabel','FI','293482050','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:18',0,'2014-03-10 16:24:30'),(16250,16899,'0000-00-00','ET','2',1,NULL,'August Hartman','FI','360803832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:13',0,'2014-03-10 14:20:26'),(15937,16586,'0000-00-00','ET','2',1,NULL,'LINDA MILLER','FI','297563914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:15',0,'2014-03-01 16:56:22'),(6406,6406,'2014-01-01','ET','2',1,NULL,'Jonathan Wooton','FI','295941336','HealthSpan','FI','311431434','Kevin  Schlotman','94','1427172','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:41',0,'2014-03-10 13:39:10'),(745,745,'2014-01-01','ET','2',1,NULL,'Cynthia Herring','FI','401867665','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:11',0,'2014-03-10 13:24:34'),(22619,23269,'0000-00-00','ET','2',1,NULL,'Kathleen Ann Lewis','FI','302501326','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-08 21:00:07',0,'2014-03-10 14:50:59'),(22872,23522,'0000-00-00','ET','2',1,NULL,'sara gonzalez','FI','641308241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:18',0,'2014-03-10 21:27:11'),(1708,1708,'2014-01-01','ET','2',1,NULL,'travis thomas','FI','437497329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:45',0,'2014-03-02 00:10:48'),(21393,22043,'0000-00-00','ET','2',1,NULL,'susan hinkle','FI','294700974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:06',0,'2014-03-03 21:36:16'),(7748,7748,'2014-01-01','ET','2',1,NULL,'Floyd Smith','FI','284708879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:47',0,'2014-03-01 15:05:09'),(2028,2028,'2014-01-01','ET','2',1,NULL,'CAROLYN A ELZY','FI','437967601','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:45',0,'2014-03-01 23:10:52'),(18932,19582,'0000-00-00','ET','2',2,1,'Janet  Cunningham','FI','299888147','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:24',0,'2014-03-10 16:31:33'),(17876,18526,'0000-00-00','ET','2',1,NULL,'Nicholas Bianco','FI','282826399','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:12',0,'2014-03-10 16:31:33'),(15629,16080,'0000-00-00','ET','2',1,NULL,'helena lisle','FI','288580586','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:50',0,'2014-03-10 16:24:30'),(14616,15067,'2014-01-01','ET','2',1,NULL,'Kimberely Elliott','FI','300681216','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:00',0,'2014-03-01 16:46:19'),(13914,14270,'2014-01-01','ET','2',1,NULL,'Amanda Jones','FI','288909909','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:10',0,'2014-03-01 16:40:16'),(12349,12349,'2014-01-01','ET','2',1,NULL,'melissa Taylor','FI','452437196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:52',0,'2014-03-02 05:03:29'),(3470,3470,'2014-01-01','ET','2',1,NULL,'MURRAY L MATZA','FI','286620794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:14',0,'2014-03-01 15:31:33'),(3517,3517,'2014-01-01','ET','2',1,NULL,'SALLY  MONCOL','FI','285461289','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:01:44',0,'2014-03-01 15:37:30'),(7423,7423,'2014-01-01','ET','2',1,NULL,'Scott Thomas Walter','FI','506177467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:36',0,'2014-03-02 04:15:49'),(6243,6243,'2014-01-01','ET','2',1,NULL,'Kenneth Barker','FI','298547552','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:43',0,'2014-03-10 13:32:15'),(10488,10488,'2014-01-01','ET','2',1,NULL,'Carole Niedzialkowski','FI','318905271','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:31',0,'2014-03-01 16:10:36'),(19346,19996,'0000-00-00','ET','2',1,NULL,'LORI SENEGAL','FI','437137784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:30',0,'2014-03-02 06:59:07'),(17649,18299,'0000-00-00','ET','2',1,NULL,'Elizabeth Dugas','FI','295720925','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:34',0,'2014-03-10 16:24:30'),(17360,18010,'0000-00-00','ET','2',1,NULL,'Alonna Smiles','FI','454210308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:15',0,'2014-03-02 06:31:45'),(5040,5040,'2014-01-01','ET','2',1,NULL,'Teresa Williams','FI','300821956','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:15',0,'2014-03-01 15:31:33'),(17255,17905,'0000-00-00','ET','2',1,NULL,'Susan Smith','FI','288508649','Dental Care Plus, Inc.','FI','311185262','Deanna M Wells','94','7827930','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:34',0,'2014-03-01 17:20:55'),(3278,3278,'2014-01-01','ET','2',1,NULL,'Elsa Decker','FI','456670358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:45',0,'2014-03-02 02:10:49'),(12042,12042,'2014-01-01','ET','2',1,NULL,'Cynthia R Walker','FI','435214087','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:41',0,'2014-03-02 05:03:29'),(14824,15275,'2014-01-01','ET','2',2,1,'GEOFFREY OKUMU','FI','284116122','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:14',0,'2014-03-10 14:03:26'),(14021,14377,'2014-01-01','ET','2',1,NULL,'SUSAN KNABE','FI','284522839','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:46',0,'2014-03-10 16:17:47'),(13308,13664,'2014-01-01','ET','2',1,NULL,'Kristine Woolery','FI','099423273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:16',0,'2014-03-01 16:40:16'),(22647,23297,'0000-00-00','ET','2',2,1,'Mohammed Soliman','FI','634235292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:18',0,'2014-03-08 22:26:18'),(22873,23523,'0000-00-00','ET','2',1,NULL,'HAYDER NASER','FI','681204100','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:19',0,'2014-03-10 21:27:11'),(3340,3340,'2014-01-01','ET','2',1,NULL,'victor harrison','FI','449088498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:51',0,'2014-03-02 02:10:49'),(6356,6356,'2014-01-01','ET','2',1,NULL,'WILLIE j JOHNSON','FI','302345312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:05',0,'2014-03-02 04:10:25'),(12512,12512,'2014-01-01','ET','2',1,NULL,'DENNIS DAQUIN','FI','427236315','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:33:49',0,'2014-03-02 05:03:29'),(20959,21609,'0000-00-00','ET','2',1,NULL,'BRENDA FRANCO','FI','643506225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 07:30:12',0,'2014-03-02 07:17:36'),(19093,19743,'0000-00-00','ET','2',1,NULL,'Michael Jacques','FI','294905189','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:38',0,'2014-03-01 17:34:07'),(12883,12883,'2014-01-01','ET','2',2,1,'Theodore J Armstrong','FI','274687243','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:17',0,'2014-03-01 16:35:14'),(17365,18015,'0000-00-00','ET','2',1,NULL,'melissa griffith','FI','449844226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:00:18',0,'2014-03-02 06:24:38'),(16886,17536,'0000-00-00','ET','2',1,NULL,'Gayle Kline','FI','454115884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:18',0,'2014-03-02 06:24:38'),(475,475,'2014-01-01','ET','2',1,NULL,'Wesley Frazier','FI','278880085','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:50',0,'2014-03-10 13:10:24'),(21579,22229,'0000-00-00','ET','2',1,NULL,'bradley chinni','FI','294666177','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:54',0,'2014-03-10 14:45:25'),(1242,1242,'2014-01-01','ET','2',1,NULL,'Gary D Weaver','FI','460984313','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:48:59',0,'2014-03-01 16:15:39'),(18259,18909,'0000-00-00','ET','2',1,NULL,'Cindy Lilly','FI','270581499','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:45',0,'2014-03-10 14:24:38'),(15216,15667,'0000-00-00','ET','2',2,1,'DAVID HEHOLT','FI','561456452','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:37',0,'2014-03-02 05:52:31'),(6999,6999,'2014-01-01','ET','2',2,1,'JOSE  DE SANTIAGO','FI','635807448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:25',0,'2014-03-02 02:10:49'),(13981,14337,'2014-01-01','ET','2',1,NULL,'Carlene Norman','FI','450969537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:16',0,'2014-03-02 05:31:31'),(727,727,'2014-01-01','ET','2',1,NULL,'Marti Stephens','FI','428393946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:40',0,'2014-03-02 02:10:49'),(3192,3192,'2014-01-01','ET','2',1,NULL,'Nicholas Cioffi','FI','231433728','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:05',0,'2014-03-01 15:48:04'),(1337,1337,'2014-01-01','ET','2',1,NULL,'LUSSY ARICEAGA','FI','627260919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:59',0,'2014-03-02 04:38:08'),(370,370,'2014-01-01','ET','2',5,4,'jason smith','FI','281781963','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:23',0,'2014-03-01 15:21:15'),(7048,7048,'2014-01-01','ET','2',1,NULL,'Karen Kinnibrugh','FI','454154455','Starmount Life Insurance Company','FI','720977315','Danielle   Kunkle','94','8341406','357','2014-01-01','Sync Success',0,'2013-12-26 04:01:59',0,'2014-03-02 03:09:49'),(20081,20731,'0000-00-00','ET','2',2,1,'SARAH KING','FI','435272293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:03',0,'2014-03-02 07:10:28'),(16421,17071,'0000-00-00','ET','2',2,1,'Jennifer Rodriguez','FI','300865596','HealthSpan','FI','311431434','Gregory B Burch','94','2776783','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:40',0,'2014-03-10 14:20:26'),(16434,17084,'0000-00-00','ET','2',1,NULL,'MARSHA KILONSKY','FI','279528293','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:48',0,'2014-03-10 14:20:26'),(17462,18112,'0000-00-00','ET','2',3,2,'BARRY BERLIN','FI','161468985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:25',0,'2014-03-02 06:31:45'),(17169,17819,'0000-00-00','ET','2',1,NULL,'SUSAN BEASLEY','FI','509568325','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:01:45',0,'2014-03-01 17:20:55'),(16517,17167,'0000-00-00','ET','2',1,NULL,'JOSE A INIZARRY GARCIA','FI','596124829','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:48',0,'2014-03-02 06:10:30'),(1250,1250,'2014-01-01','ET','2',1,NULL,'sherrie jones','FI','271660205','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:11',0,'2014-03-01 16:15:39'),(6144,6144,'2014-01-01','ET','2',1,NULL,'LISA  SMITH','FI','287680105','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:37',0,'2014-03-01 16:00:27'),(3556,3556,'2014-01-01','ET','2',2,1,'mark foster','FI','272725875','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:00',0,'2014-03-01 15:37:30'),(20105,20755,'0000-00-00','ET','2',1,NULL,'CASSADEE BUSBY','FI','438799059','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:24',0,'2014-03-02 07:10:28'),(19859,20509,'0000-00-00','ET','2',1,NULL,'Vernon Stacy','FI','406844295','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-04-01','Sync Success',0,'2014-02-20 22:01:10',0,'2014-03-10 14:37:47'),(10756,10756,'2014-01-01','ET','2',1,NULL,'SOAD WOODI','FI','050684619','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:28',0,'2014-03-01 16:15:39'),(17238,17888,'0000-00-00','ET','2',1,NULL,'Jason Broadwater','FI','292927734','Summa Insurance Company, Inc.','FI','341809108','Sherri  Smith','94','7930515','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:25',0,'2014-03-10 16:24:30'),(18529,19179,'0000-00-00','ET','2',3,2,'Brandon Procaccini','FI','300768858','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:31',0,'2014-03-10 14:31:05'),(14253,14704,'2014-01-01','ET','2',2,1,'EVELYN  AGBO','FI','782365805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:04',0,'2014-03-01 16:46:19'),(22010,22660,'0000-00-00','ET','2',1,NULL,'MARJORIE PIERCE-GIST','FI','123465824','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:59',0,'2014-03-05 21:36:22'),(20366,21016,'0000-00-00','ET','2',1,NULL,'richard townend','FI','275785548','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 08:30:52',0,'2014-03-10 14:37:47'),(17062,17712,'0000-00-00','ET','2',1,NULL,'Olga Fuentes','FI','467512521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:37',0,'2014-03-02 06:24:38'),(6112,6112,'2014-01-01','ET','2',1,NULL,'Edward Adams','FI','281660730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:40',0,'2014-03-01 16:00:27'),(12427,12427,'2014-01-01','ET','2',1,NULL,'MONICA STEWART','FI','439494946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:39',0,'2014-03-02 05:03:29'),(15786,16435,'0000-00-00','ET','2',2,1,'Francisco Castillo','FI','450130004','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:03',0,'2014-03-02 06:03:21'),(16826,17476,'0000-00-00','ET','2',1,NULL,'Benjamin Whaley','FI','438497600','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:10',0,'2014-03-02 06:17:30'),(18888,19538,'0000-00-00','ET','2',1,NULL,'Sharon Turner','FI','435574760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:53',0,'2014-03-02 06:52:12'),(21391,22041,'0000-00-00','ET','2',1,NULL,'Rodney Gay','FI','273589879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:05',0,'2014-03-03 21:36:16'),(21871,22521,'0000-00-00','ET','2',4,3,'David Stinson','FI','273882678','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:21',0,'2014-03-05 21:36:22'),(10496,10496,'2014-01-01','ET','2',2,1,'Patrick Culliton','FI','283886351','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:45',0,'2014-03-01 16:15:39'),(10851,10851,'2014-01-01','ET','2',4,3,'Tara Behrmann','FI','273863081','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:33',0,'2014-03-10 13:39:10'),(20223,20873,'0000-00-00','ET','2',1,NULL,'BERNICE CRUMB','FI','412927518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:48',0,'2014-03-02 07:10:28'),(11703,11703,'2014-01-01','ET','2',1,NULL,'GERALD DAY','FI','452048358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:59',0,'2014-03-02 04:59:36'),(11704,11704,'2014-01-01','ET','2',1,NULL,'Terri McWhorter','FI','453351364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:00',0,'2014-03-02 04:59:36'),(12650,12650,'2014-01-01','ET','2',1,NULL,'Twander M Collins','FI','436171518','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:56',0,'2014-03-02 05:10:52'),(12869,12869,'2014-01-01','ET','2',1,NULL,'JOSEPH LENGEL','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:03:47',0,'2014-03-01 16:35:14'),(21992,22642,'0000-00-00','ET','2',4,3,'DANIJEL DOBRIJEVIC','FI','288047353','Summa Insurance Company, Inc.','FI','341809108','JARED  BOLOGNA','94','8927566','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:47',0,'2014-03-10 16:44:18'),(22535,23185,'0000-00-00','ET','2',1,NULL,'MOHINDER ARORA','FI','277084166','Dental Care Plus, Inc.','FI','311185262','UDAY  PATIL','94','16477715','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:36',0,'2014-03-07 21:36:32'),(2424,2424,'2014-01-01','ET','2',1,NULL,'Robert DeCastro','FI','282806020','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 20:18:01',0,'2014-03-10 15:45:56'),(5683,5683,'2014-01-01','ET','2',1,NULL,'James Quincy','FI','365804561','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:34',0,'2014-03-10 13:52:32'),(14406,14857,'2014-01-01','ET','2',1,NULL,'jessica johanan','FI','281861507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:09',0,'2014-03-01 16:46:19'),(7765,7765,'2014-01-01','ET','2',1,NULL,'Dustin Bodenmiller','FI','278849762','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:21',0,'2014-03-10 13:03:33'),(17791,18441,'0000-00-00','ET','2',1,NULL,'Peter Shanes','FI','290545881','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:26',0,'2014-03-01 16:50:53'),(17286,17936,'0000-00-00','ET','2',2,1,'sukhjinder khosa','FI','568775981','HealthSpan','FI','311431434','sarat c bhola','94','2441270','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:48',0,'2014-03-10 14:24:38'),(16137,16786,'0000-00-00','ET','2',1,NULL,'Cindy Bechstein','FI','290522109','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:01:47',0,'2014-03-10 14:20:26'),(12943,12943,'2014-01-01','ET','2',1,NULL,'Shannon Everitt','FI','515669773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:05',0,'2014-03-02 05:17:40'),(2799,2799,'2014-01-01','ET','2',1,NULL,'Patrick Carney','FI','302841783','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:19',0,'2014-03-01 16:05:34'),(5013,5013,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:46:24',0,'2014-03-01 15:31:33'),(11610,11610,'2014-01-01','ET','2',1,NULL,'Christopher McCulley','FI','293863089','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:02',0,'2014-03-10 16:03:49'),(7636,7636,'2014-01-01','ET','2',1,NULL,'Regina Luttrell','FI','490547936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:38:24',0,'2014-03-02 04:15:49'),(20757,21407,'0000-00-00','ET','2',1,NULL,'CAROL JANE BAILEY','FI','295548982','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:38',0,'2014-03-01 18:08:07'),(7601,7601,'2014-01-01','ET','2',1,NULL,'Zachary Vadim Allred','FI','275985947','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:19',0,'2014-03-10 15:59:47'),(18653,19303,'0000-00-00','ET','2',1,NULL,'KEWAN WOODARD','FI','462438133','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:16',0,'2014-03-02 06:45:14'),(18035,18685,'0000-00-00','ET','2',2,1,'KENNETH ALBERS','FI','285569858','HealthSpan','FI','311431434','BRAIN  ALBERS','94','2825035','348','2014-03-01','Sync Success',0,'2014-02-10 21:32:03',0,'2014-03-10 14:24:38'),(6239,6239,'2014-01-01','ET','2',1,NULL,'charlotte vickery','FI','289621670','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:05:35',0,'2014-03-10 13:32:15'),(16324,16974,'0000-00-00','ET','2',1,NULL,'VANESSA JONES','FI','290705633','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:00:38',0,'2014-03-01 17:00:58'),(1450,1450,'2014-01-01','ET','2',2,1,'John Brown','FI','232944690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:43',0,'2014-03-01 16:15:39'),(10732,10732,'2014-01-01','ET','2',1,NULL,'Brandon adkins','FI','296928732','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:01:41',0,'2014-03-01 16:10:36'),(13512,13868,'2014-01-01','ET','2',2,1,'rose flores','FI','460195315','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:24',0,'2014-03-02 05:31:31'),(11200,11200,'2014-01-01','ET','2',1,NULL,'ryan creamer','FI','284843745','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:26',0,'2014-03-01 16:23:43'),(21560,22210,'0000-00-00','ET','2',1,NULL,'Crystal Van Calsem','FI','435539978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:39',0,'2014-03-03 22:26:43'),(5634,5634,'2014-01-01','ET','2',2,1,'Susan Teeter','FI','180560240','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:49',0,'2014-03-10 13:52:32'),(19958,20608,'0000-00-00','ET','2',1,NULL,'Tanya Austin','FI','450515671','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:22',0,'2014-03-02 07:03:25'),(19144,19794,'0000-00-00','ET','2',1,NULL,'BRANDON LEE GRABSKI','FI','277929035','Summa Insurance Company, Inc.','FI','341809108','JAMES A FINNEGIN','94','2766031','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:17',0,'2014-03-10 16:31:33'),(19087,19737,'0000-00-00','ET','2',1,NULL,'SHEILA KAUTZ','FI','271768770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:34',0,'2014-03-01 17:34:07'),(19008,19658,'0000-00-00','ET','2',1,NULL,'JANELLE MAY','FI','300906256','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:32:21',0,'2014-03-10 14:31:05'),(18786,19436,'0000-00-00','ET','2',1,NULL,'JUDY TODD','FI','403748372','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:56',0,'2014-03-10 14:31:05'),(15770,16419,'0000-00-00','ET','2',1,NULL,'Gregory Mealka','FI','293645432','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:35',0,'2014-03-10 16:24:30'),(14033,14389,'2014-01-01','ET','2',1,NULL,'rhonda gray','FI','428119329','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:54',0,'2014-03-02 05:31:31'),(1038,1038,'2014-01-01','ET','2',1,NULL,'RICK  LEWIS','FI','286587343','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:28',0,'2014-03-10 13:10:24'),(5261,5261,'2014-01-01','ET','2',1,NULL,'Traci Fravel','FI','275829489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:04',0,'2014-03-01 15:10:22'),(1040,1040,'2014-01-01','ET','2',1,NULL,'cierra wolfelt','94','0000437941','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:32',0,'2014-03-10 13:10:24'),(4638,4638,'2014-01-01','ET','2',1,NULL,'Maria Cantu','FI','464066446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:30',0,'2014-03-02 04:31:46'),(4052,4052,'2014-01-01','ET','2',2,1,'Zafar Khan','FI','455894459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:45',0,'2014-03-02 04:10:25'),(21399,22049,'0000-00-00','ET','2',1,NULL,'anna Bradford','FI','435533621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:10',0,'2014-03-03 21:25:18'),(21254,21904,'0000-00-00','ET','2',1,NULL,'Thomas Reding','FI','069749798','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:33',0,'2014-03-01 21:35:40'),(4960,4960,'2014-01-01','ET','2',1,0,'Julian Cooper','FI','272805902','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:32:11',0,'2014-03-01 15:05:09'),(5042,5042,'2014-01-01','ET','2',1,NULL,'ronald saxton','FI','269749402','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:18',0,'2014-03-01 15:31:33'),(15683,16332,'0000-00-00','ET','2',1,NULL,'Logan Boyd','FI','456950946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:37',0,'2014-03-02 05:59:43'),(11517,11517,'2014-01-01','ET','2',1,NULL,'Monte Shalett','FI','437510088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:09',0,'2014-03-02 04:52:44'),(12154,12154,'2014-01-01','ET','2',1,NULL,'Mary Lewis','FI','587325459','Starmount Life Insurance Company','FI','720977315','Edward  Hamlin','94','8136469','348','2014-02-01','Sync Success',0,'2014-01-01 12:07:37',0,'2014-03-02 05:03:29'),(11958,11958,'2014-01-01','ET','2',1,NULL,'Anna Grant','FI','461080261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:31',0,'2014-03-02 04:59:36'),(22031,22681,'0000-00-00','ET','2',1,NULL,'EDWARD NEWELL','FI','564113473','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:15',0,'2014-03-05 22:27:33'),(2963,2963,'2014-01-01','ET','2',1,NULL,'WENDI PORCHE','FI','275800816','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:00',0,'2014-03-01 15:37:30'),(21686,22336,'0000-00-00','ET','2',4,3,'Carolyn MacNeel','FI','273602277','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:27',0,'2014-03-04 21:36:30'),(11978,11978,'2014-01-01','ET','2',1,NULL,'Guadalupe Arguellez','FI','461988339','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:17',0,'2014-03-02 05:03:29'),(15172,15623,'0000-00-00','ET','2',1,NULL,'kATHRYN HUDSON','FI','439733220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:43',0,'2014-03-02 05:52:31'),(18933,19583,'0000-00-00','ET','2',2,1,'Allen McAdoo','FI','271589568','Summa Insurance Company, Inc.','FI','341809108','David  Auble','94','7083348','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:25',0,'2014-03-10 16:31:33'),(17776,18426,'0000-00-00','ET','2',1,NULL,'Billy J Clary','FI','454376582','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:14',0,'2014-03-02 05:52:31'),(15863,16512,'0000-00-00','ET','2',1,NULL,'Hing Chan','FI','067705112','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:49',0,'2014-03-10 16:24:30'),(22508,23158,'0000-00-00','ET','2',2,1,'Jeanea Bandi','FI','436982746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:16',0,'2014-03-07 22:26:59'),(3745,3745,'2014-01-01','ET','2',1,NULL,'Elissa Schmidt','FI','296869262','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 22:09:02',0,'2014-03-10 13:24:34'),(14023,14379,'2014-01-01','ET','2',1,NULL,'Tiffany Baldwin','FI','295885603','Summa Insurance Company, Inc.','FI','341809108','John  Reynolds','94','97302','348','2014-02-01','Sync Success',0,'2014-01-13 03:01:47',0,'2014-03-10 16:17:47'),(20792,21442,'0000-00-00','ET','2',2,1,'EMILY M ULM','FI','268888705','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:55',0,'2014-03-10 16:38:05'),(18341,18991,'0000-00-00','ET','2',1,NULL,'Lawren mccandless','FI','167602850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:20',0,'2014-03-01 17:26:36'),(17510,18160,'0000-00-00','ET','2',1,NULL,'Catherine Flores','FI','629222758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:07',0,'2014-03-02 06:31:45'),(14433,14884,'2014-01-01','ET','2',1,NULL,'Brandy Percival','FI','434534815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:23',0,'2014-03-02 05:38:34'),(16340,16990,'0000-00-00','ET','2',1,NULL,'HABIBA NABIL','FI','577412064','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:48',0,'2014-03-01 16:56:22'),(19611,20261,'0000-00-00','ET','2',1,NULL,'joe george','FI','302529474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:16',0,'2014-03-01 17:34:07'),(22754,23404,'0000-00-00','ET','2',2,1,'hoai dinh dang','FI','733092526','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:15',0,'2014-03-09 21:26:00'),(253,253,'2014-01-01','ET','2',1,NULL,'karan edmondson','FI','219848613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:58',0,'2014-03-01 20:10:57'),(21845,22495,'0000-00-00','ET','2',1,NULL,'CRELISE BAKER','FI','433772384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:03',0,'2014-03-05 22:27:33'),(21580,22230,'0000-00-00','ET','2',2,1,'kenneth starr','FI','204481848','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:54',0,'2014-03-10 14:45:25'),(10702,10702,'2014-01-01','ET','2',1,NULL,'Daniel Kozdron','FI','290842085','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:37',0,'2014-03-01 16:10:36'),(21195,21845,'0000-00-00','ET','2',5,4,'Kyle Supe','FI','396882505','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:55',0,'2014-03-10 14:45:25'),(19587,20237,'0000-00-00','ET','2',1,NULL,'Shelly Murphree','FI','459813320','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:29:10',0,'2014-03-02 06:59:07'),(17650,18300,'0000-00-00','ET','2',1,NULL,'Charles Michael','FI','452893414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:35',0,'2014-03-02 06:31:45'),(427,427,'2014-01-01','ET','2',2,1,'erica CRAWFORD','FI','274762484','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:15',0,'2014-03-01 15:21:15'),(6336,6336,'2014-01-01','ET','2',1,NULL,'Rajendra Patel','FI','634288713','Starmount Life Insurance Company','FI','720977315','Vikesh  Amin','94','15297691','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:29',0,'2014-03-02 04:10:25'),(13107,13463,'2014-01-01','ET','2',1,NULL,'allen najvar','FI','456825854','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:16',0,'2014-03-02 05:17:40'),(2840,2840,'2014-01-01','ET','2',1,NULL,'Judy Mcnicol','FI','385543949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:40',0,'2014-03-02 04:15:49'),(161,161,'2014-01-01','ET','2',1,NULL,'Rebecca Custer','FI','295623896','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:59',0,'2014-03-10 13:10:24'),(22241,22891,'0000-00-00','ET','2',1,NULL,'Theresa Sheets','FI','270646210','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:09',0,'2014-03-10 14:45:25'),(21704,22354,'0000-00-00','ET','2',1,NULL,'NICOLE TAYLOR','FI','433538897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:42',0,'2014-03-04 21:27:16'),(20408,21058,'0000-00-00','ET','2',1,NULL,'Danielle Polk','FI','436297610','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-03-31','Sync Success',0,'2014-02-26 09:30:34',0,'2014-03-02 07:10:28'),(19627,20277,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:37:23',0,'2014-03-01 17:47:19'),(10701,10701,'2014-01-01','ET','2',1,NULL,'David L Davis','FI','279567349','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:35',0,'2014-03-01 16:10:36'),(10426,10426,'2014-01-01','ET','2',2,1,'Tenaya Erica Bolin-Devore','FI','302725611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:29',0,'2014-03-01 16:10:36'),(12456,12456,'2014-01-01','ET','2',1,NULL,'Anton Martin Pilz','FI','273586316','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:43',0,'2014-03-10 16:10:34'),(396,396,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:16',0,'2014-03-01 22:10:55'),(11787,11787,'2014-01-01','ET','2',1,NULL,'Alondra Yasmine Contreras','FI','634383688','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:45',0,'2014-03-02 04:31:46'),(11252,11252,'2014-01-01','ET','2',2,1,'Juan Pacheco','FI','625163166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:02',0,'2014-03-01 16:23:43'),(949,949,'2014-01-01','ET','2',1,NULL,'Grace London','FI','435023656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:37',0,'2014-03-01 22:10:55'),(4367,4367,'2014-01-01','ET','2',1,NULL,'Ruth Huntington','FI','298486074','HealthSpan','FI','311431434','Frank  Jarome','94','16102908','348','2014-01-01','Sync Success',0,'2013-12-25 23:11:20',0,'2014-03-10 13:32:15'),(3493,3493,'2014-01-01','ET','2',1,NULL,'TeArria Robinson','FI','298807730','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:58',0,'2014-03-01 15:37:30'),(22361,23011,'0000-00-00','ET','2',1,NULL,'Amy Scott','FI','280586611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:16',0,'2014-03-07 21:36:32'),(23059,23709,'0000-00-00','ET','2',1,NULL,'james zachman','FI','276489983','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:34',0,'2014-03-10 21:17:52'),(1195,1195,'2014-01-01','ET','2',1,NULL,'Maria Fasano','FI','490824404','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:36',0,'2014-03-02 04:45:37'),(22279,22929,'0000-00-00','ET','2',1,NULL,'ELIZABETH MCCRAY GILL','FI','297447910','HealthSpan','FI','311431434','CHARLES  LURIE','94','519183','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:37',0,'2014-03-10 14:45:25'),(20334,20984,'0000-00-00','ET','2',1,NULL,'JAMES L GILL','FI','294489398','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:23',0,'2014-03-01 17:47:19'),(19266,19916,'0000-00-00','ET','2',1,NULL,'Jessica Schittone','FI','437378364','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:10',0,'2014-03-02 06:52:12'),(1444,1444,'2014-01-01','ET','2',1,NULL,'tuan diep','FI','084769983','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:55:31',0,'2014-03-01 16:15:39'),(17034,17684,'0000-00-00','ET','2',1,NULL,'Francis Huete','FI','243571642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:20',0,'2014-03-02 06:24:38'),(3117,3117,'2014-01-01','ET','2',1,NULL,'Stephen Piesciuk','FI','066469661','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:36:42',0,'2014-03-10 15:52:36'),(16668,17318,'0000-00-00','ET','2',1,NULL,'LEAH POPOLIZIO','FI','073764455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:53',0,'2014-03-01 17:00:58'),(6257,6257,'2014-01-01','ET','2',1,NULL,'David Eidelman','FI','183680438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:08',0,'2014-03-02 04:10:25'),(21162,21812,'0000-00-00','ET','2',4,3,'Linda Canizales','FI','455986627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:29',0,'2014-03-02 07:23:39'),(22606,23256,'0000-00-00','ET','2',1,NULL,'David BRYERS','FI','287706380','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-07 21:32:28',0,'2014-03-10 14:50:59'),(14238,14689,'2014-01-01','ET','2',1,NULL,'RANDALL WILLIAMS','FI','587347829','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:57',0,'2014-03-02 05:38:34'),(13728,14084,'2014-01-01','ET','2',2,1,'Henry Adams','94','0001953610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:59',0,'2014-03-02 05:24:45'),(18559,19209,'0000-00-00','ET','2',1,NULL,'erica nicholas','FI','437113894','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:16',0,'2014-03-02 06:45:14'),(18377,19027,'0000-00-00','ET','2',1,NULL,'Phat Nguyen','FI','433953340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:44',0,'2014-03-02 06:45:14'),(13464,13820,'2014-01-01','ET','2',1,NULL,'Jean Warren','FI','292524851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:18:29',0,'2014-03-01 16:40:16'),(15754,16403,'0000-00-00','ET','2',3,2,'willie perkins','FI','408157183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:24',0,'2014-03-02 05:59:43'),(10959,10959,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:27',0,'2014-03-10 16:03:49'),(7743,7743,'2014-01-01','ET','2',1,NULL,'paul waldorf','FI','189560822','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:38',0,'2014-03-01 15:05:09'),(7664,7664,'2014-01-01','ET','2',1,NULL,'Linda Stout','FI','295528686','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:39:18',0,'2014-03-10 13:39:10'),(6084,6084,'2014-01-01','ET','2',1,NULL,'GEORGE OSEI','FI','247279212','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:51',0,'2014-03-01 16:00:27'),(5648,5648,'2014-01-01','ET','2',2,1,'Bart Sharkey','FI','287840139','HealthSpan','FI','311431434','Jerry  Michael','94','2827056','348','2014-01-01','Sync Success',0,'2013-12-26 01:51:15',0,'2014-03-10 13:52:32'),(4214,4214,'2014-01-01','ET','2',1,NULL,'BRENDA SUE MYERS','FI','297749659','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:39',0,'2014-03-01 15:52:44'),(21213,21863,'0000-00-00','ET','2',1,NULL,'Heather Platz-Rosenow','FI','274667346','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-03-01 19:00:11',0,'2014-03-10 16:38:05'),(21915,22565,'0000-00-00','ET','2',1,NULL,'SERGIO PEREZ','FI','644032982','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:54',0,'2014-03-05 22:27:33'),(1203,1203,'2014-01-01','ET','2',2,1,'William Johnson','FI','283668931','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:52',0,'2014-03-10 13:45:57'),(14650,15101,'2014-01-01','ET','2',1,NULL,'Kimberly Knautz','FI','289806621','Dental Care Plus, Inc.','FI','311185262','Kathleen  Robinson','94','16929249','348','2014-02-01','Sync Success',0,'2014-01-16 08:45:21',0,'2014-03-01 16:46:19'),(13960,14316,'2014-01-01','ET','2',1,NULL,'Frances S Orzechowski','FI','282489336','HealthSpan','FI','311431434','Dennis  Tucker','94','1780702','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:41',0,'2014-03-10 14:03:26'),(12337,12337,'2014-01-01','ET','2',1,NULL,'zainab fazalbhoy','FI','633489758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:27:29',0,'2014-03-02 05:03:29'),(17021,17671,'0000-00-00','ET','2',1,NULL,'SHELLEY C DURAN','FI','437679594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:12',0,'2014-03-02 06:24:38'),(16803,17453,'0000-00-00','ET','2',1,NULL,'Dori Riddle','FI','261570140','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:43',0,'2014-03-10 16:24:30'),(16740,17390,'0000-00-00','ET','2',1,NULL,'Terri Coleman','FI','293584958','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-01 19:00:03',0,'2014-03-10 14:20:26'),(2565,2565,'2014-01-01','ET','2',1,NULL,'Christina Dell Hawkins','FI','427491788','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:05',0,'2014-03-10 13:03:33'),(5500,5500,'2014-01-01','ET','2',1,NULL,'Matthew Ashby','FI','289883711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:25',0,'2014-03-01 16:23:43'),(21833,22483,'0000-00-00','ET','2',3,2,'Samantha Sarli','FI','271847454','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:25',0,'2014-03-05 21:36:22'),(11631,11631,'2014-01-01','ET','2',1,NULL,'GLORIA JACKSON','FI','433276884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:42',0,'2014-03-02 04:52:44'),(20639,21289,'0000-00-00','ET','2',1,NULL,'Jessica Gonzalez','FI','467578407','Starmount Life Insurance Company','FI','720977315','Archer  Summers','94','16993399','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:16',0,'2014-03-02 07:17:36'),(7600,7600,'2014-01-01','ET','2',1,NULL,'Jordan Vaughan','FI','281962854','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:17',0,'2014-03-10 15:59:47'),(4733,4733,'2014-01-01','ET','2',3,2,'Larry Chambers','FI','300422183','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:52',0,'2014-03-10 13:45:57'),(5315,5315,'2014-01-01','ET','2',1,NULL,'jennifer bailey','FI','274785028','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:00',0,'2014-03-10 13:03:33'),(714,714,'2014-01-01','ET','2',1,NULL,'Laura M Berry','FI','302708225','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:07:14',0,'2014-03-10 13:24:34'),(20471,21121,'0000-00-00','ET','2',5,4,'TINA MIKLOS','FI','281825740','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:23',0,'2014-03-01 18:08:07'),(19754,20404,'0000-00-00','ET','2',1,NULL,'DIANE VAUGHT','FI','285648136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 21:30:09',0,'2014-03-01 17:47:19'),(14028,14384,'2014-01-01','ET','2',1,NULL,'Harold Edwards','FI','423767842','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:51',0,'2014-03-10 14:03:26'),(12210,12210,'2014-01-01','ET','2',2,1,'Richard Fournier','FI','286867034','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:52',0,'2014-03-01 16:35:14'),(3126,3126,'2014-01-01','ET','2',1,NULL,'Karla Moore','FI','296566731','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:37:00',0,'2014-03-10 13:24:34'),(2016,2016,'2014-01-01','ET','2',1,NULL,'Arthelma Thompson','FI','433821560','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:22',0,'2014-03-01 23:10:52'),(1959,1959,'2014-01-01','ET','2',1,NULL,'Bryan Dean Searfos','FI','284620267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:30',0,'2014-03-01 15:26:40'),(22484,23134,'0000-00-00','ET','2',1,NULL,'Patrick Lachtrupp','FI','284841090','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:59',0,'2014-03-07 21:36:32'),(22611,23261,'0000-00-00','ET','2',1,NULL,'MINOON YEUNG','FI','451392465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:02',0,'2014-03-08 21:25:11'),(446,446,'2014-01-01','ET','2',1,NULL,'Veniece Harris','FI','297921643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:51',0,'2014-03-10 15:45:56'),(3601,3601,'2014-01-01','ET','2',1,NULL,'Cindy Lou Rogers','FI','452379073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:22',0,'2014-03-02 01:10:33'),(2297,2297,'2014-01-01','ET','2',1,NULL,'sara lenczewski','FI','279907671','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:04',0,'2014-03-01 15:10:22'),(16555,17205,'0000-00-00','ET','2',1,NULL,'Shawna Hamm','FI','594481720','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:12',0,'2014-03-10 14:20:26'),(4448,4448,'2014-01-01','ET','2',1,NULL,'David Alicea','FI','581049759','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:22',0,'2014-03-01 15:16:37'),(3225,3225,'2014-01-01','ET','2',1,NULL,'DORIS TAYLOR','FI','281547441','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:05',0,'2014-03-01 15:52:44'),(5615,5615,'2014-01-01','ET','2',1,NULL,'Sabrina Nguyen','FI','273941972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:10',0,'2014-03-01 16:23:43'),(7384,7384,'2014-01-01','ET','2',2,1,'Marina Espinosa','FI','663206881','Starmount Life Insurance Company','FI','720977315','Denis  Sartain','94','1189245','348','2014-01-01','Sync Success',0,'2013-12-26 04:30:17',0,'2014-03-02 04:15:49'),(1375,1375,'2014-01-01','ET','2',1,NULL,'Crystal Rae McGee','FI','122720656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:53:12',0,'2014-03-02 04:38:08'),(18754,19404,'0000-00-00','ET','2',1,NULL,'Lolita Glass','FI','436239940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:32',0,'2014-03-02 06:45:14'),(21764,22414,'0000-00-00','ET','2',1,NULL,'Clayton Randolph','FI','280629828','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:32',0,'2014-03-10 14:45:25'),(22402,23052,'0000-00-00','ET','2',4,3,'Tyler Earl Cantrell','FI','286821936','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:36',0,'2014-03-10 14:50:59'),(14822,15273,'2014-01-01','ET','2',2,1,'Anthony Rotondo','FI','291421331','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:13',0,'2014-03-10 14:03:26'),(20523,21173,'0000-00-00','ET','2',1,NULL,'ROSE M WINBOURN','FI','447562739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:59',0,'2014-03-02 07:10:28'),(20326,20976,'0000-00-00','ET','2',1,NULL,'Sabrina Hicks','FI','642281974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:15',0,'2014-03-02 07:03:25'),(7052,7052,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:02:06',0,'2014-03-02 03:09:49'),(13409,13765,'2014-01-01','ET','2',2,1,'Mark Allen Weekley','FI','300441003','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:58',0,'2014-03-10 16:10:34'),(4879,4879,'2014-01-01','ET','2',1,NULL,'Aetna Buitron','FI','455132220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:35',0,'2014-03-01 20:10:57'),(4510,4510,'2014-01-01','ET','2',1,NULL,'Antwon D Whitaker','FI','291909508','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2013-12-25 23:32:23',NULL,NULL),(1683,1683,'2014-01-01','ET','2',1,NULL,'Katherine Schneeberger','FI','269925396','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:57',0,'2014-03-01 15:31:33'),(685,685,'2014-01-01','ET','2',1,NULL,'Joelle A Henrick','FI','097385435','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:15',0,'2014-03-10 15:52:36'),(3522,3522,'2014-01-01','ET','2',2,1,'Stephen Piesciuk','FI','066469661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:52',0,'2014-03-01 15:37:30'),(2747,2747,'2014-01-01','ET','2',1,NULL,'Patricia Ortiz','FI','557049685','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:39',0,'2014-03-02 04:15:49'),(21719,22369,'0000-00-00','ET','2',1,NULL,'rose thirdkill','FI','438232328','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:54',0,'2014-03-04 21:27:16'),(2340,2340,'2014-01-01','ET','2',2,1,'Robert Lyons','FI','298546591','Dental Care Plus, Inc.','FI','311185262','Stanley  Sieniawski','94','1766911','348','2014-01-01','Sync Success',0,'2013-12-25 20:15:23',0,'2014-03-01 15:26:40'),(19806,20456,'0000-00-00','ET','2',1,NULL,'Dianna Guntle','FI','456975868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:28',0,'2014-03-02 07:03:25'),(17226,17876,'0000-00-00','ET','2',1,NULL,'DIANN PRITT','FI','278723568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:19',0,'2014-03-01 17:20:55'),(12717,12717,'2014-01-01','ET','2',1,NULL,'Denise Jackson','FI','433066467','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-02-01','Sync Success',0,'2014-01-03 02:05:24',0,'2014-03-02 05:10:52'),(11812,11812,'2014-01-01','ET','2',1,NULL,'Larry Mckitrick','FI','292569438','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:26',0,'2014-03-01 16:15:39'),(3485,3485,'2014-01-01','ET','2',1,NULL,'WINIFRED WEAVER','FI','296867867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:42',0,'2014-03-01 15:37:30'),(5464,5464,'2014-01-01','ET','2',1,NULL,'BELINDA G CALAIS','FI','434960362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:18',0,'2014-03-02 04:45:37'),(13876,14232,'2014-01-01','ET','2',1,NULL,'william daniels','FI','292565626','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-13 02:24:05',0,'2014-03-10 14:03:26'),(2691,2691,'2014-01-01','ET','2',1,NULL,'Blake Kuhlman','FI','460119999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:54',0,'2014-03-02 04:15:49'),(4048,4048,'2014-01-01','ET','2',1,NULL,'Noel Naizer','FI','631031926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:38',0,'2014-03-02 03:09:49'),(20705,21355,'0000-00-00','ET','2',1,NULL,'Jacob Mattes','FI','299924952','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:30:14',0,'2014-03-10 16:38:05'),(17911,18561,'0000-00-00','ET','2',1,NULL,'Maria Barrera','FI','643765073','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:37',0,'2014-03-02 06:31:45'),(16845,17495,'0000-00-00','ET','2',1,NULL,'Joel Rush','FI','460045281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:21',0,'2014-03-02 06:17:30'),(4667,4667,'2014-01-01','ET','2',1,NULL,'Mallory Murphy','FI','295849282','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:27',0,'2014-03-01 16:15:39'),(2045,2045,'2014-01-01','ET','2',1,NULL,'WILLIAM KESSLER','FI','287540100','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:16',0,'2014-03-10 13:20:27'),(21615,22265,'0000-00-00','ET','2',1,NULL,'NORMA I LEAL','FI','555357917','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:00:33',0,'2014-03-04 21:27:16'),(829,829,'2014-01-01','ET','2',1,0,'Kyle Hufford','FI','280828653','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:11:18',0,'2014-03-01 15:05:09'),(21503,22153,'0000-00-00','ET','2',1,NULL,'Betty Fay Cooper','FI','403804852','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:57',0,'2014-03-03 21:36:16'),(20701,21351,'0000-00-00','ET','2',1,NULL,'Lonnie Jackson','FI','587227789','Starmount Life Insurance Company','FI','720977315','john T Allen','94','4728680','348','2014-04-01','Sync Success',0,'2014-02-28 06:30:13',0,'2014-03-02 07:17:36'),(3437,3437,'2014-01-01','ET','2',1,NULL,'susan kerr','FI','511847644','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:53',0,'2014-03-10 13:32:15'),(17547,18197,'0000-00-00','ET','2',1,NULL,'JULIA WHITE','FI','294708169','Summa Insurance Company, Inc.','FI','341809108','ROY  GULASA Jr','94','17055451','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:32',0,'2014-03-10 16:24:30'),(4455,4455,'2014-01-01','ET','2',4,3,'Robin Yohe','FI','286740927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:35',0,'2014-03-01 15:16:37'),(1300,1300,'2014-01-01','ET','2',1,NULL,'MarLisa Hamlett','FI','490949505','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:48',0,'2014-03-02 04:38:08'),(6233,6233,'2014-01-01','ET','2',1,NULL,'Kathryn Petzold','FI','073440198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:23',0,'2014-03-01 16:00:27'),(2098,2098,'2014-01-01','ET','2',1,NULL,'Steve McGarvey','FI','298884011','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:38:00',0,'2014-03-10 13:20:27'),(21821,22471,'0000-00-00','ET','2',1,NULL,'Carrie Moss','FI','455412208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:18',0,'2014-03-05 21:25:24'),(10575,10575,'2014-01-01','ET','2',1,NULL,'Dean Simmons','FI','552517893','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:23',0,'2014-03-02 04:24:47'),(21208,21858,'0000-00-00','ET','2',1,NULL,'MARK KERRY SUTTON','FI','268584664','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 19:00:08',0,'2014-03-10 14:45:25'),(1019,1019,'2014-01-01','ET','2',4,3,'Shalanda Allen','FI','439275515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:51',0,'2014-03-01 22:10:55'),(21122,21772,'0000-00-00','ET','2',1,NULL,'LAMARCUS JAMANE SCOTT','FI','456731066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:31:01',0,'2014-03-02 07:23:39'),(14762,15213,'2014-01-01','ET','2',4,3,'Rebecca Mohr','FI','287780031','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:33',0,'2014-03-10 14:03:26'),(13044,13400,'2014-01-01','ET','2',1,NULL,'Jean Warren','FI','292524851','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:55',0,'2014-03-01 16:35:14'),(10748,10748,'2014-01-01','ET','2',4,3,'Ish Rawal','FI','277083836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:09',0,'2014-03-01 16:10:36'),(2621,2621,'2014-01-01','ET','2',1,NULL,'susan fife','FI','592241985','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:37',0,'2014-03-01 15:16:37'),(7500,7500,'2014-01-01','ET','2',2,1,'Kristen Grande','FI','280841299','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:03',0,'2014-03-01 16:05:34'),(5326,5326,'2014-01-01','ET','2',1,NULL,'Barbara Ferrell','FI','294728924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:03',0,'2014-03-01 15:10:22'),(5330,5330,'2014-01-01','ET','2',1,NULL,'Lynn Johnston','FI','363086962','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:10',0,'2014-03-01 15:10:22'),(2557,2557,'2014-01-01','ET','2',1,NULL,'GAIL A CRUM','FI','288445818','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:49',0,'2014-03-10 13:03:33'),(22196,22846,'0000-00-00','ET','2',1,NULL,'JOYCELYN L MORRIS','FI','428713948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:37',0,'2014-03-06 21:27:26'),(12849,12849,'2014-01-01','ET','2',1,NULL,'CHERYL E LUMPKIN','FI','551020958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:01',0,'2014-03-02 05:17:40'),(11691,11691,'2014-01-01','ET','2',1,NULL,'CHERYL SUTTON','FI','453210591','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:39',0,'2014-03-02 04:59:36'),(2189,2189,'2014-01-01','ET','2',1,NULL,'Tucker Bailey','FI','627011925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:47',0,'2014-03-01 21:11:04'),(19580,20230,'0000-00-00','ET','2',4,3,'Rebecca Schulte','FI','294722750','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:26:22',0,'2014-03-10 14:37:47'),(17521,18171,'0000-00-00','ET','2',1,NULL,'ENEDINA SAUCEDA','FI','350484301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:15',0,'2014-03-02 06:31:45'),(4079,4079,'2014-01-01','ET','2',1,NULL,'Charles Rowland','FI','296620546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:39',0,'2014-03-01 16:00:27'),(16686,17336,'0000-00-00','ET','2',1,NULL,'JONAS G LAURENT','FI','433514184','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:06',0,'2014-03-02 06:17:30'),(16354,17004,'0000-00-00','ET','2',1,NULL,'Nika Tolber','FI','270704297','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:56',0,'2014-03-01 16:56:22'),(4483,4483,'2014-01-01','ET','2',1,NULL,'Manuel Rivera','FI','455920676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:29',0,'2014-03-01 21:11:04'),(14316,14767,'2014-01-01','ET','2',1,NULL,'robert krpoun','FI','502902017','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:31',0,'2014-03-02 05:38:34'),(355,355,'2014-01-01','ET','2',1,NULL,'Barbara Monroe','FI','295505878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:57',0,'2014-03-01 15:21:15'),(1882,1882,'2014-01-01','ET','2',1,NULL,'maria sandoval ore','FI','621189137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:18',0,'2014-03-01 23:10:52'),(1950,1950,'2014-01-01','ET','2',1,NULL,'Chasity Conner','FI','285963927','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:13',0,'2014-03-01 15:26:40'),(15213,15664,'0000-00-00','ET','2',1,NULL,'Bonnie Lynn Huster','FI','426318230','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:34',0,'2014-03-01 16:50:53'),(6189,6189,'2014-01-01','ET','2',1,NULL,'Nancy Carrillo','FI','453997743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:59',0,'2014-03-02 04:10:25'),(13519,13875,'2014-01-01','ET','2',1,NULL,'julie cottrell','FI','269649940','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:29',0,'2014-03-01 16:40:16'),(4844,4844,'2014-01-01','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:24',0,'2014-03-01 15:10:22'),(11965,11965,'2014-01-01','ET','2',1,NULL,'Gloria Moncivais','FI','454994548','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:46',0,'2014-03-02 04:59:36'),(20854,21504,'0000-00-00','ET','2',1,NULL,'KATHY Buggs','FI','439969207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:23',0,'2014-03-02 07:17:36'),(22252,22902,'0000-00-00','ET','2',2,1,'Donald Cutlip','FI','236803549','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:17',0,'2014-03-10 16:44:18'),(786,786,'2014-01-01','ET','2',1,NULL,'Deotis Dominic Hollaman','FI','288863588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:40',0,'2014-03-01 15:05:09'),(16727,17377,'0000-00-00','ET','2',1,NULL,'Bruce Lathon','FI','332508827','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:01:36',0,'2014-03-02 06:17:30'),(15244,15695,'0000-00-00','ET','2',1,NULL,'Trainett Sherman','FI','438337445','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:24',0,'2014-03-02 05:52:31'),(12216,12216,'2014-01-01','ET','2',1,NULL,'Nelson Hernandez','FI','584440365','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:04',0,'2014-03-01 16:35:14'),(20668,21318,'0000-00-00','ET','2',1,NULL,'Tiny Hall','FI','298560527','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-02-26 21:02:39',0,'2014-03-10 14:37:47'),(3968,3968,'2014-01-01','ET','2',2,1,'Mile Bozic','FI','281089487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:11',0,'2014-03-01 15:26:40'),(16218,16867,'0000-00-00','ET','2',1,NULL,'Betty Fragoso','FI','463986598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:00:52',0,'2014-03-02 06:10:30'),(4323,4323,'2014-01-01','ET','2',1,NULL,'INDRA CHAKRAVARTY','FI','535900359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:09:56',0,'2014-03-02 03:09:49'),(17535,18185,'0000-00-00','ET','2',1,NULL,'WILLIAM  B SMITH','FI','281848906','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:00:24',0,'2014-03-01 17:20:55'),(18861,19511,'0000-00-00','ET','2',1,NULL,'TIMOTHY SMITH','FI','289709537','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:33',0,'2014-03-01 17:34:07'),(21659,22309,'0000-00-00','ET','2',1,NULL,'Christine Rice','FI','298905674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:05',0,'2014-03-04 21:36:30'),(21950,22600,'0000-00-00','ET','2',2,1,'Danielle Prendergast','FI','437714014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:18',0,'2014-03-05 22:27:33'),(22351,23001,'0000-00-00','ET','2',1,NULL,'JANET JW SMITH','FI','412023145','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:12',0,'2014-03-07 21:36:32'),(665,665,'2014-01-01','ET','2',2,1,'Oliver Murphy','FI','449512358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:38',0,'2014-03-02 02:10:49'),(10761,10761,'2014-01-01','ET','2',1,NULL,'Katrina Frazier','FI','437390325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:38',0,'2014-03-02 04:15:49'),(1469,1469,'2014-01-01','ET','2',1,NULL,'John J Dugan','FI','222541784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:25',0,'2014-03-01 16:23:43'),(13841,14197,'2014-01-01','ET','2',1,NULL,'Ellen T Murphy','FI','466904200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:41',0,'2014-03-02 05:31:31'),(4345,4345,'2014-01-01','ET','2',1,NULL,'Pamela Schramm','FI','294621748','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 23:10:36',0,'2014-03-10 13:32:15'),(2373,2373,'2014-01-01','ET','2',1,NULL,'Rebecca Jean Lockhart','FI','282564018','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:27',0,'2014-03-01 15:26:40'),(3037,3037,'2014-01-01','ET','2',1,NULL,'Elena Krakora','FI','291640139','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:13',0,'2014-03-01 15:37:30'),(19139,19789,'0000-00-00','ET','2',1,NULL,'Ryan Williams','FI','276923551','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:13',0,'2014-03-10 14:31:05'),(19350,20000,'0000-00-00','ET','2',3,2,'MIRIAM MIDENCE','FI','434172450','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:33',0,'2014-03-02 06:59:07'),(1251,1251,'2014-01-01','ET','2',1,NULL,'Laurie Wright','FI','301763432','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:13',0,'2014-03-01 16:15:39'),(17257,17907,'0000-00-00','ET','2',1,NULL,'eva sanchez','FI','582839757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:35',0,'2014-03-02 06:24:38'),(16859,17509,'0000-00-00','ET','2',1,NULL,'Joann Corbett','FI','297685261','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-02 19:00:31',0,'2014-03-10 14:20:26'),(1359,1359,'2014-01-01','ET','2',1,NULL,'Melinda Thomas','FI','467986155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:43',0,'2014-03-02 04:38:08'),(4297,4297,'2014-01-01','ET','2',1,NULL,'Timothy Feehan','94','0000840504','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:14',0,'2014-03-10 13:32:15'),(15814,16463,'0000-00-00','ET','2',1,NULL,'Crystal Chaffin','FI','459291450','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','348','2014-03-01','Sync Success',0,'2014-01-24 21:00:19',0,'2014-03-02 06:03:21'),(2056,2056,'2014-01-01','ET','2',2,1,'Kim Schilling','FI','279703918','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:37',0,'2014-03-10 15:45:56'),(2561,2561,'2014-01-01','ET','2',1,NULL,'PEGGY S CALLEGARI','FI','439906217','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:57',0,'2014-03-01 20:10:57'),(18539,19189,'0000-00-00','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:07',0,'2014-03-10 16:31:33'),(18575,19225,'0000-00-00','ET','2',1,NULL,'Hannah Janine Smith','94','0000359726','Dental Care Plus, Inc.','FI','311185262','Sarah  Bean','94','10334323','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:13',0,'2014-03-01 17:26:36'),(7029,7029,'2014-01-01','ET','2',2,1,'Patricia Liles','FI','461394226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:23',0,'2014-03-02 03:09:49'),(17269,17919,'0000-00-00','ET','2',1,NULL,'Kenneth Pete','FI','462273230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:40',0,'2014-03-02 06:24:38'),(6354,6354,'2014-01-01','ET','2',2,1,'Roger Williamson','FI','545869018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:01',0,'2014-03-02 04:10:25'),(14922,15373,'2014-01-01','ET','2',3,2,'Gina Marcello-Johnson','FI','289703001','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:34',0,'2014-03-01 16:50:53'),(18345,18995,'0000-00-00','ET','2',1,NULL,'Susan Baudoin','FI','439043594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:22',0,'2014-03-02 06:45:14'),(18570,19220,'0000-00-00','ET','2',3,2,'David Moore','FI','077461424','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:09',0,'2014-03-01 17:26:36'),(18600,19250,'0000-00-00','ET','2',1,NULL,'Angel Shepherd','FI','277789124','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:34',0,'2014-03-01 17:34:07'),(18838,19488,'0000-00-00','ET','2',1,NULL,'ISABEL APARECIDA TEIXIRA','FI','629235161','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:18',0,'2014-03-02 06:52:12'),(19486,20136,'0000-00-00','ET','2',2,1,'Bernarda Rodriguez','FI','643821123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:00:24',0,'2014-03-02 06:59:07'),(21380,22030,'0000-00-00','ET','2',4,3,'Tommy Vo','FI','288968234','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:29:59',0,'2014-03-03 01:35:37'),(21805,22455,'0000-00-00','ET','2',1,NULL,'Michael Winkelman','FI','570929206','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:20',0,'2014-03-10 14:45:25'),(22134,22784,'0000-00-00','ET','2',1,NULL,'THEODORE TAYLOR HUGHES','FI','237711400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:54',0,'2014-03-06 21:27:26'),(22957,23607,'0000-00-00','ET','2',1,NULL,'CAROL A CONLEY','FI','279521426','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:21',0,'2014-03-10 21:07:22'),(11395,11395,'2014-01-01','ET','2',1,NULL,'Latonya Earls','FI','097789301','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2013-12-27 02:06:24',0,'2014-03-02 04:52:44'),(3191,3191,'2014-01-01','ET','2',1,NULL,'Catherine Phillips','FI','289446238','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:03',0,'2014-03-10 13:24:34'),(6347,6347,'2014-01-01','ET','2',1,NULL,'PATRICIA TIPTON','FI','273441172','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:08:50',0,'2014-03-10 13:39:10'),(15825,16474,'0000-00-00','ET','2',1,NULL,'Shelly Galatas','FI','439677773','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:26',0,'2014-03-02 06:03:21'),(14133,14584,'2014-01-01','ET','2',1,NULL,'KIM SMITH','FI','438791281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:56',0,'2014-03-02 05:31:31'),(13076,13432,'2014-01-01','ET','2',3,2,'Deatra Jones','FI','350608220','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:59',0,'2014-03-02 05:17:40'),(13068,13424,'2014-01-01','ET','2',1,NULL,'no nguyen','FI','439831403','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-07 04:01:44',0,'2014-03-02 05:17:40'),(3908,3908,'2014-01-01','ET','2',2,1,'Melisa Kennedy','FI','272903586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:17',0,'2014-03-01 15:26:40'),(6211,6211,'2014-01-01','ET','2',1,NULL,'Ruth Z Liptok','FI','279587019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:04:39',0,'2014-03-01 16:00:27'),(20402,21052,'0000-00-00','ET','2',1,NULL,'MELVIN HARRISON','FI','587681230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:28',0,'2014-03-02 07:03:25'),(11331,11331,'2014-01-01','ET','2',2,1,'RICHARD PARKER','FI','453063866','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:04:27',0,'2014-03-02 04:52:44'),(1304,1304,'2014-01-01','ET','2',2,1,'ANTONETTE HATTON','FI','428372130','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:56',0,'2014-03-02 04:38:08'),(13286,13642,'2014-01-01','ET','2',1,NULL,'Shanika Tyler','FI','278801177','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:07',0,'2014-03-01 16:40:16'),(4440,4440,'2014-01-01','ET','2',1,NULL,'Andrew Brock','FI','433455654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:30:04',0,'2014-03-01 21:11:04'),(19701,20351,'0000-00-00','ET','2',2,1,'Alan Weber','FI','284445659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:55:10',0,'2014-03-10 14:37:47'),(22807,23457,'0000-00-00','ET','2',1,NULL,'ANDREW CONNORS','FI','281902811','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:58',0,'2014-03-10 14:50:59'),(298,298,'2014-01-01','ET','2',1,NULL,'Frankie Pierson','FI','260291564','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:10',0,'2014-03-01 22:10:55'),(17403,18053,'0000-00-00','ET','2',1,NULL,'carol fowee','FI','295625891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:44',0,'2014-03-01 17:20:55'),(17142,17792,'0000-00-00','ET','2',3,2,'Elayne Cross','FI','288545079','Summa Insurance Company, Inc.','FI','341809108','Sam  Fiorentino','94','967259','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:27',0,'2014-03-10 16:24:30'),(1016,1016,'2014-01-01','ET','2',1,NULL,'Frank Heuer','FI','439040131','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:46',0,'2014-03-01 22:10:55'),(15930,16579,'0000-00-00','ET','2',1,NULL,'LINDA L MALTRY','FI','272687352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-25 19:00:11',0,'2014-03-01 16:56:22'),(7552,7552,'2014-01-01','ET','2',4,3,'NEIL AGARWAL','FI','123501588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:41',0,'2014-03-01 16:05:34'),(15533,15984,'0000-00-00','ET','2',1,NULL,'JANIE HERNANDEZ','FI','467847213','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:05',0,'2014-03-02 05:59:43'),(20048,20698,'0000-00-00','ET','2',1,NULL,'Alexis Korman','FI','625245872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-25 21:00:10',0,'2014-03-02 07:10:28'),(11665,11665,'2014-01-01','ET','2',1,NULL,'CHRISTIANA BASSETTE','FI','425755604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:45',0,'2014-03-02 04:52:44'),(15812,16461,'0000-00-00','ET','2',1,NULL,'David Teneyuca','FI','463273056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:18',0,'2014-03-02 06:03:21'),(7117,7117,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:04:08',0,'2014-03-01 15:52:44'),(19891,20541,'0000-00-00','ET','2',1,NULL,'Sandra Reinhard','FI','285623985','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:38',0,'2014-03-10 14:37:47'),(1047,1047,'2014-01-01','ET','2',1,NULL,'Kevin McCoy','FI','569710023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:11',0,'2014-03-01 21:11:04'),(17768,18418,'0000-00-00','ET','2',2,1,'Jeffery Beaird','FI','451042956','Starmount Life Insurance Company','FI','720977315','Terry  Payne','94','1186299','348','2014-03-01','Sync Success',0,'2014-02-10 11:00:08',0,'2014-03-02 06:17:30'),(16130,16779,'0000-00-00','ET','2',1,NULL,'Jason M Grant','FI','295564426','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:41',0,'2014-03-10 14:20:26'),(7348,7348,'2014-01-01','ET','2',1,NULL,'Shenika Myles','FI','587512122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:24',0,'2014-03-01 21:11:04'),(14058,14509,'2014-01-01','ET','2',2,1,'Karoline Trent','FI','290608087','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:08',0,'2014-03-01 16:46:19'),(14002,14358,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:32',0,'2014-03-01 16:40:16'),(13389,13745,'2014-01-01','ET','2',1,NULL,'LATOYA CHEATHAM','FI','275901991','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:49',0,'2014-03-10 16:10:34'),(12901,12901,'2014-01-01','ET','2',1,NULL,'Stephanie Green','FI','425417368','Starmount Life Insurance Company','FI','720977315','Lacy  Lockhart','94','8532080','348','2014-02-01','Sync Success',0,'2014-01-04 02:04:57',0,'2014-03-02 05:10:52'),(19951,20601,'0000-00-00','ET','2',2,1,'richard bechner','FI','551087595','Starmount Life Insurance Company','FI','720977315','greta  mcgaugh','94','17148690','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:16',0,'2014-03-02 07:03:25'),(22043,22693,'0000-00-00','ET','2',1,NULL,'Robyn Dierking','FI','406724434','HealthSpan','FI','311431434','Christopher  Mihin','94','8441437','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:23',0,'2014-03-10 14:45:25'),(22577,23227,'0000-00-00','ET','2',1,NULL,'Jill Little','FI','290522341','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:32:05',0,'2014-03-10 14:50:59'),(1014,1014,'2014-01-01','ET','2',1,NULL,'David A Kusak','FI','302866584','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:43',0,'2014-03-10 13:10:24'),(17148,17798,'0000-00-00','ET','2',1,NULL,'Melissa Weber','FI','302868050','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:31',0,'2014-03-10 16:24:30'),(11990,11990,'2014-01-01','ET','2',1,NULL,'Alexis Clark','FI','449594085','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:43',0,'2014-03-02 05:03:29'),(7682,7682,'2014-01-01','ET','2',1,NULL,'MARILYN BELL','FI','302528909','HealthSpan','FI','311431434','ALAN  ZEFF','94','2759324','357','2014-01-01','Sync Success',0,'2013-12-26 04:39:54',0,'2014-03-10 13:39:10'),(13361,13717,'2014-01-01','ET','2',2,1,'ARACELI GARCIA','FI','632119179','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:36',0,'2014-03-02 05:24:45'),(6293,6293,'2014-01-01','ET','2',1,NULL,'edwanda mckinnis','FI','436757583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:12',0,'2014-03-02 04:10:25'),(21220,21870,'0000-00-00','ET','2',1,NULL,'Larry Fitzsimmons','FI','514802427','Starmount Life Insurance Company','FI','720977315','seth  copeland','94','16548585','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:09',0,'2014-03-02 07:23:39'),(2214,2214,'2014-01-01','ET','2',1,NULL,'JOHN MAYSHACK','FI','435901412','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:37',0,'2014-03-01 21:11:04'),(16820,17470,'0000-00-00','ET','2',3,2,'Scarlett Hilton','FI','512885208','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:06',0,'2014-03-10 14:20:26'),(15579,16030,'0000-00-00','ET','2',2,1,'LINDA  GLADNEY','FI','426087926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:26',0,'2014-03-02 05:59:43'),(6202,6202,'2014-01-01','ET','2',2,1,'MICHAEL DZIAK','FI','270689680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:24',0,'2014-03-01 16:00:27'),(6188,6188,'2014-01-01','ET','2',1,NULL,'BARBARA KELSEY','FI','492603052','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:57',0,'2014-03-02 04:10:25'),(2370,2370,'2014-01-01','ET','2',1,NULL,'Edward Freeman','FI','281465082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:21',0,'2014-03-01 15:26:40'),(10541,10541,'2014-01-01','ET','2',1,NULL,'Ramakrishna Thirugnanasambandam','FI','644112567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:11',0,'2014-03-02 04:31:46'),(11450,11450,'2014-01-01','ET','2',1,NULL,'Bruce Hutchison','94','0000932112','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:09',0,'2014-03-01 16:23:43'),(18184,18834,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:40',0,'2014-03-01 17:26:36'),(10606,10606,'2014-01-01','ET','2',1,NULL,'Ronda Tyler','FI','458690436','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:24',0,'2014-03-02 04:24:47'),(4415,4415,'2014-01-01','ET','2',1,NULL,'LINDA BARDWELL','FI','298461088','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:27',0,'2014-03-10 15:39:19'),(14488,14939,'2014-01-01','ET','2',1,NULL,'JAMES ANDERSON','FI','435174760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:47',0,'2014-03-02 05:38:34'),(5948,5948,'2014-01-01','ET','2',1,NULL,'Janie A Meche','FI','433314297','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:16',0,'2014-03-02 02:10:49'),(19640,20290,'0000-00-00','ET','2',4,3,'KATRINA SUBER','FI','298709971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:40:38',0,'2014-03-01 17:47:19'),(20745,21395,'0000-00-00','ET','2',2,1,'Ricardo Orelli','FI','162449815','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:33',0,'2014-03-01 18:10:11'),(20884,21534,'0000-00-00','ET','2',1,NULL,'BRITTANY REED','FI','425699811','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:31:37',0,'2014-03-02 07:17:36'),(21905,22555,'0000-00-00','ET','2',1,NULL,'Kimberly Brooks','FI','466932364','Starmount Life Insurance Company','FI','720977315','Danielle  Abbott','94','16964484','357','2014-04-01','Sync Success',0,'2014-03-05 21:30:48',0,'2014-03-05 22:27:33'),(1786,1786,'2014-01-01','ET','2',1,NULL,'Gerald Gafeney','FI','290520050','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:10',0,'2014-03-10 13:20:27'),(11628,11628,'2014-01-01','ET','2',1,NULL,'Frederick R Ziems','FI','276547357','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:35',0,'2014-03-10 13:52:32'),(11482,11482,'2014-01-01','ET','2',1,NULL,'Marguerite Mitchell','FI','302441894','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:08',0,'2014-03-01 16:30:17'),(15538,15989,'0000-00-00','ET','2',1,NULL,'Rebecca Lyttle','FI','291441711','Summa Insurance Company, Inc.','FI','341809108','John   Pequeno','94','9544739','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:08',0,'2014-03-10 16:17:47'),(5213,5213,'2014-01-01','ET','2',1,NULL,'Delaney Morris','FI','436771226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:47',0,'2014-03-02 00:10:48'),(15048,15499,'2014-01-01','ET','2',1,NULL,'Vincent Licursi','FI','289484129','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:30',0,'2014-03-10 16:17:47'),(13969,14325,'2014-01-01','ET','2',5,4,'Andrew Saxton','FI','284823939','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:07',0,'2014-03-01 16:40:16'),(19630,20280,'0000-00-00','ET','2',1,NULL,'ROSA LOPEZ DE PORTILLO','FI','289063548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:38:02',0,'2014-03-01 17:47:19'),(20175,20825,'0000-00-00','ET','2',2,1,'genoa j sparks','FI','400762435','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:12',0,'2014-03-01 18:08:07'),(1358,1358,'2014-01-01','ET','2',1,NULL,'CAROL MATTICK','FI','585948138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:52:42',0,'2014-03-02 04:38:08'),(10588,10588,'2014-01-01','ET','2',2,1,'Mike Aycock','FI','460900907','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:46',0,'2014-03-02 04:24:47'),(7494,7494,'2014-01-01','ET','2',1,NULL,'Dana Shaw','FI','276947524','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:51',0,'2014-03-01 16:05:34'),(22017,22667,'0000-00-00','ET','2',1,NULL,'Lori Honican','FI','297620538','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:04',0,'2014-03-05 21:36:22'),(22901,23551,'0000-00-00','ET','2',3,2,'Ronald Nisch','FI','297444556','Dental Care Plus, Inc.','FI','311185262','Jason  Bradford','94','14299558','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:41',0,'2014-03-10 21:36:25'),(839,839,'2014-01-01','ET','2',1,NULL,'RUBYLEEN LEADING','FI','296922434','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:19',0,'2014-03-10 15:39:19'),(18372,19022,'0000-00-00','ET','2',1,NULL,'Juan R Martinez','FI','467026264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:42',0,'2014-03-02 06:45:14'),(11419,11419,'2014-01-01','ET','2',3,2,'Milad Baddar','FI','287903755','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:10',0,'2014-03-10 13:52:32'),(15839,16488,'0000-00-00','ET','2',1,NULL,'Susan J Haas','FI','501869847','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Received',0,'2014-01-24 21:00:34',NULL,NULL),(14993,15444,'2014-01-01','ET','2',1,NULL,'Brenda Wilson','FI','426153689','Starmount Life Insurance Company','FI','720977315','Brian  Caston','94','9699391','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:07',0,'2014-03-02 05:45:37'),(14410,14861,'2014-01-01','ET','2',1,NULL,'Larry McQuillin','FI','292423078','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:11',0,'2014-03-10 14:03:26'),(5057,5057,'2014-01-01','ET','2',2,1,'DENNIS REED','FI','271464372','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:47:50',0,'2014-03-01 15:31:33'),(4424,4424,'2014-01-01','ET','2',2,1,'Daniel  Douglas Kennedy','FI','284507667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:49',0,'2014-03-01 15:05:09'),(5674,5674,'2014-01-01','ET','2',1,NULL,'donald shumaker','FI','289583042','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:12',0,'2014-03-10 13:52:32'),(7579,7579,'2014-01-01','ET','2',1,NULL,'Suely Buller','FI','505113140','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:33',0,'2014-03-01 16:05:34'),(17690,18340,'0000-00-00','ET','2',1,NULL,'Mark Hazelwood','FI','279840264','HealthSpan','FI','311431434','Michael  Bennett','94','8790924','348','2014-03-01','Sync Success',0,'2014-02-08 19:01:01',0,'2014-03-10 14:24:38'),(15106,15557,'0000-00-00','ET','2',1,NULL,'Dirrectrick Fennell','FI','635289613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:54',0,'2014-03-02 05:52:31'),(1583,1583,'2014-01-01','ET','2',1,NULL,'Patrick Dougherty','FI','287561203','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:00:44',0,'2014-03-01 15:10:22'),(2641,2641,'2014-01-01','ET','2',1,NULL,'christopher spain','FI','271807969','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:15:06',0,'2014-03-10 13:39:10'),(4111,4111,'2014-01-01','ET','2',1,NULL,'Abraham Fadell','FI','271525791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:32',0,'2014-03-01 16:00:27'),(21251,21901,'0000-00-00','ET','2',1,NULL,'Bryan Luna','FI','625608048','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:31',0,'2014-03-01 21:35:40'),(22051,22701,'0000-00-00','ET','2',1,NULL,'RICKEY KIESSLING','FI','279589485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:29',0,'2014-03-10 14:45:25'),(256,256,'2014-01-01','ET','2',1,NULL,'Mary Van de Putte','FI','372908489','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:05',0,'2014-03-01 20:10:57'),(18422,19072,'0000-00-00','ET','2',1,NULL,'CHRISTINA MARIE GINGRAS','FI','274822574','Dental Care Plus, Inc.','FI','311185262','Mike  Groh','94','2767799','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:19',0,'2014-03-01 17:26:36'),(18136,18786,'0000-00-00','ET','2',2,1,'Martha Reimenda Licona','FI','438997976','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:05',0,'2014-03-02 06:38:05'),(15853,16502,'0000-00-00','ET','2',1,NULL,'Angie Ramirez','FI','299841800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:42',0,'2014-03-01 16:56:22'),(15564,16015,'0000-00-00','ET','2',1,NULL,'Anthony Stivaletti','FI','006668312','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 03:02:20',0,'2014-03-01 16:50:53'),(15502,15953,'0000-00-00','ET','2',1,NULL,'jeammie montalvo','FI','292862869','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:51',0,'2014-03-01 16:50:53'),(18758,19408,'0000-00-00','ET','2',2,1,'russell allatto','FI','437172424','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:35',0,'2014-03-02 06:45:14'),(4585,4585,'2014-01-01','ET','2',1,NULL,'Kim Walsh','FI','302869780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:48',0,'2014-03-01 16:15:39'),(21882,22532,'0000-00-00','ET','2',2,1,'Lowell Wagner','FI','287465744','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-05 21:30:29',0,'2014-03-05 21:36:22'),(22119,22769,'0000-00-00','ET','2',1,NULL,'Heather Lane','FI','616384713','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:43',0,'2014-03-06 21:27:26'),(23084,23734,'0000-00-00','ET','2',1,NULL,'APRIL SHINDELDECKER','FI','275660954','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:02:55',0,'2014-03-10 21:17:52'),(12696,12696,'2014-01-01','ET','2',1,NULL,'MADISON HICKS','FI','270946896','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:36',0,'2014-03-10 16:10:34'),(18390,19040,'0000-00-00','ET','2',1,NULL,'Rodney Loar','FI','439085976','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:53',0,'2014-03-02 06:45:14'),(11724,11724,'2014-01-01','ET','2',2,1,'Joseph Lengel','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:39',0,'2014-03-01 16:30:17'),(17819,18469,'0000-00-00','ET','2',1,NULL,'Angelina Giangrosso','FI','434452171','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:51',0,'2014-03-02 06:10:30'),(17101,17751,'0000-00-00','ET','2',1,NULL,'golda kudalor','FI','846777850','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:01',0,'2014-03-01 17:00:58'),(16420,17070,'0000-00-00','ET','2',1,NULL,'Teresa Robinson','FI','310705411','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:39',0,'2014-03-10 14:20:26'),(18809,19459,'0000-00-00','ET','2',1,NULL,'DIANA L JARZYNSKI','FI','282627012','HealthSpan','FI','311431434','GERALD C CAMPBELL','94','966822','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:15',0,'2014-03-10 14:31:05'),(5105,5105,'2014-01-01','ET','2',1,NULL,'Paul Rode','FI','548136879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:19',0,'2014-03-02 00:10:48'),(12716,12716,'2014-01-01','ET','2',1,NULL,'Karen Bailey-Coleman','FI','436171721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:23',0,'2014-03-02 05:10:52'),(2922,2922,'2014-01-01','ET','2',1,NULL,'Susan Wilken','FI','294827784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:38',0,'2014-03-01 15:37:30'),(17433,18083,'0000-00-00','ET','2',1,NULL,'YOLANDA AGUILAR','FI','456518369','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:04',0,'2014-03-02 06:31:45'),(17346,17996,'0000-00-00','ET','2',1,NULL,'Ahmed Zaitoun','FI','074966608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:04',0,'2014-03-02 06:31:45'),(3875,3875,'2014-01-01','ET','2',2,1,'Beau M Minson','FI','436857610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:23',0,'2014-03-01 19:11:03'),(16753,17403,'0000-00-00','ET','2',1,NULL,'Hoa Dang','FI','458930044','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:11',0,'2014-03-02 06:17:30'),(16229,16878,'0000-00-00','ET','2',1,NULL,'Joshua Bybee','FI','548331201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:58',0,'2014-03-02 06:10:30'),(15649,16298,'0000-00-00','ET','2',1,NULL,'SAMUEL EUGENE WALDROOP','FI','277608986','Dental Care Plus, Inc.','FI','311185262','CHARLES  FOX','94','15736555','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:11',0,'2014-03-01 16:56:22'),(15556,16007,'0000-00-00','ET','2',1,NULL,'Darrin Griffin','FI','119721406','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:17',0,'2014-03-01 16:50:53'),(14227,14678,'2014-01-01','ET','2',2,1,'Due Vu','FI','613562780','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:52',0,'2014-03-02 05:38:34'),(4132,4132,'2014-01-01','ET','2',1,NULL,'ANNE CASTON','FI','284729234','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:10',0,'2014-03-01 16:00:27'),(20718,21368,'0000-00-00','ET','2',1,NULL,'JACQULIN NORRIS','FI','270506738','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:20',0,'2014-03-01 18:08:07'),(20833,21483,'0000-00-00','ET','2',1,NULL,'Yolanda Gonzales','FI','564238689','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:31:14',0,'2014-03-02 07:17:36'),(10516,10516,'2014-01-01','ET','2',1,NULL,'Joseph Measher','FI','636127643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:21',0,'2014-03-02 04:24:47'),(6380,6380,'2014-01-01','ET','2',1,NULL,'STACY  WARSAW','FI','366547546','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:09:52',0,'2014-03-10 13:39:10'),(17627,18277,'0000-00-00','ET','2',1,NULL,'BRANDON W MYLES','FI','438612810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-08 19:00:20',0,'2014-03-02 06:31:45'),(4195,4195,'2014-01-01','ET','2',1,NULL,'James Martin','FI','289889108','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:07',0,'2014-03-10 15:59:47'),(22071,22721,'0000-00-00','ET','2',1,NULL,'John J Weissenberger','FI','300821467','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-04-01','Sync Success',0,'2014-03-05 21:32:44',0,'2014-03-10 14:45:25'),(810,810,'2014-01-01','ET','2',1,NULL,'dawn debord','FI','301605993','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 18:10:36',0,'2014-03-01 15:10:22'),(1970,1970,'2014-01-01','ET','2',1,NULL,'Laura Brenner','FI','291668516','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:49',0,'2014-03-01 15:26:40'),(16357,17007,'0000-00-00','ET','2',1,NULL,'hannah rose shaferly','94','0000234081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:58',0,'2014-03-01 17:00:58'),(14079,14530,'2014-01-01','ET','2',1,NULL,'JESSICA D MALDONADO','FI','568919739','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:22',0,'2014-03-02 05:38:34'),(2371,2371,'2014-01-01','ET','2',1,NULL,'Mary Butz','FI','280502324','Dental Care Plus, Inc.','FI','311185262','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 20:16:23',0,'2014-03-01 15:26:40'),(3004,3004,'2014-01-01','ET','2',1,NULL,'EVA L TAYLOR','FI','279505166','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:15',0,'2014-03-10 15:52:36'),(4475,4475,'2014-01-01','ET','2',1,NULL,'Joseph Lenertz','FI','457416990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:14',0,'2014-03-01 21:11:04'),(5690,5690,'2014-01-01','ET','2',2,1,'Tia Walker','FI','276704223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:04',0,'2014-03-01 15:37:30'),(12260,12260,'2014-01-01','ET','2',1,NULL,'Raul Vigil','FI','463253470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:49',0,'2014-03-02 05:10:52'),(20980,21630,'0000-00-00','ET','2',1,NULL,'Nicholas Kreakie','FI','274904112','Summa Insurance Company, Inc.','FI','341809108','Deana  Alexander','94','2228297','357','2014-03-31','Sync Success',0,'2014-02-28 07:30:25',0,'2014-03-10 16:38:05'),(22753,23403,'0000-00-00','ET','2',1,NULL,'Erika Walker','FI','220114830','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:14',0,'2014-03-09 21:26:00'),(125,125,'2014-01-01','ET','2',4,3,'Bart Beal','FI','274607659','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:51',0,'2014-03-10 15:45:56'),(18881,19531,'0000-00-00','ET','2',1,NULL,'dorian lindsey','FI','355544303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:48',0,'2014-03-01 17:34:07'),(1053,1053,'2014-01-01','ET','2',1,NULL,'John Richard Brintnell','FI','373940097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:23',0,'2014-03-01 15:16:37'),(3130,3130,'2014-01-01','ET','2',1,NULL,'blanca cardenas','FI','455811024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:37:07',0,'2014-03-02 01:10:33'),(15132,15583,'0000-00-00','ET','2',2,1,'RAYMOND C RITTER','FI','296788265','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:15',0,'2014-03-10 16:17:47'),(4412,4412,'2014-01-01','ET','2',1,NULL,'Whitley Smith','FI','433814267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:20',0,'2014-03-01 21:11:04'),(11209,11209,'2014-01-01','ET','2',1,NULL,'Henry Gifford','FI','297746356','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:43',0,'2014-03-01 16:23:43'),(13188,13544,'2014-01-01','ET','2',1,NULL,'NICOLE KLING','FI','269869979','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:11',0,'2014-03-10 16:10:34'),(3329,3329,'2014-01-01','ET','2',1,NULL,'Gary Vincent','FI','236769073','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:29',0,'2014-03-10 15:52:36'),(7217,7217,'2014-01-01','ET','2',1,NULL,'Eric Johnson II','FI','414571156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:09',0,'2014-03-01 15:52:44'),(17659,18309,'0000-00-00','ET','2',4,3,'Jeff Ratliff','FI','400330514','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:41',0,'2014-03-10 14:24:38'),(17615,18265,'0000-00-00','ET','2',1,NULL,'Excelcer Colbert','FI','455530864','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:12',0,'2014-03-02 06:31:45'),(17337,17987,'0000-00-00','ET','2',1,NULL,'ANITA NELSON','FI','299448824','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:31:15',0,'2014-03-10 14:24:38'),(16522,17172,'0000-00-00','ET','2',1,NULL,'KEVIN ANDREW GWYN','FI','412618465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:00:52',0,'2014-03-02 06:10:30'),(16030,16679,'0000-00-00','ET','2',1,NULL,'Sandra Pearson','FI','436783523','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:00:30',0,'2014-03-02 06:03:21'),(6151,6151,'2014-01-01','ET','2',3,2,'Fernando Ochoa','FI','450251786','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:52',0,'2014-03-02 04:10:25'),(4287,4287,'2014-01-01','ET','2',1,NULL,'Carole Johnston','FI','300480310','HealthSpan','FI','311431434','Michael  Baldea','94','15941027','348','2014-01-01','Sync Success',0,'2013-12-25 23:08:55',0,'2014-03-10 13:32:15'),(14247,14698,'2014-01-01','ET','2',1,NULL,'DOUGLAS REVELS','FI','299509206','Dental Care Plus, Inc.','FI','311185262','SHARI  SPRAGG','94','17004810','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:01',0,'2014-03-01 16:46:19'),(5728,5728,'2014-01-01','ET','2',1,NULL,'Sarah Gaugh','FI','287840931','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:14',0,'2014-03-01 15:48:04'),(13584,13940,'2014-01-01','ET','2',1,NULL,'Lilia Picazo','FI','426994296','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:13',0,'2014-03-02 05:24:45'),(1079,1079,'2014-01-01','ET','2',1,NULL,'Heleana White','FI','570416427','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:13',0,'2014-03-01 19:11:03'),(14340,14791,'2014-01-01','ET','2',1,NULL,'NAM PHAM','FI','629921754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:41',0,'2014-03-02 05:38:34'),(3060,3060,'2014-01-01','ET','2',1,NULL,'Taylor Douglas Ugie','FI','275944106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:57',0,'2014-03-01 15:37:30'),(20972,21622,'0000-00-00','ET','2',1,NULL,'Annette Rickett','FI','288523228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:20',0,'2014-03-01 18:10:11'),(21047,21697,'0000-00-00','ET','2',2,1,'SYNTHIA ELLEN POKORNY','FI','300660598','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:30:09',0,'2014-03-01 18:10:11'),(22844,23494,'0000-00-00','ET','2',1,NULL,'Cory DiDonato','FI','277927005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-09 21:30:07',0,'2014-03-09 21:35:27'),(13794,14150,'2014-01-01','ET','2',1,NULL,'Donna Jean Stahl','FI','274524512','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:43',0,'2014-03-10 13:59:38'),(2500,2500,'2014-01-01','ET','2',1,0,'emily maley','FI','455915121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:03',0,'2014-03-01 19:11:03'),(7105,7105,'2014-01-01','ET','2',1,NULL,'Alexandra Morgon Armstrong','FI','287906416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:45',0,'2014-03-01 15:52:44'),(18961,19611,'0000-00-00','ET','2',1,NULL,'Dania Pearson','FI','587697429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:45',0,'2014-03-02 06:52:12'),(20967,21617,'0000-00-00','ET','2',1,NULL,'Andrew Olinger','94','0001182479','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:17',0,'2014-03-01 18:08:07'),(11292,11292,'2014-01-01','ET','2',1,NULL,'SHARRON ACHORD','FI','225826125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:16',0,'2014-03-02 04:52:44'),(972,972,'2014-01-01','ET','2',1,NULL,'Geoffrey Barnes','FI','279762679','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:21',0,'2014-03-01 15:21:15'),(1648,1648,'2014-01-01','ET','2',1,NULL,'Hietz Severin','FI','437920720','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:26',0,'2014-03-01 20:10:57'),(4158,4158,'2014-01-01','ET','2',1,NULL,'Janet Spence','FI','268820327','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:57',0,'2014-03-10 15:59:47'),(2884,2884,'2014-01-01','ET','2',1,NULL,'Angela Spanakis','FI','280741972','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:08',0,'2014-03-10 13:39:10'),(22309,22959,'0000-00-00','ET','2',2,1,'Kevin Nguyen','FI','564579672','Starmount Life Insurance Company','FI','720977315','Tony  Ly','94','7898204','348','2014-04-01','Sync Success',0,'2014-03-06 21:30:04',0,'2014-03-06 22:25:29'),(474,474,'2014-01-01','ET','2',1,NULL,'Scott McDowell','FI','135864748','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:48',0,'2014-03-10 13:10:24'),(1279,1279,'2014-01-01','ET','2',1,NULL,'Marianne Beth Joyce','FI','287580588','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:09',0,'2014-03-01 16:23:43'),(17263,17913,'0000-00-00','ET','2',1,NULL,'Stephanie Danielle Ramos','FI','626266001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:37',0,'2014-03-02 06:24:38'),(16012,16661,'0000-00-00','ET','2',1,NULL,'Mario Alvarado','FI','641483152','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:19',0,'2014-03-02 06:03:21'),(14696,15147,'2014-01-01','ET','2',1,NULL,'Chantell Singleton','FI','437450216','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:52',0,'2014-03-02 05:45:37'),(10468,10468,'2014-01-01','ET','2',1,NULL,'reginald murdock','FI','268686219','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:53',0,'2014-03-01 16:10:36'),(11560,11560,'2014-01-01','ET','2',1,NULL,'Mary Lara','FI','452193837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:30',0,'2014-03-02 04:52:44'),(12039,12039,'2014-01-01','ET','2',1,NULL,'Sandra Williams','FI','438270603','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:33',0,'2014-03-02 05:03:29'),(4932,4932,'2014-01-01','ET','2',1,0,'ASHLEY WAGNER','FI','438592258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:11',0,'2014-03-01 19:11:03'),(11679,11679,'2014-01-01','ET','2',2,1,'ROBERT HUNDLEY','FI','263533272','HealthSpan','FI','311431434','CHARLES  BENDER','94','17057188','348','2014-02-01','Sync Success',0,'2013-12-28 03:37:14',0,'2014-03-10 13:52:32'),(11730,11730,'2014-01-01','ET','2',1,NULL,'Denise Marie Mitchell','FI','210448658','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:49',0,'2014-03-01 16:30:17'),(4107,4107,'2014-01-01','ET','2',1,NULL,'LARRY BOSO','FI','301586645','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:26',0,'2014-03-01 16:00:27'),(20190,20840,'0000-00-00','ET','2',1,NULL,'Jennifer HendonHooks','FI','454812307','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:23',0,'2014-03-02 07:10:28'),(21411,22061,'0000-00-00','ET','2',1,NULL,'Martha Mendiola','FI','458849779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-03 21:00:18',0,'2014-03-03 21:25:18'),(87,87,'2014-01-01','ET','2',1,NULL,'Sandra Bustos','FI','640301062','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:38',0,'2014-03-01 22:10:55'),(11293,11293,'2014-01-01','ET','2',1,NULL,'BARBRA HYMEL','FI','433868631','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:18',0,'2014-03-02 04:52:44'),(2007,2007,'2014-01-01','ET','2',1,NULL,'Linda Medaries','FI','436885263','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:05',0,'2014-03-01 23:10:52'),(4856,4856,'2014-01-01','ET','2',1,NULL,'jolie kapita','FI','627748081','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:48',0,'2014-03-01 20:10:57'),(16182,16831,'0000-00-00','ET','2',1,NULL,'Mary Lappin','FI','284647989','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:27',0,'2014-03-01 16:56:22'),(4148,4148,'2014-01-01','ET','2',1,NULL,'Kristine Bougie','FI','288520364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:04:39',0,'2014-03-01 16:00:27'),(14744,15195,'2014-01-01','ET','2',2,1,'Brent Ransom','FI','296743011','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:22',0,'2014-03-10 16:17:47'),(14862,15313,'2014-01-01','ET','2',1,NULL,'Sonya Prado','FI','464833933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:07',0,'2014-03-02 05:52:31'),(19677,20327,'0000-00-00','ET','2',5,4,'Deanna Nowland','FI','301605166','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-20 04:49:55',0,'2014-03-10 14:37:47'),(19696,20346,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:53:57',0,'2014-03-10 16:31:33'),(20597,21247,'0000-00-00','ET','2',1,NULL,'Memphis Bregitzer','94','0000279607','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','348','2014-03-01','Sync Success',0,'2014-02-26 21:01:47',0,'2014-03-01 18:08:07'),(21932,22582,'0000-00-00','ET','2',1,NULL,'Victoria Hanna','FI','624165137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:05',0,'2014-03-05 22:27:33'),(12541,12541,'2014-01-01','ET','2',1,NULL,'Connie Jean Yancey','FI','274724485','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:54',0,'2014-03-10 13:59:38'),(282,282,'2014-01-01','ET','2',1,NULL,'Rochelle Beard','FI','277820840','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:04',0,'2014-03-01 15:10:22'),(11765,11765,'2014-01-01','ET','2',1,NULL,'Mitchell Smith','FI','290822329','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:09:54',0,'2014-03-10 16:10:34'),(5361,5361,'2014-01-01','ET','2',1,NULL,'maria frangias','FI','271864561','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:13',0,'2014-03-10 15:39:19'),(5254,5254,'2014-01-01','ET','2',2,1,'Steven Shipley','FI','292548912','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:10',0,'2014-03-10 13:20:27'),(4896,4896,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:16',0,'2014-03-10 13:03:33'),(4857,4857,'2014-01-01','ET','2',1,NULL,'Janice Fuller','FI','451312121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:49',0,'2014-03-01 20:10:57'),(4572,4572,'2014-01-01','ET','2',1,NULL,'Kassady Oberacker','FI','293828080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:24',0,'2014-03-01 16:15:39'),(10765,10765,'2014-01-01','ET','2',1,NULL,'mai tran','FI','433618947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:46',0,'2014-03-02 04:24:47'),(6258,6258,'2014-01-01','ET','2',1,NULL,'brett cervini','FI','439087082','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:06:10',0,'2014-03-02 04:10:25'),(15068,15519,'2014-01-01','ET','2',1,NULL,'Mary Wright','FI','423684402','HealthSpan','FI','311431434','Rachael  Mears','94','15502736','357','2014-03-01','Sync Success',0,'2014-01-17 03:36:39',0,'2014-03-10 14:10:12'),(14462,14913,'2014-01-01','ET','2',1,NULL,'Anthony Giglio','FI','436539990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:35',0,'2014-03-02 05:45:37'),(12166,12166,'2014-01-01','ET','2',1,NULL,'Sonia Brumen','FI','436715573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:59',0,'2014-03-02 04:59:36'),(20735,21385,'0000-00-00','ET','2',1,NULL,'SANDRA DOENCH','FI','289506139','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:29',0,'2014-03-01 18:10:11'),(183,183,'2014-01-01','ET','2',1,NULL,'Samuel David Ballen','FI','140783890','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:40',0,'2014-03-01 22:10:55'),(7283,7283,'2014-01-01','ET','2',1,NULL,'victoria steffan','FI','293484992','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:12',0,'2014-03-10 13:32:15'),(2759,2759,'2014-01-01','ET','2',1,NULL,'Regina Dozier','FI','148603400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:01',0,'2014-03-02 04:15:49'),(14676,15127,'2014-01-01','ET','2',1,NULL,'Rebecca Jackson','FI','299860028','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:38',0,'2014-03-01 16:46:19'),(3105,3105,'2014-01-01','ET','2',1,NULL,'SALLY ANN LAVINE','FI','433945286','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:20',0,'2014-03-02 01:10:33'),(7136,7136,'2014-01-01','ET','2',1,NULL,'Diana Pham','FI','278948846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:04:38',0,'2014-03-01 15:52:44'),(5451,5451,'2014-01-01','ET','2',1,NULL,'laquivia barbee','FI','397065918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:32:03',0,'2014-03-01 15:05:09'),(21406,22056,'0000-00-00','ET','2',1,NULL,'Kimberly Nguyen','FI','522356809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:15',0,'2014-03-03 21:25:18'),(2176,2176,'2014-01-01','ET','2',1,NULL,'Brian Hall','FI','458952383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:22',0,'2014-03-01 21:11:04'),(3071,3071,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:19',0,'2014-03-02 01:10:33'),(16736,17386,'0000-00-00','ET','2',2,1,'Gloria Johnson','FI','435841376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:43',0,'2014-03-02 06:17:30'),(5908,5908,'2014-01-01','ET','2',1,NULL,'Wendy Garland','FI','274760166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:03',0,'2014-03-01 15:48:04'),(5152,5152,'2014-01-01','ET','2',1,NULL,'Daniel E Taliano','FI','285488615','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:51',0,'2014-03-10 15:52:36'),(5873,5873,'2014-01-01','ET','2',1,NULL,'Whitney Mantonya','FI','296767864','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:03',0,'2014-03-01 15:05:09'),(5162,5162,'2014-01-01','ET','2',1,NULL,'Paula Marsh','FI','288740186','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:09',0,'2014-03-10 15:45:56'),(21540,22190,'0000-00-00','ET','2',1,NULL,'Lucille bengfort','FI','455020227','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:24',0,'2014-03-03 22:26:43'),(22818,23468,'0000-00-00','ET','2',1,NULL,'ANNIE JONES','FI','587338815','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:08',0,'2014-03-09 21:26:00'),(12890,12890,'2014-01-01','ET','2',1,NULL,'MICHELLE MEXICOTT','FI','269684811','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:04:33',0,'2014-03-10 13:59:38'),(15459,15910,'0000-00-00','ET','2',1,NULL,'DENISE  KIPKER','FI','286520415','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:48',0,'2014-03-01 16:50:53'),(14318,14769,'2014-01-01','ET','2',1,NULL,'WENDY DANSORD','FI','458670368','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:32',0,'2014-03-02 05:38:34'),(1176,1176,'2014-01-01','ET','2',1,NULL,'Dylan Williams','FI','230195707','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:47:01',0,'2014-03-02 04:38:08'),(13277,13633,'2014-01-01','ET','2',2,1,'BETTY WILEY','FI','434334639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:03',0,'2014-03-02 05:24:45'),(11981,11981,'2014-01-01','ET','2',2,1,'Laura Jones','FI','643120862','Starmount Life Insurance Company','FI','720977315','Traci  Thomas','94','8956980','348','2014-02-01','Sync Success',0,'2014-01-01 12:01:23',0,'2014-03-02 05:03:29'),(22167,22817,'0000-00-00','ET','2',1,NULL,'CHRISTINE MCKENZIE','FI','274660726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:16',0,'2014-03-06 21:36:23'),(791,791,'2014-01-01','ET','2',2,1,'Ge Xiong','FI','586144252','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:50',0,'2014-03-01 19:11:03'),(13289,13645,'2014-01-01','ET','2',1,NULL,'Jose Pauta','FI','270173489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:08',0,'2014-03-01 16:40:16'),(13108,13464,'2014-01-01','ET','2',1,NULL,'ANA MARIA AMAYA','FI','454831617','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:19',0,'2014-03-02 05:17:40'),(17626,18276,'0000-00-00','ET','2',1,NULL,'BRANDON W MYLES','FI','438612810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:19',0,'2014-03-02 06:31:45'),(17531,18181,'0000-00-00','ET','2',1,NULL,'SHENIKA COOK','FI','297820144','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:22',0,'2014-03-01 17:20:55'),(17285,17935,'0000-00-00','ET','2',1,NULL,'Sandra Jean  Durham','FI','279484676','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:47',0,'2014-03-10 14:24:38'),(12220,12220,'2014-01-01','ET','2',2,1,'Claire Spann','FI','267874344','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:14',0,'2014-03-02 05:03:29'),(16253,16902,'0000-00-00','ET','2',1,NULL,'Jeri Vinson','FI','272583297','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:15',0,'2014-03-10 14:20:26'),(10928,10928,'2014-01-01','ET','2',1,NULL,'Linda Rodgers','FI','299524138','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:34',0,'2014-03-10 16:03:49'),(10792,10792,'2014-01-01','ET','2',1,NULL,'SHERRY MORAN NICHOLS','FI','431276266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:36',0,'2014-03-02 04:24:47'),(13399,13755,'2014-01-01','ET','2',1,NULL,'AMBER ROBINSON','FI','466878855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:54',0,'2014-03-02 05:24:45'),(19168,19818,'0000-00-00','ET','2',2,1,'LETICA VASQUEZ','FI','464088318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:37',0,'2014-03-02 06:52:12'),(21456,22106,'0000-00-00','ET','2',1,NULL,'SHAYNA LYNN RUFFIN','FI','290726661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:24',0,'2014-03-03 21:36:16'),(22638,23288,'0000-00-00','ET','2',1,NULL,'Douglas Libman','FI','285883854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:11',0,'2014-03-08 21:35:36'),(22689,23339,'0000-00-00','ET','2',2,1,'Sheryl Collins','FI','314763972','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:50',0,'2014-03-10 14:50:59'),(12018,12018,'2014-01-01','ET','2',1,NULL,'CASHMIR LAVIGNE','FI','434791594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:46',0,'2014-03-02 04:59:36'),(18942,19592,'0000-00-00','ET','2',1,NULL,'KYLIE GREEN','FI','628199001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:32',0,'2014-03-02 06:52:12'),(5807,5807,'2014-01-01','ET','2',2,1,'Patricia Cross','FI','288563227','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:45',0,'2014-03-10 13:24:34'),(16931,17581,'0000-00-00','ET','2',1,NULL,'KENNY GRAY','FI','428639160','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:46',0,'2014-03-02 06:17:30'),(13939,14295,'2014-01-01','ET','2',2,1,'Debra Boyd','FI','270744086','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:25',0,'2014-03-10 14:03:26'),(1466,1466,'2014-01-01','ET','2',1,NULL,'Elena Novak','FI','294947464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:19',0,'2014-03-01 16:23:43'),(4222,4222,'2014-01-01','ET','2',1,NULL,'Loan Nguyen','FI','274945133','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:54',0,'2014-03-01 16:00:27'),(19490,20140,'0000-00-00','ET','2',1,NULL,'Natashia Hills','FI','587453362','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:01:16',0,'2014-03-02 06:59:07'),(908,908,'2014-01-01','ET','2',1,NULL,'ANNAMARIE RADER','FI','293828407','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:20',0,'2014-03-01 15:21:15'),(3805,3805,'2014-01-01','ET','2',1,NULL,'Mark Lee','94','0000192616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:30',0,'2014-03-01 23:10:52'),(14089,14540,'2014-01-01','ET','2',1,NULL,'MARIA MARTINEZ','FI','642586839','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:28',0,'2014-03-02 05:38:34'),(16158,16807,'0000-00-00','ET','2',1,NULL,'SALVADOR LEDEZMA RAMIREZ','FI','463713776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:12',0,'2014-03-02 06:10:30'),(15725,16374,'0000-00-00','ET','2',1,NULL,'laonette taylor','FI','434656797','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:06',0,'2014-03-02 05:59:43'),(14656,15107,'2014-01-01','ET','2',3,2,'Randy Marmer','FI','292463379','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:26',0,'2014-03-01 16:46:19'),(20732,21382,'0000-00-00','ET','2',1,NULL,'albert upshaw','FI','287704919','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:28',0,'2014-03-01 18:10:11'),(22098,22748,'0000-00-00','ET','2',1,NULL,'Melinda Thomas','FI','467986155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-21','Sync Success',0,'2014-03-06 21:00:28',0,'2014-03-06 21:27:26'),(3257,3257,'2014-01-01','ET','2',1,NULL,'RANDY MURDOCK','FI','412949917','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:02',0,'2014-03-10 15:52:36'),(3388,3388,'2014-01-01','ET','2',1,NULL,'Katelyn Shai','94','0000336396','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:20',0,'2014-03-10 15:52:36'),(17067,17717,'0000-00-00','ET','2',1,NULL,'shawda dixon','FI','628302486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:39',0,'2014-03-02 06:24:38'),(3699,3699,'2014-01-01','ET','2',1,NULL,'Della Johnson','FI','436885585','Starmount Life Insurance Company','FI','720977315','John T Allen','94','4728680','348','2014-01-01','Sync Success',0,'2013-12-25 22:07:29',0,'2014-03-02 00:10:48'),(1486,1486,'2014-01-01','ET','2',1,NULL,'Deborah Gradomski','FI','263131323','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:56:57',0,'2014-03-10 16:03:49'),(18717,19367,'0000-00-00','ET','2',2,1,'Tomasita Mask','FI','464795679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:05',0,'2014-03-02 06:45:14'),(17977,18627,'0000-00-00','ET','2',1,NULL,'Crystal Longoria','FI','631306621','Starmount Life Insurance Company','FI','720977315','Patricio  Hernandez Jr','94','1213642','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:23',0,'2014-03-02 06:38:05'),(17967,18617,'0000-00-00','ET','2',1,NULL,'Nicole Stahl','FI','302900694','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:15',0,'2014-03-10 14:24:38'),(16131,16780,'0000-00-00','ET','2',2,1,'David Kinhalt','FI','278586795','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:42',0,'2014-03-10 14:20:26'),(2261,2261,'2014-01-01','ET','2',2,1,'Colleen Fisher','FI','279704045','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:16',0,'2014-03-10 13:10:24'),(4070,4070,'2014-01-01','ET','2',1,NULL,'Marshall Collins','FI','458975051','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:21',0,'2014-03-02 04:10:25'),(13157,13513,'2014-01-01','ET','2',1,NULL,'TOMMIE  GRAY','FI','587980783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:11',0,'2014-03-02 05:17:40'),(3273,3273,'2014-01-01','ET','2',1,NULL,'Kellyjean Chalwick','FI','269663508','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:35',0,'2014-03-10 13:32:15'),(12654,12654,'2014-01-01','ET','2',1,NULL,'JOYCE CARTER','FI','439841726','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:06',0,'2014-03-02 05:10:52'),(3538,3538,'2014-01-01','ET','2',2,1,'Linda M Spencer','FI','292509830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:24',0,'2014-03-01 15:37:30'),(3859,3859,'2014-01-01','ET','2',1,0,'JOSEPH ROBINSON','FI','269783691','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:54',0,'2014-03-01 15:05:09'),(18417,19067,'0000-00-00','ET','2',1,NULL,'Gary Blaich','FI','281629259','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:13',0,'2014-03-01 17:26:36'),(22996,23646,'0000-00-00','ET','2',1,NULL,'kevin matthew stinson','FI','294608403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:48',0,'2014-03-10 21:36:25'),(12171,12171,'2014-01-01','ET','2',1,NULL,'Cynthia Porter','FI','438334407','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:10',0,'2014-03-02 05:03:29'),(16358,17008,'0000-00-00','ET','2',1,NULL,'Ronald Canini','FI','281582725','Dental Care Plus, Inc.','FI','311185262','Todd  Hartshorn','94','2205886','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:58',0,'2014-03-01 17:00:58'),(2266,2266,'2014-01-01','ET','2',1,NULL,'anthony jones','FI','299763779','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:30',0,'2014-03-10 13:10:24'),(2467,2467,'2014-01-01','ET','2',3,2,'Mindy Rothstein','FI','381947933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:26',0,'2014-03-01 23:10:52'),(3857,3857,'2014-01-01','ET','2',1,NULL,'Jacqueline Sarra','FI','272603143','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:50',0,'2014-03-10 13:03:33'),(18395,19045,'0000-00-00','ET','2',1,NULL,'Carla Deason','FI','437654992','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:57',0,'2014-03-02 06:45:14'),(18844,19494,'0000-00-00','ET','2',2,1,'Abel Nathaniel Lopez','FI','450734912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:21',0,'2014-03-02 06:52:12'),(22532,23182,'0000-00-00','ET','2',1,NULL,'DAWUD ABDULLAH','FI','268642922','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:33',0,'2014-03-07 21:36:32'),(12412,12412,'2014-01-01','ET','2',1,NULL,'Wanda M Lemmond','FI','435743490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:07',0,'2014-03-02 05:03:29'),(12190,12190,'2014-01-01','ET','2',1,NULL,'Brian L Courtney','FI','296581108','HealthSpan','FI','311431434','Bernadine  KIRIAN','94','11391349','348','2014-02-01','Sync Success',0,'2014-01-01 12:08:58',0,'2014-03-10 13:52:32'),(10794,10794,'2014-01-01','ET','2',1,NULL,'Russell Henry','FI','437239694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:40',0,'2014-03-02 04:24:47'),(10708,10708,'2014-01-01','ET','2',1,NULL,'Brenda Dale','FI','300704406','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:49',0,'2014-03-01 16:10:36'),(14176,14627,'2014-01-01','ET','2',1,NULL,'Caroline Blankenship','FI','287641569','Summa Insurance Company, Inc.','FI','341809108','Beth  Gordon','94','11898877','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:24',0,'2014-03-10 16:17:47'),(5227,5227,'2014-01-01','ET','2',1,NULL,'Paula E Falk','FI','354727899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:18',0,'2014-03-02 00:10:48'),(13084,13440,'2014-01-01','ET','2',1,NULL,'Mary Roby','FI','549313960','Dental Care Plus, Inc.','FI','311185262','jon  Beveridge','94','7897779','348','2014-02-01','Sync Success',0,'2014-01-07 04:02:20',0,'2014-03-01 16:40:16'),(13020,13020,'2014-01-01','ET','2',1,NULL,'nathan bailey','FI','274926553','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:58',0,'2014-03-10 16:10:34'),(3233,3233,'2014-01-01','ET','2',1,NULL,'caprice wright-ybarra','FI','546577143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:19',0,'2014-03-01 15:52:44'),(3842,3842,'2014-01-01','ET','2',1,NULL,'Matthew Howe','FI','284942335','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:19',0,'2014-03-01 15:05:09'),(18162,18812,'0000-00-00','ET','2',2,1,'Michele Beary','FI','433371232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:25',0,'2014-03-02 06:38:05'),(20582,21232,'0000-00-00','ET','2',1,NULL,'QIDIAN WENG','FI','074962106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:37',0,'2014-03-01 18:08:07'),(20618,21268,'0000-00-00','ET','2',2,1,'Kenneth Crocker','FI','439989834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:01',0,'2014-03-02 07:10:28'),(20917,21567,'0000-00-00','ET','2',1,NULL,'RENEE KAY CLARK','FI','273563596','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:11',0,'2014-03-01 18:08:07'),(235,235,'2014-01-01','ET','2',1,0,'Peggy Grove','FI','292620834','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 17:30:23',0,'2014-03-01 15:05:09'),(12386,12386,'2014-01-01','ET','2',1,NULL,'Stephanie Louise Cooper','FI','231667373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:10',0,'2014-03-01 16:30:17'),(16205,16854,'0000-00-00','ET','2',1,NULL,'SHARON LOUIS','FI','433962696','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:42',0,'2014-03-02 06:10:30'),(1517,1517,'2014-01-01','ET','2',1,NULL,'sherrie chappell','FI','290586342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:57',0,'2014-03-10 13:52:32'),(11741,11741,'2014-01-01','ET','2',1,NULL,'Jacob Fiorino','FI','224653166','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:09:10',0,'2014-03-01 16:30:17'),(14405,14856,'2014-01-01','ET','2',1,NULL,'Beth Kilbane','FI','175668667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:09',0,'2014-03-01 16:46:19'),(14018,14374,'2014-01-01','ET','2',1,NULL,'Margaret Lang','FI','425210543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:44',0,'2014-03-02 05:31:31'),(13563,13919,'2014-01-01','ET','2',1,NULL,'Desirea Williams','FI','439798291','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:56',0,'2014-03-02 05:31:31'),(2085,2085,'2014-01-01','ET','2',2,1,'MARK  SCHRODDER','94','0000044246','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:33',0,'2014-03-10 13:20:27'),(4398,4398,'2014-01-01','ET','2',1,NULL,'Jennifer Hale','FI','336628541','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:52',0,'2014-03-10 15:39:19'),(2352,2352,'2014-01-01','ET','2',1,NULL,'Paula Evans','FI','450113370','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:42',0,'2014-03-01 15:26:40'),(382,382,'2014-01-01','ET','2',1,NULL,'Gail Lee Zink','FI','274540846','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:47:48',0,'2014-03-10 15:45:56'),(465,465,'2014-01-01','ET','2',1,NULL,'Craig Wolf','FI','280823852','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:29',0,'2014-03-10 13:10:24'),(1622,1622,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:46',0,'2014-03-01 20:10:57'),(16593,17243,'0000-00-00','ET','2',1,NULL,'Kathleen Edgecomb','FI','270667352','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:38',0,'2014-03-10 14:20:26'),(4140,4140,'2014-01-01','ET','2',1,NULL,'Joyce Bartlett','FI','401806995','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:23',0,'2014-03-01 16:00:27'),(16043,16692,'0000-00-00','ET','2',1,NULL,'James Woodard','FI','439886863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:38',0,'2014-03-02 06:03:21'),(14230,14681,'2014-01-01','ET','2',1,NULL,'Justin Briggs','FI','425537426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:05:54',0,'2014-03-02 05:38:34'),(18290,18940,'0000-00-00','ET','2',1,NULL,'norman whitaker','FI','284624348','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:20',0,'2014-03-01 17:26:36'),(12305,12305,'2014-01-01','ET','2',1,NULL,'Holly Bonner','FI','289842352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:28',0,'2014-03-10 16:10:34'),(10455,10455,'2014-01-01','ET','2',1,NULL,'Francine R Gaddis','FI','278640803','Dental Care Plus, Inc.','FI','311185262','Cecile  Vogler','94','1766694','348','2014-01-01','Sync Success',0,'2013-12-26 12:52:28',0,'2014-03-01 16:10:36'),(2673,2673,'2014-01-01','ET','2',1,NULL,'CHRISTYNA M SHAOMO','FI','288584694','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:18',0,'2014-03-01 16:05:34'),(14468,14919,'2014-01-01','ET','2',1,NULL,'KATHLEEN FLYNN','FI','278503006','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:38',0,'2014-03-10 16:17:47'),(3049,3049,'2014-01-01','ET','2',2,1,'Daniel Kenyon','FI','302905882','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:35',0,'2014-03-01 15:37:30'),(18308,18958,'0000-00-00','ET','2',1,NULL,'Shannon Neal','FI','284769659','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:10',0,'2014-03-10 14:24:38'),(19530,20180,'0000-00-00','ET','2',1,NULL,'Barbara Day','FI','279425023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-20 04:13:00',0,'2014-03-01 17:47:19'),(23073,23723,'0000-00-00','ET','2',1,NULL,'Obelia Hill','FI','282502790','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:46',0,'2014-03-10 21:17:52'),(777,777,'2014-01-01','ET','2',1,NULL,'Kris Scheid','FI','273765626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:18',0,'2014-03-01 15:05:09'),(7228,7228,'2014-01-01','ET','2',1,NULL,'LLOYD HENRY','FI','306506515','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:07:30',0,'2014-03-01 15:52:44'),(12360,12360,'2014-01-01','ET','2',1,NULL,'George Holley','FI','498648994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:13',0,'2014-03-02 05:03:29'),(12049,12049,'2014-01-01','ET','2',1,NULL,'Jeremy L Graves','FI','462614948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:59',0,'2014-03-02 04:59:36'),(5468,5468,'2014-01-01','ET','2',1,NULL,'GINA GARDNER','FI','439754142','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:23',0,'2014-03-02 04:45:37'),(18572,19222,'0000-00-00','ET','2',1,NULL,'Josiah Jefferson Smith','94','0001182543','Dental Care Plus, Inc.','FI','311185262','Sarah  Bean','94','10334323','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:11',0,'2014-03-01 17:26:36'),(19753,20403,'0000-00-00','ET','2',1,NULL,'William Fowlkes','FI','316805554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 21:30:09',0,'2014-03-01 17:47:19'),(22327,22977,'0000-00-00','ET','2',1,NULL,'TAWLES LITTLETON','FI','292726808','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:17',0,'2014-03-10 14:50:59'),(4360,4360,'2014-01-01','ET','2',2,1,'Bonnie Brown','FI','278643030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:04',0,'2014-03-10 13:32:15'),(7043,7043,'2014-01-01','ET','2',1,NULL,'MELISSA M GONZALES','FI','456699090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:01:50',0,'2014-03-02 03:09:49'),(13343,13699,'2014-01-01','ET','2',1,NULL,'Engy Ahmed','FI','370197720','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:29',0,'2014-03-01 16:40:16'),(15242,15693,'0000-00-00','ET','2',1,NULL,'Renata Weatherspoon','FI','436431546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:22',0,'2014-03-02 05:52:31'),(14658,15109,'2014-01-01','ET','2',1,NULL,'Deborah Hess','FI','297523808','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:27',0,'2014-03-01 16:46:19'),(19033,19683,'0000-00-00','ET','2',4,3,'Joseph Jorgenson','FI','288805821','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:06',0,'2014-03-01 17:34:07'),(22897,23547,'0000-00-00','ET','2',2,1,'julianna novel','FI','275681049','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:38',0,'2014-03-10 21:36:25'),(835,835,'2014-01-01','ET','2',1,NULL,'Ruthia Robinson','FI','587805825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:12',0,'2014-03-01 22:10:55'),(11204,11204,'2014-01-01','ET','2',1,NULL,'omari parks','FI','291760929','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:34',0,'2014-03-01 16:23:43'),(10536,10536,'2014-01-01','ET','2',1,NULL,'Janessa Brown','FI','603160641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:00',0,'2014-03-02 04:31:46'),(2803,2803,'2014-01-01','ET','2',1,NULL,'Jean Collingwood','FI','275566830','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:27',0,'2014-03-01 16:05:34'),(17093,17743,'0000-00-00','ET','2',1,NULL,'RITA FIELDS','FI','293546947','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:56',0,'2014-03-01 17:00:58'),(15528,15979,'0000-00-00','ET','2',1,NULL,'Wanda Harris','FI','465395581','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:03',0,'2014-03-02 05:59:43'),(3953,3953,'2014-01-01','ET','2',2,1,'LUZ REYNA','FI','460497092','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:39',0,'2014-03-01 23:10:52'),(3639,3639,'2014-01-01','ET','2',1,NULL,'DIANNE LYNN SIMPSON','FI','268709110','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:34',0,'2014-03-10 15:52:36'),(4612,4612,'2014-01-01','ET','2',1,NULL,'Steve Manahan','FI','463963684','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:37',0,'2014-03-02 04:31:46'),(18839,19489,'0000-00-00','ET','2',2,1,'Carol Hebert','FI','637059837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:18',0,'2014-03-02 06:52:12'),(18984,19634,'0000-00-00','ET','2',1,NULL,'Elizabeth Stanford','FI','587576208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:03',0,'2014-03-02 06:52:12'),(21217,21867,'0000-00-00','ET','2',3,2,'Kimberly Reser','FI','289749640','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:07',0,'2014-03-10 14:45:25'),(22700,23350,'0000-00-00','ET','2',1,NULL,'Monica Riddlespurger','FI','639075148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:58',0,'2014-03-08 22:26:18'),(23039,23689,'0000-00-00','ET','2',1,NULL,'LYNN E WERLING','FI','294449939','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-10 21:02:20',0,'2014-03-10 21:17:52'),(524,524,'2014-01-01','ET','2',1,NULL,'Gail A Seidenable','FI','301544530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:10',0,'2014-03-01 15:48:04'),(16530,17180,'0000-00-00','ET','2',1,NULL,'stephen williams','FI','290705812','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:57',0,'2014-03-01 17:00:58'),(12091,12091,'2014-01-01','ET','2',4,3,'Crystal McGuire','FI','402338190','Dental Care Plus, Inc.','FI','311185262','michael  daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-01 12:05:24',0,'2014-03-01 16:30:17'),(11016,11016,'2014-01-01','ET','2',3,2,'Sharon Russell','FI','572430958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:21',0,'2014-03-02 04:24:47'),(3759,3759,'2014-01-01','ET','2',1,NULL,'Cynthia Buford','FI','403315864','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:33',0,'2014-03-10 13:24:34'),(7578,7578,'2014-01-01','ET','2',1,NULL,'Shirley Turner','FI','300504332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:36:32',0,'2014-03-01 16:05:34'),(19343,19993,'0000-00-00','ET','2',1,NULL,'DONALD NED','94','0001853959','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:28',0,'2014-03-02 06:52:12'),(19637,20287,'0000-00-00','ET','2',1,NULL,'ROSA LOPEZ DE PORTILLO','FI','289063548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:40:01',0,'2014-03-01 17:47:19'),(20778,21428,'0000-00-00','ET','2',1,NULL,'JOHN M MORRIS','FI','288588213','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:48',0,'2014-03-10 16:38:05'),(21187,21837,'0000-00-00','ET','2',1,NULL,'Thomas Siebold','FI','389481757','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:31:49',0,'2014-03-10 14:45:25'),(21671,22321,'0000-00-00','ET','2',4,3,'Colleen Poteet','FI','278563784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:13',0,'2014-03-04 21:36:30'),(12892,12892,'2014-01-01','ET','2',1,NULL,'Michael Della Flora','FI','292423365','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:37',0,'2014-03-10 13:59:38'),(12823,12823,'2014-01-01','ET','2',1,NULL,'GUSSIE WOODARD','FI','439172961','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:06',0,'2014-03-02 05:10:52'),(16896,17546,'0000-00-00','ET','2',1,NULL,'Eleanor Lopez','FI','467470856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:24',0,'2014-03-02 06:24:38'),(11403,11403,'2014-01-01','ET','2',1,NULL,'Jeff Asplin','FI','288661710','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:39',0,'2014-03-10 16:03:49'),(10456,10456,'2014-01-01','ET','2',1,NULL,'Jonathan Jacobs','FI','291868263','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:30',0,'2014-03-01 16:10:36'),(15095,15546,'0000-00-00','ET','2',2,1,'Larry Jefferson','FI','463118328','Starmount Life Insurance Company','FI','720977315','Alan   Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-20 08:05:45',0,'2014-03-02 05:52:31'),(6360,6360,'2014-01-01','ET','2',1,NULL,'Mary Morgan','FI','426026311','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:12',0,'2014-03-02 04:10:25'),(18831,19481,'0000-00-00','ET','2',2,1,'Julian Esparza','FI','456838748','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:12',0,'2014-03-02 06:52:12'),(21137,21787,'0000-00-00','ET','2',1,NULL,'Demetrice Ballom','FI','436518792','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:13',0,'2014-03-02 07:23:39'),(21884,22534,'0000-00-00','ET','2',1,NULL,'Ashley Horn','FI','290904739','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:31',0,'2014-03-05 21:36:22'),(22621,23271,'0000-00-00','ET','2',1,NULL,'Kathleen Ann Lewis','FI','302501326','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-08 21:00:08',0,'2014-03-10 14:50:59'),(12593,12593,'2014-01-01','ET','2',1,NULL,'NANCY RODRIGUEZ','FI','456638658','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:51',0,'2014-03-02 05:10:52'),(1024,1024,'2014-01-01','ET','2',1,NULL,'Kari Oatman','FI','286902554','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:01',0,'2014-03-10 15:39:19'),(11553,11553,'2014-01-01','ET','2',2,1,'Maria Dominguez','FI','459842361','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:16',0,'2014-03-02 04:52:44'),(1852,1852,'2014-01-01','ET','2',4,3,'Thomas Blank','FI','163468682','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:15',0,'2014-03-01 15:26:40'),(13734,14090,'2014-01-01','ET','2',1,NULL,'Tara Perez','FI','436437039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:04',0,'2014-03-02 05:24:45'),(13810,14166,'2014-01-01','ET','2',2,1,'Stacy Waldock','FI','523792026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:16',0,'2014-03-01 16:40:16'),(13760,14116,'2014-01-01','ET','2',1,NULL,'Santresa Turner','FI','435818418','Starmount Life Insurance Company','FI','720977315','Patricia  Freeman','94','4700588','348','2014-02-01','Sync Success',0,'2014-01-13 02:22:21',0,'2014-03-02 05:24:45'),(21609,22259,'0000-00-00','ET','2',1,NULL,'wanda burger','94','0000656755','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:28',0,'2014-03-04 21:27:16'),(11586,11586,'2014-01-01','ET','2',1,NULL,'DIANE DICK','FI','524684483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:17',0,'2014-03-02 04:59:36'),(11692,11692,'2014-01-01','ET','2',1,NULL,'Ramon Arroyos','FI','461638868','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:40',0,'2014-03-02 04:59:36'),(15018,15469,'2014-01-01','ET','2',1,NULL,'Martha G Recio Torres','FI','436790908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-17 03:36:18',0,'2014-03-02 05:45:37'),(13935,14291,'2014-01-01','ET','2',1,NULL,'Douglas Grigg','FI','269667180','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:22',0,'2014-03-10 14:03:26'),(14382,14833,'2014-01-01','ET','2',2,1,'Thomas Watson','FI','282722915','Dental Care Plus, Inc.','FI','311185262','James  Packard','94','2442861','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:59',0,'2014-03-01 16:46:19'),(23043,23693,'0000-00-00','ET','2',1,NULL,'Alan Farris','FI','449632620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:23',0,'2014-03-10 21:27:11'),(10499,10499,'2014-01-01','ET','2',2,1,'Ramie Pierson','FI','302489050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:51',0,'2014-03-01 16:15:39'),(22374,23024,'0000-00-00','ET','2',1,NULL,'DEADIRA  CASTILLO','FI','457838127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:22',0,'2014-03-07 21:25:22'),(21547,22197,'0000-00-00','ET','2',1,NULL,'Marquis Young','FI','604108507','Starmount Life Insurance Company','FI','720977315','Kenneth  Higgenbottom','94','16025739','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:30',0,'2014-03-03 22:26:43'),(11774,11774,'2014-01-01','ET','2',1,NULL,'Beverly Jones','FI','289488441','HealthSpan','FI','311431434','Maureen  Fowler','94','8188952','348','2014-02-01','Sync Success',1,'2013-12-29 11:10:09',0,'2014-03-10 13:52:32'),(13866,14222,'2014-01-01','ET','2',1,NULL,'ELAINE MILLIET','FI','662145636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:59',0,'2014-03-02 05:31:31'),(20573,21223,'0000-00-00','ET','2',1,NULL,'Jacqueline Rock','FI','280847223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-26 21:01:32',0,'2014-03-01 18:08:07'),(18580,19230,'0000-00-00','ET','2',1,NULL,'Carrie Stuckert','FI','290885135','Dental Care Plus, Inc.','FI','311185262','Eric R Wolfe','94','2766182','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:18',0,'2014-03-01 17:26:36'),(15680,16329,'0000-00-00','ET','2',1,NULL,'Logan Boyd','FI','456950946','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:35',0,'2014-03-02 05:59:43'),(22591,23241,'0000-00-00','ET','2',1,NULL,'James Adamczyk','FI','296541406','Summa Insurance Company, Inc.','FI','341809108','Tim  Walters','94','1852658','348','2014-04-01','Sync Success',0,'2014-03-07 21:32:16',0,'2014-03-10 16:44:18'),(22668,23318,'0000-00-00','ET','2',1,NULL,'Nancy J Buck','FI','428419078','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:34',0,'2014-03-08 22:26:18'),(250,250,'2014-01-01','ET','2',1,NULL,'Brian Brinkley','FI','300488245','Dental Care Plus, Inc.','FI','311185262','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-25 17:30:51',0,'2014-03-01 15:10:22'),(2620,2620,'2014-01-01','ET','2',1,NULL,'Debra Robinson','FI','185507380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:36',0,'2014-03-01 15:16:37'),(5696,5696,'2014-01-01','ET','2',1,NULL,'Roy Duncan','FI','594072570','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:17',0,'2014-03-01 15:37:30'),(20691,21341,'0000-00-00','ET','2',1,NULL,'Angelle Gosha','FI','437633228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:08',0,'2014-03-02 07:17:36'),(19115,19765,'0000-00-00','ET','2',4,3,'Ginger Hineline','FI','520986117','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:55',0,'2014-03-01 17:34:07'),(14037,14393,'2014-01-01','ET','2',1,NULL,'Dustin carrizales','FI','634200464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:57',0,'2014-03-02 05:31:31'),(23040,23690,'0000-00-00','ET','2',1,NULL,'DEBRA SIMMONS','FI','433984588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:21',0,'2014-03-10 21:27:11'),(1334,1334,'2014-01-01','ET','2',1,NULL,'TUAN NGUYEN','FI','462553109','Starmount Life Insurance Company','FI','720977315','PETER  TRAN','94','736644','357','2014-01-01','Sync Success',0,'2013-12-25 18:51:54',0,'2014-03-02 04:38:08'),(10485,10485,'2014-01-01','ET','2',1,NULL,'Carole Creagh','FI','278549525','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:26',0,'2014-03-01 16:10:36'),(19799,20449,'0000-00-00','ET','2',1,NULL,'Wei Zheng','FI','109846195','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:22',0,'2014-03-02 06:59:07'),(19642,20292,'0000-00-00','ET','2',1,NULL,'ANTOINETTE M KOMYATI','FI','287642324','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:41:07',0,'2014-03-01 17:47:19'),(12321,12321,'2014-01-01','ET','2',2,1,'John Scheidt','FI','395566039','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:26:51',0,'2014-03-02 05:03:29'),(13156,13512,'2014-01-01','ET','2',2,1,'jennifer dressner','FI','227558711','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',0,'2014-01-07 04:05:08',0,'2014-03-02 05:17:40'),(18246,18896,'0000-00-00','ET','2',4,3,'Emmanouil Paris','FI','292707847','Summa Insurance Company, Inc.','FI','341809108','Mike  Sessor','94','2516402','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:32',0,'2014-03-10 16:31:33'),(18164,18814,'0000-00-00','ET','2',1,NULL,'WANDA DELANEY','FI','437961981','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:26',0,'2014-03-02 06:38:05'),(13802,14158,'2014-01-01','ET','2',2,1,'whitney martinez','FI','274921896','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:10',0,'2014-03-01 16:40:16'),(14517,14968,'2014-01-01','ET','2',2,1,'Kevin Pliska','FI','275603339','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:01',0,'2014-03-10 14:03:26'),(3238,3238,'2014-01-01','ET','2',1,NULL,'Laura Ey','FI','299861123','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:29',0,'2014-03-01 15:52:44'),(19638,20288,'0000-00-00','ET','2',4,3,'Vincent A Dugan','FI','196428448','Dental Care Plus, Inc.','FI','311185262','Ryan  Mulligan','94','8789743','348','2014-04-01','Sync Success',0,'2014-02-20 04:40:22',0,'2014-03-01 17:47:19'),(20843,21493,'0000-00-00','ET','2',1,NULL,'ABBY FORD','FI','433653365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:18',0,'2014-03-02 07:17:36'),(3744,3744,'2014-01-01','ET','2',2,1,'Elizabeth Sandys','FI','377922645','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:00',0,'2014-03-10 13:20:27'),(21344,21994,'0000-00-00','ET','2',1,NULL,'Stacey Hamric','FI','270709081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-16','Sync Success',0,'2014-03-03 01:00:20',0,'2014-03-03 01:35:37'),(20628,21278,'0000-00-00','ET','2',1,NULL,'CONNIE MARX','FI','285588602','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:08',0,'2014-03-10 14:37:47'),(3796,3796,'2014-01-01','ET','2',1,NULL,'Milton Lumpkin','FI','358682348','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:09',0,'2014-03-01 23:10:52'),(6440,6440,'2014-01-01','ET','2',2,1,'Jessica Best','FI','281764608','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:44',0,'2014-03-10 13:03:33'),(17766,18416,'0000-00-00','ET','2',1,NULL,'santiago Manrrique','FI','459232755','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:06',0,'2014-03-02 05:59:43'),(14266,14717,'2014-01-01','ET','2',1,NULL,'Steven Line','FI','286665623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:09',0,'2014-03-01 16:46:19'),(16549,17199,'0000-00-00','ET','2',1,NULL,'stephanie Garcia','FI','599326136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:08',0,'2014-03-02 06:10:30'),(16599,17249,'0000-00-00','ET','2',1,NULL,'Robin Hawkins','FI','465658246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-31 21:00:06',0,'2014-03-02 06:17:30'),(1547,1547,'2014-01-01','ET','2',2,1,'katherine walley','FI','290927510','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:50',0,'2014-03-10 13:45:57'),(22431,23081,'0000-00-00','ET','2',1,NULL,'MINOON YEUNG','FI','431392465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:22',0,'2014-03-07 22:26:59'),(22336,22986,'0000-00-00','ET','2',1,NULL,'Kenneth Smith','FI','292501799','HealthSpan','FI','311431434','Sally  Stroud','94','2341804','348','2014-04-01','Sync Success',0,'2014-03-06 21:30:23',0,'2014-03-10 14:50:59'),(21713,22363,'0000-00-00','ET','2',1,NULL,'LISSETTE C MENENDEZ','FI','437087565','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-19','Sync Success',0,'2014-03-04 21:01:49',0,'2014-03-04 21:27:16'),(20349,20999,'0000-00-00','ET','2',1,NULL,'Leanna Houser','FI','300844149','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:38',0,'2014-03-01 17:47:19'),(20256,20906,'0000-00-00','ET','2',1,NULL,'Jonnie Moreland','FI','462989281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:07',0,'2014-03-02 07:03:25'),(20211,20861,'0000-00-00','ET','2',2,1,'Jeffrey Rollfing','FI','450414420','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:39',0,'2014-03-02 07:10:28'),(4324,4324,'2014-01-01','ET','2',1,NULL,'INDRA CHAKRAVARTY','FI','535900359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:57',0,'2014-03-02 03:09:49'),(19746,20396,'0000-00-00','ET','2',1,NULL,'JOSE  DE SANTIAGO','FI','635807448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-20 21:30:04',0,'2014-03-02 07:03:25'),(19200,19850,'0000-00-00','ET','2',2,1,'Jerry Hillis','FI','302862330','HealthSpan','FI','311431434','Ty  Cramer','94','8741868','348','2014-03-01','Sync Success',0,'2014-02-15 22:02:07',0,'2014-03-10 14:31:05'),(5323,5323,'2014-01-01','ET','2',1,NULL,'Bennett LeBarre','FI','444903274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:02:19',0,'2014-03-01 19:11:03'),(18753,19403,'0000-00-00','ET','2',1,NULL,'Cleona Torres','FI','433772626','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:32',0,'2014-03-02 06:45:14'),(13299,13655,'2014-01-01','ET','2',1,NULL,'Pauline  Roll','FI','287505122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:12',0,'2014-03-01 16:40:16'),(17954,18604,'0000-00-00','ET','2',3,2,'robert mcowen','FI','293680835','Dental Care Plus, Inc.','FI','311185262','Deborah  Shelley','94','15984551','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:06',0,'2014-03-01 17:20:55'),(7685,7685,'2014-01-01','ET','2',1,NULL,'DONNA POST','FI','291668719','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:40:00',0,'2014-03-10 13:39:10'),(11095,11095,'2014-01-01','ET','2',2,1,'Robert V Dible','FI','302602693','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:55',0,'2014-03-10 13:45:57'),(22046,22696,'0000-00-00','ET','2',1,NULL,'Barbara Ray','FI','428196107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:32:25',0,'2014-03-05 22:27:33'),(22029,22679,'0000-00-00','ET','2',3,2,'ANA MARIA FLORES','FI','458393993','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:13',0,'2014-03-05 22:27:33'),(7626,7626,'2014-01-01','ET','2',1,NULL,'Kim Hollibaugh','FI','265353726','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:07',0,'2014-03-10 15:59:47'),(11792,11792,'2014-01-01','ET','2',1,NULL,'Robert Jones','FI','456498170','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:52',0,'2014-03-02 04:31:46'),(20099,20749,'0000-00-00','ET','2',1,NULL,'Nicole Baker','FI','034749643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:18',0,'2014-03-02 07:10:28'),(16747,17397,'0000-00-00','ET','2',1,NULL,'CECILIA G RUIZ','FI','629381321','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-02-01 19:00:07',0,'2014-03-02 06:17:30'),(10719,10719,'2014-01-01','ET','2',2,1,'Cheryl Woods','FI','283520392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:11',0,'2014-03-01 16:10:36'),(21555,22205,'0000-00-00','ET','2',1,NULL,'MAURINE CATHERINE KING','FI','426025106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:35',0,'2014-03-03 22:26:43'),(20153,20803,'0000-00-00','ET','2',1,NULL,'Tresha Bunce','FI','275782762','Summa Insurance Company, Inc.','FI','341809108','Scott  D Demko','94','1829571','348','2014-04-01','Sync Success',0,'2014-02-25 21:30:57',0,'2014-03-10 16:38:05'),(5607,5607,'2014-01-01','ET','2',1,NULL,'matt prince','FI','289707111','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:52',0,'2014-03-01 16:23:43'),(19184,19834,'0000-00-00','ET','2',4,3,'Stefanie Raper','FI','269886806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:51',0,'2014-03-10 14:31:05'),(17673,18323,'0000-00-00','ET','2',1,NULL,'Jeffery Swank','FI','288766718','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:49',0,'2014-03-10 16:24:30'),(16581,17231,'0000-00-00','ET','2',1,NULL,'Kelli Sund','FI','279845255','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:30',0,'2014-03-10 14:20:26'),(2568,2568,'2014-01-01','ET','2',1,0,'Rodney Hubbard','FI','427637882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:12',0,'2014-03-01 19:11:03'),(13920,14276,'2014-01-01','ET','2',1,NULL,'jolene patterson','FI','289641081','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:13',0,'2014-03-01 16:40:16'),(1269,1269,'2014-01-01','ET','2',1,NULL,'robert warner','FI','341627334','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:49:49',0,'2014-03-01 16:23:43'),(2635,2635,'2014-01-01','ET','2',2,1,'Cassandra A Peth','FI','268525951','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:07',0,'2014-03-10 13:03:33'),(21386,22036,'0000-00-00','ET','2',1,NULL,'Dennis Brown','FI','270504376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:02',0,'2014-03-03 21:36:16'),(20421,21071,'0000-00-00','ET','2',1,NULL,'CASH BERAUN','FI','520980798','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:43',0,'2014-03-01 18:08:07'),(20176,20826,'0000-00-00','ET','2',1,NULL,'Linda Moran','FI','290469504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-12','Sync Success',0,'2014-02-25 21:31:13',0,'2014-03-01 18:08:07'),(19903,20553,'0000-00-00','ET','2',1,NULL,'Allie E Butler','FI','287506420','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:06',0,'2014-03-01 17:47:19'),(18858,19508,'0000-00-00','ET','2',1,NULL,'dorian lindsey','FI','355544303','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:31',0,'2014-03-01 17:34:07'),(3218,3218,'2014-01-01','ET','2',1,NULL,'Marian Benham','FI','301923387','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:52',0,'2014-03-01 15:52:44'),(18042,18692,'0000-00-00','ET','2',1,NULL,'DORIS LONG','FI','283707604','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:32:08',0,'2014-03-10 14:24:38'),(3391,3391,'2014-01-01','ET','2',1,NULL,'Nancy Vickroy','FI','294727756','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:24',0,'2014-03-10 15:52:36'),(4286,4286,'2014-01-01','ET','2',1,NULL,'JAMES  MIHM','FI','300503884','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:54',0,'2014-03-10 13:32:15'),(5288,5288,'2014-01-01','ET','2',2,1,'patrick duffy','FI','462840232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:00',0,'2014-03-01 20:10:57'),(5954,5954,'2014-01-01','ET','2',1,NULL,'Phillip Boling','FI','405782463','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:27',0,'2014-03-10 13:24:34'),(5955,5955,'2014-01-01','ET','2',1,NULL,'Colin Jarvis','FI','298842118','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:29',0,'2014-03-10 15:52:36'),(6296,6296,'2014-01-01','ET','2',1,NULL,'David M Beck','FI','300540036','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:07:19',0,'2014-03-10 13:32:15'),(14078,14529,'2014-01-01','ET','2',1,NULL,'Elvira Perez','FI','452086258','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:21',0,'2014-03-02 05:38:34'),(21839,22489,'0000-00-00','ET','2',1,NULL,'Laureen rives','FI','436319367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:30',0,'2014-03-05 21:25:24'),(21705,22355,'0000-00-00','ET','2',1,NULL,'Ernest McCowan','FI','431436654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:42',0,'2014-03-04 21:27:16'),(13453,13809,'2014-01-01','ET','2',1,NULL,'VANESSA ROSAS','FI','639329045','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:21',0,'2014-03-02 05:31:31'),(12363,12363,'2014-01-01','ET','2',1,NULL,'Daniel Cohen','FI','462718501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:28:20',0,'2014-03-02 05:03:29'),(11540,11540,'2014-01-01','ET','2',1,NULL,'Mitchell Smith','FI','290822329','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:32:50',0,'2014-03-10 16:10:34'),(16112,16761,'0000-00-00','ET','2',2,1,'Jennifer Longmire','FI','288540107','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:26',0,'2014-03-10 14:20:26'),(2942,2942,'2014-01-01','ET','2',1,NULL,'Diana Asher','FI','272584992','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:19',0,'2014-03-01 15:37:30'),(6227,6227,'2014-01-01','ET','2',1,NULL,'Kristine Bougie','FI','288520364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:11',0,'2014-03-01 16:00:27'),(22072,22722,'0000-00-00','ET','2',1,NULL,'MELANIE SANTOS','94','0000624052','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:44',0,'2014-03-05 22:27:33'),(22408,23058,'0000-00-00','ET','2',1,NULL,'TUYEN TRAN','94','0000761226','Starmount Life Insurance Company','FI','720977315','becky  nguyen','94','16221499','357','2014-04-01','Sync Success',0,'2014-03-07 21:30:05',0,'2014-03-07 22:26:59'),(837,837,'2014-01-01','ET','2',1,NULL,'Kathleen Parsons','FI','335441940','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:16',0,'2014-03-10 15:39:19'),(13881,14237,'2014-01-01','ET','2',1,NULL,'TAMMY AHMOUDA','FI','289748623','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:24:08',0,'2014-03-10 14:03:26'),(21818,22468,'0000-00-00','ET','2',1,NULL,'mykelle daily','FI','623649948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:15',0,'2014-03-05 21:25:24'),(13133,13489,'2014-01-01','ET','2',1,NULL,'MARCELLA LEWIS','FI','459214770','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:12',0,'2014-03-02 05:17:40'),(19563,20213,'0000-00-00','ET','2',1,NULL,'LINDA SILAS','FI','436299221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:21:12',0,'2014-03-02 06:59:07'),(12406,12406,'2014-01-01','ET','2',1,NULL,'SUSAN DROKE','FI','270888910','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:50',0,'2014-03-01 16:35:14'),(2975,2975,'2014-01-01','ET','2',1,NULL,'GARY GAMBILL','94','0000227039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:24',0,'2014-03-01 15:37:30'),(7448,7448,'2014-01-01','ET','2',1,NULL,'Bradley Pierce','FI','459832618','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:23',0,'2014-03-02 04:10:25'),(7288,7288,'2014-01-01','ET','2',1,NULL,'Tim  Alan Webb','FI','294644728','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:21',0,'2014-03-10 13:32:15'),(4267,4267,'2014-01-01','ET','2',1,NULL,'LA TOYA BROWN','FI','436391194','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:20',0,'2014-03-02 03:09:49'),(4781,4781,'2014-01-01','ET','2',1,NULL,'Sam Rainer','FI','435432441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:18',0,'2014-03-01 21:11:04'),(11006,11006,'2014-01-01','ET','2',1,NULL,'Casenna Smith','FI','426598054','Starmount Life Insurance Company','FI','720977315','Casedra  Euell','94','14070191','348','2014-01-01','Sync Success',0,'2013-12-26 13:11:00',0,'2014-03-02 04:24:47'),(11556,11556,'2014-01-01','ET','2',1,NULL,'June Pape','FI','451190463','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:21',0,'2014-03-02 04:52:44'),(317,317,'2014-01-01','ET','2',1,NULL,'Virginia Riggins','FI','439725887','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:44',0,'2014-03-01 22:10:55'),(21281,21931,'0000-00-00','ET','2',1,NULL,'Roshanda Street','FI','587337588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-01 21:00:50',0,'2014-03-02 07:23:39'),(19015,19665,'0000-00-00','ET','2',1,NULL,'JANICE COLLINS','FI','300486268','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:25',0,'2014-03-10 14:31:05'),(15796,16445,'0000-00-00','ET','2',1,NULL,'JERRY SPAULDING','FI','541760357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:09',0,'2014-03-02 06:03:21'),(14887,15338,'2014-01-01','ET','2',1,NULL,'RUBY CORDOVA','FI','525155848','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:18',0,'2014-03-02 05:45:37'),(12935,12935,'2014-01-01','ET','2',1,NULL,'Amol Malshe','FI','256899022','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-04 02:06:18',0,'2014-03-10 13:59:38'),(7525,7525,'2014-01-01','ET','2',2,1,'Anton Stregl','FI','345449476','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:50',0,'2014-03-01 16:05:34'),(12063,12063,'2014-01-01','ET','2',2,1,'Victoria  Lewis','FI','283866924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:28',0,'2014-03-01 16:30:17'),(6180,6180,'2014-01-01','ET','2',2,1,'marlaine mccreight','FI','467718628','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:42',0,'2014-03-02 04:10:25'),(2057,2057,'2014-01-01','ET','2',1,NULL,'Patricia A Wojdacz','FI','300662830','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:39',0,'2014-03-10 15:45:56'),(4184,4184,'2014-01-01','ET','2',1,NULL,'MARTIN THOMAS','FI','288505467','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN P KELLY','94','2516200','348','2014-01-01','Sync Success',0,'2013-12-25 23:05:44',0,'2014-03-10 15:59:47'),(639,639,'2014-01-01','ET','2',1,NULL,'Jason Armour','FI','462916438','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:51',0,'2014-03-02 02:10:49'),(10821,10821,'2014-01-01','ET','2',1,NULL,'Shannon Alexis Bishop','FI','438499569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:34',0,'2014-03-02 04:31:46'),(10780,10780,'2014-01-01','ET','2',1,NULL,'JOVAN C LYMUEL','FI','437536557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:03:14',0,'2014-03-02 04:24:47'),(21236,21886,'0000-00-00','ET','2',1,NULL,'JEFFREY WARD','FI','372780981','HealthSpan','FI','311431434','DAVID  LEVETON','94','967966','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:20',0,'2014-03-10 14:45:25'),(10683,10683,'2014-01-01','ET','2',2,1,'Hayden Porter','FI','248613128','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:54',0,'2014-03-01 16:10:36'),(7089,7089,'2014-01-01','ET','2',1,NULL,'Camille Bizzarri','FI','566759445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:17',0,'2014-03-01 15:52:44'),(19876,20526,'0000-00-00','ET','2',1,NULL,'KEITH DAJA','FI','299463237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:25',0,'2014-03-01 17:47:19'),(19823,20473,'0000-00-00','ET','2',1,NULL,'JALYNSIA VONSHAY ERSKINE','FI','457753271','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:41',0,'2014-03-02 07:03:25'),(4077,4077,'2014-01-01','ET','2',1,NULL,'CHARLES ROWLAND','FI','296620546','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:36',0,'2014-03-01 15:52:44'),(16582,17232,'0000-00-00','ET','2',2,1,'Ericka Ahrmann','FI','270868642','HealthSpan','FI','311431434','Josh   Creagan','94','16157729','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:31',0,'2014-03-10 14:20:26'),(689,689,'2014-01-01','ET','2',1,NULL,'Alfred Hicks','FI','230356311','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:23',0,'2014-03-10 15:52:36'),(22219,22869,'0000-00-00','ET','2',1,NULL,'Thomas Jason Adams','FI','285888122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:53',0,'2014-03-06 21:36:23'),(21425,22075,'0000-00-00','ET','2',2,1,'sara highstreet','FI','435814746','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:29:58',0,'2014-03-03 22:26:43'),(3039,3039,'2014-01-01','ET','2',1,NULL,'Ruth Norton','FI','298505352','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:17',0,'2014-03-01 15:37:30'),(7289,7289,'2014-01-01','ET','2',1,NULL,'Justin Payne','FI','290785901','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:23',0,'2014-03-10 13:32:15'),(3280,3280,'2014-01-01','ET','2',1,NULL,'lupita diggins','FI','456278578','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:49',0,'2014-03-02 02:10:49'),(6249,6249,'2014-01-01','ET','2',1,NULL,'Latonya Kayelle Jackson','FI','439535309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:05:54',0,'2014-03-02 04:10:25'),(17853,18503,'0000-00-00','ET','2',1,NULL,'Bobby Bass','FI','435350777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:04',0,'2014-03-02 06:38:05'),(17634,18284,'0000-00-00','ET','2',1,NULL,'Shameka Smith','FI','425511705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:24',0,'2014-03-02 06:31:45'),(16726,17376,'0000-00-00','ET','2',1,NULL,'Vanessa Adams','FI','428415949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:36',0,'2014-03-02 06:17:30'),(6168,6168,'2014-01-01','ET','2',2,1,'JESSE GONSALES','FI','456330968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:22',0,'2014-03-02 04:10:25'),(3929,3929,'2014-01-01','ET','2',1,NULL,'Lee Brooker','FI','288549784','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:45:55',0,'2014-03-10 15:45:56'),(4121,4121,'2014-01-01','ET','2',1,NULL,'Leiann Mathis','FI','590769122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:52',0,'2014-03-01 16:00:27'),(13945,14301,'2014-01-01','ET','2',4,3,'Ruby Digonno','FI','403801641','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:30',0,'2014-03-10 14:03:26'),(4144,4144,'2014-01-01','ET','2',1,NULL,'Seema Chellath','FI','616737041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:30',0,'2014-03-01 16:00:27'),(592,592,'2014-01-01','ET','2',1,NULL,'Amber Thatcher','FI','300882235','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:03:20',0,'2014-03-10 13:24:34'),(20722,21372,'0000-00-00','ET','2',1,NULL,'Kiley E Carmichael','94','0001161590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:22',0,'2014-03-01 18:08:07'),(20593,21243,'0000-00-00','ET','2',1,NULL,'debra michaels','FI','302627394','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:44',0,'2014-03-01 18:08:07'),(20168,20818,'0000-00-00','ET','2',1,NULL,'CARLA HESTON','FI','277706130','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:07',0,'2014-03-01 18:08:07'),(19324,19974,'0000-00-00','ET','2',1,NULL,'Bau Nguyen','FI','634267585','Starmount Life Insurance Company','FI','720977315','Kim N Kelly','94','14395949','348','2014-04-01','Sync Success',0,'2014-02-18 22:00:14',0,'2014-03-02 06:59:07'),(19283,19933,'0000-00-00','ET','2',2,1,'Rodney Gay','FI','273589879','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-18 21:30:06',0,'2014-03-01 17:34:07'),(18364,19014,'0000-00-00','ET','2',1,NULL,'Alicia Greenwood','FI','462235863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:36',0,'2014-03-02 06:45:14'),(17586,18236,'0000-00-00','ET','2',1,NULL,'SHENIKA COOK','FI','297820144','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:01:02',0,'2014-03-10 16:24:30'),(16452,17102,'0000-00-00','ET','2',1,NULL,'Mark Ewart','FI','268749246','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:07',0,'2014-03-01 17:00:58'),(15948,16597,'0000-00-00','ET','2',1,NULL,'Ashaki Jerels','FI','284843607','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-25 19:00:20',NULL,NULL),(3531,3531,'2014-01-01','ET','2',1,NULL,'Elizabeth J Guider','FI','295509207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:11',0,'2014-03-01 15:31:33'),(663,663,'2014-01-01','ET','2',1,NULL,'SARAH KATHRYN BASSINGER','FI','455858781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:35',0,'2014-03-02 02:10:49'),(2837,2837,'2014-01-01','ET','2',1,NULL,'Lori Rodriguez','FI','450733637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:34',0,'2014-03-02 04:15:49'),(2703,2703,'2014-01-01','ET','2',1,NULL,'Kenneth Reeise','FI','512946799','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:17:19',0,'2014-03-02 04:15:49'),(6077,6077,'2014-01-01','ET','2',2,1,'REX E KING','FI','279661524','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:36',0,'2014-03-10 13:32:15'),(7603,7603,'2014-01-01','ET','2',1,NULL,'Gregory M Trbovich','FI','294480273','Summa Insurance Company, Inc.','FI','341809108','Deanna M Wells','94','7827930','348','2014-01-01','Sync Success',0,'2013-12-26 04:37:23',0,'2014-03-10 15:59:47'),(1021,1021,'2014-01-01','ET','2',1,NULL,'Ann Becnel','FI','222404752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:56',0,'2014-03-01 22:10:55'),(2520,2520,'2014-01-01','ET','2',1,0,'MARTHA BUTLER','FI','433840568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:38',0,'2014-03-01 19:11:03'),(6170,6170,'2014-01-01','ET','2',1,NULL,'LISA  COCKRELL','FI','548314137','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:26',0,'2014-03-02 04:10:25'),(11751,11751,'2014-01-01','ET','2',1,NULL,'joyce brown','FI','268608451','HealthSpan','FI','311431434','alfred joseph patchin','94','7685243','348','2014-02-01','Sync Success',1,'2013-12-29 11:09:29',0,'2014-03-10 13:52:32'),(20943,21593,'0000-00-00','ET','2',1,NULL,'wendy barnett','FI','290742136','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:35',0,'2014-03-10 16:38:05'),(19589,20239,'0000-00-00','ET','2',1,NULL,'David Park','FI','576433027','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:29:52',0,'2014-03-02 06:59:07'),(11770,11770,'2014-01-01','ET','2',1,NULL,'Gussie Guy','FI','439860269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:02',0,'2014-03-02 04:59:36'),(18869,19519,'0000-00-00','ET','2',1,NULL,'JOANNE E BURNS','FI','295441710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:39',0,'2014-03-01 17:34:07'),(17935,18585,'0000-00-00','ET','2',1,NULL,'James Michael Wheland','FI','467633384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:30:53',0,'2014-03-02 06:38:05'),(17550,18200,'0000-00-00','ET','2',2,1,'Edwin Gonzalez','FI','102782331','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:33',0,'2014-03-02 06:31:45'),(16311,16961,'0000-00-00','ET','2',2,1,'Brenda Vance','94','0000373656','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:30',0,'2014-03-01 16:56:22'),(10847,10847,'2014-01-01','ET','2',2,1,'Timothy Runk','FI','289583319','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:24',0,'2014-03-10 13:45:57'),(859,859,'2014-01-01','ET','2',1,NULL,'Paulette Snowden','FI','211407979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:56',0,'2014-03-01 22:10:55'),(19634,20284,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:39:07',0,'2014-03-01 17:47:19'),(6290,6290,'2014-01-01','ET','2',1,NULL,'Kenneth Goodly','FI','436371536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:07',0,'2014-03-02 04:10:25'),(15650,16299,'0000-00-00','ET','2',1,NULL,'Wanetta Collins','FI','297486769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:12',0,'2014-03-01 16:50:53'),(15602,16053,'0000-00-00','ET','2',4,3,'Roderick Caston','FI','433514003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:37',0,'2014-03-02 05:59:43'),(5770,5770,'2014-01-01','ET','2',1,NULL,'Rhonda Arnwine','FI','462438183','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:33',0,'2014-03-02 01:10:33'),(5668,5668,'2014-01-01','ET','2',1,NULL,'Wayne Scott','FI','069564728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:59',0,'2014-03-02 04:45:37'),(2363,2363,'2014-01-01','ET','2',2,1,'Barbara Marshall','FI','282506868','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:06',0,'2014-03-01 15:26:40'),(4768,4768,'2014-01-01','ET','2',1,NULL,'MARKO LUKICO','FI','627508705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:57',0,'2014-03-01 21:11:04'),(710,710,'2014-01-01','ET','2',2,1,'Debra Carmichael','FI','300424546','HealthSpan','FI','311431434','John A Guagenti','94','7990234','348','2014-01-01','Sync Success',0,'2013-12-25 18:07:03',0,'2014-03-10 13:24:34'),(22000,22650,'0000-00-00','ET','2',1,NULL,'JANICE SULLIVAN','FI','283483590','Summa Insurance Company, Inc.','FI','341809108','LARRY  MORIN','94','8328382','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:53',0,'2014-03-10 16:44:18'),(11067,11067,'2014-01-01','ET','2',1,NULL,'Kathy Steinwand','FI','277645382','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:03',0,'2014-03-10 16:03:49'),(5202,5202,'2014-01-01','ET','2',2,1,'Richard Morales','94','0000590762','Starmount Life Insurance Company','FI','720977315','DALE  ADAMS','94','8330750','348','2014-01-01','Sync Success',0,'2013-12-26 00:52:26',0,'2014-03-02 00:10:48'),(20948,21598,'0000-00-00','ET','2',1,NULL,'MICHAEL K COTTRELL','FI','270544369','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-28 07:00:42',0,'2014-03-10 14:37:47'),(19660,20310,'0000-00-00','ET','2',1,NULL,'Karen Kopis','FI','291626186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:05',0,'2014-03-01 17:47:19'),(1465,1465,'2014-01-01','ET','2',1,NULL,'Mary Margaret Beckford','FI','283548053','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:56:17',0,'2014-03-01 16:23:43'),(2303,2303,'2014-01-01','ET','2',1,NULL,'scott resor','FI','296722152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:19',0,'2014-03-01 15:05:09'),(17397,18047,'0000-00-00','ET','2',1,NULL,'CHRISTINA MARIE EVANS','FI','295760515','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:40',0,'2014-03-01 17:20:55'),(12200,12200,'2014-01-01','ET','2',1,NULL,'Ronald Keflar','FI','235171899','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-01 12:09:17',0,'2014-03-10 13:59:38'),(14428,14879,'2014-01-01','ET','2',1,NULL,'amanda williams','FI','284740187','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:20',0,'2014-03-10 14:03:26'),(11596,11596,'2014-01-01','ET','2',1,NULL,'Amanda Edwards','FI','425631858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:37',0,'2014-03-02 04:52:44'),(22505,23155,'0000-00-00','ET','2',1,NULL,'JUANITA HOLMES','FI','574025037','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:14',0,'2014-03-07 22:26:59'),(15521,15972,'0000-00-00','ET','2',2,1,'Rosa Garcia','FI','547257809','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:00',0,'2014-03-02 05:59:43'),(16838,17488,'0000-00-00','ET','2',1,NULL,'Elizabeth Priess','FI','283465220','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:17',0,'2014-03-01 17:00:58'),(2302,2302,'2014-01-01','ET','2',1,NULL,'Mary Nottingham','FI','578767446','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:17',0,'2014-03-01 15:05:09'),(1784,1784,'2014-01-01','ET','2',1,NULL,'Nancy Crego','FI','283562806','HealthSpan','FI','311431434','James  Hitchings','94','1866145','348','2014-01-01','Sync Success',0,'2013-12-25 19:19:06',0,'2014-03-10 13:20:27'),(1364,1364,'2014-01-01','ET','2',1,NULL,'Thai Lam','FI','586304312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:52',0,'2014-03-02 04:38:08'),(3252,3252,'2014-01-01','ET','2',1,NULL,'Keegan McCormick','FI','270942225','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:54',0,'2014-03-01 15:52:44'),(20219,20869,'0000-00-00','ET','2',1,NULL,'joscelyn Johnson','FI','251897167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:45',0,'2014-03-02 07:10:28'),(19301,19951,'0000-00-00','ET','2',1,NULL,'Carolyn Kerns','FI','461697728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:19',0,'2014-03-02 06:59:07'),(5146,5146,'2014-01-01','ET','2',2,1,'Robin West','FI','302582014','Summa Insurance Company, Inc.','FI','341809108','Scott D Prior','94','8416481','348','2014-01-01','Sync Success',0,'2013-12-26 00:50:41',0,'2014-03-10 15:45:56'),(4643,4643,'2014-01-01','ET','2',2,1,'Mark Chambless','FI','465252306','Starmount Life Insurance Company','FI','720977315','Josue  Ayala','94','16618982','348','2014-01-01','Sync Success',0,'2013-12-25 23:48:40',0,'2014-03-02 04:38:08'),(17322,17972,'0000-00-00','ET','2',2,1,'david s leveton','FI','290446296','HealthSpan','FI','311431434','david  leveton','94','967966','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:07',0,'2014-03-10 14:24:38'),(7408,7408,'2014-01-01','ET','2',1,NULL,'SETH WATSON','FI','433532546','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:07',0,'2014-03-02 04:10:25'),(4033,4033,'2014-01-01','ET','2',1,NULL,'Jennifer Law','FI','627108608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:09',0,'2014-03-02 03:09:49'),(3310,3310,'2014-01-01','ET','2',1,NULL,'Aaron Goode','FI','295602125','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:48',0,'2014-03-01 15:52:44'),(13993,14349,'2014-01-01','ET','2',1,NULL,'Patricia Coker','FI','439906141','Starmount Life Insurance Company','FI','720977315','Tammy Champlin Edwards','94','7899419','348','2014-02-01','Sync Success',0,'2014-01-13 03:01:24',0,'2014-03-02 05:31:31'),(22712,23362,'0000-00-00','ET','2',1,NULL,'kayla cole','FI','268944797','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-08 21:31:07',0,'2014-03-10 14:50:59'),(13613,13969,'2014-01-01','ET','2',1,NULL,'Larry A Bolek','FI','277540912','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:34',0,'2014-03-01 16:40:16'),(13191,13547,'2014-01-01','ET','2',1,NULL,'rochelle jackson','FI','026625838','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-07 04:06:19',0,'2014-03-10 13:59:38'),(21298,21948,'0000-00-00','ET','2',1,NULL,'BARBARA COXE','FI','270500332','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:04',0,'2014-03-10 16:38:05'),(20493,21143,'0000-00-00','ET','2',1,NULL,'Kiana Koning','FI','193623266','Summa Insurance Company, Inc.','FI','341809108','Tara  Krol','94','3400836','357','2014-04-01','Sync Success',0,'2014-02-26 21:00:40',0,'2014-03-10 16:38:05'),(19457,20107,'0000-00-00','ET','2',1,NULL,'angela tutton','FI','461274089','Starmount Life Insurance Company','FI','720977315','Julie   Tooze','94','17073136','348','2014-04-01','Sync Success',0,'2014-02-20 03:44:52',0,'2014-03-02 06:59:07'),(18157,18807,'0000-00-00','ET','2',1,NULL,'Carrie Burford','FI','416231365','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-02-26','Sync Success',0,'2014-02-11 21:01:21',0,'2014-03-02 06:38:05'),(3229,3229,'2014-01-01','ET','2',1,NULL,'Luther White','FI','280660376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:13',0,'2014-03-01 15:52:44'),(3506,3506,'2014-01-01','ET','2',1,NULL,'ROBIN BURGER','FI','296705831','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:24',0,'2014-03-01 15:37:30'),(15429,15880,'0000-00-00','ET','2',1,NULL,'DEBORAH LEE VARGO','FI','287541072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:28',0,'2014-03-01 16:50:53'),(3620,3620,'2014-01-01','ET','2',1,NULL,'HOLLY PATTERSON','FI','450556458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:58',0,'2014-03-02 01:10:33'),(763,763,'2014-01-01','ET','2',1,NULL,'Jason Lee Jones','FI','284744340','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:47',0,'2014-03-10 13:24:34'),(10572,10572,'2014-01-01','ET','2',1,NULL,'Heather Mayes','FI','457594793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:56:16',0,'2014-03-02 04:24:47'),(3927,3927,'2014-01-01','ET','2',1,NULL,'DONNA SOMOGYI','FI','275522753','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:52',0,'2014-03-01 15:26:40'),(3209,3209,'2014-01-01','ET','2',1,NULL,'Jeffery Griffith','FI','277562485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:45:37',0,'2014-03-01 15:48:04'),(2946,2946,'2014-01-01','ET','2',1,NULL,'NORMAN JOHN MERCER','FI','272444946','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:27',0,'2014-03-01 15:37:30'),(2969,2969,'2014-01-01','ET','2',1,NULL,'christopher creatura','FI','287668695','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:11',0,'2014-03-01 15:37:30'),(3026,3026,'2014-01-01','ET','2',1,NULL,'Amber Knight','FI','297743547','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:54',0,'2014-03-01 15:37:30'),(20589,21239,'0000-00-00','ET','2',4,3,'YVONNE  TAYLOR','FI','286866910','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:41',0,'2014-03-01 18:08:07'),(20373,21023,'0000-00-00','ET','2',1,NULL,'DEETTA NEAL','FI','274605270','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:02',0,'2014-03-10 14:37:47'),(12652,12652,'2014-01-01','ET','2',1,NULL,'Martha Epperson','FI','459879349','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:00',0,'2014-03-02 05:10:52'),(14845,15296,'2014-01-01','ET','2',1,NULL,'Regenia Lane','94','0000630399','HealthSpan','FI','311431434','Ken  Jones','94','1888068','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:28',0,'2014-03-10 14:03:26'),(11847,11847,'2014-01-01','ET','2',2,1,'Angela Wiechers','FI','113543085','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:39',0,'2014-03-01 16:15:39'),(13703,14059,'2014-01-01','ET','2',1,NULL,'Deborah Washington','FI','283669251','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:42',0,'2014-03-01 16:40:16'),(10401,10401,'2014-01-01','ET','2',1,NULL,'riley m reves','FI','279020983','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:46',0,'2014-03-01 16:10:36'),(2446,2446,'2014-01-01','ET','2',2,1,'Timothy J White','FI','458083400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:44',0,'2014-03-01 23:10:52'),(2971,2971,'2014-01-01','ET','2',2,1,'Bruce Edward Bigham','FI','289888665','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:15',0,'2014-03-01 15:37:30'),(1160,1160,'2014-01-01','ET','2',1,NULL,'joan savage','FI','437503267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:29',0,'2014-03-02 04:38:08'),(21899,22549,'0000-00-00','ET','2',1,NULL,'JOVAN W MILLER','FI','467630180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:43',0,'2014-03-05 22:27:33'),(20511,21161,'0000-00-00','ET','2',1,NULL,'Edward Salas','FI','631103968','Starmount Life Insurance Company','FI','720977315','mack e covell','94','4769712','348','2014-03-01','Sync Success',0,'2014-02-26 21:00:50',0,'2014-03-02 07:17:36'),(1290,1290,'2014-01-01','ET','2',1,NULL,'Vernon Archer','FI','427553153','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:29',0,'2014-03-02 04:38:08'),(17661,18311,'0000-00-00','ET','2',1,NULL,'Richard Stage','FI','575809067','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:42',0,'2014-03-01 17:20:55'),(16930,17580,'0000-00-00','ET','2',1,NULL,'SHENIKA LOFTON','FI','426650923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:45',0,'2014-03-02 06:17:30'),(16447,17097,'0000-00-00','ET','2',1,NULL,'River Manda Lay','FI','297139371','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-30 21:00:05',0,'2014-03-01 17:00:58'),(15437,15888,'0000-00-00','ET','2',1,NULL,'Lisa Catsoulakis','FI','282722869','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:33',0,'2014-03-10 16:17:47'),(14763,15214,'2014-01-01','ET','2',1,NULL,'susan reidling','FI','270481173','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:34',0,'2014-03-10 14:03:26'),(13827,14183,'2014-01-01','ET','2',1,NULL,'Heather Rawlins','FI','637308939','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:31',0,'2014-03-02 05:31:31'),(12219,12219,'2014-01-01','ET','2',1,NULL,'Phelisa Renae  Smith','FI','426375084','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:22:12',0,'2014-03-02 05:03:29'),(5818,5818,'2014-01-01','ET','2',1,NULL,'Todd Siebert','FI','522118806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:04:09',0,'2014-03-10 13:24:34'),(1803,1803,'2014-01-01','ET','2',1,NULL,'Jacqueline Edwards','FI','272608453','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:44',0,'2014-03-10 13:20:27'),(3234,3234,'2014-01-01','ET','2',1,NULL,'grace Gottenbusch','FI','301681809','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:21',0,'2014-03-01 15:52:44'),(851,851,'2014-01-01','ET','2',1,NULL,'PATRICIA KUBECZKA','FI','466922960','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:41',0,'2014-03-01 22:10:55'),(20508,21158,'0000-00-00','ET','2',1,NULL,'Ashley Gentris','FI','438492414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:48',0,'2014-03-02 07:17:36'),(19231,19881,'0000-00-00','ET','2',1,NULL,'liza garcia','FI','631224611','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:24',0,'2014-03-02 06:52:12'),(18803,19453,'0000-00-00','ET','2',4,3,'Tina Hamp','FI','407110552','HealthSpan','FI','311431434','Ashley Hayden McBride','94','13171651','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:10',0,'2014-03-10 14:31:05'),(1699,1699,'2014-01-01','ET','2',1,NULL,'Anthony Coleman','FI','436219873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:27',0,'2014-03-02 00:10:48'),(3326,3326,'2014-01-01','ET','2',1,NULL,'Laura Tisher','FI','295728783','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:24',0,'2014-03-10 15:52:36'),(15421,15872,'0000-00-00','ET','2',1,NULL,'Whitney Zohnd','FI','280906393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:23',0,'2014-03-01 16:50:53'),(3461,3461,'2014-01-01','ET','2',1,NULL,'Patrick Quaintance','FI','270863992','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-25 21:53:40',0,'2014-03-10 13:32:15'),(11068,11068,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:13:05',0,'2014-03-10 16:03:49'),(10964,10964,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:33',0,'2014-03-10 16:03:49'),(6028,6028,'2014-01-01','ET','2',1,NULL,'Juana Ganica','FI','290987358','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:49',0,'2014-03-01 15:10:22'),(20294,20944,'0000-00-00','ET','2',1,NULL,'Corey Mason','FI','297702292','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:38',0,'2014-03-01 18:08:07'),(5657,5657,'2014-01-01','ET','2',3,2,'Richard Bauer','FI','302527820','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:32',0,'2014-03-10 13:52:32'),(5576,5576,'2014-01-01','ET','2',1,NULL,'SHAUN RAO','FI','627164324','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:53',0,'2014-03-02 04:45:37'),(4893,4893,'2014-01-01','ET','2',2,1,'Michael Higham','FI','285745640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:17:08',0,'2014-03-01 15:05:09'),(1902,1902,'2014-01-01','ET','2',1,NULL,'hermelinda solis','FI','464190275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:49',0,'2014-03-01 23:10:52'),(14343,14794,'2014-01-01','ET','2',1,NULL,'Sandra Simmons','FI','466840637','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:43',0,'2014-03-02 05:45:37'),(12054,12054,'2014-01-01','ET','2',1,NULL,'Rashad Jones','FI','638128261','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:04:09',0,'2014-03-02 04:59:36'),(10910,10910,'2014-01-01','ET','2',2,1,'James Bull','FI','285706242','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:07:58',0,'2014-03-10 15:59:47'),(6158,6158,'2014-01-01','ET','2',2,1,'Mark Moore','FI','466080804','Starmount Life Insurance Company','FI','720977315','James  Banh','94','3184001','348','2014-01-01','Sync Success',0,'2013-12-26 03:03:06',0,'2014-03-02 04:10:25'),(17729,18379,'0000-00-00','ET','2',1,NULL,'TRINH QUAN','FI','439935228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:21',0,'2014-03-02 06:31:45'),(17193,17843,'0000-00-00','ET','2',2,1,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:00:06',0,'2014-03-02 06:24:38'),(15756,16405,'0000-00-00','ET','2',1,NULL,'Earline Johnson','FI','587136376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:01:26',0,'2014-03-02 05:59:43'),(3800,3800,'2014-01-01','ET','2',3,2,'Carlton Bonner','FI','285663882','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:18',0,'2014-03-10 15:45:56'),(3614,3614,'2014-01-01','ET','2',1,NULL,'Connie J Madrigal','FI','270562507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:47',0,'2014-03-10 13:20:27'),(2699,2699,'2014-01-01','ET','2',2,1,'Matthew William Curry','FI','452454305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:10',0,'2014-03-02 04:15:49'),(2567,2567,'2014-01-01','ET','2',1,0,'sloane pellegrini','FI','329725537','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:09',0,'2014-03-01 19:11:03'),(2036,2036,'2014-01-01','ET','2',2,1,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:00',0,'2014-03-02 00:10:48'),(2394,2394,'2014-01-01','ET','2',1,NULL,'Diana L Perley','FI','449965647','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:01',0,'2014-03-01 23:10:52'),(22914,23564,'0000-00-00','ET','2',1,NULL,'stephen michael phillips','FI','437659425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:51',0,'2014-03-10 21:27:11'),(2263,2263,'2014-01-01','ET','2',1,NULL,'JAMES BANKEMPER','FI','299564507','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:50:23',0,'2014-03-10 13:10:24'),(20912,21562,'0000-00-00','ET','2',1,NULL,'Wendy Barnett','FI','290742136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:06',0,'2014-03-01 18:08:07'),(2314,2314,'2014-01-01','ET','2',1,NULL,'David A Gambatese','FI','269561617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:42',0,'2014-03-01 15:05:09'),(2526,2526,'2014-01-01','ET','2',1,NULL,'tana ryals','FI','218946516','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:49',0,'2014-03-01 20:10:57'),(3723,3723,'2014-01-01','ET','2',1,NULL,'JERI JEANNE SIMMONS','FI','271587193','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:08:18',0,'2014-03-10 13:20:27'),(12487,12487,'2014-01-01','ET','2',2,1,'Heather Haines','FI','286724532','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:32:49',0,'2014-03-01 16:35:14'),(23018,23668,'0000-00-00','ET','2',1,NULL,'Jeremy Flowers','FI','426695333','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:04',0,'2014-03-10 21:27:11'),(22375,23025,'0000-00-00','ET','2',1,NULL,'DEADIRA CASTILLO','FI','457838127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:22',0,'2014-03-07 21:25:22'),(22199,22849,'0000-00-00','ET','2',1,NULL,'ROSEVELT WARDELL','FI','425968608','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:39',0,'2014-03-06 21:27:26'),(22165,22815,'0000-00-00','ET','2',2,1,'EVAN GEARY','FI','326823351','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:14',0,'2014-03-06 21:36:23'),(21951,22601,'0000-00-00','ET','2',1,NULL,'Frances LEE','FI','437062524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:31:19',0,'2014-03-05 22:27:33'),(19975,20625,'0000-00-00','ET','2',1,NULL,'TODD VODRAZKA','FI','269563711','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:35',0,'2014-03-01 17:47:19'),(19358,20008,'0000-00-00','ET','2',1,NULL,'Amalia Babb','FI','637246493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:39',0,'2014-03-02 06:59:07'),(4399,4399,'2014-01-01','ET','2',1,NULL,'Lisa Sue Hall','FI','295522719','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:54',0,'2014-03-10 15:39:19'),(7209,7209,'2014-01-01','ET','2',1,NULL,'Leonard Kadlub','94','0001167969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:55',0,'2014-03-01 15:52:44'),(15943,16592,'0000-00-00','ET','2',1,NULL,'Mary Melnek','94','0000377492','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-01-25 19:00:17',0,'2014-03-10 14:20:26'),(7183,7183,'2014-01-01','ET','2',1,NULL,'Tabitha Marble','FI','450810465','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:06:07',0,'2014-03-02 02:10:49'),(4850,4850,'2014-01-01','ET','2',1,NULL,'Sylvia Micozzi','FI','162448889','Summa Insurance Company, Inc.','FI','341809108','WILLIAM  MCILROY','94','8267605','348','2014-01-01','Sync Success',0,'2013-12-26 00:15:36',0,'2014-03-10 15:39:19'),(879,879,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:16:34',0,'2014-03-01 15:21:15'),(2004,2004,'2014-01-01','ET','2',1,NULL,'DJ John Rodrigue','FI','433063426','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:59',0,'2014-03-01 23:10:52'),(2246,2246,'2014-01-01','ET','2',1,NULL,'Susan Rainwater','FI','438967018','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:47',0,'2014-03-01 21:11:04'),(18607,19257,'0000-00-00','ET','2',2,1,'Jesus Mireles Ruiz','FI','288132698','Summa Insurance Company, Inc.','FI','341809108','Eric  Vought','94','16465976','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:40',0,'2014-03-10 16:31:33'),(3499,3499,'2014-01-01','ET','2',1,NULL,'Tara  J Nelson','FI','275882610','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:10',0,'2014-03-01 15:37:30'),(2598,2598,'2014-01-01','ET','2',1,0,'michael krohn','FI','271702849','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:58',0,'2014-03-01 15:05:09'),(18150,18800,'0000-00-00','ET','2',2,1,'zenda watson','FI','439199006','Starmount Life Insurance Company','FI','720977315','wayne  landwerlin','94','1632529','348','2014-03-01','Sync Success',0,'2014-02-11 21:01:15',0,'2014-03-02 06:38:05'),(13004,13004,'2014-01-01','ET','2',1,NULL,'Chad Wilkins','FI','433730838','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:15',0,'2014-03-02 05:17:40'),(16176,16825,'0000-00-00','ET','2',1,NULL,'Michael Munro','FI','237793185','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:23',0,'2014-03-01 16:56:22'),(655,655,'2014-01-01','ET','2',1,NULL,'Bryan Marsh Bell','FI','453804353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:05:23',0,'2014-03-02 02:10:49'),(1507,1507,'2014-01-01','ET','2',2,1,'Douglas Thielenhaus','FI','501744196','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:36',0,'2014-03-10 16:03:49'),(21674,22324,'0000-00-00','ET','2',2,1,'Sheila Gibson','FI','587335049','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:16',0,'2014-03-04 21:27:16'),(7464,7464,'2014-01-01','ET','2',1,NULL,'Diana Anderson','FI','464924245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:47',0,'2014-03-02 04:15:49'),(18826,19476,'0000-00-00','ET','2',1,NULL,'cedrick johnson','FI','450372806','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:09',0,'2014-03-02 06:52:12'),(17797,18447,'0000-00-00','ET','2',1,NULL,'jordan behr','FI','271924842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:31',0,'2014-03-01 16:56:22'),(17236,17886,'0000-00-00','ET','2',1,NULL,'Cindy Fahey','FI','292868702','Summa Insurance Company, Inc.','FI','341809108','Barbara  Silvey','94','8108024','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:24',0,'2014-03-10 16:24:30'),(5150,5150,'2014-01-01','ET','2',1,NULL,'Ernest Eberhard','FI','299527916','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:48',0,'2014-03-10 15:52:36'),(15837,16486,'0000-00-00','ET','2',2,1,'Jeffrey Evans','FI','204421211','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:33',0,'2014-03-01 16:56:22'),(4311,4311,'2014-01-01','ET','2',1,NULL,'Lydell Emerson','FI','439351796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:09:35',0,'2014-03-02 03:09:49'),(13401,13757,'2014-01-01','ET','2',1,NULL,'Gregory Keller','FI','463028064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:55',0,'2014-03-02 05:24:45'),(11344,11344,'2014-01-01','ET','2',1,NULL,'MARY WASHINGTON','FI','461987262','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:04:50',0,'2014-03-02 04:52:44'),(21136,21786,'0000-00-00','ET','2',1,NULL,'ERICA JONES','FI','434493756','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 21:31:12',0,'2014-03-02 07:17:36'),(20186,20836,'0000-00-00','ET','2',1,NULL,'CARMEN T MOLINA','FI','457947030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:20',0,'2014-03-02 07:10:28'),(3810,3810,'2014-01-01','ET','2',1,NULL,'Christopher Yam','FI','412537745','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:41',0,'2014-03-01 15:26:40'),(13480,13836,'2014-01-01','ET','2',1,NULL,'Shammery Whitelaw','FI','412575949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:39',0,'2014-03-02 05:31:31'),(19644,20294,'0000-00-00','ET','2',1,NULL,'Benjamin Troendly','FI','282888063','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:41:54',0,'2014-03-01 17:47:19'),(14315,14766,'2014-01-01','ET','2',2,1,'Crystal Zacarias-Camarillo','FI','465594625','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:31',0,'2014-03-02 05:38:34'),(3456,3456,'2014-01-01','ET','2',1,NULL,'Gregory Chandler','FI','496586540','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:53:32',0,'2014-03-10 13:32:15'),(21942,22592,'0000-00-00','ET','2',1,NULL,'CHEYENNE WALKER','FI','436411676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:13',0,'2014-03-05 22:27:33'),(7584,7584,'2014-01-01','ET','2',2,1,'JILL ECCARD','FI','285660717','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:48',0,'2014-03-01 16:05:34'),(7553,7553,'2014-01-01','ET','2',2,1,'Jodi Lynn Steele','FI','289580541','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:35:43',0,'2014-03-01 16:05:34'),(16822,17472,'0000-00-00','ET','2',1,NULL,'Jennifer Thomas','FI','107701529','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:08',0,'2014-03-02 06:17:30'),(15723,16372,'0000-00-00','ET','2',1,NULL,'Marian Padilla','FI','435671094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:04',0,'2014-03-02 06:03:21'),(7172,7172,'2014-01-01','ET','2',1,NULL,'Dennis Vanke','FI','271542348','Summa Insurance Company, Inc.','FI','341809108','Mark   Herwick','94','7462692','348','2014-01-01','Sync Success',0,'2013-12-26 04:05:47',0,'2014-03-10 15:59:47'),(11951,11951,'2014-01-01','ET','2',1,NULL,'Emma Tardif','FI','415693624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:14',0,'2014-03-02 04:59:36'),(3779,3779,'2014-01-01','ET','2',1,NULL,'Teresa Adams','FI','297746110','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:38',0,'2014-03-01 15:26:40'),(13579,13935,'2014-01-01','ET','2',1,NULL,'Lenora Irvin','FI','296504729','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:10',0,'2014-03-10 16:10:34'),(14890,15341,'2014-01-01','ET','2',1,NULL,'Michael A Trolinger','FI','466234225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:19',0,'2014-03-02 05:45:37'),(15309,15760,'0000-00-00','ET','2',1,NULL,'MICHAEL BUTTRAM','FI','269769865','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:23',0,'2014-03-01 16:50:53'),(20339,20989,'0000-00-00','ET','2',1,NULL,'Cory Williamson','FI','435450285','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:29',0,'2014-03-02 07:03:25'),(17945,18595,'0000-00-00','ET','2',1,NULL,'Lashun Johnson','FI','395829528','Starmount Life Insurance Company','FI','720977315','Wayne  Moore','94','17097315','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:59',0,'2014-03-02 06:38:05'),(17090,17740,'0000-00-00','ET','2',1,NULL,'KATHLEEN MCGEE','FI','278523842','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-04 21:00:54',0,'2014-03-01 17:00:58'),(18535,19185,'0000-00-00','ET','2',3,2,'Steven Payten','FI','302642350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:05',0,'2014-03-01 17:26:36'),(22160,22810,'0000-00-00','ET','2',1,NULL,'Jasmine Rose Ruffner','FI','281920974','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:11',0,'2014-03-06 21:36:23'),(1052,1052,'2014-01-01','ET','2',1,NULL,'John D Herr','FI','194488664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:21',0,'2014-03-01 21:11:04'),(6405,6405,'2014-01-01','ET','2',2,1,'Christine King','FI','298787926','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-26 03:10:37',0,'2014-03-10 13:39:10'),(5756,5756,'2014-01-01','ET','2',1,NULL,'Clinton Graham','FI','386980417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:07',0,'2014-03-02 01:10:33'),(14683,15134,'2014-01-01','ET','2',1,NULL,'stephen anthony','FI','296880737','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:43',0,'2014-03-01 16:46:19'),(3741,3741,'2014-01-01','ET','2',1,NULL,'Lesha D Self-Stoehr','FI','307887141','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:08:54',0,'2014-03-10 13:20:27'),(4782,4782,'2014-01-01','ET','2',2,1,'Thang Nguyen','FI','433456964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:21',0,'2014-03-01 21:11:04'),(18992,19642,'0000-00-00','ET','2',1,NULL,'Gerard Germani','FI','380824943','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:08',0,'2014-03-10 14:31:05'),(19930,20580,'0000-00-00','ET','2',1,NULL,'Tommy a Slocum','FI','434575266','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-21 21:30:23',0,'2014-03-02 07:03:25'),(21718,22368,'0000-00-00','ET','2',2,1,'Brian P Feeheley','FI','369701196','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:53',0,'2014-03-04 21:27:16'),(22941,23591,'0000-00-00','ET','2',1,NULL,'PATRICK ONDRAYKA','FI','268523316','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-04-01','Sync Success',0,'2014-03-10 21:01:11',0,'2014-03-10 21:07:22'),(11545,11545,'2014-01-01','ET','2',1,NULL,'steven mancine','FI','007469873','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:32:59',0,'2014-03-02 04:52:44'),(5342,5342,'2014-01-01','ET','2',2,1,'Thanh Vo','FI','278157068','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:34',0,'2014-03-01 15:10:22'),(13052,13408,'2014-01-01','ET','2',1,NULL,'SHANE ARABIE','FI','437257397','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:01:11',0,'2014-03-02 05:17:40'),(13678,14034,'2014-01-01','ET','2',1,NULL,'Shovon Crenshaw','FI','571197949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:21:27',0,'2014-03-02 05:24:45'),(18429,19079,'0000-00-00','ET','2',1,NULL,'valerie frances hill','FI','289782693','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:24',0,'2014-03-01 17:26:36'),(19296,19946,'0000-00-00','ET','2',1,NULL,'Deborah Holmes','FI','271665136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 21:30:15',0,'2014-03-10 14:31:05'),(3296,3296,'2014-01-01','ET','2',1,NULL,'DAVID KING','FI','302586256','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:19',0,'2014-03-01 15:48:04'),(18047,18697,'0000-00-00','ET','2',2,1,'Eric Spencer','FI','291663158','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:11',0,'2014-03-10 14:24:38'),(12688,12688,'2014-01-01','ET','2',1,NULL,'Christopher Morris','FI','289862629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:16',0,'2014-03-01 16:35:14'),(16899,17549,'0000-00-00','ET','2',2,1,'Shilpa Chaparala','FI','459392994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:26',0,'2014-03-02 06:24:38'),(16497,17147,'0000-00-00','ET','2',1,NULL,'brenda douglass','FI','450433506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:35',0,'2014-03-02 06:10:30'),(16114,16763,'0000-00-00','ET','2',1,NULL,'Linda a Barrett','FI','587665103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:28',0,'2014-03-02 06:03:21'),(15509,15960,'0000-00-00','ET','2',1,NULL,'Addison Williams','FI','632223524','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:55',0,'2014-03-02 05:59:43'),(10699,10699,'2014-01-01','ET','2',1,NULL,'David Cobb','FI','257439198','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:30',0,'2014-03-01 16:10:36'),(10508,10508,'2014-01-01','ET','2',1,NULL,'amber roane','FI','272881002','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:07',0,'2014-03-01 16:15:39'),(14416,14867,'2014-01-01','ET','2',1,NULL,'Robert Hydrick','FI','425653510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:14',0,'2014-03-02 05:38:34'),(12965,12965,'2014-01-01','ET','2',1,NULL,'Linda Kindle','FI','459157141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:55',0,'2014-03-02 05:17:40'),(7221,7221,'2014-01-01','ET','2',1,NULL,'Judith Sengewald','FI','302529078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:15',0,'2014-03-01 15:52:44'),(18943,19593,'0000-00-00','ET','2',1,NULL,'KYLIE GREEN','FI','628199001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:33',0,'2014-03-02 06:52:12'),(21409,22059,'0000-00-00','ET','2',1,NULL,'ALBA CISNEROS','FI','456938640','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:16',0,'2014-03-03 21:25:18'),(22077,22727,'0000-00-00','ET','2',3,2,'Cecil Larry','FI','449252894','Starmount Life Insurance Company','FI','720977315','Erik   Nelson','94','8337791','348','2014-04-01','Sync Success',0,'2014-03-06 21:00:11',0,'2014-03-06 21:27:26'),(842,842,'2014-01-01','ET','2',1,NULL,'Melissa Cheung','FI','503967204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:25',0,'2014-03-01 21:11:04'),(1830,1830,'2014-01-01','ET','2',2,1,'Thanh Hoang','FI','594416904','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:34',0,'2014-03-10 13:20:27'),(14260,14711,'2014-01-01','ET','2',1,NULL,'Catherine Otto','FI','343629800','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:06',0,'2014-03-01 16:46:19'),(13645,14001,'2014-01-01','ET','2',1,NULL,'JAYNE BRAMMER','FI','292646071','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:58',0,'2014-03-10 14:03:26'),(13624,13980,'2014-01-01','ET','2',2,1,'Rodger Rohrs','FI','279529405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:42',0,'2014-03-10 16:10:34'),(13604,13960,'2014-01-01','ET','2',2,1,'Anita Hess','FI','272769248','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:27',0,'2014-03-01 16:40:16'),(3127,3127,'2014-01-01','ET','2',1,NULL,'alicia melissa zamora','FI','643056357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:02',0,'2014-03-02 01:10:33'),(5671,5671,'2014-01-01','ET','2',1,NULL,'Melpomeni Koulakiotis','FI','463953304','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:52:05',0,'2014-03-02 04:45:37'),(21193,21843,'0000-00-00','ET','2',1,NULL,'MARY BELOW','FI','290520015','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:54',0,'2014-03-10 14:45:25'),(22347,22997,'0000-00-00','ET','2',2,1,'thomalena kingsland','FI','272745728','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:10',0,'2014-03-07 21:36:32'),(12051,12051,'2014-01-01','ET','2',2,1,'Brandie Graves','FI','454756457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:04:02',0,'2014-03-02 04:59:36'),(17278,17928,'0000-00-00','ET','2',1,NULL,'Lisa Hill','FI','463355260','Starmount Life Insurance Company','FI','720977315','James  Parent','94','8774027','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:44',0,'2014-03-02 06:24:38'),(11718,11718,'2014-01-01','ET','2',1,NULL,'MONIQUE MIKES','FI','551170541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:28',0,'2014-03-02 04:59:36'),(16903,17553,'0000-00-00','ET','2',1,NULL,'Simone Butcher','FI','324868210','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:29',0,'2014-03-01 17:00:58'),(3657,3657,'2014-01-01','ET','2',1,NULL,'James P Reikowsky','FI','302541407','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:09',0,'2014-03-10 15:52:36'),(13542,13898,'2014-01-01','ET','2',1,NULL,'Gregory  Herbert','FI','437952872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:44',0,'2014-03-02 05:24:45'),(5625,5625,'2014-01-01','ET','2',1,NULL,'Rafael Lopez','FI','102586232','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:32',0,'2014-03-10 16:03:49'),(6030,6030,'2014-01-01','ET','2',1,NULL,'Ann Crock','FI','293862374','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:53',0,'2014-03-10 13:03:33'),(6221,6221,'2014-01-01','ET','2',6,5,'Amy Scott','FI','280586611','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:56',0,'2014-03-01 16:00:27'),(7492,7492,'2014-01-01','ET','2',2,1,'UWIMANA KAMIYA','FI','631661702','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:46',0,'2014-03-01 16:05:34'),(10954,10954,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:20',0,'2014-03-10 16:03:49'),(19341,19991,'0000-00-00','ET','2',1,NULL,'RYAN HARRIS','FI','173669388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:27',0,'2014-03-02 06:59:07'),(20817,21467,'0000-00-00','ET','2',1,NULL,'Linda Bonner','FI','366601345','Starmount Life Insurance Company','FI','720977315','Julie  Tooze','94','17073136','357','2014-03-01','Sync Success',0,'2014-02-28 06:31:07',0,'2014-03-02 07:17:36'),(22034,22684,'0000-00-00','ET','2',1,NULL,'MARILYN CONNER','FI','453374872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:16',0,'2014-03-05 22:27:33'),(22710,23360,'0000-00-00','ET','2',1,NULL,'IRMA SMITH','FI','438219768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:06',0,'2014-03-08 22:26:18'),(11771,11771,'2014-01-01','ET','2',1,NULL,'Gussie Guy','FI','439860269','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:10:03',0,'2014-03-02 04:59:36'),(18285,18935,'0000-00-00','ET','2',1,NULL,'Danny Guitreau','FI','437118134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:15',0,'2014-03-02 06:38:05'),(1561,1561,'2014-01-01','ET','2',1,NULL,'david hartmann','FI','277841435','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:22',0,'2014-03-10 13:52:32'),(17492,18142,'0000-00-00','ET','2',1,NULL,'AMY  CARTER','FI','281848431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:49',0,'2014-03-10 14:24:38'),(1836,1836,'2014-01-01','ET','2',2,1,'Terence Smith','FI','379786658','HealthSpan','FI','311431434','Philip  Dubois','94','2345683','348','2014-01-01','Sync Success',0,'2013-12-25 19:20:48',0,'2014-03-10 13:20:27'),(15687,16336,'0000-00-00','ET','2',2,1,'ROBIN LACHELLE SHIELDS','FI','447625638','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:39',0,'2014-03-02 05:59:43'),(15681,16330,'0000-00-00','ET','2',1,NULL,'LINDA BARRIOS','FI','463968260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:35',0,'2014-03-02 05:59:43'),(1961,1961,'2014-01-01','ET','2',1,NULL,'Anthony brown','FI','278700701','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:32',0,'2014-03-01 15:26:40'),(13250,13606,'2014-01-01','ET','2',2,1,'CRISTINA MARIE UHRICK','FI','278646373','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:03',0,'2014-03-10 13:59:38'),(13344,13700,'2014-01-01','ET','2',1,NULL,'Brent Franz','FI','335787065','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:29',0,'2014-03-01 16:40:16'),(4699,4699,'2014-01-01','ET','2',1,NULL,'Alexis Greely','FI','439710186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:38',0,'2014-03-02 04:31:46'),(14994,15445,'2014-01-01','ET','2',1,NULL,'Sheila Hill','FI','330627594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:07',0,'2014-03-02 05:45:37'),(14175,14626,'2014-01-01','ET','2',1,NULL,'David Horneck','FI','286589928','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:23',0,'2014-03-10 16:17:47'),(3635,3635,'2014-01-01','ET','2',1,NULL,'lisa gabriel','FI','017462145','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:05:27',0,'2014-03-10 15:52:36'),(3363,3363,'2014-01-01','ET','2',1,NULL,'YUVETTE ELAINE ERWIN','FI','449436835','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:31',0,'2014-03-02 02:10:49'),(3140,3140,'2014-01-01','ET','2',2,1,'Paul Bailey','FI','296668342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:24',0,'2014-03-10 13:24:34'),(2772,2772,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:25',0,'2014-03-01 16:05:34'),(18931,19581,'0000-00-00','ET','2',1,NULL,'Carol Kunzin','FI','296685236','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:31:24',0,'2014-03-10 16:31:33'),(20671,21321,'0000-00-00','ET','2',1,NULL,'Edward Jackson','FI','277582449','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 21:02:42',0,'2014-03-10 14:37:47'),(22524,23174,'0000-00-00','ET','2',1,NULL,'Chloe Mallardi','FI','283946661','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:28',0,'2014-03-07 21:36:32'),(15626,16077,'0000-00-00','ET','2',2,1,'Tanya Rodgers','FI','280708638','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:49',0,'2014-03-10 16:17:47'),(16066,16715,'0000-00-00','ET','2',1,NULL,'ELIZABETH PALL','FI','049564548','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-27 21:00:53',0,'2014-03-01 16:56:22'),(23094,23744,'0000-00-00','ET','2',1,NULL,'Catherine Darnell','FI','291488518','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-03-10 21:03:03',0,'2014-03-10 21:17:52'),(12874,12874,'2014-01-01','ET','2',1,NULL,'Robert Greene','FI','285940204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:56',0,'2014-03-01 16:35:14'),(7012,7012,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:54',0,'2014-03-02 03:09:49'),(4729,4729,'2014-01-01','ET','2',1,NULL,'Dean Maxey','FI','276548147','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:41',0,'2014-03-10 13:45:57'),(20208,20858,'0000-00-00','ET','2',1,NULL,'MARIA ANTONIA BROWN','FI','462633997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:37',0,'2014-03-02 07:10:28'),(22479,23129,'0000-00-00','ET','2',1,NULL,'SHIRLEY FREEMAN','FI','271609502','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:56',0,'2014-03-07 21:36:32'),(486,486,'2014-01-01','ET','2',1,NULL,'BRET STETHEN  PALMER','FI','273729250','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:00:02',0,'2014-03-01 15:48:04'),(18235,18885,'0000-00-00','ET','2',3,2,'Charles B Keiffer','FI','291763528','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:23',0,'2014-03-10 14:24:38'),(873,873,'2014-01-01','ET','2',2,1,'George Sarkis','FI','290747813','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:24',0,'2014-03-01 15:21:15'),(18643,19293,'0000-00-00','ET','2',2,1,'Pamela Cress','FI','270441680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:07',0,'2014-03-01 17:26:36'),(18008,18658,'0000-00-00','ET','2',1,NULL,'Andrew Hruska','FI','494065266','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:45',0,'2014-03-10 14:24:38'),(14274,14725,'2014-01-01','ET','2',1,NULL,'SUSAN SURGEN','FI','268521650','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:13',0,'2014-03-01 16:46:19'),(12789,12789,'2014-01-01','ET','2',1,NULL,'GEORGIA GREEN','FI','550333425','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:52',0,'2014-03-02 05:10:52'),(5209,5209,'2014-01-01','ET','2',1,NULL,'jennifer mathews','FI','452610951','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:39',0,'2014-03-02 00:10:48'),(4619,4619,'2014-01-01','ET','2',1,NULL,'Bonnie Eisenman','FI','444483462','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:51',0,'2014-03-02 04:31:46'),(4511,4511,'2014-01-01','ET','2',1,NULL,'Brandon Johnson','FI','569574361','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:25',0,'2014-03-01 15:16:37'),(20986,21636,'0000-00-00','ET','2',1,NULL,'Fred Casby','FI','433113802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:29',0,'2014-03-02 07:17:36'),(22493,23143,'0000-00-00','ET','2',1,NULL,'kadir adem','FI','295110969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:05',0,'2014-03-07 21:36:32'),(4005,4005,'2014-01-01','ET','2',1,NULL,'Sylvia Lee','FI','460676130','Starmount Life Insurance Company','FI','720977315','DAVID  EDWARDS','94','565219','348','2014-01-01','Sync Success',0,'2013-12-25 23:00:18',0,'2014-03-02 03:09:49'),(7233,7233,'2014-01-01','ET','2',1,NULL,'AMOS  ELLIS','FI','270901132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:07:40',0,'2014-03-01 15:52:44'),(16227,16876,'0000-00-00','ET','2',1,NULL,'lena lollar','FI','461456460','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:57',0,'2014-03-02 06:10:30'),(14370,14821,'2014-01-01','ET','2',1,NULL,'MARY K ROCK','FI','275504012','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:54',0,'2014-03-10 16:17:47'),(13753,14109,'2014-01-01','ET','2',1,NULL,'Jonathan Hook','FI','311623389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:16',0,'2014-03-02 05:24:45'),(13533,13889,'2014-01-01','ET','2',1,NULL,'CYNTHIA LOCHER','FI','279569248','Dental Care Plus, Inc.','FI','311185262','Benson  Jones','94','7890601','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:38',0,'2014-03-01 16:40:16'),(5762,5762,'2014-01-01','ET','2',1,NULL,'Paresh Patel','FI','731072354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:17',0,'2014-03-02 01:10:33'),(4742,4742,'2014-01-01','ET','2',1,NULL,'Kathleen Temple','FI','268502660','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:11',0,'2014-03-10 13:45:57'),(22540,23190,'0000-00-00','ET','2',1,NULL,'Nancy Graf','FI','302667411','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:39',0,'2014-03-07 21:36:32'),(1005,1005,'2014-01-01','ET','2',1,NULL,'Gwendolyn Kundtz','FI','276800942','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:26',0,'2014-03-10 15:39:19'),(18061,18711,'0000-00-00','ET','2',3,2,'TAN CHAU','FI','729263193','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:08',0,'2014-03-02 06:38:05'),(2896,2896,'2014-01-01','ET','2',1,NULL,'Melanie Green','FI','299869327','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:23:36',0,'2014-03-10 13:39:10'),(12996,12996,'2014-01-01','ET','2',2,1,'Jess Gross','FI','282708098','Summa Insurance Company, Inc.','FI','341809108','Melissa  Wartman','94','15704453','348','2014-02-01','Sync Success',0,'2014-01-05 00:01:59',0,'2014-03-10 16:10:34'),(4247,4247,'2014-01-01','ET','2',1,NULL,'jennifer weygandt','FI','273802726','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:42',0,'2014-03-10 15:59:47'),(14728,15179,'2014-01-01','ET','2',1,NULL,'JOHN PLAUCHE','FI','433960540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:13',0,'2014-03-02 05:45:37'),(7347,7347,'2014-01-01','ET','2',1,NULL,'Lynne Blair','FI','439849928','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:23',0,'2014-03-01 21:11:04'),(12673,12673,'2014-01-01','ET','2',1,NULL,'Trena Hershberger','FI','284861773','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:03:46',0,'2014-03-01 16:35:14'),(729,729,'2014-01-01','ET','2',1,NULL,'Nohora Byrd','FI','769545828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:44',0,'2014-03-02 02:10:49'),(2596,2596,'2014-01-01','ET','2',2,1,'kayla cole','FI','268944797','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:52',0,'2014-03-10 13:03:33'),(22394,23044,'0000-00-00','ET','2',1,NULL,'Karen Spray','FI','275662924','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:33',0,'2014-03-10 14:50:59'),(21750,22400,'0000-00-00','ET','2',1,NULL,'PATRICIA N MARSHALL','FI','285586147','Summa Insurance Company, Inc.','FI','341809108','ALICE  RHODES','94','7814748','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:20',0,'2014-03-10 16:44:18'),(12492,12492,'2014-01-01','ET','2',1,NULL,'Mary Erby','FI','587361791','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:04',0,'2014-03-02 05:03:29'),(12552,12552,'2014-01-01','ET','2',1,NULL,'CYNTHIA PEPPEL','FI','383560750','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:19',0,'2014-03-10 16:10:34'),(15094,15545,'0000-00-00','ET','2',1,NULL,'Staci Armstrong','FI','459875502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:45',0,'2014-03-02 05:52:31'),(198,198,'2014-01-01','ET','2',1,NULL,'Catherine Riester','FI','279429869','HealthSpan','FI','311431434','Jennifer  Lindsay','94','15344208','348','2014-01-01','Sync Success',0,'2013-12-25 17:21:11',0,'2014-03-10 13:10:24'),(21228,21878,'0000-00-00','ET','2',1,NULL,'Trinidad Isabel Gomez','FI','457991512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:15',0,'2014-03-02 07:23:39'),(3294,3294,'2014-01-01','ET','2',1,NULL,'Abigail Eash','94','0000295470','Dental Care Plus, Inc.','FI','311185262','Michael  Wehner','94','1865975','348','2014-01-01','Sync Success',0,'2013-12-25 21:48:16',0,'2014-03-01 15:48:04'),(20459,21109,'0000-00-00','ET','2',1,NULL,'Shante Carson','FI','292862494','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:15',0,'2014-03-01 18:08:07'),(19989,20639,'0000-00-00','ET','2',1,NULL,'Brandi Michelle Lambert','FI','437495945','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:44',0,'2014-03-02 07:03:25'),(4986,4986,'2014-01-01','ET','2',1,NULL,'Pamela Riffle','FI','302504928','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:32',0,'2014-03-01 15:31:33'),(13141,13497,'2014-01-01','ET','2',1,NULL,'John Sutton','FI','483082349','HealthSpan','FI','311431434','Kenneth E Poston','94','1645003','348','2014-02-01','Sync Success',0,'2014-01-07 04:04:32',0,'2014-03-10 13:59:38'),(17556,18206,'0000-00-00','ET','2',1,NULL,'TYRA BRADFORD','FI','462656052','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:38',0,'2014-03-02 06:31:45'),(17019,17669,'0000-00-00','ET','2',2,1,'Kimberly Scott','FI','437599749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:10',0,'2014-03-02 06:24:38'),(1988,1988,'2014-01-01','ET','2',1,NULL,'Pam Srebernak','FI','273643827','Summa Insurance Company, Inc.','FI','341809108','Ronald  Haines','94','2759626','348','2014-01-01','Sync Success',0,'2013-12-25 19:34:24',0,'2014-03-10 15:45:56'),(3042,3042,'2014-01-01','ET','2',1,NULL,'Linda Kurtzman','FI','185403549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:22',0,'2014-03-01 15:37:30'),(20785,21435,'0000-00-00','ET','2',1,NULL,'CHERYL LING','FI','269643643','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:51',0,'2014-03-10 16:38:05'),(7074,7074,'2014-01-01','ET','2',1,NULL,'Nancy Ann Brewer','FI','299567614','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:48',0,'2014-03-01 15:52:44'),(19205,19855,'0000-00-00','ET','2',1,NULL,'Michael Grenier','FI','393685816','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:11',0,'2014-03-10 14:31:05'),(18664,19314,'0000-00-00','ET','2',1,NULL,'Diana Banda','FI','636164215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:24',0,'2014-03-02 06:45:14'),(3512,3512,'2014-01-01','ET','2',1,NULL,'Deborah Regina Hodges','FI','235846640','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:01:36',0,'2014-03-01 15:37:30'),(12306,12306,'2014-01-01','ET','2',1,NULL,'Holly Bonner','FI','289842352','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:31',0,'2014-03-10 16:10:34'),(13972,14328,'2014-01-01','ET','2',1,NULL,'Erin Waters','FI','644189350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:09',0,'2014-03-02 05:31:31'),(17709,18359,'0000-00-00','ET','2',1,NULL,'marvin ramsey','FI','438829757','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-09 19:00:08',0,'2014-03-02 06:31:45'),(11278,11278,'2014-01-01','ET','2',1,NULL,'Brandi Hopkins','FI','433634814','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:50',0,'2014-03-02 04:52:44'),(1036,1036,'2014-01-01','ET','2',1,NULL,'SHEILA  R HIRSCHFELD','FI','291483629','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:21:24',0,'2014-03-10 13:10:24'),(13139,13495,'2014-01-01','ET','2',1,NULL,'Diana Miller','FI','297469967','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:04:26',0,'2014-03-10 13:59:38'),(16776,17426,'0000-00-00','ET','2',1,NULL,'Justin Stacy','FI','283922379','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:26',0,'2014-03-01 17:00:58'),(17370,18020,'0000-00-00','ET','2',2,1,'khamtanh pradichith','FI','464835106','Starmount Life Insurance Company','FI','720977315','John Lee Wells','94','17128887','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:21',0,'2014-03-02 06:31:45'),(17463,18113,'0000-00-00','ET','2',1,NULL,'Antwon Bloxson','FI','593506798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:26',0,'2014-03-02 06:31:45'),(17962,18612,'0000-00-00','ET','2',2,1,'MINGJUAN NI','FI','285046048','Dental Care Plus, Inc.','FI','311185262','Fang  YING','94','8225079','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:12',0,'2014-03-01 17:20:55'),(18589,19239,'0000-00-00','ET','2',1,NULL,'STEPHANIE R WARD','FI','277111848','Dental Care Plus, Inc.','FI','311185262','TERRY M STONE','94','7223954','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:26',0,'2014-03-01 17:26:36'),(7097,7097,'2014-01-01','ET','2',1,NULL,'Harland Dabbs','FI','276680422','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:03:31',0,'2014-03-01 15:52:44'),(1892,1892,'2014-01-01','ET','2',1,NULL,'sheryl pollard','FI','461882588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:31',0,'2014-03-01 23:10:52'),(19167,19817,'0000-00-00','ET','2',1,NULL,'Eva Lewis','FI','465048178','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:36',0,'2014-03-02 06:52:12'),(18721,19371,'0000-00-00','ET','2',1,NULL,'FRANCISCA TOVAR','FI','640203612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:08',0,'2014-03-02 06:45:14'),(5397,5397,'2014-01-01','ET','2',1,NULL,'Maria Acosta','FI','463252162','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:05',0,'2014-03-01 20:10:57'),(18406,19056,'0000-00-00','ET','2',1,NULL,'Richard Skowronski','FI','118505097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:05',0,'2014-03-01 17:26:36'),(17068,17718,'0000-00-00','ET','2',2,1,'Terrisha Harris','FI','429515506','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:40',0,'2014-03-02 06:24:38'),(2167,2167,'2014-01-01','ET','2',2,1,'Ronald Brandt','FI','277526561','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:01',0,'2014-03-01 15:16:37'),(12144,12144,'2014-01-01','ET','2',1,NULL,'Michael  Humphries','FI','587881627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:07:15',0,'2014-03-02 04:59:36'),(13553,13909,'2014-01-01','ET','2',1,NULL,'Meshonda Hurst','FI','437712956','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:50',0,'2014-03-02 05:24:45'),(1888,1888,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:31:26',0,'2014-03-01 23:10:52'),(22073,22723,'0000-00-00','ET','2',1,NULL,'BEVERLY SHAFFER','FI','274508833','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:45',0,'2014-03-10 14:45:25'),(21981,22631,'0000-00-00','ET','2',1,NULL,'MARY LEE LOVE','FI','426195337','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:40',0,'2014-03-05 22:27:33'),(21656,22306,'0000-00-00','ET','2',1,NULL,'JOHN F BURGESS','FI','273560050','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:03',0,'2014-03-04 21:36:30'),(20747,21397,'0000-00-00','ET','2',1,NULL,'ALBERTA SCOTT','FI','304564452','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:34',0,'2014-03-02 07:17:36'),(10544,10544,'2014-01-01','ET','2',1,NULL,'Vicente pillado','FI','635242381','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:55:18',0,'2014-03-02 04:15:49'),(19402,20052,'0000-00-00','ET','2',1,NULL,'Christopher Ragonesi','FI','041642831','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:10',0,'2014-03-10 14:31:05'),(18318,18968,'0000-00-00','ET','2',1,NULL,'SCOTT KAMAN','FI','269802686','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:03',0,'2014-03-01 17:26:36'),(2295,2295,'2014-01-01','ET','2',1,NULL,'Zachary Aaron Felger','FI','298940704','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:01',0,'2014-03-01 15:10:22'),(16527,17177,'0000-00-00','ET','2',1,NULL,'Irwin Lee Lemmons','FI','458278232','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:55',0,'2014-03-02 06:10:30'),(15049,15500,'2014-01-01','ET','2',1,NULL,'Jan Boyea','FI','299525024','Summa Insurance Company, Inc.','FI','341809108','Rick  Lohr','94','15886837','348','2014-03-01','Sync Success',0,'2014-01-17 03:36:30',0,'2014-03-10 16:17:47'),(14777,15228,'2014-01-01','ET','2',1,NULL,'Barbara Fahnle','FI','402646505','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:43',0,'2014-03-10 14:03:26'),(12932,12932,'2014-01-01','ET','2',4,3,'Noel Wallbridge','FI','299928500','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:06:08',0,'2014-03-10 13:59:38'),(4216,4216,'2014-01-01','ET','2',2,1,'Jeffrey Miller','FI','275748017','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:42',0,'2014-03-01 15:52:44'),(4037,4037,'2014-01-01','ET','2',1,NULL,'Tucker Bailey','FI','627011925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:01:16',0,'2014-03-02 03:09:49'),(694,694,'2014-01-01','ET','2',1,NULL,'Angelica Pozo','FI','103464017','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:33',0,'2014-03-10 13:24:34'),(1411,1411,'2014-01-01','ET','2',1,NULL,'BRENDA YOUNG','FI','439982458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:23',0,'2014-03-02 04:45:37'),(22108,22758,'0000-00-00','ET','2',1,NULL,'MARY ROBINSON','FI','455863129','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:35',0,'2014-03-06 21:27:26'),(20831,21481,'0000-00-00','ET','2',2,1,'ELOY GARZA','FI','307580682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:13',0,'2014-03-02 07:17:36'),(20727,21377,'0000-00-00','ET','2',2,1,'CAROL FOUT','FI','269589262','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:25',0,'2014-03-01 18:10:11'),(4979,4979,'2014-01-01','ET','2',1,NULL,'randy miller','FI','289528760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:45:20',0,'2014-03-01 15:31:33'),(12904,12904,'2014-01-01','ET','2',1,NULL,'Jeremy Jernigan','FI','587653224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:03',0,'2014-03-02 05:10:52'),(12966,12966,'2014-01-01','ET','2',2,1,'Ayad Othman','FI','465616359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:00:58',0,'2014-03-02 05:17:40'),(16419,17069,'0000-00-00','ET','2',1,NULL,'Mary L Traxler','FI','271602385','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:38',0,'2014-03-10 14:20:26'),(16213,16862,'0000-00-00','ET','2',1,NULL,'JAMES BALDWIN','FI','557430979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:48',0,'2014-03-02 06:10:30'),(15007,15458,'2014-01-01','ET','2',1,NULL,'MICHELLE EVANS','FI','298603245','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:13',0,'2014-03-10 16:17:47'),(1771,1771,'2014-01-01','ET','2',2,1,'Melanie H Rick','FI','433196933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:38',0,'2014-03-02 00:10:48'),(6432,6432,'2014-01-01','ET','2',1,NULL,'Kayla Muncy','FI','281921705','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:29',0,'2014-03-01 15:10:22'),(20120,20770,'0000-00-00','ET','2',1,NULL,'Jessica Clark','FI','278865861','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-25 21:30:34',0,'2014-03-01 18:08:07'),(2768,2768,'2014-01-01','ET','2',1,NULL,'Hollie Stephens','FI','285864901','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:17',0,'2014-03-01 16:05:34'),(4391,4391,'2014-01-01','ET','2',1,NULL,'winnie chan','FI','095447949','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:40',0,'2014-03-01 15:16:37'),(4087,4087,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:54',0,'2014-03-01 16:00:27'),(3729,3729,'2014-01-01','ET','2',1,NULL,'John Scott Kulwicki','FI','283428806','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-01-01','Sync Success',0,'2013-12-25 22:08:32',0,'2014-03-10 13:20:27'),(11945,11945,'2014-01-01','ET','2',2,1,'Mario Abascal','FI','564692245','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:03',0,'2014-03-02 04:59:36'),(6450,6450,'2014-01-01','ET','2',1,NULL,'Crystal Ulibarri','FI','585493094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:05',0,'2014-03-01 20:10:57'),(10458,10458,'2014-01-01','ET','2',1,NULL,'EILEEN BENNETT','FI','298584196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:34',0,'2014-03-01 16:10:36'),(12940,12940,'2014-01-01','ET','2',4,3,'Assanatu Iddrissu','FI','302110340','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2014-01-04 06:00:09',0,'2014-03-01 15:48:04'),(11120,11120,'2014-01-01','ET','2',1,NULL,'Judith Clemons','94','0000976716','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:48',0,'2014-03-10 13:39:10'),(22001,22651,'0000-00-00','ET','2',1,NULL,'Kellee Wright','FI','288829205','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:31:53',0,'2014-03-05 21:36:22'),(646,646,'2014-01-01','ET','2',1,NULL,'JEFFREY W  DAVIS','FI','539621542','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:07',0,'2014-03-02 02:10:49'),(18189,18839,'0000-00-00','ET','2',2,1,'Scott Newcome','FI','298787068','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:43',0,'2014-03-01 17:26:36'),(17936,18586,'0000-00-00','ET','2',1,NULL,'Harry Granoff','FI','061443497','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:54',0,'2014-03-02 06:38:05'),(6209,6209,'2014-01-01','ET','2',2,1,'Jeffrey Hawkins','FI','298441578','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:34',0,'2014-03-01 16:00:27'),(16677,17327,'0000-00-00','ET','2',1,NULL,'Timothy Smith','FI','344620281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:00',0,'2014-03-02 06:17:30'),(1299,1299,'2014-01-01','ET','2',1,NULL,'Linda Lollar','FI','587644268','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:46',0,'2014-03-02 04:38:08'),(5921,5921,'2014-01-01','ET','2',3,2,'Jehangir Sadiq','FI','301946106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:26',0,'2014-03-01 15:48:04'),(2066,2066,'2014-01-01','ET','2',1,NULL,'RAYMOND SNOW','FI','308521238','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:59',0,'2014-03-10 13:20:27'),(2612,2612,'2014-01-01','ET','2',1,0,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 20:46:22',0,'2014-03-10 13:03:33'),(4151,4151,'2014-01-01','ET','2',1,NULL,'Murad Hanna','FI','791044628','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:04:42',0,'2014-03-01 16:00:27'),(2731,2731,'2014-01-01','ET','2',1,NULL,'Amy Scott','FI','437298433','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:10',0,'2014-03-02 04:15:49'),(3009,3009,'2014-01-01','ET','2',2,1,'serena may schuck','FI','298842729','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:24',0,'2014-03-10 15:52:36'),(2811,2811,'2014-01-01','ET','2',1,NULL,'Bryan Brookover','FI','287880978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:40',0,'2014-03-01 16:05:34'),(1557,1557,'2014-01-01','ET','2',2,1,'CORY SEELING','FI','281847114','HealthSpan','FI','311431434','SAMUEL  BRAUEN','94','14449933','348','2014-01-01','Sync Success',0,'2013-12-25 18:59:14',0,'2014-03-10 13:52:32'),(3165,3165,'2014-01-01','ET','2',1,NULL,'CYNTHIA LOUISE BENSON','FI','301460281','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:16',0,'2014-03-10 15:52:36'),(7746,7746,'2014-01-01','ET','2',1,NULL,'Lisa Ashcroft','FI','276709725','NOT AVAILABLE','FI','123456789',NULL,NULL,NULL,'348','2014-01-01','Received',0,'2013-12-26 05:00:43',NULL,NULL),(16336,16986,'0000-00-00','ET','2',1,NULL,'JAMES KIRSCH','FI','277744184','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-29 21:00:45',0,'2014-03-01 16:56:22'),(4745,4745,'2014-01-01','ET','2',1,NULL,'Kara Louisa Lindelof','FI','027644543','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:00:07',0,'2014-03-10 13:03:33'),(15990,16639,'0000-00-00','ET','2',2,1,'Restem Omer','FI','645179203','Starmount Life Insurance Company','FI','720977315','Dominga T Sancjhez','94','1302662','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:04',0,'2014-03-02 06:03:21'),(21301,21951,'0000-00-00','ET','2',2,1,'Terry Kulow','FI','222485689','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:01:07',0,'2014-03-10 16:38:05'),(22499,23149,'0000-00-00','ET','2',4,3,'Justin Serio','FI','354705340','HealthSpan','FI','311431434','Kirk  Bernhard','94','2828814','348','2014-04-01','Sync Success',0,'2014-03-07 21:31:09',0,'2014-03-10 14:50:59'),(278,278,'2014-01-01','ET','2',1,NULL,'elizabeth walker','FI','298600156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:55',0,'2014-03-01 15:05:09'),(17271,17921,'0000-00-00','ET','2',1,NULL,'YOLANDA NAVARRO','FI','641250020','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:40',0,'2014-03-02 06:24:38'),(16957,17607,'0000-00-00','ET','2',2,1,'JEFFREY MARKEY','FI','156740080','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:01:03',0,'2014-03-02 06:24:38'),(16186,16835,'0000-00-00','ET','2',1,NULL,'ELENORA JAMES','FI','405966443','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:29',0,'2014-03-01 16:56:22'),(15977,16626,'0000-00-00','ET','2',1,NULL,'Robert  Smith','FI','569943820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:21',0,'2014-03-01 16:56:22'),(10746,10746,'2014-01-01','ET','2',1,NULL,'debra dearing','FI','233946307','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:05',0,'2014-03-01 16:10:36'),(14213,14664,'2014-01-01','ET','2',1,NULL,'DOUGLAS MASTERS','FI','272721309','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:49',0,'2014-03-10 14:03:26'),(4924,4924,'2014-01-01','ET','2',1,0,'David Allan Hudson','FI','453876264','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 00:30:56',0,'2014-03-01 19:11:03'),(20640,21290,'0000-00-00','ET','2',1,NULL,'ANTONIO ROGERS','FI','427553620','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:02:17',0,'2014-03-02 07:10:28'),(21929,22579,'0000-00-00','ET','2',2,1,'ALICIA TORRES','FI','464900955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:03',0,'2014-03-05 22:27:33'),(1347,1347,'2014-01-01','ET','2',1,NULL,'Oralia Munoz','FI','465416785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:20',0,'2014-03-02 04:38:08'),(5724,5724,'2014-01-01','ET','2',1,NULL,'CHARLES PARKS','FI','296846874','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:09',0,'2014-03-01 15:48:04'),(15606,16057,'0000-00-00','ET','2',1,NULL,'Stephanie Brown','FI','437512881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:39',0,'2014-03-02 05:59:43'),(33,33,'2014-01-01','ET','2',1,NULL,'LARRY H MCKINNEY','FI','299482279','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:59',0,'2014-03-01 15:21:15'),(12411,12411,'2014-01-01','ET','2',1,NULL,'Michael Anthony Maldonado','FI','282461213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:04',0,'2014-03-01 16:35:14'),(11032,11032,'2014-01-01','ET','2',1,NULL,'Debra Jenkins','FI','272546712','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:53',0,'2014-03-10 15:59:47'),(19199,19849,'0000-00-00','ET','2',2,1,'Holly Stolarski','FI','299622875','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:02:05',0,'2014-03-10 14:31:05'),(3124,3124,'2014-01-01','ET','2',3,2,'CHRISTINA MOOMEY','FI','299544798','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:55',0,'2014-03-10 13:24:34'),(3476,3476,'2014-01-01','ET','2',1,NULL,'Susan Goodfellow','FI','290560248','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:26',0,'2014-03-01 15:31:33'),(22898,23548,'0000-00-00','ET','2',1,NULL,'Jonathan WILLINGHAM','FI','273848166','Dental Care Plus, Inc.','FI','311185262','PHIL J WHEELER','94','2439373','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:39',0,'2014-03-10 21:36:25'),(3645,3645,'2014-01-01','ET','2',1,NULL,'Joan Drake','FI','381485881','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:05:46',0,'2014-03-10 13:20:27'),(18093,18743,'0000-00-00','ET','2',1,NULL,'Dora Gaitan','FI','640014359','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:33',0,'2014-03-02 06:38:05'),(17465,18115,'0000-00-00','ET','2',1,NULL,'LILLIAN FOLEY','FI','437313747','Starmount Life Insurance Company','FI','720977315','MICHAEL   KIRSCHMAN','94','16151038','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:28',0,'2014-03-02 06:31:45'),(17014,17664,'0000-00-00','ET','2',2,1,'Cynthia Williams','FI','570088167','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:07',0,'2014-03-02 06:24:38'),(4793,4793,'2014-01-01','ET','2',1,NULL,'PAMELA MOORE','FI','282620597','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:41',0,'2014-03-01 15:16:37'),(15549,16000,'0000-00-00','ET','2',1,NULL,'CHRISTINA ONWUCHEKWA','FI','643104236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:13',0,'2014-03-02 05:59:43'),(11162,11162,'2014-01-01','ET','2',2,1,'Cosette Verga','FI','218491885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:22',0,'2014-03-10 13:45:57'),(5092,5092,'2014-01-01','ET','2',1,NULL,'Evelie Gravois','FI','433046457','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:48:56',0,'2014-03-02 00:10:48'),(11939,11939,'2014-01-01','ET','2',1,NULL,'katina duran','FI','291789753','HealthSpan','FI','311431434','katina  duran','94','998990','348','2014-02-01','Sync Success',0,'2013-12-30 00:02:17',0,'2014-03-10 13:52:32'),(21526,22176,'0000-00-00','ET','2',1,NULL,'Danna Thomas Dixon','FI','450020930','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:14',0,'2014-03-03 22:26:43'),(21698,22348,'0000-00-00','ET','2',1,NULL,'Amanda Badertscher','FI','284805311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:37',0,'2014-03-04 21:36:30'),(20003,20653,'0000-00-00','ET','2',1,NULL,'Clara McGee','FI','427412244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:55',0,'2014-03-02 07:03:25'),(18665,19315,'0000-00-00','ET','2',6,5,'Shahala Greyard','FI','565437904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:25',0,'2014-03-02 06:45:14'),(13379,13735,'2014-01-01','ET','2',1,NULL,'BALINDA COOLEY','FI','445508103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:45',0,'2014-03-02 05:24:45'),(17645,18295,'0000-00-00','ET','2',4,3,'Timothy Hartwig','FI','290584923','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:32',0,'2014-03-01 17:20:55'),(16617,17267,'0000-00-00','ET','2',1,NULL,'Ida Rodriguez','FI','467350471','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:19',0,'2014-03-02 06:17:30'),(15985,16634,'0000-00-00','ET','2',1,NULL,'Megan Fries','FI','277908287','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:28',0,'2014-03-10 14:20:26'),(15198,15649,'0000-00-00','ET','2',1,NULL,'Leroy Simpson','FI','439515310','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-03-01','Sync Success',0,'2014-01-21 08:44:23',0,'2014-03-02 05:52:31'),(3408,3408,'2014-01-01','ET','2',1,NULL,'vicki kramer','FI','291509823','HealthSpan','FI','311431434','donald  wiechart','94','1498942','348','2014-01-01','Sync Success',0,'2013-12-25 21:51:57',0,'2014-03-10 13:24:34'),(3834,3834,'2014-01-01','ET','2',1,NULL,'Molly Sotherden','FI','120625841','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:30:05',0,'2014-03-10 15:39:19'),(20491,21141,'0000-00-00','ET','2',1,NULL,'KYLE FORGACS','FI','293946078','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN P KELLY','94','2516200','348','2014-04-01','Sync Success',0,'2014-02-26 21:00:39',0,'2014-03-10 16:38:05'),(12329,12329,'2014-01-01','ET','2',1,NULL,'stacy pecan','FI','454534265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:10',0,'2014-03-02 05:03:29'),(12107,12107,'2014-01-01','ET','2',1,NULL,'SHARRON KORNEGAY','FI','577764413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:58',0,'2014-03-01 16:30:17'),(19636,20286,'0000-00-00','ET','2',2,1,'Melanie Dawn Lovingshimer','FI','289724784','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:39:33',0,'2014-03-01 17:47:19'),(3305,3305,'2014-01-01','ET','2',3,2,'Rachel Shamy','FI','268885750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:39',0,'2014-03-01 15:52:44'),(5572,5572,'2014-01-01','ET','2',1,NULL,'Jane Thomas','FI','086744747','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:44',0,'2014-03-02 04:45:37'),(15195,15646,'0000-00-00','ET','2',1,NULL,'Jordan Ray Miller','94','0000422842','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:21',0,'2014-03-10 16:17:47'),(17700,18350,'0000-00-00','ET','2',1,NULL,'Isaac Quaye','FI','752134585','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-08 19:30:10',0,'2014-03-10 14:24:38'),(17069,17719,'0000-00-00','ET','2',1,NULL,'Meagan Crider','FI','457977105','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:41',0,'2014-03-02 06:24:38'),(15456,15907,'0000-00-00','ET','2',1,NULL,'Douglas Vignos','FI','294627675','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:22:46',0,'2014-03-01 16:50:53'),(21635,22285,'0000-00-00','ET','2',2,1,'Ivan Dominguez','FI','572838768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:47',0,'2014-03-04 21:27:16'),(22404,23054,'0000-00-00','ET','2',1,NULL,'AL FRANK','FI','431579908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:02',0,'2014-03-07 22:26:59'),(14371,14822,'2014-01-01','ET','2',1,NULL,'Lupe Reyes','FI','274546455','Summa Insurance Company, Inc.','FI','341809108','Eric J Vought','94','16465976','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:54',0,'2014-03-10 16:17:47'),(19444,20094,'0000-00-00','ET','2',1,NULL,'Frank Civitarese','FI','289787703','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:41',0,'2014-03-10 16:31:33'),(2035,2035,'2014-01-01','ET','2',2,1,'Richard Pevey','FI','435845309','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:57',0,'2014-03-02 00:10:48'),(10481,10481,'2014-01-01','ET','2',1,NULL,'MICHAEL ALAN SANBORN','FI','230847839','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:18',0,'2014-03-01 16:10:36'),(2636,2636,'2014-01-01','ET','2',1,NULL,'Terrie Milton','FI','587415275','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:10',0,'2014-03-01 21:11:04'),(2937,2937,'2014-01-01','ET','2',1,NULL,'Kathryn Justin','FI','369563997','Dental Care Plus, Inc.','FI','311185262','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-25 21:31:09',0,'2014-03-01 15:37:30'),(22763,23413,'0000-00-00','ET','2',1,NULL,'jennifer a rayo','FI','454759067','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:21',0,'2014-03-09 21:26:00'),(14437,14888,'2014-01-01','ET','2',1,NULL,'Janell Brierley','FI','436865758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:25',0,'2014-03-02 05:38:34'),(13372,13728,'2014-01-01','ET','2',1,NULL,'CINTHYA MORALES','FI','631583819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:42',0,'2014-03-02 05:24:45'),(18479,19129,'0000-00-00','ET','2',1,NULL,'Lon Zaerr','FI','489704586','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:56',0,'2014-03-10 14:31:05'),(18356,19006,'0000-00-00','ET','2',1,NULL,'Chris Goldsum','FI','458234068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:30',0,'2014-03-02 06:45:14'),(12600,12600,'2014-01-01','ET','2',1,NULL,'raul garcia','FI','452864182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:06',0,'2014-03-02 05:10:52'),(11439,11439,'2014-01-01','ET','2',1,NULL,'Ronald Zellmann','FI','359503846','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:49',0,'2014-03-10 13:52:32'),(16739,17389,'0000-00-00','ET','2',2,1,'DANETTE MARTIN','FI','273843364','HealthSpan','FI','311431434','JOE  WORLIND','94','1967646','348','2014-03-01','Sync Success',0,'2014-01-31 21:01:46',0,'2014-03-10 14:20:26'),(16345,16995,'0000-00-00','ET','2',1,NULL,'Teresa Robinson','FI','310705411','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:51',0,'2014-03-01 16:56:22'),(16117,16766,'0000-00-00','ET','2',1,NULL,'Arthur Van Buren','FI','587888276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:31',0,'2014-03-02 06:03:21'),(10366,10366,'2014-01-01','ET','2',1,NULL,'Ryan Greene','FI','269960116','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:40',0,'2014-03-01 16:05:34'),(6342,6342,'2014-01-01','ET','2',2,1,'Lisa Ayers','FI','274805391','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:40',0,'2014-03-10 13:32:15'),(11288,11288,'2014-01-01','ET','2',2,1,'Michael Nelson','FI','436414700','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-02-01','Sync Success',0,'2013-12-27 02:03:09',0,'2014-03-02 04:52:44'),(20324,20974,'0000-00-00','ET','2',1,NULL,'Stephen Colvin','FI','467872136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:12',0,'2014-03-02 07:03:25'),(20734,21384,'0000-00-00','ET','2',2,1,'BERNADETTE DRAVIS','FI','297689127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:28',0,'2014-03-01 18:10:11'),(21246,21896,'0000-00-00','ET','2',2,1,'Susan Adkins','FI','363745112','HealthSpan','FI','311431434','R  Wise','94','7081127','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:28',0,'2014-03-10 14:45:25'),(22443,23093,'0000-00-00','ET','2',1,NULL,'MIGDALIA NINO','FI','626016870','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:30',0,'2014-03-07 22:26:59'),(22628,23278,'0000-00-00','ET','2',1,NULL,'Matthew Harmon','FI','296909780','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:03',0,'2014-03-08 21:35:36'),(22755,23405,'0000-00-00','ET','2',2,1,'EDUARDO GURROLA','FI','008238594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:15',0,'2014-03-09 21:26:00'),(1382,1382,'2014-01-01','ET','2',2,1,'jesse Monsivais','FI','459693477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:53:26',0,'2014-03-02 04:45:37'),(20021,20671,'0000-00-00','ET','2',1,NULL,'Haley Litzinger','FI','269907134','Summa Insurance Company, Inc.','FI','341809108','Thomas D Rice','94','8267754','348','2014-04-01','Sync Success',0,'2014-02-21 22:01:07',0,'2014-03-10 16:38:05'),(19277,19927,'0000-00-00','ET','2',1,NULL,'Katie Taulbee','FI','298841167','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-18 21:30:03',0,'2014-03-01 17:34:07'),(1665,1665,'2014-01-01','ET','2',2,1,'Mark Plummer','FI','585664886','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:25',0,'2014-03-02 00:10:48'),(18467,19117,'0000-00-00','ET','2',1,NULL,'Shahala Greyard','FI','565437904','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-27','Sync Success',0,'2014-02-12 21:31:49',0,'2014-03-02 06:45:14'),(5374,5374,'2014-01-01','ET','2',4,3,'MARY KIMBERLY BACOVIN','FI','273600190','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:40',0,'2014-03-01 15:16:37'),(2592,2592,'2014-01-01','ET','2',1,NULL,'Allison Saw','FI','372338112','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:45:43',0,'2014-03-10 13:03:33'),(16249,16898,'0000-00-00','ET','2',1,NULL,'Pamela Darnell','FI','276529949','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-03-01','Sync Success',0,'2014-01-28 21:01:12',0,'2014-03-10 14:20:26'),(14679,15130,'2014-01-01','ET','2',4,3,'Michelle Ghrist','FI','284862213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:40',0,'2014-03-01 16:46:19'),(3239,3239,'2014-01-01','ET','2',1,NULL,'MARTHA J KUHN','FI','299503016','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:32',0,'2014-03-01 15:52:44'),(18342,18992,'0000-00-00','ET','2',1,NULL,'NATHAN HAIK','FI','433732791','Starmount Life Insurance Company','FI','720977315','Daniel  Burghardt Sr','94','4713801','348','2014-03-01','Sync Success',0,'2014-02-12 21:30:21',0,'2014-03-02 06:45:14'),(15916,16565,'0000-00-00','ET','2',2,1,'ED  RAMIREZ','FI','534952010','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:04',0,'2014-03-02 06:03:21'),(10680,10680,'2014-01-01','ET','2',5,4,'Nathalie Szilagyi','FI','169588134','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:45',0,'2014-03-01 16:10:36'),(12175,12175,'2014-01-01','ET','2',1,NULL,'Mitchell Smith','FI','290822329','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:08:20',0,'2014-03-10 16:10:34'),(12436,12436,'2014-01-01','ET','2',1,NULL,'HENRY Letroy SANDERS','FI','438671804','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:59',0,'2014-03-02 05:03:29'),(11001,11001,'2014-01-01','ET','2',1,NULL,'Lashona Crossey','FI','427414123','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:50',0,'2014-03-02 04:31:46'),(19803,20453,'0000-00-00','ET','2',1,NULL,'ALICIA PARKER','FI','630166048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:25',0,'2014-03-02 06:59:07'),(22828,23478,'0000-00-00','ET','2',1,NULL,'Bradly J Fortney','FI','229397607','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:16',0,'2014-03-10 14:50:59'),(114,114,'2014-01-01','ET','2',2,1,'raymond lindenau','FI','274547708','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:28',0,'2014-03-10 15:45:56'),(352,352,'2014-01-01','ET','2',1,NULL,'PAUL YANOVICH','FI','278503493','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:51',0,'2014-03-01 15:21:15'),(17194,17844,'0000-00-00','ET','2',1,NULL,'Susan  Ingram','FI','587969646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-05 21:00:07',0,'2014-03-02 06:24:38'),(16768,17418,'0000-00-00','ET','2',1,NULL,'sharanda Gibbs','FI','435699260','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:20',0,'2014-03-02 06:17:30'),(1761,1761,'2014-01-01','ET','2',1,NULL,'Brent  Bourland','FI','425982855','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:18:19',0,'2014-03-02 00:10:48'),(1860,1860,'2014-01-01','ET','2',1,NULL,'DEBORAH  DAVIS','FI','276484079','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:30:32',0,'2014-03-01 15:26:40'),(13495,13851,'2014-01-01','ET','2',1,NULL,'Noah Stratton','FI','467352972','Starmount Life Insurance Company','FI','720977315','Danielle  Kunkle','94','255726','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:13',0,'2014-03-02 05:31:31'),(18142,18792,'0000-00-00','ET','2',3,2,'MOHAMMED FAROOQI','FI','664071966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:09',0,'2014-03-02 06:38:05'),(5362,5362,'2014-01-01','ET','2',1,NULL,'BRENDA JOYCE HILL','FI','270500532','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:15',0,'2014-03-10 15:39:19'),(14525,14976,'2014-01-01','ET','2',2,1,'Matthew Murphy','FI','288908836','Summa Insurance Company, Inc.','FI','341809108','Ron  Fleeter','94','1834226','348','2014-02-01','Sync Success',0,'2014-01-15 02:08:04',0,'2014-03-10 16:17:47'),(21940,22590,'0000-00-00','ET','2',1,NULL,'Jill Little','FI','290522341','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:11',0,'2014-03-10 14:45:25'),(22358,23008,'0000-00-00','ET','2',1,NULL,'MANAL ALSHAHAL','FI','271860960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:15',0,'2014-03-07 21:36:32'),(13985,14341,'2014-01-01','ET','2',1,NULL,'Brenda White','FI','433062930','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:19',0,'2014-03-02 05:31:31'),(18724,19374,'0000-00-00','ET','2',1,NULL,'Kimberly Willis','FI','453672909','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:11',0,'2014-03-02 06:45:14'),(17598,18248,'0000-00-00','ET','2',2,1,'Emelie Bankston','FI','438534501','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:30:03',0,'2014-03-02 06:31:45'),(260,260,'2014-01-01','ET','2',1,NULL,'William Jenkins','FI','268822272','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:13',0,'2014-03-10 15:39:19'),(16892,17542,'0000-00-00','ET','2',1,NULL,'Richard Stephens','FI','461829676','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:21',0,'2014-03-02 06:24:38'),(2682,2682,'2014-01-01','ET','2',2,1,'Mohamad Altabaa','FI','271065340','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:16:38',0,'2014-03-02 04:15:49'),(3440,3440,'2014-01-01','ET','2',2,1,'Jamie Wilson','FI','272822473','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:59',0,'2014-03-10 13:24:34'),(14506,14957,'2014-01-01','ET','2',2,1,'Jamie Dean','FI','292600648','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:55',0,'2014-03-10 14:03:26'),(20398,21048,'0000-00-00','ET','2',3,2,'Karla Dingman','FI','457152693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:25',0,'2014-03-02 07:10:28'),(20890,21540,'0000-00-00','ET','2',1,NULL,'Alyssa Auer','FI','305042368','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:40',0,'2014-03-10 16:38:05'),(21139,21789,'0000-00-00','ET','2',1,NULL,'ROBERT LEWIS SHAW','FI','423843109','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 21:31:14',0,'2014-03-02 07:23:39'),(1161,1161,'2014-01-01','ET','2',2,1,'toun vilaysack','FI','586565781','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:31',0,'2014-03-02 04:38:08'),(13820,14176,'2014-01-01','ET','2',1,NULL,'Kim Smith','FI','032605878','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:25',0,'2014-03-10 16:17:47'),(2976,2976,'2014-01-01','ET','2',1,NULL,'Karen Jacob','94','0000759692','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:25',0,'2014-03-01 15:37:30'),(13365,13721,'2014-01-01','ET','2',1,NULL,'Martha Alicia Barranco','FI','463431180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-08 18:24:38',0,'2014-03-02 05:24:45'),(4613,4613,'2014-01-01','ET','2',1,NULL,'Robin Juliana Wille','FI','468787585','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:39',0,'2014-03-02 04:31:46'),(21328,21978,'0000-00-00','ET','2',1,NULL,'Norah Rice','FI','439869180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:11',0,'2014-03-03 01:07:25'),(22148,22798,'0000-00-00','ET','2',1,NULL,'SHELLEY GIROUX-SCHLAF','FI','300649369','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:03',0,'2014-03-06 21:36:23'),(12325,12325,'2014-01-01','ET','2',1,NULL,'Aaron Smith','FI','451857351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:00',0,'2014-03-02 05:03:29'),(4074,4074,'2014-01-01','ET','2',1,NULL,'Jeannetta Nailon','FI','299521396','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:02:30',0,'2014-03-01 15:52:44'),(4183,4183,'2014-01-01','ET','2',3,2,'BRIAN KELLER','FI','278428692','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:42',0,'2014-03-10 15:59:47'),(16748,17398,'0000-00-00','ET','2',1,NULL,'Annaeli Duran','FI','643328384','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:08',0,'2014-03-02 06:17:30'),(7504,7504,'2014-01-01','ET','2',1,NULL,'kirk hawthorne','FI','298667376','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:34:12',0,'2014-03-01 16:05:34'),(12099,12099,'2014-01-01','ET','2',1,NULL,'PAMELA JOYCE GESSNER','FI','280566814','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:05:40',0,'2014-03-01 16:30:17'),(22654,23304,'0000-00-00','ET','2',1,NULL,'DETAYNISHA ALLEN','FI','452698644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:23',0,'2014-03-08 22:26:18'),(266,266,'2014-01-01','ET','2',1,NULL,'Barbara E Kneisley','FI','281542216','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:26',0,'2014-03-10 13:03:33'),(19206,19856,'0000-00-00','ET','2',1,NULL,'Barton Bradberry','94','0000582236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-16 19:00:03',0,'2014-03-02 06:52:12'),(2388,2388,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:51',0,'2014-03-01 23:10:52'),(3754,3754,'2014-01-01','ET','2',1,NULL,'Terasa Jarvi','FI','294627433','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:21',0,'2014-03-10 13:24:34'),(14960,15411,'2014-01-01','ET','2',1,NULL,'Margarite Jacobs','FI','270521726','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:53',0,'2014-03-01 16:46:19'),(20111,20761,'0000-00-00','ET','2',1,NULL,'Jennifer Lee','FI','427874498','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-11','Sync Success',0,'2014-02-25 21:30:28',0,'2014-03-02 07:10:28'),(21477,22127,'0000-00-00','ET','2',1,NULL,'Cynthia Roberson','FI','490562623','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:39',0,'2014-03-03 21:36:16'),(21620,22270,'0000-00-00','ET','2',4,3,'Kimberly Brooks','FI','466932364','Starmount Life Insurance Company','FI','720977315','Danielle  Abbott','94','16964484','348','2014-04-01','Sync Success',0,'2014-03-04 21:00:36',0,'2014-03-04 21:27:16'),(21856,22506,'0000-00-00','ET','2',3,2,'Yong Chung','FI','123685553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:11',0,'2014-03-05 21:36:22'),(5656,5656,'2014-01-01','ET','2',1,NULL,'Randall Carpenter','94','0000201900','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:51:31',0,'2014-03-10 13:52:32'),(2017,2017,'2014-01-01','ET','2',2,1,'NANCY PIXLEY DOMINIC','FI','433533643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:24',0,'2014-03-01 23:10:52'),(19253,19903,'0000-00-00','ET','2',1,NULL,'alfredo leal','FI','107748889','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:42',0,'2014-03-10 14:31:05'),(2150,2150,'2014-01-01','ET','2',1,NULL,'Amanda Lee Rosales','FI','454835023','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:28',0,'2014-03-01 21:11:04'),(5384,5384,'2014-01-01','ET','2',1,NULL,'Carrie Kelm','FI','629100553','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:01',0,'2014-03-01 21:11:04'),(4383,4383,'2014-01-01','ET','2',2,1,'Shawna Southard','FI','294924215','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:27',0,'2014-03-01 15:16:37'),(15163,15614,'0000-00-00','ET','2',3,2,'prakash agrawal','FI','362927325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:35',0,'2014-03-02 05:52:31'),(22749,23399,'0000-00-00','ET','2',1,NULL,'Dedrick Varise','FI','437558294','Starmount Life Insurance Company','FI','720977315','Michael  Kirschman','94','171145428','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:11',0,'2014-03-09 21:26:00'),(14007,14363,'2014-01-01','ET','2',1,NULL,'Roy Mitchell','FI','298540937','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:01:35',0,'2014-03-01 16:40:16'),(19425,20075,'0000-00-00','ET','2',1,NULL,'Michael Barefield','FI','587461760','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:27',0,'2014-03-02 06:59:07'),(18073,18723,'0000-00-00','ET','2',1,NULL,'danette sides-evans','FI','464391984','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:18',0,'2014-03-02 06:38:05'),(3089,3089,'2014-01-01','ET','2',1,NULL,'Termerrial T Taylor','FI','435556197','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:52',0,'2014-03-02 01:10:33'),(16045,16694,'0000-00-00','ET','2',1,NULL,'Sandra Lanza','FI','271767694','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:40',0,'2014-03-10 16:24:30'),(15039,15490,'2014-01-01','ET','2',1,NULL,'Ida Suire','FI','436759571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:26',0,'2014-03-02 05:52:31'),(15367,15818,'0000-00-00','ET','2',1,NULL,'Sharon Davis','FI','272529424','HealthSpan','FI','311431434','Timothy P Self','94','16166554','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:59',0,'2014-03-10 14:10:12'),(22293,22943,'0000-00-00','ET','2',1,NULL,'Paul Jeffrey Schwartz','FI','481569278','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:48',0,'2014-03-10 14:45:25'),(22474,23124,'0000-00-00','ET','2',1,NULL,'Paula Goodfield','FI','286445050','Dental Care Plus, Inc.','FI','311185262','Larry  Kendrick','94','16659434','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:52',0,'2014-03-07 21:36:32'),(14447,14898,'2014-01-01','ET','2',1,NULL,'Therese Mancuso','FI','436717753','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:29',0,'2014-03-02 05:38:34'),(18738,19388,'0000-00-00','ET','2',1,NULL,'Robert Stainback','FI','231339172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:20',0,'2014-03-02 06:45:14'),(353,353,'2014-01-01','ET','2',1,NULL,'Charles Salyers','FI','294641662','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:46:54',0,'2014-03-01 15:21:15'),(19604,20254,'0000-00-00','ET','2',1,NULL,'joe george','FI','302529474','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:32:59',0,'2014-03-01 17:34:07'),(2921,2921,'2014-01-01','ET','2',1,NULL,'Brenda Campbell','FI','591029666','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:36',0,'2014-03-01 15:37:30'),(18309,18959,'0000-00-00','ET','2',1,NULL,'robert l miller','FI','160448709','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:00:12',0,'2014-03-10 16:31:33'),(17976,18626,'0000-00-00','ET','2',1,NULL,'Crystal Longoria','FI','631306621','Starmount Life Insurance Company','FI','720977315','Patricio  Hernandez Jr','94','1213642','357','2014-03-01','Sync Success',0,'2014-02-10 21:31:22',0,'2014-03-02 06:38:05'),(14393,14844,'2014-01-01','ET','2',6,5,'Wendy Manning','FI','234295900','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:03',0,'2014-03-01 16:46:19'),(17684,18334,'0000-00-00','ET','2',4,3,'John Kuhn','FI','294801756','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:55',0,'2014-03-10 14:24:38'),(17580,18230,'0000-00-00','ET','2',1,NULL,'Brenda  Marie Pangelinan','FI','586745447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-21','Sync Success',0,'2014-02-07 19:00:57',0,'2014-03-02 06:31:45'),(12836,12836,'2014-01-01','ET','2',1,NULL,'Liem Vu','FI','435570942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-04 02:02:34',0,'2014-03-02 05:10:52'),(15972,16621,'0000-00-00','ET','2',1,NULL,'angel alonzo','FI','438250899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:18',0,'2014-03-02 06:03:21'),(11009,11009,'2014-01-01','ET','2',1,NULL,'Carlos Sotelo','FI','352822334','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:06',0,'2014-03-02 04:24:47'),(20432,21082,'0000-00-00','ET','2',1,NULL,'Teresa Kotomski','FI','281641725','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:50',0,'2014-03-10 16:38:05'),(20811,21461,'0000-00-00','ET','2',1,NULL,'ELODIA OLIVARES DURAN','FI','459047244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:04',0,'2014-03-02 07:17:36'),(22171,22821,'0000-00-00','ET','2',1,NULL,'Robert Osborne','FI','276467736','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:19',0,'2014-03-06 21:36:23'),(22521,23171,'0000-00-00','ET','2',1,NULL,'Adam Alsept','FI','292980373','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:26',0,'2014-03-07 21:36:32'),(13354,13710,'2014-01-01','ET','2',1,NULL,'Adam Rosenfield','FI','460977762','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:33',0,'2014-03-02 05:24:45'),(20400,21050,'0000-00-00','ET','2',1,NULL,'Allen David','FI','459671628','Starmount Life Insurance Company','FI','720977315','WILL H GARNER IV','94','7632653','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:27',0,'2014-03-02 07:10:28'),(19710,20360,'0000-00-00','ET','2',1,NULL,'Mathew Swingle','FI','280821022','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:56:43',0,'2014-03-10 16:38:05'),(19518,20168,'0000-00-00','ET','2',1,NULL,'SUSAN CZEKANSKY','FI','282588932','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:09:10',0,'2014-03-01 17:47:19'),(18661,19311,'0000-00-00','ET','2',1,NULL,'Edwin Adalverto Guevara','FI','644608538','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:21',0,'2014-03-02 06:45:14'),(17143,17793,'0000-00-00','ET','2',2,1,'LASHON ROSE','FI','293703109','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:28',0,'2014-03-10 16:24:30'),(20878,21528,'0000-00-00','ET','2',1,NULL,'Patrick Weadick','FI','300604875','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:35',0,'2014-03-10 14:45:25'),(21005,21655,'0000-00-00','ET','2',1,NULL,'JOSE DE SANTIAGO','FI','635807448','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:00:04',0,'2014-03-02 07:23:39'),(95,95,'2014-01-01','ET','2',1,NULL,'Deborah Elms','FI','461985784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:17:54',0,'2014-03-01 22:10:55'),(19858,20508,'0000-00-00','ET','2',1,NULL,'Eileen Zink','FI','272520462','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-20 22:01:10',0,'2014-03-10 14:37:47'),(18491,19141,'0000-00-00','ET','2',1,NULL,'sherry frady','FI','297604610','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:03',0,'2014-03-10 16:31:33'),(17852,18502,'0000-00-00','ET','2',1,NULL,'gerald jones','FI','433353817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-10 21:00:04',0,'2014-03-02 06:38:05'),(1017,1017,'2014-01-01','ET','2',1,NULL,'Shampa Mukerji','FI','428676825','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:48',0,'2014-03-01 22:10:55'),(15910,16559,'0000-00-00','ET','2',1,NULL,'JODY VASEY','FI','302562517','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:18',0,'2014-03-10 14:10:12'),(15798,16447,'0000-00-00','ET','2',2,1,'TUYET VO','FI','630080783','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:10',0,'2014-03-02 06:03:21'),(5784,5784,'2014-01-01','ET','2',1,NULL,'Jay Goldblatt','FI','272589119','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:04',0,'2014-03-10 15:52:36'),(13386,13742,'2014-01-01','ET','2',2,1,'Melanie Davis','FI','298804267','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:47',0,'2014-03-10 16:10:34'),(1908,1908,'2014-01-01','ET','2',1,NULL,'ISMERAI ATAI VALDEZ','FI','640302042','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:32:01',0,'2014-03-01 23:10:52'),(1944,1944,'2014-01-01','ET','2',2,1,'BERSONN PIERRE','FI','733018710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:33:03',0,'2014-03-01 15:26:40'),(12549,12549,'2014-01-01','ET','2',1,NULL,'Timothy Moellinger','FI','300680151','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',1,'2014-01-02 04:35:13',0,'2014-03-10 13:59:38'),(22277,22927,'0000-00-00','ET','2',1,NULL,'CORY SCHWARK','FI','293862958','HealthSpan','FI','311431434','TIMOTHY  CHARRON','94','7944002','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:36',0,'2014-03-10 14:45:25'),(22880,23530,'0000-00-00','ET','2',1,NULL,'Jose Castillo','FI','630033802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:00:24',0,'2014-03-10 21:27:11'),(1412,1412,'2014-01-01','ET','2',1,NULL,'WANDA NAZARETIAN','FI','425048447','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:25',0,'2014-03-02 04:45:37'),(20385,21035,'0000-00-00','ET','2',1,NULL,'Erin Orcutt','FI','637102175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:14',0,'2014-03-02 07:03:25'),(4307,4307,'2014-01-01','ET','2',1,NULL,'Bernie Jude Piazza','FI','587037958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:30',0,'2014-03-02 03:09:49'),(413,413,'2014-01-01','ET','2',2,1,'Sherry Vranich','FI','275507492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:47',0,'2014-03-01 15:21:15'),(16166,16815,'0000-00-00','ET','2',1,NULL,'Martha Jane McGinnis','FI','156544101','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:17',0,'2014-03-01 16:56:22'),(10984,10984,'2014-01-01','ET','2',1,NULL,'Victoria Dahlin','FI','572513145','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:13',0,'2014-03-02 04:24:47'),(5589,5589,'2014-01-01','ET','2',1,NULL,'Sara Johnson','FI','474929930','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:19',0,'2014-03-02 04:45:37'),(1678,1678,'2014-01-01','ET','2',1,NULL,'Mary Mercer','FI','461021254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:15:47',0,'2014-03-02 00:10:48'),(3628,3628,'2014-01-01','ET','2',1,NULL,'Carmen Rodriguez','FI','287961896','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 22:05:14',0,'2014-03-10 15:52:36'),(19888,20538,'0000-00-00','ET','2',1,NULL,'Heather Wollum','FI','286907771','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:35',0,'2014-03-10 14:37:47'),(20845,21495,'0000-00-00','ET','2',1,NULL,'Chauncey Eanes','FI','221668784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:19',0,'2014-03-02 07:17:36'),(22695,23345,'0000-00-00','ET','2',1,NULL,'jason robinette','FI','296807445','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:54',0,'2014-03-08 21:35:36'),(23070,23720,'0000-00-00','ET','2',2,1,'Julian Davis','FI','272760744','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:44',0,'2014-03-10 21:17:52'),(26,26,'2014-01-01','ET','2',1,NULL,'Juanita Corcodel','FI','294701729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:48',0,'2014-03-01 15:26:40'),(16500,17150,'0000-00-00','ET','2',1,NULL,'Bradley ulanowski','FI','457474493','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:37',0,'2014-03-02 06:10:30'),(11906,11906,'2014-01-01','ET','2',1,NULL,'John Nguyen','FI','603329881','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:14',0,'2014-03-02 04:59:36'),(7446,7446,'2014-01-01','ET','2',1,NULL,'adam valderas','FI','463711398','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:19',0,'2014-03-02 04:10:25'),(11071,11071,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:13:09',0,'2014-03-10 16:03:49'),(4712,4712,'2014-01-01','ET','2',3,2,'Brenda Jayne','FI','278585477','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:02',0,'2014-03-10 13:45:57'),(3373,3373,'2014-01-01','ET','2',1,NULL,'Paul Rodriguez','FI','453493758','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:51',0,'2014-03-02 02:10:49'),(11205,11205,'2014-01-01','ET','2',1,NULL,'Leslie Wood','FI','295740847','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:36',0,'2014-03-01 16:23:43'),(2560,2560,'2014-01-01','ET','2',2,1,'juliette HARLOW','FI','435494042','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:54',0,'2014-03-01 20:10:57'),(2555,2555,'2014-01-01','ET','2',1,NULL,'Lilian Trejo','FI','435878990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:31:44',0,'2014-03-01 20:10:57'),(1091,1091,'2014-01-01','ET','2',1,NULL,'Kevin Liles','FI','294626936','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:41',0,'2014-03-01 15:05:09'),(1297,1297,'2014-01-01','ET','2',1,NULL,'LINDA D JONES','FI','427080513','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:41',0,'2014-03-02 04:38:08'),(20766,21416,'0000-00-00','ET','2',1,NULL,'JAMES BARNHARD','FI','286647722','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:30:42',0,'2014-03-01 18:08:07'),(21887,22537,'0000-00-00','ET','2',1,NULL,'Blanca Martinez','FI','519586203','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:33',0,'2014-03-05 22:27:33'),(23005,23655,'0000-00-00','ET','2',1,NULL,'MELVIN KLEMAN','FI','292629670','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:55',0,'2014-03-10 21:17:52'),(262,262,'2014-01-01','ET','2',1,NULL,'Lindsey Tharpe','FI','436639588','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:17',0,'2014-03-01 20:10:57'),(18443,19093,'0000-00-00','ET','2',1,NULL,'DANA  SUE  STOUGH','FI','288549652','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:33',0,'2014-03-10 16:31:33'),(580,580,'2014-01-01','ET','2',1,NULL,'Kathryn Leigh Nathan','FI','433742127','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:02:57',0,'2014-03-02 02:10:49'),(14069,14520,'2014-01-01','ET','2',1,NULL,'ADELA F MARTINEZ','FI','459949323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:15',0,'2014-03-02 05:31:31'),(747,747,'2014-01-01','ET','2',1,NULL,'TAMMY L MCMILLION','FI','434417694','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:15',0,'2014-03-02 02:10:49'),(11015,11015,'2014-01-01','ET','2',1,NULL,'Jacqueline Applewhite','FI','428153641','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:19',0,'2014-03-02 04:24:47'),(7440,7440,'2014-01-01','ET','2',1,NULL,'Mark Jones','FI','425454666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:07',0,'2014-03-02 04:10:25'),(2477,2477,'2014-01-01','ET','2',1,NULL,'Louise Phipps-Cvengros','FI','302520264','HealthSpan','FI','311431434','Frank  Jarome','94','16102908','348','2014-01-01','Sync Success',0,'2013-12-25 20:19:45',0,'2014-03-10 13:10:24'),(12125,12125,'2014-01-01','ET','2',1,NULL,'PATRICIA FESTAGALLO','FI','272660082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:37',0,'2014-03-01 16:30:17'),(12294,12294,'2014-01-01','ET','2',1,NULL,'Jeannine Walston','FI','420963388','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:25:05',0,'2014-03-02 05:03:29'),(2569,2569,'2014-01-01','ET','2',3,2,'Mindy Bunya Rothstein','FI','381947933','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:32:14',0,'2014-03-01 19:11:03'),(21350,22000,'0000-00-00','ET','2',6,5,'Greg Chmura','FI','271489168','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:23',0,'2014-03-03 01:35:37'),(21898,22548,'0000-00-00','ET','2',1,NULL,'Blake Harris','FI','450758584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:43',0,'2014-03-05 22:27:33'),(22886,23536,'0000-00-00','ET','2',1,NULL,'James Robinson','FI','288583556','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-05-01','Sync Success',0,'2014-03-10 21:00:28',0,'2014-03-10 21:36:25'),(12413,12413,'2014-01-01','ET','2',1,NULL,'Brenda Wise','FI','268469156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:09',0,'2014-03-02 05:03:29'),(17640,18290,'0000-00-00','ET','2',1,NULL,'BRANDON BOYD','FI','279809818','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:28',0,'2014-03-01 17:20:55'),(1526,1526,'2014-01-01','ET','2',2,1,'Oretha Barnett','FI','291540125','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:15',0,'2014-03-10 16:03:49'),(11566,11566,'2014-01-01','ET','2',1,NULL,'NINA SOLIZ','FI','639122096','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:42',0,'2014-03-02 04:52:44'),(14349,14800,'2014-01-01','ET','2',1,NULL,'juan quintanilla','FI','454536552','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:06:45',0,'2014-03-02 05:45:37'),(3215,3215,'2014-01-01','ET','2',1,NULL,'DAVID LEFFLER','FI','288527239','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:48',0,'2014-03-01 15:52:44'),(4036,4036,'2014-01-01','ET','2',1,NULL,'Alejo Guevara','FI','462087378','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:14',0,'2014-03-02 03:09:49'),(13656,14012,'2014-01-01','ET','2',1,NULL,'frenchell mckenzie','FI','452816467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:13',0,'2014-03-02 05:24:45'),(13644,14000,'2014-01-01','ET','2',1,NULL,'Larry Nye','FI','287443102','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:57',0,'2014-03-10 13:59:38'),(21339,21989,'0000-00-00','ET','2',1,NULL,'Linda Dinnell','FI','376565380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:17',0,'2014-03-03 01:35:37'),(1275,1275,'2014-01-01','ET','2',1,NULL,'KIM HILL','FI','285625285','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:00',0,'2014-03-01 16:23:43'),(18431,19081,'0000-00-00','ET','2',1,NULL,'TEOFILO PONCE','FI','548952361','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:25',0,'2014-03-01 17:26:36'),(18353,19003,'0000-00-00','ET','2',1,NULL,'melanie navarre','FI','439270898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:28',0,'2014-03-02 06:45:14'),(16875,17525,'0000-00-00','ET','2',1,NULL,'CELESTE DRENNAN','FI','460373429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:12',0,'2014-03-02 06:17:30'),(12949,12949,'2014-01-01','ET','2',2,1,'Phuong Do','FI','862508283','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-05 00:00:17',0,'2014-03-02 05:17:40'),(3555,3555,'2014-01-01','ET','2',2,1,'Wendy J Roberts','FI','294768044','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:57',0,'2014-03-01 15:37:30'),(4038,4038,'2014-01-01','ET','2',1,NULL,'Tucker Bailey','FI','627011925','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:17',0,'2014-03-02 03:09:49'),(12766,12766,'2014-01-01','ET','2',1,NULL,'Juliean Hall','FI','275561342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:07:20',0,'2014-03-10 13:59:38'),(19019,19669,'0000-00-00','ET','2',1,NULL,'joseph holt','FI','259555920','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-14 22:00:02',0,'2014-03-02 06:52:12'),(19155,19805,'0000-00-00','ET','2',2,1,'cesar delgado','FI','591530599','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:27',0,'2014-03-10 16:31:33'),(21765,22415,'0000-00-00','ET','2',3,2,'Amy Dunlea','FI','295760865','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:33',0,'2014-03-10 14:45:25'),(22318,22968,'0000-00-00','ET','2',1,NULL,'Samantha E Abeln','FI','456796194','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:30:09',0,'2014-03-06 22:25:29'),(2610,2610,'2014-01-01','ET','2',1,0,'TERRI ANN STEERS','FI','455111784','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:18',0,'2014-03-01 19:11:03'),(18654,19304,'0000-00-00','ET','2',2,1,'RICARDO RIVERA','FI','604265172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:17',0,'2014-03-02 06:45:14'),(2917,2917,'2014-01-01','ET','2',1,NULL,'Robin L Anderson','FI','296501026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:30:28',0,'2014-03-01 15:37:30'),(3537,3537,'2014-01-01','ET','2',2,1,'Sherry Vranich','FI','275507492','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:22',0,'2014-03-01 15:37:30'),(12115,12115,'2014-01-01','ET','2',5,4,'John Ustaszewski','FI','298623224','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:12',0,'2014-03-01 16:30:17'),(15334,15785,'0000-00-00','ET','2',1,NULL,'Jeffrey Stout','FI','437591651','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:39',0,'2014-03-02 05:52:31'),(15285,15736,'0000-00-00','ET','2',1,NULL,'bethany conklin','FI','103740899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:10',0,'2014-03-02 05:52:31'),(11623,11623,'2014-01-01','ET','2',1,NULL,'ELIZABETH DETZEL','FI','285482807','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:27',0,'2014-03-10 13:52:32'),(21692,22342,'0000-00-00','ET','2',1,NULL,'Sienna Ramos','94','0000969505','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:31',0,'2014-03-04 21:36:30'),(22256,22906,'0000-00-00','ET','2',2,1,'Thomas Pollauf','FI','279460769','HealthSpan','FI','311431434','Michael   Webber Jr','94','968310','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:20',0,'2014-03-10 14:50:59'),(22363,23013,'0000-00-00','ET','2',1,NULL,'JACQUELINE DAVIS','FI','179441486','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:17',0,'2014-03-07 21:36:32'),(314,314,'2014-01-01','ET','2',1,NULL,'michelle gomez','FI','454693986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:38',0,'2014-03-01 22:10:55'),(18971,19621,'0000-00-00','ET','2',1,NULL,'amy boseman','94','0000833459','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:53',0,'2014-03-10 14:31:05'),(18737,19387,'0000-00-00','ET','2',2,1,'Michelle Tocchi','FI','278501429','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:19',0,'2014-03-10 16:31:33'),(18238,18888,'0000-00-00','ET','2',2,1,'BARBARA J RICHARDSON','FI','425115156','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:25',0,'2014-03-02 06:38:05'),(4338,4338,'2014-01-01','ET','2',1,NULL,'Lathem Bonem','FI','282801880','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:24',0,'2014-03-10 15:59:47'),(11256,11256,'2014-01-01','ET','2',1,NULL,'DAUREATHA HYTHON','FI','287668867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:09',0,'2014-03-01 16:23:43'),(11153,11153,'2014-01-01','ET','2',1,NULL,'Robin Trenary','FI','274844405','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:00',0,'2014-03-10 13:45:57'),(3553,3553,'2014-01-01','ET','2',1,NULL,'Amanda Bodi','FI','300906228','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:54',0,'2014-03-01 15:37:30'),(10467,10467,'2014-01-01','ET','2',1,NULL,'Jon Frank','FI','291825698','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:51',0,'2014-03-01 16:10:36'),(6393,6393,'2014-01-01','ET','2',1,NULL,'Curtis Wenning','FI','283504820','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:15',0,'2014-03-10 13:39:10'),(3489,3489,'2014-01-01','ET','2',2,1,'John Dawson','FI','249112161','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:48',0,'2014-03-01 15:37:30'),(22057,22707,'0000-00-00','ET','2',1,NULL,'Jennelle Beining','FI','270841442','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:33',0,'2014-03-10 14:45:25'),(4885,4885,'2014-01-01','ET','2',1,NULL,'Melinda Sizelove','FI','278749980','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:47',0,'2014-03-10 13:03:33'),(18980,19630,'0000-00-00','ET','2',1,NULL,'GARY SCORCE','FI','073841259','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:00',0,'2014-03-02 06:52:12'),(17858,18508,'0000-00-00','ET','2',2,1,'Christine Thornton','FI','299825891','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-22','Sync Success',0,'2014-02-10 21:00:08',0,'2014-03-01 17:20:55'),(2956,2956,'2014-01-01','ET','2',1,NULL,'Vanetta Maye','FI','365784609','Dental Care Plus, Inc.','FI','311185262','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-25 21:31:47',0,'2014-03-01 15:37:30'),(3637,3637,'2014-01-01','ET','2',1,NULL,'BRENDA MITCHELL','FI','268686102','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:30',0,'2014-03-10 15:52:36'),(4339,4339,'2014-01-01','ET','2',2,1,'Grace Meyer','FI','285900462','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:27',0,'2014-03-10 13:32:15'),(10433,10433,'2014-01-01','ET','2',1,NULL,'DANIEL S COSTIGAN','FI','299903845','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:43',0,'2014-03-01 16:10:36'),(13347,13703,'2014-01-01','ET','2',1,NULL,'heidi kovach','FI','288549011','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:30',0,'2014-03-01 16:40:16'),(13189,13545,'2014-01-01','ET','2',1,NULL,'Stefanie Ross Dean','FI','299580740','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:06:13',0,'2014-03-10 16:10:34'),(11343,11343,'2014-01-01','ET','2',1,NULL,'Audrey Edwards','FI','438020028','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:04:49',0,'2014-03-02 04:52:44'),(12527,12527,'2014-01-01','ET','2',2,1,'Jeremiah Wright','FI','300781321','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:19',0,'2014-03-10 13:59:38'),(11788,11788,'2014-01-01','ET','2',1,NULL,'Elbert Pruitt','FI','456510382','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:46',0,'2014-03-02 04:31:46'),(19466,20116,'0000-00-00','ET','2',2,1,'Manuel Acosta','FI','632018047','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:50:08',0,'2014-03-02 06:59:07'),(20428,21078,'0000-00-00','ET','2',1,NULL,'Kyle Wasserman','FI','600925639','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:47',0,'2014-03-01 18:08:07'),(22211,22861,'0000-00-00','ET','2',1,NULL,'Mary C Domer','FI','297443464','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:47',0,'2014-03-06 21:36:23'),(22977,23627,'0000-00-00','ET','2',1,NULL,'CANDACE AIKENS','FI','274846654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:35',0,'2014-03-10 21:36:25'),(5868,5868,'2014-01-01','ET','2',1,NULL,'Luigi Armogida','FI','282742153','Dental Care Plus, Inc.','FI','311185262','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-26 02:16:51',0,'2014-03-01 15:05:09'),(18866,19516,'0000-00-00','ET','2',1,NULL,'Amanda Roselli','FI','294829551','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:36',0,'2014-03-01 17:34:07'),(18347,18997,'0000-00-00','ET','2',1,NULL,'Monica Decker','FI','434881656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:24',0,'2014-03-02 06:45:14'),(17855,18505,'0000-00-00','ET','2',5,4,'CHRIS TUZZEO','FI','291606952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:05',0,'2014-03-01 17:20:55'),(3100,3100,'2014-01-01','ET','2',1,NULL,'Janie Matthews','FI','439842652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:36:12',0,'2014-03-02 01:10:33'),(11818,11818,'2014-01-01','ET','2',1,NULL,'randi holland','FI','283665599','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:40',0,'2014-03-01 16:15:39'),(7332,7332,'2014-01-01','ET','2',5,4,'Jeff Roessner','FI','280620989','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:42',0,'2014-03-10 13:32:15'),(20073,20723,'0000-00-00','ET','2',4,3,'ELYSE CLARKE','FI','165629583','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:00:27',0,'2014-03-01 18:08:07'),(22280,22930,'0000-00-00','ET','2',4,3,'Kurt Perdew','FI','279862032','HealthSpan','FI','311431434','deborah  kos','94','967498','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:38',0,'2014-03-10 14:50:59'),(965,965,'2014-01-01','ET','2',2,1,'FRANK KULOW','FI','279500237','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:08',0,'2014-03-10 15:39:19'),(19114,19764,'0000-00-00','ET','2',1,NULL,'Leonard Kreitman','FI','278566416','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:54',0,'2014-03-01 17:34:07'),(16907,17557,'0000-00-00','ET','2',1,NULL,'Jeremy Brooks','FI','273682757','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:31',0,'2014-03-01 17:00:58'),(15498,15949,'0000-00-00','ET','2',1,NULL,'EFFIE AUDI','FI','591420302','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:50',0,'2014-03-01 16:50:53'),(13031,13387,'2014-01-01','ET','2',2,1,'WILLIAM HILL','FI','294666917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:00:23',0,'2014-03-01 16:35:14'),(5438,5438,'2014-01-01','ET','2',1,0,'lori kimble','FI','294640378','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:31:35',0,'2014-03-01 15:05:09'),(4409,4409,'2014-01-01','ET','2',1,NULL,'Zachary Fiebig','FI','291723702','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:14',0,'2014-03-10 15:39:19'),(19258,19908,'0000-00-00','ET','2',1,NULL,'Larissa Kunkel','FI','285883848','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:04',0,'2014-03-10 16:31:33'),(20832,21482,'0000-00-00','ET','2',1,NULL,'ELOY GARZA','FI','307580682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 06:31:13',0,'2014-03-02 07:17:36'),(21275,21925,'0000-00-00','ET','2',2,1,'Victor Sims','FI','434780636','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:46',0,'2014-03-02 07:23:39'),(22922,23572,'0000-00-00','ET','2',1,NULL,'ANDRE HOLMES','FI','438028590','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:57',0,'2014-03-10 21:27:11'),(11607,11607,'2014-01-01','ET','2',1,NULL,'kennethia Anderson','FI','427518087','Starmount Life Insurance Company','FI','720977315','Shawn  harness','94','8898496','348','2014-02-01','Sync Success',0,'2013-12-28 03:34:56',0,'2014-03-02 04:52:44'),(18670,19320,'0000-00-00','ET','2',1,NULL,'ELIZABETH ANN SIEGER','FI','466777111','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:30',0,'2014-03-02 06:45:14'),(6017,6017,'2014-01-01','ET','2',1,NULL,'Sharon Nelson','FI','270527968','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:27',0,'2014-03-01 15:10:22'),(17896,18546,'0000-00-00','ET','2',1,NULL,'arabella cann','FI','434040535','Starmount Life Insurance Company','FI','720977315','lee scott herron','94','1205018','348','2014-03-01','Sync Success',0,'2014-02-10 21:30:26',0,'2014-03-02 06:38:05'),(13966,14322,'2014-01-01','ET','2',2,1,'Jackie Roberts','FI','288467489','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:04',0,'2014-03-01 16:40:16'),(21723,22373,'0000-00-00','ET','2',1,NULL,'FRANK TRPKA','FI','270502065','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:58',0,'2014-03-10 16:44:18'),(1301,1301,'2014-01-01','ET','2',1,NULL,'Odell Hobson','FI','587641539','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:50:50',0,'2014-03-02 04:45:37'),(3428,3428,'2014-01-01','ET','2',1,NULL,'MICHAEL ANTHONY RINELLA','FI','270965790','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:35',0,'2014-03-10 15:52:36'),(16100,16749,'0000-00-00','ET','2',1,NULL,'Joelle A Henrick','FI','097385435','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:17',0,'2014-03-10 16:24:30'),(15366,15817,'0000-00-00','ET','2',1,NULL,'Sharon Davis','FI','272529424','HealthSpan','FI','311431434','Timothy P Self','94','16166554','357','2014-02-01','Sync Success',0,'2014-01-21 08:46:58',0,'2014-03-10 14:10:12'),(5978,5978,'2014-01-01','ET','2',2,1,'Robert Maxwell','FI','297665332','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:17',0,'2014-03-10 15:52:36'),(20093,20743,'0000-00-00','ET','2',1,NULL,'KATHY DOVE','FI','437928612','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:13',0,'2014-03-02 07:10:28'),(21613,22263,'0000-00-00','ET','2',1,NULL,'CHUJUNNA Y FERGUSON','FI','450275277','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:31',0,'2014-03-04 21:27:16'),(21883,22533,'0000-00-00','ET','2',1,NULL,'Jessica Hammond','FI','296789743','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:30',0,'2014-03-05 21:36:22'),(13315,13671,'2014-01-01','ET','2',1,NULL,'Mary  Lynne Mcquain','FI','283483566','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:17',0,'2014-03-01 16:40:16'),(13152,13508,'2014-01-01','ET','2',1,NULL,'Janet Geslak','FI','302645945','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:00',0,'2014-03-10 16:10:34'),(16564,17214,'0000-00-00','ET','2',1,NULL,'jamie laurie','FI','286845121','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-30 21:01:19',0,'2014-03-10 16:24:30'),(14203,14654,'2014-01-01','ET','2',4,3,'BRENDA CLAY','FI','412113771','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:41',0,'2014-03-02 05:38:34'),(2350,2350,'2014-01-01','ET','2',1,NULL,'Jessica Hensley','FI','287809240','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:15:39',0,'2014-03-01 15:26:40'),(2517,2517,'2014-01-01','ET','2',1,0,'sandra woodward','FI','281441611','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:32',0,'2014-03-10 15:39:19'),(19665,20315,'0000-00-00','ET','2',1,NULL,'Jason Baker','FI','283765267','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:54',0,'2014-03-01 17:47:19'),(21549,22199,'0000-00-00','ET','2',1,NULL,'marquis young','FI','604108507','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:31',0,'2014-03-03 22:26:43'),(73,73,'2014-01-01','ET','2',1,NULL,'Bethany Blowers','FI','296843863','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:13',0,'2014-03-01 15:21:15'),(18993,19643,'0000-00-00','ET','2',1,NULL,'susan koenig','FI','268584726','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:32:09',0,'2014-03-10 14:31:05'),(12435,12435,'2014-01-01','ET','2',2,1,'GERALD LOTT','FI','433538181','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:56',0,'2014-03-02 05:03:29'),(16498,17148,'0000-00-00','ET','2',1,NULL,'renee natera','FI','465617411','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:36',0,'2014-03-02 06:10:30'),(16449,17099,'0000-00-00','ET','2',1,NULL,'Jonathan C Parnell','FI','276822422','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:06',0,'2014-03-01 17:00:58'),(15442,15893,'0000-00-00','ET','2',2,1,'Danny Eaken','FI','299527044','Summa Insurance Company, Inc.','FI','341809108','Mark  Farnham','94','2759994','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:36',0,'2014-03-10 16:17:47'),(976,976,'2014-01-01','ET','2',2,1,'RICKY JORGE RUTAN','FI','289708885','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:28',0,'2014-03-01 15:21:15'),(2427,2427,'2014-01-01','ET','2',2,1,'Mary Moore','FI','291701619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:18:05',0,'2014-03-10 15:45:56'),(5606,5606,'2014-01-01','ET','2',2,1,'Jennifer Hoyt','FI','280569892','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:50',0,'2014-03-01 16:23:43'),(3169,3169,'2014-01-01','ET','2',3,2,'Charles Cushwa','FI','300523617','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:25',0,'2014-03-10 15:52:36'),(7602,7602,'2014-01-01','ET','2',2,1,'Gary Morris','FI','288508234','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:20',0,'2014-03-10 15:59:47'),(4125,4125,'2014-01-01','ET','2',1,NULL,'Larissa Itomlenskis','FI','280909068','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:58',0,'2014-03-01 16:00:27'),(696,696,'2014-01-01','ET','2',2,1,'Florence Brandt','FI','279507595','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:37',0,'2014-03-10 13:24:34'),(941,941,'2014-01-01','ET','2',1,NULL,'laurie reeves','FI','220869031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:23',0,'2014-03-01 22:10:55'),(13693,14049,'2014-01-01','ET','2',1,NULL,'Michael Scully','FI','273568039','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:36',0,'2014-03-01 16:40:16'),(16495,17145,'0000-00-00','ET','2',1,NULL,'VERA DAVIS','FI','464060752','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:34',0,'2014-03-02 06:10:30'),(13392,13748,'2014-01-01','ET','2',2,1,'KATHY SAMBOR','FI','282626260','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:51',0,'2014-03-10 16:10:34'),(15562,16013,'0000-00-00','ET','2',1,NULL,'Ximena Flores','FI','292906602','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:19',0,'2014-03-01 16:50:53'),(1703,1703,'2014-01-01','ET','2',2,1,'Jerry Whatley','FI','438845580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:16:35',0,'2014-03-02 00:10:48'),(11027,11027,'2014-01-01','ET','2',1,NULL,'Heather Lewis','FI','407392844','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:42',0,'2014-03-10 13:45:57'),(14314,14765,'2014-01-01','ET','2',1,NULL,'Michelle Araiza','FI','456558314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:30',0,'2014-03-02 05:38:34'),(6138,6138,'2014-01-01','ET','2',2,1,'GLEN KREGLOW','FI','269646697','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:28',0,'2014-03-01 16:00:27'),(3932,3932,'2014-01-01','ET','2',1,NULL,'ERIC KELSON','FI','438131599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:00',0,'2014-03-01 23:10:52'),(12162,12162,'2014-01-01','ET','2',1,NULL,'Adam Heskett','FI','299881298','HealthSpan','FI','311431434','Timothy Paul Self','94','16166554','348','2014-02-01','Sync Success',0,'2014-01-01 12:07:50',0,'2014-03-10 13:52:32'),(7007,7007,'2014-01-01','ET','2',2,1,'Kevin Tran','94','0000966842','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:43',0,'2014-03-02 03:09:49'),(3563,3563,'2014-01-01','ET','2',1,NULL,'Jamie Kungu','FI','466655477','Starmount Life Insurance Company','FI','720977315','John  Skomal','94','15877096','357','2014-01-01','Sync Success',0,'2013-12-25 22:03:14',0,'2014-03-02 00:10:48'),(3420,3420,'2014-01-01','ET','2',1,NULL,'Janet Renae Goss','FI','545451751','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:21',0,'2014-03-10 13:24:34'),(21167,21817,'0000-00-00','ET','2',1,NULL,'Robert Dustin','FI','296620196','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','357','2014-03-15','Sync Success',0,'2014-02-28 21:31:33',0,'2014-03-10 14:45:25'),(22616,23266,'0000-00-00','ET','2',1,NULL,'MARTIN ROBERT RASMUSSEN','FI','465979464','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:00:05',0,'2014-03-08 21:25:11'),(14039,14395,'2014-01-01','ET','2',1,NULL,'Jesseca  Rangel','FI','459594141','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:58',0,'2014-03-02 05:31:31'),(11269,11269,'2014-01-01','ET','2',2,1,'Mohammad Jalili','FI','843135189','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:33',0,'2014-03-02 04:45:37'),(18846,19496,'0000-00-00','ET','2',1,NULL,'melissa elizabeth herrington','FI','179620068','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:23',0,'2014-03-02 06:52:12'),(6427,6427,'2014-01-01','ET','2',1,NULL,'Robert David Freid','FI','567806768','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:22',0,'2014-03-01 15:10:22'),(18234,18884,'0000-00-00','ET','2',1,NULL,'CONSTANCE B ASKINS','FI','291484133','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:22',0,'2014-03-10 14:24:38'),(5689,5689,'2014-01-01','ET','2',1,NULL,'Ruth Z Liptok','FI','279587019','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:00:02',0,'2014-03-01 15:37:30'),(14319,14770,'2014-01-01','ET','2',1,NULL,'Edith Hirth','FI','432904106','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:32',0,'2014-03-02 05:38:34'),(14499,14950,'2014-01-01','ET','2',1,NULL,'Ralph allen GREIWERA','FI','302527770','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-15 02:07:52',0,'2014-03-10 14:03:26'),(20938,21588,'0000-00-00','ET','2',1,NULL,'Naz Older','FI','284888626','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 07:00:30',0,'2014-03-10 16:38:05'),(13950,14306,'2014-01-01','ET','2',2,1,'Kevin L Fifer','FI','300486106','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:34',0,'2014-03-10 14:03:26'),(19469,20119,'0000-00-00','ET','2',1,NULL,'KYIA TINDALL','FI','497861434','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:52:05',0,'2014-03-02 06:59:07'),(1163,1163,'2014-01-01','ET','2',1,NULL,'HAROLD ROSS','FI','310621136','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:46:36',0,'2014-03-02 04:38:08'),(12186,12186,'2014-01-01','ET','2',1,NULL,'Jessica Norton','FI','294882467','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:48',0,'2014-03-10 13:52:32'),(17113,17763,'0000-00-00','ET','2',1,NULL,'Taylor Mirtallo','FI','286909721','Dental Care Plus, Inc.','FI','311185262','Jeffrey  Janosick','94','10935898','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:08',0,'2014-03-01 17:20:55'),(16889,17539,'0000-00-00','ET','2',1,NULL,'Thomas Marsh','FI','450890557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:00:20',0,'2014-03-02 06:24:38'),(20468,21118,'0000-00-00','ET','2',1,NULL,'robert rogers','FI','295587772','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:21',0,'2014-03-01 18:08:07'),(21363,22013,'0000-00-00','ET','2',1,NULL,'SAMI ELGHAZAL','FI','287138927','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:31',0,'2014-03-10 16:38:05'),(57,57,'2014-01-01','ET','2',1,NULL,'ALEXANDER HOLIDAY','FI','295945427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:43',0,'2014-03-01 15:21:15'),(14312,14763,'2014-01-01','ET','2',1,NULL,'CHARLA WHEAT','FI','451319607','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:29',0,'2014-03-02 05:38:34'),(14543,14994,'2014-01-01','ET','2',1,NULL,'LUIS  MAGANO','FI','556258606','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:14',0,'2014-03-02 05:45:37'),(7200,7200,'2014-01-01','ET','2',1,NULL,'Judith Schmitz','FI','282524477','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:06:37',0,'2014-03-10 13:32:15'),(7033,7033,'2014-01-01','ET','2',1,NULL,'Jimmy Mueller','FI','462117474','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:32',0,'2014-03-02 03:09:49'),(6024,6024,'2014-01-01','ET','2',1,NULL,'Lori Fanaselle','FI','470820619','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:41',0,'2014-03-01 20:10:57'),(19698,20348,'0000-00-00','ET','2',1,NULL,'ANTOINETTE M KOMYATI','FI','287642324','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:54:20',0,'2014-03-10 16:31:33'),(3253,3253,'2014-01-01','ET','2',1,NULL,'Bernice Thornton','FI','298583609','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:55',0,'2014-03-01 15:52:44'),(4799,4799,'2014-01-01','ET','2',1,NULL,'Vickie Lawhon','FI','289527553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:51',0,'2014-03-01 15:16:37'),(14746,15197,'2014-01-01','ET','2',1,NULL,'carl laurianti','FI','269485510','Summa Insurance Company, Inc.','FI','341809108','carl  laurianti','94','23321836','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:24',0,'2014-03-10 16:17:47'),(19889,20539,'0000-00-00','ET','2',1,NULL,'KATHLEEN  CORNE','FI','378544819','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:36',0,'2014-03-10 14:37:47'),(18864,19514,'0000-00-00','ET','2',1,NULL,'Shannon Lavery','FI','419270624','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:35',0,'2014-03-01 17:34:07'),(18854,19504,'0000-00-00','ET','2',1,NULL,'Brenda Credeur','FI','436230989','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:28',0,'2014-03-02 06:52:12'),(18532,19182,'0000-00-00','ET','2',1,NULL,'Anna Lloyd','FI','272866165','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:04',0,'2014-03-01 17:26:36'),(13241,13597,'2014-01-01','ET','2',2,1,'Miriam smith','FI','282583910','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:44',0,'2014-03-10 13:59:38'),(17105,17755,'0000-00-00','ET','2',1,NULL,'Michelle Weaver','FI','279821884','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:03',0,'2014-03-01 17:00:58'),(17017,17667,'0000-00-00','ET','2',1,NULL,'Carolyn Cannon','FI','461969594','Starmount Life Insurance Company','FI','720977315','Mary  Siggers','94','15257239','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:09',0,'2014-03-02 06:24:38'),(11314,11314,'2014-01-01','ET','2',1,NULL,'DANN GREGORY','FI','449536125','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:03:57',0,'2014-03-02 04:52:44'),(10657,10657,'2014-01-01','ET','2',1,NULL,'Nisha Uprety','FI','303278283','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:03',0,'2014-03-02 04:31:46'),(2092,2092,'2014-01-01','ET','2',1,NULL,'Jaime Garnica','FI','401865023','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:47',0,'2014-03-10 13:20:27'),(2308,2308,'2014-01-01','ET','2',2,1,'michael eskridge','FI','515581681','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:01:30',0,'2014-03-01 19:11:03'),(2034,2034,'2014-01-01','ET','2',1,NULL,'erin jackson','FI','437673115','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:35:56',0,'2014-03-02 00:10:48'),(20711,21361,'0000-00-00','ET','2',2,1,'William Loomis','FI','224118600','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:17',0,'2014-03-01 18:08:07'),(340,340,'2014-01-01','ET','2',4,3,'Kevin New','FI','280881239','Dental Care Plus, Inc.','FI','311185262','Sandy  Calire','94','16130645','348','2014-01-01','Sync Success',0,'2013-12-25 17:46:26',0,'2014-03-01 15:21:15'),(19976,20626,'0000-00-00','ET','2',1,NULL,'Michael Smith','FI','280926006','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:35',0,'2014-03-01 17:47:19'),(15019,15470,'2014-01-01','ET','2',1,NULL,'Jerrydean Thompson','FI','434193319','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:18',0,'2014-03-02 05:45:37'),(16880,17530,'0000-00-00','ET','2',1,NULL,'Brandt Baars','FI','640102405','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:15',0,'2014-03-02 06:17:30'),(16299,16949,'0000-00-00','ET','2',1,NULL,'LAMARCUS JAMANE SCOTT','FI','456731066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:22',0,'2014-03-02 06:10:30'),(14719,15170,'2014-01-01','ET','2',1,NULL,'Lenard DAVIS','FI','436434667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:08',0,'2014-03-02 05:45:37'),(11036,11036,'2014-01-01','ET','2',1,NULL,'leslie ann willoughby','FI','295785359','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:12:00',0,'2014-03-10 16:03:49'),(10519,10519,'2014-01-01','ET','2',1,NULL,'Robin Ivy Perkins','FI','458417908','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:27',0,'2014-03-02 04:24:47'),(15081,15532,'0000-00-00','ET','2',1,NULL,'Becky Snyder','FI','285625004','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:35',0,'2014-03-01 16:50:53'),(5685,5685,'2014-01-01','ET','2',1,NULL,'Patricia Lester','FI','301504359','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:52:40',0,'2014-03-10 13:52:32'),(2414,2414,'2014-01-01','ET','2',2,1,'Richard Deger','FI','159383105','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:42',0,'2014-03-01 15:26:40'),(3817,3817,'2014-01-01','ET','2',2,1,'Tereasa Griffith','FI','275763673','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:54',0,'2014-03-10 13:10:24'),(2114,2114,'2014-01-01','ET','2',1,NULL,'Lydia McConnaughy','FI','289159660','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:22',0,'2014-03-01 15:16:37'),(20925,21575,'0000-00-00','ET','2',1,NULL,'Bradley McMorris','FI','434479446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:00:17',0,'2014-03-02 07:10:28'),(7003,7003,'2014-01-01','ET','2',1,NULL,'Aaron King','FI','631075345','Starmount Life Insurance Company','FI','720977315','James L Roberts','94','1292000','348','2014-01-01','Sync Success',0,'2013-12-26 04:00:35',0,'2014-03-02 02:10:49'),(5987,5987,'2014-01-01','ET','2',2,1,'Raymond Hattar','94','0001102074','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:33',0,'2014-03-10 13:24:34'),(17496,18146,'0000-00-00','ET','2',1,NULL,'Alicia  Garcia','FI','581279013','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:51',0,'2014-03-10 14:24:38'),(16716,17366,'0000-00-00','ET','2',1,NULL,'Magaret Boos','FI','292468315','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-31 21:01:28',0,'2014-03-10 14:20:26'),(20951,21601,'0000-00-00','ET','2',1,NULL,'Demetra Robertson','FI','456539284','Starmount Life Insurance Company','FI','720977315','Shane  Cantrell','94','17077162','348','2014-04-01','Sync Success',0,'2014-02-28 07:30:05',0,'2014-03-02 07:17:36'),(21082,21732,'0000-00-00','ET','2',1,NULL,'Lisa Davis','FI','298723045','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:34',0,'2014-03-10 16:38:05'),(21586,22236,'0000-00-00','ET','2',1,NULL,'Ellen Green','FI','436299746','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','357','2014-03-18','Sync Success',0,'2014-03-04 21:00:09',0,'2014-03-04 21:27:16'),(5795,5795,'2014-01-01','ET','2',2,1,'Donald Bennett','FI','289523264','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:21',0,'2014-03-10 13:24:34'),(20519,21169,'0000-00-00','ET','2',1,NULL,'Tiffany Walker','FI','433391143','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:56',0,'2014-03-02 07:17:36'),(1577,1577,'2014-01-01','ET','2',2,1,'Fred Baker','FI','464596580','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:00:32',0,'2014-03-01 20:10:57'),(17375,18025,'0000-00-00','ET','2',1,NULL,'ADRIAN FIERROS-LOPEZ','FI','565279314','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:25',0,'2014-03-02 06:31:45'),(1732,1732,'2014-01-01','ET','2',1,NULL,'DIANE HAYES','FI','298583787','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:27',0,'2014-03-01 15:31:33'),(16122,16771,'0000-00-00','ET','2',1,NULL,'Sherman Jackson','FI','276928560','HealthSpan','FI','311431434','Kyle  Longcamp','94','8981411','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:34',0,'2014-03-10 14:20:26'),(2270,2270,'2014-01-01','ET','2',1,0,'James Cleckley','FI','454636932','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:10',0,'2014-03-01 19:11:03'),(4730,4730,'2014-01-01','ET','2',1,NULL,'Brenda Weaver','FI','294866016','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:44',0,'2014-03-10 13:45:57'),(14770,15221,'2014-01-01','ET','2',1,NULL,'Roseina Wilson','FI','458793849','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:39',0,'2014-03-02 05:45:37'),(2740,2740,'2014-01-01','ET','2',1,NULL,'Bradley McMorris','FI','434479446','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:25',0,'2014-03-02 04:15:49'),(2775,2775,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:30',0,'2014-03-01 16:05:34'),(12829,12829,'2014-01-01','ET','2',1,NULL,'TWANDA WESLEY','FI','437510210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:02:18',0,'2014-03-02 05:10:52'),(21640,22290,'0000-00-00','ET','2',1,NULL,'Clark Daniel Andrews','FI','234761108','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-04 21:00:51',0,'2014-03-04 21:36:30'),(898,898,'2014-01-01','ET','2',2,1,'Samuel Allison','FI','327442138','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:17:04',0,'2014-03-01 15:21:15'),(20466,21116,'0000-00-00','ET','2',2,1,'Carol Baglia','FI','285582638','Dental Care Plus, Inc.','FI','311185262','Stephanie  Sine','94','8013059','348','2014-04-01','Sync Success',0,'2014-02-26 21:00:20',0,'2014-03-01 18:08:07'),(7410,7410,'2014-01-01','ET','2',1,NULL,'Patricia Robinson','FI','434049180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:11',0,'2014-03-02 04:10:25'),(18775,19425,'0000-00-00','ET','2',1,NULL,'Alexis Ellis','FI','426714974','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:48',0,'2014-03-02 06:45:14'),(14055,14506,'2014-01-01','ET','2',1,NULL,'narain singh thind','FI','059764062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:05',0,'2014-03-01 16:46:19'),(20946,21596,'0000-00-00','ET','2',2,1,'Rachel Lively','FI','459919325','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:00:39',0,'2014-03-02 07:17:36'),(22121,22771,'0000-00-00','ET','2',2,1,'Elizabeth Zidan','FI','448924616','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:45',0,'2014-03-06 21:27:26'),(22945,23595,'0000-00-00','ET','2',1,NULL,'Beth Rhodes','FI','290440273','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:13',0,'2014-03-10 21:07:22'),(698,698,'2014-01-01','ET','2',1,NULL,'Melissa DeRamus','FI','433532511','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:40',0,'2014-03-02 02:10:49'),(20674,21324,'0000-00-00','ET','2',1,NULL,'CHARLES BURNELL HUBSON','FI','287764746','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:44',0,'2014-03-10 14:37:47'),(19238,19888,'0000-00-00','ET','2',1,NULL,'Pamela Hurley','FI','284725819','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:30',0,'2014-03-01 17:34:07'),(1845,1845,'2014-01-01','ET','2',1,NULL,'James Garner','FI','287464855','HealthSpan','FI','311431434','Roderick  Weller','94','2759353','348','2014-01-01','Sync Success',0,'2013-12-25 19:21:11',0,'2014-03-10 13:20:27'),(18835,19485,'0000-00-00','ET','2',1,NULL,'Dung Nguyen','FI','635296884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:15',0,'2014-03-02 06:52:12'),(7251,7251,'2014-01-01','ET','2',1,NULL,'Mary Bonko','FI','293523683','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:08:15',0,'2014-03-10 15:59:47'),(17765,18415,'0000-00-00','ET','2',1,NULL,'Dennis Zamarron','FI','465857621','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:05',0,'2014-03-02 06:10:30'),(17362,18012,'0000-00-00','ET','2',1,NULL,'Lawrence Shashy','FI','453904662','Starmount Life Insurance Company','FI','720977315','William Davis Thomas Jr','94','1170920','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:16',0,'2014-03-02 06:24:38'),(14857,15308,'2014-01-01','ET','2',1,NULL,'Jeremy Reta','FI','464894353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:05',0,'2014-03-02 05:45:37'),(7758,7758,'2014-01-01','ET','2',1,NULL,'Robert Taylor','FI','573259254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:08',0,'2014-03-01 19:11:03'),(6327,6327,'2014-01-01','ET','2',1,NULL,'Lorraine Litvin','FI','279786913','Summa Insurance Company, Inc.','FI','341809108','Michael   Kost','94','1924114','348','2014-01-01','Sync Success',0,'2013-12-26 03:08:14',0,'2014-03-10 15:59:47'),(20885,21535,'0000-00-00','ET','2',2,1,'DELILAH REED-FIGGS','FI','428067633','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:37',0,'2014-03-02 07:17:36'),(20144,20794,'0000-00-00','ET','2',1,NULL,'Sharon Zornes','FI','288543094','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-25 21:30:51',0,'2014-03-10 16:38:05'),(18418,19068,'0000-00-00','ET','2',1,NULL,'jerry christman','FI','605075032','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:14',0,'2014-03-01 17:26:36'),(6094,6094,'2014-01-01','ET','2',2,1,'ANITA RISDEN','FI','293584848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:08',0,'2014-03-01 16:00:27'),(10763,10763,'2014-01-01','ET','2',1,NULL,'Kathleen Davis','FI','463067821','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:42',0,'2014-03-02 04:24:47'),(15247,15698,'0000-00-00','ET','2',2,1,'James Phillips','FI','289548418','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:26',0,'2014-03-02 05:52:31'),(3137,3137,'2014-01-01','ET','2',1,NULL,'GREGORY KOEHL','FI','300764177','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:19',0,'2014-03-10 13:24:34'),(19899,20549,'0000-00-00','ET','2',1,NULL,'Koviljka  Vegara','FI','731098091','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-21 21:30:05',0,'2014-03-01 17:47:19'),(5666,5666,'2014-01-01','ET','2',1,NULL,'Anita Dane','FI','465296101','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:51:54',0,'2014-03-02 04:45:37'),(16153,16802,'0000-00-00','ET','2',1,NULL,'Richard Cunningam','FI','455151599','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:09',0,'2014-03-02 06:03:21'),(14204,14655,'2014-01-01','ET','2',1,NULL,'MEDI SADEGHBEGI','FI','463777205','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:42',0,'2014-03-02 05:38:34'),(13815,14171,'2014-01-01','ET','2',2,1,'Shana Louise Humberson','FI','439273775','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:21',0,'2014-03-10 16:10:34'),(12851,12851,'2014-01-01','ET','2',1,NULL,'Barbara Morris','FI','459040103','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:06',0,'2014-03-02 05:17:40'),(7439,7439,'2014-01-01','ET','2',1,NULL,'Bridget Coila','FI','435151439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:05',0,'2014-03-02 04:15:49'),(6443,6443,'2014-01-01','ET','2',1,NULL,'Nathalee Eckel','FI','288505595','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:15:52',0,'2014-03-10 15:39:19'),(21018,21668,'0000-00-00','ET','2',1,NULL,'JENNIFER PALUMBO','FI','299926243','Summa Insurance Company, Inc.','FI','341809108','michael  kost','94','1924114','357','2014-03-01','Sync Success',0,'2014-02-28 21:00:13',0,'2014-03-10 16:38:05'),(19471,20121,'0000-00-00','ET','2',1,NULL,'Laurette Escobar','FI','456234414','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:52:55',0,'2014-03-02 06:59:07'),(3131,3131,'2014-01-01','ET','2',1,NULL,'blanca cardenas','FI','455811024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:08',0,'2014-03-02 01:10:33'),(3646,3646,'2014-01-01','ET','2',2,1,'Joan Drake','FI','381485881','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:47',0,'2014-03-10 13:20:27'),(3829,3829,'2014-01-01','ET','2',1,NULL,'Robert Rhineberger','FI','301825989','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:17:25',0,'2014-03-10 13:20:27'),(4538,4538,'2014-01-01','ET','2',2,1,'Daniel Snyder','FI','384927907','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:45:16',0,'2014-03-10 16:03:49'),(21636,22286,'0000-00-00','ET','2',1,NULL,'Frank Fojtik','FI','450117834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:48',0,'2014-03-04 21:27:16'),(22507,23157,'0000-00-00','ET','2',1,NULL,'Deborah Balsamo','FI','439022483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:15',0,'2014-03-07 22:26:59'),(218,218,'2014-01-01','ET','2',1,NULL,'Jennifer L Zoblisien','FI','548475783','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:21:54',0,'2014-03-10 13:10:24'),(7496,7496,'2014-01-01','ET','2',1,NULL,'MARSHA FAY KUHN','FI','210406734','Dental Care Plus, Inc.','FI','311185262','CAROL LEE UPSHUR','94','10977904','348','2014-01-01','Sync Success',0,'2013-12-26 04:33:55',0,'2014-03-01 16:05:34'),(16662,17312,'0000-00-00','ET','2',3,2,'Maureen Toth-Ganim','FI','285564554','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:49',0,'2014-03-01 17:00:58'),(12046,12046,'2014-01-01','ET','2',1,NULL,'Mary Verner','FI','631343896','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:50',0,'2014-03-02 04:59:36'),(5591,5591,'2014-01-01','ET','2',1,NULL,'patricia scott','FI','451816032','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:49:23',0,'2014-03-02 04:45:37'),(19146,19796,'0000-00-00','ET','2',3,2,'lori morris','FI','275688161','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:19',0,'2014-03-10 16:31:33'),(1624,1624,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:01:48',0,'2014-03-01 20:10:57'),(17830,18480,'0000-00-00','ET','2',1,NULL,'samantha greco','FI','290907235','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:59',0,'2014-03-10 14:20:26'),(3579,3579,'2014-01-01','ET','2',1,NULL,'joanna colwill','FI','466579312','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:43',0,'2014-03-02 00:10:48'),(3160,3160,'2014-01-01','ET','2',2,1,'GREGORY JOSEPH GOODMAN','FI','279680232','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:07',0,'2014-03-10 13:24:34'),(12463,12463,'2014-01-01','ET','2',3,2,'Pamela Ann Smith','FI','274767367','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:58',0,'2014-03-10 16:10:34'),(12134,12134,'2014-01-01','ET','2',2,1,'Teri Ann Bersee','FI','289444172','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:54',0,'2014-03-10 13:52:32'),(12004,12004,'2014-01-01','ET','2',2,1,'Rachel LYNN McCane','FI','272782506','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:13',0,'2014-03-10 13:52:32'),(10764,10764,'2014-01-01','ET','2',1,NULL,'Mae Rosborough','FI','439960318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:02:44',0,'2014-03-02 04:24:47'),(21584,22234,'0000-00-00','ET','2',1,NULL,'MARGARET SISSEL','FI','282762276','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:59',0,'2014-03-10 14:45:25'),(6166,6166,'2014-01-01','ET','2',1,NULL,'Sharon  L  Harris','FI','454250441','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:03:18',0,'2014-03-02 04:10:25'),(5255,5255,'2014-01-01','ET','2',1,NULL,'Angela Donahue','FI','301862394','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:54:14',0,'2014-03-10 13:20:27'),(20173,20823,'0000-00-00','ET','2',1,NULL,'ARIEL DELLINGER','FI','629343958','Dental Care Plus, Inc.','FI','311185262','DENNIS   GUILLEN','94','16688854','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:10',0,'2014-03-01 18:08:07'),(19345,19995,'0000-00-00','ET','2',1,NULL,'ferd moyse','FI','587351875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:30',0,'2014-03-02 06:59:07'),(4594,4594,'2014-01-01','ET','2',1,NULL,'Douglas Latta','FI','564290596','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:06',0,'2014-03-01 16:15:39'),(13718,14074,'2014-01-01','ET','2',2,1,'michelle munson','FI','439193088','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:53',0,'2014-03-02 05:24:45'),(14738,15189,'2014-01-01','ET','2',2,1,'Kenneth Schaefer','FI','270623633','Summa Insurance Company, Inc.','FI','341809108','Barbara  Silvey','94','8108024','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:18',0,'2014-03-10 16:17:47'),(16008,16657,'0000-00-00','ET','2',1,NULL,'Betty Fragoso','FI','463986598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:15',0,'2014-03-02 06:03:21'),(15540,15991,'0000-00-00','ET','2',1,NULL,'Colleen Enoch','FI','301903001','Summa Insurance Company, Inc.','FI','341809108','Trond Michael Backus','94','7236224','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:09',0,'2014-03-10 16:17:47'),(3148,3148,'2014-01-01','ET','2',1,NULL,'Vena Moore','FI','277482609','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:42',0,'2014-03-10 13:24:34'),(21127,21777,'0000-00-00','ET','2',4,3,'Gustavo Torres','FI','297083937','Summa Insurance Company, Inc.','FI','341809108','Scott D Demko','94','1829571','348','2014-04-01','Sync Success',0,'2014-02-28 21:31:05',0,'2014-03-10 16:38:05'),(13249,13605,'2014-01-01','ET','2',1,NULL,'brittany benjamin','94','0001436510','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:00',0,'2014-03-02 05:17:40'),(19624,20274,'0000-00-00','ET','2',1,NULL,'tabitha kunsman','FI','301747143','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:36:43',0,'2014-03-01 17:47:19'),(13264,13620,'2014-01-01','ET','2',2,1,'destiny gerstner','FI','437676669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:23:57',0,'2014-03-02 05:24:45'),(19175,19825,'0000-00-00','ET','2',1,NULL,'Brittney Hawkins','FI','434732353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:43',0,'2014-03-02 06:52:12'),(18534,19184,'0000-00-00','ET','2',1,NULL,'Steven Payten','FI','302642350','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:04',0,'2014-03-01 17:26:36'),(16760,17410,'0000-00-00','ET','2',1,NULL,'Richard Conville','FI','033487846','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-01 19:00:16',0,'2014-03-02 06:17:30'),(2984,2984,'2014-01-01','ET','2',1,NULL,'Eufemia Gomez','FI','457924936','Starmount Life Insurance Company','FI','720977315','michelle  gomez vela','94','3128498','348','2014-01-01','Sync Success',0,'2013-12-25 21:32:38',0,'2014-03-02 01:10:33'),(21552,22202,'0000-00-00','ET','2',1,NULL,'NADIA KIMBROUGH','FI','428511652','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:33',0,'2014-03-03 22:26:43'),(20692,21342,'0000-00-00','ET','2',1,NULL,'Angelle Gosha','FI','437633228','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 06:30:08',0,'2014-03-02 07:17:36'),(20662,21312,'0000-00-00','ET','2',1,NULL,'Eric Brace','FI','368861334','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:34',0,'2014-03-10 16:38:05'),(20275,20925,'0000-00-00','ET','2',4,3,'Cassandra Abney','FI','269825417','HealthSpan','FI','311431434','James  Cowin','94','7520492','348','2014-04-01','Sync Success',0,'2014-02-26 08:00:20',0,'2014-03-10 14:37:47'),(19936,20586,'0000-00-00','ET','2',1,NULL,'SUSIE LARA','FI','463023727','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:04',0,'2014-03-02 07:03:25'),(19663,20313,'0000-00-00','ET','2',1,NULL,'CINDY RENTSCHLER','FI','296608590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:46:33',0,'2014-03-01 17:47:19'),(19334,19984,'0000-00-00','ET','2',1,NULL,'HOPE REYNA','FI','462472265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:22',0,'2014-03-02 06:59:07'),(18917,19567,'0000-00-00','ET','2',1,NULL,'GLORIA ODOM','FI','425159483','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:15',0,'2014-03-02 06:52:12'),(10991,10991,'2014-01-01','ET','2',1,NULL,'Leon Harris','FI','587500950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:10:27',0,'2014-03-02 04:24:47'),(11013,11013,'2014-01-01','ET','2',1,NULL,'Christopher B Wheatley','FI','428233755','Starmount Life Insurance Company','FI','720977315','Robert  Rankin','94','11068141','348','2014-01-01','Sync Success',0,'2013-12-26 13:11:14',0,'2014-03-02 04:24:47'),(15996,16645,'0000-00-00','ET','2',1,NULL,'Melanie Hogan','FI','446823728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:08',0,'2014-03-02 06:03:21'),(14647,15098,'2014-01-01','ET','2',1,NULL,'Terri Coleman','FI','293584958','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:19',0,'2014-03-10 14:03:26'),(21879,22529,'0000-00-00','ET','2',1,NULL,'Donna SUPPLENUSBAUM','FI','278522850','Dental Care Plus, Inc.','FI','311185262','Cristopher  Alamo','94','12748504','348','2014-04-01','Sync Success',0,'2014-03-05 21:30:27',0,'2014-03-05 21:36:22'),(22756,23406,'0000-00-00','ET','2',1,NULL,'Deborah Saccente','FI','550190482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:16',0,'2014-03-09 21:26:00'),(7713,7713,'2014-01-01','ET','2',1,NULL,'Roger Fridy','FI','348389767','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-26 04:45:56',0,'2014-03-01 20:10:57'),(16160,16809,'0000-00-00','ET','2',1,NULL,'Ashley Kemper','FI','356824703','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:13',0,'2014-03-02 06:10:30'),(17575,18225,'0000-00-00','ET','2',1,NULL,'Catherine Cipollone','FI','296706382','Dental Care Plus, Inc.','FI','311185262','Paul  Sullivan','94','3667671','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:53',0,'2014-03-01 17:20:55'),(20342,20992,'0000-00-00','ET','2',2,1,'Ronald Blue','FI','270504759','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:30:32',0,'2014-03-10 16:38:05'),(22624,23274,'0000-00-00','ET','2',1,NULL,'HOLLIE GRANADOS','FI','447861036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:00',0,'2014-03-08 21:35:36'),(567,567,'2014-01-01','ET','2',1,NULL,'Antonio Camp','FI','299749155','Dental Care Plus, Inc.','FI','311185262','Kevin  Schlotman','94','142172','348','2014-01-01','Sync Success',0,'2013-12-25 18:02:35',0,'2014-03-01 15:48:04'),(867,867,'2014-01-01','ET','2',1,NULL,'ANJANA SAREEN','FI','092608554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:13',0,'2014-03-01 22:10:55'),(2781,2781,'2014-01-01','ET','2',1,NULL,'Matthew Sargent','FI','302502314','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:42',0,'2014-03-01 16:05:34'),(22762,23412,'0000-00-00','ET','2',1,NULL,'emilie dixon','FI','612641665','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:20',0,'2014-03-09 21:26:00'),(11612,11612,'2014-01-01','ET','2',2,1,'Martha Irene Partin','FI','278543587','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:06',0,'2014-03-10 16:03:49'),(15045,15496,'2014-01-01','ET','2',1,NULL,'Danielle Polk','FI','436297610','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-17 03:36:29',0,'2014-03-02 05:45:37'),(16440,17090,'0000-00-00','ET','2',1,NULL,'Thelma Gilliam','FI','296488765','HealthSpan','FI','311431434','Thomas  Konzen','94','7981943','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:52',0,'2014-03-10 14:20:26'),(20867,21517,'0000-00-00','ET','2',1,NULL,'Daniel Arant','FI','506230472','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:29',0,'2014-03-10 14:37:47'),(22437,23087,'0000-00-00','ET','2',2,1,'Michael Madrid','FI','641090055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:26',0,'2014-03-07 22:26:59'),(660,660,'2014-01-01','ET','2',1,NULL,'KAREN  GROSS','FI','044724851','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:30',0,'2014-03-02 02:10:49'),(18541,19191,'0000-00-00','ET','2',1,NULL,'MEHRIN MEMON','FI','354903683','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:08',0,'2014-03-02 06:45:14'),(4981,4981,'2014-01-01','ET','2',1,NULL,'Richard Paul Caplinger','FI','286706026','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:23',0,'2014-03-01 15:31:33'),(15282,15733,'0000-00-00','ET','2',1,NULL,'STEVEN WALLACE','FI','458789355','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:08',0,'2014-03-02 05:52:31'),(843,843,'2014-01-01','ET','2',1,NULL,'Gary Smith','FI','452786083','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:26',0,'2014-03-01 22:10:55'),(3591,3591,'2014-01-01','ET','2',1,NULL,'john clay','FI','452885810','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:04:04',0,'2014-03-02 01:10:33'),(13642,13998,'2014-01-01','ET','2',1,NULL,'Dawn Murr','FI','286762861','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:56',0,'2014-03-10 14:03:26'),(12011,12011,'2014-01-01','ET','2',1,NULL,'Christine Smith Jackson','FI','438112246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:02:32',0,'2014-03-02 04:59:36'),(12034,12034,'2014-01-01','ET','2',1,NULL,'Ramona Gilmore','FI','434947646','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:03:24',0,'2014-03-02 05:03:29'),(21465,22115,'0000-00-00','ET','2',1,NULL,'david Stone','FI','297827482','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:31',0,'2014-03-03 21:36:16'),(23109,23759,'0000-00-00','ET','2',1,NULL,'Bryan Speed','FI','587445299','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-10 21:30:10',0,'2014-03-10 22:25:11'),(5550,5550,'2014-01-01','ET','2',1,NULL,'Crystal Rae McGee','FI','122720656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:48:03',0,'2014-03-02 04:45:37'),(5490,5490,'2014-01-01','ET','2',1,NULL,'bonnie chavez','FI','269949846','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:05',0,'2014-03-01 16:23:43'),(3045,3045,'2014-01-01','ET','2',1,NULL,'Zachary Caserta','FI','292908152','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:34:28',0,'2014-03-01 15:37:30'),(10925,10925,'2014-01-01','ET','2',3,2,'Orval  A  Bragg','FI','291529308','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:29',0,'2014-03-10 16:03:49'),(16571,17221,'0000-00-00','ET','2',1,NULL,'Donald E Taylor','FI','289525388','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:23',0,'2014-03-10 14:20:26'),(11791,11791,'2014-01-01','ET','2',1,NULL,'Derik Dorsey','FI','458991122','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:12:50',0,'2014-03-02 04:31:46'),(21093,21743,'0000-00-00','ET','2',1,NULL,'Catherine Bean','FI','230021219','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-02-28 21:30:43',0,'2014-03-02 07:23:39'),(22868,23518,'0000-00-00','ET','2',2,1,'YVONE SANDERS','FI','165440964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:15',0,'2014-03-10 21:27:11'),(1619,1619,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:41',0,'2014-03-01 20:10:57'),(22716,23366,'0000-00-00','ET','2',4,3,'Kelly Jo Rorrer','FI','301560068','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:10',0,'2014-03-10 16:44:18'),(5393,5393,'2014-01-01','ET','2',1,NULL,'JANEEN BRAUN','FI','290707675','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:17:19',0,'2014-03-10 13:03:33'),(6281,6281,'2014-01-01','ET','2',1,NULL,'Bruce Watkins','FI','439705270','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:53',0,'2014-03-02 04:10:25'),(15143,15594,'0000-00-00','ET','2',1,NULL,'ROBERT LAVENE','FI','434767031','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:22',0,'2014-03-02 05:52:31'),(19076,19726,'0000-00-00','ET','2',2,1,'Charles McCray','FI','227960375','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:26',0,'2014-03-02 06:52:12'),(18590,19240,'0000-00-00','ET','2',1,NULL,'Amy L Storer','FI','293863236','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:26',0,'2014-03-01 17:26:36'),(18209,18859,'0000-00-00','ET','2',1,NULL,'Diane Richmond','FI','270501096','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:00',0,'2014-03-01 17:26:36'),(16001,16650,'0000-00-00','ET','2',1,NULL,'YVONNE VALVERDE','FI','453535066','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:12',0,'2014-03-02 06:03:21'),(15899,16548,'0000-00-00','ET','2',1,NULL,'Larnetta L Lane','FI','283564699','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:01:11',0,'2014-03-10 14:10:12'),(21245,21895,'0000-00-00','ET','2',1,NULL,'Paul Stolfo','FI','284520918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:27',0,'2014-03-01 21:35:40'),(21966,22616,'0000-00-00','ET','2',1,NULL,'ERIC SCOTT','FI','269605212','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:30',0,'2014-03-10 16:44:18'),(5732,5732,'2014-01-01','ET','2',1,NULL,'John Parkin','FI','280564848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:22',0,'2014-03-01 15:48:04'),(4414,4414,'2014-01-01','ET','2',1,NULL,'Donna Delmoro','FI','279502859','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:25',0,'2014-03-10 15:39:19'),(888,888,'2014-01-01','ET','2',1,NULL,'Gerri Nickoson','FI','272647229','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:47',0,'2014-03-01 15:21:15'),(14210,14661,'2014-01-01','ET','2',2,1,'William Fisher','FI','297721016','HealthSpan','FI','311431434','Timothy  McKeown','94','1640913','348','2014-02-01','Sync Success',0,'2014-01-14 01:33:46',0,'2014-03-10 14:03:26'),(16577,17227,'0000-00-00','ET','2',1,NULL,'Deborah Reichert','FI','289565472','HealthSpan','FI','311431434','Luke  Gardner','94','432579880','348','2014-03-01','Sync Success',0,'2014-01-30 21:01:27',0,'2014-03-10 14:20:26'),(17558,18208,'0000-00-00','ET','2',1,NULL,'Nicole Murray','FI','437239315','Starmount Life Insurance Company','FI','720977315','Troy  Wingate','94','4751447','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:39',0,'2014-03-02 06:31:45'),(16923,17573,'0000-00-00','ET','2',1,NULL,'Mildred Hall','FI','234827687','Dental Care Plus, Inc.','FI','311185262','Rodney  Smith','94','1794964','348','2014-03-01','Sync Success',0,'2014-02-03 21:00:40',0,'2014-03-01 17:00:58'),(1031,1031,'2014-01-01','ET','2',1,NULL,'Randall Poley','FI','290463906','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:21:13',0,'2014-03-10 13:10:24'),(2763,2763,'2014-01-01','ET','2',1,NULL,'RAYMOND P HART','FI','434880753','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:08',0,'2014-03-02 04:15:49'),(13079,13435,'2014-01-01','ET','2',2,1,'Renee Moore','FI','295580816','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:08',0,'2014-03-01 16:35:14'),(13251,13607,'2014-01-01','ET','2',2,1,'joshua dressner','FI','434573028','Starmount Life Insurance Company','FI','720977315','Sherry  Lilly','94','13408285','348','2014-02-01','Sync Success',1,'2014-01-07 10:23:07',0,'2014-03-02 05:17:40'),(17063,17713,'0000-00-00','ET','2',1,NULL,'THOMAS LEE MCKINNEY','FI','459952869','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:37',0,'2014-03-02 06:24:38'),(3,3,'2014-01-01','ET','2',1,NULL,'Christine Kidwell','FI','309801900','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:06',0,'2014-03-01 15:21:15'),(5623,5623,'2014-01-01','ET','2',1,NULL,'christian wade','FI','284943503','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:29',0,'2014-03-10 16:03:49'),(19980,20630,'0000-00-00','ET','2',1,NULL,'Jason Vandriver','FI','451916272','Starmount Life Insurance Company','FI','720977315','justin  leblanc','94','8485121','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:38',0,'2014-03-02 07:03:25'),(16343,16993,'0000-00-00','ET','2',1,NULL,'KATHLEEN  MILTON','FI','149508876','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:50',0,'2014-03-01 16:56:22'),(15919,16568,'0000-00-00','ET','2',1,NULL,'AID TREVINO','FI','466172660','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:05',0,'2014-03-02 06:03:21'),(4656,4656,'2014-01-01','ET','2',1,NULL,'kevin mcgreevy','FI','294863575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:08',0,'2014-03-10 16:03:49'),(4137,4137,'2014-01-01','ET','2',1,NULL,'Julius Tryston Black','FI','225978952','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:18',0,'2014-03-01 16:00:27'),(10737,10737,'2014-01-01','ET','2',1,NULL,'thomas young','FI','299868673','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:48',0,'2014-03-01 16:10:36'),(7069,7069,'2014-01-01','ET','2',1,NULL,'james ryan','FI','284541280','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:37',0,'2014-03-01 15:52:44'),(2109,2109,'2014-01-01','ET','2',1,NULL,'James Snide','FI','286744273','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:12',0,'2014-03-01 15:16:37'),(20136,20786,'0000-00-00','ET','2',1,NULL,'Roberta Humphries','FI','288807003','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:45',0,'2014-03-01 18:08:07'),(6150,6150,'2014-01-01','ET','2',1,NULL,'Cindy Dreifort','FI','273524975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:50',0,'2014-03-01 16:05:34'),(16619,17269,'0000-00-00','ET','2',1,NULL,'RAUL RODRIGUEZ','FI','458298749','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:20',0,'2014-03-02 06:17:30'),(16170,16819,'0000-00-00','ET','2',1,NULL,'Tambra Petush','FI','291641992','Dental Care Plus, Inc.','FI','311185262','Sherry  Nickols','94','997516','348','2014-03-01','Sync Success',0,'2014-01-28 21:00:20',0,'2014-03-01 16:56:22'),(2368,2368,'2014-01-01','ET','2',1,NULL,'CHERYL LYNN HAMILTON','FI','291626110','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:18',0,'2014-03-01 15:26:40'),(4096,4096,'2014-01-01','ET','2',1,NULL,'Jennifer Martin','FI','592280204','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:10',0,'2014-03-01 16:00:27'),(12407,12407,'2014-01-01','ET','2',4,3,'laura  cleveland','FI','287587276','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:29:52',0,'2014-03-01 16:35:14'),(21197,21847,'0000-00-00','ET','2',1,NULL,'ROSETE SCACCIO','FI','291624221','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:57',0,'2014-03-10 16:38:05'),(21470,22120,'0000-00-00','ET','2',1,NULL,'douglas scott','FI','291824130','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:35',0,'2014-03-03 21:36:16'),(2821,2821,'2014-01-01','ET','2',2,1,'James Blake Sutton','FI','425634030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:21:00',0,'2014-03-02 04:15:49'),(20880,21530,'0000-00-00','ET','2',1,NULL,'Denise Layton','FI','276644143','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-14','Sync Success',0,'2014-02-28 06:31:35',0,'2014-03-10 14:37:47'),(5511,5511,'2014-01-01','ET','2',1,NULL,'Christian Serenity Enoch','94','0000378580','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:46:46',0,'2014-03-01 16:23:43'),(19905,20555,'0000-00-00','ET','2',1,NULL,'regina martin','FI','271582471','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:07',0,'2014-03-01 17:47:19'),(5106,5106,'2014-01-01','ET','2',2,1,'wanda celestin','FI','433516534','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:22',0,'2014-03-02 00:10:48'),(19053,19703,'0000-00-00','ET','2',4,3,'David Martin','FI','452968938','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:09',0,'2014-03-02 06:52:12'),(3626,3626,'2014-01-01','ET','2',1,NULL,'Cindy Xin Fang Chen','FI','562879608','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:05:09',0,'2014-03-10 15:52:36'),(4244,4244,'2014-01-01','ET','2',1,NULL,'Rausheen Rivers','FI','300765379','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 23:07:37',0,'2014-03-10 15:59:47'),(10938,10938,'2014-01-01','ET','2',1,NULL,'Faith Weihe','FI','302921684','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:53',0,'2014-03-10 16:03:49'),(22678,23328,'0000-00-00','ET','2',2,1,'Donna Migues','FI','437171121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:42',0,'2014-03-08 22:26:18'),(2774,2774,'2014-01-01','ET','2',1,NULL,'Hope Hammond','FI','270905218','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:19:28',0,'2014-03-01 16:05:34'),(7749,7749,'2014-01-01','ET','2',4,3,'Shannon Thompson','FI','404210236','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:49',0,'2014-03-01 15:05:09'),(13337,13693,'2014-01-01','ET','2',1,NULL,'MARY V ROBY','FI','549313960','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:26',0,'2014-03-01 16:40:16'),(19126,19776,'0000-00-00','ET','2',1,NULL,'Diana Soutendijk','FI','295581081','Dental Care Plus, Inc.','FI','311185262','Scott  Prior','94','8416481','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:02',0,'2014-03-01 17:34:07'),(21693,22343,'0000-00-00','ET','2',1,NULL,'Shaden Ramos','94','0000344196','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:32',0,'2014-03-04 21:36:30'),(3263,3263,'2014-01-01','ET','2',1,NULL,'Saul Lamovsky','FI','273727389','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:15',0,'2014-03-10 15:52:36'),(20490,21140,'0000-00-00','ET','2',1,NULL,'Jane Johns','94','0000063759','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:38',0,'2014-03-10 16:38:05'),(20235,20885,'0000-00-00','ET','2',1,NULL,'Deborah Conner','FI','273585164','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:57',0,'2014-03-10 16:38:05'),(19221,19871,'0000-00-00','ET','2',6,5,'Andrew Albrinck','FI','405884877','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:17',0,'2014-03-01 17:34:07'),(5011,5011,'2014-01-01','ET','2',1,NULL,'CECIL JONES','FI','284489630','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:21',0,'2014-03-01 15:31:33'),(4337,4337,'2014-01-01','ET','2',1,NULL,'Brandon Hoskinson','FI','289827404','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:22',0,'2014-03-10 15:59:47'),(11107,11107,'2014-01-01','ET','2',1,NULL,'Holly Forgette','FI','278828556','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:20',0,'2014-03-10 13:45:57'),(11883,11883,'2014-01-01','ET','2',1,NULL,'Solinda Hong','FI','639107947','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:30',0,'2014-03-02 04:59:36'),(241,241,'2014-01-01','ET','2',1,NULL,'Vernon L Sargent','FI','227869843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:34',0,'2014-03-01 15:10:22'),(760,760,'2014-01-01','ET','2',1,NULL,'James Coates','FI','271560473','HealthSpan','FI','311431434','Kevin  Schlotman','94','1427172','348','2014-01-01','Sync Success',0,'2013-12-25 18:08:39',0,'2014-03-10 13:24:34'),(4947,4947,'2014-01-01','ET','2',1,NULL,'Toby Taylor','FI','414532741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:31:43',0,'2014-03-01 15:10:22'),(4269,4269,'2014-01-01','ET','2',1,NULL,'JANIS RAY','FI','452066225','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:23',0,'2014-03-02 03:09:49'),(12687,12687,'2014-01-01','ET','2',1,NULL,'Kelly Hater','FI','276908556','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:13',0,'2014-03-01 16:35:14'),(21567,22217,'0000-00-00','ET','2',1,NULL,'RUBEN FOSTER','FI','428237172','Starmount Life Insurance Company','FI','720977315','BENJAMIN  BAKER','94','6393954','348','2014-04-01','Sync Success',0,'2014-03-03 21:31:44',0,'2014-03-03 22:26:43'),(23022,23672,'0000-00-00','ET','2',2,1,'George Maculo','FI','453574706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:07',0,'2014-03-10 21:27:11'),(780,780,'2014-01-01','ET','2',5,4,'Lance Bundy','FI','280887658','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:09:24',0,'2014-03-01 15:05:09'),(20882,21532,'0000-00-00','ET','2',1,NULL,'Belinda King','FI','592306691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:36',0,'2014-03-02 07:17:36'),(7411,7411,'2014-01-01','ET','2',2,1,'Annie Bates','FI','433988573','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:13',0,'2014-03-02 04:10:25'),(18378,19028,'0000-00-00','ET','2',1,NULL,'DEBRA MACK','FI','466028024','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:45',0,'2014-03-02 06:45:14'),(7592,7592,'2014-01-01','ET','2',1,NULL,'Mary Richardson','FI','409880899','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:04',0,'2014-03-02 04:15:49'),(17538,18188,'0000-00-00','ET','2',1,NULL,'Tammy Lynn Selick','FI','281649122','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-22','Sync Success',0,'2014-02-07 19:00:26',0,'2014-03-01 17:20:55'),(17424,18074,'0000-00-00','ET','2',1,NULL,'Pamela corzine','FI','545192783','Summa Insurance Company, Inc.','FI','341809108','Lawrence  Kaczmarek','94','313913','348','2014-03-01','Sync Success',0,'2014-02-06 21:00:58',0,'2014-03-10 16:24:30'),(12747,12747,'2014-01-01','ET','2',1,NULL,'alan nowakowski','FI','285722142','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:06:34',0,'2014-03-10 13:59:38'),(16914,17564,'0000-00-00','ET','2',1,NULL,'JEFF SANDIDGE','FI','274580044','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:35',0,'2014-03-01 17:00:58'),(2169,2169,'2014-01-01','ET','2',2,1,'Leonard Kadlub','94','0001167969','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:07',0,'2014-03-01 15:16:37'),(2758,2758,'2014-01-01','ET','2',1,NULL,'Seveda Kelley','FI','438519218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:59',0,'2014-03-02 04:15:49'),(16123,16772,'0000-00-00','ET','2',1,NULL,'NANCY NELSON','FI','428116118','Starmount Life Insurance Company','FI','720977315','RAUN  DEMONS','94','10882342','348','2014-03-01','Sync Success',0,'2014-01-27 21:01:35',0,'2014-03-02 06:03:21'),(15263,15714,'0000-00-00','ET','2',1,NULL,'Jessica Mullen','FI','288828549','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:39',0,'2014-03-01 16:50:53'),(15136,15587,'0000-00-00','ET','2',1,NULL,'REGEANER WILLIAMS','FI','436397667','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:18',0,'2014-03-02 05:52:31'),(968,968,'2014-01-01','ET','2',1,NULL,'Dawn Boleyn','FI','276446642','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:14',0,'2014-03-10 15:39:19'),(4491,4491,'2014-01-01','ET','2',1,NULL,'Brian Gallagher','FI','289805297','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:31:46',0,'2014-03-10 15:39:19'),(3757,3757,'2014-01-01','ET','2',1,NULL,'Adam Cornett','FI','284966093','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:29',0,'2014-03-10 13:24:34'),(2854,2854,'2014-01-01','ET','2',1,NULL,'John Davis','FI','300661214','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:09',0,'2014-03-10 15:59:47'),(4179,4179,'2014-01-01','ET','2',6,5,'Fabiola Vaccaro','FI','283789251','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:05:31',0,'2014-03-10 15:59:47'),(6986,6986,'2014-01-01','ET','2',2,1,'Rogers Hicks','FI','275586498','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:00:03',0,'2014-03-10 13:32:15'),(11035,11035,'2014-01-01','ET','2',1,NULL,'Candace Fox','FI','298822025','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:58',0,'2014-03-10 16:03:49'),(18291,18941,'0000-00-00','ET','2',1,NULL,'DONNA GROTENRATH','FI','396626977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:20',0,'2014-03-01 17:26:36'),(12648,12648,'2014-01-01','ET','2',1,NULL,'Stacy Dedon','FI','437457897','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:52',0,'2014-03-02 05:10:52'),(14733,15184,'2014-01-01','ET','2',1,NULL,'Money Johnson','FI','439068562','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:15',0,'2014-03-02 05:45:37'),(15351,15802,'0000-00-00','ET','2',1,NULL,'MICHAEL BUTTRAM','FI','269769865','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-21 08:46:49',0,'2014-03-10 14:10:12'),(19796,20446,'0000-00-00','ET','2',1,NULL,'Sandra Swayzer','FI','434172353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:19',0,'2014-03-02 07:03:25'),(22883,23533,'0000-00-00','ET','2',1,NULL,'ASHLEY PLUNKETT','FI','293901794','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:26',0,'2014-03-10 21:36:25'),(23091,23741,'0000-00-00','ET','2',3,2,'BECKY PATTON','FI','294804385','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:03:00',0,'2014-03-10 21:07:22'),(1558,1558,'2014-01-01','ET','2',1,NULL,'Michael Epley','FI','286901643','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:15',0,'2014-03-10 13:52:32'),(18703,19353,'0000-00-00','ET','2',1,NULL,'Laura Kelly','FI','433675074','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:55',0,'2014-03-02 06:45:14'),(6012,6012,'2014-01-01','ET','2',1,NULL,'bruce lloyd','FI','290522441','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:17',0,'2014-03-01 15:10:22'),(5149,5149,'2014-01-01','ET','2',1,NULL,'Jo Fannin','FI','298545721','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:50:46',0,'2014-03-10 15:52:36'),(15254,15705,'0000-00-00','ET','2',1,NULL,'Lauri Wittenstrom','FI','340523931','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:31',0,'2014-03-02 05:52:31'),(14348,14799,'2014-01-01','ET','2',1,NULL,'DeAnn  R Bryant','FI','462531525','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:44',0,'2014-03-02 05:45:37'),(13716,14072,'2014-01-01','ET','2',1,NULL,'bayne byrdlll','FI','279724323','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-13 02:21:51',0,'2014-03-10 13:59:38'),(13536,13892,'2014-01-01','ET','2',1,NULL,'Leann Riggs','FI','302565978','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:40',0,'2014-03-01 16:40:16'),(10607,10607,'2014-01-01','ET','2',1,NULL,'Eugene Franklin','FI','459924794','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 12:57:26',0,'2014-03-02 04:24:47'),(7647,7647,'2014-01-01','ET','2',1,NULL,'Ronese Manley','FI','295628490','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 04:38:44',0,'2014-03-10 13:39:10'),(2382,2382,'2014-01-01','ET','2',1,NULL,'Denise Briganti','FI','150482482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:16:41',0,'2014-03-01 23:10:52'),(4787,4787,'2014-01-01','ET','2',1,NULL,'Joshua Heskamp','FI','129728619','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:28',0,'2014-03-10 15:39:19'),(19919,20569,'0000-00-00','ET','2',1,NULL,'Trachelle Hill','FI','428354704','Starmount Life Insurance Company','FI','720977315','Elizabeth  Hardy','94','16594649','348','2014-04-01','Sync Success',0,'2014-02-21 21:30:15',0,'2014-03-02 07:03:25'),(22783,23433,'0000-00-00','ET','2',3,2,'Lelith Willis','FI','288767844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:36',0,'2014-03-09 21:35:27'),(1234,1234,'2014-01-01','ET','2',1,NULL,'TERRY CLAY','FI','268581631','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:47',0,'2014-03-01 16:15:39'),(18833,19483,'0000-00-00','ET','2',1,NULL,'Gustavo Pena','FI','627187190','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:14',0,'2014-03-02 06:52:12'),(1597,1597,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:09',0,'2014-03-01 20:10:57'),(16925,17575,'0000-00-00','ET','2',1,NULL,'CONNIE HEDGES','FI','273509683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:41',0,'2014-03-01 17:00:58'),(14754,15205,'2014-01-01','ET','2',2,1,'JAMES  V ARRIGO','FI','287741235','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:28',0,'2014-03-10 16:17:47'),(14025,14381,'2014-01-01','ET','2',1,NULL,'sharon shanahan','FI','282548983','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:48',0,'2014-03-10 14:03:26'),(12528,12528,'2014-01-01','ET','2',1,NULL,'Marcia Laudick','FI','090429124','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:22',0,'2014-03-10 13:59:38'),(12110,12110,'2014-01-01','ET','2',1,NULL,'Anna Ament','FI','270520690','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:03',0,'2014-03-01 16:30:17'),(2458,2458,'2014-01-01','ET','2',1,NULL,'Sarah Magdaline Chifici','FI','433635094','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:19:08',0,'2014-03-01 23:10:52'),(10439,10439,'2014-01-01','ET','2',2,1,'Paul Snow','FI','413336972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:56',0,'2014-03-01 16:10:36'),(7371,7371,'2014-01-01','ET','2',1,NULL,'Steven Tucker','FI','295689351','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:17',0,'2014-03-10 15:39:19'),(20751,21401,'0000-00-00','ET','2',1,NULL,'WALTER BROWN','FI','587562965','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:36',0,'2014-03-02 07:17:36'),(21114,21764,'0000-00-00','ET','2',1,NULL,'Manuel Robles','FI','454836016','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:56',0,'2014-03-02 07:23:39'),(22980,23630,'0000-00-00','ET','2',1,NULL,'Tammulia Crowell','FI','286701586','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:37',0,'2014-03-10 21:36:25'),(3128,3128,'2014-01-01','ET','2',1,NULL,'JACK R HELBERT','FI','466984089','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:04',0,'2014-03-02 01:10:33'),(4242,4242,'2014-01-01','ET','2',2,1,'Mary Mahony','FI','292529037','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:07:33',0,'2014-03-10 15:59:47'),(18688,19338,'0000-00-00','ET','2',1,NULL,'Andres Chavarria','FI','466996903','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:42',0,'2014-03-02 06:45:14'),(18423,19073,'0000-00-00','ET','2',1,NULL,'Chinonye Akunne','FI','271945882','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:20',0,'2014-03-01 17:26:36'),(18351,19001,'0000-00-00','ET','2',1,NULL,'Ashley Cummings','FI','434614444','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:26',0,'2014-03-02 06:45:14'),(7341,7341,'2014-01-01','ET','2',1,NULL,'Abraham Arreola','FI','642168754','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:10',0,'2014-03-01 21:11:04'),(10483,10483,'2014-01-01','ET','2',1,NULL,'SARITA S JAIN','FI','157688012','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:22',0,'2014-03-01 16:10:36'),(11488,11488,'2014-01-01','ET','2',1,NULL,'Brittany Shatteen','FI','285768935','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:19',0,'2014-03-01 16:30:17'),(12118,12118,'2014-01-01','ET','2',2,1,'JOSEPH LENGEL','FI','269486487','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:06:19',0,'2014-03-01 16:30:17'),(15871,16520,'0000-00-00','ET','2',1,NULL,'GEORGIA LUSK','FI','435822902','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:54',0,'2014-03-02 06:03:21'),(5297,5297,'2014-01-01','ET','2',2,1,'John Wright','FI','270485030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:18',0,'2014-03-10 13:03:33'),(3962,3962,'2014-01-01','ET','2',1,NULL,'Johanna Engebrecht','FI','296048237','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:47:00',0,'2014-03-01 15:26:40'),(18001,18651,'0000-00-00','ET','2',1,NULL,'kevin owen','FI','086644126','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:40',0,'2014-03-02 06:38:05'),(7574,7574,'2014-01-01','ET','2',1,NULL,'Eric Vaiksnoras','FI','272740344','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:24',0,'2014-03-01 16:05:34'),(14693,15144,'2014-01-01','ET','2',2,1,'Kim Thomas','FI','434354605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:50',0,'2014-03-02 05:45:37'),(14666,15117,'2014-01-01','ET','2',1,NULL,'Karmen Krinn','FI','288761729','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:32',0,'2014-03-01 16:46:19'),(11875,11875,'2014-01-01','ET','2',1,NULL,'Russchelle Hanbury','FI','454805376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:13',0,'2014-03-02 04:59:36'),(11023,11023,'2014-01-01','ET','2',1,NULL,'John Olman','FI','272447519','HealthSpan','FI','311431434','Trisha  Schmid','94','3379862','348','2014-01-01','Sync Success',0,'2013-12-26 13:11:36',0,'2014-03-10 13:45:57'),(21538,22188,'0000-00-00','ET','2',2,1,'Javonne Eatmon','FI','642182014','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:22',0,'2014-03-03 22:26:43'),(802,802,'2014-01-01','ET','2',1,NULL,'NITAYA Y MCDONALD','FI','301782994','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 18:10:16',0,'2014-03-10 15:39:19'),(19879,20529,'0000-00-00','ET','2',1,NULL,'kimberly larry','FI','280868077','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:27',0,'2014-03-01 17:47:19'),(19670,20320,'0000-00-00','ET','2',1,NULL,'Karen Kopis','FI','291626186','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:48:17',0,'2014-03-01 17:47:19'),(18272,18922,'0000-00-00','ET','2',1,NULL,'Regina Coleman','FI','522510972','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:03',0,'2014-03-02 06:45:14'),(17088,17738,'0000-00-00','ET','2',1,NULL,'Crystal Ford','FI','294561447','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:52',0,'2014-03-01 17:00:58'),(4817,4817,'2014-01-01','ET','2',2,1,'Bruce Hassel','94','0000807468','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:22',0,'2014-03-10 13:03:33'),(14806,15257,'2014-01-01','ET','2',1,NULL,'Deborah Taylor','FI','283485214','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:02',0,'2014-03-10 16:17:47'),(2607,2607,'2014-01-01','ET','2',1,0,'Molly Killen','FI','450915999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:46:12',0,'2014-03-01 19:11:03'),(6451,6451,'2014-01-01','ET','2',1,NULL,'Lila McCall','FI','461947700','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:16:07',0,'2014-03-01 20:10:57'),(7237,7237,'2014-01-01','ET','2',2,1,'NATHAN ANDERSON','FI','408042525','Starmount Life Insurance Company','FI','720977315','BRENDON  holt','94','15684392','348','2014-01-01','Sync Success',0,'2013-12-26 04:07:50',0,'2014-03-02 02:10:49'),(13627,13983,'2014-01-01','ET','2',1,NULL,'Nicole Moore','FI','280681585','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:45',0,'2014-03-10 14:03:26'),(21838,22488,'0000-00-00','ET','2',2,1,'Laureen rives','FI','436319367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:29',0,'2014-03-05 21:25:24'),(22067,22717,'0000-00-00','ET','2',1,NULL,'DARLENE K URICH','FI','296505641','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:41',0,'2014-03-10 14:45:25'),(22323,22973,'0000-00-00','ET','2',1,NULL,'wendi koontz','FI','291668215','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:13',0,'2014-03-10 16:44:18'),(4433,4433,'2014-01-01','ET','2',1,NULL,'Jarice Jefferson','FI','437732254','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:09',0,'2014-03-01 19:11:03'),(19717,20367,'0000-00-00','ET','2',1,NULL,'Areniqua White','FI','464777281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 05:31:59',0,'2014-03-02 06:59:07'),(11855,11855,'2014-01-01','ET','2',1,NULL,'Kevin Schneider','FI','289945028','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',1,'2013-12-29 11:14:59',0,'2014-03-10 13:45:57'),(15108,15559,'0000-00-00','ET','2',1,NULL,'Niem Pham','FI','640263597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:05:55',0,'2014-03-02 05:52:31'),(15302,15753,'0000-00-00','ET','2',1,NULL,'John Gussey','FI','280902022','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:19',0,'2014-03-01 16:50:53'),(15542,15993,'0000-00-00','ET','2',1,NULL,'Gail Edwards','FI','278544552','Summa Insurance Company, Inc.','FI','341809108','Anthony Edward Lancianese','94','7462726','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:10',0,'2014-03-10 16:17:47'),(56,56,'2014-01-01','ET','2',1,NULL,'Jennifer Neff','FI','297600007','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:16:42',0,'2014-03-01 15:21:15'),(1222,1222,'2014-01-01','ET','2',2,1,'Juanita Miller','FI','279545653','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:26',0,'2014-03-01 16:15:39'),(18440,19090,'0000-00-00','ET','2',1,NULL,'crystal watkins','FI','301702206','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:32',0,'2014-03-10 16:31:33'),(10707,10707,'2014-01-01','ET','2',1,NULL,'Susan Smith','FI','390463685','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:47',0,'2014-03-01 16:10:36'),(11298,11298,'2014-01-01','ET','2',1,NULL,'Obi Dhungana','FI','616693675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:26',0,'2014-03-02 04:45:37'),(14392,14843,'2014-01-01','ET','2',2,1,'ROSE PRESUTTI','FI','281561867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:03',0,'2014-03-01 16:46:19'),(17266,17916,'0000-00-00','ET','2',2,1,'Dennis Buxton','FI','433961373','Starmount Life Insurance Company','FI','720977315','James  White','94','1243428','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:38',0,'2014-03-02 06:24:38'),(15623,16074,'0000-00-00','ET','2',2,1,'Michelle Lynch','FI','296764032','Summa Insurance Company, Inc.','FI','341809108','Rick  lohr','94','15886837','348','2014-03-01','Sync Success',0,'2014-01-23 03:02:47',0,'2014-03-10 16:24:30'),(22714,23364,'0000-00-00','ET','2',1,NULL,'Vicki Flory','FI','289581610','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:31:09',0,'2014-03-10 16:44:18'),(631,631,'2014-01-01','ET','2',1,NULL,'Elisa Castro','94','0000923608','Starmount Life Insurance Company','FI','720977315','DALE  ADAMS','94','8330750','348','2014-01-01','Sync Success',0,'2013-12-25 18:04:39',0,'2014-03-02 02:10:49'),(18842,19492,'0000-00-00','ET','2',1,NULL,'Shakila Vaid','FI','461456714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:20',0,'2014-03-02 06:52:12'),(2087,2087,'2014-01-01','ET','2',1,NULL,'Teri Koller','FI','299589332','HealthSpan','FI','311431434','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-25 19:37:37',0,'2014-03-10 13:20:27'),(16885,17535,'0000-00-00','ET','2',1,NULL,'QUYNH NGUYEN','FI','231594666','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:17',0,'2014-03-02 06:17:30'),(16472,17122,'0000-00-00','ET','2',1,NULL,'danielle blanson','FI','433631416','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:20',0,'2014-03-02 06:10:30'),(11858,11858,'2014-01-01','ET','2',2,1,'Katherine White','FI','281609010','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:04',0,'2014-03-10 16:03:49'),(15952,16601,'0000-00-00','ET','2',2,1,'Gregory McCown','FI','280686528','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:03',0,'2014-03-01 16:56:22'),(12181,12181,'2014-01-01','ET','2',1,NULL,'JENNIFER REYNOLDS','FI','288721065','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:08:34',0,'2014-03-10 13:52:32'),(14900,15351,'2014-01-01','ET','2',1,NULL,'Sally Hamilton','FI','435574803','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:24',0,'2014-03-02 05:45:37'),(14527,14978,'2014-01-01','ET','2',3,2,'Marcus Montoney','FI','314708026','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:08:05',0,'2014-03-10 14:03:26'),(20448,21098,'0000-00-00','ET','2',1,NULL,'LORI KERBY','FI','291743986','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:31:04',0,'2014-03-10 14:37:47');
INSERT INTO `Edi834` VALUES (22459,23109,'0000-00-00','ET','2',1,NULL,'Darodd Duncan','FI','268522760','Summa Insurance Company, Inc.','FI','341809108','Rhonda KaY Jackson','94','1101549300','348','2014-04-01','Sync Success',0,'2014-03-07 21:30:41',0,'2014-03-10 16:44:18'),(1428,1428,'2014-01-01','ET','2',3,2,'Shannon Knippen','FI','302747886','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:54:58',0,'2014-03-10 13:45:57'),(5914,5914,'2014-01-01','ET','2',1,NULL,'Matthew McGee','FI','290920338','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:14',0,'2014-03-01 15:48:04'),(17475,18125,'0000-00-00','ET','2',1,NULL,'Robyn Jacob','FI','271560259','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:34',0,'2014-03-10 14:24:38'),(16448,17098,'0000-00-00','ET','2',1,NULL,'Tad Phipps','FI','297761178','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:05',0,'2014-03-01 17:00:58'),(3982,3982,'2014-01-01','ET','2',1,NULL,'Kristina Burns','FI','271906055','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:47:38',0,'2014-03-10 13:10:24'),(7618,7618,'2014-01-01','ET','2',2,1,'Luke Kesson','FI','380087541','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:37:51',0,'2014-03-10 13:39:10'),(20822,21472,'0000-00-00','ET','2',1,NULL,'JAIME ENRIQUE','FI','449770215','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:09',0,'2014-03-02 07:17:36'),(737,737,'2014-01-01','ET','2',1,NULL,'William Hoskins','FI','281646535','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:07:58',0,'2014-03-10 13:24:34'),(17491,18141,'0000-00-00','ET','2',1,NULL,'Cassandra Smith','FI','298681115','HealthSpan','FI','311431434','Scott  Peluso','94','1004745','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:48',0,'2014-03-10 14:24:38'),(14915,15366,'2014-01-01','ET','2',1,NULL,'Alice Frazier','FI','272680404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:30',0,'2014-03-01 16:50:53'),(5974,5974,'2014-01-01','ET','2',1,NULL,'Lydell Emerson','FI','439351796','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:09',0,'2014-03-02 01:10:33'),(3888,3888,'2014-01-01','ET','2',1,NULL,'Julie Miles','FI','295880654','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:31:50',0,'2014-03-01 15:05:09'),(3271,3271,'2014-01-01','ET','2',1,NULL,'christy toth','FI','289928740','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:47:32',0,'2014-03-10 13:24:34'),(20291,20941,'0000-00-00','ET','2',1,NULL,'MATHEW W MEHOJAH','FI','460795568','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:36',0,'2014-03-02 07:10:28'),(21033,21683,'0000-00-00','ET','2',1,NULL,'Keith Dietrich','FI','298720882','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:00:24',0,'2014-03-10 14:45:25'),(315,315,'2014-01-01','ET','2',1,NULL,'Vicki Flynn','FI','450139769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:40',0,'2014-03-01 22:10:55'),(19548,20198,'0000-00-00','ET','2',1,NULL,'Shilonda Elie','FI','437370520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:17:52',0,'2014-03-02 06:59:07'),(15047,15498,'2014-01-01','ET','2',1,NULL,'julia hansford','FI','278887806','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:29',0,'2014-03-10 14:10:12'),(13493,13849,'2014-01-01','ET','2',1,NULL,'LISBETH SALMERON','FI','459512295','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:12',0,'2014-03-02 05:31:31'),(16572,17222,'0000-00-00','ET','2',1,NULL,'Donna Kennedy','FI','275662788','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:24',0,'2014-03-10 14:20:26'),(5240,5240,'2014-01-01','ET','2',3,2,'Jeffrey Clark','FI','292760461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:41',0,'2014-03-10 13:20:27'),(1539,1539,'2014-01-01','ET','2',1,NULL,'Sue Stachowiak','FI','288729816','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:35',0,'2014-03-10 13:52:32'),(4889,4889,'2014-01-01','ET','2',3,2,'Joseph Cremonese','FI','115449366','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:58',0,'2014-03-10 13:03:33'),(11867,11867,'2014-01-01','ET','2',1,NULL,'Eugenea M Ruffing','FI','272760136','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:15:24',0,'2014-03-10 13:45:57'),(4305,4305,'2014-01-01','ET','2',1,NULL,'Jacque Davis','FI','373080992','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:27',0,'2014-03-02 03:09:49'),(11207,11207,'2014-01-01','ET','2',2,1,'Hans R Rasmussen','FI','060847808','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:39',0,'2014-03-01 16:23:43'),(21734,22384,'0000-00-00','ET','2',1,NULL,'Debra Diane McInnes','FI','287560225','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:06',0,'2014-03-10 16:44:18'),(22476,23126,'0000-00-00','ET','2',1,NULL,'Danielle Huddleston','FI','285901523','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:54',0,'2014-03-07 21:36:32'),(22558,23208,'0000-00-00','ET','2',1,NULL,'Bonnie Finitzer','FI','300429221','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:51',0,'2014-03-10 16:44:18'),(11440,11440,'2014-01-01','ET','2',2,1,'Abbey Moore','FI','302843813','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:51',0,'2014-03-10 13:52:32'),(7445,7445,'2014-01-01','ET','2',1,NULL,'Michael Seth Vestal','FI','451897484','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:17',0,'2014-03-02 04:10:25'),(21644,22294,'0000-00-00','ET','2',1,NULL,'Eric Tochtermann','FI','283464501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:54',0,'2014-03-04 21:36:30'),(173,173,'2014-01-01','ET','2',1,NULL,'Hanh Pham','FI','438836186','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:20:22',0,'2014-03-01 22:10:55'),(19863,20513,'0000-00-00','ET','2',1,NULL,'Wayne Whitmore','FI','296748212','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:13',0,'2014-03-01 17:47:19'),(14924,15375,'2014-01-01','ET','2',1,NULL,'Ryan Lee McDannell','FI','295861148','Dental Care Plus, Inc.','FI','311185262','David  Outland','94','3346146','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:35',0,'2014-03-01 16:50:53'),(17244,17894,'0000-00-00','ET','2',1,NULL,'Leisa Jaye','FI','296864807','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:28',0,'2014-03-01 17:20:55'),(1002,1002,'2014-01-01','ET','2',1,NULL,'Rebecca Conley','FI','268521148','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:20:21',0,'2014-03-10 15:39:19'),(15599,16050,'0000-00-00','ET','2',1,NULL,'monique parker','FI','435433936','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:35',0,'2014-03-02 05:59:43'),(16435,17085,'0000-00-00','ET','2',1,NULL,'CHARITY  FISHER','FI','289762734','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:48',0,'2014-03-10 14:20:26'),(21759,22409,'0000-00-00','ET','2',1,NULL,'Cindy Horsey','FI','276664223','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-04-01','Sync Success',0,'2014-03-04 21:02:29',0,'2014-03-10 14:45:25'),(22005,22655,'0000-00-00','ET','2',1,NULL,'JAMES METCALF','FI','295583427','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:57',0,'2014-03-05 21:36:22'),(22517,23167,'0000-00-00','ET','2',1,NULL,'CHANTEL HENDERSON','FI','437777247','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:23',0,'2014-03-07 22:26:59'),(432,432,'2014-01-01','ET','2',1,NULL,'Akeelah Ali','FI','427678672','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:26',0,'2014-03-01 22:10:55'),(20167,20817,'0000-00-00','ET','2',1,NULL,'Catherine Catania','FI','283863556','Dental Care Plus, Inc.','FI','311185262','WILLIAM  MCILROY','94','8267605','348','2014-04-01','Sync Success',0,'2014-02-25 21:31:06',0,'2014-03-01 18:08:07'),(19827,20477,'0000-00-00','ET','2',1,NULL,'Scott Rankine','FI','285622607','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:45',0,'2014-03-10 16:38:05'),(13449,13805,'2014-01-01','ET','2',1,NULL,'Jerry Warren','FI','593586008','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:18',0,'2014-03-02 05:31:31'),(10617,10617,'2014-01-01','ET','2',1,NULL,'Martha Mendiola','FI','458849779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:45',0,'2014-03-02 04:24:47'),(10368,10368,'2014-01-01','ET','2',1,NULL,'Chris Swansiger','FI','286806507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:49:44',0,'2014-03-01 16:10:36'),(17928,18578,'0000-00-00','ET','2',1,NULL,'Hadja Sackor','FI','644904654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:49',0,'2014-03-02 06:38:05'),(17866,18516,'0000-00-00','ET','2',3,2,'Sikander Aziz','FI','635923204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:13',0,'2014-03-02 06:38:05'),(16920,17570,'0000-00-00','ET','2',1,NULL,'CASSANDRA LEE MYERS','FI','297883024','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:38',0,'2014-03-01 17:00:58'),(16800,17450,'0000-00-00','ET','2',1,NULL,'TUN TUN','FI','292115714','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:41',0,'2014-03-02 06:17:30'),(7329,7329,'2014-01-01','ET','2',4,3,'Deborah Okes','FI','294600436','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:10:36',0,'2014-03-10 13:32:15'),(16200,16849,'0000-00-00','ET','2',1,NULL,'ANGELA  DENISE  SEMIEN','FI','439592459','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-28 21:00:39',0,'2014-03-02 06:10:30'),(15281,15732,'0000-00-00','ET','2',1,NULL,'Manuel Cerros','FI','458024922','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:07',0,'2014-03-02 05:52:31'),(3075,3075,'2014-01-01','ET','2',1,NULL,'Kevin Keithly','FI','230135482','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:27',0,'2014-03-02 01:10:33'),(5513,5513,'2014-01-01','ET','2',1,NULL,'Lisa Colagross','FI','287668964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 01:46:50',0,'2014-03-01 16:23:43'),(2249,2249,'2014-01-01','ET','2',2,1,'Pamela Moores','FI','296448309','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:53',0,'2014-03-10 13:10:24'),(2933,2933,'2014-01-01','ET','2',1,NULL,'Evan Frank','FI','299886920','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:02',0,'2014-03-01 15:37:30'),(5290,5290,'2014-01-01','ET','2',1,NULL,'Kathleen Gattozzi','FI','297563072','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:05',0,'2014-03-01 15:10:22'),(20480,21130,'0000-00-00','ET','2',1,NULL,'Kenneth Dorman','FI','286843599','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:00:31',0,'2014-03-01 18:08:07'),(20721,21371,'0000-00-00','ET','2',1,NULL,'CHERYL LING','FI','269643643','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:30:21',0,'2014-03-01 18:08:07'),(14748,15199,'2014-01-01','ET','2',2,1,'Raymond Weisel','FI','269843030','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:25',0,'2014-03-10 16:17:47'),(18748,19398,'0000-00-00','ET','2',1,NULL,'Marlo Solomon','FI','437216043','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:28',0,'2014-03-02 06:45:14'),(10860,10860,'2014-01-01','ET','2',1,NULL,'tarick rehan','FI','224716378','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:51',0,'2014-03-10 13:39:10'),(15851,16500,'0000-00-00','ET','2',1,NULL,'Samantha Ledford','FI','272987714','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:41',0,'2014-03-01 16:56:22'),(4351,4351,'2014-01-01','ET','2',1,NULL,'Teresa Beaupry','FI','268548256','HealthSpan','FI','311431434','Michelle L Seymour','94','1924703','348','2014-01-01','Sync Success',0,'2013-12-25 23:10:48',0,'2014-03-10 13:32:15'),(20574,21224,'0000-00-00','ET','2',1,NULL,'Jacqueline Rock','FI','280847223','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:32',0,'2014-03-01 18:08:07'),(14128,14579,'2014-01-01','ET','2',1,NULL,'Gloria Toney','FI','436171120','Starmount Life Insurance Company','FI','720977315','Roanita  Jenkins','94','7138487','348','2014-02-01','Sync Success',0,'2014-01-14 01:32:53',0,'2014-03-02 05:38:34'),(13252,13608,'2014-01-01','ET','2',2,1,'alan terrill','FI','530683311','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:23:10',0,'2014-03-10 13:59:38'),(18427,19077,'0000-00-00','ET','2',1,NULL,'SHARON BUTTROM','FI','274649431','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:22',0,'2014-03-01 17:26:36'),(6294,6294,'2014-01-01','ET','2',1,NULL,'Sasha Robinsin','FI','437717769','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:07:15',0,'2014-03-02 04:10:25'),(1244,1244,'2014-01-01','ET','2',1,NULL,'DARLENE THOMAS','FI','273522311','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:01',0,'2014-03-01 16:15:39'),(3727,3727,'2014-01-01','ET','2',1,NULL,'Nancy Lavelle','FI','293682011','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:26',0,'2014-03-10 13:20:27'),(12649,12649,'2014-01-01','ET','2',1,NULL,'Darlyn Washington','FI','434311358','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:54',0,'2014-03-02 05:10:52'),(7750,7750,'2014-01-01','ET','2',1,NULL,'Michael Clark','FI','274845132','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:52',0,'2014-03-10 15:39:19'),(7180,7180,'2014-01-01','ET','2',1,NULL,'Ruth Sinclair','FI','166484688','Summa Insurance Company, Inc.','FI','341809108','Marisella  Rios-Weible','94','16969504','348','2014-01-01','Sync Success',0,'2013-12-26 04:06:01',0,'2014-03-10 15:59:47'),(21831,22481,'0000-00-00','ET','2',1,NULL,'KATHI R JOHNSON','FI','278605483','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-05 21:00:24',0,'2014-03-05 21:36:22'),(852,852,'2014-01-01','ET','2',1,NULL,'Timothy Newcombe','FI','511960942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:42',0,'2014-03-01 21:11:04'),(20596,21246,'0000-00-00','ET','2',1,NULL,'Madison Bregitzer','94','0000578830','Dental Care Plus, Inc.','FI','311185262','Richard R Davis','94','2827124','348','2014-03-01','Sync Success',0,'2014-02-26 21:01:46',0,'2014-03-01 18:08:07'),(18312,18962,'0000-00-00','ET','2',1,NULL,'James Kopac','FI','294764557','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-12 21:00:14',0,'2014-03-10 16:31:33'),(15717,16366,'0000-00-00','ET','2',1,NULL,'James Hardaway','FI','327509006','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-23 21:00:59',0,'2014-03-02 05:59:43'),(20956,21606,'0000-00-00','ET','2',1,NULL,'MARISELA MOLINA','FI','453084356','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:09',0,'2014-03-02 07:17:36'),(3334,3334,'2014-01-01','ET','2',1,NULL,'ANITA WOLCOTT','FI','288580139','Summa Insurance Company, Inc.','FI','341809108','JAMES  FINNEGIN','94','2766031','348','2014-01-01','Sync Success',0,'2013-12-25 21:49:38',0,'2014-03-10 15:52:36'),(5163,5163,'2014-01-01','ET','2',1,NULL,'Saraswati Dhimal','FI','301135637','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:51:11',0,'2014-03-10 15:52:36'),(7298,7298,'2014-01-01','ET','2',1,NULL,'Deborah Peterson','FI','281525189','HealthSpan','FI','311431434','Linda  Sawyers','94','2095238','348','2014-01-01','Sync Success',0,'2013-12-26 04:09:39',0,'2014-03-10 13:32:15'),(12469,12469,'2014-01-01','ET','2',1,NULL,'Todd Smith','FI','286866405','Dental Care Plus, Inc.','FI','311185262','Heidi  McArthur','94','8621177','357','2014-01-01','Sync Success',1,'2014-01-02 04:32:13',0,'2014-03-01 16:30:17'),(12432,12432,'2014-01-01','ET','2',1,NULL,'robert mccoy','FI','435150365','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:50',0,'2014-03-02 05:03:29'),(11438,11438,'2014-01-01','ET','2',1,NULL,'william hopwood','FI','287425325','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:07:48',0,'2014-03-10 13:52:32'),(1805,1805,'2014-01-01','ET','2',1,NULL,'DONALD L TAYLOR','FI','300503004','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:19:49',0,'2014-03-10 13:20:27'),(11263,11263,'2014-01-01','ET','2',1,NULL,'Shirley Lavalais','FI','436045360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:23',0,'2014-03-02 04:45:37'),(18900,19550,'0000-00-00','ET','2',1,NULL,'CAROL UMPHENOUR','FI','280506380','Dental Care Plus, Inc.','FI','311185262','MICHEAL  DAUGHERTY','94','1131360','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:01',0,'2014-03-01 17:34:07'),(18114,18764,'0000-00-00','ET','2',1,NULL,'Niazi Thawaher Halasa','FI','629270958','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:49',0,'2014-03-02 06:38:05'),(17995,18645,'0000-00-00','ET','2',1,NULL,'David Holt','FI','427027994','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:36',0,'2014-03-02 06:38:05'),(15493,15944,'0000-00-00','ET','2',1,NULL,'Phillip Talley','FI','284840299','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',1,'2014-01-22 03:23:10',0,'2014-03-10 16:17:47'),(15449,15900,'0000-00-00','ET','2',1,NULL,'JAMAL PHELPS','FI','171681857','Starmount Life Insurance Company','FI','720977315','LEAH  PARSON','94','6393796','348','2014-03-01','Sync Success',1,'2014-01-22 03:22:41',0,'2014-03-02 05:59:43'),(15192,15643,'0000-00-00','ET','2',1,NULL,'Kayleigh  R Dale','FI','412950560','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:20',0,'2014-03-10 14:10:12'),(2737,2737,'2014-01-01','ET','2',1,NULL,'Dale Williams','FI','437853238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:18:19',0,'2014-03-02 04:15:49'),(6328,6328,'2014-01-01','ET','2',1,NULL,'Florene Kimbro-Jackson','FI','277465737','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:16',0,'2014-03-10 15:59:47'),(21954,22604,'0000-00-00','ET','2',1,NULL,'DILLION BUECHE','FI','438833817','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:21',0,'2014-03-05 22:27:33'),(13293,13649,'2014-01-01','ET','2',1,NULL,'andrea gerhart','FI','281843572','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:10',0,'2014-03-01 16:40:16'),(10955,10955,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 13:09:22',0,'2014-03-10 16:03:49'),(19207,19857,'0000-00-00','ET','2',1,NULL,'Shun  Burleson','FI','555479779','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:05',0,'2014-03-02 06:52:12'),(17859,18509,'0000-00-00','ET','2',1,NULL,'Neil Newman','FI','286562076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:00:09',0,'2014-03-01 17:20:55'),(16300,16950,'0000-00-00','ET','2',2,1,'SERGIO OYERVIDES','FI','631440594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:23',0,'2014-03-02 06:10:30'),(16038,16687,'0000-00-00','ET','2',2,1,'Charles  Edward Hartley','FI','437824028','Starmount Life Insurance Company','FI','720977315','Krystal  Effler','94','1891964789','348','2014-03-01','Sync Success',0,'2014-01-27 21:00:35',0,'2014-03-02 06:03:21'),(2236,2236,'2014-01-01','ET','2',1,NULL,'Deborah Poff','FI','298661008','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:49:25',0,'2014-03-10 15:39:19'),(13654,14010,'2014-01-01','ET','2',1,NULL,'Patrick Sullivan','FI','616308541','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:12',0,'2014-03-02 05:24:45'),(2050,2050,'2014-01-01','ET','2',1,NULL,'Angelea Colvin','FI','427116265','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:25',0,'2014-03-01 23:10:52'),(21395,22045,'0000-00-00','ET','2',1,NULL,'KATHLEEN LAMBERT','FI','293484973','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:07',0,'2014-03-10 14:45:25'),(22798,23448,'0000-00-00','ET','2',2,1,'Norman Ray Bower','FI','288702110','Dental Care Plus, Inc.','FI','311185262','Pamela  Hahn','94','783373','348','2014-04-01','Sync Success',0,'2014-03-09 21:00:48',0,'2014-03-09 21:35:27'),(22816,23466,'0000-00-00','ET','2',2,1,'NATHAN WARNECKE','FI','301783088','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:05',0,'2014-03-10 14:50:59'),(13503,13859,'2014-01-01','ET','2',2,1,'jeffery hibbitts','FI','467887491','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:18',0,'2014-03-02 05:24:45'),(3136,3136,'2014-01-01','ET','2',1,NULL,'Barbara Cornett','FI','453947322','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:37:17',0,'2014-03-02 01:10:33'),(15535,15986,'0000-00-00','ET','2',2,1,'LYNN  CURTIS','FI','264374368','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:06',0,'2014-03-10 16:17:47'),(17217,17867,'0000-00-00','ET','2',1,NULL,'Paul Gibson','FI','219922621','Dental Care Plus, Inc.','FI','311185262','Robert  Colaianni','94','16444219','348','2014-03-01','Sync Success',0,'2014-02-05 21:30:14',0,'2014-03-01 17:20:55'),(21434,22084,'0000-00-00','ET','2',1,NULL,'Cheryl Njapau','FI','439915657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:05',0,'2014-03-03 22:26:43'),(21741,22391,'0000-00-00','ET','2',1,NULL,'Lisa Michaels','FI','132621925','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:12',0,'2014-03-10 14:45:25'),(308,308,'2014-01-01','ET','2',1,NULL,'Mark Bowden','FI','465539830','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:26',0,'2014-03-01 22:10:55'),(11449,11449,'2014-01-01','ET','2',1,NULL,'Clark Daniel Andrews','FI','234761108','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:30:07',0,'2014-03-01 16:23:43'),(20527,21177,'0000-00-00','ET','2',1,NULL,'ANTONIA BALLEZA','FI','630904793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:01:02',0,'2014-03-02 07:10:28'),(14249,14700,'2014-01-01','ET','2',1,NULL,'Brenda Goolsby','FI','284443878','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:02',0,'2014-03-01 16:46:19'),(19695,20345,'0000-00-00','ET','2',2,1,'Kathryn Culpepper','FI','338766667','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:53:49',0,'2014-03-10 16:31:33'),(19214,19864,'0000-00-00','ET','2',1,NULL,'Sergio Rivas','FI','637037504','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:11',0,'2014-03-02 06:52:12'),(12533,12533,'2014-01-01','ET','2',1,NULL,'Janet Vann','FI','515606828','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:33',0,'2014-03-02 05:03:29'),(18459,19109,'0000-00-00','ET','2',1,NULL,'jerry christman','FI','605075032','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:43',0,'2014-03-10 14:31:05'),(11620,11620,'2014-01-01','ET','2',1,NULL,'Catherine Ninness','FI','382944120','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:21',0,'2014-03-10 16:10:34'),(13729,14085,'2014-01-01','ET','2',1,NULL,'donna minton','FI','430410949','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:00',0,'2014-03-02 05:24:45'),(14365,14816,'2014-01-01','ET','2',2,1,'GREG IRWIN','FI','295642943','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:51',0,'2014-03-10 16:17:47'),(22356,23006,'0000-00-00','ET','2',1,NULL,'cythnia PHILBRICK','FI','295623227','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:14',0,'2014-03-07 21:36:32'),(2814,2814,'2014-01-01','ET','2',1,NULL,'Tyrone C Smith','FI','298701446','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:20:45',0,'2014-03-01 16:05:34'),(20029,20679,'0000-00-00','ET','2',1,NULL,'Donna G Armit','FI','437966986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:01:12',0,'2014-03-02 07:03:25'),(18068,18718,'0000-00-00','ET','2',1,NULL,'Marcus Johnson','FI','449233180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:14',0,'2014-03-02 06:38:05'),(4164,4164,'2014-01-01','ET','2',1,NULL,'gary miller','FI','270706049','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:05:07',0,'2014-03-10 15:59:47'),(17306,17956,'0000-00-00','ET','2',1,NULL,'mechelle donnelly','FI','347684318','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:58',0,'2014-03-02 06:24:38'),(10923,10923,'2014-01-01','ET','2',1,NULL,'Kathleen Keenan','FI','285744787','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:24',0,'2014-03-10 16:03:49'),(22381,23031,'0000-00-00','ET','2',1,NULL,'WENDY WEBB','FI','230255605','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:26',0,'2014-03-07 21:25:22'),(531,531,'2014-01-01','ET','2',2,1,'MICHELLE SAWYER','FI','281704261','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:01:23',0,'2014-03-01 15:48:04'),(1215,1215,'2014-01-01','ET','2',1,NULL,'Jessica Frank','FI','273823854','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:14',0,'2014-03-01 16:15:39'),(19912,20562,'0000-00-00','ET','2',1,NULL,'rosa r rayos','FI','452949664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 21:30:12',0,'2014-03-02 07:03:25'),(4679,4679,'2014-01-01','ET','2',3,2,'Sasidhar Pullalarevu','FI','177808485','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:53',0,'2014-03-01 16:15:39'),(16671,17321,'0000-00-00','ET','2',1,NULL,'David Damon','FI','234721817','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-31 21:00:55',0,'2014-03-01 17:00:58'),(15570,16021,'0000-00-00','ET','2',1,NULL,'Steven Davis','FI','289464639','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:22',0,'2014-03-01 16:50:53'),(14768,15219,'2014-01-01','ET','2',1,NULL,'abbie pell','FI','627038734','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:38',0,'2014-03-02 05:45:37'),(14049,14500,'2014-01-01','ET','2',1,NULL,'kevin l gamiere','FI','297588804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:01',0,'2014-03-01 16:40:16'),(11768,11768,'2014-01-01','ET','2',1,NULL,'Brad Negrotto','FI','438619370','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:09:58',0,'2014-03-02 04:59:36'),(4626,4626,'2014-01-01','ET','2',2,1,'Michael Balahutrak','FI','290469093','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:07',0,'2014-03-02 04:31:46'),(3335,3335,'2014-01-01','ET','2',1,NULL,'Heather Platz-Rosenow','FI','274667346','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:49:40',0,'2014-03-10 15:52:36'),(3701,3701,'2014-01-01','ET','2',2,1,'Laureen rives','FI','436319367','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:32',0,'2014-03-02 01:10:33'),(22083,22733,'0000-00-00','ET','2',1,NULL,'Charles Lyle Terry','FI','629104840','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:16',0,'2014-03-06 21:27:26'),(10416,10416,'2014-01-01','ET','2',1,NULL,'ronald hall','FI','294702380','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:51:14',0,'2014-03-01 16:10:36'),(2275,2275,'2014-01-01','ET','2',1,NULL,'Pamela Vargas','FI','641321574','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:20',0,'2014-03-01 21:11:04'),(4100,4100,'2014-01-01','ET','2',1,NULL,'JEFFREY HINRICHS','FI','286569915','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:14',0,'2014-03-01 16:00:27'),(14040,14396,'2014-01-01','ET','2',2,1,'Janet Beery','FI','297783458','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:59',0,'2014-03-10 14:03:26'),(19887,20537,'0000-00-00','ET','2',1,NULL,'LINDA PARKER','FI','275644784','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:01:34',0,'2014-03-10 16:38:05'),(18391,19041,'0000-00-00','ET','2',1,NULL,'ELAINE WILLIAMS','FI','439238725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:54',0,'2014-03-02 06:45:14'),(1055,1055,'2014-01-01','ET','2',1,NULL,'JANE ELIZABETH BLAKE','FI','327407796','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:30:26',0,'2014-03-01 15:16:37'),(21308,21958,'0000-00-00','ET','2',1,NULL,'Patricia Loizou','FI','290523318','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:11',0,'2014-03-10 14:45:25'),(21067,21717,'0000-00-00','ET','2',1,NULL,'GERALD PARKER','FI','276707082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:25',0,'2014-03-01 18:10:11'),(5611,5611,'2014-01-01','ET','2',5,4,'Wei Yang','FI','052788617','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:49:59',0,'2014-03-01 16:23:43'),(20164,20814,'0000-00-00','ET','2',1,NULL,'ROSE MONTIL','FI','291545269','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:05',0,'2014-03-01 18:08:07'),(19540,20190,'0000-00-00','ET','2',1,NULL,'Linda Scott','FI','587114454','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:15:35',0,'2014-03-02 06:59:07'),(4435,4435,'2014-01-01','ET','2',1,NULL,'terrence davidson','FI','488805725','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:17:14',0,'2014-03-10 13:03:33'),(18416,19066,'0000-00-00','ET','2',1,NULL,'Alyse Nelson','FI','282482442','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:31:13',0,'2014-03-01 17:26:36'),(16550,17200,'0000-00-00','ET','2',1,NULL,'Kenneth Lemoine','FI','436594952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:09',0,'2014-03-02 06:10:30'),(13922,14278,'2014-01-01','ET','2',1,NULL,'James Neumeier','FI','302720008','HealthSpan','FI','311431434','Deborah  Shelley','94','15984551','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:15',0,'2014-03-10 14:03:26'),(3063,3063,'2014-01-01','ET','2',1,NULL,'Jeanie Moore','FI','277702539','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:03',0,'2014-03-01 15:37:30'),(2083,2083,'2014-01-01','ET','2',2,1,'Darl Wilson','FI','274524217','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:29',0,'2014-03-10 13:20:27'),(11138,11138,'2014-01-01','ET','2',3,2,'Thomas Hundley','FI','284681730','HealthSpan','FI','311431434','Tim  Iori','94','517910','348','2014-01-01','Sync Success',0,'2013-12-26 13:15:31',0,'2014-03-10 13:45:57'),(11802,11802,'2014-01-01','ET','2',1,NULL,'Aaron Peterson','FI','259630592','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:13:10',0,'2014-03-10 16:03:49'),(20658,21308,'0000-00-00','ET','2',1,NULL,'CYNTHIA FORGACS','FI','293587258','Summa Insurance Company, Inc.','FI','341809108','BENJAMIN P KELLY','94','2516200','348','2014-03-01','Sync Success',0,'2014-02-26 21:02:31',0,'2014-03-10 16:38:05'),(19617,20268,'0000-00-00','ET','2',1,NULL,'Rhonda Phillips','FI','284689766','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:35:17',0,'2014-03-01 17:47:19'),(19515,20165,'0000-00-00','ET','2',1,NULL,'SUSAN CZEKANSKY','FI','282588932','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:08:20',0,'2014-03-01 17:47:19'),(12418,12418,'2014-01-01','ET','2',1,NULL,'Gaye Laing','FI','433271144','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:20',0,'2014-03-02 05:03:29'),(18097,18747,'0000-00-00','ET','2',1,NULL,'Brent Stock','FI','640344875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:36',0,'2014-03-02 06:38:05'),(17250,17900,'0000-00-00','ET','2',1,NULL,'Paris Bardo','FI','285869005','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:32',0,'2014-03-01 17:20:55'),(893,893,'2014-01-01','ET','2',1,NULL,'Kimberly  Thompson','FI','269547828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:56',0,'2014-03-01 15:21:15'),(7763,7763,'2014-01-01','ET','2',1,NULL,'laura bair','FI','295680336','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:01:18',0,'2014-03-10 13:03:33'),(21909,22559,'0000-00-00','ET','2',1,NULL,'Jessica Street','FI','467731872','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-20','Sync Success',0,'2014-03-05 21:30:50',0,'2014-03-05 22:27:33'),(21797,22447,'0000-00-00','ET','2',1,NULL,'DELIA RODRIGUEZ','FI','309663751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:14',0,'2014-03-04 22:25:23'),(20095,20745,'0000-00-00','ET','2',1,NULL,'Mark Rosenbohm','FI','433230409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:15',0,'2014-03-02 07:10:28'),(7566,7566,'2014-01-01','ET','2',1,NULL,'Charles  Fritz','FI','288568358','Dental Care Plus, Inc.','FI','311185262','Darwin  Carmichael','94','1300095','348','2014-01-01','Sync Success',0,'2013-12-26 04:36:10',0,'2014-03-01 16:05:34'),(3017,3017,'2014-01-01','ET','2',1,NULL,'Thomas  Blemenschutz','FI','278543816','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:39',0,'2014-03-10 15:52:36'),(3174,3174,'2014-01-01','ET','2',1,NULL,'Jessica Crider','FI','293923476','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:37',0,'2014-03-10 13:24:34'),(4127,4127,'2014-01-01','ET','2',1,NULL,'manfred meier','FI','286561917','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:00',0,'2014-03-01 16:00:27'),(5188,5188,'2014-01-01','ET','2',1,NULL,'Senia Gomez','FI','645106521','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:52:00',0,'2014-03-02 00:10:48'),(1731,1731,'2014-01-01','ET','2',1,NULL,'Susan Kelby','FI','299684258','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:25',0,'2014-03-01 15:31:33'),(19972,20622,'0000-00-00','ET','2',1,NULL,'PAULA M HOBERG','FI','281805244','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:32',0,'2014-03-01 17:47:19'),(3773,3773,'2014-01-01','ET','2',1,NULL,'timothy hawe','FI','530902745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:15:27',0,'2014-03-01 23:10:52'),(3797,3797,'2014-01-01','ET','2',5,4,'Richard Ruedlinger','FI','300760348','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:10',0,'2014-03-10 15:45:56'),(13376,13732,'2014-01-01','ET','2',1,NULL,'Wanda Ragan','FI','263923882','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:43',0,'2014-03-02 05:24:45'),(22554,23204,'0000-00-00','ET','2',1,NULL,'carol lindsay','FI','297428298','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-05-01','Sync Success',0,'2014-03-07 21:31:49',0,'2014-03-10 16:44:18'),(10857,10857,'2014-01-01','ET','2',2,1,'Pam Couch','FI','282586336','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:43',0,'2014-03-10 13:45:57'),(20961,21611,'0000-00-00','ET','2',1,NULL,'RICHARD WILSON','FI','451047173','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:13',0,'2014-03-02 07:17:36'),(19964,20614,'0000-00-00','ET','2',1,NULL,'Gabriel Cotruta','FI','285065390','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:26',0,'2014-03-01 17:47:19'),(19255,19905,'0000-00-00','ET','2',1,NULL,'CONCION LOPEZ','FI','548917705','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:43',0,'2014-03-02 06:52:12'),(18785,19435,'0000-00-00','ET','2',1,NULL,'Angela K Duggins','FI','288807142','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:02:56',0,'2014-03-10 14:31:05'),(16179,16828,'0000-00-00','ET','2',1,NULL,'Stanley Rydarowics','FI','300509677','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:25',0,'2014-03-01 16:56:22'),(15928,16577,'0000-00-00','ET','2',3,2,'LINDA MARIE PODLICH','FI','274708782','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-25 19:00:10',0,'2014-03-01 16:56:22'),(2117,2117,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:28',0,'2014-03-01 15:16:37'),(13599,13955,'2014-01-01','ET','2',1,NULL,'Virginia Kondo','FI','461906099','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:23',0,'2014-03-02 05:31:31'),(5759,5759,'2014-01-01','ET','2',2,1,'Jeffrey Betty','FI','096642787','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:11',0,'2014-03-02 01:10:33'),(4317,4317,'2014-01-01','ET','2',1,NULL,'Elise Thompson','FI','439274935','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:45',0,'2014-03-02 03:09:49'),(5400,5400,'2014-01-01','ET','2',1,NULL,'Andrea monae Steptoe','FI','458450777','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:13',0,'2014-03-01 20:10:57'),(2211,2211,'2014-01-01','ET','2',1,NULL,'FREDDIE  MAE  MILLER','FI','436823697','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:48:32',0,'2014-03-01 21:11:04'),(4105,4105,'2014-01-01','ET','2',1,NULL,'MINDI SPENCE','FI','295547066','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:03:23',0,'2014-03-01 16:00:27'),(5729,5729,'2014-01-01','ET','2',1,NULL,'Sarah Gaugh','FI','287840931','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 02:01:15',0,'2014-03-01 15:48:04'),(5214,5214,'2014-01-01','ET','2',1,NULL,'Hattie Lewis','FI','439801276','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:52:49',0,'2014-03-02 00:10:48'),(20166,20816,'0000-00-00','ET','2',1,NULL,'FREDDIE A CLARIETTE','FI','413883525','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:31:06',0,'2014-03-01 18:08:07'),(5420,5420,'2014-01-01','ET','2',1,NULL,'Joseph Snavely','FI','292881403','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:57',0,'2014-03-01 15:10:22'),(19215,19865,'0000-00-00','ET','2',1,NULL,'Vivian Tippler','FI','628603569','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:12',0,'2014-03-02 06:52:12'),(19151,19801,'0000-00-00','ET','2',4,3,'RONALD HARDE ZILER','FI','273880655','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:23',0,'2014-03-10 16:31:33'),(18800,19450,'0000-00-00','ET','2',2,1,'Maureen Hemenway','FI','298469195','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:08',0,'2014-03-10 14:31:05'),(13635,13991,'2014-01-01','ET','2',1,NULL,'Constance Reid','FI','288483519','HealthSpan','FI','311431434','Stephen James Ray','94','1484647','348','2014-02-01','Sync Success',0,'2014-01-13 02:20:51',0,'2014-03-10 14:03:26'),(14611,15062,'2014-01-01','ET','2',1,NULL,'DOROTHY  EDMOND','FI','285527118','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:56',0,'2014-03-01 16:46:19'),(16937,17587,'0000-00-00','ET','2',1,NULL,'marilyn ann Washington','FI','425154025','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:49',0,'2014-03-02 06:17:30'),(746,746,'2014-01-01','ET','2',1,NULL,'Lindsay Piper','FI','287904195','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:13',0,'2014-03-10 13:24:34'),(6119,6119,'2014-01-01','ET','2',1,NULL,'Debbie Queen','FI','281507975','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:52',0,'2014-03-01 16:00:27'),(5937,5937,'2014-01-01','ET','2',1,NULL,'william dunlap','FI','296408553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:56',0,'2014-03-01 15:48:04'),(840,840,'2014-01-01','ET','2',1,NULL,'Karen Jane Evans Glasgo','FI','288703638','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:21',0,'2014-03-10 15:39:19'),(3220,3220,'2014-01-01','ET','2',2,1,'Tianling Sun','FI','014922871','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:45:55',0,'2014-03-01 15:52:44'),(17376,18026,'0000-00-00','ET','2',1,NULL,'Tiffany Lane','FI','457990055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:26',0,'2014-03-02 06:31:45'),(16804,17454,'0000-00-00','ET','2',1,NULL,'Therese M Hackett','FI','301642366','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:44',0,'2014-03-10 16:24:30'),(16773,17423,'0000-00-00','ET','2',1,NULL,'GWAYNE A BRISSETT','FI','279138468','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:23',0,'2014-03-10 14:20:26'),(16376,17026,'0000-00-00','ET','2',1,NULL,'CAROL A GUILBEAUX','FI','433175743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:11',0,'2014-03-02 06:10:30'),(14401,14852,'2014-01-01','ET','2',1,NULL,'Carol Leever','FI','287645274','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:07',0,'2014-03-01 16:46:19'),(22653,23303,'0000-00-00','ET','2',2,1,'Raul Flores','FI','545745354','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:23',0,'2014-03-08 22:26:18'),(11000,11000,'2014-01-01','ET','2',1,NULL,'kathleen spillman','FI','556576916','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:10:48',0,'2014-03-02 04:31:46'),(19476,20126,'0000-00-00','ET','2',2,1,'ERIKA VERDUGO','FI','650147923','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:55:38',0,'2014-03-02 06:59:07'),(7599,7599,'2014-01-01','ET','2',1,NULL,'James Martin','FI','289889108','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:37:16',0,'2014-03-10 15:59:47'),(17084,17734,'0000-00-00','ET','2',1,NULL,'Richard Andrew Fredley','FI','297886132','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-02-04 21:00:50',0,'2014-03-01 17:00:58'),(16905,17555,'0000-00-00','ET','2',1,NULL,'Donald G Wertz','FI','293567497','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:30',0,'2014-03-01 17:00:58'),(16847,17497,'0000-00-00','ET','2',2,1,'Daniel Klaas','FI','170581136','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:22',0,'2014-03-01 17:00:58'),(3466,3466,'2014-01-01','ET','2',1,NULL,'Ed Ball','FI','274601003','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:00:06',0,'2014-03-01 15:31:33'),(90,90,'2014-01-01','ET','2',2,1,'Sylvia Cano-Otero','FI','464470987','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:43',0,'2014-03-01 22:10:55'),(21053,21703,'0000-00-00','ET','2',1,NULL,'LONDON WILLIAMS','FI','280764769','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:15',0,'2014-03-01 18:10:11'),(18510,19160,'0000-00-00','ET','2',2,1,'Diana Starnes','FI','413966313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:32:18',0,'2014-03-02 06:45:14'),(18294,18944,'0000-00-00','ET','2',1,NULL,'SEEMA  CHELLATH','FI','616737041','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:23',0,'2014-03-01 17:26:36'),(17968,18618,'0000-00-00','ET','2',1,NULL,'Carol E Morgan','FI','291505072','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:16',0,'2014-03-10 14:24:38'),(17507,18157,'0000-00-00','ET','2',1,NULL,'Beatrica Rice','FI','644018598','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:00:05',0,'2014-03-02 06:31:45'),(13639,13995,'2014-01-01','ET','2',1,NULL,'Bruce Bucklan','FI','285420046','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:54',0,'2014-03-10 16:10:34'),(683,683,'2014-01-01','ET','2',1,NULL,'Tyler Grano','FI','274905295','Summa Insurance Company, Inc.','FI','341809108','Scott  Klonowski','94','104157','348','2014-01-01','Sync Success',0,'2013-12-25 18:06:11',0,'2014-03-10 15:52:36'),(1889,1889,'2014-01-01','ET','2',1,NULL,'Cody Witt','FI','627121206','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:27',0,'2014-03-01 23:10:52'),(5289,5289,'2014-01-01','ET','2',1,NULL,'Nicole Phillips','FI','307961159','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:01:02',0,'2014-03-01 20:10:57'),(3928,3928,'2014-01-01','ET','2',1,NULL,'ELIZABETH JORDAN','FI','271544928','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:54',0,'2014-03-10 15:45:56'),(3047,3047,'2014-01-01','ET','2',1,NULL,'DARLENE DICKERSON','FI','280567389','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:31',0,'2014-03-01 15:37:30'),(11301,11301,'2014-01-01','ET','2',1,NULL,'Joe Mauldin','FI','467253000','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:33',0,'2014-03-02 04:45:37'),(22372,23022,'0000-00-00','ET','2',1,NULL,'TOSHIA NEWSOME','FI','452910721','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:21',0,'2014-03-07 21:25:22'),(2638,2638,'2014-01-01','ET','2',2,1,'mark snyder','FI','287441869','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:47:14',0,'2014-03-10 13:03:33'),(21218,21868,'0000-00-00','ET','2',1,NULL,'victor jurado','FI','450551912','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-03-01 21:00:08',0,'2014-03-02 07:23:39'),(21009,21659,'0000-00-00','ET','2',2,1,'erlin crochet','FI','439942861','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:06',0,'2014-03-02 07:23:39'),(18746,19396,'0000-00-00','ET','2',1,NULL,'JUNIOR TAYLOR','FI','435882986','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:27',0,'2014-03-02 06:45:14'),(17804,18454,'0000-00-00','ET','2',1,NULL,'Matthew Ciraci','FI','294922565','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:37',0,'2014-03-01 16:50:53'),(5820,5820,'2014-01-01','ET','2',1,NULL,'Sarah Higgins','FI','456060557','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:15:05',0,'2014-03-01 20:10:57'),(16424,17074,'0000-00-00','ET','2',1,NULL,'MATTHEW TRENT','FI','242577797','HealthSpan','FI','311431434','PAUL DREW BAREFOOT','94','6580831','348','2014-03-01','Sync Success',0,'2014-01-29 21:01:42',0,'2014-03-10 14:20:26'),(10805,10805,'2014-01-01','ET','2',2,1,'Cynthia Greer','FI','435064717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:04:01',0,'2014-03-02 04:24:47'),(14507,14958,'2014-01-01','ET','2',2,1,'brent byers','FI','284705876','HealthSpan','FI','311431434','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-15 02:07:56',0,'2014-03-10 14:03:26'),(1139,1139,'2014-01-01','ET','2',1,NULL,'Jeff Mosley','FI','467678184','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:45:52',0,'2014-03-02 04:45:37'),(20375,21025,'0000-00-00','ET','2',1,NULL,'Cedric Pearson','FI','587574056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:04',0,'2014-03-02 07:03:25'),(3041,3041,'2014-01-01','ET','2',1,NULL,'James Higgins','FI','180440249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:34:21',0,'2014-03-01 15:37:30'),(19028,19678,'0000-00-00','ET','2',1,NULL,'SARAH ROBINSON','FI','287907848','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 21:00:02',0,'2014-03-01 17:34:07'),(17607,18257,'0000-00-00','ET','2',1,NULL,'PHILLIP BOCCUTO','FI','575860804','Starmount Life Insurance Company','FI','720977315','Fernando  Orozco','94','1438597','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:08',0,'2014-03-02 06:31:45'),(2856,2856,'2014-01-01','ET','2',1,NULL,'Sarah Allred','FI','275985946','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:13',0,'2014-03-10 15:59:47'),(13975,14331,'2014-01-01','ET','2',2,1,'Jonathan Barry Brecheen','FI','438418597','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:01:11',0,'2014-03-02 05:31:31'),(12532,12532,'2014-01-01','ET','2',1,NULL,'Mary Clark','FI','214887313','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:34:30',0,'2014-03-02 05:03:29'),(12402,12402,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-02 04:29:44',0,'2014-03-01 16:35:14'),(11953,11953,'2014-01-01','ET','2',1,NULL,'LaTau Martin','FI','254470819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:00:20',0,'2014-03-02 04:59:36'),(11033,11033,'2014-01-01','ET','2',1,NULL,'Bryan Spade','FI','275829118','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:11:55',0,'2014-03-10 16:03:49'),(7519,7519,'2014-01-01','ET','2',1,NULL,'Kathleen Schurr','FI','276900192','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:39',0,'2014-03-01 16:05:34'),(3583,3583,'2014-01-01','ET','2',1,NULL,'michael pfrimmer','FI','239821594','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:51',0,'2014-03-02 00:10:48'),(4888,4888,'2014-01-01','ET','2',2,1,'MARGRET  GOSHORN','FI','270525922','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:16:56',0,'2014-03-10 13:03:33'),(22864,23514,'0000-00-00','ET','2',1,NULL,'JUDITH MANZA','FI','552745406','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:13',0,'2014-03-10 21:27:11'),(463,463,'2014-01-01','ET','2',1,NULL,'An Huynh','FI','284947095','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:50:25',0,'2014-03-10 13:10:24'),(1646,1646,'2014-01-01','ET','2',1,NULL,'THOMAS R MYERS','FI','282581139','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:22',0,'2014-03-10 13:03:33'),(16287,16937,'0000-00-00','ET','2',3,2,'John Holub','FI','460296071','Starmount Life Insurance Company','FI','720977315','Alan  Charing','94','16800293','348','2014-03-01','Sync Success',0,'2014-01-29 21:00:14',0,'2014-03-02 06:10:30'),(2491,2491,'2014-01-01','ET','2',2,1,'CAROL FLAUGHER','FI','407926291','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:15',0,'2014-03-10 13:10:24'),(15488,15939,'0000-00-00','ET','2',1,NULL,'SHARON SMITH','FI','302567156','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',1,'2014-01-22 03:23:06',0,'2014-03-10 14:10:12'),(13910,14266,'2014-01-01','ET','2',1,NULL,'Matthew Wagner','FI','076764663','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:08',0,'2014-03-01 16:40:16'),(2680,2680,'2014-01-01','ET','2',1,NULL,'Lisa M Martin','FI','261958238','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:16:34',0,'2014-03-02 04:15:49'),(13158,13514,'2014-01-01','ET','2',1,NULL,'lea parrish','FI','425631300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:12',0,'2014-03-02 05:17:40'),(12928,12928,'2014-01-01','ET','2',2,1,'Julie Bess Jelinek','FI','391806999','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:58',0,'2014-03-10 16:10:34'),(12775,12775,'2014-01-01','ET','2',2,1,'Shaun Renzenbrink','FI','290828773','Dental Care Plus, Inc.','FI','311185262','Michael  Daugherty','94','1131360','348','2014-02-01','Sync Success',0,'2014-01-04 02:00:18',0,'2014-03-01 16:35:14'),(12560,12560,'2014-01-01','ET','2',2,1,'CONNIE BEACH','FI','292565707','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:35:40',0,'2014-03-10 13:59:38'),(21,21,'2014-01-01','ET','2',1,NULL,'Mark Sauer','FI','293744511','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:39',0,'2014-03-01 15:21:15'),(19164,19814,'0000-00-00','ET','2',2,1,'ANTHONY LALUMIA','FI','459844639','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:34',0,'2014-03-02 06:52:12'),(10686,10686,'2014-01-01','ET','2',1,NULL,'Gabriel Kirk Mudd','FI','258510568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:02',0,'2014-03-01 16:10:36'),(18014,18664,'0000-00-00','ET','2',1,NULL,'Tammy Cook','FI','293824455','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:49',0,'2014-03-01 17:20:55'),(6339,6339,'2014-01-01','ET','2',1,NULL,'JEANNE DAILEY','FI','551962589','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:08:35',0,'2014-03-02 04:10:25'),(13325,13681,'2014-01-01','ET','2',1,NULL,'BOBBY HERROD','FI','587552679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:21',0,'2014-03-02 05:24:45'),(4616,4616,'2014-01-01','ET','2',1,NULL,'Marlynda Jennings','FI','462614294','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:44',0,'2014-03-02 04:31:46'),(12246,12246,'2014-01-01','ET','2',1,NULL,'Kim Carter','FI','461068420','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:17',0,'2014-03-02 05:10:52'),(11956,11956,'2014-01-01','ET','2',1,NULL,'REGINA OBRIAN','FI','456903371','Starmount Life Insurance Company','FI','720977315','NICOLE  BOLLERO-JOHNSON','94','1138366','348','2014-02-01','Sync Success',0,'2014-01-01 12:00:26',0,'2014-03-02 04:59:36'),(2868,2868,'2014-01-01','ET','2',3,2,'Teresa Gross','FI','271665958','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:34',0,'2014-03-10 13:39:10'),(1644,1644,'2014-01-01','ET','2',1,NULL,'BONNIE SUE BARNETT','FI','302440484','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:18',0,'2014-03-10 13:03:33'),(2723,2723,'2014-01-01','ET','2',1,NULL,'Kesha Simmons','FI','436634149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:17:55',0,'2014-03-02 04:15:49'),(20994,21644,'0000-00-00','ET','2',1,NULL,'Chris Bencar','FI','272909722','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 07:30:35',0,'2014-03-10 16:38:05'),(3944,3944,'2014-01-01','ET','2',1,NULL,'Janice Jernigan','FI','435430034','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:21',0,'2014-03-01 23:10:52'),(18477,19127,'0000-00-00','ET','2',1,NULL,'pamela emmons','FI','280484914','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:55',0,'2014-03-10 14:31:05'),(17667,18317,'0000-00-00','ET','2',1,NULL,'Kevin Gibson','FI','272729618','Dental Care Plus, Inc.','FI','311185262','Roni  Bell','94','3345388','348','2014-03-01','Sync Success',0,'2014-02-08 19:00:45',0,'2014-03-01 17:20:55'),(16093,16742,'0000-00-00','ET','2',1,NULL,'AMANDA EHRHARDT','FI','284920559','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:12',0,'2014-03-10 14:20:26'),(11192,11192,'2014-01-01','ET','2',1,NULL,'regina railey','FI','383804127','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:12',0,'2014-03-01 16:23:43'),(15128,15579,'0000-00-00','ET','2',1,NULL,'Lindsay Machnikowski','FI','297887057','Summa Insurance Company, Inc.','FI','341809108','Timothy  Radwany','94','2211612','348','2014-03-01','Sync Success',0,'2014-01-20 08:06:11',0,'2014-03-10 16:17:47'),(12898,12898,'2014-01-01','ET','2',2,1,'Christoffer Lee','FI','118744374','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:49',0,'2014-03-10 13:59:38'),(23098,23748,'0000-00-00','ET','2',1,NULL,'MIKE KOLOFF','FI','281561323','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:00',0,'2014-03-10 21:36:25'),(4622,4622,'2014-01-01','ET','2',1,NULL,'Rodney  J Johnson','FI','455903879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:58',0,'2014-03-02 04:31:46'),(7490,7490,'2014-01-01','ET','2',2,1,'tina marie bryant','FI','295728868','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:33:41',0,'2014-03-10 13:39:10'),(5237,5237,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 00:53:37',0,'2014-03-10 13:20:27'),(17747,18397,'0000-00-00','ET','2',1,NULL,'Lesa McKenzie','FI','463415030','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:34',0,'2014-03-02 06:31:45'),(5339,5339,'2014-01-01','ET','2',1,NULL,'Cheryl Waltz','FI','268640805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:28',0,'2014-03-01 15:10:22'),(16107,16756,'0000-00-00','ET','2',1,NULL,'Ryan Williams','FI','276923551','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:22',0,'2014-03-10 14:20:26'),(14159,14610,'2014-01-01','ET','2',2,1,'Roy Mitchell','FI','298540937','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:12',0,'2014-03-10 16:17:47'),(15362,15813,'0000-00-00','ET','2',1,NULL,'JO ANN ALTMAN','FI','283640942','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:56',0,'2014-03-10 14:10:12'),(15266,15717,'0000-00-00','ET','2',2,1,'Kurt Waggoner','FI','306826525','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:41',0,'2014-03-10 14:10:12'),(15142,15593,'0000-00-00','ET','2',2,1,'jaime  ibanez','FI','662201360','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:21',0,'2014-03-02 05:52:31'),(14842,15293,'2014-01-01','ET','2',1,NULL,'Justin Jordan','FI','445965929','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:47:26',0,'2014-03-10 14:10:12'),(5960,5960,'2014-01-01','ET','2',1,NULL,'Denise Lynn Cheplick','FI','061548944','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:39',0,'2014-03-02 01:10:33'),(11111,11111,'2014-01-01','ET','2',1,NULL,'Charlotte L Robinson','FI','283547857','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:28',0,'2014-03-10 13:45:57'),(20609,21259,'0000-00-00','ET','2',1,NULL,'MINNIE MOORE','FI','587540467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-26 21:01:54',0,'2014-03-02 07:10:28'),(20411,21061,'0000-00-00','ET','2',1,NULL,'Pamela Nicotra','FI','425132311','Starmount Life Insurance Company','FI','720977315','Kathy   Canlas','94','7407489','348','2014-04-01','Sync Success',0,'2014-02-26 09:30:35',0,'2014-03-02 07:10:28'),(19991,20641,'0000-00-00','ET','2',1,NULL,'MOHAMED OULDSIDIRIJAL','FI','401533303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:45',0,'2014-03-02 07:03:25'),(13215,13571,'2014-01-01','ET','2',1,NULL,'MARILYN GALE JONES','FI','462313005','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:21:37',0,'2014-03-02 05:17:40'),(18428,19078,'0000-00-00','ET','2',4,3,'ELYSE CLARKE','FI','165629583','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:23',0,'2014-03-01 17:26:36'),(1366,1366,'2014-01-01','ET','2',2,1,'Benjamin Horlander','FI','450838926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:55',0,'2014-03-02 04:38:08'),(1838,1838,'2014-01-01','ET','2',1,NULL,'Amanda Wyatt','FI','268882289','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:20:53',0,'2014-03-10 13:20:27'),(21735,22385,'0000-00-00','ET','2',1,NULL,'le orton','94','0000731254','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:07',0,'2014-03-10 16:44:18'),(21278,21928,'0000-00-00','ET','2',1,NULL,'Lisa Douglas','FI','439047183','Starmount Life Insurance Company','FI','720977315','greg  town','94','1637275','348','2014-04-01','Sync Success',0,'2014-03-01 21:00:48',0,'2014-03-02 07:23:39'),(17522,18172,'0000-00-00','ET','2',1,NULL,'Barbara Lewis','FI','455824559','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:15',0,'2014-03-02 06:31:45'),(16659,17309,'0000-00-00','ET','2',1,NULL,'Micheal Hill','FI','365528774','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-31 21:00:47',0,'2014-03-10 16:24:30'),(1998,1998,'2014-01-01','ET','2',1,NULL,'ALICIA MUNOZ','FI','464940998','Starmount Life Insurance Company','FI','720977315','KENNETH E MOORE','94','10163554','348','2014-01-01','Sync Success',0,'2013-12-25 19:34:48',0,'2014-03-01 23:10:52'),(14724,15175,'2014-01-01','ET','2',1,NULL,'Danny Hatfield','FI','433210774','Starmount Life Insurance Company','FI','720977315','Greg  Town','94','1637275','348','2014-02-01','Sync Success',0,'2014-01-16 08:46:11',0,'2014-03-02 05:45:37'),(14692,15143,'2014-01-01','ET','2',1,NULL,'Kendall Leopaul','FI','439250222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:49',0,'2014-03-02 05:45:37'),(2052,2052,'2014-01-01','ET','2',1,NULL,'CHERRI NAN POLK','FI','415985691','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:28',0,'2014-03-02 00:10:48'),(2959,2959,'2014-01-01','ET','2',1,NULL,'April Risner','FI','286769768','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:52',0,'2014-03-01 15:37:30'),(23017,23667,'0000-00-00','ET','2',1,NULL,'Robert Tarzi','FI','587680300','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:02:03',0,'2014-03-10 21:27:11'),(3815,3815,'2014-01-01','ET','2',1,NULL,'JUANITA CURTIS','FI','386703994','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:50',0,'2014-03-10 13:10:24'),(22330,22980,'0000-00-00','ET','2',1,NULL,'yara habli','94','0000115550','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-31','Received',0,'2014-03-06 21:30:19',NULL,NULL),(22243,22893,'0000-00-00','ET','2',1,NULL,'Mary Guilfoyle','FI','290543729','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:10',0,'2014-03-10 16:44:18'),(4054,4054,'2014-01-01','ET','2',1,NULL,'THANH HO','FI','606236926','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:48',0,'2014-03-02 04:10:25'),(21808,22458,'0000-00-00','ET','2',1,NULL,'LELA GARSEE','FI','435231634','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:30:23',0,'2014-03-04 22:25:23'),(20872,21522,'0000-00-00','ET','2',1,NULL,'Rosa Saenz','FI','458211195','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 06:31:32',0,'2014-03-02 07:17:36'),(6409,6409,'2014-01-01','ET','2',2,1,'Denise Smith','FI','301460575','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:10:49',0,'2014-03-10 15:59:47'),(12682,12682,'2014-01-01','ET','2',1,NULL,'Patricia Festagallo','FI','272660082','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:04:04',0,'2014-03-01 16:35:14'),(15301,15752,'0000-00-00','ET','2',1,NULL,'lisa shanes','FI','272546285','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:19',0,'2014-03-01 16:50:53'),(17213,17863,'0000-00-00','ET','2',1,NULL,'Michael Harmon','FI','379524888','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:13',0,'2014-03-01 17:20:55'),(15875,16524,'0000-00-00','ET','2',1,NULL,'Elizabeth Hrusovsky','FI','298904405','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:57',0,'2014-03-10 16:24:30'),(2323,2323,'2014-01-01','ET','2',1,NULL,'Benjamin Greene','FI','260415211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:02:01',0,'2014-03-01 19:11:03'),(22266,22916,'0000-00-00','ET','2',1,NULL,'Amanda Rosen','FI','299860017','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:02:27',0,'2014-03-10 16:44:18'),(21075,21725,'0000-00-00','ET','2',1,NULL,'MARY BELOW','FI','290520015','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:30',0,'2014-03-01 18:10:11'),(6088,6088,'2014-01-01','ET','2',1,NULL,'JACK RONALD SPRADLING','FI','293504553','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:00:57',0,'2014-03-01 16:00:27'),(3633,3633,'2014-01-01','ET','2',1,NULL,'Kathy Phillips','FI','275641271','Summa Insurance Company, Inc.','FI','341809108','Beth  Gordon','94','11898877','348','2014-01-01','Sync Success',0,'2013-12-25 22:05:23',0,'2014-03-10 15:52:36'),(4316,4316,'2014-01-01','ET','2',1,NULL,'Maria Snowden','FI','433867201','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:09:44',0,'2014-03-02 03:09:49'),(18759,19409,'0000-00-00','ET','2',1,NULL,'Bessie Hall','FI','435901472','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:02:36',0,'2014-03-02 06:45:14'),(15156,15607,'0000-00-00','ET','2',1,NULL,'Byron Brown','FI','626160481','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:31',0,'2014-03-10 14:10:12'),(14830,15281,'2014-01-01','ET','2',2,1,'Dedra Swiger','FI','293787259','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-02-01','Sync Success',0,'2014-01-16 08:47:19',0,'2014-03-10 14:03:26'),(12721,12721,'2014-01-01','ET','2',1,NULL,'orla folarin','FI','065507851','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:35',0,'2014-03-10 13:59:38'),(1102,1102,'2014-01-01','ET','2',1,NULL,'Chad Kirchner','FI','289804400','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:32:05',0,'2014-03-10 13:03:33'),(2058,2058,'2014-01-01','ET','2',1,NULL,'Angelica Maghiar','FI','272822331','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:41',0,'2014-03-10 15:45:56'),(2994,2994,'2014-01-01','ET','2',1,NULL,'MELISSA M GONZALES','FI','456699090','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:32:56',0,'2014-03-02 01:10:33'),(22376,23026,'0000-00-00','ET','2',2,1,'PATRICK J KNAPP','FI','296623370','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:00:23',0,'2014-03-10 14:50:59'),(2499,2499,'2014-01-01','ET','2',1,NULL,'Christopher R Jagielski','FI','300580709','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:32',0,'2014-03-10 13:10:24'),(3012,3012,'2014-01-01','ET','2',1,NULL,'Kathleen Liotta','FI','273483631','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:33:30',0,'2014-03-10 15:52:36'),(16282,16932,'0000-00-00','ET','2',1,NULL,'DAdreinne Sweatt','FI','559879148','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:11',0,'2014-03-02 06:10:30'),(21221,21871,'0000-00-00','ET','2',2,1,'Danielle Elwood','FI','643282345','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-03-01 21:00:10',0,'2014-03-02 07:23:39'),(22857,23507,'0000-00-00','ET','2',1,NULL,'Nhan Hoai Nguyen','FI','634464859','Starmount Life Insurance Company','FI','720977315','Jimmy Hiep Dao','94','1175562','348','2014-04-01','Sync Success',0,'2014-03-10 21:00:08',0,'2014-03-10 21:27:11'),(7282,7282,'2014-01-01','ET','2',1,NULL,'Diane King','FI','272542274','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:09:11',0,'2014-03-10 13:32:15'),(2149,2149,'2014-01-01','ET','2',1,NULL,'Dale Stanley Duda','FI','366568490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:26',0,'2014-03-01 21:11:04'),(10728,10728,'2014-01-01','ET','2',1,NULL,'Amy Arps','FI','295684337','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:01:35',0,'2014-03-01 16:10:36'),(17751,18401,'0000-00-00','ET','2',2,1,'GAIL SHULKO','FI','290527097','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:36',0,'2014-03-01 17:20:55'),(17056,17706,'0000-00-00','ET','2',1,NULL,'Vicki Waddell','FI','454064075','Starmount Life Insurance Company','FI','720977315','Danielle   Abbott','94','16964484','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:33',0,'2014-03-02 06:24:38'),(11097,11097,'2014-01-01','ET','2',1,NULL,'KATHY COLEMAN','FI','268505739','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:14:00',0,'2014-03-10 13:45:57'),(12970,12970,'2014-01-01','ET','2',1,NULL,'Ashley Hymel','FI','589463892','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:01:05',0,'2014-03-02 05:17:40'),(11337,11337,'2014-01-01','ET','2',1,NULL,'Rosa Macias','FI','464216067','Starmount Life Insurance Company','FI','720977315','Christopher  Cate','94','16837384','348','2014-02-01','Sync Success',0,'2013-12-27 02:04:39',0,'2014-03-02 04:52:44'),(22315,22965,'0000-00-00','ET','2',1,NULL,'LETICIA BALINO','FI','457414410','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-06 21:30:07',0,'2014-03-06 22:25:29'),(642,642,'2014-01-01','ET','2',2,1,'David Alvarado','FI','463801396','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:58',0,'2014-03-02 02:10:49'),(1267,1267,'2014-01-01','ET','2',1,NULL,'Dolf Reeves','FI','270464154','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:44',0,'2014-03-01 16:23:43'),(17308,17958,'0000-00-00','ET','2',1,NULL,'Arnold F Leary','FI','437868233','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-05 21:30:59',0,'2014-03-02 06:24:38'),(17179,17829,'0000-00-00','ET','2',2,1,'William Bissinger','FI','275424508','HealthSpan','FI','311431434','Kenneth  LaFountain','94','1495150','348','2014-03-01','Sync Success',0,'2014-02-04 21:01:53',0,'2014-03-10 14:24:38'),(3706,3706,'2014-01-01','ET','2',1,NULL,'Melissa Montealegre','FI','438278246','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:07:43',0,'2014-03-02 01:10:33'),(16866,17516,'0000-00-00','ET','2',1,NULL,'LILLIE FOUNTAIN','FI','435942948','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:06',0,'2014-03-02 06:17:30'),(12339,12339,'2014-01-01','ET','2',1,NULL,'ANDREW BERNARD JENKINS','FI','454790693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:27:32',0,'2014-03-02 05:03:29'),(10494,10494,'2014-01-01','ET','2',1,NULL,'Darell L Buis','FI','300546095','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:53:41',0,'2014-03-01 16:15:39'),(2851,2851,'2014-01-01','ET','2',1,NULL,'Jason Gwinnup','FI','296705274','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:22:03',0,'2014-03-10 15:59:47'),(1525,1525,'2014-01-01','ET','2',1,NULL,'Glenda Watts','FI','290588321','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:14',0,'2014-03-10 16:03:49'),(407,407,'2014-01-01','ET','2',1,NULL,'Rhea Marshall','FI','270828332','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:48:36',0,'2014-03-01 15:21:15'),(7076,7076,'2014-01-01','ET','2',2,1,'Laura Landfeld','94','0000468103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:52',0,'2014-03-01 15:52:44'),(878,878,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:33',0,'2014-03-01 15:21:15'),(4578,4578,'2014-01-01','ET','2',1,NULL,'Jeff McClurg','94','0000447466','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:46:35',0,'2014-03-01 16:15:39'),(3372,3372,'2014-01-01','ET','2',1,NULL,'Gloria Rodriguez','FI','466889997','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:50:49',0,'2014-03-02 02:10:49'),(3725,3725,'2014-01-01','ET','2',3,2,'Robert Hill','FI','400231731','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:21',0,'2014-03-10 13:24:34'),(14248,14699,'2014-01-01','ET','2',2,1,'John Terrell','FI','574668561','Dental Care Plus, Inc.','FI','311185262','Thomas J Paplaczyk','94','1925192','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:01',0,'2014-03-01 16:46:19'),(13106,13462,'2014-01-01','ET','2',1,NULL,'JENNIFER L SCOTT','FI','443907512','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:03:15',0,'2014-03-02 05:17:40'),(12621,12621,'2014-01-01','ET','2',1,NULL,'JESUS ALFREDO MORALES','FI','459152200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:01:50',0,'2014-03-02 05:10:52'),(11390,11390,'2014-01-01','ET','2',2,1,'ALEXANDER MOORE','FI','428233736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:06:15',0,'2014-03-02 04:52:44'),(10465,10465,'2014-01-01','ET','2',2,1,'SHERRIE  DIFRANCESCO','FI','291460249','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:52:46',0,'2014-03-01 16:10:36'),(7698,7698,'2014-01-01','ET','2',1,NULL,'Tasha Webb','FI','159643926','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:23',0,'2014-03-01 15:10:22'),(5543,5543,'2014-01-01','ET','2',1,NULL,'Edward Reichlderfer','FI','288907115','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:47:50',0,'2014-03-01 16:23:43'),(10628,10628,'2014-01-01','ET','2',1,NULL,'nancy waldrop','FI','449839604','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:58:06',0,'2014-03-02 04:31:46'),(13929,14285,'2014-01-01','ET','2',1,NULL,'Ronnie Bagwell','FI','452837121','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 03:00:18',0,'2014-03-02 05:31:31'),(12868,12868,'2014-01-01','ET','2',2,1,'ALICE HEY','FI','404159828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:03:44',0,'2014-03-01 16:35:14'),(13463,13819,'2014-01-01','ET','2',1,NULL,'EILEEN MASSEL','FI','272685933','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:18:29',0,'2014-03-01 16:40:16'),(22021,22671,'0000-00-00','ET','2',1,NULL,'Dorcia Day','FI','329483389','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:07',0,'2014-03-05 22:27:33'),(274,274,'2014-01-01','ET','2',1,0,'Michael Johnson','FI','283708964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:31:45',0,'2014-03-01 15:05:09'),(18969,19619,'0000-00-00','ET','2',1,NULL,'ALEXANDER  BIKIS','FI','284424825','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:52',0,'2014-03-10 14:31:05'),(15958,16607,'0000-00-00','ET','2',1,NULL,'Sharon Hake','FI','287509845','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:08',0,'2014-03-01 16:56:22'),(21216,21866,'0000-00-00','ET','2',1,NULL,'Ruthann Mennen','FI','478887305','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 19:00:13',0,'2014-03-02 07:23:39'),(21853,22503,'0000-00-00','ET','2',1,NULL,'PAUL PULJIC','FI','290680808','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:08',0,'2014-03-05 21:36:22'),(7450,7450,'2014-01-01','ET','2',1,NULL,'Barton Robinson','FI','463946706','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 04:32:25',0,'2014-03-02 04:10:25'),(3596,3596,'2014-01-01','ET','2',2,1,'Eleno Contreras','FI','452934252','Starmount Life Insurance Company','FI','720977315','Miranda T Kelley','94','7552567','348','2014-01-01','Sync Success',0,'2013-12-25 22:04:13',0,'2014-03-02 01:10:33'),(4380,4380,'2014-01-01','ET','2',1,NULL,'gary daye','FI','284668607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 23:15:21',0,'2014-03-01 15:16:37'),(20301,20951,'0000-00-00','ET','2',1,NULL,'Rebecca Alcala','FI','436732230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-26 08:00:42',0,'2014-03-02 07:10:28'),(11885,11885,'2014-01-01','ET','2',1,NULL,'Martha Alicia Barranco','FI','463431180','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:00:33',0,'2014-03-02 04:59:36'),(18298,18948,'0000-00-00','ET','2',1,NULL,'PATRICIA ROLLER','FI','147448027','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:30:27',0,'2014-03-10 16:31:33'),(17579,18229,'0000-00-00','ET','2',1,NULL,'GLORIA  A DAVISON','FI','426216710','Starmount Life Insurance Company','FI','720977315','HARRIET   JONES','94','6399488','348','2014-03-01','Sync Success',0,'2014-02-07 19:00:56',0,'2014-03-02 06:31:45'),(12422,12422,'2014-01-01','ET','2',2,1,'Linda DeDon','FI','438982417','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:30:28',0,'2014-03-02 05:03:29'),(12722,12722,'2014-01-01','ET','2',1,NULL,'Deborah Gannaway','FI','302526978','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:38',0,'2014-03-10 13:59:38'),(16346,16996,'0000-00-00','ET','2',1,NULL,'bonnie ross','FI','287662504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-29 21:00:52',0,'2014-03-01 16:56:22'),(13398,13754,'2014-01-01','ET','2',1,NULL,'NET-HETEP A A TA-NESERT','FI','448647036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:54',0,'2014-03-02 05:24:45'),(2686,2686,'2014-01-01','ET','2',1,NULL,'Dennis Lewis','FI','462775515','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:16:45',0,'2014-03-02 04:15:49'),(7412,7412,'2014-01-01','ET','2',1,NULL,'REGINA  LEAR','FI','437394927','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:15',0,'2014-03-02 04:10:25'),(20327,20977,'0000-00-00','ET','2',2,1,'Tin Tran','FI','623172354','Starmount Life Insurance Company','FI','720977315','tony  ly','94','7898204','348','2014-04-01','Sync Success',0,'2014-02-26 08:30:16',0,'2014-03-02 07:03:25'),(18816,19466,'0000-00-00','ET','2',1,NULL,'Ryan Williams','FI','276923551','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-13 22:03:22',0,'2014-03-10 14:31:05'),(18637,19287,'0000-00-00','ET','2',1,NULL,'CHARLES BRITT','FI','287605629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:03',0,'2014-03-01 17:26:36'),(17697,18347,'0000-00-00','ET','2',1,NULL,'Edward Schimmel','FI','289601125','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Received',0,'2014-02-08 19:30:06',NULL,NULL),(6214,6214,'2014-01-01','ET','2',1,NULL,'Christina Kowalski','FI','298643903','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:04:43',0,'2014-03-01 16:00:27'),(3581,3581,'2014-01-01','ET','2',2,1,'LISA LAROCCA','FI','283803053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:03:45',0,'2014-03-02 00:10:48'),(14288,14739,'2014-01-01','ET','2',1,NULL,'Kari Pollock','FI','297903745','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:19',0,'2014-03-01 16:46:19'),(13748,14104,'2014-01-01','ET','2',2,1,'Toni Wilson','FI','286749924','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:13',0,'2014-03-01 16:40:16'),(13269,13625,'2014-01-01','ET','2',1,NULL,'KENT HOPKINS','FI','436725274','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:00',0,'2014-03-02 05:24:45'),(22097,22747,'0000-00-00','ET','2',1,NULL,'Myrna Moore','FI','453234319','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:27',0,'2014-03-06 21:27:26'),(137,137,'2014-01-01','ET','2',1,NULL,'Shirley Madaris','FI','275524737','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 17:19:14',0,'2014-03-10 13:10:24'),(20066,20716,'0000-00-00','ET','2',1,NULL,'CHERYL GERDEMAN','FI','287684750','HealthSpan','FI','311431434','LYNNETTE  HOVEST','94','8059678','348','2014-03-01','Sync Success',0,'2014-02-25 21:00:23',0,'2014-03-10 14:37:47'),(981,981,'2014-01-01','ET','2',1,NULL,'Bertram Donley','FI','114446114','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:19:37',0,'2014-03-01 15:21:15'),(18841,19491,'0000-00-00','ET','2',1,NULL,'Anita Castro','FI','464024481','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-14 21:30:20',0,'2014-03-02 06:52:12'),(17445,18095,'0000-00-00','ET','2',4,3,'Elaine gaglione','FI','300441434','Dental Care Plus, Inc.','FI','311185262','Micah  Ingram','94','16935453','348','2014-03-01','Sync Success',0,'2014-02-06 21:01:12',0,'2014-03-01 17:20:55'),(7041,7041,'2014-01-01','ET','2',2,1,'Connie Bowers','FI','449790657','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:01:46',0,'2014-03-02 03:09:49'),(5089,5089,'2014-01-01','ET','2',1,NULL,'Steven Patterson','FI','403848756','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:49',0,'2014-03-10 13:20:27'),(1367,1367,'2014-01-01','ET','2',1,NULL,'david genac','FI','387626249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:58',0,'2014-03-02 04:38:08'),(11306,11306,'2014-01-01','ET','2',1,NULL,'WENDY  TAYLOR','FI','452676268','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:42',0,'2014-03-02 04:45:37'),(636,636,'2014-01-01','ET','2',1,NULL,'Tammy Marie Zulueta','FI','456750624','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:48',0,'2014-03-02 02:10:49'),(21263,21913,'0000-00-00','ET','2',1,NULL,'Frank Civitarese','FI','289787703','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-01 21:00:38',0,'2014-03-01 21:35:40'),(1087,1087,'2014-01-01','ET','2',1,NULL,'Kimberly VanVorst','FI','273442404','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:32',0,'2014-03-01 15:05:09'),(16706,17356,'0000-00-00','ET','2',1,NULL,'Kimberly Graham','FI','271446501','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:21',0,'2014-03-01 17:00:58'),(16101,16750,'0000-00-00','ET','2',1,NULL,'ERIN ANNE LUOMA','FI','298867052','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-27 21:01:18',0,'2014-03-10 16:24:30'),(7358,7358,'2014-01-01','ET','2',2,1,'LORETTA MUNDY','FI','288561250','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:45',0,'2014-03-01 15:16:37'),(5725,5725,'2014-01-01','ET','2',1,NULL,'Gary Mest','FI','175709668','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:10',0,'2014-03-01 15:48:04'),(5357,5357,'2014-01-01','ET','2',1,NULL,'Michael Lambertson','FI','272906243','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:05',0,'2014-03-10 13:03:33'),(11949,11949,'2014-01-01','ET','2',1,NULL,'Marlon Chen','FI','451578554','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-01 12:00:11',0,'2014-03-02 04:59:36'),(11735,11735,'2014-01-01','ET','2',1,NULL,'Cynthia Bidlencsik','FI','298525603','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',1,'2013-12-29 11:08:59',0,'2014-03-01 16:30:17'),(5343,5343,'2014-01-01','ET','2',1,NULL,'Scott H Ballou','FI','297502264','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:37',0,'2014-03-01 15:10:22'),(3961,3961,'2014-01-01','ET','2',4,3,'Angel Rice','FI','300866413','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:56',0,'2014-03-01 15:26:40'),(3413,3413,'2014-01-01','ET','2',2,1,'Lakeishia Johnson','FI','426238768','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:52:08',0,'2014-03-02 02:10:49'),(21866,22516,'0000-00-00','ET','2',1,NULL,'April LeEllen Bernal','94','0000421530','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-05 21:30:18',0,'2014-03-05 21:36:22'),(4131,4131,'2014-01-01','ET','2',1,NULL,'Leann Havens','FI','287504457','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:04:08',0,'2014-03-01 16:00:27'),(19784,20434,'0000-00-00','ET','2',1,NULL,'BRUCE ANTHONY BAUMANN','FI','438118968','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:10',0,'2014-03-02 07:03:25'),(5559,5559,'2014-01-01','ET','2',2,1,'Marie A Vaughn','FI','556577979','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:48:19',0,'2014-03-02 04:45:37'),(19368,20018,'0000-00-00','ET','2',1,NULL,'Cynthia l rudes','FI','278521207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:45',0,'2014-03-01 17:34:07'),(19152,19802,'0000-00-00','ET','2',1,NULL,'Jacquelyn Eaver','FI','296909188','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:24',0,'2014-03-10 16:31:33'),(5365,5365,'2014-01-01','ET','2',2,1,'Christine Karl','FI','439806069','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:16:22',0,'2014-03-01 21:11:04'),(11917,11917,'2014-01-01','ET','2',1,NULL,'SOMSRI HAHNER','FI','274685918','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:32',0,'2014-03-01 16:30:17'),(17921,18571,'0000-00-00','ET','2',1,NULL,'rosa r rayos','FI','452949664','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:43',0,'2014-03-02 06:38:05'),(17913,18563,'0000-00-00','ET','2',2,1,'Raul Reyes','FI','464419317','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:38',0,'2014-03-02 06:38:05'),(13829,14185,'2014-01-01','ET','2',2,1,'Karl Harvey','FI','438688999','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:32',0,'2014-03-02 05:31:31'),(14369,14820,'2014-01-01','ET','2',1,NULL,'PATRICIA KIGHTLINGER','FI','302485047','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:53',0,'2014-03-10 16:17:47'),(17773,18423,'0000-00-00','ET','2',2,1,'ALINASR MOHAMED YAHYA','FI','640727003','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:12',0,'2014-03-02 06:17:30'),(15960,16609,'0000-00-00','ET','2',1,NULL,'CECILIA ELIZABETH CASAS','FI','450615149','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:09',0,'2014-03-02 06:03:21'),(16217,16866,'0000-00-00','ET','2',1,NULL,'Shelia  sanders','FI','411259211','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:51',0,'2014-03-02 06:10:30'),(21869,22519,'0000-00-00','ET','2',1,NULL,'John J Morin','FI','275680060','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:30:20',0,'2014-03-05 21:36:22'),(1718,1718,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-25 19:17:04',0,'2014-03-01 15:31:33'),(7404,7404,'2014-01-01','ET','2',1,NULL,'Yolanda Gail Daniel','FI','433290486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:30:59',0,'2014-03-02 04:10:25'),(4854,4854,'2014-01-01','ET','2',1,NULL,'gloria garcia','FI','464591812','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:15:44',0,'2014-03-01 20:10:57'),(7343,7343,'2014-01-01','ET','2',1,NULL,'Thomas Ajeakwa','FI','622517490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:15',0,'2014-03-01 21:11:04'),(318,318,'2014-01-01','ET','2',1,NULL,'Jacqueline Galvan','FI','463998509','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:45:46',0,'2014-03-01 22:10:55'),(14578,15029,'2014-01-01','ET','2',2,1,'LOUIS S CONSTANCIO','FI','638034477','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:36',0,'2014-03-02 05:45:37'),(18629,19279,'0000-00-00','ET','2',1,NULL,'DEBORA CRAINE','FI','273669421','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:00:58',0,'2014-03-01 17:26:36'),(18512,19162,'0000-00-00','ET','2',1,NULL,'Bert Friedman','FI','427292536','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:32:19',0,'2014-03-02 06:45:14'),(18125,18775,'0000-00-00','ET','2',1,NULL,'MARY JONES','FI','467333293','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:57',0,'2014-03-02 06:38:05'),(18123,18773,'0000-00-00','ET','2',1,NULL,'Ariel Adames','FI','632402451','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:00:55',0,'2014-03-02 06:38:05'),(13877,14233,'2014-01-01','ET','2',1,NULL,'Cheryl Pizzuti','FI','274529210','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-02-01','Sync Success',0,'2014-01-13 02:24:05',0,'2014-03-10 14:03:26'),(17289,17939,'0000-00-00','ET','2',1,NULL,'RALEE WASCOM','FI','438839871','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:49',0,'2014-03-02 06:24:38'),(10397,10397,'2014-01-01','ET','2',3,2,'Mapuka Mehaffey','FI','294921327','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:50:37',0,'2014-03-01 16:10:36'),(6359,6359,'2014-01-01','ET','2',1,NULL,'Lorraine Portis','FI','425231798','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:09:09',0,'2014-03-02 04:10:25'),(21675,22325,'0000-00-00','ET','2',1,NULL,'NIGEL CROWDER','FI','351469545','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:17',0,'2014-03-04 21:27:16'),(22869,23519,'0000-00-00','ET','2',1,NULL,'MASIKA RAY','FI','449656682','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:16',0,'2014-03-10 21:27:11'),(740,740,'2014-01-01','ET','2',1,NULL,'Jon Horner','FI','270542506','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:03',0,'2014-03-10 13:24:34'),(21305,21955,'0000-00-00','ET','2',1,NULL,'Judith Bruno','FI','282581117','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:01:09',0,'2014-03-10 14:45:25'),(13232,13588,'2014-01-01','ET','2',1,NULL,'ERIC  TO','FI','552674289','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-07 10:22:21',0,'2014-03-02 05:17:40'),(18815,19465,'0000-00-00','ET','2',2,1,'Barbara Banister','FI','308841563','HealthSpan','FI','311431434','Justin  Margeson','94','16379001','348','2014-03-01','Sync Success',0,'2014-02-13 22:03:20',0,'2014-03-10 14:31:05'),(10862,10862,'2014-01-01','ET','2',1,NULL,'Daneda Jordan','FI','294782560','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:05:55',0,'2014-03-10 13:45:57'),(5876,5876,'2014-01-01','ET','2',1,NULL,'SHANNON HARTZELL','FI','299890832','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:17:09',0,'2014-03-10 13:03:33'),(16693,17343,'0000-00-00','ET','2',1,NULL,'windom ratchford','FI','282900618','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:01:12',0,'2014-03-01 17:00:58'),(21820,22470,'0000-00-00','ET','2',2,1,'Carrie Moss','FI','455412208','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:00:17',0,'2014-03-05 21:25:24'),(443,443,'2014-01-01','ET','2',1,NULL,'Timothy Aylward','FI','275664997','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:45',0,'2014-03-10 15:39:19'),(13013,13013,'2014-01-01','ET','2',1,NULL,'Henry Rossi','FI','186447562','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-05 00:02:41',0,'2014-03-10 13:59:38'),(20993,21643,'0000-00-00','ET','2',1,NULL,'jack givens','FI','278543243','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-28 07:30:34',0,'2014-03-10 16:38:05'),(20840,21490,'0000-00-00','ET','2',1,NULL,'Tabatha Casady','FI','290767964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:17',0,'2014-03-10 14:37:47'),(12583,12583,'2014-01-01','ET','2',1,NULL,'Michele Irene Sommer','FI','275524795','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:00:30',0,'2014-03-01 16:35:14'),(12291,12291,'2014-01-01','ET','2',1,NULL,'DORA DANIELS','FI','290503606','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:57',0,'2014-03-01 16:35:14'),(10659,10659,'2014-01-01','ET','2',1,NULL,'DIEDRICH MCBRIDE','FI','452379218','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:59:06',0,'2014-03-02 04:31:46'),(4315,4315,'2014-01-01','ET','2',1,NULL,'deanna hernandez','FI','436332261','Starmount Life Insurance Company','FI','720977315','Paul Dan Jumonville','94','1061105','348','2014-01-01','Sync Success',0,'2013-12-25 23:09:43',0,'2014-03-02 03:09:49'),(17399,18049,'0000-00-00','ET','2',1,NULL,'LINDA MILLER','FI','297563914','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:00:41',0,'2014-03-01 17:20:55'),(7572,7572,'2014-01-01','ET','2',1,NULL,'Stacey Johnson','FI','299903762','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:36:21',0,'2014-03-01 16:05:34'),(3311,3311,'2014-01-01','ET','2',2,1,'Robert J Smith','FI','282542943','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:50',0,'2014-03-01 15:52:44'),(5480,5480,'2014-01-01','ET','2',1,NULL,'stanley sandifer','FI','427318409','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:45:46',0,'2014-03-02 04:45:37'),(4810,4810,'2014-01-01','ET','2',1,NULL,'REBBIE SEWELL','FI','273705977','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:10',0,'2014-03-01 15:16:37'),(5287,5287,'2014-01-01','ET','2',2,1,'yat tung lau','FI','463159520','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:58',0,'2014-03-01 20:10:57'),(5235,5235,'2014-01-01','ET','2',2,1,'JAMES GOULD','FI','278568964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:53:33',0,'2014-03-10 13:20:27'),(4043,4043,'2014-01-01','ET','2',1,NULL,'SCHOLASTICA AUMA OWINO','FI','641805177','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:01:27',0,'2014-03-02 03:09:49'),(18642,19292,'0000-00-00','ET','2',1,NULL,'Tiffany Hollinger','FI','274925417','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:06',0,'2014-03-01 17:26:36'),(18400,19050,'0000-00-00','ET','2',1,NULL,'Marina Maldonado','FI','437655725','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:31:00',0,'2014-03-02 06:45:14'),(18140,18790,'0000-00-00','ET','2',1,NULL,'Margaret Calmes','FI','439612834','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:08',0,'2014-03-02 06:38:05'),(14075,14526,'2014-01-01','ET','2',1,NULL,'GREGG ALLEN LAZARINE','FI','461777785','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:19',0,'2014-03-02 05:31:31'),(22004,22654,'0000-00-00','ET','2',2,1,'ROBERT HOBBS','FI','296600078','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:31:56',0,'2014-03-05 21:36:22'),(10700,10700,'2014-01-01','ET','2',4,3,'Evan Mecklenborg','FI','300980342','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:32',0,'2014-03-01 16:10:36'),(20379,21029,'0000-00-00','ET','2',1,NULL,'Dellonte Hossley','FI','269725584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:08',0,'2014-03-02 07:10:28'),(3254,3254,'2014-01-01','ET','2',1,NULL,'Nicholas Gentile','FI','285907388','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:56',0,'2014-03-01 15:52:44'),(4420,4420,'2014-01-01','ET','2',1,NULL,'Grant Turner Dixon','FI','288722156','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:41',0,'2014-03-01 15:05:09'),(17576,18226,'0000-00-00','ET','2',1,NULL,'Tracy Susan Luke','FI','274600222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-07 19:00:54',0,'2014-03-01 17:20:55'),(16604,17254,'0000-00-00','ET','2',1,NULL,'BINH HUY DO','FI','644587603','Starmount Life Insurance Company','FI','720977315','ARTURO  PADRON','94','11840129','348','2014-03-01','Sync Success',0,'2014-01-31 21:00:10',0,'2014-03-02 06:17:30'),(4664,4664,'2014-01-01','ET','2',1,NULL,'Luis M Stock','FI','276506820','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:49:23',0,'2014-03-01 16:15:39'),(15913,16562,'0000-00-00','ET','2',1,NULL,'JEROME WILLIAMS','FI','439414256','Starmount Life Insurance Company','FI','720977315','SALLY  HITCHENS','94','1637275','348','2014-03-01','Sync Success',0,'2014-01-25 19:00:02',0,'2014-03-02 06:03:21'),(14451,14902,'2014-01-01','ET','2',1,NULL,'latashia franks','FI','435433116','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:31',0,'2014-03-02 05:38:34'),(6271,6271,'2014-01-01','ET','2',1,NULL,'GLENDA DOMINGUE','FI','439786879','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:35',0,'2014-03-02 04:10:25'),(7526,7526,'2014-01-01','ET','2',2,1,'Kyle Eck','FI','399024791','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:52',0,'2014-03-01 16:05:34'),(11972,11972,'2014-01-01','ET','2',1,NULL,'terry waller','FI','449020214','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-01 12:01:04',0,'2014-03-02 04:59:36'),(11454,11454,'2014-01-01','ET','2',1,NULL,'TERESA BECKER','FI','299687395','Dental Care Plus, Inc.','FI','311185262','JOHN  MASTERS','94','1791316','348','2014-02-01','Sync Success',0,'2013-12-28 03:30:16',0,'2014-03-01 16:23:43'),(11210,11210,'2014-01-01','ET','2',1,NULL,'barbara owens','FI','273529286','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:00:45',0,'2014-03-01 16:23:43'),(22490,23140,'0000-00-00','ET','2',1,NULL,'Timothy Bensonhaver','FI','294444852','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:03',0,'2014-03-07 21:36:32'),(5939,5939,'2014-01-01','ET','2',1,NULL,'susannah jones','FI','439333376','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:32:00',0,'2014-03-02 01:10:33'),(3952,3952,'2014-01-01','ET','2',1,NULL,'Mabinthy McCann','FI','217218551','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:46:37',0,'2014-03-01 23:10:52'),(3925,3925,'2014-01-01','ET','2',1,NULL,'martha kasch','FI','271528133','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:45:48',0,'2014-03-01 15:26:40'),(11996,11996,'2014-01-01','ET','2',1,NULL,'Cindy Xin Fang Chen','FI','562879608','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:01:55',0,'2014-03-10 16:10:34'),(17428,18078,'0000-00-00','ET','2',1,NULL,'Jeremy Blackmon','FI','457690331','Starmount Life Insurance Company','FI','720977315','Michael  Daugherty','94','1131360','357','2014-03-01','Sync Success',0,'2014-02-06 21:01:01',0,'2014-03-02 06:31:45'),(16231,16880,'0000-00-00','ET','2',1,NULL,'Maria Mandujano','FI','455891702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:59',0,'2014-03-02 06:10:30'),(13567,13923,'2014-01-01','ET','2',1,NULL,'MICHELLE GREEN','FI','425293490','Starmount Life Insurance Company','FI','720977315','GWENDOLYN  BURT','94','1036021','348','2014-02-01','Sync Success',0,'2014-01-13 02:19:59',0,'2014-03-02 05:31:31'),(14952,15403,'2014-01-01','ET','2',4,3,'HOWARD WADE','FI','455048766','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:48',0,'2014-03-02 05:52:31'),(22486,23136,'0000-00-00','ET','2',1,NULL,'Joseph Dirocco','FI','272647804','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:00',0,'2014-03-07 21:36:32'),(22598,23248,'0000-00-00','ET','2',1,NULL,'kristin michalkiewicz','FI','274829456','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:32:22',0,'2014-03-10 14:50:59'),(7305,7305,'2014-01-01','ET','2',1,NULL,'Aden Christopher Brown','FI','426638337','Starmount Life Insurance Company','FI','720977315','Robert N Stringer','94','557653','348','2014-01-01','Sync Success',0,'2013-12-26 04:09:52',0,'2014-03-02 03:09:49'),(21253,21903,'0000-00-00','ET','2',1,NULL,'bonnie ross','FI','287662504','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-01 21:00:32',0,'2014-03-01 21:35:40'),(19003,19653,'0000-00-00','ET','2',1,NULL,'Carol R Stone','94','0000099044','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:17',0,'2014-03-10 14:31:05'),(17545,18195,'0000-00-00','ET','2',1,NULL,'Ja\'Nya K Yarbrough','94','0000436638','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:31',0,'2014-03-10 16:24:30'),(16629,17279,'0000-00-00','ET','2',1,NULL,'Christine Seal','FI','449137107','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-31 21:00:27',0,'2014-03-02 06:17:30'),(16178,16827,'0000-00-00','ET','2',1,NULL,'DONNA SUPER','FI','271589710','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:25',0,'2014-03-01 16:56:22'),(5271,5271,'2014-01-01','ET','2',1,NULL,'Caroline Chavez','FI','454372847','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:00:22',0,'2014-03-01 19:11:03'),(15625,16076,'0000-00-00','ET','2',4,3,'ANDY DALE SPORLEDER','FI','288626717','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:48',0,'2014-03-10 14:10:12'),(14170,14621,'2014-01-01','ET','2',1,NULL,'brian carothers','FI','290665079','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:20',0,'2014-03-10 16:17:47'),(22595,23245,'0000-00-00','ET','2',1,NULL,'Deborah Simon','FI','268604922','HealthSpan','FI','311431434','Robert H Zirker III','94','1005990','348','2014-04-01','Sync Success',0,'2014-03-07 21:32:19',0,'2014-03-10 14:50:59'),(449,449,'2014-01-01','ET','2',1,NULL,'KEMALA ROWE','FI','456890711','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:49:56',0,'2014-03-01 22:10:55'),(7349,7349,'2014-01-01','ET','2',1,NULL,'Daniel James Flynn','FI','561845188','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:15:26',0,'2014-03-01 21:11:04'),(3298,3298,'2014-01-01','ET','2',2,1,'WAYNE WINFRED GAMBLE','FI','291529443','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:48:22',0,'2014-03-01 15:48:04'),(13630,13986,'2014-01-01','ET','2',1,NULL,'Crystal Sterling','FI','434909583','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:47',0,'2014-03-02 05:24:45'),(15959,16608,'0000-00-00','ET','2',1,NULL,'Daniel Van Slyke','FI','481087943','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:09',0,'2014-03-02 06:03:21'),(991,991,'2014-01-01','ET','2',1,NULL,'Nancy Sirianni','FI','040546716','Dental Care Plus, Inc.','FI','311185262','Tamara D Hagan','94','3691584','348','2014-01-01','Sync Success',0,'2013-12-25 18:19:57',0,'2014-03-01 15:21:15'),(20513,21163,'0000-00-00','ET','2',1,NULL,'Bruce King','FI','437819606','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:00:51',0,'2014-03-02 07:17:36'),(20437,21087,'0000-00-00','ET','2',4,3,'eric mason','FI','298748393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:54',0,'2014-03-01 18:08:07'),(19615,20265,'0000-00-00','ET','2',1,NULL,'brady tucker','94','0000152036','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:34:56',0,'2014-03-01 17:34:07'),(18196,18846,'0000-00-00','ET','2',3,2,'Jeffery Arthur','FI','293606129','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:49',0,'2014-03-01 17:26:36'),(4829,4829,'2014-01-01','ET','2',1,NULL,'Gregory Abrams','FI','278687799','HealthSpan','FI','311431434','Jason  Suchanek','94','1491306','348','2014-01-01','Sync Success',0,'2013-12-26 00:02:47',0,'2014-03-10 13:10:24'),(6050,6050,'2014-01-01','ET','2',2,1,'BRAD HART','FI','293529093','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:35',0,'2014-03-01 15:10:22'),(687,687,'2014-01-01','ET','2',1,NULL,'Cassondra G Durham','FI','413043783','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:19',0,'2014-03-10 15:52:36'),(3714,3714,'2014-01-01','ET','2',1,NULL,'Michael J Keane','FI','287747530','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:01',0,'2014-03-10 13:20:27'),(18962,19612,'0000-00-00','ET','2',1,NULL,'Dania Pearson','FI','587697429','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:46',0,'2014-03-02 06:52:12'),(5979,5979,'2014-01-01','ET','2',1,NULL,'Deborah Willhite','FI','278681273','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:19',0,'2014-03-10 15:52:36'),(3679,3679,'2014-01-01','ET','2',1,NULL,'Felicia Denise Cook','FI','428298308','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:48',0,'2014-03-02 00:10:48'),(17468,18118,'0000-00-00','ET','2',1,NULL,'Sandra Myles','FI','433135226','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-06 21:01:30',0,'2014-03-02 06:31:45'),(2602,2602,'2014-01-01','ET','2',1,0,'kathy steffen','FI','122522385','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-12-31','Sync Failed',0,'2013-12-25 20:46:04',0,'2014-03-01 15:05:09'),(16230,16879,'0000-00-00','ET','2',1,NULL,'loveda taylor','FI','550083372','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-28 21:00:59',0,'2014-03-02 06:10:30'),(13871,14227,'2014-01-01','ET','2',1,NULL,'kenneth walker','FI','427677532','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:24:02',0,'2014-03-02 05:31:31'),(13611,13967,'2014-01-01','ET','2',1,NULL,'Lisa Tedesco','FI','573690540','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:20:33',0,'2014-03-01 16:40:16'),(11712,11712,'2014-01-01','ET','2',2,1,'Anthony Harris','FI','228474728','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:08:15',0,'2014-03-02 04:59:36'),(4722,4722,'2014-01-01','ET','2',1,NULL,'Delores Jackson','FI','282486175','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:51:26',0,'2014-03-10 13:45:57'),(4739,4739,'2014-01-01','ET','2',1,NULL,'Joni Jones','FI','278505170','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:52:06',0,'2014-03-10 13:45:57'),(3739,3739,'2014-01-01','ET','2',1,NULL,'Terry Wayne Curry','FI','281528709','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:08:51',0,'2014-03-10 13:20:27'),(11581,11581,'2014-01-01','ET','2',1,NULL,'HOLLIS JONES','FI','546311194','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:34:08',0,'2014-03-02 04:52:44'),(13092,13448,'2014-01-01','ET','2',1,NULL,'Windy Siegfried','FI','530212989','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:43',0,'2014-03-01 16:35:14'),(21523,22173,'0000-00-00','ET','2',1,NULL,'Misty Romo','FI','454659470','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-18','Sync Success',0,'2014-03-03 21:31:12',0,'2014-03-03 22:26:43'),(14255,14706,'2014-01-01','ET','2',2,1,'LETICIA JANET MCCULLOCK','FI','464498515','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:05',0,'2014-03-01 16:46:19'),(21083,21733,'0000-00-00','ET','2',1,NULL,'ROSARIO CAMPOS','FI','023173904','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:35',0,'2014-03-10 16:38:05'),(16425,17075,'0000-00-00','ET','2',1,NULL,'Sarah Shaferly','FI','297740915','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-29 21:01:43',0,'2014-03-10 14:20:26'),(16586,17236,'0000-00-00','ET','2',1,NULL,'DEBORAH LEE VARGO','FI','287541072','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:34',0,'2014-03-10 14:20:26'),(19131,19781,'0000-00-00','ET','2',5,4,'DEBORAH BEGLEY','FI','280665567','Dental Care Plus, Inc.','FI','311185262','STEVE  CZEISPERGER','94','2386027','348','2014-03-01','Sync Success',0,'2014-02-15 22:01:06',0,'2014-03-01 17:34:07'),(16967,17617,'0000-00-00','ET','2',1,NULL,'Matt Greek','FI','283860985','Dental Care Plus, Inc.','FI','311185262','Kevin  Gilfether','94','16802778','348','2014-03-01','Sync Success',0,'2014-02-03 21:01:09',0,'2014-03-01 17:00:58'),(12817,12817,'2014-01-01','ET','2',1,NULL,'Patricia Mitchell','94','0001284858','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:01:53',0,'2014-03-02 05:10:52'),(22186,22836,'0000-00-00','ET','2',3,2,'Russell Williams','FI','294741172','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:01:28',0,'2014-03-06 21:36:23'),(4826,4826,'2014-01-01','ET','2',1,NULL,'Karen Treadway','FI','279500538','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:02:40',0,'2014-03-10 15:39:19'),(11663,11663,'2014-01-01','ET','2',1,NULL,'Sonja Duskin','FI','285866545','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:40',0,'2014-03-01 16:30:17'),(19393,20043,'0000-00-00','ET','2',2,1,'Linda Griffith','FI','277549867','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:01:03',0,'2014-03-01 17:34:07'),(18446,19096,'0000-00-00','ET','2',1,NULL,'Connie Alberico','FI','233800348','Summa Insurance Company, Inc.','FI','341809108','John Christopher Dalziel','94','362362','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:35',0,'2014-03-10 16:31:33'),(1734,1734,'2014-01-01','ET','2',1,NULL,'Charles Barth','FI','275568621','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:17:31',0,'2014-03-01 15:31:33'),(22601,23251,'0000-00-00','ET','2',1,NULL,'Rosa Mendez','FI','352544221','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:32:24',0,'2014-03-07 22:26:59'),(12266,12266,'2014-01-01','ET','2',1,NULL,'Katie Deerhake','FI','289828274','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:24:05',0,'2014-03-10 13:59:38'),(14711,15162,'2014-01-01','ET','2',1,NULL,'Wayne Brown','FI','434157248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-16 08:46:02',0,'2014-03-02 05:45:37'),(15991,16640,'0000-00-00','ET','2',1,NULL,'CRUZ GARCIA','FI','585137955','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:00:05',0,'2014-03-02 06:03:21'),(18946,19596,'0000-00-00','ET','2',1,NULL,'Donna Klein','FI','276705068','Summa Insurance Company, Inc.','FI','341809108','Susan E  Lux','94','1590799','348','2014-03-01','Sync Success',0,'2014-02-14 21:31:35',0,'2014-03-10 16:31:33'),(18153,18803,'0000-00-00','ET','2',2,1,'DULCE MARIA ABAN KU','FI','661227656','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:17',0,'2014-03-02 06:38:05'),(288,288,'2014-01-01','ET','2',1,NULL,'Jackie Upchurch','FI','451278919','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:32:16',0,'2014-03-01 19:11:03'),(7696,7696,'2014-01-01','ET','2',2,1,'Marion V Phillips','FI','287469910','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:20',0,'2014-03-01 15:10:22'),(1978,1978,'2014-01-01','ET','2',2,1,'CHERYL MCCAFFERTY','FI','271607870','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:05',0,'2014-03-01 15:31:33'),(4196,4196,'2014-01-01','ET','2',1,NULL,'Karen Carpenter','FI','280487803','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:06:09',0,'2014-03-10 15:59:47'),(12651,12651,'2014-01-01','ET','2',1,NULL,'Jacqueline Lanus','FI','433250071','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:59',0,'2014-03-02 05:10:52'),(14934,15385,'2014-01-01','ET','2',1,NULL,'Jacqueline Anderson','FI','269904692','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-02-01','Sync Success',0,'2014-01-17 03:35:40',0,'2014-03-01 16:46:19'),(13720,14076,'2014-01-01','ET','2',2,1,'Joseph Lawrence Schillage','FI','437712432','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:21:54',0,'2014-03-02 05:24:45'),(841,841,'2014-01-01','ET','2',1,NULL,'Christopher Welch','FI','457678486','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:23',0,'2014-03-01 21:11:04'),(22369,23019,'0000-00-00','ET','2',1,NULL,'JANET JARNER','FI','451060458','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:00:20',0,'2014-03-07 21:25:22'),(22260,22910,'0000-00-00','ET','2',2,1,'Bill Karos','FI','276565966','Summa Insurance Company, Inc.','FI','341809108','Zig  Novak','94','3239328','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:23',0,'2014-03-10 16:44:18'),(22204,22854,'0000-00-00','ET','2',1,NULL,'Barnetta Davis','FI','272585545','Dental Care Plus, Inc.','FI','311185262','Cynthia  Lavayen Castaneda','94','14729051','348','2014-04-01','Sync Success',0,'2014-03-06 21:01:42',0,'2014-03-06 21:36:23'),(18249,18899,'0000-00-00','ET','2',5,4,'Patti Bray','FI','385668854','HealthSpan','FI','311431434','Dianne  Rudolph','94','13065591','348','2014-03-01','Sync Success',0,'2014-02-11 21:02:35',0,'2014-03-10 14:24:38'),(16827,17477,'0000-00-00','ET','2',1,NULL,'lashanti taylor','FI','439596985','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:11',0,'2014-03-02 06:17:30'),(16283,16933,'0000-00-00','ET','2',1,NULL,'Michelle Zuspan','FI','175627050','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:12',0,'2014-03-02 06:10:30'),(16188,16837,'0000-00-00','ET','2',1,NULL,'Bill Renieris','FI','403647835','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:00:30',0,'2014-03-01 16:56:22'),(7304,7304,'2014-01-01','ET','2',2,1,'EARL WARD','FI','427960884','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:09:50',0,'2014-03-02 03:09:49'),(14589,15040,'2014-01-01','ET','2',1,NULL,'Robert Jaskula','FI','358764036','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:44:43',0,'2014-03-02 05:45:37'),(14104,14555,'2014-01-01','ET','2',2,1,'Rick Chiuchiarelli','FI','289509431','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:37',0,'2014-03-01 16:40:16'),(3897,3897,'2014-01-01','ET','2',1,NULL,'Sabrina N Williams','FI','325845210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:32:09',0,'2014-03-01 19:11:03'),(13294,13650,'2014-01-01','ET','2',1,NULL,'chris gerhart','FI','295768154','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:24:10',0,'2014-03-01 16:40:16'),(12895,12895,'2014-01-01','ET','2',1,NULL,'JAMES R GUZMAN','FI','461156994','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:04:42',0,'2014-03-10 13:59:38'),(848,848,'2014-01-01','ET','2',1,NULL,'DANIEL MUNIZ','FI','450997643','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:15:35',0,'2014-03-01 22:10:55'),(3011,3011,'2014-01-01','ET','2',1,NULL,'Kevin Wright','FI','282665376','Summa Insurance Company, Inc.','FI','341809108','Jared  Bologna','94','8927566','348','2014-01-01','Sync Success',0,'2013-12-25 21:33:28',0,'2014-03-10 15:52:36'),(6132,6132,'2014-01-01','ET','2',1,NULL,'Kris Scheid','FI','273765626','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:20',0,'2014-03-01 16:00:27'),(3381,3381,'2014-01-01','ET','2',2,1,'MARIA M CANALES','FI','464977255','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:51:07',0,'2014-03-02 02:10:49'),(2401,2401,'2014-01-01','ET','2',3,2,'Silvija Krebs','FI','294524741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:17:14',0,'2014-03-01 15:26:40'),(4411,4411,'2014-01-01','ET','2',1,NULL,'Chris Bencar','FI','272909722','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:16:18',0,'2014-03-10 15:39:19'),(4997,4997,'2014-01-01','ET','2',1,NULL,'Kevin Edward Vogel','FI','270482253','Dental Care Plus, Inc.','FI','311185262','Dennis  Printy','94','518044','348','2014-01-01','Sync Success',0,'2013-12-26 00:45:52',0,'2014-03-01 15:31:33'),(1232,1232,'2014-01-01','ET','2',1,NULL,'Timothy Gilchrist','FI','426233775','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:48:43',0,'2014-03-01 16:15:39'),(6267,6267,'2014-01-01','ET','2',1,NULL,'Shannon Olivier','FI','436517692','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:06:27',0,'2014-03-02 04:10:25'),(4361,4361,'2014-01-01','ET','2',1,NULL,'AMY BABOCK','FI','293442963','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:11:06',0,'2014-03-10 13:32:15'),(11300,11300,'2014-01-01','ET','2',2,1,'ricardo rios','FI','465158983','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:30',0,'2014-03-02 04:45:37'),(13913,14269,'2014-01-01','ET','2',1,NULL,'David Kissinger','FI','294569741','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 03:00:10',0,'2014-03-01 16:40:16'),(14046,14497,'2014-01-01','ET','2',1,NULL,'Jilani M JILANI','FI','673037396','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:32:00',0,'2014-03-01 16:40:16'),(14229,14680,'2014-01-01','ET','2',2,1,'Jacob Silva','FI','639208900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:05:53',0,'2014-03-02 05:38:34'),(17636,18286,'0000-00-00','ET','2',2,1,'William Lawrence','FI','413865394','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-08 19:00:25',0,'2014-03-02 06:31:45'),(35,35,'2014-01-01','ET','2',1,NULL,'LAURENE ZORN','FI','286481222','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:16:01',0,'2014-03-01 15:21:15'),(695,695,'2014-01-01','ET','2',1,NULL,'John Allen Wright','FI','289646342','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:35',0,'2014-03-10 13:24:34'),(19946,20596,'0000-00-00','ET','2',2,1,'ericka thomas','FI','455219540','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:12',0,'2014-03-02 07:03:25'),(19186,19836,'0000-00-00','ET','2',5,4,'William Bingamon','FI','284704749','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:53',0,'2014-03-10 14:31:05'),(18279,18929,'0000-00-00','ET','2',1,NULL,'Nicholas Moss','FI','278846634','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:09',0,'2014-03-01 17:26:36'),(17570,18220,'0000-00-00','ET','2',2,1,'Michael Moroski','FI','260311393','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-07 19:00:49',0,'2014-03-01 17:20:55'),(1897,1897,'2014-01-01','ET','2',1,NULL,'JIMMIE COOPER','FI','557729204','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:31:41',0,'2014-03-01 23:10:52'),(15658,16307,'0000-00-00','ET','2',1,NULL,'Brandy Cooksey','FI','287861316','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:00:18',0,'2014-03-01 16:56:22'),(13088,13444,'2014-01-01','ET','2',1,NULL,'PEGGIE ANN HARRISON','FI','432218193','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:02:31',0,'2014-03-01 16:35:14'),(12903,12903,'2014-01-01','ET','2',1,NULL,'TIMOTHY BATTLES','FI','411475978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:05:00',0,'2014-03-02 05:10:52'),(11299,11299,'2014-01-01','ET','2',1,NULL,'Paul Simmons','FI','500763996','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:28',0,'2014-03-02 04:45:37'),(5971,5971,'2014-01-01','ET','2',2,1,'Keith Dreyer','FI','449494723','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:02',0,'2014-03-02 02:10:49'),(3240,3240,'2014-01-01','ET','2',2,1,'BOBBY D MCKINNON','FI','290569754','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:46:33',0,'2014-03-01 15:52:44'),(2936,2936,'2014-01-01','ET','2',1,NULL,'Jon Dormish','FI','300720587','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:31:08',0,'2014-03-01 15:37:30'),(118,118,'2014-01-01','ET','2',1,NULL,'Connie Workman','FI','289582310','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:37',0,'2014-03-10 15:45:56'),(22481,23131,'0000-00-00','ET','2',1,NULL,'TRAVIS STAPLETON','FI','271905844','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:57',0,'2014-03-07 21:36:32'),(21403,22053,'0000-00-00','ET','2',5,4,'ANGELA GREEN','FI','278840124','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:00:13',0,'2014-03-03 21:36:16'),(20632,21282,'0000-00-00','ET','2',2,1,'RICHARD OSUCH','FI','566041702','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:12',0,'2014-03-02 07:10:28'),(20423,21073,'0000-00-00','ET','2',1,NULL,'John Strayer','FI','229271496','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 09:30:45',0,'2014-03-01 18:08:07'),(19364,20014,'0000-00-00','ET','2',1,NULL,'THOMAS J WENKE','FI','270660707','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:43',0,'2014-03-01 17:34:07'),(18779,19429,'0000-00-00','ET','2',1,NULL,'Paul Urbanski','94','0000381187','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-13 22:02:51',0,'2014-03-10 14:31:05'),(3357,3357,'2014-01-01','ET','2',1,NULL,'Scott M Leavell','FI','372884837','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:50:22',0,'2014-03-02 02:10:49'),(13297,13653,'2014-01-01','ET','2',2,1,'RICHARD WAWERU','FI','010901729','Dental Care Plus, Inc.','FI','311185262','LISA  TAYLOR','94','1829249','348','2014-02-01','Sync Success',0,'2014-01-08 18:24:11',0,'2014-03-01 16:40:16'),(15743,16392,'0000-00-00','ET','2',1,NULL,'sandra bentley','FI','240826832','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-23 21:01:18',0,'2014-03-10 14:10:12'),(14710,15161,'2014-01-01','ET','2',1,NULL,'Wayne Brown','FI','434157248','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:46:01',0,'2014-03-02 05:45:37'),(19366,20016,'0000-00-00','ET','2',1,NULL,'Jean Karen Eichert','FI','181388911','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:44',0,'2014-03-01 17:34:07'),(19267,19917,'0000-00-00','ET','2',1,NULL,'cindy  devidegaray','FI','627039543','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:11',0,'2014-03-02 06:52:12'),(12516,12516,'2014-01-01','ET','2',1,NULL,'Virginia  Henderson','FI','587766819','Starmount Life Insurance Company','FI','720977315','James   Dillon','94','1921787','348','2014-02-01','Sync Success',1,'2014-01-02 04:33:56',0,'2014-03-02 05:03:29'),(890,890,'2014-01-01','ET','2',1,NULL,'Kimberly  Thompson','FI','269547828','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:51',0,'2014-03-01 15:21:15'),(18149,18799,'0000-00-00','ET','2',1,NULL,'zenda watson','FI','439199006','Starmount Life Insurance Company','FI','720977315','wayne  landwerlin','94','1632529','357','2014-03-01','Sync Success',0,'2014-02-11 21:01:15',0,'2014-03-02 06:38:05'),(17985,18635,'0000-00-00','ET','2',1,NULL,'Sarah Smith','FI','292825176','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:31:29',0,'2014-03-10 16:31:33'),(10914,10914,'2014-01-01','ET','2',1,NULL,'Juliann Brumbaugh','FI','297502427','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:08:06',0,'2014-03-10 15:59:47'),(16404,17054,'0000-00-00','ET','2',1,NULL,'Trevor Fisher','FI','428656745','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:29',0,'2014-03-02 06:10:30'),(22379,23029,'0000-00-00','ET','2',1,NULL,'Natalia Skef','FI','661057200','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:25',0,'2014-03-07 21:25:22'),(1362,1362,'2014-01-01','ET','2',1,NULL,'Scotty Chenault','FI','453499267','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:48',0,'2014-03-02 04:38:08'),(12630,12630,'2014-01-01','ET','2',1,NULL,'latosha simmons','FI','465755439','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:08',0,'2014-03-02 05:10:52'),(21080,21730,'0000-00-00','ET','2',1,NULL,'shawn albright','FI','269725364','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:33',0,'2014-03-01 18:10:11'),(11480,11480,'2014-01-01','ET','2',5,4,'LONNIE WALDROP','FI','515828753','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:31:04',0,'2014-03-01 16:30:17'),(18554,19204,'0000-00-00','ET','2',1,NULL,'Barton Bradberry','94','0000582236','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 21:30:13',0,'2014-03-02 06:45:14'),(15813,16462,'0000-00-00','ET','2',1,NULL,'CASIMIRA MARTINEZ','FI','602207644','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-24 21:00:19',0,'2014-03-02 06:03:21'),(14968,15419,'2014-01-01','ET','2',1,NULL,'Lauren Kushner','FI','268964965','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:35:57',0,'2014-03-01 16:50:53'),(13736,14092,'2014-01-01','ET','2',1,NULL,'JANICE  MOORE','FI','439297303','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:22:05',0,'2014-03-02 05:24:45'),(2182,2182,'2014-01-01','ET','2',1,NULL,'Janese Parks','FI','457068576','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:47:34',0,'2014-03-01 21:11:04'),(1637,1637,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:02:07',0,'2014-03-01 20:10:57'),(7654,7654,'2014-01-01','ET','2',1,NULL,'Donald Crabtree','FI','271464667','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:38:59',0,'2014-03-10 13:39:10'),(6135,6135,'2014-01-01','ET','2',1,NULL,'michael krohn','FI','271702849','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-26 03:02:24',0,'2014-03-01 16:00:27'),(4278,4278,'2014-01-01','ET','2',1,NULL,'Glenda Blanchard','FI','436904613','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:08:40',0,'2014-03-02 03:09:49'),(22662,23312,'0000-00-00','ET','2',1,NULL,'NICHOLLE FEATHERSTON','FI','454610117','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:29',0,'2014-03-08 22:26:18'),(11276,11276,'2014-01-01','ET','2',1,NULL,'Glenda Powell','FI','436194856','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:02:47',0,'2014-03-02 04:52:44'),(4988,4988,'2014-01-01','ET','2',2,1,'Ramzy Abdeljalil','FI','271945507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:45:35',0,'2014-03-01 15:31:33'),(4802,4802,'2014-01-01','ET','2',1,NULL,'Robert Beeman','FI','278821517','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:01:56',0,'2014-03-01 15:16:37'),(17246,17896,'0000-00-00','ET','2',1,NULL,'COTTON NAKKA','FI','366237733','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-20','Sync Success',0,'2014-02-05 21:30:29',0,'2014-03-01 17:20:55'),(18273,18923,'0000-00-00','ET','2',1,NULL,'David Coleman','FI','463370350','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:03',0,'2014-03-02 06:45:14'),(18129,18779,'0000-00-00','ET','2',1,NULL,'Joel Rush','FI','460045281','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:00',0,'2014-03-02 06:38:05'),(15057,15508,'2014-01-01','ET','2',1,NULL,'Judy Ann Howard','FI','301648260','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:34',0,'2014-03-10 14:10:12'),(12937,12937,'2014-01-01','ET','2',1,NULL,'brittany nash','FI','280962141','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-02-01','Sync Success',0,'2014-01-04 02:06:22',0,'2014-03-10 13:59:38'),(19657,20307,'0000-00-00','ET','2',1,NULL,'Carlye Parks','FI','268961058','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:45:19',0,'2014-03-01 17:47:19'),(19141,19791,'0000-00-00','ET','2',1,NULL,'Charla Frank','FI','286462792','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:01:15',0,'2014-03-10 16:31:33'),(18299,18949,'0000-00-00','ET','2',1,NULL,'PATRICIA ROLLER','FI','147448027','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-11 21:30:28',0,'2014-03-10 16:31:33'),(12771,12771,'2014-01-01','ET','2',2,1,'Christoffer Lee','FI','118744374','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-04 02:00:08',0,'2014-03-01 16:35:14'),(12628,12628,'2014-01-01','ET','2',1,NULL,'Isabel Machain','FI','640285914','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:02:04',0,'2014-03-02 05:10:52'),(3752,3752,'2014-01-01','ET','2',1,NULL,'christie fasick','FI','295687263','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:09:17',0,'2014-03-10 13:20:27'),(4709,4709,'2014-01-01','ET','2',1,NULL,'Todd Schneider','FI','290740655','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-25 23:50:57',0,'2014-03-10 13:45:57'),(17228,17878,'0000-00-00','ET','2',1,NULL,'Leisa Jaye','FI','296864807','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:20',0,'2014-03-10 16:24:30'),(16316,16966,'0000-00-00','ET','2',1,NULL,'Neil Newman','FI','286562076','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:34',0,'2014-03-01 16:56:22'),(5088,5088,'2014-01-01','ET','2',1,NULL,'ELIZABETH M AMES','FI','302846502','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:48:47',0,'2014-03-10 13:20:27'),(16097,16746,'0000-00-00','ET','2',1,NULL,'MICHAEL S LUDWIG','FI','277564927','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:15',0,'2014-03-10 16:24:30'),(15311,15762,'0000-00-00','ET','2',1,NULL,'Michael Smith','FI','296547311','Dental Care Plus, Inc.','FI','311185262','Nathanael  Tate','94','16890949','348','2014-03-01','Sync Success',0,'2014-01-21 08:46:24',0,'2014-03-01 16:50:53'),(2853,2853,'2014-01-01','ET','2',1,NULL,'Wanda Laurianti','FI','278504376','Summa Insurance Company, Inc.','FI','341809108','carl  laurianti','94','2332836','348','2014-01-01','Sync Success',0,'2013-12-25 21:22:07',0,'2014-03-10 15:59:47'),(7425,7425,'2014-01-01','ET','2',1,NULL,'JAMES WOODARD','FI','439886863','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:31:40',0,'2014-03-02 04:15:49'),(6065,6065,'2014-01-01','ET','2',1,NULL,'Theila Hayes','FI','435196502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:12',0,'2014-03-02 04:10:25'),(6037,6037,'2014-01-01','ET','2',1,NULL,'Lawrence Stern','FI','346644630','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:07',0,'2014-03-10 13:03:33'),(2133,2133,'2014-01-01','ET','2',1,NULL,'Susan Lemons','FI','300749874','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:45:55',0,'2014-03-01 15:16:37'),(22421,23071,'0000-00-00','ET','2',1,NULL,'Michael White','FI','457985776','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:14',0,'2014-03-07 22:26:59'),(2243,2243,'2014-01-01','ET','2',1,NULL,'Kellen Ruth Elwell','FI','223575400','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:41',0,'2014-03-10 13:10:24'),(11941,11941,'2014-01-01','ET','2',1,NULL,'Mellissa Zaffiro','FI','268807989','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:02:20',0,'2014-03-10 16:10:34'),(19725,20375,'0000-00-00','ET','2',1,NULL,'James Lovett','FI','268586885','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-20 05:34:55',0,'2014-03-10 14:37:47'),(12437,12437,'2014-01-01','ET','2',1,NULL,'Marcella Seaux','FI','436922950','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:31:01',0,'2014-03-02 05:03:29'),(19407,20057,'0000-00-00','ET','2',1,NULL,'Renee Black','FI','301868031','Summa Insurance Company, Inc.','FI','341809108','James  Finnegin','94','2766031','348','2014-04-01','Sync Success',0,'2014-02-18 22:01:13',0,'2014-03-10 16:31:33'),(19262,19912,'0000-00-00','ET','2',1,NULL,'Shirley Araiza','FI','544960185','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-17 19:00:07',0,'2014-03-02 06:52:12'),(14293,14744,'2014-01-01','ET','2',1,NULL,'Kinsley Brynn Oyer','94','0001162614','Dental Care Plus, Inc.','FI','311185262','Susan E Lux','94','1590799','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:21',0,'2014-03-01 16:46:19'),(14372,14823,'2014-01-01','ET','2',1,NULL,'MARK WEST','FI','278546382','Summa Insurance Company, Inc.','FI','341809108','GREGORY  CAUSMAN','94','519763','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:54',0,'2014-03-10 16:17:47'),(17519,18169,'0000-00-00','ET','2',1,NULL,'Charles Kerr','FI','456962942','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-07 19:00:14',0,'2014-03-02 06:31:45'),(17030,17680,'0000-00-00','ET','2',1,NULL,'CLEVELAND THOMAS','FI','558196490','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:00:18',0,'2014-03-02 06:24:38'),(885,885,'2014-01-01','ET','2',1,NULL,'BARBARA LONGBOTTOM','FI','272524510','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:16:43',0,'2014-03-01 15:21:15'),(4379,4379,'2014-01-01','ET','2',1,NULL,'gary daye','FI','284668607','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:15:19',0,'2014-03-01 15:16:37'),(19211,19861,'0000-00-00','ET','2',2,1,'Tamara Barnhart','FI','300801055','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-16 19:00:08',0,'2014-03-10 16:31:33'),(22648,23298,'0000-00-00','ET','2',2,1,'John McNeill','FI','056545693','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-08 21:30:19',0,'2014-03-08 22:26:18'),(22341,22991,'0000-00-00','ET','2',1,NULL,'elise haddad','94','0000904297','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-07 21:00:08',0,'2014-03-10 14:50:59'),(10621,10621,'2014-01-01','ET','2',1,NULL,'Trey Goolsby','FI','633100209','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:57:52',0,'2014-03-02 04:24:47'),(18265,18915,'0000-00-00','ET','2',1,NULL,'Ashley Murphy','FI','273881695','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:50',0,'2014-03-10 14:24:38'),(7456,7456,'2014-01-01','ET','2',1,NULL,'LORETTA A MCKENZIE','FI','629345166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:32:33',0,'2014-03-02 04:10:25'),(15321,15772,'0000-00-00','ET','2',1,NULL,'Nathaniel Johnson','FI','271609106','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:31',0,'2014-03-01 16:50:53'),(1811,1811,'2014-01-01','ET','2',1,NULL,'Sandra Browder','FI','283680833','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:20:00',0,'2014-03-10 13:20:27'),(11779,11779,'2014-01-01','ET','2',2,1,'Crystal Creech','FI','290661344','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:10:19',0,'2014-03-10 13:52:32'),(19726,20376,'0000-00-00','ET','2',1,NULL,'Tenola C Oliver','FI','296605213','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 05:35:24',0,'2014-03-01 17:47:19'),(19315,19965,'0000-00-00','ET','2',1,NULL,'TANYA D MAURER','FI','485963675','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:08',0,'2014-03-02 06:59:07'),(6152,6152,'2014-01-01','ET','2',1,NULL,'Howard Hayes','FI','515943174','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:02:54',0,'2014-03-02 04:10:25'),(18563,19213,'0000-00-00','ET','2',1,NULL,'Aaron Nguyen','FI','066767210','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 21:30:18',0,'2014-03-02 06:52:12'),(16096,16745,'0000-00-00','ET','2',1,NULL,'carl laurianti','FI','269485510','Summa Insurance Company, Inc.','FI','341809108','carl  laurianti','94','23321836','357','2014-02-01','Sync Success',0,'2014-01-27 21:01:14',0,'2014-03-10 16:24:30'),(15140,15591,'0000-00-00','ET','2',1,NULL,'Christopher Savage','FI','436833627','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-20 08:06:20',0,'2014-03-02 05:52:31'),(2137,2137,'2014-01-01','ET','2',2,1,'Cory Schleyer','FI','407295207','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:46:02',0,'2014-03-01 15:16:37'),(22771,23421,'0000-00-00','ET','2',1,NULL,'Ashton Jackson','FI','301920980','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:00:26',0,'2014-03-09 21:35:27'),(23001,23651,'0000-00-00','ET','2',1,NULL,'KIM SCHWEIPZER','FI','271705629','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:01:52',0,'2014-03-10 21:36:25'),(3547,3547,'2014-01-01','ET','2',1,NULL,'Susan Burgwald','FI','277527805','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 22:02:42',0,'2014-03-01 15:37:30'),(20290,20940,'0000-00-00','ET','2',1,NULL,'EUGENIA TOON','FI','455787326','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-02-26 08:00:36',0,'2014-03-02 07:10:28'),(2525,2525,'2014-01-01','ET','2',2,1,'Wyendell Evans','FI','459980026','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:47',0,'2014-03-01 20:10:57'),(4608,4608,'2014-01-01','ET','2',2,1,'Laura Landfeld','94','0000468103','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:47:28',0,'2014-03-01 16:15:39'),(5798,5798,'2014-01-01','ET','2',1,NULL,'alicia melissa zamora','FI','643056357','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:03:27',0,'2014-03-02 01:10:33'),(18144,18794,'0000-00-00','ET','2',1,NULL,'Barry Gordon','FI','436820964','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:11',0,'2014-03-02 06:38:05'),(23113,23763,'0000-00-00','ET','2',1,NULL,'Vena Moore','FI','277482609','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:30:12',0,'2014-03-10 22:17:01'),(1336,1336,'2014-01-01','ET','2',1,NULL,'Judy Timberlake','FI','462949956','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:51:58',0,'2014-03-02 04:38:08'),(14102,14553,'2014-01-01','ET','2',1,NULL,'RANDALL PATRICK ARLEDGE','FI','293623667','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-14 01:32:36',0,'2014-03-01 16:40:16'),(19969,20619,'0000-00-00','ET','2',1,NULL,'John  Metcalf','FI','270485716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-07','Sync Success',0,'2014-02-21 22:00:30',0,'2014-03-01 17:47:19'),(19310,19960,'0000-00-00','ET','2',1,NULL,'Alica Thomas','FI','452954900','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:04',0,'2014-03-02 06:59:07'),(18461,19111,'0000-00-00','ET','2',1,NULL,'Guadalupe Salinas','FI','464881525','Starmount Life Insurance Company','FI','720977315','Archer  Summers','94','16993399','348','2014-03-01','Sync Success',0,'2014-02-12 21:31:45',0,'2014-03-02 06:45:14'),(16945,17595,'0000-00-00','ET','2',1,NULL,'JOHNATHAN N JAMES','FI','439451679','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-03 21:00:55',0,'2014-03-02 06:17:30'),(3306,3306,'2014-01-01','ET','2',1,NULL,'Rachel Shamy','FI','268885750','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:48:41',0,'2014-03-01 15:52:44'),(15534,15985,'0000-00-00','ET','2',1,NULL,'Gabrial White','FI','525398952','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:02:06',0,'2014-03-02 05:59:43'),(1455,1455,'2014-01-01','ET','2',1,NULL,'Christopher Sisson','FI','276543894','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:55:54',0,'2014-03-01 16:15:39'),(4020,4020,'2014-01-01','ET','2',1,NULL,'Bridgett Silas','FI','577820172','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:00:45',0,'2014-03-02 03:09:49'),(3171,3171,'2014-01-01','ET','2',2,1,'Robert Dustin','FI','296620196','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-25 21:38:31',0,'2014-03-10 13:24:34'),(4915,4915,'2014-01-01','ET','2',1,0,'KELTON LINDSAY','FI','300766023','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:38',0,'2014-03-01 15:05:09'),(5335,5335,'2014-01-01','ET','2',1,NULL,'Rosilyn Wise','FI','292523716','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:15:20',0,'2014-03-01 15:16:37'),(10958,10958,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:25',0,'2014-03-10 16:03:49'),(21983,22633,'0000-00-00','ET','2',1,NULL,'Barbara Johnson','FI','587327726','Starmount Life Insurance Company','FI','720977315','Kenneth  Higgenbottom','94','16025739','348','2014-04-01','Sync Success',0,'2014-03-05 21:31:41',0,'2014-03-05 22:27:33'),(20971,21621,'0000-00-00','ET','2',1,NULL,'Thomas Richard Cline','FI','273447392','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:19',0,'2014-03-01 18:10:11'),(20964,21614,'0000-00-00','ET','2',2,1,'Randy D Bender','FI','400881208','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 07:30:15',0,'2014-03-01 18:08:07'),(675,675,'2014-01-01','ET','2',1,NULL,'Elizabeth Lee Chapman','FI','296544957','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:56',0,'2014-03-10 15:52:36'),(19666,20316,'0000-00-00','ET','2',2,1,'APRIL MCGOWAN','FI','289905832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:47:20',0,'2014-03-01 17:47:19'),(17929,18579,'0000-00-00','ET','2',1,NULL,'Nora Cortina','FI','634667940','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:30:49',0,'2014-03-02 06:38:05'),(930,930,'2014-01-01','ET','2',1,NULL,'RAMON GARCIA','FI','455358649','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:18:01',0,'2014-03-01 22:10:55'),(5730,5730,'2014-01-01','ET','2',2,1,'Melanie Woofter','FI','290822519','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:01:16',0,'2014-03-01 15:48:04'),(13418,13774,'2014-01-01','ET','2',2,1,'Rebecca Bichon','FI','140668654','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:02',0,'2014-03-02 05:24:45'),(1979,1979,'2014-01-01','ET','2',1,NULL,'Mary Jane Porozynski','FI','277465042','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:34:08',0,'2014-03-10 15:45:56'),(2043,2043,'2014-01-01','ET','2',1,NULL,'AMBER  MONEY','FI','282940947','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:36:11',0,'2014-03-10 13:20:27'),(5014,5014,'2014-01-01','ET','2',1,NULL,'edward firm','FI','268500507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:26',0,'2014-03-01 15:31:33'),(4628,4628,'2014-01-01','ET','2',1,NULL,'James Kornegay','FI','642071040','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:11',0,'2014-03-02 04:31:46'),(4901,4901,'2014-01-01','ET','2',1,NULL,'Floyd McCarver','FI','295660188','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:30:09',0,'2014-03-01 15:05:09'),(20641,21291,'0000-00-00','ET','2',1,NULL,'ASHLEY WILLIAMS','FI','587752138','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 21:02:17',0,'2014-03-02 07:10:28'),(20277,20927,'0000-00-00','ET','2',1,NULL,'yolvalda jones','FI','449875391','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-10','Sync Success',0,'2014-02-26 08:00:23',0,'2014-03-02 07:03:25'),(7368,7368,'2014-01-01','ET','2',1,NULL,'Daniel Frazier','FI','283509982','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:16:10',0,'2014-03-10 13:03:33'),(18198,18848,'0000-00-00','ET','2',2,1,'GERALD WILSON','FI','283782545','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:01:51',0,'2014-03-01 17:26:36'),(5654,5654,'2014-01-01','ET','2',1,NULL,'Lamees El-sadek','FI','587656571','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-26 01:51:26',0,'2014-03-02 04:45:37'),(15024,15475,'2014-01-01','ET','2',1,NULL,'david sandifer','FI','436472584','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:20',0,'2014-03-02 05:52:31'),(21518,22168,'0000-00-00','ET','2',1,NULL,'ALEX ESCOBEDO','FI','452907733','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:09',0,'2014-03-03 22:26:43'),(22062,22712,'0000-00-00','ET','2',1,NULL,'FRANCES MCKAY','FI','279520797','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-05 21:32:37',0,'2014-03-10 14:45:25'),(5986,5986,'2014-01-01','ET','2',1,NULL,'Brian Powers','FI','428437001','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:33:31',0,'2014-03-02 01:10:33'),(21045,21695,'0000-00-00','ET','2',2,1,'DOROTHY MCGEE','FI','493589719','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:30:07',0,'2014-03-01 18:10:11'),(18887,19537,'0000-00-00','ET','2',1,NULL,'Anetra Matthews','FI','435512765','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:53',0,'2014-03-02 06:52:12'),(3542,3542,'2014-01-01','ET','2',1,NULL,'Catherine Calhoun','FI','297787770','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:02:32',0,'2014-03-01 15:37:30'),(18017,18667,'0000-00-00','ET','2',1,NULL,'DORIS LONG','FI','283707604','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-10 21:31:50',0,'2014-03-01 17:20:55'),(15981,16630,'0000-00-00','ET','2',1,NULL,'AMANDA KRISTINE HILL','FI','268924074','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:25',0,'2014-03-10 16:24:30'),(4627,4627,'2014-01-01','ET','2',1,NULL,'Juanita Padilla','FI','460838244','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:48:09',0,'2014-03-02 04:31:46'),(14487,14938,'2014-01-01','ET','2',1,NULL,'CONNIE RUTHERFORD','FI','437924271','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:47',0,'2014-03-02 05:38:34'),(13505,13861,'2014-01-01','ET','2',1,NULL,'Tyler Chancellor','FI','455691134','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:20',0,'2014-03-02 05:31:31'),(22845,23495,'0000-00-00','ET','2',1,NULL,'LARRY JACKSON','FI','454042323','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 20:59:59',0,'2014-03-10 21:27:11'),(621,621,'2014-01-01','ET','2',1,NULL,'Judy Allred','FI','460982467','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:04:18',0,'2014-03-02 02:10:49'),(4700,4700,'2014-01-01','ET','2',1,NULL,'Eugenia Valentine','FI','456114165','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:50:40',0,'2014-03-02 04:31:46'),(20103,20753,'0000-00-00','ET','2',1,NULL,'SUSIE ADAMS','FI','433062222','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-25 21:30:22',0,'2014-03-02 07:10:28'),(19342,19992,'0000-00-00','ET','2',1,NULL,'Jeff Welch','FI','282883030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:28',0,'2014-03-10 14:31:05'),(11264,11264,'2014-01-01','ET','2',1,NULL,'Beau M Minson','FI','436857610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:02:25',0,'2014-03-02 04:45:37'),(19050,19700,'0000-00-00','ET','2',2,1,'Johnny Campos','FI','458656292','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:07',0,'2014-03-02 06:52:12'),(17708,18358,'0000-00-00','ET','2',1,NULL,'Walter Moore','FI','281625775','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-09 19:00:07',0,'2014-03-10 16:31:33'),(13506,13862,'2014-01-01','ET','2',1,NULL,'Serena Miller','FI','464672743','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:19:20',0,'2014-03-02 05:31:31'),(16260,16909,'0000-00-00','ET','2',1,NULL,'David Jones','FI','281829789','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-01-28 21:01:19',0,'2014-03-10 14:20:26'),(80,80,'2014-01-01','ET','2',1,NULL,'DENNIS PALOMARES','FI','264658243','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:17:25',0,'2014-03-01 22:10:55'),(11155,11155,'2014-01-01','ET','2',1,NULL,'geri ruhlman','FI','262279466','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:16:05',0,'2014-03-10 13:45:57'),(19794,20444,'0000-00-00','ET','2',1,NULL,'Farrow Carney','FI','438270348','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 22:00:18',0,'2014-03-02 07:03:25'),(18865,19515,'0000-00-00','ET','2',1,NULL,'Martha LaPointe','FI','284761746','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:36',0,'2014-03-01 17:34:07'),(18797,19447,'0000-00-00','ET','2',1,NULL,'RICHARD KELLER','FI','454989431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:03:05',0,'2014-03-10 14:31:05'),(1540,1540,'2014-01-01','ET','2',1,NULL,'SHIRLEY MARIE NELSON','FI','291421156','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:58:37',0,'2014-03-10 13:52:32'),(6072,6072,'2014-01-01','ET','2',1,NULL,'Jonathan Ells','FI','530986224','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:00:25',0,'2014-03-02 04:10:25'),(15783,16432,'0000-00-00','ET','2',1,NULL,'Judy Wooley','FI','439923941','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 21:01:45',0,'2014-03-02 05:59:43'),(15290,15741,'0000-00-00','ET','2',1,NULL,'Griselda Segura','FI','454456064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:46:13',0,'2014-03-02 05:52:31'),(13809,14165,'2014-01-01','ET','2',2,1,'DONLAD  SEELEY','FI','285468576','Dental Care Plus, Inc.','FI','311185262','CHARLES   HEARN','94','2424533','348','2014-02-01','Sync Success',0,'2014-01-13 02:23:16',0,'2014-03-01 16:40:16'),(12206,12206,'2014-01-01','ET','2',1,NULL,'OTTO THOMAS','FI','274742479','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:21:44',0,'2014-03-01 16:35:14'),(5715,5715,'2014-01-01','ET','2',1,NULL,'Judith Sullivan','FI','281382982','Dental Care Plus, Inc.','FI','311185262','Rose  Shiels','94','8398250','348','2014-01-01','Sync Success',0,'2013-12-26 02:00:56',0,'2014-03-01 15:37:30'),(22657,23307,'0000-00-00','ET','2',1,NULL,'MARGARET SMITH','FI','480766048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-08 21:30:26',0,'2014-03-08 22:26:18'),(3658,3658,'2014-01-01','ET','2',1,NULL,'Ricky Peterson','FI','433310410','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:06:11',0,'2014-03-02 00:10:48'),(11562,11562,'2014-01-01','ET','2',1,NULL,'OLGA  MIZZLES','FI','630023802','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:34',0,'2014-03-02 04:52:44'),(21559,22209,'0000-00-00','ET','2',1,NULL,'Crystal Van Calsem','FI','435539978','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:31:38',0,'2014-03-03 22:26:43'),(21360,22010,'0000-00-00','ET','2',1,NULL,'Leslee A Chilberti','FI','077784099','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 01:00:29',0,'2014-03-10 16:38:05'),(13179,13535,'2014-01-01','ET','2',1,NULL,'Johnson Zenobia','FI','278687422','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-07 04:05:55',0,'2014-03-10 16:10:34'),(16247,16896,'0000-00-00','ET','2',1,NULL,'Jackie Anderson','FI','341686595','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-28 21:01:11',0,'2014-03-02 06:10:30'),(16552,17202,'0000-00-00','ET','2',1,NULL,'Tommy Jackson','FI','425069038','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:11',0,'2014-03-02 06:17:30'),(18565,19215,'0000-00-00','ET','2',2,1,'Adrian Brown','FI','286809122','Dental Care Plus, Inc.','FI','311185262','Dominic  Wolfer','94','13818546','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:04',0,'2014-03-01 17:26:36'),(19942,20592,'0000-00-00','ET','2',1,NULL,'Lizzie Griffin','FI','456179053','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:09',0,'2014-03-02 07:03:25'),(1084,1084,'2014-01-01','ET','2',1,NULL,'Harold Bashor','FI','268485568','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:31:26',0,'2014-03-01 15:05:09'),(21178,21828,'0000-00-00','ET','2',1,NULL,'KIMBERLY BRACEY','FI','427676056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:31:41',0,'2014-03-02 07:23:39'),(11368,11368,'2014-01-01','ET','2',1,NULL,'MARK JAMES CALLAHAN','FI','439738561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-27 02:05:36',0,'2014-03-02 04:45:37'),(19362,20012,'0000-00-00','ET','2',1,NULL,'David Dietrick','FI','280481030','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-18 22:00:41',0,'2014-03-10 14:31:05'),(18662,19312,'0000-00-00','ET','2',2,1,'Herbert Hughes','FI','468665669','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-13 22:01:22',0,'2014-03-02 06:45:14'),(1496,1496,'2014-01-01','ET','2',5,4,'mohammad tariq','FI','105769780','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:57:15',0,'2014-03-10 13:52:32'),(2509,2509,'2014-01-01','ET','2',1,0,'Jeremy Langworthy','FI','276882080','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:30:19',0,'2014-03-01 15:05:09'),(7065,7065,'2014-01-01','ET','2',1,NULL,'ELIZABETH WILLIAMS','FI','348443295','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:02:29',0,'2014-03-01 15:52:44'),(16849,17499,'0000-00-00','ET','2',1,NULL,'BILLIE SCHEL','FI','298581062','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-02 19:00:24',0,'2014-03-01 17:00:58'),(12709,12709,'2014-01-01','ET','2',2,1,'Anthony Cain','FI','428295352','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-03 02:05:06',0,'2014-03-02 05:10:52'),(16580,17230,'0000-00-00','ET','2',1,NULL,'Cody Peters','FI','280927517','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:01:29',0,'2014-03-10 14:20:26'),(14148,14599,'2014-01-01','ET','2',1,NULL,'Faye  McCConnell','FI','435111175','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-14 01:33:06',0,'2014-03-02 05:38:34'),(131,131,'2014-01-01','ET','2',1,NULL,'Esther G Robledo','FI','627503315','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:04',0,'2014-03-01 23:10:52'),(19007,19657,'0000-00-00','ET','2',2,1,'Carl Wardrup','94','0000241565','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-14 21:32:20',0,'2014-03-10 14:31:05'),(18938,19588,'0000-00-00','ET','2',1,NULL,'Inna Safran','FI','297089966','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:31:29',0,'2014-03-10 16:31:33'),(16503,17153,'0000-00-00','ET','2',1,NULL,'nancy garcia','FI','627185738','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-30 21:00:39',0,'2014-03-02 06:10:30'),(10535,10535,'2014-01-01','ET','2',1,NULL,'Mikal Dang','FI','466630547','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:58',0,'2014-03-02 04:31:46'),(936,936,'2014-01-01','ET','2',1,NULL,'Sheila Dupont','FI','439495717','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:18:14',0,'2014-03-01 22:10:55'),(3158,3158,'2014-01-01','ET','2',3,2,'Ji Richards','FI','625045997','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:38:00',0,'2014-03-10 13:24:34'),(1765,1765,'2014-01-01','ET','2',1,NULL,'Michael Harvey','FI','297489707','HealthSpan','FI','311431434','Andrew  Friesner','94','4684298','348','2014-01-01','Sync Success',0,'2013-12-25 19:18:26',0,'2014-03-10 13:20:27'),(6043,6043,'2014-01-01','ET','2',1,0,'Laura Everhart','FI','343584418','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:20',0,'2014-03-01 15:05:09'),(5097,5097,'2014-01-01','ET','2',1,NULL,'ALVIN DUTRUCH','FI','439022966','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:49:05',0,'2014-03-02 00:10:48'),(1599,1599,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:01:12',0,'2014-03-01 20:10:57'),(6033,6033,'2014-01-01','ET','2',1,NULL,'Mary A Limon','FI','449949351','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:45:58',0,'2014-03-01 20:10:57'),(22114,22764,'0000-00-00','ET','2',1,NULL,'Amy Phillips','FI','480060898','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-06 21:00:39',0,'2014-03-06 21:27:26'),(22276,22926,'0000-00-00','ET','2',1,NULL,'Suzanne Harshman','94','0000906653','HealthSpan','FI','311431434','James  Rightnowar','94','967389','357','2014-04-01','Sync Success',0,'2014-03-06 21:02:35',0,'2014-03-10 14:50:59'),(22434,23084,'0000-00-00','ET','2',1,NULL,'Yorda Jessica Hoppington','FI','508292737','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:30:24',0,'2014-03-07 22:26:59'),(2287,2287,'2014-01-01','ET','2',1,NULL,'celeste broussard','FI','350540219','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:00:45',0,'2014-03-01 21:11:04'),(11541,11541,'2014-01-01','ET','2',1,NULL,'ALBERTA JONES','FI','280683950','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-28 03:32:52',0,'2014-03-10 16:10:34'),(13839,14195,'2014-01-01','ET','2',1,NULL,'norberto juarez','FI','452235764','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-01','Sync Success',0,'2014-01-13 02:23:41',0,'2014-03-02 05:31:31'),(20807,21457,'0000-00-00','ET','2',2,1,'Lowell Bentley','FI','529450421','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-28 06:31:02',0,'2014-03-02 07:17:36'),(14263,14714,'2014-01-01','ET','2',1,NULL,'Lee Duckworth','FI','272506117','Dental Care Plus, Inc.','FI','311185262','Seann J Schaller','94','6909525','348','2014-02-01','Sync Success',0,'2014-01-15 02:06:08',0,'2014-03-01 16:46:19'),(15061,15512,'2014-01-01','ET','2',1,NULL,'MARY ONEY','FI','296426083','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-17 03:36:36',0,'2014-03-10 14:10:12'),(19048,19698,'0000-00-00','ET','2',1,NULL,'Jamila Jagours','FI','457838166','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:06',0,'2014-03-02 06:52:12'),(15674,16323,'0000-00-00','ET','2',1,NULL,'PATRICIA MOORE','FI','433043446','Starmount Life Insurance Company','FI','720977315','abram  freeman','94','1219092','348','2014-03-01','Sync Success',0,'2014-01-23 21:00:30',0,'2014-03-02 05:59:43'),(2492,2492,'2014-01-01','ET','2',1,NULL,'EDITH EVANS','FI','276647813','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 20:20:17',0,'2014-03-10 13:10:24'),(21029,21679,'0000-00-00','ET','2',1,NULL,'Steven Knape','FI','503904461','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-28 21:00:20',0,'2014-03-10 14:45:25'),(11557,11557,'2014-01-01','ET','2',1,NULL,'JOSHUA HOLLY','FI','632072533','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:33:23',0,'2014-03-02 04:52:44'),(11649,11649,'2014-01-01','ET','2',1,NULL,'ANNE MARIE SKOBLAR','FI','299581056','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:36:15',0,'2014-03-10 16:10:34'),(14639,15090,'2014-01-01','ET','2',1,NULL,'GENIA ALLEN','FI','274644973','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-16 08:45:13',0,'2014-03-01 16:46:19'),(10517,10517,'2014-01-01','ET','2',1,NULL,'William jurgensen','FI','451824230','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 12:54:23',0,'2014-03-02 04:24:47'),(1633,1633,'2014-01-01','ET','2',1,NULL,'Eddie Carter','FI','430021241','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 19:02:01',0,'2014-03-01 20:10:57'),(21183,21833,'0000-00-00','ET','2',1,NULL,'muhammad samaha','FI','443763155','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-28 21:31:46',0,'2014-03-02 07:23:39'),(20289,20939,'0000-00-00','ET','2',1,NULL,'Jennie Reigelsperger','FI','294809492','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-26 08:00:34',0,'2014-03-10 14:37:47'),(13422,13778,'2014-01-01','ET','2',1,NULL,'Brent Franz','FI','335787065','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-08 18:25:05',0,'2014-03-10 13:59:38'),(18244,18894,'0000-00-00','ET','2',1,NULL,'MARY COLEY','FI','587804064','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-11 21:02:30',0,'2014-03-02 06:38:05'),(17314,17964,'0000-00-00','ET','2',1,NULL,'Samantha Norris','FI','159621454','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-03-01','Sync Success',0,'2014-02-05 21:31:02',0,'2014-03-10 14:24:38'),(17224,17874,'0000-00-00','ET','2',1,NULL,'Jing Fu Mei','FI','123906314','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:18',0,'2014-03-01 17:20:55'),(13475,13831,'2014-01-01','ET','2',2,1,'Patricia DeLand','FI','281607617','Summa Insurance Company, Inc.','FI','341809108','Ronald G. Martin','94','2432668','348','2014-02-01','Sync Success',0,'2014-01-13 02:18:35',0,'2014-03-10 16:17:47'),(22495,23145,'0000-00-00','ET','2',1,NULL,'CINDY RENTSCHLER','FI','296608590','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-04-01','Sync Success',0,'2014-03-07 21:31:06',0,'2014-03-07 21:36:32'),(22500,23150,'0000-00-00','ET','2',2,1,'JULIANNE IMES','FI','272608175','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:10',0,'2014-03-10 14:50:59'),(22536,23186,'0000-00-00','ET','2',1,NULL,'laura colson','94','0000345641','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:37',0,'2014-03-07 21:36:32'),(765,765,'2014-01-01','ET','2',1,NULL,'James Hayes','FI','278885760','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:53',0,'2014-03-01 15:05:09'),(21757,22407,'0000-00-00','ET','2',1,NULL,'Franklin O Cassabon','FI','296828729','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:02:26',0,'2014-03-10 14:45:25'),(15508,15959,'0000-00-00','ET','2',1,NULL,'SHAZIA MANZAR','FI','114886055','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-23 03:01:54',0,'2014-03-02 05:59:43'),(1914,1914,'2014-01-01','ET','2',1,NULL,'gwendolyn stewart','FI','449137480','Starmount Life Insurance Company','FI','720977315','Maxine  Peters-Giles','94','1189335','348','2014-01-01','Sync Success',0,'2013-12-25 19:32:10',0,'2014-03-01 23:10:52'),(15259,15710,'0000-00-00','ET','2',2,1,'James Fordham','FI','278804313','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:45:35',0,'2014-03-10 14:10:12'),(14885,15336,'2014-01-01','ET','2',1,NULL,'Gloria Curry','FI','461198192','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:35:17',0,'2014-03-02 05:45:37'),(14275,14726,'2014-01-01','ET','2',1,NULL,'brenda white','FI','298504507','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:06:13',0,'2014-03-01 16:46:19'),(12261,12261,'2014-01-01','ET','2',1,NULL,'ANTHONY CAGLIA','FI','074442875','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:23:51',0,'2014-03-02 05:10:52'),(11909,11909,'2014-01-01','ET','2',1,NULL,'Darius Rice','FI','587611383','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-30 00:01:20',0,'2014-03-02 04:59:36'),(10693,10693,'2014-01-01','ET','2',1,NULL,'Benjamin Todd','FI','281583577','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:00:16',0,'2014-03-01 16:10:36'),(20,20,'2014-01-01','ET','2',1,NULL,'Richard k Kamu','FI','024869399','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:15:36',0,'2014-03-01 15:21:15'),(22264,22914,'0000-00-00','ET','2',2,1,'GUY FREED','FI','295561708','Summa Insurance Company, Inc.','FI','341809108','TAMERON  LILJENQUIST','94','8328382','348','2014-04-01','Sync Success',0,'2014-03-06 21:02:26',0,'2014-03-10 16:44:18'),(21495,22145,'0000-00-00','ET','2',1,NULL,'Jennifer Schmidt','FI','277644642','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:30:52',0,'2014-03-03 21:36:16'),(1270,1270,'2014-01-01','ET','2',1,NULL,'robert warner','FI','341627334','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:49:50',0,'2014-03-01 16:23:43'),(19475,20125,'0000-00-00','ET','2',1,NULL,'Marnie Santos','FI','258730056','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 03:55:03',0,'2014-03-02 06:59:07'),(16083,16732,'0000-00-00','ET','2',1,NULL,'Page Davis','FI','277967260','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-27 21:01:05',0,'2014-03-01 16:56:22'),(7733,7733,'2014-01-01','ET','2',1,NULL,'laura bair','FI','295680336','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 05:00:19',0,'2014-03-01 15:05:09'),(6103,6103,'2014-01-01','ET','2',2,1,'Aaron Nason','FI','281501275','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 03:01:26',0,'2014-03-01 16:00:27'),(13963,14319,'2014-01-01','ET','2',1,NULL,'Christopher Bruskotter','FI','297921626','HealthSpan','FI','311431434','Adam  Cupp','94','8331078','348','2014-02-01','Sync Success',0,'2014-01-13 03:00:42',0,'2014-03-10 14:03:26'),(6045,6045,'2014-01-01','ET','2',1,0,'Darrell Crain','FI','285749790','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:46:24',0,'2014-03-10 13:03:33'),(18,18,'2014-01-01','ET','2',1,NULL,'Michael Sarisky','FI','298441448','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 17:15:34',0,'2014-03-01 15:21:15'),(758,758,'2014-01-01','ET','2',1,NULL,'Philip A Russo','FI','282489224','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:08:36',0,'2014-03-10 13:24:34'),(19633,20283,'0000-00-00','ET','2',4,3,'KATRINA SUBER','FI','298709971','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:38:40',0,'2014-03-01 17:47:19'),(7523,7523,'2014-01-01','ET','2',1,NULL,'Pamela jo Nagy','FI','272461400','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:34:47',0,'2014-03-01 16:05:34'),(18331,18981,'0000-00-00','ET','2',1,NULL,'Lori Murphy','FI','294681964','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:14',0,'2014-03-01 17:26:36'),(3747,3747,'2014-01-01','ET','2',2,1,'Paula Scranton','FI','270562347','HealthSpan','FI','311431434','Branden  Fortman','94','8484978','348','2014-01-01','Sync Success',0,'2013-12-25 22:09:06',0,'2014-03-10 13:24:34'),(16272,16922,'0000-00-00','ET','2',1,NULL,'WANDA M JOHNSON','FI','436170775','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:00:05',0,'2014-03-02 06:10:30'),(3794,3794,'2014-01-01','ET','2',1,NULL,'LaToya Shepherd','FI','427678832','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 22:16:05',0,'2014-03-01 23:10:52'),(5911,5911,'2014-01-01','ET','2',2,1,'Larry Tunstall','FI','291582362','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:31:08',0,'2014-03-01 15:48:04'),(4501,4501,'2014-01-01','ET','2',1,NULL,'David Alicea','FI','581049759','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:32:07',0,'2014-03-10 13:03:33'),(5857,5857,'2014-01-01','ET','2',2,1,'MICHAEL CLOSSON','FI','293468478','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:16:25',0,'2014-03-10 13:03:33'),(677,677,'2014-01-01','ET','2',1,NULL,'Nicole Mollohan','FI','293748506','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:06:00',0,'2014-03-10 15:52:36'),(3157,3157,'2014-01-01','ET','2',1,NULL,'darcy l kutzli','FI','269548438','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 21:37:58',0,'2014-03-10 13:24:34'),(5616,5616,'2014-01-01','ET','2',2,1,'Kyle Numbers','FI','295900680','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:50:12',0,'2014-03-01 16:23:43'),(19574,20224,'0000-00-00','ET','2',2,1,'margaretta johnson','FI','102609964','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:24:37',0,'2014-03-10 14:37:47'),(18375,19025,'0000-00-00','ET','2',1,NULL,'HEIDI NGUYEN','FI','586383419','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-12 21:30:44',0,'2014-03-02 06:45:14'),(11373,11373,'2014-01-01','ET','2',1,NULL,'NELSON  JASMINE','FI','435845479','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:05:44',0,'2014-03-02 04:52:44'),(13804,14160,'2014-01-01','ET','2',1,NULL,'Denise Pritchett','FI','272506836','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-13 02:23:12',0,'2014-03-01 16:40:16'),(1533,1533,'2014-01-01','ET','2',1,NULL,'Kevin Forsyth','FI','168541931','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2013-12-25 18:58:26',0,'2014-03-10 16:03:49'),(21715,22365,'0000-00-00','ET','2',1,NULL,'DONNA BROWN','FI','435968731','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:01:50',0,'2014-03-04 21:27:16'),(2229,2229,'2014-01-01','ET','2',1,NULL,'James Elwell','FI','286823281','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:49:11',0,'2014-03-10 15:39:19'),(19934,20584,'0000-00-00','ET','2',2,1,'Nhien Mai','94','0000830665','Starmount Life Insurance Company','FI','720977315','Daniel  Paul','94','13410051','348','2014-04-01','Sync Success',0,'2014-02-21 22:00:03',0,'2014-03-02 07:03:25'),(11284,11284,'2014-01-01','ET','2',1,NULL,'tracy brown','FI','437597374','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:03:01',0,'2014-03-02 04:52:44'),(18829,19479,'0000-00-00','ET','2',1,NULL,'Carol P Chavez','FI','462175164','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-14 21:30:11',0,'2014-03-02 06:52:12'),(17814,18464,'0000-00-00','ET','2',1,NULL,'Sheletta Spencer','FI','587438567','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 11:00:47',0,'2014-03-02 06:03:21'),(16332,16982,'0000-00-00','ET','2',1,NULL,'Willie Bradley','FI','587486502','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-01','Received',0,'2014-01-29 21:00:43',NULL,NULL),(7717,7717,'2014-01-01','ET','2',1,NULL,'Nathan Kanney','FI','281760431','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:46:03',0,'2014-03-10 13:03:33'),(14422,14873,'2014-01-01','ET','2',1,NULL,'Henry Signoff','FI','428028610','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:16',0,'2014-03-02 05:38:34'),(11624,11624,'2014-01-01','ET','2',1,NULL,'Sonja Duskin','FI','285866545','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-28 03:35:28',0,'2014-03-10 13:52:32'),(21426,22076,'0000-00-00','ET','2',1,NULL,'Dionne L Hart','FI','433299924','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-03 21:29:59',0,'2014-03-03 22:26:43'),(1468,1468,'2014-01-01','ET','2',2,1,'RICHARD WAHL','FI','298541155','Dental Care Plus, Inc.','FI','311185262','DARREN A EWASKA','94','514891','348','2014-01-01','Sync Success',0,'2013-12-25 18:56:23',0,'2014-03-01 16:23:43'),(17163,17813,'0000-00-00','ET','2',1,NULL,'Adam Grindler','FI','255659098','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:42',0,'2014-03-01 17:00:58'),(5412,5412,'2014-01-01','ET','2',1,NULL,'Curtis Hightower','FI','601521843','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 01:30:43',0,'2014-03-01 15:10:22'),(16772,17422,'0000-00-00','ET','2',1,NULL,'MARGIE I GANTZ','FI','283505398','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-01 19:00:23',0,'2014-03-10 14:20:26'),(14516,14967,'2014-01-01','ET','2',1,NULL,'toni moore','FI','286466185','HealthSpan','FI','311431434','John Anthony Guagenti','94','7990234','348','2014-02-01','Sync Success',0,'2014-01-15 02:08:00',0,'2014-03-10 14:03:26'),(22866,23516,'0000-00-00','ET','2',1,NULL,'Fannie Grundy','FI','455237642','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-10 21:00:14',0,'2014-03-10 21:27:11'),(11686,11686,'2014-01-01','ET','2',2,1,'Natalie Moser','FI','644149207','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2013-12-29 11:07:28',0,'2014-03-02 04:59:36'),(22826,23476,'0000-00-00','ET','2',1,NULL,'JEFFREY JAMES JONES','FI','288727731','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-09 21:01:14',0,'2014-03-10 16:44:18'),(22510,23160,'0000-00-00','ET','2',1,NULL,'Sean Gilbert','FI','434574249','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-07 21:31:18',0,'2014-03-07 22:26:59'),(21796,22446,'0000-00-00','ET','2',1,NULL,'DELIA RODRIGUEZ','FI','309663751','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:30:13',0,'2014-03-04 22:25:23'),(21736,22386,'0000-00-00','ET','2',1,NULL,'Richard Aaron Maus','FI','291862249','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-04 21:02:08',0,'2014-03-10 14:45:25'),(21608,22258,'0000-00-00','ET','2',2,1,'HERSHEL GLENN SHAW','FI','455274736','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-03-04 21:00:26',0,'2014-03-04 21:27:16'),(1556,1556,'2014-01-01','ET','2',1,NULL,'Sharon McGill','FI','273804958','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:59:11',0,'2014-03-10 13:52:32'),(21066,21716,'0000-00-00','ET','2',1,NULL,'John Payne','FI','272444664','Dental Care Plus, Inc.','FI','311185262','Eliot  Parker','94','14449926','348','2014-04-01','Sync Success',0,'2014-02-28 21:30:25',0,'2014-03-01 18:10:11'),(19649,20299,'0000-00-00','ET','2',1,NULL,'ANTOINETTE M KOMYATI','FI','287642324','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:43:17',0,'2014-03-01 17:47:19'),(19105,19755,'0000-00-00','ET','2',2,1,'Thomas Russell','FI','296562674','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-15 22:00:47',0,'2014-03-01 17:34:07'),(18044,18694,'0000-00-00','ET','2',1,NULL,'omar sadin','FI','281903782','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-10 21:32:09',0,'2014-03-10 14:24:38'),(17119,17769,'0000-00-00','ET','2',1,NULL,'DORIS LONG','FI','283707604','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-04 21:01:12',0,'2014-03-10 14:20:26'),(15055,15506,'2014-01-01','ET','2',1,NULL,'Jamison Smith','FI','285849870','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-17 03:36:33',0,'2014-03-10 14:10:12'),(11121,11121,'2014-01-01','ET','2',1,NULL,'Connie Arnett','FI','275524002','HealthSpan','FI','311431434','GoHealth  ZZZ','94','7709859','348','2014-01-01','Sync Success',0,'2013-12-26 13:14:50',0,'2014-03-10 13:45:57'),(3073,3073,'2014-01-01','ET','2',1,NULL,'Ricky Smith','FI','433356400','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 21:35:23',0,'2014-03-02 01:10:33'),(4123,4123,'2014-01-01','ET','2',1,NULL,'Paul Caryl Ropp','FI','299600761','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:03:55',0,'2014-03-01 16:00:27'),(5754,5754,'2014-01-01','ET','2',5,4,'Melanie McDowell','FI','286647587','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:02:01',0,'2014-03-10 13:24:34'),(7702,7702,'2014-01-01','ET','2',2,1,'Charles Fritsch','FI','274783153','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 04:45:33',0,'2014-03-01 15:10:22'),(23082,23732,'0000-00-00','ET','2',1,NULL,'Tracy R Young','FI','289722651','HealthSpan','FI','311431434','Timothy  Self','94','16166554','348','2014-04-01','Sync Success',0,'2014-03-10 21:02:54',0,'2014-03-10 21:17:52'),(236,236,'2014-01-01','ET','2',1,0,'Kyle Keith King','FI','462358561','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:30:24',0,'2014-03-01 19:11:03'),(11437,11437,'2014-01-01','ET','2',1,NULL,'Rosemary C Fugett','FI','276548348','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2013-12-27 02:07:46',0,'2014-03-10 13:52:32'),(18699,19349,'0000-00-00','ET','2',1,NULL,'Katherine Cocchiaro','94','0000374363','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-13 22:01:52',0,'2014-03-02 06:52:12'),(18574,19224,'0000-00-00','ET','2',1,NULL,'Brianna Linn Smith','94','0000961906','Dental Care Plus, Inc.','FI','311185262','Sarah  Bean','94','10334323','348','2014-03-01','Sync Success',0,'2014-02-13 22:00:13',0,'2014-03-01 17:26:36'),(17960,18610,'0000-00-00','ET','2',2,1,'THU HA THI NGUYEN','FI','287150644','Dental Care Plus, Inc.','FI','311185262','DARWIN  CARMICHAEL','94','1300095','348','2014-03-01','Sync Success',0,'2014-02-10 21:31:11',0,'2014-03-01 17:20:55'),(10961,10961,'2014-01-01','ET','2',1,NULL,'Shannon Smith','FI','297766454','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 13:09:29',0,'2014-03-10 16:03:49'),(1355,1355,'2014-01-01','ET','2',1,NULL,'Christopher Matthew Butcher','FI','458312466','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:52:36',0,'2014-03-02 04:38:08'),(16977,17627,'0000-00-00','ET','2',1,NULL,'richard brown','FI','280768832','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-03-01','Sync Success',0,'2014-02-03 21:01:15',0,'2014-03-01 17:00:58'),(16409,17059,'0000-00-00','ET','2',1,NULL,'NIKOLE MARIE FUQUA','FI','298906623','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-29 21:01:32',0,'2014-03-10 16:24:30'),(2088,2088,'2014-01-01','ET','2',1,NULL,'Nancy Kucharik','94','0000820979','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 19:37:38',0,'2014-03-10 13:20:27'),(4328,4328,'2014-01-01','ET','2',1,NULL,'ROBERT E NEWMAN','FI','296565466','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 23:10:05',0,'2014-03-10 13:32:15'),(15227,15678,'0000-00-00','ET','2',1,NULL,'SCHERRI PHILLIPS','FI','275721399','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-21 08:44:44',0,'2014-03-10 16:17:47'),(12506,12506,'2014-01-01','ET','2',1,NULL,'Sandra Johnson','FI','436215393','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',1,'2014-01-02 04:33:36',0,'2014-03-02 05:03:29'),(102,102,'2014-01-01','ET','2',2,1,'PENNY KERVIN','FI','445549990','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:18:06',0,'2014-03-01 22:10:55'),(12117,12117,'2014-01-01','ET','2',1,NULL,'Ariel Diamond','FI','344729683','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'357','2014-01-01','Sync Success',0,'2014-01-01 12:06:17',0,'2014-03-01 16:30:17'),(11851,11851,'2014-01-01','ET','2',2,1,'Carol Edwards','FI','270683629','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-01-01','Sync Success',1,'2013-12-29 11:14:49',0,'2014-03-10 13:45:57'),(3051,3051,'2014-01-01','ET','2',2,1,'Scott Kirby','FI','269606165','Dental Care Plus, Inc.','FI','311185262','Mike  Sensor','94','2516402','348','2014-01-01','Sync Success',0,'2013-12-25 21:34:39',0,'2014-03-01 15:37:30'),(19895,20545,'0000-00-00','ET','2',1,NULL,'faith Dorsey','FI','433872198','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-21 21:30:02',0,'2014-03-02 07:03:25'),(5882,5882,'2014-01-01','ET','2',2,1,'Helen Deiters','FI','233906470','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 02:30:10',0,'2014-03-10 15:52:36'),(19768,20418,'0000-00-00','ET','2',1,NULL,'DENISE ANGERSTIEN','FI','292601297','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'357','2014-02-28','Sync Success',0,'2014-02-20 21:30:18',0,'2014-03-10 16:38:05'),(17488,18138,'0000-00-00','ET','2',1,NULL,'Cassandra Hawkins','FI','279884592','HealthSpan','FI','311431434',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-06 21:01:45',0,'2014-03-10 14:24:38'),(18388,19038,'0000-00-00','ET','2',1,NULL,'EDDIE BLOSSOM','FI','427889793','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-12 21:30:52',0,'2014-03-02 06:45:14'),(23057,23707,'0000-00-00','ET','2',1,NULL,'Thomas Russell','FI','296562674','HealthSpan','FI','311431434',NULL,NULL,NULL,'357','2014-03-31','Sync Success',0,'2014-03-10 21:02:33',0,'2014-03-10 21:17:52'),(147,147,'2014-01-01','ET','2',1,NULL,'Margaret Boodey','FI','293569770','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:19:35',0,'2014-03-10 15:45:56'),(347,347,'2014-01-01','ET','2',1,NULL,'CURITIA V EMBRY','FI','272720747','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 17:46:42',0,'2014-03-01 15:21:15'),(21219,21869,'0000-00-00','ET','2',1,NULL,'Bertha Simmons','FI','304909819','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'357','2014-03-15','Sync Success',0,'2014-03-01 21:00:09',0,'2014-03-02 07:23:39'),(654,654,'2014-01-01','ET','2',2,1,'Bryan Marsh Bell','FI','453804353','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-25 18:05:20',0,'2014-03-02 02:10:49'),(5008,5008,'2014-01-01','ET','2',1,NULL,'Rhonda Strait','FI','282589972','Dental Care Plus, Inc.','FI','311185262',NULL,NULL,NULL,'348','2014-01-01','Sync Success',0,'2013-12-26 00:46:13',0,'2014-03-01 15:31:33'),(14417,14868,'2014-01-01','ET','2',1,NULL,'Betty Gibson','FI','587088048','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-02-01','Sync Success',0,'2014-01-15 02:07:14',0,'2014-03-02 05:38:34'),(19986,20636,'0000-00-00','ET','2',1,NULL,'CAROLYN SHERMAN','FI','435274928','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-21 22:00:42',0,'2014-03-02 07:03:25'),(19606,20256,'0000-00-00','ET','2',1,NULL,'Cimarron Gilson','FI','452539182','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-20 04:33:28',0,'2014-03-02 06:59:07'),(19230,19880,'0000-00-00','ET','2',1,NULL,'Joan Heuer','FI','461985041','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-04-01','Sync Success',0,'2014-02-16 19:00:24',0,'2014-03-02 06:52:12'),(17294,17944,'0000-00-00','ET','2',1,NULL,'CHARLENE MCALISTER','FI','434218630','Starmount Life Insurance Company','FI','720977315',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-02-05 21:30:52',0,'2014-03-02 06:24:38'),(17026,17676,'0000-00-00','ET','2',1,NULL,'Katina Bankston','FI','438458371','Starmount Life Insurance Company','FI','720977315','corey  holbert','94','2835272','348','2014-03-01','Sync Success',0,'2014-02-04 21:00:15',0,'2014-03-02 06:24:38'),(15986,16635,'0000-00-00','ET','2',1,NULL,'thomas dale','FI','295806321','Summa Insurance Company, Inc.','FI','341809108',NULL,NULL,NULL,'348','2014-03-01','Sync Success',0,'2014-01-26 19:00:29',0,'2014-03-10 16:24:30');
/*!40000 ALTER TABLE `Edi834` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Edi999`
--

DROP TABLE IF EXISTS `Edi999`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Edi999` (
  `Edi999Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiTransactionId` bigint(64) NOT NULL,
  `DataSegmentNote` varchar(200) DEFAULT NULL,
  `SegmentId` varchar(100) DEFAULT NULL,
  `SegmentPosition` varchar(10) DEFAULT NULL,
  `LoopCode` int(5) DEFAULT NULL,
  `SyntaxErrorCode` varchar(5) DEFAULT NULL,
  `Context` varchar(100) DEFAULT NULL,
  `ContextName` varchar(100) DEFAULT NULL,
  `ContextReference` varchar(100) DEFAULT NULL,
  `DataElementNote` varchar(100) DEFAULT NULL,
  `ElementPosition` varchar(5) DEFAULT NULL,
  `ElementReference` varchar(50) DEFAULT NULL,
  `ElementSyntaxCode` varchar(10) DEFAULT NULL,
  `CopyBadElement` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`Edi999Id`),
  KEY `EdiFunctionalGroupId` (`EdiTransactionId`)
) ENGINE=innodb AUTO_INCREMENT=1161 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Edi999`
--

LOCK TABLES `Edi999` WRITE;
/*!40000 ALTER TABLE `Edi999` DISABLE KEYS */;
INSERT INTO `Edi999` VALUES (16,13029,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186069',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:23',NULL,NULL),(1025,16179,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:21:11',NULL,NULL),(273,13157,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000633720',NULL,'93','2','R','5','9378433740',0,'2014-01-05 16:57:53',NULL,NULL),(281,13161,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000666747',NULL,'93','2','R','5','9378375183',0,'2014-01-05 16:58:04',NULL,NULL),(530,13286,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000988853',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:33',NULL,NULL),(863,14474,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000474927',NULL,'93','2','R','5','5133173474',0,'2014-01-13 03:03:46',NULL,NULL),(1029,16181,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:21:47',NULL,NULL),(417,13229,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001169407',NULL,'93','2','R','I5','3304142197',0,'2014-01-05 17:01:14',NULL,NULL),(482,13262,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000912924',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:45',NULL,NULL),(846,14466,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000336406',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:39',NULL,NULL),(874,14480,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000173784',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:52',NULL,NULL),(148,13095,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001256010',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:25',NULL,NULL),(557,13299,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000516871',NULL,'93','2','R','5','6145066844',0,'2014-01-05 17:24:10',NULL,NULL),(52,13047,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239085',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:12',NULL,NULL),(628,13335,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000369984',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:50',NULL,NULL),(1018,16173,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:42',NULL,NULL),(41,13041,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000866852',NULL,'93','2','R','I5','5134007013',0,'2014-01-05 16:50:56',NULL,NULL),(46,13044,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000166336',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:04',NULL,NULL),(297,13169,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000814273',NULL,'93','2','R','5','9374321954',0,'2014-01-05 16:58:27',NULL,NULL),(546,13294,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000323470',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:55',NULL,NULL),(820,14453,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000509175',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:27',NULL,NULL),(1093,16229,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',0,'2014-01-23 06:39:41',NULL,NULL),(751,14418,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001119925',NULL,'93','2','R','5','4402301217',0,'2014-01-13 03:02:30',NULL,NULL),(101,13071,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000137530',NULL,'93','2','R','5','3303165908',0,'2014-01-05 16:52:19',NULL,NULL),(421,13231,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000338853',NULL,'364','4','R','5','5133720978',0,'2014-01-05 17:01:19',NULL,NULL),(773,14429,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000137530',NULL,'93','2','R','5','3303165908',0,'2014-01-13 03:02:40',NULL,NULL),(942,16115,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:44:43',NULL,NULL),(969,16134,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:51:41',NULL,NULL),(1020,16174,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:58',NULL,NULL),(379,13210,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000809647',NULL,'364','4','R','5','4194784361',0,'2014-01-05 17:00:21',NULL,NULL),(404,13223,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000639499',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:57',NULL,NULL),(535,13288,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000514421',NULL,'93','2','R','5','5137069596',0,'2014-01-05 17:23:39',NULL,NULL),(630,13336,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000036973',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:52',NULL,NULL),(985,16146,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:57:57',NULL,NULL),(133,13087,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239104',NULL,'93','2','R','5','9373467293',0,'2014-01-05 16:53:03',NULL,NULL),(142,13092,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162557',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:16',NULL,NULL),(342,13192,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293156',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:30',NULL,NULL),(875,14480,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000173784',NULL,'93','2','R','5','2165361993',0,'2014-01-13 03:03:52',NULL,NULL),(11,13026,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780475',NULL,'364','4','R','5','4404766225',0,'2014-01-05 16:50:15',NULL,NULL),(779,14432,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327246',NULL,'364','6','R','5','6144249609',0,'2014-01-13 03:02:43',NULL,NULL),(1035,16186,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:26:58',NULL,NULL),(1109,16242,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:45:52',NULL,NULL),(454,13248,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000479812',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:06',NULL,NULL),(680,13361,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001118692',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:02',NULL,NULL),(709,13375,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000362478',NULL,'93','2','R','5','9378434539',0,'2014-01-05 17:27:41',NULL,NULL),(932,16108,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:42:44',NULL,NULL),(1034,16185,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:25:54',NULL,NULL),(39,13040,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000212143',NULL,'93','2','R','5','3304052938',0,'2014-01-05 16:50:53',NULL,NULL),(219,13130,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078730',NULL,'93','2','R','5','5133513768',0,'2014-01-05 16:55:03',NULL,NULL),(261,13151,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001111632',NULL,'93','2','R','5','4404099049',0,'2014-01-05 16:57:36',NULL,NULL),(653,13347,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000271405',NULL,'93','2','R','I5','6148435765',0,'2014-01-05 17:26:23',NULL,NULL),(668,13355,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000560540',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:45',NULL,NULL),(686,13364,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000533273',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:10',NULL,NULL),(715,14400,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000227044',NULL,'93','2','R','I5','9375208110',0,'2014-01-13 03:02:14',NULL,NULL),(1058,16205,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:52:47',NULL,NULL),(1075,16216,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 05:06:39',NULL,NULL),(1156,16284,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 17:00:02',NULL,NULL),(558,13300,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001135137',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:12',NULL,NULL),(674,13358,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239104',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:54',NULL,NULL),(402,13222,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000604701',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:54',NULL,NULL),(641,13341,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001059452',NULL,'310','6','R','5','39003',0,'2014-01-05 17:26:07',NULL,NULL),(483,13262,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000912924',NULL,'364','4','R','5','ellinakhramova@gmail.com',0,'2014-01-05 17:02:46',NULL,NULL),(541,13291,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000329623',NULL,'93','2','R','5','6142660889',0,'2014-01-05 17:23:47',NULL,NULL),(884,14485,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000223675',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:56',NULL,NULL),(50,13046,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000411077',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:10',NULL,NULL),(527,13284,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327246',NULL,'364','6','R','5','6144249609',0,'2014-01-05 17:23:28',NULL,NULL),(828,14457,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000666747',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:31',NULL,NULL),(415,13228,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780485',NULL,'364','4','R','5','julieerudd@gmail.com',0,'2014-01-05 17:01:11',NULL,NULL),(954,16123,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 03:47:31',NULL,NULL),(226,13134,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000874673',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:15',NULL,NULL),(255,13148,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000280804',NULL,'93','2','R','5','9373607613',0,'2014-01-05 16:57:28',NULL,NULL),(1160,16917,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000652100',NULL,'875','3','R','5','028',0,'2014-01-29 15:00:03',NULL,NULL),(851,14468,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000555333',NULL,'364','4','R','5','amylee06@gmail.com',0,'2014-01-13 03:03:41',NULL,NULL),(534,13288,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000514421',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:39',NULL,NULL),(1063,16208,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 05:00:02',NULL,NULL),(708,13375,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000362478',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:41',NULL,NULL),(149,13095,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001256010',NULL,'93','2','R','5','5135034270',0,'2014-01-05 16:53:25',NULL,NULL),(220,13131,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000495421',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:05',NULL,NULL),(856,14471,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000514421',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:43',NULL,NULL),(553,13297,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000180985',NULL,'93','2','R','5','7083737223',0,'2014-01-05 17:24:04',NULL,NULL),(801,14443,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000222372',NULL,'364','4','R','5','5138752120',0,'2014-01-13 03:03:16',NULL,NULL),(110,13076,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001249566',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:32',NULL,NULL),(473,13257,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000504449',NULL,'93','2','R','5','6148060734',0,'2014-01-05 17:02:32',NULL,NULL),(792,14439,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000103849',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:11',NULL,NULL),(879,14482,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000864798',NULL,'364','4','R','5','4196753467',0,'2014-01-13 03:03:53',NULL,NULL),(1089,16227,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:39:30',NULL,NULL),(516,13279,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000590760',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:14',NULL,NULL),(655,13348,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000987360',NULL,'93','2','R','I5','5136738802',0,'2014-01-05 17:26:26',NULL,NULL),(232,13137,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000344110',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:25',NULL,NULL),(977,16140,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:54:51',NULL,NULL),(30,13036,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001167966',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:42',NULL,NULL),(508,13275,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000422797',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:02',NULL,NULL),(591,13316,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277250',NULL,'93','2','R','5','5132128353',0,'2014-01-05 17:24:57',NULL,NULL),(359,13200,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000888148',NULL,'93','2','R','5','3302311143',0,'2014-01-05 16:59:53',NULL,NULL),(692,13367,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001198083',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:19',NULL,NULL),(729,14407,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000051897',NULL,'93','2','R','5','9374340530',0,'2014-01-13 03:02:20',NULL,NULL),(198,13120,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001115909',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:34',NULL,NULL),(292,13167,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000484750',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:21',NULL,NULL),(213,13127,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191308',NULL,'93','2','R','5','2163741569',0,'2014-01-05 16:54:54',NULL,NULL),(876,14481,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000701660',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:52',NULL,NULL),(1036,16187,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:27:54',NULL,NULL),(1099,16233,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',0,'2014-01-23 06:40:46',NULL,NULL),(151,13096,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000969424',NULL,'93','2','R','5','4198893730',0,'2014-01-05 16:53:28',NULL,NULL),(346,13194,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000728670',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:36',NULL,NULL),(423,13232,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001228038',NULL,'93','2','R','5','2169323609',0,'2014-01-05 17:01:22',NULL,NULL),(150,13096,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000969424',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:27',NULL,NULL),(377,13209,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000255936',NULL,'93','2','R','5','3306664212',0,'2014-01-05 17:00:18',NULL,NULL),(459,13250,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020404',NULL,'93','2','R','5','5137778930',0,'2014-01-05 17:02:12',NULL,NULL),(796,14441,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000344110',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:12',NULL,NULL),(336,13189,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000971449',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:22',NULL,NULL),(978,16141,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:55:56',NULL,NULL),(700,13371,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000590760',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:30',NULL,NULL),(960,16127,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:48:35',NULL,NULL),(15,13028,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000258128',NULL,'93','2','R','5','7406891492',0,'2014-01-05 16:50:20',NULL,NULL),(652,13347,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000271405',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:23',NULL,NULL),(706,13374,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780485',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:38',NULL,NULL),(909,16094,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000009809',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:35',NULL,NULL),(962,16129,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:49:22',NULL,NULL),(212,13127,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191308',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:54',NULL,NULL),(469,13255,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000790837',NULL,'93','2','R','5','4407147551',0,'2014-01-05 17:02:26',NULL,NULL),(13,13027,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000881602',NULL,'93','2','R','5','5134516490',0,'2014-01-05 16:50:18',NULL,NULL),(394,13218,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277250',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:43',NULL,NULL),(397,13219,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000878236',NULL,'364','6','R','5','6069226831',0,'2014-01-05 17:00:46',NULL,NULL),(1157,16285,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 17:30:02',NULL,NULL),(453,13247,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000254500',NULL,'93','2','R','5','5132452595',0,'2014-01-05 17:02:04',NULL,NULL),(584,13313,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001249566',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:48',NULL,NULL),(1086,16225,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:30:13',NULL,NULL),(84,13063,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186093',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:56',NULL,NULL),(788,14437,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000141468',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:09',NULL,NULL),(1107,16240,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:45:09',NULL,NULL),(717,14401,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001062083',NULL,'93','2','R','I5','2164477716',0,'2014-01-13 03:02:15',NULL,NULL),(754,14420,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000794468',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:32',NULL,NULL),(316,13179,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000254500',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:54',NULL,NULL),(640,13341,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001059452',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:06',NULL,NULL),(951,16121,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:46:44',NULL,NULL),(1060,16206,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:52:49',NULL,NULL),(94,13068,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000926232',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:10',NULL,NULL),(216,13129,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000551401',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:59',NULL,NULL),(433,13237,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001045667',NULL,'93','2','R','5','2162407926',0,'2014-01-05 17:01:36',NULL,NULL),(624,13333,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001062083',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:44',NULL,NULL),(713,14399,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001231745',NULL,'93','2','R','5','9376235094',0,'2014-01-13 03:02:13',NULL,NULL),(1140,16268,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:45:26',NULL,NULL),(48,13045,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000926232',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:07',NULL,NULL),(119,13080,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006959',NULL,'93','2','R','5','3306440668',0,'2014-01-05 16:52:44',NULL,NULL),(699,13370,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000257108',NULL,'93','2','R','5','5056994967',0,'2014-01-05 17:27:27',NULL,NULL),(778,14432,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327246',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:43',NULL,NULL),(854,14470,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000296758',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:43',NULL,NULL),(869,14477,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000533273',NULL,'364','4','R','5','adammrohio@yahoo.com',0,'2014-01-13 03:03:49',NULL,NULL),(1120,16251,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:06:35',NULL,NULL),(1127,16256,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:30:02',NULL,NULL),(200,13121,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000479812',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:37',NULL,NULL),(207,13124,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000853024',NULL,'93','2','R','5','3306066342',0,'2014-01-05 16:54:46',NULL,NULL),(414,13228,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780485',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:11',NULL,NULL),(604,13323,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001167966',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:16',NULL,NULL),(618,13330,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001093116',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:36',NULL,NULL),(795,14440,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000338853',NULL,'364','4','R','5','5133720978',0,'2014-01-13 03:03:12',NULL,NULL),(8,13025,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001119925',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:12',NULL,NULL),(160,13101,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191319',NULL,'875','3','R','5','028',0,'2014-01-05 16:53:41',NULL,NULL),(392,13217,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000728670',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:40',NULL,NULL),(357,13199,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000166336',NULL,'364','4','R','5','pyrostuff@aol.com',0,'2014-01-05 16:59:50',NULL,NULL),(554,13298,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000864798',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:07',NULL,NULL),(919,16100,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:22',NULL,NULL),(1066,16210,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 05:02:10',NULL,NULL),(766,14426,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277258',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:37',NULL,NULL),(1105,16238,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:42:34',NULL,NULL),(997,16155,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:07:06',NULL,NULL),(1132,16261,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:38:31',NULL,NULL),(178,13110,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000987360',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:06',NULL,NULL),(217,13129,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000551401',NULL,'93','2','R','5','5138840218',0,'2014-01-05 16:55:00',NULL,NULL),(153,13097,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000969424',NULL,'93','2','R','5','4198893730',0,'2014-01-05 16:53:31',NULL,NULL),(1125,16254,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000740233',NULL,'310','6','R','4','39007',0,'2014-01-23 07:07:13',NULL,NULL),(77,13059,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000983805',NULL,'93','2','R','5','5135415129',0,'2014-01-05 16:51:46',NULL,NULL),(329,13185,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000921890',NULL,'310','6','R','5','39151',0,'2014-01-05 16:59:11',NULL,NULL),(395,13218,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277250',NULL,'93','2','R','5','5132128353',0,'2014-01-05 17:00:43',NULL,NULL),(603,13322,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001192648',NULL,'93','2','R','5','9379129968',0,'2014-01-05 17:25:14',NULL,NULL),(664,13353,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000895681',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:40',NULL,NULL),(1095,16230,'I10','DMG','93',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000290755',NULL,'310','6','R','4','39005',0,'2014-01-23 06:39:44',NULL,NULL),(345,13193,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001257317',NULL,'93','2','R','5','3306220968',0,'2014-01-05 16:59:33',NULL,NULL),(481,13261,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631486',NULL,'364','4','R','5','tanvirfarooq@gmail.com',0,'2014-01-05 17:02:43',NULL,NULL),(671,13356,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001085583',NULL,'93','2','R','5','5138294806',0,'2014-01-05 17:26:49',NULL,NULL),(539,13290,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001201870',NULL,'93','2','R','5','4198788835',0,'2014-01-05 17:23:45',NULL,NULL),(734,14410,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000422797',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:23',NULL,NULL),(931,16107,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:42:31',NULL,NULL),(1083,16222,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:00:03',NULL,NULL),(211,13126,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000214617',NULL,'364','4','R','5','3307232382',0,'2014-01-05 16:54:51',NULL,NULL),(714,14400,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000227044',NULL,'875','3',NULL,NULL,'028',0,'2014-01-13 03:02:14',NULL,NULL),(192,13117,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000848302',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:26',NULL,NULL),(446,13244,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000703752',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:55',NULL,NULL),(1022,16176,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:19:10',NULL,NULL),(762,14424,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000039780',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:35',NULL,NULL),(31,13036,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001167966',NULL,'93','2','R','5','7402977931',0,'2014-01-05 16:50:42',NULL,NULL),(448,13245,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000195117',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:58',NULL,NULL),(685,13363,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000969424',NULL,'93','2','R','5','4198893730',0,'2014-01-05 17:27:08',NULL,NULL),(337,13189,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000971449',NULL,'93','2','R','5','7403459654',0,'2014-01-05 16:59:22',NULL,NULL),(987,16148,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:00:32',NULL,NULL),(829,14457,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000666747',NULL,'93','2','R','5','9378375183',0,'2014-01-13 03:03:31',NULL,NULL),(956,16124,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000869255',NULL,'310','6','R','4','39005',1,'2014-01-23 03:47:36',NULL,NULL),(1019,16173,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000449829',NULL,'310','6','R','4','39005',1,'2014-01-23 04:17:42',NULL,NULL),(126,13084,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000453874',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:54',NULL,NULL),(299,13170,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000471000',NULL,'93','2','R','5','3307843667',0,'2014-01-05 16:58:29',NULL,NULL),(355,13198,'I10','DMG','124',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293172',NULL,'93','2','R','I5','6145657735',0,'2014-01-05 16:59:47',NULL,NULL),(389,13215,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000408442',NULL,'93','2','R','5','2167696182',0,'2014-01-05 17:00:35',NULL,NULL),(271,13156,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000483458',NULL,'364','4','R','5','larring1@yahoo.com',0,'2014-01-05 16:57:50',NULL,NULL),(838,14462,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230361',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:35',NULL,NULL),(679,13360,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000276240',NULL,'93','2','R','5','4199089073',0,'2014-01-05 17:27:00',NULL,NULL),(837,14461,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000895681',NULL,'93','2','R','5','7406961273',0,'2014-01-13 03:03:34',NULL,NULL),(1003,16161,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:10:28',NULL,NULL),(317,13179,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000254500',NULL,'93','2','R','5','5132452595',0,'2014-01-05 16:58:54',NULL,NULL),(505,13273,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000626703',NULL,'364','6','R','5','3306077220',0,'2014-01-05 17:22:57',NULL,NULL),(728,14407,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000051897',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:20',NULL,NULL),(979,16142,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:56:07',NULL,NULL),(51,13046,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000411077',NULL,'364','4','R','5','7407337678',0,'2014-01-05 16:51:10',NULL,NULL),(639,13340,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000373599',NULL,'93','2','R','5','2167517568',0,'2014-01-05 17:26:04',NULL,NULL),(645,13343,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000626703',NULL,'364','6','R','5','3306077220',0,'2014-01-05 17:26:12',NULL,NULL),(724,14405,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293156',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:18',NULL,NULL),(222,13132,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001178163',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:08',NULL,NULL),(689,13365,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000727244',NULL,'93','2','R','5','4402370837',0,'2014-01-05 17:27:14',NULL,NULL),(892,14489,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000848302',NULL,'875','3','R','I5','028',0,'2014-01-13 03:04:00',NULL,NULL),(961,16128,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:49:11',NULL,NULL),(71,13056,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000828200',NULL,'93','2','R','5','3308395479',0,'2014-01-05 16:51:37',NULL,NULL),(319,13180,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957878',NULL,'93','2','R','5','4192607434',0,'2014-01-05 16:58:57',NULL,NULL),(592,13317,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000351563',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:59',NULL,NULL),(612,13327,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000310840',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:27',NULL,NULL),(663,13352,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000794468',NULL,'93','2','R','5','7405164681',0,'2014-01-05 17:26:37',NULL,NULL),(1021,16175,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:18:35',NULL,NULL),(343,13192,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293156',NULL,'93','2','R','5','2163754944',0,'2014-01-05 16:59:31',NULL,NULL),(547,13294,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000323470',NULL,'93','2','R','5','9372702265',0,'2014-01-05 17:23:56',NULL,NULL),(458,13250,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020404',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:12',NULL,NULL),(859,14472,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000385874',NULL,'93','2','R','5','5135830198',0,'2014-01-13 03:03:44',NULL,NULL),(921,16101,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000869255',NULL,'310','6','R','4','39005',1,'2014-01-23 03:41:26',NULL,NULL),(704,13373,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000034346',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:35',NULL,NULL),(710,13376,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001217346',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:44',NULL,NULL),(1030,16182,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:22:25',NULL,NULL),(1094,16230,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:39:44',NULL,NULL),(1142,16270,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 10:00:02',NULL,NULL),(688,13365,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000727244',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:13',NULL,NULL),(1041,16192,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:33:56',NULL,NULL),(920,16101,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:26',NULL,NULL),(682,13362,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000222372',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:05',NULL,NULL),(694,13368,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001149851',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:21',NULL,NULL),(194,13118,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327249',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:29',NULL,NULL),(367,13204,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000881602',NULL,'93','2','R','5','5134516490',0,'2014-01-05 17:00:04',NULL,NULL),(723,14404,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000388626',NULL,'93','2','R','5','4407298028',0,'2014-01-13 03:02:18',NULL,NULL),(374,13208,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000586673',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:15',NULL,NULL),(602,13322,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001192648',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:13',NULL,NULL),(1114,16246,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:48:31',NULL,NULL),(320,13181,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006959',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:00',NULL,NULL),(452,13247,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000254500',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:04',NULL,NULL),(943,16115,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 03:44:44',NULL,NULL),(197,13119,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001105502',NULL,'93','2','R','5','5133106827',0,'2014-01-05 16:54:32',NULL,NULL),(549,13295,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000171199',NULL,'364','4','R','5','3302096076',0,'2014-01-05 17:23:59',NULL,NULL),(257,13149,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000310840',NULL,'93','2','R','5','9372530650',0,'2014-01-05 16:57:31',NULL,NULL),(349,13195,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762255',NULL,'364','4','R','5','edt748@aol.com',0,'2014-01-05 16:59:39',NULL,NULL),(29,13035,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'93','2','R','5','4198108153',0,'2014-01-05 16:50:40',NULL,NULL),(195,13118,'I10','PER','122',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327249',NULL,'93','2','R','I5','5138501717',0,'2014-01-05 16:54:29',NULL,NULL),(471,13256,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000314668',NULL,'93','2','R','5','3308477768',0,'2014-01-05 17:02:29',NULL,NULL),(649,13345,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000604701',NULL,'93','2','R','I5','6143543021',0,'2014-01-05 17:26:18',NULL,NULL),(1000,16158,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:08:58',NULL,NULL),(139,13090,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000819755',NULL,'93','2','R','5','5132290212',0,'2014-01-05 16:53:11',NULL,NULL),(185,13113,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000146846',NULL,'93','2','R','5','2162805783',0,'2014-01-05 16:54:15',NULL,NULL),(537,13289,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001015547',NULL,'93','2','R','5','5139849550',0,'2014-01-05 17:23:42',NULL,NULL),(1152,16280,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 15:00:02',NULL,NULL),(49,13045,'1','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000926232',NULL,'364','4','R','I5','4409673924',0,'2014-01-05 16:51:07',NULL,NULL),(532,13287,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000203048',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:36',NULL,NULL),(109,13075,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762255',NULL,'364','4','R','5','edt748@aol.com',0,'2014-01-05 16:52:30',NULL,NULL),(123,13082,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001059452',NULL,'310','6','R','5','39003',0,'2014-01-05 16:52:49',NULL,NULL),(444,13243,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230358',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:52',NULL,NULL),(334,13188,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:19',NULL,NULL),(1159,16287,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 18:30:02',NULL,NULL),(105,13073,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001245575',NULL,'364','4','R','5','5138516917',0,'2014-01-05 16:52:24',NULL,NULL),(705,13373,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000034346',NULL,'364','6','R','5','5136525532',0,'2014-01-05 17:27:36',NULL,NULL),(748,14417,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000203048',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:29',NULL,NULL),(648,13345,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000604701',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:17',NULL,NULL),(43,13042,'I10','PER','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000964594',NULL,'93','2','R','I5','4402369273',0,'2014-01-05 16:50:59',NULL,NULL),(98,13070,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000678071',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:16',NULL,NULL),(468,13255,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000790837',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:26',NULL,NULL),(844,14465,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000956619',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:38',NULL,NULL),(193,13117,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000848302',NULL,'93','2','R','5','7407100280',0,'2014-01-05 16:54:26',NULL,NULL),(805,14445,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000759673',NULL,'93','2','R','5','3308292929',0,'2014-01-13 03:03:18',NULL,NULL),(1112,16244,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:46:45',NULL,NULL),(179,13110,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000987360',NULL,'93','2','R','I5','5136738802',0,'2014-01-05 16:54:07',NULL,NULL),(252,13147,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000671679',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:25',NULL,NULL),(272,13157,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000633720',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:53',NULL,NULL),(702,13372,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020392',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:33',NULL,NULL),(76,13059,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000983805',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:45',NULL,NULL),(182,13112,'7','REF','88',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162559',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:12',NULL,NULL),(634,13338,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000133293',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:58',NULL,NULL),(789,14437,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000141468',NULL,'93','2','R','5','3304683072',0,'2014-01-13 03:03:09',NULL,NULL),(870,14478,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000489205',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:50',NULL,NULL),(203,13122,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'93','2','R','5','6146196044',0,'2014-01-05 16:54:40',NULL,NULL),(794,14440,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000338853',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:11',NULL,NULL),(915,16097,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006946',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:37',NULL,NULL),(1100,16234,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:41:04',NULL,NULL),(58,13050,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000790837',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:20',NULL,NULL),(120,13081,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000880486',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:46',NULL,NULL),(678,13360,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000276240',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:59',NULL,NULL),(910,16095,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006946',NULL,'875','3','R','4','028',0,'2014-01-23 03:39:36',NULL,NULL),(1039,16190,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:31:51',NULL,NULL),(514,13278,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950644',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:11',NULL,NULL),(533,13287,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000203048',NULL,'364','4','R','5','5133195679',0,'2014-01-05 17:23:36',NULL,NULL),(141,13091,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546449',NULL,'93','2','R','5','4406285248',0,'2014-01-05 16:53:14',NULL,NULL),(865,14475,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001218525',NULL,'93','2','R','5','4195565043',0,'2014-01-13 03:03:47',NULL,NULL),(425,13233,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000353936',NULL,'93','2','R','5','2164018177',0,'2014-01-05 17:01:25',NULL,NULL),(210,13126,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000214617',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:51',NULL,NULL),(620,13331,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:39',NULL,NULL),(661,13351,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546441',NULL,'93','2','R','5','4408583641',0,'2014-01-05 17:26:35',NULL,NULL),(845,14465,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000956619',NULL,'93','2','R','5','5133219443',0,'2014-01-13 03:03:38',NULL,NULL),(231,13136,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000707584',NULL,'93','2','R','5','5135630625',0,'2014-01-05 16:55:23',NULL,NULL),(916,16098,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000372609',NULL,'875','3','R','5','028',0,'2014-01-23 03:39:38',NULL,NULL),(92,13067,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000038347',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:07',NULL,NULL),(585,13313,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001249566',NULL,'93','2','R','5','3304884126',0,'2014-01-05 17:24:49',NULL,NULL),(1133,16262,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:39:58',NULL,NULL),(1144,16272,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 11:00:03',NULL,NULL),(146,13094,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001081759',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:22',NULL,NULL),(354,13198,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293172',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:47',NULL,NULL),(627,13334,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000940823',NULL,'93','2','R','5','3304006036',0,'2014-01-05 17:25:47',NULL,NULL),(790,14438,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000662667',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:10',NULL,NULL),(803,14444,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000180985',NULL,'93','2','R','5','7083737223',0,'2014-01-13 03:03:17',NULL,NULL),(1044,16195,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:35:25',NULL,NULL),(1111,16243,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:46:12',NULL,NULL),(204,13123,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000070277',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:43',NULL,NULL),(224,13133,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000510627',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:11',NULL,NULL),(246,13144,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000121502',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:16',NULL,NULL),(815,14450,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000983805',NULL,'93','2','R','5','5135415129',0,'2014-01-13 03:03:24',NULL,NULL),(1129,16258,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:13:36',NULL,NULL),(243,13142,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000474927',NULL,'93','2','R','5','5133173474',0,'2014-01-05 16:57:11',NULL,NULL),(439,13240,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001103416',NULL,'93','2','R','5','7404382237',0,'2014-01-05 17:01:44',NULL,NULL),(496,13269,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000787178',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:46',NULL,NULL),(745,14415,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001016820',NULL,'93','2','R','5','4408779797',0,'2014-01-13 03:02:27',NULL,NULL),(900,14493,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000586673',NULL,'875','3','R','I5','028',0,'2014-01-13 03:04:03',NULL,NULL),(940,16113,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000578790',NULL,'875','3','R','I5','028',1,'2014-01-23 03:44:35',NULL,NULL),(1069,16212,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:02:45',NULL,NULL),(601,13321,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001015547',NULL,'93','2','R','5','5139849550',0,'2014-01-05 17:25:11',NULL,NULL),(616,13329,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000425063',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:33',NULL,NULL),(88,13065,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000874673',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:02',NULL,NULL),(913,16096,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006946',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:37',NULL,NULL),(475,13258,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000727244',NULL,'93','2','R','5','4402370837',0,'2014-01-05 17:02:35',NULL,NULL),(727,14406,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001231745',NULL,'93','2','R','5','9376235094',0,'2014-01-13 03:02:19',NULL,NULL),(269,13155,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'93','2','R','5','4198108153',0,'2014-01-05 16:57:48',NULL,NULL),(370,13206,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000995411',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:09',NULL,NULL),(579,13310,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000678071',NULL,'93','2','R','5','4404978103',0,'2014-01-05 17:24:40',NULL,NULL),(490,13266,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000731154',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:37',NULL,NULL),(598,13320,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000703752',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:08',NULL,NULL),(776,14431,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000669141',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:42',NULL,NULL),(209,13125,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000362478',NULL,'93','2','R','5','9378434539',0,'2014-01-05 16:54:49',NULL,NULL),(998,16156,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:07:28',NULL,NULL),(782,14434,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001018205',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:06',NULL,NULL),(492,13267,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001024258',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:40',NULL,NULL),(763,14424,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000039780',NULL,'93','2','R','5','5136526760',0,'2014-01-13 03:02:35',NULL,NULL),(937,16111,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:43:44',NULL,NULL),(311,13176,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000280804',NULL,'93','2','R','I5','9373607613',0,'2014-01-05 16:58:46',NULL,NULL),(419,13230,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000759673',NULL,'93','2','R','5','3308292929',0,'2014-01-05 17:01:17',NULL,NULL),(145,13093,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000717807',NULL,'93','2','R','5','2342179008',0,'2014-01-05 16:53:19',NULL,NULL),(456,13249,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000298186',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:09',NULL,NULL),(529,13285,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000735003',NULL,'310','6','R','5','39061',0,'2014-01-05 17:23:31',NULL,NULL),(983,16144,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 03:56:43',NULL,NULL),(312,13177,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000571965',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:48',NULL,NULL),(381,13211,'I10','DMG','93',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186069',NULL,'93','2','R','5','5136735241',0,'2014-01-05 17:00:24',NULL,NULL),(720,14403,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000443432',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:17',NULL,NULL),(988,16149,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:01:11',NULL,NULL),(362,13202,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000972710',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:58',NULL,NULL),(755,14420,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000794468',NULL,'93','2','R','5','7405164681',0,'2014-01-13 03:02:32',NULL,NULL),(861,14473,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000610839',NULL,'364','4','R','5','brian@48hourfilm.com',0,'2014-01-13 03:03:45',NULL,NULL),(691,13366,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000336406',NULL,'93','2','R','5','5139850010',0,'2014-01-05 17:27:16',NULL,NULL),(42,13042,'7','REF','58',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000964594',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:59',NULL,NULL),(293,13167,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000484750',NULL,'93','2','R','5','3308479991',0,'2014-01-05 16:58:21',NULL,NULL),(757,14421,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631486',NULL,'364','4','R','5','tanvirfarooq@gmail.com',0,'2014-01-13 03:02:33',NULL,NULL),(963,16129,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',1,'2014-01-23 03:49:22',NULL,NULL),(1136,16265,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:28:22',NULL,NULL),(1143,16271,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 10:30:02',NULL,NULL),(1006,16164,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:13:53',NULL,NULL),(138,13090,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000819755',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:11',NULL,NULL),(180,13111,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000713595',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:09',NULL,NULL),(363,13202,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000972710',NULL,'93','2','R','5','9379022240',0,'2014-01-05 16:59:58',NULL,NULL),(623,13332,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000298186',NULL,'93','2','R','5','4195156180',0,'2014-01-05 17:25:42',NULL,NULL),(651,13346,'I10','DMG','124',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293172',NULL,'93','2','R','I5','6145657735',0,'2014-01-05 17:26:21',NULL,NULL),(953,16123,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:47:31',NULL,NULL),(959,16126,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:47:58',NULL,NULL),(1064,16209,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:01:59',NULL,NULL),(568,13305,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762244',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:26',NULL,NULL),(749,14417,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000203048',NULL,'364','4','R','5','5133195679',0,'2014-01-13 03:02:29',NULL,NULL),(818,14452,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001207127',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:26',NULL,NULL),(1004,16162,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:12:40',NULL,NULL),(34,13038,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000954272',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:47',NULL,NULL),(515,13278,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950644',NULL,'93','2','R','5','2167805601',0,'2014-01-05 17:23:11',NULL,NULL),(800,14443,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000222372',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:16',NULL,NULL),(307,13174,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000443432',NULL,'93','2','R','5','5133206656',0,'2014-01-05 16:58:41',NULL,NULL),(555,13298,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000864798',NULL,'364','4','R','5','4196753467',0,'2014-01-05 17:24:07',NULL,NULL),(1135,16264,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:01:27',NULL,NULL),(774,14430,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957878',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:41',NULL,NULL),(240,13141,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000483458',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 16:57:08',NULL,NULL),(952,16122,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:47:25',NULL,NULL),(401,13221,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000191356',NULL,'93','2','R','5','7405910523',0,'2014-01-05 17:00:51',NULL,NULL),(574,13308,'7','REF','88',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162559',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:34',NULL,NULL),(117,13079,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001093116',NULL,'93','2','R','5','5133766674',0,'2014-01-05 16:52:41',NULL,NULL),(406,13224,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950644',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:59',NULL,NULL),(163,13102,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000385874',NULL,'93','2','R','I5','5135830198',0,'2014-01-05 16:53:44',NULL,NULL),(393,13217,'I10','PER','153',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000728670',NULL,'93','2','R','I5','3176951146',0,'2014-01-05 17:00:40',NULL,NULL),(497,13269,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000787178',NULL,'93','2','R','5','5137204727',0,'2014-01-05 17:22:46',NULL,NULL),(435,13238,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001122704',NULL,'93','2','R','5','4405941947',0,'2014-01-05 17:01:39',NULL,NULL),(1110,16242,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',0,'2014-01-23 06:45:52',NULL,NULL),(169,13105,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000484750',NULL,'93','2','R','5','3308479991',0,'2014-01-05 16:53:53',NULL,NULL),(280,13161,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000666747',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:04',NULL,NULL),(176,13109,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:04',NULL,NULL),(205,13123,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000070277',NULL,'93','2','R','5','9377480060',0,'2014-01-05 16:54:43',NULL,NULL),(934,16109,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:43:30',NULL,NULL),(992,16152,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 04:06:35',NULL,NULL),(164,13103,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000070277',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:47',NULL,NULL),(375,13208,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000586673',NULL,'364','4','R','5','7402821107',0,'2014-01-05 17:00:15',NULL,NULL),(832,14459,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000408442',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:32',NULL,NULL),(350,13196,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186093',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:41',NULL,NULL),(895,14490,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000038347',NULL,'93','2','R','5','9373673226',0,'2014-01-13 03:04:01',NULL,NULL),(480,13261,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631486',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:43',NULL,NULL),(572,13307,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001018205',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:32',NULL,NULL),(587,13314,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001198083',NULL,'364','6','R','5','5132525602',0,'2014-01-05 17:24:51',NULL,NULL),(233,13137,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000344110',NULL,'93','2','R','5','3307859588',0,'2014-01-05 16:55:25',NULL,NULL),(739,14412,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000309426',NULL,'364','4','R','5','quinn4qb@yahoo.com',0,'2014-01-13 03:02:25',NULL,NULL),(929,16106,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:42:09',NULL,NULL),(986,16147,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:59:54',NULL,NULL),(27,13034,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000471000',NULL,'93','2','R','5','3307843667',0,'2014-01-05 16:50:37',NULL,NULL),(430,13236,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000146846',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:33',NULL,NULL),(756,14421,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631486',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:32',NULL,NULL),(785,14435,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000930892',NULL,'364','4','R','5','max5031@zoomtown.com',0,'2014-01-13 03:03:07',NULL,NULL),(1126,16255,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:07:31',NULL,NULL),(276,13159,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001149851',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:58',NULL,NULL),(744,14415,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001016820',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:27',NULL,NULL),(208,13125,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000362478',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:48',NULL,NULL),(284,13163,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000713595',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:10',NULL,NULL),(360,13201,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000299209',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:55',NULL,NULL),(399,13220,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000453874',NULL,'93','2','R','5','9378371734',0,'2014-01-05 17:00:49',NULL,NULL),(12,13027,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000881602',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:17',NULL,NULL),(493,13267,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001024258',NULL,'310','6','R','5','39035',0,'2014-01-05 17:22:41',NULL,NULL),(855,14470,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000296758',NULL,'93','2','R','5','4404299541',0,'2014-01-13 03:03:43',NULL,NULL),(25,13033,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'93','2','R','5','4198108153',0,'2014-01-05 16:50:34',NULL,NULL),(550,13296,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000271405',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:01',NULL,NULL),(295,13168,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000940823',NULL,'93','2','R','5','3304006036',0,'2014-01-05 16:58:24',NULL,NULL),(494,13268,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000551401',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:43',NULL,NULL),(286,13164,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001201870',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:12',NULL,NULL),(380,13211,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186069',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:23',NULL,NULL),(833,14459,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000408442',NULL,'93','2','R','5','2167696182',0,'2014-01-13 03:03:33',NULL,NULL),(238,13140,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000373599',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 16:57:05',NULL,NULL),(244,13143,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000516871',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 16:57:14',NULL,NULL),(411,13226,'I10','PER','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001053027',NULL,'93','2','R','5','7406535809',0,'2014-01-05 17:01:05',NULL,NULL),(614,13328,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000587954',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:30',NULL,NULL),(510,13276,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000371465',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:05',NULL,NULL),(973,16136,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 03:51:52',NULL,NULL),(984,16145,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:57:08',NULL,NULL),(28,13035,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:39',NULL,NULL),(69,13055,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957886',NULL,'364','4','R','5','seth@sethkbrown.com',0,'2014-01-05 16:51:35',NULL,NULL),(230,13136,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000707584',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:22',NULL,NULL),(470,13256,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000314668',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:29',NULL,NULL),(609,13325,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001122704',NULL,'93','2','R','5','4405941947',0,'2014-01-05 17:25:22',NULL,NULL),(36,13039,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001180994',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:50',NULL,NULL),(440,13241,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000936035',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:47',NULL,NULL),(1096,16231,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:40:05',NULL,NULL),(1123,16253,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:07:03',NULL,NULL),(104,13073,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001245575',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:24',NULL,NULL),(712,14399,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001231745',NULL,'875','3',NULL,NULL,'028',0,'2014-01-13 03:02:13',NULL,NULL),(899,14492,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001180994',NULL,'93','2','R','5','2166507328',0,'2014-01-13 03:04:03',NULL,NULL),(831,14458,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001115909',NULL,'93','2','R','5','6145650225',0,'2014-01-13 03:03:32',NULL,NULL),(1062,16207,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:57:16',NULL,NULL),(85,13063,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186093',NULL,'364','4','R','5','DonDurbin@neo.rr.com',0,'2014-01-05 16:51:57',NULL,NULL),(181,13111,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000713595',NULL,'93','2','R','5','3306855010',0,'2014-01-05 16:54:10',NULL,NULL),(619,13330,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001093116',NULL,'93','2','R','5','5133766674',0,'2014-01-05 17:25:36',NULL,NULL),(1038,16189,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 04:30:03',NULL,NULL),(1040,16191,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:33:10',NULL,NULL),(157,13099,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000383348',NULL,'93','2','R','5','2162141398',0,'2014-01-05 16:53:36',NULL,NULL),(666,13354,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000329623',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:43',NULL,NULL),(768,14427,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000425063',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:38',NULL,NULL),(54,13048,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000921890',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:15',NULL,NULL),(369,13205,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001045667',NULL,'93','2','R','5','2162407926',0,'2014-01-05 17:00:07',NULL,NULL),(1073,16215,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000869255',NULL,'310','6','R','4','39005',1,'2014-01-23 05:06:32',NULL,NULL),(1115,16247,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:00:02',NULL,NULL),(124,13083,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000309426',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:51',NULL,NULL),(156,13099,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000383348',NULL,'875','3','R','5','028',0,'2014-01-05 16:53:36',NULL,NULL),(253,13147,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000671679',NULL,'364','4','R','5','6147352922',0,'2014-01-05 16:57:25',NULL,NULL),(294,13168,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000940823',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:23',NULL,NULL),(427,13234,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000255936',NULL,'93','2','R','5','3306664212',0,'2014-01-05 17:01:28',NULL,NULL),(161,13101,'I10','DMG','62',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191319',NULL,'93','2','R','I5','6144042246',0,'2014-01-05 16:53:42',NULL,NULL),(396,13219,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000878236',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:45',NULL,NULL),(949,16119,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',1,'2014-01-23 03:45:54',NULL,NULL),(358,13200,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000888148',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:52',NULL,NULL),(263,13152,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000212143',NULL,'93','2','R','5','3304052938',0,'2014-01-05 16:57:39',NULL,NULL),(813,14449,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000954272',NULL,'364','4','R','5','5135091363',0,'2014-01-13 03:03:23',NULL,NULL),(1071,16214,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:06:28',NULL,NULL),(86,13064,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000030530',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:59',NULL,NULL),(250,13146,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661327',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:22',NULL,NULL),(321,13181,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006959',NULL,'93','2','R','5','3306440668',0,'2014-01-05 16:59:00',NULL,NULL),(366,13204,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000881602',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:04',NULL,NULL),(442,13242,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000880486',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:50',NULL,NULL),(129,13085,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000912924',NULL,'364','4','R','5','ellinakhramova@gmail.com',0,'2014-01-05 16:52:57',NULL,NULL),(47,13044,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000166336',NULL,'364','4','R','5','pyrostuff@aol.com',0,'2014-01-05 16:51:04',NULL,NULL),(487,13264,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000878236',NULL,'364','6','R','5','6069226831',0,'2014-01-05 17:02:51',NULL,NULL),(536,13289,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001015547',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:41',NULL,NULL),(730,14408,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000847122',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:21',NULL,NULL),(1149,16277,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 13:30:02',NULL,NULL),(122,13082,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001059452',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:49',NULL,NULL),(279,13160,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000936035',NULL,'364','4','R','5','4196253817',0,'2014-01-05 16:58:02',NULL,NULL),(939,16112,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:44:00',NULL,NULL),(542,13292,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001217346',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:50',NULL,NULL),(673,13357,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000849407',NULL,'364','4','R','5','revreece7@ameritech.net',0,'2014-01-05 17:26:51',NULL,NULL),(993,16153,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:06:53',NULL,NULL),(214,13128,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000242670',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:56',NULL,NULL),(823,14454,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000214617',NULL,'364','4','R','5','3307232382',0,'2014-01-13 03:03:28',NULL,NULL),(428,13235,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000044255',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:30',NULL,NULL),(107,13074,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000891779',NULL,'93','2','R','5','3309221760',0,'2014-01-05 16:52:27',NULL,NULL),(1153,16281,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 15:30:03',NULL,NULL),(569,13305,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762244',NULL,'93','2','R','I5','7632189645',0,'2014-01-05 17:24:26',NULL,NULL),(1023,16177,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:20:36',NULL,NULL),(821,14453,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000509175',NULL,'93','2','R','5','5132543646',0,'2014-01-13 03:03:27',NULL,NULL),(581,13311,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001090877',NULL,'93','2','R','5','5138465353',0,'2014-01-05 17:24:43',NULL,NULL),(277,13159,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001149851',NULL,'93','2','R','5','3307531659',0,'2014-01-05 16:57:59',NULL,NULL),(650,13346,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293172',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:20',NULL,NULL),(806,14446,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162557',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:19',NULL,NULL),(1059,16205,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:52:47',NULL,NULL),(1077,16217,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000449829',NULL,'310','6','R','4','39005',1,'2014-01-23 05:06:42',NULL,NULL),(330,13186,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078722',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:13',NULL,NULL),(901,14493,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000586673',NULL,'364','4','R','5','7402821107',0,'2014-01-13 03:04:03',NULL,NULL),(287,13164,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001201870',NULL,'93','2','R','5','4198788835',0,'2014-01-05 16:58:13',NULL,NULL),(457,13249,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000298186',NULL,'93','2','R','5','4195156180',0,'2014-01-05 17:02:10',NULL,NULL),(672,13357,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000849407',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:51',NULL,NULL),(578,13310,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000678071',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:40',NULL,NULL),(647,13344,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001024258',NULL,'310','6','R','5','39035',0,'2014-01-05 17:26:15',NULL,NULL),(239,13140,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000373599',NULL,'93','2','R','5','2167517568',0,'2014-01-05 16:57:06',NULL,NULL),(323,13182,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000044255',NULL,'93','2','R','5','5138311796',0,'2014-01-05 16:59:03',NULL,NULL),(348,13195,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762255',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:39',NULL,NULL),(633,13337,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078722',NULL,'93','2','R','5','2165771692',0,'2014-01-05 17:25:56',NULL,NULL),(24,13033,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:34',NULL,NULL),(177,13109,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'93','2','R','5','6146196044',0,'2014-01-05 16:54:04',NULL,NULL),(523,13282,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000939750',NULL,'364','4','R','5','5137773368',0,'2014-01-05 17:23:22',NULL,NULL),(626,13334,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000940823',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:47',NULL,NULL),(201,13121,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000479812',NULL,'93','2','R','5','6145967429',0,'2014-01-05 16:54:37',NULL,NULL),(398,13220,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000453874',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:48',NULL,NULL),(270,13156,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000483458',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:50',NULL,NULL),(896,14491,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000847122',NULL,'875','3','R','I5','028',0,'2014-01-13 03:04:02',NULL,NULL),(922,16102,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:32',NULL,NULL),(938,16111,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',1,'2014-01-23 03:43:44',NULL,NULL),(933,16108,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000159382',NULL,'310','6','R','4','39007',1,'2014-01-23 03:42:44',NULL,NULL),(957,16125,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:47:40',NULL,NULL),(477,13259,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'93','2','R','5','4198108153',0,'2014-01-05 17:02:37',NULL,NULL),(787,14436,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001257317',NULL,'93','2','R','5','3306220968',0,'2014-01-13 03:03:08',NULL,NULL),(40,13041,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000866852',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:56',NULL,NULL),(223,13132,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001178163',NULL,'93','2','R','5','4402130968',0,'2014-01-05 16:55:09',NULL,NULL),(479,13260,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661325',NULL,'93','2','R','5','4193072572',0,'2014-01-05 17:02:40',NULL,NULL),(517,13279,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000590760',NULL,'93','2','R','5','9373744790',0,'2014-01-05 17:23:14',NULL,NULL),(526,13284,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327246',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:28',NULL,NULL),(966,16132,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:50:32',NULL,NULL),(265,13153,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000610839',NULL,'364','4','R','5','brian@48hourfilm.com',0,'2014-01-05 16:57:42',NULL,NULL),(91,13066,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546449',NULL,'93','2','R','5','4406285248',0,'2014-01-05 16:52:05',NULL,NULL),(303,13172,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000053025',NULL,'93','2','R','5','9372986375',0,'2014-01-05 16:58:35',NULL,NULL),(314,13178,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000662667',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:51',NULL,NULL),(437,13239,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020404',NULL,'93','2','R','5','5137778930',0,'2014-01-05 17:01:42',NULL,NULL),(552,13297,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000180985',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:04',NULL,NULL),(670,13356,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001085583',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:48',NULL,NULL),(304,13173,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000956619',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:37',NULL,NULL),(225,13133,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000510627',NULL,'93','2','R','5','4403490552',0,'2014-01-05 16:55:12',NULL,NULL),(965,16131,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:50:22',NULL,NULL),(968,16133,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:50:50',NULL,NULL),(990,16151,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:06:25',NULL,NULL),(643,13342,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000972710',NULL,'93','2','R','5','9379022240',0,'2014-01-05 17:26:10',NULL,NULL),(582,13312,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000383348',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:45',NULL,NULL),(819,14452,'I10','N4','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001207127',NULL,'93','2','R','5','6143251529',0,'2014-01-13 03:03:26',NULL,NULL),(275,13158,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957886',NULL,'364','4','R','5','seth@sethkbrown.com',0,'2014-01-05 16:57:56',NULL,NULL),(1070,16213,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:03:21',NULL,NULL),(412,13227,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000371465',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:08',NULL,NULL),(511,13276,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000371465',NULL,'93','2','R','5','7343010089',0,'2014-01-05 17:23:06',NULL,NULL),(1061,16206,'I10','DMG','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260440',NULL,'310','6','R','4','39005',1,'2014-01-23 04:52:49',NULL,NULL),(378,13210,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000809647',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:20',NULL,NULL),(802,14444,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000180985',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:17',NULL,NULL),(967,16132,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 03:50:32',NULL,NULL),(63,13052,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000819755',NULL,'93','2','R','5','5132290212',0,'2014-01-05 16:51:26',NULL,NULL),(100,13071,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000137530',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:18',NULL,NULL),(56,13049,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001118692',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:18',NULL,NULL),(911,16095,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006946',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:36',NULL,NULL),(519,13280,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001105502',NULL,'93','2','R','5','5133106827',0,'2014-01-05 17:23:17',NULL,NULL),(631,13336,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000036973',NULL,'93','2','R','5','9378905393',0,'2014-01-05 17:25:53',NULL,NULL),(136,13089,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000939750',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:08',NULL,NULL),(817,14451,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000983805',NULL,'93','2','R','5','5135415129',0,'2014-01-13 03:03:25',NULL,NULL),(289,13165,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000103849',NULL,'93','2','R','5','3309573056',0,'2014-01-05 16:58:16',NULL,NULL),(371,13206,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000995411',NULL,'93','2','R','5','2162124469',0,'2014-01-05 17:00:10',NULL,NULL),(737,14411,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000195117',NULL,'93','2','R','5','9377879087',0,'2014-01-13 03:02:24',NULL,NULL),(836,14461,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000895681',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:34',NULL,NULL),(853,14469,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000030530',NULL,'93','2','R','5','9378300732',0,'2014-01-13 03:03:42',NULL,NULL),(880,14483,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000287064',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:54',NULL,NULL),(889,14487,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000192698',NULL,'93','2','R','5','9372352289',0,'2014-01-13 03:03:58',NULL,NULL),(166,13104,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000571965',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:50',NULL,NULL),(912,16096,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000372609',NULL,'875','3','R','5','028',0,'2014-01-23 03:39:37',NULL,NULL),(927,16104,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000802547',NULL,'310','6','R','4','39153',1,'2014-01-23 03:41:37',NULL,NULL),(305,13173,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000956619',NULL,'93','2','R','5','5133219443',0,'2014-01-05 16:58:38',NULL,NULL),(1008,16166,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:15:07',NULL,NULL),(45,13043,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000637079',NULL,'364','4','R','5','5135612543',0,'2014-01-05 16:51:02',NULL,NULL),(642,13342,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000972710',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:09',NULL,NULL),(770,14428,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001153597',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:39',NULL,NULL),(407,13224,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950644',NULL,'93','2','R','5','2167805601',0,'2014-01-05 17:01:00',NULL,NULL),(878,14482,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000864798',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:53',NULL,NULL),(1051,16199,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:46:07',NULL,NULL),(637,13339,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001228038',NULL,'93','2','R','5','2169323609',0,'2014-01-05 17:26:01',NULL,NULL),(980,16142,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 03:56:07',NULL,NULL),(258,13150,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000971449',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:33',NULL,NULL),(274,13158,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957886',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:55',NULL,NULL),(422,13232,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001228038',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:22',NULL,NULL),(66,13054,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000353936',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:31',NULL,NULL),(332,13187,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000369984',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:16',NULL,NULL),(525,13283,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000555333',NULL,'364','4','R','5','amylee06@gmail.com',0,'2014-01-05 17:23:25',NULL,NULL),(662,13352,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000794468',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:37',NULL,NULL),(143,13092,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162557',NULL,'93','2','R','5','4405546379',0,'2014-01-05 16:53:17',NULL,NULL),(237,13139,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661325',NULL,'93','2','R','5','4193072572',0,'2014-01-05 16:55:32',NULL,NULL),(871,14478,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000489205',NULL,'93','2','R','5','4405709144',0,'2014-01-13 03:03:50',NULL,NULL),(137,13089,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000939750',NULL,'364','4','R','5','5137773368',0,'2014-01-05 16:53:08',NULL,NULL),(824,14455,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001085583',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:29',NULL,NULL),(981,16143,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:56:32',NULL,NULL),(1076,16217,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:06:42',NULL,NULL),(186,13114,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000247876',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:17',NULL,NULL),(199,13120,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001115909',NULL,'93','2','R','5','6145650225',0,'2014-01-05 16:54:35',NULL,NULL),(636,13339,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001228038',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:01',NULL,NULL),(1087,16225,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',0,'2014-01-23 06:30:13',NULL,NULL),(391,13216,'I10','DMG','62',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191319',NULL,'93','2','R','I5','6144042246',0,'2014-01-05 17:00:38',NULL,NULL),(429,13235,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000044255',NULL,'93','2','R','5','5138311796',0,'2014-01-05 17:01:31',NULL,NULL),(629,13335,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000369984',NULL,'93','2','R','5','2164033462',0,'2014-01-05 17:25:50',NULL,NULL),(742,14414,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078730',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:26',NULL,NULL),(1049,16198,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:45:47',NULL,NULL),(447,13244,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000703752',NULL,'93','2','R','5','9375817138',0,'2014-01-05 17:01:56',NULL,NULL),(807,14446,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162557',NULL,'93','2','R','5','4405546379',0,'2014-01-13 03:03:19',NULL,NULL),(866,14476,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001081759',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:48',NULL,NULL),(37,13039,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001180994',NULL,'93','2','R','5','2166507328',0,'2014-01-05 16:50:51',NULL,NULL),(589,13315,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000707584',NULL,'93','2','R','5','5135630625',0,'2014-01-05 17:24:54',NULL,NULL),(621,13331,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'93','2','R','5','6146196044',0,'2014-01-05 17:25:39',NULL,NULL),(80,13061,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001135137',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:51',NULL,NULL),(656,13349,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000133293',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:29',NULL,NULL),(658,13350,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020392',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:31',NULL,NULL),(767,14426,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277258',NULL,'93','2','R','5','5139261369',0,'2014-01-13 03:02:37',NULL,NULL),(83,13062,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000067657',NULL,'364','4','R','5','4404667936',0,'2014-01-05 16:51:54',NULL,NULL),(112,13077,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001218525',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:35',NULL,NULL),(1027,16180,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:21:17',NULL,NULL),(1043,16194,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:35:14',NULL,NULL),(1084,16223,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:19:21',NULL,NULL),(131,13086,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000257108',NULL,'93','2','R','5','5056994967',0,'2014-01-05 16:53:00',NULL,NULL),(936,16110,NULL,'DMG','93',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000290755',NULL,NULL,NULL,'R','4',NULL,1,'2014-01-23 03:43:33',NULL,NULL),(291,13166,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000173784',NULL,'93','2','R','5','2165361993',0,'2014-01-05 16:58:18',NULL,NULL),(1148,16276,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 13:00:02',NULL,NULL),(64,13053,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000314668',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:29',NULL,NULL),(498,13270,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000191356',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:48',NULL,NULL),(676,13359,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000731154',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:56',NULL,NULL),(1009,16167,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:16:03',NULL,NULL),(158,13100,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000930892',NULL,'875','3','R','5','028',0,'2014-01-05 16:53:38',NULL,NULL),(1146,16274,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 12:00:03',NULL,NULL),(356,13199,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000166336',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:50',NULL,NULL),(509,13275,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000422797',NULL,'93','2','R','5','4196052409',0,'2014-01-05 17:23:03',NULL,NULL),(605,13323,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001167966',NULL,'93','2','R','5','7402977931',0,'2014-01-05 17:25:17',NULL,NULL),(765,14425,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000105334',NULL,'310','6','R','5','39095',0,'2014-01-13 03:02:36',NULL,NULL),(20,13031,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230361',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:28',NULL,NULL),(168,13105,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000484750',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:52',NULL,NULL),(635,13338,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000133293',NULL,'93','2','R','5','5135209019',0,'2014-01-05 17:25:58',NULL,NULL),(1081,16221,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 05:30:14',NULL,NULL),(18,13030,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950650',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:25',NULL,NULL),(436,13239,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020404',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:41',NULL,NULL),(560,13301,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000509175',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:15',NULL,NULL),(563,13302,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000637079',NULL,'364','4','R','5','5135612543',0,'2014-01-05 17:24:18',NULL,NULL),(758,14422,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000495421',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:33',NULL,NULL),(593,13317,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000351563',NULL,'93','2','R','5','3308251040',0,'2014-01-05 17:25:00',NULL,NULL),(677,13359,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000731154',NULL,'93','2','R','5','3309483238',0,'2014-01-05 17:26:57',NULL,NULL),(1103,16236,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',0,'2014-01-23 06:41:48',NULL,NULL),(72,13057,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000510627',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:40',NULL,NULL),(322,13182,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000044255',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:02',NULL,NULL),(556,13299,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000516871',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:09',NULL,NULL),(236,13139,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661325',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:31',NULL,NULL),(964,16130,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:49:40',NULL,NULL),(102,13072,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000853024',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:21',NULL,NULL),(344,13193,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001257317',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:33',NULL,NULL),(611,13326,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000287064',NULL,'93','2','R','5','3309907936',0,'2014-01-05 17:25:25',NULL,NULL),(147,13094,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001081759',NULL,'364','4','R','5','rob.bermingham@gmail.com',0,'2014-01-05 16:53:22',NULL,NULL),(347,13194,'I10','PER','153',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000728670',NULL,'93','2','R','I5','3176951146',0,'2014-01-05 16:59:36',NULL,NULL),(654,13348,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000987360',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:26',NULL,NULL),(781,14433,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780475',NULL,'364','4','R','5','4404766225',0,'2014-01-13 03:02:44',NULL,NULL),(1106,16239,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:44:44',NULL,NULL),(659,13350,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020392',NULL,'93','2','R','I5','5137421671',0,'2014-01-05 17:26:32',NULL,NULL),(171,13106,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001178163',NULL,'93','2','R','5','4402130968',0,'2014-01-05 16:53:56',NULL,NULL),(738,14412,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000309426',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:25',NULL,NULL),(764,14425,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000105334',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:36',NULL,NULL),(784,14435,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000930892',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:07',NULL,NULL),(994,16154,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:07:00',NULL,NULL),(235,13138,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000988853',NULL,'93','2','R','5','9376455403',0,'2014-01-05 16:55:29',NULL,NULL),(573,13307,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001018205',NULL,'364','4','R','5','kateingradschool@gmail.com',0,'2014-01-05 17:24:32',NULL,NULL),(382,13212,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000639499',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:26',NULL,NULL),(465,13253,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000036973',NULL,'93','2','R','5','9378905393',0,'2014-01-05 17:02:21',NULL,NULL),(926,16104,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:37',NULL,NULL),(115,13078,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000891779',NULL,'93','2','R','5','3309221760',0,'2014-01-05 16:52:38',NULL,NULL),(400,13221,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000191356',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:51',NULL,NULL),(777,14431,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000669141',NULL,'93','2','R','5','5133782791',0,'2014-01-13 03:02:42',NULL,NULL),(690,13366,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000336406',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:16',NULL,NULL),(561,13301,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000509175',NULL,'93','2','R','5','5132543646',0,'2014-01-05 17:24:15',NULL,NULL),(340,13191,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000192698',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:27',NULL,NULL),(669,13355,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000560540',NULL,'93','2','R','5','9374335970',0,'2014-01-05 17:26:46',NULL,NULL),(811,14448,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000828200',NULL,'93','2','R','5','3308395479',0,'2014-01-13 03:03:21',NULL,NULL),(812,14449,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000954272',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:23',NULL,NULL),(315,13178,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000662667',NULL,'93','2','R','5','5134883944',0,'2014-01-05 16:58:52',NULL,NULL),(1001,16159,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:09:32',NULL,NULL),(111,13076,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001249566',NULL,'93','2','R','5','3304884126',0,'2014-01-05 16:52:33',NULL,NULL),(173,13107,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000814273',NULL,'93','2','R','5','9374321954',0,'2014-01-05 16:53:58',NULL,NULL),(390,13216,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191319',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:37',NULL,NULL),(622,13332,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000298186',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:41',NULL,NULL),(1002,16160,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:10:00',NULL,NULL),(432,13237,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001045667',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:36',NULL,NULL),(409,13225,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762244',NULL,'93','2','R','5','7632189645',0,'2014-01-05 17:01:03',NULL,NULL),(32,13037,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001103416',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:45',NULL,NULL),(464,13253,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000036973',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:20',NULL,NULL),(852,14469,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000030530',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:42',NULL,NULL),(923,16102,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 03:41:32',NULL,NULL),(1026,16179,'I10','DMG','62',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000465882',NULL,'310','6','R','4','39005',1,'2014-01-23 04:21:12',NULL,NULL),(1097,16232,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:40:34',NULL,NULL),(113,13077,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001218525',NULL,'93','2','R','5','4195565043',0,'2014-01-05 16:52:35',NULL,NULL),(154,13098,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000051897',NULL,'875','3','R','5','028',0,'2014-01-05 16:53:33',NULL,NULL),(599,13320,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000703752',NULL,'93','2','R','5','9375817138',0,'2014-01-05 17:25:08',NULL,NULL),(816,14451,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772613',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:25',NULL,NULL),(306,13174,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000443432',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:40',NULL,NULL),(310,13176,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000280804',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:46',NULL,NULL),(308,13175,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327249',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:43',NULL,NULL),(725,14405,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000293156',NULL,'93','2','R','5','2163754944',0,'2014-01-13 03:02:18',NULL,NULL),(318,13180,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957878',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:57',NULL,NULL),(489,13265,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000227044',NULL,'93','2','R','I5','9375208110',0,'2014-01-05 17:22:35',NULL,NULL),(726,14406,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001231745',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:19',NULL,NULL),(834,14460,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000411077',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:33',NULL,NULL),(62,13052,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000819755',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:26',NULL,NULL),(740,14413,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000388626',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:25',NULL,NULL),(799,14442,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000034346',NULL,'364','6','R','5','5136525532',0,'2014-01-13 03:03:13',NULL,NULL),(443,13242,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000880486',NULL,'93','2','R','5','4407242560',0,'2014-01-05 17:01:50',NULL,NULL),(882,14484,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000717807',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:55',NULL,NULL),(500,13271,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000849407',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:51',NULL,NULL),(1116,16248,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:05:12',NULL,NULL),(877,14481,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000701660',NULL,'364','4','R','5','3305947027',0,'2014-01-13 03:03:53',NULL,NULL),(1117,16249,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:05:50',NULL,NULL),(434,13238,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001122704',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:38',NULL,NULL),(520,13281,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000560540',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:19',NULL,NULL),(1092,16229,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:39:41',NULL,NULL),(449,13245,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000195117',NULL,'93','2','R','5','9377879087',0,'2014-01-05 17:01:58',NULL,NULL),(1113,16245,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:47:42',NULL,NULL),(991,16152,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:06:35',NULL,NULL),(81,13061,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001135137',NULL,'93','2','R','5','5132901897',0,'2014-01-05 16:51:51',NULL,NULL),(116,13079,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001093116',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:40',NULL,NULL),(687,13364,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000533273',NULL,'364','4','R','5','adammrohio@yahoo.com',0,'2014-01-05 17:27:11',NULL,NULL),(23,13032,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000105334',NULL,'310','6','R','5','39095',0,'2014-01-05 16:50:31',NULL,NULL),(190,13116,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000787178',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:23',NULL,NULL),(191,13116,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000787178',NULL,'93','2','R','5','5137204727',0,'2014-01-05 16:54:23',NULL,NULL),(451,13246,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000633720',NULL,'93','2','R','5','9378433740',0,'2014-01-05 17:02:01',NULL,NULL),(907,16093,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000009809',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:35',NULL,NULL),(548,13295,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000171199',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:58',NULL,NULL),(890,14488,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000323470',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:59',NULL,NULL),(242,13142,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000474927',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 16:57:11',NULL,NULL),(300,13171,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000223675',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:32',NULL,NULL),(1065,16210,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:02:10',NULL,NULL),(862,14474,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000474927',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:46',NULL,NULL),(786,14436,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001257317',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:08',NULL,NULL),(885,14485,'I10','NM1','16',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000223675',NULL,'310','6','R','5','39061',0,'2014-01-13 03:03:56',NULL,NULL),(681,13361,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001118692',NULL,'93','2','R','5','5132955085',0,'2014-01-05 17:27:02',NULL,NULL),(804,14445,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000759673',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:18',NULL,NULL),(638,13340,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000373599',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:04',NULL,NULL),(665,13353,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000895681',NULL,'93','2','R','5','7406961273',0,'2014-01-05 17:26:40',NULL,NULL),(1072,16215,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:06:32',NULL,NULL),(1141,16269,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:50:45',NULL,NULL),(324,13183,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000121502',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:05',NULL,NULL),(675,13358,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239104',NULL,'93','2','R','5','9373467293',0,'2014-01-05 17:26:54',NULL,NULL),(930,16106,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',1,'2014-01-23 03:42:09',NULL,NULL),(450,13246,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000633720',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:01',NULL,NULL),(331,13186,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078722',NULL,'93','2','R','5','2165771692',0,'2014-01-05 16:59:14',NULL,NULL),(613,13327,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000310840',NULL,'93','2','R','5','9372530650',0,'2014-01-05 17:25:28',NULL,NULL),(298,13170,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000471000',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:29',NULL,NULL),(1016,16172,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:38',NULL,NULL),(722,14404,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000388626',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:17',NULL,NULL),(1047,16197,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:45:37',NULL,NULL),(1138,16266,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',0,'2014-01-23 09:28:28',NULL,NULL),(1014,16171,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:33',NULL,NULL),(562,13302,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000637079',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:18',NULL,NULL),(826,14456,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000053025',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:30',NULL,NULL),(267,13154,'I10','PER','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000964594',NULL,'93','2','R','5','4402369273',0,'2014-01-05 16:57:45',NULL,NULL),(1052,16200,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:47:05',NULL,NULL),(140,13091,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546449',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:13',NULL,NULL),(958,16125,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000449829',NULL,'310','6','R','4','39005',1,'2014-01-23 03:47:40',NULL,NULL),(989,16150,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:01:46',NULL,NULL),(1042,16193,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:34:33',NULL,NULL),(460,13251,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000351563',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:15',NULL,NULL),(842,14464,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000888148',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:37',NULL,NULL),(857,14471,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000514421',NULL,'93','2','R','5','5137069596',0,'2014-01-13 03:03:44',NULL,NULL),(130,13086,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000257108',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:00',NULL,NULL),(466,13254,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000242670',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:23',NULL,NULL),(309,13175,'I10','PER','122',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000327249',NULL,'93','2','R','I5','5138501717',0,'2014-01-05 16:58:43',NULL,NULL),(608,13325,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001122704',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:22',NULL,NULL),(632,13337,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078722',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:55',NULL,NULL),(736,14411,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000195117',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:24',NULL,NULL),(1068,16211,'I10','DMG','93',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000290755',NULL,'310','6','R','4','39133',1,'2014-01-23 05:02:13',NULL,NULL),(97,13069,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000171199',NULL,'364','4','R','5','3302096076',0,'2014-01-05 16:52:13',NULL,NULL),(206,13124,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000853024',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:45',NULL,NULL),(486,13264,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000878236',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:51',NULL,NULL),(873,14479,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000587954',NULL,'364','4','R','5','annecatherineharvey@gmail.com',0,'2014-01-13 03:03:51',NULL,NULL),(96,13069,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000171199',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:13',NULL,NULL),(341,13191,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000192698',NULL,'93','2','R','5','9372352289',0,'2014-01-05 16:59:28',NULL,NULL),(365,13203,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001153597',NULL,'93','2','R','5','3302062344',0,'2014-01-05 17:00:01',NULL,NULL),(476,13259,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:37',NULL,NULL),(1124,16254,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:07:13',NULL,NULL),(719,14402,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000258128',NULL,'93','2','R','5','7406891492',0,'2014-01-13 03:02:16',NULL,NULL),(1005,16163,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:13:17',NULL,NULL),(771,14428,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001153597',NULL,'93','2','R','5','3302062344',0,'2014-01-13 03:02:39',NULL,NULL),(1074,16216,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:06:39',NULL,NULL),(1121,16252,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:06:40',NULL,NULL),(22,13032,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000105334',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:31',NULL,NULL),(410,13226,'7','REF','58',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001053027',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:05',NULL,NULL),(338,13190,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000504449',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:25',NULL,NULL),(615,13328,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000587954',NULL,'364','4','R','5','annecatherineharvey@gmail.com',0,'2014-01-05 17:25:31',NULL,NULL),(73,13057,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000510627',NULL,'93','2','R','5','4403490552',0,'2014-01-05 16:51:40',NULL,NULL),(103,13072,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000853024',NULL,'93','2','R','5','3306066342',0,'2014-01-05 16:52:22',NULL,NULL),(472,13257,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000504449',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:31',NULL,NULL),(918,16099,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:40:36',NULL,NULL),(976,16139,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:54:11',NULL,NULL),(1037,16188,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:29:33',NULL,NULL),(368,13205,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001045667',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:06',NULL,NULL),(696,13369,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000669141',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:24',NULL,NULL),(941,16114,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:44:38',NULL,NULL),(1013,16170,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:26',NULL,NULL),(491,13266,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000731154',NULL,'93','2','R','5','3309483238',0,'2014-01-05 17:22:38',NULL,NULL),(600,13321,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001015547',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:11',NULL,NULL),(711,13376,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001217346',NULL,'93','2','R','5','5134600782',0,'2014-01-05 17:27:44',NULL,NULL),(808,14447,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000701660',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:20',NULL,NULL),(245,13143,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000516871',NULL,'93','2','R','5','6145066844',0,'2014-01-05 16:57:14',NULL,NULL),(528,13285,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000735003',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:30',NULL,NULL),(57,13049,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001118692',NULL,'93','2','R','5','5132955085',0,'2014-01-05 16:51:18',NULL,NULL),(583,13312,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000383348',NULL,'93','2','R','5','2162141398',0,'2014-01-05 17:24:46',NULL,NULL),(797,14441,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000344110',NULL,'93','2','R','5','3307859588',0,'2014-01-13 03:03:13',NULL,NULL),(1048,16197,NULL,'DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000449829',NULL,NULL,NULL,'R','4',NULL,1,'2014-01-23 04:45:37',NULL,NULL),(588,13315,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000707584',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:54',NULL,NULL),(975,16138,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:53:21',NULL,NULL),(152,13097,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772613',NULL,'875','3','R','5','028',0,'2014-01-05 16:53:30',NULL,NULL),(431,13236,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000146846',NULL,'93','2','R','5','2162805783',0,'2014-01-05 17:01:33',NULL,NULL),(503,13272,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230358',NULL,'93','2','R','5','3306099029',0,'2014-01-05 17:22:54',NULL,NULL),(521,13281,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000560540',NULL,'93','2','R','5','9374335970',0,'2014-01-05 17:23:20',NULL,NULL),(693,13367,'2','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001198083',NULL,'364','6','R','5','5132525602',0,'2014-01-05 17:27:19',NULL,NULL),(914,16097,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 03:39:37',NULL,NULL),(134,13088,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000489205',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:05',NULL,NULL),(259,13150,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000971449',NULL,'93','2','R','5','7403459654',0,'2014-01-05 16:57:34',NULL,NULL),(898,14492,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001180994',NULL,'875','3','R','I5','028',0,'2014-01-13 03:04:02',NULL,NULL),(184,13113,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000146846',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:15',NULL,NULL),(698,13370,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000257108',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:27',NULL,NULL),(327,13184,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000809647',NULL,'364','4','R','5','4194784361',0,'2014-01-05 16:59:08',NULL,NULL),(455,13248,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000479812',NULL,'93','2','R','5','6145967429',0,'2014-01-05 17:02:07',NULL,NULL),(743,14414,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078730',NULL,'93','2','R','5','5133513768',0,'2014-01-13 03:02:26',NULL,NULL),(333,13187,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000369984',NULL,'93','2','R','5','2164033462',0,'2014-01-05 16:59:17',NULL,NULL),(597,13319,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001090877',NULL,'93','2','R','5','5138465353',0,'2014-01-05 17:25:05',NULL,NULL),(335,13188,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'93','2','R','5','6146196044',0,'2014-01-05 16:59:20',NULL,NULL),(218,13130,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000078730',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:02',NULL,NULL),(254,13148,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000280804',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:28',NULL,NULL),(607,13324,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000276240',NULL,'93','2','R','5','4199089073',0,'2014-01-05 17:25:19',NULL,NULL),(67,13054,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000353936',NULL,'93','2','R','5','2164018177',0,'2014-01-05 16:51:32',NULL,NULL),(89,13065,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000874673',NULL,'93','2','R','5','2169064763',0,'2014-01-05 16:52:02',NULL,NULL),(99,13070,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000678071',NULL,'93','2','R','5','4404978103',0,'2014-01-05 16:52:16',NULL,NULL),(44,13043,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000637079',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:01',NULL,NULL),(1131,16260,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:30:02',NULL,NULL),(772,14429,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000137530',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:40',NULL,NULL),(1011,16169,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:17:10',NULL,NULL),(82,13062,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000067657',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:54',NULL,NULL),(703,13372,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001020392',NULL,'93','2','R','5','5137421671',0,'2014-01-05 17:27:33',NULL,NULL),(551,13296,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000271405',NULL,'93','2','R','5','6148435765',0,'2014-01-05 17:24:01',NULL,NULL),(684,13363,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000969424',NULL,'875','3','R','I5','028',0,'2014-01-05 17:27:08',NULL,NULL),(1119,16250,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000740233',NULL,'310','6','R','4','39007',0,'2014-01-23 07:05:59',NULL,NULL),(567,13304,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000866852',NULL,'93','2','R','I5','5134007013',0,'2014-01-05 17:24:24',NULL,NULL),(867,14476,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001081759',NULL,'364','4','R','5','rob.bermingham@gmail.com',0,'2014-01-13 03:03:48',NULL,NULL),(610,13326,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000287064',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:25',NULL,NULL),(775,14430,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957878',NULL,'93','2','R','5','4192607434',0,'2014-01-13 03:02:41',NULL,NULL),(1139,16267,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:30:03',NULL,NULL),(463,13252,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001169407',NULL,'93','2','R','I5','3304142197',0,'2014-01-05 17:02:18',NULL,NULL),(721,14403,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000443432',NULL,'93','2','R','5','5133206656',0,'2014-01-13 03:02:17',NULL,NULL),(21,13031,'I10','DMG','62',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230361',NULL,'93','2','R','I5','4073610387',0,'2014-01-05 16:50:29',NULL,NULL),(887,14486,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001004310',NULL,'93','2','R','5','5138276723',0,'2014-01-13 03:03:57',NULL,NULL),(847,14466,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000336406',NULL,'93','2','R','5','5139850010',0,'2014-01-13 03:03:39',NULL,NULL),(55,13048,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000921890',NULL,'310','6','R','5','39151',0,'2014-01-05 16:51:15',NULL,NULL),(827,14456,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000053025',NULL,'93','2','R','5','9372986375',0,'2014-01-13 03:03:30',NULL,NULL),(167,13104,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000571965',NULL,'93','2','R','5','7404274077',0,'2014-01-05 16:53:50',NULL,NULL),(822,14454,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000214617',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:28',NULL,NULL),(1082,16221,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',0,'2014-01-23 05:30:14',NULL,NULL),(1090,16228,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:39:34',NULL,NULL),(189,13115,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950650',NULL,'364','4','R','5','4196293307',0,'2014-01-05 16:54:21',NULL,NULL),(228,13135,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000299209',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:19',NULL,NULL),(383,13212,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000639499',NULL,'93','2','R','I5','6142862357',0,'2014-01-05 17:00:26',NULL,NULL),(485,13263,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000141468',NULL,'93','2','R','5','3304683072',0,'2014-01-05 17:02:49',NULL,NULL),(545,13293,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631491',NULL,'93','2','R','5','2162213529',0,'2014-01-05 17:23:53',NULL,NULL),(571,13306,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000296758',NULL,'93','2','R','5','4404299541',0,'2014-01-05 17:24:29',NULL,NULL),(1102,16236,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:41:48',NULL,NULL),(288,13165,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000103849',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:15',NULL,NULL),(903,16091,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 03:39:20',NULL,NULL),(1088,16226,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:38:52',NULL,NULL),(14,13028,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000258128',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:20',NULL,NULL),(750,14418,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001119925',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:30',NULL,NULL),(841,14463,'I10','PER','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001053027',NULL,'93','2','R','I5','7406535809',0,'2014-01-13 03:03:36',NULL,NULL),(128,13085,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000912924',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:57',NULL,NULL),(1046,16196,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:45:33',NULL,NULL),(127,13084,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000453874',NULL,'93','2','R','5','9378371734',0,'2014-01-05 16:52:55',NULL,NULL),(716,14401,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001062083',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:15',NULL,NULL),(860,14473,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000610839',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:45',NULL,NULL),(108,13075,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762255',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:29',NULL,NULL),(326,13184,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000809647',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:08',NULL,NULL),(364,13203,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001153597',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:01',NULL,NULL),(718,14402,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000258128',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:16',NULL,NULL),(1056,16204,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:52:41',NULL,NULL),(386,13214,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000067657',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:32',NULL,NULL),(798,14442,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000034346',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:13',NULL,NULL),(872,14479,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000587954',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:51',NULL,NULL),(187,13114,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000247876',NULL,'93','2','R','5','9372511555',0,'2014-01-05 16:54:18',NULL,NULL),(215,13128,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000242670',NULL,'93','2','R','5','2166514730',0,'2014-01-05 16:54:57',NULL,NULL),(495,13268,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000551401',NULL,'93','2','R','5','5138840218',0,'2014-01-05 17:22:43',NULL,NULL),(793,14439,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000103849',NULL,'93','2','R','5','3309573056',0,'2014-01-13 03:03:11',NULL,NULL),(1033,16184,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000159382',NULL,'310','6','R','4','39007',1,'2014-01-23 04:25:25',NULL,NULL),(78,13060,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631491',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:48',NULL,NULL),(1118,16250,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 07:05:59',NULL,NULL),(385,13213,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001256010',NULL,'93','2','R','5','5135034270',0,'2014-01-05 17:00:29',NULL,NULL),(707,13374,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780485',NULL,'364','4','R','5','julieerudd@gmail.com',0,'2014-01-05 17:27:39',NULL,NULL),(1057,16204,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:52:41',NULL,NULL),(1134,16263,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:00:02',NULL,NULL),(121,13081,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000880486',NULL,'93','2','R','5','4407242560',0,'2014-01-05 16:52:46',NULL,NULL),(132,13087,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239104',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:02',NULL,NULL),(565,13303,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000039780',NULL,'93','2','R','5','5136526760',0,'2014-01-05 17:24:21',NULL,NULL),(17,13029,'I10','DMG','93',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186069',NULL,'93','2','R','5','5136735241',0,'2014-01-05 16:50:23',NULL,NULL),(814,14450,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000983805',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:24',NULL,NULL),(283,13162,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277258',NULL,'93','2','R','5','5139261369',0,'2014-01-05 16:58:07',NULL,NULL),(839,14462,'I10','DMG','62',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230361',NULL,'93','2','R','I5','4073610387',0,'2014-01-13 03:03:35',NULL,NULL),(1010,16168,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:16:56',NULL,NULL),(1067,16211,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:02:13',NULL,NULL),(543,13292,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001217346',NULL,'93','2','R','5','5134600782',0,'2014-01-05 17:23:50',NULL,NULL),(894,14490,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000038347',NULL,'875','3','R','I5','028',0,'2014-01-13 03:04:01',NULL,NULL),(945,16116,'I10','DMG','125',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000449829',NULL,'310','6','R','4','39005',1,'2014-01-23 03:44:47',NULL,NULL),(256,13149,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000310840',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:30',NULL,NULL),(594,13318,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000210977',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:02',NULL,NULL),(731,14408,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000847122',NULL,'93','2','R','5','5133681921',0,'2014-01-13 03:02:21',NULL,NULL),(1054,16202,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:51:15',NULL,NULL),(9,13025,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001119925',NULL,'93','2',NULL,NULL,'4402301217',0,'2014-01-05 16:50:12',NULL,NULL),(590,13316,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277250',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:57',NULL,NULL),(905,16092,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',0,'2014-01-23 03:39:32',NULL,NULL),(971,16135,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 03:51:46',NULL,NULL),(570,13306,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000296758',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:29',NULL,NULL),(810,14448,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000828200',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:21',NULL,NULL),(125,13083,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000309426',NULL,'364','4','R','5','quinn4qb@yahoo.com',0,'2014-01-05 16:52:52',NULL,NULL),(504,13273,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000626703',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:57',NULL,NULL),(1053,16201,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:47:53',NULL,NULL),(809,14447,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000701660',NULL,'364','4','R','5','3305947027',0,'2014-01-13 03:03:20',NULL,NULL),(886,14486,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001004310',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:57',NULL,NULL),(1079,16219,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:08:10',NULL,NULL),(849,14467,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000247876',NULL,'93','2','R','5','9372511555',0,'2014-01-13 03:03:40',NULL,NULL),(114,13078,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000891779',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:38',NULL,NULL),(352,13197,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001004310',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:44',NULL,NULL),(996,16155,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:07:06',NULL,NULL),(405,13223,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000639499',NULL,'93','2','R','I5','6142862357',0,'2014-01-05 17:00:57',NULL,NULL),(248,13145,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000995411',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:19',NULL,NULL),(260,13151,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001111632',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:36',NULL,NULL),(586,13314,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001198083',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:51',NULL,NULL),(488,13265,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000227044',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:35',NULL,NULL),(950,16120,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:46:11',NULL,NULL),(1150,16278,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 14:00:02',NULL,NULL),(266,13154,'7','REF','58',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000964594',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:44',NULL,NULL),(858,14472,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000385874',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:44',NULL,NULL),(1154,16282,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 16:00:02',NULL,NULL),(426,13234,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000255936',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:27',NULL,NULL),(461,13251,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000351563',NULL,'93','2','R','5','3308251040',0,'2014-01-05 17:02:15',NULL,NULL),(506,13274,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191308',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:00',NULL,NULL),(697,13369,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000669141',NULL,'93','2','R','5','5133782791',0,'2014-01-05 17:27:25',NULL,NULL),(53,13047,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239085',NULL,'93','2','R','5','3305192292',0,'2014-01-05 16:51:13',NULL,NULL),(175,13108,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001192648',NULL,'93','2','R','5','9379129968',0,'2014-01-05 16:54:01',NULL,NULL),(172,13107,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000814273',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:58',NULL,NULL),(353,13197,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001004310',NULL,'93','2','R','5','5138276723',0,'2014-01-05 16:59:45',NULL,NULL),(928,16105,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:56',NULL,NULL),(290,13166,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000173784',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:18',NULL,NULL),(95,13068,'1','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000926232',NULL,'364','4','R','I5','4409673924',0,'2014-01-05 16:52:11',NULL,NULL),(388,13215,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000408442',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:34',NULL,NULL),(868,14477,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000533273',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:49',NULL,NULL),(93,13067,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000038347',NULL,'93','2','R','5','9373673226',0,'2014-01-05 16:52:08',NULL,NULL),(538,13290,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001201870',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:44',NULL,NULL),(595,13318,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000210977',NULL,'364','4','R','5','4409495716',0,'2014-01-05 17:25:03',NULL,NULL),(660,13351,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546441',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:34',NULL,NULL),(843,14464,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000888148',NULL,'93','2','R','5','3302311143',0,'2014-01-13 03:03:37',NULL,NULL),(247,13144,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000121502',NULL,'364','4','R','5','2162262909',0,'2014-01-05 16:57:17',NULL,NULL),(79,13060,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631491',NULL,'93','2','R','5','2162213529',0,'2014-01-05 16:51:48',NULL,NULL),(135,13088,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000489205',NULL,'93','2','R','5','4405709144',0,'2014-01-05 16:53:06',NULL,NULL),(165,13103,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000070277',NULL,'93','2','R','5','9377480060',0,'2014-01-05 16:53:47',NULL,NULL),(234,13138,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000988853',NULL,'875','3','R','I5','028',0,'2014-01-05 16:55:28',NULL,NULL),(296,13169,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000814273',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:26',NULL,NULL),(188,13115,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950650',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:20',NULL,NULL),(759,14422,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000495421',NULL,'364','4','R','5','timdirr@gmail.com',0,'2014-01-13 03:02:34',NULL,NULL),(888,14487,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000192698',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:58',NULL,NULL),(513,13277,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000735003',NULL,'310','6','R','5','39061',0,'2014-01-05 17:23:08',NULL,NULL),(644,13343,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000626703',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:12',NULL,NULL),(1031,16183,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:25:12',NULL,NULL),(732,14409,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000210977',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:22',NULL,NULL),(229,13135,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000299209',NULL,'93','2','R','5','9375729949',0,'2014-01-05 16:55:19',NULL,NULL),(420,13231,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000338853',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:19',NULL,NULL),(501,13271,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000849407',NULL,'364','4','R','5','revreece7@ameritech.net',0,'2014-01-05 17:22:52',NULL,NULL),(935,16110,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:43:33',NULL,NULL),(241,13141,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000483458',NULL,'364','4','R','5','larring1@yahoo.com',0,'2014-01-05 16:57:08',NULL,NULL),(760,14423,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661327',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:34',NULL,NULL),(74,13058,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001016820',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:42',NULL,NULL),(780,14433,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780475',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:44',NULL,NULL),(891,14488,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000323470',NULL,'93','2','R','5','9372702265',0,'2014-01-13 03:03:59',NULL,NULL),(897,14491,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000847122',NULL,'93','2','R','5','5133681921',0,'2014-01-13 03:04:02',NULL,NULL),(441,13241,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000936035',NULL,'364','4','R','5','4196253817',0,'2014-01-05 17:01:47',NULL,NULL),(576,13309,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001111632',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:37',NULL,NULL),(701,13371,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000590760',NULL,'93','2','R','5','9373744790',0,'2014-01-05 17:27:30',NULL,NULL),(970,16135,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:51:46',NULL,NULL),(531,13286,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000988853',NULL,'93','2','R','5','9376455403',0,'2014-01-05 17:23:34',NULL,NULL),(825,14455,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001085583',NULL,'93','2','R','5','5138294806',0,'2014-01-13 03:03:29',NULL,NULL),(1158,16286,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000865825',NULL,'875','3','R','4','028',0,'2014-01-23 18:00:03',NULL,NULL),(1055,16203,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:52:35',NULL,NULL),(741,14413,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000388626',NULL,'93','2','R','5','4407298028',0,'2014-01-13 03:02:25',NULL,NULL),(769,14427,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000425063',NULL,'364','4','R','5','6142053318',0,'2014-01-13 03:02:38',NULL,NULL),(850,14468,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000555333',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:41',NULL,NULL),(893,14489,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000848302',NULL,'93','2','R','5','7407100280',0,'2014-01-13 03:04:00',NULL,NULL),(559,13300,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001135137',NULL,'93','2','R','5','5132901897',0,'2014-01-05 17:24:13',NULL,NULL),(10,13026,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000780475',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:14',NULL,NULL),(484,13263,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000141468',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:48',NULL,NULL),(906,16093,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000009809',NULL,'875','3','R','4','028',0,'2014-01-23 03:39:34',NULL,NULL),(1151,16279,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 14:30:02',NULL,NULL),(418,13230,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000759673',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:16',NULL,NULL),(424,13233,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000353936',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:25',NULL,NULL),(746,14416,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001207127',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:28',NULL,NULL),(840,14463,'7','REF','58',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001053027',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:36',NULL,NULL),(955,16124,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:47:36',NULL,NULL),(302,13172,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000053025',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:35',NULL,NULL),(372,13207,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001245575',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:12',NULL,NULL),(462,13252,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001169407',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:17',NULL,NULL),(617,13329,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000425063',NULL,'364','4','R','5','6142053318',0,'2014-01-05 17:25:33',NULL,NULL),(1130,16259,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:22:15',NULL,NULL),(90,13066,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546449',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:05',NULL,NULL),(328,13185,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000921890',NULL,'875','3','R','I5','028',0,'2014-01-05 16:59:11',NULL,NULL),(683,13362,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000222372',NULL,'364','4','R','5','5138752120',0,'2014-01-05 17:27:05',NULL,NULL),(848,14467,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000247876',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:40',NULL,NULL),(1147,16275,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 12:30:03',NULL,NULL),(155,13098,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000051897',NULL,'93','2','R','5','9374340530',0,'2014-01-05 16:53:33',NULL,NULL),(518,13280,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001105502',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:16',NULL,NULL),(1045,16195,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000428999',NULL,'310','6','R','4','39007',1,'2014-01-23 04:35:25',NULL,NULL),(1101,16235,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:41:42',NULL,NULL),(1155,16283,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 16:30:02',NULL,NULL),(35,13038,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000954272',NULL,'364','4','R','5','5135091363',0,'2014-01-05 16:50:48',NULL,NULL),(301,13171,'I10','NM1','16',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000223675',NULL,'310','6','R','5','39061',0,'2014-01-05 16:58:32',NULL,NULL),(695,13368,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001149851',NULL,'93','2','R','5','3307531659',0,'2014-01-05 17:27:22',NULL,NULL),(735,14410,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000422797',NULL,'93','2','R','5','4196052409',0,'2014-01-13 03:02:23',NULL,NULL),(118,13080,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006959',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:43',NULL,NULL),(373,13207,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001245575',NULL,'364','4','R','5','5138516917',0,'2014-01-05 17:00:12',NULL,NULL),(438,13240,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001103416',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:44',NULL,NULL),(522,13282,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000939750',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:22',NULL,NULL),(830,14458,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001115909',NULL,'875','3','R','5','028',0,'2014-01-13 03:03:31',NULL,NULL),(924,16103,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:41:36',NULL,NULL),(264,13153,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000610839',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:42',NULL,NULL),(657,13349,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000133293',NULL,'93','2','R','I5','5135209019',0,'2014-01-05 17:26:29',NULL,NULL),(1104,16237,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:42:09',NULL,NULL),(904,16092,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 03:39:32',NULL,NULL),(925,16103,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000802547',NULL,'310','6','R','4','39153',1,'2014-01-23 03:41:36',NULL,NULL),(1007,16165,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:14:30',NULL,NULL),(65,13053,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000314668',NULL,'93','2','R','5','3308477768',0,'2014-01-05 16:51:29',NULL,NULL),(540,13291,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000329623',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:47',NULL,NULL),(917,16098,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000006946',NULL,'310','6','R','I5','39007',0,'2014-01-23 03:39:38',NULL,NULL),(946,16117,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:45:04',NULL,NULL),(478,13260,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661325',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:40',NULL,NULL),(881,14483,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000287064',NULL,'93','2','R','5','3309907936',0,'2014-01-13 03:03:55',NULL,NULL),(68,13055,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000957886',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:34',NULL,NULL),(752,14419,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546441',NULL,'875','3','R','I5','028',0,'2014-01-13 03:02:31',NULL,NULL),(159,13100,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000930892',NULL,'364','4','R','5','max5031@zoomtown.com',0,'2014-01-05 16:53:39',NULL,NULL),(221,13131,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000495421',NULL,'364','4','R','5','timdirr@gmail.com',0,'2014-01-05 16:55:06',NULL,NULL),(761,14423,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661327',NULL,'93','2','R','5','5135038460',0,'2014-01-13 03:02:35',NULL,NULL),(75,13058,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001016820',NULL,'93','2','R','5','4408779797',0,'2014-01-05 16:51:43',NULL,NULL),(202,13122,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000960566',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:40',NULL,NULL),(507,13274,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001191308',NULL,'93','2','R','5','2163741569',0,'2014-01-05 17:23:00',NULL,NULL),(864,14475,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001218525',NULL,'875','3','R','I5','028',0,'2014-01-13 03:03:47',NULL,NULL),(38,13040,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000212143',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:53',NULL,NULL),(384,13213,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001256010',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:29',NULL,NULL),(972,16136,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:51:52',NULL,NULL),(474,13258,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000727244',NULL,'875','3','R','I5','028',0,'2014-01-05 17:02:34',NULL,NULL),(87,13064,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000030530',NULL,'93','2','R','5','9378300732',0,'2014-01-05 16:52:00',NULL,NULL),(106,13074,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000891779',NULL,'875','3','R','I5','028',0,'2014-01-05 16:52:27',NULL,NULL),(285,13163,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000713595',NULL,'93','2','R','5','3306855010',0,'2014-01-05 16:58:10',NULL,NULL),(999,16157,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:08:17',NULL,NULL),(268,13155,'7','REF','9',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000209588',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:47',NULL,NULL),(282,13162,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000277258',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:07',NULL,NULL),(183,13112,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162559',NULL,'93','2','R','5','6143307111',0,'2014-01-05 16:54:12',NULL,NULL),(408,13225,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000762244',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:02',NULL,NULL),(1122,16252,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',0,'2014-01-23 07:06:40',NULL,NULL),(416,13229,'7','REF','119',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001169407',NULL,'875','3','R','I5','028',0,'2014-01-05 17:01:13',NULL,NULL),(351,13196,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000186093',NULL,'364','4','R','5','DonDurbin@neo.rr.com',0,'2014-01-05 16:59:42',NULL,NULL),(791,14438,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000662667',NULL,'93','2','R','5','5134883944',0,'2014-01-13 03:03:10',NULL,NULL),(313,13177,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000571965',NULL,'93','2','R','5','7404274077',0,'2014-01-05 16:58:49',NULL,NULL),(606,13324,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000276240',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:19',NULL,NULL),(908,16094,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000009809',NULL,'875','3','R','4','028',0,'2014-01-23 03:39:35',NULL,NULL),(162,13102,'7','REF','150',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000385874',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:44',NULL,NULL),(544,13293,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000631491',NULL,'875','3','R','I5','028',0,'2014-01-05 17:23:53',NULL,NULL),(1050,16198,'I10','NM1','48',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0001204493',NULL,'310','6','R','4','39133',1,'2014-01-23 04:45:47',NULL,NULL),(646,13344,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001024258',NULL,'875','3','R','I5','028',0,'2014-01-05 17:26:15',NULL,NULL),(733,14409,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000210977',NULL,'364','4','R','5','4409495716',0,'2014-01-13 03:02:22',NULL,NULL),(1032,16184,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:25:25',NULL,NULL),(467,13254,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000242670',NULL,'93','2','R','5','2166514730',0,'2014-01-05 17:02:23',NULL,NULL),(1028,16180,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:21:17',NULL,NULL),(1085,16224,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:30:02',NULL,NULL),(19,13030,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000950650',NULL,'364','4','R','5','4196293307',0,'2014-01-05 16:50:26',NULL,NULL),(278,13160,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000936035',NULL,'875','3','R','I5','028',0,'2014-01-05 16:58:01',NULL,NULL),(566,13304,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000866852',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:23',NULL,NULL),(995,16154,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:07:00',NULL,NULL),(33,13037,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001103416',NULL,'93','2','R','5','7404382237',0,'2014-01-05 16:50:45',NULL,NULL),(60,13051,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239085',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:23',NULL,NULL),(251,13146,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000661327',NULL,'93','2','R','5','5135038460',0,'2014-01-05 16:57:22',NULL,NULL),(502,13272,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230358',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:22:54',NULL,NULL),(947,16118,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:45:43',NULL,NULL),(944,16116,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:44:47',NULL,NULL),(170,13106,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001178163',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:55',NULL,NULL),(196,13119,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001105502',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:31',NULL,NULL),(512,13277,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000735003',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:08',NULL,NULL),(325,13183,'1','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000121502',NULL,'364','4','R','5','2162262909',0,'2014-01-05 16:59:06',NULL,NULL),(1145,16273,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 11:30:03',NULL,NULL),(982,16144,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:56:42',NULL,NULL),(625,13333,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001062083',NULL,'93','2','R','5','2164477716',0,'2014-01-05 17:25:45',NULL,NULL),(227,13134,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000874673',NULL,'93','2','R','5','2169064763',0,'2014-01-05 16:55:15',NULL,NULL),(577,13309,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001111632',NULL,'93','2','R','5','4404099049',0,'2014-01-05 17:24:38',NULL,NULL),(249,13145,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000995411',NULL,'93','2','R','5','2162124469',0,'2014-01-05 16:57:20',NULL,NULL),(361,13201,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000299209',NULL,'93','2','R','5','9375729949',0,'2014-01-05 16:59:56',NULL,NULL),(174,13108,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001192648',NULL,'875','3','R','I5','028',0,'2014-01-05 16:54:01',NULL,NULL),(59,13050,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000790837',NULL,'93','2','R','5','4407147551',0,'2014-01-05 16:51:21',NULL,NULL),(948,16119,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:45:54',NULL,NULL),(499,13270,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000191356',NULL,'93','2','R','5','7405910523',0,'2014-01-05 17:22:49',NULL,NULL),(667,13354,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000329623',NULL,'93','2','R','5','6142660889',0,'2014-01-05 17:26:43',NULL,NULL),(1137,16266,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 09:28:28',NULL,NULL),(753,14419,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000546441',NULL,'93','2','R','5','4408583641',0,'2014-01-13 03:02:31',NULL,NULL),(1078,16218,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 05:06:59',NULL,NULL),(902,16090,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 03:38:41',NULL,NULL),(883,14484,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000717807',NULL,'93','2','R','5','2342179008',0,'2014-01-13 03:03:55',NULL,NULL),(974,16137,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 03:52:37',NULL,NULL),(1017,16172,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:17:38',NULL,NULL),(564,13303,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000039780',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:20',NULL,NULL),(835,14460,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000411077',NULL,'364','4','R','5','7407337678',0,'2014-01-13 03:03:33',NULL,NULL),(1098,16233,'7','REF','57',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000578790',NULL,'875','3','R','I5','028',0,'2014-01-23 06:40:46',NULL,NULL),(524,13283,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000555333',NULL,'875','3',NULL,NULL,'028',0,'2014-01-05 17:23:25',NULL,NULL),(1015,16171,'I10','DMG','63',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000772610',NULL,'310','6','R','4','39005',1,'2014-01-23 04:17:33',NULL,NULL),(144,13093,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000717807',NULL,'875','3','R','I5','028',0,'2014-01-05 16:53:19',NULL,NULL),(339,13190,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000504449',NULL,'93','2','R','5','6148060734',0,'2014-01-05 16:59:25',NULL,NULL),(1080,16220,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 05:30:02',NULL,NULL),(783,14434,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001018205',NULL,'364','4','R','5','kateingradschool@gmail.com',0,'2014-01-13 03:03:06',NULL,NULL),(1024,16178,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',1,'2014-01-23 04:21:04',NULL,NULL),(1108,16241,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 06:45:45',NULL,NULL),(376,13209,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000255936',NULL,'875','3','R','I5','028',0,'2014-01-05 17:00:18',NULL,NULL),(387,13214,'1','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000067657',NULL,'364','4','R','5','4404667936',0,'2014-01-05 17:00:32',NULL,NULL),(413,13227,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000371465',NULL,'93','2','R','5','7343010089',0,'2014-01-05 17:01:08',NULL,NULL),(596,13319,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001090877',NULL,'875','3','R','I5','028',0,'2014-01-05 17:25:05',NULL,NULL),(26,13034,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000471000',NULL,'875','3','R','I5','028',0,'2014-01-05 16:50:36',NULL,NULL),(70,13056,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000828200',NULL,'875','3','R','I5','028',0,'2014-01-05 16:51:37',NULL,NULL),(1012,16169,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000159382',NULL,'310','6','R','4','39007',1,'2014-01-23 04:17:11',NULL,NULL),(1091,16228,'I10','NM1','15',2100,'3',NULL,'SUBSCRIBER NUMBER REF02:0000869255',NULL,'310','6','R','4','39005',0,'2014-01-23 06:39:34',NULL,NULL),(262,13152,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000212143',NULL,'875','3','R','I5','028',0,'2014-01-05 16:57:39',NULL,NULL),(580,13311,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0001090877',NULL,'875','3','R','I5','028',0,'2014-01-05 17:24:43',NULL,NULL),(747,14416,'I10','N4','13',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001207127',NULL,'93','2','R','5','6143251529',0,'2014-01-13 03:02:28',NULL,NULL),(1128,16257,'7','REF','8',2000,'8',NULL,'SUBSCRIBER NUMBER REF02:0000260472',NULL,'875','3','R','5','028',0,'2014-01-23 08:00:02',NULL,NULL),(61,13051,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001239085',NULL,'93','2','R','5','3305192292',0,'2014-01-05 16:51:24',NULL,NULL),(403,13222,'I10','PER','60',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0000604701',NULL,'93','2','R','I5','6143543021',0,'2014-01-05 17:00:54',NULL,NULL),(445,13243,'I10','PER','11',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001230358',NULL,'93','2','R','5','3306099029',0,'2014-01-05 17:01:53',NULL,NULL),(575,13308,'I10','PER','12',2100,'8',NULL,'SUBSCRIBER NUMBER REF02:0001162559',NULL,'93','2','R','5','6143307111',0,'2014-01-05 17:24:35',NULL,NULL);
/*!40000 ALTER TABLE `Edi999` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiFunctionalGroup`
--

DROP TABLE IF EXISTS `EdiFunctionalGroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiFunctionalGroup` (
  `EdiFunctionalGroupId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiProcessingId` bigint(64) NOT NULL,
  `StandardVersion` varchar(45) NOT NULL COMMENT 'Example 005010X220A1',
  `TransactionType` varchar(10) NOT NULL COMMENT 'Example:  BE',
  `Sender` varchar(10) NOT NULL COMMENT 'Example TX0  Which is TX (Texas) and a 0',
  `Receiver1st5` varchar(5) NOT NULL COMMENT 'Receiver1st5 is the 1st 5 characters\nStarmount   18575,33348,46300\nHixEnroll  99734\nSummaCare  52664\nHealthSpan  92036\n',
  `Receiver` varchar(20) NOT NULL COMMENT 'Example:  33348TX0020002 contains all the digits including the 1st 5 digits',
  `GroupDate` date NOT NULL,
  `GroupTime` time NOT NULL COMMENT 'Example 18:04',
  `ControlNumber` varchar(10) NOT NULL COMMENT 'Example:  44819',
  `ResponsibleAgency` varchar(50) NOT NULL COMMENT 'Example X',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiFunctionalGroupId`),
  KEY `EDIFunctionalGroupRefEdiProcessing_fk_idx` (`EdiProcessingId`)
) ENGINE=innodb AUTO_INCREMENT=4483 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiFunctionalGroup`
--

LOCK TABLES `EdiFunctionalGroup` WRITE;
/*!40000 ALTER TABLE `EdiFunctionalGroup` DISABLE KEYS */;
INSERT INTO `EdiFunctionalGroup` VALUES (3108,2760,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-28','18:32:00','160259','X',0,'2014-01-28 21:01:20',NULL,NULL),(1415,93,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-24','01:56:00','90951','X',0,'2013-12-26 13:11:27',NULL,NULL),(2524,1576,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-13','18:44:00','134000','X',0,'2014-01-14 01:33:17',NULL,NULL),(3708,2804,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-16','18:12:00','201501','X',0,'2014-02-16 19:00:13',NULL,NULL),(4174,2836,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-03','18:33:00','236070','X',0,'2014-03-03 21:29:58',NULL,NULL),(4470,2855,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-03-10','19:23:00','255946','X',0,'2014-03-10 21:03:02',NULL,NULL),(1,1,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-05','18:31:00','54176','X',0,'2013-12-25 17:15:01',NULL,NULL),(182,13,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-03','18:20:00','49888','X',0,'2013-12-25 18:19:07',NULL,NULL),(634,40,'005010X220A1','BE','OH0','92036','92036OH0060008','2013-12-12','18:53:00','67254','X',0,'2013-12-25 22:08:00',NULL,NULL),(789,49,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-06','18:03:00','20428','X',0,'2013-12-25 23:16:51',NULL,NULL),(870,52,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-01','18:08:00','46317','X',0,'2013-12-26 00:02:21',NULL,NULL),(1722,569,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-01-03','18:38:00','116021','X',0,'2014-01-04 02:06:02',NULL,NULL),(3578,2797,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-13','18:41:00','192640','X',0,'2014-02-13 21:30:16',NULL,NULL),(4289,2847,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-03-06','18:51:00','245589','X',0,'2014-03-06 21:02:32',NULL,NULL),(203,13,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-03','18:20:00','49909','X',0,'2013-12-25 18:21:34',NULL,NULL),(794,49,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-06','18:03:00','20431','X',0,'2013-12-25 23:17:07',NULL,NULL),(915,56,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-10-16','20:51:00','10068','X',0,'2013-12-26 00:31:08',NULL,NULL),(1100,69,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-11-23','18:05:00','36690','X',0,'2013-12-26 02:16:29',NULL,NULL),(1184,75,'005010X220A1','BE','MI0','92036','92036OH0060005','2013-12-20','19:06:00','84226','X',0,'2013-12-26 03:09:46',NULL,NULL),(1317,82,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-21','18:37:00','86531','X',0,'2013-12-26 04:39:17',NULL,NULL),(2329,1474,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-09','18:28:00','127869','X',0,'2014-01-13 02:20:53',NULL,NULL),(2359,1475,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-08','18:27:00','125995','X',0,'2014-01-13 02:22:45',NULL,NULL),(2624,2540,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-16','18:41:00','141400','X',0,'2014-01-17 03:35:28',NULL,NULL),(3149,2773,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-30','18:35:00','164070','X',0,'2014-01-30 21:01:02',NULL,NULL),(3232,2776,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-02','18:10:00','168381','X',0,'2014-02-02 19:00:33',NULL,NULL),(3343,2782,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-02-06','18:28:00','176000','X',0,'2014-02-06 21:01:51',NULL,NULL),(58,4,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-11','18:01:00','7634','X',0,'2013-12-25 17:31:46',NULL,NULL),(120,7,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-16','18:37:00','74933','X',0,'2013-12-25 18:07:19',NULL,NULL),(678,41,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-08','18:10:00','59435','X',0,'2013-12-25 22:17:27',NULL,NULL),(910,56,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-16','20:51:00','10062','X',0,'2013-12-26 00:30:47',NULL,NULL),(1039,66,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-03','18:02:00','17820','X',0,'2013-12-26 01:32:12',NULL,NULL),(3435,2790,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-10','05:02:00','183708','X',0,'2014-02-10 11:01:07',NULL,NULL),(3799,2811,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-19','18:35:00','207800','X',0,'2014-02-20 04:49:42',NULL,NULL),(514,37,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-22','18:40:00','88475','X',0,'2013-12-25 21:22:26',NULL,NULL),(533,37,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-22','18:40:00','88494','X',0,'2013-12-25 21:23:35',NULL,NULL),(1710,569,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-03','18:38:00','116009','X',0,'2014-01-04 02:04:43',NULL,NULL),(2067,1314,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:56',NULL,NULL),(2196,1443,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:36',NULL,NULL),(2288,1471,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-07','18:29:00','123286','X',0,'2014-01-08 18:25:04',NULL,NULL),(2415,1478,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-12','18:13:00','132599','X',0,'2014-01-13 03:01:54',NULL,NULL),(3809,2811,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-19','18:35:00','207804','X',0,'2014-02-20 04:54:30',NULL,NULL),(3902,2818,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-25','18:33:00','219098','X',0,'2014-02-25 21:00:32',NULL,NULL),(4384,2852,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-08','18:43:00','250656','X',0,'2014-03-08 21:30:39',NULL,NULL),(141,7,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-16','18:37:00','74954','X',0,'2013-12-25 18:08:44',NULL,NULL),(865,52,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-01','18:08:00','46312','X',0,'2013-12-26 00:01:30',NULL,NULL),(1714,569,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-03','18:38:00','116013','X',0,'2014-01-04 02:05:13',NULL,NULL),(4145,2833,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-02','18:16:00','233964','X',0,'2014-03-03 01:00:12',NULL,NULL),(425,29,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-06','18:21:00','55535','X',0,'2013-12-25 20:19:21',NULL,NULL),(3231,2776,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-02','18:10:00','168380','X',0,'2014-02-02 19:00:32',NULL,NULL),(3427,2790,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-10','05:02:00','183700','X',0,'2014-02-10 11:00:47',NULL,NULL),(4349,2850,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-07','18:46:00','247664','X',0,'2014-03-07 21:31:57',NULL,NULL),(210,14,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-29','18:04:00','43703','X',0,'2013-12-25 18:30:42',NULL,NULL),(620,40,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-12','18:53:00','67240','X',0,'2013-12-25 22:04:46',NULL,NULL),(661,41,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-08','18:10:00','59418','X',0,'2013-12-25 22:16:25',NULL,NULL),(845,51,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-24','03:40:00','94584','X',0,'2013-12-25 23:51:43',NULL,NULL),(2599,2539,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-15','18:30:00','138461','X',0,'2014-01-16 08:46:55',NULL,NULL),(2940,2715,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:00:00','1','X',0,'2014-01-23 07:05:11',NULL,NULL),(2951,2726,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:48:00','1','X',0,'2014-01-23 08:22:15',NULL,NULL),(3258,2778,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-04','18:29:00','172100','X',0,'2014-02-04 21:00:04',NULL,NULL),(3736,2807,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-18','18:25:00','203030','X',0,'2014-02-18 21:30:11',NULL,NULL),(3946,2821,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-24','18:19:00','217103','X',0,'2014-02-26 08:00:35',NULL,NULL),(4206,2843,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-04','18:50:00','238753','X',0,'2014-03-04 21:01:55',NULL,NULL),(4371,2850,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-07','18:46:00','247686','X',0,'2014-03-07 21:32:26',NULL,NULL),(231,16,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-10-25','18:01:00','13421','X',0,'2013-12-25 18:32:10',NULL,NULL),(1457,99,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-26','18:41:00','100547','X',0,'2013-12-27 02:04:59',NULL,NULL),(1596,385,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-30','19:01:00','109543','X',0,'2014-01-01 12:08:19',NULL,NULL),(2061,1308,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:39',NULL,NULL),(2418,1478,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-01-12','18:13:00','132602','X',0,'2014-01-13 03:01:59',NULL,NULL),(2518,1576,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-13','18:44:00','133994','X',0,'2014-01-14 01:32:15',NULL,NULL),(2805,2580,'005010X231A1','FA','OH0','52664','52664OH1520009','2014-01-15','22:50:00','1','X',1,'2014-01-23 03:44:35',NULL,NULL),(3279,2778,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-04','18:29:00','172121','X',0,'2014-02-04 21:01:54',NULL,NULL),(3984,2824,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-24','18:21:00','218496','X',0,'2014-02-26 09:30:53',NULL,NULL),(4116,2831,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-01','18:21:00','230734','X',0,'2014-03-01 19:00:08',NULL,NULL),(916,56,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-16','20:51:00','10069','X',0,'2013-12-26 00:31:11',NULL,NULL),(2161,1408,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:58',NULL,NULL),(2215,1462,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:29',NULL,NULL),(2351,1475,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-08','18:27:00','125987','X',0,'2014-01-13 02:22:26',NULL,NULL),(2712,2554,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-20','18:21:00','146891','X',0,'2014-01-21 08:46:09',NULL,NULL),(3843,2814,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-20','18:28:00','208910','X',0,'2014-02-20 22:00:45',NULL,NULL),(4257,2846,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-03-05','18:49:00','241591','X',0,'2014-03-05 21:32:18',NULL,NULL),(92,6,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-04','18:22:00','52140','X',0,'2013-12-25 17:50:47',NULL,NULL),(585,39,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-17','18:43:00','78034','X',0,'2013-12-25 21:49:14',NULL,NULL),(2094,1341,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:11',NULL,NULL),(2099,1346,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:25',NULL,NULL),(2681,2552,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-18','18:11:00','144579','X',0,'2014-01-21 08:44:21',NULL,NULL),(2953,2728,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:42:00','1','X',0,'2014-01-23 08:38:31',NULL,NULL),(3436,2790,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-10','05:02:00','183709','X',0,'2014-02-10 11:01:09',NULL,NULL),(3612,2798,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-13','18:46:00','194335','X',0,'2014-02-13 22:03:14',NULL,NULL),(1133,71,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-15','18:15:00','73624','X',0,'2013-12-26 02:33:59',NULL,NULL),(1144,72,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-11-17','18:03:00','29573','X',0,'2013-12-26 02:45:59',NULL,NULL),(1470,99,'005010X220A1','BE','OH0','92036','92036OH0010005','2013-12-26','18:41:00','100560','X',0,'2013-12-27 02:07:08',NULL,NULL),(2187,1434,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:11',NULL,NULL),(2217,1464,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:35',NULL,NULL),(2224,1468,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-06','18:24:00','121970','X',0,'2014-01-07 04:02:46',NULL,NULL),(2429,1488,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:21',NULL,NULL),(2663,2551,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-17','18:23:00','142629','X',0,'2014-01-20 08:06:29',NULL,NULL),(2778,2556,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-22','18:31:00','150819','X',0,'2014-01-23 03:02:52',NULL,NULL),(2866,2641,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:39:00','1','X',1,'2014-01-23 04:17:57',NULL,NULL),(2916,2691,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:07:00','1','X',0,'2014-01-23 06:30:02',NULL,NULL),(146,8,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-31','18:04:00','15471','X',0,'2013-12-25 18:09:41',NULL,NULL),(1240,80,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-18','18:49:00','79070','X',0,'2013-12-26 04:06:34',NULL,NULL),(1310,82,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-21','18:37:00','86518','X',0,'2013-12-26 04:38:39',NULL,NULL),(1609,385,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-30','19:01:00','109556','X',0,'2014-01-01 12:09:13',NULL,NULL),(1670,568,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-02','18:42:00','115194','X',0,'2014-01-03 02:00:03',NULL,NULL),(1964,1211,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','12:25:00','1','X',0,'2014-01-05 16:54:33',NULL,NULL),(2307,1473,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-11','18:16:00','130864','X',0,'2014-01-13 02:18:40',NULL,NULL),(2325,1474,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-09','18:28:00','127865','X',0,'2014-01-13 02:20:44',NULL,NULL),(2507,1566,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:57',NULL,NULL),(3205,2775,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-01','18:14:00','166674','X',0,'2014-02-01 19:00:32',NULL,NULL),(3632,2799,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-14','18:39:00','196125','X',0,'2014-02-14 21:31:37',NULL,NULL),(3694,2802,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-15','18:48:00','199886','X',0,'2014-02-15 22:02:03',NULL,NULL),(3724,2806,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-17','18:05:00','202221','X',0,'2014-02-17 19:00:05',NULL,NULL),(3878,2816,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-21','18:31:00','212806','X',0,'2014-02-21 22:01:03',NULL,NULL),(1213,76,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-11-22','18:08:00','35667','X',0,'2013-12-26 03:16:17',NULL,NULL),(2250,1468,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-06','18:24:00','121997','X',0,'2014-01-07 04:06:48',NULL,NULL),(2534,1576,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-01-13','18:44:00','134010','X',0,'2014-01-14 01:33:44',NULL,NULL),(2537,1576,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-01-13','18:44:00','134013','X',0,'2014-01-14 01:33:47',NULL,NULL),(2550,2311,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-14','19:00:00','136107','X',0,'2014-01-15 02:06:00',NULL,NULL),(2654,2551,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-17','18:23:00','142620','X',0,'2014-01-20 08:05:33',NULL,NULL),(3030,2756,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-01-24','18:26:00','154311','X',0,'2014-01-24 21:01:17',NULL,NULL),(3056,2758,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-26','18:09:00','156596','X',0,'2014-01-26 19:00:27',NULL,NULL),(3401,2788,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-09','18:12:00','181781','X',0,'2014-02-09 19:00:05',NULL,NULL),(3828,2812,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-19','18:32:00','206167','X',0,'2014-02-20 05:39:53',NULL,NULL),(3890,2817,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-22','18:14:00','214242','X',0,'2014-02-22 19:00:14',NULL,NULL),(4308,2847,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-03-06','18:51:00','245609','X',0,'2014-03-06 21:02:57',NULL,NULL),(354,22,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-09','18:28:00','61524','X',0,'2013-12-25 19:37:54',NULL,NULL),(627,40,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-12','18:53:00','67247','X',0,'2013-12-25 22:06:23',NULL,NULL),(1309,82,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-21','18:37:00','86516','X',0,'2013-12-26 04:38:18',NULL,NULL),(2336,1474,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-09','18:28:00','127876','X',0,'2014-01-13 02:21:00',NULL,NULL),(2629,2540,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-16','18:41:00','141405','X',0,'2014-01-17 03:35:53',NULL,NULL),(3503,2793,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-11','18:41:00','189057','X',0,'2014-02-11 21:02:35',NULL,NULL),(4454,2855,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-10','19:23:00','255929','X',0,'2014-03-10 21:02:32',NULL,NULL),(790,49,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-06','18:03:00','20430','X',0,'2013-12-25 23:16:54',NULL,NULL),(803,50,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-26','18:20:00','40528','X',0,'2013-12-25 23:31:37',NULL,NULL),(1044,67,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-25','18:35:00','98926','X',0,'2013-12-26 01:49:37',NULL,NULL),(1111,71,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-15','18:15:00','73602','X',0,'2013-12-26 02:30:54',NULL,NULL),(3377,2786,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-08','18:12:00','180289','X',0,'2014-02-08 19:00:15',NULL,NULL),(3652,2799,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-14','18:39:00','196145','X',0,'2014-02-14 21:32:22',NULL,NULL),(3653,2799,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-14','18:39:00','196146','X',0,'2014-02-14 21:32:22',NULL,NULL),(3907,2819,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-25','18:36:00','220679','X',0,'2014-02-25 21:30:32',NULL,NULL),(4341,2850,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-07','18:46:00','247656','X',0,'2014-03-07 21:30:37',NULL,NULL),(204,14,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-29','18:04:00','43692','X',0,'2013-12-25 18:30:01',NULL,NULL),(224,16,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-25','18:01:00','13417','X',0,'2013-12-25 18:31:50',NULL,NULL),(1666,387,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-31','18:52:00','111705','X',1,'2014-01-02 04:36:05',NULL,NULL),(1880,1127,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:50:41',NULL,NULL),(2713,2554,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-20','18:21:00','146892','X',0,'2014-01-21 08:46:16',NULL,NULL),(3462,2792,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-10','18:30:00','186448','X',0,'2014-02-10 21:31:29',NULL,NULL),(246,19,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-24','18:40:00','96807','X',0,'2013-12-25 18:53:53',NULL,NULL),(815,50,'005010X220A1','BE','OH0','92036','92036OH0020008','2013-11-26','18:20:00','40540','X',0,'2013-12-25 23:32:46',NULL,NULL),(1129,71,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-15','18:15:00','73620','X',0,'2013-12-26 02:33:50',NULL,NULL),(1519,381,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-28','18:14:00','103711','X',1,'2013-12-29 11:08:19',NULL,NULL),(1630,386,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-01','18:18:00','112815','X',1,'2014-01-02 04:25:25',NULL,NULL),(2110,1357,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:36',NULL,NULL),(2895,2670,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 04:52:35',NULL,NULL),(3288,2780,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-05','18:36:00','173081','X',0,'2014-02-05 21:00:05',NULL,NULL),(3508,2793,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-11','18:41:00','189062','X',0,'2014-02-11 21:02:44',NULL,NULL),(243,19,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-24','18:40:00','96804','X',0,'2013-12-25 18:47:59',NULL,NULL),(439,29,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-06','18:21:00','55549','X',0,'2013-12-25 20:20:14',NULL,NULL),(496,35,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-28','18:02:00','42790','X',0,'2013-12-25 20:47:01',NULL,NULL),(745,47,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-19','19:11:00','81731','X',0,'2013-12-25 23:09:00',NULL,NULL),(900,54,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-02','18:00:00','5089','X',0,'2013-12-26 00:17:08',NULL,NULL),(940,59,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-11','18:36:00','64773','X',0,'2013-12-26 00:48:51',NULL,NULL),(1069,68,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-14','18:21:00','71338','X',0,'2013-12-26 02:00:38',NULL,NULL),(1429,93,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-24','01:56:00','90965','X',0,'2013-12-26 13:15:05',NULL,NULL),(1680,568,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-02','18:42:00','115204','X',0,'2014-01-03 02:05:37',NULL,NULL),(2443,1502,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:33',NULL,NULL),(3516,2793,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-11','18:41:00','189070','X',0,'2014-02-11 21:02:54',NULL,NULL),(3767,2808,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-18','18:28:00','204282','X',0,'2014-02-18 22:01:43',NULL,NULL),(4007,2825,'005010X220A1','BE','OH0','92036','92036OH0010012','2014-02-26','18:43:00','223762','X',0,'2014-02-26 21:02:23',NULL,NULL),(601,39,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-17','18:43:00','78050','X',0,'2013-12-25 21:52:55',NULL,NULL),(616,40,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-12','18:53:00','67236','X',0,'2013-12-25 22:01:56',NULL,NULL),(1708,569,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-03','18:38:00','116007','X',0,'2014-01-04 02:04:32',NULL,NULL),(2028,1275,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:07',NULL,NULL),(3285,2779,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-04','18:26:00','170960','X',0,'2014-02-04 21:30:02',NULL,NULL),(3470,2792,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-10','18:30:00','186456','X',0,'2014-02-10 21:32:00',NULL,NULL),(3517,2793,'005010X220A1','BE','WI0','92036','92036OH0060027','2014-02-11','18:41:00','189071','X',0,'2014-02-11 21:02:54',NULL,NULL),(88,6,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-04','18:22:00','52136','X',0,'2013-12-25 17:50:30',NULL,NULL),(913,56,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-16','20:51:00','10064','X',0,'2013-12-26 00:31:02',NULL,NULL),(2136,1383,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:49',NULL,NULL),(2502,1561,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:52',NULL,NULL),(1674,568,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-02','18:42:00','115198','X',0,'2014-01-03 02:04:25',NULL,NULL),(2508,1567,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:58',NULL,NULL),(3808,2810,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-19','18:35:00','207803','X',0,'2014-02-20 04:53:48',NULL,NULL),(3886,2816,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-21','18:31:00','212814','X',0,'2014-02-21 22:01:17',NULL,NULL),(4002,2825,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-26','18:43:00','223757','X',0,'2014-02-26 21:02:07',NULL,NULL),(4346,2850,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-07','18:46:00','247661','X',0,'2014-03-07 21:31:41',NULL,NULL),(208,14,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-29','18:04:00','43700','X',0,'2013-12-25 18:30:37',NULL,NULL),(284,20,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-20','18:06:00','32808','X',0,'2013-12-25 19:02:22',NULL,NULL),(360,23,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-02','18:14:00','47676','X',0,'2013-12-25 19:45:02',NULL,NULL),(399,26,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-02','18:03:00','17177','X',0,'2013-12-25 20:01:11',NULL,NULL),(1518,381,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-28','18:14:00','103710','X',1,'2013-12-29 11:08:17',NULL,NULL),(2091,1338,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:03',NULL,NULL),(2324,1474,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-09','18:28:00','127864','X',0,'2014-01-13 02:20:43',NULL,NULL),(2562,2311,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-14','19:00:00','136119','X',0,'2014-01-15 02:07:50',NULL,NULL),(3344,2782,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-02-06','18:28:00','176001','X',0,'2014-02-06 21:01:52',NULL,NULL),(3431,2790,'005010X220A1','BE','OH0','92036','92036OH0020008','2014-02-10','05:02:00','183704','X',0,'2014-02-10 11:00:59',NULL,NULL),(12,1,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-05','18:31:00','54187','X',0,'2013-12-25 17:20:03',NULL,NULL),(493,35,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-28','18:02:00','42793','X',0,'2013-12-25 20:46:52',NULL,NULL),(855,51,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-24','03:40:00','94595','X',0,'2013-12-25 23:52:10',NULL,NULL),(1474,99,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-26','18:41:00','100564','X',0,'2013-12-27 02:07:27',NULL,NULL),(2455,1514,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:06',NULL,NULL),(2852,2627,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:35:00','1','X',1,'2014-01-23 04:10:00',NULL,NULL),(3992,2824,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-24','18:21:00','218504','X',0,'2014-02-26 09:31:07',NULL,NULL),(4103,2830,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-28','19:12:00','229921','X',0,'2014-02-28 21:31:49',NULL,NULL),(2378,1477,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-10','18:26:00','129733','X',0,'2014-01-13 03:00:18',NULL,NULL),(2471,1530,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:24',NULL,NULL),(2910,2685,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:40:00','1','X',1,'2014-01-23 05:06:59',NULL,NULL),(3178,2774,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-31','18:37:00','165920','X',0,'2014-01-31 21:01:07',NULL,NULL),(3860,2814,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-02-20','18:28:00','208927','X',0,'2014-02-20 22:01:41',NULL,NULL),(4085,2829,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-28','19:08:00','228400','X',0,'2014-02-28 21:00:27',NULL,NULL),(4221,2843,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-03-04','18:50:00','238768','X',0,'2014-03-04 21:02:39',NULL,NULL),(25,1,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-05','18:31:00','54200','X',0,'2013-12-25 17:21:30',NULL,NULL),(550,38,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-13','18:39:00','69276','X',0,'2013-12-25 21:36:59',NULL,NULL),(1942,1189,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:32',NULL,NULL),(2566,2311,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-14','19:00:00','136123','X',0,'2014-01-15 02:07:54',NULL,NULL),(3634,2799,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-14','18:39:00','196127','X',0,'2014-02-14 21:31:41',NULL,NULL),(3720,2804,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-16','18:12:00','201514','X',0,'2014-02-16 19:00:43',NULL,NULL),(295,21,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-10','18:21:00','62744','X',0,'2013-12-25 19:18:20',NULL,NULL),(494,35,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-28','18:02:00','42800','X',0,'2013-12-25 20:46:57',NULL,NULL),(1341,84,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-21','18:04:00','11683','X',0,'2013-12-26 05:00:02',NULL,NULL),(1638,387,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-31','18:52:00','111677','X',1,'2014-01-02 04:30:06',NULL,NULL),(2143,1390,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:08',NULL,NULL),(2283,1471,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-07','18:29:00','123281','X',0,'2014-01-08 18:25:00',NULL,NULL),(2615,2539,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-15','18:30:00','138477','X',0,'2014-01-16 08:47:24',NULL,NULL),(2893,2668,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:45:00','1','X',1,'2014-01-23 04:47:53',NULL,NULL),(3395,2787,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-08','18:12:00','180826','X',0,'2014-02-08 19:30:02',NULL,NULL),(3425,2790,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-10','05:02:00','183698','X',0,'2014-02-10 11:00:41',NULL,NULL),(1881,1128,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:44',NULL,NULL),(2574,2311,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-14','19:00:00','136131','X',0,'2014-01-15 02:08:06',NULL,NULL),(2576,2311,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-14','19:00:00','136133','X',0,'2014-01-15 02:08:07',NULL,NULL),(2970,2745,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:28:00','1','X',0,'2014-01-23 14:00:02',NULL,NULL),(3931,2820,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-23','18:10:00','215477','X',0,'2014-02-26 08:00:08',NULL,NULL),(286,20,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-11-20','18:06:00','32810','X',0,'2013-12-25 19:02:32',NULL,NULL),(380,23,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-02','18:14:00','47696','X',0,'2013-12-25 19:50:06',NULL,NULL),(833,51,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-24','03:40:00','94572','X',0,'2013-12-25 23:49:59',NULL,NULL),(1212,76,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-11-22','18:08:00','35666','X',0,'2013-12-26 03:16:15',NULL,NULL),(1258,80,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-18','18:49:00','79088','X',0,'2013-12-26 04:09:34',NULL,NULL),(1531,381,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-28','18:14:00','103723','X',1,'2013-12-29 11:10:11',NULL,NULL),(2253,1469,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-05','18:09:00','119787','X',1,'2014-01-07 10:21:11',NULL,NULL),(2356,1475,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-08','18:27:00','125992','X',0,'2014-01-13 02:22:37',NULL,NULL),(2410,1478,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-12','18:13:00','132594','X',0,'2014-01-13 03:01:49',NULL,NULL),(3211,2775,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-01','18:14:00','166680','X',0,'2014-02-01 19:00:46',NULL,NULL),(238,19,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-24','18:40:00','96799','X',0,'2013-12-25 18:45:02',NULL,NULL),(244,19,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-24','18:40:00','96805','X',0,'2013-12-25 18:50:28',NULL,NULL),(411,28,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-08','18:00:00','6875','X',0,'2013-12-25 20:02:16',NULL,NULL),(1278,80,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-18','18:49:00','79108','X',0,'2013-12-26 04:10:49',NULL,NULL),(1629,386,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-01','18:18:00','112814','X',1,'2014-01-02 04:25:19',NULL,NULL),(2139,1386,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:57',NULL,NULL),(2968,2743,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:57:00','1','X',0,'2014-01-23 13:00:02',NULL,NULL),(3899,2818,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-25','18:33:00','219095','X',0,'2014-02-25 21:00:30',NULL,NULL),(4146,2833,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-02','18:16:00','233965','X',0,'2014-03-03 01:00:20',NULL,NULL),(7,1,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-05','18:31:00','54182','X',0,'2013-12-25 17:18:26',NULL,NULL),(614,39,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-17','18:43:00','78064','X',0,'2013-12-25 21:53:45',NULL,NULL),(1618,386,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-01','18:18:00','112803','X',1,'2014-01-02 04:22:38',NULL,NULL),(2315,1474,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-09','18:28:00','127855','X',0,'2014-01-13 02:20:02',NULL,NULL),(2397,1477,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-01-10','18:26:00','129752','X',0,'2014-01-13 03:00:43',NULL,NULL),(2846,2621,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:21:00','1','X',1,'2014-01-23 04:07:00',NULL,NULL),(510,37,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-22','18:40:00','88470','X',0,'2013-12-25 21:21:12',NULL,NULL),(973,60,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-12','18:03:00','24205','X',0,'2013-12-26 01:00:16',NULL,NULL),(984,61,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-11-16','18:03:00','28399','X',0,'2013-12-26 01:01:17',NULL,NULL),(1999,1246,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','18:10:00','1','X',0,'2014-01-05 16:57:46',NULL,NULL),(2209,1456,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:12',NULL,NULL),(2289,1471,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-07','18:29:00','123287','X',0,'2014-01-08 18:25:05',NULL,NULL),(2548,2311,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-14','19:00:00','136105','X',0,'2014-01-15 02:05:50',NULL,NULL),(3141,2772,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-29','18:30:00','161363','X',0,'2014-01-29 21:01:55',NULL,NULL),(3228,2776,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-02','18:10:00','168377','X',0,'2014-02-02 19:00:30',NULL,NULL),(3869,2815,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-21','18:28:00','211315','X',0,'2014-02-21 21:30:24',NULL,NULL),(4178,2836,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-03','18:33:00','236074','X',0,'2014-03-03 21:30:36',NULL,NULL),(28,1,'005010X220A1','BE','OH0','92036','92036OH0040032','2013-12-05','18:31:00','54203','X',0,'2013-12-25 17:21:51',NULL,NULL),(69,6,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-04','18:22:00','52117','X',0,'2013-12-25 17:45:03',NULL,NULL),(230,16,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-10-25','18:01:00','13416','X',0,'2013-12-25 18:32:07',NULL,NULL),(470,32,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-10-03','18:00:00','5202','X',0,'2013-12-25 20:32:13',NULL,NULL),(609,39,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-17','18:43:00','78058','X',0,'2013-12-25 21:53:30',NULL,NULL),(1949,1196,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:51',NULL,NULL),(2000,1247,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:49',NULL,NULL),(2326,1474,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-09','18:28:00','127866','X',0,'2014-01-13 02:20:45',NULL,NULL),(4430,2854,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-09','18:21:00','252850','X',0,'2014-03-09 21:30:02',NULL,NULL),(36,2,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-10-12','18:01:00','7920','X',0,'2013-12-25 17:30:15',NULL,NULL),(440,29,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-06','18:21:00','55550','X',0,'2013-12-25 20:20:17',NULL,NULL),(1096,69,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-23','18:05:00','36686','X',0,'2013-12-26 02:16:13',NULL,NULL),(1123,71,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-15','18:15:00','73614','X',0,'2013-12-26 02:33:24',NULL,NULL),(1529,381,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-28','18:14:00','103721','X',1,'2013-12-29 11:10:06',NULL,NULL),(2278,1471,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-07','18:29:00','123276','X',0,'2014-01-08 18:24:57',NULL,NULL),(2628,2540,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-16','18:41:00','141404','X',0,'2014-01-17 03:35:52',NULL,NULL),(3135,2772,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-29','18:30:00','161357','X',0,'2014-01-29 21:01:48',NULL,NULL),(3189,2774,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-31','18:37:00','165931','X',0,'2014-01-31 21:01:38',NULL,NULL),(3307,2781,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-02-05','18:39:00','174417','X',0,'2014-02-05 21:31:12',NULL,NULL),(3819,2811,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-19','18:35:00','207809','X',0,'2014-02-20 04:56:28',NULL,NULL),(4120,2831,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-01','18:21:00','230738','X',0,'2014-03-01 19:00:13',NULL,NULL),(104,7,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-16','18:37:00','74917','X',0,'2013-12-25 18:02:53',NULL,NULL),(3520,2794,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-11','18:37:00','187464','X',0,'2014-02-11 21:30:10',NULL,NULL),(712,46,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-07','18:13:00','57430','X',0,'2013-12-25 22:45:14',NULL,NULL),(1601,385,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-30','19:01:00','109548','X',0,'2014-01-01 12:08:44',NULL,NULL),(2023,1270,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:53',NULL,NULL),(2424,1483,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:16',NULL,NULL),(3972,2824,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-24','18:21:00','218484','X',0,'2014-02-26 09:30:02',NULL,NULL),(899,54,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-02','18:00:00','5091','X',0,'2013-12-26 00:17:04',NULL,NULL),(2242,1468,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-06','18:24:00','121988','X',0,'2014-01-07 04:06:18',NULL,NULL),(2577,2311,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-14','19:00:00','136134','X',0,'2014-01-15 02:08:08',NULL,NULL),(2799,2574,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:52:00','1','X',1,'2014-01-23 03:42:30',NULL,NULL),(3624,2799,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-14','18:39:00','196117','X',0,'2014-02-14 21:30:52',NULL,NULL),(3926,2819,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-25','18:36:00','220698','X',0,'2014-02-25 21:32:07',NULL,NULL),(3936,2820,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-23','18:10:00','215482','X',0,'2014-02-26 08:00:22',NULL,NULL),(4010,2825,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-26','18:43:00','223765','X',0,'2014-02-26 21:02:36',NULL,NULL),(4170,2835,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-03','18:31:00','234705','X',0,'2014-03-03 21:00:22',NULL,NULL),(831,51,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-24','03:40:00','94570','X',0,'2013-12-25 23:49:18',NULL,NULL),(1062,67,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-25','18:35:00','98944','X',0,'2013-12-26 01:52:36',NULL,NULL),(1450,93,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-24','01:56:00','90988','X',0,'2013-12-26 13:17:02',NULL,NULL),(1682,568,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-02','18:42:00','115206','X',0,'2014-01-03 02:05:46',NULL,NULL),(2360,1475,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-08','18:27:00','125996','X',0,'2014-01-13 02:22:46',NULL,NULL),(2393,1477,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-01-10','18:26:00','129748','X',0,'2014-01-13 03:00:38',NULL,NULL),(2721,2554,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-20','18:21:00','146900','X',0,'2014-01-21 08:46:43',NULL,NULL),(4046,2826,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-27','18:48:00','225940','X',0,'2014-02-28 06:31:45',NULL,NULL),(4065,2828,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-27','18:43:00','224649','X',0,'2014-02-28 07:30:14',NULL,NULL),(4291,2847,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-03-06','18:51:00','245591','X',0,'2014-03-06 21:02:34',NULL,NULL),(85,6,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-04','18:22:00','52133','X',0,'2013-12-25 17:50:17',NULL,NULL),(181,13,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-03','18:20:00','49887','X',0,'2013-12-25 18:18:05',NULL,NULL),(619,40,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-12','18:53:00','67239','X',0,'2013-12-25 22:04:26',NULL,NULL),(1038,66,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-03','18:02:00','17826','X',0,'2013-12-26 01:32:10',NULL,NULL),(1040,67,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-25','18:35:00','98922','X',0,'2013-12-26 01:45:02',NULL,NULL),(1255,80,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-18','18:49:00','79085','X',0,'2013-12-26 04:09:05',NULL,NULL),(2130,1377,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:32',NULL,NULL),(2642,2540,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-16','18:41:00','141418','X',0,'2014-01-17 03:36:35',NULL,NULL),(3194,2774,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-31','18:37:00','165936','X',0,'2014-01-31 21:01:43',NULL,NULL),(3798,2810,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-19','18:35:00','207800','X',0,'2014-02-20 04:49:42',NULL,NULL),(157,8,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-10-31','18:04:00','15482','X',0,'2013-12-25 18:10:27',NULL,NULL),(666,41,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-08','18:10:00','59423','X',0,'2013-12-25 22:16:54',NULL,NULL),(768,47,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-19','19:11:00','81754','X',0,'2013-12-25 23:11:20',NULL,NULL),(3317,2781,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-05','18:39:00','174427','X',0,'2014-02-05 21:31:19',NULL,NULL),(3618,2798,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-13','18:46:00','194341','X',0,'2014-02-13 22:03:20',NULL,NULL),(3915,2819,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-25','18:36:00','220687','X',0,'2014-02-25 21:31:43',NULL,NULL),(4052,2826,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-27','18:48:00','225946','X',0,'2014-02-28 06:31:49',NULL,NULL),(54,3,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-11-13','18:04:00','25396','X',0,'2013-12-25 17:31:31',NULL,NULL),(369,23,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-02','18:14:00','47685','X',0,'2013-12-25 19:48:58',NULL,NULL),(1073,68,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-14','18:21:00','71342','X',0,'2013-12-26 02:02:42',NULL,NULL),(1285,81,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-30','18:04:00','44825','X',0,'2013-12-26 04:15:51',NULL,NULL),(2687,2552,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-18','18:11:00','144585','X',0,'2014-01-21 08:44:41',NULL,NULL),(2963,2738,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:12:00','1','X',0,'2014-01-23 10:30:02',NULL,NULL),(3365,2784,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-07','18:14:00','177574','X',0,'2014-02-07 19:01:03',NULL,NULL),(3389,2786,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-08','18:12:00','180301','X',0,'2014-02-08 19:00:57',NULL,NULL),(3482,2792,'005010X220A1','BE','OH0','92036','92036OH0010012','2014-02-10','18:30:00','186468','X',0,'2014-02-10 21:32:17',NULL,NULL),(4176,2836,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-03','18:33:00','236072','X',0,'2014-03-03 21:30:11',NULL,NULL),(1115,71,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-15','18:15:00','73606','X',0,'2013-12-26 02:32:26',NULL,NULL),(1729,569,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-03','18:38:00','116028','X',0,'2014-01-04 02:06:22',NULL,NULL),(2494,1553,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:45',NULL,NULL),(2730,2554,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-20','18:21:00','146909','X',0,'2014-01-21 08:46:56',NULL,NULL),(3685,2802,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-15','18:48:00','199876','X',0,'2014-02-15 22:01:55',NULL,NULL),(3745,2807,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-18','18:25:00','203039','X',0,'2014-02-18 21:30:23',NULL,NULL),(4082,2829,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-28','19:08:00','228397','X',0,'2014-02-28 21:00:21',NULL,NULL),(124,7,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-16','18:37:00','74937','X',0,'2013-12-25 18:07:40',NULL,NULL),(156,8,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-10-31','18:04:00','15481','X',0,'2013-12-25 18:10:23',NULL,NULL),(1410,93,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-24','01:56:00','90946','X',0,'2013-12-26 13:07:57',NULL,NULL),(3223,2776,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-02','18:10:00','168372','X',0,'2014-02-02 19:00:26',NULL,NULL),(4110,2830,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-28','19:12:00','229928','X',0,'2014-02-28 21:31:55',NULL,NULL),(253,19,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-24','18:40:00','96814','X',0,'2013-12-25 18:56:45',NULL,NULL),(294,21,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-10','18:21:00','62743','X',0,'2013-12-25 19:18:13',NULL,NULL),(427,29,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-06','18:21:00','55537','X',0,'2013-12-25 20:19:36',NULL,NULL),(2840,2615,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:55:00','1','X',1,'2014-01-23 04:00:32',NULL,NULL),(161,9,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-11','18:02:00','23534','X',0,'2013-12-25 18:10:44',NULL,NULL),(396,25,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-24','18:02:00','37695','X',0,'2013-12-25 20:00:53',NULL,NULL),(119,7,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-16','18:37:00','74932','X',0,'2013-12-25 18:07:14',NULL,NULL),(2678,2552,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-18','18:11:00','144576','X',0,'2014-01-21 08:44:18',NULL,NULL),(4030,2826,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-27','18:48:00','225924','X',0,'2014-02-28 06:31:17',NULL,NULL),(1704,569,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-03','18:38:00','116003','X',0,'2014-01-04 02:01:46',NULL,NULL),(2006,1253,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:06',NULL,NULL),(3082,2759,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-27','18:27:00','158022','X',0,'2014-01-27 21:01:45',NULL,NULL),(3085,2759,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-27','18:27:00','158025','X',0,'2014-01-27 21:01:48',NULL,NULL),(699,44,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-04','18:00:00','5515','X',0,'2013-12-25 22:31:32',NULL,NULL),(778,48,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-27','18:05:00','41578','X',0,'2013-12-25 23:16:05',NULL,NULL),(854,51,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-24','03:40:00','94594','X',0,'2013-12-25 23:52:07',NULL,NULL),(869,52,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-01','18:08:00','46316','X',0,'2013-12-26 00:02:20',NULL,NULL),(1120,71,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-15','18:15:00','73611','X',0,'2013-12-26 02:33:13',NULL,NULL),(1127,71,'005010X220A1','BE','OH0','92036','92036OH0010027','2013-12-15','18:15:00','73618','X',0,'2013-12-26 02:33:43',NULL,NULL),(1913,1160,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:12',NULL,NULL),(3034,2757,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-25','18:11:00','155335','X',0,'2014-01-25 19:00:02',NULL,NULL),(3185,2774,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-31','18:37:00','165927','X',0,'2014-01-31 21:01:32',NULL,NULL),(3206,2775,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-01','18:14:00','166675','X',0,'2014-02-01 19:00:41',NULL,NULL),(3839,2813,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-20','18:26:00','208225','X',0,'2014-02-20 21:30:23',NULL,NULL),(3969,2823,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-22','18:14:00','213813','X',0,'2014-02-26 08:30:55',NULL,NULL),(4118,2831,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-01','18:21:00','230736','X',0,'2014-03-01 19:00:11',NULL,NULL),(200,13,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-03','18:20:00','49906','X',0,'2013-12-25 18:21:27',NULL,NULL),(207,14,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-29','18:04:00','43698','X',0,'2013-12-25 18:30:22',NULL,NULL),(414,29,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-06','18:21:00','55524','X',0,'2013-12-25 20:16:32',NULL,NULL),(604,39,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-17','18:43:00','78053','X',0,'2013-12-25 21:53:06',NULL,NULL),(618,40,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-12','18:53:00','67238','X',0,'2013-12-25 22:04:23',NULL,NULL),(795,49,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-06','18:03:00','20425','X',0,'2013-12-25 23:17:09',NULL,NULL),(1661,387,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-31','18:52:00','111700','X',1,'2014-01-02 04:35:46',NULL,NULL),(2404,1478,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-12','18:13:00','132588','X',0,'2014-01-13 03:01:28',NULL,NULL),(3616,2798,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-02-13','18:46:00','194339','X',0,'2014-02-13 22:03:18',NULL,NULL),(3698,2802,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-15','18:48:00','199890','X',0,'2014-02-15 22:02:09',NULL,NULL),(4042,2826,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-27','18:48:00','225936','X',0,'2014-02-28 06:31:41',NULL,NULL),(8,1,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-05','18:31:00','54183','X',0,'2013-12-25 17:18:55',NULL,NULL),(160,9,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-11','18:02:00','23533','X',0,'2013-12-25 18:10:35',NULL,NULL),(2435,1494,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','12:25:00','1','X',0,'2014-01-13 03:02:26',NULL,NULL),(2845,2620,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:00:00','1','X',1,'2014-01-23 04:06:53',NULL,NULL),(3216,2776,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-02','18:10:00','168365','X',0,'2014-02-02 19:00:03',NULL,NULL),(3691,2802,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-15','18:48:00','199883','X',0,'2014-02-15 22:02:00',NULL,NULL),(3865,2815,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-21','18:28:00','211311','X',0,'2014-02-21 21:30:15',NULL,NULL),(3880,2816,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-21','18:31:00','212808','X',0,'2014-02-21 22:01:07',NULL,NULL),(4173,2835,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-03','18:31:00','234708','X',0,'2014-03-03 21:00:26',NULL,NULL),(392,25,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-24','18:02:00','37693','X',0,'2013-12-25 20:00:24',NULL,NULL),(1178,75,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-20','19:06:00','84215','X',0,'2013-12-26 03:08:44',NULL,NULL),(1479,99,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-26','18:41:00','100569','X',0,'2013-12-27 02:07:43',NULL,NULL),(1652,387,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-31','18:52:00','111691','X',1,'2014-01-02 04:34:57',NULL,NULL),(2260,1469,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-05','18:09:00','119794','X',1,'2014-01-07 10:22:43',NULL,NULL),(2744,2555,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-21','18:24:00','147879','X',1,'2014-01-22 03:22:54',NULL,NULL),(3430,2790,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-10','05:02:00','183703','X',0,'2014-02-10 11:00:58',NULL,NULL),(3494,2793,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-11','18:41:00','189048','X',0,'2014-02-11 21:02:12',NULL,NULL),(3604,2798,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-13','18:46:00','194327','X',0,'2014-02-13 22:03:04',NULL,NULL),(3659,2800,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-14','18:36:00','195037','X',0,'2014-02-14 22:00:03',NULL,NULL),(357,22,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-09','18:28:00','61527','X',0,'2013-12-25 19:38:05',NULL,NULL),(554,38,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-13','18:39:00','69280','X',0,'2013-12-25 21:37:28',NULL,NULL),(919,57,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-19','18:07:00','31308','X',0,'2013-12-26 00:31:25',NULL,NULL),(1066,67,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-25','18:35:00','98948','X',0,'2013-12-26 01:52:45',NULL,NULL),(1174,75,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-20','19:06:00','84211','X',0,'2013-12-26 03:07:21',NULL,NULL),(1922,1169,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:37',NULL,NULL),(2022,1269,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:50',NULL,NULL),(2649,2540,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-16','18:41:00','141425','X',0,'2014-01-17 03:36:40',NULL,NULL),(2841,2616,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:48:00','1','X',1,'2014-01-23 04:01:11',NULL,NULL),(2989,2755,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-23','18:27:00','151585','X',0,'2014-01-23 21:01:14',NULL,NULL),(3949,2821,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-24','18:19:00','217099','X',0,'2014-02-26 08:00:39',NULL,NULL),(766,47,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-19','19:11:00','81752','X',0,'2013-12-25 23:11:16',NULL,NULL),(1105,70,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-28','18:08:00','14560','X',0,'2013-12-26 02:17:00',NULL,NULL),(1506,380,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-27','18:44:00','101830','X',0,'2013-12-28 03:36:58',NULL,NULL),(1639,387,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-31','18:52:00','111678','X',1,'2014-01-02 04:31:27',NULL,NULL),(2809,2584,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:34:00','1','X',1,'2014-01-23 03:45:04',NULL,NULL),(3212,2775,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-01','18:14:00','166681','X',0,'2014-02-01 19:00:47',NULL,NULL),(3403,2788,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-09','18:12:00','181783','X',0,'2014-02-09 19:00:07',NULL,NULL),(4261,2846,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-05','18:49:00','241595','X',0,'2014-03-05 21:32:25',NULL,NULL),(997,62,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-11-05','18:03:00','19344','X',0,'2013-12-26 01:02:12',NULL,NULL),(2347,1475,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-08','18:27:00','125983','X',0,'2014-01-13 02:22:20',NULL,NULL),(2886,2661,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:19:00','1','X',1,'2014-01-23 04:35:14',NULL,NULL),(3197,2775,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-02-01','18:14:00','166666','X',0,'2014-02-01 19:00:03',NULL,NULL),(4009,2825,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-26','18:43:00','223764','X',0,'2014-02-26 21:02:34',NULL,NULL),(4403,2853,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-09','18:20:00','252248','X',0,'2014-03-09 21:00:07',NULL,NULL),(1132,71,'005010X220A1','BE','OH0','99734','99734OH0050001','2013-12-15','18:15:00','73623','X',0,'2013-12-26 02:33:58',NULL,NULL),(1891,1138,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:11',NULL,NULL),(2227,1468,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-06','18:24:00','121973','X',0,'2014-01-07 04:04:18',NULL,NULL),(2706,2553,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-19','18:08:00','145213','X',0,'2014-01-21 08:45:38',NULL,NULL),(3474,2792,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-10','18:30:00','186460','X',0,'2014-02-10 21:32:05',NULL,NULL),(4086,2829,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-28','19:08:00','228401','X',0,'2014-02-28 21:00:27',NULL,NULL),(178,13,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-03','18:20:00','49884','X',0,'2013-12-25 18:17:43',NULL,NULL),(217,15,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-04','18:02:00','18537','X',0,'2013-12-25 18:31:20',NULL,NULL),(1413,93,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-24','01:56:00','90949','X',0,'2013-12-26 13:09:58',NULL,NULL),(1991,1238,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:24',NULL,NULL),(2657,2551,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-17','18:23:00','142623','X',0,'2014-01-20 08:06:00',NULL,NULL),(1442,93,'005010X220A1','BE','OH0','92036','92036OH0010005','2013-12-24','01:56:00','90980','X',0,'2013-12-26 13:16:35',NULL,NULL),(1650,387,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-31','18:52:00','111689','X',1,'2014-01-02 04:34:51',NULL,NULL),(1887,1134,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:00',NULL,NULL),(2111,1358,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:39',NULL,NULL),(2179,1426,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:49',NULL,NULL),(2321,1474,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-09','18:28:00','127861','X',0,'2014-01-13 02:20:25',NULL,NULL),(3309,2781,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-05','18:39:00','174419','X',0,'2014-02-05 21:31:13',NULL,NULL),(3945,2820,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-23','18:10:00','215491','X',0,'2014-02-26 08:00:34',NULL,NULL),(4095,2830,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-28','19:12:00','229913','X',0,'2014-02-28 21:31:33',NULL,NULL),(153,8,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-31','18:04:00','15478','X',0,'2013-12-25 18:10:15',NULL,NULL),(1125,71,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-15','18:15:00','73616','X',0,'2013-12-26 02:33:32',NULL,NULL),(1177,75,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-20','19:06:00','84214','X',0,'2013-12-26 03:08:40',NULL,NULL),(2029,1276,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:10',NULL,NULL),(3091,2760,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-28','18:32:00','160242','X',0,'2014-01-28 21:00:23',NULL,NULL),(3950,2821,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-24','18:19:00','217106','X',0,'2014-02-26 08:00:44',NULL,NULL),(4333,2849,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-07','18:42:00','246119','X',0,'2014-03-07 21:00:32',NULL,NULL),(77,6,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-04','18:22:00','52125','X',0,'2013-12-25 17:48:36',NULL,NULL),(329,22,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-09','18:28:00','61499','X',0,'2013-12-25 19:34:37',NULL,NULL),(395,25,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-24','18:02:00','37692','X',0,'2013-12-25 20:00:40',NULL,NULL),(603,39,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-17','18:43:00','78052','X',0,'2013-12-25 21:53:01',NULL,NULL),(664,41,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-08','18:10:00','59421','X',0,'2013-12-25 22:16:40',NULL,NULL),(1095,69,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-11-23','18:05:00','36685','X',0,'2013-12-26 02:16:12',NULL,NULL),(1423,93,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-24','01:56:00','90959','X',0,'2013-12-26 13:13:34',NULL,NULL),(4417,2853,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-03-09','18:20:00','252262','X',0,'2014-03-09 21:01:06',NULL,NULL),(345,22,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-09','18:28:00','61515','X',0,'2013-12-25 19:37:31',NULL,NULL),(481,33,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-01','18:03:00','16381','X',0,'2013-12-25 20:45:49',NULL,NULL),(671,41,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-08','18:10:00','59428','X',0,'2013-12-25 22:17:10',NULL,NULL),(2097,1344,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:19',NULL,NULL),(3627,2799,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-14','18:39:00','196120','X',0,'2014-02-14 21:31:14',NULL,NULL),(4119,2831,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-01','18:21:00','230737','X',0,'2014-03-01 19:00:12',NULL,NULL),(4214,2843,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-04','18:50:00','238761','X',0,'2014-03-04 21:02:20',NULL,NULL),(1203,76,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-22','18:08:00','35657','X',0,'2013-12-26 03:15:09',NULL,NULL),(2001,1248,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:57:52',NULL,NULL),(2027,1274,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:04',NULL,NULL),(2357,1475,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-01-08','18:27:00','125993','X',0,'2014-01-13 02:22:41',NULL,NULL),(2375,1477,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-10','18:26:00','129730','X',0,'2014-01-13 03:00:03',NULL,NULL),(2565,2311,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-14','19:00:00','136122','X',0,'2014-01-15 02:07:53',NULL,NULL),(2625,2540,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-16','18:41:00','141401','X',0,'2014-01-17 03:35:42',NULL,NULL),(3055,2758,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-26','18:09:00','156595','X',0,'2014-01-26 19:00:26',NULL,NULL),(3057,2758,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-26','18:09:00','156597','X',0,'2014-01-26 19:00:28',NULL,NULL),(3965,2823,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-22','18:14:00','213807','X',0,'2014-02-26 08:30:51',NULL,NULL),(539,38,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-13','18:39:00','69265','X',0,'2013-12-25 21:30:02',NULL,NULL),(734,47,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-19','19:11:00','81720','X',0,'2013-12-25 23:04:43',NULL,NULL),(931,58,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-07','19:14:00','6699','X',0,'2013-12-26 00:32:18',NULL,NULL),(1083,68,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-14','18:21:00','71352','X',0,'2013-12-26 02:03:55',NULL,NULL),(1871,1118,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:16',NULL,NULL),(3198,2775,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-01','18:14:00','166667','X',0,'2014-02-01 19:00:03',NULL,NULL),(3935,2820,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-23','18:10:00','215481','X',0,'2014-02-26 08:00:20',NULL,NULL),(4062,2827,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-26','18:39:00','222061','X',0,'2014-02-28 07:00:40',NULL,NULL),(4263,2846,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-05','18:49:00','241597','X',0,'2014-03-05 21:32:29',NULL,NULL),(211,14,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-29','18:04:00','43704','X',0,'2013-12-25 18:30:45',NULL,NULL),(714,46,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-07','18:13:00','57432','X',0,'2013-12-25 22:45:56',NULL,NULL),(1218,76,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-11-22','18:08:00','35672','X',0,'2013-12-26 03:16:29',NULL,NULL),(1900,1147,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:36',NULL,NULL),(1959,1206,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:19',NULL,NULL),(2016,1263,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:34',NULL,NULL),(2086,1333,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:49',NULL,NULL),(3126,2772,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-29','18:30:00','161348','X',0,'2014-01-29 21:01:35',NULL,NULL),(3353,2784,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-07','18:14:00','177562','X',0,'2014-02-07 19:00:29',NULL,NULL),(3943,2820,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-23','18:10:00','215489','X',0,'2014-02-26 08:00:31',NULL,NULL),(4080,2829,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-28','19:08:00','228395','X',0,'2014-02-28 21:00:19',NULL,NULL),(192,13,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-03','18:20:00','49898','X',0,'2013-12-25 18:20:57',NULL,NULL),(446,30,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-13','18:01:00','8420','X',0,'2013-12-25 20:30:02',NULL,NULL),(1022,64,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-14','18:05:00','25958','X',0,'2013-12-26 01:30:31',NULL,NULL),(1268,80,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-18','18:49:00','79098','X',0,'2013-12-26 04:10:17',NULL,NULL),(1494,380,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-27','18:44:00','101818','X',0,'2013-12-28 03:35:01',NULL,NULL),(2055,1302,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:22',NULL,NULL),(2297,1473,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-11','18:16:00','130854','X',0,'2014-01-13 02:18:22',NULL,NULL),(2822,2597,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:32:00','1','X',1,'2014-01-23 03:49:40',NULL,NULL),(2872,2647,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',1,'2014-01-23 04:21:16',NULL,NULL),(2941,2716,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:52:00','1','X',0,'2014-01-23 07:05:49',NULL,NULL),(3601,2798,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-13','18:46:00','194324','X',0,'2014-02-13 22:02:50',NULL,NULL),(4352,2850,'005010X220A1','BE','OH0','99734','99734OH0050002','2014-03-07','18:46:00','247667','X',0,'2014-03-07 21:32:00',NULL,NULL),(762,47,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-19','19:11:00','81748','X',0,'2013-12-25 23:10:58',NULL,NULL),(1206,76,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-11-22','18:08:00','35660','X',0,'2013-12-26 03:15:46',NULL,NULL),(2152,1399,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:24:33',NULL,NULL),(3225,2776,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-02','18:10:00','168374','X',0,'2014-02-02 19:00:27',NULL,NULL),(3883,2816,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-21','18:31:00','212811','X',0,'2014-02-21 22:01:12',NULL,NULL),(4448,2855,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-03-10','19:23:00','255923','X',0,'2014-03-10 21:02:18',NULL,NULL),(31,1,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-05','18:31:00','54206','X',0,'2013-12-25 17:21:58',NULL,NULL),(448,30,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-13','18:01:00','8422','X',0,'2013-12-25 20:30:13',NULL,NULL),(685,42,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-08','18:03:00','21241','X',0,'2013-12-25 22:30:34',NULL,NULL),(1434,93,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-24','01:56:00','90977','X',0,'2013-12-26 13:15:48',NULL,NULL),(1683,568,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-02','18:42:00','115207','X',0,'2014-01-03 02:05:56',NULL,NULL),(1735,571,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-04','18:14:00','119137','X',0,'2014-01-05 00:01:30',NULL,NULL),(2669,2551,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-17','18:23:00','142635','X',0,'2014-01-20 08:06:38',NULL,NULL),(2747,2555,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-21','18:24:00','147882','X',1,'2014-01-22 03:22:56',NULL,NULL),(2784,2559,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',0,'2014-01-23 03:39:32',NULL,NULL),(3214,2775,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-01','18:14:00','166683','X',0,'2014-02-01 19:00:50',NULL,NULL),(3219,2776,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-02','18:10:00','168368','X',0,'2014-02-02 19:00:13',NULL,NULL),(3522,2794,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-11','18:37:00','187466','X',0,'2014-02-11 21:30:13',NULL,NULL),(3684,2802,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-15','18:48:00','199875','X',0,'2014-02-15 22:01:51',NULL,NULL),(3852,2814,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-20','18:28:00','208919','X',0,'2014-02-20 22:01:31',NULL,NULL),(2340,1475,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-08','18:27:00','125976','X',0,'2014-01-13 02:21:49',NULL,NULL),(16,1,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-05','18:31:00','54191','X',0,'2013-12-25 17:20:20',NULL,NULL),(1025,64,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-14','18:05:00','25961','X',0,'2013-12-26 01:30:44',NULL,NULL),(1257,80,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-18','18:49:00','79087','X',0,'2013-12-26 04:09:32',NULL,NULL),(1946,1193,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:43',NULL,NULL),(2767,2556,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-22','18:31:00','150808','X',0,'2014-01-23 03:02:15',NULL,NULL),(2960,2735,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:02:00','1','X',0,'2014-01-23 09:45:26',NULL,NULL),(3023,2756,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-24','18:26:00','154303','X',0,'2014-01-24 21:01:10',NULL,NULL),(3505,2793,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-11','18:41:00','189059','X',0,'2014-02-11 21:02:40',NULL,NULL),(273,19,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-24','18:40:00','96834','X',0,'2013-12-25 18:59:19',NULL,NULL),(281,20,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-20','18:06:00','32805','X',0,'2013-12-25 19:00:58',NULL,NULL),(530,37,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-22','18:40:00','88491','X',0,'2013-12-25 21:23:19',NULL,NULL),(863,52,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-01','18:08:00','46310','X',0,'2013-12-26 00:01:24',NULL,NULL),(1029,64,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-11-14','18:05:00','25965','X',0,'2013-12-26 01:31:11',NULL,NULL),(1245,80,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-18','18:49:00','79075','X',0,'2013-12-26 04:08:08',NULL,NULL),(1571,383,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-29','18:10:00','107253','X',0,'2013-12-30 00:02:06',NULL,NULL),(2074,1321,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:15',NULL,NULL),(4004,2825,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-26','18:43:00','223759','X',0,'2014-02-26 21:02:10',NULL,NULL),(4117,2831,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-01','18:21:00','230735','X',0,'2014-03-01 19:00:10',NULL,NULL),(417,29,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-06','18:21:00','55527','X',0,'2013-12-25 20:17:47',NULL,NULL),(482,33,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-01','18:03:00','16382','X',0,'2013-12-25 20:45:51',NULL,NULL),(846,51,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-24','03:40:00','94585','X',0,'2013-12-25 23:51:46',NULL,NULL),(874,52,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-01','18:08:00','46321','X',0,'2013-12-26 00:02:30',NULL,NULL),(1189,75,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-20','19:06:00','84227','X',0,'2013-12-26 03:10:21',NULL,NULL),(2248,1468,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-06','18:24:00','121995','X',0,'2014-01-07 04:06:43',NULL,NULL),(2305,1473,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-11','18:16:00','130862','X',0,'2014-01-13 02:18:38',NULL,NULL),(2331,1474,'005010X220A1','BE','OH0','92036','92036OH0010027','2014-01-09','18:28:00','127871','X',0,'2014-01-13 02:20:56',NULL,NULL),(3200,2775,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-01','18:14:00','166669','X',0,'2014-02-01 19:00:18',NULL,NULL),(3675,2802,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-15','18:48:00','199866','X',0,'2014-02-15 22:00:54',NULL,NULL),(4275,2846,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-05','18:49:00','241609','X',0,'2014-03-05 21:32:45',NULL,NULL),(148,8,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-10-31','18:04:00','15473','X',0,'2013-12-25 18:09:59',NULL,NULL),(557,38,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-13','18:39:00','69283','X',0,'2013-12-25 21:37:44',NULL,NULL),(1303,82,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-21','18:37:00','86505','X',0,'2013-12-26 04:37:10',NULL,NULL),(2267,1469,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-05','18:09:00','119801','X',1,'2014-01-07 10:23:22',NULL,NULL),(2395,1477,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-10','18:26:00','129750','X',0,'2014-01-13 03:00:41',NULL,NULL),(2551,2311,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-14','19:00:00','136108','X',0,'2014-01-15 02:06:23',NULL,NULL),(2690,2552,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-18','18:11:00','144588','X',0,'2014-01-21 08:44:44',NULL,NULL),(52,3,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-11-13','18:04:00','25394','X',0,'2013-12-25 17:31:27',NULL,NULL),(628,40,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-12','18:53:00','67248','X',0,'2013-12-25 22:06:39',NULL,NULL),(1018,64,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-11-14','18:05:00','25954','X',0,'2013-12-26 01:30:02',NULL,NULL),(2063,1310,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:45',NULL,NULL),(3592,2798,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-13','18:46:00','194315','X',0,'2014-02-13 22:02:18',NULL,NULL),(3636,2799,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-14','18:39:00','196129','X',0,'2014-02-14 21:31:48',NULL,NULL),(4133,2832,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-01','18:23:00','232020','X',0,'2014-03-01 21:01:01',NULL,NULL),(41,2,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-12','18:01:00','7925','X',0,'2013-12-25 17:30:31',NULL,NULL),(46,3,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-13','18:04:00','25385','X',0,'2013-12-25 17:30:55',NULL,NULL),(297,21,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-10','18:21:00','62746','X',0,'2013-12-25 19:18:28',NULL,NULL),(546,38,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-13','18:39:00','69272','X',0,'2013-12-25 21:35:44',NULL,NULL),(1744,571,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-04','18:14:00','119146','X',0,'2014-01-05 00:02:42',NULL,NULL),(1904,1151,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:51:47',NULL,NULL),(3103,2760,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-28','18:32:00','160254','X',0,'2014-01-28 21:01:14',NULL,NULL),(4331,2849,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-07','18:42:00','246117','X',0,'2014-03-07 21:00:30',NULL,NULL),(820,50,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-26','18:20:00','40545','X',0,'2013-12-25 23:32:59',NULL,NULL),(1093,69,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-11-23','18:05:00','36683','X',0,'2013-12-26 02:16:06',NULL,NULL),(1349,84,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-10-21','18:04:00','11691','X',0,'2013-12-26 05:01:14',NULL,NULL),(1590,385,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-30','19:01:00','109537','X',0,'2014-01-01 12:07:02',NULL,NULL),(2882,2657,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:09:00','1','X',1,'2014-01-23 04:31:51',NULL,NULL),(3332,2782,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-06','18:28:00','175989','X',0,'2014-02-06 21:01:34',NULL,NULL),(3392,2786,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-08','18:12:00','180304','X',0,'2014-02-08 19:01:00',NULL,NULL),(3655,2799,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-14','18:39:00','196148','X',0,'2014-02-14 21:32:26',NULL,NULL),(3672,2802,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-15','18:48:00','199863','X',0,'2014-02-15 22:00:15',NULL,NULL),(3764,2808,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-18','18:28:00','204278','X',0,'2014-02-18 22:01:36',NULL,NULL),(3858,2814,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-20','18:28:00','208925','X',0,'2014-02-20 22:01:38',NULL,NULL),(751,47,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-19','19:11:00','81737','X',0,'2013-12-25 23:10:01',NULL,NULL),(2818,2593,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:43:00','1','X',1,'2014-01-23 03:47:58',NULL,NULL),(2923,2698,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:03:00','1','X',0,'2014-01-23 06:40:05',NULL,NULL),(3235,2777,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-03','18:32:00','170197','X',0,'2014-02-03 21:00:08',NULL,NULL),(101,6,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-04','18:22:00','52149','X',0,'2013-12-25 17:51:09',NULL,NULL),(421,29,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-06','18:21:00','55531','X',0,'2013-12-25 20:18:43',NULL,NULL),(773,48,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-27','18:05:00','41573','X',0,'2013-12-25 23:15:05',NULL,NULL),(942,59,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-11','18:36:00','64775','X',0,'2013-12-26 00:49:41',NULL,NULL),(969,59,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-11','18:36:00','64802','X',0,'2013-12-26 00:54:19',NULL,NULL),(1020,64,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-14','18:05:00','25956','X',0,'2013-12-26 01:30:10',NULL,NULL),(2020,1267,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:45',NULL,NULL),(2075,1322,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:18',NULL,NULL),(2983,2755,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-23','18:27:00','151579','X',0,'2014-01-23 21:00:31',NULL,NULL),(4097,2830,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-28','19:12:00','229915','X',0,'2014-02-28 21:31:36',NULL,NULL),(4177,2836,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-03','18:33:00','236073','X',0,'2014-03-03 21:30:21',NULL,NULL),(4318,2848,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-06','18:46:00','243739','X',0,'2014-03-06 21:30:22',NULL,NULL),(379,23,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-02','18:14:00','47695','X',0,'2013-12-25 19:50:04',NULL,NULL),(1171,75,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-20','19:06:00','84208','X',0,'2013-12-26 03:05:47',NULL,NULL),(3781,2809,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-19','18:35:00','207793','X',0,'2014-02-20 04:16:27',NULL,NULL),(3983,2824,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-24','18:21:00','218495','X',0,'2014-02-26 09:30:50',NULL,NULL),(4198,2836,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-03','18:33:00','236094','X',0,'2014-03-03 21:31:59',NULL,NULL),(4467,2855,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-10','19:23:00','255942','X',0,'2014-03-10 21:02:55',NULL,NULL),(404,26,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-11-02','18:03:00','17178','X',0,'2013-12-25 20:01:45',NULL,NULL),(1730,570,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-03','19:07:00','117545','X',0,'2014-01-04 06:00:02',NULL,NULL),(1981,1228,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:24',NULL,NULL),(2065,1312,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:50',NULL,NULL),(2162,1409,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:01',NULL,NULL),(2999,2755,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-23','18:27:00','151595','X',0,'2014-01-23 21:01:33',NULL,NULL),(3121,2772,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-29','18:30:00','161343','X',0,'2014-01-29 21:01:20',NULL,NULL),(3677,2802,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-15','18:48:00','199868','X',0,'2014-02-15 22:01:14',NULL,NULL),(4203,2843,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-04','18:50:00','238750','X',0,'2014-03-04 21:01:20',NULL,NULL),(4243,2845,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-05','18:46:00','240511','X',0,'2014-03-05 21:00:26',NULL,NULL),(1549,382,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-28','21:04:00','105805','X',1,'2013-12-29 11:14:52',NULL,NULL),(1993,1240,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:30',NULL,NULL),(2662,2551,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-17','18:23:00','142628','X',0,'2014-01-20 08:06:28',NULL,NULL),(2796,2571,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:33:00','1','X',1,'2014-01-23 03:41:37',NULL,NULL),(3033,2756,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-24','18:26:00','154314','X',0,'2014-01-24 21:01:19',NULL,NULL),(3807,2811,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-19','18:35:00','207803','X',0,'2014-02-20 04:53:36',NULL,NULL),(4444,2855,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-10','19:23:00','255919','X',0,'2014-03-10 21:01:59',NULL,NULL),(535,37,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-22','18:40:00','88496','X',0,'2013-12-25 21:23:40',NULL,NULL),(630,40,'005010X220A1','BE','OH0','92036','92036OH0010032','2013-12-12','18:53:00','67250','X',0,'2013-12-25 22:06:57',NULL,NULL),(985,61,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-11-16','18:03:00','28400','X',0,'2013-12-26 01:01:19',NULL,NULL),(1459,99,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-26','18:41:00','100549','X',0,'2013-12-27 02:05:17',NULL,NULL),(1671,568,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-02','18:42:00','115195','X',0,'2014-01-03 02:00:44',NULL,NULL),(2328,1474,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-09','18:28:00','127868','X',0,'2014-01-13 02:20:52',NULL,NULL),(2330,1474,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-09','18:28:00','127870','X',0,'2014-01-13 02:20:55',NULL,NULL),(2790,2565,'005010X231A1','FA','OH0','52664','52664OH1510013','2014-01-15','23:00:00','1','X',0,'2014-01-23 03:39:38',NULL,NULL),(2810,2585,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:04:00','1','X',1,'2014-01-23 03:45:43',NULL,NULL),(2876,2651,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:21:00','1','X',1,'2014-01-23 04:25:24',NULL,NULL),(2928,2703,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',0,'2014-01-23 06:41:48',NULL,NULL),(3421,2790,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-10','05:02:00','183694','X',0,'2014-02-10 11:00:21',NULL,NULL),(3609,2798,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-13','18:46:00','194332','X',0,'2014-02-13 22:03:11',NULL,NULL),(3881,2816,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-21','18:31:00','212809','X',0,'2014-02-21 22:01:07',NULL,NULL),(4053,2827,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-26','18:39:00','222052','X',0,'2014-02-28 07:00:03',NULL,NULL),(133,7,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-16','18:37:00','74946','X',0,'2013-12-25 18:08:10',NULL,NULL),(142,7,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-16','18:37:00','74955','X',0,'2013-12-25 18:08:46',NULL,NULL),(342,22,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-09','18:28:00','61512','X',0,'2013-12-25 19:37:18',NULL,NULL),(875,52,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-01','18:08:00','46322','X',0,'2013-12-26 00:02:32',NULL,NULL),(1318,82,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-21','18:37:00','86533','X',0,'2013-12-26 04:39:25',NULL,NULL),(2238,1468,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-01-06','18:24:00','121984','X',0,'2014-01-07 04:05:35',NULL,NULL),(2383,1477,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-10','18:26:00','129738','X',0,'2014-01-13 03:00:26',NULL,NULL),(3571,2797,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-13','18:41:00','192633','X',0,'2014-02-13 21:30:07',NULL,NULL),(4374,2850,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-03-07','18:46:00','247689','X',0,'2014-03-07 21:32:28',NULL,NULL),(11,1,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-05','18:31:00','54186','X',0,'2013-12-25 17:19:57',NULL,NULL),(779,48,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-11-27','18:05:00','41579','X',0,'2013-12-25 23:16:12',NULL,NULL),(1035,66,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-03','18:02:00','17825','X',0,'2013-12-26 01:31:48',NULL,NULL),(1109,71,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-15','18:15:00','73600','X',0,'2013-12-26 02:30:02',NULL,NULL),(1462,99,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-26','18:41:00','100552','X',0,'2013-12-27 02:05:54',NULL,NULL),(1593,385,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-30','19:01:00','109540','X',0,'2014-01-01 12:07:44',NULL,NULL),(1645,387,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-31','18:52:00','111684','X',1,'2014-01-02 04:34:12',NULL,NULL),(1936,1183,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:15',NULL,NULL),(1994,1241,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:32',NULL,NULL),(2081,1328,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:35',NULL,NULL),(2245,1468,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-06','18:24:00','121991','X',0,'2014-01-07 04:06:32',NULL,NULL),(3187,2774,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-31','18:37:00','165929','X',0,'2014-01-31 21:01:36',NULL,NULL),(454,31,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-18','18:07:00','30657','X',0,'2013-12-25 20:30:40',NULL,NULL),(680,42,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-08','18:03:00','21236','X',0,'2013-12-25 22:30:07',NULL,NULL),(709,45,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-10-26','18:04:00','13997','X',0,'2013-12-25 22:32:12',NULL,NULL),(932,58,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-10-07','19:14:00','6702','X',0,'2013-12-26 00:32:20',NULL,NULL),(1034,66,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-11-03','18:02:00','17824','X',0,'2013-12-26 01:31:46',NULL,NULL),(1574,383,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-29','18:10:00','107256','X',0,'2013-12-30 00:02:13',NULL,NULL),(2048,1295,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:03',NULL,NULL),(2060,1307,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:36',NULL,NULL),(2448,1507,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:38',NULL,NULL),(3689,2802,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-15','18:48:00','199880','X',0,'2014-02-15 22:01:58',NULL,NULL),(3985,2824,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-24','18:21:00','218497','X',0,'2014-02-26 09:30:57',NULL,NULL),(4050,2826,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-27','18:48:00','225944','X',0,'2014-02-28 06:31:48',NULL,NULL),(4292,2847,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-06','18:51:00','245592','X',0,'2014-03-06 21:02:35',NULL,NULL),(4335,2849,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-07','18:42:00','246121','X',0,'2014-03-07 21:00:33',NULL,NULL),(39,2,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-12','18:01:00','7923','X',0,'2013-12-25 17:30:21',NULL,NULL),(219,15,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-04','18:02:00','18538','X',0,'2013-12-25 18:31:38',NULL,NULL),(261,19,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-24','18:40:00','96822','X',0,'2013-12-25 18:58:27',NULL,NULL),(653,40,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-12','18:53:00','67273','X',0,'2013-12-25 22:09:34',NULL,NULL),(668,41,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-08','18:10:00','59425','X',0,'2013-12-25 22:17:00',NULL,NULL),(686,42,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-08','18:03:00','21242','X',0,'2013-12-25 22:30:38',NULL,NULL),(1319,82,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-21','18:37:00','86535','X',0,'2013-12-26 04:39:27',NULL,NULL),(1510,380,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-27','18:44:00','101834','X',0,'2013-12-28 03:37:09',NULL,NULL),(2529,1576,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-13','18:44:00','134005','X',0,'2014-01-14 01:33:32',NULL,NULL),(2719,2554,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-20','18:21:00','146898','X',0,'2014-01-21 08:46:39',NULL,NULL),(3898,2818,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-25','18:33:00','219094','X',0,'2014-02-25 21:00:28',NULL,NULL),(3911,2819,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-25','18:36:00','220683','X',0,'2014-02-25 21:31:13',NULL,NULL),(4407,2853,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-09','18:20:00','252252','X',0,'2014-03-09 21:00:40',NULL,NULL),(715,46,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-07','18:13:00','57433','X',0,'2013-12-25 22:46:16',NULL,NULL),(1058,67,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-25','18:35:00','98940','X',0,'2013-12-26 01:52:27',NULL,NULL),(1075,68,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-14','18:21:00','71344','X',0,'2013-12-26 02:02:59',NULL,NULL),(1156,73,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-10-14','18:02:00','9154','X',0,'2013-12-26 02:46:29',NULL,NULL),(1890,1137,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:09',NULL,NULL),(1935,1182,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:13',NULL,NULL),(2153,1400,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:36',NULL,NULL),(2877,2652,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:50:00','1','X',1,'2014-01-23 04:25:53',NULL,NULL),(3243,2777,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-03','18:32:00','170205','X',0,'2014-02-03 21:01:07',NULL,NULL),(3368,2784,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-07','18:14:00','177577','X',0,'2014-02-07 19:01:06',NULL,NULL),(4066,2828,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-27','18:43:00','224650','X',0,'2014-02-28 07:30:20',NULL,NULL),(4456,2855,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-10','19:23:00','255931','X',0,'2014-03-10 21:02:36',NULL,NULL),(558,38,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-13','18:39:00','69284','X',0,'2013-12-25 21:37:46',NULL,NULL),(674,41,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-08','18:10:00','59431','X',0,'2013-12-25 22:17:17',NULL,NULL),(2688,2552,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-18','18:11:00','144586','X',0,'2014-01-21 08:44:42',NULL,NULL),(3007,2756,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-24','18:26:00','154287','X',0,'2014-01-24 21:00:22',NULL,NULL),(93,6,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-04','18:22:00','52141','X',0,'2013-12-25 17:50:50',NULL,NULL),(538,37,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-22','18:40:00','88499','X',0,'2013-12-25 21:23:47',NULL,NULL),(1673,568,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-02','18:42:00','115197','X',0,'2014-01-03 02:03:19',NULL,NULL),(1705,569,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-03','18:38:00','116004','X',0,'2014-01-04 02:02:43',NULL,NULL),(1931,1178,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:02',NULL,NULL),(4028,2826,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-27','18:48:00','225922','X',0,'2014-02-28 06:30:56',NULL,NULL),(4041,2826,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-27','18:48:00','225935','X',0,'2014-02-28 06:31:40',NULL,NULL),(4356,2850,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-07','18:46:00','247671','X',0,'2014-03-07 21:32:03',NULL,NULL),(4419,2853,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-03-09','18:20:00','252264','X',0,'2014-03-09 21:01:09',NULL,NULL),(595,39,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-17','18:43:00','78044','X',0,'2013-12-25 21:52:25',NULL,NULL),(660,41,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-08','18:10:00','59417','X',0,'2013-12-25 22:16:10',NULL,NULL),(843,51,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-24','03:40:00','94582','X',0,'2013-12-25 23:51:32',NULL,NULL),(1548,382,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-28','21:04:00','105804','X',1,'2013-12-29 11:14:48',NULL,NULL),(1640,387,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-31','18:52:00','111679','X',1,'2014-01-02 04:32:08',NULL,NULL),(3151,2773,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-30','18:35:00','164072','X',0,'2014-01-30 21:01:14',NULL,NULL),(3297,2781,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-05','18:39:00','174407','X',0,'2014-02-05 21:30:47',NULL,NULL),(3591,2798,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-13','18:46:00','194314','X',0,'2014-02-13 22:02:13',NULL,NULL),(4245,2845,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-03-05','18:46:00','240513','X',0,'2014-03-05 21:00:32',NULL,NULL),(247,19,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-24','18:40:00','96808','X',0,'2013-12-25 18:54:01',NULL,NULL),(2051,1298,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:11',NULL,NULL),(2746,2555,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-21','18:24:00','147881','X',1,'2014-01-22 03:22:56',NULL,NULL),(2938,2713,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:53:00','1','X',0,'2014-01-23 06:48:31',NULL,NULL),(3045,2757,'005010X220A1','BE','OH0','92036','92036OH0020032','2014-01-25','18:11:00','155346','X',0,'2014-01-25 19:00:20',NULL,NULL),(3272,2778,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-04','18:29:00','172114','X',0,'2014-02-04 21:01:38',NULL,NULL),(3718,2804,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-02-16','18:12:00','201512','X',0,'2014-02-16 19:00:41',NULL,NULL),(3999,2825,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-26','18:43:00','223754','X',0,'2014-02-26 21:01:32',NULL,NULL),(79,6,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-04','18:22:00','52127','X',0,'2013-12-25 17:49:23',NULL,NULL),(135,7,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-16','18:37:00','74948','X',0,'2013-12-25 18:08:21',NULL,NULL),(165,9,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-11','18:02:00','23530','X',0,'2013-12-25 18:10:56',NULL,NULL),(234,17,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-07','18:02:00','20913','X',0,'2013-12-25 18:32:17',NULL,NULL),(296,21,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-10','18:21:00','62745','X',0,'2013-12-25 19:18:22',NULL,NULL),(1619,386,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-01','18:18:00','112804','X',1,'2014-01-02 04:23:10',NULL,NULL),(1898,1145,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:51:31',NULL,NULL),(2148,1395,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:24:22',NULL,NULL),(2828,2603,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 03:51:52',NULL,NULL),(2857,2632,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:37:00','1','X',1,'2014-01-23 04:14:29',NULL,NULL),(3199,2775,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-01','18:14:00','166668','X',0,'2014-02-01 19:00:15',NULL,NULL),(188,13,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-03','18:20:00','49894','X',0,'2013-12-25 18:20:18',NULL,NULL),(1281,81,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-30','18:04:00','44821','X',0,'2013-12-26 04:15:24',NULL,NULL),(2199,1446,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:44',NULL,NULL),(2399,1478,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-12','18:13:00','132583','X',0,'2014-01-13 03:01:04',NULL,NULL),(2839,2614,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:33:00','1','X',1,'2014-01-23 03:59:54',NULL,NULL),(3318,2782,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-06','18:28:00','175975','X',0,'2014-02-06 21:00:03',NULL,NULL),(3750,2808,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-18','18:28:00','204264','X',0,'2014-02-18 22:00:42',NULL,NULL),(759,47,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-19','19:11:00','81745','X',0,'2013-12-25 23:10:38',NULL,NULL),(888,53,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-21','18:06:00','34266','X',0,'2013-12-26 00:16:27',NULL,NULL),(3605,2798,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-13','18:46:00','194328','X',0,'2014-02-13 22:03:05',NULL,NULL),(3665,2801,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-15','18:44:00','198280','X',0,'2014-02-15 21:00:06',NULL,NULL),(4414,2853,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-09','18:20:00','252259','X',0,'2014-03-09 21:01:03',NULL,NULL),(513,37,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-22','18:40:00','88474','X',0,'2013-12-25 21:22:21',NULL,NULL),(644,40,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-12','18:53:00','67264','X',0,'2013-12-25 22:08:57',NULL,NULL),(1031,65,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-05','18:01:00','5895','X',0,'2013-12-26 01:31:16',NULL,NULL),(1291,81,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-11-30','18:04:00','44831','X',0,'2013-12-26 04:16:22',NULL,NULL),(1923,1170,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:52:40',NULL,NULL),(2158,1405,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:50',NULL,NULL),(2753,2555,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-01-21','18:24:00','147888','X',1,'2014-01-22 03:23:03',NULL,NULL),(2763,2556,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-22','18:31:00','150804','X',0,'2014-01-23 03:01:49',NULL,NULL),(3768,2808,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-18','18:28:00','204283','X',0,'2014-02-18 22:01:44',NULL,NULL),(4283,2847,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-06','18:51:00','245583','X',0,'2014-03-06 21:02:09',NULL,NULL),(3,1,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-05','18:31:00','54178','X',0,'2013-12-25 17:16:22',NULL,NULL),(2223,1468,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-06','18:24:00','121969','X',0,'2014-01-07 04:02:07',NULL,NULL),(3449,2791,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-10','18:27:00','184760','X',0,'2014-02-10 21:00:12',NULL,NULL),(3715,2804,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-16','18:12:00','201509','X',0,'2014-02-16 19:00:39',NULL,NULL),(4137,2832,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-01','18:23:00','232024','X',0,'2014-03-01 21:01:09',NULL,NULL),(1265,80,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-18','18:49:00','79095','X',0,'2013-12-26 04:10:09',NULL,NULL),(2109,1356,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','12:25:00','1','X',0,'2014-01-05 17:22:34',NULL,NULL),(2368,1476,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-10','18:26:00','129725','X',0,'2014-01-13 02:24:02',NULL,NULL),(2950,2725,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:21:00','1','X',0,'2014-01-23 08:13:36',NULL,NULL),(4096,2830,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-28','19:12:00','229914','X',0,'2014-02-28 21:31:34',NULL,NULL),(732,47,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-19','19:11:00','81718','X',0,'2013-12-25 23:02:02',NULL,NULL),(2102,1349,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:33',NULL,NULL),(2201,1448,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:50',NULL,NULL),(2653,2540,'005010X220A1','BE','OH0','92036','92036OH0010027','2014-01-16','18:41:00','141429','X',0,'2014-01-17 03:36:43',NULL,NULL),(2821,2596,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 03:49:22',NULL,NULL),(3059,2758,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-26','18:09:00','156599','X',0,'2014-01-26 19:00:30',NULL,NULL),(3626,2799,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-14','18:39:00','196119','X',0,'2014-02-14 21:30:57',NULL,NULL),(4015,2825,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-26','18:43:00','223770','X',0,'2014-02-26 21:02:42',NULL,NULL),(4244,2845,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-05','18:46:00','240512','X',0,'2014-03-05 21:00:30',NULL,NULL),(4406,2853,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-09','18:20:00','252251','X',0,'2014-03-09 21:00:39',NULL,NULL),(229,16,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-10-25','18:01:00','13414','X',0,'2013-12-25 18:32:05',NULL,NULL),(420,29,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-06','18:21:00','55530','X',0,'2013-12-25 20:18:28',NULL,NULL),(2570,2311,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-14','19:00:00','136127','X',0,'2014-01-15 02:08:01',NULL,NULL),(2774,2556,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-22','18:31:00','150815','X',0,'2014-01-23 03:02:45',NULL,NULL),(3106,2760,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-28','18:32:00','160257','X',0,'2014-01-28 21:01:18',NULL,NULL),(3180,2774,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-31','18:37:00','165922','X',0,'2014-01-31 21:01:10',NULL,NULL),(501,37,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-22','18:40:00','88453','X',0,'2013-12-25 21:15:10',NULL,NULL),(935,59,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-11','18:36:00','64768','X',0,'2013-12-26 00:45:02',NULL,NULL),(1691,568,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-02','18:42:00','115215','X',0,'2014-01-03 02:06:50',NULL,NULL),(3172,2774,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-31','18:37:00','165914','X',0,'2014-01-31 21:00:30',NULL,NULL),(3263,2778,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-04','18:29:00','172105','X',0,'2014-02-04 21:01:09',NULL,NULL),(3513,2793,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-11','18:41:00','189067','X',0,'2014-02-11 21:02:50',NULL,NULL),(3894,2818,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-02-25','18:33:00','219090','X',0,'2014-02-25 21:00:19',NULL,NULL),(4240,2845,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-05','18:46:00','240508','X',0,'2014-03-05 21:00:22',NULL,NULL),(4337,2849,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-03-07','18:42:00','246123','X',0,'2014-03-07 21:00:36',NULL,NULL),(241,19,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-24','18:40:00','96802','X',0,'2013-12-25 18:47:49',NULL,NULL),(760,47,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-19','19:11:00','81746','X',0,'2013-12-25 23:10:50',NULL,NULL),(2096,1343,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:17',NULL,NULL),(3525,2794,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-11','18:37:00','187469','X',0,'2014-02-11 21:30:19',NULL,NULL),(3615,2798,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-02-13','18:46:00','194338','X',0,'2014-02-13 22:03:17',NULL,NULL),(4269,2846,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-05','18:49:00','241603','X',0,'2014-03-05 21:32:39',NULL,NULL),(74,6,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-04','18:22:00','52122','X',0,'2013-12-25 17:47:30',NULL,NULL),(780,48,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-27','18:05:00','41580','X',0,'2013-12-25 23:16:13',NULL,NULL),(891,53,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-21','18:06:00','34269','X',0,'2013-12-26 00:16:38',NULL,NULL),(1572,383,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-29','18:10:00','107254','X',0,'2013-12-30 00:02:08',NULL,NULL),(1631,386,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-01','18:18:00','112816','X',1,'2014-01-02 04:25:41',NULL,NULL),(2264,1469,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-05','18:09:00','119798','X',1,'2014-01-07 10:23:09',NULL,NULL),(2386,1477,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-01-10','18:26:00','129741','X',0,'2014-01-13 03:00:30',NULL,NULL),(2962,2737,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:46:00','1','X',0,'2014-01-23 10:00:02',NULL,NULL),(3552,2796,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-12','18:31:00','191460','X',0,'2014-02-12 21:32:09',NULL,NULL),(3560,2796,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-12','18:31:00','191468','X',0,'2014-02-12 21:32:26',NULL,NULL),(897,53,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-21','18:06:00','34275','X',0,'2013-12-26 00:16:57',NULL,NULL),(2169,1416,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:21',NULL,NULL),(2559,2311,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-14','19:00:00','136116','X',0,'2014-01-15 02:07:37',NULL,NULL),(2758,2555,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-21','18:24:00','147893','X',1,'2014-01-22 03:23:08',NULL,NULL),(2925,2700,'005010X231A1','FA','OH0','52664','52664OH1520009','2014-01-15','23:00:00','1','X',0,'2014-01-23 06:40:46',NULL,NULL),(3367,2784,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-07','18:14:00','177576','X',0,'2014-02-07 19:01:05',NULL,NULL),(3617,2798,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-13','18:46:00','194340','X',0,'2014-02-13 22:03:19',NULL,NULL),(3811,2811,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-19','18:35:00','207805','X',0,'2014-02-20 04:55:00',NULL,NULL),(4156,2833,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-02','18:16:00','233975','X',0,'2014-03-03 01:00:38',NULL,NULL),(4479,2856,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-10','19:17:00','254166','X',0,'2014-03-10 21:30:13',NULL,NULL),(441,29,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-06','18:21:00','55551','X',0,'2013-12-25 20:20:19',NULL,NULL),(576,38,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-13','18:39:00','69302','X',0,'2013-12-25 21:39:12',NULL,NULL),(701,44,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-10-04','18:00:00','5520','X',0,'2013-12-25 22:31:38',NULL,NULL),(970,60,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-12','18:03:00','24202','X',0,'2013-12-26 01:00:01',NULL,NULL),(1656,387,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-31','18:52:00','111695','X',1,'2014-01-02 04:35:15',NULL,NULL),(2814,2589,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:47:25',NULL,NULL),(4055,2827,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-26','18:39:00','222054','X',0,'2014-02-28 07:00:17',NULL,NULL),(4164,2835,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-03','18:31:00','234699','X',0,'2014-03-03 21:00:07',NULL,NULL),(4211,2843,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-04','18:50:00','238758','X',0,'2014-03-04 21:02:13',NULL,NULL),(531,37,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-22','18:40:00','88492','X',0,'2013-12-25 21:23:31',NULL,NULL),(1215,76,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-22','18:08:00','35669','X',0,'2013-12-26 03:16:23',NULL,NULL),(2438,1497,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:29',NULL,NULL),(3335,2782,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-06','18:28:00','175992','X',0,'2014-02-06 21:01:37',NULL,NULL),(3625,2799,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-14','18:39:00','196118','X',0,'2014-02-14 21:30:56',NULL,NULL),(3700,2802,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-15','18:48:00','199892','X',0,'2014-02-15 22:02:10',NULL,NULL),(3701,2803,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-16','18:12:00','201681','X',0,'2014-02-16 19:00:02',NULL,NULL),(4208,2843,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-04','18:50:00','238755','X',0,'2014-03-04 21:02:01',NULL,NULL),(4235,2844,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-03-04','18:46:00','237496','X',0,'2014-03-04 21:30:22',NULL,NULL),(825,51,'005010X220A1','BE','TX0','18575','18575LA0020002','2013-12-24','03:40:00','94592','X',0,'2013-12-25 23:45:18',NULL,NULL),(1158,74,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-10','18:01:00','22949','X',0,'2013-12-26 02:46:34',NULL,NULL),(1263,80,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-18','18:49:00','79093','X',0,'2013-12-26 04:10:00',NULL,NULL),(2275,1471,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-07','18:29:00','123273','X',0,'2014-01-08 18:24:32',NULL,NULL),(3426,2790,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-10','05:02:00','183699','X',0,'2014-02-10 11:00:44',NULL,NULL),(4100,2830,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-28','19:12:00','229918','X',0,'2014-02-28 21:31:45',NULL,NULL),(4253,2846,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-05','18:49:00','241587','X',0,'2014-03-05 21:31:42',NULL,NULL),(1055,67,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-25','18:35:00','98937','X',0,'2013-12-26 01:52:13',NULL,NULL),(1660,387,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-31','18:52:00','111699','X',1,'2014-01-02 04:35:40',NULL,NULL),(2083,1330,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:40',NULL,NULL),(2800,2575,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 03:42:44',NULL,NULL),(3063,2759,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-27','18:27:00','158003','X',0,'2014-01-27 21:00:39',NULL,NULL),(3328,2782,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-06','18:28:00','175985','X',0,'2014-02-06 21:01:20',NULL,NULL),(4435,2855,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-10','19:23:00','255910','X',0,'2014-03-10 21:00:24',NULL,NULL),(741,47,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-19','19:11:00','81727','X',0,'2013-12-25 23:07:52',NULL,NULL),(2332,1474,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-09','18:28:00','127872','X',0,'2014-01-13 02:20:57',NULL,NULL),(3574,2797,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-13','18:41:00','192636','X',0,'2014-02-13 21:30:12',NULL,NULL),(3611,2798,'005010X220A1','BE','TX0','33348','33348TX0010002','2014-02-13','18:46:00','194334','X',0,'2014-02-13 22:03:13',NULL,NULL),(769,47,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-19','19:11:00','81755','X',0,'2013-12-25 23:11:22',NULL,NULL),(850,51,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-24','03:40:00','94589','X',0,'2013-12-25 23:51:59',NULL,NULL),(893,53,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-11-21','18:06:00','34271','X',0,'2013-12-26 00:16:46',NULL,NULL),(1941,1188,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:29',NULL,NULL),(2776,2556,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-22','18:31:00','150817','X',0,'2014-01-23 03:02:48',NULL,NULL),(3017,2756,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-24','18:26:00','154297','X',0,'2014-01-24 21:00:57',NULL,NULL),(3174,2774,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-31','18:37:00','165916','X',0,'2014-01-31 21:00:47',NULL,NULL),(4127,2832,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-01','18:23:00','232014','X',0,'2014-03-01 21:00:30',NULL,NULL),(4246,2846,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-05','18:49:00','241580','X',0,'2014-03-05 21:30:02',NULL,NULL),(559,38,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-13','18:39:00','69285','X',0,'2013-12-25 21:37:49',NULL,NULL),(1182,75,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-20','19:06:00','84219','X',0,'2013-12-26 03:09:18',NULL,NULL),(1192,75,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-20','19:06:00','84230','X',0,'2013-12-26 03:10:29',NULL,NULL),(1433,93,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-24','01:56:00','90969','X',0,'2013-12-26 13:15:39',NULL,NULL),(1731,570,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-03','19:07:00','117546','X',0,'2014-01-04 06:00:08',NULL,NULL),(2495,1554,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:46',NULL,NULL),(2611,2539,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-15','18:30:00','138473','X',0,'2014-01-16 08:47:19',NULL,NULL),(3598,2798,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-13','18:46:00','194321','X',0,'2014-02-13 22:02:45',NULL,NULL),(3773,2810,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-19','18:35:00','207788','X',0,'2014-02-20 04:00:15',NULL,NULL),(3797,2809,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-19','18:35:00','207800','X',0,'2014-02-20 04:49:17',NULL,NULL),(10,1,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-05','18:31:00','54185','X',0,'2013-12-25 17:19:19',NULL,NULL),(484,34,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-06','18:02:00','6433','X',0,'2013-12-25 20:46:06',NULL,NULL),(906,55,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-23','18:01:00','12599','X',0,'2013-12-26 00:30:18',NULL,NULL),(1685,568,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-02','18:42:00','115209','X',0,'2014-01-03 02:06:09',NULL,NULL),(2117,1364,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:56',NULL,NULL),(91,6,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-04','18:22:00','52139','X',0,'2013-12-25 17:50:45',NULL,NULL),(303,21,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-10','18:21:00','62752','X',0,'2013-12-25 19:19:26',NULL,NULL),(314,21,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-10','18:21:00','62763','X',0,'2013-12-25 19:20:30',NULL,NULL),(437,29,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-06','18:21:00','55547','X',0,'2013-12-25 20:20:07',NULL,NULL),(552,38,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-13','18:39:00','69278','X',0,'2013-12-25 21:37:18',NULL,NULL),(1197,75,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-20','19:06:00','84235','X',0,'2013-12-26 03:10:45',NULL,NULL),(2200,1447,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:47',NULL,NULL),(3142,2773,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-30','18:35:00','164063','X',0,'2014-01-30 21:00:03',NULL,NULL),(3247,2777,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-03','18:32:00','170209','X',0,'2014-02-03 21:01:23',NULL,NULL),(3489,2793,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-11','18:41:00','189043','X',0,'2014-02-11 21:01:24',NULL,NULL),(3553,2796,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-02-12','18:31:00','191461','X',0,'2014-02-12 21:32:11',NULL,NULL),(3676,2802,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-02-15','18:48:00','199867','X',0,'2014-02-15 22:01:13',NULL,NULL),(4153,2833,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-02','18:16:00','233972','X',0,'2014-03-03 01:00:36',NULL,NULL),(4338,2849,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-03-07','18:42:00','246124','X',0,'2014-03-07 21:00:36',NULL,NULL),(670,41,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-08','18:10:00','59427','X',0,'2013-12-25 22:17:07',NULL,NULL),(1600,385,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-30','19:01:00','109547','X',0,'2014-01-01 12:08:40',NULL,NULL),(2956,2731,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:03:00','1','X',0,'2014-01-23 09:01:27',NULL,NULL),(3637,2799,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-14','18:39:00','196130','X',0,'2014-02-14 21:31:50',NULL,NULL),(4339,2850,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-07','18:46:00','247654','X',0,'2014-03-07 21:30:01',NULL,NULL),(4473,2856,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-10','19:17:00','254160','X',0,'2014-03-10 21:30:00',NULL,NULL),(304,21,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-10','18:21:00','62753','X',0,'2013-12-25 19:19:35',NULL,NULL),(1595,385,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-30','19:01:00','109542','X',0,'2014-01-01 12:08:13',NULL,NULL),(2125,1372,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:18',NULL,NULL),(2376,1477,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-10','18:26:00','129731','X',0,'2014-01-13 03:00:14',NULL,NULL),(3100,2760,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-28','18:32:00','160251','X',0,'2014-01-28 21:01:11',NULL,NULL),(4357,2850,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-03-07','18:46:00','247672','X',0,'2014-03-07 21:32:04',NULL,NULL),(225,16,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-25','18:01:00','13418','X',0,'2013-12-25 18:31:52',NULL,NULL),(965,59,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-11','18:36:00','64798','X',0,'2013-12-26 00:54:02',NULL,NULL),(968,59,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-11','18:36:00','64801','X',0,'2013-12-26 00:54:17',NULL,NULL),(990,62,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-05','18:03:00','19349','X',0,'2013-12-26 01:01:45',NULL,NULL),(2661,2551,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-17','18:23:00','142627','X',0,'2014-01-20 08:06:24',NULL,NULL),(2854,2629,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:22:00','1','X',1,'2014-01-23 04:12:40',NULL,NULL),(2957,2732,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',0,'2014-01-23 09:28:22',NULL,NULL),(3422,2790,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-10','05:02:00','183695','X',0,'2014-02-10 11:00:28',NULL,NULL),(3757,2808,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-18','18:28:00','204271','X',0,'2014-02-18 22:01:22',NULL,NULL),(3923,2819,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-02-25','18:36:00','220695','X',0,'2014-02-25 21:32:02',NULL,NULL),(4179,2836,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-03','18:33:00','236075','X',0,'2014-03-03 21:30:37',NULL,NULL),(4288,2847,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-06','18:51:00','245588','X',0,'2014-03-06 21:02:30',NULL,NULL),(643,40,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-12','18:53:00','67263','X',0,'2013-12-25 22:08:52',NULL,NULL),(2156,1403,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:45',NULL,NULL),(3496,2793,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-11','18:41:00','189050','X',0,'2014-02-11 21:02:17',NULL,NULL),(3987,2824,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-24','18:21:00','218499','X',0,'2014-02-26 09:31:01',NULL,NULL),(582,39,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-17','18:43:00','78031','X',0,'2013-12-25 21:47:31',NULL,NULL),(1558,382,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-28','21:04:00','105814','X',1,'2013-12-29 11:15:23',NULL,NULL),(2382,1477,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-10','18:26:00','129737','X',0,'2014-01-13 03:00:24',NULL,NULL),(2541,1576,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-13','18:44:00','134017','X',0,'2014-01-14 01:33:50',NULL,NULL),(2646,2540,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-16','18:41:00','141422','X',0,'2014-01-17 03:36:38',NULL,NULL),(2787,2562,'005010X231A1','FA','OH0','92036','92036OH0030006','2014-01-13','22:25:00','1','X',0,'2014-01-23 03:39:36',NULL,NULL),(4025,2826,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-27','18:48:00','225919','X',0,'2014-02-28 06:30:34',NULL,NULL),(819,50,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-26','18:20:00','40544','X',0,'2013-12-25 23:32:57',NULL,NULL),(1202,76,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-22','18:08:00','35656','X',0,'2013-12-26 03:15:01',NULL,NULL),(1234,80,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-18','18:49:00','79064','X',0,'2013-12-26 04:00:02',NULL,NULL),(1597,385,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-30','19:01:00','109544','X',0,'2014-01-01 12:08:25',NULL,NULL),(1932,1179,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:53:04',NULL,NULL),(2239,1468,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-06','18:24:00','121985','X',0,'2014-01-07 04:05:36',NULL,NULL),(2458,1517,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:08',NULL,NULL),(275,19,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-24','18:40:00','96836','X',0,'2013-12-25 18:59:22',NULL,NULL),(1070,68,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-14','18:21:00','71339','X',0,'2013-12-26 02:01:32',NULL,NULL),(2262,1469,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-01-05','18:09:00','119796','X',1,'2014-01-07 10:23:02',NULL,NULL),(3120,2772,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-29','18:30:00','161342','X',0,'2014-01-29 21:01:06',NULL,NULL),(3128,2772,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-29','18:30:00','161350','X',0,'2014-01-29 21:01:39',NULL,NULL),(3281,2778,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-04','18:29:00','172123','X',0,'2014-02-04 21:01:55',NULL,NULL),(3816,2810,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-19','18:35:00','207807','X',0,'2014-02-20 04:55:56',NULL,NULL),(4242,2845,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-05','18:46:00','240510','X',0,'2014-03-05 21:00:24',NULL,NULL),(412,29,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-06','18:21:00','55522','X',0,'2013-12-25 20:15:02',NULL,NULL),(511,37,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-22','18:40:00','88472','X',0,'2013-12-25 21:21:21',NULL,NULL),(1061,67,'005010X220A1','BE','OH0','92036','92036OH0020008','2013-12-25','18:35:00','98943','X',0,'2013-12-26 01:52:33',NULL,NULL),(1657,387,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-31','18:52:00','111696','X',1,'2014-01-02 04:35:23',NULL,NULL),(1952,1199,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:00',NULL,NULL),(3962,2823,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-22','18:14:00','213804','X',0,'2014-02-26 08:30:46',NULL,NULL),(378,23,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-02','18:14:00','47694','X',0,'2013-12-25 19:49:53',NULL,NULL),(802,50,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-26','18:20:00','40527','X',0,'2013-12-25 23:31:03',NULL,NULL),(967,59,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-11','18:36:00','64800','X',0,'2013-12-26 00:54:13',NULL,NULL),(1451,93,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-24','01:56:00','90989','X',0,'2013-12-26 13:17:08',NULL,NULL),(1570,383,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-29','18:10:00','107252','X',0,'2013-12-30 00:01:55',NULL,NULL),(2607,2539,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-15','18:30:00','138469','X',0,'2014-01-16 08:47:13',NULL,NULL),(3356,2784,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-07','18:14:00','177565','X',0,'2014-02-07 19:00:37',NULL,NULL),(3868,2815,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-21','18:28:00','211314','X',0,'2014-02-21 21:30:23',NULL,NULL),(63,5,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-09','18:02:00','22411','X',0,'2013-12-25 17:32:15',NULL,NULL),(100,6,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-12-04','18:22:00','52148','X',0,'2013-12-25 17:51:07',NULL,NULL),(1287,81,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-11-30','18:04:00','44827','X',0,'2013-12-26 04:16:12',NULL,NULL),(2640,2540,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-01-16','18:41:00','141416','X',0,'2014-01-17 03:36:34',NULL,NULL),(3000,2755,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-23','18:27:00','151596','X',0,'2014-01-23 21:01:34',NULL,NULL),(4166,2835,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-03','18:31:00','234701','X',0,'2014-03-03 21:00:09',NULL,NULL),(4433,2854,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-09','18:21:00','252853','X',0,'2014-03-09 21:30:07',NULL,NULL),(56,4,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-11','18:01:00','7636','X',0,'2013-12-25 17:31:41',NULL,NULL),(911,56,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-16','20:51:00','10065','X',0,'2013-12-26 00:30:57',NULL,NULL),(1222,76,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-11-22','18:08:00','35676','X',0,'2013-12-26 03:16:36',NULL,NULL),(2572,2311,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-14','19:00:00','136129','X',0,'2014-01-15 02:08:03',NULL,NULL),(3856,2814,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-20','18:28:00','208923','X',0,'2014-02-20 22:01:36',NULL,NULL),(4451,2855,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-10','19:23:00','255926','X',0,'2014-03-10 21:02:25',NULL,NULL),(519,37,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-22','18:40:00','88480','X',0,'2013-12-25 21:22:49',NULL,NULL),(631,40,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-12','18:53:00','67251','X',0,'2013-12-25 22:06:59',NULL,NULL),(1965,1212,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:54:36',NULL,NULL),(2087,1334,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:51',NULL,NULL),(2861,2636,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 04:17:10',NULL,NULL),(3300,2781,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-05','18:39:00','174410','X',0,'2014-02-05 21:31:02',NULL,NULL),(3320,2782,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-06','18:28:00','175977','X',0,'2014-02-06 21:00:47',NULL,NULL),(3434,2790,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-10','05:02:00','183707','X',0,'2014-02-10 11:01:06',NULL,NULL),(136,7,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-16','18:37:00','74949','X',0,'2013-12-25 18:08:26',NULL,NULL),(817,50,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-26','18:20:00','40542','X',0,'2013-12-25 23:32:50',NULL,NULL),(1428,93,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-24','01:56:00','90964','X',0,'2013-12-26 13:14:47',NULL,NULL),(1893,1140,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:17',NULL,NULL),(2192,1439,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:25',NULL,NULL),(2762,2555,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-21','18:24:00','147897','X',1,'2014-01-22 03:23:12',NULL,NULL),(3116,2772,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-29','18:30:00','161338','X',0,'2014-01-29 21:00:26',NULL,NULL),(3982,2824,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-24','18:21:00','218494','X',0,'2014-02-26 09:30:49',NULL,NULL),(4342,2850,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-07','18:46:00','247657','X',0,'2014-03-07 21:30:45',NULL,NULL),(289,21,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-10','18:21:00','62738','X',0,'2013-12-25 19:15:02',NULL,NULL),(371,23,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-02','18:14:00','47687','X',0,'2013-12-25 19:49:04',NULL,NULL),(737,47,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-19','19:11:00','81723','X',0,'2013-12-25 23:06:21',NULL,NULL),(836,51,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-24','03:40:00','94575','X',0,'2013-12-25 23:50:56',NULL,NULL),(853,51,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-24','03:40:00','94593','X',0,'2013-12-25 23:52:05',NULL,NULL),(880,52,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-01','18:08:00','46327','X',0,'2013-12-26 00:02:48',NULL,NULL),(889,53,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-21','18:06:00','34267','X',0,'2013-12-26 00:16:30',NULL,NULL),(1253,80,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-18','18:49:00','79083','X',0,'2013-12-26 04:08:53',NULL,NULL),(2058,1305,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:31',NULL,NULL),(2871,2646,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 04:21:11',NULL,NULL),(2994,2755,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-23','18:27:00','151590','X',0,'2014-01-23 21:01:24',NULL,NULL),(3249,2777,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-02-03','18:32:00','170211','X',0,'2014-02-03 21:01:26',NULL,NULL),(3271,2778,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-04','18:29:00','172113','X',0,'2014-02-04 21:01:35',NULL,NULL),(3286,2780,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-05','18:36:00','173079','X',0,'2014-02-05 21:00:03',NULL,NULL),(3319,2782,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-06','18:28:00','175976','X',0,'2014-02-06 21:00:29',NULL,NULL),(3338,2782,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-06','18:28:00','175995','X',0,'2014-02-06 21:01:43',NULL,NULL),(3888,2817,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-22','18:14:00','214240','X',0,'2014-02-22 19:00:11',NULL,NULL),(3940,2820,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-23','18:10:00','215486','X',0,'2014-02-26 08:00:28',NULL,NULL),(166,10,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-19','18:01:00','10692','X',0,'2013-12-25 18:11:02',NULL,NULL),(912,56,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-10-16','20:51:00','10063','X',0,'2013-12-26 00:31:00',NULL,NULL),(927,57,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-11-19','18:07:00','31313','X',0,'2013-12-26 00:32:02',NULL,NULL),(2120,1367,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:04',NULL,NULL),(2131,1378,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:35',NULL,NULL),(2459,1518,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:09',NULL,NULL),(2499,1558,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:03:50',NULL,NULL),(2754,2555,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-21','18:24:00','147889','X',1,'2014-01-22 03:23:04',NULL,NULL),(2982,2755,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-23','18:27:00','151578','X',0,'2014-01-23 21:00:27',NULL,NULL),(3012,2756,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-24','18:26:00','154292','X',0,'2014-01-24 21:00:46',NULL,NULL),(4027,2826,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-27','18:48:00','225921','X',0,'2014-02-28 06:30:47',NULL,NULL),(4067,2828,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-27','18:43:00','224651','X',0,'2014-02-28 07:30:24',NULL,NULL),(305,21,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-10','18:21:00','62754','X',0,'2013-12-25 19:19:38',NULL,NULL),(1008,63,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-25','18:07:00','38446','X',0,'2013-12-26 01:16:08',NULL,NULL),(2072,1319,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:10',NULL,NULL),(2149,1396,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:25',NULL,NULL),(4442,2855,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-10','19:23:00','255917','X',0,'2014-03-10 21:01:52',NULL,NULL),(45,3,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-13','18:04:00','25392','X',0,'2013-12-25 17:30:51',NULL,NULL),(642,40,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-12','18:53:00','67262','X',0,'2013-12-25 22:08:50',NULL,NULL),(770,47,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-19','19:11:00','81756','X',0,'2013-12-25 23:11:24',NULL,NULL),(1175,75,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-20','19:06:00','84212','X',0,'2013-12-26 03:07:42',NULL,NULL),(1267,80,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-18','18:49:00','79097','X',0,'2013-12-26 04:10:13',NULL,NULL),(1276,80,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-18','18:49:00','79106','X',0,'2013-12-26 04:10:46',NULL,NULL),(1525,381,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-28','18:14:00','103717','X',1,'2013-12-29 11:09:47',NULL,NULL),(1684,568,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-02','18:42:00','115208','X',0,'2014-01-03 02:06:02',NULL,NULL),(2851,2626,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:07:00','1','X',1,'2014-01-23 04:09:32',NULL,NULL),(3452,2792,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-10','18:30:00','186438','X',0,'2014-02-10 21:30:21',NULL,NULL),(3706,2804,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-16','18:12:00','201499','X',0,'2014-02-16 19:00:10',NULL,NULL),(4280,2847,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-06','18:51:00','245580','X',0,'2014-03-06 21:01:41',NULL,NULL),(407,27,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-22','18:02:00','12157','X',0,'2013-12-25 20:01:52',NULL,NULL),(878,52,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-01','18:08:00','46325','X',0,'2013-12-26 00:02:44',NULL,NULL),(1051,67,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-25','18:35:00','98933','X',0,'2013-12-26 01:51:30',NULL,NULL),(3133,2772,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-29','18:30:00','161355','X',0,'2014-01-29 21:01:45',NULL,NULL),(3372,2784,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-07','18:14:00','177581','X',0,'2014-02-07 19:01:09',NULL,NULL),(3551,2796,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-12','18:31:00','191459','X',0,'2014-02-12 21:32:08',NULL,NULL),(3725,2806,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-17','18:05:00','202222','X',0,'2014-02-17 19:00:05',NULL,NULL),(4122,2832,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-01','18:23:00','232009','X',0,'2014-03-01 21:00:08',NULL,NULL),(4204,2843,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-04','18:50:00','238751','X',0,'2014-03-04 21:01:25',NULL,NULL),(637,40,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-12','18:53:00','67257','X',0,'2013-12-25 22:08:24',NULL,NULL),(980,61,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-16','18:03:00','28395','X',0,'2013-12-26 01:01:04',NULL,NULL),(2080,1327,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:32',NULL,NULL),(2505,1564,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:55',NULL,NULL),(2954,2729,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:38:00','1','X',0,'2014-01-23 08:39:58',NULL,NULL),(3559,2796,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-12','18:31:00','191467','X',0,'2014-02-12 21:32:25',NULL,NULL),(3862,2815,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-21','18:28:00','211308','X',0,'2014-02-21 21:30:04',NULL,NULL),(4135,2832,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-01','18:23:00','232022','X',0,'2014-03-01 21:01:05',NULL,NULL),(4255,2846,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-05','18:49:00','241589','X',0,'2014-03-05 21:32:06',NULL,NULL),(258,19,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-24','18:40:00','96819','X',0,'2013-12-25 18:57:24',NULL,NULL),(274,19,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-24','18:40:00','96835','X',0,'2013-12-25 18:59:21',NULL,NULL),(422,29,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-06','18:21:00','55532','X',0,'2013-12-25 20:18:48',NULL,NULL),(2299,1473,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-11','18:16:00','130856','X',0,'2014-01-13 02:18:30',NULL,NULL),(2441,1500,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:31',NULL,NULL),(2927,2702,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',0,'2014-01-23 06:41:42',NULL,NULL),(3445,2791,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-10','18:27:00','184756','X',0,'2014-02-10 21:00:07',NULL,NULL),(588,39,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-17','18:43:00','78037','X',0,'2013-12-25 21:51:18',NULL,NULL),(975,60,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-12','18:03:00','24207','X',0,'2013-12-26 01:00:34',NULL,NULL),(1412,93,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-24','01:56:00','90948','X',0,'2013-12-26 13:09:50',NULL,NULL),(1586,385,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-30','19:01:00','109533','X',0,'2014-01-01 12:04:23',NULL,NULL),(3076,2759,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-27','18:27:00','158016','X',0,'2014-01-27 21:01:37',NULL,NULL),(4307,2847,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-06','18:51:00','245608','X',0,'2014-03-06 21:02:56',NULL,NULL),(152,8,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-10-31','18:04:00','15477','X',0,'2013-12-25 18:10:12',NULL,NULL),(431,29,'005010X220A1','BE','OH0','92036','92036OH0040032','2013-12-06','18:21:00','55541','X',0,'2013-12-25 20:19:45',NULL,NULL),(503,37,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-22','18:40:00','88457','X',0,'2013-12-25 21:17:39',NULL,NULL),(521,37,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-22','18:40:00','88482','X',0,'2013-12-25 21:22:55',NULL,NULL),(693,43,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-10','18:01:00','7174','X',0,'2013-12-25 22:31:07',NULL,NULL),(914,56,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-10-16','20:51:00','10067','X',0,'2013-12-26 00:31:06',NULL,NULL),(1514,380,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-27','18:44:00','101838','X',0,'2013-12-28 03:37:19',NULL,NULL),(1567,383,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-29','18:10:00','107249','X',0,'2013-12-30 00:01:48',NULL,NULL),(1577,383,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-29','18:10:00','107259','X',0,'2013-12-30 00:02:22',NULL,NULL),(1732,570,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-03','19:07:00','117547','X',0,'2014-01-04 06:00:12',NULL,NULL),(2270,1471,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-07','18:29:00','123268','X',0,'2014-01-08 18:23:56',NULL,NULL),(2430,1489,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:22',NULL,NULL),(2740,2555,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-21','18:24:00','147875','X',1,'2014-01-22 03:22:29',NULL,NULL),(2775,2556,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-22','18:31:00','150816','X',0,'2014-01-23 03:02:47',NULL,NULL),(3064,2759,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-27','18:27:00','158004','X',0,'2014-01-27 21:00:41',NULL,NULL),(3877,2816,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-21','18:31:00','212805','X',0,'2014-02-21 22:00:57',NULL,NULL),(134,7,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-16','18:37:00','74947','X',0,'2013-12-25 18:08:14',NULL,NULL),(259,19,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-24','18:40:00','96820','X',0,'2013-12-25 18:57:54',NULL,NULL),(898,54,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-10-02','18:00:00','5090','X',0,'2013-12-26 00:17:01',NULL,NULL),(2366,1476,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-10','18:26:00','129723','X',0,'2014-01-13 02:23:53',NULL,NULL),(2656,2551,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-17','18:23:00','142622','X',0,'2014-01-20 08:05:59',NULL,NULL),(3402,2788,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-09','18:12:00','181782','X',0,'2014-02-09 19:00:05',NULL,NULL),(4250,2846,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-05','18:49:00','241584','X',0,'2014-03-05 21:31:12',NULL,NULL),(184,13,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-03','18:20:00','49890','X',0,'2013-12-25 18:19:19',NULL,NULL),(698,44,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-04','18:00:00','5522','X',0,'2013-12-25 22:31:30',NULL,NULL),(1207,76,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-22','18:08:00','35661','X',0,'2013-12-26 03:15:50',NULL,NULL),(2575,2311,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-14','19:00:00','136132','X',0,'2014-01-15 02:08:07',NULL,NULL),(3393,2786,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-08','18:12:00','180305','X',0,'2014-02-08 19:01:01',NULL,NULL),(4273,2846,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-05','18:49:00','241607','X',0,'2014-03-05 21:32:43',NULL,NULL),(327,22,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-09','18:28:00','61497','X',0,'2013-12-25 19:34:07',NULL,NULL),(455,31,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-18','18:07:00','30648','X',0,'2013-12-25 20:30:44',NULL,NULL),(743,47,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-19','19:11:00','81729','X',0,'2013-12-25 23:08:51',NULL,NULL),(2146,1393,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:17',NULL,NULL),(2444,1503,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:34',NULL,NULL),(3967,2823,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-22','18:14:00','213811','X',0,'2014-02-26 08:30:53',NULL,NULL),(333,22,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-09','18:28:00','61503','X',0,'2013-12-25 19:36:13',NULL,NULL),(597,39,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-17','18:43:00','78046','X',0,'2013-12-25 21:52:36',NULL,NULL),(1438,93,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-24','01:56:00','90975','X',0,'2013-12-26 13:16:11',NULL,NULL),(1716,569,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-03','18:38:00','116015','X',0,'2014-01-04 02:05:37',NULL,NULL),(2049,1296,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:06',NULL,NULL),(2644,2540,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-01-16','18:41:00','141420','X',0,'2014-01-17 03:36:36',NULL,NULL),(3137,2772,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-29','18:30:00','161359','X',0,'2014-01-29 21:01:51',NULL,NULL),(3266,2778,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-02-04','18:29:00','172108','X',0,'2014-02-04 21:01:16',NULL,NULL),(335,22,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-09','18:28:00','61505','X',0,'2013-12-25 19:36:19',NULL,NULL),(1248,80,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-18','18:49:00','79078','X',0,'2013-12-26 04:08:31',NULL,NULL),(1689,568,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-02','18:42:00','115213','X',0,'2014-01-03 02:06:33',NULL,NULL),(2473,1532,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:26',NULL,NULL),(2973,2748,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','10:03:00','1','X',0,'2014-01-23 15:30:02',NULL,NULL),(3131,2772,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-29','18:30:00','161353','X',0,'2014-01-29 21:01:42',NULL,NULL),(3479,2792,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-10','18:30:00','186465','X',0,'2014-02-10 21:32:13',NULL,NULL),(3646,2799,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-14','18:39:00','196139','X',0,'2014-02-14 21:32:10',NULL,NULL),(3829,2812,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-19','18:32:00','206168','X',0,'2014-02-20 05:40:26',NULL,NULL),(4359,2850,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-07','18:46:00','247674','X',0,'2014-03-07 21:32:06',NULL,NULL),(4402,2853,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-03-09','18:20:00','252247','X',0,'2014-03-09 21:00:05',NULL,NULL),(218,15,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-04','18:02:00','18532','X',0,'2013-12-25 18:31:25',NULL,NULL),(254,19,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-24','18:40:00','96815','X',0,'2013-12-25 18:56:53',NULL,NULL),(607,39,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-17','18:43:00','78056','X',0,'2013-12-25 21:53:22',NULL,NULL),(3831,2813,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-20','18:26:00','208217','X',0,'2014-02-20 21:30:05',NULL,NULL),(3871,2816,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-21','18:31:00','212799','X',0,'2014-02-21 22:00:23',NULL,NULL),(67,5,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-09','18:02:00','22418','X',0,'2013-12-25 17:32:25',NULL,NULL),(89,6,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-04','18:22:00','52137','X',0,'2013-12-25 17:50:32',NULL,NULL),(99,6,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-04','18:22:00','52147','X',0,'2013-12-25 17:51:05',NULL,NULL),(1425,93,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-24','01:56:00','90961','X',0,'2013-12-26 13:14:03',NULL,NULL),(1624,386,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-01','18:18:00','112809','X',1,'2014-01-02 04:24:29',NULL,NULL),(2213,1460,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:23',NULL,NULL),(3160,2773,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-01-30','18:35:00','164081','X',0,'2014-01-30 21:01:31',NULL,NULL),(3398,2787,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-08','18:12:00','180829','X',0,'2014-02-08 19:30:08',NULL,NULL),(3579,2797,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-13','18:41:00','192641','X',0,'2014-02-13 21:30:17',NULL,NULL),(3584,2798,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-13','18:46:00','194307','X',0,'2014-02-13 22:01:52',NULL,NULL),(3818,2810,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-19','18:35:00','207808','X',0,'2014-02-20 04:56:20',NULL,NULL),(44,3,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-13','18:04:00','25391','X',0,'2013-12-25 17:30:48',NULL,NULL),(1131,71,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-15','18:15:00','73622','X',0,'2013-12-26 02:33:56',NULL,NULL),(1440,93,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-24','01:56:00','90978','X',0,'2013-12-26 13:16:20',NULL,NULL),(2279,1471,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-01-07','18:29:00','123277','X',0,'2014-01-08 18:24:57',NULL,NULL),(3145,2773,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-30','18:35:00','164066','X',0,'2014-01-30 21:00:46',NULL,NULL),(3183,2774,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-31','18:37:00','165925','X',0,'2014-01-31 21:01:28',NULL,NULL),(772,48,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-27','18:05:00','41572','X',0,'2013-12-25 23:15:02',NULL,NULL),(1011,63,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-25','18:07:00','38449','X',0,'2013-12-26 01:16:49',NULL,NULL),(1201,75,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-20','19:06:00','84239','X',0,'2013-12-26 03:11:04',NULL,NULL),(1311,82,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-21','18:37:00','86520','X',0,'2013-12-26 04:38:43',NULL,NULL),(2106,1353,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:45',NULL,NULL),(2451,1510,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:40',NULL,NULL),(3148,2773,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-30','18:35:00','164069','X',0,'2014-01-30 21:00:56',NULL,NULL),(3603,2798,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-13','18:46:00','194326','X',0,'2014-02-13 22:02:59',NULL,NULL),(4021,2825,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-26','18:43:00','223777','X',0,'2014-02-26 21:02:47',NULL,NULL),(82,6,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-04','18:22:00','52130','X',0,'2013-12-25 17:49:56',NULL,NULL),(703,45,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-26','18:04:00','14000','X',0,'2013-12-25 22:31:44',NULL,NULL),(2984,2755,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-01-23','18:27:00','151580','X',0,'2014-01-23 21:00:54',NULL,NULL),(3107,2760,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-28','18:32:00','160258','X',0,'2014-01-28 21:01:20',NULL,NULL),(4128,2832,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-01','18:23:00','232015','X',0,'2014-03-01 21:00:43',NULL,NULL),(4215,2843,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-04','18:50:00','238762','X',0,'2014-03-04 21:02:26',NULL,NULL),(551,38,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-13','18:39:00','69277','X',0,'2013-12-25 21:37:01',NULL,NULL),(684,42,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-11-08','18:03:00','21240','X',0,'2013-12-25 22:30:32',NULL,NULL),(1119,71,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-15','18:15:00','73610','X',0,'2013-12-26 02:33:06',NULL,NULL),(1211,76,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-22','18:08:00','35665','X',0,'2013-12-26 03:16:12',NULL,NULL),(567,38,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-13','18:39:00','69293','X',0,'2013-12-25 21:38:43',NULL,NULL),(867,52,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-01','18:08:00','46314','X',0,'2013-12-26 00:02:14',NULL,NULL),(1511,380,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-27','18:44:00','101835','X',0,'2013-12-28 03:37:11',NULL,NULL),(1889,1136,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:06',NULL,NULL),(2552,2311,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-14','19:00:00','136109','X',0,'2014-01-15 02:06:47',NULL,NULL),(2880,2655,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:40:00','1','X',1,'2014-01-23 04:29:33',NULL,NULL),(3047,2758,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-26','18:09:00','156587','X',0,'2014-01-26 19:00:02',NULL,NULL),(3928,2819,'005010X220A1','BE','OH0','92036','92036OH0010008','2014-02-25','18:36:00','220700','X',0,'2014-02-25 21:32:10',NULL,NULL),(2426,1485,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:18',NULL,NULL),(2638,2540,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-16','18:41:00','141414','X',0,'2014-01-17 03:36:33',NULL,NULL),(2949,2724,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:46:00','1','X',0,'2014-01-23 08:00:02',NULL,NULL),(3917,2819,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-25','18:36:00','220689','X',0,'2014-02-25 21:31:49',NULL,NULL),(610,39,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-17','18:43:00','78059','X',0,'2013-12-25 21:53:34',NULL,NULL),(775,48,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-27','18:05:00','41575','X',0,'2013-12-25 23:15:50',NULL,NULL),(1139,72,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-17','18:03:00','29568','X',0,'2013-12-26 02:45:34',NULL,NULL),(2856,2631,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:26:00','1','X',1,'2014-01-23 04:13:53',NULL,NULL),(3041,2757,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-25','18:11:00','155342','X',0,'2014-01-25 19:00:17',NULL,NULL),(3119,2772,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-29','18:30:00','161341','X',0,'2014-01-29 21:01:00',NULL,NULL),(3583,2798,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-13','18:46:00','194306','X',0,'2014-02-13 22:01:15',NULL,NULL),(463,31,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-18','18:07:00','30654','X',0,'2013-12-25 20:31:50',NULL,NULL),(721,46,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-07','18:13:00','57439','X',0,'2013-12-25 22:47:38',NULL,NULL),(1646,387,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-31','18:52:00','111685','X',1,'2014-01-02 04:34:24',NULL,NULL),(2126,1373,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:21',NULL,NULL),(2491,1550,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:42',NULL,NULL),(2658,2551,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-17','18:23:00','142624','X',0,'2014-01-20 08:06:09',NULL,NULL),(2680,2552,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-18','18:11:00','144578','X',0,'2014-01-21 08:44:21',NULL,NULL),(3661,2800,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-14','18:36:00','195039','X',0,'2014-02-14 22:00:06',NULL,NULL),(3751,2808,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-18','18:28:00','204265','X',0,'2014-02-18 22:00:59',NULL,NULL),(4482,2856,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-10','19:17:00','254169','X',0,'2014-03-10 21:30:17',NULL,NULL),(21,1,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-05','18:31:00','54196','X',0,'2013-12-25 17:21:19',NULL,NULL),(887,53,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-21','18:06:00','34265','X',0,'2013-12-26 00:16:14',NULL,NULL),(1346,84,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-10-21','18:04:00','11688','X',0,'2013-12-26 05:00:57',NULL,NULL),(1644,387,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-31','18:52:00','111683','X',1,'2014-01-02 04:34:10',NULL,NULL),(2503,1562,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:53',NULL,NULL),(2868,2643,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:28:00','1','X',1,'2014-01-23 04:19:09',NULL,NULL),(4044,2826,'005010X220A1','BE','MS0','46300','46300MS0010001','2014-02-27','18:48:00','225938','X',0,'2014-02-28 06:31:43',NULL,NULL),(1504,380,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-27','18:44:00','101828','X',0,'2013-12-28 03:36:52',NULL,NULL),(1616,386,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-01','18:18:00','112801','X',1,'2014-01-02 04:22:08',NULL,NULL),(2723,2554,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-20','18:21:00','146902','X',0,'2014-01-21 08:46:49',NULL,NULL),(3944,2820,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-02-23','18:10:00','215490','X',0,'2014-02-26 08:00:32',NULL,NULL),(4039,2826,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-27','18:48:00','225933','X',0,'2014-02-28 06:31:36',NULL,NULL),(847,51,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-24','03:40:00','94586','X',0,'2013-12-25 23:51:52',NULL,NULL),(1409,93,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-24','01:56:00','90945','X',0,'2013-12-26 13:07:09',NULL,NULL),(3973,2824,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-24','18:21:00','218485','X',0,'2014-02-26 09:30:03',NULL,NULL),(4136,2832,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-01','18:23:00','232023','X',0,'2014-03-01 21:01:06',NULL,NULL),(55,4,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-11','18:01:00','7635','X',0,'2013-12-25 17:31:35',NULL,NULL),(827,51,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-24','03:40:00','94566','X',0,'2013-12-25 23:47:30',NULL,NULL),(2981,2755,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-23','18:27:00','151577','X',0,'2014-01-23 21:00:26',NULL,NULL),(3475,2792,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-10','18:30:00','186461','X',0,'2014-02-10 21:32:08',NULL,NULL),(167,10,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-19','18:01:00','10695','X',0,'2013-12-25 18:11:04',NULL,NULL),(822,50,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-11-26','18:20:00','40547','X',0,'2013-12-25 23:33:04',NULL,NULL),(1998,1245,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:43',NULL,NULL),(2052,1299,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:14',NULL,NULL),(2959,2734,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:05:00','1','X',0,'2014-01-23 09:30:03',NULL,NULL),(3262,2778,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-04','18:29:00','172104','X',0,'2014-02-04 21:00:50',NULL,NULL),(3963,2823,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-22','18:14:00','213805','X',0,'2014-02-26 08:30:49',NULL,NULL),(3981,2824,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-24','18:21:00','218493','X',0,'2014-02-26 09:30:48',NULL,NULL),(4034,2826,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-27','18:48:00','225928','X',0,'2014-02-28 06:31:28',NULL,NULL),(4126,2832,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-01','18:23:00','232013','X',0,'2014-03-01 21:00:28',NULL,NULL),(1082,68,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-14','18:21:00','71351','X',0,'2013-12-26 02:03:53',NULL,NULL),(1090,69,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-23','18:05:00','36680','X',0,'2013-12-26 02:15:24',NULL,NULL),(1475,99,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-26','18:41:00','100565','X',0,'2013-12-27 02:07:30',NULL,NULL),(2470,1529,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:23',NULL,NULL),(2588,2539,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-15','18:30:00','138450','X',0,'2014-01-16 08:45:46',NULL,NULL),(2924,2699,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:22:00','1','X',0,'2014-01-23 06:40:34',NULL,NULL),(3815,2811,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-19','18:35:00','207807','X',0,'2014-02-20 04:55:51',NULL,NULL),(4054,2827,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-26','18:39:00','222053','X',0,'2014-02-28 07:00:10',NULL,NULL),(4186,2836,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-03','18:33:00','236082','X',0,'2014-03-03 21:31:36',NULL,NULL),(4425,2853,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-09','18:20:00','252270','X',0,'2014-03-09 21:01:19',NULL,NULL),(4469,2855,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-10','19:23:00','255944','X',0,'2014-03-10 21:02:58',NULL,NULL),(189,13,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-03','18:20:00','49895','X',0,'2013-12-25 18:20:40',NULL,NULL),(228,16,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-10-25','18:01:00','13419','X',0,'2013-12-25 18:32:03',NULL,NULL),(383,23,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-02','18:14:00','47699','X',0,'2013-12-25 19:50:23',NULL,NULL),(485,34,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-06','18:02:00','6431','X',0,'2013-12-25 20:46:11',NULL,NULL),(1700,568,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-02','18:42:00','115225','X',0,'2014-01-03 02:07:22',NULL,NULL),(2323,1474,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-09','18:28:00','127863','X',0,'2014-01-13 02:20:37',NULL,NULL),(2827,2602,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 03:51:46',NULL,NULL),(3237,2777,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-03','18:32:00','170199','X',0,'2014-02-03 21:00:42',NULL,NULL),(3633,2799,'005010X220A1','BE','OH0','92036','92036OH0010012','2014-02-14','18:39:00','196126','X',0,'2014-02-14 21:31:40',NULL,NULL),(561,38,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-13','18:39:00','69287','X',0,'2013-12-25 21:37:59',NULL,NULL),(1196,75,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-20','19:06:00','84234','X',0,'2013-12-26 03:10:40',NULL,NULL),(1933,1180,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:07',NULL,NULL),(1971,1218,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:53',NULL,NULL),(2034,1281,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:24',NULL,NULL),(2092,1339,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:02:05',NULL,NULL),(2308,1473,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-11','18:16:00','130865','X',0,'2014-01-13 02:18:41',NULL,NULL),(2396,1477,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-10','18:26:00','129751','X',0,'2014-01-13 03:00:42',NULL,NULL),(4134,2832,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-01','18:23:00','232021','X',0,'2014-03-01 21:01:04',NULL,NULL),(340,22,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-09','18:28:00','61510','X',0,'2013-12-25 19:36:58',NULL,NULL),(669,41,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-08','18:10:00','59426','X',0,'2013-12-25 22:17:02',NULL,NULL),(811,50,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-11-26','18:20:00','40536','X',0,'2013-12-25 23:32:20',NULL,NULL),(1527,381,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-28','18:14:00','103719','X',1,'2013-12-29 11:09:53',NULL,NULL),(2114,1361,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:48',NULL,NULL),(2414,1478,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-12','18:13:00','132598','X',0,'2014-01-13 03:01:53',NULL,NULL),(3069,2759,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-27','18:27:00','158009','X',0,'2014-01-27 21:01:22',NULL,NULL),(3118,2772,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-29','18:30:00','161340','X',0,'2014-01-29 21:00:44',NULL,NULL),(3785,2809,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-19','18:35:00','207795','X',0,'2014-02-20 04:23:22',NULL,NULL),(3817,2811,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-19','18:35:00','207808','X',0,'2014-02-20 04:56:14',NULL,NULL),(812,50,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-26','18:20:00','40537','X',0,'2013-12-25 23:32:24',NULL,NULL),(2112,1359,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:42',NULL,NULL),(3758,2808,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-18','18:28:00','204272','X',0,'2014-02-18 22:01:23',NULL,NULL),(3977,2824,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-24','18:21:00','218489','X',0,'2014-02-26 09:30:13',NULL,NULL),(315,21,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-10','18:21:00','62764','X',0,'2013-12-25 19:20:38',NULL,NULL),(1539,382,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-28','21:04:00','105795','X',1,'2013-12-29 11:13:12',NULL,NULL),(1543,382,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-28','21:04:00','105799','X',1,'2013-12-29 11:14:13',NULL,NULL),(1621,386,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-01','18:18:00','112806','X',1,'2014-01-02 04:23:58',NULL,NULL),(1725,569,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-01-03','18:38:00','116024','X',0,'2014-01-04 02:06:11',NULL,NULL),(2353,1475,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-08','18:27:00','125989','X',0,'2014-01-13 02:22:34',NULL,NULL),(3125,2772,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-29','18:30:00','161347','X',0,'2014-01-29 21:01:32',NULL,NULL),(3954,2822,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-23','18:11:00','215778','X',0,'2014-02-26 08:00:49',NULL,NULL),(4305,2847,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-06','18:51:00','245606','X',0,'2014-03-06 21:02:54',NULL,NULL),(4436,2855,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-10','19:23:00','255911','X',0,'2014-03-10 21:00:43',NULL,NULL),(1001,62,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-11-05','18:03:00','19350','X',0,'2013-12-26 01:02:23',NULL,NULL),(1737,571,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-04','18:14:00','119139','X',0,'2014-01-05 00:01:37',NULL,NULL),(3028,2756,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-24','18:26:00','154308','X',0,'2014-01-24 21:01:16',NULL,NULL),(3528,2794,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-11','18:37:00','187472','X',0,'2014-02-11 21:30:26',NULL,NULL),(4427,2854,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-09','18:21:00','252847','X',0,'2014-03-09 21:29:58',NULL,NULL),(111,7,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-16','18:37:00','74924','X',0,'2013-12-25 18:06:31',NULL,NULL),(173,13,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-03','18:20:00','49879','X',0,'2013-12-25 18:15:01',NULL,NULL),(390,24,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-15','18:01:00','9473','X',0,'2013-12-25 20:00:11',NULL,NULL),(622,40,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-12','18:53:00','67242','X',0,'2013-12-25 22:05:08',NULL,NULL),(1002,63,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-25','18:07:00','38437','X',0,'2013-12-26 01:15:02',NULL,NULL),(1424,93,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-24','01:56:00','90960','X',0,'2013-12-26 13:13:43',NULL,NULL),(1921,1168,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:34',NULL,NULL),(1943,1190,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:35',NULL,NULL),(2172,1419,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:25:29',NULL,NULL),(3020,2756,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-24','18:26:00','154300','X',0,'2014-01-24 21:01:03',NULL,NULL),(3250,2777,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-03','18:32:00','170212','X',0,'2014-02-03 21:01:27',NULL,NULL),(3325,2782,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-06','18:28:00','175982','X',0,'2014-02-06 21:01:09',NULL,NULL),(432,29,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-06','18:21:00','55542','X',0,'2013-12-25 20:19:46',NULL,NULL),(1286,81,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-30','18:04:00','44826','X',0,'2013-12-26 04:16:10',NULL,NULL),(2249,1468,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-06','18:24:00','121996','X',0,'2014-01-07 04:06:45',NULL,NULL),(2464,1523,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:16',NULL,NULL),(2933,2708,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',0,'2014-01-23 06:45:45',NULL,NULL),(3075,2759,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-27','18:27:00','158015','X',0,'2014-01-27 21:01:35',NULL,NULL),(3088,2760,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-28','18:32:00','160239','X',0,'2014-01-28 21:00:03',NULL,NULL),(3693,2802,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-15','18:48:00','199885','X',0,'2014-02-15 22:02:02',NULL,NULL),(3726,2806,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-17','18:05:00','202224','X',0,'2014-02-17 19:00:10',NULL,NULL),(1427,93,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-24','01:56:00','90963','X',0,'2013-12-26 13:14:42',NULL,NULL),(1463,99,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-26','18:41:00','100553','X',0,'2013-12-27 02:06:00',NULL,NULL),(3458,2792,'005010X220A1','BE','OH0','92036','92036OH0010008','2014-02-10','18:30:00','186444','X',0,'2014-02-10 21:31:17',NULL,NULL),(4351,2850,'005010X220A1','BE','OH0','92036','92036OH0010027','2014-03-07','18:46:00','247666','X',0,'2014-03-07 21:31:59',NULL,NULL),(409,28,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-08','18:00:00','6874','X',0,'2013-12-25 20:02:08',NULL,NULL),(1244,80,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-18','18:49:00','79074','X',0,'2013-12-26 04:08:02',NULL,NULL),(3727,2806,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-17','18:05:00','202225','X',0,'2014-02-17 19:00:11',NULL,NULL),(3930,2820,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-23','18:10:00','215476','X',0,'2014-02-26 08:00:04',NULL,NULL),(4372,2850,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-07','18:46:00','247687','X',0,'2014-03-07 21:32:26',NULL,NULL),(5,1,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-05','18:31:00','54180','X',0,'2013-12-25 17:18:12',NULL,NULL),(32,1,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-05','18:31:00','54207','X',0,'2013-12-25 17:22:00',NULL,NULL),(464,31,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-18','18:07:00','30655','X',0,'2013-12-25 20:31:58',NULL,NULL),(852,51,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-24','03:40:00','94591','X',0,'2013-12-25 23:52:03',NULL,NULL),(923,57,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-19','18:07:00','31310','X',0,'2013-12-26 00:31:49',NULL,NULL),(1026,64,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-11-14','18:05:00','25962','X',0,'2013-12-26 01:31:01',NULL,NULL),(1668,387,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-12-31','18:52:00','111707','X',1,'2014-01-02 04:36:10',NULL,NULL),(1982,1229,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:27',NULL,NULL),(2233,1468,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-06','18:24:00','121979','X',0,'2014-01-07 04:04:52',NULL,NULL),(2579,2311,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-01-14','19:00:00','136136','X',0,'2014-01-15 02:08:09',NULL,NULL),(2582,2311,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-14','19:00:00','136139','X',0,'2014-01-15 02:08:12',NULL,NULL),(2645,2540,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-16','18:41:00','141421','X',0,'2014-01-17 03:36:37',NULL,NULL),(2704,2553,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-19','18:08:00','145211','X',0,'2014-01-21 08:45:35',NULL,NULL),(3109,2760,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-28','18:32:00','160260','X',0,'2014-01-28 21:01:21',NULL,NULL),(3855,2814,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-20','18:28:00','208922','X',0,'2014-02-20 22:01:35',NULL,NULL),(4319,2848,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-06','18:46:00','243740','X',0,'2014-03-06 21:30:22',NULL,NULL),(2483,1542,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:35',NULL,NULL),(3334,2782,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-06','18:28:00','175991','X',0,'2014-02-06 21:01:36',NULL,NULL),(1097,69,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-23','18:05:00','36687','X',0,'2013-12-26 02:16:16',NULL,NULL),(2174,1421,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:25:35',NULL,NULL),(2702,2553,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-19','18:08:00','145209','X',0,'2014-01-21 08:45:34',NULL,NULL),(2737,2555,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-21','18:24:00','147872','X',1,'2014-01-22 03:21:59',NULL,NULL),(3168,2773,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-30','18:35:00','164089','X',0,'2014-01-30 21:01:40',NULL,NULL),(4264,2846,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-05','18:49:00','241598','X',0,'2014-03-05 21:32:31',NULL,NULL),(113,7,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-16','18:37:00','74926','X',0,'2013-12-25 18:06:38',NULL,NULL),(154,8,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-31','18:04:00','15479','X',0,'2013-12-25 18:10:18',NULL,NULL),(599,39,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-17','18:43:00','78048','X',0,'2013-12-25 21:52:46',NULL,NULL),(816,50,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-11-26','18:20:00','40541','X',0,'2013-12-25 23:32:48',NULL,NULL),(2050,1297,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:08',NULL,NULL),(2236,1468,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-06','18:24:00','121982','X',0,'2014-01-07 04:05:28',NULL,NULL),(2338,1475,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-08','18:27:00','125974','X',0,'2014-01-13 02:21:34',NULL,NULL),(306,21,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-10','18:21:00','62755','X',0,'2013-12-25 19:19:44',NULL,NULL),(310,21,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-10','18:21:00','62759','X',0,'2013-12-25 19:19:54',NULL,NULL),(1480,99,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-26','18:41:00','100570','X',0,'2013-12-27 02:07:45',NULL,NULL),(1605,385,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-30','19:01:00','109552','X',0,'2014-01-01 12:08:55',NULL,NULL),(2506,1565,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:56',NULL,NULL),(3136,2772,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-29','18:30:00','161358','X',0,'2014-01-29 21:01:49',NULL,NULL),(308,21,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-10','18:21:00','62757','X',0,'2013-12-25 19:19:50',NULL,NULL),(725,46,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-07','18:13:00','57443','X',0,'2013-12-25 22:47:52',NULL,NULL),(1421,93,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-24','01:56:00','90957','X',0,'2013-12-26 13:12:43',NULL,NULL),(1544,382,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-28','21:04:00','105800','X',1,'2013-12-29 11:14:24',NULL,NULL),(2155,1402,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:42',NULL,NULL),(3027,2756,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-24','18:26:00','154307','X',0,'2014-01-24 21:01:15',NULL,NULL),(3099,2760,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-28','18:32:00','160250','X',0,'2014-01-28 21:01:10',NULL,NULL),(3502,2793,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-02-11','18:41:00','189056','X',0,'2014-02-11 21:02:34',NULL,NULL),(3518,2794,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-11','18:37:00','187462','X',0,'2014-02-11 21:30:02',NULL,NULL),(4192,2836,'005010X220A1','BE','MS0','46300','46300MS0010001','2014-03-03','18:33:00','236088','X',0,'2014-03-03 21:31:53',NULL,NULL),(4393,2852,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-08','18:43:00','250665','X',0,'2014-03-08 21:31:12',NULL,NULL),(318,21,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-10','18:21:00','62767','X',0,'2013-12-25 19:20:55',NULL,NULL),(489,35,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-28','18:02:00','42792','X',0,'2013-12-25 20:46:25',NULL,NULL),(726,46,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-07','18:13:00','57444','X',0,'2013-12-25 22:47:55',NULL,NULL),(834,51,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-24','03:40:00','94573','X',0,'2013-12-25 23:50:31',NULL,NULL),(2273,1471,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-07','18:29:00','123271','X',0,'2014-01-08 18:24:22',NULL,NULL),(3396,2787,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-08','18:12:00','180827','X',0,'2014-02-08 19:30:04',NULL,NULL),(3532,2795,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-12','18:27:00','189877','X',0,'2014-02-12 21:00:09',NULL,NULL),(62,5,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-09','18:02:00','22414','X',0,'2013-12-25 17:32:09',NULL,NULL),(740,47,'005010X220A1','BE','OH0','92036','92036OH0010032','2013-12-19','19:11:00','81726','X',0,'2013-12-25 23:07:50',NULL,NULL),(799,49,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-06','18:03:00','20435','X',0,'2013-12-25 23:17:18',NULL,NULL),(3801,2811,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-19','18:35:00','207801','X',0,'2014-02-20 04:51:23',NULL,NULL),(443,29,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-06','18:21:00','55553','X',0,'2013-12-25 20:20:25',NULL,NULL),(882,53,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-21','18:06:00','34260','X',0,'2013-12-26 00:15:02',NULL,NULL),(1400,92,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-24','01:56:00','90937','X',0,'2013-12-26 12:49:39',NULL,NULL),(3087,2759,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-27','18:27:00','158027','X',0,'2014-01-27 21:01:50',NULL,NULL),(3251,2777,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-03','18:32:00','170213','X',0,'2014-02-03 21:01:30',NULL,NULL),(3311,2781,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-05','18:39:00','174421','X',0,'2014-02-05 21:31:15',NULL,NULL),(3664,2801,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-15','18:44:00','198279','X',0,'2014-02-15 21:00:02',NULL,NULL),(4277,2847,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-06','18:51:00','245577','X',0,'2014-03-06 21:00:41',NULL,NULL),(4315,2848,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-06','18:46:00','243736','X',0,'2014-03-06 21:30:13',NULL,NULL),(500,37,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-22','18:40:00','88451','X',0,'2013-12-25 21:15:02',NULL,NULL),(1116,71,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-15','18:15:00','73607','X',0,'2013-12-26 02:32:29',NULL,NULL),(2878,2653,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:01:00','1','X',1,'2014-01-23 04:26:58',NULL,NULL),(3351,2784,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-07','18:14:00','177560','X',0,'2014-02-07 19:00:17',NULL,NULL),(4043,2826,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-27','18:48:00','225937','X',0,'2014-02-28 06:31:42',NULL,NULL),(4199,2843,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-04','18:50:00','238746','X',0,'2014-03-04 21:00:09',NULL,NULL),(4236,2844,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-04','18:46:00','237497','X',0,'2014-03-04 21:30:22',NULL,NULL),(1490,380,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-27','18:44:00','101814','X',0,'2013-12-28 03:31:50',NULL,NULL),(2113,1360,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:45',NULL,NULL),(2121,1368,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:07',NULL,NULL),(2454,1513,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:44',NULL,NULL),(2521,1576,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-13','18:44:00','133997','X',0,'2014-01-14 01:32:56',NULL,NULL),(2817,2592,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:47:40',NULL,NULL),(3254,2777,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-03','18:32:00','170216','X',0,'2014-02-03 21:01:34',NULL,NULL),(4241,2845,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-05','18:46:00','240509','X',0,'2014-03-05 21:00:23',NULL,NULL),(4420,2853,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-09','18:20:00','252265','X',0,'2014-03-09 21:01:12',NULL,NULL),(877,52,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-01','18:08:00','46324','X',0,'2013-12-26 00:02:42',NULL,NULL),(1117,71,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-15','18:15:00','73608','X',0,'2013-12-26 02:32:33',NULL,NULL),(1508,380,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-27','18:44:00','101832','X',0,'2013-12-28 03:37:04',NULL,NULL),(1955,1202,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:08',NULL,NULL),(2365,1476,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-10','18:26:00','129722','X',0,'2014-01-13 02:23:26',NULL,NULL),(2785,2560,'005010X231A1','FA','OH0','99734','99734OH0050003','2014-01-13','22:20:00','1','X',0,'2014-01-23 03:39:34',NULL,NULL),(2791,2566,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:19:00','1','X',1,'2014-01-23 03:40:36',NULL,NULL),(2865,2640,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 04:17:42',NULL,NULL),(3521,2794,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-11','18:37:00','187465','X',0,'2014-02-11 21:30:12',NULL,NULL),(3599,2798,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-13','18:46:00','194322','X',0,'2014-02-13 22:02:48',NULL,NULL),(3782,2810,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-19','18:35:00','207793','X',0,'2014-02-20 04:16:42',NULL,NULL),(3925,2819,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-25','18:36:00','220697','X',0,'2014-02-25 21:32:05',NULL,NULL),(3952,2821,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-24','18:19:00','217104','X',0,'2014-02-26 08:00:46',NULL,NULL),(434,29,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-06','18:21:00','55544','X',0,'2013-12-25 20:19:54',NULL,NULL),(520,37,'005010X220A1','BE','IN0','92036','92036OH0020015','2013-12-22','18:40:00','88481','X',0,'2013-12-25 21:22:52',NULL,NULL),(1092,69,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-23','18:05:00','36682','X',0,'2013-12-26 02:15:37',NULL,NULL),(1193,75,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-20','19:06:00','84231','X',0,'2013-12-26 03:10:31',NULL,NULL),(1322,82,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-21','18:37:00','86539','X',0,'2013-12-26 04:39:45',NULL,NULL),(1960,1207,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:22',NULL,NULL),(2934,2709,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',0,'2014-01-23 06:45:52',NULL,NULL),(449,30,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-13','18:01:00','8423','X',0,'2013-12-25 20:30:28',NULL,NULL),(1113,71,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-15','18:15:00','73604','X',0,'2013-12-26 02:31:58',NULL,NULL),(2010,1257,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:17',NULL,NULL),(3147,2773,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-30','18:35:00','164068','X',0,'2014-01-30 21:00:53',NULL,NULL),(3298,2781,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-05','18:39:00','174408','X',0,'2014-02-05 21:30:47',NULL,NULL),(3424,2790,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-10','05:02:00','183697','X',0,'2014-02-10 11:00:40',NULL,NULL),(991,62,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-05','18:03:00','19338','X',0,'2013-12-26 01:01:48',NULL,NULL),(1458,99,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-26','18:41:00','100548','X',0,'2013-12-27 02:05:03',NULL,NULL),(2675,2552,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-18','18:11:00','144573','X',0,'2014-01-21 08:44:11',NULL,NULL),(2771,2556,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-22','18:31:00','150812','X',0,'2014-01-23 03:02:29',NULL,NULL),(3014,2756,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-24','18:26:00','154294','X',0,'2014-01-24 21:00:50',NULL,NULL),(3278,2778,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-04','18:29:00','172120','X',0,'2014-02-04 21:01:52',NULL,NULL),(1957,1204,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:14',NULL,NULL),(3038,2757,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-25','18:11:00','155339','X',0,'2014-01-25 19:00:12',NULL,NULL),(3340,2782,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-06','18:28:00','175997','X',0,'2014-02-06 21:01:47',NULL,NULL),(3921,2819,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-25','18:36:00','220693','X',0,'2014-02-25 21:31:56',NULL,NULL),(3938,2820,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-23','18:10:00','215484','X',0,'2014-02-26 08:00:26',NULL,NULL),(4434,2855,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-10','19:23:00','255909','X',0,'2014-03-10 20:59:59',NULL,NULL),(475,33,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-01','18:03:00','16375','X',0,'2013-12-25 20:45:31',NULL,NULL),(727,46,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-07','18:13:00','57445','X',0,'2013-12-25 22:47:58',NULL,NULL),(1242,80,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-18','18:49:00','79072','X',0,'2013-12-26 04:07:49',NULL,NULL),(1337,83,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-15','18:34:00','27233','X',0,'2013-12-26 04:46:09',NULL,NULL),(1693,568,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-02','18:42:00','115217','X',0,'2014-01-03 02:06:56',NULL,NULL),(2252,1468,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-01-06','18:24:00','121999','X',0,'2014-01-07 04:06:54',NULL,NULL),(3192,2774,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-31','18:37:00','165934','X',0,'2014-01-31 21:01:41',NULL,NULL),(269,19,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-24','18:40:00','96830','X',0,'2013-12-25 18:59:08',NULL,NULL),(370,23,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-02','18:14:00','47686','X',0,'2013-12-25 19:49:00',NULL,NULL),(579,39,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-17','18:43:00','78028','X',0,'2013-12-25 21:47:00',NULL,NULL),(1217,76,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-11-22','18:08:00','35671','X',0,'2013-12-26 03:16:27',NULL,NULL),(2422,1481,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:15',NULL,NULL),(2476,1535,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:29',NULL,NULL),(2964,2739,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:08:00','1','X',0,'2014-01-23 11:00:02',NULL,NULL),(3415,2789,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-09','18:11:00','181289','X',0,'2014-02-09 19:00:40',NULL,NULL),(3416,2789,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-09','18:11:00','181290','X',0,'2014-02-09 19:00:41',NULL,NULL),(4026,2826,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-27','18:48:00','225920','X',0,'2014-02-28 06:30:38',NULL,NULL),(4298,2847,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-06','18:51:00','245598','X',0,'2014-03-06 21:02:45',NULL,NULL),(490,35,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-28','18:02:00','42797','X',0,'2013-12-25 20:46:40',NULL,NULL),(598,39,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-17','18:43:00','78047','X',0,'2013-12-25 21:52:39',NULL,NULL),(776,48,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-27','18:05:00','41576','X',0,'2013-12-25 23:15:51',NULL,NULL),(1250,80,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-18','18:49:00','79080','X',0,'2013-12-26 04:08:42',NULL,NULL),(1611,385,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-30','19:01:00','109558','X',0,'2014-01-01 12:09:21',NULL,NULL),(2013,1260,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:58:25',NULL,NULL),(2434,1493,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:25',NULL,NULL),(3556,2796,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-12','18:31:00','191464','X',0,'2014-02-12 21:32:20',NULL,NULL),(4218,2843,'005010X220A1','BE','OH0','92036','92036OH0010008','2014-03-04','18:50:00','238765','X',0,'2014-03-04 21:02:35',NULL,NULL),(4266,2846,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-03-05','18:49:00','241600','X',0,'2014-03-05 21:32:36',NULL,NULL),(209,14,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-29','18:04:00','43702','X',0,'2013-12-25 18:30:40',NULL,NULL),(998,62,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-05','18:03:00','19345','X',0,'2013-12-26 01:02:14',NULL,NULL),(1554,382,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-28','21:04:00','105810','X',1,'2013-12-29 11:15:04',NULL,NULL),(2302,1473,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-01-11','18:16:00','130859','X',0,'2014-01-13 02:18:36',NULL,NULL),(2322,1474,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-09','18:28:00','127862','X',0,'2014-01-13 02:20:26',NULL,NULL),(782,48,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-27','18:05:00','41582','X',0,'2013-12-25 23:16:19',NULL,NULL),(1296,82,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-21','18:37:00','86496','X',0,'2013-12-26 04:32:07',NULL,NULL),(2012,1259,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:23',NULL,NULL),(3252,2777,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-03','18:32:00','170214','X',0,'2014-02-03 21:01:32',NULL,NULL),(3310,2781,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-05','18:39:00','174420','X',0,'2014-02-05 21:31:14',NULL,NULL),(4033,2826,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-27','18:48:00','225927','X',0,'2014-02-28 06:31:27',NULL,NULL),(4047,2826,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-27','18:48:00','225941','X',0,'2014-02-28 06:31:46',NULL,NULL),(492,35,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-28','18:02:00','42795','X',0,'2013-12-25 20:46:49',NULL,NULL),(763,47,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-19','19:11:00','81749','X',0,'2013-12-25 23:11:00',NULL,NULL),(937,59,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-11','18:36:00','64770','X',0,'2013-12-26 00:48:33',NULL,NULL),(2181,1428,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:54',NULL,NULL),(2190,1437,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:26:19',NULL,NULL),(2221,1468,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-06','18:24:00','121967','X',0,'2014-01-07 04:00:02',NULL,NULL),(2710,2553,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-19','18:08:00','145217','X',0,'2014-01-21 08:45:43',NULL,NULL),(2946,2721,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',0,'2014-01-23 07:07:12',NULL,NULL),(2969,2744,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:05:00','1','X',0,'2014-01-23 13:30:02',NULL,NULL),(3026,2756,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-24','18:26:00','154306','X',0,'2014-01-24 21:01:14',NULL,NULL),(3209,2775,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-01','18:14:00','166678','X',0,'2014-02-01 19:00:45',NULL,NULL),(3229,2776,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-02','18:10:00','168378','X',0,'2014-02-02 19:00:31',NULL,NULL),(3506,2793,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-11','18:41:00','189060','X',0,'2014-02-11 21:02:40',NULL,NULL),(3620,2799,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-14','18:39:00','196113','X',0,'2014-02-14 21:30:02',NULL,NULL),(3927,2819,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-25','18:36:00','220699','X',0,'2014-02-25 21:32:08',NULL,NULL),(4327,2849,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-03-07','18:42:00','246113','X',0,'2014-03-07 21:00:23',NULL,NULL),(311,21,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-10','18:21:00','62760','X',0,'2013-12-25 19:20:05',NULL,NULL),(419,29,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-06','18:21:00','55529','X',0,'2013-12-25 20:18:21',NULL,NULL),(1686,568,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-02','18:42:00','115210','X',0,'2014-01-03 02:06:15',NULL,NULL),(1997,1244,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:41',NULL,NULL),(2585,2539,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-15','18:30:00','138447','X',0,'2014-01-16 08:44:47',NULL,NULL),(2693,2552,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-18','18:11:00','144591','X',0,'2014-01-21 08:44:47',NULL,NULL),(2739,2555,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-21','18:24:00','147874','X',1,'2014-01-22 03:22:21',NULL,NULL),(2961,2736,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:12:00','1','X',0,'2014-01-23 09:50:44',NULL,NULL),(3159,2773,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-30','18:35:00','164080','X',0,'2014-01-30 21:01:30',NULL,NULL),(4187,2836,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-03-03','18:33:00','236083','X',0,'2014-03-03 21:31:41',NULL,NULL),(145,8,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-31','18:04:00','15470','X',0,'2013-12-25 18:09:20',NULL,NULL),(456,31,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-18','18:07:00','30651','X',0,'2013-12-25 20:31:03',NULL,NULL),(529,37,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-22','18:40:00','88490','X',0,'2013-12-25 21:23:17',NULL,NULL),(1483,99,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-26','18:41:00','100573','X',0,'2013-12-27 02:07:54',NULL,NULL),(1675,568,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-01-02','18:42:00','115199','X',0,'2014-01-03 02:04:39',NULL,NULL),(2906,2681,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 05:06:28',NULL,NULL),(2930,2705,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:19:00','1','X',0,'2014-01-23 06:42:34',NULL,NULL),(3471,2792,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-10','18:30:00','186457','X',0,'2014-02-10 21:32:02',NULL,NULL),(3647,2799,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-14','18:39:00','196140','X',0,'2014-02-14 21:32:10',NULL,NULL),(4418,2853,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-09','18:20:00','252263','X',0,'2014-03-09 21:01:07',NULL,NULL),(983,61,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-16','18:03:00','28397','X',0,'2013-12-26 01:01:15',NULL,NULL),(1642,387,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-31','18:52:00','111681','X',1,'2014-01-02 04:33:17',NULL,NULL),(1872,1119,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:50:19',NULL,NULL),(2205,1452,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:01',NULL,NULL),(2944,2719,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',0,'2014-01-23 07:06:40',NULL,NULL),(3386,2786,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-08','18:12:00','180298','X',0,'2014-02-08 19:00:51',NULL,NULL),(3814,2810,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-19','18:35:00','207806','X',0,'2014-02-20 04:55:36',NULL,NULL),(312,21,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-10','18:21:00','62761','X',0,'2013-12-25 19:20:08',NULL,NULL),(381,23,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-02','18:14:00','47697','X',0,'2013-12-25 19:50:16',NULL,NULL),(720,46,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-07','18:13:00','57438','X',0,'2013-12-25 22:47:35',NULL,NULL),(988,62,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-05','18:03:00','19346','X',0,'2013-12-26 01:01:39',NULL,NULL),(2025,1272,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:59',NULL,NULL),(3072,2759,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-27','18:27:00','158012','X',0,'2014-01-27 21:01:32',NULL,NULL),(3784,2810,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-19','18:35:00','207794','X',0,'2014-02-20 04:22:52',NULL,NULL),(4014,2825,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-26','18:43:00','223769','X',0,'2014-02-26 21:02:41',NULL,NULL),(4373,2850,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-03-07','18:46:00','247688','X',0,'2014-03-07 21:32:28',NULL,NULL),(362,23,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-02','18:14:00','47678','X',0,'2013-12-25 19:46:39',NULL,NULL),(755,47,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-19','19:11:00','81741','X',0,'2013-12-25 23:10:15',NULL,NULL),(861,52,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-01','18:08:00','46308','X',0,'2013-12-26 00:00:52',NULL,NULL),(1326,82,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-21','18:37:00','86543','X',0,'2013-12-26 04:39:59',NULL,NULL),(1594,385,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-30','19:01:00','109541','X',0,'2014-01-01 12:07:53',NULL,NULL),(1874,1121,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:25',NULL,NULL),(2985,2755,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-23','18:27:00','151581','X',0,'2014-01-23 21:00:55',NULL,NULL),(3236,2777,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-03','18:32:00','170198','X',0,'2014-02-03 21:00:26',NULL,NULL),(3491,2793,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-11','18:41:00','189045','X',0,'2014-02-11 21:01:43',NULL,NULL),(4481,2856,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-10','19:17:00','254168','X',0,'2014-03-10 21:30:16',NULL,NULL),(691,43,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-10','18:01:00','7172','X',0,'2013-12-25 22:31:01',NULL,NULL),(1167,75,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-20','19:06:00','84204','X',0,'2013-12-26 03:02:51',NULL,NULL),(1485,99,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-26','18:41:00','100575','X',0,'2013-12-27 02:07:59',NULL,NULL),(1579,383,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-29','18:10:00','107261','X',0,'2013-12-30 00:02:26',NULL,NULL),(2481,1540,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:33',NULL,NULL),(2603,2539,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-15','18:30:00','138465','X',0,'2014-01-16 08:47:07',NULL,NULL),(4388,2852,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-08','18:43:00','250660','X',0,'2014-03-08 21:30:57',NULL,NULL),(42,3,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-13','18:04:00','25387','X',0,'2013-12-25 17:30:34',NULL,NULL),(293,21,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-10','18:21:00','62742','X',0,'2013-12-25 19:16:58',NULL,NULL),(757,47,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-19','19:11:00','81743','X',0,'2013-12-25 23:10:30',NULL,NULL),(963,59,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-11','18:36:00','64796','X',0,'2013-12-26 00:53:57',NULL,NULL),(1136,72,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-17','18:03:00','29565','X',0,'2013-12-26 02:45:04',NULL,NULL),(1143,72,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-17','18:03:00','29572','X',0,'2013-12-26 02:45:54',NULL,NULL),(1243,80,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-18','18:49:00','79073','X',0,'2013-12-26 04:07:54',NULL,NULL),(1612,385,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-30','19:01:00','109559','X',0,'2014-01-01 12:09:24',NULL,NULL),(1969,1216,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:47',NULL,NULL),(2698,2553,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-19','18:08:00','145205','X',0,'2014-01-21 08:45:21',NULL,NULL),(3511,2793,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-11','18:41:00','189065','X',0,'2014-02-11 21:02:48',NULL,NULL),(3957,2823,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-22','18:14:00','213799','X',0,'2014-02-26 08:30:19',NULL,NULL),(1006,63,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-25','18:07:00','38444','X',0,'2013-12-26 01:16:03',NULL,NULL),(4180,2836,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-03','18:33:00','236076','X',0,'2014-03-03 21:30:58',NULL,NULL),(138,7,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-16','18:37:00','74951','X',0,'2013-12-25 18:08:30',NULL,NULL),(180,13,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-03','18:20:00','49886','X',0,'2013-12-25 18:17:53',NULL,NULL),(363,23,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-02','18:14:00','47679','X',0,'2013-12-25 19:47:17',NULL,NULL),(623,40,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-12','18:53:00','67243','X',0,'2013-12-25 22:05:40',NULL,NULL),(651,40,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-12','18:53:00','67271','X',0,'2013-12-25 22:09:30',NULL,NULL),(953,59,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-11','18:36:00','64786','X',0,'2013-12-26 00:53:09',NULL,NULL),(959,59,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-11','18:36:00','64792','X',0,'2013-12-26 00:53:47',NULL,NULL),(1064,67,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-25','18:35:00','98946','X',0,'2013-12-26 01:52:41',NULL,NULL),(1289,81,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-30','18:04:00','44829','X',0,'2013-12-26 04:16:18',NULL,NULL),(2276,1471,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-07','18:29:00','123274','X',0,'2014-01-08 18:24:47',NULL,NULL),(568,38,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-13','18:39:00','69294','X',0,'2013-12-25 21:38:51',NULL,NULL),(749,47,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-19','19:11:00','81735','X',0,'2013-12-25 23:09:17',NULL,NULL),(1446,93,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-24','01:56:00','90984','X',0,'2013-12-26 13:16:46',NULL,NULL),(1973,1220,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:58',NULL,NULL),(2892,2667,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','09:37:00','1','X',1,'2014-01-23 04:47:05',NULL,NULL),(3735,2807,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-18','18:25:00','203029','X',0,'2014-02-18 21:30:10',NULL,NULL),(3827,2812,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-19','18:32:00','206166','X',0,'2014-02-20 05:39:26',NULL,NULL),(4076,2829,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-28','19:08:00','228391','X',0,'2014-02-28 21:00:01',NULL,NULL),(818,50,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-11-26','18:20:00','40543','X',0,'2013-12-25 23:32:55',NULL,NULL),(1004,63,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-25','18:07:00','38440','X',0,'2013-12-26 01:15:57',NULL,NULL),(1962,1209,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:28',NULL,NULL),(2259,1469,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-05','18:09:00','119793','X',1,'2014-01-07 10:22:36',NULL,NULL),(2990,2755,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-23','18:27:00','151586','X',0,'2014-01-23 21:01:17',NULL,NULL),(3054,2758,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-26','18:09:00','156594','X',0,'2014-01-26 19:00:26',NULL,NULL),(3600,2798,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-13','18:46:00','194323','X',0,'2014-02-13 22:02:50',NULL,NULL),(4193,2836,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-03','18:33:00','236089','X',0,'2014-03-03 21:31:53',NULL,NULL),(1416,93,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-24','01:56:00','90952','X',0,'2013-12-26 13:11:29',NULL,NULL),(2764,2556,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-22','18:31:00','150805','X',0,'2014-01-23 03:01:54',NULL,NULL),(3016,2756,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-24','18:26:00','154296','X',0,'2014-01-24 21:00:55',NULL,NULL),(3210,2775,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-02-01','18:14:00','166679','X',0,'2014-02-01 19:00:45',NULL,NULL),(3566,2796,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-12','18:31:00','191474','X',0,'2014-02-12 21:32:30',NULL,NULL),(4313,2848,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-06','18:46:00','243734','X',0,'2014-03-06 21:30:08',NULL,NULL),(4355,2850,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-07','18:46:00','247670','X',0,'2014-03-07 21:32:02',NULL,NULL),(34,2,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-12','18:01:00','7918','X',0,'2013-12-25 17:30:01',NULL,NULL),(515,37,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-22','18:40:00','88476','X',0,'2013-12-25 21:22:33',NULL,NULL),(800,50,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-26','18:20:00','40525','X',0,'2013-12-25 23:30:02',NULL,NULL),(1199,75,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-20','19:06:00','84237','X',0,'2013-12-26 03:10:58',NULL,NULL),(1985,1232,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:07',NULL,NULL),(2843,2618,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 04:06:25',NULL,NULL),(2894,2669,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:01:00','1','X',1,'2014-01-23 04:51:15',NULL,NULL),(3588,2798,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-13','18:46:00','194311','X',0,'2014-02-13 22:02:02',NULL,NULL),(3670,2801,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-15','18:44:00','198285','X',0,'2014-02-15 21:00:13',NULL,NULL),(3913,2819,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-25','18:36:00','220685','X',0,'2014-02-25 21:31:41',NULL,NULL),(307,21,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-10','18:21:00','62756','X',0,'2013-12-25 19:19:46',NULL,NULL),(555,38,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-13','18:39:00','69281','X',0,'2013-12-25 21:37:32',NULL,NULL),(1135,72,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-17','18:03:00','29564','X',0,'2013-12-26 02:45:01',NULL,NULL),(1236,80,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-18','18:49:00','79066','X',0,'2013-12-26 04:02:12',NULL,NULL),(949,59,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-11','18:36:00','64782','X',0,'2013-12-26 00:51:37',NULL,NULL),(1555,382,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-28','21:04:00','105811','X',1,'2013-12-29 11:15:09',NULL,NULL),(2039,1286,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:38',NULL,NULL),(2312,1474,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-09','18:28:00','127852','X',0,'2014-01-13 02:19:29',NULL,NULL),(2431,1490,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:02:22',NULL,NULL),(2848,2623,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:27:00','1','X',1,'2014-01-23 04:07:28',NULL,NULL),(3493,2793,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-11','18:41:00','189047','X',0,'2014-02-11 21:02:02',NULL,NULL),(4367,2850,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-03-07','18:46:00','247682','X',0,'2014-03-07 21:32:22',NULL,NULL),(358,22,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-09','18:28:00','61528','X',0,'2013-12-25 19:38:08',NULL,NULL),(1195,75,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-20','19:06:00','84233','X',0,'2013-12-26 03:10:36',NULL,NULL),(1444,93,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-24','01:56:00','90982','X',0,'2013-12-26 13:16:39',NULL,NULL),(2993,2755,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-23','18:27:00','151589','X',0,'2014-01-23 21:01:19',NULL,NULL),(3117,2772,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-29','18:30:00','161339','X',0,'2014-01-29 21:00:40',NULL,NULL),(4001,2825,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-26','18:43:00','223756','X',0,'2014-02-26 21:02:01',NULL,NULL),(4045,2826,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-27','18:48:00','225939','X',0,'2014-02-28 06:31:44',NULL,NULL),(263,19,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-24','18:40:00','96824','X',0,'2013-12-25 18:58:42',NULL,NULL),(813,50,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-11-26','18:20:00','40538','X',0,'2013-12-25 23:32:37',NULL,NULL),(1071,68,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-14','18:21:00','71340','X',0,'2013-12-26 02:01:59',NULL,NULL),(1476,99,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-26','18:41:00','100566','X',0,'2013-12-27 02:07:34',NULL,NULL),(2105,1352,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:02:42',NULL,NULL),(2738,2555,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-21','18:24:00','147873','X',1,'2014-01-22 03:22:04',NULL,NULL),(3001,2755,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-23','18:27:00','151597','X',0,'2014-01-23 21:01:38',NULL,NULL),(3622,2799,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-14','18:39:00','196115','X',0,'2014-02-14 21:30:31',NULL,NULL),(86,6,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-04','18:22:00','52134','X',0,'2013-12-25 17:50:20',NULL,NULL),(250,19,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-24','18:40:00','96811','X',0,'2013-12-25 18:54:46',NULL,NULL),(1487,99,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-26','18:41:00','100577','X',0,'2013-12-27 02:08:05',NULL,NULL),(1953,1200,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:03',NULL,NULL),(2076,1323,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:21',NULL,NULL),(2423,1482,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:02:15',NULL,NULL),(2595,2539,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-15','18:30:00','138457','X',0,'2014-01-16 08:46:41',NULL,NULL),(2620,2539,'005010X220A1','BE','OH0','92036','92036OH0010032','2014-01-15','18:30:00','138482','X',0,'2014-01-16 08:47:29',NULL,NULL),(4075,2828,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-27','18:43:00','224659','X',0,'2014-02-28 07:30:39',NULL,NULL),(321,21,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-10','18:21:00','62770','X',0,'2013-12-25 19:21:03',NULL,NULL),(366,23,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-02','18:14:00','47682','X',0,'2013-12-25 19:48:39',NULL,NULL),(1334,83,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-15','18:34:00','27230','X',0,'2013-12-26 04:45:46',NULL,NULL),(1512,380,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-27','18:44:00','101836','X',0,'2013-12-28 03:37:13',NULL,NULL),(2379,1477,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-10','18:26:00','129734','X',0,'2014-01-13 03:00:18',NULL,NULL),(2664,2551,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-17','18:23:00','142630','X',0,'2014-01-20 08:06:31',NULL,NULL),(2773,2556,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-22','18:31:00','150814','X',0,'2014-01-23 03:02:41',NULL,NULL),(3114,2772,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-29','18:30:00','161336','X',0,'2014-01-29 21:00:03',NULL,NULL),(3346,2783,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-06','18:26:00','175056','X',0,'2014-02-06 21:30:03',NULL,NULL),(4059,2827,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-26','18:39:00','222058','X',0,'2014-02-28 07:00:34',NULL,NULL),(1235,80,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-18','18:49:00','79065','X',0,'2013-12-26 04:00:16',NULL,NULL),(2268,1469,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-05','18:09:00','119802','X',1,'2014-01-07 10:23:25',NULL,NULL),(3238,2777,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-02-03','18:32:00','170200','X',0,'2014-02-03 21:00:51',NULL,NULL),(3572,2797,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-13','18:41:00','192634','X',0,'2014-02-13 21:30:10',NULL,NULL),(3821,2812,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-19','18:32:00','206160','X',0,'2014-02-20 05:30:10',NULL,NULL),(442,29,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-06','18:21:00','55552','X',0,'2013-12-25 20:20:21',NULL,NULL),(1170,75,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-20','19:06:00','84207','X',0,'2013-12-26 03:05:42',NULL,NULL),(1420,93,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-24','01:56:00','90956','X',0,'2013-12-26 13:12:36',NULL,NULL),(3744,2807,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-18','18:25:00','203038','X',0,'2014-02-18 21:30:21',NULL,NULL),(3796,2811,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-19','18:35:00','207799','X',0,'2014-02-20 04:34:01',NULL,NULL),(3884,2816,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-21','18:31:00','212812','X',0,'2014-02-21 22:01:14',NULL,NULL),(129,7,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-16','18:37:00','74942','X',0,'2013-12-25 18:07:56',NULL,NULL),(1547,382,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-28','21:04:00','105803','X',1,'2013-12-29 11:14:36',NULL,NULL),(2542,1576,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-13','18:44:00','134018','X',0,'2014-01-14 01:33:50',NULL,NULL),(4069,2828,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-27','18:43:00','224653','X',0,'2014-02-28 07:30:28',NULL,NULL),(4268,2846,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-03-05','18:49:00','241602','X',0,'2014-03-05 21:32:38',NULL,NULL),(4324,2849,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-07','18:42:00','246110','X',0,'2014-03-07 21:00:17',NULL,NULL),(1307,82,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-21','18:37:00','86513','X',0,'2013-12-26 04:37:59',NULL,NULL),(2474,1533,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:26',NULL,NULL),(3339,2782,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-06','18:28:00','175996','X',0,'2014-02-06 21:01:45',NULL,NULL),(3585,2798,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-13','18:46:00','194308','X',0,'2014-02-13 22:01:54',NULL,NULL),(47,3,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-13','18:04:00','25389','X',0,'2013-12-25 17:31:02',NULL,NULL),(487,34,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-10-06','18:02:00','6429','X',0,'2013-12-25 20:46:19',NULL,NULL),(536,37,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-22','18:40:00','88497','X',0,'2013-12-25 21:23:42',NULL,NULL),(730,46,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-07','18:13:00','57448','X',0,'2013-12-25 22:48:08',NULL,NULL),(1149,73,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-14','18:02:00','9156','X',0,'2013-12-26 02:46:11',NULL,NULL),(1321,82,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-21','18:37:00','86538','X',0,'2013-12-26 04:39:43',NULL,NULL),(1659,387,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-31','18:52:00','111698','X',1,'2014-01-02 04:35:34',NULL,NULL),(2568,2311,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-14','19:00:00','136125','X',0,'2014-01-15 02:07:59',NULL,NULL),(122,7,'005010X220A1','BE','OH0','92036','92036OH0010005','2013-12-16','18:37:00','74935','X',0,'2013-12-25 18:07:34',NULL,NULL),(1269,80,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-18','18:49:00','79099','X',0,'2013-12-26 04:10:20',NULL,NULL),(1345,84,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-21','18:04:00','11687','X',0,'2013-12-26 05:00:52',NULL,NULL),(1927,1174,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:51',NULL,NULL),(1996,1243,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:38',NULL,NULL),(2635,2540,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-16','18:41:00','141411','X',0,'2014-01-17 03:36:29',NULL,NULL),(3218,2776,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-02','18:10:00','168367','X',0,'2014-02-02 19:00:07',NULL,NULL),(3331,2782,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-06','18:28:00','175988','X',0,'2014-02-06 21:01:31',NULL,NULL),(3391,2786,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-08','18:12:00','180303','X',0,'2014-02-08 19:00:59',NULL,NULL),(3791,2809,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-19','18:35:00','207798','X',0,'2014-02-20 04:28:45',NULL,NULL),(4286,2847,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-06','18:51:00','245586','X',0,'2014-03-06 21:02:21',NULL,NULL),(279,20,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-20','18:06:00','32803','X',0,'2013-12-25 19:00:52',NULL,NULL),(939,59,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-11','18:36:00','64772','X',0,'2013-12-26 00:48:48',NULL,NULL),(1273,80,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-18','18:49:00','79103','X',0,'2013-12-26 04:10:34',NULL,NULL),(2093,1340,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:08',NULL,NULL),(2733,2554,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-20','18:21:00','146912','X',0,'2014-01-21 08:46:58',NULL,NULL),(2832,2607,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:22:00','1','X',1,'2014-01-23 03:54:50',NULL,NULL),(3270,2778,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-04','18:29:00','172112','X',0,'2014-02-04 21:01:26',NULL,NULL),(3399,2787,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-08','18:12:00','180830','X',0,'2014-02-08 19:30:10',NULL,NULL),(3562,2796,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-12','18:31:00','191470','X',0,'2014-02-12 21:32:27',NULL,NULL),(4443,2855,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-03-10','19:23:00','255945','X',0,'2014-03-10 21:01:58',NULL,NULL),(542,38,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-13','18:39:00','69268','X',0,'2013-12-25 21:32:28',NULL,NULL),(673,41,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-08','18:10:00','59430','X',0,'2013-12-25 22:17:14',NULL,NULL),(1688,568,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-02','18:42:00','115212','X',0,'2014-01-03 02:06:32',NULL,NULL),(1713,569,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-03','18:38:00','116012','X',0,'2014-01-04 02:04:54',NULL,NULL),(2118,1365,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:59',NULL,NULL),(2807,2582,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:44:43',NULL,NULL),(2996,2755,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-23','18:27:00','151592','X',0,'2014-01-23 21:01:29',NULL,NULL),(3359,2784,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-07','18:14:00','177568','X',0,'2014-02-07 19:00:55',NULL,NULL),(3948,2821,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-24','18:19:00','217100','X',0,'2014-02-26 08:00:38',NULL,NULL),(4472,2856,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-10','19:17:00','254159','X',0,'2014-03-10 21:29:57',NULL,NULL),(4,1,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-05','18:31:00','54179','X',0,'2013-12-25 17:17:18',NULL,NULL),(993,62,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-05','18:03:00','19336','X',0,'2013-12-26 01:01:56',NULL,NULL),(1316,82,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-21','18:37:00','86529','X',0,'2013-12-26 04:39:08',NULL,NULL),(1591,385,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-30','19:01:00','109538','X',0,'2014-01-01 12:07:11',NULL,NULL),(1711,569,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-03','18:38:00','116010','X',0,'2014-01-04 02:04:46',NULL,NULL),(2032,1279,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:18',NULL,NULL),(2068,1315,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:59',NULL,NULL),(2207,1454,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:07',NULL,NULL),(2734,2554,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-20','18:21:00','146913','X',0,'2014-01-21 08:46:59',NULL,NULL),(3289,2780,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-05','18:36:00','173082','X',0,'2014-02-05 21:00:05',NULL,NULL),(4171,2835,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-03','18:31:00','234706','X',0,'2014-03-03 21:00:24',NULL,NULL),(4217,2843,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-04','18:50:00','238764','X',0,'2014-03-04 21:02:34',NULL,NULL),(4466,2855,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-03-10','19:23:00','255941','X',0,'2014-03-10 21:02:55',NULL,NULL),(214,14,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-29','18:04:00','43707','X',0,'2013-12-25 18:31:03',NULL,NULL),(823,50,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-26','18:20:00','40548','X',0,'2013-12-25 23:33:06',NULL,NULL),(1252,80,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-18','18:49:00','79082','X',0,'2013-12-26 04:08:52',NULL,NULL),(1745,571,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-04','18:14:00','119147','X',0,'2014-01-05 00:02:50',NULL,NULL),(2530,1576,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-13','18:44:00','134006','X',0,'2014-01-14 01:33:35',NULL,NULL),(2862,2637,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 04:17:26',NULL,NULL),(3530,2795,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-12','18:27:00','189875','X',0,'2014-02-12 21:00:04',NULL,NULL),(3826,2812,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-19','18:32:00','206165','X',0,'2014-02-20 05:38:38',NULL,NULL),(3835,2813,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-20','18:26:00','208221','X',0,'2014-02-20 21:30:17',NULL,NULL),(3847,2814,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-20','18:28:00','208914','X',0,'2014-02-20 22:01:07',NULL,NULL),(428,29,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-06','18:21:00','55538','X',0,'2013-12-25 20:19:38',NULL,NULL),(1947,1194,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:46',NULL,NULL),(2129,1376,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:29',NULL,NULL),(2145,1392,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:14',NULL,NULL),(2212,1459,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:21',NULL,NULL),(2627,2540,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-16','18:41:00','141403','X',0,'2014-01-17 03:35:50',NULL,NULL),(2899,2674,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:58:00','1','X',1,'2014-01-23 04:57:15',NULL,NULL),(3144,2773,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-30','18:35:00','164065','X',0,'2014-01-30 21:00:24',NULL,NULL),(3472,2792,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-10','18:30:00','186458','X',0,'2014-02-10 21:32:03',NULL,NULL),(107,7,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-16','18:37:00','74920','X',0,'2013-12-25 18:03:22',NULL,NULL),(2442,1501,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:02:32',NULL,NULL),(2761,2555,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-21','18:24:00','147896','X',1,'2014-01-22 03:23:11',NULL,NULL),(2780,2556,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-22','18:31:00','150821','X',0,'2014-01-23 03:02:53',NULL,NULL),(2901,2676,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:01:00','1','X',1,'2014-01-23 05:01:58',NULL,NULL),(2986,2755,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-23','18:27:00','151582','X',0,'2014-01-23 21:00:58',NULL,NULL),(4376,2850,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-03-07','18:46:00','247691','X',0,'2014-03-07 21:32:30',NULL,NULL),(1153,73,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-10-14','18:02:00','9151','X',0,'2013-12-26 02:46:22',NULL,NULL),(1282,81,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-30','18:04:00','44822','X',0,'2013-12-26 04:15:27',NULL,NULL),(1617,386,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-01','18:18:00','112802','X',1,'2014-01-02 04:22:23',NULL,NULL),(2510,1569,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:59',NULL,NULL),(3731,2806,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-17','18:05:00','202229','X',0,'2014-02-17 19:00:16',NULL,NULL),(3893,2818,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-25','18:33:00','219089','X',0,'2014-02-25 21:00:13',NULL,NULL),(3993,2824,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-24','18:21:00','218505','X',0,'2014-02-26 09:31:08',NULL,NULL),(569,38,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-13','18:39:00','69295','X',0,'2013-12-25 21:38:55',NULL,NULL),(1023,64,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-14','18:05:00','25959','X',0,'2013-12-26 01:30:34',NULL,NULL),(1191,75,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-20','19:06:00','84229','X',0,'2013-12-26 03:10:24',NULL,NULL),(1219,76,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-11-22','18:08:00','35673','X',0,'2013-12-26 03:16:31',NULL,NULL),(1664,387,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-31','18:52:00','111703','X',1,'2014-01-02 04:35:58',NULL,NULL),(2966,2741,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:41:00','1','X',0,'2014-01-23 12:00:03',NULL,NULL),(2995,2755,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-01-23','18:27:00','151591','X',0,'2014-01-23 21:01:28',NULL,NULL),(3824,2812,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-19','18:32:00','206163','X',0,'2014-02-20 05:35:15',NULL,NULL),(4106,2830,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-28','19:12:00','229924','X',0,'2014-02-28 21:31:53',NULL,NULL),(821,50,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-11-26','18:20:00','40546','X',0,'2013-12-25 23:33:01',NULL,NULL),(1513,380,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-27','18:44:00','101837','X',0,'2013-12-28 03:37:15',NULL,NULL),(3490,2793,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-11','18:41:00','189044','X',0,'2014-02-11 21:01:31',NULL,NULL),(581,39,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-17','18:43:00','78030','X',0,'2013-12-25 21:47:25',NULL,NULL),(1402,92,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-24','01:56:00','90939','X',0,'2013-12-26 12:55:13',NULL,NULL),(2341,1475,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-08','18:27:00','125977','X',0,'2014-01-13 02:21:52',NULL,NULL),(2475,1534,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:27',NULL,NULL),(2967,2742,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','03:00:00','1','X',0,'2014-01-23 12:30:02',NULL,NULL),(277,20,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-20','18:06:00','32801','X',0,'2013-12-25 19:00:16',NULL,NULL),(650,40,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-12','18:53:00','67270','X',0,'2013-12-25 22:09:28',NULL,NULL),(806,50,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-11-26','18:20:00','40531','X',0,'2013-12-25 23:32:03',NULL,NULL),(1059,67,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-25','18:35:00','98941','X',0,'2013-12-26 01:52:29',NULL,NULL),(1077,68,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-14','18:21:00','71346','X',0,'2013-12-26 02:03:23',NULL,NULL),(1272,80,'005010X220A1','BE','OH0','92036','92036OH0010005','2013-12-18','18:49:00','79102','X',0,'2013-12-26 04:10:32',NULL,NULL),(2660,2551,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-17','18:23:00','142626','X',0,'2014-01-20 08:06:23',NULL,NULL),(2997,2755,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-23','18:27:00','151593','X',0,'2014-01-23 21:01:30',NULL,NULL),(3241,2777,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-03','18:32:00','170203','X',0,'2014-02-03 21:01:05',NULL,NULL),(3488,2793,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-11','18:41:00','189042','X',0,'2014-02-11 21:01:22',NULL,NULL),(3712,2804,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-16','18:12:00','201505','X',0,'2014-02-16 19:00:34',NULL,NULL),(4285,2847,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-06','18:51:00','245585','X',0,'2014-03-06 21:02:18',NULL,NULL),(4395,2852,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-08','18:43:00','250667','X',0,'2014-03-08 21:31:14',NULL,NULL),(330,22,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-09','18:28:00','61500','X',0,'2013-12-25 19:34:55',NULL,NULL),(901,54,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-10-02','18:00:00','5092','X',0,'2013-12-26 00:17:10',NULL,NULL),(3696,2802,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-15','18:48:00','199888','X',0,'2014-02-15 22:02:06',NULL,NULL),(3901,2818,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-25','18:33:00','219097','X',0,'2014-02-25 21:00:32',NULL,NULL),(402,26,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-02','18:03:00','17176','X',0,'2013-12-25 20:01:25',NULL,NULL),(641,40,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-12','18:53:00','67261','X',0,'2013-12-25 22:08:41',NULL,NULL),(1582,385,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-30','19:01:00','109529','X',0,'2014-01-01 12:02:12',NULL,NULL),(1610,385,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-30','19:01:00','109557','X',0,'2014-01-01 12:09:19',NULL,NULL),(2581,2311,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-14','19:00:00','136138','X',0,'2014-01-15 02:08:11',NULL,NULL),(2637,2540,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-16','18:41:00','141413','X',0,'2014-01-17 03:36:32',NULL,NULL),(2804,2579,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:32:00','1','X',1,'2014-01-23 03:43:59',NULL,NULL),(3468,2792,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-10','18:30:00','186454','X',0,'2014-02-10 21:31:58',NULL,NULL),(3825,2812,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-19','18:32:00','206164','X',0,'2014-02-20 05:37:47',NULL,NULL),(3959,2823,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-22','18:14:00','213801','X',0,'2014-02-26 08:30:31',NULL,NULL),(483,34,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-06','18:02:00','6430','X',0,'2013-12-25 20:45:56',NULL,NULL),(541,38,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-13','18:39:00','69267','X',0,'2013-12-25 21:30:24',NULL,NULL),(884,53,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-21','18:06:00','34262','X',0,'2013-12-26 00:15:25',NULL,NULL),(1443,93,'005010X220A1','BE','OH0','99734','99734OH0050001','2013-12-24','01:56:00','90981','X',0,'2013-12-26 13:16:38',NULL,NULL),(2090,1337,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:02:00',NULL,NULL),(2695,2553,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-19','18:08:00','145202','X',0,'2014-01-21 08:45:15',NULL,NULL),(3312,2781,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-05','18:39:00','174422','X',0,'2014-02-05 21:31:16',NULL,NULL),(3467,2792,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-10','18:30:00','186453','X',0,'2014-02-10 21:31:45',NULL,NULL),(3529,2795,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-12','18:27:00','189874','X',0,'2014-02-12 21:00:03',NULL,NULL),(4408,2853,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-09','18:20:00','252253','X',0,'2014-03-09 21:00:45',NULL,NULL),(50,3,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-13','18:04:00','25390','X',0,'2013-12-25 17:31:22',NULL,NULL),(527,37,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-22','18:40:00','88488','X',0,'2013-12-25 21:23:11',NULL,NULL),(828,51,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-24','03:40:00','94567','X',0,'2013-12-25 23:48:55',NULL,NULL),(2318,1474,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-09','18:28:00','127858','X',0,'2014-01-13 02:20:13',NULL,NULL),(2913,2688,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',0,'2014-01-23 05:30:13',NULL,NULL),(3321,2782,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-06','18:28:00','175978','X',0,'2014-02-06 21:00:51',NULL,NULL),(3872,2816,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-21','18:31:00','212800','X',0,'2014-02-21 22:00:37',NULL,NULL),(415,29,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-06','18:21:00','55525','X',0,'2013-12-25 20:17:08',NULL,NULL),(954,59,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-11','18:36:00','64787','X',0,'2013-12-26 00:53:11',NULL,NULL),(1204,76,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-22','18:08:00','35658','X',0,'2013-12-26 03:15:33',NULL,NULL),(1495,380,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-27','18:44:00','101819','X',0,'2013-12-28 03:35:23',NULL,NULL),(2556,2311,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-14','19:00:00','136113','X',0,'2014-01-15 02:07:17',NULL,NULL),(2732,2554,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-20','18:21:00','146911','X',0,'2014-01-21 08:46:57',NULL,NULL),(3397,2787,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-08','18:12:00','180828','X',0,'2014-02-08 19:30:06',NULL,NULL),(3439,2790,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-10','05:02:00','183712','X',0,'2014-02-10 11:01:12',NULL,NULL),(3823,2812,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-19','18:32:00','206162','X',0,'2014-02-20 05:34:09',NULL,NULL),(3922,2819,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-25','18:36:00','220694','X',0,'2014-02-25 21:31:59',NULL,NULL),(3934,2820,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-23','18:10:00','215480','X',0,'2014-02-26 08:00:19',NULL,NULL),(4296,2847,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-06','18:51:00','245596','X',0,'2014-03-06 21:02:43',NULL,NULL),(226,16,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-25','18:01:00','13415','X',0,'2013-12-25 18:31:56',NULL,NULL),(1692,568,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-02','18:42:00','115216','X',0,'2014-01-03 02:06:53',NULL,NULL),(2446,1505,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:36',NULL,NULL),(2971,2746,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','03:08:00','1','X',0,'2014-01-23 14:30:02',NULL,NULL),(255,19,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-24','18:40:00','96816','X',0,'2013-12-25 18:57:08',NULL,NULL),(1160,74,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-10','18:01:00','22947','X',0,'2013-12-26 02:46:41',NULL,NULL),(1290,81,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-11-30','18:04:00','44830','X',0,'2013-12-26 04:16:20',NULL,NULL),(2280,1471,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-07','18:29:00','123278','X',0,'2014-01-08 18:24:58',NULL,NULL),(3195,2774,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-31','18:37:00','165937','X',0,'2014-01-31 21:01:45',NULL,NULL),(3234,2777,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-03','18:32:00','170196','X',0,'2014-02-03 21:00:05',NULL,NULL),(3690,2802,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-15','18:48:00','199881','X',0,'2014-02-15 22:01:59',NULL,NULL),(851,51,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-24','03:40:00','94590','X',0,'2013-12-25 23:52:01',NULL,NULL),(1699,568,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-02','18:42:00','115223','X',0,'2014-01-03 02:07:19',NULL,NULL),(2863,2638,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',1,'2014-01-23 04:17:32',NULL,NULL),(3326,2782,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-06','18:28:00','175983','X',0,'2014-02-06 21:01:11',NULL,NULL),(3461,2792,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-10','18:30:00','186447','X',0,'2014-02-10 21:31:26',NULL,NULL),(3569,2797,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-13','18:41:00','192631','X',0,'2014-02-13 21:30:03',NULL,NULL),(4230,2844,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-04','18:46:00','237487','X',0,'2014-03-04 21:30:04',NULL,NULL),(4254,2846,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-05','18:49:00','241588','X',0,'2014-03-05 21:31:53',NULL,NULL),(534,37,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-22','18:40:00','88495','X',0,'2013-12-25 21:23:37',NULL,NULL),(1063,67,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-25','18:35:00','98945','X',0,'2013-12-26 01:52:39',NULL,NULL),(1902,1149,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:42',NULL,NULL),(1917,1164,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:23',NULL,NULL),(3589,2798,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-13','18:46:00','194312','X',0,'2014-02-13 22:02:03',NULL,NULL),(3844,2814,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-20','18:28:00','208911','X',0,'2014-02-20 22:00:52',NULL,NULL),(708,45,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-10-26','18:04:00','13998','X',0,'2013-12-25 22:32:08',NULL,NULL),(1566,383,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-29','18:10:00','107248','X',0,'2013-12-30 00:01:42',NULL,NULL),(2009,1256,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:14',NULL,NULL),(2036,1283,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:29',NULL,NULL),(2394,1477,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-10','18:26:00','129749','X',0,'2014-01-13 03:00:40',NULL,NULL),(2461,1520,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:11',NULL,NULL),(2567,2311,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-14','19:00:00','136124','X',0,'2014-01-15 02:07:57',NULL,NULL),(2699,2553,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-19','18:08:00','145206','X',0,'2014-01-21 08:45:24',NULL,NULL),(3602,2798,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-13','18:46:00','194325','X',0,'2014-02-13 22:02:55',NULL,NULL),(3614,2798,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-13','18:46:00','194337','X',0,'2014-02-13 22:03:16',NULL,NULL),(3800,2809,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-19','18:35:00','207801','X',0,'2014-02-20 04:50:57',NULL,NULL),(3885,2816,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-02-21','18:31:00','212813','X',0,'2014-02-21 22:01:16',NULL,NULL),(4362,2850,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-03-07','18:46:00','247677','X',0,'2014-03-07 21:32:11',NULL,NULL),(149,8,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-31','18:04:00','15474','X',0,'2013-12-25 18:10:01',NULL,NULL),(220,15,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-04','18:02:00','18534','X',0,'2013-12-25 18:31:40',NULL,NULL),(856,52,'005010X220A1','BE','OH0','92036','92036OH0010032','2013-12-01','18:08:00','46303','X',0,'2013-12-26 00:00:02',NULL,NULL),(2263,1469,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-05','18:09:00','119797','X',1,'2014-01-07 10:23:06',NULL,NULL),(2314,1474,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-09','18:28:00','127854','X',0,'2014-01-13 02:19:57',NULL,NULL),(2316,1474,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-09','18:28:00','127856','X',0,'2014-01-13 02:20:02',NULL,NULL),(2526,1576,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-13','18:44:00','134002','X',0,'2014-01-14 01:33:27',NULL,NULL),(2943,2718,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',0,'2014-01-23 07:06:35',NULL,NULL),(3348,2783,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-06','18:26:00','175058','X',0,'2014-02-06 21:30:04',NULL,NULL),(3723,2806,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-17','18:05:00','202223','X',0,'2014-02-17 19:00:04',NULL,NULL),(4104,2830,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-28','19:12:00','229922','X',0,'2014-02-28 21:31:50',NULL,NULL),(553,38,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-13','18:39:00','69279','X',0,'2013-12-25 21:37:23',NULL,NULL),(801,50,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-26','18:20:00','40526','X',0,'2013-12-25 23:30:12',NULL,NULL),(3697,2802,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-15','18:48:00','199889','X',0,'2014-02-15 22:02:07',NULL,NULL),(4294,2847,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-06','18:51:00','245594','X',0,'2014-03-06 21:02:40',NULL,NULL),(4399,2852,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-08','18:43:00','250671','X',0,'2014-03-08 21:31:21',NULL,NULL),(110,7,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-16','18:37:00','74923','X',0,'2013-12-25 18:06:27',NULL,NULL),(473,33,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-01','18:03:00','16373','X',0,'2013-12-25 20:45:13',NULL,NULL),(792,49,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-06','18:03:00','20423','X',0,'2013-12-25 23:17:00',NULL,NULL),(879,52,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-01','18:08:00','46326','X',0,'2013-12-26 00:02:46',NULL,NULL),(1089,69,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-23','18:05:00','36679','X',0,'2013-12-26 02:15:22',NULL,NULL),(2004,1251,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:00',NULL,NULL),(2246,1468,'005010X220A1','BE','OH0','92036','92036OH0020008','2014-01-06','18:24:00','121992','X',0,'2014-01-07 04:06:36',NULL,NULL),(2554,2311,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-14','19:00:00','136111','X',0,'2014-01-15 02:07:11',NULL,NULL),(2598,2539,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-15','18:30:00','138460','X',0,'2014-01-16 08:46:47',NULL,NULL),(2885,2660,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:22:00','1','X',1,'2014-01-23 04:34:33',NULL,NULL),(3499,2793,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-02-11','18:41:00','189053','X',0,'2014-02-11 21:02:29',NULL,NULL),(516,37,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-22','18:40:00','88477','X',0,'2013-12-25 21:22:37',NULL,NULL),(655,41,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-08','18:10:00','59412','X',0,'2013-12-25 22:15:22',NULL,NULL),(1507,380,'005010X220A1','BE','OH0','92036','92036OH0010027','2013-12-27','18:44:00','101831','X',0,'2013-12-28 03:37:01',NULL,NULL),(2564,2311,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-14','19:00:00','136121','X',0,'2014-01-15 02:07:52',NULL,NULL),(2867,2642,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:12:00','1','X',1,'2014-01-23 04:18:35',NULL,NULL),(3387,2786,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-08','18:12:00','180299','X',0,'2014-02-08 19:00:55',NULL,NULL),(3481,2792,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-10','18:30:00','186467','X',0,'2014-02-10 21:32:16',NULL,NULL),(4311,2848,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-06','18:46:00','243732','X',0,'2014-03-06 21:30:02',NULL,NULL),(4431,2854,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-09','18:21:00','252851','X',0,'2014-03-09 21:30:05',NULL,NULL),(232,17,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-07','18:02:00','20912','X',0,'2013-12-25 18:32:13',NULL,NULL),(977,61,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-16','18:03:00','28392','X',0,'2013-12-26 01:00:40',NULL,NULL),(1552,382,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-28','21:04:00','105808','X',1,'2013-12-29 11:14:59',NULL,NULL),(1697,568,'005010X220A1','BE','IN0','92036','92036OH0050005','2014-01-02','18:42:00','115224','X',0,'2014-01-03 02:07:13',NULL,NULL),(1909,1156,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:01',NULL,NULL),(1945,1192,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:40',NULL,NULL),(2304,1473,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-11','18:16:00','130861','X',0,'2014-01-13 02:18:37',NULL,NULL),(3115,2772,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-29','18:30:00','161337','X',0,'2014-01-29 21:00:08',NULL,NULL),(3558,2796,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-12','18:31:00','191466','X',0,'2014-02-12 21:32:24',NULL,NULL),(3629,2799,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-14','18:39:00','196122','X',0,'2014-02-14 21:31:20',NULL,NULL),(3810,2810,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-19','18:35:00','207804','X',0,'2014-02-20 04:54:37',NULL,NULL),(4249,2846,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-05','18:49:00','241583','X',0,'2014-03-05 21:31:10',NULL,NULL),(4461,2855,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-10','19:23:00','255936','X',0,'2014-03-10 21:02:47',NULL,NULL),(1179,75,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-20','19:06:00','84216','X',0,'2013-12-26 03:08:54',NULL,NULL),(1929,1176,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:56',NULL,NULL),(2795,2570,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:05:00','1','X',1,'2014-01-23 03:41:36',NULL,NULL),(3456,2792,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-10','18:30:00','186442','X',0,'2014-02-10 21:31:00',NULL,NULL),(3557,2796,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-12','18:31:00','191465','X',0,'2014-02-12 21:32:21',NULL,NULL),(3779,2809,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-19','18:35:00','207792','X',0,'2014-02-20 04:13:41',NULL,NULL),(3832,2813,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-20','18:26:00','208218','X',0,'2014-02-20 21:30:06',NULL,NULL),(4056,2827,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-26','18:39:00','222055','X',0,'2014-02-28 07:00:22',NULL,NULL),(4090,2830,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-28','19:12:00','229908','X',0,'2014-02-28 21:30:38',NULL,NULL),(4354,2850,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-07','18:46:00','247669','X',0,'2014-03-07 21:32:01',NULL,NULL),(30,1,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-05','18:31:00','54205','X',0,'2013-12-25 17:21:55',NULL,NULL),(508,37,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-22','18:40:00','88466','X',0,'2013-12-25 21:20:59',NULL,NULL),(591,39,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-17','18:43:00','78040','X',0,'2013-12-25 21:51:56',NULL,NULL),(1471,99,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-26','18:41:00','100561','X',0,'2013-12-27 02:07:09',NULL,NULL),(2107,1354,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:47',NULL,NULL),(2469,1528,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:21',NULL,NULL),(2958,2733,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',0,'2014-01-23 09:28:28',NULL,NULL),(3303,2781,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-05','18:39:00','174413','X',0,'2014-02-05 21:31:07',NULL,NULL),(3540,2796,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-12','18:31:00','191448','X',0,'2014-02-12 21:30:46',NULL,NULL),(359,22,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-09','18:28:00','61529','X',0,'2013-12-25 19:38:10',NULL,NULL),(692,43,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-10','18:01:00','7173','X',0,'2013-12-25 22:31:06',NULL,NULL),(729,46,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-07','18:13:00','57447','X',0,'2013-12-25 22:48:05',NULL,NULL),(1743,571,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-04','18:14:00','119145','X',0,'2014-01-05 00:02:40',NULL,NULL),(2193,1440,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:28',NULL,NULL),(2596,2539,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-15','18:30:00','138458','X',0,'2014-01-16 08:46:44',NULL,NULL),(3916,2819,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-25','18:36:00','220688','X',0,'2014-02-25 21:31:45',NULL,NULL),(4068,2828,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-27','18:43:00','224652','X',0,'2014-02-28 07:30:25',NULL,NULL),(198,13,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-03','18:20:00','49904','X',0,'2013-12-25 18:21:20',NULL,NULL),(2127,1374,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:24',NULL,NULL),(2593,2539,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-15','18:30:00','138455','X',0,'2014-01-16 08:46:32',NULL,NULL),(2677,2552,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-18','18:11:00','144575','X',0,'2014-01-21 08:44:17',NULL,NULL),(3081,2759,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-27','18:27:00','158021','X',0,'2014-01-27 21:01:43',NULL,NULL),(3294,2781,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-05','18:39:00','174404','X',0,'2014-02-05 21:30:19',NULL,NULL),(3849,2814,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-20','18:28:00','208916','X',0,'2014-02-20 22:01:12',NULL,NULL),(4040,2826,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-27','18:48:00','225934','X',0,'2014-02-28 06:31:40',NULL,NULL),(4078,2829,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-28','19:08:00','228393','X',0,'2014-02-28 21:00:12',NULL,NULL),(292,21,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-10','18:21:00','62741','X',0,'2013-12-25 19:16:19',NULL,NULL),(1497,380,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-27','18:44:00','101821','X',0,'2013-12-28 03:35:39',NULL,NULL),(1988,1235,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:15',NULL,NULL),(2230,1468,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-06','18:24:00','121976','X',0,'2014-01-07 04:04:31',NULL,NULL),(3042,2757,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-25','18:11:00','155343','X',0,'2014-01-25 19:00:18',NULL,NULL),(3512,2793,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-11','18:41:00','189066','X',0,'2014-02-11 21:02:49',NULL,NULL),(3523,2794,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-11','18:37:00','187467','X',0,'2014-02-11 21:30:15',NULL,NULL),(3593,2798,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-13','18:46:00','194316','X',0,'2014-02-13 22:02:20',NULL,NULL),(213,14,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-29','18:04:00','43706','X',0,'2013-12-25 18:30:56',NULL,NULL),(876,52,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-01','18:08:00','46323','X',0,'2013-12-26 00:02:33',NULL,NULL),(1036,66,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-03','18:02:00','17823','X',0,'2013-12-26 01:31:56',NULL,NULL),(1099,69,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-23','18:05:00','36689','X',0,'2013-12-26 02:16:27',NULL,NULL),(2453,1512,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:02:42',NULL,NULL),(2842,2617,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:25:00','1','X',1,'2014-01-23 04:01:46',NULL,NULL),(4232,2844,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-04','18:46:00','237491','X',0,'2014-03-04 21:30:16',NULL,NULL),(151,8,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-10-31','18:04:00','15476','X',0,'2013-12-25 18:10:10',NULL,NULL),(3485,2793,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-11','18:41:00','189039','X',0,'2014-02-11 21:00:03',NULL,NULL),(4260,2846,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-05','18:49:00','241594','X',0,'2014-03-05 21:32:23',NULL,NULL),(337,22,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-09','18:28:00','61507','X',0,'2013-12-25 19:36:45',NULL,NULL),(987,62,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-05','18:03:00','19342','X',0,'2013-12-26 01:01:37',NULL,NULL),(1587,385,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-30','19:01:00','109534','X',0,'2014-01-01 12:05:26',NULL,NULL),(1934,1181,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:10',NULL,NULL),(2045,1292,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:54',NULL,NULL),(2633,2540,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-16','18:41:00','141409','X',0,'2014-01-17 03:36:17',NULL,NULL),(2691,2552,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-18','18:11:00','144589','X',0,'2014-01-21 08:44:45',NULL,NULL),(2709,2553,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-19','18:08:00','145216','X',0,'2014-01-21 08:45:42',NULL,NULL),(4048,2826,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-27','18:48:00','225942','X',0,'2014-02-28 06:31:46',NULL,NULL),(4162,2834,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-02','18:15:00','232811','X',0,'2014-03-03 01:30:00',NULL,NULL),(829,51,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-24','03:40:00','94568','X',0,'2013-12-25 23:49:03',NULL,NULL),(1300,82,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-21','18:37:00','86500','X',0,'2013-12-26 04:33:43',NULL,NULL),(1717,569,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-03','18:38:00','116016','X',0,'2014-01-04 02:05:49',NULL,NULL),(2098,1345,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:22',NULL,NULL),(3111,2760,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-28','18:32:00','160262','X',0,'2014-01-28 21:01:22',NULL,NULL),(3437,2790,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-10','05:02:00','183710','X',0,'2014-02-10 11:01:09',NULL,NULL),(3469,2792,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-10','18:30:00','186455','X',0,'2014-02-10 21:31:59',NULL,NULL),(4147,2833,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-03-02','18:16:00','233966','X',0,'2014-03-03 01:00:24',NULL,NULL),(4455,2855,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-03-10','19:23:00','255930','X',0,'2014-03-10 21:02:35',NULL,NULL),(956,59,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-11','18:36:00','64789','X',0,'2013-12-26 00:53:32',NULL,NULL),(2309,1473,'005010X220A1','BE','OH0','92036','92036OH0010027','2014-01-11','18:16:00','130866','X',0,'2014-01-13 02:18:41',NULL,NULL),(3025,2756,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-24','18:26:00','154305','X',0,'2014-01-24 21:01:12',NULL,NULL),(3887,2817,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-22','18:14:00','214239','X',0,'2014-02-22 19:00:10',NULL,NULL),(1019,64,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-14','18:05:00','25955','X',0,'2013-12-26 01:30:04',NULL,NULL),(1472,99,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-26','18:41:00','100562','X',0,'2013-12-27 02:07:12',NULL,NULL),(1726,569,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-03','18:38:00','116025','X',0,'2014-01-04 02:06:14',NULL,NULL),(2005,1252,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:03',NULL,NULL),(2557,2311,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-14','19:00:00','136114','X',0,'2014-01-15 02:07:19',NULL,NULL),(2621,2539,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-15','18:30:00','138483','X',0,'2014-01-16 08:47:30',NULL,NULL),(2652,2540,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-16','18:41:00','141428','X',0,'2014-01-17 03:36:42',NULL,NULL),(3161,2773,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-30','18:35:00','164082','X',0,'2014-01-30 21:01:32',NULL,NULL),(3400,2788,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-09','18:12:00','181780','X',0,'2014-02-09 19:00:03',NULL,NULL),(4447,2855,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-10','19:23:00','255922','X',0,'2014-03-10 21:02:14',NULL,NULL),(126,7,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-16','18:37:00','74939','X',0,'2013-12-25 18:07:50',NULL,NULL),(299,21,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-10','18:21:00','62748','X',0,'2013-12-25 19:18:52',NULL,NULL),(355,22,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-09','18:28:00','61525','X',0,'2013-12-25 19:37:57',NULL,NULL),(389,24,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-15','18:01:00','9472','X',0,'2013-12-25 20:00:10',NULL,NULL),(1681,568,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-02','18:42:00','115205','X',0,'2014-01-03 02:05:42',NULL,NULL),(2101,1348,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:31',NULL,NULL),(2189,1436,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:17',NULL,NULL),(2532,1576,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-01-13','18:44:00','134008','X',0,'2014-01-14 01:33:43',NULL,NULL),(3649,2799,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-14','18:39:00','196142','X',0,'2014-02-14 21:32:15',NULL,NULL),(4079,2829,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-28','19:08:00','228394','X',0,'2014-02-28 21:00:15',NULL,NULL),(4458,2855,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-10','19:23:00','255933','X',0,'2014-03-10 21:02:38',NULL,NULL),(271,19,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-24','18:40:00','96832','X',0,'2013-12-25 18:59:13',NULL,NULL),(838,51,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-24','03:40:00','94577','X',0,'2013-12-25 23:51:04',NULL,NULL),(2705,2553,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-19','18:08:00','145212','X',0,'2014-01-21 08:45:36',NULL,NULL),(2942,2717,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',0,'2014-01-23 07:05:59',NULL,NULL),(4181,2836,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-03','18:33:00','236077','X',0,'2014-03-03 21:31:25',NULL,NULL),(679,42,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-08','18:03:00','21235','X',0,'2013-12-25 22:30:01',NULL,NULL),(837,51,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-24','03:40:00','94576','X',0,'2013-12-25 23:50:59',NULL,NULL),(1003,63,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-25','18:07:00','38439','X',0,'2013-12-26 01:15:42',NULL,NULL),(1924,1171,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:42',NULL,NULL),(2584,2539,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-15','18:30:00','138446','X',0,'2014-01-16 08:44:12',NULL,NULL),(2622,2540,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-16','18:41:00','141398','X',0,'2014-01-17 03:35:01',NULL,NULL),(2975,2750,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',0,'2014-01-23 16:30:02',NULL,NULL),(4267,2846,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-03-05','18:49:00','241601','X',0,'2014-03-05 21:32:37',NULL,NULL),(317,21,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-10','18:21:00','62766','X',0,'2013-12-25 19:20:47',NULL,NULL),(505,37,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-22','18:40:00','88460','X',0,'2013-12-25 21:18:49',NULL,NULL),(728,46,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-07','18:13:00','57446','X',0,'2013-12-25 22:48:01',NULL,NULL),(979,61,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-16','18:03:00','28394','X',0,'2013-12-26 01:00:49',NULL,NULL),(2057,1304,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:28',NULL,NULL),(2346,1475,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-08','18:27:00','125982','X',0,'2014-01-13 02:22:19',NULL,NULL),(2766,2556,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-22','18:31:00','150807','X',0,'2014-01-23 03:02:11',NULL,NULL),(2952,2727,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:09:00','1','X',0,'2014-01-23 08:30:02',NULL,NULL),(3454,2792,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-10','18:30:00','186440','X',0,'2014-02-10 21:30:54',NULL,NULL),(4184,2836,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-03','18:33:00','236080','X',0,'2014-03-03 21:31:28',NULL,NULL),(4464,2855,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-03-10','19:23:00','255939','X',0,'2014-03-10 21:02:52',NULL,NULL),(51,3,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-11-13','18:04:00','25393','X',0,'2013-12-25 17:31:25',NULL,NULL),(639,40,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-12','18:53:00','67259','X',0,'2013-12-25 22:08:35',NULL,NULL),(645,40,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-12','18:53:00','67265','X',0,'2013-12-25 22:09:07',NULL,NULL),(724,46,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-07','18:13:00','57442','X',0,'2013-12-25 22:47:48',NULL,NULL),(1706,569,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-03','18:38:00','116005','X',0,'2014-01-04 02:03:08',NULL,NULL),(2256,1469,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-05','18:09:00','119790','X',1,'2014-01-07 10:22:08',NULL,NULL),(2815,2590,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:47:31',NULL,NULL),(3293,2781,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-05','18:39:00','174403','X',0,'2014-02-05 21:30:08',NULL,NULL),(4077,2829,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-28','19:08:00','228392','X',0,'2014-02-28 21:00:06',NULL,NULL),(4312,2848,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-06','18:46:00','243733','X',0,'2014-03-06 21:30:03',NULL,NULL),(222,15,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-11-04','18:02:00','18535','X',0,'2013-12-25 18:31:45',NULL,NULL),(689,43,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-10','18:01:00','7177','X',0,'2013-12-25 22:30:52',NULL,NULL),(892,53,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-21','18:06:00','34270','X',0,'2013-12-26 00:16:44',NULL,NULL),(961,59,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-11','18:36:00','64794','X',0,'2013-12-26 00:53:54',NULL,NULL),(3039,2757,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-25','18:11:00','155340','X',0,'2014-01-25 19:00:13',NULL,NULL),(3280,2778,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-04','18:29:00','172122','X',0,'2014-02-04 21:01:55',NULL,NULL),(3929,2820,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-23','18:10:00','215475','X',0,'2014-02-26 08:00:03',NULL,NULL),(4121,2832,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-01','18:23:00','232008','X',0,'2014-03-01 21:00:07',NULL,NULL),(4144,2833,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-02','18:16:00','233963','X',0,'2014-03-03 01:00:08',NULL,NULL),(71,6,'005010X220A1','BE','OH0','92036','92036OH0040032','2013-12-04','18:22:00','52119','X',0,'2013-12-25 17:45:48',NULL,NULL),(319,21,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-10','18:21:00','62768','X',0,'2013-12-25 19:20:57',NULL,NULL),(592,39,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-17','18:43:00','78041','X',0,'2013-12-25 21:52:07',NULL,NULL),(612,39,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-17','18:43:00','78061','X',0,'2013-12-25 21:53:40',NULL,NULL),(663,41,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-08','18:10:00','59420','X',0,'2013-12-25 22:16:37',NULL,NULL),(1021,64,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-14','18:05:00','25957','X',0,'2013-12-26 01:30:20',NULL,NULL),(2391,1477,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-10','18:26:00','129746','X',0,'2014-01-13 03:00:35',NULL,NULL),(2703,2553,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-19','18:08:00','145210','X',0,'2014-01-21 08:45:34',NULL,NULL),(2837,2612,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:32:00','1','X',1,'2014-01-23 03:57:08',NULL,NULL),(2864,2639,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 04:17:38',NULL,NULL),(3299,2781,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-05','18:39:00','174409','X',0,'2014-02-05 21:30:48',NULL,NULL),(3531,2795,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-12','18:27:00','189876','X',0,'2014-02-12 21:00:07',NULL,NULL),(4225,2843,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-04','18:50:00','238772','X',0,'2014-03-04 21:02:43',NULL,NULL),(343,22,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-09','18:28:00','61513','X',0,'2013-12-25 19:37:20',NULL,NULL),(547,38,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-13','18:39:00','69273','X',0,'2013-12-25 21:36:29',NULL,NULL),(1208,76,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-22','18:08:00','35662','X',0,'2013-12-26 03:15:53',NULL,NULL),(1220,76,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-11-22','18:08:00','35674','X',0,'2013-12-26 03:16:32',NULL,NULL),(1602,385,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-30','19:01:00','109549','X',0,'2014-01-01 12:08:47',NULL,NULL),(1907,1154,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:55',NULL,NULL),(2191,1438,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:22',NULL,NULL),(2520,1576,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-13','18:44:00','133996','X',0,'2014-01-14 01:32:49',NULL,NULL),(458,31,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-18','18:07:00','30653','X',0,'2013-12-25 20:31:32',NULL,NULL),(859,52,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-01','18:08:00','46306','X',0,'2013-12-26 00:00:26',NULL,NULL),(921,57,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-19','18:07:00','31306','X',0,'2013-12-26 00:31:37',NULL,NULL),(2184,1431,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:03',NULL,NULL),(2363,1476,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-10','18:26:00','129720','X',0,'2014-01-13 02:23:09',NULL,NULL),(3162,2773,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-30','18:35:00','164083','X',0,'2014-01-30 21:01:33',NULL,NULL),(3202,2775,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-01','18:14:00','166671','X',0,'2014-02-01 19:00:24',NULL,NULL),(3535,2795,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-12','18:27:00','189880','X',0,'2014-02-12 21:00:15',NULL,NULL),(3568,2797,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-13','18:41:00','192630','X',0,'2014-02-13 21:30:03',NULL,NULL),(3573,2797,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-13','18:41:00','192635','X',0,'2014-02-13 21:30:10',NULL,NULL),(3590,2798,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-13','18:46:00','194313','X',0,'2014-02-13 22:02:04',NULL,NULL),(3769,2808,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-18','18:28:00','204284','X',0,'2014-02-18 22:01:45',NULL,NULL),(704,45,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-26','18:04:00','14001','X',0,'2013-12-25 22:31:53',NULL,NULL),(710,45,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-26','18:04:00','14004','X',0,'2013-12-25 22:32:14',NULL,NULL),(1030,64,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-11-14','18:05:00','25966','X',0,'2013-12-26 01:31:13',NULL,NULL),(1094,69,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-23','18:05:00','36684','X',0,'2013-12-26 02:16:10',NULL,NULL),(1465,99,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-26','18:41:00','100555','X',0,'2013-12-27 02:06:29',NULL,NULL),(2303,1473,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-11','18:16:00','130860','X',0,'2014-01-13 02:18:37',NULL,NULL),(2436,1495,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:27',NULL,NULL),(3015,2756,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-24','18:26:00','154295','X',0,'2014-01-24 21:00:53',NULL,NULL),(3411,2789,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-09','18:11:00','181284','X',0,'2014-02-09 19:00:31',NULL,NULL),(3704,2804,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-16','18:12:00','201497','X',0,'2014-02-16 19:00:07',NULL,NULL),(3956,2823,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-22','18:14:00','213798','X',0,'2014-02-26 08:30:02',NULL,NULL),(4370,2850,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-07','18:46:00','247685','X',0,'2014-03-07 21:32:25',NULL,NULL),(1142,72,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-11-17','18:03:00','29571','X',0,'2013-12-26 02:45:52',NULL,NULL),(1343,84,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-21','18:04:00','11685','X',0,'2013-12-26 05:00:27',NULL,NULL),(1503,380,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-27','18:44:00','101827','X',0,'2013-12-28 03:36:49',NULL,NULL),(2390,1477,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-10','18:26:00','129745','X',0,'2014-01-13 03:00:33',NULL,NULL),(3022,2756,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-24','18:26:00','154302','X',0,'2014-01-24 21:01:09',NULL,NULL),(3095,2760,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-28','18:32:00','160246','X',0,'2014-01-28 21:01:01',NULL,NULL),(3379,2786,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-08','18:12:00','180291','X',0,'2014-02-08 19:00:23',NULL,NULL),(3941,2820,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-23','18:10:00','215487','X',0,'2014-02-26 08:00:29',NULL,NULL),(4185,2836,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-03','18:33:00','236081','X',0,'2014-03-03 21:31:29',NULL,NULL),(688,42,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-11-08','18:03:00','21244','X',0,'2013-12-25 22:30:49',NULL,NULL),(1041,67,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-25','18:35:00','98923','X',0,'2013-12-26 01:46:04',NULL,NULL),(1293,82,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-21','18:37:00','86493','X',0,'2013-12-26 04:30:02',NULL,NULL),(1733,571,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-04','18:14:00','119135','X',0,'2014-01-05 00:00:02',NULL,NULL),(1892,1139,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:14',NULL,NULL),(1951,1198,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:53:57',NULL,NULL),(2021,1268,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:48',NULL,NULL),(2124,1371,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:16',NULL,NULL),(2164,1411,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:07',NULL,NULL),(2167,1414,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:25:15',NULL,NULL),(2400,1478,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-12','18:13:00','132584','X',0,'2014-01-13 03:01:08',NULL,NULL),(2777,2556,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-22','18:31:00','150818','X',0,'2014-01-23 03:02:51',NULL,NULL),(2879,2654,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:53:00','1','X',1,'2014-01-23 04:27:53',NULL,NULL),(3224,2776,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-02','18:10:00','168373','X',0,'2014-02-02 19:00:26',NULL,NULL),(920,57,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-19','18:07:00','31307','X',0,'2013-12-26 00:31:32',NULL,NULL),(1679,568,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-02','18:42:00','115203','X',0,'2014-01-03 02:05:34',NULL,NULL),(1888,1135,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:03',NULL,NULL),(1926,1173,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:48',NULL,NULL),(2295,1473,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-11','18:16:00','130852','X',0,'2014-01-13 02:18:18',NULL,NULL),(2496,1555,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:47',NULL,NULL),(3733,2807,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-18','18:25:00','203027','X',0,'2014-02-18 21:30:02',NULL,NULL),(3939,2820,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-23','18:10:00','215485','X',0,'2014-02-26 08:00:27',NULL,NULL),(4037,2826,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-27','18:48:00','225931','X',0,'2014-02-28 06:31:34',NULL,NULL),(4216,2843,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-03-04','18:50:00','238763','X',0,'2014-03-04 21:02:33',NULL,NULL),(682,42,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-08','18:03:00','21238','X',0,'2013-12-25 22:30:11',NULL,NULL),(694,43,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-10','18:01:00','7175','X',0,'2013-12-25 22:31:16',NULL,NULL),(1411,93,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-24','01:56:00','90947','X',0,'2013-12-26 13:09:43',NULL,NULL),(2160,1407,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:56',NULL,NULL),(3316,2781,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-05','18:39:00','174426','X',0,'2014-02-05 21:31:19',NULL,NULL),(4019,2825,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-26','18:43:00','223774','X',0,'2014-02-26 21:02:45',NULL,NULL),(4063,2828,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-27','18:43:00','224647','X',0,'2014-02-28 07:30:02',NULL,NULL),(4330,2849,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-07','18:42:00','246116','X',0,'2014-03-07 21:00:28',NULL,NULL),(194,13,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-03','18:20:00','49900','X',0,'2013-12-25 18:21:09',NULL,NULL),(367,23,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-02','18:14:00','47683','X',0,'2013-12-25 19:48:43',NULL,NULL),(723,46,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-07','18:13:00','57441','X',0,'2013-12-25 22:47:46',NULL,NULL),(1912,1159,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:09',NULL,NULL),(2727,2554,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-20','18:21:00','146906','X',0,'2014-01-21 08:46:54',NULL,NULL),(1183,75,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-20','19:06:00','84220','X',0,'2013-12-26 03:09:33',NULL,NULL),(1266,80,'005010X220A1','BE','OH0','92036','92036OH0020008','2013-12-18','18:49:00','79096','X',0,'2013-12-26 04:10:11',NULL,NULL),(1635,387,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-31','18:52:00','111674','X',1,'2014-01-02 04:28:40',NULL,NULL),(2327,1474,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-09','18:28:00','127867','X',0,'2014-01-13 02:20:50',NULL,NULL),(2726,2554,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-20','18:21:00','146905','X',0,'2014-01-21 08:46:51',NULL,NULL),(3728,2806,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-17','18:05:00','202226','X',0,'2014-02-17 19:00:13',NULL,NULL),(4350,2850,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-07','18:46:00','247665','X',0,'2014-03-07 21:31:58',NULL,NULL),(287,20,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-20','18:06:00','32811','X',0,'2013-12-25 19:02:35',NULL,NULL),(457,31,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-18','18:07:00','30650','X',0,'2013-12-25 20:31:08',NULL,NULL),(672,41,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-08','18:10:00','59429','X',0,'2013-12-25 22:17:12',NULL,NULL),(2898,2673,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 04:52:49',NULL,NULL),(3242,2777,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-03','18:32:00','170204','X',0,'2014-02-03 21:01:06',NULL,NULL),(3245,2777,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-03','18:32:00','170207','X',0,'2014-02-03 21:01:20',NULL,NULL),(3681,2802,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-02-15','18:48:00','199872','X',0,'2014-02-15 22:01:48',NULL,NULL),(4099,2830,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-28','19:12:00','229917','X',0,'2014-02-28 21:31:43',NULL,NULL),(1977,1224,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:10',NULL,NULL),(2173,1420,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:32',NULL,NULL),(2203,1450,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:56',NULL,NULL),(2282,1471,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-07','18:29:00','123280','X',0,'2014-01-08 18:25:00',NULL,NULL),(2377,1477,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-10','18:26:00','129732','X',0,'2014-01-13 03:00:16',NULL,NULL),(3070,2759,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-27','18:27:00','158010','X',0,'2014-01-27 21:01:26',NULL,NULL),(3093,2760,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-28','18:32:00','160244','X',0,'2014-01-28 21:00:43',NULL,NULL),(3867,2815,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-21','18:28:00','211313','X',0,'2014-02-21 21:30:21',NULL,NULL),(578,39,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-17','18:43:00','78027','X',0,'2013-12-25 21:45:05',NULL,NULL),(1430,93,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-24','01:56:00','90966','X',0,'2013-12-26 13:15:13',NULL,NULL),(1895,1142,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:22',NULL,NULL),(2046,1293,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:57',NULL,NULL),(2659,2551,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-17','18:23:00','142625','X',0,'2014-01-20 08:06:15',NULL,NULL),(3006,2756,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-24','18:26:00','154286','X',0,'2014-01-24 21:00:03',NULL,NULL),(4161,2834,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-02','18:15:00','232810','X',0,'2014-03-03 01:29:59',NULL,NULL),(647,40,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-12','18:53:00','67267','X',0,'2013-12-25 22:09:19',NULL,NULL),(1340,83,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-15','18:34:00','27236','X',0,'2013-12-26 04:46:18',NULL,NULL),(1984,1231,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:04',NULL,NULL),(2142,1389,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:06',NULL,NULL),(2783,2558,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:47:00','1','X',0,'2014-01-23 03:39:19',NULL,NULL),(2932,2707,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:13:00','1','X',0,'2014-01-23 06:45:09',NULL,NULL),(3008,2756,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-24','18:26:00','154288','X',0,'2014-01-24 21:00:23',NULL,NULL),(3283,2778,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-04','18:29:00','172125','X',0,'2014-02-04 21:01:57',NULL,NULL),(4165,2835,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-03','18:31:00','234700','X',0,'2014-03-03 21:00:08',NULL,NULL),(4300,2847,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-03-06','18:51:00','245600','X',0,'2014-03-06 21:02:49',NULL,NULL),(1448,93,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-24','01:56:00','90986','X',0,'2013-12-26 13:16:56',NULL,NULL),(1505,380,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-27','18:44:00','101829','X',0,'2013-12-28 03:36:56',NULL,NULL),(1522,381,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-28','18:14:00','103714','X',1,'2013-12-29 11:09:28',NULL,NULL),(1975,1222,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:04',NULL,NULL),(2478,1537,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:30',NULL,NULL),(3155,2773,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-01-30','18:35:00','164076','X',0,'2014-01-30 21:01:24',NULL,NULL),(3182,2774,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-31','18:37:00','165924','X',0,'2014-01-31 21:01:26',NULL,NULL),(3451,2792,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-10','18:30:00','186437','X',0,'2014-02-10 21:30:06',NULL,NULL),(3960,2823,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-22','18:14:00','213802','X',0,'2014-02-26 08:30:33',NULL,NULL),(4022,2826,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-27','18:48:00','225916','X',0,'2014-02-28 06:30:03',NULL,NULL),(4071,2828,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-27','18:43:00','224655','X',0,'2014-02-28 07:30:32',NULL,NULL),(3336,2782,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-06','18:28:00','175993','X',0,'2014-02-06 21:01:40',NULL,NULL),(3375,2785,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-07','18:13:00','177275','X',0,'2014-02-07 19:30:05',NULL,NULL),(3610,2798,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-13','18:46:00','194333','X',0,'2014-02-13 22:03:12',NULL,NULL),(2170,1417,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:24',NULL,NULL),(2294,1473,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-11','18:16:00','130851','X',0,'2014-01-13 02:18:07',NULL,NULL),(3031,2756,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-24','18:26:00','154312','X',0,'2014-01-24 21:01:18',NULL,NULL),(4029,2826,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-27','18:48:00','225923','X',0,'2014-02-28 06:31:16',NULL,NULL),(4175,2836,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-03','18:33:00','236071','X',0,'2014-03-03 21:30:06',NULL,NULL),(239,19,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-24','18:40:00','96800','X',0,'2013-12-25 18:45:56',NULL,NULL),(323,21,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-10','18:21:00','62772','X',0,'2013-12-25 19:21:10',NULL,NULL),(348,22,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-09','18:28:00','61518','X',0,'2013-12-25 19:37:40',NULL,NULL),(633,40,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-12','18:53:00','67253','X',0,'2013-12-25 22:07:10',NULL,NULL),(1271,80,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-18','18:49:00','79101','X',0,'2013-12-26 04:10:28',NULL,NULL),(2632,2540,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-16','18:41:00','141408','X',0,'2014-01-17 03:36:10',NULL,NULL),(24,1,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-05','18:31:00','54199','X',0,'2013-12-25 17:21:27',NULL,NULL),(177,13,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-03','18:20:00','49883','X',0,'2013-12-25 18:16:20',NULL,NULL),(523,37,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-22','18:40:00','88484','X',0,'2013-12-25 21:23:01',NULL,NULL),(626,40,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-12','18:53:00','67246','X',0,'2013-12-25 22:06:10',NULL,NULL),(2578,2311,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-14','19:00:00','136135','X',0,'2014-01-15 02:08:09',NULL,NULL),(3580,2798,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-13','18:46:00','194303','X',0,'2014-02-13 22:00:03',NULL,NULL),(3904,2819,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-25','18:36:00','220676','X',0,'2014-02-25 21:30:25',NULL,NULL),(4024,2826,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-27','18:48:00','225918','X',0,'2014-02-28 06:30:14',NULL,NULL),(4129,2832,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-01','18:23:00','232016','X',0,'2014-03-01 21:00:49',NULL,NULL),(201,13,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-03','18:20:00','49907','X',0,'2013-12-25 18:21:29',NULL,NULL),(1502,380,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-27','18:44:00','101826','X',0,'2013-12-28 03:36:47',NULL,NULL),(1551,382,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-28','21:04:00','105807','X',1,'2013-12-29 11:14:56',NULL,NULL),(2159,1406,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:53',NULL,NULL),(2232,1468,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-06','18:24:00','121978','X',0,'2014-01-07 04:04:47',NULL,NULL),(2251,1468,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-06','18:24:00','121998','X',0,'2014-01-07 04:06:51',NULL,NULL),(2293,1473,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-11','18:16:00','130850','X',0,'2014-01-13 02:18:04',NULL,NULL),(2511,1570,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:04:00',NULL,NULL),(2668,2551,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-17','18:23:00','142634','X',0,'2014-01-20 08:06:37',NULL,NULL),(2888,2663,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 04:45:33',NULL,NULL),(3341,2782,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-06','18:28:00','175998','X',0,'2014-02-06 21:01:48',NULL,NULL),(3866,2815,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-21','18:28:00','211312','X',0,'2014-02-21 21:30:18',NULL,NULL),(4248,2846,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-05','18:49:00','241582','X',0,'2014-03-05 21:30:31',NULL,NULL),(398,26,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-02','18:03:00','17180','X',0,'2013-12-25 20:01:09',NULL,NULL),(1738,571,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-04','18:14:00','119140','X',0,'2014-01-05 00:01:39',NULL,NULL),(2486,1545,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:03:38',NULL,NULL),(2604,2539,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-01-15','18:30:00','138466','X',0,'2014-01-16 08:47:09',NULL,NULL),(3674,2802,'005010X220A1','BE','LA0','92036','92036OH0040026','2014-02-15','18:48:00','199882','X',0,'2014-02-15 22:00:49',NULL,NULL),(3905,2819,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-25','18:36:00','220677','X',0,'2014-02-25 21:30:26',NULL,NULL),(270,19,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-24','18:40:00','96831','X',0,'2013-12-25 18:59:11',NULL,NULL),(896,53,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-11-21','18:06:00','34274','X',0,'2013-12-26 00:16:55',NULL,NULL),(1166,75,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-20','19:06:00','84203','X',0,'2013-12-26 03:00:39',NULL,NULL),(1696,568,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-02','18:42:00','115220','X',0,'2014-01-03 02:07:05',NULL,NULL),(2381,1477,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-10','18:26:00','129736','X',0,'2014-01-13 03:00:23',NULL,NULL),(2433,1492,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:24',NULL,NULL),(2697,2553,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-19','18:08:00','145204','X',0,'2014-01-21 08:45:18',NULL,NULL),(2847,2622,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 04:07:06',NULL,NULL),(3742,2807,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-18','18:25:00','203036','X',0,'2014-02-18 21:30:20',NULL,NULL),(3892,2818,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-25','18:33:00','219088','X',0,'2014-02-25 21:00:09',NULL,NULL),(4093,2830,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-28','19:12:00','229911','X',0,'2014-02-28 21:31:25',NULL,NULL),(4159,2833,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-03-02','18:16:00','233978','X',0,'2014-03-03 01:00:40',NULL,NULL),(4336,2849,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-07','18:42:00','246122','X',0,'2014-03-07 21:00:34',NULL,NULL),(922,57,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-19','18:07:00','31305','X',0,'2013-12-26 00:31:47',NULL,NULL),(938,59,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-11','18:36:00','64771','X',0,'2013-12-26 00:48:40',NULL,NULL),(1478,99,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-26','18:41:00','100568','X',0,'2013-12-27 02:07:40',NULL,NULL),(1720,569,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-03','18:38:00','116019','X',0,'2014-01-04 02:05:57',NULL,NULL),(2195,1442,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:33',NULL,NULL),(2311,1474,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-09','18:28:00','127851','X',0,'2014-01-13 02:19:06',NULL,NULL),(2597,2539,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-15','18:30:00','138459','X',0,'2014-01-16 08:46:46',NULL,NULL),(3418,2789,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-09','18:11:00','181292','X',0,'2014-02-09 19:00:43',NULL,NULL),(3447,2791,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-10','18:27:00','184758','X',0,'2014-02-10 21:00:10',NULL,NULL),(933,58,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-07','19:14:00','6701','X',0,'2013-12-26 00:32:22',NULL,NULL),(957,59,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-11','18:36:00','64790','X',0,'2013-12-26 00:53:34',NULL,NULL),(1903,1150,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:44',NULL,NULL),(2062,1309,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:42',NULL,NULL),(2676,2552,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-18','18:11:00','144574','X',0,'2014-01-21 08:44:13',NULL,NULL),(2935,2710,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:11:00','1','X',0,'2014-01-23 06:46:11',NULL,NULL),(3175,2774,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-31','18:37:00','165917','X',0,'2014-01-31 21:00:58',NULL,NULL),(3230,2776,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-02','18:10:00','168379','X',0,'2014-02-02 19:00:31',NULL,NULL),(3663,2800,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-14','18:36:00','195041','X',0,'2014-02-14 22:00:08',NULL,NULL),(4262,2846,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-05','18:49:00','241596','X',0,'2014-03-05 21:32:28',NULL,NULL),(1338,83,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-15','18:34:00','27234','X',0,'2013-12-26 04:46:14',NULL,NULL),(1541,382,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-28','21:04:00','105797','X',1,'2013-12-29 11:13:57',NULL,NULL),(1634,387,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-31','18:52:00','111673','X',1,'2014-01-02 04:26:40',NULL,NULL),(1948,1195,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:49',NULL,NULL),(2183,1430,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:00',NULL,NULL),(3429,2790,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-10','05:02:00','183702','X',0,'2014-02-10 11:00:50',NULL,NULL),(3702,2804,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-16','18:12:00','201508','X',0,'2014-02-16 19:00:04',NULL,NULL),(4083,2829,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-02-28','19:08:00','228398','X',0,'2014-02-28 21:00:25',NULL,NULL),(4441,2855,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-10','19:23:00','255916','X',0,'2014-03-10 21:01:24',NULL,NULL),(477,33,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-01','18:03:00','16377','X',0,'2013-12-25 20:45:41',NULL,NULL),(787,49,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-06','18:03:00','20426','X',0,'2013-12-25 23:16:33',NULL,NULL),(3090,2760,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-28','18:32:00','160241','X',0,'2014-01-28 21:00:14',NULL,NULL),(3166,2773,'005010X220A1','BE','OH0','92036','92036OH0020008','2014-01-30','18:35:00','164087','X',0,'2014-01-30 21:01:37',NULL,NULL),(3666,2801,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-15','18:44:00','198281','X',0,'2014-02-15 21:00:08',NULL,NULL),(4282,2847,'005010X220A1','BE','SC0','46300','46300MS0020001','2014-03-06','18:51:00','245605','X',0,'2014-03-06 21:02:03',NULL,NULL),(4477,2856,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-10','19:17:00','254164','X',0,'2014-03-10 21:30:10',NULL,NULL),(40,2,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-12','18:01:00','7924','X',0,'2013-12-25 17:30:24',NULL,NULL),(223,15,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-11-04','18:02:00','18539','X',0,'2013-12-25 18:31:47',NULL,NULL),(479,33,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-01','18:03:00','16379','X',0,'2013-12-25 20:45:45',NULL,NULL),(517,37,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-22','18:40:00','88478','X',0,'2013-12-25 21:22:41',NULL,NULL),(526,37,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-22','18:40:00','88487','X',0,'2013-12-25 21:23:10',NULL,NULL),(966,59,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-11','18:36:00','64799','X',0,'2013-12-26 00:54:07',NULL,NULL),(1254,80,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-18','18:49:00','79084','X',0,'2013-12-26 04:08:57',NULL,NULL),(2002,1249,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:55',NULL,NULL),(2180,1427,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:52',NULL,NULL),(3979,2824,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-24','18:21:00','218491','X',0,'2014-02-26 09:30:29',NULL,NULL),(4422,2853,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-09','18:20:00','252267','X',0,'2014-03-09 21:01:15',NULL,NULL),(4452,2855,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-03-10','19:23:00','255927','X',0,'2014-03-10 21:02:30',NULL,NULL),(4457,2855,'005010X220A1','BE','OH0','99734','99734OH0050002','2014-03-10','19:23:00','255932','X',0,'2014-03-10 21:02:37',NULL,NULL),(265,19,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-24','18:40:00','96826','X',0,'2013-12-25 18:58:50',NULL,NULL),(1209,76,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-22','18:08:00','35663','X',0,'2013-12-26 03:15:59',NULL,NULL),(1607,385,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-30','19:01:00','109554','X',0,'2014-01-01 12:09:04',NULL,NULL),(1632,386,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-01','18:18:00','112817','X',1,'2014-01-02 04:25:48',NULL,NULL),(2398,1477,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-10','18:26:00','129753','X',0,'2014-01-13 03:00:44',NULL,NULL),(2538,1576,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-13','18:44:00','134014','X',0,'2014-01-14 01:33:47',NULL,NULL),(3203,2775,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-01','18:14:00','166672','X',0,'2014-02-01 19:00:28',NULL,NULL),(3330,2782,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-06','18:28:00','175987','X',0,'2014-02-06 21:01:22',NULL,NULL),(3414,2789,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-09','18:11:00','181288','X',0,'2014-02-09 19:00:40',NULL,NULL),(3846,2814,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-20','18:28:00','208913','X',0,'2014-02-20 22:01:02',NULL,NULL),(4061,2827,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-26','18:39:00','222060','X',0,'2014-02-28 07:00:38',NULL,NULL),(4154,2833,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-02','18:16:00','233973','X',0,'2014-03-03 01:00:37',NULL,NULL),(1658,387,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-31','18:52:00','111697','X',1,'2014-01-02 04:35:31',NULL,NULL),(1918,1165,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:26',NULL,NULL),(2789,2564,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','11:28:00','1','X',0,'2014-01-23 03:39:37',NULL,NULL),(2992,2755,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-23','18:27:00','151588','X',0,'2014-01-23 21:01:19',NULL,NULL),(3345,2782,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-06','18:28:00','176002','X',0,'2014-02-06 21:01:53',NULL,NULL),(4114,2831,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-01','18:21:00','230732','X',0,'2014-03-01 19:00:06',NULL,NULL),(774,48,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-27','18:05:00','41574','X',0,'2013-12-25 23:15:18',NULL,NULL),(1350,84,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-10-21','18:04:00','11692','X',0,'2013-12-26 05:01:16',NULL,NULL),(2384,1477,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-10','18:26:00','129739','X',0,'2014-01-13 03:00:26',NULL,NULL),(2445,1504,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:35',NULL,NULL),(2859,2634,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:20:00','1','X',1,'2014-01-23 04:16:03',NULL,NULL),(3687,2802,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-15','18:48:00','199878','X',0,'2014-02-15 22:01:57',NULL,NULL),(240,19,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-24','18:40:00','96801','X',0,'2013-12-25 18:47:44',NULL,NULL),(952,59,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-11','18:36:00','64785','X',0,'2013-12-26 00:52:58',NULL,NULL),(1401,92,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-24','01:56:00','90938','X',0,'2013-12-26 12:54:11',NULL,NULL),(1407,92,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-24','01:56:00','90944','X',0,'2013-12-26 13:05:50',NULL,NULL),(1905,1152,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:50',NULL,NULL),(2546,1576,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-13','18:44:00','134022','X',0,'2014-01-14 01:33:53',NULL,NULL),(2974,2749,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:20:00','1','X',0,'2014-01-23 16:00:02',NULL,NULL),(3221,2776,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-02','18:10:00','168370','X',0,'2014-02-02 19:00:20',NULL,NULL),(1190,75,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-20','19:06:00','84228','X',0,'2013-12-26 03:10:22',NULL,NULL),(1520,381,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-28','18:14:00','103712','X',1,'2013-12-29 11:08:34',NULL,NULL),(1564,383,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-29','18:10:00','107246','X',0,'2013-12-30 00:01:13',NULL,NULL),(4143,2833,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-02','18:16:00','233962','X',0,'2014-03-03 01:00:04',NULL,NULL),(4182,2836,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-03-03','18:33:00','236078','X',0,'2014-03-03 21:31:27',NULL,NULL),(401,26,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-02','18:03:00','17181','X',0,'2013-12-25 20:01:23',NULL,NULL),(574,38,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-13','18:39:00','69300','X',0,'2013-12-25 21:39:08',NULL,NULL),(1165,75,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-20','19:06:00','84202','X',0,'2013-12-26 03:00:35',NULL,NULL),(1249,80,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-18','18:49:00','79079','X',0,'2013-12-26 04:08:37',NULL,NULL),(2128,1375,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:23:27',NULL,NULL),(3094,2760,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-01-28','18:32:00','160245','X',0,'2014-01-28 21:01:00',NULL,NULL),(117,7,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-16','18:37:00','74930','X',0,'2013-12-25 18:06:56',NULL,NULL),(406,26,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-02','18:03:00','17182','X',0,'2013-12-25 20:01:49',NULL,NULL),(1312,82,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-21','18:37:00','86522','X',0,'2013-12-26 04:38:52',NULL,NULL),(1721,569,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-03','18:38:00','116020','X',0,'2014-01-04 02:06:00',NULL,NULL),(2258,1469,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-05','18:09:00','119792','X',1,'2014-01-07 10:22:23',NULL,NULL),(3575,2797,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-13','18:41:00','192637','X',0,'2014-02-13 21:30:13',NULL,NULL),(3680,2802,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-15','18:48:00','199871','X',0,'2014-02-15 22:01:43',NULL,NULL),(3762,2808,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-18','18:28:00','204276','X',0,'2014-02-18 22:01:30',NULL,NULL),(4426,2853,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-03-09','18:20:00','252271','X',0,'2014-03-09 21:01:21',NULL,NULL),(163,9,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-11','18:02:00','23532','X',0,'2013-12-25 18:10:52',NULL,NULL),(393,25,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-24','18:02:00','37690','X',0,'2013-12-25 20:00:29',NULL,NULL),(1524,381,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-28','18:14:00','103716','X',1,'2013-12-29 11:09:45',NULL,NULL),(497,35,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-11-28','18:02:00','42794','X',0,'2013-12-25 20:47:06',NULL,NULL),(1185,75,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-20','19:06:00','84222','X',0,'2013-12-26 03:09:55',NULL,NULL),(1432,93,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-24','01:56:00','90968','X',0,'2013-12-26 13:15:23',NULL,NULL),(2177,1424,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:43',NULL,NULL),(2369,1476,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-10','18:26:00','129726','X',0,'2014-01-13 02:24:05',NULL,NULL),(2536,1576,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-13','18:44:00','134012','X',0,'2014-01-14 01:33:45',NULL,NULL),(2707,2553,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-19','18:08:00','145214','X',0,'2014-01-21 08:45:39',NULL,NULL),(3188,2774,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-31','18:37:00','165930','X',0,'2014-01-31 21:01:37',NULL,NULL),(435,29,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-06','18:21:00','55545','X',0,'2013-12-25 20:19:58',NULL,NULL),(1110,71,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-15','18:15:00','73601','X',0,'2013-12-26 02:30:24',NULL,NULL),(1247,80,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-18','18:49:00','79077','X',0,'2013-12-26 04:08:29',NULL,NULL),(1313,82,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-21','18:37:00','86524','X',0,'2013-12-26 04:38:57',NULL,NULL),(2466,1525,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:18',NULL,NULL),(2689,2552,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-18','18:11:00','144587','X',0,'2014-01-21 08:44:43',NULL,NULL),(2939,2714,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','10:28:00','1','X',0,'2014-01-23 07:00:02',NULL,NULL),(3500,2793,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-11','18:41:00','189054','X',0,'2014-02-11 21:02:30',NULL,NULL),(3565,2796,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-12','18:31:00','191473','X',0,'2014-02-12 21:32:30',NULL,NULL),(3964,2823,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-22','18:14:00','213806','X',0,'2014-02-26 08:30:50',NULL,NULL),(4233,2844,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-04','18:46:00','237493','X',0,'2014-03-04 21:30:20',NULL,NULL),(169,10,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-10-19','18:01:00','10694','X',0,'2013-12-25 18:11:08',NULL,NULL),(280,20,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-20','18:06:00','32804','X',0,'2013-12-25 19:00:54',NULL,NULL),(1454,99,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-26','18:41:00','100544','X',0,'2013-12-27 02:00:28',NULL,NULL),(1879,1126,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','11:30:00','1','X',0,'2014-01-05 16:50:38',NULL,NULL),(1916,1163,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:20',NULL,NULL),(2247,1468,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-06','18:24:00','121993','X',0,'2014-01-07 04:06:40',NULL,NULL),(2655,2551,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-17','18:23:00','142621','X',0,'2014-01-20 08:05:44',NULL,NULL),(2736,2555,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-21','18:24:00','147871','X',1,'2014-01-22 03:21:51',NULL,NULL),(176,13,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-03','18:20:00','49882','X',0,'2013-12-25 18:16:17',NULL,NULL),(3761,2808,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-18','18:28:00','204275','X',0,'2014-02-18 22:01:29',NULL,NULL),(4149,2833,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-02','18:16:00','233968','X',0,'2014-03-03 01:00:27',NULL,NULL),(205,14,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-29','18:04:00','43694','X',0,'2013-12-25 18:30:18',NULL,NULL),(934,58,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-07','19:14:00','6703','X',0,'2013-12-26 00:32:26',NULL,NULL),(992,62,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-05','18:03:00','19335','X',0,'2013-12-26 01:01:52',NULL,NULL),(1168,75,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-20','19:06:00','84205','X',0,'2013-12-26 03:04:16',NULL,NULL),(1339,83,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-15','18:34:00','27235','X',0,'2013-12-26 04:46:16',NULL,NULL),(1623,386,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-01','18:18:00','112808','X',1,'2014-01-02 04:24:07',NULL,NULL),(1938,1185,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:21',NULL,NULL),(2151,1398,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:31',NULL,NULL),(3619,2798,'005010X220A1','BE','OH0','92036','92036OH0010008','2014-02-13','18:46:00','194342','X',0,'2014-02-13 22:03:21',NULL,NULL),(4460,2855,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-10','19:23:00','255935','X',0,'2014-03-10 21:02:44',NULL,NULL),(164,9,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-11-11','18:02:00','23537','X',0,'2013-12-25 18:10:54',NULL,NULL),(375,23,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-02','18:14:00','47691','X',0,'2013-12-25 19:49:42',NULL,NULL),(832,51,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-24','03:40:00','94571','X',0,'2013-12-25 23:49:56',NULL,NULL),(1530,381,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-28','18:14:00','103722','X',1,'2013-12-29 11:10:08',NULL,NULL),(1940,1187,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:26',NULL,NULL),(2019,1266,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:42',NULL,NULL),(2310,1473,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-11','18:16:00','130867','X',0,'2014-01-13 02:18:42',NULL,NULL),(2490,1549,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:41',NULL,NULL),(350,22,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-09','18:28:00','61520','X',0,'2013-12-25 19:37:45',NULL,NULL),(1930,1177,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:59',NULL,NULL),(2684,2552,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-18','18:11:00','144582','X',0,'2014-01-21 08:44:30',NULL,NULL),(2751,2555,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-21','18:24:00','147886','X',1,'2014-01-22 03:23:01',NULL,NULL),(3304,2781,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-05','18:39:00','174414','X',0,'2014-02-05 21:31:07',NULL,NULL),(3484,2792,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-10','18:30:00','186470','X',0,'2014-02-10 21:32:18',NULL,NULL),(3597,2798,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-02-13','18:46:00','194320','X',0,'2014-02-13 22:02:45',NULL,NULL),(3774,2810,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-19','18:35:00','207789','X',0,'2014-02-20 04:01:42',NULL,NULL),(3776,2810,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-19','18:35:00','207790','X',0,'2014-02-20 04:02:35',NULL,NULL),(895,53,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-11-21','18:06:00','34273','X',0,'2013-12-26 00:16:51',NULL,NULL),(1308,82,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-21','18:37:00','86514','X',0,'2013-12-26 04:38:03',NULL,NULL),(1436,93,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-24','01:56:00','90973','X',0,'2013-12-26 13:15:59',NULL,NULL),(2484,1543,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:36',NULL,NULL),(3314,2781,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-05','18:39:00','174424','X',0,'2014-02-05 21:31:17',NULL,NULL),(3443,2791,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-10','18:27:00','184754','X',0,'2014-02-10 21:00:03',NULL,NULL),(1604,385,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-30','19:01:00','109551','X',0,'2014-01-01 12:08:53',NULL,NULL),(2175,1422,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:38',NULL,NULL),(2277,1471,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-07','18:29:00','123275','X',0,'2014-01-08 18:24:52',NULL,NULL),(2543,1576,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-13','18:44:00','134019','X',0,'2014-01-14 01:33:51',NULL,NULL),(2752,2555,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-21','18:24:00','147887','X',1,'2014-01-22 03:23:02',NULL,NULL),(2820,2595,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:11:00','1','X',1,'2014-01-23 03:49:11',NULL,NULL),(3113,2771,'005010X231A1','FA','OH0','52664','52664OH1510013','2014-01-29','14:05:00','1','X',0,'2014-01-29 15:00:03',NULL,NULL),(3177,2774,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-31','18:37:00','165919','X',0,'2014-01-31 21:01:03',NULL,NULL),(3276,2778,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-04','18:29:00','172118','X',0,'2014-02-04 21:01:50',NULL,NULL),(3417,2789,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-09','18:11:00','181291','X',0,'2014-02-09 19:00:42',NULL,NULL),(3669,2801,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-15','18:44:00','198284','X',0,'2014-02-15 21:00:11',NULL,NULL),(3958,2823,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-22','18:14:00','213800','X',0,'2014-02-26 08:30:26',NULL,NULL),(4468,2855,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-03-10','19:23:00','255943','X',0,'2014-03-10 21:02:57',NULL,NULL),(480,33,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-11-01','18:03:00','16380','X',0,'2013-12-25 20:45:47',NULL,NULL),(572,38,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-13','18:39:00','69298','X',0,'2013-12-25 21:39:02',NULL,NULL),(587,39,'005010X220A1','BE','NC0','33348','33348TX0020002','2013-12-17','18:43:00','78062','X',0,'2013-12-25 21:49:50',NULL,NULL),(1966,1213,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:39',NULL,NULL),(2337,1475,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-08','18:27:00','125973','X',0,'2014-01-13 02:21:08',NULL,NULL),(3349,2783,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-06','18:26:00','175059','X',0,'2014-02-06 21:30:05',NULL,NULL),(1695,568,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-02','18:42:00','115219','X',0,'2014-01-03 02:07:03',NULL,NULL),(1939,1186,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:24',NULL,NULL),(1990,1237,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:21',NULL,NULL),(2104,1351,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:39',NULL,NULL),(2915,2690,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:28:00','1','X',0,'2014-01-23 06:19:20',NULL,NULL),(233,17,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-07','18:02:00','20914','X',0,'2013-12-25 18:32:15',NULL,NULL),(739,47,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-19','19:11:00','81725','X',0,'2013-12-25 23:07:27',NULL,NULL),(1325,82,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-21','18:37:00','86542','X',0,'2013-12-26 04:39:56',NULL,NULL),(1873,1120,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:22',NULL,NULL),(2053,1300,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:00:17',NULL,NULL),(2198,1445,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:42',NULL,NULL),(2417,1478,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-12','18:13:00','132601','X',0,'2014-01-13 03:01:57',NULL,NULL),(3256,2777,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-03','18:32:00','170218','X',0,'2014-02-03 21:01:38',NULL,NULL),(4439,2855,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-10','19:23:00','255914','X',0,'2014-03-10 21:01:16',NULL,NULL),(929,57,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-19','18:07:00','31315','X',0,'2013-12-26 00:32:06',NULL,NULL),(986,62,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-05','18:03:00','19341','X',0,'2013-12-26 01:01:23',NULL,NULL),(1649,387,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-31','18:52:00','111688','X',1,'2014-01-02 04:34:45',NULL,NULL),(2519,1576,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-13','18:44:00','133995','X',0,'2014-01-14 01:32:34',NULL,NULL),(3554,2796,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-12','18:31:00','191462','X',0,'2014-02-12 21:32:11',NULL,NULL),(4421,2853,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-09','18:20:00','252266','X',0,'2014-03-09 21:01:13',NULL,NULL),(27,1,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-05','18:31:00','54202','X',0,'2013-12-25 17:21:46',NULL,NULL),(430,29,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-06','18:21:00','55540','X',0,'2013-12-25 20:19:43',NULL,NULL),(756,47,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-19','19:11:00','81742','X',0,'2013-12-25 23:10:26',NULL,NULL),(785,48,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-27','18:05:00','41585','X',0,'2013-12-25 23:16:28',NULL,NULL),(1126,71,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-15','18:15:00','73617','X',0,'2013-12-26 02:33:36',NULL,NULL),(1651,387,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-31','18:52:00','111690','X',1,'2014-01-02 04:34:55',NULL,NULL),(1963,1210,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:31',NULL,NULL),(2489,1548,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:40',NULL,NULL),(2648,2540,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-16','18:41:00','141424','X',0,'2014-01-17 03:36:39',NULL,NULL),(2671,2551,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-17','18:23:00','142637','X',0,'2014-01-20 08:06:41',NULL,NULL),(3360,2784,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-07','18:14:00','177569','X',0,'2014-02-07 19:00:57',NULL,NULL),(3671,2802,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-15','18:48:00','199862','X',0,'2014-02-15 22:00:03',NULL,NULL),(276,20,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-20','18:06:00','32800','X',0,'2013-12-25 19:00:02',NULL,NULL),(744,47,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-19','19:11:00','81730','X',0,'2013-12-25 23:08:56',NULL,NULL),(1280,81,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-30','18:04:00','44820','X',0,'2013-12-26 04:15:16',NULL,NULL),(1351,84,'005010X220A1','BE','MS0','46300','46300MS0010001','2013-10-21','18:04:00','11693','X',0,'2013-12-26 05:01:19',NULL,NULL),(1606,385,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-30','19:01:00','109553','X',0,'2014-01-01 12:09:00',NULL,NULL),(1663,387,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-31','18:52:00','111702','X',1,'2014-01-02 04:35:54',NULL,NULL),(2134,1381,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:43',NULL,NULL),(2163,1410,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:04',NULL,NULL),(3301,2781,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-05','18:39:00','174411','X',0,'2014-02-05 21:31:03',NULL,NULL),(3841,2814,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-20','18:28:00','208908','X',0,'2014-02-20 22:00:08',NULL,NULL),(3912,2819,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-25','18:36:00','220684','X',0,'2014-02-25 21:31:40',NULL,NULL),(346,22,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-09','18:28:00','61516','X',0,'2013-12-25 19:37:32',NULL,NULL),(423,29,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-06','18:21:00','55533','X',0,'2013-12-25 20:19:17',NULL,NULL),(2535,1576,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-13','18:44:00','134011','X',0,'2014-01-14 01:33:45',NULL,NULL),(2623,2540,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-16','18:41:00','141399','X',0,'2014-01-17 03:35:22',NULL,NULL),(2909,2684,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 05:06:42',NULL,NULL),(3686,2802,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-15','18:48:00','199877','X',0,'2014-02-15 22:01:56',NULL,NULL),(3717,2804,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-02-16','18:12:00','201511','X',0,'2014-02-16 19:00:40',NULL,NULL),(4102,2830,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-28','19:12:00','229920','X',0,'2014-02-28 21:31:48',NULL,NULL),(4163,2835,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-03','18:31:00','234698','X',0,'2014-03-03 21:00:00',NULL,NULL),(1562,383,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-29','18:10:00','107244','X',0,'2013-12-30 00:01:03',NULL,NULL),(3354,2784,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-07','18:14:00','177563','X',0,'2014-02-07 19:00:32',NULL,NULL),(4392,2852,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-08','18:43:00','250664','X',0,'2014-03-08 21:31:08',NULL,NULL),(4394,2852,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-03-08','18:43:00','250666','X',0,'2014-03-08 21:31:13',NULL,NULL),(1741,571,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-04','18:14:00','119143','X',0,'2014-01-05 00:02:12',NULL,NULL),(2468,1527,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:20',NULL,NULL),(2544,1576,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-01-13','18:44:00','134020','X',0,'2014-01-14 01:33:52',NULL,NULL),(2750,2555,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-21','18:24:00','147885','X',1,'2014-01-22 03:23:00',NULL,NULL),(3274,2778,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-02-04','18:29:00','172116','X',0,'2014-02-04 21:01:46',NULL,NULL),(3433,2790,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-10','05:02:00','183706','X',0,'2014-02-10 11:01:04',NULL,NULL),(3710,2804,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-16','18:12:00','201503','X',0,'2014-02-16 19:00:24',NULL,NULL),(3971,2823,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-22','18:14:00','213815','X',0,'2014-02-26 08:30:57',NULL,NULL),(4201,2843,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-04','18:50:00','238748','X',0,'2014-03-04 21:00:51',NULL,NULL),(150,8,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-10-31','18:04:00','15475','X',0,'2013-12-25 18:10:08',NULL,NULL),(377,23,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-02','18:14:00','47693','X',0,'2013-12-25 19:49:51',NULL,NULL),(459,31,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-11-18','18:07:00','30659','X',0,'2013-12-25 20:31:39',NULL,NULL),(1437,93,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-24','01:56:00','90974','X',0,'2013-12-26 13:16:04',NULL,NULL),(1584,385,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-30','19:01:00','109531','X',0,'2014-01-01 12:03:49',NULL,NULL),(1736,571,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-04','18:14:00','119138','X',0,'2014-01-05 00:01:32',NULL,NULL),(3110,2760,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-28','18:32:00','160261','X',0,'2014-01-28 21:01:22',NULL,NULL),(3630,2799,'005010X220A1','BE','TX0','33348','33348TX0010002','2014-02-14','18:39:00','196123','X',0,'2014-02-14 21:31:32',NULL,NULL),(3891,2817,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-22','18:14:00','214243','X',0,'2014-02-22 19:00:15',NULL,NULL),(796,49,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-11-06','18:03:00','20429','X',0,'2013-12-25 23:17:13',NULL,NULL),(1180,75,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-20','19:06:00','84217','X',0,'2013-12-26 03:08:59',NULL,NULL),(2406,1478,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-12','18:13:00','132590','X',0,'2014-01-13 03:01:44',NULL,NULL),(2665,2551,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-17','18:23:00','142631','X',0,'2014-01-20 08:06:31',NULL,NULL),(2741,2555,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-21','18:24:00','147876','X',1,'2014-01-22 03:22:37',NULL,NULL),(3933,2820,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-23','18:10:00','215479','X',0,'2014-02-26 08:00:17',NULL,NULL),(336,22,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-09','18:28:00','61506','X',0,'2013-12-25 19:36:29',NULL,NULL),(978,61,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-16','18:03:00','28398','X',0,'2013-12-26 01:00:48',NULL,NULL),(1262,80,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-18','18:49:00','79092','X',0,'2013-12-26 04:09:45',NULL,NULL),(1647,387,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-31','18:52:00','111686','X',1,'2014-01-02 04:34:36',NULL,NULL),(2077,1324,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:01:24',NULL,NULL),(2479,1538,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','12:25:00','1','X',0,'2014-01-13 03:03:31',NULL,NULL),(2580,2311,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-14','19:00:00','136137','X',0,'2014-01-15 02:08:10',NULL,NULL),(2692,2552,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-18','18:11:00','144590','X',0,'2014-01-21 08:44:46',NULL,NULL),(3061,2759,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-27','18:27:00','158001','X',0,'2014-01-27 21:00:24',NULL,NULL),(3355,2784,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-07','18:14:00','177564','X',0,'2014-02-07 19:00:33',NULL,NULL),(3863,2815,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-21','18:28:00','211309','X',0,'2014-02-21 21:30:08',NULL,NULL),(700,44,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-10-04','18:00:00','5513','X',0,'2013-12-25 22:31:36',NULL,NULL),(960,59,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-11','18:36:00','64793','X',0,'2013-12-26 00:53:50',NULL,NULL),(1576,383,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-29','18:10:00','107258','X',0,'2013-12-30 00:02:19',NULL,NULL),(2219,1466,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:40',NULL,NULL),(3385,2786,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-08','18:12:00','180297','X',0,'2014-02-08 19:00:48',NULL,NULL),(4310,2847,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-03-06','18:51:00','245611','X',0,'2014-03-06 21:02:58',NULL,NULL),(4326,2849,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-03-07','18:42:00','246112','X',0,'2014-03-07 21:00:23',NULL,NULL),(4478,2856,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-10','19:17:00','254165','X',0,'2014-03-10 21:30:12',NULL,NULL),(15,1,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-05','18:31:00','54190','X',0,'2013-12-25 17:20:15',NULL,NULL),(1194,75,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-20','19:06:00','84232','X',0,'2013-12-26 03:10:33',NULL,NULL),(2522,1576,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-13','18:44:00','133998','X',0,'2014-01-14 01:33:11',NULL,NULL),(3410,2789,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-09','18:11:00','181282','X',0,'2014-02-09 19:00:31',NULL,NULL),(3889,2817,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-22','18:14:00','214241','X',0,'2014-02-22 19:00:12',NULL,NULL),(4220,2843,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-04','18:50:00','238767','X',0,'2014-03-04 21:02:37',NULL,NULL),(4290,2847,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-06','18:51:00','245590','X',0,'2014-03-06 21:02:33',NULL,NULL),(652,40,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-12','18:53:00','67272','X',0,'2013-12-25 22:09:32',NULL,NULL),(706,45,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-26','18:04:00','13999','X',0,'2013-12-25 22:32:01',NULL,NULL),(909,56,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-16','20:51:00','10066','X',0,'2013-12-26 00:30:33',NULL,NULL),(962,59,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-11','18:36:00','64795','X',0,'2013-12-26 00:53:55',NULL,NULL),(2144,1391,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:11',NULL,NULL),(3709,2804,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-16','18:12:00','201502','X',0,'2014-02-16 19:00:19',NULL,NULL),(3830,2813,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-20','18:26:00','208216','X',0,'2014-02-20 21:30:02',NULL,NULL),(4438,2855,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-10','19:23:00','255913','X',0,'2014-03-10 21:01:15',NULL,NULL),(212,14,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-11-29','18:04:00','43705','X',0,'2013-12-25 18:30:54',NULL,NULL),(469,32,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-10-03','18:00:00','5204','X',0,'2013-12-25 20:32:11',NULL,NULL),(1333,83,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-15','18:34:00','27229','X',0,'2013-12-26 04:45:42',NULL,NULL),(1439,93,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-24','01:56:00','90976','X',0,'2013-12-26 13:16:14',NULL,NULL),(1575,383,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-29','18:10:00','107257','X',0,'2013-12-30 00:02:16',NULL,NULL),(2141,1388,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:03',NULL,NULL),(3080,2759,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-27','18:27:00','158020','X',0,'2014-01-27 21:01:41',NULL,NULL),(3287,2780,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-05','18:36:00','173080','X',0,'2014-02-05 21:00:04',NULL,NULL),(3772,2809,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-19','18:35:00','207789','X',0,'2014-02-20 03:43:07',NULL,NULL),(3997,2825,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-26','18:43:00','223752','X',0,'2014-02-26 21:00:40',NULL,NULL),(4231,2844,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-04','18:46:00','237489','X',0,'2014-03-04 21:30:10',NULL,NULL),(4386,2852,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-08','18:43:00','250658','X',0,'2014-03-08 21:30:51',NULL,NULL),(13,1,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-05','18:31:00','54188','X',0,'2013-12-25 17:20:07',NULL,NULL),(394,25,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-24','18:02:00','37691','X',0,'2013-12-25 20:00:35',NULL,NULL),(397,25,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-24','18:02:00','37697','X',0,'2013-12-25 20:00:58',NULL,NULL),(1157,73,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-10-14','18:02:00','9157','X',0,'2013-12-26 02:46:31',NULL,NULL),(1498,380,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-27','18:44:00','101822','X',0,'2013-12-28 03:35:56',NULL,NULL),(2274,1471,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-07','18:29:00','123272','X',0,'2014-01-08 18:24:26',NULL,NULL),(2667,2551,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-17','18:23:00','142633','X',0,'2014-01-20 08:06:36',NULL,NULL),(3444,2791,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-10','18:27:00','184755','X',0,'2014-02-10 21:00:05',NULL,NULL),(3692,2802,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-15','18:48:00','199884','X',0,'2014-02-15 22:02:01',NULL,NULL),(4141,2833,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-02','18:16:00','233960','X',0,'2014-03-03 01:00:01',NULL,NULL),(4168,2835,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-03','18:31:00','234703','X',0,'2014-03-03 21:00:14',NULL,NULL),(4188,2836,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-03','18:33:00','236084','X',0,'2014-03-03 21:31:43',NULL,NULL),(4209,2843,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-04','18:50:00','238756','X',0,'2014-03-04 21:02:07',NULL,NULL),(453,30,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-10-13','18:01:00','8427','X',0,'2013-12-25 20:30:37',NULL,NULL),(584,39,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-17','18:43:00','78033','X',0,'2013-12-25 21:47:57',NULL,NULL),(1086,69,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-11-23','18:05:00','36676','X',0,'2013-12-26 02:15:02',NULL,NULL),(2838,2613,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:36:00','1','X',1,'2014-01-23 03:57:57',NULL,NULL),(3170,2774,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-31','18:37:00','165912','X',0,'2014-01-31 21:00:04',NULL,NULL),(4167,2835,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-03','18:31:00','234702','X',0,'2014-03-03 21:00:10',NULL,NULL),(4397,2852,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-08','18:43:00','250669','X',0,'2014-03-08 21:31:17',NULL,NULL),(84,6,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-04','18:22:00','52132','X',0,'2013-12-25 17:50:13',NULL,NULL),(788,49,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-06','18:03:00','20427','X',0,'2013-12-25 23:16:43',NULL,NULL),(1884,1131,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:52',NULL,NULL),(2047,1294,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:00',NULL,NULL),(2078,1325,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:01:26',NULL,NULL),(2271,1471,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-07','18:29:00','123269','X',0,'2014-01-08 18:24:07',NULL,NULL),(2512,1571,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:04:01',NULL,NULL),(2729,2554,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-20','18:21:00','146908','X',0,'2014-01-21 08:46:56',NULL,NULL),(1928,1175,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:53',NULL,NULL),(2024,1271,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:56',NULL,NULL),(2041,1288,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:43',NULL,NULL),(2054,1301,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:19',NULL,NULL),(2583,2311,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-14','19:00:00','136140','X',0,'2014-01-15 02:08:12',NULL,NULL),(3323,2782,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-06','18:28:00','175980','X',0,'2014-02-06 21:01:00',NULL,NULL),(4205,2843,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-04','18:50:00','238752','X',0,'2014-03-04 21:01:38',NULL,NULL),(1107,70,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-10-28','18:08:00','14564','X',0,'2013-12-26 02:17:08',NULL,NULL),(2802,2577,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:56:00','1','X',1,'2014-01-23 03:43:33',NULL,NULL),(4258,2846,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-05','18:49:00','241592','X',0,'2014-03-05 21:32:20',NULL,NULL),(717,46,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-07','18:13:00','57435','X',0,'2013-12-25 22:47:21',NULL,NULL),(754,47,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-19','19:11:00','81740','X',0,'2013-12-25 23:10:11',NULL,NULL),(1886,1133,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:58',NULL,NULL),(2420,1479,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:13',NULL,NULL),(2523,1576,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-13','18:44:00','133999','X',0,'2014-01-14 01:33:15',NULL,NULL),(2626,2540,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-16','18:41:00','141402','X',0,'2014-01-17 03:35:45',NULL,NULL),(3146,2773,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-30','18:35:00','164067','X',0,'2014-01-30 21:00:51',NULL,NULL),(3275,2778,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-04','18:29:00','172117','X',0,'2014-02-04 21:01:48',NULL,NULL),(3668,2801,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-15','18:44:00','198283','X',0,'2014-02-15 21:00:10',NULL,NULL),(4084,2829,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-28','19:08:00','228399','X',0,'2014-02-28 21:00:25',NULL,NULL),(316,21,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-10','18:21:00','62765','X',0,'2013-12-25 19:20:44',NULL,NULL),(640,40,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-12','18:53:00','67260','X',0,'2013-12-25 22:08:38',NULL,NULL),(951,59,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-11','18:36:00','64784','X',0,'2013-12-26 00:52:51',NULL,NULL),(1060,67,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-25','18:35:00','98942','X',0,'2013-12-26 01:52:32',NULL,NULL),(1447,93,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-24','01:56:00','90985','X',0,'2013-12-26 13:16:52',NULL,NULL),(1987,1234,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:13',NULL,NULL),(2231,1468,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-06','18:24:00','121977','X',0,'2014-01-07 04:04:40',NULL,NULL),(2844,2619,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',1,'2014-01-23 04:06:35',NULL,NULL),(3227,2776,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-02','18:10:00','168376','X',0,'2014-02-02 19:00:29',NULL,NULL),(1418,93,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-24','01:56:00','90954','X',0,'2013-12-26 13:11:50',NULL,NULL),(2437,1496,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:28',NULL,NULL),(94,6,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-04','18:22:00','52142','X',0,'2013-12-25 17:50:54',NULL,NULL),(216,15,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-04','18:02:00','18533','X',0,'2013-12-25 18:31:07',NULL,NULL),(433,29,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-06','18:21:00','55543','X',0,'2013-12-25 20:19:50',NULL,NULL),(624,40,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-12','18:53:00','67244','X',0,'2013-12-25 22:05:43',NULL,NULL),(713,46,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-07','18:13:00','57431','X',0,'2013-12-25 22:45:53',NULL,NULL),(1662,387,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-31','18:52:00','111701','X',1,'2014-01-02 04:35:49',NULL,NULL),(2228,1468,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-06','18:24:00','121974','X',0,'2014-01-07 04:04:20',NULL,NULL),(4224,2843,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-04','18:50:00','238771','X',0,'2014-03-04 21:02:42',NULL,NULL),(4368,2850,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-07','18:46:00','247683','X',0,'2014-03-07 21:32:23',NULL,NULL),(1140,72,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-17','18:03:00','29569','X',0,'2013-12-26 02:45:39',NULL,NULL),(1441,93,'005010X220A1','BE','OH0','92036','92036OH0020008','2013-12-24','01:56:00','90979','X',0,'2013-12-26 13:16:33',NULL,NULL),(2140,1387,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:00',NULL,NULL),(2290,1471,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-07','18:29:00','123288','X',0,'2014-01-08 18:25:06',NULL,NULL),(2504,1563,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:54',NULL,NULL),(3104,2760,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-28','18:32:00','160255','X',0,'2014-01-28 21:01:15',NULL,NULL),(3390,2786,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-08','18:12:00','180302','X',0,'2014-02-08 19:00:58',NULL,NULL),(3486,2793,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-11','18:41:00','189040','X',0,'2014-02-11 21:00:50',NULL,NULL),(4057,2827,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-26','18:39:00','222056','X',0,'2014-02-28 07:00:32',NULL,NULL),(1314,82,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-21','18:37:00','86525','X',0,'2013-12-26 04:39:02',NULL,NULL),(1641,387,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-31','18:52:00','111680','X',1,'2014-01-02 04:32:53',NULL,NULL),(2634,2540,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-16','18:41:00','141410','X',0,'2014-01-17 03:36:18',NULL,NULL),(3065,2759,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-27','18:27:00','158005','X',0,'2014-01-27 21:01:02',NULL,NULL),(48,3,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-13','18:04:00','25386','X',0,'2013-12-25 17:31:10',NULL,NULL),(227,16,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-10-25','18:01:00','13420','X',0,'2013-12-25 18:32:01',NULL,NULL),(577,39,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-12-17','18:43:00','78026','X',0,'2013-12-25 21:45:02',NULL,NULL),(1986,1233,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:10',NULL,NULL),(2082,1329,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:38',NULL,NULL),(2157,1404,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:47',NULL,NULL),(2413,1478,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-12','18:13:00','132597','X',0,'2014-01-13 03:01:52',NULL,NULL),(2792,2567,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 03:41:22',NULL,NULL),(2907,2682,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:21:00','1','X',1,'2014-01-23 05:06:32',NULL,NULL),(3292,2781,'005010X220A1','BE','OH0','92036','92036OH0010012','2014-02-05','18:39:00','174402','X',0,'2014-02-05 21:30:07',NULL,NULL),(3313,2781,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-05','18:39:00','174423','X',0,'2014-02-05 21:31:16',NULL,NULL),(249,19,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-24','18:40:00','96810','X',0,'2013-12-25 18:54:40',NULL,NULL),(361,23,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-02','18:14:00','47677','X',0,'2013-12-25 19:46:25',NULL,NULL),(1274,80,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-18','18:49:00','79104','X',0,'2013-12-26 04:10:35',NULL,NULL),(1329,83,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-15','18:34:00','27225','X',0,'2013-12-26 04:45:01',NULL,NULL),(1426,93,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-24','01:56:00','90962','X',0,'2013-12-26 13:14:21',NULL,NULL),(4316,2848,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-06','18:46:00','243737','X',0,'2014-03-06 21:30:15',NULL,NULL),(4385,2852,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-08','18:43:00','250657','X',0,'2014-03-08 21:30:50',NULL,NULL),(545,38,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-13','18:39:00','69271','X',0,'2013-12-25 21:35:15',NULL,NULL),(571,38,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-13','18:39:00','69297','X',0,'2013-12-25 21:39:00',NULL,NULL),(1102,70,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-28','18:08:00','14567','X',0,'2013-12-26 02:16:46',NULL,NULL),(1404,92,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-24','01:56:00','90941','X',0,'2013-12-26 13:02:37',NULL,NULL),(1625,386,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-01','18:18:00','112810','X',1,'2014-01-02 04:25:02',NULL,NULL),(3394,2786,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-08','18:12:00','180306','X',0,'2014-02-08 19:01:01',NULL,NULL),(3722,2805,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-17','18:05:00','202553','X',0,'2014-02-17 19:00:02',NULL,NULL),(4281,2847,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-06','18:51:00','245581','X',0,'2014-03-06 21:01:54',NULL,NULL),(1734,571,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-04','18:14:00','119136','X',0,'2014-01-05 00:00:27',NULL,NULL),(3163,2773,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-30','18:35:00','164084','X',0,'2014-01-30 21:01:34',NULL,NULL),(3854,2814,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-20','18:28:00','208921','X',0,'2014-02-20 22:01:33',NULL,NULL),(4375,2850,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-03-07','18:46:00','247690','X',0,'2014-03-07 21:32:29',NULL,NULL),(288,20,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-20','18:06:00','32812','X',0,'2013-12-25 19:02:37',NULL,NULL),(903,54,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-02','18:00:00','5093','X',0,'2013-12-26 00:17:15',NULL,NULL),(1088,69,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-23','18:05:00','36678','X',0,'2013-12-26 02:15:07',NULL,NULL),(1532,381,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-28','18:14:00','103724','X',1,'2013-12-29 11:10:17',NULL,NULL),(1698,568,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-02','18:42:00','115222','X',0,'2014-01-03 02:07:16',NULL,NULL),(1978,1225,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:14',NULL,NULL),(2210,1457,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:15',NULL,NULL),(2540,1576,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-13','18:44:00','134016','X',0,'2014-01-14 01:33:49',NULL,NULL),(3123,2772,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-29','18:30:00','161345','X',0,'2014-01-29 21:01:26',NULL,NULL),(4092,2830,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-28','19:12:00','229910','X',0,'2014-02-28 21:31:12',NULL,NULL),(4196,2836,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-03','18:33:00','236092','X',0,'2014-03-03 21:31:57',NULL,NULL),(14,1,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-05','18:31:00','54189','X',0,'2013-12-25 17:20:09',NULL,NULL),(750,47,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-19','19:11:00','81736','X',0,'2013-12-25 23:09:35',NULL,NULL),(841,51,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-24','03:40:00','94580','X',0,'2013-12-25 23:51:21',NULL,NULL),(1284,81,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-11-30','18:04:00','44824','X',0,'2013-12-26 04:15:49',NULL,NULL),(2334,1474,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-01-09','18:28:00','127874','X',0,'2014-01-13 02:20:59',NULL,NULL),(2380,1477,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-10','18:26:00','129735','X',0,'2014-01-13 03:00:22',NULL,NULL),(3153,2773,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-30','18:35:00','164074','X',0,'2014-01-30 21:01:21',NULL,NULL),(3897,2818,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-25','18:33:00','219093','X',0,'2014-02-25 21:00:24',NULL,NULL),(128,7,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-16','18:37:00','74941','X',0,'2013-12-25 18:07:54',NULL,NULL),(1046,67,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-25','18:35:00','98928','X',0,'2013-12-26 01:50:31',NULL,NULL),(1501,380,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-27','18:44:00','101825','X',0,'2013-12-28 03:36:41',NULL,NULL),(1707,569,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-03','18:38:00','116006','X',0,'2014-01-04 02:04:20',NULL,NULL),(2015,1262,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:31',NULL,NULL),(2425,1484,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:17',NULL,NULL),(2485,1544,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:37',NULL,NULL),(2900,2675,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:01:00','1','X',0,'2014-01-23 05:00:02',NULL,NULL),(3382,2786,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-08','18:12:00','180294','X',0,'2014-02-08 19:00:35',NULL,NULL),(3631,2799,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-14','18:39:00','196124','X',0,'2014-02-14 21:31:33',NULL,NULL),(4252,2846,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-05','18:49:00','241586','X',0,'2014-03-05 21:31:34',NULL,NULL),(4293,2847,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-06','18:51:00','245593','X',0,'2014-03-06 21:02:37',NULL,NULL),(127,7,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-16','18:37:00','74940','X',0,'2013-12-25 18:07:52',NULL,NULL),(1164,75,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-20','19:06:00','84201','X',0,'2013-12-26 03:00:02',NULL,NULL),(1186,75,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-20','19:06:00','84223','X',0,'2013-12-26 03:10:04',NULL,NULL),(1348,84,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-21','18:04:00','11690','X',0,'2013-12-26 05:01:11',NULL,NULL),(1464,99,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-26','18:41:00','100554','X',0,'2013-12-27 02:06:25',NULL,NULL),(2639,2540,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-16','18:41:00','141415','X',0,'2014-01-17 03:36:34',NULL,NULL),(3246,2777,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-03','18:32:00','170208','X',0,'2014-02-03 21:01:21',NULL,NULL),(3651,2799,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-14','18:39:00','196144','X',0,'2014-02-14 21:32:20',NULL,NULL),(3656,2799,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-02-14','18:39:00','196149','X',0,'2014-02-14 21:32:27',NULL,NULL),(4382,2852,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-08','18:43:00','250654','X',0,'2014-03-08 21:30:34',NULL,NULL),(716,46,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-07','18:13:00','57434','X',0,'2013-12-25 22:46:50',NULL,NULL),(860,52,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-01','18:08:00','46307','X',0,'2013-12-26 00:00:50',NULL,NULL),(2757,2555,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-21','18:24:00','147892','X',1,'2014-01-22 03:23:07',NULL,NULL),(2831,2606,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:37:00','1','X',1,'2014-01-23 03:54:11',NULL,NULL),(2926,2701,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:35:00','1','X',0,'2014-01-23 06:41:04',NULL,NULL),(3576,2797,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-13','18:41:00','192638','X',0,'2014-02-13 21:30:14',NULL,NULL),(108,7,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-16','18:37:00','74921','X',0,'2013-12-25 18:03:47',NULL,NULL),(326,22,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-09','18:28:00','61496','X',0,'2013-12-25 19:32:23',NULL,NULL),(364,23,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-02','18:14:00','47680','X',0,'2013-12-25 19:47:52',NULL,NULL),(718,46,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-07','18:13:00','57436','X',0,'2013-12-25 22:47:24',NULL,NULL),(1056,67,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-25','18:35:00','98938','X',0,'2013-12-26 01:52:18',NULL,NULL),(2457,1516,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:08',NULL,NULL),(2605,2539,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-15','18:30:00','138467','X',0,'2014-01-16 08:47:10',NULL,NULL),(2666,2551,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-17','18:23:00','142632','X',0,'2014-01-20 08:06:33',NULL,NULL),(3793,2811,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-19','18:35:00','207798','X',0,'2014-02-20 04:30:18',NULL,NULL),(3996,2825,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-26','18:43:00','223751','X',0,'2014-02-26 21:00:34',NULL,NULL),(386,24,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-15','18:01:00','9469','X',0,'2013-12-25 20:00:02',NULL,NULL),(798,49,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-11-06','18:03:00','20433','X',0,'2013-12-25 23:17:17',NULL,NULL),(872,52,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-01','18:08:00','46319','X',0,'2013-12-26 00:02:26',NULL,NULL),(1568,383,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-29','18:10:00','107250','X',0,'2013-12-30 00:01:51',NULL,NULL),(1667,387,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-31','18:52:00','111706','X',1,'2014-01-02 04:36:07',NULL,NULL),(2171,1418,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:27',NULL,NULL),(2339,1475,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-08','18:27:00','125975','X',0,'2014-01-13 02:21:36',NULL,NULL),(2487,1546,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:39',NULL,NULL),(2616,2539,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-15','18:30:00','138478','X',0,'2014-01-16 08:47:25',NULL,NULL),(3096,2760,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-28','18:32:00','160247','X',0,'2014-01-28 21:01:02',NULL,NULL),(3150,2773,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-30','18:35:00','164071','X',0,'2014-01-30 21:01:12',NULL,NULL),(3255,2777,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-03','18:32:00','170217','X',0,'2014-02-03 21:01:35',NULL,NULL),(3404,2788,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-09','18:12:00','181784','X',0,'2014-02-09 19:00:08',NULL,NULL),(3546,2796,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-12','18:31:00','191454','X',0,'2014-02-12 21:31:52',NULL,NULL),(3853,2814,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-20','18:28:00','208920','X',0,'2014-02-20 22:01:32',NULL,NULL),(187,13,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-03','18:20:00','49893','X',0,'2013-12-25 18:20:14',NULL,NULL),(215,14,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-11-29','18:04:00','43708','X',0,'2013-12-25 18:31:05',NULL,NULL),(495,35,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-28','18:02:00','42798','X',0,'2013-12-25 20:46:59',NULL,NULL),(793,49,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-06','18:03:00','20424','X',0,'2013-12-25 23:17:04',NULL,NULL),(1033,65,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-05','18:01:00','5896','X',0,'2013-12-26 01:31:29',NULL,NULL),(3176,2774,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-31','18:37:00','165918','X',0,'2014-01-31 21:00:59',NULL,NULL),(4064,2828,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-27','18:43:00','224648','X',0,'2014-02-28 07:30:04',NULL,NULL),(1172,75,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-20','19:06:00','84209','X',0,'2013-12-26 03:05:51',NULL,NULL),(2405,1478,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-12','18:13:00','132589','X',0,'2014-01-13 03:01:42',NULL,NULL),(2462,1521,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:12',NULL,NULL),(2720,2554,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-20','18:21:00','146899','X',0,'2014-01-21 08:46:42',NULL,NULL),(2745,2555,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-21','18:24:00','147880','X',1,'2014-01-22 03:22:55',NULL,NULL),(2748,2555,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-21','18:24:00','147883','X',1,'2014-01-22 03:22:57',NULL,NULL),(2756,2555,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-21','18:24:00','147891','X',1,'2014-01-22 03:23:06',NULL,NULL),(2794,2569,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:41:32',NULL,NULL),(3040,2757,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-25','18:11:00','155341','X',0,'2014-01-25 19:00:13',NULL,NULL),(3623,2799,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-14','18:39:00','196116','X',0,'2014-02-14 21:30:51',NULL,NULL),(3760,2808,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-18','18:28:00','204274','X',0,'2014-02-18 22:01:26',NULL,NULL),(4060,2827,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-26','18:39:00','222059','X',0,'2014-02-28 07:00:36',NULL,NULL),(4320,2848,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-06','18:46:00','243741','X',0,'2014-03-06 21:30:24',NULL,NULL),(78,6,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-04','18:22:00','52126','X',0,'2013-12-25 17:49:18',NULL,NULL),(2178,1425,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:46',NULL,NULL),(2716,2554,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-20','18:21:00','146895','X',0,'2014-01-21 08:46:30',NULL,NULL),(2806,2581,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 03:44:38',NULL,NULL),(2902,2677,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 05:02:10',NULL,NULL),(2905,2680,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:00:00','1','X',1,'2014-01-23 05:03:21',NULL,NULL),(3463,2792,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-10','18:30:00','186449','X',0,'2014-02-10 21:31:31',NULL,NULL),(3487,2793,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-11','18:41:00','189041','X',0,'2014-02-11 21:01:00',NULL,NULL),(1118,71,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-15','18:15:00','73609','X',0,'2013-12-26 02:33:04',NULL,NULL),(2115,1362,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:50',NULL,NULL),(2235,1468,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-06','18:24:00','121981','X',0,'2014-01-07 04:05:07',NULL,NULL),(385,23,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-02','18:14:00','47701','X',0,'2013-12-25 19:50:29',NULL,NULL),(707,45,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-26','18:04:00','14003','X',0,'2013-12-25 22:32:03',NULL,NULL),(1057,67,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-25','18:35:00','98939','X',0,'2013-12-26 01:52:24',NULL,NULL),(1134,71,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-15','18:15:00','73625','X',0,'2013-12-26 02:34:01',NULL,NULL),(2533,1576,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-13','18:44:00','134009','X',0,'2014-01-14 01:33:43',NULL,NULL),(3134,2772,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-29','18:30:00','161356','X',0,'2014-01-29 21:01:47',NULL,NULL),(3748,2808,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-18','18:28:00','204262','X',0,'2014-02-18 22:00:28',NULL,NULL),(3812,2810,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-19','18:35:00','207805','X',0,'2014-02-20 04:55:06',NULL,NULL),(121,7,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-16','18:37:00','74934','X',0,'2013-12-25 18:07:27',NULL,NULL),(132,7,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-16','18:37:00','74945','X',0,'2013-12-25 18:08:09',NULL,NULL),(565,38,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-13','18:39:00','69291','X',0,'2013-12-25 21:38:30',NULL,NULL),(1332,83,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-15','18:34:00','27228','X',0,'2013-12-26 04:45:30',NULL,NULL),(1992,1239,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:27',NULL,NULL),(3284,2778,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-04','18:29:00','172126','X',0,'2014-02-04 21:01:58',NULL,NULL),(3290,2780,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-05','18:36:00','173083','X',0,'2014-02-05 21:00:07',NULL,NULL),(3423,2790,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-10','05:02:00','183696','X',0,'2014-02-10 11:00:30',NULL,NULL),(3570,2797,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-13','18:41:00','192632','X',0,'2014-02-13 21:30:07',NULL,NULL),(3703,2804,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-16','18:12:00','201496','X',0,'2014-02-16 19:00:05',NULL,NULL),(4387,2852,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-08','18:43:00','250659','X',0,'2014-03-08 21:30:54',NULL,NULL),(17,1,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-05','18:31:00','54192','X',0,'2013-12-25 17:20:59',NULL,NULL),(1870,1117,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:14',NULL,NULL),(2409,1478,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-12','18:13:00','132593','X',0,'2014-01-13 03:01:48',NULL,NULL),(2465,1524,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:17',NULL,NULL),(2769,2556,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-22','18:31:00','150810','X',0,'2014-01-23 03:02:25',NULL,NULL),(3613,2798,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-13','18:46:00','194336','X',0,'2014-02-13 22:03:15',NULL,NULL),(3783,2809,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-19','18:35:00','207794','X',0,'2014-02-20 04:22:35',NULL,NULL),(4003,2825,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-26','18:43:00','223758','X',0,'2014-02-26 21:02:08',NULL,NULL),(4101,2830,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-28','19:12:00','229919','X',0,'2014-02-28 21:31:47',NULL,NULL),(4189,2836,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-03-03','18:33:00','236085','X',0,'2014-03-03 21:31:47',NULL,NULL),(1488,380,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-27','18:44:00','101812','X',0,'2013-12-28 03:30:01',NULL,NULL),(3654,2799,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-14','18:39:00','196147','X',0,'2014-02-14 21:32:24',NULL,NULL),(814,50,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-26','18:20:00','40539','X',0,'2013-12-25 23:32:40',NULL,NULL),(1246,80,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-18','18:49:00','79076','X',0,'2013-12-26 04:08:11',NULL,NULL),(1515,380,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-27','18:44:00','101839','X',0,'2013-12-28 03:37:21',NULL,NULL),(2606,2539,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-01-15','18:30:00','138468','X',0,'2014-01-16 08:47:11',NULL,NULL),(2890,2665,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',1,'2014-01-23 04:45:46',NULL,NULL),(2998,2755,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-23','18:27:00','151594','X',0,'2014-01-23 21:01:32',NULL,NULL),(3193,2774,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-31','18:37:00','165935','X',0,'2014-01-31 21:01:42',NULL,NULL),(3879,2816,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-21','18:31:00','212807','X',0,'2014-02-21 22:01:06',NULL,NULL),(283,20,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-20','18:06:00','32807','X',0,'2013-12-25 19:02:14',NULL,NULL),(839,51,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-24','03:40:00','94578','X',0,'2013-12-25 23:51:11',NULL,NULL),(1010,63,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-25','18:07:00','38448','X',0,'2013-12-26 01:16:37',NULL,NULL),(1067,68,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-14','18:21:00','71336','X',0,'2013-12-26 02:00:02',NULL,NULL),(1283,81,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-30','18:04:00','44823','X',0,'2013-12-26 04:15:32',NULL,NULL),(2362,1475,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-08','18:27:00','125998','X',0,'2014-01-13 02:22:48',NULL,NULL),(2743,2555,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-21','18:24:00','147878','X',1,'2014-01-22 03:22:44',NULL,NULL),(3477,2792,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-02-10','18:30:00','186463','X',0,'2014-02-10 21:32:11',NULL,NULL),(4363,2850,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-07','18:46:00','247678','X',0,'2014-03-07 21:32:12',NULL,NULL),(4424,2853,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-09','18:20:00','252269','X',0,'2014-03-09 21:01:18',NULL,NULL),(543,38,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-13','18:39:00','69269','X',0,'2013-12-25 21:33:14',NULL,NULL),(894,53,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-11-21','18:06:00','34272','X',0,'2013-12-26 00:16:49',NULL,NULL),(945,59,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-11','18:36:00','64778','X',0,'2013-12-26 00:51:12',NULL,NULL),(1583,385,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-30','19:01:00','109530','X',0,'2014-01-01 12:02:16',NULL,NULL),(1739,571,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-04','18:14:00','119141','X',0,'2014-01-05 00:01:58',NULL,NULL),(2641,2540,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-16','18:41:00','141417','X',0,'2014-01-17 03:36:35',NULL,NULL),(3267,2778,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-04','18:29:00','172109','X',0,'2014-02-04 21:01:17',NULL,NULL),(4111,2830,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-28','19:12:00','229929','X',0,'2014-02-28 21:31:57',NULL,NULL),(256,19,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-24','18:40:00','96817','X',0,'2013-12-25 18:57:11',NULL,NULL),(2392,1477,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-10','18:26:00','129747','X',0,'2014-01-13 03:00:37',NULL,NULL),(2617,2539,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-01-15','18:30:00','138479','X',0,'2014-01-16 08:47:27',NULL,NULL),(3282,2778,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-04','18:29:00','172124','X',0,'2014-02-04 21:01:56',NULL,NULL),(4011,2825,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-26','18:43:00','223766','X',0,'2014-02-26 21:02:37',NULL,NULL),(594,39,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-17','18:43:00','78043','X',0,'2013-12-25 21:52:20',NULL,NULL),(4190,2836,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-03','18:33:00','236086','X',0,'2014-03-03 21:31:47',NULL,NULL),(66,5,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-11-09','18:02:00','22406','X',0,'2013-12-25 17:32:21',NULL,NULL),(332,22,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-09','18:28:00','61502','X',0,'2013-12-25 19:36:09',NULL,NULL),(525,37,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-22','18:40:00','88486','X',0,'2013-12-25 21:23:08',NULL,NULL),(662,41,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-08','18:10:00','59419','X',0,'2013-12-25 22:16:36',NULL,NULL),(1205,76,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-11-22','18:08:00','35659','X',0,'2013-12-26 03:15:42',NULL,NULL),(2421,1480,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','12:25:00','1','X',0,'2014-01-13 03:02:14',NULL,NULL),(3596,2798,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-13','18:46:00','194319','X',0,'2014-02-13 22:02:41',NULL,NULL),(3766,2808,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-18','18:28:00','204281','X',0,'2014-02-18 22:01:41',NULL,NULL),(4380,2852,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-08','18:43:00','250652','X',0,'2014-03-08 21:29:59',NULL,NULL),(143,7,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-16','18:37:00','74956','X',0,'2013-12-25 18:08:48',NULL,NULL),(237,18,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-09','18:01:00','7050','X',0,'2013-12-25 18:32:25',NULL,NULL),(871,52,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-01','18:08:00','46318','X',0,'2013-12-26 00:02:23',NULL,NULL),(2686,2552,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-18','18:11:00','144584','X',0,'2014-01-21 08:44:36',NULL,NULL),(3036,2757,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-25','18:11:00','155337','X',0,'2014-01-25 19:00:08',NULL,NULL),(3527,2794,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-11','18:37:00','187471','X',0,'2014-02-11 21:30:25',NULL,NULL),(3581,2798,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-13','18:46:00','194304','X',0,'2014-02-13 22:00:36',NULL,NULL),(3914,2819,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-25','18:36:00','220686','X',0,'2014-02-25 21:31:42',NULL,NULL),(4130,2832,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-01','18:23:00','232017','X',0,'2014-03-01 21:00:52',NULL,NULL),(137,7,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-16','18:37:00','74950','X',0,'2013-12-25 18:08:29',NULL,NULL),(824,51,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-24','03:40:00','94563','X',0,'2013-12-25 23:45:02',NULL,NULL),(981,61,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-11-16','18:03:00','28393','X',0,'2013-12-26 01:01:09',NULL,NULL),(1076,68,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-14','18:21:00','71345','X',0,'2013-12-26 02:03:21',NULL,NULL),(2798,2573,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:42:09',NULL,NULL),(2869,2644,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:01:00','1','X',1,'2014-01-23 04:20:36',NULL,NULL),(186,13,'005010X220A1','BE','OH0','92036','92036OH0010027','2013-12-03','18:20:00','49892','X',0,'2013-12-25 18:20:12',NULL,NULL),(199,13,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-03','18:20:00','49905','X',0,'2013-12-25 18:21:25',NULL,NULL),(636,40,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-12','18:53:00','67256','X',0,'2013-12-25 22:08:10',NULL,NULL),(1087,69,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-23','18:05:00','36677','X',0,'2013-12-26 02:15:04',NULL,NULL),(1461,99,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-26','18:41:00','100551','X',0,'2013-12-27 02:05:51',NULL,NULL),(2069,1316,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:01',NULL,NULL),(2539,1576,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-13','18:44:00','134015','X',0,'2014-01-14 01:33:48',NULL,NULL),(2897,2672,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 04:52:47',NULL,NULL),(3413,2789,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-09','18:11:00','181287','X',0,'2014-02-09 19:00:36',NULL,NULL),(3787,2809,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-19','18:35:00','207796','X',0,'2014-02-20 04:26:07',NULL,NULL),(3961,2823,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-22','18:14:00','213803','X',0,'2014-02-26 08:30:42',NULL,NULL),(3989,2824,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-24','18:21:00','218501','X',0,'2014-02-26 09:31:03',NULL,NULL),(4279,2847,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-06','18:51:00','245579','X',0,'2014-03-06 21:01:30',NULL,NULL),(4347,2850,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-07','18:46:00','247662','X',0,'2014-03-07 21:31:46',NULL,NULL),(391,25,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-24','18:02:00','37689','X',0,'2013-12-25 20:00:16',NULL,NULL),(429,29,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-06','18:21:00','55539','X',0,'2013-12-25 20:19:39',NULL,NULL),(1509,380,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-27','18:44:00','101833','X',0,'2013-12-28 03:37:05',NULL,NULL),(2825,2600,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:54:00','1','X',1,'2014-01-23 03:50:49',NULL,NULL),(3052,2758,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-26','18:09:00','156592','X',0,'2014-01-26 19:00:24',NULL,NULL),(3464,2792,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-10','18:30:00','186450','X',0,'2014-02-10 21:31:37',NULL,NULL),(4131,2832,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-01','18:23:00','232018','X',0,'2014-03-01 21:00:53',NULL,NULL),(629,40,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-12','18:53:00','67249','X',0,'2013-12-25 22:06:40',NULL,NULL),(742,47,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-19','19:11:00','81728','X',0,'2013-12-25 23:08:07',NULL,NULL),(1049,67,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-25','18:35:00','98931','X',0,'2013-12-26 01:51:11',NULL,NULL),(1403,92,'005010X220A1','BE','FL0','99734','99734OH0050003','2013-12-24','01:56:00','90971','X',0,'2013-12-26 12:59:17',NULL,NULL),(1718,569,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-03','18:38:00','116017','X',0,'2014-01-04 02:05:52',NULL,NULL),(2700,2553,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-19','18:08:00','145207','X',0,'2014-01-21 08:45:25',NULL,NULL),(3478,2792,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-10','18:30:00','186464','X',0,'2014-02-10 21:32:12',NULL,NULL),(4480,2856,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-10','19:17:00','254167','X',0,'2014-03-10 21:30:14',NULL,NULL),(447,30,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-13','18:01:00','8421','X',0,'2013-12-25 20:30:07',NULL,NULL),(807,50,'005010X220A1','BE','OH0','92036','92036OH0060008','2013-11-26','18:20:00','40532','X',0,'2013-12-25 23:32:06',NULL,NULL),(866,52,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-01','18:08:00','46313','X',0,'2013-12-26 00:02:11',NULL,NULL),(1302,82,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-21','18:37:00','86503','X',0,'2013-12-26 04:36:58',NULL,NULL),(2220,1467,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:43',NULL,NULL),(3101,2760,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-28','18:32:00','160252','X',0,'2014-01-28 21:01:13',NULL,NULL),(3542,2796,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-12','18:31:00','191450','X',0,'2014-02-12 21:31:03',NULL,NULL),(4358,2850,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-07','18:46:00','247673','X',0,'2014-03-07 21:32:05',NULL,NULL),(37,2,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-12','18:01:00','7921','X',0,'2013-12-25 17:30:17',NULL,NULL),(589,39,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-17','18:43:00','78038','X',0,'2013-12-25 21:51:36',NULL,NULL),(621,40,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-12','18:53:00','67241','X',0,'2013-12-25 22:04:48',NULL,NULL),(1422,93,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-24','01:56:00','90958','X',0,'2013-12-26 13:13:22',NULL,NULL),(2348,1475,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-08','18:27:00','125984','X',0,'2014-01-13 02:22:22',NULL,NULL),(2979,2754,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:07:00','1','X',0,'2014-01-23 18:30:02',NULL,NULL),(80,6,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-04','18:22:00','52128','X',0,'2013-12-25 17:49:33',NULL,NULL),(1540,382,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-28','21:04:00','105796','X',1,'2013-12-29 11:13:48',NULL,NULL),(2571,2311,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-14','19:00:00','136128','X',0,'2014-01-15 02:08:02',NULL,NULL),(3526,2794,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-11','18:37:00','187470','X',0,'2014-02-11 21:30:24',NULL,NULL),(3695,2802,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-02-15','18:48:00','199887','X',0,'2014-02-15 22:02:05',NULL,NULL),(4314,2848,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-06','18:46:00','243735','X',0,'2014-03-06 21:30:12',NULL,NULL),(656,41,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-08','18:10:00','59413','X',0,'2013-12-25 22:15:31',NULL,NULL),(658,41,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-08','18:10:00','59415','X',0,'2013-12-25 22:16:00',NULL,NULL),(767,47,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-19','19:11:00','81753','X',0,'2013-12-25 23:11:19',NULL,NULL),(2073,1320,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:12',NULL,NULL),(2439,1498,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:30',NULL,NULL),(2647,2540,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-16','18:41:00','141423','X',0,'2014-01-17 03:36:38',NULL,NULL),(2816,2591,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 03:47:36',NULL,NULL),(3658,2800,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-14','18:36:00','195036','X',0,'2014-02-14 22:00:02',NULL,NULL),(4227,2843,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-03-04','18:50:00','238774','X',0,'2014-03-04 21:02:45',NULL,NULL),(4306,2847,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-06','18:51:00','245607','X',0,'2014-03-06 21:02:55',NULL,NULL),(83,6,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-04','18:22:00','52131','X',0,'2013-12-25 17:50:06',NULL,NULL),(112,7,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-16','18:37:00','74925','X',0,'2013-12-25 18:06:34',NULL,NULL),(1027,64,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-14','18:05:00','25963','X',0,'2013-12-26 01:31:03',NULL,NULL),(1043,67,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-25','18:35:00','98925','X',0,'2013-12-26 01:48:01',NULL,NULL),(1084,68,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-14','18:21:00','71353','X',0,'2013-12-26 02:04:05',NULL,NULL),(1496,380,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-27','18:44:00','101820','X',0,'2013-12-28 03:35:29',NULL,NULL),(2509,1568,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:59',NULL,NULL),(3369,2784,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-07','18:14:00','177578','X',0,'2014-02-07 19:01:07',NULL,NULL),(3951,2821,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-24','18:19:00','217101','X',0,'2014-02-26 08:00:46',NULL,NULL),(4364,2850,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-03-07','18:46:00','247679','X',0,'2014-03-07 21:32:15',NULL,NULL),(131,7,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-16','18:37:00','74944','X',0,'2013-12-25 18:08:06',NULL,NULL),(936,59,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-11','18:36:00','64769','X',0,'2013-12-26 00:47:22',NULL,NULL),(1599,385,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-30','19:01:00','109546','X',0,'2014-01-01 12:08:36',NULL,NULL),(2345,1475,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-08','18:27:00','125981','X',0,'2014-01-13 02:22:18',NULL,NULL),(2619,2539,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-15','18:30:00','138481','X',0,'2014-01-16 08:47:29',NULL,NULL),(2643,2540,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-16','18:41:00','141419','X',0,'2014-01-17 03:36:36',NULL,NULL),(2883,2658,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:36:00','1','X',1,'2014-01-23 04:33:10',NULL,NULL),(3158,2773,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-30','18:35:00','164079','X',0,'2014-01-30 21:01:29',NULL,NULL),(3264,2778,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-04','18:29:00','172106','X',0,'2014-02-04 21:01:11',NULL,NULL),(3909,2819,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-25','18:36:00','220681','X',0,'2014-02-25 21:30:47',NULL,NULL),(4017,2825,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-26','18:43:00','223772','X',0,'2014-02-26 21:02:43',NULL,NULL),(291,21,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-10','18:21:00','62740','X',0,'2013-12-25 19:15:52',NULL,NULL),(1148,72,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-11-17','18:03:00','29577','X',0,'2013-12-26 02:46:09',NULL,NULL),(1435,93,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-24','01:56:00','90972','X',0,'2013-12-26 13:15:52',NULL,NULL),(1581,385,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-30','19:01:00','109528','X',0,'2014-01-01 12:01:52',NULL,NULL),(2226,1468,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-06','18:24:00','121972','X',0,'2014-01-07 04:03:09',NULL,NULL),(2287,1471,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-07','18:29:00','123285','X',0,'2014-01-08 18:25:03',NULL,NULL),(2749,2555,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-21','18:24:00','147884','X',1,'2014-01-22 03:22:59',NULL,NULL),(3378,2786,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-08','18:12:00','180290','X',0,'2014-02-08 19:00:20',NULL,NULL),(3848,2814,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-02-20','18:28:00','208915','X',0,'2014-02-20 22:01:10',NULL,NULL),(3874,2816,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-21','18:31:00','212802','X',0,'2014-02-21 22:00:42',NULL,NULL),(4000,2825,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-26','18:43:00','223755','X',0,'2014-02-26 21:01:54',NULL,NULL),(64,5,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-09','18:02:00','22420','X',0,'2013-12-25 17:32:17',NULL,NULL),(498,35,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-28','18:02:00','42796','X',0,'2013-12-25 20:47:09',NULL,NULL),(676,41,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-08','18:10:00','59433','X',0,'2013-12-25 22:17:21',NULL,NULL),(1009,63,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-25','18:07:00','38447','X',0,'2013-12-26 01:16:22',NULL,NULL),(1538,382,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-28','21:04:00','105794','X',1,'2013-12-29 11:13:05',NULL,NULL),(2492,1551,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:43',NULL,NULL),(3777,2809,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-19','18:35:00','207791','X',0,'2014-02-20 04:04:42',NULL,NULL),(4219,2843,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-04','18:50:00','238766','X',0,'2014-03-04 21:02:36',NULL,NULL),(158,8,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-10-31','18:04:00','15483','X',0,'2013-12-25 18:10:30',NULL,NULL),(1146,72,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-17','18:03:00','29575','X',0,'2013-12-26 02:46:03',NULL,NULL),(1633,386,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-01','18:18:00','112818','X',1,'2014-01-02 04:25:50',NULL,NULL),(1875,1122,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:27',NULL,NULL),(2186,1433,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:08',NULL,NULL),(2972,2747,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:20:00','1','X',0,'2014-01-23 15:00:02',NULL,NULL),(3441,2790,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-10','05:02:00','183714','X',0,'2014-02-10 11:01:14',NULL,NULL),(3947,2821,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-24','18:19:00','217102','X',0,'2014-02-26 08:00:37',NULL,NULL),(4109,2830,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-28','19:12:00','229927','X',0,'2014-02-28 21:31:55',NULL,NULL),(356,22,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-09','18:28:00','61526','X',0,'2013-12-25 19:38:02',NULL,NULL),(509,37,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-22','18:40:00','88468','X',0,'2013-12-25 21:21:10',NULL,NULL),(605,39,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-17','18:43:00','78054','X',0,'2013-12-25 21:53:09',NULL,NULL),(765,47,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-19','19:11:00','81751','X',0,'2013-12-25 23:11:10',NULL,NULL),(1914,1161,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:52:15',NULL,NULL),(2291,1471,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-07','18:29:00','123289','X',0,'2014-01-08 18:25:07',NULL,NULL),(4013,2825,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-02-26','18:43:00','223768','X',0,'2014-02-26 21:02:39',NULL,NULL),(4276,2847,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-06','18:51:00','245576','X',0,'2014-03-06 21:00:09',NULL,NULL),(20,1,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-05','18:31:00','54195','X',0,'2013-12-25 17:21:15',NULL,NULL),(168,10,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-10-19','18:01:00','10693','X',0,'2013-12-25 18:11:07',NULL,NULL),(635,40,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-12','18:53:00','67255','X',0,'2013-12-25 22:08:02',NULL,NULL),(1081,68,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-14','18:21:00','71350','X',0,'2013-12-26 02:03:51',NULL,NULL),(1270,80,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-18','18:49:00','79100','X',0,'2013-12-26 04:10:21',NULL,NULL),(1477,99,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-26','18:41:00','100567','X',0,'2013-12-27 02:07:37',NULL,NULL),(1746,571,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-04','18:14:00','119148','X',0,'2014-01-05 00:02:53',NULL,NULL),(3018,2756,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-24','18:26:00','154298','X',0,'2014-01-24 21:01:00',NULL,NULL),(3021,2756,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-24','18:26:00','154301','X',0,'2014-01-24 21:01:08',NULL,NULL),(3366,2784,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-07','18:14:00','177575','X',0,'2014-02-07 19:01:04',NULL,NULL),(18,1,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-05','18:31:00','54193','X',0,'2013-12-25 17:21:07',NULL,NULL),(436,29,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-06','18:21:00','55546','X',0,'2013-12-25 20:20:01',NULL,NULL),(560,38,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-13','18:39:00','69286','X',0,'2013-12-25 21:37:53',NULL,NULL),(563,38,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-13','18:39:00','69289','X',0,'2013-12-25 21:38:10',NULL,NULL),(758,47,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-19','19:11:00','81744','X',0,'2013-12-25 23:10:34',NULL,NULL),(1456,99,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-26','18:41:00','100546','X',0,'2013-12-27 02:03:26',NULL,NULL),(1569,383,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-29','18:10:00','107251','X',0,'2013-12-30 00:01:53',NULL,NULL),(1983,1230,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:30',NULL,NULL),(2265,1469,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-05','18:09:00','119799','X',1,'2014-01-07 10:23:11',NULL,NULL),(3515,2793,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-11','18:41:00','189069','X',0,'2014-02-11 21:02:52',NULL,NULL),(3747,2808,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-18','18:28:00','204261','X',0,'2014-02-18 22:00:27',NULL,NULL),(3794,2809,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-19','18:35:00','207799','X',0,'2014-02-20 04:32:31',NULL,NULL),(3873,2816,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-21','18:31:00','212801','X',0,'2014-02-21 22:00:39',NULL,NULL),(3910,2819,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-25','18:36:00','220682','X',0,'2014-02-25 21:30:58',NULL,NULL),(4139,2832,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-03-01','18:23:00','232026','X',0,'2014-03-01 21:01:10',NULL,NULL),(593,39,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-17','18:43:00','78042','X',0,'2013-12-25 21:52:17',NULL,NULL),(677,41,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-08','18:10:00','59434','X',0,'2013-12-25 22:17:24',NULL,NULL),(3157,2773,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-30','18:35:00','164078','X',0,'2014-01-30 21:01:28',NULL,NULL),(3820,2810,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-19','18:35:00','207809','X',0,'2014-02-20 04:56:36',NULL,NULL),(1256,80,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-18','18:49:00','79086','X',0,'2013-12-26 04:09:22',NULL,NULL),(1533,381,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-28','18:14:00','103725','X',1,'2013-12-29 11:10:19',NULL,NULL),(2229,1468,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-01-06','18:24:00','121975','X',0,'2014-01-07 04:04:25',NULL,NULL),(2980,2755,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-23','18:27:00','151576','X',0,'2014-01-23 21:00:03',NULL,NULL),(3102,2760,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-28','18:32:00','160253','X',0,'2014-01-28 21:01:14',NULL,NULL),(3721,2804,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-16','18:12:00','201515','X',0,'2014-02-16 19:00:43',NULL,NULL),(4462,2855,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-03-10','19:23:00','255937','X',0,'2014-03-10 21:02:49',NULL,NULL),(1103,70,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-28','18:08:00','14563','X',0,'2013-12-26 02:16:48',NULL,NULL),(1468,99,'005010X220A1','BE','OH0','92036','92036OH0010032','2013-12-26','18:41:00','100558','X',0,'2013-12-27 02:06:56',NULL,NULL),(3549,2796,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-12','18:31:00','191457','X',0,'2014-02-12 21:32:01',NULL,NULL),(4124,2832,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-01','18:23:00','232011','X',0,'2014-03-01 21:00:19',NULL,NULL),(4302,2847,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-03-06','18:51:00','245602','X',0,'2014-03-06 21:02:51',NULL,NULL),(4317,2848,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-06','18:46:00','243738','X',0,'2014-03-06 21:30:17',NULL,NULL),(4463,2855,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-10','19:23:00','255938','X',0,'2014-03-10 21:02:51',NULL,NULL),(1151,73,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-14','18:02:00','9155','X',0,'2013-12-26 02:46:16',NULL,NULL),(1740,571,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-04','18:14:00','119142','X',0,'2014-01-05 00:02:08',NULL,NULL),(2211,1458,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:18',NULL,NULL),(2240,1468,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-06','18:24:00','121986','X',0,'2014-01-07 04:05:40',NULL,NULL),(2257,1469,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-05','18:09:00','119791','X',1,'2014-01-07 10:22:18',NULL,NULL),(2493,1552,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:44',NULL,NULL),(3988,2824,'005010X220A1','BE','OH0','92036','92036OH0060008','2014-02-24','18:21:00','218500','X',0,'2014-02-26 09:31:02',NULL,NULL),(4105,2830,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-28','19:12:00','229923','X',0,'2014-02-28 21:31:51',NULL,NULL),(418,29,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-06','18:21:00','55528','X',0,'2013-12-25 20:18:16',NULL,NULL),(424,29,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-06','18:21:00','55534','X',0,'2013-12-25 20:19:19',NULL,NULL),(746,47,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-19','19:11:00','81732','X',0,'2013-12-25 23:09:02',NULL,NULL),(840,51,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-24','03:40:00','94579','X',0,'2013-12-25 23:51:16',NULL,NULL),(955,59,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-11','18:36:00','64788','X',0,'2013-12-26 00:53:20',NULL,NULL),(2272,1471,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-07','18:29:00','123270','X',0,'2014-01-08 18:24:19',NULL,NULL),(3138,2772,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-29','18:30:00','161360','X',0,'2014-01-29 21:01:51',NULL,NULL),(3156,2773,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-30','18:35:00','164077','X',0,'2014-01-30 21:01:24',NULL,NULL),(3184,2774,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-31','18:37:00','165926','X',0,'2014-01-31 21:01:28',NULL,NULL),(3220,2776,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-02','18:10:00','168369','X',0,'2014-02-02 19:00:14',NULL,NULL),(4329,2849,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-07','18:42:00','246115','X',0,'2014-03-07 21:00:26',NULL,NULL),(302,21,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-10','18:21:00','62751','X',0,'2013-12-25 19:19:23',NULL,NULL),(372,23,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-02','18:14:00','47688','X',0,'2013-12-25 19:49:07',NULL,NULL),(462,31,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-11-18','18:07:00','30649','X',0,'2013-12-25 20:31:46',NULL,NULL),(617,40,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-12','18:53:00','67237','X',0,'2013-12-25 22:03:08',NULL,NULL),(1130,71,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-15','18:15:00','73621','X',0,'2013-12-26 02:33:52',NULL,NULL),(1742,571,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-04','18:14:00','119144','X',0,'2014-01-05 00:02:22',NULL,NULL),(2407,1478,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-12','18:13:00','132591','X',0,'2014-01-13 03:01:45',NULL,NULL),(2711,2554,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-20','18:21:00','146890','X',0,'2014-01-21 08:46:00',NULL,NULL),(3327,2782,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-06','18:28:00','175984','X',0,'2014-02-06 21:01:12',NULL,NULL),(3466,2792,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-02-10','18:30:00','186452','X',0,'2014-02-10 21:31:44',NULL,NULL),(4256,2846,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-03-05','18:49:00','241590','X',0,'2014-03-05 21:32:17',NULL,NULL),(90,6,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-04','18:22:00','52138','X',0,'2013-12-25 17:50:43',NULL,NULL),(328,22,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-09','18:28:00','61498','X',0,'2013-12-25 19:34:31',NULL,NULL),(683,42,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-08','18:03:00','21239','X',0,'2013-12-25 22:30:30',NULL,NULL),(848,51,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-24','03:40:00','94587','X',0,'2013-12-25 23:51:55',NULL,NULL),(1147,72,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-11-17','18:03:00','29576','X',0,'2013-12-26 02:46:06',NULL,NULL),(1499,380,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-27','18:44:00','101823','X',0,'2013-12-28 03:36:02',NULL,NULL),(2401,1478,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-12','18:13:00','132585','X',0,'2014-01-13 03:01:19',NULL,NULL),(2488,1547,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:03:40',NULL,NULL),(2912,2687,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:05:00','1','X',0,'2014-01-23 05:30:02',NULL,NULL),(3011,2756,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-24','18:26:00','154291','X',0,'2014-01-24 21:00:35',NULL,NULL),(3139,2772,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-29','18:30:00','161361','X',0,'2014-01-29 21:01:52',NULL,NULL),(3381,2786,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-08','18:12:00','180293','X',0,'2014-02-08 19:00:34',NULL,NULL),(3978,2824,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-24','18:21:00','218490','X',0,'2014-02-26 09:30:28',NULL,NULL),(4411,2853,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-03-09','18:20:00','252256','X',0,'2014-03-09 21:00:57',NULL,NULL),(155,8,'005010X220A1','BE','OH0','92036','92036OH0010008','2013-10-31','18:04:00','15480','X',0,'2013-12-25 18:10:21',NULL,NULL),(518,37,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-22','18:40:00','88479','X',0,'2013-12-25 21:22:45',NULL,NULL),(1045,67,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-25','18:35:00','98927','X',0,'2013-12-26 01:50:21',NULL,NULL),(1101,70,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-28','18:08:00','14562','X',0,'2013-12-26 02:16:32',NULL,NULL),(1155,73,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-14','18:02:00','9153','X',0,'2013-12-26 02:46:28',NULL,NULL),(2472,1531,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:25',NULL,NULL),(2826,2601,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 03:51:41',NULL,NULL),(3507,2793,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-11','18:41:00','189061','X',0,'2014-02-11 21:02:42',NULL,NULL),(4023,2826,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-27','18:48:00','225917','X',0,'2014-02-28 06:30:13',NULL,NULL),(4150,2833,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-02','18:16:00','233969','X',0,'2014-03-03 01:00:28',NULL,NULL),(4361,2850,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-03-07','18:46:00','247676','X',0,'2014-03-07 21:32:09',NULL,NULL),(35,2,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-12','18:01:00','7919','X',0,'2013-12-25 17:30:05',NULL,NULL),(301,21,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-10','18:21:00','62750','X',0,'2013-12-25 19:19:13',NULL,NULL),(695,44,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-04','18:00:00','5518','X',0,'2013-12-25 22:31:20',NULL,NULL),(735,47,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-19','19:11:00','81721','X',0,'2013-12-25 23:06:09',NULL,NULL),(1467,99,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-26','18:41:00','100557','X',0,'2013-12-27 02:06:51',NULL,NULL),(1897,1144,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:28',NULL,NULL),(2573,2311,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-14','19:00:00','136130','X',0,'2014-01-15 02:08:05',NULL,NULL),(2770,2556,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-22','18:31:00','150811','X',0,'2014-01-23 03:02:27',NULL,NULL),(2936,2711,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:50:00','1','X',0,'2014-01-23 06:46:44',NULL,NULL),(3083,2759,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-27','18:27:00','158023','X',0,'2014-01-27 21:01:46',NULL,NULL),(3240,2777,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-03','18:32:00','170202','X',0,'2014-02-03 21:00:53',NULL,NULL),(118,7,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-16','18:37:00','74931','X',0,'2013-12-25 18:07:10',NULL,NULL),(373,23,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-02','18:14:00','47689','X',0,'2013-12-25 19:49:36',NULL,NULL),(2920,2695,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',0,'2014-01-23 06:39:34',NULL,NULL),(2977,2752,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:24:00','1','X',0,'2014-01-23 17:30:02',NULL,NULL),(3357,2784,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-07','18:14:00','177566','X',0,'2014-02-07 19:00:47',NULL,NULL),(3406,2789,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-09','18:11:00','181281','X',0,'2014-02-09 19:00:12',NULL,NULL),(3621,2799,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-14','18:39:00','196114','X',0,'2014-02-14 21:30:24',NULL,NULL),(1956,1203,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:54:11',NULL,NULL),(2079,1326,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:29',NULL,NULL),(2412,1478,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-12','18:13:00','132596','X',0,'2014-01-13 03:01:51',NULL,NULL),(3660,2800,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-14','18:36:00','195038','X',0,'2014-02-14 22:00:05',NULL,NULL),(3734,2807,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-18','18:25:00','203028','X',0,'2014-02-18 21:30:07',NULL,NULL),(438,29,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-06','18:21:00','55548','X',0,'2013-12-25 20:20:12',NULL,NULL),(522,37,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-22','18:40:00','88483','X',0,'2013-12-25 21:22:57',NULL,NULL),(830,51,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-24','03:40:00','94569','X',0,'2013-12-25 23:49:11',NULL,NULL),(924,57,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-11-19','18:07:00','31304','X',0,'2013-12-26 00:31:54',NULL,NULL),(1694,568,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-01-02','18:42:00','115218','X',0,'2014-01-03 02:06:58',NULL,NULL),(2301,1473,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-11','18:16:00','130858','X',0,'2014-01-13 02:18:34',NULL,NULL),(2860,2635,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','03:08:00','1','X',1,'2014-01-23 04:16:56',NULL,NULL),(3362,2784,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-02-07','18:14:00','177571','X',0,'2014-02-07 19:01:01',NULL,NULL),(3495,2793,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-11','18:41:00','189049','X',0,'2014-02-11 21:02:15',NULL,NULL),(264,19,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-24','18:40:00','96825','X',0,'2013-12-25 18:58:46',NULL,NULL),(657,41,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-08','18:10:00','59414','X',0,'2013-12-25 22:15:57',NULL,NULL),(1104,70,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-28','18:08:00','14565','X',0,'2013-12-26 02:16:57',NULL,NULL),(1565,383,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-29','18:10:00','107247','X',0,'2013-12-30 00:01:21',NULL,NULL),(2116,1363,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:22:53',NULL,NULL),(2298,1473,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-11','18:16:00','130855','X',0,'2014-01-13 02:18:25',NULL,NULL),(2343,1475,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-08','18:27:00','125979','X',0,'2014-01-13 02:22:07',NULL,NULL),(3112,2760,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-28','18:32:00','160263','X',0,'2014-01-28 21:01:23',NULL,NULL),(3644,2799,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-14','18:39:00','196137','X',0,'2014-02-14 21:32:06',NULL,NULL),(904,55,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-23','18:01:00','12597','X',0,'2013-12-26 00:30:02',NULL,NULL),(925,57,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-19','18:07:00','31311','X',0,'2013-12-26 00:31:58',NULL,NULL),(1007,63,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-11-25','18:07:00','38445','X',0,'2013-12-26 01:16:05',NULL,NULL),(1910,1157,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:04',NULL,NULL),(1915,1162,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:18',NULL,NULL),(2833,2608,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:11:00','1','X',1,'2014-01-23 03:55:56',NULL,NULL),(3143,2773,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-30','18:35:00','164064','X',0,'2014-01-30 21:00:19',NULL,NULL),(3442,2791,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-10','18:27:00','184753','X',0,'2014-02-10 21:00:02',NULL,NULL),(3882,2816,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-21','18:31:00','212810','X',0,'2014-02-21 22:01:11',NULL,NULL),(65,5,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-09','18:02:00','22416','X',0,'2013-12-25 17:32:19',NULL,NULL),(540,38,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-13','18:39:00','69266','X',0,'2013-12-25 21:30:10',NULL,NULL),(917,56,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-10-16','20:51:00','10070','X',0,'2013-12-26 00:31:12',NULL,NULL),(946,59,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-11','18:36:00','64779','X',0,'2013-12-26 00:51:17',NULL,NULL),(1980,1227,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:21',NULL,NULL),(2601,2539,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-15','18:30:00','138463','X',0,'2014-01-16 08:47:01',NULL,NULL),(3324,2782,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-06','18:28:00','175981','X',0,'2014-02-06 21:01:08',NULL,NULL),(3765,2808,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-18','18:28:00','204279','X',0,'2014-02-18 22:01:37',NULL,NULL),(478,33,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-01','18:03:00','16378','X',0,'2013-12-25 20:45:43',NULL,NULL),(881,52,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-01','18:08:00','46328','X',0,'2013-12-26 00:02:50',NULL,NULL),(1162,74,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-10','18:01:00','22948','X',0,'2013-12-26 02:46:47',NULL,NULL),(1613,385,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-30','19:01:00','109560','X',0,'2014-01-01 12:09:27',NULL,NULL),(2241,1468,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-06','18:24:00','121987','X',0,'2014-01-07 04:05:46',NULL,NULL),(68,6,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-04','18:22:00','52116','X',0,'2013-12-25 17:45:02',NULL,NULL),(752,47,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-19','19:11:00','81738','X',0,'2013-12-25 23:10:06',NULL,NULL),(2042,1289,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:59:46',NULL,NULL),(2254,1469,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-05','18:09:00','119788','X',1,'2014-01-07 10:21:19',NULL,NULL),(2463,1522,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:13',NULL,NULL),(3003,2755,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-23','18:27:00','151599','X',0,'2014-01-23 21:01:41',NULL,NULL),(3122,2772,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-29','18:30:00','161344','X',0,'2014-01-29 21:01:21',NULL,NULL),(3342,2782,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-06','18:28:00','175999','X',0,'2014-02-06 21:01:49',NULL,NULL),(3498,2793,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-11','18:41:00','189052','X',0,'2014-02-11 21:02:24',NULL,NULL),(4142,2833,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-02','18:16:00','233961','X',0,'2014-03-03 01:00:02',NULL,NULL),(159,8,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-10-31','18:04:00','15484','X',0,'2013-12-25 18:10:32',NULL,NULL),(221,15,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-04','18:02:00','18536','X',0,'2013-12-25 18:31:42',NULL,NULL),(761,47,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-19','19:11:00','81747','X',0,'2013-12-25 23:10:54',NULL,NULL),(1417,93,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-24','01:56:00','90953','X',0,'2013-12-26 13:11:44',NULL,NULL),(2031,1278,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:15',NULL,NULL),(2071,1318,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:07',NULL,NULL),(3550,2796,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-02-12','18:31:00','191458','X',0,'2014-02-12 21:32:07',NULL,NULL),(75,6,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-04','18:22:00','52123','X',0,'2013-12-25 17:47:53',NULL,NULL),(202,13,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-03','18:20:00','49908','X',0,'2013-12-25 18:21:31',NULL,NULL),(507,37,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-22','18:40:00','88464','X',0,'2013-12-25 21:20:55',NULL,NULL),(1546,382,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-28','21:04:00','105802','X',1,'2013-12-29 11:14:33',NULL,NULL),(2724,2554,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-20','18:21:00','146903','X',0,'2014-01-21 08:46:50',NULL,NULL),(3190,2774,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-31','18:37:00','165932','X',0,'2014-01-31 21:01:39',NULL,NULL),(3737,2807,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-18','18:25:00','203031','X',0,'2014-02-18 21:30:12',NULL,NULL),(3995,2825,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-26','18:43:00','223750','X',0,'2014-02-26 21:00:32',NULL,NULL),(4073,2828,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-27','18:43:00','224657','X',0,'2014-02-28 07:30:35',NULL,NULL),(864,52,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-01','18:08:00','46311','X',0,'2013-12-26 00:01:27',NULL,NULL),(3062,2759,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-27','18:27:00','158002','X',0,'2014-01-27 21:00:29',NULL,NULL),(3789,2809,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-19','18:35:00','207797','X',0,'2014-02-20 04:27:10',NULL,NULL),(38,2,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-10-12','18:01:00','7922','X',0,'2013-12-25 17:30:19',NULL,NULL),(384,23,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-02','18:14:00','47700','X',0,'2013-12-25 19:50:27',NULL,NULL),(972,60,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-12','18:03:00','24204','X',0,'2013-12-26 01:00:13',NULL,NULL),(1648,387,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-31','18:52:00','111687','X',1,'2014-01-02 04:34:38',NULL,NULL),(2884,2659,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:17:00','1','X',1,'2014-01-23 04:33:56',NULL,NULL),(3066,2759,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-27','18:27:00','158006','X',0,'2014-01-27 21:01:11',NULL,NULL),(4158,2833,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-03-02','18:16:00','233977','X',0,'2014-03-03 01:00:40',NULL,NULL),(474,33,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-01','18:03:00','16374','X',0,'2013-12-25 20:45:25',NULL,NULL),(1279,81,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-30','18:04:00','44819','X',0,'2013-12-26 04:15:02',NULL,NULL),(1323,82,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-21','18:37:00','86540','X',0,'2013-12-26 04:39:47',NULL,NULL),(2095,1342,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:14',NULL,NULL),(2715,2554,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-20','18:21:00','146894','X',0,'2014-01-21 08:46:28',NULL,NULL),(3269,2778,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-04','18:29:00','172111','X',0,'2014-02-04 21:01:24',NULL,NULL),(3352,2784,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-07','18:14:00','177561','X',0,'2014-02-07 19:00:29',NULL,NULL),(4107,2830,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-28','19:12:00','229925','X',0,'2014-02-28 21:31:53',NULL,NULL),(4476,2856,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-10','19:17:00','254163','X',0,'2014-03-10 21:30:07',NULL,NULL),(87,6,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-04','18:22:00','52135','X',0,'2013-12-25 17:50:24',NULL,NULL),(106,7,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-16','18:37:00','74919','X',0,'2013-12-25 18:03:19',NULL,NULL),(285,20,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-20','18:06:00','32809','X',0,'2013-12-25 19:02:24',NULL,NULL),(999,62,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-05','18:03:00','19347','X',0,'2013-12-26 01:02:17',NULL,NULL),(1352,84,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-10-21','18:04:00','11694','X',0,'2013-12-26 05:01:21',NULL,NULL),(2007,1254,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:09',NULL,NULL),(2084,1331,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:43',NULL,NULL),(2285,1471,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-07','18:29:00','123283','X',0,'2014-01-08 18:25:01',NULL,NULL),(2411,1478,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-01-12','18:13:00','132595','X',0,'2014-01-13 03:01:50',NULL,NULL),(2908,2683,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:20:00','1','X',1,'2014-01-23 05:06:38',NULL,NULL),(3450,2792,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-10','18:30:00','186436','X',0,'2014-02-10 21:30:03',NULL,NULL),(4058,2827,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-02-26','18:39:00','222057','X',0,'2014-02-28 07:00:33',NULL,NULL),(2768,2556,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-22','18:31:00','150809','X',0,'2014-01-23 03:02:23',NULL,NULL),(3729,2806,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-17','18:05:00','202227','X',0,'2014-02-17 19:00:14',NULL,NULL),(4087,2830,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-28','19:12:00','229905','X',0,'2014-02-28 21:30:02',NULL,NULL),(4391,2852,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-03-08','18:43:00','250663','X',0,'2014-03-08 21:31:07',NULL,NULL),(2911,2686,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:00:00','1','X',1,'2014-01-23 05:08:10',NULL,NULL),(3043,2757,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-25','18:11:00','155344','X',0,'2014-01-25 19:00:18',NULL,NULL),(3453,2792,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-10','18:30:00','186439','X',0,'2014-02-10 21:30:33',NULL,NULL),(374,23,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-02','18:14:00','47690','X',0,'2013-12-25 19:49:40',NULL,NULL),(602,39,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-17','18:43:00','78051','X',0,'2013-12-25 21:52:59',NULL,NULL),(1114,71,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-15','18:15:00','73605','X',0,'2013-12-26 02:32:20',NULL,NULL),(1181,75,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-20','19:06:00','84218','X',0,'2013-12-26 03:09:13',NULL,NULL),(2335,1474,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-09','18:28:00','127875','X',0,'2014-01-13 02:21:00',NULL,NULL),(2342,1475,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-01-08','18:27:00','125978','X',0,'2014-01-13 02:22:07',NULL,NULL),(2870,2645,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 04:21:04',NULL,NULL),(3358,2784,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-07','18:14:00','177567','X',0,'2014-02-07 19:00:54',NULL,NULL),(3567,2796,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-12','18:31:00','191475','X',0,'2014-02-12 21:32:31',NULL,NULL),(4210,2843,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-04','18:50:00','238757','X',0,'2014-03-04 21:02:10',NULL,NULL),(320,21,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-10','18:21:00','62769','X',0,'2013-12-25 19:20:59',NULL,NULL),(452,30,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-10-13','18:01:00','8426','X',0,'2013-12-25 20:30:36',NULL,NULL),(943,59,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-11','18:36:00','64776','X',0,'2013-12-26 00:49:59',NULL,NULL),(1598,385,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-30','19:01:00','109545','X',0,'2014-01-01 12:08:29',NULL,NULL),(1626,386,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-01','18:18:00','112811','X',1,'2014-01-02 04:25:04',NULL,NULL),(2147,1394,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:20',NULL,NULL),(2987,2755,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-23','18:27:00','151583','X',0,'2014-01-23 21:01:11',NULL,NULL),(3048,2758,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-26','18:09:00','156588','X',0,'2014-01-26 19:00:08',NULL,NULL),(3561,2796,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-12','18:31:00','191469','X',0,'2014-02-12 21:32:27',NULL,NULL),(4390,2852,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-08','18:43:00','250662','X',0,'2014-03-08 21:31:03',NULL,NULL),(4429,2854,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-03-09','18:21:00','252849','X',0,'2014-03-09 21:30:00',NULL,NULL),(197,13,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-03','18:20:00','49903','X',0,'2013-12-25 18:21:17',NULL,NULL),(549,38,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-13','18:39:00','69275','X',0,'2013-12-25 21:36:54',NULL,NULL),(1687,568,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-02','18:42:00','115211','X',0,'2014-01-03 02:06:20',NULL,NULL),(2237,1468,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-06','18:24:00','121983','X',0,'2014-01-07 04:05:30',NULL,NULL),(2385,1477,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-10','18:26:00','129740','X',0,'2014-01-13 03:00:29',NULL,NULL),(2608,2539,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-15','18:30:00','138470','X',0,'2014-01-16 08:47:14',NULL,NULL),(2631,2540,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-01-16','18:41:00','141407','X',0,'2014-01-17 03:36:09',NULL,NULL),(4449,2855,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-10','19:23:00','255924','X',0,'2014-03-10 21:02:19',NULL,NULL),(257,19,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-24','18:40:00','96818','X',0,'2013-12-25 18:57:20',NULL,NULL),(349,22,'005010X220A1','BE','OH0','92036','92036OH0040032','2013-12-09','18:28:00','61519','X',0,'2013-12-25 19:37:43',NULL,NULL),(1608,385,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-30','19:01:00','109555','X',0,'2014-01-01 12:09:10',NULL,NULL),(1869,1116,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:11',NULL,NULL),(1885,1132,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-27','16:55:00','1','X',0,'2014-01-05 16:50:55',NULL,NULL),(2296,1473,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-11','18:16:00','130853','X',0,'2014-01-13 02:18:19',NULL,NULL),(2874,2649,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:44:00','1','X',1,'2014-01-23 04:22:25',NULL,NULL),(2891,2666,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','09:49:00','1','X',1,'2014-01-23 04:46:06',NULL,NULL),(3024,2756,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-24','18:26:00','154304','X',0,'2014-01-24 21:01:12',NULL,NULL),(3483,2792,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-10','18:30:00','186469','X',0,'2014-02-10 21:32:18',NULL,NULL),(3545,2796,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-12','18:31:00','191453','X',0,'2014-02-12 21:31:45',NULL,NULL),(29,1,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-05','18:31:00','54204','X',0,'2013-12-25 17:21:53',NULL,NULL),(195,13,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-03','18:20:00','49901','X',0,'2013-12-25 18:21:10',NULL,NULL),(471,32,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-03','18:00:00','5201','X',0,'2013-12-25 20:32:15',NULL,NULL),(1237,80,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-18','18:49:00','79067','X',0,'2013-12-26 04:04:44',NULL,NULL),(1453,99,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-26','18:41:00','100543','X',0,'2013-12-27 02:00:02',NULL,NULL),(1535,381,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-28','18:14:00','103727','X',1,'2013-12-29 11:10:24',NULL,NULL),(1896,1143,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:25',NULL,NULL),(2482,1541,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:34',NULL,NULL),(3098,2760,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-28','18:32:00','160249','X',0,'2014-01-28 21:01:08',NULL,NULL),(3322,2782,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-06','18:28:00','175979','X',0,'2014-02-06 21:00:59',NULL,NULL),(3465,2792,'005010X220A1','BE','OH0','92036','92036OH0010015','2014-02-10','18:30:00','186451','X',0,'2014-02-10 21:31:44',NULL,NULL),(649,40,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-12','18:53:00','67269','X',0,'2013-12-25 22:09:26',NULL,NULL),(1000,62,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-05','18:03:00','19348','X',0,'2013-12-26 01:02:20',NULL,NULL),(1324,82,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-21','18:37:00','86541','X',0,'2013-12-26 04:39:50',NULL,NULL),(1406,92,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-24','01:56:00','90943','X',0,'2013-12-26 13:05:32',NULL,NULL),(2701,2553,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-19','18:08:00','145208','X',0,'2014-01-21 08:45:32',NULL,NULL),(3186,2774,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-31','18:37:00','165928','X',0,'2014-01-31 21:01:35',NULL,NULL),(3277,2778,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-04','18:29:00','172119','X',0,'2014-02-04 21:01:52',NULL,NULL),(3448,2791,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-10','18:27:00','184759','X',0,'2014-02-10 21:00:11',NULL,NULL),(4321,2849,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-03-07','18:42:00','246107','X',0,'2014-03-07 21:00:08',NULL,NULL),(1899,1146,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:33',NULL,NULL),(2132,1379,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:38',NULL,NULL),(3173,2774,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-31','18:37:00','165915','X',0,'2014-01-31 21:00:41',NULL,NULL),(3383,2786,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-08','18:12:00','180295','X',0,'2014-02-08 19:00:39',NULL,NULL),(3407,2789,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-09','18:11:00','181279','X',0,'2014-02-09 19:00:20',NULL,NULL),(3648,2799,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-14','18:39:00','196141','X',0,'2014-02-14 21:32:13',NULL,NULL),(4303,2847,'005010X220A1','BE','OH0','92036','92036OH0010032','2014-03-06','18:51:00','245603','X',0,'2014-03-06 21:02:52',NULL,NULL),(4343,2850,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-07','18:46:00','247658','X',0,'2014-03-07 21:31:09',NULL,NULL),(4405,2853,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-09','18:20:00','252250','X',0,'2014-03-09 21:00:26',NULL,NULL),(139,7,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-16','18:37:00','74952','X',0,'2013-12-25 18:08:32',NULL,NULL),(185,13,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-03','18:20:00','49891','X',0,'2013-12-25 18:20:06',NULL,NULL),(3370,2784,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-07','18:14:00','177579','X',0,'2014-02-07 19:01:07',NULL,NULL),(4072,2828,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-02-27','18:43:00','224656','X',0,'2014-02-28 07:30:34',NULL,NULL),(4365,2850,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-07','18:46:00','247680','X',0,'2014-03-07 21:32:18',NULL,NULL),(537,37,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-22','18:40:00','88498','X',0,'2013-12-25 21:23:45',NULL,NULL),(1152,73,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-14','18:02:00','9152','X',0,'2013-12-26 02:46:18',NULL,NULL),(1344,84,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-21','18:04:00','11686','X',0,'2013-12-26 05:00:36',NULL,NULL),(2194,1441,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:26:31',NULL,NULL),(2545,1576,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-13','18:44:00','134021','X',0,'2014-01-14 01:33:53',NULL,NULL),(3337,2782,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-06','18:28:00','175994','X',0,'2014-02-06 21:01:41',NULL,NULL),(3711,2804,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-16','18:12:00','201504','X',0,'2014-02-16 19:00:30',NULL,NULL),(3924,2819,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-25','18:36:00','220696','X',0,'2014-02-25 21:32:03',NULL,NULL),(4138,2832,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-01','18:23:00','232025','X',0,'2014-03-01 21:01:10',NULL,NULL),(49,3,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-13','18:04:00','25388','X',0,'2013-12-25 17:31:15',NULL,NULL),(1484,99,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-26','18:41:00','100574','X',0,'2013-12-27 02:07:57',NULL,NULL),(1592,385,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-30','19:01:00','109539','X',0,'2014-01-01 12:07:39',NULL,NULL),(1653,387,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-31','18:52:00','111692','X',1,'2014-01-02 04:35:02',NULL,NULL),(2070,1317,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:04',NULL,NULL),(2089,1336,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:57',NULL,NULL),(2903,2678,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 05:02:13',NULL,NULL),(2945,2720,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:48:00','1','X',0,'2014-01-23 07:07:03',NULL,NULL),(3683,2802,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-15','18:48:00','199874','X',0,'2014-02-15 22:01:50',NULL,NULL),(3864,2815,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-21','18:28:00','211310','X',0,'2014-02-21 21:30:11',NULL,NULL),(4446,2855,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-03-10','19:23:00','255921','X',0,'2014-03-10 21:02:13',NULL,NULL),(532,37,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-22','18:40:00','88493','X',0,'2013-12-25 21:23:32',NULL,NULL),(1719,569,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-03','18:38:00','116018','X',0,'2014-01-04 02:05:54',NULL,NULL),(2064,1311,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:47',NULL,NULL),(2108,1355,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:50',NULL,NULL),(2513,1572,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:04:02',NULL,NULL),(3226,2776,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-02','18:10:00','168375','X',0,'2014-02-02 19:00:28',NULL,NULL),(109,7,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-16','18:37:00','74922','X',0,'2013-12-25 18:05:41',NULL,NULL),(123,7,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-16','18:37:00','74936','X',0,'2013-12-25 18:07:37',NULL,NULL),(444,29,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-06','18:21:00','55554','X',0,'2013-12-25 20:20:29',NULL,NULL),(1701,568,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-02','18:42:00','115226','X',0,'2014-01-03 02:07:25',NULL,NULL),(3154,2773,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-30','18:35:00','164075','X',0,'2014-01-30 21:01:22',NULL,NULL),(2040,1287,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:40',NULL,NULL),(2355,1475,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-08','18:27:00','125991','X',0,'2014-01-13 02:22:36',NULL,NULL),(3053,2758,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-26','18:09:00','156593','X',0,'2014-01-26 19:00:25',NULL,NULL),(3802,2810,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-19','18:35:00','207801','X',0,'2014-02-20 04:51:31',NULL,NULL),(334,22,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-09','18:28:00','61504','X',0,'2013-12-25 19:36:15',NULL,NULL),(1159,74,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-10','18:01:00','22950','X',0,'2013-12-26 02:46:40',NULL,NULL),(1473,99,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-26','18:41:00','100563','X',0,'2013-12-27 02:07:25',NULL,NULL),(1883,1130,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:50:49',NULL,NULL),(2553,2311,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-14','19:00:00','136110','X',0,'2014-01-15 02:06:57',NULL,NULL),(2708,2553,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-19','18:08:00','145215','X',0,'2014-01-21 08:45:41',NULL,NULL),(2919,2694,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',0,'2014-01-23 06:39:29',NULL,NULL),(3361,2784,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-07','18:14:00','177570','X',0,'2014-02-07 19:00:59',NULL,NULL),(3836,2813,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-20','18:26:00','208222','X',0,'2014-02-20 21:30:19',NULL,NULL),(4378,2851,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-08','18:41:00','249543','X',0,'2014-03-08 21:00:07',NULL,NULL),(105,7,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-16','18:37:00','74918','X',0,'2013-12-25 18:03:11',NULL,NULL),(705,45,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-26','18:04:00','13996','X',0,'2013-12-25 22:31:58',NULL,NULL),(748,47,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-19','19:11:00','81734','X',0,'2013-12-25 23:09:14',NULL,NULL),(1528,381,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-28','18:14:00','103720','X',1,'2013-12-29 11:09:56',NULL,NULL),(2319,1474,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-09','18:28:00','127859','X',0,'2014-01-13 02:20:18',NULL,NULL),(3046,2757,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-25','18:11:00','155347','X',0,'2014-01-25 19:00:20',NULL,NULL),(3432,2790,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-10','05:02:00','183705','X',0,'2014-02-10 11:01:00',NULL,NULL),(3688,2802,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-15','18:48:00','199879','X',0,'2014-02-15 22:01:57',NULL,NULL),(3792,2810,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-19','18:35:00','207798','X',0,'2014-02-20 04:28:55',NULL,NULL),(4366,2850,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-07','18:46:00','247681','X',0,'2014-03-07 21:32:21',NULL,NULL),(4400,2852,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-08','18:43:00','250672','X',0,'2014-03-08 21:31:22',NULL,NULL),(648,40,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-12','18:53:00','67268','X',0,'2013-12-25 22:09:23',NULL,NULL),(1669,387,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-31','18:52:00','111708','X',1,'2014-01-02 04:36:13',NULL,NULL),(2185,1432,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:05',NULL,NULL),(2760,2555,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-01-21','18:24:00','147895','X',1,'2014-01-22 03:23:10',NULL,NULL),(4115,2831,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-03-01','18:21:00','230733','X',0,'2014-03-01 19:00:07',NULL,NULL),(4474,2856,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-10','19:17:00','254161','X',0,'2014-03-10 21:30:04',NULL,NULL),(43,3,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-13','18:04:00','25397','X',0,'2013-12-25 17:30:47',NULL,NULL),(98,6,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-04','18:22:00','52146','X',0,'2013-12-25 17:51:03',NULL,NULL),(468,32,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-03','18:00:00','5203','X',0,'2013-12-25 20:32:09',NULL,NULL),(844,51,'005010X220A1','BE','OH0','92036','92036OH0010005','2013-12-24','03:40:00','94583','X',0,'2013-12-25 23:51:41',NULL,NULL),(1335,83,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-11-15','18:34:00','27231','X',0,'2013-12-26 04:46:03',NULL,NULL),(1342,84,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-21','18:04:00','11684','X',0,'2013-12-26 05:00:06',NULL,NULL),(1709,569,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-03','18:38:00','116008','X',0,'2014-01-04 02:04:34',NULL,NULL),(3713,2804,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-16','18:12:00','201506','X',0,'2014-02-16 19:00:35',NULL,NULL),(3974,2824,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-24','18:21:00','218486','X',0,'2014-02-26 09:30:04',NULL,NULL),(193,13,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-03','18:20:00','49899','X',0,'2013-12-25 18:21:02',NULL,NULL),(805,50,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-26','18:20:00','40530','X',0,'2013-12-25 23:31:59',NULL,NULL),(1112,71,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-15','18:15:00','73603','X',0,'2013-12-26 02:31:02',NULL,NULL),(2403,1478,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-12','18:13:00','132587','X',0,'2014-01-13 03:01:27',NULL,NULL),(3074,2759,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-27','18:27:00','158014','X',0,'2014-01-27 21:01:34',NULL,NULL),(3504,2793,'005010X220A1','BE','OH0','92036','92036OH0020032','2014-02-11','18:41:00','189058','X',0,'2014-02-11 21:02:38',NULL,NULL),(3770,2808,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-18','18:28:00','204285','X',0,'2014-02-18 22:01:47',NULL,NULL),(179,13,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-03','18:20:00','49885','X',0,'2013-12-25 18:17:46',NULL,NULL),(252,19,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-24','18:40:00','96813','X',0,'2013-12-25 18:55:02',NULL,NULL),(272,19,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-24','18:40:00','96833','X',0,'2013-12-25 18:59:17',NULL,NULL),(702,45,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-10-26','18:04:00','14002','X',0,'2013-12-25 22:31:42',NULL,NULL),(1328,82,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-21','18:37:00','86545','X',0,'2013-12-26 04:40:04',NULL,NULL),(1482,99,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-26','18:41:00','100572','X',0,'2013-12-27 02:07:48',NULL,NULL),(1500,380,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-27','18:44:00','101824','X',0,'2013-12-28 03:36:16',NULL,NULL),(2558,2311,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-14','19:00:00','136115','X',0,'2014-01-15 02:07:21',NULL,NULL),(2765,2556,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-22','18:31:00','150806','X',0,'2014-01-23 03:02:06',NULL,NULL),(2978,2753,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','11:28:00','1','X',0,'2014-01-23 18:00:03',NULL,NULL),(76,6,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-04','18:22:00','52124','X',0,'2013-12-25 17:47:56',NULL,NULL),(499,35,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-11-28','18:02:00','42799','X',0,'2013-12-25 20:47:13',NULL,NULL),(667,41,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-12-08','18:10:00','59424','X',0,'2013-12-25 22:16:57',NULL,NULL),(1137,72,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-17','18:03:00','29566','X',0,'2013-12-26 02:45:29',NULL,NULL),(1995,1242,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:35',NULL,NULL),(2300,1473,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-11','18:16:00','130857','X',0,'2014-01-13 02:18:31',NULL,NULL),(2313,1474,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-09','18:28:00','127853','X',0,'2014-01-13 02:19:43',NULL,NULL),(2364,1476,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-10','18:26:00','129721','X',0,'2014-01-13 02:23:19',NULL,NULL),(2514,1573,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:04:03',NULL,NULL),(2549,2311,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-14','19:00:00','136106','X',0,'2014-01-15 02:05:54',NULL,NULL),(2714,2554,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-20','18:21:00','146893','X',0,'2014-01-21 08:46:19',NULL,NULL),(2387,1477,'005010X220A1','BE','OH0','92036','92036OH0020032','2014-01-10','18:26:00','129742','X',0,'2014-01-13 03:00:31',NULL,NULL),(2480,1539,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:32',NULL,NULL),(2609,2539,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-15','18:30:00','138471','X',0,'2014-01-16 08:47:15',NULL,NULL),(2782,2557,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:31:00','1','X',0,'2014-01-23 03:38:41',NULL,NULL),(2834,2609,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:56:07',NULL,NULL),(3850,2814,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-20','18:28:00','208917','X',0,'2014-02-20 22:01:29',NULL,NULL),(3990,2824,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-24','18:21:00','218502','X',0,'2014-02-26 09:31:04',NULL,NULL),(4113,2831,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-01','18:21:00','230731','X',0,'2014-03-01 19:00:01',NULL,NULL),(4200,2843,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-04','18:50:00','238747','X',0,'2014-03-04 21:00:15',NULL,NULL),(4299,2847,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-03-06','18:51:00','245599','X',0,'2014-03-06 21:02:48',NULL,NULL),(81,6,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-04','18:22:00','52129','X',0,'2013-12-25 17:49:38',NULL,NULL),(116,7,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-16','18:37:00','74929','X',0,'2013-12-25 18:06:51',NULL,NULL),(687,42,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-08','18:03:00','21243','X',0,'2013-12-25 22:30:45',NULL,NULL),(2602,2539,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-15','18:30:00','138464','X',0,'2014-01-16 08:47:07',NULL,NULL),(3650,2799,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-14','18:39:00','196143','X',0,'2014-02-14 21:32:18',NULL,NULL),(3679,2802,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-15','18:48:00','199870','X',0,'2014-02-15 22:01:29',NULL,NULL),(3714,2804,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-16','18:12:00','201507','X',0,'2014-02-16 19:00:38',NULL,NULL),(23,1,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-05','18:31:00','54198','X',0,'2013-12-25 17:21:24',NULL,NULL),(190,13,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-03','18:20:00','49896','X',0,'2013-12-25 18:20:44',NULL,NULL),(191,13,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-03','18:20:00','49897','X',0,'2013-12-25 18:20:46',NULL,NULL),(451,30,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-10-13','18:01:00','8425','X',0,'2013-12-25 20:30:34',NULL,NULL),(907,55,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-10-23','18:01:00','12600','X',0,'2013-12-26 00:30:28',NULL,NULL),(1330,83,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-15','18:34:00','27226','X',0,'2013-12-26 04:45:05',NULL,NULL),(1643,387,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-31','18:52:00','111682','X',1,'2014-01-02 04:33:45',NULL,NULL),(2100,1347,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:02:28',NULL,NULL),(2389,1477,'005010X220A1','BE','OH0','92036','92036OH0060012','2014-01-10','18:26:00','129744','X',0,'2014-01-13 03:00:32',NULL,NULL),(2498,1557,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:49',NULL,NULL),(3577,2797,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-13','18:41:00','192639','X',0,'2014-02-13 21:30:15',NULL,NULL),(3594,2798,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-13','18:46:00','194317','X',0,'2014-02-13 22:02:39',NULL,NULL),(3739,2807,'005010X220A1','BE','OH0','92036','92036OH0040032','2014-02-18','18:25:00','203033','X',0,'2014-02-18 21:30:15',NULL,NULL),(3980,2824,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-24','18:21:00','218492','X',0,'2014-02-26 09:30:38',NULL,NULL),(548,38,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-13','18:39:00','69274','X',0,'2013-12-25 21:36:52',NULL,NULL),(890,53,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-11-21','18:06:00','34268','X',0,'2013-12-26 00:16:36',NULL,NULL),(1677,568,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-02','18:42:00','115201','X',0,'2014-01-03 02:04:43',NULL,NULL),(3459,2792,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-10','18:30:00','186445','X',0,'2014-02-10 21:31:18',NULL,NULL),(3501,2793,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-11','18:41:00','189055','X',0,'2014-02-11 21:02:32',NULL,NULL),(4018,2825,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-02-26','18:43:00','223773','X',0,'2014-02-26 21:02:44',NULL,NULL),(242,19,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-24','18:40:00','96803','X',0,'2013-12-25 18:47:58',NULL,NULL),(1563,383,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-29','18:10:00','107245','X',0,'2013-12-30 00:01:07',NULL,NULL),(1637,387,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-31','18:52:00','111676','X',1,'2014-01-02 04:28:48',NULL,NULL),(2182,1429,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:57',NULL,NULL),(2614,2539,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-15','18:30:00','138476','X',0,'2014-01-16 08:47:22',NULL,NULL),(3564,2796,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-02-12','18:31:00','191472','X',0,'2014-02-12 21:32:29',NULL,NULL),(4278,2847,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-06','18:51:00','245578','X',0,'2014-03-06 21:01:03',NULL,NULL),(300,21,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-10','18:21:00','62749','X',0,'2013-12-25 19:19:05',NULL,NULL),(1065,67,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-25','18:35:00','98947','X',0,'2013-12-26 01:52:43',NULL,NULL),(1655,387,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-31','18:52:00','111694','X',1,'2014-01-02 04:35:08',NULL,NULL),(2292,1471,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-07','18:29:00','123290','X',0,'2014-01-08 18:25:08',NULL,NULL),(2586,2539,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-15','18:30:00','138448','X',0,'2014-01-16 08:45:18',NULL,NULL),(3196,2774,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-31','18:37:00','165938','X',0,'2014-01-31 21:01:45',NULL,NULL),(3492,2793,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-11','18:41:00','189046','X',0,'2014-02-11 21:02:01',NULL,NULL),(862,52,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-01','18:08:00','46309','X',0,'2013-12-26 00:01:14',NULL,NULL),(1239,80,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-18','18:49:00','79069','X',0,'2013-12-26 04:06:04',NULL,NULL),(1259,80,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-18','18:49:00','79089','X',0,'2013-12-26 04:09:37',NULL,NULL),(2853,2628,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:55:00','1','X',1,'2014-01-23 04:10:28',NULL,NULL),(3642,2799,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-14','18:39:00','196135','X',0,'2014-02-14 21:31:59',NULL,NULL),(3752,2808,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-18','18:28:00','204266','X',0,'2014-02-18 22:01:09',NULL,NULL),(1187,75,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-20','19:06:00','84224','X',0,'2013-12-26 03:10:12',NULL,NULL),(1216,76,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-22','18:08:00','35670','X',0,'2013-12-26 03:16:25',NULL,NULL),(1536,381,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-28','18:14:00','103728','X',1,'2013-12-29 11:10:26',NULL,NULL),(1882,1129,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:47',NULL,NULL),(1950,1197,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:54',NULL,NULL),(2133,1380,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:41',NULL,NULL),(2243,1468,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-06','18:24:00','121989','X',0,'2014-01-07 04:06:24',NULL,NULL),(2591,2539,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-15','18:30:00','138453','X',0,'2014-01-16 08:46:07',NULL,NULL),(3608,2798,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-13','18:46:00','194331','X',0,'2014-02-13 22:03:09',NULL,NULL),(4410,2853,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-09','18:20:00','252255','X',0,'2014-03-09 21:00:50',NULL,NULL),(786,49,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-11-06','18:03:00','20436','X',0,'2013-12-25 23:16:31',NULL,NULL),(885,53,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-21','18:06:00','34263','X',0,'2013-12-26 00:15:39',NULL,NULL),(3013,2756,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-24','18:26:00','154293','X',0,'2014-01-24 21:00:47',NULL,NULL),(3092,2760,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-28','18:32:00','160243','X',0,'2014-01-28 21:00:33',NULL,NULL),(3788,2810,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-19','18:35:00','207796','X',0,'2014-02-20 04:26:20',NULL,NULL),(4348,2850,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-03-07','18:46:00','247663','X',0,'2014-03-07 21:31:56',NULL,NULL),(4379,2851,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-08','18:41:00','249544','X',0,'2014-03-08 21:00:07',NULL,NULL),(681,42,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-11-08','18:03:00','21237','X',0,'2013-12-25 22:30:09',NULL,NULL),(804,50,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-26','18:20:00','40529','X',0,'2013-12-25 23:31:45',NULL,NULL),(1523,381,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-28','18:14:00','103715','X',1,'2013-12-29 11:09:32',NULL,NULL),(2137,1384,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:23:52',NULL,NULL),(2931,2706,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:41:00','1','X',0,'2014-01-23 06:44:43',NULL,NULL),(3259,2778,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-04','18:29:00','172101','X',0,'2014-02-04 21:00:10',NULL,NULL),(3968,2823,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-22','18:14:00','213812','X',0,'2014-02-26 08:30:54',NULL,NULL),(4323,2849,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-07','18:42:00','246109','X',0,'2014-03-07 21:00:14',NULL,NULL),(638,40,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-12','18:53:00','67258','X',0,'2013-12-25 22:08:28',NULL,NULL),(665,41,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-08','18:10:00','59422','X',0,'2013-12-25 22:16:50',NULL,NULL),(1072,68,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-14','18:21:00','71341','X',0,'2013-12-26 02:02:06',NULL,NULL),(1141,72,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-17','18:03:00','29570','X',0,'2013-12-26 02:45:44',NULL,NULL),(1469,99,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-26','18:41:00','100559','X',0,'2013-12-27 02:07:01',NULL,NULL),(2165,1412,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:10',NULL,NULL),(2525,1576,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-13','18:44:00','134001','X',0,'2014-01-14 01:33:25',NULL,NULL),(3037,2757,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-25','18:11:00','155338','X',0,'2014-01-25 19:00:09',NULL,NULL),(3534,2795,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-12','18:27:00','189879','X',0,'2014-02-12 21:00:11',NULL,NULL),(3547,2796,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-12','18:31:00','191455','X',0,'2014-02-12 21:31:54',NULL,NULL),(3771,2809,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-19','18:35:00','207788','X',0,'2014-02-20 03:41:46',NULL,NULL),(4345,2850,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-07','18:46:00','247660','X',0,'2014-03-07 21:31:26',NULL,NULL),(1251,80,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-18','18:49:00','79081','X',0,'2013-12-26 04:08:46',NULL,NULL),(1327,82,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-21','18:37:00','86544','X',0,'2013-12-26 04:40:02',NULL,NULL),(1336,83,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-15','18:34:00','27232','X',0,'2013-12-26 04:46:05',NULL,NULL),(1455,99,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-26','18:41:00','100545','X',0,'2013-12-27 02:02:12',NULL,NULL),(2056,1303,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:25',NULL,NULL),(2561,2311,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-14','19:00:00','136118','X',0,'2014-01-15 02:07:44',NULL,NULL),(3171,2774,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-31','18:37:00','165913','X',0,'2014-01-31 21:00:29',NULL,NULL),(3306,2781,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-05','18:39:00','174416','X',0,'2014-02-05 21:31:10',NULL,NULL),(4020,2825,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-26','18:43:00','223776','X',0,'2014-02-26 21:02:46',NULL,NULL),(4297,2847,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-03-06','18:51:00','245597','X',0,'2014-03-06 21:02:44',NULL,NULL),(324,22,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-09','18:28:00','61494','X',0,'2013-12-25 19:30:02',NULL,NULL),(675,41,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-08','18:10:00','59432','X',0,'2013-12-25 22:17:19',NULL,NULL),(930,58,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-07','19:14:00','6700','X',0,'2013-12-26 00:32:09',NULL,NULL),(1979,1226,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:17',NULL,NULL),(2043,1290,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:49',NULL,NULL),(2855,2630,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:45:00','1','X',1,'2014-01-23 04:13:16',NULL,NULL),(3419,2789,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-09','18:11:00','181293','X',0,'2014-02-09 19:00:44',NULL,NULL),(3509,2793,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-11','18:41:00','189063','X',0,'2014-02-11 21:02:46',NULL,NULL),(4284,2847,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-06','18:51:00','245584','X',0,'2014-03-06 21:02:10',NULL,NULL),(450,30,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-13','18:01:00','8424','X',0,'2013-12-25 20:30:32',NULL,NULL),(1188,75,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-20','19:06:00','84225','X',0,'2013-12-26 03:10:15',NULL,NULL),(2918,2693,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:54:00','1','X',0,'2014-01-23 06:38:52',NULL,NULL),(3191,2774,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-31','18:37:00','165933','X',0,'2014-01-31 21:01:40',NULL,NULL),(3374,2785,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-07','18:13:00','177274','X',0,'2014-02-07 19:30:03',NULL,NULL),(3908,2819,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-25','18:36:00','220680','X',0,'2014-02-25 21:30:46',NULL,NULL),(331,22,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-09','18:28:00','61501','X',0,'2013-12-25 19:35:12',NULL,NULL),(613,39,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-12-17','18:43:00','78063','X',0,'2013-12-25 21:53:42',NULL,NULL),(1304,82,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-21','18:37:00','86507','X',0,'2013-12-26 04:37:42',NULL,NULL),(3208,2775,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-01','18:14:00','166677','X',0,'2014-02-01 19:00:43',NULL,NULL),(3457,2792,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-10','18:30:00','186443','X',0,'2014-02-10 21:31:15',NULL,NULL),(3755,2808,'005010X220A1','BE','OH0','92036','92036OH0020032','2014-02-18','18:28:00','204269','X',0,'2014-02-18 22:01:20',NULL,NULL),(3763,2808,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-18','18:28:00','204277','X',0,'2014-02-18 22:01:34',NULL,NULL),(4152,2833,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-02','18:16:00','233971','X',0,'2014-03-03 01:00:35',NULL,NULL),(4440,2855,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-10','19:23:00','255915','X',0,'2014-03-10 21:01:18',NULL,NULL),(298,21,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-10','18:21:00','62747','X',0,'2013-12-25 19:18:34',NULL,NULL),(1016,63,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-11-25','18:07:00','38454','X',0,'2013-12-26 01:17:21',NULL,NULL),(2344,1475,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-08','18:27:00','125980','X',0,'2014-01-13 02:22:14',NULL,NULL),(3975,2824,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-24','18:21:00','218487','X',0,'2014-02-26 09:30:10',NULL,NULL),(3991,2824,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-24','18:21:00','218503','X',0,'2014-02-26 09:31:06',NULL,NULL),(4213,2843,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-03-04','18:50:00','238760','X',0,'2014-03-04 21:02:19',NULL,NULL),(722,46,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-07','18:13:00','57440','X',0,'2013-12-25 22:47:42',NULL,NULL),(2216,1463,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:27:32',NULL,NULL),(2830,2605,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','09:47:00','1','X',1,'2014-01-23 03:53:21',NULL,NULL),(3067,2759,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-27','18:27:00','158007','X',0,'2014-01-27 21:01:13',NULL,NULL),(3412,2789,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-09','18:11:00','181285','X',0,'2014-02-09 19:00:35',NULL,NULL),(3595,2798,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-02-13','18:46:00','194318','X',0,'2014-02-13 22:02:40',NULL,NULL),(3920,2819,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-25','18:36:00','220692','X',0,'2014-02-25 21:31:52',NULL,NULL),(4012,2825,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-26','18:43:00','223767','X',0,'2014-02-26 21:02:37',NULL,NULL),(1047,67,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-25','18:35:00','98929','X',0,'2013-12-26 01:50:44',NULL,NULL),(1138,72,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-17','18:03:00','29567','X',0,'2013-12-26 02:45:30',NULL,NULL),(2813,2588,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:27:00','1','X',1,'2014-01-23 03:46:43',NULL,NULL),(2835,2610,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:56:32',NULL,NULL),(2858,2633,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:42:00','1','X',1,'2014-01-23 04:15:07',NULL,NULL),(2881,2656,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:22:00','1','X',0,'2014-01-23 04:30:02',NULL,NULL),(3315,2781,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-05','18:39:00','174425','X',0,'2014-02-05 21:31:18',NULL,NULL),(3539,2796,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-12','18:31:00','191447','X',0,'2014-02-12 21:30:29',NULL,NULL),(3719,2804,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-02-16','18:12:00','201513','X',0,'2014-02-16 19:00:42',NULL,NULL),(4032,2826,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-27','18:48:00','225926','X',0,'2014-02-28 06:31:26',NULL,NULL),(1014,63,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-11-25','18:07:00','38452','X',0,'2013-12-26 01:17:16',NULL,NULL),(2428,1487,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:20',NULL,NULL),(2914,2689,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:25:00','1','X',0,'2014-01-23 06:00:02',NULL,NULL),(3895,2818,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-25','18:33:00','219091','X',0,'2014-02-25 21:00:21',NULL,NULL),(2214,1461,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:26',NULL,NULL),(2370,1476,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-10','18:26:00','129727','X',0,'2014-01-13 02:24:06',NULL,NULL),(2717,2554,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-20','18:21:00','146896','X',0,'2014-01-21 08:46:30',NULL,NULL),(3213,2775,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-01','18:14:00','166682','X',0,'2014-02-01 19:00:49',NULL,NULL),(4459,2855,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-10','19:23:00','255934','X',0,'2014-03-10 21:02:41',NULL,NULL),(562,38,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-13','18:39:00','69288','X',0,'2013-12-25 21:38:03',NULL,NULL),(826,51,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-24','03:40:00','94565','X',0,'2013-12-25 23:46:17',NULL,NULL),(2059,1306,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:33',NULL,NULL),(2755,2555,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-21','18:24:00','147890','X',1,'2014-01-22 03:23:05',NULL,NULL),(3705,2804,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-16','18:12:00','201498','X',0,'2014-02-16 19:00:09',NULL,NULL),(4415,2853,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-03-09','18:20:00','252260','X',0,'2014-03-09 21:01:04',NULL,NULL),(267,19,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-24','18:40:00','96828','X',0,'2013-12-25 18:58:57',NULL,NULL),(1052,67,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-25','18:35:00','98934','X',0,'2013-12-26 01:51:37',NULL,NULL),(1264,80,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-18','18:49:00','79094','X',0,'2013-12-26 04:10:04',NULL,NULL),(1542,382,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-28','21:04:00','105798','X',1,'2013-12-29 11:14:10',NULL,NULL),(3533,2795,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-12','18:27:00','189878','X',0,'2014-02-12 21:00:10',NULL,NULL),(3741,2807,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-18','18:25:00','203035','X',0,'2014-02-18 21:30:17',NULL,NULL),(3804,2811,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-19','18:35:00','207802','X',0,'2014-02-20 04:52:01',NULL,NULL),(4226,2843,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-03-04','18:50:00','238773','X',0,'2014-03-04 21:02:44',NULL,NULL),(4239,2845,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-05','18:46:00','240507','X',0,'2014-03-05 21:00:18',NULL,NULL),(4401,2853,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-09','18:20:00','252246','X',0,'2014-03-09 20:59:58',NULL,NULL),(140,7,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-16','18:37:00','74953','X',0,'2013-12-25 18:08:37',NULL,NULL),(958,59,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-11','18:36:00','64791','X',0,'2013-12-26 00:53:45',NULL,NULL),(989,62,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-11-05','18:03:00','19339','X',0,'2013-12-26 01:01:43',NULL,NULL),(2808,2583,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 03:44:46',NULL,NULL),(2929,2704,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:33:00','1','X',0,'2014-01-23 06:42:09',NULL,NULL),(2965,2740,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:00:00','1','X',0,'2014-01-23 11:30:03',NULL,NULL),(3032,2756,'005010X220A1','BE','OH0','92036','92036OH0030032','2014-01-24','18:26:00','154313','X',0,'2014-01-24 21:01:18',NULL,NULL),(4202,2843,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-04','18:50:00','238749','X',0,'2014-03-04 21:01:14',NULL,NULL),(174,13,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-03','18:20:00','49880','X',0,'2013-12-25 18:15:13',NULL,NULL),(2206,1453,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:04',NULL,NULL),(2372,1476,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-10','18:26:00','129729','X',0,'2014-01-13 02:24:08',NULL,NULL),(3204,2775,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-01','18:14:00','166673','X',0,'2014-02-01 19:00:29',NULL,NULL),(3536,2795,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-12','18:27:00','189881','X',0,'2014-02-12 21:00:17',NULL,NULL),(3607,2798,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-02-13','18:46:00','194330','X',0,'2014-02-13 22:03:07',NULL,NULL),(4309,2847,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-06','18:51:00','245610','X',0,'2014-03-06 21:02:57',NULL,NULL),(59,4,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-10-11','18:01:00','7638','X',0,'2013-12-25 17:31:48',NULL,NULL),(948,59,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-12-11','18:36:00','64781','X',0,'2013-12-26 00:51:29',NULL,NULL),(1481,99,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-26','18:41:00','100571','X',0,'2013-12-27 02:07:47',NULL,NULL),(1573,383,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-29','18:10:00','107255','X',0,'2013-12-30 00:02:11',NULL,NULL),(1712,569,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-03','18:38:00','116011','X',0,'2014-01-04 02:04:51',NULL,NULL),(3716,2804,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-16','18:12:00','201510','X',0,'2014-02-16 19:00:39',NULL,NULL),(4031,2826,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-27','18:48:00','225925','X',0,'2014-02-28 06:31:24',NULL,NULL),(4432,2854,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-09','18:21:00','252852','X',0,'2014-03-09 21:30:07',NULL,NULL),(3778,2810,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-19','18:35:00','207791','X',0,'2014-02-20 04:05:19',NULL,NULL),(4265,2846,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-03-05','18:49:00','241599','X',0,'2014-03-05 21:32:34',NULL,NULL),(753,47,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-19','19:11:00','81739','X',0,'2013-12-25 23:10:08',NULL,NULL),(1078,68,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-14','18:21:00','71347','X',0,'2013-12-26 02:03:33',NULL,NULL),(1241,80,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-18','18:49:00','79071','X',0,'2013-12-26 04:06:37',NULL,NULL),(1295,82,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-21','18:37:00','86495','X',0,'2013-12-26 04:30:50',NULL,NULL),(1298,82,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-21','18:37:00','86498','X',0,'2013-12-26 04:33:30',NULL,NULL),(1588,385,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-30','19:01:00','109535','X',0,'2014-01-01 12:06:51',NULL,NULL),(2497,1556,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:48',NULL,NULL),(2819,2594,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:24:00','1','X',1,'2014-01-23 03:48:35',NULL,NULL),(3050,2758,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-26','18:09:00','156590','X',0,'2014-01-26 19:00:14',NULL,NULL),(3079,2759,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-27','18:27:00','158019','X',0,'2014-01-27 21:01:41',NULL,NULL),(3347,2783,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-06','18:26:00','175057','X',0,'2014-02-06 21:30:04',NULL,NULL),(3384,2786,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-08','18:12:00','180296','X',0,'2014-02-08 19:00:41',NULL,NULL),(3790,2810,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-19','18:35:00','207797','X',0,'2014-02-20 04:27:25',NULL,NULL),(4008,2825,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-26','18:43:00','223763','X',0,'2014-02-26 21:02:24',NULL,NULL),(4094,2830,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-28','19:12:00','229912','X',0,'2014-02-28 21:31:32',NULL,NULL),(902,54,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-10-02','18:00:00','5088','X',0,'2013-12-26 00:17:12',NULL,NULL),(1715,569,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-03','18:38:00','116014','X',0,'2014-01-04 02:05:33',NULL,NULL),(2168,1415,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:18',NULL,NULL),(2349,1475,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-08','18:27:00','125985','X',0,'2014-01-13 02:22:24',NULL,NULL),(3524,2794,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-11','18:37:00','187468','X',0,'2014-02-11 21:30:18',NULL,NULL),(3643,2799,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-14','18:39:00','196136','X',0,'2014-02-14 21:32:00',NULL,NULL),(3743,2807,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-18','18:25:00','203037','X',0,'2014-02-18 21:30:21',NULL,NULL),(4108,2830,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-02-28','19:12:00','229926','X',0,'2014-02-28 21:31:54',NULL,NULL),(4148,2833,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-02','18:16:00','233967','X',0,'2014-03-03 01:00:25',NULL,NULL),(4238,2845,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-05','18:46:00','240506','X',0,'2014-03-05 21:00:10',NULL,NULL),(4304,2847,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-06','18:51:00','245604','X',0,'2014-03-06 21:02:53',NULL,NULL),(4416,2853,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-03-09','18:20:00','252261','X',0,'2014-03-09 21:01:05',NULL,NULL),(268,19,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-24','18:40:00','96829','X',0,'2013-12-25 18:59:03',NULL,NULL),(282,20,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-20','18:06:00','32806','X',0,'2013-12-25 19:02:13',NULL,NULL),(2887,2662,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 04:35:25',NULL,NULL),(3010,2756,'005010X220A1','BE','FL0','99734','99734OH0050003','2014-01-24','18:26:00','154309','X',0,'2014-01-24 21:00:29',NULL,NULL),(3364,2784,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-07','18:14:00','177573','X',0,'2014-02-07 19:01:02',NULL,NULL),(3514,2793,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-11','18:41:00','189068','X',0,'2014-02-11 21:02:51',NULL,NULL),(3955,2822,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-23','18:11:00','215779','X',0,'2014-02-26 08:00:50',NULL,NULL),(1260,80,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-18','18:49:00','79090','X',0,'2013-12-26 04:09:41',NULL,NULL),(1925,1172,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:45',NULL,NULL),(2670,2551,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-17','18:23:00','142636','X',0,'2014-01-20 08:06:39',NULL,NULL),(183,13,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-03','18:20:00','49889','X',0,'2013-12-25 18:19:16',NULL,NULL),(408,27,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-22','18:02:00','12158','X',0,'2013-12-25 20:02:05',NULL,NULL),(1122,71,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-15','18:15:00','73613','X',0,'2013-12-26 02:33:22',NULL,NULL),(1878,1125,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:36',NULL,NULL),(2008,1255,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:11',NULL,NULL),(2759,2555,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-21','18:24:00','147894','X',1,'2014-01-22 03:23:09',NULL,NULL),(3105,2760,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-28','18:32:00','160256','X',0,'2014-01-28 21:01:16',NULL,NULL),(3376,2786,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-08','18:12:00','180288','X',0,'2014-02-08 19:00:03',NULL,NULL),(4428,2854,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-09','18:21:00','252848','X',0,'2014-03-09 21:30:00',NULL,NULL),(416,29,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-06','18:21:00','55526','X',0,'2013-12-25 20:17:44',NULL,NULL),(1419,93,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-24','01:56:00','90955','X',0,'2013-12-26 13:12:30',NULL,NULL),(1690,568,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-02','18:42:00','115214','X',0,'2014-01-03 02:06:36',NULL,NULL),(2176,1423,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:40',NULL,NULL),(3071,2759,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-27','18:27:00','158011','X',0,'2014-01-27 21:01:27',NULL,NULL),(4081,2829,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-28','19:08:00','228396','X',0,'2014-02-28 21:00:21',NULL,NULL),(4157,2833,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-02','18:16:00','233976','X',0,'2014-03-03 01:00:39',NULL,NULL),(4191,2836,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-03','18:33:00','236087','X',0,'2014-03-03 21:31:49',NULL,NULL),(351,22,'005010X220A1','BE','OH0','92036','92036OH0040008','2013-12-09','18:28:00','61521','X',0,'2013-12-25 19:37:46',NULL,NULL),(1176,75,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-20','19:06:00','84213','X',0,'2013-12-26 03:08:22',NULL,NULL),(1876,1123,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:50:30',NULL,NULL),(3380,2786,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-08','18:12:00','180292','X',0,'2014-02-08 19:00:26',NULL,NULL),(4091,2830,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-28','19:12:00','229909','X',0,'2014-02-28 21:31:03',NULL,NULL),(4207,2843,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-03-04','18:50:00','238754','X',0,'2014-03-04 21:02:00',NULL,NULL),(791,49,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-06','18:03:00','20434','X',0,'2013-12-25 23:16:59',NULL,NULL),(2244,1468,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-06','18:24:00','121990','X',0,'2014-01-07 04:06:28',NULL,NULL),(2408,1478,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-12','18:13:00','132592','X',0,'2014-01-13 03:01:48',NULL,NULL),(313,21,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-10','18:21:00','62762','X',0,'2013-12-25 19:20:29',NULL,NULL),(606,39,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-17','18:43:00','78055','X',0,'2013-12-25 21:53:15',NULL,NULL),(1466,99,'005010X220A1','BE','OH0','92036','92036OH0050027','2013-12-26','18:41:00','100556','X',0,'2013-12-27 02:06:43',NULL,NULL),(1578,383,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-29','18:10:00','107260','X',0,'2013-12-30 00:02:24',NULL,NULL),(2306,1473,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-11','18:16:00','130863','X',0,'2014-01-13 02:18:39',NULL,NULL),(2696,2553,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-19','18:08:00','145203','X',0,'2014-01-21 08:45:17',NULL,NULL),(3261,2778,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-04','18:29:00','172103','X',0,'2014-02-04 21:00:28',NULL,NULL),(3409,2789,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-09','18:11:00','181280','X',0,'2014-02-09 19:00:29',NULL,NULL),(3438,2790,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-10','05:02:00','183711','X',0,'2014-02-10 11:01:11',NULL,NULL),(3840,2814,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-20','18:28:00','208907','X',0,'2014-02-20 22:00:03',NULL,NULL),(3994,2825,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-26','18:43:00','223749','X',0,'2014-02-26 21:00:11',NULL,NULL),(4222,2843,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-03-04','18:50:00','238769','X',0,'2014-03-04 21:02:40',NULL,NULL),(908,55,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-23','18:01:00','12601','X',0,'2013-12-26 00:30:30',NULL,NULL),(1405,92,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-24','01:56:00','90942','X',0,'2013-12-26 13:05:17',NULL,NULL),(3078,2759,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-27','18:27:00','158018','X',0,'2014-01-27 21:01:40',NULL,NULL),(3179,2774,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-01-31','18:37:00','165921','X',0,'2014-01-31 21:01:08',NULL,NULL),(3805,2810,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-19','18:35:00','207802','X',0,'2014-02-20 04:52:17',NULL,NULL),(4112,2830,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-28','19:12:00','229930','X',0,'2014-02-28 21:31:57',NULL,NULL),(162,9,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-11','18:02:00','23536','X',0,'2013-12-25 18:10:50',NULL,NULL),(544,38,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-13','18:39:00','69270','X',0,'2013-12-25 21:33:50',NULL,NULL),(1050,67,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-25','18:35:00','98932','X',0,'2013-12-26 01:51:18',NULL,NULL),(2030,1277,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:13',NULL,NULL),(3257,2778,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-04','18:29:00','172099','X',0,'2014-02-04 21:00:03',NULL,NULL),(3388,2786,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-08','18:12:00','180300','X',0,'2014-02-08 19:00:57',NULL,NULL),(3699,2802,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-15','18:48:00','199891','X',0,'2014-02-15 22:02:09',NULL,NULL),(4423,2853,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-03-09','18:20:00','252268','X',0,'2014-03-09 21:01:17',NULL,NULL),(1486,99,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-26','18:41:00','100576','X',0,'2013-12-27 02:08:02',NULL,NULL),(2261,1469,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-05','18:09:00','119795','X',1,'2014-01-07 10:22:47',NULL,NULL),(4070,2828,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-27','18:43:00','224654','X',0,'2014-02-28 07:30:29',NULL,NULL),(646,40,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-12','18:53:00','67266','X',0,'2013-12-25 22:09:16',NULL,NULL),(733,47,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-19','19:11:00','81719','X',0,'2013-12-25 23:02:25',NULL,NULL),(1032,65,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-05','18:01:00','5897','X',0,'2013-12-26 01:31:23',NULL,NULL),(1299,82,'005010X220A1','BE','OH0','92036','92036OH0040027','2013-12-21','18:37:00','86499','X',0,'2013-12-26 04:33:39',NULL,NULL),(2066,1313,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:00:53',NULL,NULL),(2612,2539,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-01-15','18:30:00','138474','X',0,'2014-01-16 08:47:19',NULL,NULL),(2731,2554,'005010X220A1','BE','IN0','92036','92036OH0020015','2014-01-20','18:21:00','146910','X',0,'2014-01-21 08:46:57',NULL,NULL),(2811,2586,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:17:00','1','X',1,'2014-01-23 03:45:53',NULL,NULL),(3009,2756,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-24','18:26:00','154289','X',0,'2014-01-24 21:00:29',NULL,NULL),(3641,2799,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-14','18:39:00','196134','X',0,'2014-02-14 21:31:56',NULL,NULL),(4151,2833,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-02','18:16:00','233970','X',0,'2014-03-03 01:00:32',NULL,NULL),(467,31,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-11-18','18:07:00','30662','X',0,'2013-12-25 20:32:06',NULL,NULL),(1028,64,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-11-14','18:05:00','25964','X',0,'2013-12-26 01:31:08',NULL,NULL),(1085,68,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-14','18:21:00','71354','X',0,'2013-12-26 02:04:09',NULL,NULL),(1557,382,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-28','21:04:00','105813','X',1,'2013-12-29 11:15:21',NULL,NULL),(3165,2773,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-30','18:35:00','164086','X',0,'2014-01-30 21:01:36',NULL,NULL),(3248,2777,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-03','18:32:00','170210','X',0,'2014-02-03 21:01:25',NULL,NULL),(3775,2809,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-19','18:35:00','207790','X',0,'2014-02-20 04:02:00',NULL,NULL),(4396,2852,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-03-08','18:43:00','250668','X',0,'2014-03-08 21:31:16',NULL,NULL),(19,1,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-05','18:31:00','54194','X',0,'2013-12-25 17:21:13',NULL,NULL),(278,20,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-20','18:06:00','32802','X',0,'2013-12-25 19:00:33',NULL,NULL),(566,38,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-12-13','18:39:00','69292','X',0,'2013-12-25 21:38:41',NULL,NULL),(1493,380,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-27','18:44:00','101817','X',0,'2013-12-28 03:34:33',NULL,NULL),(2452,1511,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:41',NULL,NULL),(2456,1515,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:07',NULL,NULL),(3244,2777,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-03','18:32:00','170206','X',0,'2014-02-03 21:01:17',NULL,NULL),(995,62,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-11-05','18:03:00','19340','X',0,'2013-12-26 01:02:05',NULL,NULL),(1347,84,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-21','18:04:00','11689','X',0,'2013-12-26 05:01:02',NULL,NULL),(1636,387,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-31','18:52:00','111675','X',1,'2014-01-02 04:28:41',NULL,NULL),(2033,1280,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:21',NULL,NULL),(2419,1478,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-12','18:13:00','132603','X',0,'2014-01-13 03:02:00',NULL,NULL),(3268,2778,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-04','18:29:00','172110','X',0,'2014-02-04 21:01:21',NULL,NULL),(3753,2808,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-18','18:28:00','204267','X',0,'2014-02-18 22:01:10',NULL,NULL),(33,1,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-05','18:31:00','54208','X',0,'2013-12-25 17:22:03',NULL,NULL),(60,5,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-09','18:02:00','22407','X',0,'2013-12-25 17:31:51',NULL,NULL),(251,19,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-12-24','18:40:00','96812','X',0,'2013-12-25 18:54:58',NULL,NULL),(502,37,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-22','18:40:00','88455','X',0,'2013-12-25 21:16:23',NULL,NULL),(947,59,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-12-11','18:36:00','64780','X',0,'2013-12-26 00:51:23',NULL,NULL),(1306,82,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-21','18:37:00','86511','X',0,'2013-12-26 04:37:50',NULL,NULL),(1449,93,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-24','01:56:00','90987','X',0,'2013-12-26 13:16:58',NULL,NULL),(1967,1214,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:42',NULL,NULL),(2103,1350,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','11:30:00','1','X',0,'2014-01-05 17:02:36',NULL,NULL),(2119,1366,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 17:23:02',NULL,NULL),(2402,1478,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-01-12','18:13:00','132586','X',0,'2014-01-13 03:01:25',NULL,NULL),(2600,2539,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-15','18:30:00','138462','X',0,'2014-01-16 08:46:56',NULL,NULL),(3005,2755,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-23','18:27:00','151601','X',0,'2014-01-23 21:01:46',NULL,NULL),(3124,2772,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-29','18:30:00','161346','X',0,'2014-01-29 21:01:28',NULL,NULL),(3260,2778,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-04','18:29:00','172102','X',0,'2014-02-04 21:00:25',NULL,NULL),(3476,2792,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-10','18:30:00','186462','X',0,'2014-02-10 21:32:10',NULL,NULL),(3900,2818,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-25','18:33:00','219096','X',0,'2014-02-25 21:00:31',NULL,NULL),(944,59,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-11','18:36:00','64777','X',0,'2013-12-26 00:50:55',NULL,NULL),(1620,386,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-01','18:18:00','112805','X',1,'2014-01-02 04:23:23',NULL,NULL),(1672,568,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-02','18:42:00','115196','X',0,'2014-01-03 02:02:13',NULL,NULL),(2284,1471,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-07','18:29:00','123282','X',0,'2014-01-08 18:25:01',NULL,NULL),(2850,2625,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:06:00','1','X',1,'2014-01-23 04:08:58',NULL,NULL),(3645,2799,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-14','18:39:00','196138','X',0,'2014-02-14 21:32:08',NULL,NULL),(4389,2852,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-08','18:43:00','250661','X',0,'2014-03-08 21:30:59',NULL,NULL),(170,11,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-24','18:01:00','12907','X',0,'2013-12-25 18:11:12',NULL,NULL),(196,13,'005010X220A1','BE','OH0','92036','92036OH0050012','2013-12-03','18:20:00','49902','X',0,'2013-12-25 18:21:15',NULL,NULL),(512,37,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-22','18:40:00','88473','X',0,'2013-12-25 21:21:57',NULL,NULL),(2123,1370,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:13',NULL,NULL),(2218,1465,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:37',NULL,NULL),(3408,2789,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-09','18:11:00','181283','X',0,'2014-02-09 19:00:26',NULL,NULL),(3756,2808,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-18','18:28:00','204270','X',0,'2014-02-18 22:01:21',NULL,NULL),(3834,2813,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-20','18:26:00','208220','X',0,'2014-02-20 21:30:14',NULL,NULL),(325,22,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-09','18:28:00','61495','X',0,'2013-12-25 19:31:09',NULL,NULL),(1460,99,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-26','18:41:00','100550','X',0,'2013-12-27 02:05:33',NULL,NULL),(1553,382,'005010X220A1','BE','OH0','92036','92036OH0030012','2013-12-28','21:04:00','105809','X',1,'2013-12-29 11:15:01',NULL,NULL),(2786,2561,'005010X231A1','FA','OH0','99734','99734OH0050003','2014-01-13','22:20:00','1','X',0,'2014-01-23 03:39:35',NULL,NULL),(3305,2781,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-05','18:39:00','174415','X',0,'2014-02-05 21:31:08',NULL,NULL),(4377,2851,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-08','18:41:00','249542','X',0,'2014-03-08 21:00:01',NULL,NULL),(1145,72,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-11-17','18:03:00','29574','X',0,'2013-12-26 02:46:01',NULL,NULL),(1521,381,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-28','18:14:00','103713','X',1,'2013-12-29 11:09:07',NULL,NULL),(1989,1236,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:18',NULL,NULL),(2035,1282,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:27',NULL,NULL),(2269,1469,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-05','18:09:00','119803','X',1,'2014-01-07 10:23:32',NULL,NULL),(2527,1576,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-13','18:44:00','134003','X',0,'2014-01-14 01:33:28',NULL,NULL),(2636,2540,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-16','18:41:00','141412','X',0,'2014-01-17 03:36:30',NULL,NULL),(2937,2712,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:06:00','1','X',0,'2014-01-23 06:47:42',NULL,NULL),(3732,2806,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-02-17','18:05:00','202230','X',0,'2014-02-17 19:00:17',NULL,NULL),(4450,2855,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-10','19:23:00','255925','X',0,'2014-03-10 21:02:21',NULL,NULL),(982,61,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-16','18:03:00','28396','X',0,'2013-12-26 01:01:11',NULL,NULL),(1210,76,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-22','18:08:00','35664','X',0,'2013-12-26 03:16:09',NULL,NULL),(1727,569,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-03','18:38:00','116026','X',0,'2014-01-04 02:06:17',NULL,NULL),(2618,2539,'005010X220A1','BE','OH0','92036','92036OH0030008','2014-01-15','18:30:00','138480','X',0,'2014-01-16 08:47:28',NULL,NULL),(3333,2782,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-02-06','18:28:00','175990','X',0,'2014-02-06 21:01:35',NULL,NULL),(3970,2823,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-02-22','18:14:00','213814','X',0,'2014-02-26 08:30:56',NULL,NULL),(4006,2825,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-26','18:43:00','223761','X',0,'2014-02-26 21:02:17',NULL,NULL),(4155,2833,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-03-02','18:16:00','233974','X',0,'2014-03-03 01:00:37',NULL,NULL),(625,40,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-12','18:53:00','67245','X',0,'2013-12-25 22:05:49',NULL,NULL),(1665,387,'005010X220A1','BE','OH0','92036','92036OH0050008','2013-12-31','18:52:00','111704','X',1,'2014-01-02 04:36:01',NULL,NULL),(1877,1124,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','18:10:00','1','X',0,'2014-01-05 16:50:33',NULL,NULL),(2592,2539,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-15','18:30:00','138454','X',0,'2014-01-16 08:46:17',NULL,NULL),(2781,2556,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-22','18:31:00','150822','X',0,'2014-01-23 03:02:54',NULL,NULL),(3201,2775,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-01','18:14:00','166670','X',0,'2014-02-01 19:00:22',NULL,NULL),(3239,2777,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-02-03','18:32:00','170201','X',0,'2014-02-03 21:00:52',NULL,NULL),(3460,2792,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-10','18:30:00','186446','X',0,'2014-02-10 21:31:24',NULL,NULL),(3497,2793,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-11','18:41:00','189051','X',0,'2014-02-11 21:02:22',NULL,NULL),(3918,2819,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-02-25','18:36:00','220690','X',0,'2014-02-25 21:31:50',NULL,NULL),(3966,2823,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-22','18:14:00','213809','X',0,'2014-02-26 08:30:52',NULL,NULL),(1958,1205,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:54:17',NULL,NULL),(2234,1468,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-06','18:24:00','121980','X',0,'2014-01-07 04:05:05',NULL,NULL),(2516,1576,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-01-13','18:44:00','133992','X',0,'2014-01-14 01:32:10',NULL,NULL),(4271,2846,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-03-05','18:49:00','241605','X',0,'2014-03-05 21:32:41',NULL,NULL),(4340,2850,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-03-07','18:46:00','247655','X',0,'2014-03-07 21:30:34',NULL,NULL),(72,6,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-04','18:22:00','52120','X',0,'2013-12-25 17:45:55',NULL,NULL),(322,21,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-10','18:21:00','62771','X',0,'2013-12-25 19:21:07',NULL,NULL),(556,38,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-13','18:39:00','69282','X',0,'2013-12-25 21:37:35',NULL,NULL),(1537,382,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-28','21:04:00','105793','X',1,'2013-12-29 11:12:34',NULL,NULL),(1556,382,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-28','21:04:00','105812','X',1,'2013-12-29 11:15:18',NULL,NULL),(2225,1468,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-06','18:24:00','121971','X',0,'2014-01-07 04:02:58',NULL,NULL),(2674,2551,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-17','18:23:00','142640','X',0,'2014-01-20 08:06:46',NULL,NULL),(2779,2556,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-01-22','18:31:00','150820','X',0,'2014-01-23 03:02:53',NULL,NULL),(2829,2604,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:16:00','1','X',1,'2014-01-23 03:52:37',NULL,NULL),(3058,2758,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-26','18:09:00','156598','X',0,'2014-01-26 19:00:29',NULL,NULL),(3073,2759,'005010X220A1','BE','OH0','92036','92036OH0020015','2014-01-27','18:27:00','158013','X',0,'2014-01-27 21:01:33',NULL,NULL),(4123,2832,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-03-01','18:23:00','232010','X',0,'2014-03-01 21:00:17',NULL,NULL),(236,18,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-09','18:01:00','7051','X',0,'2013-12-25 18:32:23',NULL,NULL),(964,59,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-11','18:36:00','64797','X',0,'2013-12-26 00:54:00',NULL,NULL),(1292,81,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-11-30','18:04:00','44832','X',0,'2013-12-26 04:16:24',NULL,NULL),(2038,1285,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:35',NULL,NULL),(2088,1335,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:54',NULL,NULL),(4328,2849,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-07','18:42:00','246114','X',0,'2014-03-07 21:00:25',NULL,NULL),(102,7,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-16','18:37:00','74915','X',0,'2013-12-25 18:00:02',NULL,NULL),(344,22,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-09','18:28:00','61514','X',0,'2013-12-25 19:37:27',NULL,NULL),(611,39,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-17','18:43:00','78060','X',0,'2013-12-25 21:53:37',NULL,NULL),(1516,381,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-28','18:14:00','103708','X',1,'2013-12-29 11:07:22',NULL,NULL),(2590,2539,'005010X220A1','BE','OH0','92036','92036OH0060005','2014-01-15','18:30:00','138452','X',0,'2014-01-16 08:46:06',NULL,NULL),(3051,2758,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-26','18:09:00','156591','X',0,'2014-01-26 19:00:20',NULL,NULL),(147,8,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-10-31','18:04:00','15472','X',0,'2013-12-25 18:09:57',NULL,NULL),(347,22,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-09','18:28:00','61517','X',0,'2013-12-25 19:37:36',NULL,NULL),(654,41,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-08','18:10:00','59411','X',0,'2013-12-25 22:15:01',NULL,NULL),(781,48,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-11-27','18:05:00','41581','X',0,'2013-12-25 23:16:17',NULL,NULL),(1106,70,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-10-28','18:08:00','14561','X',0,'2013-12-26 02:17:06',NULL,NULL),(1200,75,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-20','19:06:00','84238','X',0,'2013-12-26 03:11:01',NULL,NULL),(1550,382,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-28','21:04:00','105806','X',1,'2013-12-29 11:14:54',NULL,NULL),(2037,1284,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:32',NULL,NULL),(2122,1369,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:10',NULL,NULL),(2317,1474,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-01-09','18:28:00','127857','X',0,'2014-01-13 02:20:03',NULL,NULL),(1173,75,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-20','19:06:00','84210','X',0,'2013-12-26 03:07:18',NULL,NULL),(1414,93,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-24','01:56:00','90950','X',0,'2013-12-26 13:10:59',NULL,NULL),(1431,93,'005010X220A1','BE','OH0','92036','92036OH0020027','2013-12-24','01:56:00','90967','X',0,'2013-12-26 13:15:20',NULL,NULL),(1724,569,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-03','18:38:00','116023','X',0,'2014-01-04 02:06:07',NULL,NULL),(2432,1491,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:23',NULL,NULL),(2515,1576,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-13','18:44:00','133991','X',0,'2014-01-14 01:31:57',NULL,NULL),(3273,2778,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-04','18:29:00','172115','X',0,'2014-02-04 21:01:39',NULL,NULL),(3538,2796,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-12','18:31:00','191446','X',0,'2014-02-12 21:30:21',NULL,NULL),(3795,2810,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-19','18:35:00','207799','X',0,'2014-02-20 04:32:46',NULL,NULL),(3859,2814,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-20','18:28:00','208926','X',0,'2014-02-20 22:01:40',NULL,NULL),(3937,2820,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-23','18:10:00','215483','X',0,'2014-02-26 08:00:25',NULL,NULL),(659,41,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-08','18:10:00','59416','X',0,'2013-12-25 22:16:04',NULL,NULL),(1702,569,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-03','18:38:00','116001','X',0,'2014-01-04 02:00:02',NULL,NULL),(2266,1469,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-05','18:09:00','119800','X',1,'2014-01-07 10:23:17',NULL,NULL),(2467,1526,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:19',NULL,NULL),(3035,2757,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-25','18:11:00','155336','X',0,'2014-01-25 19:00:04',NULL,NULL),(3084,2759,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-27','18:27:00','158024','X',0,'2014-01-27 21:01:47',NULL,NULL),(3857,2814,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-02-20','18:28:00','208924','X',0,'2014-02-20 22:01:37',NULL,NULL),(3942,2820,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-02-23','18:10:00','215488','X',0,'2014-02-26 08:00:30',NULL,NULL),(171,11,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-24','18:01:00','12908','X',0,'2013-12-25 18:11:14',NULL,NULL),(738,47,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-19','19:11:00','81724','X',0,'2013-12-25 23:06:33',NULL,NULL),(764,47,'005010X220A1','BE','OH0','92036','92036OH0020005','2013-12-19','19:11:00','81750','X',0,'2013-12-25 23:11:08',NULL,NULL),(784,48,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-11-27','18:05:00','41584','X',0,'2013-12-25 23:16:24',NULL,NULL),(994,62,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-05','18:03:00','19337','X',0,'2013-12-26 01:02:01',NULL,NULL),(3217,2776,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-02-02','18:10:00','168366','X',0,'2014-02-02 19:00:06',NULL,NULL),(3233,2777,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-03','18:32:00','170195','X',0,'2014-02-03 21:00:03',NULL,NULL),(3842,2814,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-20','18:28:00','208909','X',0,'2014-02-20 22:00:22',NULL,NULL),(3876,2816,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-21','18:31:00','212804','X',0,'2014-02-21 22:00:55',NULL,NULL),(3896,2818,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-25','18:33:00','219092','X',0,'2014-02-25 21:00:23',NULL,NULL),(235,17,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-11-07','18:02:00','20911','X',0,'2013-12-25 18:32:20',NULL,NULL),(573,38,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-13','18:39:00','69299','X',0,'2013-12-25 21:39:06',NULL,NULL),(1517,381,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-28','18:14:00','103709','X',1,'2013-12-29 11:07:34',NULL,NULL),(1968,1215,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:44',NULL,NULL),(2085,1332,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:01:46',NULL,NULL),(2333,1474,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-09','18:28:00','127873','X',0,'2014-01-13 02:20:58',NULL,NULL),(2352,1475,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-08','18:27:00','125988','X',0,'2014-01-13 02:22:30',NULL,NULL),(4098,2830,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-28','19:12:00','229916','X',0,'2014-02-28 21:31:39',NULL,NULL),(4398,2852,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-08','18:43:00','250670','X',0,'2014-03-08 21:31:19',NULL,NULL),(4465,2855,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-03-10','19:23:00','255940','X',0,'2014-03-10 21:02:54',NULL,NULL),(382,23,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-02','18:14:00','47698','X',0,'2013-12-25 19:50:19',NULL,NULL),(465,31,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-11-18','18:07:00','30656','X',0,'2013-12-25 20:32:02',NULL,NULL),(926,57,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-19','18:07:00','31312','X',0,'2013-12-26 00:32:00',NULL,NULL),(1489,380,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-27','18:44:00','101813','X',0,'2013-12-28 03:31:21',NULL,NULL),(1492,380,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-27','18:44:00','101816','X',0,'2013-12-28 03:32:54',NULL,NULL),(1622,386,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-01','18:18:00','112807','X',1,'2014-01-02 04:24:04',NULL,NULL),(2728,2554,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-20','18:21:00','146907','X',0,'2014-01-21 08:46:55',NULL,NULL),(2793,2568,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:41:26',NULL,NULL),(2904,2679,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:47:00','1','X',1,'2014-01-23 05:02:45',NULL,NULL),(4140,2832,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-01','18:23:00','232027','X',0,'2014-03-01 21:01:11',NULL,NULL),(2222,1468,'005010X220A1','BE','NJ0','18575','18575LA0020002','2014-01-06','18:24:00','121994','X',0,'2014-01-07 04:00:56',NULL,NULL),(2501,1560,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:51',NULL,NULL),(2673,2551,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-17','18:23:00','142639','X',0,'2014-01-20 08:06:45',NULL,NULL),(3049,2758,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-26','18:09:00','156589','X',0,'2014-01-26 19:00:09',NULL,NULL),(3164,2773,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-30','18:35:00','164085','X',0,'2014-01-30 21:01:35',NULL,NULL),(3813,2811,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-19','18:35:00','207806','X',0,'2014-02-20 04:55:32',NULL,NULL),(3838,2813,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-20','18:26:00','208224','X',0,'2014-02-20 21:30:22',NULL,NULL),(115,7,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-16','18:37:00','74928','X',0,'2013-12-25 18:06:49',NULL,NULL),(400,26,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-02','18:03:00','17174','X',0,'2013-12-25 20:01:16',NULL,NULL),(777,48,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-27','18:05:00','41577','X',0,'2013-12-25 23:16:01',NULL,NULL),(1261,80,'005010X220A1','BE','OH0','92036','92036OH0020032','2013-12-18','18:49:00','79091','X',0,'2013-12-26 04:09:42',NULL,NULL),(2166,1413,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:25:13',NULL,NULL),(2797,2572,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:28:00','1','X',1,'2014-01-23 03:41:55',NULL,NULL),(3002,2755,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-23','18:27:00','151598','X',0,'2014-01-23 21:01:38',NULL,NULL),(690,43,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-10','18:01:00','7176','X',0,'2013-12-25 22:30:56',NULL,NULL),(1315,82,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-21','18:37:00','86527','X',0,'2013-12-26 04:39:05',NULL,NULL),(3673,2802,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-15','18:48:00','199864','X',0,'2014-02-15 22:00:30',NULL,NULL),(3976,2824,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-24','18:21:00','218488','X',0,'2014-02-26 09:30:12',NULL,NULL),(4049,2826,'005010X220A1','BE','OH0','92036','92036OH0020008','2014-02-27','18:48:00','225943','X',0,'2014-02-28 06:31:47',NULL,NULL),(4360,2850,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-03-07','18:46:00','247675','X',0,'2014-03-07 21:32:08',NULL,NULL),(564,38,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-13','18:39:00','69290','X',0,'2013-12-25 21:38:15',NULL,NULL),(835,51,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-24','03:40:00','94574','X',0,'2013-12-25 23:50:54',NULL,NULL),(1098,69,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-11-23','18:05:00','36688','X',0,'2013-12-26 02:16:25',NULL,NULL),(2135,1382,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:46',NULL,NULL),(2361,1475,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-01-08','18:27:00','125997','X',0,'2014-01-13 02:22:47',NULL,NULL),(2803,2578,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 03:43:43',NULL,NULL),(3129,2772,'005010X220A1','BE','OH0','92036','92036OH0010006','2014-01-29','18:30:00','161351','X',0,'2014-01-29 21:01:41',NULL,NULL),(3586,2798,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-13','18:46:00','194309','X',0,'2014-02-13 22:02:00',NULL,NULL),(3639,2799,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-14','18:39:00','196132','X',0,'2014-02-14 21:31:52',NULL,NULL),(3953,2821,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-24','18:19:00','217105','X',0,'2014-02-26 08:00:47',NULL,NULL),(3998,2825,'005010X220A1','BE','FL0','33348','33348TX0020002','2014-02-26','18:43:00','223775','X',0,'2014-02-26 21:00:57',NULL,NULL),(4160,2833,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-02','18:16:00','233979','X',0,'2014-03-03 01:00:41',NULL,NULL),(4194,2836,'005010X220A1','BE','OH0','92036','92036OH0020006','2014-03-03','18:33:00','236090','X',0,'2014-03-03 21:31:54',NULL,NULL),(524,37,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-22','18:40:00','88485','X',0,'2013-12-25 21:23:04',NULL,NULL),(1015,63,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-11-25','18:07:00','38453','X',0,'2013-12-26 01:17:18',NULL,NULL),(1320,82,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-21','18:37:00','86537','X',0,'2013-12-26 04:39:35',NULL,NULL),(2528,1576,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-13','18:44:00','134004','X',0,'2014-01-14 01:33:31',NULL,NULL),(3587,2798,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-13','18:46:00','194310','X',0,'2014-02-13 22:02:01',NULL,NULL),(3662,2800,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-14','18:36:00','195040','X',0,'2014-02-14 22:00:07',NULL,NULL),(3759,2808,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-02-18','18:28:00','204273','X',0,'2014-02-18 22:01:26',NULL,NULL),(4089,2830,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-28','19:12:00','229907','X',0,'2014-02-28 21:30:34',NULL,NULL),(144,8,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-31','18:04:00','15469','X',0,'2013-12-25 18:08:52',NULL,NULL),(339,22,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-09','18:28:00','61509','X',0,'2013-12-25 19:36:53',NULL,NULL),(1080,68,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-14','18:21:00','71349','X',0,'2013-12-26 02:03:42',NULL,NULL),(1445,93,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-24','01:56:00','90983','X',0,'2013-12-26 13:16:43',NULL,NULL),(3519,2794,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-11','18:37:00','187463','X',0,'2014-02-11 21:30:05',NULL,NULL),(4301,2847,'005010X220A1','BE','OH0','92036','92036OH0050008','2014-03-06','18:51:00','245601','X',0,'2014-03-06 21:02:50',NULL,NULL),(783,48,'005010X220A1','BE','OH0','92036','92036OH0060006','2013-11-27','18:05:00','41583','X',0,'2013-12-25 23:16:22',NULL,NULL),(1024,64,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-14','18:05:00','25960','X',0,'2013-12-26 01:30:36',NULL,NULL),(1108,70,'005010X220A1','BE','OH0','92036','92036OH0010032','2013-10-28','18:08:00','14566','X',0,'2013-12-26 02:17:11',NULL,NULL),(1894,1141,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:20',NULL,NULL),(2204,1451,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:58',NULL,NULL),(2354,1475,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-01-08','18:27:00','125990','X',0,'2014-01-13 02:22:35',NULL,NULL),(2460,1519,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:10',NULL,NULL),(2589,2539,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-01-15','18:30:00','138451','X',0,'2014-01-16 08:46:05',NULL,NULL),(2889,2664,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:18:00','1','X',1,'2014-01-23 04:45:36',NULL,NULL),(376,23,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-02','18:14:00','47692','X',0,'2013-12-25 19:49:48',NULL,NULL),(387,24,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-10-15','18:01:00','9470','X',0,'2013-12-25 20:00:04',NULL,NULL),(413,29,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-06','18:21:00','55523','X',0,'2013-12-25 20:15:23',NULL,NULL),(596,39,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-17','18:43:00','78045','X',0,'2013-12-25 21:52:33',NULL,NULL),(1238,80,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-18','18:49:00','79068','X',0,'2013-12-26 04:05:09',NULL,NULL),(1678,568,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-02','18:42:00','115202','X',0,'2014-01-03 02:05:16',NULL,NULL),(1920,1167,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:31',NULL,NULL),(3544,2796,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-12','18:31:00','191452','X',0,'2014-02-12 21:31:41',NULL,NULL),(3628,2799,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-02-14','18:39:00','196121','X',0,'2014-02-14 21:31:19',NULL,NULL),(4404,2853,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-09','18:20:00','252249','X',0,'2014-03-09 21:00:13',NULL,NULL),(26,1,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-12-05','18:31:00','54201','X',0,'2013-12-25 17:21:44',NULL,NULL),(70,6,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-04','18:22:00','52118','X',0,'2013-12-25 17:45:07',NULL,NULL),(1012,63,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-11-25','18:07:00','38450','X',0,'2013-12-26 01:17:09',NULL,NULL),(1091,69,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-23','18:05:00','36681','X',0,'2013-12-26 02:15:28',NULL,NULL),(1297,82,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-21','18:37:00','86497','X',0,'2013-12-26 04:33:24',NULL,NULL),(1976,1223,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:55:07',NULL,NULL),(2555,2311,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-14','19:00:00','136112','X',0,'2014-01-15 02:07:12',NULL,NULL),(2560,2311,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-01-14','19:00:00','136117','X',0,'2014-01-15 02:07:42',NULL,NULL),(3308,2781,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-05','18:39:00','174418','X',0,'2014-02-05 21:31:13',NULL,NULL),(3373,2784,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-02-07','18:14:00','177582','X',0,'2014-02-07 19:01:10',NULL,NULL),(262,19,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-24','18:40:00','96823','X',0,'2013-12-25 18:58:40',NULL,NULL),(580,39,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-17','18:43:00','78029','X',0,'2013-12-25 21:47:17',NULL,NULL),(747,47,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-19','19:11:00','81733','X',0,'2013-12-25 23:09:12',NULL,NULL),(1128,71,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-15','18:15:00','73619','X',0,'2013-12-26 02:33:47',NULL,NULL),(2477,1536,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:03:29',NULL,NULL),(2563,2311,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-14','19:00:00','136120','X',0,'2014-01-15 02:07:51',NULL,NULL),(2569,2311,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-14','19:00:00','136126','X',0,'2014-01-15 02:08:00',NULL,NULL),(2594,2539,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-15','18:30:00','138456','X',0,'2014-01-16 08:46:35',NULL,NULL),(3068,2759,'005010X220A1','BE','OH0','92036','92036OH0010008','2014-01-27','18:27:00','158008','X',0,'2014-01-27 21:01:22',NULL,NULL),(3167,2773,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-30','18:35:00','164088','X',0,'2014-01-30 21:01:38',NULL,NULL),(3291,2781,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-05','18:39:00','174401','X',0,'2014-02-05 21:30:03',NULL,NULL),(3582,2798,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-13','18:46:00','194305','X',0,'2014-02-13 22:00:50',NULL,NULL),(3740,2807,'005010X220A1','BE','OH0','92036','92036OH0040006','2014-02-18','18:25:00','203034','X',0,'2014-02-18 21:30:16',NULL,NULL),(61,5,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-09','18:02:00','22408','X',0,'2013-12-25 17:32:05',NULL,NULL),(403,26,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-02','18:03:00','17175','X',0,'2013-12-25 20:01:32',NULL,NULL),(445,29,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-12-06','18:21:00','55555','X',0,'2013-12-25 20:20:31',NULL,NULL),(1331,83,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-15','18:34:00','27227','X',0,'2013-12-26 04:45:10',NULL,NULL),(4272,2846,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-05','18:49:00','241606','X',0,'2014-03-05 21:32:42',NULL,NULL),(731,47,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-19','19:11:00','81717','X',0,'2013-12-25 23:00:02',NULL,NULL),(1054,67,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-25','18:35:00','98936','X',0,'2013-12-26 01:52:11',NULL,NULL),(1728,569,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-01-03','18:38:00','116027','X',0,'2014-01-04 02:06:20',NULL,NULL),(2450,1509,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:40',NULL,NULL),(2875,2650,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:04:00','1','X',1,'2014-01-23 04:25:12',NULL,NULL),(2922,2697,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',0,'2014-01-23 06:39:43',NULL,NULL),(3875,2816,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-21','18:31:00','212803','X',0,'2014-02-21 22:00:49',NULL,NULL),(4132,2832,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-01','18:23:00','232019','X',0,'2014-03-01 21:00:56',NULL,NULL),(4212,2843,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-04','18:50:00','238759','X',0,'2014-03-04 21:02:14',NULL,NULL),(4228,2843,'005010X220A1','BE','OH0','52664','52664OH1520010','2014-03-04','18:50:00','238775','X',0,'2014-03-04 21:02:46',NULL,NULL),(9,1,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-05','18:31:00','54184','X',0,'2013-12-25 17:19:13',NULL,NULL),(590,39,'005010X220A1','BE','OH0','92036','92036OH0010006','2013-12-17','18:43:00','78039','X',0,'2013-12-25 21:51:46',NULL,NULL),(905,55,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-23','18:01:00','12598','X',0,'2013-12-26 00:30:10',NULL,NULL),(971,60,'005010X220A1','BE','OH0','92036','92036OH0020012','2013-11-12','18:03:00','24203','X',0,'2013-12-26 01:00:11',NULL,NULL),(1560,383,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-29','18:10:00','107242','X',0,'2013-12-30 00:00:02',NULL,NULL),(4172,2835,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-03','18:31:00','234707','X',0,'2014-03-03 21:00:25',NULL,NULL),(4195,2836,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-03-03','18:33:00','236091','X',0,'2014-03-03 21:31:56',NULL,NULL),(4353,2850,'005010X220A1','BE','OH0','92036','92036OH0050027','2014-03-07','18:46:00','247668','X',0,'2014-03-07 21:32:01',NULL,NULL),(570,38,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-13','18:39:00','69296','X',0,'2013-12-25 21:38:57',NULL,NULL),(810,50,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-11-26','18:20:00','40535','X',0,'2013-12-25 23:32:13',NULL,NULL),(1970,1217,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:50',NULL,NULL),(2320,1474,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-09','18:28:00','127860','X',0,'2014-01-13 02:20:20',NULL,NULL),(2371,1476,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-01-10','18:26:00','129728','X',0,'2014-01-13 02:24:07',NULL,NULL),(2722,2554,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-20','18:21:00','146901','X',0,'2014-01-21 08:46:44',NULL,NULL),(3004,2755,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-23','18:27:00','151600','X',0,'2014-01-23 21:01:45',NULL,NULL),(4234,2844,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-03-04','18:46:00','237495','X',0,'2014-03-04 21:30:21',NULL,NULL),(4274,2846,'005010X220A1','BE','MS0','46300','46300MS0010001','2014-03-05','18:49:00','241608','X',0,'2014-03-05 21:32:44',NULL,NULL),(4475,2856,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-10','19:17:00','254162','X',0,'2014-03-10 21:30:05',NULL,NULL),(125,7,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-16','18:37:00','74938','X',0,'2013-12-25 18:07:46',NULL,NULL),(504,37,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-22','18:40:00','88458','X',0,'2013-12-25 21:18:45',NULL,NULL),(1053,67,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-25','18:35:00','98935','X',0,'2013-12-26 01:51:45',NULL,NULL),(1452,93,'005010X220A1','BE','OH0','92036','92036OH0040032','2013-12-24','01:56:00','90990','X',0,'2013-12-26 13:17:10',NULL,NULL),(3130,2772,'005010X220A1','BE','OH0','92036','92036OH0030015','2014-01-29','18:30:00','161352','X',0,'2014-01-29 21:01:41',NULL,NULL),(3405,2789,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-09','18:11:00','181286','X',0,'2014-02-09 19:00:09',NULL,NULL),(4412,2853,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-09','18:20:00','252257','X',0,'2014-03-09 21:00:59',NULL,NULL),(2,1,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-05','18:31:00','54177','X',0,'2013-12-25 17:16:10',NULL,NULL),(1277,80,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-18','18:49:00','79107','X',0,'2013-12-26 04:10:48',NULL,NULL),(2823,2598,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:21:00','1','X',1,'2014-01-23 03:50:21',NULL,NULL),(3019,2756,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-24','18:26:00','154299','X',0,'2014-01-24 21:01:01',NULL,NULL),(3329,2782,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-06','18:28:00','175986','X',0,'2014-02-06 21:01:21',NULL,NULL),(3350,2784,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-07','18:14:00','177559','X',0,'2014-02-07 19:00:03',NULL,NULL),(3446,2791,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-10','18:27:00','184757','X',0,'2014-02-10 21:00:07',NULL,NULL),(3986,2824,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-24','18:21:00','218498','X',0,'2014-02-26 09:31:00',NULL,NULL),(4287,2847,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-06','18:51:00','245587','X',0,'2014-03-06 21:02:28',NULL,NULL),(4332,2849,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-07','18:42:00','246118','X',0,'2014-03-07 21:00:31',NULL,NULL),(809,50,'005010X220A1','BE','MS0','46300','46300MS0010001','2013-11-26','18:20:00','40534','X',0,'2013-12-25 23:32:12',NULL,NULL),(886,53,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-21','18:06:00','34264','X',0,'2013-12-26 00:16:03',NULL,NULL),(1079,68,'005010X220A1','BE','OH0','52664','52664OH1520010','2013-12-14','18:21:00','71348','X',0,'2013-12-26 02:03:40',NULL,NULL),(1198,75,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-20','19:06:00','84236','X',0,'2013-12-26 03:10:54',NULL,NULL),(2026,1273,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:02',NULL,NULL),(2672,2551,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-01-17','18:23:00','142638','X',0,'2014-01-20 08:06:44',NULL,NULL),(3060,2759,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-27','18:27:00','158000','X',0,'2014-01-27 21:00:02',NULL,NULL),(3746,2808,'005010X220A1','BE','PA0','33348','33348TX0020002','2014-02-18','18:28:00','204280','X',0,'2014-02-18 22:00:02',NULL,NULL),(849,51,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-24','03:40:00','94588','X',0,'2013-12-25 23:51:57',NULL,NULL),(1901,1148,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:39',NULL,NULL),(2044,1291,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:59:52',NULL,NULL),(2500,1559,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-13 03:03:50',NULL,NULL),(2836,2611,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:56:42',NULL,NULL),(3132,2772,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-01-29','18:30:00','161354','X',0,'2014-01-29 21:01:43',NULL,NULL),(114,7,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-16','18:37:00','74927','X',0,'2013-12-25 18:06:40',NULL,NULL),(352,22,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-09','18:28:00','61522','X',0,'2013-12-25 19:37:48',NULL,NULL),(996,62,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-05','18:03:00','19343','X',0,'2013-12-26 01:02:07',NULL,NULL),(1919,1166,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:29',NULL,NULL),(2202,1449,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:53',NULL,NULL),(2725,2554,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-20','18:21:00','146904','X',0,'2014-01-21 08:46:50',NULL,NULL),(3097,2760,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-28','18:32:00','160248','X',0,'2014-01-28 21:01:05',NULL,NULL),(4197,2836,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-03-03','18:33:00','236093','X',0,'2014-03-03 21:31:58',NULL,NULL),(4413,2853,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-03-09','18:20:00','252258','X',0,'2014-03-09 21:01:00',NULL,NULL),(405,26,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-11-02','18:03:00','17179','X',0,'2013-12-25 20:01:47',NULL,NULL),(1534,381,'005010X220A1','BE','OH0','92036','92036OH0060032','2013-12-28','18:14:00','103726','X',1,'2013-12-29 11:10:22',NULL,NULL),(2812,2587,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:39:00','1','X',1,'2014-01-23 03:46:10',NULL,NULL),(3302,2781,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-05','18:39:00','174412','X',0,'2014-02-05 21:31:04',NULL,NULL),(3667,2801,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-02-15','18:44:00','198282','X',0,'2014-02-15 21:00:09',NULL,NULL),(248,19,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-24','18:40:00','96809','X',0,'2013-12-25 18:54:27',NULL,NULL),(260,19,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-24','18:40:00','96821','X',0,'2013-12-25 18:58:05',NULL,NULL),(586,39,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-17','18:43:00','78035','X',0,'2013-12-25 21:49:18',NULL,NULL),(2255,1469,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-05','18:09:00','119789','X',1,'2014-01-07 10:22:03',NULL,NULL),(2682,2552,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-01-18','18:11:00','144580','X',0,'2014-01-21 08:44:22',NULL,NULL),(3181,2774,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-31','18:37:00','165923','X',0,'2014-01-31 21:01:11',NULL,NULL),(3440,2790,'005010X220A1','BE','OH0','92036','92036OH0040027','2014-02-10','05:02:00','183713','X',0,'2014-02-10 11:01:13',NULL,NULL),(4223,2843,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-03-04','18:50:00','238770','X',0,'2014-03-04 21:02:41',NULL,NULL),(1161,74,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-10','18:01:00','22951','X',0,'2013-12-26 02:46:43',NULL,NULL),(2801,2576,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:43:30',NULL,NULL),(2976,2751,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','01:08:00','1','X',0,'2014-01-23 17:00:02',NULL,NULL),(488,34,'005010X220A1','BE','OH0','92036','92036OH0060026','2013-10-06','18:02:00','6432','X',0,'2013-12-25 20:46:21',NULL,NULL),(950,59,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-11','18:36:00','64783','X',0,'2013-12-26 00:52:40',NULL,NULL),(1150,73,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-10-14','18:02:00','9150','X',0,'2013-12-26 02:46:13',NULL,NULL),(2651,2540,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-16','18:41:00','141427','X',0,'2014-01-17 03:36:41',NULL,NULL),(4074,2828,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-27','18:43:00','224658','X',0,'2014-02-28 07:30:37',NULL,NULL),(4183,2836,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-03','18:33:00','236079','X',0,'2014-03-03 21:31:28',NULL,NULL),(4445,2855,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-03-10','19:23:00','255920','X',0,'2014-03-10 21:02:06',NULL,NULL),(266,19,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-24','18:40:00','96827','X',0,'2013-12-25 18:58:53',NULL,NULL),(858,52,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-01','18:08:00','46305','X',0,'2013-12-26 00:00:08',NULL,NULL),(1154,73,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-10-14','18:02:00','9149','X',0,'2013-12-26 02:46:26',NULL,NULL),(1305,82,'005010X220A1','BE','OH0','92036','92036OH0050032','2013-12-21','18:37:00','86509','X',0,'2013-12-26 04:37:48',NULL,NULL),(1603,385,'005010X220A1','BE','OH0','92036','92036OH0010008','2013-12-30','19:01:00','109550','X',0,'2014-01-01 12:08:50',NULL,NULL),(2388,1477,'005010X220A1','BE','OH0','92036','92036OH0050032','2014-01-10','18:26:00','129743','X',0,'2014-01-13 03:00:32',NULL,NULL),(3541,2796,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-02-12','18:31:00','191449','X',0,'2014-02-12 21:31:01',NULL,NULL),(3754,2808,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-18','18:28:00','204268','X',0,'2014-02-18 22:01:18',NULL,NULL),(4169,2835,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-03','18:31:00','234704','X',0,'2014-03-03 21:00:20',NULL,NULL),(4453,2855,'005010X220A1','BE','OH0','92036','92036OH0020012','2014-03-10','19:23:00','255928','X',0,'2014-03-10 21:02:31',NULL,NULL),(426,29,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-06','18:21:00','55536','X',0,'2013-12-25 20:19:23',NULL,NULL),(461,31,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-11-18','18:07:00','30652','X',0,'2013-12-25 20:31:43',NULL,NULL),(506,37,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-22','18:40:00','88462','X',0,'2013-12-25 21:19:11',NULL,NULL),(697,44,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-04','18:00:00','5523','X',0,'2013-12-25 22:31:25',NULL,NULL),(2017,1264,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','04:55:00','1','X',0,'2014-01-05 16:58:36',NULL,NULL),(2150,1397,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:24:28',NULL,NULL),(2873,2648,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:08:00','1','X',1,'2014-01-23 04:21:47',NULL,NULL),(3473,2792,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-02-10','18:30:00','186459','X',0,'2014-02-10 21:32:05',NULL,NULL),(3510,2793,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-11','18:41:00','189064','X',0,'2014-02-11 21:02:47',NULL,NULL),(4088,2830,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-28','19:12:00','229906','X',0,'2014-02-28 21:30:18',NULL,NULL),(4383,2852,'005010X220A1','BE','OH0','92036','92036OH0030006','2014-03-08','18:43:00','250655','X',0,'2014-03-08 21:30:37',NULL,NULL),(53,3,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-13','18:04:00','25395','X',0,'2013-12-25 17:31:29',NULL,NULL),(175,13,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-03','18:20:00','49881','X',0,'2013-12-25 18:15:23',NULL,NULL),(2683,2552,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-18','18:11:00','144581','X',0,'2014-01-21 08:44:24',NULL,NULL),(2849,2624,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:17:00','1','X',1,'2014-01-23 04:08:17',NULL,NULL),(3089,2760,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-28','18:32:00','160240','X',0,'2014-01-28 21:00:09',NULL,NULL),(172,12,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-10-17','18:00:00','10379','X',0,'2013-12-25 18:11:17',NULL,NULL),(353,22,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-09','18:28:00','61523','X',0,'2013-12-25 19:37:51',NULL,NULL),(928,57,'005010X220A1','BE','OH0','92036','92036OH0060005','2013-11-19','18:07:00','31314','X',0,'2013-12-26 00:32:04',NULL,NULL),(2921,2696,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',0,'2014-01-23 06:39:41',NULL,NULL),(2991,2755,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-23','18:27:00','151587','X',0,'2014-01-23 21:01:18',NULL,NULL),(3207,2775,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-01','18:14:00','166676','X',0,'2014-02-01 19:00:42',NULL,NULL),(3222,2776,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-02','18:10:00','168371','X',0,'2014-02-02 19:00:22',NULL,NULL),(3903,2819,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-25','18:36:00','220675','X',0,'2014-02-25 21:30:02',NULL,NULL),(290,21,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-10','18:21:00','62739','X',0,'2013-12-25 19:15:23',NULL,NULL),(1906,1153,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:53',NULL,NULL),(4270,2846,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-03-05','18:49:00','241604','X',0,'2014-03-05 21:32:40',NULL,NULL),(95,6,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-04','18:22:00','52143','X',0,'2013-12-25 17:50:56',NULL,NULL),(388,24,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-10-15','18:01:00','9471','X',0,'2013-12-25 20:00:07',NULL,NULL),(868,52,'005010X220A1','BE','OH0','92036','92036OH0030032','2013-12-01','18:08:00','46315','X',0,'2013-12-26 00:02:17',NULL,NULL),(883,53,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-21','18:06:00','34261','X',0,'2013-12-26 00:15:05',NULL,NULL),(974,60,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-11-12','18:03:00','24206','X',0,'2013-12-26 01:00:30',NULL,NULL),(1017,63,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-11-25','18:07:00','38455','X',0,'2013-12-26 01:17:23',NULL,NULL),(1214,76,'005010X220A1','BE','OH0','92036','92036OH0030015','2013-11-22','18:08:00','35668','X',0,'2013-12-26 03:16:22',NULL,NULL),(1614,385,'005010X220A1','BE','OH0','92036','92036OH0020026','2013-12-30','19:01:00','109561','X',0,'2014-01-01 12:09:28',NULL,NULL),(1908,1155,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:51:58',NULL,NULL),(1944,1191,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:38',NULL,NULL),(2003,1250,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:57:57',NULL,NULL),(2281,1471,'005010X220A1','BE','OH0','92036','92036OH0060026','2014-01-07','18:29:00','123279','X',0,'2014-01-08 18:24:59',NULL,NULL),(3044,2757,'005010X220A1','BE','OH0','99734','99734OH0050001','2014-01-25','18:11:00','155345','X',0,'2014-01-25 19:00:19',NULL,NULL),(3152,2773,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-01-30','18:35:00','164073','X',0,'2014-01-30 21:01:18',NULL,NULL),(3906,2819,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-25','18:36:00','220678','X',0,'2014-02-25 21:30:28',NULL,NULL),(1042,67,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-25','18:35:00','98924','X',0,'2013-12-26 01:47:59',NULL,NULL),(2154,1401,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-27','16:55:00','1','X',0,'2014-01-05 17:24:39',NULL,NULL),(2988,2755,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-01-23','18:27:00','151584','X',0,'2014-01-23 21:01:13',NULL,NULL),(3543,2796,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-12','18:31:00','191451','X',0,'2014-02-12 21:31:30',NULL,NULL),(4381,2852,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-08','18:43:00','250653','X',0,'2014-03-08 21:30:16',NULL,NULL),(3086,2759,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-27','18:27:00','158026','X',0,'2014-01-27 21:01:49',NULL,NULL),(3296,2781,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-05','18:39:00','174406','X',0,'2014-02-05 21:30:35',NULL,NULL),(3919,2819,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-25','18:36:00','220691','X',0,'2014-02-25 21:31:51',NULL,NULL),(4016,2825,'005010X220A1','BE','OH0','92036','92036OH0010026','2014-02-26','18:43:00','223771','X',0,'2014-02-26 21:02:43',NULL,NULL),(4035,2826,'005010X220A1','BE','OH0','92036','92036OH0060015','2014-02-27','18:48:00','225929','X',0,'2014-02-28 06:31:29',NULL,NULL),(4051,2826,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-27','18:48:00','225945','X',0,'2014-02-28 06:31:48',NULL,NULL),(460,31,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-11-18','18:07:00','30658','X',0,'2013-12-25 20:31:41',NULL,NULL),(842,51,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-24','03:40:00','94581','X',0,'2013-12-25 23:51:25',NULL,NULL),(3127,2772,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-01-29','18:30:00','161349','X',0,'2014-01-29 21:01:38',NULL,NULL),(3455,2792,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-10','18:30:00','186441','X',0,'2014-02-10 21:30:56',NULL,NULL),(3638,2799,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-14','18:39:00','196131','X',0,'2014-02-14 21:31:50',NULL,NULL),(1580,385,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-30','19:01:00','109527','X',0,'2014-01-01 12:00:02',NULL,NULL),(2447,1506,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:37',NULL,NULL),(2679,2552,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-18','18:11:00','144577','X',0,'2014-01-21 08:44:20',NULL,NULL),(2788,2563,'005010X231A1','FA','OH0','52664','52664OH1510013','2014-01-15','22:50:00','1','X',0,'2014-01-23 03:39:36',NULL,NULL),(3657,2799,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-02-14','18:39:00','196150','X',0,'2014-02-14 21:32:28',NULL,NULL),(3730,2806,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-02-17','18:05:00','202228','X',0,'2014-02-17 19:00:15',NULL,NULL),(4251,2846,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-03-05','18:49:00','241585','X',0,'2014-03-05 21:31:28',NULL,NULL),(4369,2850,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-03-07','18:46:00','247684','X',0,'2014-03-07 21:32:24',NULL,NULL),(857,52,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-01','18:08:00','46304','X',0,'2013-12-26 00:00:04',NULL,NULL),(1561,383,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-29','18:10:00','107243','X',0,'2013-12-30 00:00:34',NULL,NULL),(1961,1208,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:25',NULL,NULL),(2824,2599,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:16:00','1','X',1,'2014-01-23 03:50:32',NULL,NULL),(3861,2815,'005010X220A1','BE','LA0','18575','18575LA0020001','2014-02-21','18:28:00','211307','X',0,'2014-02-21 21:30:02',NULL,NULL),(130,7,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-12-16','18:37:00','74943','X',0,'2013-12-25 18:08:02',NULL,NULL),(466,31,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-18','18:07:00','30661','X',0,'2013-12-25 20:32:04',NULL,NULL),(1294,82,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-21','18:37:00','86494','X',0,'2013-12-26 04:30:41',NULL,NULL),(2772,2556,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-01-22','18:31:00','150813','X',0,'2014-01-23 03:02:32',NULL,NULL),(3140,2772,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-29','18:30:00','161362','X',0,'2014-01-29 21:01:54',NULL,NULL),(3363,2784,'005010X220A1','BE','OH0','52664','52664OH1520009','2014-02-07','18:14:00','177572','X',0,'2014-02-07 19:01:01',NULL,NULL),(3635,2799,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-14','18:39:00','196128','X',0,'2014-02-14 21:31:42',NULL,NULL),(309,21,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-10','18:21:00','62758','X',0,'2013-12-25 19:19:52',NULL,NULL),(608,39,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-17','18:43:00','78057','X',0,'2013-12-25 21:53:26',NULL,NULL),(632,40,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-12','18:53:00','67252','X',0,'2013-12-25 22:07:08',NULL,NULL),(736,47,'005010X220A1','BE','OH0','92036','92036OH0060015','2013-12-19','19:11:00','81722','X',0,'2013-12-25 23:06:19',NULL,NULL),(1068,68,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-14','18:21:00','71337','X',0,'2013-12-26 02:00:36',NULL,NULL),(1954,1201,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:05',NULL,NULL),(2011,1258,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:20',NULL,NULL),(2367,1476,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-10','18:26:00','129724','X',0,'2014-01-13 02:24:01',NULL,NULL),(2547,1576,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-01-13','18:44:00','134023','X',0,'2014-01-14 01:33:54',NULL,NULL),(3265,2778,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-04','18:29:00','172107','X',0,'2014-02-04 21:01:13',NULL,NULL),(3548,2796,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-02-12','18:31:00','191456','X',0,'2014-02-12 21:31:56',NULL,NULL),(97,6,'005010X220A1','BE','OH0','92036','92036OH0030008','2013-12-04','18:22:00','52145','X',0,'2013-12-25 17:51:00',NULL,NULL),(3678,2802,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-15','18:48:00','199869','X',0,'2014-02-15 22:01:28',NULL,NULL),(3738,2807,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-02-18','18:25:00','203032','X',0,'2014-02-18 21:30:14',NULL,NULL),(206,14,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-29','18:04:00','43696','X',0,'2013-12-25 18:30:21',NULL,NULL),(486,34,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-06','18:02:00','6434','X',0,'2013-12-25 20:46:17',NULL,NULL),(873,52,'005010X220A1','BE','OH0','92036','92036OH0040015','2013-12-01','18:08:00','46320','X',0,'2013-12-26 00:02:28',NULL,NULL),(1491,380,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-27','18:44:00','101815','X',0,'2013-12-28 03:32:46',NULL,NULL),(1974,1221,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','12:25:00','1','X',0,'2014-01-05 16:55:01',NULL,NULL),(2197,1444,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:39',NULL,NULL),(2358,1475,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-01-08','18:27:00','125994','X',0,'2014-01-13 02:22:42',NULL,NULL),(2416,1478,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-12','18:13:00','132600','X',0,'2014-01-13 03:01:56',NULL,NULL),(2694,2553,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-01-19','18:08:00','145201','X',0,'2014-01-21 08:45:15',NULL,NULL),(6,1,'005010X220A1','BE','MS0','46300','46300MS0020002','2013-12-05','18:31:00','54181','X',0,'2013-12-25 17:18:18',NULL,NULL),(96,6,'005010X220A1','BE','OH0','92036','92036OH0030006','2013-12-04','18:22:00','52144','X',0,'2013-12-25 17:50:59',NULL,NULL),(341,22,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-09','18:28:00','61511','X',0,'2013-12-25 19:37:05',NULL,NULL),(365,23,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-12-02','18:14:00','47681','X',0,'2013-12-25 19:48:03',NULL,NULL),(476,33,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-11-01','18:03:00','16376','X',0,'2013-12-25 20:45:38',NULL,NULL),(1124,71,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-15','18:15:00','73615','X',0,'2013-12-26 02:33:31',NULL,NULL),(2014,1261,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:28',NULL,NULL),(2286,1471,'005010X220A1','BE','MS0','46300','46300MS0020001','2014-01-07','18:29:00','123284','X',0,'2014-01-08 18:25:02',NULL,NULL),(4005,2825,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-26','18:43:00','223760','X',0,'2014-02-26 21:02:12',NULL,NULL),(719,46,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-07','18:13:00','57437','X',0,'2013-12-25 22:47:28',NULL,NULL),(1005,63,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-11-25','18:07:00','38442','X',0,'2013-12-26 01:15:59',NULL,NULL),(1169,75,'005010X220A1','BE','OH0','92036','92036OH0050026','2013-12-20','19:06:00','84206','X',0,'2013-12-26 03:05:29',NULL,NULL),(1288,81,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-11-30','18:04:00','44828','X',0,'2013-12-26 04:16:14',NULL,NULL),(2018,1265,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:58:39',NULL,NULL),(2896,2671,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:19:00','1','X',1,'2014-01-23 04:52:40',NULL,NULL),(3295,2781,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-05','18:39:00','174405','X',0,'2014-02-05 21:30:27',NULL,NULL),(4247,2846,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-05','18:49:00','241581','X',0,'2014-03-05 21:30:05',NULL,NULL),(4334,2849,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-03-07','18:42:00','246120','X',0,'2014-03-07 21:00:32',NULL,NULL),(4409,2853,'005010X220A1','BE','OH0','92036','92036OH0060006','2014-03-09','18:20:00','252254','X',0,'2014-03-09 21:00:49',NULL,NULL),(771,47,'005010X220A1','BE','OH0','92036','92036OH0040012','2013-12-19','19:11:00','81757','X',0,'2013-12-25 23:11:26',NULL,NULL),(1074,68,'005010X220A1','BE','OH0','52664','52664OH1510015','2013-12-14','18:21:00','71343','X',0,'2013-12-26 02:02:44',NULL,NULL),(1121,71,'005010X220A1','BE','OH0','52664','52664OH1520009','2013-12-15','18:15:00','73612','X',0,'2013-12-26 02:33:16',NULL,NULL),(1589,385,'005010X220A1','BE','OH0','92036','92036OH0050015','2013-12-30','19:01:00','109536','X',0,'2014-01-01 12:06:58',NULL,NULL),(1615,386,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-01-01','18:18:00','112800','X',1,'2014-01-02 04:21:43',NULL,NULL),(1628,386,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-01','18:18:00','112813','X',1,'2014-01-02 04:25:17',NULL,NULL),(2138,1385,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:23:54',NULL,NULL),(2650,2540,'005010X220A1','BE','OH0','92036','92036OH0010005','2014-01-16','18:41:00','141426','X',0,'2014-01-17 03:36:40',NULL,NULL),(3371,2784,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-07','18:14:00','177580','X',0,'2014-02-07 19:01:09',NULL,NULL),(3707,2804,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-16','18:12:00','201500','X',0,'2014-02-16 19:00:11',NULL,NULL),(3749,2808,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-18','18:28:00','204263','X',0,'2014-02-18 22:00:41',NULL,NULL),(22,1,'005010X220A1','BE','OH0','92036','92036OH0030005','2013-12-05','18:31:00','54197','X',0,'2013-12-25 17:21:21',NULL,NULL),(410,28,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-10-08','18:00:00','6876','X',0,'2013-12-25 20:02:14',NULL,NULL),(1301,82,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-21','18:37:00','86502','X',0,'2013-12-26 04:35:33',NULL,NULL),(2188,1435,'005010X231A1','FA','OH0','99734','99734OH0050003','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:26:14',NULL,NULL),(3428,2790,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-02-10','05:02:00','183701','X',0,'2014-02-10 11:00:49',NULL,NULL),(4344,2850,'005010X220A1','BE','LA0','18575','18575LA0020002','2014-03-07','18:46:00','247659','X',0,'2014-03-07 21:31:12',NULL,NULL),(338,22,'005010X220A1','BE','OH0','92036','92036OH0050005','2013-12-09','18:28:00','61508','X',0,'2013-12-25 19:36:47',NULL,NULL),(615,40,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-12-12','18:53:00','67235','X',0,'2013-12-25 22:00:02',NULL,NULL),(1723,569,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-03','18:38:00','116022','X',0,'2014-01-04 02:06:04',NULL,NULL),(2208,1455,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 17:27:09',NULL,NULL),(2350,1475,'005010X220A1','BE','OH0','92036','92036OH0050015','2014-01-08','18:27:00','125986','X',0,'2014-01-13 02:22:25',NULL,NULL),(2517,1576,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-13','18:44:00','133993','X',0,'2014-01-14 01:32:11',NULL,NULL),(2613,2539,'005010X220A1','BE','OH0','92036','92036OH0020005','2014-01-15','18:30:00','138475','X',0,'2014-01-16 08:47:21',NULL,NULL),(2735,2554,'005010X220A1','BE','OH0','92036','92036OH0060027','2014-01-20','18:21:00','146914','X',0,'2014-01-21 08:47:01',NULL,NULL),(3640,2799,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-14','18:39:00','196133','X',0,'2014-02-14 21:31:55',NULL,NULL),(3837,2813,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-20','18:26:00','208223','X',0,'2014-02-20 21:30:21',NULL,NULL),(73,6,'005010X220A1','BE','OH0','92036','92036OH0030026','2013-12-04','18:22:00','52121','X',0,'2013-12-25 17:47:25',NULL,NULL),(103,7,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-12-16','18:37:00','74916','X',0,'2013-12-25 18:01:41',NULL,NULL),(472,33,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-01','18:03:00','16372','X',0,'2013-12-25 20:45:02',NULL,NULL),(918,57,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-19','18:07:00','31309','X',0,'2013-12-26 00:31:17',NULL,NULL),(976,60,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-11-12','18:03:00','24208','X',0,'2013-12-26 01:00:37',NULL,NULL),(1037,66,'005010X220A1','BE','OH0','99734','99734OH0050004','2013-11-03','18:02:00','17822','X',0,'2013-12-26 01:32:03',NULL,NULL),(1221,76,'005010X220A1','BE','OH0','92036','92036OH0060012','2013-11-22','18:08:00','35675','X',0,'2013-12-26 03:16:35',NULL,NULL),(2427,1486,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:19',NULL,NULL),(3169,2773,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-01-30','18:35:00','164090','X',0,'2014-01-30 21:01:40',NULL,NULL),(3480,2792,'005010X220A1','BE','OH0','92036','92036OH0050026','2014-02-10','18:30:00','186466','X',0,'2014-02-10 21:32:14',NULL,NULL),(3845,2814,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-20','18:28:00','208912','X',0,'2014-02-20 22:00:56',NULL,NULL),(4125,2832,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-03-01','18:23:00','232012','X',0,'2014-03-01 21:00:22',NULL,NULL),(4471,2855,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-03-10','19:23:00','255947','X',0,'2014-03-10 21:03:03',NULL,NULL),(368,23,'005010X220A1','BE','OH0','92036','92036OH0020006','2013-12-02','18:14:00','47684','X',0,'2013-12-25 19:48:56',NULL,NULL),(696,44,'005010X220A1','BE','LA0','18575','18575LA0020002','2013-10-04','18:00:00','5517','X',0,'2013-12-25 22:31:22',NULL,NULL),(941,59,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-12-11','18:36:00','64774','X',0,'2013-12-26 00:49:28',NULL,NULL),(1013,63,'005010X220A1','BE','OH0','92036','92036OH0010026','2013-11-25','18:07:00','38451','X',0,'2013-12-26 01:17:14',NULL,NULL),(1627,386,'005010X220A1','BE','OH0','92036','92036OH0020026','2014-01-01','18:18:00','112812','X',1,'2014-01-02 04:25:13',NULL,NULL),(1676,568,'005010X220A1','BE','OH0','92036','92036OH0060032','2014-01-02','18:42:00','115200','X',0,'2014-01-03 02:04:42',NULL,NULL),(1703,569,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-01-03','18:38:00','116002','X',0,'2014-01-04 02:00:26',NULL,NULL),(2440,1499,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:30',NULL,NULL),(2630,2540,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-16','18:41:00','141406','X',0,'2014-01-17 03:36:05',NULL,NULL),(3029,2756,'005010X220A1','BE','OH0','92036','92036OH0020027','2014-01-24','18:26:00','154310','X',0,'2014-01-24 21:01:16',NULL,NULL),(3420,2790,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-10','05:02:00','183693','X',0,'2014-02-10 11:00:04',NULL,NULL),(3563,2796,'005010X220A1','BE','OH0','92036','92036OH0030012','2014-02-12','18:31:00','191471','X',0,'2014-02-12 21:32:28',NULL,NULL),(3682,2802,'005010X220A1','BE','OH0','92036','92036OH0030005','2014-02-15','18:48:00','199873','X',0,'2014-02-15 22:01:49',NULL,NULL),(3822,2812,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-19','18:32:00','206161','X',0,'2014-02-20 05:32:25',NULL,NULL),(3932,2820,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-02-23','18:10:00','215478','X',0,'2014-02-26 08:00:12',NULL,NULL),(491,35,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-11-28','18:02:00','42791','X',0,'2013-12-25 20:46:47',NULL,NULL),(600,39,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-12-17','18:43:00','78049','X',0,'2013-12-25 21:52:49',NULL,NULL),(711,46,'005010X220A1','BE','OH0','52664','52664OH1510013','2013-12-07','18:13:00','57429','X',0,'2013-12-25 22:45:02',NULL,NULL),(808,50,'005010X220A1','BE','OH0','92036','92036OH0050006','2013-11-26','18:20:00','40533','X',0,'2013-12-25 23:32:09',NULL,NULL),(1585,385,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-30','19:01:00','109532','X',0,'2014-01-01 12:03:54',NULL,NULL),(2718,2554,'005010X220A1','BE','OH0','52664','52664OH1510015','2014-01-20','18:21:00','146897','X',0,'2014-01-21 08:46:37',NULL,NULL),(2742,2555,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-01-21','18:24:00','147877','X',1,'2014-01-22 03:22:41',NULL,NULL),(2955,2730,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','02:34:00','1','X',0,'2014-01-23 09:00:02',NULL,NULL),(3606,2798,'005010X220A1','BE','OH0','92036','92036OH0030027','2014-02-13','18:46:00','194329','X',0,'2014-02-13 22:03:06',NULL,NULL),(3780,2810,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-19','18:35:00','207792','X',0,'2014-02-20 04:14:00',NULL,NULL),(4295,2847,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-03-06','18:51:00','245595','X',0,'2014-03-06 21:02:42',NULL,NULL),(4325,2849,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-03-07','18:42:00','246111','X',0,'2014-03-07 21:00:18',NULL,NULL),(245,19,'005010X220A1','BE','TX0','33348','33348TX0020002','2013-12-24','18:40:00','96806','X',0,'2013-12-25 18:50:55',NULL,NULL),(528,37,'005010X220A1','BE','OH0','92036','92036OH0030027','2013-12-22','18:40:00','88489','X',0,'2013-12-25 21:23:13',NULL,NULL),(1163,74,'005010X220A1','BE','OH0','92036','92036OH0040026','2013-11-10','18:01:00','22946','X',0,'2013-12-26 02:46:53',NULL,NULL),(1972,1219,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:54:56',NULL,NULL),(2531,1576,'005010X220A1','BE','OH0','92036','92036OH0050012','2014-01-13','18:44:00','134007','X',0,'2014-01-14 01:33:42',NULL,NULL),(2587,2539,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-01-15','18:30:00','138449','X',0,'2014-01-16 08:45:19',NULL,NULL),(2685,2552,'005010X220A1','BE','OH0','92036','92036OH0040008','2014-01-18','18:11:00','144583','X',0,'2014-01-21 08:44:36',NULL,NULL),(3851,2814,'005010X220A1','BE','OH0','92036','92036OH0040015','2014-02-20','18:28:00','208918','X',0,'2014-02-20 22:01:30',NULL,NULL),(4237,2844,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-04','18:46:00','237498','X',0,'2014-03-04 21:30:23',NULL,NULL),(4437,2855,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-03-10','19:23:00','255912','X',0,'2014-03-10 21:01:06',NULL,NULL),(57,4,'005010X220A1','BE','OH0','99734','99734OH0050003','2013-10-11','18:01:00','7637','X',0,'2013-12-25 17:31:44',NULL,NULL),(583,39,'005010X220A1','BE','TX0','33348','33348TX0020001','2013-12-17','18:43:00','78032','X',0,'2013-12-25 21:47:37',NULL,NULL),(797,49,'005010X220A1','BE','OH0','92036','92036OH0040005','2013-11-06','18:03:00','20432','X',0,'2013-12-25 23:17:15',NULL,NULL),(1048,67,'005010X220A1','BE','LA0','18575','18575LA0020001','2013-12-25','18:35:00','98930','X',0,'2013-12-26 01:50:52',NULL,NULL),(2449,1508,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-13 03:02:39',NULL,NULL),(3253,2777,'005010X220A1','BE','OH0','92036','92036OH0050006','2014-02-03','18:32:00','170215','X',0,'2014-02-03 21:01:33',NULL,NULL),(1526,381,'005010X220A1','BE','OH0','92036','92036OH0040006','2013-12-28','18:14:00','103718','X',1,'2013-12-29 11:09:51',NULL,NULL),(1559,382,'005010X220A1','BE','OH0','92036','92036OH0010012','2013-12-28','21:04:00','105815','X',1,'2013-12-29 11:15:25',NULL,NULL),(3215,2775,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-01','18:14:00','166684','X',0,'2014-02-01 19:00:51',NULL,NULL),(3786,2810,'005010X220A1','BE','OH0','92036','92036OH0040026','2014-02-19','18:35:00','207795','X',0,'2014-02-20 04:23:30',NULL,NULL),(3833,2813,'005010X220A1','BE','OH0','52664','52664OH1510013','2014-02-20','18:26:00','208219','X',0,'2014-02-20 21:30:10',NULL,NULL),(4036,2826,'005010X220A1','BE','TX0','33348','33348TX0020001','2014-02-27','18:48:00','225930','X',0,'2014-02-28 06:31:30',NULL,NULL),(575,38,'005010X220A1','BE','OH0','92036','92036OH0010015','2013-12-13','18:39:00','69301','X',0,'2013-12-25 21:39:11',NULL,NULL),(1275,80,'005010X220A1','BE','OH0','92036','92036OH0020015','2013-12-18','18:49:00','79105','X',0,'2013-12-26 04:10:41',NULL,NULL),(1545,382,'005010X220A1','BE','MS0','46300','46300MS0020001','2013-12-28','21:04:00','105801','X',1,'2013-12-29 11:14:30',NULL,NULL),(1654,387,'005010X220A1','BE','OH0','92036','92036OH0060027','2013-12-31','18:52:00','111693','X',1,'2014-01-02 04:35:05',NULL,NULL),(1911,1158,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:52:07',NULL,NULL),(2948,2723,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-15','00:03:00','1','X',0,'2014-01-23 07:30:02',NULL,NULL),(3077,2759,'005010X220A1','BE','OH0','92036','92036OH0030026','2014-01-27','18:27:00','158017','X',0,'2014-01-27 21:01:39',NULL,NULL),(3555,2796,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-02-12','18:31:00','191463','X',0,'2014-02-12 21:32:15',NULL,NULL),(3870,2816,'005010X220A1','BE','TX0','33348','33348TX0020002','2014-02-21','18:31:00','212798','X',0,'2014-02-21 22:00:03',NULL,NULL),(4038,2826,'005010X220A1','BE','OH0','92036','92036OH0050005','2014-02-27','18:48:00','225932','X',0,'2014-02-28 06:31:35',NULL,NULL),(1937,1184,'005010X231A1','FA','OH0','99734','99734OH0050004','2013-12-28','11:05:00','1','X',0,'2014-01-05 16:53:18',NULL,NULL),(2610,2539,'005010X220A1','BE','MS0','46300','46300MS0020002','2014-01-15','18:30:00','138472','X',0,'2014-01-16 08:47:16',NULL,NULL),(2917,2692,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:15:00','1','X',0,'2014-01-23 06:30:13',NULL,NULL),(2947,2722,'005010X231A1','FA','OH0','52664','52664OH1510015','2014-01-14','23:31:00','1','X',0,'2014-01-23 07:07:31',NULL,NULL),(3537,2796,'005010X220A1','BE','OH0','99734','99734OH0050003','2014-02-12','18:31:00','191445','X',0,'2014-02-12 21:30:03',NULL,NULL),(4229,2843,'005010X220A1','BE','OH0','92036','92036OH0040005','2014-03-04','18:50:00','238776','X',0,'2014-03-04 21:02:47',NULL,NULL),(4259,2846,'005010X220A1','BE','OH0','92036','92036OH0040012','2014-03-05','18:49:00','241593','X',0,'2014-03-05 21:32:21',NULL,NULL),(4322,2849,'005010X220A1','BE','OH0','99734','99734OH0050004','2014-03-07','18:42:00','246108','X',0,'2014-03-07 21:00:08',NULL,NULL);
/*!40000 ALTER TABLE `EdiFunctionalGroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiIC834`
--

DROP TABLE IF EXISTS `EdiIC834`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiIC834` (
  `EdiIC834Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiProcessingId` bigint(64) NOT NULL,
  `PaymentDate` date DEFAULT NULL,
  `AssignedPolicyId` varchar(50) DEFAULT NULL,
  `Status` enum('Pending','Accepted','Failed') NOT NULL DEFAULT 'Pending',
  `CreatedByUserId` bigint(64) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiIC834Id`),
  KEY `EdiProcessingId` (`EdiProcessingId`)
) ENGINE=innodb AUTO_INCREMENT=1223 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiIC834`
--

LOCK TABLES `EdiIC834` WRITE;
/*!40000 ALTER TABLE `EdiIC834` DISABLE KEYS */;
INSERT INTO `EdiIC834` VALUES (1,154,NULL,NULL,'Accepted',1,'2014-01-02 05:06:56',1,'2014-01-02 06:06:15'),(182,335,NULL,NULL,'Accepted',1,'2014-01-02 05:08:19',NULL,'2014-01-13 03:04:58'),(634,1973,'2013-12-26','A00618486','Pending',1,'2014-01-14 23:15:07',NULL,NULL),(789,2128,'2014-01-06','A00618937','Pending',1,'2014-01-15 00:17:17',NULL,NULL),(870,2209,'2014-01-06','A00619052','Pending',1,'2014-01-15 00:19:00',NULL,NULL),(203,356,NULL,NULL,'Accepted',1,'2014-01-02 05:08:29',NULL,'2014-01-13 03:04:59'),(794,2133,'2014-01-06','A00618944','Pending',1,'2014-01-15 00:17:23',NULL,NULL),(915,2254,'2014-01-06','A00619127','Pending',1,'2014-01-15 00:19:58',NULL,NULL),(1100,2440,'2014-01-02','A00619088','Pending',1,'2014-01-15 09:04:09',NULL,NULL),(1184,2524,'2014-01-01','A00622598','Pending',1,'2014-01-15 22:21:48',NULL,NULL),(58,211,NULL,NULL,'Accepted',1,'2014-01-02 05:07:22',NULL,'2014-01-13 03:05:00'),(120,273,NULL,NULL,'Accepted',1,'2014-01-02 05:07:51',NULL,'2014-01-13 03:04:59'),(678,2017,'2013-12-26','A00618788','Pending',1,'2014-01-14 23:16:08',NULL,NULL),(910,2249,'2014-01-06','A00619096','Pending',1,'2014-01-15 00:19:52',NULL,NULL),(1039,2379,'2014-01-06','A00619013','Pending',1,'2014-01-15 09:03:25',NULL,NULL),(514,1852,'2013-12-31','A00619025','Accepted',1,'2014-01-14 23:10:31',NULL,'2014-01-24 10:32:18'),(533,1871,'2014-01-06','A00619049','Accepted',1,'2014-01-14 23:10:57',NULL,'2014-01-24 09:43:28'),(141,294,NULL,NULL,'Accepted',1,'2014-01-02 05:08:00',1,'2014-01-02 06:07:30'),(865,2204,'2014-01-06','A00619043','Pending',1,'2014-01-15 00:18:54',NULL,NULL),(425,1763,'2013-12-26','A00618904','Accepted',1,'2014-01-14 23:08:33',NULL,'2014-01-24 11:02:03'),(210,363,NULL,NULL,'Accepted',1,'2014-01-02 05:08:32',NULL,'2014-01-13 03:04:42'),(620,1959,'2013-12-24','A00618468','Pending',1,'2014-01-14 23:14:51',NULL,NULL),(661,2000,'2013-12-24','A00618765','Pending',1,'2014-01-14 23:15:45',NULL,NULL),(845,2184,'2014-01-06','A00619017','Pending',1,'2014-01-15 00:18:29',NULL,NULL),(231,564,'2013-12-12','DT1086537','Pending',1,'2014-01-02 16:41:06',NULL,NULL),(916,2255,'2014-01-06','A00619128','Pending',1,'2014-01-15 00:20:00',NULL,NULL),(92,245,NULL,NULL,'Accepted',1,'2014-01-02 05:07:38',NULL,'2014-01-13 03:05:01'),(585,1924,'2013-12-23','A00612101','Pending',1,'2014-01-14 23:14:12',NULL,NULL),(1133,2473,'2014-01-06','A00619150','Pending',1,'2014-01-15 09:04:33',NULL,NULL),(1144,2484,'2013-12-30','A00619162','Pending',1,'2014-01-15 09:04:40',NULL,NULL),(146,299,NULL,NULL,'Accepted',1,'2014-01-02 05:08:03',1,'2014-01-02 06:06:43'),(1213,2765,'2013-12-14','DT689534','Pending',1,'2014-01-29 13:46:29',NULL,NULL),(354,1692,'2013-12-24','A00618802','Accepted',1,'2014-01-14 23:07:04',NULL,'2014-01-24 11:01:01'),(627,1966,'2013-12-24','A00618476','Pending',1,'2014-01-14 23:14:59',NULL,NULL),(790,2129,'2014-01-06','A00618940','Pending',1,'2014-01-15 00:17:18',NULL,NULL),(803,2142,'2014-01-06','A00618971','Pending',1,'2014-01-15 00:17:35',NULL,NULL),(1044,2384,'2014-01-06','A00619018','Pending',1,'2014-01-15 09:03:28',NULL,NULL),(1111,2451,'2014-01-06','A00619099','Pending',1,'2014-01-15 09:04:17',NULL,NULL),(204,357,NULL,NULL,'Accepted',1,'2014-01-02 05:08:29',1,'2014-01-02 06:07:39'),(224,377,NULL,NULL,'Accepted',1,'2014-01-02 05:08:38',1,'2014-01-02 06:06:59'),(246,1584,'2014-01-07','A00606303','Accepted',1,'2014-01-14 23:04:53',NULL,'2014-01-24 11:01:52'),(815,2154,'2014-01-06','A00618983','Pending',1,'2014-01-15 00:17:51',NULL,NULL),(1129,2469,'2014-01-06','A00619143','Pending',1,'2014-01-15 09:04:30',NULL,NULL),(243,1581,'2013-12-24','A00513703','Accepted',1,'2014-01-14 23:04:50',NULL,'2014-01-24 11:02:02'),(439,1777,'2013-12-23','A00618919','Accepted',1,'2014-01-14 23:08:50',NULL,'2014-01-24 10:59:43'),(496,1834,'2014-01-06','A00619001','Accepted',1,'2014-01-14 23:10:04',NULL,'2014-01-24 10:58:39'),(745,2084,'2013-12-24','A00618884','Pending',1,'2014-01-14 23:17:34',NULL,NULL),(900,2239,'2014-01-01','A00619086','Pending',1,'2014-01-15 00:19:38',NULL,NULL),(940,2279,'2014-01-06','A00619156','Pending',1,'2014-01-15 00:20:29',NULL,NULL),(1069,2409,'2014-01-06','A00619054','Pending',1,'2014-01-15 09:03:45',NULL,NULL),(601,1940,'2013-12-23','A00615014','Pending',1,'2014-01-14 23:14:30',NULL,NULL),(616,1955,'2014-01-02','A00618462','Pending',1,'2014-01-14 23:14:47',NULL,NULL),(88,241,NULL,NULL,'Accepted',1,'2014-01-02 05:07:36',1,'2014-01-02 06:07:05'),(913,2252,'2014-01-06','A00619099','Pending',1,'2014-01-15 00:19:56',NULL,NULL),(475,1813,'2014-01-06','A00618979','Accepted',1,'2014-01-14 23:09:39',NULL,'2014-01-24 10:02:02'),(727,2066,'2013-12-26','A00618852','Pending',1,'2014-01-14 23:17:10',NULL,NULL),(269,1607,'2014-01-01','A00618445','Accepted',1,'2014-01-14 23:05:22',NULL,'2014-01-24 11:00:38'),(370,1708,'2013-12-24','A00618827','Accepted',1,'2014-01-14 23:07:24',NULL,'2014-01-24 11:01:03'),(579,1918,'2013-12-24','A00513703','Pending',1,'2014-01-14 23:14:06',NULL,NULL),(1217,2769,'2013-12-18','DT1685573','Pending',1,'2014-01-29 13:46:33',NULL,NULL),(490,1828,'2014-01-06','A00618995','Accepted',1,'2014-01-14 23:09:57',NULL,'2014-01-24 10:31:11'),(598,1937,'2013-12-26','A00612970','Pending',1,'2014-01-14 23:14:27',NULL,NULL),(776,2115,'2013-12-26','A00618920','Pending',1,'2014-01-15 00:17:02',NULL,NULL),(209,362,NULL,NULL,'Accepted',1,'2014-01-02 05:08:32',1,'2014-01-02 06:07:12'),(998,2338,'2014-01-06','A00618967','Pending',1,'2014-01-15 09:03:02',NULL,NULL),(782,2121,'2014-01-06','A00618926','Pending',1,'2014-01-15 00:17:09',NULL,NULL),(492,1830,'2014-01-06','A00618997','Accepted',1,'2014-01-14 23:09:59',NULL,'2014-01-24 11:00:24'),(763,2102,'2013-12-24','A00618906','Pending',1,'2014-01-14 23:17:58',NULL,NULL),(937,2276,'2014-01-10','A00619153','Pending',1,'2014-01-15 00:20:25',NULL,NULL),(311,1649,'2013-12-31','A00618729','Accepted',1,'2014-01-14 23:06:10',NULL,'2014-01-24 11:01:49'),(419,1757,'2014-01-02','A00618896','Accepted',1,'2014-01-14 23:08:26',NULL,'2014-01-24 11:01:39'),(145,298,NULL,NULL,'Accepted',1,'2014-01-02 05:08:02',1,'2014-01-02 06:06:45'),(456,1794,'2014-01-06','A00618942','Accepted',1,'2014-01-14 23:09:15',NULL,'2014-01-24 11:00:35'),(529,1867,'2014-01-06','A00619043','Accepted',1,'2014-01-14 23:10:52',NULL,'2014-01-24 08:01:01'),(983,2323,'2013-12-30','A00618929','Pending',1,'2014-01-15 09:02:53',NULL,NULL),(312,1650,'2013-12-31','A00618730','Accepted',1,'2014-01-14 23:06:11',NULL,'2014-01-24 11:02:13'),(381,1719,'2013-12-26','A00618841','Accepted',1,'2014-01-14 23:07:37',NULL,'2014-01-24 11:02:18'),(720,2059,'2013-12-24','A00618844','Pending',1,'2014-01-14 23:17:02',NULL,NULL),(988,2328,'2014-01-06','A00618940','Pending',1,'2014-01-15 09:02:56',NULL,NULL),(362,1700,'2013-12-23','A00618812','Accepted',1,'2014-01-14 23:07:14',NULL,'2014-01-24 11:01:20'),(755,2094,'2014-01-02','A00618896','Pending',1,'2014-01-14 23:17:47',NULL,NULL),(861,2200,'2013-12-23','A00619039','Pending',1,'2014-01-15 00:18:50',NULL,NULL),(691,2030,'2014-01-02','A00618803','Pending',1,'2014-01-14 23:16:25',NULL,NULL),(1167,2507,'2014-01-06','A00622208','Pending',1,'2014-01-15 09:04:56',NULL,NULL),(42,195,NULL,NULL,'Accepted',1,'2014-01-02 05:07:15',1,'2014-01-02 06:06:47'),(293,1631,'2014-01-07','A00618480','Accepted',1,'2014-01-14 23:05:50',NULL,'2014-01-24 11:01:58'),(757,2096,'2013-12-24','A00618898','Pending',1,'2014-01-14 23:17:50',NULL,NULL),(963,2302,'2014-01-02','A00619184','Pending',1,'2014-01-15 00:20:58',NULL,NULL),(1136,2476,'2014-01-06','A00619154','Pending',1,'2014-01-15 09:04:35',NULL,NULL),(1143,2483,'2014-01-10','A00619161','Pending',1,'2014-01-15 09:04:39',NULL,NULL),(1006,2346,'2014-01-01','A00618976','Pending',1,'2014-01-15 09:03:06',NULL,NULL),(138,291,NULL,NULL,'Accepted',1,'2014-01-02 05:07:59',NULL,'2014-01-13 03:05:03'),(180,333,NULL,NULL,'Accepted',1,'2014-01-02 05:08:18',1,'2014-01-02 06:06:14'),(363,1701,'2013-12-24','A00618813','Accepted',1,'2014-01-14 23:07:16',NULL,'2014-01-24 11:02:29'),(623,1962,'2013-12-24','A00618471','Pending',1,'2014-01-14 23:14:54',NULL,NULL),(651,1990,'2013-12-24','A00618734','Pending',1,'2014-01-14 23:15:27',NULL,NULL),(953,2292,'2013-12-23','A00619171','Pending',1,'2014-01-15 00:20:45',NULL,NULL),(959,2298,'2014-01-01','A00619179','Pending',1,'2014-01-15 00:20:53',NULL,NULL),(1064,2404,'2013-12-20','A00619045','Pending',1,'2014-01-15 09:03:42',NULL,NULL),(568,1906,'2014-01-06','A00619090','Pending',1,'2014-01-14 23:11:42',NULL,NULL),(749,2088,'2013-12-26','A00618888','Pending',1,'2014-01-14 23:17:40',NULL,NULL),(818,2157,'2014-01-06','A00618986','Pending',1,'2014-01-15 00:17:55',NULL,NULL),(1004,2344,'2014-01-06','A00618974','Pending',1,'2014-01-15 09:03:05',NULL,NULL),(34,187,NULL,NULL,'Accepted',1,'2014-01-02 05:07:11',1,'2014-01-02 06:06:40'),(515,1853,'2013-12-26','A00619026','Accepted',1,'2014-01-14 23:10:33',NULL,'2014-01-24 08:00:25'),(800,2139,'2014-01-06','A00618967','Pending',1,'2014-01-15 00:17:31',NULL,NULL),(1199,2541,'2014-01-08','A00622211','Pending',1,'2014-01-20 05:44:22',NULL,NULL),(307,1645,'2013-12-26','A00618501','Accepted',1,'2014-01-14 23:06:06',NULL,'2014-01-24 11:01:48'),(555,1893,'2014-01-08','A00619077','Accepted',1,'2014-01-14 23:11:26',1,'2014-01-24 06:03:38'),(1135,2475,'2014-01-10','A00619153','Pending',1,'2014-01-15 09:04:34',NULL,NULL),(774,2113,'2013-12-23','A00618918','Pending',1,'2014-01-15 00:16:59',NULL,NULL),(240,1578,'2013-12-23','A00120926','Accepted',1,'2014-01-14 23:04:46',NULL,'2014-01-24 11:00:32'),(952,2291,'2014-01-06','A00619170','Pending',1,'2014-01-15 00:20:44',NULL,NULL),(1190,2530,'2014-01-01','A00623124','Pending',1,'2014-01-15 22:21:51',NULL,NULL),(401,1739,'2013-12-24','A00618874','Accepted',1,'2014-01-14 23:08:03',NULL,'2014-01-24 10:59:49'),(574,1912,'2014-01-06','A00619096','Pending',1,'2014-01-14 23:11:51',NULL,NULL),(1165,2505,'2014-01-06','A00622205','Pending',1,'2014-01-15 09:04:54',NULL,NULL),(117,270,NULL,NULL,'Accepted',1,'2014-01-02 05:07:49',1,'2014-01-02 06:07:10'),(406,1744,'2013-12-31','A00618881','Accepted',1,'2014-01-14 23:08:09',NULL,'2014-01-24 10:59:41'),(163,316,NULL,NULL,'Accepted',1,'2014-01-02 05:08:10',1,'2014-01-02 06:07:07'),(393,1731,'2013-12-24','A00618854','Accepted',1,'2014-01-14 23:07:51',NULL,'2014-01-24 11:02:24'),(497,1835,'2014-01-06','A00619002','Accepted',1,'2014-01-14 23:10:07',NULL,'2014-01-24 10:02:06'),(1185,2525,'2014-01-06','A00622599','Pending',1,'2014-01-15 22:21:49',NULL,NULL),(435,1773,'2013-12-26','A00618915','Accepted',1,'2014-01-14 23:08:46',NULL,'2014-01-24 11:00:30'),(1110,2450,'2014-01-06','A00619098','Pending',1,'2014-01-15 09:04:16',NULL,NULL),(169,322,NULL,NULL,'Accepted',1,'2014-01-02 05:08:13',1,'2014-01-02 06:06:33'),(280,1618,'2014-01-02','A00618462','Accepted',1,'2014-01-14 23:05:36',NULL,'2014-01-24 11:01:45'),(176,329,NULL,NULL,'Accepted',1,'2014-01-02 05:08:16',1,'2014-01-02 06:07:00'),(205,358,NULL,NULL,'Accepted',1,'2014-01-02 05:08:30',NULL,'2014-01-13 03:04:53'),(934,2273,'2013-12-30','A00619148','Pending',1,'2014-01-15 00:20:21',NULL,NULL),(992,2332,'2014-01-06','A00618944','Pending',1,'2014-01-15 09:02:58',NULL,NULL),(1168,2508,'2013-12-26','A00622209','Pending',1,'2014-01-15 09:04:56',NULL,NULL),(164,317,NULL,NULL,'Accepted',1,'2014-01-02 05:08:11',NULL,'2014-01-13 03:05:10'),(375,1713,'2013-12-24','A00618834','Accepted',1,'2014-01-14 23:07:30',NULL,'2014-01-24 11:01:54'),(832,2171,'2014-01-06','A00619001','Pending',1,'2014-01-15 00:18:12',NULL,NULL),(350,1688,'2013-12-24','A00618798','Accepted',1,'2014-01-14 23:06:59',NULL,'2014-01-24 11:00:51'),(895,2234,'2013-12-30','A00619081','Pending',1,'2014-01-15 00:19:32',NULL,NULL),(480,1818,'2014-01-06','A00618984','Accepted',1,'2014-01-14 23:09:45',NULL,'2014-01-24 11:01:56'),(572,1910,'2014-01-06','A00619094','Pending',1,'2014-01-14 23:11:49',NULL,NULL),(587,1926,'2013-12-23','A00612108','Pending',1,'2014-01-14 23:14:14',NULL,NULL),(233,566,'2013-12-11','DT1077389','Pending',1,'2014-01-02 16:41:09',NULL,NULL),(739,2078,'2013-12-24','A00618876','Pending',1,'2014-01-14 23:17:26',NULL,NULL),(929,2268,'2014-01-06','A00619141','Pending',1,'2014-01-15 00:20:16',NULL,NULL),(986,2326,'2013-12-30','A00618935','Pending',1,'2014-01-15 09:02:55',NULL,NULL),(27,180,NULL,NULL,'Accepted',1,'2014-01-02 05:07:08',NULL,'2014-01-13 03:04:46'),(430,1768,'2013-12-26','A00618909','Accepted',1,'2014-01-14 23:08:39',NULL,'2014-01-24 11:01:46'),(756,2095,'2014-12-24','A00618897','Pending',1,'2014-01-14 23:17:48',NULL,NULL),(785,2124,'2013-12-30','A00618929','Pending',1,'2014-01-15 00:17:12',NULL,NULL),(1126,2466,'2014-01-06','A00619140','Pending',1,'2014-01-15 09:04:28',NULL,NULL),(276,1614,'2013-12-27','A00618457','Accepted',1,'2014-01-14 23:05:30',NULL,'2014-01-24 11:00:57'),(744,2083,'2013-12-24','A00618883','Pending',1,'2014-01-14 23:17:33',NULL,NULL),(208,361,NULL,NULL,'Accepted',1,'2014-01-02 05:08:31',NULL,'2014-01-13 03:04:53'),(284,1622,'2013-12-24','A00618468','Accepted',1,'2014-01-14 23:05:40',NULL,'2014-01-24 10:59:45'),(360,1698,'2013-12-23','A00618810','Accepted',1,'2014-01-14 23:07:12',NULL,'2014-01-24 11:01:18'),(399,1737,'2013-12-23','A00618870','Accepted',1,'2014-01-14 23:08:00',NULL,'2014-01-24 10:59:40'),(12,165,NULL,NULL,'Pending',1,'2014-01-02 05:07:01',NULL,NULL),(493,1831,'2014-01-06','A00618998','Accepted',1,'2014-01-14 23:10:01',NULL,'2014-01-24 10:59:35'),(855,2194,'2013-12-26','A00619032','Pending',1,'2014-01-15 00:18:43',NULL,NULL),(25,178,NULL,NULL,'Accepted',1,'2014-01-02 05:07:07',NULL,'2014-01-13 03:04:39'),(550,1888,'2014-01-06','A00619072','Accepted',1,'2014-01-14 23:11:19',NULL,'2014-01-24 10:02:34'),(295,1633,'2014-01-06','A00618482','Accepted',1,'2014-01-14 23:05:52',NULL,'2014-01-24 11:01:51'),(494,1832,'2013-12-31','A00618999','Accepted',1,'2014-01-14 23:10:02',NULL,'2014-01-24 10:59:06'),(286,1624,'2013-12-24','A00618470','Accepted',1,'2014-01-14 23:05:42',NULL,'2014-01-24 11:01:31'),(380,1718,'2013-12-26','A00618840','Accepted',1,'2014-01-14 23:07:36',NULL,'2014-01-24 10:59:14'),(833,2172,'2014-01-06','A00619002','Pending',1,'2014-01-15 00:18:13',NULL,NULL),(1212,2764,'2013-12-14','DT439589','Pending',1,'2014-01-29 13:46:29',NULL,NULL),(238,1575,'2014-01-01','HIM00201AJ','Accepted',1,'2014-01-13 22:14:45',NULL,'2014-01-24 05:15:17'),(244,1582,'2014-01-01','A00554513','Accepted',1,'2014-01-14 23:04:51',NULL,'2014-01-24 11:01:30'),(411,1749,'2013-12-31','A00618886','Accepted',1,'2014-01-14 23:08:16',NULL,'2014-01-24 11:02:02'),(7,160,NULL,NULL,'Accepted',1,'2014-01-02 05:06:59',NULL,'2014-01-13 03:05:04'),(614,1953,'2013-12-26','A00618459','Pending',1,'2014-01-14 23:14:45',NULL,NULL),(510,1848,'2014-01-06','A00619018','Accepted',1,'2014-01-14 23:10:26',NULL,'2014-01-24 09:42:58'),(973,2313,'2013-12-23','A00618919','Pending',1,'2014-01-15 09:02:48',NULL,NULL),(984,2324,'2013-12-31','A00618930','Pending',1,'2014-01-15 09:02:54',NULL,NULL),(28,181,NULL,NULL,'Accepted',1,'2014-01-02 05:07:08',NULL,'2014-01-13 03:05:07'),(69,222,NULL,NULL,'Accepted',1,'2014-01-02 05:07:27',1,'2014-01-02 06:06:27'),(230,563,'2013-12-14','DT689534','Pending',1,'2014-01-02 16:41:05',NULL,NULL),(470,1808,'2014-01-06','A00618974','Accepted',1,'2014-01-14 23:09:33',NULL,'2014-01-24 11:02:25'),(609,1948,'2013-12-23','A00618453','Pending',1,'2014-01-14 23:14:39',NULL,NULL),(36,189,NULL,NULL,'Accepted',1,'2014-01-02 05:07:12',NULL,'2014-01-13 03:05:09'),(440,1778,'2013-12-26','A00618920','Accepted',1,'2014-01-14 23:08:52',NULL,'2014-01-24 10:00:24'),(1096,2436,'2014-01-01','A00619084','Pending',1,'2014-01-15 09:04:06',NULL,NULL),(1123,2463,'2013-12-26','A00619137','Pending',1,'2014-01-15 09:04:26',NULL,NULL),(104,257,NULL,NULL,'Accepted',1,'2014-01-02 05:07:43',NULL,'2014-01-13 03:05:17'),(712,2051,'2013-12-30','A00618835','Pending',1,'2014-01-14 23:16:52',NULL,NULL),(899,2238,'2014-01-06','A00619085','Pending',1,'2014-01-15 00:19:37',NULL,NULL),(831,2170,'2014-01-06','A00619000','Pending',1,'2014-01-15 00:18:11',NULL,NULL),(1062,2402,'2014-01-06','A00619042','Pending',1,'2014-01-15 09:03:40',NULL,NULL),(85,238,NULL,NULL,'Accepted',1,'2014-01-02 05:07:35',NULL,'2014-01-13 03:05:17'),(181,334,NULL,NULL,'Accepted',1,'2014-01-02 05:08:19',1,'2014-01-02 06:06:53'),(619,1958,'2013-12-26','A00618467','Pending',1,'2014-01-14 23:14:50',NULL,NULL),(1038,2378,'2014-01-06','A00619012','Pending',1,'2014-01-15 09:03:25',NULL,NULL),(1040,2380,'2014-01-06','A00619014','Pending',1,'2014-01-15 09:03:26',NULL,NULL),(157,310,NULL,NULL,'Accepted',1,'2014-01-02 05:08:08',1,'2014-01-02 06:07:03'),(666,2005,'2013-12-20','A00618772','Pending',1,'2014-01-14 23:15:52',NULL,NULL),(768,2107,'2013-12-24','A00618912','Pending',1,'2014-01-14 23:18:04',NULL,NULL),(54,207,NULL,NULL,'Accepted',1,'2014-01-02 05:07:20',1,'2014-01-02 06:06:19'),(369,1707,'2013-12-23','A00618826','Accepted',1,'2014-01-14 23:07:23',NULL,'2014-01-24 11:00:26'),(1073,2413,'2014-01-06','A00619059','Pending',1,'2014-01-15 09:03:48',NULL,NULL),(1115,2455,'2014-01-06','A00619129','Pending',1,'2014-01-15 09:04:20',NULL,NULL),(124,277,NULL,NULL,'Accepted',1,'2014-01-02 05:07:52',NULL,'2014-01-13 03:05:11'),(156,309,NULL,NULL,'Accepted',1,'2014-01-02 05:08:07',NULL,'2014-01-13 03:05:16'),(253,1591,'2013-12-19','A00612120','Accepted',1,'2014-01-14 23:05:02',NULL,'2014-01-24 11:02:14'),(294,1632,'2013-12-24','A00618481','Accepted',1,'2014-01-14 23:05:51',NULL,'2014-01-24 11:01:37'),(427,1765,'2013-12-24','A00618906','Accepted',1,'2014-01-14 23:08:35',NULL,'2014-01-24 11:02:19'),(161,314,NULL,NULL,'Accepted',1,'2014-01-02 05:08:10',1,'2014-01-02 06:07:30'),(396,1734,'2013-12-24','A00618863','Accepted',1,'2014-01-14 23:07:56',NULL,'2014-01-24 11:01:26'),(949,2288,'2013-12-31','A00619165','Pending',1,'2014-01-15 00:20:40',NULL,NULL),(358,1696,'2013-12-30','A00618807','Accepted',1,'2014-01-14 23:07:09',NULL,'2014-01-24 10:02:25'),(1195,2535,'2014-01-14','A00623139','Pending',1,'2014-01-15 22:21:54',NULL,NULL),(263,1601,'2013-12-12','A00612971','Accepted',1,'2014-01-14 23:05:14',NULL,'2014-01-24 11:01:45'),(813,2152,'2014-01-06','A00618981','Pending',1,'2014-01-15 00:17:48',NULL,NULL),(1071,2411,'2014-01-06','A00619057','Pending',1,'2014-01-15 09:03:47',NULL,NULL),(86,239,NULL,NULL,'Accepted',1,'2014-01-02 05:07:35',1,'2014-01-02 06:07:09'),(250,1588,'2013-12-24','A00612102','Accepted',1,'2014-01-14 23:04:59',NULL,'2014-01-24 11:02:28'),(321,1659,'2013-12-24','A00618757','Accepted',1,'2014-01-14 23:06:25',NULL,'2014-01-24 11:01:16'),(366,1704,'2013-12-23','A00618820','Accepted',1,'2014-01-14 23:07:19',NULL,'2014-01-24 10:59:59'),(442,1780,'2014-01-03','A00618922','Accepted',1,'2014-01-14 23:08:54',NULL,'2014-01-24 11:01:25'),(1170,2510,'2013-12-30','A00622570','Pending',1,'2014-01-15 22:21:40',NULL,NULL),(129,282,NULL,NULL,'Accepted',1,'2014-01-02 05:07:55',1,'2014-01-02 06:07:26'),(47,200,NULL,NULL,'Accepted',1,'2014-01-02 05:07:17',NULL,'2014-01-13 03:04:40'),(487,1825,'2014-01-06','A00618991','Accepted',1,'2014-01-14 23:09:53',NULL,'2014-01-24 11:00:58'),(536,1874,'2013-12-23','A00619056','Accepted',1,'2014-01-14 23:11:00',NULL,'2014-01-24 10:02:29'),(730,2069,'2013-12-20','A00618858','Pending',1,'2014-01-14 23:17:14',NULL,NULL),(1149,2489,'2014-01-06','A00619168','Pending',1,'2014-01-15 09:04:44',NULL,NULL),(122,275,NULL,NULL,'Accepted',1,'2014-01-02 05:07:51',1,'2014-01-02 06:06:22'),(279,1617,'2014-01-07','A00618461','Accepted',1,'2014-01-14 23:05:33',NULL,'2014-01-24 11:02:17'),(939,2278,'2013-12-30','A00619155','Pending',1,'2014-01-15 00:20:27',NULL,NULL),(542,1880,'2014-01-06','A00619062','Accepted',1,'2014-01-14 23:11:08',NULL,'2014-01-24 10:01:13'),(673,2012,'2014-01-06','A00618782','Pending',1,'2014-01-14 23:16:02',NULL,NULL),(4,157,NULL,NULL,'Accepted',1,'2014-01-02 05:06:57',1,'2014-01-02 06:06:12'),(993,2333,'2014-01-06','A00618945','Pending',1,'2014-01-15 09:02:59',NULL,NULL),(214,367,NULL,NULL,'Accepted',1,'2014-01-02 05:08:34',1,'2014-01-02 06:07:33'),(823,2162,'2014-01-06','A00618991','Pending',1,'2014-01-15 00:18:01',NULL,NULL),(428,1766,'2013-12-31','A00618907','Accepted',1,'2014-01-14 23:08:36',NULL,'2014-01-24 10:59:40'),(107,260,NULL,NULL,'Accepted',1,'2014-01-02 05:07:45',1,'2014-01-02 06:06:48'),(1153,2493,'2013-12-30','A00619173','Pending',1,'2014-01-15 09:04:46',NULL,NULL),(569,1907,'2014-01-06','A00619091','Pending',1,'2014-01-14 23:11:44',NULL,NULL),(1023,2363,'2013-12-28','A00618994','Pending',1,'2014-01-15 09:03:16',NULL,NULL),(1191,2531,'2014-01-03','A00623126','Pending',1,'2014-01-15 22:21:52',NULL,NULL),(1219,2837,NULL,NULL,'Pending',0,'2014-03-04 09:28:50',NULL,NULL),(821,2160,'2013-12-23','A00618989','Pending',1,'2014-01-15 00:17:58',NULL,NULL),(581,1920,'2013-12-30','A00575738','Pending',1,'2014-01-14 23:14:08',NULL,NULL),(277,1615,'2013-12-26','A00618458','Accepted',1,'2014-01-14 23:05:31',NULL,'2014-01-24 11:02:26'),(650,1989,'2013-12-23','A00618733','Pending',1,'2014-01-14 23:15:26',NULL,NULL),(806,2145,'2014-01-06','A00618974','Pending',1,'2014-01-15 00:17:39',NULL,NULL),(1059,2399,'2013-12-23','A00619039','Pending',1,'2014-01-15 09:03:38',NULL,NULL),(1077,2417,'2013-12-27','A00619063','Pending',1,'2014-01-15 09:03:52',NULL,NULL),(330,1668,'2013-12-20','A00618772','Accepted',1,'2014-01-14 23:06:36',NULL,'2014-01-24 11:02:16'),(901,2240,'2013-12-27','A00619087','Pending',1,'2014-01-15 00:19:39',NULL,NULL),(1183,2523,'2014-01-06','A00622596','Pending',1,'2014-01-15 22:21:48',NULL,NULL),(287,1625,'2013-12-24','A00618471','Accepted',1,'2014-01-14 23:05:43',NULL,'2014-01-24 11:01:13'),(457,1795,'2013-12-30','A00618943','Accepted',1,'2014-01-14 23:09:17',NULL,'2014-01-24 10:30:41'),(672,2011,'2013-12-26','A00618780','Pending',1,'2014-01-14 23:16:01',NULL,NULL),(578,1917,'2013-12-23','A00400419','Pending',1,'2014-01-14 23:14:05',NULL,NULL),(647,1986,'2013-12-31','A00618729','Pending',1,'2014-01-14 23:15:23',NULL,NULL),(239,1577,'2014-01-09','A00011490','Accepted',1,'2014-01-14 23:04:45',NULL,'2014-01-24 11:02:28'),(323,1661,'2013-12-24','A00618762','Accepted',1,'2014-01-14 23:06:28',NULL,'2014-01-24 11:00:53'),(348,1686,'2013-12-19','A00618795','Accepted',1,'2014-01-14 23:06:57',NULL,'2014-01-24 11:02:21'),(633,1972,'2013-12-24','A00618485','Pending',1,'2014-01-14 23:15:06',NULL,NULL),(24,177,NULL,NULL,'Accepted',1,'2014-01-02 05:07:06',NULL,'2014-01-13 03:05:04'),(177,330,NULL,NULL,'Accepted',1,'2014-01-02 05:08:17',1,'2014-01-02 06:07:19'),(523,1861,'2014-01-01','A00619036','Accepted',1,'2014-01-14 23:10:43',NULL,'2014-01-24 08:32:04'),(626,1965,'2013-12-24','A00618475','Pending',1,'2014-01-14 23:14:58',NULL,NULL),(201,354,NULL,NULL,'Accepted',1,'2014-01-02 05:08:28',1,'2014-01-02 06:06:52'),(398,1736,'2013-12-24','A00618868','Accepted',1,'2014-01-14 23:07:59',NULL,'2014-01-24 10:59:03'),(270,1608,'2014-01-01','A00618449','Accepted',1,'2014-01-14 23:05:23',NULL,'2014-01-24 11:01:24'),(896,2235,'2014-01-06','A00619082','Pending',1,'2014-01-15 00:19:33',NULL,NULL),(1166,2506,'2013-12-31','A00622206','Pending',1,'2014-01-15 09:04:55',NULL,NULL),(922,2261,'2013-12-27','A00619134','Pending',1,'2014-01-15 00:20:07',NULL,NULL),(938,2277,'2014-01-06','A00619154','Pending',1,'2014-01-15 00:20:26',NULL,NULL),(933,2272,'2014-01-06','A00619147','Pending',1,'2014-01-15 00:20:20',NULL,NULL),(957,2296,'2013-12-30','A00619177','Pending',1,'2014-01-15 00:20:50',NULL,NULL),(477,1815,'2014-01-06','A00618981','Accepted',1,'2014-01-14 23:09:41',NULL,'2014-01-24 09:31:15'),(787,2126,'2013-12-26','A00618934','Pending',1,'2014-01-15 00:17:15',NULL,NULL),(40,193,NULL,NULL,'Accepted',1,'2014-01-02 05:07:14',NULL,'2014-01-13 03:05:18'),(223,376,NULL,NULL,'Accepted',1,'2014-01-02 05:08:38',1,'2014-01-02 06:07:31'),(479,1817,'2014-01-06','A00618983','Accepted',1,'2014-01-14 23:09:44',NULL,'2014-01-24 10:58:16'),(517,1855,'2014-01-06','A00619029','Accepted',1,'2014-01-14 23:10:35',NULL,'2014-01-24 10:30:23'),(526,1864,'2014-01-06','A00619040','Accepted',1,'2014-01-14 23:10:48',NULL,'2014-01-24 10:01:06'),(966,2305,'2013-12-26','A00621828','Pending',1,'2014-01-15 00:21:03',NULL,NULL),(265,1603,'2013-12-23','A00615014','Accepted',1,'2014-01-14 23:05:18',NULL,'2014-01-24 11:01:53'),(1209,2761,'2014-01-06','A00619060','Pending',1,'2014-01-29 13:39:55',NULL,NULL),(119,272,NULL,NULL,'Accepted',1,'2014-01-02 05:07:50',NULL,'2014-01-13 03:05:03'),(699,2038,'2013-12-24','A00618813','Pending',1,'2014-01-14 23:16:35',NULL,NULL),(778,2117,'2014-01-03','A00618922','Pending',1,'2014-01-15 00:17:04',NULL,NULL),(854,2193,'2014-01-06','A00619030','Pending',1,'2014-01-15 00:18:41',NULL,NULL),(869,2208,'2014-01-06','A00619049','Pending',1,'2014-01-15 00:18:59',NULL,NULL),(1120,2460,'2013-12-27','A00619134','Pending',1,'2014-01-15 09:04:24',NULL,NULL),(1127,2467,'2014-01-06','A00619141','Pending',1,'2014-01-15 09:04:29',NULL,NULL),(200,353,NULL,NULL,'Accepted',1,'2014-01-02 05:08:27',NULL,'2014-01-13 03:05:06'),(207,360,NULL,NULL,'Accepted',1,'2014-01-02 05:08:31',1,'2014-01-02 06:06:56'),(414,1752,'2013-12-23','A00618890','Accepted',1,'2014-01-14 23:08:19',NULL,'2014-01-24 11:02:12'),(604,1943,'2013-12-26','A00618444','Pending',1,'2014-01-14 23:14:33',NULL,NULL),(618,1957,'2013-12-24','A00618464','Pending',1,'2014-01-14 23:14:49',NULL,NULL),(795,2134,'2014-01-06','A00618945','Pending',1,'2014-01-15 00:17:24',NULL,NULL),(8,161,NULL,NULL,'Accepted',1,'2014-01-02 05:06:59',NULL,'2014-01-13 03:04:49'),(160,313,NULL,NULL,'Accepted',1,'2014-01-02 05:08:09',1,'2014-01-02 06:06:39'),(392,1730,'2013-12-24','A00618853','Accepted',1,'2014-01-14 23:07:50',NULL,'2014-01-24 11:01:58'),(1178,2518,'2014-01-09','A00622587','Pending',1,'2014-01-15 22:21:45',NULL,NULL),(357,1695,'2014-01-03','A00618805','Accepted',1,'2014-01-14 23:07:08',NULL,'2014-01-24 11:01:59'),(554,1892,'2014-01-06','A00619076','Accepted',1,'2014-01-14 23:11:25',NULL,'2014-01-24 10:58:46'),(919,2258,'2013-12-30','A00619131','Pending',1,'2014-01-15 00:20:03',NULL,NULL),(1066,2406,'2013-12-30','A00619048','Pending',1,'2014-01-15 09:03:43',NULL,NULL),(1174,2514,'2013-12-30','A00622579','Pending',1,'2014-01-15 22:21:42',NULL,NULL),(766,2105,'2013-12-26','A00618909','Pending',1,'2014-01-14 23:18:01',NULL,NULL),(1105,2445,'2013-12-23','A00619093','Pending',1,'2014-01-15 09:04:13',NULL,NULL),(997,2337,'2013-12-30','A00618966','Pending',1,'2014-01-15 09:03:01',NULL,NULL),(1132,2472,'2013-12-30','A00619148','Pending',1,'2014-01-15 09:04:32',NULL,NULL),(178,331,NULL,NULL,'Accepted',1,'2014-01-02 05:08:17',NULL,'2014-01-13 03:05:11'),(217,370,NULL,NULL,'Accepted',1,'2014-01-02 05:08:35',1,'2014-01-02 06:07:06'),(153,306,NULL,NULL,'Accepted',1,'2014-01-02 05:08:06',NULL,'2014-01-13 03:04:48'),(1125,2465,'2013-12-26','A00619139','Pending',1,'2014-01-15 09:04:28',NULL,NULL),(1177,2517,'2014-01-09','A00622586','Pending',1,'2014-01-15 22:21:44',NULL,NULL),(77,230,NULL,NULL,'Accepted',1,'2014-01-02 05:07:31',NULL,'2014-01-13 03:04:45'),(329,1667,'2013-12-23','A00618771','Accepted',1,'2014-01-14 23:06:34',NULL,'2014-01-24 11:01:55'),(395,1733,'2013-12-24','A00618859','Accepted',1,'2014-01-14 23:07:53',NULL,'2014-01-24 11:01:05'),(603,1942,'2013-12-26','A00618442','Pending',1,'2014-01-14 23:14:32',NULL,NULL),(664,2003,'2014-01-03','A00618770','Pending',1,'2014-01-14 23:15:50',NULL,NULL),(1095,2435,'2013-12-28','A00619083','Pending',1,'2014-01-15 09:04:05',NULL,NULL),(345,1683,'2013-12-24','A00618791','Accepted',1,'2014-01-14 23:06:52',NULL,'2014-01-24 10:01:31'),(481,1819,'2014-01-06','A00618985','Accepted',1,'2014-01-14 23:09:46',NULL,'2014-01-24 10:58:16'),(671,2010,'2013-12-23','A00618777','Pending',1,'2014-01-14 23:15:59',NULL,NULL),(1203,2545,'2014-01-06','A00622220','Pending',1,'2014-01-20 05:44:23',NULL,NULL),(539,1877,'2014-01-06','A00619059','Accepted',1,'2014-01-14 23:11:04',NULL,'2014-01-24 09:02:43'),(734,2073,'2013-12-24','A00618868','Pending',1,'2014-01-14 23:17:19',NULL,NULL),(931,2270,'2014-01-06','A00619143','Pending',1,'2014-01-15 00:20:18',NULL,NULL),(1083,2423,'2014-01-01','A00619071','Pending',1,'2014-01-15 09:03:55',NULL,NULL),(211,364,NULL,NULL,'Accepted',1,'2014-01-02 05:08:33',NULL,'2014-01-13 03:04:54'),(714,2053,'2013-12-30','A00618837','Pending',1,'2014-01-14 23:16:54',NULL,NULL),(1218,2770,'2014-01-06','A00619060','Accepted',1,'2014-01-29 13:47:43',0,'2014-03-11 01:29:56'),(192,345,NULL,NULL,'Accepted',1,'2014-01-02 05:08:24',1,'2014-01-02 06:07:28'),(446,1784,'2014-01-06','A00618926','Accepted',1,'2014-01-14 23:09:01',NULL,'2014-01-24 11:02:05'),(1022,2362,'2014-01-06','A00618992','Pending',1,'2014-01-15 09:03:15',NULL,NULL),(762,2101,'2013-12-24','A00618905','Pending',1,'2014-01-14 23:17:57',NULL,NULL),(1206,2548,'2013-12-30','A00622224','Pending',1,'2014-01-20 05:44:25',NULL,NULL),(31,184,NULL,NULL,'Accepted',1,'2014-01-02 05:07:10',NULL,'2014-01-13 03:04:49'),(448,1786,'2014-01-06','A00618928','Accepted',1,'2014-01-14 23:09:03',NULL,'2014-01-24 10:31:46'),(685,2024,'2014-01-02','A00618796','Pending',1,'2014-01-14 23:16:17',NULL,NULL),(337,1675,'2014-01-06','A00618782','Accepted',1,'2014-01-14 23:06:43',NULL,'2014-01-24 11:01:14'),(987,2327,'2014-01-06','A00618937','Pending',1,'2014-01-15 09:02:55',NULL,NULL),(829,2168,'2014-01-06','A00618998','Pending',1,'2014-01-15 00:18:08',NULL,NULL),(956,2295,'2014-01-01','A00619175','Pending',1,'2014-01-15 00:20:49',NULL,NULL),(1019,2359,'2013-12-23','A00618989','Pending',1,'2014-01-15 09:03:13',NULL,NULL),(126,279,NULL,NULL,'Accepted',1,'2014-01-02 05:07:53',NULL,'2014-01-13 03:04:57'),(299,1637,'2013-12-23','A00618487','Accepted',1,'2014-01-14 23:05:56',NULL,'2014-01-24 10:59:05'),(355,1693,'2014-01-02','A00618803','Accepted',1,'2014-01-14 23:07:06',NULL,'2014-01-24 10:59:34'),(389,1727,'2013-12-23','A00618849','Accepted',1,'2014-01-14 23:07:46',NULL,'2014-01-24 11:02:23'),(271,1609,'2013-12-30','A00618450','Accepted',1,'2014-01-14 23:05:25',NULL,'2014-01-24 11:02:07'),(838,2177,'2013-12-31','A00619010','Pending',1,'2014-01-15 00:18:20',NULL,NULL),(679,2018,'2013-12-30','A00618789','Pending',1,'2014-01-14 23:16:09',NULL,NULL),(837,2176,'2014-01-06','A00619009','Pending',1,'2014-01-15 00:18:18',NULL,NULL),(1003,2343,'2014-01-01','A00618973','Pending',1,'2014-01-15 09:03:04',NULL,NULL),(317,1655,'2013-12-31','A00618751','Accepted',1,'2014-01-14 23:06:17',NULL,'2014-01-24 11:02:04'),(505,1843,'2014-01-06','A00619013','Accepted',1,'2014-01-14 23:10:18',NULL,'2014-01-24 10:32:23'),(728,2067,'2013-12-24','A00618853','Pending',1,'2014-01-14 23:17:11',NULL,NULL),(979,2319,'2013-12-27','A00618925','Pending',1,'2014-01-15 09:02:51',NULL,NULL),(51,204,NULL,NULL,'Accepted',1,'2014-01-02 05:07:19',1,'2014-01-02 06:07:22'),(639,1978,'2013-12-23','A00618493','Pending',1,'2014-01-14 23:15:13',NULL,NULL),(645,1984,'2013-12-24','A00618707','Pending',1,'2014-01-14 23:15:20',NULL,NULL),(724,2063,'2013-12-26','A00618848','Pending',1,'2014-01-14 23:17:07',NULL,NULL),(222,375,NULL,NULL,'Accepted',1,'2014-01-02 05:08:38',NULL,'2014-01-13 03:04:48'),(689,2028,'2013-12-19','A00618801','Pending',1,'2014-01-14 23:16:23',NULL,NULL),(892,2231,'2014-01-06','A00619078','Pending',1,'2014-01-15 00:19:27',NULL,NULL),(961,2300,'2014-01-06','A00619182','Pending',1,'2014-01-15 00:20:55',NULL,NULL),(71,224,NULL,NULL,'Accepted',1,'2014-01-02 05:07:28',NULL,'2014-01-13 03:05:09'),(319,1657,'2013-12-30','A00618753','Accepted',1,'2014-01-14 23:06:19',NULL,'2014-01-24 11:02:07'),(592,1931,'2013-12-31','A00612139','Pending',1,'2014-01-14 23:14:20',NULL,NULL),(612,1951,'2013-12-27','A00618457','Pending',1,'2014-01-14 23:14:43',NULL,NULL),(663,2002,'2013-12-24','A00618768','Pending',1,'2014-01-14 23:15:49',NULL,NULL),(1021,2361,'2014-01-06','A00618991','Pending',1,'2014-01-15 09:03:15',NULL,NULL),(343,1681,'2013-12-30','A00618789','Accepted',1,'2014-01-14 23:06:50',NULL,'2014-01-24 10:58:41'),(547,1885,'2013-12-31','A00619069','Accepted',1,'2014-01-14 23:11:14',NULL,'2014-01-24 11:01:08'),(1208,2550,'2014-01-06','A00622226','Pending',1,'2014-01-20 05:44:25',NULL,NULL),(1220,2838,NULL,NULL,'Pending',0,'2014-03-04 09:29:00',NULL,NULL),(458,1796,'2014-01-06','A00618944','Accepted',1,'2014-01-14 23:09:18',NULL,'2014-01-24 10:59:56'),(859,2198,'2014-01-01','A00619036','Pending',1,'2014-01-15 00:18:47',NULL,NULL),(921,2260,'2014-01-06','A00619133','Pending',1,'2014-01-15 00:20:06',NULL,NULL),(704,2043,'2013-12-23','A00618825','Pending',1,'2014-01-14 23:16:41',NULL,NULL),(710,2049,'2014-01-01','A00618833','Pending',1,'2014-01-14 23:16:49',NULL,NULL),(1030,2370,'2014-01-06','A00619001','Pending',1,'2014-01-15 09:03:20',NULL,NULL),(1094,2434,'2014-01-06','A00619082','Pending',1,'2014-01-15 09:04:03',NULL,NULL),(1142,2482,'2014-01-06','A00619160','Pending',1,'2014-01-15 09:04:39',NULL,NULL),(688,2027,'2013-12-23','A00618800','Pending',1,'2014-01-14 23:16:22',NULL,NULL),(1041,2381,'2014-01-06','A00619015','Pending',1,'2014-01-15 09:03:27',NULL,NULL),(920,2259,'2013-12-26','A00619132','Pending',1,'2014-01-15 00:20:05',NULL,NULL),(682,2021,'2013-12-30','A00618792','Pending',1,'2014-01-14 23:16:13',NULL,NULL),(694,2033,'2013-12-30','A00618807','Pending',1,'2014-01-14 23:16:29',NULL,NULL),(194,347,NULL,NULL,'Accepted',1,'2014-01-02 05:08:25',NULL,'2014-01-13 03:05:00'),(367,1705,'2013-12-30','A00618824','Accepted',1,'2014-01-14 23:07:20',NULL,'2014-01-24 10:58:29'),(723,2062,'2013-12-19','A00618847','Pending',1,'2014-01-14 23:17:06',NULL,NULL),(374,1712,'2014-01-01','A00618833','Accepted',1,'2014-01-14 23:07:29',NULL,'2014-01-24 10:58:29'),(602,1941,'2013-12-24','A00615015','Pending',1,'2014-01-14 23:14:31',NULL,NULL),(1114,2454,'2014-01-06','A00619128','Pending',1,'2014-01-15 09:04:20',NULL,NULL),(1181,2521,'2014-01-08','A00622593','Pending',1,'2014-01-15 22:21:47',NULL,NULL),(320,1658,'2013-12-24','A00618756','Accepted',1,'2014-01-14 23:06:24',NULL,'2014-01-24 11:00:15'),(452,1790,'2013-12-30','A00618935','Accepted',1,'2014-01-14 23:09:09',NULL,'2014-01-24 11:02:10'),(943,2282,'2014-01-10','A00619159','Pending',1,'2014-01-15 00:20:33',NULL,NULL),(197,350,NULL,NULL,'Accepted',1,'2014-01-02 05:08:26',NULL,'2014-01-13 03:04:46'),(549,1887,'2014-01-01','A00619071','Accepted',1,'2014-01-14 23:11:18',NULL,'2014-01-24 10:59:33'),(257,1595,'2014-01-01','A00612141','Accepted',1,'2014-01-14 23:05:07',NULL,'2014-01-24 11:01:49'),(349,1687,'2014-01-02','A00618796','Accepted',1,'2014-01-14 23:06:58',NULL,'2014-01-24 11:01:58'),(29,182,NULL,NULL,'Accepted',1,'2014-01-02 05:07:09',NULL,'2014-01-13 03:04:50'),(195,348,NULL,NULL,'Pending',1,'2014-01-02 05:08:25',NULL,NULL),(471,1809,'2014-01-06','A00618975','Accepted',1,'2014-01-14 23:09:34',NULL,'2014-01-24 11:01:40'),(649,1988,'2013-12-24','A00618732','Pending',1,'2014-01-14 23:15:25',NULL,NULL),(1000,2340,'2014-01-06','A00618970','Pending',1,'2014-01-15 09:03:03',NULL,NULL),(139,292,NULL,NULL,'Accepted',1,'2014-01-02 05:07:59',NULL,'2014-01-13 03:05:18'),(185,338,NULL,NULL,'Accepted',1,'2014-01-02 05:08:21',NULL,'2014-01-13 03:04:52'),(537,1875,'2014-01-06','A00619057','Accepted',1,'2014-01-14 23:11:02',NULL,'2014-01-24 06:30:32'),(1152,2492,'2013-12-27','A00619172','Pending',1,'2014-01-15 09:04:45',NULL,NULL),(49,202,NULL,NULL,'Accepted',1,'2014-01-02 05:07:18',NULL,'2014-01-13 03:05:18'),(532,1870,'2013-12-30','A00619048','Accepted',1,'2014-01-14 23:10:55',1,'2014-01-24 06:17:09'),(109,262,NULL,NULL,'Accepted',1,'2014-01-02 05:07:45',1,'2014-01-02 06:07:25'),(123,276,NULL,NULL,'Accepted',1,'2014-01-02 05:07:52',NULL,'2014-01-13 03:05:20'),(444,1782,'2014-01-06','A00618924','Accepted',1,'2014-01-14 23:08:57',NULL,'2014-01-24 11:02:24'),(334,1672,'2013-12-31','A00618776','Accepted',1,'2014-01-14 23:06:40',NULL,'2014-01-24 11:01:53'),(1159,2499,'2014-01-06','A00619182','Pending',1,'2014-01-15 09:04:50',NULL,NULL),(105,258,NULL,NULL,'Accepted',1,'2014-01-02 05:07:44',1,'2014-01-02 06:06:38'),(705,2044,'2013-12-23','A00618826','Pending',1,'2014-01-14 23:16:43',NULL,NULL),(748,2087,'2013-12-24','A00618887','Pending',1,'2014-01-14 23:17:38',NULL,NULL),(648,1987,'2013-12-31','A00618730','Pending',1,'2014-01-14 23:15:24',NULL,NULL),(43,196,NULL,NULL,'Accepted',1,'2014-01-02 05:07:15',1,'2014-01-02 06:07:23'),(98,251,NULL,NULL,'Accepted',1,'2014-01-02 05:07:40',1,'2014-01-02 06:06:16'),(468,1806,'2014-01-10','A00618972','Accepted',1,'2014-01-14 23:09:31',NULL,'2014-01-24 10:58:34'),(844,2183,'2014-01-08','A00619016','Pending',1,'2014-01-15 00:18:27',NULL,NULL),(193,346,NULL,NULL,'Accepted',1,'2014-01-02 05:08:24',NULL,'2014-01-13 03:04:39'),(805,2144,'2014-01-01','A00618973','Pending',1,'2014-01-15 00:17:38',NULL,NULL),(1112,2452,'2014-01-06','A00619126','Pending',1,'2014-01-15 09:04:18',NULL,NULL),(179,332,NULL,NULL,'Accepted',1,'2014-01-02 05:08:18',1,'2014-01-02 06:06:23'),(252,1590,'2013-12-26','A00612112','Accepted',1,'2014-01-14 23:05:01',NULL,'2014-01-24 11:01:56'),(272,1610,'2014-01-02','A00618451','Accepted',1,'2014-01-14 23:05:26',NULL,'2014-01-24 11:02:10'),(702,2041,'2013-12-23','A00618820','Pending',1,'2014-01-14 23:16:39',NULL,NULL),(76,229,NULL,NULL,'Accepted',1,'2014-01-02 05:07:30',NULL,'2014-01-13 03:05:07'),(499,1837,'2014-01-06','A00619005','Accepted',1,'2014-01-14 23:10:10',NULL,'2014-01-24 10:58:42'),(667,2006,'2013-12-24','A00618773','Pending',1,'2014-01-14 23:15:53',NULL,NULL),(1137,2477,'2013-12-30','A00619155','Pending',1,'2014-01-15 09:04:35',NULL,NULL),(753,2092,'2014-01-02','A00618894','Pending',1,'2014-01-14 23:17:44',NULL,NULL),(1078,2418,'2014-01-06','A00619064','Pending',1,'2014-01-15 09:03:52',NULL,NULL),(902,2241,'2014-01-02','A00619088','Pending',1,'2014-01-15 00:19:41',NULL,NULL),(16,169,NULL,NULL,'Accepted',1,'2014-01-02 05:07:03',NULL,'2014-01-13 03:04:44'),(1025,2365,'2014-01-06','A00618996','Pending',1,'2014-01-15 09:03:17',NULL,NULL),(273,1611,'2013-12-23','A00618453','Accepted',1,'2014-01-14 23:05:27',NULL,'2014-01-24 11:02:31'),(281,1619,'2013-12-24','A00618463','Accepted',1,'2014-01-14 23:05:37',NULL,'2014-01-24 11:01:06'),(530,1868,'2013-12-20','A00619045','Accepted',1,'2014-01-14 23:10:53',NULL,'2014-01-24 09:02:13'),(863,2202,'2013-12-28','A00619041','Pending',1,'2014-01-15 00:18:52',NULL,NULL),(1029,2369,'2014-01-06','A00619000','Pending',1,'2014-01-15 09:03:19',NULL,NULL),(417,1755,'2014-01-02','A00618894','Accepted',1,'2014-01-14 23:08:23',NULL,'2014-01-24 10:58:55'),(482,1820,'2014-01-06','A00618986','Accepted',1,'2014-01-14 23:09:48',NULL,'2014-01-24 11:00:43'),(846,2185,'2014-01-06','A00619018','Pending',1,'2014-01-15 00:18:30',NULL,NULL),(874,2213,'2014-01-06','A00619058','Pending',1,'2014-01-15 00:19:04',NULL,NULL),(1189,2529,'2014-01-01','A00623110','Pending',1,'2014-01-15 22:21:50',NULL,NULL),(148,301,NULL,NULL,'Accepted',1,'2014-01-02 05:08:04',1,'2014-01-02 06:07:18'),(557,1895,'2013-12-27','A00619079','Accepted',1,'2014-01-14 23:11:29',NULL,'2014-01-24 07:02:24'),(52,205,NULL,NULL,'Accepted',1,'2014-01-02 05:07:19',1,'2014-01-02 06:06:57'),(628,1967,'2013-12-23','A00618478','Pending',1,'2014-01-14 23:15:00',NULL,NULL),(1018,2358,'2013-12-23','A00618988','Pending',1,'2014-01-15 09:03:13',NULL,NULL),(41,194,NULL,NULL,'Accepted',1,'2014-01-02 05:07:14',NULL,'2014-01-13 03:04:42'),(46,199,NULL,NULL,'Accepted',1,'2014-01-02 05:07:17',NULL,'2014-01-13 03:04:55'),(297,1635,'2013-12-24','A00618485','Accepted',1,'2014-01-14 23:05:54',NULL,'2014-01-24 11:02:16'),(546,1884,'2013-12-26','A00619068','Accepted',1,'2014-01-14 23:11:13',1,'2014-01-24 06:18:56'),(820,2159,'2013-12-23','A00618988','Pending',1,'2014-01-15 00:17:57',NULL,NULL),(1093,2433,'2013-12-30','A00619081','Pending',1,'2014-01-15 09:04:02',NULL,NULL),(751,2090,'2013-12-24','A00618891','Pending',1,'2014-01-14 23:17:42',NULL,NULL),(101,254,NULL,NULL,'Accepted',1,'2014-01-02 05:07:42',NULL,'2014-01-13 03:04:55'),(421,1759,'2013-12-24','A00618898','Accepted',1,'2014-01-14 23:08:28',NULL,'2014-01-24 11:01:43'),(773,2112,'2013-12-31','A00618917','Pending',1,'2014-01-14 23:18:11',NULL,NULL),(942,2281,'2014-01-06','A00619158','Pending',1,'2014-01-15 00:20:31',NULL,NULL),(969,2308,'2014-01-06','A00622208','Pending',1,'2014-01-15 00:21:07',NULL,NULL),(1020,2360,'2013-12-23','A00618990','Pending',1,'2014-01-15 09:03:14',NULL,NULL),(379,1717,'2013-12-23','A00618838','Accepted',1,'2014-01-14 23:07:34',NULL,'2014-01-24 11:01:03'),(1171,2511,'2013-12-30','A00622574','Pending',1,'2014-01-15 22:21:40',NULL,NULL),(404,1742,'2013-12-31','A00618878','Accepted',1,'2014-01-14 23:08:06',NULL,'2014-01-24 11:00:03'),(535,1873,'2014-01-06','A00619054','Accepted',1,'2014-01-14 23:10:59',NULL,'2014-01-24 10:59:54'),(630,1969,'2013-12-24','A00618481','Pending',1,'2014-01-14 23:15:02',NULL,NULL),(985,2325,'2013-12-26','A00618934','Pending',1,'2014-01-15 09:02:54',NULL,NULL),(133,286,NULL,NULL,'Accepted',1,'2014-01-02 05:07:57',NULL,'2014-01-13 03:04:56'),(142,295,NULL,NULL,'Accepted',1,'2014-01-02 05:08:01',1,'2014-01-02 06:07:32'),(342,1680,'2013-12-26','A00618788','Accepted',1,'2014-01-14 23:06:49',NULL,'2014-01-24 11:01:42'),(875,2214,'2014-01-06','A00619059','Pending',1,'2014-01-15 00:19:06',NULL,NULL),(11,164,NULL,NULL,'Accepted',1,'2014-01-02 05:07:00',1,'2014-01-02 06:06:36'),(779,2118,'2014-01-01','A00618923','Pending',1,'2014-01-15 00:17:05',NULL,NULL),(1035,2375,'2014-01-06','A00619009','Pending',1,'2014-01-15 09:03:23',NULL,NULL),(1109,2449,'2014-01-01','A00619097','Pending',1,'2014-01-15 09:04:16',NULL,NULL),(454,1792,'2014-01-06','A00618940','Accepted',1,'2014-01-14 23:09:12',NULL,'2014-01-24 11:01:33'),(680,2019,'2014-01-02','A00618790','Pending',1,'2014-01-14 23:16:10',NULL,NULL),(709,2048,'2013-12-24','A00618830','Pending',1,'2014-01-14 23:16:47',NULL,NULL),(932,2271,'2014-01-06','A00619144','Pending',1,'2014-01-15 00:20:19',NULL,NULL),(1034,2374,'2014-01-01','A00619007','Pending',1,'2014-01-15 09:03:22',NULL,NULL),(39,192,NULL,NULL,'Accepted',1,'2014-01-02 05:07:13',NULL,'2014-01-13 03:05:08'),(219,372,NULL,NULL,'Accepted',1,'2014-01-02 05:08:36',1,'2014-01-02 06:07:14'),(261,1599,'2013-12-24','A00612969','Accepted',1,'2014-01-14 23:05:11',NULL,'2014-01-24 11:01:13'),(653,1992,'2013-12-31','A00618751','Pending',1,'2014-01-14 23:15:31',NULL,NULL),(668,2007,'2014-01-06','A00618774','Pending',1,'2014-01-14 23:15:55',NULL,NULL),(686,2025,'2013-12-24','A00618798','Pending',1,'2014-01-14 23:16:18',NULL,NULL),(715,2054,'2013-12-23','A00618838','Pending',1,'2014-01-14 23:16:55',NULL,NULL),(1058,2398,'2013-12-23','A00619037','Pending',1,'2014-01-15 09:03:37',NULL,NULL),(1075,2415,'2013-12-23','A00619061','Pending',1,'2014-01-15 09:03:50',NULL,NULL),(1156,2496,'2014-01-06','A00619178','Pending',1,'2014-01-15 09:04:48',NULL,NULL),(558,1896,'2014-01-06','A00619080','Accepted',1,'2014-01-14 23:11:30',NULL,'2014-01-24 00:30:44'),(674,2013,'2013-12-23','A00618783','Pending',1,'2014-01-14 23:16:04',NULL,NULL),(402,1740,'2013-12-23','A00618875','Accepted',1,'2014-01-14 23:08:04',NULL,'2014-01-24 11:01:21'),(641,1980,'2013-12-24','A00618495','Pending',1,'2014-01-14 23:15:16',NULL,NULL),(483,1821,'2014-01-06','A00618987','Accepted',1,'2014-01-14 23:09:49',NULL,'2014-01-24 11:01:50'),(541,1879,'2013-12-23','A00619061','Accepted',1,'2014-01-14 23:11:07',NULL,'2014-01-24 04:40:14'),(884,2223,'2014-01-06','A00619070','Pending',1,'2014-01-15 00:19:17',NULL,NULL),(50,203,NULL,NULL,'Accepted',1,'2014-01-02 05:07:18',NULL,'2014-01-13 03:05:08'),(527,1865,'2013-12-28','A00619041','Accepted',1,'2014-01-14 23:10:49',NULL,'2014-01-24 07:13:21'),(828,2167,'2014-01-06','A00618997','Pending',1,'2014-01-15 00:18:07',NULL,NULL),(415,1753,'2013-12-24','A00618891','Accepted',1,'2014-01-14 23:08:21',NULL,'2014-01-24 11:00:55'),(954,2293,'2013-12-27','A00619172','Pending',1,'2014-01-15 00:20:47',NULL,NULL),(1204,2546,'2013-12-30','A00622222','Pending',1,'2014-01-20 05:44:24',NULL,NULL),(226,379,NULL,NULL,'Accepted',1,'2014-01-02 05:08:39',1,'2014-01-02 06:06:31'),(255,1593,'2013-12-24','A00612132','Accepted',1,'2014-01-14 23:05:04',NULL,'2014-01-24 11:02:22'),(1160,2500,'2013-12-31','A00619183','Pending',1,'2014-01-15 09:04:51',NULL,NULL),(851,2190,'2013-12-26','A00619026','Pending',1,'2014-01-15 00:18:38',NULL,NULL),(534,1872,'2014-01-06','A00619052','Accepted',1,'2014-01-14 23:10:58',NULL,'2014-01-24 08:02:09'),(1063,2403,'2014-01-06','A00619043','Pending',1,'2014-01-15 09:03:41',NULL,NULL),(708,2047,'2014-01-01','A00618829','Pending',1,'2014-01-14 23:16:46',NULL,NULL),(149,302,NULL,NULL,'Accepted',1,'2014-01-02 05:08:04',1,'2014-01-02 06:06:20'),(220,373,NULL,NULL,'Accepted',1,'2014-01-02 05:08:37',1,'2014-01-02 06:06:29'),(856,2195,'2014-01-06','A00619033','Pending',1,'2014-01-15 00:18:44',NULL,NULL),(553,1891,'2013-12-31','A00619075','Accepted',1,'2014-01-14 23:11:23',NULL,'2014-01-24 09:01:53'),(801,2140,'2014-01-06','A00618969','Pending',1,'2014-01-15 00:17:32',NULL,NULL),(110,263,NULL,NULL,'Accepted',1,'2014-01-02 05:07:46',NULL,'2014-01-13 03:05:15'),(473,1811,'2014-01-06','A00618977','Accepted',1,'2014-01-14 23:09:37',NULL,'2014-01-24 10:59:48'),(792,2131,'2014-01-06','A00618942','Pending',1,'2014-01-15 00:17:20',NULL,NULL),(879,2218,'2013-12-27','A00619063','Pending',1,'2014-01-15 00:19:11',NULL,NULL),(1089,2429,'2014-01-08','A00619077','Pending',1,'2014-01-15 09:04:00',NULL,NULL),(516,1854,'2013-12-31','A00619027','Accepted',1,'2014-01-14 23:10:34',NULL,'2014-01-24 07:36:10'),(655,1994,'2013-12-30','A00618753','Pending',1,'2014-01-14 23:15:33',NULL,NULL),(232,565,'2013-12-18','DT2442979 ','Pending',1,'2014-01-02 16:41:08',NULL,NULL),(977,2317,'2014-01-01','A00618923','Pending',1,'2014-01-15 09:02:50',NULL,NULL),(1179,2519,'2013-12-30','A00622589','Pending',1,'2014-01-15 22:21:46',NULL,NULL),(30,183,NULL,NULL,'Accepted',1,'2014-01-02 05:07:09',NULL,'2014-01-13 03:05:10'),(508,1846,'2014-01-08','A00619016','Accepted',1,'2014-01-14 23:10:22',NULL,'2014-01-24 10:59:53'),(591,1930,'2013-12-24','A00612132','Pending',1,'2014-01-14 23:14:19',NULL,NULL),(359,1697,'2014-01-02','A00618809','Accepted',1,'2014-01-14 23:07:10',NULL,'2014-01-24 11:01:28'),(692,2031,'2013-12-24','A00618804','Pending',1,'2014-01-14 23:16:27',NULL,NULL),(729,2068,'2013-12-24','A00618854','Pending',1,'2014-01-14 23:17:13',NULL,NULL),(198,351,NULL,NULL,'Accepted',1,'2014-01-02 05:08:27',1,'2014-01-02 06:06:37'),(292,1630,'2013-12-23','A00618478','Accepted',1,'2014-01-14 23:05:49',NULL,'2014-01-24 11:02:17'),(213,366,NULL,NULL,'Accepted',1,'2014-01-02 05:08:33',1,'2014-01-02 06:06:18'),(876,2215,'2014-01-06','A00619060','Pending',1,'2014-01-15 00:19:08',NULL,NULL),(1036,2376,'2013-12-31','A00619010','Pending',1,'2014-01-15 09:03:24',NULL,NULL),(1099,2439,'2013-12-27','A00619087','Pending',1,'2014-01-15 09:04:08',NULL,NULL),(151,304,NULL,NULL,'Accepted',1,'2014-01-02 05:08:05',1,'2014-01-02 06:07:21'),(346,1684,'2013-12-30','A00618792','Accepted',1,'2014-01-14 23:06:53',NULL,'2014-01-24 11:02:13'),(423,1761,'2013-12-24','A00618901','Accepted',1,'2014-01-14 23:08:30',NULL,'2014-01-24 10:59:42'),(150,303,NULL,NULL,'Accepted',1,'2014-01-02 05:08:04',NULL,'2014-01-13 03:05:01'),(377,1715,'2013-12-20','A00618836','Accepted',1,'2014-01-14 23:07:32',NULL,'2014-01-24 11:02:23'),(459,1797,'2014-01-06','A00618945','Accepted',1,'2014-01-14 23:09:19',NULL,'2014-01-24 11:00:20'),(796,2135,'2014-01-06','A00618946','Pending',1,'2014-01-15 00:17:26',NULL,NULL),(1180,2520,'2013-12-30','A00622590','Pending',1,'2014-01-15 22:21:46',NULL,NULL),(336,1674,'2013-12-26','A00618780','Accepted',1,'2014-01-14 23:06:42',NULL,'2014-01-24 11:01:57'),(978,2318,'2014-01-06','A00618924','Pending',1,'2014-01-15 09:02:50',NULL,NULL),(700,2039,'2013-12-23','A00618816','Pending',1,'2014-01-14 23:16:37',NULL,NULL),(960,2299,'2013-12-30','A00619181','Pending',1,'2014-01-15 00:20:54',NULL,NULL),(15,168,NULL,NULL,'Accepted',1,'2014-01-02 05:07:02',NULL,'2014-01-13 03:04:46'),(1194,2534,'2014-01-06','A00623137','Pending',1,'2014-01-15 22:21:53',NULL,NULL),(652,1991,'2013-12-24','A00618750','Pending',1,'2014-01-14 23:15:29',NULL,NULL),(706,2045,'2013-12-24','A00618827','Pending',1,'2014-01-14 23:16:44',NULL,NULL),(909,2248,'2013-12-30','A00619095','Pending',1,'2014-01-15 00:19:49',NULL,NULL),(962,2301,'2013-12-31','A00619183','Pending',1,'2014-01-15 00:20:57',NULL,NULL),(212,365,NULL,NULL,'Accepted',1,'2014-01-02 05:08:33',1,'2014-01-02 06:06:26'),(469,1807,'2014-01-01','A00618973','Accepted',1,'2014-01-14 23:09:32',NULL,'2014-01-24 11:02:00'),(13,166,NULL,NULL,'Accepted',1,'2014-01-02 05:07:01',NULL,'2014-01-13 03:04:46'),(394,1732,'2013-12-20','A00618858','Accepted',1,'2014-01-14 23:07:52',NULL,'2014-01-24 10:59:57'),(397,1735,'2013-12-23','A00618864','Accepted',1,'2014-01-14 23:07:58',NULL,'2014-01-24 11:02:27'),(1157,2497,'2014-01-01','A00619179','Pending',1,'2014-01-15 09:04:49',NULL,NULL),(453,1791,'2014-01-06','A00618937','Accepted',1,'2014-01-14 23:09:11',NULL,'2014-01-24 10:59:21'),(584,1923,'2013-12-24','A00612100','Pending',1,'2014-01-14 23:14:11',NULL,NULL),(1086,2426,'2014-01-01','A00619074','Pending',1,'2014-01-15 09:03:58',NULL,NULL),(84,237,NULL,NULL,'Accepted',1,'2014-01-02 05:07:34',NULL,'2014-01-13 03:05:13'),(788,2127,'2013-12-30','A00618935','Pending',1,'2014-01-15 00:17:16',NULL,NULL),(1107,2447,'2013-12-30','A00619095','Pending',1,'2014-01-15 09:04:14',NULL,NULL),(717,2056,'2013-12-26','A00618841','Pending',1,'2014-01-14 23:16:58',NULL,NULL),(754,2093,'2014-01-01','A00618895','Pending',1,'2014-01-14 23:17:46',NULL,NULL),(316,1654,'2013-12-24','A00618750','Accepted',1,'2014-01-14 23:06:16',NULL,'2014-01-24 10:59:44'),(640,1979,'2014-01-01','A00618494','Pending',1,'2014-01-14 23:15:14',NULL,NULL),(951,2290,'2014-01-06','A00619168','Pending',1,'2014-01-15 00:20:43',NULL,NULL),(1060,2400,'2014-01-06','A00619040','Pending',1,'2014-01-15 09:03:39',NULL,NULL),(94,247,NULL,NULL,'Accepted',1,'2014-01-02 05:07:39',NULL,'2014-01-13 03:05:14'),(216,369,NULL,NULL,'Accepted',1,'2014-01-02 05:08:35',NULL,'2014-01-13 03:04:47'),(433,1771,'2013-12-26','A00618913','Accepted',1,'2014-01-14 23:08:43',NULL,'2014-01-24 10:59:55'),(624,1963,'2013-12-24','A00618473','Pending',1,'2014-01-14 23:14:56',NULL,NULL),(713,2052,'2013-12-20','A00618836','Pending',1,'2014-01-14 23:16:53',NULL,NULL),(1140,2480,'2014-01-06','A00619158','Pending',1,'2014-01-15 09:04:37',NULL,NULL),(48,201,NULL,NULL,'Accepted',1,'2014-01-02 05:07:17',NULL,'2014-01-13 03:04:49'),(227,560,'2013-12-20','DT1675008','Pending',1,'2014-01-02 16:41:01',NULL,NULL),(577,1916,'2013-12-23','A00340181','Pending',1,'2014-01-14 23:14:04',NULL,NULL),(249,1587,'2013-12-23','A00612101','Accepted',1,'2014-01-14 23:04:58',NULL,'2014-01-24 11:02:29'),(361,1699,'2013-12-30','A00618811','Accepted',1,'2014-01-14 23:07:13',NULL,'2014-01-24 10:31:03'),(174,327,NULL,NULL,'Accepted',1,'2014-01-02 05:08:16',NULL,'2014-01-13 03:05:13'),(59,212,NULL,NULL,'Accepted',1,'2014-01-02 05:07:22',NULL,'2014-01-13 03:05:02'),(948,2287,'2014-01-08','A00619164','Pending',1,'2014-01-15 00:20:39',NULL,NULL),(561,1899,'2013-12-28','A00619083','Pending',1,'2014-01-14 23:11:33',NULL,NULL),(1196,2536,'2013-12-30','A00623193','Pending',1,'2014-01-15 22:21:55',NULL,NULL),(340,1678,'2013-12-26','A00618785','Accepted',1,'2014-01-14 23:06:47',NULL,'2014-01-24 10:31:36'),(669,2008,'2013-12-26','A00618775','Pending',1,'2014-01-14 23:15:57',NULL,NULL),(811,2150,'2014-01-06','A00618979','Pending',1,'2014-01-15 00:17:46',NULL,NULL),(812,2151,'2014-01-02','A00618980','Pending',1,'2014-01-15 00:17:47',NULL,NULL),(315,1653,'2013-12-24','A00618734','Accepted',1,'2014-01-14 23:06:15',NULL,'2014-01-24 11:01:16'),(1001,2341,'2014-01-06','A00618971','Pending',1,'2014-01-15 09:03:03',NULL,NULL),(111,264,NULL,NULL,'Accepted',1,'2014-01-02 05:07:46',NULL,'2014-01-13 03:04:41'),(173,326,NULL,NULL,'Accepted',1,'2014-01-02 05:08:15',NULL,'2014-01-07 11:00:01'),(390,1728,'2013-12-19','A00618851','Accepted',1,'2014-01-14 23:07:48',NULL,'2014-01-24 10:59:14'),(622,1961,'2013-12-24','A00618470','Pending',1,'2014-01-14 23:14:53',NULL,NULL),(1002,2342,'2014-01-10','A00618972','Pending',1,'2014-01-15 09:03:04',NULL,NULL),(432,1770,'2013-12-24','A00618912','Accepted',1,'2014-01-14 23:08:41',NULL,'2014-01-24 10:58:28'),(409,1747,'2013-12-24','A00618884','Accepted',1,'2014-01-14 23:08:13',NULL,'2014-01-24 11:02:32'),(5,158,NULL,NULL,'Accepted',1,'2014-01-02 05:06:58',NULL,'2014-01-13 03:04:45'),(32,185,NULL,NULL,'Accepted',1,'2014-01-02 05:07:10',NULL,'2014-01-13 03:05:12'),(464,1802,'2014-01-06','A00618967','Accepted',1,'2014-01-14 23:09:26',NULL,'2014-01-24 11:00:32'),(852,2191,'2013-12-31','A00619027','Pending',1,'2014-01-15 00:18:39',NULL,NULL),(923,2262,'2013-12-26','A00619135','Pending',1,'2014-01-15 00:20:08',NULL,NULL),(1026,2366,'2014-01-06','A00618997','Pending',1,'2014-01-15 09:03:17',NULL,NULL),(1097,2437,'2014-01-06','A00619085','Pending',1,'2014-01-15 09:04:07',NULL,NULL),(113,266,NULL,NULL,'Accepted',1,'2014-01-02 05:07:47',1,'2014-01-02 06:07:38'),(154,307,NULL,NULL,'Accepted',1,'2014-01-02 05:08:06',NULL,'2014-01-13 03:04:44'),(599,1938,'2013-12-12','A00612971','Pending',1,'2014-01-14 23:14:28',NULL,NULL),(816,2155,'2014-01-06','A00618984','Pending',1,'2014-01-15 00:17:52',NULL,NULL),(306,1644,'2014-01-01','A00618500','Accepted',1,'2014-01-14 23:06:05',NULL,'2014-01-24 11:02:30'),(310,1648,'2013-12-26','A00618708','Accepted',1,'2014-01-14 23:06:09',NULL,'2014-01-24 11:02:23'),(308,1646,'2013-12-24','A00618503','Accepted',1,'2014-01-14 23:06:07',NULL,'2014-01-24 11:01:29'),(725,2064,'2013-12-23','A00618849','Pending',1,'2014-01-14 23:17:08',NULL,NULL),(318,1656,'2013-12-27','A00618752','Accepted',1,'2014-01-14 23:06:18',NULL,'2014-01-24 11:02:11'),(489,1827,'2013-12-28','A00618994','Accepted',1,'2014-01-14 23:09:56',NULL,'2014-01-24 10:00:08'),(726,2065,'2013-12-19','A00618851','Pending',1,'2014-01-14 23:17:09',NULL,NULL),(834,2173,'2014-01-06','A00619003','Pending',1,'2014-01-15 00:18:15',NULL,NULL),(62,215,NULL,NULL,'Accepted',1,'2014-01-02 05:07:24',1,'2014-01-02 06:06:46'),(740,2079,'2013-12-31','A00618878','Pending',1,'2014-01-14 23:17:28',NULL,NULL),(799,2138,'2013-12-30','A00618966','Pending',1,'2014-01-15 00:17:29',NULL,NULL),(443,1781,'2014-01-01','A00618923','Accepted',1,'2014-01-14 23:08:55',NULL,'2014-01-24 11:00:39'),(882,2221,'2013-12-26','A00619068','Pending',1,'2014-01-15 00:19:15',NULL,NULL),(500,1838,'2014-01-01','A00619007','Accepted',1,'2014-01-14 23:10:11',NULL,'2014-01-24 08:00:43'),(1116,2456,'2013-12-23','A00619130','Pending',1,'2014-01-15 09:04:21',NULL,NULL),(877,2216,'2013-12-23','A00619061','Pending',1,'2014-01-15 00:19:09',NULL,NULL),(1117,2457,'2013-12-30','A00619131','Pending',1,'2014-01-15 09:04:22',NULL,NULL),(434,1772,'2013-12-24','A00618914','Accepted',1,'2014-01-14 23:08:45',NULL,'2014-01-24 11:02:09'),(520,1858,'2014-01-06','A00619033','Accepted',1,'2014-01-14 23:10:39',NULL,'2014-01-24 09:01:59'),(1092,2432,'2014-01-06','A00619080','Pending',1,'2014-01-15 09:04:02',NULL,NULL),(1193,2533,'2014-01-10','A00623136','Pending',1,'2014-01-15 22:21:53',NULL,NULL),(449,1787,'2013-12-30','A00618929','Accepted',1,'2014-01-14 23:09:06',NULL,'2014-01-24 11:02:11'),(1113,2453,'2014-01-06','A00619127','Pending',1,'2014-01-15 09:04:19',NULL,NULL),(991,2331,'2013-12-30','A00618943','Pending',1,'2014-01-15 09:02:58',NULL,NULL),(81,234,NULL,NULL,'Accepted',1,'2014-01-02 05:07:33',NULL,'2014-01-13 03:04:55'),(116,269,NULL,NULL,'Accepted',1,'2014-01-02 05:07:49',NULL,'2014-01-13 03:05:15'),(687,2026,'2013-12-23','A00618799','Pending',1,'2014-01-14 23:16:20',NULL,NULL),(23,176,NULL,NULL,'Accepted',1,'2014-01-02 05:07:06',NULL,'2014-01-13 03:05:11'),(190,343,NULL,NULL,'Accepted',1,'2014-01-02 05:08:23',1,'2014-01-02 06:07:37'),(191,344,NULL,NULL,'Accepted',1,'2014-01-02 05:08:23',1,'2014-01-02 06:06:24'),(451,1789,'2013-12-26','A00618934','Accepted',1,'2014-01-14 23:09:08',NULL,'2014-01-24 11:01:12'),(907,2246,'2013-12-23','A00619093','Pending',1,'2014-01-15 00:19:47',NULL,NULL),(548,1886,'2014-01-06','A00619070','Accepted',1,'2014-01-14 23:11:15',NULL,'2014-01-24 08:01:33'),(890,2229,'2014-01-06','A00619076','Pending',1,'2014-01-15 00:19:24',NULL,NULL),(242,1580,'2013-12-23','A00400419','Accepted',1,'2014-01-14 23:04:49',NULL,'2014-01-24 11:01:37'),(300,1638,'2013-12-24','A00618488','Accepted',1,'2014-01-14 23:05:57',NULL,'2014-01-24 11:02:22'),(1065,2405,'2014-01-06','A00619046','Pending',1,'2014-01-15 09:03:42',NULL,NULL),(862,2201,'2014-01-06','A00619040','Pending',1,'2014-01-15 00:18:51',NULL,NULL),(1187,2527,'2013-12-30','A00622673','Pending',1,'2014-01-15 22:21:50',NULL,NULL),(1216,2768,'2013-12-11','DT1077389','Pending',1,'2014-01-29 13:46:32',NULL,NULL),(786,2125,'2013-12-31','A00618930','Pending',1,'2014-01-15 00:17:14',NULL,NULL),(885,2224,'2014-01-01','A00619071','Pending',1,'2014-01-15 00:19:18',NULL,NULL),(681,2020,'2013-12-24','A00618791','Pending',1,'2014-01-14 23:16:12',NULL,NULL),(804,2143,'2014-01-10','A00618972','Pending',1,'2014-01-15 00:17:37',NULL,NULL),(638,1977,'2013-12-19','A00618492','Pending',1,'2014-01-14 23:15:12',NULL,NULL),(665,2004,'2013-12-23','A00618771','Pending',1,'2014-01-14 23:15:51',NULL,NULL),(1072,2412,'2014-01-06','A00619058','Pending',1,'2014-01-15 09:03:47',NULL,NULL),(1141,2481,'2014-01-10','A00619159','Pending',1,'2014-01-15 09:04:38',NULL,NULL),(324,1662,'2013-12-26','A00618763','Accepted',1,'2014-01-14 23:06:29',NULL,'2014-01-24 11:01:50'),(675,2014,'2013-12-23','A00618784','Pending',1,'2014-01-14 23:16:05',NULL,NULL),(930,2269,'2014-01-06','A00619142','Pending',1,'2014-01-15 00:20:17',NULL,NULL),(450,1788,'2013-12-31','A00618930','Accepted',1,'2014-01-14 23:09:07',NULL,'2014-01-24 11:01:06'),(1188,2528,'2014-01-01','A00622681','Pending',1,'2014-01-15 22:21:50',NULL,NULL),(331,1669,'2013-12-24','A00618773','Accepted',1,'2014-01-14 23:06:37',NULL,'2014-01-24 11:01:36'),(613,1952,'2013-12-26','A00618458','Pending',1,'2014-01-14 23:14:44',NULL,NULL),(298,1636,'2013-12-26','A00618486','Accepted',1,'2014-01-14 23:05:55',NULL,'2014-01-24 11:02:31'),(1016,2356,'2014-01-06','A00618986','Pending',1,'2014-01-15 09:03:12',NULL,NULL),(722,2061,'2013-12-24','A00618846','Pending',1,'2014-01-14 23:17:04',NULL,NULL),(1047,2387,'2014-01-06','A00619024','Pending',1,'2014-01-15 09:03:30',NULL,NULL),(1138,2478,'2014-01-06','A00619156','Pending',1,'2014-01-15 09:04:36',NULL,NULL),(1014,2354,'2014-01-06','A00618984','Pending',1,'2014-01-15 09:03:10',NULL,NULL),(562,1900,'2014-01-01','A00619084','Pending',1,'2014-01-14 23:11:35',NULL,NULL),(826,2165,'2014-01-06','A00618995','Pending',1,'2014-01-15 00:18:04',NULL,NULL),(267,1605,'2013-12-26','A00618442','Accepted',1,'2014-01-14 23:05:20',NULL,'2014-01-24 11:02:30'),(1052,2392,'2014-01-06','A00619030','Pending',1,'2014-01-15 09:03:33',NULL,NULL),(140,293,NULL,NULL,'Accepted',1,'2014-01-02 05:08:00',1,'2014-01-02 06:07:29'),(958,2297,'2014-01-06','A00619178','Pending',1,'2014-01-15 00:20:52',NULL,NULL),(989,2329,'2014-01-06','A00618941','Pending',1,'2014-01-15 09:02:57',NULL,NULL),(1042,2382,'2014-01-08','A00619016','Pending',1,'2014-01-15 09:03:27',NULL,NULL),(460,1798,'2014-01-06','A00618946','Accepted',1,'2014-01-14 23:09:20',NULL,'2014-01-24 11:01:38'),(842,2181,'2014-01-06','A00619014','Pending',1,'2014-01-15 00:18:24',NULL,NULL),(857,2196,'2013-12-31','A00619034','Pending',1,'2014-01-15 00:18:45',NULL,NULL),(130,283,NULL,NULL,'Accepted',1,'2014-01-02 05:07:55',1,'2014-01-02 06:06:32'),(466,1804,'2014-01-06','A00618970','Accepted',1,'2014-01-14 23:09:29',NULL,'2014-01-24 11:00:48'),(309,1647,'2013-12-24','A00618707','Accepted',1,'2014-01-14 23:06:08',NULL,'2014-01-24 11:00:13'),(608,1947,'2014-01-02','A00618451','Pending',1,'2014-01-14 23:14:38',NULL,NULL),(632,1971,'2013-12-20','A00618484','Pending',1,'2014-01-14 23:15:05',NULL,NULL),(736,2075,'2013-12-27','A00618872','Pending',1,'2014-01-14 23:17:21',NULL,NULL),(1068,2408,'2014-01-06','A00619052','Pending',1,'2014-01-15 09:03:45',NULL,NULL),(97,250,NULL,NULL,'Accepted',1,'2014-01-02 05:07:40',1,'2014-01-02 06:07:35'),(206,359,NULL,NULL,'Accepted',1,'2014-01-02 05:08:30',1,'2014-01-02 06:07:11'),(486,1824,'2013-12-23','A00618990','Accepted',1,'2014-01-14 23:09:52',NULL,'2014-01-24 10:58:15'),(873,2212,'2014-01-06','A00619057','Pending',1,'2014-01-15 00:19:03',NULL,NULL),(6,159,NULL,NULL,'Accepted',1,'2014-01-02 05:06:58',1,'2014-01-02 06:07:01'),(96,249,NULL,NULL,'Accepted',1,'2014-01-02 05:07:40',NULL,'2014-01-13 03:05:19'),(341,1679,'2013-12-26','A00618786','Accepted',1,'2014-01-14 23:06:48',NULL,'2014-01-24 11:00:49'),(365,1703,'2013-12-27','A00618817','Accepted',1,'2014-01-14 23:07:18',NULL,'2014-01-24 11:00:54'),(476,1814,'2014-01-02','A00618980','Accepted',1,'2014-01-14 23:09:40',NULL,'2014-01-24 11:01:55'),(1124,2464,'2014-01-06','A00619138','Pending',1,'2014-01-15 09:04:27',NULL,NULL),(719,2058,'2013-12-24','A00618843','Pending',1,'2014-01-14 23:17:01',NULL,NULL),(1005,2345,'2014-01-06','A00618975','Pending',1,'2014-01-15 09:03:05',NULL,NULL),(1169,2509,'2013-12-26','A00622210','Pending',1,'2014-01-15 09:04:57',NULL,NULL),(771,2110,'2013-12-26','A00618915','Pending',1,'2014-01-14 23:18:08',NULL,NULL),(1074,2414,'2014-01-06','A00619060','Pending',1,'2014-01-15 09:03:49',NULL,NULL),(1121,2461,'2013-12-26','A00619135','Pending',1,'2014-01-15 09:04:25',NULL,NULL),(22,175,NULL,NULL,'Accepted',1,'2014-01-02 05:07:05',NULL,'2014-01-13 03:04:48'),(410,1748,'2013-12-26','A00618885','Accepted',1,'2014-01-14 23:08:14',NULL,'2014-01-24 11:01:00'),(338,1676,'2013-12-23','A00618783','Accepted',1,'2014-01-14 23:06:44',NULL,'2014-01-24 11:02:30'),(615,1954,'2014-01-07','A00618461','Pending',1,'2014-01-14 23:14:46',NULL,NULL),(73,226,NULL,NULL,'Accepted',1,'2014-01-02 05:07:29',NULL,'2014-01-13 03:04:57'),(103,256,NULL,NULL,'Accepted',1,'2014-01-02 05:07:43',1,'2014-01-02 06:06:34'),(472,1810,'2014-01-01','A00618976','Accepted',1,'2014-01-14 23:09:36',NULL,'2014-01-24 11:01:40'),(918,2257,'2013-12-23','A00619130','Pending',1,'2014-01-15 00:20:02',NULL,NULL),(976,2316,'2014-01-03','A00618922','Pending',1,'2014-01-15 09:02:49',NULL,NULL),(1037,2377,'2014-01-06','A00619011','Pending',1,'2014-01-15 09:03:24',NULL,NULL),(1221,2839,NULL,NULL,'Pending',0,'2014-03-04 09:35:43',NULL,NULL),(368,1706,'2013-12-23','A00618825','Accepted',1,'2014-01-14 23:07:22',NULL,'2014-01-24 10:59:30'),(696,2035,'2013-12-23','A00618810','Pending',1,'2014-01-14 23:16:32',NULL,NULL),(941,2280,'2014-01-06','A00619157','Pending',1,'2014-01-15 00:20:30',NULL,NULL),(1013,2353,'2014-01-06','A00618983','Pending',1,'2014-01-15 09:03:10',NULL,NULL),(491,1829,'2014-01-06','A00618996','Accepted',1,'2014-01-14 23:09:58',NULL,'2014-01-24 10:31:05'),(600,1939,'2013-12-24','A00612972','Pending',1,'2014-01-14 23:14:29',NULL,NULL),(711,2050,'2013-12-24','A00618834','Pending',1,'2014-01-14 23:16:50',NULL,NULL),(808,2147,'2014-01-01','A00618976','Pending',1,'2014-01-15 00:17:41',NULL,NULL),(245,1583,'2013-12-30','A00575738','Accepted',1,'2014-01-14 23:04:52',NULL,'2014-01-24 10:58:23'),(528,1866,'2014-01-06','A00619042','Accepted',1,'2014-01-14 23:10:50',NULL,'2014-01-24 07:02:08'),(1163,2503,'2014-01-06','A00619186','Pending',1,'2014-01-15 09:04:53',NULL,NULL),(57,210,NULL,NULL,'Accepted',1,'2014-01-02 05:07:22',NULL,'2014-01-13 03:05:00'),(583,1922,'2013-12-20','A00610247','Pending',1,'2014-01-14 23:14:10',NULL,NULL),(797,2136,'2014-01-08','A00618947','Pending',1,'2014-01-15 00:17:27',NULL,NULL),(1048,2388,'2013-12-31','A00619025','Pending',1,'2014-01-15 09:03:31',NULL,NULL),(93,246,NULL,NULL,'Accepted',1,'2014-01-02 05:07:38',NULL,'2014-01-13 03:04:57'),(538,1876,'2014-01-06','A00619058','Accepted',1,'2014-01-14 23:11:03',NULL,'2014-01-24 07:32:13'),(595,1934,'2013-12-23','A00612473','Pending',1,'2014-01-14 23:14:23',NULL,NULL),(660,1999,'2013-12-26','A00618763','Pending',1,'2014-01-14 23:15:43',NULL,NULL),(843,2182,'2014-01-06','A00619015','Pending',1,'2014-01-15 00:18:25',NULL,NULL),(247,1585,'2013-12-20','A00610247','Accepted',1,'2014-01-14 23:04:54',NULL,'2014-01-24 11:02:19'),(79,232,NULL,NULL,'Accepted',1,'2014-01-02 05:07:32',NULL,'2014-01-13 03:05:04'),(135,288,NULL,NULL,'Accepted',1,'2014-01-02 05:07:58',NULL,'2014-01-13 03:05:19'),(165,318,NULL,NULL,'Accepted',1,'2014-01-02 05:08:11',1,'2014-01-02 06:07:36'),(234,567,'2013-12-18','DT1685573','Pending',1,'2014-01-02 16:41:11',NULL,NULL),(296,1634,'2013-12-20','A00618484','Accepted',1,'2014-01-14 23:05:53',NULL,'2014-01-24 11:02:21'),(188,341,NULL,NULL,'Accepted',1,'2014-01-02 05:08:22',NULL,'2014-01-13 03:05:03'),(759,2098,'2013-12-24','A00618901','Pending',1,'2014-01-14 23:17:53',NULL,NULL),(888,2227,'2014-01-01','A00619074','Pending',1,'2014-01-15 00:19:22',NULL,NULL),(513,1851,'2014-01-06','A00619024','Accepted',1,'2014-01-14 23:10:30',NULL,'2014-01-24 09:31:19'),(644,1983,'2013-12-24','A00618503','Pending',1,'2014-01-14 23:15:19',NULL,NULL),(1031,2371,'2014-01-06','A00619002','Pending',1,'2014-01-15 09:03:20',NULL,NULL),(3,156,NULL,NULL,'Accepted',1,'2014-01-02 05:06:57',NULL,'2014-01-13 03:04:50'),(732,2071,'2013-12-24','A00618863','Pending',1,'2014-01-14 23:17:16',NULL,NULL),(229,562,'2013-12-14','DT439589','Pending',1,'2014-01-02 16:41:04',NULL,NULL),(420,1758,'2014-12-24','A00618897','Accepted',1,'2014-01-14 23:08:27',NULL,'2014-01-24 11:01:11'),(501,1839,'2014-01-06','A00619009','Accepted',1,'2014-01-14 23:10:12',NULL,'2014-01-24 10:02:02'),(935,2274,'2014-01-06','A00619150','Pending',1,'2014-01-15 00:20:23',NULL,NULL),(241,1579,'2013-12-23','A00340181','Accepted',1,'2014-01-14 23:04:47',NULL,'2014-01-24 11:02:31'),(760,2099,'2013-12-23','A00618903','Pending',1,'2014-01-14 23:17:54',NULL,NULL),(74,227,NULL,NULL,'Accepted',1,'2014-01-02 05:07:29',NULL,'2014-01-13 03:05:06'),(780,2119,'2014-01-06','A00618924','Pending',1,'2014-01-15 00:17:06',NULL,NULL),(891,2230,'2014-01-08','A00619077','Pending',1,'2014-01-15 00:19:25',NULL,NULL),(897,2236,'2013-12-28','A00619083','Pending',1,'2014-01-15 00:19:34',NULL,NULL),(441,1779,'2013-12-24','A00618921','Accepted',1,'2014-01-14 23:08:53',NULL,'2014-01-24 10:31:40'),(576,1915,'2013-12-23','A00120926','Pending',1,'2014-01-14 23:14:03',NULL,NULL),(701,2040,'2013-12-27','A00618817','Pending',1,'2014-01-14 23:16:38',NULL,NULL),(970,2309,'2013-12-26','A00622209','Pending',1,'2014-01-15 00:21:08',NULL,NULL),(531,1869,'2014-01-06','A00619046','Accepted',1,'2014-01-14 23:10:54',NULL,'2014-01-24 09:00:03'),(1215,2767,'2013-12-18','DT2442979','Pending',1,'2014-01-29 13:46:31',NULL,NULL),(825,2164,'2013-12-28','A00618994','Pending',1,'2014-01-15 00:18:03',NULL,NULL),(1158,2498,'2013-12-30','A00619181','Pending',1,'2014-01-15 09:04:49',NULL,NULL),(1055,2395,'2013-12-31','A00619034','Pending',1,'2014-01-15 09:03:35',NULL,NULL),(741,2080,'2013-12-24','A00618879','Pending',1,'2014-01-14 23:17:29',NULL,NULL),(769,2108,'2013-12-26','A00618913','Pending',1,'2014-01-14 23:18:05',NULL,NULL),(850,2189,'2013-12-31','A00619025','Pending',1,'2014-01-15 00:18:36',NULL,NULL),(893,2232,'2013-12-27','A00619079','Pending',1,'2014-01-15 00:19:29',NULL,NULL),(559,1897,'2013-12-30','A00619081','Accepted',1,'2014-01-14 23:11:31',NULL,'2014-01-24 06:30:33'),(1182,2522,'2014-01-02','A00622595','Pending',1,'2014-01-15 22:21:47',NULL,NULL),(1192,2532,'2014-01-10','A00623128','Pending',1,'2014-01-15 22:21:52',NULL,NULL),(10,163,NULL,NULL,'Accepted',1,'2014-01-02 05:07:00',NULL,'2014-01-13 03:04:54'),(484,1822,'2013-12-23','A00618988','Accepted',1,'2014-01-14 23:09:50',NULL,'2014-01-24 10:58:34'),(906,2245,'2014-01-09','A00619092','Pending',1,'2014-01-15 00:19:46',NULL,NULL),(1151,2491,'2013-12-23','A00619171','Pending',1,'2014-01-15 09:04:45',NULL,NULL),(418,1756,'2014-01-01','A00618895','Accepted',1,'2014-01-14 23:08:24',NULL,'2014-01-24 11:00:15'),(424,1762,'2013-12-23','A00618903','Accepted',1,'2014-01-14 23:08:31',NULL,'2014-01-24 11:01:38'),(746,2085,'2013-12-26','A00618885','Pending',1,'2014-01-14 23:17:36',NULL,NULL),(840,2179,'2014-01-06','A00619012','Pending',1,'2014-01-15 00:18:22',NULL,NULL),(955,2294,'2013-12-30','A00619173','Pending',1,'2014-01-15 00:20:48',NULL,NULL),(302,1640,'2013-12-19','A00618492','Accepted',1,'2014-01-14 23:06:00',NULL,'2014-01-24 11:01:51'),(372,1710,'2014-01-01','A00618829','Accepted',1,'2014-01-14 23:07:26',NULL,'2014-01-24 11:01:45'),(462,1800,'2014-01-09','A00618965','Accepted',1,'2014-01-14 23:09:24',NULL,'2014-01-24 11:01:05'),(617,1956,'2013-12-24','A00618463','Pending',1,'2014-01-14 23:14:48',NULL,NULL),(1130,2470,'2014-01-06','A00619144','Pending',1,'2014-01-15 09:04:31',NULL,NULL),(90,243,NULL,NULL,'Accepted',1,'2014-01-02 05:07:37',1,'2014-01-02 06:06:35'),(328,1666,'2014-01-03','A00618770','Accepted',1,'2014-01-14 23:06:33',NULL,'2014-01-24 11:01:51'),(683,2022,'2013-12-24','A00618794','Pending',1,'2014-01-14 23:16:14',NULL,NULL),(848,2187,'2013-12-23','A00619022','Pending',1,'2014-01-15 00:18:33',NULL,NULL),(1147,2487,'2013-12-31','A00619165','Pending',1,'2014-01-15 09:04:42',NULL,NULL),(155,308,NULL,NULL,'Accepted',1,'2014-01-02 05:08:07',NULL,'2014-01-13 03:05:13'),(518,1856,'2014-01-06','A00619030','Accepted',1,'2014-01-14 23:10:36',1,'2014-01-24 06:03:22'),(1045,2385,'2014-01-06','A00619019','Pending',1,'2014-01-15 09:03:29',NULL,NULL),(1101,2441,'2013-12-26','A00619089','Pending',1,'2014-01-15 09:04:10',NULL,NULL),(1155,2495,'2013-12-30','A00619177','Pending',1,'2014-01-15 09:04:47',NULL,NULL),(35,188,NULL,NULL,'Accepted',1,'2014-01-02 05:07:11',NULL,'2014-01-13 03:05:08'),(301,1639,'2013-12-27','A00618489','Accepted',1,'2014-01-14 23:05:59',NULL,'2014-01-24 11:02:32'),(695,2034,'2014-01-02','A00618809','Pending',1,'2014-01-14 23:16:31',NULL,NULL),(735,2074,'2013-12-23','A00618870','Pending',1,'2014-01-14 23:17:20',NULL,NULL),(118,271,NULL,NULL,'Accepted',1,'2014-01-02 05:07:50',NULL,'2014-01-13 03:04:40'),(373,1711,'2013-12-24','A00618830','Accepted',1,'2014-01-14 23:07:27',NULL,'2014-01-24 11:01:16'),(438,1776,'2013-12-23','A00618918','Accepted',1,'2014-01-14 23:08:49',NULL,'2014-01-24 11:00:17'),(522,1860,'2014-01-06','A00619035','Accepted',1,'2014-01-14 23:10:42',NULL,'2014-01-24 10:30:15'),(830,2169,'2013-12-31','A00618999','Pending',1,'2014-01-15 00:18:10',NULL,NULL),(924,2263,'2014-01-06','A00619136','Pending',1,'2014-01-15 00:20:09',NULL,NULL),(264,1602,'2013-12-24','A00612972','Accepted',1,'2014-01-14 23:05:16',NULL,'2014-01-24 11:02:07'),(657,1996,'2013-12-24','A00618757','Pending',1,'2014-01-14 23:15:37',NULL,NULL),(1104,2444,'2014-01-09','A00619092','Pending',1,'2014-01-15 09:04:12',NULL,NULL),(904,2243,'2014-01-06','A00619090','Pending',1,'2014-01-15 00:19:44',NULL,NULL),(925,2264,'2013-12-26','A00619137','Pending',1,'2014-01-15 00:20:11',NULL,NULL),(1007,2347,'2014-01-06','A00618977','Pending',1,'2014-01-15 09:03:07',NULL,NULL),(65,218,NULL,NULL,'Accepted',1,'2014-01-02 05:07:25',NULL,'2014-01-13 03:05:02'),(540,1878,'2014-01-06','A00619060','Accepted',1,'2014-01-14 23:11:05',NULL,'2014-01-24 10:30:55'),(917,2256,'2014-01-06','A00619129','Pending',1,'2014-01-15 00:20:01',NULL,NULL),(946,2285,'2013-12-30','A00619162','Pending',1,'2014-01-15 00:20:36',NULL,NULL),(478,1816,'2014-01-06','A00618982','Accepted',1,'2014-01-14 23:09:43',NULL,'2014-01-24 11:02:20'),(881,2220,'2014-01-06','A00619067','Pending',1,'2014-01-15 00:19:14',NULL,NULL),(1162,2502,'2013-12-27','A00619185','Pending',1,'2014-01-15 09:04:52',NULL,NULL),(68,221,NULL,NULL,'Accepted',1,'2014-01-02 05:07:27',NULL,'2014-01-13 03:05:07'),(752,2091,'2014-01-07','A00618893','Pending',1,'2014-01-14 23:17:43',NULL,NULL),(159,312,NULL,NULL,'Accepted',1,'2014-01-02 05:08:09',1,'2014-01-02 06:07:17'),(221,374,NULL,NULL,'Accepted',1,'2014-01-02 05:08:37',1,'2014-01-02 06:06:51'),(761,2100,'2013-12-26','A00618904','Pending',1,'2014-01-14 23:17:55',NULL,NULL),(75,228,NULL,NULL,'Accepted',1,'2014-01-02 05:07:30',NULL,'2014-01-13 03:04:52'),(202,355,NULL,NULL,'Accepted',1,'2014-01-02 05:08:28',1,'2014-01-02 06:06:22'),(507,1845,'2014-01-06','A00619015','Accepted',1,'2014-01-14 23:10:21',NULL,'2014-01-24 09:43:30'),(864,2203,'2014-01-06','A00619042','Pending',1,'2014-01-15 00:18:53',NULL,NULL),(38,191,NULL,NULL,'Accepted',1,'2014-01-02 05:07:13',NULL,'2014-01-13 03:04:58'),(384,1722,'2013-12-24','A00618844','Accepted',1,'2014-01-14 23:07:40',NULL,'2014-01-24 10:59:51'),(972,2312,'2013-12-23','A00618918','Pending',1,'2014-01-15 09:02:47',NULL,NULL),(474,1812,'2013-12-26','A00618978','Accepted',1,'2014-01-14 23:09:38',NULL,'2014-01-24 11:01:52'),(87,240,NULL,NULL,'Accepted',1,'2014-01-02 05:07:35',NULL,'2014-01-13 03:05:06'),(106,259,NULL,NULL,'Accepted',1,'2014-01-02 05:07:44',1,'2014-01-02 06:07:20'),(285,1623,'2013-12-24','A00618469','Accepted',1,'2014-01-14 23:05:41',NULL,'2014-01-24 10:59:00'),(999,2339,'2014-01-06','A00618969','Pending',1,'2014-01-15 09:03:02',NULL,NULL),(268,1606,'2013-12-26','A00618444','Accepted',1,'2014-01-14 23:05:21',NULL,'2014-01-24 11:01:30'),(282,1620,'2013-12-24','A00618464','Accepted',1,'2014-01-14 23:05:38',NULL,'2014-01-24 11:00:35'),(183,336,NULL,NULL,'Accepted',1,'2014-01-02 05:08:20',NULL,'2014-01-13 03:05:12'),(408,1746,'2013-12-24','A00618883','Accepted',1,'2014-01-14 23:08:12',NULL,'2014-01-24 10:59:31'),(1122,2462,'2014-01-06','A00619136','Pending',1,'2014-01-15 09:04:26',NULL,NULL),(416,1754,'2014-01-07','A00618893','Accepted',1,'2014-01-14 23:08:22',NULL,'2014-01-24 10:58:48'),(351,1689,'2013-12-23','A00618799','Accepted',1,'2014-01-14 23:07:00',NULL,'2014-01-24 11:01:24'),(1176,2516,'2014-01-06','A00622582','Pending',1,'2014-01-15 22:21:44',NULL,NULL),(791,2130,'2014-01-06','A00618941','Pending',1,'2014-01-15 00:17:19',NULL,NULL),(313,1651,'2013-12-24','A00618732','Accepted',1,'2014-01-14 23:06:12',NULL,'2014-01-24 10:59:38'),(606,1945,'2014-01-01','A00618449','Pending',1,'2014-01-14 23:14:36',NULL,NULL),(908,2247,'2014-01-06','A00619094','Pending',1,'2014-01-15 00:19:48',NULL,NULL),(162,315,NULL,NULL,'Accepted',1,'2014-01-02 05:08:10',1,'2014-01-02 06:06:28'),(544,1882,'2014-01-06','A00619064','Accepted',1,'2014-01-14 23:11:10',NULL,'2014-01-24 10:32:00'),(1050,2390,'2013-12-31','A00619027','Pending',1,'2014-01-15 09:03:32',NULL,NULL),(646,1985,'2013-12-26','A00618708','Pending',1,'2014-01-14 23:15:22',NULL,NULL),(733,2072,'2013-12-23','A00618864','Pending',1,'2014-01-14 23:17:17',NULL,NULL),(1032,2372,'2014-01-06','A00619003','Pending',1,'2014-01-15 09:03:21',NULL,NULL),(467,1805,'2014-01-06','A00618971','Accepted',1,'2014-01-14 23:09:30',NULL,'2014-01-24 11:00:09'),(1028,2368,'2013-12-31','A00618999','Pending',1,'2014-01-15 09:03:18',NULL,NULL),(1085,2425,'2013-12-27','A00619073','Pending',1,'2014-01-15 09:03:57',NULL,NULL),(19,172,NULL,NULL,'Accepted',1,'2014-01-02 05:07:04',NULL,'2014-01-13 03:05:17'),(278,1616,'2013-12-26','A00618459','Accepted',1,'2014-01-14 23:05:32',NULL,'2014-01-24 11:02:28'),(566,1904,'2014-01-02','A00619088','Pending',1,'2014-01-14 23:11:40',NULL,NULL),(995,2335,'2014-01-08','A00618947','Pending',1,'2014-01-15 09:03:00',NULL,NULL),(33,186,NULL,NULL,'Accepted',1,'2014-01-02 05:07:11',NULL,'2014-01-13 03:05:15'),(60,213,NULL,NULL,'Accepted',1,'2014-01-02 05:07:23',NULL,'2014-01-13 03:04:51'),(251,1589,'2013-12-23','A00612108','Accepted',1,'2014-01-14 23:05:00',NULL,'2014-01-24 11:02:00'),(502,1840,'2013-12-31','A00619010','Accepted',1,'2014-01-14 23:10:14',NULL,'2014-01-24 09:43:14'),(947,2286,'2014-01-01','A00619163','Pending',1,'2014-01-15 00:20:38',NULL,NULL),(944,2283,'2014-01-06','A00619160','Pending',1,'2014-01-15 00:20:34',NULL,NULL),(170,323,NULL,NULL,'Accepted',1,'2014-01-02 05:08:14',1,'2014-01-02 06:07:13'),(196,349,NULL,NULL,'Accepted',1,'2014-01-02 05:08:26',NULL,'2014-01-13 03:04:40'),(512,1850,'2013-12-23','A00619022','Accepted',1,'2014-01-14 23:10:29',NULL,'2014-01-24 10:58:58'),(325,1663,'2013-12-24','A00618765','Accepted',1,'2014-01-14 23:06:30',NULL,'2014-01-24 10:32:26'),(1145,2485,'2014-01-01','A00619163','Pending',1,'2014-01-15 09:04:41',NULL,NULL),(982,2322,'2014-01-06','A00618928','Pending',1,'2014-01-15 09:02:53',NULL,NULL),(1210,2762,'2013-12-20','DT1675008','Pending',1,'2014-01-29 13:46:28',NULL,NULL),(625,1964,'2013-12-24','A00618474','Pending',1,'2014-01-14 23:14:57',NULL,NULL),(588,1927,'2013-12-26','A00612112','Pending',1,'2014-01-14 23:14:15',NULL,NULL),(975,2315,'2013-12-24','A00618921','Pending',1,'2014-01-15 09:02:49',NULL,NULL),(152,305,NULL,NULL,'Accepted',1,'2014-01-02 05:08:05',1,'2014-01-02 06:07:19'),(431,1769,'2013-12-26','A00618910','Accepted',1,'2014-01-14 23:08:40',NULL,'2014-01-24 11:00:19'),(503,1841,'2014-01-06','A00619011','Accepted',1,'2014-01-14 23:10:15',NULL,'2014-01-24 09:00:32'),(521,1859,'2013-12-31','A00619034','Accepted',1,'2014-01-14 23:10:41',NULL,'2014-01-24 08:30:44'),(693,2032,'2014-01-03','A00618805','Pending',1,'2014-01-14 23:16:28',NULL,NULL),(914,2253,'2014-01-06','A00619126','Pending',1,'2014-01-15 00:19:57',NULL,NULL),(134,287,NULL,NULL,'Accepted',1,'2014-01-02 05:07:57',NULL,'2014-01-13 03:04:54'),(259,1597,'2013-12-23','A00612473','Accepted',1,'2014-01-14 23:05:09',NULL,'2014-01-24 11:02:09'),(898,2237,'2014-01-01','A00619084','Pending',1,'2014-01-15 00:19:36',NULL,NULL),(184,337,NULL,NULL,'Accepted',1,'2014-01-02 05:08:20',1,'2014-01-02 06:06:58'),(698,2037,'2013-12-23','A00618812','Pending',1,'2014-01-14 23:16:34',NULL,NULL),(1207,2549,'2014-01-06','A00622225','Pending',1,'2014-01-20 05:44:25',NULL,NULL),(327,1665,'2013-12-24','A00618768','Accepted',1,'2014-01-14 23:06:32',NULL,'2014-01-24 11:02:16'),(455,1793,'2014-01-06','A00618941','Accepted',1,'2014-01-14 23:09:14',NULL,'2014-01-24 10:59:30'),(743,2082,'2013-12-24','A00618882','Pending',1,'2014-01-14 23:17:32',NULL,NULL),(333,1671,'2013-12-26','A00618775','Accepted',1,'2014-01-14 23:06:39',NULL,'2014-01-24 11:02:15'),(597,1936,'2013-12-24','A00612969','Pending',1,'2014-01-14 23:14:25',NULL,NULL),(335,1673,'2013-12-23','A00618777','Accepted',1,'2014-01-14 23:06:41',NULL,'2014-01-24 11:02:31'),(218,371,NULL,NULL,'Accepted',1,'2014-01-02 05:08:36',1,'2014-01-02 06:06:50'),(254,1592,'2013-12-24','A00612124','Accepted',1,'2014-01-14 23:05:03',NULL,'2014-01-24 11:01:46'),(607,1946,'2013-12-30','A00618450','Pending',1,'2014-01-14 23:14:37',NULL,NULL),(67,220,NULL,NULL,'Accepted',1,'2014-01-02 05:07:26',NULL,'2014-01-13 03:04:45'),(89,242,NULL,NULL,'Accepted',1,'2014-01-02 05:07:36',NULL,'2014-01-13 03:05:13'),(99,252,NULL,NULL,'Accepted',1,'2014-01-02 05:07:41',1,'2014-01-02 06:07:15'),(44,197,NULL,NULL,'Accepted',1,'2014-01-02 05:07:16',NULL,'2014-01-13 03:04:56'),(1131,2471,'2014-01-06','A00619147','Pending',1,'2014-01-15 09:04:32',NULL,NULL),(772,2111,'2013-12-24','A00618916','Pending',1,'2014-01-14 23:18:10',NULL,NULL),(1011,2351,'2014-01-06','A00618981','Pending',1,'2014-01-15 09:03:09',NULL,NULL),(1201,2543,'2014-01-01','A00622214','Pending',1,'2014-01-20 05:44:22',NULL,NULL),(82,235,NULL,NULL,'Accepted',1,'2014-01-02 05:07:33',NULL,'2014-01-13 03:04:56'),(703,2042,'2013-12-30','A00618824','Pending',1,'2014-01-14 23:16:40',NULL,NULL),(551,1889,'2013-12-27','A00619073','Accepted',1,'2014-01-14 23:11:20',NULL,'2014-01-24 06:00:50'),(684,2023,'2013-12-19','A00618795','Pending',1,'2014-01-14 23:16:15',NULL,NULL),(1119,2459,'2014-01-06','A00619133','Pending',1,'2014-01-15 09:04:23',NULL,NULL),(1211,2763,'2013-12-13','DT2454047','Pending',1,'2014-01-29 13:46:28',NULL,NULL),(567,1905,'2013-12-26','A00619089','Pending',1,'2014-01-14 23:11:41',NULL,NULL),(867,2206,'2014-01-06','A00619046','Pending',1,'2014-01-15 00:18:57',NULL,NULL),(610,1949,'2013-12-26','A00618454','Pending',1,'2014-01-14 23:14:40',NULL,NULL),(775,2114,'2013-12-23','A00618919','Pending',1,'2014-01-15 00:17:00',NULL,NULL),(1139,2479,'2014-01-06','A00619157','Pending',1,'2014-01-15 09:04:37',NULL,NULL),(463,1801,'2013-12-30','A00618966','Accepted',1,'2014-01-14 23:09:25',NULL,'2014-01-24 11:02:06'),(721,2060,'2013-12-31','A00618845','Pending',1,'2014-01-14 23:17:03',NULL,NULL),(21,174,NULL,NULL,'Accepted',1,'2014-01-02 05:07:05',NULL,'2014-01-13 03:04:40'),(887,2226,'2013-12-27','A00619073','Pending',1,'2014-01-15 00:19:20',NULL,NULL),(847,2186,'2014-01-06','A00619019','Pending',1,'2014-01-15 00:18:32',NULL,NULL),(55,208,NULL,NULL,'Accepted',1,'2014-01-02 05:07:21',NULL,'2014-01-13 03:05:16'),(827,2166,'2014-01-06','A00618996','Pending',1,'2014-01-15 00:18:06',NULL,NULL),(167,320,NULL,NULL,'Accepted',1,'2014-01-02 05:08:12',NULL,'2014-01-13 03:04:41'),(822,2161,'2013-12-23','A00618990','Pending',1,'2014-01-15 00:17:59',NULL,NULL),(1082,2422,'2014-01-06','A00619070','Pending',1,'2014-01-15 09:03:55',NULL,NULL),(1090,2430,'2014-01-06','A00619078','Pending',1,'2014-01-15 09:04:00',NULL,NULL),(189,342,NULL,NULL,'Accepted',1,'2014-01-02 05:08:22',1,'2014-01-02 06:07:24'),(228,561,'2013-12-13','DT2454047','Pending',1,'2014-01-02 16:41:02',NULL,NULL),(383,1721,'2013-12-24','A00618843','Accepted',1,'2014-01-14 23:07:39',NULL,'2014-01-24 11:02:18'),(485,1823,'2013-12-23','A00618989','Accepted',1,'2014-01-14 23:09:51',NULL,'2014-01-24 10:31:25'),(545,1883,'2014-01-06','A00619067','Accepted',1,'2014-01-14 23:11:12',NULL,'2014-01-24 08:00:52'),(571,1909,'2013-12-23','A00619093','Pending',1,'2014-01-14 23:11:46',NULL,NULL),(1102,2442,'2014-01-06','A00619090','Pending',1,'2014-01-15 09:04:10',NULL,NULL),(288,1626,'2013-12-24','A00618473','Accepted',1,'2014-01-14 23:05:44',NULL,'2014-01-24 10:58:21'),(903,2242,'2013-12-26','A00619089','Pending',1,'2014-01-15 00:19:42',NULL,NULL),(1088,2428,'2014-01-06','A00619076','Pending',1,'2014-01-15 09:03:59',NULL,NULL),(14,167,NULL,NULL,'Accepted',1,'2014-01-02 05:07:02',NULL,'2014-01-13 03:04:41'),(750,2089,'2013-12-23','A00618890','Pending',1,'2014-01-14 23:17:41',NULL,NULL),(841,2180,'2014-01-06','A00619013','Pending',1,'2014-01-15 00:18:23',NULL,NULL),(128,281,NULL,NULL,'Accepted',1,'2014-01-02 05:07:54',NULL,'2014-01-13 03:05:01'),(1046,2386,'2013-12-23','A00619022','Pending',1,'2014-01-15 09:03:29',NULL,NULL),(127,280,NULL,NULL,'Accepted',1,'2014-01-02 05:07:54',NULL,'2014-01-13 03:04:43'),(1164,2504,'2013-12-26','A00621828','Pending',1,'2014-01-15 09:04:53',NULL,NULL),(1186,2526,'2013-12-27','A00622605','Pending',1,'2014-01-15 22:21:49',NULL,NULL),(716,2055,'2013-12-26','A00618840','Pending',1,'2014-01-14 23:16:57',NULL,NULL),(860,2199,'2013-12-23','A00619037','Pending',1,'2014-01-15 00:18:48',NULL,NULL),(108,261,NULL,NULL,'Pending',1,'2014-01-02 05:07:45',NULL,NULL),(326,1664,'2013-12-24','A00618766','Accepted',1,'2014-01-14 23:06:31',NULL,'2014-01-24 10:59:04'),(364,1702,'2013-12-23','A00618816','Accepted',1,'2014-01-14 23:07:17',NULL,'2014-01-24 11:02:19'),(718,2057,'2013-12-24','A00618842','Pending',1,'2014-01-14 23:16:59',NULL,NULL),(1056,2396,'2014-01-06','A00619035','Pending',1,'2014-01-15 09:03:36',NULL,NULL),(386,1724,'2013-12-24','A00618846','Accepted',1,'2014-01-14 23:07:43',NULL,'2014-01-24 10:30:43'),(798,2137,'2014-01-09','A00618965','Pending',1,'2014-01-15 00:17:28',NULL,NULL),(872,2211,'2013-12-23','A00619056','Pending',1,'2014-01-15 00:19:02',NULL,NULL),(187,340,NULL,NULL,'Accepted',1,'2014-01-02 05:08:21',NULL,'2014-01-13 03:04:47'),(215,368,NULL,NULL,'Accepted',1,'2014-01-02 05:08:34',1,'2014-01-02 06:06:45'),(495,1833,'2014-01-06','A00619000','Accepted',1,'2014-01-14 23:10:03',NULL,'2014-01-24 11:01:11'),(793,2132,'2013-12-30','A00618943','Pending',1,'2014-01-15 00:17:22',NULL,NULL),(1033,2373,'2014-01-06','A00619005','Pending',1,'2014-01-15 09:03:22',NULL,NULL),(1172,2512,'2013-12-30','A00622576','Pending',1,'2014-01-15 22:21:41',NULL,NULL),(78,231,NULL,NULL,'Accepted',1,'2014-01-02 05:07:31',NULL,'2014-01-13 03:04:50'),(1118,2458,'2013-12-26','A00619132','Pending',1,'2014-01-15 09:04:23',NULL,NULL),(385,1723,'2013-12-31','A00618845','Accepted',1,'2014-01-14 23:07:42',NULL,'2014-01-24 11:01:28'),(707,2046,'2013-12-26','A00618828','Pending',1,'2014-01-14 23:16:45',NULL,NULL),(1057,2397,'2014-01-01','A00619036','Pending',1,'2014-01-15 09:03:37',NULL,NULL),(1134,2474,'2014-01-06','A00619152','Pending',1,'2014-01-15 09:04:34',NULL,NULL),(121,274,NULL,NULL,'Accepted',1,'2014-01-02 05:07:51',1,'2014-01-02 06:07:08'),(132,285,NULL,NULL,'Accepted',1,'2014-01-02 05:07:56',NULL,'2014-01-13 03:05:10'),(565,1903,'2013-12-27','A00619087','Pending',1,'2014-01-14 23:11:39',NULL,NULL),(17,170,NULL,NULL,'Accepted',1,'2014-01-02 05:07:03',NULL,'2014-01-13 03:04:59'),(814,2153,'2014-01-06','A00618982','Pending',1,'2014-01-15 00:17:50',NULL,NULL),(283,1621,'2013-12-26','A00618467','Accepted',1,'2014-01-14 23:05:39',NULL,'2014-01-24 11:02:26'),(839,2178,'2014-01-06','A00619011','Pending',1,'2014-01-15 00:18:21',NULL,NULL),(1010,2350,'2014-01-02','A00618980','Pending',1,'2014-01-15 09:03:08',NULL,NULL),(1067,2407,'2014-01-06','A00619049','Pending',1,'2014-01-15 09:03:44',NULL,NULL),(543,1881,'2013-12-27','A00619063','Accepted',1,'2014-01-14 23:11:09',NULL,'2014-01-24 09:31:05'),(894,2233,'2014-01-06','A00619080','Pending',1,'2014-01-15 00:19:30',NULL,NULL),(945,2284,'2014-01-10','A00619161','Pending',1,'2014-01-15 00:20:35',NULL,NULL),(256,1594,'2013-12-31','A00612139','Accepted',1,'2014-01-14 23:05:06',NULL,'2014-01-24 11:00:42'),(594,1933,'2013-12-23','A00612142','Pending',1,'2014-01-14 23:14:22',NULL,NULL),(731,2070,'2013-12-24','A00618859','Pending',1,'2014-01-14 23:17:15',NULL,NULL),(1054,2394,'2014-01-06','A00619033','Pending',1,'2014-01-15 09:03:35',NULL,NULL),(9,162,NULL,NULL,'Accepted',1,'2014-01-02 05:06:59',NULL,'2014-01-13 03:04:52'),(590,1929,'2013-12-24','A00612124','Pending',1,'2014-01-14 23:14:18',NULL,NULL),(905,2244,'2014-01-06','A00619091','Pending',1,'2014-01-15 00:19:45',NULL,NULL),(971,2310,'2013-12-26','A00622210','Pending',1,'2014-01-15 00:21:09',NULL,NULL),(570,1908,'2014-01-09','A00619092','Pending',1,'2014-01-14 23:11:45',NULL,NULL),(810,2149,'2013-12-26','A00618978','Pending',1,'2014-01-15 00:17:44',NULL,NULL),(125,278,NULL,NULL,'Accepted',1,'2014-01-02 05:07:53',NULL,'2014-01-13 03:04:43'),(504,1842,'2014-01-06','A00619012','Accepted',1,'2014-01-14 23:10:16',NULL,'2014-01-24 11:00:20'),(1053,2393,'2013-12-26','A00619032','Pending',1,'2014-01-15 09:03:34',NULL,NULL),(2,155,NULL,NULL,'Accepted',1,'2014-01-02 05:06:56',NULL,'2014-01-13 03:04:42'),(809,2148,'2014-01-06','A00618977','Pending',1,'2014-01-15 00:17:43',NULL,NULL),(886,2225,'2014-01-06','A00619072','Pending',1,'2014-01-15 00:19:19',NULL,NULL),(1079,2419,'2014-01-06','A00619067','Pending',1,'2014-01-15 09:03:53',NULL,NULL),(1198,2538,'2014-01-09','A00623195','Pending',1,'2014-01-15 22:21:56',NULL,NULL),(849,2188,'2014-01-06','A00619024','Pending',1,'2014-01-15 00:18:35',NULL,NULL),(114,267,NULL,NULL,'Accepted',1,'2014-01-02 05:07:48',1,'2014-01-02 06:06:44'),(352,1690,'2013-12-23','A00618800','Accepted',1,'2014-01-14 23:07:01',NULL,'2014-01-24 11:02:12'),(996,2336,'2014-01-09','A00618965','Pending',1,'2014-01-15 09:03:00',NULL,NULL),(405,1743,'2013-12-24','A00618879','Accepted',1,'2014-01-14 23:08:08',NULL,'2014-01-24 10:31:57'),(248,1586,'2013-12-24','A00612100','Accepted',1,'2014-01-14 23:04:56',NULL,'2014-01-24 11:02:25'),(260,1598,'2013-12-23','A00612966','Accepted',1,'2014-01-14 23:05:10',NULL,'2014-01-24 11:02:13'),(586,1925,'2013-12-24','A00612102','Pending',1,'2014-01-14 23:14:13',NULL,NULL),(1161,2501,'2014-01-02','A00619184','Pending',1,'2014-01-15 09:04:51',NULL,NULL),(488,1826,'2014-01-06','A00618992','Accepted',1,'2014-01-14 23:09:55',NULL,'2014-01-24 10:31:36'),(950,2289,'2013-12-30','A00619166','Pending',1,'2014-01-15 00:20:42',NULL,NULL),(1150,2490,'2014-01-06','A00619170','Pending',1,'2014-01-15 09:04:44',NULL,NULL),(266,1604,'2013-12-24','A00615015','Accepted',1,'2014-01-14 23:05:19',NULL,'2014-01-24 11:01:54'),(858,2197,'2014-01-06','A00619035','Pending',1,'2014-01-15 00:18:46',NULL,NULL),(1154,2494,'2014-01-01','A00619175','Pending',1,'2014-01-15 09:04:47',NULL,NULL),(426,1764,'2013-12-24','A00618905','Accepted',1,'2014-01-14 23:08:34',NULL,'2014-01-24 11:00:18'),(461,1799,'2014-01-08','A00618947','Accepted',1,'2014-01-14 23:09:23',NULL,'2014-01-24 11:02:14'),(506,1844,'2014-01-06','A00619014','Accepted',1,'2014-01-14 23:10:19',NULL,'2014-01-24 11:01:07'),(697,2036,'2013-12-30','A00618811','Pending',1,'2014-01-14 23:16:33',NULL,NULL),(53,206,NULL,NULL,'Accepted',1,'2014-01-02 05:07:20',NULL,'2014-01-13 03:04:43'),(175,328,NULL,NULL,'Accepted',1,'2014-01-02 05:08:16',1,'2014-01-02 06:06:42'),(172,325,NULL,NULL,'Accepted',1,'2014-01-02 05:08:15',NULL,'2014-01-13 03:04:52'),(353,1691,'2013-12-19','A00618801','Accepted',1,'2014-01-14 23:07:03',NULL,'2014-01-24 10:59:06'),(928,2267,'2014-01-06','A00619140','Pending',1,'2014-01-15 00:20:14',NULL,NULL),(290,1628,'2013-12-24','A00618475','Accepted',1,'2014-01-14 23:05:46',NULL,'2014-01-24 11:02:11'),(95,248,NULL,NULL,'Accepted',1,'2014-01-02 05:07:39',1,'2014-01-02 06:06:58'),(388,1726,'2013-12-26','A00618848','Accepted',1,'2014-01-14 23:07:45',NULL,'2014-01-24 11:02:29'),(868,2207,'2013-12-30','A00619048','Pending',1,'2014-01-15 00:18:58',NULL,NULL),(883,2222,'2013-12-31','A00619069','Pending',1,'2014-01-15 00:19:16',NULL,NULL),(974,2314,'2013-12-26','A00618920','Pending',1,'2014-01-15 09:02:48',NULL,NULL),(1017,2357,'2014-01-06','A00618987','Pending',1,'2014-01-15 09:03:12',NULL,NULL),(1214,2766,'2013-12-12','DT1086537','Pending',1,'2014-01-29 13:46:30',NULL,NULL),(91,244,NULL,NULL,'Accepted',1,'2014-01-02 05:07:37',NULL,'2014-01-13 03:05:19'),(303,1641,'2013-12-23','A00618493','Accepted',1,'2014-01-14 23:06:01',NULL,'2014-01-24 10:58:23'),(314,1652,'2013-12-23','A00618733','Accepted',1,'2014-01-14 23:06:14',NULL,'2014-01-24 10:58:17'),(437,1775,'2013-12-31','A00618917','Accepted',1,'2014-01-14 23:08:48',NULL,'2014-01-24 10:02:51'),(552,1890,'2014-01-01','A00619074','Accepted',1,'2014-01-14 23:11:21',NULL,'2014-01-24 08:31:37'),(1197,2537,'2014-01-01','A00623194','Pending',1,'2014-01-15 22:21:55',NULL,NULL),(670,2009,'2013-12-31','A00618776','Pending',1,'2014-01-14 23:15:58',NULL,NULL),(304,1642,'2014-01-01','A00618494','Accepted',1,'2014-01-14 23:06:02',NULL,'2014-01-24 11:01:20'),(225,378,NULL,NULL,'Accepted',1,'2014-01-02 05:08:39',1,'2014-01-02 06:06:49'),(965,2304,'2014-01-06','A00619186','Pending',1,'2014-01-15 00:21:02',NULL,NULL),(968,2307,'2013-12-31','A00622206','Pending',1,'2014-01-15 00:21:06',NULL,NULL),(990,2330,'2014-01-06','A00618942','Pending',1,'2014-01-15 09:02:57',NULL,NULL),(643,1982,'2013-12-26','A00618501','Pending',1,'2014-01-14 23:15:18',NULL,NULL),(582,1921,'2014-01-07','A00606303','Pending',1,'2014-01-14 23:14:09',NULL,NULL),(819,2158,'2014-01-06','A00618987','Pending',1,'2014-01-15 00:17:56',NULL,NULL),(1202,2544,'2014-01-06','A00622218','Pending',1,'2014-01-20 05:44:23',NULL,NULL),(275,1613,'2013-12-30','A00618456','Accepted',1,'2014-01-14 23:05:29',NULL,'2014-01-24 11:02:05'),(1070,2410,'2013-12-23','A00619056','Pending',1,'2014-01-15 09:03:46',NULL,NULL),(412,1750,'2013-12-24','A00618887','Accepted',1,'2014-01-14 23:08:17',NULL,'2014-01-24 10:31:27'),(511,1849,'2014-01-06','A00619019','Accepted',1,'2014-01-14 23:10:27',NULL,'2014-01-24 10:59:33'),(1061,2401,'2013-12-28','A00619041','Pending',1,'2014-01-15 09:03:39',NULL,NULL),(378,1716,'2013-12-30','A00618837','Accepted',1,'2014-01-14 23:07:33',NULL,'2014-01-24 11:01:42'),(802,2141,'2014-01-06','A00618970','Pending',1,'2014-01-15 00:17:33',NULL,NULL),(967,2306,'2014-01-06','A00622205','Pending',1,'2014-01-15 00:21:04',NULL,NULL),(63,216,NULL,NULL,'Accepted',1,'2014-01-02 05:07:24',1,'2014-01-02 06:06:21'),(100,253,NULL,NULL,'Accepted',1,'2014-01-02 05:07:41',1,'2014-01-02 06:07:27'),(56,209,NULL,NULL,'Accepted',1,'2014-01-02 05:07:21',NULL,'2014-01-13 03:05:14'),(911,2250,'2014-01-01','A00619097','Pending',1,'2014-01-15 00:19:54',NULL,NULL),(1222,2842,NULL,NULL,'Pending',0,'2014-03-04 09:59:08',NULL,NULL),(519,1857,'2013-12-26','A00619032','Accepted',1,'2014-01-14 23:10:38',NULL,'2014-01-24 10:32:01'),(631,1970,'2014-01-06','A00618482','Pending',1,'2014-01-14 23:15:04',NULL,NULL),(136,289,NULL,NULL,'Accepted',1,'2014-01-02 05:07:58',NULL,'2014-01-13 03:05:16'),(817,2156,'2014-01-06','A00618985','Pending',1,'2014-01-15 00:17:53',NULL,NULL),(289,1627,'2013-12-24','A00618474','Accepted',1,'2014-01-14 23:05:45',NULL,'2014-01-24 11:01:35'),(371,1709,'2013-12-26','A00618828','Accepted',1,'2014-01-14 23:07:25',NULL,'2014-01-24 11:00:46'),(737,2076,'2013-12-24','A00618874','Pending',1,'2014-01-14 23:17:23',NULL,NULL),(836,2175,'2014-01-01','A00619007','Pending',1,'2014-01-15 00:18:17',NULL,NULL),(853,2192,'2014-01-06','A00619029','Pending',1,'2014-01-15 00:18:40',NULL,NULL),(880,2219,'2014-01-06','A00619064','Pending',1,'2014-01-15 00:19:12',NULL,NULL),(889,2228,'2013-12-31','A00619075','Pending',1,'2014-01-15 00:19:23',NULL,NULL),(166,319,NULL,NULL,'Accepted',1,'2014-01-02 05:08:12',1,'2014-01-02 06:07:16'),(912,2251,'2014-01-06','A00619098','Pending',1,'2014-01-15 00:19:55',NULL,NULL),(927,2266,'2013-12-26','A00619139','Pending',1,'2014-01-15 00:20:13',NULL,NULL),(305,1643,'2013-12-24','A00618495','Accepted',1,'2014-01-14 23:06:04',NULL,'2014-01-24 11:01:08'),(1008,2348,'2013-12-26','A00618978','Pending',1,'2014-01-15 09:03:07',NULL,NULL),(45,198,NULL,NULL,'Accepted',1,'2014-01-02 05:07:16',1,'2014-01-02 06:06:54'),(642,1981,'2014-01-01','A00618500','Pending',1,'2014-01-14 23:15:17',NULL,NULL),(770,2109,'2013-12-24','A00618914','Pending',1,'2014-01-14 23:18:07',NULL,NULL),(1175,2515,'2013-12-30','A00622581','Pending',1,'2014-01-15 22:21:43',NULL,NULL),(407,1745,'2013-12-24','A00618882','Accepted',1,'2014-01-14 23:08:11',NULL,'2014-01-24 11:02:24'),(878,2217,'2014-01-06','A00619062','Pending',1,'2014-01-15 00:19:10',NULL,NULL),(1051,2391,'2014-01-06','A00619029','Pending',1,'2014-01-15 09:03:33',NULL,NULL),(637,1976,'2013-12-27','A00618489','Pending',1,'2014-01-14 23:15:11',NULL,NULL),(980,2320,'2014-01-06','A00618926','Pending',1,'2014-01-15 09:02:52',NULL,NULL),(258,1596,'2013-12-23','A00612142','Accepted',1,'2014-01-14 23:05:08',NULL,'2014-01-24 11:01:57'),(274,1612,'2013-12-26','A00618454','Accepted',1,'2014-01-14 23:05:28',NULL,'2014-01-24 11:01:59'),(422,1760,'2013-12-24','A00618899','Accepted',1,'2014-01-14 23:08:29',NULL,'2014-01-24 11:01:08'),(66,219,NULL,NULL,'Accepted',1,'2014-01-02 05:07:26',NULL,'2014-01-13 03:04:58'),(332,1670,'2014-01-06','A00618774','Accepted',1,'2014-01-14 23:06:38',NULL,'2014-01-24 11:00:33'),(525,1863,'2013-12-23','A00619039','Accepted',1,'2014-01-14 23:10:46',NULL,'2014-01-24 09:41:55'),(662,2001,'2013-12-24','A00618766','Pending',1,'2014-01-14 23:15:48',NULL,NULL),(1205,2547,'2014-01-02','A00622223','Pending',1,'2014-01-20 05:44:24',NULL,NULL),(143,296,NULL,NULL,'Accepted',1,'2014-01-02 05:08:01',NULL,'2014-01-13 03:04:51'),(237,1574,'2013-12-23','DT105089','Accepted',1,'2014-01-13 22:09:07',NULL,'2014-01-24 07:00:39'),(871,2210,'2014-01-06','A00619054','Pending',1,'2014-01-15 00:19:01',NULL,NULL),(137,290,NULL,NULL,'Accepted',1,'2014-01-02 05:07:58',1,'2014-01-02 06:06:34'),(824,2163,'2014-01-06','A00618992','Pending',1,'2014-01-15 00:18:02',NULL,NULL),(981,2321,'2013-12-23','A00618927','Pending',1,'2014-01-15 09:02:52',NULL,NULL),(1076,2416,'2014-01-06','A00619062','Pending',1,'2014-01-15 09:03:51',NULL,NULL),(186,339,NULL,NULL,'Accepted',1,'2014-01-02 05:08:21',1,'2014-01-02 06:07:34'),(199,352,NULL,NULL,'Accepted',1,'2014-01-02 05:08:27',NULL,'2014-01-13 03:05:05'),(636,1975,'2013-12-24','A00618488','Pending',1,'2014-01-14 23:15:10',NULL,NULL),(1087,2427,'2013-12-31','A00619075','Pending',1,'2014-01-15 09:03:58',NULL,NULL),(391,1729,'2013-12-26','A00618852','Accepted',1,'2014-01-14 23:07:49',NULL,'2014-01-24 11:02:08'),(429,1767,'2013-12-23','A00618908','Accepted',1,'2014-01-14 23:08:38',NULL,'2014-01-24 11:01:04'),(629,1968,'2014-01-07','A00618480','Pending',1,'2014-01-14 23:15:01',NULL,NULL),(742,2081,'2013-12-31','A00618881','Pending',1,'2014-01-14 23:17:30',NULL,NULL),(1049,2389,'2013-12-26','A00619026','Pending',1,'2014-01-15 09:03:31',NULL,NULL),(447,1785,'2013-12-23','A00618927','Accepted',1,'2014-01-14 23:09:02',NULL,'2014-01-24 11:00:28'),(807,2146,'2014-01-06','A00618975','Pending',1,'2014-01-15 00:17:40',NULL,NULL),(866,2205,'2013-12-20','A00619045','Pending',1,'2014-01-15 00:18:55',NULL,NULL),(37,190,NULL,NULL,'Accepted',1,'2014-01-02 05:07:12',NULL,'2014-01-13 03:05:11'),(589,1928,'2013-12-19','A00612120','Pending',1,'2014-01-14 23:14:16',NULL,NULL),(621,1960,'2013-12-24','A00618469','Pending',1,'2014-01-14 23:14:52',NULL,NULL),(80,233,NULL,NULL,'Accepted',1,'2014-01-02 05:07:32',1,'2014-01-02 06:07:09'),(656,1995,'2013-12-24','A00618756','Pending',1,'2014-01-14 23:15:35',NULL,NULL),(658,1997,'2014-01-03','A00618761','Pending',1,'2014-01-14 23:15:38',NULL,NULL),(767,2106,'2013-12-26','A00618910','Pending',1,'2014-01-14 23:18:03',NULL,NULL),(83,236,NULL,NULL,'Accepted',1,'2014-01-02 05:07:34',NULL,'2014-01-13 03:05:09'),(112,265,NULL,NULL,'Accepted',1,'2014-01-02 05:07:47',1,'2014-01-02 06:06:25'),(1027,2367,'2014-01-06','A00618998','Pending',1,'2014-01-15 09:03:18',NULL,NULL),(1043,2383,'2014-01-06','A00619017','Pending',1,'2014-01-15 09:03:28',NULL,NULL),(1084,2424,'2014-01-06','A00619072','Pending',1,'2014-01-15 09:03:56',NULL,NULL),(131,284,NULL,NULL,'Accepted',1,'2014-01-02 05:07:56',NULL,'2014-01-13 03:04:51'),(936,2275,'2014-01-06','A00619152','Pending',1,'2014-01-15 00:20:24',NULL,NULL),(291,1629,'2013-12-24','A00618476','Accepted',1,'2014-01-14 23:05:48',NULL,'2014-01-24 11:01:27'),(1148,2488,'2013-12-30','A00619166','Pending',1,'2014-01-15 09:04:43',NULL,NULL),(64,217,NULL,NULL,'Accepted',1,'2014-01-02 05:07:25',NULL,'2014-01-13 03:04:44'),(498,1836,'2014-01-06','A00619003','Accepted',1,'2014-01-14 23:10:08',NULL,'2014-01-24 10:02:39'),(676,2015,'2013-12-26','A00618785','Pending',1,'2014-01-14 23:16:06',NULL,NULL),(1009,2349,'2014-01-06','A00618979','Pending',1,'2014-01-15 09:03:08',NULL,NULL),(158,311,NULL,NULL,'Accepted',1,'2014-01-02 05:08:08',1,'2014-01-02 06:06:13'),(1146,2486,'2014-01-08','A00619164','Pending',1,'2014-01-15 09:04:41',NULL,NULL),(356,1694,'2013-12-24','A00618804','Accepted',1,'2014-01-14 23:07:07',NULL,'2014-01-24 11:02:27'),(509,1847,'2014-01-06','A00619017','Accepted',1,'2014-01-14 23:10:23',NULL,'2014-01-24 10:30:53'),(605,1944,'2014-01-01','A00618445','Pending',1,'2014-01-14 23:14:35',NULL,NULL),(765,2104,'2013-12-23','A00618908','Pending',1,'2014-01-14 23:18:00',NULL,NULL),(20,173,NULL,NULL,'Accepted',1,'2014-01-02 05:07:05',1,'2014-01-02 06:07:04'),(168,321,NULL,NULL,'Accepted',1,'2014-01-02 05:08:13',1,'2014-01-02 06:06:41'),(635,1974,'2013-12-23','A00618487','Pending',1,'2014-01-14 23:15:09',NULL,NULL),(1081,2421,'2013-12-31','A00619069','Pending',1,'2014-01-15 09:03:54',NULL,NULL),(18,171,NULL,NULL,'Accepted',1,'2014-01-02 05:07:04',NULL,'2014-01-13 03:05:05'),(436,1774,'2013-12-24','A00618916','Accepted',1,'2014-01-14 23:08:47',NULL,'2014-01-24 11:01:22'),(560,1898,'2014-01-06','A00619082','Accepted',1,'2014-01-14 23:11:32',NULL,'2014-01-24 10:58:18'),(563,1901,'2014-01-06','A00619085','Pending',1,'2014-01-14 23:11:36',NULL,NULL),(758,2097,'2013-12-24','A00618899','Pending',1,'2014-01-14 23:17:51',NULL,NULL),(593,1932,'2014-01-01','A00612141','Pending',1,'2014-01-14 23:14:21',NULL,NULL),(677,2016,'2013-12-26','A00618786','Pending',1,'2014-01-14 23:16:07',NULL,NULL),(1103,2443,'2014-01-06','A00619091','Pending',1,'2014-01-15 09:04:11',NULL,NULL),(72,225,NULL,NULL,'Accepted',1,'2014-01-02 05:07:29',1,'2014-01-02 06:06:55'),(322,1660,'2014-01-03','A00618761','Accepted',1,'2014-01-14 23:06:26',NULL,'2014-01-24 11:02:20'),(556,1894,'2014-01-06','A00619078','Accepted',1,'2014-01-14 23:11:27',NULL,'2014-01-24 07:02:30'),(236,1472,'2013-01-07','30868','Pending',1,'2014-01-09 10:26:03',NULL,NULL),(964,2303,'2013-12-27','A00619185','Pending',1,'2014-01-15 00:20:59',NULL,NULL),(102,255,NULL,NULL,'Accepted',1,'2014-01-02 05:07:42',NULL,'2014-01-13 03:04:47'),(344,1682,'2014-01-02','A00618790','Accepted',1,'2014-01-14 23:06:51',NULL,'2014-01-24 11:02:25'),(611,1950,'2013-12-30','A00618456','Pending',1,'2014-01-14 23:14:41',NULL,NULL),(147,300,NULL,NULL,'Accepted',1,'2014-01-02 05:08:03',1,'2014-01-02 06:06:30'),(347,1685,'2013-12-24','A00618794','Accepted',1,'2014-01-14 23:06:56',NULL,'2014-01-24 11:00:57'),(654,1993,'2013-12-27','A00618752','Pending',1,'2014-01-14 23:15:32',NULL,NULL),(781,2120,'2013-12-27','A00618925','Pending',1,'2014-01-15 00:17:08',NULL,NULL),(1106,2446,'2014-01-06','A00619094','Pending',1,'2014-01-15 09:04:13',NULL,NULL),(1200,2542,'2014-01-06','A00622213','Pending',1,'2014-01-20 05:44:22',NULL,NULL),(1173,2513,'2014-01-06','A00622577','Pending',1,'2014-01-15 22:21:42',NULL,NULL),(659,1998,'2013-12-24','A00618762','Pending',1,'2014-01-14 23:15:40',NULL,NULL),(171,324,NULL,NULL,'Accepted',1,'2014-01-02 05:08:14',1,'2014-01-02 06:06:17'),(738,2077,'2013-12-23','A00618875','Pending',1,'2014-01-14 23:17:24',NULL,NULL),(764,2103,'2013-12-31','A00618907','Pending',1,'2014-01-14 23:17:59',NULL,NULL),(784,2123,'2014-01-06','A00618928','Pending',1,'2014-01-15 00:17:11',NULL,NULL),(994,2334,'2014-01-06','A00618946','Pending',1,'2014-01-15 09:02:59',NULL,NULL),(235,1470,'2013-12-20','DT1040900','Pending',1,'2014-01-07 10:58:05',NULL,NULL),(573,1911,'2013-12-30','A00619095','Pending',1,'2014-01-14 23:11:50',NULL,NULL),(382,1720,'2013-12-24','A00618842','Accepted',1,'2014-01-14 23:07:38',NULL,'2014-01-24 11:00:04'),(465,1803,'2014-01-06','A00618969','Accepted',1,'2014-01-14 23:09:27',NULL,'2014-01-24 11:02:04'),(926,2265,'2014-01-06','A00619138','Pending',1,'2014-01-15 00:20:12',NULL,NULL),(115,268,NULL,NULL,'Accepted',1,'2014-01-02 05:07:48',NULL,'2014-01-13 03:05:02'),(400,1738,'2013-12-27','A00618872','Accepted',1,'2014-01-14 23:08:01',NULL,'2014-01-24 10:58:55'),(777,2116,'2013-12-24','A00618921','Pending',1,'2014-01-15 00:17:03',NULL,NULL),(690,2029,'2013-12-24','A00618802','Pending',1,'2014-01-14 23:16:24',NULL,NULL),(564,1902,'2014-01-01','A00619086','Pending',1,'2014-01-14 23:11:37',NULL,NULL),(835,2174,'2014-01-06','A00619005','Pending',1,'2014-01-15 00:18:16',NULL,NULL),(1098,2438,'2014-01-01','A00619086','Pending',1,'2014-01-15 09:04:08',NULL,NULL),(524,1862,'2013-12-23','A00619037','Accepted',1,'2014-01-14 23:10:45',NULL,'2014-01-24 10:02:37'),(1015,2355,'2014-01-06','A00618985','Pending',1,'2014-01-15 09:03:11',NULL,NULL),(144,297,NULL,NULL,'Accepted',1,'2014-01-02 05:08:02',NULL,'2014-01-13 03:04:53'),(339,1677,'2013-12-23','A00618784','Accepted',1,'2014-01-14 23:06:46',NULL,'2014-01-24 11:00:43'),(1080,2420,'2013-12-26','A00619068','Pending',1,'2014-01-15 09:03:53',NULL,NULL),(783,2122,'2013-12-23','A00618927','Pending',1,'2014-01-15 00:17:10',NULL,NULL),(1024,2364,'2014-01-06','A00618995','Pending',1,'2014-01-15 09:03:16',NULL,NULL),(1108,2448,'2014-01-06','A00619096','Pending',1,'2014-01-15 09:04:15',NULL,NULL),(376,1714,'2013-12-30','A00618835','Accepted',1,'2014-01-14 23:07:31',NULL,'2014-01-24 11:02:18'),(387,1725,'2013-12-19','A00618847','Accepted',1,'2014-01-14 23:07:44',NULL,'2014-01-24 11:02:22'),(413,1751,'2013-12-26','A00618888','Accepted',1,'2014-01-14 23:08:18',NULL,'2014-01-24 10:59:50'),(596,1935,'2013-12-23','A00612966','Pending',1,'2014-01-14 23:14:24',NULL,NULL),(26,179,NULL,NULL,'Accepted',1,'2014-01-02 05:07:07',NULL,'2014-01-13 03:05:05'),(70,223,NULL,NULL,'Accepted',1,'2014-01-02 05:07:28',NULL,'2014-01-13 03:05:14'),(1012,2352,'2014-01-06','A00618982','Pending',1,'2014-01-15 09:03:09',NULL,NULL),(1091,2431,'2013-12-27','A00619079','Pending',1,'2014-01-15 09:04:01',NULL,NULL),(262,1600,'2013-12-26','A00612970','Accepted',1,'2014-01-14 23:05:12',NULL,'2014-01-24 11:02:14'),(580,1919,'2014-01-01','A00554513','Pending',1,'2014-01-14 23:14:07',NULL,NULL),(747,2086,'2013-12-31','A00618886','Pending',1,'2014-01-14 23:17:37',NULL,NULL),(1128,2468,'2014-01-06','A00619142','Pending',1,'2014-01-15 09:04:30',NULL,NULL),(61,214,NULL,NULL,'Accepted',1,'2014-01-02 05:07:23',1,'2014-01-02 06:07:02'),(403,1741,'2013-12-24','A00618876','Accepted',1,'2014-01-14 23:08:05',NULL,'2014-01-24 11:01:22'),(445,1783,'2013-12-27','A00618925','Accepted',1,'2014-01-14 23:08:58',NULL,'2014-01-24 11:01:28'),(575,1914,'2014-01-09','A00011490','Pending',1,'2014-01-14 23:14:02',NULL,NULL);
/*!40000 ALTER TABLE `EdiIC834` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiParticipant`
--

DROP TABLE IF EXISTS `EdiParticipant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiParticipant` (
  `EdiParticipantId` bigint(64) NOT NULL AUTO_INCREMENT,
  `Edi834Id` bigint(64) NOT NULL,
  `SubscriberIndicator` enum('Y','N') NOT NULL,
  `RelationshipCode` varchar(45) NOT NULL,
  `MaintenanceTypeCode` varchar(45) NOT NULL COMMENT 'Example: Addition',
  `MaintenanceReasonCode` varchar(50) NOT NULL COMMENT 'Example:  Member Benefit Selection',
  `BenefitStatusCode` varchar(45) NOT NULL COMMENT 'Example: Active',
  `MedicareStatusCode` varchar(45) DEFAULT NULL,
  `COBRAStatusCode` varchar(45) DEFAULT NULL,
  `EmploymentStatusCode` varchar(45) NOT NULL COMMENT 'Example: Active',
  `SubscriberNumber` varchar(45) NOT NULL COMMENT 'Example 0000861722',
  `ClientNumber` varchar(45) NOT NULL,
  `CrossReferenceNumber` varchar(45) NOT NULL COMMENT 'Example: TX00001068412',
  `EntityIdentifierCode` varchar(100) NOT NULL COMMENT 'Example:  Insured of Subscriber',
  `EntityTypeQualifier` varchar(100) NOT NULL COMMENT 'Example:  Person',
  `NameLastOrOrganizationName` varchar(100) NOT NULL COMMENT 'Example: FitzSimmons',
  `FirstName` varchar(45) DEFAULT NULL,
  `MiddleName` varchar(45) DEFAULT NULL,
  `PrefixName` varchar(45) DEFAULT NULL,
  `SuffixName` varchar(45) DEFAULT NULL,
  `NationalIdentifierNumber` varchar(45) DEFAULT NULL,
  `ParticipantIdentifier` varchar(45) DEFAULT NULL,
  `Address` varchar(100) DEFAULT NULL COMMENT 'Address can be NULL.  However, if NULL expect to find a Pos',
  `AddressIsPOBox` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Address Information can be null null in which case you should expect a PO Box.\nYou will find a Party Locatiohn with Address Information of P.O.Box 620 for example.  The Geographic location should be the same. an N4.\n\n',
  `City` varchar(100) NOT NULL COMMENT 'Example:   San Diego',
  `StateCode` char(2) NOT NULL COMMENT 'Example: OH',
  `ZipCode1st5` char(5) NOT NULL COMMENT '1st 5 characters of the Zip Code',
  `ZipCodeLast4` char(4) DEFAULT NULL COMMENT 'Last 4 of Zip Code if provided',
  `LocationCode` varchar(45) DEFAULT NULL,
  `Location` varchar(45) DEFAULT NULL,
  `Birthdate` date NOT NULL COMMENT 'This is demographic Information Date Time Period\nExample: 19630724',
  `GenderCode` varchar(45) NOT NULL COMMENT 'Example: Male',
  `MaritalStatus` varchar(100) NOT NULL COMMENT 'Example: Unmarried (Single or Divorced or Widowed)',
  `CompositeInformation` varchar(45) DEFAULT NULL,
  `HealthRelatedCode` varchar(45) DEFAULT NULL COMMENT 'Example:  None',
  `HealthMaintenanceCode` varchar(45) DEFAULT NULL,
  `CoverageLevelCode` varchar(45) NOT NULL COMMENT 'Example: Dental',
  `PolicyNumber` varchar(45) NOT NULL COMMENT 'Example 0000861722',
  `ReferenceQHPId` varchar(45) NOT NULL COMMENT 'Example 480013',
  `BenefitDate` date DEFAULT NULL COMMENT 'Example: 20140101',
  `SubmitedTimestamp` varchar(50) NOT NULL COMMENT 'Example: 33348TX002000201',
  `AptcAmount` varchar(10) DEFAULT NULL COMMENT 'Example: Social Security Number',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `PreAmountTotal` varchar(10) DEFAULT NULL,
  `TotalResponsibleAmount` varchar(10) DEFAULT NULL,
  `RatingArea` varchar(10) DEFAULT NULL,
  `ExchangeId` varchar(3) DEFAULT NULL,
  `PreAmount1` varchar(10) DEFAULT NULL COMMENT 'Example: 451336221',
  `AddlMainReason` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`EdiParticipantId`),
  KEY `EdiParticipantRefEdi834_fk_idx` (`Edi834Id`)
) ENGINE=innodb AUTO_INCREMENT=29216 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiParticipant`
--

LOCK TABLES `EdiParticipant` WRITE;
/*!40000 ALTER TABLE `EdiParticipant` DISABLE KEYS */;
INSERT INTO `EdiParticipant` VALUES (5702,4525,'Y','18','021','EC','A','','','AC','0001223138','0001223138','OH00000516046','IL','1','DIETRICH','MICHAEL','','','','34','269869538','1020 INVERNESS DR',0,'FINDLAY','OH','45840','2921','CY','39063','1987-02-03','M','U',':RET:2106-3','N','021','HLT','218646','92036OH006001501','2014-01-01','2013-11-26 12:16:11','96.00',NULL,NULL,'178.73','82.73','R-OH002','OH0','178.73',NULL,0,'2013-12-25 23:32:56'),(22273,17778,'Y','18','021','EC','A','','','AC','0000927866','0000927866','TX00002139005','IL','1','Stewart','Daniel','','','','34','460791463','309 W CHURCH ST',0,'SAN SABA','TX','76877','5729','CY','48411','1984-03-03','M','U',':RET:2106-3','N','021','DEN','2634512','33348TX002000201','2014-03-01','2014-01-24 18:39:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:15'),(22139,17670,'N','01','021','EC','A',NULL,NULL,'','0001095701','0000292008','','IL','1','SELF','DEBORAH','K','','','34','268561230','816 WILLARD ST',0,'WASHINGTON COURT HOUSE','OH','43160','2157','CY','39047','1954-01-31','F','',':RET:2106-3','N','021','DEN','3616832','99734OH005000401','2014-03-01','2014-02-08 17:35:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:48'),(3886,3113,'N','19','021','EC','A',NULL,NULL,'','0000928484','0001034646','','IL','1','Heaton','Jeremy','M','','','34','270985885','2793 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','2263','CY','39153','1994-09-12','M','',':RET:2106-3','N','021','HLT','1146485','52664OH152000901','2014-01-01','2013-12-13 11:11:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:36:35'),(4002,3196,'Y','18','021','EC','A','','','AC','0000780491','0000780491','OH00000864639','IL','1','Neely','Linnette','','','','34','299480651','1746 Bising Ave',0,'Cincinnati','OH','45239',NULL,'CY','39061','1949-06-26','F','U',':RET:2054-5','N','021','DEN','1547212','99734OH005000401','2014-01-01','2013-12-16 19:37:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:13'),(16088,12884,'Y','18','021','EC','A','','','AC','0000919408','0000919408','OH00001961248','IL','1','BURNS','NICOLE','','','','34','289807456','2950 CLEINVIEW AVE',0,'CINCINNATI','OH','45206','1421','CY','39061','1969-08-22','F','U',':RET:2054-5','N','021','DEN','2286076','99734OH005000401','2014-02-01','2014-01-03 18:05:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:04:19'),(8834,7002,'N','01','021','EC','A',NULL,NULL,'','0000606516','0000568901','','IL','1','Ribeiro','Wendi',NULL,NULL,NULL,NULL,NULL,'1461 FM 934',0,'Blum','TX','76627',NULL,'CY','48217','1965-05-05','F','',':RET:2106-3','N','021','DEN','2202795','33348TX002000201','2014-01-01','2013-12-17 20:39:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:00:34'),(27755,21949,'Y','18','021','EC','A','','','AC','0001219877','0001219877','LA00003128146','IL','1','ROJAS RODRIGUEZ','GUADALUPE','','','','34','439676181','2400 N BROAD ST',0,'NEW ORLEANS','LA','70122','2930','CY','22071','1961-12-05','F','M',NULL,'N','021','DEN','3417247','18575LA002000201','2014-04-01','2014-03-05 10:14:54','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:17'),(13987,11143,'N','01','021','EC','A',NULL,NULL,'','0000581489','0000600797','','IL','1','Day','Evelyn',NULL,NULL,NULL,NULL,NULL,'2002 Austin Bluffs',0,'Toledo','OH','43615',NULL,'CY','39095','1950-05-21','F','',NULL,'N','021','HLT','1632211','92036OH001002601','2014-01-01','2013-12-23 09:58:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','694.33',NULL,0,'2013-12-26 13:15:42'),(3344,2680,'Y','18','024','14','A','','','TE','0000450528','0000450528','','IL','1','Martin','Lisa','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-15','F','',NULL,NULL,NULL,'','1479712','','2013-12-21','2013-12-21 23:19:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:16:34'),(7611,6023,'Y','18','021','EC','A','','','AC','0000348758','0000348758','TX00000126831','IL','1','Warren','liberty','','','','34','449195649','7018 Wild Violet Dr.',0,'Humble','TX','77346',NULL,'CY','48201','1959-08-31','M','M',':RET:2106-3','T','021','DEN','1222005','33348TX002000101','2014-01-01','2013-11-17 09:01:19','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:45:40'),(6864,5443,'Y','18','024','14','A','','','TE','0000092463','0000092463','','IL','1','Bracken','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-09-09','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:31:45'),(28692,22706,'N','01','021','EC','A',NULL,NULL,'','0000203147','0001200954','','IL','1','HENRY','DANIEL','','','','34','271540753','1297 W COMET RD',0,'CLINTON','OH','44216','9666','CY','39153','1953-10-20','M','',NULL,'N','021','HLT','3724542','52664OH152000901','2014-04-01','2014-03-08 15:31:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.31',NULL,0,'2014-03-08 21:31:03'),(24878,19726,'Y','18','024','14','A','','','TE','0000227044','0000227044','','IL','1','Oliver','Tenola','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-06-19','F','',NULL,NULL,NULL,'','1656286','','2014-02-28','2014-02-19 09:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:35:29'),(493,403,'Y','18','021','EC','A','','','AC','0000503418','0000503418','LA00001010155','IL','1','Oakley','Valerie','','','','34','094609136','122 S SAMMY AVE',0,'GONZALES','LA','70737','3330','CY','22005','1974-11-18','F','M',':RET:2106-3','N','021','DEN','125345','18575LA002000201','2014-01-01','2013-12-04 13:58:47','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:48:28'),(20733,16566,'Y','18','024','14','A','','','TE','0000582837','0000582837','','IL','1','SCHEDLER','LAURA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-10-06','F','',NULL,NULL,NULL,'','3518808','','2014-01-30','2014-01-30 10:41:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:20'),(17847,14256,'Y','18','021','EC','A','','','AC','0001143335','0001143335','OH00002265017','IL','1','Davis','Jeffrey','','','','34','298828455','912 GLENSIDE RD',0,'SOUTH EUCLID','OH','44121','3442','CY','39035','1985-03-06','M','U',NULL,'N','021','DEN','2107113','99734OH005000401','2014-02-01','2014-01-14 08:53:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:05'),(5309,4209,'Y','18','024','14','A','','','TE','0000782334','0000782334','','IL','1','JEFFERSON','ANGELA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-11','F','',NULL,NULL,NULL,'','1850663','','2013-12-19','2013-12-19 11:51:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 23:06:31'),(13061,10410,'N','01','021','EC','A',NULL,NULL,'','0000184938','0000176390','','IL','1','Filina','Robert','','','','34','293640865','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','1970-06-10','M','',':RET:2106-3','N','021','DEN','1466228','99734OH005000401','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:02'),(28101,22242,'Y','18','021','EC','A','','','AC','0000951870','0000951870','OH00003247342','31','1','Francis','John','','','','34','268741280','PO Box 68',0,'Randolph','OH','44265',NULL,'CY','39133','1962-03-29','M','U',':RET:2106-3','T','021','HLT','3650815','52664OH152000901','2014-04-01','2014-03-05 19:53:03','75.00',NULL,NULL,'366.67','291.67','R-OH012','OH0','366.67',NULL,0,'2014-03-06 21:02:10'),(6010,4758,'Y','18','021','EC','A','','','AC','0000366252','0000366252','OH00001169116','IL','1','Braunstein','Pamela','J','','','34','280569077','6542 SIMON DR',0,'CINCINNATI','OH','45233','4562','CY','39061','1954-07-25','F','M',':RET:2106-3','N','021','DEN','1195773','99734OH005000301','2014-01-01','2013-12-01 11:13:11','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:00:35'),(21576,17234,'Y','18','021','EC','A','','','AC','0000999881','0000999881','OH00001959311','IL','1','Jeffries','Stephone',NULL,NULL,NULL,NULL,NULL,'1000 DELIA AVE',0,'AKRON','OH','44320','2120','CY','39153','1964-07-16','M','U',':RET:2054-5','N','021','HLT','3628478','52664OH151001305','2014-03-01','2014-02-05 12:50:42','281.00',NULL,NULL,'380.45','99.45','R-OH012','OH0','380.45',NULL,0,'2014-02-05 21:30:23'),(15409,12326,'Y','18','021','EC','A','','','AC','0000826937','0000826937','TX00000609704','IL','1','nguyen','Tuyen','','','','34','445821511','531 hawthorne dr',0,'murphy','TX','75094',NULL,'CY','48085','1963-05-28','F','U',':RET:2047-9','N','021','DEN','1670382','33348TX002000201','2014-02-01','2013-12-30 23:23:16','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:27:03'),(17970,14359,'Y','18','021','EC','A','','','AC','0000759729','0000759729','OH00002189496','IL','1','Nelson','Shamecka','','','','34','404085979','112 GLADYS CT',0,'OBERLIN','OH','44074','1716','CY','39093','1977-07-16','F','U',':RET:2054-5','N','021','HLT','2421177','52664OH151001305','2014-02-01','2014-01-13 21:34:40','161.00',NULL,NULL,'309.37','148.37','R-OH011','OH0','309.37',NULL,0,'2014-01-15 02:06:49'),(17504,13996,'Y','18','021','EC','A','','','AC','0000530709','0000530709','OH00001683744','IL','1','Lampert','Christine','','','','34','049663699','7291 Lauren J Drive',0,'Mentor','OH','44060',NULL,'CY','39085','1969-06-06','F','M',':RET:2106-3','N','021','HLT','1596454','52664OH151001501','2014-02-01','2014-01-11 19:22:12','216.00',NULL,NULL,'1388.83','1172.83','R-OH011','OH0','421.42',NULL,0,'2014-01-13 03:01:27'),(28079,22223,'Y','18','021','EC','A','','','AC','0000164094','0000164094','TX00002442195','IL','1','Gonzales','James','','','Jr','34','452236537','122 STERLING DR',0,'SAN ANTONIO','TX','78220','3133','CY','48029','1959-09-30','M','M',NULL,'N','021','DEN','3706027','33348TX002000101','2014-04-01','2014-03-05 22:01:21','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2014-03-06 21:01:56'),(14904,11906,'Y','18','021','EC','A','','','AC','0000522506','0000522506','MS00000387350','31','1','Nguyen','John','','','','34','603329881','10051 Starbright Cir',0,'Westminster','CA','92683',NULL,'CY','28049','1988-09-11','M','U',':RET:2047-9','N','021','DEN','1456950','46300MS002000201','2014-02-01','2013-12-28 18:44:45','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-30 00:01:14'),(4975,3950,'Y','18','021','EC','A','','','AC','0000645231','0000645231','TX00000022302','IL','1','Lewis','Dennis','','','','34','462775515','3212 BAIN PL',0,'TYLER','TX','75701','7916','CY','48423','1986-03-03','M','U',':RET:2106-3','N','021','DEN','104346','33348TX002000201','2014-01-01','2013-12-06 20:59:11','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 22:46:34'),(14901,11903,'Y','18','021','EC','A','','','AC','0000545254','0000545254','OH00001759609','IL','1','hauss','joan','','','','34','291609961','9170 TRELAWNEY CT',0,'CINCINNATI','OH','45251','3034','CY','39061','1961-04-29','F','U',':RET:2106-3','T','021','DEN','2039769','99734OH005000301','2014-02-01','2013-12-28 18:20:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-30 00:01:08'),(494,403,'N','01','021','EC','A',NULL,NULL,'','0000503418','0000448580','','IL','1','Oakley','David','Lee','','','34','115586684','122 S SAMMY AVE',0,'GONZALES','LA','70737','3330','CY','22005','1964-03-20','M','',':RET:2106-3','N','021','DEN','125345','18575LA002000201','2014-01-01','2013-12-04 13:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 17:48:29'),(5967,4723,'N','01','021','EC','A',NULL,NULL,'','0000427630','0000043232','','IL','1','lashaway','dennis','l','','','34','277589246','15111 MERMILL RD',0,'RUDOLPH','OH','43462','9633','CY','39173','1960-12-18','M','',':RET:2106-3','N','021','HLT','2437178','92036OH004002601','2014-01-01','2013-12-23 22:16:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.86',NULL,0,'2013-12-25 23:51:30'),(14086,11226,'Y','18','021','EC','A','','','AC','0000103887','0000103887','OH00001177875','IL','1','louis','sharon','','','','34','179441346','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-08-15','F','M',':RET:2106-3','T','021','DEN','1649884','99734OH005000401','2014-02-01','2013-12-26 10:40:42','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:01:15'),(25124,19929,'Y','18','021','EC','A','','','AC','0001174433','0001174433','OH00003147722','IL','1','ulrick','peter','','','','34','271765322','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1979-08-19','M','M',':RET:2106-3','N','021','HLT','3177188','92036OH004001501','2014-04-01','2014-02-20 20:29:57','340.00',NULL,NULL,'449.32','109.32','R-OH002','OH0','214.83','CIC',0,'2014-02-21 21:30:22'),(9116,7232,'Y','18','021','EC','A','','','AC','0000024100','0000024100','OH00001133645','IL','1','Legros','Terry','','','','34','277482407','1748 BANTAM RIDGE RD',0,'WINTERSVILLE','OH','43953','7267','CY','39081','1949-09-25','F','M',':RET:2106-3','N','021','DEN','1713868','99734OH005000301','2014-01-01','2013-12-18 17:02:43','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:07:39'),(6896,5472,'Y','18','021','EC','A','','','AC','0001997204','0001997204','LA00001428399','IL','1','Tibbs','Surnovia','','','','34','437331829','1809 N. Harco Bldg 2',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1978-01-19','F','M',':RET:2054-5','T','021','DEN','2594124','18575LA002000201','2014-01-01','2013-12-24 21:42:35','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:31'),(23455,18684,'Y','18','021','EC','A','','','AC','0000012910','0000012910','TX00001685709','31','1','JOHNSON','ROBERT','','','','34','452984438','PO BOX 532',0,'LUFKIN','TX','75902',NULL,'CY','48005','1955-04-02','M','U',NULL,'N','021','DEN','3530728','33348TX002000201','2014-03-01','2014-02-13 14:01:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:39'),(7133,5660,'Y','18','021','EC','A','','','AC','0001112200','0001112200','MS00001355428','IL','1','reed','wendy','','','','34','587495491','159 SPRING HILL CEMETERY RD',0,'EUPORA','MS','39744','5721','CY','28155','1970-09-23','F','M',':RET:2106-3','N','021','DEN','2497056','46300MS002000101','2014-01-01','2013-12-24 20:57:57','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 01:51:40'),(7475,5915,'Y','18','021','EC','A','','','AC','0000279532','0000279532','OH00000348083','IL','1','Hattar','Raymond',NULL,NULL,NULL,NULL,NULL,'3906 JEFFERSON LN',0,'AMELIA','OH','45102','1180','CY','39025','1979-08-07','M','M',NULL,'T','021','DEN','235962','99734OH005000401','2014-01-01','2013-12-15 09:24:18','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:31:16'),(17590,14060,'Y','18','021','EC','A','','','AC','0000060286','0000060286','OH00001963978','IL','1','Ellis','Genise','','','','34','376682808','36 Cambridge Ave.',0,'Dayton','OH','45406',NULL,'CY','39113','1962-03-02','F','U',':RET:2054-5','N','021','DEN','1999436','99734OH005000401','2014-02-01','2014-01-13 18:32:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-14 01:32:09'),(21103,16863,'N','19','021','EC','A',NULL,NULL,'','0000874735','0001253568','','IL','1','Pylypuik','Jonathon','P',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','2006-03-25','M','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-02-03 21:00:04'),(14751,11778,'Y','18','021','EC','A','','','AC','0000761114','0000761114','OH00001710048','IL','1','Hawkins','Jeremy','','','','34','290681520','1800 N.Mccord',0,'Toledo','OH','43615',NULL,'CY','39095','1975-07-14','M','M',':RET:2106-3','N','021','HLT','1474249','92036OH006002601','2014-02-01','2013-12-27 20:31:53','0.00',NULL,NULL,'192.70','192.70','R-OH001','OH0','192.70',NULL,1,'2013-12-29 11:10:18'),(26103,20703,'Y','18','021','EC','A','','','AC','0000203139','0000203139','OH00003226976','IL','1','James','Linda','','','','34','278523742','608 STONER RD',0,'CLINTON','OH','44216','9605','CY','39153','1953-01-10','F','M',':RET:2106-3','N','021','HLT','3131255','52664OH152000901','2014-03-01','2014-02-26 18:10:16','770.00',NULL,NULL,'928.27','158.27','R-OH012','OH0','458.99',NULL,0,'2014-02-28 06:30:13'),(21780,17393,'N','19','021','EC','A',NULL,NULL,'','0000688322','0000482222','','IL','1','shaffer','austin','ronald',NULL,NULL,NULL,NULL,'4934 state route 276',0,'batavia','OH','45103',NULL,'CY','39025','1997-11-26','M','',':RET:2106-3','N','021','DEN','2986182','99734OH005000401','2014-03-01','2014-02-05 21:52:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:00:37'),(14455,11532,'Y','18','021','EC','A','','','AC','0001918710','0001918710','LA00001038397','IL','1','tran','trang','','','','34','434850892','2505 pirate drive',0,'chalmette','LA','70043',NULL,'CY','22087','1974-10-20','F','U',':RET:2047-9','N','021','DEN','2518357','18575LA002000201','2014-02-01','2013-12-27 14:36:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:36'),(25506,20236,'Y','18','021','EC','A','','','AC','0000054520','0000054520','OH00002943899','IL','1','Meeks','William','','','','34','286646872','4080 HAMBLETON AVE',0,'LOUISVILLE','OH','44641','9428','CY','39151','1957-09-28','M','M',':RET:2106-3','N','021','HLT','3169253','52664OH152000901','2014-04-01','2014-02-25 16:30:56','402.00',NULL,NULL,'593.74','191.74','R-OH015','OH0','381.07',NULL,0,'2014-02-25 21:31:58'),(17720,14160,'N','19','021','EC','A',NULL,NULL,'','0000783254','0000802598','','IL','1','Brown','Jason','R','','','34','301986312','541 CLARK DR',0,'TALLMADGE','OH','44278','1549','CY','39153','1996-10-13','M','',':RET:2106-3','N','021','HLT','2720438','52664OH152000901','2014-02-01','2014-01-13 15:10:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-14 01:33:14'),(1212,996,'Y','18','021','EC','A','','','AC','0000290762','0000290762','OH00001160755','IL','1','DOGGETT','LINDA','DARLENE','','','34','277524971','1849 BLEDSOE DR',0,'BELLBROOK','OH','45305','1316','CY','39057','1956-02-05','F','M',':RET:2106-3','T','021','HLT','957167','92036OH005000501','2014-01-01','2013-12-02 21:41:45','969.00',NULL,NULL,'1349.12','380.12','R-OH003','OH0','666.19',NULL,0,'2013-12-25 18:20:07'),(16685,13351,'Y','18','024','14','A','','','TE','0000183390','0000183390','','IL','1','Nugent','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-09-25','F','',NULL,NULL,NULL,'','2501273','','2014-01-06','2014-01-06 18:39:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-08 18:24:32'),(8033,6360,'Y','18','021','EC','A','','','AC','0000569486','0000569486','MS00000522888','IL','1','Morgan','Mary','','','','34','426026311','782 CRESTON DR',0,'BYRAM','MS','39272','3000','CY','28049','1953-08-23','F','U',':RET:2054-5','N','021','DEN','1444205','46300MS002000101','2014-01-01','2013-12-20 18:10:41','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 03:09:12'),(27293,21611,'Y','18','021','EC','A','','','AC','0001257048','0001257048','TX00002427454','IL','1','FANG','LUCY','','','','34','572719138','514 ENCHANTED SPRINGS DR',0,'ROSENBERG','TX','77471','6422','CY','48157','1954-01-14','F','U',':RET:2034-7','N','021','DEN','3896268','33348TX002000201','2014-04-01','2014-03-04 11:04:16','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:30'),(19127,15239,'N','01','021','EC','A',NULL,NULL,'','0000535785','0000314730','','IL','1','MOHAMUD','SAHRA','','','','34','600797499','2388 VINING DR',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1971-09-30','F','',':RET:2054-5','N','021','DEN','2746277','99734OH005000401','2014-03-01','2014-01-19 08:45:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:45:21'),(14978,11970,'N','01','021','EC','A',NULL,NULL,'','0000557904','0000682537','','IL','1','Ye','Julia','','','','34','496940286','9618 OAKLAND LAKE WAY',0,'MISSOURI CITY','TX','77459','6451','CY','48157','1962-01-03','F','',':RET:2034-7','N','021','DEN','1492600','33348TX002000201','2014-02-01','2013-12-30 13:40:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:00:59'),(7848,6214,'Y','18','021','EC','A','','','AC','0001220827','0001220827','OH00001183481','IL','1','Kowalski','Christina','','','','34','298643903','7573 SCENICVIEW DR',0,'INDEPENDENCE','OH','44131','6500','CY','39035','1962-10-04','F','U',':RET:2106-3','N','021','DEN','2487878','99734OH005000301','2014-01-01','2013-12-20 08:57:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:04:44'),(17894,14292,'N','01','021','EC','A',NULL,NULL,'','0000880542','0000586714','','IL','1','Hawkins','Thomas','','','','34','253750644','1877 LARAMIE DR',0,'POWELL','OH','43065','7504','CY','39049','1982-05-25','M','',':RET:2106-3','N','021','DEN','2124356','99734OH005000401','2014-02-01','2014-01-14 16:54:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:21'),(614,506,'Y','18','021','EC','A','','','AC','0000268889','0000268889','OH00001319919','IL','1','Wink','Melissa','','','','34','220980978','3434 MOONEY AVE',0,'CINCINNATI','OH','45208','2006','CY','39061','1968-03-20','F','U',':RET:2106-3','N','021','DEN','2458023','99734OH005000401','2014-01-01','2013-12-16 10:29:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:00:40'),(24906,19746,'Y','18','024','14','A','','','TE','0000047108','0000047108','','IL','1','DE SANTIAGO','JOSE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-24','M','',NULL,NULL,NULL,'','2591080','','2014-03-31','2014-02-20 17:47:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 21:30:05'),(21320,17037,'Y','18','021','EC','A','','','AC','0001607992','0001607992','LA00002556266','31','1','johnson','darlene','','','','34','433042831','PO BOX 385',0,'garyville','LA','70051',NULL,'CY','22095','1960-05-12','F','U',':RET:2054-5','N','021','DEN','3021708','18575LA002000201','2014-03-01','2014-02-04 17:01:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:22'),(16,12,'Y','18','021','EC','A','','','AC','0000936035','0000936035','OH00000159924','IL','1','Moss','Karen','','','','34','286528614','528 Jackson St',0,'Sandusky','OH','44870',NULL,'CY','39043','1951-11-29','F','U',':RET:2106-3','N','021','DEN','654948','99734OH005000401','2014-01-01','2013-12-05 09:47:51','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 17:15:24'),(14752,11779,'Y','18','021','EC','A','','','AC','0000402471','0000402471','OH00001592025','IL','1','Creech','Crystal','','','','34','290661344','214 KNEDLER RD',0,'CLARKSVILLE','OH','45113','8688','CY','39027','1969-06-29','F','M',':RET:2106-3','N','021','HLT','1404626','92036OH001000601','2014-02-01','2013-12-27 22:06:18','359.00',NULL,NULL,'723.48','364.48','R-OH005','OH0','361.74',NULL,1,'2013-12-29 11:10:20'),(5990,4742,'Y','18','021','EC','A','','','AC','0000570562','0000570562','OH00000772111','IL','1','Temple','Kathleen','','','','34','268502660','520 Milan Ave.',0,'Norwalk','OH','44857',NULL,'CY','39077','1952-07-13','F','U',':RET:2106-3','N','021','HLT','2317932','92036OH003002705','2014-01-01','2013-12-24 01:51:55','462.00',NULL,NULL,'572.23','110.23','R-OH006','OH0','572.23',NULL,0,'2013-12-25 23:52:11'),(1798,1477,'Y','18','024','14','A','','','TE','0000529404','0000529404','','IL','1','Prout','Mark','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-12-01','M','',NULL,NULL,NULL,'','669510','','2013-12-24','2013-12-24 17:47:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:56:42'),(22967,18312,'Y','18','024','14','A','','','TE','0000792244','0000792244','','IL','1','Kopac','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-25','M','',NULL,NULL,NULL,'','3697907','','2014-02-28','2014-02-12 17:22:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-12 21:00:14'),(14865,11869,'N','01','021','EC','A',NULL,NULL,'','0000008809','0000546503','','IL','1','Manion','Rebecca','','','','34','465574249','915 MEADOW VIEW DR',0,'RICHARDSON','TX','75080','3009','CY','48113','1972-08-12','F','',':RET:2106-3','N','021','DEN','1622478','33348TX002000201','2014-02-01','2013-12-28 18:14:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-30 00:00:04'),(22660,18095,'Y','18','021','EC','A','','','AC','0000983819','0000983819','TX00002623709','IL','1','Carrizales','Maria','','','','34','461455485','4218 Juarez',0,'Laredo','TX','78041',NULL,'CY','48479','1966-08-25','F','U',':RET:2106-3','N','021','DEN','3224666','33348TX002000201','2014-03-01','2014-02-11 13:12:01','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2014-02-11 21:00:34'),(21362,17074,'Y','18','021','EC','A','','','AC','0000592299','0000592299','TX00002438637','IL','1','Carpenter','Peterson','','','','34','458776428','122 COUNTRY EST',0,'EUSTACE','TX','75124','9600','CY','48213','1985-11-13','M','M',NULL,'N','021','DEN','3106089','33348TX002000201','2014-03-01','2014-02-04 15:57:58','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:44'),(1029,844,'Y','18','021','EC','A','','','AC','0000953585','0000953585','TX00000459634','IL','1','Dorsey','Laura','','','','34','433710147','2784 FM 2434',0,'Columbus','TX','78934',NULL,'CY','48089','1985-12-23','F','M',':RET:2106-3','N','021','DEN','238836','33348TX002000201','2014-01-01','2013-12-03 09:37:55','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:15:29'),(17477,13973,'Y','18','021','EC','A','','','AC','0000660425','0000660425','TX00001875077','IL','1','Adams','Stephanie','','','','34','464396079','1302 Waugh Drive',0,'Houston','TX','77019',NULL,'CY','48201','1963-10-01','F','U',':RET:2054-5','N','021','DEN','1541760','33348TX002000201','2014-02-01','2014-01-12 12:20:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 03:01:10'),(14513,11579,'Y','18','021','EC','A','','','AC','0000500763','0000500763','TX00001738747','IL','1','Moss','Debra','','','','34','465924828','109 E CENTRE ST',0,'FREDERICKSBURG','TX','78624','3913','CY','48171','1953-01-11','F','U',':RET:2106-3','N','021','DEN','2182271','33348TX002000201','2014-02-01','2013-12-27 16:09:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:34:07'),(25819,20472,'Y','18','021','EC','A','','','AC','0001016910','0001016910','OH00003278627','IL','1','Ablaghi-Darian','Zahra','','','','34','277966737','7620 SESSIS DR',0,'WORTHINGTON','OH','43085','5318','CY','39049','1950-10-27','F','U',':RET:2106-3','N','021','DEN','2742217','99734OH005000301','2014-04-01','2014-02-26 15:31:17','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:00:25'),(23482,18704,'Y','18','021','EC','A','','','AC','0001786568','0001786568','LA00002244824','IL','1','Leppala','Maarit','','','','34','104722454','5812 FLOWER DR',0,'METAIRIE','LA','70003','1028','CY','22051','1961-04-16','F','U',':RET:2106-3','N','021','DEN','2960602','18575LA002000101','2014-03-01','2014-02-13 10:23:43','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-13 22:01:56'),(23401,18645,'N','19','021','EC','A',NULL,NULL,'','0000546511','0000327317','','S1','1','Johnson','Jenny','','','','34','286029754','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','1997-10-15','M','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:10'),(20064,16003,'Y','18','021','EC','A','','','AC','0001090727','0001090727','TX00001536804','IL','1','Emerson','Linda','F','','','34','453372740','2621 JUNIUS ST',0,'SAN ANGELO','TX','76901','1466','CY','48451','1959-01-05','F','U',':RET:2054-5','N','021','DEN','2492798','33348TX002000201','2014-03-01','2014-01-27 12:42:03','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-27 21:00:13'),(6301,4998,'Y','18','021','EC','A','','','AC','0000362478','0000362478','OH00000365210','IL','1','Wesser','Claude','','','','34','278483778','11834 SUNBURST AVE',0,'LAKEVIEW','OH','43331','9266','CY','39091','1950-01-06','M','U',':RET:2106-3','N','021','DEN','46259','99734OH005000401','2014-01-01','2013-12-11 09:27:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:45:54'),(5509,4373,'N','19','021','EC','A',NULL,NULL,'','0001207117','0000396124','','IL','1','Stamp','Jenna','Paige','','','34','268155168','11818 Hidden Lake Dr.',0,'Marshallville','OH','44645',NULL,'CY','39169','2008-08-28','F','',':RET:2106-3','N','021','DEN','1073474','99734OH005000301','2014-01-01','2013-11-26 18:22:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:07'),(3200,2574,'Y','18','021','EC','A','','','AC','0000847118','0000847118','OH00000834160','IL','1','Ross','Natasha','','','','34','300806038','615 FRANKLIN AVE',0,'COLUMBUS','OH','43215','4715','CY','39049','1983-11-05','F','U',':RET:2106-3','N','021','DEN','498038','99734OH005000401','2014-01-01','2013-10-31 19:41:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:45:08'),(18252,14571,'Y','18','021','EC','A','','','AC','0001157343','0001157343','TX00001631483','IL','1','Hayes','Arthur','Joe','','','34','450153041','3740 PINE MILL RD',0,'PARIS','TX','75462','5254','CY','48277','1961-07-05','M','U',':RET:2106-3','N','021','DEN','1520209','33348TX002000201','2014-02-01','2014-01-15 11:11:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:31'),(17762,14191,'N','01','021','EC','A',NULL,NULL,'','0000201941','0000443475','','IL','1','Hayes','Kenneth','L','','Sr','34','249848837','2420 JETT HILL RD',0,'NEW RICHMOND','OH','45157','9593','CY','39025','1951-07-05','M','',':RET:2106-3','N','021','HLT','2001992','92036OH004000601','2014-02-01','2014-01-13 12:35:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','495.91',NULL,0,'2014-01-14 01:33:33'),(28365,22444,'Y','18','021','EC','A','','','AC','0000023919','0000023919','TX00003416499','IL','1','inman','anna','','','','34','457800876','219 S CENTRE ST',0,'DE KALB','TX','75559','1820','CY','48037','1950-02-05','F','U',':RET:2106-3','T','021','DEN','3649432','33348TX002000201','2014-04-01','2014-03-07 15:51:59','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-03-07 21:30:31'),(7216,5720,'Y','18','021','EC','A','','','AC','0000690707','0000690707','OH00000129963','IL','1','Sarisky','Michael','','','','34','298441448','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1954-05-03','M','M',':RET:2106-3','N','021','DEN','5673','99734OH005000401','2014-01-01','2013-12-14 12:07:50','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:01:02'),(6848,5429,'Y','18','021','EC','A','','','AC','0000183179','0000183179','TX00000064419','IL','1','Wilson','Justin','','','','34','519984110','3105 Old Highway 77',0,'Brownsville','TX','78520',NULL,'CY','48061','1981-02-18','M','U',NULL,'N','021','DEN','961886','33348TX002000201','2014-01-01','2013-10-05 08:43:12','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 01:31:19'),(14360,11452,'N','01','021','EC','A',NULL,NULL,'','0000607163','0000894627','','IL','1','SAMAS','LAUREN','','','','34','275883779','5963 SPRINGWOOD DR',0,'MENTOR','OH','44060','2839','CY','39085','1983-01-02','F','',NULL,'N','021','DEN','1693430','99734OH005000401','2014-02-01','2013-12-26 19:27:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:14'),(2267,1853,'Y','18','021','EC','A','','','AC','0000363754','0000363754','OH00000583380','IL','1','Dalton','Brooke','','','','34','300601269','540 THACKERAY RD',0,'MAUMEE','OH','43537','2359','CY','39095','1977-09-09','F','M',':RET:2106-3','N','021','DEN','163870','99734OH005000301','2014-01-01','2013-12-09 09:53:52','0.00',NULL,NULL,'59.76','59.76','R-OH001','OH0','0.00',NULL,0,'2013-12-25 19:30:19'),(29195,23106,'Y','18','021','EC','A','','','AC','0000906663','0000906663','OH00002905912','IL','1','BRADFORD','WARREN','','','','34','289804776','3615 BERKELEY RD',0,'CLEVELAND HEIGHTS','OH','44118','1940','CY','39035','1969-06-26','M','M',NULL,'N','021','DEN','3599206','99734OH005000301','2014-04-01','2014-03-10 11:31:10','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00','CIC',0,'2014-03-10 21:30:08'),(23529,18743,'Y','18','021','EC','A','','','AC','0002130744','0002130744','LA00002085092','31','1','BROWN','ANDREW','','','','34','439191616','PO BOX 704',0,'AMA','LA','70031',NULL,'CY','22089','1971-01-31','M','U',NULL,'N','021','DEN','3093449','18575LA002000201','2014-03-01','2014-02-13 10:33:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:25'),(628,519,'Y','18','021','EC','A','','','AC','0001097767','0001097767','OH00000856776','IL','1','Sweeney','Robert','','','','34','381582338','270 N ARDMORE RD',0,'COLUMBUS','OH','43209','1447','CY','39049','1953-09-05','M','M',':RET:2106-3','N','021','DEN','2157161','99734OH005000401','2014-01-01','2013-12-16 12:51:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:01:02'),(23051,18378,'Y','18','021','EC','A','','','AC','0000470734','0000470734','TX00002563608','IL','1','MACK','DEBRA','','','','34','466028024','122 WEST BROWNLEE AVE',0,'DALLAS','TX','75224',NULL,'CY','48113','1958-04-16','F','U',':RET:2054-5','N','021','DEN','3739259','33348TX002000201','2014-03-01','2014-02-12 16:50:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:45'),(22234,17747,'Y','18','021','EC','A','','','AC','0000865647','0000865647','TX00002466568','IL','1','McKenzie','Lesa','','','','34','463415030','9406 NELLS FARM',0,'HELOTES','TX','78023','4172','CY','48029','1963-05-14','F','U',':RET:2054-5','N','021','DEN','3194952','33348TX002000101','2014-03-01','2014-02-09 14:45:36','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-09 19:00:34'),(18087,14446,'Y','18','021','EC','A','','','AC','0002358367','0002358367','LA00001561422','31','1','DYER','LONDA','','','','34','436219357','3778 UNCAS ST',0,'BATON ROUGE','LA','70805',NULL,'CY','22033','1961-09-21','F','U',':RET:2054-5','N','021','DEN','2450695','18575LA002000201','2014-02-01','2014-01-14 11:45:36','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-15 02:07:29'),(16469,13178,'Y','18','021','EC','A','','','AC','0000173825','0000173825','OH00001288920','IL','1','Mcgrady','Karen','','','','34','273588771','900 VALDES AVE',0,'AKRON','OH','44320','1746','CY','39153','1958-04-17','F','U',':RET:2054-5','N','021','HLT','1574974','52664OH151001301','2014-02-01','2014-01-06 13:07:28','162.00',NULL,NULL,'497.31','335.31','R-OH012','OH0','497.31',NULL,0,'2014-01-07 04:05:53'),(26992,21380,'Y','18','021','EC','A','','','AC','0000779160','0000779160','OH00002654646','IL','1','Vo','Tommy','','','','34','288968234','6938 Hawksbeard dr',0,'Westerville','OH','43082',NULL,'CY','39041','1975-04-01','M','M',':RET:2047-9','N','021','DEN','3839908','99734OH005000301','2014-04-01','2014-03-02 11:43:22','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00','CIC',0,'2014-03-03 01:29:59'),(9273,7357,'Y','18','021','EC','A','','','AC','0000222373','0000222373','OH00000050934','IL','1','Stover','Louella','M','','','34','292567127','2001 MOUNT CARMEL RD',0,'VINTON','OH','45686','9132','CY','39053','1958-09-21','F','M',':RET:2106-3','N','021','DEN','1077152','99734OH005000401','2014-01-01','2013-11-30 17:41:43','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-26 04:15:43'),(46,41,'Y','18','021','EC','A','','','AC','0000597860','0000597860','MS00000132305','IL','1','Hunter','Debra','','','','34','587134719','3170 BENSON DR',0,'JACKSON','MS','39212','4209','CY','28049','1964-12-15','F','U',':RET:2054-5','N','021','DEN','222660','46300MS002000101','2014-01-01','2013-12-04 19:56:27','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 17:16:13'),(297,246,'Y','18','021','EC','A','','','AC','0001166770','0001166770','OH00000100234','IL','1','White','Lorenzo','','','','34','268965578','3411 W128th',0,'Cleveland','OH','44111',NULL,'CY','39035','1992-07-02','M','U',':RET:2054-5','N','021','DEN','492182','99734OH005000401','2014-01-01','2013-11-13 15:28:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:30:43'),(22195,17715,'Y','18','021','EC','A','','','AC','0000943309','0000943309','TX00001873062','IL','1','harmon','melonie','','','','34','464439388','2522 53RD ST',0,'LUBBOCK','TX','79413','4408','CY','48303','1969-01-08','F','U',':RET:2106-3','T','021','DEN','3132932','33348TX002000201','2014-03-01','2014-02-09 16:56:27','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-09 19:00:12'),(15891,12724,'N','01','021','EC','A',NULL,NULL,'','0000937283','0000030556','','IL','1','SCOTT','RICHARD','ALLEN','','Sr','34','283641990','3951 GRANDVIEW COURT',0,'TOLEDO','OH','43614',NULL,'CY','39095','1958-11-19','M','',':RET:2106-3','N','021','HLT','2271490','92036OH004002601','2014-02-01','2014-01-02 12:22:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','349.65',NULL,0,'2014-01-03 02:05:44'),(25677,20370,'Y','18','021','EC','A','','','AC','0001107901','0001107901','TX00002325037','IL','1','BARON-MEJIA','LAURA','','','','34','632116467','12406 MERCURY LN',0,'AUSTIN','TX','78727','5211','CY','48453','1990-12-17','F','U',NULL,'N','021','DEN','2766358','33348TX002000101','2014-04-01','2014-02-22 12:46:23','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-26 08:30:55'),(22189,17709,'Y','18','024','14','A','','','TE','0000440970','0000440970','','IL','1','ramsey','marvin','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-02','M','',NULL,NULL,NULL,'','364923','','2014-02-28','2014-02-09 16:54:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-09 19:00:08'),(6476,5129,'N','19','021','EC','A',NULL,NULL,'','0000217560','0000188828','','IL','1','Cord','Elianna','','','','34','293088620','741 ABINGTON RD',0,'AKRON','OH','44312','2440','CY','39153','2004-02-07','F','',':RET:2106-3','N','021','HLT','596609','52664OH151001306','2014-01-01','2013-12-10 23:35:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 00:50:13'),(6717,5327,'Y','18','024','14','A','','','TE','0000645939','0000645939','','IL','1','Ludwig','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-09','M','',NULL,NULL,NULL,'','797819','','2013-11-25','2013-11-25 13:01:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:15:05'),(21531,17202,'Y','18','021','EC','A','','','AC','0000906373','0000906373','TX00001806141','IL','1','HERNDON','LATEARRIA','','','','34','453972760','1810 WILLIAMS ST',0,'LUFKIN','TX','75904','1912','CY','48005','1988-03-18','F','U',':RET:2054-5','N','021','DEN','3230754','33348TX002000101','2014-03-01','2014-02-05 14:35:29','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-05 21:30:06'),(17066,13657,'N','01','021','EC','A',NULL,NULL,'','0001138430','0000364607','','IL','1','Eatmon','Curtis','','','III','34','450670935','1526 Reynoldston',0,'Dallas','TX','75232',NULL,'CY','48113','1980-01-02','M','',':RET:2054-5','N','021','DEN','1545352','33348TX002000201','2014-02-01','2014-01-07 21:43:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:14'),(19222,15315,'N','01','021','EC','A',NULL,NULL,'','0001031477','0000136109','','IL','1','GREEN','BONITA','','','','34','293643343','596 GREENWOOD AVE',0,'AKRON','OH','44320','1865','CY','39153','1958-01-12','F','',NULL,'N','021','DEN','1940029','99734OH005000401','2014-03-01','2014-01-20 10:17:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:46:27'),(24034,19115,'Y','18','021','EC','A','','','AC','0000304757','0000304757','OH00002906434','IL','1','Hineline','Ginger','','','','34','520986117','8368 HAMBLETONIAN DR',0,'CINCINNATI','OH','45249','1309','CY','39061','1967-07-09','F','U',':RET:2106-3','N','021','DEN','2881544','99734OH005000301','2014-03-01','2014-02-15 08:58:34','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:55'),(13944,11118,'N','01','021','EC','A',NULL,NULL,'','0000661345','0000105362','','IL','1','Poshedley','Christine','B','','','34','296804332','11081 FAIRLAWN DR',0,'PARMA','OH','44130','1217','CY','39035','1972-06-03','F','',NULL,'T','021','HLT','1777511','92036OH003000804','2014-01-01','2013-12-22 22:14:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','365.58',NULL,0,'2013-12-26 13:14:46'),(773,639,'Y','18','021','EC','A','','','AC','0001155976','0001155976','TX00000454752','IL','1','Armour','Jason','','','','34','462916438','2515 DURANGO RIDGE DR',0,'BEDFORD','TX','76021','7248','CY','48439','1977-08-17','M','R',':RET:2106-3','T','021','DEN','2569061','33348TX002000201','2014-01-01','2013-12-16 12:43:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:04:52'),(4177,3325,'N','19','021','EC','A',NULL,NULL,'','0000021373','0000304704','','IL','1','Cipro','Joseph','','','','34','273118119','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2004-12-28','M','',':RET:2106-3','N','021','HLT','2222362','52664OH151001304','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 21:49:22'),(2075,1699,'Y','18','021','EC','A','','','AC','0000841402','0000841402','LA00000869037','IL','1','Coleman','Anthony','','','','34','436219873','2749 Hollywood street',0,'Baton Rouge','LA','70805',NULL,'CY','22033','1967-09-29','M','R',':RET:2054-5','N','021','DEN','1001236','18575LA002000201','2014-01-01','2013-12-09 21:44:35','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:28'),(6541,5186,'Y','18','021','EC','A','','','AC','0000225807','0000225807','TX00001313050','IL','1','Palmer','Jeffrey','','','','34','099603595','9641 BARKSDALE DR',0,'FORT WORTH','TX','76244','6047','CY','48439','1966-03-02','M','M',':RET:2106-3','N','021','DEN','325582','33348TX002000201','2014-01-01','2013-12-11 10:38:14','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:51:55'),(16081,12878,'N','01','021','EC','A',NULL,NULL,'','0000398623','0000465933','','IL','1','Stamp','Tricia','B','','','34','296608430','381 southampton',0,'aurora','OH','44202',NULL,'CY','39133','1971-02-24','F','',':RET:2106-3','N','021','DEN','2202481','99734OH005000401','2014-02-01','2014-01-03 15:03:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:04:06'),(17744,14176,'Y','18','021','EC','A','','','AC','0001026954','0001026954','OH00001437579','IL','1','Blankenship','Caroline','','','','34','287641569','1083 SUNHAVEN DR',0,'MEDINA','OH','44256','3000','CY','39103','1958-04-23','F','U',':RET:2106-3','N','021','HLT','1390905','52664OH151001304','2014-02-01','2014-01-13 15:58:26','296.00',NULL,NULL,'497.31','201.31','R-OH012','OH0','497.31',NULL,0,'2014-01-14 01:33:24'),(18697,14906,'Y','18','021','EC','A','','','AC','0001418489','0001418489','LA00002432406','31','1','Johnson','Ricka','','','','34','433177889','PO Box 115',0,'Grayson','LA','71435',NULL,'CY','22021','1963-12-14','F','U',NULL,'N','021','DEN','2795715','18575LA002000101','2014-03-01','2014-01-16 14:02:27','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-17 03:35:26'),(23200,18498,'N','01','021','EC','A',NULL,NULL,'','0000295545','0001236625','','IL','1','Minnich','Joseph','','','','34','213272226','411 FOUR SEASONS DR',0,'MASON','OH','45040','2831','CY','39165','1985-01-18','M','',NULL,'N','021','HLT','3229708','92036OH006001201','2014-03-01','2014-02-12 16:49:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','190.50',NULL,0,'2014-02-12 21:32:08'),(27941,22103,'Y','18','021','EC','A','','','AC','0000246177','0000246177','TX00003073344','IL','1','ZAPATA','LUZ','MARIA','','','34','455350084','1349 JAMES DUDLEY DR',0,'EL PASO','TX','79936',NULL,'CY','48141','1955-02-27','F','U',':RET:2106-3','N','021','DEN','3293253','33348TX002000201','2014-04-01','2014-03-06 13:46:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-06 21:00:32'),(3108,2496,'N','01','021','EC','A',NULL,NULL,'','0000836613','0000253020','','IL','1','Murray','William','','','','34','271525222','1285 County Road F',0,'Swanton','OH','43558',NULL,'CY','39051','1960-08-30','M','',':RET:2106-3','T','021','HLT','757277','92036OH002002601','2014-01-01','2013-12-06 13:27:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','528.29',NULL,0,'2013-12-25 20:20:27'),(19601,15625,'Y','18','021','EC','A','','','AC','0000727314','0000727314','OH00001715519','IL','1','SPORLEDER','ANDY','DALE','','','34','288626717','6020 MAIN ST',0,'SYLVANIA','OH','43560','1265','CY','39095','1957-07-14','M','M',':RET:2106-3','N','021','HLT','2809126','92036OH005002604','2014-03-01','2014-01-22 10:49:54','800.00',NULL,NULL,'1191.97','391.97','R-OH001','OH0','454.92',NULL,0,'2014-01-23 03:02:48'),(18324,14630,'Y','18','021','EC','A','','','AC','0000382186','0000382186','OH00002225910','IL','1','eismon','tonya','','','','34','278642531','112 WING ST',0,'NEWARK','OH','43055','6688','CY','39089','1967-03-12','F','M',':RET:2106-3','N','021','DEN','2916955','99734OH005000401','2014-02-01','2014-01-15 11:34:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:09'),(27983,22140,'Y','18','021','EC','A','','','AC','0001980447','0001980447','LA00003052923','IL','1','Dejean','Karen','Martin','','','34','439274120','724 PATTIE MOSS RD',0,'SULPHUR','LA','70663','1908','CY','22019','1961-10-03','F','U',':RET:2054-5','N','021','DEN','4091485','18575LA002000201','2014-04-01','2014-03-06 16:09:25','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-06 21:00:58'),(24346,19335,'Y','18','021','EC','A','','','AC','0000548116','0000548116','TX00001385724','IL','1','NIETO DE BERLANGA','Lucero','J','','','34','640568777','33657 SHOEMAKER RD',0,'LOS FRESNOS','TX','78566','4903','CY','48061','1960-12-15','F','U',NULL,'N','021','DEN','2865706','33348TX002000201','2014-04-01','2014-02-18 16:35:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-18 22:00:23'),(15707,12566,'Y','18','021','EC','A','','','AC','0000946118','0000946118','OH00001457151','IL','1','Rutkowski','Melinda','','','','34','232237589','1403 DIFFORD DR',0,'NILES','OH','44446','2830','CY','39155','1971-03-07','F','U',':RET:2106-3','N','021','HLT','2586658','92036OH005003205','2014-02-01','2013-12-31 17:32:19','106.00',NULL,NULL,'320.73','214.73','R-OH013','OH0','320.73',NULL,1,'2014-01-02 04:35:57'),(15690,12552,'Y','18','021','EC','A','','','AC','0000071653','0000071653','OH00001369243','IL','1','PEPPEL','CYNTHIA','','','','34','383560750','206 SCENIC VIEW DR',0,'COPLEY','OH','44321','1345','CY','39153','1954-01-04','F','U',':RET:2106-3','N','021','HLT','2306998','52664OH152000901','2014-02-01','2013-12-31 17:23:48','390.00',NULL,NULL,'443.31','53.31','R-OH012','OH0','443.31',NULL,1,'2014-01-02 04:35:19'),(21689,17318,'Y','18','021','EC','A','','','AC','0002378843','0002378843','LA00002375010','IL','1','Branch','Joseph','','','','34','534942923','17525 CHADSFORD AVE',0,'BATON ROUGE','LA','70817','2604','CY','22033','1983-11-20','M','U',':RET:2106-3','N','021','DEN','3619137','18575LA002000101','2014-03-01','2014-02-04 21:42:29','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-05 21:31:05'),(4832,3827,'N','19','021','EC','A',NULL,NULL,'','0000909453','0001062088','','S3','1','Henry','Tracy','glen','','','34','059863382','124 N Main St',0,'Rawson','OH','45881',NULL,'CY','39063','1996-04-14','M','',':RET:2106-3','N','021','HLT','413741','92036OH005001505','2014-01-01','2013-12-08 15:38:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 22:17:21'),(17821,14236,'Y','18','021','EC','A','','','AC','0001052511','0001052511','MS00002458382','IL','1','Briggs','Justin','A','','','34','425537423','523 Foster Rd',0,'Florence','MS','39073',NULL,'CY','28121','1981-08-18','M','U',':RET:2054-5','T','021','DEN','2405652','46300MS002000201','2014-02-01','2014-01-14 10:09:27','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:56'),(20350,16251,'Y','18','024','14','A','','','TE','0000303377','0000303377','','IL','1','Swartz','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-09-20','M','',NULL,NULL,NULL,'','2547549','','2014-01-28','2014-01-28 17:04:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:14'),(15060,12038,'Y','18','021','EC','A','','','AC','0001519180','0001519180','LA00000945324','IL','1','Perry','Quintessa','','','','34','433718113','6478 HIGHWAY 513',0,'MANSFIELD','LA','71052','5159','CY','22031','1984-01-04','F','U',':RET:2054-5','N','021','DEN','1799560','18575LA002000201','2014-02-01','2013-12-30 15:11:48','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-01 12:03:32'),(25298,20071,'Y','18','021','EC','A','','','AC','0001096743','0001096743','OH00002721990','IL','1','Cenna','Sharon','M','','','34','083442803','5250 COLUMBIA RD',0,'NORTH OLMSTED','OH','44070','3531','CY','39035','1950-02-04','F','U',':RET:2106-3','N','021','DEN','2892386','99734OH005000401','2014-04-01','2014-02-25 13:42:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-25 21:00:27'),(870,720,'Y','18','021','EC','A','','','AC','0001184873','0001184873','OH00001086512','IL','1','Whiteleather','Richard','','','','34','285520339','726 TWIN OAKS RD',0,'DEERFIELD','OH','44411','9717','CY','39133','1952-11-22','M','M',':RET:2106-3','N','021','HLT','1649240','52664OH151001501','2014-01-01','2013-12-16 12:51:13','691.00',NULL,NULL,'1503.16','812.16','R-OH012','OH0','751.58',NULL,0,'2013-12-25 18:07:25'),(23672,18849,'Y','18','021','EC','A','','','AC','0002183537','0002183537','LA00002490522','IL','1','theriot','charlmayne','','','','34','438063796','3227 A Lee drive',0,'Pierre Part','LA','70339',NULL,'CY','22007','1962-10-09','F','U',':RET:2106-3','N','021','DEN','3374011','18575LA002000201','2014-03-01','2014-02-13 18:26:37','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-02-14 21:30:25'),(16672,13342,'Y','18','021','EC','A','','','AC','0000491895','0000491895','OH00001859679','IL','1','VEAUTHIER','FREDRICK','','','','34','271788865','7104 GLENDALE AVE',0,'BOARDMAN','OH','44512','4863','CY','39099','1981-05-08','M','U',':RET:2106-3','N','021','DEN','1967530','99734OH005000301','2014-02-01','2014-01-07 14:48:29','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-08 18:24:29'),(23468,18692,'Y','18','021','EC','A','','','AC','0000529509','0000529509','TX00001795834','IL','1','Gonzales','Debra','','','','34','465214873','400 S LLANO ST',0,'WHITNEY','TX','76692','2603','CY','48217','1961-03-24','F','U',':RET:2106-3','N','021','DEN','2826903','33348TX002000201','2014-03-01','2014-02-13 15:25:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:46'),(22976,18319,'N','19','021','EC','A',NULL,NULL,'','0000988927','0000108199','','IL','1','Scherr','Gage','','','','34','283151248','3914 LITTLE CREEK DR',0,'AMELIA','OH','45102','1173','CY','39025','2009-07-21','M','',':RET:2106-3','N','021','DEN','3198987','99734OH005000301','2014-03-01','2014-02-11 18:31:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:05'),(15668,12536,'N','19','021','EC','A',NULL,NULL,'','0000910535','0001031459','','S3','1','Ayers','Deziree',NULL,NULL,NULL,NULL,NULL,'1802 Rosewood Drive',0,'Wapakoneta','OH','45895',NULL,'CY','39011','2007-04-26','F','',':RET:2106-3','N','021','HLT','1392798','92036OH004001501','2014-02-01','2013-12-31 08:35:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,1,'2014-01-02 04:34:40'),(24465,19436,'Y','18','021','EC','A','','','AC','0000042106','0000042106','OH00002355279','IL','1','Carper','Scott','','','','34','285620375','2032 GRAYBILL RD',0,'UNIONTOWN','OH','44685','8170','CY','39153','1962-03-19','M','M',':RET:2106-3','T','021','HLT','3564266','52664OH151001501','2014-04-01','2014-02-18 16:41:50','302.00',NULL,NULL,'1156.47','854.47','R-OH012','OH0','600.41',NULL,0,'2014-02-18 22:01:35'),(14335,11435,'Y','18','021','EC','A','','','AC','0001005722','0001005722','OH00001474885','IL','1','Hollinger','Rocksand','','','','34','271547843','8875 State Route 49 North',0,'Greenville','OH','45331',NULL,'CY','39037','1952-10-14','F','M',':RET:2106-3','N','021','HLT','1795862','92036OH004000501','2014-02-01','2013-12-26 17:53:31','440.00',NULL,NULL,'537.11','97.11','R-OH003','OH0','537.11',NULL,0,'2013-12-27 02:07:42'),(2624,2134,'Y','18','021','EC','A','','','AC','0000976676','0000976676','OH00000779225','IL','1','BULLOCK','VICTOR','L','','','34','298564282','4424 FIELDS ERTEL RD',0,'CINCINNATI','OH','45241','1268','CY','39017','1961-09-26','M','U',NULL,'N','021','DEN','469066','99734OH005000401','2014-01-01','2013-12-02 08:53:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:56'),(23610,18805,'Y','18','021','EC','A','','','AC','0001033709','0001033709','OH00001590630','IL','1','SHINALL','TODD','','','','34','287622215','529 N WAGNER AVE',0,'SIDNEY','OH','45365','1249','CY','39149','1961-03-15','M','M',':RET:2106-3','T','021','HLT','2693423','92036OH003000506','2014-03-01','2014-02-13 12:54:04','880.00',NULL,NULL,'1166.73','286.73','R-OH003','OH0','557.24',NULL,0,'2014-02-13 22:03:12'),(2329,1895,'Y','18','021','EC','A','','','AC','0001172437','0001172437','TX00000966991','IL','1','Barclay','David','','','','34','455216762','4705 OREGON TRL',0,'AMARILLO','TX','79109','5919','CY','48381','1969-01-17','M','R',NULL,'N','021','DEN','26471','33348TX002000201','2014-01-01','2013-12-09 11:32:55','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 19:31:38'),(17205,13769,'Y','18','021','EC','A','','','AC','0000399906','0000399906','OH00002039676','IL','1','Weisel','Raymond','','','','34','269843030','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1976-09-08','M','M',':RET:2106-3','N','021','HLT','1538851','52664OH151001306','2014-02-01','2014-01-08 00:22:02','443.00',NULL,NULL,'553.95','110.95','R-OH012','OH0','276.08',NULL,0,'2014-01-13 02:22:26'),(22984,18324,'Y','18','021','EC','A','','','AC','0000652173','0000652173','OH00001522239','IL','1','Rodabaugh','Dan','','','','34','568318041','12 S BROADWAY ST',0,'LEBANON','OH','45036','1706','CY','39165','1967-08-18','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','3316241','99734OH005000301','2014-03-01','2014-02-11 22:12:20','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:30:10'),(9350,7411,'Y','18','021','EC','A','','','AC','0001181899','0001181899','LA00001041886','IL','1','Bates','Annie','','','','34','433988573','111 S OAK ST',0,'VIDALIA','LA','71373','4040','CY','22029','1955-09-25','F','M',':RET:2054-5','N','021','DEN','1362458','18575LA002000201','2014-01-01','2013-12-20 23:36:35','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-26 04:31:13'),(21677,17310,'Y','18','021','EC','A','','','AC','0001210424','0001210424','LA00001969282','IL','1','mulkey','mary','','','','34','437888074','19495 SCHMOLKE RD',0,'COVINGTON','LA','70435','7767','CY','22103','1953-07-28','F','U',':RET:2106-3','N','021','DEN','2828175','18575LA002000201','2014-03-01','2014-02-05 16:45:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:31:00'),(678,558,'Y','18','021','EC','A','','','AC','0000683371','0000683371','OH00001195479','IL','1','MALLOY','MARTIN','JAMES','','','34','272689114','2132 40TH ST NW',0,'CANTON','OH','44709','2335','CY','39151','1967-05-12','M','U',':RET:2106-3','T','021','DEN','2146572','99734OH005000301','2014-01-01','2013-12-16 10:48:49','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 18:02:18'),(910,755,'Y','18','021','EC','A','','','AC','0001181011','0001181011','OH00000093876','31','1','cramer','karen','','','','34','272522073','PO BOX 643',0,'Kalida','OH','45853',NULL,'CY','39137','1952-04-21','F','U',':RET:2106-3','N','021','HLT','1698982','92036OH006001501','2014-01-01','2013-12-16 14:13:40','347.00',NULL,NULL,'490.47','143.47','R-OH002','OH0','490.47',NULL,0,'2013-12-25 18:08:31'),(19702,15700,'Y','18','021','EC','A','','','AC','0001122247','0001122247','TX00002540033','IL','1','Pruett','Christopher','Paul','','','34','630301659','2500 Taylor',0,'Wichita Falls','TX','76309',NULL,'CY','48485','1992-01-20','M','U',':RET:1002-5','N','021','DEN','3093028','33348TX002000201','2014-03-01','2014-01-23 15:09:33','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-23 21:00:48'),(20653,16504,'Y','18','021','EC','A','','','AC','0000774473','0000774473','TX00002201285','IL','1','Mitotes','Debra','','','','34','585423830','6161 DONIPHAN DR',0,'EL PASO','TX','79932','1232','CY','48141','1952-09-25','F','M',NULL,'N','021','DEN','2926105','33348TX002000201','2014-03-01','2014-01-30 16:03:23','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-30 21:00:40'),(28263,22364,'Y','18','021','EC','A','','','AC','0000499942','0000499942','MS00002713906','IL','1','WINTERS','BILLY','','','','34','436068994','7921 ATTALA ROAD 2120',0,'MC COOL','MS','39108','8719','CY','28007','1971-11-20','M','M',':RET:2106-3','N','021','DEN','2994372','46300MS002000201','2014-04-01','2014-03-06 21:17:03','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85','CIC',0,'2014-03-07 21:00:18'),(24788,19662,'Y','18','021','EC','A','','','AC','0001165319','0001165319','OH00001564682','IL','1','ANAYA','MAURA','KENNEDY','','','34','251843487','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-22','F','M',':RET:2106-3','T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:46:25'),(533,434,'N','19','021','EC','A',NULL,NULL,'','0000869506','0000010053','','IL','1','Johnson','LaPortia','','','','34','428719531','237 Baker Lane',0,'Brandon','MS','39047',NULL,'CY','28121','1991-08-11','F','',':RET:2054-5','N','021','DEN','400413','46300MS002000201','2014-01-01','2013-12-03 23:35:26',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 17:49:29'),(21598,17249,'N','19','021','EC','A',NULL,NULL,'','0001076598','0000394966','','IL','1','SAMI','ALI','','','','34','291113174','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','2005-12-13','M','',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(2196,1807,'Y','18','021','EC','A','','','AC','0000536896','0000536896','OH00000197428','IL','1','lowe','donald','j','','','34','280543846','305 S RIDGE AVE',0,'TROY','OH','45373','3011','CY','39109','1954-02-10','M','U',':RET:2106-3','N','021','HLT','1234824','92036OH005000505','2014-01-01','2013-12-10 10:39:32','419.00',NULL,NULL,'618.76','199.76','R-OH003','OH0','618.76',NULL,0,'2013-12-25 19:19:53'),(28035,22186,'N','01','021','EC','A',NULL,NULL,'','0000542737','0001094695','','IL','1','Williams','Christy','A','','','34','290682785','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','1972-01-26','F','',':RET:2106-3','N','021','DEN','3613905','99734OH005000401','2014-04-01','2014-03-06 17:25:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:29'),(25420,20170,'Y','18','021','EC','A','','','AC','0000221373','0000221373','OH00003320613','IL','1','BURKAY','BARRY','','','','34','269545689','1165 NAVAJO TRAIL',0,'STREETSBORO','OH','44241',NULL,'CY','39133','1955-01-21','M','M',':RET:2106-3','N','021','DEN','3391734','99734OH005000401','2014-04-01','2014-02-25 15:02:39','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:31:08'),(21261,16990,'Y','18','024','14','A','','','TE','0001149540','0001149540','','IL','1','bennett','yolanda','faye',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-18','F','',NULL,NULL,NULL,'','1612868','','2014-02-03','2014-02-03 11:29:27',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-03 21:01:23'),(21120,16875,'Y','18','021','EC','A','','','AC','0000078372','0000078372','TX00002344486','IL','1','DRENNAN','CELESTE','','','','34','460373429','11019 SUNSHINE CT',0,'EL PASO','TX','79936',NULL,'CY','48141','1973-04-30','F','U',':RET:2106-3','N','021','DEN','3232841','33348TX002000201','2014-03-01','2014-02-03 10:47:21','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-03 21:00:12'),(1825,1496,'N','01','021','EC','A',NULL,NULL,'','0000593684','0000831998','','IL','1','tariq','zahida','','','','34','271066675','1613 RIDGE CROSS RD',0,'PERRYSBURG','OH','43551','9055','CY','39173','1961-03-23','F','',NULL,'N','021','HLT','1708312','92036OH005002605','2014-01-01','2013-12-24 14:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.63',NULL,0,'2013-12-25 18:57:17'),(16714,13377,'Y','18','021','EC','A','','','AC','0000152983','0000152983','TX00001946416','IL','1','Langshaw','Duane','','','','34','458025711','4718 JASON ST',0,'HOUSTON','TX','77096','1703','CY','48201','1953-11-13','M','U',':RET:2106-3','N','021','DEN','2506032','33348TX002000201','2014-02-01','2014-01-07 13:26:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-08 18:24:44'),(25914,20549,'Y','18','021','EC','A','','','AC','0000991201','0000991201','TX00003249825','IL','1','smith','kathleen','','','','34','438907007','1904 MERRIMAC ST',0,'TYLER','TX','75701','3524','CY','48423','1952-02-07','F','U',':RET:2106-3','N','021','DEN','2824470','33348TX002000201','2014-04-01','2014-02-26 14:57:58','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-26 21:01:16'),(5340,4235,'Y','18','021','EC','A','','','AC','0000656925','0000656925','OH00001037904','IL','1','Terrill','Angela','','','','34','279727800','2340 MARENGO ST',0,'TOLEDO','OH','43614','4110','CY','39095','1970-08-15','F','U',':RET:2106-3','N','021','DEN','1445291','99734OH005000301','2014-01-01','2013-12-19 15:10:50','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:07:20'),(3231,2601,'Y','18','021','EC','A','','','AC','0000149312','0000149312','OH00001182759','IL','1','steffen','kathy','','','','34','122522385','23307 LORAIN RD',0,'NORTH OLMSTED','OH','44070','1634','CY','39035','1958-06-10','F','U',NULL,'N','021','DEN','689534','99734OH005000401','2014-01-01','2013-10-06 12:16:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:03'),(3427,2752,'Y','18','021','EC','A','','','AC','0000240348','0000240348','OH00000381433','IL','1','SHIPLETT','STEVEN','','','','34','282689352','3865 MONACA AVE',0,'YOUNGSTOWN','OH','44511','2548','CY','39099','1967-11-09','M','U',':RET:2028-9^:RET:2106-3','N','021','HLT','2523059','92036OH005003206','2014-01-01','2013-12-22 10:32:02','284.00',NULL,NULL,'363.07','79.07','R-OH013','OH0','363.07',NULL,0,'2013-12-25 21:18:48'),(28990,22946,'Y','18','024','14','A','','','TE','0001162588','0001162588','','IL','1','HENDERSON','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-27','M','',NULL,NULL,NULL,'','1803078','','2014-03-31','2014-03-10 15:55:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:01:14'),(16094,12890,'Y','18','024','14','A','','','TE','0000577331','0000577331','','IL','1','MEXICOTT','MICHELLE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-11-07','F','',NULL,NULL,NULL,'','2049803','','2014-01-02','2014-01-02 20:10:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:04:33'),(16049,12852,'Y','18','021','EC','A','','','AC','0000218840','0000218840','OH00001375049','IL','1','Bair','Janelle','','','','34','276762202','1558 ELAINE ST',0,'TROTWOOD','OH','45417','9319','CY','39113','1964-04-09','F','U',':RET:2106-3','N','021','DEN','1985400','99734OH005000401','2014-02-01','2014-01-02 19:50:14','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:03:09'),(25466,20204,'N','01','021','EC','A',NULL,NULL,'','0000293629','0000213540','','IL','1','Ratcliff','Jermaine','Deleon','','','34','460915832','19719 PLANTATION GROVE TRL',0,'KATY','TX','77449','4978','CY','48201','1976-12-31','M','',':RET:2054-5','N','021','DEN','2737116','33348TX002000201','2014-04-01','2014-02-25 15:55:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-25 21:31:34'),(19692,15692,'Y','18','021','EC','A','','','AC','0000863125','0000863125','TX00001620544','IL','1','GARCIA','PABLO','','','','34','645647123','121 GARVIS ST',0,'LUFKIN','TX','75904','4743','CY','48005','1963-06-30','M','U',NULL,'N','021','DEN','2175315','33348TX002000201','2014-03-01','2014-01-23 16:50:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:43'),(17824,14239,'Y','18','021','EC','A','','','AC','0000610795','0000610795','MS00002182050','IL','1','baral','srijana','','','','34','755014584','129 WARRIOR LN',0,'CLINTON','MS','39056','3134','CY','28049','1983-06-21','F','M',':RET:2028-9','N','021','DEN','2223439','46300MS002000201','2014-02-01','2014-01-14 11:29:49','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:57'),(3736,2987,'Y','18','021','EC','A','','','AC','0000033209','0000033209','TX00000225482','IL','1','Neighbors','Nancy','','','','34','451234201','5425 LAKE VIEW DR',0,'GRANBURY','TX','76048','3256','CY','48221','1961-05-23','F','M',':RET:2106-3','N','021','DEN','792601','33348TX002000201','2014-01-01','2013-12-13 11:27:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:45'),(28137,22266,'Y','18','021','EC','A','','','AC','0000957950','0000957950','OH00003371329','IL','1','Rosen','Amanda','','','','34','299860017','1072 Eagle Dr',0,'Green','OH','44312',NULL,'CY','39153','1981-06-17','F','U',':RET:2106-3','N','021','HLT','4122255','52664OH151001304','2014-04-01','2014-03-06 17:50:59','95.00',NULL,NULL,'263.82','168.82','R-OH012','OH0','263.82',NULL,0,'2014-03-06 21:02:28'),(25923,20558,'Y','18','021','EC','A','','','AC','0000124434','0000124434','TX00002784117','IL','1','BROWN','SHIRLEY','','','','34','458596370','244 PRIVATE RD 4362',0,'LAMPASAS','TX','76550',NULL,'CY','48281','1970-08-04','F','U',NULL,'N','021','DEN','3782853','33348TX002000201','2014-04-01','2014-02-26 15:51:24','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-26 21:01:22'),(6564,5203,'Y','18','021','EC','A','','','AC','0000876640','0000876640','TX00000902075','IL','1','Olguin','Nancy','','','','34','627785436','6705 Sumners Dr W',0,'Fort Worth','TX','76137',NULL,'CY','48439','1992-01-22','F','U',NULL,'N','021','DEN','119283','33348TX002000201','2014-01-01','2013-12-11 13:35:21','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:52:29'),(4030,3218,'Y','18','021','EC','A','','','AC','0000453903','0000453903','OH00000336935','IL','1','Benham','Marian','','','','34','301923387','6755 S PITCHIN RD',0,'SPRINGFIELD','OH','45502','9372','CY','39023','1991-02-20','F','U',':RET:2106-3','N','021','DEN','1491905','99734OH005000401','2014-01-01','2013-12-17 09:34:28','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:45:52'),(5521,4379,'Y','18','021','EC','A','','','AC','0001153585','0001153585','OH00000647201','IL','1','daye','gary','','','','34','284668607','5094 ZIMMER DR',0,'COLUMBUS','OH','43232','6048','CY','39049','1960-03-07','M','U',':RET:2106-3','N','021','DEN','1066166','99734OH005000401','2014-01-01','2013-11-26 18:29:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:20'),(6272,4973,'Y','18','021','EC','A','','','AC','0000877097','0000877097','OH00000298693','IL','1','Florgie Winkler','Cathy','L','','','34','272665054','132 N 4TH ST',0,'RITTMAN','OH','44270','1336','CY','39169','1962-11-22','F','M',':RET:2106-3','N','021','DEN','1190631','99734OH005000401','2014-01-01','2013-12-10 18:44:17','0.00',NULL,NULL,'31.57','31.57','R-OH014','OH0','0.00',NULL,0,'2013-12-26 00:45:08'),(17157,13728,'Y','18','021','EC','A','','','AC','0001953610','0001953610','LA00001452422','IL','1','Adams','Henry','','','III',NULL,NULL,'105 WATERFORD DR',0,'LAFAYETTE','LA','70503','5406','CY','22055','1969-03-19','M','M',':RET:2106-3','N','021','DEN','2364104','18575LA002000201','2014-02-01','2014-01-08 10:52:09','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-01-13 02:21:59'),(20039,15980,'N','01','021','EC','A',NULL,NULL,'','0001074165','0000009861','','IL','1','mize','Randall','','','','34','272583134','2999 CARMODY BLVD',0,'MIDDLETOWN','OH','45042','1757','CY','39017','1954-11-04','M','',':RET:2106-3','T','021','HLT','1580459','92036OH004001201','2014-03-01','2014-01-25 22:49:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','516.72',NULL,0,'2014-01-26 19:00:25'),(25252,20032,'Y','18','021','EC','A','','','AC','0001054889','0001054889','MS00002730442','IL','1','SMITH','BARBARA','','','','34','425213174','3340 HARLEY ST',0,'JACKSON','MS','39209','7260','CY','28049','1960-11-16','F','U',':RET:2054-5','N','021','DEN','3744403','46300MS002000101','2014-04-01','2014-02-21 16:32:10','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-21 22:01:14'),(19779,15768,'Y','18','021','EC','A','','','AC','0000251651','0000251651','OH00002302602','IL','1','Kaemming','Lindy','','','','34','281821039','2132 RAGAN WOODS DR',0,'TOLEDO','OH','43614','1009','CY','39095','1983-11-30','F','M',':RET:2106-3','N','021','HLT','2169927','92036OH005002606','2014-03-01','2014-01-22 23:29:48','300.00',NULL,NULL,'454.91','154.91','R-OH001','OH0','221.32',NULL,0,'2014-01-23 21:01:32'),(14680,11720,'Y','18','021','EC','A','','','AC','0001131919','0001131919','MS00001568770','IL','1','clark','alfred','','','','34','427370728','1436 babs dr',0,'west point','MS','39773',NULL,'CY','28025','1980-05-18','M','U',':RET:2054-5','N','021','DEN','2232216','46300MS002000201','2014-02-01','2013-12-27 19:24:28','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,1,'2013-12-29 11:08:32'),(18755,14944,'Y','18','024','14','A','','','TE','0000689561','0000689561','','IL','1','Mirelez','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-05-22','M','',NULL,NULL,NULL,'','1727826','','2014-01-15','2014-01-15 18:35:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:45'),(7139,5664,'N','19','021','EC','A',NULL,NULL,'','0000083660','0000862994','','IL','1','Cage','Danielle','','','','34','629465154','10907 RADFORD LN',0,'HOUSTON','TX','77099','4724','CY','48201','1992-06-25','F','',':RET:2054-5','N','021','DEN','1586864','33348TX002000101','2014-01-01','2013-12-24 19:50:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 01:51:50'),(15460,12371,'N','01','021','EC','A',NULL,NULL,'','0000433134','0000183370','','IL','1','MONTERROZA','AYDEE','','','','34','606105019','15902 N BEND CT',0,'HOUSTON','TX','77073','5450','CY','48201','1956-07-09','F','',':RET:2106-3','N','021','DEN','2023730','33348TX002000201','2014-02-01','2013-12-31 18:07:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,1,'2014-01-02 04:28:38'),(25203,19993,'Y','18','021','EC','A','','','AC','0002198962','0002198962','LA00002572970','IL','1','OAKLEY','FRANCESCA','','','','34','433276596','623 SADIE AVE',0,'METAIRIE','LA','70003','4847','CY','22051','1960-12-26','M','M',NULL,'T','021','DEN','2792610','18575LA002000201','2014-04-01','2014-02-21 17:00:53','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-21 22:00:47'),(17989,14376,'Y','18','021','EC','A','','','AC','0000930926','0000930926','OH00001588792','IL','1','bardes','eric','','','','34','312706724','1055 EASTLAND AVE',0,'AKRON','OH','44305','1374','CY','39153','1957-07-01','M','M',':RET:2106-3','N','021','HLT','2712486','52664OH151001301','2014-02-01','2014-01-14 17:15:43','0.00',NULL,NULL,'520.28','520.28','R-OH012','OH0','520.28',NULL,0,'2014-01-15 02:06:56'),(13919,11101,'Y','18','021','EC','A','','','AC','0000829276','0000829276','OH00000890129','IL','1','Baker','Danielle','','','','34','191728579','216 S. Damascus St.',0,'Liberty Center','OH','43532',NULL,'CY','39069','1991-03-13','F','M',':RET:2106-3','N','021','HLT','2229453','92036OH003002605','2014-01-01','2013-12-22 22:12:54','134.00',NULL,NULL,'408.08','274.08','R-OH001','OH0','203.63',NULL,0,'2013-12-26 13:14:10'),(3969,3171,'Y','18','021','EC','A','','','AC','0001055297','0001055297','OH00000161538','IL','1','Dustin','Robert','','','','34','296620196','3070 Park Rd',0,'Goshen','OH','45122',NULL,'CY','39025','1959-10-12','M','M',NULL,'N','021','HLT','39950','92036OH004000601','2014-01-01','2013-12-13 11:19:31','695.00',NULL,NULL,'737.06','42.06','R-OH005','OH0','368.53',NULL,0,'2013-12-25 21:38:32'),(27219,21552,'Y','18','021','EC','A','','','AC','0000131015','0000131015','MS00002795256','IL','1','KIMBROUGH','NADIA','','','','34','428511652','6300 OLD CANTON RD BUILDING 9',0,'JACKSON','MS','39211',NULL,'CY','28049','1985-01-17','F','U',':RET:2054-5','N','021','DEN','2690222','46300MS002000201','2014-04-01','2014-03-03 12:01:41','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:33'),(28198,22314,'Y','18','021','EC','A','','','AC','0000765063','0000765063','TX00002665905','IL','1','Montejano','Suzan','','','','34','562518130','305 W AVENUE K',0,'MULESHOE','TX','79347','4527','CY','48017','1970-03-23','F','M',NULL,'N','021','DEN','3453776','33348TX002000201','2014-04-01','2014-03-06 12:36:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-06 21:30:07'),(26335,20894,'Y','18','021','EC','A','','','AC','0000702833','0000702833','OH00003073080','31','1','Brockman','Michael','','','','34','301469273','101 n. wayne st. box 548',0,'fort recovery','OH','45846',NULL,'CY','39107','1952-05-19','M','U',':RET:2106-3','N','021','HLT','3589871','92036OH003001504','2014-04-01','2014-02-27 12:03:14','485.00',NULL,NULL,'645.86','160.86','R-OH002','OH0','645.86',NULL,0,'2014-02-28 06:31:42'),(13222,10548,'N','01','021','EC','A',NULL,NULL,'','0000856983','0000210426','','IL','1','Kang','Boo','Young','','','34','634427916','2402 LITTLER CT',0,'LAREDO','TX','78045','8150','CY','48479','1959-02-12','F','',':RET:2040-4','N','021','DEN','1820010','33348TX002000201','2014-01-01','2013-12-22 19:22:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:55:30'),(26208,20786,'Y','18','021','EC','A','','','AC','0000972801','0000972801','OH00002739352','IL','1','Terry','Autumn','','','','34','494763464','1886 COVENTRY DR',0,'BRUNSWICK','OH','44212','4178','CY','39103','1974-10-31','F','M',':RET:2106-3','N','021','HLT','3606227','52664OH151001305','2014-03-01','2014-02-27 11:49:31','294.00',NULL,NULL,'571.80','277.80','R-OH012','OH0','281.44',NULL,0,'2014-02-28 06:30:52'),(9254,7338,'Y','18','021','EC','A','','','AC','0000741174','0000741174','TX00000485480','IL','1','Ryan','Alicia','P','','','34','415848730','143 LOWES CREEK PARK',0,'HEMPHILL','TX','75948','4801','CY','48403','1950-05-22','F','M',':RET:2106-3','N','021','DEN','1042113','33348TX002000201','2014-01-01','2013-11-30 12:18:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:15:05'),(3698,2960,'Y','18','021','EC','A','','','AC','0001230366','0001230366','OH00000395385','31','1','BERNHART','DELORES','','','','34','285567440','Po Box 261',0,'Millersburg','OH','44654',NULL,'CY','39075','1957-06-16','F','U',':RET:2106-3','N','021','DEN','247130','99734OH005000401','2014-01-01','2013-12-13 11:38:59','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2013-12-25 21:31:55'),(1768,1459,'Y','18','024','14','A','','','TE','0000987405','0000987405','','IL','1','Stampley','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-09-30','F','',NULL,NULL,NULL,'','2232085','','2013-12-24','2013-12-24 14:17:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:56:04'),(7255,5754,'N','19','021','EC','A',NULL,NULL,'','0000038362','0000142811','','S1','1','McDowell','Chad','','','','34','494173889','127 Moores Road',0,'Seaman','OH','45679',NULL,'CY','39001','2000-10-19','F','',':RET:2106-3','N','021','HLT','996722','92036OH002000601','2014-01-01','2013-12-13 23:27:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 02:02:02'),(7143,5667,'Y','18','021','EC','A','','','AC','0001234196','0001234196','TX00001573686','IL','1','sullivan','anne','','','','34','219723111','605 Rainbow Creek Court',0,'Arlington','TX','76012',NULL,'CY','48439','1957-06-19','F','U',':RET:2106-3','N','021','DEN','2555607','33348TX002000101','2014-01-01','2013-12-24 22:50:42','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 01:51:57'),(28899,22874,'Y','18','021','EC','A','','','AC','0001190551','0001190551','TX00002749295','IL','1','Boyd','George','','','','34','456904050','5192 FM Road 3129 South',0,'Bloomburg','TX','75556',NULL,'CY','48067','1955-07-12','M','U',NULL,'T','021','DEN','3775622','33348TX002000201','2014-04-01','2014-03-10 16:28:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:20'),(8,7,'Y','18','021','EC','A','','','AC','0000642047','0000642047','OH00000898256','IL','1','Abrams','Brian','','','','34','298843959','37813 EUCLID AVE',0,'WILLOUGHBY','OH','44094','5900','CY','39085','1986-09-06','M','U',':RET:2106-3','N','021','DEN','47248','99734OH005000401','2014-01-01','2013-12-04 21:53:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:15:13'),(16543,13234,'Y','18','021','EC','A','','','AC','0000124218','0000124218','OH00002150887','IL','1','pierson','david','','','','34','464732716','829 mark pl',0,'columbus','OH','43204',NULL,'CY','39049','1980-03-01','M','U',':RET:2106-3','N','021','DEN','1879595','99734OH005000401','2014-02-01','2014-01-05 13:55:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-07 10:22:26'),(15941,12762,'Y','18','021','EC','A','','','AC','0000685858','0000685858','OH00001796234','IL','1','priest','anna','','','','34','285501332','12977 US RT 50',0,'Bainbridge','OH','45612',NULL,'CY','39071','1950-01-24','F','M',':RET:2106-3','N','021','HLT','2239684','92036OH005000606','2014-02-01','2014-01-02 13:58:02','597.00',NULL,NULL,'644.00','47.00','R-OH005','OH0','644.00',NULL,0,'2014-01-03 02:07:11'),(5019,3978,'Y','18','021','EC','A','','','AC','0000515257','0000515257','LA00001171819','31','1','Rayford','Gary','','','','34','436864641','P O BOX  5612',0,'Shreveport','LA','71135',NULL,'CY','22017','1956-01-08','M','U',':RET:2106-3','N','021','DEN','488031','18575LA002000101','2014-01-01','2013-12-07 10:24:54','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 22:47:29'),(3216,2587,'Y','18','021','EC','A','','','AC','0000738984','0000738984','OH00000713192','IL','1','Dennison','David','','','','34','282729217','4240 Americana Dr.',0,'Cuyahoga Falls','OH','44224',NULL,'CY','39153','1965-04-02','M','U',':RET:2106-3','N','021','HLT','604341','52664OH151001305','2014-01-01','2013-10-31 20:27:24','228.00',NULL,NULL,'364.62','136.62','R-OH012','OH0','364.62',NULL,0,'2013-12-25 20:45:34'),(13532,10788,'Y','18','021','EC','A','','','AC','0002196372','0002196372','LA00000437633','IL','1','Steiner','Laura','Elizabeth','','','34','427552098','300 RAINTREE TRL',0,'LAFAYETTE','LA','70507','3716','CY','22055','1986-08-22','F','U',':RET:2106-3','N','021','DEN','2124868','18575LA002000201','2014-01-01','2013-12-23 11:44:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 13:03:29'),(7396,5854,'Y','18','021','EC','A','','','AC','0000653161','0000653161','OH00001121880','IL','1','Hoffman','Donald','','','','34','294540011','221 BEERSHEBA RD SE',0,'GNADENHUTTEN','OH','44629','9773','CY','39157','1953-07-18','M','M',':RET:2106-3','N','021','DEN','379539','99734OH005000301','2014-01-01','2013-11-23 08:09:03','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2013-12-26 02:16:17'),(6473,5128,'N','01','021','EC','A',NULL,NULL,'','0000317320','0000700356','','IL','1','Sayavich','Randall','J','','Sr','34','298489984','1729 Mallard Road',0,'Andover','OH','44003',NULL,'CY','39007','1950-07-21','M','',NULL,'N','021','HLT','484313','52664OH151001306','2014-01-01','2013-12-10 20:50:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','742.48',NULL,0,'2013-12-26 00:50:10'),(29160,23081,'N','19','021','EC','A',NULL,NULL,'','0000959165','0001257393','','IL','1','MITCHELL','DALLAS','','','','34','283133721','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','2007-06-20','M','',NULL,'N','021','HLT','4234698','92036OH006000501','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.71',NULL,0,'2014-03-10 21:02:53'),(24423,19401,'Y','18','021','EC','A','','','AC','0000232688','0000232688','OH00002810076','31','1','Montgomery','Brittany','','','','34','287928770','3760 Olmsby Dr',0,'Kent','OH','44240',NULL,'CY','39099','1990-11-30','F','U',':RET:2054-5','N','021','DEN','3182296','99734OH005000301','2014-04-01','2014-02-18 17:57:33','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-18 22:01:09'),(7534,5963,'N','01','021','EC','A',NULL,NULL,'','0000295924','0000383864','','IL','1','Islam','Sharmin','','','','34','613897125','13355 US HWY 183 N',0,'Austin','TX','78750',NULL,'CY','48491','1974-03-01','F','',':RET:2028-9','N','021','DEN','1162495','33348TX002000201','2014-01-01','2013-12-15 11:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:32:46'),(23956,19049,'Y','18','021','EC','A','','','AC','0000742972','0000742972','TX00001435584','IL','1','Gomez','Sylvia','','','','34','451432215','1435 SE 4 th st',0,'Grand Prairie','TX','75051',NULL,'CY','48113','1964-01-02','F','U',':RET:2106-3','N','021','DEN','3220054','33348TX002000101','2014-03-01','2014-02-14 18:14:45','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-15 22:00:07'),(23042,18370,'Y','18','021','EC','A','','','AC','0000490513','0000490513','TX00001441211','IL','1','Sadler','James','','','','34','465177172','1604 GLENWICK DR',0,'PLANO','TX','75075','4201','CY','48085','1957-02-01','M','M',':RET:2106-3','N','021','DEN','2710583','33348TX002000201','2014-03-01','2014-02-12 10:17:29','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:40'),(17018,13620,'Y','18','021','EC','A','','','AC','0000071658','0000071658','OH00000590787','IL','1','LEIGHTON','MICHELLE','','','','34','282137117','3740 WYNDHAM RIDGE DR',0,'STOW','OH','44224','6152','CY','39153','1981-10-19','F','M',':RET:2106-3','N','021','HLT','2109833','52664OH152000901','2014-02-01','2014-01-08 19:30:34','344.00',NULL,NULL,'500.47','156.47','R-OH012','OH0','193.23',NULL,0,'2014-01-13 02:20:39'),(19963,15925,'Y','18','021','EC','A','','','AC','0000598783','0000598783','OH00002261557','IL','1','Fisher','Cindy','M','','','34','272560252','1315 Tampa Ave',0,'Akron','OH','44314',NULL,'CY','39153','1953-09-22','F','M',':RET:2106-3','N','021','HLT','2492756','52664OH151001304','2014-03-01','2014-01-24 21:08:23','345.00',NULL,NULL,'605.24','260.24','R-OH012','OH0','605.24',NULL,0,'2014-01-25 19:00:08'),(24391,19373,'Y','18','021','EC','A','','','AC','0000707664','0000707664','OH00002934669','IL','1','Stahlman','Jamie','','','','34','277863134','3442 Claretta Rd',0,'Columbus','OH','43232',NULL,'CY','39049','1985-12-24','F','U',':RET:2106-3','N','021','DEN','3079857','99734OH005000401','2014-04-01','2014-02-18 12:58:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-18 22:00:49'),(3949,3160,'Y','18','021','EC','A','','','AC','0000151961','0000151961','OH00000500949','IL','1','GOODMAN','GREGORY','JOSEPH','','','34','279680232','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1965-08-29','M','M',':RET:2106-3','N','021','HLT','48028','92036OH006002701','2014-01-01','2013-12-13 10:43:19','578.74',NULL,NULL,'583.00','4.26','R-OH006','OH0','252.84',NULL,0,'2013-12-25 21:38:07'),(2989,2405,'Y','18','021','EC','A','','','AC','0000433867','0000433867','OH00000412755','IL','1','Jereb','Richard',NULL,NULL,NULL,NULL,NULL,'3612 VEZBER DR',0,'SEVEN HILLS','OH','44131','6226','CY','39035','1950-09-01','M','U',':RET:2106-3','N','021','DEN','1227509','99734OH005000301','2014-01-01','2013-12-06 14:19:35','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:17:23'),(23047,18374,'Y','18','021','EC','A','','','AC','0000669805','0000669805','TX00001877010','IL','1','Catoe','Phyllis','','','','34','467865770','1911 W PFLUGERVILLE PKWY',0,'ROUND ROCK','TX','78664','8641','CY','48453','1950-06-05','F','U',':RET:2106-3','N','021','DEN','3215594','33348TX002000201','2014-03-01','2014-02-12 14:17:01','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-12 21:30:43'),(17334,13865,'Y','18','021','EC','A','','','AC','0002354583','0002354583','LA00002068112','IL','1','Muhammad','Mariam','','','','34','766687559','7115 HIGHWAY 110 E',0,'LONGVILLE','LA','70652','4604','CY','22011','1968-02-25','F','M',NULL,'N','021','DEN','2262988','18575LA002000201','2014-02-01','2014-01-10 13:16:07','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-13 02:23:58'),(1922,1567,'N','01','021','EC','A',NULL,NULL,'','0001214756','0000598717','','IL','1','porter','paula','m','','','34','285823259','177 CRESTLINE AVE',0,'MANSFIELD','OH','44903','4118','CY','39139','1984-09-01','F','',':RET:2106-3','N','021','DEN','945090','99734OH005000301','2014-01-01','2013-11-20 13:52:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:00:11'),(7442,5890,'Y','18','021','EC','A','','','AC','0000203061','0000203061','OH00000670934','IL','1','Hurlow','Melinda','','','','34','269567163','1445 JERSEY RIDGE RD',0,'ZANESVILLE','OH','43701','7333','CY','39119','1953-10-26','F','U',':RET:2106-3','N','021','DEN','1025837','99734OH005000301','2014-01-01','2013-12-14 19:44:49','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 02:30:27'),(15357,12283,'N','19','021','EC','A',NULL,NULL,'','0000377471','0000342747','','IL','1','Toalston','Tatiana','C','','','34','310219781','5069 Apollo Rd NE',0,'Salineville','OH','43945',NULL,'CY','39019','1999-05-15','F','',':RET:2106-3','N','021','DEN','1934105','99734OH005000301','2014-02-01','2013-12-31 23:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:24:41'),(3212,2584,'Y','18','021','EC','A','','','AC','0001172395','0001172395','TX00001204793','IL','1','aberman','maria','','','','34','336540307','7712 YVETTE CIR',0,'MERCEDES','TX','78570','5642','CY','48215','1970-12-22','F','U',':RET:2106-3','N','021','DEN','377028','33348TX002000201','2014-01-01','2013-11-01 15:24:48','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 20:45:27'),(27016,21399,'Y','18','024','14','A','','','TE','0002253953','0002253953','','IL','1','Bradford','anna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-04-26','F','',NULL,NULL,NULL,'','3565235','','2014-03-31','2014-03-03 11:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-03 21:00:10'),(29028,22975,'N','19','021','EC','A',NULL,NULL,'','0000148405','0000009905','','IL','1','Rivera','Khloe','G','','','34','272152428','2549 S HARBOR DR',0,'MAINEVILLE','OH','45039','9318','CY','39165','2008-11-15','F','',':RET:2106-3','N','021','DEN','3894223','99734OH005000401','2014-04-01','2014-03-10 11:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:34'),(25849,20492,'Y','18','021','EC','A','','','AC','0000050742','0000050742','OH00003235618','IL','1','Koning','Kiana','','','','34','193623266','19 CARRIAGE SQ',0,'AURORA','OH','44202','9314','CY','39133','1982-09-05','F','M',':RET:2106-3','N','021','HLT','3627460','52664OH152000901','2014-04-01','2014-02-26 17:32:18','217.00',NULL,NULL,'382.54','165.54','R-OH012','OH0','189.31',NULL,0,'2014-02-26 21:00:39'),(16561,13250,'Y','18','021','EC','A','','','AC','0000001052','0000001052','OH00001730140','IL','1','UHRICK','CRISTINA','MARIE','','','34','278646373','214 GLENN ST',0,'MENDON','OH','45862','9586','CY','39107','1957-08-07','F','M',':RET:2106-3','N','021','HLT','1648865','92036OH001001501','2014-02-01','2014-01-05 15:39:36','1014.00',NULL,NULL,'1496.45','482.45','R-OH002','OH0','619.34',NULL,1,'2014-01-07 10:23:03'),(21739,17358,'N','01','021','EC','A',NULL,NULL,'','0000484456','0000935471','','IL','1','Rodriquez','Michael','','','','34','570672274','1504 37th street',0,'Lubbock','TX','79412',NULL,'CY','48303','1981-09-29','M','',':RET:2106-3','N','021','DEN','3622893','33348TX002000201','2014-03-01','2014-02-06 17:37:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:14'),(5344,4238,'Y','18','021','EC','A','','','AC','0000228328','0000228328','OH00000884634','IL','1','THIRY','JUDITH','','','','34','280505258','5819 OAK HILL DR',0,'WEST FARMINGTON','OH','44491','9751','CY','39155','1950-04-30','F','M',NULL,'N','021','DEN','1846123','99734OH005000301','2014-01-01','2013-12-19 17:57:01','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:07:26'),(3076,2471,'Y','18','021','EC','A','','','AC','0000136674','0000136674','LA00000775265','IL','1','Alexander','Lisa','','','','34','434172850','3741 MANSFIELD AVE',0,'NEW ORLEANS','LA','70131','5625','CY','22071','1959-10-31','F','U',':RET:2054-5','N','021','DEN','9022','18575LA002000101','2014-01-01','2013-12-06 15:41:43','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:19:35'),(152,127,'Y','18','021','EC','A','','','AC','0000033183','0000033183','TX00000990658','IL','1','Roubique','Ronald','W','','','34','435906625','2918 ROSEHEATH LN',0,'HOUSTON','TX','77073','3430','CY','48201','1954-01-26','M','U',NULL,'N','021','DEN','188377','33348TX002000101','2014-01-01','2013-12-04 19:07:03','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 17:18:56'),(21566,17227,'N','01','021','EC','A',NULL,NULL,'','0001248370','0000424066','','IL','1','Crabiel','Mark','','','','34','196463749','4980 Maple Heights Drive',0,'Medina','OH','44256',NULL,'CY','39103','1970-12-24','M','',':RET:2106-3','N','021','HLT','3214185','52664OH151001305','2014-03-01','2014-02-04 19:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2014-02-05 21:30:20'),(4546,3603,'Y','18','021','EC','A','','','AC','0000084021','0000084021','OH00000817783','IL','1','Ball','Ed','','','','34','274601003','1023 Lindsay Ave',0,'Akron','OH','44306',NULL,'CY','39153','1955-06-09','M','U',':RET:2106-3','N','021','HLT','858956','52664OH152000901','2014-01-01','2013-12-11 19:13:21','347.00',NULL,NULL,'416.19','69.19','R-OH012','OH0','416.19',NULL,0,'2013-12-25 22:04:27'),(5720,4541,'Y','18','021','EC','A','','','AC','0001566439','0001566439','LA00000338463','IL','1','Guy','Gregory','','','','34','435178028','3429 W PARC GREEN ST',0,'HARVEY','LA','70058','7043','CY','22051','1959-01-04','M','M',':RET:2054-5','N','021','DEN','1724098','18575LA002000201','2014-01-01','2013-12-23 21:32:41','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:23'),(14387,11475,'Y','18','021','EC','A','','','AC','0000267536','0000267536','OH00001762376','IL','1','Mckean','Stephen','','','','34','300743430','5015 SHATTUC AVE',0,'CINCINNATI','OH','45208','4441','CY','39061','1973-10-02','M','U',':RET:2106-3','N','021','DEN','1501173','99734OH005000401','2014-02-01','2013-12-27 14:19:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:54'),(14355,11449,'Y','18','021','EC','A','','','AC','0000568032','0000568032','OH00001294082','IL','1','Andrews','Clark','Daniel','','','34','234761108','6194 Busch Blvd',0,'Columbus','OH','43229','2532','CY','39049','1964-05-22','M','U',':RET:2106-3','N','021','DEN','1760634','99734OH005000401','2014-02-01','2013-12-26 19:03:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:07'),(6762,5365,'Y','18','021','EC','A','','','AC','0000373984','0000373984','LA00000721891','IL','1','Karl','Christine','','','','34','439806069','28 belle vu loop',0,'covington','LA','70433',NULL,'CY','22103','1950-03-15','F','M',':RET:2106-3','N','021','DEN','48923','18575LA002000201','2014-01-01','2013-11-25 13:18:33','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:16:23'),(28533,22582,'Y','18','021','EC','A','','','AC','0000780576','0000780576','OH00003444939','31','1','SCOTT','NANCY','','','','34','292523694','P.O. BOX 102',0,'ADDYSTON','OH','45001',NULL,'CY','39061','1952-08-23','F','U',NULL,'N','021','HLT','3785684','92036OH002001201','2014-04-01','2014-03-07 13:29:15','299.00',NULL,NULL,'696.64','397.64','R-OH004','OH0','696.64',NULL,0,'2014-03-07 21:32:09'),(16895,13520,'Y','18','021','EC','A','','','AC','0000841930','0000841930','OH00001582752','IL','1','Hayes','Linda','','','','34','299568853','136Brooklyn Ave.',0,'Sidney','OH','45365',NULL,'CY','39149','1958-01-25','F','U',':RET:2106-3','T','021','DEN','2560024','99734OH005000401','2014-02-01','2014-01-08 18:40:40','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:19:30'),(13679,10914,'Y','18','021','EC','A','','','AC','0000082564','0000082564','OH00001146080','IL','1','Brumbaugh','Juliann','','','','34','297502427','5058 STONE MEADOW RUN',0,'STOW','OH','44224','1373','CY','39153','1951-09-08','F','U',':RET:2106-3','N','021','HLT','2249102','52664OH151001306','2014-01-01','2013-12-22 20:26:01','537.00',NULL,NULL,'640.70','103.70','R-OH012','OH0','640.70',NULL,0,'2013-12-26 13:08:06'),(9322,7389,'N','01','021','EC','A',NULL,NULL,'','0001888235','0001864929','','IL','1','Placide','Yves','','','','34','595090249','103 BERKLEY DR',0,'NEW ORLEANS','LA','70131','4005','CY','22071','1957-03-09','M','',':RET:2054-5','N','021','DEN','1679721','18575LA002000101','2014-01-01','2013-12-21 13:32:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 04:30:30'),(21371,17081,'Y','18','024','14','A','','','TE','0000926620','0000926620','','IL','1','Ortega','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-13','F','',NULL,NULL,NULL,'','3188342','','2014-02-04','2014-02-04 17:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:00:49'),(27758,21950,'N','01','021','EC','A',NULL,NULL,'','0001173640','0001922581','','IL','1','Prendergast','Daniel','','','','34','458931148','340 Ridgewood Loop',0,'Mandeville','LA','70471',NULL,'CY','22103','1982-12-08','M','',':RET:2106-3','N','021','DEN','3791782','18575LA002000201','2014-04-01','2014-03-05 10:56:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-05 21:31:19'),(21732,17354,'Y','18','021','EC','A','','','AC','0000515769','0000515769','TX00001515581','IL','1','Golleher','Sarah','Christine','','','34','566943627','1801 AVENUE J',0,'ANSON','TX','79501','5237','CY','48253','1954-11-27','F','M',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','2798694','33348TX002000201','2014-03-01','2014-02-06 15:35:40','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-02-06 21:00:10'),(21694,17322,'N','01','021','EC','A',NULL,NULL,'','0000336459','0000602317','','IL','1','leveton','sharon','m','','','34','270584804','3355 ELMONT RD',0,'TOLEDO','OH','43615','1421','CY','39095','1954-06-11','F','',':RET:2106-3','N','021','HLT','3206720','92036OH002002601','2014-03-01','2014-02-04 20:27:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.17',NULL,0,'2014-02-05 21:31:07'),(1207,993,'Y','18','021','EC','A','','','AC','0000373599','0000373599','OH00000899435','IL','1','LEWIS','LINDA','','','','34','302447964','12801 FARRINGDON AVE',0,'CLEVELAND','OH','44105','2929','CY','39035','1950-09-22','F','U',':RET:2054-5','N','021','DEN','1256806','99734OH005000301','2014-01-01','2013-12-03 14:53:04','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:20:01'),(18698,14907,'Y','18','024','14','A','','','TE','0001418489','0001418489','','IL','1','Johnson','Ricka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-14','F','',NULL,NULL,NULL,'','2795715','','2014-01-16','2014-01-16 16:38:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-17 03:35:27'),(17927,14321,'Y','18','021','EC','A','','','AC','0000546579','0000546579','TX00001370569','IL','1','Rodriguez','Megann','','','','34','462738155','3713 FM 47',0,'POINT','TX','75472','6135','CY','48379','1982-11-01','F','U',':RET:2106-3','N','021','DEN','1682878','33348TX002000201','2014-02-01','2014-01-14 11:43:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:33'),(27265,21589,'Y','18','021','EC','A','','','AC','0002351013','0002351013','LA00003601600','31','1','White','Michael','','','','34','434809262','P O Box 84183',0,'Baton Rouge','LA','70884',NULL,'CY','22033','1951-12-24','M','M',':RET:2106-3','N','021','DEN','3304377','18575LA002000101','2014-04-01','2014-03-04 12:04:43','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-04 21:00:12'),(15619,12492,'Y','18','021','EC','A','','','AC','0000188159','0000188159','MS00002067847','IL','1','Erby','Mary','','','','34','587361791','2202 22nd st north',0,'columbus','MS','39701',NULL,'CY','28087','1950-09-28','F','U',NULL,'N','021','DEN','1396905','46300MS002000101','2014-02-01','2013-12-31 10:24:42','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2014-01-02 04:33:04'),(22132,17664,'Y','18','021','EC','A','','','AC','0000250282','0000250282','OH00001711017','IL','1','Bentley','Gary','','','','34','278563586','4080 BEECHWOOD DR',0,'BELLBROOK','OH','45305','1644','CY','39057','1954-03-03','M','M',':RET:2106-3','N','021','DEN','3604625','99734OH005000401','2014-03-01','2014-02-08 11:43:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-08 19:00:44'),(22050,17601,'Y','18','021','EC','A','','','AC','0000816843','0000816843','TX00001777379','31','1','Lopez','Catherina','Ofunre','','','34','637285265','1115 GOLDMARK DR',0,'ARLINGTON','TX','76006','7072','CY','48439','1991-11-26','F','M',':RET:2054-5','N','021','DEN','3588164','33348TX002000201','2014-03-01','2014-02-07 19:30:08','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-08 19:00:04'),(21701,17329,'Y','18','021','EC','A','','','AC','0000417184','0000417184','MS00001640612','31','1','Taylor','Brittany','','','','34','427677943','PO Box 81',0,'Utica','MS','39175',NULL,'CY','28049','1989-11-21','F','U',':RET:2054-5','N','021','DEN','2638859','46300MS002000201','2014-03-01','2014-02-04 22:57:52','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-05 21:31:11'),(18693,14903,'Y','18','024','14','A','','','TE','0002015318','0002015318','','IL','1','Dannel','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-02','F','',NULL,NULL,NULL,'','1437482','','2014-01-16','2014-01-16 09:48:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-17 03:35:25'),(14354,11448,'Y','18','021','EC','A','','','AC','0000262728','0000262728','OH00001654054','IL','1','EAKIN','BARBARA','','','','34','292527843','3968 MARSH CREEK LN',0,'ROOTSTOWN','OH','44272','9280','CY','39133','1952-08-15','F','U',NULL,'N','021','DEN','1702278','99734OH005000401','2014-02-01','2013-12-26 18:48:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-28 03:30:06'),(14014,11164,'Y','18','024','14','A','','','TE','0000433888','0000433888','','IL','1','Verga','Cosette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-08-11','F','',NULL,NULL,NULL,'','2109334','','2013-12-23','2013-12-23 14:57:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:16:27'),(23146,18452,'Y','18','021','EC','A','','','AC','0000759741','0000759741','OH00001994335','IL','1','Gruesen','Michael','Geoffrey',NULL,NULL,NULL,NULL,'2753 Glenhaven Ave',0,'Copley','OH','44321',NULL,'CY','39153','1985-10-05','M','M',':RET:2106-3','N','021','HLT','3069440','52664OH151001305','2014-03-01','2014-02-12 14:17:18','299.00',NULL,NULL,'476.12','177.12','R-OH012','OH0','242.41',NULL,0,'2014-02-12 21:31:39'),(22547,18004,'Y','18','021','EC','A','','','AC','0002177790','0002177790','LA00002183816','IL','1','Huynh','Lisa','','','','34','437979240','301 WILDFLOWER DR',0,'LAFAYETTE','LA','70506','7865','CY','22055','1971-12-26','F','M',':RET:2047-9','N','021','DEN','3810769','18575LA002000101','2014-03-01','2014-02-10 14:53:07','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-10 21:31:42'),(6025,4769,'Y','18','021','EC','A','','','AC','0000686627','0000686627','TX00000090808','IL','1','gonzalez','maribel','','','','34','457434633','1029 n. wright',0,'Alice','TX','78332',NULL,'CY','48249','1969-04-28','F','U',':RET:2106-3','N','021','DEN','141585','33348TX002000201','2014-01-01','2013-12-01 16:29:36','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:00:59'),(2049,1678,'Y','18','021','EC','A','','','AC','0000137797','0000137797','TX00001178483','IL','1','Mercer','Mary','','','','34','461021254','612 Johnson Ave',0,'Wake Village','TX','75501',NULL,'CY','48037','1954-03-20','F','U',':RET:2106-3','N','021','DEN','596593','33348TX002000201','2014-01-01','2013-12-10 17:04:31','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 19:15:47'),(19917,15884,'Y','18','021','EC','A','','','AC','0000321786','0000321786','TX00001353470','IL','1','Wreyford','Christina','K','','','34','639785749','1204 SAN BERNARD ST',0,'AUSTIN','TX','78702','1129','CY','48453','1978-07-09','F','M',':RET:2106-3','N','021','DEN','2680394','33348TX002000101','2014-03-01','2014-01-24 12:19:22','0.00',NULL,NULL,'54.30','54.30','R-TX003','TX0','27.15',NULL,0,'2014-01-24 21:01:02'),(19020,15147,'Y','18','021','EC','A','','','AC','0000590249','0000590249','MS00001699042','IL','1','DEVEREUX','TENA','','','','34','414940712','4884 WILLIAMS RD',0,'HERNANDO','MS','38632','9770','CY','28033','1955-06-01','F','M',':RET:2106-3','N','021','DEN','2902868','46300MS002000101','2014-03-01','2014-01-17 00:50:48','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-20 08:06:25'),(18207,14531,'Y','18','024','14','A','','','TE','0000486963','0000486963','','IL','1','renaud','ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-04-12','F','',NULL,NULL,NULL,'','1523644','','2014-01-14','2014-01-14 14:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:08:08'),(18013,14393,'N','19','021','EC','A',NULL,NULL,'','0001184903','0000160807','','S1','1','Manning','Ted','M','','','34','282135766','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','2007-07-01','M','',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(28492,22544,'N','01','021','EC','A',NULL,NULL,'','0000950985','0000662187','','IL','1','Murriel','Robert','','','','34','426652322','711 Lake Habour DR',0,'Ridgeland','MS','39157',NULL,'CY','28089','1977-12-13','M','',NULL,'N','021','DEN','3629257','46300MS002000201','2014-04-01','2014-03-06 20:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-03-07 21:31:42'),(6442,5108,'N','01','021','EC','A',NULL,NULL,'','0000526813','0000570821','','IL','1','Hyndman','Randee','','','','34','054668866','8236 BOONE AVE',0,'BATON ROUGE','LA','70808','6812','CY','22033','1980-01-27','F','',':RET:2106-3','N','021','DEN','618320','18575LA002000201','2014-01-01','2013-12-11 17:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:49:28'),(20899,16704,'Y','18','024','14','A','','','TE','0000249111','0000249111','','IL','1','Rickett','Annette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-28','F','',NULL,NULL,NULL,'','1723742','','2014-01-31','2014-01-31 13:23:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:20'),(20276,16181,'Y','18','021','EC','A','','','AC','0000923347','0000923347','OH00002109138','IL','1','minotti','karen','','','','34','293645631','601 E WESTERN RESERVE RD',0,'POLAND','OH','44514','4337','CY','39099','1958-07-12','F','U',NULL,'N','021','DEN','2698935','99734OH005000401','2014-03-01','2014-01-28 11:46:01','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-28 21:00:26'),(15363,12288,'Y','18','021','EC','A','','','AC','0000136093','0000136093','OH00001362018','IL','1','Spires','Vivian','','','','34','303765831','1253 BUNCE RD',0,'GALLIPOLIS','OH','45631','8993','CY','39053','1964-07-22','F','U',NULL,'N','021','DEN','2303523','99734OH005000301','2014-02-01','2014-01-01 11:48:50','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,1,'2014-01-02 04:24:50'),(2973,2394,'Y','18','021','EC','A','','','AC','0000678437','0000678437','TX00000391729','IL','1','Perley','Diana','L','','','34','449965647','9000 OTTOBAHN',0,'AMARILLO','TX','79119','3866','CY','48381','1956-05-22','F','R',':RET:2106-3','N','021','DEN','469171','33348TX002000201','2014-01-01','2013-12-06 13:58:45','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 20:17:01'),(14939,11938,'Y','18','021','EC','A','','','AC','0000257134','0000257134','OH00001211132','IL','1','Lewis','Stacy','Lee','','','34','302809189','403 E Walnut Street',0,'West Union','OH','45693',NULL,'CY','39001','1982-06-15','F','U',':RET:2106-3','N','021','HLT','2424339','92036OH003000605','2014-02-01','2013-12-29 12:02:46','185.00',NULL,NULL,'259.83','74.83','R-OH005','OH0','259.83',NULL,0,'2013-12-30 00:02:14'),(13186,10519,'Y','18','021','EC','A','','','AC','0000493119','0000493119','TX00001113810','IL','1','Perkins','Robin','Ivy','','','34','458417908','2012 COLQUITT ST',0,'HOUSTON','TX','77098','3406','CY','48201','1961-08-21','F','U',':RET:2106-3','N','021','DEN','1666046','33348TX002000101','2014-01-01','2013-12-22 23:03:03','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:27'),(5824,4625,'Y','18','021','EC','A','','','AC','0000140575','0000140575','TX00000104981','IL','1','McCoy','Edward','','','','34','452953540','1504 BROWNSTONE',0,'DESOTO','TX','75115','7838','CY','48113','1985-08-16','M','U',':RET:2054-5','N','021','DEN','2556913','33348TX002000201','2014-01-01','2013-12-23 22:26:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:05'),(18519,14767,'Y','18','021','EC','A','','','AC','0001173708','0001173708','TX00001574230','IL','1','VASILE','MARIAN','','','','34','511191300','15935 Bent Tree Forest Circle',0,'DALLAS','TX','75248',NULL,'CY','48113','1969-05-31','M','M',':RET:2106-3','N','021','DEN','2812729','33348TX002000101','2014-02-01','2014-01-14 23:18:52','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-01-16 08:46:37'),(9302,7375,'Y','18','021','EC','A','','','AC','0000328372','0000328372','OH00000909149','IL','1','Numbers','Virginia','','','','34','273508063','229 E MAIN ST',0,'CRIDERSVILLE','OH','45806','2403','CY','39011','1949-09-24','F','M',':RET:2106-3','N','021','HLT','1057001','92036OH006001501','2014-01-01','2013-11-30 18:00:28','450.00',NULL,NULL,'523.61','73.61','R-OH002','OH0','523.61',NULL,0,'2013-12-26 04:16:26'),(19865,15845,'N','01','021','EC','A',NULL,NULL,'','0000111921','0001001186','','IL','1','Bodeker','Diane','G','','','34','282669743','1327 Catherine Dr',0,'Brunswick','OH','44212',NULL,'CY','39103','1960-06-19','F','',':RET:2106-3','N','021','DEN','1748053','99734OH005000401','2014-03-01','2014-01-24 08:18:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-24 21:00:38'),(5560,4414,'Y','18','021','EC','A','','','AC','0000461895','0000461895','OH00000366448','IL','1','Delmoro','Donna','','','','34','279502859','344 Southeast Ave',0,'Tallmadge','OH','44278',NULL,'CY','39153','1949-09-18','F','M',':RET:2106-3','N','021','HLT','1135258','52664OH152000901','2014-01-01','2013-11-27 17:13:10','198.00',NULL,NULL,'490.00','292.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 23:16:25'),(4753,3768,'Y','18','021','EC','A','','','AC','0000731441','0000731441','TX00000940918','IL','1','LANDRENEAU','LAWRENCE','','','','34','433923479','213 CR 462',0,'CARTHAGE','TX','75633',NULL,'CY','48365','1953-01-15','M','M',':RET:2106-3','T','021','DEN','182059','33348TX002000201','2014-01-01','2013-12-08 14:41:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:15:17'),(19517,15557,'Y','18','021','EC','A','','','AC','0000547912','0000547912','OH00001645367','IL','1','Washington','Alonzo','','','','34','287682085','1745 W 25TH ST',0,'CLEVELAND','OH','44113','3157','CY','39035','1965-09-04','M','U',':RET:2054-5','N','021','DEN','1878554','99734OH005000401','2014-03-01','2014-01-21 22:24:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:02:17'),(29159,23081,'N','19','021','EC','A',NULL,NULL,'','0000959165','0001217428','','IL','1','MITCHELL','GRIFFIN','','','','34','278154772','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','2009-04-13','M','',NULL,'N','021','HLT','4234698','92036OH006000501','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.71',NULL,0,'2014-03-10 21:02:53'),(13858,11058,'Y','18','021','EC','A','','','AC','0000436592','0000436592','OH00000403205','IL','1','Marrone','Lindsay','','','','34','288760213','383 GREENWOOD AVE',0,'AKRON','OH','44320','1246','CY','39153','1980-08-18','F','U',':RET:2106-3','N','021','HLT','1546166','52664OH151001501','2014-01-01','2013-12-22 20:32:48','45.00',NULL,NULL,'320.42','275.42','R-OH012','OH0','320.42',NULL,0,'2013-12-26 13:12:44'),(6633,5261,'Y','18','021','EC','A','','','AC','0000353931','0000353931','OH00000069696','IL','1','Fravel','Traci','','','','34','275829489','294 E GRANVILLE ST',0,'SUNBURY','OH','43074','9488','CY','39041','1984-01-01','F','U',NULL,'N','021','DEN','282958','99734OH005000401','2014-01-01','2013-11-12 07:57:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:00:04'),(24368,19354,'Y','18','021','EC','A','','','AC','0002229294','0002229294','LA00002602208','IL','1','Davis','Kevin','Junious','','','34','437498200','1950',0,'Baton Rouge','LA','70807',NULL,'CY','22033','1966-10-24','M','U',':RET:2054-5','N','021','DEN','3848497','18575LA002000201','2014-04-01','2014-02-18 13:59:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-18 22:00:36'),(22424,17905,'Y','18','021','EC','A','','','AC','0002118650','0002118650','LA00002107982','IL','1','Mendez','Aura','','','','34','660144346','3443 Edenborn Ave 134',0,'Metairie','LA','70002',NULL,'CY','22051','1965-10-15','F','U',':RET:2106-3','N','021','DEN','3810777','18575LA002000201','2014-03-01','2014-02-10 17:18:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:32'),(4940,3920,'Y','18','024','14','A','','','TE','0000186080','0000186080','','IL','1','YANOVICH','PAUL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-11','M','',NULL,NULL,NULL,'','817973','','2013-12-07','2013-12-07 16:09:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:45:39'),(13541,10797,'Y','18','021','EC','A','','','AC','0002231653','0002231653','LA00000185266','IL','1','COBB','CHARLIE','D','','','34','437810380','423 MCARTHUR LOOP',0,'COTTON VALLEY','LA','71018','2816','CY','22119','1991-04-11','F','U',':RET:2106-3','N','021','DEN','1594710','18575LA002000201','2014-01-01','2013-12-23 13:43:26','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:03:47'),(13101,10445,'N','01','021','EC','A',NULL,NULL,'','0000103887','0000837696','','IL','1','louis','frank','','','','34','163443973','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-05-23','M','',':RET:2106-3','T','021','DEN','2616117','99734OH005000401','2014-01-01','2013-12-23 13:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:52:10'),(15401,12319,'Y','18','024','14','A','','','TE','0000864113','0000864113','','IL','1','WILSON','TAMARA','N',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-01-31','F','',NULL,NULL,NULL,'','2170698','','2013-12-30','2013-12-30 19:29:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:26:48'),(4356,3458,'Y','18','021','EC','A','','','AC','0000896951','0000896951','OH00000814117','IL','1','Biggert','Robin',NULL,NULL,NULL,NULL,NULL,'23675 State Route 51 West',0,'Genoa','OH','43430',NULL,'CY','39123','1961-09-26','F','R',':RET:2106-3','N','021','HLT','1835997','92036OH005002701','2014-01-01','2013-12-17 13:29:14','0.00',NULL,NULL,'380.63','380.63','R-OH006','OH0','380.63',NULL,0,'2013-12-25 21:53:36'),(4041,3225,'Y','18','021','EC','A','','','AC','0000089809','0000089809','OH00000802615','IL','1','TAYLOR','DORIS','','','','34','281547441','724 BARLOW RD',0,'HUDSON','OH','44236','3703','CY','39153','1951-02-04','F','M',':RET:2106-3','N','021','DEN','1685491','99734OH005000401','2014-01-01','2013-12-17 11:19:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:46:05'),(23550,18761,'Y','18','021','EC','A','','','AC','0001283699','0001283699','LA00001618459','IL','1','lafleur','dustin','','','','34','437556187','1035 CATALPA LN',0,'WASHINGTON','LA','70589','5533','CY','22039','1984-11-08','M','U',':RET:2106-3','N','021','DEN','2974264','18575LA002000201','2014-03-01','2014-02-13 15:50:31','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-13 22:02:38'),(9196,7293,'Y','18','024','14','A','','','TE','0000067661','0000067661','','IL','1','Stangelo','Megan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-07-29','F','',NULL,NULL,NULL,'','2295718','','2013-12-18','2013-12-18 12:56:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:30'),(7610,6022,'Y','18','021','EC','A','','','AC','0000327237','0000327237','OH00000375470','IL','1','Tetzel','Marie','Elizabeth','','','34','270760878','2720 Maitland Ave.',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1964-03-25','F','U',':RET:2106-3','T','021','HLT','975758','52664OH152000901','2014-01-01','2013-11-17 11:42:46','45.00',NULL,NULL,'320.46','275.46','R-OH012','OH0','320.46',NULL,0,'2013-12-26 02:45:37'),(26573,21069,'Y','18','021','EC','A','','','AC','0000563199','0000563199','OH00003230874','IL','1','holloway','kevin','','','','34','271829705','4660 BELFAST DR',0,'COLUMBUS','OH','43227','2527','CY','39049','1969-02-02','M','U',':RET:2054-5','N','021','DEN','3478580','99734OH005000401','2014-04-01','2014-02-28 12:26:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:27'),(20418,16308,'N','01','021','EC','A',NULL,NULL,'','0000319703','0000949542','','IL','1','Colbow','Michael','L','','','34','274549316','2737 State Route 60',0,'Loudonville','OH','44842',NULL,'CY','39005','1955-09-05','M','',':RET:2106-3','N','021','DEN','1600309','99734OH005000301','2014-03-01','2014-01-28 22:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:29'),(2938,2364,'Y','18','021','EC','A','','','AC','0000608417','0000608417','OH00000354303','IL','1','PATEL','RAJNIKANT','','','','34','298119269','4947 GLEN SPRINGS DR',0,'LIBERTY TWP','OH','45011','2637','CY','39017','1953-02-06','M','M',':RET:2029-7','N','021','DEN','1007455','99734OH005000401','2014-01-01','2013-12-06 07:05:47','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:16:09'),(13484,10752,'Y','18','021','EC','A','','','AC','0000190196','0000190196','OH00000897790','IL','1','Cooper','Amanda','','','','34','298807513','1601 Hill Street',0,'Belpre','OH','45714',NULL,'CY','39167','1979-05-22','F','M',':RET:2106-3','N','021','DEN','1961601','99734OH005000301','2014-01-01','2013-12-23 17:43:47','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-26 13:02:17'),(13275,10595,'Y','18','021','EC','A','','','AC','0000132479','0000132479','TX00001288490','IL','1','Moore','Michael','','','','34','464355855','60 COUNTY ROAD 1516',0,'AVINGER','TX','75630','2727','CY','48067','1962-11-25','M','M',':RET:2106-3','T','021','DEN','2300605','33348TX002000201','2014-01-01','2013-12-23 12:34:18','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:01'),(9509,7541,'Y','18','024','14','A','','','TE','0001244159','0001244159','','IL','1','HOLTKAMP','JOHN','','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-04','M','',NULL,NULL,NULL,'','1530171','','2013-12-21','2013-12-21 16:11:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:35:21'),(79,69,'N','19','021','EC','A',NULL,NULL,'','0000866868','0000103867','','IL','1','Tatic','Mirna','','','','34','285986761','3942 WELCKER DR NE',0,'WARREN','OH','44483','4541','CY','39155','1992-10-24','F','',':RET:2106-3','N','021','DEN','320054','99734OH005000301','2014-01-01','2013-12-05 17:36:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:17:07'),(19125,15238,'Y','18','021','EC','A','','','AC','0000022821','0000022821','OH00002185789','IL','1','brown','thomas','','','','34','278748539','5405 north ridge rd e',0,'ashtabula','OH','44004',NULL,'CY','39007','1963-07-14','M','U',':RET:2106-3','N','021','DEN','3120518','99734OH005000401','2014-03-01','2014-01-18 21:49:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:45:19'),(2828,2285,'Y','18','021','EC','A','','','AC','0000022171','0000022171','LA00000746953','IL','1','Smith','Ashanti','','','','34','439755859','519 MAIN PROJECT RD',0,'SCHRIEVER','LA','70395','4325','CY','22109','1985-09-02','F','U',':RET:2054-5','N','021','DEN','546580','18575LA002000201','2014-01-01','2013-11-23 19:02:22','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 20:00:41'),(3199,2573,'Y','18','021','EC','A','','','AC','0000884169','0000884169','OH00001053509','IL','1','Liebenguth','Janet','','','','34','290805510','104 Plaza Ct',0,'Akron','OH','44312',NULL,'CY','39153','1977-10-03','F','U',':RET:2106-3','N','021','DEN','317561','99734OH005000401','2014-01-01','2013-10-31 18:56:28','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:45:06'),(3318,2663,'N','01','021','EC','A',NULL,NULL,'','0000689692','0000106711','','IL','1','Burnette','Nicole','','','','34','593665145','1157 THORNY RIDGE TRL',0,'LEBANON','OH','45036','7713','CY','39165','1981-12-24','F','',':RET:2106-3','N','021','DEN','1478794','99734OH005000301','2014-01-01','2013-12-22 14:38:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:59'),(14797,11817,'Y','18','021','EC','A','','','AC','0000525585','0000525585','OH00001098961','IL','1','Cohen','Alaina','','','','34','286929960','3551 NORTHCLIFFE RD',0,'CLEVELAND HEIGHTS','OH','44118','3609','CY','39035','1987-05-25','F','U',':RET:2106-3','T','021','DEN','1521790','99734OH005000401','2014-01-01','2013-12-23 20:42:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:38'),(22463,17935,'Y','18','024','14','A','','','TE','0000469409','0000469409','','IL','1','Wheland','James','Michael','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-03-28','M','',NULL,NULL,NULL,'','3102811','','2014-02-10','2014-02-10 16:18:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:53'),(18457,14724,'Y','18','021','EC','A','','','AC','0001371331','0001371331','LA00002218322','IL','1','Hatfield','Danny','','','','34','433210774','1103 S 7TH ST',0,'MONROE','LA','71202','2836','CY','22073','1964-02-19','M','U',NULL,'N','021','DEN','1830545','18575LA002000101','2014-02-01','2014-01-15 12:49:29','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-16 08:46:11'),(18414,14690,'N','01','021','EC','A',NULL,NULL,'','0001550691','0001169970','','IL','1','Chao','Anna','','','','34','439656414','1701 N 5TH ST',0,'MONROE','LA','71201','4733','CY','22073','1975-11-25','F','',NULL,'N','021','DEN','1919199','18575LA002000201','2014-02-01','2014-01-14 20:52:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:45:49'),(3665,2931,'N','01','021','EC','A',NULL,NULL,'','0000357173','0000262706','','IL','1','Orf','Terry','','','','34','292722065','1581 MEADOW POND CT',0,'DAYTON','OH','45458',NULL,'CY','39113','1975-11-12','F','',':RET:2106-3','N','021','DEN','998018','99734OH005000401','2014-01-01','2013-12-12 20:29:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:59'),(24959,19793,'Y','18','021','EC','A','','','AC','0001554372','0001554372','LA00003122548','IL','1','Conley','Michael','Ladell','','','34','435635870','405 HANCOCK AVE',0,'NATCHITOCHES','LA','71457','5509','CY','22069','1982-05-29','M','U',':RET:2106-3','T','021','DEN','3007369','18575LA002000201','2014-04-01','2014-02-20 15:42:45','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-20 22:00:17'),(21946,17526,'Y','18','021','EC','A','','','AC','0000857154','0000857154','OH00002292897','IL','1','Topovski-Mason','LuAnn','','','','34','275485026','398 AMBER LIGHT CIR',0,'DELAWARE','OH','43015','5092','CY','39041','1961-11-23','F','U',':RET:2106-3','N','021','DEN','2764637','99734OH005000401','2014-03-01','2014-02-06 18:30:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:18'),(20451,16335,'Y','18','021','EC','A','','','AC','0000051953','0000051953','OH00002475815','IL','1','KIRSCH','JAMES','','','','34','277744184','1715 HIGHLAND AVE',0,'PORTSMOUTH','OH','45662','3610','CY','39145','1978-09-28','M','U',':RET:2106-3','N','021','DEN','3007977','99734OH005000401','2014-03-01','2014-01-28 19:53:56','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-01-29 21:00:45'),(14364,11456,'Y','18','021','EC','A','','','AC','0000749531','0000749531','OH00000586495','IL','1','Edwards','Teryl','','','','34','289641260','2213 SANFORD ST',0,'SANDUSKY','OH','44870','1973','CY','39043','1969-07-07','F','M',':RET:2106-3','N','021','DEN','1660751','99734OH005000401','2014-02-01','2013-12-26 21:37:16','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-28 03:30:21'),(644,532,'Y','18','021','EC','A','','','AC','0000784346','0000784346','OH00000085205','IL','1','Bates','Eli','','','','34','296907754','2664 N KEARNEY CT',0,'XENIA','OH','45385','5705','CY','39057','1986-12-10','M','M',':RET:2106-3','N','021','DEN','1892374','99734OH005000401','2014-01-01','2013-12-16 15:38:35','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:01:26'),(3768,3016,'Y','18','021','EC','A','','','AC','0001093132','0001093132','OH00001284079','IL','1','Paule','Christine','','','','34','281508679','798 PURDUE AVE',0,'YOUNGSTOWN','OH','44515','4221','CY','39099','1951-10-18','F','M',':RET:2106-3','N','021','HLT','1238633','52664OH151001305','2014-01-01','2013-12-13 14:49:53','545.00',NULL,NULL,'726.57','181.57','R-OH013','OH0','726.57',NULL,0,'2013-12-25 21:33:38'),(26245,20815,'N','01','021','EC','A',NULL,NULL,'','0000834369','0001226892','','IL','1','Nguyen','Tram','','','','34','730269166','814 BROKEN FEATHER TRL',0,'PFLUGERVILLE','TX','78660','3702','CY','48453','1974-07-05','F','',':RET:2047-9','N','021','DEN','3322202','33348TX002000201','2014-04-01','2014-02-27 12:01:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 06:31:06'),(9430,7482,'Y','18','021','EC','A','','','AC','0000847141','0000847141','TX00000595627','IL','1','cult','Yvonne','','','','34','524765366','7 whooping crane dr',0,'laguna vista','TX','78578',NULL,'CY','48061','1952-02-06','F','R',NULL,'N','021','DEN','1800677','33348TX002000201','2014-01-01','2013-12-21 17:55:49','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 04:33:22'),(7040,5591,'Y','18','021','EC','A','','','AC','0000730219','0000730219','TX00000138440','IL','1','scott','patricia','','','','34','451816032','2801 4th st',0,'brownwood','TX','76801',NULL,'CY','48049','1976-12-16','F','U',':RET:2106-3','N','021','DEN','2520809','33348TX002000201','2014-02-01','2013-12-25 00:20:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:49:23'),(16214,12984,'Y','18','021','EC','A','','','AC','0000006450','0000006450','MS00001464416','IL','1','Johnson','Earline','','','','34','587136376','3017 Warner Road',0,'Port Gibson','MS','39150',NULL,'CY','28021','1963-05-23','F','M',':RET:2054-5','N','021','DEN','1707500','46300MS002000101','2014-02-01','2014-01-03 22:14:54','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-05 00:01:35'),(25578,20289,'Y','18','021','EC','A','','','AC','0001096813','0001096813','OH00003224026','IL','1','Reigelsperger','Jennie','','','','34','294809492','1737 SUNSET AVE',0,'SPRINGFIELD','OH','45505','4382','CY','39023','1973-10-04','F','U',':RET:2106-3','N','021','HLT','3578040','92036OH004000501','2014-04-01','2014-02-23 17:28:28','231.00',NULL,NULL,'244.27','13.27','R-OH003','OH0','244.27',NULL,0,'2014-02-26 08:00:34'),(5169,4100,'Y','18','021','EC','A','','','AC','0000752065','0000752065','OH00000647783','IL','1','HINRICHS','JEFFREY','','','','34','286569915','307 TRUMBULL AVE',0,'GIRARD','OH','44420','3362','CY','39155','1955-05-14','M','U',':RET:2106-3','N','021','DEN','1816215','99734OH005000401','2014-01-01','2013-12-19 11:16:08','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:03:15'),(7514,5945,'Y','18','021','EC','A','','','AC','0000660591','0000660591','LA00001081114','IL','1','Jackson','Sandra','','','','34','435432395','2087 CUNARD AVE',0,'BATON ROUGE','LA','70807','1806','CY','22033','1966-08-26','F','U',':RET:2054-5','N','021','DEN','941467','18575LA002000201','2014-01-01','2013-12-15 11:57:56','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:32:11'),(9676,7666,'N','19','021','EC','A',NULL,NULL,'','0000957908','0000514437','','IL','1','JULIUS','MATTHEW','','','','34','272968009','5713 TIBARON LN',0,'TOLEDO','OH','43615',NULL,'CY','39095','1992-12-15','M','',NULL,'T','021','HLT','2118305','92036OH006002601','2014-01-01','2013-12-21 12:08:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','177.84',NULL,0,'2013-12-26 04:39:22'),(21439,17135,'N','01','021','EC','A',NULL,NULL,'','0000012695','0001066434','','IL','1','Love','Tyrone','','','','34','425436053','3393 BENSON RD',0,'POPE','MS','38658','3903','CY','28107','1966-10-05','M','',':RET:2054-5','N','021','DEN','3145331','46300MS002000101','2014-03-01','2014-02-04 11:56:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-04 21:01:23'),(22919,18269,'Y','18','021','EC','A','','','AC','0000644709','0000644709','OH00002471922','IL','1','FITE','TAMMY','','','','34','285785035','8095 FAIR RIDGE RD',0,'HILLSBORO','OH','45133','9636','CY','39071','1966-03-09','F','M',NULL,'T','021','HLT','3857807','92036OH003000605','2014-03-01','2014-02-11 17:08:50','208.00',NULL,NULL,'402.96','194.96','R-OH005','OH0','402.96',NULL,0,'2014-02-11 21:02:53'),(25147,19948,'N','01','021','EC','A',NULL,NULL,'','0000853480','0000559354','','IL','1','Sanchez','Amy','Jo','','','34','458796184','1201 E WARREN AVE',0,'KINGSVILLE','TX','78363','6472','CY','48273','1984-02-18','F','',NULL,'N','021','DEN','2906292','33348TX002000201','2014-04-01','2014-02-21 12:11:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-21 22:00:14'),(28805,22800,'Y','18','021','EC','A','','','AC','0000266584','0000266584','OH00003814910','IL','1','Keller','Elizabeth','','','','34','279506443','2015 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44223','1917','CY','39153','1951-08-31','F','M',':RET:2106-3','N','021','HLT','3704995','52664OH151001301','2014-05-01','2014-03-09 09:11:48','0.00',NULL,NULL,'640.70','640.70','R-OH012','OH0','640.70',NULL,0,'2014-03-09 21:00:51'),(29024,22973,'Y','18','021','EC','A','','','AC','0000372668','0000372668','OH00003079392','IL','1','Stephens','Michelle','','','','34','301880546','125 Hopping Court',0,'Harrison','OH','45030',NULL,'CY','39061','1986-12-16','F','U',':RET:2106-3','N','021','DEN','4215342','99734OH005000401','2014-04-01','2014-03-10 10:45:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:32'),(15025,12009,'Y','18','021','EC','A','','','AC','0001553038','0001553038','LA00001833867','IL','1','Dollar','Kathleen','','','','34','436516182','6003 JONI LN',0,'BOSSIER CITY','LA','71111','5724','CY','22015','1979-09-12','F','M',':RET:2106-3','N','021','DEN','2167272','18575LA002000201','2014-02-01','2013-12-29 23:51:28','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-01 12:02:26'),(26863,21290,'Y','18','021','EC','A','','','AC','0000295136','0000295136','TX00002782891','IL','1','Rivera','Monica','','','','34','639129767','1305 URSULA CT',0,'PLANO','TX','75075','2232','CY','48085','1986-05-16','F','U',NULL,'N','021','DEN','3552958','33348TX002000101','2014-04-01','2014-03-01 00:29:01','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-01 21:00:58'),(26196,20775,'Y','18','021','EC','A','','','AC','0001190120','0001190120','OH00003026482','IL','1','Hamric','Stacey','','','','34','270709081','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1971-08-19','F','M',':RET:2106-3','N','021','DEN','3299454','99734OH005000301','2014-03-01','2014-02-27 16:24:47','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:46'),(26004,20624,'Y','18','021','EC','A','','','AC','0001235098','0001235098','LA00003355512','IL','1','Watkins','Kanisha','','','','34','608222554','5445 PROVINE PL',0,'ALEXANDRIA','LA','71303','5801','CY','22079','1983-08-03','F','M',':RET:2054-5','N','021','DEN','3854689','18575LA002000101','2014-04-01','2014-02-26 14:05:43','0.00',NULL,NULL,'50.04','50.04','R-LA006','LA0','25.02',NULL,0,'2014-02-26 21:02:05'),(25744,20418,'N','01','021','EC','A',NULL,NULL,'','0001024330','0001207206','','IL','1','hughes','sarah','','','','34','271703965','151 IVANHOE AVE',0,'CINCINNATI','OH','45233','1206','CY','39061','1975-09-24','F','',':RET:2106-3','N','021','DEN','2686273','99734OH005000401','2014-04-01','2014-02-24 14:32:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:42'),(23420,18661,'Y','18','021','EC','A','','','AC','0001173807','0001173807','TX00002347244','IL','1','Guevara','Edwin','Adalverto','','','34','644608538','6926 ROOS RD',0,'HOUSTON','TX','77074','4830','CY','48201','1987-01-25','M','U',':RET:2106-3','N','021','DEN','3299111','33348TX002000201','2014-03-01','2014-02-12 21:26:49','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-13 22:01:21'),(21787,17399,'Y','18','021','EC','A','','','AC','0000128130','0000128130','OH00001823003','IL','1','MILLER','LINDA','','','','34','297563914','4645 CANTERBURY RD',0,'NORTH OLMSTED','OH','44070',NULL,'CY','39035','1958-12-17','F','U',NULL,'N','021','DEN','3285441','99734OH005000401','2014-03-01','2014-02-06 12:14:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:00:41'),(26337,20896,'Y','18','021','EC','A','','','AC','0000142878','0000142878','OH00002335750','IL','1','Green','Ken','','','','34','273507752','1062 ATLANTIC AVE',0,'TOLEDO','OH','43609','3012','CY','39095','1950-08-07','M','M',':RET:2106-3','N','021','HLT','2785701','92036OH006002601','2014-03-01','2014-02-27 11:12:06','137.00',NULL,NULL,'456.50','319.50','R-OH001','OH0','456.50',NULL,0,'2014-02-28 06:31:42'),(6066,4806,'Y','18','021','EC','A','','','AC','0000712487','0000712487','OH00000873534','31','1','Williamson','George','','','','34','204385228','P.O. Box 161',0,'Columbus','OH','43216',NULL,'CY','39049','1949-10-23','M','U',':RET:2106-3','N','021','DEN','698071','99734OH005000401','2014-01-01','2013-12-01 12:30:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:02:03'),(23476,18699,'Y','18','024','14','A','','','TE','0000374363','0000374363','','IL','1','Cocchiaro','Katherine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-13','F','',NULL,NULL,NULL,'','1741472','','2014-02-28','2014-02-13 17:48:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-13 22:01:52'),(24141,19184,'N','19','021','EC','A',NULL,NULL,'','0000702823','0000608494','','IL','1','Raper','Miranda','R','','','34','270022667','4439 Happiness Lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','1996-08-21','F','',':RET:2106-3','N','021','HLT','3217890','92036OH004000601','2014-03-01','2014-02-15 10:42:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:52'),(22284,17789,'Y','18','021','EC','A','','','AC','0000122998','0000122998','OH00002313981','IL','1','Pavlis','Karen','','','','34','296540406','1214 W MAPLE ST',0,'NORTH CANTON','OH','44720','2852','CY','39151','1952-12-28','F','U',':RET:2106-3','N','021','DEN','2657107','99734OH005000401','2014-03-01','2014-01-21 09:51:06','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-10 11:00:24'),(13745,10972,'Y','18','021','EC','A','','','AC','0000951798','0000951798','OH00000062900','IL','1','Farmer','Jacob','','','','34','281928682','822 TEAKWOOD CT',0,'LEBANON','OH','45036','8650','CY','39165','1985-08-27','M','M',':RET:2106-3','N','021','HLT','2344128','92036OH003001205','2014-01-01','2013-12-23 16:11:33','250.00',NULL,NULL,'487.38','237.38','R-OH004','OH0','243.69',NULL,0,'2013-12-26 13:09:49'),(437,359,'N','01','021','EC','A',NULL,NULL,'','0000030514','0000489209','','IL','1','Glasser','Jan','','','','34','295504340','13725 HEATH RD',0,'NOVELTY','OH','44072','9746','CY','39055','1955-12-10','F','',':RET:2106-3','N','021','DEN','1191845','99734OH005000401','2014-01-01','2013-12-04 11:00:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:05'),(13448,10723,'Y','18','021','EC','A','','','AC','0000814286','0000814286','OH00000329771','IL','1','Yarshen','James','','','','34','293488902','4908 OAKRIDGE RD',0,'ROME','OH','44085','9650','CY','39007','1954-04-28','M','M',':RET:2106-3','N','021','DEN','1609289','99734OH005000301','2014-01-01','2013-12-23 14:07:22','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:24'),(2200,1811,'Y','18','024','14','A','','','TE','0000378543','0000378543','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','1118401','','2013-12-10','2013-12-10 14:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:20:00'),(19752,15744,'Y','18','021','EC','A','','','AC','0000145384','0000145384','OH00001431404','IL','1','bentley','sandra','','','','34','240826832','2560 SHERWOOD DR',0,'LIMA','OH','45805','1426','CY','39003','1950-01-27','F','U',':RET:2054-5','N','021','HLT','2111671','92036OH004001501','2014-03-01','2014-01-23 13:27:00','478.00',NULL,NULL,'530.89','52.89','R-OH002','OH0','530.89',NULL,0,'2014-01-23 21:01:18'),(670,552,'Y','18','024','14','A','','','TE','0000939732','0000939732','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','830500','','2013-12-16','2013-12-16 09:53:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:06'),(25549,20270,'Y','18','021','EC','A','','','AC','0000582855','0000582855','OH00003070473','IL','1','Fulmer','Dianne','','','','34','279527349','6006 CINNAMON DR E',0,'WEST SALEM','OH','44287','9698','CY','39169','1951-01-09','F','U',':RET:2106-3','N','021','DEN','3213169','99734OH005000401','2014-04-01','2014-02-23 16:36:54','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-02-26 08:00:17'),(4549,3605,'N','19','021','EC','A',NULL,NULL,'','0001183512','0001234106','','IL','1','Daugherty','Haley','','','','34','300967922','9275 DANIELS RD',0,'SEVILLE','OH','44273','8843','CY','39103','1994-06-06','F','',':RET:2106-3','N','021','HLT','918505','52664OH152000901','2014-01-01','2013-12-12 09:02:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 22:04:31'),(4527,3587,'Y','18','021','EC','A','','','AC','0000184613','0000184613','TX00000017181','IL','1','LEE','LLOYD','ASTER','','','34','452786337','19619 DAKOTA SPRINGS DR',0,'TOMBALL','TX','77377',NULL,'CY','48201','1949-10-17','M','M',':RET:2054-5^:RET:2106-3','N','021','DEN','1060843','33348TX002000201','2014-01-01','2013-12-12 15:43:37','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:03:58'),(22830,18216,'Y','18','021','EC','A','','','AC','0000722680','0000722680','OH00001467516','31','1','Ross','Sylvia','','','','34','279681766','P.O. Box 4912',0,'Akron','OH','44310',NULL,'CY','39153','1958-06-25','F','U',':RET:2106-3','N','021','HLT','3148004','52664OH151001305','2014-03-01','2014-02-11 10:41:38','365.00',NULL,NULL,'497.31','132.31','R-OH012','OH0','497.31',NULL,0,'2014-02-11 21:02:06'),(8039,6365,'Y','18','021','EC','A','','','AC','0000700370','0000700370','OH00001185674','IL','1','ZELLER','JAMES','PAUL','','','34','286463464','1501 MERRILL AVE',0,'KENT','OH','44240','6315','CY','39133','1951-07-02','M','M',':RET:2106-3','N','021','HLT','1878932','52664OH152000901','2014-01-01','2013-12-20 08:08:39','600.00',NULL,NULL,'867.34','267.34','R-OH012','OH0','469.28',NULL,0,'2013-12-26 03:09:22'),(22781,18189,'Y','18','021','EC','A','','','AC','0001050681','0001050681','OH00002599647','IL','1','Newcome','Scott','','','','34','298787068','71 ORGAN AVE',0,'AKRON','OH','44319','3070','CY','39153','1974-09-05','M','M',':RET:2106-3','N','021','DEN','2944106','99734OH005000301','2014-03-01','2014-02-10 19:56:06','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-02-11 21:01:44'),(22185,17706,'Y','18','021','EC','A','','','AC','0000852787','0000852787','LA00001644448','IL','1','LINDE','BARBARA','','','','34','439920749','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1952-04-09','F','M',':RET:2106-3','N','021','DEN','3361436','18575LA002000201','2014-03-01','2014-02-09 13:03:33','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61','CIC',0,'2014-02-09 19:00:06'),(13225,10551,'Y','18','021','EC','A','','','AC','0001099168','0001099168','TX00001021325','IL','1','Mixon','Thelma','J','','','34','462352112','8004 W VIRGINIA DR',0,'DALLAS','TX','75237','4426','CY','48113','1961-11-23','F','M',':RET:2054-5','N','021','DEN','2075972','33348TX002000201','2014-01-01','2013-12-22 21:03:25','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:55:35'),(2125,1745,'Y','18','021','EC','A','','','AC','0000631486','0000631486','OH00001179520','IL','1','FAROOQ','TANVIR','','','','34','284028153','meadow green cir',0,'gahanna','OH','43230',NULL,'CY','39049','1959-10-01','M','M',':RET:2029-7','N','021','DEN','742038','99734OH005000401','2014-01-01','2013-12-10 14:44:54','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:17:50'),(2376,1938,'Y','18','021','EC','A','','','AC','0001140747','0001140747','OH00001235130','IL','1','Cooke','Loretta','','','','34','301608487','875 Eaton Avenue',0,'Hamilton','OH','45013',NULL,'CY','39017','1965-03-17','F','U',NULL,'N','021','DEN','730813','99734OH005000401','2014-01-01','2013-12-09 10:17:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:32:53'),(6016,4761,'N','01','021','EC','A',NULL,NULL,'','0000261460','0000802542','','IL','1','Perkoski','Carol','','','','34','293586331','22735 CREEK BEND CT',0,'STRONGSVILLE','OH','44149','2013','CY','39035','1966-06-04','F','',NULL,'N','021','DEN','730649','99734OH005000301','2014-01-01','2013-12-01 14:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:43'),(5568,4418,'N','01','021','EC','A',NULL,NULL,'','0001050608','0000021349','','IL','1','Coakley','Dawn','I','','','34','547699836','1044 MCCOY CT',0,'PATASKALA','OH','43062','7098','CY','39089','1973-10-17','F','',':RET:2106-3','N','021','DEN','276530','99734OH005000301','2014-01-01','2013-11-05 19:28:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:36'),(24920,19760,'Y','18','024','14','A','','','TE','0000947423','0000947423','','IL','1','Wilson','Aimee','F',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-04-23','F','',NULL,NULL,NULL,'','2124296','','2014-02-28','2014-02-20 15:38:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:13'),(6645,5273,'Y','18','021','EC','A','','','AC','0001168775','0001168775','TX00000468683','IL','1','Adams','James','Robert','','','34','618409493','1606 N 7th St.',0,'Longview','TX','75601',NULL,'CY','48183','1990-11-06','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','405548','33348TX002000201','2014-01-01','2013-11-12 11:19:21','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 01:00:26'),(22022,17583,'Y','18','021','EC','A','','','AC','0000667817','0000667817','OH00001375833','IL','1','Hubbell','Diane','','','','34','298602051','491 N SPRING ST',0,'WILMINGTON','OH','45177','1630','CY','39027','1966-08-01','F','M',':RET:2106-3','N','021','HLT','3098229','92036OH003000606','2014-03-01','2014-02-07 08:06:46','876.00',NULL,NULL,'957.04','81.04','R-OH005','OH0','350.40',NULL,0,'2014-02-07 19:00:59'),(2661,2162,'Y','18','024','14','A','','','TE','0000366252','0000366252','','IL','1','Braunstein','Pamela','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-07-25','F','',NULL,NULL,NULL,'','1195773','','2013-12-02','2013-12-02 09:59:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:46:51'),(13959,11127,'Y','18','021','EC','A','','','AC','0000904260','0000904260','OH00000579142','IL','1','Bartee','Timothy','','','','34','302721756','411 E. Pinehurst St.',0,'Sidney','OH','45365',NULL,'CY','39149','1963-07-04','M','M',':RET:2106-3','N','021','HLT','1862973','92036OH005000501','2014-01-01','2013-12-22 22:34:16','604.00',NULL,NULL,'888.53','284.53','R-OH003','OH0','424.53',NULL,0,'2013-12-26 13:15:06'),(22353,17853,'Y','18','021','EC','A','','','AC','0002322418','0002322418','LA00001401414','IL','1','Bass','Bobby','','','','34','435350777','730 Lakeshore Drive',0,'Monroe','LA','71203',NULL,'CY','22073','1978-07-30','M','U',NULL,'N','021','DEN','3241813','18575LA002000201','2014-03-01','2014-02-10 12:39:44','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61','CIC',0,'2014-02-10 21:00:04'),(15929,12754,'N','19','021','EC','A',NULL,NULL,'','0000798422','0000577336','','S1','1','HE','MING','','','','34','277028808','710 TRACK LANE',0,'CINCINNATI','OH','45245',NULL,'CY','39025','1997-04-22','F','',':RET:2034-7','N','021','HLT','2485977','92036OH004000601','2014-02-01','2014-01-02 16:46:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-03 02:06:52'),(26790,21232,'Y','18','021','EC','A','','','AC','0001628618','0001628618','LA00002095009','IL','1','Richoux','Ranell','','','','34','437861097','1530 CAMELLIA DR',0,'HAMMOND','LA','70403','6228','CY','22105','1952-08-18','F','U',':RET:2106-3','N','021','DEN','3259949','18575LA002000101','2014-04-01','2014-02-28 20:55:30','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-01 21:00:18'),(27970,22128,'Y','18','021','EC','A','','','AC','0001397438','0001397438','LA00003638669','IL','1','RODRIGEUZ','DIANE','M',NULL,NULL,NULL,NULL,'164 OLDS LANE',0,'MONROE','LA','71203',NULL,'CY','22073','1952-02-19','F','M',NULL,'T','021','DEN','3300967','18575LA002000201','2014-04-01','2014-03-06 12:13:58','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-06 21:00:50'),(23820,18953,'Y','18','021','EC','A','','','AC','0000011204','0000011204','OH00002766319','IL','1','Greenler','Joseph','','','','34','299602721','104 Madison Street',0,'Tiffin','OH','44883',NULL,'CY','39147','1965-01-19','M','M',':RET:2106-3','N','021','HLT','3560716','92036OH005002705','2014-03-01','2014-02-14 15:37:55','568.00',NULL,NULL,'665.34','97.34','R-OH006','OH0','332.67',NULL,0,'2014-02-14 21:31:40'),(15176,12127,'N','01','021','EC','A',NULL,NULL,'','0000790881','0000477466','','IL','1','Wood','Jill','','','','34','296843319','93 HEATHERBRIDGE LN',0,'BLACKLICK','OH','43004','9267','CY','39049','1984-11-29','F','',':RET:2106-3','T','021','DEN','1788793','99734OH005000401','2014-02-01','2013-12-30 16:31:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:42'),(23183,18484,'Y','18','021','EC','A','','','AC','0000967751','0000967751','MS00002059095','IL','1','White','Sandra','C','','','34','587266108','5123 HEATHERTON DR',0,'JACKSON','MS','39211','4558','CY','28049','1950-08-15','F','M',':RET:2106-3','N','021','DEN','3605850','46300MS002000101','2014-03-01','2014-02-12 15:11:54','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-12 21:31:59'),(19227,15320,'Y','18','021','EC','A','','','AC','0000175131','0000175131','OH00002265193','IL','1','buchanan','sheila','','','','34','288720813','409 HIGH ST',0,'Bellevue','OH','44811',NULL,'CY','39077','1961-11-03','F','U',':RET:2106-3','N','021','HLT','2282485','92036OH004002701','2014-03-01','2014-01-19 21:16:35','303.81',NULL,NULL,'306.05','2.24','R-OH006','OH0','306.05',NULL,0,'2014-01-21 08:46:30'),(13558,10812,'N','01','021','EC','A',NULL,NULL,'','0001462795','0001861365','','IL','1','Murray','Jason','','','','34','433599991','384 TOWNSVILLE RD',0,'MARION','LA','71260','3614','CY','22111','1978-05-10','M','',NULL,'T','021','DEN','2025980','18575LA002000201','2014-01-01','2013-12-23 15:33:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:16'),(16813,13448,'Y','18','024','14','A','','','TE','0000307765','0000307765','','IL','1','Cole','Christi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-11-16','F','',NULL,NULL,NULL,'','2188661','','2014-01-11','2014-01-11 17:19:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:18:18'),(26838,21272,'Y','18','021','EC','A','','','AC','0001483493','0001483493','LA00002798815','IL','1','MILLER','KEIANA','','','','34','437832465','445 CAPITOL DRIVE',0,'AVONDALE','LA','70094',NULL,'CY','22051','1991-12-09','F','U',':RET:2054-5','N','021','DEN','3283809','18575LA002000201','2014-03-01','2014-02-28 20:42:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-01 21:00:44'),(19751,15743,'Y','18','024','14','A','','','TE','0000145384','0000145384','','IL','1','bentley','sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-27','F','',NULL,NULL,NULL,'','1711686','','2014-01-23','2014-01-23 13:22:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:18'),(14347,11444,'Y','18','021','EC','A','','','AC','0000514453','0000514453','OH00000260289','IL','1','Zheng','Lixuan','','','','34','274968033','1079 STREAM RIDGE LN',0,'CINCINNATI','OH','45255','4323','CY','39061','1969-02-14','F','M',':RET:2034-7','N','021','HLT','1945675','92036OH006001201','2014-02-01','2013-12-26 17:35:49','260.00',NULL,NULL,'699.90','439.90','R-OH004','OH0','237.84',NULL,0,'2013-12-27 02:08:04'),(16856,13486,'Y','18','021','EC','A','','','AC','0000219701','0000219701','TX00002522695','IL','1','green','carolyn','','','','34','562577152','po box 1442',0,'quitman','TX','75783',NULL,'CY','48499','1964-03-21','F','U',':RET:2106-3','T','021','DEN','2597141','33348TX002000201','2014-02-01','2014-01-08 18:18:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:07'),(4559,3610,'N','19','021','EC','A',NULL,NULL,'','0000426405','0000213354','','IL','1','Williams','Kennedy',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2008-10-10','F','',':RET:2054-5','N','021','HLT','1132180','52664OH152000901','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 22:04:41'),(15552,12445,'Y','18','021','EC','A','','','AC','0001671566','0001671566','LA00001941387','IL','1','Prevost','Mallory','','','','34','428657449','13011 CATAHOULA DR',0,'DENHAM SPRINGS','LA','70726','6966','CY','22063','1987-11-18','F','U',':RET:2106-3','N','021','DEN','1902500','18575LA002000201','2014-02-01','2013-12-31 16:30:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:31:19'),(7293,5780,'Y','18','021','EC','A','','','AC','0000776411','0000776411','OH00001006726','IL','1','Pacifico','Michael',NULL,NULL,NULL,NULL,NULL,'114 S PROSPECT ST',0,'KENT','OH','44240','3422','CY','39133','1952-06-06','M','M',':RET:2106-3','T','021','HLT','370453','52664OH151001501','2014-01-01','2013-12-14 13:09:49','845.00',NULL,NULL,'1386.41','541.41','R-OH012','OH0','864.32',NULL,0,'2013-12-26 02:02:56'),(28410,22479,'Y','18','021','EC','A','','','AC','0000850563','0000850563','OH00003782220','IL','1','FREEMAN','SHIRLEY','','','','34','271609502','1254 N LOCKWOOD AVE',0,'EAST CLEVELAND','OH','44112','4133','CY','39035','1958-09-07','F','U',NULL,'N','021','DEN','4065058','99734OH005000401','2014-04-01','2014-03-07 11:16:23','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:56'),(28808,22802,'Y','18','021','EC','A','','','AC','0000615576','0000615576','OH00003002819','IL','1','Robinson','James','','','','34','288583556','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1955-12-24','M','M',':RET:2106-3','N','021','HLT','3047642','52664OH151001306','2014-05-01','2014-03-09 10:14:28','1000.00',NULL,NULL,'1173.46','173.46','R-OH012','OH0','568.22',NULL,0,'2014-03-09 21:00:53'),(28874,22851,'Y','18','021','EC','A','','','AC','0000103982','0000103982','TX00003005052','IL','1','MORENO','BEATRIZ','','','','34','631349772','709 W CHAMPION ST',0,'EDINBURG','TX','78539','4254','CY','48215','1993-01-21','F','U',NULL,'N','021','DEN','4273476','33348TX002000201','2014-04-01','2014-03-09 21:42:48','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-10 21:00:04'),(16039,12842,'Y','18','021','EC','A','','','AC','0000831485','0000831485','TX00001309232','IL','1','Shimek','Stephanie','Dawn','','','34','452556296','350 CRESTVIEW CIR',0,'BEAUMONT','TX','77707','1454','CY','48245','1973-03-03','F','U',':RET:2106-3','N','021','DEN','1689968','33348TX002000101','2014-02-01','2014-01-02 20:25:10','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2014-01-04 02:02:46'),(3281,2646,'Y','18','021','EC','A','','','AC','0000061312','0000061312','OH00000011672','IL','1','Dowling','Stuart','','','','34','282766030','32356 S ROUNDHEAD DR',0,'SOLON','OH','44139','4769','CY','39035','1965-06-08','M','M',':RET:2106-3','N','021','DEN','1722878','99734OH005000301','2014-01-01','2013-12-21 19:59:09','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:15:16'),(5031,3985,'N','01','021','EC','A',NULL,NULL,'','0000702751','0000595106','','IL','1','Harmon','Rachelle','','','','34','286880099','1811 W SPRING ST',0,'LIMA','OH','45805','2627','CY','39003','1983-10-25','F','',':RET:2106-3','N','021','HLT','618218','92036OH003001505','2014-01-01','2013-12-07 16:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','260.87',NULL,0,'2013-12-25 22:47:45'),(412,340,'Y','18','021','EC','A','','','AC','0000847129','0000847129','OH00001040181','IL','1','New','Kevin','','','','34','280881239','5838 EDGEHILL DR',0,'PARMA HEIGHTS','OH','44130','2023','CY','39035','1981-06-07','M','M',':RET:2106-3','N','021','DEN','1007424','99734OH005000401','2014-01-01','2013-12-04 15:26:54','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:27'),(23388,18637,'Y','18','021','EC','A','','','AC','0000977983','0000977983','OH00002030257','IL','1','BRITT','CHARLES','','','','34','287605629','1235 HADDON RD',0,'COLUMBUS','OH','43209','2926','CY','39049','1961-10-14','M','U',':RET:2106-3','T','021','DEN','3082157','99734OH005000401','2014-03-01','2014-02-13 14:16:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:01:03'),(25738,20415,'N','19','021','EC','A',NULL,NULL,'','0001033720','0000944920','','S1','1','WILLSON','DEMETRIUS','','','','34','287064979','38718 AVENEL CT',0,'WILLOUGHBY','OH','44094','8068','CY','39085','2001-05-20','F','',':RET:2054-5','N','021','DEN','2970780','99734OH005000401','2014-04-01','2014-02-24 11:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:39'),(3868,3097,'Y','18','021','EC','A','','','AC','0000067927','0000067927','LA00000815450','IL','1','stevens','virginia','','','','34','439965434','187 LLOYD HICKS RD',0,'CALHOUN','LA','71225','9541','CY','22073','1952-10-29','F','M',':RET:2106-3','N','021','DEN','284686','18575LA002000201','2014-01-01','2013-12-13 09:14:53','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 21:36:07'),(3356,2690,'Y','18','021','EC','A','','','AC','0000997711','0000997711','TX00000978863','IL','1','Harless','Dwayne','','','','34','500701221','623 MITCHELL ST',0,'WINNSBORO','TX','75494','2081','CY','48159','1962-04-09','M','M',':RET:2106-3','T','021','DEN','1649594','33348TX002000201','2014-01-01','2013-12-22 12:10:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:16:52'),(24893,19736,'N','01','021','EC','A',NULL,NULL,'','0001142218','0000421508','','IL','1','PATEL','NILA','B','','','34','268155736','9060 COUNTRY CLUB RD',0,'PIQUA','OH','45356','8570','CY','39109','1961-06-25','F','',NULL,'N','021','HLT','3160392','92036OH004000501','2014-04-01','2014-02-19 12:19:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.09','CIC',0,'2014-02-20 05:39:22'),(7211,5715,'Y','18','021','EC','A','','','AC','0000242689','0000242689','OH00000402803','31','1','Sullivan','Judith','','','','34','281382982','1385 TIMSHEL ST',0,'DAYTON','OH','45440','3964','CY','39057','1949-08-06','F','M',':RET:2106-3','N','021','DEN','1006508','99734OH005000401','2014-01-01','2013-12-14 06:14:21','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:00:57'),(7415,5867,'Y','18','021','EC','A','','','AC','0000599720','0000599720','OH00000486576','IL','1','nerone','patricia','','','','34','270509057','8115 FORESTDALE DR',0,'WILLOUGHBY','OH','44094','8641','CY','39085','1950-08-21','F','U',':RET:2106-3','N','021','DEN','643700','99734OH005000401','2014-01-01','2013-10-28 08:00:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:16:49'),(20804,16624,'Y','18','021','EC','A','','','AC','0000588450','0000588450','TX00001404923','IL','1','nnolim','Brian','','','','34','258679322','7313 REGENCY SQUARE CT',0,'HOUSTON','TX','77036','3114','CY','48201','1965-04-21','M','U',':RET:2054-5','N','021','DEN','2091772','33348TX002000201','2014-03-01','2014-01-31 15:43:19','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-31 21:00:23'),(16835,13466,'Y','18','021','EC','A','','','AC','0000317358','0000317358','OH00001554534','IL','1','Barrington','Dennis','','','','34','288583771','80 Center Street',0,'Seville','OH','44273',NULL,'CY','39103','1956-08-30','M','M',':RET:2106-3','N','021','DEN','2141792','99734OH005000401','2014-02-01','2014-01-11 16:12:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:18:30'),(27262,21586,'Y','18','024','14','A','','','TE','0001339216','0001339216','','IL','1','Green','Ellen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-04-26','F','',NULL,NULL,NULL,'','2099472','','2014-03-18','2014-03-03 18:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-04 21:00:10'),(24998,19825,'N','01','021','EC','A',NULL,NULL,'','0000093699','0000847435','','IL','1','Rettinger','Marsha','','','','34','312541380','26434 OLD LAAKE LN',0,'NEW ULM','TX','78950','4849','CY','48015','1951-10-27','F','',':RET:2106-3','N','021','DEN','2757689','33348TX002000201','2014-04-01','2014-02-20 16:11:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 22:00:44'),(23873,18997,'Y','18','021','EC','A','','','AC','0001066019','0001066019','OH00002117210','IL','1','Simmons','Kathrine',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1968-10-03','F','R',NULL,'N','021','HLT','3387705','52664OH151001501','2014-03-01','2014-02-14 11:43:31','0.00',NULL,NULL,'1819.31','1819.31','R-OH011','OH0','435.60',NULL,0,'2014-02-14 21:32:11'),(22332,17833,'Y','18','021','EC','A','','','AC','0000467970','0000467970','TX00002355941','IL','1','Arellano','Margarito','','','','34','462961527','7951 BOSQUE RD',0,'CANUTILLO','TX','79835','7402','CY','48141','1953-07-09','M','M',':RET:2106-3','N','021','DEN','2804791','33348TX002000101','2014-03-01','2014-01-28 11:10:54','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-10 11:01:02'),(4995,3963,'Y','18','021','EC','A','','','AC','0001020392','0001020392','OH00000344070','IL','1','Shah','Daksha','R','','','34','297605518','696 HARCOURT DR',0,'CINCINNATI','OH','45246','1421','CY','39061','1952-12-24','F','M',':RET:2029-7','N','021','DEN','679571','99734OH005000301','2014-01-01','2013-12-07 00:51:59','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:47:01'),(3785,3032,'Y','18','021','EC','A','','','AC','0000590764','0000590764','OH00000598817','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',NULL,'N','021','DEN','833538','99734OH005000301','2014-01-01','2013-12-13 09:01:25','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:34:05'),(3118,2505,'Y','18','021','EC','A','','','AC','0000396977','0000396977','TX00000860192','IL','1','Blackshear','Jarred','','','','34','629013534','5012 CORINTHIAN BAY DR',0,'FRISCO','TX','75034','2162','CY','48121','1985-10-09','M','U',NULL,'N','021','DEN','102942','33348TX002000201','2014-01-01','2013-10-13 15:58:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:30:12'),(3069,2467,'Y','18','021','EC','A','','','AC','0000015736','0000015736','LA00000672027','IL','1','Rothstein','Mindy','','','','34','381947933','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','1981-08-21','F','R',':RET:2106-3','N','021','DEN','1029260','18575LA002000101','2014-01-01','2013-12-06 17:16:10','0.00',NULL,NULL,'94.59','94.59','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:19:26'),(13329,10642,'Y','18','021','EC','A','','','AC','0000268987','0000268987','TX00000620631','31','1','Morris','Linda','','','','34','467847243','P O Box 63662',0,'Pipe Creek','TX','78063',NULL,'CY','48019','1949-12-15','F','M',NULL,'N','021','DEN','1422431','33348TX002000201','2014-01-01','2013-12-23 17:27:15','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:58:34'),(20138,16070,'Y','18','021','EC','A','','','AC','0000031974','0000031974','OH00002345648','IL','1','ROBINSON','JUDITH','','','','34','289685630','1742 LOXLEY RD',0,'TOLEDO','OH','43613','4602','CY','39095','1960-12-13','F','U',NULL,'T','021','DEN','1576890','99734OH005000401','2014-03-01','2014-01-27 14:16:45','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-27 21:00:56'),(17818,14233,'Y','18','021','EC','A','','','AC','0000061522','0000061522','MS00002230909','31','1','King','Natalie','','','','34','427579414','3315 North Hills St.',0,'Meridian','MS','39305',NULL,'CY','28049','1986-05-21','F','R',':RET:2054-5','N','021','DEN','2189932','46300MS002000201','2014-02-01','2014-01-14 02:00:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:55'),(18959,15105,'Y','18','024','14','A','','','TE','0001019904','0001019904','','IL','1','Spotswood','Jasmine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-07-08','F','',NULL,NULL,NULL,'','1912276','','2014-01-16','2014-01-16 22:52:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-20 08:05:54'),(26621,21108,'Y','18','021','EC','A','','','AC','0000252428','0000252428','TX00002414699','IL','1','SALAZAR','JOHN','','','Jr','34','449572240','2833 S 28TH ST',0,'ABILENE','TX','79605','6701','CY','48441','1982-02-26','M','M',NULL,'N','021','DEN','3740779','33348TX002000201','2014-04-01','2014-02-28 12:08:11','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-02-28 21:30:52'),(812,672,'Y','18','024','14','A','','','TE','0001011536','0001011536','','IL','1','Drake','Teri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-07','F','',NULL,NULL,NULL,'','1046243','','2013-12-16','2013-12-16 10:18:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:05:51'),(2112,1732,'Y','18','021','EC','A','','','AC','0001004310','0001004310','OH00000375772','IL','1','HAYES','DIANE','','','','34','298583787','682 CLOVERDALE AVENUE',0,'CINCINNATI','OH','45246',NULL,'CY','39061','1957-11-25','F','U',':RET:2054-5','N','021','DEN','771728','99734OH005000401','2014-01-01','2013-12-10 10:51:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:28'),(15010,11998,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','2014333','','2013-12-30','2013-12-30 10:08:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:02:00'),(22718,18141,'Y','18','021','EC','A','','','AC','0002003908','0002003908','LA00002359908','IL','1','Branch','Jerry','','','','34','435233451','962 HIGHWAY 564',0,'JONESVILLE','LA','71343','7815','CY','22025','1963-04-05','M','U',':RET:2054-5','N','021','DEN','3705390','18575LA002000201','2014-03-01','2014-02-11 11:18:38','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-11 21:01:08'),(22020,17581,'Y','18','021','EC','A','','','AC','0000076386','0000076386','TX00001867908','IL','1','Harmon','Leticia','','','','34','462298517','108 BRUNSWICK DR',0,'BOERNE','TX','78006','3267','CY','48259','1957-03-28','F','U',':RET:2106-3','N','021','DEN','2999708','33348TX002000101','2014-03-01','2014-02-06 23:36:59','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-07 19:00:57'),(19448,15502,'Y','18','021','EC','A','','','AC','0000618393','0000618393','OH00002000104','IL','1','montalvo','jeammie','','','','34','292862869','14216 BERWYN AVE',0,'CLEVELAND','OH','44111','3238','CY','39035','1987-08-09','F','U',NULL,'T','021','DEN','2649549','99734OH005000301','2014-03-01','2014-01-21 18:39:37','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:01:51'),(16688,13354,'Y','18','021','EC','A','','','AC','0000120615','0000120615','TX00001822329','IL','1','Rosenfield','Adam','','','','34','460977762','4117 FORBES DR',0,'PLANO','TX','75093','6610','CY','48085','1988-02-04','M','U',':RET:2106-3','N','021','DEN','2047170','33348TX002000201','2014-02-01','2014-01-06 21:41:23','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-08 18:24:33'),(13853,11054,'Y','18','021','EC','A','','','AC','0000417394','0000417394','OH00000026855','IL','1','Antoine','Matthew','I','','','34','299981812','2518 ORLAND AVE',0,'CINCINNATI','OH','45211','8306','CY','39061','1996-03-29','M','U',':RET:2054-5','N','021','HLT','1467534','92036OH006001201','2014-01-01','2013-12-22 20:15:25','0.00',NULL,NULL,'108.11','108.11','R-OH004','OH0','108.11',NULL,0,'2013-12-26 13:12:37'),(14291,11400,'Y','18','021','EC','A','','','AC','0000345585','0000345585','OH00001449695','IL','1','SHARPLES','DIANA','','','','34','278664401','2496 RED FOX PASS',0,'WILLOUGHBY HILLS','OH','44094','9622','CY','39085','1959-03-09','F','U',':RET:2106-3','N','021','HLT','2067029','52664OH152000901','2014-02-01','2013-12-26 11:43:53','283.00',NULL,NULL,'393.32','110.32','R-OH011','OH0','393.32',NULL,0,'2013-12-27 02:06:34'),(27416,21697,'N','19','021','EC','A',NULL,NULL,'','0000585592','0000392427','','IL','1','Manning','Kaitlyn','','','','34','273113570','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','2004-12-08','F','',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:36'),(28073,22217,'Y','18','021','EC','A','','','AC','0000523470','0000523470','OH00003072259','IL','1','Bubsey','Duane','','','','34','277528294','4326 W 137TH ST',0,'CLEVELAND','OH','44135','2123','CY','39035','1958-08-18','M','U',':RET:2106-3','N','021','DEN','3761362','99734OH005000301','2014-04-01','2014-03-06 14:16:39','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:52'),(7668,6074,'Y','18','021','EC','A','','','AC','0001848282','0001848282','LA00000234443','IL','1','Alleman','Nicole','','','','34','433635040','10159 JEFFERSON HWY',0,'BATON ROUGE','LA','70809','2726','CY','22033','1974-12-10','F','U',':RET:2106-3','N','021','DEN','2468428','18575LA002000101','2014-01-01','2013-12-20 17:07:04','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:29'),(17702,14146,'Y','18','021','EC','A','','','AC','0001268775','0001268775','LA00002051027','IL','1','CESTEDES-MONTANO','EDUARD','I','','','34','598544676','339 HELEN ST',0,'TERRYTOWN','LA','70056','3816','CY','22051','1975-11-18','M','M',NULL,'N','021','DEN','1645190','18575LA002000201','2014-02-01','2014-01-13 13:45:26','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:05'),(1725,1437,'N','19','021','EC','A',NULL,NULL,'','0000876064','0000964623','','IL','1','Lynch','John Christopher','Maisto','','','34','215591430','287 CASTLE BLVD',0,'AKRON','OH','44313','6534','CY','39153','2000-10-16','M','',':RET:2036-2^:RET:2106-3','N','021','DEN','1370597','99734OH005000301','2014-01-01','2013-12-24 10:25:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:17'),(3954,3164,'Y','18','021','EC','A','','','AC','0000728689','0000728689','OH00001114838','IL','1','Mink','Ray','','','','34','290585164','1850 State Route 28',0,'Goshen','OH','45122',NULL,'CY','39025','1956-06-23','M','U',NULL,'N','021','HLT','485458','92036OH005000606','2014-01-01','2013-12-13 12:24:55','425.00',NULL,NULL,'523.16','98.16','R-OH005','OH0','523.16',NULL,0,'2013-12-25 21:38:15'),(16257,13015,'Y','18','021','EC','A','','','AC','0000035638','0000035638','MS00001504000','IL','1','Steward','Eddie','','','','34','587512817','534 SCOTT ST',0,'JACKSON','MS','39203','1824','CY','28049','1979-04-10','M','U',':RET:2054-5','N','021','DEN','2524778','46300MS002000201','2014-02-01','2014-01-04 10:28:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-05 00:02:47'),(23859,18984,'Y','18','021','EC','A','','','AC','0001646376','0001646376','LA00002344776','31','1','Stanford','Elizabeth','','','','34','587576208','PO Box 44',0,'Grand Isle','LA','70358',NULL,'CY','22051','1983-11-03','F','U',':RET:2106-3','N','021','DEN','2860021','18575LA002000101','2014-03-01','2014-02-14 14:33:10','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:03'),(15129,12091,'N','19','021','EC','A',NULL,NULL,'','0001063253','0001071789','','S1','1','mcguire','david','','','','34','299029570','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1998-06-22','M','',NULL,'N','021','DEN','1658127','99734OH005000301','2014-02-01','2013-12-30 17:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:25'),(6069,4809,'Y','18','021','EC','A','','','AC','0000077529','0000077529','OH00000166240','IL','1','Richardson','Dionna','','','','34','287883408','2160 LYNN RD',0,'KENT','OH','44240','6832','CY','39133','1981-07-31','F','U',':RET:2106-3','N','021','DEN','373973','99734OH005000401','2014-01-01','2013-12-01 12:50:43','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:02:09'),(23110,18420,'N','19','021','EC','A',NULL,NULL,'','0000504509','0000814326','','S1','1','wong','christina','','','','34','603068212','8111 EAGLE RIDGE DR',0,'WEST CHESTER','OH','45069','1976','CY','39017','1998-04-17','F','',':RET:2028-9^:RET:2500-7','N','021','DEN','2782996','99734OH005000401','2014-03-01','2014-02-12 17:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:17'),(4427,3518,'Y','18','021','EC','A','','','AC','0000802552','0000802552','OH00000751332','IL','1','Johnston','ERIN','','','','34','287821078','2851 MARBLEVISTA BLVD',0,'COLUMBUS','OH','43204',NULL,'CY','39049','1972-10-08','M','U',':RET:2106-3','N','021','DEN','581295','99734OH005000401','2014-01-01','2013-12-12 17:11:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:45'),(5007,3971,'Y','18','021','EC','A','','','AC','0000098969','0000098969','OH00001247980','IL','1','Smith','Kareem','','','','34','301867607','4608 EDGEWOOD DR',0,'LORAIN','OH','44053','3047','CY','39093','1973-03-17','M','M',NULL,'N','021','DEN','753375','99734OH005000301','2014-01-01','2013-12-07 14:24:11','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:47:16'),(26565,21061,'Y','18','021','EC','A','','','AC','0001026989','0001026989','OH00003063663','IL','1','RISK','DAVID','','','','34','270523465','1209 Tyler St',0,'Sandusky','OH','44870',NULL,'CY','39043','1951-06-22','M','U',NULL,'N','021','DEN','3231369','99734OH005000401','2014-03-01','2014-02-28 10:49:43','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-28 21:30:22'),(5570,4419,'N','19','021','EC','A',NULL,NULL,'','0001057951','0000353930','','IL','1','Scrivner','Cole','M','','','34','272063375','8072 MILL CREEK CIR',0,'WEST CHESTER','OH','45069','1649','CY','39017','2000-11-14','M','',':RET:2106-3','N','021','DEN','174461','99734OH005000301','2014-01-01','2013-11-06 09:38:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:39'),(5217,4141,'N','01','021','EC','A',NULL,NULL,'','0001183522','0000484772','','IL','1','Currence','Bernice','M','','','34','300568533','1183 STATE ROUTE 88',0,'BRISTOLVILLE','OH','44402','9714','CY','39155','1955-09-05','F','',NULL,'N','021','DEN','2216722','99734OH005000401','2014-01-01','2013-12-19 15:56:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:04:26'),(26077,20679,'Y','18','021','EC','A','','','AC','0000142878','0000142878','OH00002814266','31','1','Green','Ken','','','','34','273507752','p.o. box 140912',0,'Toledo','OH','43614',NULL,'CY','39095','1950-08-07','M','M',':RET:2106-3','N','021','HLT','3467019','92036OH006002601','2014-03-01','2014-02-26 17:47:40','151.00',NULL,NULL,'456.50','305.50','R-OH001','OH0','456.50',NULL,0,'2014-02-26 21:02:47'),(3020,2428,'Y','18','021','EC','A','','','AC','0000655795','0000655795','OH00000231421','IL','1','Acoff','Bettye','','','','34','302704013','549 Talbot Avenue',0,'Akron','OH','44306',NULL,'CY','39153','1964-12-22','F','U',':RET:2054-5','N','021','HLT','1148843','52664OH151001306','2014-01-01','2013-12-06 12:38:17','326.00',NULL,NULL,'380.45','54.45','R-OH012','OH0','380.45',NULL,0,'2013-12-25 20:18:07'),(1224,1007,'Y','18','021','EC','A','','','AC','0000898424','0000898424','OH00000809974','IL','1','Everett','Kevin','','','','34','288645175','3950 CARL ST NW',0,'UNIONTOWN','OH','44685','9152','CY','39151','1959-12-13','M','U',':RET:2106-3','T','021','HLT','85530','52664OH151001305','2014-01-01','2013-12-03 14:05:12','310.00',NULL,NULL,'547.54','237.54','R-OH015','OH0','547.54',NULL,0,'2013-12-25 18:20:29'),(1809,1487,'Y','18','021','EC','A','','','AC','0000171215','0000171215','OH00001499710','IL','1','Gradomski','Deborah','','','','34','263131323','5411 N River Rd W9',0,'Geneva','OH','44041',NULL,'CY','39007','1953-09-22','F','M',':RET:2106-3','N','021','HLT','1616445','52664OH151001501','2014-01-01','2013-12-24 11:18:14','426.00',NULL,NULL,'818.71','392.71','R-OH011','OH0','818.71',NULL,0,'2013-12-25 18:56:58'),(6126,4858,'Y','18','021','EC','A','','','AC','0000407762','0000407762','TX00000346177','IL','1','URIAS','BOBBIE','','','','34','643103345','813 CASCADA ST',0,'EL PASO','TX','79928','9027','CY','48141','1989-10-27','F','M',':RET:2106-3','N','021','DEN','684165','33348TX002000201','2014-01-01','2013-11-21 15:27:55','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 00:15:52'),(22875,18245,'N','01','021','EC','A',NULL,NULL,'','0000624041','0000206493','','IL','1','Shih','Mei','Chou','','','34','624848015','331 County Road 1498',0,'Tupelo','MS','38804',NULL,'CY','28081','1966-11-15','F','',':RET:2034-7','N','021','DEN','3245245','46300MS002000101','2014-03-01','2014-02-11 10:06:40',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-11 21:02:32'),(18905,15064,'Y','18','024','14','A','','','TE','0001004364','0001004364','','IL','1','Nay','Shayna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-03-01','F','',NULL,NULL,NULL,'','1516552','','2014-01-15','2014-01-15 19:32:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:38'),(19723,15717,'Y','18','024','14','A','','','TE','0001785149','0001785149','','IL','1','Hardaway','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-26','M','',NULL,NULL,NULL,'','2355307','','2014-01-23','2014-01-23 10:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-23 21:00:59'),(28044,22191,'Y','18','024','14','A','','','TE','0000366840','0000366840','','IL','1','Stepteau','Don',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-01-22','M','',NULL,NULL,NULL,'','4119365','','2014-03-05','2014-03-05 18:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-06 21:01:33'),(22870,18243,'N','17','021','EC','A',NULL,NULL,'','0000432803','0000005878','','IL','1','dang','celina','t','','','34','061843302','610 chestnut ln',0,'boardman','OH','44512',NULL,'CY','39099','1994-09-23','F','',':RET:2047-9','N','021','HLT','3682106','92036OH005003204','2014-03-01','2014-02-10 22:50:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','153.71',NULL,0,'2014-02-11 21:02:30'),(5306,4206,'Y','18','021','EC','A','','','AC','0001194654','0001194654','MS00000581125','IL','1','JACKSON','CELESTE','ANN','','','34','410452550','10038 STEPHENSON LN',0,'OLIVE BRANCH','MS','38654','1817','CY','28033','1969-02-25','F','U',':RET:2106-3','N','021','DEN','1927581','46300MS002000101','2014-01-01','2013-12-18 23:49:46','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 23:06:26'),(3693,2955,'Y','18','024','14','A','','','TE','0001056674','0001056674','','IL','1','GOODMAN','GREGORY','JOSEPH',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-08-29','M','',NULL,NULL,NULL,'','321464','','2013-12-13','2013-12-13 10:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:31:47'),(20874,16682,'Y','18','021','EC','A','','','AC','0001593066','0001593066','LA00001726946','IL','1','GILBERT','TONY','D','','','34','433255680','1586 WINDSOR DR',0,'BATON ROUGE','LA','70815','3073','CY','22033','1962-09-20','M','U',':RET:2054-5','N','021','DEN','2924657','18575LA002000101','2014-03-01','2014-01-30 21:53:03','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-31 21:01:04'),(18007,14390,'Y','18','021','EC','A','','','AC','0001239140','0001239140','OH00002245260','IL','1','Clapper','Daren','','','','34','268860278','235 STILLWELL ST',0,'ZANESVILLE','OH','43701','4353','CY','39119','1987-01-31','M','U',':RET:2106-3','N','021','DEN','1989133','99734OH005000301','2014-02-01','2014-01-14 10:23:15','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-01-15 02:07:02'),(13145,10485,'Y','18','021','EC','A','','','AC','0001252112','0001252112','OH00000820941','IL','1','Creagh','Carole','','','','34','278549525','12049 NICKI LN',0,'CHARDON','OH','44024','8941','CY','39055','1954-10-19','F','U',':RET:2106-3','N','021','DEN','2221793','99734OH005000401','2014-01-01','2013-12-23 16:22:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:26'),(16590,13270,'Y','18','021','EC','A','','','AC','0001233920','0001233920','LA00000732509','IL','1','Brundy','Rosemary','','','','34','433179508','5801 LOUIS PRIMA DR E',0,'NEW ORLEANS','LA','70128','2806','CY','22071','1965-11-20','F','U',NULL,'T','021','DEN','2561993','18575LA002000201','2014-02-01','2014-01-07 16:36:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:24:00'),(28284,22381,'Y','18','021','EC','A','','','AC','0002327443','0002327443','LA00003167186','IL','1','WEBB','WENDY','','','','34','230255605','2153 N ROCHEBLAVE ST',0,'NEW ORLEANS','LA','70119','1457','CY','22071','1973-10-12','F','U',NULL,'N','021','DEN','3115001','18575LA002000201','2014-04-01','2014-03-07 11:58:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-03-07 21:00:26'),(18168,14507,'N','01','021','EC','A',NULL,NULL,'','0001016873','0000367399','','IL','1','Byers','Dyanna','','','','34','280746456','4192 WHITE OAK RD',0,'BLUE CREEK','OH','45616','9026','CY','39001','1963-10-19','F','',NULL,'N','021','HLT','2676347','92036OH005000601','2014-02-01','2014-01-14 12:24:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','383.39',NULL,0,'2014-01-15 02:07:56'),(9333,7397,'Y','18','021','EC','A','','','AC','0001113135','0001113135','OH00000796860','IL','1','Huff','Betty','','','','34','270527199','376 REDBIRD DR',0,'LOVELAND','OH','45140','9516','CY','39025','1952-04-05','F','M',':RET:2106-3','T','021','HLT','1415013','92036OH004000601','2014-01-01','2013-12-21 11:40:26','445.00',NULL,NULL,'557.81','112.81','R-OH005','OH0','557.81',NULL,0,'2013-12-26 04:30:47'),(9144,7251,'Y','18','024','14','A','','','TE','0000096359','0000096359','','IL','1','Bonko','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-27','F','',NULL,NULL,NULL,'','319801','','2013-12-18','2013-12-18 09:36:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:08:15'),(3141,2525,'N','01','021','EC','A',NULL,NULL,'','0000798058','0001222941','','IL','1','Evans','Nancy','','','','34','451825652','107 LAURELFIELD DR',0,'FRIENDSWOOD','TX','77546','4066','CY','48167','1958-01-28','F','',NULL,'N','021','DEN','489296','33348TX002000201','2014-01-01','2013-11-17 20:26:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 20:30:48'),(28042,22189,'Y','18','021','EC','A','','','AC','0000071095','0000071095','MS00002645184','IL','1','VURDUN','AMEER','','','','34','328668916','1617 ECKFORD ST',0,'WATER VALLEY','MS','38965','9052','CY','28161','1977-06-22','M','U',NULL,'T','021','DEN','3187863','46300MS002000201','2014-04-01','2014-03-05 18:16:31','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-06 21:01:32'),(4509,3574,'Y','18','024','14','A','','','TE','0000361659','0000361659','','IL','1','Kay','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-04','M','',NULL,NULL,NULL,'','39002','','2013-12-12','2013-12-12 00:16:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:03:33'),(25707,20393,'Y','18','021','EC','A','','','AC','0000723112','0000723112','TX00002322112','IL','1','Montes','Raul','Soria','','','34','458954919','1521 NE 37TH ST',0,'FORT WORTH','TX','76106','3953','CY','48439','1953-05-05','M','U',NULL,'N','021','DEN','2770125','33348TX002000201','2014-04-01','2014-02-24 14:53:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 09:30:21'),(24844,19696,'N','01','021','EC','A',NULL,NULL,'','0000857169','0000242757','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','HLT','2640425','52664OH152000901','2014-04-01','2014-02-19 09:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.68',NULL,0,'2014-02-20 04:54:12'),(7222,5724,'Y','18','021','EC','A','','','AC','0000430260','0000430260','OH00001233197','IL','1','PARKS','CHARLES','','','','34','296846874','918 PACKARD DR',0,'AKRON','OH','44320','2840','CY','39153','1970-08-28','M','M',NULL,'N','021','DEN','562796','99734OH005000401','2014-01-01','2013-12-14 13:15:20','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:01:09'),(24286,19287,'Y','18','021','EC','A','','','AC','0001211629','0001211629','LA00002520061','IL','1','LaFargue','Richard','A','','Jr','34','436217266','4626 CHARLMARK DR',0,'NEW ORLEANS','LA','70127','3502','CY','22071','1961-07-25','M','U',':RET:2054-5','N','021','DEN','3622055','18575LA002000201','2014-04-01','2014-02-18 15:28:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-18 21:30:09'),(22640,18078,'Y','18','024','14','A','','','TE','0000307865','0000307865','','IL','1','Phan','Thanh',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-03-02','M','',NULL,NULL,NULL,'','3493068','','2014-02-11','2014-02-11 09:58:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-11 21:00:22'),(20069,16008,'Y','18','021','EC','A','','','AC','0000613886','0000613886','TX00001976099','IL','1','Fragoso','Betty','','','','34','463986598','3624avenue street',0,'galveston','TX','77550',NULL,'CY','48167','1953-05-06','F','U',':RET:2106-3','N','021','DEN','3288910','33348TX002000201','2014-03-01','2014-01-27 14:07:29','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-27 21:00:16'),(25329,20096,'Y','18','021','EC','A','','','AC','0001741338','0001741338','LA00002284845','IL','1','WORTH','MOLLY','','','','34','438610857','1001 WALLACE ST',0,'SLIDELL','LA','70461',NULL,'CY','22103','1986-04-04','F','U',':RET:2106-3','N','021','DEN','3359278','18575LA002000201','2014-04-01','2014-02-25 12:50:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:16'),(21585,17242,'Y','18','021','EC','A','','','AC','0001163877','0001163877','OH00002118343','IL','1','Nichols','Debra','L','','','34','295661668','5381 Four Mile Rd.',0,'Jackson','OH','45640',NULL,'CY','39079','1960-05-24','F','U',':RET:2106-3','T','021','DEN','2875217','99734OH005000301','2014-03-01','2014-02-04 19:15:27','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-05 21:30:27'),(7899,6245,'Y','18','021','EC','A','','','AC','0000162261','0000162261','OH00000800386','IL','1','Luedeke','David','','','','34','289583677','2100 Celina Road Lot 13',0,'Saint Marys','OH','45885',NULL,'CY','39011','1955-12-16','M','M',':RET:2106-3','N','021','HLT','1595691','92036OH003001505','2014-01-01','2013-12-20 16:34:20','1041.00',NULL,NULL,'1171.22','130.22','R-OH002','OH0','585.61',NULL,0,'2013-12-26 03:05:46'),(20470,16351,'Y','18','021','EC','A','','','AC','0000296815','0000296815','OH00001748780','IL','1','banning','mary anne','','','','34','276461161','7900 CORINTH COURT RD',0,'FARMDALE','OH','44417','9703','CY','39155','1953-09-26','F','U',NULL,'N','021','DEN','3082927','99734OH005000401','2014-03-01','2014-01-29 11:56:29','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-29 21:00:55'),(4120,3290,'N','01','021','EC','A',NULL,NULL,'','0000309426','0000344129','','IL','1','Cipro','Romualdo','','','Jr','34','298760256','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1970-06-25','M','',':RET:2106-3','N','021','DEN','1795221','99734OH005000301','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:10'),(3819,3058,'Y','18','024','14','A','','','TE','0000130677','0000130677','','IL','1','Markielowski','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-03-19','F','',NULL,NULL,NULL,'','958682','','2013-12-13','2013-12-13 14:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:54'),(104,91,'N','01','021','EC','A',NULL,NULL,'','0000196207','0000029380','','IL','1','Lawson','Keith','Benton','','Jr','34','467757577','1427 W FAIRMONT ST',0,'LONGVIEW','TX','75604','4408','CY','48183','1979-05-07','M','',':RET:2106-3','N','021','DEN','245834','33348TX002000201','2014-01-01','2013-12-05 16:16:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 17:17:47'),(3520,2827,'N','01','021','EC','A',NULL,NULL,'','0000796271','0000549321','','IL','1','WESLEY','KENNETH','','','','34','425234751','614 SAWPINE LN',0,'RIDGELAND','MS','39157','3632','CY','28089','1959-08-28','M','',NULL,'N','021','DEN','2411282','46300MS002000101','2014-01-01','2013-12-21 20:28:38',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 21:21:14'),(23914,19021,'Y','18','021','EC','A','','','AC','0000813132','0000813132','OH00002835392','IL','1','Trimmer','Christopher','','','','34','289866896','2266 TIMBER RIDGE TRL',0,'STREETSBORO','OH','44241','4202','CY','39133','1974-06-12','M','M',':RET:2106-3','N','021','DEN','3787451','99734OH005000301','2014-03-01','2014-02-13 23:40:35','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00','CIC',0,'2014-02-14 22:00:04'),(22345,17846,'Y','18','021','EC','A','','','AC','0001220870','0001220870','OH00001401240','IL','1','Caruso','Andrew','','','','34','276909154','712 hollywood ave',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1983-04-18','M','M',':RET:2106-3','N','021','HLT','3590523','52664OH151001306','2014-03-01','2014-02-01 10:46:33','375.00',NULL,NULL,'506.22','131.22','R-OH012','OH0','253.11',NULL,0,'2014-02-10 11:01:11'),(13390,10689,'Y','18','021','EC','A','','','AC','0000482187','0000482187','OH00000215409','IL','1','Vadakin-Salvati','Cheryl','','','','34','290543953','7640 CHESTERBROOK RD',0,'CHESTERLAND','OH','44026','3429','CY','39055','1962-12-11','F','U',':RET:2106-3','N','021','DEN','2035434','99734OH005000301','2014-01-01','2013-12-23 06:38:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:07'),(22302,17805,'Y','18','021','EC','A','','','AC','0000639555','0000639555','OH00001451669','IL','1','Chamberlain','Shanna','','','','34','257576096','6104 Donna Jay Dr',0,'loveland','OH','45140',NULL,'CY','39025','1986-09-05','F','M',NULL,'N','021','DEN','2982394','99734OH005000301','2014-03-01','2014-01-25 13:36:41','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2014-02-10 11:00:38'),(19835,15818,'Y','18','024','14','A','','','TE','0000215786','0000215786','','IL','1','Davis','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-14','F','',NULL,NULL,NULL,'','433155','','2014-01-24','2014-01-24 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:22'),(24864,19714,'Y','18','024','14','A','','','TE','0000125690','0000125690','','IL','1','Chavez','Carol','P',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-02-09','F','',NULL,NULL,NULL,'','3658115','','2014-03-31','2014-02-19 08:27:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 05:31:19'),(1601,1339,'Y','18','021','EC','A','','','AC','0000334099','0000334099','TX00001444247','IL','1','CASTILLO','OLIVIA','VALDEZ','','','34','456354944','1213 COLT',0,'LA FERIA','TX','78559','5031','CY','48061','1961-09-03','F','M',':RET:2106-3','T','021','DEN','2040739','33348TX002000201','2014-01-01','2013-12-24 12:39:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:52:02'),(19897,15871,'Y','18','021','EC','A','','','AC','0001523153','0001523153','LA00001386657','IL','1','LUSK','GEORGIA','','','','34','435822902','45433 TANGLEWOOD DR',0,'HAMMOND','LA','70401','4450','CY','22105','1951-07-31','F','U',':RET:2054-5','N','021','DEN','3026118','18575LA002000101','2014-03-01','2014-01-24 12:42:22','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-24 21:00:54'),(17694,14140,'N','19','021','EC','A',NULL,NULL,'','0001794495','0001353646','','IL','1','Bowers','Julia','','','','34','434874124','133 WOODLAKE BLVD',0,'KENNER','LA','70065','1032','CY','22051','1993-05-04','F','',NULL,'N','021','DEN','1900301','18575LA002000201','2014-02-01','2014-01-13 12:27:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-01-14 01:33:01'),(4564,3613,'N','01','021','EC','A',NULL,NULL,'','0000278304','0000165057','','IL','1','Piesciuk','Delores',NULL,NULL,NULL,NULL,NULL,'3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-09-11','F','',':RET:2106-3','N','021','HLT','605789','52664OH152000901','2014-01-01','2013-12-12 18:11:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2013-12-25 22:04:46'),(17454,13958,'N','19','021','EC','A',NULL,NULL,'','0001005730','0000799906','','IL','1','Kennedy','Thomas',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','2010-03-16','M','',':RET:2106-3','N','021','HLT','1835802','92036OH002000601','2014-02-01','2014-01-10 14:33:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-13 03:00:39'),(28781,22783,'Y','18','021','EC','A','','','AC','0000221388','0000221388','OH00003326935','IL','1','Willis','Lelith','','','','34','288767844','732 Bellingham Ct',0,'Worthington','OH','43085',NULL,'CY','39049','1965-09-09','F','M',':RET:2054-5','N','021','DEN','2822386','99734OH005000401','2014-04-01','2014-03-09 16:12:08','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-03-09 21:00:36'),(28865,22843,'Y','18','021','EC','A','','','AC','0001001873','0001001873','TX00003256444','IL','1','ROMO','VIOLETA','','','','34','630157773','2605 COTTONWOOD ST',0,'MISSION','TX','78574',NULL,'CY','48215','1978-04-26','F','R',NULL,'N','021','DEN','3680315','33348TX002000201','2014-04-01','2014-03-09 15:35:55','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61','CIC',0,'2014-03-09 21:30:07'),(25958,20588,'Y','18','021','EC','A','','','AC','0000427688','0000427688','OH00002905495','IL','1','MILLER','CAROL','','','','34','299508149','4028 HARDING AVEVUE',0,'CINCINNATTI','OH','45211',NULL,'CY','39061','1949-08-03','F','U',':RET:2106-3','N','021','DEN','3245600','99734OH005000401','2014-03-01','2014-02-26 12:29:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:01:40'),(7345,5815,'N','01','021','EC','A',NULL,NULL,'','0000109265','0000687204','','IL','1','Papich Forsyth','Maria','','','','34','298645763','3672 Sanctuary Dr.',0,'Akron','OH','44333',NULL,'CY','39153','1965-06-04','M','',':RET:2106-3','N','021','HLT','246118','52664OH152000901','2014-01-01','2013-12-14 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.06',NULL,0,'2013-12-26 02:04:05'),(4170,3320,'Y','18','021','EC','A','','','AC','0000793453','0000793453','OH00000066425','IL','1','Smith','Stephen','','','','34','287502772','657 Eastern Ave',0,'Bellefontaine','OH','43311',NULL,'CY','39091','1951-04-01','M','M',':RET:2106-3','N','021','DEN','1490619','99734OH005000301','2014-01-01','2013-12-17 17:17:34','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:49:12'),(3624,2899,'N','19','021','EC','A',NULL,NULL,'','0001064709','0001012919','','S1','1','Riegler','John','','','','34','297084402','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','2004-04-19','M','',':RET:2106-3','N','021','HLT','1527827','52664OH151001501','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 21:23:44'),(16878,13504,'Y','18','021','EC','A','','','AC','0001206037','0001206037','TX00001886188','IL','1','McEldowney','Alivia','','','','34','233390980','808 RICHARDSON RD',0,'LUFKIN','TX','75904','7913','CY','48005','1991-02-28','F','U',':RET:2106-3','N','021','DEN','1608602','33348TX002000201','2014-02-01','2014-01-08 19:38:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:19'),(27534,21783,'Y','18','024','14','A','','','TE','0000616885','0000616885','','IL','1','THIERET','SHARON','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-06-26','F','',NULL,NULL,NULL,'','1926859','','2014-03-31','2014-03-03 18:01:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:05'),(28377,22452,'N','01','021','EC','A',NULL,NULL,'','0000175171','0001160483','','IL','1','Werring','Christina','','','','34','291867123','4009 MOORE MARATHON RD',0,'WILLIAMSBURG','OH','45176','8231','CY','39025','1972-01-05','F','',':RET:2106-3','N','021','HLT','4225138','92036OH005000601','2014-04-01','2014-03-07 10:43:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','284.44',NULL,0,'2014-03-07 21:30:37'),(16480,13189,'Y','18','021','EC','A','','','AC','0000426443','0000426443','OH00002206565','31','1','Ross Dean','Stefanie','','','','34','299580740','1003 SUNNYWOOD LN',0,'RAVENNA','OH','44266','3612','CY','39133','1966-02-12','F','U',':RET:2106-3','N','021','HLT','1411966','52664OH151001305','2014-02-01','2014-01-06 11:38:23','257.00',NULL,NULL,'348.56','91.56','R-OH012','OH0','348.56',NULL,0,'2014-01-07 04:06:14'),(4065,3247,'Y','18','021','EC','A','','','AC','0000044255','0000044255','OH00000972267','IL','1','Vuotto','Linda','','','','34','283509452','6105 Brooktree Ct',0,'Milford','OH','45150',NULL,'CY','39025','1950-07-30','F','U',':RET:2106-3','N','021','DEN','1898328','99734OH005000401','2014-01-01','2013-12-17 16:15:36','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:46:46'),(26806,21243,'Y','18','021','EC','A','','','AC','0000915694','0000915694','OH00003595201','IL','1','GULLY','FRANCES','E','','','34','281827590','25 WEST HILL LANE',0,'CINCINNATI','OH','45215',NULL,'CY','39061','1970-07-06','F','U',':RET:2106-3','N','021','DEN','3007603','99734OH005000301','2014-04-01','2014-03-01 11:05:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:26'),(17741,14174,'N','19','021','EC','A',NULL,NULL,'','0000250269','0000309464','','S1','1','Hindel','Scott','','','','34','298066125','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2002-05-11','F','',':RET:2106-3','N','021','HLT','2130210','52664OH151001304','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-14 01:33:23'),(14084,11224,'Y','18','021','EC','A','','','AC','0000407379','0000407379','OH00001009825','IL','1','archer','randy','','','','34','302420646','11 mill st.',0,'berlin heights','OH','44814',NULL,'CY','39043','1953-09-04','M','U',':RET:2106-3','N','021','DEN','1527104','99734OH005000401','2014-02-01','2013-12-26 10:32:08','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-27 02:01:11'),(8124,6426,'Y','18','021','EC','A','','','AC','0000819745','0000819745','OH00000433951','IL','1','Collins','Cyanthia','S','','','34','300684219','2299 CARRIAGE HILL DR',0,'BELLEFONTAINE','OH','43311','9430','CY','39091','1961-02-25','F','M',':RET:2106-3','N','021','DEN','618035','99734OH005000401','2014-01-01','2013-11-22 14:25:33','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:15:21'),(27861,22037,'Y','18','021','EC','A','','','AC','0000461996','0000461996','OH00003715284','IL','1','Hodge','Reginald','','','','34','301820337','5512 flowerdale ave',0,'Cleveland','OH','44144',NULL,'CY','39035','1985-04-14','M','U',':RET:2054-5','N','021','HLT','3800237','92036OH004000801','2014-04-01','2014-03-05 09:08:32','118.00',NULL,NULL,'204.35','86.35','R-OH011','OH0','204.35',NULL,0,'2014-03-05 21:32:19'),(16326,13071,'Y','18','021','EC','A','','','AC','0001652333','0001652333','LA00001851113','IL','1','CRAWFORD','SHACQUELINE','','','','34','437336177','44636 6L WESTWOOD PARK DRIVE',0,'SHREVEPORT','LA','71109',NULL,'CY','22017','1978-02-17','F','U',NULL,'N','021','DEN','1369636','18575LA002000201','2014-02-01','2014-01-06 09:55:20','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-07 04:01:50'),(15157,12115,'N','19','021','EC','A',NULL,NULL,'','0000116595','0000639538','','IL','1','Ustaszewski','Alexa','N','','','34','281042898','3201 Arctic Avenue',0,'Lewis Center','OH','43035',NULL,'CY','39041','1999-04-29','F','',NULL,'N','021','DEN','2566146','99734OH005000401','2014-02-01','2013-12-30 13:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:14'),(4943,3922,'N','01','021','EC','A',NULL,NULL,'','0000137543','0000615485','','IL','1','Martinez','Maria','','','','34','631096282','3509 HILDA AVE',0,'CINCINNATI','OH','45211','4805','CY','39061','1971-04-30','F','',NULL,'N','021','DEN','628200','99734OH005000401','2014-01-01','2013-12-07 16:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:45:43'),(26934,21346,'Y','18','021','EC','A','','','AC','0000613059','0000613059','OH00002834672','IL','1','RANDOLPH','DONNA','KAY','','','34','282270843','105 BEVERLY COURT',0,'ELYRIA','OH','44035',NULL,'CY','39093','1960-07-11','F','U',':RET:2106-3','N','021','DEN','3081474','99734OH005000301','2014-04-01','2014-03-02 10:05:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-03 01:00:21'),(13883,11076,'Y','18','021','EC','A','','','AC','0000685845','0000685845','OH00000696395','IL','1','Evans','Robert','Todd','','','34','277744266','18300 PARKLAND DR',0,'SHAKER HEIGHTS','OH','44122','3449','CY','39035','1964-04-24','M','R',':RET:2106-3','N','021','HLT','1935254','52664OH151001501','2014-01-01','2013-12-23 17:12:03','0.00',NULL,NULL,'1541.77','1541.77','R-OH011','OH0','514.63',NULL,0,'2013-12-26 13:13:20'),(3194,2569,'Y','18','021','EC','A','','','AC','0000015736','0000015736','LA00000387587','IL','1','Rothstein','Mindy','Bunya','','','34','381947933','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','1981-08-21','F','U',NULL,'N','021','DEN','150521','18575LA002000101','2014-01-01','2013-10-02 23:49:15','0.00',NULL,NULL,'94.59','94.59','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:32:14'),(26254,20824,'Y','18','021','EC','A','','','AC','0000134224','0000134224','TX00002108438','IL','1','IBARRA','SARAI','','','','34','636186859','418 ALMA AVE',0,'ALAMO','TX','78516','3201','CY','48215','1987-12-10','F','M',NULL,'N','021','DEN','3196455','33348TX002000201','2014-04-01','2014-02-27 15:05:05','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-28 06:31:10'),(17326,13859,'Y','18','021','EC','A','','','AC','0001748952','0001748952','LA00001676166','31','1','Jackson','Jimmie','','','','34','435432870','1967 Georgia St',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1968-09-19','M','U',':RET:2054-5','N','021','DEN','1754215','18575LA002000201','2014-02-01','2014-01-09 19:15:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:23:54'),(17577,14054,'Y','18','021','EC','A','','','AC','0000196157','0000196157','OH00001752152','IL','1','Copley','Cheryl','A','','','34','283665560','7248 CHILDRENS HOME BRADFORD RD',0,'GREENVILLE','OH','45331','9234','CY','39037','1961-11-22','F','M',':RET:2106-3','N','021','DEN','2474676','99734OH005000401','2014-02-01','2014-01-13 14:06:46','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-14 01:32:05'),(24692,19601,'Y','18','021','EC','A','','','AC','0001039350','0001039350','TX00002373939','IL','1','Musharbash','Basel','Jalal','','','34','641988141','2470 RIDGEVIEW RD',0,'PARIS','TX','75460','3204','CY','48277','1992-07-08','M','U',':RET:2028-9','N','021','DEN','3200339','33348TX002000101','2014-04-01','2014-02-19 00:10:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:32:41'),(13872,11068,'Y','18','021','EC','A','','','AC','0000264202','0000264202','OH00000842921','IL','1','Peterson','Aaron','','','','34','259630592','8238 EMERALD AVE NE',0,'CANTON','OH','44721','1772','CY','39151','1977-05-08','M','R',':RET:2106-3','N','021','HLT','1945486','52664OH151001501','2014-01-01','2013-12-23 13:32:17','0.00',NULL,NULL,'328.98','328.98','R-OH015','OH0','328.98',NULL,0,'2013-12-26 13:13:05'),(4668,3701,'Y','18','021','EC','A','','','AC','0000008568','0000008568','LA00000275191','IL','1','rives','Laureen','','','','34','436319367','12538 N OAK HILLS PKWY',0,'BATON ROUGE','LA','70810','3239','CY','22033','1964-04-08','F','M',':RET:2106-3','N','021','DEN','803427','18575LA002000201','2014-01-01','2013-12-12 13:55:36','0.00',NULL,NULL,'52.83','52.83','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:07:32'),(24761,19648,'Y','18','021','EC','A','','','AC','0000514496','0000514496','OH00002707401','IL','1','Moore','Nancy','','','','34','277689072','307 FLINT ROCK DR',0,'DELAWARE','OH','43015','6206','CY','39041','1963-10-14','F','U',':RET:2106-3','N','021','DEN','2897440','99734OH005000401','2014-04-01','2014-02-19 11:59:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:42:49'),(22380,17873,'Y','18','021','EC','A','','','AC','0001156236','0001156236','OH00001873072','IL','1','Cassiday','John','','','','34','294787814','2955 PREAKNESS DR',0,'STOW','OH','44224','6235','CY','39153','1966-10-10','M','M',':RET:2106-3','N','021','HLT','2648777','52664OH151001306','2014-03-01','2014-02-10 10:54:56','871.00',NULL,NULL,'1095.41','224.41','R-OH012','OH0','348.56',NULL,0,'2014-02-10 21:30:09'),(4685,3714,'Y','18','021','EC','A','','','AC','0001155087','0001155087','OH00000769041','IL','1','Keane','Michael','J','','','34','287747530','4004 West 223rd Street',0,'Fairview park','OH','44126',NULL,'CY','39035','1963-09-18','M','M',':RET:2106-3','T','021','HLT','886543','92036OH006000801','2014-01-01','2013-12-12 07:37:35','193.00',NULL,NULL,'380.82','187.82','R-OH011','OH0','380.82',NULL,0,'2013-12-25 22:08:01'),(178,147,'Y','18','021','EC','A','','','AC','0000378554','0000378554','OH00000989469','IL','1','Boodey','Margaret','','','','34','293569770','8994 Lowell Ln',0,'Northfield','OH','44067',NULL,'CY','39153','1957-05-31','F','M',':RET:2106-3','N','021','HLT','785689','52664OH151001301','2014-01-01','2013-12-05 10:20:11','115.00',NULL,NULL,'520.28','405.28','R-OH012','OH0','520.28',NULL,0,'2013-12-25 17:19:36'),(26140,20727,'Y','18','021','EC','A','','','AC','0000153425','0000153425','OH00002463449','IL','1','FOUT','CAROL','','','','34','269589262','501 E BROAD ST',0,'COLUMBUS','OH','43215','3822','CY','39049','1955-04-24','F','M',NULL,'N','021','DEN','3279910','99734OH005000401','2014-04-01','2014-02-27 12:38:16','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:25'),(24485,19451,'Y','18','021','EC','A','','','AC','0001953632','0001953632','LA00002772938','IL','1','HUDSON','MICHAEL','','','','34','434846173','18429 BARNEY LN',0,'FRANKLINTON','LA','70438','5948','CY','22117','1960-05-28','M','U',':RET:2106-3','N','021','DEN','2973385','18575LA002000101','2014-04-01','2014-02-18 18:02:53','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-20 03:41:58'),(15716,12572,'Y','18','021','EC','A','','','AC','0000183520','0000183520','OH00002052136','IL','1','danlap','brenda','','','','34','268505903','1040 E TOWNSHIP ROAD 122',0,'TIFFIN','OH','44883','8738','CY','39147','1949-08-08','F','M',':RET:2106-3','N','021','HLT','2348199','92036OH005002705','2014-02-01','2013-12-31 18:30:34','497.00',NULL,NULL,'584.98','87.98','R-OH006','OH0','584.98',NULL,1,'2014-01-02 04:36:14'),(14117,11251,'Y','18','021','EC','A','','','AC','0001175717','0001175717','OH00001085756','IL','1','ELLIOTT','TERESA','','','','34','280682543','830 W COMET RD',0,'CLINTON','OH','44216','9648','CY','39153','1961-05-02','F','M',NULL,'T','021','DEN','2058254','99734OH005000401','2014-02-01','2013-12-26 15:03:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:02:00'),(15504,12405,'Y','18','021','EC','A','','','AC','0000144229','0000144229','OH00001531068','IL','1','WALTERS','TREGENIA','ARRIE','','','34','288523367','4694 LYNDENHALL DR.',0,'COLUMBUS','OH','43207',NULL,'CY','39049','1953-05-14','F','M',':RET:2054-5','N','021','DEN','2223135','99734OH005000401','2014-02-01','2013-12-31 14:30:08','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:49'),(16487,13193,'Y','18','021','EC','A','','','AC','0001065985','0001065985','OH00001736303','IL','1','CORNE','KATHLEEN','','','','34','378544819','300 MARGARET PLACE',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1949-06-08','F','U',':RET:2106-3','N','021','HLT','2297770','92036OH004002601','2014-02-01','2014-01-06 13:32:15','0.00',NULL,NULL,'470.37','470.37','R-OH001','OH0','470.37',NULL,0,'2014-01-07 04:06:25'),(18120,14472,'Y','18','021','EC','A','','','AC','0000370048','0000370048','OH00002044903','IL','1','WILBUR','COLLEEN','','','','34','299464347','377 AVON POINT AVE',0,'AVON LAKE','OH','44012',NULL,'CY','39093','1949-07-20','F','M',':RET:2106-3','N','021','HLT','2447955','52664OH152000901','2014-02-01','2014-01-14 14:05:47','447.00',NULL,NULL,'552.65','105.65','R-OH011','OH0','552.65',NULL,0,'2014-01-15 02:07:40'),(28599,22633,'Y','18','021','EC','A','','','AC','0001039817','0001039817','OH00002620426','IL','1','Landry','Leann','','','','34','458918307','8392 ABBEY RD',0,'NORTH ROYALTON','OH','44133','1131','CY','39035','1979-09-24','F','U',':RET:2106-3','N','021','DEN','3330006','99734OH005000401','2014-04-01','2014-03-08 10:05:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-08 21:30:07'),(6142,4871,'Y','18','021','EC','A','','','AC','0000516871','0000516871','OH00000383358','IL','1','ARLEDGE','RANDALL','PATRICK','','','34','293623667','3771 HENDERSON RD',0,'columbus','OH','43220',NULL,'CY','39049','1958-09-30','M','U',':RET:2106-3','N','021','DEN','131264','99734OH005000301','2014-01-01','2013-11-21 11:54:20','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:16:18'),(5103,4044,'Y','18','021','EC','A','','','AC','0000614928','0000614928','TX00000403066','IL','1','Munoz','Santa','','','','34','643825774','504 S OLIVE St',0,'Kermit','TX','79745',NULL,'CY','48495','1970-11-13','F','M',':RET:2106-3','N','021','DEN','1640825','33348TX002000201','2014-01-01','2013-12-19 17:03:52','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:01:29'),(4659,3694,'Y','18','021','EC','A','','','AC','0001041185','0001041185','LA00000465405','IL','1','arceneaux','patrick','','','','34','435351494','12459 Arceneaux Lane',0,'Geismar','LA','70734',NULL,'CY','22005','1965-02-28','M','U',':RET:2106-3','N','021','DEN','791241','18575LA002000201','2014-01-01','2013-12-12 11:01:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:07:19'),(22599,18050,'Y','18','021','EC','A','','','AC','0000218874','0000218874','OH00001631974','IL','1','MAYS','SHARON','','','','34','291628246','6839 BEECHWOOD RD',0,'HILLSBORO','OH','45133','8450','CY','39071','1960-09-17','F','M',NULL,'N','021','HLT','2895812','92036OH002000601','2014-03-01','2014-02-10 13:51:10','853.00',NULL,NULL,'1137.39','284.39','R-OH005','OH0','505.73',NULL,0,'2014-02-10 21:32:14'),(13155,10494,'Y','18','021','EC','A','','','AC','0001086785','0001086785','OH00001024839','IL','1','Buis','Darell','L','','','34','300546095','350 WILLOW LN',0,'HARRISON','OH','45030','1488','CY','39061','1952-05-22','M','M',':RET:2106-3','N','021','DEN','2321892','99734OH005000401','2014-01-01','2013-12-23 17:29:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:41'),(22412,17895,'Y','18','021','EC','A','','','AC','0001924755','0001924755','LA00002188790','31','1','MIMS','HARVEY','','','','34','439199908','5131 UNDY RD',0,'NEW ORLEANS','LA','70127',NULL,'CY','22071','1974-01-02','M','U',':RET:2054-5','N','021','DEN','2650922','18575LA002000201','2014-03-01','2014-02-10 10:42:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:26'),(7432,5882,'Y','18','021','EC','A','','','AC','0000356029','0000356029','OH00001267477','31','1','Deiters','Helen','','','','34','233906470','683 VALLEY CREST DR',0,'AKRON','OH','44319','4260','CY','39153','1954-05-18','F','M',':RET:2106-3','T','021','HLT','732165','52664OH151001305','2014-01-01','2013-12-14 19:15:06','895.00',NULL,NULL,'1187.84','292.84','R-OH012','OH0','667.56',NULL,0,'2013-12-26 02:30:11'),(14602,11655,'Y','18','021','EC','A','','','AC','0000111903','0000111903','OH00000827222','IL','1','GRANDSTAFF','BENJAMIN','R','','','34','277542598','1345 TOWNSHIP RD 206',0,'MARENGO','OH','43334',NULL,'CY','39117','1953-05-14','M','M',':RET:2106-3','N','021','DEN','1686067','99734OH005000301','2014-02-01','2013-12-27 11:42:17','0.00',NULL,NULL,'42.26','42.26','R-OH008','OH0','0.00',NULL,0,'2013-12-28 03:36:26'),(14519,11584,'Y','18','021','EC','A','','','AC','0000443433','0000443433','TX00000837792','IL','1','Williams','LaSanya','','','','34','459531746','16104 COUNTY ROAD 4325',0,'LARUE','TX','75770','4328','CY','48213','1965-05-10','F','U',':RET:2054-5','N','021','DEN','2098998','33348TX002000201','2014-02-01','2013-12-27 16:26:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:34:15'),(2029,1662,'Y','18','021','EC','A','','','AC','0001139486','0001139486','OH00001314491','IL','1','Warren','Everett','','','','34','288508526','4750 Tahiti Dr.',0,'Akron','OH','44319',NULL,'CY','39153','1951-01-31','M','M',':RET:2106-3','N','021','HLT','45191','52664OH152000901','2014-01-01','2013-12-10 16:32:58','876.00',NULL,NULL,'951.46','75.46','R-OH012','OH0','469.28',NULL,0,'2013-12-25 19:15:18'),(9056,7185,'Y','18','021','EC','A','','','AC','0000685333','0000685333','TX00000993664','IL','1','ODELSON','LINDA','','','','34','147463618','100 PROSPECTOR PASS',0,'GEORGETOWN','TX','78633','4893','CY','48491','1951-09-03','F','M',':RET:2106-3','N','021','DEN','2469556','33348TX002000101','2014-01-01','2013-12-17 22:18:43','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 04:06:11'),(6130,4861,'N','01','021','EC','A',NULL,NULL,'','0000470446','0000851920','','IL','1','Hornecker','Tara','','','','34','450457323','6118 ADIRONDACK TRL',0,'AMARILLO','TX','79106','3404','CY','48375','1970-07-03','F','',':RET:2106-3','N','021','DEN','356423','33348TX002000201','2014-01-01','2013-11-21 17:40:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:15:58'),(23689,18865,'Y','18','021','EC','A','','','AC','0000234097','0000234097','OH00002536844','IL','1','LaPointe','Martha','','','','34','284761746','1032 WOOSTER RD W',0,'BARBERTON','OH','44203','7145','CY','39153','1965-03-14','F','U',':RET:2106-3','T','021','DEN','3849392','99734OH005000401','2014-03-01','2014-02-13 20:24:19','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:36'),(20389,16287,'N','01','021','EC','A',NULL,NULL,'','0000094900','0000585676','','IL','1','Holub','Elena','','','','34','460825617','1132 FM 1890',0,'Colubus','TX','78934',NULL,'CY','48089','1964-05-24','F','',NULL,'N','021','DEN','3042843','33348TX002000201','2014-03-01','2014-01-29 11:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:14'),(603,496,'Y','18','021','EC','A','','','AC','0000242689','0000242689','OH00000969716','31','1','Sullivan','Judith','','','','34','281382982','1385 TIMSHEL ST',0,'DAYTON','OH','45440','3964','CY','39057','1949-08-06','F','M',':RET:2106-3','N','021','DEN','1594217','99734OH005000401','2014-01-01','2013-12-16 07:05:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:00:22'),(15741,12592,'Y','18','021','EC','A','','','AC','0000024652','0000024652','TX00001868311','IL','1','Austin','Michelle','','','','34','454392682','203 S 31ST ST',0,'TEMPLE','TX','76504','4072','CY','48027','1964-02-08','F','M',':RET:2054-5','N','021','DEN','1732972','33348TX002000201','2014-02-01','2014-01-02 12:15:33','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-03 02:00:49'),(14907,11909,'Y','18','021','EC','A','','','AC','0000783663','0000783663','MS00001547971','IL','1','Rice','Darius','','','','34','587611383','995 N AZALEA DR',0,'MADISON','MS','39110','8581','CY','28089','1982-10-16','M','U',':RET:2054-5','N','021','DEN','2168348','46300MS002000201','2014-02-01','2013-12-29 15:35:52','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-30 00:01:20'),(28607,22641,'Y','18','024','14','A','','','TE','0000927284','0000927284','','IL','1','miller','randy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-22','M','',NULL,NULL,NULL,'','558732','','2014-03-31','2014-03-08 14:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-08 21:30:13'),(22801,18200,'Y','18','021','EC','A','','','AC','0000356070','0000356070','OH00001984432','IL','1','Beshah','Brook','','','','34','220617332','725 DIANDREA DR',0,'FAIRLAWN','OH','44333','2906','CY','39153','1956-08-02','M','M',':RET:2054-5','N','021','DEN','3675876','99734OH005000301','2014-03-01','2014-02-11 13:09:10','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2014-02-11 21:01:53'),(17623,14089,'Y','18','021','EC','A','','','AC','0000460636','0000460636','TX00001871258','IL','1','MARTINEZ','MARIA','','','','34','642586839','812  ROYAL HILL LANE',0,'ARLINGTON','TX','77614',NULL,'CY','48351','1955-12-24','F','U',NULL,'N','021','DEN','1980975','33348TX002000201','2014-02-01','2014-01-13 14:10:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:28'),(9214,7309,'Y','18','021','EC','A','','','AC','0000600438','0000600438','MS00000733226','IL','1','Cole','Brenda','','','','34','587542448','111 PARKSIDE DR',0,'BRANDON','MS','39042','4214','CY','28121','1951-11-19','F','U',':RET:2106-3','N','021','DEN','2521780','46300MS002000201','2014-01-01','2013-12-18 18:20:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:09:59'),(6122,4855,'Y','18','021','EC','A','','','AC','0000111712','0000111712','TX00000912597','IL','1','Yuen','Walton','','','','34','576821873','10737 QUARRY OAKS TRL',0,'AUSTIN','TX','78717','4437','CY','48491','1965-06-30','M','M',':RET:2034-7','N','021','DEN','322612','33348TX002000201','2014-01-01','2013-11-20 22:04:22','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 00:15:46'),(17413,13936,'Y','18','021','EC','A','','','AC','0000114215','0000114215','OH00001805561','IL','1','McIver','Steven','','','','34','309527453','746 BIRCHWOOD DR',0,'GREENVILLE','OH','45331','2493','CY','39037','1950-11-06','M','U',NULL,'N','021','HLT','1657093','92036OH002000501','2014-02-01','2014-01-10 10:12:16','390.00',NULL,NULL,'810.35','420.35','R-OH003','OH0','810.35',NULL,0,'2014-01-13 03:00:23'),(4119,3290,'N','19','021','EC','A',NULL,NULL,'','0000309426','0000011146','','IL','1','Cipro','Romualdo','','','III','34','272069939','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2000-11-26','M','',':RET:2106-3','N','021','DEN','1795221','99734OH005000301','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:09'),(17006,13612,'Y','18','021','EC','A','','','AC','0000762309','0000762309','OH00000754973','IL','1','Singer','Andrew','Jason','','','34','296846535','1538 Polk Dr',0,'Brunswick','OH','44212',NULL,'CY','39103','1986-08-27','M','U',':RET:2106-3','N','021','DEN','2484901','99734OH005000301','2014-02-01','2014-01-09 11:40:43','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:20:34'),(8813,6986,'N','01','021','EC','A',NULL,NULL,'','0000111881','0000828222','','IL','1','Hicks','Sandra','','','','34','289684847','988 CLEPPER LN',0,'BATAVIA','OH','45103','2318','CY','39025','1960-09-29','F','',':RET:2106-3','N','021','HLT','2085621','92036OH004000601','2014-01-01','2013-12-17 18:32:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','352.13',NULL,0,'2013-12-26 04:00:04'),(6742,5348,'Y','18','021','EC','A','','','AC','0000021352','0000021352','OH00000259210','IL','1','Skillen','Traci','','','','34','288469247','2865 FORESTVIEW AVE',0,'ROCKY RIVER','OH','44116','3305','CY','39035','1964-07-13','F','U',NULL,'N','021','HLT','158786','52664OH151001305','2014-01-01','2013-11-25 13:23:43','213.00',NULL,NULL,'429.09','216.09','R-OH011','OH0','429.09',NULL,0,'2013-12-26 01:15:48'),(29136,23066,'Y','18','021','EC','A','','','AC','0000754634','0000754634','OH00003090682','IL','1','Nisch','Ronald','','','','34','297444556','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','1959-01-13','M','M',':RET:2106-3','N','021','HLT','4316538','92036OH003002705','2014-04-01','2014-03-10 17:13:13','536.00',NULL,NULL,'787.05','251.05','R-OH006','OH0','454.11',NULL,0,'2014-03-10 21:02:40'),(26713,21175,'Y','18','021','EC','A','','','AC','0001122369','0001122369','MS00002954420','IL','1','TAYLOR','THAWANN','','','','34','426497466','5610 Shaw Rd.',0,'Jackson','MS','39209',NULL,'CY','28049','1984-02-19','F','U',':RET:2054-5','N','021','DEN','3456017','46300MS002000201','2014-03-01','2014-02-27 21:45:57','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 21:31:39'),(7990,6325,'Y','18','021','EC','A','','','AC','0000563130','0000563130','OH00000743842','IL','1','Hockstra','Steven','','','','34','216887989','3170 BENT OAK TRL',0,'RAVENNA','OH','44266','8285','CY','39133','1976-03-24','M','M',NULL,'N','021','HLT','2591260','52664OH151001304','2014-01-01','2013-12-20 15:06:03','412.00',NULL,NULL,'831.82','419.82','R-OH012','OH0','276.08',NULL,0,'2013-12-26 03:08:10'),(26284,20849,'Y','18','021','EC','A','','','AC','0002047878','0002047878','LA00003029977','IL','1','SHARP','BRANDON','','','','34','433691120','16497 WARDLINE RD',0,'COVINGTON','LA','70435',NULL,'CY','22103','1980-11-23','M','M',':RET:2106-3','N','021','DEN','3299432','18575LA002000101','2014-04-01','2014-02-27 11:08:23','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-02-28 06:31:21'),(25877,20517,'Y','18','021','EC','A','','','AC','0001427552','0001427552','LA00003076377','IL','1','Edwards','Spencer','','','','34','431691331','424 Eliza St',0,'New Orleans','LA','70114',NULL,'CY','22071','1973-04-02','M','U',':RET:2106-3','N','021','DEN','3032112','18575LA002000201','2014-04-01','2014-02-26 17:35:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:55'),(25270,20049,'Y','18','021','EC','A','','','AC','0001322540','0001322540','LA00002762610','IL','1','ATTAWAY','VICKI','','','','34','436861952','7423 whispering pine drive',0,'shrevport','LA','71129',NULL,'CY','22017','1950-11-07','F','M',NULL,'N','021','DEN','3046138','18575LA002000201','2014-04-01','2014-02-25 13:19:32','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61','CIC',0,'2014-02-25 21:00:11'),(24293,19294,'Y','18','024','14','A','','','TE','0000664185','0000664185','','IL','1','COHEN','MICHELLE','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-12-03','F','',NULL,NULL,NULL,'','1488564','','2014-03-31','2014-02-18 11:21:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:14'),(17677,14126,'Y','18','021','EC','A','','','AC','0002243476','0002243476','LA00001476440','IL','1','Jones','Milton','','','','34','433064477','2200 Oretha Castle Haley Blvd',0,'New Orleans','LA','70113',NULL,'CY','22071','1958-02-20','M','R',':RET:2054-5','T','021','DEN','1435056','18575LA002000101','2014-02-01','2014-01-13 13:20:45','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-14 01:32:52'),(17609,14076,'Y','18','021','EC','A','','','AC','0001026945','0001026945','TX00001607228','IL','1','Pundt','Mary','Evelyn','','','34','458966641','904 LIBOLD DR',0,'DEVINE','TX','78016','2036','CY','48325','1952-12-20','F','M',':RET:2106-3','N','021','DEN','2580660','33348TX002000201','2014-02-01','2014-01-13 00:18:47','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-14 01:32:20'),(14394,11480,'N','19','021','EC','A',NULL,NULL,'','0000382170','0000869289','','IL','1','WALDROP','ABBY','','','','34','272082778','3291 BRENTWOOD CT',0,'POWELL','OH','43065','9134','CY','39041','2002-10-09','F','',NULL,'N','021','DEN','2537519','99734OH005000401','2014-02-01','2013-12-27 15:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:31:05'),(16737,13391,'N','19','021','EC','A',NULL,NULL,'','0000674079','0001081816','','S1','1','Ferrari','Anthony','L','','','34','275024959','1705 ARNDALE RD',0,'STOW','OH','44224','1850','CY','39153','1997-02-26','M','',':RET:2106-3','N','021','HLT','1624945','52664OH151001305','2014-02-01','2014-01-06 20:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:51'),(1871,1527,'Y','18','021','EC','A','','','AC','0000524495','0000524495','OH00001513344','IL','1','Vansickle','Deborah','','','','34','270502843','3313 PARNELL DR',0,'AKRON','OH','44319','1668','CY','39153','1950-10-18','F','M',':RET:2106-3','T','021','HLT','1609429','52664OH152000901','2014-01-01','2013-12-24 15:26:21','317.00',NULL,NULL,'554.51','237.51','R-OH012','OH0','554.51',NULL,0,'2013-12-25 18:58:18'),(6062,4803,'Y','18','021','EC','A','','','AC','0001242939','0001242939','OH00001310652','IL','1','Gardner','Elise','','','','34','271860040','1231 ORTEGO DR',0,'FAIRBORN','OH','45324','5734','CY','39057','1985-10-23','F','U',NULL,'N','021','DEN','394793','99734OH005000401','2014-01-01','2013-12-01 09:59:44','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:01:59'),(27882,22056,'N','19','021','EC','A',NULL,NULL,'','0000063765','0001147404','','IL','1','Garver','Madison','','','','34','285026438','1371 ADAK AVE',0,'LIMA','OH','45805','3901','CY','39003','1997-09-24','F','',':RET:2106-3','N','021','HLT','3510168','92036OH005001505','2014-04-01','2014-03-05 11:06:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-03-05 21:32:33'),(26782,21225,'N','01','021','EC','A',NULL,NULL,'','0000605853','0001228274','','IL','1','Guerrero','Maria','G','','','34','469576374','2414 CRIMSON AVE',0,'MISSION','TX','78574','2245','CY','48215','1975-02-09','F','',NULL,'N','021','DEN','2700866','33348TX002000201','2014-04-01','2014-03-01 10:26:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-01 21:00:13'),(13740,10967,'Y','18','021','EC','A','','','AC','0001220837','0001220837','OH00001132572','IL','1','witt','deborah','','','','34','286629709','2062 ROLLING MEADOWS LN',0,'AKRON','OH','44312','4961','CY','39153','1956-12-27','F','M',':RET:2106-3','N','021','HLT','2000018','52664OH151001306','2014-01-01','2013-12-23 19:02:29','250.00',NULL,NULL,'543.47','293.47','R-OH012','OH0','543.47',NULL,0,'2013-12-26 13:09:38'),(23667,18844,'N','19','021','EC','A',NULL,NULL,'','0000373319','0000246071','','IL','1','Lopez','Jacob','Jun-ide','','','34','645026726','9329 JUANCHIDO LN',0,'YSLETA DEL SUR PUEBLO','TX','79907','6831','CY','48141','2006-05-05','M','',':RET:1002-5','N','021','DEN','3532953','33348TX002000201','2014-03-01','2014-02-14 13:14:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-14 21:30:22'),(22455,17928,'Y','18','021','EC','A','','','AC','0001234385','0001234385','TX00002576362','IL','1','Sackor','Hadja','','','','34','644904654','6714 de moss',0,'Houston','TX','77074',NULL,'CY','48201','1982-12-30','F','M',NULL,'N','021','DEN','3014343','33348TX002000201','2014-03-01','2014-02-10 15:02:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-10 21:30:49'),(2518,2053,'Y','18','021','EC','A','','','AC','0000639496','0000639496','OH00001119761','IL','1','laurie','jamie','','','','34','286845121','421 HIGH ST',0,'DOYLESTOWN','OH','44230','1360','CY','39169','1985-09-28','F','U',':RET:2106-3','N','021','HLT','1035658','52664OH152000901','2014-01-01','2013-12-09 01:08:59','166.00',NULL,NULL,'177.55','11.55','R-OH014','OH0','177.55',NULL,0,'2013-12-25 19:36:30'),(27976,22133,'Y','18','021','EC','A','','','AC','0001815626','0001815626','LA00002646264','IL','1','MARTINEZ','NORMA','YAMILETH','','','34','435817231','3820 E LOUISIANA STATE DR',0,'KENNER','LA','70065','2508','CY','22051','1959-10-11','F','U',':RET:2106-3','N','021','DEN','3734939','18575LA002000201','2014-04-01','2014-03-06 13:22:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:53'),(17591,14061,'Y','18','021','EC','A','','','AC','0000661369','0000661369','OH00002351802','IL','1','Marshall','Nora','','','','34','269602017','4235 U.S. Route 127 South',0,'Greenville','OH','45331',NULL,'CY','39037','1956-12-02','F','M',':RET:2106-3','N','021','HLT','1459916','92036OH003000505','2014-02-01','2014-01-12 18:31:49','1080.00',NULL,NULL,'1251.15','171.15','R-OH003','OH0','604.97',NULL,0,'2014-01-14 01:32:10'),(17015,13617,'Y','18','024','14','A','','','TE','0000472274','0000472274','','IL','1','ROZACK','AUDREY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-21','F','',NULL,NULL,NULL,'','2125264','','2014-01-09','2014-01-09 08:48:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:20:38'),(9180,7281,'Y','18','021','EC','A','','','AC','0000981604','0000981604','OH00000950081','IL','1','LUNSFORD','JUDITH','','','','34','293469940','12353 ROAD R',0,'COLUMBUS GROVE','OH','45830','9778','CY','39137','1951-06-23','F','U',':RET:2106-3','T','021','HLT','1915396','92036OH005001505','2014-01-01','2013-12-18 12:02:13','590.00',NULL,NULL,'727.15','137.15','R-OH002','OH0','727.15',NULL,0,'2013-12-26 04:09:09'),(15975,12785,'Y','18','021','EC','A','','','AC','0000023633','0000023633','TX00001888469','31','1','BARNES','PAUL','ANTHONY','','','34','451270196','P.O. BOX',0,'TIMPSON','TX','75975',NULL,'CY','48419','1963-11-13','M','M',':RET:2054-5','T','021','DEN','1988891','33348TX002000201','2014-02-01','2014-01-02 22:53:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:00:44'),(5167,4098,'Y','18','024','14','A','','','TE','0000817528','0000817528','','IL','1','SPENCE','JEREMY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-05','M','',NULL,NULL,NULL,'','2371668','','2013-12-19','2013-12-19 10:57:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:13'),(2099,1720,'Y','18','021','EC','A','','','AC','0000242689','0000242689','OH00000365173','31','1','Sullivan','Judith','','','','34','281382982','1385 TIMSHEL ST',0,'DAYTON','OH','45440','3964','CY','39057','1949-08-06','F','M',':RET:2106-3','N','021','DEN','340740','99734OH005000401','2014-01-01','2013-12-09 20:26:18','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:06'),(18945,15095,'Y','18','021','EC','A','','','AC','0000758335','0000758335','TX00001693861','IL','1','Jefferson','Larry','','','','34','463118328','507 MARTINDALE DR',0,'LANCASTER','TX','75146','3140','CY','48113','1950-02-18','M','M',':RET:2054-5','N','021','DEN','2418478','33348TX002000201','2014-03-01','2014-01-17 10:34:21','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-20 08:05:45'),(26433,20965,'Y','18','024','14','A','','','TE','0000251660','0000251660','','IL','1','Figley','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-10-08','M','',NULL,NULL,NULL,'','3376447','','2014-02-27','2014-02-27 11:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:30:17'),(20196,16116,'Y','18','021','EC','A','','','AC','0001090011','0001090011','MS00001363974','IL','1','perkins','willie','','','','34','408157183','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','1970-09-15','F','R',':RET:2054-5','N','021','DEN','3156092','46300MS002000101','2014-03-01','2014-01-27 10:50:58','0.00',NULL,NULL,'101.40','101.40','R-MS001','MS0','27.15',NULL,0,'2014-01-27 21:01:29'),(17938,14332,'Y','18','021','EC','A','','','AC','0000632476','0000632476','TX00002354507','IL','1','Wendt','Katie','','','','34','455939661','1122 Jackson St.',0,'Dallas','TX','75202',NULL,'CY','48113','1979-12-04','F','U',':RET:2106-3','N','021','DEN','2287562','33348TX002000201','2014-02-01','2014-01-14 15:08:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:38'),(2866,2316,'Y','18','021','EC','A','','','AC','0000936027','0000936027','OH00000317761','IL','1','yeager','robert','','','','34','298469758','2373 euclid rd.',0,'new london','OH','44851',NULL,'CY','39077','1950-09-27','M','M',NULL,'N','021','HLT','556899','92036OH004002701','2014-01-01','2013-11-01 21:01:59','459.46',NULL,NULL,'462.84','3.38','R-OH006','OH0','462.84',NULL,0,'2013-12-25 20:01:46'),(26531,21039,'Y','18','024','14','A','','','TE','0001408570','0001408570','','IL','1','mills','jacob','carl',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-02','M','',NULL,NULL,NULL,'','2345458','','2014-03-31','2014-02-28 17:42:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 21:00:28'),(4873,3864,'Y','18','021','EC','A','','','AC','0000482849','0000482849','TX00000537261','IL','1','Slowik','Anthony','','','','34','453559871','705 LISA DR',0,'AUSTIN','TX','78733','2422','CY','48453','1967-05-20','M','U',NULL,'N','021','DEN','458642','33348TX002000101','2014-01-01','2013-10-10 07:52:22','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 22:31:04'),(28725,22733,'N','01','021','EC','A',NULL,NULL,'','0001751453','0001679980','','IL','1','Kern','Mamie','Bevery','','','34','434411430','4108 W PARK AVE',0,'GRAY','LA','70359','3202','CY','22109','1962-07-15','F','',':RET:2106-3','T','021','DEN','4269266','18575LA002000101','2014-04-01','2014-03-08 18:03:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-03-09 20:59:59'),(1213,996,'N','01','021','EC','A',NULL,NULL,'','0000290762','0000790845','','IL','1','DOGGETT','CHRISTOPHER','L','','','34','284485259','1849 BLEDSOE DR',0,'BELLBROOK','OH','45305','1316','CY','39057','1951-07-02','M','',':RET:2106-3','N','021','HLT','957167','92036OH005000501','2014-01-01','2013-12-02 21:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','682.93',NULL,0,'2013-12-25 18:20:09'),(2250,1847,'Y','18','021','EC','A','','','AC','0001175689','0001175689','OH00000031008','IL','1','arnold','daniel','','','','34','299727849','3046 w 46',0,'cleveland','OH','44102',NULL,'CY','39035','1970-05-22','M','U',':RET:2106-3','N','021','DEN','767716','99734OH005000301','2014-01-01','2013-12-08 18:45:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:30:05'),(6739,5346,'Y','18','021','EC','A','','','AC','0000687192','0000687192','OH00001124116','IL','1','Ferrell','Barbara','','','','34','294728924','2249 E MARKET ST',0,'AKRON','OH','44312','1244','CY','39153','1964-09-01','F','U',':RET:2106-3','N','021','HLT','834236','52664OH151001304','2014-01-01','2013-11-25 11:16:42','163.00',NULL,NULL,'380.45','217.45','R-OH012','OH0','380.45',NULL,0,'2013-12-26 01:15:43'),(14695,11733,'Y','18','021','EC','A','','','AC','0001105545','0001105545','OH00001388555','IL','1','Hess','Joshua','','','','34','295842376','5221 LEONA DR',0,'CINCINNATI','OH','45238','3727','CY','39061','1976-09-14','M','M',':RET:2106-3','N','021','DEN','1709837','99734OH005000401','2014-02-01','2013-12-27 22:33:59','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:08:55'),(13867,11063,'Y','18','021','EC','A','','','AC','0000915648','0000915648','OH00000243623','IL','1','Averill','Paul','Irving','','','34','287482662','2697 8TH ST',0,'CUYAHOGA FALLS','OH','44221','2413','CY','39153','1949-04-22','M','U',':RET:2106-3','N','021','HLT','1952776','52664OH151001501','2014-01-01','2013-12-23 10:00:37','500.00',NULL,NULL,'802.38','302.38','R-OH012','OH0','802.38',NULL,0,'2013-12-26 13:12:56'),(3890,3115,'N','19','021','EC','A',NULL,NULL,'','0000021368','0001245579','','IL','1','Hartezell','Shelby','Francis','','','34','287949150','2901 perrydale st.nw',0,'greentown','OH','44630',NULL,'CY','39151','1991-11-29','F','',':RET:2106-3','N','021','HLT','19180','52664OH152000901','2014-01-01','2013-12-13 12:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2013-12-25 21:36:40'),(24670,19580,'N','01','021','EC','A',NULL,NULL,'','0000149395','0000664234','','IL','1','Schulte','Andrew','','','','34','293646397','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1973-05-08','M','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.07',NULL,0,'2014-02-20 04:27:04'),(9317,7387,'Y','18','021','EC','A','','','AC','0001794477','0001794477','LA00001284418','IL','1','Williams','W   Keith','','','','34','280546469','900 Richsmith Ln',0,'Hammond','LA','70403',NULL,'CY','22105','1953-07-01','M','U',':RET:2106-3','N','021','DEN','2413835','18575LA002000101','2014-01-01','2013-12-21 12:37:46','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 04:30:24'),(14144,11274,'Y','18','021','EC','A','','','AC','0002036740','0002036740','LA00001732423','IL','1','Kandous','Jehad','','','','34','157703518','309 SERPAS DR',0,'ARABI','LA','70032','1840','CY','22087','1975-05-03','M','M',NULL,'T','021','DEN','1974517','18575LA002000201','2014-02-01','2013-12-26 12:36:58','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:44'),(14419,11500,'Y','18','021','EC','A','','','AC','0000689561','0000689561','TX00001551294','IL','1','Mirelez','David','','','','34','450158425','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1963-05-22','M','M',NULL,'N','021','DEN','1727826','33348TX002000101','2014-02-01','2013-12-27 10:33:47','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:39'),(7145,5669,'Y','18','021','EC','A','','','AC','0000310488','0000310488','TX00001368000','IL','1','atanda-salau','athinas','','','','34','160820936','2723 whitinham drive',0,'houston','TX','77067',NULL,'CY','48201','1985-02-25','F','U',':RET:2054-5','N','021','DEN','2244432','33348TX002000101','2014-01-01','2013-12-24 23:46:04','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:52:01'),(27269,21593,'Y','18','021','EC','A','','','AC','0001420960','0001420960','LA00002703598','IL','1','LOUIS','ANTHONY','','','','34','434191728','3813 HIGHWAY 14',0,'NEW IBERIA','LA','70560','9436','CY','22045','1958-11-04','M','U',NULL,'N','021','DEN','3876523','18575LA002000101','2014-04-01','2014-03-04 16:01:44','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-04 21:00:15'),(7111,5641,'Y','18','021','EC','A','','','AC','0001220844','0001220844','LA00000899209','IL','1','Creppel','Bryson','','','','34','439611003','1601 E BAYOU RD',0,'DONALDSONVILLE','LA','70346','4314','CY','22005','1984-11-02','M','U',':RET:2106-3','N','021','DEN','2041993','18575LA002000101','2014-01-01','2013-12-24 22:07:42','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 01:51:02'),(9685,7671,'Y','18','021','EC','A','','','AC','0000437967','0000437967','OH00000075565','IL','1','caldwell','keith',NULL,NULL,NULL,NULL,NULL,'7692 BAYSHORE',0,'MASON','OH','45040','8613','CY','39165','1959-04-30','M','M',':RET:2054-5','N','021','HLT','1616219','92036OH001001201','2014-01-01','2013-12-21 12:03:13','335.00',NULL,NULL,'1105.68','770.68','R-OH004','OH0','552.84',NULL,0,'2013-12-26 04:39:33'),(19995,15950,'Y','18','021','EC','A','','','AC','0000257154','0000257154','OH00002201190','IL','1','slone','debra','','','','34','295582496','5491 HIGH POINT RD',0,'GLENFORD','OH','43739','9727','CY','39127','1956-05-18','F','M',':RET:2106-3','N','021','DEN','3124360','99734OH005000401','2014-03-01','2014-01-26 18:02:13','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-01-26 19:00:02'),(17942,14336,'Y','18','021','EC','A','','','AC','0000093565','0000093565','TX00001400897','IL','1','NGUYEN','KIMBINH','T','','','34','638545291','6846 CELES MEADOW DR',0,'CONVERSE','TX','78109','3468','CY','48029','1976-01-13','F','U',':RET:2047-9','N','021','DEN','2192718','33348TX002000201','2014-02-01','2014-01-14 15:42:32','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:40'),(3907,3125,'Y','18','021','EC','A','','','AC','0001096738','0001096738','OH00000580906','IL','1','TESSONE','NANCY','','','','34','353448995','717 CASTALIA ST',0,'BELLEVUE','OH','44811','1122','CY','39077','1950-10-26','F','R',':RET:2106-3','N','021','HLT','54257','92036OH005002701','2014-01-01','2013-12-13 09:03:17','0.00',NULL,NULL,'575.62','575.62','R-OH006','OH0','575.62',NULL,0,'2013-12-25 21:36:58'),(7752,6140,'Y','18','024','14','A','','','TE','0000313227','0000313227','','IL','1','Sawatsky','Will',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-28','M','',NULL,NULL,NULL,'','692480','','2013-12-20','2013-12-20 16:27:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:33'),(14124,11257,'Y','18','021','EC','A','','','AC','0001021475','0001021475','OH00001358155','IL','1','Wilson','Jeffrey','','','','34','302544910','1502 CHARLES ST',0,'PORTSMOUTH','OH','45662','4636','CY','39145','1951-11-07','M','U',':RET:2106-3','N','021','DEN','1523212','99734OH005000401','2014-02-01','2013-12-26 17:38:52','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-27 02:02:11'),(6589,5224,'Y','18','021','EC','A','','','AC','0000540742','0000540742','TX00000161439','IL','1','Baker','Sara','','','','34','224663322','1002 W Pearl',0,'Granbury','TX','76048',NULL,'CY','48221','1954-03-04','F','M',':RET:2106-3','N','021','DEN','1187016','33348TX002000101','2014-01-01','2013-12-10 22:22:52','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 00:53:12'),(6411,5081,'Y','18','021','EC','A','','','AC','0000607130','0000607130','OH00001218802','IL','1','Motto','Irene','','','','34','282529162','4655 LINDA LN',0,'SHEFFIELD VILLAGE','OH','44054','2725','CY','39093','1952-10-21','F','M',':RET:2106-3','N','021','HLT','873566','92036OH005000804','2014-01-01','2013-12-11 11:11:05','312.00',NULL,NULL,'656.99','344.99','R-OH011','OH0','656.99',NULL,0,'2013-12-26 00:48:37'),(22146,17677,'Y','18','021','EC','A','','','AC','0000622527','0000622527','OH00001509521','IL','1','Grisel','Andrew','','','','34','296948969','38155 STATE ROUTE 303',0,'GRAFTON','OH','44044','9013','CY','39093','1992-06-01','M','U',':RET:2106-3','N','021','HLT','3058523','52664OH151001305','2014-03-01','2014-02-08 10:17:21','100.00',NULL,NULL,'251.52','151.52','R-OH011','OH0','251.52',NULL,0,'2014-02-08 19:00:51'),(20652,16503,'Y','18','021','EC','A','','','AC','0000091267','0000091267','TX00001691526','IL','1','garcia','nancy','','','','34','627185738','3503 S URBAHN AVE',0,'LAREDO','TX','78046','7142','CY','48479','1989-03-30','F','U',NULL,'T','021','DEN','2762229','33348TX002000201','2014-03-01','2014-01-30 15:47:32','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-30 21:00:39'),(23835,18965,'N','19','021','EC','A',NULL,NULL,'','0000775131','0001219636','','IL','1','KEHLING','JESSICA','ANN','','','34','272042091','1167 BISHOP AVE',0,'HAMILTON','OH','45015','2165','CY','39017','1998-09-30','F','',':RET:2106-3','N','021','HLT','3243040','92036OH003001205','2014-03-01','2014-02-13 20:39:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-14 21:31:49'),(16484,13192,'Y','18','021','EC','A','','','AC','0000209652','0000209652','OH00002145606','IL','1','BADER','NORMA','','','','34','271845164','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','1977-07-03','F','U',NULL,'N','021','HLT','2166183','92036OH004000801','2014-02-01','2014-01-06 14:09:48','241.00',NULL,NULL,'470.00','229.00','R-OH011','OH0','231.24',NULL,0,'2014-01-07 04:06:21'),(23015,18350,'Y','18','021','EC','A','','','AC','0002062742','0002062742','LA00001924104','IL','1','CRUZ POSAS','DANNY','','','','34','872245606','15095 OLD SPANISH TRAIL',0,'PARADIS','LA','70080',NULL,'CY','22089','1981-04-28','M','M',NULL,'N','021','DEN','3780205','18575LA002000101','2014-03-01','2014-02-12 10:38:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-12 21:30:26'),(15089,12061,'Y','18','021','EC','A','','','AC','0000670264','0000670264','OH00001948515','IL','1','Hanford','Tiffany','','','','34','308882178','7129 Summit Avenue',0,'Cincinnati','OH','45243',NULL,'CY','39061','1979-05-17','F','U',':RET:2106-3','N','021','DEN','2198855','99734OH005000301','2014-02-01','2013-12-29 19:17:53','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:04:25'),(1519,1267,'Y','18','021','EC','A','','','AC','0000805119','0000805119','OH00001209688','IL','1','Reeves','Dolf','','','','34','270464154','8766 MORGANS RUN',0,'OLMSTED FALLS','OH','44138','3242','CY','39035','1949-07-06','M','U',':RET:2106-3','N','021','DEN','1394050','99734OH005000401','2014-01-01','2013-12-24 14:51:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:44'),(2110,1730,'Y','18','021','EC','A','','','AC','0000788175','0000788175','OH00000705716','IL','1','lowe','donald','j','','','34','280543846','305 S RIDGE AVE',0,'TROY','OH','45373','3011','CY','39109','1954-02-10','M','U',':RET:2106-3','N','021','DEN','361944','99734OH005000401','2014-01-01','2013-12-10 10:39:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:24'),(29055,22996,'Y','18','021','EC','A','','','AC','0000134640','0000134640','OH00003380192','IL','1','stinson','kevin','matthew','','','34','294608403','4401 THORNBERRY DR',0,'COLUMBUS','OH','43231','6192','CY','39049','1967-12-09','M','U',':RET:2054-5','N','021','DEN','3847927','99734OH005000401','2014-04-01','2014-03-10 15:21:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:01:48'),(26753,21202,'Y','18','024','14','A','','','TE','0000311547','0000311547','','IL','1','harrison','victor',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-22','M','',NULL,NULL,NULL,'','2477657','','2014-03-31','2014-03-01 00:27:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-01 19:00:04'),(16290,13041,'Y','18','021','EC','A','','','AC','0000979310','0000979310','OH00000092056','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','DEN','1898071','99734OH005000401','2014-02-01','2014-01-06 17:02:50','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-01-07 04:00:48'),(26549,21049,'N','19','021','EC','A',NULL,NULL,'','0000858541','0001050694','','IL','1','Barnette','Benjamin','','','','34','282064841','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2001-06-12','M','',':RET:2106-3','N','021','DEN','3004039','99734OH005000301','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:12'),(20178,16102,'Y','18','021','EC','A','','','AC','0000929862','0000929862','OH00002444035','IL','1','Weber','Helen','','','','34','275545464','726 KEEN AVE',0,'ASHLAND','OH','44805','3629','CY','39005','1950-08-06','F','U',':RET:2106-3','N','021','HLT','2993384','52664OH151001305','2014-03-01','2014-01-27 14:58:02','592.00',NULL,NULL,'658.32','66.32','R-OH012','OH0','658.32',NULL,0,'2014-01-27 21:01:18'),(900,747,'Y','18','021','EC','A','','','AC','0000853805','0000853805','MS00000025048','IL','1','MCMILLION','TAMMY','L','','','34','434417694','1040 PINE MEADOW LN',0,'MAGNOLIA','MS','39652','8116','CY','28113','1969-03-17','F','U',':RET:2106-3','N','021','DEN','2400940','46300MS002000101','2014-01-01','2013-12-16 13:09:10','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 18:08:15'),(9707,7689,'Y','18','021','EC','A','','','AC','0001031419','0001031419','OH00000679041','IL','1','Eggeman','Phil','','','','34','274464246','4113 SW LEBANON RD',0,'DALTON','OH','44618','9631','CY','39169','1952-06-12','M','U',':RET:2106-3','N','021','HLT','5219','52664OH151001306','2014-01-01','2013-11-15 16:31:51','559.00',NULL,NULL,'626.65','67.65','R-OH014','OH0','626.65',NULL,0,'2013-12-26 04:45:05'),(17719,14160,'N','19','021','EC','A',NULL,NULL,'','0000783254','0000847166','','IL','1','Brown','Summer','L','','','34','297024310','541 CLARK DR',0,'TALLMADGE','OH','44278','1549','CY','39153','1998-04-13','F','',':RET:2106-3','N','021','HLT','2720438','52664OH152000901','2014-02-01','2014-01-13 15:10:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-14 01:33:13'),(27351,21659,'Y','18','021','EC','A','','','AC','0000637107','0000637107','OH00003536504','IL','1','Rice','Christine','','','','34','298905674','710 Jefferson Ave',0,'Cleveland','OH','44113',NULL,'CY','39035','1987-04-10','F','U',':RET:2106-3','N','021','DEN','2873327','99734OH005000401','2014-04-01','2014-03-04 13:28:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:05'),(29150,23076,'Y','18','021','EC','A','','','AC','0000296856','0000296856','OH00003745174','IL','1','Gawrych','Kathy','Y','','','34','289441964','5765 FAIRRIDGE LN',0,'HAMILITON','OH','45011',NULL,'CY','39017','1955-08-20','F','M',':RET:2106-3','N','021','HLT','4135568','92036OH003001204','2014-04-01','2014-03-10 17:35:36','253.00',NULL,NULL,'571.20','318.20','R-OH004','OH0','571.20',NULL,0,'2014-03-10 21:02:48'),(7711,6105,'Y','18','021','EC','A','','','AC','0001207139','0001207139','OH00000501285','IL','1','Alvarado','Christopher','','','','34','457210858','1335 W 49TH ST',0,'CLEVELAND','OH','44102','2202','CY','39035','1972-08-18','M','R',':RET:2047-9','N','021','DEN','2414868','99734OH005000401','2014-01-01','2013-12-20 10:01:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:29'),(4243,3380,'Y','18','021','EC','A','','','AC','0000480821','0000480821','TX00000816977','IL','1','HOLUB','PAUL','','','','34','451253338','12215 TYSON CV',0,'AUSTIN','TX','78758','5302','CY','48453','1959-02-10','M','U',':RET:2106-3','N','021','DEN','1617144','33348TX002000201','2014-01-01','2013-12-17 16:49:43','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:51:05'),(5751,4566,'Y','18','021','EC','A','','','AC','0001344219','0001344219','LA00001161665','IL','1','Morris','Chasidy','','','','34','428593199','4002 KILKENNY DR',0,'BATON ROUGE','LA','70814','7525','CY','22033','1987-10-17','F','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','1574623','18575LA002000201','2014-01-01','2013-12-24 02:42:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:46:13'),(1981,1620,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000175175','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','599594','33348TX002000101','2014-01-01','2013-11-19 23:03:52','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:43'),(3677,2943,'Y','18','021','EC','A','','','AC','0000100044','0000100044','OH00001295811','IL','1','Eckels','Dirk','Allen','','','34','298567022','7323 GEARIED ST',0,'PICKERINGTON','OH','43147','8123','CY','39045','1955-03-03','M','M',':RET:2106-3','N','021','DEN','15423','99734OH005000401','2014-01-01','2013-12-13 08:45:38','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:31:22'),(24118,19172,'Y','18','021','EC','A','','','AC','0001051390','0001051390','TX00002661800','IL','1','HERNANDEZ','GUADALUPE','R','','','34','456044510','328 COLMILLO DR',0,'EL PASO','TX','79907','4145','CY','48141','1953-12-13','F','M',':RET:2106-3','N','021','DEN','2834203','33348TX002000201','2014-03-01','2014-02-15 14:43:07','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-15 22:01:41'),(20116,16050,'Y','18','021','EC','A','','','AC','0001081833','0001081833','OH00002325906','IL','1','Bobbitt','Tammy','','','','34','299641328','8860 Garringer Edgefield rd',0,'Jamestown','OH','45335',NULL,'CY','39047','1961-03-28','F','M',':RET:2106-3','N','021','DEN','2605032','99734OH005000401','2014-03-01','2014-01-26 21:33:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-27 21:00:43'),(18409,14686,'N','01','021','EC','A',NULL,NULL,'','0001075328','0000258187','','IL','1','Menasian','Edward','','','','34','293701389','3016 117TH ST',0,'TOLEDO','OH','43611','2705','CY','39095','1964-03-31','M','',NULL,'N','021','DEN','2932843','99734OH005000301','2014-02-01','2014-01-15 18:10:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:46'),(20047,15988,'Y','18','021','EC','A','','','AC','0000011509','0000011509','TX00002312954','IL','1','Vasavada','Sharva','','','','34','452658740','5313 MARINERS DR',0,'PLANO','TX','75093','4117','CY','48085','1983-05-23','M','U',':RET:2029-7','N','021','DEN','1810258','33348TX002000201','2014-03-01','2014-01-26 18:07:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-27 21:00:03'),(3033,2439,'Y','18','021','EC','A','','','AC','0000768851','0000768851','OH00000538584','IL','1','Gant','Kathleen','','','','34','288721534','819 WOODWARD AVE',0,'TOLEDO','OH','43608','2018','CY','39095','1962-03-13','F','U',':RET:2054-5','N','021','HLT','283183','92036OH004002601','2014-01-01','2013-12-06 16:25:04','290.29',NULL,NULL,'292.43','2.14','R-OH001','OH0','292.43',NULL,0,'2013-12-25 20:18:27'),(5015,3974,'Y','18','021','EC','A','','','AC','0000045728','0000045728','OH00001005378','IL','1','Weihrauch','Pamela','','','','34','291508296','109 Hartford Ct',0,'Lima','OH','45805',NULL,'CY','39003','1951-05-16','F','U',':RET:2106-3','N','021','HLT','1218721','92036OH002001501','2014-01-01','2013-12-07 05:40:55','396.00',NULL,NULL,'730.20','334.20','R-OH002','OH0','730.20',NULL,0,'2013-12-25 22:47:23'),(19367,15438,'Y','18','021','EC','A','','','AC','0001130252','0001130252','OH00002103740','IL','1','Black','Thomas','','','','34','282563984','155 EMMONS AVE',0,'AKRON','OH','44312','1361','CY','39153','1954-04-25','M','U',':RET:2106-3','N','021','HLT','1851913','52664OH151001306','2014-03-01','2014-01-21 14:47:31','482.00',NULL,NULL,'580.49','98.49','R-OH012','OH0','580.49',NULL,1,'2014-01-22 03:22:34'),(27495,21755,'Y','18','021','EC','A','','','AC','0000553979','0000553979','OH00003655034','IL','1','Kemp','Diana','','','','34','296765112','7933 Rodgers Rd',0,'Lodi','OH','44254',NULL,'CY','39103','1973-08-01','F','M',':RET:2106-3','N','021','HLT','3982720','52664OH151001306','2014-04-01','2014-03-04 15:31:45','457.00',NULL,NULL,'587.62','130.62','R-OH012','OH0','285.00',NULL,0,'2014-03-04 21:02:25'),(15164,12118,'N','01','021','EC','A',NULL,NULL,'','0000484800','0000364896','','IL','1','LENGEL','BETTY JO','','','','34','302426542','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-06-20','F','',':RET:2106-3','N','021','DEN','2148751','99734OH005000401','2014-02-01','2013-12-30 14:28:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:20'),(24180,19209,'Y','18','021','EC','A','','','AC','0001155141','0001155141','OH00001860566','IL','1','Krishen','Adarsh','','','','34','284643919','844 MERRIMAN RD',0,'AKRON','OH','44303','1748','CY','39153','1960-09-17','M','R',':RET:2029-7^:RET:2106-3','N','021','HLT','2733311','52664OH152000901','2014-03-01','2014-02-15 23:40:32','0.00',NULL,NULL,'333.21','333.21','R-OH012','OH0','333.21',NULL,0,'2014-02-16 19:00:07'),(4053,3237,'Y','18','021','EC','A','','','AC','0000831985','0000831985','OH00000705972','IL','1','Minham','Patricia','L','','','34','302654555','8312 STATE ROUTE 366',0,'RUSSELLS POINT','OH','43348','9691','CY','39091','1957-05-19','F','U',':RET:2106-3','N','021','DEN','1531360','99734OH005000401','2014-01-01','2013-12-17 15:03:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:28'),(20206,16122,'Y','18','021','EC','A','','','AC','0001199535','0001199535','OH00002362150','IL','1','Jackson','Sherman','','','','34','276928560','114 COUNTRY CLUB DR',0,'OXFORD','OH','45056','9049','CY','39017','1979-06-16','M','U',':RET:2054-5','N','021','HLT','2757127','92036OH005001205','2014-03-01','2014-01-27 10:57:52','162.00',NULL,NULL,'260.61','98.61','R-OH004','OH0','260.61',NULL,0,'2014-01-27 21:01:35'),(13608,10851,'N','19','021','EC','A',NULL,NULL,'','0000796957','0000882846','','IL','1','Behrmann','Joseph','','','','34','282981201','9499 HADDINGTON CT',0,'CINCINNATI','OH','45251','2362','CY','39061','1995-04-12','M','',':RET:2106-3','N','021','HLT','1676823','92036OH002001201','2014-01-01','2013-12-22 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 13:05:34'),(28074,22218,'Y','18','021','EC','A','','','AC','0001253603','0001253603','OH00002734431','IL','1','Adams','Lisa','','','','34','401379520','855 ROMBACH AVE',0,'WILMINGTON','OH','45177','1935','CY','39027','1983-05-02','F','M',':RET:2106-3','N','021','DEN','4014876','99734OH005000301','2014-04-01','2014-03-06 16:49:13','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-03-06 21:01:53'),(6482,5134,'Y','18','021','EC','A','','','AC','0000144194','0000144194','OH00000972025','IL','1','REED','DENNIS','','','','34','271464372','2221 mifflin ave',0,'ashland','OH','44805',NULL,'CY','39005','1950-09-30','M','M',NULL,'N','021','HLT','863096','52664OH151001305','2014-01-01','2013-12-11 09:47:25','1018.00',NULL,NULL,'1155.63','137.63','R-OH012','OH0','658.32',NULL,0,'2013-12-26 00:50:20'),(2383,1944,'N','01','021','EC','A',NULL,NULL,'','0000271405','0001188769','','IL','1','VITAL','MYRNA','PIERRE','','','34','269173824','4207 SUNDANCE DR',0,'COLUMBUS','OH','43224','1852','CY','39049','1980-07-12','F','',':RET:2054-5','N','021','DEN','1134243','99734OH005000401','2014-01-01','2013-12-09 10:40:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:04'),(24267,19272,'Y','18','021','EC','A','','','AC','0000066302','0000066302','OH00002440325','IL','1','Dechant','Debra',NULL,NULL,NULL,NULL,NULL,'1054 Bell Ct.',0,'Elyria','OH','44035',NULL,'CY','39093','1955-01-21','F','M',NULL,'N','021','HLT','3225993','92036OH004000801','2014-04-01','2014-02-17 13:35:11','434.00',NULL,NULL,'489.35','55.35','R-OH011','OH0','489.35',NULL,0,'2014-02-17 19:00:14'),(22692,18119,'Y','18','021','EC','A','','','AC','0001180120','0001180120','TX00002157799','IL','1','Botello','Robert','','','','34','456905809','10602 CAROVILLI DR',0,'AUSTIN','TX','78748','2363','CY','48453','1951-08-08','M','M',NULL,'N','021','DEN','3773609','33348TX002000101','2014-03-01','2014-02-10 20:05:51','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-11 21:00:53'),(22925,18275,'Y','18','024','14','A','','','TE','0000640922','0000640922','','IL','1','Sheal','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-02','F','',NULL,NULL,NULL,'','1418752','','2014-02-28','2014-02-11 18:20:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:06'),(24955,19789,'Y','18','021','EC','A','','','AC','0001433995','0001433995','LA00003127802','IL','1','HENSLEY','JESSICA','VIRGINIA','','','34','219724831','124 S LOPEZ ST',0,'NEW ORLEANS','LA','70119','6214','CY','22071','1972-11-25','F','U',NULL,'N','021','DEN','3455819','18575LA002000201','2014-04-01','2014-02-20 12:33:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:14'),(13248,10573,'Y','18','021','EC','A','','','AC','0001215498','0001215498','TX00001343132','IL','1','Guerrero','Patricia','','','','34','632586857','3402 Alice Lane',0,'Edinburg','TX','78541',NULL,'CY','48215','1969-01-02','F','M',NULL,'N','021','DEN','2508919','33348TX002000201','2014-01-01','2013-12-23 11:04:09','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-26 12:56:19'),(19351,15424,'N','01','021','EC','A',NULL,NULL,'','0000387310','0000486970','','IL','1','McCoy','Andrew','Michael','','','34','283685039','10210 WINSTEAD LN',0,'CINCINNATI','OH','45231','2720','CY','39061','1961-03-24','M','',':RET:2106-3','N','021','DEN','3202365','99734OH005000301','2014-03-01','2014-01-21 14:02:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:25'),(1593,1331,'Y','18','021','EC','A','','','AC','0001201210','0001201210','TX00001380040','IL','1','Boyd','Victoria','','','','34','455554835','1810 Ridgeway',0,'Temple','TX','76502',NULL,'CY','48027','1981-03-18','F','U',':RET:2106-3','N','021','DEN','2556950','33348TX002000201','2014-01-01','2013-12-24 11:58:15','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 18:51:49'),(1994,1633,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','640296','','2013-11-19','2013-11-19 23:07:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:02:02'),(23362,18615,'Y','18','021','EC','A','','','AC','0000809720','0000809720','OH00002096116','IL','1','Sharier','Forrest','','','','34','281589695','100 8th Street',0,'Barberton','OH','44203',NULL,'CY','39153','1958-09-29','M','U',':RET:2106-3','N','021','HLT','2644035','52664OH151001304','2014-03-01','2014-02-13 15:43:08','311.00',NULL,NULL,'497.31','186.31','R-OH012','OH0','497.31',NULL,0,'2014-02-13 22:00:46'),(4878,3868,'Y','18','021','EC','A','','','AC','0000315229','0000315229','TX00000166109','IL','1','Rasnic','Rhea','','','','34','406883570','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1970-06-27','M','U',NULL,'N','021','DEN','322518','33348TX002000201','2014-01-01','2013-10-10 01:38:25','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:31:11'),(13116,10460,'Y','18','024','14','A','','','TE','0000784317','0000784317','','IL','1','Ivory','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-07','F','',NULL,NULL,NULL,'','485023','','2013-12-23','2013-12-23 13:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:52:37'),(22808,18203,'N','01','021','EC','A',NULL,NULL,'','0001024319','0000209675','','IL','1','BARRETT','DARLENE','','','','34','284548178','18706 ESSEX RD',0,'LOGAN','OH','43138',NULL,'CY','39073','1953-02-23','F','',':RET:2106-3','N','021','DEN','3773641','99734OH005000301','2014-03-01','2014-02-11 14:46:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:56'),(6813,5404,'N','01','021','EC','A',NULL,NULL,'','0001170797','0000870587','','IL','1','Jennings','Kathy','','','','34','299646764','808 MCKINLEY AVE',0,'AKRON','OH','44306','1906','CY','39153','1955-09-07','F','',':RET:2106-3','N','021','HLT','295091','52664OH151001306','2014-01-01','2013-11-13 18:33:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2013-12-26 01:30:22'),(21658,17297,'Y','18','021','EC','A','','','AC','0002352112','0002352112','LA00001879072','31','1','Rogers','Vicki','','','','34','434572938','3201 Kaliste Saloom Rd Lot 172',0,'Lafayette','LA','70508',NULL,'CY','22055','1969-08-28','F','M',':RET:2106-3','N','021','DEN','3593406','18575LA002000201','2014-03-01','2014-02-05 11:56:24','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-05 21:30:53'),(20488,16367,'Y','18','021','EC','A','','','AC','0000186140','0000186140','OH00002559624','IL','1','CASADO','DANNY','','','','34','108666320','1445 CHESTNUT ST',0,'MINERAL RIDGE','OH','44440','9728','CY','39155','1982-07-09','M','U',NULL,'N','021','HLT','3100238','52664OH151001306','2014-03-01','2014-01-29 16:13:41','205.00',NULL,NULL,'293.11','88.11','R-OH013','OH0','293.11',NULL,0,'2014-01-29 21:01:05'),(6115,4849,'Y','18','021','EC','A','','','AC','0000540264','0000540264','OH00000134717','IL','1','Goeters','Grant','','','','34','388762714','2423 6TH ST NW',0,'CANTON','OH','44708','4411','CY','39151','1958-02-20','M','U',':RET:2106-3','N','021','HLT','851111','52664OH151001306','2014-01-01','2013-11-21 15:37:18','402.00',NULL,NULL,'497.31','95.31','R-OH015','OH0','497.31',NULL,0,'2013-12-26 00:15:35'),(18784,14962,'Y','18','021','EC','A','','','AC','0000788229','0000788229','OH00001379153','IL','1','Jackson','Michail','','','','34','283780168','6015 DEER RUN DR',0,'CHAGRIN FALLS','OH','44022','2571','CY','39035','1977-02-02','F','M',NULL,'N','021','DEN','1801515','99734OH005000401','2014-02-01','2014-01-15 21:49:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:54'),(9222,7317,'Y','18','024','14','A','','','TE','0001216239','0001216239','','IL','1','BISHOP','TERRY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-06-13','M','',NULL,NULL,NULL,'','1256957','','2013-12-18','2013-12-18 12:15:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:10:14'),(653,538,'Y','18','021','EC','A','','','AC','0000775085','0000775085','OH00000907456','31','1','McDonald','Delbert','','','','34','236907845','PO Box205',0,'Stockport','OH','43787',NULL,'CY','39115','1955-04-22','M','U',':RET:2106-3','N','021','DEN','2469494','99734OH005000401','2014-01-01','2013-12-16 16:52:27','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:01:39'),(668,551,'Y','18','021','EC','A','','','AC','0000495437','0000495437','OH00000828098','IL','1','PUFFER','DONNA','','','','34','299721024','11050 FANCHER RD',0,'WESTERVILLE','OH','43082',NULL,'CY','39041','1962-03-15','F','M',':RET:2106-3','T','021','DEN','1392044','99734OH005000301','2014-01-01','2013-12-16 08:58:41','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:02:03'),(2719,2198,'N','01','021','EC','A',NULL,NULL,'','0000866223','0000196024','','IL','1','johnson','michael','joseph','','Sr','34','438822708','740 alexandria hwy',0,'leesville','LA','71446',NULL,'CY','22115','1951-09-30','M','',':RET:2106-3','N','021','DEN','1031697','18575LA002000201','2014-01-01','2013-12-01 19:00:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:48:08'),(28188,22305,'Y','18','021','EC','A','','','AC','0000001097','0000001097','OH00003354702','IL','1','Berger','Mary','','','','34','279626105','254 W Main St',0,'Norwalk','OH','44857',NULL,'CY','39077','1959-02-19','F','U',':RET:2106-3','N','021','HLT','3303402','92036OH005002706','2014-04-01','2014-03-06 16:20:34','428.00',NULL,NULL,'434.84','6.84','R-OH006','OH0','434.84',NULL,0,'2014-03-06 21:02:59'),(25982,20605,'Y','18','021','EC','A','','','AC','0000473695','0000473695','OH00002217977','IL','1','PROCHASKA','JOSEPHINE','','','','34','286503815','3264 S.159TH ST',0,'CLEVELAND','OH','44111',NULL,'CY','39035','1953-03-19','F','U',NULL,'N','021','DEN','2744736','99734OH005000401','2014-03-01','2014-02-26 16:36:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:01:52'),(13122,10465,'Y','18','021','EC','A','','','AC','0000783231','0000783231','OH00000049706','IL','1','DIFRANCESCO','SHERRIE','','','','34','291460249','1303 GIESSE DR',0,'CLEVELAND','OH','44124','1814','CY','39035','1958-02-19','F','M',':RET:2106-3','N','021','DEN','2564503','99734OH005000401','2014-01-01','2013-12-23 14:07:36','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:47'),(6092,4829,'Y','18','021','EC','A','','','AC','0000229406','0000229406','OH00000164926','IL','1','Abrams','Gregory','','','','34','278687799','3959 DELHI AVE',0,'CINCINNATI','OH','45204','1247','CY','39061','1975-02-13','M','U',':RET:2106-3','N','021','HLT','454421','92036OH003001204','2014-01-01','2013-12-01 12:37:19','112.00',NULL,NULL,'279.34','167.34','R-OH004','OH0','279.34',NULL,0,'2013-12-26 00:02:47'),(20403,16297,'Y','18','021','EC','A','','','AC','0000067073','0000067073','TX00002179912','IL','1','GARCIA','ANGEL','ESTEBAN','','','34','458973245','4828 HARTFORD DR',0,'RIVER OAKS','TX','76114','3003','CY','48439','1964-09-13','M','M',NULL,'N','021','DEN','3219634','33348TX002000201','2014-03-01','2014-01-29 15:58:44','0.00',NULL,NULL,'96.89','96.89','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:21'),(16998,13605,'N','01','021','EC','A',NULL,NULL,'','0000411129','0000399909','','IL','1','James','Janel','K','','','34','293509819','943 WYE DR',0,'AKRON','OH','44303','1118','CY','39153','1954-04-15','F','',':RET:2106-3','T','021','DEN','2610068','99734OH005000301','2014-02-01','2014-01-09 08:33:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:29'),(16985,13594,'Y','18','021','EC','A','','','AC','0000923751','0000923751','TX00002174945','IL','1','gorka','brandon','','','','34','346741258','9842 MENARD CIR',0,'SAN ANTONIO','TX','78245','2850','CY','48029','1982-05-03','M','U',':RET:2106-3','N','021','DEN','1565304','33348TX002000101','2014-02-01','2014-01-09 10:44:24','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-13 02:20:20'),(13615,10856,'Y','18','021','EC','A','','','AC','0000882851','0000882851','OH00000073130','IL','1','BESSENBACHER','JANET','','','','34','297545452','4406 FEHR ROAD',0,'CINNCINATI','OH','45238',NULL,'CY','39061','1952-03-18','F','M',NULL,'N','021','HLT','2092252','92036OH002001201','2014-01-01','2013-12-23 13:31:08','297.00',NULL,NULL,'696.64','399.64','R-OH004','OH0','696.64',NULL,0,'2013-12-26 13:05:42'),(13396,10691,'N','01','021','EC','A',NULL,NULL,'','0001057989','0000436595','','IL','1','Thomas','Timothy','','','','34','280861432','5798 UNIVERSITY HEIGHTS DR',0,'ATHENS','OH','45701','9339','CY','39009','1974-05-15','M','',':RET:2106-3','N','021','DEN','2503092','99734OH005000301','2014-01-01','2013-12-23 08:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:13'),(22782,18189,'N','01','021','EC','A',NULL,NULL,'','0001050681','0000150690','','IL','1','Newcome','Laura','Michelle','','','34','291685314','71 ORGAN AVE',0,'AKRON','OH','44319','3070','CY','39153','1962-08-07','F','',':RET:2106-3','T','021','DEN','2944106','99734OH005000301','2014-03-01','2014-02-10 19:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:44'),(15607,12484,'Y','18','021','EC','A','','','AC','0000965780','0000965780','OH00001364475','IL','1','Armstrong','Darren','','','','34','633226634','943 Brittany Drive',0,'Delaware','OH','43015',NULL,'CY','39041','1987-03-24','M','M',':RET:2106-3','N','021','DEN','2188430','99734OH005000301','2014-02-01','2013-12-31 15:41:22','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:32:42'),(7045,5595,'Y','18','021','EC','A','','','AC','0000421592','0000421592','TX00001712192','IL','1','Gustafson','Linda','','','','34','456923055','1348 COUNTY ROAD 2013',0,'WALNUT SPRINGS','TX','76690','3080','CY','48425','1949-09-05','F','U',':RET:2106-3','N','021','DEN','1875189','33348TX002000201','2014-02-01','2013-12-25 08:43:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:49:31'),(22237,17750,'Y','18','021','EC','A','','','AC','0000723938','0000723938','OH00002536683','IL','1','King','Larry',NULL,NULL,NULL,NULL,NULL,'559 Park Hill Dr',0,'Fairlawn','OH','44333',NULL,'CY','39153','1959-04-13','M','R',':RET:2106-3','T','021','HLT','2992645','52664OH152000901','2014-03-01','2014-02-09 14:57:38','0.00',NULL,NULL,'401.04','401.04','R-OH012','OH0','401.04',NULL,0,'2014-02-09 19:00:36'),(21361,17073,'Y','18','021','EC','A','','','AC','0001200358','0001200358','TX00001644348','IL','1','FLOWERS','BRENDA','','','','34','459968919','18426 FOREST DEW DR',0,'KATY','TX','77449','4469','CY','48201','1953-03-18','F','U',':RET:2054-5','N','021','DEN','2628679','33348TX002000201','2014-03-01','2014-02-04 15:26:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-04 21:00:43'),(19320,15401,'Y','18','021','EC','A','','','AC','0000952615','0000952615','TX00002115497','IL','1','STONE','MICHAEL','','','Sr','34','027480698','6094 COUNTY ROAD 309',0,'CALDWELL','TX','77836','5918','CY','48051','1957-02-14','M','U',':RET:2106-3','N','021','DEN','2332976','33348TX002000201','2014-03-01','2014-01-21 11:27:55','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,1,'2014-01-22 03:22:11'),(28775,22778,'Y','18','021','EC','A','','','AC','0001241932','0001241932','OH00002756877','IL','1','STAIRS','KEVIN','','','','34','302782200','14 W PARK DR',0,'SHELBY','OH','44875','1427','CY','39139','1982-10-19','M','M',':RET:2106-3','N','021','DEN','3350780','99734OH005000401','2014-04-01','2014-03-09 13:18:23','0.00',NULL,NULL,'31.57','31.57','R-OH007','OH0','0.00',NULL,0,'2014-03-09 21:00:32'),(25218,20002,'N','01','021','EC','A',NULL,NULL,'','0001157590','0000561706','','IL','1','Collett','Kathleen','','','','34','277525011','6755 WINDWARD HILLS DR',0,'BRECKSVILLE','OH','44141','2469','CY','39035','1952-12-28','F','',NULL,'N','021','DEN','3238736','99734OH005000301','2014-04-01','2014-02-21 17:36:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:54'),(18599,14828,'Y','18','021','EC','A','','','AC','0000993942','0000993942','MS00001645222','IL','1','Jones','Meko','','','','34','587638022','4438 Willowrun Drive',0,'Jackson','MS','39212',NULL,'CY','28049','1988-12-26','M','U',':RET:2054-5','N','021','DEN','1737017','46300MS002000201','2014-02-01','2014-01-15 11:30:13','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-16 08:47:18'),(18369,14661,'N','01','021','EC','A',NULL,NULL,'','0000948436','0001168019','','IL','1','Abou-Osman','Ahmad','','','','34','529413582','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','1962-07-20','M','',NULL,'T','021','DEN','1558565','99734OH005000301','2014-02-01','2014-01-15 10:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:29'),(1115,918,'Y','18','021','EC','A','','','AC','0000846113','0000846113','OH00000203524','IL','1','Paynter','Sylvia','','','','34','235844328','1986 County Road 104',0,'Chesapeake','OH','45619',NULL,'CY','39087','1951-01-11','F','M',':RET:2106-3','N','021','DEN','1054838','99734OH005000401','2014-01-01','2013-12-03 17:40:42','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:17:37'),(25253,20033,'Y','18','021','EC','A','','','AC','0000173861','0000173861','OH00002436738','IL','1','Brannon','Marquis','','','','34','289907128','3226 EUCLID AVE',0,'CLEVELAND','OH','44115','2510','CY','39035','1988-06-22','M','U',':RET:2054-5','N','021','HLT','3263108','52664OH152001001','2014-04-01','2014-02-21 14:00:46','0.00',NULL,NULL,'138.84','138.84','R-OH011','OH0','138.84',NULL,0,'2014-02-21 22:01:15'),(1846,1512,'Y','18','021','EC','A','','','AC','0001053058','0001053058','OH00000977863','IL','1','Meadows','Kristianna','','','','34','288967218','79 W NIMISILA RD',0,'AKRON','OH','44319','4913','CY','39153','1993-09-25','F','U',':RET:2106-3','N','021','HLT','1627296','52664OH151001306','2014-01-01','2013-12-24 15:23:47','74.00',NULL,NULL,'141.61','67.61','R-OH012','OH0','141.61',NULL,0,'2013-12-25 18:57:46'),(24594,19525,'Y','18','021','EC','A','','','AC','0000477503','0000477503','OH00002719699','IL','1','Smith','Lisa','','','','34','278828586','32 N. Leutz rd.',0,'oak harbor','OH','43449',NULL,'CY','39123','1968-05-31','F','U',':RET:2106-3','N','021','DEN','3274461','99734OH005000301','2014-04-01','2014-02-19 15:31:38','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-20 04:11:31'),(17716,14159,'Y','18','021','EC','A','','','AC','0000680864','0000680864','OH00001570314','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','T','021','HLT','2230115','52664OH152000901','2014-02-01','2014-01-13 09:08:46','542.00',NULL,NULL,'927.18','385.18','R-OH012','OH0','488.95',NULL,0,'2014-01-14 01:33:12'),(29035,22981,'Y','18','021','EC','A','','','AC','0000884288','0000884288','OH00002628952','IL','1','JACKSON','DENITA','','','','34','286808135','30 HEFFRON DR',0,'FAIRFIELD','OH','45014','7166','CY','39017','1975-07-09','F','U',':RET:2054-5','N','021','DEN','4414936','99734OH005000401','2014-04-01','2014-03-10 12:28:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:37'),(124,108,'Y','18','021','EC','A','','','AC','0000556685','0000556685','OH00000087368','IL','1','Lauer','Marie','','','','34','288521902','564 COMMON WEALTH DR',0,'CINCINNATI','OH','45244','1031','CY','39025','1954-01-06','F','M',NULL,'N','021','HLT','683093','92036OH002000601','2014-01-01','2013-12-05 17:35:37','764.00',NULL,NULL,'1318.13','554.13','R-OH005','OH0','645.32',NULL,0,'2013-12-25 17:18:16'),(27942,22104,'Y','18','021','EC','A','','','AC','0000103956','0000103956','TX00003205018','IL','1','GARZA','DAVID','','','Jr','34','638283678','513 EAST BREBOLL',0,'RUNGE','TX','78151',NULL,'CY','48255','1992-01-31','M','U',NULL,'N','021','DEN','4164327','33348TX002000201','2014-04-01','2014-03-06 14:11:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:32'),(23771,18915,'N','19','021','EC','A',NULL,NULL,'','0001070521','0000784407','','IL','1','Record','Benjamin','Corwin','','','34','299941436','6214 Robison Road',0,'Cincinnati','OH','45213',NULL,'CY','39061','1992-05-21','M','',':RET:2106-3','N','021','DEN','3685676','99734OH005000301','2014-03-01','2014-02-14 17:10:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:14'),(19022,15149,'Y','18','021','EC','A','','','AC','0000686697','0000686697','MS00001487082','IL','1','TATUM','EARNESTINE','','','','34','434199396','1076 COUNTY RAOD 20',0,'LOUIN','MS','39338',NULL,'CY','28061','1958-12-07','F','M',NULL,'N','021','DEN','2352275','46300MS002000101','2014-03-01','2014-01-17 11:38:14','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-20 08:06:26'),(18877,15039,'Y','18','021','EC','A','','','AC','0001765742','0001765742','LA00001494745','IL','1','Suire','Ida','','','','34','436759571','1897 MARCIA AVE',0,'ABBEVILLE','LA','70510','3047','CY','22113','1986-12-31','F','U',NULL,'N','021','DEN','1806707','18575LA002000201','2014-03-01','2014-01-16 15:46:26','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-17 03:36:26'),(4747,3762,'Y','18','021','EC','A','','','AC','0001140937','0001140937','TX00001195186','IL','1','hollins','rayvon','','','','34','456158369','5765 REMINGTON CIR',0,'FORT WORTH','TX','76132','4676','CY','48439','1962-09-26','F','M',':RET:2054-5','T','021','DEN','377299','33348TX002000201','2014-01-01','2013-12-07 20:57:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:15:05'),(13404,10696,'Y','18','021','EC','A','','','AC','0000027894','0000027894','OH00000644291','31','1','Horn','Laura','','','','34','280865476','508 Park Avenue',0,'Bellevue','OH','44811',NULL,'CY','39083','1987-03-24','F','U',':RET:2106-3','N','021','DEN','1821431','99734OH005000301','2014-01-01','2013-12-23 09:39:14','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:00:24'),(9745,7716,'N','01','021','EC','A',NULL,NULL,'','0001038960','0000320304','','IL','1','Estrada','Pedro','B','','','34','450374993','7007 CORAL LN',0,'SACHSE','TX','75048','2537','CY','48085','1951-09-08','M','',':RET:2106-3','N','021','DEN','416977','33348TX002000201','2014-01-01','2013-11-15 16:27:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:46:01'),(28530,22579,'Y','18','021','EC','A','','','AC','0001580027','0001580027','LA00003716528','IL','1','Toups','Michele','Elizabeth','','','34','433191494','508 Celestine Street',0,'Abbeville','LA','70510',NULL,'CY','22113','1961-11-30','F','U',':RET:2106-3','N','021','DEN','3437416','18575LA002000101','2014-04-01','2014-03-07 11:06:18','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-07 21:32:07'),(29138,23066,'N','19','021','EC','A',NULL,NULL,'','0000754634','0000979360','','IL','1','Nisch Quan','Matthiessen','','','','34','302944833','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','1992-09-09','M','',':RET:2029-7^:RET:2034-7^:RET:2106-3','N','021','HLT','4316538','92036OH003002705','2014-04-01','2014-03-10 17:13:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2014-03-10 21:02:41'),(4489,3558,'N','01','021','EC','A',NULL,NULL,'','0000287077','0000808641','','IL','1','Leyda','Christine','L','','','34','291523570','102 W WOOD ST',0,'MALVERN','OH','44644','9401','CY','39019','1951-10-04','F','',':RET:2106-3','N','021','DEN','753509','99734OH005000301','2014-01-01','2013-12-12 15:50:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:03:06'),(19150,15257,'Y','18','024','14','A','','','TE','0000473659','0000473659','','IL','1','STADLER','NORA','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-07-22','F','',NULL,NULL,NULL,'','1875283','','2014-01-18','2014-01-18 19:45:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:45:34'),(14325,11425,'Y','18','021','EC','A','','','AC','0000409748','0000409748','OH00000483057','IL','1','beery','david','russell','','','34','275740459','3660 SEVILLE RD',0,'SEVILLE','OH','44273','9742','CY','39103','1974-03-05','M','U',':RET:2106-3','N','021','HLT','2399313','52664OH151001306','2014-02-01','2013-12-26 16:07:23','231.00',NULL,NULL,'281.44','50.44','R-OH012','OH0','281.44',NULL,0,'2013-12-27 02:07:21'),(14550,11609,'Y','18','021','EC','A','','','AC','0000901346','0000901346','MS00000680227','IL','1','HARRIS','EONNETTE','','','','34','428215957','226 APPLERIDGE RD',0,'BRANDON','MS','39042','9018','CY','28121','1963-12-04','F','M',NULL,'N','021','DEN','1519783','46300MS002000201','2014-02-01','2013-12-27 16:57:43','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:35:00'),(7327,5806,'Y','18','021','EC','A','','','AC','0000346879','0000346879','OH00000973487','31','1','Davis','Carolee','Ann','','','34','522722156','P. O. Box 427',0,'Winchester','OH','45697',NULL,'CY','39001','1953-01-06','F','M',':RET:2106-3','N','021','HLT','823633','92036OH003000605','2014-01-01','2013-12-14 11:51:08','603.97',NULL,NULL,'608.42','4.45','R-OH005','OH0','608.42',NULL,0,'2013-12-26 02:03:45'),(5799,4607,'Y','18','024','14','A','','','TE','0000468103','0000468103','','IL','1','Landfeld','Laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-09-02','F','',NULL,NULL,NULL,'','1514161','','2013-12-24','2013-12-24 02:20:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:47:28'),(25467,20205,'Y','18','021','EC','A','','','AC','0000640161','0000640161','TX00002854477','31','1','Rios','Jacquelyn','','','','34','467375753','PO Box 742',0,'Fredericksburg','TX','78624',NULL,'CY','48171','1961-03-12','F','M',':RET:2106-3','N','021','DEN','3226156','33348TX002000201','2014-04-01','2014-02-25 16:19:22','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:35'),(23356,18612,'Y','18','021','EC','A','','','AC','0001062169','0001062169','OH00002463104','IL','1','koontz','wendi','','','','34','291668215','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','1974-02-05','F','M',NULL,'N','021','HLT','3713513','52664OH151001304','2014-03-01','2014-02-13 14:50:43','383.00',NULL,NULL,'700.91','317.91','R-OH012','OH0','285.00',NULL,0,'2014-02-13 22:00:44'),(16017,12821,'Y','18','021','EC','A','','','AC','0002366509','0002366509','LA00002242556','IL','1','Glasper','Karla','','','','34','439110446','1221 N 35TH ST',0,'BATON ROUGE','LA','70802','1905','CY','22033','1965-05-03','F','U',NULL,'N','021','DEN','2399479','18575LA002000201','2014-02-01','2014-01-02 22:25:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-04 02:02:03'),(22228,17742,'N','01','021','EC','A',NULL,NULL,'','0002003907','0002025408','','IL','1','Wright','Jonathan','M','','','34','258317985','6081 FEDERAL 80 HWY',0,'RAYVILLE','LA','71269','6705','CY','22083','1973-02-22','M','',':RET:2106-3','T','021','DEN','2982680','18575LA002000101','2014-03-01','2014-02-09 17:04:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-09 19:00:30'),(22106,17645,'N','19','021','EC','A',NULL,NULL,'','0000957938','0000664219','','IL','1','Hartwig','Isabella','A','','','34','276152344','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','2009-02-20','F','',':RET:2106-3','N','021','DEN','2941556','99734OH005000301','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:32'),(13831,11038,'N','01','021','EC','A',NULL,NULL,'','0000904262','0000546472','','IL','1','Filina','Robert','','','','34','293640865','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','1970-06-10','M','',':RET:2106-3','N','021','HLT','2523112','52664OH152000901','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','221.65',NULL,0,'2013-12-26 13:12:06'),(14654,11696,'Y','18','024','14','A','','','TE','0000389432','0000389432','','IL','1','Williams','Nixon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-09','M','',NULL,NULL,NULL,'','1447949','','2013-12-27','2013-12-27 20:30:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:07:49'),(21564,17227,'N','19','021','EC','A',NULL,NULL,'','0001248370','0000530729','','S1','1','Crabiel','Mark','','','','34','284116857','4980 Maple Heights Drive',0,'Medina','OH','44256',NULL,'CY','39103','2005-08-10','M','',':RET:2106-3','N','021','HLT','3214185','52664OH151001305','2014-03-01','2014-02-04 19:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-05 21:30:19'),(21873,17462,'N','01','021','EC','A',NULL,NULL,'','0002388442','0001996122','','IL','1','BERLIN','DEBORAH','','','','34','268568210','4000 LAKEWAY BLVD',0,'BENTON','LA','71006','9325','CY','22015','1956-06-23','F','',':RET:2106-3','N','021','DEN','3036569','18575LA002000201','2014-03-01','2014-02-05 22:07:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-06 21:01:26'),(14765,11788,'Y','18','021','EC','A','','','AC','0000909825','0000909825','TX00001136489','IL','1','Pruitt','Elbert','','','','34','456510382','11381 COUNTY ROAD 2249',0,'TYLER','TX','75707','5309','CY','48423','1968-12-30','M','U',NULL,'N','021','DEN','2113491','33348TX002000201','2014-01-01','2013-12-23 19:37:56','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,1,'2013-12-29 11:12:46'),(14897,11899,'Y','18','021','EC','A','','','AC','0001712539','0001712539','LA00000207030','IL','1','Zuchowski','Robert','','','','34','524699922','4143 Canal St.',0,'New Orleans','LA','70119',NULL,'CY','22071','1989-03-06','M','U',':RET:2106-3','N','021','DEN','2023650','18575LA002000201','2014-02-01','2013-12-29 15:29:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:59'),(2993,2408,'Y','18','024','14','A','','','TE','0000705120','0000705120','','IL','1','Isenbarger','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-14','M','',NULL,NULL,NULL,'','1211363','','2013-12-05','2013-12-05 20:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:17:30'),(24022,19105,'Y','18','021','EC','A','','','AC','0000810832','0000810832','OH00002401823','IL','1','Russell','Thomas','','','','34','296562674','5211 SHEILA DR',0,'TOLEDO','OH','43613','2441','CY','39095','1961-10-21','M','M',':RET:2106-3','N','021','DEN','2820520','99734OH005000401','2014-03-01','2014-02-15 16:20:41','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2014-02-15 22:00:48'),(23236,18525,'Y','18','021','EC','A','','','AC','0000223739','0000223739','OH00002074065','IL','1','WALKER','SHEILA','ANN','','','34','292724440','1218 HOMESIDE AVE',0,'CINCINNATI','OH','45224','2622','CY','39061','1963-02-21','F','U',':RET:2054-5','T','021','HLT','3831500','92036OH003001206','2014-03-01','2014-02-12 14:27:05','300.00',NULL,NULL,'480.83','180.83','R-OH004','OH0','480.83',NULL,0,'2014-02-12 21:32:29'),(7934,6275,'Y','18','021','EC','A','','','AC','0002315129','0002315129','LA00000221159','31','1','GUILLORY','CARL','ADAM','','','34','435497227','PO BOX 598',0,'OBERLIN','LA','70655',NULL,'CY','22003','1975-07-13','M','U',NULL,'N','021','DEN','1406378','18575LA002000201','2014-01-01','2013-12-20 13:57:06','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 03:06:42'),(15238,12180,'Y','18','021','EC','A','','','AC','0000003587','0000003587','OH00000762912','IL','1','Arts','Henricus','','','','34','301040530','5520 ELM SUGAR RD',0,'CONVOY','OH','45832','9580','CY','39161','1955-04-24','M','M',':RET:2106-3','N','021','HLT','1888863','92036OH004001501','2014-02-01','2013-12-30 09:16:45','924.37',NULL,NULL,'931.18','6.81','R-OH002','OH0','450.90',NULL,0,'2014-01-01 12:08:30'),(8023,6351,'N','01','021','EC','A',NULL,NULL,'','0000368540','0000546468','','IL','1','Wells','Leslie','','','','34','458118029','3607 LANSDOWNE AVE',0,'CINCINNATI','OH','45236','3007','CY','39061','1955-11-12','F','',':RET:2106-3','N','021','HLT','1696870','92036OH006001201','2014-01-01','2013-12-19 21:11:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','433.78',NULL,0,'2013-12-26 03:08:57'),(1487,1240,'Y','18','021','EC','A','','','AC','0000937272','0000937272','OH00001477410','IL','1','Dortch','Carolynda','','','','34','270503655','704 MERTON AVE',0,'AKRON','OH','44306','1524','CY','39153','1952-08-10','F','U',':RET:2054-5','N','021','DEN','2167125','99734OH005000401','2014-01-01','2013-12-24 10:58:09','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:48:56'),(26901,21320,'Y','18','021','EC','A','','','AC','0000317066','0000317066','TX00003479400','IL','1','Villarreal','Eduwiges','','','','34','645106396','127 FLINT AVE',0,'LEVELLAND','TX','79336','5153','CY','48219','1958-01-10','F','M',':RET:2106-3','N','021','DEN','3680049','33348TX002000201','2014-04-01','2014-03-02 12:51:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 01:00:07'),(2076,1700,'Y','18','021','EC','A','','','AC','0001031523','0001031523','LA00000944384','IL','1','arabie','ronald','','','','34','438531972','71435 POITEVENT ST',0,'ABITA SPRINGS','LA','70420','3415','CY','22103','1968-12-18','M','R',':RET:2106-3','N','021','DEN','488085','18575LA002000201','2014-01-01','2013-12-09 21:55:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:16:30'),(21207,16947,'Y','18','021','EC','A','','','AC','0001691474','0001691474','LA00001772496','IL','1','LEWIS','KATHERINE','J','','','34','436118046','1835 SYCAMORE ST',0,'JENA','LA','71342',NULL,'CY','22059','1955-08-17','F','U',':RET:2054-5','N','021','DEN','3753958','18575LA002000201','2014-03-01','2014-02-03 11:40:12','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-03 21:00:57'),(24865,19715,'Y','18','021','EC','A','','','AC','0000125690','0000125690','TX00002143113','IL','1','Chavez','Carol','P','','','34','462175164','2821 HEDGEROW DR',0,'DALLAS','TX','75235','7535','CY','48113','1958-02-09','F','U',NULL,'N','021','DEN','2958090','33348TX002000201','2014-04-01','2014-02-19 08:27:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-20 05:31:31'),(26728,21185,'Y','18','021','EC','A','','','AC','0000913012','0000913012','OH00002863176','IL','1','Williams','Letitia','','','','34','271780312','345 Wise Rd.',0,'Lynchburg','OH','45142',NULL,'CY','39071','1977-04-26','F','M',':RET:2106-3','N','021','HLT','3069858','92036OH005000606','2014-03-01','2014-02-28 10:30:59','205.00',NULL,NULL,'264.05','59.05','R-OH005','OH0','264.05',NULL,0,'2014-02-28 21:31:47'),(321,264,'Y','18','021','EC','A','','','AC','0000770040','0000770040','LA00000489178','IL','1','Keys','Lester','','','','34','437987126','2003 KINGS RD',0,'LEESVILLE','LA','71446','5115','CY','22115','1962-03-24','M','U',':RET:2054-5','N','021','DEN','513222','18575LA002000101','2014-01-01','2013-11-13 17:56:34','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-25 17:31:21'),(27249,21576,'Y','18','021','EC','A','','','AC','0001258287','0001258287','TX00003458776','IL','1','Collins','Tai','','','','34','458817273','1603 Holstein dr',0,'Austin','TX','78758',NULL,'CY','48453','1985-10-09','M','U',NULL,'N','021','DEN','3642673','33348TX002000101','2014-04-01','2014-03-03 15:56:18','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-03 21:31:52'),(20839,16656,'Y','18','021','EC','A','','','AC','0000025334','0000025334','OH00002524536','IL','1','DONLEY','JO','ANN','','','34','236769532','236 COUNTY ROAD 530',0,'WEST SALEM','OH','44287','9100','CY','39005','1950-03-02','F','M',':RET:2106-3','T','021','HLT','1606392','52664OH151001306','2014-03-01','2014-01-31 12:34:27','631.00',NULL,NULL,'757.07','126.07','R-OH012','OH0','757.07',NULL,0,'2014-01-31 21:00:45'),(20264,16169,'N','01','021','EC','A',NULL,NULL,'','0000869314','0000389870','','IL','1','ni','ying','','','','34','089847919','243 ERNEST DR',0,'TALLMADGE','OH','44278','1665','CY','39153','1976-11-19','F','',':RET:2034-7','N','021','DEN','3269916','99734OH005000301','2014-03-01','2014-01-27 23:28:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-28 21:00:19'),(2086,1707,'N','01','021','EC','A',NULL,NULL,'','0000013141','0000852795','','IL','1','cervini','nitza','vanessa','','','34','665184959','1936 HICKORY AVE',0,'HARAHAN','LA','70123','1637','CY','22051','1978-03-21','F','',NULL,'N','021','DEN','1185494','18575LA002000201','2014-01-01','2013-12-10 13:43:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:16:44'),(3353,2687,'Y','18','021','EC','A','','','AC','0000645231','0000645231','TX00000919365','IL','1','Lewis','Dennis','','','','34','462775515','3212 BAIN PL',0,'TYLER','TX','75701','7916','CY','48423','1986-03-03','M','U',':RET:2106-3','N','021','DEN','1961467','33348TX002000201','2014-01-01','2013-12-22 08:16:41','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 21:16:46'),(18994,15129,'N','19','021','EC','A',NULL,NULL,'','0001064742','0000881651','','IL','1','PODOLL','OWEN','','','','34','206726300','5625 NICHOLSON DR',0,'HUDSON','OH','44236',NULL,'CY','39153','1991-12-01','M','',NULL,'N','021','HLT','2214063','52664OH151001305','2014-03-01','2014-01-17 16:11:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-01-20 08:06:12'),(14412,11494,'Y','18','021','EC','A','','','AC','0000831456','0000831456','TX00001409167','IL','1','Prado','Josephine','','','','34','452821325','2934 NUEVA TIERRA ST',0,'GRAND PRAIRIE','TX','75052','5415','CY','48113','1949-05-25','F','U',':RET:2106-3','N','021','DEN','2027442','33348TX002000101','2014-02-01','2013-12-27 05:53:15','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-28 03:31:29'),(13080,10427,'Y','18','024','14','A','','','TE','0000082525','0000082525','','IL','1','Bolin-Devore','Tenaya','Erica',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-05-13','F','',NULL,NULL,NULL,'','621696','','2013-12-23','2013-12-23 10:40:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:51:33'),(27159,21504,'Y','18','021','EC','A','','','AC','0000776038','0000776038','TX00003320771','IL','1','MACNAMES','PHILIP','','','','34','335464278','101 LEGEND HILLS BLVD',0,'LLANO','TX','78643','1932','CY','48299','1951-12-30','M','U',NULL,'N','021','DEN','3619788','33348TX002000201','2014-04-01','2014-03-03 10:02:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:30:58'),(22440,17917,'N','01','021','EC','A',NULL,NULL,'','0000426395','0000749274','','IL','1','EXCELL','GREGORY','','','','34','553884903','110 MUSTANG TRL',0,'SHADY SHORES','TX','76208','5104','CY','48121','1954-01-14','M','',NULL,'N','021','DEN','3763996','33348TX002000201','2014-03-01','2014-02-10 11:35:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-10 21:30:41'),(20784,16606,'Y','18','021','EC','A','','','AC','0000262832','0000262832','TX00002461472','IL','1','SIMMS','GARLA','','','','34','458844234','5208 VIA NAUTLA ST',0,'ARLINGTON','TX','76017','1702','CY','48439','1954-03-30','F','U',':RET:2106-3','N','021','DEN','2747869','33348TX002000201','2014-03-01','2014-01-30 21:41:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-31 21:00:11'),(19106,15222,'N','01','021','EC','A',NULL,NULL,'','0001823365','0001955073','','IL','1','Tomasella','Troy','D','','','34','434908336','600 WILLOW OAK LN',0,'MANDEVILLE','LA','70471','2728','CY','22103','1961-04-17','M','',':RET:2106-3','N','021','DEN','1972598','18575LA002000201','2014-03-01','2014-01-18 16:26:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-21 08:44:41'),(5453,4333,'Y','18','021','EC','A','','','AC','0000637093','0000637093','OH00000913222','IL','1','HATTON','WILLIAM','','','','34','296489448','1816 FERNWOOD ST',0,'MIDDLETOWN','OH','45044','6432','CY','39017','1949-12-14','M','M',':RET:2106-3','N','021','HLT','2037927','92036OH003001204','2014-01-01','2013-12-19 09:49:22','881.00',NULL,NULL,'1316.60','435.60','R-OH004','OH0','672.53',NULL,0,'2013-12-25 23:10:14'),(25645,20344,'Y','18','021','EC','A','','','AC','0000178944','0000178944','OH00003108466','IL','1','Schneider','Rachael','','','','34','284880705','18 W 5TH ST',0,'FREDERICKTOWN','OH','43019','1279','CY','39083','1988-01-14','F','U',':RET:2106-3','N','021','DEN','3610846','99734OH005000401','2014-04-01','2014-02-21 18:40:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:34'),(17270,13815,'Y','18','021','EC','A','','','AC','0001230407','0001230407','OH00001381582','IL','1','Humberson','Shana','Louise','','','34','439273775','3628 MARCELLA AVE',0,'STOW','OH','44224','4119','CY','39153','1976-06-26','F','M',':RET:2106-3','N','021','HLT','2580605','52664OH152000901','2014-02-01','2014-01-09 18:53:37','243.00',NULL,NULL,'447.23','204.23','R-OH012','OH0','202.22',NULL,0,'2014-01-13 02:23:21'),(20343,16244,'Y','18','021','EC','A','','','AC','0001147369','0001147369','OH00001672506','IL','1','Prince','Timothy','J','','','34','287425149','3717 RIDGEPORT AVE SE',0,'MINERVA','OH','44657','8933','CY','39151','1950-04-08','M','M',':RET:2106-3','N','021','HLT','2333111','52664OH151001305','2014-03-01','2014-01-28 13:18:31','445.00',NULL,NULL,'658.32','213.32','R-OH015','OH0','658.32',NULL,0,'2014-01-28 21:01:09'),(26261,20829,'Y','18','021','EC','A','','','AC','0000803197','0000803197','TX00002500131','IL','1','ROPER','AMANDA','','','','34','627018453','8342 VERDELAND',0,'EL PASO','TX','79907',NULL,'CY','48141','1983-08-06','F','U',':RET:2106-3','N','021','DEN','3831899','33348TX002000201','2014-04-01','2014-02-27 15:47:36','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 06:31:12'),(21680,17313,'Y','18','021','EC','A','','','AC','0001208345','0001208345','OH00001575896','IL','1','Kellerman','Jeff','','','','34','284780657','2061 STATE ROUTE 125',0,'AMELIA','OH','45102','2080','CY','39025','1965-09-07','M','U',':RET:2106-3','N','021','HLT','3094367','92036OH004000601','2014-03-01','2014-02-04 19:32:03','156.00',NULL,NULL,'282.22','126.22','R-OH005','OH0','282.22',NULL,0,'2014-02-05 21:31:02'),(2669,2166,'N','01','021','EC','A',NULL,NULL,'','0000433862','0000727252','','IL','1','berry','michael','','','','34','275608673','12 n hazelwood',0,'youngstown','OH','44509',NULL,'CY','39099','1958-01-05','M','',':RET:2106-3','N','021','DEN','636690','99734OH005000301','2014-01-01','2013-12-02 12:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:00'),(24816,19676,'N','01','021','EC','A',NULL,NULL,'','0000757194','0000784410','','IL','1','Nowland','Steven','R','','','34','221332990','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1980-02-12','M','',':RET:2106-3','T','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.98',NULL,0,'2014-02-20 04:50:15'),(19030,15155,'N','01','021','EC','A',NULL,NULL,'','0000625451','0001132784','','IL','1','Mcwhorter','James','L','','','34','282587156','464 GATES RD',0,'HAMILTON','OH','45013','9023','CY','39017','1964-11-16','M','',':RET:2106-3','T','021','HLT','2380512','92036OH004001201','2014-03-01','2014-01-17 15:56:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','338.65',NULL,0,'2014-01-20 08:06:30'),(4260,3395,'Y','18','021','EC','A','','','AC','0000968210','0000968210','OH00000195070','IL','1','musil','mary',NULL,NULL,NULL,NULL,NULL,'6810 CHIPPEWA RD',0,'MEDINA','OH','44256','8573','CY','39103','1961-11-28','F','M',':RET:2106-3','T','021','HLT','1485820','52664OH151001501','2014-01-01','2013-12-17 13:09:05','645.00',NULL,NULL,'1257.10','612.10','R-OH012','OH0','600.41',NULL,0,'2013-12-25 21:51:31'),(7229,5730,'N','01','021','EC','A',NULL,NULL,'','0000314681','0000843317','','IL','1','Woofter','James','Brian','','','34','298821491','316 GREENBRIAR DR',0,'CORTLAND','OH','44410','1615','CY','39155','1968-09-13','M','',':RET:2106-3','N','021','DEN','1250614','99734OH005000401','2014-01-01','2013-12-14 16:02:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:01:18'),(17501,13994,'Y','18','021','EC','A','','','AC','0000773995','0000773995','OH00002011982','IL','1','MATHEWS','JOHN','','','','34','288507659','8411 TWP. RD. 1166',0,'BETTSVILLE','OH','44815',NULL,'CY','39147','1951-06-07','M','M',':RET:2106-3','N','021','HLT','1734411','92036OH003002704','2014-02-01','2014-01-11 18:58:11','402.00',NULL,NULL,'585.04','183.04','R-OH006','OH0','585.04',NULL,0,'2014-01-13 03:01:25'),(337,277,'Y','18','021','EC','A','','','AC','0000559404','0000559404','OH00000013189','IL','1','Cho','Kyung','Sook','','','34','324685966','2605 N BEND RD',0,'ASHTABULA','OH','44004','8674','CY','39007','1957-02-27','F','M',':RET:2040-4','N','021','DEN','989903','99734OH005000401','2014-01-01','2013-11-09 17:14:39','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:31:52'),(23703,18874,'Y','18','021','EC','A','','','AC','0000463280','0000463280','OH00001560776','IL','1','Brown','Beverly','','','','34','271465955','21487 Meranda Road',0,'MAPLEWOOD','OH','45340',NULL,'CY','39149','1955-04-25','F','M',NULL,'N','021','DEN','2997559','99734OH005000401','2014-03-01','2014-02-14 12:08:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:30:43'),(16149,12932,'N','01','021','EC','A',NULL,NULL,'','0000532115','0000488002','','IL','1','wallbridge','allyson','elizabeth',NULL,NULL,NULL,NULL,'527 S REVERE RD',0,'CINCINNATI','OH','45255','5085','CY','39025','1976-07-02','F','',':RET:2106-3','N','021','HLT','1372273','92036OH001000601','2014-02-01','2014-01-03 15:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','320.56',NULL,0,'2014-01-04 02:06:11'),(7071,5613,'N','19','021','EC','A',NULL,NULL,'','0000566628','0000552634','','IL','1','Blair','Brendan','Monroe','','','34','277133989','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','2007-03-16','M','',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:06'),(22813,18206,'Y','18','024','14','A','','','TE','0000959127','0000959127','','IL','1','Mullen','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-07','F','',NULL,NULL,NULL,'','2074561','','2014-02-11','2014-02-11 15:45:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:01:58'),(14512,11578,'Y','18','021','EC','A','','','AC','0000950149','0000950149','TX00000772271','IL','1','Ali','Amran','S','','','34','327338174','2801 N GRAND ST',0,'AMARILLO','TX','79107','7336','CY','48375','1990-03-13','F','U',':RET:2054-5','N','021','DEN','2013362','33348TX002000201','2014-02-01','2013-12-27 15:55:16','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-28 03:34:04'),(7199,5704,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000752055','','IL','1','Shamy','Austin','J',NULL,NULL,NULL,NULL,'13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',':RET:2106-3','N','021','DEN','1081283','99734OH005000301','2014-01-01','2013-12-14 17:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:36'),(5887,4669,'N','19','021','EC','A',NULL,NULL,'','0000125559','0000776430','','IL','1','Walker','Landin','','','','34','278081679','6803 BREMEN RD SE',0,'LANCASTER','OH','43130','9417','CY','39045','2003-03-11','M','',':RET:2106-3','N','021','DEN','2554208','99734OH005000301','2014-01-01','2013-12-23 22:43:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:34'),(16328,13073,'Y','18','021','EC','A','','','AC','0001587650','0001587650','LA00002391406','IL','1','HECHAVARRIA','JULIO','WALNER','','','34','434976475','1075 ELVIN DR',0,'BATON ROUGE','LA','70810','8711','CY','22033','1970-05-06','M','U',':RET:2106-3','N','021','DEN','1827784','18575LA002000201','2014-02-01','2014-01-06 17:07:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:54'),(9334,7398,'Y','18','021','EC','A','','','AC','0000022787','0000022787','OH00000913354','31','1','Nicely','Larry','','','','34','299480607','PO BOX 146',0,'Fayetteville','OH','45118',NULL,'CY','39015','1950-06-20','M','U',':RET:2106-3','T','021','HLT','2397937','92036OH004000601','2014-01-01','2013-12-21 12:43:22','475.00',NULL,NULL,'585.97','110.97','R-OH005','OH0','585.97',NULL,0,'2013-12-26 04:30:49'),(3111,2499,'Y','18','021','EC','A','','','AC','0001165303','0001165303','OH00000622064','31','1','Jagielski','Christopher','R','','','34','300580709','P. O. Box 545',0,'Dayton','OH','45405',NULL,'CY','39113','1959-12-04','M','U',':RET:2106-3','N','021','HLT','639374','92036OH006000501','2014-01-01','2013-12-05 18:55:00','316.00',NULL,NULL,'402.48','86.48','R-OH003','OH0','402.48',NULL,0,'2013-12-25 20:20:32'),(15310,12243,'Y','18','021','EC','A','','','AC','0000163861','0000163861','TX00001464358','IL','1','Purnell','Terrence','','','','34','426555206','12537 ALFA ROMEO WAY',0,'FRISCO','TX','75033','5259','CY','48121','1977-10-11','M','U',NULL,'N','021','DEN','2522420','33348TX002000101','2014-02-01','2013-12-31 19:17:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2014-01-02 04:23:11'),(28659,22678,'N','01','021','EC','A',NULL,NULL,'','0001904953','0001173644','','IL','1','Migues','Kaven','V','','','34','435235968','28421 GRAND TURK DR',0,'DENHAM SPRINGS','LA','70726','7875','CY','22063','1959-06-27','M','',':RET:2106-3','N','021','DEN','3769650','18575LA002000201','2014-04-01','2014-03-07 19:07:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-08 21:30:43'),(16395,13118,'N','01','021','EC','A',NULL,NULL,'','0000525434','0000355253','','IL','1','penrod','maria','isabel','','','34','455770926','8110 ROYAL FLD',0,'SAN ANTONIO','TX','78255','3318','CY','48029','1985-04-05','F','',NULL,'N','021','DEN','1887562','33348TX002000201','2014-02-01','2014-01-06 10:37:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-07 04:03:41'),(13508,10766,'Y','18','021','EC','A','','','AC','0002006673','0002006673','LA00000502703','31','1','Videau','Patricia','','','','34','433822403','P.O. Box 433',0,'Saint Gabriel','LA','70776',NULL,'CY','22047','1950-11-25','F','U',':RET:2054-5','N','021','DEN','2238099','18575LA002000201','2014-01-01','2013-12-22 21:50:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:02:48'),(21978,17551,'Y','18','021','EC','A','','','AC','0002253953','0002253953','LA00001814306','IL','1','Bradford','anna','','','','34','435533621','134 FOUNTAIN DR',0,'SLIDELL','LA','70458','1559','CY','22103','1975-04-26','F','U',':RET:2106-3','N','021','DEN','3565235','18575LA002000101','2014-03-01','2014-02-06 19:33:41','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-07 19:00:34'),(21295,17016,'Y','18','021','EC','A','','','AC','0002112204','0002112204','LA00002308507','IL','1','Williams','Lakeisha','','','','34','436430510','1733 NEWPORT PL',0,'KENNER','LA','70065','5625','CY','22051','1980-11-09','F','U',':RET:2054-5','T','021','DEN','2856255','18575LA002000101','2014-03-01','2014-02-04 14:52:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-04 21:00:08'),(19848,15830,'Y','18','021','EC','A','','','AC','0001004369','0001004369','OH00002175317','IL','1','chavez','marcela','','','','34','772108352','317 CEDAR ST',0,'PORT CLINTON','OH','43452','1235','CY','39123','1975-12-11','F','M',NULL,'N','021','HLT','2724029','92036OH004002701','2014-03-01','2014-01-24 11:19:31','146.47',NULL,NULL,'195.37','48.90','R-OH006','OH0','195.37',NULL,0,'2014-01-24 21:00:29'),(16620,13296,'Y','18','021','EC','A','','','AC','0000988896','0000988896','OH00001883585','IL','1','Toth','Slavcia','','','','34','297568169','29915 TRUMAN AVE',0,'WICKLIFFE','OH','44092','1721','CY','39085','1955-02-16','F','U',NULL,'N','021','DEN','2235945','99734OH005000401','2014-02-01','2014-01-07 12:21:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:11'),(17343,13874,'Y','18','021','EC','A','','','AC','0000723659','0000723659','MS00001774056','IL','1','little','john','','','','34','587198740','1340 TROPICAL CV',0,'GULFPORT','MS','39507','6003','CY','28047','1966-07-09','M','U',':RET:2054-5','N','021','DEN','2430369','46300MS002000201','2014-02-01','2014-01-10 17:26:22','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-13 02:24:04'),(6790,5385,'Y','18','021','EC','A','','','AC','0000166349','0000166349','TX00001063290','IL','1','butler','lsteifa','','','','34','589114092','3809 EDGEFIELD ST',0,'KILLEEN','TX','76549','5022','CY','48027','1990-08-30','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','528502','33348TX002000201','2014-01-01','2013-11-25 15:59:58','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 01:17:03'),(2005,1644,'Y','18','021','EC','A','','','AC','0000805081','0000805081','OH00000671841','IL','1','BARNETT','BONNIE','SUE','','','34','302440484','5 SWEET GUM LN',0,'MILFORD','OH','45150','2540','CY','39025','1949-06-04','F','M',':RET:2106-3','N','021','HLT','216019','92036OH006000601','2014-01-01','2013-11-20 10:03:26','198.00',NULL,NULL,'510.73','312.73','R-OH005','OH0','510.73',NULL,0,'2013-12-25 19:02:18'),(8077,6396,'Y','18','024','14','A','','','TE','0000911735','0000911735','','IL','1','Levo','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-12-10','F','',NULL,NULL,NULL,'','381785','','2013-12-20','2013-12-20 13:22:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:22'),(13027,10384,'N','01','021','EC','A',NULL,NULL,'','0000830627','0000475967','','IL','1','Hurst','Susan','Kay','','','34','290481629','21395 COUNTY ROAD U',0,'NAPOLEON','OH','43545','9407','CY','39069','1953-07-04','F','',':RET:2106-3','N','021','DEN','1744409','99734OH005000401','2014-01-01','2013-12-22 22:03:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:15'),(22066,17614,'N','01','021','EC','A',NULL,NULL,'','0000418005','0000920331','','IL','1','Hazari','Sushilaben','Dayasagar','','','34','634138996','2310 WHITE ST',0,'CLIFTON','TX','76634','1135','CY','48035','1967-10-14','F','',':RET:2029-7','N','021','DEN','3495532','33348TX002000201','2014-03-01','2014-02-08 13:48:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-08 19:00:12'),(19243,15333,'Y','18','021','EC','A','','','AC','0000909506','0000909506','OH00002521769','IL','1','Calaway','Susan','','','','34','293520285','532 PHEASANT RUN',0,'TALLMADGE','OH','44278','3602','CY','39153','1951-01-28','F','U',':RET:2106-3','N','021','HLT','3211386','52664OH151001501','2014-03-01','2014-01-20 14:40:23','400.00',NULL,NULL,'789.56','389.56','R-OH012','OH0','789.56',NULL,0,'2014-01-21 08:46:38'),(24659,19575,'Y','18','021','EC','A','','','AC','0000509255','0000509255','OH00002864335','IL','1','johnson','margaretta','','','','34','102609964','817 HOAG ST',0,'TOLEDO','OH','43607','4114','CY','39095','1969-03-14','F','M',NULL,'N','021','HLT','3338672','92036OH004002601','2014-04-01','2014-02-19 15:38:13','219.00',NULL,NULL,'452.82','233.82','R-OH001','OH0','226.41',NULL,0,'2014-02-20 04:24:57'),(23589,18791,'N','19','021','EC','A',NULL,NULL,'','0000389882','0001026981','','S1','1','Schanz','Cynthia','','','','34','302988402','798 N SUMMIT ST',0,'BARBERTON','OH','44203','1523','CY','39153','1996-06-27','M','',':RET:2106-3','N','021','HLT','3127425','52664OH152000901','2014-03-01','2014-02-13 11:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-02-13 22:03:01'),(1776,1464,'Y','18','021','EC','A','','','AC','0000432762','0000432762','OH00000847228','IL','1','miller','scott',NULL,NULL,NULL,NULL,NULL,'94 marion ave',0,'mogadore','OH','44260',NULL,'CY','39153','1980-04-29','M','M',':RET:2106-3','N','021','DEN','2417846','99734OH005000301','2014-01-01','2013-12-24 15:00:23','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:56:15'),(27996,22152,'N','01','021','EC','A',NULL,NULL,'','0000521015','0000491931','','IL','1','DECKER','ALICE','','','','34','290761080','975 MILLER AVE',0,'NEWARK','OH','43055',NULL,'CY','39089','1964-12-25','F','',NULL,'T','021','DEN','3187864','99734OH005000401','2014-04-01','2014-03-05 19:06:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:06'),(7919,6262,'Y','18','021','EC','A','','','AC','0002377630','0002377630','LA00000158281','IL','1','Williams','Sharon','Dian','','','34','438213396','362 PORTER ST',0,'MANSFIELD','LA','71052','2157','CY','22031','1964-11-17','F','M',':RET:2054-5','N','021','DEN','2508757','18575LA002000201','2014-01-01','2013-12-19 23:11:40','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:06:17'),(17107,13691,'Y','18','021','EC','A','','','AC','0000457820','0000457820','OH00002489656','IL','1','Null','Vickie','','','','34','295584309','4901 Turkey Road',0,'Hillsboro','OH','45133',NULL,'CY','39071','1958-04-07','F','M',NULL,'N','021','HLT','2592942','92036OH004000601','2014-02-01','2014-01-08 14:01:21','895.06',NULL,NULL,'901.65','6.59','R-OH005','OH0','384.93',NULL,0,'2014-01-13 02:21:35'),(19955,15917,'Y','18','024','14','A','','','TE','0001213185','0001213185','','IL','1','Ngezelonye','Austen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-02','M','',NULL,NULL,NULL,'','2713741','','2014-01-24','2014-01-24 18:31:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-25 19:00:04'),(19770,15760,'Y','18','024','14','A','','','TE','0000768902','0000768902','','IL','1','McCune','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-26','M','',NULL,NULL,NULL,'','2758359','','2014-01-23','2014-01-23 16:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:28'),(1680,1402,'Y','18','021','EC','A','','','AC','0001664140','0001664140','LA00001094122','31','1','Beauchamp','Anthony','','','','34','439086460','P. O. Box 872402',0,'New Orleans','LA','70187',NULL,'CY','22071','1958-08-23','M','M',NULL,'N','021','DEN','1559168','18575LA002000101','2014-01-01','2013-12-24 09:58:14','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:08'),(15966,12778,'Y','18','021','EC','A','','','AC','0000837392','0000837392','TX00000489063','IL','1','Dunn','Stephanie','','','','34','457239387','212 HARLEY RIDGE RD',0,'LONGVIEW','TX','75604','9637','CY','48183','1967-02-11','F','U',NULL,'N','021','DEN','2414352','33348TX002000201','2014-02-01','2014-01-02 18:29:58','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-04 02:00:27'),(9590,7594,'Y','18','021','EC','A','','','AC','0000531145','0000531145','MS00000610734','IL','1','Kessler','Theresa','','','','34','426439109','1094 DESOTO ST',0,'BILOXI','MS','39530','1725','CY','28047','1968-05-22','F','U',':RET:2106-3','N','021','DEN','2251304','46300MS002000201','2014-01-01','2013-12-21 15:23:52','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 04:37:07'),(13099,10444,'Y','18','021','EC','A','','','AC','0000226022','0000226022','OH00001010904','IL','1','Erwin','Ryan','','','','34','295904704','2360 East Market St. Apt. 2F',0,'Akron','OH','44312',NULL,'CY','39153','1986-02-27','M','U',':RET:2106-3','N','021','DEN','2320385','99734OH005000401','2014-01-01','2013-12-23 12:43:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:52:07'),(14000,11153,'Y','18','021','EC','A','','','AC','0000934662','0000934662','OH00001177643','IL','1','Trenary','Robin','','','','34','274844405','10067.5 market street',0,'north lima','OH','44452',NULL,'CY','39099','1978-02-14','F','U',':RET:2106-3','T','021','HLT','2029298','92036OH002003201','2014-01-01','2013-12-23 07:40:52','126.00',NULL,NULL,'392.80','266.80','R-OH013','OH0','392.80',NULL,0,'2013-12-26 13:16:01'),(17543,14026,'Y','18','021','EC','A','','','AC','0000385921','0000385921','OH00001888667','IL','1','Rogers','Raymond','','','','34','293703329','5336 DONNER DR',0,'CLINTON','OH','44216','9711','CY','39153','1976-02-17','M','U',':RET:2106-3','N','021','HLT','1639065','52664OH152000901','2014-02-01','2014-01-12 12:16:20','127.00',NULL,NULL,'202.22','75.22','R-OH012','OH0','202.22',NULL,0,'2014-01-13 03:01:49'),(27227,21560,'Y','18','021','EC','A','','','AC','0002183547','0002183547','LA00003577223','IL','1','Van Calsem','Crystal','','','','34','435539978','106 Kappa St',0,'Belle Chasse','LA','70037',NULL,'CY','22075','1981-10-21','F','U',':RET:2106-3','N','021','DEN','3242358','18575LA002000101','2014-04-01','2014-03-03 16:23:23','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-03 21:31:39'),(20828,16647,'Y','18','024','14','A','','','TE','0001616396','0001616396','','IL','1','Goodman-Daniel','Diane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-04-17','F','',NULL,NULL,NULL,'','2154723','','2014-01-31','2014-01-31 15:52:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-31 21:00:39'),(3014,2423,'N','01','021','EC','A',NULL,NULL,'','0001186272','0001016818','','IL','1','DeCastro','Danielle','','','','34','293803042','1586 NORLEDGE RD',0,'AKRON','OH','44305','1343','CY','39153','1983-10-01','F','',':RET:2106-3','N','021','HLT','629470','52664OH151001305','2014-01-01','2013-12-06 18:09:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11',NULL,0,'2013-12-25 20:18:00'),(6511,5161,'Y','18','021','EC','A','','','AC','0000993949','0000993949','OH00000708062','IL','1','cochoy','dale','','','','34','298482682','13262 KAUFMAN AVE NW',0,'HARTVILLE','OH','44632','9040','CY','39151','1949-05-09','M','M',':RET:2106-3','N','021','HLT','1041125','52664OH152000901','2014-01-01','2013-12-11 15:06:51','0.00',NULL,NULL,'490.00','490.00','R-OH015','OH0','490.00',NULL,0,'2013-12-26 00:51:08'),(5454,4333,'N','01','021','EC','A',NULL,NULL,'','0000637093','0001237688','','IL','1','HATTON','KATHY','','','','34','282508323','1816 FERNWOOD ST',0,'MIDDLETOWN','OH','45044','6432','CY','39017','1951-03-26','F','',':RET:2106-3','N','021','HLT','2037927','92036OH003001204','2014-01-01','2013-12-19 09:49:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','644.07',NULL,0,'2013-12-25 23:10:15'),(2502,2038,'Y','18','024','14','A','','','TE','0000161576','0000161576','','IL','1','Pevey','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-23','M','',NULL,NULL,NULL,'','987327','','2013-12-09','2013-12-09 17:52:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:36:03'),(5060,4009,'Y','18','021','EC','A','','','AC','0000882347','0000882347','TX00000271540','IL','1','White','Matthew','','','','34','637303832','3321NW NW 24TH ST',0,'FORT WORTH','TX','76106','3342','CY','48439','1992-04-22','M','U',':RET:2054-5','N','021','DEN','2601249','33348TX002000201','2014-01-01','2013-12-19 00:43:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:00:24'),(17798,14217,'Y','18','021','EC','A','','','AC','0000241543','0000241543','OH00001710420','IL','1','SEDDENS','WILLIAM','','','','34','268584836','170 SADDLEBROOK DR',0,'LIMA','OH','45807','2074','CY','39003','1960-03-28','M','M',NULL,'N','021','HLT','2746098','92036OH005001505','2014-02-01','2014-01-13 16:10:17','387.00',NULL,NULL,'448.97','61.97','R-OH002','OH0','448.97',NULL,0,'2014-01-14 01:33:52'),(18384,14673,'Y','18','021','EC','A','','','AC','0000359702','0000359702','OH00001811102','IL','1','WIGGINS','SHANE','','','','34','400419929','2224 KEMPER LN',0,'CINCINNATI','OH','45206','2719','CY','39061','1988-09-07','M','U',NULL,'N','021','DEN','2751541','99734OH005000301','2014-02-01','2014-01-15 13:15:14','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:36'),(20611,16469,'Y','18','021','EC','A','','','AC','0000901100','0000901100','OH00001493906','IL','1','Weber','David','','','','34','274605061','309 SCHROCK RD',0,'WORTHINGTON','OH','43085','3214','CY','39049','1970-09-19','M','U',':RET:2106-3','N','021','DEN','2696890','99734OH005000401','2014-03-01','2014-01-30 17:03:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:17'),(21652,17291,'Y','18','021','EC','A','','','AC','0001302112','0001302112','LA00001760468','IL','1','Benit-Laing','Patricia','','','','34','437418857','4639 EASTERN ST',0,'NEW ORLEANS','LA','70122','6123','CY','22071','1971-01-20','F','M',':RET:2106-3','N','021','DEN','3563917','18575LA002000201','2014-03-01','2014-02-04 20:49:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:50'),(27823,22004,'N','01','021','EC','A',NULL,NULL,'','0000982764','0000280893','','IL','1','HOBBS','MARY','','','','34','298883385','6042 5TH AVE',0,'MIAMISBURG','OH','45342','5117','CY','39113','1986-12-06','F','',NULL,'N','021','DEN','3482622','99734OH005000301','2014-04-01','2014-03-05 01:18:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:31:57'),(25705,20392,'Y','18','021','EC','A','','','AC','0001085115','0001085115','TX00003282332','IL','1','Carroll','holly','','','','34','419255507','4400 paluxy drive',0,'Tyler','TX','75703',NULL,'CY','48423','1974-07-03','F','M',':RET:2106-3','N','021','DEN','2702048','33348TX002000201','2014-04-01','2014-02-24 14:37:35','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-02-26 09:30:20'),(19685,15687,'N','01','021','EC','A',NULL,NULL,'','0001118247','0001053544','','IL','1','GRANT','CHARLIE','','','','34','067626527','595 JIM CANNON RD',0,'VAN ALSTYNE','TX','75495','2729','CY','48181','1964-04-29','M','',':RET:2106-3','N','021','DEN','2815178','33348TX002000201','2014-03-01','2014-01-23 13:09:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:40'),(14776,11799,'Y','18','021','EC','A','','','AC','0000260472','0000260472','OH00000484185','IL','1','ARMOUR','DIANE','','','','34','299584575','2175 PRESTWICK DR',0,'UNIONTOWN','OH','44685','7552','CY','39153','1957-05-20','F','U',NULL,'N','021','HLT','2254214','52664OH151001501','2014-01-01','2013-12-23 20:32:27','0.00',NULL,NULL,'624.00','624.00','R-OH012','OH0','624.00',NULL,1,'2013-12-29 11:13:06'),(15830,12674,'Y','18','021','EC','A','','','AC','0001108099','0001108099','OH00001650421','IL','1','Decker','Deborah','','','','34','283603449','344 Greenacres Dr',0,'Springfield','OH','45504',NULL,'CY','39023','1957-07-05','F','U',':RET:2106-3','N','021','DEN','1755345','99734OH005000401','2014-02-01','2014-01-01 19:57:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:03:49'),(3938,3152,'Y','18','021','EC','A','','','AC','0000422796','0000422796','OH00001063619','IL','1','Simpkins','Michelle','','','','34','268842451','3009 RAVENWOOD BLVD',0,'TOLEDO','OH','43614','3725','CY','39095','1972-07-11','F','M',NULL,'N','021','HLT','474435','92036OH002002601','2014-01-01','2013-12-13 09:03:29','159.00',NULL,NULL,'293.20','134.20','R-OH001','OH0','293.20',NULL,0,'2013-12-25 21:37:50'),(8116,6420,'Y','18','021','EC','A','','','AC','0000713601','0000713601','OH00000579461','IL','1','FISHER','THOMAS','','','','34','282506896','26 S CLAY ST',0,'BROOKVILLE','OH','45309','1409','CY','39113','1950-09-10','M','M',':RET:2106-3','N','021','DEN','380629','99734OH005000401','2014-01-01','2013-11-21 18:57:15','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:15:10'),(8942,7091,'Y','18','021','EC','A','','','AC','0000452731','0000452731','OH00000584907','IL','1','Clark','Bonnie','','','','34','378583451','254 DeHoff',0,'Youngstown','OH','44515',NULL,'CY','39099','1951-10-29','F','M',':RET:2106-3','N','021','DEN','2031168','99734OH005000401','2014-01-01','2013-12-18 10:55:21','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:03:22'),(25421,20170,'N','01','021','EC','A',NULL,NULL,'','0000221373','0001155145','','IL','1','BURKAY','PAULA','','','','34','270724690','1165 NAVAJO TRAIL',0,'STREETSBORO','OH','44241',NULL,'CY','39133','1972-01-21','F','',':RET:2106-3','T','021','DEN','3391734','99734OH005000401','2014-04-01','2014-02-25 15:02:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:31:09'),(25171,19966,'Y','18','021','EC','A','','','AC','0000824643','0000824643','OH00002702237','IL','1','Pennington','Elizabeth','','','','34','383063292','9221 Meadow Drive',0,'Maineville','OH','45039',NULL,'CY','39165','1979-07-30','F','U',':RET:2106-3','N','021','DEN','3150440','99734OH005000401','2014-04-01','2014-02-21 10:37:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-21 22:00:28'),(22254,17762,'Y','18','021','EC','A','','','AC','0000136314','0000136314','MS00002649321','31','1','MCCOLLUM','ROBERT','','','','34','564316742','6068 HWY 98 WEST',0,'HATTIESBURG','MS','39402',NULL,'CY','28073','1959-11-28','M','M',NULL,'N','021','DEN','2618625','46300MS002000201','2014-03-01','2014-02-09 17:26:31','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2014-02-09 19:00:44'),(28679,22695,'Y','18','021','EC','A','','','AC','0000998843','0000998843','OH00002683634','IL','1','robinette','jason','','','','34','296807445','120 MCKINLEY ST',0,'WELLINGTON','OH','44090','1336','CY','39093','1982-07-16','M','U',':RET:2106-3','N','021','DEN','3306819','99734OH005000301','2014-04-01','2014-03-07 21:10:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-08 21:30:55'),(16692,13358,'Y','18','021','EC','A','','','AC','0001225546','0001225546','TX00001913404','IL','1','Navarro','Bertha','','','','34','467139054','1408 LOOKOUT',0,'EDINBURG','TX','78541','2347','CY','48215','1954-08-20','F','U',':RET:2106-3','N','021','DEN','2001841','33348TX002000201','2014-02-01','2014-01-07 12:56:21','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-08 18:24:35'),(579,474,'Y','18','021','EC','A','','','AC','0000293157','0000293157','OH00000529560','IL','1','McDowell','Scott','','','','34','135864748','94 STONEGATE CIR',0,'BOWLING GREEN','OH','43402','9291','CY','39173','1983-01-12','M','U',':RET:2106-3','N','021','HLT','919708','92036OH005002604','2014-01-01','2013-12-04 07:57:11','19.00',NULL,NULL,'221.32','202.32','R-OH001','OH0','221.32',NULL,0,'2013-12-25 17:50:48'),(14841,11851,'Y','18','021','EC','A','','','AC','0000519836','0000519836','OH00000355106','IL','1','Edwards','Carol','','','','34','270683629','303E Wapakoneta St',0,'Waynesfield','OH','45896',NULL,'CY','39011','1959-03-25','F','M',':RET:2106-3','N','021','HLT','2082375','92036OH003001505','2014-01-01','2013-12-23 20:52:37','948.00',NULL,NULL,'1076.31','128.31','R-OH002','OH0','490.70',NULL,1,'2013-12-29 11:14:49'),(9644,7641,'Y','18','021','EC','A','','','AC','0000590814','0000590814','TX00000183798','IL','1','BRUBAKER','MARC','ERICSON','','','34','465696814','5903 NANCY ANN ST',0,'HOUSTON','TX','77009','1308','CY','48201','1984-04-12','M','R',':RET:2106-3','N','021','DEN','2142208','33348TX002000101','2014-01-01','2013-12-21 14:23:13','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 04:38:34'),(5582,4427,'N','01','021','EC','A',NULL,NULL,'','0001184944','0000444398','','IL','1','mcgee','alicia','','','','34','637641479','555 county road 4315',0,'omaha','TX','75571',NULL,'CY','48449','1979-06-23','F','',NULL,'N','021','DEN','199100','33348TX002000201','2014-01-01','2013-11-06 00:05:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:16:58'),(2964,2387,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','716280','','2013-12-06','2013-12-06 00:26:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 20:16:50'),(16938,13556,'Y','18','024','14','A','','','TE','0001471488','0001471488','','IL','1','WILLIAMS','EUGENIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-18','F','',NULL,NULL,NULL,'','2410492','','2014-01-09','2014-01-09 09:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 02:19:52'),(598,492,'Y','18','021','EC','A','','','AC','0000145366','0000145366','OH00000614052','IL','1','Steed','Adam','','','','34','503786846','208 Parkwood Avenue',0,'Columbus','OH','43203',NULL,'CY','39049','1971-10-21','M','M',':RET:2106-3','N','021','DEN','260484','99734OH005000401','2014-01-01','2013-12-15 20:49:30','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:00:15'),(776,641,'Y','18','021','EC','A','','','AC','0000097422','0000097422','TX00000787272','IL','1','Ashton','Erikalin','','','','34','223132719','4424 Gaines Ranch Loop',0,'Austin','TX','78735',NULL,'CY','48453','1972-01-15','F','R',':RET:2106-3','N','021','DEN','2227677','33348TX002000201','2014-01-01','2013-12-16 13:17:36','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:57'),(7536,5964,'N','19','021','EC','A',NULL,NULL,'','0000048245','0000617480','','IL','1','Zander','Breanna','','','','34','644329493','2900 Shalimar Dr.',0,'Plano','TX','75023',NULL,'CY','48085','1992-10-30','F','',':RET:2106-3','N','021','DEN','942959','33348TX002000201','2014-01-01','2013-12-15 11:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:32:48'),(7437,5886,'Y','18','021','EC','A','','','AC','0000307086','0000307086','OH00000004041','IL','1','WAGNER','MARCIA','','','','34','277745372','373 E ARCHWOOD AVE',0,'AKRON','OH','44301','2138','CY','39153','1964-05-09','F','M',':RET:2106-3','N','021','HLT','269477','52664OH151001304','2014-01-01','2013-12-15 11:08:44','511.00',NULL,NULL,'760.90','249.90','R-OH012','OH0','380.45',NULL,0,'2013-12-26 02:30:19'),(2013,1652,'Y','18','021','EC','A','','','AC','0000665596','0000665596','OH00001033104','IL','1','Stubbs','Linda','','','','34','296488183','440 PRAIRIE AVE',0,'WILMINGTON','OH','45177','1749','CY','39027','1949-10-05','F','U',':RET:2106-3','N','021','HLT','381695','92036OH002000601','2014-01-01','2013-11-20 13:32:21','350.00',NULL,NULL,'743.71','393.71','R-OH005','OH0','743.71',NULL,0,'2013-12-25 19:02:33'),(5536,4392,'Y','18','021','EC','A','','','AC','0000618322','0000618322','OH00000745569','IL','1','shirkoobiye','hawo','a','','','34','634842032','5123 sliver wood lane',0,'frankline','OH','43016',NULL,'CY','39049','1971-01-01','F','M',':RET:2054-5','N','021','DEN','789845','99734OH005000401','2014-01-01','2013-11-27 14:54:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:42'),(5125,4062,'Y','18','021','EC','A','','','AC','0001116558','0001116558','TX00001123589','IL','1','Mattick','Carol','','','','34','585948138','721 GOLFCREST DR',0,'WINDCREST','TX','78239','2623','CY','48029','1957-01-13','F','R',':RET:2106-3','N','021','DEN','2131819','33348TX002000101','2014-01-01','2013-12-18 19:05:52','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2013-12-25 23:02:03'),(15069,12046,'Y','18','021','EC','A','','','AC','0000093915','0000093915','MS00000451713','IL','1','Verner','Mary','','','','34','631343896','1470 IRBY ST',0,'GREENVILLE','MS','38701','7146','CY','28151','1988-03-11','F','U',':RET:2106-3','N','021','DEN','2458750','46300MS002000101','2014-02-01','2013-12-29 19:13:35','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-01 12:03:50'),(4266,3398,'N','01','021','EC','A',NULL,NULL,'','0001152170','0000879460','','IL','1','Griffith','Jeffery','','','','34','277562485','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1961-11-28','M','',':RET:2106-3','N','021','HLT','2499077','92036OH003001501','2014-01-01','2013-12-16 20:37:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.63',NULL,0,'2013-12-25 21:51:39'),(20566,16436,'Y','18','021','EC','A','','','AC','0000848385','0000848385','OH00001945495','IL','1','Reed','Tylor','','','','34','268944854','226 MIDLAND AVE',0,'FINDLAY','OH','45840','4645','CY','39063','1991-03-02','M','U',':RET:2106-3','N','021','HLT','3102549','92036OH004001501','2014-03-01','2014-01-29 13:14:55','120.00',NULL,NULL,'176.96','56.96','R-OH002','OH0','176.96',NULL,0,'2014-01-29 21:01:49'),(22770,18179,'Y','18','024','14','A','','','TE','0001095701','0001095701','','IL','1','SELF','STEPHEN','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-21','M','',NULL,NULL,NULL,'','3616832','','2014-02-11','2014-02-11 12:03:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:01:37'),(28764,22768,'Y','18','021','EC','A','','','AC','0001109422','0001109422','TX00003622338','IL','1','Taylor','Carl','','','','34','409947268','17320 E St Hwy 29',0,'Buchanan Dam','TX','78609',NULL,'CY','48299','1950-06-20','M','M',':RET:2106-3','N','021','DEN','3452568','33348TX002000201','2014-04-01','2014-03-09 15:21:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-09 21:00:24'),(28774,22777,'Y','18','021','EC','A','','','AC','0000906662','0000906662','OH00002852553','IL','1','krauss','sarah','','','','34','302743028','4480co .rd. ef',0,'swanton','OH','43558',NULL,'CY','39051','1979-05-07','F','U',':RET:2106-3','N','021','DEN','3700975','99734OH005000401','2014-04-01','2014-03-09 12:25:59','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-09 21:00:31'),(15469,12377,'Y','18','021','EC','A','','','AC','0000695640','0000695640','OH00001857163','IL','1','Dresser','Christine','','','','34','282564842','1480 GRANGER RD',0,'MEDINA','OH','44256','8617','CY','39103','1953-11-01','F','R',':RET:2106-3','N','021','DEN','1701183','99734OH005000401','2014-02-01','2013-12-30 18:48:34','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:28:51'),(998,818,'Y','18','021','EC','A','','','AC','0001099062','0001099062','TX00000337506','IL','1','Adair','Meagan','','','','34','627209823','10034 ELKWOOD GLEN LN',0,'TOMBALL','TX','77375','1033','CY','48201','1988-09-27','F','U',':RET:2106-3','N','021','DEN','1238173','33348TX002000201','2014-01-01','2013-11-11 13:07:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:10:51'),(7865,6224,'Y','18','021','EC','A','','','AC','0001049356','0001049356','OH00000127583','IL','1','CINQUINA','MARY','','','','34','271564295','6850 EILER LN',0,'CINCINNATI','OH','45239','5617','CY','39061','1954-06-18','F','U',NULL,'T','021','DEN','2487893','99734OH005000301','2014-01-01','2013-12-20 15:23:33','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:05:04'),(7690,6089,'N','01','021','EC','A',NULL,NULL,'','0000795506','0001195498','','IL','1','Durig','Leah','Kristen','','','34','592408180','5717 MONTGOMERY RD',0,'CINCINNATI','OH','45212','1932','CY','39061','1982-10-19','F','',':RET:2106-3','N','021','DEN','1378177','99734OH005000401','2014-01-01','2013-12-19 21:05:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:00'),(14661,11703,'Y','18','021','EC','A','','','AC','0000233122','0000233122','TX00000195724','IL','1','DAY','GERALD','','','','34','452048358','730 TURTLE CREEK DR',0,'MISSOURI CITY','TX','77489','5233','CY','48157','1955-07-18','M','M',':RET:2054-5','N','021','DEN','2156608','33348TX002000201','2014-02-01','2013-12-27 23:08:56','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2013-12-29 11:08:00'),(9391,7447,'Y','18','021','EC','A','','','AC','0000479695','0000479695','TX00000258654','IL','1','Rylander','Joshua','','','','34','461699321','2009 PLYMOUTH ROCK DR',0,'RICHARDSON','TX','75081','3946','CY','48113','1984-06-23','M','U',':RET:2106-3','N','021','DEN','1843362','33348TX002000201','2014-01-01','2013-12-20 20:26:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:32:21'),(27449,21722,'N','01','021','EC','A',NULL,NULL,'','0000133372','0001235245','','IL','1','Andrews','Paula','Hurd','','','34','294549525','350 ROBERT DR',0,'KENT','OH','44240','2156','CY','39133','1962-02-26','F','',':RET:2106-3','N','021','HLT','3852436','52664OH151001501','2014-04-01','2014-03-04 09:00:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2014-03-04 21:01:57'),(24794,19662,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000726112','','IL','1','ANAYA','ADLYNN','','','','34','279960857','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1993-04-19','F','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:47:07'),(16436,13151,'N','19','021','EC','A',NULL,NULL,'','0000137584','0000741729','','IL','1','Kost','Timothy','M','','Jr','34','293901601','2462 STROUP RD',0,'ATWATER','OH','44201','9100','CY','39133','1989-02-11','M','',':RET:2106-3','N','021','HLT','2111229','52664OH152000901','2014-02-01','2014-01-06 14:03:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2014-01-07 04:04:59'),(25929,20562,'Y','18','021','EC','A','','','AC','0001093297','0001093297','TX00002966423','31','1','ALVIAR','ROBERTO','','','','34','451176718','PO BOX 486',0,'ALICE','TX','78333',NULL,'CY','48249','1956-09-17','M','U',NULL,'N','021','DEN','3177313','33348TX002000201','2014-03-01','2014-02-26 16:19:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:25'),(1011,828,'Y','18','021','EC','A','','','AC','0000699225','0000699225','OH00000786720','IL','1','Trzcinski','Timothy','','','','34','291587508','5737 WECKERLY RD',0,'WHITEHOUSE','OH','43571','9763','CY','39095','1958-12-05','M','M',':RET:2106-3','N','021','HLT','215943','92036OH006002601','2014-01-01','2013-10-24 14:28:44','290.00',NULL,NULL,'344.86','54.86','R-OH001','OH0','344.86',NULL,0,'2013-12-25 18:11:15'),(15020,12005,'Y','18','021','EC','A','','','AC','0001870531','0001870531','LA00000831558','IL','1','Moore','HILDA','','','','34','434740113','938 7TH ST',0,'NEW ORLEANS','LA','70115','2235','CY','22071','1951-03-08','F','U',':RET:2054-5','N','021','DEN','1924113','18575LA002000201','2014-02-01','2013-12-29 19:02:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:17'),(19911,15880,'Y','18','021','EC','A','','','AC','0000194080','0000194080','OH00002420488','IL','1','MEYERS','DEBRA','A','','','34','163385638','1544 GURLEY AVE',0,'AKRON','OH','44310','2513','CY','39153','1951-03-19','F','M',':RET:2106-3','N','021','HLT','2255053','52664OH151001501','2014-03-01','2014-01-24 10:47:43','454.48',NULL,NULL,'768.43','313.95','R-OH012','OH0','768.43',NULL,0,'2014-01-24 21:01:00'),(26186,20767,'Y','18','021','EC','A','','','AC','0000364946','0000364946','OH00002322214','IL','1','Schafer','Annette','','','','34','273823618','1297 FAGINS RUN RD',0,'NEW RICHMOND','OH','45157','9180','CY','39025','1968-05-26','F','M',':RET:2106-3','N','021','DEN','3476347','99734OH005000301','2014-04-01','2014-02-27 11:36:55','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-02-28 06:30:43'),(23932,19030,'N','01','021','EC','A',NULL,NULL,'','0000998798','0000357213','','IL','1','ASHCRAFT','JAMES','','','','34','276540727','7960 RIO GRANDE DR',0,'CLEVES','OH','45002','2303','CY','39061','1954-06-26','M','',':RET:2106-3','T','021','DEN','3430257','99734OH005000401','2014-03-01','2014-02-15 09:49:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-15 21:00:04'),(9787,7749,'N','01','021','EC','A',NULL,NULL,'','0000631477','0000349221','','IL','1','Thompson','Michael','','','','34','282861900','1274 SERENITY LN',0,'COLUMBUS','OH','43085','4796','CY','39049','1975-07-14','M','',':RET:2106-3','N','021','DEN','582269','99734OH005000301','2014-01-01','2013-10-21 12:15:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:51'),(15585,12472,'Y','18','021','EC','A','','','AC','0000114189','0000114189','OH00001957165','IL','1','Smith','Todd','','','','34','286866405','556 HOWELLS CT',0,'EASTLAKE','OH','44095','1237','CY','39085','1973-03-29','M','U',':RET:2106-3','N','021','DEN','2576450','99734OH005000301','2014-02-01','2013-12-30 19:35:09','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:32:17'),(7390,5850,'Y','18','021','EC','A','','','AC','0000761078','0000761078','OH00000079886','IL','1','Padula','Cassandra','','','','34','273847429','4551 WARREN RAVENNA RD',0,'NEWTON FALLS','OH','44444','8788','CY','39155','1985-09-15','F','U',NULL,'N','021','HLT','1009','52664OH152001001','2014-01-01','2013-11-23 15:59:34','0.00',NULL,NULL,'151.13','151.13','R-OH013','OH0','151.13',NULL,0,'2013-12-26 02:16:09'),(9491,7526,'N','01','021','EC','A',NULL,NULL,'','0000645975','0001149870','','IL','1','Eck','Jennifer','','','','34','295866888','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1985-01-18','F','',':RET:2106-3','N','021','DEN','2255413','99734OH005000401','2014-01-01','2013-12-21 13:26:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:54'),(26231,20805,'Y','18','021','EC','A','','','AC','0000149582','0000149582','TX00002852188','IL','1','Hernandez','Angel','Aurelio','','','34','465658853','1640 RICK RHODES DR',0,'EL PASO','TX','79936','5689','CY','48141','1983-09-24','M','M',NULL,'N','021','DEN','3580477','33348TX002000201','2014-04-01','2014-02-26 23:55:59','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-28 06:31:01'),(24804,19671,'Y','18','021','EC','A','','','AC','0001126924','0001126924','OH00002292001','IL','1','Cheema','Sukhdev','','','','34','296153683','7532 mount whitney',0,'Dayton','OH','45424',NULL,'CY','39113','1979-01-04','M','M',':RET:2028-9','N','021','DEN','3430354','99734OH005000401','2014-04-01','2014-02-19 16:54:51','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-20 04:48:42'),(1119,922,'Y','18','021','EC','A','','','AC','0000303963','0000303963','MS00001072065','IL','1','odum','sarah','','','','34','427512034','119 n 35th ave.',0,'hattiesburg','MS','39401',NULL,'CY','28035','1984-08-10','F','U',':RET:2106-3','T','021','DEN','123078','46300MS002000101','2014-01-01','2013-12-02 21:58:23','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2013-12-25 18:17:46'),(14009,11160,'N','01','021','EC','A',NULL,NULL,'','0000751018','0000987397','','IL','1','Boitnott','James','','','','34','293801760','2830 Hamilton Mason Rd',0,'Hamilton','OH','45011',NULL,'CY','39017','1967-10-27','M','',':RET:2106-3','N','021','HLT','2296047','92036OH001001201','2014-01-01','2013-12-23 11:53:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','388.40',NULL,0,'2013-12-26 13:16:19'),(24357,19346,'Y','18','021','EC','A','','','AC','0001206168','0001206168','LA00002010281','IL','1','SENEGAL','LORI','','','','34','437137784','304 ODILE ST',0,'LAFAYETTE','LA','70501','2033','CY','22055','1969-07-28','F','U',':RET:2054-5','N','021','DEN','3521619','18575LA002000201','2014-04-01','2014-02-18 08:43:45','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-18 22:00:30'),(6489,5140,'Y','18','021','EC','A','','','AC','0001043380','0001043380','OH00000788119','IL','1','Marochino','Joseph','','','','34','270885716','3785 Cascades Blvd',0,'Kent','OH','44240',NULL,'CY','39133','1985-06-01','M','U',':RET:2106-3','N','021','HLT','71941','52664OH151001304','2014-01-01','2013-12-11 11:57:17','74.00',NULL,NULL,'242.41','168.41','R-OH012','OH0','242.41',NULL,0,'2013-12-26 00:50:31'),(17666,14118,'Y','18','021','EC','A','','','AC','0000616888','0000616888','OH00001557253','IL','1','ROBINSON','DELAYNO','','','','34','356541368','7726 DELVIEW DR',0,'WEST CHESTER','OH','45069','3324','CY','39017','1962-12-24','M','M',':RET:2054-5','N','021','DEN','1386705','99734OH005000301','2014-02-01','2014-01-13 16:27:42','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:47'),(17759,14190,'Y','18','021','EC','A','','','AC','0000586710','0000586710','OH00001818981','31','1','TOLLE','MICHAEL','','','','34','278560055','PO BOX 101',0,'seaman','OH','45679',NULL,'CY','39001','1954-06-01','M','M',':RET:2106-3','N','021','HLT','2067459','92036OH004000601','2014-02-01','2014-01-13 11:17:34','792.00',NULL,NULL,'801.45','9.45','R-OH005','OH0','449.32',NULL,0,'2014-01-14 01:33:33'),(23443,18675,'N','17','021','EC','A',NULL,NULL,'','0000552096','0000351955','','S1','1','Greenfield','Lena','','','','34','408798478','1220 Middle Cove Dr',0,'Plano','TX','75023',NULL,'CY','48085','1995-08-08','F','',NULL,'N','021','DEN','2625245','33348TX002000201','2014-03-01','2014-02-13 12:15:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-13 22:01:34'),(23535,18748,'Y','18','021','EC','A','','','AC','0002011493','0002011493','LA00001871970','IL','1','Solomon','Marlo','','','','34','437216043','8731 LOMOND RD',0,'NEW ORLEANS','LA','70127','1537','CY','22071','1973-03-17','F','U',':RET:2054-5','N','021','DEN','3489401','18575LA002000201','2014-03-01','2014-02-13 12:13:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:29'),(28482,22535,'Y','18','021','EC','A','','','AC','0001249644','0001249644','OH00003161477','IL','1','ARORA','MOHINDER','','','','34','277084166','7902 MISTY SHORE DR',0,'WEST CHESTER','OH','45069','9649','CY','39017','1965-10-12','M','M',':RET:2029-7','N','021','DEN','3571445','99734OH005000301','2014-04-01','2014-03-07 14:13:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:31:36'),(9576,7583,'N','19','021','EC','A',NULL,NULL,'','0001218535','0000647068','','IL','1','Hinkle','Nicholas','Ray','','','34','271029622','2593 MAPLE DR',0,'TWINSBURG','OH','44087','2139','CY','39153','1996-09-06','M','',':RET:2106-3','N','021','DEN','2409970','99734OH005000301','2014-01-01','2013-12-21 17:04:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:47'),(27236,21567,'Y','18','021','EC','A','','','AC','0000411025','0000411025','MS00003349831','IL','1','FOSTER','RUBEN','','','Jr','34','428237172','536 MOUNTAIN CREEK FARM RD',0,'FLORENCE','MS','39073',NULL,'CY','28121','1960-06-05','M','M',':RET:2106-3','N','021','DEN','3168208','46300MS002000101','2014-04-01','2014-03-03 13:59:00','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-03 21:31:45'),(7691,6090,'Y','18','021','EC','A','','','AC','0000015253','0000015253','OH00000867296','IL','1','EATHRIDGE','GWENDOLYN','','','','34','292705117','9901 SOPHIA AVE',0,'CLEVELAND','OH','44104',NULL,'CY','39035','1962-05-17','F','U',NULL,'N','021','DEN','1446431','99734OH005000401','2014-01-01','2013-12-19 21:20:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:02'),(7189,5698,'Y','18','021','EC','A','','','AC','0000247874','0000247874','OH00000201403','IL','1','Smith','Deborah','Ann','','','34','294441617','856 MARK AVE',0,'HAMILTON','OH','45013','1743','CY','39017','1951-01-16','F','U',':RET:2106-3','N','021','DEN','7697','99734OH005000301','2014-01-01','2013-12-14 12:47:50','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:00:22'),(2552,2076,'N','01','021','EC','A',NULL,NULL,'','0000626713','0000209603','','IL','1','Audino','Debra','Ann','','','34','188527953','3516 Hopkins Rd',0,'Youngstown','OH','44511',NULL,'CY','39099','1957-06-03','F','',':RET:2106-3','N','021','HLT','928700','52664OH151001501','2014-01-01','2013-12-09 16:08:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','707.63',NULL,0,'2013-12-25 19:37:18'),(27105,21456,'Y','18','021','EC','A','','','AC','0000781950','0000781950','OH00003534946','IL','1','RUFFIN','SHAYNA','LYNN','','','34','290726661','8746 NEPTUNE DR',0,'CINCINNATI','OH','45231','4124','CY','39061','1972-08-08','F','U',':RET:2054-5','N','021','DEN','3018567','99734OH005000301','2014-04-01','2014-03-03 10:16:07','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:24'),(20664,16512,'N','01','021','EC','A',NULL,NULL,'','0000132642','0000872763','','IL','1','Hawkins','Richard','A','','','34','465591352','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1979-01-05','M','',':RET:2054-5','N','021','DEN','2912423','33348TX002000201','2014-03-01','2014-01-30 17:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:45'),(24569,19511,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000230489','','IL','1','ONWUAGBA','BRITTANY','','','','34','443172183','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','2002-07-10','F','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:07:19'),(27042,21417,'Y','18','024','14','A','','','TE','0001405004','0001405004','','IL','1','Murphy','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-08-31','M','',NULL,NULL,NULL,'','3568219','','2014-03-31','2014-03-03 11:19:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-03 21:00:22'),(2426,1976,'Y','18','021','EC','A','','','AC','0000469519','0000469519','OH00000150007','IL','1','Weihrauch','Pamela','','','','34','291508296','109 Hartford Ct',0,'Lima','OH','45805',NULL,'CY','39003','1951-05-16','F','U',':RET:2106-3','N','021','DEN','968154','99734OH005000401','2014-01-01','2013-12-09 16:25:02','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 19:34:01'),(23496,18717,'Y','18','021','EC','A','','','AC','0001036819','0001036819','TX00002154450','IL','1','Mask','Tomasita','','','','34','464795679','6055 DOOLEY DR',0,'THE COLONY','TX','75056','1520','CY','48121','1986-10-31','F','M',':RET:2106-3','N','021','DEN','3145544','33348TX002000101','2014-03-01','2014-02-12 22:45:56','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-02-13 22:02:05'),(5046,3995,'Y','18','021','EC','A','','','AC','0000313791','0000313791','MS00001086233','IL','1','Edwards','Vicki','','','','34','428171720','153 BARTON FERRY RD',0,'WEST POINT','MS','39773','5635','CY','28025','1959-06-08','F','U',':RET:2054-5','N','021','DEN','61322','46300MS002000101','2014-01-01','2013-12-07 15:29:52','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 22:48:09'),(27984,22141,'Y','18','021','EC','A','','','AC','0001471526','0001471526','LA00003711651','IL','1','Teets','Amberle','','','','34','216083241','2455 Weldwood Dr',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1985-04-06','F','U',':RET:2106-3','N','021','DEN','4043222','18575LA002000201','2014-04-01','2014-03-06 16:14:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:59'),(16240,13006,'Y','18','021','EC','A','','','AC','0001709242','0001709242','LA00000397574','IL','1','London','Whitney','','','','34','435833914','4010 Gibson St.',0,'New Orleans','LA','70122',NULL,'CY','22071','1988-07-04','F','U',':RET:2054-5','N','021','DEN','1648854','18575LA002000101','2014-02-01','2014-01-04 15:43:25','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-05 00:02:20'),(5831,4631,'Y','18','021','EC','A','','','AC','0000607689','0000607689','TX00000301846','IL','1','Rodriguez','Griselda','','','','34','627264548','229 FAUST AVE',0,'SAN ANTONIO','TX','78237','1639','CY','48029','1991-09-20','F','U',NULL,'N','021','DEN','1764587','33348TX002000201','2014-01-01','2013-12-23 23:18:08','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:48:18'),(15512,12410,'Y','18','021','EC','A','','','AC','0001227033','0001227033','OH00000089509','IL','1','Jones','Julie','','','','34','514824262','7971 Bristol Bane Court',0,'Dublin','OH','43016',NULL,'CY','39049','1981-03-16','F','U',':RET:2106-3','N','021','DEN','2405361','99734OH005000401','2014-02-01','2013-12-31 17:40:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:30:02'),(17095,13681,'Y','18','021','EC','A','','','AC','0001196672','0001196672','TX00002194641','IL','1','Gonzalez','Maria','D','','','34','458231694','109 S LIBERTY LOOP',0,'SAN JUAN','TX','78589','4012','CY','48215','1953-11-01','F','U',NULL,'N','021','DEN','1920141','33348TX002000201','2014-02-01','2014-01-08 15:26:56','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-13 02:21:29'),(3119,2506,'Y','18','021','EC','A','','','AC','0000277246','0000277246','OH00001029397','IL','1','pesek','adam','','','','34','269747521','12379 EATON BLVD',0,'GRAFTON','OH','44044','9552','CY','39093','1970-08-25','M','U',NULL,'T','021','DEN','261059','99734OH005000301','2014-01-01','2013-10-12 19:37:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:30:14'),(7885,6236,'N','19','021','EC','A',NULL,NULL,'','0000637097','0000812020','','S3','1','AGARWAL','NEIL','PRAHLAD','','','34','296045870','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','2000-04-17','F','',':RET:2029-7','N','021','DEN','1767706','99734OH005000301','2014-01-01','2013-12-20 18:44:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:29'),(18743,14935,'Y','18','021','EC','A','','','AC','0000898479','0000898479','OH00002506781','IL','1','mooneyham','rebecca','','','','34','300521065','7190 MIDDLE RIDGE RD',0,'MADISON','OH','44057','3010','CY','39085','1954-04-14','F','M',NULL,'N','021','DEN','2468088','99734OH005000301','2014-02-01','2014-01-15 19:27:29','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:40'),(5801,4608,'N','01','021','EC','A',NULL,NULL,'','0000468103','0000884199','','IL','1','Landfeld','Bedrich',NULL,NULL,NULL,NULL,NULL,'12802 Morning Glory Trail',0,'Chesterland','OH','44026',NULL,'CY','39055','1952-07-27','M','',':RET:2106-3','N','021','DEN','2341513','99734OH005000401','2014-01-01','2013-12-24 02:20:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:47:30'),(8145,6442,'Y','18','021','EC','A','','','AC','0000990033','0000990033','OH00000496866','IL','1','Likovetz','Betty','','','','34','218545067','2396 MCKENNA AVE',0,'AKRON','OH','44305','2127','CY','39153','1949-10-18','F','M',':RET:2106-3','N','021','HLT','629266','52664OH152000901','2014-01-01','2013-11-21 23:34:08','407.00',NULL,NULL,'490.00','83.00','R-OH012','OH0','490.00',NULL,0,'2013-12-26 03:15:51'),(2126,1745,'N','01','021','EC','A',NULL,NULL,'','0000631486','0000230414','','IL','1','tanvir','samina','','','','34','730098985','meadow green cir',0,'gahanna','OH','43230',NULL,'CY','39049','1970-01-22','F','',':RET:2029-7','N','021','DEN','742038','99734OH005000401','2014-01-01','2013-12-10 14:44:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:17:50'),(4482,3556,'Y','18','021','EC','A','','','AC','0000377445','0000377445','OH00000888165','IL','1','foster','mark','','','','34','272725875','726 WALLINGER DR',0,'GALLOWAY','OH','43119','8752','CY','39049','1974-04-18','M','M',':RET:2106-3','T','021','DEN','775664','99734OH005000301','2014-01-01','2013-12-12 15:35:22','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:03:00'),(14010,11161,'Y','18','021','EC','A','','','AC','0000298219','0000298219','OH00001173780','IL','1','wright','nolan','','','','34','271748872','12693 st rt 134',0,'martinsville','OH','45146',NULL,'CY','39027','1976-04-21','M','M',':RET:2106-3','T','021','HLT','2186936','92036OH003000606','2014-01-01','2013-12-23 09:47:52','208.00',NULL,NULL,'319.16','111.16','R-OH005','OH0','319.16',NULL,0,'2013-12-26 13:16:21'),(6555,5196,'N','01','021','EC','A',NULL,NULL,'','0000632290','0000222933','','IL','1','LEE','ZOE','WANG','','','34','645707573','1625 AVENUE P',0,'HUNTSVILLE','TX','77340',NULL,'CY','48471','1975-01-21','F','',':RET:2028-9','N','021','DEN','450537','33348TX002000201','2014-01-01','2013-12-11 12:53:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:52:16'),(22583,18036,'Y','18','024','14','A','','','TE','0001084188','0001084188','','IL','1','ALBERS','KENNETH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-23','M','',NULL,NULL,NULL,'','3702745','','2014-02-10','2014-02-10 12:08:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:32:04'),(5385,4272,'Y','18','021','EC','A','','','AC','0001804515','0001804515','LA00000795604','IL','1','Tarre','Maria','','','','34','047741153','1119 RACE ST',0,'NEW ORLEANS','LA','70130','4717','CY','22071','1965-07-03','F','U',':RET:2106-3','N','021','DEN','2436882','18575LA002000201','2014-01-01','2013-12-19 16:15:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:28'),(25841,20485,'Y','18','021','EC','A','','','AC','0000364945','0000364945','OH00002807785','IL','1','Cline','Stephanie','','','','34','294764798','9607 Community Rd',0,'Windham','OH','44288',NULL,'CY','39133','1980-03-24','F','M',':RET:2106-3','T','021','HLT','2832183','52664OH152000901','2014-03-01','2014-02-26 11:36:48','194.00',NULL,NULL,'225.03','31.03','R-OH012','OH0','225.03',NULL,0,'2014-02-26 21:00:35'),(18684,14895,'Y','18','021','EC','A','','','AC','0000320540','0000320540','TX00002182148','31','1','KELLAR','REBECCA','','','','34','377707631','P.O. BOX 63',0,'LEONA','TX','75850',NULL,'CY','48289','1971-03-03','F','M',':RET:2106-3','N','021','DEN','1674829','33348TX002000201','2014-02-01','2014-01-15 20:31:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:21'),(8885,7044,'Y','18','021','EC','A','','','AC','0001216867','0001216867','TX00000942331','IL','1','TORRES','MARIA','','','','34','463439823','3002 NE 11TH AVE',0,'AMARILLO','TX','79107',NULL,'CY','48375','1958-11-21','F','M',NULL,'N','021','DEN','2193127','33348TX002000201','2014-01-01','2013-12-18 15:55:05','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 04:01:52'),(14705,11741,'Y','18','021','EC','A','','','AC','0000581503','0000581503','OH00001766061','IL','1','Fiorino','Jacob','','','','34','224653166','888 Thurber Dr. W.',0,'Columbus','OH','43215',NULL,'CY','39049','1987-11-17','M','U',':RET:2106-3','N','021','DEN','1985268','99734OH005000301','2014-02-01','2013-12-28 12:18:38','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:09:11'),(4406,3502,'Y','18','021','EC','A','','','AC','0000338860','0000338860','OH00000076369','IL','1','JOHNSON','PASHULA','L','','','34','289788945','281 MIDDLEBURY LN',0,'TOLEDO','OH','43612','4512','CY','39095','1977-01-22','F','U',':RET:2054-5','N','021','DEN','452069','99734OH005000401','2014-01-01','2013-12-12 14:39:10','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:01:17'),(13792,11009,'Y','18','021','EC','A','','','AC','0000913266','0000913266','MS00000750528','IL','1','Sotelo','Carlos','','','','34','352822334','308 CRAWFORD ST',0,'SENATOBIA','MS','38668','1807','CY','28137','1977-07-09','M','M',NULL,'N','021','DEN','1417374','46300MS002000101','2014-01-01','2013-12-23 00:30:44','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-26 13:11:06'),(26558,21054,'N','01','021','EC','A',NULL,NULL,'','0001030419','0000496804','','IL','1','Supe','Lauren','','','','34','298909651','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','1985-05-03','F','',':RET:2106-3','N','021','DEN','2969530','99734OH005000301','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:17'),(21841,17442,'Y','18','021','EC','A','','','AC','0001179660','0001179660','OH00002262860','IL','1','Edmisten','Donna','L','','','34','302463275','7150 STATE ROUTE 770',0,'SEAMAN','OH','45679','9516','CY','39001','1950-09-06','F','M',':RET:2106-3','T','021','HLT','2952478','92036OH003000604','2014-03-01','2014-02-06 13:02:51','430.00',NULL,NULL,'761.04','331.04','R-OH005','OH0','761.04',NULL,0,'2014-02-06 21:01:10'),(3180,2557,'Y','18','021','EC','A','','','AC','0000762249','0000762249','OH00000283275','IL','1','CRUM','GAIL','A','','','34','288445818','241 LEAR RD',0,'AVON LAKE','OH','44012',NULL,'CY','39093','1954-09-25','F','M',':RET:2106-3','N','021','HLT','624340','92036OH004000801','2014-01-01','2013-11-18 11:46:46','24.00',NULL,NULL,'489.35','465.35','R-OH011','OH0','489.35',NULL,0,'2013-12-25 20:31:49'),(5875,4662,'Y','18','021','EC','A','','','AC','0000794497','0000794497','OH00000946555','IL','1','Shell','Gary','','','','34','270527476','2842 CYPRESS WAY',0,'CINCINNATI','OH','45212','2446','CY','39061','1951-11-27','M','M',':RET:2106-3','N','021','DEN','2068413','99734OH005000301','2014-01-01','2013-12-23 21:11:41','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:49:19'),(26199,20777,'Y','18','021','EC','A','','','AC','0001108148','0001108148','OH00002946509','IL','1','DePaul','Daniel','J','','','34','299523322','1872 9TH ST',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1961-01-26','M','U',':RET:2106-3','N','021','HLT','3023279','52664OH151001301','2014-04-01','2014-02-26 18:47:28','176.00',NULL,NULL,'454.94','278.94','R-OH012','OH0','454.94',NULL,0,'2014-02-28 06:30:48'),(25799,20459,'Y','18','021','EC','A','','','AC','0000763579','0000763579','OH00002624082','IL','1','Carson','Shante','','','','34','292862494','2452 Vera Ave',0,'Cincinnati','OH','45237',NULL,'CY','39061','1986-06-21','F','U',':RET:2054-5','N','021','DEN','3396829','99734OH005000301','2014-03-01','2014-02-26 11:28:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:15'),(14482,11553,'N','01','021','EC','A',NULL,NULL,'','0001012975','0000160279','','IL','1','Dominguez','Rafael','Manuel','','','34','449781614','2734 Sarita St.',0,'Corpus Christi','TX','78405',NULL,NULL,NULL,'1951-10-24','M','',':RET:2106-3','N','021','DEN','1894342','33348TX002000201','2014-02-01','2013-12-26 21:33:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:17'),(23477,18700,'Y','18','021','EC','A','','','AC','0000378622','0000378622','OH00002192734','IL','1','Houser','Kayle','','','','34','291609817','2781 Sharpsville Rd',0,'Lynchburg','OH','45142',NULL,'CY','39071','1977-02-25','F','U',':RET:2106-3','N','021','HLT','3171487','92036OH003000605','2014-03-01','2014-02-12 19:26:40','167.00',NULL,NULL,'277.53','110.53','R-OH005','OH0','277.53',NULL,0,'2014-02-13 22:01:52'),(9045,7177,'Y','18','021','EC','A','','','AC','0000168879','0000168879','OH00000818086','IL','1','Yokie','James','Michael','','','34','293529245','7155 CHAPEL RD',0,'MADISON','OH','44057','2240','CY','39085','1955-07-13','M','M',NULL,'N','021','HLT','2472454','52664OH151001306','2014-01-01','2013-12-18 16:30:39','900.00',NULL,NULL,'1481.19','581.19','R-OH011','OH0','640.87',NULL,0,'2013-12-26 04:05:56'),(28181,22299,'N','01','021','EC','A',NULL,NULL,'','0000955603','0000274849','','IL','1','Hennies','Jane','Lynn','','','34','268745882','3179 Kennedy-Ford Rd.',0,'Bethel','OH','45106',NULL,'CY','39025','1963-04-20','F','',':RET:2106-3','N','021','HLT','3288625','92036OH004000601','2014-04-01','2014-03-06 13:25:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.28',NULL,0,'2014-03-06 21:02:54'),(25001,19828,'Y','18','021','EC','A','','','AC','0000427684','0000427684','OH00002595139','IL','1','Carbone','Dianna','','','','34','279503681','1627 SLUSSER RD',0,'AKRON','OH','44305','1411','CY','39153','1950-12-21','F','M',':RET:2106-3','N','021','HLT','3498530','52664OH151001305','2014-04-01','2014-02-20 13:45:30','515.00',NULL,NULL,'658.32','143.32','R-OH012','OH0','658.32',NULL,0,'2014-02-20 22:00:46'),(24157,19194,'Y','18','021','EC','A','','','AC','0000736565','0000736565','OH00002793462','IL','1','Swallow','Bonita','','','','34','296669890','269 Marker Rd',0,'Versailles','OH','45380',NULL,'CY','39037','1959-06-06','F','U',':RET:2106-3','T','021','HLT','2801430','92036OH004000501','2014-03-01','2014-02-14 20:00:27','218.00',NULL,NULL,'469.29','251.29','R-OH003','OH0','469.29',NULL,0,'2014-02-15 22:02:00'),(2096,1717,'Y','18','021','EC','A','','','AC','0001153597','0001153597','OH00000577130','IL','1','Wrann','Rosamunde','Monika','','','34','286540364','12160 EASTON ST NE',0,'Alliance','OH','44601',NULL,'CY','39151','1953-05-12','F','U',':RET:2106-3','T','021','DEN','371633','99734OH005000401','2014-01-01','2013-12-09 20:09:34','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 19:17:02'),(7695,6093,'Y','18','021','EC','A','','','AC','0000758255','0000758255','OH00000135372','IL','1','Wood','Patricia','','','','34','282489071','4907 LARKHAVEN DR',0,'TOLEDO','OH','43623','3020','CY','39095','1952-03-24','F','M',':RET:2106-3','N','021','DEN','2070728','99734OH005000401','2014-01-01','2013-12-19 23:29:41','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 03:01:07'),(3615,2894,'Y','18','021','EC','A','','','AC','0001139500','0001139500','OH00001197045','IL','1','Horne','Derrick','','','','34','300781808','518 W 3RD ST',0,'PORT CLINTON','OH','43452','1702','CY','39123','1982-08-09','M','U',NULL,'N','021','HLT','1588896','92036OH004002701','2014-01-01','2013-12-22 13:49:15','180.40',NULL,NULL,'181.73','1.33','R-OH006','OH0','181.73',NULL,0,'2013-12-25 21:23:32'),(20147,16077,'Y','18','024','14','A','','','TE','0001085583','0001085583','','IL','1','Riley','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-02','F','',NULL,NULL,NULL,'','1251335','','2014-01-27','2014-01-27 17:34:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:02'),(19519,15558,'N','19','021','EC','A',NULL,NULL,'','0001037384','0000082587','','IL','1','Scott','William','Kurtis','','','34','278170749','142 BRIARCLIFF AVE',0,'ALLIANCE','OH','44601','2112','CY','39151','2011-06-02','M','',':RET:2106-3','N','021','DEN','2804688','99734OH005000401','2014-03-01','2014-01-22 09:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:18'),(74,66,'N','01','021','EC','A',NULL,NULL,'','0000934632','0000765944','','IL','1','daugherty','steven','c','','','34','302408938','30 FRAZIER RD',0,'ONTARIO','OH','44906','1312','CY','39139','1950-09-02','M','',':RET:2106-3','T','021','DEN','380785','99734OH005000301','2014-01-01','2013-12-05 17:02:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:17:01'),(5549,4404,'Y','18','021','EC','A','','','AC','0001046803','0001046803','OH00000558597','IL','1','Wakelin','Matt','','','','34','292503558','5638 Greenridge',0,'Toledo','OH','43615',NULL,'CY','39095','1957-01-07','M','U',':RET:2106-3','N','021','HLT','1061986','92036OH004002601','2014-01-01','2013-11-26 20:59:21','218.00',NULL,NULL,'365.79','147.79','R-OH001','OH0','365.79',NULL,0,'2013-12-25 23:16:04'),(26731,21186,'N','19','021','EC','A',NULL,NULL,'','0000328462','0000966963','','IL','1','Hedrick','Blake','','','','34','297152175','4825 BURNHAM AVE',0,'TOLEDO','OH','43612','2438','CY','39095','2010-06-05','M','',NULL,'N','021','HLT','3290702','92036OH003002604','2014-01-01','2014-02-28 11:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-28 21:31:49'),(20231,16141,'Y','18','021','EC','A','','','AC','0000310888','0000310888','OH00002064796','IL','1','Bonifas','Kirk','','','','34','284921557','12198 MIDDLEPOINT WETZEL RD',0,'DELPHOS','OH','45833','8808','CY','39161','1990-07-04','M','U',NULL,'N','021','HLT','3289908','92036OH005001506','2014-03-01','2014-01-27 17:15:42','183.00',NULL,NULL,'220.08','37.08','R-OH002','OH0','220.08',NULL,0,'2014-01-27 21:01:50'),(2962,2385,'Y','18','021','EC','A','','','AC','0000449280','0000449280','TX00000797368','31','1','Jernigan','Janice','','','','34','435430034','null null',0,'PANOLA','TX','75685','0282','CY','48365','1965-01-04','F','U',':RET:2106-3','N','021','DEN','1200563','33348TX002000201','2014-01-01','2013-12-06 17:52:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:47'),(2386,1947,'Y','18','024','14','A','','','TE','0001151047','0001151047','','IL','1','vardhan','aniket',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-25','M','',NULL,NULL,NULL,'','159839','','2013-12-09','2013-12-09 11:28:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:33:09'),(9051,7180,'Y','18','021','EC','A','','','AC','0000029031','0000029031','OH00000535342','IL','1','Sinclair','Ruth','','','','34','166484688','330 Cardinal Dr',0,'Medina','OH','44256',NULL,'CY','39103','1955-03-04','F','M',':RET:2106-3','N','021','HLT','2354817','52664OH151001306','2014-01-01','2013-12-18 18:08:00','441.00',NULL,NULL,'568.22','127.22','R-OH012','OH0','568.22',NULL,0,'2013-12-26 04:06:01'),(9763,7730,'N','01','021','EC','A',NULL,NULL,'','0000496721','0000425051','','IL','1','Ditcher','Nancy','','','','34','272526930','4574 MAPLE GROVE RD SE',0,'UHRICHSVILLE','OH','44683','1350','CY','39157','1953-08-19','F','',NULL,'N','021','DEN','350448','99734OH005000401','2014-01-01','2013-10-20 17:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:14'),(15495,12399,'Y','18','021','EC','A','','','AC','0000910534','0000910534','OH00001793375','IL','1','DEVORE','DREW','','','','34','272902005','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1985-09-20','M','M',NULL,'N','021','DEN','2022527','99734OH005000401','2014-02-01','2013-12-31 12:18:07','0.00',NULL,NULL,'71.95','71.95','R-OH015','OH0','0.00',NULL,1,'2014-01-02 04:29:38'),(14697,11734,'Y','18','021','EC','A','','','AC','0000205793','0000205793','OH00001719995','IL','1','Bidlencsik','Cynthia','','','','34','298525603','2614 WALBROOK AVE',0,'CLEVELAND','OH','44109','5547','CY','39035','1952-01-02','F','M',':RET:2106-3','N','021','DEN','1838126','99734OH005000401','2014-02-01','2013-12-28 00:35:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:08:57'),(16719,13380,'N','01','021','EC','A',NULL,NULL,'','0000412782','0000252217','','IL','1','Maldonado','Mirtha','Aracelia','','','34','627361616','107 ALBERTO TREVINO ST',0,'MISSION','TX','78572','6788','CY','48215','1964-04-07','F','',':RET:2106-3','N','021','DEN','1571424','33348TX002000201','2014-02-01','2014-01-07 15:43:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-08 18:24:45'),(28089,22231,'Y','18','021','EC','A','','','AC','0000980169','0000980169','TX00003214315','IL','1','Cortinas','Ruth','','','','34','466479762','525 ROSSVILLE RD',0,'DEVINE','TX','78016','3033','CY','48325','1966-05-13','F','U',NULL,'N','021','DEN','3352066','33348TX002000101','2014-04-01','2014-03-06 17:35:04','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-03-06 21:02:03'),(897,744,'Y','18','024','14','A','','','TE','0000322100','0000322100','','IL','1','Van Slyke','Linda','Lou',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-11-17','F','',NULL,NULL,NULL,'','45960','','2013-12-16','2013-12-16 12:46:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:08:10'),(1226,1009,'Y','18','021','EC','A','','','AC','0000265208','0000265208','OH00001251527','IL','1','RIEGLER','NANCY','','','','34','270504123','103 BEECH ST',0,'DOYLESTOWN','OH','44230','1012','CY','39169','1950-09-16','F','M',':RET:2106-3','N','021','HLT','752233','52664OH151001304','2014-01-01','2013-12-03 16:05:10','412.00',NULL,NULL,'658.32','246.32','R-OH014','OH0','658.32',NULL,0,'2013-12-25 18:20:33'),(26316,20878,'Y','18','021','EC','A','','','AC','0000777715','0000777715','OH00002662071','IL','1','Weadick','Patrick','','','','34','300604875','1224 Fawn Ct',0,'Loveland','OH','45140',NULL,'CY','39025','1965-08-24','M','M',':RET:2106-3','T','021','HLT','3142530','92036OH006000601','2014-04-01','2014-02-27 16:34:55','35.00',NULL,NULL,'320.11','285.11','R-OH005','OH0','320.11',NULL,0,'2014-02-28 06:31:35'),(2559,2081,'Y','18','024','14','A','','','TE','0000090168','0000090168','','IL','1','Ackerman','M',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-15','F','',NULL,NULL,NULL,'','690909','','2013-12-09','2013-12-09 17:27:03',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 19:37:27'),(20462,16346,'Y','18','024','14','A','','','TE','0001157523','0001157523','','IL','1','ross','bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-11-17','F','',NULL,NULL,NULL,'','595195','','2014-01-29','2014-01-29 10:26:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:52'),(20454,16338,'Y','18','021','EC','A','','','AC','0000115523','0000115523','OH00001706938','IL','1','waugh','anthony','','','','34','280523953','910 DECATUR ST',0,'SANDUSKY','OH','44870','3377','CY','39043','1954-02-05','M','U',':RET:2106-3','T','021','DEN','3402274','99734OH005000401','2014-03-01','2014-01-28 21:50:37','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-29 21:00:47'),(5698,4522,'Y','18','021','EC','A','','','AC','0000200723','0000200723','OH00000565978','IL','1','Reis','Mark','David','','','34','297643581','8841 DALY RD',0,'CINCINNATI','OH','45231','4622','CY','39061','1960-12-29','M','U',NULL,'N','021','HLT','804408','92036OH005001205','2014-01-01','2013-11-26 10:14:34','200.00',NULL,NULL,'437.93','237.93','R-OH004','OH0','437.93',NULL,0,'2013-12-25 23:32:49'),(20741,16571,'Y','18','021','EC','A','','','AC','0000172444','0000172444','OH00001505627','IL','1','Taylor','Donald','E','','','34','289525388','2204 ALSTON AVE',0,'HAMILTON','OH','45015','1302','CY','39017','1952-03-04','M','M',':RET:2106-3','N','021','HLT','2695740','92036OH003001201','2014-03-01','2014-01-30 11:40:37','329.64',NULL,NULL,'629.96','300.32','R-OH004','OH0','629.96',NULL,0,'2014-01-30 21:01:24'),(15382,12304,'N','01','021','EC','A',NULL,NULL,'','0000983842','0001100607','','IL','1','Chapman','Jennifer',NULL,NULL,NULL,NULL,NULL,'1088 KIRKWALL DR',0,'COPLEY','OH','44321','1727','CY','39153','1980-04-08','F','',':RET:2106-3','N','021','HLT','2554510','52664OH151001305','2014-02-01','2014-01-01 10:32:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.16',NULL,1,'2014-01-02 04:25:27'),(701,578,'Y','18','021','EC','A','','','AC','0000948698','0000948698','LA00000906398','IL','1','GONZALEZ','EDUARDO','rene','','','34','665189138','4133 FLORIDA AVE',0,'KENNER','LA','70065','2199','CY','22051','1992-01-22','M','U',NULL,'N','021','DEN','933883','18575LA002000201','2014-01-01','2013-12-15 18:43:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:02:54'),(26588,21082,'Y','18','021','EC','A','','','AC','0000069125','0000069125','OH00003097433','IL','1','Davis','Lisa','','','','34','298723045','839A Rocky Brook Drive',0,'Akro','OH','44313',NULL,'CY','39153','1966-06-08','F','U',':RET:2106-3','T','021','HLT','3360415','52664OH152000901','2014-04-01','2014-02-27 18:19:38','230.00',NULL,NULL,'293.60','63.60','R-OH012','OH0','293.60',NULL,0,'2014-02-28 21:30:34'),(17622,14088,'Y','18','021','EC','A','','','AC','0000065793','0000065793','TX00002424887','IL','1','Phillips','Terry','Lynn','','','34','462216183','1016 N SEVEN POINTS DR',0,'KEMP','TX','75143','8125','CY','48213','1958-04-01','F','U',':RET:2106-3','N','021','DEN','1826671','33348TX002000201','2014-02-01','2014-01-13 13:50:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:28'),(4208,3347,'Y','18','021','EC','A','','','AC','0000167518','0000167518','TX00000007486','IL','1','GREEN','STACY','','','','34','525290227','4514 HAVERHILL LN',0,'CORPUS CHRISTI','TX','78411','4936','CY','48355','1963-12-31','F','U',':RET:2106-3','N','021','DEN','2592067','33348TX002000201','2014-01-01','2013-12-16 21:59:07','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 21:50:06'),(29174,23091,'N','17','021','EC','A',NULL,NULL,'','0000519899','0000027961','','IL','1','PATTON','BRIE','','','','34','302967790','2947 BURNHAM JUMP DR',0,'CUYAHOGA FALLS','OH','44223','1218','CY','39153','1994-10-26','F','',NULL,'N','021','HLT','4011165','52664OH151001501','2014-04-01','2014-03-10 16:55:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-03-10 21:03:01'),(9652,7649,'Y','18','021','EC','A','','','AC','0001028069','0001028069','OH00000467179','IL','1','perez','ignacio','','','','34','268569788','16339 State Rt 65',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1954-11-23','M','M',NULL,'N','021','HLT','2380995','92036OH004001501','2014-01-01','2013-12-21 15:20:03','856.00',NULL,NULL,'873.51','17.51','R-OH002','OH0','460.65',NULL,0,'2013-12-26 04:38:49'),(9480,7517,'Y','18','021','EC','A','','','AC','0000921915','0000921915','OH00000855895','IL','1','Davis','Gary','','','','34','279507225','1019 E Nimisila rd.',0,'Akron','OH','44319',NULL,'CY','39153','1950-09-23','M','U',':RET:2106-3','N','021','DEN','1983801','99734OH005000401','2014-01-01','2013-12-21 11:35:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:34:37'),(3426,2751,'N','01','021','EC','A',NULL,NULL,'','0000114188','0000385895','','IL','1','upadhyay','sonal','umesh','','','34','297982571','485 West main street',0,'Canfield','OH','44406',NULL,'CY','39099','1960-03-08','F','',':RET:2029-7','N','021','HLT','1637208','92036OH005003206','2014-01-01','2013-12-21 18:39:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','493.79',NULL,0,'2013-12-25 21:18:47'),(7214,5718,'Y','18','021','EC','A','','','AC','0000226004','0000226004','OH00000775497','31','1','Davis','Carolee','Ann','','','34','522722156','P. O. Box 427',0,'Winchester','OH','45697',NULL,'CY','39001','1953-01-06','F','M',':RET:2106-3','N','021','DEN','444602','99734OH005000401','2014-01-01','2013-12-14 11:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:01:00'),(28033,22186,'Y','18','021','EC','A','','','AC','0000542737','0000542737','OH00003101068','IL','1','Williams','Russell','','','','34','294741172','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','1975-11-08','M','M',':RET:2106-3','N','021','DEN','3613905','99734OH005000401','2014-04-01','2014-03-06 17:25:58','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:28'),(24747,19638,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000507028','','IL','1','Dugan','Vincent','A','','III','34','300945929','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1992-07-07','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:51'),(21299,17019,'N','01','021','EC','A',NULL,NULL,'','0002188706','0001152293','','IL','1','Scott','Heath','','','','34','439352343','8021 WOLFCREEK PL',0,'DENHAM SPRINGS','LA','70726','1201','CY','22063','1975-08-26','M','',':RET:1002-5','N','021','DEN','3359840','18575LA002000201','2014-03-01','2014-02-03 18:39:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:11'),(22386,17875,'Y','18','021','EC','A','','','AC','0000349303','0000349303','OH00002017347','IL','1','Stocker','Jamie','','','','34','289729906','9806 TOWNSHIP ROAD 89',0,'KILLBUCK','OH','44637','9401','CY','39075','1976-04-13','F','M',NULL,'N','021','HLT','2822985','52664OH151001306','2014-03-01','2014-02-10 11:47:41','162.00',NULL,NULL,'276.08','114.08','R-OH014','OH0','276.08',NULL,0,'2014-02-10 21:30:11'),(23661,18840,'N','19','021','EC','A',NULL,NULL,'','0000226116','0000737466','','IL','1','Chui','Ethan','','','','34','036298448','789 EIFFEL DR',0,'PLANO','TX','75023','7062','CY','48085','2012-07-17','M','',':RET:2034-7^:RET:2106-3','N','021','DEN','2804020','33348TX002000201','2014-03-01','2014-02-14 12:46:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-14 21:30:19'),(19226,15319,'Y','18','021','EC','A','','','AC','0000564231','0000564231','OH00002570849','IL','1','Krasinski','Rachel','Tara','','','34','300700513','5708 EDGEWATER DR',0,'TOLEDO','OH','43611','2461','CY','39095','1976-10-16','F','U',':RET:2106-3','T','021','HLT','3157394','92036OH004002601','2014-03-01','2014-01-20 10:02:12','0.00',NULL,NULL,'223.22','223.22','R-OH001','OH0','223.22',NULL,0,'2014-01-21 08:46:29'),(23891,19004,'N','01','021','EC','A',NULL,NULL,'','0001203271','0001190110','','IL','1','NEFF','ALYCE','','','','34','217529310','158 LINDEN AVE',0,'WILMINGTON','OH','45177','1917','CY','39027','1949-10-27','F','',':RET:2106-3','N','021','HLT','2857784','92036OH003000605','2014-03-01','2014-02-14 17:27:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','672.53',NULL,0,'2014-02-14 21:32:18'),(24734,19636,'Y','18','021','EC','A','','','AC','0000990107','0000990107','OH00003038556','IL','1','Lovingshimer','Melanie','Dawn','','','34','289724784','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-01-08','F','M',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:39:40'),(3000,2412,'Y','18','021','EC','A','','','AC','0000880486','0000880486','OH00000494401','IL','1','wahl','stephen','','','','34','272543809','10993 OLMAR DR',0,'CHARDON','OH','44024','9706','CY','39055','1955-10-23','M','M',':RET:2106-3','N','021','DEN','815942','99734OH005000301','2014-01-01','2013-12-06 12:55:49','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:17:38'),(22458,17931,'Y','18','024','14','A','','','TE','0000550795','0000550795','','IL','1','Valenta','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-19','M','',NULL,NULL,NULL,'','2625035','','2014-02-10','2014-02-10 15:15:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:51'),(28904,22878,'Y','18','021','EC','A','','','AC','0001231068','0001231068','TX00003157690','31','1','Stovall','Kara','','','','34','460914019','2321 Mill Pond',0,'Garland','TX','75044',NULL,'CY','48113','1974-10-28','F','U',':RET:2106-3','N','021','DEN','3837464','33348TX002000201','2014-04-01','2014-03-10 17:21:40','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-10 21:00:23'),(22551,18008,'Y','18','021','EC','A','','','AC','0000731237','0000731237','OH00001954460','IL','1','Hruska','Andrew','','','','34','494065266','301 E. Walnut St.',0,'Botkins','OH','45306',NULL,'CY','39149','1992-02-24','M','U',':RET:2106-3','N','021','HLT','2628780','92036OH002000501','2014-03-01','2014-02-10 00:34:29','0.00',NULL,NULL,'274.51','274.51','R-OH003','OH0','274.51',NULL,0,'2014-02-10 21:31:45'),(14289,11399,'Y','18','021','EC','A','','','AC','0001209593','0001209593','OH00001658877','IL','1','louis','sharon','','','','34','179441346','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-08-15','F','M',':RET:2106-3','T','021','HLT','2559689','52664OH152000901','2014-02-01','2013-12-26 10:40:42','978.00',NULL,NULL,'1019.60','41.60','R-OH012','OH0','509.80',NULL,0,'2013-12-27 02:06:32'),(2572,2089,'N','01','021','EC','A',NULL,NULL,'','0000027872','0000089801','','IL','1','Grega','Bonnie','','','','34','273568251','2981 S U Route 20 E',0,'Collins','OH','44826',NULL,'CY','39077','1954-05-03','F','',NULL,'T','021','HLT','791152','92036OH005002705','2014-01-01','2013-12-09 14:45:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','583.72',NULL,0,'2013-12-25 19:37:42'),(1378,1143,'Y','18','021','EC','A','','','AC','0001204970','0001204970','LA00000110249','IL','1','Banks','Tiffany','','','','34','434219082','1030 coursey blvd',0,'baton rouge','LA','70816',NULL,'CY','22033','1970-10-18','F','U',NULL,'N','021','DEN','1959386','18575LA002000201','2014-01-01','2013-12-24 08:31:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:01'),(19712,15707,'N','01','021','EC','A',NULL,NULL,'','0000755464','0000559230','','IL','1','Vergil','Xavier','','','','34','450921291','2335 WEBSTER RANCH RD',0,'FRIENDSWOOD','TX','77546','2660','CY','48201','1955-09-19','M','',NULL,'N','021','DEN','1863890','33348TX002000201','2014-03-01','2014-01-23 15:55:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:53'),(9381,7439,'Y','18','021','EC','A','','','AC','0001373942','0001373942','LA00001183549','IL','1','Coila','Bridget','','','','34','435151439','614 AMELIA ST',0,'GRETNA','LA','70053','5406','CY','22051','1973-08-31','F','U',':RET:2106-3','N','021','DEN','2591337','18575LA002000201','2014-01-01','2013-12-21 17:38:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:32:05'),(14898,11900,'Y','18','021','EC','A','','','AC','0001457739','0001457739','LA00000512539','IL','1','Lynch','Cartez','','','','34','437639916','700 PATTON ST',0,'WINNFIELD','LA','71483','3748','CY','22127','1984-05-31','M','U',':RET:2054-5','N','021','DEN','1713294','18575LA002000201','2014-02-01','2013-12-29 15:30:03','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-30 00:01:01'),(5333,4229,'Y','18','024','14','A','','','TE','0001053035','0001053035','','IL','1','newell','esther',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-04-02','F','',NULL,NULL,NULL,'','868398','','2013-12-19','2013-12-19 14:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:07:08'),(20449,16333,'Y','18','024','14','A','','','TE','0000026399','0000026399','','IL','1','Bradley','Earlean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-06-22','F','',NULL,NULL,NULL,'','2794652','','2014-01-29','2014-01-29 14:59:16',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-29 21:00:44'),(7238,5739,'Y','18','024','14','A','','','TE','0000670280','0000670280','','IL','1','Whatley','Jerry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-28','M','',NULL,NULL,NULL,'','743126','','2013-12-13','2013-12-13 21:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 02:01:36'),(14834,11847,'Y','18','021','EC','A','','','AC','0000362502','0000362502','OH00000668012','IL','1','Wiechers','Angela','','','','34','113543085','520 S POPLAR ST',0,'BUCYRUS','OH','44820','2658','CY','39033','1960-12-04','F','M',':RET:2106-3','N','021','DEN','1552824','99734OH005000301','2014-01-01','2013-12-23 20:18:03','0.00',NULL,NULL,'42.26','42.26','R-OH007','OH0','0.00',NULL,1,'2013-12-29 11:14:39'),(24924,19764,'Y','18','024','14','A','','','TE','0001009849','0001009849','','IL','1','hathcox','thomas','f','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-03-07','M','',NULL,NULL,NULL,'','3812233','','2014-03-31','2014-02-20 14:00:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-20 21:30:15'),(4902,3887,'Y','18','021','EC','A','','','AC','0000745405','0000745405','OH00000119481','IL','1','Salyers','Charles','','','','34','294641662','15026 GIBSON RD',0,'ASHVILLE','OH','43103','9663','CY','39129','1958-03-07','M','U',':RET:2106-3','N','021','DEN','1068321','99734OH005000401','2014-01-01','2013-10-26 06:17:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:31:48'),(16077,12875,'Y','18','021','EC','A','','','AC','0000125571','0000125571','OH00002245037','IL','1','Moreo','Julie','','','','34','283648206','203 WILLOWWOOD DR',0,'DAYTON','OH','45405','3020','CY','39113','1958-05-21','F','M',':RET:2106-3','N','021','DEN','1567826','99734OH005000401','2014-02-01','2014-01-03 13:52:29','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:03:59'),(21284,17010,'Y','18','021','EC','A','','','AC','0001729348','0001729348','LA00001811477','IL','1','Dacruz','Analiesse','','','','34','437915804','6512 PARK MANOR DR',0,'METAIRIE','LA','70003','3926','CY','22051','1963-04-04','F','M',NULL,'N','021','DEN','3138284','18575LA002000101','2014-03-01','2014-02-03 18:29:55','0.00',NULL,NULL,'139.14','139.14','R-LA001','LA0','25.02',NULL,0,'2014-02-04 21:00:04'),(17264,13812,'Y','18','021','EC','A','','','AC','0000669198','0000669198','OH00001494545','IL','1','Schreiner','Rita','','','','34','291705939','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1961-07-06','F','M',':RET:2106-3','T','021','DEN','1797637','99734OH005000301','2014-02-01','2014-01-10 14:37:22','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:23:19'),(7663,6069,'Y','18','021','EC','A','','','AC','0001735358','0001735358','LA00000842747','IL','1','Patterson','Jessica','','','','34','439698997','9283 Samoa Ave',0,'Baton Rouge','LA','70810',NULL,'CY','22033','1987-04-16','F','U',':RET:2106-3','N','021','DEN','1723847','18575LA002000101','2014-01-01','2013-12-20 14:53:30','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:20'),(8108,6414,'Y','18','021','EC','A','','','AC','0001157555','0001157555','OH00000313671','IL','1','RICE','VIOLA','ELIZABETH','','','34','299600365','14808 DAY RD',0,'MOUNT ORAB','OH','45154','8332','CY','39015','1972-03-30','F','M',':RET:2106-3','N','021','HLT','2300444','92036OH003000605','2014-01-01','2013-12-20 17:16:09','302.00',NULL,NULL,'588.94','286.94','R-OH005','OH0','291.89',NULL,0,'2013-12-26 03:11:02'),(880,728,'Y','18','021','EC','A','','','AC','0000881647','0000881647','MS00000707075','IL','1','Edwards','Teresa','','','','34','368824238','40 Vardaman St',0,'Noxapater','MS','39346',NULL,'CY','28159','1963-08-24','F','U',NULL,'N','021','DEN','1865202','46300MS002000201','2014-01-01','2013-12-16 12:00:02','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:07:43'),(27878,22053,'Y','18','021','EC','A','','','AC','0001155158','0001155158','OH00002972732','IL','1','Harden','William','','','','34','291521806','325 N MCDONEL ST',0,'LIMA','OH','45801','4203','CY','39003','1950-09-23','M','U',':RET:2106-3','T','021','HLT','3526126','92036OH003001505','2014-04-01','2014-03-05 14:29:27','600.00',NULL,NULL,'780.23','180.23','R-OH002','OH0','780.23',NULL,0,'2014-03-05 21:32:30'),(6713,5323,'Y','18','021','EC','A','','','AC','0000484150','0000484150','TX00000263002','IL','1','LeBarre','Bennett','','','','34','444903274','7518 MIDDLEWOOD ST',0,'HOUSTON','TX','77063','1806','CY','48201','1987-07-02','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','664519','33348TX002000101','2014-01-01','2013-11-05 15:43:17','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:02:19'),(912,757,'Y','18','024','14','A','','','TE','0000963205','0000963205','','IL','1','Matthews','Janice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-14','F','',NULL,NULL,NULL,'','1238520','','2013-12-16','2013-12-16 14:17:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:08:35'),(21910,17498,'Y','18','021','EC','A','','','AC','0000134613','0000134613','OH00001892079','31','1','fowee','carol','','','','34','295625891','p.o. box 435',0,'lynchburg','OH','45142',NULL,'CY','39071','1957-08-22','F','U',':RET:2106-3','N','021','HLT','2700302','92036OH004000601','2014-03-01','2014-02-06 14:48:36','375.00',NULL,NULL,'402.70','27.70','R-OH005','OH0','402.70',NULL,0,'2014-02-06 21:01:53'),(21442,17138,'Y','18','021','EC','A','','','AC','0001104484','0001104484','OH00002318019','IL','1','Ford','Crystal','','','','34','294561447','865 PEERLESS AVE',0,'AKRON','OH','44320','2821','CY','39153','1956-12-24','F','U',':RET:2054-5','N','021','HLT','1631816','52664OH151001501','2014-03-01','2014-02-03 21:39:15','384.00',NULL,NULL,'651.81','267.81','R-OH012','OH0','651.81',NULL,0,'2014-02-04 21:01:24'),(2131,1749,'Y','18','024','14','A','','','TE','0001066955','0001066955','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','307480','','2013-12-10','2013-12-10 16:25:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:17:58'),(6217,4927,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00001068293','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','474980','92036OH006002601','2014-01-01','2013-10-15 21:31:42','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-26 00:31:03'),(6433,5101,'Y','18','021','EC','A','','','AC','0000578531','0000578531','LA00000815383','IL','1','Breaux','Gina','Otzenberger','','','34','433338821','1131 CURRIE DR',0,'SULPHUR','LA','70665','7927','CY','22019','1961-10-28','F','U',':RET:2106-3','N','021','DEN','417302','18575LA002000201','2014-01-01','2013-12-11 13:23:33','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 00:49:12'),(26909,21327,'Y','18','021','EC','A','','','AC','0001452439','0001452439','LA00002856817','IL','1','crawford','teresa','','','','34','520928498','2025 HEMPSTEAD DR',0,'SLIDELL','LA','70461','4822','CY','22103','1967-01-01','F','U',':RET:2106-3','N','021','DEN','3112002','18575LA002000201','2014-04-01','2014-03-02 13:16:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-03 01:00:11'),(15737,12588,'Y','18','021','EC','A','','','AC','0001003317','0001003317','OH00002002182','IL','1','Shaffer','Ryan','Thomas','','','34','302841669','1955 STABLER RD',0,'AKRON','OH','44313','6035','CY','39153','1986-08-18','M','U',':RET:2106-3','N','021','DEN','2272820','99734OH005000301','2014-02-01','2014-01-02 15:40:01','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-03 02:00:42'),(26786,21228,'Y','18','021','EC','A','','','AC','0001224443','0001224443','TX00002486609','IL','1','Gomez','Trinidad','Isabel','','','34','457991512','301 S. Adams',0,'Alice','TX','78332',NULL,'CY','48249','1988-06-07','F','U',':RET:2106-3','N','021','DEN','3005474','33348TX002000201','2014-04-01','2014-03-01 14:27:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-01 21:00:15'),(26447,20978,'Y','18','021','EC','A','','','AC','0000115550','0000115550','OH00003096353','S1','1','Habli','firas','','','','34','269130210','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2006-08-28','F','U',NULL,'N','021','DEN','3477411','99734OH005000301','2014-03-01','2014-02-27 14:31:36','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13','CIC',0,'2014-02-28 07:30:24'),(22278,17783,'Y','18','021','EC','A','','','AC','0001030405','0001030405','TX00002040183','IL','1','Gifford','Christine','','','','34','506024503','13101 TRAIL DRIVER ST',0,'AUSTIN','TX','78737','9577','CY','48209','1965-08-15','F','U',':RET:2106-3','N','021','DEN','2901825','33348TX002000201','2014-03-01','2014-01-29 11:41:40','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-10 11:00:19'),(23194,18494,'Y','18','024','14','A','','','TE','0000111909','0000111909','','IL','1','lee','brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-09','M','',NULL,NULL,NULL,'','1513504','','2014-02-27','2014-02-12 14:46:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-12 21:32:05'),(23533,18746,'Y','18','021','EC','A','','','AC','0001238638','0001238638','LA00002503572','IL','1','TAYLOR','JUNIOR','','','','34','435882986','446 CARROLLTON AVE',0,'METAIRIE','LA','70005','3640','CY','22051','1952-10-09','M','U',':RET:2106-3','N','021','DEN','3803203','18575LA002000201','2014-03-01','2014-02-13 11:46:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:27'),(14119,11252,'N','01','021','EC','A',NULL,NULL,'','0000474979','0000443462','','IL','1','Pacheco','Maria','','','','34','624127313','1214 POPLAR HILL DR',0,'LEBANON','OH','45036','8563','CY','39165','1967-05-06','F','',NULL,'N','021','DEN','2555638','99734OH005000401','2014-02-01','2013-12-26 15:16:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:02:03'),(5776,4588,'N','01','021','EC','A',NULL,NULL,'','0000645975','0001149870','','IL','1','Eck','Jennifer','','','','34','295866888','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1985-01-18','F','',':RET:2106-3','N','021','DEN','1492383','99734OH005000401','2014-01-01','2013-12-23 22:55:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:46:55'),(4280,3409,'N','19','021','EC','A',NULL,NULL,'','0001073132','0000744416','','IL','1','Hostetler','Alexander','Lee','','','34','830165564','14110 State Route 116',0,'Van Wert','OH','45891',NULL,'CY','39161','2013-06-17','M','',':RET:2106-3','N','021','HLT','1958887','92036OH005001504','2014-01-01','2013-12-17 11:34:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 21:52:00'),(9137,7246,'N','01','021','EC','A',NULL,NULL,'','0000781886','0000752062','','IL','1','Warner','Joe','','','','34','291763442','809 Morse St.',0,'Findlay','OH','45840',NULL,'CY','39063','1974-11-08','M','',':RET:2054-5','N','021','HLT','1864009','92036OH003001505','2014-01-01','2013-12-17 21:30:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.05',NULL,0,'2013-12-26 04:08:06'),(24167,19200,'Y','18','021','EC','A','','','AC','0000283311','0000283311','OH00002308786','IL','1','Hillis','Jerry','','','','34','302862330','13645 COUNTY ROAD M',0,'NAPOLEON','OH','43545','9571','CY','39069','1974-08-21','M','M',NULL,'N','021','HLT','2752215','92036OH005002605','2014-03-01','2014-02-15 12:01:35','392.00',NULL,NULL,'489.06','97.06','R-OH001','OH0','246.08',NULL,0,'2014-02-15 22:02:07'),(1276,1054,'Y','18','021','EC','A','','','AC','0000614072','0000614072','OH00000611203','IL','1','Ervin','Andrew','','','','34','461791777','1360 LINGER DR',0,'CLINTON','OH','44216','9133','CY','39153','1986-11-11','M','U',':RET:2106-3','N','021','DEN','688532','99734OH005000401','2014-01-01','2013-11-29 14:00:22','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:30:25'),(22744,18158,'Y','18','024','14','A','','','TE','0001356215','0001356215','','IL','1','watson','zenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-06-06','F','',NULL,NULL,NULL,'','3138493','','2014-02-11','2014-02-11 17:29:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-11 21:01:21'),(28180,22299,'N','19','021','EC','A',NULL,NULL,'','0000955603','0000179973','','IL','1','Hennies','Derek','Richard','','','34','298945034','3179 Kennedy-Ford Rd.',0,'Bethel','OH','45106',NULL,'CY','39025','1992-06-18','M','',':RET:2106-3','N','021','HLT','3288625','92036OH004000601','2014-04-01','2014-03-06 13:25:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-03-06 21:02:54'),(18078,14438,'Y','18','021','EC','A','','','AC','0002247617','0002247617','LA00001539132','IL','1','Brierley','Chelsi','','','','34','436811028','418 COMMERCE ST',0,'HOUMA','LA','70360','6318','CY','22109','1991-01-10','F','U',':RET:2106-3','N','021','DEN','1841228','18575LA002000201','2014-02-01','2014-01-14 10:32:50','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-15 02:07:26'),(14225,11343,'Y','18','024','14','A','','','TE','0000608599','0000608599','','IL','1','Edwards','Audrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-28','F','',NULL,NULL,NULL,'','357934','','2013-12-26','2013-12-26 17:16:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:04:49'),(27930,22094,'Y','18','021','EC','A','','','AC','0000891301','0000891301','TX00002604125','IL','1','OBALE','MICHELLE','','','','34','432953495','7211 FOXBRICK LN',0,'HUMBLE','TX','77338','6225','CY','48201','1978-01-16','F','U',NULL,'N','021','DEN','3106911','33348TX002000201','2014-04-01','2014-03-06 10:55:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-06 21:00:25'),(28289,22384,'N','01','021','EC','A',NULL,NULL,'','0001060977','0000292037','','IL','1','Britenriker','Ramona','A','','','34','295603512','528 MAIN ST',0,'WADSWORTH','OH','44281','1357','CY','39103','1961-12-14','F','',':RET:2106-3','N','021','HLT','4089073','52664OH151001304','2014-04-01','2014-03-07 14:30:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31','CIC',0,'2014-03-07 21:00:27'),(25389,20144,'Y','18','024','14','A','','','TE','0001207207','0001207207','','IL','1','Zornes','Sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-10-04','F','',NULL,NULL,NULL,'','3706989','','2014-02-24','2014-02-24 22:53:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-25 21:30:51'),(18999,15132,'Y','18','021','EC','A','','','AC','0000762319','0000762319','OH00002579695','IL','1','RITTER','RAYMOND','C','','','34','296788265','3001 GALE DR',0,'AKRON','OH','44312','2937','CY','39153','1966-06-29','M','M',':RET:2106-3','N','021','HLT','2954796','52664OH151001305','2014-03-01','2014-01-17 12:31:11','708.00',NULL,NULL,'929.05','221.05','R-OH012','OH0','348.56',NULL,0,'2014-01-20 08:06:15'),(14664,11706,'Y','18','021','EC','A','','','AC','0000863020','0000863020','TX00001438702','IL','1','Abraham','Jeff','','','','34','131744845','4915 Rebel Ridge Drive',0,'Sugar Land','TX','77478',NULL,'CY','48157','1984-12-16','M','R',':RET:2029-7','N','021','DEN','1818056','33348TX002000201','2014-02-01','2013-12-28 15:27:45','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2013-12-29 11:08:04'),(9640,7638,'Y','18','021','EC','A','','','AC','0000446927','0000446927','TX00001148774','IL','1','COOPER','EVELYN','','','','34','457914067','908 PALITINE LN',0,'PFLUGERVILLE','TX','78660','5148','CY','48453','1974-04-30','F','M',':RET:2106-3','N','021','DEN','1560034','33348TX002000101','2014-01-01','2013-12-21 13:44:51','0.00',NULL,NULL,'54.30','54.30','R-TX003','TX0','27.15',NULL,0,'2013-12-26 04:38:28'),(2954,2379,'Y','18','021','EC','A','','','AC','0000669510','0000669510','TX00000572928','IL','1','Hetrick','Calvin','','','','34','441500925','1232 S FANNIN ST',0,'AMARILLO','TX','79102','1426','CY','48375','1950-07-14','M','M',':RET:2106-3','N','021','DEN','688668','33348TX002000201','2014-01-01','2013-12-06 11:38:32','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 20:16:36'),(9129,7240,'Y','18','024','14','A','','','TE','0000677564','0000677564','','IL','1','perrin','susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-02','F','',NULL,NULL,NULL,'','454652','','2013-12-17','2013-12-17 19:31:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 04:07:57'),(14480,11552,'N','01','021','EC','A',NULL,NULL,'','0000699469','0001231852','','IL','1','Mendoza Arredondo','Ma Leticia','','','','34','628785568','1403 Camp Craft Rd',0,'Austin','TX','78746',NULL,'CY','48453','1961-09-21','F','',NULL,'N','021','DEN','2265116','33348TX002000201','2014-02-01','2013-12-26 21:31:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-28 03:33:15'),(5030,3985,'Y','18','021','EC','A','','','AC','0000702751','0000702751','OH00000698422','IL','1','Harmon','Zachary','','','','34','268903408','1811 W SPRING ST',0,'LIMA','OH','45805','2627','CY','39003','1987-07-13','M','M',':RET:2106-3','N','021','HLT','618218','92036OH003001505','2014-01-01','2013-12-07 16:34:23','329.00',NULL,NULL,'496.22','167.22','R-OH002','OH0','235.35',NULL,0,'2013-12-25 22:47:43'),(3458,2780,'N','01','021','EC','A',NULL,NULL,'','0001001154','0000264195','','IL','1','Baldwin','Lori','L','','','34','301807892','13385 Ett Noecker Road',0,'Ashville','OH','43103',NULL,'CY','39129','1969-04-14','F','',':RET:2106-3','N','021','DEN','1903281','99734OH005000401','2014-01-01','2013-12-22 01:04:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:41'),(18978,15121,'N','19','021','EC','A',NULL,NULL,'','0000228366','0001019298','','IL','1','WHITLATCH','JASMINE','R','','','34','296022864','537 FOWLER ST',0,'NEW LEXINGTON','OH','43764',NULL,'CY','39127','1998-03-21','F','',':RET:2106-3','N','021','DEN','2237610','99734OH005000301','2014-03-01','2014-01-17 13:47:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:06'),(6148,4875,'N','19','021','EC','A',NULL,NULL,'','0001237671','0000406096','','IL','1','Runyan','Sierra','','','','34','772489238','539 BLENHEIM RD',0,'COLUMBUS','OH','43214','3263','CY','39049','2006-04-14','F','',':RET:2054-5^:RET:2106-3','N','021','DEN','216026','99734OH005000301','2014-01-01','2013-11-21 14:07:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:16:27'),(4897,3885,'Y','18','021','EC','A','','','AC','0000384362','0000384362','OH00000107734','IL','1','Stableford','Andrew','','','','34','299888171','5650 river road',0,'fairfield','OH','45014',NULL,'CY','39017','1988-08-26','M','U',':RET:2106-3','N','021','HLT','214452','92036OH006001201','2014-01-01','2013-10-26 08:51:45','41.00',NULL,NULL,'170.93','129.93','R-OH004','OH0','170.93',NULL,0,'2013-12-25 22:31:43'),(16024,12827,'Y','18','021','EC','A','','','AC','0002390638','0002390638','LA00001799009','IL','1','GIMAGGIO','GALE','','','','34','497689926','5113 TOPAZ DRIVE',0,'FARRERO','LA','70072','5929','CY','22051','1958-05-06','F','M',NULL,'T','021','DEN','2431358','18575LA002000201','2014-02-01','2014-01-03 10:26:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:14'),(21819,17424,'Y','18','021','EC','A','','','AC','0001257368','0001257368','OH00001651193','IL','1','corzine','Pamela','','','','34','545192783','3217 MEADOW BROOK BLVD',0,'RAVENNA','OH','44266','8977','CY','39133','1962-04-29','F','U',':RET:2106-3','N','021','HLT','2992602','52664OH151001305','2014-03-01','2014-02-06 16:35:14','319.00',NULL,NULL,'415.91','96.91','R-OH012','OH0','415.91',NULL,0,'2014-02-06 21:00:58'),(6264,4966,'Y','18','021','EC','A','','','AC','0000343683','0000343683','TX00000209480','IL','1','Wright','John','','','','34','642129254','13310 BRANTFIELD PARK LN',0,'TOMBALL','TX','77377','8254','CY','48201','1987-08-14','M','U',NULL,'N','021','DEN','1201414','33348TX002000101','2014-01-01','2013-10-06 19:55:10','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 00:32:19'),(18705,14913,'Y','18','021','EC','A','','','AC','0000714999','0000714999','OH00002291276','IL','1','Dwillis','Randall','','','','34','288646827','503 CALEB DR',0,'BROOKVILLE','OH','45309','1386','CY','39113','1958-03-30','M','M',':RET:2106-3','N','021','DEN','2733689','99734OH005000301','2014-02-01','2014-01-15 21:02:03','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:35:29'),(18248,14567,'Y','18','021','EC','A','','','AC','0000010107','0000010107','TX00001793760','IL','1','EDWARDS','DELEISHA','','','','34','462937713','5525 EISENHOWER DR',0,'FORT WORTH','TX','76112','7620','CY','48439','1987-12-28','F','U',':RET:2054-5','N','021','DEN','2111518','33348TX002000201','2014-02-01','2014-01-15 14:51:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-16 08:44:29'),(9134,7245,'Y','18','021','EC','A','','','AC','0000769978','0000769978','OH00000725060','IL','1','Bishoff','Ross','','','','34','268769919','919 POPPY DR',0,'WAPAKONETA','OH','45895','1042','CY','39011','1977-07-21','M','M',':RET:2106-3','N','021','HLT','2052685','92036OH003001505','2014-01-01','2013-12-17 20:35:28','355.00',NULL,NULL,'567.23','212.23','R-OH002','OH0','282.70',NULL,0,'2013-12-26 04:08:03'),(3855,3085,'Y','18','021','EC','A','','','AC','0000624096','0000624096','LA00000124771','IL','1','DAVIS','ETHEL','','','','34','439869436','109 MILLS RD',0,'JONESVILLE','LA','71343','5800','CY','22029','1951-11-07','F','U',':RET:2054-5','N','021','DEN','1122751','18575LA002000201','2014-01-01','2013-12-13 18:05:05','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 21:35:45'),(18170,14509,'Y','18','021','EC','A','','','AC','0000655843','0000655843','OH00002142319','IL','1','Herbst','Theresa','','','','34','299423008','170 S 2ND ST',0,'WILLIAMSBURG','OH','45176','1217','CY','39025','1952-08-26','F','U',NULL,'N','021','HLT','2348512','92036OH005000605','2014-02-01','2014-01-14 16:23:41','451.00',NULL,NULL,'603.24','152.24','R-OH005','OH0','603.24',NULL,0,'2014-01-15 02:07:57'),(4319,3431,'Y','18','021','EC','A','','','AC','0001151066','0001151066','OH00000329349','IL','1','Waits','Galen','','','','34','274481668','5873 TRACY RD',0,'SARDINIA','OH','45171','9113','CY','39015','1950-06-02','M','M',':RET:2106-3','N','021','HLT','1402552','92036OH004000601','2014-01-01','2013-12-17 10:06:55','787.00',NULL,NULL,'878.07','91.07','R-OH005','OH0','509.54',NULL,0,'2013-12-25 21:52:43'),(16643,13316,'Y','18','021','EC','A','','','AC','0000310865','0000310865','OH00002379246','IL','1','Ross','Kevin','','','','34','164420843','5708 Terrace Park Drive',0,'Kettering','OH','45429',NULL,'CY','39113','1952-07-24','M','M',':RET:2106-3','N','021','DEN','1809841','99734OH005000401','2014-02-01','2014-01-07 15:40:59','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:18'),(5325,4223,'Y','18','021','EC','A','','','AC','0000426413','0000426413','OH00000556618','IL','1','stalnaker','courtney','','','','34','274866517','1140 jessie ave',0,'kent','OH','44240',NULL,'CY','39133','1969-02-01','F','U',':RET:2106-3','T','021','DEN','1594396','99734OH005000301','2014-01-01','2013-12-19 08:45:01','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:06:56'),(6518,5167,'Y','18','021','EC','A','','','AC','0000502958','0000502958','OH00001314504','IL','1','Kampschmidt','Carla','','','','34','299745461','3934 LANSDOWNE AVE',0,'CINCINNATI','OH','45236','3024','CY','39061','1979-05-28','F','R',NULL,'N','021','HLT','83207','92036OH006001201','2014-01-01','2013-12-10 19:20:46','0.00',NULL,NULL,'206.68','206.68','R-OH004','OH0','206.68',NULL,0,'2013-12-26 00:51:19'),(15270,12207,'Y','18','021','EC','A','','','AC','0000909487','0000909487','OH00001522515','IL','1','Fowlkes','William','','','','34','316805554','55 JESSICA WAY',0,'GAHANNA','OH','43230','4408','CY','39049','1964-10-07','M','M',':RET:2054-5','N','021','DEN','2541451','99734OH005000401','2014-02-01','2013-12-31 18:59:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:21:45'),(17528,14014,'Y','18','024','14','A','','','TE','0000122992','0000122992','','IL','1','DORDICK','DANIEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-01-25','M','',NULL,NULL,NULL,'','1483164','','2014-01-12','2014-01-12 14:23:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:41'),(26426,20959,'Y','18','024','14','A','','','TE','0000819343','0000819343','','IL','1','FRANCO','BRENDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-10-28','F','',NULL,NULL,NULL,'','3462272','','2014-02-27','2014-02-27 13:33:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-02-28 07:30:12'),(9385,7442,'N','01','021','EC','A',NULL,NULL,'','0001156006','0000524008','','IL','1','LNU','Kaisar','','','','34','586315141','5500 SUNCHASE CT',0,'GRANBURY','TX','76049','7800','CY','48221','1972-02-10','M','',':RET:2028-9','N','021','DEN','2354935','33348TX002000201','2014-01-01','2013-12-20 19:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:32:12'),(6619,5249,'Y','18','021','EC','A','','','AC','0000723875','0000723875','OH00000155355','IL','1','Baker','Holly','','','','34','283663804','2061 State Route 125',0,'Amelia','OH','45102',NULL,'CY','39025','1972-04-13','F','U',':RET:2106-3','N','021','HLT','662416','92036OH001000601','2014-01-01','2013-12-11 12:04:07','224.00',NULL,NULL,'337.14','113.14','R-OH005','OH0','337.14',NULL,0,'2013-12-26 00:53:58'),(2174,1788,'N','19','021','EC','A',NULL,NULL,'','0000393642','0000530670','','IL','1','Loughridge','Cole','Z','','','34','280985916','219 S BRANDON AVE',0,'CELINA','OH','45822','2012','CY','39107','1995-04-06','M','',':RET:2106-3','N','021','HLT','1182800','92036OH003001501','2014-01-01','2013-12-09 20:34:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 19:19:15'),(24015,19099,'Y','18','021','EC','A','','','AC','0000648374','0000648374','OH00002584990','IL','1','Nguyen','Mai-Ly','','','','34','586541656','23561 MASTICK RD',0,'NORTH OLMSTED','OH','44070','3716','CY','39035','1962-09-09','F','U',':RET:2047-9','N','021','DEN','3524298','99734OH005000401','2014-03-01','2014-02-15 12:54:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:43'),(17046,13639,'Y','18','021','EC','A','','','AC','0000859709','0000859709','OH00001528501','31','1','Bucklan','Bruce','','','','34','285420046','PO Box 19',0,'novelty','OH','44072',NULL,'CY','39055','1955-01-13','M','R',':RET:2106-3','N','021','HLT','2177426','52664OH151001501','2014-02-01','2014-01-09 16:54:27','0.00',NULL,NULL,'785.22','785.22','R-OH011','OH0','785.22',NULL,0,'2014-01-13 02:20:54'),(113,99,'Y','18','021','EC','A','','','AC','0000126663','0000126663','TX00000489373','IL','1','Kungu','Jamie','','','','34','466655477','706 WILCOX ST',0,'WINNSBORO','TX','75494','2040','CY','48499','1977-06-26','F','M',':RET:2106-3','N','021','DEN','49746','33348TX002000201','2014-01-01','2013-12-05 17:34:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:18:01'),(14110,11245,'Y','18','021','EC','A','','','AC','0000314708','0000314708','OH00000994223','IL','1','stauter','elizabeth','','','','34','302886617','406 kater ave.',0,'harrison','OH','45030',NULL,'CY','39061','1987-07-22','F','U',':RET:2106-3','N','021','DEN','2400398','99734OH005000401','2014-02-01','2013-12-26 14:14:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:01:49'),(7467,5909,'Y','18','021','EC','A','','','AC','0000995420','0000995420','OH00001012540','IL','1','Clark','Terri','','','','34','271687407','346 OLD STREET',0,'MONROE','OH','45050',NULL,'CY','39017','1965-09-03','F','U',':RET:2054-5','N','021','DEN','598998','99734OH005000401','2014-01-01','2013-12-14 19:40:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:05'),(13497,10757,'Y','18','021','EC','A','','','AC','0001100597','0001100597','OH00000369712','IL','1','Crabtree','Karen','','','','34','301463542','1974 BAKER AVE',0,'AKRON','OH','44312','2110','CY','39153','1949-06-23','F','M',':RET:2106-3','N','021','DEN','2141246','99734OH005000301','2014-01-01','2013-12-23 19:04:12','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:02:30'),(26318,20880,'Y','18','024','14','A','','','TE','0001138044','0001138044','','IL','1','Layton','Denise',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-06-17','F','',NULL,NULL,NULL,'','2392698','','2014-03-14','2014-02-27 10:35:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 06:31:35'),(2506,2041,'Y','18','021','EC','A','','','AC','0000161576','0000161576','LA00000100511','IL','1','Pevey','Richard','','','','34','435845309','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1951-10-23','M','M',':RET:2106-3','N','021','DEN','26495','18575LA002000201','2014-01-01','2013-12-09 18:11:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:36:08'),(1605,1342,'Y','18','021','EC','A','','','AC','0000396088','0000396088','TX00000181303','IL','1','WILSON','DOROTHY','GEORGETTE','','','34','467574631','4540 BARNETT RD',0,'WICHITA FALLS','TX','76310','4909','CY','48485','1982-09-12','F','U',':RET:2106-3','N','021','DEN','2225544','33348TX002000201','2014-01-01','2013-12-24 12:56:18','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:52:08'),(20405,16297,'N','19','021','EC','A',NULL,NULL,'','0000067073','0000002713','','IL','1','GARCIA','ESTEBAN','','','','34','628907286','4828 HARTFORD DR',0,'RIVER OAKS','TX','76114','3003','CY','48439','2003-12-16','M','',NULL,'N','021','DEN','3219634','33348TX002000201','2014-03-01','2014-01-29 15:58:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-01-29 21:00:22'),(27841,22022,'Y','18','021','EC','A','','','AC','0000499882','0000499882','TX00002598117','IL','1','Avendano','Roberto','Martin','','Jr','34','636165744','3004 N ALAMO RD',0,'EDINBURG','TX','78542','2937','CY','48215','1990-03-17','M','M',':RET:2106-3','N','021','DEN','2985645','33348TX002000101','2014-04-01','2014-03-04 22:01:56','0.00',NULL,NULL,'50.04','50.04','R-TX015','TX0','25.02',NULL,0,'2014-03-05 21:32:08'),(4568,3617,'Y','18','021','EC','A','','','AC','0001191638','0001191638','TX00000747271','IL','1','Brown','Anthony','','','','34','445607924','11911 GREENVILLE AVE',0,'DALLAS','TX','75243','3671','CY','48113','1969-12-22','M','U',':RET:2054-5','N','021','DEN','84586','33348TX002000101','2014-01-01','2013-12-12 12:56:54','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 22:04:53'),(26057,20666,'Y','18','021','EC','A','','','AC','0001048046','0001048046','OH00002861777','IL','1','Pitler','Amy','','','','34','385882441','PO Box 13194',0,'Toledo','OH','43613',NULL,'CY','39095','1966-07-01','F','M',':RET:2106-3','N','021','HLT','2986628','92036OH002002601','2014-04-01','2014-02-26 00:05:12','54.00',NULL,NULL,'351.97','297.97','R-OH001','OH0','351.97',NULL,0,'2014-02-26 21:02:37'),(19526,15561,'N','01','021','EC','A',NULL,NULL,'','0000689722','0000550097','','IL','1','Ventura','Tuyet','','','','34','603901492','7350 JAGUAR CT',0,'WAYNESVILLE','OH','45068','8210','CY','39165','1977-11-01','F','',':RET:2047-9','N','021','DEN','2134178','99734OH005000401','2014-03-01','2014-01-21 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:19'),(9540,7560,'Y','18','021','EC','A','','','AC','0000093840','0000093840','OH00000691475','IL','1','Holcomb','Zachary','','','','34','295905395','201 HILLTOP DR',0,'DOYLESTOWN','OH','44230','1029','CY','39169','1985-01-21','M','U',':RET:2106-3','N','021','DEN','1729948','99734OH005000301','2014-01-01','2013-12-21 11:25:44','0.00',NULL,NULL,'21.13','21.13','R-OH014','OH0','0.00',NULL,0,'2013-12-26 04:35:59'),(2155,1772,'Y','18','021','EC','A','','','AC','0000980632','0000980632','LA00000209816','IL','1','Fuller','Amanda','','','','34','433673966','224 N JEFFERSON DAVIS PKWY',0,'NEW ORLEANS','LA','70119','5310','CY','22071','1983-04-26','F','U',':RET:2106-3','N','021','DEN','347225','18575LA002000101','2014-01-01','2013-12-09 21:46:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 19:18:40'),(13420,10707,'Y','18','021','EC','A','','','AC','0000003575','0000003575','OH00001038107','IL','1','Smith','Susan','','','','34','390463685','1830 LINDSEY LN',0,'CINCINNATI','OH','45230','2197','CY','39061','1960-05-18','F','U',':RET:2106-3','N','021','DEN','2264873','99734OH005000301','2014-01-01','2013-12-23 11:14:37','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:47'),(3099,2490,'Y','18','021','EC','A','','','AC','0000748162','0000748162','OH00001040228','IL','1','KERSEY','REBECCA','','','','34','285547125','983 ONTARIO TRL',0,'JAMESTOWN','OH','45335','1472','CY','39057','1953-01-08','F','M',':RET:2106-3','N','021','HLT','1165787','92036OH002000501','2014-01-01','2013-12-06 12:54:52','382.00',NULL,NULL,'745.01','363.01','R-OH003','OH0','745.01',NULL,0,'2013-12-25 20:20:13'),(7593,6007,'N','19','021','EC','A',NULL,NULL,'','0000221249','0000079872','','IL','1','Riley','Johnhenry','T','','','34','282020140','5062 WETMORE RD',0,'CONNEAUT','OH','44030','9644','CY','39007','1997-06-10','M','',NULL,'N','021','DEN','200360','99734OH005000401','2014-01-01','2013-11-17 09:21:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:45:11'),(24813,19676,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000455358','','IL','1','Burdick','Elliott','','','','34','274043242','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1998-12-21','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:02'),(9325,7392,'Y','18','021','EC','A','','','AC','0001712534','0001712534','LA00000782373','IL','1','Williams','Nolfris','','','','34','416173603','4301 Tulane Ave',0,'New Orleans','LA','70119',NULL,'CY','22071','1982-07-29','M','U',':RET:2054-5','N','021','DEN','1466133','18575LA002000101','2014-01-01','2013-12-21 16:11:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:36'),(726,601,'Y','18','021','EC','A','','','AC','0000963249','0000963249','TX00000837152','IL','1','menkhosf','choanne','','','','34','454311144','5801 NOTRE DAME DR',0,'AMARILLO','TX','79109','6664','CY','48381','1970-11-22','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','2185451','33348TX002000101','2014-01-01','2013-12-16 15:30:48','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2013-12-25 18:03:38'),(28034,22186,'N','19','021','EC','A',NULL,NULL,'','0000542737','0001015630','','S1','1','Williams','Christy','A','','','34','289063647','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','2001-10-22','M','',':RET:2106-3','N','021','DEN','3613905','99734OH005000401','2014-04-01','2014-03-06 17:25:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:29'),(13089,10435,'N','01','021','EC','A',NULL,NULL,'','0000556719','0000630372','','IL','1','Leighton','Stephanie','','','','34','284622166','8246 WOOSTER PIKE',0,'CINCINNATI','OH','45227','4010','CY','39061','1956-05-08','F','',':RET:2106-3','N','021','DEN','1498868','99734OH005000401','2014-01-01','2013-12-23 11:24:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:49'),(6387,5065,'Y','18','021','EC','A','','','AC','0001192648','0001192648','OH00000661712','IL','1','Timmons','Thomas','Clifford','','','34','079448514','3983 FELICE CT',0,'BEAVERCREEK','OH','45432','2073','CY','39057','1949-09-13','M','M',':RET:2106-3','N','021','DEN','679660','99734OH005000301','2014-01-01','2013-12-11 11:30:09','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:48:05'),(9164,7268,'N','01','021','EC','A',NULL,NULL,'','0000063703','0000230425','','IL','1','yu','chun','yun','','','34','291949801','5300 W US HIGHWAY 36',0,'URBANA','OH','43078','9644','CY','39021','1964-04-19','F','',':RET:2034-7','N','021','HLT','1757583','92036OH003000505','2014-01-01','2013-12-18 10:19:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','423.50',NULL,0,'2013-12-26 04:08:46'),(25250,20030,'Y','18','021','EC','A','','','AC','0000977172','0000977172','MS00002251133','IL','1','Everhardt','Gwendolyn','Licciardi','','','34','436940793','568 OLD CAMP RD',0,'POPLARVILLE','MS','39470','6101','CY','28109','1956-07-14','F','M',NULL,'N','021','DEN','3275817','46300MS002000101','2014-04-01','2014-02-21 14:26:02','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-21 22:01:13'),(4565,3614,'Y','18','021','EC','A','','','AC','0000502961','0000502961','OH00000301147','IL','1','Madrigal','Connie','J','','','34','270562507','214 N UNION ST',0,'FOSTORIA','OH','44830','2241','CY','39147','1962-07-22','F','U',NULL,'T','021','HLT','691175','92036OH003002705','2014-01-01','2013-12-11 19:17:33','258.00',NULL,NULL,'436.76','178.76','R-OH006','OH0','436.76',NULL,0,'2013-12-25 22:04:47'),(5168,4099,'Y','18','024','14','A','','','TE','0000803710','0000803710','','IL','1','DEVORE','DREW',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-20','M','',NULL,NULL,NULL,'','252161','','2013-12-19','2013-12-19 11:08:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:14'),(15561,12452,'Y','18','021','EC','A','','','AC','0000929805','0000929805','OH00001603360','IL','1','MAYFIELD','JACK','','','','34','278523377','129 WATERLOO RD',0,'MOGADORE','OH','44260',NULL,'CY','39133','1951-07-08','M','U',':RET:2106-3','N','021','HLT','2545209','52664OH151001306','2014-02-01','2013-12-31 10:07:41','536.00',NULL,NULL,'640.70','104.70','R-OH012','OH0','640.70',NULL,1,'2014-01-02 04:31:36'),(23794,18934,'Y','18','021','EC','A','','','AC','0000448817','0000448817','OH00001908175','IL','1','Brzeski','Karen','','','','34','280808152','6330 Grenwood Pkwy',0,'Sagamore Hills','OH','44067',NULL,'CY','39153','1967-05-06','F','U',':RET:2106-3','N','021','HLT','3068381','52664OH151001305','2014-03-01','2014-02-14 12:11:00','223.00',NULL,NULL,'334.51','111.51','R-OH012','OH0','334.51',NULL,0,'2014-02-14 21:31:26'),(15186,12135,'Y','18','021','EC','A','','','AC','0001182516','0001182516','OH00001435958','IL','1','Jordan','Ericka','','','','34','270721456','402 DANESMOOR RD',0,'HOLLAND','OH','43528','8209','CY','39095','1974-05-20','F','M',':RET:2054-5^:RET:2106-3','N','021','HLT','1532003','92036OH004002601','2014-02-01','2013-12-30 10:23:07','0.00',NULL,NULL,'197.87','197.87','R-OH001','OH0','197.87',NULL,0,'2014-01-01 12:06:57'),(7082,5618,'N','01','021','EC','A',NULL,NULL,'','0000995440','0000546482','','IL','1','Parsons','David','','','','34','132604956','2880 CLARKSON RD',0,'CLEVELAND','OH','44118','2819','CY','39035','1963-10-28','M','',NULL,'N','021','DEN','1999008','99734OH005000301','2014-02-01','2013-12-25 00:46:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:19'),(26798,21237,'N','19','021','EC','A',NULL,NULL,'','0000862497','0001166863','','IL','1','Gonzalez','Eusebio','','','Jr','34','272047597','336 N BERLIN AVE',0,'TOLEDO','OH','43605','1508','CY','39095','1998-11-20','M','',NULL,'N','021','HLT','2734646','92036OH003002605','2014-04-01','2014-03-01 16:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-01 21:00:22'),(2773,2240,'Y','18','021','EC','A','','','AC','0000300374','0000300374','OH00000995845','IL','1','Rowe','Sarah','I','','','34','276825839','97 Paige Ave.',0,'Akron','OH','44302',NULL,'CY','39153','1983-01-07','F','U',':RET:2106-3','N','021','HLT','18547','52664OH151001301','2014-01-01','2013-12-02 16:27:16','0.00',NULL,NULL,'253.11','253.11','R-OH012','OH0','253.11',NULL,0,'2013-12-25 19:49:35'),(29196,23106,'N','19','021','EC','A',NULL,NULL,'','0000906663','0000540357','','IL','1','BRADFORD','SANTANA','','','','34','285153910','3615 BERKELEY RD',0,'CLEVELAND HEIGHTS','OH','44118','1940','CY','39035','2009-08-14','M','',':RET:2054-5','N','021','DEN','3599206','99734OH005000301','2014-04-01','2014-03-10 11:31:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-10 21:30:08'),(16906,13527,'N','01','021','EC','A',NULL,NULL,'','0001145990','0000333877','','IL','1','Lutterodt','Salomey','A','','','34','305235867','7574 BARON CT',0,'WEST CHESTER','OH','45069','2306','CY','39017','1955-06-06','F','',':RET:2054-5','N','021','DEN','1963586','99734OH005000401','2014-02-01','2014-01-09 16:34:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:19:35'),(7350,5820,'Y','18','021','EC','A','','','AC','0000477152','0000477152','LA00000551298','31','1','Higgins','Sarah','','','','34','456060557','PO Box 740782',0,'New Orleans','LA','70174',NULL,'CY','22071','1954-08-24','F','U',':RET:2106-3','N','021','DEN','1243169','18575LA002000101','2014-01-01','2013-11-22 18:28:10','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 02:15:05'),(21457,17148,'Y','18','021','EC','A','','','AC','0000292005','0000292005','OH00002073877','IL','1','Weber','Melissa','','','','34','302868050','1639 MAPLE GROVE CT',0,'STREETSBORO','OH','44241','6349','CY','39133','1982-05-31','F','U',':RET:2106-3','N','021','HLT','3359861','52664OH151001306','2014-03-01','2014-02-04 14:40:46','188.00',NULL,NULL,'258.47','70.47','R-OH012','OH0','258.47',NULL,0,'2014-02-04 21:01:31'),(16673,13343,'Y','18','021','EC','A','','','AC','0000366292','0000366292','OH00001615191','IL','1','Ahmed','Engy','','','','34','370197720','8900 COLDWATER DR',0,'POWELL','OH','43065','7096','CY','39041','1986-04-19','F','R',NULL,'N','021','DEN','2348322','99734OH005000301','2014-02-01','2014-01-06 20:06:59','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:29'),(28458,22518,'Y','18','021','EC','A','','','AC','0001192102','0001192102','LA00003336168','IL','1','BRITTON','LATANYA','','','','34','436352540','75 CARRIAGE LANE',0,'DESTREHAN','LA','70047',NULL,'CY','22089','1978-08-18','F','U',':RET:2054-5','N','021','DEN','2972622','18575LA002000201','2014-04-01','2014-03-07 14:57:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:23'),(9518,7549,'Y','18','021','EC','A','','','AC','0000654590','0000654590','OH00001255543','IL','1','STOFF','ALBERT','F','','','34','286447336','2833 FERNCLIFF AVE',0,'DAYTON','OH','45420','3201','CY','39113','1955-08-08','M','M',':RET:2106-3','T','021','DEN','1945323','99734OH005000301','2014-01-01','2013-12-20 19:14:38','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:35:35'),(1829,1500,'Y','18','021','EC','A','','','AC','0000911768','0000911768','OH00001547795','IL','1','robertswhitehead','michelle','','','','34','273665000','3054 CAMELOT DR',0,'OREGON','OH','43616','2905','CY','39095','1961-05-28','F','M',':RET:2106-3','N','021','HLT','1714271','92036OH003002605','2014-01-01','2013-12-24 11:18:20','195.00',NULL,NULL,'397.49','202.49','R-OH001','OH0','397.49',NULL,0,'2013-12-25 18:57:23'),(25921,20556,'Y','18','021','EC','A','','','AC','0001245622','0001245622','TX00003044849','IL','1','Lawrence','Rose','','','','34','466538851','20000 Samus Road',0,'katy','TX','77449',NULL,'CY','48201','1956-12-06','F','U',':RET:2054-5','N','021','DEN','3119837','33348TX002000201','2014-04-01','2014-02-26 15:42:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 21:01:20'),(7677,6081,'Y','18','021','EC','A','','','AC','0000767386','0000767386','OH00000003033','IL','1','Turner','Nicole','Renee','','','34','301805693','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','1970-12-01','F','U',NULL,'N','021','DEN','2276263','99734OH005000401','2014-01-01','2013-12-19 19:29:16','0.00',NULL,NULL,'50.05','50.05','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:00:45'),(3884,3112,'Y','18','021','EC','A','','','AC','0000373600','0000373600','OH00000646096','IL','1','Anderson','Robin','L','','','34','296501026','240 NATHAN AVE',0,'CUYAHOGA FALLS','OH','44221','2613','CY','39153','1954-05-22','M','U',':RET:2106-3','T','021','HLT','979971','52664OH152000901','2014-01-01','2013-12-13 18:05:21','0.00',NULL,NULL,'488.95','488.95','R-OH012','OH0','488.95',NULL,0,'2013-12-25 21:36:31'),(9050,7179,'Y','18','021','EC','A','','','AC','0000630363','0000630363','OH00000733222','IL','1','LUCAK','DOUGLAS','','','','34','287665937','1814 E 40TH ST',0,'CLEVELAND','OH','44103',NULL,'CY','39035','1959-01-13','M','U',':RET:2106-3','N','021','HLT','2552837','52664OH151001304','2014-01-01','2013-12-18 17:41:38','283.00',NULL,NULL,'536.99','253.99','R-OH011','OH0','536.99',NULL,0,'2013-12-26 04:05:59'),(20335,16238,'Y','18','021','EC','A','','','AC','0000788237','0000788237','OH00001492542','IL','1','Garapic','Mark','','','','34','300647757','127 GRAND AVE',0,'AKRON','OH','44302','1219','CY','39153','1959-03-20','M','U',':RET:2106-3','T','021','HLT','2070449','52664OH151001501','2014-03-01','2014-01-28 12:49:48','116.00',NULL,NULL,'656.69','540.69','R-OH012','OH0','656.69',NULL,0,'2014-01-28 21:01:04'),(28931,22895,'N','01','021','EC','A',NULL,NULL,'','0000701767','0000783313','','IL','1','Tepperman','Jonathan','','','','34','522867070','3021 WOODBINE PL',0,'COLUMBUS','OH','43202','1428','CY','39049','1972-05-09','M','',':RET:2106-3','N','021','DEN','4272007','99734OH005000301','2014-04-01','2014-03-10 13:47:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:37'),(129,112,'Y','18','021','EC','A','','','AC','0000848960','0000848960','MS00000123318','IL','1','Davis','Louis','','','','34','587320969','407 COLLEGE ST',0,'NATCHEZ','MS','39120','2416','CY','28001','1951-07-10','M','U',':RET:2054-5','N','021','DEN','713024','46300MS002000201','2014-01-01','2013-12-05 15:58:55','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 17:18:25'),(18760,14948,'Y','18','021','EC','A','','','AC','0000243816','0000243816','TX00002328071','IL','1','GARCIA','ALFONSO','JAIME','','','34','576510422','571 W 6TH ST',0,'LANCASTER','TX','75146',NULL,'CY','48113','1977-01-27','M','M',NULL,'N','021','DEN','1454813','33348TX002000101','2014-02-01','2014-01-15 21:34:38','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-01-17 03:35:47'),(2542,2068,'N','01','021','EC','A',NULL,NULL,'','0000013750','0001078866','','IL','1','McCormick','Cheryl','L','','','34','289446517','8340 W BANCROFT ST',0,'TOLEDO','OH','43617','1902','CY','39095','1950-04-05','F','',':RET:2106-3','N','021','HLT','1010158','92036OH006002601','2014-01-01','2013-12-09 14:13:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','456.50',NULL,0,'2013-12-25 19:37:03'),(26858,21287,'N','19','021','EC','A',NULL,NULL,'','0000177685','0000396216','','IL','1','campton','Andrew','','','','34','289987066','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1995-09-26','M','',NULL,'N','021','HLT','3909716','92036OH003000601','2014-04-01','2014-03-01 11:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-01 21:00:55'),(2474,2014,'Y','18','021','EC','A','','','AC','0000917721','0000917721','LA00000053529','IL','1','Smith','Ava','','','','34','435905027','402 DAPHNE DR',0,'GONZALES','LA','70737','3353','CY','22005','1953-01-01','F','M',':RET:2054-5','N','021','DEN','543534','18575LA002000201','2014-01-01','2013-12-09 11:50:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:19'),(23760,18910,'N','01','021','EC','A',NULL,NULL,'','0000756056','0000504511','','IL','1','Vulcan','Lucia','','','','34','269026497','4517 OCALA DR',0,'PARMA','OH','44134','6331','CY','39035','1958-07-29','F','',':RET:2106-3','N','021','DEN','3560706','99734OH005000301','2014-03-01','2014-02-14 10:14:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:10'),(19707,15705,'Y','18','021','EC','A','','','AC','0000850673','0000850673','TX00002403519','IL','1','PARK','SUN','','','','34','357782946','16705 ANJOU LN',0,'ROUND ROCK','TX','78681','5316','CY','48491','1958-08-04','F','M',':RET:2040-4','N','021','DEN','3071475','33348TX002000201','2014-03-01','2014-01-23 15:38:32','0.00',NULL,NULL,'47.55','47.55','R-TX003','TX0','15.85',NULL,0,'2014-01-23 21:00:51'),(19646,15657,'Y','18','021','EC','A','','','AC','0000412235','0000412235','OH00001744129','IL','1','Costello','Elizabeth','','','','34','266394911','4630 Collingville Way',0,'Columbus','OH','43230',NULL,'CY','39049','1960-08-13','F','M',':RET:2106-3','N','021','DEN','1483410','99734OH005000401','2014-03-01','2014-01-23 09:35:29','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:17'),(18817,14987,'N','01','021','EC','A',NULL,NULL,'','0001212363','0000863490','','IL','1','shteiwi','hala','','','','34','288662099','5758 AUBERGER DR',0,'FAIRFIELD','OH','45014','3806','CY','39017','1960-11-19','F','',':RET:2028-9','N','021','DEN','2204901','99734OH005000401','2014-02-01','2014-01-15 20:10:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:36:05'),(28347,22429,'Y','18','021','EC','A','','','AC','0000290828','0000290828','TX00003479604','IL','1','Lewis','Florence','','','','34','449536156','3514 TINA ST',0,'SACHSE','TX','75048','3168','CY','48113','1970-09-21','F','M',':RET:2054-5','N','021','DEN','3883097','33348TX002000201','2014-04-01','2014-03-07 11:56:27','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:20'),(15155,12114,'Y','18','024','14','A','','','TE','0000203039','0000203039','','IL','1','alexakis','kyriakos',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-03','M','',NULL,NULL,NULL,'','932054','','2013-12-30','2013-12-30 13:04:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:11'),(27090,21446,'N','01','021','EC','A',NULL,NULL,'','0000581554','0000550134','','IL','1','Dugger','Charlotte','','','','34','299525726','3316 BATH HEIGHTS DR',0,'CUYAHOGA FALLS','OH','44223','3756','CY','39153','1952-04-23','F','',NULL,'N','021','HLT','3401943','52664OH151001305','2014-04-01','2014-03-03 12:38:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-03-03 21:30:16'),(730,605,'Y','18','021','EC','A','','','AC','0000980947','0000980947','TX00001178690','IL','1','Hammonds','Gena','S','','','34','458675349','2202 JOHN TEE DR',0,'CEDAR PARK','TX','78613','1753','CY','48491','1967-08-11','F','U',':RET:2106-3','N','021','DEN','1503015','33348TX002000101','2014-01-01','2013-12-16 18:06:52','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:03:46'),(4576,3624,'Y','18','021','EC','A','','','AC','0000560376','0000560376','TX00000704430','IL','1','Wilkins','Michael','D','','','34','505969018','808 COUNTY ROAD 4777',0,'TIMPSON','TX','75975','3200','CY','48419','1960-12-11','M','M',':RET:2054-5','N','021','DEN','579070','33348TX002000101','2014-01-01','2013-12-12 17:36:27','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-25 22:05:05'),(23169,18471,'Y','18','021','EC','A','','','AC','0000956539','0000956539','TX00001776037','IL','1','Arbor','ALana','','','','34','465132656','803 BLACKSHEAR DR',0,'HEARNE','TX','77859','3502','CY','48395','1957-08-27','F','M',':RET:2054-5','N','021','DEN','2883869','33348TX002000101','2014-03-01','2014-02-12 16:37:13','0.00',NULL,NULL,'25.02','25.02','R-TX006','TX0','25.02',NULL,0,'2014-02-12 21:31:52'),(23076,18399,'Y','18','021','EC','A','','','AC','0001653676','0001653676','LA00002336694','IL','1','LU','WEIBIN','','','','34','115941817','14050 GARDEN COVE CT',0,'GONZALES','LA','70737','8948','CY','22005','1989-08-21','M','U',':RET:2034-7','N','021','DEN','3396487','18575LA002000201','2014-03-01','2014-02-12 16:45:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:31:00'),(8001,6331,'Y','18','024','14','A','','','TE','0000971450','0000971450','','IL','1','Goldstein','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-04','F','',NULL,NULL,NULL,'','130374','','2013-12-20','2013-12-20 16:34:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:08:22'),(28950,22911,'Y','18','021','EC','A','','','AC','0001152312','0001152312','LA00003321033','IL','1','Giblin','Amelia','','','','34','333569694','1114 Felicity St.',0,'New Orleans','LA','70130',NULL,'CY','22071','1959-04-10','F','U',':RET:2106-3','N','021','DEN','3203611','18575LA002000201','2014-04-01','2014-03-09 23:35:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:49'),(28359,22438,'Y','18','021','EC','A','','','AC','0000599673','0000599673','TX00003723662','31','1','Holoman','Elisha','K','','','34','460273758','po box 841',0,'trinity','TX','75862',NULL,'CY','48455','1973-08-15','F','U',NULL,'N','021','DEN','4159523','33348TX002000201','2014-04-01','2014-03-07 14:05:27','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:27'),(1927,1570,'Y','18','021','EC','A','','','AC','0001168776','0001168776','TX00000891984','IL','1','Geistweidt','Sammy','','','','34','456766845','169 T ANCHOR RD',0,'FREDERICKSBURG','TX','78624','6562','CY','48171','1950-09-09','M','M',':RET:2106-3','N','021','DEN','825918','33348TX002000201','2014-01-01','2013-11-19 18:25:19','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:00:17'),(13525,10782,'Y','18','021','EC','A','','','AC','0001727885','0001727885','LA00000195422','IL','1','Irvin','Harris','','','','34','437336700','13252 SAINT HELENA PL',0,'NEW ORLEANS','LA','70129','1024','CY','22071','1966-05-12','M','U',NULL,'N','021','DEN','1683677','18575LA002000201','2014-01-01','2013-12-23 10:36:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:18'),(6274,4974,'Y','18','021','EC','A','','','AC','0000777654','0000777654','OH00001046718','IL','1','Bostic','H Evelyn','','','','34','283520701','1950 ANDINA AVE',0,'CINCINNATI','OH','45237','6018','CY','39061','1952-07-02','F','U',':RET:2054-5','N','021','DEN','383119','99734OH005000401','2014-01-01','2013-12-10 18:56:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:45:10'),(6826,5410,'N','19','021','EC','A',NULL,NULL,'','0001169407','0001131407','','IL','1','Smas','Thomas','','','','34','287156990','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','2009-10-26','M','',NULL,'N','021','DEN','1156560','99734OH005000301','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:30:39'),(3331,2673,'Y','18','021','EC','A','','','AC','0000129258','0000129258','OH00000230660','IL','1','SHAOMO','CHRISTYNA','M','','','34','288584694','824 W HIGHLAND AVE',0,'RAVENNA','OH','44266','2130','CY','39133','1955-12-24','F','U',':RET:2106-3','N','021','DEN','1726506','99734OH005000301','2014-01-01','2013-12-22 18:08:40','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:16:18'),(18450,14717,'N','01','021','EC','A',NULL,NULL,'','0000909497','0000053077','','IL','1','Newnam','Wayne','','','','34','287462093','565 Countryside Dr South',0,'Troy','OH','45373',NULL,'CY','39109','1952-12-03','M','',':RET:2106-3','N','021','HLT','2026613','92036OH006000501','2014-02-01','2014-01-14 19:27:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','529.74',NULL,0,'2014-01-16 08:46:07'),(20315,16218,'Y','18','024','14','A','','','TE','0000613886','0000613886','','IL','1','Fragoso','Betty',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-06','F','',NULL,NULL,NULL,'','3288910','','2014-01-28','2014-01-28 13:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:52'),(22787,18193,'Y','18','021','EC','A','','','AC','0000525621','0000525621','OH00002211335','IL','1','EVANS','TERRI','','','','34','206442505','5545 CHOWNING WAY',0,'COLUMBUS','OH','43213','1409','CY','39049','1955-06-25','F','U',':RET:2106-3','N','021','DEN','2647585','99734OH005000301','2014-03-01','2014-02-11 10:40:51','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-11 21:01:47'),(4935,3916,'Y','18','024','14','A','','','TE','0000828195','0000828195','','IL','1','Burns','Kristina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-18','F','',NULL,NULL,NULL,'','980619','','2013-12-07','2013-12-07 12:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:45:32'),(939,776,'N','01','021','EC','A',NULL,NULL,'','0000866852','0000172365','','IL','1','means','nancy','','','','34','115786330','687 WOODTHRUSH DR',0,'CINCINNATI','OH','45244','1150','CY','39025','1956-03-15','F','',NULL,'N','021','DEN','442950','99734OH005000401','2014-01-01','2013-10-31 14:19:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:17'),(5258,4170,'Y','18','021','EC','A','','','AC','0000385886','0000385886','OH00000918141','IL','1','RIDDLE','ALICE','C','','','34','301562771','581 STEPPORD AVE',0,'ACKRIN','OH','44312',NULL,'CY','39153','1956-03-16','F','U',':RET:2106-3','N','021','HLT','1807003','52664OH151001305','2014-01-01','2013-12-19 10:26:51','419.00',NULL,NULL,'543.47','124.47','R-OH012','OH0','543.47',NULL,0,'2013-12-25 23:05:17'),(28225,22333,'Y','18','024','14','A','','','TE','0000971518','0000971518','','IL','1','habli','ibrahim',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2004-08-11','M','',NULL,NULL,NULL,'','3168356','','2014-03-06','2014-03-06 15:47:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-06 21:30:21'),(21248,16979,'Y','18','021','EC','A','','','AC','0001054249','0001054249','OH00001939495','IL','1','Southwick','Terry','','','','34','280529036','403 ARDEN RD',0,'COLUMBUS','OH','43214','3764','CY','39049','1952-02-21','F','U',':RET:2106-3','N','021','DEN','3037969','99734OH005000301','2014-03-01','2014-02-03 18:05:18','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-03 21:01:16'),(25287,20064,'Y','18','021','EC','A','','','AC','0001235237','0001235237','OH00002224336','IL','1','WOLF','RICHARD','','','','34','281546318','773 COUNTY ROAD 2920',0,'PERRYSVILLE','OH','44864','9752','CY','39005','1953-04-01','M','M',NULL,'N','021','HLT','3772849','52664OH151001305','2014-03-01','2014-02-24 21:21:42','851.00',NULL,NULL,'985.69','134.69','R-OH012','OH0','605.24','CIC',0,'2014-02-25 21:00:21'),(28640,22665,'N','01','021','EC','A',NULL,NULL,'','0001219488','0000238631','','IL','1','GARCIA','ROSALIO','','','','34','475879581','240 SANTOS GOMEZ DR',0,'SAN BENITO','TX','78586','8048','CY','48061','1959-09-04','M','',NULL,'N','021','DEN','3873156','33348TX002000201','2014-04-01','2014-03-08 15:21:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:32'),(24397,19378,'N','01','021','EC','A',NULL,NULL,'','0000175155','0000798470','','IL','1','GRIFFIN','JERRY','','','','34','235882281','250 FAIRVIEW ST',0,'MARION','OH','43302','1815','CY','39101','1954-06-10','M','',':RET:2106-3','N','021','DEN','3091062','99734OH005000401','2014-04-01','2014-02-18 14:10:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:52'),(7788,6167,'N','01','021','EC','A',NULL,NULL,'','0000493093','0000155059','','IL','1','Valles','Christene','Elizabeth','','','34','449151969','305 Persimmon Ave',0,'Sanderson','TX','79848',NULL,'CY','48443','1957-11-08','F','',':RET:2106-3','N','021','DEN','2592275','33348TX002000201','2014-01-01','2013-12-20 14:26:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:03:22'),(1713,1430,'Y','18','021','EC','A','','','AC','0000851841','0000851841','OH00000247635','IL','1','Handley','David','','','','34','302647180','5320 HI LO DR',0,'FRAZEYSBURG','OH','43822','9002','CY','39119','1958-12-02','M','M',':RET:2106-3','N','021','DEN','1668699','99734OH005000301','2014-01-01','2013-12-24 08:01:26','0.00',NULL,NULL,'87.78','87.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:55:03'),(2118,1738,'Y','18','024','14','A','','','TE','0000746850','0000746850','','IL','1','Jorgensen','Cindy','Marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-30','F','',NULL,NULL,NULL,'','308852','','2013-12-10','2013-12-10 13:00:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:17:39'),(14866,11870,'Y','18','021','EC','A','','','AC','0000119289','0000119289','TX00001580120','IL','1','Schweers','Ellen','','','','34','449117895','411 WAINWRIGHT ST',0,'DENTON','TX','76201','6117','CY','48121','1954-07-22','F','U',':RET:2106-3','N','021','DEN','1473061','33348TX002000201','2014-02-01','2013-12-28 19:18:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-30 00:00:05'),(25119,19926,'N','01','021','EC','A',NULL,NULL,'','0000710190','0000858534','','IL','1','Wilhelm','Randy','A','','','34','302526139','15159 MONROE MILLS RD',0,'MOUNT VERNON','OH','43050','9739','CY','39083','1966-06-13','M','',NULL,'N','021','DEN','3204348','99734OH005000301','2014-04-01','2014-02-21 12:01:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-21 21:30:20'),(9205,7302,'Y','18','021','EC','A','','','AC','0000237440','0000237440','MS00000834803','IL','1','MAISURIA','RAKESHKUMAR','','','','34','665774479','2206 MAIN ST',0,'COLUMBUS','MS','39701','6046','CY','28087','1972-10-09','M','M',':RET:2029-7','N','021','DEN','1988233','46300MS002000201','2014-01-01','2013-12-18 12:27:15','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2013-12-26 04:09:47'),(16623,13298,'Y','18','024','14','A','','','TE','0000650793','0000650793','','IL','1','Meek','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-29','M','',NULL,NULL,NULL,'','1605811','','2014-01-07','2014-01-07 14:16:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:24:12'),(19319,15400,'Y','18','021','EC','A','','','AC','0001185207','0001185207','TX00001547314','31','1','ROSA','MAGALI','','','','34','458619398','PO BOX 312',0,'ROMAN','TX','78584',NULL,'CY','48427','1982-06-19','F','U',':RET:2106-3','N','021','DEN','2920443','33348TX002000201','2014-03-01','2014-01-21 11:01:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-22 03:22:10'),(24514,19473,'N','19','021','EC','A',NULL,NULL,'','0000737484','0000999260','','IL','1','Hinojosa','Brandin','','','','34','629801904','6200 Crosscreek Ln',0,'Benbrook','TX','76109',NULL,'CY','48439','2001-12-25','M','',NULL,'N','021','DEN','2793876','33348TX002000201','2014-04-01','2014-02-19 10:40:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-20 03:54:26'),(23156,18460,'Y','18','021','EC','A','','','AC','0001012973','0001012973','OH00002200505','IL','1','Iredale','Jeanean','','','','34','273866964','6619 HIGHLAND AVE',0,'CINCINNATI','OH','45236','3914','CY','39061','1971-12-28','F','R',':RET:2106-3','T','021','HLT','3035557','92036OH004001201','2014-03-01','2014-02-12 16:34:06','0.00',NULL,NULL,'263.02','263.02','R-OH004','OH0','263.02',NULL,0,'2014-02-12 21:31:44'),(28823,22811,'Y','18','021','EC','A','','','AC','0000066325','0000066325','OH00002615617','IL','1','Rodriguiez','Larry','','','','34','291642958','2719 BLEEKER ST',0,'OREGON','OH','43616','2107','CY','39095','1961-02-22','M','U',NULL,'T','021','HLT','3751109','92036OH004002601','2014-04-01','2014-03-09 11:33:19','296.00',NULL,NULL,'367.84','71.84','R-OH001','OH0','367.84',NULL,0,'2014-03-09 21:01:01'),(13560,10814,'Y','18','021','EC','A','','','AC','0001460336','0001460336','LA00000363379','IL','1','Liu','Eden','','','','34','245550888','1410 st andrew st',0,'new orleans','LA','70130',NULL,'CY','22071','1987-09-04','F','R',':RET:2034-7','N','021','DEN','2246804','18575LA002000201','2014-01-01','2013-12-23 15:43:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:20'),(641,530,'Y','18','024','14','A','','','TE','0000251603','0000251603','','IL','1','HILL','STANLEY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-20','M','',NULL,NULL,NULL,'','897557','','2013-12-16','2013-12-16 14:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:01:22'),(7617,6027,'N','01','021','EC','A',NULL,NULL,'','0001188760','0000735002','','IL','1','Stephens','Debra','','','','34','271803515','2557Bramble rd sw',0,'Carrollton','OH','44615',NULL,'CY','39019','1966-11-05','F','',':RET:2106-3','N','021','DEN','684141','99734OH005000301','2014-01-01','2013-11-17 09:52:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:45:48'),(26610,21099,'Y','18','021','EC','A','','','AC','0001090853','0001090853','TX00002839066','IL','1','dill','christopher','','','','34','463673992','1020 RS COUNTY ROAD 1690',0,'LONE OAK','TX','75453','8014','CY','48379','1982-02-19','M','M',':RET:2106-3','N','021','DEN','3527057','33348TX002000201','2014-03-01','2014-02-27 23:42:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:47'),(18160,14503,'Y','18','021','EC','A','','','AC','0000333886','0000333886','OH00002505258','IL','1','Young','Steve','','','','34','294704814','9536 HOUSTON RD',0,'SIDNEY','OH','45365','8034','CY','39149','1967-05-22','M','M',NULL,'N','021','HLT','1819573','92036OH003000504','2014-02-01','2014-01-14 11:33:40','476.00',NULL,NULL,'730.81','254.81','R-OH003','OH0','372.35',NULL,0,'2014-01-15 02:07:54'),(16742,13393,'Y','18','021','EC','A','','','AC','0000403673','0000403673','OH00001911977','IL','1','Mcquain','Mary','Lynne','','','34','283483566','129 W CUYAHOGA FALLS AVE',0,'AKRON','OH','44310','2903','CY','39153','1951-11-23','F','M',':RET:2106-3','N','021','HLT','2050004','52664OH151001301','2014-02-01','2014-01-07 13:53:54','895.00',NULL,NULL,'1281.40','386.40','R-OH012','OH0','640.70',NULL,0,'2014-01-08 18:24:52'),(27995,22152,'Y','18','021','EC','A','','','AC','0000521015','0000521015','OH00003098705','IL','1','DECKER','KEVIN','','','','34','290685436','975 MILLER AVE',0,'NEWARK','OH','43055',NULL,'CY','39089','1963-11-21','M','M',NULL,'N','021','DEN','3187864','99734OH005000401','2014-04-01','2014-03-05 19:06:33','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:06'),(28729,22737,'Y','18','024','14','A','','','TE','0001250715','0001250715','','IL','1','Tademy','Charnell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-10-05','F','',NULL,NULL,NULL,'','2390177','','2014-03-31','2014-03-09 12:33:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-09 21:00:02'),(3312,2661,'N','19','021','EC','A',NULL,NULL,'','0000198559','0000744430','','IL','1','Kamman','Orion','','','','34','301023050','5542 KAREN AVE',0,'CINCINNATI','OH','45248','5207','CY','39061','1998-07-20','M','',':RET:2106-3','N','021','DEN','2587529','99734OH005000301','2014-01-01','2013-12-22 14:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:52'),(6477,5129,'N','01','021','EC','A',NULL,NULL,'','0000217560','0000461909','','IL','1','Cord','Adam','','','','34','282883781','741 ABINGTON RD',0,'AKRON','OH','44312','2440','CY','39153','1973-11-23','M','',':RET:2106-3','N','021','HLT','596609','52664OH151001306','2014-01-01','2013-12-10 23:35:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','285.00',NULL,0,'2013-12-26 00:50:13'),(24616,19537,'Y','18','021','EC','A','','','AC','0001239785','0001239785','MS00002725558','31','1','BROWN','WALTER','','','','34','587562965','P. O. BX 94',0,'CHARLESTON','MS','38921',NULL,'CY','28135','1953-01-06','M','U',':RET:2054-5','N','021','DEN','3138700','46300MS002000201','2014-04-01','2014-02-19 11:48:08','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-20 04:14:52'),(22537,17995,'Y','18','021','EC','A','','','AC','0000182802','0000182802','MS00001996843','IL','1','Holt','David','','','','34','427027994','1206 SUNSET DR',0,'OCEAN SPRINGS','MS','39564','2943','CY','28059','1955-09-23','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','3266715','46300MS002000201','2014-03-01','2014-02-10 15:07:56','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-10 21:31:36'),(19896,15870,'Y','18','021','EC','A','','','AC','0002134557','0002134557','LA00001905541','IL','1','nicholas','erica','','','','34','437113894','825 E HARDING ST',0,'DESTREHAN','LA','70047','4222','CY','22089','1962-05-14','F','U',':RET:2054-5','N','021','DEN','3099030','18575LA002000101','2014-03-01','2014-01-23 20:10:07','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-24 21:00:53'),(20583,16446,'Y','18','021','EC','A','','','AC','0000868267','0000868267','OH00001991540','IL','1','Hitchcock','Daniel','','','','34','274909774','3463 WHITFIELD AVE',0,'CINCINNATI','OH','45220','1556','CY','39061','1987-08-04','M','M',NULL,'N','021','DEN','3094238','99734OH005000401','2014-03-01','2014-01-29 18:27:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(21021,16798,'Y','18','021','EC','A','','','AC','0000545275','0000545275','OH00001568047','IL','1','Gott','Christopher','','','','34','564274613','11088 PHILLIPS RD',0,'BLUFFTON','OH','45817','9512','CY','39003','1973-07-05','M','M',NULL,'N','021','DEN','3506874','99734OH005000401','2014-03-01','2014-02-01 14:57:58','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2014-02-01 19:00:40'),(9798,7759,'Y','18','021','EC','A','','','AC','0001083379','0001083379','TX00000239982','IL','1','Martinez','Kimberly','','','','34','465996714','201 33RD ST',0,'SNYDER','TX','79549','3819','CY','48415','1988-06-11','F','M',':RET:2106-3','N','021','DEN','96848','33348TX002000201','2014-01-01','2013-10-21 09:54:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 05:01:10'),(22571,18026,'Y','18','021','EC','A','','','AC','0000158034','0000158034','OH00002598706','IL','1','Jakubec','Kara','','','','34','299800540','4717 CLINTON AVE',0,'CLEVELAND','OH','44102','3446','CY','39035','1981-07-17','F','U',':RET:2106-3','N','021','DEN','3132029','99734OH005000401','2014-03-01','2014-02-10 16:46:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:56'),(3439,2764,'Y','18','021','EC','A','','','AC','0002223458','0002223458','LA00000528908','31','1','Parkman','Diane','','','','34','433172697','4085 HAZELWOOD DR',0,'BATON ROUGE','LA','70805','5228','CY','22033','1962-05-09','F','U',':RET:2054-5','N','021','DEN','1950115','18575LA002000101','2014-01-01','2013-12-22 17:25:21','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 21:19:10'),(6118,4852,'Y','18','024','14','A','','','TE','0000315241','0000315241','','IL','1','King','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-05-10','M','',NULL,NULL,NULL,'','128983','','2013-11-20','2013-11-20 20:52:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:15:40'),(6225,4934,'N','01','021','EC','A',NULL,NULL,'','0000478438','0000479802','','IL','1','Moore','Bruce','Edward','','','34','285765114','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1980-09-05','M','',NULL,'T','021','HLT','1018266','92036OH006001501','2014-01-01','2013-10-16 20:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.45',NULL,0,'2013-12-26 00:31:15'),(17839,14251,'Y','18','021','EC','A','','','AC','0000570578','0000570578','OH00002152586','IL','1','McCleery','Patrick','','','','34','272706039','4645 CADMUS DR',0,'COLUMBUS','OH','43228','8406','CY','39049','1976-02-08','M','U',':RET:2106-3','N','021','DEN','1586271','99734OH005000401','2014-02-01','2014-01-13 19:54:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:02'),(17937,14331,'Y','18','021','EC','A','','','AC','0000891092','0000891092','TX00002254184','IL','1','chavarria','priscilla','','','','34','449731977','5010 SEAN HAGGERTY DR',0,'EL PASO','TX','79924','1213','CY','48141','1985-03-01','F','U',':RET:2106-3','N','021','DEN','2026595','33348TX002000201','2014-02-01','2014-01-14 14:57:43','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-15 02:06:38'),(226,190,'Y','18','021','EC','A','','','AC','0000857670','0000857670','LA00000320112','IL','1','WHITE','KATHLEEN','','','','34','437980037','207 COBB ST',0,'SPRINGHILL','LA','71075','3811','CY','22119','1957-04-13','F','M',NULL,'N','021','DEN','223867','18575LA002000201','2014-01-01','2013-12-05 14:42:15','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 17:20:55'),(5983,4735,'N','01','021','EC','A',NULL,NULL,'','0000740276','0000684818','','IL','1','Stanic','Riste','','','','34','286066248','7013 STATE RD',0,'PARMA','OH','44134','4950','CY','39035','1965-01-21','M','',':RET:2106-3','N','021','HLT','1965704','92036OH003000805','2014-01-01','2013-12-23 23:36:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','399.20',NULL,0,'2013-12-25 23:51:58'),(5906,4679,'Y','18','021','EC','A','','','AC','0000321045','0000321045','OH00001429459','IL','1','Pullalarevu','Sasidhar','','','','34','177808485','10820 Kingslake Dr',0,'Cincinnati','OH','45242',NULL,'CY','39061','1980-10-11','M','M',':RET:2029-7','N','021','DEN','1698426','99734OH005000301','2014-01-01','2013-12-24 00:42:25','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:49:54'),(8850,7016,'Y','18','021','EC','A','','','AC','0001130715','0001130715','TX00000634514','IL','1','Salvany','M Lyn','','','','34','461196104','809 N 7TH ST',0,'TEMPLE','TX','76501','2571','CY','48027','1967-02-17','F','U',':RET:2106-3','N','021','DEN','1359491','33348TX002000201','2014-01-01','2013-12-18 09:50:22','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 04:01:00'),(7406,5861,'Y','18','021','EC','A','','','AC','0000870118','0000870118','TX00000355421','IL','1','Fairchild','Alicia','','','','34','436732163','4525 GLENWOOD AVE',0,'DEER PARK','TX','77536','7901','CY','48201','1978-12-17','F','U',':RET:2106-3','N','021','DEN','750796','33348TX002000201','2014-01-01','2013-10-26 22:43:01','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:16:35'),(26468,20995,'Y','18','024','14','A','','','TE','0000428999','0000428999','','IL','1','Bencar','Chris',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-11-18','M','',NULL,NULL,NULL,'','330390','','2014-02-28','2014-02-27 13:06:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:35'),(27807,21992,'N','01','021','EC','A',NULL,NULL,'','0000495502','0000045840','','IL','1','DOBRIDJEVIC','GORDANA','','','','34','293045833','792 HANCOCK CIR',0,'AKRON','OH','44314','1017','CY','39153','1976-01-28','F','',':RET:2106-3','N','021','HLT','3753464','52664OH151001305','2014-04-01','2014-03-05 12:39:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2014-03-05 21:31:48'),(14395,11480,'N','19','021','EC','A',NULL,NULL,'','0000382170','0000270023','','IL','1','WALDROP','LAUREN','','','','34','287048111','3291 BRENTWOOD CT',0,'POWELL','OH','43065','9134','CY','39041','1999-09-16','F','',NULL,'N','021','DEN','2537519','99734OH005000401','2014-02-01','2013-12-27 15:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:31:05'),(23870,18994,'Y','18','021','EC','A','','','AC','0000646046','0000646046','OH00002139505','IL','1','michel','gary','','','','34','297901446','1832 CHERRY LN',0,'FINDLAY','OH','45840','6736','CY','39063','1987-10-07','M','U',':RET:2106-3','N','021','HLT','2619969','92036OH004001501','2014-03-01','2014-02-14 17:57:41','159.00',NULL,NULL,'181.21','22.21','R-OH002','OH0','181.21',NULL,0,'2014-02-14 21:32:09'),(5020,3979,'Y','18','021','EC','A','','','AC','0000393405','0000393405','LA00000700863','IL','1','CURRY','TODD','','','','34','436066177','6735 DOGWOOD DR',0,'PINEVILLE','LA','71360',NULL,'CY','22079','1960-08-05','M','M',NULL,'N','021','DEN','475278','18575LA002000101','2014-01-01','2013-12-07 16:59:26','0.00',NULL,NULL,'50.04','50.04','R-LA006','LA0','25.02',NULL,0,'2013-12-25 22:47:31'),(23554,18765,'Y','18','021','EC','A','','','AC','0000873280','0000873280','OH00002351154','IL','1','Gilene','Elizabeth','','','','34','291701399','7726 HUNTERS TRL',0,'MASON','OH','45040','6950','CY','39165','1962-02-25','F','R',NULL,'N','021','HLT','2952650','92036OH002001201','2014-03-01','2014-02-13 08:35:01','0.00',NULL,NULL,'483.91','483.91','R-OH004','OH0','483.91',NULL,0,'2014-02-13 22:02:40'),(7538,5964,'N','01','021','EC','A',NULL,NULL,'','0000048245','0000964534','','IL','1','Zander','Liston','','','','34','459459205','2900 Shalimar Dr.',0,'Plano','TX','75023',NULL,'CY','48085','1961-07-26','M','',':RET:2106-3','N','021','DEN','942959','33348TX002000201','2014-01-01','2013-12-15 11:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:32:48'),(27528,21779,'Y','18','021','EC','A','','','AC','0000536992','0000536992','OH00002754067','IL','1','Peterson','William','','','','34','292707311','6731 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9414','CY','39123','1968-06-18','M','M',':RET:2106-3','N','021','HLT','3477579','92036OH006002701','2014-04-01','2014-03-04 16:36:12','0.00',NULL,NULL,'416.01','416.01','R-OH006','OH0','223.31',NULL,0,'2014-03-04 21:02:45'),(27332,21642,'Y','18','021','EC','A','','','AC','0001228120','0001228120','OH00002629776','IL','1','PARKER','KAREN','','','','34','403829796','4143 FOX RUN TRL',0,'CINCINNATI','OH','45255','3625','CY','39025','1953-03-06','F','U',NULL,'N','021','DEN','3386137','99734OH005000401','2014-04-01','2014-03-03 20:10:31','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-04 21:00:53'),(26524,21034,'Y','18','024','14','A','','','TE','0000661345','0000661345','','IL','1','Poshedley','Rocco',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-14','M','',NULL,NULL,NULL,'','1777511','','2014-02-28','2014-02-28 14:34:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:25'),(23405,18647,'Y','18','021','EC','A','','','AC','0000607197','0000607197','OH00002438915','IL','1','Slone','Siobhan','','','','34','296840591','1850 MILLS AVE',0,'CINCINNATI','OH','45212','2947','CY','39061','1986-07-10','F','U',':RET:2106-3','N','021','DEN','3824577','99734OH005000401','2014-03-01','2014-02-13 17:33:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:01:11'),(3569,2866,'Y','18','021','EC','A','','','AC','0000781895','0000781895','OH00001205649','IL','1','MEADOWS','WILLIAM','','','','34','296564274','6609 EMASSY CT',0,'MAUMEE','OH','43537',NULL,'CY','39095','1957-11-25','M','M',':RET:2106-3','T','021','HLT','2145836','92036OH005002601','2014-01-01','2013-12-22 08:03:04','0.00',NULL,NULL,'523.16','523.16','R-OH001','OH0','523.16',NULL,0,'2013-12-25 21:22:30'),(20949,16740,'Y','18','024','14','A','','','TE','0000689713','0000689713','','IL','1','Coleman','Terri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-02-15','F','',NULL,NULL,NULL,'','2895263','','2014-01-31','2014-01-31 18:27:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-01 19:00:03'),(28882,22858,'Y','18','021','EC','A','','','AC','0000948245','0000948245','TX00003663919','31','1','Wallace','Denise','','','','34','449968295','P O Box 886',0,'Meridian','TX','76665',NULL,'CY','48035','1952-08-25','F','U',NULL,'N','021','DEN','4081339','33348TX002000201','2014-04-01','2014-03-10 12:33:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:09'),(9536,7558,'N','01','021','EC','A',NULL,NULL,'','0000442169','0000547872','','IL','1','Hayes','Frederick','William','','','34','290601811','2857 Lovers Lane',0,'Ravenna','OH','44266',NULL,'CY','39133','1961-05-08','M','',':RET:2106-3','N','021','DEN','2528190','99734OH005000301','2014-01-01','2013-12-21 10:54:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:55'),(21792,17404,'Y','18','021','EC','A','','','AC','0000692965','0000692965','OH00002313201','IL','1','Mueller','Shane','','','','34','298845901','203 CLINTON ST',0,'COLUMBUS','OH','43202','3046','CY','39049','1979-08-07','M','U',':RET:2106-3','N','021','DEN','3742651','99734OH005000401','2014-03-01','2014-02-06 14:52:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:44'),(3589,2879,'Y','18','021','EC','A','','','AC','0001245590','0001245590','OH00000707394','IL','1','HO','AMY','','','','34','284983742','8264 VENTLE DR',0,'WEST CHESTER','OH','45069','2713','CY','39017','1960-03-07','F','M',':RET:2047-9','N','021','HLT','2358515','92036OH005001201','2014-01-01','2013-12-22 10:23:02','0.00',NULL,NULL,'437.93','437.93','R-OH004','OH0','437.93',NULL,0,'2013-12-25 21:22:58'),(1917,1564,'N','19','021','EC','A',NULL,NULL,'','0000949475','0000984808','','IL','1','leese','Samuel',NULL,NULL,NULL,NULL,NULL,'895 WATERVILLE MONCLOVA RD',0,'WATERVILLE','OH','43566','1163','CY','39095','2008-03-07','M','',':RET:2106-3','N','021','DEN','70200','99734OH005000301','2014-01-01','2013-11-20 09:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:00:05'),(19703,15701,'Y','18','021','EC','A','','','AC','0000417961','0000417961','TX00002222508','IL','1','Pruett','Lela','','','','34','452258374','2500 Taylor',0,'Wichita Falls','TX','76309',NULL,'CY','48485','1956-09-05','F','U',':RET:2106-3','N','021','DEN','1661422','33348TX002000201','2014-03-01','2014-01-23 15:09:33','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-23 21:00:49'),(8877,7038,'Y','18','024','14','A','','','TE','0000585484','0000585484','','IL','1','AQEEL','AMIR',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-11-07','M','',NULL,NULL,NULL,'','2086841','','2013-12-18','2013-12-18 14:32:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:01:42'),(25617,20324,'Y','18','021','EC','A','','','AC','0000003821','0000003821','TX00002486413','IL','1','Colvin','Stephen','','','','34','467872136','13714 LONG GLEN DR',0,'HOUSTON','TX','77039','2446','CY','48201','1984-10-02','M','U',NULL,'N','021','DEN','3429351','33348TX002000201','2014-04-01','2014-02-22 11:46:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 08:30:13'),(17430,13945,'N','01','021','EC','A',NULL,NULL,'','0000817556','0000846159','','IL','1','Digonno','Antonio','D','','','34','277687423','2531 REGINA PL',0,'HAMILTON','OH','45013','4812','CY','39017','1958-10-05','M','',':RET:2106-3','N','021','HLT','2087727','92036OH003001205','2014-02-01','2014-01-10 12:11:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','499.92',NULL,0,'2014-01-13 03:00:30'),(149,125,'N','01','021','EC','A',NULL,NULL,'','0000204539','0000122942','','IL','1','Beal','Tammy','','','','34','289600281','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1962-03-03','F','',':RET:2106-3','N','021','HLT','217583','52664OH152000901','2014-01-01','2013-12-05 12:07:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.63',NULL,0,'2013-12-25 17:18:53'),(7047,5597,'Y','18','024','14','A','','','TE','0000009928','0000009928','','IL','1','Flores','Maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-22','F','',NULL,NULL,NULL,'','749951','','2013-12-25','2013-12-25 15:39:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 01:49:35'),(4599,3641,'N','01','021','EC','A',NULL,NULL,'','0000926247','0000914416','','IL','1','ARMSTRONG','PATRICK','','','','34','276509004','409 BREWER AVE',0,'AKRON','OH','44305','3109','CY','39153','1949-08-22','M','',NULL,'N','021','HLT','405922','52664OH151001305','2014-01-01','2013-12-12 16:13:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','669.00',NULL,0,'2013-12-25 22:05:39'),(13676,10912,'Y','18','021','EC','A','','','AC','0000095233','0000095233','OH00000709993','IL','1','thompson','charlene','','','','34','289540212','794w.highland rd.',0,'sagamore hills','OH','44067',NULL,'CY','39153','1953-05-09','F','M',':RET:2106-3','N','021','HLT','2435864','52664OH151001305','2014-01-01','2013-12-22 19:47:26','461.00',NULL,NULL,'605.24','144.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 13:08:03'),(19360,15431,'Y','18','021','EC','A','','','AC','0000597329','0000597329','OH00001914825','IL','1','Bencie','Jessica','','','','34','161700333','910 BROOKFIELD DR',0,'AURORA','OH','44202','8023','CY','39133','1988-02-03','F','U',':RET:2106-3','N','021','HLT','3180538','52664OH151001305','2014-03-01','2014-01-20 20:27:30','116.00',NULL,NULL,'228.36','112.36','R-OH012','OH0','228.36',NULL,1,'2014-01-22 03:22:30'),(20883,16689,'N','19','021','EC','A',NULL,NULL,'','0000468146','0001236616','','IL','1','Shaw','Johnny','Lee','','III','34','284119025','525 S WEST ST',0,'HILLSBORO','OH','45133','1343','CY','39071','2005-08-16','M','',':RET:2106-3','N','021','HLT','3234142','92036OH006000601','2014-03-01','2014-01-30 21:04:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-01-31 21:01:09'),(22923,18273,'Y','18','024','14','A','','','TE','0000393367','0000393367','','IL','1','Coleman','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-04','M','',NULL,NULL,NULL,'','1880895','','2014-02-28','2014-02-11 18:13:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-11 21:30:03'),(23083,18404,'Y','18','021','EC','A','','','AC','0000465961','0000465961','OH00002756088','IL','1','Redmond','Nathan','','','','34','297903112','182 W MAIN ST',0,'WALDO','OH','43356','9106','CY','39101','1985-03-09','M','M',NULL,'N','021','DEN','3642155','99734OH005000401','2014-03-01','2014-02-11 20:43:33','0.00',NULL,NULL,'31.57','31.57','R-OH008','OH0','0.00',NULL,0,'2014-02-12 21:31:04'),(25878,20518,'Y','18','021','EC','A','','','AC','0001381869','0001381869','LA00003329126','IL','1','MUSTAFA','MUSTAFA','','','','34','439737400','520 WALL BLVD',0,'GRETNA','LA','70056','7736','CY','22051','1987-06-08','M','M',NULL,'N','021','DEN','3452180','18575LA002000201','2014-04-01','2014-02-26 17:41:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:55'),(28147,22275,'Y','18','021','EC','A','','','AC','0000069137','0000069137','OH00003482161','IL','1','Smith','Karen','','','','34','290522342','234 NORTHDALE DR',0,'TOLEDO','OH','43612','3673','CY','39095','1953-09-19','F','M',NULL,'N','021','HLT','3946623','92036OH001002601','2014-04-01','2014-03-06 11:40:58','0.00',NULL,NULL,'1314.10','1314.10','R-OH001','OH0','638.35',NULL,0,'2014-03-06 21:02:35'),(16713,13376,'Y','18','021','EC','A','','','AC','0000623746','0000623746','TX00002092341','IL','1','Ragan','Wanda','','','','34','263923882','2100 W FM 320',0,'Palestine','TX','75803',NULL,'CY','48001','1959-12-09','F','U',':RET:1002-5','N','021','DEN','1422873','33348TX002000201','2014-02-01','2014-01-07 13:22:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:43'),(15543,12437,'Y','18','021','EC','A','','','AC','0001708177','0001708177','LA00002103241','IL','1','Seaux','Marcella','','','','34','436922950','422 ALTHEA DR',0,'DUSON','LA','70529','3739','CY','22055','1953-10-02','F','M',':RET:2106-3','N','021','DEN','2224628','18575LA002000201','2014-02-01','2013-12-31 14:57:32','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:31:01'),(2012,1651,'Y','18','021','EC','A','','','AC','0000217881','0000217881','LA00000785642','IL','1','Gremillion','Susan','','','','34','565478399','81203 JIM SHARP RD',0,'COVINGTON','LA','70435','8264','CY','22103','1965-04-22','F','M',':RET:2039-6^:RET:2106-3','N','021','DEN','561221','18575LA002000201','2014-01-01','2013-11-20 14:22:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:02:32'),(14495,11563,'N','01','021','EC','A',NULL,NULL,'','0000183346','0000670751','','IL','1','ACEVEDO','JOSE','MANUEL','','','34','325667817','3742 ROGER JOSEPH DR',0,'EL PASO','TX','79938','9442','CY','48141','1952-12-01','M','',NULL,'N','021','DEN','1408056','33348TX002000201','2014-02-01','2013-12-27 12:50:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:37'),(9496,7531,'Y','18','021','EC','A','','','AC','0000585530','0000585530','OH00000950269','IL','1','Connor','Andrew','','','','34','199640898','3401 Brookline Ave.',0,'Cincinnati','OH','45220',NULL,'CY','39061','1984-07-18','M','U',NULL,'N','021','DEN','2219276','99734OH005000401','2014-01-01','2013-12-21 14:19:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:35:03'),(4790,3799,'N','01','021','EC','A',NULL,NULL,'','0000166353','0001100573','','IL','1','Chebra','Janice','M','','','34','275526443','4919 CHESTNUT DR',0,'KENT','OH','44240','7069','CY','39133','1952-02-08','F','',':RET:2106-3','N','021','HLT','2535','52664OH151001304','2014-01-01','2013-12-08 08:42:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2013-12-25 22:16:17'),(18540,14785,'Y','18','021','EC','A','','','AC','0001234342','0001234342','MS00001715351','IL','1','Knight','Joelle','','','','34','425639407','31 JOEL P JEFCOAT RD',0,'SOSO','MS','39480','5057','CY','28067','1984-08-12','F','U',NULL,'N','021','DEN','2565196','46300MS002000101','2014-02-01','2014-01-15 00:42:27','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-16 08:46:48'),(19381,15450,'Y','18','021','EC','A','','','AC','0000067029','0000067029','TX00001974599','IL','1','Saltzman','Angel','Michelle-Harris','','','34','636286159','2811 LA FRONTERA BLVD',0,'Austin','TX','78728',NULL,'CY','48453','1990-05-27','F','M',NULL,'N','021','DEN','2673673','33348TX002000101','2014-03-01','2014-01-20 22:03:13','0.00',NULL,NULL,'54.30','54.30','R-TX003','TX0','27.15',NULL,1,'2014-01-22 03:22:42'),(25313,20081,'Y','18','021','EC','A','','','AC','0001220882','0001220882','LA00002695889','IL','1','KING','SARAH','','','','34','435272293','3126 MONROE ST',0,'ALEXANDRIA','LA','71301','5537','CY','22079','1962-03-16','F','M',NULL,'N','021','DEN','2780493','18575LA002000201','2014-04-01','2014-02-24 18:01:54','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-25 21:30:03'),(28312,22402,'Y','18','021','EC','A','','','AC','0001179578','0001179578','OH00003429630','IL','1','Cantrell','Tyler','Earl','','','34','286821936','65 W MAIN ST',0,'SARDINIA','OH','45171','8000','CY','39071','1983-09-28','M','M',':RET:2106-3','N','021','HLT','3668637','92036OH002000601','2014-04-01','2014-03-07 16:23:55','507.00',NULL,NULL,'873.64','366.64','R-OH005','OH0','281.38','CIC',0,'2014-03-07 21:00:36'),(7777,6158,'Y','18','021','EC','A','','','AC','0000486735','0000486735','TX00000293985','IL','1','Moore','Mark','','','','34','466080804','2809 N CEDAR BLUFF RD',0,'GARRISON','TX','75946','7342','CY','48347','1955-03-24','M','M',':RET:2106-3','N','021','DEN','2033975','33348TX002000201','2014-01-01','2013-12-19 23:02:20','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:06'),(16377,13105,'Y','18','021','EC','A','','','AC','0000630962','0000630962','TX00002330178','31','1','MONTOYA','DIAMANTINA','','','','34','456657931','208 W EL PASO ST',0,'FORT STOCKTON','TX','79735',NULL,'CY','48371','1982-05-29','F','M',NULL,'N','021','DEN','1932849','33348TX002000201','2014-02-01','2014-01-06 12:39:07','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-07 04:03:12'),(4327,3438,'Y','18','021','EC','A','','','AC','0001207128','0001207128','OH00001144683','IL','1','GOULD','JAMES','','','','34','278568964','47 summerberry lane',0,'NILES','OH','44446',NULL,'CY','39155','1955-04-22','M','M',NULL,'N','021','HLT','1727193','92036OH002003201','2014-01-01','2013-12-17 09:32:07','858.00',NULL,NULL,'1424.46','566.46','R-OH013','OH0','712.23',NULL,0,'2013-12-25 21:52:56'),(4496,3563,'Y','18','024','14','A','','','TE','0000126663','0000126663','','IL','1','Kungu','Jamie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-06-26','F','',NULL,NULL,NULL,'','49746','','2013-12-11','2013-12-11 20:19:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:03:14'),(2190,1802,'Y','18','021','EC','A','','','AC','0000933180','0000933180','OH00001124350','IL','1','JONES','TERRY','L','','','34','290585424','6698 PIN OAK DR',0,'LOVELAND','OH','45140','9435','CY','39025','1956-10-28','M','U',':RET:2106-3','N','021','HLT','707010','92036OH002000601','2014-01-01','2013-12-10 15:54:51','325.00',NULL,NULL,'604.16','279.16','R-OH005','OH0','604.16',NULL,0,'2013-12-25 19:19:43'),(2221,1829,'Y','18','021','EC','A','','','AC','0000186086','0000186086','OH00000060954','IL','1','Shelton','Pearline','','','','34','275603053','2620 Westmar Ct.',0,'Toledo','OH','43615',NULL,'CY','39095','1956-01-03','F','M',':RET:2054-5','N','021','HLT','1226322','92036OH003002605','2014-01-01','2013-12-10 13:44:39','883.00',NULL,NULL,'1097.39','214.39','R-OH001','OH0','496.27',NULL,0,'2013-12-25 19:20:31'),(5918,4686,'N','01','021','EC','A',NULL,NULL,'','0000444506','0000235624','','IL','1','Roets','Samantha','','','','34','564516128','21272 EVA ST',0,'MONTGOMERY','TX','77356','1809','CY','48339','1972-11-01','F','',':RET:2106-3','N','021','DEN','1633478','33348TX002000101','2014-01-01','2013-12-23 23:59:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:12'),(19079,15200,'Y','18','021','EC','A','','','AC','0000258190','0000258190','OH00002561890','31','1','FOUCHE','SUZANNA','','','','34','269845855','PO BOX 12114',0,'COLUMBUS','OH','43212',NULL,'CY','39049','1973-01-22','F','U',NULL,'N','021','DEN','2120478','99734OH005000401','2014-03-01','2014-01-17 22:19:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:44:25'),(21938,17518,'Y','18','024','14','A','','','TE','0000485233','0000485233','','IL','1','Moreno','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-08','M','',NULL,NULL,NULL,'','1744231','','2014-02-22','2014-02-07 15:52:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-07 19:00:13'),(22926,18276,'Y','18','021','EC','A','','','AC','0000640922','0000640922','OH00002441541','31','1','Sheal','Jennifer','','','','34','287801012','P.O. box .31463',0,'CINCINNATI','OH','45231',NULL,'CY','39061','1983-03-02','F','U',':RET:2106-3','N','021','DEN','2617446','99734OH005000301','2014-03-01','2014-02-11 18:20:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00','CIC',0,'2014-02-11 21:30:06'),(27118,21465,'Y','18','021','EC','A','','','AC','0000992729','0000992729','OH00003342397','IL','1','Stone','david','','','','34','297827482','518 BLAINE ST',0,'GENEVA','OH','44041','1610','CY','39007','1984-08-13','M','U',':RET:2106-3','N','021','DEN','2912027','99734OH005000301','2014-04-01','2014-03-03 13:08:35','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:32'),(17395,13919,'Y','18','021','EC','A','','','AC','0000846160','0000846160','OH00001680239','IL','1','BROOKS','DEBBIE','','','','34','293562202','10040 DALY RD',0,'CINCINNATI','OH','45231','2442','CY','39061','1956-01-08','F','U',':RET:2106-3','N','021','DEN','2565072','99734OH005000401','2014-02-01','2014-01-10 16:33:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 03:00:13'),(6113,4847,'Y','18','021','EC','A','','','AC','0001100563','0001100563','OH00000016788','IL','1','Stefan-Wohlgamuth','Sarah','','','','34','270747103','822 GARSON DR',0,'AKRON','OH','44319','1004','CY','39153','1977-05-05','F','M',':RET:2106-3','N','021','HLT','1003572','52664OH151001301','2014-01-01','2013-11-20 22:27:21','0.00',NULL,NULL,'274.30','274.30','R-OH012','OH0','274.30',NULL,0,'2013-12-26 00:15:31'),(2693,2182,'Y','18','021','EC','A','','','AC','0000808175','0000808175','TX00000524745','IL','1','Parks','Janese','','','','34','457068576','11585 SABO RD',0,'HOUSTON','TX','77089','2531','CY','48201','1969-07-05','F','U',':RET:2106-3','N','021','DEN','362831','33348TX002000201','2014-01-01','2013-12-02 17:19:24','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:47:34'),(1997,1636,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000639822','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','15024','33348TX002000101','2014-01-01','2013-11-19 23:07:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:02:06'),(18486,14744,'N','01','021','EC','A',NULL,NULL,'','0000092543','0000996547','','IL','1','Ransom','Elizabeth','','','','34','290764609','515 7th Street NW',0,'North Canton','OH','44720',NULL,'CY','39151','1980-02-06','F','',':RET:2106-3','N','021','HLT','2342101','52664OH151001305','2014-02-01','2014-01-15 12:12:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.16',NULL,0,'2014-01-16 08:46:23'),(456,372,'Y','18','021','EC','A','','','AC','0000818542','0000818542','OH00000253067','IL','1','Muntz','Diane','','','','34','291769989','9 PARK LANE DR',0,'NAPOLEON','OH','43545','1325','CY','39069','1965-03-17','F','M',':RET:2106-3','N','021','HLT','498216','92036OH003002605','2014-01-01','2013-12-04 11:59:14','208.00',NULL,NULL,'332.95','124.95','R-OH001','OH0','332.95',NULL,0,'2013-12-25 17:47:28'),(21473,17160,'Y','18','021','EC','A','','','AC','0000168920','0000168920','OH00002470527','IL','1','ON','HELEN','','','','34','281111735','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1977-08-25','F','M',NULL,'N','021','DEN','3006962','99734OH005000301','2014-03-01','2014-02-04 11:15:32','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:39'),(21763,17379,'Y','18','021','EC','A','','','AC','0001024563','0001024563','TX00002504511','IL','1','Arias','Michele','','','','34','451711700','206 HELENITA',0,'BURNET','TX','78611','2942','CY','48053','1976-06-18','F','U',NULL,'N','021','DEN','3534042','33348TX002000201','2014-03-01','2014-02-06 16:15:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:27'),(22389,17878,'Y','18','021','EC','A','','','AC','0000771477','0000771477','OH00002399203','IL','1','phillips','linda','fae','','','34','287484143','172twp rd 2150',0,'jeromesville','OH','44840',NULL,'CY','39005','1951-08-25','F','U',NULL,'T','021','HLT','3387559','52664OH151001306','2014-03-01','2014-02-10 12:32:13','591.00',NULL,NULL,'736.81','145.81','R-OH012','OH0','736.81',NULL,0,'2014-02-10 21:30:14'),(25461,20201,'Y','18','021','EC','A','','','AC','0000389662','0000389662','TX00003335784','IL','1','Green','Danita','','','','34','453818200','1700 GOODE DR',0,'KILLEEN','TX','76543','5058','CY','48027','1983-09-26','F','U',':RET:2054-5','N','021','DEN','2806479','33348TX002000201','2014-04-01','2014-02-25 15:41:10','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-25 21:31:31'),(29093,23027,'Y','18','021','EC','A','','','AC','0000217636','0000217636','TX00003056467','IL','1','Sanders','Jereme','','','','34','625545052','800 E Park',0,'San Antonio','TX','78212',NULL,'CY','48029','1989-03-15','M','U',':RET:2106-3','N','021','DEN','3548247','33348TX002000101','2014-04-01','2014-03-10 15:19:30','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-03-10 21:02:11'),(983,805,'Y','18','021','EC','A','','','AC','0000835430','0000835430','OH00000058254','IL','1','Lacey','Carrie','','','','34','279785904','3197 W 138TH ST',0,'CLEVELAND','OH','44111','1537','CY','39035','1971-12-24','F','U',NULL,'N','021','HLT','1026474','92036OH001000801','2014-01-01','2013-10-29 10:09:06','0.00',NULL,NULL,'373.68','373.68','R-OH011','OH0','373.68',NULL,0,'2013-12-25 18:10:22'),(1642,1372,'Y','18','021','EC','A','','','AC','0000977556','0000977556','TX00001501239','IL','1','Gomez','Maria','','','','34','263674589','434 SONORA AVE',0,'RAYMONDVILLE','TX','78580','1644','CY','48489','1962-04-01','F','M',NULL,'N','021','DEN','1426107','33348TX002000201','2014-01-01','2013-12-24 15:37:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:06'),(5934,4698,'Y','18','021','EC','A','','','AC','0001677505','0001677505','LA00001156475','IL','1','Duplantis','Rebecca','','','','34','433728367','200 Lodge Drive',0,'Lafayette','LA','70506',NULL,'CY','22055','1954-12-13','F','U',':RET:2106-3','N','021','DEN','1435663','18575LA002000101','2014-01-01','2013-12-23 22:07:32','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 23:50:36'),(6424,5093,'N','01','021','EC','A',NULL,NULL,'','0000250188','0000170121','','IL','1','Morgan','Brandon','Lee','','','34','433390042','48011A LAURA ROGERS RD',0,'TICKFAW','LA','70466','5101','CY','22105','1978-06-06','M','',':RET:2106-3','N','021','DEN','482932','18575LA002000201','2014-01-01','2013-12-10 20:50:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:48:59'),(19528,15563,'Y','18','024','14','A','','','TE','0000990084','0000990084','','IL','1','Kren','Tiffany',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-10-28','F','',NULL,NULL,NULL,'','2165090','','2014-01-22','2014-01-22 14:04:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:20'),(23540,18753,'Y','18','024','14','A','','','TE','0001387258','0001387258','','IL','1','Torres','Cleona',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-05-15','F','',NULL,NULL,NULL,'','3217802','','2014-02-13','2014-02-13 12:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-13 22:02:32'),(25034,19851,'Y','18','021','EC','A','','','AC','0002273756','0002273756','LA00002780165','IL','1','Navarro','Dennis','','','','34','439218771','107 ORANGE ST',0,'WEST MONROE','LA','71292','3864','CY','22073','1961-08-28','M','U',':RET:2106-3','N','021','DEN','3334431','18575LA002000101','2014-04-01','2014-02-20 12:44:29','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-20 22:01:05'),(25965,20591,'Y','18','024','14','A','','','TE','0000467141','0000467141','','IL','1','Culpepper','Kathryn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-22','F','',NULL,NULL,NULL,'','3067108','','2014-02-26','2014-02-26 12:40:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:01:43'),(26002,20622,'Y','18','021','EC','A','','','AC','0002029276','0002029276','LA00001983408','IL','1','Mariche','Danielle','','','','34','434611137','347 ORION AVE',0,'METAIRIE','LA','70005','3730','CY','22051','1986-04-19','F','U',':RET:2106-3','N','021','DEN','3533200','18575LA002000101','2014-03-01','2014-02-26 13:20:12','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-26 21:02:04'),(27433,21711,'N','01','021','EC','A',NULL,NULL,'','0001997237','0001267671','','IL','1','GRIER','WILLIAM','ALEX','','','34','467957130','3027 GEORGE JOHNIKINS RD',0,'SPEARSVILLE','LA','71277','2263','CY','22111','1974-04-06','M','',':RET:2106-3','N','021','DEN','3497657','18575LA002000201','2014-04-01','2014-03-04 13:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-04 21:01:47'),(8867,7030,'Y','18','021','EC','A','','','AC','0000936477','0000936477','TX00001131184','IL','1','Warren','Sarah','','','','34','644329426','4940 Paluxy Dr.',0,'Tyler','TX','75703',NULL,'CY','48423','1992-10-10','F','U',':RET:2054-5','N','021','DEN','1390010','33348TX002000201','2014-01-01','2013-12-18 12:47:45','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-26 04:01:26'),(14667,11708,'Y','18','021','EC','A','','','AC','0000490393','0000490393','TX00001627529','31','1','Bybee','Joshua','','','','34','548331201','519 LILY LN',0,'WHARTON','TX','77488','4513','CY','48481','1971-08-30','M','M',':RET:2106-3','N','021','DEN','1809652','33348TX002000201','2014-02-01','2013-12-28 17:04:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:08:08'),(8158,6454,'Y','18','021','EC','A','','','AC','0000408434','0000408434','OH00000505295','IL','1','JANSON','LINDA','','','','34','276448198','4383 W 180TH ST',0,'CLEVELAND','OH','44135','3820','CY','39035','1950-08-03','F','U',':RET:2106-3','N','021','HLT','980598','92036OH005000801','2014-01-01','2013-11-22 12:27:10','291.00',NULL,NULL,'690.16','399.16','R-OH011','OH0','690.16',NULL,0,'2013-12-26 03:16:16'),(14557,11614,'Y','18','024','14','A','','','TE','0000961874','0000961874','','IL','1','Partin','Martha','Irene',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-09-15','F','',NULL,NULL,NULL,'','2007118','','2013-12-27','2013-12-27 11:25:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:35:11'),(13446,10721,'N','01','021','EC','A',NULL,NULL,'','0000421463','0001020417','','IL','1','Campbell','Ruth','','','','34','288625801','4356 N St Rt 741',0,'Lebanon','OH','45036',NULL,'CY','39165','1957-05-02','F','',':RET:2106-3','N','021','DEN','1481146','99734OH005000301','2014-01-01','2013-12-23 14:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:20'),(3072,2468,'Y','18','024','14','A','','','TE','0000900721','0000900721','','IL','1','HARRIS','MYA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-01','F','',NULL,NULL,NULL,'','998987','','2013-12-06','2013-12-06 17:54:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 20:19:30'),(3784,3031,'Y','18','021','EC','A','','','AC','0001138034','0001138034','OH00000914215','IL','1','Freed','Brandi','','','','34','275726180','120 BYERS AVE',0,'AKRON','OH','44302','1341','CY','39153','1975-07-16','F','U',':RET:2106-3','N','021','DEN','149639','99734OH005000301','2014-01-01','2013-12-13 09:00:55','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:34:03'),(6893,5469,'Y','18','021','EC','A','','','AC','0001368862','0001368862','LA00000044826','IL','1','Dupre','Rhoeyce','','','','34','439715701','590 HALSEY ST',0,'EUNICE','LA','70535','5612','CY','22097','1988-01-22','M','R',':RET:2054-5','N','021','DEN','2081151','18575LA002000201','2014-01-01','2013-12-24 21:33:59','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 01:45:26'),(28602,22636,'Y','18','021','EC','A','','','AC','0000976808','0000976808','OH00003820253','IL','1','KURLAS','THOMAS','','','','34','271668100','244 S HAGUE AVE',0,'COLUMBUS','OH','43204','3003','CY','39049','1961-01-14','M','U',':RET:2106-3','T','021','DEN','3828637','99734OH005000401','2014-04-01','2014-03-07 19:02:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:30:09'),(14383,11472,'Y','18','021','EC','A','','','AC','0001237705','0001237705','OH00000272049','IL','1','Davis','Erica','','','','34','274869878','2941 BROWNLEE AVE',0,'COLUMBUS','OH','43209','3059','CY','39049','1983-08-11','F','M',':RET:2106-3','T','021','DEN','1663621','99734OH005000401','2014-02-01','2013-12-27 13:59:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:48'),(2584,2100,'N','01','021','EC','A',NULL,NULL,'','0000526755','0000269990','','IL','1','McCarty','John','Robert','','','34','298561077','2863 state route 132',0,'new richmond','OH','45157',NULL,'CY','39025','1955-08-22','M','',':RET:2106-3','N','021','HLT','714144','92036OH001000601','2014-01-01','2013-12-09 17:19:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','659.77',NULL,0,'2013-12-25 19:38:04'),(9777,7743,'Y','18','021','EC','A','','','AC','0000060216','0000060216','OH00000997038','IL','1','waldorf','paul','','','','34','189560822','1379 CARLIN CT',0,'FAIRFIELD','OH','45014','4599','CY','39017','1959-11-25','M','U',NULL,'T','021','DEN','89078','99734OH005000301','2014-01-01','2013-10-20 17:36:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 05:00:39'),(5653,4484,'N','01','021','EC','A',NULL,NULL,'','0000452937','0000678421','','IL','1','Torres','Ricardo','','','','34','450211310','691 JEWEL DR',0,'SOCORRO','TX','79927','4536','CY','48141','1959-03-22','M','',':RET:2106-3','N','021','DEN','387799','33348TX002000201','2014-01-01','2013-11-26 13:57:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:31:33'),(28516,22566,'Y','18','021','EC','A','','','AC','0000637175','0000637175','OH00002929132','IL','1','Browne','Matthew','William','','','34','285928603','27796 Oregon Rd.',0,'Perrysburg','OH','43551',NULL,'CY','39173','1989-10-30','M','U',':RET:2106-3','N','021','HLT','3520729','92036OH006002601','2014-04-01','2014-03-06 20:53:33','126.00',NULL,NULL,'154.64','28.64','R-OH001','OH0','154.64',NULL,0,'2014-03-07 21:31:57'),(22405,17889,'Y','18','021','EC','A','','','AC','0001570037','0001570037','LA00002371227','IL','1','Mancil','Olivia','','','','34','433196613','1625 Robert Drive',0,'Saint Bernard','LA','70085',NULL,'CY','22087','1958-07-10','F','U',':RET:2106-3','N','021','DEN','3627050','18575LA002000201','2014-03-01','2014-02-09 18:35:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:21'),(5562,4416,'Y','18','021','EC','A','','','AC','0001043367','0001043367','OH00000557430','IL','1','BUTTRAM','MICHAEL','','','','34','269769865','3409 ROBB AVE',0,'CINCINNATI','OH','45211','5332','CY','39061','1978-03-06','M','U',':RET:2106-3','N','021','HLT','993817','92036OH006001201','2014-01-01','2013-11-27 17:43:01','0.00',NULL,NULL,'208.03','208.03','R-OH004','OH0','208.03',NULL,0,'2013-12-25 23:16:29'),(19504,15545,'Y','18','021','EC','A','','','AC','0001105141','0001105141','TX00002122049','IL','1','Clark','Synolin','','','','34','457718127','2408 SARATOGA ST',0,'NACOGDOCHES','TX','75964','3422','CY','48347','1969-05-16','F','M',NULL,'N','021','DEN','2712646','33348TX002000101','2014-03-01','2014-01-21 19:17:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-23 03:02:11'),(21512,17187,'Y','18','021','EC','A','','','AC','0000965807','0000965807','OH00001681724','IL','1','Schuster','Margaret','','','','34','268523561','779 CLYDE ST',0,'AKRON','OH','44310','4007','CY','39153','1951-10-06','F','U',':RET:2106-3','N','021','HLT','3485711','52664OH151001304','2014-03-01','2014-02-04 07:50:43','455.00',NULL,NULL,'640.70','185.70','R-OH012','OH0','640.70','CIC',0,'2014-02-04 21:30:03'),(21337,17052,'Y','18','021','EC','A','','','AC','0000637521','0000637521','TX00001885290','IL','1','Giger','Tiffany','','','','34','601464924','3022 GUADALUPE ST',0,'SAN ANGELO','TX','76901','2811','CY','48451','1987-08-20','F','U',':RET:2106-3','N','021','DEN','3030176','33348TX002000201','2014-03-01','2014-02-03 20:34:47','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-04 21:00:31'),(7801,6179,'Y','18','021','EC','A','','','AC','0000630857','0000630857','TX00001131336','31','1','Daley','Gabriela','','','','34','392782163','PO BOX 30',0,'Wadsworth','TX','77483',NULL,'CY','48321','1974-02-28','F','U',':RET:2106-3','N','021','DEN','1398825','33348TX002000201','2014-01-01','2013-12-20 16:23:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:41'),(15700,12560,'Y','18','021','EC','A','','','AC','0000372616','0000372616','OH00001726226','IL','1','BEACH','CONNIE','','','','34','292565707','710 E BROADWAY ST',0,'NORTH BALTIMORE','OH','45872','9565','CY','39173','1954-08-23','F','M',NULL,'N','021','HLT','2288392','92036OH004002601','2014-02-01','2013-12-31 12:49:36','529.00',NULL,NULL,'858.60','329.60','R-OH001','OH0','408.14',NULL,1,'2014-01-02 04:35:41'),(13657,10896,'Y','18','021','EC','A','','','AC','0001398739','0001398739','LA00001107542','IL','1','Mason','Aria','Monette','','','34','436533253','6468 General Haig',0,'New Orleans','LA','70124',NULL,'CY','22071','1983-03-17','F','U',':RET:2054-5','N','021','DEN','1986012','18575LA002000101','2014-01-01','2013-12-23 01:05:56','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:30'),(979,801,'N','01','021','EC','A',NULL,NULL,'','0000699226','0000820966','','IL','1','Vickery','Harold','W','','','34','301703748','115 Barbara Lane',0,'Sherwood','OH','43556',NULL,'CY','39039','1962-12-17','M','',':RET:2106-3','T','021','HLT','1031568','92036OH005002601','2014-01-01','2013-10-28 22:42:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','418.23',NULL,0,'2013-12-25 18:10:14'),(25783,20447,'N','01','021','EC','A',NULL,NULL,'','0000312245','0000211053','','IL','1','HERNANDEZ','ROBIN','D','','','34','296823579','1201 PARKSIDE PL',0,'FINDLAY','OH','45840','5537','CY','39063','1968-04-11','F','',':RET:2106-3','N','021','HLT','3068584','92036OH005001506','2014-04-01','2014-02-24 15:06:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','317.81',NULL,0,'2014-02-26 09:31:04'),(5763,4578,'Y','18','021','EC','A','','','AC','0000447466','0000447466','OH00000391015','IL','1','McClurg','Jeff',NULL,NULL,NULL,NULL,NULL,'1233 HIGH ST',0,'FAIRPORT HARBOR','OH','44077','5560','CY','39085','1962-09-13','M','R',':RET:2106-3','N','021','DEN','1783176','99734OH005000401','2014-01-01','2013-12-23 22:11:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:46:35'),(2766,2236,'Y','18','024','14','A','','','TE','0001183494','0001183494','','IL','1','Poff','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-20','F','',NULL,NULL,NULL,'','662105','','2013-12-02','2013-12-02 15:13:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:49:26'),(5244,4159,'Y','18','024','14','A','','','TE','0001129005','0001129005','','IL','1','Spence','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-29','F','',NULL,NULL,NULL,'','691252','','2013-12-18','2013-12-18 21:54:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:59'),(4905,3890,'Y','18','021','EC','A','','','AC','0000361360','0000361360','LA00000817380','IL','1','Dingler','Beau','','','','34','439390073','2026 Prytania St',0,'New Orleans','LA','70130',NULL,'CY','22071','1980-01-26','M','U',':RET:2106-3','N','021','DEN','1080780','18575LA002000201','2014-01-01','2013-10-26 04:35:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:31:54'),(25736,20415,'Y','18','021','EC','A','','','AC','0001033720','0001033720','OH00002355380','IL','1','WILLSON','MIESHA','','','','34','293744800','38718 AVENEL CT',0,'WILLOUGHBY','OH','44094','8068','CY','39085','1979-03-09','F','M',':RET:2054-5','N','021','DEN','2970780','99734OH005000401','2014-04-01','2014-02-24 11:43:49','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2014-02-26 09:30:39'),(29188,23102,'Y','18','021','EC','A','','','AC','0000815378','0000815378','OH00003758381','IL','1','Sebe','Paul','','','','34','285828552','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','1969-09-11','M','M',':RET:2106-3','N','021','HLT','3135230','52664OH151001301','2014-04-01','2014-03-10 16:59:12','153.00',NULL,NULL,'764.69','611.69','R-OH014','OH0','311.54','CIC',0,'2014-03-10 21:30:03'),(27094,21450,'Y','18','021','EC','A','','','AC','0000920875','0000920875','OH00003271422','IL','1','JONES','PAMELA','','','','34','288689552','4150 E 114TH ST',0,'CLEVELAND','OH','44105','5401','CY','39035','1963-10-20','F','U',':RET:2054-5','N','021','HLT','3501322','52664OH151001306','2014-04-01','2014-03-03 14:58:37','298.00',NULL,NULL,'449.21','151.21','R-OH011','OH0','449.21',NULL,0,'2014-03-03 21:30:19'),(22827,18213,'N','01','021','EC','A',NULL,NULL,'','0001182541','0001104493','','IL','1','Plum','Jeff',NULL,NULL,NULL,NULL,NULL,'1269 SPRUCE WOOD WAY',0,'UNIONTOWN','OH','44685','9579','CY','39153','1957-08-18','M','',NULL,'N','021','HLT','3637434','52664OH151001301','2014-03-01','2014-02-11 09:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2014-02-11 21:02:04'),(16241,13007,'Y','18','021','EC','A','','','AC','0000295508','0000295508','OH00001730121','IL','1','Wieman','John','','','Jr','34','293561354','5745 GREEN ACRES CT',0,'CINCINNATI','OH','45248','4130','CY','39061','1957-11-17','M','M',':RET:2106-3','N','021','DEN','2254608','99734OH005000301','2014-02-01','2014-01-03 23:53:30','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-05 00:02:23'),(18939,15091,'N','19','021','EC','A',NULL,NULL,'','0001060937','0000764992','','IL','1','post','sophia',NULL,NULL,NULL,NULL,NULL,'4823 PARKSIDE DR',0,'SOUTH LEBANON','OH','45065','1383','CY','39165','1997-04-03','F','',NULL,'N','021','DEN','2692844','99734OH005000401','2014-03-01','2014-01-17 12:19:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:05:43'),(4834,3828,'N','01','021','EC','A',NULL,NULL,'','0000526754','0000956625','','IL','1','Miller','Betty','Sue','','','34','272509556','5486 GRIFFITH RD',0,'HILLSBORO','OH','45133','8800','CY','39071','1950-08-04','F','',':RET:2106-3','N','021','HLT','1200586','92036OH002000601','2014-01-01','2013-12-08 16:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','731.81',NULL,0,'2013-12-25 22:17:24'),(14552,11611,'Y','18','021','EC','A','','','AC','0000154649','0000154649','OH00001511288','IL','1','Whitis','Kimberly','','','','34','293667882','2511 Ardwell Ave.',0,'Akron','OH','44312',NULL,'CY','39153','1959-09-14','F','U',':RET:2106-3','N','021','HLT','1926538','52664OH152000901','2014-02-01','2013-12-27 10:07:28','333.00',NULL,NULL,'348.73','15.73','R-OH012','OH0','348.73',NULL,0,'2013-12-28 03:35:04'),(6372,5052,'Y','18','021','EC','A','','','AC','0000661325','0000661325','OH00000676095','IL','1','Bailey','David','','','','34','293480758','330 N WAYNE ST',0,'FREMONT','OH','43420','2436','CY','39143','1950-03-24','M','M',':RET:2106-3','N','021','DEN','769237','99734OH005000301','2014-01-01','2013-12-11 06:29:59','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-26 00:47:40'),(28710,22720,'Y','18','021','EC','A','','','AC','0000374770','0000374770','OH00002623218','IL','1','giffin','aaron','','','','34','290807236','8628 MILLERSTOWN ERIS RD',0,'SAINT PARIS','OH','43072','9312','CY','39021','1983-08-16','M','U',':RET:2106-3','T','021','HLT','3126836','92036OH005000506','2014-04-01','2014-03-07 20:33:46','248.00',NULL,NULL,'310.27','62.27','R-OH003','OH0','310.27',NULL,0,'2014-03-08 21:31:13'),(26014,20631,'N','19','021','EC','A',NULL,NULL,'','0000016669','0000869338','','IL','1','MILLER','ERICA','','','','34','296945877','833 ALLINGHAM ST',0,'VAN WERT','OH','45891','1005','CY','39161','1994-02-03','F','',':RET:2106-3','N','021','HLT','3762075','92036OH003001506','2014-03-01','2014-02-26 12:33:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-26 21:02:12'),(25803,20463,'Y','18','021','EC','A','','','AC','0000208556','0000208556','OH00003170561','IL','1','Narayanan','Thilagarajan','','','','34','651143403','5006 SINGLETON DR',0,'HILLIARD','OH','43026','9136','CY','39049','1976-12-16','M','U',NULL,'N','021','DEN','3164196','99734OH005000301','2014-04-01','2014-02-26 12:45:49','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:00:18'),(16206,12976,'Y','18','021','EC','A','','','AC','0000770779','0000770779','TX00001436077','IL','1','Luna','Vanessa','','','','34','633500008','1307 QUAIL DR',0,'SAN JUAN','TX','78589','3239','CY','48215','1988-05-22','F','M',NULL,'N','021','DEN','2390667','33348TX002000201','2014-02-01','2014-01-04 13:52:08','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-05 00:01:18'),(13356,10667,'Y','18','021','EC','A','','','AC','0000415971','0000415971','OH00000482784','IL','1','Seay','Philip','','','','34','592584945','308 SMEAD AVE',0,'LIMA','OH','45804','3240','CY','39003','1983-10-10','M','U',':RET:2106-3','N','021','DEN','1766684','99734OH005000301','2014-01-01','2013-12-22 18:56:28','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 12:59:20'),(13838,11043,'Y','18','021','EC','A','','','AC','0001149874','0001149874','OH00000754437','IL','1','PARKER','CAROLINE','LOUISE','','','34','271542513','56 N PERSHING AVE',0,'AKRON','OH','44313','6258','CY','39153','1950-11-05','F','U',':RET:2054-5','T','021','HLT','1425950','52664OH152000901','2014-01-01','2013-12-23 11:38:13','477.00',NULL,NULL,'554.51','77.51','R-OH012','OH0','554.51',NULL,0,'2013-12-26 13:12:15'),(22776,18184,'Y','18','021','EC','A','','','AC','0000776470','0000776470','OH00001441186','IL','1','Kopac','James','','','','34','294764557','6702 FOREST AVE',0,'SEVEN HILLS','OH','44129','2734','CY','39035','1965-03-25','M','U',':RET:2106-3','T','021','DEN','3157833','99734OH005000401','2014-03-01','2014-02-11 13:53:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-11 21:01:40'),(15087,12060,'Y','18','021','EC','A','','','AC','0001236600','0001236600','TX00001489169','IL','1','Valluzzi','Timothy','','','','34','141462628','2010 SE 21st Street',0,'Mineral Wells','TX','76067',NULL,'CY','48363','1951-05-17','M','M',':RET:2106-3','N','021','DEN','1736632','33348TX002000101','2014-02-01','2013-12-30 18:40:06','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-01-01 12:04:21'),(22570,18025,'Y','18','024','14','A','','','TE','0001089595','0001089595','','IL','1','BRIDGEFORD','MARY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-05-18','F','',NULL,NULL,NULL,'','2780054','','2014-02-10','2014-02-10 16:02:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:56'),(20368,16269,'Y','18','021','EC','A','','','AC','0001993705','0001993705','LA00001589099','IL','1','Martinovich','Alexis','','','','34','614189038','2511 Constance Street',0,'New Orleans','LA','70130',NULL,'CY','22071','1984-12-13','F','U',':RET:2106-3','N','021','DEN','3168633','18575LA002000101','2014-03-01','2014-01-28 19:04:23','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-29 21:00:04'),(21772,17386,'N','01','021','EC','A',NULL,NULL,'','0000171271','0000459198','','IL','1','CIMINI','PEGGY','A','','','34','291524110','8153 US HIGHWAY 23 N',0,'DELAWARE','OH','43015','9697','CY','39041','1950-04-04','F','',':RET:2106-3','N','021','DEN','3845843','99734OH005000401','2014-03-01','2014-02-06 13:34:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:00:33'),(29165,23085,'Y','18','021','EC','A','','','AC','0000322213','0000322213','OH00002648988','IL','1','Hardy','Trista','','','','34','292788330','1633 Washington Ave',0,'Findlay','OH','45840',NULL,'CY','39063','1982-03-04','F','U',NULL,'T','021','HLT','3917073','92036OH005001506','2014-04-01','2014-03-10 14:22:30','237.00',NULL,NULL,'299.42','62.42','R-OH002','OH0','299.42',NULL,0,'2014-03-10 21:02:56'),(71,64,'Y','18','024','14','A','','','TE','0000482154','0000482154','','IL','1','Solomon','Gary','Alan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-15','M','',NULL,NULL,NULL,'','584939','','2013-12-05','2013-12-05 14:18:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:16:56'),(19116,15230,'N','01','021','EC','A',NULL,NULL,'','0001183547','0000691859','','IL','1','Greer','Brittany','','','','34','292947309','2605 Aberdeen Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1992-03-04','F','',':RET:2106-3','N','021','HLT','1651645','92036OH005001501','2014-03-01','2014-01-18 10:03:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.08',NULL,0,'2014-01-21 08:44:47'),(14622,11671,'Y','18','021','EC','A','','','AC','0000559444','0000559444','OH00001703714','IL','1','Bledsoe','Geia',NULL,NULL,NULL,NULL,NULL,'841 WILLOW AVE',0,'TOLEDO','OH','43605','2934','CY','39095','1965-03-29','F','U',NULL,'N','021','HLT','1511895','92036OH004002601','2014-02-01','2013-12-27 10:46:28','215.00',NULL,NULL,'256.36','41.36','R-OH001','OH0','256.36',NULL,0,'2013-12-28 03:36:57'),(5968,4724,'Y','18','021','EC','A','','','AC','0000684817','0000684817','OH00000999256','IL','1','morrin','scott','','','','34','271525446','4232 BARBARA DR',0,'TOLEDO','OH','43623','3404','CY','39095','1963-07-09','M','U',':RET:2106-3','N','021','HLT','1664926','92036OH004002601','2014-01-01','2013-12-23 23:10:15','151.00',NULL,NULL,'280.03','129.03','R-OH001','OH0','280.03',NULL,0,'2013-12-25 23:51:32'),(7244,5744,'Y','18','021','EC','A','','','AC','0000040278','0000040278','LA00001082539','IL','1','Isom','Lynn','','','','34','437843997','9630 Haynes Blvd.',0,'New Orleans','LA','70127',NULL,'CY','22071','1950-05-08','F','U',':RET:2054-5','N','021','DEN','241521','18575LA002000201','2014-01-01','2013-12-14 13:13:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:44'),(2864,2314,'Y','18','021','EC','A','','','AC','0000904223','0000904223','OH00000495449','IL','1','Gambatese','David','A','','','34','269561617','10411 MEADOWHURST LN',0,'CHARDON','OH','44024','9712','CY','39055','1957-09-05','M','U',':RET:2106-3','T','021','DEN','777460','99734OH005000401','2014-01-01','2013-11-02 13:40:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:01:42'),(1828,1499,'Y','18','021','EC','A','','','AC','0001099190','0001099190','OH00001518690','31','1','SHENKMIN','SHERRY','ROCHELLE','','','34','290506753','P.O. BOX 62',0,'MALINTA','OH','43535',NULL,'CY','39069','1959-08-21','F','U',':RET:2106-3','N','021','HLT','2059608','92036OH003002604','2014-01-01','2013-12-24 09:41:23','299.00',NULL,NULL,'434.76','135.76','R-OH001','OH0','434.76',NULL,0,'2013-12-25 18:57:22'),(24803,19669,'N','01','021','EC','A',NULL,NULL,'','0001126924','0000547931','','IL','1','cheema','navjot','','','','34','095829646','7532 mount whitney',0,'Dayton','OH','45424',NULL,'CY','39113','1986-02-10','F','',':RET:2028-9','N','021','DEN','3430354','99734OH005000401','2014-04-01','2014-02-19 16:54:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:48:34'),(547,448,'Y','18','021','EC','A','','','AC','0000542644','0000542644','OH00000652643','IL','1','Machado','Jorge','','','','34','590373618','939 LLOYD RD',0,'WICKLIFFE','OH','44092','2335','CY','39085','1993-10-10','F','U',NULL,'N','021','HLT','73485','52664OH152000901','2014-01-01','2013-12-04 16:47:54','100.00',NULL,NULL,'116.98','16.98','R-OH011','OH0','116.98',NULL,0,'2013-12-25 17:49:54'),(1208,994,'Y','18','021','EC','A','','','AC','0000811988','0000811988','OH00001106808','IL','1','BELKIN','BORIS','','','','34','289949231','5450 Cascade Court',0,'Willoughby','OH','44094',NULL,'CY','39085','1966-10-12','M','M',':RET:2106-3','N','021','DEN','1227425','99734OH005000301','2014-01-01','2013-12-03 16:21:21','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:20:03'),(19739,15731,'Y','18','021','EC','A','','','AC','0001603143','0001603143','LA00001494862','31','1','Mousa','Yaser','','','','34','064923737','925 Anderson St.',0,'Franklin','LA','70538',NULL,'CY','22101','1979-01-07','M','U',NULL,'N','021','DEN','3371268','18575LA002000201','2014-03-01','2014-01-23 15:44:52','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-23 21:01:10'),(6036,4780,'Y','18','021','EC','A','','','AC','0000044237','0000044237','LA00000219369','IL','1','Nesbitt','Lee','','','','34','434196051','5127 Prytania St.',0,'New Orleans','LA','70115',NULL,'CY','22071','1971-07-12','M','U',':RET:2106-3','N','021','DEN','663372','18575LA002000101','2014-01-01','2013-12-01 16:17:56','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:01:17'),(3568,2865,'Y','18','024','14','A','','','TE','0000781895','0000781895','','IL','1','MEADOWS','WILLIAM',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-11-25','M','',NULL,NULL,NULL,'','2456973','','2013-12-22','2013-12-22 07:26:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:22:29'),(5248,4162,'Y','18','021','EC','A','','','AC','0000881616','0000881616','OH00000853397','IL','1','merriman','sean','m','','','34','284503668','21746 GATEHOUSE LN',0,'ROCKY RIVER','OH','44116','2180','CY','39035','1967-02-23','M','U',':RET:2106-3','N','021','HLT','2103573','52664OH151001306','2014-01-01','2013-12-19 08:37:19','245.00',NULL,NULL,'377.28','132.28','R-OH011','OH0','377.28',NULL,0,'2013-12-25 23:05:04'),(4514,3578,'Y','18','021','EC','A','','','AC','0000009917','0000009917','TX00000565173','IL','1','anaya','daniel','','','','34','463776392','404 S 29TH AVE',0,'EDINBURG','TX','78542','5012','CY','48215','1984-09-23','M','M',NULL,'N','021','DEN','1158424','33348TX002000201','2014-01-01','2013-12-12 11:18:29','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:03:40'),(3359,2692,'Y','18','024','14','A','','','TE','0000151570','0000151570','','IL','1','Londoff','Daniel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-14','M','',NULL,NULL,NULL,'','813250','','2013-12-22','2013-12-22 13:12:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:16:56'),(17769,14197,'Y','18','021','EC','A','','','AC','0001169023','0001169023','TX00002225814','IL','1','Jaffer','Mehboob','','','','34','638037000','6707 Park Lane',0,'Houston','TX','77023',NULL,'CY','48201','1954-04-28','M','M',':RET:2029-7','N','021','DEN','1546815','33348TX002000101','2014-02-01','2014-01-13 13:43:07','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:37'),(15467,12375,'N','01','021','EC','A',NULL,NULL,'','0000191381','0001053066','','IL','1','TRAN','NGA','','','','34','300901129','4307 MANTELL CT',0,'DAYTON','OH','45440','3869','CY','39057','1965-08-16','F','',NULL,'N','021','HLT','2512995','92036OH004000501','2014-02-01','2013-12-31 11:20:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','312.51',NULL,1,'2014-01-02 04:28:47'),(14407,11489,'Y','18','021','EC','A','','','AC','0000953259','0000953259','OH00000954350','IL','1','Taylor','Daniel','J','','','34','728716744','328 CLOUGH ST',0,'BOWLING GREEN','OH','43402','2906','CY','39173','1970-09-14','M','M',':RET:2106-3','N','021','DEN','1637587','99734OH005000401','2014-02-01','2013-12-27 18:10:45','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-28 03:31:21'),(6767,5369,'Y','18','021','EC','A','','','AC','0000045660','0000045660','LA00000380679','IL','1','Page','William','Louis','','Jr','34','261954064','10290 JANICE ST',0,'BATON ROUGE','LA','70816','5013','CY','22033','1979-12-21','M','M',':RET:2106-3','T','021','DEN','55030','18575LA002000201','2014-01-01','2013-11-25 09:35:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:16:31'),(1711,1428,'N','01','021','EC','A',NULL,NULL,'','0000314703','0000965772','','IL','1','Knippen','Rick','L','','','34','297620174','26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','1958-02-05','M','',':RET:2106-3','T','021','HLT','1693316','92036OH003001501','2014-01-01','2013-12-24 07:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','589.42',NULL,0,'2013-12-25 18:55:00'),(6020,4764,'N','19','021','EC','A',NULL,NULL,'','0000333821','0001022745','','IL','1','Fultz','Larry','Allen','','III','34','392176077','7405 AMBER LN',0,'BRECKSVILLE','OH','44141','1903','CY','39035','1997-11-27','M','',':RET:2106-3','N','021','DEN','331619','99734OH005000301','2014-01-01','2013-12-01 12:12:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:49'),(13977,11138,'Y','18','021','EC','A','','','AC','0000553911','0000553911','OH00001113844','IL','1','Hundley','Thomas','','','','34','284681730','192 COUNTRY VIEW DR',0,'HARRISON','OH','45030',NULL,'CY','39061','1961-02-07','M','M',':RET:2106-3','N','021','HLT','2519518','92036OH004001201','2014-01-01','2013-12-23 11:07:35','654.00',NULL,NULL,'804.02','150.02','R-OH004','OH0','336.93',NULL,0,'2013-12-26 13:15:31'),(5076,4022,'Y','18','021','EC','A','','','AC','0000445769','0000445769','TX00000094069','IL','1','Williams','Theodore','','','','34','227748484','4820 Westgrove DR',0,'Addison','TX','75001',NULL,'CY','48113','1960-04-29','M','U',':RET:2054-5','N','021','DEN','1556221','33348TX002000201','2014-01-01','2013-12-19 13:36:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:00:50'),(3289,2652,'Y','18','021','EC','A','','','AC','0000874684','0000874684','OH00000399773','IL','1','CONNOLLY','JOHN','','','','34','299542670','2712 120TH ST',0,'TOLEDO','OH','43611','2231','CY','39095','1954-10-16','M','U',':RET:2106-3','N','021','DEN','2194636','99734OH005000301','2014-01-01','2013-12-22 05:11:02','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:15:28'),(20427,16315,'Y','18','021','EC','A','','','AC','0001046867','0001046867','OH00001840497','IL','1','Touassi','Mohamed','','','','34','278861735','5738 VILLAS CREEK DR',0,'MASON','OH','45040','2456','CY','39165','1951-12-04','M','M',':RET:2106-3','N','021','DEN','2223794','99734OH005000301','2014-03-01','2014-01-29 12:21:49','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:33'),(20830,16649,'Y','18','021','EC','A','','','AC','0001823375','0001823375','LA00001814192','IL','1','Suleiman','Summer','','','','34','436738788','28 Shadows Ct',0,'Marrero','LA','70072',NULL,'CY','22051','1987-11-15','F','U',':RET:2106-3','N','021','DEN','2685763','18575LA002000201','2014-03-01','2014-01-31 16:17:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:40'),(21621,17263,'Y','18','021','EC','A','','','AC','0000217468','0000217468','TX00001585768','IL','1','Ramos','Stephanie','Danielle','','','34','626266001','368 Shadow Mountain Drive',0,'El Paso','TX','79912',NULL,'CY','48141','1987-07-14','F','R',NULL,'N','021','DEN','2890772','33348TX002000201','2014-03-01','2014-02-05 01:17:46','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-05 21:30:37'),(22078,17622,'Y','18','021','EC','A','','','AC','0002074915','0002074915','LA00002051609','IL','1','Stevenson','Bernita','','','','34','435844509','447 E OLIVE ST',0,'SHREVEPORT','LA','71104','2764','CY','22017','1950-08-24','F','U',':RET:2054-5','N','021','DEN','2649861','18575LA002000201','2014-03-01','2014-02-07 21:35:04','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-08 19:00:17'),(17121,13702,'Y','18','021','EC','A','','','AC','0000866911','0000866911','OH00001364644','IL','1','CRABTREE','ANNETTA','F','','','34','278560837','1485B MCDERMOTT POND CREEK RD',0,'MC DERMOTT','OH','45652','8978','CY','39145','1953-11-11','F','M',':RET:2106-3','T','021','DEN','1900184','99734OH005000401','2014-02-01','2014-01-08 10:36:58','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2014-01-13 02:21:42'),(14549,11608,'Y','18','021','EC','A','','','AC','0000807796','0000807796','MS00000816216','IL','1','DOWE','DAKOTA','','','','34','587619563','1809 BROCK RD',0,'UTICA','MS','39175','8071','CY','28049','1988-01-26','M','U',':RET:2106-3','N','021','DEN','1653968','46300MS002000201','2014-02-01','2013-12-27 16:14:52','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:58'),(7346,5816,'Y','18','024','14','A','','','TE','0001029342','0001029342','','IL','1','Dedo','Robert','Ross',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-07','M','',NULL,NULL,NULL,'','340858','','2013-12-14','2013-12-14 15:54:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:04:06'),(1745,1448,'Y','18','021','EC','A','','','AC','0000784364','0000784364','OH00000433633','IL','1','Haikal','Samir','','','','34','284821386','13882 LAKE AVE',0,'LAKEWOOD','OH','44107','1425','CY','39035','1966-04-04','M','M',NULL,'N','021','DEN','2188206','99734OH005000301','2014-01-01','2013-12-24 12:16:41','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:37'),(3835,3068,'Y','18','021','EC','A','','','AC','0000998760','0000998760','OH00000611558','IL','1','Horner','Torey','Jay','','','34','273661184','347 DEER CREEK TRL',0,'CORTLAND','OH','44410','2606','CY','39155','1959-06-20','F','M',':RET:2106-3','N','021','DEN','904097','99734OH005000301','2014-01-01','2013-12-13 16:59:46','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:35:14'),(5368,4256,'Y','18','021','EC','A','','','AC','0000246435','0000246435','OH00000263686','IL','1','Lyman','Angela','','','','34','027763774','512 TUSCULUM AVE',0,'CINCINNATI','OH','45226','1774','CY','39061','1968-06-12','F','M',':RET:2106-3','N','021','HLT','1722743','92036OH005001205','2014-01-01','2013-12-19 10:48:13','102.00',NULL,NULL,'309.99','207.99','R-OH004','OH0','309.99',NULL,0,'2013-12-25 23:08:01'),(3826,3064,'Y','18','021','EC','A','','','AC','0000780485','0000780485','OH00000575877','IL','1','Rudd','Julie','','','','34','092729969','38 B North Spring St',0,'Wilmington','OH','45177',NULL,'CY','39027','1982-04-15','F','U',':RET:2106-3','N','021','DEN','655213','99734OH005000301','2014-01-01','2013-12-13 15:32:17','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:35:05'),(18614,14838,'Y','18','021','EC','A','','','AC','0000045793','0000045793','OH00001958899','IL','1','Truax','Joan','','','','34','291623147','60 N state route 101',0,'Tiffin','OH','44883',NULL,'CY','39147','1956-12-28','F','M',':RET:2106-3','N','021','HLT','1566755','92036OH004002701','2014-02-01','2014-01-15 11:20:43','283.00',NULL,NULL,'382.11','99.11','R-OH006','OH0','382.11',NULL,0,'2014-01-16 08:47:25'),(18885,15046,'N','01','021','EC','A',NULL,NULL,'','0001884409','0002156033','','IL','1','Vicknair','Cynthia','Marie','','','34','435499940','6512 MITCHELL AVE',0,'METAIRIE','LA','70003','4855','CY','22051','1980-03-04','F','',':RET:2106-3','N','021','DEN','1790244','18575LA002000201','2014-02-01','2014-01-15 20:34:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-17 03:36:29'),(20246,16155,'Y','18','024','14','A','','','TE','0000889695','0000889695','','IL','1','Doberson','Chad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-23','M','',NULL,NULL,NULL,'','2294967','','2014-01-28','2014-01-28 09:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:10'),(23567,18775,'Y','18','021','EC','A','','','AC','0001213461','0001213461','MS00002465447','IL','1','Ellis','Alexis','','','','34','426714974','1100 J. R. Lynch St.',0,'Jackson','MS','39203',NULL,'CY','28049','1991-02-10','F','U',':RET:2054-5','N','021','DEN','3832617','46300MS002000201','2014-03-01','2014-02-13 10:40:08','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-13 22:02:48'),(27438,21715,'Y','18','021','EC','A','','','AC','0001977801','0001977801','LA00002999187','IL','1','BROWN','DONNA','','','','34','435968731','1534 COURT ST  TRLR 28',0,'PORT ALLEN','LA','70767',NULL,'CY','22121','1955-11-29','F','U',NULL,'T','021','DEN','4032956','18575LA002000201','2014-04-01','2014-03-04 15:15:11','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-04 21:01:51'),(28459,22519,'Y','18','021','EC','A','','','AC','0001984782','0001984782','LA00003351256','IL','1','Evans','William','','','','34','436294749','238 MCGEHEE DR',0,'BATON ROUGE','LA','70815','5014','CY','22033','1971-09-07','M','U',NULL,'N','021','DEN','4042035','18575LA002000201','2014-04-01','2014-03-07 15:36:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-07 21:31:24'),(428,351,'Y','18','021','EC','A','','','AC','0000327246','0000327246','OH00001006432','IL','1','Adams','Edward','','','','34','281660730','729 MOON RD',0,'COLUMBUS','OH','43224','3159','CY','39049','1967-05-07','M','R',':RET:2054-5^:RET:2106-3','N','021','DEN','1250327','99734OH005000401','2014-01-01','2013-12-04 16:09:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:50'),(18095,14454,'Y','18','021','EC','A','','','AC','0002122523','0002122523','LA00001496732','31','1','Jones','Erma','','','','34','436259138','P.O. Box 435',0,'Wisner','LA','71378',NULL,'CY','22041','1963-04-23','F','U',':RET:2054-5','N','021','DEN','2712466','18575LA002000201','2014-02-01','2014-01-14 13:24:50','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:32'),(2129,1747,'N','01','021','EC','A',NULL,NULL,'','0000484750','0000176371','','IL','1','Downing','Kathleen','Martin','','','34','278568593','2358 CLEARVIEW DR NW',0,'WARREN','OH','44483',NULL,'CY','39155','1953-12-16','F','',':RET:2106-3','N','021','DEN','1073711','99734OH005000401','2014-01-01','2013-12-10 15:22:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:17:54'),(7338,5812,'Y','18','021','EC','A','','','AC','0000911753','0000911753','OH00001131017','IL','1','Johnson','Wade','','','','34','288507986','8050 Brandywine Road',0,'Northfield','OH','44067',NULL,'CY','39153','1949-06-03','M','U',':RET:2106-3','N','021','HLT','1058529','52664OH152000901','2014-01-01','2013-12-14 15:31:17','0.00',NULL,NULL,'490.00','490.00','R-OH012','OH0','490.00',NULL,0,'2013-12-26 02:03:57'),(16294,13045,'Y','18','021','EC','A','','','AC','0001879495','0001879495','LA00002257643','IL','1','Matthews','Debbie','','','','34','436116550','10021 Adam Drive',0,'Denham Springs','LA','70726',NULL,'CY','22063','1959-07-01','F','U',':RET:2106-3','T','021','DEN','1500470','18575LA002000201','2014-02-01','2014-01-06 12:13:44','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:00:58'),(15350,12279,'Y','18','021','EC','A','','','AC','0000194055','0000194055','OH00000440707','IL','1','KOLCINKO','ANTHONY','','','','34','275528620','5651 ANDOVER BLVD',0,'CLEVELAND','OH','44125','3554','CY','39035','1959-04-20','M','U',':RET:2106-3','N','021','DEN','1614551','99734OH005000301','2014-02-01','2013-12-31 20:24:35','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:24:31'),(7014,5568,'Y','18','021','EC','A','','','AC','0000402742','0000402742','TX00000598228','IL','1','finley','beau','','','','34','644128932','4413 40th street',0,'lubbock','TX','79414',NULL,'CY','48303','1990-03-16','M','U',':RET:2106-3','N','021','DEN','1392640','33348TX002000201','2014-01-01','2013-12-24 20:06:20','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 01:48:36'),(5461,4338,'Y','18','021','EC','A','','','AC','0000672750','0000672750','OH00000678635','IL','1','Bonem','Lathem','','','','34','282801880','2647 Euclid Heights Blvd',0,'Cleveland Heights','OH','44106',NULL,'CY','39035','1978-10-18','M','U',':RET:2106-3','N','021','HLT','1476172','52664OH151001501','2014-01-01','2013-12-19 17:58:46','168.00',NULL,NULL,'368.63','200.63','R-OH011','OH0','368.63',NULL,0,'2013-12-25 23:10:24'),(5941,4705,'Y','18','021','EC','A','','','AC','0001408570','0001408570','LA00000854770','IL','1','mills','jacob','carl','','','34','532118302','1117 ODWYER PL',0,'JEFFERSON','LA','70121','3019','CY','22051','1979-05-02','M','U',':RET:2106-3','N','021','DEN','2345458','18575LA002000101','2014-01-01','2013-12-24 00:22:19','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:50:49'),(20055,15995,'Y','18','024','14','A','','','TE','0000334099','0000334099','','IL','1','CASTILLO','OLIVIA','VALDEZ',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-03','F','',NULL,NULL,NULL,'','2040739','','2014-01-27','2014-01-27 09:59:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:07'),(23139,18445,'Y','18','021','EC','A','','','AC','0000563183','0000563183','OH00002425541','IL','1','FORAKER','CANDACE','','','','34','297701796','422 S MAIN ST',0,'HUBBARD','OH','44425','2257','CY','39155','1960-06-29','F','M',':RET:2106-3','T','021','HLT','3696790','52664OH151001305','2014-03-01','2014-02-12 10:07:52','330.00',NULL,NULL,'593.29','263.29','R-OH013','OH0','593.29',NULL,0,'2014-02-12 21:31:35'),(26763,21211,'Y','18','021','EC','A','','','AC','0001121453','0001121453','OH00002798813','IL','1','POKORNY','SYNTHIA','ELLEN','','','34','300660598','11430 WOODIEBROOK RD',0,'CHARDON','OH','44024','8496','CY','39055','1959-08-04','F','M',NULL,'N','021','DEN','2809951','99734OH005000301','2014-03-01','2014-02-28 19:30:13','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00','CIC',0,'2014-03-01 19:00:09'),(28471,22529,'Y','18','021','EC','A','','','AC','0000277324','0000277324','OH00003559056','IL','1','Ramsier','Pamela','','','','34','290749747','107 Township Road 810',0,'West Salem','OH','44287',NULL,'CY','39005','1964-03-14','F','U',':RET:2106-3','N','021','DEN','2712400','99734OH005000301','2014-04-01','2014-03-07 08:15:32','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-07 21:31:31'),(16486,13192,'N','19','021','EC','A',NULL,NULL,'','0000209652','0001139518','','IL','1','BADER','EMMANUEL','','','','34','290063017','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','2001-11-05','M','',NULL,'N','021','HLT','2166183','92036OH004000801','2014-02-01','2014-01-06 14:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.38',NULL,0,'2014-01-07 04:06:24'),(9474,7514,'Y','18','021','EC','A','','','AC','0000393663','0000393663','OH00000177273','IL','1','Daniels','Donald','','','','34','285526922','4825 CREEKNOLL CT',0,'HUBER HEIGHTS','OH','45424','1902','CY','39113','1952-09-08','M','M',':RET:2106-3','T','021','DEN','2300470','99734OH005000401','2014-01-01','2013-12-21 11:05:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:34:30'),(15870,12708,'Y','18','021','EC','A','','','AC','0000683195','0000683195','MS00002046029','IL','1','CARDWELL','GERRI','F','','','34','408151767','3305 NICHOLAS LN',0,'SOUTHAVEN','MS','38672','6733','CY','28033','1958-09-14','F','M',':RET:2106-3','N','021','DEN','2547643','46300MS002000101','2014-02-01','2014-01-02 14:48:25','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-03 02:05:04'),(9374,7432,'Y','18','021','EC','A','','','AC','0001180827','0001180827','LA00000256018','IL','1','Bagneris','Christopher','','','','34','435856966','4978 MUSIC ST',0,'NEW ORLEANS','LA','70122','5120','CY','22071','1992-08-14','M','U',':RET:2054-5','N','021','DEN','1500812','18575LA002000201','2014-01-01','2013-12-21 13:50:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:53'),(2901,2339,'N','01','021','EC','A',NULL,NULL,'','0000895683','0000367354','','IL','1','Facchiano','Nancy','Mae','','','34','302582976','3505 Hemphill Rd',0,'Norton','OH','44203',NULL,'CY','39153','1956-03-15','F','',':RET:2106-3','N','021','HLT','1168448','52664OH151001501','2014-01-01','2013-12-06 13:51:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','651.81',NULL,0,'2013-12-25 20:15:22'),(19335,15414,'Y','18','021','EC','A','','','AC','0001044188','0001044188','TX00001521836','IL','1','Castillo','Esmeralda','Garcia','','','34','454908405','302 E HILL AVE',0,'ALICE','TX','78332','5968','CY','48249','1949-11-05','F','U',':RET:2106-3','N','021','DEN','1892194','33348TX002000201','2014-03-01','2014-01-21 15:40:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-22 03:22:18'),(20728,16562,'Y','18','021','EC','A','','','AC','0000076332','0000076332','OH00002195129','IL','1','Collins','Sharon','','','','34','275485494','118 THORLONE AVE',0,'AKRON','OH','44312','1851','CY','39153','1951-03-31','F','U',NULL,'N','021','HLT','3554326','52664OH151001305','2014-03-01','2014-01-30 17:26:02','481.00',NULL,NULL,'640.70','159.70','R-OH012','OH0','640.70',NULL,0,'2014-01-30 21:01:17'),(21900,17489,'Y','18','021','EC','A','','','AC','0000412247','0000412247','OH00002154295','IL','1','Fox','Gina','','','','34','014649957','21409 MONTICELLO SPENCERVILL RD',0,'SPENCERVILLE','OH','45887','9022','CY','39161','1975-11-14','F','M',':RET:2106-3','N','021','HLT','3013219','92036OH005001506','2014-03-01','2014-02-06 14:35:14','511.00',NULL,NULL,'546.70','35.70','R-OH002','OH0','274.24',NULL,0,'2014-02-06 21:01:46'),(23365,18617,'N','01','021','EC','A',NULL,NULL,'','0000716386','0001128058','','IL','1','Kunzin','George','','','','34','278524779','1726 PRESTON AVE',0,'AKRON','OH','44305','3520','CY','39153','1958-08-03','M','',':RET:2106-3','N','021','HLT','3685649','52664OH151001305','2014-03-01','2014-02-13 16:39:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-02-13 22:00:48'),(23713,18881,'Y','18','024','14','A','','','TE','0000205834','0000205834','','IL','1','lindsey','dorian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-09-19','M','',NULL,NULL,NULL,'','2812074','','2014-02-14','2014-02-14 16:21:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:30:48'),(23900,19012,'Y','18','021','EC','A','','','AC','0000192774','0000192774','OH00002041665','IL','1','MEYER','LAURA','','','','34','285500034','793 N WEST ST',0,'XENIA','OH','45385','2339','CY','39057','1951-09-26','F','R',':RET:2106-3','N','021','HLT','3602256','92036OH004000501','2014-03-01','2014-02-14 15:59:44','0.00',NULL,NULL,'549.13','549.13','R-OH003','OH0','549.13',NULL,0,'2014-02-14 21:32:23'),(14942,11941,'Y','18','021','EC','A','','','AC','0000276283','0000276283','OH00001146420','IL','1','Zaffiro','Mellissa','','','','34','268807989','4986 CORLISS RD',0,'LYNDHURST','OH','44124','1133','CY','39035','1973-07-19','F','U',':RET:2106-3','N','021','HLT','1372148','52664OH151001501','2014-02-01','2013-12-29 14:45:37','127.00',NULL,NULL,'385.52','258.52','R-OH011','OH0','385.52',NULL,0,'2013-12-30 00:02:20'),(9166,7270,'Y','18','021','EC','A','','','AC','0000777665','0000777665','OH00000230410','IL','1','joseph','gerald','','','','34','291484004','7367 CLUM RD',0,'HARROD','OH','45850','9413','CY','39003','1950-09-17','M','M',':RET:2106-3','T','021','HLT','1472476','92036OH004001501','2014-01-01','2013-12-18 11:01:55','1111.12',NULL,NULL,'1119.30','8.18','R-OH002','OH0','600.76',NULL,0,'2013-12-26 04:08:48'),(21260,16989,'N','01','021','EC','A',NULL,NULL,'','0001130258','0000726167','','IL','1','Davis','Tammy','S','','','34','277789178','4308 Jacksonburg Road',0,'Hamilton','OH','45011',NULL,'CY','39017','1976-12-11','F','',':RET:2106-3','T','021','HLT','2879020','92036OH003001204','2014-03-01','2014-02-03 16:01:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.16',NULL,0,'2014-02-03 21:01:22'),(23931,19030,'Y','18','021','EC','A','','','AC','0000998798','0000998798','OH00002783889','IL','1','ASHCRAFT','ELLEN','','','','34','288667053','7960 RIO GRANDE DR',0,'CLEVES','OH','45002','2303','CY','39061','1958-11-06','F','M',':RET:2106-3','N','021','DEN','3430257','99734OH005000401','2014-03-01','2014-02-15 09:49:21','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00','CIC',0,'2014-02-15 21:00:03'),(18536,14781,'Y','18','021','EC','A','','','AC','0000254556','0000254556','OH00002296397','IL','1','King','Gary','','','','34','286882493','5731 E ROWLAND RD',0,'TOLEDO','OH','43613','2224','CY','39095','1981-03-22','M','U',':RET:2106-3','N','021','HLT','1625218','92036OH006002601','2014-02-01','2014-01-15 16:22:10','8.00',NULL,NULL,'182.95','174.95','R-OH001','OH0','182.95',NULL,0,'2014-01-16 08:46:46'),(15765,12615,'Y','18','021','EC','A','','','AC','0000796996','0000796996','TX00001611795','IL','1','Grajeda','Alexander','','','','34','467799951','6511 N SEMINARY RD',0,'EDINBURG','TX','78541','5194','CY','48215','1974-12-09','M','R',':RET:2106-3','N','021','DEN','1702440','33348TX002000201','2014-02-01','2014-01-02 13:13:08','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-03 02:01:38'),(17826,14240,'N','01','021','EC','A',NULL,NULL,'','0000740937','0000895749','','IL','1','DAVIS','EVA','','','','34','587131024','28 SHARMONT DR',0,'HATTIESBURG','MS','39402','1950','CY','28073','1957-07-22','F','',':RET:2054-5','N','021','DEN','2768017','46300MS002000201','2014-02-01','2014-01-14 12:16:52',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-15 02:05:58'),(9331,7395,'N','01','021','EC','A',NULL,NULL,'','0000683381','0000364882','','IL','1','Arkus','Alan','J','','','34','156749645','3746 White Chapel Ct.',0,'Amelia','OH','45102',NULL,'CY','39025','1973-05-17','M','',':RET:2106-3','N','021','HLT','1814248','92036OH004000601','2014-01-01','2013-12-20 18:52:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.60',NULL,0,'2013-12-26 04:30:44'),(4104,3279,'N','01','021','EC','A',NULL,NULL,'','0000834074','0000851967','','IL','1','Williams','Cindy','Dawn','','','34','460278314','934 GLADEWATER DR',0,'FRISCO','TX','75033','7444','CY','48121','1958-08-11','F','',':RET:2054-5','N','021','DEN','2150443','33348TX002000101','2014-01-01','2013-12-17 01:53:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 21:47:48'),(25646,20345,'Y','18','024','14','A','','','TE','0000152036','0000152036','','IL','1','tucker','brady',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2003-11-27','M','',NULL,NULL,NULL,'','3730892','','2014-02-21','2014-02-21 19:33:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 08:30:35'),(15652,12522,'Y','18','021','EC','A','','','AC','0000260611','0000260611','MS00000845952','IL','1','HARPER','CURMERA','','','','34','426591761','1725 DORCHESTER DR',0,'SOUTHAVEN','MS','38671','5707','CY','28033','1987-10-10','F','U',':RET:2054-5','N','021','DEN','2576481','46300MS002000201','2014-02-01','2013-12-31 16:55:00','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,1,'2014-01-02 04:34:08'),(3697,2959,'Y','18','021','EC','A','','','AC','0000675430','0000675430','OH00000138922','IL','1','Risner','April','','','','34','286769768','127 INDIANA AVE',0,'DAYTON','OH','45410','2309','CY','39113','1974-04-24','F','U',':RET:2106-3','N','021','DEN','62906','99734OH005000401','2014-01-01','2013-12-13 11:38:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:31:53'),(23735,18898,'Y','18','021','EC','A','','','AC','0001096806','0001096806','OH00002195458','IL','1','Finsterwald','Emily','','','','34','278824625','2 HARRIS RD',0,'ATHENS','OH','45701','1833','CY','39009','1980-12-26','F','U',':RET:2106-3','N','021','DEN','2678319','99734OH005000301','2014-03-01','2014-02-13 20:09:46','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-02-14 21:31:00'),(16812,13447,'Y','18','021','EC','A','','','AC','0000290609','0000290609','TX00002474347','IL','1','Martinez','Miguel','','','','34','384062539','414 N 8TH ST',0,'DONNA','TX','78537','2625','CY','48215','1988-02-18','M','U',':RET:2106-3','N','021','DEN','2602129','33348TX002000201','2014-02-01','2014-01-11 17:14:23','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-13 02:18:17'),(27720,21922,'Y','18','021','EC','A','','','AC','0000277951','0000277951','TX00003770608','IL','1','trevino','jessica',NULL,NULL,NULL,NULL,NULL,'13407 SPRUCE HOLLOW CT',0,'HOUSTON','TX','77059','3237','CY','48201','1977-03-02','F','M',NULL,'N','021','DEN','3109320','33348TX002000201','2014-04-01','2014-03-05 14:05:56','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-05 21:30:57'),(7224,5726,'Y','18','021','EC','A','','','AC','0000234035','0000234035','OH00000565260','IL','1','Smaltz','Michelle','','','','34','294904804','8191 Oakwood Dr',0,'Findlay','OH','45840',NULL,'CY','39063','1989-12-04','F','U',':RET:2106-3','T','021','DEN','954696','99734OH005000401','2014-01-01','2013-12-14 14:38:01','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 02:01:12'),(6537,5183,'Y','18','021','EC','A','','','AC','0000968261','0000968261','TX00000694596','IL','1','evans','sonya','','','','34','553459773','109 east dean ave',0,'killeen','TX','76541',NULL,'CY','48027','1974-01-21','F','U',':RET:2054-5','N','021','DEN','797137','33348TX002000201','2014-01-01','2013-12-10 22:40:15','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 00:51:50'),(15945,12765,'Y','18','021','EC','A','','','AC','0000798420','0000798420','OH00002162546','IL','1','MILLER','BETHANY','','','','34','269746237','417 E NORTH ST',0,'WEST UNION','OH','45693','1072','CY','39001','1977-06-27','F','U',':RET:2106-3','T','021','HLT','2420897','92036OH003000606','2014-02-01','2014-01-02 11:46:39','232.00',NULL,NULL,'317.11','85.11','R-OH005','OH0','317.11',NULL,0,'2014-01-03 02:07:18'),(22811,18205,'Y','18','021','EC','A','','','AC','0000322190','0000322190','OH00001588110','IL','1','Etter','Sadie','','','','34','272861130','342 BRITTON LN',0,'MONROE','OH','45050','1102','CY','39017','1982-10-01','F','M',':RET:2106-3','N','021','DEN','2762493','99734OH005000301','2014-03-01','2014-02-11 15:26:33','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:57'),(20871,16680,'Y','18','021','EC','A','','','AC','0001153423','0001153423','MS00002388756','IL','1','potts','delores','','','','34','587238295','241 BROWN RD E',0,'CANTON','MS','39046','8705','CY','28089','1965-01-09','F','M',':RET:2054-5','N','021','DEN','3352333','46300MS002000101','2014-03-01','2014-01-31 15:46:45','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-31 21:01:02'),(2554,2078,'Y','18','021','EC','A','','','AC','0000751733','0000751733','MS00000179350','IL','1','Taylor','Kathryn','','','','34','428535927','140 COUNTY ROAD 8361',0,'RIENZI','MS','38865','9326','CY','28003','1985-02-22','F','R',':RET:2106-3','N','021','DEN','1111897','46300MS002000201','2014-01-01','2013-12-09 11:32:51','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 19:37:21'),(13341,10653,'Y','18','021','EC','A','','','AC','0000449352','0000449352','TX00000073175','IL','1','Meeks','George','','','','34','426238032','9506 LEANING TREE LN',0,'HOUSTON','TX','77064','5375','CY','48201','1960-10-17','M','M',':RET:2054-5','N','021','DEN','1462056','33348TX002000201','2014-01-01','2013-12-23 18:22:02','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:54'),(26946,21351,'N','01','021','EC','A',NULL,NULL,'','0000532169','0000221379','','IL','1','Neff','Deborah','Kay','','','34','283726944','900 Lodge Road',0,'Norwich','OH','43767',NULL,'CY','39119','1961-12-16','F','',':RET:2106-3','N','021','DEN','3935724','99734OH005000301','2014-04-01','2014-03-02 17:20:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:24'),(25863,20505,'Y','18','021','EC','A','','','AC','0001442863','0001442863','LA00002342162','IL','1','Moore','Denise','','','','34','439080143','3035 Cedar Avenue',0,'Baton Rouge','LA','70805',NULL,'CY','22033','1958-05-15','F','U',NULL,'N','021','DEN','3449822','18575LA002000201','2014-04-01','2014-02-26 13:33:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-26 21:00:46'),(6854,5434,'Y','18','021','EC','A','','','AC','0000095199','0000095199','OH00000840494','IL','1','RUTLEDGE','MARY','ANN','','','34','273546368','4626 GREENWICH VILLAGE AVE',0,'DAYTON','OH','45406','2410','CY','39113','1949-10-23','F','U',NULL,'N','021','DEN','679289','99734OH005000301','2014-01-01','2013-10-05 17:46:13','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:31:28'),(24106,19164,'Y','18','021','EC','A','','','AC','0001037890','0001037890','TX00002381283','IL','1','LALUMIA','ANTHONY','','','','34','459844639','9304 LOCARNO DR',0,'DALLAS','TX','75243','7218','CY','48113','1949-11-12','M','M',':RET:2106-3','N','021','DEN','3215683','33348TX002000201','2014-03-01','2014-02-14 19:14:52','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:34'),(4882,3871,'Y','18','021','EC','A','','','AC','0000500582','0000500582','TX00001119465','IL','1','Blench','Karl','','','','34','028688760','6318 Wilshire Ridge',0,'Houston','TX','77040',NULL,NULL,NULL,'1981-03-24','M','U',NULL,'N','021','DEN','240967','33348TX002000201','2014-01-01','2013-10-10 13:32:48','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:31:15'),(13612,10854,'Y','18','021','EC','A','','','AC','0000035753','0000035753','OH00000832629','IL','1','Mack','Darlene','','','','34','287545061','8062 Hickory Hill Lane',0,'Cincinnati','OH','45241',NULL,'CY','39017','1958-02-18','F','U',':RET:2106-3','N','021','HLT','1712998','92036OH002001201','2014-01-01','2013-12-23 11:44:30','304.00',NULL,NULL,'710.27','406.27','R-OH004','OH0','552.84',NULL,0,'2013-12-26 13:05:38'),(3481,2794,'Y','18','021','EC','A','','','AC','0000137567','0000137567','OH00001120362','S3','1','Watrous','Shawn','','','','34','277045749','1760 HOLLOW RUN DR',0,'COLUMBUS','OH','43223','3413','CY','39049','1999-03-12','M','U',':RET:2106-3','N','021','DEN','1634542','99734OH005000401','2014-01-01','2013-12-22 11:05:02','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-25 21:20:10'),(27734,21931,'Y','18','021','EC','A','','','AC','0000752821','0000752821','TX00003074334','IL','1','Urrutia','Daniela','','','','34','635643831','1376 JAMES DUDLEY DR',0,'EL PASO','TX','79936','7221','CY','48141','1982-10-24','F','M',NULL,'N','021','DEN','3563607','33348TX002000201','2014-04-01','2014-03-05 16:14:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:31:05'),(26270,20837,'Y','18','021','EC','A','','','AC','0000218617','0000218617','TX00002752800','IL','1','DAVILA','EDNA','M','','','34','563434801','317 APODACA PLACE',0,'EL PASO','TX','79907',NULL,'CY','48141','1963-11-15','F','U',NULL,'N','021','DEN','3831904','33348TX002000201','2014-04-01','2014-02-27 17:41:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 06:31:15'),(1697,1416,'Y','18','021','EC','A','','','AC','0000570563','0000570563','OH00000774821','IL','1','KENNEDY','MARK','','','','34','286420221','3014 REDINGTON WOODS RD',0,'TOLEDO','OH','43615','2124','CY','39095','1953-10-22','M','U',NULL,'N','021','HLT','2073899','92036OH004002601','2014-01-01','2013-12-24 11:55:29','183.00',NULL,NULL,'425.53','242.53','R-OH001','OH0','425.53',NULL,0,'2013-12-25 18:54:35'),(1552,1295,'Y','18','021','EC','A','','','AC','0000582217','0000582217','MS00001046244','IL','1','RUDD','JOE','','','','34','428477841','10906 CURTIS RD',0,'BATESVILLE','MS','38606',NULL,'CY','28107','1983-04-04','M','U',':RET:2054-5','N','021','DEN','2439574','46300MS002000201','2014-01-01','2013-12-24 12:04:01','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:50:38'),(1179,971,'Y','18','021','EC','A','','','AC','0000403628','0000403628','OH00001261935','IL','1','THOMAS','TIFFANI','','','','34','282820618','3015 CANFIELD RD',0,'YOUNGSTOWN','OH','44511','2867','CY','39099','1978-12-30','F','U',':RET:2054-5','N','021','DEN','991377','99734OH005000301','2014-01-01','2013-12-02 20:13:27','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:19:20'),(16270,13026,'N','01','021','EC','A',NULL,NULL,'','0000489261','0001143330','','IL','1','boots','sheila','','','','34','295764443','6333 TOWNSHIP ROAD 178',0,'WEST LIBERTY','OH','43357','9578','CY','39091','1974-11-03','F','',':RET:2106-3','N','021','DEN','2172071','99734OH005000401','2014-02-01','2014-01-05 19:20:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:15'),(26085,20687,'Y','18','021','EC','A','','','AC','0001181931','0001181931','LA00002782812','IL','1','Nguyen','Nam','','','','34','456793942','1159 SANTA MARIA DR',0,'MARRERO','LA','70072','2559','CY','22051','1960-12-31','M','M',':RET:2047-9','N','021','DEN','3626002','18575LA002000201','2014-03-01','2014-02-26 22:37:39','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:06'),(2795,2260,'Y','18','021','EC','A','','','AC','0000599559','0000599559','LA00000826246','IL','1','James','Ian','','','','34','519131805','6427 PROVINCE LN',0,'BATON ROUGE','LA','70808','3579','CY','22033','1971-02-25','M','U',NULL,'N','021','DEN','1132933','18575LA002000101','2014-01-01','2013-12-02 16:11:37','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:50:15'),(16963,13577,'Y','18','021','EC','A','','','AC','0000596292','0000596292','OH00002199757','IL','1','Bensie','Lauren','','','','34','294888173','3871 HERMAN RD',0,'MANTUA','OH','44255','9304','CY','39133','1988-03-23','F','U',':RET:2106-3','N','021','HLT','2351051','52664OH151001305','2014-02-01','2014-01-09 16:42:09','105.00',NULL,NULL,'223.90','118.90','R-OH012','OH0','223.90',NULL,0,'2014-01-13 02:20:08'),(24347,19336,'Y','18','021','EC','A','','','AC','0000118295','0000118295','TX00001674187','IL','1','Ochoa','Veronica','','','','34','455477299','11863 Urbici Soler Dr.',0,'El Paso','TX','79936',NULL,'CY','48141','1976-07-30','F','U',':RET:2106-3','N','021','DEN','3374104','33348TX002000201','2014-04-01','2014-02-18 17:11:32','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-18 22:00:24'),(591,486,'Y','18','021','EC','A','','','AC','0000705126','0000705126','OH00001000896','IL','1','PALMER','BRET','STETHEN','','','34','273729250','146 W TALLMADGE AVE',0,'AKRON','OH','44310','2848','CY','39153','1957-09-30','M','U',':RET:2106-3','N','021','DEN','687544','99734OH005000401','2014-01-01','2013-12-15 18:09:56','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:00:03'),(23643,18827,'Y','18','021','EC','A','','','AC','0000805910','0000805910','TX00002809956','IL','1','SANTOS','CELESTE','','','','34','465690846','2813 E NOPAL DR',0,'EDINBURG','TX','78542','0576','CY','48215','1979-11-27','F','M',':RET:2106-3','N','021','DEN','2909042','33348TX002000201','2014-03-01','2014-02-13 21:55:28','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-14 21:30:10'),(2107,1728,'Y','18','021','EC','A','','','AC','0000283231','0000283231','OH00000294622','IL','1','Harris','Brent','','','','34','290729751','2594 BRUNSWICK LN',0,'HUDSON','OH','44236','1475','CY','39153','1976-10-15','M','M',':RET:2106-3','N','021','DEN','846515','99734OH005000401','2014-01-01','2013-12-10 10:21:47','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:17:21'),(18256,14575,'Y','18','021','EC','A','','','AC','0000707239','0000707239','TX00001585371','IL','1','FINCH','EDMOND','','','','34','416981121','2430 NW MILITARY HWY',0,'SAN ANTONIO','TX','78231','2542','CY','48029','1975-11-21','M','R',':RET:2054-5','N','021','DEN','2754300','33348TX002000201','2014-02-01','2014-01-15 16:19:46','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-16 08:44:34'),(6279,4979,'Y','18','024','14','A','','','TE','0000927284','0000927284','','IL','1','miller','randy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-22','M','',NULL,NULL,NULL,'','1024130','','2013-12-10','2013-12-10 20:10:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:45:20'),(3303,2658,'N','01','021','EC','A',NULL,NULL,'','0000658418','0000373628','','IL','1','Brown','Denise','Ann','','','34','269507145','8630 Lawton Dr',0,'Macedonia','OH','44056',NULL,'CY','39153','1951-08-07','F','',NULL,'T','021','DEN','2403811','99734OH005000301','2014-01-01','2013-12-22 12:34:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:44'),(9138,7247,'Y','18','021','EC','A','','','AC','0001138039','0001138039','OH00000738065','IL','1','Deckman','William','','','','34','268465541','13762 HOWELL RD',0,'SAINT MARYS','OH','45885','9753','CY','39011','1949-05-22','M','M',':RET:2106-3','N','021','HLT','1987200','92036OH003001501','2014-01-01','2013-12-18 13:48:16','962.00',NULL,NULL,'1367.95','405.95','R-OH002','OH0','689.49',NULL,0,'2013-12-26 04:08:07'),(692,570,'Y','18','024','14','A','','','TE','0000974069','0000974069','','IL','1','Byers','Chrisann',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-12-28','F','',NULL,NULL,NULL,'','463054','','2013-12-16','2013-12-16 14:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:41'),(6309,5004,'Y','18','021','EC','A','','','AC','0000710112','0000710112','OH00000546275','IL','1','Culbert','Eva','','','','34','587467518','5123 Ryan Rd',0,'toledo','OH','43614',NULL,'CY','39095','1951-10-01','F','U',':RET:2054-5','N','021','DEN','373003','99734OH005000401','2014-01-01','2013-12-11 10:27:43','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:46:06'),(4835,3829,'Y','18','021','EC','A','','','AC','0001011538','0001011538','OH00001130815','IL','1','Rhineberger','Robert','','','','34','301825989','1 PARKRIDGE CT',0,'NORWALK','OH','44857','1910','CY','39077','1971-09-20','M','U',':RET:2106-3','T','021','HLT','1143851','92036OH004002701','2014-01-01','2013-12-08 16:54:45','20.00',NULL,NULL,'238.92','218.92','R-OH006','OH0','238.92',NULL,0,'2013-12-25 22:17:25'),(4718,3740,'N','19','021','EC','A',NULL,NULL,'','0000968206','0000837672','','IL','1','Cooper','Emily','','','','34','285945106','536 CLEMRAY DR',0,'CINCINNATI','OH','45231','2763','CY','39061','1991-11-15','F','',NULL,'N','021','HLT','31700','92036OH005001205','2014-01-01','2013-12-12 13:41:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','214.67',NULL,0,'2013-12-25 22:08:53'),(3916,3134,'Y','18','021','EC','A','','','AC','0000637200','0000637200','TX00000351574','IL','1','maley','emily','','','','34','455915121','4210 Paramount Blvd',0,'Amarillo','TX','79109',NULL,'CY','48381','1977-11-27','F','U',NULL,'N','021','DEN','89589','33348TX002000101','2014-01-01','2013-12-13 15:48:37','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2013-12-25 21:37:15'),(16056,12857,'N','01','021','EC','A',NULL,NULL,'','0000484800','0000364896','','IL','1','LENGEL','BETTY JO','','','','34','302426542','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-06-20','F','',':RET:2106-3','N','021','DEN','1474405','99734OH005000401','2014-02-01','2014-01-03 09:14:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:03:22'),(13177,10511,'Y','18','021','EC','A','','','AC','0000262659','0000262659','TX00000573608','IL','1','Olsheski','Kendrick','','','','34','627129142','26006 S GLENROSE RD',0,'SAN ANTONIO','TX','78260','5335','CY','48029','1985-11-01','M','U',':RET:2106-3','T','021','DEN','2416308','33348TX002000101','2014-01-01','2013-12-22 18:37:10','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 12:54:12'),(14241,11356,'Y','18','021','EC','A','','','AC','0000219112','0000219112','MS00000111853','IL','1','CALLAHAN','HENRIETTA','','','','34','587431431','1299 CEMETERY RD',0,'EDWARDS','MS','39066','9418','CY','28049','1980-05-04','F','U',':RET:2054-5','N','021','DEN','2265105','46300MS002000101','2014-02-01','2013-12-26 16:02:56','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-27 02:05:14'),(17918,14313,'Y','18','021','EC','A','','','AC','0000176461','0000176461','TX00002564149','IL','1','MURILLO','OMAR','','','','34','628187831','1600 W DOVE AVE',0,'MCALLEN','TX','78504','4432','CY','48215','1973-01-14','M','U',NULL,'N','021','DEN','1487894','33348TX002000201','2014-02-01','2014-01-14 10:12:32','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-15 02:06:30'),(18525,14772,'Y','18','021','EC','A','','','AC','0000590941','0000590941','TX00002002518','IL','1','holt','joseph','','','','34','259555920','212 WILLOW CRST',0,'CIBOLO','TX','78108','2376','CY','48187','1979-02-20','M','U',':RET:2106-3','N','021','DEN','1908131','33348TX002000101','2014-02-01','2014-01-15 16:48:32','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-16 08:46:40'),(19302,15387,'Y','18','021','EC','A','','','AC','0001517907','0001517907','LA00001507884','IL','1','ENGLISH','DONALD','RAY','','Sr','34','439046020','3228 PAMPAS STREET',0,'BATON ROUGE','LA','70805',NULL,'CY','22033','1957-05-06','M','M',':RET:2054-5','N','021','DEN','2103306','18575LA002000101','2014-03-01','2014-01-21 11:20:37','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-22 03:22:02'),(22745,18159,'Y','18','021','EC','A','','','AC','0002163509','0002163509','LA00002448070','IL','1','Thomas','Kathy','','','','34','433214293','224 Washington Heights',0,'Clayton','LA','71326',NULL,'CY','22029','1974-09-09','F','U',':RET:2054-5','N','021','DEN','2722107','18575LA002000201','2014-03-01','2014-02-11 17:56:22','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-11 21:01:22'),(7482,5920,'Y','18','021','EC','A','','','AC','0000894608','0000894608','OH00000683446','IL','1','Blevins','Kari','','','','34','271804648','122 S. Vine St.',0,'Convoy','OH','45832',NULL,'CY','39161','1982-01-15','F','M',':RET:2106-3','N','021','DEN','225375','99734OH005000401','2014-01-01','2013-12-15 13:21:30','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 02:31:25'),(6666,5287,'N','01','021','EC','A',NULL,NULL,'','0000866366','0000250551','','IL','1','lau','jung','sim','','','34','456395803','12908 SCOFIELD FARMS DR',0,'AUSTIN','TX','78727','4589','CY','48453','1954-08-30','F','',':RET:2040-4','N','021','DEN','522120','33348TX002000201','2014-01-01','2013-11-16 14:08:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:01:00'),(19884,15860,'N','01','021','EC','A',NULL,NULL,'','0000988914','0000745470','','IL','1','Ferguson','Shurley','','','','34','285600320','326 GAIL AVE NE',0,'MASSILLON','OH','44646','4058','CY','39151','1962-06-26','F','',':RET:2106-3','N','021','HLT','2094591','52664OH151001305','2014-03-01','2014-01-24 15:14:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2014-01-24 21:00:48'),(21556,17220,'Y','18','021','EC','A','','','AC','0000631539','0000631539','OH00002109317','IL','1','Allaer','Paul','','','','34','577117066','9669 Lansford Drive',0,'Cincinnati','OH','45242',NULL,'CY','39061','1960-08-01','M','R',':RET:2106-3','N','021','DEN','2856287','99734OH005000401','2014-03-01','2014-02-05 15:48:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:16'),(22232,17745,'N','01','021','EC','A',NULL,NULL,'','0000217483','0001029292','','IL','1','Golden','Clifford','Malcolm','','','34','628179502','4005 CROCKETT ST',0,'AMARILLO','TX','79110','1106','CY','48381','1966-04-14','M','',':RET:2106-3','N','021','DEN','3051073','33348TX002000101','2014-03-01','2014-02-09 12:40:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-09 19:00:32'),(28916,22886,'Y','18','024','14','A','','','TE','0000022858','0000022858','','IL','1','Robinson','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-24','M','',NULL,NULL,NULL,'','4021324','','2014-03-10','2014-03-10 09:41:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:00:29'),(3236,2606,'Y','18','021','EC','A','','','AC','0000146846','0000146846','OH00000261805','IL','1','Presley','Christopher','','','','34','302821094','17785 Whitney Rd',0,'Strongsville','OH','44136',NULL,'CY','39035','1984-06-12','M','U',NULL,'N','021','DEN','439574','99734OH005000301','2014-01-01','2013-10-06 12:12:00','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:10'),(755,623,'Y','18','021','EC','A','','','AC','0000054236','0000054236','TX00000953699','IL','1','Loven','Vicky','','','','34','451293261','7855 ARROWOOD RD',0,'GILMER','TX','75644','7453','CY','48459','1955-12-17','F','U',':RET:2106-3','N','021','DEN','2071983','33348TX002000201','2014-01-01','2013-12-16 10:53:05','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:04:23'),(861,713,'Y','18','021','EC','A','','','AC','0000201897','0000201897','OH00000871670','31','1','Berry','Laura','M','','','34','302708225','P.O. Box 2485',0,'youngstown','OH','44509',NULL,'CY','39099','1965-09-14','F','M',':RET:2106-3','N','021','HLT','1758833','92036OH002003201','2014-01-01','2013-12-16 08:45:35','745.00',NULL,NULL,'1080.39','335.39','R-OH013','OH0','457.04',NULL,0,'2013-12-25 18:07:11'),(1874,1530,'Y','18','021','EC','A','','','AC','0000062541','0000062541','OH00000825821','IL','1','weletyk','john','','','','34','296584792','52 S GLENCOE DR',0,'AKRON','OH','44319','1768','CY','39153','1961-05-20','M','M',NULL,'T','021','HLT','1630923','52664OH152000901','2014-01-01','2013-12-24 17:00:56','0.00',NULL,NULL,'366.67','366.67','R-OH012','OH0','366.67',NULL,0,'2013-12-25 18:58:22'),(4830,3827,'Y','18','021','EC','A','','','AC','0000909453','0000909453','OH00000644827','IL','1','henry','james','richard','','','34','281841680','124 N Main St',0,'Rawson','OH','45881',NULL,'CY','39063','1970-08-13','M','M',':RET:2106-3','N','021','HLT','413741','92036OH005001505','2014-01-01','2013-12-08 15:38:51','436.00',NULL,NULL,'578.17','142.17','R-OH002','OH0','298.65',NULL,0,'2013-12-25 22:17:20'),(22593,18046,'Y','18','021','EC','A','','','AC','0000315969','0000315969','OH00001716926','IL','1','BENDER','HEATHER','','','','34','283620455','1788 WATERFORD CT',0,'AKRON','OH','44313',NULL,'CY','39153','1970-07-17','F','U',NULL,'N','021','HLT','2985053','52664OH151001501','2014-03-01','2014-02-10 12:56:44','39.00',NULL,NULL,'362.95','323.95','R-OH012','OH0','362.95',NULL,0,'2014-02-10 21:32:10'),(23311,18581,'N','01','021','EC','A',NULL,NULL,'','0000689734','0000121590','','IL','1','Walden','Valerie','','','','34','298689310','405 BANK AVE',0,'CINCINNATI','OH','45217','1214','CY','39061','1960-08-15','F','',':RET:2106-3','N','021','DEN','2721161','99734OH005000301','2014-03-01','2014-02-13 11:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:20'),(23568,18776,'Y','18','021','EC','A','','','AC','0000464794','0000464794','MS00002648290','IL','1','GRIFFIN','CHIQUITA','','','','34','427576617','3340 PATTERSON DRIVE',0,'PEARL','MS','39208',NULL,'CY','28121','1987-07-15','F','U',':RET:2054-5','N','021','DEN','3352641','46300MS002000201','2014-03-01','2014-02-13 13:19:21','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-13 22:02:49'),(24917,19757,'Y','18','021','EC','A','','','AC','0001104503','0001104503','OH00002298149','IL','1','BOWERS','GLENN','','','','34','296428644','818 TALLMADGE RD',0,'CUYAHOGA FALLS','OH','44221','5016','CY','39153','1952-10-17','M','U',':RET:2106-3','N','021','HLT','3819593','52664OH151001305','2014-03-01','2014-02-20 14:04:21','496.00',NULL,NULL,'626.65','130.65','R-OH012','OH0','626.65','CIC',0,'2014-02-20 21:30:11'),(27468,21738,'Y','18','021','EC','A','','','AC','0000569378','0000569378','OH00002762857','IL','1','Smith','Christopher','','','','34','293822995','6544 STATE ROUTE 132',0,'GOSHEN','OH','45122','9354','CY','39025','1984-12-15','M','U',':RET:2106-3','N','021','HLT','3719059','92036OH003000606','2014-04-01','2014-03-04 16:46:47','125.00',NULL,NULL,'250.85','125.85','R-OH005','OH0','250.85',NULL,0,'2014-03-04 21:02:09'),(28282,22380,'Y','18','021','EC','A','','','AC','0000019532','0000019532','LA00003155172','IL','1','Skef Promoslovsky','Natalia','Deborah','','','34','661057200','2404 JENA ST',0,'NEW ORLEANS','LA','70115','5908','CY','22071','1978-03-03','F','M',':RET:2106-3','N','021','DEN','3921794','18575LA002000201','2014-04-01','2014-03-07 09:57:21','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61','CIC',0,'2014-03-07 21:00:25'),(4945,3924,'Y','18','021','EC','A','','','AC','0000213349','0000213349','OH00001014827','IL','1','Domin','Maria','','','','34','009782194','900 Cove Point Dr.',0,'Columbus','OH','43228',NULL,'CY','39049','1956-03-30','F','U',':RET:2106-3','N','021','DEN','117747','99734OH005000401','2014-01-01','2013-12-07 14:19:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:45:47'),(17502,13995,'Y','18','021','EC','A','','','AC','0000644689','0000644689','OH00001813742','IL','1','Krisha','Nora','','','','34','279867150','3207 FITCHVILLE RIVER RD',0,'WAKEMAN','OH','44889','9320','CY','39077','1976-01-27','F','M',':RET:2106-3','N','021','HLT','2022799','92036OH003002706','2014-02-01','2014-01-12 16:49:02','571.00',NULL,NULL,'617.42','46.42','R-OH006','OH0','253.74',NULL,0,'2014-01-13 03:01:26'),(14359,11452,'Y','18','021','EC','A','','','AC','0000607163','0000607163','OH00000054403','IL','1','SAMAS','MICHAEL','','','','34','274864114','5963 SPRINGWOOD DR',0,'MENTOR','OH','44060','2839','CY','39085','1979-04-27','M','M',NULL,'N','021','DEN','1693430','99734OH005000401','2014-02-01','2013-12-26 19:27:38','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:14'),(13235,10560,'Y','18','021','EC','A','','','AC','0001025646','0001025646','TX00000327233','IL','1','Duncan','Neal','','','','34','602098702','2704 BARTONS BLUFF LN',0,'AUSTIN','TX','78746','7944','CY','48453','1987-12-21','M','U',':RET:2034-7^:RET:2106-3','N','021','DEN','1981546','33348TX002000201','2014-01-01','2013-12-22 22:59:03','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:55:53'),(19080,15201,'Y','18','021','EC','A','','','AC','0000267556','0000267556','OH00001649459','IL','1','BERRY','THOMAS','','','','34','268620255','289 BAYVIEW RD',0,'BAY VILLAGE','OH','44140',NULL,'CY','39035','1954-04-06','M','U',':RET:2106-3','N','021','DEN','3096608','99734OH005000401','2014-03-01','2014-01-18 09:42:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:44:25'),(24791,19662,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000141486','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','283049387','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1999-07-16','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:46:49'),(28306,22397,'Y','18','024','14','A','','','TE','0000784935','0000784935','','IL','1','Ingram','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-25','F','',NULL,NULL,NULL,'','3202671','','2014-03-31','2014-03-07 16:02:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-03-07 21:00:34'),(4919,3903,'Y','18','021','EC','A','','','AC','0000195106','0000195106','OH00000903264','IL','1','McLaughlin','Yvonne','','','','34','291443471','2959 PREMAE DR',0,'AKRON','OH','44312','5551','CY','39153','1950-09-03','F','M',':RET:2106-3','N','021','HLT','537076','52664OH151001301','2014-01-01','2013-12-07 16:57:41','335.00',NULL,NULL,'658.32','323.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 22:45:07'),(293,242,'Y','18','021','EC','A','','','AC','0000993933','0000993933','OH00001085989','IL','1','CLAY','TERRY','','','','34','268581631','2265  Benson Dr.',0,'Dayton','OH','45406',NULL,'CY','39113','1955-07-08','F','U',NULL,'T','021','DEN','835305','99734OH005000401','2014-01-01','2013-11-13 07:58:37','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:30:37'),(8975,7118,'Y','18','021','EC','A','','','AC','0000969424','0000969424','OH00001098602','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','DEN','2042976','99734OH005000401','2014-01-01','2013-12-18 15:24:34','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:04:09'),(6995,5551,'N','01','021','EC','A',NULL,NULL,'','0001153852','0001194170','','IL','1','Gomes','Aaron','','','','34','038542417','1737 Oates Dr',0,'Mesquite','TX','75150',NULL,'CY','48113','1985-12-09','M','',':RET:2054-5','T','021','DEN','1621101','33348TX002000201','2014-01-01','2013-12-24 18:32:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:48:06'),(2698,2185,'N','19','021','EC','A',NULL,NULL,'','0000867535','0001030172','','IL','1','ruiz','ariel','','','','34','627320298','321 SUNSET DR',0,'MARBLE FALLS','TX','78654','1430','CY','48053','1992-03-30','F','',':RET:2106-3','N','021','DEN','38414','33348TX002000201','2014-01-01','2013-12-02 15:41:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:47:40'),(8899,7056,'N','01','021','EC','A',NULL,NULL,'','0001188775','0000889591','','IL','1','HURLEY','GEORGE','','','','34','282621152','21 SWANGER AVE',0,'MANSFIELD','OH','44902','7844','CY','39139','1960-01-29','M','',':RET:2106-3','N','021','DEN','2236492','99734OH005000401','2014-01-01','2013-12-17 18:32:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:13'),(1243,1023,'Y','18','024','14','A','','','TE','0000642041','0000642041','','IL','1','Heskamp','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-22','M','',NULL,NULL,NULL,'','140382','','2013-12-03','2013-12-03 09:09:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:21:00'),(21632,17272,'Y','18','021','EC','A','','','AC','0000550795','0000550795','TX00001716835','IL','1','Valenta','Timothy','','','','34','449316301','4029 WINDMILL RIDGE CIR',0,'OVILLA','TX','75154','5552','CY','48139','1965-11-19','M','M',':RET:2106-3','N','021','DEN','2625035','33348TX002000201','2014-03-01','2014-02-05 11:51:17','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-05 21:30:41'),(22707,18133,'Y','18','021','EC','A','','','AC','0001896717','0001896717','LA00002398020','IL','1','BELL','RUDY','LEE','','','34','434411215','1406 ALABAMA AVE',0,'BASTROP','LA','71220','4010','CY','22067','1978-06-03','M','U',':RET:2054-5','N','021','DEN','3356288','18575LA002000201','2014-03-01','2014-02-10 20:24:56','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-11 21:01:02'),(22833,18219,'Y','18','021','EC','A','','','AC','0001118764','0001118764','OH00001979282','IL','1','Zanella','Vicki','','','','34','277501443','545 E MAPLE ST',0,'HARTVILLE','OH','44632','8840','CY','39151','1954-03-15','F','M',':RET:2106-3','N','021','HLT','3583543','52664OH151001304','2014-03-01','2014-02-11 13:15:48','850.00',NULL,NULL,'1238.81','388.81','R-OH015','OH0','580.49',NULL,0,'2014-02-11 21:02:09'),(24151,19189,'Y','18','021','EC','A','','','AC','0000982754','0000982754','OH00002777728','IL','1','Jacques','Michael','','','','34','294905189','2304 ohio ave',0,'Cincinnati','OH','45219',NULL,'CY','39061','1984-09-20','M','U',':RET:2106-3','T','021','HLT','3019576','92036OH004001201','2014-03-01','2014-02-15 11:27:22','0.00',NULL,NULL,'222.12','222.12','R-OH004','OH0','222.12',NULL,0,'2014-02-15 22:01:56'),(25223,20007,'Y','18','021','EC','A','','','AC','0000246501','0000246501','OH00002355341','IL','1','MCMILLION','EDWIN','','','','34','278543511','257 HILLSDALE CIR',0,'WADSWORTH','OH','44281','1007','CY','39103','1963-10-18','M','M',NULL,'N','021','HLT','2647888','52664OH151001306','2014-04-01','2014-02-21 10:34:58','729.00',NULL,NULL,'874.41','145.41','R-OH012','OH0','398.29',NULL,0,'2014-02-21 22:00:58'),(1006,824,'N','01','021','EC','A',NULL,NULL,'','0001019686','0001020820','','IL','1','reed','johnny','m','','','34','464271039','2584 COUNTY ROAD 2995',0,'HUGHES SPRINGS','TX','75656','6196','CY','48067','1958-07-01','M','',':RET:2080-0','N','021','DEN','671828','33348TX002000201','2014-01-01','2013-10-19 17:28:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:11:06'),(18094,14453,'Y','18','021','EC','A','','','AC','0001931756','0001931756','LA00001816143','IL','1','Lee','Trinette','','','','34','561332481','5208 HIGHWAY 90 E',0,'NEW IBERIA','LA','70560','9001','CY','22045','1969-10-03','F','U',':RET:2054-5','N','021','DEN','2798195','18575LA002000201','2014-02-01','2014-01-14 12:58:43','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-15 02:07:31'),(16111,12905,'Y','18','021','EC','A','','','AC','0000261898','0000261898','MS00002226654','IL','1','gillman','richard','','','','34','189425254','1200 mill road',0,'gulfport','MS','39507',NULL,'CY','28047','1951-10-23','M','M',':RET:2106-3','N','021','DEN','1614601','46300MS002000101','2014-02-01','2014-01-03 15:18:35','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-04 02:05:04'),(6726,5336,'Y','18','021','EC','A','','','AC','0000849407','0000849407','OH00001000484','IL','1','Reece','Neva','','','','34','270508102','400 TRAILWOOD DR',0,'PAINESVILLE','OH','44077','2806','CY','39085','1952-08-11','F','U',':RET:2106-3','N','021','DEN','47141','99734OH005000401','2014-01-01','2013-11-24 19:52:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:15:22'),(19473,15521,'N','01','021','EC','A',NULL,NULL,'','0000396226','0000222019','','IL','1','Garcia','Mario','Alberto','','','34','450610677','115 Ismael Jr St.',0,'Sullivan City','TX','78595',NULL,'CY','48215','1962-09-26','M','',NULL,'N','021','DEN','2318712','33348TX002000201','2014-03-01','2014-01-21 18:42:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 03:02:00'),(23779,18922,'Y','18','024','14','A','','','TE','0000743192','0000743192','','IL','1','Wiggins','Tiffany',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-07','F','',NULL,NULL,NULL,'','3620666','','2014-02-14','2014-02-14 12:50:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-14 21:31:18'),(24238,19248,'Y','18','021','EC','A','','','AC','0000472297','0000472297','OH00002195523','IL','1','Clutter','Brian','','','','34','301864830','2357 WALES AVE',0,'LIMA','OH','45805','3449','CY','39003','1982-06-27','M','M',':RET:2106-3','N','021','HLT','3712360','92036OH003001506','2014-03-01','2014-02-15 21:33:06','474.00',NULL,NULL,'507.24','33.24','R-OH002','OH0','266.38',NULL,0,'2014-02-16 19:00:38'),(26594,21085,'Y','18','021','EC','A','','','AC','0000709003','0000709003','OH00003224183','IL','1','Klein','Karon','','','','34','283660484','168 E ROSEWOOD AVE',0,'AKRON','OH','44301','2545','CY','39153','1958-05-25','F','M',':RET:2106-3','T','021','HLT','2823456','52664OH152000901','2014-04-01','2014-02-28 15:23:52','352.00',NULL,NULL,'418.89','66.89','R-OH012','OH0','418.89',NULL,0,'2014-02-28 21:30:37'),(18287,14600,'Y','18','021','EC','A','','','AC','0001165357','0001165357','OH00002222307','IL','1','ROBINSON','RAYMOND','','','','34','272728965','283 Washington Ave.',0,'Elyria','OH','44035',NULL,'CY','39093','1963-06-17','M','M',':RET:2054-5','N','021','DEN','2575415','99734OH005000401','2014-02-01','2014-01-14 20:18:40','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:44:50'),(16986,13595,'Y','18','021','EC','A','','','AC','0001210808','0001210808','TX00001315625','IL','1','Robinson','Dominique','','','','34','456794604','3200 Ross Ave Unit 24',0,'Dallas','TX','75204',NULL,'CY','48113','1978-02-22','F','U',':RET:2054-5','N','021','DEN','2127564','33348TX002000101','2014-02-01','2014-01-09 12:03:28','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-13 02:20:21'),(16731,13390,'N','19','021','EC','A',NULL,NULL,'','0000142840','0000049509','','S1','1','Marty','Michael','','','','34','289112248','2156 Steiner rd',0,'Creston','OH','44217',NULL,'CY','39169','2005-11-11','M','',':RET:2106-3','N','021','HLT','2533888','52664OH151001301','2014-02-01','2014-01-07 16:56:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:50'),(7721,6114,'N','01','021','EC','A',NULL,NULL,'','0000640917','0000956637','','IL','1','Rowe','Sara','','','','34','286848165','1551 WILDON AVE',0,'AKRON','OH','44306','3360','CY','39153','1983-02-28','F','',NULL,'N','021','DEN','2216763','99734OH005000401','2014-01-01','2013-12-20 13:46:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:44'),(7493,5928,'Y','18','021','EC','A','','','AC','0001235157','0001235157','OH00000873892','IL','1','Kleinpaste','Todd','','','','34','272906521','2360 Glenmawr Ave',0,'Columbus','OH','43202',NULL,'CY','39049','1983-05-29','M','M',':RET:2106-3','T','021','DEN','1255667','99734OH005000401','2014-01-01','2013-12-15 15:03:38','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:41'),(16095,12891,'Y','18','021','EC','A','','','AC','0000623985','0000623985','OH00000778899','IL','1','HUTCHINSON','JASON','','','','34','271707457','3256 N REACH DR',0,'OREGON','OH','43616','2370','CY','39095','1976-01-24','M','U',':RET:2106-3','N','021','HLT','2325819','92036OH006002601','2014-02-01','2014-01-02 20:29:18','153.00',NULL,NULL,'192.70','39.70','R-OH001','OH0','192.70',NULL,0,'2014-01-04 02:04:35'),(15686,12548,'Y','18','021','EC','A','','','AC','0000153379','0000153379','OH00002091022','IL','1','harrison','danette','','','','34','299601835','1347Longacre dr',0,'Cincinatti','OH','45240',NULL,'CY','39061','1965-02-18','F','U',':RET:2106-3','T','021','HLT','2322191','92036OH006001201','2014-02-01','2013-12-31 16:06:00','116.00',NULL,NULL,'320.11','204.11','R-OH004','OH0','320.11',NULL,1,'2014-01-02 04:35:12'),(5284,4187,'Y','18','021','EC','A','','','AC','0000948405','0000948405','OH00001075130','IL','1','CASTON','ANNE','','','','34','284729234','2042 DEMING ST',0,'CUYAHOGA FALLS','OH','44221','4132','CY','39153','1960-12-28','F','U',':RET:2106-3','N','021','HLT','2299288','52664OH151001306','2014-01-01','2013-12-19 15:12:16','368.00',NULL,NULL,'454.94','86.94','R-OH012','OH0','454.94',NULL,0,'2013-12-25 23:05:51'),(1227,1010,'Y','18','021','EC','A','','','AC','0000805086','0000805086','OH00000857626','IL','1','Stroll','Jeffrey','','','','34','274745800','812 INDUSTRY RD',0,'ATWATER','OH','44201','7107','CY','39133','1978-06-28','M','U',NULL,'N','021','HLT','433278','52664OH151001301','2014-01-01','2013-12-03 16:15:57','0.00',NULL,NULL,'272.52','272.52','R-OH012','OH0','272.52',NULL,0,'2013-12-25 18:20:35'),(5253,4167,'Y','18','021','EC','A','','','AC','0000571987','0000571987','OH00000026639','IL','1','Thomas','Ronald','','','','34','270504177','4666 Rockcut rd',0,'Norton','OH','44203',NULL,'CY','39153','1952-02-15','M','M',':RET:2106-3','N','021','HLT','2396534','52664OH151001305','2014-01-01','2013-12-19 09:58:31','435.00',NULL,NULL,'626.65','191.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 23:05:11'),(2276,1857,'N','19','021','EC','A',NULL,NULL,'','0001085590','0000280810','','IL','1','Dunn','Paul','Kenneth Ray',NULL,NULL,NULL,NULL,'515 Martha Drive',0,'Franklin','OH','45005',NULL,'CY','39165','1999-02-13','M','',':RET:2106-3','N','021','DEN','623334','99734OH005000301','2014-01-01','2013-12-09 12:09:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:28'),(4971,3947,'Y','18','021','EC','A','','','AC','0000866386','0000866386','TX00000604611','IL','1','Tennant','Kristy','','','','34','457614437','2112 Drake Dr',0,'Richardson','TX','75081',NULL,'CY','48113','1978-06-20','F','M',':RET:2106-3','N','021','DEN','997854','33348TX002000201','2014-01-01','2013-12-06 19:23:32','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:46:26'),(16968,13582,'Y','18','021','EC','A','','','AC','0000564220','0000564220','OH00001665375','IL','1','Murdocco','Antonio','','','','34','288580070','340 Waterloo Rd',0,'Mogadore','OH','44260',NULL,'CY','39133','1955-07-01','M','M',':RET:2106-3','N','021','HLT','2189827','52664OH151001306','2014-02-01','2014-01-09 17:01:23','955.00',NULL,NULL,'1088.50','133.50','R-OH012','OH0','568.22',NULL,0,'2014-01-13 02:20:12'),(22717,18140,'Y','18','021','EC','A','','','AC','0001727906','0001727906','LA00002722978','IL','1','Calmes','Margaret','','','','34','439612834','2427 LAHARPE ST',0,'NEW ORLEANS','LA','70119','2425','CY','22071','1986-01-03','F','U',NULL,'N','021','DEN','3633439','18575LA002000201','2014-03-01','2014-02-11 10:52:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:08'),(19648,15658,'Y','18','021','EC','A','','','AC','0000519865','0000519865','OH00002565673','IL','1','Cooksey','Brandy','','','','34','287861316','200 CONCORD AVE',0,'HEATH','OH','43056','1418','CY','39089','1976-12-05','F','U',':RET:2106-3','N','021','DEN','3339234','99734OH005000401','2014-03-01','2014-01-23 12:20:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:18'),(15666,12535,'Y','18','021','EC','A','','','AC','0000848360','0000848360','OH00000210799','IL','1','Wilson','Charolette','','','','34','262529317','65 FULTON ST',0,'WILMINGTON','OH','45177','1606','CY','39027','1951-10-02','F','M',NULL,'N','021','HLT','1741285','92036OH001000601','2014-02-01','2013-12-30 23:09:36','310.00',NULL,NULL,'743.93','433.93','R-OH005','OH0','743.93',NULL,1,'2014-01-02 04:34:37'),(15194,12142,'Y','18','021','EC','A','','','AC','0000336205','0000336205','MS00001420099','IL','1','HOWARD','KATIE','','','','34','587347326','6 PINE ST',0,'HATTIESBURG','MS','39402','9670','CY','28035','1951-05-01','F','U',':RET:2054-5','N','021','DEN','2196455','46300MS002000201','2014-02-01','2013-12-29 21:40:24','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-01 12:07:12'),(24084,19150,'Y','18','021','EC','A','','','AC','0000106758','0000106758','OH00002144126','IL','1','Jassem','Jennifer','','','','34','297784779','1615 NEWMAN AVE',0,'LAKEWOOD','OH','44107','5260','CY','39035','1981-10-21','F','M',NULL,'N','021','HLT','3792620','52664OH151001305','2014-03-01','2014-02-15 13:54:49','136.00',NULL,NULL,'297.55','161.55','R-OH011','OH0','297.55',NULL,0,'2014-02-15 22:01:23'),(3087,2481,'Y','18','021','EC','A','','','AC','0000974060','0000974060','OH00000337700','IL','1','Clark','Donna','','','','34','280485244','4984 MCKAY RD',0,'BATAVIA','OH','45103','8642','CY','39025','1949-06-19','F','M',':RET:2106-3','N','021','HLT','929996','92036OH006000601','2014-01-01','2013-12-06 12:43:06','428.00',NULL,NULL,'510.73','82.73','R-OH005','OH0','510.73',NULL,0,'2013-12-25 20:19:53'),(9029,7164,'Y','18','024','14','A','','','TE','0000120057','0000120057','','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-06','F','',NULL,NULL,NULL,'','769343','','2013-12-18','2013-12-18 10:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:31'),(19109,15225,'Y','18','024','14','A','','','TE','0001074165','0001074165','','IL','1','Mize','Cindy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-03-01','F','',NULL,NULL,NULL,'','1540283','','2014-01-18','2014-01-18 11:58:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:44:43'),(20742,16572,'Y','18','021','EC','A','','','AC','0000318443','0000318443','OH00002182412','IL','1','Kennedy','Donna','','','','34','275662788','910 WALLS LAKE DR NE',0,'VIENNA','OH','44473','9739','CY','39155','1958-06-25','F','U',':RET:2106-3','T','021','HLT','3217486','92036OH005003206','2014-03-01','2014-01-30 08:20:03','477.00',NULL,NULL,'620.75','143.75','R-OH013','OH0','620.75',NULL,0,'2014-01-30 21:01:24'),(18663,14878,'Y','18','021','EC','A','','','AC','0001046494','0001046494','TX00001411993','IL','1','VARGAS','ROSA','','','','34','372568585','713 S VICTORIA RD',0,'DONNA','TX','78537','5537','CY','48215','1955-09-22','F','U',NULL,'N','021','DEN','2307416','33348TX002000201','2014-03-01','2014-01-16 16:10:18','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-17 03:35:14'),(6308,5003,'N','01','021','EC','A',NULL,NULL,'','0000798399','0001248309','','IL','1','Cordray','Ernest','','','','34','276581810','282 CLOUSE LN',0,'GRANVILLE','OH','43023','1492','CY','39089','1955-03-06','M','',NULL,'N','021','DEN','626842','99734OH005000401','2014-01-01','2013-12-11 10:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:05'),(18245,14564,'Y','18','021','EC','A','','','AC','0001041452','0001041452','TX00001770826','IL','1','Fodell','Nanette','','','','34','465295641','807 S AVENUE J',0,'MARBLE FALLS','TX','78654','6228','CY','48053','1959-02-09','F','U',':RET:2106-3','N','021','DEN','2562195','33348TX002000201','2014-02-01','2014-01-15 12:53:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:27'),(4236,3373,'Y','18','021','EC','A','','','AC','0000964547','0000964547','TX00000824078','IL','1','Rodriguez','Paul','','','','34','453493758','3926 KINGSTON DR',0,'CORPUS CHRISTI','TX','78415','3326','CY','48355','1973-07-26','M','U',':RET:2106-3','N','021','DEN','1494759','33348TX002000201','2014-01-01','2013-12-17 14:07:25','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 21:50:52'),(24767,19650,'N','01','021','EC','A',NULL,NULL,'','0000947441','0000807554','','IL','1','GARZA','RICHARD','','','','34','302782700','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-11-19','M','',NULL,'T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:43:42'),(23894,19007,'Y','18','021','EC','A','','','AC','0000241565','0000241565','OH00002445703','IL','1','Wardrup','Carl',NULL,NULL,NULL,NULL,NULL,'4641 Melody Lane',0,'Cincinatti','OH','45245',NULL,'CY','39025','1954-11-26','M','M',NULL,'N','021','HLT','3473564','92036OH004000601','2014-03-01','2014-02-14 16:00:16','712.00',NULL,NULL,'917.78','205.78','R-OH005','OH0','449.32',NULL,0,'2014-02-14 21:32:20'),(13619,10859,'Y','18','021','EC','A','','','AC','0000923323','0000923323','OH00001311531','IL','1','SEIBERT','FREDERIC','','','','34','297488752','2139 BROADHURST AVE',0,'CINCINNATI','OH','45240','1413','CY','39061','1950-05-27','M','M',':RET:2106-3','N','021','HLT','1365513','92036OH002001201','2014-01-01','2013-12-23 16:33:47','701.00',NULL,NULL,'1463.62','762.62','R-OH004','OH0','731.81',NULL,0,'2013-12-26 13:05:48'),(28501,22553,'Y','18','021','EC','A','','','AC','0001100651','0001100651','OH00003119145','IL','1','Mallardi','Chloe','','','','34','283946661','1171 PITKIN AVE',0,'AKRON','OH','44310','1120','CY','39153','1991-08-05','F','U',':RET:2106-3','N','021','HLT','3591399','52664OH151001306','2014-04-01','2014-03-06 20:30:48','154.00',NULL,NULL,'223.01','69.01','R-OH012','OH0','223.01',NULL,0,'2014-03-07 21:31:48'),(26050,20660,'Y','18','021','EC','A','','','AC','0000057388','0000057388','OH00003004668','IL','1','Coull','Elaine','','','','34','299522792','12444 SNODE ST NE',0,'ALLIANCE','OH','44601','8859','CY','39151','1954-07-16','F','M',NULL,'N','021','HLT','3535590','52664OH151001304','2014-04-01','2014-02-26 17:30:33','80.00',NULL,NULL,'580.49','500.49','R-OH015','OH0','580.49',NULL,0,'2014-02-26 21:02:32'),(24431,19407,'Y','18','021','EC','A','','','AC','0000775139','0000775139','OH00002387810','IL','1','Black','Renee','','','','34','301868031','1480 MAPLE ST',0,'BARBERTON','OH','44203','7616','CY','39153','1982-09-03','F','U',NULL,'N','021','HLT','2846735','52664OH151001305','2014-04-01','2014-02-18 12:55:47','154.00',NULL,NULL,'258.47','104.47','R-OH012','OH0','258.47',NULL,0,'2014-02-18 22:01:13'),(15167,12121,'Y','18','021','EC','A','','','AC','0001192681','0001192681','OH00001744605','IL','1','Smith','Stephanie','','','','34','276849834','308 S APPLE ST',0,'GEORGETOWN','OH','45121','1534','CY','39015','1985-10-29','F','M',':RET:2106-3','T','021','DEN','2292399','99734OH005000401','2014-02-01','2013-12-30 15:07:48','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-01-01 12:06:26'),(4966,3942,'Y','18','021','EC','A','','','AC','0000604128','0000604128','TX00000928258','IL','1','Pittard','Theresa','Louise','','','34','013527796','5750 Maquita Ave',0,'Dallas','TX','75206',NULL,'CY','48113','1957-12-02','F','U',':RET:2106-3','N','021','DEN','299358','33348TX002000201','2014-01-01','2013-12-06 18:42:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:46:17'),(2365,1929,'Y','18','021','EC','A','','','AC','0000168857','0000168857','OH00000213532','IL','1','CALCO','PETE','','','','34','278521467','3615 KENT RD',0,'STOW','OH','44224','4603','CY','39153','1956-08-13','M','U',':RET:2106-3','N','021','DEN','140542','99734OH005000401','2014-01-01','2013-12-09 07:54:35','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:32:36'),(15102,12071,'Y','18','021','EC','A','','','AC','0001081806','0001081806','OH00001616090','IL','1','Lawson','Katariina','','','','34','277528183','24383 Smith Avenue',0,'Westlake','OH','44145',NULL,'CY','39035','1953-08-04','F','M',NULL,'N','021','DEN','1737808','99734OH005000301','2014-02-01','2013-12-30 09:25:01','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:04:44'),(14659,11701,'Y','18','024','14','A','','','TE','0000815620','0000815620','','IL','1','Flores','Rene',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-01','M','',NULL,NULL,NULL,'','1922644','','2013-12-27','2013-12-27 22:33:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:07:56'),(14285,11395,'Y','18','024','14','A','','','TE','0001137289','0001137289','','IL','1','Earls','Latonya',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-11-10','F','',NULL,NULL,NULL,'','1529359','','2013-12-26','2013-12-26 17:21:53',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-27 02:06:25'),(7459,5902,'Y','18','021','EC','A','','','AC','0000499299','0000499299','OH00000650177','IL','1','Westerfield','Phyllis','','','','34','288483045','1669 TUTTLE AVE',0,'DAYTON','OH','45403','3425','CY','39113','1960-09-18','F','U',':RET:2106-3','T','021','DEN','729975','99734OH005000301','2014-01-01','2013-12-15 15:58:32','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:30:52'),(7527,5958,'Y','18','021','EC','A','','','AC','0000516678','0000516678','TX00001051255','IL','1','Hoffman','Bryan','','','','34','513927737','4800 Brookdale Dr.',0,'Wichita Falls','TX','76310',NULL,'CY','48485','1987-02-03','M','M',':RET:2106-3','N','021','DEN','1130877','33348TX002000201','2014-01-01','2013-12-14 20:49:12','0.00',NULL,NULL,'31.70','31.70','R-TX025','TX0','15.85',NULL,0,'2013-12-26 02:32:35'),(13270,10591,'Y','18','021','EC','A','','','AC','0000505502','0000505502','TX00001311491','IL','1','Huffman','Edward','Raymond','','','34','450028922','502 Bowie St',0,'Santa Anna','TX','76878',NULL,'CY','48083','1952-08-06','M','U',':RET:2106-3','N','021','DEN','1901080','33348TX002000201','2014-01-01','2013-12-23 12:24:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:52'),(20670,16518,'Y','18','021','EC','A','','','AC','0000374650','0000374650','MS00002176513','31','1','Kimburbrough','Kimberly','','','','34','587211125','P. O. Box 227',0,'Startville','MS','39760',NULL,'CY','28105','1968-07-18','F','U',NULL,'N','021','DEN','3132756','46300MS002000201','2014-03-01','2014-01-30 13:20:43','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-30 21:00:49'),(13234,10559,'Y','18','021','EC','A','','','AC','0001261823','0001261823','TX00000404629','IL','1','roos','kathryn','','','','34','459904473','5819 TAMMY DR',0,'MANVEL','TX','77578','3155','CY','48039','1965-12-15','F','U',':RET:2106-3','N','021','DEN','2028195','33348TX002000201','2014-01-01','2013-12-22 22:56:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:55:51'),(17455,13958,'N','19','021','EC','A',NULL,NULL,'','0001005730','0001131463','','IL','1','Kennedy','Josiah',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','2007-11-21','M','',':RET:2106-3','N','021','HLT','1835802','92036OH002000601','2014-02-01','2014-01-10 14:33:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-13 03:00:40'),(17893,14292,'Y','18','021','EC','A','','','AC','0000880542','0000880542','OH00002145821','IL','1','Mcbeath','Miranda','','','','34','317984481','1877 LARAMIE DR',0,'POWELL','OH','43065','7504','CY','39049','1982-06-01','F','M',':RET:2106-3','N','021','DEN','2124356','99734OH005000401','2014-02-01','2014-01-14 16:54:35','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:20'),(19143,15251,'N','01','021','EC','A',NULL,NULL,'','0000632500','0000640031','','IL','1','AGUIRRE','JOSE','A','','','34','458277451','13033 PERICO DR',0,'SAN ELIZARIO','TX','79849','9509','CY','48141','1957-04-25','M','',NULL,'N','021','DEN','1877204','33348TX002000201','2014-03-01','2014-01-19 17:22:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:45:29'),(25226,20009,'Y','18','021','EC','A','','','AC','0000307144','0000307144','OH00002755000','IL','1','Manuppella','Mark','','','','34','274564920','3352 Hines',0,'Kingsville','OH','44048',NULL,'CY','39007','1953-06-29','M','U',':RET:2106-3','N','021','HLT','3726675','52664OH151001305','2014-04-01','2014-02-21 13:04:23','605.00',NULL,NULL,'682.62','77.62','R-OH011','OH0','682.62',NULL,0,'2014-02-21 22:00:59'),(7509,5940,'N','01','021','EC','A',NULL,NULL,'','0000409956','0000596986','','IL','1','GASPER','THOMAS','J','','IV','34','437674106','1228 LEE ST',0,'MARRERO','LA','70072','2346','CY','22051','1977-06-18','M','',':RET:2054-5','N','021','DEN','1113533','18575LA002000201','2014-01-01','2013-12-14 23:05:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 02:32:03'),(25177,19971,'Y','18','021','EC','A','','','AC','0000762339','0000762339','OH00002347457','IL','1','Newman','Robert','','','','34','292904386','1604 TAYLOR AVE',0,'MIDDLETOWN','OH','45044','5937','CY','39017','1989-09-22','M','M',':RET:2106-3','N','021','DEN','3835478','99734OH005000401','2014-04-01','2014-02-21 12:40:29','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-21 22:00:32'),(7126,5655,'Y','18','021','EC','A','','','AC','0000553152','0000553152','MS00000381713','IL','1','Witcher','John','','','','34','428337929','146 E WATERWOOD DR',0,'BRANDON','MS','39047','6527','CY','28121','1966-04-11','M','U',':RET:2106-3','N','021','DEN','1436880','46300MS002000201','2014-02-01','2013-12-25 14:19:07','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 01:51:29'),(21400,17102,'Y','18','024','14','A','','','TE','0000552661','0000552661','','IL','1','Mason','Eric',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-15','M','',NULL,NULL,NULL,'','3762814','','2014-02-04','2014-02-04 12:45:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:02'),(20161,16090,'Y','18','021','EC','A','','','AC','0000600828','0000600828','OH00001394622','IL','1','KONCAN','RUSSELL','J','','','34','293567548','5554 MILLWOOD DR',0,'BROADVIEW HEIGHTS','OH','44147','2246','CY','39035','1959-06-26','M','M',':RET:2106-3','N','021','DEN','3238156','99734OH005000301','2014-03-01','2014-01-27 15:39:49','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:01:10'),(2934,2362,'Y','18','021','EC','A','','','AC','0001138022','0001138022','OH00000283478','IL','1','Raubenolt','Douglas','','','','34','301566168','276 TOWNSHIP ROAD 2450',0,'LOUDONVILLE','OH','44842','9624','CY','39005','1954-10-18','M','M',':RET:2106-3','N','021','DEN','260208','99734OH005000401','2014-01-01','2013-12-05 22:42:48','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:16:05'),(4958,3935,'N','01','021','EC','A',NULL,NULL,'','0000998137','0000874608','','IL','1','Pham','Thach','','','','34','659140621','1041 MICHAEL ST',0,'MARRERO','LA','70072','2636','CY','22051','1949-07-25','M','',':RET:2047-9','N','021','DEN','1205719','18575LA002000201','2014-01-01','2013-12-06 21:56:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:46:06'),(28799,22796,'Y','18','021','EC','A','','','AC','0000022858','0000022858','OH00003488628','IL','1','Robinson','James','','','','34','288583556','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1955-12-24','M','M',':RET:2106-3','N','021','DEN','4021324','99734OH005000301','2014-05-01','2014-03-09 10:14:28','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-03-09 21:00:47'),(6987,5544,'Y','18','021','EC','A','','','AC','0000728714','0000728714','OH00001152362','IL','1','Bauer','Richard','','','','34','302527820','870 Oak canyon Drive',0,'Loveland','OH','45140',NULL,'CY','39061','1952-10-01','M','M',':RET:2106-3','N','021','DEN','2495737','99734OH005000401','2014-02-01','2013-12-25 00:45:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:52'),(1113,916,'Y','18','021','EC','A','','','AC','0000650747','0000650747','OH00000316881','IL','1','larr','mike','','','','34','279702009','11415 sarchet ln',0,'dresden','OH','43821',NULL,'CY','39119','1961-10-18','M','M',':RET:2106-3','N','021','DEN','1089119','99734OH005000401','2014-01-01','2013-12-03 17:00:07','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:17:34'),(14559,11616,'Y','18','021','EC','A','','','AC','0001062127','0001062127','OH00000776203','IL','1','HENSAL','LISA','','','','34','281587708','582 BELL MAWR PL',0,'BARBERTON','OH','44203','4371','CY','39153','1965-05-24','F','R',':RET:2106-3','N','021','HLT','2559728','52664OH152000901','2014-02-01','2013-12-27 12:08:13','0.00',NULL,NULL,'370.78','370.78','R-OH012','OH0','267.06',NULL,0,'2013-12-28 03:35:14'),(24303,19303,'Y','18','021','EC','A','','','AC','0001136696','0001136696','OH00002848169','IL','1','Rivera','Viviana','','','','34','017580992','744 VILLAGE LN',0,'DEFIANCE','OH','43512','3741','CY','39039','1974-06-10','F','M',NULL,'N','021','HLT','3449618','92036OH004002601','2014-04-01','2014-02-18 16:04:16','0.00',NULL,NULL,'197.87','197.87','R-OH001','OH0','197.87','CIC',0,'2014-02-18 21:30:21'),(8086,6402,'Y','18','021','EC','A','','','AC','0000526771','0000526771','OH00000243477','IL','1','BROOKS','Michael','','','','34','292747529','1674 PRAIRIE RD',0,'WILMINGTON','OH','45177','9531','CY','39027','1965-03-30','M','U',NULL,'N','021','HLT','2208208','92036OH005000606','2014-01-01','2013-12-20 15:08:21','299.00',NULL,NULL,'350.99','51.99','R-OH005','OH0','350.99',NULL,0,'2013-12-26 03:10:32'),(7832,6203,'Y','18','024','14','A','','','TE','0000203061','0000203061','','IL','1','Hurlow','Melinda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-10-26','F','',NULL,NULL,NULL,'','1025837','','2013-12-19','2013-12-19 20:10:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:26'),(3424,2750,'Y','18','021','EC','A','','','AC','0002149664','0002149664','LA00000010143','IL','1','Wilson','Lila',NULL,NULL,NULL,NULL,NULL,'3601 Purdue Dr',0,'Metairie','LA','70003',NULL,'CY','22051','1965-01-10','F','U',':RET:2106-3','N','021','DEN','2585182','18575LA002000201','2014-01-01','2013-12-22 18:16:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:44'),(28953,22914,'Y','18','021','EC','A','','','AC','0001784088','0001784088','LA00003127125','IL','1','phillips','stephen','michael','','','34','437659425','824 oakwood dr.',0,'terrytown','LA','70056',NULL,'CY','22051','1983-08-17','M','U',':RET:2106-3','N','021','DEN','3663641','18575LA002000201','2014-04-01','2014-03-10 11:19:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:51'),(26557,21054,'N','19','021','EC','A',NULL,NULL,'','0001030419','0000609596','','IL','1','Supe','Tyler','','','','34','297116485','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2006-05-18','M','',':RET:2106-3','N','021','DEN','2969530','99734OH005000301','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:17'),(17240,13796,'Y','18','021','EC','A','','','AC','0000956667','0000956667','OH00001698771','IL','1','Frazier','Danny','','','','34','276746059','2434 Wales Ave.',0,'Lima','OH','45805',NULL,'CY','39003','1977-12-08','M','U',':RET:2106-3','N','021','HLT','1838418','92036OH004001501','2014-02-01','2014-01-08 17:30:40','216.08',NULL,NULL,'217.67','1.59','R-OH002','OH0','217.67',NULL,0,'2014-01-13 02:22:44'),(19506,15547,'Y','18','024','14','A','','','TE','0000941767','0000941767','','IL','1','Thigpen','Toncha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-15','F','',NULL,NULL,NULL,'','2944848','','2014-01-22','2014-01-22 09:36:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 03:02:12'),(3990,3185,'Y','18','021','EC','A','','','AC','0000603346','0000603346','OH00001233166','IL','1','Hill','Pamela','Jo','','','34','485724424','7354 Deer Trail Ct',0,'Toledo','OH','43615',NULL,'CY','39095','1955-04-28','F','U',':RET:2106-3','N','021','HLT','350919','92036OH005002601','2014-01-01','2013-12-13 14:46:37','223.00',NULL,NULL,'496.84','273.84','R-OH001','OH0','496.84',NULL,0,'2013-12-25 21:39:03'),(3850,3080,'Y','18','024','14','A','','','TE','0000776457','0000776457','','IL','1','Smith','Ricky',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-06-14','M','',NULL,NULL,NULL,'','132719','','2013-12-13','2013-12-13 12:35:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:35:37'),(20616,16474,'Y','18','021','EC','A','','','AC','0002080813','0002080813','LA00002478356','31','1','Short','Calvin','','','','34','439372623','P.O. Box 2104',0,'Houma','LA','70361',NULL,'CY','22109','1962-11-20','M','U',NULL,'N','021','DEN','2893254','18575LA002000101','2014-03-01','2014-01-30 14:43:52','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-30 21:00:21'),(27922,22087,'N','19','021','EC','A',NULL,NULL,'','0000386860','0000282042','','IL','1','ZAMARRIPA','DANIEL','','','Jr','34','643095444','2908 GRINNELL ST',0,'LUBBOCK','TX','79415','1640','CY','48303','1989-02-08','M','',NULL,'N','021','DEN','4063809','33348TX002000201','2014-04-01','2014-03-05 22:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:20'),(27805,21992,'N','19','021','EC','A',NULL,NULL,'','0000495502','0000670312','','IL','1','DOBRIJEVIC','STEFAN','','','','34','288089443','792 HANCOCK CIR',0,'AKRON','OH','44314','1017','CY','39153','2003-10-18','M','',':RET:2106-3','N','021','HLT','3753464','52664OH151001305','2014-04-01','2014-03-05 12:39:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-05 21:31:47'),(20960,16749,'Y','18','024','14','A','','','TE','0001150916','0001150916','','IL','1','RAMIREZ','AMELIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-26','F','',NULL,NULL,NULL,'','579099','','2014-02-01','2014-02-01 13:26:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-01 19:00:09'),(21959,17535,'Y','18','024','14','A','','','TE','0000647102','0000647102','','IL','1','SMITH','WILLIAM','B',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-04-03','M','',NULL,NULL,NULL,'','2942629','','2014-02-07','2014-02-07 09:59:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-07 19:00:25'),(23881,19000,'N','19','021','EC','A',NULL,NULL,'','0001036174','0000443504','','S1','1','Kiger','Laura','J','','','34','011891124','6761 Beagle Drive',0,'Hamilton','OH','45011',NULL,'CY','39017','2011-10-30','M','',':RET:2106-3','N','021','HLT','3830411','92036OH002001201','2014-03-01','2014-02-14 02:03:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-02-14 21:32:14'),(16918,13538,'N','01','021','EC','A',NULL,NULL,'','0000243752','0000997770','','IL','1','Bell','Duane','Paul','','','34','270480350','1977 ASHBURN DR',0,'DELAWARE','OH','43015','9128','CY','39041','1949-11-23','M','',':RET:2106-3','N','021','DEN','1899239','99734OH005000401','2014-02-01','2014-01-09 15:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:19:42'),(27410,21696,'Y','18','021','EC','A','','','AC','0001124133','0001124133','OH00003403680','IL','1','Gandy','Benjamin','Russell','','','34','283780349','3090 Livingston Rd',0,'Cleveland','OH','44120',NULL,'CY','39035','1978-06-15','M','M',':RET:2054-5','N','021','DEN','2943428','99734OH005000301','2014-04-01','2014-03-04 14:21:49','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:35'),(23949,19043,'Y','18','021','EC','A','','','AC','0000827041','0000827041','TX00002623857','IL','1','Kemper','Ashley','','','','34','356824703','6605 Riverhill Drive',0,'Plano','TX','75024',NULL,'CY','48121','1983-04-20','F','M',':RET:2106-3','N','021','DEN','3500908','33348TX002000101','2014-03-01','2014-02-14 21:12:27','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-15 22:00:03'),(4136,3300,'N','01','021','EC','A',NULL,NULL,'','0000843322','0001196799','','IL','1','Cater','Nayla','','','','34','268849957','9871 N POINTE CIR',0,'BRECKSVILLE','OH','44141','3186','CY','39035','1962-06-04','F','',':RET:2106-3','N','021','DEN','2040203','99734OH005000301','2014-01-01','2013-12-17 10:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:28'),(6697,5309,'Y','18','021','EC','A','','','AC','0000853011','0000853011','OH00000061927','IL','1','Douglas','Susan','','','','34','415113035','3903 HILE RD',0,'STOW','OH','44224','4230','CY','39153','1959-07-27','F','U',':RET:2106-3','N','021','HLT','955656','52664OH151001501','2014-01-01','2013-11-05 15:36:06','0.00',NULL,NULL,'571.04','571.04','R-OH012','OH0','571.04',NULL,0,'2013-12-26 01:01:46'),(9694,7679,'Y','18','021','EC','A','','','AC','0000610860','0000610860','OH00001214632','IL','1','Wilson','Dennis','J','','','34','302487830','7626 STEARNS RD',0,'OLMSTED FALLS','OH','44138','1047','CY','39035','1950-03-26','M','M',NULL,'N','021','HLT','1968344','92036OH005000801','2014-01-01','2013-12-21 12:50:07','0.00',NULL,NULL,'1259.93','1259.93','R-OH011','OH0','690.16',NULL,0,'2013-12-26 04:39:48'),(5710,4533,'Y','18','021','EC','A','','','AC','0000854200','0000854200','OH00001445658','IL','1','Duncan','LaVail','DeShaun','','Sr','34','456733400','587 DORCHESTER RD',0,'AKRON','OH','44320','1946','CY','39153','1978-08-29','M','U',':RET:2054-5','N','021','HLT','2314276','52664OH151001306','2014-01-01','2013-12-23 22:34:00','0.00',NULL,NULL,'272.52','272.52','R-OH012','OH0','272.52',NULL,0,'2013-12-25 23:45:07'),(17771,14198,'Y','18','021','EC','A','','','AC','0000347555','0000347555','TX00002559241','IL','1','Jaffer','Aleem','','','','34','638036006','6707 PARK LN',0,'HOUSTON','TX','77023','4017','CY','48201','1985-08-02','M','U',':RET:2029-7','T','021','DEN','2604727','33348TX002000101','2014-02-01','2014-01-13 14:05:21','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:38'),(19224,15317,'Y','18','021','EC','A','','','AC','0000666783','0000666783','OH00001945315','IL','1','Allen','Claire','','','','34','624508407','7245 Davis Road',0,'Hilliard','OH','43026',NULL,'CY','39049','1991-02-09','F','U',':RET:2106-3','N','021','DEN','2908493','99734OH005000401','2014-03-01','2014-01-20 14:22:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:46:28'),(19852,15834,'Y','18','021','EC','A','','','AC','0000163713','0000163713','OH00002406265','IL','1','Latimore-Kennedy','Theresa','','','','34','285522264','103 E AVONDALE AVE',0,'YOUNGSTOWN','OH','44507','1960','CY','39099','1951-08-03','F','M',':RET:2054-5','N','021','DEN','2946030','99734OH005000301','2014-03-01','2014-01-24 18:17:43','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-24 21:00:31'),(20269,16174,'Y','18','024','14','A','','','TE','0001057988','0001057988','','IL','1','Mudd','Gabriel','Kirk',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-14','M','',NULL,NULL,NULL,'','2127061','','2014-01-28','2014-01-28 16:44:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:22'),(22367,17862,'Y','18','021','EC','A','','','AC','0002134557','0002134557','LA00002652797','IL','1','nicholas','erica','','','','34','437113894','825 E HARDING ST',0,'DESTREHAN','LA','70047','4222','CY','22089','1962-05-14','F','U',':RET:2054-5','N','021','DEN','3292539','18575LA002000101','2014-03-01','2014-02-10 14:58:15','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02','CIC',0,'2014-02-10 21:00:11'),(15980,12790,'Y','18','021','EC','A','','','AC','0000390703','0000390703','TX00001938774','IL','1','BECKER','TERRY','','','','34','464867259','200 SPARERIB RD',0,'MARBLE FALLS','TX','78654','7306','CY','48053','1950-05-12','M','U',NULL,'N','021','DEN','1702463','33348TX002000201','2014-02-01','2014-01-03 10:35:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:00:54'),(9373,7431,'Y','18','021','EC','A','','','AC','0001242672','0001242672','LA00000141668','31','1','JOHNSON','LAMONICA','MICHELLE','','','34','438254929','PO BOX 6944',0,'SHREVEPORT','LA','71136',NULL,'CY','22017','1974-09-06','F','U',':RET:2054-5','N','021','DEN','2092117','18575LA002000201','2014-01-01','2013-12-21 13:13:00','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 04:31:51'),(4741,3756,'Y','18','021','EC','A','','','AC','0000142794','0000142794','OH00001116219','IL','1','Self-Stoehr','Lesha','D','','','34','307887141','3020 GODA AVE',0,'CINCINNATI','OH','45211','2706','CY','39061','1966-04-26','F','M',':RET:2106-3','N','021','HLT','628336','92036OH002001201','2014-01-01','2013-12-12 15:23:36','260.00',NULL,NULL,'387.49','127.49','R-OH004','OH0','387.49',NULL,0,'2013-12-25 22:09:27'),(3475,2790,'Y','18','021','EC','A','','','AC','0000179893','0000179893','OH00000066662','IL','1','Khammachone','Phay','','','','34','279765052','1312 NAUTICAL DR',0,'COLUMBUS','OH','43207','7241','CY','39049','1979-01-23','M','U',':RET:2028-9','T','021','DEN','1818889','99734OH005000401','2014-01-01','2013-12-22 10:52:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:20:03'),(22666,18100,'Y','18','021','EC','A','','','AC','0000192604','0000192604','TX00001688092','IL','1','Patel','Vishal','','','','34','637014635','2107 E MARSHALL AVE',0,'LONGVIEW','TX','75601','6916','CY','48183','1987-04-19','M','U',':RET:2029-7','T','021','DEN','3699000','33348TX002000201','2014-03-01','2014-02-11 14:37:21','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-11 21:00:38'),(19928,15892,'Y','18','021','EC','A','','','AC','0000708738','0000708738','MS00002349581','IL','1','Gibbs','christoyua','','','','34','427658163','180 COUNTY ROAD 841',0,'BLUE MOUNTAIN','MS','38610','9349','CY','28139','1989-03-30','F','U',':RET:2054-5','N','021','DEN','2642295','46300MS002000101','2014-03-01','2014-01-24 13:23:38','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2014-01-24 21:01:07'),(5407,4293,'Y','18','021','EC','A','','','AC','0000777672','0000777672','OH00000565478','IL','1','Moss','Steward','','','Jr','34','280560164','54 MOUNT HOLLY LN',0,'AMELIA','OH','45102','9753','CY','39025','1954-03-11','M','R',':RET:2106-3','N','021','HLT','2001164','92036OH003000601','2014-01-01','2013-12-19 12:37:30','0.00',NULL,NULL,'1040.88','1040.88','R-OH005','OH0','583.55',NULL,0,'2013-12-25 23:09:05'),(4126,3295,'Y','18','021','EC','A','','','AC','0000739010','0000739010','OH00000361930','IL','1','Harmon','Patricia','A','','','34','280543902','1439 ROSEDALE DR',0,'DAYTON','OH','45406','4743','CY','39113','1954-08-11','F','M',':RET:2054-5','N','021','DEN','2080595','99734OH005000301','2014-01-01','2013-12-16 23:58:01','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:48:17'),(3963,3169,'N','19','021','EC','A',NULL,NULL,'','0000110507','0000607134','','IL','1','Cushwa','Phoebe','','','','34','354232948','2655 N PARK BLVD',0,'CLEVELAND HEIGHTS','OH','44106','3622','CY','39035','2012-07-07','F','',':RET:2106-3','N','021','HLT','1078795','52664OH151001501','2014-01-01','2013-12-13 16:02:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-25 21:38:27'),(25122,19927,'N','19','021','EC','A',NULL,NULL,'','0001136698','0000476016','','IL','1','Spofford','Kendra','N','','','34','270981823','1652 SHERIDAN DR',0,'LANCASTER','OH','43130','1366','CY','39045','1994-09-21','F','',':RET:2106-3','N','021','DEN','3468365','99734OH005000301','2014-03-01','2014-02-21 12:51:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-21 21:30:21'),(9338,7402,'Y','18','021','EC','A','','','AC','0001773087','0001773087','LA00000900055','IL','1','PERRY','RUBY','','','','34','435293415','78046 TROBY ELZIE RD',0,'KENTWOOD','LA','70444','4473','CY','22105','1971-01-14','F','U',':RET:2054-5','N','021','DEN','1808108','18575LA002000201','2014-01-01','2013-12-20 20:04:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:30:56'),(24257,19262,'Y','18','021','EC','A','','','AC','0000380655','0000380655','TX00002271865','IL','1','Araiza','Shirley','','','','34','544960185','3632 SANDY PLATEAU CIR',0,'EL PASO','TX','79936','0759','CY','48141','1979-04-09','F','U',':RET:2106-3','N','021','DEN','3195176','33348TX002000201','2014-04-01','2014-02-16 20:39:00','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-17 19:00:07'),(9118,7234,'Y','18','021','EC','A','','','AC','0000449857','0000449857','OH00000577486','31','1','MYERS','BRENDA','SUE','','','34','297749659','P O Box 406',0,'Kingsville','OH','44048',NULL,'CY','39007','1963-07-30','F','U',':RET:2106-3','T','021','DEN','2219109','99734OH005000301','2014-01-01','2013-12-18 17:36:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:07:42'),(26575,21070,'N','19','021','EC','A',NULL,NULL,'','0001121454','0000833468','','IL','1','Capotosto','Anthony','James','','','34','289024221','2589 W ELM ST',0,'LIMA','OH','45805','2544','CY','39003','1997-11-29','M','',':RET:2106-3','N','021','DEN','3607412','99734OH005000401','2014-04-01','2014-02-28 12:39:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:27'),(4385,3486,'Y','18','021','EC','A','','','AC','0000055891','0000055891','OH00000334289','IL','1','SPERMAN','ANGEL','','','','34','279700684','22450 LAKEMONT AVE',0,'EUCLID','OH','44123','1622','CY','39035','1969-10-10','F','U',':RET:2054-5','N','021','DEN','1042411','99734OH005000401','2014-01-01','2013-12-12 10:44:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:44'),(4918,3902,'Y','18','021','EC','A','','','AC','0000125533','0000125533','OH00000619911','IL','1','PITTS','ANDREW','STEVEN','','','34','269861428','5791  SHERIDAN RD',0,'YOUNGSTOWN','OH','44514',NULL,'CY','39099','1981-12-17','M','U',NULL,'N','021','HLT','634363','52664OH151001306','2014-01-01','2013-12-07 16:27:12','243.00',NULL,NULL,'299.17','56.17','R-OH013','OH0','299.17',NULL,0,'2013-12-25 22:45:05'),(8120,6423,'Y','18','021','EC','A','','','AC','0000525545','0000525545','OH00000372993','IL','1','Best','Jessica','','','','34','281764608','110 N SYCAMORE ST',0,'ARCANUM','OH','45304','1169','CY','39037','1980-02-07','F','M',':RET:2106-3','N','021','DEN','285669','99734OH005000401','2014-01-01','2013-11-21 22:15:01','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:15:15'),(6491,5142,'Y','18','021','EC','A','','','AC','0000402439','0000402439','OH00001256535','IL','1','Hallam','Brenda','','','','34','277621914','459 STATE RD',0,'GENEVA','OH','44041','9356','CY','39007','1956-09-19','F','M',':RET:2106-3','N','021','HLT','1017504','52664OH151001305','2014-01-01','2013-12-11 12:26:11','476.00',NULL,NULL,'612.95','136.95','R-OH011','OH0','612.95',NULL,0,'2013-12-26 00:50:35'),(26249,20819,'Y','18','021','EC','A','','','AC','0000158023','0000158023','TX00002168307','IL','1','GREEN','FANNIE','','','','34','455353609','1713 N FLETCHER ST',0,'JASPER','TX','75951','2605','CY','48241','1974-04-07','F','U',NULL,'N','021','DEN','3569750','33348TX002000201','2014-03-01','2014-02-27 13:43:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:31:08'),(24992,19821,'Y','18','021','EC','A','','','AC','0000562068','0000562068','TX00002381424','IL','1','LAMBERT','TALISHA','','','','34','456956073','506 S TILDEN ST',0,'MIDLAND','TX','79701',NULL,'CY','48329','1977-06-25','F','M',':RET:2054-5','N','021','DEN','3343408','33348TX002000201','2014-04-01','2014-02-20 14:49:02','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-20 22:00:40'),(6803,5396,'Y','18','021','EC','A','','','AC','0001080288','0001080288','OH00000396271','IL','1','Eady','Barbara','','','','34','302467067','3036 KESWICK RD',0,'CLEVELAND','OH','44120','2721','CY','39035','1950-06-09','F','U',':RET:2054-5','N','021','HLT','470248','92036OH004000801','2014-01-01','2013-11-13 18:23:49','0.00',NULL,NULL,'554.95','554.95','R-OH011','OH0','554.95',NULL,0,'2013-12-26 01:30:03'),(19826,15809,'Y','18','024','14','A','','','TE','0000841117','0000841117','','IL','1','JONES','MARILYN','GALE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-21','F','',NULL,NULL,NULL,'','2430196','','2014-01-24','2014-01-24 13:29:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:16'),(15633,12504,'Y','18','021','EC','A','','','AC','0002052878','0002052878','LA00001042333','IL','1','ANTOINE','KENESHA','DWAN','','','34','438411733','1606 SOUTHLAND CT',0,'BATON ROUGE','LA','70810','3453','CY','22033','1979-09-19','F','U',NULL,'N','021','DEN','1906310','18575LA002000101','2014-02-01','2013-12-31 14:11:13','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-02 04:33:31'),(9280,7361,'N','19','021','EC','A',NULL,NULL,'','0000753357','0001192631','','IL','1','TARELLARI','MARIO','','','','34','277136063','10814 WINDHAM RD',0,'PARMA','OH','44130','1573','CY','39035','2007-03-19','M','',':RET:2106-3','N','021','DEN','15448','99734OH005000301','2014-01-01','2013-11-30 11:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:15:53'),(14304,11411,'Y','18','021','EC','A','','','AC','0000415978','0000415978','OH00001707358','IL','1','SCHAFFER','REBECCA','','','','34','291508975','819 HEMLOCK ST',0,'CELINA','OH','45822','1239','CY','39107','1951-11-06','F','M',':RET:2106-3','N','021','HLT','2538581','92036OH006001501','2014-02-01','2013-12-26 15:16:56','497.79',NULL,NULL,'501.46','3.67','R-OH002','OH0','501.46',NULL,0,'2013-12-27 02:06:55'),(4281,3409,'N','19','021','EC','A',NULL,NULL,'','0001073132','0001151067','','IL','1','Hostetler','Olivia','Danbi','','','34','310370147','14110 State Route 116',0,'Van Wert','OH','45891',NULL,'CY','39161','2011-04-05','F','',':RET:2106-3','N','021','HLT','1958887','92036OH005001504','2014-01-01','2013-12-17 11:34:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 21:52:00'),(6689,5302,'N','19','021','EC','A',NULL,NULL,'','0000728670','0000055874','','IL','1','Palmer','Sophia',NULL,NULL,NULL,NULL,NULL,'401 SILVERWOOD FARMS DR',0,'LEBANON','OH','45036','8314','CY','39165','2007-08-25','F','',':RET:2106-3','N','021','DEN','125151','99734OH005000401','2014-01-01','2013-11-05 13:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:32'),(3163,2545,'Y','18','021','EC','A','','','AC','0000864786','0000864786','OH00000343864','IL','1','BECKETT','STEVEN','JOSEPH','','','34','299562298','2808 FERM CLIFF AVE',0,'DAYTON','OH','45420',NULL,'CY','39113','1955-08-06','M','M',':RET:2106-3','T','021','DEN','669572','99734OH005000401','2014-01-01','2013-11-18 16:05:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:31:22'),(16802,13439,'N','01','021','EC','A',NULL,NULL,'','0000512759','0000553148','','IL','1','sheeley','jason','lee','','','34','642188350','827 RUTH ST',0,'HAWKINS','TX','75765','2743','CY','48499','1990-05-11','M','',':RET:2106-3','N','021','DEN','2304835','33348TX002000201','2014-02-01','2014-01-11 11:35:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:18:12'),(15354,12283,'Y','18','021','EC','A','','','AC','0000377471','0000377471','OH00001775073','IL','1','Toalston','Richard','L','','','34','279741184','5069 Apollo Rd NE',0,'Salineville','OH','43945',NULL,'CY','39019','1962-12-20','M','M',':RET:2106-3','N','021','DEN','1934105','99734OH005000301','2014-02-01','2013-12-31 23:41:05','0.00',NULL,NULL,'87.78','87.78','R-OH015','OH0','0.00',NULL,1,'2014-01-02 04:24:40'),(18163,14505,'Y','18','021','EC','A','','','AC','0001065993','0001065993','OH00001842669','IL','1','Tran','Minh','','','','34','429877541','641 KEN HAWK PL',0,'WILMINGTON','OH','45177','7933','CY','39027','1970-06-01','M','M',':RET:2047-9','N','021','HLT','2539005','92036OH005000605','2014-02-01','2014-01-14 00:16:38','345.00',NULL,NULL,'551.91','206.91','R-OH005','OH0','291.30',NULL,0,'2014-01-15 02:07:55'),(24800,19668,'N','01','021','EC','A',NULL,NULL,'','0000984904','0000843385','','IL','1','MCGOWAN','HOWARD','GERALD','','','34','302765445','1009 3RD ST',0,'MARIETTA','OH','45750','1836','CY','39167','1980-12-23','M','',NULL,'T','021','DEN','3100708','99734OH005000401','2014-04-01','2014-02-19 16:30:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:48:05'),(28801,22797,'Y','18','021','EC','A','','','AC','0000141572','0000141572','OH00003690494','IL','1','Rodriguiez','Larry','','','','34','291642958','2719 BLEEKER ST',0,'OREGON','OH','43616','2107','CY','39095','1961-02-22','M','U',NULL,'T','021','DEN','4309474','99734OH005000301','2014-04-01','2014-03-09 11:33:19','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-09 21:00:48'),(29031,22977,'Y','18','021','EC','A','','','AC','0000145449','0000145449','OH00003228596','IL','1','AIKENS','CANDACE','','','','34','274846654','4480 LOCKWOOD BLVD',0,'YOUNGSTOWN','OH','44511','3560','CY','39099','1975-08-06','F','U',':RET:2106-3','N','021','DEN','3543513','99734OH005000401','2014-04-01','2014-03-10 11:46:39','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-03-10 21:01:35'),(16025,12828,'Y','18','021','EC','A','','','AC','0001634948','0001634948','LA00001734894','IL','1','Perritt','Tammy','','','','34','436438078','6801 W 70TH ST',0,'SHREVEPORT','LA','71129','2339','CY','22017','1963-07-02','F','U',':RET:2106-3','T','021','DEN','1650076','18575LA002000201','2014-02-01','2014-01-03 10:36:30','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-04 02:02:16'),(6650,5275,'N','19','021','EC','A',NULL,NULL,'','0000736481','0001145930','','IL','1','Hill','Steven','','','','34','270080501','6853 CLUBSIDE DR',0,'LOVELAND','OH','45140','6040','CY','39025','2002-09-15','M','',NULL,'N','021','HLT','830523','92036OH004000601','2014-01-01','2013-11-12 12:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 01:00:33'),(6868,5447,'Y','18','021','EC','A','','','AC','0000586903','0000586903','TX00000674279','IL','1','graves','donna','may','','','34','465331233','6498 ORCHARD RD',0,'BOWIE','TX','76230','7177','CY','48337','1962-04-17','F','M',':RET:2106-3','N','021','DEN','710362','33348TX002000201','2014-01-01','2013-11-03 17:20:05','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:31:54'),(1759,1454,'N','17','021','EC','A',NULL,NULL,'','0001260013','0000005836','','S3','1','Bepler','Jamie','Lyn','','','34','297047993','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','2000-04-03','M','',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:52'),(24580,19515,'Y','18','021','EC','A','','','AC','0000290852','0000290852','OH00001805183','IL','1','CZEKANSKY','SUSAN','','','','34','282588932','1374 LIPTON AVE SW',0,'CANTON','OH','44720','4147','CY','39151','1970-06-25','F','U',NULL,'N','021','DEN','2951732','99734OH005000301','2014-04-01','2014-02-19 10:44:21','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-20 04:08:25'),(24369,19355,'Y','18','021','EC','A','','','AC','0001211629','0001211629','LA00003018747','IL','1','LaFargue','Richard','A','','Jr','34','436217266','4626 CHARLMARK DR',0,'NEW ORLEANS','LA','70127','3502','CY','22071','1961-07-25','M','U',':RET:2054-5','N','021','DEN','2985259','18575LA002000201','2014-04-01','2014-02-18 15:06:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:37'),(2800,2263,'Y','18','021','EC','A','','','AC','0000795484','0000795484','OH00000711919','IL','1','BANKEMPER','JAMES','','','','34','299564507','5861 PINNACLE RD',0,'MIAMISBURG','OH','45342','1029','CY','39113','1955-03-16','M','U',':RET:2106-3','T','021','HLT','808102','92036OH006000501','2014-01-01','2013-12-02 15:04:17','504.00',NULL,NULL,'552.38','48.38','R-OH003','OH0','552.38',NULL,0,'2013-12-25 19:50:24'),(16770,13415,'Y','18','021','EC','A','','','AC','0000064902','0000064902','OH00002432124','IL','1','Smith','Margaret','','','','34','283508849','6316 St Rt 73',0,'Hillsboro','OH','45133',NULL,'CY','39071','1951-03-17','F','U',':RET:2106-3','N','021','HLT','2188568','92036OH005000605','2014-02-01','2014-01-07 12:48:47','565.00',NULL,NULL,'616.74','51.74','R-OH005','OH0','616.74',NULL,0,'2014-01-08 18:25:01'),(9414,7469,'Y','18','021','EC','A','','','AC','0000993693','0000993693','TX00000515760','IL','1','ECKLAND','IMOGENE','','','','34','569784024','405 cavender ct',0,'hurst','TX','76054',NULL,'CY','48439','1950-07-29','F','M',':RET:2106-3','N','021','DEN','2221641','33348TX002000201','2014-01-01','2013-12-21 13:40:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:32:57'),(20955,16745,'Y','18','024','14','A','','','TE','0000690971','0000690971','','IL','1','Lopez','Maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-21','F','',NULL,NULL,NULL,'','2110988','','2014-02-01','2014-02-01 11:07:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-01 19:00:06'),(15464,12375,'Y','18','021','EC','A','','','AC','0000191381','0000191381','OH00001354128','IL','1','TRAN','TUAN','','','','34','277922314','4307 MANTELL CT',0,'DAYTON','OH','45440','3869','CY','39057','1966-06-16','M','M',':RET:2047-9','N','021','HLT','2512995','92036OH004000501','2014-02-01','2013-12-31 11:20:20','540.00',NULL,NULL,'854.02','314.02','R-OH003','OH0','298.75',NULL,1,'2014-01-02 04:28:45'),(28422,22490,'Y','18','021','EC','A','','','AC','0001205879','0001205879','OH00002789572','IL','1','Bensonhaver','Timothy','','','','34','294444852','708 N MARKET ST',0,'LOGAN','OH','43138','1212','CY','39073','1956-02-01','M','U',':RET:2106-3','N','021','DEN','2969757','99734OH005000401','2014-04-01','2014-03-07 14:17:59','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-03-07 21:31:03'),(15673,12537,'N','01','021','EC','A',NULL,NULL,'','0000749537','0000091154','','IL','1','Haines','Anthony','B','','','34','278687147','202 W FOREST ST',0,'CELINA','OH','45822','1062','CY','39107','1972-12-30','M','',':RET:2106-3','N','021','HLT','2183681','92036OH004001501','2014-02-01','2013-12-31 18:30:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','230.41',NULL,1,'2014-01-02 04:34:45'),(5223,4146,'Y','18','021','EC','A','','','AC','0000180999','0000180999','OH00000414706','IL','1','HOOT','PEGGY','SUE','','','34','284582105','3561 TRUMAN RD',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1961-08-26','F','M',':RET:2106-3','T','021','DEN','2116828','99734OH005000401','2014-01-01','2013-12-19 17:01:49','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:04:35'),(27864,22040,'Y','18','021','EC','A','','','AC','0000717882','0000717882','OH00003770618','IL','1','Mullins','Katie','','','','34','278523139','9374 ACME RD',0,'SEVILLE','OH','44273','9754','CY','39103','1952-07-22','F','U',':RET:2106-3','N','021','HLT','3425925','52664OH151001501','2014-04-01','2014-03-05 17:13:42','269.00',NULL,NULL,'751.58','482.58','R-OH012','OH0','751.58',NULL,0,'2014-03-05 21:32:21'),(23328,18593,'Y','18','021','EC','A','','','AC','0000862477','0000862477','OH00002536832','IL','1','Gillespie','Karen','','','','34','272843517','4533 E Miami River Rd',0,'Cleves','OH','45002',NULL,'CY','39061','1970-05-10','F','M',NULL,'N','021','DEN','3175670','99734OH005000301','2014-03-01','2014-02-13 15:07:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:28'),(27621,21846,'Y','18','021','EC','A','','','AC','0001594372','0001594372','LA00002929057','IL','1','Park','Christina','','','','34','590892417','12754 N Lakeshore Dr.',0,'Walker','LA','70785',NULL,'CY','22063','1970-12-02','F','U',NULL,'N','021','DEN','3406266','18575LA002000101','2014-04-01','2014-03-05 12:50:55','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-05 21:30:04'),(17070,13660,'Y','18','021','EC','A','','','AC','0000788559','0000788559','TX00001455080','IL','1','Pham','Tina','','','','34','439799274','1311 PAW PAW RD',0,'GILMER','TX','75645','2803','CY','48459','1990-11-27','F','U',':RET:2047-9','N','021','DEN','1595205','33348TX002000201','2014-02-01','2014-01-07 22:37:38','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-13 02:21:16'),(26174,20755,'Y','18','024','14','A','','','TE','0000840433','0000840433','','IL','1','Tart','Charley','Mae',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-02-05','F','',NULL,NULL,NULL,'','3195282','','2014-02-27','2014-02-27 13:38:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-28 06:30:37'),(18956,15103,'Y','18','021','EC','A','','','AC','0000952606','0000952606','TX00002083093','IL','1','Moore','Jennifer','','','','34','461576876','700 E. 15th Ave.',0,'Corsicana','TX','75110',NULL,'CY','48349','1981-03-24','F','U',NULL,'T','021','DEN','2600997','33348TX002000201','2014-03-01','2014-01-16 22:36:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-20 08:05:52'),(1941,1581,'Y','18','021','EC','A','','','AC','0001014335','0001014335','OH00000709191','IL','1','Binion','Sheena','','','','34','380943514','6404 Busch Blvd',0,'Columbus','OH','43229',NULL,'CY','39049','1984-08-14','F','U',':RET:2054-5','T','021','DEN','539577','99734OH005000401','2014-01-01','2013-11-20 01:03:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:00:40'),(14032,11177,'N','01','021','EC','A',NULL,NULL,'','0001250839','0000191362','','IL','1','Huffman','Kathy','Louise','','','34','271601083','2350 E STATE ROUTE 18',0,'TIFFIN','OH','44883','9667','CY','39147','1956-03-13','F','',':RET:2106-3','N','021','HLT','2133356','92036OH004002701','2014-01-01','2013-12-23 14:56:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.11',NULL,0,'2013-12-26 13:16:54'),(4769,3783,'Y','18','021','EC','A','','','AC','0000217555','0000217555','OH00000028756','IL','1','Fredley','Richard','Andrew','','','34','297886132','954 ROBERSON ST',0,'COLUMBUS','OH','43201','3646','CY','39049','1987-12-12','M','U',NULL,'N','021','DEN','1033227','99734OH005000401','2014-01-01','2013-12-08 11:50:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:15:46'),(15423,12338,'Y','18','021','EC','A','','','AC','0000415450','0000415450','TX00001533854','IL','1','anderson','amy','','','','34','440847801','7150 OLD VALDASTA RD',0,'BLUE RIDGE','TX','75424','3767','CY','48085','1976-02-05','F','M',':RET:2106-3','N','021','DEN','1666442','33348TX002000201','2014-02-01','2013-12-31 11:33:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:27:30'),(15137,12097,'Y','18','021','EC','A','','','AC','0000026628','0000026628','OH00001526021','IL','1','Mitchell','Marguerite','','','','34','302441894','2976 CAUDIL EAST RD',0,'BATAVIA','OH','45103','8415','CY','39025','1950-01-24','F','M',':RET:2106-3','N','021','DEN','2273931','99734OH005000401','2014-02-01','2013-12-30 06:33:17','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-01 12:05:37'),(13522,10779,'Y','18','021','EC','A','','','AC','0002050218','0002050218','LA00000555644','IL','1','Young','Meagan','','','','34','439695485','810 S ARENAS ST',0,'RAYNE','LA','70578','6802','CY','22001','1988-02-16','F','U',':RET:2054-5','N','021','DEN','2512638','18575LA002000201','2014-01-01','2013-12-23 09:14:28','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 13:03:13'),(17411,13934,'N','19','021','EC','A',NULL,NULL,'','0000187402','0000920233','','IL','1','Hill','Marvin','Lynn','','Jr','34','467979860','307 north Jordan street',0,'Whitesboro','TX','76273',NULL,'CY','48181','1988-04-20','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','1506486','33348TX002000101','2014-02-01','2014-01-10 15:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-13 03:00:22'),(4498,3565,'Y','18','021','EC','A','','','AC','0000783728','0000783728','TX00000226664','IL','1','Pate','Donna','','','','34','465498962','785 PRAIRIE ST',0,'TIMPSON','TX','75975','5215','CY','48419','1965-02-24','F','U',':RET:2106-3','N','021','DEN','714212','33348TX002000201','2014-01-01','2013-12-11 20:43:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:03:17'),(29027,22975,'N','19','021','EC','A',NULL,NULL,'','0000148405','0000382228','','IL','1','Hogan','Lukas','','','','34','798256757','2549 S HARBOR DR',0,'MAINEVILLE','OH','45039','9318','CY','39165','2012-10-23','M','',':RET:2106-3','N','021','DEN','3894223','99734OH005000401','2014-04-01','2014-03-10 11:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:34'),(25370,20129,'Y','18','021','EC','A','','','AC','0000224770','0000224770','OH00003104480','IL','1','Wallace','Jimmie','','','','34','306541953','7760 CARTER RD',0,'SAGAMORE HILLS','OH','44067','1617','CY','39153','1950-04-28','M','M',':RET:2106-3','N','021','DEN','3213207','99734OH005000301','2014-04-01','2014-02-25 14:34:18','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:30:41'),(23157,18461,'Y','18','021','EC','A','','','AC','0000447149','0000447149','TX00001568277','IL','1','Salinas','Guadalupe','','','','34','464881525','2202 Tourist Drive',0,'Edinburg','TX','78539',NULL,'CY','48215','1950-12-12','F','U',NULL,'N','021','DEN','3306126','33348TX002000101','2014-03-01','2014-02-11 20:26:58','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-02-12 21:31:45'),(19390,15458,'Y','18','024','14','A','','','TE','0000598781','0000598781','','IL','1','Saul','Evan','Thomas',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1995-02-14','M','',NULL,NULL,NULL,'','2683018','','2014-01-21','2014-01-21 11:17:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:47'),(5519,4378,'Y','18','021','EC','A','','','AC','0001203186','0001203186','OH00001190189','IL','1','Bredenfoerder','Laura','','','','34','287548996','8751 HAVERHILL LN',0,'CINCINNATI','OH','45236','2119','CY','39061','1953-07-09','F','R',':RET:2106-3','N','021','DEN','815801','99734OH005000301','2014-01-01','2013-11-27 15:23:34','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:15:16'),(9490,7526,'Y','18','021','EC','A','','','AC','0000645975','0000645975','OH00000603812','IL','1','Eck','Kyle','','','','34','399024791','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1986-09-02','M','R',':RET:2106-3','T','021','DEN','2255413','99734OH005000401','2014-01-01','2013-12-21 13:26:12','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:34:52'),(3549,2848,'Y','18','024','14','A','','','TE','0000792207','0000792207','','IL','1','Cottle','Kristy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-09','F','',NULL,NULL,NULL,'','139374','','2013-12-21','2013-12-21 22:24:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:21:58'),(1151,949,'Y','18','021','EC','A','','','AC','0000351646','0000351646','LA00000730222','IL','1','London','Grace','','','','34','435023656','2608 W CATAWBA DR',0,'HARVEY','LA','70058','2027','CY','22051','1957-08-29','F','R',':RET:2054-5','N','021','DEN','835445','18575LA002000201','2014-01-01','2013-12-02 23:39:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:37'),(26015,20632,'Y','18','021','EC','A','','','AC','0000707391','0000707391','TX00003191849','31','1','OSUCH','RICHARD','','','','34','566041702','13722 Oak Cabin',0,'San Antonio','TX','78232',NULL,'CY','48029','1956-05-23','M','M',':RET:2106-3','N','021','DEN','3713786','33348TX002000101','2014-04-01','2014-02-26 10:46:11','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2014-02-26 21:02:12'),(6914,5487,'Y','18','021','EC','A','','','AC','0001981859','0001981859','LA00001059434','IL','1','Recio Torres','Martha','G','','','34','436790908','1304 LEVEE DR',0,'HOUMA','LA','70360','3914','CY','22109','1967-10-22','F','R',NULL,'N','021','DEN','1471708','18575LA002000201','2014-02-01','2013-12-25 12:49:35','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-26 01:45:59'),(17099,13685,'Y','18','021','EC','A','','','AC','0000180418','0000180418','TX00002490963','IL','1','Burk','Allison','','','','34','456771684','10050 Great Hills Trail',0,'Austin','TX','78759',NULL,'CY','48453','1985-03-28','F','R',':RET:2106-3','N','021','DEN','1358906','33348TX002000201','2014-02-01','2014-01-08 16:28:52','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:21:31'),(25330,20097,'Y','18','021','EC','A','','','AC','0001562635','0001562635','LA00002787807','IL','1','Thibodeaux','Tracie','','','','34','437691708','5681 AIRLINE HWY',0,'BATON ROUGE','LA','70805','2404','CY','22033','1977-07-21','F','R',':RET:2054-5','N','021','DEN','3785337','18575LA002000201','2014-04-01','2014-02-25 13:45:30','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:17'),(2493,2031,'Y','18','024','14','A','','','TE','0001028649','0001028649','','IL','1','bruneau','thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-05-08','M','',NULL,NULL,NULL,'','1246822','','2013-12-09','2013-12-09 16:33:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:35:51'),(21578,17236,'Y','18','021','EC','A','','','AC','0000568059','0000568059','OH00001644367','IL','1','Fahey','Cindy','','','','34','292868702','5778 Wildrose Dr.',0,'Akron','OH','44319',NULL,'CY','39153','1975-07-30','F','U',NULL,'N','021','HLT','3332951','52664OH151001306','2014-03-01','2014-02-05 13:03:12','202.00',NULL,NULL,'277.87','75.87','R-OH012','OH0','277.87',NULL,0,'2014-02-05 21:30:24'),(21179,16926,'Y','18','021','EC','A','','','AC','0000214694','0000214694','OH00002207200','IL','1','Broughton','Angie','','','','34','286725438','7805 GAIL DR',0,'CINCINNATI','OH','45236','2331','CY','39061','1963-05-23','F','M',NULL,'N','021','DEN','3683061','99734OH005000401','2014-03-01','2014-02-03 17:09:47','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:42'),(27475,21742,'N','19','021','EC','A',NULL,NULL,'','0000237646','0000245042','','IL','1','Choe','Sinae','E','','','34','292961435','8586 W STATE ROUTE 163',0,'OAK HARBOR','OH','43449','8815','CY','39123','1994-01-24','F','',':RET:2040-4','N','021','HLT','3693657','92036OH003002705','2014-04-01','2014-03-03 21:46:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-04 21:02:13'),(424,347,'Y','18','021','EC','A','','','AC','0000468095','0000468095','OH00000149883','IL','1','EMBRY','CURITIA','V','','','34','272720747','1430 ANSEL RD',0,'CLEVELAND','OH','44106',NULL,'CY','39035','1968-07-21','F','U',':RET:2054-5','N','021','DEN','1022950','99734OH005000401','2014-01-01','2013-12-04 10:46:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:43'),(23469,18693,'Y','18','021','EC','A','','','AC','0000210643','0000210643','TX00001699617','IL','1','yelli','anthony','','','','34','357542154','16505 tiffany court',0,'houston','TX','77058',NULL,'CY','48201','1974-11-10','M','M',':RET:2028-9^:RET:2106-3','N','021','DEN','3463190','33348TX002000201','2014-03-01','2014-02-13 15:43:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-13 22:01:47'),(20242,16151,'Y','18','021','EC','A','','','AC','0000723674','0000723674','MS00001847692','IL','1','BALLARD','APRIL','','','','34','426416793','176 APONAUG RD',0,'KOSCIUSKO','MS','39090','3558','CY','28007','1981-10-20','F','M',NULL,'N','021','DEN','1837317','46300MS002000101','2014-03-01','2014-01-28 17:14:10','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-28 21:00:08'),(955,785,'Y','18','021','EC','A','','','AC','0000280795','0000280795','OH00000936350','IL','1','Caserta','Zachary','','','','34','292908152','905 CHARLES ST',0,'TRENTON','OH','45067','1817','CY','39017','1987-07-01','M','U',':RET:2106-3','N','021','DEN','985884','99734OH005000301','2014-01-01','2013-10-31 15:00:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:38'),(2272,1856,'Y','18','021','EC','A','','','AC','0001196788','0001196788','OH00001170771','IL','1','Throckmorton','Patricia','L','','','34','296544308','118 VALENTINE DR',0,'DAYTON','OH','45431','1924','CY','39113','1957-04-21','F','U',':RET:2106-3','N','021','DEN','792457','99734OH005000301','2014-01-01','2013-12-09 11:48:14','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:30:25'),(4329,3439,'Y','18','024','14','A','','','TE','0001207128','0001207128','','IL','1','GOULD','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-22','M','',NULL,NULL,NULL,'','111825','','2013-12-17','2013-12-17 09:32:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:52:58'),(24505,19466,'N','01','021','EC','A',NULL,NULL,'','0000323097','0000008988','','IL','1','Acosta','Rosario','S','','','34','641620550','1845 Westcrest Dr.',0,'Houston','TX','77055',NULL,'CY','48201','1958-12-25','F','',':RET:2106-3','N','021','DEN','2960745','33348TX002000201','2014-04-01','2014-02-18 23:05:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 03:50:38'),(372,309,'Y','18','021','EC','A','','','AC','0000935166','0000935166','TX00000592236','IL','1','Fairbrother','Phillip','Thomas','','','34','605303892','118 N IMPALA RD',0,'GILMER','TX','75644','4411','CY','48459','1986-05-29','M','M',':RET:2106-3','N','021','DEN','205831','33348TX002000201','2014-01-01','2013-12-04 15:52:10','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2013-12-25 17:45:28'),(462,377,'Y','18','021','EC','A','','','AC','0001210892','0001210892','OH00000336544','IL','1','Hind','Dannett','','','','34','299581462','940 BROOK RD',0,'WADSWORTH','OH','44281','9042','CY','39103','1956-06-28','F','U',':RET:2106-3','N','021','HLT','703197','52664OH151001306','2014-01-01','2013-12-04 18:13:00','461.00',NULL,NULL,'543.47','82.47','R-OH012','OH0','543.47',NULL,0,'2013-12-25 17:47:39'),(24232,19244,'Y','18','021','EC','A','','','AC','0001009849','0001009849','MS00002933505','IL','1','hathcox','thomas','f','','Jr','34','434558801','10 THREE OAKS RD',0,'CARRIERE','MS','39426','9114','CY','28109','1967-03-07','M','M',':RET:2106-3','N','021','DEN','3812233','46300MS002000201','2014-03-01','2014-02-15 20:37:40','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-16 19:00:34'),(23246,18533,'Y','18','024','14','A','','','TE','0001012970','0001012970','','IL','1','HILL','JODELL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-04-03','F','',NULL,NULL,NULL,'','2729120','','2014-02-28','2014-02-12 22:36:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:04'),(22059,17609,'Y','18','021','EC','A','','','AC','0000672371','0000672371','TX00001560601','IL','1','PETEET','JAMES','','','','34','453866044','408 E HOPKINS ST',0,'MEXIA','TX','76667','3634','CY','48293','1951-01-12','M','U',':RET:2054-5','T','021','DEN','3590658','33348TX002000201','2014-03-01','2014-02-08 12:19:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:09'),(4989,3960,'Y','18','021','EC','A','','','AC','0000599730','0000599730','OH00001214077','IL','1','Dingler','Ibtihaj','','','','34','283139604','8924 SUMMIT AVE',0,'BLUE ASH','OH','45242','7835','CY','39061','1961-04-14','F','M',NULL,'N','021','DEN','642830','99734OH005000301','2014-01-01','2013-12-06 21:21:42','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:46:54'),(2711,2193,'Y','18','021','EC','A','','','AC','0000329612','0000329612','OH00000297048','IL','1','Douglas-Korber','Kristine','','','','34','204626895','544 BAYFAIR DR',0,'BAY VILLAGE','OH','44140','2633','CY','39035','1968-07-20','F','M',':RET:2106-3','N','021','HLT','82994','52664OH151001501','2014-01-01','2013-12-02 13:32:17','89.81',NULL,NULL,'435.60','345.79','R-OH011','OH0','435.60',NULL,0,'2013-12-25 19:47:57'),(28036,22187,'Y','18','021','EC','A','','','AC','0000926336','0000926336','OH00003449010','IL','1','KLUN','MARIA','','','','34','287723564','860 E 239TH ST',0,'EUCLID','OH','44123',NULL,'CY','39035','1962-08-15','F','M',NULL,'N','021','DEN','3540924','99734OH005000401','2014-04-01','2014-03-06 17:35:52','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:30'),(25137,19940,'Y','18','024','14','A','','','TE','0000542424','0000542424','','IL','1','BURKE','BOBETTE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-01','F','',NULL,NULL,NULL,'','3129212','','2014-02-21','2014-02-21 10:32:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-21 22:00:07'),(26517,21031,'N','19','021','EC','A',NULL,NULL,'','0000294433','0000569376','','S1','1','Dietrich','Kara','M','','','34','288021829','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1997-11-02','F','',NULL,'N','021','HLT','3280933','92036OH003002706','2014-03-01','2014-02-28 14:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-28 21:00:22'),(14483,11554,'Y','18','021','EC','A','','','AC','0000902133','0000902133','TX00001719958','IL','1','Gregory','Dann','','','','34','449536125','907 NATURE DR',0,'DUNCANVILLE','TX','75116','2527','CY','48113','1971-06-07','F','U',':RET:2106-3','N','021','DEN','1482802','33348TX002000201','2014-02-01','2013-12-27 00:40:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-28 03:33:18'),(422,346,'Y','18','021','EC','A','','','AC','0000895681','0000895681','OH00000881690','IL','1','Obrien','Lauren','','','','34','177483189','42325 HOOPER RD',0,'SHADE','OH','45776','9549','CY','39105','1956-02-15','F','M',':RET:2106-3','N','021','DEN','1143732','99734OH005000401','2014-01-01','2013-12-04 10:00:13','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2013-12-25 17:46:40'),(17712,14155,'Y','18','021','EC','A','','','AC','0002215772','0002215772','LA00002365443','IL','1','Miller','Penny','','','','34','306687507','8914 HIGHWAY 34',0,'EROS','LA','71238','7106','CY','22049','1959-04-22','F','M',':RET:2106-3','N','021','DEN','2585860','18575LA002000201','2014-02-01','2014-01-13 17:29:00','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-14 01:33:10'),(29049,22991,'Y','18','021','EC','A','','','AC','0000330954','0000330954','OH00003088185','IL','1','smith','felicia','','','','34','292782613','213 YOUNG AVE NE',0,'CANTON','OH','44704','1656','CY','39151','1967-10-10','F','U',':RET:2054-5','T','021','DEN','3964750','99734OH005000401','2014-04-01','2014-03-10 14:17:13','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-10 21:01:45'),(24159,19196,'Y','18','021','EC','A','','','AC','0000162315','0000162315','OH00001603100','IL','1','dryfka','david','','','','34','398628072','U078 co.rd.3',0,'liberty center','OH','43532',NULL,'CY','39069','1953-07-04','M','M',':RET:2106-3','N','021','HLT','3558212','92036OH001002601','2014-03-01','2014-02-15 16:13:20','370.00',NULL,NULL,'638.35','268.35','R-OH001','OH0','638.35',NULL,0,'2014-02-15 22:02:02'),(22164,17688,'Y','18','021','EC','A','','','AC','0000313286','0000313286','OH00001897095','IL','1','Oder','Christopher','','','','34','277900167','228 High St',0,'Hamilton','OH','45011',NULL,'CY','39017','1987-12-18','M','U',':RET:2106-3','N','021','HLT','3535129','92036OH004001201','2014-03-01','2014-02-08 13:59:37','0.00',NULL,NULL,'176.75','176.75','R-OH004','OH0','176.75',NULL,0,'2014-02-08 19:00:59'),(17572,14050,'Y','18','021','EC','A','','','AC','0001217389','0001217389','OH00002398571','IL','1','Hays','Paula','','','','34','273762864','9164 Ridgemont Drive',0,'West Chester','OH','45069',NULL,'CY','39017','1970-08-21','F','U',':RET:2106-3','T','021','DEN','1862155','99734OH005000401','2014-02-01','2014-01-13 13:11:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:02'),(5949,4712,'Y','18','021','EC','A','','','AC','0000077568','0000077568','OH00000591896','IL','1','Jayne','Brenda','','','','34','278585477','26169 s u rte 52',0,'stout','OH','45684',NULL,'CY','39001','1955-03-25','F','M',NULL,'N','021','HLT','1760503','92036OH003000605','2014-01-01','2013-12-23 23:52:56','1240.00',NULL,NULL,'1439.45','199.45','R-OH005','OH0','571.20',NULL,0,'2013-12-25 23:51:03'),(1205,991,'Y','18','021','EC','A','','','AC','0000957878','0000957878','OH00000738635','IL','1','Sirianni','Nancy','','','','34','040546716','1122 RADCLIFFE DR',0,'TOLEDO','OH','43609','3148','CY','39095','1958-07-16','F','U',':RET:2106-3','N','021','DEN','895073','99734OH005000301','2014-01-01','2013-12-03 11:33:34','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:19:57'),(26175,20756,'Y','18','021','EC','A','','','AC','0000469860','0000469860','MS00003141691','IL','1','Sanders','Annie','Rivers','','','34','427256706','791 W COUNTY LINE RD',0,'JACKSON','MS','39213','8214','CY','28049','1967-05-02','F','U',':RET:2054-5','N','021','DEN','3507522','46300MS002000201','2014-04-01','2014-02-27 17:12:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 06:30:37'),(15265,12203,'Y','18','021','EC','A','','','AC','0001135178','0001135178','OH00001587117','IL','1','MILLER','RONALD','GERALD','','Jr','34','268702800','4814 HARTLAND CENTER RD',0,'COLLINS','OH','44826','9767','CY','39077','1966-02-21','M','U',':RET:2106-3','N','021','HLT','1391749','92036OH005002706','2014-02-01','2013-12-30 14:55:05','272.00',NULL,NULL,'304.78','32.78','R-OH006','OH0','304.78',NULL,0,'2014-01-01 12:09:25'),(15160,12115,'N','01','021','EC','A',NULL,NULL,'','0000116595','0000063724','','IL','1','Ustaszewski','Tamara','L','','','34','271683710','3201 Arctic Avenue',0,'Lewis Center','OH','43035',NULL,'CY','39041','1966-07-12','F','',NULL,'N','021','DEN','2566146','99734OH005000401','2014-02-01','2013-12-30 13:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:15'),(25746,20420,'Y','18','021','EC','A','','','AC','0001016905','0001016905','OH00002483783','IL','1','HERNANDEZ','LUCIANO','','','Jr','34','280343550','1201 PARKSIDE PL',0,'FINDLAY','OH','45840','5537','CY','39063','1939-11-12','M','M',':RET:2106-3','N','021','DEN','3701705','99734OH005000401','2014-04-01','2014-02-24 15:06:30','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2014-02-26 09:30:43'),(5157,4089,'Y','18','021','EC','A','','','AC','0001187632','0001187632','OH00000693897','IL','1','BETTS','PATRICIA','ANN','','','34','276665963','1135 BLACKLICK RD',0,'MILLERSPORT','OH','43046','9726','CY','39045','1958-10-25','F','M',':RET:2106-3','N','021','DEN','2216690','99734OH005000401','2014-01-01','2013-12-19 10:30:56','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:02:57'),(8816,6988,'Y','18','024','14','A','','','TE','0000960575','0000960575','','IL','1','Lewis','Jack',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-25','M','',NULL,NULL,NULL,'','272092','','2013-12-18','2013-12-18 07:50:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:00:07'),(5093,4037,'Y','18','024','14','A','','','TE','0000244595','0000244595','','IL','1','Bailey','Tucker',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-09','M','',NULL,NULL,NULL,'','498172','','2013-12-19','2013-12-19 15:31:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:16'),(4983,3957,'Y','18','024','14','A','','','TE','0000444415','0000444415','','IL','1','Arreola','Abraham',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-04-14','M','',NULL,NULL,NULL,'','694720','','2013-12-07','2013-12-07 14:57:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:46:47'),(4852,3844,'Y','18','021','EC','A','','','AC','0000982667','0000982667','OH00001204804','IL','1','Stout','William','','','','34','296604098','515 S FOUNTAIN AVE',0,'SPRINGFIELD','OH','45506','2223','CY','39023','1964-12-08','M','M',':RET:2106-3','N','021','DEN','848570','99734OH005000401','2014-01-01','2013-11-08 14:36:52','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:30:24'),(18847,15011,'Y','18','021','EC','A','','','AC','0001129038','0001129038','OH00002487143','IL','1','DAVIS','JEFFERY','','','','34','291666524','417 RED ROCK DRIVE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1962-02-06','M','M',':RET:2106-3','N','021','HLT','2529099','52664OH151001301','2014-02-01','2014-01-15 19:05:14','556.00',NULL,NULL,'1054.83','498.83','R-OH012','OH0','415.91',NULL,0,'2014-01-17 03:36:14'),(20457,16341,'Y','18','021','EC','A','','','AC','0000837723','0000837723','OH00002022882','IL','1','McClary','Nancy','','','','34','274602757','2384 GARDENDALE DR',0,'COLUMBUS','OH','43219','2002','CY','39049','1958-01-25','F','U',':RET:2054-5','N','021','DEN','3159892','99734OH005000401','2014-03-01','2014-01-29 08:42:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:49'),(21648,17287,'Y','18','021','EC','A','','','AC','0001519192','0001519192','LA00002079346','IL','1','CARTER','MURSEL','LEON','','','34','428048426','118 W CLUB DR',0,'SAINT ROSE','LA','70087','3449','CY','22089','1967-09-24','M','U',':RET:2054-5','T','021','DEN','3022754','18575LA002000201','2014-03-01','2014-02-04 19:30:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:48'),(16635,13308,'Y','18','021','EC','A','','','AC','0000229446','0000229446','OH00001377914','IL','1','Woolery','Kristine','','','','34','099423273','367 N JAY ST',0,'WEST MILTON','OH','45383','1712','CY','39109','1951-10-19','F','M',':RET:2106-3','N','021','DEN','2523625','99734OH005000401','2014-02-01','2014-01-07 11:30:04','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:16'),(824,681,'N','01','021','EC','A',NULL,NULL,'','0000790849','0000915618','','IL','1','Lawrence','Amy','Nicole','','','34','555750539','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1982-07-29','F','',':RET:2106-3','N','021','HLT','2279894','52664OH151001301','2014-01-01','2013-12-16 14:59:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','258.47',NULL,0,'2013-12-25 18:06:10'),(19755,15747,'Y','18','021','EC','A','','','AC','0000359707','0000359707','OH00001747480','IL','1','Swanson','Alia','','','','34','234084099','6062 BRICE PARK DR',0,'CANAL WINCHESTER','OH','43110','9039','CY','39049','1976-02-03','F','U',':RET:2054-5','N','021','DEN','2190168','99734OH005000301','2014-03-01','2014-01-23 11:22:31','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:01:20'),(13374,10680,'N','01','021','EC','A',NULL,NULL,'','0000636002','0000511951','','IL','1','Sullivan','Gregory','John','','','34','009501055','18800 State Route 47 East',0,'Sidney','OH','45365',NULL,'CY','39149','1964-02-18','M','',':RET:2106-3','N','021','DEN','2046709','99734OH005000301','2014-01-01','2013-12-22 21:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:47'),(17144,13719,'Y','18','021','EC','A','','','AC','0001712549','0001712549','LA00001971062','IL','1','ARMSTRONG','MARTIN','','','','34','435496189','2295 HORTON ST',0,'ZWOLLE','LA','71486','3103','CY','22085','1981-02-08','M','M',':RET:2106-3','N','021','DEN','1487741','18575LA002000201','2014-02-01','2014-01-07 20:16:33','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-13 02:21:53'),(2798,2262,'Y','18','021','EC','A','','','AC','0000201897','0000201897','OH00001127065','31','1','Berry','Laura','M','','','34','302708225','P.O. Box 2485',0,'youngstown','OH','44509',NULL,'CY','39099','1965-09-14','F','M',':RET:2106-3','N','021','HLT','226447','92036OH002003201','2014-01-01','2013-12-02 12:51:40','745.00',NULL,NULL,'1080.39','335.39','R-OH013','OH0','457.04',NULL,0,'2013-12-25 19:50:20'),(16862,13492,'Y','18','021','EC','A','','','AC','0000086426','0000086426','TX00002278851','IL','1','Orr','Mary','','','','34','501111266','7700 State Highway 98',0,'Simms','TX','75574',NULL,'CY','48037','1986-06-21','F','M',':RET:2106-3','N','021','DEN','1755512','33348TX002000201','2014-02-01','2014-01-09 10:26:42','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2014-01-13 02:19:11'),(16867,13496,'Y','18','024','14','A','','','TE','0000119289','0000119289','','IL','1','Schweers','Ellen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-07-22','F','',NULL,NULL,NULL,'','1473061','','2014-01-09','2014-01-09 12:31:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:19:14'),(28092,22234,'Y','18','024','14','A','','','TE','0000608277','0000608277','','IL','1','Smith','Janice','Marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-28','F','',NULL,NULL,NULL,'','3511232','','2014-03-06','2014-03-06 11:08:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-06 21:02:05'),(16779,13421,'N','01','021','EC','A',NULL,NULL,'','0001130241','0001253547','','IL','1','Francis','Neil','R','','','34','281888715','1076 PARKWAY DR',0,'GREENVILLE','OH','45331','2620','CY','39037','1976-10-22','M','',':RET:2106-3','N','021','HLT','1492777','92036OH004000501','2014-02-01','2014-01-07 11:33:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','236.62',NULL,0,'2014-01-08 18:25:05'),(199,165,'Y','18','021','EC','A','','','AC','0000902179','0000902179','OH00000541170','IL','1','Yerian','Regina','','','','34','297508382','2725 SYMPHONY WAY',0,'DAYTON','OH','45449','3314','CY','39113','1954-06-06','F','M',':RET:2106-3','T','021','HLT','1117404','92036OH005000501','2014-01-01','2013-12-04 20:07:01','0.00',NULL,NULL,'711.58','711.58','R-OH003','OH0','711.58',NULL,0,'2013-12-25 17:20:08'),(22346,17846,'N','01','021','EC','A',NULL,NULL,'','0001220870','0000043254','','IL','1','Caruso','Sarah','','','','34','301861509','712 hollywood ave',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1983-05-20','F','',':RET:2106-3','N','021','HLT','3590523','52664OH151001306','2014-03-01','2014-02-01 10:46:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11',NULL,0,'2014-02-10 11:01:12'),(16422,13140,'N','01','021','EC','A',NULL,NULL,'','0000417411','0000509221','','IL','1','Jin','Hyun','Kyung','','','34','276925441','3789 MAPLE GROVE LN',0,'BEAVERCREEK','OH','45440','3573','CY','39057','1965-12-25','F','',':RET:2040-4','N','021','HLT','2136580','92036OH001000501','2014-02-01','2014-01-06 14:12:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.80',NULL,0,'2014-01-07 04:04:31'),(16322,13067,'N','01','021','EC','A',NULL,NULL,'','0001548248','0001235057','','IL','1','mai','uyen','t','','','34','437998423','20357 chaumont ave',0,'baton rouge','LA','70817',NULL,'CY','22033','1978-05-15','F','',':RET:2047-9','N','021','DEN','2561030','18575LA002000201','2014-02-01','2014-01-06 16:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:43'),(19988,15944,'Y','18','021','EC','A','','','AC','0000873264','0000873264','OH00002069703','IL','1','Bundy','Jess','','','','34','270887682','626.5  S. Main St.',0,'Findlay','OH','45840',NULL,'CY','39063','1976-03-12','M','U',':RET:2106-3','N','021','HLT','3438979','92036OH005001504','2014-03-01','2014-01-25 13:06:19','142.00',NULL,NULL,'272.46','130.46','R-OH002','OH0','272.46',NULL,0,'2014-01-25 19:00:18'),(4686,3715,'Y','18','021','EC','A','','','AC','0000921895','0000921895','OH00000412909','IL','1','werline','karen','','','','34','272507532','109 FOREST MEADOW DR',0,'BATAVIA','OH','45103','7518','CY','39025','1952-03-27','F','U',':RET:2106-3','N','021','HLT','74393','92036OH005000605','2014-01-01','2013-12-12 08:27:47','428.00',NULL,NULL,'603.24','175.24','R-OH005','OH0','603.24',NULL,0,'2013-12-25 22:08:03'),(3787,3034,'Y','18','024','14','A','','','TE','0000195113','0000195113','','IL','1','Spencer','Linda','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-29','F','',NULL,NULL,NULL,'','61616','','2013-12-13','2013-12-13 09:53:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:08'),(391,322,'Y','18','021','EC','A','','','AC','0000993944','0000993944','OH00000046333','IL','1','Johnston','Thomas','','','','34','286466845','310 FOWLER ST',0,'CORTLAND','OH','44410','1332','CY','39155','1953-04-10','M','M',':RET:2106-3','T','021','HLT','663432','92036OH004003201','2014-01-01','2013-12-04 11:39:37','853.00',NULL,NULL,'930.66','77.66','R-OH013','OH0','607.45',NULL,0,'2013-12-25 17:45:54'),(26800,21238,'Y','18','021','EC','A','','','AC','0001094703','0001094703','OH00002779254','IL','1','EBERLE','MARK','','','','34','276564516','623 FLANDERS AVE',0,'BOWLING GREEN','OH','43402',NULL,'CY','39173','1954-10-06','M','M',NULL,'N','021','DEN','3681525','99734OH005000301','2014-03-01','2014-02-28 18:39:58','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2014-03-01 21:00:22'),(25987,20608,'N','19','021','EC','A',NULL,NULL,'','0000279609','0001174450','','IL','1','McKnight','Isabella','','','','34','274960796','2570 COVENTRY RD',0,'SHAKER HEIGHTS','OH','44120','1304','CY','39035','1993-01-07','F','',':RET:2106-3','N','021','DEN','3840866','99734OH005000401','2014-03-01','2014-02-26 17:21:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:54'),(25657,20355,'Y','18','021','EC','A','','','AC','0000794560','0000794560','OH00002216680','IL','1','Stout','Ruth','','','','34','298802492','404 LEE LN',0,'MANSFIELD','OH','44905','2722','CY','39139','1967-11-25','F','U',':RET:2106-3','T','021','DEN','3146806','99734OH005000401','2014-04-01','2014-02-22 16:53:13','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-02-26 08:30:42'),(22208,17725,'Y','18','021','EC','A','','','AC','0001084187','0001084187','OH00001652609','IL','1','Mattingly','Elizabeth','','','','34','403271825','3507 VICTORIA PL',0,'CINCINNATI','OH','45208','1430','CY','39061','1983-04-10','F','R',':RET:2106-3','N','021','DEN','3212839','99734OH005000401','2014-03-01','2014-02-09 15:50:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-09 19:00:18'),(3464,2782,'N','01','021','EC','A',NULL,NULL,'','0000139006','0001004331','','IL','1','Spieldenner','Kimberly','S','','','34','301687611','4424 BURNINGTREE DR',0,'TOLEDO','OH','43623','3186','CY','39095','1966-07-16','F','',':RET:2106-3','N','021','DEN','2500676','99734OH005000401','2014-01-01','2013-12-22 04:18:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:46'),(15369,12292,'N','01','021','EC','A',NULL,NULL,'','0000711380','0000417407','','IL','1','Philpot','Zachary','','','','34','301805400','6054 HILL AVE',0,'MIAMISBURG','OH','45342','5159','CY','39113','1976-10-28','M','',':RET:2106-3','N','021','DEN','2559858','99734OH005000301','2014-02-01','2014-01-01 15:11:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:25:01'),(9780,7745,'N','01','021','EC','A',NULL,NULL,'','0000529404','0000528206','','IL','1','Prout','Gina','J','','','34','280766545','1000 W Main St Lot 20',0,'west jefferson','OH','43162',NULL,'CY','39097','1972-07-14','F','',':RET:2106-3','N','021','DEN','669510','99734OH005000301','2014-01-01','2013-10-20 20:11:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:42'),(9145,7252,'Y','18','021','EC','A','','','AC','0000894612','0000894612','OH00000219879','IL','1','Nickerson','Jane','','','','34','294564059','2999 GIVENS DR',0,'NORTON','OH','44203','5329','CY','39153','1953-11-17','F','U',':RET:2106-3','N','021','HLT','2176529','52664OH151001501','2014-01-01','2013-12-18 11:20:05','330.00',NULL,NULL,'725.90','395.90','R-OH012','OH0','725.90',NULL,0,'2013-12-26 04:08:16'),(21730,17352,'Y','18','021','EC','A','','','AC','0001152553','0001152553','TX00002650714','IL','1','Hill','Pat','','','','34','456199211','1116 RS COUNTY ROAD 2360',0,'ALBA','TX','75410','7955','CY','48379','1959-07-04','M','U',':RET:2106-3','N','021','DEN','3366528','33348TX002000201','2014-03-01','2014-02-06 15:13:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:09'),(18608,14833,'N','01','021','EC','A',NULL,NULL,'','0000816438','0000636022','','IL','1','CAMPOLONGO','CHERYL','','','','34','290740761','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1963-11-14','F','',NULL,'N','021','HLT','1840005','92036OH004000601','2014-02-01','2014-01-15 16:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.28',NULL,0,'2014-01-16 08:47:21'),(15523,12419,'Y','18','021','EC','A','','','AC','0002393467','0002393467','LA00002056852','IL','1','BURNLEY','BOBBY','K','','','34','437945213','407 REGISTER ST',0,'WEST MONROE','LA','71291','2739','CY','22073','1963-02-07','M','U',NULL,'N','021','DEN','2155500','18575LA002000201','2014-02-01','2013-12-30 20:28:54','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:30:22'),(742,615,'Y','18','021','EC','A','','','AC','0000320362','0000320362','TX00000791852','IL','1','Rejcek','Kristen','','','','34','633073547','715 SAN SABA DR',0,'COLLEGE STATION','TX','77845','6524','CY','48041','1984-01-02','F','U',':RET:2106-3','N','021','DEN','678415','33348TX002000201','2014-01-01','2013-12-15 23:43:42','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 18:04:05'),(27317,21629,'Y','18','021','EC','A','','','AC','0000515870','0000515870','TX00003042437','IL','1','Roman','Dora','H','','','34','451856335','897 Denman St.',0,'Diboll','TX','75941',NULL,'CY','48005','1960-04-22','F','U',':RET:2106-3','N','021','DEN','3616121','33348TX002000201','2014-04-01','2014-03-04 14:54:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:43'),(21142,16893,'N','01','021','EC','A',NULL,NULL,'','0000604411','0001097920','','IL','1','CRAIN','RICHARD','R','','','34','463924893','12124 TROTWOOD DR',0,'AUSTIN','TX','78753','6935','CY','48453','1951-03-18','M','',':RET:2106-3','N','021','DEN','3471899','33348TX002000201','2014-03-01','2014-02-03 16:41:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-03 21:00:22'),(9030,7165,'Y','18','021','EC','A','','','AC','0000227042','0000227042','OH00001065207','IL','1','healy','mason',NULL,NULL,NULL,NULL,NULL,'3151 bancroft',0,'fairlawn','OH','44313',NULL,'CY','39153','2000-11-22','M','R',NULL,'N','021','HLT','1372795','52664OH151001305','2014-01-01','2013-12-18 11:20:26','94.93',NULL,NULL,'141.61','46.68','R-OH012','OH0','141.61',NULL,0,'2013-12-26 04:05:32'),(28785,22785,'Y','18','021','EC','A','','','AC','0000287168','0000287168','OH00002617702','IL','1','Jones','Todd','E','','','34','298766195','4481 Eastwood Drive',0,'Batavia','OH','45103',NULL,'CY','39025','1972-05-25','M','U',':RET:2106-3','N','021','DEN','3230411','99734OH005000401','2014-04-01','2014-03-09 16:24:07','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-09 21:00:37'),(5220,4144,'Y','18','021','EC','A','','','AC','0000012419','0000012419','OH00000223476','IL','1','Chellath','Seema','','','','34','616737041','5758 HAWTHORNE RESERVES DR',0,'LIBERTY TOWNSHIP','OH','45044','8888','CY','39017','1974-04-24','F','R',':RET:2029-7','N','021','DEN','1807042','99734OH005000401','2014-01-01','2013-12-19 16:38:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:30'),(2184,1796,'Y','18','021','EC','A','','','AC','0000146777','0000146777','TX00001213059','IL','1','beesley','wade','','','','34','454271289','1605 chestnut ave',0,'austin','TX','78702',NULL,'CY','48453','1969-11-02','M','U',NULL,'N','021','DEN','519918','33348TX002000101','2014-01-01','2013-12-10 15:15:48','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 19:19:31'),(25245,20025,'Y','18','021','EC','A','','','AC','0000498229','0000498229','OH00002224281','IL','1','BEGGS','SUSAN','J','','','34','276484375','2808 LAKEWOOD AVE',0,'LIMA','OH','45805','3012','CY','39003','1949-11-16','F','M',':RET:2106-3','N','021','HLT','2868244','92036OH004001501','2014-04-01','2014-02-21 13:43:20','0.00',NULL,NULL,'530.89','530.89','R-OH002','OH0','530.89',NULL,0,'2014-02-21 22:01:10'),(18781,14959,'Y','18','021','EC','A','','','AC','0000232671','0000232671','OH00001354530','IL','1','Ford','Betty','','','','34','294566126','923 Anderson St.',0,'Northwood','OH','43619',NULL,'CY','39173','1956-07-13','F','U',':RET:2106-3','T','021','HLT','2751560','92036OH003002604','2014-02-01','2014-01-15 18:52:53','303.00',NULL,NULL,'570.70','267.70','R-OH001','OH0','570.70',NULL,0,'2014-01-17 03:35:52'),(704,581,'Y','18','024','14','A','','','TE','0000933603','0000933603','','IL','1','Nathan','Kathryn','Leigh',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-09-09','F','',NULL,NULL,NULL,'','1020169','','2013-12-15','2013-12-15 19:29:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:02:59'),(8947,7095,'Y','18','024','14','A','','','TE','0000699253','0000699253','','IL','1','BRAND','DON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-02','M','',NULL,NULL,NULL,'','628321','','2013-12-18','2013-12-18 11:08:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:03:28'),(7588,6003,'Y','18','021','EC','A','','','AC','0001135132','0001135132','OH00000380635','IL','1','Williams','Margaret','','','','34','278584944','2060 BURNT CABIN RD',0,'SEAMAN','OH','45679','9025','CY','39001','1956-06-09','F','U',':RET:2106-3','N','021','HLT','1234534','92036OH006000601','2014-01-01','2013-11-16 18:14:38','0.00',NULL,NULL,'414.90','414.90','R-OH005','OH0','414.90',NULL,0,'2013-12-26 02:45:03'),(15834,12678,'Y','18','021','EC','A','','','AC','0000467106','0000467106','OH00001577565','IL','1','MCGURR','ROSEANN','','','','34','301563577','324 ZELLER AVE',0,'AKRON','OH','44310','3828','CY','39153','1956-02-22','F','U',NULL,'N','021','DEN','2161878','99734OH005000401','2014-02-01','2014-01-02 11:25:50','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-03 02:03:56'),(15199,12147,'Y','18','021','EC','A','','','AC','0000286293','0000286293','MS00000756190','IL','1','Pitalo','Sherri','','','','34','587429647','13704 PARAISO RD',0,'OCEAN SPRINGS','MS','39564','2568','CY','28059','1950-01-06','F','M',':RET:2106-3','N','021','DEN','1623553','46300MS002000201','2014-02-01','2013-12-30 11:01:23','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-01 12:07:21'),(19435,15493,'Y','18','021','EC','A','','','AC','0000021413','0000021413','OH00002377183','IL','1','Talley','Phillip','','','','34','284840299','1416 w 110th street',0,'cleveland','OH','44102',NULL,'CY','39035','1985-10-16','M','U',':RET:2054-5','N','021','HLT','3246126','52664OH151001501','2014-03-01','2014-01-21 12:38:19','29.00',NULL,NULL,'327.91','298.91','R-OH011','OH0','327.91',NULL,1,'2014-01-22 03:23:10'),(20191,16112,'Y','18','021','EC','A','','','AC','0000471047','0000471047','OH00002403561','IL','1','Longmire','Jennifer','','','','34','288540107','3230 Leatherwood Creek road',0,'Sidney','OH','45365',NULL,'CY','39149','1952-09-12','F','M',':RET:2106-3','T','021','HLT','3028613','92036OH004000501','2014-03-01','2014-01-27 03:48:56','1182.36',NULL,NULL,'1191.07','8.71','R-OH003','OH0','617.67',NULL,0,'2014-01-27 21:01:26'),(21583,17241,'Y','18','021','EC','A','','','AC','0000615549','0000615549','OH00002001821','IL','1','Barchalk','Michael','','','','34','276728809','801 Franklin Avenue',0,'Kent','OH','44240',NULL,'CY','39133','1965-05-08','M','M',':RET:2106-3','T','021','HLT','3742625','52664OH151001306','2014-03-01','2014-02-05 16:48:59','785.00',NULL,NULL,'1086.87','301.87','R-OH012','OH0','419.31',NULL,0,'2014-02-05 21:30:26'),(22487,17953,'Y','18','021','EC','A','','','AC','0001230437','0001230437','OH00002664033','IL','1','Walker','Sarah','','','','34','298780179','425 Glen Park Dr',0,'Bay Village','OH','44140',NULL,'CY','39035','1979-04-09','F','U',':RET:2106-3','N','021','DEN','3689317','99734OH005000301','2014-03-01','2014-02-10 10:17:02','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:06'),(24583,19516,'N','01','021','EC','A',NULL,NULL,'','0000178939','0001125482','','IL','1','Saladino','Cristeta','A','','','34','299025250','6391 WILLOW BROOKE DR',0,'LIBERTY TWP','OH','45011','0401','CY','39017','1951-10-28','F','',':RET:2036-2','N','021','DEN','3061186','99734OH005000301','2014-04-01','2014-02-18 23:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:56'),(1142,940,'Y','18','021','EC','A','','','AC','0000163009','0000163009','LA00001204938','IL','1','Hooker','Teresa','','','','34','437173686','2602 RENWICK ST',0,'MONROE','LA','71201','8058','CY','22073','1963-02-05','F','U',':RET:2054-5','N','021','DEN','707911','18575LA002000201','2014-01-01','2013-12-03 10:52:14','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 18:18:22'),(16806,13442,'Y','18','021','EC','A','','','AC','0001255381','0001255381','TX00001705492','IL','1','Rabago','Victor','','','','34','463512040','521 BOONE ST',0,'UVALDE','TX','78801','4501','CY','48463','1977-06-26','M','U',NULL,'N','021','DEN','2341989','33348TX002000201','2014-02-01','2014-01-11 13:24:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:18:14'),(5633,4468,'Y','18','021','EC','A','','','AC','0000706163','0000706163','OH00000382142','IL','1','Harris','Janet','','','','34','288547119','2371 CALL RD',0,'STOW','OH','44224','1538','CY','39153','1956-09-20','F','M',':RET:2106-3','N','021','DEN','794715','99734OH005000401','2014-01-01','2013-11-26 15:56:22','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:31:01'),(3095,2487,'Y','18','021','EC','A','','','AC','0000053034','0000053034','OH00001216237','31','1','STEPHENS','RANDALL','','','','34','296426118','PO BOX 187',0,'WILLARD','OH','44890',NULL,'CY','39077','1953-11-27','M','M',':RET:2106-3','N','021','HLT','479101','92036OH005002706','2014-01-01','2013-12-06 16:49:18','870.00',NULL,NULL,'877.46','7.46','R-OH006','OH0','529.21',NULL,0,'2013-12-25 20:20:06'),(3022,2430,'Y','18','021','EC','A','','','AC','0000718888','0000718888','OH00000235178','IL','1','Smith','Patricia','','','','34','284504797','3587 State Route 83',0,'Millersburg','OH','44654',NULL,'CY','39075','1950-10-15','F','U',':RET:2106-3','N','021','HLT','17684','52664OH151001305','2014-01-01','2013-12-06 10:02:04','584.00',NULL,NULL,'658.32','74.32','R-OH014','OH0','658.32',NULL,0,'2013-12-25 20:18:10'),(18774,14956,'N','19','021','EC','A',NULL,NULL,'','0000794535','0001089578','','IL','1','swope','aiden','','','','34','830615291','13391 WARDLOW RD',0,'SARDINIA','OH','45171','9706','CY','39015','2012-06-06','M','',':RET:2106-3','N','021','HLT','2984581','92036OH004000601','2014-02-01','2014-01-15 18:35:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-17 03:35:51'),(19389,15457,'Y','18','024','14','A','','','TE','0000633720','0000633720','','IL','1','KIPKER','DENISE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-25','F','',NULL,NULL,NULL,'','819597','','2014-01-21','2014-01-21 11:00:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:47'),(26462,20989,'Y','18','021','EC','A','','','AC','0001232720','0001232720','LA00002831959','IL','1','leboeuf','paula','','','','34','439356147','104 Acapulco Ct',0,'Houma','LA','70363',NULL,'CY','22109','1967-06-21','F','M',':RET:2106-3','N','021','DEN','3627483','18575LA002000201','2014-04-01','2014-02-27 13:28:11','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61','CIC',0,'2014-02-28 07:30:31'),(26770,21217,'Y','18','021','EC','A','','','AC','0000650824','0000650824','OH00003465600','IL','1','Reser','Kimberly','','','','34','289749640','4478 St Rt 121',0,'Greenville','OH','45331',NULL,'CY','39037','1963-06-21','F','M',':RET:2106-3','N','021','HLT','2725909','92036OH004000501','2014-04-01','2014-02-28 18:08:39','830.00',NULL,NULL,'855.30','25.30','R-OH003','OH0','341.36',NULL,0,'2014-03-01 21:00:07'),(27146,21492,'Y','18','021','EC','A','','','AC','0000590842','0000590842','OH00003091619','IL','1','Musarra','Dominic','Anthony','','Jr','34','292904949','33139 RoundHead Pl',0,'Solon','OH','44139',NULL,'CY','39035','1989-09-20','M','U',':RET:2106-3','N','021','DEN','3770744','99734OH005000401','2014-04-01','2014-03-03 13:12:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:49'),(7705,6100,'Y','18','021','EC','A','','','AC','0000860966','0000860966','OH00000800365','IL','1','Weber','William','Clarence','','Jr','34','282827486','440 KUEBLER RD',0,'BLANCHESTER','OH','45107','9789','CY','39027','1970-12-02','M','U',':RET:2106-3','T','021','DEN','1878935','99734OH005000401','2014-01-01','2013-12-20 09:16:35','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:01:22'),(7567,5990,'Y','18','021','EC','A','','','AC','0000750998','0000750998','OH00001276584','IL','1','Dalrymple','Janet','','','','34','268584501','20015 EISLEY RD',0,'WAPAKONETA','OH','45895','7519','CY','39011','1970-05-20','F','M',NULL,'N','021','HLT','367925','92036OH004001501','2014-01-01','2013-12-15 10:45:36','0.00',NULL,NULL,'240.14','240.14','R-OH002','OH0','240.14',NULL,0,'2013-12-26 02:33:39'),(16359,13091,'N','01','021','EC','A',NULL,NULL,'','0001071792','0001053069','','IL','1','Payton','Rodney','Lee','','','34','273822019','1765 WINCHESTER RD',0,'XENIA','OH','45385','7632','CY','39057','1979-03-16','M','',':RET:2106-3','N','021','DEN','2423445','99734OH005000301','2014-02-01','2014-01-06 14:27:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:41'),(14966,11962,'Y','18','021','EC','A','','','AC','0000451709','0000451709','TX00001555551','IL','1','YOUNG','CYNTHIA','','','','34','463136014','6504 COUNTY ROAD 35',0,'TYLER','TX','75706','8248','CY','48423','1957-01-01','F','M',':RET:2054-5','N','021','DEN','1815748','33348TX002000201','2014-02-01','2013-12-30 11:38:48','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-01-01 12:00:39'),(14582,11637,'Y','18','021','EC','A','','','AC','0002002640','0002002640','LA00001126706','IL','1','Froeba','Jonathan','','','','34','433254252','111 GRAND ISLAND ST',0,'BELLE CHASSE','LA','70037','2513','CY','22075','1975-07-24','M','U',':RET:2106-3','T','021','DEN','1623506','18575LA002000101','2014-02-01','2013-12-27 17:34:52','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-28 03:35:53'),(9743,7715,'Y','18','021','EC','A','','','AC','0000776666','0000776666','TX00000689715','IL','1','Price','Norma','','','','34','236083573','5 PAVEY CIR',0,'NEW WAVERLY','TX','77358','3988','CY','48471','1960-11-17','F','U',':RET:2106-3','T','021','DEN','729504','33348TX002000201','2014-01-01','2013-11-15 15:23:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:45:58'),(22166,17690,'Y','18','021','EC','A','','','AC','0001133975','0001133975','OH00002100906','IL','1','Hazelwood','Mark','','','','34','279840264','1201 st.rt. 1312',0,'milford','OH','45150',NULL,'CY','39025','1969-10-04','M','U',NULL,'T','021','HLT','2936998','92036OH006000601','2014-03-01','2014-02-08 15:56:32','152.00',NULL,NULL,'273.51','121.51','R-OH005','OH0','273.51',NULL,0,'2014-02-08 19:01:01'),(25586,20297,'Y','18','021','EC','A','','','AC','0000304855','0000304855','LA00002871023','31','1','LaHaye','DeAnna','','','','34','438868322','32 Hyacinth Dr.',0,'Covington','LA','70433',NULL,'CY','22103','1952-11-13','F','U',':RET:2106-3','N','021','DEN','2963157','18575LA002000201','2014-04-01','2014-02-23 22:56:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-26 08:00:40'),(26991,21379,'N','01','021','EC','A',NULL,NULL,'','0001104868','0000257738','','IL','1','Boteler','Dawn','','','','34','427390902','214 BOTELER RD',0,'FLORENCE','MS','39073','8993','CY','28121','1964-05-02','F','',':RET:2106-3','N','021','DEN','2898827','46300MS002000101','2014-04-01','2014-03-02 17:08:57',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-03 01:00:42'),(28230,22335,'Y','18','024','14','A','','','TE','0000528303','0000528303','','IL','1','fletcher','deitra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-11-08','F','',NULL,NULL,NULL,'','2693691','','2014-03-06','2014-03-06 14:13:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-06 21:30:22'),(920,763,'Y','18','021','EC','A','','','AC','0000878251','0000878251','OH00000664220','IL','1','Jones','Jason','Lee','','','34','284744340','2600 State Route 136',0,'Hillsboro','OH','45133',NULL,'CY','39071','1977-11-08','M','U',':RET:2106-3','T','021','HLT','1657407','92036OH004000601','2014-01-01','2013-12-16 17:37:59','199.00',NULL,NULL,'244.17','45.17','R-OH005','OH0','244.17',NULL,0,'2013-12-25 18:08:47'),(15445,12359,'Y','18','021','EC','A','','','AC','0000710817','0000710817','TX00000646938','IL','1','Bean','Patricia','','','','34','464907321','1818 2ND AVE N',0,'TEXAS CITY','TX','77590','7324','CY','48167','1951-04-12','F','U',NULL,'T','021','DEN','1665198','33348TX002000201','2014-02-01','2013-12-31 14:47:45','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:28:10'),(7465,5907,'Y','18','021','EC','A','','','AC','0000771437','0000771437','MS00000888246','IL','1','Abbott','Joseph','','','','34','428089861','127 HAMPTON HILL BLVD',0,'CANTON','MS','39046','4409','CY','28089','1964-10-11','M','U',':RET:2106-3','N','021','DEN','417442','46300MS002000201','2014-01-01','2013-12-15 16:55:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:31:00'),(1926,1569,'N','19','021','EC','A',NULL,NULL,'','0001162559','0000171201','','IL','1','McAllister','Owen','','','','34','218654386','7019 DORAN DR',0,'NEW ALBANY','OH','43054','9320','CY','39049','2002-12-31','M','',':RET:2106-3','N','021','DEN','1165593','99734OH005000301','2014-01-01','2013-11-20 12:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:00:16'),(6706,5316,'N','01','021','EC','A',NULL,NULL,'','0001011518','0000598712','','IL','1','rigdon','wesia','may','','','34','403192972','1112 millston road box 286',0,'Aberdeen','OH','45101',NULL,'CY','39015','1966-10-15','F','',':RET:2106-3','T','021','HLT','630282','92036OH006000601','2014-01-01','2013-11-04 19:57:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','306.01',NULL,0,'2013-12-26 01:02:03'),(5427,4309,'Y','18','021','EC','A','','','AC','0000233150','0000233150','MS00000696131','IL','1','ALLEN','EARL','','','','34','587729261','6480 SHADY LN',0,'WEST POINT','MS','39773','4651','CY','28025','1952-09-13','M','U',NULL,'N','021','DEN','2589718','46300MS002000201','2014-01-01','2013-12-19 17:37:47','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 23:09:32'),(14098,11234,'Y','18','024','14','A','','','TE','0000179875','0000179875','','IL','1','creatura','christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-09-16','M','',NULL,NULL,NULL,'','278291','','2013-12-26','2013-12-26 11:45:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:01:30'),(18627,14848,'N','19','021','EC','A',NULL,NULL,'','0000333893','0000532131','','IL','1','Scott','Morgan','T','','','34','280026894','9380 Hunt Club Trail NE',0,'Warren','OH','44484',NULL,'CY','39155','1997-07-05','F','',':RET:2106-3','N','021','HLT','1745173','92036OH001003201','2014-02-01','2014-01-15 17:34:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','185.41',NULL,0,'2014-01-16 08:47:30'),(18718,14921,'Y','18','021','EC','A','','','AC','0000175128','0000175128','OH00001742858','IL','1','Ervin','John','','','','34','274662194','277 Waterside Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1960-08-12','M','M',':RET:2054-5','N','021','DEN','1817250','99734OH005000301','2014-02-01','2014-01-15 22:58:32','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:35:33'),(18941,15091,'N','01','021','EC','A',NULL,NULL,'','0001060937','0000175130','','IL','1','post','debbie','','','','34','405989801','4823 PARKSIDE DR',0,'SOUTH LEBANON','OH','45065','1383','CY','39165','1960-02-05','F','',NULL,'N','021','DEN','2692844','99734OH005000401','2014-03-01','2014-01-17 12:19:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:05:43'),(19970,15929,'Y','18','021','EC','A','','','AC','0000951831','0000951831','OH00001798185','31','1','MALTRY','LINDA','L','','','34','272687352','PO BOX 204',0,'GRAND RIVER','OH','44045',NULL,'CY','39085','1959-05-16','F','M',':RET:2106-3','N','021','DEN','1576874','99734OH005000301','2014-03-01','2014-01-25 11:17:03','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-25 19:00:11'),(20756,16583,'N','19','021','EC','A',NULL,NULL,'','0000152011','0000713663','','IL','1','Henry','Lily',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1998-05-26','F','',':RET:2106-3','N','021','HLT','3188235','92036OH005001201','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-01-30 21:01:32'),(26332,20891,'Y','18','024','14','A','','','TE','0000384444','0000384444','','IL','1','FRANKOWSKI','DAVID',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-06-19','M','',NULL,NULL,NULL,'','2887311','','2014-02-27','2014-02-27 10:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:31:41'),(28134,22264,'Y','18','021','EC','A','','','AC','0000035818','0000035818','OH00003758229','IL','1','FREED','GUY','','','','34','295561708','1817 A HIGBY',0,'STOW','OH','44224',NULL,'CY','39153','1952-12-09','M','M',':RET:2106-3','T','021','HLT','3000466','52664OH151001304','2014-04-01','2014-03-06 15:30:27','952.00',NULL,NULL,'1325.89','373.89','R-OH012','OH0','720.65',NULL,0,'2014-03-06 21:02:26'),(17525,14011,'Y','18','021','EC','A','','','AC','0000122992','0000122992','OH00001739089','IL','1','DORDICK','DANIEL','','','','34','130707015','2376 N STAR RD',0,'COLUMBUS','OH','43221',NULL,'CY','39049','1984-01-25','M','U',NULL,'N','021','DEN','1483164','99734OH005000401','2014-02-01','2014-01-12 13:48:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 03:01:39'),(9154,7261,'Y','18','021','EC','A','','','AC','0000619628','0000619628','OH00000968455','IL','1','McGinnis','Kristin','','','','34','300846593','1002 WASHINGTON ST',0,'GENOA','OH','43430','1432','CY','39123','1986-08-28','F','U',NULL,'N','021','HLT','2378329','92036OH004002701','2014-01-01','2013-12-17 22:37:37','163.11',NULL,NULL,'164.31','1.20','R-OH006','OH0','164.31',NULL,0,'2013-12-26 04:08:31'),(15218,12164,'Y','18','021','EC','A','','','AC','0002149674','0002149674','LA00000074531','IL','1','Terrell Remble','Theresa','','','','34','434815936','1021 Quail Creek Rd',0,'Shreveport','LA','71105',NULL,'CY','22017','1974-09-06','F','U',':RET:2054-5','N','021','DEN','2613715','18575LA002000101','2014-02-01','2013-12-29 23:29:46','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-01 12:07:54'),(7965,6305,'Y','18','021','EC','A','','','AC','0001181843','0001181843','MS00000903763','IL','1','BROWN','GAIL','M','','','34','587170080','106 COTTON ACRES DR',0,'CLINTON','MS','39056',NULL,'CY','28049','1958-06-08','F','M',':RET:2054-5','N','021','DEN','1642156','46300MS002000201','2014-01-01','2013-12-20 14:45:29','0.00',NULL,NULL,'56.37','56.37','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:32'),(15203,12151,'Y','18','021','EC','A','','','AC','0001225869','0001225869','MS00001829241','IL','1','ROBINSON','ANDREA','','','','34','587485187','302 MAX COVE',0,'MADISON','MS','39110',NULL,'CY','28089','1966-12-20','F','M',':RET:2106-3','N','021','DEN','1735247','46300MS002000201','2014-02-01','2013-12-30 13:16:22','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-01 12:07:28'),(7964,6304,'Y','18','021','EC','A','','','AC','0000240163','0000240163','MS00000549463','IL','1','Boone','Mary','Melissa','','','34','426372507','236 CHARLENE DR',0,'BYRAM','MS','39272','6418','CY','28049','1964-05-03','F','M',':RET:2106-3','T','021','DEN','2279010','46300MS002000201','2014-01-01','2013-12-20 12:55:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:31'),(4063,3246,'Y','18','021','EC','A','','','AC','0001069310','0001069310','OH00000740056','IL','1','Bryant','Jamal','','','','34','276869883','14414 ROXBORO AVE',0,'CLEVELAND','OH','44111','1329','CY','39035','1971-09-15','M','M',':RET:2054-5','N','021','DEN','1365117','99734OH005000401','2014-01-01','2013-12-17 16:14:46','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:44'),(14645,11688,'Y','18','021','EC','A','','','AC','0001000495','0001000495','TX00000167378','IL','1','Cortez','Consuelo','','','','34','454295855','2602 33RD AVE N',0,'TEXAS CITY','TX','77590','3839','CY','48167','1949-09-25','F','U',NULL,'N','021','DEN','1660786','33348TX002000101','2014-02-01','2013-12-27 21:46:49','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,1,'2013-12-29 11:07:34'),(25544,20265,'Y','18','021','EC','A','','','AC','0001081860','0001081860','OH00002072935','IL','1','Toth','Andrew','','','','34','288909284','14754 N. Gallatin Blvd.',0,'Brook Park','OH','44142',NULL,'CY','39035','1989-07-25','M','U',':RET:2106-3','N','021','DEN','3836944','99734OH005000401','2014-04-01','2014-02-22 20:56:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 08:00:14'),(25915,20550,'Y','18','021','EC','A','','','AC','0001194395','0001194395','TX00002716364','IL','1','baker','tina','','','','34','459599616','408 CAROTHERS AVE',0,'ROCHESTER','TX','79544','2131','CY','48207','1975-04-20','F','U',':RET:2106-3','T','021','DEN','3716664','33348TX002000201','2014-03-01','2014-02-26 14:58:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:17'),(7434,5883,'Y','18','021','EC','A','','','AC','0000866880','0000866880','OH00000614031','IL','1','Parks','Rebecca','Kay','','','34','301849086','891 SCHOCALOG RD',0,'AKRON','OH','44320','1049','CY','39153','1977-07-11','F','U',':RET:2106-3','N','021','HLT','505014','52664OH151001305','2014-01-01','2013-12-14 19:38:51','188.00',NULL,NULL,'274.30','86.30','R-OH012','OH0','274.30',NULL,0,'2013-12-26 02:30:13'),(17396,13920,'Y','18','021','EC','A','','','AC','0000197163','0000197163','OH00002519201','IL','1','patterson','jolene','','','','34','289641081','34883 lakeshore Blvd.',0,'timberlake','OH','44095',NULL,'CY','39085','1962-12-02','F','U',':RET:2106-3','T','021','DEN','1910799','99734OH005000401','2014-02-01','2014-01-10 17:15:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 03:00:13'),(2127,1746,'Y','18','021','EC','A','','','AC','0001066955','0001066955','OH00000463173','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','DEN','307480','99734OH005000401','2014-01-01','2013-12-10 14:49:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:51'),(2593,2106,'N','19','021','EC','A',NULL,NULL,'','0000474926','0000112904','','IL','1','Toth','Caroline',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-05-01','F','',':RET:2106-3','N','021','DEN','223776','99734OH005000401','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:07'),(16585,13266,'Y','18','021','EC','A','','','AC','0002273731','0002273731','LA00000261754','IL','1','Bruhnke','Pamela','','','','34','023463411','173 Lola Circle',0,'Benton','LA','71006',NULL,'CY','22015','1954-10-19','F','U',':RET:2106-3','N','021','DEN','1556987','18575LA002000201','2014-02-01','2014-01-07 14:44:32','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-08 18:23:59'),(3081,2476,'Y','18','021','EC','A','','','AC','0000159388','0000159388','OH00000873661','IL','1','McPheron','Poleena','','','','34','286585088','3391 Kenyon Dr.',0,'Lima','OH','45805',NULL,'CY','39003','1957-08-15','F','M',':RET:2106-3','N','021','HLT','710596','92036OH002001501','2014-01-01','2013-12-06 14:43:04','445.00',NULL,NULL,'592.95','147.95','R-OH002','OH0','592.95',NULL,0,'2013-12-25 20:19:44'),(15438,12352,'Y','18','024','14','A','','','TE','0000179377','0000179377','','IL','1','JENKINS','ANDREW','BERNARD',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-27','M','',NULL,NULL,NULL,'','2066119','','2013-12-31','2013-12-31 13:46:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:27:58'),(3849,3079,'Y','18','021','EC','A','','','AC','0000776457','0000776457','LA00001037603','IL','1','Smith','Ricky','','','','34','433356400','9137 BEECHWOOD DR',0,'BASTROP','LA','71220','4801','CY','22067','1976-06-14','M','U',':RET:2054-5','N','021','DEN','512256','18575LA002000101','2014-01-01','2013-12-13 12:35:45','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 21:35:35'),(13851,11053,'N','19','021','EC','A',NULL,NULL,'','0000536920','0000661348','','IL','1','Cavin','Jael','Addyson','','','34','300152851','3714 Drexel Dr',0,'Toledo','OH','43612',NULL,'CY','39095','2010-08-15','F','',NULL,'N','021','HLT','1393906','92036OH002002601','2014-01-01','2013-12-23 15:11:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2013-12-26 13:12:35'),(4078,3259,'Y','18','021','EC','A','','','AC','0000820988','0000820988','OH00000942250','IL','1','White','Helen','','','','34','402761495','233 GRANDVIEW BLVD',0,'RITTMAN','OH','44270','1617','CY','39169','1950-10-21','F','M',NULL,'N','021','HLT','2114355','52664OH152000901','2014-01-01','2013-12-17 11:47:05','319.00',NULL,NULL,'482.18','163.18','R-OH014','OH0','482.18',NULL,0,'2013-12-25 21:47:07'),(13682,10917,'Y','18','021','EC','A','','','AC','0000168884','0000168884','OH00001070258','IL','1','Ferlito','Jake','B','','','34','302862367','1464 RIVER TRAIL DR',0,'KENT','OH','44240','2385','CY','39133','1987-10-19','M','U',':RET:2106-3','N','021','HLT','1930304','52664OH151001305','2014-01-01','2013-12-22 21:59:23','133.00',NULL,NULL,'228.36','95.36','R-OH012','OH0','228.36',NULL,0,'2013-12-26 13:08:12'),(18555,14797,'Y','18','021','EC','A','','','AC','0000491904','0000491904','OH00001553170','IL','1','gabers','robert','','','','34','268501909','855maple street',0,'napoleon','OH','43545',NULL,'CY','39069','1950-06-14','M','M',':RET:2106-3','N','021','HLT','2139302','92036OH005002601','2014-02-01','2014-01-15 10:52:02','0.00',NULL,NULL,'575.62','575.62','R-OH001','OH0','575.62',NULL,0,'2014-01-16 08:46:55'),(19620,15639,'Y','18','021','EC','A','','','AC','0000725083','0000725083','OH00001684058','IL','1','SWISSA','ALISA','','','','34','285883505','3134 BREMEN ST',0,'COLUMBUS','OH','43224','4368','CY','39049','1980-03-24','F','M',NULL,'N','021','DEN','3160880','99734OH005000401','2014-03-01','2014-01-22 18:31:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:03'),(20780,16602,'Y','18','021','EC','A','','','AC','0000361928','0000361928','TX00001404901','IL','1','Acobo','Adelfa','','','','34','720892339','10905 Acoma ST',0,'El Paso','TX','79934',NULL,'CY','48141','1959-04-28','F','M',NULL,'N','021','DEN','2907274','33348TX002000201','2014-03-01','2014-01-30 19:57:09','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:09'),(21231,16966,'N','19','021','EC','A',NULL,NULL,'','0000634849','0000953276','','IL','1','BLESSING','MAX','C','','','34','271948830','1520 QUEEN ANNES GATE',0,'WESTLAKE','OH','44145','2636','CY','39035','1991-04-09','M','',NULL,'N','021','DEN','3105087','99734OH005000301','2014-03-01','2014-02-03 11:06:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:01:09'),(23994,19078,'Y','18','021','EC','A','','','AC','0001281018','0001281018','LA00002220489','IL','1','BROWN','NATASHA','','','','34','434438983','137 TRUMAN CIRCLE',0,'THIBODAUX','LA','70301',NULL,'CY','22057','1980-03-25','F','U',':RET:2054-5','N','021','DEN','2755014','18575LA002000201','2014-03-01','2014-02-15 15:10:44','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-02-15 22:00:28'),(27389,21685,'N','01','021','EC','A',NULL,NULL,'','0001022848','0000671760','','IL','1','GROVE','ROCHELLE',NULL,NULL,NULL,NULL,NULL,'11272 LOCKPORT CT',0,'CINCINNATI','OH','45240','2327','CY','39061','1967-03-06','F','',NULL,'N','021','DEN','3970596','99734OH005000301','2014-04-01','2014-03-03 18:08:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:26'),(17900,14298,'Y','18','021','EC','A','','','AC','0000241545','0000241545','OH00001988647','IL','1','Brouse','Joseph','','','','34','287829191','2833 redcrest ln',0,'Akron','OH','44319',NULL,'CY','39153','1982-05-03','M','U',':RET:2106-3','N','021','DEN','2723831','99734OH005000401','2014-02-01','2014-01-14 18:20:19','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:23'),(7613,6024,'Y','18','021','EC','A','','','AC','0000835069','0000835069','TX00001029456','IL','1','Fanaselle','Lori','','','','34','470820619','1052 South sunset drive',0,'Donna','TX','78537',NULL,'CY','48215','1959-08-21','F','U',':RET:2106-3','N','021','DEN','1017189','33348TX002000101','2014-01-01','2013-11-17 11:21:03','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-26 02:45:41'),(15745,12596,'Y','18','021','EC','A','','','AC','0000770769','0000770769','TX00001801727','IL','1','CISNEROS','RAUL','','','','34','452911012','12776 STATE WY 186',0,'RAMONDVILLE','TX','78580',NULL,'CY','48489','1980-01-25','M','U',NULL,'N','021','DEN','1573880','33348TX002000201','2014-02-01','2014-01-02 12:41:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:00:58'),(22867,18242,'Y','18','021','EC','A','','','AC','0000491465','0000491465','MS00002259599','IL','1','simmons','barbara','','','','34','452215036','113 CREEK LN',0,'HATTIESBURG','MS','39402','3612','CY','28035','1958-01-03','F','U',':RET:2054-5','T','021','DEN','3436672','46300MS002000201','2014-03-01','2014-02-11 16:37:48','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-11 21:02:28'),(7212,5716,'Y','18','024','14','A','','','TE','0000242689','0000242689','','IL','1','Sullivan','Judith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-06','F','',NULL,NULL,NULL,'','340740','','2013-12-14','2013-12-14 06:14:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:00:58'),(16958,13573,'Y','18','021','EC','A','','','AC','0001024293','0001024293','OH00002471190','IL','1','James','Brian','','','','34','295766607','943 Wye Drive',0,'Akron','OH','44303',NULL,'CY','39153','1963-10-11','M','M',':RET:2106-3','N','021','HLT','2262952','52664OH151001305','2014-02-01','2014-01-09 08:33:00','500.00',NULL,NULL,'1065.85','565.85','R-OH012','OH0','398.29',NULL,0,'2014-01-13 02:20:05'),(4232,3369,'N','01','021','EC','A',NULL,NULL,'','0000759645','0001115506','','IL','1','Li','Angelica','','','','34','641520100','25242 SPRING IRIS LN',0,'KATY','TX','77494','5580','CY','48157','1971-11-23','F','',NULL,'N','021','DEN','1889593','33348TX002000201','2014-01-01','2013-12-17 13:03:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:50:44'),(5366,4254,'N','01','021','EC','A',NULL,NULL,'','0001259994','0000687209','','IL','1','Young','Jacqueline','L','','','34','289529232','4355 BEAL RD',0,'FRANKLIN','OH','45005','4515','CY','39165','1952-06-21','F','',':RET:2106-3','N','021','HLT','1365203','92036OH005001201','2014-01-01','2013-12-18 21:08:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2013-12-25 23:07:58'),(23090,18407,'Y','18','021','EC','A','','','AC','0001142214','0001142214','OH00002226468','IL','1','HARKLEROAD','MARGUERITE','','','','34','291529171','2526 REDGATE LN',0,'YOUNGSTOWN','OH','44511','1926','CY','39099','1952-07-13','F','U',':RET:2106-3','T','021','DEN','2756171','99734OH005000401','2014-03-01','2014-02-12 11:36:10','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-12 21:31:06'),(23838,18967,'Y','18','021','EC','A','','','AC','0000816465','0000816465','OH00002668743','IL','1','Moore','Marie','','','','34','272765969','1717 US HIGHWAY 50',0,'BATAVIA','OH','45103','8602','CY','39025','1964-06-06','F','U',':RET:2106-3','N','021','HLT','3818123','92036OH006000601','2014-03-01','2014-02-13 21:27:04','143.00',NULL,NULL,'290.44','147.44','R-OH005','OH0','290.44',NULL,0,'2014-02-14 21:31:50'),(24884,19731,'Y','18','021','EC','A','','','AC','0000495492','0000495492','OH00002258706','IL','1','Kontout','Robert','','','','34','042460933','8191 SQUIRREL HOLLOW RDG',0,'WEST CHESTER','OH','45069','2115','CY','39017','1958-05-25','M','M',':RET:2106-3','N','021','DEN','2845507','99734OH005000301','2014-03-01','2014-02-19 12:53:02','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00','CIC',0,'2014-02-20 05:37:18'),(151,126,'N','01','021','EC','A',NULL,NULL,'','0000848316','0001088241','','IL','1','Canterbury','Bert','','','','34','296743477','333 LAFAYETTE RD',0,'MEDINA','OH','44256','2335','CY','39103','1964-06-19','M','',':RET:2106-3','T','021','HLT','1250349','52664OH152000901','2014-01-01','2013-12-05 15:24:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','320.46',NULL,0,'2013-12-25 17:18:55'),(17782,14206,'Y','18','021','EC','A','','','AC','0000312205','0000312205','OH00002080236','IL','1','Gray','Carmen','','','','34','120569284','1215 W 10th St',0,'Cleveland','OH','44113',NULL,'CY','39035','1970-03-25','F','U',NULL,'T','021','HLT','1533749','92036OH005000804','2014-02-01','2014-01-13 12:58:35','138.00',NULL,NULL,'364.85','226.85','R-OH011','OH0','364.85',NULL,0,'2014-01-14 01:33:43'),(7201,5706,'Y','18','021','EC','A','','','AC','0000500385','0000500385','OH00001197901','IL','1','Powell','Terrie','','','','34','282604214','209 WILTON DR',0,'WEST UNION','OH','45693','9623','CY','39001','1972-08-29','F','M',':RET:2106-3','N','021','DEN','14266','99734OH005000401','2014-01-01','2013-12-13 18:44:40','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:00:39'),(18827,14995,'N','01','021','EC','A',NULL,NULL,'','0001247777','0000409528','','IL','1','Duke','James','w','','','34','587645626','273 VIRLILIA RD',0,'CANTON','MS','39046',NULL,'CY','28089','1953-03-19','M','',':RET:2106-3','N','021','DEN','2633276','46300MS002000201','2014-03-01','2014-01-16 11:40:30',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-17 03:36:08'),(18910,15069,'Y','18','021','EC','A','','','AC','0000680874','0000680874','OH00001802112','IL','1','Anderson','Tanya','V','','','34','299588256','3511 willow run dr',0,'toledo','OH','43607',NULL,'CY','39095','1956-11-18','F','U',':RET:2054-5','N','021','HLT','2086684','92036OH004002601','2014-02-01','2014-01-15 20:56:26','340.00',NULL,NULL,'382.11','42.11','R-OH001','OH0','382.11',NULL,0,'2014-01-17 03:36:40'),(20011,15960,'Y','18','021','EC','A','','','AC','0000621640','0000621640','TX00001773407','IL','1','CASAS','CECILIA','ELIZABETH','','','34','450615149','2100 LAKE OMEGA ST',0,'EL PASO','TX','79936','3814','CY','48141','1968-09-27','F','U',NULL,'N','021','DEN','3063925','33348TX002000201','2014-03-01','2014-01-25 18:29:53','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-26 19:00:09'),(20274,16179,'Y','18','021','EC','A','','','AC','0001060944','0001060944','OH00002261607','IL','1','Rydarowics','Stanley','','','','34','300509677','165 MANCHESTER AVE',0,'YOUNGSTOWN','OH','44509','2306','CY','39099','1951-09-06','M','U',NULL,'N','021','DEN','2919484','99734OH005000401','2014-03-01','2014-01-28 09:35:15','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-28 21:00:25'),(22325,17826,'Y','18','021','EC','A','','','AC','0001975762','0001975762','LA00002066024','IL','1','Porter','Aaron','Damon','','','34','569970204','4229 N DERBIGNY ST',0,'NEW ORLEANS','LA','70117','4501','CY','22071','1986-03-14','M','U',':RET:2106-3','N','021','DEN','3694038','18575LA002000201','2014-03-01','2014-01-30 16:28:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 11:00:56'),(27198,21535,'Y','18','021','EC','A','','','AC','0000630775','0000630775','TX00003606875','IL','1','Turella','Marcus','','','','34','452879800','6112 Bridlington Circle',0,'Austin','TX','78745',NULL,'CY','48453','1975-02-18','M','M',NULL,'T','021','DEN','2783455','33348TX002000201','2014-04-01','2014-03-03 16:50:37','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-03 21:31:20'),(15014,12002,'Y','18','021','EC','A','','','AC','0000276285','0000276285','OH00001402819','IL','1','LI','KEMING','','','','34','284783402','3313 SHEPHERD STREET NW',0,'NORTH CANTON','OH','44720',NULL,'CY','39151','1958-05-10','F','M',':RET:2034-7','N','021','HLT','1470322','52664OH151001305','2014-02-01','2013-12-30 15:23:24','349.00',NULL,NULL,'638.92','289.92','R-OH015','OH0','497.31',NULL,0,'2014-01-01 12:02:07'),(14265,11379,'Y','18','021','EC','A','','','AC','0000560561','0000560561','OH00001136636','IL','1','Koch','Mary','','','','34','277583977','2005 STILL WATER LN',0,'MILFORD','OH','45150','4510','CY','39025','1955-08-07','F','U',':RET:2106-3','T','021','HLT','1475492','92036OH006000601','2014-02-01','2013-12-26 08:28:52','417.00',NULL,NULL,'498.84','81.84','R-OH005','OH0','498.84',NULL,0,'2013-12-27 02:05:55'),(3354,2688,'Y','18','021','EC','A','','','AC','0001226599','0001226599','TX00000898923','31','1','Thongsavanh','Thothsakanh','','','','34','586120581','929 Zarsky Drive',0,'Corpus Christi','TX','78412',NULL,'CY','48355','1974-03-02','M','U',':RET:2028-9','N','021','DEN','1729981','33348TX002000201','2014-01-01','2013-12-22 10:41:14','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 21:16:48'),(13432,10715,'Y','18','021','EC','A','','','AC','0000444907','0000444907','OH00000469582','IL','1','Skovich','Michael','','','','34','290468868','3409 RALPH AVE',0,'CLEVELAND','OH','44109','5512','CY','39035','1953-02-23','M','U',':RET:2106-3','N','021','DEN','2298485','99734OH005000301','2014-01-01','2013-12-23 12:33:24','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:04'),(6418,5088,'Y','18','021','EC','A','','','AC','0001049348','0001049348','OH00000954932','IL','1','AMES','ELIZABETH','M','','','34','302846502','1967 BEATTY RD',0,'WILMINGTON','OH','45177','9324','CY','39027','1984-08-18','F','U',':RET:2106-3','N','021','HLT','733451','92036OH003000606','2014-01-01','2013-12-11 13:58:42','229.00',NULL,NULL,'250.85','21.85','R-OH005','OH0','250.85',NULL,0,'2013-12-26 00:48:47'),(5477,4348,'Y','18','024','14','A','','','TE','0000011117','0000011117','','IL','1','baney','david',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-18','M','',NULL,NULL,NULL,'','961934','','2013-12-19','2013-12-19 10:37:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:44'),(4815,3817,'Y','18','021','EC','A','','','AC','0001152170','0001152170','OH00000744660','IL','1','Griffith','Tereasa','','','','34','275763673','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1967-07-18','F','M',':RET:2106-3','N','021','HLT','724805','92036OH003001501','2014-01-01','2013-12-07 21:58:25','431.00',NULL,NULL,'793.38','362.38','R-OH002','OH0','344.75',NULL,0,'2013-12-25 22:16:55'),(4818,3818,'N','19','021','EC','A',NULL,NULL,'','0001131417','0001231743','','IL','1','paparodis','teddy','james','','','34','271041310','250bGateway Drive',0,'milford','OH','45150',NULL,'CY','39025','1998-09-29','M','',':RET:2106-3','N','021','HLT','113807','92036OH006000601','2014-01-01','2013-12-08 06:22:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-25 22:16:59'),(20106,16042,'Y','18','021','EC','A','','','AC','0001260708','0001260708','LA00002248036','IL','1','Whitemore','Dabne','','','','34','045767695','1249 KERLEREC ST',0,'NEW ORLEANS','LA','70116','1909','CY','22071','1973-06-21','F','M',NULL,'N','021','DEN','3199807','18575LA002000201','2014-03-01','2014-01-27 16:13:22','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-27 21:00:38'),(20404,16297,'N','19','021','EC','A',NULL,NULL,'','0000067073','0000611129','','IL','1','GARCIA','ISAIAS','','','','34','629131773','4828 HARTFORD DR',0,'RIVER OAKS','TX','76114','3003','CY','48439','2007-11-15','M','',NULL,'N','021','DEN','3219634','33348TX002000201','2014-03-01','2014-01-29 15:58:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-01-29 21:00:22'),(23749,18906,'N','19','021','EC','A',NULL,NULL,'','0000137619','0000134622','','IL','1','MIDAMBA','REHEMA','','','','34','292983524','3909 PINE CREST DRIVE',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1995-11-29','F','',':RET:2054-5','N','021','DEN','2972052','99734OH005000301','2014-03-01','2014-02-14 05:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:06'),(26086,20687,'N','01','021','EC','A',NULL,NULL,'','0001181931','0001627556','','IL','1','Le','Phuong','Thi Thuy','','','34','456792791','1159 SANTA MARIA DR',0,'MARRERO','LA','70072','2559','CY','22051','1966-12-31','F','',':RET:2047-9','N','021','DEN','3626002','18575LA002000201','2014-03-01','2014-02-26 22:37:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-28 06:30:06'),(28026,22179,'Y','18','021','EC','A','','','AC','0001002229','0001002229','OH00002873986','IL','1','BARNES','EMILY','','','','34','295902481','2708 ACORN DR',0,'KETTERING','OH','45419','2336','CY','39113','1986-06-28','F','U',NULL,'N','021','DEN','3244657','99734OH005000401','2014-04-01','2014-03-06 15:41:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-06 21:01:24'),(28319,22406,'Y','18','021','EC','A','','','AC','0000042397','0000042397','TX00002836016','IL','1','Ward','Ebony','Latracy','','','34','465794570','120 Delmar St',0,'San Antonio','TX','78210',NULL,'CY','48029','1986-12-10','F','M',':RET:2054-5','N','021','DEN','3816235','33348TX002000201','2014-04-01','2014-03-06 18:23:50','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-07 21:30:03'),(28329,22415,'Y','18','024','14','A','','','TE','0000872922','0000872922','','IL','1','Denbow','Jayna','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-20','F','',NULL,NULL,NULL,'','3682816','','2014-03-07','2014-03-07 00:39:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-07 21:30:09'),(7842,6210,'Y','18','021','EC','A','','','AC','0001218534','0001218534','OH00000947412','IL','1','JOHNSON','KATHI','R','','','34','278605483','530 NORTHFIELD RD',0,'BEDFORD','OH','44146','2304','CY','39035','1958-07-14','F','U',':RET:2054-5','N','021','DEN','1586505','99734OH005000301','2014-01-01','2013-12-19 23:05:17','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:04:38'),(7604,6017,'Y','18','021','EC','A','','','AC','0000137530','0000137530','OH00001033083','IL','1','Nelson','Sharon','','','','34','270527968','7962 WOODRUSH DR NW',0,'NORTH CANTON','OH','44720','5719','CY','39151','1951-01-24','F','U',':RET:2106-3','N','021','DEN','759390','99734OH005000401','2014-01-01','2013-11-17 15:05:35','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 02:45:27'),(22460,17933,'Y','18','021','EC','A','','','AC','0000244888','0000244888','TX00002493018','IL','1','KING','BRENDA','','','','34','458041626','186 COUNTY ROAD 2437',0,'MINEOLA','TX','75773','2997','CY','48499','1953-12-20','F','M',':RET:2106-3','N','021','DEN','3387566','33348TX002000201','2014-03-01','2014-02-10 16:03:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 21:30:52'),(24700,19609,'Y','18','021','EC','A','','','AC','0000194106','0000194106','OH00003008678','S1','1','tucker','christopher','','','','34','291068322','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2001-12-03','M','U',':RET:2106-3','N','021','DEN','3274450','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:34:05'),(26736,21190,'Y','18','021','EC','A','','','AC','0000366339','0000366339','OH00003329200','IL','1','Cappel','Raymond','','','','34','291428621','4127 W FORK RD',0,'CINCINNATI','OH','45247','7556','CY','39061','1954-04-17','M','M',':RET:2106-3','N','021','HLT','3871477','92036OH004001201','2014-04-01','2014-02-28 14:56:44','0.00',NULL,NULL,'817.85','817.85','R-OH004','OH0','449.32',NULL,0,'2014-02-28 21:31:52'),(13137,10478,'Y','18','021','EC','A','','','AC','0000950675','0000950675','OH00001169909','IL','1','Couch','Pam','','','','34','282586336','1621 STAHLHEBER RD',0,'HAMILTON','OH','45013','1919','CY','39017','1954-12-27','F','M',NULL,'N','021','DEN','2122248','99734OH005000401','2014-01-01','2013-12-23 15:21:33','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:11'),(1023,838,'Y','18','021','EC','A','','','AC','0000208459','0000208459','OH00000193298','IL','1','Doherty','Kristen','','','','34','290926497','1269 CLEVELAND AVE',0,'MADISON','OH','44057','1513','CY','39085','1987-05-29','F','U',':RET:2106-3','N','021','HLT','22879','52664OH152000901','2014-01-01','2013-12-03 14:50:13','176.00',NULL,NULL,'188.65','12.65','R-OH011','OH0','188.65',NULL,0,'2013-12-25 18:15:18'),(17174,13742,'Y','18','021','EC','A','','','AC','0000338890','0000338890','OH00001574023','IL','1','Weisel','Raymond','','','','34','269843030','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1976-09-08','M','M',':RET:2106-3','N','021','DEN','2412958','99734OH005000301','2014-02-01','2014-01-08 00:22:02','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:22:09'),(7872,6227,'Y','18','021','EC','A','','','AC','0001119947','0001119947','OH00001293731','IL','1','Bougie','Kristine','','','','34','288520364','615 Stanley Street',0,'Middletown','OH','45044',NULL,'CY','39017','1950-09-27','F','U',':RET:2106-3','N','021','DEN','1659055','99734OH005000301','2014-01-01','2013-12-20 16:08:59','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:05:12'),(1664,1390,'Y','18','021','EC','A','','','AC','0000563953','0000563953','TX00001589426','IL','1','Hollis','James','','','','34','431023754','3400 Doe Run',0,'Austin','TX','78748',NULL,'CY','48453','1951-09-14','M','M',':RET:2106-3','N','021','DEN','1543620','33348TX002000201','2014-01-01','2013-12-24 17:38:15','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:53:43'),(5817,4620,'N','19','021','EC','A',NULL,NULL,'','0000876732','0000969804','','IL','1','Ghneim','Nizar','Said','','','34','601686489','5807 MANCHESTER DR',0,'RICHARDSON','TX','75082','2709','CY','48085','1988-08-01','M','',':RET:2106-3','N','021','DEN','1632313','33348TX002000201','2014-01-01','2013-12-23 21:56:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:47:55'),(6291,4989,'Y','18','021','EC','A','','','AC','0000021364','0000021364','OH00000916515','IL','1','Elam','Maurita','','','','34','587584345','4276 BRUMBAUGH BLVD',0,'TROTWOOD','OH','45416','1615','CY','39113','1950-09-15','F','M',':RET:2054-5','N','021','DEN','17632','99734OH005000401','2014-01-01','2013-12-11 00:25:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:45:38'),(19682,15685,'Y','18','021','EC','A','','','AC','0000031016','0000031016','TX00002043676','IL','1','HOLMES','GERALD','','','','34','585279535','3773 SEPTEMBER ST',0,'WILLS POINT','TX','75169','5821','CY','48467','1970-03-05','M','M',NULL,'N','021','DEN','2248682','33348TX002000201','2014-03-01','2014-01-23 10:02:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:38'),(20755,16583,'N','19','021','EC','A',NULL,NULL,'','0000152011','0000485891','','IL','1','Henry','Grace',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','2000-10-14','F','',':RET:2106-3','N','021','HLT','3188235','92036OH005001201','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-01-30 21:01:32'),(20966,16754,'Y','18','021','EC','A','','','AC','0001251842','0001251842','TX00002416590','IL','1','GONZALEZ','ERIC','','','','34','547539623','2205 CUELLAR CT',0,'LAREDO','TX','78040','1010','CY','48479','1978-03-31','M','M',NULL,'N','021','DEN','3345620','33348TX002000201','2014-03-01','2014-02-01 12:16:12','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2014-02-01 19:00:12'),(24277,19280,'Y','18','021','EC','A','','','AC','0000614158','0000614158','OH00001776179','IL','1','Haggard','Hollis','Wright','','III','34','284785842','3311 NEW YEAR DR',0,'CINCINNATI','OH','45251','1110','CY','39061','1978-08-18','M','U',':RET:2106-3','N','021','DEN','3829545','99734OH005000401','2014-04-01','2014-02-18 13:07:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-18 21:30:04'),(24941,19779,'Y','18','021','EC','A','','','AC','0000992656','0000992656','MS00002810108','IL','1','HUGHES','CAROLINE','','','','34','587473535','133 ASHTON DR',0,'BRANDON','MS','39047',NULL,'CY','28121','1967-04-07','F','U',NULL,'N','021','DEN','3767833','46300MS002000201','2014-04-01','2014-02-19 21:54:42','40.52',NULL,NULL,'72.22','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-20 22:00:05'),(26971,21368,'Y','18','021','EC','A','','','AC','0000987482','0000987482','TX00002908272','IL','1','Craft','Mitchell','','','','34','463947114','1905 Mesa Verde Dr',0,'Deer Park','TX','77536',NULL,'CY','48201','1959-09-24','M','U',':RET:2106-3','N','021','DEN','3453609','33348TX002000101','2014-04-01','2014-03-02 16:07:56','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-03 01:00:34'),(821,679,'N','01','021','EC','A',NULL,NULL,'','0000486934','0001229298','','IL','1','STUCK-BRUSAC','PATRICIA','A','','','34','269605509','640 E PARK AVE',0,'BARBERTON','OH','44203','3442','CY','39153','1957-02-17','F','',':RET:2106-3','N','021','HLT','2256358','52664OH151001305','2014-01-01','2013-12-16 13:27:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-25 18:06:05'),(18898,15058,'Y','18','021','EC','A','','','AC','0000532133','0000532133','OH00001852492','IL','1','dailey','victoria','','','','34','280520126','1301 N MCDONEL ST',0,'LIMA','OH','45801','2734','CY','39003','1951-08-10','F','M',':RET:2106-3','N','021','HLT','2452311','92036OH002001501','2014-03-01','2014-01-16 11:24:02','356.00',NULL,NULL,'730.20','374.20','R-OH002','OH0','730.20',NULL,0,'2014-01-17 03:36:35'),(3490,2802,'Y','18','021','EC','A','','','AC','0001114530','0001114530','OH00000197981','IL','1','Baker','David','','','','34','278780042','6557 FOXTAIL LN',0,'LIBERTY TOWNSHIP','OH','45044','8332','CY','39017','1974-06-24','M','M',NULL,'N','021','DEN','1428182','99734OH005000401','2014-01-01','2013-12-22 14:01:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:20:25'),(4677,3707,'N','01','021','EC','A',NULL,NULL,'','0000620347','0000999397','','IL','1','JOESPH','RONALD','J','','','34','437237959','314 1 ST',0,'CHATAIGNIER','LA','70524',NULL,'CY','22039','1966-03-29','M','',':RET:2054-5','N','021','DEN','27560','18575LA002000201','2014-01-01','2013-12-12 15:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:46'),(7867,6226,'Y','18','021','EC','A','','','AC','0000328405','0000328405','OH00000053969','IL','1','Miller','Timothy','','','','34','300807095','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1965-12-24','M','M',':RET:2106-3','N','021','DEN','2279031','99734OH005000301','2014-01-01','2013-12-20 15:42:29','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:05:08'),(7203,5707,'Y','18','021','EC','A','','','AC','0000566603','0000566603','OH00000897242','IL','1','Pallotta','Brian','','','','34','293765069','8070 BAINBRIDGE RD',0,'CHAGRIN FALLS','OH','44023','4716','CY','39055','1980-11-21','M','M',':RET:2106-3','N','021','DEN','856599','99734OH005000401','2014-01-01','2013-12-13 19:09:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:41'),(18778,14957,'N','19','021','EC','A',NULL,NULL,'','0000245016','0000694231','','IL','1','Himes','Andrew','','','','34','279929506','5696 MELODY LN',0,'MILFORD','OH','45150','2661','CY','39025','1990-04-16','M','',':RET:2106-3','N','021','HLT','2073136','92036OH004000601','2014-03-01','2014-01-16 13:23:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-01-17 03:35:51'),(5859,4652,'N','01','021','EC','A',NULL,NULL,'','0001070474','0000429043','','IL','1','SMART','BRENDA','','','','34','298807636','1660 N STADIUM RD',0,'OREGON','OH','43616','1119','CY','39095','1955-03-05','F','',NULL,'N','021','HLT','1585686','92036OH005002605','2014-01-01','2013-12-23 21:46:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','496.84',NULL,0,'2013-12-25 23:49:00'),(13406,10698,'Y','18','021','EC','A','','','AC','0000772641','0000772641','OH00001132491','IL','1','GUADIAN','ROBIN','','','','34','299725841','4667 RATHBURN DR',0,'ENGLEWOOD','OH','45322','3721','CY','39113','1965-04-18','F','U',':RET:2106-3','N','021','DEN','1652285','99734OH005000301','2014-01-01','2013-12-23 09:51:18','0.00',NULL,NULL,'59.76','59.76','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:00:28'),(14141,11272,'Y','18','024','14','A','','','TE','0001834708','0001834708','','IL','1','NGUYEN','TRAN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-05-13','F','',NULL,NULL,NULL,'','1998616','','2013-12-26','2013-12-26 12:17:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:40'),(15101,12070,'Y','18','024','14','A','','','TE','0001081806','0001081806','','IL','1','Lawson','Katariina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-04','F','',NULL,NULL,NULL,'','2257055','','2013-12-30','2013-12-30 09:25:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:04:43'),(16738,13391,'N','19','021','EC','A',NULL,NULL,'','0000674079','0000105384','','IL','1','Ferrari','Austin','T','','','34','272988638','1705 ARNDALE RD',0,'STOW','OH','44224','1850','CY','39153','1994-12-03','M','',':RET:2106-3','N','021','HLT','1624945','52664OH151001305','2014-02-01','2014-01-06 20:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:51'),(21325,17040,'N','01','021','EC','A',NULL,NULL,'','0002133329','0001310119','','IL','1','JARAMILLO','LUIS','ALBERTO','','','34','434698435','901 VOURAY DR',0,'KENNER','LA','70065',NULL,'CY','22051','1964-02-22','M','',NULL,'N','021','DEN','3617954','18575LA002000201','2014-03-01','2014-02-04 17:46:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:24'),(23366,18618,'Y','18','021','EC','A','','','AC','0001161581','0001161581','OH00002672832','31','1','ABBOTT','BRENDA','','','','34','279528500','PO BOX 654',0,'ANDOVER','MD','44003',NULL,'CY','39007','1951-10-08','F','M',NULL,'T','021','HLT','2858767','52664OH151001304','2014-03-01','2014-02-13 16:42:20','540.00',NULL,NULL,'831.01','291.01','R-OH011','OH0','831.01',NULL,0,'2014-02-13 22:00:49'),(25274,20053,'Y','18','021','EC','A','','','AC','0001203927','0001203927','TX00002433166','IL','1','Martinez','Yvette','','','','34','464730077','5531 Ghost Hawk Way',0,'SAN ANTONIO','TX','78242',NULL,'CY','48029','1975-11-14','F','U',NULL,'N','021','DEN','3142449','33348TX002000201','2014-03-01','2014-02-24 20:26:00','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61','CIC',0,'2014-02-25 21:00:14'),(25667,20363,'Y','18','021','EC','A','','','AC','0000053548','0000053548','MS00002690684','31','1','CUNNINGHAM','DARIUS','','','','34','425552578','PO BOX 1813',0,'WEST POINTE','MS','39773',NULL,'CY','28087','1986-05-04','M','U',':RET:2054-5','N','021','DEN','3009665','46300MS002000101','2014-04-01','2014-02-21 20:38:15','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-26 08:30:49'),(26848,21279,'Y','18','021','EC','A','','','AC','0001161300','0001161300','LA00003139695','IL','1','Jones','Shavonna','','','','34','438393478','2018 STANLEY ST',0,'SHREVEPORT','LA','71107','5934','CY','22017','1969-11-02','F','U',':RET:2054-5','T','021','DEN','2950523','18575LA002000201','2014-04-01','2014-03-01 15:16:18','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-01 21:00:49'),(27993,22150,'Y','18','024','14','A','','','TE','0001173225','0001173225','','IL','1','Addison','Starlette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-02','F','',NULL,NULL,NULL,'','2303235','','2014-03-20','2014-03-05 18:28:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-06 21:01:05'),(9487,7524,'Y','18','021','EC','A','','','AC','0000873237','0000873237','OH00000959806','IL','1','Dermody','Daniel','','','','34','299508793','5794 OBSERVATION CT',0,'MILFORD','OH','45150','1472','CY','39025','1952-02-24','M','M',':RET:2106-3','N','021','DEN','1444234','99734OH005000401','2014-01-01','2013-12-21 12:57:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:34:48'),(1402,1164,'Y','18','021','EC','A','','','AC','0001312762','0001312762','LA00000177548','IL','1','Ardoin','Felton','','','','34','433719795','1204 Giovanni Street',0,'Lake Charles','LA','70601',NULL,'CY','22019','1976-01-23','M','U',':RET:2054-5','N','021','DEN','2510407','18575LA002000201','2014-01-01','2013-12-24 12:25:03','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 18:46:38'),(2341,1906,'Y','18','021','EC','A','','','AC','0000093381','0000093381','TX00000992094','IL','1','Matula','Adam','','','','34','461750322','1817 CHAPEL HEIGHTS DR',0,'WHARTON','TX','77488','4459','CY','48481','1985-11-29','M','U',':RET:2106-3','N','021','DEN','316538','33348TX002000201','2014-01-01','2013-12-09 13:38:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:57'),(6248,4951,'Y','18','021','EC','A','','','AC','0000799571','0000799571','LA00000326409','IL','1','scott','kim','','','','34','434458127','8750 JAMES ST',0,'DENHAM SPRINGS','LA','70726','6305','CY','22063','1981-05-26','F','U',':RET:2106-3','N','021','DEN','227701','18575LA002000201','2014-01-01','2013-11-19 17:59:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:31:51'),(5003,3968,'Y','18','021','EC','A','','','AC','0001057965','0001057965','OH00000166389','IL','1','Bozic','Mile','','','','34','281089487','37 MEADOW CREST CIR',0,'HINCKLEY','OH','44233','9249','CY','39103','1981-05-07','M','M',':RET:2106-3','N','021','DEN','70407','99734OH005000301','2014-01-01','2013-12-07 13:41:34','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:47:11'),(16710,13373,'Y','18','021','EC','A','','','AC','0000618922','0000618922','TX00002159059','IL','1','Shuffield','Amy','','','','34','466951146','1510 APPLE LN',0,'MIDLOTHIAN','TX','76065','5413','CY','48139','1988-01-14','F','U',':RET:2106-3','N','021','DEN','2052459','33348TX002000201','2014-02-01','2014-01-06 22:47:17','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-08 18:24:42'),(28102,22243,'Y','18','021','EC','A','','','AC','0001077819','0001077819','OH00002662310','IL','1','Guilfoyle','Mary','','','','34','290543729','6034 West Smith Road',0,'Medina','OH','44256',NULL,'CY','39103','1955-05-14','F','U',':RET:2106-3','T','021','HLT','4162941','52664OH152000901','2014-04-01','2014-03-06 11:44:11','442.00',NULL,NULL,'478.62','36.62','R-OH012','OH0','478.62',NULL,0,'2014-03-06 21:02:11'),(18225,14546,'Y','18','021','EC','A','','','AC','0000608799','0000608799','TX00001762836','IL','1','Brannigan','Eric','','','','34','595609177','4305 40TH ST',0,'LUBBOCK','TX','79413','2535','CY','48303','1987-10-14','M','U',':RET:2106-3','N','021','DEN','1382625','33348TX002000201','2014-02-01','2014-01-14 19:49:43','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-16 08:44:15'),(16754,13403,'Y','18','021','EC','A','','','AC','0000776813','0000776813','TX00001458791','IL','1','Correa','Marjorie','','','','34','466902810','4931 FM 1863',0,'BULVERDE','TX','78163','2448','CY','48091','1951-04-11','F','M',':RET:2106-3','N','021','DEN','2520021','33348TX002000101','2014-02-01','2014-01-07 15:16:08','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-08 18:24:56'),(6014,4760,'N','01','021','EC','A',NULL,NULL,'','0000566578','0000011125','','IL','1','Yaslovitz','Avi','','','','34','058829650','3825 MIDDLETON AVE',0,'CINCINNATI','OH','45220','1126','CY','39061','1970-02-10','M','',':RET:2106-3','T','021','DEN','81590','99734OH005000301','2014-01-01','2013-12-01 14:36:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:40'),(9100,7223,'N','01','021','EC','A',NULL,NULL,'','0000246433','0000430262','','IL','1','ILHARDT','JOHN','','','','34','300545280','1324 LIBBY LN',0,'NEW RICHMOND','OH','45157','9163','CY','39025','1960-12-27','M','',':RET:2106-3','T','021','DEN','1490662','99734OH005000301','2014-01-01','2013-12-18 14:36:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:21'),(1077,883,'Y','18','021','EC','A','','','AC','0001174374','0001174374','OH00001035937','IL','1','LONGBOTTOM','BARBARA','','','','34','272524510','118 E WOODLAND AVE',0,'COLUMBIANA','OH','44408','1519','CY','39029','1953-01-31','F','M',':RET:2106-3','N','021','DEN','235632','99734OH005000401','2014-01-01','2013-12-03 09:20:55','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:16:40'),(8152,6449,'Y','18','021','EC','A','','','AC','0001061007','0001061007','TX00000874649','IL','1','Kornhaber','Jay','','','','34','176463848','6030 DELLFERN DR',0,'HOUSTON','TX','77035','4126','CY','48201','1953-10-20','M','U',':RET:2106-3','N','021','DEN','6296','33348TX002000201','2014-01-01','2013-11-22 11:15:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 03:16:04'),(1813,1489,'N','19','021','EC','A',NULL,NULL,'','0001166821','0000034380','','IL','1','Niklas','Sophia',NULL,NULL,NULL,NULL,NULL,'80 E CASE DR',0,'HUDSON','OH','44236','2744','CY','39153','2002-10-10','F','',':RET:2106-3','N','021','HLT','2153126','52664OH151001501','2014-01-01','2013-12-24 14:40:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 18:57:03'),(20524,16400,'Y','18','021','EC','A','','','AC','0001074180','0001074180','OH00001700554','IL','1','Morris','Robin','','','','34','277706577','3317 SEAMAN RD',0,'OREGON','OH','43616','1925','CY','39095','1963-05-02','F','U',':RET:2106-3','N','021','HLT','3516155','92036OH005002604','2014-03-01','2014-01-28 21:43:54','195.00',NULL,NULL,'348.25','153.25','R-OH001','OH0','348.25',NULL,0,'2014-01-29 21:01:27'),(22409,17893,'Y','18','021','EC','A','','','AC','0001441723','0001441723','LA00002204932','IL','1','Tardo','Magen','','','','34','439759721','2421 MARGARET LN',0,'MERAUX','LA','70075','2731','CY','22087','1985-08-05','F','M',':RET:2106-3','N','021','DEN','3656760','18575LA002000201','2014-03-01','2014-02-10 10:12:45','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:24'),(22480,17947,'Y','18','021','EC','A','','','AC','0000702811','0000702811','OH00002587151','IL','1','ruggs','aletha','','','','34','276606309','2327 Alpine Way',0,'Dayton','OH','45406',NULL,'CY','39113','1956-02-23','F','U',NULL,'N','021','DEN','3035469','99734OH005000301','2014-03-01','2014-02-09 20:40:56','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-10 21:31:02'),(22876,18246,'Y','18','021','EC','A','','','AC','0000050726','0000050726','OH00002040446','IL','1','Paris','Emmanouil','','','','34','292707847','5450 PARKS AVE',0,'LOUISVILLE','OH','44641','9522','CY','39151','1967-09-14','M','R',NULL,'N','021','HLT','3696746','52664OH151001501','2014-03-01','2014-02-11 09:18:36','0.00',NULL,NULL,'1127.10','1127.10','R-OH015','OH0','401.20',NULL,0,'2014-02-11 21:02:32'),(23865,18989,'N','03','021','EC','A',NULL,NULL,'','0001157609','0001095703','','IL','1','Wells','Virginia','Leigh','','','34','298848408','4351 IMPERIAL DR',0,'TOLEDO','OH','43615','1215','CY','39095','2013-02-11','F','',':RET:2106-3','N','021','HLT','2804017','92036OH002002601','2014-03-01','2014-02-14 09:26:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-02-14 21:32:07'),(25290,20065,'N','19','021','EC','A',NULL,NULL,'','0001104507','0001031504','','IL','1','VON AHN','AMBER','','','','34','270966197','29 Zeller Court',0,'Berea','OH','44017',NULL,'CY','39035','1992-09-22','F','',':RET:2106-3','N','021','HLT','3055167','52664OH151001306','2014-03-01','2014-02-25 13:22:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52','CIC',0,'2014-02-25 21:00:22'),(25348,20113,'Y','18','021','EC','A','','','AC','0001767808','0001767808','LA00002951725','IL','1','COOPER','SANDRA','','','','34','437982467','503 LEGACY LN',0,'RUSTON','LA','71270','4778','CY','22061','1954-02-11','F','U',NULL,'N','021','DEN','2684848','18575LA002000101','2014-04-01','2014-02-25 01:03:32','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-25 21:30:29'),(15375,12298,'Y','18','021','EC','A','','','AC','0000285651','0000285651','OH00001741342','IL','1','Penhorwood','Patti','','','','34','273741282','4245 PICKLE RD',0,'OREGON','OH','43616','5716','CY','39095','1965-01-22','F','M',':RET:2106-3','T','021','HLT','1886265','92036OH002002601','2014-02-01','2014-01-01 09:04:28','0.00',NULL,NULL,'441.80','441.80','R-OH001','OH0','441.80',NULL,1,'2014-01-02 04:25:14'),(19534,15568,'Y','18','021','EC','A','','','AC','0000408510','0000408510','OH00001592647','IL','1','copeland','mellanese','','','','34','299789324','6352 MONTGOMERY RD',0,'CINCINNATI','OH','45213','1421','CY','39061','1979-09-23','F','U',':RET:2054-5','T','021','DEN','3273848','99734OH005000401','2014-03-01','2014-01-22 12:54:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:02:21'),(21223,16959,'Y','18','021','EC','A','','','AC','0001387252','0001387252','LA00002115744','31','1','MAJOR','JOE','','','Jr','34','454432145','PO BOX 2681',0,'JENA','LA','71342',NULL,'CY','22059','1965-10-22','M','U',':RET:2054-5','N','021','DEN','2905831','18575LA002000201','2014-03-01','2014-02-03 17:28:12','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-03 21:01:05'),(23189,18490,'Y','18','021','EC','A','','','AC','0000417436','0000417436','OH00002300550','IL','1','KAMMILLER','JOHN','','','','34','296644402','9034 SKYLANE DR',0,'WADSWORTH','OH','44281','9513','CY','39103','1957-12-31','M','U',NULL,'N','021','HLT','2690888','52664OH152000901','2014-03-01','2014-02-12 09:55:43','0.00',NULL,NULL,'381.07','381.07','R-OH012','OH0','381.07',NULL,0,'2014-02-12 21:32:03'),(23465,18691,'N','19','021','EC','A',NULL,NULL,'','0000160460','0000250879','','S1','1','RUBIO','FRANCISCO','','','','34','645649074','310 E TRIPP RD',0,'SUNNYVALE','TX','75182','9591','CY','48113','1998-12-18','M','',NULL,'N','021','DEN','3007197','33348TX002000201','2014-03-01','2014-02-13 15:03:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-13 22:01:45'),(25398,20149,'Y','18','021','EC','A','','','AC','0001188843','0001188843','OH00002325089','IL','1','Miller','Julie','','','','34','282789742','714 Graham Rd',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1966-05-23','F','U',':RET:2106-3','N','021','HLT','2896171','52664OH151001306','2014-04-01','2014-02-25 14:45:28','296.00',NULL,NULL,'348.56','52.56','R-OH012','OH0','348.56',NULL,0,'2014-02-25 21:30:54'),(27022,21403,'N','17','021','EC','A',NULL,NULL,'','0000592211','0000866954','','IL','1','GREEN','BRYLER','','','','34','284027296','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1997-04-27','M','',':RET:2106-3','N','021','DEN','3725480','99734OH005000301','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:13'),(27728,21928,'Y','18','021','EC','A','','','AC','0001203023','0001203023','TX00003136043','IL','1','delfin','nicandro','','','','34','462978646','416 16TH ST',0,'HUNTSVILLE','TX','77340','5305','CY','48471','1957-05-22','M','M',NULL,'N','021','DEN','3478787','33348TX002000201','2014-04-01','2014-03-05 15:21:49','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:31:03'),(28769,22773,'Y','18','021','EC','A','','','AC','0001228129','0001228129','OH00003592636','IL','1','Stowell','Viktor','','','','34','073809955','9127 TAHOMA ST',0,'COLUMBUS','OH','43240','6025','CY','39041','1953-07-17','M','U',':RET:2106-3','N','021','DEN','4038058','99734OH005000401','2014-04-01','2014-03-09 09:47:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-09 21:00:28'),(18679,14891,'Y','18','021','EC','A','','','AC','0001251778','0001251778','TX00001841702','IL','1','DeWitt','James','','','','34','463159855','2900 Robin Rd',0,'Greenville','TX','75402',NULL,'CY','48231','1965-10-11','M','M',':RET:2106-3','T','021','DEN','2273162','33348TX002000201','2014-02-01','2014-01-15 20:08:20','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:20'),(18591,14822,'N','01','021','EC','A',NULL,NULL,'','0000827182','0000295522','','IL','1','Rotondo','Margaret','A','','','34','280527392','131 SANDY BEACH WAY',0,'CELINA','OH','45822','2723','CY','39107','1954-02-22','F','',':RET:2106-3','T','021','HLT','2665209','92036OH006001501','2014-02-01','2014-01-15 10:34:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.49',NULL,0,'2014-01-16 08:47:14'),(8126,6428,'Y','18','021','EC','A','','','AC','0000341303','0000341303','OH00000011903','IL','1','BARRINGER','SANDI','K','','','34','299565235','1299 ISLAND BAY DR',0,'COLUMBUS','OH','43235','7559','CY','39049','1957-02-22','F','U',':RET:2106-3','T','021','DEN','1168254','99734OH005000401','2014-01-01','2013-11-22 09:05:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:15:25'),(20361,16262,'Y','18','021','EC','A','','','AC','0000662729','0000662729','OH00001636723','31','1','Niese','Richard','A','','','34','268568108','PO 511',0,'Napoleon','OH','43545',NULL,'CY','39069','1953-11-28','M','U',NULL,'N','021','HLT','3556534','92036OH002002601','2014-03-01','2014-01-28 13:25:15','294.00',NULL,NULL,'611.15','317.15','R-OH001','OH0','611.15',NULL,0,'2014-01-28 21:01:20'),(23841,18969,'Y','18','021','EC','A','','','AC','0000563188','0000563188','OH00001650033','IL','1','BIKIS','ALEXANDER','','','','34','284424825','503 ARROWHEAD TRL',0,'LOVELAND','OH','45140','8505','CY','39025','1952-05-18','M','U',NULL,'T','021','HLT','2713150','92036OH005000605','2014-03-01','2014-02-14 14:12:45','440.00',NULL,NULL,'693.72','253.72','R-OH005','OH0','693.72',NULL,0,'2014-02-14 21:31:52'),(18742,14934,'Y','18','021','EC','A','','','AC','0000721364','0000721364','OH00002391683','IL','1','Anderson','Jacqueline','','','','34','269904692','33141 FAIRPORT DR',0,'AVON LAKE','OH','44012','2374','CY','39093','1981-02-23','F','U',NULL,'N','021','DEN','1728352','99734OH005000301','2014-02-01','2014-01-15 19:01:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:40'),(1004,823,'Y','18','021','EC','A','','','AC','0000414664','0000414664','OH00000636060','IL','1','raimey','lyra','','','','34','280645170','9442 CROCKETT PASS',0,'HAMILTON','OH','45011','9054','CY','39017','1963-09-13','F','U',':RET:2054-5','N','021','DEN','8760','99734OH005000301','2014-01-01','2013-10-19 11:20:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:11:03'),(17297,13833,'Y','18','021','EC','A','','','AC','0000866554','0000866554','TX00001854810','IL','1','Robbins','Lisa','','','','34','259049317','215 COUNTY ROAD 2231',0,'DOUGLASSVILLE','TX','75560','5549','CY','48067','1961-04-01','F','U',':RET:2106-3','N','021','DEN','1498231','33348TX002000201','2014-02-01','2014-01-10 11:27:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:36'),(5090,4034,'Y','18','021','EC','A','','','AC','0000332971','0000332971','TX00001219174','IL','1','INGRAM','CHARICE','R','','','34','098563576','9320 SOUTH PADRE ISLAND DRIVE',0,'CORPUS CHRISTI','TX','78418',NULL,'CY','48355','1966-11-08','F','M',':RET:2054-5','T','021','DEN','1472558','33348TX002000201','2014-01-01','2013-12-19 14:45:48','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 23:01:11'),(2990,2406,'Y','18','021','EC','A','','','AC','0000039780','0000039780','OH00000227639','IL','1','Schmidtbauer','Laura','','','','34','138684802','1306 Burney Lane',0,'Cincinnati','OH','45230',NULL,'CY','39061','1962-03-27','F','U',':RET:2106-3','T','021','DEN','273287','99734OH005000301','2014-01-01','2013-12-06 14:53:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:17:25'),(3600,2887,'Y','18','021','EC','A','','','AC','0000570557','0000570557','OH00000972555','IL','1','KIRCHENR','GLENN','','','','34','283686361','120 WALL ST',0,'TIFFIN','OH','44883','2146','CY','39147','1959-08-08','M','M',':RET:2106-3','T','021','HLT','1660459','92036OH003002705','2014-01-01','2013-12-22 11:37:50','804.00',NULL,NULL,'1046.31','242.31','R-OH006','OH0','499.98',NULL,0,'2013-12-25 21:23:14'),(20278,16183,'Y','18','021','EC','A','','','AC','0000105403','0000105403','OH00001689111','IL','1','Paige','Deborah','','','','34','293468589','1286B Sunrisecourt',0,'Van Wert','OH','45891',NULL,'CY','39161','1951-09-07','F','U',':RET:2086-7^:RET:2106-3','N','021','DEN','2915984','99734OH005000401','2014-03-01','2014-01-28 12:44:52','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-01-28 21:00:27'),(21065,16831,'N','01','021','EC','A',NULL,NULL,'','0000859729','0000049546','','IL','1','Czlapinski','Theodore','f','','Sr','34','290524882','747 Kipling Dr',0,'toledo','OH','43612',NULL,'CY','39095','1952-08-30','M','',':RET:2106-3','T','021','HLT','2668978','92036OH005002605','2014-03-01','2014-02-02 15:27:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','630.15',NULL,0,'2014-02-02 19:00:14'),(25027,19845,'N','01','021','EC','A',NULL,NULL,'','0000825449','0000576201','','IL','1','PHAM','LE','K','','','34','643889367','1633 Webster St.',0,'League City','TX','77573',NULL,'CY','48167','1982-10-01','F','',':RET:2047-9','N','021','DEN','3850995','33348TX002000101','2014-04-01','2014-02-20 14:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-20 22:01:00'),(26233,20806,'Y','18','024','14','A','','','TE','0000615046','0000615046','','IL','1','Birchfield','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-02-28','M','',NULL,NULL,NULL,'','2077597','','2014-03-14','2014-02-27 00:22:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-28 06:31:02'),(15434,12348,'Y','18','021','EC','A','','','AC','0001231872','0001231872','TX00000194441','IL','1','cummings','debra','','','','34','460803994','201 SPUR DR',0,'VICTORIA','TX','77904','3219','CY','48469','1957-06-02','F','U',':RET:2106-3','N','021','DEN','1455740','33348TX002000201','2014-02-01','2013-12-31 12:50:19','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,1,'2014-01-02 04:27:50'),(4355,3457,'Y','18','024','14','A','','','TE','0000896951','0000896951','','IL','1','Biggert','Robin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-26','F','',NULL,NULL,NULL,'','1147227','','2013-12-17','2013-12-17 13:29:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:53:35'),(8103,6410,'N','01','021','EC','A',NULL,NULL,'','0000781890','0001240548','','IL','1','Horrigan','Rikki','Anne','','','34','372927873','1273 SHERMAN ST',0,'AKRON','OH','44301','1811','CY','39153','1969-01-10','F','',':RET:2106-3','N','021','HLT','2141014','52664OH151001501','2014-01-01','2013-12-20 17:53:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.65',NULL,0,'2013-12-26 03:10:54'),(4535,3594,'Y','18','021','EC','A','','','AC','0000783735','0000783735','TX00000963239','IL','1','Thompson','Lonnie','','','','34','464907855','338 East FM Road 71',0,'Mount Pleasant','TX','75455',NULL,'CY','48449','1952-11-03','M','M',':RET:2106-3','N','021','DEN','1121357','33348TX002000201','2014-01-01','2013-12-12 16:49:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:10'),(21513,17188,'Y','18','024','14','A','','','TE','0000965807','0000965807','','IL','1','Schuster','Margaret',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-06','F','',NULL,NULL,NULL,'','3330307','','2014-02-28','2014-02-04 07:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-04 21:30:03'),(21762,17378,'Y','18','021','EC','A','','','AC','0001177645','0001177645','TX00002319381','IL','1','Spann','Alicia','','','','34','459891054','5494 COUNTY ROAD 6',0,'CLAUDE','TX','79019','3838','CY','48011','1977-01-28','F','M',':RET:2106-3','N','021','DEN','2631199','33348TX002000201','2014-03-01','2014-02-06 14:58:34','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-06 21:00:27'),(27945,22107,'Y','18','021','EC','A','','','AC','0000242590','0000242590','TX00002849849','IL','1','SANDERS','YVONE','','','','34','165440964','5613 SILTSTONE LOOP',0,'KILLEEN','TX','76542','5763','CY','48027','1952-09-21','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','2906700','33348TX002000201','2014-04-01','2014-03-06 15:24:46','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-03-06 21:00:35'),(34,29,'Y','18','024','14','A','','','TE','0000745405','0000745405','','IL','1','Salyers','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-03-07','M','',NULL,NULL,NULL,'','658570','','2013-12-05','2013-12-05 12:35:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:15:53'),(515,420,'Y','18','021','EC','A','','','AC','0000981581','0000981581','OH00000786931','IL','1','Bragan','Kelly','','','','34','275905674','628 CAHOON LEDGES DR',0,'BAY VILLAGE','OH','44140','2192','CY','39035','1982-07-08','F','U',':RET:2106-3','N','021','DEN','980724','99734OH005000301','2014-01-01','2013-12-04 10:50:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:49:03'),(13393,10691,'N','19','021','EC','A',NULL,NULL,'','0001057989','0001136651','','IL','1','Thomas','Eden','','','','34','276139994','5798 UNIVERSITY HEIGHTS DR',0,'ATHENS','OH','45701','9339','CY','39009','2007-02-28','F','',':RET:2106-3','N','021','DEN','2503092','99734OH005000301','2014-01-01','2013-12-23 08:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:12'),(15121,12085,'N','19','021','EC','A',NULL,NULL,'','0001063253','0000322151','','IL','1','Mcguire','Elizabeth','','','','34','290960133','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1993-11-12','F','',NULL,'N','021','DEN','2611229','99734OH005000301','2014-02-01','2013-12-30 15:51:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:14'),(4894,3882,'Y','18','021','EC','A','','','AC','0000006441','0000006441','MS00000720767','IL','1','Magnon','Keith','','','','34','435310116','13101 CAMBRIDGE BLVD',0,'OCEAN SPRINGS','MS','39564','2629','CY','28059','1964-08-30','M','U',NULL,'N','021','DEN','752014','46300MS002000101','2014-01-01','2013-10-04 12:02:51','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 22:31:37'),(5447,4327,'N','01','021','EC','A',NULL,NULL,'','0000382143','0000622473','','IL','1','XU','YINGJIE','','','','34','285040502','3824 BARLEYTON CIR',0,'SYLVANIA','OH','43560','3501','CY','39095','1968-05-03','F','',NULL,'N','021','HLT','2395141','92036OH004002601','2014-01-01','2013-12-18 22:56:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','226.41',NULL,0,'2013-12-25 23:10:04'),(9130,7241,'Y','18','024','14','A','','','TE','0000866223','0000866223','','IL','1','johnson','brenda','sue',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-12-17','F','',NULL,NULL,NULL,'','1031697','','2013-12-18','2013-12-18 10:58:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 04:07:58'),(20090,16028,'Y','18','021','EC','A','','','AC','0001323674','0001323674','LA00002333576','IL','1','MILLIGAN','DEBRA','','','','34','434047784','5545 ANDREWS LN',0,'SAINT GABRIEL','LA','70776','5439','CY','22047','1956-04-10','F','U',':RET:2054-5','N','021','DEN','1885337','18575LA002000101','2014-03-01','2014-01-27 16:35:47','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-27 21:00:29'),(23164,18467,'Y','18','024','14','A','','','TE','0000520158','0000520158','','IL','1','Greyard','Shahala',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-12-02','F','',NULL,NULL,NULL,'','305838','','2014-02-27','2014-02-12 17:20:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-12 21:31:49'),(27071,21434,'Y','18','021','EC','A','','','AC','0001340451','0001340451','LA00002084105','IL','1','Njapau','Cheryl','','','','34','439915657','11999 Longridge Ave',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1988-07-07','F','U',':RET:2054-5','N','021','DEN','3437223','18575LA002000201','2014-04-01','2014-03-03 16:23:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-03 21:30:05'),(27256,21582,'Y','18','021','EC','A','','','AC','0000267587','0000267587','OH00003220421','IL','1','Martin','Timothy','','','','34','287684526','1106 COLONIAL DR',0,'SIDNEY','OH','45365','3406','CY','39149','1964-01-13','M','U',':RET:2106-3','N','021','HLT','3512994','92036OH003000505','2014-04-01','2014-03-03 17:15:52','357.00',NULL,NULL,'443.34','86.34','R-OH003','OH0','443.34',NULL,0,'2014-03-03 21:31:56'),(18568,14808,'Y','18','021','EC','A','','','AC','0000246473','0000246473','OH00001590006','IL','1','Purcell','Joseph','','','','34','302664793','1297 HOMESITE DR',0,'STOW','OH','44224','1252','CY','39153','1959-03-14','M','M',NULL,'N','021','HLT','2884526','52664OH152000901','2014-02-01','2014-01-15 12:41:18','681.94',NULL,NULL,'681.94','0.00','R-OH012','OH0','348.73',NULL,0,'2014-01-16 08:47:03'),(14641,11685,'Y','18','021','EC','A','','','AC','0000372005','0000372005','TX00000845883','IL','1','Alaniz','Becky','','','','34','457556612','p o box 596',0,'Natalia','TX','78059',NULL,'CY','48325','1981-04-19','F','U',NULL,'N','021','DEN','2088593','33348TX002000101','2014-02-01','2013-12-28 16:11:39','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,1,'2013-12-29 11:07:26'),(1135,934,'Y','18','021','EC','A','','','AC','0000648469','0000648469','LA00000175257','IL','1','Harper','Robert','','','','34','438983711','38308 LEVI CRAWFORD LN',0,'PEARL RIVER','LA','70452','4632','CY','22103','1956-03-13','M','M',':RET:2106-3','N','021','DEN','1103562','18575LA002000201','2014-01-01','2013-12-02 21:56:24','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:10'),(5328,4225,'Y','18','021','EC','A','','','AC','0000895700','0000895700','OH00000183660','IL','1','Sullivan','Bartholomew','','','','34','269828832','1776 24th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1983-10-07','M','U',':RET:2106-3','N','021','DEN','1923600','99734OH005000301','2014-01-01','2013-12-19 11:18:55','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:07:01'),(1658,1385,'Y','18','021','EC','A','','','AC','0001046406','0001046406','TX00001498662','IL','1','hilliard','joesph','','','','34','315020759','2420 YORKTOWN ST',0,'HOUSTON','TX','77056','4527','CY','48201','1981-07-17','M','U',':RET:2106-3','N','021','DEN','1694854','33348TX002000201','2014-01-01','2013-12-24 17:01:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:53:33'),(13048,10402,'Y','18','021','EC','A','','','AC','0000102817','0000102817','OH00001145037','IL','1','everage','karen','','','','34','268547620','6559 abbey run',0,'sylvania','OH','43560',NULL,'CY','39095','1954-12-17','F','U',NULL,'N','021','DEN','2176825','99734OH005000401','2014-01-01','2013-12-23 08:47:06','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 12:50:47'),(7416,5868,'Y','18','021','EC','A','','','AC','0000327234','0000327234','OH00000619602','IL','1','Armogida','Luigi','','','','34','282742153','1296 Main ST',0,'Cleveland','OH','44114','2251','CY','39035','1976-04-15','M','U',':RET:2106-3','N','021','DEN','385379','99734OH005000401','2014-01-01','2013-10-28 14:42:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:16:52'),(9387,7443,'N','01','021','EC','A',NULL,NULL,'','0001215476','0000505481','','IL','1','MARTIN','JAMES','','','','34','450257277','7946 STATE HIGHWAY 31 W',0,'ATHENS','TX','75751','8500','CY','48213','1950-12-11','M','',':RET:2106-3','N','021','DEN','1987336','33348TX002000201','2014-01-01','2013-12-20 19:36:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:32:14'),(7824,6197,'N','19','021','EC','A',NULL,NULL,'','0000982460','0001199106','','IL','1','VETTA','KAITLIN','','','','34','610985161','417 ALEXANDER ST',0,'LANCASTER','TX','75146','1507','CY','48113','1997-05-30','F','',NULL,'N','021','DEN','1457685','33348TX002000201','2014-01-01','2013-12-20 18:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2013-12-26 03:04:16'),(3345,2681,'Y','18','021','EC','A','','','AC','0001156018','0001156018','TX00000808282','IL','1','Samudio','Judy','Kazuko','','','34','418065675','13221 BLUFF VIEW DR',0,'WILLIS','TX','77318','5304','CY','48339','1974-02-18','F','R',':RET:2039-6^:RET:2106-3','N','021','DEN','2170313','33348TX002000201','2014-01-01','2013-12-21 23:40:19','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:16:35'),(21972,17546,'Y','18','021','EC','A','','','AC','0000404839','0000404839','OH00001826832','IL','1','Yarbrough','Jonathan','','','','34','276824472','2188 THURMONT RD',0,'AKRON','OH','44313','5403','CY','39153','1984-05-04','M','U',':RET:2054-5','N','021','HLT','2658635','52664OH151001306','2014-03-01','2014-02-07 07:33:20','127.59',NULL,NULL,'249.55','121.96','R-OH012','OH0','249.55',NULL,0,'2014-02-07 19:00:31'),(28371,22450,'Y','18','021','EC','A','','','AC','0000134639','0000134639','OH00002712825','IL','1','Fisher','Sandra','','','','34','289527097','381 Community Drive',0,'Wilmington','OH','45177',NULL,'CY','39027','1950-05-17','F','U',':RET:2106-3','N','021','HLT','3126787','92036OH005000605','2014-04-01','2014-03-06 18:25:52','597.00',NULL,NULL,'633.70','36.70','R-OH005','OH0','633.70',NULL,0,'2014-03-07 21:30:35'),(28394,22464,'Y','18','021','EC','A','','','AC','0001002231','0001002231','OH00003487283','S3','1','Allen','Lori','M','','','34','294021659','3150 JAKE PL',0,'COLUMBUS','OH','43219','5002','CY','39049','1997-02-06','M','U',NULL,'N','021','DEN','4177724','99734OH005000401','2014-04-01','2014-03-06 18:29:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-03-07 21:30:46'),(16769,13414,'N','19','021','EC','A',NULL,NULL,'','0001244178','0000288306','','S3','1','gerhart','chris','','','','34','279154436','629 SKYLES RD',0,'UNION','OH','45322','3229','CY','39113','2009-05-06','F','',':RET:2106-3','N','021','HLT','2154479','92036OH006000501','2014-02-01','2014-01-07 12:15:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.71',NULL,0,'2014-01-08 18:25:01'),(4774,3788,'Y','18','021','EC','A','','','AC','0000172379','0000172379','OH00001210169','IL','1','Johnson','Marquita','','','','34','283843291','4680 e.173',0,'cleveland','OH','44128',NULL,'CY','39035','1968-11-18','F','U',':RET:2054-5','N','021','DEN','1185443','99734OH005000401','2014-01-01','2013-12-08 16:42:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:15:55'),(5946,4710,'Y','18','021','EC','A','','','AC','0000384394','0000384394','OH00001204519','S3','1','Schneider','Todd','','','','34','291020785','15618 HENGSTLER RD',0,'WAPAKONETA','OH','45895','9132','CY','39011','1997-08-20','F','U',NULL,'N','021','HLT','1829921','92036OH005001501','2014-01-01','2013-12-23 21:37:49','100.98',NULL,NULL,'139.76','38.78','R-OH002','OH0','139.76',NULL,0,'2013-12-25 23:50:59'),(18708,14915,'Y','18','021','EC','A','','','AC','0001004365','0001004365','OH00002423973','IL','1','Frazier','Alice','','','','34','272680404','3655 HERSCHEL AVE',0,'CINCINNATI','OH','45208','1936','CY','39061','1960-09-05','F','U',':RET:2054-5','N','021','DEN','1664107','99734OH005000301','2014-02-01','2014-01-15 21:19:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:30'),(23112,18421,'Y','18','021','EC','A','','','AC','0001235228','0001235228','OH00002030233','IL','1','Fiorello','Christine','S','','','34','278461499','5641 SCHIRM FARMS WAY',0,'CANAL WINCHESTER','OH','43110','8166','CY','39045','1949-09-15','F','U',':RET:2106-3','N','021','DEN','3526685','99734OH005000401','2014-03-01','2014-02-12 17:08:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:18'),(23736,18899,'Y','18','021','EC','A','','','AC','0000810831','0000810831','OH00001889420','IL','1','Vyas','Annal','','','','34','295861435','4410 EASTWICKE BLVD',0,'STOW','OH','44224','2115','CY','39153','1981-01-14','M','U',':RET:2029-7','N','021','DEN','3542828','99734OH005000301','2014-03-01','2014-02-13 22:06:27','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:31:01'),(25048,19864,'N','01','021','EC','A',NULL,NULL,'','0000874755','0001147389','','IL','1','SABIROVA','RUFINA','','','','34','271080232','6818 LAKESIDE DR',0,'WEST CHESTER','OH','45069','7675','CY','39017','1981-12-02','F','',NULL,'T','021','DEN','3463338','99734OH005000401','2014-04-01','2014-02-19 21:46:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:01:15'),(18018,14395,'Y','18','021','EC','A','','','AC','0000317360','0000317360','OH00001528621','IL','1','Ward','Susan','','','','34','294829689','1003 Wilmington Ave',0,'Dayton','OH','45420',NULL,'CY','39113','1976-01-03','F','M',':RET:2106-3','N','021','DEN','2558646','99734OH005000301','2014-02-01','2014-01-14 12:36:33','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:07:05'),(367,304,'Y','18','021','EC','A','','','AC','0000145591','0000145591','TX00000726116','IL','1','Chambers','Ashley','','','','34','629588085','5325 BENT TREE FOREST DR',0,'DALLAS','TX','75248','3462','CY','48113','1992-07-13','F','U',':RET:2054-5','N','021','DEN','577381','33348TX002000201','2014-01-01','2013-12-04 05:25:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:45:21'),(15189,12138,'Y','18','024','14','A','','','TE','0000353942','0000353942','','IL','1','Workman','Connie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-03','F','',NULL,NULL,NULL,'','50896','','2013-12-29','2013-12-29 21:25:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:07:03'),(5774,4587,'Y','18','024','14','A','','','TE','0000645975','0000645975','','IL','1','Eck','Kyle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-09-02','M','',NULL,NULL,NULL,'','1813473','','2013-12-23','2013-12-23 22:55:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:46:52'),(6566,5205,'Y','18','021','EC','A','','','AC','0000560368','0000560368','TX00000712150','IL','1','Trevino','Benjamin','','','','34','458135717','1011 RR 165',0,'Dripping Springs','TX','78620',NULL,'CY','48209','1957-06-26','M','U',':RET:2106-3','N','021','DEN','361997','33348TX002000201','2014-01-01','2013-12-11 14:04:23','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 00:52:32'),(1912,1562,'N','19','021','EC','A',NULL,NULL,'','0000828235','0000582813','','IL','1','Schultz','Joshua','','','','34','270980408','5865 SQUIREHILL CT',0,'CINCINNATI','OH','45241','6021','CY','39061','1994-07-18','M','',':RET:2106-3','N','021','HLT','1521879','92036OH003001201','2014-01-01','2013-12-24 17:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 18:59:25'),(19536,15570,'Y','18','021','EC','A','','','AC','0001160438','0001160438','OH00001793893','IL','1','Davis','Steven','','','','34','289464639','5065 HALLGATE AVE',0,'TOLEDO','OH','43612','3033','CY','39095','1950-02-12','M','U',':RET:2106-3','N','021','DEN','3312007','99734OH005000401','2014-03-01','2014-01-22 15:52:10','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-23 03:02:22'),(22760,18172,'Y','18','021','EC','A','','','AC','0000043260','0000043260','OH00001737109','IL','1','shah','dina','','','','34','272868284','6611 greenfield woods n',0,'cincinnati','OH','45224',NULL,'CY','39061','1961-04-13','F','M',':RET:2029-7','N','021','DEN','3794710','99734OH005000401','2014-03-01','2014-02-10 23:21:59','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:32'),(26488,21011,'Y','18','024','14','A','','','TE','0002280124','0002280124','','IL','1','Turner','Tress',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-06-20','F','',NULL,NULL,NULL,'','3750783','','2014-02-27','2014-02-27 22:40:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-28 21:00:08'),(26626,21111,'Y','18','024','14','A','','','TE','0001022232','0001022232','','IL','1','BOWERS','LASANDRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-20','F','',NULL,NULL,NULL,'','2821906','','2014-02-28','2014-02-28 12:56:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:54'),(26750,21199,'Y','18','021','EC','A','','','AC','0000875427','0000875427','TX00002859307','IL','1','JAVIER','TERESA','','','','34','733182080','12414 JAGUAR DR',0,'STAFFORD','TX','77477',NULL,'CY','48201','1975-09-30','F','U',':RET:2036-2','N','021','DEN','3136362','33348TX002000201','2014-04-01','2014-02-28 20:08:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-03-01 19:00:02'),(27024,21403,'N','19','021','EC','A',NULL,NULL,'','0000592211','0000338935','','IL','1','JOHNSON','TYLER','','','','34','269963818','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1992-10-09','M','',':RET:2106-3','N','021','DEN','3725480','99734OH005000301','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:13'),(27150,21495,'Y','18','021','EC','A','','','AC','0000119124','0000119124','OH00002442060','IL','1','Schmidt','Jennifer','','','','34','277644642','9449 HADDINGTON CT',0,'CINCINNATI','OH','45251','2358','CY','39061','1970-07-11','F','U',':RET:2106-3','N','021','DEN','3633943','99734OH005000401','2014-04-01','2014-03-03 14:04:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:52'),(27636,21858,'N','01','021','EC','A',NULL,NULL,'','0000872115','0000322205','','IL','1','Lam','Oi Man','','','','34','080721713','3161 AVALON RD',0,'UPPER ARLINGTON','OH','43221','2669','CY','39049','1958-01-03','F','',':RET:2034-7','N','021','DEN','3606440','99734OH005000401','2014-04-01','2014-03-05 09:58:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:13'),(13028,10385,'Y','18','021','EC','A','','','AC','0000884211','0000884211','OH00000146693','IL','1','Haynes','Shawn','','','','34','409477073','811 Belrock Ave',0,'Belpre','OH','45714',NULL,'CY','39167','1983-09-05','M','M',':RET:2106-3','N','021','DEN','1956668','99734OH005000401','2014-01-01','2013-12-22 22:25:39','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2013-12-26 12:50:16'),(4536,3595,'Y','18','021','EC','A','','','AC','0000410477','0000410477','TX00000853151','IL','1','SPIES','DEBRA','','','','34','464066070','13101 W STATE HIGHWAY 21',0,'DOUGLASS','TX','75943',NULL,'CY','48347','1955-06-03','F','M',':RET:2106-3','N','021','DEN','137934','33348TX002000201','2014-01-01','2013-12-12 17:14:51','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:11'),(4708,3732,'Y','18','021','EC','A','','','AC','0000024075','0000024075','OH00001011401','IL','1','Gilbert','Michael','','','','34','287542183','4 Old State Road',0,'Milan','OH','44846',NULL,'CY','39077','1951-02-24','M','U',':RET:2106-3','N','021','HLT','552090','92036OH005002704','2014-01-01','2013-12-12 10:56:48','423.00',NULL,NULL,'560.22','137.22','R-OH006','OH0','560.22',NULL,0,'2013-12-25 22:08:38'),(20189,16110,'Y','18','021','EC','A','','','AC','0001074383','0001074383','TX00002362161','IL','1','MORGAN','DERRICK','Q','','','34','464570951','7015 KINGDOM ESTATES DR',0,'DALLAS','TX','75236','3020','CY','48113','1976-09-02','M','U',':RET:2054-5','T','021','DEN','3466308','33348TX002000101','2014-03-01','2014-01-27 12:57:34','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-27 21:01:25'),(26423,20956,'Y','18','021','EC','A','','','AC','0000594581','0000594581','TX00003125383','IL','1','MOLINA','MARISELA','','','','34','453084356','710 Brazos St',0,'Mission','TX','78572',NULL,'CY','48215','1953-12-05','F','M',NULL,'N','021','DEN','3592528','33348TX002000201','2014-04-01','2014-02-27 10:55:28','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61','CIC',0,'2014-02-28 07:30:10'),(27655,21874,'Y','18','021','EC','A','','','AC','0000091220','0000091220','OH00003615426','IL','1','Patel','Rashmiben','','','','34','148880320','301 BIHL AVE',0,'NORTHWOOD','OH','43619','1539','CY','39173','1960-01-31','F','M',':RET:2029-7','N','021','DEN','3309374','99734OH005000401','2014-04-01','2014-03-05 13:31:02','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2014-03-05 21:30:24'),(29126,23058,'Y','18','021','EC','A','','','AC','0000175173','0000175173','OH00003498860','IL','1','Bordner','Jonathan','','','','34','298806170','520 Leroy Ave.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1983-05-22','M','U',':RET:2106-3','T','021','HLT','4090539','92036OH006002601','2014-04-01','2014-03-10 15:22:53','123.00',NULL,NULL,'201.85','78.85','R-OH001','OH0','201.85',NULL,0,'2014-03-10 21:02:33'),(374,310,'Y','18','021','EC','A','','','AC','0000311517','0000311517','TX00000449743','IL','1','Robinson','Bilindra','','','','34','454491889','904 S ROCKWALL ST',0,'TERRELL','TX','75160','4412','CY','48257','1965-12-30','F','M',':RET:2054-5','N','021','DEN','1083819','33348TX002000201','2014-01-01','2013-12-04 15:53:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:45:31'),(16909,13530,'Y','18','021','EC','A','','','AC','0001074166','0001074166','OH00001669279','IL','1','Messac','Paule','','','','34','095504958','437 CATHERINE ST',0,'COLUMBUS','OH','43223','1904','CY','39049','1955-02-02','F','U',NULL,'N','021','DEN','2275440','99734OH005000401','2014-02-01','2014-01-09 11:14:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:19:37'),(1114,917,'Y','18','021','EC','A','','','AC','0000721320','0000721320','OH00000139795','IL','1','Jackson','Teanna','','','','34','405176619','1209 WESSELS AVE',0,'CINCINNATI','OH','45205','1344','CY','39061','1981-07-13','F','U',':RET:2054-5','N','021','DEN','567363','99734OH005000401','2014-01-01','2013-12-03 17:27:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:17:35'),(1387,1152,'Y','18','021','EC','A','','','AC','0001848285','0001848285','LA00001167903','IL','1','Garcia','Dina','','','','34','591879891','10853 W FULLER PL',0,'BATON ROUGE','LA','70816','4230','CY','22033','1972-09-22','F','M',':RET:2106-3','N','021','DEN','1509668','18575LA002000201','2014-01-01','2013-12-24 10:48:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:15'),(19034,15159,'Y','18','021','EC','A','','','AC','0000800110','0000800110','MS00002166363','IL','1','HAYNES','DARLENE','','','','34','426398116','132 BEN STROUD RD',0,'TAYLORSVILLE','MS','39168','4513','CY','28129','1966-03-26','F','U',':RET:2054-5','N','021','DEN','3033950','46300MS002000201','2014-03-01','2014-01-17 13:09:32','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-20 08:06:33'),(20559,16429,'N','01','021','EC','A',NULL,NULL,'','0000509204','0000176393','','IL','1','Jones','Suzanne','P','','','34','374624466','10530 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','9649','CY','39173','1955-04-23','F','',NULL,'N','021','HLT','2481727','92036OH004002601','2014-03-01','2014-01-29 16:56:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','399.50',NULL,0,'2014-01-29 21:01:45'),(23193,18493,'N','01','021','EC','A',NULL,NULL,'','0000253089','0000560591','','IL','1','Walkerow','Carla','J','','','34','283480058','496 Stephens Road',0,'Akron','OH','44312',NULL,'CY','39153','1950-03-14','F','',':RET:2106-3','N','021','HLT','3316254','52664OH152000901','2014-03-01','2014-02-12 10:50:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2014-02-12 21:32:05'),(24197,19220,'Y','18','021','EC','A','','','AC','0001032650','0001032650','OH00002795943','IL','1','Cochran-Styles','Paula','','','','34','280486207','60 Providence Dr',0,'Fairfield','OH','45014',NULL,'CY','39017','1953-02-18','F','U',':RET:2054-5','N','021','DEN','2658897','99734OH005000301','2014-03-01','2014-02-15 21:28:11','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-16 19:00:16'),(320,263,'Y','18','024','14','A','','','TE','0000411225','0000411225','','IL','1','Tharpe','Lindsey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-12-06','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-12 21:28:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 17:31:20'),(4589,3634,'Y','18','021','EC','A','','','AC','0000507961','0000507961','OH00000013532','IL','1','miller','gary','','','','34','270706049','522 HICKORY MILLS CIR',0,'KENT','OH','44240','4626','CY','39133','1971-08-06','M','U',':RET:2106-3','N','021','HLT','847738','52664OH151001301','2014-01-01','2013-12-12 10:55:53','72.00',NULL,NULL,'295.48','223.48','R-OH012','OH0','295.48',NULL,0,'2013-12-25 22:05:25'),(4390,3490,'Y','18','021','EC','A','','','AC','0000699253','0000699253','OH00001197839','IL','1','BRAND','DON','','','','34','288521638','5948 ROAN ROAD',0,'MILFORD','OH','45150',NULL,'CY','39025','1951-08-02','M','U',':RET:2106-3','N','021','DEN','628321','99734OH005000401','2014-01-01','2013-12-12 11:24:18','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 22:00:52'),(18668,14882,'Y','18','021','EC','A','','','AC','0001028201','0001028201','TX00002544878','IL','1','HUME','DEBORAH','','','','34','458986534','681 V.Z.C.R.2128',0,'WELLPOINT','TX','75169',NULL,'CY','48467','1954-07-27','F','M',':RET:2106-3','N','021','DEN','2754344','33348TX002000201','2014-03-01','2014-01-16 17:15:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:16'),(18666,14880,'N','01','021','EC','A',NULL,NULL,'','0000791243','0001183745','','IL','1','Vasquez','Michael','Ray','','Sr','34','463974655','6127 VERDE VALLEY DR',0,'HUMBLE','TX','77396','1351','CY','48201','1983-11-28','M','',NULL,'N','021','DEN','2209118','33348TX002000201','2014-03-01','2014-01-16 16:24:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-17 03:35:15'),(2987,2403,'Y','18','021','EC','A','','','AC','0000878236','0000878236','OH00000184531','IL','1','Hieronimus','Jennifer','D','','','34','286646015','39 TOWNSHIP ROAD 1188',0,'SOUTH POINT','OH','45680','8732','CY','39087','1960-10-08','F','U',':RET:2106-3','N','021','DEN','993956','99734OH005000301','2014-01-01','2013-12-06 11:51:55','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 20:17:19'),(13397,10692,'Y','18','021','EC','A','','','AC','0001214791','0001214791','OH00001203284','IL','1','Conter','Marc','','','','34','281622113','2058 CASA LOMA DR',0,'FAIRFIELD','OH','45014','4850','CY','39017','1958-05-12','M','M',':RET:2106-3','N','021','DEN','1805895','99734OH005000301','2014-01-01','2013-12-23 08:30:12','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:15'),(17846,14255,'N','01','021','EC','A',NULL,NULL,'','0001184902','0000246469','','IL','1','MCCULLOCK','WINSTON','','','','34','644644997','7608 CYPRESS POINT DR',0,'PICKERINGTON','OH','43147','8749','CY','39045','1967-10-30','M','',NULL,'N','021','DEN','1746629','99734OH005000401','2014-02-01','2014-01-13 23:37:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:05'),(15762,12612,'Y','18','021','EC','A','','','AC','0000770769','0000770769','TX00002139641','IL','1','CISNEROS','RAUL','','','','34','452911012','12776 STATE WY 186',0,'RAMONDVILLE','TX','78580',NULL,'CY','48489','1980-01-25','M','U',NULL,'N','021','DEN','2075413','33348TX002000201','2014-02-01','2014-01-02 11:51:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:31'),(19861,15842,'Y','18','021','EC','A','','','AC','0000133346','0000133346','OH00002073686','IL','1','McMurry','Christy','','','','34','300604108','7545F MANSION CIR',0,'MASON','OH','45040','8279','CY','39165','1968-05-24','F','U',':RET:2106-3','N','021','DEN','2602435','99734OH005000401','2014-03-01','2014-01-24 11:39:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-24 21:00:35'),(20881,16689,'Y','18','021','EC','A','','','AC','0000468146','0000468146','OH00001478367','IL','1','Shaw','Johnny','','','','34','296862970','525 S WEST ST',0,'HILLSBORO','OH','45133','1343','CY','39071','1974-12-06','M','M',':RET:2106-3','N','021','HLT','3234142','92036OH006000601','2014-03-01','2014-01-30 21:04:55','638.51',NULL,NULL,'643.21','4.70','R-OH005','OH0','214.85',NULL,0,'2014-01-31 21:01:09'),(22664,18098,'Y','18','021','EC','A','','','AC','0000345388','0000345388','TX00001895926','31','1','TORRES','MARIA','ISABELLE','','','34','627311032','PO BOX 836014',0,'RICHARDSON','TX','75083',NULL,'CY','48113','1965-09-23','F','U',NULL,'N','021','DEN','2791165','33348TX002000201','2014-03-01','2014-02-11 13:47:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:37'),(24592,19523,'Y','18','021','EC','A','','','AC','0000452799','0000452799','OH00001844579','IL','1','MIKESELL','EDWIN','','','','34','274686953','9785 BUNKERHILL LANE',0,'CINCINATTI','OH','45242',NULL,'CY','39061','1963-01-17','M','U',NULL,'N','021','DEN','2879396','99734OH005000301','2014-04-01','2014-02-19 14:41:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:10:56'),(24829,19683,'Y','18','021','EC','A','','','AC','0000697956','0000697956','OH00002635752','IL','1','wilson','michael','','','','34','243734736','37 CONCORD WOODS DR',0,'MILFORD','OH','45150','1334','CY','39025','1992-04-28','M','M',':RET:2106-3','N','021','HLT','3440784','92036OH002000601','2014-04-01','2014-02-18 22:48:36','0.00',NULL,NULL,'247.90','247.90','R-OH005','OH0','247.90',NULL,0,'2014-02-20 04:51:43'),(24947,19782,'Y','18','021','EC','A','','','AC','0002052904','0002052904','LA00002944941','IL','1','Kilchrist','Kim','Anthony','','','34','434047085','246 GABRIEL ST',0,'LAFAYETTE','LA','70506','4722','CY','22055','1962-03-19','M','U',':RET:2106-3','N','021','DEN','3750566','18575LA002000201','2014-04-01','2014-02-19 18:16:24','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 22:00:08'),(197,163,'N','01','021','EC','A',NULL,NULL,'','0000357163','0001131414','','IL','1','Anderson','Philip','','','','34','335701574','2180 PLYMOUTH DR',0,'UNIONTOWN','OH','44685','9743','CY','39153','1966-06-30','M','',NULL,'N','021','HLT','1067464','52664OH151001501','2014-01-01','2013-12-04 19:50:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','418.05',NULL,0,'2013-12-25 17:20:05'),(17802,14220,'Y','18','021','EC','A','','','AC','0000577331','0000577331','OH00001688768','IL','1','MEXICOTT','MICHELLE','ANN','','','34','269684811','A805 COUNTY ROAD 13',0,'NEW BAVARIA','OH','43548',NULL,'CY','39069','1966-11-07','F','M',':RET:2106-3','N','021','HLT','1592595','92036OH003002604','2014-02-01','2014-01-13 17:57:41','0.00',NULL,NULL,'318.29','318.29','R-OH001','OH0','318.29',NULL,0,'2014-01-14 01:33:54'),(15684,12546,'Y','18','021','EC','A','','','AC','0000646001','0000646001','OH00001526071','IL','1','Hart','Stephanee','','','','34','279940802','22595 W CEDAR AVE',0,'CURTICE','OH','43412','9674','CY','39123','1987-12-02','F','M',':RET:2106-3','N','021','HLT','1434775','92036OH006002701','2014-02-01','2013-12-31 11:15:27','21.00',NULL,NULL,'158.35','137.35','R-OH006','OH0','158.35',NULL,1,'2014-01-02 04:35:06'),(7342,5815,'Y','18','021','EC','A','','','AC','0000109265','0000109265','OH00000275257','IL','1','Forsyth','Kevin','','','','34','168541931','3672 Sanctuary Dr.',0,'Akron','OH','44333',NULL,'CY','39153','1959-06-26','M','R',':RET:2106-3','N','021','HLT','246118','52664OH152000901','2014-01-01','2013-12-14 16:24:41','0.00',NULL,NULL,'823.23','823.23','R-OH012','OH0','348.73',NULL,0,'2013-12-26 02:04:03'),(5471,4346,'N','19','021','EC','A',NULL,NULL,'','0001046832','0000058746','','IL','1','Arif','Nabeel','','','','34','286086344','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','2003-09-13','M','',':RET:2028-9','N','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-25 23:10:40'),(7039,5590,'Y','18','021','EC','A','','','AC','0000865460','0000865460','TX00001358124','IL','1','aivalis','ryan','james','','','34','433814572','22406 CAROLINE COVE LN',0,'KATY','TX','77450','8201','CY','48157','1987-05-29','M','U',':RET:2106-3','T','021','DEN','1644778','33348TX002000201','2014-02-01','2013-12-25 00:17:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:49:21'),(1839,1507,'Y','18','021','EC','A','','','AC','0000872037','0000872037','OH00001481445','IL','1','Thielenhaus','Douglas','','','','34','501744196','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1966-06-29','M','M',':RET:2106-3','N','021','HLT','1860178','52664OH151001305','2014-01-01','2013-12-24 11:43:09','313.00',NULL,NULL,'660.10','347.10','R-OH012','OH0','348.56',NULL,0,'2013-12-25 18:57:36'),(2384,1945,'Y','18','021','EC','A','','','AC','0000666738','0000666738','OH00001040281','IL','1','LINER','LINDA','','','','34','160460322','1420 SHADOWOOD TRAIL',0,'MAINEVILLE','OH','45039',NULL,'CY','39165','1953-11-25','F','U',NULL,'N','021','DEN','116698','99734OH005000401','2014-01-01','2013-12-09 11:07:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:05'),(2445,1991,'N','19','021','EC','A',NULL,NULL,'','0000188827','0000595109','','IL','1','Truong','Timmy','','','','34','295967125','3365 LAKE CREST DR',0,'HAMILTON','OH','45011','8167','CY','39017','1994-02-12','M','',':RET:2047-9','N','021','HLT','1256918','92036OH004001201','2014-01-01','2013-12-08 19:57:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 19:34:33'),(6313,5008,'Y','18','021','EC','A','','','AC','0000453889','0000453889','OH00000208774','IL','1','Strait','Rhonda','','','','34','282589972','12303 Bon Air Av. North East',0,'Alliance','OH','44601',NULL,'CY','39151','1955-12-05','F','U',':RET:2106-3','N','021','DEN','4051','99734OH005000401','2014-01-01','2013-12-11 10:57:46','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 00:46:14'),(14064,11207,'Y','18','021','EC','A','','','AC','0000893158','0000893158','OH00001262912','IL','1','Rasmussen','Hans','R','','','34','060847808','7292 PORTER DR',0,'CANAL WINCHESTER','OH','43110','8230','CY','39049','1959-10-12','M','M',':RET:2106-3','N','021','DEN','1956929','99734OH005000401','2014-02-01','2013-12-26 08:28:25','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:40'),(14873,11877,'Y','18','021','EC','A','','','AC','0000416768','0000416768','TX00001374929','IL','1','Villarreal','Maria','','','','34','467157100','1658 STATE HIGHWAY 75 N',0,'HUNTSVILLE','TX','77320','1098','CY','48471','1974-05-06','F','U',NULL,'N','021','DEN','2232229','33348TX002000201','2014-02-01','2013-12-29 12:12:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-30 00:00:17'),(21079,16844,'N','01','021','EC','A',NULL,NULL,'','0000533989','0000113044','','IL','1','Bruder','Todd','','','','34','465674441','9301 Spectrum Drive',0,'Austin','TX','78717',NULL,'CY','48491','1984-03-12','M','',':RET:2106-3','N','021','DEN','2899297','33348TX002000101','2014-03-01','2014-02-01 20:48:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-02 19:00:21'),(21102,16863,'N','19','021','EC','A',NULL,NULL,'','0000874735','0000807530','','IL','1','Pylypuik','Audrey','E',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','2009-03-18','F','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-02-03 21:00:04'),(21377,17085,'Y','18','024','14','A','','','TE','0000353967','0000353967','','IL','1','James','Robin','Brintnall',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-11-24','M','',NULL,NULL,NULL,'','2092125','','2014-02-03','2014-02-03 19:39:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:00:51'),(25375,20133,'Y','18','021','EC','A','','','AC','0000518455','0000518455','OH00002501421','IL','1','LEON','JULIE',NULL,NULL,NULL,NULL,NULL,'1003 LAKEVILLE DR',0,'CINCINNATI','OH','45233','4527','CY','39061','1977-06-03','F','U',':RET:2106-3','N','021','DEN','3653212','99734OH005000301','2014-04-01','2014-02-25 16:09:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:43'),(27141,21487,'Y','18','021','EC','A','','','AC','0001022847','0001022847','OH00002334427','IL','1','DANIELS','NORMA','','','','34','362581904','2716 LAFEUILLE CIR',0,'CINCINNATI','OH','45211','8269','CY','39061','1953-09-04','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3671413','99734OH005000401','2014-04-01','2014-03-03 12:51:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:46'),(27561,21801,'Y','18','021','EC','A','','','AC','0000195113','0000195113','OH00003421356','IL','1','Spencer','Linda','M','','','34','292509830','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1951-01-29','F','M',':RET:2054-5','N','021','DEN','2926918','99734OH005000301','2014-04-01','2014-03-04 11:13:17','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00','CIC',0,'2014-03-04 21:30:17'),(28936,22899,'Y','18','021','EC','A','','','AC','0001081880','0001081880','OH00002783247','31','1','Nice','Carianne','','','','34','299660063','20 twp.hwy. 204',0,'Bloomingdale','OH','43910',NULL,'CY','39081','1969-10-19','F','U',':RET:2106-3','T','021','DEN','3873206','99734OH005000301','2014-04-01','2014-03-10 16:02:03','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-03-10 21:00:40'),(16398,13120,'N','01','021','EC','A',NULL,NULL,'','0001256813','0000281790','','IL','1','Baker','Sheila','','','','34','319687847','1031 STEWART AVE',0,'DUNCANVILLE','TX','75137','3548','CY','48113','1967-06-29','F','',':RET:2106-3','N','021','DEN','2257225','33348TX002000201','2014-02-01','2014-01-06 13:11:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-07 04:03:47'),(16203,12973,'Y','18','021','EC','A','','','AC','0000773078','0000773078','TX00001803041','IL','1','GUTIERREZ','GERARDO','','','','34','452572467','2419 BRIARWOOD DRIVE',0,'MISSION','TX','78574',NULL,'CY','48215','1980-04-06','M','U',':RET:2106-3','N','021','DEN','1746407','33348TX002000201','2014-02-01','2014-01-04 13:06:38','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-05 00:01:12'),(9151,7258,'Y','18','021','EC','A','','','AC','0000928472','0000928472','OH00000778229','IL','1','Barker','Mary','','','','34','295527213','2522 SANDY LN',0,'COPLEY','OH','44321','2539','CY','39153','1952-05-12','F','M',':RET:2106-3','N','021','HLT','1782831','52664OH151001501','2014-01-01','2013-12-18 15:07:45','367.00',NULL,NULL,'751.58','384.58','R-OH012','OH0','751.58',NULL,0,'2013-12-26 04:08:26'),(7969,6307,'N','01','021','EC','A',NULL,NULL,'','0001221203','0000168485','','IL','1','Akiti','Brenda','Faye','','','34','571116945','701 PECAN CT',0,'BRANDON','MS','39042','6013','CY','28121','1969-07-30','F','',':RET:2054-5','N','021','DEN','2175622','46300MS002000201','2014-01-01','2013-12-20 15:24:27',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 03:07:37'),(15907,12739,'Y','18','021','EC','A','','','AC','0000550086','0000550086','OH00001837546','IL','1','Frowine','Andrew','','','','34','276428943','1225 STONEY RD',0,'PEEBLES','OH','45660','9271','CY','39001','1950-05-17','M','M',':RET:2106-3','N','021','HLT','1599726','92036OH006000601','2014-02-01','2014-01-02 14:38:53','910.00',NULL,NULL,'980.97','70.97','R-OH005','OH0','502.56',NULL,0,'2014-01-03 02:06:16'),(1905,1557,'N','01','021','EC','A',NULL,NULL,'','0000784365','0000260475','','IL','1','SEELING','SAMANTHA','','','','34','282804382','312 E NORTH ST',0,'BEAVERDAM','OH','45808','9736','CY','39003','1980-03-24','F','',NULL,'N','021','HLT','2071054','92036OH004001501','2014-01-01','2013-12-24 13:44:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','212.00',NULL,0,'2013-12-25 18:59:14'),(7254,5754,'Y','18','021','EC','A','','','AC','0000038362','0000038362','OH00000064903','IL','1','McDowell','Melanie','','','','34','286647587','127 Moores Road',0,'Seaman','OH','45679',NULL,'CY','39001','1973-08-15','F','M',':RET:2106-3','N','021','HLT','996722','92036OH002000601','2014-01-01','2013-12-13 23:27:17','652.00',NULL,NULL,'1111.90','459.90','R-OH005','OH0','316.83',NULL,0,'2013-12-26 02:02:02'),(2974,2395,'Y','18','021','EC','A','','','AC','0000437994','0000437994','TX00000321617','IL','1','Fisher','Natalie','Jacqueline','','','34','637124767','1500 PLANTATION OAKS DR',0,'TROPHY CLUB','TX','76262','8346','CY','48121','1984-12-25','F','M',':RET:2106-3','N','021','DEN','506221','33348TX002000201','2014-01-01','2013-12-05 18:30:52','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:17:03'),(20516,16392,'N','01','021','EC','A',NULL,NULL,'','0000889695','0000295994','','IL','1','Doberson','Juvy','','','','34','636042361','2655 SKYVIEW RIDGE CT',0,'HOUSTON','TX','77047','6518','CY','48201','1983-02-22','F','',':RET:2036-2','N','021','DEN','3595669','33348TX002000101','2014-03-01','2014-01-28 21:43:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-29 21:01:22'),(22184,17705,'Y','18','021','EC','A','','','AC','0000787233','0000787233','OH00002508607','S3','1','Wipert Lyons','Cheryl','Retta','','','34','268021439','6561 COOPER MEADOWS RD',0,'WESTERVILLE','OH','43081','8952','CY','39049','1996-10-03','F','U',':RET:2106-3','N','021','DEN','2982667','99734OH005000401','2014-03-01','2014-02-08 18:54:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78','CIC',0,'2014-02-09 19:00:05'),(22565,18021,'Y','18','021','EC','A','','','AC','0000498215','0000498215','OH00002608605','IL','1','TEMPLE','ALLAN','','','','34','285882299','1843 SEDRO ST',0,'CUYAHOGA FALLS','OH','44221','5242','CY','39153','1980-03-27','M','M',':RET:2106-3','N','021','DEN','3588204','99734OH005000401','2014-03-01','2014-02-10 13:32:25','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-10 21:31:53'),(25694,20385,'Y','18','021','EC','A','','','AC','0001264625','0001264625','TX00003140540','IL','1','Orcutt','Erin','','','','34','637102175','310 HOUSTON ST',0,'NACOGDOCHES','TX','75961','4462','CY','48347','1986-09-29','F','U',':RET:2106-3','N','021','DEN','3389091','33348TX002000201','2014-04-01','2014-02-23 22:38:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:14'),(27197,21534,'N','01','021','EC','A',NULL,NULL,'','0000991227','0001069426','','IL','1','Tran','Qui','Joseph','','Sr','34','561639872','103  Henderson. St',0,'Palacios','TX','77465',NULL,'CY','48321','1965-12-01','M','',':RET:2047-9','T','021','DEN','3680090','33348TX002000201','2014-04-01','2014-03-03 16:33:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:19'),(14226,11344,'Y','18','024','14','A','','','TE','0001131863','0001131863','','IL','1','WASHINGTON','MARY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-09','F','',NULL,NULL,NULL,'','2361200','','2013-12-26','2013-12-26 17:34:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:04:50'),(9433,7484,'Y','18','021','EC','A','','','AC','0000342727','0000342727','OH00001200905','IL','1','Lewis','Joseph','','','','34','271507134','5630 CODER RD',0,'ATTICA','OH','44807','9600','CY','39077','1951-02-07','M','M',':RET:2106-3','T','021','HLT','1503277','92036OH003002705','2014-01-01','2013-12-21 14:01:17','1055.00',NULL,NULL,'1283.69','228.69','R-OH006','OH0','672.80',NULL,0,'2013-12-26 04:33:27'),(20271,16176,'Y','18','021','EC','A','','','AC','0000060301','0000060301','OH00002131315','IL','1','Munro','Michael','','','','34','237793185','538 S HIGH ST',0,'COVINGTON','OH','45318','1126','CY','39109','1990-07-26','M','U',':RET:2106-3','N','021','DEN','3532552','99734OH005000401','2014-03-01','2014-01-27 19:02:40','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-28 21:00:23'),(23934,19031,'N','01','021','EC','A',NULL,NULL,'','0001111704','0000924840','','IL','1','Wilcox','Daniel','','','','34','293763275','5860 KILBURY HUBER RD',0,'PLAIN CITY','OH','43064','9557','CY','39097','1964-07-04','M','',NULL,'N','021','DEN','2969208','99734OH005000401','2014-03-01','2014-02-14 18:29:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-15 21:00:05'),(25084,19893,'N','19','021','EC','A',NULL,NULL,'','0000305891','0000692979','','IL','1','NICKOLI','TYLER','','','','34','268061076','2090 TOWNLINE ROAD 12',0,'WILLARD','OH','44890',NULL,'CY','39077','2000-08-22','M','',NULL,'N','021','HLT','2753695','92036OH003002706','2014-04-01','2014-02-20 15:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-20 22:01:41'),(26434,20966,'Y','18','024','14','A','','','TE','0001182479','0001182479','','IL','1','Olinger','Andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1997-02-09','M','',NULL,NULL,NULL,'','342028','','2014-03-31','2014-02-27 11:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:17'),(26813,21248,'Y','18','021','EC','A','','','AC','0001168063','0001168063','OH00002327660','IL','1','Nichpor','Joann','M','','','34','290520656','11167 RIVERBEND CT W',0,'PERRYSBURG','OH','43551','3678','CY','39173','1950-12-31','F','M',':RET:2106-3','N','021','HLT','2853050','92036OH006002601','2014-04-01','2014-03-01 12:07:17','224.00',NULL,NULL,'456.50','232.50','R-OH001','OH0','456.50',NULL,0,'2014-03-01 21:00:30'),(28494,22546,'Y','18','021','EC','A','','','AC','0000312559','0000312559','MS00002376799','IL','1','Davis','Catia','','','','34','428513481','114 Arnold avenue 29',0,'Greenville','MS','38701',NULL,'CY','28151','1985-01-03','F','U',':RET:2054-5','T','021','DEN','3170857','46300MS002000201','2014-04-01','2014-03-07 08:10:35','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-07 21:31:44'),(28584,22622,'Y','18','021','EC','A','','','AC','0001100653','0001100653','OH00002673528','IL','1','Lewis','Kathleen','Ann','','','34','302501326','789 WISBEY RD',0,'BLANCHESTER','OH','45107','9788','CY','39027','1953-05-30','F','M',':RET:2106-3','N','021','HLT','3452548','92036OH003000601','2014-05-01','2014-03-08 13:45:58','0.00',NULL,NULL,'608.42','608.42','R-OH005','OH0','608.42','CIC',0,'2014-03-08 21:00:09'),(28745,22751,'Y','18','021','EC','A','','','AC','0001529396','0001529396','LA00003045277','IL','1','BOSTON','LILLIAN','IRENE','','','34','435197321','140 IRVING ST',0,'LAKE CHARLES','LA','70605','6510','CY','22019','1958-10-25','F','U',':RET:2106-3','N','021','DEN','4314117','18575LA002000201','2014-04-01','2014-03-09 17:46:05','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-09 21:00:12'),(401,330,'Y','18','021','EC','A','','','AC','0000573032','0000573032','OH00001291629','IL','1','Fink','Joan','','','','34','278509262','4710 Dutch Ridge Rd.',0,'New Straitsville','OH','43766',NULL,'CY','39127','1952-04-10','F','M',':RET:2106-3','N','021','DEN','1050137','99734OH005000401','2014-01-01','2013-12-04 09:09:49','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-25 17:46:10'),(19264,15353,'Y','18','021','EC','A','','','AC','0001105946','0001105946','MS00001756385','IL','1','Fields','James','','','','34','587487295','1956 Ventura Drive',0,'Jackson','MS','39204',NULL,'CY','28049','1953-04-24','M','U',':RET:2054-5','N','021','DEN','1735781','46300MS002000201','2014-03-01','2014-01-20 12:24:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-21 08:46:51'),(16507,13205,'N','01','021','EC','A',NULL,NULL,'','0000322155','0000247907','','IL','1','PARMITER','Lynne','','','','34','270506929','8125 GOOSECREEK RD',0,'ROSEVILLE','OH','43777',NULL,'CY','39119','1952-09-21','F','',NULL,'N','021','DEN','2563415','99734OH005000301','2014-02-01','2014-01-05 15:50:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-07 10:21:15'),(1249,1029,'Y','18','021','EC','A','','','AC','0000863434','0000863434','OH00000522216','IL','1','Sibberson','Jeffrey','','','','34','276720773','564 S. Howard Rd.',0,'Curtice','OH','43412',NULL,'CY','39095','1968-01-13','M','U',':RET:2106-3','N','021','HLT','1199216','92036OH005002601','2014-01-01','2013-12-03 10:01:08','0.00',NULL,NULL,'281.58','281.58','R-OH001','OH0','281.58',NULL,0,'2013-12-25 18:21:10'),(16315,13063,'Y','18','021','EC','A','','','AC','0001550686','0001550686','LA00001388753','IL','1','NEWELL','MARY','','','','34','434927904','16441 S HARRELLS FERRY RD',0,'BATON ROUGE','LA','70816','7516','CY','22033','1954-02-05','F','U',':RET:2054-5','N','021','DEN','1638941','18575LA002000201','2014-02-01','2014-01-06 16:37:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:33'),(8110,6415,'Y','18','021','EC','A','','','AC','0000545234','0000545234','OH00000876908','IL','1','Petzold','Kathryn','','','','34','073440198','4466 US HIGHWAY 62',0,'HILLSBORO','OH','45133','9525','CY','39071','1950-01-08','F','M',':RET:2106-3','N','021','HLT','2259076','92036OH002000601','2014-01-01','2013-12-20 17:29:29','0.00',NULL,NULL,'731.81','731.81','R-OH005','OH0','731.81',NULL,0,'2013-12-26 03:11:05'),(7974,6312,'Y','18','021','EC','A','','','AC','0000452736','0000452736','OH00000318514','IL','1','Icke','Crystal','','','','34','273905019','26898 SPRAGUE RD',0,'OLMSTED FALLS','OH','44138','2618','CY','39035','1986-05-30','F','U',':RET:2106-3','N','021','HLT','2486829','52664OH151001306','2014-01-01','2013-12-19 20:36:32','160.00',NULL,NULL,'263.59','103.59','R-OH011','OH0','263.59',NULL,0,'2013-12-26 03:07:47'),(5073,4021,'Y','18','021','EC','A','','','AC','0000780305','0000780305','TX00000221108','IL','1','majidi','ahmad','','','','34','609942232','13115 Marble Falls Cove',0,'Austin','TX','78729',NULL,'CY','48453','1960-05-11','M','M',':RET:2106-3','N','021','DEN','2324111','33348TX002000201','2014-01-01','2013-12-19 13:03:58','0.00',NULL,NULL,'47.55','47.55','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:00:47'),(20635,16489,'N','01','021','EC','A',NULL,NULL,'','0000991099','0000855960','','IL','1','Bertrand','Patricia','M','','','34','434661910','19831 LIONS GATE CT',0,'HUMBLE','TX','77338','1924','CY','48201','1946-06-29','F','',':RET:2106-3','N','021','DEN','3507959','33348TX002000201','2014-03-01','2014-01-30 10:35:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','17.60',NULL,0,'2014-01-30 21:00:30'),(20738,16569,'N','19','021','EC','A',NULL,NULL,'','0000977970','0000091189','','S1','1','koons','chad',NULL,NULL,NULL,NULL,NULL,'327 MORROW ST',0,'GREENVILLE','OH','45331','1836','CY','39037','1996-02-18','F','',':RET:2106-3','N','021','HLT','3040152','92036OH005000501','2014-03-01','2014-01-29 20:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2014-01-30 21:01:22'),(21421,17122,'Y','18','021','EC','A','','','AC','0000155783','0000155783','OH00001966824','IL','1','Kopp','Nancy','','','','34','300501249','1522 MAPLE AVE',0,'WYOMING','OH','45215','2118','CY','39061','1952-01-05','F','U',':RET:2106-3','N','021','HLT','3679403','92036OH004001201','2014-03-01','2014-02-03 20:40:56','315.00',NULL,NULL,'495.91','180.91','R-OH004','OH0','495.91',NULL,0,'2014-02-04 21:01:13'),(6013,4760,'Y','18','021','EC','A','','','AC','0000566578','0000566578','OH00000533549','IL','1','Yaslovitz','Melea','','','','34','405157376','3825 MIDDLETON AVE',0,'CINCINNATI','OH','45220','1126','CY','39061','1976-08-12','F','M',':RET:2106-3','T','021','DEN','81590','99734OH005000301','2014-01-01','2013-12-01 14:36:11','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:00:38'),(406,334,'Y','18','021','EC','A','','','AC','0000607122','0000607122','OH00000752393','IL','1','Tankovich','Paul','','','','34','274744202','5715 Houseman Rd',0,'Ostrander','OH','43061',NULL,'CY','39041','1973-02-14','M','U',':RET:2106-3','N','021','DEN','534600','99734OH005000401','2014-01-01','2013-12-04 12:09:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:17'),(1312,1086,'Y','18','021','EC','A','','','AC','0000225973','0000225973','OH00000688247','IL','1','warner','robert','','','','34','341627334','3316 W 125',0,'Cleveland','OH','44111',NULL,'CY','39035','1964-03-25','M','U',':RET:2106-3','N','021','DEN','525723','99734OH005000401','2014-01-01','2013-11-04 03:55:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:31:30'),(1721,1435,'Y','18','021','EC','A','','','AC','0000788203','0000788203','OH00000332350','IL','1','Myers','David','','','','34','288546271','251 BARNES DR',0,'TALLMADGE','OH','44278','1541','CY','39153','1968-11-10','M','U',':RET:2106-3','N','021','DEN','1410619','99734OH005000301','2014-01-01','2013-12-24 10:06:16','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:55:12'),(3762,3010,'Y','18','021','EC','A','','','AC','0000829259','0000829259','OH00001189093','IL','1','Knoblock','Robert','','','','34','167408370','814 CLOVER AVE',0,'CUYAHOGA FALLS','OH','44221','1948','CY','39153','1951-03-17','M','U',':RET:2106-3','N','021','HLT','229503','52664OH151001301','2014-01-01','2013-12-13 10:48:05','287.00',NULL,NULL,'640.70','353.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 21:33:26'),(3680,2945,'Y','18','021','EC','A','','','AC','0000212148','0000212148','OH00001113323','IL','1','FREIMAN','TRACEY','JO','','','34','272669090','1040 BEVAN ST',0,'BARBERTON','OH','44203','4509','CY','39153','1959-03-27','F','U',':RET:2106-3','N','021','DEN','290146','99734OH005000401','2014-01-01','2013-12-13 09:15:51','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:31:26'),(20502,16380,'Y','18','021','EC','A','','','AC','0001983295','0001983295','LA00002445342','IL','1','Lirette','Marisha','','','','34','434673095','111 Ziegler Street',0,'Houma','LA','70360',NULL,'CY','22109','1979-12-01','F','U',':RET:2106-3','N','021','DEN','3417507','18575LA002000201','2014-03-01','2014-01-29 14:27:19','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-29 21:01:13'),(17563,14043,'Y','18','021','EC','A','','','AC','0001244188','0001244188','OH00001747211','IL','1','Vetter','Katharine','','','','34','298807903','628 CHATHAM RD',0,'COLUMBUS','OH','43214','3350','CY','39049','1971-02-27','F','U',NULL,'N','021','DEN','2288643','99734OH005000401','2014-02-01','2014-01-12 18:14:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:31:58'),(2544,2070,'Y','18','021','EC','A','','','AC','0000034345','0000034345','OH00000179346','IL','1','Bica','Thomas','','','','34','269423506','3490 OLD HICKORY LN',0,'MEDINA','OH','44256','9685','CY','39103','1949-12-18','M','M',':RET:2106-3','N','021','HLT','550576','52664OH151001501','2014-01-01','2013-12-09 11:02:44','0.00',NULL,NULL,'802.38','802.38','R-OH012','OH0','802.38',NULL,0,'2013-12-25 19:37:06'),(2750,2226,'Y','18','021','EC','A','','','AC','0000748155','0000748155','OH00001022864','IL','1','HOLTON','MELISSA','','','','34','297683477','127 MACKIE LN',0,'HARRISON','OH','45030','2021','CY','39061','1975-11-13','F','U',':RET:2106-3','N','021','HLT','660783','92036OH003001201','2014-01-01','2013-12-02 09:27:24','0.00',NULL,NULL,'279.34','279.34','R-OH004','OH0','279.34',NULL,0,'2013-12-25 19:49:03'),(3710,2968,'N','01','021','EC','A',NULL,NULL,'','0000959080','0000885572','','IL','1','Hirst','Diana','','','','34','292601755','1434 CHURCHILL RD',0,'GIRARD','OH','44420','2430','CY','39155','1960-03-14','F','',':RET:2106-3','N','021','DEN','1117656','99734OH005000401','2014-01-01','2013-12-13 14:26:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:10'),(3433,2758,'Y','18','021','EC','A','','','AC','0001267627','0001267627','LA00000089069','IL','1','Kelley','Seveda','','','','34','438519218','417 SOPHIA ST',0,'RIVER RIDGE','LA','70123','1135','CY','22051','1967-02-12','F','U',':RET:2106-3','T','021','DEN','1980211','18575LA002000101','2014-01-01','2013-12-22 11:57:25','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:19:00'),(20091,16029,'Y','18','021','EC','A','','','AC','0002114783','0002114783','LA00001945429','IL','1','LACIURA','DONNA','M','','','34','434908750','39583 W TIGER LOOP',0,'PONCHATOULA','LA','70454','9610','CY','22105','1950-03-05','F','U',NULL,'N','021','DEN','2769519','18575LA002000201','2014-03-01','2014-01-26 19:04:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-27 21:00:29'),(20876,16684,'Y','18','021','EC','A','','','AC','0002277347','0002277347','LA00001893155','31','1','MORRIS','JOHNNY','','','','34','587052094','70 buccaneer dr',0,'hattiesburg','MS','39402',NULL,'CY','22051','1950-02-22','M','U',':RET:2106-3','T','021','DEN','3239573','18575LA002000101','2014-03-01','2014-01-31 13:19:29','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-31 21:01:05'),(21194,16938,'Y','18','021','EC','A','','','AC','0000727646','0000727646','MS00001915097','IL','1','STEPHENS','JACQUELYN','','','','34','438533731','793 HARRY SONES RD',0,'CARRIERE','MS','39426','8200','CY','28109','1983-12-01','F','M',':RET:2106-3','N','021','DEN','3052190','46300MS002000101','2014-03-01','2014-02-03 16:57:01','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,0,'2014-02-03 21:00:50'),(21279,17006,'Y','18','021','EC','A','','','AC','0000720283','0000720283','OH00002250667','IL','1','Jeziorowski','Kaitlin','','','','34','281846178','2331 EASTBROOK DR',0,'TOLEDO','OH','43613','3924','CY','39095','1984-06-08','F','U',NULL,'N','021','HLT','2873995','92036OH003002605','2014-03-01','2014-02-03 17:45:41','110.00',NULL,NULL,'227.86','117.86','R-OH001','OH0','227.86',NULL,0,'2014-02-03 21:01:36'),(22076,17620,'N','01','021','EC','A',NULL,NULL,'','0001268791','0002209238','','IL','1','Tubbs','Kelly','E','','','34','434550381','2056 E TEXAS ST',0,'BOSSIER CITY','LA','71111','3844','CY','22015','1972-03-25','F','',':RET:2106-3','N','021','DEN','2621245','18575LA002000201','2014-03-01','2014-02-07 20:27:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-08 19:00:16'),(22143,17674,'Y','18','021','EC','A','','','AC','0000614148','0000614148','OH00002518669','IL','1','Harpster','Kaleena','','','','34','299888504','1214 ANDERSON RD',0,'CUYAHOGA FALLS','OH','44221','4304','CY','39153','1988-08-22','F','U',':RET:2106-3','N','021','HLT','2853871','52664OH152000901','2014-03-01','2014-02-08 16:19:29','90.00',NULL,NULL,'163.99','73.99','R-OH012','OH0','163.99',NULL,0,'2014-02-08 19:00:49'),(24665,19580,'Y','18','021','EC','A','','','AC','0000149395','0000149395','OH00002642209','IL','1','Schulte','Rebecca','','','','34','294722750','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1962-07-10','F','R',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17','0.00',NULL,NULL,'770.28','770.28','R-OH002','OH0','325.53',NULL,0,'2014-02-20 04:26:31'),(27644,21866,'Y','18','024','14','A','','','TE','0000421530','0000421530','','IL','1','Bernal','April','LeEllen',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1996-12-21','F','',NULL,NULL,NULL,'','4070870','','2014-03-05','2014-03-05 12:17:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:30:18'),(14971,11966,'Y','18','021','EC','A','','','AC','0000409171','0000409171','TX00001516115','IL','1','White','Timothy','','','','34','463997974','606 CYPRESSWOOD TRCE',0,'SPRING','TX','77373','3031','CY','48201','1982-09-25','M','R',':RET:2106-3','T','021','DEN','2203448','33348TX002000201','2014-02-01','2013-12-30 12:33:55','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:00:49'),(377,313,'Y','18','021','EC','A','','','AC','0000151570','0000151570','TX00000931622','IL','1','Londoff','Daniel','','','','34','491708435','14773 COUNTY ROAD 1125',0,'TYLER','TX','75703','6707','CY','48423','1959-02-14','M','M',':RET:2106-3','N','021','DEN','813250','33348TX002000201','2014-01-01','2013-12-03 23:35:48','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 17:45:36'),(7718,6112,'Y','18','021','EC','A','','','AC','0000327246','0000327246','OH00000591637','IL','1','Adams','Edward','','','','34','281660730','729 MOON RD',0,'COLUMBUS','OH','43224','3159','CY','39049','1967-05-07','M','R',':RET:2054-5^:RET:2106-3','N','021','DEN','2454047','99734OH005000401','2014-01-01','2013-12-20 13:28:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:01:40'),(1437,1199,'Y','18','021','EC','A','','','AC','0000844110','0000844110','MS00000881224','IL','1','Bass','Vincent','','','','34','343441814','6869 Delta Newberry Cove',0,'Olive Branch','MS','38654',NULL,'CY','28033','1952-03-25','M','U',':RET:2054-5','N','021','DEN','1561410','46300MS002000101','2014-01-01','2013-12-24 03:49:36','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 18:47:45'),(14439,11516,'Y','18','021','EC','A','','','AC','0001385866','0001385866','LA00001219656','IL','1','Oliver','Belinda','','','','34','437116896','264 RIVERVIEW DR',0,'SAINT ROSE','LA','70087','3541','CY','22089','1958-08-12','F','U',':RET:2054-5','N','021','DEN','2539814','18575LA002000201','2014-02-01','2013-12-27 11:19:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:08'),(6367,5048,'Y','18','021','EC','A','','','AC','0001034640','0001034640','OH00000796359','IL','1','Wingate','Diana','','','','34','270564368','9390 BASSETT LN',0,'NORTH ROYALTON','OH','44133','2814','CY','39035','1954-04-30','F','U',':RET:2106-3','N','021','DEN','509704','99734OH005000301','2014-01-01','2013-12-10 21:33:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:31'),(5697,4521,'Y','18','021','EC','A','','','AC','0001151043','0001151043','OH00001026809','IL','1','FINDLEY','PAUL','','','','34','287861852','30 RED DELICIOUS LN',0,'AMHERST','OH','44001','3113','CY','39093','1981-08-31','M','U',':RET:2106-3','T','021','HLT','85468','92036OH002000801','2014-01-01','2013-11-26 00:55:03','206.00',NULL,NULL,'367.32','161.32','R-OH011','OH0','367.32',NULL,0,'2013-12-25 23:32:47'),(20282,16187,'Y','18','024','14','A','','','TE','0000122982','0000122982','','IL','1','Canning-Hollenbeck','Julie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-11-05','F','',NULL,NULL,NULL,'','1642424','','2014-01-28','2014-01-28 15:45:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:30'),(21445,17140,'N','19','021','EC','A',NULL,NULL,'','0001053089','0000485895','','IL','1','Ebert','Daniel','','','','34','296943735','1092 WEXFORD CT',0,'AKRON','OH','44312','4635','CY','39153','1992-04-10','M','',':RET:2106-3','N','021','HLT','3628447','52664OH151001501','2014-03-01','2014-02-04 12:09:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2014-02-04 21:01:26'),(24410,19390,'Y','18','021','EC','A','','','AC','0000984901','0000984901','OH00002922699','IL','1','GRACE','MICHELLE','','','','34','280644747','5706 STEWART AVE',0,'CINCINNATI','OH','45227','1228','CY','39061','1972-05-15','F','U',':RET:2054-5','T','021','DEN','2714334','99734OH005000301','2014-04-01','2014-02-18 09:51:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:01:01'),(27454,21727,'Y','18','021','EC','A','','','AC','0001111729','0001111729','OH00002621621','IL','1','Smith','Tammie','','','','34','302747119','199 ORCHARD CIR',0,'BLANCHESTER','OH','45107','1029','CY','39027','1964-07-27','F','U',':RET:2106-3','T','021','HLT','3974332','92036OH006000601','2014-04-01','2014-03-04 16:57:00','310.00',NULL,NULL,'334.01','24.01','R-OH005','OH0','334.01',NULL,0,'2014-03-04 21:02:01'),(796,657,'Y','18','024','14','A','','','TE','0000311517','0000311517','','IL','1','Robinson','Bilindra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-30','F','',NULL,NULL,NULL,'','1083819','','2013-12-16','2013-12-16 16:51:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:05:26'),(18085,14444,'Y','18','021','EC','A','','','AC','0001274270','0001274270','LA00002178446','IL','1','Guillen','Eddy','Villalta','','','34','587851925','918 BOURBON ST',0,'NEW ORLEANS','LA','70116','3121','CY','22071','1965-11-18','M','U',':RET:2106-3','N','021','DEN','2360365','18575LA002000201','2014-02-01','2014-01-14 11:34:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:28'),(9301,7374,'Y','18','021','EC','A','','','AC','0000992651','0000992651','OH00000472667','IL','1','Fall','Jamie','','','','34','278764864','1345 WASHINGTON AVE',0,'FINDLAY','OH','45840','5153','CY','39063','1964-07-03','F','U',':RET:2106-3','N','021','HLT','144246','92036OH005001501','2014-01-01','2013-11-30 16:36:19','100.00',NULL,NULL,'375.47','275.47','R-OH002','OH0','375.47',NULL,0,'2013-12-26 04:16:23'),(16568,13253,'N','19','021','EC','A',NULL,NULL,'','0001204544','0001030387','','IL','1','Johnson','Kenneth','','','','34','269113134','2318 DEERPATH LN',0,'TOLEDO','OH','43614','5012','CY','39095','2004-09-10','M','',':RET:2054-5','N','021','HLT','2243536','92036OH003002604','2014-02-01','2014-01-04 20:22:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,1,'2014-01-07 10:23:14'),(2665,2164,'N','01','021','EC','A',NULL,NULL,'','0000987360','0000688255','','IL','1','Carnes','Mary','E','','','34','312562196','461 SANOMA CT',0,'CINCINNATI','OH','45255','5645','CY','39025','1949-08-26','F','',':RET:2106-3','N','021','DEN','438721','99734OH005000301','2014-01-01','2013-12-02 11:45:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:55'),(15522,12418,'Y','18','021','EC','A','','','AC','0002032773','0002032773','LA00001401790','IL','1','Laing','Gaye','','','','34','433271144','3742 BAYOU ACRES DR',0,'BASTROP','LA','71220','7405','CY','22067','1961-04-13','F','M',':RET:2106-3','N','021','DEN','2563303','18575LA002000201','2014-02-01','2013-12-30 20:06:12','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:30:20'),(14016,11165,'N','01','021','EC','A',NULL,NULL,'','0000578783','0000830632','','IL','1','Root','Danielle','J','','','34','340766858','2202 KINNETT RD',0,'BETHEL','OH','45106','7213','CY','39025','1971-11-30','F','',':RET:2106-3','N','021','HLT','2511505','92036OH003000606','2014-01-01','2013-12-23 15:05:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.05',NULL,0,'2013-12-26 13:16:29'),(6966,5529,'N','19','021','EC','A',NULL,NULL,'','0001096764','0001221944','','IL','1','SYNDER','KAI','','','','34','282968591','976 W WEBB RD',0,'MERIAL RIDGE','OH','44440',NULL,'CY','39155','1993-10-11','M','',NULL,'N','021','DEN','1819156','99734OH005000401','2014-01-01','2013-12-24 22:46:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:22'),(19451,15504,'Y','18','021','EC','A','','','AC','0000234077','0000234077','OH00002105260','IL','1','SERGENT-MICHEL','SANDRA','S','','','34','302501234','764 FROOME AVE',0,'CINCINNATI','OH','45232','1745','CY','39061','1952-06-17','F','M',':RET:2106-3','N','021','DEN','2870281','99734OH005000301','2014-03-01','2014-01-22 17:38:14','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:01:52'),(19993,15949,'Y','18','021','EC','A','','','AC','0000035782','0000035782','OH00001711875','IL','1','parmar','prakashsinh','','','','34','406694050','8109 w mill st',0,'cleves','OH','45002',NULL,'CY','39061','1979-11-15','M','M',':RET:2029-7','N','021','HLT','3171094','92036OH004001201','2014-03-01','2014-01-25 12:59:19','209.00',NULL,NULL,'447.35','238.35','R-OH004','OH0','209.55',NULL,0,'2014-01-25 19:00:20'),(22055,17605,'Y','18','021','EC','A','','','AC','0001089706','0001089706','TX00001422392','IL','1','MORGAN','RUBERTHA','','','','34','454554725','818 Richcrest Drive',0,'Houston','TX','77060',NULL,'CY','48201','1980-12-29','F','U',':RET:2054-5','N','021','DEN','2824036','33348TX002000201','2014-03-01','2014-02-07 22:12:48','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-08 19:00:07'),(22671,18104,'Y','18','021','EC','A','','','AC','0001165559','0001165559','TX00001823142','IL','1','Castro','Anita','','','','34','464024481','154 KOEPKE AVE',0,'SAN ANTONIO','TX','78214','1443','CY','48029','1955-09-25','F','U',':RET:2106-3','N','021','DEN','3093393','33348TX002000201','2014-03-01','2014-02-11 15:20:12','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-11 21:00:42'),(24051,19128,'Y','18','021','EC','A','','','AC','0000376187','0000376187','OH00002116080','IL','1','HOLBERT','ALBERTA','','','','34','285689255','27089 COOK RD',0,'OLMSTED FALLS','OH','44138','1110','CY','39035','1974-10-14','F','U',':RET:2106-3','N','021','DEN','3681182','99734OH005000301','2014-03-01','2014-02-15 11:36:23','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:01:04'),(25445,20189,'Y','18','021','EC','A','','','AC','0000844913','0000844913','TX00002489334','31','1','Gibson','Carla','','','','34','465117768','PO Box 1928',0,'ROCKPORT','TX','78381',NULL,'CY','48007','1956-07-12','F','M',NULL,'N','021','DEN','3665775','33348TX002000201','2014-04-01','2014-02-25 12:25:43','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-25 21:31:23'),(28177,22298,'N','01','021','EC','A',NULL,NULL,'','0000285689','0000819839','','IL','1','RAFEEDIE','JACOB','ISSA','','','34','273829442','4018 BAYMAR DR',0,'YOUNGSTOWN','OH','44511','3439','CY','39099','1976-04-06','M','',NULL,'N','021','HLT','3906018','92036OH001003201','2014-04-01','2014-03-06 12:39:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','361.45',NULL,0,'2014-03-06 21:02:52'),(18380,14670,'Y','18','021','EC','A','','','AC','0000697935','0000697935','OH00002002488','IL','1','salmons','Josh','','','','34','270923120','2431 INDIANOLA AVE',0,'COLUMBUS','OH','43202','3012','CY','39049','1989-11-16','M','U',':RET:2106-3','N','021','DEN','2897804','99734OH005000301','2014-02-01','2014-01-15 09:35:12','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:34'),(978,801,'Y','18','021','EC','A','','','AC','0000699226','0000699226','OH00000270838','IL','1','vickery','charlotte','','','','34','289621670','115 Barbara Lane',0,'Sherwood','OH','43556',NULL,'CY','39039','1964-08-10','F','M',':RET:2106-3','N','021','HLT','1031568','92036OH005002601','2014-01-01','2013-10-28 22:42:12','300.00',NULL,NULL,'750.90','450.90','R-OH001','OH0','332.67',NULL,0,'2013-12-25 18:10:13'),(1262,1041,'Y','18','021','EC','A','','','AC','0000596245','0000596245','OH00000152488','IL','1','lomax','nathaniel','','','','34','268781546','2045 woodtrail drive',0,'fairfield','OH','45014',NULL,'CY','39017','1981-04-15','M','U',':RET:2054-5','N','021','HLT','417108','92036OH006001201','2014-01-01','2013-12-03 16:55:10','0.00',NULL,NULL,'201.40','201.40','R-OH004','OH0','201.40',NULL,0,'2013-12-25 18:21:35'),(8079,6398,'Y','18','021','EC','A','','','AC','0000923318','0000923318','OH00000819560','IL','1','Hoehn','Paul','','','','34','284647811','7109 Daleview Road',0,'Cincinnati','OH','45247',NULL,'CY','39061','1958-11-21','M','M',':RET:2106-3','T','021','HLT','2015120','92036OH004001201','2014-01-01','2013-12-20 14:51:14','722.00',NULL,NULL,'1046.82','324.82','R-OH004','OH0','442.67',NULL,0,'2013-12-26 03:10:25'),(18110,14465,'N','01','021','EC','A',NULL,NULL,'','0002255092','0001496795','','IL','1','Pham','Loi','Minh','','','34','626417751','1392 WELLINGTON DR',0,'BATON ROUGE','LA','70815','5337','CY','22033','1958-04-27','M','',NULL,'N','021','DEN','2890364','18575LA002000201','2014-02-01','2014-01-14 18:33:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:37'),(16370,13100,'N','19','021','EC','A',NULL,NULL,'','0000071699','0001144895','','IL','1','Wingfield','Giavanna','Patricia-Rose','','','34','635083868','4200 SCOTLAND ST',0,'HOUSTON','TX','77007',NULL,'CY','48201','2007-04-08','F','',':RET:2106-3','N','021','DEN','1673024','33348TX002000101','2014-02-01','2014-01-06 12:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-07 04:03:01'),(15583,12470,'Y','18','021','EC','A','','','AC','0000114189','0000114189','OH00001641180','IL','1','Smith','Todd','','','','34','286866405','556 HOWELLS CT',0,'EASTLAKE','OH','44095','1237','CY','39085','1973-03-29','M','U',':RET:2106-3','N','021','DEN','1632554','99734OH005000301','2014-02-01','2013-12-30 19:26:50','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:32:14'),(5190,4117,'Y','18','021','EC','A','','','AC','0000383348','0000383348','OH00000745106','IL','1','Harper','Donna','','','','34','295642942','6350 Stumph Road',0,'Parma Heights','OH','44130',NULL,'CY','39035','1957-06-10','F','U',':RET:2106-3','N','021','DEN','1682007','99734OH005000401','2014-01-01','2013-12-19 13:35:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:46'),(4551,3605,'N','01','021','EC','A',NULL,NULL,'','0001183512','0000889584','','IL','1','Daugherty','Jill','','','','34','391800941','9275 DANIELS RD',0,'SEVILLE','OH','44273','8843','CY','39103','1959-05-17','F','',':RET:2106-3','N','021','HLT','918505','52664OH152000901','2014-01-01','2013-12-12 09:02:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.73',NULL,0,'2013-12-25 22:04:32'),(15086,12059,'Y','18','021','EC','A','','','AC','0000390691','0000390691','TX00001819698','IL','1','Minkovskaya','Danute','','','','34','641663026','15190 PRESTONWOOD BLVD',0,'DALLAS','TX','75248','4730','CY','48113','1957-03-29','F','U',':RET:2106-3','N','021','DEN','1981904','33348TX002000101','2014-02-01','2013-12-30 18:25:26','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-01 12:04:20'),(22384,17873,'N','01','021','EC','A',NULL,NULL,'','0001156236','0001092169','','IL','1','Cassiday','Angele','','','','34','179627116','2955 PREAKNESS DR',0,'STOW','OH','44224','6235','CY','39153','1968-08-28','F','',':RET:2106-3','N','021','HLT','2648777','52664OH151001306','2014-03-01','2014-02-10 10:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.02',NULL,0,'2014-02-10 21:30:10'),(24202,19221,'N','19','021','EC','A',NULL,NULL,'','0000221366','0000475017','','IL','1','Albrinck','Nicholas','','','','34','279060629','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','2001-04-05','M','',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:18'),(24680,19589,'Y','18','021','EC','A','','','AC','0000983854','0000983854','TX00002888782','IL','1','Park','David','','','','34','576433027','2312 TAHOE LN',0,'DENTON','TX','76210','2986','CY','48121','1983-05-26','M','U',':RET:2040-4^:RET:2106-3','N','021','DEN','3053656','33348TX002000101','2014-04-01','2014-02-18 22:51:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-20 04:30:00'),(26310,20874,'Y','18','021','EC','A','','','AC','0000408135','0000408135','TX00002104535','IL','1','WALKER','GWENDOLYN','K','','','34','450115213','328 TENNESSEE ST',0,'HOUSTON','TX','77029','4640','CY','48201','1954-12-19','F','M',':RET:2054-5','N','021','DEN','3273169','33348TX002000101','2014-04-01','2014-02-27 14:15:05','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-28 06:31:33'),(26869,21296,'Y','18','021','EC','A','','','AC','0000195192','0000195192','OH00002980474','IL','1','Morris','Monica','','','','34','276844547','745 GRACE AVE',0,'AKRON','OH','44320','3748','CY','39153','1972-02-25','F','U',NULL,'N','021','HLT','3040877','52664OH151001305','2014-04-01','2014-03-01 09:13:49','303.00',NULL,NULL,'437.09','134.09','R-OH012','OH0','295.48',NULL,0,'2014-03-01 21:01:02'),(27514,21766,'Y','18','021','EC','A','','','AC','0000253107','0000253107','OH00003371202','IL','1','ANDRES','DAVID','K','','','34','302443393','10596 NEW BIDDINGER RD',0,'HARRISON','OH','45030',NULL,'CY','39061','1953-02-21','M','U',':RET:2106-3','N','021','HLT','3825059','92036OH003001201','2014-04-01','2014-03-04 10:40:38','250.00',NULL,NULL,'629.96','379.96','R-OH004','OH0','629.96',NULL,0,'2014-03-04 21:02:34'),(1698,1417,'Y','18','021','EC','A','','','AC','0000687221','0000687221','OH00000434960','IL','1','Overton','Joyce','','','','34','300486136','3118 MULBERRY ST',0,'TOLEDO','OH','43608','1900','CY','39095','1951-08-17','F','U',':RET:2054-5','T','021','HLT','2194833','92036OH004002601','2014-01-01','2013-12-24 13:06:51','218.00',NULL,NULL,'518.03','300.03','R-OH001','OH0','518.03',NULL,0,'2013-12-25 18:54:37'),(20816,16635,'Y','18','021','EC','A','','','AC','0002128620','0002128620','LA00002118260','IL','1','Crowe','Dwayne','','','','34','255536304','3408 N. Rampart St.',0,'New Orleans','LA','70117',NULL,'CY','22071','1970-04-26','M','U',':RET:2106-3','N','021','DEN','2650726','18575LA002000201','2014-03-01','2014-01-30 19:03:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:32'),(24496,19460,'N','01','021','EC','A',NULL,NULL,'','0000204349','0000310704','','IL','1','Vargas','Nora','Lisa','','','34','434196746','1617 S. Lasater',0,'Falfurrias','TX','78355',NULL,'CY','48047','1965-08-08','F','',NULL,'N','021','DEN','3435444','33348TX002000201','2014-04-01','2014-02-18 19:29:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:46:56'),(25227,20010,'Y','18','021','EC','A','','','AC','0000726180','0000726180','OH00002104388','IL','1','BRELO','ROBERT','M','','','34','289720798','2001 SACKETT AVE',0,'CUYAHOGA FALLS','OH','44223','1868','CY','39153','1971-08-18','M','U',':RET:2106-3','N','021','HLT','2828552','52664OH151001305','2014-04-01','2014-02-21 13:16:09','204.00',NULL,NULL,'295.48','91.48','R-OH012','OH0','295.48',NULL,0,'2014-02-21 22:01:00'),(9766,7733,'Y','18','021','EC','A','','','AC','0000605909','0000605909','OH00000051849','IL','1','bair','laura','','','','34','295680336','45 ROBIN HOOD DR',0,'GREENVILLE','OH','45331','9773','CY','39037','1970-10-30','F','U',':RET:2106-3','N','021','DEN','433104','99734OH005000401','2014-01-01','2013-10-20 20:37:01','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 05:00:19'),(6947,5517,'Y','18','024','14','A','','','TE','0000260477','0000260477','','IL','1','WILLIAMS','LOIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-11-13','F','',NULL,NULL,NULL,'','1940692','','2013-12-24','2013-12-24 20:58:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:46:57'),(3153,2536,'Y','18','021','EC','A','','','AC','0000930879','0000930879','OH00001181774','IL','1','Zaret','Lisa','','','','34','283505390','2312 Elstun Road',0,'Cincinnati','OH','45230',NULL,'CY','39061','1961-07-12','F','M',':RET:2106-3','N','021','DEN','848603','99734OH005000301','2014-01-01','2013-11-18 15:41:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:06'),(1284,1061,'Y','18','021','EC','A','','','AC','0000533784','0000533784','MS00000867779','IL','1','Thomas','Anthony','','','','34','199585984','858 WOODLAKE DR',0,'JACKSON','MS','39206','2222','CY','28049','1978-05-19','M','U',':RET:2054-5','N','021','DEN','219987','46300MS002000201','2014-01-01','2013-11-28 22:28:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:30:39'),(19890,15864,'N','01','021','EC','A',NULL,NULL,'','0000771465','0001148752','','IL','1','Casserman','Diane','','','','34','294560508','4470 CYNTHIA DR',0,'NORTH CANTON','OH','44720','1206','CY','39153','1957-11-27','F','',':RET:2106-3','N','021','HLT','2812919','52664OH151001301','2014-03-01','2014-01-24 13:48:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2014-01-24 21:00:50'),(23056,18382,'N','01','021','EC','A',NULL,NULL,'','0001255755','0001921297','','IL','1','Russo','Christy','','','','34','435611657','209 MASTERS POINT CT',0,'SLIDELL','LA','70458','5786','CY','22103','1978-01-01','F','',':RET:2106-3','N','021','DEN','3767594','18575LA002000201','2014-03-01','2014-02-11 23:07:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-12 21:30:48'),(27950,22110,'Y','18','021','EC','A','','','AC','0001070523','0001070523','TX00003173327','IL','1','Ponce Galvan','Valentin','','','','34','640242016','75 Underwood Dr',0,'Huntsville','TX','77340',NULL,'CY','48471','1967-02-14','M','U',':RET:2106-3','N','021','DEN','3261237','33348TX002000201','2014-04-01','2014-03-06 16:43:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:37'),(128,111,'Y','18','021','EC','A','','','AC','0001003569','0001003569','MS00000330167','IL','1','Dearman','Linda','','','','34','587549927','56 O. F. Johnston Road',0,'Laurel','MS','39443',NULL,'CY','28067','1951-08-12','F','M',':RET:2106-3','N','021','DEN','555709','46300MS002000201','2014-01-01','2013-12-05 12:06:31','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 17:18:23'),(4293,3415,'Y','18','021','EC','A','','','AC','0001175961','0001175961','MS00000790750','IL','1','Jackson','Georgia','M','','','34','587266952','205 DORIS FRANCIS BLVD',0,'CANTON','MS','39046','7020','CY','28089','1950-11-19','F','U',':RET:2054-5','N','021','DEN','1468513','46300MS002000201','2014-01-01','2013-12-17 11:03:47','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:52:12'),(14413,11495,'Y','18','021','EC','A','','','AC','0000298712','0000298712','TX00001643513','IL','1','Aguirre','Noemi','','','','34','459822553','6423 WILDLIFE WAY',0,'BAYTOWN','TX','77523','7480','CY','48071','1950-11-28','F','U',':RET:2106-3','N','021','DEN','1550352','33348TX002000101','2014-02-01','2013-12-27 06:35:32','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:30'),(13413,10701,'Y','18','021','EC','A','','','AC','0001029353','0001029353','OH00000838801','IL','1','Davis','David','L','','','34','279567349','3941 MANTELL AVE',0,'CINCINNATI','OH','45236','1669','CY','39061','1960-12-03','M','M',NULL,'N','021','DEN','2118405','99734OH005000301','2014-01-01','2013-12-23 10:06:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:36'),(21105,16863,'N','19','021','EC','A',NULL,NULL,'','0000874735','0000725092','','IL','1','Pylypuik','Zachary','R',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','2000-06-06','M','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:04'),(127,110,'Y','18','021','EC','A','','','AC','0000958371','0000958371','MS00001117181','IL','1','Betts','Charlie','','','','34','587627653','5818 N HARPER ROAD EXT',0,'CORINTH','MS','38834','7025','CY','28003','1952-02-02','M','U',':RET:2054-5','N','021','DEN','35569','46300MS002000201','2014-01-01','2013-12-05 10:39:17','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 17:18:21'),(6439,5106,'N','01','021','EC','A',NULL,NULL,'','0000902046','0000706958','','IL','1','celestin','joel','','','','34','435350562','201 BARKSDALE DR',0,'BROUSSARD','LA','70518','9100','CY','22055','1973-08-22','M','',NULL,'N','021','DEN','449226','18575LA002000201','2014-01-01','2013-12-11 16:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:49:23'),(7363,5831,'Y','18','021','EC','A','','','AC','0000643536','0000643536','MS00000543514','IL','1','Garrett','Quiton','','','','34','425591231','30 N HILL PKWY',0,'JACKSON','MS','39206','5574','CY','28049','1987-08-28','M','U',':RET:2054-5','N','021','DEN','795814','46300MS002000201','2014-01-01','2013-11-23 17:46:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:15:27'),(1464,1220,'N','01','021','EC','A',NULL,NULL,'','0000669182','0000344144','','IL','1','TENAGLIO','RICHARD','','','','34','292508191','1418 CHURCHILL HUBBARD RD',0,'YOUNGSTOWN','OH','44505','1349','CY','39155','1951-01-16','M','',':RET:2106-3','N','021','DEN','1444476','99734OH005000401','2014-01-01','2013-12-24 08:59:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:24'),(19138,15249,'Y','18','024','14','A','','','TE','0000316891','0000316891','','IL','1','Carson','Annette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-07-24','F','',NULL,NULL,NULL,'','1889400','','2014-01-18','2014-01-18 23:08:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:45:28'),(20258,16166,'Y','18','021','EC','A','','','AC','0001223200','0001223200','OH00002182357','IL','1','McGinnis','Martha','Jane','','','34','156544101','4635 BAKER ST',0,'CINCINNATI','OH','45212','2501','CY','39061','1956-11-26','F','R',':RET:2106-3','N','021','DEN','2622403','99734OH005000301','2014-03-01','2014-01-27 21:35:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-28 21:00:17'),(20926,16724,'N','17','021','EC','A',NULL,NULL,'','0000125594','0001174431','','IL','1','SCOTT','MADISON','','','','34','286116335','1516 CHESTNUT BLVD',0,'CUYAHOGA FALLS','OH','44223','2347','CY','39153','2005-09-14','F','',':RET:2106-3','N','021','HLT','2093280','52664OH151001501','2014-03-01','2014-01-31 13:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-01-31 21:01:34'),(22538,17996,'Y','18','021','EC','A','','','AC','0001070309','0001070309','MS00002195341','IL','1','neal','jerlean','','','','34','426356098','1002 DAVID BRITT ST',0,'WESSON','MS','39191','9050','CY','28029','1976-09-20','F','U',':RET:2054-5','N','021','DEN','3451799','46300MS002000201','2014-03-01','2014-02-10 16:41:21','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 21:31:37'),(22561,18018,'Y','18','024','14','A','','','TE','0000346848','0000346848','','IL','1','Sharpe','Keven','James',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-30','M','',NULL,NULL,NULL,'','111503','','2014-02-25','2014-02-10 12:19:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-10 21:31:51'),(24595,19526,'Y','18','021','EC','A','','','AC','0000452799','0000452799','OH00001844579','IL','1','MIKESELL','EDWIN','','','','34','274686953','9785 BUNKERHILL LANE',0,'CINCINATTI','OH','45242',NULL,'CY','39061','1963-01-17','M','U',NULL,'N','021','DEN','2879396','99734OH005000301','2014-04-01','2014-02-19 14:41:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:11:35'),(14837,11849,'Y','18','021','EC','A','','','AC','0000170159','0000170159','OH00001371100','IL','1','Kirchmer','Ryan','','','','34','302749572','8014 CYPRESSTREE CIR',0,'WEST CHESTER','OH','45069','1625','CY','39017','1974-11-28','M','M',':RET:2106-3','N','021','DEN','1578531','99734OH005000301','2014-01-01','2013-12-23 19:46:42','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:14:44'),(860,712,'Y','18','021','EC','A','','','AC','0001147326','0001147326','OH00001164672','IL','1','Eickholt','Lois','','','','34','289520652','825 East Main St',0,'Ottawa','OH','45875',NULL,'CY','39137','1950-11-18','F','U',NULL,'N','021','HLT','1482180','92036OH005001506','2014-01-01','2013-12-16 15:41:25','628.00',NULL,NULL,'649.68','21.68','R-OH002','OH0','649.68',NULL,0,'2013-12-25 18:07:08'),(2757,2230,'Y','18','021','EC','A','','','AC','0000717800','0000717800','OH00000330081','IL','1','HALL','ROBERT','JOHN','','','34','298483142','239 EAST BAIRD AVE',0,'BARBERTON','OH','44203',NULL,'CY','39153','1952-01-17','M','U',':RET:2106-3','T','021','HLT','513343','52664OH151001304','2014-01-01','2013-12-02 14:53:25','426.00',NULL,NULL,'720.65','294.65','R-OH012','OH0','720.65',NULL,0,'2013-12-25 19:49:13'),(14669,11710,'Y','18','021','EC','A','','','AC','0000599342','0000599342','TX00001677280','IL','1','GARCIA','MAURO','F','','','34','453748480','1314 SALINAS ST',0,'EAGLE PASS','TX','78852','3725','CY','48323','1950-11-21','M','M',NULL,'N','021','DEN','2304550','33348TX002000201','2014-02-01','2013-12-28 17:30:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:08:12'),(8872,7035,'Y','18','021','EC','A','','','AC','0000605503','0000605503','TX00000038846','IL','1','RAMIREZ','NORA','G','','','34','467961152','701 LA PALMA ST',0,'SAN BENITO','TX','78586','4209','CY','48061','1954-08-04','F','M',NULL,'N','021','DEN','2460482','33348TX002000201','2014-01-01','2013-12-18 14:18:09','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2013-12-26 04:01:36'),(8933,7082,'Y','18','021','EC','A','','','AC','0000234042','0000234042','OH00000853329','IL','1','Martin','Jennifer','','','','34','592280204','6119 W. River Rd. S.',0,'Elyria','OH','44035',NULL,'CY','39093','1971-10-31','F','U',':RET:2106-3','N','021','DEN','2530779','99734OH005000401','2014-01-01','2013-12-18 10:24:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:05'),(6333,5022,'Y','18','021','EC','A','','','AC','0001088245','0001088245','OH00000225401','IL','1','Jordan','Sara','','','','34','187640968','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','1984-05-24','F','R',NULL,'T','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40','0.00',NULL,NULL,'71.95','71.95','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:46:40'),(18441,14713,'Y','18','021','EC','A','','','AC','0001446953','0001446953','LA00002579641','IL','1','NETTERVILLE','DIANNA','','','','34','433855102','7399 AGATE ST',0,'NEW ORLEANS','LA','70124',NULL,'CY','22071','1987-12-23','F','U',':RET:2106-3','N','021','DEN','2492577','18575LA002000201','2014-02-01','2014-01-15 17:12:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:46:03'),(18456,14723,'Y','18','021','EC','A','','','AC','0001616395','0001616395','LA00002341234','IL','1','Jones','Valerie','','','','34','426964947','12932 TOLLWAY DR',0,'BATON ROUGE','LA','70816','4915','CY','22033','1953-03-23','F','U',':RET:2054-5','N','021','DEN','1937029','18575LA002000101','2014-02-01','2014-01-15 10:24:49','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:10'),(21199,16940,'N','19','021','EC','A',NULL,NULL,'','0000523443','0000271459','','IL','1','Newell','Elizabeth','Ann','','','34','268965904','12970 HARLON AVE',0,'LAKEWOOD','OH','44107','2812','CY','39035','1992-07-05','F','',':RET:2106-3','N','021','HLT','3593362','92036OH005000801','2014-03-01','2014-02-02 23:41:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.79',NULL,0,'2014-02-03 21:00:52'),(22859,18236,'N','19','021','EC','A',NULL,NULL,'','0000708982','0001245636','','IL','1','Swisher','Kimberly','','','','34','286925532','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1990-08-12','F','',':RET:2106-3','N','021','HLT','3585946','92036OH003002705','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2014-02-11 21:02:24'),(23993,19077,'Y','18','021','EC','A','','','AC','0002133340','0002133340','LA00001976581','IL','1','Oliver','Dawn','','','','34','562658356','275 LOUISE CT',0,'GRETNA','LA','70056','7800','CY','22051','1979-02-08','F','U',':RET:2054-5','N','021','DEN','3737177','18575LA002000201','2014-03-01','2014-02-15 15:06:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:27'),(27327,21638,'Y','18','021','EC','A','','','AC','0000196604','0000196604','TX00003199317','IL','1','Garza','Leandro','','','','34','636448108','416 W. Diamondhead Ave',0,'Alton','TX','78573',NULL,'CY','48215','1954-05-25','M','M',':RET:2106-3','N','021','DEN','3859396','33348TX002000201','2014-04-01','2014-03-04 17:05:05','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-04 21:00:50'),(27803,21991,'N','01','021','EC','A',NULL,NULL,'','0000930979','0000228397','','IL','1','DONALDSON MILLER','ELIZABETH','','','','34','277503806','15200 S DEEPWOOD LN',0,'CHAGRIN FALLS','OH','44022','2642','CY','39055','1961-04-30','F','',NULL,'N','021','HLT','4107626','52664OH151001305','2014-04-01','2014-03-05 12:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.97',NULL,0,'2014-03-05 21:31:47'),(17983,14370,'Y','18','021','EC','A','','','AC','0000483504','0000483504','OH00001843795','IL','1','ROCK','MARY','K','','','34','275504012','165 PROVENCE PT.',0,'AKRON','OH','44333',NULL,'CY','39153','1951-09-08','F','U',':RET:2106-3','N','021','HLT','1520179','52664OH151001305','2014-02-01','2014-01-14 16:13:53','506.00',NULL,NULL,'640.70','134.70','R-OH012','OH0','640.70',NULL,0,'2014-01-15 02:06:54'),(6974,5534,'Y','18','021','EC','A','','','AC','0000636014','0000636014','OH00000238558','IL','1','Smilanich','Vickie','','','','34','269503858','19730 Roslyn Dr.',0,'Rocky River','OH','44116',NULL,'CY','39035','1954-08-17','F','M',':RET:2106-3','N','021','DEN','2205608','99734OH005000401','2014-01-01','2013-12-24 23:25:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:32'),(364,301,'Y','18','024','14','A','','','TE','0000361659','0000361659','','IL','1','Kay','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-04','M','',NULL,NULL,NULL,'','919683','','2013-12-03','2013-12-03 22:15:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 17:45:16'),(718,593,'Y','18','021','EC','A','','','AC','0000835138','0000835138','TX00000258362','IL','1','Jay','Mary','','','','34','137461785','2164 CHAPMAN DR',0,'CARROLLTON','TX','75010','4156','CY','48121','1952-02-29','F','U',':RET:2106-3','N','021','DEN','812205','33348TX002000101','2014-01-01','2013-12-15 18:55:49','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:03:23'),(1056,865,'Y','18','021','EC','A','','','AC','0001033794','0001033794','TX00000335383','IL','1','jones','wilma','','','','34','455313746','5319 sherry st',0,'san antonio','TX','78242',NULL,'CY','48029','1963-12-08','F','U',':RET:2036-2','N','021','DEN','836688','33348TX002000201','2014-01-01','2013-12-03 17:31:56','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 18:16:10'),(4522,3583,'Y','18','021','EC','A','','','AC','0000326678','0000326678','TX00000731498','IL','1','pfrimmer','michael','','','','34','239821594','606 west 12th street',0,'weslaco','TX','78596',NULL,'CY','48215','1950-10-21','M','U',':RET:2106-3','N','021','DEN','298219','33348TX002000201','2014-01-01','2013-12-12 13:03:40','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:03:51'),(3996,3191,'Y','18','021','EC','A','','','AC','0000232641','0000232641','OH00000207896','IL','1','Phillips','Catherine','','','','34','289446238','19475 Twp. Rd. 52',0,'Bluffton','OH','45817',NULL,'CY','39063','1955-08-12','F','U',':RET:2106-3','T','021','HLT','2217646','92036OH001001501','2014-01-01','2013-12-16 18:28:21','473.00',NULL,NULL,'777.87','304.87','R-OH002','OH0','777.87',NULL,0,'2013-12-25 21:45:03'),(15811,12656,'N','01','021','EC','A',NULL,NULL,'','0001576143','0001717549','','IL','1','Lam','Phuoc','Huu','','','34','435839741','11331 PARKWOOD CT N',0,'NEW ORLEANS','LA','70128','2913','CY','22071','1966-06-09','M','',NULL,'N','021','DEN','2453384','18575LA002000201','2014-02-01','2014-01-02 17:33:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-03 02:03:11'),(14425,11504,'Y','18','021','EC','A','','','AC','0000386576','0000386576','TX00001268253','31','1','BALDWIN','BRIDGETTE','ANNETTE','','','34','455231338','PO BOX 8052',0,'CORPUS CHRISTI','TX','78468',NULL,'CY','48355','1966-01-13','F','M',':RET:2054-5','N','021','DEN','1866945','33348TX002000101','2014-02-01','2013-12-27 17:09:10','0.00',NULL,NULL,'50.04','50.04','R-TX007','TX0','25.02',NULL,0,'2013-12-28 03:31:47'),(14205,11328,'Y','18','021','EC','A','','','AC','0000750139','0000750139','TX00000200611','IL','1','SHARDON','LISA','','','','34','057446201','5015 W HANOVER AVE',0,'DALLAS','TX','75209','3309','CY','48113','1954-10-02','F','M',NULL,'N','021','DEN','1788679','33348TX002000201','2014-02-01','2013-12-26 14:11:25','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-27 02:04:21'),(20344,16245,'Y','18','021','EC','A','','','AC','0001059502','0001059502','OH00001451713','IL','1','Wcislo','Brett','','','','34','296841477','4790 BEACH RD',0,'MEDINA','OH','44256','8462','CY','39103','1984-11-30','M','U',':RET:2106-3','N','021','HLT','3362502','52664OH151001305','2014-03-01','2014-01-28 14:45:44','137.00',NULL,NULL,'249.55','112.55','R-OH012','OH0','249.55',NULL,0,'2014-01-28 21:01:10'),(21191,16935,'Y','18','021','EC','A','','','AC','0000978200','0000978200','MS00002343027','IL','1','WARDEN','DONNA','','','','34','425027898','104 Hall St',0,'Wiggins','MS','39577',NULL,'CY','28131','1955-05-26','F','M',':RET:2106-3','N','021','DEN','2670323','46300MS002000101','2014-03-01','2014-02-03 14:16:50','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-03 21:00:48'),(25538,20259,'Y','18','021','EC','A','','','AC','0001139553','0001139553','OH00002301839','IL','1','Coston','Torrie','','','','34','298882856','6666 Dante Ave.',0,'Cincinnati','OH','45213',NULL,'CY','39061','1988-07-29','F','U',':RET:2054-5','N','021','DEN','2790154','99734OH005000301','2014-04-01','2014-02-23 03:04:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:00:09'),(27345,21653,'Y','18','021','EC','A','','','AC','0000037069','0000037069','OH00002433413','IL','1','Knight','Nichole','','','','34','283888410','12660 MILLERSBURG RD SW',0,'MASSILLON','OH','44647','9715','CY','39151','1987-11-10','F','U',':RET:2106-3','N','021','DEN','3657360','99734OH005000401','2014-04-01','2014-03-04 10:45:13','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-04 21:01:01'),(7545,5971,'Y','18','021','EC','A','','','AC','0000225825','0000225825','TX00001238985','IL','1','Dreyer','Keith','','','','34','449494723','401 Fleming St',0,'Wylie','TX','75098',NULL,'CY','48085','1972-02-13','M','M',':RET:2106-3','N','021','DEN','633415','33348TX002000201','2014-01-01','2013-12-15 18:03:48','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:33:02'),(19622,15641,'Y','18','021','EC','A','','','AC','0001250868','0001250868','OH00001706851','IL','1','Singh','Sarjeet','','','','34','225596577','4785 SARAH LN',0,'MEDINA','OH','44256','6350','CY','39103','1966-05-06','M','M',NULL,'N','021','DEN','1855703','99734OH005000401','2014-03-01','2014-01-22 19:09:44','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-23 21:00:04'),(19524,15561,'N','19','021','EC','A',NULL,NULL,'','0000689722','0000783266','','IL','1','Ventura','Michael','','','','34','275080878','7350 JAGUAR CT',0,'WAYNESVILLE','OH','45068','8210','CY','39165','2003-01-11','M','',':RET:2047-9','N','021','DEN','2134178','99734OH005000401','2014-03-01','2014-01-21 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:19'),(3650,2921,'Y','18','021','EC','A','','','AC','0000560527','0000560527','OH00000221991','IL','1','Campbell','Brenda','','','','34','591029666','1000 SPRINGBROOK DR',0,'CINCINNATI','OH','45224','1611','CY','39061','1958-04-08','F','U',':RET:2106-3','N','021','DEN','475432','99734OH005000401','2014-01-01','2013-12-12 18:48:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:30:37'),(19361,15432,'Y','18','021','EC','A','','','AC','0000519863','0000519863','OH00001697912','IL','1','Gillis','Aron','','','','34','300825125','852 GROVE LN',0,'ORRVILLE','OH','44667','9373','CY','39169','1985-04-10','F','U',':RET:2106-3','T','021','HLT','1712471','52664OH151001306','2014-03-01','2014-01-20 21:47:37','186.00',NULL,NULL,'278.77','92.77','R-OH014','OH0','278.77',NULL,1,'2014-01-22 03:22:31'),(27667,21884,'Y','18','021','EC','A','','','AC','0001213520','0001213520','OH00003595389','IL','1','Horn','Ashley','','','','34','290904739','11050 fancher rd',0,'Westerville','OH','43082',NULL,'CY','39041','1986-11-05','F','U',':RET:2106-3','N','021','DEN','3860436','99734OH005000401','2014-04-01','2014-03-05 16:50:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-05 21:30:31'),(14967,11962,'N','01','021','EC','A',NULL,NULL,'','0000451709','0000874155','','IL','1','YOUNG','WILLIE','','','','34','452130701','6504 COUNTY ROAD 35',0,'TYLER','TX','75706','8248','CY','48423','1956-02-03','M','',':RET:2054-5','N','021','DEN','1815748','33348TX002000201','2014-02-01','2013-12-30 11:38:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-01 12:00:40'),(191,160,'Y','18','021','EC','A','','','AC','0001139479','0001139479','OH00000363764','IL','1','YEAKLE','ANTHONY','E','','','34','302622458','530 WHITE STREET',0,'TOLEDO','OH','43605',NULL,'CY','39095','1960-04-22','M','U',':RET:2106-3','N','021','HLT','101737','92036OH006002601','2014-01-01','2013-12-04 19:36:28','18.00',NULL,NULL,'315.47','297.47','R-OH001','OH0','315.47',NULL,0,'2013-12-25 17:19:58'),(451,370,'N','19','021','EC','A',NULL,NULL,'','0000001005','0000642046','','IL','1','smith','breylan','m','','','34','294110754','2110 PLEASANT HILL RD',0,'MARION','OH','43302','9474','CY','39101','2006-02-18','M','',':RET:2106-3','N','021','DEN','630463','99734OH005000401','2014-01-01','2013-12-04 17:54:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:24'),(907,752,'Y','18','021','EC','A','','','AC','0000402430','0000402430','OH00001249342','IL','1','Ledsome','Melissa','','','','34','277963877','11246  crestline st sw',0,'beach city','OH','44608',NULL,'CY','39151','1993-01-29','F','U',':RET:2106-3','N','021','HLT','1566968','52664OH152001001','2014-01-01','2013-12-16 13:27:24','0.00',NULL,NULL,'77.86','77.86','R-OH015','OH0','77.86',NULL,0,'2013-12-25 18:08:27'),(26888,21310,'N','19','021','EC','A',NULL,NULL,'','0000493301','0001190122','','IL','1','Gaskill','Riley','','','','34','294111677','506 Collins Ave',0,'Van Wert','OH','45891',NULL,'CY','39161','2006-03-05','F','',':RET:2106-3','N','021','HLT','3516931','92036OH003001505','2014-04-01','2014-03-02 15:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-03-03 01:00:02'),(20665,16513,'Y','18','024','14','A','','','TE','0000132642','0000132642','','IL','1','Hawkins','Robin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-05','F','',NULL,NULL,NULL,'','3106001','','2014-01-30','2014-01-30 17:35:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-30 21:00:46'),(1408,1170,'Y','18','021','EC','A','','','AC','0001936883','0001936883','LA00000654802','IL','1','LOURIE','WALTER','','','','34','482667325','1500 W ESPLANADE AVE',0,'KENNER','LA','70065',NULL,'CY','22051','1957-10-27','M','U',':RET:2106-3','N','021','DEN','1420105','18575LA002000201','2014-01-01','2013-12-24 13:10:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:49'),(28536,22585,'Y','18','021','EC','A','','','AC','0000468176','0000468176','OH00003026778','IL','1','Salem','Scott','Joseph','','','34','302861947','6436 MAJESTIC DR',0,'NORTH RIDGEVILLE','OH','44039','2898','CY','39093','1986-12-23','M','U',':RET:2106-3','N','021','HLT','4188722','92036OH003000805','2014-04-01','2014-03-07 11:03:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,NULL,0,'2014-03-07 21:32:11'),(26248,20818,'Y','18','021','EC','A','','','AC','0000637603','0000637603','TX00002982748','IL','1','Mazzolla','Richard','Vincent','','Jr','34','145922807','477 LINDA VISTA LN',0,'ROBINSON','TX','76706','7218','CY','48309','1992-01-14','M','U',':RET:2106-3','N','021','DEN','2932784','33348TX002000201','2014-04-01','2014-02-27 13:42:48','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-02-28 06:31:07'),(23032,18362,'N','19','021','EC','A',NULL,NULL,'','0000538663','0000472000','','IL','1','TAPIA','NATALY','YAJIAGRA','','','34','634229652','10222 INWOOD SHADOWS ST',0,'HOUSTON','TX','77088','2227','CY','48201','1990-09-05','F','',NULL,'N','021','DEN','2930060','33348TX002000201','2014-03-01','2014-02-12 11:49:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-12 21:30:35'),(1779,1464,'N','01','021','EC','A',NULL,NULL,'','0000432762','0000954307','','IL','1','miller','amanda',NULL,NULL,NULL,NULL,NULL,'94 marion ave',0,'mogadore','OH','44260',NULL,'CY','39153','1981-07-29','F','',':RET:2106-3','N','021','DEN','2417846','99734OH005000301','2014-01-01','2013-12-24 15:00:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:16'),(3459,2781,'Y','18','021','EC','A','','','AC','0000011155','0000011155','OH00001061747','IL','1','Sargent','Matthew','','','','34','302502314','3653 Mozart Avenue',0,'Cincinnati','OH','45211',NULL,'CY','39061','1965-11-29','M','U',':RET:2106-3','N','021','DEN','2350379','99734OH005000401','2014-01-01','2013-12-22 01:52:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:19:42'),(21150,16900,'Y','18','021','EC','A','','','AC','0000622521','0000622521','OH00001891996','IL','1','Checco','Amanda','','','','34','291825128','360 RESOR AVE',0,'CINCINNATI','OH','45220','1616','CY','39061','1984-03-05','F','U',':RET:2106-3','N','021','DEN','2935575','99734OH005000401','2014-03-01','2014-02-02 20:32:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:27'),(15738,12589,'Y','18','021','EC','A','','','AC','0000688294','0000688294','OH00002003298','IL','1','Gallimore','Mark','','','','34','273509561','405 E MAIN ST',0,'CRIDERSVILLE','OH','45806','2407','CY','39011','1949-12-29','M','U',':RET:2106-3','N','021','DEN','2447670','99734OH005000301','2014-02-01','2014-01-02 17:40:46','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-03 02:00:43'),(13618,10858,'Y','18','024','14','A','','','TE','0000923323','0000923323','','IL','1','SEIBERT','FREDERIC',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-27','M','',NULL,NULL,NULL,'','1711557','','2013-12-23','2013-12-23 16:33:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:05:47'),(27911,22081,'Y','18','021','EC','A','','','AC','0000671027','0000671027','TX00002742010','31','1','Snow','Julie','','','','34','471721383','PO Box 13023',0,'Arlington','TX','76094',NULL,'CY','48439','1954-06-09','F','U',':RET:2106-3','N','021','DEN','3642783','33348TX002000201','2014-04-01','2014-03-05 21:14:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:15'),(21038,16809,'Y','18','021','EC','A','','','AC','0000181037','0000181037','OH00002417788','IL','1','Shelton','Kirk','','','','34','287806892','208 N PORTAGE PATH',0,'AKRON','OH','44303','1136','CY','39153','1968-04-02','M','U',':RET:2054-5','N','021','HLT','2037711','52664OH152000901','2014-03-01','2014-02-01 14:59:58','235.86',NULL,NULL,'235.86','0.00','R-OH012','OH0','235.86',NULL,0,'2014-02-01 19:00:48'),(300,248,'Y','18','021','EC','A','','','AC','0000289077','0000289077','TX00000923186','IL','1','Francis','Carolyn','','','','34','438902788','623 S WASHINGTON ST',0,'FREDERICKSBURG','TX','78624','4565','CY','48171','1953-08-01','F','U',':RET:2106-3','N','021','DEN','455458','33348TX002000201','2014-01-01','2013-11-13 17:31:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:30:48'),(5050,3999,'Y','18','021','EC','A','','','AC','0001181327','0001181327','TX00000070361','31','1','LaDue','Paula','R','','','34','484620067','P.O.BOX 211',0,'STRATFORD','TX','79084',NULL,'CY','48421','1951-05-12','F','M',':RET:2106-3','N','021','DEN','2384633','33348TX002000201','2014-01-01','2013-12-18 20:12:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:09'),(6692,5304,'Y','18','021','EC','A','','','AC','0000924758','0000924758','OH00000768679','IL','1','NELSON','DONNA','','','','34','270687140','1024 LONG AVE',0,'LORAIN','OH','44052','1958','CY','39093','1960-01-07','F','U',':RET:2106-3','T','021','DEN','304504','99734OH005000401','2014-01-01','2013-11-05 16:46:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:01:37'),(9725,7702,'N','01','021','EC','A',NULL,NULL,'','0000612954','0000659868','','IL','1','Fritsch','Natosha','','','','34','298800636','832 SUNCREEK CT',0,'CINCINNATI','OH','45238','4836','CY','39061','1980-04-18','F','',':RET:2106-3','N','021','DEN','89143','99734OH005000301','2014-01-01','2013-11-14 23:56:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:34'),(14171,11298,'Y','18','021','EC','A','','','AC','0000348936','0000348936','TX00001685809','IL','1','Dhungana','Obi','','','','34','616693675','1500 davis lane',0,'brownwood','TX','76801',NULL,'CY','48049','1981-02-02','M','M',':RET:2028-9','N','021','DEN','2301961','33348TX002000201','2014-02-01','2013-12-25 19:43:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:27'),(17426,13944,'Y','18','021','EC','A','','','AC','0000899588','0000899588','OH00002047444','IL','1','pakvasa','sonal','','','','34','272744471','240 GRAYLING DR',0,'FAIRLAWN','OH','44333','2865','CY','39153','1953-10-25','F','U',':RET:2029-7','N','021','HLT','1785156','52664OH151001306','2014-02-01','2014-01-10 14:20:49','515.00',NULL,NULL,'605.24','90.24','R-OH012','OH0','605.24',NULL,0,'2014-01-13 03:00:29'),(25768,20437,'N','19','021','EC','A',NULL,NULL,'','0001168054','0000727325','','IL','1','MASON','CARTER','','','','34','292139650','3800 Milner rd',0,'Newark','OH','43055',NULL,'CY','39089','2008-01-23','M','',NULL,'N','021','DEN','3409536','99734OH005000301','2014-04-01','2014-02-24 13:04:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:55'),(18681,14892,'Y','18','024','14','A','','','TE','0001251778','0001251778','','IL','1','DeWitt','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-10-11','M','',NULL,NULL,NULL,'','2273162','','2014-01-15','2014-01-15 20:11:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:20'),(18028,14400,'N','01','021','EC','A',NULL,NULL,'','0001237727','0000885616','','IL','1','Heiser','Kathleen','','','','34','282520892','5615 DRAKE RD',0,'PIQUA','OH','45356','8307','CY','39109','1951-10-08','F','',':RET:2106-3','N','021','DEN','2393483','99734OH005000301','2014-02-01','2014-01-14 14:03:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:07'),(13017,10375,'Y','18','021','EC','A','','','AC','0000889605','0000889605','OH00000829752','IL','1','Hermann','Michael','','','','34','339442450','137000 Sprecher Ave',0,'Clevland','OH','44135',NULL,'CY','39035','1952-06-10','M','M',NULL,'T','021','DEN','1438140','99734OH005000401','2014-01-01','2013-12-22 20:09:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:49:57'),(18211,14535,'Y','18','021','EC','A','','','AC','0001085637','0001085637','OH00002370712','IL','1','Elkins','Ramona','','','','34','296705115','2109 Pearl Street',0,'Middletown','OH','45044',NULL,'CY','39017','1962-09-19','F','M',':RET:2106-3','N','021','HLT','1530971','92036OH002001201','2014-02-01','2014-01-14 15:50:06','273.00',NULL,NULL,'462.36','189.36','R-OH004','OH0','462.36',NULL,0,'2014-01-15 02:08:10'),(5502,4368,'Y','18','021','EC','A','','','AC','0001119954','0001119954','OH00001207955','IL','1','Berner','Johnathan','','','','34','300920266','8300 US Highway 22',0,'Sabina','OH','45169',NULL,'CY','39027','1991-01-22','M','U',':RET:2106-3','T','021','HLT','1528890','92036OH001000601','2014-01-01','2013-12-19 16:37:45','0.00',NULL,NULL,'297.78','297.78','R-OH005','OH0','297.78',NULL,0,'2013-12-25 23:11:21'),(3608,2891,'Y','18','021','EC','A','','','AC','0000411109','0000411109','OH00000553208','IL','1','Meyer','Lee','','','','34','279460744','909 MEESE RD',0,'LOUISVILLE','OH','44641','2756','CY','39151','1954-02-18','M','R',':RET:2106-3','N','021','HLT','1876319','52664OH152000901','2014-01-01','2013-12-22 17:29:55','0.00',NULL,NULL,'425.18','425.18','R-OH015','OH0','425.18',NULL,0,'2013-12-25 21:23:24'),(15359,12284,'Y','18','021','EC','A','','','AC','0000955553','0000955553','OH00001372470','IL','1','italiano','cynthia','','','','34','292507934','8523 HITCHCOCK RD',0,'YOUNGSTOWN','OH','44512','6543','CY','39099','1951-04-10','F','U',':RET:2106-3','N','021','DEN','1724364','99734OH005000301','2014-02-01','2014-01-01 01:01:06','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,1,'2014-01-02 04:24:43'),(7011,5565,'Y','18','021','EC','A','','','AC','0001135509','0001135509','TX00001597107','IL','1','guerra','roy','','','','34','457272729','205 s 9th',0,'comanche','TX','76442',NULL,'CY','48093','1962-08-28','M','U',':RET:2106-3','N','021','DEN','1732760','33348TX002000201','2014-01-01','2013-12-24 19:49:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:32'),(27549,21791,'Y','18','021','EC','A','','','AC','0000171290','0000171290','OH00003627457','IL','1','Kitcko','Micheal','','','','34','274547166','11605 BRADY LN',0,'STRONGSVILLE','OH','44149','2853','CY','39035','1953-02-22','M','M',NULL,'N','021','DEN','3977521','99734OH005000401','2014-04-01','2014-03-04 15:10:46','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-03-04 21:30:10'),(26060,20667,'N','19','021','EC','A',NULL,NULL,'','0000528303','0001160466','','S1','1','Fletcher','Jerry','J','','','34','295985686','8135 Stringdown Rd',0,'Aberdeen','OH','45101',NULL,'CY','39015','1996-01-24','M','',NULL,'N','021','HLT','2693691','92036OH004000601','2014-04-01','2014-02-26 12:27:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-26 21:02:39'),(20610,16468,'Y','18','021','EC','A','','','AC','0000001066','0000001066','OH00001390530','IL','1','CEGELSKI','MARY','GERTRUDE','','','34','299469711','14111 SAINT JAMES AVE',0,'CLEVELAND','OH','44135','1465','CY','39035','1952-01-22','F','M',':RET:2106-3','N','021','DEN','3357296','99734OH005000401','2014-03-01','2014-01-30 16:36:18','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-30 21:00:17'),(3092,2485,'Y','18','021','EC','A','','','AC','0001081774','0001081774','OH00000490488','IL','1','COPSEY','RONDA','','','','34','285728244','3942 GREENWICH MILAN TOWNLINE RD',0,'GREENWICH','OH','44837','9437','CY','39077','1962-06-10','F','M',':RET:2106-3','T','021','HLT','1002607','92036OH005002706','2014-01-01','2013-12-06 07:49:33','854.00',NULL,NULL,'989.59','135.59','R-OH006','OH0','418.23',NULL,0,'2013-12-25 20:20:02'),(3788,3035,'Y','18','021','EC','A','','','AC','0000195113','0000195113','OH00000764951','IL','1','Spencer','Linda','M','','','34','292509830','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1951-01-29','F','M',':RET:2054-5','N','021','DEN','1231216','99734OH005000301','2014-01-01','2013-12-13 09:53:52','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:34:09'),(5747,4562,'Y','18','021','EC','A','','','AC','0001941234','0001941234','LA00000814597','IL','1','Korman','Alexis','','','','34','625245872','200 Carondelet Street',0,'New Orleans','LA','70130',NULL,'CY','22071','1981-11-20','F','U',':RET:2106-3','N','021','DEN','1410599','18575LA002000201','2014-01-01','2013-12-24 01:04:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:46:05'),(681,560,'Y','18','021','EC','A','','','AC','0000283243','0000283243','OH00000820480','IL','1','KREPINA','WANETA','ETHEL','','','34','279507018','323 MAX ROAD',0,'LODI','OH','44254',NULL,'CY','39103','1951-02-13','F','U',':RET:2106-3','N','021','DEN','1992084','99734OH005000301','2014-01-01','2013-12-16 10:56:28','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:02:24'),(804,665,'Y','18','021','EC','A','','','AC','0000118031','0000118031','TX00000296273','IL','1','Murphy','Oliver','','','','34','449512358','4213 MEADOWBROOK DR',0,'BRYAN','TX','77802','3516','CY','48041','1953-07-13','M','M',':RET:2106-3','N','021','DEN','1872260','33348TX002000201','2014-01-01','2013-12-16 18:20:29','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2013-12-25 18:05:38'),(1523,1269,'Y','18','024','14','A','','','TE','0000225973','0000225973','','IL','1','warner','robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-25','M','',NULL,NULL,NULL,'','525723','','2013-12-24','2013-12-24 15:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:49:49'),(7814,6191,'Y','18','021','EC','A','','','AC','0000263989','0000263989','TX00000980191','IL','1','Schronk','Dianna','Sue','','','34','452888463','502 W BAKER ST',0,'HAMILTON','TX','76531','2808','CY','48193','1950-02-08','F','U',':RET:2106-3','N','021','DEN','1392311','33348TX002000201','2014-01-01','2013-12-20 17:53:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:04:02'),(7729,6121,'N','01','021','EC','A',NULL,NULL,'','0000765967','0000626723','','IL','1','Blocher','Kim','','','','34','274484241','21 Grouse Dr',0,'Amelia','OH','45102',NULL,'CY','39025','1957-03-27','F','',':RET:2106-3','N','021','DEN','1404174','99734OH005000401','2014-01-01','2013-12-20 14:38:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:57'),(2931,2360,'N','01','021','EC','A',NULL,NULL,'','0000274757','0000984812','','IL','1','Perry','James','','','','34','236026414','15293 CALABOONE RD',0,'DOYLESTOWN','OH','44230','9204','CY','39169','1964-06-29','M','',':RET:2106-3','N','021','DEN','758404','99734OH005000401','2014-01-01','2013-12-05 20:48:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:16:00'),(3259,2626,'Y','18','021','EC','A','','','AC','0000097371','0000097371','TX00000562484','31','1','Kotschwar','Shellee','','','','34','507861158','P.O. Box 62',0,'Gainesville','TX','76241',NULL,'CY','48097','1956-06-05','F','U',':RET:2106-3','T','021','DEN','507274','33348TX002000201','2014-01-01','2013-11-27 18:17:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:46:48'),(17671,14121,'Y','18','024','14','A','','','TE','0001203573','0001203573','','IL','1','Gafford','Gaines',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-07-08','M','',NULL,NULL,NULL,'','1541519','','2014-01-13','2014-01-13 10:53:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-14 01:32:49'),(16009,12813,'Y','18','021','EC','A','','','AC','0001102515','0001102515','TX00000019395','IL','1','Munoz','Perla','','','','34','455118237','708 Oblate Ave.',0,'Mission','TX','78572',NULL,'CY','48215','1955-04-03','F','U',NULL,'N','021','DEN','1402051','33348TX002000201','2014-02-01','2014-01-03 17:49:07','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-04 02:01:45'),(5474,4346,'N','19','021','EC','A',NULL,NULL,'','0001046832','0001077722','','IL','1','Arif','Waqar','','','','34','592060244','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','1990-12-09','M','',':RET:2028-9','N','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99',NULL,0,'2013-12-25 23:10:41'),(23699,18872,'N','19','021','EC','A',NULL,NULL,'','0000616874','0000387331','','IL','1','MCCARTHY','JACOB','','','','34','279048714','3386 PALMHILL LN',0,'CINCINNATI','OH','45239','7162','CY','39061','1999-05-02','M','',NULL,'N','021','DEN','3576493','99734OH005000401','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:41'),(24702,19611,'Y','18','021','EC','A','','','AC','0001064763','0001064763','OH00002808958','IL','1','george','joe','','','','34','302529474','4456 matson ave',0,'cinn','OH','45236',NULL,'CY','39061','1952-09-16','M','U',':RET:2106-3','N','021','DEN','3172968','99734OH005000401','2014-04-01','2014-02-18 21:38:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:34:23'),(26799,21237,'N','01','021','EC','A',NULL,NULL,'','0000862497','0000515882','','IL','1','Gonzalez-Hernandez','Eusebio','','','','34','276067132','336 N BERLIN AVE',0,'TOLEDO','OH','43605','1508','CY','39095','1971-08-14','M','',NULL,'N','021','HLT','2734646','92036OH003002605','2014-04-01','2014-03-01 16:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','269.82',NULL,0,'2014-03-01 21:00:22'),(28018,22172,'Y','18','021','EC','A','','','AC','0001046910','0001046910','OH00002960545','IL','1','Miller','Andrew','','','','34','291823390','650 DAVIDS ST',0,'MARION','OH','43302','6132','CY','39101','1984-12-12','M','U',':RET:2106-3','T','021','DEN','3428368','99734OH005000401','2014-04-01','2014-03-06 13:54:12','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2014-03-06 21:01:19'),(5486,4355,'Y','18','021','EC','A','','','AC','0001161533','0001161533','OH00000514490','IL','1','Wright','Randy','','','','34','299663400','810 s. 7th. St.',0,'Greenfield','OH','45123',NULL,'CY','39071','1961-02-16','M','M',':RET:2106-3','N','021','HLT','1531508','92036OH005000604','2014-01-01','2013-12-19 18:24:32','713.00',NULL,NULL,'922.65','209.65','R-OH005','OH0','419.03',NULL,0,'2013-12-25 23:10:56'),(24442,19415,'Y','18','021','EC','A','','','AC','0001040897','0001040897','OH00002165737','IL','1','SNYDER','SUSAN','','','','34','278528830','27 COMO ST',0,'STRUTHERS','OH','44471','1602','CY','39099','1950-12-21','F','M',NULL,'N','021','HLT','2633971','92036OH002003201','2014-04-01','2014-02-18 10:00:43','1054.00',NULL,NULL,'1663.73','609.73','R-OH013','OH0','825.16',NULL,0,'2014-02-18 22:01:20'),(24364,19350,'N','19','021','EC','A',NULL,NULL,'','0002008031','0001896721','','IL','1','MIDENCE','MARK','','','','34','439719393','29 TRAMINER DR',0,'KENNER','LA','70065',NULL,'CY','22051','1987-07-21','M','',NULL,'N','021','DEN','3745364','18575LA002000201','2014-04-01','2014-02-18 11:02:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-18 22:00:33'),(21152,16902,'Y','18','021','EC','A','','','AC','0000253085','0000253085','OH00002229958','IL','1','Huang','Decheng','','','','34','230675438','526 BEAVERBROOK DR',0,'COLUMBUS','OH','43230','4382','CY','39049','1970-04-19','M','M',':RET:2034-7','N','021','DEN','2929842','99734OH005000401','2014-03-01','2014-02-02 22:17:58','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-03 21:00:28'),(13562,10815,'N','01','021','EC','A',NULL,NULL,'','0001743826','0001582481','','IL','1','Qasem','Amna','','','','34','859392932','12625 Coursey Blvd',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1967-12-18','F','',':RET:2106-3','N','021','DEN','2357288','18575LA002000201','2014-01-01','2013-12-23 15:51:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:23'),(20446,16330,'N','01','021','EC','A',NULL,NULL,'','0000433197','0000763136','','IL','1','Hughes','Zachary','','','','34','426674435','1047 WEST ST',0,'WESSON','MS','39191','7714','CY','28029','1987-12-03','M','',':RET:2106-3','N','021','DEN','2790881','46300MS002000101','2014-03-01','2014-01-29 10:49:46',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-29 21:00:42'),(4913,3897,'Y','18','021','EC','A','','','AC','0000130989','0000130989','MS00000773755','IL','1','Williams','Sabrina','N','','','34','325845210','7117 TUDOR LN',0,'HORN LAKE','MS','38637','1273','CY','28033','1983-12-04','F','U',':RET:2106-3','N','021','DEN','94198','46300MS002000101','2014-01-01','2013-10-26 00:02:12','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 22:32:09'),(9354,7414,'Y','18','021','EC','A','','','AC','0001462790','0001462790','LA00001280525','IL','1','newman','janice','','','','34','437849490','127 PETITE ST',0,'LAKE CHARLES','LA','70605','6635','CY','22019','1951-10-01','F','U',':RET:2106-3','N','021','DEN','2338430','18575LA002000201','2014-01-01','2013-12-20 23:49:48','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 04:31:20'),(1381,1146,'Y','18','021','EC','A','','','AC','0001612794','0001612794','LA00000055572','IL','1','Bernard','Deanna','','','','34','436965267','2170 RUE PICKNEY',0,'MANDEVILLE','LA','70448','2388','CY','22103','1957-12-03','F','U',':RET:2106-3','N','021','DEN','2031596','18575LA002000201','2014-01-01','2013-12-24 09:17:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:06'),(25697,20388,'Y','18','021','EC','A','','','AC','0000885106','0000885106','TX00002465697','IL','1','PATEL','RASIK','','','','34','056768397','1213 E US HIGHWAY 80',0,'MINEOLA','TX','75773','5067','CY','48499','1969-10-12','M','M',NULL,'N','021','DEN','3280778','33348TX002000201','2014-04-01','2014-02-24 09:30:37','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:17'),(15474,12379,'N','01','021','EC','A',NULL,NULL,'','0000910534','0000385881','','IL','1','DEVORE','ABBY','M','','','34','269882832','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1987-06-19','F','',NULL,'N','021','DEN','1454396','99734OH005000401','2014-02-01','2013-12-30 19:18:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:28:58'),(6362,5044,'Y','18','021','EC','A','','','AC','0000957886','0000957886','OH00000808800','IL','1','Brown','Patricia','','','','34','295541465','911 CHESTNUT ST',0,'DRESDEN','OH','43821','9685','CY','39119','1956-02-10','M','M',':RET:2106-3','N','021','DEN','624605','99734OH005000301','2014-01-01','2013-12-10 18:26:16','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 00:47:23'),(14066,11208,'Y','18','021','EC','A','','','AC','0000703789','0000703789','OH00000069468','IL','1','Koch','Mary','','','','34','277583977','2005 STILL WATER LN',0,'MILFORD','OH','45150','4510','CY','39025','1955-08-07','F','U',':RET:2106-3','T','021','DEN','2214734','99734OH005000401','2014-02-01','2013-12-26 08:28:52','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-27 02:00:42'),(25115,19923,'Y','18','021','EC','A','','','AC','0001078769','0001078769','MS00002423593','IL','1','McCain','Zachary','','','','34','415639064','1111 COLLEGE ST',0,'CLEVELAND','MS','38732','3112','CY','28011','1987-06-19','M','M',':RET:2106-3','N','021','DEN','3279774','46300MS002000201','2014-04-01','2014-02-21 16:03:01','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85','CIC',0,'2014-02-21 21:30:18'),(13472,10745,'Y','18','021','EC','A','','','AC','0001240556','0001240556','OH00000066772','IL','1','LEE','KRISTEN','L','','','34','327742896','8330 MEETING ST',0,'WEST CHESTER','OH','45069','5164','CY','39017','1984-01-10','F','M',':RET:2106-3','N','021','DEN','1727612','99734OH005000301','2014-01-01','2013-12-23 16:30:37','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:02:03'),(28838,22821,'Y','18','021','EC','A','','','AC','0000830701','0000830701','OH00003360122','IL','1','Tolbert','Charles','','','','34','289505025','1029 S 2ND ST',0,'HAMILTON','OH','45011','3133','CY','39017','1951-03-29','M','M',NULL,'N','021','HLT','3587781','92036OH006001201','2014-04-01','2014-03-09 14:08:18','876.00',NULL,NULL,'936.34','60.34','R-OH004','OH0','502.56',NULL,0,'2014-03-09 21:01:11'),(19950,15913,'Y','18','021','EC','A','','','AC','0001642179','0001642179','LA00001901813','IL','1','WILLIAMS','JEROME','','','','34','439414256','1430 ENTERPRISE RD',0,'ALEXANDRIA','LA','71303','4416','CY','22079','1964-10-26','M','U',NULL,'N','021','DEN','1844395','18575LA002000201','2014-03-01','2014-01-24 21:31:05','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-25 19:00:03'),(5228,4151,'Y','18','024','14','A','','','TE','0001066946','0001066946','','IL','1','Hanna','Murad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-01-01','M','',NULL,NULL,NULL,'','44965','','2013-12-19','2013-12-19 18:33:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:43'),(1956,1595,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001101678','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','1002439','33348TX002000101','2014-01-01','2013-11-19 22:58:23','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:06'),(2412,1969,'Y','18','021','EC','A','','','AC','0001022758','0001022758','OH00001160914','IL','1','lomack','mark','','','','34','246196058','3428 ferncroft dr',0,'cincinnati','OH','45211',NULL,'CY','39061','1965-02-20','M','M',':RET:2054-5','N','021','DEN','713099','99734OH005000401','2014-01-01','2013-12-09 15:40:23','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:46'),(13467,10741,'Y','18','021','EC','A','','','AC','0000521947','0000521947','OH00000811853','IL','1','Albers','Maura','Alyse','','','34','278909528','6967 Thorndike Road',0,'Mariemont','OH','45227',NULL,'CY','39061','1980-02-08','F','U',':RET:2106-3','N','021','DEN','2137293','99734OH005000301','2014-01-01','2013-12-23 16:06:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:55'),(13816,11028,'Y','18','021','EC','A','','','AC','0000120080','0000120080','OH00000425925','IL','1','Dasinger','Michael','','','','34','300589772','2234 W 100TH ST',0,'CLEVELAND','OH','44102','3609','CY','39035','1961-04-12','M','U',':RET:2106-3','N','021','HLT','2274891','92036OH005000806','2014-01-01','2013-12-22 19:01:22','322.00',NULL,NULL,'456.37','134.37','R-OH011','OH0','456.37',NULL,0,'2013-12-26 13:11:45'),(15594,12478,'Y','18','024','14','A','','','TE','0000516871','0000516871','','IL','1','ARLEDGE','RANDALL','PATRICK',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-30','M','',NULL,NULL,NULL,'','131264','','2013-12-31','2013-12-31 12:04:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:28'),(17406,13930,'Y','18','021','EC','A','','','AC','0000837423','0000837423','TX00002184361','IL','1','PORTILLO','OLGA','MARINA','','','34','461955407','400 LINDA LN',0,'WEBSTER','TX','77598','5040','CY','48201','1959-02-01','F','U',NULL,'N','021','DEN','1827883','33348TX002000101','2014-02-01','2014-01-10 09:46:12','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-13 03:00:19'),(18649,14867,'N','01','021','EC','A',NULL,NULL,'','0000861937','0001053527','','IL','1','MARSH','CHARLENE','ESPINOZA','','','34','450333378','9014 McGallion Rd.',0,'Houston','TX','77022',NULL,'CY','48201','1973-07-11','F','',NULL,'N','021','DEN','2022939','33348TX002000201','2014-03-01','2014-01-16 09:24:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-17 03:35:09'),(19743,15735,'Y','18','021','EC','A','','','AC','0000808687','0000808687','OH00001991431','IL','1','Kilby','Brandon','','','','34','275889977','7299 SILVER CREST DR',0,'CINCINNATI','OH','45236','3622','CY','39061','1981-01-26','M','U',':RET:2054-5','N','021','HLT','2885766','92036OH005001205','2014-03-01','2014-01-23 15:48:05','120.00',NULL,NULL,'257.16','137.16','R-OH004','OH0','257.16',NULL,0,'2014-01-23 21:01:13'),(20431,16318,'Y','18','024','14','A','','','TE','0001139501','0001139501','','IL','1','Wilson','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-19','F','',NULL,NULL,NULL,'','2407701','','2014-01-29','2014-01-29 13:03:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:35'),(22843,18226,'Y','18','021','EC','A','','','AC','0000479892','0000479892','OH00001846904','IL','1','Beaulieu','Amanda','J','','','34','277783881','2732 W ELM ST',0,'LIMA','OH','45805','2509','CY','39003','1980-03-22','F','U',':RET:2106-3','N','021','HLT','3482004','92036OH004001501','2014-03-01','2014-02-11 12:00:48','0.00',NULL,NULL,'212.00','212.00','R-OH002','OH0','212.00',NULL,0,'2014-02-11 21:02:15'),(23576,18783,'Y','18','021','EC','A','','','AC','0000246498','0000246498','OH00002777667','IL','1','Hartten','Julie','','','','34','271700677','145 S SAINT CLAIR ST',0,'TOLEDO','OH','43604','9003','CY','39095','1969-11-14','F','U',':RET:2106-3','N','021','HLT','2716764','92036OH003002604','2014-03-01','2014-02-13 17:20:18','133.00',NULL,NULL,'284.48','151.48','R-OH001','OH0','284.48',NULL,0,'2014-02-13 22:02:54'),(28843,22824,'Y','18','024','14','A','','','TE','0000432825','0000432825','','IL','1','Messenger','Debra','Louise',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-03-25','F','',NULL,NULL,NULL,'','3616292','','2014-03-08','2014-03-09 13:14:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-09 21:01:13'),(7866,6225,'Y','18','021','EC','A','','','AC','0001059467','0001059467','OH00000728174','IL','1','henderson','amber','','','','34','285881843','2466 QUAIL MEADOW DR',0,'GROVE CITY','OH','43123','8728','CY','39049','1985-05-09','F','U',':RET:2106-3','N','021','DEN','1916929','99734OH005000301','2014-01-01','2013-12-20 15:40:20','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:05:06'),(16068,12868,'Y','18','021','EC','A','','','AC','0000783243','0000783243','OH00000324862','IL','1','HEY','ALICE','','','','34','404159828','1462 DELYNN DR',0,'DAYTON','OH','45459','5417','CY','39113','1954-11-24','F','M',':RET:2028-9','N','021','DEN','1955689','99734OH005000401','2014-02-01','2014-01-03 11:15:31','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:03:45'),(7140,5664,'N','01','021','EC','A',NULL,NULL,'','0000083660','0000547914','','IL','1','Cage','Donald','','','','34','461478288','10907 RADFORD LN',0,'HOUSTON','TX','77099','4724','CY','48201','1964-02-08','M','',':RET:2054-5','N','021','DEN','1586864','33348TX002000101','2014-01-01','2013-12-24 19:50:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 01:51:51'),(14146,11275,'Y','18','024','14','A','','','TE','0002036740','0002036740','','IL','1','Kandous','Jehad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-05-03','M','',NULL,NULL,NULL,'','1974517','','2013-12-26','2013-12-26 12:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:46'),(13340,10652,'Y','18','021','EC','A','','','AC','0000444500','0000444500','TX00000754497','IL','1','Speed','Raylene','R','','','34','449822792','11623 W. Bellfort St.',0,'Houston','TX','77099',NULL,'CY','48201','1957-09-27','M','U',':RET:2106-3','N','021','DEN','1568564','33348TX002000201','2014-01-01','2013-12-23 18:17:28','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:53'),(5768,4582,'Y','18','021','EC','A','','','AC','0000105370','0000105370','OH00001273684','IL','1','Williams','Kareema','','','','34','296861429','4713 Country Lane',0,'Cleveland','OH','44128',NULL,'CY','39035','1987-09-08','F','U',':RET:2054-5','N','021','DEN','2118526','99734OH005000401','2014-01-01','2013-12-23 22:29:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:46:42'),(2860,2310,'Y','18','021','EC','A','','','AC','0000555333','0000555333','OH00000220381','IL','1','Donohoe','Ashley','','','','34','292882815','5588 GARRETT DR',0,'MILFORD','OH','45150','2864','CY','39025','1987-10-04','F','U',':RET:2106-3','N','021','DEN','831751','99734OH005000401','2014-01-01','2013-11-01 21:45:34','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 20:01:36'),(3362,2694,'Y','18','021','EC','A','','','AC','0000889671','0000889671','TX00000743922','IL','1','rodriguez','pablo','','','','34','456928485','1105 DURHAM AVE',0,'BROWNWOOD','TX','76801','3328','CY','48049','1949-11-13','M','M',NULL,'N','021','DEN','1544786','33348TX002000201','2014-01-01','2013-12-22 13:35:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:00'),(20075,16014,'Y','18','021','EC','A','','','AC','0000909977','0000909977','TX00002416486','IL','1','TIJERINA','MAURO','','','','34','454755821','2800 SANTA BARBARA DR',0,'ALAMO','TX','78516','9405','CY','48215','1969-05-10','M','M',':RET:2106-3','N','021','DEN','3273936','33348TX002000201','2014-03-01','2014-01-27 16:21:47','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-27 21:00:20'),(21458,17149,'Y','18','021','EC','A','','','AC','0000736551','0000736551','OH00001658423','IL','1','Lommler','Kathryn','','','','34','299584951','3654 Winchell Road',0,'Mantua','OH','44255',NULL,'CY','39133','1956-06-23','F','U',':RET:2106-3','T','021','HLT','3462974','52664OH151001306','2014-03-01','2014-02-04 15:05:15','463.00',NULL,NULL,'624.99','161.99','R-OH012','OH0','624.99',NULL,0,'2014-02-04 21:01:32'),(21749,17368,'Y','18','021','EC','A','','','AC','0001209743','0001209743','TX00001778681','IL','1','Belcher','Crystal','','','','34','442840805','1659 MCGREGOR AVE',0,'WICHITA FALLS','TX','76301','5720','CY','48485','1982-11-26','F','M',':RET:1002-5^:RET:2039-6^:RET:2106-3','N','021','DEN','3166258','33348TX002000201','2014-03-01','2014-02-05 19:31:34','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-06 21:00:19'),(22488,17954,'Y','18','021','EC','A','','','AC','0000976762','0000976762','OH00002585803','IL','1','mcowen','robert','','','','34','293680835','112 E MAIN ST',0,'BEAVERDAM','OH','45808','9723','CY','39003','1959-10-07','M','M',NULL,'N','021','DEN','3647458','99734OH005000301','2014-03-01','2014-02-10 12:25:21','0.00',NULL,NULL,'87.78','87.78','R-OH002','OH0','0.00',NULL,0,'2014-02-10 21:31:06'),(22586,18039,'Y','18','021','EC','A','','','AC','0000836669','0000836669','OH00001930452','IL','1','THOBE','MARILYN','','','','34','307703849','522 W LIVINGSTON ST',0,'CELINA','OH','45822','1637','CY','39107','1963-02-01','F','U',':RET:2106-3','N','021','HLT','3100458','92036OH006001501','2014-03-01','2014-02-10 12:15:50','150.00',NULL,NULL,'325.53','175.53','R-OH002','OH0','325.53',NULL,0,'2014-02-10 21:32:06'),(22989,18328,'Y','18','021','EC','A','','','AC','0000227088','0000227088','OH00002778852','IL','1','Budzinski','Tiffany','','','','34','291900309','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1980-10-22','F','M',':RET:2047-9','N','021','DEN','2698252','99734OH005000301','2014-03-01','2014-02-12 11:08:07','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2014-02-12 21:30:13'),(25642,20342,'Y','18','021','EC','A','','','AC','0000055977','0000055977','OH00003108465','IL','1','Blue','Ronald','','','','34','270504759','18592 EDWARDS RD',0,'DOYLESTOWN','OH','44230','9546','CY','39169','1951-03-20','M','M',NULL,'N','021','HLT','3069700','52664OH151001301','2014-04-01','2014-02-21 18:38:24','843.00',NULL,NULL,'1284.97','441.97','R-OH014','OH0','658.32',NULL,0,'2014-02-26 08:30:32'),(25660,20358,'Y','18','021','EC','A','','','AC','0001084198','0001084198','OH00002492002','IL','1','SINGH','GURPREET','','','','34','621684392','374 PRESERVE LN',0,'MACEDONIA','OH','44056','1793','CY','39153','1976-06-29','M','M',':RET:2029-7','N','021','HLT','3179987','52664OH152000901','2014-04-01','2014-02-22 12:00:09','295.00',NULL,NULL,'403.13','108.13','R-OH012','OH0','202.22',NULL,0,'2014-02-26 08:30:44'),(28030,22183,'Y','18','021','EC','A','','','AC','0001069382','0001069382','OH00003609854','IL','1','warner','vicki','','','','34','275505854','1971 BEACON ST',0,'WASHINGTON COURT HOUSE','OH','43160','3706','CY','39047','1949-10-01','F','U',NULL,'N','021','DEN','2876031','99734OH005000401','2014-04-01','2014-03-06 16:52:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:27'),(264,218,'Y','18','021','EC','A','','','AC','0000907991','0000907991','OH00000287118','IL','1','Zoblisien','Jennifer','L','','','34','548475783','7366 West B1',0,'Boardman','OH','44512',NULL,'CY','39099','1972-02-27','F','M',':RET:2106-3','N','021','HLT','281783','92036OH003003201','2014-01-01','2013-12-05 14:42:12','0.00',NULL,NULL,'329.12','329.12','R-OH013','OH0','329.12',NULL,0,'2013-12-25 17:21:54'),(15772,12621,'Y','18','021','EC','A','','','AC','0000752570','0000752570','TX00000698113','IL','1','MORALES','JESUS','ALFREDO','','','34','459152200','309 E GOLF COURSE RD',0,'MIDLAND','TX','79701','2346','CY','48329','1953-06-20','M','M',NULL,'T','021','DEN','1561730','33348TX002000201','2014-02-01','2014-01-02 13:57:53','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-03 02:01:51'),(3112,2500,'Y','18','021','EC','A','','','AC','0000637200','0000637200','TX00001146669','IL','1','maley','emily','','','','34','455915121','4210 Paramount Blvd',0,'Amarillo','TX','79109',NULL,'CY','48381','1977-11-27','F','U',NULL,'N','021','DEN','1197953','33348TX002000101','2014-01-01','2013-10-12 18:25:24','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2013-12-25 20:30:03'),(2343,1908,'Y','18','021','EC','A','','','AC','0000188333','0000188333','TX00000385105','IL','1','VALDEZ','ISMERAI','ATAI','','','34','640302042','509 PRADA MACHIN DR',0,'LAREDO','TX','78046',NULL,'CY','48479','1992-06-24','F','U',NULL,'N','021','DEN','997901','33348TX002000201','2014-01-01','2013-12-09 13:47:25','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 19:32:01'),(2116,1736,'Y','18','021','EC','A','','','AC','0000939750','0000939750','OH00000503218','IL','1','KING','MARY','L','','','34','289628834','8087 WEST CHESTER ROAD',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','1958-01-04','F','U',':RET:2106-3','N','021','DEN','154259','99734OH005000401','2014-01-01','2013-12-10 12:58:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:36'),(22734,18152,'Y','18','021','EC','A','','','AC','0001880829','0001880829','LA00002600965','IL','1','nguyen','long','','','','34','480174498','29795 hwy 23',0,'port sulpher','LA','70083',NULL,'CY','22075','1953-11-21','M','M',':RET:2047-9','N','021','DEN','2828295','18575LA002000201','2014-03-01','2014-02-11 15:53:11','0.00',NULL,NULL,'67.44','67.44','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:17'),(23684,18860,'Y','18','021','EC','A','','','AC','0000392408','0000392408','OH00002776505','IL','1','Fusco','Louis','J','','','34','117504766','889 COMMERCIAL PKWY',0,'DOVER','OH','44622','3152','CY','39157','1956-01-20','M','M',':RET:2106-3','N','021','DEN','2982841','99734OH005000401','2014-03-01','2014-02-13 19:06:07','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-14 21:30:33'),(24494,19459,'Y','18','021','EC','A','','','AC','0000014247','0000014247','TX00002251050','IL','1','Ouchley','Laura','','','','34','437674927','5200 Meadowcreek Drive',0,'Dallas','TX','75248',NULL,'CY','48113','1984-08-30','F','U',NULL,'N','021','DEN','3395426','33348TX002000201','2014-04-01','2014-02-18 18:56:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:46:11'),(28933,22897,'Y','18','021','EC','A','','','AC','0000843408','0000843408','OH00003201044','IL','1','novel','julianna','','','','34','275681049','29875 SCHWARTZ RD',0,'WESTLAKE','OH','44145','3828','CY','39035','1975-04-10','F','M',':RET:2106-3','T','021','DEN','3830152','99734OH005000301','2014-04-01','2014-03-10 14:29:18','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:00:38'),(25491,20221,'Y','18','021','EC','A','','','AC','0000269161','0000269161','MS00002689299','IL','1','James','Harriet','','','','34','153622735','418 EATONVILLE RD',0,'HATTIESBURG','MS','39401','9786','CY','28035','1961-11-23','F','U',':RET:2054-5','T','021','DEN','2934910','46300MS002000201','2014-04-01','2014-02-25 13:31:50','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-25 21:31:47'),(23288,18565,'N','01','021','EC','A',NULL,NULL,'','0000367425','0000268939','','IL','1','Brown','Gabrielle','Maria','','','34','277846720','121 South Main Street',0,'New Lexington','OH','43764',NULL,'CY','39127','1985-04-19','F','',':RET:2106-3','N','021','DEN','3584977','99734OH005000301','2014-03-01','2014-02-12 19:24:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:05'),(16705,13370,'Y','18','021','EC','A','','','AC','0001204834','0001204834','TX00001625429','IL','1','WILLIAMS','EMILY','','','','34','462811858','844 N AVENUE I',0,'ODESSA','TX','79763',NULL,'CY','48135','1985-02-04','F','M',':RET:2106-3','N','021','DEN','1499361','33348TX002000201','2014-02-01','2014-01-06 20:39:20','0.00',NULL,NULL,'29.22','29.22','R-TX017','TX0','14.61',NULL,0,'2014-01-08 18:24:40'),(5355,4247,'Y','18','021','EC','A','','','AC','0000155764','0000155764','OH00001019806','IL','1','weygandt','jennifer','','','','34','273802726','1489 2nd street',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1981-02-26','F','U',':RET:2106-3','N','021','HLT','1401409','52664OH152000901','2014-01-01','2013-12-19 16:14:46','89.00',NULL,NULL,'193.23','104.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 23:07:43'),(2220,1828,'Y','18','021','EC','A','','','AC','0000835443','0000835443','OH00001122146','IL','1','Brinkman','Kathleen','','','','34','283503804','137 N Sherman Street',0,'Ottawa','OH','45875',NULL,'CY','39137','1950-10-21','F','U',':RET:2106-3','N','021','HLT','898696','92036OH006001501','2014-01-01','2013-12-10 13:26:43','511.47',NULL,NULL,'515.24','3.77','R-OH002','OH0','515.24',NULL,0,'2013-12-25 19:20:30'),(19513,15553,'Y','18','021','EC','A','','','AC','0000063734','0000063734','OH00002156255','IL','1','jodrey','tina','','','','34','281808150','6634 CHESTNUT ST',0,'CINCINNATI','OH','45227','3605','CY','39061','1968-08-05','F','R',':RET:2106-3','N','021','DEN','2759410','99734OH005000401','2014-03-01','2014-01-21 19:48:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:02:15'),(18475,14738,'N','01','021','EC','A',NULL,NULL,'','0000524512','0000318430','','IL','1','Schaefer','Debra','','','','34','280468806','46 SELDEN AVE',0,'AKRON','OH','44301','2849','CY','39153','1954-06-20','F','',NULL,'N','021','HLT','2496245','52664OH151001304','2014-02-01','2014-01-14 20:39:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2014-01-16 08:46:19'),(16546,13236,'Y','18','021','EC','A','','','AC','0000111908','0000111908','OH00001921817','IL','1','Jones','Susan','Lyn','','','34','294482483','34 Forest Ave SE',0,'Massillon','OH','44646',NULL,'CY','39151','1950-09-27','F','U',':RET:2106-3','N','021','DEN','2388073','99734OH005000401','2014-02-01','2014-01-05 10:10:01','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,1,'2014-01-07 10:22:32'),(9135,7245,'N','01','021','EC','A',NULL,NULL,'','0000769978','0000837684','','IL','1','Bishoff','Faith','','','','34','392981981','919 POPPY DR',0,'WAPAKONETA','OH','45895','1042','CY','39011','1976-06-28','F','',':RET:2106-3','N','021','HLT','2052685','92036OH003001505','2014-01-01','2013-12-17 20:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','284.53',NULL,0,'2013-12-26 04:08:04'),(6064,4805,'Y','18','021','EC','A','','','AC','0000436575','0000436575','OH00000850295','IL','1','Lindhal','Curtis','A','','','34','274485986','1522 E MORGAN RD',0,'JEFFERSON','OH','44047','8122','CY','39007','1951-12-03','M','M',':RET:2106-3','N','021','DEN','494574','99734OH005000401','2014-01-01','2013-12-01 12:11:17','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:02:01'),(589,484,'Y','18','021','EC','A','','','AC','0000827128','0000827128','OH00000835725','IL','1','Baumgardner','Michelle','','','','34','280842136','4948 EAST RD',0,'LIMA','OH','45807','1415','CY','39003','1974-09-26','F','U',':RET:2106-3','N','021','HLT','840895','92036OH001001501','2014-01-01','2013-12-04 17:15:14','139.00',NULL,NULL,'335.02','196.02','R-OH002','OH0','335.02',NULL,0,'2013-12-25 17:51:08'),(6562,5202,'Y','18','021','EC','A','','','AC','0000590762','0000590762','TX00000205106','IL','1','Morales','Richard',NULL,NULL,NULL,NULL,NULL,'4707 S. Austin',0,'Amarillo','TX','79110',NULL,'CY','48381','1974-09-13','M','M',':RET:2106-3','N','021','DEN','1197163','33348TX002000201','2014-01-01','2013-12-11 13:23:47','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-26 00:52:27'),(28141,22270,'Y','18','021','EC','A','','','AC','0000710207','0000710207','OH00003703025','IL','1','Kaur','Rajwinder','','','','34','272041215','3212 ESTUARY PL',0,'MAUMEE','OH','43537','9435','CY','39095','1982-08-30','F','M',NULL,'N','021','HLT','3845220','92036OH006002601','2014-04-01','2014-03-06 16:37:26','82.00',NULL,NULL,'347.33','265.33','R-OH001','OH0','179.23',NULL,0,'2014-03-06 21:02:31'),(2348,1913,'Y','18','021','EC','A','','','AC','0000686649','0000686649','TX00000321690','IL','1','HENDERSON','STEPHEN','','','','34','455517994','201 MACARTHUR DR',0,'TEXARKANA','TX','75501','3515','CY','48037','1965-01-03','M','U',':RET:2054-5','N','021','DEN','932323','33348TX002000201','2014-01-01','2013-12-09 15:35:25','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 19:32:08'),(17620,14086,'Y','18','024','14','A','','','TE','0000218462','0000218462','','IL','1','Schuur Sousa','Alexandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-04-11','F','',NULL,NULL,NULL,'','2272997','','2014-01-13','2014-01-13 13:02:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-14 01:32:27'),(18065,14430,'Y','18','021','EC','A','','','AC','0002189772','0002189772','LA00001456349','31','1','George','Frances','','','','34','433116734','PO BOX 1430',0,'Amite','LA','70422',NULL,'CY','22105','1961-04-20','F','M',':RET:2054-5','N','021','DEN','2750054','18575LA002000201','2014-02-01','2014-01-13 20:00:28','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-15 02:07:22'),(28272,22373,'Y','18','024','14','A','','','TE','0000968339','0000968339','','IL','1','Wynns','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-03','F','',NULL,NULL,NULL,'','2150886','','2014-03-31','2014-03-07 13:54:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-07 21:00:22'),(7447,5895,'Y','18','021','EC','A','','','AC','0001057973','0001057973','OH00000539950','IL','1','Johnson','Stacey','','','','34','299903762','4319 POST RAIL LN',0,'FRANKLIN','OH','45005','4950','CY','39165','1987-08-28','F','U',NULL,'N','021','DEN','30388','99734OH005000301','2014-01-01','2013-12-15 11:50:23','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:30:37'),(24654,19571,'Y','18','021','EC','A','','','AC','0000227100','0000227100','OH00002656788','IL','1','Harris-Carr','Patricia','','','','34','299421632','22095 COUNTY ROAD 226',0,'FOSTORIA','OH','44830','9703','CY','39173','1950-10-29','F','M',':RET:2106-3','T','021','HLT','3117242','92036OH004002601','2014-04-01','2014-02-18 19:26:04','0.00',NULL,NULL,'532.27','532.27','R-OH001','OH0','532.27',NULL,0,'2014-02-20 04:23:51'),(7107,5637,'Y','18','021','EC','A','','','AC','0001953606','0001953606','LA00000270757','IL','1','Sissac','Candace','','','','34','438332848','829 FRANKLIN AVE',0,'GRETNA','LA','70053','2221','CY','22051','1966-08-11','F','M',':RET:2054-5','N','021','DEN','2293631','18575LA002000101','2014-01-01','2013-12-24 19:37:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 01:50:55'),(22842,18225,'Y','18','021','EC','A','','','AC','0000692967','0000692967','OH00002590817','IL','1','Nichols','Will','','','','34','289520337','1475 Edgewood Drive',0,'Lima','OH','45805',NULL,'CY','39003','1957-06-27','M','U',':RET:2054-5','N','021','HLT','3685532','92036OH004001501','2014-03-01','2014-02-11 01:28:12','232.00',NULL,NULL,'412.86','180.86','R-OH002','OH0','412.86',NULL,0,'2014-02-11 21:02:14'),(7938,6278,'Y','18','021','EC','A','','','AC','0001180821','0001180821','LA00000202641','IL','1','DELANEUVILLE','BRIANA','','','','34','434906827','2908 CAMBRIDGE DR',0,'LA PLACE','LA','70068','2208','CY','22095','1952-04-29','F','M',':RET:2106-3','N','021','DEN','2002643','18575LA002000201','2014-01-01','2013-12-20 14:39:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:48'),(27032,21410,'Y','18','021','EC','A','','','AC','0000024875','0000024875','TX00003096457','IL','1','Francher','John','','','','34','634128779','15174 FM 95 S',0,'MOUNT ENTERPRISE','TX','75681','3167','CY','48401','1989-08-29','M','M',':RET:2106-3','N','021','DEN','3433154','33348TX002000201','2014-04-01','2014-03-03 14:43:57','0.00',NULL,NULL,'67.44','67.44','R-TX013','TX0','14.61','CIC',0,'2014-03-03 21:00:17'),(4978,3953,'Y','18','021','EC','A','','','AC','0000471677','0000471677','TX00000097787','IL','1','REYNA','LUZ','','','','34','460497092','118 E MIMS ST',0,'TYLER','TX','75702','2131','CY','48423','1978-08-23','F','M',NULL,'N','021','DEN','835568','33348TX002000201','2014-01-01','2013-12-07 16:42:00','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 22:46:39'),(6613,5243,'Y','18','021','EC','A','','','AC','0000479819','0000479819','OH00000003888','IL','1','holder','marilyn','louise','','','34','299489308','6625 Springdale Road',0,'Cincinnati','OH','45247',NULL,'CY','39061','1951-01-31','F','M',':RET:2106-3','N','021','HLT','1171974','92036OH004001201','2014-01-01','2013-12-11 10:29:00','125.00',NULL,NULL,'495.91','370.91','R-OH004','OH0','495.91',NULL,0,'2013-12-26 00:53:48'),(6575,5213,'Y','18','021','EC','A','','','AC','0000759327','0000759327','LA00001184288','IL','1','Morris','Delaney','','','','34','436771226','7196 LAKELAND DR',0,'ZACHARY','LA','70791','2888','CY','22033','1989-09-09','F','U',':RET:2054-5','N','021','DEN','806014','18575LA002000101','2014-01-01','2013-12-11 12:40:55','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 00:52:47'),(5791,4599,'Y','18','021','EC','A','','','AC','0000209634','0000209634','OH00000825756','IL','1','Lange','Nancy','','','','34','283486985','2715 Silver Springs Dr',0,'Norton','OH','44203',NULL,'CY','39153','1950-02-02','F','U',':RET:2106-3','N','021','DEN','2170479','99734OH005000401','2014-01-01','2013-12-24 00:38:25','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:47:15'),(2816,2277,'Y','18','021','EC','A','','','AC','0000458015','0000458015','TX00000191787','IL','1','Vomacka','Michael','','','','34','453753599','535 South Mesa Hills Drive',0,'El Paso','TX','79912',NULL,'CY','48141','1985-08-26','M','U',':RET:2106-3','N','021','DEN','1253965','33348TX002000201','2014-01-01','2013-11-24 17:20:51','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 20:00:23'),(4306,3424,'Y','18','021','EC','A','','','AC','0000093834','0000093834','OH00000278001','IL','1','davis','teresa','','','','34','294745384','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1962-12-18','F','M',':RET:2106-3','T','021','HLT','2284060','92036OH004001201','2014-01-01','2013-12-17 05:52:20','240.00',NULL,NULL,'762.05','522.05','R-OH004','OH0','370.22',NULL,0,'2013-12-25 21:52:29'),(83,72,'Y','18','021','EC','A','','','AC','0000701655','0000701655','OH00000589590','IL','1','Davidson','Danielle','M','','','34','298500836','486 Bay Hill Dr.',0,'Avon Lake','OH','44012',NULL,'CY','39093','1952-11-05','F','U',NULL,'N','021','DEN','254667','99734OH005000301','2014-01-01','2013-12-05 17:45:52','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:17:12'),(16839,13470,'Y','18','021','EC','A','','','AC','0001031467','0001031467','OH00002080194','IL','1','Winer','Sharon','','','','34','278545130','2894 Chamberlain Rd',0,'Akron','OH','44333',NULL,'CY','39153','1951-05-27','F','U',':RET:2106-3','N','021','HLT','1454635','52664OH151001305','2014-02-01','2014-01-11 09:57:06','520.00',NULL,NULL,'640.70','120.70','R-OH012','OH0','640.70',NULL,0,'2014-01-13 02:18:32'),(7779,6159,'Y','18','024','14','A','','','TE','0000404107','0000404107','','IL','1','Aljabbari','Odeaa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-03-27','M','',NULL,NULL,NULL,'','1707691','','2013-12-19','2013-12-19 23:20:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:09'),(1043,856,'Y','18','021','EC','A','','','AC','0000479622','0000479622','TX00000710584','IL','1','PETERS','TOM','','','','34','503629767','734 LAKE DAM ROAD',0,'BLACKWELL','TX','79506',NULL,'CY','48081','1950-10-02','M','M',':RET:2106-3','N','021','DEN','123100','33348TX002000201','2014-01-01','2013-12-03 14:25:54','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:15:50'),(13144,10484,'Y','18','021','EC','A','','','AC','0001044481','0001044481','OH00000345789','IL','1','SMITH','MIKE','','','','34','413943619','221 RIDGECREST DR',0,'WEST CARROLLTON','OH','45449',NULL,'CY','39113','1955-07-20','M','U',':RET:2106-3','N','021','DEN','2212030','99734OH005000401','2014-01-01','2013-12-23 16:22:08','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:53:24'),(7670,6075,'N','01','021','EC','A',NULL,NULL,'','0002295930','0002210528','','IL','1','Shaffer','Sandra','','','','34','434987357','16313 SHETLAND AVE',0,'GREENWELL SPRINGS','LA','70739','5926','CY','22033','1958-01-16','F','',':RET:2106-3','N','021','DEN','1478703','18575LA002000101','2014-01-01','2013-12-20 18:10:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 03:00:32'),(23187,18488,'Y','18','021','EC','A','','','AC','0000037047','0000037047','OH00001778831','IL','1','Lenahan','Jennifer','','','','34','268869914','1684 MAXWELL BLVD',0,'BRUNSWICK','OH','44212','4414','CY','39103','1982-04-21','F','U',':RET:2106-3','N','021','HLT','2640259','52664OH152000901','2014-03-01','2014-02-11 21:50:43','0.00',NULL,NULL,'189.31','189.31','R-OH012','OH0','189.31',NULL,0,'2014-02-12 21:32:01'),(13123,10465,'N','01','021','EC','A',NULL,NULL,'','0000783231','0000168892','','IL','1','DIFRANCESCO','DAVID','','','','34','273483274','1303 GIESSE DR',0,'CLEVELAND','OH','44124','1814','CY','39035','1949-11-09','M','',':RET:2106-3','N','021','DEN','2564503','99734OH005000401','2014-01-01','2013-12-23 14:07:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:52:47'),(9210,7305,'Y','18','021','EC','A','','','AC','0000487500','0000487500','MS00000971092','IL','1','Brown','Aden','Christopher','','','34','426638337','1117 PROSE AVE',0,'JACKSON','MS','39204','2828','CY','28049','1988-06-30','M','U',':RET:2054-5','N','021','DEN','1807976','46300MS002000201','2014-01-01','2013-12-18 15:15:51','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:09:52'),(19312,15395,'Y','18','021','EC','A','','','AC','0000105057','0000105057','TX00002126941','IL','1','ANGULO','RAMON','','','','34','635583096','14121 ENTRADA LOOP',0,'LAREDO','TX','78045',NULL,'CY','48479','1961-12-02','M','M',NULL,'N','021','DEN','1557346','33348TX002000201','2014-03-01','2014-01-20 22:40:41','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,1,'2014-01-22 03:22:06'),(9545,7564,'Y','18','021','EC','A','','','AC','0000716329','0000716329','OH00000709926','IL','1','Williams','Colleen','','','','34','280903823','8955 MIMOSA LN',0,'WEST CHESTER','OH','45069','3635','CY','39017','1981-06-03','F','U',':RET:2106-3','N','021','DEN','1645878','99734OH005000301','2014-01-01','2013-12-21 12:02:05','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:07'),(1806,1484,'Y','18','021','EC','A','','','AC','0000002296','0000002296','OH00000239929','IL','1','Miller','David','M','','','34','296424640','277 LAKE FRONT DR',0,'AKRON','OH','44319','3619','CY','39153','1949-12-30','M','U',':RET:2106-3','T','021','HLT','2551153','52664OH151001501','2014-01-01','2013-12-24 08:10:46','441.00',NULL,NULL,'922.73','481.73','R-OH012','OH0','922.73',NULL,0,'2013-12-25 18:56:55'),(14782,11805,'Y','18','021','EC','A','','','AC','0001127998','0001127998','OH00001288552','IL','1','kauntz','candace','','','','34','270586776','3638 W148 St.',0,'Cleveland','OH','44111',NULL,'CY','39035','1953-12-18','F','M',':RET:2106-3','N','021','DEN','2176924','99734OH005000401','2014-01-01','2013-12-23 20:22:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:15'),(6524,5173,'Y','18','021','EC','A','','','AC','0000999828','0000999828','OH00001098261','IL','1','Ftacnik','Nicole','','','','34','372063666','4237 Fontenay',0,'Mason','OH','45040',NULL,'CY','39165','1975-03-08','F','U',':RET:2106-3','N','021','HLT','135408','92036OH002001201','2014-01-01','2013-12-10 19:41:38','0.00',NULL,NULL,'308.91','308.91','R-OH004','OH0','308.91',NULL,0,'2013-12-26 00:51:30'),(1148,946,'Y','18','021','EC','A','','','AC','0000459282','0000459282','LA00000389024','IL','1','Ray','Jane','','','','34','437709320','15515 RIVERDALE AVE E',0,'BATON ROUGE','LA','70816','1577','CY','22033','1950-03-09','F','U',':RET:2106-3','N','021','DEN','1162159','18575LA002000201','2014-01-01','2013-12-03 15:00:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:32'),(6355,5037,'Y','18','021','EC','A','','','AC','0000631491','0000631491','OH00000278978','IL','1','Pizir','Nancy','','','','34','289760651','1470 ARTHUR AVE',0,'LAKEWOOD','OH','44107','3802','CY','39035','1979-09-11','F','U',':RET:2106-3','N','021','DEN','1103777','99734OH005000401','2014-01-01','2013-12-11 14:46:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:10'),(24422,19400,'Y','18','021','EC','A','','','AC','0000735074','0000735074','OH00001930692','IL','1','Dixon','Amy','','','','34','400374653','12405 Detroit Ave.',0,'Lakewood','OH','44107',NULL,'CY','39035','1988-03-13','F','U',':RET:2106-3','T','021','DEN','3847313','99734OH005000301','2014-04-01','2014-02-18 16:40:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:01:08'),(16576,13258,'Y','18','021','EC','A','','','AC','0000561686','0000561686','OH00001284946','IL','1','BROWN','BRYAN','','','','34','297681212','4250 State RT 307',0,'Geneva','OH','44041',NULL,'CY','39007','1968-03-02','M','U',':RET:2106-3','N','021','HLT','1774105','52664OH151001305','2014-02-01','2014-01-05 10:07:20','245.00',NULL,NULL,'363.19','118.19','R-OH011','OH0','363.19',NULL,1,'2014-01-07 10:23:30'),(18376,14667,'Y','18','024','14','A','','','TE','0000338890','0000338890','','IL','1','Weisel','Raymond',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-08','M','',NULL,NULL,NULL,'','2412958','','2014-01-15','2014-01-15 14:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:32'),(16193,12964,'Y','18','021','EC','A','','','AC','0000899831','0000899831','TX00002152354','IL','1','EDWARDS','BILLIE','RAYE','','','34','430292305','8713 RIVER RD',0,'AMARILLO','TX','79108','1721','CY','48375','1972-09-18','F','U',':RET:2106-3','T','021','DEN','1849211','33348TX002000201','2014-02-01','2014-01-04 08:22:56','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-05 00:00:54'),(27790,21980,'Y','18','021','EC','A','','','AC','0000773906','0000773906','MS00003047658','IL','1','SWANSON','ALBERTHA','','','','34','587467825','603 CENTRAL ST',0,'BELZONI','MS','39038','3311','CY','28053','1951-03-07','F','U',':RET:2054-5','N','021','DEN','4068596','46300MS002000201','2014-04-01','2014-03-05 14:07:05','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-05 21:31:40'),(26189,20769,'Y','18','021','EC','A','','','AC','0000033009','0000033009','OH00003042264','IL','1','IZRAEL','JAMES','','','','34','268727914','3030 EAST 63',0,'CLEVLAND','OH','44127',NULL,'CY','39035','1969-11-08','M','U',NULL,'N','021','DEN','2684936','99734OH005000301','2014-04-01','2014-02-27 12:34:30','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:44'),(24243,19250,'N','17','021','EC','A',NULL,NULL,'','0000177678','0000282063','','S3','1','Sexton','Barbara','','','','34','276110433','935 Hathaway Dr.',0,'Trenton','OH','45067',NULL,'CY','39017','2005-01-18','M','',NULL,'N','021','HLT','2768781','92036OH004001201','2014-03-01','2014-02-15 22:14:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-16 19:00:40'),(23759,18910,'Y','18','021','EC','A','','','AC','0000756056','0000756056','OH00001557973','IL','1','Vulcan','Nicolae','','','','34','269027373','4517 OCALA DR',0,'PARMA','OH','44134','6331','CY','39035','1952-01-16','M','M',':RET:2106-3','N','021','DEN','3560706','99734OH005000301','2014-03-01','2014-02-14 10:14:36','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:31:09'),(3777,3025,'Y','18','021','EC','A','','','AC','0000368535','0000368535','OH00000151350','IL','1','scippio','carolyn','','','','34','128484903','825 MEDOSH ST',0,'CINCINNATI','OH','45215','1652','CY','39061','1956-08-22','F','U',':RET:2054-5','T','021','DEN','987494','99734OH005000301','2014-01-01','2013-12-13 17:47:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:33:52'),(26425,20958,'Y','18','021','EC','A','','','AC','0000819343','0000819343','TX00002531883','IL','1','FRANCO','BRENDA','','','','34','643506225','1106 GUITERREZ CV',0,'ROUND ROCK','TX','78681','6425','CY','48491','1990-10-28','F','U',NULL,'N','021','DEN','3462272','33348TX002000201','2014-04-01','2014-02-27 13:09:41','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-02-28 07:30:11'),(28646,22669,'N','19','021','EC','A',NULL,NULL,'','0000218017','0000005187','','IL','1','Church','Alexandrea','','','','34','425753998','953 ARBOR VISTA BLVD',0,'JACKSON','MS','39209','7133','CY','28049','1992-11-05','F','',':RET:2054-5','N','021','DEN','3530033','46300MS002000101','2014-04-01','2014-03-07 22:16:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-08 21:30:35'),(28784,22784,'Y','18','021','EC','A','','','AC','0001090979','0001090979','OH00002641300','IL','1','Collins','Briana','','','','34','282969599','13164 FORESTDALE DR',0,'GARFIELD HEIGHTS','OH','44125',NULL,'CY','39035','1993-10-06','F','U',NULL,'N','021','DEN','3227884','99734OH005000401','2014-04-01','2014-03-09 16:12:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2014-03-09 21:00:36'),(19172,15274,'Y','18','021','EC','A','','','AC','0001228130','0001228130','TX00002012170','IL','1','Mixon','Leonidas','','','','34','438598690','907 W 4TH ST',0,'LAMPASAS','TX','76550','2522','CY','48281','1969-08-15','M','M',':RET:2106-3','N','021','DEN','2758280','33348TX002000201','2014-03-01','2014-01-20 11:58:39','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-01-21 08:46:03'),(18349,14649,'Y','18','021','EC','A','','','AC','0000393694','0000393694','OH00001370594','IL','1','spence','diane','','','','34','301804084','31600 north marginal rd',0,'willowick','OH','44095',NULL,'CY','39085','1975-05-28','F','U',':RET:2106-3','T','021','DEN','1560829','99734OH005000301','2014-02-01','2014-01-14 19:43:08','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:21'),(17247,13801,'Y','18','021','EC','A','','','AC','0001080352','0001080352','OH00002037014','IL','1','Fraser','Melissa','','','','34','232044454','801 Leisure Lane',0,'Medina','OH','44256',NULL,'CY','39103','1973-01-07','F','U',':RET:2106-3','N','021','DEN','2201469','99734OH005000301','2014-02-01','2014-01-09 18:18:29','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:23:09'),(7461,5904,'Y','18','021','EC','A','','','AC','0001168493','0001168493','MS00000968333','IL','1','Porter','Shirley','','','','34','427133324','107 Parkview',0,'Canton','MS','39046',NULL,'CY','28089','1959-12-19','F','U',':RET:2054-5','N','021','DEN','541001','46300MS002000201','2014-01-01','2013-12-14 18:51:27','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:30:55'),(7278,5772,'Y','18','021','EC','A','','','AC','0000253200','0000253200','TX00000102074','31','1','barron','jose','','','','34','636013030','4108 la luz ave.',0,'el paso','TX','79903',NULL,'CY','48141','1954-02-27','M','M',NULL,'T','021','DEN','16824','33348TX002000201','2014-01-01','2013-12-14 17:17:48','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-26 02:02:37'),(5430,4312,'Y','18','021','EC','A','','','AC','0000489329','0000489329','LA00001305112','IL','1','Emerson','Lydell','','','','34','439351796','6564 CAMBRIDGE ST',0,'BATON ROUGE','LA','70807','6476','CY','22033','1976-02-23','M','U',':RET:2054-5','N','021','DEN','2113168','18575LA002000101','2014-01-01','2013-12-18 22:23:46','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:09:37'),(2726,2204,'N','01','021','EC','A',NULL,NULL,'','0000358841','0000628150','','IL','1','Corley','Debbie','S','','','34','433905022','38232 ZILDA ST',0,'GONZALES','LA','70737','5917','CY','22005','1952-09-16','F','',':RET:2106-3','N','021','DEN','1051354','18575LA002000201','2014-01-01','2013-12-02 14:49:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:48:20'),(4570,3619,'Y','18','021','EC','A','','','AC','0000110344','0000110344','TX00000925931','IL','1','Flowers','Jeannfer','','','','34','639168738','617 ELECTRA ST',0,'LONGVIEW','TX','75602','1903','CY','48183','1989-03-27','F','U',':RET:2054-5','N','021','DEN','799510','33348TX002000101','2014-01-01','2013-12-12 13:40:27','0.00',NULL,NULL,'25.02','25.02','R-TX013','TX0','25.02',NULL,0,'2013-12-25 22:04:57'),(22334,17835,'Y','18','021','EC','A','','','AC','0000201929','0000201929','TX00002402413','IL','1','stuard','chanda','','','','34','453810328','2534 PAINT ROCK RD',0,'SAN ANGELO','TX','76905','8214','CY','48451','1986-12-02','F','U',':RET:2106-3','N','021','DEN','3176704','33348TX002000101','2014-03-01','2014-01-30 14:42:58','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2014-02-10 11:01:03'),(22471,17943,'Y','18','021','EC','A','','','AC','0000204052','0000204052','MS00001902115','IL','1','Groshong','Joel','','','','34','541609343','2009 TEMPLE RD',0,'MAGNOLIA','MS','39652','8004','CY','28113','1950-05-28','M','U',NULL,'N','021','DEN','3455551','46300MS002000101','2014-03-01','2014-02-10 11:55:33','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-10 21:30:59'),(23524,18740,'Y','18','021','EC','A','','','AC','0002040003','0002040003','LA00001832621','IL','1','HAMILTON','JANICE','','','','34','434150774','5350 GROOM RD',0,'BAKER','LA','70714',NULL,'CY','22033','1959-10-27','F','U',':RET:2054-5','N','021','DEN','3113056','18575LA002000201','2014-03-01','2014-02-13 04:56:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-13 22:02:22'),(23950,19044,'Y','18','021','EC','A','','','AC','0001246730','0001246730','TX00002870858','IL','1','Williams','Curtis','Wayne','','','34','460293590','4202 ADELPHI LN',0,'AUSTIN','TX','78727','5348','CY','48453','1971-06-24','M','M',NULL,'N','021','DEN','3730838','33348TX002000101','2014-03-01','2014-02-14 22:46:12','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:04'),(25776,20441,'Y','18','021','EC','A','','','AC','0001456304','0001456304','LA00003277174','IL','1','MONTGOMERY','JAMES','','','','34','435083405','147 S 20TH ST',0,'BATON ROUGE','LA','70806','3641','CY','22033','1955-10-18','M','M',':RET:2054-5','N','021','DEN','3113351','18575LA002000101','2014-04-01','2014-02-24 13:19:07','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-26 09:30:58'),(27900,22073,'Y','18','021','EC','A','','','AC','0000817599','0000817599','OH00002708829','IL','1','SHAFFER','BEVERLY','','','','34','274508833','7040 WOODLAND TRL',0,'HILLSBORO','OH','45133','7525','CY','39071','1950-12-08','F','M',':RET:2106-3','N','021','HLT','3235038','92036OH004000601','2014-04-01','2014-03-05 16:38:24','450.00',NULL,NULL,'509.54','59.54','R-OH005','OH0','509.54',NULL,0,'2014-03-05 21:32:45'),(29048,22990,'Y','18','021','EC','A','','','AC','0000859759','0000859759','OH00002723780','IL','1','Groya','Amy','','','','34','273901729','6833 SILKWOOD LN',0,'SOLON','OH','44139','5074','CY','39035','1986-06-12','F','U',':RET:2106-3','N','021','DEN','3566174','99734OH005000401','2014-04-01','2014-03-10 14:04:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:44'),(8946,7094,'Y','18','021','EC','A','','','AC','0001096743','0001096743','OH00001276724','IL','1','Ceena','Sharon','M','','','34','083442803','5250 COLUMBIA RD',0,'NORTH OLMSTED','OH','44070','3531','CY','39035','1950-02-04','F','U',':RET:2106-3','N','021','DEN','2131772','99734OH005000401','2014-01-01','2013-12-18 11:08:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:27'),(16927,13546,'Y','18','021','EC','A','','','AC','0002261610','0002261610','LA00000010713','IL','1','Woodard','Joan','','','','34','439965233','1504 Cynthia St',0,'Jonesboro','LA','71251',NULL,'CY','22049','1952-08-11','F','U',':RET:2054-5','T','021','DEN','1557042','18575LA002000201','2014-02-01','2014-01-09 10:55:38','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-13 02:19:47'),(672,554,'Y','18','021','EC','A','','','AC','0000684802','0000684802','OH00000311143','IL','1','Brown','Kyle','','','','34','287922675','6788 Harrison Ave',0,'cincinnati','OH','45248',NULL,'CY','39061','1988-09-15','M','M',':RET:2106-3','T','021','DEN','1696616','99734OH005000301','2014-01-01','2013-12-16 09:53:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:02:09'),(1389,1154,'Y','18','021','EC','A','','','AC','0001888236','0001888236','LA00000548270','IL','1','Carey','Denise','R','','','34','438597142','36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1972-09-30','F','U',':RET:2054-5','N','021','DEN','1422524','18575LA002000201','2014-01-01','2013-12-24 10:52:28','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:19'),(15874,12711,'Y','18','021','EC','A','','','AC','0000062902','0000062902','MS00001521361','IL','1','WADLEY','LEANITRA','','','','34','282749622','307 NORTH VIEW STREET',0,'UTICA','MS','39175',NULL,'CY','28049','1963-04-08','F','U',NULL,'N','021','DEN','1832865','46300MS002000101','2014-02-01','2014-01-02 11:36:34','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-03 02:05:10'),(3681,2946,'Y','18','021','EC','A','','','AC','0001218526','0001218526','OH00000071451','IL','1','MERCER','NORMAN','JOHN','','','34','272444946','1375 COUNTY ROAD B',0,'SWANTON','OH','43558','9753','CY','39051','1949-12-15','M','U',':RET:2106-3','N','021','DEN','902765','99734OH005000401','2014-01-01','2013-12-13 09:17:56','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:31:27'),(6371,5051,'N','01','021','EC','A',NULL,NULL,'','0000582788','0000097552','','IL','1','Becker','Christine','','','','34','282480265','2900 DENISE DR',0,'COPLEY','OH','44321','2245','CY','39153','1950-05-19','F','',':RET:2106-3','N','021','DEN','327047','99734OH005000301','2014-01-01','2013-12-11 05:39:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:47:39'),(20626,16481,'Y','18','021','EC','A','','','AC','0000155262','0000155262','TX00001820410','IL','1','Gray','Gregory','','','','34','462809554','2638 Pine Village Drive',0,'Houston','TX','77080',NULL,'CY','48201','1949-07-06','M','U',NULL,'N','021','DEN','2876581','33348TX002000201','2014-03-01','2014-01-29 18:56:20','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-30 21:00:26'),(26165,20747,'Y','18','021','EC','A','','','AC','0000123043','0000123043','MS00002044471','IL','1','SCOTT','ALBERTA','','','','34','304564452','917 W LAKE DOCKERY DR',0,'BYRAM','MS','39272','9004','CY','28049','1952-09-02','F','M',NULL,'N','021','DEN','3748037','46300MS002000201','2014-04-01','2014-02-26 18:22:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 06:30:34'),(26617,21104,'N','01','021','EC','A',NULL,NULL,'','0001114364','0000837607','','IL','1','RIVERA','CONCEPCION','','','','34','633251745','302 N JOHNSON',0,'AMARILLO','TX','79107',NULL,'CY','48375','1950-08-08','F','',NULL,'N','021','DEN','3569782','33348TX002000201','2014-04-01','2014-02-28 11:17:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 21:30:49'),(5373,4260,'Y','18','024','14','A','','','TE','0000063936','0000063936','','IL','1','Woods','Cheylon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-20','F','',NULL,NULL,NULL,'','63781','','2013-12-18','2013-12-18 20:05:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 23:08:08'),(9449,7496,'Y','18','021','EC','A','','','AC','0000490462','0000490462','OH00001054268','IL','1','KUHN','MARSHA','FAY','','','34','210406734','13467 DURKEE RD',0,'GRAFTON','OH','44044',NULL,'CY','39093','1949-11-17','F','M',':RET:2106-3','N','021','DEN','1456544','99734OH005000401','2014-01-01','2013-12-20 20:47:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:33:55'),(3070,2467,'N','19','021','EC','A',NULL,NULL,'','0000015736','0000014312','','IL','1','Polsky','Toby','','','','34','351918704','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','2012-08-06','F','',':RET:2106-3','N','021','DEN','1029260','18575LA002000101','2014-01-01','2013-12-06 17:16:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2013-12-25 20:19:27'),(9060,7189,'Y','18','021','EC','A','','','AC','0001181324','0001181324','TX00000264894','IL','1','MOORE','STACEY','','','','34','572176571','1425 VANDERBILT S',0,'FORT WORTH','TX','76120',NULL,'CY','48439','1964-06-28','F','U',':RET:2106-3','N','021','DEN','2256458','33348TX002000101','2014-01-01','2013-12-18 11:58:49','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 04:06:19'),(9011,7150,'Y','18','024','14','A','','','TE','0000542644','0000542644','','IL','1','Machado','Jorge',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1993-10-10','F','',NULL,NULL,NULL,'','73485','','2013-12-18','2013-12-18 16:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:05'),(19977,15935,'Y','18','021','EC','A','','','AC','0001205840','0001205840','OH00001375584','IL','1','Stauffer','David','','','','34','269646810','578 S. East St.',0,'Bucyrus','OH','44820',NULL,'CY','39033','1959-02-10','M','M',':RET:2106-3','N','021','DEN','1462886','99734OH005000401','2014-03-01','2014-01-25 10:42:26','0.00',NULL,NULL,'31.57','31.57','R-OH007','OH0','0.00',NULL,0,'2014-01-25 19:00:14'),(24356,19345,'Y','18','021','EC','A','','','AC','0001874275','0001874275','LA00001606711','IL','1','moyse','ferd','','','','34','587351875','1217 FRANCE ST',0,'NEW ORLEANS','LA','70117','4803','CY','22071','1976-11-10','M','U',':RET:2106-3','N','021','DEN','3222321','18575LA002000201','2014-04-01','2014-02-18 08:32:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:30'),(25907,20542,'Y','18','021','EC','A','','','AC','0000746985','0000746985','TX00003122688','IL','1','Cody','Pamela','Jo','','','34','441626954','2925 Mars Dr',0,'Garland','TX','75040',NULL,'CY','48113','1958-01-05','F','U',':RET:2106-3','N','021','DEN','3223923','33348TX002000201','2014-04-01','2014-02-26 14:19:02','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:12'),(27626,21851,'Y','18','024','14','A','','','TE','0000293156','0000293156','','IL','1','Lapushansky','John','Alexander',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-05-31','M','',NULL,NULL,NULL,'','338364','','2014-03-19','2014-03-04 19:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-05 21:30:07'),(13942,11118,'N','19','021','EC','A',NULL,NULL,'','0000661345','0000670255','','IL','1','Poshedley','Dominic','','','','34','278028106','11081 FAIRLAWN DR',0,'PARMA','OH','44130','1217','CY','39035','1997-05-07','M','',NULL,'N','021','HLT','1777511','92036OH003000804','2014-01-01','2013-12-22 22:14:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','155.05',NULL,0,'2013-12-26 13:14:45'),(8886,7045,'Y','18','021','EC','A','','','AC','0001039039','0001039039','TX00000837264','IL','1','MCFADDEN','BILLY','','','','34','451862338','1408 COUNTY ROAD 34650',0,'SUMNER','TX','75486','4224','CY','48277','1950-09-01','M','M',':RET:2106-3','N','021','DEN','2383180','33348TX002000201','2014-01-01','2013-12-18 16:30:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:53'),(1895,1550,'Y','18','021','EC','A','','','AC','0000894626','0000894626','OH00001277173','IL','1','Bender','Judy','Ann','','','34','268601767','155 C.R. 6',0,'Tiffin','OH','44883',NULL,'CY','39147','1956-08-26','F','U',':RET:2106-3','N','021','HLT','1499008','92036OH004002701','2014-01-01','2013-12-24 12:28:30','222.00',NULL,NULL,'382.11','160.11','R-OH006','OH0','382.11',NULL,0,'2013-12-25 18:58:58'),(13514,10772,'Y','18','021','EC','A','','','AC','0002230426','0002230426','LA00000902611','IL','1','Smith','Deirdre','','','','34','550978532','13675 Coursey Blvd',0,'Baton Rouge','LA','70817',NULL,'CY','22033','1982-05-22','F','U',':RET:2106-3','N','021','DEN','1773637','18575LA002000201','2014-01-01','2013-12-23 00:07:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:03:00'),(20864,16673,'N','19','021','EC','A',NULL,NULL,'','0000728749','0001020449','','IL','1','Vyas','Damien',NULL,NULL,NULL,NULL,NULL,'5830 TRIPLETT SQ',0,'NEW ALBANY','OH','43054','8080','CY','39049','2001-09-24','M','',':RET:2106-3','N','021','DEN','2759609','99734OH005000301','2014-03-01','2014-01-31 15:19:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:57'),(25102,19910,'Y','18','024','14','A','','','TE','0001156225','0001156225','','IL','1','Cobos','Satiago',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-06-26','M','',NULL,NULL,NULL,'','2628733','','2014-03-31','2014-02-21 16:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-21 21:30:11'),(25322,20089,'Y','18','021','EC','A','','','AC','0002153423','0002153423','LA00002074373','IL','1','Carney','LaJerrika','','','','34','435778887','2741 N DAY DR',0,'BAKER','LA','70714','3213','CY','22033','1990-01-23','F','U',':RET:2054-5','N','021','DEN','2645540','18575LA002000201','2014-04-01','2014-02-25 09:49:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:10'),(25708,20394,'Y','18','021','EC','A','','','AC','0000737505','0000737505','TX00002784048','IL','1','NINO','MIGDALIA','','','','34','626016870','4168 BEECH AVE',0,'MERCEDES','TX','78570',NULL,'CY','48215','1963-09-22','F','M',NULL,'N','021','DEN','3073581','33348TX002000201','2014-04-01','2014-02-24 15:48:46','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-26 09:30:22'),(26000,20620,'Y','18','021','EC','A','','','AC','0001235096','0001235096','LA00003261343','IL','1','FIGEROA','DOUGLAS','ALBERTO','','','34','433974980','3557 MARTINIQUE AVE',0,'KENNER','LA','70065','3560','CY','22051','1956-07-10','M','M',NULL,'N','021','DEN','3298368','18575LA002000101','2014-04-01','2014-02-26 11:24:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-26 21:02:03'),(13686,10920,'N','01','021','EC','A',NULL,NULL,'','0000190195','0000144216','','IL','1','chick','kelly','lynn','','','34','268881275','151 E OVERLOOK DR',0,'EASTLAKE','OH','44095','1107','CY','39085','1974-09-21','F','',':RET:2106-3','T','021','HLT','1756418','52664OH151001305','2014-01-01','2013-12-23 09:43:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','365.03',NULL,0,'2013-12-26 13:08:20'),(18771,14954,'N','01','021','EC','A',NULL,NULL,'','0000239712','0000832877','','IL','1','SHERER','CANDACE','','','','34','462657877','515 PINE RD',0,'CLEAR LAKE SHORES','TX','77565','2422','CY','48167','1968-06-22','F','',NULL,'N','021','DEN','3021306','33348TX002000101','2014-02-01','2014-01-15 19:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-17 03:35:50'),(1984,1623,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','1152817','','2013-11-19','2013-11-19 23:04:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:47'),(18615,14839,'Y','18','021','EC','A','','','AC','0001252141','0001252141','OH00001375388','IL','1','Copas','Mitzi','','','','34','285569789','1310 SARATOGA DR',0,'TROY','OH','45373','1617','CY','39109','1954-06-29','F','U',':RET:2106-3','T','021','HLT','2442685','92036OH004000501','2014-02-01','2014-01-15 14:07:44','441.00',NULL,NULL,'572.17','131.17','R-OH003','OH0','572.17',NULL,0,'2014-01-16 08:47:25'),(15501,12402,'Y','18','024','14','A','','','TE','0000180980','0000180980','','IL','1','firm','edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-17','M','',NULL,NULL,NULL,'','432405','','2013-12-31','2013-12-31 13:39:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:45'),(7853,6218,'N','01','021','EC','A',NULL,NULL,'','0000192727','0000940846','','IL','1','Lehman','Denise','A','','','34','288488867','842 JOHNSON PLANK RD NE',0,'WARREN','OH','44481','9361','CY','39155','1949-08-21','F','',':RET:2106-3','N','021','DEN','1509377','99734OH005000301','2014-01-01','2013-12-20 09:38:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:53'),(15404,12321,'N','01','021','EC','A',NULL,NULL,'','0000083700','0000381529','','IL','1','Scheidt','Patt','Sue','','','34','397608309','236 RAINBOW DR',0,'LIVINGSTON','TX','77399','2036','CY','48373','1954-01-18','F','',':RET:2106-3','N','021','DEN','1895478','33348TX002000201','2014-02-01','2013-12-30 20:10:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:26:53'),(14537,11600,'Y','18','021','EC','A','','','AC','0000967734','0000967734','MS00001854495','IL','1','MILLER','PATSY','','','','34','425020381','410 STONEYBROOK DRIVE',0,'BRANDON','MS','39042',NULL,'CY','28121','1955-04-06','F','U',':RET:2106-3','N','021','DEN','1831403','46300MS002000201','2014-02-01','2013-12-27 11:42:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:42'),(5272,4179,'N','19','021','EC','A',NULL,NULL,'','0000696804','0000536912','','S1','1','Vaccaro','Raphael','M',NULL,NULL,NULL,NULL,'2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','1998-07-15','F','',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:05:34'),(14313,11416,'Y','18','021','EC','A','','','AC','0000618374','0000618374','OH00000499152','IL','1','Jordan','Robin','','','','34','591967627','85 Oak Street',0,'tiffin','OH','44883',NULL,'CY','39147','1990-03-07','F','U',':RET:2106-3','N','021','HLT','1637549','92036OH003002705','2014-02-01','2013-12-26 17:54:32','128.00',NULL,NULL,'203.63','75.63','R-OH006','OH0','203.63',NULL,0,'2013-12-27 02:07:04'),(22141,17672,'Y','18','021','EC','A','','','AC','0000037041','0000037041','OH00002532817','IL','1','CROYLE','SANDRA','','','','34','287480594','4774 WOLFF DR',0,'BRUNSWICK','OH','44212','2551','CY','39103','1950-02-24','F','M',NULL,'T','021','HLT','3329268','52664OH152000901','2014-03-01','2014-02-08 11:25:18','430.00',NULL,NULL,'563.50','133.50','R-OH012','OH0','563.50',NULL,0,'2014-02-08 19:00:49'),(13022,10380,'Y','18','021','EC','A','','','AC','0000157992','0000157992','OH00001077643','IL','1','graham','david','','','','34','299806196','1222 BROWN ST',0,'AKRON','OH','44301','1954','CY','39153','1983-12-17','M','U',':RET:2106-3','N','021','DEN','2571957','99734OH005000401','2014-01-01','2013-12-22 21:28:08','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:50:06'),(960,788,'N','01','021','EC','A',NULL,NULL,'','0000561727','0000249125','','IL','1','Nguyen','andy','','','','34','633324671','1120 KIRKWOOD LN',0,'PROSPER','TX','75078','7941','CY','48085','1981-10-20','M','',':RET:2047-9','T','021','DEN','363906','33348TX002000201','2014-01-01','2013-10-28 21:16:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:09:45'),(1576,1315,'N','01','021','EC','A',NULL,NULL,'','0000990966','0000206631','','IL','1','REYES','CHRISTINA','','','','34','458936196','20903 HARVEST TERRACE LN',0,'SPRING','TX','77379',NULL,'CY','48201','1973-07-09','F','',NULL,'N','021','DEN','1671507','33348TX002000201','2014-01-01','2013-12-24 10:24:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:51:19'),(2219,1827,'N','01','021','EC','A',NULL,NULL,'','0000376133','0000076280','','IL','1','Walters','Joyce','','','','34','269582370','9027 RED HAWK DR',0,'STREETSBORO','OH','44241','4541','CY','39133','1953-12-04','F','',':RET:2106-3','N','021','HLT','4035','52664OH151001305','2014-01-01','2013-12-10 17:22:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2013-12-25 19:20:28'),(6254,4956,'Y','18','021','EC','A','','','AC','0000987353','0000987353','OH00001211300','IL','1','HIRSCHFELD','SHEILA','R','','','34','291483629','215 STONE OAK CT',0,'HOLLAND','OH','43528','9256','CY','39095','1950-11-17','F','M',':RET:2106-3','N','021','HLT','42165','92036OH001002601','2014-01-01','2013-11-19 09:59:03','0.00',NULL,NULL,'694.33','694.33','R-OH001','OH0','694.33',NULL,0,'2013-12-26 00:32:03'),(7279,5772,'N','01','021','EC','A',NULL,NULL,'','0000253200','0000679703','','IL','1','barron','maria','r','','','34','455398195','4108 LA LUZ AVE',0,'EL PASO','TX','79903','3014','CY','48141','1955-12-31','F','',':RET:2106-3','N','021','DEN','16824','33348TX002000201','2014-01-01','2013-12-14 17:17:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 02:02:38'),(19409,15475,'N','19','021','EC','A',NULL,NULL,'','0000196164','0001200912','','IL','1','Gruich','Jonathan','','','','34','293962224','2449 GREENHAVEN DR',0,'AKRON','OH','44333','2753','CY','39153','1993-12-20','M','',':RET:2106-3','N','021','HLT','3023737','52664OH152000901','2014-03-01','2014-01-21 11:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,1,'2014-01-22 03:22:57'),(25949,20579,'Y','18','021','EC','A','','','AC','0000943472','0000943472','OH00001841111','S3','1','brewsaugh','brandon','Michael','','','34','736943346','18184 HUBER RD',0,'MOUNT ORAB','OH','45154','8795','CY','39015','2012-01-24','M','U',':RET:2106-3','N','021','DEN','3014703','99734OH005000401','2014-04-01','2014-02-26 10:06:01','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','15.78',NULL,0,'2014-02-26 21:01:35'),(13023,10381,'Y','18','021','EC','A','','','AC','0000687217','0000687217','OH00000491138','IL','1','UHLENBROCK','RICHARD','A','','','34','278468658','6327 ELKWATER CT',0,'CINCINNATI','OH','45248','3903','CY','39061','1950-05-07','M','U',NULL,'T','021','DEN','2092203','99734OH005000401','2014-01-01','2013-12-22 21:38:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:08'),(1194,983,'Y','18','021','EC','A','','','AC','0000644644','0000644644','OH00000694411','IL','1','heck','loretta','','','','34','288642410','17761 STATE ROUTE 7 S',0,'CROWN CITY','OH','45623','9081','CY','39053','1959-06-16','F','U',':RET:2106-3','T','021','DEN','299264','99734OH005000301','2014-01-01','2013-12-03 13:09:36','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:19:42'),(18520,14767,'N','01','021','EC','A',NULL,NULL,'','0001173708','0000467929','','IL','1','VASILE','ELENA','FELICIA','','','34','630084537','15935 Bent Tree Forest Circle',0,'DALLAS','TX','75248',NULL,'CY','48113','1970-08-09','F','',':RET:2106-3','N','021','DEN','2812729','33348TX002000101','2014-02-01','2014-01-14 23:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-16 08:46:37'),(9143,7250,'N','01','021','EC','A',NULL,NULL,'','0000121523','0000882837','','IL','1','Cromwell','Ray','','','','34','523174446','1154 BEARDSLEY ST',0,'AKRON','OH','44301','1818','CY','39153','1976-08-03','M','',NULL,'N','021','HLT','2436779','52664OH151001501','2014-01-01','2013-12-18 08:38:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','331.12',NULL,0,'2013-12-26 04:08:14'),(17605,14072,'Y','18','021','EC','A','','','AC','0001246618','0001246618','TX00002446053','IL','1','Mosley','Brenda','','','','34','451088118','101 Senecio Street',0,'Victoria','TX','77901',NULL,'CY','48469','1953-08-27','F','U',':RET:2054-5','T','021','DEN','1659824','33348TX002000201','2014-02-01','2014-01-12 21:00:12','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-14 01:32:18'),(4847,3840,'Y','18','021','EC','A','','','AC','0000499277','0000499277','OH00000342436','IL','1','Combs','Terri','','','','34','290602174','222worth st',0,'Cincinnati','OH','45226',NULL,'CY','39061','1961-06-09','F','M',':RET:2106-3','N','021','DEN','163603','99734OH005000401','2014-01-01','2013-11-08 10:55:40','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:30:16'),(14420,11500,'N','01','021','EC','A',NULL,NULL,'','0000689561','0000183344','','IL','1','Mirelez','Nancy','Y','','','34','533311633','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1971-01-24','F','',NULL,'N','021','DEN','1727826','33348TX002000101','2014-02-01','2013-12-27 10:33:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-28 03:31:40'),(16949,13566,'Y','18','021','EC','A','','','AC','0000242733','0000242733','MS00001257604','31','1','Ferrell','Leon','','','','34','587980672','p.o. box 28',0,'ludlow','MS','39098',NULL,'CY','28123','1953-10-10','M','M',':RET:2054-5','N','021','DEN','1716831','46300MS002000101','2014-02-01','2014-01-08 20:51:24','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:19:59'),(16531,13224,'N','01','021','EC','A',NULL,NULL,'','0000007457','0000704899','','IL','1','juarez','rosamaria','','','','34','629142337','9920 GENIE DR',0,'EL PASO','TX','79924','5016','CY','48141','1966-12-12','F','',':RET:2106-3','T','021','DEN','1912130','33348TX002000201','2014-02-01','2014-01-05 16:43:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-07 10:22:03'),(19429,15488,'Y','18','024','14','A','','','TE','0000773964','0000773964','','IL','1','SMITH','SHARON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-13','F','',NULL,NULL,NULL,'','1977452','','2014-01-21','2014-01-21 12:00:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:23:06'),(19984,15940,'Y','18','021','EC','A','','','AC','0001196843','0001196843','OH00001560310','IL','1','Diehl','Jamie','','','','34','283809965','2322 MARCIA DR',0,'COLUMBUS','OH','43211','1948','CY','39049','1983-04-15','F','U',':RET:2054-5^:RET:2106-3','T','021','DEN','3380289','99734OH005000401','2014-03-01','2014-01-25 18:04:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-25 19:00:16'),(21651,17290,'Y','18','021','EC','A','','','AC','0001300839','0001300839','LA00002553939','IL','1','do','hong','','','','34','513844501','7121 CAMBERLEY DR',0,'NEW ORLEANS','LA','70128','2205','CY','22071','1962-02-19','F','U',':RET:2028-9^:RET:2047-9','N','021','DEN','2709270','18575LA002000201','2014-03-01','2014-02-04 20:13:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:50'),(21851,17449,'Y','18','021','EC','A','','','AC','0000216146','0000216146','OH00002519770','IL','1','Mikulan','Patricia','','','','34','280741017','3188 NOTTINGHAM ST NW',0,'WARREN','OH','44485','2024','CY','39155','1965-06-29','F','U',':RET:2106-3','N','021','DEN','3102735','99734OH005000301','2014-03-01','2014-02-06 17:37:26','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-06 21:01:16'),(23223,18513,'Y','18','021','EC','A','','','AC','0000923354','0000923354','OH00002730200','IL','1','Mansfield','Laura','','','','34','271682787','8710 Road 1-7',0,'Ottawa','OH','45875',NULL,'CY','39137','1961-02-24','F','M',':RET:2106-3','N','021','HLT','2780201','92036OH003001505','2014-03-01','2014-02-12 15:03:03','294.00',NULL,NULL,'468.87','174.87','R-OH002','OH0','468.87',NULL,0,'2014-02-12 21:32:20'),(25041,19858,'Y','18','024','14','A','','','TE','0001048041','0001048041','','IL','1','Zink','Eileen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-30','F','',NULL,NULL,NULL,'','2776656','','2014-02-20','2014-02-20 15:34:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 22:01:10'),(25104,19912,'Y','18','021','EC','A','','','AC','0000276627','0000276627','TX00003181113','IL','1','rayos','rosa','r','','','34','452949664','18660 sobrino dr',0,'tornillo','TX','79853',NULL,'CY','48141','1950-02-28','F','M',':RET:2106-3','N','021','DEN','3407052','33348TX002000201','2014-04-01','2014-02-21 14:00:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61','CIC',0,'2014-02-21 21:30:12'),(26703,21169,'Y','18','021','EC','A','','','AC','0001207210','0001207210','OH00002703424','IL','1','rivera','antonette','','','','34','282927234','12705 THRUSH ST',0,'LAKEWOOD','OH','44107','7221','CY','39035','1990-05-03','F','U',':RET:2106-3','T','021','HLT','3047333','52664OH152001001','2014-04-01','2014-02-27 23:30:42','0.00',NULL,NULL,'159.02','159.02','R-OH011','OH0','159.02',NULL,0,'2014-02-28 21:31:34'),(26783,21226,'Y','18','021','EC','A','','','AC','0000996574','0000996574','TX00002360371','IL','1','Polhemus','Mark','','','','34','467377176','2118 LANDCIRCLE CT',0,'SUGAR LAND','TX','77478','6018','CY','48157','1961-05-15','M','M',':RET:2106-3','N','021','DEN','3042158','33348TX002000201','2014-04-01','2014-03-01 11:18:01','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-01 21:00:14'),(26817,21252,'Y','18','021','EC','A','','','AC','0000902262','0000902262','OH00002138418','IL','1','POLISETTI','PURNA','','','','34','278158742','9220 WORTHINGTON RD',0,'WESTERVILLE','OH','43082',NULL,'CY','39041','1982-06-18','F','M',':RET:2029-7','N','021','DEN','2911974','99734OH005000401','2014-04-01','2014-02-28 23:50:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:32'),(27769,21959,'N','19','021','EC','A',NULL,NULL,'','0002389526','0001389556','','IL','1','SHELBY','KATIE','','','','34','439850073','8059 DIXIE BLANCHARD RD.',0,'TREEPORT','LA','71107',NULL,'CY','22017','1992-12-11','F','',NULL,'N','021','DEN','2922995','18575LA002000201','2014-04-01','2014-03-05 15:43:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-05 21:31:25'),(18659,14875,'Y','18','021','EC','A','','','AC','0000030986','0000030986','TX00001965141','IL','1','Morris','John','','','','34','462257181','6065 Montevista Ln',0,'Fort Worth','TX','76132',NULL,'CY','48439','1960-01-15','M','U',':RET:2106-3','N','021','DEN','1829382','33348TX002000201','2014-03-01','2014-01-16 14:31:22','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:13'),(14553,11612,'Y','18','021','EC','A','','','AC','0000961874','0000961874','OH00000691845','IL','1','Partin','Martha','Irene','','','34','278543587','799 FAIRWOOD RD',0,'AKRON','OH','44319','4760','CY','39153','1953-09-15','F','M',':RET:2106-3','N','021','HLT','2007118','52664OH152000901','2014-02-01','2013-12-27 11:19:14','600.00',NULL,NULL,'933.31','333.31','R-OH012','OH0','443.31',NULL,0,'2013-12-28 03:35:06'),(27045,21419,'N','19','021','EC','A',NULL,NULL,'','0000265305','0000885653','','S1','1','Drees','Richard','H','','','34','301087523','5831 MURNEN RD',0,'TOLEDO','OH','43623','1413','CY','39095','2004-07-22','M','',':RET:2106-3','N','021','HLT','3396980','92036OH005002601','2014-04-01','2014-03-03 11:30:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83','CIC',0,'2014-03-03 21:00:23'),(18103,14460,'N','19','021','EC','A',NULL,NULL,'','0001770496','0001370243','','IL','1','smith','shannah','','','','34','438834523','320 PRAIRIE RD',0,'COLUMBIA','LA','71418','3442','CY','22021','1992-01-19','F','',':RET:2106-3','N','021','DEN','1889268','18575LA002000201','2014-02-01','2014-01-14 16:42:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:34'),(17887,14286,'Y','18','021','EC','A','','','AC','0000519858','0000519858','OH00002326614','IL','1','Moxley','Candace','','','','34','297545870','1948 Cordova',0,'Cincinnati','OH','45239',NULL,'CY','39061','1953-11-11','F','U',':RET:2106-3','T','021','DEN','2743760','99734OH005000401','2014-02-01','2014-01-14 15:25:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:18'),(4231,3369,'Y','18','021','EC','A','','','AC','0000759645','0000759645','TX00000715239','IL','1','Li','edward','','','','34','452718528','25242 SPRING IRIS LN',0,'KATY','TX','77494','5580','CY','48157','1962-05-15','M','M',':RET:2034-7','N','021','DEN','1889593','33348TX002000201','2014-01-01','2013-12-17 13:03:46','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:50:43'),(3997,3192,'Y','18','024','14','A','','','TE','0001086762','0001086762','','IL','1','Cioffi','Nicholas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-08-30','M','',NULL,NULL,NULL,'','1215508','','2013-12-16','2013-12-16 18:39:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:06'),(1575,1315,'Y','18','021','EC','A','','','AC','0000990966','0000990966','TX00000707583','IL','1','COOPER','DAMON','','','','34','385887486','20903 HARVEST TERRACE LN',0,'SPRING','TX','77379',NULL,'CY','48201','1973-09-18','M','M',NULL,'N','021','DEN','1671507','33348TX002000201','2014-01-01','2013-12-24 10:24:16','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:51:18'),(5275,4181,'Y','18','021','EC','A','','','AC','0000812016','0000812016','OH00000001723','IL','1','BORES','MICHELLE','ANN','','','34','271807016','10134 WILLIAM HENRY DR',0,'STREETSBORO','OH','44241','5091','CY','39133','1966-12-06','F','M',NULL,'N','021','HLT','2120874','52664OH151001301','2014-01-01','2013-12-19 14:06:28','473.00',NULL,NULL,'845.87','372.87','R-OH012','OH0','348.56',NULL,0,'2013-12-25 23:05:37'),(3287,2650,'Y','18','021','EC','A','','','AC','0000671698','0000671698','OH00000597957','IL','1','Smith','Thomas','W','','','34','281743332','1071 E 98TH ST',0,'CLEVELAND','OH','44108','3343','CY','39035','1963-11-02','M','U',':RET:2054-5','N','021','DEN','2382360','99734OH005000301','2014-01-01','2013-12-21 23:33:13','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:15:24'),(19556,15589,'Y','18','021','EC','A','','','AC','0002076081','0002076081','LA00001724237','IL','1','MEDINE','DEBORAH','ANN','','','34','435907098','1809 S HOLMES AVE',0,'GONZALES','LA','70737',NULL,'CY','22005','1953-02-09','F','U',':RET:2106-3','N','021','DEN','2699966','18575LA002000101','2014-03-01','2014-01-22 11:31:28','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-23 03:02:31'),(21181,16927,'Y','18','021','EC','A','','','AC','0000995093','0000995093','MS00002123382','IL','1','GWYN','KEVIN','','','','34','412618465','2116 CUSTER DR',0,'SOUTHAVEN','MS','38671','5024','CY','28033','1982-11-19','M','M',':RET:2106-3','N','021','DEN','3064066','46300MS002000101','2014-03-01','2014-02-02 22:39:05','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2014-02-03 21:00:43'),(23240,18529,'Y','18','021','EC','A','','','AC','0000351611','0000351611','OH00001668687','IL','1','Procaccini','Brandon','','','','34','300768858','2240 S COUNTY ROAD 43',0,'REPUBLIC','OH','44867','9750','CY','39147','1978-03-13','M','M',':RET:2106-3','N','021','HLT','3442061','92036OH005002701','2014-03-01','2014-02-12 16:27:15','0.00',NULL,NULL,'598.82','598.82','R-OH006','OH0','238.27',NULL,0,'2014-02-12 21:32:31'),(24171,19203,'Y','18','021','EC','A','','','AC','0000326234','0000326234','OH00002702117','IL','1','Butler','Karen','','','','34','295549466','117 Timberhill Dr.',0,'Hamilton','OH','45013',NULL,'CY','39017','1953-11-28','F','U',':RET:2054-5','N','021','HLT','3288125','92036OH003001204','2014-03-01','2014-02-15 13:08:24','325.00',NULL,NULL,'608.42','283.42','R-OH004','OH0','608.42',NULL,0,'2014-02-15 22:02:09'),(24186,19213,'N','01','021','EC','A',NULL,NULL,'','0000841969','0001218590','','IL','1','Farr','Michael','H','','','34','374762557','507 bourbon st',0,'blanchester','OH','45107',NULL,'CY','39027','1960-09-17','M','',':RET:2106-3','T','021','HLT','3446831','92036OH005000606','2014-03-01','2014-02-15 18:25:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','503.62',NULL,0,'2014-02-16 19:00:11'),(25978,20603,'Y','18','021','EC','A','','','AC','0000823570','0000823570','OH00002441927','IL','1','heald','scott','','','','34','283924111','20901 CLUTTER RD',0,'UTICA','OH','43080','9609','CY','39083','1988-03-15','M','M',NULL,'N','021','DEN','3439684','99734OH005000401','2014-04-01','2014-02-26 16:27:19','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:50'),(27062,21426,'Y','18','021','EC','A','','','AC','0002165920','0002165920','LA00003421280','IL','1','Hart','Dionne','L','','','34','433299924','7001 BUNDY RD',0,'NEW ORLEANS','LA','70127','2166','CY','22071','1971-01-26','F','U',':RET:2054-5','N','021','DEN','3263346','18575LA002000201','2014-04-01','2014-03-03 09:01:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-03 21:30:00'),(28930,22895,'N','19','021','EC','A',NULL,NULL,'','0000701767','0000303432','','S1','1','Tepperman','Jonathan','','','','34','290152125','3021 WOODBINE PL',0,'COLUMBUS','OH','43202','1428','CY','39049','2009-12-17','M','',':RET:2106-3','N','021','DEN','4272007','99734OH005000301','2014-04-01','2014-03-10 13:47:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:36'),(13363,10673,'Y','18','021','EC','A','','','AC','0001126866','0001126866','OH00001113796','IL','1','Smith','Sara','','','','34','282667060','3289 KILDARE RD',0,'CLEVELAND HEIGHTS','OH','44118','2930','CY','39035','1959-07-28','F','U',':RET:2106-3','N','021','DEN','2310696','99734OH005000301','2014-01-01','2013-12-22 19:34:24','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:59:31'),(15792,12640,'Y','18','021','EC','A','','','AC','0001292246','0001292246','LA00001485245','IL','1','Dixon','Sean','','','','34','438598525','2900 HARRIS ST',0,'ALEXANDRIA','LA','71301','4325','CY','22079','1971-11-07','M','U',':RET:2054-5','N','021','DEN','2189691','18575LA002000201','2014-02-01','2014-01-02 14:47:33','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-03 02:02:32'),(7893,6242,'Y','18','021','EC','A','','','AC','0000689688','0000689688','OH00000968617','IL','1','McGuire','Susan','','','','34','268547597','1004 LONES DR',0,'PERRYSBURG','OH','43551','2332','CY','39173','1963-06-06','F','M',':RET:2106-3','N','021','HLT','1836189','92036OH005002601','2014-01-01','2013-12-20 15:11:38','500.00',NULL,NULL,'993.70','493.70','R-OH001','OH0','348.25',NULL,0,'2013-12-26 03:05:40'),(13280,10599,'Y','18','021','EC','A','','','AC','0000884845','0000884845','TX00001143800','IL','1','GUTIRREZ','CHRSTAL','','','','34','457733824','9405 N BENTSEN PALM DR',0,'MISSION','TX','78574','4247','CY','48215','1985-06-16','F','U',NULL,'N','021','DEN','2591443','33348TX002000201','2014-01-01','2013-12-23 13:02:08','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 12:57:10'),(4209,3348,'Y','18','021','EC','A','','','AC','0000321737','0000321737','TX00001286856','31','1','Munoz','Alexandria','Michelle','','','34','627323695','P.O. Box 1071',0,'Premont','TX','78375',NULL,'CY','48249','1992-08-19','F','U',':RET:2106-3','T','021','DEN','1437795','33348TX002000201','2014-01-01','2013-12-16 23:10:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:08'),(4188,3332,'Y','18','021','EC','A','','','AC','0000182277','0000182277','OH00000051396','IL','1','Bickerstaff','Karen','','','','34','302581856','1100 MERCER AVE',0,'AKRON','OH','44320','3646','CY','39153','1958-01-01','F','U',NULL,'N','021','HLT','1928797','52664OH151001305','2014-01-01','2013-12-17 14:01:00','345.00',NULL,NULL,'520.28','175.28','R-OH012','OH0','520.28',NULL,0,'2013-12-25 21:49:35'),(5079,4025,'Y','18','021','EC','A','','','AC','0000073886','0000073886','TX00000694975','IL','1','BENNIE','PATRICIA','','','','34','456909666','1406 WALNUT STREET',0,'BROWNWOOD','TX','76801',NULL,'CY','48049','1951-04-26','F','M',NULL,'N','021','DEN','2075831','33348TX002000201','2014-01-01','2013-12-19 13:53:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:54'),(3692,2954,'N','01','021','EC','A',NULL,NULL,'','0001056674','0000358306','','IL','1','GOODMAN','TERI','SUE','','','34','287567305','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1959-12-18','F','',':RET:2106-3','N','021','DEN','885503','99734OH005000401','2014-01-01','2013-12-13 10:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:31:45'),(21404,17106,'Y','18','024','14','A','','','TE','0000298268','0000298268','','IL','1','Weaver','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-12','F','',NULL,NULL,NULL,'','2734026','','2014-02-04','2014-02-04 13:56:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:04'),(22863,18238,'N','19','021','EC','A',NULL,NULL,'','0000520378','0000819287','','IL','1','MALLETT','BRIA','REANN','','','34','588054136','406 RIDGE PARK CV',0,'RAYMOND','MS','39154','9654','CY','28049','2007-12-24','F','',':RET:2054-5','N','021','DEN','2805096','46300MS002000201','2014-03-01','2014-02-11 12:16:19',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2014-02-11 21:02:26'),(24130,19179,'N','19','021','EC','A',NULL,NULL,'','0002157211','0002015336','','IL','1','Strohmeyer','Charles','Henry','','IV','34','438832362','110 EVANGELINE LN',0,'DESTREHAN','LA','70047','3045','CY','22089','1992-02-05','M','',':RET:2106-3','N','021','DEN','2932534','18575LA002000101','2014-03-01','2014-02-15 14:42:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-15 22:01:47'),(27857,22033,'Y','18','024','14','A','','','TE','0000062073','0000062073','','IL','1','CONNER','MARILYN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-20','F','',NULL,NULL,NULL,'','3842501','','2014-03-05','2014-03-05 17:08:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:32:16'),(28486,22539,'Y','18','021','EC','A','','','AC','0000726190','0000726190','OH00003590151','IL','1','Stanley','David','','','','34','292603437','840 High St',0,'Nelsonville','OH','45764',NULL,'CY','39009','1974-06-28','M','U',':RET:2106-3','T','021','DEN','3761422','99734OH005000301','2014-04-01','2014-03-07 15:52:10','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-03-07 21:31:38'),(163,137,'Y','18','021','EC','A','','','AC','0000983809','0000983809','OH00000867866','IL','1','Madaris','Shirley','','','','34','275524737','802 Vienna Woods',0,'cincenati','OH','45211',NULL,'CY','39061','1951-06-15','F','U',NULL,'N','021','HLT','1034489','92036OH004001201','2014-01-01','2013-12-04 19:08:24','367.00',NULL,NULL,'495.91','128.91','R-OH004','OH0','495.91',NULL,0,'2013-12-25 17:19:15'),(13976,11137,'Y','18','021','EC','A','','','AC','0000349262','0000349262','OH00000462543','IL','1','Davis','David','L','','','34','279567349','3941 MANTELL AVE',0,'CINCINNATI','OH','45236','1669','CY','39061','1960-12-03','M','M',NULL,'N','021','HLT','2052997','92036OH004001201','2014-01-01','2013-12-23 10:06:21','275.00',NULL,NULL,'352.13','77.13','R-OH004','OH0','352.13',NULL,0,'2013-12-26 13:15:29'),(7782,6162,'Y','18','021','EC','A','','','AC','0000242240','0000242240','TX00000159455','IL','1','Lenz','Carmen','','','','34','641081154','133 Alexandria',0,'La Vernia','TX','78121',NULL,'CY','48493','1965-05-18','F','U',':RET:2106-3','N','021','DEN','2551875','33348TX002000201','2014-01-01','2013-12-20 00:56:54','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 03:03:12'),(20607,16465,'Y','18','021','EC','A','','','AC','0000687246','0000687246','OH00001602685','IL','1','Morgan','Robin','','','','34','286680549','3021 CAVANAUGH AVE',0,'CINCINNATI','OH','45211','8024','CY','39061','1967-02-06','F','U',':RET:2054-5','N','021','DEN','3551128','99734OH005000401','2014-03-01','2014-01-30 14:27:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:15'),(21118,16873,'N','01','021','EC','A',NULL,NULL,'','0000041182','0001006939','','IL','1','Randolph','Terrel','M','','Sr','34','620073223','19002 KEMBLE RD',0,'HUMBLE','TX','77346','2621','CY','48201','1972-01-21','M','',':RET:2054-5','T','021','DEN','2772464','33348TX002000201','2014-03-01','2014-02-03 10:08:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-03 21:00:11'),(22703,18129,'Y','18','021','EC','A','','','AC','0000769712','0000769712','TX00001815490','IL','1','Rush','Joel','','','','34','460045281','14279 PECAN LN',0,'FORNEY','TX','75126','6842','CY','48257','1955-12-19','M','M',':RET:2106-3','N','021','DEN','3066918','33348TX002000101','2014-03-01','2014-02-11 16:08:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-11 21:01:00'),(25340,20105,'Y','18','021','EC','A','','','AC','0002177798','0002177798','LA00001692085','IL','1','BUSBY','CASSADEE','','','','34','438799059','114 CURRENT DR',0,'MONROE','LA','71203','9729','CY','22073','1990-10-01','F','U',':RET:2054-5','N','021','DEN','3355288','18575LA002000201','2014-04-01','2014-02-25 16:39:37','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-25 21:30:24'),(26535,21042,'Y','18','021','EC','A','','','AC','0000609594','0000609594','OH00003355566','IL','1','HOLLAND','JOMAILE','','','','34','577082592','6463 MAYFLOWER AVE',0,'CINCINNATI','OH','45237','4401','CY','39061','1983-04-30','F','U',NULL,'N','021','DEN','3071170','99734OH005000301','2014-04-01','2014-02-27 19:18:31','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:04'),(26969,21366,'N','01','021','EC','A',NULL,NULL,'','0000226169','0000780619','','IL','1','GHIRONTE','ILEANA','','','','34','645563218','504 Colesher St',0,'McKinney','TX','75069',NULL,'CY','48085','1974-07-15','F','',':RET:2106-3','N','021','DEN','2978031','33348TX002000101','2014-04-01','2014-03-01 23:23:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-03-03 01:00:34'),(27371,21674,'Y','18','021','EC','A','','','AC','0000890773','0000890773','MS00002356730','31','1','Gibson','Sheila','','','','34','587335049','PO Box 121',0,'Moorhead','MS','38761',NULL,'CY','28133','1966-02-08','F','U',':RET:2054-5','N','021','DEN','3887008','46300MS002000101','2014-04-01','2014-03-03 23:30:12','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-03-04 21:01:16'),(27493,21753,'Y','18','021','EC','A','','','AC','0000626794','0000626794','OH00003000317','IL','1','SOLOMON','LINDSAY','','','','34','288945533','426 WYANDOTTE TRL SW',0,'HARTVILLE','OH','44632','9419','CY','39151','1987-11-08','F','U',':RET:2106-3','N','021','HLT','3506332','52664OH151001305','2014-05-01','2014-03-04 12:12:50','100.00',NULL,NULL,'228.36','128.36','R-OH015','OH0','228.36',NULL,0,'2014-03-04 21:02:23'),(27633,21856,'N','19','021','EC','A',NULL,NULL,'','0000699334','0000741776','','IL','1','Chung','Wooyoung','','','','34','317113155','9424 EASTBROOK DR',0,'MIAMISBURG','OH','45342','7871','CY','39113','1992-03-13','M','',':RET:2040-4','N','021','DEN','3199599','99734OH005000401','2014-04-01','2014-03-05 09:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:11'),(27888,22061,'Y','18','021','EC','A','','','AC','0000055992','0000055992','OH00002815524','IL','1','lukasko','george','','','','34','278629201','1921 north albright mckay road',0,'brookfield','OH','44403',NULL,'CY','39155','1964-12-16','M','U',':RET:2106-3','N','021','HLT','3076552','92036OH003003206','2014-04-01','2014-03-05 12:53:08','358.00',NULL,NULL,'431.24','73.24','R-OH013','OH0','431.24',NULL,0,'2014-03-05 21:32:37'),(28280,22378,'N','01','021','EC','A',NULL,NULL,'','0000500463','0000226072','','IL','1','Cunningham','Karin','M','','','34','296905607','4643 BLUEJAY CT',0,'CINCINNATI','OH','45244','1178','CY','39025','1984-03-22','F','',':RET:2106-3','N','021','HLT','4242423','92036OH001000601','2014-04-01','2014-03-07 09:32:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.90','CIC',0,'2014-03-07 21:00:24'),(8821,6993,'Y','18','021','EC','A','','','AC','0001161914','0001161914','TX00000498591','IL','1','HAYNES','SHARON','','','','34','463275961','408 MARTIN ST',0,'BONHAM','TX','75418','2209','CY','48147','1962-06-15','F','M',NULL,'N','021','DEN','1935982','33348TX002000201','2014-01-01','2013-12-17 18:32:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:17'),(1185,976,'N','01','021','EC','A',NULL,NULL,'','0000985971','0000360984','','IL','1','RUTAN','DENISE','DIANE','','','34','290665148','21271 16 SCHOOL RD',0,'WELLSVILLE','OH','43968','9618','CY','39029','1964-01-09','F','',NULL,'T','021','DEN','16169','99734OH005000301','2014-01-01','2013-12-03 09:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:29'),(18379,14669,'Y','18','021','EC','A','','','AC','0000016639','0000016639','OH00002182078','IL','1','MCCALLISTER','DEBBIE','','','','34','280682843','319 township rd 1110',0,'PROCTORVILLE','OH','45669',NULL,'CY','39087','1959-09-16','F','U',':RET:2106-3','N','021','DEN','2651470','99734OH005000301','2014-02-01','2014-01-14 18:54:59','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-16 08:45:34'),(17743,14175,'Y','18','021','EC','A','','','AC','0000553936','0000553936','OH00001407306','IL','1','Horneck','David','','','','34','286589928','16610 CHATFIELD AVE',0,'CLEVELAND','OH','44111','4225','CY','39035','1963-06-17','M','U',NULL,'N','021','HLT','2689101','52664OH151001304','2014-02-01','2014-01-13 15:28:38','185.00',NULL,NULL,'449.21','264.21','R-OH011','OH0','449.21',NULL,0,'2014-01-14 01:33:23'),(17518,14005,'Y','18','024','14','A','','','TE','0000721360','0000721360','','IL','1','Mitchell','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-25','M','',NULL,NULL,NULL,'','1705471','','2014-01-12','2014-01-12 10:07:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:34'),(14917,11918,'Y','18','021','EC','A','','','AC','0000513342','0000513342','OH00000160977','IL','1','Intihar','Eric','','','','34','294889632','5611 RENWOOD DR',0,'PARMA','OH','44129','4023','CY','39035','1983-03-13','M','U',NULL,'N','021','DEN','1789800','99734OH005000401','2014-02-01','2013-12-29 11:07:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-30 00:01:34'),(15940,12761,'N','01','021','EC','A',NULL,NULL,'','0001016864','0000541654','','IL','1','Fishback','KRISTY','','','','34','283705847','1 ALLISON CT',0,'WILLIAMSBURG','OH','45176','9298','CY','39025','1964-12-01','F','',':RET:2106-3','N','021','HLT','1995400','92036OH005000606','2014-02-01','2014-01-02 13:38:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','366.23',NULL,0,'2014-01-03 02:07:10'),(20293,16198,'Y','18','021','EC','A','','','AC','0001878339','0001878339','LA00001756521','IL','1','BRUMFIELD','KONISHA','','','','34','436876712','21205 HIGHWAY 38',0,'KENTWOOD','LA','70444','5405','CY','22105','1983-08-24','F','U',':RET:2054-5','N','021','DEN','3121836','18575LA002000201','2014-03-01','2014-01-28 12:12:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-28 21:00:38'),(23191,18492,'Y','18','024','14','A','','','TE','0000321071','0000321071','','IL','1','frady','sherry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-02','F','',NULL,NULL,NULL,'','3392649','','2014-02-12','2014-02-12 15:19:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:32:04'),(23757,18909,'N','19','021','EC','A',NULL,NULL,'','0000661393','0000201962','','IL','1','Falck','Hannah','Marie','','','34','277986418','461 North Street',0,'Batavia','OH','45103',NULL,'CY','39025','1995-02-04','F','',':RET:2106-3','N','021','DEN','2834135','99734OH005000301','2014-03-01','2014-02-14 08:35:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:08'),(25821,20474,'Y','18','024','14','A','','','TE','0000187428','0000187428','','IL','1','Vaughn','Ieasha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-12-08','F','',NULL,NULL,NULL,'','504514','','2014-03-13','2014-02-26 16:23:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 21:00:26'),(28240,22345,'Y','18','024','14','A','','','TE','0000279607','0000279607','','IL','1','Bregitzer','Memphis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2007-10-24','M','',NULL,NULL,NULL,'','3057490','','2014-03-31','2014-03-07 10:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:10'),(20204,16121,'Y','18','021','EC','A','','','AC','0000498198','0000498198','OH00002193659','IL','1','Moeller','Ralph','','','','34','282549813','4146 ST RT 707',0,'Rockford','OH','45882',NULL,'CY','39107','1954-04-30','M','M',':RET:2106-3','T','021','HLT','1585152','92036OH002001501','2014-03-01','2014-01-27 10:26:17','790.00',NULL,NULL,'1256.95','466.95','R-OH002','OH0','760.83',NULL,0,'2014-01-27 21:01:34'),(13952,11123,'N','01','021','EC','A',NULL,NULL,'','0000196137','0001224462','','IL','1','Vogel','Joseph','A','','','34','283786682','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','1965-12-22','M','',':RET:2106-3','N','021','HLT','1462002','92036OH004000601','2014-01-01','2013-12-23 12:07:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','282.22',NULL,0,'2013-12-26 13:14:56'),(1247,1027,'Y','18','024','14','A','','','TE','0000834436','0000834436','','IL','1','McGarvey','Steve',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-06-23','M','',NULL,NULL,NULL,'','762262','','2013-12-03','2013-12-03 11:29:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:21:06'),(18346,14648,'N','19','021','EC','A',NULL,NULL,'','0000234068','0000057353','','IL','1','Damon','Gregory','','','','34','276967938','8068 Quail Meadow Lane',0,'West Chester','OH','45069',NULL,'CY','39017','1993-03-04','M','',':RET:2106-3','N','021','DEN','1469552','99734OH005000301','2014-02-01','2014-01-14 19:15:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:20'),(15297,12231,'Y','18','021','EC','A','','','AC','0001284858','0001284858','LA00001350181','IL','1','Mitchell','Patricia',NULL,NULL,NULL,NULL,NULL,'7516 Prairie Drive',0,'Greenwell Springs','LA','70739',NULL,'CY','22033','1973-10-06','F','M',':RET:2106-3','N','021','DEN','1373505','18575LA002000201','2014-02-01','2013-12-31 19:09:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:22:41'),(3500,2811,'Y','18','021','EC','A','','','AC','0000408475','0000408475','OH00000997944','IL','1','Brookover','Bryan','','','','34','287880978','1656 PEACH TREE DR',0,'LEBANON','OH','45036','9253','CY','39165','1985-10-31','M','U',':RET:2106-3','N','021','DEN','2593878','99734OH005000401','2014-01-01','2013-12-22 16:08:17','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:20:40'),(6899,5474,'Y','18','021','EC','A','','','AC','0001462800','0001462800','LA00001343347','IL','1','Olivers','Chanda','','','','34','086566538','205 BELLEVUE PLANTATION RD',0,'LAFAYETTE','LA','70503','6005','CY','22055','1970-11-08','F','U',':RET:2054-5','N','021','DEN','1967229','18575LA002000201','2014-01-01','2013-12-24 22:31:37','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 01:45:35'),(24055,19131,'N','19','021','EC','A',NULL,NULL,'','0000558192','0000242753','','IL','1','BEGLEY','JESSICA','','','','34','271047328','4238 WILLIAMSPORT DR',0,'BEAVERCREEK','OH','45430','1837','CY','39057','1998-11-11','F','',':RET:2106-3','N','021','DEN','3143301','99734OH005000301','2014-03-01','2014-02-14 20:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:07'),(24566,19509,'N','19','021','EC','A',NULL,NULL,'','0000737910','0000699324','','IL','1','grubb','brandon','','','','34','289028975','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1997-12-01','M','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:06:55'),(24996,19824,'N','01','021','EC','A',NULL,NULL,'','0000831683','0000830660','','IL','1','AGUIRRE','SERGIO','','','','34','645360050','305 E STOKES AVE',0,'MIDLAND','TX','79701','1924','CY','48329','1972-10-28','M','',':RET:2106-3','T','021','DEN','3711054','33348TX002000201','2014-04-01','2014-02-20 15:11:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 22:00:43'),(25673,20368,'Y','18','021','EC','A','','','AC','0000671752','0000671752','OH00002045727','IL','1','LEE','BONNIE','','','','34','272529176','7950 STATE ROUTE 161',0,'MECHANICSBURG','OH','43044','9769','CY','39021','1951-10-31','F','M',NULL,'N','021','HLT','3641123','92036OH003000504','2014-04-01','2014-02-22 11:47:23','494.00',NULL,NULL,'713.19','219.19','R-OH003','OH0','713.19',NULL,0,'2014-02-26 08:30:53'),(26620,21107,'Y','18','021','EC','A','','','AC','0001192988','0001192988','TX00003417342','IL','1','Caceres','Maria','Erma','','','34','464897575','PO BOX 251',0,'Trinity','TX','75862',NULL,'CY','48455','1959-02-10','F','U',':RET:2106-3','N','021','DEN','3359383','33348TX002000201','2014-03-01','2014-02-28 11:53:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:51'),(27431,21710,'Y','18','021','EC','A','','','AC','0001402650','0001402650','LA00002751472','IL','1','Washington','Regina','','','','34','384908103','626 DAMAKA DR',0,'SHREVEPORT','LA','71106','4002','CY','22017','1973-12-03','F','U',':RET:2054-5','N','021','DEN','3974306','18575LA002000201','2014-04-01','2014-03-04 12:55:35','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-04 21:01:46'),(28847,22827,'Y','18','021','EC','A','','','AC','0000699339','0000699339','OH00003843748','IL','1','Bellmore-Reeves','Diane','Lynn','','','34','292503283','2328 Mellwood Ave',0,'Toledo','OH','43613',NULL,'CY','39095','1951-03-18','F','M',':RET:2106-3','N','021','HLT','3464864','92036OH005002601','2014-04-01','2014-03-09 14:11:31','156.00',NULL,NULL,'575.62','419.62','R-OH001','OH0','575.62',NULL,0,'2014-03-09 21:01:15'),(20261,16168,'N','19','021','EC','A',NULL,NULL,'','0000768911','0000475005','','IL','1','Wood','Elijah',NULL,NULL,NULL,NULL,NULL,'1434 HARVARD BLVD',0,'DAYTON','OH','45406','5960','CY','39113','2004-07-31','M','',':RET:2054-5','N','021','DEN','2111747','99734OH005000301','2014-03-01','2014-01-27 22:50:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-28 21:00:19'),(280,231,'Y','18','021','EC','A','','','AC','0000258112','0000258112','OH00000107708','IL','1','Eaton','Susan','','','','34','369660017','3339 DRUMMOND RD',0,'TOLEDO','OH','43606','1672','CY','39095','1956-08-13','F','U',NULL,'N','021','HLT','354090','92036OH002002601','2014-01-01','2013-10-12 07:40:54','0.00',NULL,NULL,'548.79','548.79','R-OH001','OH0','548.79',NULL,0,'2013-12-25 17:30:16'),(19841,15824,'Y','18','021','EC','A','','','AC','0001869501','0001869501','LA00002375803','IL','1','LIETEAU','SANDRA','L','','','34','438927748','1414 TITA ST',0,'NEW ORLEANS','LA','70114','3128','CY','22071','1954-08-06','F','U',':RET:2054-5','N','021','DEN','3393566','18575LA002000201','2014-03-01','2014-01-24 12:38:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-24 21:00:25'),(1801,1479,'Y','18','021','EC','A','','','AC','0000057334','0000057334','OH00001220827','IL','1','Meyer','Tammy','','','','34','267453674','3923 OLDE SAVANNAH DR',0,'CINCINNATI','OH','45247','2100','CY','39061','1967-07-11','F','U',NULL,'N','021','HLT','1638586','92036OH004001201','2014-01-01','2013-12-24 08:07:04','0.00',NULL,NULL,'258.91','258.91','R-OH004','OH0','258.91',NULL,0,'2013-12-25 18:56:46'),(18191,14523,'Y','18','021','EC','A','','','AC','0000729995','0000729995','OH00001488188','IL','1','Alicea','Anthony','Philip','','','34','277884871','171 EATON RIDGE DR',0,'SAGAMORE HILLS','OH','44067','1573','CY','39153','1980-03-06','M','M',':RET:2054-5','N','021','HLT','2722660','52664OH151001501','2014-02-01','2014-01-14 13:18:43','0.00',NULL,NULL,'490.26','490.26','R-OH012','OH0','320.42',NULL,0,'2014-01-15 02:08:04'),(5084,4029,'Y','18','024','14','A','','','TE','0000685279','0000685279','','IL','1','Mireles','Andres',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-02-05','M','',NULL,NULL,NULL,'','938393','','2013-12-19','2013-12-19 14:25:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:01'),(14508,11574,'Y','18','021','EC','A','','','AC','0000576274','0000576274','TX00001247379','31','1','Morales','Glenda','','','','34','633181353','PO Box 995',0,'Seadrift','TX','77983',NULL,'CY','48057','1990-09-09','F','U',NULL,'N','021','DEN','1826313','33348TX002000201','2014-02-01','2013-12-27 15:31:35','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-28 03:33:58'),(25983,20606,'Y','18','024','14','A','','','TE','0000733653','0000733653','','IL','1','Thompson','Desirae',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-10','F','',NULL,NULL,NULL,'','2768909','','2014-02-26','2014-02-26 16:38:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:01:52'),(26380,20927,'Y','18','024','14','A','','','TE','0001747612','0001747612','','IL','1','Bates','Dorey','Lee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-02','F','',NULL,NULL,NULL,'','1970770','','2014-03-31','2014-02-26 13:32:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:00:19'),(26910,21328,'Y','18','021','EC','A','','','AC','0001560162','0001560162','LA00002599238','IL','1','Rice','Norah','','','','34','439869180','4859 Tchoupitoulas St.',0,'New Orleans','LA','70115',NULL,'CY','22071','1953-06-20','M','U',':RET:2054-5','N','021','DEN','3063727','18575LA002000201','2014-04-01','2014-03-02 15:06:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-03 01:00:12'),(27195,21533,'Y','18','021','EC','A','','','AC','0000232122','0000232122','TX00002773286','31','1','MAQUEDA','ELIZABETH','','','','34','627228092','P.O. BOX 16',0,'MERETA','TX','76940',NULL,'CY','48451','1987-10-20','F','U',NULL,'N','021','DEN','3826061','33348TX002000201','2014-04-01','2014-03-03 16:25:19','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-03-03 21:31:18'),(176,145,'N','01','021','EC','A',NULL,NULL,'','0000876028','0001029334','','IL','1','sullivan','amy','','','','34','286881950','7706 Norwalk Rd',0,'Medina','OH','44256',NULL,'CY','39103','1977-09-27','F','',NULL,'N','021','HLT','547990','52664OH151001306','2014-01-01','2013-12-05 09:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','274.30',NULL,0,'2013-12-25 17:19:33'),(13371,10680,'N','19','021','EC','A',NULL,NULL,'','0000636002','0000575919','','IL','1','Szilagyi','Eamon','Michael Sullivan','','','34','242997669','18800 State Route 47 East',0,'Sidney','OH','45365',NULL,'CY','39149','2002-05-14','M','',':RET:2106-3','N','021','DEN','2046709','99734OH005000301','2014-01-01','2013-12-22 21:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:46'),(13029,10385,'N','01','021','EC','A',NULL,NULL,'','0000884211','0000242709','','IL','1','Haynes','Alexa','May','','','34','310983353','811 Belrock Ave',0,'Belpre','OH','45714',NULL,'CY','39167','1983-04-03','F','',':RET:2106-3','N','021','DEN','1956668','99734OH005000401','2014-01-01','2013-12-22 22:25:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:18'),(19745,15737,'Y','18','021','EC','A','','','AC','0000047287','0000047287','TX00001789962','IL','1','GONZALEZ','GERARDO','','','Sr','34','467414537','425 CAYMAN CT',0,'LAREDO','TX','78045',NULL,'CY','48479','1951-10-13','M','M',':RET:2106-3','N','021','DEN','1783951','33348TX002000101','2014-03-01','2014-01-22 22:06:20','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-01-23 21:01:14'),(22686,18116,'Y','18','021','EC','A','','','AC','0000071819','0000071819','TX00002076847','IL','1','Sweely','Wayne','','','','34','301546496','801 Pampa St',0,'Sulphur Springs','TX','75482',NULL,'CY','48223','1959-12-03','M','M',':RET:2106-3','N','021','DEN','3259488','33348TX002000201','2014-03-01','2014-02-11 17:59:04','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:50'),(24067,19139,'Y','18','021','EC','A','','','AC','0001135198','0001135198','OH00002744023','IL','1','Williams','Ryan','','','','34','276923551','249 CENTER RD',0,'BEDFORD','OH','44146','2732','CY','39035','1988-09-06','M','U',':RET:2054-5','N','021','HLT','2933517','92036OH003000805','2014-03-01','2014-02-14 22:58:09','121.00',NULL,NULL,'245.14','124.14','R-OH011','OH0','245.14',NULL,0,'2014-02-15 22:01:13'),(24883,19730,'Y','18','024','14','A','','','TE','0001059504','0001059504','','IL','1','DELLIFANTI','CAROL','JOYCE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-22','F','',NULL,NULL,NULL,'','1937320','','2014-03-31','2014-02-19 12:49:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:37:02'),(26778,21222,'Y','18','021','EC','A','','','AC','0000217558','0000217558','TX00001984896','IL','1','SARGEANT','RANDOLPH','','','','34','093582600','246 RANCHVIEW DR',0,'GRAND PRAIRE','TX','75052',NULL,'CY','48439','1950-02-12','M','U',':RET:2054-5','N','021','DEN','3304285','33348TX002000201','2014-03-01','2014-02-28 22:23:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-01 21:00:11'),(27101,21453,'N','01','021','EC','A',NULL,NULL,'','0001055377','0000585590','','IL','1','Wright','James','Lewis','','','34','301801273','1845 BEECH RD',0,'STOW','OH','44224','3912','CY','39153','1969-04-24','M','',':RET:2106-3','N','021','DEN','2943336','99734OH005000301','2014-04-01','2014-03-03 07:27:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:21'),(28860,22838,'Y','18','024','14','A','','','TE','0001840095','0001840095','','IL','1','Stevens','LeeAnna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-05-23','F','',NULL,NULL,NULL,'','3282983','','2014-03-31','2014-03-09 13:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-09 21:30:03'),(19414,15478,'Y','18','021','EC','A','','','AC','0000464782','0000464782','MS00001986674','IL','1','TRUONG','TIM','','','','34','586149826','6660 CORTEZ CIR',0,'OCEAN SPRINGS','MS','39564','2323','CY','28059','1968-06-01','M','M',':RET:2047-9','N','021','DEN','1965004','46300MS002000201','2014-03-01','2014-01-21 11:58:24','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,1,'2014-01-22 03:22:59'),(13207,10539,'Y','18','021','EC','A','','','AC','0000135129','0000135129','TX00000585236','IL','1','Brown','Rosalind','','','','34','506964704','PO Box 803645',0,'Dallas','TX','75380',NULL,'CY','48113','1962-05-29','F','R',':RET:2054-5','N','021','DEN','1826140','33348TX002000101','2014-01-01','2013-12-23 18:12:37','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:55:08'),(7991,6325,'N','19','021','EC','A',NULL,NULL,'','0000563130','0000920798','','IL','1','Hockstra','Clara','','','','34','636957151','3170 BENT OAK TRL',0,'RAVENNA','OH','44266','8285','CY','39133','2013-04-06','F','',NULL,'N','021','HLT','2591260','52664OH151001304','2014-01-01','2013-12-20 15:06:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 03:08:10'),(7312,5795,'Y','18','021','EC','A','','','AC','0000600781','0000600781','OH00000561736','IL','1','Bennett','Donald','','','','34','289523264','3452 VERNON ST NW',0,'BURGHILL','OH','44404','9704','CY','39155','1951-12-05','M','M',':RET:2106-3','N','021','HLT','795079','92036OH005003201','2014-01-01','2013-12-14 00:09:37','626.00',NULL,NULL,'1312.15','686.15','R-OH013','OH0','695.41',NULL,0,'2013-12-26 02:03:22'),(17485,13980,'Y','18','021','EC','A','','','AC','0000744072','0000744072','TX00001410772','IL','1','Baker','Laurie','','','','34','439151826','20214 RAINGATE LN',0,'KATY','TX','77449','3103','CY','48201','1960-10-12','F','U',':RET:2106-3','N','021','DEN','2054763','33348TX002000201','2014-02-01','2014-01-12 15:27:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 03:01:15'),(15709,12567,'N','19','021','EC','A',NULL,NULL,'','0000433900','0000350583','','IL','1','NING','JOHN','','','','34','290941157','110 CREEKSIDE DR',0,'MAPLE HEIGHTS','OH','44137','4780','CY','39035','1991-11-18','M','',NULL,'N','021','HLT','1792571','92036OH003000805','2014-02-01','2013-12-31 14:44:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','244.15',NULL,1,'2014-01-02 04:36:01'),(6231,4939,'Y','18','021','EC','A','','','AC','0000332884','0000332884','TX00000935069','IL','1','CANTU','DAVID','','','Jr','34','460833002','407 RESURRECTION',0,'SAN ANTONIO','TX','78227',NULL,'CY','48029','1983-08-12','M','U',NULL,'N','021','DEN','851097','33348TX002000101','2014-01-01','2013-11-19 10:25:28','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 00:31:27'),(4071,3253,'Y','18','021','EC','A','','','AC','0000132057','0000132057','OH00000320495','IL','1','Thornton','Bernice','','','','34','298583609','728 CLARK ST',0,'CINCINNATI','OH','45203','3101','CY','39061','1959-02-02','F','U',':RET:2054-5','N','021','DEN','1456336','99734OH005000401','2014-01-01','2013-12-17 17:36:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:55'),(15368,12292,'Y','18','021','EC','A','','','AC','0000711380','0000711380','OH00000492614','IL','1','Philpot','Evonne','','','','34','270881524','6054 HILL AVE',0,'MIAMISBURG','OH','45342','5159','CY','39113','1977-11-19','F','M',':RET:2106-3','N','021','DEN','2559858','99734OH005000301','2014-02-01','2014-01-01 15:11:33','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,1,'2014-01-02 04:24:59'),(4022,3211,'N','01','021','EC','A',NULL,NULL,'','0000607139','0000633725','','IL','1','ruggles','lynne','elizabeth','','','34','271582392','3830 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9575','CY','39123','1962-04-26','F','',':RET:2106-3','N','021','DEN','2168737','99734OH005000401','2014-01-01','2013-12-17 08:39:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:41'),(20436,16323,'Y','18','021','EC','A','','','AC','0001135205','0001135205','OH00001365129','IL','1','SMITH','CHARLOTTE','','','','34','282527820','231 COUNTY ROAD 281',0,'SULLIVAN','OH','44880',NULL,'CY','39005','1951-08-22','F','M',':RET:2106-3','N','021','DEN','2951254','99734OH005000301','2014-03-01','2014-01-29 17:06:09','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-29 21:00:38'),(22407,17891,'Y','18','021','EC','A','','','AC','0001971978','0001971978','LA00002206271','31','1','Talbot','Casey','','','','34','433836487','Po box 41459',0,'baton rouge','LA','70835',NULL,'CY','22063','1991-08-19','F','U',':RET:2106-3','T','021','DEN','3616848','18575LA002000201','2014-03-01','2014-02-09 22:07:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 21:30:23'),(23897,19009,'Y','18','021','EC','A','','','AC','0001249626','0001249626','OH00002138048','IL','1','SANCHEZ','KELLY','J','','','34','295685673','408 S OHIO AVE',0,'SIDNEY','OH','45365',NULL,'CY','39149','1962-07-19','F','U',':RET:2106-3','T','021','HLT','2973325','92036OH005000505','2014-03-01','2014-02-14 17:37:20','378.00',NULL,NULL,'509.84','131.84','R-OH003','OH0','509.84',NULL,0,'2014-02-14 21:32:21'),(25525,20250,'N','19','021','EC','A',NULL,NULL,'','0001220886','0000560599','','S1','1','PLATTENBURG','EVA','','','','34','301980219','54 FLEMING RD',0,'CINCINNATI','OH','45215','2644','CY','39061','1996-05-15','M','',NULL,'N','021','HLT','3737360','92036OH004001201','2014-04-01','2014-02-25 16:24:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-25 21:32:09'),(26315,20877,'N','19','021','EC','A',NULL,NULL,'','0000282072','0000141562','','IL','1','York','Rebecca','','','','34','295947726','2494 HEROLD RD',0,'BATAVIA','OH','45103','2102','CY','39025','1992-03-12','F','',':RET:2106-3','N','021','HLT','3817057','92036OH006000601','2014-04-01','2014-02-27 16:25:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','170.24',NULL,0,'2014-02-28 06:31:35'),(15819,12663,'N','01','021','EC','A',NULL,NULL,'','0000115503','0001175720','','IL','1','Demoulin','Yves','','','','34','135487516','2925 Kerrwood Dr.',0,'Columbus','OH','43231',NULL,'CY','39049','1954-10-02','M','',':RET:2106-3','N','021','DEN','1808624','99734OH005000401','2014-02-01','2014-01-02 12:01:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:03:28'),(15261,12199,'Y','18','024','14','A','','','TE','0000519800','0000519800','','IL','1','longworth','maureen','a',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-13','F','',NULL,NULL,NULL,'','408297','','2013-12-30','2013-12-30 15:14:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:09:16'),(14962,11959,'Y','18','021','EC','A','','','AC','0000836376','0000836376','TX00001250049','IL','1','Autrey','Danielle','','','','34','628340068','731 High Point Drive',0,'Midlothian','TX','76065',NULL,'CY','48139','1992-11-02','F','U',':RET:2106-3','N','021','DEN','1545139','33348TX002000201','2014-02-01','2013-12-30 10:56:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:33'),(14847,11855,'Y','18','021','EC','A','','','AC','0001020421','0001020421','OH00000475795','IL','1','Schneider','Kevin','','','','34','289945028','15175 KRUSE RD',0,'WAPAKONETA','OH','45895','9518','CY','39011','1992-01-28','M','U',NULL,'N','021','HLT','2289281','92036OH005001501','2014-01-01','2013-12-23 20:54:23','32.00',NULL,NULL,'220.08','188.08','R-OH002','OH0','220.08',NULL,1,'2013-12-29 11:14:59'),(7831,6202,'N','01','021','EC','A',NULL,NULL,'','0000733581','0000156929','','IL','1','DZIAK','CONNIE','','','','34','283669859','2899 C.R. 195',0,'CLYDE','OH','43410',NULL,'CY','39143','1962-02-17','F','',':RET:2106-3','N','021','DEN','2025757','99734OH005000301','2014-01-01','2013-12-19 20:05:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:25'),(5111,4050,'Y','18','021','EC','A','','','AC','0000038313','0000038313','TX00000215247','IL','1','Doucet','Geraldine','','','','34','438922709','4023 OLD PINE GROVE DR',0,'HUMBLE','TX','77346','3240','CY','48201','1951-07-22','F','U',':RET:2054-5','N','021','DEN','1693024','33348TX002000201','2014-01-01','2013-12-19 18:03:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:01:41'),(6340,5024,'Y','18','021','EC','A','','','AC','0001008928','0001008928','OH00000243045','IL','1','Gunnell','Deborah','','','','34','281466067','3630 Sterling Park Circle',0,'Grove City','OH','43123',NULL,'CY','39049','1950-08-24','F','U',':RET:2106-3','T','021','DEN','1017503','99734OH005000401','2014-01-01','2013-12-11 12:11:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:45'),(20517,16393,'Y','18','021','EC','A','','','AC','0000307828','0000307828','TX00002336343','IL','1','whitaker','alvin','','','','34','509869848','4802 66th st',0,'Lubbock','TX','79414',NULL,'CY','48303','1978-10-23','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','2700098','33348TX002000101','2014-03-01','2014-01-28 22:58:11','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2014-01-29 21:01:22'),(20767,16591,'Y','18','021','EC','A','','','AC','0000128106','0000128106','OH00002369808','IL','1','QUINCY','JAMES','','','','34','365804561','19425 VAN AKEN BLV.',0,'SHAKER HEIGHTS','OH','44122',NULL,'CY','39035','1967-06-12','M','U',NULL,'N','021','HLT','3584690','92036OH002000801','2014-03-01','2014-01-30 14:23:41','0.00',NULL,NULL,'404.99','404.99','R-OH011','OH0','404.99',NULL,0,'2014-01-30 21:01:37'),(21886,17475,'Y','18','021','EC','A','','','AC','0001261241','0001261241','OH00002002933','IL','1','Jacob','Robyn','','','','34','271560259','7713 REMINGTON RD',0,'MONTGOMERY','OH','45242','7101','CY','39061','1954-09-02','F','U',':RET:2106-3','N','021','HLT','2939091','92036OH002001201','2014-03-01','2014-02-06 15:16:23','342.00',NULL,NULL,'645.32','303.32','R-OH004','OH0','645.32',NULL,0,'2014-02-06 21:01:34'),(22370,17865,'Y','18','024','14','A','','','TE','0000300124','0000300124','','IL','1','Aziz','Sikander',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-29','M','',NULL,NULL,NULL,'','2526649','','2014-02-28','2014-02-10 15:13:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-10 21:00:13'),(23581,18787,'N','01','021','EC','A',NULL,NULL,'','0000569363','0000439451','','IL','1','bucher','cynthia','a','','','34','270664037','2222 TRAPPERS KNOLL DR',0,'BATAVIA','OH','45103','2656','CY','39025','1957-12-29','F','',':RET:2106-3','N','021','HLT','3720006','92036OH004000601','2014-03-01','2014-02-13 13:00:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','402.70',NULL,0,'2014-02-13 22:02:57'),(24851,19701,'N','01','021','EC','A',NULL,NULL,'','0000214713','0000392413','','IL','1','Weber','Diane','','','','34','293423090','9470 BENCHMARK LN',0,'BLUE ASH','OH','45242','6004','CY','39061','1953-01-13','F','',':RET:2106-3','N','021','HLT','2699454','92036OH005001201','2014-04-01','2014-02-19 14:28:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2014-02-20 04:55:28'),(25477,20213,'Y','18','021','EC','A','','','AC','0000564255','0000564255','OH00003204661','IL','1','huber','kevin','','','','34','293742306','6151 agerter rd',0,'lima','OH','45806',NULL,'CY','39003','1965-07-22','M','M',':RET:2106-3','N','021','HLT','3015856','92036OH006001501','2014-04-01','2014-02-24 18:37:25','157.00',NULL,NULL,'285.38','128.38','R-OH002','OH0','285.38',NULL,0,'2014-02-25 21:31:41'),(27352,21660,'Y','18','024','14','A','','','TE','0000102817','0000102817','','IL','1','everage','karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-17','F','',NULL,NULL,NULL,'','2176825','','2014-03-19','2014-03-04 13:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-04 21:01:06'),(15915,12743,'N','01','021','EC','A',NULL,NULL,'','0000797000','0000380491','','IL','1','geloach','ruth','','','','34','419374585','286 fm1696 rd west',0,'huntsville','TX','77320',NULL,'CY','48471','1983-07-20','F','',':RET:2106-3','N','021','DEN','2537657','33348TX002000101','2014-02-01','2014-01-02 18:19:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-03 02:06:27'),(2294,1870,'Y','18','021','EC','A','','','AC','0001139484','0001139484','OH00000904729','IL','1','Thompson','Megan','','','','34','297769009','2820 GRANDIN HOLLOW LN',0,'CINCINNATI','OH','45208','3315','CY','39061','1976-09-14','F','R',':RET:2106-3','N','021','DEN','6540','99734OH005000301','2014-01-01','2013-12-09 16:04:08','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:52'),(3031,2437,'N','01','021','EC','A',NULL,NULL,'','0000728680','0000600769','','IL','1','Barrera','Joe','S','','','34','299540278','8351 DORR ST',0,'TOLEDO','OH','43617','1732','CY','39095','1956-09-15','M','',':RET:2106-3','N','021','HLT','1153011','92036OH004002601','2014-01-01','2013-12-05 22:35:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.11',NULL,0,'2013-12-25 20:18:24'),(14208,11330,'Y','18','021','EC','A','','','AC','0000043445','0000043445','TX00001679836','IL','1','arnold','james','','','','34','454238704','2115 hwy 80 east',0,'mesquite','TX','75710',NULL,'CY','48423','1957-12-10','M','U',':RET:2106-3','N','021','DEN','1641246','33348TX002000201','2014-02-01','2013-12-26 14:32:53','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-27 02:04:25'),(4175,3324,'Y','18','024','14','A','','','TE','0000575887','0000575887','','IL','1','Kim','Suzanne','Lynn',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-14','F','',NULL,NULL,NULL,'','619214','','2013-12-16','2013-12-16 19:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:49:20'),(14398,11481,'Y','18','024','14','A','','','TE','0000777644','0000777644','','IL','1','hannah','sheryl',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-12','F','',NULL,NULL,NULL,'','658395','','2013-12-27','2013-12-27 16:01:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:31:07'),(13129,10471,'Y','18','024','14','A','','','TE','0000803719','0000803719','','IL','1','BOCKIE','ABBUL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-30','M','',NULL,NULL,NULL,'','1858314','','2013-12-23','2013-12-23 14:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:52:58'),(8159,6455,'Y','18','021','EC','A','','','AC','0000012398','0000012398','OH00000674367','IL','1','Olmstead','Deborah','','','','34','283602010','1901 LOGAN AVE',0,'FINDLAY','OH','45840','1621','CY','39063','1970-03-14','F','M',':RET:2106-3','N','021','HLT','481187','92036OH004001501','2014-01-01','2013-11-22 12:57:37','0.00',NULL,NULL,'737.43','737.43','R-OH002','OH0','240.14',NULL,0,'2013-12-26 03:16:18'),(7192,5699,'N','01','021','EC','A',NULL,NULL,'','0000714953','0000064869','','IL','1','Estevez Martinez','Celeste','','','','34','605996098','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1982-10-12','F','',':RET:2106-3','N','021','DEN','166636','99734OH005000301','2014-01-01','2013-12-14 13:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:26'),(7210,5714,'Y','18','021','EC','A','','','AC','0001235156','0001235156','OH00001148413','IL','1','Miller','Katrina','','','','34','284861346','329 RAWLINGS ST',0,'WASHINGTON COURT HOUSE','OH','43160','1420','CY','39047','1987-02-10','F','U',':RET:2106-3','N','021','DEN','1204584','99734OH005000401','2014-01-01','2013-12-14 00:17:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:00:54'),(21496,17174,'N','19','021','EC','A',NULL,NULL,'','0000639560','0000055958','','IL','1','ON','JOY','','','','34','283112440','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','2005-07-06','F','',NULL,'N','021','HLT','3733016','92036OH003001204','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-04 21:01:49'),(23437,18670,'Y','18','021','EC','A','','','AC','0000783014','0000783014','TX00001568332','IL','1','SIEGER','ELIZABETH','ANN','','','34','466777111','6870 W MILITARY RD',0,'MISSION','TX','78572','1418','CY','48215','1984-09-21','F','U',':RET:2106-3','N','021','DEN','2797702','33348TX002000201','2014-03-01','2014-02-13 11:00:27','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-13 22:01:30'),(25884,20524,'Y','18','021','EC','A','','','AC','0000105192','0000105192','TX00003326547','IL','1','STANLEY','MIKE','J','','','34','454359657','1007 W 12TH ST',0,'CISCO','TX','76437','3708','CY','48133','1963-07-26','M','M',':RET:2106-3','N','021','DEN','2840567','33348TX002000201','2014-04-01','2014-02-26 10:43:02','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:00'),(28166,22289,'Y','18','021','EC','A','','','AC','0000149183','0000149183','LA00003412889','IL','1','Mayfield','LaKitta','Marie','','','34','435675501','213 MAGNOLIA RIDGE RD',0,'BOUTTE','LA','70039','3215','CY','22089','1977-11-15','F','U',':RET:2054-5','N','021','DEN','3698588','18575LA002000101','2014-04-01','2014-03-06 11:51:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-06 21:02:45'),(15670,12536,'N','19','021','EC','A',NULL,NULL,'','0000910535','0000898464','','S3','1','Ayers','Deziree',NULL,NULL,NULL,NULL,NULL,'1802 Rosewood Drive',0,'Wapakoneta','OH','45895',NULL,'CY','39011','2003-01-24','M','',':RET:2106-3','N','021','HLT','1392798','92036OH004001501','2014-02-01','2013-12-31 08:35:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,1,'2014-01-02 04:34:41'),(14503,11570,'Y','18','021','EC','A','','','AC','0000879005','0000879005','TX00000483095','IL','1','Barron','Aracely','','','','34','631141867','1411 BOB HOPE DR',0,'EL PASO','TX','79936','0427','CY','48141','1976-07-13','F','U',':RET:2106-3','N','021','DEN','2501019','33348TX002000201','2014-02-01','2013-12-27 14:32:30','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-28 03:33:50'),(13749,10975,'Y','18','021','EC','A','','','AC','0001095656','0001095656','OH00000495111','IL','1','EACHUS','THOMAS','','','','34','270828290','124 GEIGER ST',0,'BLUFFTON','OH','45817','1412','CY','39003','1973-12-03','M','M',NULL,'N','021','HLT','2010668','92036OH004001501','2014-01-01','2013-12-23 13:35:06','440.60',NULL,NULL,'443.84','3.24','R-OH002','OH0','226.17',NULL,0,'2013-12-26 13:09:54'),(13572,10825,'Y','18','021','EC','A','','','AC','0001354828','0001354828','LA00001021425','IL','1','Allen','Eugene','','','','34','438945303','62007 HOLLIS LESLIE RD',0,'ANGIE','LA','70426','2139','CY','22117','1953-01-31','M','M',':RET:2054-5','N','021','DEN','2322902','18575LA002000201','2014-01-01','2013-12-23 17:12:30','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:42'),(9561,7579,'Y','18','021','EC','A','','','AC','0000013769','0000013769','OH00001017567','IL','1','Buller','Suely','','','','34','505113140','1329 Apache Trail',0,'Stow','OH','44224',NULL,'CY','39153','1954-02-25','F','M',':RET:2106-3','N','021','DEN','2324250','99734OH005000301','2014-01-01','2013-12-21 16:03:13','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:36:34'),(2632,2140,'Y','18','021','EC','A','','','AC','0000133282','0000133282','OH00000561378','IL','1','Wood-Andersen','Mary','','','','34','267577232','2224 BRIARHURST LN',0,'COLUMBUS','OH','43220','2304','CY','39049','1960-08-23','F','U',':RET:2106-3','N','021','DEN','778756','99734OH005000401','2014-01-01','2013-12-02 13:10:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:09'),(14196,11321,'Y','18','021','EC','A','','','AC','0000649712','0000649712','TX00001468793','IL','1','Perez','Yesenia','','','','34','622461871','213 W 11TH ST',0,'MULESHOE','TX','79347','3232','CY','48017','1991-01-12','F','U',NULL,'N','021','DEN','2133561','33348TX002000201','2014-02-01','2013-12-26 13:07:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:04:08'),(8864,7028,'Y','18','021','EC','A','','','AC','0000641269','0000641269','TX00000925101','IL','1','Robinson','Wilmer','','','','34','450884991','1511 OAK GLEN TRL',0,'DALLAS','TX','75232','3732','CY','48113','1950-12-14','M','M',':RET:2054-5','N','021','DEN','2453940','33348TX002000201','2014-01-01','2013-12-18 12:42:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:01:22'),(13085,10432,'Y','18','021','EC','A','','','AC','0000889606','0000889606','OH00001051682','IL','1','Fleenor','Billy','Wayne','','Jr','34','290969207','6221 beaverlake drive',0,'grove city','OH','43123',NULL,'CY','39049','1993-12-02','M','R',':RET:2106-3','N','021','DEN','1839258','99734OH005000401','2014-01-01','2013-12-23 11:13:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-26 12:51:41'),(27678,21891,'Y','18','021','EC','A','','','AC','0000304351','0000304351','TX00003560243','IL','1','SHOEMAKER','ROBERT','','','','34','560926746','208 RANGER DRIVE',0,'BOERNE','TX','78006',NULL,'CY','48259','1954-02-11','M','M',':RET:2106-3','N','021','DEN','3705982','33348TX002000201','2014-04-01','2014-03-04 20:21:37','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-03-05 21:30:37'),(27801,21990,'Y','18','021','EC','A','','','AC','0001244222','0001244222','OH00003453835','IL','1','Paddy','Carol','','','','34','283481663','170 JOHNSON RD',0,'WADSWORTH','OH','44281','9093','CY','39103','1949-12-17','F','M',':RET:2106-3','N','021','HLT','4046801','52664OH151001304','2014-04-01','2014-03-05 10:45:59','410.00',NULL,NULL,'669.00','259.00','R-OH012','OH0','669.00',NULL,0,'2014-03-05 21:31:46'),(27843,22023,'Y','18','021','EC','A','','','AC','0000205742','0000205742','TX00003418915','IL','1','TRICHEL','PATRICIA','','','','34','454578331','4237 HIGHWAY 377 S',0,'BROWNWOOD','TX','76801',NULL,'CY','48049','1968-09-12','F','U',NULL,'N','021','DEN','3649332','33348TX002000101','2014-04-01','2014-03-05 11:00:09','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-03-05 21:32:08'),(28246,22349,'N','19','021','EC','A',NULL,NULL,'','0000947441','0001020475','','IL','1','HUSKEY','ELIZABETH','MARIE','','','34','272084374','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','2002-11-08','F','',':RET:2106-3','N','021','DEN','3294622','99734OH005000401','2014-04-01','2014-03-07 12:47:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-07 21:00:12'),(29185,23099,'Y','18','021','EC','A','','','AC','0000518473','0000518473','OH00003201023','IL','1','Berish','Cathy','','','','34','297709266','975 N HOWARD ST',0,'AKRON','OH','44310','1333','CY','39153','1965-02-27','F','U',':RET:2106-3','T','021','HLT','3067669','52664OH151001305','2014-04-01','2014-03-10 09:51:23','271.00',NULL,NULL,'437.52','166.52','R-OH012','OH0','437.52','CIC',0,'2014-03-10 21:30:01'),(7844,6212,'Y','18','021','EC','A','','','AC','0000284391','0000284391','OH00001296113','IL','1','Liptok','Ruth','Z','','','34','279587019','148 NAPLES DR',0,'ELYRIA','OH','44035','1521','CY','39093','1956-08-07','F','M',':RET:2106-3','N','021','DEN','1463280','99734OH005000301','2014-01-01','2013-12-19 23:10:24','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:04:41'),(15823,12667,'Y','18','021','EC','A','','','AC','0000979310','0000979310','OH00000848841','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','DEN','1955666','99734OH005000401','2014-02-01','2014-01-02 14:01:09','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-01-03 02:03:35'),(13203,10536,'Y','18','021','EC','A','','','AC','0000765775','0000765775','TX00001215824','IL','1','Brown','Janessa','','','','34','603160641','502 Sunrise Canyon Dr apt 7204',0,'Universal City','TX','78148',NULL,'CY','48029','1988-08-27','F','U',':RET:2054-5','N','021','DEN','2073800','33348TX002000101','2014-01-01','2013-12-23 15:52:22','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 12:55:01'),(1819,1494,'Y','18','021','EC','A','','','AC','0000456526','0000456526','OH00001109035','IL','1','Perez','Cuauhtemoc','','','','34','451233716','3917 BELLEVUE RD',0,'TOLEDO','OH','43613','4402','CY','39095','1957-05-23','M','U',NULL,'N','021','HLT','1748774','92036OH005002604','2014-01-01','2013-12-24 09:24:10','295.00',NULL,NULL,'454.92','159.92','R-OH001','OH0','454.92',NULL,0,'2013-12-25 18:57:12'),(2296,1870,'N','01','021','EC','A',NULL,NULL,'','0001139484','0000266512','','IL','1','Thompson','Michael','','','','34','284827773','2820 GRANDIN HOLLOW LN',0,'CINCINNATI','OH','45208','3315','CY','39061','1976-12-27','M','',':RET:2106-3','N','021','DEN','6540','99734OH005000301','2014-01-01','2013-12-09 16:04:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:53'),(23762,18911,'N','19','021','EC','A',NULL,NULL,'','0001146017','0001144811','','IL','1','DiMuzio','Gloria','','','','34','282117236','614 COLEBERRY CT',0,'CLEVES','OH','45002','1390','CY','39061','2005-06-16','F','',':RET:2106-3','N','021','DEN','2812096','99734OH005000301','2014-03-01','2014-02-14 14:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:10'),(26051,20661,'Y','18','021','EC','A','','','AC','0000808714','0000808714','OH00003421152','IL','1','Johnson','William','','','','34','343527108','1023 TOWNSHIP ROAD 1682',0,'ASHLAND','OH','44805','9281','CY','39005','1955-11-27','M','M',':RET:2106-3','N','021','HLT','3595104','52664OH151001305','2014-04-01','2014-02-26 17:58:38','1031.00',NULL,NULL,'1111.69','80.69','R-OH012','OH0','568.22',NULL,0,'2014-02-26 21:02:33'),(7565,5988,'Y','18','021','EC','A','','','AC','0000736503','0000736503','OH00000784732','IL','1','Hardy','Harold','Fredrick','','','34','270845177','6109 PINE MEADOWS DR',0,'LOVELAND','OH','45140','6538','CY','39025','1972-10-16','M','M',':RET:2106-3','N','021','HLT','618433','92036OH006000601','2014-01-01','2013-12-15 11:23:36','0.00',NULL,NULL,'221.66','221.66','R-OH005','OH0','221.66',NULL,0,'2013-12-26 02:33:35'),(17097,13683,'Y','18','021','EC','A','','','AC','0000909870','0000909870','TX00002088964','IL','1','Gomez','Martha','M','','','34','450533543','1700 S Main street',0,'Midland','TX','79701',NULL,'CY','48329','1965-11-16','F','U',NULL,'N','021','DEN','2013649','33348TX002000201','2014-02-01','2014-01-08 15:48:41','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-13 02:21:30'),(6027,4771,'Y','18','021','EC','A','','','AC','0000537317','0000537317','TX00000357959','31','1','reyes','marcela','','','','34','452295056','pobox7191',0,'corpuschristi','TX','78467',NULL,'CY','48355','1957-10-18','F','U',NULL,'N','021','DEN','738079','33348TX002000201','2014-01-01','2013-12-01 18:03:06','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 00:01:03'),(3322,2667,'Y','18','021','EC','A','','','AC','0000581482','0000581482','OH00000972579','IL','1','Riegler','Ann','','','','34','298885594','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','1973-03-29','F','M',':RET:2106-3','N','021','DEN','2144635','99734OH005000301','2014-01-01','2013-12-22 16:21:48','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:16:06'),(1453,1211,'N','01','021','EC','A',NULL,NULL,'','0000277274','0000024113','','IL','1','Knippen','Rick','L','','','34','297620174','26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','1958-02-05','M','',':RET:2106-3','T','021','DEN','2201030','99734OH005000401','2014-01-01','2013-12-24 07:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:08'),(19900,15873,'N','19','021','EC','A',NULL,NULL,'','0000679562','0000247924','','S1','1','Sherman','Darris','Leroy','','','34','280065451','600 GLENWOOD RD',0,'ROSSFORD','OH','43460','1508','CY','39173','2001-05-04','F','',NULL,'N','021','HLT','2925974','92036OH002002601','2014-03-01','2014-01-23 20:08:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-01-24 21:00:56'),(21941,17521,'Y','18','021','EC','A','','','AC','0000401947','0000401947','TX00002660407','IL','1','SAUCEDA','ENEDINA','','','','34','350484301','900 W 2ND ST',0,'WESLACO','TX','78596','5620','CY','48215','1963-05-08','F','U',':RET:2106-3','N','021','DEN','3538969','33348TX002000201','2014-03-01','2014-02-07 16:22:28','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-07 19:00:15'),(25724,20404,'Y','18','021','EC','A','','','AC','0001203595','0001203595','LA00002677052','IL','1','cruz','sandra','','','','34','663169492','4524 alexander dr',0,'metairie','LA','70003',NULL,'CY','22051','1972-09-30','F','M',NULL,'N','021','DEN','2947971','18575LA002000201','2014-04-01','2014-02-24 00:18:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 09:30:30'),(25808,20466,'Y','18','021','EC','A','','','AC','0000948478','0000948478','OH00003245900','IL','1','Baglia','Carol','','','','34','285582638','7097 BRIGHTWOOD DR',0,'PAINESVILLE','OH','44077','2170','CY','39085','1957-12-30','F','M',':RET:2106-3','N','021','DEN','3742148','99734OH005000301','2014-04-01','2014-02-26 13:14:57','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:00:20'),(25855,20497,'Y','18','024','14','A','','','TE','0000709821','0000709821','','IL','1','Howard','Edith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-13','F','',NULL,NULL,NULL,'','1094024','','2014-03-13','2014-02-26 09:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-26 21:00:42'),(27353,21661,'Y','18','021','EC','A','','','AC','0000761174','0000761174','OH00003281233','IL','1','JOHNSON','YOLANDA','','','','34','386545519','3273 E 137TH ST',0,'CLEVELAND','OH','44120','3950','CY','39035','1952-04-20','F','U',':RET:2054-5','T','021','DEN','3282522','99734OH005000401','2014-04-01','2014-03-04 14:02:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:06'),(649,535,'Y','18','021','EC','A','','','AC','0001078879','0001078879','OH00000234193','IL','1','Hartman','Cathy','','','','34','291443709','212 EDGEFIELD BLVD',0,'MARION','OH','43302','5802','CY','39101','1956-07-08','F','M',':RET:2106-3','N','021','DEN','1536411','99734OH005000401','2014-01-01','2013-12-16 16:13:11','0.00',NULL,NULL,'31.57','31.57','R-OH008','OH0','0.00',NULL,0,'2013-12-25 18:01:32'),(1000,820,'Y','18','021','EC','A','','','AC','0000515804','0000515804','OH00000013191','IL','1','Lea','Thomas','','','','34','283543464','524 SCIOTO ST',0,'URBANA','OH','43078','2133','CY','39021','1958-05-04','M','U',':RET:2106-3','T','021','HLT','494455','92036OH006000501','2014-01-01','2013-11-11 14:25:18','0.00',NULL,NULL,'483.45','483.45','R-OH003','OH0','483.45',NULL,0,'2013-12-25 18:10:55'),(1324,1095,'Y','18','021','EC','A','','','AC','0000081209','0000081209','LA00000767188','IL','1','barnes','dale','','','','34','435843186','7019 LOUISE ST',0,'SHREVEPORT','LA','71108','4840','CY','22017','1951-08-12','M','U',':RET:2106-3','T','021','DEN','363904','18575LA002000201','2014-01-01','2013-10-25 11:39:57','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:31:51'),(1406,1168,'Y','18','021','EC','A','','','AC','0002243466','0002243466','LA00000681385','IL','1','Stallings','Yvonne','','','','34','346703636','12064 W ENGLAND AVE',0,'BATON ROUGE','LA','70814','7741','CY','22033','1970-07-11','F','U',':RET:2054-5','N','021','DEN','2221890','18575LA002000201','2014-01-01','2013-12-24 13:04:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:45'),(17695,14140,'N','01','021','EC','A',NULL,NULL,'','0001794495','0001475379','','IL','1','Bowers','Robert','','','Sr','34','433432567','133 WOODLAKE BLVD',0,'KENNER','LA','70065','1032','CY','22051','1968-07-27','M','',NULL,'N','021','DEN','1900301','18575LA002000201','2014-02-01','2014-01-13 12:27:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-14 01:33:01'),(2701,2187,'Y','18','021','EC','A','','','AC','0001038971','0001038971','TX00001035918','IL','1','Lohman','Diane','','','','34','466805291','305 ROSE ST',0,'FREDERICKSBURG','TX','78624','3622','CY','48171','1961-01-11','F','M',':RET:2106-3','N','021','DEN','416058','33348TX002000201','2014-01-01','2013-12-02 13:14:04','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:47:43'),(17652,14109,'Y','18','021','EC','A','','','AC','0000948436','0000948436','OH00001567625','IL','1','abou-osman','wanda','','','','34','385707741','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','1957-03-16','F','M',':RET:2106-3','T','021','DEN','1526001','99734OH005000301','2014-02-01','2014-01-13 12:27:16','0.00',NULL,NULL,'87.78','87.78','R-OH013','OH0','0.00',NULL,0,'2014-01-14 01:32:41'),(4698,3725,'Y','18','021','EC','A','','','AC','0001162578','0001162578','OH00001230623','IL','1','Hill','Robert','','','','34','400231731','12648 OLD TROY PIKE',0,'SAINT PARIS','OH','43072','9626','CY','39021','1972-05-13','M','M',NULL,'T','021','HLT','236864','92036OH005000505','2014-01-01','2013-12-12 18:14:10','694.00',NULL,NULL,'850.13','156.13','R-OH003','OH0','355.92',NULL,0,'2013-12-25 22:08:21'),(13941,11118,'N','19','021','EC','A',NULL,NULL,'','0000661345','0000008416','','IL','1','Poshedley','Angela','','','','34','277043162','11081 FAIRLAWN DR',0,'PARMA','OH','44130','1217','CY','39035','1999-03-14','F','',NULL,'N','021','HLT','1777511','92036OH003000804','2014-01-01','2013-12-22 22:14:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','155.05',NULL,0,'2013-12-26 13:14:44'),(14245,11360,'Y','18','021','EC','A','','','AC','0000982526','0000982526','TX00000167318','IL','1','Triska','Richard','L','','Jr','34','462985016','815A Brazos Street',0,'Austin','TX','78701',NULL,'CY','48453','1951-02-14','M','R',':RET:2106-3','N','021','DEN','2265092','33348TX002000101','2014-02-01','2013-12-26 11:46:51','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-27 02:05:22'),(17333,13864,'Y','18','021','EC','A','','','AC','0001614121','0001614121','LA00001455159','IL','1','Lightell','Jonathan','','','','34','434831868','2123 MT HOPE ALY',0,'BATON ROUGE','LA','70820','4630','CY','22033','1988-12-19','M','U',NULL,'N','021','DEN','1838466','18575LA002000201','2014-02-01','2014-01-10 12:20:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:23:58'),(15951,12770,'Y','18','021','EC','A','','','AC','0000148351','0000148351','OH00001717465','IL','1','Ton','Quang','','','','34','281762337','3528 KINGSWOOD DR',0,'KETTERING','OH','45429','4316','CY','39113','1953-02-01','M','M',':RET:2047-9','N','021','DEN','2235857','99734OH005000301','2014-02-01','2014-01-02 19:29:07','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:00:06'),(21335,17050,'Y','18','021','EC','A','','','AC','0000435918','0000435918','TX00001633189','IL','1','Jimenez De Gomez','Lucila','','','','34','629297709','1715 CANDLESTON LN',0,'KATY','TX','77450','6761','CY','48201','1939-08-19','F','U',':RET:2106-3','N','021','DEN','3088441','33348TX002000201','2014-03-01','2014-02-03 20:05:40','0.00',NULL,NULL,'17.60','17.60','R-TX010','TX0','17.60',NULL,0,'2014-02-04 21:00:30'),(22953,18301,'Y','18','021','EC','A','','','AC','0000407414','0000407414','OH00002170787','IL','1','Braig','Mary','','','','34','271581695','7793 CARRAWAY CT',0,'MAINEVILLE','OH','45039','8995','CY','39165','1955-02-15','F','M',':RET:2106-3','N','021','DEN','3621883','99734OH005000301','2014-03-01','2014-02-11 19:17:03','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00','CIC',0,'2014-02-12 21:00:04'),(24455,19427,'Y','18','021','EC','A','','','AC','0000206498','0000206498','MS00002378922','IL','1','Hunt','Glenda','','','','34','413860156','7100 TULANE RD E',0,'HORN LAKE','MS','38637','1481','CY','28033','1949-09-09','F','U',NULL,'N','021','DEN','2923862','46300MS002000101','2014-04-01','2014-02-18 11:20:51','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-18 22:01:29'),(25656,20354,'N','01','021','EC','A',NULL,NULL,'','0000521015','0000491931','','IL','1','DECKER','ALICE','','','','34','290761080','975 MILLER AVE',0,'NEWARK','OH','43055',NULL,'CY','39089','1964-12-25','F','',NULL,'T','021','DEN','3849584','99734OH005000401','2014-04-01','2014-02-22 16:52:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 08:30:41'),(26568,21064,'Y','18','021','EC','A','','','AC','0000890809','0000890809','OH00003042302','IL','1','Taylor','Cole','A','','','34','292041398','3706 W Salinas Circle',0,'Dayton','OH','45440',NULL,'CY','39057','2000-01-16','M','R',':RET:2106-3','N','021','DEN','3870155','99734OH005000401','2014-04-01','2014-02-28 11:04:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-02-28 21:30:24'),(28261,22362,'N','01','021','EC','A',NULL,NULL,'','0000951788','0000198553','','IL','1','Scott','Evan','L','','','34','280544884','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1965-01-26','M','',':RET:2106-3','N','021','DEN','3607652','99734OH005000301','2014-04-01','2014-03-07 09:02:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-07 21:00:17'),(28862,22840,'Y','18','021','EC','A','','','AC','0001910773','0001910773','LA00003380160','IL','1','Smith','James','','','','34','434352567','2621 ROUSSEAU ST',0,'NEW ORLEANS','LA','70130','2042','CY','22071','1977-12-01','M','M',':RET:2054-5','N','021','DEN','4263679','18575LA002000201','2014-04-01','2014-03-09 17:40:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-03-09 21:30:04'),(16320,13066,'N','01','021','EC','A',NULL,NULL,'','0001566453','0001723194','','IL','1','Pham','Hung','','','','34','732146266','1235 S ALAMEDA DR',0,'BATON ROUGE','LA','70815','1006','CY','22033','1967-09-27','M','',NULL,'N','021','DEN','1910662','18575LA002000201','2014-02-01','2014-01-06 16:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:40'),(16298,13049,'Y','18','021','EC','A','','','AC','0002051525','0002051525','LA00001597392','IL','1','HUDSON','ELAINE','','','','34','347549105','2924 DOVE AVENUE',0,'MARRERO','LA','70072',NULL,'CY','22051','1961-03-12','F','M',NULL,'N','021','DEN','2551505','18575LA002000201','2014-02-01','2014-01-06 15:43:15','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:05'),(3407,2735,'Y','18','021','EC','A','','','AC','0001599164','0001599164','LA00001112541','IL','1','Joseph','Dorothy','','','','34','437087071','909 GOVERNOR MOUTON ST',0,'SAINT MARTINVILLE','LA','70582','3005','CY','22099','1969-09-02','F','U',':RET:2054-5','N','021','DEN','1696994','18575LA002000201','2014-01-01','2013-12-22 15:09:22','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 21:18:17'),(19391,15459,'Y','18','021','EC','A','','','AC','0000633720','0000633720','OH00001896726','IL','1','KIPKER','DENISE','','','','34','286520415','10753 STATE ROUTE 274',0,'LEWISTOWN','OH','43333','9705','CY','39091','1954-10-25','F','M',NULL,'N','021','DEN','1997062','99734OH005000401','2014-03-01','2014-01-21 11:34:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-22 03:22:48'),(19555,15588,'Y','18','021','EC','A','','','AC','0001558808','0001558808','LA00001358761','IL','1','Tabary','Carolynne','','','','34','433390249','3029 ROYAL ST',0,'NEW ORLEANS','LA','70117','6740','CY','22071','1963-11-04','F','R',':RET:2106-3','T','021','DEN','1700235','18575LA002000101','2014-03-01','2014-01-22 11:12:04','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-23 03:02:30'),(26295,20859,'Y','18','021','EC','A','','','AC','0001105598','0001105598','OH00003029998','IL','1','Silcox','Paul','','','','34','365644414','18825 RANGE LINE RD',0,'BOWLING GREEN','OH','43402','9750','CY','39173','1955-05-06','M','U',NULL,'N','021','HLT','3271779','92036OH005002606','2014-04-01','2014-02-27 17:35:59','412.00',NULL,NULL,'496.84','84.84','R-OH001','OH0','496.84',NULL,0,'2014-02-28 06:31:26'),(27182,21522,'Y','18','021','EC','A','','','AC','0000139641','0000139641','TX00002596836','IL','1','ledesma','jose','','','','34','668668354','648 North Flores St',0,'Robstown','TX','78380',NULL,'CY','48355','1963-02-16','M','M',NULL,'N','021','DEN','3388126','33348TX002000201','2014-04-01','2014-03-03 14:05:35','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-03-03 21:31:11'),(16374,13102,'Y','18','021','EC','A','','','AC','0000062994','0000062994','TX00002290987','IL','1','Meazle','Robert','','','','34','466174634','1111 TIERRA DR',0,'MESQUITE','TX','75149','5215','CY','48113','1964-01-28','M','U',':RET:2106-3','N','021','DEN','2276945','33348TX002000101','2014-02-01','2014-01-06 13:20:46','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-07 04:03:06'),(15008,11997,'Y','18','021','EC','A','','','AC','0000473659','0000473659','OH00000659993','IL','1','STADLER','NORA','A','','','34','287481123','2940 8TH ST',0,'CUYAHOGA FALLS','OH','44221','1622','CY','39153','1960-07-22','F','U',':RET:2106-3','N','021','HLT','1875283','52664OH151001306','2014-02-01','2013-12-29 20:25:20','468.00',NULL,NULL,'596.55','128.55','R-OH012','OH0','454.94',NULL,0,'2014-01-01 12:01:57'),(6886,5462,'Y','18','021','EC','A','','','AC','0001927663','0001927663','LA00001615962','IL','1','Poole','Antoinette','','','','34','436832119','1160 Adner Road',0,'Haughton','LA','71037',NULL,'CY','22015','1991-11-12','F','U',':RET:2054-5','N','021','DEN','1592115','18575LA002000201','2014-01-01','2013-12-24 19:42:42','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 01:45:14'),(6463,5121,'N','01','021','EC','A',NULL,NULL,'','0000631482','0000780479','','IL','1','CARTER','ARLENE','','','','34','268721099','1 PARK CENTER DR',0,'WADSWORTH','OH','44281','9452','CY','39103','1961-03-10','F','',':RET:2106-3','N','021','HLT','881253','52664OH151001501','2014-01-01','2013-12-11 11:53:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-26 00:49:57'),(638,528,'Y','18','021','EC','A','','','AC','0000132052','0000132052','OH00000846684','IL','1','lee','kaylie','','','','34','285867511','33075 CHESTNUT RIDGE RD',0,'NORTH RIDGEVILLE','OH','44039','3439','CY','39093','1987-06-25','F','M',':RET:2106-3','N','021','DEN','1935922','99734OH005000401','2014-01-01','2013-12-16 14:31:57','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:01:17'),(14928,11928,'Y','18','021','EC','A','','','AC','0000806360','0000806360','OH00001159488','31','1','Antesky','Mitchell','','','','34','288705357','21873 W Sr 51 PO Box 181',0,'Genoa','OH','43430',NULL,'CY','39123','1958-12-31','M','U',':RET:2106-3','N','021','HLT','2464975','92036OH004002701','2014-02-01','2013-12-28 23:30:19','233.00',NULL,NULL,'349.65','116.65','R-OH006','OH0','349.65',NULL,0,'2013-12-30 00:01:54'),(14849,11857,'Y','18','021','EC','A','','','AC','0000699276','0000699276','OH00000085708','IL','1','Burns','Cheryl','','','','34','284660742','7702 Compton Lake Drive',0,'cincinnati','OH','45231',NULL,'CY','39061','1959-12-09','F','U',':RET:2054-5','N','021','HLT','1597349','92036OH003001204','2014-01-01','2013-12-23 19:55:42','264.00',NULL,NULL,'478.63','214.63','R-OH004','OH0','478.63',NULL,1,'2013-12-29 11:15:02'),(8072,6393,'Y','18','021','EC','A','','','AC','0000993940','0000993940','OH00001131315','IL','1','Wenning','Curtis','','','','34','283504820','803 Fox St.',0,'New Bremen','OH','45869',NULL,'CY','39011','1951-05-07','M','U',':RET:2106-3','N','021','HLT','1696880','92036OH004001501','2014-01-01','2013-12-20 13:00:30','458.00',NULL,NULL,'508.42','50.42','R-OH002','OH0','508.42',NULL,0,'2013-12-26 03:10:16'),(9659,7652,'Y','18','021','EC','A','','','AC','0000815328','0000815328','OH00001199464','IL','1','hindsman','latoya','marie','','','34','288885756','322 REDWOOD AVE',0,'DAYTON','OH','45405','5116','CY','39113','1977-04-15','F','U',':RET:2054-5','T','021','HLT','1898543','92036OH005000506','2014-01-01','2013-12-21 10:09:22','211.00',NULL,NULL,'336.24','125.24','R-OH003','OH0','336.24',NULL,0,'2013-12-26 04:38:56'),(3534,2837,'Y','18','021','EC','A','','','AC','0000839902','0000839902','TX00000004425','IL','1','Rodriguez','Lori','','','','34','450733637','123 East Gonzalez Dr.',0,'San Juan','TX','78589',NULL,'CY','48215','1981-07-24','F','U',NULL,'N','021','DEN','2224167','33348TX002000101','2014-01-01','2013-12-21 23:55:49','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-25 21:21:34'),(3771,3019,'Y','18','021','EC','A','','','AC','0001062091','0001062091','OH00000828024','IL','1','Starcher','Benjamin','','','','34','287749582','4470 BEACHVIEW DR',0,'RAVENNA','OH','44266','9330','CY','39133','1973-12-06','M','U',':RET:2106-3','T','021','HLT','1035842','52664OH151001305','2014-01-01','2013-12-13 15:04:33','194.00',NULL,NULL,'327.75','133.75','R-OH012','OH0','327.75',NULL,0,'2013-12-25 21:33:42'),(20384,16284,'Y','18','021','EC','A','','','AC','0000651300','0000651300','TX00002159569','IL','1','Sorcini','Emma','','','','34','526944334','1801 GARDEN GATE WAY',0,'EL PASO','TX','79936','5565','CY','48141','1951-05-28','F','U',NULL,'N','021','DEN','1669568','33348TX002000201','2014-03-01','2014-01-28 23:37:47','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-29 21:00:13'),(21215,16953,'Y','18','021','EC','A','','','AC','0002213401','0002213401','LA00001961913','IL','1','Bilici','Ayca','','','','34','665166273','7846 Clover Ridge Avenue',0,'Baton Rouge','LA','70820',NULL,'CY','22033','1979-01-28','F','U',NULL,'N','021','DEN','3746355','18575LA002000201','2014-03-01','2014-02-03 14:52:56','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-03 21:01:00'),(21774,17388,'Y','18','021','EC','A','','','AC','0001070512','0001070512','OH00001986986','IL','1','Stamper','Michele','','','','34','299469371','1076 HILLRIDGE RD',0,'REYNOLDSBURG','OH','43068','1806','CY','39049','1956-08-17','F','U',NULL,'N','021','DEN','3236873','99734OH005000401','2014-03-01','2014-02-06 15:18:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:34'),(21962,17538,'Y','18','024','14','A','','','TE','0000757149','0000757149','','IL','1','Selick','Tammy','Lynn',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-02-14','F','',NULL,NULL,NULL,'','1625905','','2014-02-22','2014-02-07 10:38:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-07 19:00:26'),(23588,18791,'N','01','021','EC','A',NULL,NULL,'','0000389882','0000493279','','IL','1','Schanz','Cynthia','','','','34','287644577','798 N SUMMIT ST',0,'BARBERTON','OH','44203','1523','CY','39153','1964-07-12','F','',':RET:2106-3','N','021','HLT','3127425','52664OH152000901','2014-03-01','2014-02-13 11:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','278.66',NULL,0,'2014-02-13 22:03:00'),(25247,20027,'Y','18','024','14','A','','','TE','0001174433','0001174433','','IL','1','ulrick','peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-19','M','',NULL,NULL,NULL,'','3177188','','2014-02-21','2014-02-21 16:30:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-21 22:01:11'),(25916,20551,'Y','18','021','EC','A','','','AC','0000706115','0000706115','TX00003178978','IL','1','spoon','catherine','','','','34','452815797','139 BAY DR',0,'MABANK','TX','75156','6887','CY','48213','1972-08-13','F','M',':RET:2106-3','T','021','DEN','2755231','33348TX002000201','2014-04-01','2014-02-26 14:59:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:17'),(26371,20919,'Y','18','024','14','A','','','TE','0000690775','0000690775','','IL','1','Mathias','Donna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-31','F','',NULL,NULL,NULL,'','3124567','','2014-02-26','2014-02-26 14:45:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:00:12'),(28645,22669,'Y','18','021','EC','A','','','AC','0000218017','0000218017','MS00002999318','IL','1','CHURCH','FONDA','','','','34','587276241','953 ARBOR VISTA BLVD',0,'JACKSON','MS','39209','7133','CY','28049','1964-05-05','F','U',':RET:2054-5','N','021','DEN','3530033','46300MS002000101','2014-04-01','2014-03-07 22:16:06','0.00',NULL,NULL,'108.60','108.60','R-MS003','MS0','27.15',NULL,0,'2014-03-08 21:30:35'),(16223,12992,'Y','18','024','14','A','','','TE','0000370028','0000370028','','IL','1','Farris','Sarah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-26','F','',NULL,NULL,NULL,'','1581176','','2014-01-04','2014-01-04 08:39:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-05 00:01:51'),(1327,1098,'Y','18','021','EC','A','','','AC','0000713595','0000713595','OH00000102819','IL','1','Gill','Jamie','L','','','34','275581563','1009 FAIR OAKS AVE SW',0,'NORTH CANTON','OH','44720','3533','CY','39151','1955-12-02','F','U',':RET:2106-3','N','021','DEN','997614','99734OH005000301','2014-01-01','2013-10-25 06:59:26','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 18:31:57'),(16087,12883,'N','01','021','EC','A',NULL,NULL,'','0000857113','0000937284','','IL','1','Armstrong','Toria','L','','','34','272687549','234 Blair Dr',0,'Fairborn','OH','45324',NULL,'CY','39057','1964-11-22','F','',':RET:2106-3','N','021','DEN','2523555','99734OH005000401','2014-02-01','2014-01-03 16:53:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:04:18'),(14189,11314,'Y','18','024','14','A','','','TE','0000902133','0000902133','','IL','1','GREGORY','DANN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-06-07','F','',NULL,NULL,NULL,'','2310772','','2013-12-26','2013-12-26 12:24:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:03:57'),(13140,10480,'Y','18','021','EC','A','','','AC','0000963228','0000963228','OH00000552215','IL','1','Sweeney','Susan','','','','34','404820528','6415 CANASTOTA DR',0,'HAMILTON','OH','45011','5003','CY','39017','1952-05-25','F','M',NULL,'N','021','DEN','1954211','99734OH005000401','2014-01-01','2013-12-23 15:43:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:16'),(18762,14949,'Y','18','024','14','A','','','TE','0000042185','0000042185','','IL','1','Morris','Rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-02-10','F','',NULL,NULL,NULL,'','1389650','','2014-01-15','2014-01-15 21:36:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:47'),(21443,17139,'Y','18','021','EC','A','','','AC','0000884259','0000884259','OH00001473234','IL','1','HARRIS','ANN','','','','34','288588944','6812 EVERGREEN RD',0,'HUDSON','OH','44236','3225','CY','39153','1956-01-03','F','U',NULL,'N','021','HLT','3325310','52664OH151001501','2014-03-01','2014-02-04 11:57:40','364.00',NULL,NULL,'681.50','317.50','R-OH012','OH0','681.50',NULL,0,'2014-02-04 21:01:25'),(22731,18150,'Y','18','021','EC','A','','','AC','0001356215','0001356215','LA00001741148','IL','1','watson','zenda','','','','34','439199006','2360 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4454','CY','22071','1973-06-06','F','M',':RET:2054-5','N','021','DEN','3138493','18575LA002000201','2014-03-01','2014-02-11 15:46:05','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:15'),(16789,13430,'Y','18','024','14','A','','','TE','0000768896','0000768896','','IL','1','WILLIAMS','TIMOTHY','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-09-07','M','',NULL,NULL,NULL,'','2511931','','2014-01-10','2014-01-10 18:21:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:18:05'),(15644,12514,'Y','18','021','EC','A','','','AC','0000963255','0000963255','MS00001176705','IL','1','Parker','Evan','','','','34','233134937','1631 GRANDVIEW DR',0,'LAUREL','MS','39440','4211','CY','28067','1963-10-20','M','M',':RET:2106-3','N','021','DEN','2015623','46300MS002000201','2014-02-01','2013-12-31 10:55:39','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,1,'2014-01-02 04:33:53'),(14809,11828,'Y','18','021','EC','A','','','AC','0001320356','0001320356','LA00000819807','IL','1','GUIDRY','DEXTER','JOSEPH','','','34','439795254','328 JACKSON ST',0,'LAFAYETTE','LA','70501',NULL,'CY','22055','1990-09-26','M','U',':RET:2054-5','N','021','DEN','1435645','18575LA002000201','2014-01-01','2013-12-23 20:00:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:14:00'),(5056,4005,'Y','18','021','EC','A','','','AC','0001053354','0001053354','TX00000698840','IL','1','Lee','Sylvia','','','','34','460676130','1601 BOWIE CIR',0,'TYLER','TX','75701','6830','CY','48423','1969-09-20','F','U',NULL,'N','021','DEN','2461904','33348TX002000201','2014-01-01','2013-12-18 21:04:39','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 23:00:18'),(4284,3410,'N','19','021','EC','A',NULL,NULL,'','0000689680','0000432741','','IL','1','Halker','Breanne','','','','34','274984741','9323 dt rt 12',0,'columbus grove','OH','45830',NULL,'CY','39137','1994-12-06','F','',':RET:2106-3','N','021','HLT','2079510','92036OH005001501','2014-01-01','2013-12-17 13:22:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 21:52:03'),(3509,2819,'Y','18','021','EC','A','','','AC','0000634803','0000634803','OH00000253719','IL','1','james','cornelius','','','','34','285624904','949 Havensport Dr',0,'Cincinnati','OH','45240',NULL,'CY','39061','1958-03-04','M','M',NULL,'N','021','HLT','1444255','92036OH002001201','2014-01-01','2013-12-21 19:46:37','295.00',NULL,NULL,'552.84','257.84','R-OH004','OH0','552.84',NULL,0,'2013-12-25 21:20:56'),(3419,2745,'Y','18','021','EC','A','','','AC','0002171634','0002171634','LA00000308737','IL','1','Mckenzie','Inez','G','','','34','436941918','1418 EGANIA ST',0,'NEW ORLEANS','LA','70117','3612','CY','22071','1954-12-18','F','U',':RET:2054-5','N','021','DEN','2308154','18575LA002000201','2014-01-01','2013-12-22 17:36:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:35'),(13953,11124,'Y','18','021','EC','A','','','AC','0001256031','0001256031','OH00000296686','IL','1','SHIPLEY','ANGELETTA','','','','34','300745276','4617 BROOKVIEW DR',0,'BATAVIA','OH','45103','1307','CY','39025','1979-02-16','F','U',':RET:2106-3','N','021','HLT','2601538','92036OH004000601','2014-01-01','2013-12-23 14:46:29','0.00',NULL,NULL,'209.55','209.55','R-OH005','OH0','209.55',NULL,0,'2013-12-26 13:14:58'),(20362,16263,'Y','18','024','14','A','','','TE','0000661318','0000661318','','IL','1','Turner','Bessie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-30','F','',NULL,NULL,NULL,'','958464','','2014-01-28','2014-01-28 14:38:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:21'),(27221,21554,'Y','18','021','EC','A','','','AC','0000841685','0000841685','MS00003520544','IL','1','HUGHES','GENISA','','','','34','426717680','386 RAYMOND RD',0,'JACKSON','MS','39204',NULL,'CY','28049','1991-03-08','F','U',':RET:2054-5','N','021','DEN','3496091','46300MS002000201','2014-04-01','2014-03-03 14:36:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:35'),(29064,23004,'Y','18','021','EC','A','','','AC','0000552689','0000552689','OH00003555239','IL','1','Kerr','Brian','','','','34','296721946','4134 N LOCKWOOD AVE',0,'TOLEDO','OH','43612','1745','CY','39095','1969-09-18','M','M',NULL,'N','021','HLT','3276340','92036OH004002601','2014-04-01','2014-03-10 12:08:04','183.00',NULL,NULL,'663.25','480.25','R-OH001','OH0','219.04',NULL,0,'2014-03-10 21:01:54'),(17261,13810,'Y','18','021','EC','A','','','AC','0000898470','0000898470','OH00002137211','IL','1','Waldock','Stacy','','','','34','523792026','901 S. Fountain Ave',0,'Springfield','OH','45506',NULL,'CY','39023','1988-04-09','F','M',':RET:2106-3','N','021','DEN','1564200','99734OH005000301','2014-02-01','2014-01-10 12:40:24','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:23:16'),(1188,978,'Y','18','021','EC','A','','','AC','0001200866','0001200866','OH00000396387','IL','1','Morris','Lloyd','','','','34','273566197','4881 Westville Lake Rd',0,'Beloit','OH','44609',NULL,'CY','39029','1956-07-01','M','M',':RET:2106-3','T','021','DEN','634259','99734OH005000301','2014-01-01','2013-12-03 09:46:35','0.00',NULL,NULL,'59.76','59.76','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:19:32'),(17249,13802,'N','01','021','EC','A',NULL,NULL,'','0000705167','0000011178','','IL','1','martinez','lance','','','','34','451971344','2190 KINSMAN RD NE',0,'NORTH BLOOMFIELD','OH','44450','9729','CY','39155','1983-11-01','M','',':RET:2106-3','N','021','DEN','1428774','99734OH005000301','2014-02-01','2014-01-09 19:32:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:11'),(5064,4013,'Y','18','021','EC','A','','','AC','0000310424','0000310424','TX00001248395','IL','1','wilson','linda','','','','34','463909146','377 cement mountain rd',0,'graham','TX','76450',NULL,'CY','48503','1951-07-22','F','R',':RET:2106-3','N','021','DEN','2440720','33348TX002000201','2014-01-01','2013-12-19 10:25:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:31'),(19286,15372,'Y','18','024','14','A','','','TE','0001448386','0001448386','','IL','1','Richard','Melrose',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-05','F','',NULL,NULL,NULL,'','2101165','','2014-01-20','2014-01-20 18:45:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2014-01-22 03:21:52'),(25452,20194,'N','01','021','EC','A',NULL,NULL,'','0000434588','0000324330','','IL','1','VARGAS','GERARDO','F','','','34','552997719','661 AGUA CLARA ST',0,'EL PASO','TX','79928','9012','CY','48141','1971-10-17','M','',':RET:2106-3','N','021','DEN','3053788','33348TX002000201','2014-04-01','2014-02-25 13:38:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:26'),(26266,20833,'Y','18','024','14','A','','','TE','0000556666','0000556666','','IL','1','Gonzales','Yolanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-10-31','F','',NULL,NULL,NULL,'','2825997','','2014-02-27','2014-02-27 16:04:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:14'),(27308,21621,'Y','18','021','EC','A','','','AC','0000693738','0000693738','TX00002883529','IL','1','Trujillo','James','','','','34','458611339','924 C ST',0,'Brownsville','TX','78520',NULL,'CY','48061','1982-06-20','M','U',NULL,'N','021','DEN','3005573','33348TX002000201','2014-04-01','2014-03-04 13:47:40','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-04 21:00:37'),(28003,22158,'Y','18','021','EC','A','','','AC','0000201979','0000201979','OH00003715313','IL','1','Harding','Abigale','','','','34','288968279','1139 N MANTUA ST',0,'KENT','OH','44240','5013','CY','39133','1992-07-14','F','U',':RET:2106-3','N','021','DEN','3377189','99734OH005000401','2014-04-01','2014-03-05 20:28:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-06 21:01:10'),(6810,5402,'Y','18','021','EC','A','','','AC','0000071521','0000071521','TX00001078064','IL','1','hicks','Lonnie','','','Jr','34','461310516','1111 S. Main Street',0,'Carrollton','TX','75006',NULL,'CY','48113','1969-07-14','M','U',':RET:2054-5','N','021','DEN','550325','33348TX002000201','2014-01-01','2013-11-14 12:10:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:30:17'),(17109,13692,'Y','18','021','EC','A','','','AC','0000917007','0000917007','OH00002212910','IL','1','Dillion','Elizabeth','','','','34','298685079','209 S. Supinger Avenue',0,'Blanchester','OH','45107',NULL,'CY','39027','1968-08-20','F','U',':RET:2106-3','N','021','HLT','1564154','92036OH004000601','2014-02-01','2014-01-08 17:49:14','112.00',NULL,NULL,'249.26','137.26','R-OH005','OH0','249.26',NULL,0,'2014-01-13 02:21:36'),(4152,3309,'Y','18','021','EC','A','','','AC','0000031920','0000031920','OH00000999859','IL','1','Grubb','Kenneth','E','','','34','296564017','1751 GILBERT RD',0,'TOLEDO','OH','43614','4000','CY','39095','1956-06-30','M','U',':RET:2106-3','N','021','DEN','2575778','99734OH005000301','2014-01-01','2013-12-17 14:01:42','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:48:47'),(6266,4968,'Y','18','021','EC','A','','','AC','0000171199','0000171199','OH00000027344','IL','1','JORDAN','CAROL','','','','34','270501982','2374 HUME ST NW',0,'NORTH CANTON','OH','44720','6230','CY','39151','1949-11-11','F','U',NULL,'N','021','DEN','1023808','99734OH005000301','2014-01-01','2013-10-07 09:29:37','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 00:32:23'),(3457,2780,'Y','18','021','EC','A','','','AC','0001001154','0001001154','OH00000991323','IL','1','Hall','Jammie','','','','34','271885017','13385 Ett Noecker Road',0,'Ashville','OH','43103',NULL,'CY','39129','1972-10-20','M','M',':RET:2106-3','T','021','DEN','1903281','99734OH005000401','2014-01-01','2013-12-22 01:04:37','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:19:40'),(20598,16458,'Y','18','024','14','A','','','TE','0000091162','0000091162','','IL','1','oquendo','emily',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-07','F','',NULL,NULL,NULL,'','2532907','','2014-01-30','2014-01-30 12:50:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:12'),(23160,18463,'Y','18','021','EC','A','','','AC','0000165319','0000165319','TX00002362539','IL','1','Tran','Chi','','','','34','021905059','10802 Kingspoint Dr',0,'Houston','TX','77075',NULL,'CY','48201','1956-05-10','F','U',NULL,'N','021','DEN','3440607','33348TX002000101','2014-03-01','2014-02-12 11:16:37','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-12 21:31:46'),(23612,18806,'Y','18','024','14','A','','','TE','0001173261','0001173261','','IL','1','Nelson','Alyse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-21','F','',NULL,NULL,NULL,'','2762536','','2014-02-13','2014-02-13 13:58:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:03:13'),(24093,19153,'N','01','021','EC','A',NULL,NULL,'','0001109274','0000805161','','IL','1','Krause','Gary','Jay','','Jr','34','294769637','3024 Frost Road',0,'Mantua','OH','44255',NULL,'CY','39133','1969-07-30','M','',':RET:2106-3','N','021','HLT','3679734','52664OH151001304','2014-03-01','2014-02-15 14:30:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-02-15 22:01:26'),(24102,19160,'Y','18','021','EC','A','','','AC','0000834324','0000834324','TX00002003158','IL','1','Robertson','Demetra','','','','34','456539284','1232 McCary St',0,'Cedar Hill','TX','75104',NULL,'CY','48113','1970-01-17','F','U',NULL,'N','021','DEN','3532013','33348TX002000201','2014-03-01','2014-02-14 18:07:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:31'),(24775,19652,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000726112','','IL','1','ANAYA','ADLYNN','','','','34','279960857','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1993-04-19','F','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:43'),(26229,20803,'Y','18','021','EC','A','','','AC','0001199405','0001199405','TX00002741742','IL','1','Bickham','Rebecca','','','','34','454953936','30323 ALDINE WESTFIELD RD',0,'SPRING','TX','77386','3356','CY','48339','1978-03-19','F','R',':RET:2106-3','N','021','DEN','3795103','33348TX002000201','2014-03-01','2014-02-26 22:17:45','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 06:31:00'),(18282,14596,'Y','18','021','EC','A','','','AC','0000703800','0000703800','OH00002102509','IL','1','SHARMA','CHAKRESHWAR','','','','34','289138622','4794 TIMBERKNOLL RD',0,'CINCINNATI','OH','45244','1125','CY','39025','1966-11-24','M','M',':RET:2029-7','N','021','DEN','1372558','99734OH005000401','2014-02-01','2014-01-14 19:03:17','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:44:47'),(16078,12876,'Y','18','021','EC','A','','','AC','0000565557','0000565557','OH00001818803','IL','1','McIntosh','Saundra','','','','34','284661595','15416 WINGATE RD',0,'MAPLE HEIGHTS','OH','44137','3727','CY','39035','1960-08-01','F','U',':RET:2054-5','T','021','DEN','2423393','99734OH005000401','2014-02-01','2014-01-03 14:21:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:04:00'),(5842,4641,'Y','18','021','EC','A','','','AC','0000226909','0000226909','TX00001059341','IL','1','Mims','Catherine','','','','34','460735249','721 S LAUREL AVE',0,'LULING','TX','78648','3303','CY','48055','1979-03-23','F','M',':RET:2106-3','N','021','DEN','2357349','33348TX002000201','2014-01-01','2013-12-24 00:12:44','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:48:35'),(15714,12570,'Y','18','021','EC','A','','','AC','0000198574','0000198574','OH00002048662','IL','1','Kitchingham','Charles','','','','34','271749580','2053 West Alexis Rd',0,'Toledo','OH','43613',NULL,'CY','39095','1962-07-02','M','U',':RET:2106-3','N','021','HLT','2074096','92036OH003002605','2014-02-01','2013-12-31 17:14:24','257.00',NULL,NULL,'379.79','122.79','R-OH001','OH0','379.79',NULL,1,'2014-01-02 04:36:08'),(1388,1153,'Y','18','021','EC','A','','','AC','0001709233','0001709233','LA00000945122','IL','1','McCraine','Chad','','','','34','531968892','1804 GENTILLY BLVD',0,'NEW ORLEANS','LA','70119','2018','CY','22071','1969-09-07','M','U',':RET:2106-3','T','021','DEN','1725310','18575LA002000201','2014-01-01','2013-12-24 10:52:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:17'),(1568,1309,'Y','18','021','EC','A','','','AC','0001011508','0001011508','TX00000365922','IL','1','Cantu','Osiel','','','','34','457456140','2502 South Ohio Ave.',0,'Weslaco','TX','78596',NULL,'CY','48215','1977-06-17','M','U',NULL,'N','021','DEN','2199871','33348TX002000201','2014-01-01','2013-12-24 08:46:27','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:51:06'),(13620,10859,'N','01','021','EC','A',NULL,NULL,'','0000923323','0001161536','','IL','1','SEIBERT','MARILYN','','','','34','288520405','2139 BROADHURST AVE',0,'CINCINNATI','OH','45240','1413','CY','39061','1950-12-08','F','',':RET:2106-3','N','021','HLT','1365513','92036OH002001201','2014-01-01','2013-12-23 16:33:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','731.81',NULL,0,'2013-12-26 13:05:50'),(2171,1786,'Y','18','021','EC','A','','','AC','0000106691','0000106691','OH00000689990','IL','1','Gafeney','Gerald','','','','34','290520050','2420 VALENTINE ST',0,'TOLEDO','OH','43605','1273','CY','39095','1953-01-16','M','U',NULL,'T','021','HLT','223969','92036OH006002601','2014-01-01','2013-12-10 14:07:44','0.00',NULL,NULL,'482.65','482.65','R-OH001','OH0','482.65',NULL,0,'2013-12-25 19:19:10'),(3255,2623,'N','19','021','EC','A',NULL,NULL,'','0000148293','0000702740','','IL','1','Scott','Ronald','Bernard','','','34','622600497','24 2ND AVE',0,'BEREA','OH','44017','1244','CY','39035','1992-08-29','M','',':RET:2054-5','N','021','DEN','197683','99734OH005000301','2014-01-01','2013-11-27 20:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:46:43'),(3404,2732,'Y','18','021','EC','A','','','AC','0002123786','0002123786','LA00000259997','IL','1','Canales','Oscar','Alberto','','','34','632301122','2000 Muphrey Rd.',0,'Chalmette','LA','70043',NULL,'CY','22087','1984-06-18','M','U',NULL,'N','021','DEN','2217928','18575LA002000201','2014-01-01','2013-12-22 14:18:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:12');
INSERT INTO `EdiParticipant` VALUES (24000,19084,'Y','18','021','EC','A','','','AC','0000054510','0000054510','OH00002113366','31','1','White','Arliss','','','Jr','34','290642430','1209 Woodnell Avenue',0,'Columbus','OH','43219',NULL,'CY','39049','1958-11-07','M','U',NULL,'T','021','DEN','3713573','99734OH005000401','2014-03-01','2014-02-15 08:46:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:32'),(187,156,'Y','18','024','14','A','','','TE','0000738984','0000738984','','IL','1','Dennison','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-02','M','',NULL,NULL,NULL,'','604341','','2013-12-05','2013-12-05 12:11:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:19:51'),(17931,14325,'Y','18','021','EC','A','','','AC','0000191019','0000191019','TX00001775411','IL','1','GARRETT','HALEY','K','','','34','635101921','302 SW 14TH AVE',0,'MINERAL WELLS','TX','76067','5182','CY','48363','1987-09-05','F','U',':RET:2106-3','N','021','DEN','1629129','33348TX002000201','2014-02-01','2014-01-14 13:11:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:35'),(495,404,'Y','18','021','EC','A','','','AC','0000586096','0000586096','LA00000068557','IL','1','Jack','Dominic','','','','34','433755383','5024 ASTORIA DR',0,'BATON ROUGE','LA','70812','3101','CY','22033','1989-06-13','M','U',':RET:2054-5','N','021','DEN','1169632','18575LA002000201','2014-01-01','2013-12-04 14:03:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:48:31'),(5184,4112,'Y','18','021','EC','A','','','AC','0000086409','0000086409','OH00000590045','IL','1','HAMPEL','JUDITH','','','','34','291729539','8886 MOCKINGBIRD LN',0,'CINCINNATI','OH','45231','4740','CY','39061','1961-07-12','F','U',':RET:2106-3','N','021','DEN','2122005','99734OH005000401','2014-01-01','2013-12-19 12:45:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:34'),(4064,3246,'N','01','021','EC','A',NULL,NULL,'','0001069310','0000446276','','IL','1','Bryant','Rachel','Anne','','','34','286860550','14414 ROXBORO AVE',0,'CLEVELAND','OH','44111','1329','CY','39035','1978-08-28','F','',':RET:2106-3','N','021','DEN','1365117','99734OH005000401','2014-01-01','2013-12-17 16:14:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:46:45'),(16893,13518,'Y','18','021','EC','A','','','AC','0000189907','0000189907','TX00001626792','IL','1','MALDONADO','ANDREA','','','','34','460396860','1107 WEST SYLVIA STREET',0,'BEEVILLE','TX','78102',NULL,'CY','48025','1961-02-16','F','U',NULL,'N','021','DEN','2121697','33348TX002000201','2014-02-01','2014-01-09 17:27:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:28'),(13136,10477,'Y','18','021','EC','A','','','AC','0000139013','0000139013','OH00001214776','IL','1','BOLLER','PHILIP','','','','34','290605006','1002 PAMELA RD',0,'CINCINNATI','OH','45255','4723','CY','39061','1961-11-28','M','M',':RET:2106-3','N','021','DEN','2572037','99734OH005000401','2014-01-01','2013-12-23 15:11:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:09'),(13964,11130,'Y','18','024','14','A','','','TE','0000040937','0000040937','','IL','1','Wilson','Jamie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-02-23','F','',NULL,NULL,NULL,'','2352477','','2013-12-23','2013-12-23 16:26:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:15:13'),(18507,14760,'N','17','021','EC','A',NULL,NULL,'','0000230464','0000741745','','IL','1','Maffo','Maxwell','','','','34','294944499','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1992-07-12','M','',':RET:2106-3','N','021','HLT','1900415','52664OH151001305','2014-02-01','2014-01-15 17:50:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-01-16 08:46:32'),(25950,20580,'Y','18','021','EC','A','','','AC','0000963290','0000963290','OH00002835669','IL','1','TARANTO','DANIEL','','','','34','294606361','6629 BUCKRIDGE WAY',0,'CANAL WINCHESTER','OH','43110','8314','CY','39049','1963-11-03','M','U',':RET:2106-3','N','021','DEN','2724715','99734OH005000401','2014-04-01','2014-02-26 10:26:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:36'),(26059,20667,'N','01','021','EC','A',NULL,NULL,'','0000528303','0000276323','','IL','1','Fletcher','Jerry','','','','34','298726788','8135 Stringdown Rd',0,'Aberdeen','OH','45101',NULL,'CY','39015','1972-05-25','M','',NULL,'N','021','HLT','2693691','92036OH004000601','2014-04-01','2014-02-26 12:27:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.74',NULL,0,'2014-02-26 21:02:38'),(28433,22499,'N','19','021','EC','A',NULL,NULL,'','0000547943','0000516972','','IL','1','Serio','Ameliah','','','','34','288134642','404 Webb St',0,'Saint Marys','OH','45885',NULL,'CY','39011','2007-10-26','F','',':RET:2106-3','N','021','HLT','3747252','92036OH003001505','2014-04-01','2014-03-06 18:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-03-07 21:31:10'),(17939,14333,'Y','18','021','EC','A','','','AC','0000565402','0000565402','TX00002509468','IL','1','strange','lola','','','','34','433988362','2475 FM 1462 RD',0,'ALVIN','TX','77511','8059','CY','48039','1954-03-26','F','M',':RET:2106-3','N','021','DEN','2546810','33348TX002000201','2014-02-01','2014-01-14 15:15:26','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-15 02:06:39'),(3623,2899,'N','19','021','EC','A',NULL,NULL,'','0001064709','0000351565','','S1','1','Riegler','John','','','','34','298112754','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','2006-06-04','M','',':RET:2106-3','N','021','HLT','1527827','52664OH151001501','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 21:23:44'),(5091,4035,'Y','18','024','14','A','','','TE','0001144712','0001144712','','IL','1','Hailey','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-18','F','',NULL,NULL,NULL,'','46066','','2013-12-19','2013-12-19 14:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:13'),(2756,2229,'Y','18','021','EC','A','','','AC','0001130193','0001130193','OH00001298090','IL','1','Elwell','James','','','','34','286823281','633 COBBLESTONE DR',0,'AMHERST','OH','44001','1967','CY','39093','1984-07-19','M','M',':RET:2106-3','N','021','HLT','32653','52664OH151001301','2014-01-01','2013-12-02 14:06:43','0.00',NULL,NULL,'281.45','281.45','R-OH011','OH0','281.45',NULL,0,'2013-12-25 19:49:12'),(6862,5441,'Y','18','024','14','A','','','TE','0000092463','0000092463','','IL','1','Bracken','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-09-09','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:31:42'),(2745,2222,'Y','18','021','EC','A','','','AC','0000796924','0000796924','OH00000187781','IL','1','Wells','Steven','','','','34','344467959','390-1 WINDWARD LN',0,'AURORA','OH','44202','8208','CY','39133','1952-10-04','M','M',':RET:2106-3','N','021','HLT','1116071','52664OH152000901','2014-01-01','2013-12-02 16:34:44','0.00',NULL,NULL,'902.30','902.30','R-OH012','OH0','458.99',NULL,0,'2013-12-25 19:48:55'),(19568,15600,'Y','18','021','EC','A','','','AC','0001781676','0001781676','LA00002306021','IL','1','APARICIO','BLANCA','','','','34','585726777','2716 HERO DR',0,'GRETNA','LA','70053','7530','CY','22051','1950-07-11','F','M',NULL,'N','021','DEN','2848313','18575LA002000201','2014-03-01','2014-01-22 14:14:27','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-23 03:02:36'),(21313,17030,'Y','18','021','EC','A','','','AC','0002144359','0002144359','LA00001927603','IL','1','THOMAS','CLEVELAND','','','','34','558196490','6913 RICE ROAD',0,'SHREVEPORT','LA','71129',NULL,'CY','22017','1968-01-04','M','U',NULL,'N','021','DEN','3301469','18575LA002000201','2014-03-01','2014-02-04 12:21:50','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-04 21:00:18'),(28586,22623,'N','19','021','EC','A',NULL,NULL,'','0001228127','0001036192','','IL','1','Jarrett','Riley','R','','','34','297060166','1677 ABBY DR',0,'NEWARK','OH','43055','9416','CY','39089','2002-04-06','F','',':RET:2106-3','N','021','DEN','3070144','99734OH005000401','2014-04-01','2014-03-07 18:00:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-08 21:30:00'),(9364,7423,'Y','18','021','EC','A','','','AC','0001326481','0001326481','LA00000119079','IL','1','Walter','Scott','Thomas','','','34','506177467','2702 CHARTRES ST',0,'NEW ORLEANS','LA','70117','7314','CY','22071','1973-02-04','M','U',':RET:2106-3','N','021','DEN','2441816','18575LA002000201','2014-01-01','2013-12-21 11:13:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:37'),(5160,4091,'Y','18','024','14','A','','','TE','0000234042','0000234042','','IL','1','Martin','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-31','F','',NULL,NULL,NULL,'','2530779','','2013-12-19','2013-12-19 10:37:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:02'),(3463,2782,'N','19','021','EC','A',NULL,NULL,'','0000139006','0000421458','','IL','1','Spieldenner','Emma','S','','','34','286023688','4424 BURNINGTREE DR',0,'TOLEDO','OH','43623','3186','CY','39095','1997-09-28','F','',':RET:2106-3','N','021','DEN','2500676','99734OH005000401','2014-01-01','2013-12-22 04:18:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:45'),(2905,2342,'Y','18','024','14','A','','','TE','0000678060','0000678060','','IL','1','Otchere','Baffour',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-20','M','',NULL,NULL,NULL,'','472829','','2013-12-05','2013-12-05 23:13:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:15:27'),(2806,2268,'Y','18','021','EC','A','','','AC','0000401208','0000401208','OH00000542089','IL','1','Metcalf','Cortney','','','','34','307024753','5241 NORFOLK ST',0,'LIMA','OH','45806','9465','CY','39003','1978-06-27','F','U',NULL,'N','021','HLT','718342','92036OH005001506','2014-01-01','2013-10-14 21:21:01','529.00',NULL,NULL,'560.55','31.55','R-OH002','OH0','268.93',NULL,0,'2013-12-25 20:00:05'),(5353,4246,'Y','18','021','EC','A','','','AC','0000961855','0000961855','OH00000334605','IL','1','Randolph','Julie','','','','34','287622287','4056 St Rt 84',0,'Kingsville','OH','44048',NULL,'CY','39007','1967-10-02','F','M',':RET:2106-3','T','021','HLT','1673857','52664OH152000901','2014-01-01','2013-12-19 15:25:28','648.92',NULL,NULL,'648.92','0.00','R-OH011','OH0','317.79',NULL,0,'2013-12-25 23:07:41'),(20481,16361,'N','01','021','EC','A',NULL,NULL,'','0000461959','0001071814','','IL','1','Klippel','Tina','','','','34','285621829','17 GRANGER RD',0,'MEDINA','OH','44256','8410','CY','39103','1958-09-29','F','',':RET:2106-3','N','021','HLT','3476682','52664OH151001304','2014-03-01','2014-01-28 20:02:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-01-29 21:01:01'),(20679,16525,'N','19','021','EC','A',NULL,NULL,'','0000167726','0001123643','','IL','1','Hassan','Aaidah','','','','34','713158380','643 LEAFY RDG',0,'SAN ANTONIO','TX','78251','4251','CY','48029','2012-04-01','F','',NULL,'N','021','DEN','3626848','33348TX002000101','2014-03-01','2014-01-29 19:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-01-30 21:00:54'),(22147,17678,'Y','18','021','EC','A','','','AC','0001094679','0001094679','OH00002161004','IL','1','Musmurati','Fitore','','','','34','136066915','1337 WARREN RD',0,'LAKEWOOD','OH','44107','2517','CY','39035','1985-08-07','F','U',':RET:2106-3','N','021','HLT','2748045','52664OH151001306','2014-03-01','2014-02-08 11:35:41','190.00',NULL,NULL,'273.40','83.40','R-OH011','OH0','273.40',NULL,0,'2014-02-08 19:00:52'),(23678,18854,'Y','18','021','EC','A','','','AC','0001953630','0001953630','LA00001811744','IL','1','Credeur','Brenda','','','','34','436230989','629 ASHTON ST',0,'NEW IBERIA','LA','70563','1860','CY','22045','1970-03-25','F','U',':RET:2106-3','N','021','DEN','2882826','18575LA002000201','2014-03-01','2014-02-14 11:32:24','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-14 21:30:29'),(26427,20960,'Y','18','021','EC','A','','','AC','0001141303','0001141303','TX00003337279','IL','1','powdrill','Sheila','j','','','34','455676997','1053 FM 2787',0,'JOAQUIN','TX','75954','5683','CY','48419','1964-07-26','F','M',NULL,'N','021','DEN','3025563','33348TX002000201','2014-04-01','2014-02-27 14:14:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-28 07:30:13'),(17854,14262,'Y','18','021','EC','A','','','AC','0000076321','0000076321','OH00001814873','31','1','Poynter','Ashley','','','','34','294929887','1 North Commerce Park Drive',0,'Lockland','OH','45215',NULL,'CY','39113','1990-09-26','F','U',':RET:2106-3','N','021','DEN','2131362','99734OH005000401','2014-02-01','2014-01-14 10:44:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:08'),(17795,14215,'Y','18','021','EC','A','','','AC','0000019128','0000019128','OH00001397602','IL','1','MILLER','LESLIE','','','','34','295467951','402 N PARK ST',0,'DESHLER','OH','43516','1138','CY','39069','1952-11-04','M','M',':RET:2106-3','N','021','HLT','2668564','92036OH001002601','2014-02-01','2014-01-13 15:52:50','93.00',NULL,NULL,'660.95','567.95','R-OH001','OH0','660.95',NULL,0,'2014-01-14 01:33:50'),(6879,5456,'Y','18','021','EC','A','','','AC','0000957868','0000957868','OH00000070999','IL','1','barbee','laquivia','','','','34','397065918','7815 CLOVERNOOK AVE',0,'CINCINNATI','OH','45231','3509','CY','39061','1990-08-31','F','U',':RET:2054-5','N','021','HLT','271776','92036OH006001201','2014-01-01','2013-11-02 19:35:42','0.00',NULL,NULL,'170.24','170.24','R-OH004','OH0','170.24',NULL,0,'2013-12-26 01:32:13'),(5201,4127,'Y','18','021','EC','A','','','AC','0000924772','0000924772','OH00000542782','31','1','meier','manfred','','','','34','286561917','34520 maple dr',0,'solon','OH','44139',NULL,'CY','39133','1954-09-22','M','U',':RET:2106-3','N','021','DEN','1928936','99734OH005000401','2014-01-01','2013-12-19 14:24:07','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:04:01'),(5117,4055,'Y','18','021','EC','A','','','AC','0000916063','0000916063','TX00001130135','31','1','NAIZER','NOEL','M','','','34','631031926','po box 412',0,'granger','TX','76530',NULL,'CY','48491','1987-12-07','F','U',':RET:2106-3','N','021','DEN','2076887','33348TX002000201','2014-01-01','2013-12-19 18:26:42','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:01:51'),(20920,16721,'Y','18','024','14','A','','','TE','0000086449','0000086449','','IL','1','Anderson','Keith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-16','M','',NULL,NULL,NULL,'','2784885','','2014-01-31','2014-01-31 11:08:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:32'),(22633,18074,'Y','18','021','EC','A','','','AC','0001165553','0001165553','TX00002343190','IL','1','Cardenas','Emeterio','','','','34','642033889','3851 LAS CASITAS DR',0,'EL PASO','TX','79938','9454','CY','48141','1964-02-28','M','M',NULL,'N','021','DEN','2874146','33348TX002000201','2014-03-01','2014-02-11 07:16:37','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-11 21:00:19'),(23986,19071,'Y','18','021','EC','A','','','AC','0001815615','0001815615','LA00002393367','IL','1','Derousselle','Danielle','','','','34','437495228','301 Prejean rd.',0,'Carenco','LA','70520',NULL,'CY','22055','1983-04-28','F','U',':RET:2054-5','N','021','DEN','3787500','18575LA002000201','2014-03-01','2014-02-15 12:57:34','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-15 22:00:23'),(28297,22388,'N','01','021','EC','A',NULL,NULL,'','0000198629','0000382223','','IL','1','Reddy','James','Martin','','','34','281883275','2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','1981-08-12','M','',':RET:2106-3','N','021','HLT','2876054','92036OH004000601','2014-04-01','2014-03-07 11:40:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.20','CIC',0,'2014-03-07 21:00:30'),(17889,14288,'Y','18','021','EC','A','','','AC','0000125578','0000125578','OH00001562818','IL','1','Pollock','Kari','','','','34','297903745','108 SHAFOR ST',0,'MIDDLETOWN','OH','45042','3270','CY','39017','1987-06-14','F','U',':RET:2106-3','N','021','DEN','2204837','99734OH005000401','2014-02-01','2014-01-14 15:37:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:19'),(16777,13421,'Y','18','021','EC','A','','','AC','0001130241','0001130241','OH00002115161','IL','1','Ramirez Francis','Sacha','','','','34','277801860','1076 PARKWAY DR',0,'GREENVILLE','OH','45331','2620','CY','39037','1978-06-28','F','M',':RET:2106-3','N','021','HLT','1492777','92036OH004000501','2014-02-01','2014-01-07 11:33:08','0.00',NULL,NULL,'591.56','591.56','R-OH003','OH0','233.56',NULL,0,'2014-01-08 18:25:04'),(14444,11521,'Y','18','021','EC','A','','','AC','0001258167','0001258167','LA00001459595','IL','1','Williams','Nikia','Beatrice','','','34','439473350','750 HARDING BLVD',0,'BATON ROUGE','LA','70807','5310','CY','22033','1976-04-22','F','U',':RET:2054-5','N','021','DEN','1861770','18575LA002000201','2014-02-01','2013-12-27 12:12:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-28 03:32:17'),(1134,933,'Y','18','021','EC','A','','','AC','0001048122','0001048122','LA00001310679','IL','1','reeves','laurie','','','','34','220869031','363 WHIPPOORWILL RD',0,'DERIDDER','LA','70634','7123','CY','22011','1965-03-20','F','M',':RET:2106-3','N','021','DEN','1195794','18575LA002000201','2014-01-01','2013-12-02 21:33:00','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 18:18:08'),(14113,11247,'Y','18','024','14','A','','','TE','0000902212','0000902212','','IL','1','Mathews','Elizabeth','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-01-25','F','',NULL,NULL,NULL,'','1513217','','2013-12-26','2013-12-26 14:16:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:01:54'),(6392,5067,'N','19','021','EC','A',NULL,NULL,'','0000566593','0000328386','','IL','1','ABBOTT','RACHEL','ANN','','','34','212518553','1917 TILDEN AVE',0,'CINCINNATI','OH','45212','2519','CY','39061','1997-04-19','F','',':RET:2106-3','N','021','DEN','1187027','99734OH005000301','2014-01-01','2013-12-11 11:44:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:11'),(3748,2998,'N','01','021','EC','A',NULL,NULL,'','0001030200','0001066171','','IL','1','Walsh','Julia','A','','','34','566907655','21520 HORSESHOE LOOP',0,'LAGO VISTA','TX','78645','4743','CY','48453','1951-10-13','F','',':RET:2106-3','N','021','DEN','238066','33348TX002000201','2014-01-01','2013-12-13 14:47:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:33:06'),(25737,20415,'N','19','021','EC','A',NULL,NULL,'','0001033720','0000037057','','S1','1','WILLSON','DEMETRIUS','','','','34','275174468','38718 AVENEL CT',0,'WILLOUGHBY','OH','44094','8068','CY','39085','2011-03-28','F','',':RET:2054-5','N','021','DEN','2970780','99734OH005000401','2014-04-01','2014-02-24 11:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:39'),(18260,14578,'Y','18','021','EC','A','','','AC','0001116709','0001116709','TX00002268550','31','1','CONSTANCIO','LOUIS','S','','','34','638034477','PO BOX 38',0,'SHADOWWATER','TX','79363',NULL,'CY','48303','1971-02-18','M','M',NULL,'N','021','DEN','2192775','33348TX002000201','2014-02-01','2014-01-15 16:39:42','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-01-16 08:44:36'),(13526,10783,'Y','18','021','EC','A','','','AC','0001516492','0001516492','LA00000867474','IL','1','Nunez','Kevin','','','','34','434813913','105 Firethorn DR',0,'Gretna','LA','70056',NULL,'CY','22051','1988-03-23','M','M',NULL,'N','021','DEN','2359656','18575LA002000201','2014-01-01','2013-12-23 10:44:59','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:20'),(2374,1936,'Y','18','021','EC','A','','','AC','0001227003','0001227003','OH00000644831','IL','1','MCINTYRE','CALVIN','','','','34','295484719','3565 HILDANA RD',0,'SHAKER HEIGHTS','OH','44120',NULL,'CY','39035','1950-03-02','M','U',NULL,'N','021','DEN','43672','99734OH005000401','2014-01-01','2013-12-09 09:47:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:32:49'),(2833,2289,'Y','18','024','14','A','','','TE','0000588228','0000588228','','IL','1','Dupont','Sheila',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-01-04','F','',NULL,NULL,NULL,'','104165','','2013-11-24','2013-11-24 16:27:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 20:00:49'),(1910,1562,'Y','18','021','EC','A','','','AC','0000828235','0000828235','OH00001243706','IL','1','Schultz','Martin','','','','34','276465911','5865 SQUIREHILL CT',0,'CINCINNATI','OH','45241','6021','CY','39061','1963-03-27','M','R',':RET:2106-3','N','021','HLT','1521879','92036OH003001201','2014-01-01','2013-12-24 17:57:54','0.00',NULL,NULL,'1309.66','1309.66','R-OH004','OH0','400.38',NULL,0,'2013-12-25 18:59:23'),(20554,16426,'Y','18','021','EC','A','','','AC','0000346923','0000346923','OH00002050323','IL','1','Crable','Mary','','','','34','284581497','517 WALSH ST',0,'TOLEDO','OH','43609','1960','CY','39095','1955-07-26','F','M',':RET:2106-3','T','021','HLT','2964992','92036OH004002601','2014-03-01','2014-01-29 11:47:38','929.00',NULL,NULL,'991.69','62.69','R-OH001','OH0','459.42',NULL,0,'2014-01-29 21:01:43'),(20650,16501,'Y','18','021','EC','A','','','AC','0001107812','0001107812','TX00001967907','IL','1','Bowden','Gregory','','','','34','457314224','1900 Elm St',0,'Dallas','TX','75201',NULL,'CY','48113','1960-07-23','M','U',NULL,'N','021','DEN','3125884','33348TX002000201','2014-03-01','2014-01-30 15:30:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:38'),(24182,19211,'Y','18','021','EC','A','','','AC','0000818631','0000818631','OH00002259745','IL','1','Barnhart','Tamara','','','','34','300801055','57 S MONROE ST',0,'MILLERSBURG','OH','44654','1424','CY','39075','1967-03-15','F','M',':RET:2106-3','N','021','HLT','3532059','52664OH151001304','2014-03-01','2014-02-15 21:18:17','639.00',NULL,NULL,'877.98','238.98','R-OH014','OH0','334.51',NULL,0,'2014-02-16 19:00:08'),(25510,20238,'N','01','021','EC','A',NULL,NULL,'','0000938584','0000414749','','IL','1','HOLSINGER','DEBRA','','','','34','285568235','420 SOUTH WEST ST.',0,'HILLSBORO','OH','45133',NULL,'CY','39071','1959-10-06','F','',NULL,'T','021','HLT','3814901','92036OH004000601','2014-04-01','2014-02-25 13:44:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','423.81',NULL,0,'2014-02-25 21:32:00'),(26894,21314,'Y','18','021','EC','A','','','AC','0000448339','0000448339','TX00002800255','IL','1','El-Jaber','Warde','Mohamad','','','34','634427091','19826 Beecham Lake Lane',0,'Richmond','TX','77407',NULL,'CY','48157','1958-09-23','F','M',':RET:2106-3','N','021','DEN','3791638','33348TX002000201','2014-04-01','2014-03-01 18:35:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-03 01:00:04'),(27382,21679,'Y','18','021','EC','A','','','AC','0001140056','0001140056','MS00003489882','31','1','GARRISON','CONNIE','DENISE','','','34','428029027','P.O. BOX 553',0,'VERONA','MS','38879',NULL,'CY','28081','1956-08-22','F','U',':RET:2106-3','N','021','DEN','3621084','46300MS002000201','2014-04-01','2014-03-03 18:20:54','0.00',NULL,NULL,'15.85','15.85','R-MS002','MS0','15.85',NULL,0,'2014-03-04 21:01:21'),(27531,21781,'Y','18','021','EC','A','','','AC','0001184945','0001184945','OH00002623088','IL','1','beane','wendy','','','','34','289903920','239 NEW MILFORD RD',0,'RAVENNA','OH','44266','3360','CY','39133','1989-08-31','F','U',':RET:2106-3','T','021','HLT','3551961','52664OH152001001','2014-04-01','2014-03-04 16:45:35','0.00',NULL,NULL,'141.00','141.00','R-OH012','OH0','141.00',NULL,0,'2014-03-04 21:02:47'),(15042,12024,'Y','18','021','EC','A','','','AC','0001178460','0001178460','LA00001315379','31','1','Hurst','Gail','','','','34','434881748','P.O. Box 505',0,'New Roads','LA','70760',NULL,'CY','22077','1949-10-10','F','U',':RET:2054-5','N','021','DEN','1703810','18575LA002000201','2014-02-01','2013-12-30 13:03:14','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:02:59'),(9336,7400,'Y','18','021','EC','A','','','AC','0001282446','0001282446','LA00000846950','31','1','ROSE','KILWANNA','M','','','34','436455062','P.O. BOX 1307',0,'BASTROP','LA','71221',NULL,'CY','22067','1981-12-23','F','U',':RET:2054-5','N','021','DEN','2499306','18575LA002000201','2014-01-01','2013-12-20 19:42:48','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 04:30:53'),(4606,3647,'Y','18','021','EC','A','','','AC','0000632669','0000632669','OH00001175806','IL','1','Wagner','Patricia','','','','34','284527087','665 JUDSON RD',0,'KENT','OH','44240','6052','CY','39133','1953-07-12','F','R',':RET:2106-3','N','021','HLT','671089','52664OH151001501','2014-01-01','2013-12-11 20:10:21','0.00',NULL,NULL,'725.90','725.90','R-OH012','OH0','725.90',NULL,0,'2013-12-25 22:05:50'),(946,780,'N','17','021','EC','A',NULL,NULL,'','0000321006','0000818533','','IL','1','Hall','Ariel','','','','34','271987833','218 BAKER ST',0,'LODI','OH','44254','1407','CY','39103','1994-10-11','F','',':RET:2106-3','N','021','DEN','133654','99734OH005000301','2014-01-01','2013-10-28 22:38:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:27'),(3765,3013,'Y','18','021','EC','A','','','AC','0001129005','0001129005','OH00001286737','IL','1','Spence','Janet','','','','34','268820327','104 CLEVELAND AVE',0,'DOYLESTOWN','OH','44230','1203','CY','39169','1979-05-29','F','U',':RET:2106-3','N','021','HLT','691252','52664OH151001306','2014-01-01','2013-12-13 12:54:24','0.00',NULL,NULL,'270.73','270.73','R-OH014','OH0','270.73',NULL,0,'2013-12-25 21:33:32'),(1980,1619,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','209848','','2013-11-19','2013-11-19 23:03:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:41'),(2601,2113,'Y','18','021','EC','A','','','AC','0000489205','0000489205','OH00000931566','IL','1','Roberts','Darryl','','','','34','289622356','2580 WOODRUFF CT',0,'WESTLAKE','OH','44145','2966','CY','39035','1964-06-12','M','R',':RET:2106-3','N','021','DEN','12307','99734OH005000401','2014-01-01','2013-12-01 21:12:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:45:20'),(22225,17740,'N','19','021','EC','A',NULL,NULL,'','0000473659','0001069327','','IL','1','Usberghi','Caitlin','Elizabeth','','','34','288965926','2940 8TH ST',0,'CUYAHOGA FALLS','OH','44221','1622','CY','39153','1993-09-12','F','',':RET:2106-3','N','021','HLT','3855626','52664OH151001305','2014-03-01','2014-02-09 17:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-09 19:00:29'),(24146,19186,'N','19','021','EC','A',NULL,NULL,'','0000444955','0000540339','','IL','1','Bingamon','Madison','','','','34','296044764','3533 NEALS CIR',0,'BATAVIA','OH','45103','9709','CY','39025','2000-04-01','F','',':RET:2106-3','N','021','HLT','3320747','92036OH004000601','2014-03-01','2014-02-15 11:05:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:54'),(27429,21708,'Y','18','021','EC','A','','','AC','0002218181','0002218181','LA00002774388','IL','1','JONES','CHRISTIAN','','','','34','433731053','609 MANCHESTER LN',0,'LAPLACE','LA','70068',NULL,'CY','22095','1988-11-02','F','U',':RET:2054-5','N','021','DEN','2620405','18575LA002000201','2014-04-01','2014-03-04 12:09:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:45'),(27473,21741,'Y','18','021','EC','A','','','AC','0001261262','0001261262','OH00003378971','31','1','Michaels','Lisa','','','','34','132621925','15767 BROOKVIEW TRL',0,'FINDLAY','OH','45840','8899','CY','39063','1964-08-06','F','U',':RET:2106-3','N','021','HLT','3329866','92036OH004001501','2014-04-01','2014-03-04 16:19:34','0.00',NULL,NULL,'301.91','301.91','R-OH002','OH0','301.91',NULL,0,'2014-03-04 21:02:12'),(27933,22096,'Y','18','021','EC','A','','','AC','0000930493','0000930493','TX00003562895','IL','1','SANCHEZ','JUAN','','','','34','460199670','8004 LAS CRUCES DR',0,'LAREDO','TX','78045','7029','CY','48479','1960-12-23','M','M',NULL,'N','021','DEN','3700873','33348TX002000201','2014-04-01','2014-03-06 12:22:51','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-03-06 21:00:27'),(8978,7121,'Y','18','021','EC','A','','','AC','0000982696','0000982696','OH00001128787','IL','1','Flower','Michelle','','','','34','268822818','226 SELDEN AVE',0,'AKRON','OH','44301','2949','CY','39153','1978-09-29','F','U',':RET:2106-3','N','021','DEN','1450198','99734OH005000401','2014-01-01','2013-12-18 15:39:43','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:04:14'),(13482,10750,'Y','18','021','EC','A','','','AC','0000477455','0000477455','OH00001366404','IL','1','Storey','David','','','','34','294821973','315 WASHINGTON AVE',0,'BARBERTON','OH','44203','2830','CY','39153','1984-11-25','M','U',':RET:2106-3','N','021','DEN','1707150','99734OH005000301','2014-01-01','2013-12-23 17:34:04','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:02:14'),(9681,7669,'N','19','021','EC','A',NULL,NULL,'','0000839048','0000886895','','IL','1','Hayden','Zoe','','','','34','276177675','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','2011-04-10','F','',':RET:2054-5^:RET:2106-3','N','021','HLT','1434306','92036OH001001201','2014-01-01','2013-12-21 11:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-26 04:39:29'),(25280,20057,'Y','18','024','14','A','','','TE','0000745350','0000745350','','IL','1','KERVIN','PENNY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-30','F','',NULL,NULL,NULL,'','117708','','2014-03-31','2014-02-25 13:51:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-25 21:00:17'),(27793,21983,'Y','18','021','EC','A','','','AC','0001258570','0001258570','MS00003124192','IL','1','Johnson','Barbara','','','','34','587327726','3654 PARKWAY AVE',0,'JACKSON','MS','39213','6014','CY','28049','1951-01-09','F','U',NULL,'N','021','DEN','2850715','46300MS002000201','2014-04-01','2014-03-05 15:30:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-05 21:31:41'),(28210,22323,'Y','18','024','14','A','','','TE','0001062169','0001062169','','IL','1','koontz','wendi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-05','F','',NULL,NULL,NULL,'','3713513','','2014-03-31','2014-03-06 12:51:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-06 21:30:13'),(68,61,'Y','18','021','EC','A','','','AC','0001256010','0001256010','OH00000225248','IL','1','Uhl','Stephen','','','','34','302527843','765 STORY DR',0,'FAIRFIELD','OH','45014','3633','CY','39017','1950-12-24','M','U',':RET:2106-3','N','021','DEN','183043','99734OH005000301','2014-01-01','2013-12-05 06:39:04','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:50'),(18210,14534,'Y','18','021','EC','A','','','AC','0000975253','0000975253','OH00002598188','IL','1','Leever','Carol','','','','34','287645274','5816 HIGH ST',0,'CINCINNATI','OH','45227','3518','CY','39061','1959-05-08','F','U',':RET:2106-3','N','021','HLT','2482867','92036OH002001201','2014-02-01','2014-01-14 15:23:18','340.00',NULL,NULL,'529.28','189.28','R-OH004','OH0','529.28',NULL,0,'2014-01-15 02:08:09'),(16169,12945,'Y','18','021','EC','A','','','AC','0001168536','0001168536','LA00001896320','IL','1','Manuel','Kaneisha','','','','34','439695456','8520 BELFAST ST',0,'NEW ORLEANS','LA','70118','3138','CY','22071','1987-07-15','F','U',NULL,'N','021','DEN','2523557','18575LA002000201','2014-02-01','2014-01-03 19:08:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-05 00:00:11'),(5573,4421,'Y','18','021','EC','A','','','AC','0000112899','0000112899','OH00000109196','IL','1','painter','frederick','','','','34','232271176','1344 WOODSMILL RD',0,'BIDWELL','OH','45614','9180','CY','39053','1975-04-08','M','U',':RET:2106-3','N','021','DEN','916809','99734OH005000401','2014-01-01','2013-11-05 20:41:32','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 23:16:44'),(6660,5283,'Y','18','021','EC','A','','','AC','0000162609','0000162609','TX00000918588','IL','1','fletcher','jerome','','','','34','466517152','1409 simon',0,'brenham','TX','77833',NULL,'CY','48477','1975-11-21','M','U',NULL,'N','021','DEN','700703','33348TX002000201','2014-01-01','2013-11-15 20:34:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:00:50'),(6657,5280,'Y','18','021','EC','A','','','AC','0000682117','0000682117','OH00000217007','IL','1','Fields','Taylor','','','','34','061783200','2341 E 74TH ST',0,'CLEVELAND','OH','44104','2023','CY','39035','1990-06-11','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','1059151','99734OH005000401','2014-01-01','2013-11-16 11:24:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:00:45'),(5363,4252,'N','01','021','EC','A',NULL,NULL,'','0001259994','0000687209','','IL','1','Young','Jacqueline','L','','','34','289529232','4355 BEAL RD',0,'FRANKLIN','OH','45005','4515','CY','39165','1952-06-21','F','',':RET:2106-3','N','021','HLT','2573194','92036OH005001201','2014-01-01','2013-12-18 19:52:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2013-12-25 23:07:54'),(5110,4049,'Y','18','021','EC','A','','','AC','0000049311','0000049311','TX00000540195','31','1','GARZA','MARIANELA','P','','','34','452902423','P O BOX 284',0,'HEBBRONVILLE','TX','78361',NULL,'CY','48247','1950-08-15','F','U',NULL,'N','021','DEN','1538097','33348TX002000201','2014-01-01','2013-12-19 17:43:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:01:39'),(3342,2678,'N','01','021','EC','A',NULL,NULL,'','0000236920','0001111850','','IL','1','Butler','Linda','Jean','','','34','468724354','756 WILTSHIRE DR',0,'HUTTO','TX','78634','5598','CY','48491','1954-11-28','F','',':RET:2106-3','N','021','DEN','1919557','33348TX002000201','2014-01-01','2013-12-21 19:17:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:16:30'),(3498,2809,'Y','18','021','EC','A','','','AC','0000876059','0000876059','OH00000177331','IL','1','Vo','Stanley','C','','','34','554652596','703 WYMAN ST',0,'TOLEDO','OH','43609','1140','CY','39095','1952-12-02','M','U',':RET:2028-9^:RET:2047-9','N','021','DEN','1974210','99734OH005000401','2014-01-01','2013-12-22 15:03:06','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:20:37'),(6182,4899,'Y','18','021','EC','A','','','AC','0000422775','0000422775','OH00000392612','IL','1','Boyd','Christina','','','','34','274707128','364 MCJUNKIN RD',0,'BLANCHESTER','OH','45107','7810','CY','39027','1965-03-25','F','U',NULL,'N','021','DEN','940982','99734OH005000401','2014-01-01','2013-10-22 20:55:33','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:30:05'),(23284,18562,'Y','18','024','14','A','','','TE','0002239319','0002239319','','IL','1','Nguyen','Aaron',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-31','M','',NULL,NULL,NULL,'','2431866','','2014-02-28','2014-02-13 15:48:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-13 21:30:17'),(26407,20943,'Y','18','024','14','A','','','TE','0000413399','0000413399','','IL','1','barnett','wendy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-08-31','F','',NULL,NULL,NULL,'','3629635','','2014-03-31','2014-02-26 13:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:36'),(9543,7563,'Y','18','021','EC','A','','','AC','0000570552','0000570552','OH00000549531','IL','1','Kobistek','Robert','','','','34','283568853','5589 CARDINAL DR',0,'MENTOR','OH','44060','1841','CY','39085','1954-09-25','M','R',':RET:2106-3','N','021','DEN','1397616','99734OH005000301','2014-01-01','2013-12-21 11:57:29','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:36:04'),(18498,14754,'N','01','021','EC','A',NULL,NULL,'','0000142850','0001019294','','IL','1','ARRIGO','LISA','M','','','34','297629493','6871 BRECK CT',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1967-03-12','F','',NULL,'N','021','HLT','2707604','52664OH151001306','2014-02-01','2014-01-15 16:19:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','377.28',NULL,0,'2014-01-16 08:46:28'),(18134,14480,'N','01','021','EC','A',NULL,NULL,'','0000542703','0000525601','','IL','1','BRADEN-HUGHETT','KATHERINE','','','','34','271787557','4208 BROOKSIDE AVE',0,'CINCINNATI','OH','45223','2102','CY','39061','1981-06-21','F','',':RET:2106-3','N','021','HLT','1403598','92036OH004001201','2014-02-01','2014-01-14 17:34:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.20',NULL,0,'2014-01-15 02:07:44'),(17758,14189,'Y','18','021','EC','A','','','AC','0000685865','0000685865','OH00001775354','IL','1','collie','ray','','','','34','287844118','126 BARNUM ST',0,'LIBERTY TWP','OH','45011','2534','CY','39017','1984-11-19','M','U',':RET:2106-3','N','021','HLT','1822071','92036OH003001201','2014-02-01','2014-01-13 12:17:27','0.00',NULL,NULL,'250.85','250.85','R-OH004','OH0','250.85',NULL,0,'2014-01-14 01:33:32'),(8993,7135,'Y','18','021','EC','A','','','AC','0000004706','0000004706','OH00000018697','IL','1','Stahl-Frakes','Wendy','','','','34','291448049','1407 BROOK LAWN',0,'FINDLAY','OH','45840','8104','CY','39063','1960-04-11','F','M',':RET:2106-3','N','021','DEN','2553857','99734OH005000401','2014-01-01','2013-12-18 17:31:24','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:04:37'),(16513,13210,'Y','18','021','EC','A','','','AC','0000276489','0000276489','TX00001443098','IL','1','Foss','Amanda','','','','34','541396111','3613 N walnut avenue',0,'odessa','TX','79761',NULL,'CY','48135','1992-02-09','F','U',':RET:2106-3','N','021','DEN','1576364','33348TX002000201','2014-02-01','2014-01-04 19:45:46','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,1,'2014-01-07 10:21:25'),(15576,12463,'N','01','021','EC','A',NULL,NULL,'','0000816437','0000830644','','IL','1','Smith','Charles','Robert','','Jr','34','268740679','303 W WASHINGTON ST',0,'MEDINA','OH','44256','2236','CY','39103','1967-06-15','M','',':RET:2106-3','T','021','HLT','2193769','52664OH151001306','2014-02-01','2013-12-31 15:28:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','384.69',NULL,1,'2014-01-02 04:32:01'),(15565,12455,'Y','18','024','14','A','','','TE','0000413362','0000413362','','IL','1','Shaheen','Terrie','Lee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-08','F','',NULL,NULL,NULL,'','2251373','','2013-12-31','2013-12-31 12:42:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:31:43'),(21756,17372,'N','01','021','EC','A',NULL,NULL,'','0000560630','0001230926','','IL','1','Guajardo','Jose','Luis','','','34','632182115','206 DE GAIL ST',0,'GRAND SALINE','TX','75140','1332','CY','48467','1974-12-16','M','',NULL,'N','021','DEN','2767043','33348TX002000201','2014-03-01','2014-02-05 23:39:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:23'),(26180,20761,'Y','18','021','EC','A','','','AC','0000609592','0000609592','OH00002460666','IL','1','Velez','Keishla','','','','34','599268714','8303 DENISON AVE',0,'CLEVELAND','OH','44102','5405','CY','39035','1989-12-22','F','U',NULL,'N','021','DEN','2899902','99734OH005000301','2014-04-01','2014-02-26 20:07:21','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:40'),(27699,21906,'Y','18','021','EC','A','','','AC','0000428667','0000428667','TX00002488201','31','1','Brooks','Kimberly','','','','34','466932364','PO BOX 631',0,'Tomball','TX','77377',NULL,'CY','48339','1975-09-12','F','M',NULL,'N','021','DEN','2896425','33348TX002000201','2014-04-01','2014-03-05 11:52:56','0.00',NULL,NULL,'112.74','112.74','R-TX010','TX0','15.85',NULL,0,'2014-03-05 21:30:48'),(27761,21952,'N','01','021','EC','A',NULL,NULL,'','0001957147','0001963585','','IL','1','WARD','SHANQUILLE','','','','34','434855400','11555 SOUTHFORK AVE',0,'BATON ROUGE','LA','70816','2269','CY','22033','1988-11-16','M','',NULL,'N','021','DEN','3278867','18575LA002000201','2014-04-01','2014-03-05 11:34:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-05 21:31:20'),(28428,22496,'Y','18','021','EC','A','','','AC','0000108209','0000108209','OH00002639964','IL','1','RENTSCHLER','CINDY','','','','34','296608590','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247',NULL,'CY','39061','1962-03-18','F','U',':RET:2106-3','N','021','DEN','3840127','99734OH005000401','2014-04-01','2014-03-07 15:59:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:31:07'),(23342,18604,'N','19','021','EC','A',NULL,NULL,'','0000110556','0000011199','','IL','1','Bencina','Kyle','Joseph','','','34','286060843','38278 Roselawn Street',0,'Willoughby','OH','44094',NULL,'CY','39085','2001-08-17','M','',NULL,'N','021','HLT','3683295','52664OH151001305','2014-03-01','2014-02-12 21:48:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-02-13 22:00:38'),(27189,21527,'N','01','021','EC','A',NULL,NULL,'','0000315634','0000879243','','IL','1','PEREZ','SERGIO','','','','34','644032982','21835 FM 493',0,'ELSA','TX','78543',NULL,'CY','48215','1962-01-16','M','',NULL,'N','021','DEN','3173272','33348TX002000201','2014-04-01','2014-03-03 15:44:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:15'),(27748,21942,'Y','18','021','EC','A','','','AC','0002219406','0002219406','LA00003412833','31','1','WALKER','CHEYENNE','','','','34','436411676','PO BOX 872864',0,'NEW ORLEANS','LA','70187',NULL,'CY','22071','1976-08-14','F','U',':RET:2054-5','N','021','DEN','3164434','18575LA002000201','2014-04-01','2014-03-04 19:08:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:13'),(16293,13044,'Y','18','021','EC','A','','','AC','0000399903','0000399903','OH00002248878','IL','1','Warren','Jean','','','','34','292524851','316 LEGACY WAY',0,'HARRISON','OH','45030','8219','CY','39061','1955-02-02','F','U',':RET:2106-3','N','021','DEN','1655538','99734OH005000401','2014-02-01','2014-01-06 17:46:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:55'),(584,479,'Y','18','021','EC','A','','','AC','0000078731','0000078731','OH00000970618','IL','1','Morris','Erica','','','','34','302841214','4263 IVY POINTE BLVD',0,'CINCINNATI','OH','45245','1037','CY','39025','1986-07-20','F','U',NULL,'N','021','HLT','29954','92036OH003000605','2014-01-01','2013-12-04 08:01:06','73.00',NULL,NULL,'234.93','161.93','R-OH005','OH0','234.93',NULL,0,'2013-12-25 17:51:00'),(1086,892,'Y','18','021','EC','A','','','AC','0000546441','0000546441','OH00000391635','IL','1','Curtis','Esther','','','','34','521820365','111 Cromwell Drive',0,'Geneva','OH','44041',NULL,'CY','39007','1954-10-22','F','M',':RET:2106-3','N','021','DEN','207264','99734OH005000401','2014-01-01','2013-12-03 13:21:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:55'),(15864,12702,'N','01','021','EC','A',NULL,NULL,'','0000200446','0000305196','','IL','1','Rooker','Brian','S','','','34','428638269','711 S MIDDLE ST',0,'RIPLEY','MS','38663','2722','CY','28139','1987-08-24','M','',':RET:2106-3','N','021','DEN','1987830','46300MS002000101','2014-02-01','2014-01-02 12:36:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-03 02:04:52'),(7564,5987,'N','01','021','EC','A',NULL,NULL,'','0001102074','0000150632','','IL','1','Hattar','Barbara',NULL,NULL,NULL,NULL,NULL,'3906 JEFFERSON LN',0,'AMELIA','OH','45102','1180','CY','39025','1982-04-28','F','',NULL,'N','021','HLT','1174461','92036OH006000601','2014-01-01','2013-12-15 09:24:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','197.32',NULL,0,'2013-12-26 02:33:34'),(23904,19015,'Y','18','021','EC','A','','','AC','0000111939','0000111939','OH00002812606','IL','1','COLLINS','JANICE','','','','34','300486268','4091 RANGER DR',0,'NORTHWOOD','OH','43619','2052','CY','39173','1951-10-02','F','U',NULL,'N','021','HLT','3234531','92036OH005002605','2014-03-01','2014-02-14 15:03:42','448.00',NULL,NULL,'560.22','112.22','R-OH001','OH0','560.22',NULL,0,'2014-02-14 21:32:26'),(25351,20116,'Y','18','024','14','A','','','TE','0002030434','0002030434','','IL','1','Johnson','Money',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-06','M','',NULL,NULL,NULL,'','2839728','','2014-03-31','2014-02-25 11:52:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-25 21:30:31'),(25588,20299,'Y','18','024','14','A','','','TE','0001841406','0001841406','','IL','1','Alcala','Rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-02-05','F','',NULL,NULL,NULL,'','2731862','','2014-02-24','2014-02-24 14:02:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-26 08:00:41'),(27232,21564,'N','19','021','EC','A',NULL,NULL,'','0001117315','0000078830','','IL','1','Montague','Simone','','','','34','301130003','131 Noran Circle',0,'Bedford','OH','44146',NULL,'CY','39035','2008-07-02','F','',':RET:2054-5','N','021','HLT','3879202','92036OH004000801','2014-04-01','2014-03-02 21:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.38',NULL,0,'2014-03-03 21:31:42'),(27925,22089,'Y','18','024','14','A','','','TE','0000891301','0000891301','','IL','1','Obale','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-01-16','F','',NULL,NULL,NULL,'','3832135','','2014-03-05','2014-03-05 23:26:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-06 21:00:22'),(28811,22804,'Y','18','021','EC','A','','','AC','0000053121','0000053121','OH00003353711','IL','1','McKee','Richard','','','','34','291429407','1550 Co. Rd. 175',0,'Jeromesville','OH','44840',NULL,'CY','39005','1957-01-22','M','M',':RET:2106-3','N','021','HLT','3524890','52664OH151001305','2014-04-01','2014-03-09 11:43:32','849.00',NULL,NULL,'978.78','129.78','R-OH012','OH0','543.47',NULL,0,'2014-03-09 21:00:54'),(18224,14545,'Y','18','021','EC','A','','','AC','0000889806','0000889806','TX00001998463','IL','1','Gray','Justin','','','','34','641011869','1471 Anderson County Road 1224',0,'Elkhart','TX','75839',NULL,'CY','48001','1988-08-29','M','U',':RET:2106-3','N','021','DEN','2061317','33348TX002000201','2014-02-01','2014-01-14 19:38:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:15'),(788,650,'Y','18','021','EC','A','','','AC','0000826817','0000826817','TX00001065110','IL','1','Smith','Warren',NULL,NULL,NULL,NULL,NULL,'2108 WOOD ST',0,'TEXARKANA','TX','75501','3973','CY','48037','1962-10-05','M','U',NULL,'N','021','DEN','1933311','33348TX002000201','2014-01-01','2013-12-16 15:44:27','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 18:05:14'),(17210,13772,'Y','18','021','EC','A','','','AC','0000983847','0000983847','OH00001614031','IL','1','LOUCKS','DEBRA','','','','34','279507365','525 TAYLOR AVE',0,'AKRON','OH','44312','3573','CY','39153','1951-03-26','F','U',':RET:2106-3','N','021','HLT','2452037','52664OH151001304','2014-02-01','2014-01-08 11:03:18','455.00',NULL,NULL,'640.70','185.70','R-OH012','OH0','640.70',NULL,0,'2014-01-13 02:22:29'),(9345,7407,'Y','18','021','EC','A','','','AC','0002283735','0002283735','LA00000749146','IL','1','JOHNSON','KEITH','','','','34','438984587','331 FACIANE LN',0,'SLIDELL','LA','70460','3519','CY','22103','1956-05-21','M','M',':RET:2106-3','N','021','DEN','2151811','18575LA002000201','2014-01-01','2013-12-20 22:09:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:05'),(6985,5542,'N','01','021','EC','A',NULL,NULL,'','0000498167','0000700383','','IL','1','Graven','Lori','','','','34','302568283','9213 ROANOKE CT',0,'NORTH ROYALTON','OH','44133','1777','CY','39035','1958-01-01','F','',':RET:2106-3','N','021','DEN','1534400','99734OH005000401','2014-02-01','2013-12-25 00:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:50'),(6548,5192,'Y','18','021','EC','A','','','AC','0000776704','0000776704','TX00000505625','IL','1','LAHAYE','RICHARD','','','Jr','34','545338586','16139 OLD STABLE RD',0,'SAN ANTONIO','TX','78247','4490','CY','48029','1958-08-18','M','U',':RET:2106-3','N','021','DEN','115325','33348TX002000201','2014-01-01','2013-12-11 11:38:20','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-26 00:52:06'),(5988,4740,'Y','18','024','14','A','','','TE','0000060243','0000060243','','IL','1','SELKA','STEVEN','ALAN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-02','M','',NULL,NULL,NULL,'','1759961','','2013-12-24','2013-12-24 01:36:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:52:08'),(2512,2047,'Y','18','021','EC','A','','','AC','0000812333','0000812333','MS00000692245','IL','1','HOOD','ANITERA','','','','34','428373640','4840 SANDYLAND RD',0,'MACON','MS','39341','3235','CY','28103','1979-10-20','F','U',':RET:2054-5','N','021','DEN','281844','46300MS002000101','2014-01-01','2013-12-08 23:54:52','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 19:36:20'),(20397,16292,'N','01','021','EC','A',NULL,NULL,'','0000033427','0000436986','','IL','1','GARCIA','ANITA','','','','34','465853726','1999 FM 975',0,'CALDWELL','TX','77836','6345','CY','48051','1966-07-26','F','',NULL,'N','021','DEN','2747834','33348TX002000201','2014-03-01','2014-01-29 13:03:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:18'),(24349,19338,'Y','18','021','EC','A','','','AC','0000034595','0000034595','TX00002304478','IL','1','Bonilla','Maria','Esther','','','34','639150846','703 LA MANCHA DR',0,'EDINBURG','TX','78541','5648','CY','48215','1959-12-21','F','U',':RET:2106-3','N','021','DEN','3213077','33348TX002000201','2014-04-01','2014-02-18 17:23:22','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-18 22:00:26'),(25463,20202,'N','01','021','EC','A',NULL,NULL,'','0000996557','0000042322','','IL','1','Parrott','Janine','Kaye','','','34','512506892','3016 Highgate Ln',0,'Bedford','TX','76021',NULL,'CY','48439','1950-12-14','F','',':RET:2106-3','N','021','DEN','3623303','33348TX002000201','2014-04-01','2014-02-25 15:48:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-25 21:31:33'),(26515,21031,'Y','18','021','EC','A','','','AC','0000294433','0000294433','OH00003546114','IL','1','Dietrich','Keith','','','','34','298720882','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1975-07-03','M','M',NULL,'N','021','HLT','3280933','92036OH003002706','2014-03-01','2014-02-28 14:25:52','679.00',NULL,NULL,'769.34','90.34','R-OH006','OH0','253.74','CIC',0,'2014-02-28 21:00:22'),(26604,21093,'Y','18','024','14','A','','','TE','0000213550','0000213550','','IL','1','Bean','Catherine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-15','F','',NULL,NULL,NULL,'','3006575','','2014-02-27','2014-02-27 20:02:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:43'),(28487,22540,'Y','18','021','EC','A','','','AC','0000844765','0000844765','OH00003718597','IL','1','Graf','Nancy','','','','34','302667411','5254 WARREN AVE',0,'CINCINNATI','OH','45212','1418','CY','39061','1967-12-08','F','U',':RET:2106-3','N','021','DEN','4093977','99734OH005000301','2014-04-01','2014-03-07 16:29:49','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:31:39'),(18893,15053,'Y','18','021','EC','A','','','AC','0000304734','0000304734','OH00001726663','IL','1','Eihinger','Treva','','','','34','270501494','2836 South Cleveland Massillon Rd',0,'Norton','OH','44203',NULL,'CY','39153','1949-10-15','F','M',':RET:2106-3','N','021','HLT','3039895','52664OH151001501','2014-03-01','2014-01-16 10:11:31','417.00',NULL,NULL,'802.38','385.38','R-OH012','OH0','802.38',NULL,0,'2014-01-17 03:36:33'),(9147,7254,'Y','18','021','EC','A','','','AC','0000078753','0000078753','OH00000528641','IL','1','Kaplansky','Jody','','','','34','299744537','12075 Waywood Dr',0,'Twinsburg','OH','44087',NULL,'CY','39153','1957-08-06','F','R',':RET:2106-3','N','021','HLT','1740647','52664OH151001501','2014-01-01','2013-12-18 11:46:52','0.00',NULL,NULL,'624.00','624.00','R-OH012','OH0','624.00',NULL,0,'2013-12-26 04:08:19'),(8832,7001,'N','01','021','EC','A',NULL,NULL,'','0001196526','0001085858','','IL','1','Stotler','Chad','','','','34','521611906','2118A HIDDEN HOLLOW CIR',0,'BRYAN','TX','77807','2229','CY','48041','1982-08-21','M','',':RET:2106-3','N','021','DEN','2445760','33348TX002000201','2014-01-01','2013-12-17 20:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:00:32'),(17874,14279,'Y','18','021','EC','A','','','AC','0001126890','0001126890','OH00002175072','IL','1','Vollmer','Daniel','','','','34','286744952','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','1979-03-06','M','R',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(17439,13951,'Y','18','021','EC','A','','','AC','0000172424','0000172424','OH00002160371','IL','1','Matheny','Rhonda','','','','34','291721968','16168 Co. Rd. M1',0,'Napoleon','OH','43545',NULL,'CY','39069','1963-06-15','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','1612339','92036OH004002601','2014-02-01','2014-01-10 10:09:56','0.00',NULL,NULL,'280.03','280.03','R-OH001','OH0','280.03',NULL,0,'2014-01-13 03:00:35'),(16755,13404,'Y','18','021','EC','A','','','AC','0000337566','0000337566','TX00002294978','IL','1','PREVOST','JANICE','L','','','34','454295059','5927 ALMEDA RD',0,'HOUSTON','TX','77004','7791','CY','48201','1963-12-09','F','U',':RET:2054-5','N','021','DEN','1787575','33348TX002000101','2014-02-01','2014-01-07 17:59:51','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-08 18:24:56'),(4205,3344,'Y','18','021','EC','A','','','AC','0000888495','0000888495','TX00000735882','IL','1','HERNANDEZ','ELIDA','','','','34','467947712','3014 GUADALUPE ST',0,'SAN ANGELO','TX','76901','2811','CY','48451','1949-09-26','F','U',NULL,'N','021','DEN','1563211','33348TX002000201','2014-01-01','2013-12-16 20:35:17','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 21:50:01'),(5001,3966,'Y','18','021','EC','A','','','AC','0000520931','0000520931','OH00001252637','IL','1','kellam','tracy','','','','34','298804773','23 BENTLEY ST',0,'HUBBARD','OH','44425','2003','CY','39155','1980-01-28','F','U',':RET:2054-5','N','021','DEN','1103679','99734OH005000301','2014-01-01','2013-12-07 12:32:06','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 22:47:08'),(5140,4074,'Y','18','021','EC','A','','','AC','0000757127','0000757127','OH00000694929','IL','1','Nailon','Jeannetta','','','','34','299521396','5618 SUGARBERRY CT',0,'CINCINNATI','OH','45224','3249','CY','39061','1954-11-21','F','U',':RET:2054-5','N','021','DEN','1473737','99734OH005000401','2014-01-01','2013-12-18 20:11:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:02:30'),(19737,15729,'N','01','021','EC','A',NULL,NULL,'','0002268065','0001475389','','IL','1','SMITH','RONNIE','','','','34','436989112','111 MAYS DR',0,'MONROE','LA','71202','7213','CY','22073','1954-01-16','M','',NULL,'N','021','DEN','2793326','18575LA002000201','2014-03-01','2014-01-23 14:52:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 21:01:09'),(22810,18204,'N','01','021','EC','A',NULL,NULL,'','0000806393','0000688325','','IL','1','KAUR','PARAMJIT',NULL,NULL,NULL,NULL,NULL,'7615 SHADOW CREEK DR',0,'HAMILTON','OH','45011','6541','CY','39017','1984-02-06','F','',NULL,'N','021','DEN','3180986','99734OH005000301','2014-03-01','2014-02-11 15:05:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:57'),(22963,18308,'Y','18','021','EC','A','','','AC','0000288334','0000288334','OH00001830219','IL','1','Neal','Shannon','','','','34','284769659','704 EUCLID AVE',0,'DELPHOS','OH','45833','2117','CY','39003','1969-06-27','F','R',':RET:2106-3','N','021','HLT','3256038','92036OH006001501','2014-03-01','2014-02-12 11:41:34','0.00',NULL,NULL,'243.84','243.84','R-OH002','OH0','243.84','CIC',0,'2014-02-12 21:00:11'),(25598,20309,'Y','18','021','EC','A','','','AC','0000436651','0000436651','OH00003156019','IL','1','Santiago','Elijah','','','','34','299905672','3412 CEDARBROOK DR',0,'TOLEDO','OH','43615','1603','CY','39095','1989-04-02','M','U',NULL,'N','021','HLT','3215882','92036OH004002601','2014-04-01','2014-02-24 16:23:49','100.00',NULL,NULL,'156.79','56.79','R-OH001','OH0','156.79','CIC',0,'2014-02-26 08:00:47'),(27847,22026,'N','01','021','EC','A',NULL,NULL,'','0000315634','0000879243','','IL','1','PEREZ','SERGIO','','','','34','644032982','21835 FM 493',0,'ELSA','TX','78543',NULL,'CY','48215','1962-01-16','M','',NULL,'N','021','DEN','3498898','33348TX002000101','2014-04-01','2014-03-05 13:28:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-05 21:32:11'),(13259,10581,'N','01','021','EC','A',NULL,NULL,'','0001115546','0001017599','','IL','1','Pipkin','Janet','','','','34','412025474','9102 BARTON CREEK DR',0,'ROWLETT','TX','75089','2637','CY','48397','1954-09-06','F','',':RET:2106-3','N','021','DEN','2516707','33348TX002000201','2014-01-01','2013-12-23 11:44:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:56:37'),(1373,1138,'Y','18','021','EC','A','','','AC','0000192438','0000192438','TX00001311637','IL','1','bustos','marco','','','','34','635228199','9408 PRESTHOPE DR',0,'FRISCO','TX','75035','5765','CY','48085','1985-01-08','M','U',':RET:2106-3','N','021','DEN','2225571','33348TX002000101','2014-01-01','2013-12-24 17:31:26','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:45:51'),(18492,14749,'Y','18','021','EC','A','','','AC','0000732609','0000732609','OH00002042294','IL','1','Wesie','Christine','','','','34','234941413','29 TUDOR LN',0,'KENT','OH','44240','7272','CY','39133','1957-02-14','F','U',NULL,'N','021','HLT','2834814','52664OH151001305','2014-02-01','2014-01-15 09:04:46','387.00',NULL,NULL,'520.28','133.28','R-OH012','OH0','520.28',NULL,0,'2014-01-16 08:46:26'),(16699,13364,'Y','18','021','EC','A','','','AC','0001090658','0001090658','TX00001438917','IL','1','Camacho','Humberto','','','Sr','34','565558172','2183 SUNCREST DR',0,'EAGLE PASS','TX','78852','3224','CY','48323','1961-09-16','M','M',NULL,'N','021','DEN','2094169','33348TX002000201','2014-02-01','2014-01-07 16:10:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:38'),(5171,4102,'Y','18','021','EC','A','','','AC','0000633730','0000633730','OH00001077452','IL','1','Conti','Falon','','','','34','285861196','2270 Winter Parkway',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1987-03-21','F','U',':RET:2106-3','N','021','DEN','2247613','99734OH005000401','2014-01-01','2013-12-19 11:22:49','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:03:19'),(21002,16781,'Y','18','021','EC','A','','','AC','0001935595','0001935595','LA00002525697','IL','1','CARNEY','CAROLINE','','','','34','415457464','3920 PERRIER ST',0,'NEW ORLEANS','LA','70115','3740','CY','22071','1983-11-13','F','U',':RET:2106-3','N','021','DEN','2569033','18575LA002000101','2014-03-01','2014-01-31 21:37:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-01 19:00:29'),(22378,17871,'Y','18','021','EC','A','','','AC','0000834499','0000834499','OH00002207338','IL','1','NEILL','KIMBALL','LAURENCE','','','34','268522107','2244 RIDGEWOOD RD',0,'AKRON','OH','44313','4465','CY','39153','1956-11-08','M','U',':RET:2106-3','N','021','HLT','3858739','52664OH151001306','2014-03-01','2014-02-09 18:34:26','438.00',NULL,NULL,'543.47','105.47','R-OH012','OH0','543.47',NULL,0,'2014-02-10 21:30:07'),(22766,18176,'N','01','021','EC','A',NULL,NULL,'','0000910560','0000720290','','IL','1','MINGASSOUBA','AISSETOU','','','','34','302158452','3659 EMERY CLUB WAY',0,'COLUMBUS','OH','43219','3160','CY','39049','1982-12-21','F','',':RET:2054-5','N','021','DEN','3211853','99734OH005000401','2014-03-01','2014-02-11 11:32:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:35'),(24708,19617,'Y','18','021','EC','A','','','AC','0000089877','0000089877','OH00002764978','IL','1','Phillips','Rhonda','','','','34','284689766','2739 TownTerrace',0,'Cincinnati','OH','45251',NULL,'CY','39061','1963-01-29','F','U',':RET:2054-5','N','021','DEN','3187442','99734OH005000401','2014-04-01','2014-02-19 00:11:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:35:24'),(25281,20058,'Y','18','021','EC','A','','','AC','0000745350','0000745350','TX00001760927','IL','1','KERVIN','PENNY','','','','34','445549990','10865 COLONIAL HEIGHTS LANE',0,'FORT WORTH','TX','76179',NULL,'CY','48439','1953-01-30','F','U',NULL,'N','021','DEN','2954429','33348TX002000201','2014-04-01','2014-02-25 13:51:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-25 21:00:17'),(26373,20921,'Y','18','021','EC','A','','','AC','0000188899','0000188899','OH00002311298','IL','1','Hammond','Nana','','','','34','093593295','7171 AUSTRIAN WAY',0,'REYNOLDSBURG','OH','43068','5626','CY','39049','1987-03-06','F','U',':RET:2054-5','N','021','DEN','3767997','99734OH005000401','2014-04-01','2014-02-26 15:56:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-28 07:00:13'),(27134,21481,'Y','18','021','EC','A','','','AC','0001184944','0001184944','OH00002570356','IL','1','Madison','Michelle','','','','34','291623252','20112 Sunset Drive',0,'Warrensville Hts','OH','44122',NULL,'CY','39035','1966-04-27','F','U',':RET:2054-5','N','021','DEN','2775754','99734OH005000401','2014-04-01','2014-03-03 08:40:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:42'),(14053,11197,'Y','18','021','EC','A','','','AC','0000539287','0000539287','OH00001772698','IL','1','Bohlmann','Jeffrey','','','','34','294863389','4206 Colister Dr',0,'Dublin','OH','43016',NULL,'CY','39049','1979-09-14','M','U',':RET:2106-3','T','021','DEN','2183560','99734OH005000301','2014-02-01','2013-12-26 15:47:38','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:21'),(7966,6305,'N','19','021','EC','A',NULL,NULL,'','0001181843','0001246291','','IL','1','BROWN','EDISON','T','','III','34','427877734','106 COTTON ACRES DR',0,'CLINTON','MS','39056',NULL,'CY','28049','1999-12-27','M','',':RET:2054-5','N','021','DEN','1642156','46300MS002000201','2014-01-01','2013-12-20 14:45:29',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2013-12-26 03:07:33'),(6117,4851,'Y','18','021','EC','A','','','AC','0000514409','0000514409','OH00000044967','IL','1','Davis','Andrea','Nicole','','','34','286926819','38 BORTON AVE',0,'AKRON','OH','44302','1012','CY','39153','1990-07-03','F','U',':RET:2106-3','N','021','HLT','902404','52664OH151001306','2014-01-01','2013-11-21 12:46:03','150.00',NULL,NULL,'223.01','73.01','R-OH012','OH0','223.01',NULL,0,'2013-12-26 00:15:39'),(18146,14491,'Y','18','021','EC','A','','','AC','0001767790','0001767790','LA00001535424','IL','1','SKIPPER','DEBBIE','L','','','34','433118819','706 KELLI DR',0,'PATTERSON','LA','70392','4214','CY','22101','1966-01-03','F','M',':RET:2054-5','N','021','DEN','1802786','18575LA002000101','2014-02-01','2014-01-14 16:36:15','0.00',NULL,NULL,'50.04','50.04','R-LA003','LA0','25.02',NULL,0,'2014-01-15 02:07:48'),(17198,13762,'Y','18','021','EC','A','','','AC','0000111909','0000111909','OH00001827232','IL','1','lee','brandon','','','','34','285847273','3486 bent tree lane',0,'stow','OH','44224',NULL,'CY','39153','1986-04-09','M','R',':RET:2106-3','N','021','HLT','1513504','52664OH152000901','2014-02-01','2014-01-07 22:05:08','0.00',NULL,NULL,'171.18','171.18','R-OH012','OH0','171.18',NULL,0,'2014-01-13 02:22:22'),(16596,13274,'N','01','021','EC','A',NULL,NULL,'','0001202214','0001312768','','IL','1','VALLIER','DARRELL','','','','34','437029432','412 SUNSET DR',0,'LAFAYETTE','LA','70501','3742','CY','22055','1957-12-16','M','',':RET:2054-5','T','021','DEN','1499367','18575LA002000201','2014-02-01','2014-01-07 07:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-08 18:24:02'),(20614,16472,'Y','18','021','EC','A','','','AC','0001249447','0001249447','LA00002225027','IL','1','blanson','danielle','','','','34','433631416','1013 Manhattan Blvd',0,'harvey','LA','70058',NULL,'CY','22051','1977-12-11','F','U',':RET:2054-5','N','021','DEN','1662962','18575LA002000101','2014-03-01','2014-01-30 11:53:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-30 21:00:20'),(21975,17549,'Y','18','024','14','A','','','TE','0000969478','0000969478','','IL','1','Reiter','Jana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-12','F','',NULL,NULL,NULL,'','3438049','','2014-02-06','2014-02-06 19:59:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-07 19:00:33'),(22725,18146,'Y','18','021','EC','A','','','AC','0001970837','0001970837','LA00002187709','IL','1','Javier','Bernardita','','','','34','598382435','1526 London Cross Rd',0,'Harvey','LA','70058',NULL,'CY','22051','1967-10-15','F','M',NULL,'N','021','DEN','3214343','18575LA002000201','2014-03-01','2014-02-11 13:54:45','0.00',NULL,NULL,'67.44','67.44','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:12'),(22804,18200,'N','01','021','EC','A',NULL,NULL,'','0000356070','0001074189','','IL','1','Gebru','Tsehainesh','K','','','34','217613674','725 DIANDREA DR',0,'FAIRLAWN','OH','44333','2906','CY','39153','1964-12-21','F','',':RET:2054-5','N','021','DEN','3675876','99734OH005000301','2014-03-01','2014-02-11 13:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:53'),(27567,21804,'Y','18','021','EC','A','','','AC','0000209610','0000209610','OH00002884838','IL','1','Tupaz','Benjamin','','','','34','269703499','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','1970-07-07','M','M',':RET:2036-2','N','021','DEN','3012426','99734OH005000301','2014-04-01','2014-03-04 14:02:05','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00','CIC',0,'2014-03-04 21:30:19'),(28175,22298,'Y','18','021','EC','A','','','AC','0000285689','0000285689','OH00003106061','IL','1','RAFEEDIE','RACHEL','MARIE','','','34','282861702','4018 BAYMAR DR',0,'YOUNGSTOWN','OH','44511','3439','CY','39099','1981-03-25','F','M',NULL,'N','021','HLT','3906018','92036OH001003201','2014-04-01','2014-03-06 12:39:03','448.00',NULL,NULL,'896.62','448.62','R-OH013','OH0','349.76',NULL,0,'2014-03-06 21:02:52'),(28790,22790,'Y','18','021','EC','A','','','AC','0000655782','0000655782','TX00003137236','IL','1','Bruno','Kevin','','','','34','449291536','8001 PARKER RD',0,'HOUSTON','TX','77078','1714','CY','48201','1961-08-03','M','U',':RET:2054-5','N','021','DEN','3186643','33348TX002000101','2014-04-01','2014-03-08 21:55:18','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-09 21:00:41'),(2151,1769,'Y','18','021','EC','A','','','AC','0000426789','0000426789','LA00000930533','IL','1','nelson','camile','','','','34','438559290','1045 TRACI AVE',0,'DENHAM SPRINGS','LA','70726','2640','CY','22063','1972-07-21','F','U',':RET:2054-5','N','021','DEN','254742','18575LA002000101','2014-01-01','2013-12-09 19:06:11','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:18:35'),(1623,1356,'Y','18','021','EC','A','','','AC','0001087286','0001087286','TX00001478497','IL','1','Simmons','Phillip','Ray','','','34','446629950','1724 W 13TH ST',0,'TEXARKANA','TX','75501','4835','CY','48037','1959-04-15','M','U',':RET:2054-5','N','021','DEN','2305764','33348TX002000201','2014-01-01','2013-12-24 13:58:43','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 18:52:38'),(992,812,'Y','18','021','EC','A','','','AC','0000761073','0000761073','OH00000511382','IL','1','Stivaletti','Anthony','','','','34','006668312','60 E. Spring St.',0,'Columbus','OH','43215',NULL,'CY','39049','1967-04-20','M','U',':RET:2106-3','N','021','DEN','1048926','99734OH005000401','2014-01-01','2013-11-11 12:11:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:10:39'),(7806,6183,'Y','18','024','14','A','','','TE','0000888495','0000888495','','IL','1','HERNANDEZ','ELIDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-09-26','F','',NULL,NULL,NULL,'','1563211','','2013-12-20','2013-12-20 16:54:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:48'),(1339,1108,'Y','18','021','EC','A','','','AC','0000345543','0000345543','OH00000363614','IL','1','Exley','Zachary','','','','34','183745759','5 TIMBER LAKE DR',0,'HUBBARD','OH','44425','8718','CY','39099','1993-03-08','M','U',':RET:2106-3','N','021','HLT','974697','92036OH003003206','2014-01-01','2013-11-06 19:38:56','118.00',NULL,NULL,'160.52','42.52','R-OH013','OH0','160.52',NULL,0,'2013-12-25 18:32:21'),(20802,16622,'Y','18','021','EC','A','','','AC','0000836489','0000836489','TX00001487331','IL','1','Mejia','Maria','','','','34','463041456','224 E FM 1417',0,'Sherman','TX','75090',NULL,'CY','48181','1952-10-05','F','U',NULL,'N','021','DEN','3019204','33348TX002000201','2014-03-01','2014-01-31 14:23:45','0.00',NULL,NULL,'15.85','15.85','R-TX020','TX0','15.85',NULL,0,'2014-01-31 21:00:22'),(21984,17556,'Y','18','021','EC','A','','','AC','0001471507','0001471507','LA00002492939','IL','1','BRADFORD','TYRA','','','','34','462656052','1327 W 29TH AVE',0,'COVINGTON','LA','70433','1246','CY','22103','1974-09-01','F','U',':RET:2054-5','N','021','DEN','2891937','18575LA002000201','2014-03-01','2014-02-06 18:47:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-07 19:00:39'),(22377,17870,'Y','18','021','EC','A','','','AC','0000481112','0000481112','OH00002619614','IL','1','thomas','alex','','','','34','290941331','8938 STATE ROUTE 82',0,'GARRETTSVILLE','OH','44231','9475','CY','39133','1991-11-26','M','U',':RET:2106-3','N','021','HLT','2674053','52664OH151001305','2014-03-01','2014-02-09 18:34:23','105.00',NULL,NULL,'223.01','118.01','R-OH012','OH0','223.01',NULL,0,'2014-02-10 21:30:06'),(23754,18908,'Y','18','021','EC','A','','','AC','0000242749','0000242749','OH00002327289','IL','1','Brothers','Lacey','L','','','34','279881824','20857 STATE ROUTE 164',0,'SALINEVILLE','OH','43945','9602','CY','39029','1977-10-11','F','U',':RET:2106-3','N','021','DEN','2980380','99734OH005000301','2014-03-01','2014-02-14 08:06:22','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-14 21:31:07'),(27192,21530,'Y','18','021','EC','A','','','AC','0000187615','0000187615','TX00003424126','IL','1','Vong','Pheakdey','','','','34','627272904','20211 TAMERTON DR',0,'SPRING','TX','77388','3181','CY','48201','1982-12-15','F','U',':RET:2028-9','N','021','DEN','3713965','33348TX002000201','2014-04-01','2014-03-03 16:17:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-03 21:31:16'),(27428,21707,'Y','18','021','EC','A','','','AC','0002229302','0002229302','LA00003399807','IL','1','TOLDEN','KATHERINE','','','','34','587341390','57430 SUNSET RD',0,'SLIDELL','LA','70461','2402','CY','22103','1952-03-18','F','U',NULL,'N','021','DEN','3208557','18575LA002000201','2014-04-01','2014-03-04 11:55:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:44'),(27712,21914,'Y','18','024','14','A','','','TE','0000315634','0000315634','','IL','1','PEREZ','MARIBEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-08-13','F','',NULL,NULL,NULL,'','3173272','','2014-03-05','2014-03-05 12:52:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:54'),(14134,11266,'Y','18','021','EC','A','','','AC','0001221863','0001221863','LA00000407159','31','1','HARRY','ACKER','','','','34','434539029','P.O. BOX 661',0,'FOLSOM','LA','70437',NULL,'CY','22103','1982-07-28','M','U',':RET:2054-5','N','021','DEN','1598522','18575LA002000201','2014-02-01','2013-12-26 11:30:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:28'),(18030,14402,'Y','18','021','EC','A','','','AC','0000258184','0000258184','OH00001531422','IL','1','MANSOUR','SAAID','','','','34','283901567','1428 FITZROY ST',0,'WESTLAKE','OH','44145','2471','CY','39035','1988-02-08','M','U',':RET:2106-3','N','021','DEN','2239970','99734OH005000301','2014-02-01','2014-01-14 16:06:04','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:08'),(16467,13176,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','1896932','','2014-01-06','2014-01-06 10:59:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:05:51'),(1530,1274,'N','01','021','EC','A',NULL,NULL,'','0000596278','0000933209','','IL','1','Flakes','Tracy','nicole','','','34','281545386','828 HUBER ST',0,'AKRON','OH','44306','2924','CY','39153','1968-01-24','F','',':RET:2054-5','T','021','DEN','2383639','99734OH005000401','2014-01-01','2013-12-24 16:01:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:59'),(1787,1471,'Y','18','021','EC','A','','','AC','0000596279','0000596279','OH00000548308','IL','1','Tigrett','Bernice','','','','34','292782180','910 MAURINE DR',0,'COLUMBUS','OH','43228','3118','CY','39049','1968-09-06','F','M',':RET:2106-3','N','021','DEN','2152098','99734OH005000301','2014-01-01','2013-12-24 16:20:25','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:56:29'),(21961,17537,'Y','18','024','14','A','','','TE','0001036165','0001036165','','IL','1','ZIMMERS','DONALD',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-30','M','',NULL,NULL,NULL,'','3666743','','2014-02-07','2014-02-07 10:17:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-07 19:00:26'),(22563,18019,'N','01','021','EC','A',NULL,NULL,'','0001219628','0001011599','','IL','1','POWERS','KAREN','J','','','34','295620461','3691 WEAVER RD',0,'WILLIAMSBURG','OH','45176','9376','CY','39025','1962-12-26','F','',NULL,'N','021','DEN','2970424','99734OH005000401','2014-03-01','2014-02-10 12:48:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:52'),(23977,19063,'Y','18','021','EC','A','','','AC','0001505543','0001505543','LA00001932952','31','1','Fox','Jacqueline','','','','34','433651519','PO Box 155',0,'Westlake','LA','70669',NULL,'CY','22019','1973-08-20','F','U',':RET:2106-3','N','021','DEN','2996370','18575LA002000201','2014-03-01','2014-02-15 10:33:54','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-15 22:00:18'),(25410,20160,'Y','18','021','EC','A','','','AC','0000996579','0000996579','OH00003183578','IL','1','Hurst','Debra','','','','34','295643922','1741 PARKAMO AVE',0,'Hamilton','OH','45011',NULL,'CY','39017','1963-06-12','F','R',':RET:2106-3','N','021','DEN','2810896','99734OH005000401','2014-04-01','2014-02-25 06:57:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:31:02'),(350,287,'Y','18','021','EC','A','','','AC','0000794453','0000794453','OH00001100442','IL','1','debord','dolly','','','','34','301549113','724 UNION RD',0,'FRANKLIN','OH','45005','2568','CY','39165','1952-01-26','F','U',':RET:2106-3','N','021','DEN','865289','99734OH005000301','2014-01-01','2013-11-09 10:27:09','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:32:14'),(19089,15208,'Y','18','021','EC','A','','','AC','0000486967','0000486967','OH00001376827','IL','1','Borshell','Phil','','','','34','571912091','13248 Spruce Run dr.',0,'North Royalton','OH','44133',NULL,'CY','39035','1986-11-23','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','1735768','99734OH005000301','2014-03-01','2014-01-18 13:23:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:44:31'),(16356,13090,'Y','18','021','EC','A','','','AC','0000768896','0000768896','OH00001106586','IL','1','WILLIAMS','TIMOTHY','J','','','34','299787440','5344 WILDCAT PIKE',0,'MARION','OH','43302','9432','CY','39101','1982-09-07','M','M',':RET:2106-3','N','021','DEN','2511931','99734OH005000301','2014-02-01','2014-01-06 14:23:17','0.00',NULL,NULL,'42.26','42.26','R-OH008','OH0','0.00',NULL,0,'2014-01-07 04:02:37'),(15800,12647,'Y','18','021','EC','A','','','AC','0002261610','0002261610','LA00001655304','IL','1','Woodard','Joan','','','','34','439965233','1504 Cynthia St',0,'Jonesboro','LA','71251',NULL,'CY','22049','1952-08-11','F','U',':RET:2054-5','T','021','DEN','1601083','18575LA002000201','2014-02-01','2014-01-02 09:54:54','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-03 02:02:50'),(3597,2884,'Y','18','021','EC','A','','','AC','0000731191','0000731191','OH00001024700','IL','1','Spanakis','Angela','','','','34','280741972','8507 N Akins Rd',0,'North Royalton','OH','44133',NULL,'CY','39035','1956-11-10','F','U',':RET:2106-3','N','021','HLT','1541052','92036OH003000805','2014-01-01','2013-12-22 10:49:23','300.00',NULL,NULL,'595.02','295.02','R-OH011','OH0','595.02',NULL,0,'2013-12-25 21:23:09'),(5916,4686,'Y','18','021','EC','A','','','AC','0000444506','0000444506','TX00000277021','31','1','Roets','Etienne','','','','34','615258293','p.o. box 2049',0,'montgomery','TX','77356',NULL,'CY','48339','1972-11-01','M','M',':RET:2106-3','N','021','DEN','1633478','33348TX002000101','2014-01-01','2013-12-23 23:59:04','0.00',NULL,NULL,'81.45','81.45','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:50:10'),(20982,16768,'Y','18','021','EC','A','','','AC','0001903442','0001903442','LA00002275279','IL','1','Gibbs','sharanda','','','','34','435699260','9889 hooper road',0,'baton rouge','LA','70818',NULL,'CY','22033','1987-12-24','F','U',':RET:2054-5','N','021','DEN','3056893','18575LA002000201','2014-03-01','2014-02-01 00:08:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-01 19:00:20'),(24409,19389,'Y','18','021','EC','A','','','AC','0000893198','0000893198','OH00002278573','IL','1','Ragonesi','Christopher','','','','34','041642831','102 SAINT ANDREWS DR',0,'CINCINNATI','OH','45245','2904','CY','39025','1961-09-26','M','U',':RET:2106-3','N','021','DEN','2997618','99734OH005000301','2014-04-01','2014-02-18 08:28:45','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-18 22:01:00'),(25573,20287,'Y','18','021','EC','A','','','AC','0000687265','0000687265','OH00001873409','IL','1','LOCKER','MICHAEL','','','','34','281703478','335 NORTHWAY DR',0,'SAINT MARYS','OH','45885','1243','CY','39011','1962-07-14','M','U',NULL,'N','021','HLT','3732079','92036OH003001505','2014-04-01','2014-02-23 14:28:04','299.00',NULL,NULL,'428.66','129.66','R-OH002','OH0','428.66',NULL,0,'2014-02-26 08:00:32'),(28249,22351,'Y','18','021','EC','A','','','AC','0000615565','0000615565','OH00003223238','IL','1','SMITH','JANET','JW','','','34','412023145','6530 SOM CENTER ROAD',0,'SOLON','OH','44139',NULL,'CY','39035','1954-04-06','F','M',':RET:2106-3','T','021','DEN','2720346','99734OH005000401','2014-04-01','2014-03-07 13:03:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-03-07 21:00:12'),(18408,14686,'N','19','021','EC','A',NULL,NULL,'','0001075328','0000781923','','S1','1','Menasian','Edward','','','','34','272048498','3016 117TH ST',0,'TOLEDO','OH','43611','2705','CY','39095','1998-11-27','M','',NULL,'N','021','DEN','2932843','99734OH005000301','2014-02-01','2014-01-15 18:10:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:46'),(5174,4105,'Y','18','024','14','A','','','TE','0000912943','0000912943','','IL','1','SPENCE','MINDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-10-10','F','',NULL,NULL,NULL,'','1656260','','2013-12-19','2013-12-19 11:53:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:23'),(1436,1198,'Y','18','021','EC','A','','','AC','0002217023','0002217023','LA00000965328','IL','1','MORRIS','BETTY','','','','34','437024238','3121 ANTIOCH ST',0,'PAULINA','LA','70763','2418','CY','22093','1963-06-17','F','U',':RET:2054-5','N','021','DEN','1477973','18575LA002000201','2014-01-01','2013-12-24 17:56:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:43'),(13391,10690,'Y','18','021','EC','A','','','AC','0000460579','0000460579','OH00000622733','IL','1','Sweet','Pamela','','','','34','282621399','7273 CHETBERT DR',0,'CINCINNATI','OH','45236','3603','CY','39061','1966-04-25','F','U',':RET:2106-3','N','021','DEN','2272423','99734OH005000301','2014-01-01','2013-12-23 07:09:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:09'),(21645,17285,'Y','18','021','EC','A','','','AC','0001190094','0001190094','OH00002142755','IL','1','Durham','Sandra','Jean','','','34','279484676','110 one half dale ave',0,'Willard','OH','44890',NULL,'CY','39077','1929-10-23','F','M',':RET:2054-5','N','021','HLT','3205404','92036OH004002701','2014-03-01','2014-02-04 19:23:16','466.93',NULL,NULL,'470.37','3.44','R-OH006','OH0','470.37',NULL,0,'2014-02-05 21:30:47'),(26685,21156,'Y','18','021','EC','A','','','AC','0002070020','0002070020','LA00003443254','IL','1','CARR','CHENELLE','','','','34','438496295','2438 DANIEL DR',0,'VIOLET','LA','70092','3800','CY','22087','1970-05-19','F','U',':RET:2054-5','N','021','DEN','3911986','18575LA002000201','2014-04-01','2014-02-28 17:31:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:25'),(28300,22391,'Y','18','024','14','A','','','TE','0000117784','0000117784','','IL','1','KALTENBACH','KAREN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-04-16','F','',NULL,NULL,NULL,'','2003928','','2014-03-31','2014-03-07 11:15:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:31'),(5708,4531,'Y','18','021','EC','A','','','AC','0000163679','0000163679','OH00001235840','IL','1','PFAHLER','MACKENVIE','','','','34','268880878','5071 KAREN DRIVE',0,'NEW FRANKLIN','OH','44319',NULL,'CY','39153','1982-04-13','F','U',':RET:2106-3','T','021','HLT','1668662','52664OH151001304','2014-01-01','2013-12-23 21:01:20','72.00',NULL,NULL,'297.24','225.24','R-OH012','OH0','297.24',NULL,0,'2013-12-25 23:45:03'),(7360,5829,'Y','18','021','EC','A','','','AC','0000091102','0000091102','OH00000890800','IL','1','Miracle','Gerald','','','','34','270501508','872 SKYSIDE DR',0,'CLINTON','OH','44216','9659','CY','39153','1950-07-06','M','M',':RET:2106-3','N','021','HLT','575059','52664OH151001501','2014-01-01','2013-11-22 19:57:19','896.00',NULL,NULL,'1441.37','545.37','R-OH012','OH0','789.56',NULL,0,'2013-12-26 02:15:23'),(2277,1858,'Y','18','021','EC','A','','','AC','0000373604','0000373604','OH00000976038','IL','1','Hater','Robert','','','','34','301901622','6565 BRIDGETOWN RD',0,'CINCINNATI','OH','45248','2936','CY','39061','1983-06-06','M','M',NULL,'N','021','DEN','72984','99734OH005000301','2014-01-01','2013-12-09 12:27:37','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:29'),(2543,2069,'Y','18','021','EC','A','','','AC','0000520929','0000520929','OH00001049592','IL','1','SORG','KENNETH','W','','','34','276543748','130 E WASHINGTON APT 8',0,'BOWLING GREEN','OH','43402',NULL,'CY','39173','1953-05-20','M','M',':RET:2106-3','N','021','HLT','612262','92036OH006002601','2014-01-01','2013-12-09 15:54:33','15.00',NULL,NULL,'419.70','404.70','R-OH001','OH0','419.70',NULL,0,'2013-12-25 19:37:04'),(9450,7497,'Y','18','021','EC','A','','','AC','0000946102','0000946102','OH00001267829','IL','1','Moore','Michael','','','','34','273583923','23948 WOLTZ RD',0,'ROCKBRIDGE','OH','43149','9516','CY','39073','1954-10-11','M','U',':RET:2106-3','N','021','DEN','2454099','99734OH005000401','2014-01-01','2013-12-20 21:00:57','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 04:33:56'),(9656,7651,'Y','18','021','EC','A','','','AC','0000790870','0000790870','OH00000462409','IL','1','Logan','William','Alva','','','34','317602099','6699 SOUTHERN VISTA DR',0,'ENON','OH','45323','1640','CY','39023','1956-06-26','M','R',':RET:2106-3','N','021','HLT','1476234','92036OH005000501','2014-01-01','2013-12-20 23:29:11','0.00',NULL,NULL,'1173.59','1173.59','R-OH003','OH0','579.30',NULL,0,'2013-12-26 04:38:53'),(3177,2555,'Y','18','021','EC','A','','','AC','0000263671','0000263671','LA00000039254','31','1','Trejo','Lilian','','','','34','435878990','1617 Newport Pl',0,'kenner','LA','70065',NULL,'CY','22051','1972-12-22','F','U',':RET:2106-3','N','021','DEN','418048','18575LA002000101','2014-01-01','2013-11-17 22:44:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:31:44'),(17941,14335,'Y','18','021','EC','A','','','AC','0000986020','0000986020','TX00001741658','IL','1','Tran','Hong','','','','34','730267654','1412 FIREBUSH DR',0,'PFLUGERVILLE','TX','78660','8949','CY','48453','1976-12-02','F','M',':RET:2047-9','N','021','DEN','2307312','33348TX002000201','2014-02-01','2014-01-14 15:22:59','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:39'),(25830,20478,'N','01','021','EC','A',NULL,NULL,'','0000444962','0000066311','','IL','1','Weilnau','Brett','W','','','34','268747625','1076 REVERES RUN',0,'LEBANON','OH','45036','8974','CY','39165','1976-05-22','M','',':RET:2106-3','N','021','DEN','2946724','99734OH005000301','2014-04-01','2014-02-26 16:54:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:29'),(20182,16106,'Y','18','021','EC','A','','','AC','0000358362','0000358362','OH00002540094','IL','1','Moate','Randall','','','','34','164642431','3713 Cascades Blvd',0,'kent','OH','44240',NULL,'CY','39133','1981-03-20','M','U',':RET:2106-3','N','021','HLT','2223759','52664OH151001305','2014-03-01','2014-01-27 16:53:56','120.00',NULL,NULL,'263.82','143.82','R-OH012','OH0','263.82',NULL,0,'2014-01-27 21:01:21'),(17704,14147,'Y','18','024','14','A','','','TE','0001268775','0001268775','','IL','1','CESTEDES-MONTANO','EDUARD','I',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-18','M','',NULL,NULL,NULL,'','1642789','','2014-01-13','2014-01-13 13:45:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-14 01:33:06'),(28178,22299,'Y','18','021','EC','A','','','AC','0000955603','0000955603','OH00003783495','IL','1','Hennies','Harold','','','','34','292425328','3179 Kennedy-Ford Rd.',0,'Bethel','OH','45106',NULL,'CY','39025','1960-01-28','M','M',':RET:2106-3','N','021','HLT','3288625','92036OH004000601','2014-04-01','2014-03-06 13:25:26','577.00',NULL,NULL,'959.03','382.03','R-OH005','OH0','368.53',NULL,0,'2014-03-06 21:02:53'),(605,498,'Y','18','021','EC','A','','','AC','0000689678','0000689678','OH00000916675','IL','1','BELL','SHATILA','MICHELLE','','','34','268902729','11110 HARVARD AVE',0,'CLEVELAND','OH','44105','5341','CY','39035','1988-08-24','F','U',':RET:2054-5','N','021','DEN','1598942','99734OH005000401','2014-01-01','2013-12-16 09:10:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:00:25'),(15780,12629,'Y','18','021','EC','A','','','AC','0000984751','0000984751','TX00001667784','IL','1','brom','aileen','anne','','','34','378194532','4607 dusik lane',0,'austin','TX','78746',NULL,'CY','48453','1986-11-15','F','U',':RET:2106-3','N','021','DEN','1581362','33348TX002000201','2014-02-01','2014-01-02 17:11:32','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-03 02:02:06'),(15581,12468,'Y','18','024','14','A','','','TE','0000718911','0000718911','','IL','1','Pushkaran','Ashish',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-18','M','',NULL,NULL,NULL,'','1600650','','2013-12-30','2013-12-30 19:08:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:12'),(7333,5808,'N','19','021','EC','A',NULL,NULL,'','0000491858','0000954285','','IL','1','Maus','Richard','Jackson','','','34','288130596','822 BOLENDER RD',0,'MOSCOW','OH','45153','9650','CY','39025','2007-09-24','M','',':RET:2106-3','N','021','HLT','711943','92036OH003000601','2014-01-01','2013-12-14 14:54:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-26 02:03:50'),(4013,3206,'Y','18','021','EC','A','','','AC','0000817528','0000817528','OH00000779655','IL','1','SPENCE','JEREMY','','','','34','421170204','741 RIDGEWOOD AVE',0,'HAMILTON','OH','45013','3201','CY','39017','1982-02-05','M','M',':RET:2106-3','N','021','DEN','2371668','99734OH005000401','2014-01-01','2013-12-17 01:42:50','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:29'),(4276,3406,'N','01','021','EC','A',NULL,NULL,'','0000906597','0000301872','','IL','1','COLLIER','DAVID','ROBERT','','','34','270526112','4216 TOWNSHIP NORTH ELLIS ROAD',0,'BATAVIA','OH','45103',NULL,'CY','39025','1951-09-03','M','',':RET:2106-3','N','021','HLT','1521337','92036OH001000601','2014-01-01','2013-12-17 10:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','743.93',NULL,0,'2013-12-25 21:51:53'),(25075,19885,'Y','18','021','EC','A','','','AC','0000312554','0000312554','MS00002753741','IL','1','Young','Emma','','','','34','587113286','3095 BIXON',0,'UTICH','MS','39175',NULL,'CY','28049','1957-06-07','F','M',NULL,'N','021','DEN','3145724','46300MS002000101','2014-04-01','2014-02-20 11:07:35','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 22:01:33'),(18219,14540,'N','01','021','EC','A',NULL,NULL,'','0000333889','0000991561','','IL','1','ROSENBROOK','ROBERT','A','','','34','291640564','4810 PICKLE RD',0,'OREGON','OH','43616','5618','CY','39095','1961-07-28','M','',':RET:2106-3','N','021','HLT','2271793','92036OH004002601','2014-02-01','2014-01-14 18:00:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','306.05',NULL,0,'2014-01-15 02:08:13'),(19718,15713,'Y','18','021','EC','A','','','AC','0000822084','0000822084','OH00001679242','IL','1','Brown','Sandra','','','','34','280622228','120 E. Maumee Ave.',0,'Napoleon','OH','43545',NULL,'CY','39069','1958-12-17','F','U',':RET:2106-3','T','021','HLT','1670928','92036OH004002601','2014-03-01','2014-01-23 14:34:39','359.00',NULL,NULL,'402.10','43.10','R-OH001','OH0','402.10',NULL,0,'2014-01-23 21:00:56'),(27824,22005,'Y','18','021','EC','A','','','AC','0000913020','0000913020','OH00003067943','IL','1','METCALF','JAMES','','','','34','295583427','129 PALMER LN',0,'BRYAN','OH','43506','7800','CY','39171','1956-05-28','M','M',':RET:2106-3','T','021','DEN','3764645','99734OH005000301','2014-04-01','2014-03-05 09:41:49','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-05 21:31:57'),(17662,14115,'N','19','021','EC','A',NULL,NULL,'','0001128018','0001171906','','IL','1','Hussein','Amin','','','','34','228835155','4689 CRYSTAL LAKE DR',0,'HILLIARD','OH','43026','2824','CY','39049','1999-02-17','M','',':RET:2054-5','N','021','DEN','2598500','99734OH005000301','2014-02-01','2014-01-13 15:18:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:45'),(24059,19132,'Y','18','021','EC','A','','','AC','0000058802','0000058802','OH00002085169','IL','1','Marquardt','Amber','','','','34','292803985','6048 HOPKINS RD',0,'MENTOR','OH','44060','2208','CY','39085','1983-07-30','F','U',':RET:2106-3','N','021','DEN','3063397','99734OH005000301','2014-03-01','2014-02-14 20:04:15','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:01:08'),(1081,887,'Y','18','021','EC','A','','','AC','0000860948','0000860948','OH00001251508','IL','1','Jackson','Willis','','','','34','272549569','6255 SENECA RD',0,'MENTOR','OH','44060','2922','CY','39085','1955-10-12','M','U',':RET:2106-3','T','021','DEN','1030535','99734OH005000401','2014-01-01','2013-12-03 09:33:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:46'),(3021,2429,'Y','18','021','EC','A','','','AC','0000151945','0000151945','OH00000498191','IL','1','LEONARD','GARY','E','','','34','273609702','1081 CREEK ROAD',0,'PIER POINT','OH','44082',NULL,'CY','39007','1956-10-06','M','M',':RET:2106-3','N','021','HLT','975934','52664OH151001306','2014-01-01','2013-12-06 12:42:15','582.00',NULL,NULL,'612.95','30.95','R-OH011','OH0','612.95',NULL,0,'2013-12-25 20:18:09'),(17158,13728,'N','01','021','EC','A',NULL,NULL,'','0001953610','0001993691','','IL','1','Adams','Janet',NULL,NULL,NULL,NULL,NULL,'105 WATERFORD DR',0,'LAFAYETTE','LA','70503','5406','CY','22055','1976-04-13','F','',NULL,'N','021','DEN','2364104','18575LA002000201','2014-02-01','2014-01-08 10:52:09',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:22:00'),(16763,13409,'N','01','021','EC','A',NULL,NULL,'','0000264222','0000665662','','IL','1','Weekley','Regina','Lynn','','','34','278545598','1360 HILLCREST DR',0,'CUYAHOGA FALLS','OH','44221','4840','CY','39153','1954-02-02','F','',':RET:2106-3','N','021','HLT','2187409','52664OH152000901','2014-02-01','2014-01-07 11:10:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','425.18',NULL,0,'2014-01-08 18:24:59'),(21788,17400,'Y','18','021','EC','A','','','AC','0000940894','0000940894','OH00002584720','IL','1','Roberts','Jeremy','','','','34','408291495','2524 Williams Ave.',0,'Norwood','OH','45212',NULL,'CY','39061','1975-05-05','M','U',':RET:2106-3','N','021','DEN','3594628','99734OH005000401','2014-03-01','2014-02-06 12:56:44','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:00:42'),(18278,14593,'Y','18','021','EC','A','','','AC','0000406621','0000406621','TX00002541054','31','1','Salinas','Sofia','','','','34','462454041','P.O Box 3321',0,'Lubbock','TX','79452',NULL,'CY','48303','1970-04-04','F','U',':RET:2106-3','N','021','DEN','2897842','33348TX002000201','2014-02-01','2014-01-15 18:06:24','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-16 08:44:45'),(9365,7424,'Y','18','021','EC','A','','','AC','0002219360','0002219360','LA00001002683','IL','1','SEMIEN','ANGELA','DENISE','','','34','439592459','6854 BUCKLEY RD',0,'IOWA','LA','70647','3322','CY','22019','1986-01-04','F','U',NULL,'N','021','DEN','2552979','18575LA002000201','2014-01-01','2013-12-21 11:22:28','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 04:31:38'),(436,359,'Y','18','021','EC','A','','','AC','0000030514','0000030514','OH00001170659','IL','1','Glasser','David','','','','34','547888793','13725 HEATH RD',0,'NOVELTY','OH','44072','9746','CY','39055','1953-09-13','M','M',':RET:2106-3','N','021','DEN','1191845','99734OH005000401','2014-01-01','2013-12-04 11:00:10','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:47:04'),(13300,10617,'Y','18','021','EC','A','','','AC','0000521477','0000521477','TX00000535638','IL','1','Mendiola','Martha','','','','34','458849779','2502 W Twohig Ave',0,'San Angelo','TX','76901',NULL,'CY','48451','1949-08-16','F','U',':RET:2106-3','N','021','DEN','2406514','33348TX002000201','2014-01-01','2013-12-23 14:50:43','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-26 12:57:45'),(7849,6215,'Y','18','021','EC','A','','','AC','0000025282','0000025282','OH00001320158','IL','1','Damis','Lauren','','','','34','270865291','3389 BON AIR AVE NW',0,'WARREN','OH','44485','1304','CY','39155','1986-07-07','F','U',':RET:2106-3','N','021','DEN','2463330','99734OH005000301','2014-01-01','2013-12-20 09:05:25','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-26 03:04:46'),(28816,22805,'N','19','021','EC','A',NULL,NULL,'','0000559505','0001222001','','IL','1','CALVERT','DYLAN','T','','','34','273968780','5321 DONNER DRIVE',0,'NEW FRANKLIN','OH','44216',NULL,'CY','39153','1992-11-18','M','',':RET:2106-3','N','021','HLT','3871781','52664OH151001304','2014-04-01','2014-03-09 15:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-03-09 21:00:56'),(7351,5821,'Y','18','021','EC','A','','','AC','0000001001','0000001001','LA00001112981','31','1','Gilhaus','Joshua','','','','34','438418089','P.O.Box703',0,'Madisonville','LA','70447',NULL,'CY','22103','1976-07-13','M','M',':RET:2106-3','T','021','DEN','29845','18575LA002000101','2014-01-01','2013-11-22 20:32:01','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 02:15:07'),(28628,22656,'Y','18','021','EC','A','','','AC','0000736304','0000736304','TX00003104889','IL','1','CANALES','MARCO','ANTONIO','','','34','453711394','3209 CALLE TERESA',0,'EAGLE PASS','TX','78852','5670','CY','48323','1960-12-06','M','M',NULL,'N','021','DEN','4293616','33348TX002000201','2014-04-01','2014-03-08 11:07:03','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:25'),(24610,19533,'Y','18','021','EC','A','','','AC','0000319075','0000319075','MS00001445544','IL','1','WASHINGTON','CAROLYN','','','','34','427110973','76203 ELIZABETH LN',0,'BRANDON','MS','39042','2741','CY','28121','1959-07-16','F','M',':RET:2054-5','N','021','DEN','3005194','46300MS002000201','2014-04-01','2014-02-18 18:28:43','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:13:55'),(6990,5547,'Y','18','021','EC','A','','','AC','0000384399','0000384399','OH00001175074','IL','1','Saviano','Joeseph','','','','34','283447233','926 E 216TH ST',0,'CLEVELAND','OH','44119','2422','CY','39035','1951-08-20','M','M',':RET:2106-3','T','021','DEN','2545075','99734OH005000401','2014-02-01','2013-12-25 16:55:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:58'),(7905,6249,'Y','18','021','EC','A','','','AC','0001482083','0001482083','LA00001062836','IL','1','Jackson','Latonya','Kayelle','','','34','439535309','832 KELLER AVE',0,'WESTWEGO','LA','70094','4706','CY','22051','1976-03-06','F','U',':RET:2054-5','N','021','DEN','2573265','18575LA002000201','2014-01-01','2013-12-19 19:28:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:05:54'),(4948,3927,'Y','18','021','EC','A','','','AC','0001143293','0001143293','OH00000961926','IL','1','SOMOGYI','DONNA','','','','34','275522753','10290 MILL RD',0,'CINCINNATI','OH','45231','1965','CY','39061','1950-08-06','F','U',':RET:2106-3','N','021','DEN','965929','99734OH005000401','2014-01-01','2013-12-07 15:30:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:52'),(5832,4632,'Y','18','024','14','A','','','TE','0000540750','0000540750','','IL','1','ORR','PATRICIA','ANN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-29','F','',NULL,NULL,NULL,'','1070037','','2013-12-23','2013-12-23 23:18:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:48:20'),(22871,18243,'N','01','021','EC','A',NULL,NULL,'','0000432803','0000384441','','IL','1','vo','trang thao','thi','','','34','277924184','610 chestnut ln',0,'boardman','OH','44512',NULL,'CY','39099','1971-08-02','F','',':RET:2047-9','N','021','HLT','3682106','92036OH005003204','2014-03-01','2014-02-10 22:50:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','320.73',NULL,0,'2014-02-11 21:02:30'),(16634,13307,'N','01','021','EC','A',NULL,NULL,'','0000650793','0000632705','','IL','1','Meek','Jennifer','Lee','','','34','300864253','1227 CLOVERVIEW ST',0,'BLACKLICK','OH','43004','6052','CY','39049','1978-05-24','F','',':RET:2106-3','N','021','DEN','1605811','99734OH005000401','2014-02-01','2014-01-07 11:17:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:15'),(16588,13268,'Y','18','021','EC','A','','','AC','0001659551','0001659551','LA00001630251','IL','1','Brooks','Jesse','','','','34','434792013','306 E Robert Street',0,'Hammond','LA','70401',NULL,'CY','22105','1987-01-26','M','U',':RET:2106-3','N','021','DEN','2148930','18575LA002000201','2014-02-01','2014-01-07 16:13:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:23:59'),(8151,6448,'Y','18','021','EC','A','','','AC','0000878857','0000878857','TX00000598439','IL','1','Hertel','Rhonda','','','','34','452457414','605 S DONALD ST',0,'SEYMOUR','TX','76380','2813','CY','48023','1963-05-18','F','M',NULL,'N','021','DEN','1154145','33348TX002000201','2014-01-01','2013-11-22 16:28:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:16:01'),(13774,10994,'N','01','021','EC','A',NULL,NULL,'','0000548063','0000978187','','IL','1','WALTON','GENEVA','','','','34','426027216','4856 WOODMONT DR',0,'JACKSON','MS','39206',NULL,'CY','28049','1953-10-17','F','',NULL,'N','021','DEN','1671399','46300MS002000201','2014-01-01','2013-12-23 13:17:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:34'),(5418,4300,'Y','18','021','EC','A','','','AC','0001146858','0001146858','MS00000766507','IL','1','Hughie','Amanda','','','','34','411577339','562 WOODLAND HILLS PL',0,'JACKSON','MS','39216','3230','CY','28049','1976-08-04','F','U',':RET:2106-3','N','021','DEN','1601541','46300MS002000201','2014-01-01','2013-12-18 22:05:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:09:18'),(5296,4197,'Y','18','021','EC','A','','','AC','0001191325','0001191325','OH00001296038','IL','1','BAILEY','MICHELLE','L','','','34','276920833','301.5 N MAIN ST',0,'NEW BREMEN','OH','45869','1136','CY','39011','1989-06-23','F','U',':RET:2106-3','N','021','HLT','1610270','92036OH003001506','2014-01-01','2013-12-18 19:12:16','175.00',NULL,NULL,'229.83','54.83','R-OH002','OH0','229.83',NULL,0,'2013-12-25 23:06:10'),(22931,18280,'Y','18','024','14','A','','','TE','0000442158','0000442158','','IL','1','Moss','Danielle','Niccole',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-30','F','',NULL,NULL,NULL,'','1754565','','2014-02-28','2014-02-11 09:23:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:10'),(24879,19727,'Y','18','024','14','A','','','TE','0000540301','0000540301','','IL','1','Johnson','Scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-03-04','M','',NULL,NULL,NULL,'','1908737','','2014-03-31','2014-02-19 10:20:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:35:43'),(26732,21187,'Y','18','024','14','A','','','TE','0001007907','0001007907','','IL','1','Siebold','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-13','M','',NULL,NULL,NULL,'','2756961','','2014-02-28','2014-02-28 11:37:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 21:31:49'),(28224,22332,'Y','18','024','14','A','','','TE','0000971518','0000971518','','IL','1','habli','ibrahim',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2004-08-11','M','',NULL,NULL,NULL,'','3569754','','2014-03-31','2014-03-06 15:30:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-06 21:30:20'),(1103,907,'Y','18','024','14','A','','','TE','0000342698','0000342698','','IL','1','Thompson','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-10','F','',NULL,NULL,NULL,'','264973','','2013-12-03','2013-12-03 14:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:17:19'),(17725,14163,'Y','18','021','EC','A','','','AC','0001163860','0001163860','OH00001975771','IL','1','Ogden','Joseph','','','','34','297869850','6532 MIDNIGHT SUN DR',0,'MAINEVILLE','OH','45039','8943','CY','39165','1982-06-07','M','U',':RET:2106-3','N','021','HLT','1794957','92036OH006001201','2014-02-01','2014-01-13 00:11:36','0.00',NULL,NULL,'197.32','197.32','R-OH004','OH0','197.32',NULL,0,'2014-01-14 01:33:16'),(7727,6120,'Y','18','021','EC','A','','','AC','0000885583','0000885583','OH00001113653','IL','1','Golias','Deborah','Ann','','','34','302645100','3117 SNOW RD',0,'PARMA','OH','44134','2955','CY','39035','1971-01-05','F','U',':RET:2106-3','N','021','DEN','2145763','99734OH005000401','2014-01-01','2013-12-20 14:29:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:54'),(1958,1597,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','1002439','','2013-11-19','2013-11-19 22:58:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:09'),(16251,13012,'N','19','021','EC','A',NULL,NULL,'','0000236286','0001242984','','IL','1','bonenfant','kayle','m','','','34','271022373','25271 SPRAGUE RD',0,'COLUMBIA STATION','OH','44028','9602','CY','39093','1996-09-18','F','',':RET:2106-3','N','021','DEN','2522495','99734OH005000301','2014-02-01','2014-01-04 15:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:39'),(7652,6059,'Y','18','021','EC','A','','','AC','0000611924','0000611924','OH00000671815','IL','1','Bonnington','Thomas','Edward','','','34','535729368','2456 Goddard Rd',0,'Toledo','OH','43606',NULL,'CY','39095','1964-01-23','M','U',':RET:2106-3','N','021','HLT','1117219','92036OH004002601','2014-01-01','2013-11-09 21:08:23','0.00',NULL,NULL,'267.49','267.49','R-OH001','OH0','267.49',NULL,0,'2013-12-26 02:46:54'),(4271,3402,'Y','18','021','EC','A','','','AC','0000144200','0000144200','OH00001150726','IL','1','GROSS','ALYSHA','D','','','34','296760147','312 E AUGLAIZE ST',0,'WAPAKONETA','OH','45895','1529','CY','39011','1978-06-26','F','M',NULL,'N','021','HLT','1796717','92036OH003001506','2014-01-01','2013-12-17 10:01:47','229.00',NULL,NULL,'280.84','51.84','R-OH002','OH0','280.84',NULL,0,'2013-12-25 21:51:45'),(15698,12558,'N','01','021','EC','A',NULL,NULL,'','0000226030','0000328423','','IL','1','Goist','Pamela','G','','','34','297621750','6504 Elm St',0,'Kinsman','OH','44428',NULL,'CY','39155','1960-10-07','F','',':RET:2106-3','N','021','HLT','2292427','92036OH003003204','2014-02-01','2013-12-31 12:33:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','515.66',NULL,1,'2014-01-02 04:35:37'),(14914,11916,'Y','18','021','EC','A','','','AC','0001162602','0001162602','OH00001359586','IL','1','lambert','derrick','','','','34','396849206','200 Bent Tree Dr.',0,'fairfield','OH','45014',NULL,'CY','39017','1973-04-07','M','M',':RET:2054-5','N','021','DEN','2466359','99734OH005000401','2014-02-01','2013-12-28 21:40:19','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-30 00:01:31'),(7187,5697,'Y','18','021','EC','A','','','AC','0000604701','0000604701','OH00000159188','IL','1','Kameoka','Tracy','','','','34','296820363','1320 TRANQUIL DR',0,'WORTHINGTON','OH','43085','1579','CY','39049','1976-05-14','F','M',':RET:2106-3','N','021','DEN','240309','99734OH005000301','2014-01-01','2013-12-14 11:58:19','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:00:19'),(6881,5457,'N','01','021','EC','A',NULL,NULL,'','0001949858','0001527161','','IL','1','DJEMA','MALITA','','','','34','660220589','1610 CARROLLTON AVE',0,'METAIRIE','LA','70005','5001','CY','22051','1976-08-23','F','',NULL,'N','021','DEN','2552252','18575LA002000201','2014-01-01','2013-12-24 18:20:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:45:04'),(19419,15481,'N','01','021','EC','A',NULL,NULL,'','0000728746','0000049532','','IL','1','Fichtner','Stanley','','','','34','116442390','525 STELTON RD',0,'XENIA','OH','45385','5226','CY','39057','1954-08-07','M','',NULL,'N','021','HLT','2730155','92036OH004000501','2014-03-01','2014-01-21 17:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.54',NULL,1,'2014-01-22 03:23:01'),(523,427,'Y','18','021','EC','A','','','AC','0001011530','0001011530','OH00001146897','IL','1','CRAWFORD','erica','','','','34','274762484','2471 GATE ST',0,'CINCINNATI','OH','45211','7308','CY','39061','1980-01-24','F','M',':RET:2054-5','N','021','DEN','1071161','99734OH005000301','2014-01-01','2013-12-04 14:14:41','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:49:15'),(13338,10650,'Y','18','021','EC','A','','','AC','0000679760','0000679760','TX00000772049','IL','1','FERNANDEZ','MARCELINA','R','','','34','458636411','15002 VISTAMONT DR',0,'HOUSTON','TX','77083','5668','CY','48157','1953-04-26','F','M',NULL,'N','021','DEN','2142378','33348TX002000201','2014-01-01','2013-12-23 18:09:40','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:48'),(16566,13252,'N','01','021','EC','A',NULL,NULL,'','0000427647','0000671713','','IL','1','terrill','jane','','','','34','276705908','421 E DOROTHY LN',0,'KETTERING','OH','45419','1802','CY','39113','1965-11-25','F','',':RET:2106-3','T','021','HLT','1850226','92036OH006000501','2014-02-01','2014-01-04 20:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','354.46',NULL,1,'2014-01-07 10:23:11'),(13279,10598,'Y','18','021','EC','A','','','AC','0000617530','0000617530','TX00000800562','IL','1','Cruz','Sandra','','','','34','453978610','6349 S. FM 548',0,'Royse City','TX','75189',NULL,'CY','48397','1980-01-13','F','M',NULL,'N','021','DEN','1495144','33348TX002000201','2014-01-01','2013-12-23 12:57:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:07'),(5364,4253,'Y','18','024','14','A','','','TE','0001259994','0001259994','','IL','1','Young','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-30','M','',NULL,NULL,NULL,'','2573194','','2013-12-18','2013-12-18 20:58:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:07:55'),(3904,3124,'Y','18','021','EC','A','','','AC','0000857079','0000857079','OH00001281506','IL','1','MOOMEY','CHRISTINA','','','','34','299544798','17231 W TRUE RD',0,'GRAYTOWN','OH','43432','9799','CY','39123','1962-11-23','F','M',':RET:2106-3','N','021','HLT','394064','92036OH005002705','2014-01-01','2013-12-12 18:52:51','747.00',NULL,NULL,'885.30','138.30','R-OH006','OH0','363.68',NULL,0,'2013-12-25 21:36:56'),(5889,4669,'N','01','021','EC','A',NULL,NULL,'','0000125559','0000172407','','IL','1','Walker','Shad','','','','34','299842744','6803 BREMEN RD SE',0,'LANCASTER','OH','43130','9417','CY','39045','1971-01-03','M','',':RET:2106-3','N','021','DEN','2554208','99734OH005000301','2014-01-01','2013-12-23 22:43:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:34'),(20452,16336,'Y','18','024','14','A','','','TE','0000051953','0000051953','','IL','1','KIRSCH','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-09-28','M','',NULL,NULL,NULL,'','3007977','','2014-01-28','2014-01-28 20:02:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:45'),(22107,17645,'N','19','021','EC','A',NULL,NULL,'','0000957938','0000493273','','IL','1','Hartwig','Ayden','J','','','34','276133632','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','2007-02-19','M','',':RET:2106-3','N','021','DEN','2941556','99734OH005000301','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:32'),(23818,18951,'N','01','021','EC','A',NULL,NULL,'','0000885590','0000076301','','IL','1','Dible','Rebecca','J','','','34','504961493','7315 N Twp Rd 63',0,'Fostoria','OH','44830','9574','CY','39147','1967-05-17','F','',':RET:2106-3','N','021','HLT','3716386','92036OH005002705','2014-03-01','2014-02-13 20:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','292.49',NULL,0,'2014-02-14 21:31:39'),(24806,19673,'Y','18','021','EC','A','','','AC','0000923361','0000923361','OH00002704436','IL','1','RIBY WILLIAMS','DONALD','','','','34','529211138','7808 MEADOWHAVEN BLVD',0,'COLUMBUS','OH','43235',NULL,'CY','39049','1951-12-24','M','U',NULL,'N','021','DEN','2894866','99734OH005000401','2014-04-01','2014-02-19 17:47:10','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:48:55'),(25942,20572,'Y','18','021','EC','A','','','AC','0001163719','0001163719','FL00002589032','IL','1','Price','Domonitue','','','','34','456676245','2440 Rockwell St',0,'Beaumont','FL','77701',NULL,'CY','48245','1984-02-26','M','U',':RET:2054-5','N','021','DEN','3721520','33348TX002000201','2014-04-01','2014-02-26 16:40:47','0.00',NULL,NULL,'14.61','14.61','R-TX004','FL0','14.61',NULL,0,'2014-02-26 21:01:31'),(28316,22403,'Y','18','021','EC','A','','','AC','0001031856','0001031856','TX00003560325','IL','1','Tillett','Jim','','','','34','008442500','948 JEFFERSON ST E',0,'SULPHUR SPRINGS','TX','75482','2967','CY','48223','1952-03-13','M','M',':RET:2106-3','N','021','DEN','3996519','33348TX002000201','2014-04-01','2014-03-06 18:01:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:01'),(18396,14680,'N','19','021','EC','A',NULL,NULL,'','0000505755','0001104469','','IL','1','Smith','Journey','B','','','34','279130978','11817 Crofton Road',0,'Garfield Heights','OH','44125',NULL,'CY','39035','2007-04-14','M','',':RET:2106-3','N','021','DEN','2210292','99734OH005000301','2014-02-01','2014-01-15 17:10:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:41'),(1502,1253,'N','19','021','EC','A',NULL,NULL,'','0000122982','0000802578','','IL','1','Hollenbeck','Joseph','William','','','34','312899114','10947 SHADOW GLEN DR',0,'LOVELAND','OH','45140','7800','CY','39061','2012-09-25','M','',':RET:2106-3','N','021','DEN','1642424','99734OH005000401','2014-01-01','2013-12-24 12:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:18'),(1551,1294,'Y','18','021','EC','A','','','AC','0000364194','0000364194','MS00001497362','IL','1','Benoit','Timothy','','','','34','587867773','199 Bob Cheeks Rd',0,'Ellisville','MS','39437',NULL,'CY','28067','1961-11-10','M','U',':RET:2106-3','N','021','DEN','1949119','46300MS002000201','2014-01-01','2013-12-24 11:01:26','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:50:36'),(4248,3384,'Y','18','021','EC','A','','','AC','0001220248','0001220248','TX00000154152','IL','1','Crepps','Gina','','','','34','547136355','3101 HARPERS FERRY LN',0,'AUSTIN','TX','78745','6720','CY','48453','1963-07-29','F','M',':RET:2106-3','N','021','DEN','1792963','33348TX002000201','2014-01-01','2013-12-17 17:13:11','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:51:12'),(13014,10372,'Y','18','021','EC','A','','','AC','0001231748','0001231748','OH00000439088','IL','1','Crutcher','Carrie','','','','34','291783160','6266 CORBLY RD',0,'CINCINNATI','OH','45230','1543','CY','39061','1981-12-15','F','U',':RET:2106-3','N','021','DEN','2515453','99734OH005000401','2014-01-01','2013-12-22 19:34:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:49:52'),(6664,5286,'N','01','021','EC','A',NULL,NULL,'','0000168712','0000342392','','IL','1','Hedrick','Alan','Lee','','','34','295703694','409 E 9TH ST',0,'VALLEY MILLS','TX','76689','4506','CY','48035','1975-12-15','M','',':RET:2106-3','N','021','DEN','459701','33348TX002000201','2014-01-01','2013-11-16 11:12:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:00:57'),(20570,16440,'Y','18','021','EC','A','','','AC','0001070506','0001070506','OH00002461434','IL','1','Gilliam','Thelma','','','','34','296488765','227 Linda Court',0,'Trenton','OH','45067',NULL,'CY','39017','1950-06-06','F','U',':RET:2106-3','T','021','HLT','2875097','92036OH004001201','2014-03-01','2014-01-29 16:43:26','388.00',NULL,NULL,'585.97','197.97','R-OH004','OH0','585.97',NULL,0,'2014-01-29 21:01:52'),(24597,19528,'Y','18','021','EC','A','','','AC','0000477503','0000477503','OH00002719699','IL','1','Smith','Lisa','','','','34','278828586','32 N. Leutz rd.',0,'oak harbor','OH','43449',NULL,'CY','39123','1968-05-31','F','U',':RET:2106-3','N','021','DEN','3274461','99734OH005000301','2014-04-01','2014-02-19 15:31:38','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-20 04:12:16'),(25192,19983,'Y','18','024','14','A','','','TE','0002184664','0002184664','','IL','1','Alexander','Whitney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-06','F','',NULL,NULL,NULL,'','3691979','','2014-02-20','2014-02-20 18:28:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-21 22:00:41'),(26491,21014,'Y','18','021','EC','A','','','AC','0002048871','0002048871','LA00003147898','IL','1','BUSSEY','LORNA','','','','34','436193095','337 RUTH ST',0,'HOUMA','LA','70364','3365','CY','22109','1961-11-18','F','M',':RET:2106-3','N','021','DEN','3742224','18575LA002000201','2014-04-01','2014-02-28 15:45:57','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61','CIC',0,'2014-02-28 21:00:10'),(27241,21570,'Y','18','021','EC','A','','','AC','0000111950','0000111950','OH00002713709','IL','1','jewell','tara','','','','34','595521558','12 E VOORHEES ST',0,'CINCINNATI','OH','45215','4817','CY','39061','1984-05-03','F','U',':RET:2106-3','N','021','HLT','2894030','92036OH004001201','2014-04-01','2014-03-03 04:06:23','178.00',NULL,NULL,'193.15','15.15','R-OH004','OH0','193.15',NULL,0,'2014-03-03 21:31:47'),(9587,7591,'N','01','021','EC','A',NULL,NULL,'','0000949898','0000629256','','IL','1','CARTER','LORETTA','','','','34','587781835','22 WILMA JAMES CARTER DR',0,'BEAUMONT','MS','39423','2427','CY','28111','1957-08-05','F','',':RET:2054-5','N','021','DEN','2613302','46300MS002000201','2014-01-01','2013-12-20 20:01:09',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 04:37:03'),(19140,15250,'N','01','021','EC','A',NULL,NULL,'','0000660461','0000663137','','IL','1','Fahmy','Michael','','','','34','645461576','2802 CLIFFBROOK DR',0,'CARROLLTON','TX','75007','5709','CY','48121','1956-05-15','M','',NULL,'N','021','DEN','1640525','33348TX002000201','2014-03-01','2014-01-18 23:55:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-21 08:45:28'),(7822,6196,'Y','18','021','EC','A','','','AC','0000070601','0000070601','TX00000290371','IL','1','Shing','Silvia','','','','34','555933733','7113 N 4TH ST',0,'MCALLEN','TX','78504','1745','CY','48215','1957-11-28','F','M',NULL,'N','021','DEN','1681058','33348TX002000201','2014-01-01','2013-12-20 18:27:42','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 03:04:13'),(7575,5994,'Y','18','021','EC','A','','','AC','0000179878','0000179878','OH00000294790','IL','1','Blevins','Kari','','','','34','271804648','122 S. Vine St.',0,'Convoy','OH','45832',NULL,'CY','39161','1982-01-15','F','M',':RET:2106-3','N','021','HLT','709415','92036OH005001506','2014-01-01','2013-12-15 13:21:30','206.00',NULL,NULL,'255.08','49.08','R-OH002','OH0','255.08',NULL,0,'2013-12-26 02:33:50'),(18464,14730,'Y','18','021','EC','A','','','AC','0001752776','0001752776','LA00002399711','IL','1','Pardue','Donna','','','','34','437452855','31767 Shelton Drive',0,'Springfield','LA','70462',NULL,'CY','22063','1966-01-21','F','U',':RET:2106-3','N','021','DEN','2867434','18575LA002000101','2014-02-01','2014-01-15 16:48:49','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:14'),(3905,3124,'N','19','021','EC','A',NULL,NULL,'','0000857079','0000877100','','IL','1','MOOMEY','AMBER','','','','34','300966407','17231 W TRUE RD',0,'GRAYTOWN','OH','43432','9799','CY','39123','1994-06-01','F','',':RET:2106-3','N','021','HLT','394064','92036OH005002705','2014-01-01','2013-12-12 18:52:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-25 21:36:57'),(5331,4227,'N','01','021','EC','A',NULL,NULL,'','0000151965','0001040842','','IL','1','LaForce','Eveline','','','','34','301486245','7140 White Water Ct.',0,'Dayton','OH','45414',NULL,'CY','39113','1950-10-28','F','',NULL,'N','021','DEN','1494883','99734OH005000301','2014-01-01','2013-12-19 12:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:07:06'),(5871,4659,'Y','18','021','EC','A','','','AC','0000134580','0000134580','OH00000385876','IL','1','Ridge','Carol','','','','34','303540499','103 THORNHILL AVE',0,'XENIA','OH','45385','5531','CY','39057','1950-08-28','F','M',NULL,'T','021','HLT','1387646','92036OH005000506','2014-01-01','2013-12-23 21:44:27','543.00',NULL,NULL,'806.95','263.95','R-OH003','OH0','806.95',NULL,0,'2013-12-25 23:49:14'),(14725,11757,'Y','18','024','14','A','','','TE','0002238058','0002238058','','IL','1','ANDERSEN','MARY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-11-14','F','',NULL,NULL,NULL,'','2486905','','2013-12-27','2013-12-27 18:37:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2013-12-29 11:09:39'),(17390,13914,'Y','18','024','14','A','','','TE','0000653212','0000653212','','IL','1','Jones','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-23','F','',NULL,NULL,NULL,'','2001773','','2014-01-10','2014-01-10 10:42:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:10'),(17958,14349,'Y','18','024','14','A','','','TE','0001005618','0001005618','','IL','1','quintanilla','juan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-08-18','M','',NULL,NULL,NULL,'','2581670','','2014-01-14','2014-01-14 18:26:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:45'),(18084,14443,'Y','18','024','14','A','','','TE','0001274270','0001274270','','IL','1','Guillen','Eddy','Villalta',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-18','M','',NULL,NULL,NULL,'','2588975','','2014-01-14','2014-01-14 11:34:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-15 02:07:28'),(20789,16610,'N','01','021','EC','A',NULL,NULL,'','0000168969','0000926605','','IL','1','Trauthwein','Gregory','C','','','34','273446879','4 MUSKMALLOW CT',0,'THE WOODLANDS','TX','77380','1520','CY','48339','1954-05-28','M','',':RET:2106-3','N','021','DEN','3266534','33348TX002000201','2014-03-01','2014-01-31 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-31 21:00:14'),(23658,18839,'Y','18','021','EC','A','','','AC','0000576485','0000576485','TX00002621159','IL','1','Hebert','Carol','','','','34','637059837','400 COUNTY ROAD 3136',0,'BUNA','TX','77612','3436','CY','48241','1985-06-16','F','M',NULL,'N','021','DEN','3581475','33348TX002000201','2014-03-01','2014-02-14 10:55:38','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:18'),(24066,19138,'Y','18','021','EC','A','','','AC','0000243788','0000243788','OH00002418141','IL','1','Brewer','Steven','Nathaniel','','Jr','34','289848077','2201 KEMPER LN',0,'CINCINNATI','OH','45206','2718','CY','39061','1986-06-10','M','U',':RET:2054-5','N','021','DEN','3438334','99734OH005000301','2014-03-01','2014-02-15 17:11:56','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:01:12'),(24289,19290,'Y','18','021','EC','A','','','AC','0000114254','0000114254','OH00003004472','IL','1','McNeal','Amanda','','','','34','295863602','5710 BUCKWHEAT RD',0,'MILFORD','OH','45150','2415','CY','39025','1985-12-30','F','U',NULL,'N','021','HLT','3735909','92036OH005000605','2014-04-01','2014-02-18 10:03:56','105.00',NULL,NULL,'233.35','128.35','R-OH005','OH0','233.35','CIC',0,'2014-02-18 21:30:11'),(27074,21437,'Y','18','021','EC','A','','','AC','0000671758','0000671758','OH00003225597','IL','1','douglas','shannon','','','','34','285601561','1230 BYE ST',0,'AKRON','OH','44320','1902','CY','39153','1970-02-17','F','U',':RET:2054-5','T','021','HLT','3721635','52664OH152000901','2014-04-01','2014-03-02 19:29:40','438.00',NULL,NULL,'633.19','195.19','R-OH012','OH0','262.41',NULL,0,'2014-03-03 21:30:08'),(27164,21508,'N','01','021','EC','A',NULL,NULL,'','0000819360','0000044935','','IL','1','Dinh','Ngoc','','','','34','806332289','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1990-10-03','F','',':RET:2047-9','N','021','DEN','3151799','33348TX002000201','2014-04-01','2014-03-03 10:28:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-03 21:31:01'),(27316,21628,'Y','18','021','EC','A','','','AC','0000021102','0000021102','TX00003327899','31','1','Cooper','Lisa','Renee','','','34','466470483','P.O Box 296',0,'Mount Enterprise','TX','75681',NULL,'CY','48401','1979-08-16','F','U',':RET:2054-5','N','021','DEN','3061541','33348TX002000201','2014-04-01','2014-03-04 14:53:57','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-03-04 21:00:42'),(28295,22388,'Y','18','021','EC','A','','','AC','0000198629','0000198629','OH00002704901','IL','1','Day','Jennifer','','','','34','291884850','2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','1982-10-29','F','M',':RET:2106-3','N','021','HLT','2876054','92036OH004000601','2014-04-01','2014-03-07 11:40:17','287.00',NULL,NULL,'513.87','226.87','R-OH005','OH0','200.06','CIC',0,'2014-03-07 21:00:29'),(18764,14951,'Y','18','021','EC','A','','','AC','0000461944','0000461944','TX00002361990','IL','1','Medina','Yeni','','','','34','456655397','8939 HAZEN ST',0,'HOUSTON','TX','77036','6747','CY','48201','1982-03-29','F','U',':RET:2106-3','N','021','DEN','1928607','33348TX002000101','2014-03-01','2014-01-16 14:26:40','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:48'),(14167,11294,'Y','18','021','EC','A','','','AC','0001336636','0001336636','LA00001762358','IL','1','McRae','Jeff','','','','34','238818684','1617 N BROAD ST',0,'NEW ORLEANS','LA','70119','2335','CY','22071','1979-02-23','M','U',':RET:2106-3','N','021','DEN','2154234','18575LA002000201','2014-02-01','2013-12-26 17:28:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:20'),(13245,10570,'Y','18','021','EC','A','','','AC','0000397090','0000397090','TX00000786561','IL','1','Alexander','Sean','Lavar','','','34','573472177','8432 Creek Bluff Dr',0,'Dallas','TX','75249',NULL,'CY','48113','1977-05-14','M','M',':RET:2054-5','N','021','DEN','2083600','33348TX002000201','2014-01-01','2013-12-23 09:42:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:56:13'),(17016,13618,'Y','18','021','EC','A','','','AC','0000662708','0000662708','OH00002302235','IL','1','Hartong','Jill','','','','34','284523886','730 ALAMEDA AVE',0,'CUYAHOGA FALLS','OH','44221','1208','CY','39153','1950-05-26','F','M',':RET:2106-3','N','021','HLT','1786258','52664OH152000901','2014-02-01','2014-01-09 10:39:29','424.00',NULL,NULL,'482.18','58.18','R-OH012','OH0','482.18',NULL,0,'2014-01-13 02:20:38'),(4159,3313,'N','19','021','EC','A',NULL,NULL,'','0000930898','0001003283','','IL','1','NAKKA','DANIEL','RATANKIRITI','','','34','271083719','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','2002-09-22','M','',':RET:2029-7','N','021','DEN','1675008','99734OH005000301','2014-01-01','2013-12-17 15:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:57'),(4093,3270,'Y','18','021','EC','A','','','AC','0001102489','0001102489','MS00000648814','IL','1','MALLARD','NICHOLAS','','','','34','428497429','607 WHITE ST',0,'MCCOMB','MS','39648','3050','CY','28113','1984-05-26','M','M',':RET:2054-5','N','021','DEN','2598786','46300MS002000101','2014-01-01','2013-12-16 21:31:47','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 21:47:30'),(3742,2993,'Y','18','021','EC','A','','','AC','0000174908','0000174908','TX00001248151','IL','1','riley','shane','','','','34','643095682','10910 MARBLE RD',0,'AUSTIN','TX','78750','1518','CY','48453','1987-09-11','M','U',':RET:2106-3','N','021','DEN','523912','33348TX002000201','2014-01-01','2013-12-13 13:29:21','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:32:55'),(15097,12066,'N','01','021','EC','A',NULL,NULL,'','0001081806','0000906612','','IL','1','Lawson','James',NULL,NULL,NULL,NULL,NULL,'24383 Smith Avenue',0,'Westlake','OH','44145',NULL,'CY','39035','1951-01-21','M','',NULL,'N','021','DEN','2257055','99734OH005000301','2014-02-01','2013-12-30 05:44:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:04:35'),(16642,13315,'Y','18','021','EC','A','','','AC','0000714985','0000714985','OH00002008367','IL','1','Mcquain','Mary','Lynne','','','34','283483566','129 W CUYAHOGA FALLS AVE',0,'AKRON','OH','44310','2903','CY','39153','1951-11-23','F','M',':RET:2106-3','N','021','DEN','2372561','99734OH005000401','2014-02-01','2014-01-07 13:53:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-08 18:24:18'),(27935,22098,'Y','18','024','14','A','','','TE','0000387953','0000387953','','IL','1','Thomas','Melinda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-01-30','F','',NULL,NULL,NULL,'','1982765','','2014-03-21','2014-03-06 13:01:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-06 21:00:28'),(28647,22669,'N','19','021','EC','A',NULL,NULL,'','0000218017','0001153434','','IL','1','Church','Alexis','','','','34','425753999','953 ARBOR VISTA BLVD',0,'JACKSON','MS','39209','7133','CY','28049','1992-11-05','F','',':RET:2054-5','N','021','DEN','3530033','46300MS002000101','2014-04-01','2014-03-07 22:16:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-08 21:30:36'),(17670,14120,'Y','18','021','EC','A','','','AC','0001930308','0001930308','LA00001531349','IL','1','Guggenheim','Tonya','Joanne','','','34','452738652','2826 Misty lane',0,'Bossier City','LA','71111',NULL,'CY','22015','1978-05-19','F','M',':RET:2106-3','T','021','DEN','2128875','18575LA002000101','2014-02-01','2014-01-12 20:21:21','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-14 01:32:49'),(5463,4339,'N','01','021','EC','A',NULL,NULL,'','0000728698','0001038585','','IL','1','Meyer','Dustin','','','','34','272880278','5800 FESSLER BUXTON RD',0,'HOUSTON','OH','45333','9771','CY','39149','1986-04-06','M','',':RET:2106-3','N','021','HLT','1661679','92036OH006000501','2014-01-01','2013-12-19 09:03:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','197.56',NULL,0,'2013-12-25 23:10:28'),(1478,1232,'Y','18','021','EC','A','','','AC','0000442180','0000442180','OH00001308978','IL','1','Gilchrist','Timothy','','','','34','426233775','4538 Natural Trail',0,'New Albany','OH','43054',NULL,'CY','39049','1962-04-19','M','U',NULL,'N','021','DEN','1652412','99734OH005000401','2014-01-01','2013-12-24 10:03:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:44'),(19814,15798,'Y','18','021','EC','A','','','AC','0000194999','0000194999','TX00002260431','IL','1','VO','TUYET','','','','34','630080783','4318 GOODNIGHT TRL',0,'SAN ANGELO','TX','76903','8113','CY','48451','1977-12-12','F','M',':RET:2047-9','N','021','DEN','3066550','33348TX002000201','2014-03-01','2014-01-23 20:37:30','0.00',NULL,NULL,'29.22','29.22','R-TX018','TX0','14.61',NULL,0,'2014-01-24 21:00:11'),(24899,19741,'N','19','021','EC','A',NULL,NULL,'','0000737896','0001235234','','S1','1','MARTIN','BRANDON','','','','34','758168587','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','2013-10-16','M','',NULL,'N','021','HLT','3420153','92036OH003002705','2014-01-01','2014-02-19 17:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-20 05:41:10'),(25162,19959,'Y','18','021','EC','A','','','AC','0001225760','0001225760','OH00002909147','IL','1','Decker','Philip','','','','34','278847123','257 STERLING AVE',0,'RITTMAN','OH','44270','1269','CY','39169','1985-12-06','M','M',':RET:2106-3','N','021','DEN','3113285','99734OH005000401','2014-04-01','2014-02-20 21:46:57','0.00',NULL,NULL,'31.57','31.57','R-OH014','OH0','0.00',NULL,0,'2014-02-21 22:00:23'),(25191,19982,'Y','18','021','EC','A','','','AC','0002173953','0002173953','LA00002257322','IL','1','Lee','Rachelle','','','','34','620188371','2307 PLINY ST',0,'BATON ROUGE','LA','70808','1493','CY','22033','1988-04-13','F','U',':RET:2106-3','N','021','DEN','3076174','18575LA002000101','2014-04-01','2014-02-20 18:18:22','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-21 22:00:40'),(27453,21726,'Y','18','021','EC','A','','','AC','0000618423','0000618423','OH00003474452','IL','1','Ress','Michael','','','','34','277563694','3596 TURNBERRY',0,'AMELIA','OH','45102','2505','CY','39025','1953-10-20','M','R',':RET:2106-3','N','021','HLT','3996374','92036OH006000601','2014-04-01','2014-03-03 19:36:50','0.00',NULL,NULL,'462.04','462.04','R-OH005','OH0','462.04',NULL,0,'2014-03-04 21:02:00'),(17987,14374,'Y','18','021','EC','A','','','AC','0000650798','0000650798','OH00001961490','IL','1','Steffan','Lisa','','','','34','286808129','738 STERLING RD',0,'WICKLIFFE','OH','44092','2162','CY','39085','1969-06-01','F','U',':RET:2106-3','T','021','HLT','2181534','52664OH151001305','2014-02-01','2014-01-14 17:09:58','190.00',NULL,NULL,'404.08','214.08','R-OH011','OH0','404.08',NULL,0,'2014-01-15 02:06:55'),(1152,950,'Y','18','021','EC','A','','','AC','0000650770','0000650770','LA00000503038','IL','1','Doucette','Steven','','','','34','434218653','2112 New Orleans St',0,'New Orleans','LA','70119',NULL,'CY','22071','1961-05-06','M','U',':RET:2054-5','N','021','DEN','1137794','18575LA002000201','2014-01-01','2013-12-03 06:57:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:39'),(5642,4476,'Y','18','021','EC','A','','','AC','0001107547','0001107547','TX00001111790','IL','1','Novak','Richard','','','','34','212603746','22959 CREEKSIDE WILLOW DR',0,'TOMBALL','TX','77375','7196','CY','48201','1953-12-12','M','M',':RET:2106-3','N','021','DEN','1071075','33348TX002000201','2014-01-01','2013-11-26 14:47:40','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:31:17'),(2545,2071,'Y','18','021','EC','A','','','AC','0000552608','0000552608','OH00000230090','IL','1','Voiers','Claire Ann','','','','34','288549122','56 JEAN AVE',0,'MUNROE FALLS','OH','44262','1342','CY','39153','1954-05-05','F','R',':RET:2106-3','N','021','HLT','34218','52664OH151001501','2014-01-01','2013-12-09 11:18:25','0.00',NULL,NULL,'696.21','696.21','R-OH012','OH0','696.21',NULL,0,'2013-12-25 19:37:08'),(17544,14027,'Y','18','021','EC','A','','','AC','0000584291','0000584291','OH00002268408','IL','1','Rebrisorean','Viorel','','','','34','288085854','2115 REDWOOD PL',0,'CANFIELD','OH','44406','8463','CY','39099','1967-08-01','M','M',':RET:2106-3','N','021','HLT','1466827','92036OH005003205','2014-02-01','2014-01-12 12:52:12','500.00',NULL,NULL,'933.58','433.58','R-OH013','OH0','363.07',NULL,0,'2014-01-13 03:01:50'),(17312,13846,'Y','18','021','EC','A','','','AC','0000151741','0000151741','TX00002526584','IL','1','Silva','Altagracia','','','','34','566967587','1021 BEECHWOOD DR',0,'TYLER','TX','75701','7630','CY','48423','1950-06-17','F','M',NULL,'N','021','DEN','1403492','33348TX002000201','2014-02-01','2014-01-10 14:30:44','0.00',NULL,NULL,'30.83','30.83','R-TX022','TX0','14.61',NULL,0,'2014-01-13 02:23:45'),(16445,13158,'Y','18','021','EC','A','','','AC','0001209574','0001209574','MS00000582913','IL','1','parrish','lea','','','','34','425631300','260 soso big creek rd',0,'soso','MS','39480',NULL,'CY','28067','1974-03-08','F','M',':RET:2106-3','T','021','DEN','1644039','46300MS002000101','2014-02-01','2014-01-05 21:49:17','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-07 04:05:13'),(16846,13476,'Y','18','021','EC','A','','','AC','0000648344','0000648344','OH00002137225','IL','1','Plakosh','Jeanne','','','','34','285581823','2819 ALGONQUIN DR',0,'POLAND','OH','44514','1811','CY','39099','1955-12-20','F','U',':RET:2106-3','T','021','HLT','2411983','92036OH004003201','2014-02-01','2014-01-11 10:30:27','290.00',NULL,NULL,'570.29','280.29','R-OH013','OH0','570.29',NULL,0,'2014-01-13 02:18:36'),(19377,15447,'Y','18','024','14','A','','','TE','0000370958','0000370958','','IL','1','Nelson','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-03-15','F','',NULL,NULL,NULL,'','1624674','','2014-01-21','2014-01-21 11:32:32',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2014-01-22 03:22:40'),(19643,15655,'Y','18','021','EC','A','','','AC','0000203115','0000203115','OH00002459929','31','1','Symons','Brenda','','','','34','288503981','Po box 312',0,'Bolivar','OH','44612',NULL,'CY','39157','1950-05-30','F','U',':RET:2106-3','N','021','DEN','2370335','99734OH005000401','2014-03-01','2014-01-23 17:08:56','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-23 21:00:16'),(19802,15787,'Y','18','021','EC','A','','','AC','0001201329','0001201329','TX00002210980','IL','1','Salinas','Alicia','','','','34','452904712','204 W VINE AVE',0,'MCALLEN','TX','78501','2143','CY','48215','1950-11-24','F','M',NULL,'N','021','DEN','3272438','33348TX002000201','2014-03-01','2014-01-24 11:44:54','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-24 21:00:05'),(20005,15954,'Y','18','021','EC','A','','','AC','0000503008','0000503008','OH00002551528','IL','1','MCPETERS','CATHERINE','','','','34','292463171','443 E MAIN ST',0,'LEBANON','OH','45036','2261','CY','39165','1964-08-25','F','U',':RET:2106-3','T','021','DEN','3424979','99734OH005000401','2014-03-01','2014-01-26 11:45:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-26 19:00:05'),(23230,18520,'Y','18','021','EC','A','','','AC','0000035793','0000035793','OH00002557495','IL','1','Ramos','Jaime','Elizabeth','','','34','182722710','41 MAPLE AVE',0,'NORTHFIELD','OH','44067','1529','CY','39153','1987-11-24','F','U',':RET:2106-3','N','021','HLT','2862040','52664OH152001001','2014-03-01','2014-02-12 08:08:59','0.00',NULL,NULL,'125.55','125.55','R-OH012','OH0','125.55',NULL,0,'2014-02-12 21:32:25'),(24396,19378,'Y','18','021','EC','A','','','AC','0000175155','0000175155','OH00002514211','IL','1','GRIFFIN','ELIZABETH','','','','34','233944262','250 FAIRVIEW ST',0,'MARION','OH','43302','1815','CY','39101','1959-04-19','F','M',':RET:2106-3','N','021','DEN','3091062','99734OH005000401','2014-04-01','2014-02-18 14:10:16','0.00',NULL,NULL,'31.57','31.57','R-OH008','OH0','0.00',NULL,0,'2014-02-18 22:00:52'),(25688,20381,'Y','18','021','EC','A','','','AC','0000149104','0000149104','MS00003121346','IL','1','SINGLETON','JANICE','A','','','34','428375129','405 D LINDALE STREET',0,'CLINTON','MS','39056',NULL,'CY','28049','1965-10-25','F','U',':RET:2054-5','N','021','DEN','3641151','46300MS002000201','2014-04-01','2014-02-24 17:18:01','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:10'),(29158,23081,'Y','18','021','EC','A','','','AC','0000959165','0000959165','OH00002619137','IL','1','MITCHELL','RICHARD','','','','34','290607480','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','1968-05-15','M','M',NULL,'N','021','HLT','4234698','92036OH006000501','2014-04-01','2014-03-10 13:16:43','346.00',NULL,NULL,'752.57','406.57','R-OH003','OH0','272.22',NULL,0,'2014-03-10 21:02:53'),(13565,10818,'Y','18','021','EC','A','','','AC','0002348400','0002348400','LA00000729723','31','1','Wren','Jessica','','','','34','439574384','PO Box 1195',0,'Coushatta','LA','71019',NULL,'CY','22081','1979-10-14','F','U',':RET:2106-3','N','021','DEN','2269990','18575LA002000201','2014-01-01','2013-12-23 16:33:36','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:04:28'),(1484,1238,'Y','18','021','EC','A','','','AC','0000312189','0000312189','OH00000043514','IL','1','Bucci','Christina','','','','34','294922776','3258 Birchview Drive',0,'Ravenna','OH','44266',NULL,'CY','39133','1983-04-02','F','U',':RET:2106-3','N','021','DEN','2213430','99734OH005000401','2014-01-01','2013-12-24 10:49:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:48:53'),(1592,1330,'Y','18','021','EC','A','','','AC','0001005542','0001005542','TX00001407934','IL','1','Perez','Andrew','','','','34','450935745','602 UPSON DR',0,'EL PASO','TX','79902','3753','CY','48141','1985-01-17','M','U',':RET:2106-3','T','021','DEN','2281810','33348TX002000201','2014-01-01','2013-12-24 11:57:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:51:47'),(17188,13754,'Y','18','021','EC','A','','','AC','0001206035','0001206035','TX00001486844','IL','1','Shaw','Amy','','','','34','455975222','224 AZALEA TRL',0,'BOERNE','TX','78006','2142','CY','48259','1983-02-20','F','M',NULL,'N','021','DEN','2183849','33348TX002000101','2014-02-01','2014-01-08 16:05:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-13 02:22:17'),(16226,12995,'Y','18','021','EC','A','','','AC','0000864838','0000864838','OH00002050843','IL','1','ARNETT','AMY','','','','34','293709217','372 NUTT RD',0,'DAYTON','OH','45458','9690','CY','39113','1967-10-03','F','U',NULL,'N','021','DEN','2385356','99734OH005000401','2014-02-01','2014-01-04 16:10:39','0.00',NULL,NULL,'50.05','50.05','R-OH003','OH0','0.00',NULL,0,'2014-01-05 00:01:56'),(9282,7361,'N','01','021','EC','A',NULL,NULL,'','0000753357','0000025265','','IL','1','TARELLARI','ARTHUR','','','','34','391022020','10814 WINDHAM RD',0,'PARMA','OH','44130','1573','CY','39035','1975-03-16','M','',':RET:2106-3','N','021','DEN','15448','99734OH005000301','2014-01-01','2013-11-30 11:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:15:54'),(3683,2948,'Y','18','021','EC','A','','','AC','0000141484','0000141484','OH00000322866','IL','1','stojsavljevic','milorad','','','','34','295502702','20064 IDLEWOOD TRL',0,'STRONGSVILLE','OH','44149','3143','CY','39035','1952-01-24','M','U',':RET:2106-3','N','021','DEN','33675','99734OH005000401','2014-01-01','2013-12-13 09:54:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:31:30'),(23981,19067,'Y','18','024','14','A','','','TE','0002352112','0002352112','','IL','1','Rogers','Vicki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-28','F','',NULL,NULL,NULL,'','3593406','','2014-02-14','2014-02-14 18:45:24',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-15 22:00:20'),(24290,19291,'Y','18','024','14','A','','','TE','0000303382','0000303382','','IL','1','CHEATHAM','LATOYA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-04-06','F','',NULL,NULL,NULL,'','1661015','','2014-03-31','2014-02-18 10:14:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:12'),(27401,21691,'Y','18','021','EC','A','','','AC','0001036189','0001036189','OH00003432257','S1','1','Ramos','Andrew','','','','34','680447223','8308 WAINSTEAD DR',0,'PARMA','OH','44129','4847','CY','39035','2002-10-04','M','U',':RET:2106-3','N','021','DEN','3897424','99734OH005000301','2014-04-01','2014-03-04 01:59:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2014-03-04 21:01:31'),(27591,21820,'N','19','021','EC','A',NULL,NULL,'','0000693636','0000024902','','IL','1','Daughn','Madison','Blair','','','34','632625011','1401 Hartford Rd',0,'Austin','TX','78703',NULL,'CY','48453','1998-06-23','F','',NULL,'N','021','DEN','3830956','33348TX002000201','2014-04-01','2014-03-05 16:38:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52','CIC',0,'2014-03-05 21:00:17'),(29084,23020,'Y','18','021','EC','A','','','AC','0000158470','0000158470','MS00003737254','IL','1','NELSON','MALIYA','','','','34','363889505','5230 WILLIAMS RD',0,'HERNANDO','MS','38632','4287','CY','28033','1972-01-12','F','U',':RET:2054-5','N','021','DEN','3902596','46300MS002000101','2014-04-01','2014-03-10 17:35:44','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-03-10 21:02:05'),(13799,11015,'Y','18','021','EC','A','','','AC','0000734864','0000734864','MS00001027644','IL','1','Applewhite','Jacqueline','','','','34','428153641','132 CHURCH LN',0,'LONG BEACH','MS','39560','5434','CY','28047','1960-01-24','F','U',':RET:2054-5','N','021','DEN','1740966','46300MS002000101','2014-01-01','2013-12-23 12:21:14','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-26 13:11:20'),(18067,14431,'Y','18','021','EC','A','','','AC','0002307241','0002307241','LA00002012030','IL','1','ballom','demetrice','','','','34','436518792','1345 INDEPENDENCE ST',0,'NEW ORLEANS','LA','70117','5635','CY','22071','1971-10-14','F','U',':RET:2054-5','N','021','DEN','2460335','18575LA002000201','2014-02-01','2014-01-13 23:18:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:22'),(9744,7716,'Y','18','021','EC','A','','','AC','0001038960','0001038960','TX00000291894','IL','1','Estrada','Margaret','','','','34','463920478','7007 CORAL LN',0,'SACHSE','TX','75048','2537','CY','48085','1954-11-16','F','M',':RET:2106-3','N','021','DEN','416977','33348TX002000201','2014-01-01','2013-11-15 16:27:55','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:46:00'),(9544,7563,'N','01','021','EC','A',NULL,NULL,'','0000570552','0000840507','','IL','1','Kobistek','Mary','','','','34','304502197','5589 CARDINAL DR',0,'MENTOR','OH','44060','1841','CY','39085','1953-02-11','F','',':RET:2106-3','N','021','DEN','1397616','99734OH005000301','2014-01-01','2013-12-21 11:57:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:06'),(5398,4285,'Y','18','021','EC','A','','','AC','0001244157','0001244157','OH00000549369','IL','1','Spencer','Neal','','','','34','285482100','106 South Elm Street',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1949-11-18','M','U',':RET:2106-3','N','021','HLT','2258965','92036OH004001501','2014-01-01','2013-12-18 20:32:04','328.00',NULL,NULL,'530.89','202.89','R-OH002','OH0','530.89',NULL,0,'2013-12-25 23:08:52'),(21306,17025,'Y','18','024','14','A','','','TE','0002253951','0002253951','','IL','1','Bryant','Angie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-03-27','F','',NULL,NULL,NULL,'','3543695','','2014-02-04','2014-02-04 10:23:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-04 21:00:15'),(22070,17617,'Y','18','021','EC','A','','','AC','0000556579','0000556579','TX00001869173','IL','1','wilson','travonda','','','','34','433411481','1603 nandina drive',0,'arlington','TX','76014',NULL,'CY','48439','1976-10-30','F','M',':RET:2054-5','N','021','DEN','3530581','33348TX002000201','2014-03-01','2014-02-08 15:24:09','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-08 19:00:13'),(24759,19646,'N','19','021','EC','A',NULL,NULL,'','0000027939','0001135222','','IL','1','Dugan','Matthew','J','','','34','284988688','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1995-05-29','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:42:44'),(13823,11033,'Y','18','021','EC','A','','','AC','0000479843','0000479843','OH00001166357','IL','1','Spade','Bryan','','','','34','275829118','11047 CANAAN CENTER RD',0,'CRESTON','OH','44217','9763','CY','39169','1982-02-09','M','U',NULL,'N','021','HLT','2313013','52664OH152000901','2014-01-01','2013-12-22 22:35:10','189.31',NULL,NULL,'189.31','0.00','R-OH014','OH0','189.31',NULL,0,'2013-12-26 13:11:56'),(19063,15185,'Y','18','024','14','A','','','TE','0000814403','0000814403','','IL','1','ALLEN','GLANDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-28','F','',NULL,NULL,NULL,'','2413080','','2014-01-18','2014-01-18 12:36:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:44:16'),(444,365,'Y','18','021','EC','A','','','AC','0000443426','0000443426','OH00000616213','IL','1','Gephart','Michael','','','','34','277760118','1519 HENLEY RD',0,'TROY','OH','45373','2616','CY','39109','1966-10-02','M','M',':RET:2106-3','N','021','DEN','563748','99734OH005000401','2014-01-01','2013-12-04 11:43:20','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:47:14'),(17321,13854,'Y','18','024','14','A','','','TE','0000348936','0000348936','','IL','1','Dhungana','Obi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-02-02','M','',NULL,NULL,NULL,'','2301961','','2014-01-10','2014-01-10 17:36:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:23:50'),(3154,2537,'Y','18','021','EC','A','','','AC','0000509175','0000509175','OH00000961718','IL','1','Abrams','Anita','','','','34','298583401','8324 White Hill Lane',0,'West Chester','OH','45069',NULL,'CY','39017','1956-09-07','F','U',NULL,'N','021','DEN','475050','99734OH005000301','2014-01-01','2013-11-18 15:47:06','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:07'),(16559,13248,'Y','18','021','EC','A','','','AC','0002036748','0002036748','LA00002229355','IL','1','Woodrow','Melinda','','','','34','426332844','1639 CRETE ST',0,'NEW ORLEANS','LA','70119','3068','CY','22071','1964-03-03','F','U',':RET:2106-3','N','021','DEN','2030793','18575LA002000201','2014-02-01','2014-01-04 20:25:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-07 10:22:59'),(5118,4056,'Y','18','021','EC','A','','','AC','0000749035','0000749035','TX00000356152','IL','1','Schoonover','Jimmy','','','','34','455131842','8304 HIGHWAY 70',0,'PAMPA','TX','79065','1753','CY','48179','1955-09-15','M','M',':RET:2106-3','N','021','DEN','2039307','33348TX002000201','2014-01-01','2013-12-19 18:30:29','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:01:53'),(15580,12467,'Y','18','021','EC','A','','','AC','0000570571','0000570571','OH00001301902','IL','1','GIBSON','RICHARD','L','','','34','271564305','1969 BALTIMORE AVE',0,'CINCINNATI','OH','45225','1950','CY','39061','1957-03-25','M','M',NULL,'N','021','DEN','1437008','99734OH005000301','2014-02-01','2013-12-30 19:01:53','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:32:10'),(7294,5780,'N','01','021','EC','A',NULL,NULL,'','0000776411','0000484757','','IL','1','Pacifico','Kendra',NULL,NULL,NULL,NULL,NULL,'114 S PROSPECT ST',0,'KENT','OH','44240','3422','CY','39133','1961-10-14','F','',':RET:2106-3','N','021','HLT','370453','52664OH151001501','2014-01-01','2013-12-14 13:09:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-26 02:02:58'),(6353,5035,'Y','18','021','EC','A','','','AC','0000209607','0000209607','OH00000795258','IL','1','Meyer','James','','','','34','301745286','225 North 4th Street',0,'Columbus','OH','43215',NULL,'CY','39049','1967-01-04','M','R',':RET:2106-3','N','021','DEN','518515','99734OH005000401','2014-01-01','2013-12-11 14:09:59','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:47:06'),(22317,17818,'Y','18','021','EC','A','','','AC','0002226638','0002226638','LA00002552532','IL','1','August','Bruce','','','','34','434395898','610 Half Hebert St',0,'Jeanerette','LA','70544',NULL,'CY','22045','1971-04-18','M','U',NULL,'N','021','DEN','3004678','18575LA002000201','2014-03-01','2014-01-29 00:20:20','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-10 11:00:51'),(23267,18551,'Y','18','024','14','A','','','TE','0000987360','0000987360','','IL','1','Carnes','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-09','M','',NULL,NULL,NULL,'','438721','','2014-02-28','2014-02-13 14:33:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:12'),(23350,18608,'Y','18','021','EC','A','','','AC','0000235252','0000235252','OH00002801095','IL','1','Selby','Carolyn','','','','34','301463309','584 Fifth St Lane',0,'Barberton','OH','44203',NULL,'CY','39153','1951-09-16','F','U',':RET:2106-3','N','021','HLT','3723858','52664OH151001306','2014-03-01','2014-02-13 11:53:41','524.00',NULL,NULL,'640.70','116.70','R-OH012','OH0','640.70',NULL,0,'2014-02-13 22:00:41'),(26091,20692,'Y','18','024','14','A','','','TE','0002064248','0002064248','','IL','1','Gosha','Angelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-09','F','',NULL,NULL,NULL,'','3213260','','2014-02-27','2014-02-27 10:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-28 06:30:08'),(28287,22383,'N','01','021','EC','A',NULL,NULL,'','0000308334','0000885664','','IL','1','Kline','Daniel','','','','34','277426795','3518 RANDOLPH RD',0,'MOGADORE','OH','44260','9453','CY','39133','1949-11-29','M','',':RET:2106-3','N','021','HLT','3455015','52664OH151001305','2014-04-01','2014-03-07 10:30:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','669.00','CIC',0,'2014-03-07 21:00:27'),(7607,6019,'N','01','021','EC','A',NULL,NULL,'','0000081256','0001124033','','IL','1','DEITZ','YVONNE','','','','34','273608278','4256 N MONROE CTR',0,'KINGSVILLE','OH','44048','9706','CY','39007','1958-10-10','F','',':RET:2106-3','N','021','HLT','847402','52664OH151001301','2014-01-01','2013-11-16 20:24:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','560.89',NULL,0,'2013-12-26 02:45:33'),(4084,3262,'N','01','021','EC','A',NULL,NULL,'','0000656919','0000864810','','IL','1','CHESMAR','LARRY','DEAN','','','34','288546529','5759 CANTERBURY RD',0,'AKRON','OH','44319','5101','CY','39153','1956-10-20','M','',':RET:2106-3','N','021','HLT','1756079','52664OH152000901','2014-01-01','2013-12-17 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2013-12-25 21:47:14'),(2523,2056,'N','01','021','EC','A',NULL,NULL,'','0000232632','0000587958','','IL','1','Schilling','Peter','G','','','34','291766554','2914 MAYFAIR RD',0,'AKRON','OH','44312','5432','CY','39153','1969-04-05','M','',':RET:2106-3','N','021','HLT','917086','52664OH152000901','2014-01-01','2013-12-09 13:53:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','228.19',NULL,0,'2013-12-25 19:36:38'),(20541,16414,'Y','18','021','EC','A','','','AC','0000317367','0000317367','OH00001552016','IL','1','SHORTER','ROBERT','','','','34','271525738','2721 WESTCASTLE DR',0,'TOLEDO','OH','43615',NULL,'CY','39095','1949-06-25','M','M',NULL,'N','021','HLT','2967640','92036OH006002601','2014-03-01','2014-01-28 23:27:08','79.00',NULL,NULL,'463.92','384.92','R-OH001','OH0','463.92',NULL,0,'2014-01-29 21:01:36'),(28076,22220,'Y','18','021','EC','A','','','AC','0000830725','0000830725','TX00002706333','IL','1','Moreno','Juan','Pablo','','','34','640180709','7708 LUZ DE CAMINO WAY',0,'EL PASO','TX','79912','8433','CY','48141','1990-07-23','M','U',':RET:2106-3','N','021','DEN','2826215','33348TX002000101','2014-04-01','2014-03-05 19:13:23','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-03-06 21:01:54'),(28949,22910,'Y','18','021','EC','A','','','AC','0001277009','0001277009','LA00003220685','IL','1','Holloway','Dejunna','','','','34','435291767','802 fisher lane',0,'Kentwood','LA','70444',NULL,'CY','22105','1976-08-27','F','U',':RET:2054-5','N','021','DEN','3863383','18575LA002000201','2014-04-01','2014-03-09 22:54:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:00:48'),(13949,11123,'Y','18','021','EC','A','','','AC','0000196137','0000196137','OH00000661052','IL','1','Vogel','Judy','','','','34','275820374','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','1968-03-14','F','R',':RET:2106-3','T','021','HLT','1462002','92036OH004000601','2014-01-01','2013-12-23 12:07:50','0.00',NULL,NULL,'788.09','788.09','R-OH005','OH0','286.65',NULL,0,'2013-12-26 13:14:53'),(16575,13257,'N','01','021','EC','A',NULL,NULL,'','0000834478','0000403671','','IL','1','Mejia','Mario','','','','34','217898455','372 W Cedar St',0,'Akron','OH','44307',NULL,'CY','39153','1972-11-14','M','',':RET:2106-3','N','021','HLT','1439955','52664OH151001305','2014-02-01','2014-01-05 00:11:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.36',NULL,1,'2014-01-07 10:23:28'),(9720,7699,'Y','18','021','EC','A','','','AC','0000345545','0000345545','OH00000288182','IL','1','brosky','debra','','','','34','300544448','9968 AKINS RD',0,'NORTH ROYALTON','OH','44133','4547','CY','39035','1954-02-03','F','M',':RET:2106-3','N','021','DEN','450199','99734OH005000401','2014-01-01','2013-11-15 17:58:30','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:45:26'),(9342,7405,'Y','18','021','EC','A','','','AC','0001589081','0001589081','LA00000169279','IL','1','Dogan','Yolanda','','','','34','436237626','8369 Siegen Lane',0,'Baton Rouge','LA','70810',NULL,'CY','22033','1968-10-27','F','U',':RET:2054-5','T','021','DEN','1376756','18575LA002000201','2014-01-01','2013-12-20 20:54:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:02'),(7235,5736,'Y','18','021','EC','A','','','AC','0000198547','0000198547','OH00000494630','IL','1','Anu','Khepra','','','','34','272644017','2994 S MORELAND BLVD',0,'CLEVELAND','OH','44120','2759','CY','39035','1956-07-05','M','U',':RET:2054-5','N','021','DEN','206134','99734OH005000401','2014-01-01','2013-12-14 17:59:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:01:30'),(6765,5367,'Y','18','021','EC','A','','','AC','0000667831','0000667831','LA00000820037','31','1','Bourgeois','Deyanna','','','','34','438352365','PO box 1136',0,'Natalbany','LA','70451',NULL,'CY','22105','1978-06-02','F','M',':RET:2054-5','N','021','DEN','441963','18575LA002000201','2014-01-01','2013-11-24 21:06:04','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:16:27'),(2231,1836,'Y','18','021','EC','A','','','AC','0000477434','0000477434','OH00000458354','IL','1','Smith','Terence','','','','34','379786658','2484 LITTLE DRY RUN RD',0,'CINCINNATI','OH','45244','3247','CY','39061','1961-06-11','M','M',':RET:2054-5','N','021','HLT','116742','92036OH005001205','2014-01-01','2013-12-10 14:34:46','521.00',NULL,NULL,'819.40','298.40','R-OH004','OH0','419.03',NULL,0,'2013-12-25 19:20:48'),(17836,14248,'N','01','021','EC','A',NULL,NULL,'','0000255979','0000165103','','IL','1','Terrell','Jovan','B','','','34','290803009','5551 JOYCE ANN DR',0,'DAYTON','OH','45415','2948','CY','39113','1983-05-30','F','',NULL,'N','021','DEN','1864945','99734OH005000401','2014-02-01','2014-01-13 18:59:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:01'),(3227,2597,'Y','18','021','EC','A','','','AC','0000103849','0000103849','OH00000460513','IL','1','PETTIES','KAVEN','','','','34','364641558','1657 DELIA AVE',0,'AKRON','OH','44320','1671','CY','39153','1955-06-22','M','U',NULL,'N','021','DEN','1020737','99734OH005000401','2014-01-01','2013-10-05 19:40:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:45:57'),(5039,3990,'Y','18','021','EC','A','','','AC','0000105343','0000105343','OH00001108270','IL','1','kasch','martha','','','','34','271528133','20 TIMBERLAKE CT',0,'NORTHWOOD','OH','43619','1932','CY','39173','1950-09-24','F','U',':RET:2106-3','N','021','HLT','378299','92036OH003002605','2014-01-01','2013-12-07 14:26:49','456.00',NULL,NULL,'601.12','145.12','R-OH001','OH0','601.12',NULL,0,'2013-12-25 22:47:56'),(14261,11375,'Y','18','021','EC','A','','','AC','0001212944','0001212944','LA00000486484','IL','1','Mcclay','June','Helen','','','34','119529549','58215 Bayou Road',0,'Plaquemune','LA','70764',NULL,'CY','22047','1956-12-20','F','U',':RET:2054-5','N','021','DEN','1550337','18575LA002000101','2014-02-01','2013-12-26 13:44:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-27 02:05:48'),(14256,11370,'Y','18','021','EC','A','','','AC','0001689442','0001689442','LA00000097285','IL','1','CLARK','MANZY','','','','34','434765399','3003 MAIN ST',0,'BATON ROUGE','LA','70802','2756','CY','22033','1949-10-06','M','M',':RET:2054-5','N','021','DEN','2434904','18575LA002000101','2014-02-01','2013-12-26 10:40:59','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-27 02:05:39'),(23068,18392,'Y','18','021','EC','A','','','AC','0001209336','0001209336','LA00002411851','IL','1','Sheppard','Jessica','','','','34','589826543','212 VERRET ST',0,'NEW ORLEANS','LA','70114','1022','CY','22071','1978-04-19','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','3082108','18575LA002000201','2014-03-01','2014-02-12 12:25:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:55'),(27717,21919,'Y','18','021','EC','A','','','AC','0000223295','0000223295','TX00003262662','31','1','ROBINSON','LEONARD','C','','','34','467274603','P.O. BOX 33',0,'BAYCITY','TX','77414',NULL,'CY','48321','1959-11-27','M','U',':RET:2054-5','N','021','DEN','4120749','33348TX002000201','2014-04-01','2014-03-05 13:47:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:30:56'),(28580,22618,'Y','18','021','EC','A','','','AC','0001536865','0001536865','LA00003017913','IL','1','Smith','Ebony','Marie','','','34','437850656','703 JOHNSON ST',0,'JONESVILLE','LA','71343','2831','CY','22025','1992-09-28','F','U',':RET:2054-5','N','021','DEN','4108894','18575LA002000201','2014-04-01','2014-03-07 21:41:43','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61','CIC',0,'2014-03-08 21:00:07'),(16465,13174,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','1494060','','2014-01-06','2014-01-06 10:34:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:05:48'),(15866,12704,'Y','18','021','EC','A','','','AC','0000815056','0000815056','MS00001505064','IL','1','MILES','XAVIER','','','','34','587103430','70 BLANCHE ST',0,'LUCEDALE','MS','39452','5942','CY','28039','1951-12-11','M','U',':RET:2054-5','N','021','DEN','1958505','46300MS002000101','2014-02-01','2014-01-02 14:09:47','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-03 02:04:56'),(15353,12282,'Y','18','021','EC','A','','','AC','0000956658','0000956658','OH00001437294','IL','1','Bawa','Ruchi','','','','34','279800346','6574 LAKESIDE DR',0,'WEST CHESTER','OH','45069','4490','CY','39017','1976-09-24','F','U',':RET:2029-7','N','021','DEN','1875371','99734OH005000301','2014-02-01','2013-12-31 23:15:12','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:24:37'),(13817,11029,'Y','18','024','14','A','','','TE','0000422785','0000422785','','IL','1','Pozo','Angelica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-17','F','',NULL,NULL,NULL,'','78057','','2013-12-22','2013-12-22 21:59:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:11:47'),(5409,4294,'Y','18','021','EC','A','','','AC','0000974082','0000974082','OH00001059005','IL','1','Middleton','Keith','Thomas','','','34','292585611','719 MCCUNE RD',0,'WILMINGTON','OH','45177','8715','CY','39027','1959-11-09','M','M',':RET:2106-3','N','021','HLT','1575700','92036OH003000601','2014-01-01','2013-12-19 13:29:44','737.00',NULL,NULL,'1302.50','565.50','R-OH005','OH0','478.63',NULL,0,'2013-12-25 23:09:07'),(13258,10581,'Y','18','021','EC','A','','','AC','0001115546','0001115546','TX00001111317','IL','1','Pipkin','Rick','','','','34','413928269','9102 BARTON CREEK DR',0,'ROWLETT','TX','75089','2637','CY','48397','1952-10-23','M','M',':RET:2106-3','N','021','DEN','2516707','33348TX002000201','2014-01-01','2013-12-23 11:44:05','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:56:36'),(9340,7403,'N','01','021','EC','A',NULL,NULL,'','0001553025','0001282447','','IL','1','ELLSWORTH','SHEILA','','','','34','436173650','1644 SHADOW LAKE CT',0,'HARVEY','LA','70058','6606','CY','22051','1959-06-13','F','',':RET:2054-5','N','021','DEN','1602660','18575LA002000201','2014-01-01','2013-12-20 20:17:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:30:58'),(7540,5966,'Y','18','021','EC','A','','','AC','0000890924','0000890924','TX00000073812','IL','1','Hollingsworth','Stacy','','','','34','557470516','3709 WILLIAMS TRACE DR',0,'BRYAN','TX','77808','2251','CY','48041','1977-01-04','F','U',':RET:2106-3','N','021','DEN','1234997','33348TX002000201','2014-01-01','2013-12-15 13:43:20','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-26 02:32:52'),(21020,16797,'Y','18','021','EC','A','','','AC','0000105407','0000105407','OH00002573661','IL','1','benjamin','brian','','','','34','279701760','601 N SANDUSKY ST',0,'MOUNT VERNON','OH','43050','2075','CY','39083','1969-05-16','M','U',':RET:2106-3','N','021','DEN','3109912','99734OH005000401','2014-03-01','2014-02-01 14:49:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:39'),(22528,17986,'Y','18','024','14','A','','','TE','0000037041','0000037041','','IL','1','CROYLE','SANDRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-24','F','',NULL,NULL,NULL,'','3329268','','2014-02-10','2014-02-10 09:53:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:30'),(17484,13979,'Y','18','021','EC','A','','','AC','0000157825','0000157825','TX00001616402','IL','1','Hoy','Danyeil','','','','34','350809223','21738 Colter Stone Dr.',0,'Spring','TX','77388',NULL,'CY','48201','1988-05-02','F','U',':RET:2054-5','N','021','DEN','2335595','33348TX002000201','2014-02-01','2014-01-12 14:10:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 03:01:15'),(16823,13456,'Y','18','021','EC','A','','','AC','0001300829','0001300829','LA00002562915','IL','1','Adams','Gloria','','','','34','520279897','21251 VINCENT ACRES CIR',0,'DENHAM SPRINGS','LA','70726','7626','CY','22063','1983-05-10','F','U',NULL,'N','021','DEN','1627750','18575LA002000201','2014-02-01','2014-01-11 11:49:14','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:18:24'),(13518,10776,'Y','18','021','EC','A','','','AC','0002255074','0002255074','LA00001120414','IL','1','Hyde','David','Michael','','','34','438800005','504 S Cherry St',0,'Hammond','LA','70403',NULL,'CY','22105','1954-09-21','M','U',':RET:2106-3','N','021','DEN','1864314','18575LA002000201','2014-01-01','2013-12-23 07:57:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:03:08'),(15328,12260,'Y','18','021','EC','A','','','AC','0000484322','0000484322','TX00002016433','IL','1','Vigil','Raul','','','','34','463253470','8704 MARBLE DR',0,'EL PASO','TX','79904','1710','CY','48141','1956-11-07','M','M',':RET:2106-3','N','021','DEN','2431316','33348TX002000201','2014-02-01','2014-01-01 13:58:32','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2014-01-02 04:23:49'),(14581,11636,'Y','18','021','EC','A','','','AC','0001760471','0001760471','LA00001651612','IL','1','Day','Erica','','','','34','418375979','401 Metairie Rd',0,'Metairie','LA','70005',NULL,'CY','22051','1987-02-18','F','U',NULL,'N','021','DEN','1653973','18575LA002000101','2014-02-01','2013-12-27 17:03:22','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-28 03:35:51'),(14269,11383,'Y','18','021','EC','A','','','AC','0000672605','0000672605','MS00001614920','IL','1','Short','Linda','','','','34','261633948','4849 ROSEHAVEN DR',0,'JACKSON','MS','39209','3750','CY','28049','1967-01-09','F','U',':RET:2054-5','N','021','DEN','1383489','46300MS002000201','2014-02-01','2013-12-26 08:52:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:01'),(4368,3470,'Y','18','021','EC','A','','','AC','0000759689','0000759689','OH00000317107','IL','1','MATZA','MURRAY','L','','','34','286620794','1500 EAST 193RD STREET',0,'EUCLID','OH','44117',NULL,'CY','39035','1958-08-30','M','U',NULL,'N','021','DEN','546900','99734OH005000401','2014-01-01','2013-12-11 19:43:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:14'),(5307,4207,'Y','18','021','EC','A','','','AC','0000483374','0000483374','MS00000308555','IL','1','Hoop','Darryl','','','','34','427375411','216 HOLLY ST',0,'COFFEEVILLE','MS','38922','9417','CY','28043','1965-09-26','M','U',':RET:2106-3','N','021','DEN','1436413','46300MS002000101','2014-01-01','2013-12-19 06:41:30','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 23:06:28'),(20318,16221,'Y','18','021','EC','A','','','AC','0000791290','0000791290','TX00001889019','IL','1','Malone','Erin','','','','34','635071150','5115 N MESA ST',0,'EL PASO','TX','79912','5858','CY','48141','1983-08-06','F','U',NULL,'N','021','DEN','2903061','33348TX002000201','2014-03-01','2014-01-28 13:55:28','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-28 21:00:54'),(19654,15660,'Y','18','021','EC','A','','','AC','0001049409','0001049409','OH00002366867','IL','1','Keyser','Janet','','','','34','286585986','317 S CENTER ST',0,'VERSAILLES','OH','45380','1104','CY','39037','1957-08-11','F','U',':RET:2106-3','N','021','DEN','3226647','99734OH005000401','2014-03-01','2014-01-23 12:26:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-23 21:00:20'),(18914,15072,'Y','18','021','EC','A','','','AC','0001094663','0001094663','OH00001515164','IL','1','TOPP','RACHEL','E','','','34','296722376','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1970-10-09','F','M',':RET:2106-3','N','021','HLT','2100812','92036OH005001506','2014-02-01','2014-01-15 19:29:07','612.00',NULL,NULL,'730.03','118.03','R-OH002','OH0','298.65',NULL,0,'2014-01-17 03:36:41'),(16350,13086,'N','01','021','EC','A',NULL,NULL,'','0000317355','0000079930','','IL','1','Thacker','LaVonda','Kaye','','','34','402113348','3210 MAIN ST',0,'MINERAL RIDGE','OH','44440','9745','CY','39155','1962-12-25','F','',':RET:2106-3','N','021','DEN','2553573','99734OH005000301','2014-02-01','2014-01-06 07:22:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:28'),(4057,3240,'N','01','021','EC','A',NULL,NULL,'','0000205772','0000749508','','IL','1','MCKINNON','GRETA','D','','','34','277600716','1600 BLAIR AVE NW',0,'WARREN','OH','44483','3308','CY','39155','1955-06-23','F','',NULL,'N','021','DEN','2120738','99734OH005000401','2014-01-01','2013-12-17 15:14:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:46:34'),(7998,6330,'Y','18','021','EC','A','','','AC','0000768872','0000768872','OH00001279139','IL','1','Chasteen','Linda','Jean','','','34','395667722','7340 PAWNEE RD',0,'SPENCER','OH','44275','9764','CY','39103','1961-09-22','F','U',':RET:2106-3','N','021','HLT','2490235','52664OH151001304','2014-01-01','2013-12-20 16:31:35','362.00',NULL,NULL,'718.53','356.53','R-OH012','OH0','435.31',NULL,0,'2013-12-26 03:08:19'),(6315,5009,'N','19','021','EC','A',NULL,NULL,'','0000648299','0000043210','','IL','1','Setser','Olivia','Chayse','','','34','289089601','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','2003-11-11','F','',':RET:2106-3','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:17'),(3390,2719,'Y','18','021','EC','A','','','AC','0001891933','0001891933','LA00001073739','IL','1','Fluitt','Janice','','','','34','438860626','1608 Hwy1204',0,'Pineville','LA','71360',NULL,'CY','22079','1952-04-25','F','M',':RET:2106-3','N','021','DEN','1633289','18575LA002000201','2014-01-01','2013-12-21 20:05:20','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 21:17:48'),(5229,4152,'Y','18','021','EC','A','','','AC','0000314691','0000314691','OH00000525280','IL','1','Props','Nancy','','','','34','298484460','5478 S MAIN ST',0,'AKRON','OH','44319','4939','CY','39153','1950-02-22','F','M',':RET:2106-3','N','021','HLT','2525524','52664OH151001304','2014-01-01','2013-12-18 19:06:53','373.00',NULL,NULL,'658.32','285.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 23:04:44'),(20268,16173,'Y','18','024','14','A','','','TE','0000310851','0000310851','','IL','1','Williams','Brice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-12-16','M','',NULL,NULL,NULL,'','2261328','','2014-01-28','2014-01-28 16:15:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:22'),(21603,17250,'Y','18','021','EC','A','','','AC','0000870665','0000870665','OH00002450282','IL','1','Bardo','Paris','','','','34','285869005','20201 lorain rd',0,'Fairview park','OH','44126',NULL,'CY','39035','1987-07-21','M','U',':RET:2106-3','N','021','DEN','3632095','99734OH005000301','2014-03-01','2014-02-05 12:37:26','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:32'),(23029,18360,'Y','18','021','EC','A','','','AC','0000986131','0000986131','TX00002179034','IL','1','WILLIAMS','CLARA','M','','','34','449234941','818 JEWETT ST',0,'NAVASOTA','TX','77868','2068','CY','48185','1959-12-23','F','U',NULL,'N','021','DEN','3614381','33348TX002000201','2014-03-01','2014-02-12 11:03:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-12 21:30:33'),(28477,22532,'Y','18','021','EC','A','','','AC','0001066053','0001066053','OH00002904350','IL','1','ABDULLAH','DAWUD','','','','34','268642922','7030 LOCKWOOD BLVD',0,'BOARDMAN','OH','44512',NULL,'CY','39099','1959-07-01','M','U',':RET:2054-5','N','021','DEN','3597951','99734OH005000301','2014-04-01','2014-03-07 10:30:18','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-03-07 21:31:34'),(17043,13637,'Y','18','021','EC','A','','','AC','0000891827','0000891827','OH00002168651','IL','1','Davidson','Andrew','','','','34','280904146','78 LUCY CRK',0,'AMELIA','OH','45102','1570','CY','39025','1989-03-09','M','U',':RET:2106-3','N','021','HLT','1789020','92036OH004000601','2014-02-01','2014-01-09 14:55:49','106.00',NULL,NULL,'172.61','66.61','R-OH005','OH0','172.61',NULL,0,'2014-01-13 02:20:52'),(16871,13499,'Y','18','021','EC','A','','','AC','0001088508','0001088508','TX00002251414','IL','1','mcfatridge','tanya','','','','34','467555682','1101 N 2ND ST',0,'CRANFILLS GAP','TX','76637','4068','CY','48035','1975-04-12','F','M',':RET:2106-3','N','021','DEN','2404457','33348TX002000201','2014-02-01','2014-01-09 16:39:28','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:15'),(6781,5379,'Y','18','021','EC','A','','','AC','0001095229','0001095229','TX00000245265','IL','1','GONZALEZ','HORACIO','','','','34','459475945','1901 CARLA ST',0,'ZAPATA','TX','78076','3237','CY','48505','1965-04-02','M','M',NULL,'T','021','DEN','441966','33348TX002000201','2014-01-01','2013-11-25 17:31:41','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:16:52'),(21389,17092,'N','19','021','EC','A',NULL,NULL,'','0000552661','0000026652','','IL','1','Mason','Averi','','','','34','290946565','3800 MILNER RD',0,'NEWARK','OH','43055','9304','CY','39089','1992-01-28','F','',':RET:2106-3','N','021','DEN','3762814','99734OH005000401','2014-03-01','2014-02-04 09:27:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:56'),(24673,19582,'Y','18','021','EC','A','','','AC','0001025549','0001025549','OH00002678294','IL','1','Parker','Robert','','','','34','289829447','518 E SANDUSKY ST',0,'FINDLAY','OH','45840','5920','CY','39063','1984-12-11','M','U',':RET:2106-3','T','021','HLT','3033150','92036OH004001501','2014-04-01','2014-02-18 20:44:05','153.00',NULL,NULL,'227.73','74.73','R-OH002','OH0','227.73',NULL,0,'2014-02-20 04:27:35'),(26239,20810,'Y','18','024','14','A','','','TE','0000874354','0000874354','','IL','1','Ringo','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-20','F','',NULL,NULL,NULL,'','2651023','','2014-02-27','2014-02-27 10:07:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:04'),(29078,23014,'Y','18','021','EC','A','','','AC','0001205930','0001205930','MS00003525866','IL','1','WARD','LINDA','L','','','34','426111555','594 SHAW SKENE ROAD',0,'BOYLE','MS','38730',NULL,'CY','28011','1968-09-12','F','U',':RET:2054-5','N','021','DEN','3695082','46300MS002000101','2014-04-01','2014-03-10 11:55:08','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-10 21:02:01'),(29125,23057,'Y','18','024','14','A','','','TE','0000763567','0000763567','','IL','1','Russell','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-10-21','M','',NULL,NULL,NULL,'','2897387','','2014-03-31','2014-03-10 10:35:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:02:33'),(480,392,'Y','18','021','EC','A','','','AC','0000222357','0000222357','LA00001000568','IL','1','Weiss','Paul','','','','34','206487038','190 LEVET LN',0,'FRANKLIN','LA','70538','6403','CY','22101','1961-06-08','M','U',':RET:2106-3','N','021','DEN','1198166','18575LA002000201','2014-01-01','2013-12-03 22:24:13','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 17:48:08'),(20672,16520,'Y','18','021','EC','A','','','AC','0000636971','0000636971','MS00002275248','31','1','Pough','Zeder','','','','34','073441712','PO Box 617',0,'Waynesboro','MS','39367',NULL,'CY','28153','1952-12-07','F','M',':RET:2054-5','N','021','DEN','1909758','46300MS002000201','2014-03-01','2014-01-30 17:37:13','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-30 21:00:50'),(587,482,'Y','18','021','EC','A','','','AC','0000757106','0000757106','OH00000865423','IL','1','Roush','Pamela','','','','34','292565045','6726 S TOWNSHIP ROAD 1067',0,'TIFFIN','OH','44883','9364','CY','39147','1952-09-17','F','U',':RET:2106-3','N','021','HLT','16212','92036OH003002701','2014-01-01','2013-12-04 17:16:05','370.00',NULL,NULL,'572.23','202.23','R-OH006','OH0','572.23',NULL,0,'2013-12-25 17:51:05'),(1790,1472,'N','19','021','EC','A',NULL,NULL,'','0000627876','0001042300','','IL','1','Landfair','Anthony','J','','','34','576975248','4173 FOREST RIDGE BLVD',0,'DAYTON','OH','45424','4836','CY','39113','2003-09-22','M','',NULL,'N','021','DEN','2280430','99734OH005000301','2014-01-01','2013-12-24 16:43:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:34'),(20380,16280,'Y','18','021','EC','A','','','AC','0000641461','0000641461','TX00001745235','IL','1','Carabajal','Fernando','','','','34','639241741','7404 PUSCH RIDGE LOOP',0,'AUSTIN','TX','78749','2459','CY','48453','1985-02-28','M','U',':RET:2106-3','N','021','DEN','3099128','33348TX002000201','2014-03-01','2014-01-28 20:51:54','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-29 21:00:10'),(16941,13559,'Y','18','021','EC','A','','','AC','0002318740','0002318740','LA00002519161','IL','1','Brown','Wanda','','','','34','434883138','2825 Anita Circle',0,'Baton Rouge','LA','70805',NULL,'CY','22033','1952-02-14','F','U',':RET:2054-5','N','021','DEN','1755516','18575LA002000201','2014-02-01','2014-01-09 11:52:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:19:54'),(6004,4754,'Y','18','021','EC','A','','','AC','0000044232','0000044232','OH00001096966','IL','1','Helms','Ryan','','','','34','287829206','1003 KENNEDYS LNDG',0,'CINCINNATI','OH','45245','5121','CY','39025','1981-08-13','M','R',':RET:2106-3','N','021','DEN','463831','99734OH005000301','2014-01-01','2013-12-01 10:29:15','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:00:27'),(23176,18478,'Y','18','021','EC','A','','','AC','0000267570','0000267570','OH00002603506','IL','1','SPENCER','JESSE','','','','34','279881547','6501 FOUST RD',0,'COLUMBUS GROVE','OH','45830','9497','CY','39003','1981-06-05','F','M',NULL,'N','021','HLT','3184442','92036OH004001501','2014-03-01','2014-02-12 14:11:10','304.00',NULL,NULL,'418.70','114.70','R-OH002','OH0','209.35',NULL,0,'2014-02-12 21:31:55'),(25088,19897,'Y','18','021','EC','A','','','AC','0001459180','0001459180','LA00003135685','IL','1','Lopez','Comcepcion','','','','34','548917705','4462 PLUM GROVE RD',0,'PIONEER','LA','71266','7622','CY','22123','1963-12-08','M','M',NULL,'N','021','DEN','3683502','18575LA002000101','2014-04-01','2014-02-21 10:25:06','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02','CIC',0,'2014-02-21 21:30:04'),(20567,16437,'Y','18','021','EC','A','','','AC','0000192761','0000192761','OH00002557195','IL','1','Ferrell','Tesia','','','','34','301844922','632 COLLEGE ST',0,'FINDLAY','OH','45840','2612','CY','39063','1987-01-03','F','U',NULL,'N','021','HLT','2889341','92036OH004001501','2014-03-01','2014-01-29 14:42:37','30.00',NULL,NULL,'185.46','155.46','R-OH002','OH0','185.46',NULL,0,'2014-01-29 21:01:50'),(20032,15976,'Y','18','021','EC','A','','','AC','0000103912','0000103912','OH00001504524','IL','1','Sherman','Michael','','','','34','283504223','339 WATERLOO ST',0,'MARION','OH','43302','4769','CY','39101','1953-09-14','M','M',':RET:2106-3','N','021','DEN','3363721','99734OH005000301','2014-03-01','2014-01-25 21:21:30','0.00',NULL,NULL,'42.26','42.26','R-OH008','OH0','0.00',NULL,0,'2014-01-26 19:00:21'),(13747,10973,'Y','18','021','EC','A','','','AC','0001055314','0001055314','OH00001090425','IL','1','Burk','Deborah','','','','34','292429678','409 S WENTZ ST',0,'WAPAKONETA','OH','45895','2469','CY','39011','1958-08-16','F','U',NULL,'T','021','HLT','2099931','92036OH004001501','2014-01-01','2013-12-22 19:08:54','216.00',NULL,NULL,'453.83','237.83','R-OH002','OH0','453.83',NULL,0,'2013-12-26 13:09:51'),(2104,1725,'Y','18','021','EC','A','','','AC','0000783205','0000783205','OH00000698464','IL','1','Bechler','Haley','','','','34','290926969','44 SHERMAN ST',0,'DAYTON','OH','45403','2532','CY','39113','1987-04-09','F','R',':RET:2106-3','N','021','DEN','10258','99734OH005000401','2014-01-01','2013-12-09 22:42:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:15'),(9353,7413,'Y','18','021','EC','A','','','AC','0001375428','0001375428','LA00000796850','IL','1','Mendez','Kimberly','','','','34','429410543','2114 Ambassador Caffery Pkwy',0,'Lafayette','LA','70506',NULL,'CY','22055','1969-09-21','F','U',':RET:2106-3','T','021','DEN','2414921','18575LA002000201','2014-01-01','2013-12-20 23:49:25','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 04:31:17'),(6108,4842,'Y','18','024','14','A','','','TE','0000761073','0000761073','','IL','1','Stivaletti','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-04-20','M','',NULL,NULL,NULL,'','1048926','','2013-11-21','2013-11-21 14:22:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:15:22'),(5923,4690,'N','01','021','EC','A',NULL,NULL,'','0000889695','0000295994','','IL','1','Doberson','Juvy','Conchas','','','34','636042361','2655 SKYVIEW RIDGE CT',0,'HOUSTON','TX','77047','6518','CY','48201','1983-02-22','F','',':RET:2036-2','N','021','DEN','2294967','33348TX002000101','2014-01-01','2013-12-24 00:54:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:20'),(23586,18791,'Y','18','021','EC','A','','','AC','0000389882','0000389882','OH00002785036','IL','1','Schanz','Peter','','','','34','292845796','798 N SUMMIT ST',0,'BARBERTON','OH','44203','1523','CY','39153','1970-08-30','M','M',':RET:2106-3','N','021','HLT','3127425','52664OH152000901','2014-03-01','2014-02-13 11:50:42','451.00',NULL,NULL,'707.75','256.75','R-OH012','OH0','221.65',NULL,0,'2014-02-13 22:03:00'),(24032,19113,'N','19','021','EC','A',NULL,NULL,'','0001467814','0002056819','','IL','1','dotson','Aiden',NULL,NULL,NULL,NULL,NULL,'22825 citation dr',0,'denham springs','LA','43553',NULL,'CY','39051','2013-01-24','M','',':RET:2054-5','N','021','HLT','3243067','92036OH004002601','2014-03-01','2014-02-14 19:49:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','99.57',NULL,0,'2014-02-15 22:00:53'),(28015,22169,'Y','18','021','EC','A','','','AC','0001040909','0001040909','OH00003310807','IL','1','WINANS','AMY','','','','34','298869042','2950 GRATZ RIDGE RD',0,'GROVE CITY','OH','43123','3780','CY','39049','1986-06-16','F','U',':RET:2106-3','N','021','DEN','3190433','99734OH005000401','2014-04-01','2014-03-06 12:20:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:17'),(20463,16347,'Y','18','021','EC','A','','','AC','0000613030','0000613030','OH00001959177','IL','1','SHOOKS','EVA','S','','','34','276567899','585 SEVILLE RD',0,'WADSWORTH','OH','44281','1030','CY','39103','1953-06-02','F','M',NULL,'N','021','DEN','2318838','99734OH005000401','2014-03-01','2014-01-29 10:48:19','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-29 21:00:52'),(739,612,'Y','18','021','EC','A','','','AC','0000370652','0000370652','TX00000694770','IL','1','Aragon','Maria','','','','34','466351973','208 Cherry',0,'El Paso','TX','79915',NULL,'CY','48141','1961-10-19','F','U',':RET:2106-3','N','021','DEN','1169950','33348TX002000201','2014-01-01','2013-12-15 21:52:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:03:59'),(14833,11846,'N','01','021','EC','A',NULL,NULL,'','0000789665','0000679534','','IL','1','polk','renelda','ann','','','34','276529500','500 GLENWOOD AVE',0,'CINCINNATI','OH','45229','2016','CY','39061','1954-06-17','F','',':RET:2054-5','N','021','DEN','2279259','99734OH005000301','2014-01-01','2013-12-23 20:17:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:14:38'),(15518,12415,'Y','18','021','EC','A','','','AC','0001340414','0001340414','LA00001100350','31','1','SIMMONS','DEBRA','','','','34','437961396','PO BOX 829',0,'MANSURA','LA','71350',NULL,'CY','22009','1954-11-25','F','U',':RET:2054-5','N','021','DEN','2451885','18575LA002000201','2014-02-01','2013-12-30 19:14:10','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,1,'2014-01-02 04:30:14'),(9140,7248,'Y','18','021','EC','A','','','AC','0000078752','0000078752','OH00000498602','IL','1','COMPTON','SARAH','','','','34','401256529','10656 TURFWOOD CT',0,'CINCINNATI','OH','45241','2945','CY','39061','1983-12-21','F','R',NULL,'N','021','HLT','2326594','92036OH001001201','2014-01-01','2013-12-17 20:37:49','0.00',NULL,NULL,'293.90','293.90','R-OH004','OH0','293.90',NULL,0,'2013-12-26 04:08:09'),(14181,11306,'Y','18','021','EC','A','','','AC','0000282813','0000282813','TX00001359518','IL','1','TAYLOR','WENDY','','','','34','452676268','400 PARR AVE',0,'SPICEWOOD','TX','78669','8408','CY','48053','1968-05-20','F','U',':RET:2106-3','N','021','DEN','1834074','33348TX002000201','2014-02-01','2013-12-26 10:22:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:42'),(2417,1972,'Y','18','021','EC','A','','','AC','0000377441','0000377441','OH00001028495','IL','1','Porter','Angela','','','','34','279580155','1041 CLOVERLY DR',0,'GAHANNA','OH','43230','6219','CY','39049','1957-04-12','F','M',':RET:2054-5','N','021','DEN','869595','99734OH005000401','2014-01-01','2013-12-09 15:55:32','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:52'),(3256,2623,'N','01','021','EC','A',NULL,NULL,'','0000148293','0000536880','','IL','1','Scott','Debra','L','','','34','560551520','24 2ND AVE',0,'BEREA','OH','44017','1244','CY','39035','1963-08-21','F','',':RET:2054-5','N','021','DEN','197683','99734OH005000301','2014-01-01','2013-11-27 20:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:46:43'),(4439,3529,'Y','18','021','EC','A','','','AC','0000399863','0000399863','OH00000942047','IL','1','Buczkowski','Krystyna','','','','34','280923017','22627 MEADOWHILL LN',0,'ROCKY RIVER','OH','44116','2035','CY','39035','1969-07-18','F','M',NULL,'N','021','DEN','624644','99734OH005000301','2014-01-01','2013-12-11 18:57:13','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:07'),(13283,10602,'Y','18','021','EC','A','','','AC','0000945460','0000945460','TX00000528966','IL','1','Viera','Richard','','','','34','452499995','240 JENSEN AVE',0,'EL PASO','TX','79915','3808','CY','48141','1965-03-27','M','U',':RET:2106-3','N','021','DEN','1853631','33348TX002000201','2014-01-01','2013-12-23 13:06:37','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 12:57:15'),(5636,4471,'Y','18','021','EC','A','','','AC','0000622464','0000622464','TX00001034623','IL','1','turner','joseph','','','','34','445820312','1211 north 8th',0,'wichita falls','TX','76306',NULL,'CY','48485','1983-10-28','M','U',':RET:1002-5^:RET:2029-7','T','021','DEN','1114547','33348TX002000201','2014-01-01','2013-11-25 19:22:21','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 23:31:06'),(9736,7709,'N','01','021','EC','A',NULL,NULL,'','0000950017','0000151554','','IL','1','Tran','Cuong','','','','34','009505639','4536 9TH ST',0,'BACLIFF','TX','77518','2259','CY','48167','1973-11-11','M','',':RET:2028-9','N','021','DEN','929760','33348TX002000201','2014-01-01','2013-11-14 20:43:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:45:47'),(6676,5295,'Y','18','021','EC','A','','','AC','0000856392','0000856392','LA00000214557','IL','1','Kellgren','Kyle','','','','34','439815579','37319 BLACK OAK DR',0,'PRAIRIEVILLE','LA','70769','3722','CY','22005','1986-08-01','M','U',':RET:2106-3','N','021','DEN','626517','18575LA002000201','2014-01-01','2013-11-16 11:51:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:01:15'),(7322,5802,'N','19','021','EC','A',NULL,NULL,'','0000566077','0000405395','','IL','1','dobbs','eli','carson','','','34','412759459','648 lakewood cove',0,'brandon','MS','39042',NULL,'CY','28121','1994-02-24','M','',':RET:2106-3','N','021','DEN','754977','46300MS002000201','2014-01-01','2013-12-14 10:58:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2013-12-26 02:03:38'),(21761,17377,'Y','18','021','EC','A','','','AC','0000824348','0000824348','TX00002431662','IL','1','CREECH','DANE','','','','34','616221648','2013 COUNTY ROAD 279',0,'DUBLIN','TX','76446','4997','CY','48143','1979-01-11','M','U',':RET:2106-3','N','021','DEN','3553436','33348TX002000201','2014-03-01','2014-02-06 14:53:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:26'),(25100,19908,'N','19','021','EC','A',NULL,NULL,'','0000746968','0000320652','','IL','1','ZAVALA','CLAUDIA','MARCELA','','','34','643341815','8379 TAMIAMI TRAIL',0,'FORTWORTH','TX','76137',NULL,'CY','48439','1993-02-18','F','',NULL,'N','021','DEN','2820623','33348TX002000101','2014-04-01','2014-02-21 10:51:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-21 21:30:10'),(28244,22348,'Y','18','024','14','A','','','TE','0000947441','0000947441','','IL','1','GARZA','EMILY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-04-26','F','',NULL,NULL,NULL,'','2678422','','2014-03-07','2014-03-07 12:47:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:11'),(28797,22795,'Y','18','021','EC','A','','','AC','0001055377','0001055377','OH00003293488','IL','1','Wright','Kellee','','','','34','288829205','1845 Beech Rd',0,'Stow','OH','44224',NULL,'CY','39153','1971-03-17','F','M',':RET:2106-3','N','021','DEN','4088055','99734OH005000301','2014-04-01','2014-03-09 09:45:47','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-03-09 21:00:46'),(21233,16967,'Y','18','021','EC','A','','','AC','0001196854','0001196854','OH00001801142','IL','1','Greek','Matt','','','','34','283860985','866 SHERWOOD DR',0,'ELYRIA','OH','44035','3016','CY','39093','1974-06-26','M','U',':RET:2106-3','N','021','DEN','3264198','99734OH005000301','2014-03-01','2014-02-03 12:38:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:01:10'),(7693,6092,'Y','18','021','EC','A','','','AC','0001143311','0001143311','OH00001256895','IL','1','Kou','Yu Ching','','','','34','282845357','10812 WILLFLEET DR',0,'CINCINNATI','OH','45241','2831','CY','39061','1953-12-16','F','M',':RET:2034-7','N','021','DEN','1726367','99734OH005000401','2014-01-01','2013-12-19 22:28:42','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:01:06'),(1649,1378,'Y','18','021','EC','A','','','AC','0000260474','0000260474','TX00001111478','IL','1','Rogers','Roderick','','','','34','413064171','19518 COUNTRY BREEZE CT',0,'SPRING','TX','77388','2544','CY','48201','1966-04-15','M','M',':RET:2054-5','N','021','DEN','1456827','33348TX002000201','2014-01-01','2013-12-24 16:07:55','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:53:18'),(2519,2054,'Y','18','021','EC','A','','','AC','0000012410','0000012410','OH00000260634','IL','1','LASLO','VICKI','','','','34','279501572','18592 EDWARDS RD LOT 107',0,'DOYLESTOWN','OH','44230',NULL,'CY','39169','1950-08-14','F','M',':RET:2106-3','N','021','HLT','1012665','52664OH152000901','2014-01-01','2013-12-09 12:43:00','482.18',NULL,NULL,'482.18','0.00','R-OH014','OH0','482.18',NULL,0,'2013-12-25 19:36:32'),(18813,14984,'N','01','021','EC','A',NULL,NULL,'','0001113165','0001228076','','IL','1','WILSON','BONNIE','','','','34','285567803','1693 LICK RUN RD',0,'CHILLICOTHE','OH','45601','9098','CY','39141','1954-12-08','F','',':RET:2106-3','N','021','DEN','1427755','99734OH005000401','2014-02-01','2014-01-15 19:09:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:36:03'),(18340,14645,'N','17','021','EC','A',NULL,NULL,'','0000514473','0000505756','','IL','1','Maffo','Maxwell','','','','34','294944499','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1992-07-12','M','',':RET:2106-3','N','021','DEN','2732603','99734OH005000401','2014-02-01','2014-01-15 17:50:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:17'),(5797,4605,'Y','18','021','EC','A','','','AC','0000209634','0000209634','OH00000754547','IL','1','Lange','Nancy','','','','34','283486985','2715 Silver Springs Dr',0,'Norton','OH','44203',NULL,'CY','39153','1950-02-02','F','U',':RET:2106-3','N','021','DEN','1936448','99734OH005000401','2014-01-01','2013-12-24 01:45:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:47:24'),(6682,5299,'N','01','021','EC','A',NULL,NULL,'','0000520916','0000772605','','IL','1','Fisher','Keith','','','','34','288529803','524 GLENMONT AVE',0,'COLUMBUS','OH','43214','3260','CY','39049','1968-06-27','M','',':RET:2106-3','N','021','DEN','262546','99734OH005000401','2014-01-01','2013-11-04 21:10:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:25'),(22915,18266,'Y','18','021','EC','A','','','AC','0000438013','0000438013','OH00002515077','IL','1','NAVARRE','MARSHA','','','','34','299542274','1763 FALLBROOK RD',0,'TOLEDO','OH','43614','3251','CY','39095','1957-11-09','F','M',':RET:2106-3','T','021','HLT','3172765','92036OH006002601','2014-03-01','2014-02-11 15:45:45','82.00',NULL,NULL,'414.89','332.89','R-OH001','OH0','414.89',NULL,0,'2014-02-11 21:02:51'),(27,22,'Y','18','021','EC','A','','','AC','0001160385','0001160385','OH00001025451','IL','1','Yuschak-Smith','Karla','','','','34','299443408','549 MARGUERITE AVE',0,'CUYAHOGA FALLS','OH','44221','1811','CY','39153','1949-08-12','F','U',':RET:2106-3','N','021','DEN','384325','99734OH005000401','2014-01-01','2013-12-05 11:44:49','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:41'),(20347,16248,'Y','18','024','14','A','','','TE','0000642095','0000642095','','IL','1','Gravett','Kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-30','M','',NULL,NULL,NULL,'','2034899','','2014-01-28','2014-01-28 11:24:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:12'),(17737,14173,'Y','18','021','EC','A','','','AC','0000084065','0000084065','OH00002583116','IL','1','Hein','Janice','','','','34','279568013','21600 TRACY AVE',0,'EUCLID','OH','44123','2967','CY','39035','1954-04-13','F','U',NULL,'T','021','HLT','1645184','52664OH151001306','2014-02-01','2014-01-13 12:22:14','459.00',NULL,NULL,'752.91','293.91','R-OH011','OH0','752.91',NULL,0,'2014-01-14 01:33:22'),(3360,2693,'Y','18','021','EC','A','','','AC','0000604202','0000604202','TX00001203242','IL','1','Reeise','Kenneth','','','','34','512946799','3533 BARCLAY DR',0,'AMARILLO','TX','79109','4009','CY','48381','1983-03-30','M','M',':RET:2106-3','N','021','DEN','1413912','33348TX002000201','2014-01-01','2013-12-22 13:22:48','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 21:16:57'),(3803,3049,'Y','18','021','EC','A','','','AC','0000490455','0000490455','OH00000385248','IL','1','Kenyon','Daniel','','','','34','302905882','24 SHADY LANE DR',0,'NORWALK','OH','44857','2372','CY','39077','1984-12-24','M','M',':RET:2106-3','N','021','DEN','396507','99734OH005000301','2014-01-01','2013-12-13 13:18:48','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:34:35'),(5406,4292,'Y','18','021','EC','A','','','AC','0000493200','0000493200','OH00000312478','IL','1','Flaherty','Gregory','','','','34','280486783','6211 Watchcreek Way Unit 103',0,'Milford','OH','45150',NULL,'CY','39025','1951-07-20','M','U',NULL,'N','021','HLT','1478593','92036OH003000605','2014-01-01','2013-12-18 22:02:59','441.00',NULL,NULL,'644.07','203.07','R-OH005','OH0','644.07',NULL,0,'2013-12-25 23:09:04'),(5236,4154,'Y','18','021','EC','A','','','AC','0000758253','0000758253','OH00001145852','31','1','JONES','BONNIE','','','','34','268663081','P.O BOX 950',0,'RAVENNA','OH','44266',NULL,'CY','39133','1960-03-24','F','M',NULL,'N','021','HLT','2571753','52664OH151001305','2014-01-01','2013-12-18 19:58:24','751.00',NULL,NULL,'952.25','201.25','R-OH012','OH0','454.94',NULL,0,'2013-12-25 23:04:50'),(23953,19046,'N','01','021','EC','A',NULL,NULL,'','0001172752','0000099991','','IL','1','Woodruff','Christina','','','','34','630129033','13772 BIG OAK BAY RD',0,'TYLER','TX','75707','7214','CY','48423','1986-09-24','F','',':RET:2106-3','N','021','DEN','3361632','33348TX002000101','2014-03-01','2014-02-15 10:36:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-15 22:00:05'),(25701,20389,'N','01','021','EC','A',NULL,NULL,'','0000409368','0000714958','','IL','1','RODGRIGUEZ','JORGE','ERNESTO','','','34','630043809','2412 DURHAM AVE',0,'BROWNWOOD','TX','76801','4921','CY','48049','1969-12-21','M','',NULL,'N','021','DEN','2644264','33348TX002000201','2014-04-01','2014-02-24 12:09:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:18'),(26187,20767,'N','01','021','EC','A',NULL,NULL,'','0000364946','0000239083','','IL','1','Schafer','Daren',NULL,NULL,NULL,NULL,NULL,'1297 FAGINS RUN RD',0,'NEW RICHMOND','OH','45157','9180','CY','39025','1967-01-09','M','',':RET:2106-3','N','021','DEN','3476347','99734OH005000301','2014-04-01','2014-02-27 11:36:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:43'),(28214,22325,'Y','18','024','14','A','','','TE','0000477434','0000477434','','IL','1','Smith','Terence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-06-11','M','',NULL,NULL,NULL,'','116742','','2014-03-31','2014-03-06 13:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-06 21:30:15'),(28846,22826,'Y','18','021','EC','A','','','AC','0001066055','0001066055','OH00002856090','IL','1','JONES','JEFFREY','JAMES','','','34','288727731','3608 State Rd.',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1962-07-15','M','U',':RET:2106-3','T','021','HLT','4299809','52664OH152000901','2014-04-01','2014-03-09 17:36:27','350.32',NULL,NULL,'350.32','0.00','R-OH012','OH0','350.32',NULL,0,'2014-03-09 21:01:15'),(121,105,'Y','18','021','EC','A','','','AC','0000935169','0000935169','TX00000454430','IL','1','Roemish','Thomas','','','','34','450391971','2208 44TH ST',0,'SNYDER','TX','79549','5927','CY','48415','1962-12-04','M','U',NULL,'N','021','DEN','80334','33348TX002000201','2014-01-01','2013-12-05 15:55:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:18:11'),(17513,14000,'Y','18','024','14','A','','','TE','0000721360','0000721360','','IL','1','Mitchell','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-25','M','',NULL,NULL,NULL,'','2088910','','2014-01-12','2014-01-12 09:33:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:31'),(565,464,'Y','18','021','EC','A','','','AC','0000180978','0000180978','OH00001192784','IL','1','Barton','Laura','','','','34','277724505','5086 Norwich rd',0,'toledo','OH','43615',NULL,'CY','39095','1963-06-24','F','U',':RET:2106-3','N','021','HLT','175935','92036OH006002601','2014-01-01','2013-12-03 23:24:44','0.00',NULL,NULL,'430.83','430.83','R-OH001','OH0','276.19',NULL,0,'2013-12-25 17:50:27'),(1332,1103,'Y','18','021','EC','A','','','AC','0000422776','0000422776','OH00001226377','IL','1','Chandler','John','S','','','34','443548442','4350 SWEENEY LN',0,'HILLSBORO','OH','45133','4303','CY','39071','1949-12-29','M','M',':RET:2106-3','N','021','HLT','595165','92036OH005000601','2014-01-01','2013-10-25 09:21:03','724.00',NULL,NULL,'1102.32','378.32','R-OH005','OH0','644.00',NULL,0,'2013-12-25 18:32:08'),(1992,1631,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','870713','','2013-11-19','2013-11-19 23:06:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:59'),(3284,2647,'N','01','021','EC','A',NULL,NULL,'','0000071639','0000752072','','IL','1','Green','Laura','','','','34','279886655','4531 NATURAL TRL',0,'NEW ALBANY','OH','43054','8859','CY','39049','1977-02-22','F','',':RET:2106-3','N','021','DEN','1390224','99734OH005000301','2014-01-01','2013-12-21 21:51:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:20'),(3290,2653,'Y','18','021','EC','A','','','AC','0000134574','0000134574','OH00000007771','IL','1','woyshville','beth','','','','34','294588375','3255 west 43',0,'cleveland','OH','44109',NULL,'CY','39035','1964-11-02','F','U',NULL,'N','021','DEN','2473970','99734OH005000301','2014-01-01','2013-12-22 07:43:26','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:15:30'),(6653,5277,'Y','18','021','EC','A','','','AC','0000398578','0000398578','OH00000583099','IL','1','Susich','Jeffrey','','','','34','477723934','6865 CLUBSIDE DR',0,'LOVELAND','OH','45140','6041','CY','39025','1956-05-01','M','M',NULL,'N','021','DEN','386653','99734OH005000301','2014-01-01','2013-11-12 13:50:02','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2013-12-26 01:00:38'),(5704,4527,'Y','18','021','EC','A','','','AC','0001091516','0001091516','TX00000506770','IL','1','Lemmond','Victoria','','','','34','632441585','3802 Carazelle Parkway',0,'Corpus Christie','TX','78415',NULL,'CY','48355','1994-08-06','F','U',':RET:2106-3','T','021','DEN','842247','33348TX002000101','2014-01-01','2013-11-26 17:33:49','0.00',NULL,NULL,'44.55','44.55','R-TX007','TX0','44.55',NULL,0,'2013-12-25 23:33:00'),(5631,4466,'N','01','021','EC','A',NULL,NULL,'','0000612960','0000240312','','IL','1','Holloway','Minnie','J','','','34','311841426','5091 ELNO AVE',0,'AKRON','OH','44319','4931','CY','39153','1963-08-30','F','',':RET:2106-3','N','021','DEN','223737','99734OH005000401','2014-01-01','2013-11-26 11:14:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:58'),(6743,5349,'Y','18','021','EC','A','','','AC','0000394894','0000394894','OH00001148031','IL','1','YOST','ROBIN','L','','','34','294766777','182  SOUTH PARDEE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1954-01-14','F','U',':RET:2106-3','T','021','HLT','1158096','52664OH151001304','2014-01-01','2013-11-25 15:46:10','386.00',NULL,NULL,'667.56','281.56','R-OH012','OH0','667.56',NULL,0,'2013-12-26 01:15:50'),(4692,3720,'Y','18','021','EC','A','','','AC','0000281986','0000281986','OH00001233098','IL','1','SIMMONS','JERI','JEANNE','','','34','271587193','2860 VIMARK RD',0,'BELLBROOK','OH','45305','9731','CY','39057','1955-05-25','F','U',':RET:2106-3','N','021','HLT','766795','92036OH005000504','2014-01-01','2013-12-12 09:58:36','245.00',NULL,NULL,'605.66','360.66','R-OH003','OH0','605.66',NULL,0,'2013-12-25 22:08:12'),(20803,16623,'Y','18','021','EC','A','','','AC','0000143259','0000143259','TX00001821599','IL','1','ORTIZ','MARIA','R','','','34','458860636','18721 PENCIL CACTUS DR',0,'PFLUGERVILLE','TX','78660','5354','CY','48453','1951-11-03','F','U',NULL,'N','021','DEN','3386325','33348TX002000201','2014-03-01','2014-01-31 15:41:09','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-31 21:00:23'),(23458,18686,'Y','18','021','EC','A','','','AC','0000787340','0000787340','TX00001438325','IL','1','Redic','Deanna','','','','34','461493031','110 East Hawkins Parkway apt. 1512',0,'Longview','TX','75605',NULL,'CY','48183','1964-10-07','F','U',':RET:2054-5','N','021','DEN','3477064','33348TX002000201','2014-03-01','2014-02-13 14:13:06','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-13 22:01:41'),(24375,19361,'Y','18','021','EC','A','','','AC','0001667650','0001667650','LA00002557650','IL','1','hull','walter','w','','Jr','34','433173406','400 BROADMOOR ST',0,'MONROE','LA','71203','4130','CY','22073','1963-01-11','M','U',':RET:2106-3','T','021','DEN','3242029','18575LA002000201','2014-04-01','2014-02-18 17:55:03','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-18 22:00:40'),(26822,21257,'Y','18','021','EC','A','','','AC','0000558207','0000558207','OH00003215437','IL','1','Zehring','Christine','Ann','','','34','296546439','156 Crown Point Meadows',0,'Dayton','OH','45458',NULL,'CY','39165','1952-10-01','F','U',':RET:2106-3','N','021','DEN','3220406','99734OH005000401','2014-04-01','2014-03-01 12:14:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:35'),(7252,5752,'Y','18','021','EC','A','','','AC','0000684086','0000684086','LA00000722280','IL','1','BAUER','KRISTIN','','','','34','435416044','313 JADE AVE',0,'METAIRIE','LA','70003','6616','CY','22051','1980-06-13','F','U',':RET:2106-3','N','021','DEN','396545','18575LA002000201','2014-01-01','2013-12-14 17:53:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:57'),(4587,3632,'Y','18','021','EC','A','','','AC','0000448752','0000448752','OH00000542472','IL','1','Hall','E','','','','34','299525687','33 KREINER AVE',0,'AKRON','OH','44312','1803','CY','39153','1952-04-13','F','U',':RET:2106-3','N','021','HLT','817139','52664OH151001301','2014-01-01','2013-12-12 10:38:04','293.00',NULL,NULL,'626.65','333.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 22:05:22'),(3613,2893,'N','19','021','EC','A',NULL,NULL,'','0000997747','0000525579','','IL','1','McDermott','Owen','','','','34','279066235','419 Cabot Drive',0,'Akron','OH','44333',NULL,'CY','39153','2001-04-20','M','',':RET:2106-3','N','021','HLT','1423401','52664OH152000901','2014-01-01','2013-12-22 18:15:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:23:30'),(2465,2006,'Y','18','021','EC','A','','','AC','0000842837','0000842837','LA00000977088','IL','1','Sibille','Amanda','','','','34','458872358','5719 HIGHWAY 14 E',0,'IOWA','LA','70647','5205','CY','22019','1981-08-25','F','M',':RET:2106-3','N','021','DEN','678179','18575LA002000101','2014-01-01','2013-12-09 15:00:13','0.00',NULL,NULL,'50.04','50.04','R-LA004','LA0','25.02',NULL,0,'2013-12-25 19:35:04'),(2769,2238,'N','19','021','EC','A',NULL,NULL,'','0000655790','0000661315','','IL','1','Toth','Kayla',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-02-08','F','',':RET:2106-3','N','021','HLT','212152','52664OH151001304','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 19:49:30'),(20796,16616,'Y','18','021','EC','A','','','AC','0000927896','0000927896','TX00001362698','IL','1','Kercado','Edelba','','','','34','583407577','1507 Lynn Drive',0,'Wylie','TX','75098',NULL,'CY','48085','1951-07-03','F','U',NULL,'N','021','DEN','3182966','33348TX002000201','2014-03-01','2014-01-31 11:11:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-31 21:00:18'),(25282,20059,'Y','18','021','EC','A','','','AC','0001081000','0001081000','TX00001940010','IL','1','Salazar','Alicia','','','','34','463332946','14253 SNAFFLE BIT TRL',0,'HASLET','TX','76052','2997','CY','48439','1963-02-19','F','U',':RET:2106-3','N','021','DEN','3146858','33348TX002000201','2014-03-01','2014-02-25 15:32:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-25 21:00:18'),(25957,20587,'Y','18','021','EC','A','','','AC','0000615565','0000615565','OH00003235584','IL','1','SMITH','JANET','JW','','','34','412023145','6530 S O M CENTER ROAD',0,'SOLON','OH','44139',NULL,'CY','39035','1954-04-06','F','M',NULL,'T','021','DEN','2644327','99734OH005000401','2014-05-01','2014-02-26 12:19:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:01:40'),(27392,21686,'N','19','021','EC','A',NULL,NULL,'','0001042351','0001014437','','IL','1','MacNeel','Jack','','','','34','289042675','6424 ASHLEY OAKS CT',0,'WEST CHESTER','OH','45069','5107','CY','39017','1999-11-14','M','',':RET:2106-3','N','021','DEN','3740872','99734OH005000301','2014-04-01','2014-03-03 18:44:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:27'),(7720,6114,'Y','18','021','EC','A','','','AC','0000640917','0000640917','OH00000962432','IL','1','Rowe','Hoang','','','','34','284720024','1551 WILDON AVE',0,'AKRON','OH','44306','3360','CY','39153','1970-05-03','M','M',NULL,'N','021','DEN','2216763','99734OH005000401','2014-01-01','2013-12-20 13:46:50','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:01:44'),(15616,12490,'N','19','021','EC','A',NULL,NULL,'','0000282616','0000537693','','S1','1','Ross','Jackie','','','','34','438917644','103 SUNRISE POINT DR',0,'BRANDON','MS','39047','6523','CY','28121','1995-08-01','M','',NULL,'N','021','DEN','1832816','46300MS002000101','2014-02-01','2013-12-30 21:26:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,1,'2014-01-02 04:32:59'),(1833,1503,'Y','18','021','EC','A','','','AC','0000934671','0000934671','OH00001228697','IL','1','Dortch','Carolynda','','','','34','270503655','704 MERTON AVE',0,'AKRON','OH','44306','1524','CY','39153','1952-08-10','F','U',':RET:2054-5','N','021','HLT','2338675','52664OH151001305','2014-01-01','2013-12-24 10:58:09','481.00',NULL,NULL,'626.65','145.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 18:57:28'),(7409,5863,'Y','18','021','EC','A','','','AC','0000822847','0000822847','TX00000938530','IL','1','Pinkerton','Kyle','','','','34','466089192','703 RALPH NERREN RD',0,'HUNTINGTON','TX','75949','6303','CY','48005','1962-04-03','M','U',':RET:2106-3','T','021','DEN','1133978','33348TX002000201','2014-01-01','2013-10-28 15:36:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:16:40'),(7062,5610,'Y','18','021','EC','A','','','AC','0001223175','0001223175','OH00000761606','IL','1','carnes','jeffrey','','','','34','298785453','9125 St rt 377',0,'chesterhill','OH','43728',NULL,'CY','39115','1967-03-05','M','R',':RET:2054-5','N','021','DEN','2523318','99734OH005000301','2014-01-01','2013-12-24 21:31:50','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:49:58'),(15470,12378,'Y','18','021','EC','A','','','AC','0000484802','0000484802','OH00000671694','IL','1','Garcia','Amy','Elizabeth','','','34','295786720','6740 Murray Ave',0,'Cincinnati','OH','45227',NULL,'CY','39061','1978-02-18','F','U',':RET:2106-3','T','021','DEN','2186152','99734OH005000401','2014-02-01','2013-12-30 18:53:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:28:53'),(5515,4375,'Y','18','021','EC','A','','','AC','0000573031','0000573031','OH00000094873','IL','1','Walsh','Patrick','','','','34','269905659','5278 ADENA TRL',0,'CINCINNATI','OH','45230','5103','CY','39061','1984-12-07','M','R',':RET:2106-3','N','021','DEN','1250228','99734OH005000301','2014-01-01','2013-11-27 12:33:07','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:15:10'),(6702,5313,'Y','18','021','EC','A','','','AC','0000257095','0000257095','OH00001012042','IL','1','Harris','Loretta','','','','34','213822082','1474 CRESTWOOD RD',0,'TOLEDO','OH','43612','2768','CY','39095','1961-10-07','F','U',':RET:2106-3','T','021','HLT','501749','92036OH004002601','2014-01-01','2013-11-04 19:47:13','335.00',NULL,NULL,'351.96','16.96','R-OH001','OH0','351.96',NULL,0,'2013-12-26 01:01:57'),(13915,11099,'Y','18','021','EC','A','','','AC','0001250836','0001250836','OH00000655718','IL','1','Rayman','Roland','','','','34','287425736','2117 Eastbrook Drive',0,'Toledo','OH','43613',NULL,'CY','39095','1955-01-16','M','M',':RET:2106-3','N','021','HLT','1846280','92036OH003002605','2014-01-01','2013-12-22 21:51:45','744.00',NULL,NULL,'972.96','228.96','R-OH001','OH0','518.85',NULL,0,'2013-12-26 13:14:04'),(20703,16543,'Y','18','021','EC','A','','','AC','0002298536','0002298536','LA00002508399','31','1','BICKMAM','THOMAS','D','','','34','434752467','PO BOX 600',0,'ZACHARY','LA','70791',NULL,'CY','22033','1986-02-02','M','U',':RET:2106-3','T','021','DEN','3381427','18575LA002000201','2014-03-01','2014-01-30 11:38:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-30 21:01:05'),(17559,14040,'Y','18','021','EC','A','','','AC','0000511965','0000511965','OH00002299878','IL','1','Beery','Janet','','','','34','297783458','4411 ZURMEHLY RD',0,'LIMA','OH','45806','1030','CY','39003','1979-12-25','F','M',':RET:2106-3','N','021','HLT','1946058','92036OH001001501','2014-02-01','2014-01-12 14:48:51','422.00',NULL,NULL,'683.45','261.45','R-OH002','OH0','322.28',NULL,0,'2014-01-13 03:02:00'),(9106,7229,'Y','18','021','EC','A','','','AC','0001135152','0001135152','OH00000643990','31','1','cremeans','shannon','','','','34','294728273','PO Box 45',0,'Pomeroy','OH','45769',NULL,'CY','39105','1972-09-10','M','M',':RET:2106-3','N','021','DEN','2250070','99734OH005000301','2014-01-01','2013-12-18 15:33:20','0.00',NULL,NULL,'87.78','87.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 04:07:31'),(13989,11144,'N','01','021','EC','A',NULL,NULL,'','0000810787','0001165340','','IL','1','TARRANT','CRESTON','LANELL','','','34','251358365','211 LARCH LN',0,'SWANTON','OH','43558','8698','CY','39051','1967-01-16','M','',':RET:2054-5','N','021','HLT','1873855','92036OH001002601','2014-01-01','2013-12-23 13:01:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','352.81',NULL,0,'2013-12-26 13:15:45'),(1515,1264,'Y','18','021','EC','A','','','AC','0001169451','0001169451','OH00000195591','IL','1','DAVIS','BENJAMIN','','','','34','298883077','364 E WATER ST',0,'PIQUA','OH','45356','2453','CY','39109','1983-09-19','M','U',':RET:2106-3','N','021','DEN','1809523','99734OH005000401','2014-01-01','2013-12-24 14:19:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:49:38'),(3879,3107,'Y','18','021','EC','A','','','AC','0000200237','0000200237','LA00000891206','31','1','THOMAS','LEROY','','','','34','434392369','P.O. BOX 1126',0,'ELTON','LA','70532',NULL,'CY','22053','1965-12-14','M','U',NULL,'N','021','DEN','304952','18575LA002000201','2014-01-01','2013-12-13 13:40:13','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 21:36:23'),(2890,2334,'N','01','021','EC','A',NULL,NULL,'','0000631482','0000780479','','IL','1','carter','arlene','','','','34','268721099','1 park center drive',0,'wadsworth','OH','44281',NULL,'CY','39103','1961-03-10','F','',':RET:2106-3','N','021','HLT','55854','52664OH151001501','2014-01-01','2013-12-06 11:47:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-25 20:15:09'),(2998,2410,'Y','18','021','EC','A','','','AC','0000642050','0000642050','OH00001268616','IL','1','Mihalek','Cynthia','','','','34','292624465','407 E 323RD ST',0,'WILLOWICK','OH','44095','3331','CY','39085','1956-11-15','F','U',':RET:2106-3','N','021','DEN','1197047','99734OH005000301','2014-01-01','2013-12-06 12:03:51','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:17:34'),(5688,4513,'N','01','021','EC','A',NULL,NULL,'','0000630345','0000432716','','IL','1','Adanich','Tracy','','','','34','271742187','27380 COOK RD',0,'OLMSTED FALLS','OH','44138','1097','CY','39035','1978-05-02','F','',':RET:2106-3','N','021','DEN','1165629','99734OH005000301','2014-01-01','2013-11-26 11:36:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:32:31'),(21617,17261,'Y','18','021','EC','A','','','AC','0000230793','0000230793','TX00002262822','IL','1','Belew','Abebe','','','','34','637986262','12349 METRIC BLVD',0,'AUSTIN','TX','78758','2585','CY','48453','1970-09-17','M','M',NULL,'N','021','DEN','3094368','33348TX002000201','2014-03-01','2014-02-04 20:13:59','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-05 21:30:36'),(22511,17971,'Y','18','021','EC','A','','','AC','0001204961','0001204961','TX00001934073','IL','1','Gleason','Gina','','','','34','645034059','1415 CHURCH ST',0,'SULPHUR SPRINGS','TX','75482','2111','CY','48223','1986-02-02','F','U',':RET:2106-3','N','021','DEN','3539007','33348TX002000101','2014-03-01','2014-02-09 19:35:08','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-10 21:31:19'),(23406,18648,'Y','18','021','EC','A','','','AC','0000356073','0000356073','OH00002465481','IL','1','STOCKTON','WILLIAM','KERMIT','','Jr','34','234175296','903 CAROLYN AVE',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1980-01-14','M','U',':RET:2054-5','T','021','DEN','3355018','99734OH005000401','2014-03-01','2014-02-13 17:42:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:01:12'),(283,233,'Y','18','021','EC','A','','','AC','0000142784','0000142784','OH00000804659','IL','1','burdett','marcus','','','','34','259498786','355 E. 7th St.',0,'lima','OH','45804',NULL,'CY','39003','1977-07-17','M','U',NULL,'N','021','HLT','1073338','92036OH004001501','2014-01-01','2013-10-12 10:27:07','0.00',NULL,NULL,'217.67','217.67','R-OH002','OH0','217.67',NULL,0,'2013-12-25 17:30:20'),(18041,14412,'Y','18','021','EC','A','','','AC','0000368306','0000368306','MS00001285126','IL','1','BILLINGSLEA','DEBRA','','','','34','425276660','194 A LAKE CASTLE RD',0,'MADISON','MS','39110',NULL,'CY','28089','1964-04-05','F','U',':RET:2054-5','N','021','DEN','2283769','46300MS002000101','2014-02-01','2014-01-13 19:31:51','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-15 02:07:12'),(18447,14716,'N','19','021','EC','A',NULL,NULL,'','0000618384','0000676736','','S1','1','Link','Edward','Glen','','III','34','271130316','1453 LANGDON DR',0,'SIDNEY','OH','45365','6202','CY','39149','2006-10-29','M','',':RET:2106-3','N','021','HLT','1806607','92036OH001000501','2014-02-01','2014-01-14 19:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.08',NULL,0,'2014-01-16 08:46:06'),(17583,14056,'N','19','021','EC','A',NULL,NULL,'','0000050708','0000179920','','S1','1','Hindel','Scott','','','','34','298066125','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2002-05-11','F','',':RET:2106-3','N','021','DEN','1970276','99734OH005000401','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:07'),(14790,11813,'Y','18','021','EC','A','','','AC','0000970459','0000970459','OH00000932456','IL','1','Adams','Stephen','','','','34','301861825','980 N FAIRFIELD RD',0,'BEAVERCREEK','OH','45434','5922','CY','39057','1971-09-01','M','U',':RET:2106-3','N','021','DEN','1685903','99734OH005000401','2014-01-01','2013-12-23 20:11:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,1,'2013-12-29 11:13:29'),(6752,5358,'Y','18','021','EC','A','','','AC','0001140734','0001140734','OH00001063285','IL','1','Scarlato','Nicholas','','','','34','286683690','3633 Darwin ave',0,'Cincinnati','OH','45211',NULL,'CY','39061','1975-06-02','M','M',':RET:2106-3','N','021','HLT','72764','92036OH004001201','2014-01-01','2013-11-24 23:30:48','0.00',NULL,NULL,'435.69','435.69','R-OH004','OH0','215.09',NULL,0,'2013-12-26 01:16:07'),(8002,6332,'Y','18','021','EC','A','','','AC','0000825436','0000825436','TX00001278061','IL','1','Clemons','Jessica',NULL,NULL,NULL,NULL,NULL,'7319 CAMPBELL RD',0,'DALLAS','TX','75248','1630','CY','48113','1977-11-13','F','M',NULL,'N','021','DEN','1437976','33348TX002000101','2014-01-01','2013-12-19 20:37:58','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 03:08:23'),(19832,15815,'Y','18','024','14','A','','','TE','0001047682','0001047682','','IL','1','Kline','Gayle','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-30','F','',NULL,NULL,NULL,'','1581359','','2014-01-24','2014-01-24 14:24:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:20'),(20357,16258,'Y','18','024','14','A','','','TE','0000735058','0000735058','','IL','1','dale','thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-09-19','M','',NULL,NULL,NULL,'','2859567','','2014-01-28','2014-01-28 14:03:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:18'),(22904,18256,'N','01','021','EC','A',NULL,NULL,'','0000061358','0000893190','','IL','1','STEPHENS','JOHN','','','','34','283549838','3371 COUNTY ROAD 5 DASH 1',0,'DELTA','OH','43515',NULL,'CY','39051','1954-09-05','M','',':RET:2106-3','N','021','HLT','3099406','92036OH002002601','2014-03-01','2014-02-11 11:02:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.17',NULL,0,'2014-02-11 21:02:43'),(24636,19553,'Y','18','021','EC','A','','','AC','0001682228','0001682228','LA00003018768','IL','1','Blazio','LoLita','Hamilton','','','34','436293736','2318 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4403','CY','22071','1967-11-19','F','U',NULL,'N','021','DEN','2898543','18575LA002000201','2014-04-01','2014-02-19 10:38:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 04:18:55'),(26608,21097,'Y','18','021','EC','A','','','AC','0001093304','0001093304','TX00002227983','IL','1','Brutcher','Anthony','','','','34','600020392','1417 RYAN STEVEN PL',0,'EL PASO','TX','79936','0262','CY','48141','1986-06-26','M','U',':RET:2106-3','N','021','DEN','2986729','33348TX002000201','2014-03-01','2014-02-27 22:52:56','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:30:45'),(9769,7736,'Y','18','021','EC','A','','','AC','0000621081','0000621081','OH00000889221','IL','1','Geib','Ella','','','','34','293626587','5807 TROY VILLA BLVD',0,'DAYTON','OH','45424','2649','CY','39113','1962-09-02','F','M',':RET:2106-3','N','021','DEN','478861','99734OH005000401','2014-01-01','2013-10-21 11:45:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 05:00:24'),(8966,7112,'N','01','021','EC','A',NULL,NULL,'','0000437960','0001002159','','IL','1','Fidak','Alan','','','','34','283501352','928 BANFIELD AVE',0,'TORONTO','OH','43964','1104','CY','39081','1950-02-13','M','',':RET:2106-3','N','021','DEN','2257562','99734OH005000401','2014-01-01','2013-12-18 14:26:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:03:58'),(16080,12878,'Y','18','021','EC','A','','','AC','0000398623','0000398623','OH00001480238','IL','1','amrose','charles','','','','34','269860737','381 southampton',0,'aurora','OH','44202',NULL,'CY','39133','1971-02-24','M','M',':RET:2106-3','N','021','DEN','2202481','99734OH005000401','2014-02-01','2014-01-03 15:03:32','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-04 02:04:05'),(7573,5992,'N','01','021','EC','A',NULL,NULL,'','0000996517','0000449846','','IL','1','Lee','Marc','','','','34','292786025','459 S WASHINGTON ST',0,'TIFFIN','OH','44883','3313','CY','39147','1974-10-28','M','',NULL,'N','021','HLT','140720','92036OH001002701','2014-01-01','2013-12-15 10:22:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','296.83',NULL,0,'2013-12-26 02:33:46'),(6124,4856,'Y','18','021','EC','A','','','AC','0000705774','0000705774','TX00000347670','IL','1','kapita','jolie','','','','34','627748081','1902 S. Hwy 121',0,'Lewisville','TX','75067',NULL,'CY','48121','1977-06-09','F','U',':RET:2054-5','N','021','DEN','1250187','33348TX002000201','2014-01-01','2013-11-21 09:56:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:15:48'),(7001,5557,'Y','18','021','EC','A','','','AC','0000903615','0000903615','TX00000181344','IL','1','Cruz','Ricardo','','','','34','453897695','6039 Whitby Rd',0,'San Antonio','TX','78240',NULL,'CY','48029','1987-09-10','M','U',NULL,'N','021','DEN','1521887','33348TX002000201','2014-01-01','2013-12-24 19:03:22','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 01:48:16'),(19338,15416,'Y','18','021','EC','A','','','AC','0001130905','0001130905','TX00001916092','IL','1','GOTTLIEB','LEWIS','','','','34','453213519','17050 GLENEAGLE DR S',0,'CONROE','TX','77385','4614','CY','48339','1957-12-14','M','U',NULL,'N','021','DEN','1972644','33348TX002000201','2014-03-01','2014-01-21 18:00:10','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-22 03:22:19'),(22025,17584,'Y','18','021','EC','A','','','AC','0000553952','0000553952','OH00001548891','IL','1','HAGAN','JOHN','RICHARD','','','34','285600340','4880 CHAPPARAL RD',0,'WEST UNION','OH','45693','9499','CY','39001','1974-12-13','M','M',':RET:2106-3','T','021','HLT','3084293','92036OH003000606','2014-03-01','2014-02-07 15:56:47','496.00',NULL,NULL,'661.02','165.02','R-OH005','OH0','325.35',NULL,0,'2014-02-07 19:01:00'),(22788,18194,'Y','18','021','EC','A','','','AC','0000995478','0000995478','OH00001945746','IL','1','Noethen','Cynthia','','','','34','289568870','590 OTTAWA ST',0,'MONTPELIER','OH','43543','9014','CY','39171','1952-12-29','F','U',':RET:2106-3','T','021','DEN','3416600','99734OH005000301','2014-03-01','2014-02-11 11:59:20','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-11 21:01:48'),(23407,18649,'Y','18','021','EC','A','','','AC','0000309496','0000309496','OH00001885537','IL','1','Monahan','Kenneth','','','','34','277641575','800 West Seymour Avenue',0,'Cincinnati','OH','45216',NULL,'CY','39061','1971-05-09','M','U',':RET:2106-3','N','021','DEN','2735553','99734OH005000401','2014-03-01','2014-02-13 17:59:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:01:13'),(25960,20589,'N','19','021','EC','A',NULL,NULL,'','0000648379','0001161587','','S1','1','TAYLOR','DEMETRIUS','','','','34','281066480','231 S FINDLAY ST',0,'DAYTON','OH','45403','2658','CY','39113','2001-05-25','F','',NULL,'N','021','DEN','3479755','99734OH005000401','2014-04-01','2014-02-26 12:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:41'),(28541,22589,'Y','18','021','EC','A','','','AC','0000490687','0000490687','TX00003814882','IL','1','Johnson','Allyson','','','','34','455790700','801 Cleveland',0,'Houston','TX','77019',NULL,'CY','48201','1986-08-07','F','U',':RET:2106-3','N','021','DEN','3858502','33348TX002000101','2014-04-01','2014-03-07 17:01:59','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-07 21:32:14'),(38,33,'Y','18','021','EC','A','','','AC','0000398580','0000398580','OH00000945755','IL','1','MCKINNEY','LARRY','H','','','34','299482279','2687 ROUTE 50',0,'BATAVIA','OH','45103',NULL,'CY','39025','1950-09-13','M','U',NULL,'N','021','DEN','757242','99734OH005000401','2014-01-01','2013-12-05 12:56:30','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 17:15:59'),(8881,7041,'N','01','021','EC','A',NULL,NULL,'','0000567513','0000291867','','IL','1','Cote','Mark','','','','34','590553049','4443 OCEAN DR',0,'CORPUS CHRISTI','TX','78412','2582','CY','48355','1969-04-24','M','',':RET:2106-3','N','021','DEN','1904270','33348TX002000201','2014-01-01','2013-12-18 15:23:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:47'),(13762,10985,'Y','18','021','EC','A','','','AC','0000412070','0000412070','MS00000500098','IL','1','DAQUIN','DENNIS','','','','34','427236315','236 BASSWOOD DR',0,'PASS CHRISTIAN','MS','39571','2104','CY','28047','1960-07-09','M','M',':RET:2106-3','T','021','DEN','1958110','46300MS002000201','2014-01-01','2013-12-23 10:33:37','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2013-12-26 13:10:15'),(5760,4575,'Y','18','021','EC','A','','','AC','0000436603','0000436603','OH00001312748','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','DEN','1757976','99734OH005000401','2014-01-01','2013-12-23 21:51:51','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:46:30'),(1782,1467,'Y','18','021','EC','A','','','AC','0000799894','0000799894','OH00000758794','IL','1','muscatello','malissa','','','','34','280843963','432 EASTWOOD AVE',0,'TALLMADGE','OH','44278','3122','CY','39153','1985-12-17','F','U',':RET:2106-3','N','021','DEN','2419257','99734OH005000301','2014-01-01','2013-12-24 15:16:29','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:56:22'),(3066,2464,'Y','18','021','EC','A','','','AC','0000910496','0000910496','OH00001310766','IL','1','stefanelli','paul','','','','34','282826962','7856 SNIDER RD',0,'MASON','OH','45040','9620','CY','39165','1969-12-14','M','U',':RET:2106-3','N','021','HLT','26419','92036OH006001201','2014-01-01','2013-12-06 01:13:15','163.00',NULL,NULL,'237.84','74.84','R-OH004','OH0','237.84',NULL,0,'2013-12-25 20:19:20'),(19869,15848,'Y','18','021','EC','A','','','AC','0001103469','0001103469','OH00002504249','IL','1','Bradford','Harry','','','','34','300462740','3573 LEWIS RD',0,'AMELIA','OH','45102','1682','CY','39025','1950-07-08','M','M',':RET:2106-3','N','021','DEN','3154785','99734OH005000401','2014-03-01','2014-01-24 09:22:43','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-24 21:00:39'),(20244,16153,'Y','18','021','EC','A','','','AC','0000187474','0000187474','TX00002590547','IL','1','Cunningam','Richard','','','','34','455151599','14122 MERGANSER DR',0,'HOUSTON','TX','77047','4616','CY','48201','1961-07-31','M','U',':RET:2054-5','N','021','DEN','3186903','33348TX002000101','2014-03-01','2014-01-27 18:28:01','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-28 21:00:09'),(26548,21049,'N','19','021','EC','A',NULL,NULL,'','0000858541','0000198621','','IL','1','Barnette','Allison','','','','34','269080761','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2002-08-23','F','',':RET:2106-3','N','021','DEN','3004039','99734OH005000301','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:11'),(27850,22028,'Y','18','021','EC','A','','','AC','0000451984','0000451984','TX00002908422','IL','1','Mebrahtu','Adiel','','','','34','629502735','3430 LIVINGSTON LN',0,'CARROLLTON','TX','75007','3211','CY','48121','1973-11-04','F','U',':RET:2054-5','N','021','DEN','3828522','33348TX002000101','2014-04-01','2014-03-05 14:29:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-05 21:32:12'),(28325,22412,'Y','18','021','EC','A','','','AC','0000455863','0000455863','TX00002658637','IL','1','SEO','HYUN NAM','','','','34','629209738','2289 SCRIPTURE ST',0,'DENTON','TX','76201','3747','CY','48121','1963-12-31','F','M',':RET:2040-4','N','021','DEN','3574347','33348TX002000201','2014-04-01','2014-03-06 23:53:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:07'),(17947,14339,'Y','18','021','EC','A','','','AC','0000733882','0000733882','TX00002377044','31','1','Haikenwaelder','Kathy','','','','34','453922818','9617 FM 340',0,'Moulton','TX','77975',NULL,'CY','48057','1953-08-20','F','U',':RET:2106-3','N','021','DEN','2366241','33348TX002000201','2014-02-01','2014-01-14 16:08:54','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-15 02:06:41'),(14138,11269,'N','01','021','EC','A',NULL,NULL,'','0002008003','0001971952','','IL','1','Raofisani','Hayedeh',NULL,NULL,NULL,NULL,NULL,'1803 Martin Luther King BLVD',0,'Houma','LA','70360',NULL,'CY','22109','1954-01-25','F','',':RET:2029-7','N','021','DEN','2349335','18575LA002000201','2014-02-01','2013-12-26 11:50:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:02:35'),(7639,6048,'Y','18','021','EC','A','','','AC','0000376116','0000376116','OH00000120724','IL','1','Moore','Karla','','','','34','296566731','421 W OAK ST',0,'OAK HARBOR','OH','43449','1231','CY','39123','1955-08-23','F','U',NULL,'N','021','HLT','1144772','92036OH003002701','2014-01-01','2013-10-14 08:59:02','197.00',NULL,NULL,'518.85','321.85','R-OH006','OH0','518.85',NULL,0,'2013-12-26 02:46:30'),(4900,3886,'N','17','021','EC','A',NULL,NULL,'','0000743040','0000491836','','IL','1','Alvarez','Tyrus','','','','34','282025205','17683 brim rd',0,'Bowling Green','OH','43402',NULL,'CY','39173','1997-01-29','M','',':RET:2148-5^:RET:2106-3','N','021','DEN','947616','99734OH005000401','2014-01-01','2013-10-26 01:07:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:31:46'),(9279,7361,'N','19','021','EC','A',NULL,NULL,'','0000753357','0000479809','','IL','1','TARELLARI','ANGELICA','','','','34','883278644','10814 WINDHAM RD',0,'PARMA','OH','44130','1573','CY','39035','2013-07-17','F','',':RET:2106-3','N','021','DEN','15448','99734OH005000301','2014-01-01','2013-11-30 11:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:15:53'),(3269,2635,'N','01','021','EC','A',NULL,NULL,'','0000244944','0000884177','','IL','1','Peth','Richard','','','','34','298444435','3641 Heatherdowns',0,'Toledo','OH','43614',NULL,'CY','39095','1950-10-20','M','',':RET:2106-3','N','021','HLT','684199','92036OH003002601','2014-01-01','2013-11-27 19:35:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','601.12',NULL,0,'2013-12-25 20:47:08'),(5372,4259,'Y','18','021','EC','A','','','AC','0000282003','0000282003','OH00000509797','IL','1','Couch','Tamara','','','','34','314768931','48 Shadowlake Dr',0,'Mason','OH','45040',NULL,'CY','39165','1960-09-24','F','U',':RET:2106-3','N','021','HLT','1634418','92036OH005001201','2014-01-01','2013-12-19 18:01:23','135.00',NULL,NULL,'437.93','302.93','R-OH004','OH0','437.93',NULL,0,'2013-12-25 23:08:06'),(4816,3817,'N','01','021','EC','A',NULL,NULL,'','0001152170','0000879460','','IL','1','Griffith','Jeffery','','','','34','277562485','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1961-11-28','M','',':RET:2106-3','N','021','HLT','724805','92036OH003001501','2014-01-01','2013-12-07 21:58:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.63',NULL,0,'2013-12-25 22:16:56'),(4476,3552,'N','19','021','EC','A',NULL,NULL,'','0000129245','0000870603','','IL','1','Dail','Andrew',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1992-07-24','M','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:53'),(4590,3635,'Y','18','024','14','A','','','TE','0001252092','0001252092','','IL','1','gabriel','lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-01-17','F','',NULL,NULL,NULL,'','260196','','2013-12-12','2013-12-12 11:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:05:28'),(23069,18393,'Y','18','021','EC','A','','','AC','0001223248','0001223248','LA00001514489','IL','1','WILSON','ROGERICK','','','','34','426135404','2136 N LOBDELL BLVD',0,'BATON ROUGUE','LA','70806',NULL,'CY','22033','1976-12-01','M','U',NULL,'N','021','DEN','2813299','18575LA002000201','2014-03-01','2014-02-12 12:32:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:56'),(23171,18473,'Y','18','021','EC','A','','','AC','0000358374','0000358374','OH00002395767','IL','1','SMITH','BETTY','','','','34','288641471','100 ECKMANSVILLE RD',0,'WEST UNION','OH','45693','9704','CY','39001','1961-12-09','F','M',':RET:2106-3','T','021','HLT','3552482','92036OH003000605','2014-03-01','2014-02-11 20:27:12','323.00',NULL,NULL,'503.23','180.23','R-OH005','OH0','503.23',NULL,0,'2014-02-12 21:31:53'),(23936,19033,'Y','18','021','EC','A','','','AC','0000979339','0000979339','OH00002913961','IL','1','Jorgenson','Joseph','','','','34','288805821','754 POINTVIEW DR',0,'WESTERVILLE','OH','43081','3476','CY','39049','1980-04-13','M','M',':RET:2106-3','N','021','DEN','3425477','99734OH005000301','2014-03-01','2014-02-15 06:59:21','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00','CIC',0,'2014-02-15 21:00:06'),(25305,20075,'Y','18','024','14','A','','','TE','0000761132','0000761132','','IL','1','L\'Heureux','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-03-04','F','',NULL,NULL,NULL,'','2492465','','2014-02-28','2014-02-25 16:09:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:30'),(17299,13834,'N','01','021','EC','A',NULL,NULL,'','0000368306','0001005619','','IL','1','Hernandez','Felipe','','','','34','455577121','7115 SYLVIA HANDY ST',0,'WESLACO','TX','78596','9059','CY','48215','1970-04-12','M','',':RET:2106-3','N','021','DEN','1537336','33348TX002000201','2014-02-01','2014-01-10 11:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:23:37'),(13051,10405,'Y','18','021','EC','A','','','AC','0000267524','0000267524','OH00000967615','IL','1','Stump','Paula','M','','','34','301466567','642 E 6TH ST',0,'DELPHOS','OH','45833','1518','CY','39003','1949-07-29','F','M',':RET:2106-3','N','021','DEN','1650849','99734OH005000401','2014-01-01','2013-12-23 09:04:04','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 12:50:52'),(285,235,'Y','18','024','14','A','','','TE','0000103850','0000103850','','IL','1','Grove','Peggy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-21','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:30:23'),(17252,13804,'Y','18','021','EC','A','','','AC','0000093864','0000093864','OH00001727713','IL','1','Pritchett','Denise','','','','34','272506836','71 KESSLER PL',0,'CINCINNATI','OH','45217','1549','CY','39061','1951-09-18','F','U',':RET:2054-5','N','021','DEN','1604716','99734OH005000301','2014-02-01','2014-01-10 09:26:56','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:23:12'),(4304,3422,'N','01','021','EC','A',NULL,NULL,'','0001175697','0001250825','','IL','1','Martin','Charleen','','','','34','302528173','1559 OLD STATE ROUTE 74',0,'BATAVIA','OH','45103','1604','CY','39025','1954-09-14','F','',':RET:2106-3','N','021','HLT','2570296','92036OH005000604','2014-01-01','2013-12-17 16:32:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','558.80',NULL,0,'2013-12-25 21:52:25'),(16489,13195,'Y','18','021','EC','A','','','AC','0000132084','0000132084','OH00002322471','IL','1','CLARK','JOYCE','','','','34','294665074','150 S LEONARD AVE',0,'LIMA','OH','45804','2926','CY','39003','1960-03-12','F','M',NULL,'N','021','HLT','1751826','92036OH002001501','2014-02-01','2014-01-06 16:18:41','683.00',NULL,NULL,'1137.89','454.89','R-OH002','OH0','518.49',NULL,0,'2014-01-07 04:06:30'),(16180,12954,'N','01','021','EC','A',NULL,NULL,'','0000380494','0000121765','','IL','1','Chamness','Victoria','','','','34','465782509','7519 TIMBER RIDGE TRL',0,'SUGAR LAND','TX','77479','6121','CY','48157','1950-09-19','F','',NULL,'N','021','DEN','1567836','33348TX002000201','2014-02-01','2014-01-03 18:43:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-05 00:00:30'),(2285,1862,'Y','18','021','EC','A','','','AC','0000371465','0000371465','OH00000808758','IL','1','Lippert','Samuel','','','','34','371826117','2569 MONTANA AVE',0,'CINCINNATI','OH','45211','3710','CY','39061','1966-08-10','M','U',':RET:2106-3','N','021','DEN','29061','99734OH005000301','2014-01-01','2013-12-09 13:27:43','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:37'),(4058,3241,'Y','18','021','EC','A','','','AC','0000788186','0000788186','OH00001104824','IL','1','DAVIS-BAILEY','SHIRLEY','','','','34','281485390','1083 W KEMPER RD',0,'cincinnati','OH','45240',NULL,'CY','39061','1949-08-18','F','M',':RET:2054-5','N','021','DEN','2331742','99734OH005000401','2014-01-01','2013-12-17 15:34:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:35'),(14881,11884,'Y','18','021','EC','A','','','AC','0000197686','0000197686','TX00001571313','IL','1','Sanchez','Hilda','R','','','34','630886497','26434 PALOMINO AVE',0,'LA FERIA','TX','78559','4398','CY','48061','1968-05-15','F','M',':RET:2106-3','N','021','DEN','1925377','33348TX002000201','2014-02-01','2013-12-29 15:31:15','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-30 00:00:32'),(23594,18795,'Y','18','021','EC','A','','','AC','0000048238','0000048238','OH00001815559','IL','1','CRAINE','DEBORA','','','','34','273669421','827 HAMILTON RD',0,'LYNX','OH','45650','9714','CY','39001','1958-02-19','F','U',NULL,'T','021','HLT','3178345','92036OH006000601','2014-03-01','2014-02-13 12:03:57','0.00',NULL,NULL,'456.76','456.76','R-OH005','OH0','456.76',NULL,0,'2014-02-13 22:03:04'),(25523,20249,'Y','18','021','EC','A','','','AC','0000643281','0000643281','OH00002580537','IL','1','Brennan','John','','','','34','298609810','6338 GREENBRIAR DR',0,'FAIRFIELD','OH','45014','4748','CY','39017','1977-05-11','M','U',':RET:2106-3','N','021','HLT','2857992','92036OH006001201','2014-04-01','2014-02-25 17:30:49','41.00',NULL,NULL,'209.41','168.41','R-OH004','OH0','209.41',NULL,0,'2014-02-25 21:32:08'),(27658,21876,'Y','18','021','EC','A','','','AC','0000448834','0000448834','OH00003483212','IL','1','Wilson','Joshua','','','','34','302905854','6738 SMITH RD',0,'LOVELAND','OH','45140','8404','CY','39025','1988-10-18','M','U',':RET:2106-3','N','021','DEN','3224198','99734OH005000401','2014-04-01','2014-03-05 14:29:54','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-05 21:30:25'),(28907,22881,'Y','18','021','EC','A','','','AC','0001022858','0001022858','OH00002627796','31','1','kinnison','gary','','','','34','572611088','po box 261',0,'pleasantville','OH','43148',NULL,'CY','39045','1978-07-24','M','U',':RET:2106-3','T','021','DEN','3784614','99734OH005000301','2014-04-01','2014-03-09 18:26:30','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:00:25'),(2779,2246,'Y','18','021','EC','A','','','AC','0000631949','0000631949','MS00000878940','IL','1','Rainwater','Susan','','','','34','438967018','111 Lakeshore Dr',0,'Brandon','MS','39047',NULL,'CY','28121','1956-04-12','F','U',':RET:2106-3','N','021','DEN','883814','46300MS002000101','2014-01-01','2013-12-02 18:07:45','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 19:49:47'),(2674,2168,'N','19','021','EC','A',NULL,NULL,'','0000280804','0000490439','','IL','1','sickles','kody','','','Jr','34','302154859','1700 WOODWARD AVE',0,'SPRINGFIELD','OH','45506','3147','CY','39023','2010-09-27','M','',':RET:2106-3','N','021','DEN','697055','99734OH005000301','2014-01-01','2013-12-02 15:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:06'),(556,456,'Y','18','021','EC','A','','','AC','0000032671','0000032671','LA00001144297','31','1','HOWARD','DELVIN','','','','34','437710910','921 CHURCH ST HOUMA',0,'HOUMA','LA','70360',NULL,'CY','22109','1980-11-01','M','U',':RET:2054-5','N','021','DEN','205822','18575LA002000101','2014-01-01','2013-12-04 13:00:09','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2013-12-25 17:50:10'),(8059,6382,'Y','18','024','14','A','','','TE','0000659881','0000659881','','IL','1','Brown','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-20','F','',NULL,NULL,NULL,'','2099730','','2013-12-20','2013-12-20 08:35:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:09:56'),(19639,15652,'Y','18','021','EC','A','','','AC','0000735055','0000735055','OH00002057411','IL','1','Mealka','Gregory','','','','34','293645432','3916 South Arlington Rd.',0,'Uniontown','OH','44685',NULL,'CY','39153','1958-10-19','M','U',':RET:2106-3','N','021','DEN','2843499','99734OH005000401','2014-03-01','2014-01-23 11:34:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-23 21:00:13'),(19680,15684,'Y','18','021','EC','A','','','AC','0001129521','0001129521','TX00001586565','IL','1','CABRERA','JUDIDIA','','','','34','453532394','3112 37TH PL',0,'SNYDER','TX','79549','5701','CY','48415','1975-08-07','F','M',':RET:2106-3','N','021','DEN','1810211','33348TX002000201','2014-03-01','2014-01-22 22:26:27','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:37'),(20174,16098,'N','01','021','EC','A',NULL,NULL,'','0000207160','0000394958','','IL','1','ALI','MICHAEL','','','','34','283662048','269 SOUTH EAGLE STREET',0,'GENEVA','OH','44041',NULL,'CY','39007','1963-11-17','M','',':RET:2054-5','N','021','HLT','1448622','52664OH151001301','2014-03-01','2014-01-27 12:47:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','449.21',NULL,0,'2014-01-27 21:01:16'),(20565,16435,'Y','18','021','EC','A','','','AC','0000585558','0000585558','OH00001877814','IL','1','FISHER','CHARITY','','','','34','289762734','1301 GLENN AVE',0,'LIMA','OH','45804',NULL,'CY','39003','1980-11-05','F','U',NULL,'T','021','HLT','3459119','92036OH005001506','2014-03-01','2014-01-29 12:59:02','223.00',NULL,NULL,'303.20','80.20','R-OH002','OH0','303.20',NULL,0,'2014-01-29 21:01:49'),(21413,17115,'Y','18','021','EC','A','','','AC','0000695670','0000695670','OH00002522044','31','1','Leger','Nathalie',NULL,NULL,NULL,NULL,NULL,'8773 Fenton Court',0,'Sagamore Hills','OH','44067',NULL,'CY','39133','1986-12-28','F','U',NULL,'N','021','DEN','3422378','99734OH005000401','2014-03-01','2014-02-04 17:02:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-04 21:01:09'),(25312,20080,'Y','18','024','14','A','','','TE','0000699308','0000699308','','IL','1','Alexander','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-13','M','',NULL,NULL,NULL,'','2953966','','2014-02-25','2014-02-25 13:47:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-25 21:00:33'),(26629,21114,'Y','18','021','EC','A','','','AC','0000096356','0000096356','TX00003323059','IL','1','Robles','Manuel','','','','34','454836016','7606 hermosillo',0,'el paso','TX','79915',NULL,'CY','48141','1987-03-26','M','U',NULL,'N','021','DEN','3121457','33348TX002000201','2014-04-01','2014-02-28 14:28:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:30:56'),(26916,21332,'Y','18','021','EC','A','','','AC','0000417451','0000417451','OH00002342281','IL','1','Estep','Rebecca','','','','34','275882944','59 BEECHVIEW DR',0,'BROOKVILLE','OH','45309','9206','CY','39113','1978-06-04','F','M',':RET:2106-3','N','021','DEN','2818693','99734OH005000401','2014-04-01','2014-03-01 19:35:13','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-03 01:00:14'),(27377,21676,'N','19','021','EC','A',NULL,NULL,'','0000302878','0000449547','','IL','1','tran','hanh','hieu','','','34','595869580','7412 OLD FORT BAYOU RD',0,'OCEAN SPRINGS','MS','39564','8195','CY','28059','1989-09-20','F','',':RET:2047-9','N','021','DEN','3947696','46300MS002000101','2014-04-01','2014-03-04 13:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-04 21:01:19'),(18226,14547,'Y','18','021','EC','A','','','AC','0000697099','0000697099','TX00002334787','IL','1','GUTIERREZ','ALMA','','','','34','457812211','12453 TIERRA BELLA DR',0,'EL PASO','TX','79938',NULL,'CY','48141','1986-01-11','F','U',NULL,'N','021','DEN','2750114','33348TX002000201','2014-02-01','2014-01-14 20:47:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-16 08:44:16'),(17905,14301,'Y','18','021','EC','A','','','AC','0000753941','0000753941','TX00001613015','IL','1','Nadel','Elissa','A','','','34','460736739','2816 Vine Street',0,'Dallas','TX','75204',NULL,'CY','48113','1984-06-04','F','U',':RET:2106-3','N','021','DEN','1485695','33348TX002000201','2014-02-01','2014-01-13 18:58:23','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:24'),(17805,14222,'Y','18','021','EC','A','','','AC','0000799597','0000799597','TX00002077445','IL','1','Edgar','Gregory','','','','34','175468080','5912 SAN BERNARDO AVE',0,'LAREDO','TX','78041','2506','CY','48479','1954-09-27','M','U',':RET:2106-3','N','021','DEN','2665154','33348TX002000101','2014-02-01','2014-01-13 18:36:26','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-01-15 02:05:50'),(16891,13516,'Y','18','021','EC','A','','','AC','0001163196','0001163196','TX00001763748','IL','1','Hooper','Ralph','Edward','','Jr','34','466252106','1675 FM 60 E',0,'SOMERVILLE','TX','77879','4064','CY','48051','1958-01-28','M','M',':RET:2106-3','N','021','DEN','1528460','33348TX002000201','2014-02-01','2014-01-09 17:18:51','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-13 02:19:27'),(4972,3948,'Y','18','021','EC','A','','','AC','0000720122','0000720122','TX00000961915','IL','1','Lopez','Anna','E','','','34','639103929','4215 RiverDrive',0,'Huston','TX','77017',NULL,'CY','48201','1987-03-23','F','U',NULL,'N','021','DEN','560027','33348TX002000201','2014-01-01','2013-12-06 19:25:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:46:28'),(6695,5307,'Y','18','021','EC','A','','','AC','0000521374','0000521374','TX00001059775','IL','1','Katt','Jude','','','','34','437213106','9608 BEECHNUT DR',0,'AUSTIN','TX','78748','2248','CY','48453','1974-12-16','F','U',':RET:2106-3','N','021','DEN','550312','33348TX002000201','2014-01-01','2013-11-05 17:55:22','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:01:42'),(28731,22739,'Y','18','021','EC','A','','','AC','0002197769','0002197769','LA00003698268','IL','1','Walker','Celetta','','','','34','434351623','8121 GREENWELL SPRINGS RD',0,'BATON ROUGE','LA','70814','2229','CY','22033','1977-10-13','F','U',':RET:2054-5','N','021','DEN','3508937','18575LA002000101','2014-04-01','2014-03-09 13:46:02','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-09 21:00:03'),(15676,12539,'N','19','021','EC','A',NULL,NULL,'','0000043240','0000593690','','IL','1','Milefchik','Peyton','Olivia','','','34','760292219','322 Wilson Ave',0,'Port Clinton','OH','43452',NULL,'CY','39123','2011-07-28','F','',':RET:2106-3','N','021','HLT','2474421','92036OH004002701','2014-02-01','2013-12-31 16:54:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,1,'2014-01-02 04:34:50'),(6402,5074,'Y','18','021','EC','A','','','AC','0000179869','0000179869','OH00000889572','IL','1','Kahny','Brandon','Jeffery','','','34','279767197','57 VAN BUREN DR',0,'HAMILTON','OH','45011',NULL,'CY','39017','1980-06-09','M','R',':RET:2106-3','N','021','DEN','212387','99734OH005000301','2014-01-01','2013-12-11 14:37:58','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:48:22'),(15406,12323,'Y','18','021','EC','A','','','AC','0001041388','0001041388','TX00001782717','IL','1','Garza','Phillip','','','','34','450978218','183 COUNTY ROAD 366',0,'SANDIA','TX','78383','2245','CY','48249','1988-01-12','M','M',':RET:2106-3','N','021','DEN','1629907','33348TX002000201','2014-02-01','2013-12-30 22:54:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:26:56'),(15105,12073,'Y','18','021','EC','A','','','AC','0000012444','0000012444','OH00001592056','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','DEN','1960765','99734OH005000301','2014-02-01','2013-12-30 10:08:49','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-01 12:04:48'),(2590,2105,'N','01','021','EC','A',NULL,NULL,'','0001165296','0000474925','','IL','1','Bayardi','Laura','L','','','34','277586572','210 Martha St.',0,'Yorkville','OH','43971',NULL,'CY','39081','1954-12-02','F','',':RET:2106-3','N','021','DEN','1099448','99734OH005000401','2014-01-01','2013-12-01 18:20:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:04'),(4716,3739,'Y','18','021','EC','A','','','AC','0000876037','0000876037','OH00000491717','IL','1','Curry','Terry','Wayne','','','34','281528709','150 CENTRAL AVE',0,'TIFFIN','OH','44883','2614','CY','39147','1954-04-11','M','U',':RET:2106-3','N','021','HLT','80529','92036OH002002701','2014-01-01','2013-12-12 12:23:48','0.00',NULL,NULL,'586.17','586.17','R-OH006','OH0','586.17',NULL,0,'2013-12-25 22:08:51'),(14546,11605,'N','01','021','EC','A',NULL,NULL,'','0000584442','0000373441','','IL','1','derouen','willis','p','','Jr','34','435615423','410 E GEORGETOWN ST',0,'CRYSTAL SPRINGS','MS','39059','2533','CY','28029','1971-12-18','M','',NULL,'N','021','DEN','2322100','46300MS002000201','2014-02-01','2013-12-27 14:40:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-28 03:34:53'),(19072,15194,'Y','18','024','14','A','','','TE','0000186894','0000186894','','IL','1','BALDWIN','ADA','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-06-07','F','',NULL,NULL,NULL,'','1361703','','2014-01-17','2014-01-17 20:09:01',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-21 08:44:21'),(22553,18010,'Y','18','021','EC','A','','','AC','0000459199','0000459199','OH00001818106','IL','1','Jackson','Delilah','Olena','','','34','276548041','41 BERTUS ST',0,'CINCINNATI','OH','45217','1631','CY','39061','1954-04-21','F','U',':RET:2106-3','T','021','DEN','3629652','99734OH005000401','2014-03-01','2014-02-10 08:56:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:46'),(23955,19048,'Y','18','021','EC','A','','','AC','0000384122','0000384122','TX00002843360','31','1','Jagours','Jamila','','','','34','457838166','P.O. Box 260272',0,'Plano','TX','75026',NULL,'CY','48085','1975-07-27','F','U',NULL,'N','021','DEN','2797770','33348TX002000101','2014-03-01','2014-02-15 11:36:35','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-15 22:00:06'),(24779,19655,'Y','18','021','EC','A','','','AC','0000514496','0000514496','OH00002707401','IL','1','Moore','Nancy','','','','34','277689072','307 FLINT ROCK DR',0,'DELAWARE','OH','43015','6206','CY','39041','1963-10-14','F','U',':RET:2106-3','N','021','DEN','2897440','99734OH005000401','2014-04-01','2014-02-19 11:59:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:45:00'),(17971,14360,'Y','18','021','EC','A','','','AC','0001260031','0001260031','OH00001525270','IL','1','Minhas','Rubina',NULL,NULL,NULL,NULL,NULL,'4897 SHINING WILLOW BLVD',0,'STOW','OH','44224','5935','CY','39153','1963-07-20','F','M',':RET:2106-3','N','021','HLT','1942667','52664OH151001306','2014-02-01','2014-01-14 03:45:04','795.00',NULL,NULL,'941.76','146.76','R-OH012','OH0','398.29',NULL,0,'2014-01-15 02:06:49'),(13018,10376,'Y','18','021','EC','A','','','AC','0001126867','0001126867','OH00000870774','IL','1','McGinty','kathleen','','','','34','272842411','1911 HINCKLEY HILLS RD',0,'HINCKLEY','OH','44233','9737','CY','39103','1985-05-07','F','U',':RET:2106-3','N','021','DEN','1829789','99734OH005000401','2014-01-01','2013-12-22 20:17:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:49:58'),(17693,14140,'Y','18','021','EC','A','','','AC','0001794495','0001794495','LA00001674865','IL','1','Bowers','Dawn','','','','34','437312091','133 WOODLAKE BLVD',0,'KENNER','LA','70065','1032','CY','22051','1971-05-23','F','M',NULL,'N','021','DEN','1900301','18575LA002000201','2014-02-01','2014-01-13 12:27:05','0.00',NULL,NULL,'67.44','67.44','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:00'),(781,644,'Y','18','021','EC','A','','','AC','0000862915','0000862915','TX00000784783','IL','1','Fontana','Valerie','','','','34','079642387','815-A Brazos St.',0,'Austin','TX','78701',NULL,'CY','48453','1967-04-17','F','U',NULL,'N','021','DEN','2364161','33348TX002000201','2014-01-01','2013-12-16 14:56:22','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:05:03'),(1106,910,'Y','18','021','EC','A','','','AC','0000816399','0000816399','OH00001026876','IL','1','ZIMMER','CINDY','KATHRYN','','','34','302588354','7774 CANNON RIDGE DR',0,'MENTOR','OH','44060','6749','CY','39085','1958-05-03','F','U',':RET:2106-3','T','021','DEN','412353','99734OH005000401','2014-01-01','2013-12-03 16:17:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:24'),(14821,11838,'N','19','021','EC','A',NULL,NULL,'','0000860687','0000763371','','IL','1','Borromeo II','Marjoe Anthony','Tonggao','','','34','645366383','15707 Pinyon Creek Dr',0,'Houston','TX','77095',NULL,'CY','48201','1993-08-03','M','',':RET:2036-2','N','021','DEN','2013174','33348TX002000101','2014-01-01','2013-12-23 20:51:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,1,'2013-12-29 11:14:20'),(7986,6322,'Y','18','021','EC','A','','','AC','0000658414','0000658414','OH00000018805','IL','1','Osborne','Keith','','','','34','293780563','3890 MORLEY DR',0,'KENT','OH','44240','6658','CY','39133','1977-09-19','M','U',':RET:2106-3','N','021','HLT','2324178','52664OH151001306','2014-01-01','2013-12-20 14:45:31','199.00',NULL,NULL,'274.30','75.30','R-OH012','OH0','274.30',NULL,0,'2013-12-26 03:08:03'),(14173,11300,'Y','18','021','EC','A','','','AC','0000712282','0000712282','TX00000835286','IL','1','rios','ricardo','','','','34','465158983','2010 12TH ST',0,'GALENA PARK','TX','77547','2206','CY','48201','1967-03-13','M','M',NULL,'N','021','DEN','2405202','33348TX002000201','2014-02-01','2013-12-25 22:17:51','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-27 02:03:31'),(6744,5350,'Y','18','021','EC','A','','','AC','0000720211','0000720211','OH00000472621','IL','1','Keltz','Jeanne','','','','34','287482424','9162 FRIENDSVILLE RD',0,'SEVILLE','OH','44273','9119','CY','39103','1950-07-15','F','U',':RET:2106-3','N','021','HLT','938323','52664OH151001305','2014-01-01','2013-11-25 08:56:28','506.00',NULL,NULL,'658.32','152.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 01:15:51'),(2317,1883,'Y','18','021','EC','A','','','AC','0000914738','0000914738','TX00000677144','31','1','Witt','Cody','','','','34','627121206','PO BOX 3081',0,'Big Spring','TX','79721',NULL,'CY','48227','1985-11-12','M','U',':RET:2106-3','N','021','DEN','35637','33348TX002000201','2014-01-01','2013-12-09 07:17:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:20'),(6038,4782,'Y','18','021','EC','A','','','AC','0000333094','0000333094','LA00000476181','IL','1','Nguyen','Thang','','','','34','433456964','280 WYLIE DR',0,'BATON ROUGE','LA','70808','5572','CY','22033','1957-12-27','M','M',':RET:2047-9','N','021','DEN','95725','18575LA002000101','2014-01-01','2013-11-30 21:00:12','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-26 00:01:21'),(22065,17614,'N','19','021','EC','A',NULL,NULL,'','0000418005','0000656661','','IL','1','Hazari','Akash','Dayasagar','','','34','635135645','2310 WHITE ST',0,'CLIFTON','TX','76634','1135','CY','48035','1992-04-15','M','',':RET:2029-7','N','021','DEN','3495532','33348TX002000201','2014-03-01','2014-02-08 13:48:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-08 19:00:12'),(26836,21270,'Y','18','021','EC','A','','','AC','0000444963','0000444963','OH00003575974','IL','1','Watts','Mechelle','','','','34','284804402','6503 Marsol RD',0,'Mayfield Height','OH','44124',NULL,'CY','39035','1982-04-02','F','U',':RET:2054-5','N','021','DEN','3333527','99734OH005000401','2014-04-01','2014-03-01 17:21:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:42'),(27975,22132,'Y','18','021','EC','A','','','AC','0001150861','0001150861','LA00002592815','IL','1','HUGHES','NICHOLAS','GUY','','','34','241634256','6501 MEMPHIS ST',0,'NEW ORLEANS','LA','70124','3235','CY','22071','1989-01-26','M','R',':RET:2106-3','N','021','DEN','3994212','18575LA002000201','2014-04-01','2014-03-06 13:18:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:52'),(1173,966,'N','19','021','EC','A',NULL,NULL,'','0000695599','0000280805','','IL','1','Sandstrom','Garrett','','','','34','269062415','630 Chilham Circle',0,'Uniontown','OH','44685',NULL,'CY','39153','2000-08-23','M','',':RET:2106-3','N','021','HLT','541910','52664OH151001501','2014-01-01','2013-12-03 13:04:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 18:19:11'),(18801,14974,'Y','18','021','EC','A','','','AC','0000406159','0000406159','OH00001463650','IL','1','Simmons','Mary','','','','34','275449782','2090 S. Ridge W',0,'Ashtabula','OH','44004',NULL,'CY','39007','1952-07-09','F','U',':RET:2106-3','N','021','DEN','1572998','99734OH005000401','2014-03-01','2014-01-16 12:35:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:59'),(17567,14045,'N','01','021','EC','A',NULL,NULL,'','0000313268','0000528267','','IL','1','SIAMIOMAZA','IRYNA','','','','34','293132692','8588 BROADACRE DR',0,'POWELL','OH','43065',NULL,'CY','39049','1971-02-16','F','',NULL,'N','021','DEN','1432202','99734OH005000401','2014-02-01','2014-01-13 00:03:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:31:59'),(1724,1437,'N','19','021','EC','A',NULL,NULL,'','0000876064','0000171236','','IL','1','Lynch','Emilie Cecilia','Maisto','','','34','271132407','287 CASTLE BLVD',0,'AKRON','OH','44313','6534','CY','39153','2006-11-06','F','',':RET:2036-2^:RET:2106-3','N','021','DEN','1370597','99734OH005000301','2014-01-01','2013-12-24 10:25:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:16'),(16940,13558,'Y','18','021','EC','A','','','AC','0002372351','0002372351','LA00002365345','IL','1','Johnson','Charles','','','','34','425479527','4306 S Carrollton Ave',0,'New Orleans','LA','70119',NULL,'CY','22071','1967-09-09','M','M',':RET:2106-3','N','021','DEN','1716837','18575LA002000201','2014-02-01','2014-01-09 11:48:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:53'),(16417,13138,'N','01','021','EC','A',NULL,NULL,'','0000168905','0000848370','','IL','1','Butcher','David','Lynn','','','34','234047842','6918 WHITE PINE DR',0,'RAVENNA','OH','44266','8983','CY','39133','1958-10-31','M','',':RET:2106-3','T','021','HLT','2088781','52664OH151001501','2014-02-01','2014-01-06 15:56:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','685.92',NULL,0,'2014-01-07 04:04:25'),(16007,12811,'Y','18','021','EC','A','','','AC','0000431816','0000431816','TX00001047741','IL','1','Molina','Diana','','','','34','509060907','4303 AVENUE D',0,'AUSTIN','TX','78751','3712','CY','48453','1982-07-25','F','U',':RET:2106-3','N','021','DEN','2389196','33348TX002000201','2014-02-01','2014-01-03 17:00:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-04 02:01:40'),(2355,1920,'Y','18','021','EC','A','','','AC','0000850458','0000850458','TX00000156478','IL','1','Willett','Robert','','','','34','457067755','351 SHEPHERD RD',0,'NACOGDOCHES','TX','75965','6945','CY','48347','1954-02-03','M','U',':RET:2106-3','N','021','DEN','915920','33348TX002000201','2014-01-01','2013-12-09 17:31:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:32:20'),(20331,16234,'Y','18','021','EC','A','','','AC','0000700415','0000700415','OH00002270118','IL','1','Conway','Connie','','','','34','313580636','5842 MEGAN DR',0,'LIBERTY TWP','OH','45011','2374','CY','39017','1953-03-02','F','U',':RET:2106-3','N','021','HLT','3249083','92036OH003001206','2014-03-01','2014-01-27 21:24:36','462.00',NULL,NULL,'608.42','146.42','R-OH004','OH0','608.42',NULL,0,'2014-01-28 21:01:01'),(20587,16450,'Y','18','024','14','A','','','TE','0000609559','0000609559','','IL','1','Shannawi','Sameer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-29','M','',NULL,NULL,NULL,'','3569056','','2014-01-29','2014-01-29 20:44:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:07'),(25451,20194,'Y','18','021','EC','A','','','AC','0000434588','0000434588','TX00003142918','IL','1','ESTRADA','CECILIA','','','','34','451251643','661 AGUA CLARA ST',0,'EL PASO','TX','79928','9012','CY','48141','1970-12-10','F','M',':RET:2106-3','N','021','DEN','3053788','33348TX002000201','2014-04-01','2014-02-25 13:38:44','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-25 21:31:26'),(27013,21396,'Y','18','024','14','A','','','TE','0000956539','0000956539','','IL','1','Arbor','ALana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-27','F','',NULL,NULL,NULL,'','2883869','','2014-03-31','2014-03-03 10:33:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-03 21:00:08'),(19572,15602,'N','19','021','EC','A',NULL,NULL,'','0001647541','0001530678','','S1','1','Caston','CaSandra','Tillman','','','34','437971805','6316 Timberman Place',0,'Shreveport','LA','71119',NULL,'CY','22017','1998-05-05','M','',':RET:2054-5','N','021','DEN','1758740','18575LA002000201','2014-03-01','2014-01-22 14:23:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-01-23 03:02:37'),(14004,11157,'Y','18','021','EC','A','','','AC','0001062114','0001062114','OH00000042375','IL','1','Becker','Matthew','','','','34','300622127','2416 SPRING VALLEY RD',0,'MIAMISBURG','OH','45342','4440','CY','39113','1972-08-25','M','R',':RET:2106-3','N','021','HLT','2508921','92036OH004000501','2014-01-01','2013-12-23 11:10:31','0.00',NULL,NULL,'248.86','248.86','R-OH003','OH0','248.86',NULL,0,'2013-12-26 13:16:10'),(18096,14455,'Y','18','021','EC','A','','','AC','0002046403','0002046403','LA00002524153','IL','1','Porche','Christopher','','','','34','434571662','2448 HIGHWAY 654',0,'GHEENS','LA','70355','2402','CY','22057','1984-02-25','M','U',NULL,'N','021','DEN','1990422','18575LA002000201','2014-02-01','2014-01-14 14:19:53','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-15 02:07:32'),(9625,7623,'Y','18','021','EC','A','','','AC','0000077560','0000077560','OH00000123883','IL','1','Paris','Stephen','Douglas','','','34','275443922','4222 EUCLID BLVD',0,'YOUNGSTOWN','OH','44512','1311','CY','39099','1957-05-23','M','U',NULL,'N','021','HLT','2507712','52664OH151001501','2014-01-01','2013-12-20 21:38:47','323.00',NULL,NULL,'707.63','384.63','R-OH013','OH0','707.63',NULL,0,'2013-12-26 04:38:02'),(2553,2077,'Y','18','021','EC','A','','','AC','0000654568','0000654568','OH00000660456','IL','1','Kutcher','John','Thomas','','','34','270444871','3783 FOX RUN DR',0,'BLUE ASH','OH','45236','1189','CY','39061','1949-04-25','M','U',':RET:2106-3','N','021','HLT','1122596','92036OH005001201','2014-01-01','2013-12-09 11:27:40','0.00',NULL,NULL,'644.00','644.00','R-OH004','OH0','644.00',NULL,0,'2013-12-25 19:37:19'),(8161,6456,'Y','18','021','EC','A','','','AC','0000300370','0000300370','OH00001145276','IL','1','Ware','Mary','','','','34','296561817','1035 S KEMP RD',0,'LIMA','OH','45806','9342','CY','39003','1954-12-22','F','M',':RET:2106-3','N','021','HLT','1222030','92036OH004001501','2014-01-01','2013-11-22 09:46:06','457.28',NULL,NULL,'460.65','3.37','R-OH002','OH0','460.65',NULL,0,'2013-12-26 03:16:21'),(4378,3479,'Y','18','021','EC','A','','','AC','0000896965','0000896965','OH00000899655','IL','1','Gonzalez','Nico','','','','34','361547771','11983 Olde Dominion Drive',0,'Cincinnati','OH','45249',NULL,'CY','39061','1976-01-14','M','R',NULL,'N','021','DEN','1086571','99734OH005000401','2014-01-01','2013-12-12 08:34:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:00:31'),(20478,16359,'Y','18','021','EC','A','','','AC','0000062565','0000062565','OH00001457754','IL','1','Somers','Robert','','','','34','299946152','24.5 N WASHINGTON ST',0,'TIFFIN','OH','44883','2321','CY','39147','1992-07-31','M','U',':RET:2106-3','N','021','DEN','3451544','99734OH005000401','2014-03-01','2014-01-29 16:02:25','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-29 21:00:59'),(20492,16371,'Y','18','021','EC','A','','','AC','0002128617','0002128617','LA00001560374','IL','1','evans','shacqueline','','','','34','439698146','3059 syphon st',0,'shreveport','LA','71109',NULL,'CY','22017','1988-02-09','F','U',':RET:2054-5','N','021','DEN','2730277','18575LA002000201','2014-03-01','2014-01-29 05:05:46','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-29 21:01:07'),(21551,17215,'Y','18','021','EC','A','','','AC','0001153650','0001153650','OH00002084902','IL','1','Hurdle','Darnell','','','','34','271682041','1324 JOSEPH ST',0,'CINCINNATI','OH','45237','5912','CY','39061','1960-10-05','F','M',NULL,'N','021','DEN','3183070','99734OH005000401','2014-03-01','2014-02-05 13:45:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:14'),(18107,14463,'Y','18','021','EC','A','','','AC','0001800778','0001800778','LA00002233072','IL','1','Ardoin','Pamela','','','','34','439082886','115 Mireille lane',0,'Raceland','LA','70394',NULL,'CY','22057','1970-11-13','F','U',':RET:2106-3','N','021','DEN','1999470','18575LA002000201','2014-02-01','2014-01-14 17:19:19','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-15 02:07:35'),(15719,12575,'Y','18','021','EC','A','','','AC','0000728723','0000728723','OH00000428385','IL','1','Ivans','Thomas','','','','34','276905592','9150 CAMBRIDGE RD',0,'CHARDON','OH','44024','9621','CY','39055','1986-01-04','M','R',':RET:2106-3','N','021','DEN','1899051','99734OH005000301','2014-02-01','2014-01-02 08:29:54','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:00:09'),(13424,10710,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000171233','','IL','1','Mecklenborg','Rosie','Mae',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2013-11-02','F','',NULL,'N','021','DEN','2321841','99734OH005000301','2014-01-01','2013-12-23 11:34:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:54'),(1528,1273,'Y','18','021','EC','A','','','AC','0001080336','0001080336','OH00001483550','IL','1','Bailey','Cynthia','','','','34','271681938','1193 BISHOP AVE',0,'HAMILTON','OH','45015','2713','CY','39017','1958-12-04','F','M',NULL,'N','021','DEN','2447425','99734OH005000401','2014-01-01','2013-12-24 16:00:44','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:56'),(15080,12053,'Y','18','021','EC','A','','','AC','0001005576','0001005576','TX00001657606','IL','1','NEWTON','DENISE','','','','34','187462240','4305 FAIRWAY DR',0,'GRANBURY','TX','76049','5109','CY','48221','1956-02-06','F','U',':RET:2106-3','N','021','DEN','1914716','33348TX002000101','2014-02-01','2013-12-30 09:17:11','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-01 12:04:07'),(4366,3468,'Y','18','021','EC','A','','','AC','0000443432','0000443432','OH00001086356','IL','1','Stewart','Katherine','','','','34','290905513','516 QUAIL RUN RD',0,'MIDDLETOWN','OH','45042','3834','CY','39017','1988-10-23','F','U',':RET:2106-3','N','021','DEN','1182874','99734OH005000401','2014-01-01','2013-12-11 19:35:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:00:10'),(3046,2446,'N','01','021','EC','A',NULL,NULL,'','0000957335','0001205842','','IL','1','White','Laura','Leian','','','34','585922170','707 N 20TH ST',0,'LAMESA','TX','79331','2523','CY','48115','1956-09-06','F','',':RET:2106-3','N','021','DEN','973467','33348TX002000101','2014-01-01','2013-12-05 21:45:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 20:18:46'),(4400,3498,'Y','18','021','EC','A','','','AC','0000787167','0000787167','OH00000968251','31','1','Medley','Justin','Alan','','','34','275907681','Po Box 177',0,'White Cottage','OH','43791',NULL,'CY','39119','1977-10-15','M','U',':RET:2106-3','T','021','DEN','66852','99734OH005000401','2014-01-01','2013-12-12 14:12:07','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:01:08'),(22752,18164,'Y','18','021','EC','A','','','AC','0001627542','0001627542','LA00002183850','31','1','DELANEY','WANDA','','','','34','437961981','PO BOX 13836',0,'ALEXANDRIA','LA','71315',NULL,'CY','22079','1957-05-01','F','U',NULL,'T','021','DEN','3088613','18575LA002000101','2014-03-01','2014-02-11 14:58:33','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-11 21:01:26'),(26619,21106,'Y','18','021','EC','A','','','AC','0000334379','0000334379','TX00002789274','IL','1','WILLINGHAM','NICOLE','','','','34','464199330','1182 COUNTY ROAD 2260',0,'MINEOLA','TX','75773','6434','CY','48499','1965-05-15','F','U',':RET:2106-3','N','021','DEN','2996641','33348TX002000201','2014-04-01','2014-02-28 11:47:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:51'),(27089,21446,'Y','18','021','EC','A','','','AC','0000581554','0000581554','OH00003674380','IL','1','Dugger','Robert','','','','34','270503432','3316 BATH HEIGHTS DR',0,'CUYAHOGA FALLS','OH','44223','3756','CY','39153','1950-07-08','M','M',NULL,'N','021','HLT','3401943','52664OH151001305','2014-04-01','2014-03-03 12:38:59','1072.00',NULL,NULL,'1284.97','212.97','R-OH012','OH0','658.32',NULL,0,'2014-03-03 21:30:16'),(28415,22483,'Y','18','021','EC','A','','','AC','0000541709','0000541709','OH00003308761','IL','1','loiselle','michael','','','','34','037462847','1300 w 93rd st',0,'cleveland','OH','44102',NULL,'CY','39035','1968-06-25','M','U',':RET:2106-3','N','021','DEN','3640243','99734OH005000401','2014-04-01','2014-03-07 12:13:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:59'),(18411,14688,'Y','18','021','EC','A','','','AC','0001326499','0001326499','LA00002413688','IL','1','Obrien','Patrick','','','','34','436270380','325 E Boston St.',0,'Covington','LA','70433',NULL,'CY','22103','1961-08-14','M','U',':RET:2106-3','N','021','DEN','2224940','18575LA002000201','2014-02-01','2014-01-14 19:36:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:47'),(9067,7196,'Y','18','021','EC','A','','','AC','0000145657','0000145657','TX00000916807','IL','1','CALZADA','MARIA','DE  VE LOS ANGELES','','','34','622993068','11801 GARDEN GROVE DR',0,'AUSTIN','TX','78725','6316','CY','48453','1968-03-18','F','U',NULL,'N','021','DEN','1684458','33348TX002000101','2014-01-01','2013-12-18 16:54:36','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 04:06:30'),(1669,1394,'Y','18','021','EC','A','','','AC','0001044077','0001044077','TX00000140709','IL','1','granger','ashley','','','','34','627056754','2652 BISHOP ALLEN LN',0,'DALLAS','TX','75237','3643','CY','48113','1986-06-06','F','R',':RET:2054-5','N','021','DEN','2612218','33348TX002000201','2014-01-01','2013-12-24 17:58:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:53:50'),(15995,12802,'Y','18','021','EC','A','','','AC','0001184944','0001184944','TX00001843551','IL','1','McGee','John','','','','34','459939691','555 COUNTY ROAD 4315',0,'Omaha','TX','75571',NULL,'CY','48449','1976-02-01','M','M',':RET:2106-3','T','021','DEN','2133736','33348TX002000201','2014-02-01','2014-01-03 13:53:32','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:20'),(2760,2232,'Y','18','021','EC','A','','','AC','0000149316','0000149316','OH00000454371','IL','1','CALKINS','MAXINE','MARIE','','','34','298785097','4709 W 158TH ST',0,'CLEVELAND','OH','44135','2607','CY','39035','1979-05-24','F','U',':RET:2106-3','N','021','HLT','185779','52664OH151001301','2014-01-01','2013-12-02 17:14:05','0.00',NULL,NULL,'305.34','305.34','R-OH011','OH0','305.34',NULL,0,'2013-12-25 19:49:17'),(15416,12332,'Y','18','021','EC','A','','','AC','0000278983','0000278983','TX00001812116','IL','1','Cervantes Ramos','Marcos','','','','34','463829275','414 W 4TH ST',0,'BISHOP','TX','78343','2141','CY','48355','1951-03-06','M','U',':RET:2106-3','N','021','DEN','2066114','33348TX002000201','2014-02-01','2013-12-31 08:07:30','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2014-01-02 04:27:18'),(15358,12283,'N','01','021','EC','A',NULL,NULL,'','0000377471','0000427644','','IL','1','Toalston','Laura','L','','','34','304948550','5069 Apollo Rd NE',0,'Salineville','OH','43945',NULL,'CY','39019','1973-09-24','F','',':RET:2106-3','N','021','DEN','1934105','99734OH005000301','2014-02-01','2013-12-31 23:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:24:42'),(14579,11634,'Y','18','021','EC','A','','','AC','0001942233','0001942233','LA00001466529','IL','1','BENTLEY','NORMAN','','','','34','403766085','524 ESTEBAN ST',0,'ARABI','LA','70032','1141','CY','22087','1952-01-22','M','U',':RET:2106-3','N','021','DEN','2081234','18575LA002000101','2014-02-01','2013-12-27 14:15:28','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-28 03:35:47'),(6678,5297,'Y','18','021','EC','A','','','AC','0001069294','0001069294','OH00000868750','IL','1','Wright','John','','','','34','270485030','3820 TOWNSEND ANGLING RD',0,'COLLINS','OH','44826','9761','CY','39077','1951-01-10','M','U',':RET:2106-3','N','021','HLT','669565','92036OH002002701','2014-01-01','2013-11-16 14:55:34','0.00',NULL,NULL,'1233.13','1233.13','R-OH006','OH0','646.96',NULL,0,'2013-12-26 01:01:18'),(5805,4611,'Y','18','021','EC','A','','','AC','0000673510','0000673510','TX00000180133','IL','1','Sturdivant','Johnny','Edward','','','34','463191729','585 TEXAS ST',0,'AVERY','TX','75554','9787','CY','48387','1959-09-02','M','U',':RET:2106-3','T','021','DEN','1502112','33348TX002000201','2014-01-01','2013-12-23 21:17:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:47:36'),(7081,5618,'Y','18','021','EC','A','','','AC','0000995440','0000995440','OH00000145560','IL','1','Epple','Colette','','','','34','292749273','2880 CLARKSON RD',0,'CLEVELAND','OH','44118','2819','CY','39035','1972-10-06','F','M',NULL,'N','021','DEN','1999008','99734OH005000301','2014-02-01','2013-12-25 00:46:43','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:50:18'),(20086,16024,'Y','18','024','14','A','','','TE','0001021388','0001021388','','IL','1','Malbrough','Brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-04-08','M','',NULL,NULL,NULL,'','1233783','','2014-01-27','2014-01-27 14:32:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:26'),(20621,16478,'N','01','021','EC','A',NULL,NULL,'','0002031695','0002088458','','IL','1','Boyet','RaiSonja','Gail','','','34','407233322','630 S PLEASANT AVE',0,'GONZALES','LA','70737','3424','CY','22005','1967-10-27','F','',':RET:2054-5','N','021','DEN','2842561','18575LA002000101','2014-03-01','2014-01-30 17:20:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-30 21:00:23'),(21977,17550,'N','01','021','EC','A',NULL,NULL,'','0002235421','0001795885','','IL','1','Chocon','Maria','','','','34','662126218','1010 LAKE AVE',0,'METAIRIE','LA','70005','2565','CY','22051','1961-06-12','F','',NULL,'N','021','DEN','3841776','18575LA002000101','2014-03-01','2014-02-06 18:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-07 19:00:34'),(25050,19865,'N','19','021','EC','A',NULL,NULL,'','0000542737','0001015630','','S1','1','Williams','Christy','A','','','34','289063647','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','2001-10-22','M','',':RET:2106-3','N','021','DEN','3426767','99734OH005000401','2014-04-01','2014-02-19 22:05:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:01:16'),(19945,15908,'Y','18','021','EC','A','','','AC','0001258686','0001258686','OH00002553730','IL','1','Craft','Patsy','','','','34','296489732','6100 Hursh Road',0,'Middletown','OH','45042',NULL,'CY','39017','1950-03-01','F','M',':RET:2106-3','N','021','HLT','3036326','92036OH002001201','2014-03-01','2014-01-24 10:42:02','335.00',NULL,NULL,'743.71','408.71','R-OH004','OH0','743.71',NULL,0,'2014-01-24 21:01:17'),(18090,14449,'Y','18','021','EC','A','','','AC','0002253943','0002253943','LA00002594306','31','1','COMEAUX','JERRY','','','','34','439868324','PO BOX 54',0,'RHINEHEART','LA','71363',NULL,'CY','22025','1951-11-22','F','U',':RET:2054-5','N','021','DEN','1934440','18575LA002000201','2014-02-01','2014-01-14 12:19:39','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-15 02:07:30'),(468,381,'N','19','021','EC','A',NULL,NULL,'','0000626707','0000759682','','IL','1','Currier','Jordan','','','','34','287043285','279 COUNTY ROAD 40',0,'SULLIVAN','OH','44880','9731','CY','39005','1999-09-16','M','',':RET:2106-3','N','021','HLT','476605','52664OH151001301','2014-01-01','2013-12-04 10:57:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 17:47:47'),(16858,13488,'Y','18','021','EC','A','','','AC','0000074007','0000074007','TX00001801877','IL','1','Lynum','Edwin','Jerome','','','34','457945411','1621 VISTA REAL DR',0,'EL PASO','TX','79935','3412','CY','48141','1953-08-06','M','U',':RET:2054-5','N','021','DEN','1902667','33348TX002000201','2014-02-01','2014-01-08 20:03:35','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:19:08'),(13019,10377,'Y','18','021','EC','A','','','AC','0000929837','0000929837','OH00001189531','IL','1','Basinger','Joshua','','','','34','295820319','3251 Shoal Creek Ln',0,'Hilliard','OH','43026',NULL,'CY','39049','1985-03-26','M','U',':RET:2106-3','N','021','DEN','2336028','99734OH005000401','2014-01-01','2013-12-22 20:38:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:49:59'),(16210,12980,'Y','18','021','EC','A','','','AC','0000239659','0000239659','TX00001705338','IL','1','Jackson','Maya','','','','34','570917282','1401 GLADIOLUS ST',0,'WICHITA FALLS','TX','76301','1408','CY','48485','1978-07-27','F','U',':RET:2054-5','T','021','DEN','2418122','33348TX002000201','2014-02-01','2014-01-04 17:15:20','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-05 00:01:27'),(1709,1428,'Y','18','021','EC','A','','','AC','0000314703','0000314703','OH00000632328','IL','1','Knippen','Shannon','','','','34','302747886','26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','1975-07-16','F','M',':RET:2106-3','N','021','HLT','1693316','92036OH003001501','2014-01-01','2013-12-24 07:56:06','447.00',NULL,NULL,'1021.76','574.76','R-OH002','OH0','286.39',NULL,0,'2013-12-25 18:54:59'),(6957,5525,'Y','18','021','EC','A','','','AC','0000093853','0000093853','OH00000961482','IL','1','MURPHY','TERRY','','','','34','294624880','4030 BELMORE TRACE',0,'DAYTON','OH','45426',NULL,'CY','39113','1963-06-30','M','M',':RET:2054-5','N','021','DEN','1504748','99734OH005000401','2014-01-01','2013-12-24 22:17:32','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:47:12'),(15520,12417,'Y','18','021','EC','A','','','AC','0002034153','0002034153','LA00000025806','IL','1','Nhan','Mann','','','','34','580181821','9801 HEARTHSIDE CIR',0,'SHREVEPORT','LA','71118','4830','CY','22017','1968-01-20','M','M',NULL,'N','021','DEN','2364926','18575LA002000201','2014-02-01','2013-12-30 19:44:56','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,1,'2014-01-02 04:30:18'),(3974,3175,'Y','18','021','EC','A','','','AC','0000807479','0000807479','OH00000866999','IL','1','Roberts','Jimmy','','','','34','293561213','1960 STATE ROUTE 73',0,'HILLSBORO','OH','45133','5817','CY','39071','1955-10-19','M','M',':RET:2106-3','N','021','HLT','748426','92036OH004000601','2014-01-01','2013-12-13 13:38:44','436.59',NULL,NULL,'439.81','3.22','R-OH005','OH0','439.81',NULL,0,'2013-12-25 21:38:39'),(4886,3875,'N','01','021','EC','A',NULL,NULL,'','0000025403','0000024358','','IL','1','Minson','Amy','D','','','34','434733008','9989 WILCOX ST',0,'SAINT FRANCISVILLE','LA','70775','4407','CY','22125','1988-10-19','F','',NULL,'N','021','DEN','434517','18575LA002000201','2014-01-01','2013-10-04 12:59:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:31:23'),(15880,12716,'Y','18','021','EC','A','','','AC','0002215761','0002215761','LA00001847157','IL','1','Bailey-Coleman','Karen','','','','34','436171721','7431 BULLARD AVE',0,'NEW ORLEANS','LA','70128','2313','CY','22071','1959-01-28','F','M',':RET:2054-5','N','021','DEN','2217344','18575LA002000101','2014-02-01','2014-01-02 18:02:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-03 02:05:23'),(13690,10924,'Y','18','021','EC','A','','','AC','0000762291','0000762291','OH00000167092','IL','1','Eckel','Caleb','','','','34','108744773','793 LENOX NEW LYME RD',0,'JEFFERSON','OH','44047','9570','CY','39007','1988-10-20','M','M',':RET:2034-7^:RET:2106-3','N','021','HLT','1839254','52664OH151001304','2014-01-01','2013-12-23 10:55:56','322.00',NULL,NULL,'510.09','188.09','R-OH011','OH0','252.53',NULL,0,'2013-12-26 13:08:27'),(7589,6004,'Y','18','021','EC','A','','','AC','0000680803','0000680803','OH00001126965','IL','1','Rock Higgins','Lisa','Ann','','','34','302582020','4023 HARDIN RD',0,'RAVENNA','OH','44266','9313','CY','39133','1971-06-20','F','M',':RET:2106-3','N','021','DEN','600923','99734OH005000401','2014-01-01','2013-11-16 19:33:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:45:05'),(7277,5771,'Y','18','021','EC','A','','','AC','0000848268','0000848268','TX00000456063','IL','1','PHILLIPS','CECELIA','ANN','','','34','458904645','2402 ROCKIN SEVEN DR',0,'HOCKLEY','TX','77447',NULL,'CY','48201','1952-07-31','F','U',':RET:2054-5','N','021','DEN','855419','33348TX002000201','2014-01-01','2013-12-14 16:41:44','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:02:35'),(19134,15246,'Y','18','021','EC','A','','','AC','0001010379','0001010379','TX00002168925','IL','1','nunez','bertha','','','','34','585029265','2945 S AMISTAD AVE',0,'ODESSA','TX','79766','8812','CY','48135','1956-05-29','F','U',':RET:2106-3','N','021','DEN','2859424','33348TX002000201','2014-03-01','2014-01-18 18:15:46','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-21 08:45:26'),(19274,15362,'Y','18','021','EC','A','','','AC','0001069345','0001069345','OH00001454212','IL','1','ALTMAN','JO ANN','','','','34','283640942','518 MADISON AVE',0,'FINDLAY','OH','45840','3728','CY','39063','1961-05-04','F','U',NULL,'T','021','HLT','2044080','92036OH005001506','2014-03-01','2014-01-20 13:05:51','400.00',NULL,NULL,'494.04','94.04','R-OH002','OH0','494.04',NULL,0,'2014-01-21 08:46:56'),(20102,16038,'N','01','021','EC','A',NULL,NULL,'','0001451369','0002226637','','IL','1','Harley','Cheryl','L','','','34','436882404','13005 BETHANY STATE LINE RD',0,'BETHANY','LA','71007','9768','CY','22017','1952-08-31','F','',':RET:2106-3','T','021','DEN','2979951','18575LA002000201','2014-03-01','2014-01-27 13:24:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-27 21:00:36'),(24343,19332,'Y','18','021','EC','A','','','AC','0000205694','0000205694','TX00002460469','IL','1','MALOOLY','MARY','','','','34','462231050','4109 HAMPSHIRE ST',0,'PLANO','TX','75093','6041','CY','48085','1962-06-04','F','U',NULL,'N','021','DEN','3122317','33348TX002000201','2014-04-01','2014-02-18 16:02:21','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-18 22:00:21'),(26007,20626,'Y','18','021','EC','A','','','AC','0000643282','0000643282','OH00001823517','IL','1','ST MYER','CATHY','J','','','34','297567747','1812 E ELM ST',0,'LIMA','OH','45804','3026','CY','39003','1964-11-11','F','U',NULL,'N','021','HLT','2752434','92036OH005001505','2014-03-01','2014-02-26 09:56:05','288.00',NULL,NULL,'375.47','87.47','R-OH002','OH0','375.47',NULL,0,'2014-02-26 21:02:07'),(26459,20986,'Y','18','021','EC','A','','','AC','0000923227','0000923227','LA00002593926','IL','1','Casby','Fred','','','','34','433113802','6108 Singleton Dr.',0,'Marrero','LA','70072',NULL,'CY','22051','1958-02-14','M','U',':RET:2054-5','N','021','DEN','2843209','18575LA002000201','2014-04-01','2014-02-27 10:37:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-28 07:30:29'),(27395,21688,'Y','18','021','EC','A','','','AC','0000435363','0000435363','OH00002724871','IL','1','Kirkbride','Valli','F','','','34','290526103','48 Beechrock Drive',0,'Zanesville','OH','43701',NULL,'CY','39119','1951-11-21','F','U',':RET:2106-3','N','021','DEN','3469993','99734OH005000301','2014-04-01','2014-03-03 21:31:17','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-03-04 21:01:28'),(27487,21751,'N','19','021','EC','A',NULL,NULL,'','0000891866','0000394989','','IL','1','PHILLIPS','SIERRA','','','','34','270989608','539 LLOYD ST',0,'BARBERTON','OH','44203',NULL,'CY','39153','1994-11-10','F','',':RET:2106-3','N','021','HLT','3953584','52664OH151001304','2014-04-01','2014-03-04 10:48:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-04 21:02:21'),(722,597,'Y','18','021','EC','A','','','AC','0000289136','0000289136','TX00001043116','IL','1','alcala','elsa','','','','34','464336555','2800 veterans 106',0,'del rio','TX','78840',NULL,'CY','48465','1962-06-22','F','M',NULL,'N','021','DEN','2424958','33348TX002000101','2014-01-01','2013-12-16 10:38:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:03:29'),(13443,10720,'N','19','021','EC','A',NULL,NULL,'','0000279552','0000294407','','IL','1','STROUD','FELICITY','','','','34','293967142','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','1993-11-20','F','',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:17'),(2830,2286,'N','01','021','EC','A',NULL,NULL,'','0000464421','0000879180','','IL','1','durnin','carolyn','b','','','34','434064310','61326 n military rd',0,'slidell','LA','70461',NULL,'CY','22103','1957-03-08','F','',':RET:2106-3','N','021','DEN','796852','18575LA002000201','2014-01-01','2013-11-24 10:58:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:00:44'),(6193,4907,'Y','18','024','14','A','','','TE','0000844554','0000844554','','IL','1','Churchill','Dale',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-12','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-23 02:41:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:30:23'),(7083,5619,'Y','18','021','EC','A','','','AC','0000312193','0000312193','OH00001642263','IL','1','Seals','Rita','','','','34','276580156','2741 BAKER ST',0,'COOLVILLE','OH','45723','8149','CY','39009','1955-08-10','F','M',':RET:2106-3','N','021','DEN','1701063','99734OH005000301','2014-02-01','2013-12-25 15:30:01','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-26 01:50:20'),(3595,2883,'Y','18','021','EC','A','','','AC','0000124201','0000124201','OH00001188201','IL','1','Hall','William','','','','34','280668380','8421 COX RD',0,'WEST CHESTER','OH','45069','3339','CY','39017','1966-02-13','M','M',':RET:2106-3','N','021','HLT','1679769','92036OH001001201','2014-01-01','2013-12-22 15:31:27','268.00',NULL,NULL,'747.83','479.83','R-OH004','OH0','404.73',NULL,0,'2013-12-25 21:23:06'),(6251,4953,'N','01','021','EC','A',NULL,NULL,'','0001200858','0000362467','','IL','1','HUMPHREY','MELVIN','RAY','','','34','282769354','20545 STATE ROUTE 247',0,'SEAMAN','OH','45679',NULL,'CY','39001','1968-10-21','M','',':RET:2106-3','N','021','HLT','931025','92036OH005000605','2014-01-01','2013-11-18 19:46:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','309.99',NULL,0,'2013-12-26 00:31:57'),(20793,16614,'Y','18','021','EC','A','','','AC','0000381648','0000381648','TX00002047909','IL','1','LE','PHONG','','','','34','187704048','4844 FM 39 N',0,'MEXIA','TX','76667','5022','CY','48293','1967-08-10','M','M',':RET:2047-9','N','021','DEN','1990797','33348TX002000201','2014-03-01','2014-01-31 10:45:28','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-31 21:00:16'),(24425,19403,'Y','18','021','EC','A','','','AC','0000815378','0000815378','OH00002045614','IL','1','Sebe','Paul','','','','34','285828552','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','1969-09-11','M','M',':RET:2106-3','N','021','HLT','3372930','52664OH151001301','2014-04-01','2014-02-18 08:47:51','171.00',NULL,NULL,'764.69','593.69','R-OH014','OH0','311.54',NULL,0,'2014-02-18 22:01:11'),(26039,20651,'Y','18','021','EC','A','','','AC','0001071839','0001071839','OH00001928154','IL','1','burkey','theodore','g','','Jr','34','288560417','15239 GATES ST',0,'DOYLESTOWN','OH','44230','9591','CY','39169','1955-02-15','M','U',':RET:2106-3','T','021','HLT','3620929','52664OH151001304','2014-03-01','2014-02-26 12:18:19','415.00',NULL,NULL,'667.56','252.56','R-OH014','OH0','667.56',NULL,0,'2014-02-26 21:02:26'),(28748,22754,'Y','18','021','EC','A','','','AC','0000663338','0000663338','TX00002750539','IL','1','dang','hoai','dinh','','','34','733092526','700 CARVER AVE',0,'ODESSA','TX','79761','7115','CY','48135','1984-04-05','M','M',':RET:2047-9','N','021','DEN','3952721','33348TX002000201','2014-04-01','2014-03-08 23:31:19','0.00',NULL,NULL,'29.22','29.22','R-TX017','TX0','14.61',NULL,0,'2014-03-09 21:00:15'),(18593,14824,'Y','18','021','EC','A','','','AC','0000878283','0000878283','OH00001896606','IL','1','OKUMU','GEOFFREY','','','','34','284116122','707 6TH ST',0,'BOWLING GREEN','OH','43402','4152','CY','39173','1989-04-24','M','M',NULL,'N','021','HLT','2492550','92036OH004002601','2014-02-01','2014-01-15 10:35:29','217.00',NULL,NULL,'314.21','97.21','R-OH001','OH0','156.79',NULL,0,'2014-01-16 08:47:15'),(9228,7322,'N','01','021','EC','A',NULL,NULL,'','0000374696','0000798404','','IL','1','ILHARDT','JOHN','','','','34','300545280','1324 LIBBY LN',0,'NEW RICHMOND','OH','45157','9163','CY','39025','1960-12-27','M','',':RET:2106-3','T','021','HLT','2089330','92036OH003000604','2014-01-01','2013-12-18 14:36:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','525.93',NULL,0,'2013-12-26 04:10:24'),(18311,14619,'Y','18','021','EC','A','','','AC','0000790894','0000790894','OH00002123022','IL','1','carare','justine','','','','34','296676988','6100 laurent dr.',0,'herma','OH','44129',NULL,'CY','39035','1964-12-04','F','U',':RET:2106-3','N','021','DEN','1571657','99734OH005000401','2014-02-01','2014-01-15 12:47:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:02'),(15435,12349,'Y','18','021','EC','A','','','AC','0000353078','0000353078','TX00001071716','IL','1','Taylor','melissa','','','','34','452437196','1018 Hickory PO Box 717',0,'Kempner','TX','76539',NULL,'CY','48281','1965-11-29','F','U',':RET:2106-3','T','021','DEN','1555517','33348TX002000201','2014-02-01','2013-12-31 13:09:08','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,1,'2014-01-02 04:27:52'),(3719,2972,'N','01','021','EC','A',NULL,NULL,'','0001165319','0000930893','','IL','1','Anaya','George','Antonio','','','34','279963007','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-21','M','',':RET:2106-3','T','021','DEN','210262','99734OH005000401','2014-01-01','2013-12-13 14:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:19'),(13105,10449,'Y','18','021','EC','A','','','AC','0000049488','0000049488','OH00000420029','IL','1','Bethel','Nicole','','','','34','271760439','1520 ROYAL GOLD DR',0,'COLUMBUS','OH','43240','2094','CY','39041','1974-09-08','F','U',':RET:2054-5','N','021','DEN','2017504','99734OH005000401','2014-01-01','2013-12-23 13:06:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:52:16'),(19067,15189,'Y','18','021','EC','A','','','AC','0000203110','0000203110','OH00001394472','IL','1','Buksdorf','Diana','','','','34','298929498','6613 W BANCROFT ST',0,'TOLEDO','OH','43615','3154','CY','39095','1987-12-16','F','U',':RET:2106-3','N','021','HLT','2893032','92036OH002002601','2014-03-01','2014-01-17 20:00:31','0.00',NULL,NULL,'230.59','230.59','R-OH001','OH0','230.59',NULL,0,'2014-01-21 08:44:18'),(20240,16149,'Y','18','021','EC','A','','','AC','0000453409','0000453409','MS00001427979','IL','1','Jones','Dewayne','','','','34','306807635','23 COUNTY ROAD 119',0,'ABBEVILLE','MS','38601','9773','CY','28071','1976-03-27','M','U',':RET:2054-5','N','021','DEN','1748124','46300MS002000101','2014-03-01','2014-01-28 14:25:57','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-28 21:00:07'),(22039,17593,'Y','18','021','EC','A','','','AC','0001223572','0001223572','MS00001583375','IL','1','Graves','Jacqueline','','','','34','587146850','84 EBENEZER CHURCH RD',0,'BASSFIELD','MS','39421','9588','CY','28091','1951-03-04','F','M',':RET:2054-5','N','021','DEN','3530560','46300MS002000201','2014-03-01','2014-02-07 17:08:10','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-07 19:01:07'),(25272,20051,'Y','18','021','EC','A','','','AC','0001968357','0001968357','LA00002844616','IL','1','goldberg','annette','','','','34','457884833','12575 mansfield road',0,'keithville','LA','71047',NULL,'CY','22017','1949-09-30','F','U',':RET:2106-3','T','021','DEN','2781832','18575LA002000201','2014-04-01','2014-02-25 15:09:24','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61','CIC',0,'2014-02-25 21:00:12'),(27061,21425,'N','01','021','EC','A',NULL,NULL,'','0001207198','0001504490','','IL','1','Estes','Jordan','','','','34','435775742','1817 BURDETTE ST',0,'NEW ORLEANS','LA','70118','4106','CY','22071','1987-05-18','M','',':RET:2106-3','N','021','DEN','3212380','18575LA002000201','2014-04-01','2014-03-03 06:25:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-03 21:29:59'),(16621,13297,'Y','18','021','EC','A','','','AC','0000812039','0000812039','OH00001747084','IL','1','WAWERU','RICHARD','','','','34','010901729','4327 CHESFORD RD',0,'COLUMBUS','OH','43224','1787','CY','39049','1950-09-10','M','M',NULL,'N','021','DEN','2132584','99734OH005000401','2014-02-01','2014-01-07 12:49:10','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:11'),(1353,1121,'Y','18','021','EC','A','','','AC','0000297260','0000297260','TX00000546990','IL','1','Zaccarello','Alice','Angeline','','','34','461921463','2243 LAWNDALE DR',0,'DALLAS','TX','75211','1835','CY','48113','1951-04-27','F','U',':RET:2106-3','N','021','DEN','2592591','33348TX002000101','2014-01-01','2013-12-24 13:11:45','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:45:19'),(15729,12581,'Y','18','021','EC','A','','','AC','0001024283','0001024283','OH00001496420','IL','1','Williams','Rachel','','','','34','285822089','56 BOTNICK PLZ',0,'AKRON','OH','44301','1004','CY','39153','1984-08-07','F','U',':RET:2106-3','T','021','DEN','2377759','99734OH005000301','2014-02-01','2014-01-01 20:05:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-03 02:00:26'),(20786,16608,'Y','18','021','EC','A','','','AC','0000984858','0000984858','TX00002008944','IL','1','kennedy','derek','','','','34','636164222','ns 1 lake cherokee',0,'longview','TX','75603',NULL,'CY','48183','1990-04-04','M','U',':RET:2106-3','N','021','DEN','3352320','33348TX002000201','2014-03-01','2014-01-30 23:01:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-31 21:00:13'),(23322,18587,'Y','18','021','EC','A','','','AC','0000961898','0000961898','OH00001588201','IL','1','Wertz','Donald','G','','Jr','34','293567497','50 COLUMBUS ST',0,'BEDFORD','OH','44146','2819','CY','39035','1955-07-07','M','M',':RET:2106-3','N','021','DEN','2843952','99734OH005000301','2014-03-01','2014-02-13 13:42:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:25'),(25196,19987,'Y','18','021','EC','A','','','AC','0002274869','0002274869','LA00002528936','IL','1','Parent','Sheryl','','','','34','587384727','12306 JOHN LAMBERT RD',0,'GONZALES','LA','70737','1910','CY','22005','1952-09-14','F','M',':RET:2106-3','N','021','DEN','2691133','18575LA002000201','2014-04-01','2014-02-21 11:49:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-21 22:00:43'),(25820,20473,'Y','18','021','EC','A','','','AC','0000172472','0000172472','OH00002744223','IL','1','DOZIER','LONI','','','','34','300840798','12088 GOODFIELD CT',0,'CINCINNATI','OH','45240','1112','CY','39061','1986-12-10','F','U',':RET:2106-3','N','021','DEN','3769312','99734OH005000301','2014-04-01','2014-02-26 16:07:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:25'),(28283,22380,'N','01','021','EC','A',NULL,NULL,'','0000019532','0000693415','','IL','1','Promoslovsky','Fernando','M','','','34','663055885','2404 JENA ST',0,'NEW ORLEANS','LA','70115','5908','CY','22071','1975-06-03','M','',':RET:2106-3','N','021','DEN','3921794','18575LA002000201','2014-04-01','2014-03-07 09:57:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-03-07 21:00:25'),(29062,23002,'Y','18','021','EC','A','','','AC','0000923383','0000923383','OH00003182810','IL','1','WARREN','SHYNIQUE',NULL,NULL,NULL,NULL,NULL,'4045 ASBURY DR',0,'TOLEDO','OH','43612','1801','CY','39095','1992-08-11','F','U',NULL,'N','021','HLT','4258712','92036OH004002601','2014-04-01','2014-03-09 21:04:17','150.00',NULL,NULL,'156.79','6.79','R-OH001','OH0','156.79',NULL,0,'2014-03-10 21:01:53'),(8940,7089,'Y','18','021','EC','A','','','AC','0001166800','0001166800','OH00001246845','IL','1','Bizzarri','Camille','','','','34','566759445','6845 WINDWARD ST',0,'CINCINNATI','OH','45227','2617','CY','39061','1983-05-25','F','U',':RET:2106-3','N','021','DEN','1758969','99734OH005000401','2014-01-01','2013-12-18 10:50:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:18'),(9124,7236,'N','01','021','EC','A',NULL,NULL,'','0000323491','0000615501','','IL','1','Torres','Efrain','','','','34','583277940','7973 SCHOOL HOUSE LN',0,'MONTGOMERY','OH','45242','5928','CY','39061','1963-03-15','M','',NULL,'N','021','DEN','1795337','99734OH005000301','2014-01-01','2013-12-18 18:04:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:49'),(2717,2197,'N','01','021','EC','A',NULL,NULL,'','0000803372','0000154879','','IL','1','Toups','Isaac','Jacob','','','34','434594857','2231 CONSTANCE ST',0,'NEW ORLEANS','LA','70130','5541','CY','22071','1979-06-17','M','',':RET:2106-3','N','021','DEN','873329','18575LA002000201','2014-01-01','2013-12-01 18:55:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:48:06'),(5680,4507,'Y','18','021','EC','A','','','AC','0000062504','0000062504','OH00001082139','IL','1','Carter','Barbara','','','','34','292427425','10107 Will Allman Rd',0,'Georgetown','OH','45121',NULL,'CY','39015','1956-07-10','F','M',NULL,'N','021','HLT','467816','92036OH004000601','2014-01-01','2013-11-26 11:42:10','175.00',NULL,NULL,'420.66','245.66','R-OH005','OH0','420.66',NULL,0,'2013-12-25 23:32:18'),(4459,3544,'Y','18','021','EC','A','','','AC','0000575896','0000575896','OH00000033491','IL','1','Warren','Edward','Gerard','','','34','289620801','1410 Springfield Pike',0,'Wyoming','OH','45215',NULL,'CY','39061','1959-12-27','M','U',':RET:2054-5','N','021','DEN','986308','99734OH005000301','2014-01-01','2013-12-12 12:01:05','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:02:36'),(19218,15312,'Y','18','021','EC','A','','','AC','0001043420','0001043420','OH00002431348','IL','1','ROWLAND','TRISHA','','','','34','289702654','2300 EL CID DR',0,'BEAVERCREEK','OH','45431',NULL,'CY','39057','1967-08-06','F','U',':RET:2106-3','N','021','DEN','2191582','99734OH005000401','2014-03-01','2014-01-20 12:54:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-21 08:46:25'),(19257,15346,'Y','18','021','EC','A','','','AC','0002350985','0002350985','LA00002322823','IL','1','Villegas','Ronald','','','','34','545433579','115 Vallette St.',0,'New Orleans','LA','70114',NULL,'CY','22071','1975-09-05','M','U',':RET:2036-2','N','021','DEN','1887904','18575LA002000201','2014-03-01','2014-01-20 13:10:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:46:47'),(21037,16808,'N','01','021','EC','A',NULL,NULL,'','0001074183','0000849463','','IL','1','Paisley','Mary','B','','','34','273529777','313 N FREEDOM ST',0,'RAVENNA','OH','44266','2448','CY','39133','1957-07-20','F','',':RET:2106-3','N','021','HLT','2649746','52664OH152000901','2014-03-01','2014-02-01 07:57:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','381.07',NULL,0,'2014-02-01 19:00:48'),(21823,17427,'N','19','021','EC','A',NULL,NULL,'','0000825672','0000626304','','IL','1','Blackmon','Jace','','','','34','274976084','15994 COUNTY ROAD 3138',0,'LINDALE','TX','75771','7358','CY','48423','2013-11-26','M','',':RET:2106-3','N','021','DEN','3697795','33348TX002000101','2014-03-01','2014-02-06 09:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-02-06 21:01:01'),(22359,17855,'N','01','021','EC','A',NULL,NULL,'','0000948462','0000911802','','IL','1','TUZZEO','LISA','','','','34','288723020','115 HIGHLAND MIST CIR',0,'HINCKLEY','OH','44233','9354','CY','39103','1964-05-25','F','',':RET:2106-3','N','021','DEN','3504412','99734OH005000401','2014-03-01','2014-02-10 10:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-10 21:00:06'),(23991,19076,'Y','18','021','EC','A','','','AC','0001869509','0001869509','LA00001653952','IL','1','McCray','Charles','','','','34','227960375','22203 ROLLING ACRES DR',0,'DENHAM SPRINGS','LA','70726','7308','CY','22063','1961-04-18','M','M',':RET:2106-3','T','021','DEN','3409382','18575LA002000201','2014-03-01','2014-02-15 14:57:48','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-15 22:00:26'),(17478,13974,'Y','18','021','EC','A','','','AC','0000911003','0000911003','TX00001871224','IL','1','MURCER','DEBRA','ELIZABETH','','','34','449394149','606 SHADY DR W',0,'KERRVILLE','TX','78028','5129','CY','48265','1960-06-23','F','U',':RET:2106-3','N','021','DEN','1934359','33348TX002000201','2014-02-01','2014-01-12 12:24:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 03:01:11'),(16799,13437,'Y','18','021','EC','A','','','AC','0001122206','0001122206','TX00002468819','IL','1','DIAZ','MARIA','ROSARIO','','','34','629908210','8907 NORTON ST',0,'EL PASO','TX','79904','1324','CY','48141','1958-12-20','F','U',NULL,'N','021','DEN','1973718','33348TX002000201','2014-02-01','2014-01-11 10:25:48','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:18:10'),(15148,12107,'Y','18','021','EC','A','','','AC','0001163849','0001163849','OH00001648956','IL','1','KORNEGAY','SHARRON','','','','34','577764413','2605 BERWICK BLVD',0,'COLUMBUS','OH','43209',NULL,'CY','39049','1954-03-09','F','U',NULL,'N','021','DEN','1703804','99734OH005000401','2014-02-01','2013-12-30 12:04:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:05:58'),(15073,12048,'N','01','021','EC','A',NULL,NULL,'','0000167611','0000562920','','IL','1','HOEFER','JAMES','ANTHONY','','','34','452921428','3153 SILVERTON DR',0,'DALLAS','TX','75229','3753','CY','48113','1951-10-24','M','',NULL,'N','021','DEN','1902424','33348TX002000101','2014-02-01','2013-12-29 19:14:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-01 12:03:57'),(21416,17117,'Y','18','024','14','A','','','TE','0001183547','0001183547','','IL','1','Greer','Dustin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-27','M','',NULL,NULL,NULL,'','1651645','','2014-02-03','2014-02-03 22:12:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:10'),(28727,22735,'Y','18','021','EC','A','','','AC','0001700543','0001700543','LA00003727534','31','1','MOORE','CATHERINE','','','','34','434962789','PO BOX 464',0,'VIOLET','LA','70092',NULL,'CY','22087','1952-12-25','F','U',':RET:2054-5','N','021','DEN','3526247','18575LA002000101','2014-04-01','2014-03-08 22:44:04','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-09 21:00:00'),(29081,23017,'Y','18','021','EC','A','','','AC','0000612882','0000612882','MS00002956093','IL','1','Tarzi','Robert','','','','34','587680300','1639 herrin st.',0,'clarksdale','MS','38614',NULL,'CY','28027','1954-06-25','M','U',':RET:2106-3','N','021','DEN','3441394','46300MS002000101','2014-04-01','2014-03-10 15:04:49','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-10 21:02:03'),(19119,15233,'Y','18','021','EC','A','','','AC','0001853942','0001853942','LA00001706806','IL','1','keller','erin','','','','34','434694458','42554 pumpkin center road',0,'hammond','LA','70403',NULL,'CY','22105','1986-04-04','F','U',NULL,'N','021','DEN','2769406','18575LA002000101','2014-03-01','2014-01-19 13:36:13','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-21 08:45:16'),(13539,10795,'Y','18','021','EC','A','','','AC','0001168528','0001168528','LA00001177679','IL','1','LOUIS','BERROUET','','','','34','437938909','4409 VIXEN ST',0,'NEW ORLEANS','LA','70131','5151','CY','22071','1972-08-01','M','M',':RET:2054-5','T','021','DEN','1717399','18575LA002000201','2014-01-01','2013-12-23 13:11:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:43'),(4262,3396,'Y','18','021','EC','A','','','AC','0000603347','0000603347','OH00001126054','IL','1','Gabel','Victoria','','','','34','294562193','130 CLEARWATER DR',0,'BRUNSWICK','OH','44212','1534','CY','39103','1956-11-19','F','U',':RET:2106-3','N','021','HLT','2295668','52664OH151001501','2014-01-01','2013-12-17 13:14:57','340.00',NULL,NULL,'651.81','311.81','R-OH012','OH0','651.81',NULL,0,'2013-12-25 21:51:33'),(5557,4411,'Y','18','021','EC','A','','','AC','0000428999','0000428999','OH00000732666','31','1','Bencar','Chris','','','','34','272909722','PO Box 593',0,'geneva','OH','44041',NULL,'CY','39007','1988-11-18','M','U',':RET:2106-3','N','021','HLT','330390','52664OH152001001','2014-01-01','2013-11-27 12:23:52','0.00',NULL,NULL,'138.84','138.84','R-OH011','OH0','138.84',NULL,0,'2013-12-25 23:16:19'),(2676,2168,'N','01','021','EC','A',NULL,NULL,'','0000280804','0000518370','','IL','1','sickles','kody','','','Sr','34','282943346','1700 WOODWARD AVE',0,'SPRINGFIELD','OH','45506','3147','CY','39023','1989-06-27','M','',':RET:2106-3','T','021','DEN','697055','99734OH005000301','2014-01-01','2013-12-02 15:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:07'),(21913,17500,'N','01','021','EC','A',NULL,NULL,'','0000669217','0000656968','','IL','1','Page','Remy','L','','','34','062664937','7240 CAVE RD',0,'BAINBRIDGE','OH','45612','9536','CY','39071','1981-05-07','M','',':RET:2106-3','N','021','HLT','2889524','92036OH003000605','2014-03-01','2014-02-06 15:55:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.21','CIC',0,'2014-02-06 21:30:03'),(22560,18017,'Y','18','024','14','A','','','TE','0000021421','0000021421','','IL','1','LONG','DORIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-03-01','F','',NULL,NULL,NULL,'','3246413','','2014-02-10','2014-02-10 12:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:51'),(26063,20669,'N','19','021','EC','A',NULL,NULL,'','0000182350','0000816477','','IL','1','alsept','spencer','morgan','','','34','292130289','1548 WONDERLICK RD',0,'LIMA','OH','45805','3936','CY','39003','2008-01-10','M','',':RET:2054-5^:RET:2106-3','N','021','HLT','3273127','92036OH002001501','2014-03-01','2014-02-26 12:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2014-02-26 21:02:40'),(26089,20690,'Y','18','021','EC','A','','','AC','0002285040','0002285040','LA00003258855','IL','1','Hamlett','Shannon','','','','34','436359211','134 ASHLAND CT',0,'LAFAYETTE','LA','70508','5372','CY','22055','1969-08-06','F','U',NULL,'N','021','DEN','3091268','18575LA002000201','2014-04-01','2014-02-27 04:51:56','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-28 06:30:07'),(27457,21730,'Y','18','021','EC','A','','','AC','0000770048','0000770048','OH00003520584','IL','1','Walker','Donald','J','','','34','185381714','5974 Cleveland RD Lot 28',0,'Wooster','OH','44691',NULL,'CY','39169','1951-08-03','M','U',':RET:2106-3','N','021','HLT','3168251','52664OH152000901','2014-04-01','2014-03-04 11:19:58','363.00',NULL,NULL,'469.28','106.28','R-OH014','OH0','469.28',NULL,0,'2014-03-04 21:02:03'),(28983,22939,'N','01','021','EC','A',NULL,NULL,'','0000615576','0000489313','','IL','1','robinson','carol','i','','','34','296502263','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1953-07-11','F','',':RET:2106-3','N','021','HLT','4101757','52664OH151001306','2014-05-01','2014-03-10 09:41:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2014-03-10 21:01:10'),(17473,13969,'N','01','021','EC','A',NULL,NULL,'','0000268919','0000346916','','IL','1','Saxton','Julie','','','','34','284864613','4287 mahoning rd',0,'Diamond','OH','44412',NULL,'CY','39133','1976-01-04','F','',':RET:2106-3','N','021','DEN','1625084','99734OH005000301','2014-02-01','2014-01-12 16:27:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:08'),(1541,1284,'Y','18','021','EC','A','','','AC','0000482194','0000482194','OH00001353956','IL','1','Crombie','Amy','','','','34','290606051','1139 Obannonville rd',0,'Loveland','OH','45140',NULL,'CY','39025','1971-04-10','F','U',':RET:2106-3','T','021','DEN','2356337','99734OH005000401','2014-01-01','2013-12-24 17:42:08','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:50:18'),(1634,1365,'Y','18','021','EC','A','','','AC','0000988530','0000988530','TX00000360039','IL','1','Muldrew','Shalonda',NULL,NULL,NULL,NULL,NULL,'2110 TEXAS BLVD',0,'TEXARKANA','TX','75501','3866','CY','48037','1973-07-09','F','U',':RET:2054-5','N','021','DEN','1763151','33348TX002000201','2014-01-01','2013-12-24 15:09:07','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 18:52:54'),(1948,1588,'Y','18','021','EC','A','','','AC','0000504358','0000504358','MS00001026761','IL','1','collins','Michaeous','','','','34','592507374','1117 monroe st',0,'jackson','MS','39202',NULL,'CY','28049','1972-06-20','M','U',':RET:2054-5','N','021','DEN','441947','46300MS002000201','2014-01-01','2013-11-19 19:15:14','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 19:00:53'),(15124,12087,'Y','18','021','EC','A','','','AC','0000598761','0000598761','OH00001009943','IL','1','Hannahs','Virgil','','','','34','280847148','160 GRACE AVE',0,'BARNESVILLE','OH','43713','1406','CY','39013','1984-12-02','M','R',':RET:2106-3','N','021','DEN','2363869','99734OH005000301','2014-02-01','2013-12-30 16:42:42','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-01-01 12:05:18'),(13419,10706,'N','01','021','EC','A',NULL,NULL,'','0000432756','0000605957','','IL','1','Williams','Lisa','','','','34','298686032','1687 REBECCA DR',0,'LIMA','OH','45805','1666','CY','39003','1960-01-08','F','',':RET:2106-3','N','021','DEN','1937819','99734OH005000301','2014-01-01','2013-12-23 11:07:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:46'),(3702,2962,'N','01','021','EC','A',NULL,NULL,'','0000240325','0000309418','','IL','1','Williams','Vicki','Ann','','','34','279548447','134 VERMONT AVE',0,'CINCINNATI','OH','45215','2046','CY','39061','1954-08-09','F','',':RET:2106-3','N','021','DEN','608255','99734OH005000401','2014-01-01','2013-12-13 13:19:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:00'),(5733,4550,'Y','18','021','EC','A','','','AC','0001268766','0001268766','LA00000523131','IL','1','Silva','Danny','G','','Jr','34','561150138','31033 IRON KETTLE RD',0,'BUSH','LA','70431','6111','CY','22103','1962-03-14','M','M',':RET:2106-3','N','021','DEN','2490494','18575LA002000201','2014-01-01','2013-12-23 22:59:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:43'),(14384,11473,'Y','18','021','EC','A','','','AC','0000294418','0000294418','OH00000125484','IL','1','HUNDLEY','ROBERT','','','','34','263533272','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-09-28','M','M',NULL,'N','021','DEN','2213563','99734OH005000401','2014-02-01','2013-12-27 14:07:58','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:50'),(18767,14952,'N','19','021','EC','A',NULL,NULL,'','0000427340','0000271811','','S1','1','WADE','STACY','','','','34','631526871','2610 CODY CT',0,'MIDLOTHIAN','TX','76065','7023','CY','48139','1996-03-09','F','',NULL,'N','021','DEN','2815071','33348TX002000101','2014-03-01','2014-01-16 17:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-17 03:35:49'),(5555,4409,'Y','18','021','EC','A','','','AC','0001153588','0001153588','OH00000341451','IL','1','Fiebig','Zachary','','','','34','291723702','12310 Erwin Ave',0,'Cleveland','OH','44135',NULL,'CY','39035','1976-09-14','M','U',':RET:1002-5^:RET:2106-3','N','021','HLT','461251','52664OH151001501','2014-01-01','2013-11-27 11:41:45','0.00',NULL,NULL,'373.46','373.46','R-OH011','OH0','373.46',NULL,0,'2013-12-25 23:16:15'),(6641,5269,'Y','18','024','14','A','','','TE','0000210315','0000210315','','IL','1','Morrow','Jason','Alan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-24','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-12 04:15:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 01:00:19'),(5387,4274,'Y','18','021','EC','A','','','AC','0002196369','0002196369','LA00000283994','IL','1','Jason','Horatio','','','','34','439274658','1118 HOGAN DR',0,'OPELOUSAS','LA','70570','3768','CY','22097','1976-08-12','M','U',':RET:2054-5','N','021','DEN','2267223','18575LA002000201','2014-01-01','2013-12-19 16:26:39','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 23:08:33'),(9211,7306,'Y','18','021','EC','A','','','AC','0000707444','0000707444','MS00000209067','IL','1','Shird','Lorna',NULL,NULL,NULL,NULL,NULL,'722 Campbell St',0,'Jackson','MS','39203',NULL,'CY','28049','1954-07-30','F','U',':RET:2054-5','N','021','DEN','2588385','46300MS002000201','2014-01-01','2013-12-18 16:26:40','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:09:54'),(21069,16835,'Y','18','021','EC','A','','','AC','0000146920','0000146920','OH00002004009','IL','1','Spuzzillo','Jill',NULL,NULL,NULL,NULL,NULL,'4794 GLENN LODGE RD',0,'MENTOR','OH','44060','1325','CY','39085','1977-08-07','F','U',':RET:2106-3','T','021','DEN','2878990','99734OH005000401','2014-03-01','2014-02-01 20:39:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-02 19:00:16'),(23927,19027,'Y','18','021','EC','A','','','AC','0000949487','0000949487','OH00002432984','IL','1','Overfield','Jon','','','','34','301720107','1436 RUTH AVE',0,'CUYAHOGA FALLS','OH','44221','2938','CY','39153','1970-02-02','M','R',':RET:2106-3','N','021','HLT','2733265','52664OH151001501','2014-03-01','2014-02-14 17:08:45','0.00',NULL,NULL,'835.03','835.03','R-OH012','OH0','373.65','CIC',0,'2014-02-14 22:00:09'),(25932,20564,'Y','18','021','EC','A','','','AC','0000995210','0000995210','TX00001923046','IL','1','SMART','TERRY','ANN','','','34','461119508','2101 WILSON STREET',0,'SAN ANGELO','TX','76901',NULL,'CY','48451','1957-01-14','F','M',NULL,'N','021','DEN','3685957','33348TX002000201','2014-04-01','2014-02-26 16:40:34','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-26 21:01:26'),(28624,22653,'Y','18','021','EC','A','','','AC','0000026416','0000026416','TX00002969247','IL','1','Flores','Raul','','','','34','545745354','910 FORT CLARK RD',0,'UVALDE','TX','78801','4507','CY','48463','1950-05-21','M','M',NULL,'N','021','DEN','3194546','33348TX002000201','2014-04-01','2014-03-08 10:38:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:23'),(29054,22995,'N','01','021','EC','A',NULL,NULL,'','0001003366','0000220043','','IL','1','Gangwisch','Ronald','J','','','34','287565504','710 THORPE DR',0,'SANDUSKY','OH','44870','1624','CY','39043','1954-09-03','M','',':RET:2106-3','N','021','DEN','3992868','99734OH005000401','2014-04-01','2014-03-10 15:10:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:48'),(18950,15099,'Y','18','021','EC','A','','','AC','0000233209','0000233209','TX00001819165','IL','1','Steakley','Michelle','','','','34','525252818','9 LAKEWOOD ST',0,'SWEETWATER','TX','79556','1709','CY','48353','1964-02-10','F','M',':RET:2106-3','N','021','DEN','1915189','33348TX002000201','2014-03-01','2014-01-17 14:05:15','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-20 08:05:48'),(223,187,'Y','18','021','EC','A','','','AC','0000043007','0000043007','LA00000859185','IL','1','Judice','Ryan','','','','34','438048260','123 COCONUT GROVE CIR',0,'LAFAYETTE','LA','70508','6955','CY','22055','1970-12-28','M','U',':RET:2106-3','N','021','DEN','22932','18575LA002000201','2014-01-01','2013-12-05 14:18:00','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 17:20:49'),(479,391,'Y','18','021','EC','A','','','AC','0000180079','0000180079','LA00000008267','IL','1','Cornin','Kathleen','','','','34','436962438','3832 DEERRUN LN',0,'HARVEY','LA','70058','2121','CY','22051','1955-10-28','F','M',':RET:2054-5','N','021','DEN','430791','18575LA002000201','2014-01-01','2013-12-03 22:14:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:06'),(16966,13580,'Y','18','021','EC','A','','','AC','0001037371','0001037371','OH00002383294','31','1','rogalsky-cannon','pamela','','','','34','269621867','po box 11255',0,'bradylake','OH','44211',NULL,'CY','39133','1956-11-18','F','M',NULL,'T','021','HLT','2223322','52664OH151001305','2014-02-01','2014-01-09 15:05:14','391.00',NULL,NULL,'624.99','233.99','R-OH012','OH0','624.99',NULL,0,'2014-01-13 02:20:11'),(526,429,'Y','18','021','EC','A','','','AC','0000891775','0000891775','OH00001061086','IL','1','McLean','Maryann','','','','34','291720838','5616 BRAVE CHIEF LN',0,'RAVENNA','OH','44266','9106','CY','39133','1968-04-03','F','M',':RET:2106-3','T','021','HLT','203135','52664OH151001501','2014-01-01','2013-12-04 11:39:40','480.00',NULL,NULL,'993.50','513.50','R-OH012','OH0','444.15',NULL,0,'2013-12-25 17:49:21'),(16825,13458,'Y','18','021','EC','A','','','AC','0002285014','0002285014','LA00002016669','IL','1','Schomburg','Cindy','','','','34','391664856','3310 Industrial Drv',0,'Bossier City','LA','71112',NULL,'CY','22015','1956-10-09','F','U',':RET:2106-3','N','021','DEN','1755564','18575LA002000201','2014-02-01','2014-01-11 13:11:45','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-13 02:18:25'),(16735,13391,'Y','18','021','EC','A','','','AC','0000674079','0000674079','OH00002224493','IL','1','Ferrari','Carey','','','','34','276888153','1705 ARNDALE RD',0,'STOW','OH','44224','1850','CY','39153','1973-10-07','F','M',':RET:2106-3','N','021','HLT','1624945','52664OH151001305','2014-02-01','2014-01-06 20:25:49','730.00',NULL,NULL,'1005.31','275.31','R-OH012','OH0','285.00',NULL,0,'2014-01-08 18:24:50'),(15443,12357,'Y','18','021','EC','A','','','AC','0000710817','0000710817','TX00001928259','IL','1','Bean','Patricia','','','','34','464907321','1818 2ND AVE N',0,'TEXAS CITY','TX','77590','7324','CY','48167','1951-04-12','F','U',NULL,'T','021','DEN','2495904','33348TX002000201','2014-02-01','2013-12-31 14:39:40','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:28:07'),(14958,11955,'N','01','021','EC','A',NULL,NULL,'','0000842374','0001229518','','IL','1','STALTER','JENNIFER','FAYE','','','34','501042669','400 W VALENCIA DR',0,'AMARILLO','TX','79118',NULL,'CY','48381','1980-12-08','F','',':RET:2106-3','N','021','DEN','1967340','33348TX002000201','2014-02-01','2013-12-30 08:02:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-01 12:00:26'),(5976,4731,'N','01','021','EC','A',NULL,NULL,'','0001020422','0000163681','','IL','1','Inks','Jamie','','','','34','300823078','912 KIEFFER ST',0,'WOOSTER','OH','44691','2465','CY','39169','1973-03-04','M','',':RET:2106-3','T','021','HLT','2474174','52664OH151001501','2014-01-01','2013-12-23 22:57:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','393.09',NULL,0,'2013-12-25 23:51:48'),(14015,11165,'Y','18','021','EC','A','','','AC','0000578783','0000578783','OH00000323384','IL','1','Root','Richard','','','','34','283680560','2202 KINNETT RD',0,'BETHEL','OH','45106','7213','CY','39025','1971-07-26','M','M',':RET:2106-3','N','021','HLT','2511505','92036OH003000606','2014-01-01','2013-12-23 15:05:58','426.00',NULL,NULL,'594.10','168.10','R-OH005','OH0','297.05',NULL,0,'2013-12-26 13:16:29'),(3979,3177,'N','01','021','EC','A',NULL,NULL,'','0000971452','0000775082','','IL','1','Good','Kara','Marie','','','34','292900290','910 CORNELL DR',0,'LIMA','OH','45805','1622','CY','39003','1989-08-07','F','',':RET:2106-3','N','021','HLT','155695','92036OH003001504','2014-01-01','2013-12-13 12:17:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.83',NULL,0,'2013-12-25 21:38:46'),(21304,17023,'Y','18','021','EC','A','','','AC','0001987425','0001987425','LA00001959278','IL','1','pouncey','whitney','','','','34','643108240','2854 KING OAKS LOOP',0,'SHREVEPORT','LA','71107','4205','CY','22017','1986-02-24','F','M',':RET:2054-5','T','021','DEN','2813121','18575LA002000201','2014-03-01','2014-02-03 22:19:43','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-04 21:00:14'),(28483,22536,'Y','18','021','EC','A','','','AC','0000345641','0000345641','OH00003386183','IL','1','colson','laura',NULL,NULL,NULL,NULL,NULL,'3641 w 139',0,'cleveland','OH','44111',NULL,'CY','39035','1971-04-25','F','U',':RET:2054-5','N','021','DEN','3562431','99734OH005000301','2014-04-01','2014-03-07 14:17:26','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:31:37'),(28495,22547,'Y','18','021','EC','A','','','AC','0000108304','0000108304','MS00002683607','IL','1','CHATMAN','GREG','BERNARD','','','34','425296197','125 NORMAN RD',0,'MAGEE','MS','39111','2901','CY','28127','1966-01-23','M','U',':RET:2054-5','N','021','DEN','2890354','46300MS002000201','2014-04-01','2014-03-07 12:53:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-07 21:31:44'),(29203,23111,'Y','18','021','EC','A','','','AC','0000313820','0000313820','MS00002729889','IL','1','LOWMAN','JESSE','','','Jr','34','545332663','385 NAIL RD',0,'SOUTHAVEN','MS','38671',NULL,'CY','28033','1964-01-30','M','M',':RET:2106-3','T','021','DEN','4392418','46300MS002000201','2014-04-01','2014-03-10 15:50:54','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85','CIC',0,'2014-03-10 21:30:11'),(9703,7685,'Y','18','021','EC','A','','','AC','0000184935','0000184935','OH00000409346','IL','1','POST','DONNA','','','','34','291668719','1341 POST RD',0,'SAINT HENRY','OH','45883','9723','CY','39107','1961-01-19','F','U',':RET:2106-3','N','021','HLT','2358490','92036OH003001506','2014-01-01','2013-12-21 15:12:54','405.00',NULL,NULL,'448.63','43.63','R-OH002','OH0','448.63',NULL,0,'2013-12-26 04:40:00'),(1209,994,'N','01','021','EC','A',NULL,NULL,'','0000811988','0000974050','','IL','1','BELKIN','KRISTINE','','','','34','469371903','5450 Cascade Court',0,'Willoughby','OH','44094',NULL,'CY','39085','1971-08-19','F','',':RET:2106-3','N','021','DEN','1227425','99734OH005000301','2014-01-01','2013-12-03 16:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:20:04'),(7813,6190,'Y','18','021','EC','A','','','AC','0000804351','0000804351','TX00000369511','IL','1','Biram','Scott','','','','34','452954123','4800 TRAIL CREST CIR',0,'AUSTIN','TX','78735','6353','CY','48453','1974-04-04','M','U',':RET:2106-3','N','021','DEN','2403724','33348TX002000201','2014-01-01','2013-12-20 17:50:51','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 03:04:00'),(21206,16946,'Y','18','021','EC','A','','','AC','0002399267','0002399267','LA00002453859','IL','1','Dumas','Joana','','','','34','437253923','19495 LEMON ST',0,'VACHERIE','LA','70090','3217','CY','22093','1975-07-21','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','3318908','18575LA002000201','2014-03-01','2014-02-03 10:40:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:00:56'),(21745,17364,'Y','18','021','EC','A','','','AC','0000324261','0000324261','TX00001915158','IL','1','griffith','melissa','','','','34','449844226','510 MAYBROOK DR',0,'BUDA','TX','78610','9420','CY','48209','1955-09-12','F','U',':RET:2106-3','N','021','DEN','3839264','33348TX002000201','2014-03-01','2014-02-05 18:55:28','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-06 21:00:17'),(22220,17736,'N','01','021','EC','A',NULL,NULL,'','0001392215','0001494548','','IL','1','Creel','Donna','Lenora','','','34','439907073','186 WHISENANT RD',0,'WINNFIELD','LA','71483','6119','CY','22127','1951-11-16','F','',':RET:2106-3','N','021','DEN','3695625','18575LA002000201','2014-03-01','2014-02-09 16:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-09 19:00:26'),(23186,18487,'Y','18','021','EC','A','','','AC','0000960923','0000960923','MS00002576429','IL','1','Cohn','Haley','','','','34','426734084','450 KILPATRICK ST',0,'BALDWYN','MS','38824','1125','CY','28117','1992-01-17','F','M',':RET:2106-3','T','021','DEN','3045859','46300MS002000101','2014-03-01','2014-02-12 16:29:33','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-12 21:32:01'),(25791,20455,'Y','18','021','EC','A','','','AC','0000394984','0000394984','OH00002073016','IL','1','Roth','David','','','','34','297528409','1155 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1955-10-22','M','M',':RET:2106-3','N','021','DEN','3284779','99734OH005000301','2014-03-01','2014-02-26 10:00:17','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2014-02-26 21:00:12'),(28753,22757,'Y','18','024','14','A','','','TE','0000330696','0000330696','','IL','1','nava','eric',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-01-26','M','',NULL,NULL,NULL,'','3505274','','2014-03-09','2014-03-09 00:02:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-09 21:00:17'),(18921,15075,'Y','18','021','EC','A','','','AC','0000561700','0000561700','OH00001353323','IL','1','Hiltbrunner','Barbara','','','','34','296425906','921 MAPLEWOOD ST',0,'WILLARD','OH','44890','1619','CY','39077','1949-06-14','F','M',NULL,'N','021','HLT','1517832','92036OH001002701','2014-02-01','2014-01-15 20:50:42','0.00',NULL,NULL,'705.61','705.61','R-OH006','OH0','705.61',NULL,0,'2014-01-17 03:36:43'),(14586,11641,'Y','18','021','EC','A','','','AC','0000072886','0000072886','OH00000974204','IL','1','Siferd','Laura','','','','34','298645938','1528 W Market Street',0,'Lima','OH','45805',NULL,'CY','39003','1973-08-07','F','M',':RET:2106-3','N','021','HLT','2182263','92036OH005001501','2014-02-01','2013-12-27 12:30:11','0.00',NULL,NULL,'281.27','281.27','R-OH002','OH0','281.27',NULL,0,'2013-12-28 03:35:59'),(2907,2343,'N','01','021','EC','A',NULL,NULL,'','0000678060','0000818539','','IL','1','Otchere','Tonette','','','','34','268664864','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1960-12-17','F','',':RET:2054-5','N','021','DEN','34684','99734OH005000401','2014-01-01','2013-12-05 23:13:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:29'),(2413,1969,'N','19','021','EC','A',NULL,NULL,'','0001022758','0000656903','','IL','1','lomack','simone',NULL,NULL,NULL,NULL,NULL,'3428 ferncroft dr',0,'cincinnati','OH','45211',NULL,'CY','39061','1999-03-06','F','',':RET:2054-5','N','021','DEN','713099','99734OH005000401','2014-01-01','2013-12-09 15:40:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:48'),(2082,1704,'Y','18','021','EC','A','','','AC','0000125376','0000125376','LA00000252049','IL','1','Canterbury','Elizabeth','','','','34','434216690','504 TRACEY CIR',0,'LAFAYETTE','LA','70503','4365','CY','22055','1957-09-19','F','U',':RET:2106-3','N','021','DEN','601159','18575LA002000201','2014-01-01','2013-12-10 11:23:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:16:38'),(22296,17799,'Y','18','021','EC','A','','','AC','0001025531','0001025531','OH00002236627','IL','1','Lantz','Robert','','','','34','090547898','6935 WOODY CT',0,'CANAL WINCHESTER','OH','43110','9645','CY','39049','1960-03-30','M','U',':RET:2106-3','N','021','DEN','3393690','99734OH005000301','2014-03-01','2014-01-31 13:21:33','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-10 11:00:33'),(26774,21219,'Y','18','024','14','A','','','TE','0000784812','0000784812','','IL','1','Simmons','Bertha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-06-14','F','',NULL,NULL,NULL,'','1612899','','2014-03-15','2014-02-28 19:07:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-01 21:00:09'),(27858,22034,'Y','18','021','EC','A','','','AC','0000062073','0000062073','TX00003192125','IL','1','CONNER','MARILYN','','','','34','453374872','607 DELMAR AVE',0,'AUSTIN','TX','78752','2626','CY','48453','1963-03-20','F','U',':RET:2054-5','N','021','DEN','3654955','33348TX002000101','2014-04-01','2014-03-05 17:08:48','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-05 21:32:16'),(28045,22192,'Y','18','021','EC','A','','','AC','0000366840','0000366840','MS00003355794','IL','1','Stepteau','Don','','','','34','436537510','157B N WIND RIDGE LN',0,'PURVIS','MS','39475','5839','CY','28073','1984-01-22','M','M',':RET:2054-5','N','021','DEN','3734913','46300MS002000201','2014-04-01','2014-03-05 18:43:56','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2014-03-06 21:01:34'),(28226,22334,'Y','18','021','EC','A','','','AC','0001204586','0001204586','OH00002628846','IL','1','ALSHAHAL','MANAL','','','','34','271860960','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','1978-05-18','F','M',NULL,'N','021','DEN','2969726','99734OH005000301','2014-04-01','2014-03-06 15:47:59','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00','CIC',0,'2014-03-06 21:30:21'),(19339,15417,'Y','18','021','EC','A','','','AC','0000192557','0000192557','TX00002325815','IL','1','POWELL','PAMELA','','','','34','452494107','2216 TANGLEWOOD ST',0,'MESQUITE','TX','75181','1797','CY','48113','1979-09-22','F','M',':RET:2054-5','N','021','DEN','1495965','33348TX002000201','2014-03-01','2014-01-21 18:00:17','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:20'),(361,298,'Y','18','021','EC','A','','','AC','0000041945','0000041945','TX00000295894','IL','1','Pierson','Frankie','','','','34','260291564','7707 S IH 35 Apt 830',0,'Austin','TX','78744',NULL,'CY','48453','1965-09-04','F','M',':RET:2106-3','N','021','DEN','734726','33348TX002000201','2014-01-01','2013-12-03 18:34:05','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 17:45:10'),(13704,10934,'Y','18','021','EC','A','','','AC','0000045764','0000045764','OH00000665930','IL','1','seme','joseph','','','','34','300446369','3741 COTTAGE GROVE RD',0,'AKRON','OH','44319','3711','CY','39153','1949-08-19','M','U',':RET:2106-3','N','021','HLT','2199770','52664OH151001305','2014-01-01','2013-12-23 13:01:25','508.00',NULL,NULL,'669.00','161.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 13:08:46'),(5156,4088,'Y','18','024','14','A','','','TE','0000912943','0000912943','','IL','1','SPENCE','MINDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-10-10','F','',NULL,NULL,NULL,'','2024444','','2013-12-19','2013-12-19 10:27:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:02:56'),(7510,5941,'Y','18','024','14','A','','','TE','0000596986','0000596986','','IL','1','GASPER','THOMAS','J','','IV',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-06-18','M','',NULL,NULL,NULL,'','538371','','2013-12-14','2013-12-14 23:05:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 02:32:04'),(20419,16309,'Y','18','021','EC','A','','','AC','0001003337','0001003337','OH00001424302','IL','1','Mink','Judy','','','','34','404860497','4054 PEMBROKE DR',0,'HAMILTON','OH','45015','1941','CY','39017','1955-03-03','F','U',NULL,'N','021','DEN','3437875','99734OH005000301','2014-03-01','2014-01-29 09:36:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:29'),(23385,18634,'N','01','021','EC','A',NULL,NULL,'','0000323550','0000539333','','IL','1','CONLEY','CHRISTOPHER','','','','34','302889595','1435 FAIRLANE AVE SW',0,'CANTON','OH','44710','1349','CY','39151','1985-06-09','M','',NULL,'T','021','DEN','3338533','99734OH005000401','2014-03-01','2014-02-13 13:54:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:02'),(27763,21954,'Y','18','021','EC','A','','','AC','0002323845','0002323845','LA00002849789','IL','1','BUECHE','DILLION','','','','34','438833817','6622 ISLAND RD',0,'JARREAU','LA','70749',NULL,'CY','22077','1992-02-21','M','U',':RET:2106-3','T','021','DEN','3367249','18575LA002000201','2014-04-01','2014-03-05 12:35:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:21'),(28840,22822,'Y','18','024','14','A','','','TE','0000830701','0000830701','','IL','1','Tolbert','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-29','M','',NULL,NULL,NULL,'','3587781','','2014-03-08','2014-03-09 14:16:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-09 21:01:12'),(29016,22965,'Y','18','021','EC','A','','','AC','0000957952','0000957952','OH00003769674','IL','1','Scott','Karen','','','','34','273606162','8319 NOWLEN ST',0,'MENTOR','OH','44060','5763','CY','39085','1963-02-24','F','U',':RET:2106-3','N','021','DEN','4178907','99734OH005000401','2014-04-01','2014-03-10 00:02:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:26'),(174,144,'Y','18','021','EC','A','','','AC','0000187436','0000187436','OH00000271062','IL','1','Hatch','Diane','','','','34','273464349','1657 ROCKFORD ST',0,'AKRON','OH','44301','2510','CY','39153','1952-12-20','F','U',':RET:2106-3','N','021','HLT','216164','52664OH151001306','2014-01-01','2013-12-05 09:43:51','524.00',NULL,NULL,'626.65','102.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 17:19:30'),(19204,15299,'N','01','021','EC','A',NULL,NULL,'','0000726155','0000005866','','IL','1','Phillips','Karol','','','','34','287643640','466 13th St',0,'Campbell','OH','44405',NULL,'CY','39099','1957-09-29','F','',':RET:2106-3','N','021','HLT','1718238','52664OH151001304','2014-03-01','2014-01-20 18:06:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','590.00',NULL,0,'2014-01-21 08:46:18'),(2206,1817,'Y','18','021','EC','A','','','AC','0000009818','0000009818','OH00000404057','IL','1','Maas','Rodney','','','','34','280580721','338 VIENNA AVE',0,'NILES','OH','44446','2628','CY','39155','1955-09-24','M','U',':RET:2106-3','N','021','HLT','942786','52664OH151001305','2014-01-01','2013-12-10 13:34:16','464.00',NULL,NULL,'644.38','180.38','R-OH013','OH0','644.38',NULL,0,'2013-12-25 19:20:10'),(17348,13879,'Y','18','021','EC','A','','','AC','0000552648','0000552648','OH00002393943','IL','1','Kelly','Patricia','','','','34','295569446','636 E RUSSELL RD',0,'SIDNEY','OH','45365','2063','CY','39149','1953-01-24','F','M',':RET:2106-3','N','021','HLT','1367289','92036OH004000501','2014-02-01','2014-01-10 14:02:28','525.00',NULL,NULL,'537.11','12.11','R-OH003','OH0','537.11',NULL,0,'2014-01-13 02:24:07'),(9195,7292,'Y','18','021','EC','A','','','AC','0000067661','0000067661','OH00001008089','IL','1','Stangelo','Megan','','','','34','291808836','340 West Wooster',0,'Bowling Green','OH','43402',NULL,'CY','39173','1983-07-29','F','U',':RET:2106-3','N','021','HLT','2295718','92036OH006002601','2014-01-01','2013-12-18 12:26:34','0.00',NULL,NULL,'175.52','175.52','R-OH001','OH0','175.52',NULL,0,'2013-12-26 04:09:29'),(9019,7155,'N','01','021','EC','A',NULL,NULL,'','0001024255','0000714960','','IL','1','Kaye','Regina','','','','34','286789495','938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1966-12-09','F','',':RET:2106-3','N','021','HLT','2350159','52664OH151001301','2014-01-01','2013-12-17 19:26:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.56',NULL,0,'2013-12-26 04:05:16'),(8854,7020,'Y','18','021','EC','A','','','AC','0000791069','0000791069','TX00000236762','IL','1','Quijano','Mario','','','','34','452531467','625 East Dallas Ave',0,'McAllen','TX','78501',NULL,'CY','48215','1957-01-05','M','M',NULL,'T','021','DEN','2500424','33348TX002000201','2014-01-01','2013-12-18 10:32:37','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-26 04:01:06'),(4309,3425,'Y','18','024','14','A','','','TE','0000093834','0000093834','','IL','1','davis','teresa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-12-18','F','',NULL,NULL,NULL,'','2284060','','2013-12-17','2013-12-17 07:29:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:52:31'),(4500,3567,'Y','18','021','EC','A','','','AC','0000324015','0000324015','TX00000589733','IL','1','vivero','nancy','','','','34','461418005','201 W EBONY ST',0,'SULLIVAN CITY','TX','78595','2112','CY','48215','1977-08-17','F','M',NULL,'N','021','DEN','234672','33348TX002000201','2014-01-01','2013-12-11 20:57:32','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:03:21'),(15613,12488,'Y','18','021','EC','A','','','AC','0000025307','0000025307','OH00000641041','IL','1','Donahue','Jill','','','','34','298567622','3756 Luxair Drive',0,'Hillard','OH','43026',NULL,'CY','39049','1957-05-31','F','U',NULL,'N','021','DEN','2184999','99734OH005000301','2014-02-01','2013-12-31 18:32:08','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:32:52'),(23038,18367,'Y','18','021','EC','A','','','AC','0000925282','0000925282','TX00002723032','IL','1','NGUYEN','TRUNG','VAN','','','34','462719714','5104 FORT BUCKNER DR',0,'MCKINNEY','TX','75070','1000','CY','48085','1953-12-24','M','M',':RET:2047-9','N','021','DEN','3851927','33348TX002000201','2014-03-01','2014-02-12 17:19:11','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:38'),(24751,19640,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000924845','','IL','1','PARHAM','QUANTE','','','','34','288982082','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1995-08-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:41:12'),(27310,21623,'Y','18','024','14','A','','','TE','0000553050','0000553050','','IL','1','Legg','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-17','M','',NULL,NULL,NULL,'','1980234','','2014-03-19','2014-03-04 14:03:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-04 21:00:39'),(28979,22936,'Y','18','021','EC','A','','','AC','0000816491','0000816491','OH00003281421','IL','1','FRAZEE','LYNN','','','','34','272564271','2488 DONNA DR',0,'RICHFEILD','OH','44286',NULL,'CY','39153','1954-06-19','M','U',':RET:2106-3','N','021','HLT','3731446','52664OH151001305','2014-04-01','2014-03-09 20:34:24','466.00',NULL,NULL,'580.49','114.49','R-OH012','OH0','580.49',NULL,0,'2014-03-10 21:01:08'),(59,53,'Y','18','021','EC','A','','','AC','0000198531','0000198531','OH00001215051','IL','1','Cox','Jeffrey','','','','34','284869286','2485 BOBMEYER RD',0,'FAIRFIELD','OH','45014','1201','CY','39017','1973-01-24','M','U',':RET:2106-3','N','021','DEN','12640','99734OH005000301','2014-01-01','2013-12-04 23:36:36','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:37'),(14522,11587,'Y','18','024','14','A','','','TE','0000307605','0000307605','','IL','1','Rios','Jane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-25','F','',NULL,NULL,NULL,'','1710247','','2013-12-27','2013-12-27 17:10:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:34:20'),(20131,16064,'Y','18','024','14','A','','','TE','0000714933','0000714933','','IL','1','Truong','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-06-01','M','',NULL,NULL,NULL,'','2460550','','2014-01-27','2014-01-27 12:10:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:52'),(18872,15034,'Y','18','021','EC','A','','','AC','0001742446','0001742446','LA00001936621','IL','1','Young','Kathryn','','','','34','205682198','2016 CHRISTIAN ST',0,'BATON ROUGE','LA','70808','2175','CY','22033','1987-05-07','F','U',':RET:2106-3','N','021','DEN','2164998','18575LA002000201','2014-03-01','2014-01-16 12:13:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:24'),(18091,14450,'Y','18','021','EC','A','','','AC','0002188694','0002188694','LA00001949911','IL','1','blanson','misty','','','','34','436758906','510 WARHAWK WAY',0,'MONROE','LA','71203',NULL,'CY','22073','1984-10-29','F','U',':RET:2054-5','N','021','DEN','2418357','18575LA002000201','2014-02-01','2014-01-14 12:20:57','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:30'),(5788,4597,'N','19','021','EC','A',NULL,NULL,'','0000518419','0000230440','','IL','1','Harper','Randal','Kalai','','','34','292922222','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1990-08-23','M','',':RET:2106-3','N','021','DEN','1997609','99734OH005000401','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:47:13'),(4432,3522,'N','01','021','EC','A',NULL,NULL,'','0001095634','0001258635','','IL','1','Piesciuk','Delores',NULL,NULL,NULL,NULL,NULL,'3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-09-11','F','',':RET:2106-3','N','021','DEN','601255','99734OH005000401','2014-01-01','2013-12-12 18:11:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:53'),(21104,16863,'N','19','021','EC','A',NULL,NULL,'','0000874735','0000396198','','IL','1','Pylypuik','Carolyn','G',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','2003-04-06','F','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:04'),(24386,19370,'Y','18','021','EC','A','','','AC','0000479899','0000479899','OH00002274451','IL','1','STERLING','JAMAL','','','','34','443987951','1614 RIVERSTONE WAY',0,'MONROE','OH','45050','1750','CY','39017','1990-08-09','M','M',NULL,'N','021','DEN','3458464','99734OH005000401','2014-04-01','2014-02-18 11:37:51','0.00',NULL,NULL,'50.05','50.05','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:47'),(25356,20118,'N','01','021','EC','A',NULL,NULL,'','0001120004','0000159465','','IL','1','STOGSDILL','LOIS','ANN','','','34','402139713','5757 LAKE EERIE DR.',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','1979-07-13','F','',':RET:2106-3','T','021','DEN','3026771','99734OH005000301','2014-04-01','2014-02-24 18:33:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:33'),(1257,1036,'Y','18','024','14','A','','','TE','0000987353','0000987353','','IL','1','HIRSCHFELD','SHEILA','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-17','F','',NULL,NULL,NULL,'','1044747','','2013-12-03','2013-12-03 14:50:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:21:24'),(5316,4216,'Y','18','021','EC','A','','','AC','0000772631','0000772631','OH00001058966','IL','1','Miller','Jeffrey','','','','34','275748017','3375 LINDSTROM DR',0,'COLUMBUS','OH','43228','7062','CY','39049','1965-01-27','M','M',':RET:2106-3','N','021','DEN','1663111','99734OH005000301','2014-01-01','2013-12-18 20:02:37','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:06:42'),(20076,16015,'Y','18','021','EC','A','','','AC','0001158510','0001158510','TX00001998728','IL','1','Frederick','Reid','','','','34','457554716','7114 CLAREN CT',0,'DALLAS','TX','75252','6117','CY','48085','1968-06-17','M','U',':RET:2106-3','N','021','DEN','2688209','33348TX002000201','2014-03-01','2014-01-27 16:23:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-27 21:00:20'),(19272,15360,'Y','18','021','EC','A','','','AC','0001528367','0001528367','LA00002214574','IL','1','Knighton','Jesse','Ann','','','34','545888423','1079 HIGHWAY 846 N',0,'COLUMBIA','LA','71418','5037','CY','22021','1951-01-14','F','M',NULL,'N','021','DEN','1516617','18575LA002000101','2014-03-01','2014-01-20 10:13:13','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-21 08:46:55'),(2767,2237,'Y','18','021','EC','A','','','AC','0001030339','0001030339','OH00000312973','IL','1','Clark','Donald','Leroy','','','34','224684692','38 CLEMENT AVE',0,'AKRON','OH','44319','4802','CY','39153','1951-01-09','M','M',':RET:2106-3','N','021','HLT','795860','52664OH151001305','2014-01-01','2013-12-02 10:36:33','464.00',NULL,NULL,'640.70','176.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 19:49:27'),(16595,13274,'Y','18','021','EC','A','','','AC','0001202214','0001202214','LA00002110022','IL','1','VALLIER','PAULA','MARIE','','','34','438171815','412 SUNSET DR',0,'LAFAYETTE','LA','70501','3742','CY','22055','1959-08-04','F','M',':RET:2054-5','N','021','DEN','1499367','18575LA002000201','2014-02-01','2014-01-07 07:24:41','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-01-08 18:24:02'),(2960,2383,'N','01','021','EC','A',NULL,NULL,'','0000027196','0001183527','','IL','1','Escobedo','Benito','','','','34','455888335','219 E Ave 1',0,'San Angelo','TX','76903',NULL,'CY','48451','1950-01-24','M','',NULL,'N','021','DEN','643962','33348TX002000201','2014-01-01','2013-12-06 17:14:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:16:44'),(15503,12404,'Y','18','021','EC','A','','','AC','0000120100','0000120100','OH00001381342','IL','1','Bengston','Laura','Mae','','','34','277442846','831 MEADOWVIEW DR',0,'COLUMBUS','OH','43224','1929','CY','39049','1954-04-24','F','M',NULL,'T','021','DEN','1398066','99734OH005000401','2014-02-01','2013-12-31 13:55:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:47'),(1651,1379,'Y','18','021','EC','A','','','AC','0000485318','0000485318','TX00001419946','IL','1','KATTA','SUNEETHA','','','','34','321114899','2502 BROWN BEAR WAY',0,'EULESS','TX','76039','6062','CY','48439','1954-07-01','F','U',':RET:2029-7','N','021','DEN','2285832','33348TX002000201','2014-01-01','2013-12-24 16:17:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:53:21'),(21383,17089,'N','01','021','EC','A',NULL,NULL,'','0000276306','0000240386','','IL','1','Vega','Samuel','','','Jr','34','351668520','4951 E. Lake Rd.',0,'Sheffield Lake','OH','44054',NULL,'CY','39093','1967-01-12','M','',NULL,'N','021','DEN','3544834','99734OH005000401','2014-03-01','2014-02-03 23:03:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:54'),(22093,17636,'Y','18','021','EC','A','','','AC','0000869534','0000869534','MS00002065053','IL','1','Lawrence','William','','','','34','413865394','10619 N. Cockrum Dr.',0,'Hernando','MS','38632',NULL,'CY','28033','1950-08-11','M','M',':RET:2106-3','N','021','DEN','3650086','46300MS002000201','2014-03-01','2014-02-08 17:41:55','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85',NULL,0,'2014-02-08 19:00:25'),(23625,18813,'Y','18','021','EC','A','','','AC','0001129054','0001129054','OH00002156783','IL','1','Algahmee','Anise','','','','34','277748537','1334 DOUGLAS AVE',0,'YOUNGSTOWN','OH','44502','2816','CY','39099','1972-12-27','M','U',':RET:2106-3','N','021','HLT','3224740','92036OH003003205','2014-03-01','2014-02-13 16:56:29','215.00',NULL,NULL,'329.12','114.12','R-OH013','OH0','329.12',NULL,0,'2014-02-13 22:03:19'),(23698,18872,'Y','18','021','EC','A','','','AC','0000616874','0000616874','OH00002357768','IL','1','mccarthy','dan','','','','34','290600527','3386 PALMHILL LN',0,'CINCINNATI','OH','45239','7162','CY','39061','1965-05-13','M','M',NULL,'T','021','DEN','3576493','99734OH005000401','2014-03-01','2014-02-14 11:43:31','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:41'),(276,228,'Y','18','021','EC','A','','','AC','0000595530','0000595530','TX00001101601','IL','1','Moulton','Katherine','','','','34','133703335','2513 AMEN CORNER RD',0,'PFLUGERVILLE','TX','78660','5027','CY','48453','1986-10-16','F','U',NULL,'N','021','DEN','600866','33348TX002000201','2014-01-01','2013-10-12 12:44:19','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 17:30:10'),(19531,15566,'Y','18','021','EC','A','','','AC','0001042330','0001042330','OH00001944472','IL','1','DANIELS','KEVIN','','','','34','278648039','1838 DYSART AVE',0,'COLOMBUS','OH','43219',NULL,'CY','39049','1964-03-02','M','U',':RET:2054-5','N','021','DEN','3058219','99734OH005000401','2014-03-01','2014-01-22 17:34:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-23 03:02:20'),(13556,10811,'Y','18','021','EC','A','','','AC','0001411250','0001411250','LA00000840235','IL','1','Daigle','John','','','','34','439231294','3931 CREEK SHADOW CT',0,'BATON ROUGE','LA','70816','9098','CY','22033','1961-08-27','M','U',':RET:2106-3','N','021','DEN','2475382','18575LA002000201','2014-01-01','2013-12-23 15:22:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:13'),(19112,15228,'Y','18','021','EC','A','','','AC','0001048018','0001048018','OH00002379560','IL','1','MOBLEY','DIANE','L','','','34','272562258','103 EMMONS AVE',0,'AKRON','OH','44312',NULL,'CY','39153','1953-11-30','F','U',':RET:2106-3','N','021','HLT','1535035','52664OH151001305','2014-03-01','2014-01-18 15:38:52','475.00',NULL,NULL,'605.24','130.24','R-OH012','OH0','605.24',NULL,0,'2014-01-21 08:44:45'),(18302,14612,'Y','18','021','EC','A','','','AC','0000942012','0000942012','OH00002499118','IL','1','Nicholson','Kelley','','','','34','298602100','4330 N ST RT 61',0,'Sunbury','OH','43074',NULL,'CY','39041','1977-09-01','F','M',':RET:2106-3','N','021','DEN','2014848','99734OH005000401','2014-02-01','2014-01-15 10:35:32','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:44:57'),(8943,7091,'N','01','021','EC','A',NULL,NULL,'','0000452731','0000539276','','IL','1','Clark','Robert','A','','','34','178421277','254 DeHoff',0,'Youngstown','OH','44515',NULL,'CY','39099','1951-04-28','M','',':RET:2106-3','N','021','DEN','2031168','99734OH005000401','2014-01-01','2013-12-18 10:55:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:03:23'),(8036,6362,'N','01','021','EC','A',NULL,NULL,'','0000276265','0001178169','','IL','1','KAUFMAN','GREGORY','','','','34','269702365','912 HEATHERVIEW CT',0,'FINDLAY','OH','45840',NULL,'CY','39063','1970-02-23','M','',':RET:2106-3','T','021','HLT','1726386','92036OH005001505','2014-01-01','2013-12-20 15:20:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','343.45',NULL,0,'2013-12-26 03:09:17'),(2163,1780,'Y','18','021','EC','A','','','AC','0000844687','0000844687','OH00001319711','IL','1','Finley','John','','','','34','302446848','2670 ALEXANDER RD',0,'ATWATER','OH','44201','9745','CY','39133','1951-11-09','M','U',':RET:2106-3','N','021','HLT','960763','52664OH151001501','2014-01-01','2013-12-10 12:59:57','415.00',NULL,NULL,'768.43','353.43','R-OH012','OH0','768.43',NULL,0,'2013-12-25 19:18:57'),(3301,2657,'N','01','021','EC','A',NULL,NULL,'','0000524487','0000377454','','IL','1','Murphy','Patrick','Charles','','','34','332620682','255 GUILFORD BLVD',0,'MEDINA','OH','44256','2134','CY','39103','1966-10-07','M','',':RET:2106-3','N','021','DEN','1471448','99734OH005000301','2014-01-01','2013-12-22 12:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:41'),(7388,5848,'Y','18','021','EC','A','','','AC','0000053025','0000053025','OH00000166200','IL','1','MANNEY','PAUL','','','','34','271644972','1316 ELMDALE DR',0,'KETTERING','OH','45409',NULL,'CY','39113','1959-03-17','M','U',':RET:2106-3','N','021','DEN','592777','99734OH005000401','2014-01-01','2013-11-23 16:56:00','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:16:05'),(6318,5009,'N','19','021','EC','A',NULL,NULL,'','0000648299','0001147313','','IL','1','Setser','Madison','Emily','','','34','277028535','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','1997-04-07','F','',':RET:2106-3','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:18'),(17444,13953,'N','01','021','EC','A',NULL,NULL,'','0001030389','0001163859','','IL','1','DUFRESNE','DAVID','','','','34','380568412','3522 WALBRIDGE RD',0,'MILLBURY','OH','43447','9741','CY','39173','1952-12-27','M','',':RET:2106-3','N','021','HLT','2394519','92036OH004002601','2014-02-01','2014-01-10 16:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','440.60',NULL,0,'2014-01-13 03:00:36'),(6154,4879,'Y','18','021','EC','A','','','AC','0000332885','0000332885','TX00000153620','IL','1','Buitron','Aetna','','','','34','455132220','6120 SPRINGFIELD AVE',0,'LAREDO','TX','78041','6701','CY','48479','1958-07-08','F','M',':RET:2106-3','N','021','DEN','1170576','33348TX002000101','2014-01-01','2013-11-21 15:59:21','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2013-12-26 00:16:36'),(25059,19872,'Y','18','021','EC','A','','','AC','0001046892','0001046892','OH00002698620','IL','1','martin','regina','','','','34','271582471','2911 WHITNEY LN',0,'FAIRFIELD','OH','45014','5133','CY','39017','1955-03-14','F','U',NULL,'N','021','DEN','3273014','99734OH005000401','2014-04-01','2014-02-20 12:54:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:22'),(25372,20130,'Y','18','024','14','A','','','TE','0000205834','0000205834','','IL','1','lindsey','dorian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-09-19','M','',NULL,NULL,NULL,'','3718587','','2014-02-25','2014-02-25 14:48:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-25 21:30:42'),(25640,20340,'Y','18','021','EC','A','','','AC','0001979272','0001979272','LA00003002340','IL','1','HINES','VERA','','','','34','434844251','3031 MONROE ST',0,'NEW ORLEANS','LA','70118','3241','CY','22071','1950-03-20','F','U',NULL,'N','021','DEN','3260842','18575LA002000201','2014-04-01','2014-02-22 14:13:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 08:30:30'),(28868,22846,'Y','18','021','EC','A','','','AC','0001173934','0001173934','TX00003294689','IL','1','Davila','Francisca','','','','34','595685657','4404 Mattie Drive',0,'Killeen','TX','76549',NULL,'CY','48027','1957-07-15','F','M',':RET:2106-3','N','021','DEN','3789177','33348TX002000201','2014-04-01','2014-03-09 19:51:01','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-10 21:00:00'),(18465,14731,'Y','18','021','EC','A','','','AC','0002292236','0002292236','LA00002015570','IL','1','Edwards','Toni','','','','34','433132155','13131 TRIPLE B RD',0,'GREENWELL SPRINGS','LA','70739','3138','CY','22033','1958-03-06','F','U',':RET:2106-3','N','021','DEN','1718156','18575LA002000101','2014-02-01','2014-01-15 15:55:59','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:14'),(18158,14501,'Y','18','021','EC','A','','','AC','0000597320','0000597320','OH00001502861','31','1','KOHLER','BERTRAM','','','','34','369560009','pobox13092',0,'toledo','OH','43613',NULL,'CY','39095','1950-01-04','M','U',':RET:2106-3','N','021','HLT','2207557','92036OH005002604','2014-02-01','2014-01-14 15:09:34','424.00',NULL,NULL,'584.98','160.98','R-OH001','OH0','584.98',NULL,0,'2014-01-15 02:07:53'),(6512,5162,'Y','18','021','EC','A','','','AC','0000682128','0000682128','OH00000823854','IL','1','Marsh','Paula','','','','34','288740186','8731 MIDDLEBRANCH AVE NE',0,'CANTON','OH','44721','1504','CY','39151','1963-03-27','F','U',':RET:2106-3','N','021','HLT','878508','52664OH152000901','2014-01-01','2013-12-11 15:07:29','100.00',NULL,NULL,'291.73','191.73','R-OH015','OH0','291.73',NULL,0,'2013-12-26 00:51:10'),(16609,13286,'Y','18','021','EC','A','','','AC','0000675461','0000675461','OH00001436128','IL','1','Tyler','Shanika','','','','34','278801177','7942 TRIBUTARY LN',0,'REYNOLDSBURG','OH','43068','9588','CY','39045','1980-11-14','F','U',NULL,'N','021','DEN','2506011','99734OH005000401','2014-02-01','2014-01-06 18:29:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:07'),(14702,11739,'Y','18','021','EC','A','','','AC','0000004719','0000004719','OH00001118189','IL','1','STUDEBAKER','JOHN','E','','','34','286587211','701 S STANFIELD RD',0,'TROY','OH','45373',NULL,'CY','39109','1958-06-09','M','U',NULL,'N','021','DEN','2034451','99734OH005000401','2014-02-01','2013-12-28 09:35:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,1,'2013-12-29 11:09:06'),(13546,10802,'Y','18','024','14','A','','','TE','0000650772','0000650772','','IL','1','Sanders','Donald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-19','M','',NULL,NULL,NULL,'','877251','','2013-12-23','2013-12-23 14:40:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:03:57'),(22991,18329,'Y','18','021','EC','A','','','AC','0001126918','0001126918','OH00002461718','IL','1','Colon','Octavio','','','','34','582794840','3608 Woodbridge Ave',0,'Cleveland','OH','44109',NULL,'CY','39035','1979-08-04','M','U',NULL,'N','021','DEN','2657581','99734OH005000301','2014-03-01','2014-02-12 13:11:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:30:13'),(25901,20537,'Y','18','021','EC','A','','','AC','0001230995','0001230995','TX00002061638','IL','1','MAYFIELD','BETTY','','','','34','455840582','825 E PLEASANT RUN RD',0,'DESOTO','TX','75115',NULL,'CY','48113','1949-10-14','F','U',NULL,'N','021','DEN','2775638','33348TX002000201','2014-04-01','2014-02-26 13:41:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:08'),(27537,21784,'N','19','021','EC','A',NULL,NULL,'','0000616885','0000740344','','IL','1','THIERET','CHRISTIAN','H',NULL,NULL,NULL,NULL,'7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','1993-09-21','M','',':RET:2106-3','N','021','DEN','3776480','99734OH005000401','2014-04-01','2014-03-03 18:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:06'),(27829,22010,'Y','18','021','EC','A','','','AC','0001113198','0001113198','OH00002667057','IL','1','PIERCE-GIST','MARJORIE','','','','34','123465824','1339 RELKA AVE',0,'DAYTON','OH','45403','3024','CY','39113','1955-08-18','F','U',NULL,'N','021','DEN','4030046','99734OH005000301','2014-04-01','2014-03-05 10:03:36','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-05 21:31:59'),(29007,22958,'Y','18','021','EC','A','','','AC','0000569384','0000569384','OH00002837380','IL','1','blake','james','','','','34','275568207','719 TOWNSHIP ROAD 101',0,'WEST SALEM','OH','44287','9117','CY','39005','1958-06-01','M','M',':RET:2106-3','N','021','HLT','3983999','52664OH152000901','2014-04-01','2014-03-10 14:50:38','320.64',NULL,NULL,'364.25','43.61','R-OH012','OH0','364.25',NULL,0,'2014-03-10 21:01:22'),(3708,2967,'N','01','021','EC','A',NULL,NULL,'','0001095634','0001258635','','IL','1','Piesciuk','Delores',NULL,NULL,NULL,NULL,NULL,'3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-09-11','F','',':RET:2106-3','N','021','DEN','171040','99734OH005000401','2014-01-01','2013-12-13 14:24:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:08'),(21410,17112,'Y','18','024','14','A','','','TE','0001236606','0001236606','','IL','1','Vignos','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-22','M','',NULL,NULL,NULL,'','2757005','','2014-02-04','2014-02-04 15:28:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:07'),(19195,15293,'N','19','021','EC','A',NULL,NULL,'','0000427340','0000716143','','S1','1','WADE','STACY','','','','34','628746912','2610 CODY CT',0,'MIDLOTHIAN','TX','76065',NULL,'CY','48139','2000-10-31','F','',NULL,'N','021','DEN','2105914','33348TX002000101','2014-03-01','2014-01-20 14:18:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-21 08:46:14'),(9738,7710,'N','01','021','EC','A',NULL,NULL,'','0001150864','0000132368','','IL','1','guajardo','cruz','roberto','','','34','461877205','4834 U S HIGHWAY 59 N',0,'LIVINGSTON','TX','77351','0254','CY','48373','1962-05-03','M','',NULL,'N','021','DEN','250273','33348TX002000201','2014-01-01','2013-11-14 22:46:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:45:50'),(13135,10476,'N','01','021','EC','A',NULL,NULL,'','0001115938','0000020179','','IL','1','Carlton','Dustin','','','','34','279843288','1232 Shawnee Trail',0,'Streetsboro','OH','44241',NULL,'CY','39133','1976-08-18','M','',':RET:2106-3','N','021','DEN','2534743','99734OH005000401','2014-01-01','2013-12-23 15:07:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:07'),(14259,11373,'Y','18','021','EC','A','','','AC','0002354577','0002354577','LA00000110372','31','1','JASMINE','NELSON','','','','34','435845479','PO BOX 1242',0,'VICHERIE','LA','70090',NULL,'CY','22093','1951-09-24','M','U',':RET:2054-5','N','021','DEN','1839486','18575LA002000101','2014-02-01','2013-12-26 12:05:40','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-27 02:05:45'),(15829,12673,'Y','18','021','EC','A','','','AC','0000979310','0000979310','OH00001928298','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','DEN','2179776','99734OH005000401','2014-02-01','2014-01-02 16:50:36','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-01-03 02:03:47'),(17347,13878,'Y','18','021','EC','A','','','AC','0000532124','0000532124','OH00001414577','IL','1','Williams','Danae','','','','34','469233842','619 Koogler St.',0,'Fairborn','OH','45324',NULL,'CY','39057','1986-04-19','F','U',':RET:2054-5','N','021','HLT','2127585','92036OH004000501','2014-02-01','2014-01-09 19:45:48','0.00',NULL,NULL,'200.30','200.30','R-OH003','OH0','200.30',NULL,0,'2014-01-13 02:24:06'),(16317,13064,'N','01','021','EC','A',NULL,NULL,'','0001249435','0001180841','','IL','1','warner','shannon','','','','34','459350626','5400 BARKSDALE BLVD',0,'BOSSIER CITY','LA','71112','4538','CY','22015','1969-11-18','F','',':RET:2054-5','N','021','DEN','2589166','18575LA002000201','2014-02-01','2014-01-06 16:41:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:36'),(16647,13319,'Y','18','021','EC','A','','','AC','0001002438','0001002438','MS00001272549','IL','1','RHODES','JOHN','','','','34','426946142','14398 T-Bird Road',0,'Biloxi','MS','39532',NULL,'CY','28047','1949-07-24','M','M',':RET:2106-3','N','021','DEN','2568485','46300MS002000201','2014-02-01','2014-01-06 19:30:06','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2014-01-08 18:24:19'),(22387,17876,'Y','18','021','EC','A','','','AC','0000105416','0000105416','OH00002359885','IL','1','Bianco','Nicholas','','','','34','282826399','2598 Hidden Spring Lane',0,'Wadsworth','OH','44281',NULL,'CY','39103','1984-01-21','M','U',':RET:2106-3','T','021','HLT','3450733','52664OH151001306','2014-03-01','2014-02-10 12:10:48','179.00',NULL,NULL,'291.08','112.08','R-OH012','OH0','291.08',NULL,0,'2014-02-10 21:30:12'),(23413,18654,'N','01','021','EC','A',NULL,NULL,'','0000549595','0000502270','','IL','1','RIVERA','LINDA','','','','34','613368341','8126 TINA DR',0,'TYLER','TX','75703','4809','CY','48423','1970-10-14','F','',NULL,'N','021','DEN','3610613','33348TX002000201','2014-03-01','2014-02-12 19:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:17'),(23449,18679,'N','01','021','EC','A',NULL,NULL,'','0001219368','0000241129','','IL','1','CAROLSON','ERICA','','','','34','226619291','11001 S 1ST ST',0,'AUSTIN','TX','78748','6762','CY','48453','1986-07-10','F','',':RET:2106-3','N','021','DEN','2898416','33348TX002000201','2014-03-01','2014-02-13 13:06:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:36'),(24848,19700,'Y','18','021','EC','A','','','AC','0001073200','0001073200','OH00002888801','IL','1','Spangler','Wanda','','','','34','274568908','237 N HAREFOOTE RD',0,'TOLEDO','OH','43615','4823','CY','39095','1955-11-28','F','M',':RET:2106-3','N','021','HLT','2646501','92036OH006002601','2014-04-01','2014-02-19 13:33:13','295.00',NULL,NULL,'394.02','99.02','R-OH001','OH0','394.02',NULL,0,'2014-02-20 04:54:51'),(28965,22925,'Y','18','021','EC','A','','','AC','0001601688','0001601688','LA00002651567','IL','1','REESE','WILLIE','','','','34','436986144','313 W WASHINGTON ST',0,'NEW IBERIA','LA','70560','4365','CY','22045','1956-10-21','M','M',NULL,'N','021','DEN','4127115','18575LA002000201','2014-04-01','2014-03-10 15:14:15','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-03-10 21:00:59'),(19337,15415,'N','01','021','EC','A',NULL,NULL,'','0000730341','0000176498','','IL','1','lowe','katrina','m','','','34','573750400','505  w avenue j',0,'killeen','TX','76541',NULL,'CY','48027','1978-12-12','F','',':RET:2106-3','T','021','DEN','2998303','33348TX002000201','2014-03-01','2014-01-21 15:56:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-22 03:22:19'),(634,524,'Y','18','021','EC','A','','','AC','0001026923','0001026923','OH00000651685','IL','1','Seidenable','Gail','A','','','34','301544530','415 DARBY CT',0,'GALLOWAY','OH','43119','8708','CY','39049','1953-12-18','F','U',':RET:2106-3','T','021','DEN','2352443','99734OH005000401','2014-01-01','2013-12-16 13:19:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:01:11'),(789,651,'Y','18','021','EC','A','','','AC','0000220738','0000220738','TX00000944605','IL','1','Miles','Kristin','','','','34','438042132','403 AUDREY ST',0,'WHITEHOUSE','TX','75791','3243','CY','48423','1966-09-21','F','U',':RET:2106-3','N','021','DEN','1591488','33348TX002000201','2014-01-01','2013-12-16 16:00:26','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 18:05:16'),(14938,11937,'Y','18','021','EC','A','','','AC','0000145309','0000145309','MS00001689654','IL','1','Claiborne','John','','','','34','587987488','20 ALICE LN',0,'NATCHEZ','MS','39120','4424','CY','28001','1954-05-23','M','U',':RET:2054-5','N','021','DEN','1578724','46300MS002000101','2014-02-01','2013-12-29 11:20:12','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-30 00:02:12'),(5191,4118,'Y','18','021','EC','A','','','AC','0001096743','0001096743','OH00000513347','IL','1','Ceena','Sharon','M','','','34','083442803','5250 COLUMBIA RD',0,'NORTH OLMSTED','OH','44070','3531','CY','39035','1950-02-04','F','U',':RET:2106-3','N','021','DEN','1614982','99734OH005000401','2014-01-01','2013-12-19 13:41:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:48'),(1722,1436,'Y','18','021','EC','A','','','AC','0000283261','0000283261','OH00000031805','IL','1','Myers','Shannon','','','','34','286024519','1361 West Nimisila Rd',0,'New Franklin','OH','44216',NULL,'CY','39153','1997-09-24','F','R',':RET:2106-3','N','021','DEN','1867905','99734OH005000301','2014-01-01','2013-12-24 10:06:16','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','21.13',NULL,0,'2013-12-25 18:55:14'),(4624,3663,'Y','18','021','EC','A','','','AC','0001010957','0001010957','LA00000620051','IL','1','Grue','Teal','','','','34','435617031','509 PATTERSON DR',0,'NEW ORLEANS','LA','70114','1048','CY','22071','1970-01-12','M','U',':RET:2106-3','T','021','DEN','448219','18575LA002000101','2014-01-01','2013-12-12 12:58:18','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 22:06:20'),(4289,3412,'Y','18','024','14','A','','','TE','0000869506','0000869506','','IL','1','Johnson','Lakeishia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-26','F','',NULL,NULL,NULL,'','400413','','2013-12-16','2013-12-16 21:33:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 21:52:08'),(20322,16225,'Y','18','021','EC','A','','','AC','0001065207','0001065207','TX00002263883','IL','1','CISNEROS','ALBA','','','','34','456938640','440 BROTHERS RD',0,'CANUTILLO','TX','79835',NULL,'CY','48141','1957-07-21','F','U',NULL,'N','021','DEN','1548568','33348TX002000201','2014-03-01','2014-01-28 15:27:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-28 21:00:56'),(21525,17197,'Y','18','021','EC','A','','','AC','0000473263','0000473263','TX00001462791','IL','1','Chambers','Joe','','','','34','457573938','714 LIBERTY ST',0,'MALAKOFF','TX','75148','9731','CY','48213','1965-12-21','M','U',':RET:2054-5','N','021','DEN','3750228','33348TX002000101','2014-03-01','2014-02-04 19:31:39','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-05 21:30:04'),(21870,17461,'N','01','021','EC','A',NULL,NULL,'','0001356215','0001823380','','IL','1','watson','kentrell','c','','Sr','34','434238513','2360 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4454','CY','22071','1973-08-31','M','',':RET:2054-5','N','021','DEN','3604579','18575LA002000201','2014-03-01','2014-02-05 20:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-06 21:01:25'),(24682,19591,'Y','18','021','EC','A','','','AC','0000178090','0000178090','TX00002916522','IL','1','Murphree','Shelly','','','','34','459813320','333 COUNTY ROAD 2592',0,'SHELBYVILLE','TX','75973','2615','CY','48419','1971-12-11','F','U',':RET:2106-3','N','021','DEN','3720135','33348TX002000101','2014-04-01','2014-02-18 21:01:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:30:43'),(25087,19896,'Y','18','024','14','A','','','TE','0001459180','0001459180','','IL','1','LOPEZ','CONCION',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-08','M','',NULL,NULL,NULL,'','3099594','','2014-03-31','2014-02-21 10:25:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-21 21:30:03'),(25387,20142,'Y','18','021','EC','A','','','AC','0001195546','0001195546','OH00002213983','IL','1','Beers','Jennifer','','','','34','293868619','1514 COLLINWOOD CIR',0,'CUYAHOGA FALLS','OH','44221','3630','CY','39153','1980-01-21','F','U',NULL,'N','021','HLT','3543057','52664OH151001306','2014-04-01','2014-02-24 19:06:55','191.00',NULL,NULL,'270.73','79.73','R-OH012','OH0','270.73',NULL,0,'2014-02-25 21:30:50'),(26520,21032,'N','19','021','EC','A',NULL,NULL,'','0000294433','0000541704','','S1','1','Dietrich','Kara','M','','','34','268060473','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','2000-08-20','M','',NULL,'N','021','HLT','2621755','92036OH003002706','2014-03-01','2014-02-28 14:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-28 21:00:24'),(29209,23116,'Y','18','021','EC','A','','','AC','0001177804','0001177804','TX00003609996','IL','1','Boone','Kriserpher','','','','34','644010070','1425 CHEROKEE ST',0,'LONGVIEW','TX','75604','5780','CY','48183','1985-09-12','F','U',':RET:2054-5','N','021','DEN','3832274','33348TX002000201','2014-04-01','2014-03-10 13:21:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61','CIC',0,'2014-03-10 21:30:14'),(19273,15361,'Y','18','024','14','A','','','TE','0000234028','0000234028','','IL','1','Warner','Tammie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-06-19','F','',NULL,NULL,NULL,'','1140567','','2014-01-20','2014-01-20 10:35:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:56'),(17120,13701,'N','01','021','EC','A',NULL,NULL,'','0000643242','0001171902','','IL','1','MATHEWS','JO','A','','','34','271587983','253 S ALPHA BELLBROOK RD',0,'XENIA','OH','45385','9397','CY','39057','1954-09-01','F','',':RET:2106-3','N','021','DEN','1909219','99734OH005000401','2014-02-01','2014-01-08 10:25:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:41'),(15511,12409,'Y','18','021','EC','A','','','AC','0000674077','0000674077','OH00001561120','IL','1','Deeter','Mark','','','','34','300440970','488 US Route 42',0,'Ashland','OH','44805',NULL,'CY','39005','1960-06-24','M','U',':RET:2106-3','T','021','DEN','1411861','99734OH005000401','2014-02-01','2013-12-31 17:22:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:29:59'),(14464,11541,'Y','18','024','14','A','','','TE','0000016576','0000016576','','IL','1','JONES','ALBERTA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-14','F','',NULL,NULL,NULL,'','785445','','2013-12-27','2013-12-27 14:49:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:32:52'),(2403,1962,'N','01','021','EC','A',NULL,NULL,'','0000422793','0000545216','','IL','1','Price','Cynthia','Ann','','','34','297443390','5520 Ridgewood Rd. W.',0,'Springfield','OH','45503',NULL,'CY','39023','1956-04-22','F','',':RET:2106-3','N','021','DEN','112745','99734OH005000401','2014-01-01','2013-12-09 14:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:35'),(14921,11922,'Y','18','021','EC','A','','','AC','0001236585','0001236585','OH00001584929','IL','1','KERR','PAUL','','','Jr','34','302861873','11976 STATE ROUTE 691',0,'NELSONVILLE','OH','45764',NULL,'CY','39009','1974-02-20','M','U',':RET:2106-3','T','021','DEN','1442347','99734OH005000401','2014-02-01','2013-12-29 15:07:32','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-30 00:01:41'),(9523,7551,'N','01','021','EC','A',NULL,NULL,'','0000253042','0001065967','','IL','1','BESECE','KATHY','','','','34','292648101','4861 STATE ROUTE 152',0,'DILLONVALE','OH','43917','7902','CY','39081','1958-06-29','F','',NULL,'T','021','DEN','2268449','99734OH005000301','2014-01-01','2013-12-20 20:15:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:40'),(22268,17773,'N','01','021','EC','A',NULL,NULL,'','0000548053','0000546633','','IL','1','ADAM','AMIRA','YAGOUB','','','34','634250730','6606 De Moss Dr',0,'Houston','TX','77074',NULL,'CY','48201','1989-11-04','F','',':RET:2054-5','N','021','DEN','2889374','33348TX002000201','2014-03-01','2014-01-30 17:55:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-10 11:00:12'),(23852,18978,'N','19','021','EC','A',NULL,NULL,'','0000137621','0000176443','','S1','1','POTTKOTTER','ALAN','','','','34','283044152','282 SIEGRIST JUTTE RD',0,'FORT RECOVERY','OH','45846','9573','CY','39107','1999-06-01','F','',NULL,'N','021','HLT','3021951','92036OH005001501','2014-03-01','2014-02-14 16:35:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-02-14 21:31:59'),(26013,20631,'N','19','021','EC','A',NULL,NULL,'','0000016669','0000588029','','IL','1','MILLER','JARED','','','','34','289987859','833 ALLINGHAM ST',0,'VAN WERT','OH','45891','1005','CY','39161','1995-10-28','M','',':RET:2106-3','N','021','HLT','3762075','92036OH003001506','2014-03-01','2014-02-26 12:33:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-26 21:02:11'),(26194,20773,'Y','18','024','14','A','','','TE','0001204586','0001204586','','IL','1','ALSHAHAL','MANAL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-18','F','',NULL,NULL,NULL,'','2693744','','2014-02-27','2014-02-27 14:20:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:45'),(26493,21016,'Y','18','021','EC','A','','','AC','0002293461','0002293461','LA00003307124','31','1','Nguyen','Nhai','','','','34','586507721','po box 2124',0,'Morgan city','LA','70381',NULL,'CY','22101','1957-04-18','F','U',':RET:2047-9','N','021','DEN','3195461','18575LA002000201','2014-04-01','2014-02-28 17:48:05','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61','CIC',0,'2014-02-28 21:00:11'),(28031,22184,'Y','18','021','EC','A','','','AC','0000717883','0000717883','OH00003544992','IL','1','Schaefer','Adam','','','','34','297662887','5672 CHILDS AVE',0,'CINCINNATI','OH','45248','4206','CY','39061','1970-11-28','M','U',':RET:2106-3','N','021','DEN','3429731','99734OH005000401','2014-04-01','2014-03-06 17:10:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:27'),(29164,23084,'Y','18','024','14','A','','','TE','0001026995','0001026995','','IL','1','SHINDELDECKER','APRIL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-06-20','F','',NULL,NULL,NULL,'','3838613','','2014-03-10','2014-03-10 14:05:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:02:55'),(13962,11128,'N','01','021','EC','A',NULL,NULL,'','0000999849','0000726132','','IL','1','bryant','marcia','a','','','34','835787061','2350 LOWER BELLBROOK RD',0,'SPRING VALLEY','OH','45370','8774','CY','39057','1963-08-09','F','',NULL,'N','021','HLT','1480111','92036OH005000504','2014-01-01','2013-12-23 13:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','424.53',NULL,0,'2013-12-26 13:15:09'),(5324,4222,'Y','18','021','EC','A','','','AC','0000751007','0000751007','OH00001066496','IL','1','Nguyen','Loan','','','','34','274945133','7852 DENNLER LN',0,'CINCINNATI','OH','45247','5505','CY','39061','1958-11-19','F','U',':RET:2047-9','N','021','DEN','2493070','99734OH005000301','2014-01-01','2013-12-19 08:42:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:06:54'),(2978,2399,'Y','18','021','EC','A','','','AC','0000705120','0000705120','OH00000911600','IL','1','Isenbarger','John','','','','34','269821132','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1976-09-14','M','M',':RET:2106-3','T','021','DEN','1211363','99734OH005000301','2014-01-01','2013-12-05 19:26:50','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:17:10'),(2765,2235,'N','01','021','EC','A',NULL,NULL,'','0001183494','0001022741','','IL','1','Poff','Daniel','J','','Sr','34','300521732','1120 GRIGGS RD',0,'JEFFERSON','OH','44047','9754','CY','39007','1952-12-17','M','',':RET:2106-3','N','021','HLT','544468','52664OH151001305','2014-01-01','2013-12-02 15:13:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','706.77',NULL,0,'2013-12-25 19:49:24'),(1328,1099,'Y','18','021','EC','A','','','AC','0000178853','0000178853','OH00000300724','IL','1','Hardisty','Jacqueline','','','','34','546773417','7374 STONE VALLEY LN',0,'NEW ALBANY','OH','43054','9017','CY','39049','1982-08-21','F','U',':RET:2106-3','N','021','DEN','477437','99734OH005000301','2014-01-01','2013-10-25 11:43:46','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:32:00'),(1500,1252,'N','01','021','EC','A',NULL,NULL,'','0000675453','0000727281','','IL','1','Doeding','Mark','Edward','','','34','264251073','4081 GLEN ESTE WITHAMSVILLE RD',0,'CINCINNATI','OH','45245','2042','CY','39025','1955-08-27','M','',':RET:2106-3','N','021','DEN','2417825','99734OH005000401','2014-01-01','2013-12-24 12:03:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:16'),(16163,12941,'Y','18','021','EC','A','','','AC','0000772993','0000772993','TX00000744945','IL','1','barron','michael','','','','34','463047669','2119 Quite Falls Lane',0,'League City','TX','77573',NULL,'CY','48167','1955-11-07','M','M',NULL,'N','021','DEN','1901738','33348TX002000201','2014-01-01','2013-12-16 22:28:07','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-04 06:00:13'),(17223,13782,'Y','18','021','EC','A','','','AC','0000855650','0000855650','OH00002155878','IL','1','Cross','Pamela','','','','34','280606597','432 Harefoote St.',0,'Holland','OH','43528',NULL,'CY','39095','1957-05-14','F','U',':RET:2106-3','N','021','HLT','2030861','92036OH005002604','2014-02-01','2014-01-08 13:38:24','250.00',NULL,NULL,'454.92','204.92','R-OH001','OH0','454.92',NULL,0,'2014-01-13 02:22:35'),(17401,13925,'Y','18','021','EC','A','','','AC','0000257713','0000257713','MS00001459918','IL','1','McIntyre','Jessie','Mae','','','34','426029528','6029 WOODHAVEN RD',0,'JACKSON','MS','39206','2528','CY','28049','1953-12-18','F','U',':RET:2054-5','N','021','DEN','1630144','46300MS002000101','2014-02-01','2014-01-09 22:41:26','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-13 03:00:16'),(17881,14280,'N','01','021','EC','A',NULL,NULL,'','0000011183','0000757167','','IL','1','FENIMORE','TIMOTHY','J','','','34','278866709','6669 NANCY DR',0,'NORTH OLMSTED','OH','44070','4949','CY','39035','1980-08-23','M','',':RET:2106-3','N','021','DEN','2031028','99734OH005000401','2014-02-01','2014-01-14 14:29:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:16'),(19926,15890,'Y','18','021','EC','A','','','AC','0000445396','0000445396','MS00002273894','IL','1','GRANT','SHIRLEY','','','','34','425040737','7997 HAYNES CHAPEL RD',0,'PELAHATTHA','MS','39145',NULL,'CY','28121','1951-10-09','F','M',':RET:2106-3','N','021','DEN','3056742','46300MS002000101','2014-03-01','2014-01-23 21:26:24','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-24 21:01:06'),(18496,14753,'Y','18','021','EC','A','','','AC','0000195164','0000195164','OH00002213101','IL','1','Rodriguez','Guadalupe','','','','34','274024690','423 W 41ST ST',0,'ASHTABULA','OH','44004','5741','CY','39007','1969-02-08','M','M',NULL,'T','021','HLT','2581825','52664OH151001305','2014-02-01','2014-01-15 11:56:48','201.00',NULL,NULL,'404.08','203.08','R-OH011','OH0','404.08',NULL,0,'2014-01-16 08:46:28'),(20424,16313,'Y','18','021','EC','A','','','AC','0000035783','0000035783','OH00001815220','IL','1','JONES','ROBERT','','','','34','283469524','124 TOWNSHIP ROAD 1291',0,'PROCTORVILLE','OH','45669','8711','CY','39087','1949-12-18','M','M',NULL,'N','021','DEN','3446411','99734OH005000301','2014-03-01','2014-01-29 11:43:24','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-01-29 21:00:32'),(22002,17568,'N','19','021','EC','A',NULL,NULL,'','0000658460','0000159451','','IL','1','Mennetti','Collin',NULL,NULL,NULL,NULL,NULL,'612 DOUGLAS DR',0,'WAUSEON','OH','43567','1613','CY','39051','2007-06-12','M','',':RET:2106-3','N','021','DEN','3010499','99734OH005000301','2014-03-01','2014-02-06 19:01:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:48'),(22047,17598,'N','01','021','EC','A',NULL,NULL,'','0002109711','0001670279','','IL','1','Bankston','David','Russell','','','34','434880908','114 OAK POST RD',0,'LAFAYETTE','LA','70503','6106','CY','22055','1961-01-18','M','',':RET:2106-3','N','021','DEN','3167599','18575LA002000101','2014-03-01','2014-02-06 23:02:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02','CIC',0,'2014-02-07 19:30:04'),(24411,19391,'Y','18','021','EC','A','','','AC','0000267577','0000267577','OH00002879942','IL','1','SNYDER','SUSAN','','','','34','278528830','27 COMO ST',0,'STRUTHERS','OH','44471','1602','CY','39099','1950-12-21','F','M',NULL,'N','021','DEN','2914120','99734OH005000301','2014-04-01','2014-02-18 10:00:43','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-02-18 22:01:01'),(26193,20772,'Y','18','021','EC','A','','','AC','0001053109','0001053109','OH00003080367','IL','1','FRIEBEL','SHANNON','','','','34','293907534','1307 BRYDEN RD',0,'COLUMBUS','OH','43205','2046','CY','39049','1986-11-04','M','U',NULL,'N','021','DEN','3092627','99734OH005000301','2014-04-01','2014-02-27 13:59:18','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:45'),(26773,21218,'Y','18','024','14','A','','','TE','0001136991','0001136991','','IL','1','jurado','victor',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-08-03','M','',NULL,NULL,NULL,'','3302500','','2014-02-28','2014-02-28 18:15:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-01 21:00:09'),(18592,14823,'Y','18','021','EC','A','','','AC','0000991564','0000991564','OH00001643970','IL','1','George','Paula',NULL,NULL,NULL,NULL,NULL,'1730 HOMEWARD AVE',0,'LIMA','OH','45805','1107','CY','39003','1957-09-03','F','U',NULL,'N','021','HLT','1705616','92036OH006001501','2014-02-01','2014-01-15 14:50:43','323.00',NULL,NULL,'407.20','84.20','R-OH002','OH0','407.20',NULL,0,'2014-01-16 08:47:14'),(17888,14287,'Y','18','024','14','A','','','TE','0000519858','0000519858','','IL','1','Moxley','Candace',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-11','F','',NULL,NULL,NULL,'','2743760','','2014-01-14','2014-01-14 15:27:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:06:18'),(8011,6341,'Y','18','021','EC','A','','','AC','0000622542','0000622542','TX00000358603','31','1','Broadus','Cyndy','C','','','34','466922039','po box 5158',0,'Longview','TX','75608',NULL,'CY','48203','1958-11-02','F','M',':RET:2106-3','N','021','DEN','1595701','33348TX002000101','2014-01-01','2013-12-20 18:31:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 03:08:38'),(14633,11679,'Y','18','021','EC','A','','','AC','0001203227','0001203227','OH00000626390','IL','1','HUNDLEY','ROBERT','','','','34','263533272','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-09-28','M','M',NULL,'N','021','HLT','1741205','92036OH005001204','2014-02-01','2013-12-27 14:07:58','622.00',NULL,NULL,'957.44','335.44','R-OH004','OH0','478.72',NULL,0,'2013-12-28 03:37:14'),(1995,1634,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000866594','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','634156','33348TX002000101','2014-01-01','2013-11-19 23:07:33','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:02:03'),(2300,1873,'Y','18','021','EC','A','','','AC','0000109262','0000109262','OH00000865547','IL','1','Skelley','David','','','','34','283529862','5415 SPIETH RD',0,'MEDINA','OH','44256','9443','CY','39103','1954-09-30','M','M',NULL,'T','021','DEN','1083972','99734OH005000301','2014-01-01','2013-12-09 16:58:43','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:30:58'),(2313,1880,'Y','18','021','EC','A','','','AC','0001187557','0001187557','TX00000747149','IL','1','JAEB','JENNIFER','','','','34','473628022','13533 SPRUCEWOOD DR',0,'DALLAS','TX','75240','3630','CY','48113','1958-04-17','F','U',':RET:2106-3','N','021','DEN','479128','33348TX002000201','2014-01-01','2013-12-08 19:54:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:31:14'),(7624,6034,'Y','18','021','EC','A','','','AC','0000890711','0000890711','OH00000771119','IL','1','Burrows','Tammy','','','','34','283648544','501 Clifton Avenue',0,'Findlay','OH','45840',NULL,'CY','39063','1960-11-04','F','U',':RET:2106-3','T','021','HLT','735617','92036OH001001501','2014-01-01','2013-11-17 10:20:45','0.00',NULL,NULL,'622.80','622.80','R-OH002','OH0','622.80',NULL,0,'2013-12-26 02:46:00'),(7850,6216,'Y','18','021','EC','A','','','AC','0000982700','0000982700','OH00000749106','IL','1','Baker','Peggy','','','','34','284662374','1755 Shawnee RD',0,'Lima','OH','45805',NULL,'CY','39003','1958-08-01','F','U',':RET:2106-3','N','021','DEN','2088144','99734OH005000301','2014-01-01','2013-12-20 09:27:23','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 03:04:47'),(2549,2074,'N','01','021','EC','A',NULL,NULL,'','0001078865','0000982672','','IL','1','Miracle','Pamela','J','','','34','273588896','872 SKYSIDE DR',0,'CLINTON','OH','44216','9659','CY','39153','1956-05-13','F','',':RET:2106-3','N','021','HLT','1010156','52664OH151001501','2014-01-01','2013-12-09 13:25:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','651.81',NULL,0,'2013-12-25 19:37:14'),(20571,16441,'Y','18','021','EC','A','','','AC','0000318442','0000318442','OH00002110529','IL','1','martin','jasmine','','','','34','301920063','4806 Glendale Ave.',0,'Toledo','OH','43614',NULL,'CY','39095','1991-04-24','F','U',':RET:2054-5','N','021','HLT','1679306','92036OH002002601','2014-03-01','2014-01-29 17:12:08','142.00',NULL,NULL,'225.18','83.18','R-OH001','OH0','225.18',NULL,0,'2014-01-29 21:01:52'),(22489,17954,'N','19','021','EC','A',NULL,NULL,'','0000976762','0000817582','','IL','1','McOwen','Sarah','','','','34','297022308','112 E MAIN ST',0,'BEAVERDAM','OH','45808','9723','CY','39003','1998-04-18','F','',NULL,'N','021','DEN','3647458','99734OH005000301','2014-03-01','2014-02-10 12:25:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:07'),(25277,20055,'N','01','021','EC','A',NULL,NULL,'','0001132137','0001235584','','IL','1','Contreras','Virginia','','','','34','641289940','206 DE GAIL ST',0,'GRAND SALINE','TX','75140','1332','CY','48467','1974-12-16','F','',NULL,'N','021','DEN','3499800','33348TX002000201','2014-04-01','2014-02-25 11:11:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-02-25 21:00:15'),(25993,20614,'Y','18','021','EC','A','','','AC','0000360226','0000360226','MS00001891102','IL','1','Davis','Tyrone','','','','34','425272976','544 HILLANDALE DR',0,'JACKSON','MS','39212','3249','CY','28049','1974-01-21','M','U',':RET:2054-5','N','021','DEN','3233395','46300MS002000201','2014-03-01','2014-02-26 16:35:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:58'),(28333,22417,'Y','18','021','EC','A','','','AC','0000973980','0000973980','TX00002746943','IL','1','Breaux','Chaime','','','','34','458711394','104 Daffodil dr',0,'Killeen','TX','76542',NULL,'CY','48027','1984-12-23','M','R',':RET:2054-5','N','021','DEN','3577102','33348TX002000201','2014-04-01','2014-03-07 01:09:18','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-07 21:30:11'),(20194,16114,'Y','18','021','EC','A','','','AC','0000354205','0000354205','MS00001370851','IL','1','Barrett','Linda','a','','','34','587665103','78 Keyes Rd.',0,'Laurel','MS','39443',NULL,'CY','28067','1951-08-16','F','M',':RET:2106-3','N','021','DEN','2855069','46300MS002000101','2014-03-01','2014-01-27 10:49:15','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-27 21:01:28'),(18119,14471,'N','01','021','EC','A',NULL,NULL,'','0000409765','0000510668','','IL','1','Reddick','Michael','','','','34','301809687','942 CANTON RD NW',0,'CARROLLTON','OH','44615','8402','CY','39019','1968-04-24','M','',':RET:2106-3','N','021','HLT','1878356','52664OH152000901','2014-02-01','2014-01-14 13:17:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','235.86',NULL,0,'2014-01-15 02:07:40'),(17487,13982,'Y','18','021','EC','A','','','AC','0000341540','0000341540','TX00001571616','IL','1','NICOLAS','MARIA','D','','','34','453879659','4001 E KELLY',0,'PHARR','TX','78577',NULL,'CY','48215','1980-12-14','F','U',':RET:2106-3','N','021','DEN','2026539','33348TX002000201','2014-02-01','2014-01-12 17:30:42','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-13 03:01:17'),(13757,10980,'Y','18','021','EC','A','','','AC','0000264228','0000264228','MS00000362265','IL','1','Fawcett','Randall','','','','34','259824124','7048 EDGEWATER DR',0,'RIDGELAND','MS','39157','1011','CY','28089','1950-12-25','M','M',':RET:2106-3','N','021','DEN','2499400','46300MS002000201','2014-01-01','2013-12-23 05:54:11','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:06'),(16782,13423,'N','01','021','EC','A',NULL,NULL,'','0000043242','0000611967','','IL','1','Gilliland','Brian','','','','34','301845813','909 ROSEWOOD DR',0,'CELINA','OH','45822','1330','CY','39107','1985-03-15','M','',':RET:2106-3','T','021','HLT','1363070','92036OH003001506','2014-02-01','2014-01-07 15:56:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','287.32',NULL,0,'2014-01-08 18:25:06'),(4154,3311,'Y','18','021','EC','A','','','AC','0000374693','0000374693','OH00000220983','IL','1','Smith','Robert','J','','Jr','34','282542943','21506 HALBURTON RD',0,'BEACHWOOD','OH','44122','3919','CY','39035','1957-03-20','M','M',NULL,'N','021','DEN','2277583','99734OH005000301','2014-01-01','2013-12-17 14:50:06','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:48:50'),(5109,4048,'Y','18','024','14','A','','','TE','0000916063','0000916063','','IL','1','Naizer','Noel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-07','F','',NULL,NULL,NULL,'','427341','','2013-12-19','2013-12-19 17:39:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:38'),(26009,20628,'Y','18','021','EC','A','','','AC','0000373679','0000373679','OH00002708543','IL','1','MARX','CONNIE','','','','34','285588602','154 W MAIN ST',0,'NORWALK','OH','44857','2072','CY','39077','1961-09-11','F','U',NULL,'N','021','HLT','3732130','92036OH005002705','2014-03-01','2014-02-26 10:16:22','334.00',NULL,NULL,'380.63','46.63','R-OH006','OH0','380.63',NULL,0,'2014-02-26 21:02:09'),(26225,20799,'Y','18','021','EC','A','','','AC','0000952733','0000952733','TX00002257476','IL','1','Lobato','Rebecca','','','','34','460457239','13401 METRIC BLVD',0,'AUSTIN','TX','78727','3319','CY','48453','1963-04-12','F','U',NULL,'N','021','DEN','3421465','33348TX002000201','2014-03-01','2014-02-26 21:04:26','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-28 06:30:58'),(27017,21400,'Y','18','024','14','A','','','TE','0000195181','0000195181','','IL','1','MAROUS','TAMMY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-14','F','',NULL,NULL,NULL,'','3742724','','2014-03-31','2014-03-03 10:49:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:11'),(28348,22429,'N','01','021','EC','A',NULL,NULL,'','0000290828','0000847511','','IL','1','Lewis','Olen','','','III','34','458451712','3514 TINA ST',0,'SACHSE','TX','75048','3168','CY','48113','1965-01-23','M','',':RET:2054-5','N','021','DEN','3883097','33348TX002000201','2014-04-01','2014-03-07 11:56:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-07 21:30:21'),(28668,22686,'Y','18','021','EC','A','','','AC','0001314167','0001314167','LA00002751665','IL','1','Williams','Lakesha','','','','34','435655835','10240 HERITAGE DR',0,'NEW ORLEANS','LA','70127','1810','CY','22071','1973-09-11','F','U',':RET:2054-5','N','021','DEN','3732523','18575LA002000201','2014-04-01','2014-03-08 15:46:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:47'),(1674,1396,'N','01','021','EC','A',NULL,NULL,'','0000175106','0000060266','','IL','1','Phelps','Michele','','','','34','285880788','500 HARRISON LN',0,'ANDERSON','OH','45244','2205','CY','39025','1976-10-18','F','',':RET:2106-3','N','021','HLT','1387674','92036OH005000605','2014-01-01','2013-12-24 05:22:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.76',NULL,0,'2013-12-25 18:53:56'),(20558,16429,'Y','18','021','EC','A','','','AC','0000509204','0000509204','OH00001743089','IL','1','JONES','CHARLES','','','','34','092408370','10530 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','9649','CY','39173','1950-02-16','M','M',NULL,'T','021','HLT','2481727','92036OH004002601','2014-03-01','2014-01-29 16:56:48','310.00',NULL,NULL,'940.42','630.42','R-OH001','OH0','540.92',NULL,0,'2014-01-29 21:01:45'),(5593,4438,'Y','18','021','EC','A','','','AC','0000269137','0000269137','MS00000296945','IL','1','Watkins','Larry','','','','34','435985357','635 POST OAK PL',0,'PEARL','MS','39208','5534','CY','28121','1961-08-22','M','U',':RET:2106-3','T','021','DEN','118967','46300MS002000101','2014-01-01','2013-11-06 12:53:24','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 23:17:20'),(20197,16116,'N','19','021','EC','A',NULL,NULL,'','0001090011','0000215323','','IL','1','perkins','nuriel','','','','34','415891673','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','2000-10-17','F','',':RET:2054-5','N','021','DEN','3156092','46300MS002000101','2014-03-01','2014-01-27 10:50:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-01-27 21:01:30'),(5304,4204,'Y','18','021','EC','A','','','AC','0001105935','0001105935','MS00001209311','IL','1','Perkins','Evon','','','','34','587540088','2880 CARLETON ST',0,'JACKSON','MS','39212','2703','CY','28049','1952-12-16','F','M',':RET:2054-5','N','021','DEN','2555147','46300MS002000101','2014-01-01','2013-12-18 19:19:04','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 23:06:22'),(20165,16091,'N','01','021','EC','A',NULL,NULL,'','0000393706','0000584306','','IL','1','alsawaeer','hiba','','','','34','269176002','1218 BUCKINGHAM GATE BLVD',0,'CUYAHOGA FALLS','OH','44221','5327','CY','39153','1986-01-21','F','',NULL,'N','021','DEN','3243691','99734OH005000301','2014-03-01','2014-01-27 16:07:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:01:11'),(18193,14524,'Y','18','024','14','A','','','TE','0000729995','0000729995','','IL','1','Alicea','Anthony','Philip',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-03-06','M','',NULL,NULL,NULL,'','2722660','','2014-01-14','2014-01-14 13:33:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:08:04'),(18137,14483,'Y','18','021','EC','A','','','AC','0002089507','0002089507','LA00001452572','IL','1','Herod','Candace','','','','34','434883430','8210 Cypress Road',0,'Baton Rouge','LA','70811',NULL,'CY','22033','1950-07-14','F','U',':RET:2054-5','N','021','DEN','2026579','18575LA002000101','2014-02-01','2014-01-13 22:39:52','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-15 02:07:45'),(9451,7498,'Y','18','021','EC','A','','','AC','0000515828','0000515828','OH00000522903','IL','1','hamman','matthew','','','','34','279729488','1478 west 6th ave',0,'columbus','OH','43212',NULL,'CY','39049','1961-06-25','M','M',':RET:2106-3','N','021','DEN','1394944','99734OH005000401','2014-01-01','2013-12-20 21:44:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:33:58'),(14011,11162,'Y','18','021','EC','A','','','AC','0000433888','0000433888','OH00000975445','IL','1','Verga','Cosette','','','','34','218491885','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1988-08-11','F','M',':RET:2106-3','N','021','HLT','2109334','92036OH003000606','2014-01-01','2013-12-23 14:32:53','319.00',NULL,NULL,'454.64','135.64','R-OH005','OH0','225.08',NULL,0,'2013-12-26 13:16:22'),(22741,18156,'Y','18','021','EC','A','','','AC','0002358383','0002358383','LA00001777466','IL','1','WILSON','RUSSELL','','','','34','436906683','1715 DEBORAH DR',0,'SAINT BERNARD','LA','70085','4811','CY','22087','1954-08-23','M','M',':RET:2106-3','N','021','DEN','3806865','18575LA002000201','2014-03-01','2014-02-11 17:14:02','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:20'),(23803,18940,'Y','18','021','EC','A','','','AC','0000322195','0000322195','OH00001676997','IL','1','Duffy','Colin','','','','34','296928574','2988 CARLTON RD',0,'SHAKER HEIGHTS','OH','44122','2504','CY','39035','1987-05-24','M','U',':RET:2106-3','N','021','HLT','2928856','52664OH151001301','2014-03-01','2014-02-14 17:13:15','0.00',NULL,NULL,'257.56','257.56','R-OH011','OH0','257.56',NULL,0,'2014-02-14 21:31:30'),(25033,19850,'N','01','021','EC','A',NULL,NULL,'','0001792367','0001736419','','IL','1','Ellzey','Charles','','','','34','434770659','29469 Joe Albin Rd',0,'Livingston','LA','70754',NULL,'CY','22063','1975-09-15','M','',':RET:2106-3','N','021','DEN','2861195','18575LA002000101','2014-04-01','2014-02-20 12:19:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-20 22:01:04'),(25628,20332,'N','19','021','EC','A',NULL,NULL,'','0000685891','0000152036','','IL','1','Tucker','Brady','','','','34','291082360','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2003-11-27','M','',':RET:2106-3','N','021','DEN','3742050','99734OH005000301','2014-04-01','2014-02-21 19:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 08:30:21'),(17033,13628,'Y','18','021','EC','A','','','AC','0001781665','0001781665','LA00001231634','IL','1','HEBERT','ANDRE','','','','34','436799674','510 ASHLAND DR',0,'THIBODAUX','LA','70301','6903','CY','22057','1988-01-04','F','U',':RET:2106-3','N','021','DEN','2063812','18575LA002000101','2014-02-01','2014-01-09 14:12:26','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-13 02:20:46'),(15926,12752,'N','01','021','EC','A',NULL,NULL,'','0000178548','0001185941','','IL','1','Temple','Sondra','','','','34','427378297','448 OLD RIVER RD',0,'PETAL','MS','39465','9105','CY','28035','1964-12-03','F','',':RET:2106-3','T','021','DEN','2458854','46300MS002000201','2014-02-01','2014-01-02 15:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-03 02:06:47'),(14974,11969,'Y','18','021','EC','A','','','AC','0001142397','0001142397','TX00002014068','IL','1','BENJAMIN','LORIN','','','','34','228969895','1350 DANDERA HWY',0,'KERRVILLE','TX','78028',NULL,'CY','48265','1958-12-20','F','U',NULL,'N','021','DEN','2303454','33348TX002000201','2014-02-01','2013-12-30 12:59:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:00:55'),(4702,3727,'Y','18','021','EC','A','','','AC','0000740250','0000740250','OH00001189049','IL','1','Lavelle','Nancy','','','','34','293682011','1 Bratenahl Place',0,'Bratenahl','OH','44108',NULL,'CY','39035','1974-03-31','F','U',':RET:2106-3','N','021','HLT','362038','92036OH004000801','2014-01-01','2013-12-12 11:20:31','0.00',NULL,NULL,'237.24','237.24','R-OH011','OH0','237.24',NULL,0,'2013-12-25 22:08:27'),(3431,2756,'Y','18','021','EC','A','','','AC','0001617687','0001617687','LA00000195343','IL','1','Hughes','Kiera','','','','34','438799171','2448 Williamsburg Dr.',0,'Laplace','LA','70068',NULL,'CY','22095','1990-10-15','F','U',':RET:2054-5','N','021','DEN','1496336','18575LA002000101','2014-01-01','2013-12-21 21:43:33','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:18:56'),(7804,6181,'Y','18','021','EC','A','','','AC','0000556368','0000556368','TX00000814312','IL','1','Grayson','Pamela','','','','34','525131608','2676 CHASE LN',0,'CRANDALL','TX','75114','5083','CY','48257','1963-12-02','F','M',':RET:2106-3','T','021','DEN','1438003','33348TX002000201','2014-01-01','2013-12-20 16:36:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 03:03:45'),(2562,2083,'Y','18','021','EC','A','','','AC','0001063209','0001063209','OH00001138360','IL','1','Wilson','Darl','','','','34','274524217','200 PARK AVE',0,'TIFFIN','OH','44883','1040','CY','39147','1953-02-17','M','M',':RET:2106-3','N','021','HLT','1050282','92036OH003002701','2014-01-01','2013-12-09 16:09:01','987.00',NULL,NULL,'1027.73','40.73','R-OH006','OH0','552.66',NULL,0,'2013-12-25 19:37:30'),(2324,1890,'Y','18','024','14','A','','','TE','0000914738','0000914738','','IL','1','Witt','Cody',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-12','M','',NULL,NULL,NULL,'','656255','','2013-12-09','2013-12-09 08:13:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:31:29'),(2091,1712,'Y','18','021','EC','A','','','AC','0001044645','0001044645','LA00000842348','IL','1','breaux','harry','','','','34','436231521','702 thomas st',0,'abbeville','LA','70510',NULL,'CY','22113','1968-06-15','M','M',':RET:2106-3','T','021','DEN','438934','18575LA002000201','2014-01-01','2013-12-10 16:51:38','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:16:53'),(399,328,'Y','18','021','EC','A','','','AC','0000045732','0000045732','OH00001277477','IL','1','Bounce','Joseph','','','','34','301561702','2799 CORY AVE',0,'AKRON','OH','44314','1364','CY','39153','1954-06-23','M','M',':RET:2106-3','N','021','DEN','1007399','99734OH005000401','2014-01-01','2013-12-03 20:32:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:46:06'),(21025,16801,'Y','18','021','EC','A','','','AC','0000206490','0000206490','MS00002431551','IL','1','draper','julia','','','','34','267881614','7229 AKIKAI DR',0,'DIAMONDHEAD','MS','39525','3908','CY','28045','1950-03-31','F','M',':RET:2106-3','N','021','DEN','3734128','46300MS002000201','2014-03-01','2014-02-01 14:03:57','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2014-02-01 19:00:42'),(25039,19856,'Y','18','021','EC','A','','','AC','0001048041','0001048041','OH00002082316','IL','1','Zink','Eileen','','','','34','272520462','3868 Yale Avenue',0,'Lima','OH','45804',NULL,'CY','39003','1951-10-30','F','U',':RET:2106-3','N','021','HLT','2776656','92036OH003001504','2014-04-01','2014-02-20 08:37:59','535.00',NULL,NULL,'660.32','125.32','R-OH002','OH0','660.32',NULL,0,'2014-02-20 22:01:08'),(25169,19964,'Y','18','021','EC','A','','','AC','0000595190','0000595190','OH00002338115','IL','1','Cotruta','Gabriel','','','','34','285065390','23839 David dr.',0,'North Olmsted','OH','44070',NULL,'CY','39035','1975-08-19','M','U',':RET:2106-3','T','021','DEN','3296991','99734OH005000401','2014-04-01','2014-02-21 09:27:05','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:26'),(26137,20725,'N','01','021','EC','A',NULL,NULL,'','0001204586','0000236326','','IL','1','HABLI','FIRAS','','','','34','290110182','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','1976-01-05','M','',':RET:2106-3','N','021','DEN','3501190','99734OH005000401','2014-03-01','2014-02-27 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:24'),(26579,21073,'Y','18','021','EC','A','','','AC','0000029097','0000029097','OH00003027811','IL','1','SPASOFF','PETER','','','','34','377582263','7984 STONEGATE DR',0,'CINCINNATI','OH','45255','3166','CY','39061','1952-07-23','M','M',':RET:2106-3','N','021','DEN','3524585','99734OH005000401','2014-04-01','2014-02-28 13:34:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:29'),(17592,14061,'N','01','021','EC','A',NULL,NULL,'','0000661369','0000950694','','IL','1','Marshall','Stephen','','','','34','269500212','4235 U.S. Route 127 South',0,'Greenville','OH','45331',NULL,'CY','39037','1954-06-06','M','',':RET:2106-3','N','021','HLT','1459916','92036OH003000505','2014-02-01','2014-01-12 18:31:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','646.18',NULL,0,'2014-01-14 01:32:10'),(3992,3187,'Y','18','021','EC','A','','','AC','0000642063','0000642063','OH00000090041','IL','1','Joyce','Joseph','','','','34','290801110','8399 Bennett Dr',0,'Piqua','OH','45356',NULL,'CY','39109','1964-07-01','M','U',':RET:2106-3','N','021','HLT','211255','92036OH004000501','2014-01-01','2013-12-13 15:05:27','252.00',NULL,NULL,'326.08','74.08','R-OH003','OH0','326.08',NULL,0,'2013-12-25 21:39:07'),(4103,3279,'Y','18','021','EC','A','','','AC','0000834074','0000834074','TX00000018599','IL','1','Williams','Autry','','','','34','464040546','934 GLADEWATER DR',0,'FRISCO','TX','75033','7444','CY','48121','1956-09-24','M','M',':RET:2054-5','N','021','DEN','2150443','33348TX002000101','2014-01-01','2013-12-17 01:53:47','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:47:47'),(7020,5574,'Y','18','021','EC','A','','','AC','0000140591','0000140591','TX00001280861','IL','1','Escamia','James','','','','34','644037225','103 LEGEND DR',0,'VICTORIA','TX','77904','3853','CY','48469','1987-02-13','M','U',':RET:2106-3','N','021','DEN','1507405','33348TX002000201','2014-01-01','2013-12-24 21:33:26','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-26 01:48:49'),(17073,13663,'Y','18','021','EC','A','','','AC','0001071631','0001071631','TX00002241442','IL','1','ARMOND','KIMBERLY','S','','','34','467535318','105 N ALEXANDER ST',0,'BELTON','TX','76513','2959','CY','48027','1966-05-10','F','M',':RET:2106-3','T','021','DEN','1939701','33348TX002000201','2014-02-01','2014-01-08 11:19:31','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-13 02:21:18'),(8080,6398,'N','19','021','EC','A',NULL,NULL,'','0000923318','0000981609','','IL','1','Hoehn','Morgan','M','','','34','288981726','7109 Daleview Road',0,'Cincinnati','OH','45247',NULL,'CY','39061','1995-08-29','F','',':RET:2106-3','N','021','HLT','2015120','92036OH004001201','2014-01-01','2013-12-20 14:51:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 03:10:26'),(16684,13350,'Y','18','021','EC','A','','','AC','0000424043','0000424043','OH00002043285','IL','1','Jacobs','nancylee','','','','34','330465907','11112 OBEE RD',0,'WHITEHOUSE','OH','43571','9207','CY','39095','1951-06-08','F','U',NULL,'N','021','DEN','2489625','99734OH005000301','2014-02-01','2014-01-07 18:14:24','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-08 18:24:32'),(15667,12536,'Y','18','021','EC','A','','','AC','0000910535','0000910535','OH00002088753','IL','1','Ayers','Jeremy',NULL,NULL,NULL,NULL,NULL,'1802 Rosewood Drive',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1973-07-31','M','M',':RET:2106-3','N','021','HLT','1392798','92036OH004001501','2014-02-01','2013-12-31 08:35:53','298.00',NULL,NULL,'782.39','484.39','R-OH002','OH0','226.17',NULL,1,'2014-01-02 04:34:39'),(9642,7639,'Y','18','021','EC','A','','','AC','0000829314','0000829314','TX00001110170','IL','1','Polk','Leah','','','','34','636201623','7205 Hart Lane',0,'Aledo','TX','78731','2422','CY','48453','1990-10-04','F','U',':RET:2106-3','N','021','DEN','1601687','33348TX002000101','2014-01-01','2013-12-21 14:07:59','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 04:38:31'),(14734,11763,'Y','18','021','EC','A','','','AC','0000221300','0000221300','OH00001107826','IL','1','Jundi','Lisa','Marie','','','34','287769820','324 ASHLAND AVE',0,'CUYAHOGA FALLS','OH','44221','2210','CY','39153','1979-06-18','F','M',':RET:2106-3','N','021','HLT','2414224','52664OH151001301','2014-02-01','2013-12-28 14:13:07','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,1,'2013-12-29 11:09:51'),(14540,11603,'Y','18','021','EC','A','','','AC','0001213447','0001213447','MS00000650870','31','1','MYERS','TASHA','','','','34','428334796','POBOX 982',0,'BYRAM','MS','39272',NULL,'CY','28049','1973-10-13','F','M',':RET:2054-5','N','021','DEN','2009582','46300MS002000201','2014-02-01','2013-12-27 13:36:10','0.00',NULL,NULL,'72.22','72.22','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:47'),(23740,18902,'Y','18','021','EC','A','','','AC','0000015310','0000015310','OH00002822905','IL','1','Misseldine','Ava','','','','34','291882804','3521 WESTBAY DR',0,'COLUMBUS','OH','43231','7339','CY','39049','1972-12-28','F','U',':RET:2079-2^:RET:2106-3','N','021','DEN','2668276','99734OH005000301','2014-03-01','2014-02-13 22:37:30','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-14 21:31:03'),(25190,19981,'Y','18','021','EC','A','','','AC','0001497895','0001497895','LA00002994271','IL','1','Barbee','James','','','','34','225024008','2136 CADIZ ST',0,'NEW ORLEANS','LA','70115','5926','CY','22071','1969-07-24','M','U',NULL,'N','021','DEN','3580330','18575LA002000101','2014-04-01','2014-02-20 23:16:05','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-21 22:00:39'),(26271,20838,'Y','18','024','14','A','','','TE','0000782785','0000782785','','IL','1','Jarmon','Tiana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-01-21','F','',NULL,NULL,NULL,'','2532397','','2014-03-14','2014-02-27 17:47:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-28 06:31:16'),(2378,1940,'Y','18','021','EC','A','','','AC','0000338851','0000338851','OH00000821287','IL','1','Murphy','Michelle','','','','34','269807096','265 E315th st',0,'Willowick','OH','44095',NULL,'CY','39085','1967-06-22','F','U',':RET:2106-3','N','021','DEN','962198','99734OH005000401','2014-01-01','2013-12-09 10:25:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:32:56'),(2471,2011,'Y','18','021','EC','A','','','AC','0000375246','0000375246','LA00000674578','IL','1','Bourgeois','Adam','','','','34','433771925','43478 HIGHWAY 621',0,'GONZALES','LA','70737','7444','CY','22005','1986-05-07','M','U',':RET:2106-3','N','021','DEN','1141639','18575LA002000201','2014-01-01','2013-12-08 22:09:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:13'),(20801,16621,'Y','18','021','EC','A','','','AC','0000866638','0000866638','TX00002040236','IL','1','Lester','Frances','','','','34','466635953','8601 WESTLINE DR',0,'EL PASO','TX','79904','2561','CY','48141','1968-03-02','F','U',NULL,'N','021','DEN','3533937','33348TX002000201','2014-03-01','2014-01-31 13:59:16','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:22'),(2910,2346,'Y','18','021','EC','A','','','AC','0000162247','0000162247','OH00000468886','IL','1','SHORT','ADAM','','','','34','292886274','4973 WABASH DR',0,'FAIRFIELD','OH','45014','1564','CY','39017','1988-04-10','M','M',NULL,'N','021','DEN','991471','99734OH005000401','2014-01-01','2013-12-06 11:24:04','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:32'),(7689,6089,'Y','18','021','EC','A','','','AC','0000795506','0000795506','OH00000367115','IL','1','Griffen','Steven','','','','34','407339325','5717 MONTGOMERY RD',0,'CINCINNATI','OH','45212','1932','CY','39061','1983-01-09','M','M',':RET:2106-3','N','021','DEN','1378177','99734OH005000401','2014-01-01','2013-12-19 21:05:18','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:00:58'),(15372,12295,'Y','18','024','14','A','','','TE','0000213099','0000213099','','IL','1','Creswell','Priestly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-10-17','F','',NULL,NULL,NULL,'','1615469','','2014-01-01','2014-01-01 10:41:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2014-01-02 04:25:08'),(9199,7296,'Y','18','021','EC','A','','','AC','0000896951','0000896951','OH00000663139','IL','1','BIGGERT','ROBIN','S','','','34','298627697','23675 STATE ROUTE 51 W',0,'GENOA','OH','43430','9769','CY','39123','1961-09-26','F','M',':RET:2106-3','N','021','HLT','1370172','92036OH005002701','2014-01-01','2013-12-18 10:18:47','0.00',NULL,NULL,'380.63','380.63','R-OH006','OH0','380.63',NULL,0,'2013-12-26 04:09:36'),(13130,10472,'Y','18','021','EC','A','','','AC','0001221940','0001221940','OH00000535636','IL','1','POLK','HOLLAND','','','','34','268565151','3103 MERRIWEATHER RD',0,'SANDUSKY','OH','44870',NULL,'CY','39043','1954-09-20','F','U',':RET:2054-5','N','021','DEN','1378410','99734OH005000401','2014-01-01','2013-12-23 14:34:21','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 12:52:59'),(15260,12198,'Y','18','021','EC','A','','','AC','0000071650','0000071650','OH00001064444','IL','1','TRAPNELL','TAMARA','','','','34','301549318','945 PRAIRIE RD',0,'WILMINGTON','OH','45177',NULL,'CY','39027','1959-10-10','F','U',':RET:2106-3','N','021','HLT','1758196','92036OH004000601','2014-02-01','2013-12-30 14:33:48','365.84',NULL,NULL,'368.53','2.69','R-OH005','OH0','368.53',NULL,0,'2014-01-01 12:09:14'),(24821,19679,'Y','18','021','EC','A','','','AC','0000759752','0000759752','OH00002699801','IL','1','VALLEE','BRENDA DIANE','','','','34','278583433','220 WASHINGTON AVE',0,'WILMINGTON','OH','45177','1130','CY','39027','1955-10-28','F','U',':RET:2106-3','N','021','HLT','3814777','92036OH004000601','2014-04-01','2014-02-19 14:25:55','334.00',NULL,NULL,'439.81','105.81','R-OH005','OH0','439.81',NULL,0,'2014-02-20 04:50:36'),(29178,23093,'Y','18','021','EC','A','','','AC','0000763594','0000763594','OH00003295792','IL','1','BRUMBAUGH','CAROLYN','','','','34','281482976','7364 MCMECHAM RD',0,'GREENVILLE','OH','45331','9411','CY','39037','1951-07-31','F','M',NULL,'T','021','HLT','4210067','92036OH005000506','2014-04-01','2014-03-10 16:42:28','619.00',NULL,NULL,'785.37','166.37','R-OH003','OH0','785.37',NULL,0,'2014-03-10 21:03:03'),(18584,14818,'N','19','021','EC','A',NULL,NULL,'','0000322165','0000986033','','IL','1','Marmer','Emily','','','','34','284048518','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1999-08-07','F','',':RET:2039-6^:RET:2106-3','N','021','HLT','1856858','92036OH002001201','2014-02-01','2014-01-15 01:42:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-16 08:47:10'),(4934,3915,'Y','18','021','EC','A','','','AC','0000392349','0000392349','OH00000993288','IL','1','Griffin','Paula','','','','34','274745472','19 WOODSIDE DR',0,'ARCANUM','OH','45304','1345','CY','39037','1962-04-02','F','U',':RET:2106-3','N','021','DEN','1241879','99734OH005000401','2014-01-01','2013-12-07 12:42:12','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:45:30'),(18412,14689,'Y','18','021','EC','A','','','AC','0001953617','0001953617','LA00002149957','IL','1','Cano','Elsa','','','','34','639307934','8016 DESOTO ST',0,'METAIRIE','LA','70003','6304','CY','22051','1958-09-21','F','M',':RET:2106-3','N','021','DEN','1414628','18575LA002000201','2014-02-01','2014-01-14 20:50:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:47'),(18113,14467,'Y','18','021','EC','A','','','AC','0000991559','0000991559','OH00001512678','IL','1','Scroggins','Timothy','','','','34','454419230','5666 RICHMAN RD',0,'SPENCER','OH','44275','9788','CY','39103','1963-12-09','M','M',':RET:2106-3','T','021','HLT','2460330','52664OH152000901','2014-02-01','2014-01-13 20:17:41','0.00',NULL,NULL,'890.00','890.00','R-OH012','OH0','335.49',NULL,0,'2014-01-15 02:07:38'),(17706,14149,'Y','18','021','EC','A','','','AC','0001795868','0001795868','LA00001553081','IL','1','CARTER','DOUGLAS','','','','34','439316536','828 E VERSAILLES DR',0,'BATON ROUGE','LA','70819','3345','CY','22033','1970-11-09','M','U',':RET:2106-3','N','021','DEN','2218610','18575LA002000201','2014-02-01','2014-01-13 14:15:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:07'),(1571,1311,'N','01','021','EC','A',NULL,NULL,'','0001163127','0001258017','','IL','1','Nguyen','Quy','Viet','','','34','637158015','6619 VICTORIA AVE',0,'DALLAS','TX','75209','4522','CY','48113','1971-01-02','M','',':RET:2047-9','N','021','DEN','1753764','33348TX002000201','2014-01-01','2013-12-24 09:09:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:51:11'),(17443,13953,'N','19','021','EC','A',NULL,NULL,'','0001030389','0001239139','','S1','1','DUFRESNE','DAVID','','','','34','298047644','3522 WALBRIDGE RD',0,'MILLBURY','OH','43447','9741','CY','39173','2000-05-18','F','',':RET:2106-3','N','021','HLT','2394519','92036OH004002601','2014-02-01','2014-01-10 16:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-01-13 03:00:36'),(16805,13441,'Y','18','021','EC','A','','','AC','0000944356','0000944356','TX00002557771','31','1','RAMIEREZ','SAMUEL','','','','34','460413217','P O BOX  1413',0,'CLINT','TX','79836',NULL,'CY','48141','1963-09-02','M','U',NULL,'N','021','DEN','1913498','33348TX002000201','2014-02-01','2014-01-11 13:16:49','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:18:13'),(15320,12252,'Y','18','021','EC','A','','','AC','0000273967','0000273967','TX00001994670','IL','1','Hamilton','Chamica','','','','34','459374351','4214 Magnolia St.',0,'Texarkana','TX','75503',NULL,'CY','48037','1976-04-22','F','U',':RET:2054-5','N','021','DEN','2548799','33348TX002000201','2014-02-01','2013-12-31 20:48:26','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,1,'2014-01-02 04:23:31'),(9341,7404,'Y','18','021','EC','A','','','AC','0001787673','0001787673','LA00000230570','IL','1','Daniel','Yolanda','Gail','','','34','433290486','323 DUTCHMAN DR',0,'MONROE','LA','71203','2460','CY','22073','1967-05-31','F','U',':RET:2054-5','N','021','DEN','2202977','18575LA002000201','2014-01-01','2013-12-20 20:45:25','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 04:30:59'),(25806,20464,'N','01','021','EC','A',NULL,NULL,'','0000825956','0000407427','','IL','1','Fluegel','Cherie','A','','','34','041607850','524 CHAPEL RD',0,'AMELIA','OH','45102','9738','CY','39025','1963-11-11','F','',':RET:2106-3','N','021','DEN','2843167','99734OH005000301','2014-04-01','2014-02-26 13:01:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:19'),(417,342,'Y','18','021','EC','A','','','AC','0000533273','0000533273','OH00000953367','IL','1','Hamacher','Adam','','','','34','301600681','6335 BIRCHVIEW DR S',0,'REYNOLDSBURG','OH','43068','3541','CY','39049','1973-05-07','M','U',':RET:2106-3','N','021','DEN','487954','99734OH005000401','2014-01-01','2013-12-03 19:20:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:32'),(874,723,'Y','18','024','14','A','','','TE','0001020401','0001020401','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','1006471','','2013-12-16','2013-12-16 11:19:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:07:32'),(16996,13604,'N','19','021','EC','A',NULL,NULL,'','0000878277','0001119979','','IL','1','Hess','Sarah','','','','34','283043439','17 W INTERSTATE ST',0,'BEDFORD','OH','44146','4248','CY','39035','1999-05-28','F','',':RET:2106-3','N','021','DEN','1874384','99734OH005000301','2014-02-01','2014-01-08 22:59:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:28'),(14116,11250,'Y','18','021','EC','A','','','AC','0000705148','0000705148','OH00001404052','IL','1','Toth','Andrew','James','','','34','288927013','1633 Cedarwood Drive',0,'Westlake','OH','44145',NULL,'CY','39035','1990-08-15','M','U',':RET:2106-3','N','021','DEN','2029549','99734OH005000401','2014-02-01','2013-12-26 15:00:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:59'),(9041,7173,'Y','18','021','EC','A','','','AC','0000142804','0000142804','OH00000253539','IL','1','Smithnosky','Christine','M','','','34','200407654','1918 Victoria St',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1949-12-14','F','U',':RET:2106-3','N','021','HLT','1388603','52664OH151001306','2014-01-01','2013-12-18 15:27:55','469.00',NULL,NULL,'669.00','200.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 04:05:49'),(2331,1897,'Y','18','021','EC','A','','','AC','0000973549','0000973549','TX00000442245','IL','1','COOPER','JIMMIE','','','','34','557729204','3001 S BARRETT AVE',0,'DENISON','TX','75020','7934','CY','48181','1949-11-05','F','M',':RET:2106-3','N','021','DEN','409545','33348TX002000201','2014-01-01','2013-12-09 12:21:06','0.00',NULL,NULL,'15.85','15.85','R-TX020','TX0','15.85',NULL,0,'2013-12-25 19:31:41'),(8853,7019,'Y','18','021','EC','A','','','AC','0000022153','0000022153','TX00000024002','IL','1','Bermudez','Gloria','','','','34','463982291','212 ELIZABETH ST',0,'UVALDE','TX','78801','5112','CY','48463','1955-11-23','F','U',':RET:2106-3','N','021','DEN','1940216','33348TX002000201','2014-01-01','2013-12-18 10:29:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:05'),(5851,4647,'Y','18','021','EC','A','','','AC','0000038369','0000038369','TX00000247620','IL','1','bazaldua','javier','','','','34','455958060','310 FURR DR',0,'SAN ANTONIO','TX','78201','4415','CY','48029','1985-01-26','M','U',NULL,'T','021','DEN','2387725','33348TX002000201','2014-01-01','2013-12-24 00:43:15','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:48:48'),(8150,6447,'Y','18','024','14','A','','','TE','0000893725','0000893725','','IL','1','Arreaga','Jose','Daniel',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-07','M','',NULL,NULL,NULL,'','613231','','2013-11-22','2013-11-22 10:18:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:16:00'),(20911,16715,'Y','18','021','EC','A','','','AC','0000684847','0000684847','OH00002378497','IL','1','glass','tina','','','','34','279682727','310 JENNINGS RD',0,'ROSSFORD','OH','43460','1128','CY','39173','1967-02-18','F','M',NULL,'N','021','HLT','3378994','92036OH006002601','2014-03-01','2014-01-31 11:42:38','142.00',NULL,NULL,'241.71','99.71','R-OH001','OH0','241.71',NULL,0,'2014-01-31 21:01:27'),(22011,17572,'Y','18','021','EC','A','','','AC','0000096438','0000096438','OH00001711003','IL','1','Showalter','Martha','','','','34','302521978','3492BradleyBrownlee',0,'Cortland','OH','44410',NULL,'CY','39155','1952-12-28','F','M',':RET:2106-3','N','021','DEN','3483402','99734OH005000301','2014-03-01','2014-02-07 09:59:22','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-07 19:00:51'),(27871,22046,'Y','18','024','14','A','','','TE','0000284870','0000284870','','IL','1','Ray','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-10-17','F','',NULL,NULL,NULL,'','946774','','2014-03-20','2014-03-05 10:46:48',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERM',0,'2014-03-05 21:32:25'),(19907,15877,'Y','18','024','14','A','','','TE','0000321021','0000321021','','IL','1','Reed','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-28','M','',NULL,NULL,NULL,'','8726','','2014-01-24','2014-01-24 09:51:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:58'),(15335,12265,'N','19','021','EC','A',NULL,NULL,'','0000710157','0000378585','','IL','1','Johnson','Zachary','David','','','34','509111404','9344 ROCKY WATER CT',0,'SYLVANIA','OH','43560','9225','CY','39095','1994-01-23','M','',':RET:2106-3','N','021','HLT','2148800','92036OH005002601','2014-02-01','2014-01-01 15:35:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,1,'2014-01-02 04:24:03'),(14638,11682,'Y','18','024','14','A','','','TE','0000999850','0000999850','','IL','1','Holley','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-09-10','F','',NULL,NULL,NULL,'','2496973','','2013-12-27','2013-12-27 18:28:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:37:22'),(5676,4503,'Y','18','024','14','A','','','TE','0000053026','0000053026','','IL','1','Whisner','philip',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-02-29','M','',NULL,NULL,NULL,'','506074','','2013-11-26','2013-11-26 17:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:32:11'),(9394,7450,'Y','18','024','14','A','','','TE','0001120622','0001120622','','IL','1','Robinson','Barton',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-19','M','',NULL,NULL,NULL,'','2031279','','2013-12-20','2013-12-20 22:03:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:25'),(26413,20947,'Y','18','021','EC','A','','','AC','0000154627','0000154627','OH00003257333','IL','1','COTTRELL','MICHAEL','A','','','34','270544369','10110 ST RT 124',0,'HILLSBORO','OH','45133',NULL,'CY','39071','1956-03-29','M','M',':RET:2106-3','N','021','HLT','3037057','92036OH003000604','2014-03-01','2014-02-26 15:43:16','352.00',NULL,NULL,'546.34','194.34','R-OH005','OH0','546.34','CIC',0,'2014-02-28 07:00:41'),(27471,21740,'Y','18','021','EC','A','','','AC','0001045750','0001045750','OH00002940088','IL','1','Owens','Toby','','','','34','296522962','1109 JUDITH ST',0,'LIMA','OH','45801','3534','CY','39003','1951-10-05','M','M',':RET:2106-3','N','021','HLT','2625764','92036OH004001501','2014-04-01','2014-03-04 14:52:22','932.00',NULL,NULL,'1005.71','73.71','R-OH002','OH0','508.42',NULL,0,'2014-03-04 21:02:11'),(28048,22194,'Y','18','021','EC','A','','','AC','0000685524','0000685524','MS00003479549','IL','1','Greenfield','Ajankoo','','','','34','426650199','210 BRIARWOOD DR',0,'JACKSON','MS','39206','3050','CY','28049','1988-11-09','F','U',':RET:2054-5','N','021','DEN','3450096','46300MS002000201','2014-04-01','2014-03-05 20:45:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:35'),(28690,22705,'N','01','021','EC','A',NULL,NULL,'','0000392431','0000921992','','IL','1','Coleman','Aaron','','','','34','269767851','994 SUNSET VIEW BLVD',0,'TALLMADGE','OH','44278','3232','CY','39153','1978-05-17','M','',NULL,'T','021','HLT','3433379','52664OH152000901','2014-04-01','2014-03-08 15:19:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.54',NULL,0,'2014-03-08 21:31:03'),(52,47,'Y','18','021','EC','A','','','AC','0000234020','0000234020','OH00000139821','IL','1','Getz','Maria','','','','34','301680204','210 South Grove Street',0,'Bowling Green','OH','43402',NULL,'CY','39173','1975-10-19','F','U',':RET:2106-3','N','021','DEN','531050','99734OH005000301','2014-01-01','2013-12-04 18:49:47','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 17:16:25'),(19824,15807,'Y','18','021','EC','A','','','AC','0001067870','0001067870','TX00001734149','IL','1','Guajardo','Victor','','','','34','465391617','77 Santa Isabel',0,'Laguna Vista','TX','78578',NULL,'CY','48061','1975-10-21','M','U',':RET:2106-3','N','021','DEN','3059523','33348TX002000201','2014-03-01','2014-01-24 13:05:15','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-24 21:00:15'),(19787,15774,'Y','18','024','14','A','','','TE','0000358353','0000358353','','IL','1','Beasley','Justin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-09','M','',NULL,NULL,NULL,'','2373940','','2014-01-23','2014-01-23 11:44:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:38'),(19094,15213,'Y','18','021','EC','A','','','AC','0000909503','0000909503','OH00001841757','IL','1','Huster','Bonnie','Lynn','','','34','426318230','7926 TOWNSHIP ROAD 50',0,'DOLA','OH','45835','9709','CY','39065','1967-10-20','F','R',':RET:2106-3','N','021','DEN','1641879','99734OH005000301','2014-03-01','2014-01-18 12:27:50','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-21 08:44:34'),(16037,12840,'Y','18','021','EC','A','','','AC','0001612804','0001612804','LA00001688546','IL','1','PITTMAN','ireon','','','','34','436653674','2433 ARTS ST',0,'NEW ORLEANS','LA','70117','7504','CY','22071','1987-05-02','F','U',NULL,'N','021','DEN','2433714','18575LA002000201','2014-02-01','2014-01-03 16:50:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:42'),(4133,3300,'Y','18','021','EC','A','','','AC','0000843322','0000843322','OH00000715231','IL','1','Cater','Ramzi','','','','34','234923838','9871 N POINTE CIR',0,'BRECKSVILLE','OH','44141','3186','CY','39035','1953-05-01','M','M',':RET:2106-3','N','021','DEN','2040203','99734OH005000301','2014-01-01','2013-12-17 10:36:50','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:48:26'),(6852,5432,'Y','18','021','EC','A','','','AC','0000067632','0000067632','OH00000288118','IL','1','Terrell','Vharmella','','','','34','288607909','7410 MELYNNE TRCE',0,'CANAL WINCHESTER','OH','43110','7720','CY','39049','1976-07-29','F','U',NULL,'N','021','DEN','951549','99734OH005000301','2014-01-01','2013-10-04 23:26:04','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:31:24'),(6942,5512,'N','01','021','EC','A',NULL,NULL,'','0001169453','0000934673','','IL','1','ABUBAKAR','NASRA','BANA','','','34','034785630','6191 BRENTHURST DR',0,'COLUMBUS','OH','43230','6324','CY','39049','1977-06-17','F','',NULL,'N','021','DEN','1910370','99734OH005000401','2014-01-01','2013-12-24 20:25:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:46:49'),(14736,11765,'Y','18','024','14','A','','','TE','0001046845','0001046845','','IL','1','Smith','Mitchell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-28','M','',NULL,NULL,NULL,'','2457331','','2013-12-28','2013-12-28 16:20:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:09:55'),(13873,11069,'Y','18','021','EC','A','','','AC','0001110355','0001110355','OH00000397201','IL','1','Wallin','Susan','','','','34','275746856','815 Ardmore Ave',0,'Akron','OH','44302',NULL,'CY','39153','1962-10-07','F','U',':RET:2106-3','N','021','HLT','1625754','52664OH151001501','2014-01-01','2013-12-23 13:37:00','100.00',NULL,NULL,'498.82','398.82','R-OH012','OH0','498.82',NULL,0,'2013-12-26 13:13:06'),(14374,11465,'Y','18','021','EC','A','','','AC','0001083094','0001083094','OH00000017921','IL','1','Sarka','Sandra','','','','34','284667030','14201 LEROY AVE',0,'CLEVELAND','OH','44135','1447','CY','39035','1957-08-20','F','U',':RET:2106-3','N','021','DEN','1369444','99734OH005000401','2014-02-01','2013-12-27 11:25:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:37'),(22708,18134,'Y','18','021','EC','A','','','AC','0001402631','0001402631','LA00001960827','IL','1','McCann','Kevin','P','','','34','438700196','270 EDGEWOOD LN',0,'MONTZ','LA','70068','8967','CY','22095','1954-01-19','M','M',':RET:2106-3','T','021','DEN','3621841','18575LA002000201','2014-03-01','2014-02-10 20:41:14','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:03'),(22831,18217,'Y','18','021','EC','A','','','AC','0000735070','0000735070','OH00002566068','IL','1','Flickinger','Brent','','','','34','287725851','4796 Medina Road',0,'Copley','OH','44321',NULL,'CY','39153','1966-05-05','M','U',':RET:2106-3','N','021','HLT','3135893','52664OH151001306','2014-03-01','2014-02-11 11:43:34','263.00',NULL,NULL,'348.56','85.56','R-OH012','OH0','348.56',NULL,0,'2014-02-11 21:02:07'),(23204,18499,'N','01','021','EC','A',NULL,NULL,'','0000401284','0000984878','','IL','1','Budzinski','Aaron','','','','34','280763956','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1978-08-03','M','',':RET:2106-3','N','021','HLT','3157858','92036OH006002601','2014-03-01','2014-02-12 11:08:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','188.96',NULL,0,'2014-02-12 21:32:09'),(41,36,'Y','18','021','EC','A','','','AC','0000188823','0000188823','OH00000689872','IL','1','Bradford','Billy','','','','34','415211529','988 DISCOVERY DR',0,'WORTHINGTON','OH','43085','4705','CY','39049','1961-03-26','M','U',':RET:2106-3','T','021','DEN','1069784','99734OH005000401','2014-01-01','2013-12-05 15:13:59','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:16:04'),(5262,4173,'Y','18','021','EC','A','','','AC','0000552619','0000552619','OH00000574894','IL','1','HAMRICK','SHARON','L','','','34','274600158','3560 OCHARD DRIVE LOT D8',0,'STOW','OH','44224',NULL,'CY','39153','1956-04-16','F','U',':RET:2106-3','N','021','HLT','2206670','52664OH151001305','2014-01-01','2013-12-19 11:05:41','384.00',NULL,NULL,'543.47','159.47','R-OH012','OH0','543.47',NULL,0,'2013-12-25 23:05:22'),(19729,15722,'N','01','021','EC','A',NULL,NULL,'','0001576164','0001370251','','IL','1','Brown','franisha','','','','34','558810785','105 west st.marys dr.',0,'covington','LA','70433',NULL,'CY','22103','1971-06-27','F','',':RET:2054-5','T','021','DEN','3199739','18575LA002000201','2014-03-01','2014-01-23 16:39:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 21:01:04'),(18850,15012,'Y','18','021','EC','A','','','AC','0001165359','0001165359','OH00002077541','IL','1','ST JOHN KODISH','ANNE','','','','34','288548296','809 SHEFFIELD AVE NE',0,'MASSILLON','OH','44646','4443','CY','39151','1960-12-29','F','U',':RET:2106-3','T','021','HLT','2550422','52664OH151001305','2014-02-01','2014-01-15 19:12:27','320.00',NULL,NULL,'523.18','203.18','R-OH015','OH0','523.18',NULL,0,'2014-01-17 03:36:15'),(13880,11075,'Y','18','021','EC','A','','','AC','0001216261','0001216261','OH00001244899','IL','1','RIEHM','ELLEN','D','','','34','392488822','19601 BATTERSEA BLVD',0,'ROCKY RIVER','OH','44116','1651','CY','39035','1956-03-12','F','M',':RET:2106-3','N','021','HLT','1359839','52664OH151001501','2014-01-01','2013-12-23 15:05:55','213.99',NULL,NULL,'1273.61','1059.62','R-OH011','OH0','735.15',NULL,0,'2013-12-26 13:13:17'),(22091,17634,'Y','18','021','EC','A','','','AC','0000532591','0000532591','MS00002611244','31','1','Smith','Shameka','','','','34','425511705','403 OLD WESSON RD NE',0,'BROOKHAVEN','MS','39601','2833','CY','28085','1984-03-01','F','U',':RET:2054-5','N','021','DEN','3673161','46300MS002000201','2014-03-01','2014-02-07 23:22:29','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-08 19:00:24'),(23041,18369,'Y','18','021','EC','A','','','AC','0000161633','0000161633','TX00001477140','IL','1','Runge','Elizabeth','Ann','','','34','460132935','215 TUSCANY DR',0,'VICTORIA','TX','77904','5229','CY','48469','1958-07-14','F','U',NULL,'N','021','DEN','3648813','33348TX002000201','2014-03-01','2014-02-12 17:46:50','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-12 21:30:40'),(24983,19815,'Y','18','021','EC','A','','','AC','0000438318','0000438318','TX00002998855','IL','1','GONZALES','JUDY','','','','34','449515699','709 SUMMERWOOD DR',0,'NEW BRAUNFELS','TX','78130','3626','CY','48091','1965-10-25','F','U',NULL,'N','021','DEN','3277222','33348TX002000201','2014-04-01','2014-02-20 12:21:21','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-20 22:00:35'),(25318,20085,'Y','18','021','EC','A','','','AC','0001574826','0001574826','LA00003177922','IL','1','rumball','brett','','','','34','766098683','5835 CLARA ST',0,'NEW ORLEANS','LA','70115','7029','CY','22071','1986-07-21','M','U',NULL,'N','021','DEN','2877157','18575LA002000201','2014-04-01','2014-02-24 21:50:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:06'),(29166,23086,'Y','18','021','EC','A','','','AC','0001121468','0001121468','OH00003243955','IL','1','SUTHERLY','REBECCA','J','','','34','300484369','5898 BELLEFONTAINE RD.',0,'LIMA','OH','45804',NULL,'CY','39003','1950-09-17','F','U',':RET:2106-3','N','021','HLT','3968207','92036OH005001506','2014-05-01','2014-03-10 17:31:36','620.00',NULL,NULL,'649.68','29.68','R-OH002','OH0','649.68',NULL,0,'2014-03-10 21:02:56'),(21440,17136,'Y','18','024','14','A','','','TE','0001084928','0001084928','','IL','1','Washington','marilyn','ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-24','F','',NULL,NULL,NULL,'','3352374','','2014-02-04','2014-02-04 14:04:42',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-04 21:01:23'),(19785,15772,'N','01','021','EC','A',NULL,NULL,'','0000891838','0000876085','','IL','1','LaPlant','Kathleen','','','','34','293943481','2242 15TH ST',0,'CUYAHOGA FALLS','OH','44223','2459','CY','39153','1984-07-26','F','',':RET:2106-3','N','021','HLT','2629450','52664OH151001306','2014-03-01','2014-01-23 00:42:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.55',NULL,0,'2014-01-23 21:01:37'),(794,655,'Y','18','024','14','A','','','TE','0001229370','0001229370','','IL','1','Bell','Bryan','Marsh',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-01','M','',NULL,NULL,NULL,'','40727','','2013-12-16','2013-12-16 16:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:05:23'),(1184,976,'Y','18','021','EC','A','','','AC','0000985971','0000985971','OH00001193991','IL','1','RUTAN','RICKY','JORGE','','','34','289708885','21271 16 SCHOOL RD',0,'WELLSVILLE','OH','43968','9618','CY','39029','1970-12-16','M','M',NULL,'T','021','DEN','16169','99734OH005000301','2014-01-01','2013-12-03 09:18:52','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:19:28'),(3343,2679,'Y','18','021','EC','A','','','AC','0000348872','0000348872','TX00001311396','IL','1','VALLE','JOE','','','','34','364643238','9101 W BUSINESS 83',0,'HARLINGEN','TX','78552','2088','CY','48061','1957-06-24','M','U',NULL,'N','021','DEN','1885780','33348TX002000201','2014-01-01','2013-12-21 21:33:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 21:16:32'),(16177,12952,'Y','18','021','EC','A','','','AC','0002032776','0002032776','LA00001989780','IL','1','McNeal','Edna','','','','34','140568887','309 baker',0,'Pineville','LA','71360',NULL,'CY','22079','1959-10-27','F','U',':RET:2054-5','T','021','DEN','1407012','18575LA002000201','2014-02-01','2014-01-04 15:39:45','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-05 00:00:24'),(2359,1923,'N','01','021','EC','A',NULL,NULL,'','0000680814','0000078740','','IL','1','Shafitz','Suzanne','','','','34','294508514','4021 Eastern Avenue',0,'Cincinnati','OH','45226',NULL,'CY','39061','1967-03-06','F','',NULL,'N','021','DEN','24288','99734OH005000401','2014-01-01','2013-12-08 21:01:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:32:27'),(15492,12396,'Y','18','021','EC','A','','','AC','0000862449','0000862449','OH00002092179','IL','1','Riggle','Brian','','','','34','300744306','275 BETZ RD',0,'OBETZ','OH','43207','2935','CY','39049','1979-11-24','M','U',':RET:2106-3','T','021','DEN','2160596','99734OH005000401','2014-02-01','2013-12-31 11:55:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:32'),(7306,5790,'Y','18','024','14','A','','','TE','0000533268','0000533268','','IL','1','EMERUWA','CAROL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-10-06','F','',NULL,NULL,NULL,'','62542','','2013-12-14','2013-12-14 16:07:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:03:15'),(8925,7076,'N','01','021','EC','A',NULL,NULL,'','0000468103','0000884199','','IL','1','Landfeld','Bedrich',NULL,NULL,NULL,NULL,NULL,'12802 Morning Glory Trail',0,'Chesterland','OH','44026',NULL,'CY','39055','1952-07-27','M','',':RET:2106-3','N','021','DEN','1514161','99734OH005000401','2014-01-01','2013-12-18 09:08:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:53'),(22221,17737,'Y','18','021','EC','A','','','AC','0001766772','0001766772','LA00002399186','IL','1','Sawyer','Stephen','','','','34','439797136','1930 LIvingston St',0,'Mandeville','LA','70448',NULL,'CY','22103','1990-11-16','M','U',NULL,'N','021','DEN','3403526','18575LA002000201','2014-03-01','2014-02-09 17:16:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:26'),(28521,22571,'Y','18','021','EC','A','','','AC','0000870687','0000870687','OH00003045202','S3','1','Walker','Charysse','','','','34','301136541','4686 E. 86 st',0,'Garfield Hts','OH','44125',NULL,'CY','39035','2008-07-29','M','U',':RET:2054-5','N','021','DEN','2873446','99734OH005000201','2014-04-01','2014-03-06 21:10:00','0.00',NULL,NULL,'24.48','24.48','R-OH011','OH0','24.48',NULL,0,'2014-03-07 21:32:00'),(28932,22896,'Y','18','021','EC','A','','','AC','0001261265','0001261265','OH00003261790','IL','1','Reda','Wendeline','R','','','34','287505390','5816 Milo Road',0,'Dayton','OH','45414',NULL,'CY','39113','1950-05-08','F','U',':RET:2106-3','N','021','DEN','4375771','99734OH005000301','2014-04-01','2014-03-10 14:26:25','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:00:37'),(29037,22983,'Y','18','021','EC','A','','','AC','0001097841','0001097841','OH00002806833','IL','1','SOHRABI','MINA','','','','34','294864401','6730 WARRINGTON DR',0,'NORTH OLMSTED','OH','44070','5052','CY','39035','1987-10-09','F','R',':RET:2106-3','N','021','DEN','3776670','99734OH005000401','2014-04-01','2014-03-10 12:36:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:39'),(120,104,'Y','18','021','EC','A','','','AC','0000245757','0000245757','TX00000263201','IL','1','Mendez','Noelia','','','','34','453948202','5950 HILL CREST DR',0,'CORPUS CHRISTI','TX','78415','2443','CY','48355','1951-06-09','F','U',NULL,'T','021','DEN','676988','33348TX002000201','2014-01-01','2013-12-05 15:26:25','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 17:18:09'),(21374,17083,'Y','18','021','EC','A','','','AC','0000481105','0000481105','OH00002408939','IL','1','McCarthy','Cindy','','','','34','288584787','6511 OLIVE BRANCH RD',0,'OREGONIA','OH','45054','9715','CY','39165','1956-06-26','F','M',':RET:2106-3','N','021','DEN','3326761','99734OH005000401','2014-03-01','2014-02-03 18:49:52','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:00:50'),(18805,14978,'Y','18','021','EC','A','','','AC','0000440841','0000440841','OH00002022696','IL','1','Ward','Camille','','','','34','279846765','7039 Treebourne Drive',0,'Reynoldsburg','OH','43068',NULL,'CY','39049','1969-07-12','F','U',':RET:2054-5','T','021','DEN','2662750','99734OH005000401','2014-03-01','2014-01-16 14:48:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-17 03:36:01'),(17692,14139,'Y','18','021','EC','A','','','AC','0002020242','0002020242','LA00002141113','IL','1','Collins','Myrna','','','','34','433924583','2512 EASTVIEW DR',0,'HARVEY','LA','70058','5035','CY','22051','1953-07-31','F','U',NULL,'N','021','DEN','1957368','18575LA002000201','2014-02-01','2014-01-13 12:06:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:00'),(6616,5246,'Y','18','021','EC','A','','','AC','0000955517','0000955517','OH00001208988','IL','1','Wiechart','Donald','','','','34','299620870','560 N. St. MarysRoad',0,'Spencerville','OH','45887',NULL,'CY','39003','1966-08-26','M','R',':RET:2106-3','N','021','HLT','1217835','92036OH005001501','2014-01-01','2013-12-11 11:31:43','0.00',NULL,NULL,'344.00','344.00','R-OH002','OH0','344.00',NULL,0,'2013-12-26 00:53:53'),(14251,11365,'Y','18','021','EC','A','','','AC','0001149710','0001149710','TX00001095528','IL','1','Adams','Patrick','','','','34','156789952','9550 Long Point Rd',0,'Houston','TX','77055',NULL,'CY','48201','1985-08-10','M','U',':RET:2106-3','N','021','DEN','2138835','33348TX002000101','2014-02-01','2013-12-26 13:51:39','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-27 02:05:30'),(8848,7014,'Y','18','021','EC','A','','','AC','0001107619','0001107619','TX00000281541','IL','1','armendariz','letty','','','','34','449493779','2509 N MUSKINGUM AVE',0,'ODESSA','TX','79761','1283','CY','48135','1979-11-29','F','U',NULL,'N','021','DEN','1826972','33348TX002000201','2014-01-01','2013-12-18 09:19:25','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-26 04:00:56'),(23071,18395,'Y','18','021','EC','A','','','AC','0001809842','0001809842','LA00002055234','IL','1','Deason','Carla','','','','34','437654992','500 HICKORY CREEK LOOP',0,'DERIDDER','LA','70634','2459','CY','22011','1981-01-12','F','U',':RET:2106-3','N','021','DEN','2937106','18575LA002000201','2014-03-01','2014-02-12 14:08:55','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-12 21:30:57'),(23824,18956,'Y','18','021','EC','A','','','AC','0000126606','0000126606','MS00002122541','IL','1','Morris','Louis','','','','34','427475315','160 ABRAM FORD DR',0,'JACKSON','MS','39213','4646','CY','28049','1979-09-24','M','U',':RET:2054-5','N','021','DEN','3477085','46300MS002000101','2014-03-01','2014-02-13 20:38:55','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-14 21:31:42'),(28247,22349,'N','01','021','EC','A',NULL,NULL,'','0000947441','0000807554','','IL','1','GARZA','RICHARD','','','','34','302782700','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-11-19','M','',NULL,'T','021','DEN','3294622','99734OH005000401','2014-04-01','2014-03-07 12:47:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-07 21:00:12'),(28747,22753,'Y','18','021','EC','A','','','AC','0000859599','0000859599','TX00003259208','IL','1','Walker','Erika','','','','34','220114830','5004 Paragon Drive',0,'Killeen','TX','76542',NULL,'CY','48027','1957-08-01','F','U',':RET:2106-3','N','021','DEN','3147294','33348TX002000201','2014-04-01','2014-03-08 19:54:30','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-09 21:00:14'),(2288,1865,'Y','18','021','EC','A','','','AC','0001007864','0001007864','OH00000946979','IL','1','PETERS','CHARLES','KINGSLEY','','','34','375549820','1665 SPILLAN RD',0,'YELLOW SPRINGS','OH','45387',NULL,'CY','39057','1954-07-04','M','M',':RET:2106-3','N','021','DEN','412499','99734OH005000301','2014-01-01','2013-12-09 14:04:21','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:30:42'),(19645,15656,'N','01','021','EC','A',NULL,NULL,'','0001219620','0000629269','','IL','1','MINAMYER','VICKI','LYNN','','','34','269526526','35 DEER TRAIL DR',0,'SPRINGBORO','OH','45066',NULL,'CY','39165','1951-09-11','F','',':RET:2106-3','N','021','DEN','2440304','99734OH005000401','2014-03-01','2014-01-23 09:28:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:17'),(3902,3122,'N','01','021','EC','A',NULL,NULL,'','0001114511','0000518392','','IL','1','Pavliga','Frank',NULL,NULL,NULL,NULL,NULL,'1965 NEW MILFORD RD',0,'ATWATER','OH','44201','7701','CY','39133','1956-05-06','M','',':RET:2106-3','N','021','HLT','1012859','52664OH152000901','2014-01-01','2013-12-13 16:57:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2013-12-25 21:36:52'),(18957,15104,'Y','18','021','EC','A','','','AC','0000845833','0000845833','TX00002594434','IL','1','Sun','Hua','','','','34','627135723','2044 PALACE WAY',0,'ALLEN','TX','75013','3007','CY','48085','1975-05-28','M','M',':RET:2034-7','N','021','DEN','3067798','33348TX002000201','2014-03-01','2014-01-16 22:42:45','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-20 08:05:53'),(7495,5929,'Y','18','021','EC','A','','','AC','0000796942','0000796942','OH00001263509','IL','1','SAXOUR','CHERYL','','','','34','268803477','65 MCCLAIN AVE',0,'NEW HOLLAND','OH','43145','9602','CY','39047','1966-10-10','F','M',':RET:2106-3','N','021','DEN','1172143','99734OH005000401','2014-01-01','2013-12-15 15:06:03','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:42'),(18652,14870,'Y','18','021','EC','A','','','AC','0000083778','0000083778','TX00001855014','IL','1','GOMEZ','SHAWNTEL','','','','34','455937331','820 S STAPLES ST',0,'CORPUS CHRISTI','TX','78404','3233','CY','48355','1984-01-17','F','M',':RET:2106-3','N','021','DEN','2963719','33348TX002000201','2014-03-01','2014-01-16 11:06:51','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-01-17 03:35:10'),(16990,13599,'Y','18','021','EC','A','','','AC','0000991034','0000991034','TX00001403078','IL','1','Kondo','Virginia','','','','34','461906099','5206 BEALS DR',0,'EL PASO','TX','79924','5806','CY','48141','1951-10-10','F','M',':RET:2106-3','N','021','DEN','2155736','33348TX002000101','2014-02-01','2014-01-09 13:22:14','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-01-13 02:20:24'),(7953,6293,'Y','18','021','EC','A','','','AC','0001668959','0001668959','LA00000621583','IL','1','mckinnis','edwanda','','','','34','436757583','523 27TH ST',0,'KENNER','LA','70062','5011','CY','22051','1989-03-31','F','U',':RET:2054-5','N','021','DEN','1455228','18575LA002000201','2014-01-01','2013-12-20 18:18:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:07:13'),(9346,7408,'Y','18','021','EC','A','','','AC','0001401549','0001401549','LA00000489949','IL','1','WATSON','SETH','','','','34','433532546','5417 MANDEVILLE ST.',0,'NEW ORLEANS','LA','70122',NULL,'CY','22071','1982-01-30','M','U',NULL,'N','021','DEN','2601366','18575LA002000201','2014-01-01','2013-12-20 23:02:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:07'),(9580,7586,'Y','18','021','EC','A','','','AC','0001207154','0001207154','OH00000065288','IL','1','Lignoski','Nancy','','','','34','208664017','960 HESSEL DR',0,'AKRON','OH','44313','5804','CY','39153','1979-04-07','F','U',':RET:2106-3','N','021','DEN','1387456','99734OH005000301','2014-01-01','2013-12-21 17:31:43','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:36:52'),(13037,10393,'Y','18','021','EC','A','','','AC','0001081795','0001081795','OH00001191008','IL','1','Hodson','Walker','','','','34','210749840','9218 STATE ROUTE 82',0,'GARRETTSVILLE','OH','44231','9427','CY','39133','1994-09-10','M','R',':RET:2106-3','N','021','DEN','2581100','99734OH005000401','2014-01-01','2013-12-23 05:43:08','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78',NULL,0,'2013-12-26 12:50:31'),(13773,10994,'Y','18','021','EC','A','','','AC','0000548063','0000548063','MS00000646610','31','1','WALTON','WT','','','','34','587609116','PO BOX 31607',0,'JACKSON','MS','39286',NULL,'CY','28049','1951-06-28','M','M',NULL,'N','021','DEN','1671399','46300MS002000201','2014-01-01','2013-12-23 13:17:28','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:33'),(24822,19678,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000455358','','IL','1','Burdick','Elliott','','','','34','274043242','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1998-12-21','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:37'),(26349,20904,'Y','18','021','EC','A','','','AC','0000938588','0000938588','OH00003389621','IL','1','howard','tina','','','','34','268821628','103 ROGER AVE',0,'BELLEVUE','OH','44811','1152','CY','39077','1967-11-27','F','M',NULL,'N','021','HLT','2966815','92036OH004002701','2014-04-01','2014-02-27 13:31:57','0.00',NULL,NULL,'491.54','491.54','R-OH006','OH0','235.18',NULL,0,'2014-02-28 06:31:47'),(28185,22302,'N','01','021','EC','A',NULL,NULL,'','0001028119','0000540356','','IL','1','Brouman','Alice','','','','34','284700372','3913 Boston Ave',0,'New Franklin','OH','44319',NULL,'CY','39153','1962-07-16','F','',':RET:2106-3','N','021','HLT','3141407','52664OH151001501','2014-04-01','2014-03-06 14:24:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','498.82',NULL,0,'2014-03-06 21:02:56'),(18892,15052,'Y','18','021','EC','A','','','AC','0001037379','0001037379','OH00001958950','IL','1','Kopaniewski','Joanna','','','','34','295110944','4526 Newkirk Dr',0,'Brunswick','OH','44212',NULL,'CY','39103','1985-11-13','F','R',':RET:2106-3','N','021','HLT','2690392','52664OH151001501','2014-02-01','2014-01-15 23:19:51','0.00',NULL,NULL,'290.74','290.74','R-OH012','OH0','290.74',NULL,0,'2014-01-17 03:36:32'),(16897,13522,'Y','18','021','EC','A','','','AC','0000980556','0000980556','OH00002166126','IL','1','Murphy','Airica','','','','34','274949919','1077 JUNE DR',0,'XENIA','OH','45385','3725','CY','39057','1991-05-08','F','M',':RET:2106-3','N','021','DEN','1449712','99734OH005000401','2014-02-01','2014-01-09 10:37:58','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:19:31'),(1842,1509,'Y','18','021','EC','A','','','AC','0000649378','0000649378','OH00000951771','IL','1','ROHRER','MELISSA','','','','34','270503065','3607 SEVILLE ROAD',0,'SEVILLE','OH','44273',NULL,'CY','39103','1950-03-05','F','M',':RET:2106-3','N','021','HLT','2239426','52664OH151001306','2014-01-01','2013-12-24 12:08:35','527.00',NULL,NULL,'658.32','131.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 18:57:39'),(4145,3305,'Y','18','021','EC','A','','','AC','0000614088','0000614088','OH00001092391','IL','1','Shamy','Rachel','','','','34','268885750','13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','1977-10-04','F','R',':RET:2106-3','N','021','DEN','1998433','99734OH005000301','2014-01-01','2013-12-17 12:46:15','0.00',NULL,NULL,'59.76','59.76','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:48:40'),(4543,3600,'Y','18','021','EC','A','','','AC','0001159532','0001159532','TX00000598810','IL','1','VALLEJO','JUANITA','','','','34','454905846','408 23RD ST',0,'HIDALGO','TX','78557','3609','CY','48215','1950-01-03','F','M',NULL,'N','021','DEN','788677','33348TX002000201','2014-01-01','2013-12-12 18:22:34','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:04:20'),(6683,5300,'Y','18','021','EC','A','','','AC','0000242670','0000242670','OH00000471360','IL','1','Simbeck','David','','','','34','271481591','2157 W. 85th. St.',0,'Cleveland','OH','44102',NULL,'CY','39035','1951-01-03','M','U',':RET:2106-3','N','021','DEN','150565','99734OH005000401','2014-01-01','2013-11-04 21:45:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:01:27'),(9678,7667,'Y','18','021','EC','A','','','AC','0000019107','0000019107','OH00000516822','IL','1','POTTER','SANDRA','L','','','34','292503167','1803 BIRDIE DR',0,'TOLEDO','OH','43615','3209','CY','39095','1950-04-28','F','M',':RET:2106-3','N','021','HLT','2332002','92036OH006002601','2014-01-01','2013-12-21 15:58:56','345.00',NULL,NULL,'456.50','111.50','R-OH001','OH0','456.50',NULL,0,'2013-12-26 04:39:24'),(24252,19257,'Y','18','021','EC','A','','','AC','0000653249','0000653249','OH00002339279','IL','1','green','janet','','','','34','294444029','218 myrtle place',0,'akron','OH','44303',NULL,'CY','39153','1955-02-17','F','U',NULL,'T','021','HLT','3609633','52664OH152000901','2014-04-01','2014-02-17 11:05:41','488.95',NULL,NULL,'488.95','0.00','R-OH012','OH0','488.95','CIC',0,'2014-02-17 19:00:02'),(25591,20302,'Y','18','021','EC','A','','','AC','0001841406','0001841406','LA00002079807','IL','1','Alcala','Rebecca','','','','34','436732230','415 West Parker Boulevard',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1988-02-05','F','M',':RET:2106-3','N','021','DEN','2780478','18575LA002000201','2014-03-01','2014-02-24 14:34:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61','CIC',0,'2014-02-26 08:00:43'),(6933,5504,'Y','18','021','EC','A','','','AC','0000373634','0000373634','OH00001361826','IL','1','sayre','matthew','','','','34','236317695','15449 HUMMEL RD',0,'BROOKPARK','OH','44142','1948','CY','39035','1987-09-05','M','U',':RET:2106-3','N','021','DEN','2178256','99734OH005000401','2014-01-01','2013-12-24 20:03:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:35'),(6163,4886,'N','01','021','EC','A',NULL,NULL,'','0001151042','0001147300','','IL','1','Gibson','Paula','','','','34','292567461','340 OHIO AVE',0,'TIFFIN','OH','44883','1752','CY','39147','1954-03-31','F','',':RET:2106-3','N','021','HLT','486531','92036OH003002705','2014-01-01','2013-11-21 14:19:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','530.07',NULL,0,'2013-12-26 00:16:51'),(13324,10638,'Y','18','021','EC','A','','','AC','0000439357','0000439357','TX00000471104','IL','1','RUSS','BENJAMIN','','','','34','460856438','1604 S FRANKLIN AVE',0,'MONAHANS','TX','79756','6718','CY','48475','1985-05-23','M','U',':RET:2106-3','N','021','DEN','1809417','33348TX002000201','2014-01-01','2013-12-23 16:00:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:26'),(5441,4322,'N','01','021','EC','A',NULL,NULL,'','0001828561','0001358968','','IL','1','Park','Young','','','','34','435912265','1446 Helios Ave',0,'Metairie','LA','70005',NULL,'CY','22051','1959-01-13','F','',NULL,'N','021','DEN','1435366','18575LA002000101','2014-01-01','2013-12-19 17:01:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 23:09:56'),(9084,7208,'Y','18','021','EC','A','','','AC','0000689682','0000689682','OH00000977388','31','1','Shelton','Erik','','','','34','383823076','p.o. box 94',0,'Anna','OH','45302',NULL,'CY','39149','1978-01-29','M','U',':RET:2106-3','N','021','DEN','1867443','99734OH005000301','2014-01-01','2013-12-18 09:20:40','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:06:54'),(5245,4160,'Y','18','021','EC','A','','','AC','0000679525','0000679525','OH00000002979','IL','1','Sliman','Amal','','','','34','298943247','6075 Somerset Dr',0,'North Olmsted','OH','44070',NULL,'CY','39035','1961-08-10','F','M',':RET:2106-3','T','021','HLT','1752316','52664OH151001305','2014-01-01','2013-12-18 22:52:49','249.00',NULL,NULL,'564.61','315.61','R-OH011','OH0','564.61',NULL,0,'2013-12-25 23:05:00'),(20279,16184,'Y','18','021','EC','A','','','AC','0000737891','0000737891','OH00002450123','IL','1','LaFever','Nancy','','','','34','281544844','9179 CROUSE WILLISON RD',0,'JOHNSTOWN','OH','43031','8165','CY','39089','1953-01-29','F','U',':RET:2106-3','N','021','DEN','2396316','99734OH005000401','2014-03-01','2014-01-28 13:20:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-28 21:00:28'),(24827,19681,'Y','18','021','EC','A','','','AC','0000759752','0000759752','OH00002699801','IL','1','VALLEE','BRENDA DIANE','','','','34','278583433','220 WASHINGTON AVE',0,'WILMINGTON','OH','45177','1130','CY','39027','1955-10-28','F','U',':RET:2106-3','N','021','HLT','3814777','92036OH004000601','2014-04-01','2014-02-19 14:25:55','334.00',NULL,NULL,'439.81','105.81','R-OH005','OH0','439.81',NULL,0,'2014-02-20 04:51:11'),(25094,19903,'Y','18','021','EC','A','','','AC','0000951854','0000951854','OH00002928732','IL','1','Butler','Allie','E','','','34','287506420','6519 IMPERIAL WOODS RD',0,'DAYTON','OH','45459','3206','CY','39113','1952-12-16','M','U',':RET:2054-5','N','021','DEN','2879441','99734OH005000401','2014-04-01','2014-02-21 14:46:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00','CIC',0,'2014-02-21 21:30:06'),(28349,22430,'Y','18','021','EC','A','','','AC','0000808562','0000808562','TX00003007793','IL','1','LOZANO','ANITA','','','','34','467279142','125 E RIVERSIDE AVE',0,'SAN ANGELO','TX','76905','7729','CY','48451','1959-12-26','F','M',NULL,'N','021','DEN','3834563','33348TX002000201','2014-04-01','2014-03-07 12:32:29','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-03-07 21:30:21'),(29053,22995,'Y','18','021','EC','A','','','AC','0001003366','0001003366','OH00003583745','IL','1','Gangwisch','Nancy','Jean','','','34','273744630','710 THORPE DR',0,'SANDUSKY','OH','44870','1624','CY','39043','1962-12-11','F','M',':RET:2106-3','N','021','DEN','3992868','99734OH005000401','2014-04-01','2014-03-10 15:10:49','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2014-03-10 21:01:47'),(659,544,'Y','18','021','EC','A','','','AC','0000833399','0000833399','OH00001252861','IL','1','Finke','Emily','','','','34','283888303','10797 BENTLEY PASS LN',0,'LOVELAND','OH','45140','9366','CY','39061','1981-11-04','F','U',':RET:2106-3','N','021','DEN','305006','99734OH005000301','2014-01-01','2013-12-15 19:31:52','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:50'),(9313,7384,'N','01','021','EC','A',NULL,NULL,'','0001536827','0001308757','','IL','1','Leon','Florentino',NULL,NULL,NULL,NULL,NULL,'2005 KLEINERT AVE',0,'BATON ROUGE','LA','70806','6711','CY','22033','1939-08-24','M','',':RET:2106-3','N','021','DEN','1673960','18575LA002000101','2014-01-01','2013-12-21 11:17:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','31.00',NULL,0,'2013-12-26 04:30:18'),(18752,14941,'Y','18','021','EC','A','','','AC','0000701721','0000701721','OH00002358197','IL','1','MOORE','SHARON','','','','34','204423713','3141 VILLA DR',0,'TOLEDO','OH','43614','5267','CY','39095','1953-11-05','F','M',':RET:2106-3','N','021','HLT','2929562','92036OH005002605','2014-02-01','2014-01-15 22:12:07','337.00',NULL,NULL,'529.21','192.21','R-OH001','OH0','529.21',NULL,0,'2014-01-17 03:35:44'),(15917,12745,'Y','18','021','EC','A','','','AC','0001080771','0001080771','TX00001264309','IL','1','Peralez','Lynnta','','','','34','459084406','County Road 3523',0,'Orange Grove','TX','78372',NULL,'CY','48249','1953-02-05','F','U',':RET:2106-3','N','021','DEN','1706432','33348TX002000101','2014-02-01','2014-01-02 13:16:14','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-03 02:06:31'),(8992,7134,'Y','18','021','EC','A','','','AC','0001018221','0001018221','OH00001058954','IL','1','Rammel','Jared','','','','34','286885633','116 E RACE ST',0,'MECHANICSBURG','OH','43044','1024','CY','39021','1975-01-14','M','M',':RET:2106-3','T','021','DEN','1471240','99734OH005000401','2014-01-01','2013-12-18 17:20:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:04:35'),(3084,2478,'N','19','021','EC','A',NULL,NULL,'','0000776401','0000064859','','IL','1','Post','Jennifer','Leigh','','','34','289961734','9810 SPENCERVILLE RD',0,'SPENCERVILLE','OH','45887','9726','CY','39003','1993-11-16','F','',':RET:2106-3','N','021','HLT','1039627','92036OH004001501','2014-01-01','2013-12-06 17:00:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2013-12-25 20:19:48'),(15873,12710,'Y','18','021','EC','A','','','AC','0000298906','0000298906','MS00001703862','IL','1','Griffin','Robert','','','','34','428215992','2511 LYONS RD',0,'BOLTON','MS','39041','9217','CY','28049','1965-12-12','M','U',':RET:2054-5','T','021','DEN','1747539','46300MS002000101','2014-02-01','2014-01-02 18:17:52','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-03 02:05:09'),(6366,5047,'Y','18','021','EC','A','','','AC','0001095628','0001095628','OH00000558833','IL','1','Hohn','Betty','J','','','34','284560056','1769 WINCHESTER RD',0,'XENIA','OH','45385','7632','CY','39057','1954-05-27','F','U',':RET:2106-3','N','021','DEN','60335','99734OH005000301','2014-01-01','2013-12-10 19:23:58','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:47:29'),(13826,11036,'Y','18','021','EC','A','','','AC','0000697913','0000697913','OH00000441706','IL','1','willoughby','leslie','ann','','','34','295785359','3799 East Normandy Park Dr',0,'medina','OH','44256',NULL,'CY','39103','1966-08-29','F','R',':RET:2106-3','N','021','HLT','2390195','52664OH152000901','2014-01-01','2013-12-23 01:41:43','0.00',NULL,NULL,'255.30','255.30','R-OH012','OH0','255.30',NULL,0,'2013-12-26 13:12:00'),(23106,18419,'Y','18','021','EC','A','','','AC','0000558188','0000558188','OH00001814438','IL','1','Bradford','Sandra','','','','34','283483603','744 CARNEGIE AVE',0,'AKRON','OH','44314','1173','CY','39153','1950-06-19','F','U',':RET:2106-3','N','021','DEN','3780223','99734OH005000401','2014-03-01','2014-02-12 15:54:30','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-12 21:31:15'),(23440,18673,'Y','18','021','EC','A','','','AC','0000955301','0000955301','TX00002743953','IL','1','Gates','Jim','','','','34','451137644','1627 FM 2779',0,'Pearsall','TX','78061',NULL,'CY','48163','1961-03-31','M','R',NULL,'T','021','DEN','2734248','33348TX002000201','2014-03-01','2014-02-13 11:51:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:33'),(24951,19785,'N','01','021','EC','A',NULL,NULL,'','0001802285','0002253961','','IL','1','GONZALEZ','OMAR','RUBEN','','','34','437578604','4212 CHATEAU BLVD',0,'KENNER','LA','70065','1986','CY','22051','1969-05-03','M','',NULL,'N','021','DEN','3820865','18575LA002000201','2014-04-01','2014-02-19 23:43:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-20 22:00:11'),(27313,21626,'Y','18','021','EC','A','','','AC','0000268247','0000268247','TX00002999184','IL','1','Trujillo','Gloria','','','','34','449066870','924 C ST',0,'BROWNSVILLE','TX','78520','4123','CY','48061','1955-02-14','F','U',':RET:2106-3','N','021','DEN','4014766','33348TX002000201','2014-04-01','2014-03-04 14:07:15','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-04 21:00:41'),(28133,22263,'Y','18','021','EC','A','','','AC','0000199735','0000199735','OH00003512687','IL','1','Odlivak','Anthony','','','','34','286800576','3047 MASSILLON RD',0,'AKRON','OH','44312','5355','CY','39153','1983-07-12','M','U',':RET:2106-3','N','021','HLT','2978221','52664OH151001305','2014-04-01','2014-03-06 12:44:09','165.00',NULL,NULL,'253.11','88.11','R-OH012','OH0','253.11',NULL,0,'2014-03-06 21:02:26'),(28310,22400,'Y','18','021','EC','A','','','AC','0001175959','0001175959','MS00003432421','IL','1','Seay','Heather','Renee','','','34','467991771','308 KIMBERLY DR',0,'GULFPORT','MS','39503','2904','CY','28047','1988-06-18','F','M',':RET:2106-3','N','021','DEN','3752412','46300MS002000101','2014-04-01','2014-03-07 17:35:52','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15','CIC',0,'2014-03-07 21:00:36'),(13485,10753,'Y','18','021','EC','A','','','AC','0000446291','0000446291','OH00000182562','IL','1','Mays','Tracey','','','','34','293889761','159 MARATHON AVE',0,'DAYTON','OH','45405','3615','CY','39113','1987-11-27','M','U',':RET:2054-5','N','021','DEN','2614655','99734OH005000301','2014-01-01','2013-12-23 17:52:30','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:02:19'),(18612,14836,'N','01','021','EC','A',NULL,NULL,'','0000636041','0001050663','','IL','1','POLZIN','KATHERINE','','','','34','368029855','6938 DOMERSVILLE RD',0,'DEFIANCE','OH','43512','9123','CY','39039','1985-11-09','F','',':RET:2106-3','N','021','HLT','1994353','92036OH002002601','2014-02-01','2014-01-15 13:16:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','244.79',NULL,0,'2014-01-16 08:47:23'),(16910,13531,'Y','18','021','EC','A','','','AC','0000004730','0000004730','OH00002405870','IL','1','Fout','Stephen','','','','34','283863666','267 N SOUTH ST',0,'WILMINGTON','OH','45177','1660','CY','39027','1979-01-20','M','U',':RET:2106-3','N','021','DEN','1998052','99734OH005000401','2014-02-01','2014-01-09 11:29:08','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-13 02:19:37'),(16630,13304,'Y','18','021','EC','A','','','AC','0001252129','0001252129','OH00001527412','IL','1','MCKINNEY','CHRISTINE','','','','34','277540167','2314 E 37TH ST',0,'LORAIN','OH','44055','2803','CY','39093','1951-11-07','F','U',NULL,'N','021','DEN','2265374','99734OH005000401','2014-02-01','2014-01-07 09:09:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:14'),(16108,12902,'Y','18','024','14','A','','','TE','0000282616','0000282616','','IL','1','Ross','Bobby',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-17','M','',NULL,NULL,NULL,'','1832816','','2014-01-03','2014-01-03 11:39:08',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-04 02:04:59'),(20461,16345,'Y','18','021','EC','A','','','AC','0000669214','0000669214','OH00001358882','IL','1','Robinson','Teresa','','','','34','310705411','7005 MOORFIELD DR',0,'CINCINNATI','OH','45230','2258','CY','39061','1962-07-12','F','U',':RET:2106-3','N','021','DEN','3149860','99734OH005000401','2014-03-01','2014-01-29 10:18:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:51'),(27917,22085,'N','19','021','EC','A',NULL,NULL,'','0000248355','0001143680','','IL','1','ALVARADO','LEYBER','AARON','','','34','656181931','3045 YASMEEN CIR',0,'FLINT','TX','75762','6734','CY','48423','2004-06-04','M','',NULL,'N','021','DEN','3758819','33348TX002000201','2014-04-01','2014-03-05 21:56:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-03-06 21:00:19'),(16936,13554,'Y','18','024','14','A','','','TE','0002158528','0002158528','','IL','1','Hurst','Meshonda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-23','F','',NULL,NULL,NULL,'','2405431','','2014-01-08','2014-01-08 21:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 02:19:51'),(16138,12926,'Y','18','024','14','A','','','TE','0000490477','0000490477','','IL','1','Strayer','Brian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-03-31','M','',NULL,NULL,NULL,'','1753884','','2014-01-03','2014-01-03 10:42:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:05:54'),(15228,12173,'Y','18','021','EC','A','','','AC','0000968222','0000968222','OH00000688054','IL','1','Kuhnell','Keith','','','','34','278703995','5930 WOODSPOINT DR',0,'MILFORD','OH','45150','2157','CY','39025','1975-12-01','M','M',':RET:2106-3','N','021','HLT','1445791','92036OH005000605','2014-02-01','2013-12-29 23:38:17','519.00',NULL,NULL,'807.62','288.62','R-OH005','OH0','267.49',NULL,0,'2014-01-01 12:08:14'),(1868,1525,'Y','18','021','EC','A','','','AC','0001005719','0001005719','OH00000323495','IL','1','Watts','Glenda','','','','34','290588321','12513 Crennell Ave',0,'Cleveland','OH','44105',NULL,'CY','39035','1955-09-21','F','U',':RET:2054-5','N','021','HLT','2100138','52664OH152000901','2014-01-01','2013-12-24 12:33:03','293.00',NULL,NULL,'469.40','176.40','R-OH011','OH0','469.40',NULL,0,'2013-12-25 18:58:14'),(9724,7702,'Y','18','021','EC','A','','','AC','0000612954','0000612954','OH00000728762','IL','1','Fritsch','Charles','','','','34','274783153','832 SUNCREEK CT',0,'CINCINNATI','OH','45238','4836','CY','39061','1978-03-14','M','M',':RET:2106-3','T','021','DEN','89143','99734OH005000301','2014-01-01','2013-11-14 23:56:39','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:33'),(4465,3547,'Y','18','024','14','A','','','TE','0000639477','0000639477','','IL','1','Burgwald','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-06-15','F','',NULL,NULL,NULL,'','571271','','2013-12-12','2013-12-12 13:54:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:43'),(7614,6025,'Y','18','021','EC','A','','','AC','0001066133','0001066133','TX00000578326','IL','1','Luttrell','Regina','','','','34','490547936','2630 LARK LN',0,'HUMBLE','TX','77396','1844','CY','48201','1956-08-02','F','U',':RET:2106-3','N','021','DEN','242078','33348TX002000101','2014-01-01','2013-11-17 11:45:45','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:45:44'),(21486,17169,'Y','18','024','14','A','','','TE','0000408509','0000408509','','IL','1','BEASLEY','SUSAN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-08','F','',NULL,NULL,NULL,'','2889192','','2014-02-04','2014-02-04 17:53:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:45'),(22596,18048,'Y','18','021','EC','A','','','AC','0001033704','0001033704','OH00002117071','IL','1','Mullins','Curtis','','','','34','302686590','2658 NORTHVALE DR',0,'OREGON','OH','43616','2114','CY','39095','1960-11-16','M','M',':RET:2106-3','T','021','HLT','3768890','92036OH003002605','2014-03-01','2014-02-10 12:58:35','178.00',NULL,NULL,'477.73','299.73','R-OH001','OH0','477.73',NULL,0,'2014-02-10 21:32:12'),(23178,18479,'Y','18','024','14','A','','','TE','0000969471','0000969471','','IL','1','Zaerr','Lon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-05-22','M','',NULL,NULL,NULL,'','3640606','','2014-02-12','2014-02-12 14:41:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:56'),(25057,19870,'Y','18','021','EC','A','','','AC','0000841974','0000841974','OH00001838620','IL','1','Murphy','Donte','','','','34','293887194','4003 FRAMPTON CT',0,'ENGLEWOOD','OH','45322','2520','CY','39113','1988-04-14','M','M',':RET:2054-5','N','021','DEN','2620087','99734OH005000401','2014-04-01','2014-02-20 10:11:25','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-20 22:01:20'),(25653,20352,'Y','18','021','EC','A','','','AC','0000822104','0000822104','OH00002197972','S3','1','Berry StVictor','Sophia','Loren','','','34','268028359','2536 NONA RD',0,'COLUMBUS','OH','43207','2714','CY','39049','1996-08-12','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','3288257','99734OH005000401','2014-04-01','2014-02-22 14:40:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-02-26 08:30:40'),(26177,20758,'Y','18','021','EC','A','','','AC','0000296844','0000296844','OH00003402059','IL','1','Suveges','Jane','','','','34','282482366','9100 OLDE 8 RD',0,'NORTHFIELD','OH','44067','2773','CY','39153','1956-08-29','F','U',':RET:2106-3','N','021','DEN','3342135','99734OH005000301','2014-04-01','2014-02-26 18:45:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:38'),(29201,23109,'Y','18','024','14','A','','','TE','0000358115','0000358115','','IL','1','Speed','Bryan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-02','M','',NULL,NULL,NULL,'','3319793','','2014-03-10','2014-03-10 12:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCELCIC',0,'2014-03-10 21:30:10'),(17293,13830,'Y','18','021','EC','A','','','AC','0000157825','0000157825','TX00001358482','IL','1','Hoy','Danyeil','','','','34','350809223','21738 Colter Stone Dr.',0,'Spring','TX','77388',NULL,'CY','48201','1988-05-02','F','U',':RET:2054-5','N','021','DEN','2250928','33348TX002000201','2014-02-01','2014-01-09 22:34:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:23:34'),(16969,13582,'N','01','021','EC','A',NULL,NULL,'','0000564220','0000810801','','IL','1','Murdocco','Jean','A','','','34','286649775','340 Waterloo Rd',0,'Mogadore','OH','44260',NULL,'CY','39133','1957-04-11','F','',':RET:2106-3','N','021','HLT','2189827','52664OH151001306','2014-02-01','2014-01-09 17:01:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2014-01-13 02:20:12'),(926,769,'Y','18','021','EC','A','','','AC','0000115452','0000115452','OH00001052088','IL','1','Rini','Jennifer','Ann','','','34','296805161','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','1982-02-18','F','M',':RET:2106-3','N','021','DEN','19531','99734OH005000401','2014-01-01','2013-10-28 23:21:09','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:09:00'),(13581,10831,'N','19','021','EC','A',NULL,NULL,'','0002041430','0001714842','','IL','1','West','Josie','Nicole','','','34','435813776','12043 RODDY RD',0,'GONZALES','LA','70737','1838','CY','22005','1991-01-30','F','',':RET:2054-5','N','021','DEN','2276539','18575LA002000201','2014-01-01','2013-12-23 18:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:54'),(13445,10721,'Y','18','021','EC','A','','','AC','0000421463','0000421463','OH00000545827','IL','1','Campbell','Charles','','','','34','275607252','4356 N St Rt 741',0,'Lebanon','OH','45036',NULL,'CY','39165','1956-08-01','M','M',':RET:2106-3','N','021','DEN','1481146','99734OH005000301','2014-01-01','2013-12-23 14:01:25','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:19'),(15201,12149,'Y','18','021','EC','A','','','AC','0000286293','0000286293','MS00001549265','IL','1','Pitalo','Sherri','','','','34','587429647','13704 PARAISO RD',0,'OCEAN SPRINGS','MS','39564','2568','CY','28059','1950-01-06','F','M',':RET:2106-3','N','021','DEN','1434743','46300MS002000201','2014-02-01','2013-12-30 11:12:53','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-01 12:07:24'),(2728,2206,'Y','18','021','EC','A','','','AC','0000001004','0000001004','LA00001188785','31','1','Bruce','Staci','','','','34','425498836','614 SOPHIA LN',0,'SHREVEPORT','LA','71115','2406','CY','22017','1981-06-27','F','U',':RET:2106-3','N','021','DEN','255921','18575LA002000201','2014-01-01','2013-12-02 17:28:05','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 19:48:23'),(16418,13139,'Y','18','021','EC','A','','','AC','0000642087','0000642087','OH00001380364','IL','1','Miller','Diana','','','','34','297469967','4744 STONY CREEK RD',0,'URBANA','OH','43078','9454','CY','39021','1949-08-30','F','M',':RET:2106-3','N','021','HLT','2086405','92036OH001000501','2014-02-01','2014-01-06 15:18:35','0.00',NULL,NULL,'860.17','860.17','R-OH003','OH0','860.17',NULL,0,'2014-01-07 04:04:27'),(2904,2341,'Y','18','021','EC','A','','','AC','0000180980','0000180980','OH00001111919','IL','1','firm','edward','','','','34','268500507','492 fairview hts.',0,'toronto','OH','43964',NULL,'CY','39081','1949-02-17','M','M',':RET:2106-3','N','021','DEN','949064','99734OH005000401','2014-01-01','2013-12-05 23:04:10','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 20:15:25'),(5529,4385,'Y','18','021','EC','A','','','AC','0000533271','0000533271','OH00000826209','IL','1','Lloyd','Anna','','','','34','272866165','3400 CHARRING CROSS DR',0,'STOW','OH','44224','4609','CY','39153','1985-11-16','F','U',':RET:2106-3','N','021','DEN','309972','99734OH005000401','2014-01-01','2013-11-26 23:46:13','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:15:31'),(5738,4555,'Y','18','021','EC','A','','','AC','0002277331','0002277331','LA00000834046','IL','1','HAwkins','Vonnie','','','','34','437081177','13564 NEIL AVE',0,'BATON ROUGE','LA','70810','5137','CY','22033','1965-12-17','F','M',':RET:2106-3','N','021','DEN','2203223','18575LA002000201','2014-01-01','2013-12-23 23:38:34','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:52'),(1283,1060,'N','01','021','EC','A',NULL,NULL,'','0000558121','0000720213','','IL','1','Holmes','William','','','','34','271924266','1621 LAVAL DR',0,'CINCINNATI','OH','45255','3213','CY','39061','1978-10-26','M','',':RET:2106-3','N','021','DEN','264914','99734OH005000401','2014-01-01','2013-11-29 13:08:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:30:36'),(2362,1926,'Y','18','021','EC','A','','','AC','0000029011','0000029011','OH00000434156','IL','1','Yurcik','John','','','','34','278501615','13324 Tomson Drive',0,'Strongsville','OH','44149',NULL,'CY','39035','1952-05-15','M','U',':RET:2106-3','N','021','DEN','720935','99734OH005000401','2014-01-01','2013-12-09 07:31:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:32:31'),(5699,4523,'Y','18','021','EC','A','','','AC','0000644819','0000644819','MS00001067233','IL','1','CARTER','LAJUNA','CHANAIE','','','34','427292160','300 W CAYUGA ST',0,'CRYSTAL SPRINGS','MS','39059','2785','CY','28029','1971-03-10','F','M',':RET:2054-5','N','021','DEN','1252681','46300MS002000201','2014-01-01','2013-11-26 12:04:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:32:51'),(20440,16327,'Y','18','021','EC','A','','','AC','0000765706','0000765706','MS00001792511','31','1','Shepard','Richard','L','','','34','426176081','PO BOX 181',0,'Beulah','MS','38726',NULL,'CY','28011','1963-05-01','M','U',':RET:2054-5','N','021','DEN','2948559','46300MS002000101','2014-03-01','2014-01-28 19:19:03','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-29 21:00:40'),(21144,16895,'Y','18','024','14','A','','','TE','0000584548','0000584548','','IL','1','NGUYEN','HEIDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-01','F','',NULL,NULL,NULL,'','3021685','','2014-02-03','2014-02-03 16:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:00:23'),(23522,18738,'Y','18','021','EC','A','','','AC','0002298547','0002298547','LA00002238230','IL','1','Stainback','Robert','','','','34','231339172','5301 PERLITA ST',0,'NEW ORLEANS','LA','70122','1931','CY','22071','1972-03-07','M','M',':RET:2106-3','N','021','DEN','2653078','18575LA002000201','2014-03-01','2014-02-13 00:35:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:21'),(24104,19162,'Y','18','021','EC','A','','','AC','0000475867','0000475867','TX00002527409','IL','1','Roman','Salina','','','','34','465631793','701 CASCADE LN',0,'EL PASO','TX','79912','1305','CY','48141','1981-03-17','F','U',':RET:2106-3','N','021','DEN','3858915','33348TX002000201','2014-03-01','2014-02-14 18:45:04','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-15 22:01:32'),(24304,19304,'Y','18','021','EC','A','','','AC','0001200874','0001200874','OH00002440346','IL','1','Bunton','William','','','','34','509643458','1135 STONER ST',0,'AKRON','OH','44320','3507','CY','39153','1956-12-16','M','M',':RET:2054-5','N','021','HLT','3517969','52664OH152000901','2014-04-01','2014-02-18 16:35:34','598.00',NULL,NULL,'814.25','216.25','R-OH012','OH0','398.06','CIC',0,'2014-02-18 21:30:22'),(24578,19514,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000653252','','IL','1','ONWUAGBA','CHIDIEBUBE','','','','34','284112818','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','2000-06-04','M','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:15'),(24898,19741,'Y','18','021','EC','A','','','AC','0000737896','0000737896','OH00003009937','IL','1','MARTIN','DANETTE','','','','34','273843364','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','1983-10-22','F','M',NULL,'N','021','HLT','3420153','92036OH003002705','2014-01-01','2014-02-19 17:18:16','556.00',NULL,NULL,'720.88','164.88','R-OH006','OH0','231.13','CIC',0,'2014-02-20 05:40:57'),(25619,20326,'Y','18','021','EC','A','','','AC','0000773289','0000773289','TX00002763913','31','1','Hicks','Sabrina','','','','34','642281974','9356 Mechler Ln',0,'La Coste','TX','78039',NULL,'CY','48029','1992-03-08','F','U',':RET:2106-3','N','021','DEN','3664382','33348TX002000201','2014-04-01','2014-02-22 13:58:20','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-26 08:30:15'),(28051,22197,'Y','18','021','EC','A','','','AC','0000991542','0000991542','MS00002683548','31','1','SMITH','JOHNNY','C','','','34','587584769','P.O BOX 867',0,'TERRY','MS','39170',NULL,'CY','28049','1952-12-20','M','M',NULL,'T','021','DEN','4142773','46300MS002000201','2014-04-01','2014-03-06 11:36:21','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:37'),(14799,11819,'Y','18','021','EC','A','','','AC','0000589324','0000589324','OH00000061655','IL','1','Homan','Michael','','','','34','289647821','4460 TOWER RD',0,'DORSET','OH','44032','9628','CY','39007','1968-07-12','M','M',':RET:2106-3','N','021','DEN','1951572','99734OH005000401','2014-01-01','2013-12-23 19:40:15','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:42'),(6436,5104,'Y','18','021','EC','A','','','AC','0000677564','0000677564','LA00000059720','IL','1','perrin','susan','','','','34','438902402','106  Alyene St',0,'Lafayette','LA','70506',NULL,'CY','22055','1954-12-02','F','U',':RET:2106-3','T','021','DEN','454652','18575LA002000201','2014-01-01','2013-12-11 15:56:30','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:49:18'),(5927,4693,'N','19','021','EC','A',NULL,NULL,'','0000495608','0001074261','','IL','1','ling','kate','','','','34','644151165','1712 EDINBURG CT',0,'ALLEN','TX','75013','5335','CY','48085','2008-07-01','F','',':RET:2034-7','N','021','DEN','2450149','33348TX002000101','2014-01-01','2013-12-24 01:08:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2013-12-25 23:50:25'),(14593,11647,'Y','18','021','EC','A','','','AC','0001219600','0001219600','OH00001598168','IL','1','headrick','gary','','','','34','297647104','555 FRANKLIN AVE',0,'BARBERTON','OH','44203','2922','CY','39153','1960-06-28','M','M',':RET:2106-3','N','021','HLT','1988757','52664OH151001301','2014-02-01','2013-12-27 11:50:41','585.00',NULL,NULL,'952.25','367.25','R-OH012','OH0','454.94',NULL,0,'2013-12-28 03:36:10'),(1739,1443,'Y','18','021','EC','A','','','AC','0001011569','0001011569','OH00000356469','IL','1','heckel','gina','','','','34','291586997','5339 307TH ST',0,'TOLEDO','OH','43611','2667','CY','39095','1965-08-03','F','U',':RET:2106-3','N','021','DEN','2262542','99734OH005000301','2014-01-01','2013-12-24 11:06:17','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:55:30'),(13900,11086,'Y','18','021','EC','A','','','AC','0000672757','0000672757','OH00000048376','IL','1','Hull','valerie','','','','34','276686912','9462 Frankfort',0,'Holland','OH','43528',NULL,'CY','39095','1974-11-03','F','U',NULL,'N','021','HLT','2277910','92036OH006002601','2014-01-01','2013-12-23 07:05:47','0.00',NULL,NULL,'195.16','195.16','R-OH001','OH0','195.16',NULL,0,'2013-12-26 13:13:40'),(3267,2634,'Y','18','021','EC','A','','','AC','0000096561','0000096561','LA00000670563','IL','1','zeringue','shane','','','','34','435736493','2424 MARYLAND AVE',0,'METAIRIE','LA','70003','5412','CY','22051','1976-05-23','M','M',':RET:2106-3','N','021','DEN','13360','18575LA002000101','2014-01-01','2013-11-27 22:16:30','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:47:05'),(20924,16724,'Y','18','021','EC','A','','','AC','0000125594','0000125594','OH00002232413','IL','1','SCOTT','LISA','','','','34','278821045','1516 CHESTNUT BLVD',0,'CUYAHOGA FALLS','OH','44223','2347','CY','39153','1973-10-08','F','U',':RET:2106-3','N','021','HLT','2093280','52664OH151001501','2014-03-01','2014-01-31 13:48:38','159.00',NULL,NULL,'851.34','692.34','R-OH012','OH0','341.82',NULL,0,'2014-01-31 21:01:34'),(21862,17455,'Y','18','021','EC','A','','','AC','0000513364','0000513364','OH00002223913','IL','1','Kash','Marwan','','','','34','290666631','5646 REVERE DR',0,'NORTH OLMSTED','OH','44070','4472','CY','39035','1958-04-09','M','U',':RET:2106-3','N','021','DEN','3334110','99734OH005000301','2014-03-01','2014-02-06 16:17:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:01:20'),(24433,19408,'N','19','021','EC','A',NULL,NULL,'','0000524538','0001171933','','IL','1','Theodore','Sabastian','','','','34','270085907','889 ROBINSON AVE',0,'BARBERTON','OH','44203','3850','CY','39153','2002-09-26','M','',':RET:2106-3','N','021','HLT','3674864','52664OH151001305','2014-04-01','2014-02-18 13:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-18 22:01:15'),(26701,21167,'Y','18','024','14','A','','','TE','0001055297','0001055297','','IL','1','Dustin','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-12','M','',NULL,NULL,NULL,'','39950','','2014-03-15','2014-02-28 11:27:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 21:31:33'),(14151,11280,'Y','18','021','EC','A','','','AC','0001617692','0001617692','LA00000989037','IL','1','Murphy','Sean','','','','34','436596443','3865 MARTINIQUE AVE',0,'KENNER','LA','70065','3507','CY','22051','1985-09-10','M','U',':RET:2106-3','N','021','DEN','1488672','18575LA002000201','2014-02-01','2013-12-26 13:26:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:54'),(8098,6409,'Y','18','021','EC','A','','','AC','0001224459','0001224459','OH00000020274','IL','1','Smith','Denise','','','','34','301460575','736 EAST AVE',0,'TALLMADGE','OH','44278','2570','CY','39153','1950-08-28','F','M',NULL,'T','021','HLT','1588821','52664OH151001501','2014-01-01','2013-12-20 16:46:16','779.00',NULL,NULL,'1633.89','854.89','R-OH012','OH0','907.99',NULL,0,'2013-12-26 03:10:49'),(2617,2127,'N','01','021','EC','A',NULL,NULL,'','0000384367','0000805085','','IL','1','BALL','ROGER','','','','34','281541890','5600 BEATTY RD',0,'GROVE CITY','OH','43123','8945','CY','39049','1952-04-01','M','',':RET:2106-3','N','021','DEN','50013','99734OH005000401','2014-01-01','2013-12-02 14:56:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:45'),(7532,5962,'Y','18','021','EC','A','','','AC','0000398327','0000398327','TX00001174452','IL','1','Wack','Bryan','','','','34','495966139','7740 SUMMERBROOK CIR',0,'FORT WORTH','TX','76137','5464','CY','48439','1976-01-21','M','U',':RET:2106-3','N','021','DEN','676219','33348TX002000201','2014-01-01','2013-12-15 10:58:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:32:42'),(4011,3204,'Y','18','021','EC','A','','','AC','0000116581','0000116581','OH00000277998','IL','1','Lawhorn','Deborah','','','','34','276541342','4300 Regency Ridge Court',0,'cincinnati','OH','45248',NULL,'CY','39061','1964-07-31','F','U',':RET:2106-3','N','021','DEN','1423047','99734OH005000401','2014-01-01','2013-12-16 23:22:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:24'),(13819,11031,'Y','18','021','EC','A','','','AC','0001143316','0001143316','OH00000354985','IL','1','Kuntz','Corey','','','','34','285602784','2684 WADSWORTH RD',0,'NORTON','OH','44203','5368','CY','39153','1970-10-11','M','M',':RET:2106-3','N','021','HLT','2184575','52664OH152000901','2014-01-01','2013-12-22 20:11:59','166.00',NULL,NULL,'527.59','361.59','R-OH012','OH0','221.65',NULL,0,'2013-12-26 13:11:51'),(7265,5760,'Y','18','021','EC','A','','','AC','0000916063','0000916063','TX00000241943','31','1','Naizer','Noel','','','','34','631031926','PO Box 412',0,'Granger','TX','76530',NULL,'CY','48491','1987-12-07','F','U',':RET:2106-3','N','021','DEN','427341','33348TX002000201','2014-01-01','2013-12-13 22:33:58','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 02:02:14'),(5734,4551,'Y','18','021','EC','A','','','AC','0001561252','0001561252','LA00000111709','IL','1','Silva','Rhonda','M','','','34','276582540','31033 IRON KETTLE RD',0,'BUSH','LA','70431','6111','CY','22103','1969-02-28','F','M',':RET:2106-3','N','021','DEN','1551465','18575LA002000201','2014-01-01','2013-12-23 22:59:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:44'),(7242,5742,'Y','18','021','EC','A','','','AC','0000180762','0000180762','LA00000910530','IL','1','Nebret','David','','','','34','158462993','3207 Belmont Place',0,'Metairie','LA','70002',NULL,'CY','22051','1953-01-12','M','U',':RET:2028-9','N','021','DEN','1122765','18575LA002000201','2014-01-01','2013-12-14 10:55:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:41'),(19714,15709,'Y','18','021','EC','A','','','AC','0000414727','0000414727','OH00001866571','IL','1','Faller','Adam','','','','34','297565545','3084 CORYDON RD',0,'CLEVELAND HTS','OH','44118','3561','CY','39035','1967-03-14','M','U',':RET:2106-3','N','021','HLT','1384138','92036OH005000805','2014-03-01','2014-01-22 19:34:17','215.00',NULL,NULL,'350.69','135.69','R-OH011','OH0','350.69',NULL,0,'2014-01-23 21:00:54'),(21272,17001,'Y','18','024','14','A','','','TE','0001005719','0001005719','','IL','1','Watts','Glenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-21','F','',NULL,NULL,NULL,'','2100138','','2014-02-03','2014-02-03 12:35:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:31'),(13625,10864,'Y','18','021','EC','A','','','AC','0001097784','0001097784','OH00001355284','IL','1','WAGNER','DEBRA','','','','34','272603406','1000 SPRING LAKE DR',0,'PANDORA','OH','45877','9434','CY','39137','1958-01-09','F','U',NULL,'N','021','HLT','1929210','92036OH005001504','2014-01-01','2013-12-23 16:19:23','319.00',NULL,NULL,'490.79','171.79','R-OH002','OH0','490.79',NULL,0,'2013-12-26 13:05:58'),(7313,5795,'N','01','021','EC','A',NULL,NULL,'','0000600781','0000521930','','IL','1','Bennett','Ruth','','','','34','300607298','3452 VERNON ST NW',0,'BURGHILL','OH','44404','9704','CY','39155','1955-12-05','F','',':RET:2106-3','N','021','HLT','795079','92036OH005003201','2014-01-01','2013-12-14 00:09:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','616.74',NULL,0,'2013-12-26 02:03:23'),(18284,14597,'Y','18','021','EC','A','','','AC','0000142845','0000142845','OH00002147318','31','1','Jakuszeit','Jacob','','','','34','278884939','PO Box 921',0,'Athens','OH','45701',NULL,'CY','39009','1985-04-09','M','U',':RET:2106-3','N','021','DEN','2321076','99734OH005000401','2014-02-01','2014-01-14 19:48:43','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-01-16 08:44:48'),(4566,3615,'Y','18','021','EC','A','','','AC','0000364447','0000364447','TX00001256556','IL','1','DORSEY','DEBORAH','','','','34','460947031','2600 TWIN CITY HWY',0,'GROVES','TX','77619',NULL,'CY','48245','1954-09-16','F','U',':RET:2054-5','N','021','DEN','1050358','33348TX002000101','2014-01-01','2013-12-11 19:18:24','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2013-12-25 22:04:49'),(13890,11079,'Y','18','021','EC','A','','','AC','0000031937','0000031937','OH00000872106','IL','1','Young','Pearl','','','','34','268546206','3141 128TH ST',0,'TOLEDO','OH','43611','2620','CY','39095','1962-06-10','F','U',NULL,'N','021','HLT','2412477','92036OH005002606','2014-01-01','2013-12-23 13:31:37','297.00',NULL,NULL,'363.68','66.68','R-OH001','OH0','363.68',NULL,0,'2013-12-26 13:13:27'),(14061,11204,'Y','18','021','EC','A','','','AC','0000170163','0000170163','OH00000605520','IL','1','parks','omari','','','','34','291760929','1100 E 114TH ST',0,'CLEVELAND','OH','44108','3745','CY','39035','1976-08-20','M','U',':RET:2054-5','N','021','DEN','1644793','99734OH005000401','2014-02-01','2013-12-25 23:48:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:00:34'),(19468,15517,'Y','18','021','EC','A','','','AC','0000282935','0000282935','TX00001693959','IL','1','HART','LISA','R','','','34','634090066','1914 GREGORY DR',0,'AMARILLO','TX','79106','2478','CY','48375','1989-06-10','F','U',':RET:2106-3','N','021','DEN','2645919','33348TX002000201','2014-03-01','2014-01-22 16:01:41','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-23 03:01:58'),(24285,19286,'Y','18','024','14','A','','','TE','0001211629','0001211629','','IL','1','LaFargue','Richard','A','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-07-25','M','',NULL,NULL,NULL,'','2985259','','2014-03-31','2014-02-18 15:28:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-18 21:30:09'),(27294,21612,'Y','18','021','EC','A','','','AC','0001239612','0001239612','TX00003382459','IL','1','Nunn','David','E','','','34','540961633','8550 STATE HIGHWAY 34 N',0,'WOLFE CITY','TX','75496','2998','CY','48231','1952-12-04','M','M',NULL,'N','021','DEN','3425854','33348TX002000201','2014-04-01','2014-03-04 11:21:55','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-04 21:00:30'),(18711,14916,'N','19','021','EC','A',NULL,NULL,'','0000854219','0000590814','','IL','1','Henry','Lily',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1998-05-26','F','',':RET:2106-3','N','021','DEN','3018902','99734OH005000301','2014-02-01','2014-01-15 21:39:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:31'),(1054,864,'N','19','021','EC','A',NULL,NULL,'','0000247917','0000268879','','IL','1','Watson','Meaghan','L','','','34','629209868','6135 LA COSA DR',0,'DALLAS','TX','75248','4924','CY','48113','1990-10-31','F','',':RET:2106-3','N','021','DEN','365095','33348TX002000201','2014-01-01','2013-12-03 12:46:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:16:08'),(1728,1439,'Y','18','021','EC','A','','','AC','0000049491','0000049491','OH00000415059','IL','1','Zymler','Ryan','','','','34','276926156','2231 W 11TH ST',0,'CLEVELAND','OH','44113','3605','CY','39035','1989-05-16','M','U',NULL,'N','021','DEN','1469022','99734OH005000301','2014-01-01','2013-12-24 10:33:15','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:20'),(17076,13666,'Y','18','021','EC','A','','','AC','0001062453','0001062453','TX00002170060','IL','1','SALDANA','SULUMA','','','','34','452902975','304N N LIBERTY ST',0,'WESLACO','TX','78596','5218','CY','48215','1953-05-09','F','U',NULL,'N','021','DEN','1754163','33348TX002000201','2014-02-01','2014-01-08 12:07:01','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-13 02:21:20'),(2875,2323,'Y','18','021','EC','A','','','AC','0000617422','0000617422','TX00000020617','IL','1','Greene','Benjamin','','','','34','260415211','po box 45',0,'Foersetburg','TX','76239',NULL,'CY','48337','1970-10-01','M','U',':RET:2106-3','T','021','DEN','835271','33348TX002000201','2014-01-01','2013-10-22 13:59:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:02:02'),(5742,4558,'Y','18','021','EC','A','','','AC','0001984742','0001984742','LA00000761520','IL','1','Minor','Jo','','','','34','263610877','712 BELLEVILLE ST',0,'NEW ORLEANS','LA','70114','2403','CY','22071','1962-03-20','F','U',':RET:2054-5','N','021','DEN','2292182','18575LA002000201','2014-01-01','2013-12-24 00:38:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:59'),(7557,5981,'Y','18','021','EC','A','','','AC','0000154630','0000154630','OH00000550497','IL','1','Quesenberry','Madison','','','','34','272920773','115 W RACE ST',0,'MECHANICSBURG','OH','43044','1125','CY','39021','1989-04-30','F','U',':RET:2106-3','N','021','HLT','141967','92036OH004000501','2014-01-01','2013-12-14 22:04:41','117.00',NULL,NULL,'191.13','74.13','R-OH003','OH0','191.13',NULL,0,'2013-12-26 02:33:23'),(7157,5677,'N','01','021','EC','A',NULL,NULL,'','0001133950','0001011570','','IL','1','Hertzfeld','Andrea','L','','','34','290886897','1337 SENECA CREEK CT',0,'PERRYSBURG','OH','43551','6023','CY','39173','1980-12-15','F','',':RET:2106-3','N','021','HLT','2207053','92036OH004002601','2014-01-01','2013-12-24 20:51:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','187.83',NULL,0,'2013-12-26 01:52:21'),(19576,15604,'Y','18','021','EC','A','','','AC','0001435404','0001435404','LA00001868850','IL','1','EDWARDS','BETTY','JEAN','','','34','435941792','1835 JOB AVE',0,'ZACHARY','LA','70791','5909','CY','22033','1953-03-28','F','U',NULL,'N','021','DEN','2385773','18575LA002000201','2014-03-01','2014-01-22 17:27:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-23 03:02:38'),(19628,15644,'N','01','021','EC','A',NULL,NULL,'','0000271456','0000911794','','IL','1','FLEISHER','ANTHONY','','','','34','297664624','2408 BILLINGSLEY RD',0,'COLUMBUS','OH','43235','1922','CY','39049','1967-10-28','M','',NULL,'N','021','DEN','1786610','99734OH005000401','2014-03-01','2014-01-23 10:13:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:07'),(19544,15578,'Y','18','021','EC','A','','','AC','0000026400','0000026400','MS00002565642','IL','1','HENDERSON','JONAS','','','','34','420351502','887 WAY RD',0,'CANTON','MS','39046','9330','CY','28089','1964-11-09','M','M',':RET:2054-5','N','021','DEN','1712499','46300MS002000101','2014-03-01','2014-01-21 21:11:15','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-23 03:02:26'),(20455,16339,'Y','18','021','EC','A','','','AC','0000615545','0000615545','OH00002319206','IL','1','hunter','elizabeth','','','','34','279783754','4041 Hamilton Ave.',0,'Cincinnati','OH','45223',NULL,'CY','39061','1968-05-02','F','U',':RET:2106-3','N','021','DEN','2680476','99734OH005000401','2014-03-01','2014-01-29 07:38:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:47'),(25197,19988,'Y','18','021','EC','A','','','AC','0001767804','0001767804','LA00001787916','IL','1','Gold','Jacob','Adam','','','34','099722756','3909 IBERVILLE ST',0,'NEW ORLEANS','LA','70119','5115','CY','22071','1987-06-02','M','U',':RET:2106-3','N','021','DEN','3025405','18575LA002000201','2014-04-01','2014-02-20 18:42:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-21 22:00:44'),(26352,20905,'N','19','021','EC','A',NULL,NULL,'','0000132119','0000430320','','IL','1','Scott','Jillian','Rose','','','34','272069735','26961 SCHADY RD',0,'OLMSTED FALLS','OH','44138','1709','CY','39035','2000-11-20','F','',':RET:2106-3','N','021','HLT','2773072','92036OH002000801','2014-05-01','2014-02-27 14:27:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','171.46',NULL,0,'2014-02-28 06:31:47'),(26456,20983,'Y','18','021','EC','A','','','AC','0000105658','0000105658','MS00003389610','IL','1','Thompson','Jesse','','','','34','212889347','1154 NORTHSIDE DR',0,'PORT GIBSON','MS','39150','4241','CY','28021','1962-05-01','M','U',':RET:2054-5','N','021','DEN','3867593','46300MS002000101','2014-03-01','2014-02-27 11:06:50','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15','CIC',0,'2014-02-28 07:30:27'),(26711,21174,'Y','18','021','EC','A','','','AC','0000991598','0000991598','OH00002893885','IL','1','BENNER','DEBRA','','','','34','298629653','363 S HOWARD ST',0,'SABINA','OH','45169','1402','CY','39027','1960-03-08','F','M',':RET:2106-3','T','021','HLT','3777685','92036OH003000601','2014-03-01','2014-02-28 09:57:11','619.00',NULL,NULL,'1100.84','481.84','R-OH005','OH0','525.93',NULL,0,'2014-02-28 21:31:38'),(7116,5646,'Y','18','021','EC','A','','','AC','0000374712','0000374712','OH00000945182','IL','1','GODSEY','ELIZABETH','','','','34','293760136','5099 EVANS RUN RD',0,'GEORGETOWN','OH','45121','9742','CY','39015','1970-10-20','F','M',':RET:2106-3','T','021','HLT','1932553','92036OH001000601','2014-01-01','2013-12-24 19:21:33','0.00',NULL,NULL,'404.08','404.08','R-OH005','OH0','404.08',NULL,0,'2013-12-26 01:51:12'),(14548,11607,'Y','18','021','EC','A','','','AC','0000374641','0000374641','MS00001542753','IL','1','Anderson','kennethia','','','','34','427518087','1523 e County line rd',0,'jackson','MS','39211',NULL,'CY','28049','1985-01-18','F','U',':RET:2054-5','N','021','DEN','2201179','46300MS002000201','2014-02-01','2013-12-27 15:59:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:57'),(5957,4718,'Y','18','021','EC','A','','','AC','0000067675','0000067675','OH00000620672','IL','1','Ronda','Alan','','','','34','279822966','5066 Jamieson Drive',0,'Toledo','OH','43613',NULL,'CY','39095','1972-07-09','M','U',':RET:2106-3','N','021','HLT','2464769','92036OH001002601','2014-01-01','2013-12-23 22:08:35','0.00',NULL,NULL,'306.24','306.24','R-OH001','OH0','306.24',NULL,0,'2013-12-25 23:51:17'),(3514,2823,'Y','18','021','EC','A','','','AC','0000439558','0000439558','MS00001292312','31','1','Wyatt','Jerome','','','Jr','34','426530084','null null',0,'LAUREL','MS','39442','2362','CY','28067','1970-06-10','M','U',':RET:2054-5','T','021','DEN','2588588','46300MS002000201','2014-01-01','2013-12-22 07:56:13','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 21:21:05'),(3364,2696,'Y','18','021','EC','A','','','AC','0000211896','0000211896','TX00001072760','IL','1','Manes','Wesley','','','','34','525778301','3420 s coulter',0,'Amarillo','TX','79109',NULL,'CY','48381','1988-09-08','M','M',':RET:2106-3','N','021','DEN','2414982','33348TX002000201','2014-01-01','2013-12-22 14:01:02','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 21:17:04'),(22215,17732,'Y','18','021','EC','A','','','AC','0001959806','0001959806','LA00002494308','IL','1','jasmin','sidney','','','','34','433330893','2023 LAFITTE ST',0,'LA PLACE','LA','70068','2031','CY','22095','1973-02-22','M','U',':RET:2054-5','T','021','DEN','3250691','18575LA002000201','2014-03-01','2014-02-09 14:02:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:23'),(23631,18817,'N','01','021','EC','A',NULL,NULL,'','0000725342','0000775975','','IL','1','Bhakta','Jaynaben','','','','34','655527853','110 S MAIN',0,'DILLEY','TX','78017','3834','CY','48163','1975-10-12','F','',NULL,'N','021','DEN','2713126','33348TX002000201','2014-03-01','2014-02-13 18:16:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-14 21:30:03'),(23644,18827,'N','01','021','EC','A',NULL,NULL,'','0000805910','0000298921','','IL','1','SANTOS','REI','R','','','34','628314493','2813 E NOPAL DR',0,'EDINBURG','TX','78542','0576','CY','48215','1986-12-28','M','',':RET:2036-2','N','021','DEN','2909042','33348TX002000201','2014-03-01','2014-02-13 21:55:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-14 21:30:10'),(28053,22199,'Y','18','021','EC','A','','','AC','0000938109','0000938109','MS00003161430','IL','1','WARDELL','ROSEVELT','','','','34','425968608','1627 FAIRWOOD DR.',0,'JACKSON','MS','39213',NULL,'CY','28049','1950-03-12','M','M',':RET:2054-5','N','021','DEN','3751005','46300MS002000201','2014-04-01','2014-03-06 12:45:03','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:39'),(28644,22668,'Y','18','021','EC','A','','','AC','0000869546','0000869546','MS00002878993','IL','1','Buck','Nancy','J','','','34','428419078','2419 5TH AVE S',0,'COLUMBUS','MS','39701','6234','CY','28087','1981-11-25','F','U',':RET:2054-5','N','021','DEN','4221483','46300MS002000101','2014-04-01','2014-03-07 18:23:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-08 21:30:34'),(7676,6080,'Y','18','021','EC','A','','','AC','0001036125','0001036125','OH00000530133','IL','1','Dejager','Paul','','','','34','411065785','1306 azel ave',0,'Halmilton','OH','45013',NULL,'CY','39017','1969-11-20','M','U',':RET:2106-3','N','021','DEN','2355985','99734OH005000401','2014-01-01','2013-12-19 19:07:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:00:43'),(1925,1569,'N','19','021','EC','A',NULL,NULL,'','0001162559','0000963192','','IL','1','McAllister','Grant','','','','34','675243223','7019 DORAN DR',0,'NEW ALBANY','OH','43054','9320','CY','39049','2005-01-16','M','',':RET:2106-3','N','021','DEN','1165593','99734OH005000301','2014-01-01','2013-11-20 12:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:00:16'),(6644,5272,'Y','18','021','EC','A','','','AC','0000297118','0000297118','TX00000087187','IL','1','Strackbein','Barbara','','','','34','465023623','200 LUCKE DR',0,'FREDERICKSBURG','TX','78624','5990','CY','48171','1951-12-03','F','U',':RET:2106-3','N','021','DEN','324006','33348TX002000201','2014-01-01','2013-11-12 10:35:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:00:24'),(4531,3590,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00000930638','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','36996','33348TX002000201','2014-01-01','2013-12-12 15:54:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:03'),(6485,5136,'Y','18','021','EC','A','','','AC','0000755976','0000755976','OH00000493003','IL','1','JANOVEC','JOHN','MARTIN','','Jr','34','293421878','1076 NORTON AVE',0,'NORTON','OH','44203','6554','CY','39153','1962-08-09','M','U',':RET:2106-3','N','021','HLT','1015218','52664OH151001301','2014-01-01','2013-12-11 10:26:16','0.00',NULL,NULL,'415.91','415.91','R-OH012','OH0','415.91',NULL,0,'2013-12-26 00:50:25'),(19223,15316,'Y','18','021','EC','A','','','AC','0000884249','0000884249','OH00002133752','IL','1','MORTON','LELIA','','','','34','418724922','566 BRIDGESIDE DR',0,'AVON LAKE','OH','44012',NULL,'CY','39093','1949-12-04','F','U',':RET:2054-5','N','021','DEN','2927078','99734OH005000401','2014-03-01','2014-01-20 13:26:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:27'),(14217,11336,'Y','18','021','EC','A','','','AC','0000521514','0000521514','TX00000575363','IL','1','Alderson','Jerry','L','','Jr','34','629053225','45 McDonald Rd.',0,'Hooks','TX','75561',NULL,'CY','48037','1988-12-10','M','U',':RET:2106-3','N','021','DEN','2340153','33348TX002000201','2014-02-01','2013-12-26 16:25:36','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-27 02:04:38'),(20358,16259,'Y','18','021','EC','A','','','AC','0000274818','0000274818','OH00002305121','IL','1','Vrabel','Gregory','','','','34','293482050','224 VALLEY BROOK BLVD',0,'HINCKLEY','OH','44233','9686','CY','39103','1950-06-26','M','M',':RET:2106-3','N','021','HLT','2934290','52664OH152000901','2014-03-01','2014-01-28 16:50:14','359.00',NULL,NULL,'482.18','123.18','R-OH012','OH0','482.18',NULL,0,'2014-01-28 21:01:18'),(20503,16381,'Y','18','021','EC','A','','','AC','0001809837','0001809837','LA00002521927','IL','1','Gillyard','LaDeldrick','','','','34','436712884','428 SOUTHEAST ST',0,'MANSFIELD','LA','71052','3333','CY','22031','1988-07-23','M','R',':RET:2054-5','N','021','DEN','3371375','18575LA002000201','2014-03-01','2014-01-29 14:29:39','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-29 21:01:14'),(26497,21020,'Y','18','024','14','A','','','TE','0001064742','0001064742','','IL','1','PODOLL','BRETT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-25','M','',NULL,NULL,NULL,'','2214063','','2014-02-28','2014-02-28 16:28:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 21:00:14'),(26562,21058,'Y','18','021','EC','A','','','AC','0000956703','0000956703','OH00002414690','IL','1','WOEHRMEYER','DIANE','','','','34','271563522','2331 GOLF DR',0,'CINCINNATI','OH','45239','4618','CY','39061','1956-03-11','F','U',NULL,'N','021','DEN','3655888','99734OH005000401','2014-04-01','2014-02-27 23:02:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:20'),(16832,13463,'Y','18','021','EC','A','','','AC','0001046853','0001046853','OH00001775318','IL','1','MASSEL','EILEEN','','','','34','272685933','7544 BRIDGEFORD CT',0,'WEST CHESTER','OH','45069','5605','CY','39017','1961-06-05','F','M',':RET:2106-3','N','021','DEN','2014736','99734OH005000401','2014-02-01','2014-01-11 11:26:03','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:18:29'),(16533,13225,'N','01','021','EC','A',NULL,NULL,'','0000631957','0000964343','','IL','1','BRAY','TERRI','','','','34','427314840','2606 ROXANNE DR',0,'PEARL','MS','39208','6343','CY','28121','1972-11-07','F','',':RET:1002-5','N','021','DEN','2340359','46300MS002000201','2014-02-01','2014-01-04 21:46:54',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,1,'2014-01-07 10:22:05'),(5713,4536,'Y','18','021','EC','A','','','AC','0000575924','0000575924','OH00001050324','IL','1','Lewis','Daniel','','','','34','290869812','773 Marie Ave',0,'Akron','OH','44314',NULL,'CY','39153','1979-01-25','M','M',':RET:2054-5','N','021','HLT','2276578','52664OH151001306','2014-01-01','2013-12-23 23:16:42','435.00',NULL,NULL,'534.55','99.55','R-OH012','OH0','270.73',NULL,0,'2013-12-25 23:45:12'),(1878,1534,'Y','18','021','EC','A','','','AC','0000054464','0000054464','OH00001384421','IL','1','Smith','Kalin','','','','34','292908550','8939 COUNTY ROAD 21',0,'FAYETTE','OH','43521','9753','CY','39051','1989-06-16','F','U',':RET:2106-3','N','021','HLT','2349257','92036OH006002601','2014-01-01','2013-12-24 10:58:13','73.00',NULL,NULL,'154.64','81.64','R-OH001','OH0','154.64',NULL,0,'2013-12-25 18:58:28'),(4887,3875,'Y','18','021','EC','A','','','AC','0000025403','0000025403','LA00000570018','IL','1','Minson','Beau','M','','','34','436857610','9989 WILCOX ST',0,'SAINT FRANCISVILLE','LA','70775','4407','CY','22125','1984-09-26','M','U',NULL,'N','021','DEN','434517','18575LA002000201','2014-01-01','2013-10-04 12:59:20','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:31:23'),(6106,4840,'N','01','021','EC','A',NULL,NULL,'','0000818537','0001207113','','IL','1','Saunders','Julia','A','','','34','276045268','6772 US HIGHWAY 20',0,'METAMORA','OH','43540','9739','CY','39051','1968-08-16','F','',NULL,'N','021','DEN','25867','99734OH005000401','2014-01-01','2013-11-21 12:30:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:15:19'),(6457,5118,'Y','18','021','EC','A','','','AC','0000998757','0000998757','OH00000029878','IL','1','RICHARDSON','GARRY','','','','34','293524153','249 E FORD AVE',0,'BARBERTON','OH','44203','3232','CY','39153','1952-09-18','M','M',':RET:2106-3','N','021','HLT','22418','52664OH151001501','2014-01-01','2013-12-11 09:06:31','826.00',NULL,NULL,'1503.16','677.16','R-OH012','OH0','751.58',NULL,0,'2013-12-26 00:49:50'),(3376,2706,'Y','18','021','EC','A','','','AC','0000604202','0000604202','TX00000550903','IL','1','Reeise','Kenneth','','','','34','512946799','3533 BARCLAY DR',0,'AMARILLO','TX','79109','4009','CY','48381','1983-03-30','M','M',':RET:2106-3','N','021','DEN','1660474','33348TX002000201','2014-01-01','2013-12-22 17:04:24','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 21:17:23'),(22201,17720,'Y','18','021','EC','A','','','AC','0000968249','0000968249','OH00002455348','IL','1','FLATT','CHARLES','','','','34','519947439','575 BRUNNER DR',0,'CINCINNATI','OH','45240','3925','CY','39061','1964-02-25','M','R',':RET:2106-3','N','021','DEN','2881331','99734OH005000401','2014-03-01','2014-02-09 12:33:09','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-09 19:00:15'),(26375,20923,'Y','18','024','14','A','','','TE','0001090915','0001090915','','IL','1','Mack','Vada',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-10-03','F','',NULL,NULL,NULL,'','1807232','','2014-02-28','2014-02-26 17:28:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:15'),(26541,21046,'Y','18','021','EC','A','','','AC','0001231829','0001231829','OH00003390752','IL','1','Brown','Clyde','','','','34','282427153','7042 PINEVIEW DR',0,'HUBER HEIGHTS','OH','45424','2554','CY','39113','1953-06-23','M','M',':RET:2106-3','N','021','DEN','2965706','99734OH005000301','2014-04-01','2014-02-28 12:02:25','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-02-28 21:30:08'),(26627,21112,'Y','18','021','EC','A','','','AC','0000784040','0000784040','TX00002856769','IL','1','Sparks','Alice','','','','34','461922207','135 WOODLAND TRL',0,'GUN BARREL CITY','TX','75156','3528','CY','48213','1950-05-26','F','M',':RET:2106-3','N','021','DEN','3162785','33348TX002000201','2014-04-01','2014-02-28 13:23:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:55'),(27191,21529,'Y','18','021','EC','A','','','AC','0001171575','0001171575','TX00002853343','IL','1','REYES DE CEDILLO','SILVIA','','','','34','648468921','1602 N MUSKINGUM AVE',0,'ODESSA','TX','79761','2654','CY','48135','1957-11-21','F','M',NULL,'N','021','DEN','2740921','33348TX002000201','2014-04-01','2014-03-03 15:58:47','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-03-03 21:31:16'),(7249,5749,'Y','18','021','EC','A','','','AC','0001033944','0001033944','LA00000012315','IL','1','Bradstreet','Virginia','','','','34','435948973','1343 ESTATE CIR',0,'HAMMOND','LA','70403','5967','CY','22105','1956-01-13','F','U',NULL,'N','021','DEN','1029516','18575LA002000201','2014-01-01','2013-12-14 16:14:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:01:51'),(1419,1181,'Y','18','021','EC','A','','','AC','0001857590','0001857590','LA00001635879','31','1','BROWN','MICHAEL','','','','34','435949683','209 E THOMAS ST',0,'HAMMOND','LA','70401',NULL,'CY','22063','1956-10-02','M','M',NULL,'T','021','DEN','1860206','18575LA002000201','2014-01-01','2013-12-24 15:06:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:47:11'),(19202,15298,'Y','18','021','EC','A','','','AC','0000622514','0000622514','OH00001565426','IL','1','WADE','TANYA','','','','34','281720182','490 SNYDER AVE',0,'BARBERTON','OH','44203','4246','CY','39153','1962-10-26','F','U',':RET:2054-5','N','021','HLT','2769422','52664OH151001306','2014-03-01','2014-01-20 15:40:54','351.00',NULL,NULL,'415.91','64.91','R-OH012','OH0','415.91',NULL,0,'2014-01-21 08:46:17'),(1793,1472,'N','01','021','EC','A',NULL,NULL,'','0000627876','0000008425','','IL','1','Landfair','Shawn','M','','','34','576276021','4173 FOREST RIDGE BLVD',0,'DAYTON','OH','45424','4836','CY','39113','1974-07-25','F','',':RET:2028-9','N','021','DEN','2280430','99734OH005000301','2014-01-01','2013-12-24 16:43:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:35'),(18434,14707,'N','01','021','EC','A',NULL,NULL,'','0001846150','0002336140','','IL','1','French','Charles','','','','34','434869134','533 HICKORY BEND RD',0,'WEST MONROE','LA','71292','0179','CY','22073','1952-11-18','M','',':RET:2054-5','N','021','DEN','1737037','18575LA002000201','2014-02-01','2014-01-15 16:42:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:46:00'),(15925,12752,'Y','18','021','EC','A','','','AC','0000178548','0000178548','MS00001981150','IL','1','Temple','Jimmy','','','','34','426153161','448 OLD RIVER RD',0,'PETAL','MS','39465','9105','CY','28035','1961-01-29','M','M',':RET:2106-3','T','021','DEN','2458854','46300MS002000201','2014-02-01','2014-01-02 15:05:47','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2014-01-03 02:06:45'),(4081,3262,'Y','18','021','EC','A','','','AC','0000656919','0000656919','OH00000154142','IL','1','CHESMAR','LINDA','KAY','','','34','276661335','5759 CANTERBURY RD',0,'AKRON','OH','44319','5101','CY','39153','1960-10-28','F','M',':RET:2106-3','N','021','HLT','1756079','52664OH152000901','2014-01-01','2013-12-17 15:36:51','555.00',NULL,NULL,'998.33','443.33','R-OH012','OH0','333.21',NULL,0,'2013-12-25 21:47:11'),(4157,3313,'Y','18','021','EC','A','','','AC','0000930898','0000930898','OH00000574783','IL','1','NAKKA','COTTON','','','','34','366237733','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','1976-04-24','M','R',':RET:2029-7','N','021','DEN','1675008','99734OH005000301','2014-01-01','2013-12-17 15:18:48','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:55'),(15724,12576,'N','01','021','EC','A',NULL,NULL,'','0001128010','0000581505','','IL','1','Jamison','William','Edward','','IV','34','289743185','160 HICKORY HILLS DR',0,'SPRINGBORO','OH','45066','8625','CY','39165','1974-11-02','M','',':RET:2106-3','N','021','DEN','1945838','99734OH005000301','2014-02-01','2014-01-02 14:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:00:14'),(5541,4396,'Y','18','021','EC','A','','','AC','0000308233','0000308233','OH00000290675','IL','1','Kalk','Karl','','','','34','271488012','2305 FALLEN OAK CIR NE',0,'MASSILLON','OH','44646','4887','CY','39151','1949-08-22','M','U',':RET:2106-3','N','021','DEN','739263','99734OH005000401','2014-01-01','2013-11-27 16:18:35','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 23:15:48'),(20725,16560,'Y','18','021','EC','A','','','AC','0000670290','0000670290','OH00002018238','IL','1','Johnson','Sandra','','','','34','272463561','1471 Troy Rd',0,'Ashland','OH','44805',NULL,'CY','39005','1949-12-26','F','M',':RET:2106-3','N','021','HLT','3279222','52664OH151001305','2014-03-01','2014-01-30 11:58:50','584.00',NULL,NULL,'669.00','85.00','R-OH012','OH0','669.00',NULL,0,'2014-01-30 21:01:16'),(22682,18113,'Y','18','021','EC','A','','','AC','0000894039','0000894039','TX00002622501','IL','1','Ongesa','Yucabed','','','','34','455832426','1415 Seely street',0,'Arlington','TX','76018',NULL,'CY','48439','1961-11-18','F','M',':RET:2054-5','N','021','DEN','3482023','33348TX002000201','2014-03-01','2014-02-11 17:17:41','0.00',NULL,NULL,'56.37','56.37','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:48'),(24888,19733,'Y','18','024','14','A','','','TE','0001152250','0001152250','','IL','1','Irby','Melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-07-12','F','',NULL,NULL,NULL,'','3229869','','2014-03-31','2014-02-19 10:59:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:38:18'),(28685,22701,'Y','18','021','EC','A','','','AC','0000224785','0000224785','TX00003372600','31','1','hankston','kendreic','','','','34','453938968','18419 hazycrest dr',0,'spring','TX','77379',NULL,'CY','48201','1976-07-28','M','U',':RET:2054-5','T','021','DEN','3915906','33348TX002000101','2014-04-01','2014-03-08 16:39:34','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-08 21:30:59'),(26414,20948,'Y','18','024','14','A','','','TE','0000154627','0000154627','','IL','1','COTTRELL','MICHAEL','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-03-29','M','',NULL,NULL,NULL,'','265303','','2014-02-28','2014-02-26 15:43:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:42'),(26714,21176,'Y','18','021','EC','A','','','AC','0000434519','0000434519','MS00002269509','IL','1','Mallory','Tabitha','','','','34','425434759','95 OLD GRANGE HALL RD',0,'VICKSBURG','MS','39180','8049','CY','28149','1981-09-27','F','U',':RET:2054-5','N','021','DEN','3351821','46300MS002000201','2014-04-01','2014-02-28 10:20:32','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 21:31:40'),(27690,21899,'Y','18','021','EC','A','','','AC','0000482197','0000482197','TX00003214240','IL','1','MILLER','JOVAN','W','','','34','467630180','3303 SPOTTED HORSE DR',0,'KILLEEN','TX','76542','8447','CY','48027','1977-11-13','F','U',NULL,'N','021','DEN','3689967','33348TX002000201','2014-04-01','2014-03-05 09:52:41','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-05 21:30:43'),(29030,22976,'Y','18','021','EC','A','','','AC','0000582867','0000582867','OH00003656704','IL','1','Smith','Dwain','','','','34','279583676','2032 Parkhill Drive',0,'Dayton','OH','45406',NULL,'CY','39113','1959-09-28','M','U',':RET:2054-5','N','021','DEN','3617677','99734OH005000401','2014-04-01','2014-03-10 11:13:07','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:01:34'),(9709,7690,'N','01','021','EC','A',NULL,NULL,'','0000804829','0000746012','','IL','1','Nguyen','Trang','','','','34','438936797','522 SADDLER RD',0,'MARRERO','LA','70072','1631','CY','22051','1963-06-10','F','',':RET:2047-9','N','021','DEN','1004685','18575LA002000201','2014-01-01','2013-11-14 19:10:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:45:08'),(17801,14219,'N','01','021','EC','A',NULL,NULL,'','0001036149','0000277291','','IL','1','Schultz','Mick','','','','34','280908535','3920 Pansy Rd',0,'Clarksville','OH','45113',NULL,'CY','39027','1975-02-04','M','',':RET:2106-3','T','021','HLT','2630655','92036OH005000606','2014-02-01','2014-01-13 17:01:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','307.62',NULL,0,'2014-01-14 01:33:53'),(7320,5802,'Y','18','021','EC','A','','','AC','0000566077','0000566077','MS00001173311','IL','1','dobbs','kevin','','','','34','418906944','648 lakewood cove',0,'brandon','MS','39042',NULL,'CY','28121','1961-09-12','M','M',':RET:2106-3','N','021','DEN','754977','46300MS002000201','2014-01-01','2013-12-14 10:58:56','0.00',NULL,NULL,'112.74','73.52','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:03:36'),(6155,4880,'Y','18','021','EC','A','','','AC','0000254507','0000254507','OH00001033109','IL','1','Piening','James','','','','34','289520260','208 N HANOVER ST',0,'MINSTER','OH','45865','1068','CY','39011','1956-11-24','M','U',':RET:2106-3','T','021','HLT','838022','92036OH006001501','2014-01-01','2013-11-21 13:09:09','0.00',NULL,NULL,'489.17','489.17','R-OH002','OH0','489.17',NULL,0,'2013-12-26 00:16:37'),(15032,12015,'Y','18','021','EC','A','','','AC','0001466575','0001466575','LA00000144277','IL','1','Horn','Virgil','','','','34','323508358','128 Cecelia Street',0,'Morgan City','LA','70380',NULL,'CY','22007','1956-08-03','M','R',':RET:2106-3','T','021','DEN','1876689','18575LA002000201','2014-02-01','2013-12-30 11:30:43','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-01 12:02:39'),(14475,11549,'Y','18','021','EC','A','','','AC','0000100877','0000100877','TX00001825884','IL','1','Doucette','John','','','','34','032549321','1406 WILLOW ST',0,'AUSTIN','TX','78702','4302','CY','48453','1968-02-06','M','U',':RET:2106-3','N','021','DEN','1725405','33348TX002000201','2014-02-01','2013-12-26 20:22:39','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-28 03:33:07'),(18944,15094,'Y','18','021','EC','A','','','AC','0001206082','0001206082','TX00001828636','IL','1','Armstrong','Staci','','','','34','459875502','1801 MCCRACKEN ST',0,'ABILENE','TX','79602','4716','CY','48441','1986-08-09','F','M',':RET:2106-3','N','021','DEN','2182788','33348TX002000201','2014-03-01','2014-01-17 00:34:30','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-01-20 08:05:45'),(22235,17748,'Y','18','021','EC','A','','','AC','0000993908','0000993908','TX00002425466','IL','1','Uriegas','Maurice','','','','34','467853124','418 Prokop Court',0,'Webster','TX','77598',NULL,'CY','48201','1982-09-19','M','U',':RET:2106-3','N','021','DEN','2975239','33348TX002000101','2014-03-01','2014-02-09 15:56:29','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-09 19:00:34'),(24815,19676,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000149396','','IL','1','Burdick','Tanner','','','','34','302982628','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1996-06-20','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:08'),(27940,22102,'Y','18','021','EC','A','','','AC','0000616460','0000616460','TX00003114035','IL','1','Nance','Geremy','','','','34','628280098','616B Bermuda Street',0,'Copperas Cove','TX','76522',NULL,'CY','48099','1987-10-29','M','R',':RET:2106-3','N','021','DEN','4067379','33348TX002000201','2014-04-01','2014-03-06 13:46:11','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-06 21:00:31'),(28558,22601,'Y','18','024','14','A','','','TE','0001083506','0001083506','','IL','1','Mendez','Rosa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-11-12','F','',NULL,NULL,NULL,'','2713381','','2014-03-07','2014-03-07 13:24:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-07 21:32:24'),(17966,14356,'N','01','021','EC','A',NULL,NULL,'','0001096778','0000642090','','IL','1','ANDREWS','RICHARD','','','','34','284683515','2336 24TH ST',0,'CUYAHOGA FALLS','OH','44223','1510','CY','39153','1962-01-22','M','',':RET:2106-3','N','021','HLT','2117705','52664OH151001305','2014-02-01','2014-01-13 19:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2014-01-15 02:06:47'),(16704,13369,'Y','18','021','EC','A','','','AC','0000240978','0000240978','TX00001955277','IL','1','Maberry','Kathy','','','','34','465049632','54 E 37TH ST',0,'SAN ANGELO','TX','76903','2106','CY','48451','1952-01-24','F','U',':RET:2106-3','N','021','DEN','1378881','33348TX002000201','2014-02-01','2014-01-06 20:37:42','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-08 18:24:40'),(1264,1043,'Y','18','021','EC','A','','','AC','0000332893','0000332893','TX00000563676','31','1','Hernandez','Martin','','','','34','455853268','P.O. Box 147',0,'Brandon','TX','76628',NULL,'CY','48217','1963-03-19','M','M',NULL,'N','021','DEN','795837','33348TX002000201','2014-01-01','2013-11-28 19:20:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:30:04'),(4401,3499,'Y','18','021','EC','A','','','AC','0000878246','0000878246','OH00000312176','IL','1','Nelson','Tara','J','','','34','275882610','170 SHEPHERD CT',0,'LOVELAND','OH','45140','3021','CY','39165','1974-09-11','F','U',':RET:2106-3','N','021','DEN','1226391','99734OH005000401','2014-01-01','2013-12-12 14:15:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:10'),(1840,1507,'N','01','021','EC','A',NULL,NULL,'','0000872037','0000733588','','IL','1','Thielenhaus','Brenda','Jean','','','34','275805507','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1969-07-15','F','',':RET:2106-3','N','021','HLT','1860178','52664OH151001305','2014-01-01','2013-12-24 11:43:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2013-12-25 18:57:37'),(25012,19835,'Y','18','021','EC','A','','','AC','0000116634','0000116634','OH00002761218','IL','1','Beekman','Kathy','','','','34','269586923','901 GUSTAVUS LN',0,'COLUMBUS','OH','43205','1212','CY','39049','1962-07-15','F','M',':RET:2039-6^:RET:2106-3','N','021','DEN','2958112','99734OH005000301','2014-04-01','2014-02-19 19:25:40','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-02-20 22:00:52'),(25469,20206,'Y','18','021','EC','A','','','AC','0000608946','0000608946','TX00002105983','IL','1','McLaurin','Martha','','','','34','467536439','4015 CRYSTAL LAKE CIR S',0,'PEARLAND','TX','77584','2576','CY','48039','1961-10-28','F','U',':RET:2106-3','N','021','DEN','3399292','33348TX002000201','2014-04-01','2014-02-25 16:22:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:36'),(26484,21008,'Y','18','024','14','A','','','TE','0000163099','0000163099','','IL','1','crochet','erlin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-17','M','',NULL,NULL,NULL,'','1080882','','2014-03-31','2014-02-27 20:42:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 21:00:06'),(28675,22691,'Y','18','021','EC','A','','','AC','0000249179','0000249179','OH00003655178','IL','1','Gajewicz','Robert','','','Sr','34','296664455','5811 pheasant hollow',0,'Toledo','OH','43615',NULL,'CY','39095','1967-09-02','M','R',':RET:2106-3','T','021','HLT','2990985','92036OH004002601','2014-04-01','2014-03-07 21:05:05','0.00',NULL,NULL,'270.46','270.46','R-OH001','OH0','270.46',NULL,0,'2014-03-08 21:30:52'),(28803,22798,'N','19','021','EC','A',NULL,NULL,'','0000963305','0001247014','','IL','1','Bower','Chase','James','','','34','293025201','5207 SOUTH ST',0,'VERMILION','OH','44089','1348','CY','39043','1998-02-01','M','',':RET:2106-3','N','021','DEN','4279564','99734OH005000301','2014-04-01','2014-03-09 12:58:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:49'),(17681,14129,'N','19','021','EC','A',NULL,NULL,'','0001521983','0001869491','','IL','1','bratcher','patricia','','','','34','433853472','425 BELLEVUE DR',0,'LA PLACE','LA','70068','3403','CY','22095','1992-05-04','F','',NULL,'N','021','DEN','2433904','18575LA002000101','2014-02-01','2014-01-13 15:13:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-14 01:32:54'),(18655,14872,'Y','18','021','EC','A','','','AC','0000086468','0000086468','TX00001553229','IL','1','Bowden','Bobbie','','','','34','638425380','1010 E TYLER ST',0,'ATHENS','TX','75751','2144','CY','48213','1987-09-10','F','M',':RET:2106-3','T','021','DEN','2571391','33348TX002000201','2014-03-01','2014-01-16 14:17:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:11'),(3543,2845,'Y','18','021','EC','A','','','AC','0000639886','0000639886','TX00001172421','IL','1','Dickey','Grant','','','','34','454799970','1100 WINDMILL LN',0,'IRVING','TX','75061','6121','CY','48113','1977-05-22','M','U',':RET:2106-3','N','021','DEN','1718714','33348TX002000101','2014-01-01','2013-12-22 17:13:52','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:21:51'),(2154,1771,'N','01','021','EC','A',NULL,NULL,'','0000383016','0000862642','','IL','1','Rick','Elbert','Anthony','','','34','439862487','59561 COMPANY RD',0,'AMITE','LA','70422','3643','CY','22105','1954-10-31','M','',':RET:2106-3','N','021','DEN','1114789','18575LA002000101','2014-01-01','2013-12-09 20:29:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 19:18:39'),(16994,13603,'Y','18','021','EC','A','','','AC','0000667796','0000667796','OH00001780469','IL','1','freytes','heather','','','','34','049888917','18770 dellwood drive',0,'bedford','OH','44146',NULL,'CY','39035','1984-12-29','F','M',':RET:2106-3','N','021','DEN','2454767','99734OH005000301','2014-02-01','2014-01-08 22:50:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:20:27'),(19470,15519,'Y','18','021','EC','A','','','AC','0000276557','0000276557','TX00001548585','IL','1','harris','jami','','','','34','213216092','17301 gazebo lane apt 1604',0,'euless','TX','76040',NULL,'CY','48439','1986-12-30','F','U',':RET:2054-5','N','021','DEN','1820929','33348TX002000201','2014-03-01','2014-01-22 16:33:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 03:01:59'),(27188,21527,'Y','18','021','EC','A','','','AC','0000315634','0000315634','TX00003484437','31','1','PEREZ','MARIBEL','','','','34','453839186','PO BOX',0,'LA BLANCA','TX','78558',NULL,'CY','48215','1966-08-13','F','M',NULL,'N','021','DEN','3173272','33348TX002000201','2014-04-01','2014-03-03 15:44:04','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-03 21:31:14'),(27822,22004,'Y','18','021','EC','A','','','AC','0000982764','0000982764','OH00002862052','IL','1','HOBBS','ROBERT','','','','34','296600078','6042 5TH AVE',0,'MIAMISBURG','OH','45342','5117','CY','39113','1977-03-25','M','M',NULL,'N','021','DEN','3482622','99734OH005000301','2014-04-01','2014-03-05 01:18:34','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-03-05 21:31:56'),(28498,22550,'Y','18','021','EC','A','','','AC','0001215614','0001215614','MS00002789580','IL','1','Mcqueen','Florine','','','','34','427048405','1055 Quinn Street',0,'Jackson','MS','39202',NULL,'CY','28049','1956-03-24','F','U',':RET:2054-5','N','021','DEN','3237710','46300MS002000201','2014-04-01','2014-03-07 16:34:38','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-07 21:31:46'),(28867,22845,'Y','18','021','EC','A','','','AC','0001143715','0001143715','TX00003483342','IL','1','JACKSON','LARRY','','','','34','454042323','401 CORRELL AVE',0,'WHARTON','TX','77488','5607','CY','48481','1954-04-21','M','U',':RET:2054-5','N','021','DEN','3674002','33348TX002000201','2014-04-01','2014-03-09 18:20:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:00'),(29086,23022,'Y','18','021','EC','A','','','AC','0000888891','0000888891','TX00003285396','IL','1','Maculo','George','','','','34','453574706','615 SHADBERRY DR',0,'MAGNOLIA','TX','77354','1642','CY','48339','1953-09-24','M','M',':RET:2106-3','N','021','DEN','4352191','33348TX002000101','2014-04-01','2014-03-09 21:29:29','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-03-10 21:02:07'),(3086,2480,'Y','18','021','EC','A','','','AC','0000801224','0000801224','OH00000954815','IL','1','Evans','Paula','','','','34','450113370','2 PROMONT CT',0,'MILFORD','OH','45150','1762','CY','39025','1954-04-19','F','R',':RET:2106-3','N','021','HLT','914629','92036OH006000601','2014-01-01','2013-12-06 17:05:32','0.00',NULL,NULL,'443.16','443.16','R-OH005','OH0','443.16',NULL,0,'2013-12-25 20:19:51'),(17991,14378,'Y','18','021','EC','A','','','AC','0000231525','0000231525','OH00001647922','IL','1','Caynor','Sheila','','','','34','301463843','4124 HAWAII AVE',0,'NORTON','OH','44203','6171','CY','39153','1950-08-23','F','U',':RET:2106-3','N','021','HLT','2741249','52664OH151001305','2014-02-01','2014-01-14 18:07:54','525.00',NULL,NULL,'658.32','133.32','R-OH012','OH0','658.32',NULL,0,'2014-01-15 02:06:57'),(15450,12363,'Y','18','021','EC','A','','','AC','0001186465','0001186465','TX00001495329','IL','1','Cohen','Daniel','','','','34','462718501','286 VERANO DR',0,'KYLE','TX','78640','5768','CY','48209','1970-03-29','M','U',':RET:2106-3','N','021','DEN','2243450','33348TX002000201','2014-02-01','2013-12-31 15:18:14','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,1,'2014-01-02 04:28:20'),(14566,11621,'Y','18','021','EC','A','','','AC','0001140784','0001140784','OH00000822143','IL','1','Soto','Michael','','','','34','293689381','7720 ARLINGTON AVE',0,'CINCINNATI','OH','45255','3008','CY','39061','1974-06-25','M','R',':RET:1002-5^:RET:2106-3','N','021','HLT','2577523','92036OH006001201','2014-02-01','2013-12-26 20:57:03','0.00',NULL,NULL,'214.85','214.85','R-OH004','OH0','214.85',NULL,0,'2013-12-28 03:35:24'),(5667,4496,'Y','18','021','EC','A','','','AC','0000359651','0000359651','OH00001127017','IL','1','Ramage','Ryan','','','','34','277826408','13216 PRINCE GEORGES AVE NW',0,'UNIONTOWN','OH','44685','8284','CY','39151','1980-09-18','M','U',':RET:2106-3','N','021','HLT','1092859','52664OH151001306','2014-01-01','2013-11-26 11:46:25','172.00',NULL,NULL,'267.16','95.16','R-OH015','OH0','267.16',NULL,0,'2013-12-25 23:31:56'),(5501,4367,'Y','18','021','EC','A','','','AC','0000352822','0000352822','OH00000069082','IL','1','Huntington','Ruth','','','','34','298486074','3006 HAMMAN DR',0,'YOUNGSTOWN','OH','44511','1834','CY','39099','1950-01-19','F','U',NULL,'N','021','HLT','2440755','92036OH003003201','2014-01-01','2013-12-19 16:03:34','447.00',NULL,NULL,'746.18','299.18','R-OH013','OH0','746.18',NULL,0,'2013-12-25 23:11:20'),(20133,16066,'Y','18','024','14','A','','','TE','0001195530','0001195530','','IL','1','PALL','ELIZABETH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-26','F','',NULL,NULL,NULL,'','2481566','','2014-01-27','2014-01-27 12:53:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:53'),(21008,16787,'Y','18','021','EC','A','','','AC','0001131475','0001131475','OH00002446465','IL','1','Rudduck','Brett','','','','34','291763180','488 KATHRYN DR',0,'WILMINGTON','OH','45177','1712','CY','39027','1980-08-05','M','M',':RET:2106-3','T','021','DEN','2840026','99734OH005000401','2014-03-01','2014-01-31 22:19:53','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-02-01 19:00:33'),(21638,17278,'Y','18','021','EC','A','','','AC','0000235820','0000235820','TX00002143859','IL','1','Hill','Lisa','','','','34','463355260','784 HCR 1425',0,'Covington','TX','76636',NULL,'CY','48217','1960-11-08','F','U',NULL,'N','021','DEN','3567959','33348TX002000201','2014-03-01','2014-02-05 14:02:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:44'),(27497,21756,'Y','18','021','EC','A','','','AC','0000894683','0000894683','OH00002754069','IL','1','DOWDY','STEPHEN','','','','34','287764447','144 COUNTY ROAD 700',0,'WEST SALEM','OH','44287','9116','CY','39005','1964-11-10','M','U',NULL,'T','021','HLT','3313987','52664OH151001305','2014-04-01','2014-03-04 16:42:15','282.00',NULL,NULL,'437.52','155.52','R-OH012','OH0','437.52',NULL,0,'2014-03-04 21:02:26'),(13302,10619,'Y','18','021','EC','A','','','AC','0000920127','0000920127','TX00000368408','IL','1','Pride','Miata','Monique','','','34','638101565','2311 Garapan Dr',0,'Dallas','TX','75224',NULL,'CY','48113','1989-11-23','F','U',':RET:2054-5','N','021','DEN','2078546','33348TX002000201','2014-01-01','2013-12-23 14:56:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:49'),(18896,15056,'Y','18','021','EC','A','','','AC','0001198135','0001198135','OH00002078985','IL','1','Meyers','Jason','','','','34','279902750','4912 FAIRVIEW AVE',0,'BLUE ASH','OH','45242','6218','CY','39061','1984-02-14','M','U',':RET:2106-3','N','021','HLT','2815053','92036OH006001201','2014-02-01','2014-01-15 23:56:05','0.00',NULL,NULL,'190.50','190.50','R-OH004','OH0','190.50',NULL,0,'2014-01-17 03:36:34'),(17871,14277,'Y','18','021','EC','A','','','AC','0001064737','0001064737','OH00002510943','IL','1','KIRKLAND','TERESA','','','','34','268607590','522 S CHURCH ST',0,'SAINT PARIS','OH','43072','9503','CY','39021','1956-03-16','F','M',NULL,'N','021','DEN','2292755','99734OH005000401','2014-02-01','2014-01-14 13:57:06','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:14'),(7386,5846,'N','01','021','EC','A',NULL,NULL,'','0000029007','0000700345','','IL','1','Frenton','Teresa','Jean','','','34','277609916','514 BRENTWOOD DR',0,'NEWARK','OH','43055','9707','CY','39089','1957-11-20','F','',':RET:2106-3','N','021','DEN','1030460','99734OH005000401','2014-01-01','2013-11-23 14:23:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:16:02'),(3455,2779,'Y','18','021','EC','A','','','AC','0001024271','0001024271','OH00000844098','IL','1','baker','chrystine','','','','34','269747375','752 WILTSHIRE RD',0,'COLUMBUS','OH','43204','2337','CY','39049','1977-12-24','F','M',':RET:2106-3','N','021','DEN','1903279','99734OH005000401','2014-01-01','2013-12-21 23:10:58','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:19:37'),(19447,15501,'Y','18','024','14','A','','','TE','0000509175','0000509175','','IL','1','Abrams','Anita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-07','F','',NULL,NULL,NULL,'','475050','','2014-01-22','2014-01-22 16:00:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:01:51'),(23212,18504,'N','01','021','EC','A',NULL,NULL,'','0000196137','0001224462','','IL','1','Vogel','Joseph','A','','','34','283786682','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','1965-12-22','M','',':RET:2106-3','N','021','HLT','2825581','92036OH004000601','2014-03-01','2014-02-12 14:33:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','282.22',NULL,0,'2014-02-12 21:32:13'),(23441,18674,'Y','18','021','EC','A','','','AC','0000759906','0000759906','TX00002440222','IL','1','MARROQUIN','DORA','','','','34','451867840','762 RUBY RED ST',0,'MERCEDES','TX','78570','3942','CY','48215','1952-07-27','F','U',NULL,'N','021','DEN','3634981','33348TX002000201','2014-03-01','2014-02-13 11:51:53','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-13 22:01:33'),(23829,18960,'Y','18','021','EC','A','','','AC','0001077639','0001077639','MS00001954633','IL','1','Pearson','Dania','','','','34','587697429','853 SERVILLE DR',0,'JACKSON','MS','39206','4209','CY','28049','1983-08-12','F','U',':RET:2054-5','N','021','DEN','3208112','46300MS002000101','2014-03-01','2014-02-14 02:09:31','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-14 21:31:45'),(27166,21509,'N','01','021','EC','A',NULL,NULL,'','0001043033','0000105217','','IL','1','Canales','Melanie','Jean','','','34','122587132','4331 BRICK HOUSE',0,'SAN ANTONIO','TX','78222','2705','CY','48029','1975-10-08','F','',':RET:2106-3','N','021','DEN','2981799','33348TX002000201','2014-04-01','2014-03-03 10:34:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:02'),(15876,12713,'Y','18','021','EC','A','','','AC','0001044137','0001044137','MS00002092250','IL','1','harris','marcus','','','','34','587233995','1420 PITTSBURG ST',0,'JACKSON','MS','39203','2825','CY','28049','1975-08-11','M','U',':RET:2054-5','N','021','DEN','1695077','46300MS002000101','2014-02-01','2014-01-02 15:40:38','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-03 02:05:15'),(8041,6366,'Y','18','021','EC','A','','','AC','0000678084','0000678084','OH00000754265','IL','1','KOVALAK','WILLIAM','','','','34','285587719','423 WOODRIDGE RD',0,'VERMILION','OH','44089',NULL,'CY','39093','1960-08-18','M','U',NULL,'N','021','HLT','1900917','52664OH152000901','2014-01-01','2013-12-20 14:23:44','334.00',NULL,NULL,'375.82','41.82','R-OH011','OH0','375.82',NULL,0,'2013-12-26 03:09:25'),(6466,5124,'Y','18','021','EC','A','','','AC','0000656904','0000656904','OH00000996038','IL','1','Miller','Diana','Lynn','','','34','271540215','886 FLORIDA AVE',0,'AKRON','OH','44314','2071','CY','39153','1953-10-27','F','M',':RET:2106-3','N','021','HLT','1010199','52664OH151001301','2014-01-01','2013-12-10 19:12:39','223.00',NULL,NULL,'605.24','382.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 00:50:02'),(2497,2035,'Y','18','021','EC','A','','','AC','0000161576','0000161576','LA00000583398','IL','1','Pevey','Richard','','','','34','435845309','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1951-10-23','M','M',':RET:2106-3','N','021','DEN','740848','18575LA002000201','2014-01-01','2013-12-09 17:34:25','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:58'),(2819,2279,'Y','18','021','EC','A','','','AC','0000214252','0000214252','MS00001013552','31','1','Redmond','Sharon','','','','34','426252177','P.O.Box 477',0,'Sledge','MS','38670',NULL,'CY','28119','1966-09-05','F','U',':RET:2054-5','N','021','DEN','368941','46300MS002000201','2014-01-01','2013-11-24 16:32:46','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2013-12-25 20:00:27'),(5588,4433,'Y','18','021','EC','A','','','AC','0000232823','0000232823','LA00000924414','IL','1','Jefferson','Jarice','','','','34','437732254','315 FURMAN DR',0,'KENNER','LA','70065','4005','CY','22051','1988-08-08','F','U',':RET:2054-5','N','021','DEN','157570','18575LA002000101','2014-01-01','2013-11-05 19:28:47','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:17:10'),(21721,17345,'Y','18','021','EC','A','','','AC','0000346928','0000346928','OH00001851750','IL','1','SMITH','ANGELICA','','','','34','285680903','1920 S BYRNE RD',0,'TOLEDO','OH','43614','3665','CY','39095','1974-01-28','F','U',NULL,'N','021','HLT','2788725','92036OH006002601','2014-03-01','2014-02-05 15:57:38','139.00',NULL,NULL,'197.64','58.64','R-OH001','OH0','197.64',NULL,0,'2014-02-05 21:31:20'),(23811,18946,'Y','18','021','EC','A','','','AC','0000744477','0000744477','OH00002550586','IL','1','Klein','Donna','','','','34','276705068','93 South Tamarack Drive',0,'Akron','OH','44319',NULL,'CY','39153','1960-04-01','F','U',':RET:2106-3','N','021','HLT','3257291','52664OH152000901','2014-03-01','2014-02-14 11:18:25','232.00',NULL,NULL,'333.21','101.21','R-OH012','OH0','333.21',NULL,0,'2014-02-14 21:31:35'),(26452,20981,'N','19','021','EC','A',NULL,NULL,'','0000177461','0000681891','','S1','1','Bretheim','Shelly','','','','34','588014564','147 CHINQUIPIN CV',0,'RIDGELAND','MS','39157','1007','CY','28089','2006-12-15','F','',':RET:2106-3','N','021','DEN','3260961','46300MS002000101','2014-03-01','2014-02-27 07:32:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10','CIC',0,'2014-02-28 07:30:26'),(27859,22035,'Y','18','021','EC','A','','','AC','0000240416','0000240416','OH00002914446','IL','1','Scott','Debra','','','','34','290569280','34 BEAVER CREEK DR SW',0,'WARREN','OH','44481','9607','CY','39155','1958-01-04','F','U',':RET:2106-3','T','021','HLT','2693942','92036OH005003205','2014-04-01','2014-03-04 20:12:39','444.00',NULL,NULL,'649.40','205.40','R-OH013','OH0','649.40',NULL,0,'2014-03-05 21:32:17'),(902,748,'N','01','021','EC','A',NULL,NULL,'','0000062896','0000872000','','IL','1','OWENS','KAREN','','','','34','335466702','7207 LONDONDERRY DR',0,'SOUTHAVEN','MS','38671','5945','CY','28033','1952-04-23','F','',':RET:2054-5','N','021','DEN','2078157','46300MS002000101','2014-01-01','2013-12-16 14:52:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 18:08:18'),(1383,1148,'Y','18','021','EC','A','','','AC','0001655899','0001655899','LA00001136541','IL','1','GUICE','LISA','','','','34','434377082','6858 EASTLAKE RD',0,'STERLINGTON','LA','71220',NULL,'CY','22067','1963-08-02','F','M',':RET:2106-3','N','021','DEN','2035577','18575LA002000201','2014-01-01','2013-12-24 10:15:29','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 18:46:09'),(1715,1430,'N','19','021','EC','A',NULL,NULL,'','0000851841','0000122980','','IL','1','Handley','Caitlin','','','','34','286967738','5320 HI LO DR',0,'FRAZEYSBURG','OH','43822','9002','CY','39119','1993-09-08','F','',':RET:2106-3','N','021','DEN','1668699','99734OH005000301','2014-01-01','2013-12-24 08:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:04'),(18605,14833,'Y','18','021','EC','A','','','AC','0000816438','0000816438','OH00001748525','IL','1','CAMPOLONGO','DANTE','','','','34','282644839','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1957-08-27','M','M',NULL,'T','021','HLT','1840005','92036OH004000601','2014-02-01','2014-01-15 16:53:34','549.00',NULL,NULL,'1053.60','504.60','R-OH005','OH0','463.10',NULL,0,'2014-01-16 08:47:21'),(18421,14696,'Y','18','021','EC','A','','','AC','0001401560','0001401560','LA00001419379','IL','1','Singleton','Chantell','','','','34','437450216','2818 OREILLY ST',0,'NEW ORLEANS','LA','70119','2118','CY','22071','1979-12-19','F','U',':RET:2054-5','N','021','DEN','2303830','18575LA002000201','2014-02-01','2014-01-15 00:02:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:53'),(15072,12048,'Y','18','021','EC','A','','','AC','0000167611','0000167611','TX00001923098','IL','1','HOEFER','SUSAN','','','','34','462809419','3153 SILVERTON DR',0,'DALLAS','TX','75229','3753','CY','48113','1953-02-07','F','M',NULL,'N','021','DEN','1902424','33348TX002000101','2014-02-01','2013-12-29 19:14:54','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-01-01 12:03:56'),(22206,17723,'N','01','021','EC','A',NULL,NULL,'','0000870639','0001006832','','IL','1','darby','james','w','','','34','161449734','7 WHITEFRIARS DR',0,'AKRON','OH','44319','3050','CY','39153','1953-09-21','M','',':RET:2106-3','N','021','DEN','3324252','99734OH005000401','2014-03-01','2014-02-09 14:26:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-09 19:00:17'),(25138,19941,'Y','18','021','EC','A','','','AC','0000542424','0000542424','TX00002382765','IL','1','BURKE','BOBETTE','','','','34','461192798','2524 RIDGMAR BLVD',0,'FORT WORTH','TX','76116',NULL,'CY','48439','1956-12-01','F','U',':RET:2106-3','N','021','DEN','3711071','33348TX002000201','2014-04-01','2014-02-21 10:35:15','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-21 22:00:08'),(25291,20065,'N','01','021','EC','A',NULL,NULL,'','0001104507','0001115996','','IL','1','VON AHN','LAURA','','','','34','275822211','29 Zeller Court',0,'Berea','OH','44017',NULL,'CY','39035','1968-04-02','F','',':RET:2106-3','N','021','HLT','3055167','52664OH151001306','2014-03-01','2014-02-25 13:22:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.19','CIC',0,'2014-02-25 21:00:23'),(19750,15742,'Y','18','021','EC','A','','','AC','0000586720','0000586720','OH00002145011','IL','1','Riffle','Richard','','','','34','372589679','1831 MARNE AVE',0,'TOLEDO','OH','43613','5233','CY','39095','1951-08-03','M','U',':RET:2106-3','T','021','HLT','2628429','92036OH003002604','2014-03-01','2014-01-23 10:45:00','394.00',NULL,NULL,'672.80','278.80','R-OH001','OH0','672.80',NULL,0,'2014-01-23 21:01:17'),(16648,13319,'N','01','021','EC','A',NULL,NULL,'','0001002438','0000100259','','IL','1','Rhodes','Cynthia','','','','34','587624580','14398 T-Bird Road',0,'Biloxi','MS','39532',NULL,'CY','28047','1951-09-05','F','',':RET:2106-3','N','021','DEN','2568485','46300MS002000201','2014-02-01','2014-01-06 19:30:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-08 18:24:20'),(6000,4751,'Y','18','021','EC','A','','','AC','0000596986','0000596986','LA00001197581','IL','1','GASPER','THOMAS','J','','IV','34','437674106','1228 LEE ST',0,'MARRERO','LA','70072','2346','CY','22051','1977-06-18','M','M',':RET:2054-5','N','021','DEN','538371','18575LA002000201','2014-01-01','2013-12-01 06:35:16','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:00:20'),(15058,12036,'Y','18','021','EC','A','','','AC','0002178837','0002178837','LA00000531988','IL','1','Thomas','Rena','P','','','34','433045702','2516 GATES CIR',0,'BATON ROUGE','LA','70809','1019','CY','22033','1956-10-26','F','U',':RET:2054-5','N','021','DEN','1612055','18575LA002000201','2014-02-01','2013-12-30 15:01:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:27'),(6563,5202,'N','01','021','EC','A',NULL,NULL,'','0000590762','0001115481','','IL','1','Morales','Kristen',NULL,NULL,NULL,NULL,NULL,'4707 S. Austin',0,'Amarillo','TX','79110',NULL,'CY','48381','1984-03-21','F','',':RET:2106-3','N','021','DEN','1197163','33348TX002000201','2014-01-01','2013-12-11 13:23:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:52:28'),(7075,5614,'Y','18','021','EC','A','','','AC','0000293195','0000293195','OH00000772194','IL','1','Suski','Donna','','','','34','061422705','4818 MYRTLE AVE',0,'BLUE ASH','OH','45242','6133','CY','39061','1953-10-14','F','U',':RET:2106-3','T','021','DEN','2306848','99734OH005000301','2014-01-01','2013-12-24 23:11:30','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:50:08'),(7818,6193,'Y','18','021','EC','A','','','AC','0000723860','0000723860','TX00001281886','IL','1','Reed','Timothy','','','','34','636167595','3028 PALOMINO TRL',0,'ROBINSON','TX','76706','7295','CY','48309','1990-03-18','M','R',NULL,'N','021','DEN','1852379','33348TX002000201','2014-01-01','2013-12-20 18:03:25','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2013-12-26 03:04:07'),(14796,11816,'Y','18','021','EC','A','','','AC','0000739023','0000739023','OH00000891773','IL','1','KAUFMAN','SETH','','','','34','434550076','3966 AVILLA PL',0,'NORWOOD','OH','45212','4041','CY','39061','1984-01-16','M','U',':RET:2106-3','N','021','DEN','1546264','99734OH005000401','2014-01-01','2013-12-23 20:09:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:13:36'),(23414,18655,'Y','18','021','EC','A','','','AC','0000902343','0000902343','TX00002029155','IL','1','RAMIREZ','VERONICA','','','','34','451692218','13 HOHMANN RD',0,'SAN ANGELO','TX','76905','7318','CY','48451','1982-09-16','F','M',NULL,'N','021','DEN','3785077','33348TX002000201','2014-03-01','2014-02-12 20:05:31','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-13 22:01:17'),(24125,19176,'N','01','021','EC','A',NULL,NULL,'','0002315173','0002098191','','IL','1','Moton','Mildred','T','','','34','587640146','5433 RIVERBEND BLVD',0,'BATON ROUGE','LA','70820','4314','CY','22033','1951-09-19','F','',':RET:2054-5','N','021','DEN','2863476','18575LA002000101','2014-03-01','2014-02-14 20:55:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-15 22:01:44'),(26584,21078,'Y','18','021','EC','A','','','AC','0000609595','0000609595','OH00003099750','IL','1','TENNEY','MARGARET','FAYE','','','34','527156984','1112 PROSPECT STREET',0,'BARBERTON','OH','44203',NULL,'CY','39153','1955-01-02','F','M',':RET:2106-3','N','021','DEN','3587459','99734OH005000401','2014-04-01','2014-02-28 15:35:25','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-28 21:30:32'),(2006,1645,'Y','18','021','EC','A','','','AC','0000615472','0000615472','OH00000003603','IL','1','Kaminsky','Dorothy','','','','34','276528296','22 Amelia Olive Branch Rd',0,'Amelia','OH','45102',NULL,'CY','39025','1951-02-16','F','M',':RET:2106-3','N','021','HLT','564995','92036OH006000601','2014-01-01','2013-11-20 10:41:42','391.00',NULL,NULL,'489.12','98.12','R-OH005','OH0','489.12',NULL,0,'2013-12-25 19:02:20'),(18058,14427,'Y','18','021','EC','A','','','AC','0000398639','0000398639','OH00001898921','IL','1','Schriner','James','','','','34','290840228','2501 St Rt 138',0,'Sardinia','OH','45171',NULL,'CY','39071','1984-01-30','M','M',':RET:2106-3','N','021','HLT','1369814','92036OH003000606','2014-02-01','2014-01-13 19:45:37','470.00',NULL,NULL,'514.28','44.28','R-OH005','OH0','254.45',NULL,0,'2014-01-15 02:07:19'),(16854,13484,'Y','18','021','EC','A','','','AC','0001257349','0001257349','OH00002073386','IL','1','VIERS','RYAN','','','','34','283861512','21220 STATE ROUTE 51 W',0,'GENOA','OH','43430',NULL,'CY','39123','1983-02-22','M','U',':RET:2106-3','N','021','HLT','2091390','92036OH001002701','2014-02-01','2014-01-11 14:41:54','0.00',NULL,NULL,'266.97','266.97','R-OH006','OH0','266.97',NULL,0,'2014-01-13 02:18:42'),(6703,5314,'Y','18','021','EC','A','','','AC','0000372567','0000372567','OH00000564773','IL','1','beamish','carey','','','','34','295786427','221 STONE OAK CT',0,'HOLLAND','OH','43528','9256','CY','39095','1975-02-06','M','U',':RET:2106-3','T','021','HLT','297834','92036OH004002601','2014-01-01','2013-11-04 19:59:26','167.00',NULL,NULL,'224.68','57.68','R-OH001','OH0','224.68',NULL,0,'2013-12-26 01:01:58'),(7181,5694,'Y','18','021','EC','A','','','AC','0000183477','0000183477','OH00000372149','IL','1','dittmer','vickie','','','','34','292589122','2970 S 1ST ST',0,'CLINTON','OH','44216','9126','CY','39153','1956-03-31','F','U',':RET:2106-3','N','021','DEN','614813','99734OH005000301','2014-01-01','2013-12-14 10:33:29','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:00:13'),(16104,12899,'Y','18','021','EC','A','','','AC','0000091156','0000091156','OH00002109948','IL','1','Russell','Ryan','T','','','34','270947566','13885 MERMILL RD',0,'RUDOLPH','OH','43462','9799','CY','39173','1991-03-31','M','M',':RET:2106-3','T','021','HLT','1992943','92036OH003002605','2014-02-01','2014-01-02 22:07:31','239.00',NULL,NULL,'437.81','198.81','R-OH001','OH0','234.18',NULL,0,'2014-01-04 02:04:52'),(26852,21283,'Y','18','021','EC','A','','','AC','0000250198','0000250198','MS00003095364','IL','1','JONES','ELDORA','','','','34','425048762','816 BELL AVE',0,'CLEVELAND','MS','38732','3534','CY','28011','1957-01-25','F','U',NULL,'N','021','DEN','3662172','46300MS002000101','2014-04-01','2014-03-01 17:54:51','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-01 21:00:51'),(15035,12017,'Y','18','021','EC','A','','','AC','0001688293','0001688293','LA00001931911','IL','1','Winston','Charles','','','','34','437083700','4368 PETRUS AVE',0,'BASTROP','LA','71220','7211','CY','22067','1962-08-14','M','U',NULL,'T','021','DEN','1871877','18575LA002000201','2014-02-01','2013-12-30 11:46:30','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:02:45'),(21491,17172,'N','19','021','EC','A',NULL,NULL,'','0000103920','0000909511','','IL','1','Lyons','Andrew','','','','34','295049753','185 Forest Green Dr.',0,'Marblehead','OH','43440',NULL,'CY','39123','2000-03-10','M','',':RET:2106-3','N','021','HLT','3702652','92036OH002002701','2014-03-01','2014-02-04 14:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-02-04 21:01:47'),(21768,17383,'Y','18','021','EC','A','','','AC','0000783279','0000783279','OH00002410314','S3','1','DOWNING-JOHNSON','WAYNETTE',NULL,NULL,NULL,NULL,NULL,'19353 BAGLEY RD APT B204',0,'MIDDLEBURG HEIGHTS','OH','44130',NULL,'CY','39035','2001-10-08','F','U',NULL,'N','021','DEN','2842690','99734OH005000401','2014-03-01','2014-02-06 11:10:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2014-02-06 21:00:30'),(22940,18289,'Y','18','021','EC','A','','','AC','0000259277','0000259277','OH00002340335','IL','1','whitaker','norman','','','','34','284624348','607 W WILLIAM ST',0,'MAUMEE','OH','43537','2061','CY','39095','1959-03-22','M','M',':RET:2106-3','T','021','HLT','3115491','92036OH004002601','2014-03-01','2014-02-10 22:31:04','500.00',NULL,NULL,'769.94','269.94','R-OH001','OH0','384.97','CIC',0,'2014-02-11 21:30:19'),(17200,13764,'Y','18','021','EC','A','','','AC','0000814303','0000814303','OH00001423866','IL','1','WILSON','GARY','','','','34','288508340','2887 E TURKEYFOOT LAKE RD',0,'UNIONTOWN','OH','44685','7532','CY','39153','1951-02-28','M','U',NULL,'T','021','HLT','1882320','52664OH152000901','2014-02-01','2014-01-08 12:00:41','514.00',NULL,NULL,'539.67','25.67','R-OH012','OH0','539.67',NULL,0,'2014-01-13 02:22:24'),(5138,4072,'Y','18','021','EC','A','','','AC','0000132060','0000132060','OH00000715343','IL','1','Daniel','Jamiliah','','','','34','299849537','1221 EVERTON DR',0,'AKRON','OH','44307','1460','CY','39153','1986-11-05','F','U',':RET:2054-5','N','021','DEN','2214240','99734OH005000401','2014-01-01','2013-12-18 19:06:49','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:02:26'),(1120,923,'Y','18','021','EC','A','','','AC','0001118687','0001118687','OH00000298512','IL','1','Winegardner','Jaime','','','','34','291841745','100 MASTERS CT',0,'LIMA','OH','45805','4007','CY','39003','1981-01-05','F','M',':RET:2106-3','N','021','HLT','1096653','92036OH003001501','2014-01-01','2013-12-02 19:33:02','0.00',NULL,NULL,'844.64','844.64','R-OH002','OH0','271.90',NULL,0,'2013-12-25 18:17:47'),(1127,927,'Y','18','021','EC','A','','','AC','0001023120','0001023120','TX00000839395','IL','1','Odems','Ladonna','Renee','','','34','463299078','2101 JACK COUNTY DR',0,'FORNEY','TX','75126','5146','CY','48257','1961-11-04','F','U',':RET:2054-5','N','021','DEN','833241','33348TX002000101','2014-01-01','2013-12-02 20:03:34','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:17:56'),(3839,3071,'Y','18','021','EC','A','','','AC','0000776457','0000776457','LA00000147627','IL','1','Smith','Ricky','','','','34','433356400','9137 BEECHWOOD DR',0,'BASTROP','LA','71220','4801','CY','22067','1976-06-14','M','U',':RET:2054-5','N','021','DEN','936125','18575LA002000101','2014-01-01','2013-12-13 18:05:04','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 21:35:20'),(15778,12627,'Y','18','021','EC','A','','','AC','0000471849','0000471849','TX00001710185','IL','1','Luna','Araceli','','','','34','457539294','800 w rancho blanco rd',0,'pharr','TX','78577',NULL,'CY','48215','1964-04-14','F','U',NULL,'N','021','DEN','2566228','33348TX002000201','2014-02-01','2014-01-02 17:00:22','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-03 02:02:02'),(3185,2561,'Y','18','021','EC','A','','','AC','0000915570','0000915570','LA00001078084','IL','1','CALLEGARI','PEGGY','S','','','34','439906217','839 HORSESHOE DR',0,'COTTONPORT','LA','71327',NULL,'CY','22009','1952-05-11','F','M',':RET:2106-3','N','021','DEN','730583','18575LA002000201','2014-01-01','2013-11-18 17:50:31','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 20:31:58'),(7760,6147,'Y','18','021','EC','A','','','AC','0000634800','0000634800','OH00000313675','IL','1','Whittridge','Kimberly','A',NULL,NULL,NULL,NULL,'1043 W ALKALINE SPRINGS RD',0,'VANDALIA','OH','45377','1101','CY','39113','1959-09-15','F','R',':RET:2106-3','N','021','DEN','1696910','99734OH005000401','2014-01-01','2013-12-20 17:49:13','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:02:44'),(7800,6178,'Y','18','021','EC','A','','','AC','0000176330','0000176330','TX00000456361','31','1','Lambert','LaDonna','','','','34','443521467','Post Office Box 156',0,'Gause','TX','77857',NULL,'CY','48331','1950-01-06','F','M',':RET:2106-3','N','021','DEN','1509405','33348TX002000201','2014-01-01','2013-12-20 16:18:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:39'),(15070,12047,'Y','18','021','EC','A','','','AC','0000322500','0000322500','MS00001437253','IL','1','Santibanez','Rita','M','','','34','541217619','909 WHITWORTH ST',0,'JACKSON','MS','39202','2744','CY','28049','1987-08-21','F','M',NULL,'N','021','DEN','2331134','46300MS002000101','2014-02-01','2013-12-30 18:14:45','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-01 12:03:52'),(9721,7699,'N','01','021','EC','A',NULL,NULL,'','0000345545','0000144180','','IL','1','Brosky','David','','','','34','297529264','9968 AKINS RD',0,'NORTH ROYALTON','OH','44133','4547','CY','39035','1950-12-26','M','',':RET:2106-3','N','021','DEN','450199','99734OH005000401','2014-01-01','2013-11-15 17:58:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:27'),(26819,21254,'Y','18','021','EC','A','','','AC','0000067716','0000067716','OH00003567334','IL','1','Reding','Thomas','','','','34','069749798','2112 Lennox Rd.',0,'Cleveland Heights','OH','44106',NULL,'CY','39035','1981-06-15','M','U',':RET:2106-3','N','021','DEN','3092693','99734OH005000401','2014-04-01','2014-03-01 00:21:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:33'),(27932,22095,'N','01','021','EC','A',NULL,NULL,'','0000872922','0001011829','','IL','1','Denbow','William','Kevin','','','34','460690387','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1968-09-16','M','',':RET:2106-3','N','021','DEN','3860455','33348TX002000201','2014-04-01','2014-03-06 12:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-06 21:00:26'),(20787,16609,'Y','18','024','14','A','','','TE','0001062373','0001062373','','IL','1','Eisenman','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-11-03','F','',NULL,NULL,NULL,'','2212073','','2014-01-31','2014-01-31 09:11:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-31 21:00:13'),(3178,2556,'Y','18','021','EC','A','','','AC','0001210883','0001210883','OH00000652498','IL','1','Deadwyler','Arianna','','','','34','286766035','4982 East 88th Street',0,'Cleveland','OH','44125',NULL,'CY','39035','1967-02-03','F','M',':RET:2054-5','N','021','HLT','292194','92036OH004000801','2014-01-01','2013-11-17 19:46:48','411.00',NULL,NULL,'537.08','126.08','R-OH011','OH0','281.98',NULL,0,'2013-12-25 20:31:47'),(4085,3263,'Y','18','021','EC','A','','','AC','0000714959','0000714959','OH00001186549','IL','1','Lamovsky','Saul','','','','34','273727389','516 Massillon Rd',0,'Akron','OH','44306',NULL,'CY','39153','1972-02-22','M','M',':RET:2106-3','N','021','HLT','1912581','52664OH152000901','2014-01-01','2013-12-17 16:38:32','0.00',NULL,NULL,'212.67','212.67','R-OH012','OH0','212.67',NULL,0,'2013-12-25 21:47:15'),(3860,3090,'Y','18','021','EC','A','','','AC','0001048122','0001048122','LA00000379762','IL','1','reeves','laurie','','','','34','220869031','363 WHIPPOORWILL RD',0,'DERIDDER','LA','70634','7123','CY','22011','1965-03-20','F','M',':RET:2106-3','N','021','DEN','374276','18575LA002000201','2014-01-01','2013-12-12 20:27:48','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 21:35:54'),(19944,15907,'Y','18','024','14','A','','','TE','0000727259','0000727259','','IL','1','RAFHEED','KHADIJAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-23','F','',NULL,NULL,NULL,'','861673','','2014-01-24','2014-01-24 10:14:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:01:17'),(22426,17907,'Y','18','021','EC','A','','','AC','0001113260','0001113260','TX00002286967','31','1','IBARRA','VIDAL','','','','34','449857800','P.O. Box 7321',0,'Glen Rose','TX','76043',NULL,'CY','48425','1951-04-09','M','M',NULL,'N','021','DEN','3762939','33348TX002000201','2014-03-01','2014-02-09 18:36:05','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-10 21:30:33'),(24732,19634,'Y','18','021','EC','A','','','AC','0000467141','0000467141','OH00002367482','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-20 04:39:15'),(24989,19819,'N','01','021','EC','A',NULL,NULL,'','0000320645','0000493368','','IL','1','Mrasi','Zaineh','','','','34','729094705','3634 WINGATE PARK',0,'HOUSTON','TX','77082','9001','CY','48201','1986-05-19','F','',':RET:2028-9','N','021','DEN','3404827','33348TX002000201','2014-04-01','2014-02-20 13:58:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 22:00:39'),(25156,19955,'N','01','021','EC','A',NULL,NULL,'','0001019041','0001101617','','IL','1','Gordon','Teresa','','','','34','460043279','307 N FOREST BLVD',0,'HOUSTON','TX','77090','4747','CY','48201','1952-11-16','F','',':RET:2106-3','N','021','DEN','3194078','33348TX002000201','2014-04-01','2014-02-21 16:02:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-21 22:00:19'),(25542,20263,'Y','18','021','EC','A','','','AC','0000050739','0000050739','OH00003073988','31','1','McElroy','Matthew','Kemp','','','34','293861391','P.O Box 5768',0,'athens','OH','45701',NULL,'CY','39009','1973-10-18','M','U',':RET:2106-3','N','021','DEN','2920052','99734OH005000301','2014-04-01','2014-02-23 15:33:26','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-02-26 08:00:12'),(25686,20379,'Y','18','021','EC','A','','','AC','0000137727','0000137727','MS00002921432','IL','1','Hossley','Dellonte','','','','34','269725584','580 S pear orchard rd',0,'ridgeland','MS','39157',NULL,'CY','28089','1973-11-22','M','U',':RET:2054-5','N','021','DEN','3149379','46300MS002000201','2014-04-01','2014-02-24 15:53:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:08'),(27936,22099,'Y','18','021','EC','A','','','AC','0000696190','0000696190','TX00003663780','IL','1','MORENO','CINDY','','','','34','627162266','9105 MCNORTON RD',0,'CORPUS CHRISTI','TX','78409','2429','CY','48355','1973-04-19','F','M',NULL,'N','021','DEN','3918386','33348TX002000201','2014-04-01','2014-03-06 13:24:23','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-03-06 21:00:28'),(19741,15733,'Y','18','021','EC','A','','','AC','0001792350','0001792350','LA00002429089','IL','1','Sigler','Cameron','','','','34','641347458','18217 MANCHAC PLACE DR',0,'PRAIRIEVILLE','LA','70769','3355','CY','22005','1988-01-26','F','U',':RET:2106-3','N','021','DEN','2498879','18575LA002000201','2014-03-01','2014-01-23 15:47:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-23 21:01:11'),(18793,14969,'Y','18','021','EC','A','','','AC','0000521973','0000521973','OH00002123072','IL','1','Parkhouse','Elizabeth','','','','34','297846690','211 Orchard St',0,'Cincinnati','OH','45202',NULL,'CY','39061','1986-06-03','F','R',':RET:2106-3','N','021','DEN','2724971','99734OH005000401','2014-03-01','2014-01-16 09:33:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:57'),(550,451,'Y','18','021','EC','A','','','AC','0000532715','0000532715','TX00000635127','IL','1','Bailey','Marcus','D','','','34','459316057','2720 BRIARWOOD DR',0,'PARIS','TX','75460','3389','CY','48277','1975-03-04','M','U',':RET:2054-5','N','021','DEN','316449','33348TX002000101','2014-01-01','2013-12-04 12:44:34','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 17:50:00'),(17956,14347,'Y','18','021','EC','A','','','AC','0000202929','0000202929','TX00001730405','IL','1','Simien','Diann','','','','34','453063576','407 GLENSTONE ST',0,'HOUSTON','TX','77013','5001','CY','48201','1956-11-21','F','R',NULL,'N','021','DEN','1651524','33348TX002000201','2014-02-01','2014-01-14 17:41:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-15 02:06:44'),(2566,2085,'Y','18','021','EC','A','','','AC','0000044246','0000044246','OH00000614866','IL','1','SCHRODDER','MARK',NULL,NULL,NULL,NULL,NULL,'4333 ZURMEHLY RD',0,'LIMA','OH','45806','1028','CY','39003','1956-11-15','M','M',':RET:2106-3','N','021','HLT','950513','92036OH006001501','2014-01-01','2013-12-09 11:55:27','678.00',NULL,NULL,'814.59','136.59','R-OH002','OH0','425.36',NULL,0,'2013-12-25 19:37:33'),(3634,2908,'Y','18','021','EC','A','','','AC','0000413188','0000413188','MS00000260817','IL','1','Hearn','Mary','','','','34','587228352','5645 North Washington St',0,'Vicksburg','MS','39183',NULL,'CY','28149','1950-09-16','F','M',':RET:2106-3','N','021','DEN','1134414','46300MS002000201','2014-01-01','2013-12-13 17:31:41','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:13'),(6399,5071,'Y','18','021','EC','A','','','AC','0000089803','0000089803','OH00000561626','IL','1','Conley','Maureen','','','','34','279641055','2646 HENTHORN RD',0,'UPPER ARLINGTON','OH','43221','3214','CY','39049','1958-07-07','F','U',':RET:2106-3','N','021','DEN','827436','99734OH005000301','2014-01-01','2013-12-11 13:16:39','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:48:18'),(7021,5575,'Y','18','021','EC','A','','','AC','0000890999','0000890999','TX00000659893','IL','1','SALAHUDEEN','SAJEETHA','','','','34','638705044','805 CARLETON DR',0,'RICHARDSON','TX','75081','5908','CY','48113','1973-07-18','F','M',':RET:2028-9','N','021','DEN','2261579','33348TX002000201','2014-01-01','2013-12-24 21:43:25','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:48:51'),(15109,12076,'N','01','021','EC','A',NULL,NULL,'','0001049386','0001204538','','IL','1','DIPUCCIO','BARBARA','J','','','34','281664048','58 E HOWE RD',0,'TALLMADGE','OH','44278','1055','CY','39153','1962-11-15','F','',NULL,'N','021','DEN','2121427','99734OH005000301','2014-02-01','2013-12-30 13:01:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:04:55'),(8012,6342,'Y','18','021','EC','A','','','AC','0000216090','0000216090','OH00000566649','IL','1','Ayers','Lisa','','','','34','274805391','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1970-02-05','F','R',':RET:2106-3','N','021','HLT','2430784','92036OH001000601','2014-01-01','2013-12-19 20:48:10','0.00',NULL,NULL,'515.82','515.82','R-OH005','OH0','351.38',NULL,0,'2013-12-26 03:08:41'),(23942,19036,'Y','18','021','EC','A','','','AC','0000288334','0000288334','OH00002933483','IL','1','Neal','Shannon','','','','34','284769659','704 EUCLID AVE',0,'DELPHOS','OH','45833','2117','CY','39003','1969-06-27','F','U',':RET:2106-3','N','021','HLT','2767316','92036OH006001501','2014-03-01','2014-02-15 11:00:46','0.00',NULL,NULL,'243.84','243.84','R-OH002','OH0','243.84','CIC',0,'2014-02-15 21:00:09'),(26100,20700,'Y','18','021','EC','A','','','AC','0001924772','0001924772','LA00003318417','IL','1','GOSS','QUITION','','','','34','425060756','217 DRIFTWOOD DR',0,'LAFAYETTE','LA','70503','6019','CY','22055','1957-04-28','M','U',':RET:2054-5','T','021','DEN','3547889','18575LA002000201','2014-03-01','2014-02-27 15:45:38','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-28 06:30:12'),(27773,21963,'Y','18','021','EC','A','','','AC','0002089537','0002089537','LA00002456039','IL','1','Andrews','David','Ellis','','','34','438459183','1801 Lake St.',0,'Lake Charles','LA','70601',NULL,'CY','22019','1979-10-07','M','U',':RET:2106-3','N','021','DEN','3023531','18575LA002000201','2014-04-01','2014-03-05 17:48:44','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-05 21:31:27'),(1341,1110,'Y','18','021','EC','A','','','AC','0000427102','0000427102','TX00000595786','IL','1','Edge','Raymond','','','','34','459619281','7332 19TH ST',0,'LUBBOCK','TX','79407','4302','CY','48303','1973-08-31','M','U',NULL,'T','021','DEN','931956','33348TX002000101','2014-01-01','2013-10-09 09:27:25','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 18:32:27'),(20968,16755,'Y','18','021','EC','A','','','AC','0001141204','0001141204','TX00002338920','IL','1','Russa','Jose','','','','34','152505537','1611 Jason Avenue',0,'Edinburg','TX','78539',NULL,'CY','48215','1950-02-16','M','U',':RET:2106-3','N','021','DEN','3074314','33348TX002000201','2014-03-01','2014-02-01 12:34:59','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-01 19:00:13'),(20684,16527,'Y','18','021','EC','A','','','AC','0001196750','0001196750','TX00001886658','IL','1','Lemmons','Irwin','Lee','','','34','458278232','7409 HARBOR DR',0,'ROWLETT','TX','75088','5327','CY','48113','1960-03-30','M','R',':RET:2106-3','N','021','DEN','2940012','33348TX002000101','2014-03-01','2014-01-30 14:56:37','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-30 21:00:55'),(5041,3991,'N','01','021','EC','A',NULL,NULL,'','0001087263','0001010927','','IL','1','Riley','Josie','','','','34','488640421','455 QUEEN JULIANNA LN',0,'JACKSON','MS','39209','2230','CY','28049','1954-04-03','F','',NULL,'T','021','DEN','629481','46300MS002000201','2014-01-01','2013-12-07 14:30:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 22:48:00'),(20388,16287,'N','19','021','EC','A',NULL,NULL,'','0000094900','0000398565','','IL','1','Holub','Clayton','','','','34','645249044','1132 FM 1890',0,'Colubus','TX','78934',NULL,'CY','48089','1991-05-12','M','',NULL,'N','021','DEN','3042843','33348TX002000201','2014-03-01','2014-01-29 11:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:14'),(3395,2724,'Y','18','021','EC','A','','','AC','0001315458','0001315458','LA00000706227','IL','1','Grezaffi','Brandy',NULL,NULL,NULL,NULL,NULL,'1008 PARENT ST',0,'NEW ROADS','LA','70760','2828','CY','22077','1976-11-27','F','M',NULL,'N','021','DEN','1490855','18575LA002000201','2014-01-01','2013-12-22 03:45:01','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:17:58'),(17007,13613,'Y','18','021','EC','A','','','AC','0000761125','0000761125','OH00001936362','IL','1','Bolek','Larry','A','','','34','277540912','1175 HYDE OAKFIELD RD',0,'NORTH BLOOMFIELD','OH','44450','9720','CY','39155','1953-08-30','M','U',':RET:2106-3','N','021','DEN','1811320','99734OH005000301','2014-02-01','2014-01-09 13:08:51','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-13 02:20:35'),(14295,11404,'Y','18','021','EC','A','','','AC','0000051922','0000051922','OH00001593349','IL','1','ALEXANDER','DEBORAH','','','','34','273585642','6372 LIEB DR',0,'CLINTON','OH','44216','9131','CY','39153','1955-04-23','F','M',':RET:2106-3','N','021','HLT','1875212','52664OH152000901','2014-02-01','2013-12-26 17:31:07','380.00',NULL,NULL,'416.19','36.19','R-OH012','OH0','416.19',NULL,0,'2013-12-27 02:06:41'),(14031,11177,'Y','18','021','EC','A','','','AC','0001250839','0001250839','OH00001078978','IL','1','Huffman','Dale','','','','34','291522066','2350 E STATE ROUTE 18',0,'TIFFIN','OH','44883','9667','CY','39147','1953-03-02','M','M',':RET:2106-3','N','021','HLT','2133356','92036OH004002701','2014-01-01','2013-12-23 14:56:28','801.74',NULL,NULL,'807.64','5.90','R-OH006','OH0','425.53',NULL,0,'2013-12-26 13:16:53'),(6571,5210,'Y','18','021','EC','A','','','AC','0001045668','0001045668','LA00001283969','IL','1','LEBOUEF','MARLENE','','','','34','439881156','41918 WILLOW LN',0,'PONCHATOULA','LA','70454','8403','CY','22105','1958-01-01','F','U',':RET:2106-3','T','021','DEN','7552','18575LA002000101','2014-01-01','2013-12-10 20:08:36','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 00:52:41'),(6663,5286,'Y','18','021','EC','A','','','AC','0000168712','0000168712','TX00000748386','IL','1','Hedrick','Lori','','','','34','460652457','409 E 9TH ST',0,'VALLEY MILLS','TX','76689','4506','CY','48035','1983-09-15','F','M',':RET:2106-3','N','021','DEN','459701','33348TX002000201','2014-01-01','2013-11-16 11:12:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:00:56'),(24837,19691,'Y','18','021','EC','A','','','AC','0000835501','0000835501','MS00001805196','IL','1','JONES','JACQUELINE','','','','34','426139033','416 WOODSTONE RD',0,'CLINTON','MS','39056',NULL,'CY','28049','1963-11-25','F','M',NULL,'N','021','DEN','3608257','46300MS002000101','2014-04-01','2014-02-19 15:48:42','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:53:15'),(2574,2091,'Y','18','021','EC','A','','','AC','0000502957','0000502957','OH00000325293','IL','1','Dostall','Jennifer','','','','34','299788409','4079 GREENMONT DR SE',0,'WARREN','OH','44484','2613','CY','39155','1982-09-01','F','U',':RET:2106-3','N','021','HLT','582585','92036OH003003205','2014-01-01','2013-12-09 15:51:10','168.00',NULL,NULL,'292.97','124.97','R-OH013','OH0','292.97',NULL,0,'2013-12-25 19:37:46'),(6167,4888,'N','01','021','EC','A',NULL,NULL,'','0000470981','0001194081','','IL','1','GOSHORN','ROBERT','PAUL','','','34','281527360','1219 TRADITIONS TURN',0,'BATAVIA','OH','45103',NULL,'CY','39025','1951-11-01','M','',':RET:2106-3','N','021','HLT','1022839','92036OH002000601','2014-01-01','2013-11-21 14:41:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','712.24',NULL,0,'2013-12-26 00:16:57'),(20998,16778,'N','19','021','EC','A',NULL,NULL,'','0000469571','0000455338','','IL','1','HILL','MALLORY','','','','34','292068238','8330 TUCKER DRIVE',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','2001-12-26','F','',':RET:2106-3','N','021','DEN','3262694','99734OH005000301','2014-03-01','2014-02-01 14:09:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:27'),(2970,2392,'Y','18','021','EC','A','','','AC','0000167478','0000167478','TX00000821247','IL','1','sonnier','nancy','','','','34','589221105','943 W POLK ST',0,'LIVINGSTON','TX','77351','2601','CY','48373','1973-10-08','F','U',':RET:2106-3','T','021','DEN','7733','33348TX002000201','2014-01-01','2013-12-06 15:47:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:57'),(19571,15602,'Y','18','021','EC','A','','','AC','0001647541','0001647541','LA00002194977','IL','1','Caston','Roderick','','','','34','433514003','6316 Timberman Place',0,'Shreveport','LA','71119',NULL,'CY','22017','1968-03-31','M','M',':RET:2054-5','N','021','DEN','1758740','18575LA002000201','2014-03-01','2014-01-22 14:23:25','0.00',NULL,NULL,'105.66','105.66','R-LA008','LA0','14.61',NULL,0,'2014-01-23 03:02:37'),(6526,5175,'Y','18','021','EC','A','','','AC','0000699250','0000699250','OH00000723509','IL','1','Tipton','Bonita','','','','34','276548215','2080 Woodtrail Dr 4',0,'Fairfield','OH','45014',NULL,'CY','39017','1952-03-04','F','U',':RET:2106-3','T','021','HLT','934751','92036OH002001201','2014-01-01','2013-12-11 13:56:01','314.00',NULL,NULL,'801.14','487.14','R-OH004','OH0','801.14',NULL,0,'2013-12-26 00:51:34'),(6786,5382,'Y','18','021','EC','A','','','AC','0000916022','0000916022','TX00001094406','IL','1','Rauch','Kirsten','','','','34','539788595','1076 IRON ORE HILL RD',0,'CAT SPRING','TX','78933','5465','CY','48089','1968-02-12','F','U',':RET:2106-3','N','021','DEN','748044','33348TX002000201','2014-01-01','2013-11-24 18:28:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:16:58'),(19246,15336,'Y','18','021','EC','A','','','AC','0000330079','0000330079','MS00001750124','IL','1','Williams','Stacy','','','','34','436419310','114 JOHNSON RD',0,'LUMBERTON','MS','39455','9188','CY','28073','1977-10-15','F','U',':RET:2106-3','N','021','DEN','1824542','46300MS002000101','2014-03-01','2014-01-19 22:27:28','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-21 08:46:41'),(9412,7467,'N','01','021','EC','A',NULL,NULL,'','0000410521','0000096054','','IL','1','Jimenez-Solis','Bertha','','','','34','452313893','11474 ED MERRINS DR',0,'EL PASO','TX','79936','5621','CY','48141','1962-03-02','F','',NULL,'N','021','DEN','1388765','33348TX002000201','2014-01-01','2013-12-21 12:40:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:32:53'),(18923,15077,'Y','18','021','EC','A','','','AC','0000771461','0000771461','OH00001659447','IL','1','MARULANDA','DOLORES','','','','34','291063999','4724 BROOKHIGH DR',0,'BROOKLYN','OH','44144','3105','CY','39035','1955-04-04','F','M',':RET:2106-3','N','021','DEN','2982241','99734OH005000401','2014-03-01','2014-01-16 19:10:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:05:34'),(17332,13863,'N','01','021','EC','A',NULL,NULL,'','0001949868','0001781666','','IL','1','BREWSTER','PATRICIA','','','','34','434217722','381 TWIN OAKS DRIVE',0,'MANY','LA','71449',NULL,'CY','22085','1959-01-10','F','',NULL,'N','021','DEN','2074315','18575LA002000201','2014-02-01','2014-01-10 12:37:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:23:57'),(16810,13445,'Y','18','021','EC','A','','','AC','0000250753','0000250753','TX00001787006','IL','1','BOLTON','ALISON','','','','34','466753179','217 RIVER RD',0,'CHANNELVIEW','TX','77530','3130','CY','48201','1986-02-11','F','U',':RET:2106-3','T','021','DEN','2230094','33348TX002000201','2014-02-01','2014-01-11 15:23:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:18:16'),(17274,13816,'N','01','021','EC','A',NULL,NULL,'','0000381160','0001083104','','IL','1','Kilpatrick','Kathleen','','','','34','277844409','149 PATRICK JOHN DR',0,'WADSWORTH','OH','44281','8789','CY','39103','1975-03-02','F','',':RET:2106-3','N','021','HLT','1510165','52664OH152000901','2014-02-01','2014-01-09 21:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.52',NULL,0,'2014-01-13 02:23:23'),(24110,19166,'Y','18','021','EC','A','','','AC','0000559317','0000559317','TX00001861812','IL','1','Hartnett','Margie','','','','34','467081166','9103 FOREST HILLS BLVD',0,'DALLAS','TX','75218','4006','CY','48113','1955-10-15','F','U',':RET:2106-3','N','021','DEN','3229796','33348TX002000201','2014-03-01','2014-02-14 20:30:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:36'),(25453,20195,'Y','18','021','EC','A','','','AC','0000169056','0000169056','TX00001979618','IL','1','WOOLBRIGHT','ROSE','','','','34','459944449','311 W GRANT ST',0,'DIMMITT','TX','79027','3320','CY','48069','1954-04-07','F','M',NULL,'N','021','DEN','3268239','33348TX002000201','2014-04-01','2014-02-25 14:00:28','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:27'),(286,236,'Y','18','021','EC','A','','','AC','0000602622','0000602622','TX00000412457','IL','1','King','Kyle','Keith','','','34','462358561','320 W POLK ST',0,'HOUSTON','TX','77019','4588','CY','48201','1960-07-18','M','U',NULL,'T','021','DEN','1225965','33348TX002000101','2014-01-01','2013-10-12 13:19:30','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 17:30:25'),(380,315,'Y','18','021','EC','A','','','AC','0000607588','0000607588','TX00000094958','IL','1','Flynn','Vicki','','','','34','450139769','8510 EL PASO DR',0,'AMARILLO','TX','79118','6146','CY','48381','1958-09-26','F','U',':RET:2106-3','N','021','DEN','1219700','33348TX002000201','2014-01-01','2013-12-04 13:30:38','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 17:45:41'),(4331,3440,'N','01','021','EC','A',NULL,NULL,'','0000040937','0000397322','','IL','1','Wilson','Travis','Joshua','','','34','301828536','117 ARMSTRONG ST',0,'GREENVILLE','OH','45331','1501','CY','39037','1984-03-01','M','',':RET:2106-3','N','021','HLT','2352477','92036OH005000504','2014-01-01','2013-12-17 09:35:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.99',NULL,0,'2013-12-25 21:53:01'),(18845,15010,'Y','18','021','EC','A','','','AC','0000351597','0000351597','OH00002379507','IL','1','KISSELL','ZACH','','','','34','273884057','41 SUNNYCLIFF DRIVE',0,'EUCLID','OH','44123',NULL,'CY','39035','1982-02-05','M','M',':RET:2106-3','N','021','HLT','1925839','52664OH151001305','2014-02-01','2014-01-15 19:01:40','302.00',NULL,NULL,'583.02','281.02','R-OH011','OH0','291.51',NULL,0,'2014-01-17 03:36:14'),(8026,6354,'Y','18','021','EC','A','','','AC','0000931195','0000931195','MS00000913279','31','1','Williamson','Roger','','','','34','545869018','P.O. Box 1263',0,'Clinton','MS','39060',NULL,'CY','28049','1950-08-16','M','M',':RET:2106-3','N','021','DEN','2016122','46300MS002000101','2014-01-01','2013-12-19 21:33:36','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-26 03:09:01'),(9772,7739,'Y','18','021','EC','A','','','AC','0000209333','0000209333','LA00000953185','IL','1','Schiff','Rachel','','','','34','316063747','328 Oak Street',0,'Denham Springs','LA','70726',NULL,'CY','22063','1984-08-16','F','U',':RET:2106-3','N','021','DEN','54343','18575LA002000201','2014-01-01','2013-10-20 16:53:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 05:00:30'),(13097,10442,'Y','18','021','EC','A','','','AC','0000481074','0000481074','OH00000962572','IL','1','Burchett','Mark','','','','34','270702877','2958 Madison Road',0,'Cincinnati','OH','45209',NULL,'CY','39061','1960-04-20','M','U',':RET:2106-3','N','021','DEN','2157568','99734OH005000401','2014-01-01','2013-12-23 12:04:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:03'),(21019,16796,'Y','18','021','EC','A','','','AC','0000897019','0000897019','OH00001697021','IL','1','hevener','jeanne','','','','34','159448859','3583 EVERETT RD',0,'RICHFIELD','OH','44286','9723','CY','39153','1953-12-15','F','M',':RET:2106-3','N','021','DEN','3713217','99734OH005000401','2014-03-01','2014-02-01 14:20:27','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-01 19:00:39'),(21265,16994,'Y','18','024','14','A','','','TE','0000874670','0000874670','','IL','1','sabel','robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-09-11','M','',NULL,NULL,NULL,'','799322','','2014-02-03','2014-02-03 11:41:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:27'),(23064,18388,'Y','18','021','EC','A','','','AC','0001528376','0001528376','LA00002321886','IL','1','BLOSSOM','EDDIE','','','','34','427889793','151 E TOPEKA ST',0,'SHREVEPORT','LA','71101','5029','CY','22017','1952-12-02','M','M',':RET:2054-5','N','021','DEN','2818246','18575LA002000201','2014-03-01','2014-02-12 17:07:34','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-12 21:30:52'),(27742,21938,'Y','18','021','EC','A','','','AC','0000211062','0000211062','OH00002679948','IL','1','Zemenski','Timothy',NULL,NULL,NULL,NULL,NULL,'5115 KELLER RD',0,'WALBRIDGE','OH','43465','9752','CY','39173','1972-09-16','M','U',NULL,'N','021','HLT','3092831','92036OH004002601','2014-04-01','2014-03-04 18:08:26','169.00',NULL,NULL,'403.29','234.29','R-OH001','OH0','204.15',NULL,0,'2014-03-05 21:31:10'),(820,679,'Y','18','021','EC','A','','','AC','0000486934','0000486934','OH00001102184','IL','1','BURSAC','SAMUEL','','','','34','299526199','640 E PARK AVE',0,'BARBERTON','OH','44203','3442','CY','39153','1952-08-24','M','M',':RET:2106-3','N','021','HLT','2256358','52664OH151001305','2014-01-01','2013-12-16 13:27:07','901.00',NULL,NULL,'1146.93','245.93','R-OH012','OH0','626.65',NULL,0,'2013-12-25 18:06:04'),(1093,898,'Y','18','021','EC','A','','','AC','0001192637','0001192637','OH00000321563','IL','1','Allison','Samuel','','','','34','327442138','793 So. St. Rt. 123',0,'Lebanon','OH','45036',NULL,'CY','39165','1950-06-15','M','M',':RET:2106-3','N','021','DEN','1072171','99734OH005000401','2014-01-01','2013-12-03 15:23:44','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:17:05'),(1349,1117,'Y','18','021','EC','A','','','AC','0000478283','0000478283','TX00000432364','IL','1','Joiner','Perry','','','','34','404352228','1202 Loma Dr',0,'Austin','TX','78741',NULL,'CY','48453','1973-11-27','M','U',NULL,'N','021','DEN','2244371','33348TX002000101','2014-01-01','2013-12-24 12:20:09','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:11'),(3858,3088,'Y','18','021','EC','A','','','AC','0000916656','0000916656','LA00000565199','31','1','HOLMES','JOHN','','','','34','436252032','POX 1553',0,'OAKDALE','LA','71463',NULL,'CY','22003','1965-07-20','M','M',':RET:2054-5','N','021','DEN','1053936','18575LA002000201','2014-01-01','2013-12-12 19:28:29','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 21:35:50'),(17002,13608,'Y','18','021','EC','A','','','AC','0001217388','0001217388','OH00002029486','IL','1','Bucurel','David','','','','34','272524498','7095 SANDBRIDGE CT',0,'MENTOR','OH','44060','6583','CY','39085','1951-10-18','M','U',NULL,'N','021','DEN','1378949','99734OH005000301','2014-02-01','2014-01-09 16:09:00','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:20:31'),(3392,2721,'Y','18','021','EC','A','','','AC','0001591645','0001591645','LA00000682324','IL','1','Greenwell','Suzanne','','','','34','305768850','215 E PIN OAK DR',0,'SAINT ROSE','LA','70087','3239','CY','22089','1957-12-29','F','U',':RET:2106-3','N','021','DEN','1569448','18575LA002000201','2014-01-01','2013-12-21 21:49:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:17:51'),(15671,12536,'N','01','021','EC','A',NULL,NULL,'','0000910535','0000545257','','IL','1','Ayers','Deziree',NULL,NULL,NULL,NULL,NULL,'1802 Rosewood Drive',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1976-04-23','F','',':RET:2106-3','N','021','HLT','1392798','92036OH004001501','2014-02-01','2013-12-31 08:35:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','219.08',NULL,1,'2014-01-02 04:34:41'),(13938,11117,'N','19','021','EC','A',NULL,NULL,'','0001008945','0000329644','','IL','1','Maurer','Nicholas','J','','','34','152027307','14015 SHERMAN WHITE RD',0,'SWANTON','OH','43558','9112','CY','39095','1997-05-18','M','',':RET:2106-3','N','021','HLT','1879201','92036OH004002601','2014-01-01','2013-12-23 17:27:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-26 13:14:41'),(7311,5794,'N','01','021','EC','A',NULL,NULL,'','0001029340','0000733565','','IL','1','Schrack','Jeri','','','','34','289801886','1432 CHIPPEWA AVE',0,'AKRON','OH','44305','2706','CY','39153','1970-09-18','F','',NULL,'N','021','HLT','1198503','52664OH151001305','2014-01-01','2013-12-14 17:23:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2013-12-26 02:03:20'),(7561,5985,'Y','18','021','EC','A','','','AC','0000699257','0000699257','OH00000998738','IL','1','Foust','Ty','T','','','34','291763281','7051 Quail Lakes Drive',0,'Holland','OH','43528',NULL,'CY','39095','1980-11-06','M','U',':RET:2106-3','N','021','HLT','895411','92036OH004002601','2014-01-01','2013-12-15 17:53:05','0.00',NULL,NULL,'187.83','187.83','R-OH001','OH0','187.83',NULL,0,'2013-12-26 02:33:29'),(7940,6280,'Y','18','021','EC','A','','','AC','0001368855','0001368855','LA00000720249','IL','1','Milo','Ingrid','','','','34','434887345','1427 WILLOW GLEN RIVER RD',0,'ALEXANDRIA','LA','71302','5461','CY','22079','1952-02-01','F','U',':RET:2054-5','N','021','DEN','1944174','18575LA002000201','2014-01-01','2013-12-20 15:16:23','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 03:06:52'),(22856,18235,'N','01','021','EC','A',NULL,NULL,'','0001208353','0001004382','','IL','1','Keiffer','Kari','Nicole','','','34','280901969','1418 S TOWNSHIP ROAD 37',0,'FOSTORIA','OH','44830','9622','CY','39147','1989-02-21','F','',':RET:2106-3','N','021','HLT','2797614','92036OH003002704','2014-03-01','2014-02-10 22:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.45',NULL,0,'2014-02-11 21:02:23'),(23097,18411,'N','19','021','EC','A',NULL,NULL,'','0000991586','0000731239','','IL','1','PENNINGTON','NATHAN','','','','34','283982064','26407 LUNDA RD',0,'WEST MANSFIELD','OH','43358','9644','CY','39159','1995-07-08','M','',':RET:2106-3','N','021','DEN','3377749','99734OH005000401','2014-03-01','2014-02-12 13:55:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:09'),(24538,19492,'Y','18','021','EC','A','','','AC','0000056954','0000056954','TX00001735956','IL','1','VALERIO','SYLVIA','','','','34','360469991','2709 GRANDORA DR',0,'SAN JUAN','TX','78589','4686','CY','48215','1953-07-07','F','U',NULL,'T','021','DEN','2721323','33348TX002000201','2014-04-01','2014-02-19 17:28:19','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-20 04:01:50'),(25206,19994,'N','01','021','EC','A',NULL,NULL,'','0001697900','0001299719','','IL','1','BAGLAY','VILMA','','','','34','662125343','100 MCDONALD STREET',0,'LAFAYETTE','LA','70506',NULL,'CY','22055','1983-08-18','F','',NULL,'N','021','DEN','3102049','18575LA002000201','2014-04-01','2014-02-21 17:27:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-21 22:00:48'),(28940,22901,'N','19','021','EC','A',NULL,NULL,'','0000827226','0001054290','','IL','1','Nisch Quan','Matthiessen','','','','34','302944833','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','1992-09-09','M','',':RET:2029-7^:RET:2034-7^:RET:2106-3','N','021','DEN','4285886','99734OH005000301','2014-04-01','2014-03-10 17:13:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:42'),(751,620,'N','01','021','EC','A',NULL,NULL,'','0000133873','0000635855','','IL','1','Tappan','Gina','Rose','','','34','327543731','5522 KINGS CIR',0,'CORPUS CHRISTI','TX','78413','2913','CY','48355','1957-04-15','F','',':RET:2106-3','N','021','DEN','1515355','33348TX002000201','2014-01-01','2013-12-16 09:17:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:04:17'),(4833,3828,'Y','18','021','EC','A','','','AC','0000526754','0000526754','OH00000402576','IL','1','Miller','Stephen','','','','34','299480176','5486 GRIFFITH RD',0,'HILLSBORO','OH','45133','8800','CY','39071','1950-05-02','M','M',':RET:2106-3','T','021','HLT','1200586','92036OH002000601','2014-01-01','2013-12-08 16:12:08','952.00',NULL,NULL,'1573.39','621.39','R-OH005','OH0','841.58',NULL,0,'2013-12-25 22:17:23'),(20142,16073,'N','01','021','EC','A',NULL,NULL,'','0000119094','0001036157','','IL','1','cowns','Dominic','','','','34','295949424','3353 queen city ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1992-05-08','M','',':RET:2054-5','N','021','DEN','2934263','99734OH005000401','2014-03-01','2014-01-27 16:05:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:00:59'),(18289,14601,'Y','18','021','EC','A','','','AC','0000590811','0000590811','OH00002220929','IL','1','AMIN','SANAR','','','','34','272158055','6429 GOBEL DR',0,'PRAMA','OH','44134',NULL,'CY','39035','1981-12-20','F','U',':RET:2106-3','N','021','DEN','1616978','99734OH005000401','2014-02-01','2014-01-14 20:37:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:44:51'),(15600,12482,'N','19','021','EC','A',NULL,NULL,'','0000283270','0001248343','','IL','1','Rengel','Jillian','Marie','','','34','298947891','3603 TURFSIDE CIR',0,'HURON','OH','44839','2193','CY','39043','1992-06-23','F','',':RET:2106-3','N','021','DEN','2124004','99734OH005000301','2014-02-01','2013-12-31 14:43:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:37'),(13879,11074,'N','01','021','EC','A',NULL,NULL,'','0000510655','0000443455','','IL','1','LUKINAC','BRIAN','','','','34','272820488','11762 BEECHDALE AVE NW',0,'UNIONTOWN','OH','44685',NULL,'CY','39151','1968-12-26','M','',NULL,'N','021','HLT','2386338','52664OH151001501','2014-01-01','2013-12-23 14:56:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','386.22',NULL,0,'2013-12-26 13:13:16'),(7240,5741,'Y','18','021','EC','A','','','AC','0000377848','0000377848','LA00000791820','IL','1','Webster','Sharon','','','','34','439961234','8806 WESTBROOK PL',0,'SHREVEPORT','LA','71108','6024','CY','22017','1956-12-20','F','M',':RET:2054-5','N','021','DEN','177405','18575LA002000201','2014-01-01','2013-12-14 10:42:58','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2013-12-26 02:01:40'),(21036,16808,'Y','18','021','EC','A','','','AC','0001074183','0001074183','OH00002408898','IL','1','Watson','Christopher','','','','34','274527320','313 N FREEDOM ST',0,'RAVENNA','OH','44266','2448','CY','39133','1955-07-26','M','M',':RET:2106-3','T','021','HLT','2649746','52664OH152000901','2014-03-01','2014-02-01 07:57:08','513.00',NULL,NULL,'859.69','346.69','R-OH012','OH0','478.62',NULL,0,'2014-02-01 19:00:47'),(26636,21120,'Y','18','021','EC','A','','','AC','0001100582','0001100582','TX00003136963','IL','1','CERVANTES','LUCIA','','','','34','451974257','2828 MARY ST',0,'CORPUS CHRISTI','TX','78405','2227','CY','48355','1956-03-04','F','M',NULL,'N','021','DEN','3459837','33348TX002000201','2014-04-01','2014-02-28 16:57:04','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-28 21:31:00'),(27789,21979,'Y','18','021','EC','A','','','AC','0000790955','0000790955','MS00002792946','IL','1','LOWERY','ANN','','','','34','425021252','345 SMYRNA RD',0,'SEMINARY','MS','39479','4162','CY','28031','1953-04-27','F','U',NULL,'T','021','DEN','3790292','46300MS002000201','2014-04-01','2014-03-05 13:56:35','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-05 21:31:39'),(28096,22238,'Y','18','021','EC','A','','','AC','0001010964','0001010964','MS00003517985','IL','1','JOHNSON','JOHNNY','','','','34','439157798','106 CHRISTOPHER RD',0,'COLUMBIA','MS','39429','8180','CY','28091','1971-05-15','M','U',':RET:2054-5','N','021','DEN','2767843','46300MS002000101','2014-04-01','2014-03-06 15:31:52','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-06 21:02:07'),(101,90,'Y','18','021','EC','A','','','AC','0001102353','0001102353','TX00001296724','IL','1','Cano-Otero','Sylvia','','','','34','464470987','1472 Franklin St',0,'Brownsville','TX','78520',NULL,'CY','48061','1964-05-04','F','M',':RET:2106-3','N','021','DEN','512013','33348TX002000201','2014-01-01','2013-12-05 13:41:56','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2013-12-25 17:17:44'),(421,345,'Y','18','021','EC','A','','','AC','0000470987','0000470987','OH00001011203','IL','1','Jones','Kathleen','L','','','34','301740927','1808 Wilbur Ave',0,'Fairborn','OH','45385',NULL,'CY','39057','1963-11-16','F','U',':RET:2106-3','T','021','DEN','70323','99734OH005000401','2014-01-01','2013-12-03 23:58:13','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:46:38'),(4762,3777,'Y','18','021','EC','A','','','AC','0000848318','0000848318','OH00001138317','IL','1','CURTIS','JUANITA','','','','34','386703994','3945 BORDEN ST',0,'CINCINNATI','OH','45223','2401','CY','39061','1975-09-24','F','M',':RET:2054-5','N','021','DEN','725945','99734OH005000401','2014-01-01','2013-12-07 20:41:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:15:35'),(4707,3731,'Y','18','024','14','A','','','TE','0000024075','0000024075','','IL','1','Gilbert','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-24','M','',NULL,NULL,NULL,'','739230','','2013-12-12','2013-12-12 10:56:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:08:36'),(19715,15710,'Y','18','021','EC','A','','','AC','0000061350','0000061350','OH00001543405','IL','1','thomas','robert','','','','34','285564478','26650 BUTTERNUT RIDGE RD',0,'NORTH OLMSTED','OH','44070','4405','CY','39035','1958-12-27','M','U',':RET:2106-3','N','021','HLT','2879845','92036OH005000805','2014-03-01','2014-01-23 14:51:34','369.00',NULL,NULL,'521.37','152.37','R-OH011','OH0','521.37',NULL,0,'2014-01-23 21:00:54'),(19560,15593,'Y','18','021','EC','A','','','AC','0002099469','0002099469','LA00001877655','IL','1','LANDRY','ELLIS','','','','34','434883086','59655 KEMBER DR',0,'PLAQUEMINE','LA','70764',NULL,'CY','22047','1951-09-16','M','M',NULL,'T','021','DEN','2739995','18575LA002000201','2014-03-01','2014-01-22 10:02:16','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-23 03:02:33'),(969,794,'Y','18','021','EC','A','','','AC','0000163687','0000163687','MS00000164779','IL','1','Morris','Michael','','','','34','427176466','124 STEVENS ST',0,'PETAL','MS','39465','2108','CY','28035','1973-11-04','M','U',':RET:2106-3','N','021','DEN','1008511','46300MS002000201','2014-01-01','2013-10-28 19:16:42','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:09:58'),(4097,3274,'Y','18','021','EC','A','','','AC','0000307604','0000307604','TX00001068869','IL','1','pozos','ashley','','','','34','626564434','134 COUNTY ROAD 1113',0,'BRASHEAR','TX','75420','6337','CY','48223','1992-02-25','F','U',':RET:2106-3','N','021','DEN','1667170','33348TX002000101','2014-01-01','2013-12-16 19:18:06','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 21:47:38'),(19165,15268,'Y','18','021','EC','A','','','AC','0000179927','0000179927','OH00002069589','IL','1','PERRY','GARRY','','','','34','269583258','112 E YOUNG ST',0,'LIBERTY CENTER','OH','43532',NULL,'CY','39069','1957-05-04','M','U',NULL,'N','021','HLT','2737415','92036OH005002601','2014-03-01','2014-01-19 15:54:42','0.00',NULL,NULL,'454.92','454.92','R-OH001','OH0','454.92',NULL,0,'2014-01-21 08:45:43'),(18255,14574,'Y','18','021','EC','A','','','AC','0001058757','0001058757','TX00002588147','IL','1','TATUM','CARLOS','W','','','34','452655558','9370 FM 1662 WEST',0,'LANEVILLE','TX','75667',NULL,'CY','48401','1969-09-17','M','M',':RET:2054-5','N','021','DEN','1523703','33348TX002000201','2014-02-01','2014-01-15 13:59:52','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-16 08:44:33'),(6420,5090,'Y','18','021','EC','A','','','AC','0000577169','0000577169','LA00001168352','IL','1','Gravois','Evelie','','','','34','433046457','13756 HIGHWAY 643',0,'VACHERIE','LA','70090','3364','CY','22093','1956-01-31','F','U',':RET:2106-3','N','021','DEN','601178','18575LA002000201','2014-01-01','2013-12-10 18:43:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:48:52'),(17565,14044,'N','01','021','EC','A',NULL,NULL,'','0001121405','0000493254','','IL','1','Marshall','Stephen','','','','34','269500212','4235 U.S. Route 127 South',0,'Greenville','OH','45331',NULL,'CY','39037','1954-06-06','M','',':RET:2106-3','N','021','DEN','1938439','99734OH005000401','2014-02-01','2014-01-12 18:31:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:31:58'),(14443,11520,'Y','18','021','EC','A','','','AC','0002031680','0002031680','LA00001662963','IL','1','Newman','Audrey','','','','34','216467335','205 HOLLEY SPRINGS CHURCH RD',0,'COUSHATTA','LA','71019','5242','CY','22081','1952-09-09','F','U',':RET:2106-3','N','021','DEN','1565014','18575LA002000201','2014-02-01','2013-12-27 12:06:50','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-28 03:32:15'),(13069,10417,'Y','18','021','EC','A','','','AC','0001078891','0001078891','OH00000125220','IL','1','Davis','Lisadarling','','','','34','283724028','3927 Deer Knoll Dr',0,'Columbus','OH','43230',NULL,'CY','39049','1965-05-25','F','U',':RET:2054-5','N','021','DEN','1358356','99734OH005000401','2014-01-01','2013-12-23 10:07:22','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:15'),(13725,10952,'N','01','021','EC','A',NULL,NULL,'','0000872037','0000733588','','IL','1','Thielenhaus','Brenda','Jean','','','34','275805507','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1969-07-15','F','',':RET:2106-3','N','021','HLT','2009388','52664OH151001305','2014-01-01','2013-12-23 17:32:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2013-12-26 13:09:17'),(13999,11152,'N','01','021','EC','A',NULL,NULL,'','0000894619','0000358321','','IL','1','Williams','Lisa','','','','34','298686032','1687 REBECCA DR',0,'LIMA','OH','45805','1666','CY','39003','1960-01-08','F','',':RET:2106-3','N','021','HLT','1767857','92036OH002001501','2014-01-01','2013-12-23 11:07:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','518.49',NULL,0,'2013-12-26 13:15:59'),(21963,17539,'Y','18','021','EC','A','','','AC','0000708977','0000708977','OH00002235693','IL','1','McElroy','Sarah','','','','34','286541975','350 S LIBERTY AVE',0,'ALLIANCE','OH','44601','2643','CY','39151','1953-10-15','F','U',':RET:2054-5','T','021','DEN','3729236','99734OH005000401','2014-03-01','2014-02-07 15:37:14','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-07 19:00:27'),(22263,17769,'Y','18','021','EC','A','','','AC','0000809518','0000809518','TX00001546470','IL','1','FLORES','MARIA','D','','','34','645429257','13502 WEIMAN RD LOT',0,'HOUSTON','TX','77041',NULL,'CY','48201','1963-10-29','F','U',NULL,'N','021','DEN','2253645','33348TX002000201','2014-03-01','2014-01-31 22:25:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-10 11:00:08'),(27711,21913,'Y','18','021','EC','A','','','AC','0000564232','0000564232','TX00003111559','31','1','Hernandez','Gloria','','','','34','460907294','PO Box 882',0,'SAN BENITO','TX','78586',NULL,'CY','48061','1952-04-12','F','U',NULL,'N','021','DEN','3054060','33348TX002000201','2014-04-01','2014-03-05 12:44:30','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-05 21:30:53'),(26129,20722,'Y','18','021','EC','A','','','AC','0001161590','0001161590','OH00002965004','S3','1','Carmichael','Shelley','E','','','34','590876291','3033 INDIAN RIPPLE RD',0,'BEAVERCREEK','OH','45440','3644','CY','39057','1999-08-15','F','U',':RET:2106-3','N','021','DEN','2832227','99734OH005000401','2014-03-01','2014-02-27 11:53:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-02-28 06:30:22'),(28565,22605,'N','01','021','EC','A',NULL,NULL,'','0000130763','0000029100','','IL','1','Henderson','Michelle','A','','','34','292760191','4132 ROUTT LN',0,'FRANKLIN','OH','45005','4648','CY','39165','1979-10-16','F','',':RET:2106-3','N','021','HLT','3450176','92036OH003001205','2014-04-01','2014-03-07 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.15',NULL,0,'2014-03-07 21:32:27'),(28642,22666,'N','01','021','EC','A',NULL,NULL,'','0001030596','0000398760','','IL','1','Patterson','Marna','','','','34','455812072','1718 HARVEST BEND LN',0,'CEDAR PARK','TX','78613','4152','CY','48491','1974-11-04','F','',':RET:2106-3','N','021','DEN','3606611','33348TX002000201','2014-04-01','2014-03-08 15:35:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-08 21:30:33'),(425,348,'Y','18','021','EC','A','','','AC','0000828200','0000828200','OH00000864290','IL','1','Gill','Bruce','','','','34','282588030','712 Sheldon st',0,'Ravenna','OH','44266',NULL,'CY','39133','1965-05-09','M','U',':RET:2106-3','T','021','DEN','1252760','99734OH005000401','2014-01-01','2013-12-04 10:56:33','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:46:45'),(21665,17303,'Y','18','021','EC','A','','','AC','0002079709','0002079709','LA00001765487','IL','1','FUENTES','JUAN','','','','34','662012683','138 VILLAGE LN',0,'MORGAN CITY','LA','70380','6124','CY','22101','1986-07-22','M','M',NULL,'N','021','DEN','2689599','18575LA002000201','2014-03-01','2014-02-05 14:22:47','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-05 21:30:56'),(20673,16521,'Y','18','021','EC','A','','','AC','0001207349','0001207349','MS00001398999','IL','1','kersh','alma','','','','34','428114734','32512 dog wood trail',0,'jackson','MS','39212',NULL,'CY','28049','1959-11-18','F','M',':RET:2054-5','N','021','DEN','2991301','46300MS002000101','2014-03-01','2014-01-29 19:06:56','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-30 21:00:51'),(6095,4831,'Y','18','021','EC','A','','','AC','0000045728','0000045728','OH00001038599','IL','1','Weihrauch','Pamela','','','','34','291508296','109 Hartford Ct',0,'Lima','OH','45805',NULL,'CY','39003','1951-05-16','F','U',':RET:2106-3','N','021','HLT','755735','92036OH002001501','2014-01-01','2013-12-01 15:42:48','396.00',NULL,NULL,'730.20','334.20','R-OH002','OH0','730.20',NULL,0,'2013-12-26 00:02:52'),(4693,3721,'Y','18','021','EC','A','','','AC','0000303341','0000303341','OH00000232776','IL','1','Macdonald','Cynthia','','','','34','370848938','440 Suncrest Dr.',0,'Yellow Springs','OH','45387',NULL,'CY','39057','1961-07-18','F','U',':RET:2106-3','N','021','HLT','539908','92036OH005000505','2014-01-01','2013-12-12 10:31:25','324.00',NULL,NULL,'464.00','140.00','R-OH003','OH0','464.00',NULL,0,'2013-12-25 22:08:14'),(5466,4342,'Y','18','021','EC','A','','','AC','0001205809','0001205809','OH00000233064','IL','1','Rhoades','Sharon','K','','','34','274449739','1463 LANTERN LN',0,'TROY','OH','45373','4767','CY','39109','1949-06-28','F','U',':RET:2106-3','N','021','HLT','1963861','92036OH004000501','2014-01-01','2013-12-19 09:06:12','0.00',NULL,NULL,'573.40','573.40','R-OH003','OH0','573.40',NULL,0,'2013-12-25 23:10:32'),(6675,5294,'N','G8','021','EC','A',NULL,NULL,'','0000852787','0000851665','','IL','1','LINDE','WILLIAM','CONNOR','','','34','433754183','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1988-10-03','M','',':RET:2106-3','N','021','DEN','1085015','18575LA002000201','2014-01-01','2013-11-16 10:40:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:01:14'),(6723,5333,'Y','18','021','EC','A','','','AC','0000086386','0000086386','OH00000149799','IL','1','KRAJENKE','FRANCIS','','','Jr','34','377802094','610 BROADWAY',0,'LORAIN','OH','44052','1861','CY','39093','1967-03-08','M','U',':RET:2106-3','T','021','DEN','692149','99734OH005000401','2014-01-01','2013-11-25 17:43:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:15:17'),(7049,5599,'Y','18','021','EC','A','','','AC','0000367388','0000367388','OH00001610090','IL','1','IDE','BOUBACAR','','','','34','110906552','1730 TANGLEWOOD DR',0,'AKRON','OH','44313','6359','CY','39153','1973-11-06','M','U',NULL,'N','021','DEN','1620020','99734OH005000301','2014-01-01','2013-12-24 18:41:43','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:49:38'),(9017,7155,'Y','18','021','EC','A','','','AC','0001024255','0001024255','OH00000293859','IL','1','Kaye','Daniel','','','','34','294561130','938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1967-12-05','M','M',':RET:2106-3','N','021','HLT','2350159','52664OH151001301','2014-01-01','2013-12-17 19:26:44','329.00',NULL,NULL,'824.68','495.68','R-OH012','OH0','334.51',NULL,0,'2013-12-26 04:05:15'),(9054,7183,'Y','18','021','EC','A','','','AC','0000322803','0000322803','TX00001194429','IL','1','Marble','Tabitha','','','','34','450810465','14106 PAWNEE TRAILS DR',0,'CYPRESS','TX','77429','4671','CY','48201','1987-01-23','F','U',':RET:2106-3','N','021','DEN','2557668','33348TX002000101','2014-01-01','2013-12-17 20:15:20','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 04:06:07'),(9384,7442,'Y','18','021','EC','A','','','AC','0001156006','0001156006','TX00000644152','IL','1','Kaisar','Ramona','','','','34','586109499','5500 SUNCHASE CT',0,'GRANBURY','TX','76049','7800','CY','48221','1963-11-14','F','R',':RET:2500-7','N','021','DEN','2354935','33348TX002000201','2014-01-01','2013-12-20 19:28:01','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:32:11'),(13312,10629,'Y','18','021','EC','A','','','AC','0000536156','0000536156','TX00000239851','IL','1','Shah','Narendra','','','','34','639621573','14707 Rich Valley Lane',0,'Sugar Land','TX','77498',NULL,'CY','48157','1952-04-13','M','M',':RET:2029-7','N','021','DEN','2056788','33348TX002000201','2014-01-01','2013-12-23 16:17:42','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:08'),(15807,12653,'N','01','021','EC','A',NULL,NULL,'','0002123798','0001630027','','IL','1','Breaux','Jeanette','Elizabeth','','','34','438370185','1746 Richard School  Road',0,'Church Point','LA','70525',NULL,'CY','22001','1962-05-01','F','',':RET:2106-3','T','021','DEN','2377783','18575LA002000201','2014-02-01','2014-01-02 15:06:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-03 02:03:04'),(15838,12682,'Y','18','021','EC','A','','','AC','0000141522','0000141522','OH00001577574','IL','1','Festagallo','Patricia','','','','34','272660082','102 STATE ROUTE 133',0,'FELICITY','OH','45120','9706','CY','39025','1958-05-25','F','U',':RET:2106-3','N','021','DEN','2372462','99734OH005000401','2014-02-01','2014-01-02 13:17:02','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-03 02:04:04'),(20430,16317,'Y','18','021','EC','A','','','AC','0000525610','0000525610','OH00001896894','IL','1','Arora','Savita','','','','34','284082100','7902 MISTY SHORE DR',0,'WEST CHESTER','OH','45069','9649','CY','39017','1968-06-20','F','M',':RET:2029-7','N','021','DEN','2876565','99734OH005000301','2014-03-01','2014-01-29 12:49:08','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:35'),(17302,13837,'Y','18','021','EC','A','','','AC','0000621577','0000621577','TX00001665391','IL','1','guthrie','gail','','','','34','452511296','217 CR 4342',0,'Tenaha','TX','75974',NULL,'CY','48365','1964-05-09','F','M',':RET:2106-3','T','021','DEN','2386840','33348TX002000201','2014-02-01','2014-01-10 12:54:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:39'),(27652,21871,'N','19','021','EC','A',NULL,NULL,'','0000134634','0000433969','','IL','1','Stinson','Jade','','','','34','292087277','2540 OWLCREST DR',0,'CINCINNATI','OH','45231','1152','CY','39061','2003-12-17','F','',':RET:2054-5^:RET:2106-3','N','021','DEN','2946972','99734OH005000401','2014-04-01','2014-03-05 13:17:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:22'),(28298,22389,'Y','18','021','EC','A','','','AC','0000876105','0000876105','OH00003132409','IL','1','Morris','Paul','','','','34','282806696','1050 COOKS XING',0,'MILFORD','OH','45150','5546','CY','39025','1971-02-02','M','M',':RET:2106-3','N','021','HLT','3503792','92036OH003000605','2014-04-01','2014-03-07 11:14:32','136.00',NULL,NULL,'304.21','168.21','R-OH005','OH0','304.21','CIC',0,'2014-03-07 21:00:30'),(25358,20120,'Y','18','024','14','A','','','TE','0000471025','0000471025','','IL','1','Clark','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-18','F','',NULL,NULL,NULL,'','2276887','','2014-03-11','2014-02-24 18:43:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:34'),(20140,16072,'Y','18','021','EC','A','','','AC','0000827191','0000827191','OH00002029885','IL','1','PALLATT','RICHARD','ALLEN','','','34','205445364','1056 NELA PKWY',0,'TOLEDO','OH','43615','6848','CY','39095','1953-06-04','M','U',':RET:2106-3','N','021','DEN','1862474','99734OH005000401','2014-03-01','2014-01-27 15:42:13','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-27 21:00:57'),(661,546,'Y','18','021','EC','A','','','AC','0000420012','0000420012','OH00000283741','IL','1','BLAIR','KATHLEEN','','','','34','103664110','3426 BLACKSNAKE HILL RD NE',0,'DOVER','OH','44622','6994','CY','39157','1971-02-22','F','U',':RET:2106-3','N','021','DEN','753616','99734OH005000301','2014-01-01','2013-12-15 23:07:20','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:01:53'),(16492,13196,'N','19','021','EC','A',NULL,NULL,'','0001144785','0001073161','','IL','1','TA','VALORY','','','','34','272119391','1866 LATHAM AVE',0,'LIMA','OH','45805','1636','CY','39003','2004-12-13','F','',':RET:2047-9','N','021','HLT','1452164','92036OH006001501','2014-02-01','2014-01-06 16:20:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-01-07 04:06:35'),(2599,2111,'Y','18','021','EC','A','','','AC','0000891771','0000891771','OH00000270987','IL','1','Sizemore','Wesley','','','','34','285820948','940 dayton st',0,'Hamilton','OH','45011',NULL,'CY','39017','1982-11-02','M','U',':RET:2106-3','N','021','DEN','1089081','99734OH005000401','2014-01-01','2013-12-01 20:39:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:17'),(16387,13112,'Y','18','021','EC','A','','','AC','0000982566','0000982566','TX00001438873','IL','1','Provence Dodge','Marcia','','','','34','466155202','9 PRAIRIE LN',0,'BRIDGEPORT','TX','76426','2615','CY','48497','1968-06-08','F','U',':RET:2106-3','N','021','DEN','1595145','33348TX002000201','2014-02-01','2014-01-05 23:18:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:27'),(14154,11283,'Y','18','021','EC','A','','','AC','0001548247','0001548247','LA00000172312','IL','1','Chen','Xing','','','','34','125928060','458 Kay Dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1971-01-10','M','M',':RET:2034-7','T','021','DEN','2167210','18575LA002000201','2014-02-01','2013-12-26 13:56:55','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:02:59'),(7275,5769,'Y','18','021','EC','A','','','AC','0000775711','0000775711','TX00000936898','IL','1','Hallett','Richard','','','','34','496521137','420 CR 2781',0,'Shelbyville','TX','75973',NULL,'CY','48419','1949-02-26','M','U',':RET:2106-3','N','021','DEN','56084','33348TX002000201','2014-01-01','2013-12-14 15:58:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:02:31'),(7330,5808,'Y','18','021','EC','A','','','AC','0000491858','0000491858','OH00000698634','IL','1','Maus','Richard','Aaron','','','34','291862249','822 BOLENDER RD',0,'MOSCOW','OH','45153','9650','CY','39025','1978-08-15','M','M',':RET:2106-3','N','021','HLT','711943','92036OH003000601','2014-01-01','2013-12-14 14:54:21','0.00',NULL,NULL,'966.22','966.22','R-OH005','OH0','273.93',NULL,0,'2013-12-26 02:03:48'),(22514,17974,'Y','18','021','EC','A','','','AC','0000563052','0000563052','TX00002065070','IL','1','Whitley','Barbara','','','','34','467066376','2846 FM 2410 SPUR',0,'Belton','TX','76513',NULL,'CY','48027','1955-10-04','F','M',':RET:2106-3','N','021','DEN','3660612','33348TX002000101','2014-03-01','2014-02-10 11:29:17','0.00',NULL,NULL,'50.04','50.04','R-TX011','TX0','25.02',NULL,0,'2014-02-10 21:31:21'),(23447,18678,'Y','18','024','14','A','','','TE','0000042236','0000042236','','IL','1','Sadruddin','Sadiq',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-08-14','M','',NULL,NULL,NULL,'','3849168','','2014-02-13','2014-02-13 12:50:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-13 22:01:35'),(26876,21300,'N','01','021','EC','A',NULL,NULL,'','0000485910','0001186367','','IL','1','Tsai','Cheng','Hao','','','34','285060070','2686 Pine Run',0,'Lima','OH','45801',NULL,'CY','39003','1972-07-14','M','',':RET:2034-7^:RET:2028-9','N','021','HLT','3206004','92036OH005001505','2014-04-01','2014-02-28 21:43:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','286.55',NULL,0,'2014-03-01 21:01:06'),(27509,21763,'N','01','021','EC','A',NULL,NULL,'','0000851896','0000678151','','IL','1','Gupta','Chelsey','','','','34','290881034','2450 UNDERHILL RD',0,'OTTAWA HILLS','OH','43615','2332','CY','39095','1987-09-26','F','',':RET:2106-3','N','021','HLT','3948896','92036OH004002601','2014-04-01','2014-03-04 15:10:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','160.55',NULL,0,'2014-03-04 21:02:32'),(27608,21834,'Y','18','024','14','A','','','TE','0002277357','0002277357','','IL','1','Bucalan','Normita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-12-15','F','',NULL,NULL,NULL,'','3377827','','2014-03-31','2014-03-05 12:14:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-05 21:00:27'),(28772,22776,'Y','18','021','EC','A','','','AC','0000863532','0000863532','OH00003706950','IL','1','YUSUF','ABDI','','','','34','269044266','498 RENE CT',0,'WESTERVILLE','OH','43081','4937','CY','39049','1964-05-01','M','M',':RET:2054-5','N','021','DEN','4130383','99734OH005000401','2014-04-01','2014-03-09 11:36:02','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-03-09 21:00:30'),(20354,16255,'Y','18','021','EC','A','','','AC','0000117828','0000117828','OH00001651007','IL','1','Budd','Jessica','','','','34','301907778','8969 LINCOLN WAY E',0,'ORRVILLE','OH','44667','9336','CY','39169','1984-08-18','F','U',NULL,'T','021','HLT','3397241','52664OH152000901','2014-03-01','2014-01-28 12:33:08','155.00',NULL,NULL,'210.19','55.19','R-OH014','OH0','210.19',NULL,0,'2014-01-28 21:01:16'),(1457,1214,'Y','18','021','EC','A','','','AC','0000226024','0000226024','OH00001305483','IL','1','Meyer','Tammy','','','','34','267453674','3923 OLDE SAVANNAH DR',0,'CINCINNATI','OH','45247','2100','CY','39061','1967-07-11','F','U',NULL,'N','021','DEN','2487123','99734OH005000401','2014-01-01','2013-12-24 08:07:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:48:13'),(6147,4875,'Y','18','021','EC','A','','','AC','0001237671','0001237671','OH00000671854','IL','1','Strickland','Victoria','','','','34','491980388','539 BLENHEIM RD',0,'COLUMBUS','OH','43214','3263','CY','39049','1985-11-17','F','U',':RET:2054-5','N','021','DEN','216026','99734OH005000301','2014-01-01','2013-11-21 14:07:07','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:16:25'),(1596,1334,'Y','18','024','14','A','','','TE','0000923653','0000923653','','IL','1','NGUYEN','TUAN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-02','M','',NULL,NULL,NULL,'','2169132','','2013-12-24','2013-12-24 12:19:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:51:55'),(5755,4570,'Y','18','021','EC','A','','','AC','0000168894','0000168894','OH00000445482','IL','1','Ford','Candace','','','','34','274921600','5438 WOODVALE CT',0,'WESTERVILLE','OH','43081','4350','CY','39049','1988-03-24','F','U',':RET:2054-5','N','021','DEN','2073849','99734OH005000401','2014-01-01','2013-12-23 21:24:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:20'),(18571,14810,'Y','18','021','EC','A','','','AC','0001083110','0001083110','OH00002458446','IL','1','Stiles','Michelle','','','','34','296888279','370 HUNTMERE DR',0,'BAY VILLAGE','OH','44140','2504','CY','39035','1985-07-02','F','R',':RET:2106-3','T','021','HLT','2744887','52664OH152000901','2014-02-01','2014-01-15 11:18:06','0.00',NULL,NULL,'230.29','230.29','R-OH011','OH0','230.29',NULL,0,'2014-01-16 08:47:04'),(18439,14712,'Y','18','021','EC','A','','','AC','0001227293','0001227293','LA00001929944','IL','1','Bui','Khai','','','','34','664074858','2275 N VEGA DR',0,'BATON ROUGE','LA','70815','8860','CY','22033','1972-01-01','M','M',NULL,'N','021','DEN','1732058','18575LA002000201','2014-02-01','2014-01-15 17:00:17','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-16 08:46:02'),(14435,11512,'N','01','021','EC','A',NULL,NULL,'','0002074891','0002159648','','IL','1','Gregory','Rebecca','E','','','34','400849950','665 WOODHAVEN ST',0,'BATON ROUGE','LA','70815','4661','CY','22033','1954-06-22','F','',':RET:2106-3','N','021','DEN','2296270','18575LA002000201','2014-02-01','2013-12-27 09:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-28 03:32:02'),(2805,2267,'Y','18','021','EC','A','','','AC','0000610812','0000610812','TX00000470110','IL','1','Kirby-Rogers','Amber','','','','34','615460843','11314 FAWN SPRINGS CT',0,'CYPRESS','TX','77433','2304','CY','48201','1989-07-26','F','U',NULL,'N','021','DEN','755585','33348TX002000201','2014-01-01','2013-10-14 19:54:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:00:03'),(4116,3290,'Y','18','021','EC','A','','','AC','0000309426','0000309426','OH00000939094','IL','1','Cipro','Dawn','','','','34','288661665','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1967-03-02','F','M',':RET:2106-3','N','021','DEN','1795221','99734OH005000301','2014-01-01','2013-12-16 20:52:52','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:48:08'),(3984,3181,'Y','18','021','EC','A','','','AC','0000203059','0000203059','OH00000739925','IL','1','Rudd','Julie','','','','34','092729969','38 B North Spring St',0,'Wilmington','OH','45177',NULL,'CY','39027','1982-04-15','F','U',':RET:2106-3','N','021','HLT','863203','92036OH006000601','2014-01-01','2013-12-13 15:32:17','0.00',NULL,NULL,'197.32','197.32','R-OH005','OH0','197.32',NULL,0,'2013-12-25 21:38:54'),(3279,2644,'Y','18','021','EC','A','','','AC','0000957909','0000957909','OH00000507472','IL','1','Hannan','Barbara','Sue','','','34','275587202','6308 KENWOOD RD',0,'CINCINNATI','OH','45243','2312','CY','39061','1956-02-22','F','U',':RET:2106-3','N','021','DEN','1747049','99734OH005000301','2014-01-01','2013-12-21 18:59:27','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:13'),(6867,5446,'Y','18','021','EC','A','','','AC','0000185760','0000185760','TX00000513716','IL','1','Estrada','Griselda','','','','34','457856199','611 Belmont',0,'Dumas','TX','79029',NULL,'CY','48341','1986-03-01','F','U',NULL,'N','021','DEN','81464','33348TX002000201','2014-01-01','2013-11-03 17:16:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:31:51'),(13730,10957,'Y','18','024','14','A','','','TE','0001249587','0001249587','','IL','1','Smith','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-06','F','',NULL,NULL,NULL,'','1683758','','2013-12-23','2013-12-23 18:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:25'),(22825,18213,'N','19','021','EC','A',NULL,NULL,'','0001182541','0000501651','','IL','1','Plum','Alexander',NULL,NULL,NULL,NULL,NULL,'1269 SPRUCE WOOD WAY',0,'UNIONTOWN','OH','44685','9579','CY','39153','1993-11-20','M','',NULL,'N','021','HLT','3637434','52664OH151001301','2014-03-01','2014-02-11 09:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-11 21:02:04'),(24838,19692,'Y','18','021','EC','A','','','AC','0000608277','0000608277','MS00002800018','IL','1','Smith','Janice','Marie','','','34','426337150','1212 COVINGTON PARK DR',0,'JACKSON','MS','39212','5044','CY','28049','1964-03-28','F','U',':RET:2054-5','N','021','DEN','3511232','46300MS002000101','2014-04-01','2014-02-19 17:15:39','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:53:21'),(26043,20653,'N','01','021','EC','A',NULL,NULL,'','0000194050','0000599760','','IL','1','TAYLOR','BRIAN','','','','34','272863807','417 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1983-03-22','M','',NULL,'N','021','HLT','2864760','52664OH151001304','2014-03-01','2014-02-26 14:38:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11',NULL,0,'2014-02-26 21:02:28'),(26789,21231,'Y','18','021','EC','A','','','AC','0002006716','0002006716','LA00002680895','IL','1','Henderson','Dianne','','','','34','437020620','772 BOHNE RD',0,'PORT ALLEN','LA','70767','4252','CY','22121','1953-07-06','F','M',NULL,'N','021','DEN','2641871','18575LA002000101','2014-04-01','2014-02-28 18:20:17','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-01 21:00:17'),(28187,22304,'Y','18','021','EC','A','','','AC','0000427697','0000427697','OH00003437748','IL','1','Sparks','Leslie','','','','34','254597534','631 HERITAGE SQ',0,'HARRISON','OH','45030','8207','CY','39061','1979-06-18','F','U',NULL,'N','021','HLT','4026289','92036OH005001205','2014-04-01','2014-03-06 16:11:03','152.00',NULL,NULL,'260.61','108.61','R-OH004','OH0','260.61',NULL,0,'2014-03-06 21:02:58'),(24420,19398,'Y','18','021','EC','A','','','AC','0000513377','0000513377','OH00002170925','IL','1','Smith','Cynthia','','','','34','301505537','4492 STONE CREEK DR',0,'BRUNSWICK','OH','44212','5519','CY','39103','1957-07-24','F','U',':RET:2106-3','N','021','DEN','3254761','99734OH005000301','2014-04-01','2014-02-18 13:59:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:01:07'),(26984,21375,'Y','18','021','EC','A','','','AC','0000178878','0000178878','OH00002594026','IL','1','RICHARDSON','ERIN','','','','34','298942950','6428 GLADE AVE',0,'CINCINNATI','OH','45230','2836','CY','39061','1979-10-23','F','U',':RET:2106-3','N','021','HLT','3066086','92036OH005001206','2014-04-01','2014-03-02 12:40:40','196.00',NULL,NULL,'260.61','64.61','R-OH004','OH0','260.61',NULL,0,'2014-03-03 01:00:39'),(9538,7559,'N','19','021','EC','A',NULL,NULL,'','0000546469','0000716328','','IL','1','Hayden','Zoe','','','','34','276177675','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','2011-04-10','F','',':RET:2054-5^:RET:2106-3','N','021','DEN','2490277','99734OH005000301','2014-01-01','2013-12-21 11:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:58'),(590,485,'Y','18','021','EC','A','','','AC','0000295457','0000295457','OH00001309528','IL','1','Duncan','Sanjae','','','','34','116788809','2230 Fox Sedge Way',0,'West Chester','OH','45069',NULL,'CY','39017','1987-12-30','M','U',':RET:2054-5','N','021','HLT','1092975','92036OH006001201','2014-01-01','2013-12-04 17:48:37','0.00',NULL,NULL,'174.33','174.33','R-OH004','OH0','174.33',NULL,0,'2013-12-25 17:51:10'),(905,750,'N','01','021','EC','A',NULL,NULL,'','0000895695','0000870608','','IL','1','Le','Tam','V','','','34','379137939','12085 Brookston Dr',0,'Cincinnati','OH','45240','1350','CY','39061','1966-03-04','M','',':RET:2047-9','N','021','HLT','2334579','92036OH004001201','2014-01-01','2013-12-16 13:17:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','269.80',NULL,0,'2013-12-25 18:08:23'),(9362,7422,'Y','18','021','EC','A','','','AC','0001941230','0001941230','LA00000233192','IL','1','Rongey','Benjamin','','','','34','439879424','70 BELLGROVE DR',0,'DESTREHAN','LA','70047','2524','CY','22089','1987-10-05','M','M',':RET:2106-3','N','021','DEN','1567266','18575LA002000201','2014-01-01','2013-12-21 11:06:14','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:34'),(1560,1302,'Y','18','021','EC','A','','','AC','0000585502','0000585502','MS00000947762','31','1','Lacayo','Dianna','','','','34','587869057','PO Box 283',0,'Magnolia','MS','39652',NULL,'CY','28113','1952-06-15','F','U',':RET:2106-3','T','021','DEN','2134838','46300MS002000201','2014-01-01','2013-12-24 17:02:13','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:50:52'),(18247,14566,'Y','18','021','EC','A','','','AC','0001111976','0001111976','TX00001496787','IL','1','RIVERA','ANABEL','','','','34','451499643','2709 SAN CARLOS DR',0,'ALAMO','TX','78516',NULL,'CY','48215','1979-11-07','F','U',NULL,'N','021','DEN','2110021','33348TX002000201','2014-02-01','2014-01-15 14:30:37','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-16 08:44:28'),(15122,12085,'N','01','021','EC','A',NULL,NULL,'','0001063253','0000726140','','IL','1','mcguire','david','','','','34','294529317','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1955-05-11','M','',NULL,'N','021','DEN','2611229','99734OH005000301','2014-02-01','2013-12-30 15:51:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:14'),(23052,18379,'Y','18','021','EC','A','','','AC','0002096992','0002096992','LA00001995582','IL','1','Todesco','Erica','','','','34','439113338','2533 MICHIGAN AVE',0,'METAIRIE','LA','70003','5423','CY','22051','1956-12-12','F','M',NULL,'N','021','DEN','3625627','18575LA002000201','2014-03-01','2014-02-11 19:30:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:46'),(23647,18830,'Y','18','021','EC','A','','','AC','0000581661','0000581661','TX00002039325','IL','1','Rodriguez','Brenda','','','','34','638163775','1301 ELAINE PL',0,'FORT WORTH','TX','76106','2938','CY','48439','1976-09-30','F','U',NULL,'N','021','DEN','3771585','33348TX002000201','2014-03-01','2014-02-13 23:04:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:12'),(570,467,'N','01','021','EC','A',NULL,NULL,'','0000846115','0000605920','','IL','1','reynolds','craig','s','','','34','281769207','5921 Cedaridge Dr.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1980-03-21','M','',':RET:2106-3','N','021','HLT','330460','92036OH005001205','2014-01-01','2013-12-03 21:00:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','257.16',NULL,0,'2013-12-25 17:50:35'),(16388,13113,'Y','18','021','EC','A','','','AC','0001147269','0001147269','TX00001815925','IL','1','lara','brenda','a','','','34','464089158','1919 29TH ST',0,'LUBBOCK','TX','79411','1515','CY','48303','1960-06-17','F','U',NULL,'N','021','DEN','2304695','33348TX002000201','2014-02-01','2014-01-05 23:44:30','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-07 04:03:29'),(1386,1151,'Y','18','021','EC','A','','','AC','0001929108','0001929108','LA00001053168','IL','1','Williams','LaShunda','','','','34','439233737','320 Oregon Avenue',0,'Shreveport','LA','71101',NULL,'CY','22017','1968-02-10','F','U',':RET:2054-5','N','021','DEN','1571072','18575LA002000201','2014-01-01','2013-12-24 10:44:33','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:46:14'),(7191,5699,'N','17','021','EC','A',NULL,NULL,'','0000714953','0000525558','','IL','1','Perez Estevez','Angel','','','','34','851694128','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','2001-08-15','M','',':RET:2106-3','N','021','DEN','166636','99734OH005000301','2014-01-01','2013-12-14 13:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:25'),(2320,1886,'Y','18','021','EC','A','','','AC','0000914738','0000914738','TX00000186832','31','1','Witt','Cody','','','','34','627121206','PO BOX 3081',0,'Big Spring','TX','79721',NULL,'CY','48227','1985-11-12','M','U',':RET:2106-3','N','021','DEN','180931','33348TX002000201','2014-01-01','2013-12-09 07:38:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:24'),(13658,10897,'Y','18','021','EC','A','','','AC','0002282432','0002282432','LA00000872067','IL','1','Wooten','Kimelia','','','','34','435069905','2222 NIXON DR',0,'HOUMA','LA','70363','7031','CY','22109','1961-01-12','F','M',':RET:2054-5','N','021','DEN','2451556','18575LA002000101','2014-01-01','2013-12-23 07:17:45','0.00',NULL,NULL,'50.04','50.04','R-LA002','LA0','25.02',NULL,0,'2013-12-26 13:07:32'),(2722,2201,'Y','18','021','EC','A','','','AC','0000803373','0000803373','LA00000159851','IL','1','Ecker','Joseph','','','','34','300521999','500 INVADER ST',0,'SULPHUR','LA','70663','6968','CY','22019','1967-01-09','M','U',':RET:2106-3','T','021','DEN','18533','18575LA002000201','2014-01-01','2013-12-01 22:22:54','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 19:48:13'),(5123,4060,'Y','18','021','EC','A','','','AC','0000324037','0000324037','TX00001075082','IL','1','Puente','Maria','Anita','','','34','457082176','1511 W BREEZE CT',0,'LA FERIA','TX','78559','6215','CY','48061','1956-01-05','F','M',NULL,'N','021','DEN','1526610','33348TX002000201','2014-01-01','2013-12-18 18:42:54','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 23:02:00'),(4234,3371,'Y','18','021','EC','A','','','AC','0000026020','0000026020','TX00000872849','IL','1','Person','Kimberly','','','','34','459872760','851 Lake Carolyn Pkwy',0,'Irving','TX','75039',NULL,'CY','48113','1981-11-22','F','U',NULL,'N','021','DEN','2322507','33348TX002000201','2014-01-01','2013-12-17 13:32:44','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:50:47'),(13932,11112,'Y','18','021','EC','A','','','AC','0001050637','0001050637','OH00000192681','IL','1','Carr','John','','','','34','291485216','5424 ELMER DR',0,'TOLEDO','OH','43615','2804','CY','39095','1952-11-01','M','M',':RET:2106-3','N','021','HLT','1820046','92036OH004002601','2014-01-01','2013-12-23 09:21:09','82.00',NULL,NULL,'440.60','358.60','R-OH001','OH0','440.60',NULL,0,'2013-12-26 13:14:30'),(21132,16887,'Y','18','021','EC','A','','','AC','0000106576','0000106576','TX00002031204','IL','1','Flores','Ami','','','','34','639032546','3101 COUNTY ROAD 345',0,'BRAZORIA','TX','77422','7602','CY','48039','1987-12-02','F','M',':RET:2106-3','N','021','DEN','2650791','33348TX002000201','2014-03-01','2014-02-03 15:31:37','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-03 21:00:18'),(26212,20788,'N','01','021','EC','A',NULL,NULL,'','0000727346','0000173869','','IL','1','Petersen','Michael','H','','','34','278503215','6509 VAIR RD',0,'RAVENNA','OH','44266','8402','CY','39133','1951-08-05','M','',':RET:2106-3','T','021','HLT','3704644','52664OH151001301','2014-04-01','2014-02-27 14:51:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','736.81',NULL,0,'2014-02-28 06:30:54'),(29102,23035,'Y','18','021','EC','A','','','AC','0000551491','0000551491','OH00003633863','IL','1','Vance','Tammy','','','','34','294788953','6122 STATE ROUTE 350',0,'CLARKSVILLE','OH','45113','9741','CY','39027','1967-09-30','F','M',':RET:2106-3','N','021','HLT','3797832','92036OH004000601','2014-04-01','2014-03-10 16:53:51','124.00',NULL,NULL,'258.91','134.91','R-OH005','OH0','258.91',NULL,0,'2014-03-10 21:02:17'),(18231,14551,'Y','18','021','EC','A','','','AC','0001032807','0001032807','TX00002110241','IL','1','akinwole','olywatosin','','','','34','637159537','107 28th street',0,'canyon','TX','79015',NULL,'CY','48381','1986-12-07','M','U',':RET:2054-5','N','021','DEN','2662687','33348TX002000201','2014-02-01','2014-01-14 21:58:21','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-16 08:44:19'),(504,412,'Y','18','021','EC','A','','','AC','0000589278','0000589278','OH00000554899','IL','1','Hill','Willis','','','','34','289561682','16067 LONDON RD',0,'ORIENT','OH','43146','9516','CY','39129','1956-12-20','M','U',':RET:2106-3','T','021','DEN','605542','99734OH005000301','2014-01-01','2013-12-04 12:21:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:48:46'),(16908,13529,'Y','18','024','14','A','','','TE','0000380075','0000380075','','IL','1','Kramer','Nicholas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-09-17','M','',NULL,NULL,NULL,'','2397380','','2014-01-09','2014-01-09 16:37:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:19:36'),(6430,5099,'Y','18','021','EC','A','','','AC','0000099711','0000099711','LA00000897130','IL','1','NELSON','LISA','','','','34','530687945','380 HOMESTEAD RD',0,'TRANSYLVANIA','LA','71286',NULL,'CY','22035','1968-12-03','F','U',':RET:2054-5','T','021','DEN','1141704','18575LA002000201','2014-01-01','2013-12-11 12:47:18','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 00:49:08'),(7449,5897,'Y','18','024','14','A','','','TE','0001057973','0001057973','','IL','1','Johnson','Stacey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-08-28','F','',NULL,NULL,NULL,'','30388','','2013-12-15','2013-12-15 11:58:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:30:40'),(21014,16791,'Y','18','021','EC','A','','','AC','0001229333','0001229333','OH00002008967','IL','1','Strausbaugh','Crystal','','','','34','283884442','28 LONG ST',0,'ASHVILLE','OH','43103','1309','CY','39129','1988-01-30','F','M',':RET:2106-3','N','021','DEN','2696918','99734OH005000401','2014-03-01','2014-02-01 11:58:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:35'),(22117,17654,'Y','18','021','EC','A','','','AC','0001137021','0001137021','TX00001542400','IL','1','Dodds','Jeffrey','','','','34','512720733','10588 stone canyon rd',0,'Dallas','TX','75230',NULL,'CY','48113','1961-09-02','M','U',':RET:2106-3','N','021','DEN','3704157','33348TX002000101','2014-03-01','2014-02-08 12:21:14','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-08 19:00:38'),(25118,19926,'Y','18','021','EC','A','','','AC','0000710190','0000710190','OH00002925385','IL','1','WILHELM','MACHAEL','','','','34','287569894','15159 MONROE MILLS RD',0,'MOUNT VERNON','OH','43050','9739','CY','39083','1959-08-17','F','M',NULL,'N','021','DEN','3204348','99734OH005000301','2014-04-01','2014-02-21 12:01:40','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00','CIC',0,'2014-02-21 21:30:20'),(26105,20704,'Y','18','021','EC','A','','','AC','0000846187','0000846187','OH00003281057','IL','1','Mattes','Jacob','','','','34','299924952','1684 bailey road',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1990-12-22','M','U',':RET:2106-3','T','021','HLT','2780572','52664OH152000901','2014-04-01','2014-02-26 23:02:04','137.00',NULL,NULL,'187.84','50.84','R-OH012','OH0','187.84',NULL,0,'2014-02-28 06:30:14'),(18651,14869,'Y','18','021','EC','A','','','AC','0001185193','0001185193','TX00002251659','IL','1','May','Kimberly','','','','34','462718559','4501woodbend dr',0,'Bryan','TX','77803',NULL,'CY','48041','1969-11-01','F','U',':RET:2106-3','N','021','DEN','1512412','33348TX002000201','2014-03-01','2014-01-16 10:49:18','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-17 03:35:10'),(1277,1055,'Y','18','021','EC','A','','','AC','0000015226','0000015226','OH00001246327','IL','1','BLAKE','JANE','ELIZABETH','','','34','327407796','7205 REFUGEE ROAD',0,'PICKERINGTON','OH','43147',NULL,'CY','39045','1949-11-04','F','M',':RET:2106-3','N','021','DEN','1031682','99734OH005000401','2014-01-01','2013-11-29 16:01:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:30:27'),(2823,2281,'Y','18','021','EC','A','','','AC','0000465885','0000465885','OH00000406033','IL','1','Schneider','Adam','','','','34','302902360','2261 banning Rd.',0,'Cincinnati','OH','45239',NULL,'CY','39061','1989-09-23','M','U',':RET:2106-3','N','021','DEN','1180107','99734OH005000301','2014-01-01','2013-11-24 11:44:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:00:32'),(17934,14328,'Y','18','021','EC','A','','','AC','0000102390','0000102390','TX00001906339','IL','1','ashmore','andrew','','','','34','431699233','68 Comal',0,'Austin','TX','78702',NULL,'CY','48453','1982-11-15','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2563645','33348TX002000201','2014-02-01','2014-01-14 14:17:14','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:36'),(15527,12422,'N','01','021','EC','A',NULL,NULL,'','0001958377','0001215417','','IL','1','DeDon','Charles','R','','Sr','34','434842317','21374 N Dutch Rd',0,'Franklinton','LA','70438',NULL,'CY','22117','1951-10-29','M','',':RET:2106-3','N','021','DEN','1513343','18575LA002000201','2014-02-01','2013-12-31 10:07:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:30:30'),(15295,12229,'Y','18','021','EC','A','','','AC','0001549584','0001549584','LA00001360757','IL','1','POWE','TAWANDA','','','','34','433574147','4201 BELVEDERE STREET',0,'METAIRIE','LA','70001',NULL,'CY','22051','1983-12-07','F','U',':RET:2054-5','N','021','DEN','1865969','18575LA002000101','2014-02-01','2014-01-01 17:47:55','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:22:36'),(3986,3182,'N','01','021','EC','A',NULL,NULL,'','0000273767','0000523390','','IL','1','Suttles','Tammy','S','','','34','298822610','102 BACON ST',0,'CINCINNATI','OH','45215','2903','CY','39061','1970-12-06','F','',':RET:2106-3','N','021','HLT','46351','92036OH003001205','2014-01-01','2013-12-13 13:10:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.21',NULL,0,'2013-12-25 21:38:57'),(20314,16217,'Y','18','021','EC','A','','','AC','0000360510','0000360510','TX00001618087','IL','1','sanders','Shelia','','','','34','411259211','4014 LEMAC DR',0,'HOUSTON','TX','77025','4602','CY','48201','1966-07-01','F','U',':RET:2054-5','N','021','DEN','3138175','33348TX002000201','2014-03-01','2014-01-28 13:47:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-28 21:00:51'),(23584,18790,'Y','18','021','EC','A','','','AC','0001064757','0001064757','OH00002279665','IL','1','Grogan','Cynthia','','','','34','405086654','2978 STATE ROUTE 133',0,'BETHEL','OH','45106','9304','CY','39025','1962-07-08','F','M',NULL,'N','021','HLT','3163908','92036OH004000601','2014-03-01','2014-02-13 17:02:03','241.00',NULL,NULL,'494.54','253.54','R-OH005','OH0','321.93',NULL,0,'2014-02-13 22:02:59'),(23674,18850,'N','01','021','EC','A',NULL,NULL,'','0001672936','0002213408','','IL','1','Ennis','Manda','','','','34','467654705','2201 nolan trace',0,'Leesville','LA','71446',NULL,'CY','22115','1981-09-11','F','',':RET:2106-3','N','021','DEN','2904908','18575LA002000201','2014-03-01','2014-02-13 19:25:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-14 21:30:26'),(25265,20044,'Y','18','024','14','A','','','TE','0001667627','0001667627','','IL','1','Wright','Mary','Elizabeth',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-01-21','F','',NULL,NULL,NULL,'','1665628','','2014-03-31','2014-02-22 15:33:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-22 19:00:15'),(15399,12317,'Y','18','021','EC','A','','','AC','0000864113','0000864113','TX00000431161','IL','1','WILSON','TAMARA','N','','','34','455068075','2003 W COLLIN ST',0,'CORSICANA','TX','75110','4242','CY','48349','1955-01-31','F','U',':RET:2106-3','N','021','DEN','2170698','33348TX002000201','2014-02-01','2013-12-30 19:25:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:26:43'),(9547,7566,'Y','18','021','EC','A','','','AC','0000009839','0000009839','OH00001007111','IL','1','Fritz','Charles','','','','34','288568358','2450 OLD STATE RD',0,'MOUNT ORAB','OH','45154','9129','CY','39015','1954-10-23','M','U',':RET:2106-3','N','021','DEN','1988399','99734OH005000301','2014-01-01','2013-12-21 12:13:22','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:36:11'),(4688,3717,'Y','18','021','EC','A','','','AC','0001043382','0001043382','OH00000206227','IL','1','WALLACE','SHARON','L','','','34','285701200','4771 DELHI ARNHEIM RD',0,'GEORGETOWN','OH','45121','8228','CY','39015','1958-08-06','F','M',':RET:2106-3','N','021','HLT','1058461','92036OH005000605','2014-01-01','2013-12-12 15:29:10','787.00',NULL,NULL,'979.54','192.54','R-OH005','OH0','478.72',NULL,0,'2013-12-25 22:08:06'),(3746,2997,'Y','18','021','EC','A','','','AC','0001012860','0001012860','TX00001028633','IL','1','HALEY','TIFFANY','','','','34','459414745','7930 DUFFIELD LANE',0,'HOUSTON','TX','77071','2015','CY','48201','1977-01-16','F','U',':RET:2054-5','N','021','DEN','62919','33348TX002000201','2014-01-01','2013-12-13 14:13:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:33:02'),(5375,4262,'Y','18','021','EC','A','','','AC','0001967135','0001967135','LA00001157525','IL','1','Johnson','David','','','','34','437237568','5362 N AFTON PKWY',0,'BATON ROUGE','LA','70806','3531','CY','22033','1959-09-10','M','U',':RET:2106-3','N','021','DEN','2234197','18575LA002000201','2014-01-01','2013-12-19 13:06:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:08:11'),(2672,2168,'Y','18','021','EC','A','','','AC','0000280804','0000280804','OH00000919790','IL','1','silvers','heather','','','','34','282809533','1700 WOODWARD AVE',0,'SPRINGFIELD','OH','45506','3147','CY','39023','1983-05-27','F','R',':RET:2106-3','T','021','DEN','697055','99734OH005000301','2014-01-01','2013-12-02 15:33:35','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:47:04'),(21015,16792,'Y','18','021','EC','A','','','AC','0000264237','0000264237','OH00001724444','IL','1','Hall','Krystian','','','','34','300849981','2 OHIO AVE NE',0,'MASSILLON','OH','44646','4670','CY','39151','1985-08-23','F','M',':RET:2106-3','N','021','DEN','3387403','99734OH005000401','2014-03-01','2014-02-01 13:40:20','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-01 19:00:36'),(22758,18170,'Y','18','021','EC','A','','','AC','0000939825','0000939825','OH00002245842','IL','1','CASE','RICK','','','','34','269706526','1608 CENTERRIDGE AVE',0,'CINCINNATI','OH','45231','5206','CY','39061','1962-12-05','M','U',':RET:2106-3','T','021','DEN','3829330','99734OH005000401','2014-03-01','2014-02-10 19:35:03','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:31'),(27052,21422,'Y','18','024','14','A','','','TE','0000908038','0000908038','','IL','1','smith','Miriam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-10','F','',NULL,NULL,NULL,'','1708595','','2014-03-31','2014-03-03 12:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:25'),(29119,23052,'Y','18','021','EC','A','','','AC','0000851744','0000851744','MS00003756934','IL','1','FLowers','Robert','','','','34','587179369','2926 ANGELA CIR',0,'JACKSON','MS','39209','6127','CY','28049','1967-03-17','M','U',':RET:2054-5','N','021','DEN','3413539','46300MS002000201','2014-04-01','2014-03-10 15:54:56','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-10 21:02:29'),(19023,15150,'Y','18','021','EC','A','','','AC','0001028617','0001028617','MS00002068338','IL','1','Bridgeman','Daliska','','','','34','426192358','319 WELCH ST',0,'CANTON','MS','39046','3655','CY','28089','1971-09-28','F','M',':RET:2054-5','N','021','DEN','3095385','46300MS002000101','2014-03-01','2014-01-17 14:27:32','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-20 08:06:27'),(14854,11860,'Y','18','021','EC','A','','','AC','0000323502','0000323502','OH00000116519','31','1','tarulli','jason','','','','34','283687776','PO BOX 4655',0,'Akron','OH','44310',NULL,'CY','39153','1974-01-30','M','R',':RET:2106-3','N','021','HLT','1777644','52664OH152000901','2014-01-01','2013-12-23 20:24:23','0.00',NULL,NULL,'206.14','206.14','R-OH012','OH0','206.14',NULL,1,'2013-12-29 11:15:10'),(6732,5340,'Y','18','021','EC','A','','','AC','0001122704','0001122704','OH00000081091','IL','1','GIURBINO','MICHAEL','','','','34','289509713','3590 ADAMS ROAD',0,'KINGSVILLE','OH','44048',NULL,'CY','39007','1950-08-02','M','U',NULL,'T','021','DEN','466539','99734OH005000401','2014-01-01','2013-11-25 10:27:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:15:31'),(9193,7291,'Y','18','021','EC','A','','','AC','0000180978','0000180978','OH00000677488','IL','1','Barton','Laura','','','','34','277724505','5086 Norwich rd',0,'toledo','OH','43615',NULL,'CY','39095','1963-06-24','F','U',':RET:2106-3','N','021','HLT','1424322','92036OH006002601','2014-01-01','2013-12-18 11:03:24','421.00',NULL,NULL,'430.83','9.83','R-OH001','OH0','276.19',NULL,0,'2013-12-26 04:09:26'),(21868,17460,'Y','18','021','EC','A','','','AC','0001420944','0001420944','LA00002109339','IL','1','Ogden','Jesse','','','','34','373060591','701 Lesseps St',0,'New Orleans','LA','70117',NULL,'CY','22071','1986-07-29','M','U',NULL,'N','021','DEN','3203980','18575LA002000201','2014-03-01','2014-02-06 15:10:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-06 21:01:24'),(23145,18451,'Y','18','021','EC','A','','','AC','0000473688','0000473688','OH00001799916','IL','1','Himmelright','Vicki','','','','34','298541998','202 GOODHUE DR',0,'AKRON','OH','44313','6008','CY','39153','1952-03-05','F','U',':RET:2106-3','N','021','HLT','2916316','52664OH151001301','2014-03-01','2014-02-12 14:05:16','346.00',NULL,NULL,'626.65','280.65','R-OH012','OH0','626.65',NULL,0,'2014-02-12 21:31:38'),(23434,18668,'Y','18','021','EC','A','','','AC','0001091828','0001091828','TX00001503511','IL','1','MENDOZA','ARACELI','','','','34','632843569','3220 HUBERT DR',0,'BROWNSVILLE','TX','78526','2889','CY','48061','1956-03-08','F','M',NULL,'N','021','DEN','3849358','33348TX002000201','2014-03-01','2014-02-13 10:27:33','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-02-13 22:01:28'),(24088,19151,'N','19','021','EC','A',NULL,NULL,'','0000289573','0001086826','','IL','1','ZILER','ALEXA','BARBARA','','','34','297045543','4870 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','2000-05-03','F','',':RET:2106-3','N','021','HLT','2907628','52664OH151001305','2014-03-01','2014-02-15 14:09:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:24'),(24862,19712,'Y','18','021','EC','A','','','AC','0000573949','0000573949','TX00002731434','IL','1','Castaneda','Jessica','','','','34','464491987','1701 REINERMAN ST',0,'HOUSTON','TX','77007','2236','CY','48201','1967-06-23','F','U',':RET:2106-3','N','021','DEN','3637610','33348TX002000201','2014-04-01','2014-02-18 22:07:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-20 05:30:35'),(25805,20464,'N','19','021','EC','A',NULL,NULL,'','0000825956','0000599807','','IL','1','Fluegel','Spencer','D','','','34','043987520','524 CHAPEL RD',0,'AMELIA','OH','45102','9738','CY','39025','1998-09-05','M','',':RET:2106-3','N','021','DEN','2843167','99734OH005000301','2014-04-01','2014-02-26 13:01:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:19'),(9762,7730,'Y','18','021','EC','A','','','AC','0000496721','0000496721','OH00000871133','IL','1','Ditcher','Steve','','','','34','298521693','4574 MAPLE GROVE RD SE',0,'UHRICHSVILLE','OH','44683','1350','CY','39157','1952-10-25','M','U',NULL,'N','021','DEN','350448','99734OH005000401','2014-01-01','2013-10-20 17:18:42','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-26 05:00:14'),(1834,1504,'Y','18','021','EC','A','','','AC','0000016620','0000016620','OH00001071508','IL','1','FOX','KATHLEEN','BERNICE','','','34','291503006','1083 TOWNSHIP ROAD 713',0,'ASHLAND','OH','44805','9791','CY','39005','1949-06-24','F','M',':RET:2106-3','N','021','HLT','2368236','52664OH151001305','2014-01-01','2013-12-24 11:20:01','1247.00',NULL,NULL,'1327.32','80.32','R-OH012','OH0','669.00',NULL,0,'2013-12-25 18:57:30'),(7095,5627,'Y','18','021','EC','A','','','AC','0001103438','0001103438','OH00000517079','IL','1','Opalenik','Daniel','','','','34','283481674','3360 CHARRING CROSS DR',0,'STOW','OH','44224','4607','CY','39153','1951-01-19','M','U',':RET:2106-3','N','021','HLT','1678496','52664OH151001305','2014-01-01','2013-12-24 19:42:16','475.00',NULL,NULL,'640.70','165.70','R-OH012','OH0','640.70',NULL,0,'2013-12-26 01:50:37'),(17431,13946,'Y','18','021','EC','A','','','AC','0000109288','0000109288','OH00002447329','IL','1','FARAH','MAHMUD','','','Sr','34','337465759','519 EAST LIBERTY STREET',0,'YOUNGSTOWN','OH','44505',NULL,'CY','39155','1950-01-11','M','M',NULL,'N','021','HLT','2301203','92036OH003003206','2014-02-01','2014-01-10 12:27:27','634.00',NULL,NULL,'758.31','124.31','R-OH013','OH0','758.31',NULL,0,'2014-01-13 03:00:31'),(14613,11664,'Y','18','021','EC','A','','','AC','0000716112','0000716112','MS00001733485','31','1','Stamps','Donna','','','','34','374842996','po box 123',0,'edwards','MS','39066',NULL,'CY','28049','1973-08-04','F','M',NULL,'N','021','DEN','2260429','46300MS002000101','2014-02-01','2013-12-27 00:14:51','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-28 03:36:43'),(14224,11342,'Y','18','024','14','A','','','TE','0000109054','0000109054','','IL','1','Rodriguez','Eric',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-25','M','',NULL,NULL,NULL,'','1847905','','2013-12-26','2013-12-26 17:05:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:04:48'),(21422,17123,'Y','18','021','EC','A','','','AC','0000904297','0000904297','OH00002146235','IL','1','haddad','elise',NULL,NULL,NULL,NULL,NULL,'5467 surrey ct',0,'West chester','OH','45069',NULL,'CY','39017','1986-04-03','F','M',':RET:2106-3','N','021','HLT','3428920','92036OH004001201','2014-03-01','2014-02-03 23:16:51','299.00',NULL,NULL,'716.50','417.50','R-OH004','OH0','180.89',NULL,0,'2014-02-04 21:01:14'),(23683,18859,'Y','18','021','EC','A','','','AC','0000964659','0000964659','OH00001869340','IL','1','SCOTT','RAYMONE','','','','34','285787390','1020 JEFFERSON AVE',0,'AKRON','OH','44302','1046','CY','39153','1976-09-22','M','U',':RET:2054-5','N','021','DEN','2977624','99734OH005000401','2014-03-01','2014-02-13 18:53:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:32'),(27679,21891,'N','01','021','EC','A',NULL,NULL,'','0000304351','0000428668','','IL','1','SHOEMAKER','JANA','','','','34','457193671','208 RANGER DRIVE',0,'BOERNE','TX','78006',NULL,'CY','48259','1956-05-02','F','',':RET:2106-3','N','021','DEN','3705982','33348TX002000201','2014-04-01','2014-03-04 20:21:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:37'),(17860,14267,'N','01','021','EC','A',NULL,NULL,'','0000172417','0000794512','','IL','1','Line','Brenda','','','','34','296702625','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1960-10-15','F','',':RET:2106-3','N','021','DEN','1441285','99734OH005000401','2014-02-01','2014-01-14 11:16:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:10'),(9390,7446,'Y','18','024','14','A','','','TE','0000315246','0000315246','','IL','1','valderas','adam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-22','M','',NULL,NULL,NULL,'','499422','','2013-12-20','2013-12-20 20:25:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:20'),(15804,12651,'Y','18','021','EC','A','','','AC','0002037773','0002037773','LA00001910745','IL','1','Lanus','Jacqueline','','','','34','433250071','1949 SCENIC GARDENS AVE',0,'BATON ROUGE','LA','70807','6260','CY','22033','1964-12-12','F','M',':RET:2054-5','N','021','DEN','2559875','18575LA002000201','2014-02-01','2014-01-02 13:06:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:59'),(9335,7399,'Y','18','021','EC','A','','','AC','0002038932','0002038932','LA00000579035','31','1','Davis','Wilbert','','','','34','437419265','PO Box 1075',0,'Donaldsonville','LA','70346',NULL,'CY','22005','1980-10-04','M','U',':RET:2054-5','N','021','DEN','1578309','18575LA002000201','2014-01-01','2013-12-20 18:58:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:30:51'),(5402,4289,'Y','18','021','EC','A','','','AC','0000619631','0000619631','OH00000266298','IL','1','Sparough','John','','','','34','349564639','4228 DELANEY ST',0,'CINCINNATI','OH','45223','2017','CY','39061','1958-09-20','M','M',':RET:2106-3','N','021','HLT','1686742','92036OH006001201','2014-01-01','2013-12-19 14:41:49','600.00',NULL,NULL,'759.30','159.30','R-OH004','OH0','379.65',NULL,0,'2013-12-25 23:08:59'),(6404,5076,'Y','18','021','EC','A','','','AC','0001053035','0001053035','OH00000611469','IL','1','newell','esther','','','','34','277542256','3062 CADWALLADER SONK RD',0,'CORTLAND','OH','44410','8801','CY','39155','1953-04-02','F','M',NULL,'N','021','DEN','868398','99734OH005000301','2014-01-01','2013-12-11 16:17:31','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:48:27'),(20316,16219,'Y','18','021','EC','A','','','AC','0000613886','0000613886','TX00002279274','IL','1','Fragoso','Betty','','','','34','463986598','3624avenue street',0,'galveston','TX','77550',NULL,'CY','48167','1953-05-06','F','U',':RET:2106-3','N','021','DEN','2829128','33348TX002000201','2014-03-01','2014-01-28 13:48:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-28 21:00:52'),(22064,17614,'Y','18','021','EC','A','','','AC','0000418005','0000418005','TX00002358637','IL','1','Hazari','Dayasagar','','','','34','631135832','2310 WHITE ST',0,'CLIFTON','TX','76634','1135','CY','48035','1965-06-10','M','M',':RET:2029-7','N','021','DEN','3495532','33348TX002000201','2014-03-01','2014-02-08 13:48:19','0.00',NULL,NULL,'43.83','43.83','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:12'),(22130,17662,'Y','18','021','EC','A','','','AC','0000322187','0000322187','OH00002089632','IL','1','CROYLE','SANDRA','','','','34','287480594','4774 WOLFF DR',0,'BRUNSWICK','OH','44212','2551','CY','39103','1950-02-24','F','M',NULL,'T','021','DEN','2969013','99734OH005000401','2014-03-01','2014-02-08 11:25:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-08 19:00:43'),(25400,20150,'N','01','021','EC','A',NULL,NULL,'','0000661402','0000813140','','IL','1','ZENDER','JOHN','','','','34','268720732','1124 UNION ST',0,'ASHLAND','OH','44805','1831','CY','39005','1959-07-08','M','',NULL,'N','021','HLT','3819706','52664OH151001306','2014-04-01','2014-02-25 15:42:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2014-02-25 21:30:55'),(26628,21113,'Y','18','021','EC','A','','','AC','0001023519','0001023519','TX00003229452','31','1','RENFRO','RICKY','O','','','34','463339012','PO BOX 9551',0,'TYLER','TX','75711',NULL,'CY','48423','1966-09-24','M','U',':RET:2054-5','N','021','DEN','2775708','33348TX002000201','2014-04-01','2014-02-28 14:10:30','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-28 21:30:55'),(28703,22716,'Y','18','021','EC','A','','','AC','0000314760','0000314760','OH00003503437','IL','1','Rorrer','Kelly','Jo','','','34','301560068','175 HERMANN ST',0,'BARBERTON','OH','44203','1422','CY','39153','1970-01-28','F','M',':RET:2106-3','N','021','HLT','3646802','52664OH151001301','2014-04-01','2014-03-08 13:02:36','0.00',NULL,NULL,'906.30','906.30','R-OH012','OH0','311.54',NULL,0,'2014-03-08 21:31:10'),(29151,23077,'Y','18','021','EC','A','','','AC','0001212398','0001212398','OH00002974168','IL','1','Murphy','Bobby','','','','34','289440927','104 COVER DR',0,'POLAND','OH','44514','1619','CY','39099','1950-01-16','M','M',NULL,'N','021','HLT','3174996','92036OH005003201','2014-04-01','2014-03-10 11:46:28','931.00',NULL,NULL,'1421.55','490.55','R-OH013','OH0','726.14',NULL,0,'2014-03-10 21:02:49'),(19352,15425,'Y','18','024','14','A','','','TE','0000006959','0000006959','','IL','1','MCCALL','YVONNE','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-16','F','',NULL,NULL,NULL,'','827197','','2014-01-21','2014-01-21 14:07:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:26'),(7649,6056,'Y','18','021','EC','A','','','AC','0000254527','0000254527','TX00001122898','IL','1','pham','quang','','','','34','558696506','9614 BENDING WILLOW LN',0,'HOUSTON','TX','77064','5738','CY','48201','1958-01-08','M','M',':RET:2047-9','N','021','DEN','848575','33348TX002000201','2014-01-01','2013-11-09 23:49:15','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:46:48'),(3673,2939,'Y','18','021','EC','A','','','AC','0000205766','0000205766','OH00000260774','IL','1','Eaton','Laura','','','','34','302660749','588 ELMA ST',0,'AKRON','OH','44310','3208','CY','39153','1959-01-09','F','U',':RET:2106-3','N','021','DEN','1007654','99734OH005000401','2014-01-01','2013-12-12 21:53:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:31:13'),(3976,3177,'Y','18','021','EC','A','','','AC','0000971452','0000971452','OH00000676204','IL','1','King','Sheldon','','','','34','280885050','910 CORNELL DR',0,'LIMA','OH','45805','1622','CY','39003','1978-05-02','M','M',':RET:2106-3','N','021','HLT','155695','92036OH003001504','2014-01-01','2013-12-13 12:17:55','509.00',NULL,NULL,'802.57','293.57','R-OH002','OH0','280.84',NULL,0,'2013-12-25 21:38:44'),(4049,3233,'Y','18','021','EC','A','','','AC','0001006804','0001006804','OH00000733137','IL','1','wright-ybarra','caprice','','','','34','546577143','3356 livingston ave',0,'lorain','OH','44055',NULL,'CY','39093','1968-01-18','F','U',':RET:2106-3','N','021','DEN','1501652','99734OH005000401','2014-01-01','2013-12-17 13:20:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:20'),(18955,15102,'Y','18','021','EC','A','','','AC','0001113182','0001113182','TX00002188341','IL','1','GARCIA','LEE','','','','34','465310830','6403 BEAU GESTE DR',0,'HOUSTON','TX','77088','5208','CY','48201','1961-04-06','F','U',NULL,'N','021','DEN','1427791','33348TX002000201','2014-03-01','2014-01-16 22:16:42','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:51'),(7570,5992,'Y','18','021','EC','A','','','AC','0000996517','0000996517','OH00000469151','IL','1','Lee','Kyrie','','','','34','273861597','459 S WASHINGTON ST',0,'TIFFIN','OH','44883','3313','CY','39147','1977-10-15','F','M',NULL,'N','021','HLT','140720','92036OH001002701','2014-01-01','2013-12-15 10:22:32','191.00',NULL,NULL,'884.88','693.88','R-OH006','OH0','289.31',NULL,0,'2013-12-26 02:33:44'),(5626,4465,'Y','18','021','EC','A','','','AC','0000609502','0000609502','OH00001109418','IL','1','HUDSON','CLARICE','','','','34','298604554','10889 PLEASANTHILL DR',0,'CINCINNATI','OH','45240','3367','CY','39061','1964-03-25','F','U',':RET:2054-5','N','021','DEN','1039490','99734OH005000401','2014-01-01','2013-11-26 17:40:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:54'),(5942,4706,'Y','18','021','EC','A','','','AC','0001939765','0001939765','LA00000238464','IL','1','Margoni','Michael','','','','34','378763520','4520  Earl Gros',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1974-09-28','M','U',NULL,'N','021','DEN','1761834','18575LA002000101','2014-01-01','2013-12-24 01:05:15','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:50:51'),(6601,5235,'Y','18','021','EC','A','','','AC','0001207128','0001207128','OH00000552639','IL','1','GOULD','JAMES','','','','34','278568964','47 summerberry lane',0,'NILES','OH','44446',NULL,'CY','39155','1955-04-22','M','M',NULL,'N','021','HLT','111825','92036OH002003201','2014-01-01','2013-12-11 08:55:02','858.00',NULL,NULL,'1424.46','566.46','R-OH013','OH0','712.23',NULL,0,'2013-12-26 00:53:33'),(18281,14595,'Y','18','021','EC','A','','','AC','0000611073','0000611073','TX00001468159','IL','1','Boyle-Court','Benjamn','','','','34','645205677','118 TOPSPIN CIR',0,'SPICEWOOD','TX','78669','3179','CY','48053','1990-10-25','M','U',':RET:2106-3','N','021','DEN','2977051','33348TX002000201','2014-02-01','2014-01-15 18:08:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:47'),(14020,11169,'Y','18','021','EC','A','','','AC','0000309441','0000309441','OH00000804305','IL','1','Tatman','Terry','','','','34','290564092','918 HERR RD',0,'FAIRBORN','OH','45324','9491','CY','39057','1959-08-18','M','U',':RET:2106-3','N','021','HLT','2059465','92036OH001000501','2014-01-01','2013-12-23 10:21:17','263.00',NULL,NULL,'612.17','349.17','R-OH003','OH0','612.17',NULL,0,'2013-12-26 13:16:36'),(16208,12978,'Y','18','021','EC','A','','','AC','0000630960','0000630960','TX00001508741','IL','1','Cooke','Afton','','','','34','634126291','350 CHEYENNE DR',0,'STEPHENVILLE','TX','76401','3816','CY','48143','1989-09-23','F','U',':RET:2106-3','N','021','DEN','2211293','33348TX002000201','2014-02-01','2014-01-04 15:41:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-05 00:01:22'),(15373,12296,'Y','18','021','EC','A','','','AC','0000060235','0000060235','MS00000893200','IL','1','Pollard','Alonzo','','','','34','426414398','3701 W. 4th St.',0,'Hattisburg','MS','39401',NULL,'CY','28035','1972-10-12','M','U',':RET:2054-5','N','021','DEN','1479236','46300MS002000201','2014-02-01','2014-01-01 14:13:21','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,1,'2014-01-02 04:25:09'),(20060,16000,'Y','18','021','EC','A','','','AC','0000490513','0000490513','TX00002545036','IL','1','Sadler','James','','','','34','465177172','1604 GLENWICK DR',0,'PLANO','TX','75075','4201','CY','48085','1957-02-01','M','M',':RET:2106-3','N','021','DEN','3169858','33348TX002000201','2014-03-01','2014-01-27 11:40:11','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-27 21:00:11'),(20526,16402,'Y','18','021','EC','A','','','AC','0000429075','0000429075','OH00001640467','IL','1','Budzinski','Tiffany','','','','34','291900309','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1980-12-20','F','M',NULL,'N','021','HLT','2833778','92036OH005002605','2014-03-01','2014-01-29 15:39:56','321.00',NULL,NULL,'471.86','150.86','R-OH001','OH0','233.59',NULL,0,'2014-01-29 21:01:28'),(23882,19000,'N','01','021','EC','A',NULL,NULL,'','0001036174','0000503023','','IL','1','Kiger','Laura','J','','','34','275761421','6761 Beagle Drive',0,'Hamilton','OH','45011',NULL,'CY','39017','1972-05-03','F','',':RET:2106-3','N','021','HLT','3830411','92036OH002001201','2014-03-01','2014-02-14 02:03:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.78',NULL,0,'2014-02-14 21:32:14'),(26821,21256,'Y','18','021','EC','A','','','AC','0000679586','0000679586','OH00002746729','IL','1','Swain','Jared','','','','34','287889412','9824 KIMS ARBOR LN',0,'CINCINNATI','OH','45249','8000','CY','39165','1986-09-12','F','U',':RET:2106-3','N','021','DEN','3689844','99734OH005000401','2014-04-01','2014-03-01 11:32:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:34'),(27258,21583,'N','01','021','EC','A',NULL,NULL,'','0000618422','0000604762','','IL','1','Branco','Michael','','','','34','280584738','401 Castalia St.',0,'Bellevue','OH','44811',NULL,'CY','39077','1958-03-06','M','',NULL,'N','021','HLT','3321125','92036OH003002704','2014-04-01','2014-03-03 17:33:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.07',NULL,0,'2014-03-03 21:31:58'),(27350,21658,'Y','18','021','EC','A','','','AC','0000759764','0000759764','OH00003414155','IL','1','SUGGS-WILSON','Constance','','','','34','273606254','1444 E 111TH ST',0,'CLEVELAND','OH','44106','1318','CY','39035','1965-05-29','F','U',NULL,'N','021','DEN','3112076','99734OH005000401','2014-04-01','2014-03-04 13:01:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:04'),(6431,5100,'Y','18','021','EC','A','','','AC','0000168135','0000168135','LA00001307304','IL','1','Nguyen','Thuy','N','','','34','620188424','400 E 4TH ST',0,'KAPLAN','LA','70548','4223','CY','22113','1968-04-17','F','M',':RET:2047-9','N','021','DEN','351914','18575LA002000201','2014-01-01','2013-12-11 13:05:18','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:49:10'),(17834,14247,'Y','18','021','EC','A','','','AC','0000392379','0000392379','OH00001715275','IL','1','REVELS','DOUGLAS','','','','34','299509206','1840 LAKENOLL DR',0,'CINCINNATI','OH','45231','5118','CY','39061','1951-07-04','M','M',NULL,'N','021','DEN','2231522','99734OH005000401','2014-02-01','2014-01-13 18:39:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:01'),(6382,5061,'Y','18','021','EC','A','','','AC','0000138990','0000138990','OH00001178497','IL','1','TAKACH','BRUCE','','','','34','291567856','680 WHIPPOORWILL LN',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1955-02-22','M','M',':RET:2106-3','N','021','DEN','1219853','99734OH005000301','2014-01-01','2013-12-11 10:25:38','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:57'),(17345,13876,'Y','18','021','EC','A','','','AC','0000187488','0000187488','OH00001539027','IL','1','daniels','william','','','','34','292565626','114 W HIGH ST',0,'FINDLAY','OH','45840','3538','CY','39063','1965-08-26','M','M',NULL,'N','021','HLT','1952107','92036OH003001505','2014-02-01','2014-01-09 19:12:31','266.00',NULL,NULL,'375.78','109.78','R-OH002','OH0','375.78',NULL,0,'2014-01-13 02:24:05'),(20550,16422,'Y','18','024','14','A','','','TE','0000848360','0000848360','','IL','1','Wilson','Charolette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-02','F','',NULL,NULL,NULL,'','1741285','','2014-01-29','2014-01-29 10:22:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:41'),(5329,4226,'Y','18','021','EC','A','','','AC','0000965762','0000965762','OH00000222299','IL','1','HUGUS','SUSAN','','','','34','186424872','388 SHADY AVE',0,'STEUBENVILLE','OH','43952',NULL,'CY','39081','1949-09-20','F','U',':RET:2106-3','N','021','DEN','1488242','99734OH005000301','2014-01-01','2013-12-19 11:30:00','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:07:03'),(5279,4183,'N','19','021','EC','A',NULL,NULL,'','0001221930','0000482177','','IL','1','KELLER','KYLE','R','','','34','041921846','6407 CANTERBURY DR',0,'HUDSON','OH','44236','3487','CY','39153','1993-02-02','M','',':RET:2106-3','N','021','HLT','2017288','52664OH151001301','2014-01-01','2013-12-19 14:38:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:05:43'),(18034,14406,'Y','18','021','EC','A','','','AC','0000350597','0000350597','OH00001693750','IL','1','johanan','jessica','','','','34','281861507','18566 ROYALTON RD',0,'STRONGSVILLE','OH','44136','5184','CY','39035','1985-07-01','F','U',':RET:2054-5','N','021','DEN','2509557','99734OH005000301','2014-02-01','2014-01-14 17:56:21','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:09'),(16785,13426,'Y','18','024','14','A','','','TE','0000336439','0000336439','','IL','1','Hill','Donald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-06-22','M','',NULL,NULL,NULL,'','1440000','','2014-01-07','2014-01-07 13:50:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:25:07'),(8138,6440,'Y','18','021','EC','A','','','AC','0000550034','0000550034','OH00001019094','IL','1','Best','Jessica','','','','34','281764608','110 N SYCAMORE ST',0,'ARCANUM','OH','45304','1169','CY','39037','1980-02-07','F','M',':RET:2106-3','N','021','HLT','318666','92036OH005000506','2014-01-01','2013-11-21 22:15:01','520.00',NULL,NULL,'577.15','57.15','R-OH003','OH0','284.76',NULL,0,'2013-12-26 03:15:44'),(16633,13307,'Y','18','021','EC','A','','','AC','0000650793','0000650793','OH00001455057','IL','1','Meek','David','','','','34','232215634','1227 CLOVERVIEW ST',0,'BLACKLICK','OH','43004','6052','CY','39049','1970-09-29','M','M',':RET:2106-3','N','021','DEN','1605811','99734OH005000401','2014-02-01','2014-01-07 11:17:13','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:15'),(13025,10383,'Y','18','021','EC','A','','','AC','0001090915','0001090915','OH00000587496','IL','1','Mack','Vada','','','','34','294661624','9947 Darrow Park Drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1960-10-03','F','R',':RET:2054-5','N','021','DEN','1807232','99734OH005000401','2014-01-01','2013-12-22 22:01:02','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:50:12'),(13447,10722,'Y','18','021','EC','A','','','AC','0000908029','0000908029','OH00001244888','IL','1','Feerer','Luke','','','','34','299709539','167 WOOLERY LN',0,'DAYTON','OH','45415','1732','CY','39113','1972-10-25','M','U',':RET:2106-3','N','021','DEN','2341418','99734OH005000301','2014-01-01','2013-12-23 14:02:26','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:01:21'),(15422,12337,'Y','18','024','14','A','','','TE','0000518941','0000518941','','IL','1','fazalbhoy','zainab',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-05-26','F','',NULL,NULL,NULL,'','784627','','2013-12-31','2013-12-31 11:32:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:27:29'),(23744,18905,'N','01','021','EC','A',NULL,NULL,'','0000533347','0001168045','','IL','1','WALDRON','AMANDA','','','','34','203660426','65666 BETHEL RD',0,'NEW PLYMOUTH','OH','45654','8936','CY','39163','1980-09-23','F','',NULL,'N','021','DEN','3469550','99734OH005000301','2014-03-01','2014-02-14 00:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:05'),(27268,21592,'Y','18','021','EC','A','','','AC','0001838746','0001838746','LA00003674465','IL','1','BUTLER','REBECCA','','','','34','434966054','402 TENTH ST',0,'SAINT JOSEPH','LA','71366',NULL,'CY','22107','1952-11-18','F','M',NULL,'N','021','DEN','3467232','18575LA002000101','2014-04-01','2014-03-04 15:43:58','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-03-04 21:00:14'),(28409,22478,'N','01','021','EC','A',NULL,NULL,'','0000726189','0000995496','','IL','1','PINO','JOSEPH','CHARLES',NULL,NULL,NULL,NULL,'627 broadway blvd',0,'steubenville','OH','43952',NULL,'CY','39081','1951-09-11','M','',NULL,'N','021','DEN','3173446','99734OH005000401','2014-04-01','2014-03-07 11:09:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:30:56'),(19674,15678,'Y','18','021','EC','A','','','AC','0000274041','0000274041','TX00001510530','IL','1','springob','michael','','','','34','466656429','536 HIGHLAND DR',0,'ARLINGTON','TX','76010','7525','CY','48439','1982-03-25','M','U',':RET:2106-3','N','021','DEN','3119089','33348TX002000201','2014-03-01','2014-01-22 21:15:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 21:00:33'),(18690,14900,'Y','18','021','EC','A','','','AC','0002338319','0002338319','LA00001951338','IL','1','Hamilton','Sally','','','','34','435574803','5828 BRUYNINCKX RD',0,'ALEXANDRIA','LA','71303','2103','CY','22079','1968-09-09','F','U',':RET:2106-3','N','021','DEN','1659975','18575LA002000101','2014-02-01','2014-01-15 23:18:38','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-01-17 03:35:24'),(13403,10695,'Y','18','021','EC','A','','','AC','0001249584','0001249584','OH00001199573','IL','1','LAMBERT','SUSAN','','','','34','473782172','20050 PARKLANE DR',0,'ROCKY RIVER','OH','44116','4045','CY','39035','1956-08-07','F','U',':RET:2106-3','N','021','DEN','1392435','99734OH005000301','2014-01-01','2013-12-23 09:22:51','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:22'),(13290,10608,'Y','18','021','EC','A','','','AC','0001190116','0001190116','TX00000202847','IL','1','Franklin','Eugene','','','','34','459924794','922 HANNAH FALLS LN',0,'FRESNO','TX','77545','7196','CY','48157','1951-03-26','M','U',':RET:2054-5','N','021','DEN','1719888','33348TX002000201','2014-01-01','2013-12-23 13:30:13','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:57:27'),(9121,7236,'N','19','021','EC','A',NULL,NULL,'','0000323491','0000139000','','IL','1','Torres','Daniel','','','','34','293047420','7973 SCHOOL HOUSE LN',0,'MONTGOMERY','OH','45242','5928','CY','39061','2000-01-31','M','',':RET:2106-3','N','021','DEN','1795337','99734OH005000301','2014-01-01','2013-12-18 18:04:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:48'),(24778,19653,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000726112','','IL','1','ANAYA','ADLYNN','','','','34','279960857','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1993-04-19','F','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:54'),(25471,20208,'Y','18','021','EC','A','','','AC','0000623922','0000623922','TX00002539605','IL','1','BROWN','MARIA','ANTONIA','','','34','462633997','2202 VALLEY VIEW LANE',0,'MARBLE FALL','TX','78654',NULL,'CY','48053','1959-08-07','F','U',NULL,'N','021','DEN','2698577','33348TX002000201','2014-04-01','2014-02-25 17:09:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:37'),(28130,22260,'N','01','021','EC','A',NULL,NULL,'','0000298301','0000622555','','IL','1','Woods','Susan','','','','34','280669668','333 S ROSE BLVD',0,'AKRON','OH','44313','7802','CY','39153','1959-07-26','F','',':RET:2106-3','N','021','HLT','3616200','52664OH151001305','2014-04-01','2014-03-06 11:36:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2014-03-06 21:02:24'),(28513,22564,'Y','18','021','EC','A','','','AC','0000621171','0000621171','OH00002676230','IL','1','SALEH','ADAM','','','','34','367199128','363 S BRIARCLIFF DR',0,'CANFIELD','OH','44406','1016','CY','39099','1984-02-21','M','M',NULL,'N','021','HLT','3919562','52664OH151001306','2014-04-01','2014-03-07 17:56:49','188.00',NULL,NULL,'287.04','99.04','R-OH013','OH0','287.04',NULL,0,'2014-03-07 21:31:55'),(1618,1352,'N','01','021','EC','A',NULL,NULL,'','0000088430','0000482990','','IL','1','Barrick','Nyssa','Mariah','','','34','639101881','111 N Pear St',0,'Alpine','TX','79830',NULL,'CY','48043','1985-06-25','F','',':RET:2106-3','N','021','DEN','2538506','33348TX002000201','2014-01-01','2013-12-24 13:23:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:31'),(18024,14399,'Y','18','021','EC','A','','','AC','0000408502','0000408502','OH00001821227','IL','1','Andrews','Tonya','','','','34','270789489','6827 DRY RUN RD',0,'KINGSTON','OH','45644','9711','CY','39141','1974-10-31','F','M',':RET:2106-3','N','021','DEN','2850751','99734OH005000301','2014-02-01','2014-01-14 13:19:11','0.00',NULL,NULL,'59.76','59.76','R-OH010','OH0','0.00',NULL,0,'2014-01-15 02:07:06'),(2846,2300,'Y','18','021','EC','A','','','AC','0000741156','0000741156','TX00000087169','IL','1','jones','ransom','','','','34','455459685','13 Retama st',0,'Brackettville','TX','78832',NULL,'CY','48271','1960-04-05','M','U',':RET:2106-3','N','021','DEN','669532','33348TX002000101','2014-01-01','2013-11-01 20:09:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:01:12'),(17687,14134,'Y','18','021','EC','A','','','AC','0002136976','0002136976','LA00001372718','IL','1','Kennedy','Justin','','','','34','439698441','12067 ANNA DR',0,'HAMMOND','LA','70403','3128','CY','22105','1987-12-03','M','U',':RET:2106-3','N','021','DEN','1490225','18575LA002000201','2014-02-01','2014-01-12 21:36:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:32:57'),(15637,12508,'Y','18','021','EC','A','','','AC','0001400109','0001400109','LA00000893187','IL','1','sherman','matoya','','','','34','605246750','9100 WALKER RD',0,'SHREVEPORT','LA','71118','2933','CY','22017','1986-10-28','F','U',':RET:2054-5','N','021','DEN','2537615','18575LA002000101','2014-02-01','2013-12-31 16:37:01','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-02 04:33:41'),(8146,6443,'Y','18','021','EC','A','','','AC','0000880477','0000880477','OH00000717350','IL','1','Eckel','Nathalee','','','','34','288505595','833 BASSWOOD AVE',0,'CANAL FULTON','OH','44614','9119','CY','39151','1951-05-05','F','U',':RET:2106-3','T','021','HLT','612020','52664OH152000901','2014-01-01','2013-11-22 17:48:34','473.00',NULL,NULL,'539.67','66.67','R-OH015','OH0','539.67',NULL,0,'2013-12-26 03:15:53'),(22104,17644,'N','01','021','EC','A',NULL,NULL,'','0001016891','0000403698','','IL','1','mccandless','dolores','ruth','','','34','233047125','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1959-11-19','F','',':RET:2106-3','N','021','DEN','3271258','99734OH005000301','2014-03-01','2014-02-08 11:47:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:31'),(25696,20387,'Y','18','021','EC','A','','','AC','0000415742','0000415742','TX00002688223','IL','1','AGATEP','MELINDA','','','','34','635943050','4904 GREENBRIAR LANE',0,'ANGELO','TX','76904',NULL,'CY','48451','1951-05-29','F','M',':RET:2028-9','N','021','DEN','3580379','33348TX002000201','2014-04-01','2014-02-24 08:50:42','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-26 09:30:16'),(26718,21179,'N','01','021','EC','A',NULL,NULL,'','0000595347','0000796289','','IL','1','Kelly','Roosevelt','','','Jr','34','425080768','111 BRIGADE AVE',0,'CANTON','MS','39046','8025','CY','28089','1956-04-10','M','',':RET:2054-5','N','021','DEN','3700669','46300MS002000201','2014-03-01','2014-02-28 16:21:42',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-28 21:31:43'),(20625,16480,'N','01','021','EC','A',NULL,NULL,'','0001134379','0000631063','','IL','1','PORRAS','RODRIGO','','','','34','449610756','319 AVENIDA ESTRELLA',0,'BROWNSVILLE','TX','78526','4004','CY','48061','1978-10-21','M','',NULL,'T','021','DEN','3035208','33348TX002000201','2014-03-01','2014-01-29 18:49:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:25'),(6509,5159,'Y','18','021','EC','A','','','AC','0000452718','0000452718','OH00001089877','IL','1','Bell','Justin','','','','34','268868405','819 Rockybrook Dr',0,'Akron','OH','44313',NULL,'CY','39153','1982-02-13','M','U',':RET:2106-3','N','021','HLT','507541','52664OH152000901','2014-01-01','2013-12-11 11:06:17','165.00',NULL,NULL,'189.31','24.31','R-OH012','OH0','189.31',NULL,0,'2013-12-26 00:51:04'),(19957,15919,'Y','18','021','EC','A','','','AC','0000304173','0000304173','TX00001507962','IL','1','TREVINO','AID','','','','34','466172660','311 N MAYBERRY ST',0,'MISSION','TX','78572','5750','CY','48215','1963-03-28','F','M',NULL,'N','021','DEN','3419559','33348TX002000201','2014-03-01','2014-01-24 21:29:18','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-25 19:00:05'),(5861,4653,'N','19','021','EC','A',NULL,NULL,'','0000186118','0001066981','','IL','1','Harper','Kolina','Sheri',NULL,NULL,NULL,NULL,'7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1992-11-22','F','',':RET:2106-3','N','021','HLT','1829936','92036OH005002606','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99',NULL,0,'2013-12-25 23:49:02'),(17864,14271,'Y','18','021','EC','A','','','AC','0000781921','0000781921','OH00002304812','IL','1','Brooks','James','','','','34','277500368','2954 COUNTRY CLUB LN',0,'TWINSBURG','OH','44087','2949','CY','39153','1953-12-08','M','M',NULL,'N','021','DEN','2070142','99734OH005000401','2014-02-01','2014-01-14 11:47:18','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:11'),(16992,13601,'Y','18','021','EC','A','','','AC','0000870646','0000870646','OH00001597463','IL','1','mccain','michael','','','','34','336747050','145 MADISON ST',0,'TIFFIN','OH','44883','2826','CY','39147','1981-04-04','M','U',':RET:2106-3','T','021','HLT','1753086','92036OH004002701','2014-02-01','2014-01-08 22:43:42','125.00',NULL,NULL,'213.31','88.31','R-OH006','OH0','213.31',NULL,0,'2014-01-13 02:20:25'),(16612,13289,'Y','18','021','EC','A','','','AC','0000100076','0000100076','OH00002351690','IL','1','Pauta','Jose','','','','34','270173489','3822 SPOKANE AVE',0,'CLEVELAND','OH','44109',NULL,'CY','39035','1976-10-15','M','M',NULL,'N','021','DEN','1823102','99734OH005000401','2014-02-01','2014-01-07 10:04:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:08'),(16478,13187,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','2201355','','2014-01-06','2014-01-06 11:12:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:06:10'),(15389,12310,'Y','18','021','EC','A','','','AC','0000025308','0000025308','OH00002039554','IL','1','Gilmer','Martin','','','','34','294900830','8415 LORRAINE DR',0,'STRONGSVILLE','OH','44149','1033','CY','39035','1986-01-05','M','U',NULL,'N','021','HLT','2133686','52664OH151001305','2014-02-01','2014-01-01 17:20:44','85.00',NULL,NULL,'273.40','188.40','R-OH011','OH0','273.40',NULL,1,'2014-01-02 04:25:40'),(4532,3591,'Y','18','021','EC','A','','','AC','0000582843','0000582843','TX00001114812','IL','1','clay','john','','','','34','452885810','650 COUNTY ROAD 33980 N',0,'POWDERLY','TX','75473','4956','CY','48277','1951-12-27','M','U',':RET:2106-3','N','021','DEN','364348','33348TX002000201','2014-01-01','2013-12-12 16:00:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:04'),(9591,7595,'Y','18','021','EC','A','','','AC','0000166084','0000166084','MS00000055328','IL','1','Hanly','James','','','','34','437061524','110 E FORD ST',0,'RIDGELAND','MS','39157','3410','CY','28089','1955-07-10','M','U',NULL,'N','021','DEN','1858585','46300MS002000201','2014-01-01','2013-12-21 16:00:22','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:37:09'),(2548,2074,'Y','18','021','EC','A','','','AC','0001078865','0001078865','OH00000239170','IL','1','Miracle','Gerald','','','','34','270501508','872 SKYSIDE DR',0,'CLINTON','OH','44216','9659','CY','39153','1950-07-06','M','M',':RET:2106-3','N','021','HLT','1010156','52664OH151001501','2014-01-01','2013-12-09 13:25:44','874.00',NULL,NULL,'1441.37','567.37','R-OH012','OH0','789.56',NULL,0,'2013-12-25 19:37:13'),(22109,17646,'Y','18','021','EC','A','','','AC','0000443496','0000443496','OH00001996810','IL','1','Hoffman','Grace','','','','34','279961798','94 E TULANE RD',0,'COLUMBUS','OH','43202','2220','CY','39049','1992-09-01','F','U',':RET:2106-3','N','021','DEN','3319004','99734OH005000301','2014-03-01','2014-02-08 13:58:56','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-08 19:00:33'),(24302,19302,'Y','18','021','EC','A','','','AC','0000259216','0000259216','TX00001703545','IL','1','Owen','Nicholas','','','','34','461132736','14700 Marsh Ave',0,'Addison','TX','75001',NULL,'CY','48113','1962-01-25','M','U',':RET:2054-5^:RET:2106-3','T','021','DEN','3351581','33348TX002000101','2014-04-01','2014-02-18 14:49:05','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15','CIC',0,'2014-02-18 21:30:20'),(24634,19551,'Y','18','021','EC','A','','','AC','0001682228','0001682228','LA00003018768','IL','1','Blazio','LoLita','Hamilton','','','34','436293736','2318 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4403','CY','22071','1967-11-19','F','U',NULL,'N','021','DEN','2898543','18575LA002000201','2014-04-01','2014-02-19 10:38:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 04:18:31'),(28493,22545,'Y','18','021','EC','A','','','AC','0001002459','0001002459','MS00003074399','IL','1','Irby','Lorie','L','','','34','425258275','1029 Highway 51 N',0,'Madison','MS','39110',NULL,'CY','28089','1961-02-26','F','U',':RET:2106-3','N','021','DEN','3638091','46300MS002000201','2014-04-01','2014-03-06 22:15:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-07 21:31:43'),(20887,16692,'Y','18','021','EC','A','','','AC','0000207162','0000207162','OH00002378491','IL','1','FISHER','andrea','','','','34','272606272','5465 DEERLAKE CT',0,'CINCINNATI','OH','45247','3591','CY','39061','1972-02-28','F','U',NULL,'N','021','DEN','1811763','99734OH005000401','2014-03-01','2014-01-30 21:32:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:12'),(20850,16665,'Y','18','021','EC','A','','','AC','0000816456','0000816456','OH00001950289','IL','1','Albert','John','','','','34','270604905','938 SOUTHPORT DR',0,'MEDINA','OH','44256','3018','CY','39103','1967-12-04','M','U',':RET:2106-3','T','021','DEN','3676705','99734OH005000301','2014-03-01','2014-01-31 07:12:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-31 21:00:52'),(5231,4153,'N','19','021','EC','A',NULL,NULL,'','0000446277','0000627863','','IL','1','Kress','Kaitlyn','E','','','34','308651952','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','2013-09-22','F','',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:04:47'),(20689,16532,'Y','18','021','EC','A','','','AC','0000912989','0000912989','OH00002011270','IL','1','COLON','ROXANA','MAYLEEN','','','34','598220257','25157 CARLTON PARK',0,'NORTH OLMSTED','OH','44070',NULL,'CY','39035','1989-07-26','F','M',':RET:2106-3','N','021','DEN','2605109','99734OH005000301','2014-03-01','2014-01-29 22:41:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-30 21:00:58'),(19503,15544,'Y','18','021','EC','A','','','AC','0000106743','0000106743','OH00002265250','IL','1','Iberahim','alaa','','','','34','278982915','275 SKYVIEW DR',0,'AKRON','OH','44319','4542','CY','39153','1968-09-12','M','U',NULL,'N','021','HLT','3207606','52664OH151001305','2014-03-01','2014-01-22 15:13:52','232.00',NULL,NULL,'322.02','90.02','R-OH012','OH0','322.02',NULL,0,'2014-01-23 03:02:11'),(16830,13461,'N','01','021','EC','A',NULL,NULL,'','0001132774','0000880534','','IL','1','JENNINGS','CATHY','','','','34','275689346','5926 KENTLAND AVE.',0,'PORTSMOUTH','OH','45662',NULL,'CY','39145','1959-03-24','F','',':RET:2106-3','N','021','DEN','1398299','99734OH005000401','2014-02-01','2014-01-10 19:34:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:18:28'),(2000,1639,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','838014','','2013-11-19','2013-11-19 23:08:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:02:10'),(7072,5613,'N','19','021','EC','A',NULL,NULL,'','0000566628','0000740278','','IL','1','Blair','Connor','James','','','34','298088737','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','2004-05-19','M','',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:06'),(13520,10778,'Y','18','021','EC','A','','','AC','0001179676','0001179676','LA00000926453','IL','1','DAVIS-CURRY','TANYA','MARIA','','','34','496707585','3916 ELDER ST',0,'ALEXANDRIA','LA','71302',NULL,'CY','22079','1971-11-15','F','M',':RET:2054-5','N','021','DEN','1442058','18575LA002000201','2014-01-01','2013-12-23 09:13:59','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-26 13:03:11'),(28078,22222,'Y','18','021','EC','A','','','AC','0000581751','0000581751','TX00003782159','IL','1','Diaz','Erica','','','','34','636182957','9811 cooper creek',0,'austin','TX','78729',NULL,'CY','48491','1990-10-22','F','U',':RET:2054-5','N','021','DEN','3235053','33348TX002000101','2014-04-01','2014-03-05 21:03:08','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-06 21:01:55'),(28663,22681,'Y','18','021','EC','A','','','AC','0001924783','0001924783','LA00002718906','IL','1','comeaux','megan','','','','34','437555825','112 HUNTINGTON DR',0,'LAFAYETTE','LA','70508','7116','CY','22055','1984-06-24','F','U',':RET:2106-3','T','021','DEN','4039165','18575LA002000201','2014-04-01','2014-03-07 20:59:11','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-08 21:30:44'),(28718,22727,'Y','18','021','EC','A','','','AC','0000257195','0000257195','OH00003005022','IL','1','Jones','Todd','E','','','34','298766195','4481 Eastwood Drive',0,'Batavia','OH','45103',NULL,'CY','39025','1972-05-25','M','U',':RET:2106-3','T','021','HLT','3185162','92036OH004000601','2014-04-01','2014-03-08 16:58:39','189.00',NULL,NULL,'258.45','69.45','R-OH005','OH0','258.45',NULL,0,'2014-03-08 21:31:18'),(20341,16243,'Y','18','021','EC','A','','','AC','0001125469','0001125469','OH00002377320','IL','1','Wcislo','Patricia','','','','34','281605303','4790 BEACH RD',0,'MEDINA','OH','44256','8462','CY','39103','1958-06-17','F','M',':RET:2106-3','N','021','HLT','3371345','52664OH151001305','2014-03-01','2014-01-28 10:18:06','735.00',NULL,NULL,'994.62','259.62','R-OH012','OH0','497.31',NULL,0,'2014-01-28 21:01:08'),(20006,15955,'Y','18','021','EC','A','','','AC','0001255061','0001255061','OH00002265313','IL','1','Beckrest','Sara','','','','34','291847310','3686 Lynnfield Road',0,'Shaker Heights','OH','44122',NULL,'CY','39035','1986-06-15','F','U',':RET:2106-3','N','021','DEN','3132658','99734OH005000401','2014-03-01','2014-01-26 13:18:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-26 19:00:06'),(19855,15837,'Y','18','021','EC','A','','','AC','0000344169','0000344169','OH00001905552','IL','1','Evans','Jeffrey','','','','34','204421211','867 OVERLOOK DR',0,'WINTERSVILLE','OH','43953','7405','CY','39081','1951-07-20','M','M',':RET:2106-3','N','021','DEN','2853599','99734OH005000301','2014-03-01','2014-01-24 13:46:58','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-24 21:00:33'),(18713,14917,'Y','18','021','EC','A','','','AC','0001084170','0001084170','OH00002274978','IL','1','MCINTYRE','KATHERINE','','','','34','199369953','1536 CROSSINGS PKWY',0,'WESTLAKE','OH','44145','6260','CY','39035','1952-01-17','F','U',':RET:2106-3','N','021','DEN','2539111','99734OH005000301','2014-02-01','2014-01-15 21:54:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:32'),(15722,12576,'N','19','021','EC','A',NULL,NULL,'','0001128010','0000939792','','IL','1','Jamison','Rebekah','','','','34','287130384','160 HICKORY HILLS DR',0,'SPRINGBORO','OH','45066','8625','CY','39165','2007-09-28','F','',':RET:2106-3','N','021','DEN','1945838','99734OH005000301','2014-02-01','2014-01-02 14:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:00:14'),(795,656,'Y','18','021','EC','A','','','AC','0000093404','0000093404','TX00000177016','IL','1','Williams','Melissa','','','','34','467518683','209 S TRAVIS ST',0,'GRANBURY','TX','76048','2447','CY','48221','1977-05-02','F','U',':RET:2106-3','T','021','DEN','2378240','33348TX002000201','2014-01-01','2013-12-16 16:39:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:05:24'),(3616,2895,'Y','18','021','EC','A','','','AC','0000721337','0000721337','OH00000279475','IL','1','Perkins','Cheryl','','','','34','281661911','402 W SANDUSKY ST',0,'FINDLAY','OH','45840','3222','CY','39063','1966-01-08','F','U',':RET:2106-3','T','021','HLT','1411438','92036OH006001501','2014-01-01','2013-12-22 15:52:38','307.00',NULL,NULL,'313.73','6.73','R-OH002','OH0','313.73',NULL,0,'2013-12-25 21:23:33'),(2404,1963,'Y','18','021','EC','A','','','AC','0001231748','0001231748','OH00000484656','IL','1','Crutcher','Carrie','','','','34','291783160','6266 CORBLY RD',0,'CINCINNATI','OH','45230','1543','CY','39061','1981-12-15','F','U',':RET:2106-3','N','021','DEN','928690','99734OH005000401','2014-01-01','2013-12-09 14:08:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:36'),(22516,17975,'Y','18','021','EC','A','','','AC','0000028511','0000028511','TX00002480849','IL','1','GARIBAY','ELIZABETH','','','','34','465976357','12470 STARCREST DR',0,'SAN ANTONIO','TX','78216','2978','CY','48029','1955-01-05','F','U',NULL,'N','021','DEN','3152627','33348TX002000101','2014-03-01','2014-02-10 11:59:43','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-10 21:31:22'),(26882,21305,'Y','18','021','EC','A','','','AC','0000338932','0000338932','OH00003221726','IL','1','Bruno','Judith','','','','34','282581117','2894 Lilly Drive',0,'Elida','OH','45807',NULL,'CY','39003','1955-09-27','F','U',':RET:2106-3','N','021','HLT','2853054','92036OH003001504','2014-04-01','2014-03-01 14:04:40','437.00',NULL,NULL,'585.61','148.61','R-OH002','OH0','585.61',NULL,0,'2014-03-01 21:01:09'),(27496,21755,'N','01','021','EC','A',NULL,NULL,'','0000553979','0000808719','','IL','1','Kemp','Benjamin','Todd','','','34','300648488','7933 Rodgers Rd',0,'Lodi','OH','44254',NULL,'CY','39103','1971-01-06','M','',':RET:2106-3','N','021','HLT','3982720','52664OH151001306','2014-04-01','2014-03-04 15:31:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2014-03-04 21:02:25'),(27666,21883,'Y','18','021','EC','A','','','AC','0000304763','0000304763','OH00002756745','IL','1','Hammond','Jessica','','','','34','296789743','6507 Marsol Rd',0,'Mayfield','OH','44124',NULL,'CY','39035','1982-08-01','F','U',':RET:2106-3','N','021','DEN','3315337','99734OH005000401','2014-04-01','2014-03-05 16:36:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-05 21:30:30'),(20584,16447,'Y','18','024','14','A','','','TE','0000703759','0000703759','','IL','1','Lay','River','Manda',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2008-05-06','F','',NULL,NULL,NULL,'','1385358','','2014-01-29','2014-01-29 19:19:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:05'),(16242,13007,'N','01','021','EC','A',NULL,NULL,'','0000295508','0001175722','','IL','1','Wieman','Leslie','','','','34','277606335','5745 GREEN ACRES CT',0,'CINCINNATI','OH','45248','4130','CY','39061','1955-10-03','F','',':RET:2106-3','N','021','DEN','2254608','99734OH005000301','2014-02-01','2014-01-03 23:53:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:25'),(15710,12567,'N','01','021','EC','A',NULL,NULL,'','0000433900','0000116598','','IL','1','NING','ZHAO','','','','34','294921991','110 CREEKSIDE DR',0,'MAPLE HEIGHTS','OH','44137','4780','CY','39035','1963-08-31','F','',NULL,'N','021','HLT','1792571','92036OH003000805','2014-02-01','2013-12-31 14:44:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','436.05',NULL,1,'2014-01-02 04:36:01'),(4621,3660,'Y','18','021','EC','A','','','AC','0000020681','0000020681','LA00000435582','31','1','RICHARD','EDMOND','L','','Jr','34','438618777','9340 HIGHWAY 14',0,'LAKE ARTHUR','LA','70549',NULL,'CY','22053','1981-08-15','M','U',':RET:2106-3','T','021','DEN','360810','18575LA002000101','2014-01-01','2013-12-12 10:51:22','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2013-12-25 22:06:13'),(8088,6404,'Y','18','024','14','A','','','TE','0000258112','0000258112','','IL','1','Eaton','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-13','F','',NULL,NULL,NULL,'','354090','','2013-12-20','2013-12-20 15:22:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:37'),(4173,3322,'Y','18','021','EC','A','','','AC','0001217358','0001217358','OH00000693770','31','1','Wilt','William','','','','34','282426791','105 Mary Street',0,'Botkins','OH','45306','0274','CY','39149','1951-07-27','M','M',':RET:2106-3','T','021','HLT','2546887','92036OH006000501','2014-01-01','2013-12-17 09:54:08','471.00',NULL,NULL,'622.85','151.85','R-OH003','OH0','622.85',NULL,0,'2013-12-25 21:49:17'),(26642,21125,'Y','18','021','EC','A','','','AC','0000642132','0000642132','OH00003317348','IL','1','ROBINSON','TONI','','','','34','268643151','20552 LAKE SHORE BLVD',0,'EUCLID','OH','44123','1846','CY','39035','1960-02-23','F','U',':RET:2054-5','T','021','HLT','2682464','52664OH151001306','2014-04-01','2014-02-27 18:36:30','388.00',NULL,NULL,'617.54','229.54','R-OH011','OH0','617.54',NULL,0,'2014-02-28 21:31:03'),(20557,16428,'Y','18','024','14','A','','','TE','0000509204','0000509204','','IL','1','JONES','CHARLES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-16','M','',NULL,NULL,NULL,'','1822712','','2014-01-29','2014-01-29 16:26:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:44'),(2744,2221,'Y','18','021','EC','A','','','AC','0000654564','0000654564','OH00000823625','IL','1','heath','kevin','','','','34','298542487','3030 9th street',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1953-12-27','M','U',':RET:2106-3','N','021','HLT','185782','52664OH152000901','2014-01-01','2013-12-02 17:29:20','0.00',NULL,NULL,'443.31','443.31','R-OH012','OH0','443.31',NULL,0,'2013-12-25 19:48:53'),(3604,2889,'N','19','021','EC','A',NULL,NULL,'','0000309439','0000265232','','IL','1','Haven','Troy','M','','','34','295987930','5992 HEYL RD',0,'WOOSTER','OH','44691','7454','CY','39169','1996-02-14','M','',NULL,'N','021','HLT','1869103','52664OH152000901','2014-01-01','2013-12-22 12:30:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:23:21'),(6572,5211,'Y','18','021','EC','A','','','AC','0000182539','0000182539','LA00000479997','IL','1','Cope','John','','','','34','264279157','5601 BERKLEY DR',0,'NEW ORLEANS','LA','70131','5402','CY','22071','1957-04-06','M','R',':RET:2106-3','N','021','DEN','446929','18575LA002000101','2014-01-01','2013-12-11 10:59:27','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:52:43'),(19145,15253,'Y','18','021','EC','A','','','AC','0000935408','0000935408','TX00002309200','IL','1','Robenson','Cynthia','D','','','34','456256873','3245 Simpson Stuart Rd bldg-10',0,'Dallas','TX','75241',NULL,'CY','48113','1964-07-25','F','U',':RET:2054-5','N','021','DEN','1399748','33348TX002000201','2014-03-01','2014-01-19 09:17:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-21 08:45:31'),(7983,6321,'Y','18','021','EC','A','','','AC','0000740268','0000740268','OH00000390744','IL','1','Brown','Brandon','','','','34','278969963','202 Hawk Ave',0,'Akron','OH','44312',NULL,'CY','39153','1987-12-17','M','M',':RET:2106-3','N','021','HLT','1854694','52664OH151001305','2014-01-01','2013-12-20 14:39:16','271.00',NULL,NULL,'592.98','321.98','R-OH012','OH0','228.36',NULL,0,'2013-12-26 03:08:01'),(9393,7449,'Y','18','024','14','A','','','TE','0000964547','0000964547','','IL','1','Rodriguez','Paul',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-07-26','M','',NULL,NULL,NULL,'','1494759','','2013-12-20','2013-12-20 21:26:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:24'),(9409,7465,'Y','18','024','14','A','','','TE','0000686673','0000686673','','IL','1','Deal','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-08-11','M','',NULL,NULL,NULL,'','483097','','2013-12-21','2013-12-21 12:18:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:50'),(18875,15037,'Y','18','021','EC','A','','','AC','0002249028','0002249028','LA00001558943','IL','1','VONNET-CELESTINE','MARTHA','','','','34','435257157','105 ITALIAN DRIVE',0,'LAFAYETTE','LA','70507',NULL,'CY','22055','1962-11-07','F','M',NULL,'N','021','DEN','2049002','18575LA002000201','2014-03-01','2014-01-16 14:42:56','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-17 03:36:26'),(13465,10739,'Y','18','021','EC','A','','','AC','0000998779','0000998779','OH00000475758','IL','1','HUFF','MALISSA','L','','','34','329765278','10897 BIRCHRIDGE DR',0,'CINCINNATI','OH','45240','3301','CY','39061','1985-04-05','F','U',':RET:2054-5','N','021','DEN','2416391','99734OH005000301','2014-01-01','2013-12-23 15:36:02','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:51'),(24195,19218,'Y','18','021','EC','A','','','AC','0000991590','0000991590','OH00002511663','IL','1','Bandy','Elizabeth','','','','34','298687198','23612 BOWMAN RD',0,'HOMEWORTH','OH','44634','9709','CY','39029','1972-08-27','F','U',':RET:2106-3','N','021','DEN','3077614','99734OH005000301','2014-03-01','2014-02-15 20:47:33','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-16 19:00:15'),(25066,19879,'Y','18','021','EC','A','','','AC','0001039804','0001039804','OH00002901227','IL','1','larry','kimberly','','','','34','280868077','665 E 131ST ST',0,'CLEVELAND','OH','44108','2034','CY','39035','1970-09-03','F','U',':RET:2054-5','N','021','DEN','3093633','99734OH005000401','2014-04-01','2014-02-20 14:36:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:01:27'),(27056,21424,'N','17','021','EC','A',NULL,NULL,'','0000399894','0001210981','','IL','1','GREEN','BRYLER','','','','34','284027296','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1997-04-27','M','',':RET:2106-3','N','021','HLT','3076432','92036OH003002704','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-03-03 21:00:27'),(20543,16416,'Y','18','021','EC','A','','','AC','0000741753','0000741753','OH00002319215','IL','1','Cajka','Nancy','','','','34','292607670','7105 5 POINT RD',0,'PERRYSBURG','OH','43551','9230','CY','39173','1960-11-07','F','M',':RET:2106-3','N','021','HLT','3154876','92036OH006002601','2014-03-01','2014-01-29 12:18:49','31.00',NULL,NULL,'315.47','284.47','R-OH001','OH0','315.47',NULL,0,'2014-01-29 21:01:37'),(20295,16200,'Y','18','024','14','A','','','TE','0002219360','0002219360','','IL','1','SEMIEN','ANGELA','DENISE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-04','F','',NULL,NULL,NULL,'','2552979','','2014-01-28','2014-01-28 13:51:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-28 21:00:39'),(4499,3566,'Y','18','021','EC','A','','','AC','0000731458','0000731458','TX00000736733','IL','1','Martinez','Pedro','F','','','34','585669767','524 S BOISDARC STREET',0,'Pecos','TX','79772',NULL,'CY','48389','1955-05-11','M','M',NULL,'T','021','DEN','909958','33348TX002000201','2014-01-01','2013-12-11 20:52:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:03:19'),(16244,13009,'Y','18','021','EC','A','','','AC','0000468125','0000468125','OH00001394076','IL','1','patel','kanak','','','','34','366234351','1435 S CARPENTER RD',0,'BRUNSWICK','OH','44212','3861','CY','39103','1959-02-22','M','M',':RET:2029-7','N','021','DEN','1530718','99734OH005000301','2014-02-01','2014-01-04 10:41:54','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-05 00:02:28'),(2649,2152,'N','01','021','EC','A',NULL,NULL,'','0000789866','0000361656','','IL','1','Everitt','Danny','Leroy','','','34','460903057','4400 MEMORIAL DR',0,'HOUSTON','TX','77007','7378','CY','48201','1949-10-01','M','',':RET:2106-3','N','021','DEN','89249','33348TX002000101','2014-01-01','2013-12-02 17:44:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 19:46:33'),(7227,5729,'Y','18','024','14','A','','','TE','0000584258','0000584258','','IL','1','Gaugh','Sarah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-05-19','F','',NULL,NULL,NULL,'','994202','','2013-12-14','2013-12-14 15:49:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:01:16'),(22574,18029,'Y','18','021','EC','A','','','AC','0000991583','0000991583','OH00002220248','IL','1','holzhauser','lois','','','','34','269703271','467 hyde st',0,'wakeman','OH','44889',NULL,'CY','39077','1961-04-22','F','M',':RET:2106-3','T','021','HLT','3316174','92036OH004002701','2014-03-01','2014-02-10 06:52:52','310.00',NULL,NULL,'351.96','41.96','R-OH006','OH0','351.96',NULL,0,'2014-02-10 21:31:58'),(22698,18124,'N','01','021','EC','A',NULL,NULL,'','0000764956','0000482097','','IL','1','HILL','BRENDA','J','','','34','552904345','9001 MARKVILLE DR',0,'DALLAS','TX','75243','9341','CY','48113','1953-10-04','F','',':RET:2106-3','N','021','DEN','3655447','33348TX002000101','2014-03-01','2014-02-11 02:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-11 21:00:57'),(27442,21718,'N','01','021','EC','A',NULL,NULL,'','0001426207','0002310050','','IL','1','Feeheley','Monica','P','','','34','436312410','3030 PARKWAY ST',0,'RINGGOLD','LA','71068','8204','CY','22013','1962-09-04','F','',NULL,'N','021','DEN','3236131','18575LA002000201','2014-04-01','2014-03-04 15:41:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-04 21:01:54'),(15173,12125,'Y','18','021','EC','A','','','AC','0000141522','0000141522','OH00001684665','IL','1','FESTAGALLO','PATRICIA','','','','34','272660082','102 STATE ROUTE 133',0,'FELICITY','OH','45120','9706','CY','39025','1958-05-25','F','U',NULL,'N','021','DEN','2490723','99734OH005000401','2014-02-01','2013-12-30 15:53:49','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-01 12:06:38'),(15075,12050,'Y','18','024','14','A','','','TE','0001111908','0001111908','','IL','1','Graves','Jeremy','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-02-07','M','',NULL,NULL,NULL,'','1603097','','2013-12-29','2013-12-29 19:38:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-01 12:04:01'),(1506,1255,'Y','18','021','EC','A','','','AC','0000463236','0000463236','OH00001024933','IL','1','Moore','Peter','','','','34','280701078','1716 WATERTOWER DR',0,'COLUMBUS','OH','43235','1939','CY','39049','1968-07-06','M','U',':RET:2106-3','T','021','DEN','1442216','99734OH005000401','2014-01-01','2013-12-24 12:29:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:22'),(9018,7155,'N','19','021','EC','A',NULL,NULL,'','0001024255','0000762274','','S1','1','Kaye','Regina','','','','34','287026638','938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1997-10-15','M','',':RET:2106-3','N','021','HLT','2350159','52664OH151001301','2014-01-01','2013-12-17 19:26:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 04:05:16'),(9000,7141,'N','01','021','EC','A',NULL,NULL,'','0000751005','0001212336','','IL','1','Wiant','Diana','L','','','34','298483569','2485 DALTON RD',0,'FAIRLAWN','OH','44333','3851','CY','39153','1950-06-26','F','',NULL,'N','021','HLT','2045238','52664OH152000901','2014-01-01','2013-12-17 22:12:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2013-12-26 04:04:51'),(6906,5480,'Y','18','021','EC','A','','','AC','0001993684','0001993684','LA00001533725','IL','1','sandifer','stanley','','','','34','427318409','837 NAVAHO TRL',0,'SHREVEPORT','LA','71107','5317','CY','22017','1975-12-03','M','U',':RET:2054-5','N','021','DEN','1641216','18575LA002000201','2014-01-01','2013-12-24 23:46:52','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 01:45:46'),(22053,17604,'Y','18','021','EC','A','','','AC','0001142561','0001142561','TX00001365301','IL','1','Chavira','Jorge','','','','34','523731854','12927 SPARKS DR',0,'EL PASO','TX','79928','5719','CY','48141','1989-06-22','M','M',':RET:2106-3','N','021','DEN','3411455','33348TX002000201','2014-03-01','2014-02-07 20:40:33','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-08 19:00:06'),(27909,22079,'Y','18','021','EC','A','','','AC','0000622873','0000622873','TX00002710213','IL','1','Jones','Debbie','Deniese','','','34','453398579','7100 Joy Ave',0,'Canyon','TX','79015',NULL,'CY','48381','1960-05-09','F','M',':RET:2106-3','N','021','DEN','3265070','33348TX002000201','2014-04-01','2014-03-05 19:31:33','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-03-06 21:00:13'),(28059,22204,'Y','18','021','EC','A','','','AC','0000699338','0000699338','OH00002873958','IL','1','Davis','Barnetta','','','','34','272585545','235 Minster St',0,'Hamilton','OH','45011',NULL,'CY','39017','1956-01-26','M','U',NULL,'N','021','DEN','3588915','99734OH005000301','2014-04-01','2014-03-05 21:39:44','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:42'),(19578,15606,'Y','18','021','EC','A','','','AC','0001587663','0001587663','LA00001977449','IL','1','Brown','Stephanie','','','','34','437512881','2206 MIKE ST',0,'WINNSBORO','LA','71295','2336','CY','22041','1974-07-23','F','U',':RET:2054-5','N','021','DEN','1566913','18575LA002000201','2014-03-01','2014-01-22 12:11:22','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-23 03:02:39'),(18455,14722,'Y','18','021','EC','A','','','AC','0001463946','0001463946','LA00001799310','IL','1','Davis','Lenard','','','','34','436434667','1418 KING DEAN DR',0,'BATON ROUGE','LA','70810','3217','CY','22033','1964-09-18','M','U',':RET:2054-5','N','021','DEN','2754253','18575LA002000101','2014-02-01','2014-01-14 22:11:04','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:09'),(17584,14056,'N','01','021','EC','A',NULL,NULL,'','0000050708','0001126887','','IL','1','Hindel','Scott','','','','34','276886241','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','1976-12-24','M','',':RET:2106-3','N','021','DEN','1970276','99734OH005000401','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:07'),(2347,1912,'Y','18','021','EC','A','','','AC','0000941593','0000941593','TX00000029823','IL','1','barckow','linda','','','','34','092545918','8245 SAN ANTONIO ST',0,'ODESSA','TX','79765','8527','CY','48329','1958-08-27','F','M',':RET:2106-3','T','021','DEN','455760','33348TX002000201','2014-01-01','2013-12-09 14:26:29','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-25 19:32:07'),(13680,10915,'Y','18','021','EC','A','','','AC','0001163830','0001163830','OH00000004469','IL','1','Clark','Roseanna','','','','34','299525063','2711 W. Market Street',0,'Akron','OH','44313',NULL,'CY','39153','1953-04-06','F','U',NULL,'N','021','HLT','1671346','52664OH151001305','2014-01-01','2013-12-22 21:29:02','455.00',NULL,NULL,'605.24','150.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 13:08:08'),(6651,5275,'N','01','021','EC','A',NULL,NULL,'','0000736481','0001115896','','IL','1','Waugh','Kevin','','','','34','275748630','6853 CLUBSIDE DR',0,'LOVELAND','OH','45140','6040','CY','39025','1978-08-31','M','',NULL,'N','021','HLT','830523','92036OH004000601','2014-01-01','2013-11-12 12:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','210.92',NULL,0,'2013-12-26 01:00:33'),(1876,1532,'Y','18','021','EC','A','','','AC','0000329649','0000329649','OH00001450938','IL','1','Boyd','Beatrice','','','','34','279505856','900 MCKINLEY AVE',0,'AKRON','OH','44306','1908','CY','39153','1952-07-06','F','U',':RET:2054-5','N','021','HLT','1552926','52664OH152000901','2014-01-01','2013-12-24 17:13:11','458.99',NULL,NULL,'458.99','0.00','R-OH012','OH0','458.99',NULL,0,'2013-12-25 18:58:25'),(3380,2709,'Y','18','021','EC','A','','','AC','0000731522','0000731522','TX00001223236','IL','1','Peterson','Melinda','','','','34','459575420','3210 Lanell Drive',0,'Belton','TX','76513',NULL,'CY','48027','1970-08-19','F','U',':RET:2106-3','N','021','DEN','2447241','33348TX002000201','2014-01-01','2013-12-22 17:21:52','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 21:17:29'),(4091,3268,'Y','18','021','EC','A','','','AC','0000317930','0000317930','MS00001182307','IL','1','Edens','Justin','','','','34','426754086','601 Harbor Ridge Drive',0,'Brandon','MS','39047',NULL,'CY','28121','1987-10-27','M','R',':RET:2106-3','T','021','DEN','2245135','46300MS002000101','2014-01-01','2013-12-16 18:48:40','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 21:47:26'),(9156,7263,'Y','18','021','EC','A','','','AC','0000192720','0000192720','OH00000103380','IL','1','Douglas','Andrew','','','','34','301848375','11733 RETVIEW LN',0,'LOVELAND','OH','45140','9376','CY','39061','1978-11-01','M','R',NULL,'N','021','HLT','1779881','92036OH006001201','2014-01-01','2013-12-17 21:40:25','0.00',NULL,NULL,'208.03','208.03','R-OH004','OH0','208.03',NULL,0,'2013-12-26 04:08:35'),(4609,3650,'Y','18','021','EC','A','','','AC','0000340265','0000340265','OH00000099426','IL','1','mcmaster','christopher','','','','34','289783927','3660 KENT RD',0,'STOW','OH','44224','4667','CY','39153','1982-04-16','M','U',NULL,'N','021','HLT','221442','52664OH151001501','2014-01-01','2013-12-11 22:01:08','141.00',NULL,NULL,'309.99','168.99','R-OH012','OH0','309.99',NULL,0,'2013-12-25 22:05:55'),(5294,4195,'Y','18','021','EC','A','','','AC','0000370013','0000370013','OH00000384043','IL','1','Martin','James','','','','34','289889108','3318 HEARTHSTONE RD',0,'PARMA','OH','44134','2642','CY','39035','1986-04-24','M','U',':RET:2106-3','N','021','HLT','1814206','52664OH151001305','2014-01-01','2013-12-19 17:49:54','110.00',NULL,NULL,'263.59','153.59','R-OH011','OH0','263.59',NULL,0,'2013-12-25 23:06:07'),(23303,18578,'Y','18','021','EC','A','','','AC','0000573091','0000573091','OH00001767081','IL','1','yue','min','','','','34','595633035','5124 HARVESTDALE DR',0,'MASON','OH','45040','3669','CY','39165','1970-12-29','F','U',':RET:2034-7','N','021','DEN','2650001','99734OH005000301','2014-03-01','2014-02-13 07:34:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:16'),(23428,18665,'N','19','021','EC','A',NULL,NULL,'','0000520158','0000336656','','IL','1','Tippett','Catelyn','','','','34','627251588','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','2010-01-29','F','',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-13 22:01:26'),(23624,18812,'N','01','021','EC','A',NULL,NULL,'','0000097619','0000287140','','IL','1','Vayda','Heidi','Warren','','','34','005764959','42 E LORAIN ST',0,'OBERLIN','OH','44074','1128','CY','39093','1965-09-28','F','',':RET:2106-3','N','021','HLT','3227163','92036OH005000806','2014-03-01','2014-02-13 16:36:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.26',NULL,0,'2014-02-13 22:03:18'),(24457,19429,'Y','18','021','EC','A','','','AC','0000929786','0000929786','MS00002585033','IL','1','BUSH','KATHERINE','','','','34','426254251','8 RASBERRY RD',0,'LAUREL','MS','39443','8877','CY','28067','1960-09-03','F','U',':RET:2106-3','N','021','DEN','3824682','46300MS002000101','2014-04-01','2014-02-18 15:10:11','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-18 22:01:30'),(28402,22472,'Y','18','021','EC','A','','','AC','0000381205','0000381205','OH00003234758','IL','1','Gibson','Natasha','','','','34','297943152','4313 E 141ST ST',0,'CLEVELAND','OH','44128','2301','CY','39035','1992-01-27','F','U',':RET:2054-5','N','021','DEN','4235911','99734OH005000401','2014-04-01','2014-03-07 08:39:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:51'),(18611,14836,'Y','18','021','EC','A','','','AC','0000636041','0000636041','OH00002549919','IL','1','POLZIN','BEN','','','','34','384949845','6938 DOMERSVILLE RD',0,'DEFIANCE','OH','43512','9123','CY','39039','1978-06-13','M','M',':RET:2106-3','N','021','HLT','1994353','92036OH002002601','2014-02-01','2014-01-15 13:16:59','51.00',NULL,NULL,'519.95','468.95','R-OH001','OH0','275.16',NULL,0,'2014-01-16 08:47:23'),(13739,10966,'Y','18','021','EC','A','','','AC','0000578787','0000578787','OH00000482895','IL','1','Weathers','Terry','','','','34','256827790','215 ELMWOOD DR',0,'DOYLESTOWN','OH','44230','1002','CY','39169','1951-07-28','M','U',':RET:2106-3','N','021','HLT','1891469','52664OH151001305','2014-01-01','2013-12-23 18:56:29','529.00',NULL,NULL,'640.70','111.70','R-OH014','OH0','640.70',NULL,0,'2013-12-26 13:09:37'),(18435,14708,'Y','18','021','EC','A','','','AC','0001255738','0001255738','LA00001925965','IL','1','Prudhomme','Dorothy','','','','34','034624769','426 KIMBRO DR',0,'BATON ROUGE','LA','70808','6036','CY','22033','1970-10-05','F','U',':RET:2106-3','N','021','DEN','1847086','18575LA002000201','2014-02-01','2014-01-15 16:52:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-16 08:46:00'),(16364,13096,'Y','18','021','EC','A','','','AC','0000467588','0000467588','MS00001794995','IL','1','Barton','John','','','','34','425044291','403 Hayes St.',0,'Carthage','MS','39051',NULL,'CY','28079','1956-08-27','M','M',':RET:2054-5','N','021','DEN','1651299','46300MS002000201','2014-02-01','2014-01-06 11:00:37','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2014-01-07 04:02:51'),(16074,12873,'Y','18','021','EC','A','','','AC','0001078905','0001078905','OH00001158196','IL','1','Bender','Randy','D','','','34','400881208','117 Shay Street',0,'Deleware','OH','43015',NULL,'CY','39041','1956-01-03','M','M',NULL,'N','021','DEN','2547671','99734OH005000401','2014-02-01','2014-01-03 12:58:37','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-04 02:03:53'),(5503,4369,'Y','18','021','EC','A','','','AC','0000312175','0000312175','OH00000733296','IL','1','Smith','Sean','','','','34','271764361','1438 NORTH RD SE',0,'WARREN','OH','44484','2901','CY','39155','1974-10-15','M','M',':RET:2106-3','N','021','HLT','1471322','92036OH002003201','2014-01-01','2013-12-19 17:41:47','0.00',NULL,NULL,'352.76','352.76','R-OH013','OH0','352.76',NULL,0,'2013-12-25 23:11:23'),(9528,7553,'Y','18','021','EC','A','','','AC','0000160787','0000160787','OH00000068101','IL','1','Steele','Jodi','Lynn','','','34','289580541','1027 Vernon Road',0,'Bexley','OH','43209',NULL,'CY','39049','1971-11-01','F','R',NULL,'N','021','DEN','1782972','99734OH005000301','2014-01-01','2013-12-20 22:05:28','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:35:44'),(14879,11882,'Y','18','021','EC','A','','','AC','0000682534','0000682534','TX00001962234','IL','1','Pham','Christy','','','','34','455456103','10410 KIRKVALE DR',0,'HOUSTON','TX','77089','2014','CY','48201','1978-10-03','F','M',':RET:2034-7','N','021','DEN','2000244','33348TX002000201','2014-02-01','2013-12-29 15:03:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-30 00:00:28'),(24213,19231,'Y','18','021','EC','A','','','AC','0001187875','0001187875','TX00001486329','IL','1','garcia','liza','','','','34','631224611','2020 W PINE ST',0,'TYLER','TX','75702','6721','CY','48423','1991-03-06','F','U',NULL,'N','021','DEN','3261851','33348TX002000201','2014-03-01','2014-02-15 20:01:25','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-16 19:00:24'),(24378,19364,'Y','18','021','EC','A','','','AC','0001176897','0001176897','OH00002324925','IL','1','WENKE','THOMAS','J','','','34','270660707','2847 QUEENSWOOD DR',0,'CINCINNATI','OH','45211','8309','CY','39061','1959-09-12','M','U',':RET:2106-3','N','021','DEN','2882879','99734OH005000401','2014-04-01','2014-02-18 08:26:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:43'),(27584,21814,'Y','18','021','EC','A','','','AC','0000396088','0000396088','TX00003482124','IL','1','WILSON','DOROTHY','GEORGETTE','','','34','467574631','1006 FOLEY AVE',0,'IOWA PARK','TX','76367','1402','CY','48485','1982-09-12','F','U',':RET:2106-3','N','021','DEN','3120068','33348TX002000201','2014-04-01','2014-03-05 10:54:58','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85','CIC',0,'2014-03-05 21:00:13'),(7150,5673,'Y','18','021','EC','A','','','AC','0000307691','0000307691','TX00001155280','IL','1','landerman','gregory','','','','34','272689825','3404 ROCK RIDGE ST',0,'NACOGDOCHES','TX','75965','3238','CY','48347','1965-12-27','M','R',':RET:2106-3','N','021','DEN','2114946','33348TX002000101','2014-02-01','2013-12-25 16:53:29','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 01:52:10'),(15947,12767,'Y','18','021','EC','A','','','AC','0000315948','0000315948','OH00001080494','IL','1','cox','jeanette','','','','34','421666026','358 N Lake Pine Dr',0,'Marblehead','OH','43440',NULL,'CY','39123','1951-01-31','F','U',':RET:2106-3','T','021','HLT','1454463','92036OH005002705','2014-02-01','2014-01-02 17:46:05','522.00',NULL,NULL,'661.96','139.96','R-OH006','OH0','661.96',NULL,0,'2014-01-03 02:07:24'),(9439,7488,'Y','18','021','EC','A','','','AC','0001155097','0001155097','OH00001119256','IL','1','Tucker','Barbara','','','','34','114442304','7127 Oak Post Ln',0,'Cincinnati','OH','45241',NULL,'CY','39061','1952-03-04','F','U',':RET:2106-3','N','021','HLT','2025846','92036OH006001201','2014-01-01','2013-12-21 17:42:35','251.00',NULL,NULL,'478.41','227.41','R-OH004','OH0','478.41',NULL,0,'2013-12-26 04:33:38'),(8999,7141,'Y','18','021','EC','A','','','AC','0000751005','0000751005','OH00001278994','IL','1','Wiant','Harold','','','','34','278521064','2485 DALTON RD',0,'FAIRLAWN','OH','44333','3851','CY','39153','1952-09-12','M','M',NULL,'N','021','HLT','2045238','52664OH152000901','2014-01-01','2013-12-17 22:12:12','800.00',NULL,NULL,'941.17','141.17','R-OH012','OH0','458.99',NULL,0,'2013-12-26 04:04:49'),(18201,14528,'N','19','021','EC','A',NULL,NULL,'','0000964638','0000397366','','S1','1','shaferly','michael','david','','','34','281113012','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','2005-04-04','F','',':RET:2106-3','N','021','HLT','2743747','92036OH002001501','2014-02-01','2014-01-14 12:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2014-01-15 02:08:06'),(3994,3189,'Y','18','021','EC','A','','','AC','0000672738','0000672738','OH00000355869','31','1','Wolf','Virginia','','','','34','286566032','PO Box 582',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1958-10-12','F','M',NULL,'N','021','HLT','952011','92036OH001001501','2014-01-01','2013-12-13 15:49:06','289.00',NULL,NULL,'592.01','303.01','R-OH002','OH0','592.01',NULL,0,'2013-12-25 21:39:12'),(1578,1317,'Y','18','021','EC','A','','','AC','0000664280','0000664280','TX00000017805','IL','1','Rodriguez','Maria','','','','34','459927696','3702 SANTA CLEOTILDE AVE',0,'LAREDO','TX','78041','5563','CY','48479','1950-12-25','F','U',NULL,'N','021','DEN','1390416','33348TX002000201','2014-01-01','2013-12-24 10:29:11','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 18:51:22'),(2306,1875,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001163808','','IL','1','Isenbarger','Jacob','','','','34','294022081','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1998-02-22','M','',':RET:2106-3','N','021','DEN','709237','99734OH005000301','2014-01-01','2013-12-09 17:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:05'),(7405,5860,'Y','18','021','EC','A','','','AC','0000522560','0000522560','TX00000887762','IL','1','Poyant','Kathryn','D','','','34','013663834','5105 Timberland Pkwy.',0,'Flower Mound','TX','75028',NULL,'CY','48121','1984-11-17','F','U',NULL,'N','021','DEN','701750','33348TX002000201','2014-01-01','2013-10-26 21:19:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:16:33'),(6851,5431,'Y','18','021','EC','A','','','AC','0000228054','0000228054','TX00000064420','IL','1','byers','john','','','','34','455272816','22531 Indian ridge dr',0,'katy','TX','77450',NULL,'CY','48201','1957-09-20','M','U',NULL,'N','021','DEN','439573','33348TX002000201','2014-01-01','2013-10-05 16:08:29','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:31:22'),(3840,3072,'Y','18','024','14','A','','','TE','0000776457','0000776457','','IL','1','Smith','Ricky',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-06-14','M','',NULL,NULL,NULL,'','936125','','2013-12-13','2013-12-13 18:07:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:35:22'),(21109,16866,'Y','18','021','EC','A','','','AC','0001675248','0001675248','LA00002589465','IL','1','FOUNTAIN','LILLIE','','','','34','435942948','12242 LAZY OAK DR',0,'BAKER','LA','70714','6036','CY','22033','1953-09-13','F','U',NULL,'N','021','DEN','3518862','18575LA002000101','2014-03-01','2014-02-02 19:37:50','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-03 21:00:06'),(22527,17985,'Y','18','021','EC','A','','','AC','0000399934','0000399934','OH00001927713','IL','1','Smith','Sarah','','','','34','292825176','2323 19TH ST',0,'CUYAHOGA FALLS','OH','44223','1538','CY','39153','1985-01-05','F','U',':RET:2106-3','N','021','HLT','3835145','52664OH152000901','2014-03-01','2014-02-09 21:40:09','172.00',NULL,NULL,'182.78','10.78','R-OH012','OH0','182.78',NULL,0,'2014-02-10 21:31:29'),(17933,14327,'Y','18','021','EC','A','','','AC','0000422768','0000422768','TX00002029609','IL','1','WOO','DANIELA','','','','34','645544654','420 N EXPRESSWAY',0,'BROWNSVILLE','TX','78521',NULL,'CY','48061','1987-07-04','F','U',NULL,'N','021','DEN','2682859','33348TX002000201','2014-02-01','2014-01-14 14:10:18','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-15 02:06:36'),(1405,1167,'Y','18','021','EC','A','','','AC','0001936882','0001936882','LA00000970259','IL','1','Mujaahid','Pearlie','','','','34','437927803','7237 Regent',0,'New Orleans','LA','70124',NULL,'CY','22071','1951-09-22','F','U',':RET:2054-5','N','021','DEN','1649798','18575LA002000201','2014-01-01','2013-12-24 12:42:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:43'),(17647,14106,'Y','18','021','EC','A','','','AC','0001200901','0001200901','OH00001841563','IL','1','MUHAMMAD','NIYRA','R','','','34','291760774','2352 CHEYENNE BLVD',0,'TOLEDO','OH','43614',NULL,'CY','39095','1980-11-01','F','U',':RET:2054-5','N','021','DEN','1485664','99734OH005000301','2014-02-01','2014-01-13 11:24:32','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-14 01:32:39'),(5465,4341,'Y','18','024','14','A','','','TE','0001205809','0001205809','','IL','1','Rhoades','Sharon','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-28','F','',NULL,NULL,NULL,'','1894843','','2013-12-19','2013-12-19 09:06:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:31'),(4618,3657,'Y','18','021','EC','A','','','AC','0000979288','0000979288','OH00001085088','IL','1','Reikowsky','James','P','','','34','302541407','601 WOODSIDE AVE NE',0,'NORTH CANTON','OH','44720','2035','CY','39151','1954-03-17','M','U',':RET:2106-3','N','021','HLT','590599','52664OH151001501','2014-01-01','2013-12-12 17:52:14','197.00',NULL,NULL,'696.21','499.21','R-OH015','OH0','696.21',NULL,0,'2013-12-25 22:06:09'),(19922,15886,'Y','18','021','EC','A','','','AC','0000017606','0000017606','MS00002354729','IL','1','EDMOND','WILLIAM','','','','34','587209934','086 GEORGE STREET',0,'MOUND BAYOU','MS','38762',NULL,'CY','28011','1949-08-25','M','U',':RET:2054-5','N','021','DEN','3167345','46300MS002000101','2014-03-01','2014-01-24 16:26:05','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-24 21:01:04'),(23266,18550,'N','01','021','EC','A',NULL,NULL,'','0000987360','0000688255','','IL','1','Carnes','Mary','E','','','34','312562196','461 SANOMA CT',0,'CINCINNATI','OH','45255','5645','CY','39025','1949-08-26','F','',':RET:2106-3','N','021','DEN','2961704','99734OH005000301','2014-03-01','2014-02-13 14:33:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-13 21:30:11'),(23335,18599,'Y','18','021','EC','A','','','AC','0000251669','0000251669','OH00002453038','IL','1','Handel','David','','','','34','282924566','370 S 5TH ST',0,'COLUMBUS','OH','43215','5435','CY','39049','1988-02-16','M','U',':RET:2106-3','N','021','DEN','2757527','99734OH005000301','2014-03-01','2014-02-13 17:00:52','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:33'),(25515,20242,'Y','18','021','EC','A','','','AC','0000740334','0000740334','OH00002897680','IL','1','FREELAND','TRACY','','','','34','293809013','14893 STATE ROUTE 136',0,'WINCHESTER','OH','45697',NULL,'CY','39001','1967-10-21','F','R',':RET:2106-3','N','021','HLT','3084691','92036OH001000601','2014-04-01','2014-02-25 10:29:00','0.00',NULL,NULL,'835.06','835.06','R-OH005','OH0','388.40',NULL,0,'2014-02-25 21:32:03'),(27467,21737,'N','01','021','EC','A',NULL,NULL,'','0000938591','0000229499','','IL','1','Ranck','Eric','','','','34','302926175','9 E MARTHA JEAN DR',0,'AMELIA','OH','45102','1416','CY','39025','1990-01-26','M','',':RET:2106-3','N','021','HLT','3554078','92036OH003000605','2014-04-01','2014-03-03 20:59:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2014-03-04 21:02:09'),(9577,7584,'Y','18','021','EC','A','','','AC','0000368543','0000368543','OH00000545721','IL','1','ECCARD','JILL','','','','34','285660717','1711 COTTONTAIL DR',0,'MILFORD','OH','45150','5520','CY','39025','1958-09-02','F','M',':RET:2106-3','N','021','DEN','1556347','99734OH005000301','2014-01-01','2013-12-21 17:13:16','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:36:48'),(7295,5781,'Y','18','021','EC','A','','','AC','0001066959','0001066959','OH00000557799','IL','1','MCCARTHY','JAMES','','','','34','302482818','1668 OVERBROOK RD',0,'LYNDHURST','OH','44124','2767','CY','39035','1952-12-26','M','M',NULL,'N','021','HLT','517574','52664OH151001501','2014-01-01','2013-12-14 16:08:14','294.00',NULL,NULL,'847.67','553.67','R-OH011','OH0','847.67',NULL,0,'2013-12-26 02:02:59'),(6374,5054,'Y','18','021','EC','A','','','AC','0001181002','0001181002','OH00001070766','IL','1','Deloatch','Patricia','','','','34','578900535','522 FOREST AVE',0,'ZANESVILLE','OH','43701','2928','CY','39119','1959-12-04','F','M',':RET:2054-5','N','021','DEN','330625','99734OH005000301','2014-01-01','2013-12-11 09:05:37','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 00:47:45'),(17354,13884,'Y','18','021','EC','A','','','AC','0001631157','0001631157','LA00002574487','IL','1','Dainty','Virginia','','','','34','435889555','22569 FAIRBORN RD',0,'FRANKLINTON','LA','70438','3003','CY','22117','1951-02-24','F','U',':RET:2106-3','N','021','DEN','2625928','18575LA002000101','2014-02-01','2014-01-10 13:30:34','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:24:10'),(16955,13571,'Y','18','021','EC','A','','','AC','0000186127','0000186127','OH00002414778','IL','1','Hayes','Linda','','','','34','299568853','136Brooklyn Ave.',0,'Sidney','OH','45365',NULL,'CY','39149','1958-01-25','F','U',':RET:2106-3','T','021','HLT','1744969','92036OH003000506','2014-02-01','2014-01-08 18:40:40','531.00',NULL,NULL,'666.00','135.00','R-OH003','OH0','666.00',NULL,0,'2014-01-13 02:20:03'),(2030,1662,'N','01','021','EC','A',NULL,NULL,'','0001139486','0000776406','','IL','1','Warren','Marsha','Lynn','','','34','288505289','4750 Tahiti Dr.',0,'Akron','OH','44319',NULL,'CY','39153','1950-05-23','F','',':RET:2106-3','N','021','HLT','45191','52664OH152000901','2014-01-01','2013-12-10 16:32:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2013-12-25 19:15:20'),(15994,12801,'N','01','021','EC','A',NULL,NULL,'','0000393367','0000150508','','IL','1','Coleman','Regina','','','','34','522510972','111 FM 1996',0,'OGLESBY','TX','76561','2014','CY','48099','1986-10-14','F','',NULL,'N','021','DEN','1880895','33348TX002000201','2014-02-01','2014-01-03 13:31:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:01:19'),(16950,13567,'Y','18','021','EC','A','','','AC','0001006158','0001006158','MS00001890004','31','1','GREEN','MICHELLE','','','','34','425293490','P.O.BOX13',0,'ARCOLA','MS','38722',NULL,'CY','28151','1964-04-16','F','M',':RET:2054-5','N','021','DEN','1601235','46300MS002000101','2014-02-01','2014-01-08 22:34:18','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:20:00'),(2447,1992,'Y','18','021','EC','A','','','AC','0001231747','0001231747','OH00001250525','IL','1','Clark','Lois','','','','34','403683336','2059 Smith Rd',0,'Hamilton','OH','45013',NULL,'CY','39017','1949-10-07','F','M',':RET:2106-3','N','021','HLT','655055','92036OH004001201','2014-01-01','2013-12-09 13:39:38','206.00',NULL,NULL,'517.83','311.83','R-OH004','OH0','517.83',NULL,0,'2013-12-25 19:34:34'),(2679,2170,'Y','18','021','EC','A','','','AC','0001256007','0001256007','OH00000753646','IL','1','GRAY','ARTHUR','','','','34','269643827','667 CHERRY HILL DR',0,'PICKERINGTON','OH','43147','8768','CY','39045','1962-01-09','M','M',NULL,'N','021','DEN','862877','99734OH005000301','2014-01-01','2013-12-02 13:08:44','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:47:10'),(16493,13196,'N','19','021','EC','A',NULL,NULL,'','0001144785','0000330889','','IL','1','TA','TOAN','N','','','34','301062234','1866 LATHAM AVE',0,'LIMA','OH','45805','1636','CY','39003','2002-07-03','M','',':RET:2047-9','N','021','HLT','1452164','92036OH006001501','2014-02-01','2014-01-06 16:20:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-01-07 04:06:35'),(4493,3561,'Y','18','021','EC','A','','','AC','0001235250','0001235250','TX00001133343','IL','1','Flores','Noelia','','','','34','452698880','462 Patricia Ave',0,'Mercedes','TX','78570',NULL,'CY','48215','1973-11-29','F','M',NULL,'N','021','DEN','163963','33348TX002000201','2014-01-01','2013-12-11 18:43:53','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:03:11'),(9573,7583,'N','19','021','EC','A',NULL,NULL,'','0001218535','0000851830','','IL','1','Hinkle','Damian','Christopher','','','34','295081080','2593 MAPLE DR',0,'TWINSBURG','OH','44087','2139','CY','39153','2003-03-21','M','',':RET:2054-5','N','021','DEN','2409970','99734OH005000301','2014-01-01','2013-12-21 17:04:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:46'),(20122,16055,'Y','18','024','14','A','','','TE','0000203048','0000203048','','IL','1','Montgomery','Gwyn','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-03','F','',NULL,NULL,NULL,'','843790','','2014-01-27','2014-01-27 09:42:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:47'),(20656,16507,'Y','18','021','EC','A','','','AC','0000580413','0000580413','TX00001666992','IL','1','SOTO','TOMASA','','','','34','641785393','3721 N CRUMP ST',0,'FORT WORTH','TX','76106','3702','CY','48439','1960-10-17','F','M',NULL,'N','021','DEN','3333969','33348TX002000201','2014-03-01','2014-01-30 16:19:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:41'),(25618,20325,'Y','18','021','EC','A','','','AC','0000685610','0000685610','TX00002215338','IL','1','Greener','David','J','','','34','464877101','10307 GENTRY DR',0,'JUSTIN','TX','76247','7888','CY','48121','1982-07-30','M','U',':RET:2106-3','N','021','DEN','3832845','33348TX002000201','2014-04-01','2014-02-22 11:54:44','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 08:30:14'),(27606,21833,'N','19','021','EC','A',NULL,NULL,'','0001099244','0000100125','','IL','1','Sarli-Freeman','Colette','','','','34','292112492','23896 Parkwood Drive',0,'Columbia Station','OH','44028',NULL,'CY','39093','2006-01-28','F','',NULL,'N','021','DEN','3390721','99734OH005000301','2014-04-01','2014-03-05 12:10:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-05 21:00:26'),(17792,14212,'N','01','021','EC','A',NULL,NULL,'','0000134595','0000464657','','IL','1','Vodney','William','','','III','34','287685722','2368 ANDERSON RD',0,'CUYAHOGA FALLS','OH','44221','3657','CY','39153','1960-05-19','M','',NULL,'N','021','HLT','2081622','52664OH151001501','2014-02-01','2014-01-13 15:30:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','545.63',NULL,0,'2014-01-14 01:33:48'),(16071,12870,'Y','18','021','EC','A','','','AC','0001142180','0001142180','OH00000084592','IL','1','GUTWILL','KARIN','THERESA','','','34','294865034','36209 FALCON CREST AVE',0,'AVON','OH','44011','1869','CY','39093','1987-05-04','F','U',':RET:2106-3','N','021','DEN','1729404','99734OH005000401','2014-02-01','2014-01-03 12:14:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:03:48'),(14563,11619,'Y','18','021','EC','A','','','AC','0000578790','0000578790','OH00001690738','IL','1','Barnett','Oretha','','','','34','291540125','3974 Colony Rd',0,'South Euclid','OH','44118',NULL,'CY','39035','1954-08-20','F','M',':RET:2054-5','N','021','HLT','1756668','52664OH152000901','2014-02-01','2013-12-27 12:46:12','737.00',NULL,NULL,'997.20','260.20','R-OH011','OH0','479.53',NULL,0,'2013-12-28 03:35:19'),(13711,10940,'Y','18','021','EC','A','','','AC','0001099186','0001099186','OH00000833968','IL','1','Lambert','Mary','','','','34','297527865','28304 LINCOLN RD',0,'BAY VILLAGE','OH','44140','2119','CY','39035','1951-01-11','F','M',':RET:2106-3','N','021','HLT','1416305','52664OH151001301','2014-01-01','2013-12-23 14:15:30','139.00',NULL,NULL,'722.61','583.61','R-OH011','OH0','722.61',NULL,0,'2013-12-26 13:08:56'),(2824,2282,'Y','18','021','EC','A','','','AC','0000156900','0000156900','OH00001035859','IL','1','Congrove','Timothy','','','','34','279924806','7385 NOLL DR',0,'NORTH RIDGEVILLE','OH','44039','3760','CY','39093','1978-09-20','M','U',':RET:2054-5^:RET:2500-7^:RET:2106-3','T','021','DEN','237690','99734OH005000301','2014-01-01','2013-11-24 18:00:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:00:34'),(7208,5712,'Y','18','021','EC','A','','','AC','0000891790','0000891790','OH00000849398','IL','1','JONES','SONYA','','','','34','294649123','4478 W 12TH ST',0,'CLEVELAND','OH','44109','4435','CY','39035','1966-01-31','F','U',':RET:2106-3','N','021','DEN','791322','99734OH005000401','2014-01-01','2013-12-13 23:29:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:50'),(4831,3827,'N','19','021','EC','A',NULL,NULL,'','0000909453','0000078739','','S3','1','Henry','Tracy','rae','','','34','103866386','124 N Main St',0,'Rawson','OH','45881',NULL,'CY','39063','1997-07-03','F','',':RET:2106-3','N','021','HLT','413741','92036OH005001505','2014-01-01','2013-12-08 15:38:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 22:17:21'),(5072,4020,'Y','18','021','EC','A','','','AC','0000637283','0000637283','TX00000655541','IL','1','Silas','Bridgett','','','','34','577820172','12807 Varrientos',0,'San Antonio','TX','78233',NULL,'CY','48029','1962-02-20','F','M',NULL,'N','021','DEN','2476598','33348TX002000201','2014-01-01','2013-12-19 12:58:58','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:00:45'),(8980,7123,'Y','18','021','EC','A','','','AC','0000669171','0000669171','OH00000647744','IL','1','Powell','Daniel','','','','34','289506737','9905 MAIN ST',0,'WAYNESVILLE','OH','45068','9210','CY','39165','1957-07-06','M','U',':RET:2106-3','N','021','DEN','1911417','99734OH005000401','2014-01-01','2013-12-18 15:56:17','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:18'),(21933,17515,'N','19','021','EC','A',NULL,NULL,'','0000560635','0000081095','','IL','1','SOWEMIMO','ASHLEY','','','','34','627425644','5830 COASTAL WAY',0,'HOUSTON','TX','77085','1922','CY','48201','1994-04-08','F','',':RET:2054-5','N','021','DEN','3222083','33348TX002000201','2014-03-01','2014-02-07 10:12:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-07 19:00:12'),(23773,18916,'Y','18','021','EC','A','','','AC','0001119993','0001119993','OH00002239736','IL','1','NEFF','ALYCE','','','','34','217529310','158 LINDEN AVE',0,'WILMINGTON','OH','45177','1917','CY','39027','1949-10-27','F','M',':RET:2106-3','N','021','DEN','3376675','99734OH005000301','2014-03-01','2014-02-14 17:27:54','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-14 21:31:14'),(26918,21334,'Y','18','021','EC','A','','','AC','0001070534','0001070534','OH00002493479','IL','1','Cobb','Jamie','L','','','34','295881008','4756 Clevesdale Drive',0,'Cincinnati','OH','45238',NULL,'CY','39061','1987-02-11','F','U',NULL,'N','021','DEN','3638937','99734OH005000401','2014-04-01','2014-03-01 20:51:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 01:00:14'),(28991,22947,'Y','18','021','EC','A','','','AC','0000837765','0000837765','OH00002998145','IL','1','Townsend','Kimberly','','','','34','300708461','19 ORRVILLE AVE',0,'CUYAHOGA FALLS','OH','44221','1528','CY','39153','1969-04-28','F','U',':RET:2106-3','N','021','HLT','3066396','52664OH151001305','2014-04-01','2014-03-10 17:54:46','216.00',NULL,NULL,'311.54','95.54','R-OH012','OH0','311.54',NULL,0,'2014-03-10 21:01:14'),(29193,23104,'N','01','021','EC','A',NULL,NULL,'','0001282489','0001866031','','IL','1','Osburn','David','M','','','34','435438312','44292 DOC HYDE RD',0,'PONCHATOULA','LA','70454','5657','CY','22105','1972-05-11','M','',':RET:2106-3','N','021','DEN','4204357','18575LA002000201','2014-04-01','2014-03-10 10:56:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-03-10 21:30:06'),(13185,10518,'N','01','021','EC','A',NULL,NULL,'','0000370688','0000490338','','IL','1','Lalime','William','John','','','34','003545985','13410 E CYPRESS FOREST DR',0,'HOUSTON','TX','77070','4009','CY','48201','1959-02-16','M','',':RET:2106-3','N','021','DEN','2280246','33348TX002000101','2014-01-01','2013-12-22 22:54:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 12:54:26'),(9423,7476,'Y','18','021','EC','A','','','AC','0000001105','0000001105','TX00001262612','31','1','CARRIZALES','LISA','','','','34','461678281','P.O. BOX 1104',0,'PORT ISABEL','TX','78578',NULL,'CY','48061','1974-10-24','F','U',NULL,'N','021','DEN','2157459','33348TX002000201','2014-01-01','2013-12-21 16:04:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 04:33:10'),(4665,3698,'Y','18','021','EC','A','','','AC','0000145418','0000145418','LA00000111024','31','1','Washington','Natasha','','','','34','438530816','240 RYAN RD',0,'BENTON','LA','71006','4103','CY','22015','1984-04-02','F','U',':RET:2054-5','N','021','DEN','623458','18575LA002000201','2014-01-01','2013-12-12 12:49:55','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:07:28'),(1826,1497,'Y','18','021','EC','A','','','AC','0000089825','0000089825','OH00001009776','IL','1','Kamper','Mark','R','','','34','292546610','341 S Harefoote Street',0,'Holland','OH','43528',NULL,'CY','39095','1954-06-11','M','U',':RET:2106-3','N','021','HLT','1428402','92036OH005002604','2014-01-01','2013-12-24 14:53:51','333.00',NULL,NULL,'507.58','174.58','R-OH001','OH0','507.58',NULL,0,'2013-12-25 18:57:18'),(26490,21013,'Y','18','024','14','A','','','TE','0002048871','0002048871','','IL','1','BUSSEY','LORNA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-18','F','',NULL,NULL,NULL,'','2234706','','2014-03-31','2014-02-28 15:45:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 21:00:10'),(26710,21173,'N','01','021','EC','A',NULL,NULL,'','0001096815','0000613057','','IL','1','MARSH','JERRY','','','','34','292629128','3638 BLACK JACK TRL',0,'AMELIA','OH','45102','1619','CY','39025','1958-11-13','M','',':RET:2106-3','N','021','HLT','3651849','92036OH003000601','2014-04-01','2014-02-27 21:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','499.92',NULL,0,'2014-02-28 21:31:37'),(27194,21532,'Y','18','024','14','A','','','TE','0000630775','0000630775','','IL','1','Turella','Marcus','John',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-02-18','M','',NULL,NULL,NULL,'','785465','','2014-03-18','2014-03-03 16:18:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-03 21:31:18'),(28220,22329,'Y','18','021','EC','A','','','AC','0000356080','0000356080','OH00003392048','IL','1','Ferguson','Teresa','','','','34','286662595','7913 NATIONAL RD SW',0,'ETNA','OH','43062','8614','CY','39089','1959-12-30','F','M',NULL,'N','021','DEN','3360660','99734OH005000301','2014-04-01','2014-03-06 13:52:48','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00','CIC',0,'2014-03-06 21:30:18'),(19166,15269,'Y','18','021','EC','A','','','AC','0000951477','0000951477','TX00001590108','IL','1','Janak','Laura','','','','34','631143974','740 Rose Street',0,'Albany','TX','76430',NULL,'CY','48417','1984-01-10','F','U',':RET:2106-3','N','021','DEN','2978442','33348TX002000201','2014-03-01','2014-01-19 18:28:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-21 08:46:01'),(608,500,'N','01','021','EC','A',NULL,NULL,'','0001174386','0000373610','','IL','1','ABERA','GETNET','','','','34','300606956','7882 MERDON DR',0,'BLACKLICK','OH','43004','9116','CY','39049','1965-05-20','M','',NULL,'T','021','DEN','2318873','99734OH005000401','2014-01-01','2013-12-16 09:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:00:29'),(4706,3730,'Y','18','021','EC','A','','','AC','0001038579','0001038579','OH00000453607','IL','1','SAW','DANIEL','','','','34','217536124','2912 SQUIRREL BND',0,'TOLEDO','OH','43617','1367','CY','39095','1985-07-20','M','U',NULL,'N','021','HLT','958647','92036OH004002601','2014-01-01','2013-12-12 14:11:36','140.00',NULL,NULL,'170.44','30.44','R-OH001','OH0','170.44',NULL,0,'2013-12-25 22:08:34'),(1068,874,'Y','18','021','EC','A','','','AC','0000610839','0000610839','OH00000303562','IL','1','Bowers','Brian','','','','34','289861399','2792 E RIVER RD',0,'SHEFFIELD LAKE','OH','44054','2704','CY','39093','1979-04-14','M','M',':RET:2106-3','N','021','DEN','1015024','99734OH005000401','2014-01-01','2013-12-03 02:04:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:26'),(15118,12084,'Y','18','021','EC','A','','','AC','0000987412','0000987412','OH00001047631','IL','1','Granneman','Katelyn','','','','34','270947831','2055 NAPOLEON RD',0,'BOWLING GREEN','OH','43402','9151','CY','39173','1985-04-11','F','U',':RET:2106-3','N','021','DEN','1406868','99734OH005000301','2014-02-01','2013-12-30 15:36:19','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-01 12:05:11'),(16843,13474,'Y','18','021','EC','A','','','AC','0000930926','0000930926','OH00001403122','IL','1','bardes','eric','','','','34','312706724','1055 EASTLAND AVE',0,'AKRON','OH','44305','1374','CY','39153','1957-07-01','M','M',':RET:2106-3','N','021','HLT','1625072','52664OH151001501','2014-02-01','2014-01-11 10:07:43','0.00',NULL,NULL,'624.00','624.00','R-OH012','OH0','624.00',NULL,0,'2014-01-13 02:18:34'),(20969,16756,'Y','18','021','EC','A','','','AC','0000968499','0000968499','TX00001474411','IL','1','de leon','maria','','','','34','459551480','1419 N UVALDE ST',0,'ALTON','TX','78573','5804','CY','48215','1970-12-07','F','M',':RET:2106-3','N','021','DEN','3162160','33348TX002000201','2014-03-01','2014-02-01 14:03:21','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-01 19:00:13'),(24380,19365,'N','01','021','EC','A',NULL,NULL,'','0000956699','0000984900','','IL','1','Harris','Nathan','Lamar','','','34','301864144','6331 STRATHAVEN DR',0,'WEST CHESTER','OH','45069','6643','CY','39017','1980-09-17','M','',':RET:2054-5','N','021','DEN','3784044','99734OH005000401','2014-04-01','2014-02-18 08:53:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:44'),(26668,21142,'Y','18','021','EC','A','','','AC','0002168381','0002168381','LA00003075130','IL','1','Stewart','Amanda','','','','34','437795579','4101 Delaware ave',0,'kenner','LA','70065',NULL,'CY','22051','1990-08-27','F','U',':RET:2106-3','N','021','DEN','3847568','18575LA002000201','2014-04-01','2014-02-27 23:48:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:16'),(17425,13943,'N','01','021','EC','A',NULL,NULL,'','0001145991','0000047106','','IL','1','pitz','joyce','e','','','34','294563290','535 northeast ave',0,'tallmadge','OH','44278',NULL,'CY','39153','1964-02-17','F','',':RET:2106-3','N','021','HLT','1782251','52664OH151001306','2014-02-01','2014-01-10 09:31:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45',NULL,0,'2014-01-13 03:00:28'),(17094,13680,'N','01','021','EC','A',NULL,NULL,'','0000407940','0000585608','','IL','1','MENDOZA ARREDONDO','Ma LETICIA','','','','34','628785568','1403 CAMP CRAFT RD  APT C',0,'AUSTIN','TX','78746',NULL,'CY','48453','1961-09-21','F','',NULL,'N','021','DEN','1633872','33348TX002000201','2014-02-01','2014-01-08 15:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:29'),(6607,5240,'Y','18','021','EC','A','','','AC','0000380027','0000380027','OH00001195283','IL','1','Clark','Jeffrey','','','','34','292760461','9217 PITSBURG LAURA RD',0,'ARCANUM','OH','45304','9627','CY','39037','1965-10-27','M','M',':RET:2106-3','N','021','HLT','677107','92036OH003000501','2014-01-01','2013-12-11 10:33:49','500.00',NULL,NULL,'1026.45','526.45','R-OH003','OH0','405.87',NULL,0,'2013-12-26 00:53:41'),(17053,13646,'Y','18','021','EC','A','','','AC','0000843352','0000843352','OH00001710333','IL','1','BROMLEY-KWORTEK','CAROL','','','','34','280505157','1105 KENMORE AVE SE',0,'WARREN','OH','44484','4355','CY','39155','1950-12-18','F','U',':RET:2106-3','N','021','HLT','2225916','92036OH005003204','2014-02-01','2014-01-09 11:16:59','532.00',NULL,NULL,'714.53','182.53','R-OH013','OH0','714.53',NULL,0,'2014-01-13 02:20:59'),(16184,12957,'Y','18','021','EC','A','','','AC','0000416797','0000416797','TX00001299265','IL','1','Miller','Justine','','','','34','280505686','20423 Hidden Point Ln',0,'Richmond','TX','77407',NULL,'CY','48157','1949-09-06','F','U',':RET:2106-3','N','021','DEN','1806329','33348TX002000201','2014-02-01','2014-01-03 20:16:01','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-05 00:00:37'),(21163,16912,'Y','18','021','EC','A','','','AC','0001187676','0001187676','OH00002176586','IL','1','Seifert','Peggy','','','','34','402887521','6092 Pinecreek St. NW',0,'North Canton','OH','44720',NULL,'CY','39151','1957-10-12','F','U',':RET:2106-3','T','021','DEN','2638809','99734OH005000401','2014-03-01','2014-02-03 11:04:21','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-03 21:00:34'),(21816,17421,'Y','18','021','EC','A','','','AC','0001208346','0001208346','OH00001707135','IL','1','Papczun','ron','','','','34','278660001','890 TALLMADGE RD',0,'KENT','OH','44240','7360','CY','39133','1966-12-20','M','U',':RET:2106-3','N','021','HLT','2784034','52664OH151001306','2014-03-01','2014-02-06 14:07:05','283.00',NULL,NULL,'348.56','65.56','R-OH012','OH0','348.56',NULL,0,'2014-02-06 21:00:56'),(25096,19905,'Y','18','021','EC','A','','','AC','0001046892','0001046892','OH00002827846','IL','1','martin','regina','','','','34','271582471','2911 WHITNEY LN',0,'FAIRFIELD','OH','45014','5133','CY','39017','1955-03-14','F','U',NULL,'N','021','DEN','3682414','99734OH005000401','2014-04-01','2014-02-21 15:06:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-21 21:30:07'),(26241,20812,'Y','18','024','14','A','','','TE','0001246738','0001246738','','IL','1','FLORES','FRANKIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-09-12','M','',NULL,NULL,NULL,'','2625358','','2014-02-27','2014-02-27 10:54:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:05'),(27477,21743,'Y','18','021','EC','A','','','AC','0000703878','0000703878','TX00003238190','IL','1','Schollian','Melissa','Kay','','','34','452858008','1400 West Valley Ridge Blvd',0,'Lewisville','TX','75077',NULL,'CY','48121','1984-01-03','F','U',':RET:2106-3','N','021','DEN','3554084','33348TX002000101','2014-04-01','2014-03-03 23:04:12','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-04 21:02:14'),(27565,21802,'N','19','021','EC','A',NULL,NULL,'','0000346947','0001147402','','IL','1','Landow','Joseph','','','','34','668078249','3319 BRAEMAR RD',0,'SHAKER HEIGHTS','OH','44120','3331','CY','39035','1999-09-11','M','',':RET:2106-3','N','021','DEN','3460948','99734OH005000301','2014-04-01','2014-03-04 12:53:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:18'),(206,171,'Y','18','024','14','A','','','TE','0000219950','0000219950','','IL','1','Solomon','Gary','Alan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-15','M','',NULL,NULL,NULL,'','682864','','2013-12-05','2013-12-05 14:18:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:20:20'),(18145,14490,'Y','18','021','EC','A','','','AC','0001388514','0001388514','LA00002252956','IL','1','Templeman','Theresa','','','','34','436904458','402 Little Choupic Rd.',0,'Thibodaux','LA','70301',NULL,'CY','22057','1960-09-06','F','U',':RET:2106-3','N','021','DEN','2531799','18575LA002000101','2014-02-01','2014-01-14 15:53:43','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-15 02:07:48'),(14054,11198,'Y','18','021','EC','A','','','AC','0001086792','0001086792','OH00000904194','IL','1','DEMITRY','ANGIE','','','','34','291747243','1019 SCOTT ST',0,'MAUMEE','OH','43537','3141','CY','39095','1974-01-01','F','M',NULL,'N','021','DEN','2181066','99734OH005000301','2014-02-01','2013-12-26 15:53:19','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-27 02:00:23'),(1228,1011,'Y','18','021','EC','A','','','AC','0000486921','0000486921','OH00001095798','IL','1','YOUNG','DEBOHRA','LEE','','','34','272561210','4380 EGYPT RD',0,'SMITHVILLE','OH','44677','9530','CY','39169','1953-11-13','F','U',':RET:2106-3','N','021','HLT','56240','52664OH151001306','2014-01-01','2013-12-03 12:03:13','515.00',NULL,NULL,'605.24','90.24','R-OH014','OH0','605.24',NULL,0,'2013-12-25 18:20:37'),(2886,2332,'N','19','021','EC','A',NULL,NULL,'','0001241833','0000182264','','IL','1','domer','melissa','r','','','34','284946414','2965 SMITH KRAMER ST NE',0,'HARTVILLE','OH','44632','9706','CY','39151','1989-09-30','F','',':RET:2106-3','N','021','HLT','1087758','52664OH151001501','2014-01-01','2013-12-05 19:02:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2013-12-25 20:15:04'),(9383,7441,'Y','18','021','EC','A','','','AC','0000144455','0000144455','TX00001113678','IL','1','PARTIDA','JOSE','LUIS','','','34','549130684','4748 ALGIERS ST',0,'DALLAS','TX','75207','5500','CY','48113','1957-11-19','M','U',NULL,'N','021','DEN','1796916','33348TX002000201','2014-01-01','2013-12-20 19:14:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:32:09'),(9191,7289,'Y','18','021','EC','A','','','AC','0000079899','0000079899','OH00000788394','IL','1','Payne','Justin','','','','34','290785901','203.5 N Main St',0,'Bowling Green','OH','43402',NULL,'CY','39173','1981-05-03','M','U',':RET:2106-3','T','021','HLT','1710305','92036OH006002601','2014-01-01','2013-12-18 10:03:49','123.00',NULL,NULL,'210.39','87.39','R-OH001','OH0','210.39',NULL,0,'2013-12-26 04:09:23'),(21296,17017,'Y','18','021','EC','A','','','AC','0001838730','0001838730','LA00002388819','IL','1','Cannon','Carolyn','','','','34','461969594','134 Turtledove Drive',0,'Monroe','LA','71203',NULL,'CY','22073','1951-12-20','F','M',':RET:2106-3','N','021','DEN','3491917','18575LA002000101','2014-03-01','2014-02-04 15:46:36','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-04 21:00:09'),(21956,17533,'Y','18','021','EC','A','','','AC','0001181059','0001181059','OH00001951791','IL','1','WILSON','GREGORY','','','','34','268484762','5010 KEY WEST DR',0,'DAYTON','OH','45424','5925','CY','39113','1950-12-14','M','M',':RET:2106-3','N','021','DEN','3556736','99734OH005000401','2014-03-01','2014-02-07 09:35:22','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-07 19:00:23'),(24599,19527,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000840579','','IL','1','Sexton','Lola','Avery','','','34','298130362','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2008-05-12','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:12:37'),(26875,21300,'Y','18','021','EC','A','','','AC','0000485910','0000485910','OH00002972570','IL','1','Lai','Yu','','','','34','283067385','2686 Pine Run',0,'Lima','OH','45801',NULL,'CY','39003','1975-12-05','F','M',':RET:2034-7^:RET:2028-9','N','021','HLT','3206004','92036OH005001505','2014-04-01','2014-02-28 21:43:25','434.00',NULL,NULL,'560.79','126.79','R-OH002','OH0','274.24',NULL,0,'2014-03-01 21:01:05'),(27420,21699,'Y','18','021','EC','A','','','AC','0001390925','0001390925','LA00003680179','IL','1','mejia','angelica','','','','34','436657202','701 lafayette st',0,'gretna','LA','70053',NULL,'CY','22051','1987-01-06','F','U',':RET:2054-5','N','021','DEN','3597822','18575LA002000201','2014-04-01','2014-03-03 18:29:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:38'),(18682,14893,'Y','18','021','EC','A','','','AC','0001054870','0001054870','TX00001770861','IL','1','Landry','Lindsay','','','','34','642057594','4711 AVENUE R',0,'GALVESTON','TX','77551','5274','CY','48167','1988-12-04','F','U',':RET:2106-3','N','021','DEN','1661281','33348TX002000201','2014-02-01','2014-01-15 20:27:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-17 03:35:20'),(17981,14368,'Y','18','021','EC','A','','','AC','0001056720','0001056720','OH00001540555','IL','1','Howatt','Valerie','','','','34','298882028','3191 OLD MILL RD',0,'HUDSON','OH','44236','1570','CY','39153','1984-11-19','F','U',':RET:2106-3','N','021','HLT','2246211','52664OH151001304','2014-02-01','2014-01-14 15:52:10','97.00',NULL,NULL,'249.55','152.55','R-OH012','OH0','249.55',NULL,0,'2014-01-15 02:06:53'),(16780,13422,'Y','18','021','EC','A','','','AC','0000168906','0000168906','OH00002261123','IL','1','Franz','Brent','','','','34','335787065','117 S Enterprise St',0,'Celina','OH','45822',NULL,'CY','39107','1981-10-12','M','U',':RET:2106-3','N','021','HLT','2301124','92036OH003001505','2014-02-01','2014-01-07 11:52:50','150.00',NULL,NULL,'271.90','121.90','R-OH002','OH0','271.90',NULL,0,'2014-01-08 18:25:05'),(15188,12137,'Y','18','024','14','A','','','TE','0000432769','0000432769','','IL','1','Quinter','Alicia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-15','F','',NULL,NULL,NULL,'','2283419','','2013-12-29','2013-12-29 22:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:07:02'),(4086,3264,'Y','18','021','EC','A','','','AC','0000293171','0000293171','OH00000939090','IL','1','Cron','Karen','','','','34','284885450','4264 COUNTY ROAD T',0,'LIBERTY CENTER','OH','43532','9524','CY','39069','1987-12-08','F','U',':RET:2106-3','N','021','HLT','1468496','92036OH005002606','2014-01-01','2013-12-16 18:46:55','159.00',NULL,NULL,'199.67','40.67','R-OH001','OH0','199.67',NULL,0,'2013-12-25 21:47:18'),(21303,17022,'Y','18','021','EC','A','','','AC','0001967160','0001967160','LA00001371014','IL','1','Edwards','Andrew','','','','34','352720315','124 DARTEZE DR',0,'LAFAYETTE','LA','70508','8111','CY','22055','1983-08-10','M','U',':RET:2106-3','N','021','DEN','3695522','18575LA002000201','2014-03-01','2014-02-03 21:49:48','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-04 21:00:13'),(21827,17429,'Y','18','021','EC','A','','','AC','0001023425','0001023425','TX00001790259','IL','1','Burney','Belinda','G','','','34','454311351','4310 SENECA ST',0,'PASADENA','TX','77504','3511','CY','48201','1959-10-01','F','M',NULL,'N','021','DEN','2617329','33348TX002000101','2014-03-01','2014-02-06 13:47:46','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-06 21:01:02'),(19300,15385,'Y','18','021','EC','A','','','AC','0001573482','0001573482','LA00001972457','IL','1','Edie','Amy','','','','34','433453553','9100 Walker Rd',0,'Shreveport','LA','71118',NULL,'CY','22017','1975-02-17','F','U',NULL,'N','021','DEN','2877759','18575LA002000101','2014-03-01','2014-01-21 00:15:24','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-22 03:22:00'),(18208,14532,'Y','18','021','EC','A','','','AC','0000382184','0000382184','OH00001873939','IL','1','Coon','bryan','','','','34','290563137','7938 Runkle Road',0,'Saint Paris','OH','43072',NULL,'CY','39021','1961-04-24','M','U',':RET:2106-3','N','021','HLT','2800704','92036OH005000505','2014-02-01','2014-01-14 14:26:08','369.00',NULL,NULL,'464.00','95.00','R-OH003','OH0','464.00',NULL,0,'2014-01-15 02:08:08'),(16302,13051,'N','01','021','EC','A',NULL,NULL,'','0001503374','0001890795','','IL','1','Palmisano','Erica','Emily','','','34','438536376','103 FIELD ST',0,'BELLE CHASSE','LA','70037','1249','CY','22075','1984-02-12','F','',':RET:2106-3','N','021','DEN','1619247','18575LA002000201','2014-02-01','2014-01-06 18:06:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:10'),(1991,1630,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000894505','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','870713','33348TX002000101','2014-01-01','2013-11-19 23:06:18','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:57'),(15933,12756,'Y','18','021','EC','A','','','AC','0000031948','0000031948','OH00002125269','IL','1','bower','theodore','','','','34','282920172','814 TOD AVE NW',0,'WARREN','OH','44485','2824','CY','39155','1985-09-26','M','R',':RET:2106-3','N','021','HLT','2241997','52664OH152001001','2014-02-01','2014-01-01 20:14:52','0.00',NULL,NULL,'151.13','151.13','R-OH013','OH0','151.13',NULL,0,'2014-01-03 02:06:58'),(14660,11702,'Y','18','021','EC','A','','','AC','0000955127','0000955127','TX00001306999','IL','1','Chacon','Jasmine','','','','34','640103666','243 holycross',0,'El Paso','TX','79928',NULL,'CY','48141','1988-06-17','F','M',NULL,'N','021','DEN','2300887','33348TX002000201','2014-02-01','2013-12-27 23:05:47','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:07:57'),(15187,12136,'Y','18','021','EC','A','','','AC','0000432769','0000432769','OH00000210752','IL','1','Quinter','Alicia','','','','34','274789959','440 Touvelle St',0,'Celina','OH','45822',NULL,'CY','39107','1980-09-15','F','U',':RET:2106-3','N','021','HLT','2283419','92036OH005001506','2014-02-01','2013-12-29 21:24:45','243.00',NULL,NULL,'263.65','20.65','R-OH002','OH0','263.65',NULL,0,'2014-01-01 12:07:00'),(21676,17309,'N','01','021','EC','A',NULL,NULL,'','0001725426','0001929127','','IL','1','DINH','VINHHAO','THI','','','34','434835971','729 WILLOWBROOK DR',0,'GRETNA','LA','70056','7927','CY','22051','1957-05-13','F','',NULL,'N','021','DEN','3407952','18575LA002000201','2014-03-01','2014-02-05 16:29:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:31:00'),(27184,21523,'Y','18','024','14','A','','','TE','0001124842','0001124842','','IL','1','Romo','Misty',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-11-08','F','',NULL,NULL,NULL,'','3116998','','2014-03-18','2014-03-03 14:37:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-03 21:31:12'),(27802,21991,'Y','18','021','EC','A','','','AC','0000930979','0000930979','OH00003537842','IL','1','MILLER','JIM','','','','34','290546901','15200 S DEEPWOOD LN',0,'CHAGRIN FALLS','OH','44022','2642','CY','39055','1954-07-02','M','M',NULL,'N','021','HLT','4107626','52664OH151001305','2014-04-01','2014-03-05 12:04:29','736.00',NULL,NULL,'1145.67','409.67','R-OH011','OH0','654.70',NULL,0,'2014-03-05 21:31:47'),(22464,17936,'Y','18','021','EC','A','','','AC','0000100964','0000100964','TX00002201500','IL','1','Granoff','Harry','','','','34','061443497','49 Masland Circle',0,'Dallas','TX','75230',NULL,'CY','48113','1952-07-24','M','U',NULL,'N','021','DEN','3320572','33348TX002000201','2014-03-01','2014-02-10 18:19:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:54'),(22626,18068,'Y','18','021','EC','A','','','AC','0001027042','0001027042','TX00002371263','IL','1','Johnson','Marcus','','','','34','449233180','9815 GRANITEVILLE DR',0,'HOUSTON','TX','77078','2946','CY','48201','1971-12-20','M','M',':RET:2054-5','N','021','DEN','2744311','33348TX002000201','2014-03-01','2014-02-10 21:32:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:14'),(1442,1203,'Y','18','021','EC','A','','','AC','0000168895','0000168895','OH00000145490','IL','1','Johnson','William','','','','34','283668931','520 SCHELL RD',0,'WILMINGTON','OH','45177','9425','CY','39027','1958-08-21','M','M',':RET:2106-3','T','021','HLT','1359942','92036OH003000605','2014-01-01','2013-12-24 11:15:22','739.00',NULL,NULL,'1014.74','275.74','R-OH005','OH0','574.91',NULL,0,'2013-12-25 18:47:53'),(19075,15197,'Y','18','021','EC','A','','','AC','0002020248','0002020248','LA00002329232','IL','1','JENKINS','ROSIE','','','','34','434250888','1707 MEDRA DR',0,'MONROE','LA','71202',NULL,'CY','22073','1965-09-01','F','M',':RET:2054-5','N','021','DEN','2418491','18575LA002000101','2014-03-01','2014-01-17 22:06:48','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2014-01-21 08:44:23'),(17616,14082,'Y','18','021','EC','A','','','AC','0000307768','0000307768','TX00001396446','IL','1','Reynolds','Lee','P','','','34','641093725','7901 SOUTHWEST PKWY',0,'AUSTIN','TX','78735','8950','CY','48453','1988-02-07','M','U',':RET:2106-3','N','021','DEN','1548220','33348TX002000201','2014-02-01','2014-01-13 11:37:15','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:24'),(17555,14036,'Y','18','021','EC','A','','','AC','0000175074','0000175074','TX00002282542','IL','1','Robinson','Bruce','','','','34','544827187','2601 Scofield Ridge Pkwy',0,'Austin','TX','78727',NULL,'CY','48453','1959-03-01','M','U',':RET:2106-3','N','021','DEN','1740336','33348TX002000101','2014-02-01','2014-01-12 14:33:37','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-13 03:01:57'),(2321,1887,'Y','18','024','14','A','','','TE','0000914738','0000914738','','IL','1','Witt','Cody',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-12','M','',NULL,NULL,NULL,'','493429','','2013-12-09','2013-12-09 07:38:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:31:25'),(23037,18366,'Y','18','024','14','A','','','TE','0000925282','0000925282','','IL','1','NGUYEN','TRUNG','VAN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-24','M','',NULL,NULL,NULL,'','3083989','','2014-02-12','2014-02-12 17:19:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-12 21:30:38'),(24080,19148,'N','01','021','EC','A',NULL,NULL,'','0000652179','0000521998','','IL','1','Mahlendorf','Mary','','','','34','279545465','6351 Grove Road',0,'Clinton','OH','44216',NULL,'CY','39153','1954-07-29','F','',':RET:2106-3','N','021','HLT','2927654','52664OH151001304','2014-03-01','2014-02-15 12:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2014-02-15 22:01:21'),(24873,19721,'Y','18','024','14','A','','','TE','0000830627','0000830627','','IL','1','Hurst','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-18','M','',NULL,NULL,NULL,'','1744409','','2014-03-31','2014-02-19 11:20:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:33:50'),(26334,20893,'Y','18','021','EC','A','','','AC','0000870617','0000870617','OH00002988253','IL','1','Walker','David','','','','34','372681830','19533 Williams Rd',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1961-11-02','M','U',NULL,'T','021','HLT','3042100','92036OH003001505','2014-04-01','2014-02-27 10:44:30','386.00',NULL,NULL,'515.93','129.93','R-OH002','OH0','515.93',NULL,0,'2014-02-28 06:31:41'),(26883,21306,'Y','18','024','14','A','','','TE','0000798422','0000798422','','IL','1','HE','LIFEM',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-10-17','F','',NULL,NULL,NULL,'','2485977','','2014-03-16','2014-03-01 14:24:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-01 21:01:10'),(27130,21477,'Y','18','021','EC','A','','','AC','0001175767','0001175767','OH00002433336','IL','1','Roberson','Cynthia','','','','34','490562623','274 HILLIARD ROME RD',0,'COLUMBUS','OH','43228','1125','CY','39049','1949-12-17','F','U',':RET:2054-5','N','021','DEN','3487399','99734OH005000401','2014-04-01','2014-03-02 19:17:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:39'),(28189,22306,'Y','18','024','14','A','','','TE','0000575588','0000575588','','IL','1','Ollie','Folser',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-03','M','',NULL,NULL,NULL,'','3522051','','2014-03-05','2014-03-05 18:19:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCELCIC',0,'2014-03-06 21:30:03'),(15448,12361,'N','01','021','EC','A',NULL,NULL,'','0001197726','0000166523','','IL','1','Brown','Cynthia','D','','','34','461492457','462 County Road 44060',0,'Powderly','TX','75473',NULL,'CY','48277','1964-07-19','F','',':RET:2106-3','N','021','DEN','1516155','33348TX002000201','2014-02-01','2013-12-31 15:05:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:28:16'),(4841,3835,'Y','18','021','EC','A','','','AC','0000722605','0000722605','OH00000057245','IL','1','Burke','Michael','','','','34','269903112','3922 Northshore',0,'Akron','OH','44333',NULL,'CY','39153','1980-06-06','M','U',NULL,'T','021','HLT','1053496','52664OH152000901','2014-01-01','2013-11-08 10:57:25','0.00',NULL,NULL,'225.03','225.03','R-OH012','OH0','225.03',NULL,0,'2013-12-25 22:30:07'),(13119,10463,'Y','18','021','EC','A','','','AC','0000098996','0000098996','OH00000398595','IL','1','Boyd','Virginia','','','','34','290788613','8846 GREENBURG DR',0,'POWELL','OH','43065','9214','CY','39049','1976-03-31','F','M',':RET:2106-3','N','021','DEN','1840593','99734OH005000401','2014-01-01','2013-12-23 14:01:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:52:42'),(6935,5506,'Y','18','021','EC','A','','','AC','0000160796','0000160796','OH00001201233','IL','1','McNairl','Rayna','','','','34','415698513','3019 DUNSTON LN',0,'DAYTON','OH','45424','5070','CY','39113','1991-11-09','F','R',':RET:2054-5','N','021','DEN','1858869','99734OH005000401','2014-01-01','2013-12-24 20:10:10','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:46:38'),(7761,6148,'Y','18','021','EC','A','','','AC','0001219585','0001219585','OH00001308728','IL','1','Blevins','Ossie','','','','34','422709734','6521 Elwynne Dr',0,'Cincinnati','OH','45236',NULL,'CY','39061','1950-08-31','M','M',':RET:2054-5','N','021','DEN','2022030','99734OH005000401','2014-01-01','2013-12-20 18:41:52','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:02:46'),(8859,7023,'Y','18','021','EC','A','','','AC','0001039031','0001039031','TX00000802674','IL','1','FERNANDEZ','VIRGINIA','','','','34','450552788','2411 47TH ST',0,'LUBBOCK','TX','79412','2107','CY','48303','1977-12-20','F','U',NULL,'N','021','DEN','2396480','33348TX002000201','2014-01-01','2013-12-18 10:49:33','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 04:01:13'),(21740,17359,'Y','18','021','EC','A','','','AC','0000545245','0000545245','TX00002588597','IL','1','Truesdale','Maxine','','','','34','460113275','1301 SOUTH ST',0,'SCHULENBURG','TX','78956','2224','CY','48149','1969-04-18','F','U',':RET:2054-5','N','021','DEN','3304825','33348TX002000201','2014-03-01','2014-02-06 17:52:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:15'),(22970,18315,'Y','18','024','14','A','','','TE','0000776470','0000776470','','IL','1','Kopac','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-25','M','',NULL,NULL,NULL,'','3157833','','2014-02-28','2014-02-12 17:22:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-12 21:00:16'),(24169,19201,'Y','18','021','EC','A','','','AC','0000586841','0000586841','MS00002623875','IL','1','Day','Calvin','','','','34','427135479','5741 BEECHCREST CT',0,'JACKSON','MS','39211','3405','CY','28049','1961-10-18','M','M',':RET:2054-5','N','021','DEN','3265815','46300MS002000101','2014-03-01','2014-02-15 12:35:42','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-15 22:02:07'),(24502,19465,'Y','18','021','EC','A','','','AC','0000344040','0000344040','TX00002563778','IL','1','Ramirez','Ricardo','','','','34','454815649','321 CIRUELA LN',0,'BROWNSVILLE','TX','78521','7368','CY','48061','1974-10-31','M','M',NULL,'N','021','DEN','2800017','33348TX002000201','2014-04-01','2014-02-18 22:42:01','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-02-20 03:49:29'),(26385,20931,'Y','18','021','EC','A','','','AC','0000194050','0000194050','OH00003207549','IL','1','Taylor','Kathleen','','','','34','277801472','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1981-07-24','F','M',':RET:2106-3','N','021','HLT','3232398','52664OH151001301','2014-03-01','2014-02-26 11:42:57','0.00',NULL,NULL,'658.54','658.54','R-OH012','OH0','263.82','CIC',0,'2014-02-28 07:00:23'),(17844,14254,'Y','18','021','EC','A','','','AC','0000243760','0000243760','OH00001584110','IL','1','Williams','Carla','','','','34','079624523','3216 GALLANT DR',0,'COLUMBUS','OH','43232','7445','CY','39049','1975-10-18','F','U',NULL,'N','021','DEN','1605989','99734OH005000401','2014-02-01','2014-01-13 22:57:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:04'),(15695,12556,'Y','18','021','EC','A','','','AC','0000285651','0000285651','OH00001914356','IL','1','Penhorwood','Patti','','','','34','273741282','4245 PICKLE RD',0,'OREGON','OH','43616','5716','CY','39095','1965-01-22','F','M',':RET:2106-3','T','021','HLT','1894461','92036OH002002601','2014-02-01','2013-12-31 17:50:49','0.00',NULL,NULL,'441.80','441.80','R-OH001','OH0','441.80',NULL,1,'2014-01-02 04:35:30'),(329,271,'Y','18','021','EC','A','','','AC','0000116558','0000116558','OH00001234810','IL','1','Covert','Harry','Michael','','','34','274602791','5655 QUAIL HOLLOW WAY',0,'WESTERVILLE','OH','43082','8182','CY','39041','1955-12-21','M','U',NULL,'N','021','DEN','409256','99734OH005000401','2014-01-01','2013-10-11 10:01:23','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:31:38'),(14760,11785,'Y','18','021','EC','A','','','AC','0001253044','0001253044','TX00001115413','IL','1','Mckenzie','William','','','','34','465040778','4854 STARCREST CT',0,'FORT WORTH','TX','76132','2346','CY','48439','1953-06-25','M','U',':RET:2106-3','N','021','DEN','1606935','33348TX002000201','2014-01-01','2013-12-23 20:03:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2013-12-29 11:12:40'),(14652,11695,'Y','18','021','EC','A','','','AC','0000863019','0000863019','TX00000756158','IL','1','Acebo','Bysmark','A','','','34','637014518','20023 SKY HOLLOW LN',0,'KATY','TX','77450','5219','CY','48201','1955-05-17','M','M',':RET:2106-3','N','021','DEN','1543700','33348TX002000201','2014-02-01','2013-12-27 20:24:42','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,1,'2013-12-29 11:07:47'),(5108,4047,'N','01','021','EC','A',NULL,NULL,'','0000950081','0000959851','','IL','1','Rodriguez','Claudia','','','','34','632288751','7129 Orange Tree Lane',0,'El Paso','TX','79915',NULL,'CY','48141','1976-10-28','F','',':RET:2036-2','N','021','DEN','2452802','33348TX002000201','2014-01-01','2013-12-19 17:30:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:37'),(7454,5899,'N','19','021','EC','A',NULL,NULL,'','0000896969','0000124190','','IL','1','KOPPEL','MATEO','ODELL','','','34','292063432','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','2001-12-29','M','',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:30:45'),(18635,14854,'Y','18','021','EC','A','','','AC','0000139461','0000139461','TX00002511027','IL','1','Gonzales','Steven','','','','34','452879190','306 ELBERT LN',0,'HARKER HEIGHTS','TX','76548','1936','CY','48027','1986-09-17','M','M',':RET:2106-3','N','021','DEN','2632239','33348TX002000201','2014-02-01','2014-01-15 22:01:00','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-17 03:35:03'),(18472,14736,'N','01','021','EC','A',NULL,NULL,'','0000930930','0000053078','','IL','1','Trump','Timothy','','','','34','275728158','112 Emerald Avenue',0,'Streetsboro','OH','44241',NULL,'CY','39133','1962-02-28','M','',NULL,'N','021','HLT','2648242','52664OH151001304','2014-02-01','2014-01-14 20:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2014-01-16 08:46:17'),(5936,4700,'Y','18','021','EC','A','','','AC','0001344218','0001344218','LA00001021473','IL','1','Valentine','Eugenia','','','','34','456114165','1001 URSULINES AVE',0,'NEW ORLEANS','LA','70116','2413','CY','22071','1967-04-15','F','U',NULL,'N','021','DEN','2585328','18575LA002000101','2014-01-01','2013-12-23 22:20:44','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:50:40'),(1799,1478,'Y','18','021','EC','A','','','AC','0000199663','0000199663','OH00000203001','IL','1','Unger','John','','','III','34','312607403','2730 RED FOX',0,'DUNCAN FALLS','OH','43734','9740','CY','39119','1952-11-03','M','M',':RET:2106-3','N','021','DEN','2034345','99734OH005000301','2014-01-01','2013-12-24 18:11:36','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:56:43'),(18471,14736,'N','19','021','EC','A',NULL,NULL,'','0000930930','0001163863','','S1','1','Trump','Timothy','','','','34','286062600','112 Emerald Avenue',0,'Streetsboro','OH','44241',NULL,'CY','39133','2001-08-12','M','',NULL,'N','021','HLT','2648242','52664OH151001304','2014-02-01','2014-01-14 20:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-16 08:46:17'),(2712,2194,'Y','18','021','EC','A','','','AC','0000909448','0000909448','OH00000114428','IL','1','Korber','John','Robert','','Jr','34','276661456','544 Bayfair Dr',0,'Bay Village','OH','44140',NULL,'CY','39035','1965-11-12','M','M',':RET:2106-3','N','021','HLT','388920','52664OH151001501','2014-01-01','2013-12-02 13:32:17','141.19',NULL,NULL,'684.77','543.58','R-OH011','OH0','493.22',NULL,0,'2013-12-25 19:48:00'),(2351,1916,'Y','18','021','EC','A','','','AC','0000560359','0000560359','TX00000383594','IL','1','Alridge','Gabriel','','','','34','633166814','2924 BARNES BRIDGE RD',0,'DALLAS','TX','75228','2308','CY','48113','1990-05-16','F','U',':RET:2054-5','N','021','DEN','6541','33348TX002000201','2014-01-01','2013-12-09 16:36:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:32:14'),(7290,5778,'N','19','021','EC','A',NULL,NULL,'','0000998761','0000789653','','IL','1','Rogers','Heather',NULL,NULL,NULL,NULL,NULL,'10016 HOMESTEAD RD',0,'WADSWORTH','OH','44281','9033','CY','39103','1997-04-26','F','',NULL,'N','021','HLT','980982','52664OH151001501','2014-01-01','2013-12-14 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 02:02:52'),(14302,11409,'Y','18','021','EC','A','','','AC','0000444874','0000444874','OH00000681460','IL','1','SHANNON','FRANCINE','','','','34','384748738','120.5  EAST SAN DUSKY ST',0,'FINDLAY','OH','45840',NULL,'CY','39063','1961-10-19','F','U',':RET:2054-5','T','021','HLT','1886116','92036OH006001501','2014-02-01','2013-12-26 10:34:57','388.94',NULL,NULL,'391.80','2.86','R-OH002','OH0','391.80',NULL,0,'2013-12-27 02:06:52'),(13516,10774,'Y','18','024','14','A','','','TE','0000334350','0000334350','','IL','1','Teer','Miki','Elizabeth',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-05','F','',NULL,NULL,NULL,'','146745','','2013-12-23','2013-12-23 00:16:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:03:05'),(14003,11156,'Y','18','021','EC','A','','','AC','0000183499','0000183499','OH00000473427','IL','1','Tarpley','Ryan','','','','34','281884799','5274 PITCAIRN RD',0,'HUBER HEIGHTS','OH','45424','5834','CY','39113','1981-10-21','M','U',':RET:2106-3','N','021','HLT','1672574','92036OH004000501','2014-01-01','2013-12-23 08:56:42','89.00',NULL,NULL,'226.12','137.12','R-OH003','OH0','226.12',NULL,0,'2013-12-26 13:16:08'),(23626,18814,'Y','18','021','EC','A','','','AC','0000235254','0000235254','OH00002528733','IL','1','Burden','Hellen','','','','34','280585421','1032 Nimitz Lane',0,'Cincinnati','OH','45230',NULL,'CY','39061','1955-04-05','F','U',NULL,'N','021','HLT','3149138','92036OH005001205','2014-03-01','2014-02-13 17:02:58','390.00',NULL,NULL,'546.97','156.97','R-OH004','OH0','546.97',NULL,0,'2014-02-13 22:03:20'),(24997,19825,'Y','18','021','EC','A','','','AC','0000093699','0000093699','TX00002861676','IL','1','Rettinger','Richard','','','','34','443601503','26434 OLD LAAKE LN',0,'NEW ULM','TX','78950','4849','CY','48015','1954-11-13','M','M',':RET:2106-3','N','021','DEN','2757689','33348TX002000201','2014-04-01','2014-02-20 16:11:27','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:43'),(585,480,'Y','18','021','EC','A','','','AC','0000264169','0000264169','OH00000068552','IL','1','Howard','Aundre','','','','34','276805489','3911 Orchard Road',0,'Cleveland Heights','OH','44118',NULL,'CY','39035','1969-02-06','M','U',':RET:2054-5','N','021','HLT','882431','92036OH003000801','2014-01-01','2013-12-04 11:32:08','0.00',NULL,NULL,'341.09','341.09','R-OH011','OH0','341.09',NULL,0,'2013-12-25 17:51:02'),(21696,17324,'Y','18','021','EC','A','','','AC','0001170871','0001170871','OH00001930349','IL','1','Smith','Susan','','','','34','288508649','1611 OAKWOOD AVE',0,'AKRON','OH','44301','2745','CY','39153','1949-06-05','F','U',':RET:2106-3','T','021','HLT','3621736','52664OH152000901','2014-03-01','2014-02-05 15:28:15','517.00',NULL,NULL,'563.50','46.50','R-OH012','OH0','563.50',NULL,0,'2014-02-05 21:31:08'),(6218,4928,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000926693','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','831734','92036OH006002601','2014-01-01','2013-10-15 22:03:14','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-26 00:31:04'),(5259,4171,'Y','18','021','EC','A','','','AC','0000109269','0000109269','OH00001036456','IL','1','Allshouse','Jamie','','','','34','280689387','1560 BEALL AVE',0,'WOOSTER','OH','44691','2376','CY','39169','1963-05-28','F','U',NULL,'T','021','HLT','2404733','52664OH151001301','2014-01-01','2013-12-19 10:58:14','152.00',NULL,NULL,'458.04','306.04','R-OH014','OH0','458.04',NULL,0,'2013-12-25 23:05:18'),(21101,16863,'N','19','021','EC','A',NULL,NULL,'','0000874735','0000643264','','IL','1','Pylypuik','Alexander','B',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','2012-05-25','M','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-02-03 21:00:04'),(20783,16605,'Y','18','021','EC','A','','','AC','0001052348','0001052348','TX00002549003','IL','1','Suciu','Cornel','','','','34','632420349','7007 Sable ln',0,'Sachse','TX','75048',NULL,'CY','48085','1952-08-14','M','M',':RET:2106-3','N','021','DEN','3578668','33348TX002000201','2014-03-01','2014-01-30 21:36:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-31 21:00:11'),(18763,14950,'Y','18','021','EC','A','','','AC','0000657629','0000657629','TX00001637634','IL','1','Willis','Alvey','','','','34','549359191','11059 County Road 219',0,'Tyler','TX','75707',NULL,'CY','48423','1965-08-04','M','U',':RET:2106-3','N','021','DEN','2953586','33348TX002000101','2014-02-01','2014-01-15 23:36:17','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2014-01-17 03:35:47'),(9697,7681,'Y','18','021','EC','A','','','AC','0000711364','0000711364','OH00000982685','IL','1','BELL','MARILYN','','','','34','302528909','5718 HILLTOP WAY',0,'MILFORD','OH','45150',NULL,'CY','39025','1952-08-30','F','M',':RET:2106-3','N','021','HLT','2189191','92036OH006000601','2014-01-01','2013-12-21 13:59:05','689.00',NULL,NULL,'1056.35','367.35','R-OH005','OH0','478.41',NULL,0,'2013-12-26 04:39:52'),(16225,12994,'Y','18','021','EC','A','','','AC','0001026950','0001026950','OH00001001731','IL','1','WASHER','CHRIS','A','','','34','279447404','427 MORENCI',0,'LYONS','OH','43553',NULL,'CY','39051','1949-07-01','M','M',NULL,'N','021','DEN','2232373','99734OH005000401','2014-02-01','2014-01-04 11:48:03','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-05 00:01:54'),(15571,12461,'Y','18','021','EC','A','','','AC','0000951810','0000951810','OH00001892457','31','1','Ventura','James','','','','34','287622874','3560 Middlebranch Ave. NE',0,'Canton','OH','44705',NULL,'CY','39151','1966-12-09','M','U',':RET:2106-3','N','021','HLT','1774001','52664OH151001301','2014-02-01','2013-12-31 13:04:36','38.12',NULL,NULL,'348.56','310.44','R-OH015','OH0','348.56',NULL,1,'2014-01-02 04:31:53'),(22835,18220,'Y','18','021','EC','A','','','AC','0000792244','0000792244','OH00002096048','IL','1','Kopac','James','','','','34','294764557','6702 FOREST AVE',0,'SEVEN HILLS','OH','44129','2734','CY','39035','1965-03-25','M','U',':RET:2106-3','T','021','HLT','3697907','52664OH151001301','2014-03-01','2014-02-11 13:53:25','0.00',NULL,NULL,'472.92','472.92','R-OH011','OH0','472.92',NULL,0,'2014-02-11 21:02:10'),(28040,22188,'Y','18','021','EC','A','','','AC','0000366840','0000366840','MS00003657692','IL','1','Stepteau','Don','','','','34','436537510','157B N WIND RIDGE LN',0,'PURVIS','MS','39475','5839','CY','28073','1984-01-22','M','M',':RET:2054-5','N','021','DEN','4119365','46300MS002000201','2014-04-01','2014-03-05 18:16:29','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2014-03-06 21:01:31'),(21134,16888,'N','17','021','EC','A',NULL,NULL,'','0000823163','0000810751','','IL','1','JAHANARA','DANIA','SARA','','','34','032491626','901 E 26TH ST',0,'HOUSTON','TX','77009','1005','CY','48201','1992-12-05','F','',':RET:2106-3','N','021','DEN','2673931','33348TX002000201','2014-03-01','2014-02-03 15:47:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-03 21:00:19'),(6298,4995,'Y','18','021','EC','A','','','AC','0000866874','0000866874','OH00000531064','IL','1','Oliver','Bonita','','','','34','172382719','6177 Roundhead Rd',0,'New Vienna','OH','45159',NULL,'CY','39071','1954-01-27','F','M',':RET:2106-3','N','021','DEN','1055013','99734OH005000401','2014-01-01','2013-12-11 08:42:37','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:45:49'),(20498,16376,'Y','18','021','EC','A','','','AC','0002077162','0002077162','LA00002170518','IL','1','GUILBEAUX','CAROL','A','','','34','433175743','1085 CELESTINE RD',0,'BROUSSARD','LA','70518','8116','CY','22099','1960-07-15','F','U',':RET:2106-3','T','021','DEN','2150334','18575LA002000201','2014-03-01','2014-01-29 13:11:13','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-29 21:01:11'),(2187,1799,'Y','18','021','EC','A','','','AC','0000374633','0000374633','MS00000306909','IL','1','Durant','Millie','','','','34','425064323','6164 Bradford Apt.',0,'Southaven','MS','38671',NULL,'CY','28033','1956-05-20','F','U',':RET:2054-5','N','021','DEN','1122636','46300MS002000201','2014-01-01','2013-12-10 17:07:16','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-25 19:19:37'),(17117,13699,'Y','18','021','EC','A','','','AC','0001010224','0001010224','OH00001627768','31','1','Hunt','Gary','','','','34','305069820','PO Box 1093',0,'Hilliard','OH','43026',NULL,'CY','39083','1975-08-15','M','M',':RET:2040-4','N','021','DEN','1739274','99734OH005000401','2014-02-01','2014-01-07 22:48:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:21:40'),(15842,12685,'N','01','021','EC','A',NULL,NULL,'','0000172417','0000794512','','IL','1','Line','Brenda','','','','34','296702625','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1960-10-15','F','',':RET:2106-3','N','021','DEN','1394281','99734OH005000401','2014-02-01','2014-01-02 15:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:04:11'),(2663,2163,'N','01','021','EC','A',NULL,NULL,'','0000366252','0000598719','','IL','1','Braunstein','Paul','','','','34','276544420','6542 SIMON DR',0,'CINCINNATI','OH','45233','4562','CY','39061','1952-10-19','M','',':RET:2106-3','N','021','DEN','523596','99734OH005000301','2014-01-01','2013-12-02 09:59:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:52'),(9471,7512,'N','01','021','EC','A',NULL,NULL,'','0000142824','0000768873','','IL','1','smith','rita','','','','34','404648598','2674 KNIGHT AVE',0,'CINCINNATI','OH','45212','1314','CY','39061','1949-12-13','F','',NULL,'N','021','DEN','1417282','99734OH005000401','2014-01-01','2013-12-21 10:40:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:26'),(13176,10510,'Y','18','024','14','A','','','TE','0000404772','0000404772','','IL','1','BURROUGHS','DAVID',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-25','M','',NULL,NULL,NULL,'','1152946','','2013-12-23','2013-12-23 19:22:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:54:10'),(14106,11242,'Y','18','021','EC','A','','','AC','0000282019','0000282019','OH00001351321','IL','1','Turner','Bernita','','','','34','292665027','2102 CLEVELAND RD',0,'SANDUSKY','OH','44870','4495','CY','39043','1961-07-19','F','U',':RET:2054-5','N','021','DEN','2141407','99734OH005000401','2014-02-01','2013-12-26 13:45:57','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-27 02:01:43'),(14297,11406,'Y','18','021','EC','A','','','AC','0001055326','0001055326','OH00000242629','IL','1','BLACK','TAMMY','A','','','34','274707087','411 MOORE AVE',0,'BELLEVUE','OH','44811','1148','CY','39077','1966-09-25','F','M',NULL,'N','021','HLT','1516017','92036OH005002706','2014-02-01','2013-12-26 11:58:46','583.00',NULL,NULL,'637.45','54.45','R-OH006','OH0','304.78',NULL,0,'2013-12-27 02:06:45'),(14810,11829,'Y','18','021','EC','A','','','AC','0001534010','0001534010','LA00001300219','IL','1','LeBeouf','Quindell','','','','34','439578436','136 grissaffe lane',0,'belle rose','LA','70341',NULL,'CY','22007','1985-07-03','M','U',':RET:2054-5','N','021','DEN','1529184','18575LA002000201','2014-01-01','2013-12-23 20:01:50','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,1,'2013-12-29 11:14:01'),(23028,18359,'N','19','021','EC','A',NULL,NULL,'','0000805891','0001119688','','IL','1','hernandez','ivan','eduardo','','','34','629247608','3665 trina pl.',0,'el paso','TX','79936',NULL,'CY','48141','1991-05-02','M','',NULL,'N','021','DEN','3661707','33348TX002000201','2014-03-01','2014-02-12 00:10:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-12 21:30:33'),(24119,19172,'N','01','021','EC','A',NULL,NULL,'','0001051390','0000881326','','IL','1','HERNANDEZ','RICARDO','','','','34','449270958','328 COLMILLO DR',0,'EL PASO','TX','79907','4145','CY','48141','1962-08-11','M','',':RET:2106-3','N','021','DEN','2834203','33348TX002000201','2014-03-01','2014-02-15 14:43:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-15 22:01:41'),(25060,19873,'Y','18','021','EC','A','','','AC','0000025352','0000025352','OH00002568618','IL','1','BUMSTED','DANA','','','','34','479921923','9490 WYNNECREST DR',0,'BLUE ASH','OH','45242','6941','CY','39061','1968-06-07','F','U',':RET:2106-3','N','021','DEN','3232297','99734OH005000401','2014-04-01','2014-02-20 13:00:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:23'),(27870,22045,'Y','18','021','EC','A','','','AC','0000589377','0000589377','OH00003217911','IL','1','WOLFF','DEAN','','','','34','364740976','1422 HAMPTON DR',0,'FINDLAY','OH','45840','6633','CY','39063','1961-11-08','M','U',NULL,'N','021','HLT','3300933','92036OH004001501','2014-04-01','2014-03-05 15:54:45','342.90',NULL,NULL,'345.43','2.53','R-OH002','OH0','345.43',NULL,0,'2014-03-05 21:32:25'),(29032,22978,'Y','18','021','EC','A','','','AC','0000615578','0000615578','OH00002827226','IL','1','Mabry','Stephen','','','','34','290562526','212 E CHURCH ST',0,'URBANA','OH','43078','1821','CY','39021','1954-04-14','M','U',':RET:2106-3','N','021','DEN','3157232','99734OH005000401','2014-04-01','2014-03-10 11:54:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:01:35'),(22693,18120,'Y','18','021','EC','A','','','AC','0000981195','0000981195','TX00002101996','IL','1','Fontenot-Amedee','Isaac','','','','34','435579844','112 LAMAR DR',0,'HILLSBORO','TX','76645','2711','CY','48217','1984-11-27','M','U',':RET:2106-3','N','021','DEN','3129632','33348TX002000101','2014-03-01','2014-02-10 20:33:00','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-11 21:00:53'),(6898,5473,'Y','18','021','EC','A','','','AC','0001658399','0001658399','LA00000573839','IL','1','WICKS','DERYL','','','','34','433744115','74275 HIGHWAY 59',0,'COVINGTON','LA','70435','0210','CY','22103','1953-09-04','F','M',NULL,'N','021','DEN','2497061','18575LA002000201','2014-01-01','2013-12-24 22:07:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:33'),(1609,1344,'N','01','021','EC','A',NULL,NULL,'','0000026101','0000302658','','IL','1','CAMACHO','MICHAEL','','','','34','461832070','4507 JOHN STOCKBAUER DR',0,'VICTORIA','TX','77904','1941','CY','48469','1973-07-13','M','',':RET:2106-3','N','021','DEN','2261515','33348TX002000201','2014-01-01','2013-12-24 13:07:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:14'),(20443,16329,'N','19','021','EC','A',NULL,NULL,'','0000268077','0000995115','','IL','1','PAIGE','JORDAN','A','','','34','426831603','904 WINDING  LAKE COVE',0,'MADISON','MS','39110',NULL,'CY','28089','1997-06-23','F','',':RET:2054-5','N','021','DEN','1755955','46300MS002000101','2014-03-01','2014-01-29 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-01-29 21:00:41'),(2307,1875,'N','01','021','EC','A',NULL,NULL,'','0000705120','0001097757','','IL','1','Isenbarger','Stephanie','','','','34','273766352','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1979-10-11','F','',':RET:2106-3','N','021','DEN','709237','99734OH005000301','2014-01-01','2013-12-09 17:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:05'),(18768,14952,'N','01','021','EC','A',NULL,NULL,'','0000427340','0000908905','','IL','1','WADE','STACY','','','','34','453696531','2610 CODY CT',0,'MIDLOTHIAN','TX','76065','7023','CY','48139','1969-01-29','F','',NULL,'N','021','DEN','2815071','33348TX002000101','2014-03-01','2014-01-16 17:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-17 03:35:49'),(18154,14498,'Y','18','021','EC','A','','','AC','0000075258','0000075258','OH00002018990','IL','1','Schubert','Gary','','','','34','293563084','5050 BRASHER AVE',0,'BLUE ASH','OH','45242','3906','CY','39061','1956-06-29','M','U',':RET:2106-3','N','021','HLT','1509082','92036OH003001205','2014-02-01','2014-01-13 22:09:13','370.00',NULL,NULL,'546.34','176.34','R-OH004','OH0','546.34',NULL,0,'2014-01-15 02:07:51'),(17275,13817,'Y','18','021','EC','A','','','AC','0000440830','0000440830','OH00002364282','IL','1','Iammarino','Virginia','','','','34','199369758','2641 DOUG AVE',0,'HUDSON','OH','44236','3206','CY','39153','1959-04-02','F','M',NULL,'N','021','HLT','1633910','52664OH152000901','2014-02-01','2014-01-10 10:13:31','484.00',NULL,NULL,'512.07','28.07','R-OH012','OH0','348.73',NULL,0,'2014-01-13 02:23:23'),(16929,13547,'N','01','021','EC','A',NULL,NULL,'','0001268775','0001349981','','IL','1','RAMOS-ALVAREZ','ROXANA','','','','34','581339896','339 HELEN ST',0,'TERRYTOWN','LA','70056','3816','CY','22051','1963-07-27','F','',NULL,'N','021','DEN','1642789','18575LA002000201','2014-02-01','2014-01-09 16:05:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:19:48'),(9263,7347,'Y','18','021','EC','A','','','AC','0000506124','0000506124','LA00000063506','IL','1','Blair','Lynne','','','','34','439849928','606 POPLAR ST',0,'DENHAM SPRINGS','LA','70726','3006','CY','22063','1949-07-03','F','M',':RET:2106-3','N','021','DEN','582395','18575LA002000201','2014-01-01','2013-11-30 17:50:30','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:15:23'),(23764,18911,'N','19','021','EC','A',NULL,NULL,'','0001146017','0000550114','','IL','1','DiMuzio','Anthony','','','','34','291962097','614 COLEBERRY CT',0,'CLEVES','OH','45002','1390','CY','39061','1993-11-11','M','',':RET:2106-3','N','021','DEN','2812096','99734OH005000301','2014-03-01','2014-02-14 14:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:11'),(24593,19524,'Y','18','021','EC','A','','','AC','0000005889','0000005889','OH00002518947','IL','1','GAUDIO','DONALD','DOMENIC','','Jr','34','298667018','5981 APPLECREST DR',0,'BOARDMAN','OH','44512','3140','CY','39099','1961-12-27','M','U',':RET:2106-3','N','021','DEN','3840693','99734OH005000301','2014-04-01','2014-02-19 13:35:43','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-20 04:11:01'),(26067,20671,'Y','18','024','14','A','','','TE','0000217651','0000217651','','IL','1','Jackson','Edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-23','M','',NULL,NULL,NULL,'','3664199','','2014-02-26','2014-02-26 14:03:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:02:42'),(26131,20724,'Y','18','021','EC','A','','','AC','0000911816','0000911816','OH00002797488','IL','1','DAVIS','KIMBERLY','','','','34','295725916','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1971-05-27','F','M',':RET:2106-3','N','021','DEN','3709810','99734OH005000401','2014-03-01','2014-02-27 12:17:02','0.00',NULL,NULL,'71.95','71.95','R-OH005','OH0','0.00',NULL,0,'2014-02-28 06:30:23'),(28068,22212,'Y','18','021','EC','A','','','AC','0000789721','0000789721','OH00002730820','IL','1','RALL','SUSAN','MICHELLE','','','34','302747207','10762 COUNTY ROAD 195',0,'KENTON','OH','43326',NULL,'CY','39065','1966-11-29','F','M',':RET:2106-3','N','021','DEN','3263530','99734OH005000301','2014-04-01','2014-03-06 12:56:34','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-03-06 21:01:48'),(22494,17958,'Y','18','021','EC','A','','','AC','0000403701','0000403701','OH00002076805','IL','1','Frail','Jamie','','','','34','293885648','10423 BAILEY RD',0,'WATERVILLE','OH','43566','9716','CY','39095','1981-11-13','F','M',':RET:2106-3','N','021','DEN','3030303','99734OH005000301','2014-03-01','2014-02-10 14:03:38','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2014-02-10 21:31:10'),(19459,15511,'Y','18','021','EC','A','','','AC','0000028447','0000028447','TX00001525466','IL','1','HOLMES','BOBBY','','','','34','451022950','249 FREDONIA',0,'KILGORE','TX','75662','8255','CY','48183','1955-06-27','M','U',NULL,'N','021','DEN','3003186','33348TX002000201','2014-03-01','2014-01-21 21:51:38','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-23 03:01:56'),(4198,3338,'Y','18','021','EC','A','','','AC','0000758252','0000758252','OH00000150290','IL','1','BRENNAN','KATHLEEN','','','','34','278524761','440 LOOMIS AVE',0,'CUYAHOGA FALLS','OH','44221','5020','CY','39153','1951-06-14','F','U',':RET:2106-3','N','021','HLT','1953844','52664OH151001304','2014-01-01','2013-12-17 16:55:20','458.00',NULL,NULL,'640.70','182.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 21:49:48'),(13414,10702,'Y','18','021','EC','A','','','AC','0000556718','0000556718','OH00001063039','IL','1','Kozdron','Daniel','','','','34','290842085','1191 Bell Ct',0,'Elyria','OH','44035',NULL,'CY','39093','1986-05-07','M','U',NULL,'N','021','DEN','1975376','99734OH005000301','2014-01-01','2013-12-23 10:44:09','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:37'),(7414,5866,'N','01','021','EC','A',NULL,NULL,'','0000383010','0000381664','','IL','1','SIMON','STEPHANIE','','','','34','436294894','334 N LOPEZ ST',0,'NEW ORLEANS','LA','70119','5430','CY','22071','1975-02-25','F','',':RET:2054-5','N','021','DEN','623025','18575LA002000201','2014-01-01','2013-10-28 17:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 02:16:48'),(6590,5225,'Y','18','021','EC','A','','','AC','0001220219','0001220219','TX00000236493','31','1','ROBLING','JUDY','LAVERNE','','','34','459948609','PO BOX 47',0,'SINTON','TX','78387',NULL,'CY','48409','1955-04-15','F','U',':RET:2106-3','N','021','DEN','1060776','33348TX002000101','2014-01-01','2013-12-11 08:56:18','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2013-12-26 00:53:15'),(22026,17584,'N','01','021','EC','A',NULL,NULL,'','0000553952','0001140813','','IL','1','HAGAN','HOLLY','ANN','','','34','286845448','4880 CHAPPARAL RD',0,'WEST UNION','OH','45693','9499','CY','39001','1972-05-14','F','',':RET:2106-3','T','021','HLT','3084293','92036OH003000606','2014-03-01','2014-02-07 15:56:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','335.67',NULL,0,'2014-02-07 19:01:00'),(24416,19394,'Y','18','021','EC','A','','','AC','0000634860','0000634860','OH00002587378','IL','1','BYRUM','MICHAEL','W','','','34','292827046','3808 VANNEST AVE',0,'MIDDLETOWN','OH','45042','2652','CY','39017','1969-11-20','M','U',':RET:2106-3','T','021','DEN','3029130','99734OH005000301','2014-04-01','2014-02-18 11:13:36','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:01:04'),(24611,19533,'N','01','021','EC','A',NULL,NULL,'','0000319075','0001250165','','IL','1','PETERS','MARIO','D','','','34','427297142','76203 ELIZABETH LN',0,'BRANDON','MS','39042','2741','CY','28121','1976-06-10','M','',':RET:2054-5','N','021','DEN','3005194','46300MS002000201','2014-04-01','2014-02-18 18:28:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 04:14:10'),(27522,21773,'Y','18','024','14','A','','','TE','0000378637','0000378637','','IL','1','zheng','qiao',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-08-08','F','',NULL,NULL,NULL,'','2739689','','2014-03-04','2014-03-04 13:53:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:40'),(404,332,'Y','18','021','EC','A','','','AC','0001219558','0001219558','OH00000043910','IL','1','Witt','Kurtis','','','','34','301601671','3566 west 105st',0,'cleveland','OH','44111',NULL,'CY','39035','1961-12-10','M','U',':RET:2106-3','N','021','DEN','47233','99734OH005000401','2014-01-01','2013-12-04 09:26:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:14'),(1730,1440,'N','19','021','EC','A',NULL,NULL,'','0000809681','0000009851','','IL','1','Funkhouser','Justin','','','','34','284085652','401 Bell Ave',0,'Sandusky','OH','44870',NULL,'CY','39043','2003-07-22','M','',':RET:2106-3','N','021','DEN','2527329','99734OH005000301','2014-01-01','2013-12-24 10:59:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:23'),(20159,16088,'Y','18','021','EC','A','','','AC','0000516945','0000516945','OH00001715599','IL','1','Martini','Ryan','','','','34','295901885','55 Barrett Rd',0,'Berea','OH','44017',NULL,'CY','39035','1987-11-05','M','M',':RET:2106-3','N','021','DEN','2147982','99734OH005000301','2014-03-01','2014-01-27 13:26:01','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:01:08'),(20018,15965,'Y','18','021','EC','A','','','AC','0001185231','0001185231','TX00002174126','IL','1','steeves','karen','','','','34','452472866','641 DOLPHIN CIR',0,'PORT ARANSAS','TX','78373','5400','CY','48355','1964-10-17','F','U',':RET:2106-3','N','021','DEN','2476303','33348TX002000201','2014-03-01','2014-01-26 14:51:00','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-26 19:00:13'),(18383,14672,'N','19','021','EC','A',NULL,NULL,'','0000154680','0000785821','','IL','1','halerz','matthew','','','','34','296131403','31704 Daniel Dr.',0,'Willowick','OH','44095',NULL,'CY','39085','2008-04-04','M','',':RET:2106-3','N','021','DEN','1841290','99734OH005000301','2014-02-01','2014-01-15 11:10:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:36'),(5522,4380,'Y','18','024','14','A','','','TE','0001153585','0001153585','','IL','1','daye','gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-03-07','M','',NULL,NULL,NULL,'','839316','','2013-11-26','2013-11-26 18:29:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:15:22'),(13569,10822,'Y','18','021','EC','A','','','AC','0001427512','0001427512','LA00001199630','IL','1','Wagnon','John','','','','34','433736445','242 Lakes Falls Dr',0,'Pineville','LA','71360',NULL,'CY','22079','1977-05-25','M','U',':RET:2106-3','N','021','DEN','1426000','18575LA002000201','2014-01-01','2013-12-23 16:56:33','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 13:04:37'),(16939,13557,'Y','18','021','EC','A','','','AC','0001471488','0001471488','LA00001788309','IL','1','WILLIAMS','EUGENIA','','','','34','438233890','4305 ILLINOIS AVE',0,'SHREVEPORT','LA','71109',NULL,'CY','22017','1965-11-18','F','U',':RET:2054-5','T','021','DEN','2453533','18575LA002000201','2014-02-01','2014-01-09 11:04:24','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-13 02:19:52'),(14017,11166,'Y','18','021','EC','A','','','AC','0000044272','0000044272','OH00000674024','IL','1','young','thomas','','','','34','299868673','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1987-07-10','M','M',':RET:2106-3','N','021','HLT','2317852','92036OH003000606','2014-01-01','2013-12-23 15:20:42','95.00',NULL,NULL,'229.56','134.56','R-OH005','OH0','229.56',NULL,0,'2013-12-26 13:16:30'),(26943,21350,'N','19','021','EC','A',NULL,NULL,'','0000618418','0000774033','','IL','1','Chmura','Anthony',NULL,NULL,NULL,NULL,NULL,'1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','1997-02-12','M','',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:23'),(15473,12379,'N','19','021','EC','A',NULL,NULL,'','0000910534','0000177616','','IL','1','DEVORE','WESLEY','DAVID','','','34','093994907','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2011-10-01','M','',NULL,'N','021','DEN','1454396','99734OH005000401','2014-02-01','2013-12-30 19:18:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:28:58'),(1993,1632,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001197520','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','640296','33348TX002000101','2014-01-01','2013-11-19 23:06:38','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:02:00'),(21111,16868,'Y','18','021','EC','A','','','AC','0001211618','0001211618','LA00001949346','IL','1','Martinez','Ryan','','','','34','437618291','6101 Tullis Dr',0,'New Orleans','LA','70131',NULL,'CY','22071','1986-08-23','M','R',':RET:2054-5','N','021','DEN','2813101','18575LA002000101','2014-03-01','2014-02-03 13:22:41','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-03 21:00:07'),(19584,15611,'Y','18','021','EC','A','','','AC','0001009842','0001009842','MS00002245469','IL','1','Ducksworth','Kimbula','','','','34','425454434','3649 OLD BAY SPRINGS RD',0,'LAUREL','MS','39440','1460','CY','28067','1982-07-23','F','U',':RET:2054-5','N','021','DEN','3126954','46300MS002000201','2014-03-01','2014-01-21 21:46:15','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-23 03:02:42'),(2796,2261,'Y','18','021','EC','A','','','AC','0001074115','0001074115','OH00000084791','IL','1','Fisher','Colleen','','','','34','279704045','9014 STATE ROUTE 3 WEST',0,'Clarksville','OH','45113',NULL,'CY','39027','1960-06-09','F','M',':RET:2106-3','N','021','HLT','558510','92036OH001000601','2014-01-01','2013-12-02 12:24:18','697.00',NULL,NULL,'1255.88','558.88','R-OH005','OH0','528.24',NULL,0,'2013-12-25 19:50:17'),(4444,3531,'Y','18','021','EC','A','','','AC','0000672732','0000672732','OH00000624492','IL','1','Guider','Elizabeth','J','','','34','295509207','3940 Bogdon Drive',0,'Canal Winchester','OH','43110',NULL,'CY','39049','1960-08-07','F','U',':RET:2106-3','N','021','DEN','763892','99734OH005000301','2014-01-01','2013-12-11 23:03:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:02:11'),(18566,14806,'Y','18','021','EC','A','','','AC','0000105394','0000105394','OH00001754816','IL','1','Taylor','Deborah','','','','34','283485214','5857 LAKEWOOD RD',0,'RAVENNA','OH','44266','9001','CY','39133','1953-03-03','F','U',':RET:2106-3','N','021','HLT','2287596','52664OH152000901','2014-02-01','2014-01-14 23:38:11','389.00',NULL,NULL,'443.31','54.31','R-OH012','OH0','443.31',NULL,0,'2014-01-16 08:47:02'),(17944,14338,'Y','18','021','EC','A','','','AC','0000608795','0000608795','TX00001992380','IL','1','Rayas','Debra','Ann','','','34','450577441','1722 Socorro',0,'San Antonio','TX','78214',NULL,'CY','48029','1968-03-14','F','M',':RET:2106-3','N','021','DEN','2008634','33348TX002000201','2014-02-01','2014-01-14 16:01:03','0.00',NULL,NULL,'43.83','43.83','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:40'),(15021,12006,'Y','18','021','EC','A','','','AC','0001548248','0001548248','LA00000709023','IL','1','nguyen','no','','','','34','439831403','20357 chaumont ave',0,'baton rouge','LA','70817',NULL,'CY','22033','1970-10-02','M','M',':RET:2047-9','N','021','DEN','2353135','18575LA002000201','2014-02-01','2013-12-29 20:39:19','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:02:19'),(16529,13223,'Y','18','024','14','A','','','TE','0000007457','0000007457','','IL','1','juarez','norberto',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-07','M','',NULL,NULL,NULL,'','2325787','','2014-01-05','2014-01-05 16:43:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-07 10:22:00'),(15539,12434,'Y','18','021','EC','A','','','AC','0001807206','0001807206','LA00001749619','IL','1','AUBERT','CAROLE','','','','34','434804537','4000 FERRAN DR',0,'METAIRIE','LA','70002','4420','CY','22051','1952-10-03','F','U',':RET:2106-3','N','021','DEN','1882169','18575LA002000201','2014-02-01','2013-12-31 14:15:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:30:54'),(15992,12800,'Y','18','021','EC','A','','','AC','0000922524','0000922524','TX00001297901','IL','1','ZAN','QUANG','','','','34','634238455','2605 HOYA DR',0,'MIDLAND','TX','79707',NULL,'CY','48329','1978-08-18','M','U',NULL,'N','021','DEN','2412868','33348TX002000201','2014-02-01','2014-01-03 12:16:05','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-04 02:01:16'),(24253,19258,'Y','18','021','EC','A','','','AC','0000326235','0000326235','OH00001883056','IL','1','Kunkel','Larissa','','','','34','285883848','1023 HEMLOCK HILLS DR',0,'AKRON','OH','44313','8292','CY','39153','1984-02-25','F','U',':RET:2106-3','N','021','HLT','3254748','52664OH152000901','2014-04-01','2014-02-16 20:50:00','175.00',NULL,NULL,'185.39','10.39','R-OH012','OH0','185.39',NULL,0,'2014-02-17 19:00:04'),(24323,19317,'Y','18','024','14','A','','','TE','0000560630','0000560630','','IL','1','Contreras','virginia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-07-06','F','',NULL,NULL,NULL,'','2767043','','2014-02-18','2014-02-18 11:52:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-18 22:00:10'),(27157,21502,'Y','18','021','EC','A','','','AC','0000582864','0000582864','OH00002686287','IL','1','Judd','Rhonda','Jane','','','34','271521623','1167 TOWNSHIP ROAD 31 N',0,'BELLEFONTAINE','OH','43311','9630','CY','39091','1960-03-21','F','M',':RET:2106-3','N','021','DEN','3118869','99734OH005000401','2014-04-01','2014-03-03 16:32:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:56'),(28937,22900,'Y','18','021','EC','A','','','AC','0000156995','0000156995','OH00002604275','IL','1','TURNER','KELLEY','','','','34','289682256','815 LONGVIEW AVE',0,'AKRON','OH','44307',NULL,'CY','39153','1968-01-28','F','U',':RET:2054-5','N','021','DEN','4175272','99734OH005000301','2014-04-01','2014-03-10 16:07:56','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:00:40'),(535,436,'Y','18','021','EC','A','','','AC','0000236421','0000236421','MS00000226492','IL','1','Clark','Shirley','','','','34','587279926','2638 KEY ST',0,'JACKSON','MS','39212','2924','CY','28049','1961-12-25','F','U',':RET:2054-5','N','021','DEN','808151','46300MS002000201','2014-01-01','2013-12-04 16:58:33','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 17:49:32'),(6177,4895,'Y','18','021','EC','A','','','AC','0000006946','0000006946','OH00000107698','IL','1','Higham','Michael','','','','34','285745640','4429 Robinson Rd',0,'Hillsboro','OH','45133',NULL,'CY','39071','1967-10-02','M','U',NULL,'T','021','HLT','104048','92036OH003000606','2014-01-01','2013-10-02 07:22:01','683.00',NULL,NULL,'867.53','184.53','R-OH005','OH0','386.70',NULL,0,'2013-12-26 00:17:13'),(20954,16744,'Y','18','021','EC','A','','','AC','0000438243','0000438243','TX00002243220','31','1','Fischer','Christopher','','','','34','594214099','PO Box 1',0,'Bluffton','TX','78607',NULL,'CY','48299','1992-02-05','M','M',':RET:2106-3','N','021','DEN','3423728','33348TX002000201','2014-03-01','2014-02-01 11:07:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-01 19:00:06'),(18314,14622,'Y','18','021','EC','A','','','AC','0001184904','0001184904','OH00002570758','IL','1','Holtkamp','Karen','','','','34','281866746','6714 BRITTON AVE',0,'CINCINNATI','OH','45227','3126','CY','39061','1973-07-07','F','U',':RET:2106-3','N','021','DEN','1929889','99734OH005000401','2014-02-01','2014-01-15 12:52:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:04'),(15096,12066,'Y','18','021','EC','A','','','AC','0001081806','0001081806','OH00000945302','IL','1','Lawson','Katariina','','','','34','277528183','24383 Smith Avenue',0,'Westlake','OH','44145',NULL,'CY','39035','1953-08-04','F','M',NULL,'N','021','DEN','2257055','99734OH005000301','2014-02-01','2013-12-30 05:44:04','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:04:35'),(14125,11258,'Y','18','021','EC','A','','','AC','0002152357','0002152357','LA00001467627','IL','1','Morlie','Hickman','','','','34','434216684','1153 rapides ave',0,'Alexandria','LA','71301',NULL,'CY','22079','1964-11-14','M','U',':RET:2054-5','N','021','DEN','1593426','18575LA002000201','2014-02-01','2013-12-25 19:28:11','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-27 02:02:13'),(13072,10420,'Y','18','021','EC','A','','','AC','0000016612','0000016612','OH00000849880','IL','1','Catacutan','Emmanuel',NULL,NULL,NULL,NULL,NULL,'3212 W 32ND ST',0,'CLEVELAND','OH','44109','1531','CY','39035','1956-12-22','M','M',':RET:2036-2','N','021','DEN','1618732','99734OH005000401','2014-01-01','2013-12-23 10:24:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:20'),(3609,2892,'Y','18','021','EC','A','','','AC','0000844704','0000844704','OH00001121678','IL','1','Sherwood','Thomas',NULL,NULL,NULL,NULL,NULL,'1653 Hampton Knoll Dr.',0,'Akron','OH','44313',NULL,'CY','39153','1977-01-17','M','R',':RET:2039-6^:RET:2106-3','N','021','HLT','2168054','52664OH152000901','2014-01-01','2013-12-22 17:54:54','0.00',NULL,NULL,'200.91','200.91','R-OH012','OH0','200.91',NULL,0,'2013-12-25 21:23:27'),(2328,1894,'Y','18','021','EC','A','','','AC','0000394652','0000394652','TX00000101870','IL','1','Herrera','Alfonso','','','','34','450822518','704 St James',0,'Laredo','TX','78041',NULL,'CY','48479','1950-03-16','M','U',':RET:2106-3','N','021','DEN','40898','33348TX002000201','2014-01-01','2013-12-09 11:27:28','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 19:31:35'),(1671,1396,'Y','18','021','EC','A','','','AC','0000175106','0000175106','OH00000182628','IL','1','Phelps','Martin','','','','34','296864092','500 HARRISON LN',0,'ANDERSON','OH','45244','2205','CY','39025','1978-03-21','M','M',':RET:2106-3','N','021','HLT','1387674','92036OH005000605','2014-01-01','2013-12-24 05:22:01','588.00',NULL,NULL,'800.71','212.71','R-OH005','OH0','262.31',NULL,0,'2013-12-25 18:53:54'),(21916,17503,'Y','18','021','EC','A','','','AC','0000058794','0000058794','OH00002089598','IL','1','Hemmer','Kaitlin','','','','34','298947889','2020 S SUGAR BUSH DR',0,'MARBLEHEAD','OH','43440','2350','CY','39123','1992-06-11','F','U',':RET:2106-3','N','021','HLT','3297941','92036OH005002706','2014-03-01','2014-02-06 16:40:29','150.00',NULL,NULL,'194.99','44.99','R-OH006','OH0','194.99','CIC',0,'2014-02-06 21:30:06'),(22288,17793,'Y','18','021','EC','A','','','AC','0000928530','0000928530','OH00001872670','IL','1','Smith','Daniel','','','','34','296909491','10877 SOUTHWIND DR',0,'POWELL','OH','43065','7699','CY','39041','1986-01-09','M','U',':RET:2106-3','T','021','DEN','3167277','99734OH005000401','2014-03-01','2014-01-20 22:46:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-10 11:00:27'),(23092,18409,'Y','18','021','EC','A','','','AC','0000449909','0000449909','OH00002555274','IL','1','Podgorski','Dean','','','','34','284642933','4419 W 56TH ST',0,'CLEVELAND','OH','44144','2914','CY','39035','1971-05-20','M','M',':RET:2106-3','N','021','DEN','3631141','99734OH005000401','2014-03-01','2014-02-12 13:13:35','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:07'),(24103,19161,'Y','18','021','EC','A','','','AC','0000762478','0000762478','TX00002448189','IL','1','FAUST','SCOTT','','','','34','524354792','4202 BOXWOOD DR',0,'DENTON','TX','76208','7312','CY','48121','1975-04-27','M','U',':RET:2106-3','N','021','DEN','3397690','33348TX002000201','2014-03-01','2014-02-14 18:40:17','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:32'),(24980,19812,'Y','18','021','EC','A','','','AC','0000389645','0000389645','TX00001869489','IL','1','SMITH','DONYA','R','','','34','465573699','7618 LEATHER MARKET ST',0,'HOUSTON','TX','77064',NULL,'CY','48201','1966-12-19','F','M',NULL,'N','021','DEN','3348807','33348TX002000201','2014-04-01','2014-02-20 11:45:03','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:33'),(25450,20193,'N','01','021','EC','A',NULL,NULL,'','0001154077','0001134472','','IL','1','DOZIER','PHILLIP','','','','34','457084977','9221 PAGEWOOD LANE',0,'HOUSTON','TX','77063',NULL,'CY','48201','1954-09-29','M','',':RET:2054-5','N','021','DEN','2997783','33348TX002000201','2014-04-01','2014-02-25 13:32:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-25 21:31:25'),(27408,21695,'Y','18','021','EC','A','','','AC','0001111728','0001111728','OH00003341169','IL','1','LASKY','NIKOLE','M','','','34','273920320','3195 LINCOLN ST',0,'LORAIN','OH','44052','2714','CY','39093','1987-07-19','F','M',':RET:2106-3','N','021','DEN','3441137','99734OH005000301','2014-04-01','2014-03-04 10:56:33','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:34'),(16268,13025,'Y','18','021','EC','A','','','AC','0000034389','0000034389','OH00002147064','IL','1','SMITH','VIRGINIA','','','','34','295524643','842 VINE STREET',0,'ORRVILLE','OH','44667',NULL,'CY','39169','1952-07-22','F','U',NULL,'T','021','DEN','1488926','99734OH005000401','2014-02-01','2014-01-06 15:57:05','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-01-07 04:00:12'),(15766,12616,'Y','18','021','EC','A','','','AC','0000574891','0000574891','TX00001651736','IL','1','Cobb','Stephanie','','','','34','539909475','104 ROBB ST',0,'HEARNE','TX','77859','4060','CY','48395','1981-08-11','F','U',':RET:1002-5^:RET:2106-3','T','021','DEN','1794721','33348TX002000201','2014-02-01','2014-01-02 13:15:13','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-03 02:01:40'),(15440,12354,'Y','18','021','EC','A','','','AC','0000515623','0000515623','TX00001618850','IL','1','Rackley','James','','','','34','450316783','1136 STONE BLF',0,'NEW BRAUNFELS','TX','78130','2448','CY','48091','1971-06-16','M','M',':RET:2106-3','T','021','DEN','2007225','33348TX002000201','2014-02-01','2013-12-31 14:01:07','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,1,'2014-01-02 04:28:01'),(21949,17528,'N','19','021','EC','A',NULL,NULL,'','0000140332','0001260048','','S1','1','PATEL','JAYPRAKASH','C','','','34','300026415','4135 LINCOLN ST E',0,'CANTON','OH','44730','9479','CY','39151','1998-06-29','M','',':RET:2029-7','N','021','DEN','3175502','99734OH005000401','2014-03-01','2014-02-06 20:07:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:20'),(26281,20846,'Y','18','021','EC','A','','','AC','0001327660','0001327660','LA00003080348','IL','1','WILLAIMS','JESSICA','','','','34','438373433','605 HALL ST',0,'HOUMA','LA','70360','5531','CY','22109','1977-09-15','F','U',':RET:2054-5','N','021','DEN','3653259','18575LA002000101','2014-04-01','2014-02-27 01:11:50','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-02-28 06:31:20'),(2278,1858,'N','01','021','EC','A',NULL,NULL,'','0000373604','0000101405','','IL','1','Hater','Kristie','Ann','','','34','365040339','6565 BRIDGETOWN RD',0,'CINCINNATI','OH','45248','2936','CY','39061','1984-03-05','F','',NULL,'N','021','DEN','72984','99734OH005000301','2014-01-01','2013-12-09 12:27:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:30'),(3189,2565,'Y','18','021','EC','A','','','AC','0000383330','0000383330','OH00000330007','IL','1','Dell Hawkins','Christina','','','','34','427491788','835 WOODBURN RD',0,'URBANA','OH','43078','9492','CY','39021','1971-02-01','F','M',':RET:2106-3','T','021','HLT','800597','92036OH004000501','2014-01-01','2013-11-18 11:51:09','0.00',NULL,NULL,'291.25','291.25','R-OH003','OH0','291.25',NULL,0,'2013-12-25 20:32:05'),(5700,4524,'Y','18','021','EC','A','','','AC','0000374631','0000374631','MS00001045255','IL','1','Miller','Terry','','','','34','436963054','1962 BIENVILLE DR',0,'JACKSON','MS','39212','2536','CY','28049','1956-12-25','M','M',':RET:2054-5','N','021','DEN','500564','46300MS002000201','2014-01-01','2013-11-26 16:02:56','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:32:53'),(6465,5123,'Y','18','021','EC','A','','','AC','0000911749','0000911749','OH00000606065','IL','1','ROWLAND','ROBERTA','','','','34','273589489','2758 NESMITH LAKE BLVD',0,'AKRON','OH','44314',NULL,'CY','39153','1955-02-19','F','M',NULL,'N','021','HLT','315206','52664OH151001306','2014-01-01','2013-12-10 18:48:06','268.00',NULL,NULL,'568.22','300.22','R-OH012','OH0','568.22',NULL,0,'2013-12-26 00:50:00'),(20612,16470,'Y','18','021','EC','A','','','AC','0000653230','0000653230','OH00002589424','IL','1','Chiles','Renee','','','','34','301561082','6954 WATERLOO RD',0,'ATWATER','OH','44201','9593','CY','39133','1956-06-08','F','M',':RET:2106-3','N','021','DEN','2728907','99734OH005000401','2014-03-01','2014-01-30 17:41:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-30 21:00:18'),(20113,16047,'N','01','021','EC','A',NULL,NULL,'','0000919427','0000659933','','IL','1','jusko','rosemarie','','','','34','298624990','35975 MATOMA BLVD',0,'EASTLAKE','OH','44095','1518','CY','39085','1960-01-16','F','',':RET:2106-3','N','021','DEN','2825185','99734OH005000401','2014-03-01','2014-01-26 19:58:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:00:42'),(9310,7382,'Y','18','021','EC','A','','','AC','0001558791','0001558791','LA00000230576','IL','1','Neathamer','Susan','Helene','','','34','433042757','920 5TH ST',0,'GRETNA','LA','70053','6004','CY','22051','1956-12-09','F','U',NULL,'N','021','DEN','1682084','18575LA002000101','2014-01-01','2013-12-20 22:51:01','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:13'),(19249,15339,'Y','18','021','EC','A','','','AC','0000415737','0000415737','MS00001546249','IL','1','Faulkner','Deidra','','','','34','427738114','6780 RIVERDALE RD',0,'HORN LAKE','MS','38637','1518','CY','28033','1992-05-27','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3134021','46300MS002000101','2014-03-01','2014-01-20 17:46:27','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-21 08:46:42'),(14653,11695,'N','01','021','EC','A',NULL,NULL,'','0000863019','0000321827','','IL','1','Acebo','Carmen','I','','','34','627038378','20023 SKY HOLLOW LN',0,'KATY','TX','77450','5219','CY','48201','1957-08-05','F','',':RET:2106-3','N','021','DEN','1543700','33348TX002000201','2014-02-01','2013-12-27 20:24:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,1,'2013-12-29 11:07:48'),(14874,11878,'Y','18','021','EC','A','','','AC','0000197683','0000197683','TX00000776237','IL','1','Spyres','Carl','','','','34','446529484','801 QUAIL RUN CIR',0,'QUINLAN','TX','75474','2638','CY','48231','1950-10-27','M','M',':RET:2106-3','N','021','DEN','2084968','33348TX002000201','2014-02-01','2013-12-29 12:17:04','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-30 00:00:19'),(16960,13574,'Y','18','021','EC','A','','','AC','0000472274','0000472274','OH00001520159','IL','1','ROZACK','AUDREY','','','','34','302487856','5099 WHITE PINE DR',0,'BRUNSWICK','OH','44212',NULL,'CY','39103','1951-07-21','F','U',':RET:2106-3','T','021','HLT','2503650','52664OH151001305','2014-02-01','2014-01-09 08:48:17','508.00',NULL,NULL,'736.81','228.81','R-OH012','OH0','736.81',NULL,0,'2014-01-13 02:20:06'),(23238,18527,'Y','18','021','EC','A','','','AC','0001109267','0001109267','OH00002161102','IL','1','Sweet','Sheila','','','','34','289489526','2618 POPLAR RIDGE DR',0,'BETHEL','OH','45106','8547','CY','39025','1951-01-20','F','M',NULL,'N','021','HLT','2643985','92036OH005000604','2014-03-01','2014-02-12 14:34:56','352.00',NULL,NULL,'633.70','281.70','R-OH005','OH0','633.70',NULL,0,'2014-02-12 21:32:30'),(24223,19236,'N','01','021','EC','A',NULL,NULL,'','0000984923','0000750335','','IL','1','Bauer','Melissa','Ruth','','','34','520130717','112 WILLIAMSON DR',0,'BRYAN','TX','77801','1925','CY','48041','1981-04-02','F','',':RET:2106-3','N','021','DEN','3259669','33348TX002000201','2014-04-01','2014-02-16 10:46:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-16 19:00:29'),(26277,20844,'Y','18','021','EC','A','','','AC','0001934491','0001934491','LA00003097411','31','1','Mitchell','Emil','','','','34','433046356','P.O. Box 1106',0,'Gramercy','LA','70052',NULL,'CY','22093','1958-08-18','M','M',NULL,'N','021','DEN','3837030','18575LA002000101','2014-04-01','2014-02-26 22:23:13','0.00',NULL,NULL,'75.06','75.06','R-LA001','LA0','25.02',NULL,0,'2014-02-28 06:31:19'),(26512,21028,'Y','18','024','14','A','','','TE','0000117830','0000117830','','IL','1','Knape','Steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-19','M','',NULL,NULL,NULL,'','3107446','','2014-03-31','2014-02-28 12:04:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:20'),(5422,4304,'Y','18','021','EC','A','','','AC','0000317933','0000317933','MS00000725146','IL','1','Donald','Jalisa','','','','34','587714165','2068 SAINT JOHN RD',0,'BRAXTON','MS','39044','9416','CY','28127','1991-09-05','F','U',':RET:2054-5','N','021','DEN','2222500','46300MS002000201','2014-01-01','2013-12-19 08:48:10','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:09:26'),(5517,4376,'Y','18','021','EC','A','','','AC','0000610838','0000610838','OH00001198808','IL','1','Nixon','Andrew','','','','34','288880396','1070 West Hunter Street',0,'Logan','OH','43138',NULL,'CY','39073','1981-02-26','M','U',':RET:2106-3','N','021','DEN','1100877','99734OH005000301','2014-01-01','2013-11-27 13:32:58','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 23:15:12'),(21777,17391,'Y','18','021','EC','A','','','AC','0001089595','0001089595','OH00001486011','IL','1','BRIDGEFORD','MARY','','','','34','273666885','203 CENTERBURY CT',0,'SPRINGDALE','OH','45246','4904','CY','39061','1960-05-18','F','U',':RET:2106-3','N','021','DEN','2780054','99734OH005000401','2014-03-01','2014-02-05 21:01:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:00:36'),(14235,11353,'Y','18','021','EC','A','','','AC','0001025151','0001025151','MS00000250528','IL','1','Elkhatib','Mostafa','M','','','34','578801403','515 Florence Dr.',0,'Madison','MS','39110',NULL,'CY','28089','1951-06-16','M','M',NULL,'N','021','DEN','1703709','46300MS002000101','2014-02-01','2013-12-26 13:00:59','0.00',NULL,NULL,'81.45','81.45','R-MS003','MS0','27.15',NULL,0,'2013-12-27 02:05:07'),(14267,11381,'Y','18','021','EC','A','','','AC','0001125445','0001125445','OH00001689599','IL','1','Hornschemeir','Harold','','','','34','275563403','1436 Gumbert Dr',0,'Batavia Township','OH','45102',NULL,'CY','39025','1954-04-09','M','U',':RET:2106-3','T','021','HLT','2572226','92036OH006000601','2014-02-01','2013-12-26 13:57:22','288.00',NULL,NULL,'509.63','221.63','R-OH005','OH0','509.63',NULL,0,'2013-12-27 02:05:58'),(14871,11875,'Y','18','021','EC','A','','','AC','0001044101','0001044101','TX00001284806','IL','1','Hanbury','Russchelle','','','','34','454805376','906 DENVER AVE',0,'DALHART','TX','79022','3628','CY','48111','1953-12-10','F','U',':RET:2106-3','N','021','DEN','1957019','33348TX002000201','2014-02-01','2013-12-29 11:16:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-30 00:00:13'),(25812,20469,'Y','18','021','EC','A','','','AC','0001155146','0001155146','OH00002602402','IL','1','Wells','Jennifer','','','','34','272807268','2509 CATHY DR NE',0,'CANTON','OH','44705','3905','CY','39151','1981-08-22','F','M',':RET:2106-3','N','021','DEN','3007507','99734OH005000301','2014-04-01','2014-02-26 14:15:51','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-26 21:00:22'),(26808,21244,'N','01','021','EC','A',NULL,NULL,'','0001066042','0000758323','','IL','1','ALLAN','ALI','','','','34','114542728','4027 SHELLEY DR',0,'NORTH OLMSTED','OH','44070','1947','CY','39035','1960-06-13','M','',NULL,'N','021','DEN','3395691','99734OH005000301','2014-04-01','2014-03-01 11:39:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-01 21:00:27'),(15881,12717,'Y','18','021','EC','A','','','AC','0001642161','0001642161','LA00001527305','IL','1','Jackson','Denise','','','','34','433066467','3110 Alabama Street',0,'Mornoe','LA','71202',NULL,'CY','22073','1956-02-05','F','U',':RET:2054-5','N','021','DEN','2217322','18575LA002000101','2014-02-01','2014-01-02 09:45:37','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-03 02:05:25'),(17009,13614,'N','01','021','EC','A',NULL,NULL,'','0000336440','0001183537','','IL','1','OCONNOR','DONALD','','','','34','284624613','2927 8 ROUTE 756',0,'FELICITY','OH','45120',NULL,'CY','39025','1959-03-07','M','',NULL,'N','021','DEN','1455946','99734OH005000301','2014-02-01','2014-01-09 13:42:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:35'),(17601,14070,'Y','18','021','EC','A','','','AC','0000983698','0000983698','TX00002170136','IL','1','Patel','Hasmukhlal','','','','34','640213044','2502 W FERGUSON RD',0,'MOUNT PLEASANT','TX','75455','2942','CY','48449','1950-11-02','M','M',':RET:2029-7','T','021','DEN','2672002','33348TX002000201','2014-02-01','2014-01-12 19:20:17','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:16'),(17879,14279,'N','01','021','EC','A',NULL,NULL,'','0001126890','0000361031','','IL','1','Vollmer','Melanie','','','','34','271884246','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','1979-10-31','F','',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(18190,14522,'Y','18','021','EC','A','','','AC','0000066271','0000066271','OH00001758629','IL','1','MURANKO','PEGGY','','','','34','272709118','9976 SMITH RD',0,'LITCHFIELD','OH','44253','9707','CY','39103','1960-04-02','F','R',':RET:2106-3','N','021','HLT','2415688','52664OH151001501','2014-02-01','2014-01-14 11:22:26','0.00',NULL,NULL,'545.63','545.63','R-OH012','OH0','545.63',NULL,0,'2014-01-15 02:08:03'),(19538,15572,'Y','18','021','EC','A','','','AC','0000951828','0000951828','OH00001606146','IL','1','Tipton','Janyce','','','','34','278468877','5550 GAY ST',0,'TOLEDO','OH','43613','1911','CY','39095','1954-11-12','F','U',':RET:2106-3','N','021','HLT','2759411','92036OH004002601','2014-03-01','2014-01-21 22:42:48','405.16',NULL,NULL,'408.14','2.98','R-OH001','OH0','408.14',NULL,0,'2014-01-23 03:02:23'),(20234,16144,'Y','18','021','EC','A','','','AC','0000685509','0000685509','MS00002155354','31','1','Roberts','Ginger','','','','34','587571965','Post Office Box 647',0,'New Albany','MS','38652',NULL,'CY','28145','1972-11-05','F','U',':RET:2106-3','N','021','DEN','1857074','46300MS002000101','2014-03-01','2014-01-27 18:42:01','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2014-01-28 21:00:04'),(23417,18658,'Y','18','021','EC','A','','','AC','0000610032','0000610032','TX00001922698','IL','1','johnson','cedrick','','','','34','450372806','1919 n joe ramsey blvd',0,'greenville','TX','75401',NULL,'CY','48231','1976-01-08','M','U',':RET:2054-5','N','021','DEN','3800900','33348TX002000201','2014-03-01','2014-02-12 20:56:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:20'),(24255,19260,'Y','18','021','EC','A','','','AC','0000507939','0000507939','TX00002794903','IL','1','Vo','Co','','','','34','731260218','9122 FERNDALE VIEW DR',0,'HOUSTON','TX','77064','3487','CY','48201','1980-11-21','F','M',':RET:2047-9','N','021','DEN','3759592','33348TX002000201','2014-04-01','2014-02-16 19:39:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-17 19:00:06'),(712,589,'Y','18','021','EC','A','','','AC','0001233038','0001233038','OH00000502304','IL','1','perkins','denise','','','','34','237514148','69 W WASHBURN ST',0,'NEW LONDON','OH','44851','1048','CY','39077','1972-10-17','F','M',':RET:2106-3','N','021','HLT','2175371','92036OH005002705','2014-01-01','2013-12-16 10:32:04','250.00',NULL,NULL,'503.10','253.10','R-OH006','OH0','253.89',NULL,0,'2013-12-25 18:03:14'),(2023,1657,'N','01','021','EC','A',NULL,NULL,'','0001075287','0001115911','','IL','1','Ridgeway','Nancy','J','','','34','278605032','1522 Newton Pass',0,'Broadview Heights','OH','44147',NULL,'CY','39035','1957-06-10','F','',NULL,'N','021','HLT','1121237','52664OH152000901','2014-01-01','2013-12-09 21:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','429.79',NULL,0,'2013-12-25 19:15:09'),(21271,17000,'Y','18','021','EC','A','','','AC','0000058789','0000058789','OH00001751567','IL','1','Keener','Julie','','','','34','301802522','246 N LYMAN ST',0,'WADSWORTH','OH','44281','1818','CY','39103','1976-04-09','F','M',':RET:2106-3','N','021','HLT','3351165','52664OH152000901','2014-03-01','2014-02-03 11:54:24','0.00',NULL,NULL,'202.22','202.22','R-OH012','OH0','202.22',NULL,0,'2014-02-03 21:01:31'),(20338,16241,'Y','18','021','EC','A','','','AC','0001653667','0001653667','LA00002141440','IL','1','Crow','Paige','','','','34','434794368','108 crow street',0,'Marion','LA','71260',NULL,'CY','22111','1990-02-01','F','U',':RET:2054-5','N','021','DEN','3297725','18575LA002000101','2014-03-01','2014-01-28 16:44:37','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-28 21:01:06'),(19870,15849,'Y','18','021','EC','A','','','AC','0000702801','0000702801','OH00002474682','IL','1','Mejia','Miriam','','','','34','053786199','1840 Shirley Ave',0,'Hamilton','OH','45011',NULL,'CY','39017','1965-03-06','F','U',NULL,'N','021','DEN','2190190','99734OH005000401','2014-03-01','2014-01-24 09:46:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-24 21:00:40'),(5569,4419,'Y','18','021','EC','A','','','AC','0001057951','0001057951','OH00000274806','IL','1','Scrivner','Michael','','','','34','288749878','8072 MILL CREEK CIR',0,'WEST CHESTER','OH','45069','1649','CY','39017','1973-06-14','M','M',':RET:2106-3','T','021','DEN','174461','99734OH005000301','2014-01-01','2013-11-06 09:38:55','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:16:38'),(7724,6117,'Y','18','021','EC','A','','','AC','0000518404','0000518404','OH00000676516','IL','1','Banchek','Amanda','','','','34','277805738','2606 Hampshire Road',0,'Cleveland Heights','OH','44106',NULL,'CY','39035','1974-01-24','F','U',':RET:2106-3','N','021','DEN','2406295','99734OH005000401','2014-01-01','2013-12-20 14:16:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:49'),(18674,14887,'Y','18','021','EC','A','','','AC','0000621604','0000621604','TX00002488477','IL','1','CORDOVA','RUBY','','','','34','525155848','2301 E I 40',0,'AMARILLO','TX','79104',NULL,'CY','48375','1962-05-28','F','U',':RET:2106-3','N','021','DEN','1702819','33348TX002000201','2014-02-01','2014-01-15 19:31:24','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-17 03:35:18'),(8905,7062,'Y','18','021','EC','A','','','AC','0001208285','0001208285','OH00001233324','IL','1','Bangerter','Amy','','','','34','295863242','1110 SPINNING RD',0,'DAYTON','OH','45432','1642','CY','39113','1987-09-23','F','U',':RET:2106-3','N','021','DEN','1794045','99734OH005000401','2014-01-01','2013-12-17 20:06:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:02:24'),(14005,11158,'Y','18','021','EC','A','','','AC','0000485859','0000485859','OH00001017641','IL','1','Bickerstaff','Dorothy','','','','34','300508823','3016 NILES CARVER RD',0,'NILES','OH','44446','1330','CY','39155','1951-09-21','F','M',':RET:2106-3','N','021','HLT','1370468','92036OH003003201','2014-01-01','2013-12-23 09:39:55','958.00',NULL,NULL,'1584.33','626.33','R-OH013','OH0','726.22',NULL,0,'2013-12-26 13:16:12'),(14375,11466,'Y','18','021','EC','A','','','AC','0000781908','0000781908','OH00001594859','IL','1','CIOTTI','LINDA','','','','34','288502170','2720 S UNION AVE',0,'ALLIANCE','OH','44601','5085','CY','39151','1951-04-05','F','M',':RET:2106-3','N','021','DEN','1629827','99734OH005000401','2014-02-01','2013-12-27 11:35:41','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-28 03:30:39'),(15856,12695,'Y','18','024','14','A','','','TE','0000847160','0000847160','','IL','1','Simmons','Dominique',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-10-01','F','',NULL,NULL,NULL,'','2439810','','2014-01-02','2014-01-02 11:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:04:36'),(15760,12610,'Y','18','021','EC','A','','','AC','0000250716','0000250716','TX00001618886','31','1','HINOJOSA','IRMA','','','','34','457236504','P.O. BOX 1042',0,'EDCOUCH','TX','78538',NULL,'CY','48215','1961-06-18','F','U',NULL,'N','021','DEN','1705245','33348TX002000201','2014-02-01','2014-01-02 11:35:36','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-03 02:01:27'),(22713,18137,'Y','18','021','EC','A','','','AC','0002067533','0002067533','LA00001855515','IL','1','Arroyo-Tabin','Taylor','Teresa','','','34','607402617','2109 RICHLAND AVE',0,'METAIRIE','LA','70001','1646','CY','22051','1990-08-07','F','U',':RET:2106-3','N','021','DEN','2683461','18575LA002000201','2014-03-01','2014-02-11 00:19:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:05'),(28924,22891,'Y','18','021','EC','A','','','AC','0000019167','0000019167','OH00003590229','IL','1','Welch','Matthew','Ryan','','','34','300908181','7351 Cayman Way',0,'Maineville','OH','45039',NULL,'CY','39165','1987-05-26','M','M',':RET:2106-3','N','021','DEN','4022804','99734OH005000301','2014-04-01','2014-03-10 12:48:07','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:00:32'),(24435,19409,'Y','18','021','EC','A','','','AC','0001110410','0001110410','OH00003033316','IL','1','CARPENTER','CHRISTOPHER','GENE','','','34','276721071','4621 STATE ROUTE 43',0,'KENT','OH','44240','6431','CY','39133','1969-10-13','M','M',':RET:2106-3','T','021','HLT','2968113','52664OH151001305','2014-04-01','2014-02-18 14:49:11','528.00',NULL,NULL,'858.88','330.88','R-OH012','OH0','358.27',NULL,0,'2014-02-18 22:01:15'),(24642,19559,'Y','18','021','EC','A','','','AC','0001202245','0001202245','LA00002744088','IL','1','DANIEL','SAMUEL','L','','Sr','34','433880206','112 ALTHEA DR',0,'MONROE','LA','71202','6033','CY','22073','1959-01-25','M','U',':RET:2054-5','T','021','DEN','3219078','18575LA002000201','2014-04-01','2014-02-19 11:34:06','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 04:20:21'),(899,746,'Y','18','021','EC','A','','','AC','0001171873','0001171873','OH00000252266','IL','1','Piper','Lindsay','','','','34','287904195','6091 W STATE ROUTE 29',0,'URBANA','OH','43078','9360','CY','39021','1989-05-29','F','U',':RET:2106-3','T','021','HLT','1957706','92036OH003000501','2014-01-01','2013-12-16 13:07:50','0.00',NULL,NULL,'285.47','285.47','R-OH003','OH0','285.47',NULL,0,'2013-12-25 18:08:13'),(1901,1554,'N','01','021','EC','A',NULL,NULL,'','0000535762','0000532109','','IL','1','Fichera','Rossana',NULL,NULL,NULL,NULL,NULL,'20350 Mosher rd',0,'wellington','OH','44090',NULL,'CY','39093','1950-11-06','F','',NULL,'N','021','HLT','1939365','92036OH005000805','2014-01-01','2013-12-24 15:33:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','690.16',NULL,0,'2013-12-25 18:59:08'),(13750,10975,'N','01','021','EC','A',NULL,NULL,'','0001095656','0000507986','','IL','1','EACHUS','KIMBERLY','','','','34','297604352','124 GEIGER ST',0,'BLUFFTON','OH','45817','1412','CY','39003','1977-05-08','F','',NULL,'N','021','HLT','2010668','92036OH004001501','2014-01-01','2013-12-23 13:35:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','217.67',NULL,0,'2013-12-26 13:09:55'),(18967,15113,'Y','18','024','14','A','','','TE','0000373653','0000373653','','IL','1','smalley','kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-06-02','M','',NULL,NULL,NULL,'','2424844','','2014-01-16','2014-01-16 18:52:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:05:59'),(2836,2292,'Y','18','021','EC','A','','','AC','0001250802','0001250802','OH00001042650','IL','1','Carman','Philip','','','','34','301522155','4291 GREENWOOD DR',0,'UNIONTOWN','OH','44685','7921','CY','39153','1955-08-11','M','U',':RET:2106-3','N','021','HLT','1142571','52664OH152000901','2014-01-01','2013-11-24 11:02:38','0.00',NULL,NULL,'416.19','416.19','R-OH012','OH0','416.19',NULL,0,'2013-12-25 20:00:55'),(15712,12569,'Y','18','021','EC','A','','','AC','0000911776','0000911776','OH00000181510','IL','1','CARTER','SYLVIA','','','','34','279648592','510 MAPLE ST',0,'WAPAKONETA','OH','45895','2320','CY','39011','1959-07-09','F','M',NULL,'T','021','HLT','2205770','92036OH006001501','2014-02-01','2013-12-31 16:53:08','724.00',NULL,NULL,'784.60','60.60','R-OH002','OH0','428.54',NULL,1,'2014-01-02 04:36:06'),(5358,4249,'Y','18','021','EC','A','','','AC','0000615505','0000615505','OH00000551979','IL','1','Matthiesen','Karen','','','','34','286462125','1702 MARIGOLD AVE',0,'AKRON','OH','44301','2555','CY','39153','1949-10-17','F','M',NULL,'N','021','HLT','2496667','52664OH152000901','2014-01-01','2013-12-19 17:07:35','490.00',NULL,NULL,'490.00','0.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 23:07:46'),(7051,5601,'Y','18','021','EC','A','','','AC','0001139507','0001139507','OH00000754608','IL','1','DAlbenzio','Diane','','','','34','268500110','322 LOVERS LN',0,'STEUBENVILLE','OH','43953','3448','CY','39081','1950-07-20','F','U',':RET:2106-3','N','021','DEN','2093859','99734OH005000301','2014-01-01','2013-12-24 19:11:30','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:49:41'),(7264,5759,'N','01','021','EC','A',NULL,NULL,'','0000361689','0000407812','','IL','1','Betty','Anita','Kay','','','34','451733997','410 N MADISON ST',0,'SAN ANGELO','TX','76901','1766','CY','48451','1967-06-18','F','',':RET:2106-3','N','021','DEN','234756','33348TX002000201','2014-01-01','2013-12-13 22:17:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 02:02:13'),(7158,5678,'Y','18','021','EC','A','','','AC','0000318414','0000318414','OH00001080264','IL','1','FORSTER','KIMBERLY','','','','34','367869897','311 E CORNELIA ST',0,'HICKSVILLE','OH','43526','1213','CY','39039','1976-07-25','F','M',':RET:2106-3','N','021','HLT','2182204','92036OH004002601','2014-01-01','2013-12-24 21:08:20','494.00',NULL,NULL,'500.16','6.16','R-OH001','OH0','194.11',NULL,0,'2013-12-26 01:52:22'),(20760,16586,'Y','18','021','EC','A','','','AC','0000893179','0000893179','OH00001459348','IL','1','VARGO','DEBORAH','LEE','','','34','287541072','1 S HAMILTON ST',0,'MONREVILLE','OH','44847',NULL,'CY','39077','1954-07-25','F','U',':RET:2106-3','N','021','HLT','3114093','92036OH003002704','2014-03-01','2014-01-30 13:42:57','370.00',NULL,NULL,'530.07','160.07','R-OH006','OH0','530.07',NULL,0,'2014-01-30 21:01:34'),(22724,18145,'Y','18','021','EC','A','','','AC','0002219394','0002219394','LA00002370057','IL','1','Webb','James','','','','34','437174456','3147 woodglynn dr',0,'baton rouge','LA','70814',NULL,'CY','22033','1965-12-11','M','U',':RET:2054-5','N','021','DEN','3486925','18575LA002000201','2014-03-01','2014-02-11 13:09:53','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-11 21:01:11'),(26309,20873,'Y','18','021','EC','A','','','AC','0000426457','0000426457','TX00003408454','S1','1','Mammadova','Gulnara','Alimund','','','34','644136885','14718 Perthshire Rd.',0,'Houston','TX','77079',NULL,'CY','48201','2004-06-11','F','U',':RET:2106-3','N','021','DEN','3154328','33348TX002000101','2014-03-01','2014-02-27 12:41:29','0.00',NULL,NULL,'47.10','47.10','R-TX010','TX0','47.10',NULL,0,'2014-02-28 06:31:32'),(27834,22015,'Y','18','021','EC','A','','','AC','0001239185','0001239185','OH00002821005','IL','1','SUTTON','APRIL','','','','34','284703587','776 GARBERDALE SQUARE',0,'BOLIVAR','OH','44612',NULL,'CY','39157','1965-10-26','F','U',NULL,'N','021','DEN','3141358','99734OH005000301','2014-04-01','2014-03-05 14:14:03','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-03-05 21:32:02'),(17892,14291,'Y','18','021','EC','A','','','AC','0001100616','0001100616','OH00001805676','IL','1','Thomas','Joseph','','','','34','297846988','3394 VERNER RD',0,'KENT','OH','44240','5239','CY','39153','1986-04-15','M','U',':RET:2106-3','N','021','DEN','2865976','99734OH005000401','2014-02-01','2014-01-14 15:53:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:20'),(4413,3506,'Y','18','021','EC','A','','','AC','0000266517','0000266517','OH00000724858','IL','1','BURGER','ROBIN','','','','34','296705831','18908 ROCKLAND AVE',0,'CLEVELAND','OH','44135','3964','CY','39035','1962-07-22','F','U',':RET:2106-3','N','021','DEN','1237373','99734OH005000401','2014-01-01','2013-12-12 14:56:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:25'),(5821,4623,'Y','18','021','EC','A','','','AC','0000944263','0000944263','TX00001070390','IL','1','Chisum','Alesse','','','','34','628036403','1110 s w 2nd st',0,'crane','TX','79731',NULL,'CY','48103','1987-03-05','F','U',':RET:2106-3','N','021','DEN','1828686','33348TX002000201','2014-01-01','2013-12-23 22:11:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:48:00'),(1919,1565,'Y','18','021','EC','A','','','AC','0000076272','0000076272','OH00000115545','IL','1','Miller','Brian','','','','34','284848642','2309 STONEY RUN TRL',0,'BROADVIEW HEIGHTS','OH','44147','2558','CY','39035','1986-03-23','M','U',':RET:2106-3','N','021','DEN','762217','99734OH005000301','2014-01-01','2013-11-20 09:30:12','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:00:07'),(25530,20253,'Y','18','024','14','A','','','TE','0000805910','0000805910','','IL','1','SANTOS','CELESTE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-11-27','F','',NULL,NULL,NULL,'','2909042','','2014-02-22','2014-02-22 19:16:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-26 08:00:04'),(28075,22219,'Y','18','021','EC','A','','','AC','0001149922','0001149922','OH00003662597','IL','1','Adams','Thomas','Jason','','','34','285888122','855 Rombach Avenue',0,'Wilmington','OH','45177',NULL,'CY','39027','1979-01-10','M','M',':RET:2106-3','N','021','DEN','2831135','99734OH005000301','2014-04-01','2014-03-06 16:49:13','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-03-06 21:01:53'),(19647,15657,'N','01','021','EC','A',NULL,NULL,'','0000412235','0000300436','','IL','1','Costello','John','','','','34','140440485','4630 Collingville Way',0,'Columbus','OH','43230',NULL,'CY','39049','1949-07-08','M','',':RET:2106-3','N','021','DEN','1483410','99734OH005000401','2014-03-01','2014-01-23 09:35:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:18'),(13402,10694,'N','19','021','EC','A',NULL,NULL,'','0001075301','0000308266','','IL','1','Danner','Sarah','Grace','','','34','291020906','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1997-07-29','F','',':RET:2106-3','N','021','DEN','2539568','99734OH005000301','2014-01-01','2013-12-23 09:16:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:21'),(2812,2273,'Y','18','021','EC','A','','','AC','0000272784','0000272784','TX00000991892','IL','1','ACOSTA MORALES','GENOVEVA','','','','34','506518308','13341 GREENDALE DR',0,'EL PASO','TX','79928','5632','CY','48141','1965-01-28','F','M',NULL,'N','021','DEN','843652','33348TX002000201','2014-01-01','2013-11-23 18:05:51','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 20:00:17'),(16869,13497,'N','01','021','EC','A',NULL,NULL,'','0000380515','0000329373','','IL','1','Jones','Ruthie','','','','34','454023831','985 S JOHNSON ST',0,'SLATON','TX','79364','5808','CY','48303','1953-02-20','F','',':RET:2054-5','N','021','DEN','2152484','33348TX002000201','2014-02-01','2014-01-09 12:35:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:19:14'),(3667,2933,'Y','18','021','EC','A','','','AC','0000893134','0000893134','OH00000909423','IL','1','Frank','Evan','','','','34','299886920','5424 DRY RUN RD',0,'MILFORD','OH','45150','9530','CY','39025','1988-03-25','M','U',':RET:2106-3','N','021','DEN','978702','99734OH005000401','2014-01-01','2013-12-12 20:40:22','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:31:03'),(9095,7219,'Y','18','021','EC','A','','','AC','0000484768','0000484768','OH00000021292','IL','1','Altemus','Dorothy','E','','','34','287485035','8273 MANOR GATE WAY',0,'MENTOR','OH','44060','5971','CY','39085','1950-05-17','F','U',':RET:2106-3','N','021','DEN','2339619','99734OH005000301','2014-01-01','2013-12-18 12:22:28','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:07:13'),(7973,6311,'Y','18','021','EC','A','','','AC','0000125549','0000125549','OH00000219987','IL','1','Sehm','Jennifer','M','','','34','269524917','1104 PORTAGE LAKES DR',0,'AKRON','OH','44319','1432','CY','39153','1964-10-05','F','U',':RET:2106-3','N','021','HLT','2539416','52664OH151001305','2014-01-01','2013-12-19 20:27:16','255.00',NULL,NULL,'380.45','125.45','R-OH012','OH0','380.45',NULL,0,'2013-12-26 03:07:45'),(5544,4399,'Y','18','021','EC','A','','','AC','0000805082','0000805082','OH00001053613','IL','1','Hall','Lisa','Sue','','','34','295522719','13947 KAUFFMAN AVE',0,'STERLING','OH','44276','7401','CY','39169','1958-01-17','F','U',':RET:2106-3','T','021','HLT','828308','52664OH151001306','2014-01-01','2013-11-26 20:28:00','375.00',NULL,NULL,'571.90','196.90','R-OH014','OH0','571.90',NULL,0,'2013-12-25 23:15:55'),(21418,17119,'Y','18','021','EC','A','','','AC','0000199700','0000199700','OH00002377472','IL','1','LONG','DORIS','','','','34','283707604','1236 FERNWOOD AVE',0,'TOLEDO','OH','43607',NULL,'CY','39095','1961-03-01','F','U',':RET:2054-5','N','021','HLT','2375728','92036OH006002601','2014-03-01','2014-02-04 11:29:23','0.00',NULL,NULL,'315.47','315.47','R-OH001','OH0','315.47',NULL,0,'2014-02-04 21:01:12'),(21633,17273,'Y','18','021','EC','A','','','AC','0000575015','0000575015','TX00002163323','IL','1','ACUNA','EVA','','','','34','631244114','321 OREGANO ST',0,'EDINBURG','TX','78541','7250','CY','48215','1991-03-15','F','U',':RET:2106-3','N','021','DEN','3621728','33348TX002000201','2014-03-01','2014-02-05 12:10:52','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-05 21:30:42'),(23815,18949,'N','01','021','EC','A',NULL,NULL,'','0000625469','0000664228','','IL','1','Kreakie','Catherine','Renee','','','34','279843734','1882 BROOKWOOD CT',0,'ORRVILLE','OH','44667','2368','CY','39169','1985-01-22','F','',':RET:2106-3','N','021','HLT','2897356','52664OH152000901','2014-03-01','2014-02-14 17:45:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.78',NULL,0,'2014-02-14 21:31:37'),(24645,19562,'Y','18','021','EC','A','','','AC','0001276993','0001276993','LA00001650140','IL','1','Vancol','Joseph','','','','34','070681655','1284 LAURADALE DR',0,'NEW ORLEANS','LA','70114','2832','CY','22071','1954-06-26','M','U',':RET:2054-5','N','021','DEN','2887473','18575LA002000201','2014-04-01','2014-02-19 14:25:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 04:21:10'),(26504,21023,'Y','18','021','EC','A','','','AC','0000622531','0000622531','OH00003238079','IL','1','Jordan','Timothy','','','','34','275808524','10271 kenwood',0,'Cincinnati','OH','45242',NULL,'CY','39061','1966-04-25','M','U',':RET:2106-3','N','021','DEN','3527060','99734OH005000401','2014-04-01','2014-02-28 10:43:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-28 21:00:16'),(28844,22825,'Y','18','021','EC','A','','','AC','0000072943','0000072943','OH00002717779','IL','1','Morris','Rebecca','','','','34','271865727','1884 MALASIA RD',0,'AKRON','OH','44305','3672','CY','39153','1980-08-13','F','M',':RET:2106-3','N','021','HLT','3281234','52664OH152000901','2014-04-01','2014-03-09 13:59:40','183.00',NULL,NULL,'388.91','205.91','R-OH012','OH0','195.68',NULL,0,'2014-03-09 21:01:14'),(13555,10810,'Y','18','021','EC','A','','','AC','0002193459','0002193459','LA00000833980','IL','1','Hilliard','Donald','','','','34','433256465','11975 LAKELAND PARK BLVD',0,'BATON ROUGE','LA','70809','4217','CY','22033','1963-07-23','M','U',NULL,'N','021','DEN','2524368','18575LA002000201','2014-01-01','2013-12-23 15:17:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:12'),(17585,14057,'Y','18','021','EC','A','','','AC','0000060285','0000060285','OH00002521550','IL','1','McCue','Michelle','','','','34','299606635','1050 N CARPENTER RD',0,'BRUNSWICK','OH','44212','2236','CY','39103','1974-09-23','F','M',':RET:2106-3','N','021','DEN','2457716','99734OH005000401','2014-02-01','2014-01-13 15:45:14','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-14 01:32:07'),(14629,11676,'Y','18','021','EC','A','','','AC','0000424034','0000424034','OH00000723006','IL','1','Freeland','Greta','','','','34','311564168','14915 STATE ROUTE 136',0,'WINCHESTER','OH','45697','9729','CY','39001','1951-02-03','F','U',NULL,'T','021','HLT','1537027','92036OH004000601','2014-02-01','2013-12-27 12:23:16','457.00',NULL,NULL,'570.30','113.30','R-OH005','OH0','570.30',NULL,0,'2013-12-28 03:37:08'),(16021,12825,'Y','18','021','EC','A','','','AC','0001962357','0001962357','LA00000438054','IL','1','LEONARD','BRANDON','','','','34','433757637','1457 NATALIE ST',0,'SHREVEPORT','LA','71108','3530','CY','22017','1985-08-15','M','M',':RET:2054-5','N','021','DEN','1499287','18575LA002000201','2014-02-01','2014-01-03 07:25:02','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-04 02:02:10'),(14672,11712,'N','01','021','EC','A',NULL,NULL,'','0000932501','0000088450','','IL','1','Harris','Christina','M','','','34','450914876','8128 County Road 3409',0,'Chandler','TX','75758',NULL,'CY','48213','1977-04-19','F','',':RET:2106-3','N','021','DEN','2250650','33348TX002000201','2014-02-01','2013-12-28 17:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2013-12-29 11:08:17'),(5604,4447,'Y','18','021','EC','A','','','AC','0001205787','0001205787','OH00000460617','IL','1','Gips','Arkadiy','','','','34','294969962','622 Parkfair Pl',0,'Columbus','OH','43213',NULL,'CY','39049','1955-07-31','M','U',':RET:2106-3','N','021','DEN','598581','99734OH005000401','2014-01-01','2013-11-25 20:12:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:30:20'),(9771,7738,'Y','18','021','EC','A','','','AC','0000258728','0000258728','LA00001223782','IL','1','Johnson','Stella','','','','34','434020170','1305 E BAYOU RD',0,'DONALDSONVILLE','LA','70346','3838','CY','22005','1956-09-08','F','U',':RET:2054-5','T','021','DEN','614306','18575LA002000201','2014-01-01','2013-10-19 22:28:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 05:00:28'),(4223,3361,'Y','18','021','EC','A','','','AC','0000500653','0000500653','TX00001290987','IL','1','Noel','Connie','','','','34','455190223','402 E CASTLELAKE DR',0,'GRANITE SHOALS','TX','78654','2304','CY','48053','1957-01-04','F','U',':RET:2106-3','N','021','DEN','1475988','33348TX002000201','2014-01-01','2013-12-17 10:56:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:29'),(13131,10473,'Y','18','021','EC','A','','','AC','0000912952','0000912952','OH00000214210','IL','1','HARDING','AMELIA','','','','34','280862597','487 W FOSTER  MAINEVILLE',0,'MAINEVILLE','OH','45039',NULL,'CY','39165','1952-07-10','F','U',':RET:2028-9','N','021','DEN','2369470','99734OH005000401','2014-01-01','2013-12-23 14:40:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:01'),(4990,3961,'Y','18','021','EC','A','','','AC','0000327249','0000327249','OH00001215093','IL','1','Rice','Angel','','','','34','300866413','5137 RIVERVIEW DR',0,'SOUTH LEBANON','OH','45065','8782','CY','39165','1977-03-23','F','M',':RET:2106-3','N','021','DEN','272020','99734OH005000301','2014-01-01','2013-12-06 21:42:42','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:46:56'),(21499,17175,'N','01','021','EC','A',NULL,NULL,'','0000439443','0000158027','','IL','1','Nguyen','Sam','','','','34','363139778','1201 BERNATH PKWY',0,'TOLEDO','OH','43615','6741','CY','39095','1973-10-30','M','',':RET:2047-9','T','021','HLT','3626937','92036OH003002605','2014-03-01','2014-02-04 12:28:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','299.29',NULL,0,'2014-02-04 21:01:51'),(22799,18199,'N','19','021','EC','A',NULL,NULL,'','0000229477','0000690777','','IL','1','Swisher','Kimberly','','','','34','286925532','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1990-08-12','F','',':RET:2106-3','N','021','DEN','3292565','99734OH005000301','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:52'),(24805,19672,'Y','18','021','EC','A','','','AC','0000108209','0000108209','OH00001952089','IL','1','RENTSCHLER','CINDY','','','','34','296608590','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247',NULL,'CY','39061','1962-03-18','F','U',':RET:2106-3','N','021','DEN','2618926','99734OH005000401','2014-04-01','2014-02-19 13:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:48:52'),(28430,22497,'N','01','021','EC','A',NULL,NULL,'','0000976807','0001250902','','IL','1','JONES','ALFRED','','','III','34','294841879','73 EASTGAY DR',0,'AKRON','OH','44313',NULL,'CY','39153','1981-06-12','M','',NULL,'N','021','DEN','3690096','99734OH005000401','2014-04-01','2014-03-07 16:51:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:08'),(17863,14270,'Y','18','021','EC','A','','','AC','0000818601','0000818601','OH00002491108','IL','1','johnson','marc','','','','34','275600392','6218 HANNA RD',0,'RAVENNA','OH','44266','8528','CY','39133','1962-11-03','M','U',':RET:2106-3','N','021','DEN','1487900','99734OH005000401','2014-02-01','2014-01-14 11:43:43','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:11'),(7852,6218,'Y','18','021','EC','A','','','AC','0000192727','0000192727','OH00000255950','IL','1','Lehman','Ronald','H','','','34','295423213','842 JOHNSON PLANK RD NE',0,'WARREN','OH','44481','9361','CY','39155','1949-10-28','M','M',':RET:2106-3','N','021','DEN','1509377','99734OH005000301','2014-01-01','2013-12-20 09:38:46','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-26 03:04:52'),(7862,6222,'Y','18','024','14','A','','','TE','0000998760','0000998760','','IL','1','Horner','Torey','Jay',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-06-20','F','',NULL,NULL,NULL,'','904097','','2013-12-20','2013-12-20 14:33:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:05:01'),(5144,4078,'Y','18','021','EC','A','','','AC','0000932098','0000932098','OH00001267704','IL','1','Watson','Theodore','','','','34','270865224','476 LINCOLN AVE',0,'STRUTHERS','OH','44471','1014','CY','39099','1986-05-01','M','U',':RET:2106-3','N','021','DEN','2060299','99734OH005000401','2014-01-01','2013-12-19 07:45:10','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:02:38'),(23270,18552,'N','19','021','EC','A',NULL,NULL,'','0000848565','0001074462','','IL','1','Nwanne','Miriam','','','','34','627203703','8318 Lighthouse Drive',0,'Rowlett','TX','75089',NULL,'CY','48113','1990-08-15','F','',NULL,'N','021','DEN','3156478','33348TX002000101','2014-03-01','2014-02-13 09:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-13 21:30:13'),(14150,11279,'Y','18','021','EC','A','','','AC','0001220846','0001220846','LA00001255877','IL','1','matthews','melody','','','','34','323729421','220 N FORREST RD',0,'PLAIN DEALING','LA','71064','4033','CY','22015','1967-04-05','F','U',':RET:1002-5^:RET:2106-3','T','021','DEN','1463680','18575LA002000201','2014-02-01','2013-12-26 13:24:10','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-27 02:02:52'),(950,783,'Y','18','021','EC','A','','','AC','0000265197','0000265197','OH00000912533','IL','1','Pickrel','Sharon','','','','34','578843659','1005 REGINA AVE',0,'CINCINNATI','OH','45205','2430','CY','39061','1958-09-23','F','U',':RET:2106-3','T','021','DEN','239845','99734OH005000301','2014-01-01','2013-10-29 11:23:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:33'),(20205,16121,'N','01','021','EC','A',NULL,NULL,'','0000498198','0000970482','','IL','1','moeller','susan','','','','34','409137006','4146 ST RT 707',0,'Rockford','OH','45882',NULL,'CY','39107','1962-01-16','F','',':RET:2106-3','N','021','HLT','1585152','92036OH002001501','2014-03-01','2014-01-27 10:26:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','496.12',NULL,0,'2014-01-27 21:01:34'),(3998,3193,'Y','18','024','14','A','','','TE','0000042032','0000042032','','IL','1','Cioffi','Nicolle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-29','F','',NULL,NULL,NULL,'','519964','','2013-12-16','2013-12-16 18:41:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:07'),(17231,13790,'Y','18','021','EC','A','','','AC','0000250181','0000250181','MS00001932118','IL','1','Scott','Larry','','','','34','427041704','110 FAIROAKS DR',0,'JACKSON','MS','39212','2223','CY','28049','1956-10-31','M','M',':RET:2054-5','N','021','DEN','2096722','46300MS002000101','2014-02-01','2014-01-08 12:52:20','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-13 02:22:40'),(21269,16998,'Y','18','024','14','A','','','TE','0000827041','0000827041','','IL','1','Kemper','Ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-04-20','F','',NULL,NULL,NULL,'','2042778','','2014-02-03','2014-02-03 15:59:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:01:29'),(22198,17717,'Y','18','021','EC','A','','','AC','0000585566','0000585566','OH00001555174','IL','1','Harbin','Renee','','','','34','280742401','932 West Drive',0,'Sheffield Lake','OH','44054',NULL,'CY','39093','1962-09-16','F','U',':RET:2106-3','T','021','DEN','3165023','99734OH005000401','2014-03-01','2014-02-08 20:59:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-09 19:00:13'),(22410,17893,'N','01','021','EC','A',NULL,NULL,'','0001441723','0001241393','','IL','1','tardo','Joel','','','','34','439673412','2421 MARGARET LN',0,'MERAUX','LA','70075','2731','CY','22087','1982-09-25','M','',':RET:2106-3','N','021','DEN','3656760','18575LA002000201','2014-03-01','2014-02-10 10:12:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-10 21:30:25'),(24014,19098,'Y','18','021','EC','A','','','AC','0000841967','0000841967','OH00002305561','IL','1','BLUST','KRISTEN','','','','34','290906381','2034 DALLAS AVE',0,'CINCINNATI','OH','45239','4700','CY','39061','1989-04-11','F','U',NULL,'N','021','DEN','3057260','99734OH005000401','2014-03-01','2014-02-15 12:33:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:42'),(26614,21103,'Y','18','021','EC','A','','','AC','0000698566','0000698566','TX00002884681','IL','1','Gaona','Cynthia','','','','34','888537838','8901 Bissonnet St.',0,'HOUSTON','TX','77074',NULL,'CY','48201','1979-11-12','F','M',NULL,'N','021','DEN','3014789','33348TX002000201','2014-04-01','2014-02-28 11:11:29','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-28 21:30:49'),(28570,22609,'Y','18','021','EC','A','','','AC','0000027958','0000027958','OH00002919502','IL','1','Hubbard','Ronald','','','','34','271728612','750 Wells Street',0,'Cincinnati','OH','45205',NULL,'CY','39061','1966-03-25','M','U',':RET:2106-3','N','021','HLT','2635585','92036OH006001201','2014-04-01','2014-03-07 17:36:46','108.00',NULL,NULL,'278.36','170.36','R-OH004','OH0','278.36',NULL,0,'2014-03-07 21:32:31'),(18736,14930,'Y','18','021','EC','A','','','AC','0001103467','0001103467','OH00001707906','IL','1','KOHUT','PENNY','S','','','34','301560031','78 W HINES HILL RD',0,'HUDSON','OH','44236','1031','CY','39153','1959-01-31','F','M',':RET:2106-3','N','021','DEN','2893002','99734OH005000301','2014-03-01','2014-01-16 16:00:43','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:35:38'),(1015,832,'Y','18','021','EC','A','','','AC','0000646187','0000646187','MS00000015366','IL','1','Sullivan','Seth','','','','34','426633354','1401 WALNUT ST',0,'WAYNESBORO','MS','39367','2233','CY','28153','1981-02-15','M','M',':RET:2106-3','N','021','DEN','607964','46300MS002000201','2014-01-01','2013-12-03 00:02:52','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:15:06'),(1320,1091,'Y','18','021','EC','A','','','AC','0000481030','0000481030','OH00000971676','IL','1','Liles','Kevin','','','','34','294626936','2230 WOODLAWN RD',0,'PORTSMOUTH','OH','45662','3016','CY','39145','1970-05-17','M','U',':RET:2106-3','N','021','DEN','1051214','99734OH005000301','2014-01-01','2013-11-03 21:05:18','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:31:41'),(18633,14852,'N','01','021','EC','A',NULL,NULL,'','0001253148','0000968440','','IL','1','DUNCAN','TAMMY','LYNN','','','34','575042926','14197 RANIER POINT DR',0,'EL PASO','TX','79938','5204','CY','48141','1968-01-15','F','',NULL,'N','021','DEN','1712407','33348TX002000201','2014-02-01','2014-01-15 21:34:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:03'),(16396,13119,'Y','18','021','EC','A','','','AC','0000170134','0000170134','TX00002056967','IL','1','Lang','Tasha','','','','34','450711202','155 W. Overly Dr.',0,'Lake Dallas','TX','75065',NULL,'CY','48121','1984-11-17','F','U',':RET:2106-3','N','021','DEN','1455861','33348TX002000201','2014-02-01','2014-01-06 13:00:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:43'),(8812,6986,'Y','18','021','EC','A','','','AC','0000111881','0000111881','OH00000570680','IL','1','Hicks','Rogers','','','','34','275586498','988 CLEPPER LN',0,'BATAVIA','OH','45103','2318','CY','39025','1957-07-31','M','M',':RET:2106-3','N','021','HLT','2085621','92036OH004000601','2014-01-01','2013-12-17 18:32:07','350.00',NULL,NULL,'754.83','404.83','R-OH005','OH0','402.70',NULL,0,'2013-12-26 04:00:03'),(15226,12171,'Y','18','021','EC','A','','','AC','0001475373','0001475373','LA00001573822','31','1','Porter','Cynthia','','','','34','438334407','po box 9532',0,'monroe','LA','71211',NULL,'CY','22073','1964-09-13','F','U',':RET:2054-5','N','021','DEN','1958434','18575LA002000101','2014-02-01','2013-12-30 18:33:19','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-01 12:08:10'),(7672,6077,'Y','18','021','EC','A','','','AC','0000948406','0000948406','OH00001091468','IL','1','KING','REX','E','','','34','279661524','254 GREENFIELD ST',0,'TIFFIN','OH','44883','2424','CY','39147','1960-06-26','M','M',':RET:2106-3','N','021','HLT','2445884','92036OH005002701','2014-01-01','2013-12-19 18:52:14','419.00',NULL,NULL,'814.11','395.11','R-OH006','OH0','397.79',NULL,0,'2013-12-26 03:00:36'),(4946,3925,'Y','18','021','EC','A','','','AC','0000520933','0000520933','OH00001281333','IL','1','kasch','martha','','','','34','271528133','20 TIMBERLAKE CT',0,'NORTHWOOD','OH','43619','1932','CY','39173','1950-09-24','F','U',':RET:2106-3','N','021','DEN','35626','99734OH005000401','2014-01-01','2013-12-07 14:26:49','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:45:48'),(5124,4061,'Y','18','021','EC','A','','','AC','0000734795','0000734795','TX00001122503','IL','1','read','christina','','','','34','466578904','508 E PINE ST',0,'EDGEWOOD','TX','75117','3141','CY','48467','1977-06-05','F','R',':RET:2106-3','N','021','DEN','1611465','33348TX002000201','2014-01-01','2013-12-18 18:47:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:02:01'),(4711,3735,'Y','18','021','EC','A','','','AC','0000012413','0000012413','OH00000337857','IL','1','BARNT','ELAINE','DAWN','','','34','282601053','535 N WESTMINSTER ST',0,'WAYNESFIELD','OH','45896','9449','CY','39011','1966-10-26','F','U',':RET:2106-3','N','021','HLT','1058452','92036OH005001501','2014-01-01','2013-12-12 13:52:16','280.00',NULL,NULL,'344.00','64.00','R-OH002','OH0','344.00',NULL,0,'2013-12-25 22:08:43'),(21145,16896,'Y','18','021','EC','A','','','AC','0000148281','0000148281','TX00001791690','IL','1','Lopez','Eleanor','','','','34','467470856','1100 RUNNELS ST',0,'BIG SPRING','TX','79720','4337','CY','48227','1979-10-29','F','U',NULL,'N','021','DEN','2962669','33348TX002000201','2014-03-01','2014-02-03 17:09:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:24'),(22557,18014,'Y','18','021','EC','A','','','AC','0000563178','0000563178','OH00002185067','IL','1','Cook','Tammy','','','','34','293824455','3690 VINEYARD HAVEN DR',0,'LOVELAND','OH','45140','3617','CY','39165','1973-06-16','F','U',':RET:2106-3','N','021','DEN','2846509','99734OH005000401','2014-03-01','2014-02-10 11:05:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:49'),(23597,18797,'Y','18','021','EC','A','','','AC','0000766016','0000766016','OH00001975087','IL','1','KELLER','RICHARD','','','','34','454989431','644 NORTHVIEW DR',0,'FOSTORIA','OH','44830','2730','CY','39147','1954-10-29','M','U',':RET:2106-3','T','021','HLT','3345894','92036OH005002705','2014-03-01','2014-02-13 12:15:01','430.00',NULL,NULL,'583.72','153.72','R-OH006','OH0','583.72',NULL,0,'2014-02-13 22:03:05'),(24295,19296,'Y','18','021','EC','A','','','AC','0000806402','0000806402','OH00002490617','IL','1','Holmes','Deborah','','','','34','271665136','844 N HIGHLAND AVE',0,'GIRARD','OH','44420','2022','CY','39155','1958-03-28','F','U',':RET:2106-3','N','021','HLT','3763208','92036OH004003201','2014-04-01','2014-02-18 14:00:40','367.00',NULL,NULL,'454.06','87.06','R-OH013','OH0','454.06','CIC',0,'2014-02-18 21:30:16'),(25427,20175,'N','01','021','EC','A',NULL,NULL,'','0000148390','0000417447','','IL','1','sparks','steve','m','','','34','405740845','8865 canoe dr',0,'galloway','OH','43119',NULL,'CY','39049','1950-09-02','M','',NULL,'N','021','DEN','3836997','99734OH005000401','2014-04-01','2014-02-25 17:33:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:31:12'),(26855,21286,'Y','18','021','EC','A','','','AC','0001179676','0001179676','OH00002408222','31','1','Hayes','Beverly','','','','34','286703832','P. O. Box 568',0,'Georgetown','OH','45121',NULL,'CY','39015','1972-08-21','F','R',':RET:2106-3','N','021','HLT','3452252','92036OH003000601','2014-04-01','2014-02-28 19:34:34','0.00',NULL,NULL,'291.89','291.89','R-OH005','OH0','291.89',NULL,0,'2014-03-01 21:00:53'),(144,123,'Y','18','021','EC','A','','','AC','0000061293','0000061293','OH00000297134','IL','1','Corcodel','Juanita','','','','34','294701729','1186 NEVILLE AVE',0,'AKRON','OH','44306','2947','CY','39153','1960-11-30','F','M',':RET:2106-3','N','021','HLT','1218686','52664OH152000901','2014-01-01','2013-12-05 17:06:49','327.00',NULL,NULL,'333.21','6.21','R-OH012','OH0','333.21',NULL,0,'2013-12-25 17:18:47'),(19612,15631,'Y','18','021','EC','A','','','AC','0000404831','0000404831','OH00002387221','IL','1','COLLINS','MONIKA','','','','34','297500532','2615 MIDDLETON RD',0,'HUDSON','OH','44236','1558','CY','39153','1950-04-30','F','M',NULL,'N','021','HLT','2381964','52664OH152000901','2014-03-01','2014-01-22 15:34:51','243.00',NULL,NULL,'482.18','239.18','R-OH012','OH0','482.18',NULL,0,'2014-01-23 03:02:51'),(18740,14933,'Y','18','021','EC','A','','','AC','0000188875','0000188875','OH00002390638','IL','1','SALING','NEAL','','','','34','400048187','8808 STONEHILL CT',0,'SPRINGBORO','OH','45066','8608','CY','39165','1972-02-21','M','M',':RET:2106-3','N','021','DEN','3049279','99734OH005000301','2014-03-01','2014-01-16 18:07:42','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:39'),(1445,1205,'Y','18','021','EC','A','','','AC','0000095243','0000095243','OH00001036835','IL','1','Merrill','Nathaniel','','','','34','286643853','62 Big Pine Rd.',0,'Winchester','OH','45697',NULL,'CY','39001','1965-05-20','M','U',':RET:2106-3','T','021','HLT','1589142','92036OH003000601','2014-01-01','2013-12-24 18:12:29','0.00',NULL,NULL,'421.52','421.52','R-OH005','OH0','421.52',NULL,0,'2013-12-25 18:47:57'),(3519,2827,'Y','18','021','EC','A','','','AC','0000796271','0000796271','MS00000325809','IL','1','WESLEY','CLAIRE','','','','34','451040587','614 SAWPINE LN',0,'RIDGELAND','MS','39157','3632','CY','28089','1954-10-29','F','M',NULL,'N','021','DEN','2411282','46300MS002000101','2014-01-01','2013-12-21 20:28:38','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-25 21:21:13'),(4301,3420,'Y','18','021','EC','A','','','AC','0000254519','0000254519','OH00000244401','IL','1','Goss','Janet','Renae','','','34','545451751','277 N. Spring St.',0,'Wilmington','OH','45177',NULL,'CY','39027','1963-10-17','F','U',NULL,'T','021','HLT','1897206','92036OH005000606','2014-01-01','2013-12-16 22:23:29','365.00',NULL,NULL,'440.90','75.90','R-OH005','OH0','440.90',NULL,0,'2013-12-25 21:52:21'),(5534,4390,'Y','18','021','EC','A','','','AC','0000183460','0000183460','OH00000485463','IL','1','Eneix','Annamarie','','','','34','295483241','5551 Ivy Court',0,'Willoughby','OH','44094',NULL,'CY','39085','1949-11-14','F','U',NULL,'N','021','DEN','1038087','99734OH005000401','2014-01-01','2013-11-27 14:26:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:15:39'),(14772,11795,'Y','18','021','EC','A','','','AC','0000694769','0000694769','TX00000711416','31','1','Saldana','Robert','','','','34','454411859','PO Box 2259',0,'Leander','TX','78646',NULL,'CY','48053','1963-09-19','M','U',':RET:2106-3','N','021','DEN','2520686','33348TX002000201','2014-01-01','2013-12-23 20:33:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:12:58'),(14919,11920,'Y','18','021','EC','A','','','AC','0000155788','0000155788','OH00001231376','IL','1','short','joan','','','','34','415136034','216 eas tmain street',0,'girard','OH','44420',NULL,'CY','39155','1958-09-15','F','U',':RET:2106-3','N','021','DEN','1467889','99734OH005000401','2014-02-01','2013-12-29 12:35:52','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-30 00:01:36'),(17013,13615,'N','01','021','EC','A',NULL,NULL,'','0000145400','0000231518','','IL','1','Hurley','Mary','Stupnik','','','34','289541517','2605 WELLINGTON RD',0,'CLEVELAND HEIGHTS','OH','44118','4120','CY','39035','1952-08-25','F','',':RET:2106-3','N','021','DEN','2106998','99734OH005000301','2014-02-01','2014-01-09 13:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:37'),(15131,12091,'N','01','021','EC','A',NULL,NULL,'','0001063253','0000726140','','IL','1','mcguire','david','','','','34','294529317','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1955-05-11','M','',NULL,'N','021','DEN','1658127','99734OH005000301','2014-02-01','2013-12-30 17:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:26'),(16518,13214,'Y','18','021','EC','A','','','AC','0001097821','0001097821','TX00001596120','IL','1','SMITH','BILLY','W','','','34','459848592','6518 DEVINE DRIVE',0,'ARLINGTON','TX','76001',NULL,'CY','48439','1950-10-27','M','M',':RET:2106-3','N','021','DEN','1490058','33348TX002000201','2014-02-01','2014-01-05 13:23:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-07 10:21:34'),(23636,18821,'Y','18','021','EC','A','','','AC','0000292135','0000292135','TX00002448152','IL','1','BOULIGNY','JENNY','','','','34','436777936','6526 LAS BRISAS DR',0,'HOUSTON','TX','77083','1318','CY','48201','1981-11-17','F','M',NULL,'N','021','DEN','3780272','33348TX002000201','2014-03-01','2014-02-13 19:25:25','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-14 21:30:05'),(24857,19707,'Y','18','024','14','A','','','TE','0000295545','0000295545','','IL','1','Minnich','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-10-09','F','',NULL,NULL,NULL,'','3229708','','2014-02-19','2014-02-19 16:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 04:56:25'),(26930,21342,'N','01','021','EC','A',NULL,NULL,'','0001178240','0000550130','','IL','1','jenkins','bobby','k','','Jr','34','270745766','5350 MAIN AVE',0,'NORTH RIDGEVILLE','OH','44039','2222','CY','39093','1975-12-02','M','',':RET:2106-3','N','021','DEN','2921394','99734OH005000401','2014-04-01','2014-03-02 16:40:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:19'),(27435,21712,'N','01','021','EC','A',NULL,NULL,'','0001183223','0001561293','','IL','1','GARAY','ALMA','HIDALIA','','','34','864628996','1501 NEWTON ST',0,'GRANDA','LA','70053',NULL,'CY','22051','1975-12-06','F','',NULL,'N','021','DEN','3791736','18575LA002000201','2014-04-01','2014-03-04 13:27:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-04 21:01:48'),(16584,13265,'Y','18','021','EC','A','','','AC','0001732017','0001732017','LA00001527416','IL','1','TOLLIVER','GLORIA','','','','34','437904668','1233 ROBINSON AVE',0,'MARRERO','LA','70072','2908','CY','22051','1953-04-06','F','M',':RET:2054-5','N','021','DEN','2043748','18575LA002000201','2014-02-01','2014-01-07 12:31:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:23:58'),(15774,12623,'Y','18','021','EC','A','','','AC','0000877801','0000877801','TX00001548076','IL','1','taylor','loveda','','','','34','550083372','901 S 23RD ST',0,'COPPERAS COVE','TX','76522','2757','CY','48099','1953-08-16','F','U',':RET:2106-3','N','021','DEN','2262806','33348TX002000201','2014-02-01','2014-01-02 15:22:10','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-03 02:01:54'),(15153,12112,'Y','18','024','14','A','','','TE','0001163849','0001163849','','IL','1','KORNEGAY','SHARRON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-03-09','F','',NULL,NULL,NULL,'','1703804','','2013-12-30','2013-12-30 12:59:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:07'),(14786,11809,'Y','18','021','EC','A','','','AC','0001020419','0001020419','OH00000336194','IL','1','Knowles','Lisa','','','','34','078521123','718 POLO DR N',0,'COLUMBUS','OH','43229','2408','CY','39049','1960-11-29','F','U',':RET:2054-5','N','021','DEN','2009406','99734OH005000401','2014-01-01','2013-12-23 19:48:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:13:21'),(1894,1549,'Y','18','021','EC','A','','','AC','0000799895','0000799895','OH00000278518','IL','1','FISHER','BRENDA','S','','','34','283642973','7249 SPENCERVILLE RD',0,'LIMA','OH','45806','9384','CY','39003','1957-09-21','F','M',':RET:2106-3','N','021','HLT','1546338','92036OH005001505','2014-01-01','2013-12-24 15:53:08','427.00',NULL,NULL,'513.45','86.45','R-OH002','OH0','513.45',NULL,0,'2013-12-25 18:58:56'),(5884,4668,'Y','18','021','EC','A','','','AC','0000105370','0000105370','OH00001188365','IL','1','Williams','Kareema','','','','34','296861429','4713 Country Lane',0,'Cleveland','OH','44128',NULL,'CY','39035','1987-09-08','F','U',':RET:2054-5','N','021','DEN','1915805','99734OH005000301','2014-01-01','2013-12-23 22:41:08','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:49:30'),(2354,1919,'Y','18','021','EC','A','','','AC','0000952418','0000952418','TX00000611400','IL','1','Mann','Pamela','Jo','','','34','454901877','1303 THISTLE LN',0,'MANSFIELD','TX','76063','5598','CY','48439','1950-10-11','F','M',':RET:2106-3','N','021','DEN','576328','33348TX002000201','2014-01-01','2013-12-09 17:31:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:32:19'),(2460,2001,'Y','18','021','EC','A','','','AC','0001067652','0001067652','TX00001233002','IL','1','Williams','Masoomeh','','','','34','626597370','6810 APPLE VALLEY LN',0,'HOUSTON','TX','77069','2306','CY','48201','1976-09-21','F','M',':RET:2106-3','N','021','DEN','800860','33348TX002000101','2014-01-01','2013-12-09 14:30:03','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 19:34:55'),(2589,2105,'Y','18','021','EC','A','','','AC','0001165296','0001165296','OH00000831810','IL','1','Bayardi','Rick','K','','','34','302524695','210 Martha St.',0,'Yorkville','OH','43971',NULL,'CY','39081','1954-08-02','M','M',':RET:2106-3','N','021','DEN','1099448','99734OH005000401','2014-01-01','2013-12-01 18:20:45','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-25 19:45:03'),(9673,7664,'Y','18','021','EC','A','','','AC','0000658416','0000658416','OH00000675105','IL','1','Stout','Linda','','','','34','295528686','3618 Coronada Dr.',0,'Toledo','OH','43615',NULL,'CY','39095','1951-07-08','F','M',':RET:2106-3','N','021','HLT','2080829','92036OH006002601','2014-01-01','2013-12-21 08:55:40','0.00',NULL,NULL,'444.29','444.29','R-OH001','OH0','444.29',NULL,0,'2013-12-26 04:39:18'),(21530,17201,'Y','18','021','EC','A','','','AC','0000549565','0000549565','TX00002191324','31','1','Dugan','Brenda','','','','34','465274652','PO Box 344',0,'Paradise','TX','76073',NULL,'CY','48497','1958-05-28','F','U',NULL,'T','021','DEN','3739074','33348TX002000101','2014-03-01','2014-02-05 11:49:41','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-05 21:30:06'),(23765,18911,'N','01','021','EC','A',NULL,NULL,'','0001146017','0000357239','','IL','1','DiMuzio','Jennifer','','','','34','268667273','614 COLEBERRY CT',0,'CLEVES','OH','45002','1390','CY','39061','1959-09-17','F','',':RET:2106-3','N','021','DEN','2812096','99734OH005000301','2014-03-01','2014-02-14 14:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:11'),(24183,19211,'N','01','021','EC','A',NULL,NULL,'','0000818631','0000950720','','IL','1','Barnhart','William','L','','','34','268641700','57 S MONROE ST',0,'MILLERSBURG','OH','44654','1424','CY','39075','1956-10-29','M','',':RET:2106-3','N','021','HLT','3532059','52664OH151001304','2014-03-01','2014-02-15 21:18:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2014-02-16 19:00:08'),(24334,19325,'Y','18','021','EC','A','','','AC','0000491887','0000491887','TX00002661830','IL','1','Ransleben','Linda','','','','34','456026321','592 CHERRY HOLLOW DR',0,'FREDERICKSBURG','TX','78624','6704','CY','48171','1956-04-29','F','M',':RET:2106-3','N','021','DEN','3285737','33348TX002000201','2014-04-01','2014-02-18 14:02:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:15'),(7236,5737,'Y','18','021','EC','A','','','AC','0000740315','0000740315','LA00001069841','IL','1','Williams','Chasidity','','','','34','437515550','3217 HIGHWAY 1',0,'MARKSVILLE','LA','71351','4116','CY','22009','1979-10-01','F','U',':RET:2054-5','N','021','DEN','404543','18575LA002000201','2014-01-01','2013-12-13 19:41:07','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 02:01:33'),(24512,19473,'Y','18','021','EC','A','','','AC','0000737484','0000737484','TX00002834397','31','1','Skinner','Jacob','','','','34','642287155','PO Box 13247',0,'Arlington','TX','79094',NULL,'CY','48439','1983-03-25','M','U',NULL,'N','021','DEN','2793876','33348TX002000201','2014-04-01','2014-02-19 10:40:59','0.00',NULL,NULL,'96.89','96.89','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:54:08'),(481,393,'Y','18','021','EC','A','','','AC','0000700745','0000700745','LA00000143198','31','1','Alexander','Lisa','','','','34','435651680','po box 4414',0,'covington','LA','70434',NULL,'CY','22103','1971-02-04','F','M',':RET:2106-3','N','021','DEN','1145005','18575LA002000201','2014-01-01','2013-12-03 22:29:19','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:10'),(2097,1718,'Y','18','021','EC','A','','','AC','0000242689','0000242689','OH00001052426','31','1','Sullivan','Judith','','','','34','281382982','1385 TIMSHEL ST',0,'DAYTON','OH','45440','3964','CY','39057','1949-08-06','F','M',':RET:2106-3','N','021','DEN','855252','99734OH005000401','2014-01-01','2013-12-09 20:12:05','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:04'),(3627,2901,'Y','18','021','EC','A','','','AC','0000844705','0000844705','OH00000220105','IL','1','Stricker','Elizabeth','','','','34','291509256','3984 STATE ROUTE 119',0,'MINSTER','OH','45865','8702','CY','39011','1951-05-14','F','M',':RET:2106-3','T','021','HLT','2369379','92036OH003001506','2014-01-01','2013-12-22 18:02:24','595.00',NULL,NULL,'759.36','164.36','R-OH002','OH0','759.36',NULL,0,'2013-12-25 21:23:49'),(20963,16752,'Y','18','021','EC','A','','','AC','0000860859','0000860859','TX00002478387','IL','1','PEDROZA','GLORIA','','','','34','451479559','3303 GARNET DR',0,'EL PASO','TX','79904','2532','CY','48141','1969-04-22','F','U',NULL,'N','021','DEN','2947476','33348TX002000201','2014-03-01','2014-02-01 17:07:24','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-01 19:00:10'),(20580,16445,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000142860','','IL','1','Alshinnawi','Rami','S','','','34','296949375','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1992-03-31','M','',':RET:2106-3','N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(15912,12743,'Y','18','021','EC','A','','','AC','0000797000','0000797000','TX00000945411','IL','1','geloach','pruitt','','','','34','465792624','286 fm1696 rd west',0,'huntsville','TX','77320',NULL,'CY','48471','1983-11-23','M','M',':RET:2106-3','T','021','DEN','2537657','33348TX002000101','2014-02-01','2014-01-02 18:19:02','0.00',NULL,NULL,'139.14','139.14','R-TX026','TX0','25.02',NULL,0,'2014-01-03 02:06:25'),(4595,3638,'N','01','021','EC','A',NULL,NULL,'','0000652104','0000307082','','IL','1','Cook','Allyn','Russell','','','34','044724653','130 ADAMS AVE',0,'CUYAHOGA FALLS','OH','44221','1704','CY','39153','1968-05-07','M','',':RET:2106-3','N','021','HLT','726058','52664OH151001306','2014-01-01','2013-12-12 14:22:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.02',NULL,0,'2013-12-25 22:05:34'),(4687,3716,'Y','18','021','EC','A','','','AC','0000982688','0000982688','OH00000087555','IL','1','Mitchell','Kristine','L','','','34','289520284','199 KNOLLS DR',0,'WILMINGTON','OH','45177','7593','CY','39027','1952-05-28','F','M',':RET:2106-3','N','021','HLT','548184','92036OH005000606','2014-01-01','2013-12-12 14:41:16','592.00',NULL,NULL,'603.24','11.24','R-OH005','OH0','603.24',NULL,0,'2013-12-25 22:08:04'),(4721,3742,'Y','18','021','EC','A','','','AC','0000957888','0000957888','OH00001251811','IL','1','Davis','Rachel','','','','34','280586270','5622 WHITNEY PL',0,'CINCINNATI','OH','45227','2126','CY','39061','1959-12-28','F','U',NULL,'N','021','HLT','1197212','92036OH005001206','2014-01-01','2013-12-12 15:51:39','354.00',NULL,NULL,'458.32','104.32','R-OH004','OH0','458.32',NULL,0,'2013-12-25 22:08:56'),(7326,5805,'Y','18','021','EC','A','','','AC','0001024250','0001024250','OH00000549163','IL','1','Davis','Bruce','','','','34','276525355','19916 SR 136',0,'WINCHESTER','OH','45697','0427','CY','39001','1952-07-03','M','M',':RET:2106-3','T','021','HLT','517560','92036OH003000605','2014-01-01','2013-12-14 11:51:08','692.83',NULL,NULL,'724.46','5.30','R-OH005','OH0','724.46',NULL,0,'2013-12-26 02:03:44'),(15175,12127,'Y','18','021','EC','A','','','AC','0000790881','0000790881','OH00000338673','IL','1','wood','matthew','','','','34','291828066','93 HEATHERBRIDGE LN',0,'BLACKLICK','OH','43004','9267','CY','39049','1984-12-29','M','M',':RET:2106-3','T','021','DEN','1788793','99734OH005000401','2014-02-01','2013-12-30 16:31:29','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:06:41'),(13807,11020,'Y','18','021','EC','A','','','AC','0000700375','0000700375','OH00001112555','IL','1','Crutcher','Carrie','','','','34','291783160','6266 CORBLY RD',0,'CINCINNATI','OH','45230','1543','CY','39061','1981-12-15','F','U',':RET:2106-3','N','021','HLT','2382402','92036OH005001205','2014-01-01','2013-12-22 19:34:35','150.00',NULL,NULL,'253.96','103.96','R-OH004','OH0','253.96',NULL,0,'2013-12-26 13:11:30'),(9751,7721,'Y','18','021','EC','A','','','AC','0001033619','0001033619','OH00001131595','IL','1','Brandt','Dana','','','','34','291788539','315 NOTRE DAME AVE',0,'CUYAHOGA FALLS','OH','44221','1849','CY','39153','1982-04-07','F','U',':RET:2106-3','N','021','HLT','375905','52664OH151001501','2014-01-01','2013-11-15 15:06:00','214.00',NULL,NULL,'309.99','95.99','R-OH012','OH0','309.99',NULL,0,'2013-12-26 04:46:13'),(25465,20204,'Y','18','021','EC','A','','','AC','0000293629','0000293629','TX00002995415','IL','1','Ratcliff','Mercie','','','','34','460618375','19719 PLANTATION GROVE TRL',0,'KATY','TX','77449','4978','CY','48201','1980-01-17','F','M',':RET:2054-5','N','021','DEN','2737116','33348TX002000201','2014-04-01','2014-02-25 15:55:55','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:34'),(25548,20269,'Y','18','021','EC','A','','','AC','0001218595','0001218595','OH00003183535','IL','1','Martin','Brynn','','','','34','302907286','2700 Link Side Drive',0,'Cincinnati','OH','45245',NULL,'CY','39025','1986-04-11','M','M',':RET:2106-3','N','021','DEN','3453415','99734OH005000401','2014-04-01','2014-02-23 16:11:48','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-26 08:00:16'),(27114,21461,'Y','18','021','EC','A','','','AC','0000426497','0000426497','OH00003362453','IL','1','Hall','Robert','','','','34','281841544','404 MAYFAIR BLVD',0,'COLUMBUS','OH','43213','2237','CY','39049','1986-01-16','M','U',':RET:2054-5','T','021','DEN','2665009','99734OH005000301','2014-04-01','2014-03-02 23:53:56','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:29'),(27887,22060,'N','01','021','EC','A',NULL,NULL,'','0000221384','0000672822','','IL','1','Wurns','Robert','','','Sr','34','300506198','139 S HALLETT AVE',0,'SWANTON','OH','43558','1513','CY','39095','1953-01-19','M','',':RET:2106-3','N','021','HLT','3414736','92036OH005002605','2014-04-01','2014-03-05 15:09:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','547.95',NULL,0,'2014-03-05 21:32:36'),(20859,16672,'N','19','021','EC','A',NULL,NULL,'','0001201924','0000186142','','IL','1','Destefano','Jake','','','','34','293023907','3688 HEMPHILL RD',0,'NORTON','OH','44203','5020','CY','39153','1998-02-02','M','',NULL,'N','021','DEN','2817982','99734OH005000301','2014-03-01','2014-01-31 15:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:56'),(2357,1922,'Y','18','021','EC','A','','','AC','0000785763','0000785763','OH00000146063','IL','1','Bartels-Behring','Angela','','','','34','298726253','1112 Lee Ave.',0,'Port Clinton','OH','43452',NULL,'CY','39123','1962-02-08','F','M',':RET:2106-3','N','021','DEN','38535','99734OH005000401','2014-01-01','2013-12-08 19:14:55','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 19:32:24'),(19775,15765,'Y','18','021','EC','A','','','AC','0000453948','0000453948','OH00002429090','IL','1','Richardson','David','','','','34','288608824','144 W. Plumber St',0,'Toledo','OH','43605',NULL,'CY','39095','1966-03-18','M','M',NULL,'N','021','HLT','1796581','92036OH006002601','2014-03-01','2014-01-23 16:39:33','417.00',NULL,NULL,'505.54','88.54','R-OH001','OH0','241.71',NULL,0,'2014-01-23 21:01:31'),(18367,14661,'Y','18','021','EC','A','','','AC','0000948436','0000948436','OH00001368487','IL','1','abou-osman','wanda','','','','34','385707741','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','1957-03-16','F','M',':RET:2106-3','T','021','DEN','1558565','99734OH005000301','2014-02-01','2014-01-15 10:53:10','0.00',NULL,NULL,'87.78','87.78','R-OH013','OH0','0.00',NULL,0,'2014-01-16 08:45:29'),(3055,2454,'Y','18','021','EC','A','','','AC','0000917719','0000917719','LA00000812303','IL','1','Richard','Robert','','','','34','438861049','402 PEAKE ST',0,'LAKE CHARLES','LA','70601','6048','CY','22019','1952-03-01','M','M',':RET:2106-3','T','021','DEN','1126807','18575LA002000201','2014-01-01','2013-12-06 17:18:32','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 20:18:59'),(3057,2455,'N','01','021','EC','A',NULL,NULL,'','0000684082','0000849143','','IL','1','Armbruster','John','William','','IV','34','433295857','544 HONORE DR',0,'JEFFERSON','LA','70121','1605','CY','22051','1970-12-01','M','',':RET:2106-3','N','021','DEN','1251537','18575LA002000201','2014-01-01','2013-12-06 17:23:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:19:03'),(16032,12835,'Y','18','021','EC','A','','','AC','0002048879','0002048879','LA00002029346','IL','1','Nellum','Marcus','','','','34','435134298','2900 POCAHONTAS ST',0,'NEW ORLEANS','LA','70126','4839','CY','22071','1964-01-04','M','U',':RET:2054-5','N','021','DEN','2479716','18575LA002000201','2014-02-01','2014-01-03 14:00:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:32'),(8916,7071,'N','01','021','EC','A',NULL,NULL,'','0000340275','0000255948','','IL','1','Thompson','Jonathan','Luther','','','34','269747817','707 CARTER CT',0,'OXFORD','OH','45056','1098','CY','39017','1977-11-18','M','',':RET:2054-5','T','021','DEN','1532756','99734OH005000401','2014-01-01','2013-12-18 00:23:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:42'),(15418,12334,'Y','18','021','EC','A','','','AC','0000721412','0000721412','TX00001422687','31','1','Ramirez','Maricela','','','','34','451559156','p.o. box 7398',0,'eagle pass','TX','78852',NULL,'CY','48323','1966-06-17','F','M',':RET:2106-3','N','021','DEN','1417713','33348TX002000201','2014-02-01','2013-12-31 10:57:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:23'),(26431,20964,'Y','18','021','EC','A','','','AC','0001078905','0001078905','OH00003394250','IL','1','Bender','Randy','D','','','34','400881208','117 SHAY ST',0,'DELAWARE','OH','43015','5026','CY','39041','1956-01-03','M','M',NULL,'N','021','DEN','2932773','99734OH005000401','2014-04-01','2014-02-27 07:41:45','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00','CIC',0,'2014-02-28 07:30:16'),(3935,3149,'N','01','021','EC','A',NULL,NULL,'','0001029342','0000577298','','IL','1','Dedo','Lorraine','Amanda','','','34','285581458','1758 Lealand Ave.',0,'Poland','OH','44514',NULL,'CY','39099','1957-01-21','F','',':RET:2106-3','N','021','HLT','340858','92036OH002003201','2014-01-01','2013-12-12 21:26:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','652.13',NULL,0,'2013-12-25 21:37:45'),(4528,3587,'N','01','021','EC','A',NULL,NULL,'','0000184613','0000531738','','IL','1','LEE','DEBORAH','ANN','','','34','461089054','19619 DAKOTA SPRINGS DR',0,'TOMBALL','TX','77377',NULL,'CY','48201','1954-08-04','F','',':RET:2106-3','N','021','DEN','1060843','33348TX002000201','2014-01-01','2013-12-12 15:43:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:59'),(21760,17376,'Y','18','021','EC','A','','','AC','0000434501','0000434501','TX00001400239','IL','1','Lane','Tiffany','','','','34','457990055','2221 CARRUTHERS DR',0,'FORT WORTH','TX','76112','8045','CY','48439','1985-02-11','F','R',':RET:2054-5','N','021','DEN','3821629','33348TX002000201','2014-03-01','2014-02-06 14:01:52','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:26'),(8078,6397,'Y','18','021','EC','A','','','AC','0000086414','0000086414','OH00001204263','IL','1','arnold','johanna','','','','34','128540738','770 schau rd',0,'port clinton','OH','43452',NULL,'CY','39123','1957-09-26','F','M',':RET:2106-3','N','021','HLT','1976474','92036OH004002701','2014-01-01','2013-12-20 13:58:23','0.00',NULL,NULL,'365.79','365.79','R-OH006','OH0','365.79',NULL,0,'2013-12-26 03:10:23'),(5071,4019,'Y','18','021','EC','A','','','AC','0001076769','0001076769','TX00000020206','IL','1','Harvell','Katie','','','','34','639102802','504 Gilchrist Ave',0,'College Station','TX','77840',NULL,'CY','48041','1975-03-27','F','U',':RET:2106-3','N','021','DEN','1468661','33348TX002000201','2014-01-01','2013-12-19 12:32:07','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 23:00:43'),(7645,6052,'Y','18','021','EC','A','','','AC','0000509174','0000509174','OH00000032090','IL','1','Morrison','Samantha','','','','34','284883303','2927 lee road',0,'Silver lake','OH','44224',NULL,'CY','39153','1987-07-25','F','U',':RET:2106-3','N','021','HLT','1067270','52664OH151001301','2014-01-01','2013-11-10 14:21:11','0.00',NULL,NULL,'228.36','228.36','R-OH012','OH0','228.36',NULL,0,'2013-12-26 02:46:41'),(22704,18130,'Y','18','024','14','A','','','TE','0000769712','0000769712','','IL','1','Rush','Joel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-19','M','',NULL,NULL,NULL,'','3607799','','2014-02-11','2014-02-11 16:08:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-11 21:01:00'),(22761,18172,'N','01','021','EC','A',NULL,NULL,'','0000043260','0001245635','','IL','1','Shah','Hemant','','','','34','272868655','6611 greenfield woods n',0,'cincinnati','OH','45224',NULL,'CY','39061','1955-11-07','M','',':RET:2029-7','N','021','DEN','3794710','99734OH005000401','2014-03-01','2014-02-10 23:21:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:32'),(26364,20912,'Y','18','021','EC','A','','','AC','0000022832','0000022832','OH00002915461','IL','1','Barnett','Wendy','','','','34','290742136','7824 PEACHMONT AVE NW',0,'NORTH CANTON','OH','44720','5799','CY','39151','1963-08-31','F','U',':RET:2106-3','N','021','DEN','2789212','99734OH005000301','2014-04-01','2014-02-26 13:55:36','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00','CIC',0,'2014-02-28 07:00:07'),(26586,21080,'Y','18','021','EC','A','','','AC','0001116002','0001116002','OH00002646063','IL','1','albright','shawn','','','','34','269725364','7008 russell court',0,'cleveland','OH','44103',NULL,'CY','39035','1970-12-28','M','U',NULL,'N','021','DEN','3315153','99734OH005000401','2014-04-01','2014-02-28 17:30:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-28 21:30:33'),(27539,21785,'Y','18','024','14','A','','','TE','0001221913','0001221913','','IL','1','Bear','August',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-13','M','',NULL,NULL,NULL,'','249215','','2014-03-31','2014-03-03 19:44:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:06'),(21438,17135,'Y','18','021','EC','A','','','AC','0000012695','0000012695','MS00002009029','IL','1','Love','Charlotte','','','','34','413131183','3393 BENSON RD',0,'POPE','MS','38658','3903','CY','28107','1967-05-28','F','M',':RET:2054-5','N','021','DEN','3145331','46300MS002000101','2014-03-01','2014-02-04 11:56:10','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-02-04 21:01:22'),(1900,1554,'Y','18','021','EC','A','','','AC','0000535762','0000535762','OH00001170024','IL','1','Pack','Steven','','','','34','370702068','20350 Mosher rd',0,'wellington','OH','44090',NULL,'CY','39093','1968-02-05','M','M',NULL,'N','021','HLT','1939365','92036OH005000805','2014-01-01','2013-12-24 15:33:33','769.00',NULL,NULL,'1027.77','258.77','R-OH011','OH0','337.61',NULL,0,'2013-12-25 18:59:07'),(4080,3261,'Y','18','021','EC','A','','','AC','0000555356','0000555356','OH00000616621','IL','1','FISHER','LEANNE','','','','34','280725077','610 E HENRY ST',0,'WOOSTER','OH','44691','4218','CY','39169','1961-11-03','F','U',':RET:2106-3','T','021','HLT','1734560','52664OH152000901','2014-01-01','2013-12-17 15:29:49','366.67',NULL,NULL,'366.67','0.00','R-OH014','OH0','366.67',NULL,0,'2013-12-25 21:47:10'),(18677,14889,'N','01','021','EC','A',NULL,NULL,'','0000292042','0001122228','','IL','1','Atilano','Pete','','','','34','462960782','11208 PEACEPIPE LN',0,'EL PASO','TX','79936','1244','CY','48141','1954-11-19','M','',NULL,'N','021','DEN','2496298','33348TX002000201','2014-02-01','2014-01-15 19:58:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:19'),(16235,13001,'Y','18','021','EC','A','','','AC','0000048382','0000048382','TX00001677448','IL','1','THOMAS','TAMI','','','','34','288585680','741 S MAIN ST',0,'SALADO','TX','76571','6202','CY','48027','1964-07-30','F','M',NULL,'N','021','DEN','1373576','33348TX002000101','2014-02-01','2014-01-03 21:56:03','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2014-01-05 00:02:10'),(15296,12230,'Y','18','021','EC','A','','','AC','0001340416','0001340416','LA00001501403','IL','1','Morris','Shenae','Gabrielle','','','34','435738947','1307 Lasseigne Rd',0,'Thibodaux','LA','70301',NULL,'CY','22057','1989-02-02','F','U',':RET:2054-5','N','021','DEN','1942363','18575LA002000201','2014-02-01','2013-12-31 19:04:44','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,1,'2014-01-02 04:22:39'),(7420,5872,'Y','18','021','EC','A','','','AC','0000762244','0000762244','OH00001055705','IL','1','Cooper','Selwyn','','','','34','419965913','4244 BROWNSTONE LN',0,'MEDINA','OH','44256','5551','CY','39103','1968-03-02','M','U',':RET:2054-5','N','021','DEN','138922','99734OH005000301','2014-01-01','2013-10-26 18:17:32','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:17:01'),(7484,5921,'N','17','021','EC','A',NULL,NULL,'','0000071620','0001086768','','IL','1','BIBI','IQRA','','','','34','276153353','6346 RUGOSA AVE',0,'REYNOLDSBURG','OH','43068','1062','CY','39049','1992-09-28','F','',':RET:2029-7','N','021','DEN','692546','99734OH005000401','2014-01-01','2013-12-15 13:53:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:28'),(7957,6297,'Y','18','024','14','A','','','TE','0000264169','0000264169','','IL','1','Howard','Aundre',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-02-06','M','',NULL,NULL,NULL,'','882431','','2013-12-20','2013-12-20 18:06:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:07:21'),(24752,19641,'Y','18','021','EC','A','','','AC','0000934709','0000934709','OH00002902512','IL','1','KOMYATI','ANTOINETTE','M','','','34','287642324','1939 GLENWOOD DR',0,'TWINSBURG','OH','44087','1256','CY','39153','1956-11-16','F','M',':RET:2106-3','T','021','DEN','3264613','99734OH005000401','2014-04-01','2014-02-19 11:36:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-20 04:41:15'),(27430,21709,'Y','18','021','EC','A','','','AC','0001646391','0001646391','LA00003617977','IL','1','Heck','Michael','','','','34','408211357','58166 Main St.',0,'Plaquemine','LA','70764',NULL,'CY','22047','1964-02-12','M','U',NULL,'N','021','DEN','3815131','18575LA002000201','2014-04-01','2014-03-04 12:50:55','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-04 21:01:46'),(28789,22789,'Y','18','021','EC','A','','','AC','0000248383','0000248383','TX00002739710','31','1','GRIFFIN','CHRISTI','','','','34','451370484','p.o. box 270759',0,'flower mound','TX','75027',NULL,'CY','48121','1971-11-21','F','U',':RET:2106-3','N','021','DEN','3589025','33348TX002000101','2014-04-01','2014-03-08 21:22:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-09 21:00:41'),(20444,16329,'N','19','021','EC','A',NULL,NULL,'','0000268077','0000709753','','IL','1','PAIGE','CHARLES','N','','','34','426816925','904 WINDING  LAKE COVE',0,'MADISON','MS','39110',NULL,'CY','28089','1996-07-03','M','',':RET:2054-5','N','021','DEN','1755955','46300MS002000101','2014-03-01','2014-01-29 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-01-29 21:00:42'),(17919,14314,'Y','18','021','EC','A','','','AC','0000304141','0000304141','TX00001857482','IL','1','Araiza','Michelle','','','','34','456558314','501 E STASSNEY LN',0,'AUSTIN','TX','78745','3216','CY','48453','1981-03-05','F','U',NULL,'N','021','DEN','1904031','33348TX002000201','2014-02-01','2014-01-14 10:17:38','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:30'),(17328,13861,'Y','18','021','EC','A','','','AC','0001322521','0001322521','LA00001381595','IL','1','Lester','Jonathan','','','','34','415474056','8221 GREEN ST',0,'NEW ORLEANS','LA','70118','2845','CY','22071','1984-10-12','M','U',':RET:2106-3','N','021','DEN','1519004','18575LA002000201','2014-02-01','2014-01-10 11:30:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:23:55'),(28156,22280,'N','01','021','EC','A',NULL,NULL,'','0000108222','0000757209','','IL','1','perdew','nicole','','','','34','171707458','703 TAYLOR ST',0,'DELTA','OH','43515','1043','CY','39051','1988-08-31','F','',':RET:2106-3','N','021','HLT','3334936','92036OH005002601','2014-04-01','2014-03-06 15:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.78',NULL,0,'2014-03-06 21:02:39'),(28960,22920,'Y','18','021','EC','A','','','AC','0001906031','0001906031','LA00003381500','IL','1','Bursntein','Keith','','','','34','150703760','1735 feliciana st',0,'new orleans','LA','70117',NULL,'CY','22071','1979-12-13','M','U',':RET:2106-3','N','021','DEN','3907494','18575LA002000201','2014-04-01','2014-03-10 12:51:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:56'),(2534,2062,'Y','18','021','EC','A','','','AC','0001223151','0001223151','OH00000352930','IL','1','Price','Ronald','Eugene','','','34','273580077','5520 Ridgewood Rd. W.',0,'Springfield','OH','45503',NULL,'CY','39023','1954-09-26','M','M',':RET:2106-3','T','021','HLT','130316','92036OH005000506','2014-01-01','2013-12-09 14:02:33','200.00',NULL,NULL,'1290.88','1090.88','R-OH003','OH0','711.58',NULL,0,'2013-12-25 19:36:52'),(17483,13978,'Y','18','024','14','A','','','TE','0000157825','0000157825','','IL','1','Hoy','Danyeil',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-02','F','',NULL,NULL,NULL,'','2250928','','2014-01-12','2014-01-12 14:10:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 03:01:14'),(13956,11125,'N','17','021','EC','A',NULL,NULL,'','0000112931','0001132758','','S3','1','Neiheisel','Robin','K','','','34','288029790','41 CROSSBOW CT',0,'AMELIA','OH','45102','2112','CY','39025','1997-11-14','F','',':RET:2106-3','N','021','HLT','2027257','92036OH004000601','2014-01-01','2013-12-23 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 13:15:01'),(13955,11125,'N','19','021','EC','A',NULL,NULL,'','0000112931','0001208297','','S1','1','Neiheisel','Robin','K','','','34','288151858','41 CROSSBOW CT',0,'AMELIA','OH','45102','2112','CY','39025','2009-10-27','M','',':RET:2106-3','N','021','HLT','2027257','92036OH004000601','2014-01-01','2013-12-23 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 13:15:01'),(4308,3424,'N','01','021','EC','A',NULL,NULL,'','0000093834','0000803718','','IL','1','davis','orville','j','','','34','406119320','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1965-12-09','M','',':RET:2106-3','N','021','HLT','2284060','92036OH004001201','2014-01-01','2013-12-17 05:52:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','282.22',NULL,0,'2013-12-25 21:52:30'),(23693,18868,'Y','18','021','EC','A','','','AC','0000710185','0000710185','OH00001824704','IL','1','Hays','Christine','','','','34','299745730','2810 ROSEANN LN',0,'CINCINNATI','OH','45239','7252','CY','39061','1964-03-16','F','U',':RET:2106-3','N','021','DEN','2741941','99734OH005000401','2014-03-01','2014-02-14 00:19:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:38'),(23935,19032,'Y','18','021','EC','A','','','AC','0000841968','0000841968','OH00002352630','IL','1','RUDISILL','NANCY','','','','34','273684525','5544 Ridge Rd.',0,'Parma','OH','44129',NULL,'CY','39035','1967-09-22','F','M',NULL,'N','021','DEN','3828038','99734OH005000401','2014-03-01','2014-02-15 12:47:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-15 21:00:06'),(24757,19643,'N','01','021','EC','A',NULL,NULL,'','0000990107','0000504519','','IL','1','Lovingshimer','Carl','Lee','','Jr','34','299806976','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-06-11','M','',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:42:10'),(25365,20126,'N','01','021','EC','A',NULL,NULL,'','0000259284','0000153424','','IL','1','ELDRIDGE','MELISSA','','','','34','223573173','2810 INLAND DR',0,'MIDDLETOWN','OH','45042','3320','CY','39017','1988-07-08','F','',NULL,'N','021','DEN','3848628','99734OH005000301','2014-04-01','2014-02-25 09:52:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:38'),(28405,22475,'Y','18','021','EC','A','','','AC','0000759772','0000759772','OH00003308753','IL','1','KUELLING','Robert','','','','34','295566447','5127 DILL RD',0,'BELLVILLE','OH','44813','9374','CY','39139','1955-03-16','M','U',':RET:2106-3','N','021','DEN','3603902','99734OH005000401','2014-04-01','2014-03-07 10:12:10','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-03-07 21:30:53'),(354,291,'Y','18','021','EC','A','','','AC','0000011117','0000011117','OH00000761748','IL','1','baney','david','','','','34','284621335','113 S TAYLOR ST',0,'NORTH BALTIMORE','OH','45872','1422','CY','39173','1958-12-18','M','U',':RET:2106-3','N','021','HLT','961934','92036OH005002604','2014-01-01','2013-11-09 16:44:41','259.00',NULL,NULL,'434.84','175.84','R-OH001','OH0','434.84',NULL,0,'2013-12-25 17:32:22'),(7276,5770,'Y','18','021','EC','A','','','AC','0000069265','0000069265','TX00001044368','31','1','Arnwine','Rhonda','','','','34','462438183','PO Box 870661',0,'Mesquite','TX','75187',NULL,'CY','48113','1962-08-24','F','U',NULL,'N','021','DEN','437769','33348TX002000201','2014-01-01','2013-12-14 16:31:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:02:34'),(22448,17923,'N','19','021','EC','A',NULL,NULL,'','0000925348','0000228370','','S1','1','Townsend','Benjamin','Curtis','','Jr','34','768441765','11433 TURNING LEAF TRL',0,'FORT WORTH','TX','76244','4889','CY','48439','2005-10-04','F','',':RET:2106-3','N','021','DEN','2928737','33348TX002000201','2014-03-01','2014-02-10 14:28:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-10 21:30:45'),(16811,13446,'Y','18','021','EC','A','','','AC','0000887529','0000887529','TX00002302285','IL','1','maxfield','sky','','','','34','449712789','1583 N WILLIS ST',0,'ABILENE','TX','79603','4333','CY','48441','1983-10-04','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','1592537','33348TX002000201','2014-02-01','2014-01-11 16:12:52','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-01-13 02:18:16'),(3503,2814,'Y','18','021','EC','A','','','AC','0001158913','0001158913','OH00000724012','IL','1','Smith','Tyrone','C','','','34','298701446','1339 W JOHNNY LYTLE AVE',0,'SPRINGFIELD','OH','45506','2370','CY','39023','1976-07-20','M','U',':RET:2054-5','T','021','DEN','1450434','99734OH005000401','2014-01-01','2013-12-22 17:16:16','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:46'),(16624,13299,'Y','18','021','EC','A','','','AC','0000291984','0000291984','OH00001531209','IL','1','Roll','Pauline','','','','34','287505122','45 Cranston Ct',0,'Centerville','OH','45458',NULL,'CY','39113','1951-05-06','F','U',':RET:2106-3','N','021','DEN','2088804','99734OH005000401','2014-02-01','2014-01-07 14:47:57','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:12'),(15820,12664,'Y','18','021','EC','A','','','AC','0000525596','0000525596','OH00001616164','IL','1','Ellis','Jacqueline','','','','34','293487632','3942 AUSTIN RD',0,'GENEVA','OH','44041','7707','CY','39007','1950-04-04','F','U',':RET:2106-3','N','021','DEN','2520995','99734OH005000401','2014-02-01','2014-01-02 12:17:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:03:29'),(13496,10756,'Y','18','021','EC','A','','','AC','0000960601','0000960601','OH00000791203','IL','1','WOODI','SOAD','','','','34','050684619','1517 FITZROY STREET',0,'WEST LAKE','OH','44145',NULL,'CY','39035','1975-11-12','F','M',NULL,'N','021','DEN','1815475','99734OH005000301','2014-01-01','2013-12-23 18:37:13','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:02:28'),(26096,20696,'N','01','021','EC','A',NULL,NULL,'','0002006714','0001944664','','IL','1','ALLEN','SUSIE','','','','34','507946305','442 MEHLE ST',0,'ARABI','LA','70032','1058','CY','22087','1962-02-01','F','',NULL,'N','021','DEN','3046223','18575LA002000201','2014-03-01','2014-02-27 13:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-28 06:30:10'),(27140,21486,'N','01','021','EC','A',NULL,NULL,'','0000264260','0000197196','','IL','1','MENSAH','MILLICENT','','','','34','274117945','1328 CAMP HILL WAY',0,'DAYTON','OH','45449','3136','CY','39113','1986-06-05','F','',':RET:2054-5','N','021','DEN','3613733','99734OH005000401','2014-04-01','2014-03-03 12:00:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:46'),(27707,21911,'Y','18','021','EC','A','','','AC','0001151267','0001151267','TX00003236969','IL','1','LOPEZ','JANETH','','','','34','602268212','16510 SPERRY GARDENS DR',0,'HOUSTON','TX','77095','5551','CY','48201','1966-10-19','F','M',NULL,'N','021','DEN','3295852','33348TX002000201','2014-04-01','2014-03-05 12:29:36','0.00',NULL,NULL,'47.55','47.55','R-TX010','TX0','15.85',NULL,0,'2014-03-05 21:30:51'),(27881,22056,'Y','18','021','EC','A','','','AC','0000063765','0000063765','OH00002856959','IL','1','Scott','Jennifer','','','','34','297827536','1371 ADAK AVE',0,'LIMA','OH','45805','3901','CY','39003','1976-07-09','F','U',':RET:2106-3','N','021','HLT','3510168','92036OH005001505','2014-04-01','2014-03-05 11:06:53','277.00',NULL,NULL,'412.22','135.22','R-OH002','OH0','272.46',NULL,0,'2014-03-05 21:32:32'),(29153,23078,'Y','18','021','EC','A','','','AC','0000937344','0000937344','OH00002739739','IL','1','Fink','Karl','','','','34','269848427','393 JARONTE DR',0,'BOARDMAN','OH','44512','4429','CY','39099','1966-03-19','M','M',NULL,'N','021','HLT','4361192','92036OH005003204','2014-04-01','2014-03-10 12:18:51','462.00',NULL,NULL,'758.83','296.83','R-OH013','OH0','395.76',NULL,0,'2014-03-10 21:02:50'),(790,652,'Y','18','024','14','A','','','TE','0000903472','0000903472','','IL','1','Alexander','Princesa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-03','F','',NULL,NULL,NULL,'','810640','','2013-12-16','2013-12-16 16:29:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:05:17'),(5222,4145,'N','01','021','EC','A',NULL,NULL,'','0000672749','0001143310','','IL','1','MOTTLE','JOSEPH','','','','34','316606396','4400 LOT 267',0,'WOOSTER','OH','44691',NULL,'CY','39169','1954-05-19','M','',':RET:2106-3','N','021','DEN','1633168','99734OH005000401','2014-01-01','2013-12-19 16:52:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:04:34'),(1111,914,'Y','18','021','EC','A','','','AC','0000114162','0000114162','OH00000683098','IL','1','Kearns','Sherry','','','','34','284622738','1 Gruver Street',0,'Kenton','OH','43326',NULL,'CY','39065','1954-07-09','F','U',':RET:2106-3','N','021','DEN','676931','99734OH005000401','2014-01-01','2013-12-03 12:04:47','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:17:29'),(3377,2706,'N','01','021','EC','A',NULL,NULL,'','0000604202','0000679742','','IL','1','Reeise','Yuridia','','','','34','457699733','3533 BARCLAY DR',0,'AMARILLO','TX','79109','4009','CY','48381','1983-02-02','F','',NULL,'N','021','DEN','1660474','33348TX002000201','2014-01-01','2013-12-22 17:04:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:17:24'),(3652,2923,'Y','18','021','EC','A','','','AC','0001106771','0001106771','OH00000205175','IL','1','SPRADLING','JACK','RONALD','','Sr','34','293504553','4116 WILLIAMSON DR',0,'DAYTON','OH','45416','2146','CY','39113','1951-07-16','M','M',':RET:2106-3','N','021','DEN','116837','99734OH005000401','2014-01-01','2013-12-12 18:55:39','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:30:40'),(4724,3744,'Y','18','021','EC','A','','','AC','0000806340','0000806340','OH00000855488','IL','1','Sandys','Elizabeth','','','','34','377922645','2158 LONGPORT DR',0,'MAUMEE','OH','43537','1152','CY','39095','1969-01-10','F','M',':RET:2106-3','N','021','HLT','439028','92036OH003002601','2014-01-01','2013-12-12 15:05:13','188.00',NULL,NULL,'589.39','401.39','R-OH001','OH0','284.48',NULL,0,'2013-12-25 22:09:01'),(5257,4169,'Y','18','021','EC','A','','','AC','0001038586','0001038586','OH00001232387','IL','1','RITENOUR','LARRELL','','','','34','268524480','3271 BROOKLAWN DR',0,'NORTON','OH','44203','5222','CY','39153','1950-03-14','F','U',':RET:2106-3','N','021','HLT','1663137','52664OH151001306','2014-01-01','2013-12-19 10:11:20','534.00',NULL,NULL,'658.32','124.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 23:05:15'),(23280,18558,'Y','18','024','14','A','','','TE','0002134557','0002134557','','IL','1','nicholas','erica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-14','F','',NULL,NULL,NULL,'','2711719','','2014-02-28','2014-02-13 13:19:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-13 21:30:16'),(25554,20275,'Y','18','021','EC','A','','','AC','0000638562','0000638562','OH00003111209','IL','1','Abney','Cassandra','','','','34','269825417','14533 UPPER CUMBERLAND RD',0,'MOUNT ORAB','OH','45154','9085','CY','39015','1984-02-15','F','M',NULL,'N','021','HLT','3140999','92036OH004000601','2014-04-01','2014-02-23 08:34:43','397.00',NULL,NULL,'619.34','222.34','R-OH005','OH0','195.92',NULL,0,'2014-02-26 08:00:20'),(26751,21200,'Y','18','024','14','A','','','TE','0000875427','0000875427','','IL','1','JAVIER','TERESA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-09-13','F','',NULL,NULL,NULL,'','1444891','','2014-03-31','2014-02-28 20:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-01 19:00:03'),(27470,21739,'N','01','021','EC','A',NULL,NULL,'','0000990117','0001054279','','IL','1','FOWLER','DIANE','','','','34','280686414','1701 DARLAND AVE',0,'LIMA','OH','45804',NULL,'CY','39003','1961-02-16','F','',NULL,'N','021','HLT','3828458','92036OH004001501','2014-04-01','2014-03-03 21:01:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','361.01',NULL,0,'2014-03-04 21:02:11'),(20678,16525,'Y','18','021','EC','A','','','AC','0000167726','0000167726','TX00001374234','IL','1','Hassan','Syed','','','','34','513060073','643 LEAFY RDG',0,'SAN ANTONIO','TX','78251','4251','CY','48029','1968-10-11','M','M',NULL,'N','021','DEN','3626848','33348TX002000101','2014-03-01','2014-01-29 19:08:53','0.00',NULL,NULL,'158.67','158.67','R-TX019','TX0','25.02',NULL,0,'2014-01-30 21:00:54'),(1880,1536,'Y','18','024','14','A','','','TE','0000054464','0000054464','','IL','1','Smith','Kalin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-06-16','F','',NULL,NULL,NULL,'','2349257','','2013-12-24','2013-12-24 13:44:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:58:30'),(2713,2194,'N','17','021','EC','A',NULL,NULL,'','0000909448','0001249550','','IL','1','Douglas','Austin','Charles','','','34','292983724','544 Bayfair Dr',0,'Bay Village','OH','44140',NULL,'CY','39035','1995-11-21','M','',':RET:2106-3','N','021','HLT','388920','52664OH151001501','2014-01-01','2013-12-02 13:32:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-25 19:48:00'),(4635,3672,'N','01','021','EC','A',NULL,NULL,'','0000784935','0000023680','','IL','1','Ingram','Charles','Douglas','','','34','587742411','350 Main st',0,'pope','MS','38658',NULL,'CY','28107','1953-09-19','M','',':RET:2106-3','N','021','DEN','313948','46300MS002000101','2014-01-01','2013-12-12 15:47:09',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 22:06:38'),(5880,4664,'Y','18','021','EC','A','','','AC','0000664182','0000664182','OH00000270663','IL','1','Stock','Luis','M','','','34','276506820','10 HILLCREST DR',0,'MARTINS FERRY','OH','43935','1018','CY','39013','1950-11-28','M','U',':RET:2106-3','N','021','DEN','2435976','99734OH005000301','2014-01-01','2013-12-23 22:07:07','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:49:23'),(17604,14071,'N','01','021','EC','A',NULL,NULL,'','0000225988','0001054846','','IL','1','NGUYEN','HUE','THITHANH','','','34','630198962','8308 SHALLOT WAY',0,'AUSTIN','TX','78748','1046','CY','48453','1969-06-20','F','',':RET:2047-9','N','021','DEN','1790110','33348TX002000201','2014-02-01','2014-01-12 19:39:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-14 01:32:17'),(26955,21359,'Y','18','021','EC','A','','','AC','0000245041','0000245041','OH00003404844','IL','1','Hamric','Stacey','Marie','','','34','270709081','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1971-08-19','F','M',':RET:2106-3','N','021','HLT','3266135','52664OH151001305','2014-04-01','2014-03-01 21:31:20','644.00',NULL,NULL,'890.24','246.24','R-OH012','OH0','295.48',NULL,0,'2014-03-03 01:00:28'),(18585,14818,'N','01','021','EC','A',NULL,NULL,'','0000322165','0001239146','','IL','1','Marmer Hashimoto','Tsuneko','','','','34','294028393','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1958-01-31','F','',':RET:2039-6','N','021','HLT','1856858','92036OH002001201','2014-02-01','2014-01-15 01:42:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','578.36',NULL,0,'2014-01-16 08:47:10'),(6497,5147,'Y','18','021','EC','A','','','AC','0000142804','0000142804','OH00000558864','IL','1','Smithnosky','Christine','M','','','34','200407654','1918 Victoria St',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1949-12-14','F','U',':RET:2106-3','N','021','HLT','54730','52664OH151001306','2014-01-01','2013-12-11 15:08:58','469.00',NULL,NULL,'669.00','200.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 00:50:44'),(18362,14657,'Y','18','021','EC','A','','','AC','0000488009','0000488009','OH00002159285','IL','1','AYERS','LISA','','','','34','274805391','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1970-02-05','F','R',':RET:2106-3','N','021','DEN','2772132','99734OH005000301','2014-02-01','2014-01-15 02:13:49','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:45:27'),(9320,7389,'Y','18','021','EC','A','','','AC','0001888235','0001888235','LA00000452739','IL','1','Placide','Marie','','','','34','594095175','103 BERKLEY DR',0,'NEW ORLEANS','LA','70131','4005','CY','22071','1962-03-26','F','M',':RET:2054-5','N','021','DEN','1679721','18575LA002000101','2014-01-01','2013-12-21 13:32:00','0.00',NULL,NULL,'75.06','75.06','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:29'),(13334,10647,'Y','18','021','EC','A','','','AC','0001131863','0001131863','TX00000792336','IL','1','WASHINGTON','MARY','','','','34','461987262','11455 BISSONNET ST',0,'HOUSTON','TX','77099',NULL,'CY','48201','1954-06-09','F','U',':RET:2054-5','N','021','DEN','2361200','33348TX002000201','2014-01-01','2013-12-23 18:03:53','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:42'),(14056,11199,'Y','18','021','EC','A','','','AC','0000283268','0000283268','OH00001471160','31','1','Phillips','Lila','','','','34','302528826','P.O. Box 12365',0,'Norwood','OH','45212','3566','CY','39061','1952-03-16','F','U',':RET:2106-3','T','021','DEN','2027433','99734OH005000301','2014-02-01','2013-12-26 16:19:27','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:25'),(16212,12982,'Y','18','021','EC','A','','','AC','0000293201','0000293201','OH00002224446','IL','1','SMITH','BRITTANY','','','','34','300924916','30 S CLEVELAND ST',0,'MINSTER','OH','45865','1222','CY','39011','1991-01-09','F','U',':RET:2106-3','N','021','HLT','1470420','92036OH003001505','2014-02-01','2014-01-03 18:47:09','167.00',NULL,NULL,'229.83','62.83','R-OH002','OH0','229.83',NULL,0,'2014-01-05 00:01:31'),(27486,21751,'Y','18','021','EC','A','','','AC','0000891866','0000891866','OH00003554994','IL','1','PHILLIPS','REBECCA','','','','34','286687942','539 LLOYD ST',0,'BARBERTON','OH','44203',NULL,'CY','39153','1973-08-27','F','U',':RET:2106-3','N','021','HLT','3953584','52664OH151001304','2014-04-01','2014-03-04 10:48:14','300.00',NULL,NULL,'568.22','268.22','R-OH012','OH0','285.00',NULL,0,'2014-03-04 21:02:21'),(28218,22327,'Y','18','021','EC','A','','','AC','0000522018','0000522018','OH00003444910','IL','1','LITTLETON','TAWLES','','','','34','292726808','7635 WESSELMAN RD',0,'CLEVES','OH','45002','8605','CY','39061','1961-07-05','M','M',':RET:2106-3','T','021','HLT','3822429','92036OH005001205','2014-04-01','2014-03-06 17:17:18','317.50',NULL,NULL,'481.88','164.38','R-OH004','OH0','481.88','CIC',0,'2014-03-06 21:30:17'),(496,405,'Y','18','021','EC','A','','','AC','0000077848','0000077848','LA00001120928','IL','1','Fickling','Richard','','','','34','231319593','3722 BAUDIN ST',0,'NEW ORLEANS','LA','70119','7023','CY','22071','1968-11-22','M','U',':RET:2106-3','N','021','DEN','1185357','18575LA002000201','2014-01-01','2013-12-04 14:36:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:32'),(19658,15663,'N','01','021','EC','A',NULL,NULL,'','0000598782','0000696843','','IL','1','Lovill','William','','','','34','295682930','2335 UNION RD',0,'MIDDLETOWN','OH','45044','8828','CY','39165','1963-01-21','M','',NULL,'N','021','DEN','3296350','99734OH005000401','2014-03-01','2014-01-23 15:12:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:23'),(19484,15531,'Y','18','021','EC','A','','','AC','0000161556','0000161556','TX00001495839','IL','1','Lillie','Traycee','','','','34','460932420','Po box 778',0,'Freer','TX','78357',NULL,'CY','48131','1982-01-02','F','M',NULL,'N','021','DEN','3226625','33348TX002000201','2014-03-01','2014-01-22 12:50:21','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-23 03:02:04'),(17005,13611,'Y','18','021','EC','A','','','AC','0000380073','0000380073','OH00002088983','IL','1','Tedesco','Lisa','','','','34','573690540','2325 SAINT CHARLES AVE',0,'DAYTON','OH','45410','2716','CY','39113','1967-03-17','F','M',':RET:2106-3','N','021','DEN','2283657','99734OH005000301','2014-02-01','2014-01-09 11:15:00','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:20:33'),(15550,12443,'Y','18','021','EC','A','','','AC','0001754029','0001754029','LA00000744332','IL','1','Dang','Bachyen','','','','34','729120201','38098 COVE CT',0,'PRAIRIEVILLE','LA','70769','4186','CY','22005','1958-05-03','F','U',NULL,'N','021','DEN','1893121','18575LA002000201','2014-02-01','2013-12-31 16:13:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:31:15'),(6244,4947,'Y','18','021','EC','A','','','AC','0000550031','0000550031','OH00000303456','IL','1','Taylor','Toby','','','','34','414532741','565 DELTA AVE',0,'CINCINNATI','OH','45226','2051','CY','39061','1976-09-03','M','U',':RET:2106-3','N','021','DEN','219928','99734OH005000301','2014-01-01','2013-11-19 13:48:57','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:31:43'),(15022,12006,'N','01','021','EC','A',NULL,NULL,'','0001548248','0001235057','','IL','1','mai','uyen','t','','','34','437998423','20357 chaumont ave',0,'baton rouge','LA','70817',NULL,'CY','22033','1978-05-15','F','',':RET:2047-9','N','021','DEN','2353135','18575LA002000201','2014-02-01','2013-12-29 20:39:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:02:20'),(14715,11748,'N','01','021','EC','A',NULL,NULL,'','0001020425','0000277280','','IL','1','Jeffries','Ileane','L','','','34','279685153','22095 Libby Rd',0,'Bedford','OH','44146',NULL,'CY','39035','1964-03-28','F','',':RET:2054-5','N','021','DEN','2083900','99734OH005000301','2014-02-01','2013-12-27 23:56:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:09:24'),(5665,4494,'Y','18','021','EC','A','','','AC','0001128987','0001128987','OH00001005220','IL','1','spicer','helen','','','','34','276504659','1679 rockford st',0,'akron','OH','44301',NULL,'CY','39153','1951-08-25','F','M',':RET:2106-3','N','021','HLT','1095442','52664OH151001304','2014-01-01','2013-11-26 14:47:18','402.00',NULL,NULL,'640.70','238.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 23:31:52'),(8007,6337,'Y','18','021','EC','A','','','AC','0000734744','0000734744','TX00000707303','IL','1','Sparkman','Patsy','','','','34','445585288','1703 NORWICH AVE',0,'LUBBOCK','TX','79416','6907','CY','48303','1953-11-17','F','U',':RET:2106-3','N','021','DEN','1756250','33348TX002000101','2014-01-01','2013-12-20 14:39:48','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-26 03:08:32'),(4374,3475,'Y','18','021','EC','A','','','AC','0000447443','0000447443','OH00001007848','IL','1','Mason','Harold','Crew','','','34','276864032','2621 N. Moreland Blvd',0,'Cleveland','OH','44120',NULL,'CY','39035','1972-09-12','M','R',':RET:2054-5','N','021','DEN','509760','99734OH005000401','2014-01-01','2013-12-12 07:21:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:24'),(3571,2868,'Y','18','021','EC','A','','','AC','0000876057','0000876057','OH00000564383','IL','1','Gross','Teresa','','','','34','271665958','8480 Greenville Saint Marys Rd',0,'Greenville','OH','45331',NULL,'CY','39037','1959-10-30','F','M',':RET:2106-3','N','021','HLT','1935101','92036OH005000506','2014-01-01','2013-12-22 07:24:12','1152.00',NULL,NULL,'1199.96','47.96','R-OH003','OH0','507.51',NULL,0,'2013-12-25 21:22:34'),(7168,5684,'N','19','021','EC','A',NULL,NULL,'','0000870633','0000833421','','IL','1','Yang','Jake','','','','34','288020289','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1997-10-22','M','',':RET:2034-7','N','021','HLT','1985187','92036OH003002705','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2013-12-26 01:52:39'),(6766,5368,'Y','18','021','EC','A','','','AC','0000039695','0000039695','LA00000053295','IL','1','Smith','Elizabeth','','','','34','434339860','2623 BESSEMER ST',0,'KENNER','LA','70062','5019','CY','22051','1977-12-19','F','U',':RET:2106-3','N','021','DEN','195001','18575LA002000201','2014-01-01','2013-11-24 23:00:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:16:30'),(22933,18282,'Y','18','024','14','A','','','TE','0000200762','0000200762','','IL','1','Sheal','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-02','F','',NULL,NULL,NULL,'','1717345','','2014-02-28','2014-02-11 18:20:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:12'),(28219,22328,'Y','18','024','14','A','','','TE','0000356080','0000356080','','IL','1','Ferguson','Teresa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-30','F','',NULL,NULL,NULL,'','2687428','','2014-03-06','2014-03-06 13:52:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-06 21:30:18'),(779,643,'Y','18','021','EC','A','','','AC','0000586952','0000586952','TX00000152862','IL','1','Bueno','Ingrid','','','','34','461438810','716 SANTA BARBARA DR',0,'EL PASO','TX','79915','2118','CY','48141','1964-10-11','F','M',':RET:2106-3','N','021','DEN','1835942','33348TX002000201','2014-01-01','2013-12-16 14:10:37','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:05:00'),(6203,4916,'Y','18','021','EC','A','','','AC','0000100021','0000100021','OH00000337475','IL','1','DeJane','Diana','','','','34','275609605','10136 PLYMOUTH ST',0,'HANOVERTON','OH','44423','9623','CY','39029','1956-04-21','F','U',NULL,'N','021','DEN','1017131','99734OH005000401','2014-01-01','2013-10-16 18:55:05','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:30:40'),(1462,1219,'Y','18','024','14','A','','','TE','0000209634','0000209634','','IL','1','Lange','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-02','F','',NULL,NULL,NULL,'','1936448','','2013-12-24','2013-12-24 08:53:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:22'),(1645,1375,'Y','18','024','14','A','','','TE','0000493005','0000493005','','IL','1','McGee','Crystal','Rae',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-26','F','',NULL,NULL,NULL,'','507160','','2013-12-24','2013-12-24 15:51:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:53:12'),(21143,16894,'Y','18','021','EC','A','','','AC','0000584548','0000584548','TX00002208638','IL','1','NGUYEN','HEIDI','','','','34','586383419','19134 WALBROOK MEADOWS LN',0,'CYPRESS','TX','77433','2762','CY','48201','1949-11-01','F','U',NULL,'N','021','DEN','3198797','33348TX002000201','2014-03-01','2014-02-03 16:42:56','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-03 21:00:23'),(2081,1703,'N','01','021','EC','A',NULL,NULL,'','0000670280','0000338287','','IL','1','Whatley','Gloria','Mae','','','34','433983221','2041 CONSTANTINE DR',0,'MARRERO','LA','70072','4558','CY','22051','1956-10-08','F','',':RET:2054-5','N','021','DEN','743126','18575LA002000201','2014-01-01','2013-12-09 23:47:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:16:37'),(19920,15885,'N','19','021','EC','A',NULL,NULL,'','0000707455','0000174172','','IL','1','THOMPSON','JOSIAH','L','','','34','428714862','110 WINNSBORO CT',0,'JACKSON','MS','39206','2520','CY','28049','1991-06-29','M','',NULL,'N','021','DEN','2920526','46300MS002000101','2014-03-01','2014-01-24 12:06:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-24 21:01:04'),(9386,7443,'Y','18','021','EC','A','','','AC','0001215476','0001215476','TX00000384104','IL','1','MARTIN','EUNICE','','','','34','454215113','7946 STATE HIGHWAY 31 W',0,'ATHENS','TX','75751','8500','CY','48213','1953-02-15','F','M',':RET:2106-3','N','021','DEN','1987336','33348TX002000201','2014-01-01','2013-12-20 19:36:44','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:32:13'),(13091,10437,'Y','18','021','EC','A','','','AC','0000192734','0000192734','OH00000818337','IL','1','PARKER','CAROLINE','LOUISE','','','34','271542513','56 N PERSHING AVE',0,'AKRON','OH','44313','6258','CY','39153','1950-11-05','F','U',':RET:2054-5','T','021','DEN','2373234','99734OH005000401','2014-01-01','2013-12-23 11:38:13','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:51:52'),(19914,15883,'Y','18','021','EC','A','','','AC','0000300124','0000300124','TX00001793921','IL','1','Aziz','Sikander','','','','34','635923204','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1958-09-29','M','M',':RET:2029-7','N','021','DEN','2526649','33348TX002000101','2014-03-01','2014-01-24 00:06:15','0.00',NULL,NULL,'81.45','81.45','R-TX008','TX0','27.15',NULL,0,'2014-01-24 21:01:01'),(15415,12331,'Y','18','021','EC','A','','','AC','0000172447','0000172447','TX00001447314','IL','1','Nguyen','Stephen','','','','34','482041130','2034 Burnside Dr.',0,'Allen','TX','75013',NULL,'CY','48085','1966-01-19','M','U',':RET:2047-9','N','021','DEN','2208683','33348TX002000201','2014-02-01','2013-12-31 07:59:09','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:27:15'),(24053,19130,'Y','18','021','EC','A','','','AC','0000888222','0000888222','OH00001984556','IL','1','CHENZIRA','SAKILE','S','','','34','291544321','2308 MADISON RD',0,'CINCINNATI','OH','45208','2631','CY','39061','1954-06-23','F','U',NULL,'N','021','DEN','3253306','99734OH005000301','2014-03-01','2014-02-14 18:54:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:01:05'),(25294,20068,'Y','18','021','EC','A','','','AC','0000902258','0000902258','OH00002342131','IL','1','SATURDAY','SHAWN','','','','34','297729139','676 GLENSPRINGS DR',0,'CINCINNATI','OH','45246','2125','CY','39061','1963-06-15','M','U',':RET:2054-5','N','021','DEN','2817018','99734OH005000401','2014-03-01','2014-02-25 10:51:03','11.47',NULL,NULL,'50.05','38.58','R-OH004','OH0','0.00','CIC',0,'2014-02-25 21:00:25'),(25918,20553,'Y','18','021','EC','A','','','AC','0001226884','0001226884','TX00002533237','IL','1','KRENEK','HELEN','','','','34','457963974','178 COUNTY ROAD 222A',0,'SCHULENBURG','TX','78956','2503','CY','48149','1952-02-10','F','U',NULL,'N','021','DEN','3672296','33348TX002000201','2014-04-01','2014-02-26 15:26:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:18'),(680,559,'N','01','021','EC','A',NULL,NULL,'','0000635994','0000154632','','IL','1','Vargas Escorcia','Juan',NULL,NULL,NULL,NULL,NULL,'496 N Firestone Blvd',0,'Akron','OH','44301',NULL,'CY','39153','1962-03-08','M','',NULL,'N','021','DEN','2609121','99734OH005000301','2014-01-01','2013-12-16 10:49:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:22'),(5996,4747,'N','01','021','EC','A',NULL,NULL,'','0000908129','0001019977','','IL','1','Wesley','Lee','A','','','34','434825457','219 LATHAM LN',0,'MONROE','LA','71202','8566','CY','22073','1950-06-16','F','',':RET:2054-5','N','021','DEN','555620','18575LA002000201','2014-01-01','2013-12-01 16:39:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:00:13'),(20286,16191,'Y','18','021','EC','A','','','AC','0000632719','0000632719','OH00001583189','IL','1','HRONEK','CHRISTINA','','','','34','287769149','3458 DORIS RD',0,'CLEVELAND','OH','44111','2974','CY','39035','1975-01-19','F','R',':RET:2106-3','N','021','DEN','3232742','99734OH005000401','2014-03-01','2014-01-28 17:31:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-28 21:00:32'),(20094,16032,'Y','18','021','EC','A','','','AC','0002050238','0002050238','LA00001773417','IL','1','Madere','Ramsey','','','','34','436752169','6788 HIGHWAY 996',0,'BELLE ROSE','LA','70341','5351','CY','22007','1988-03-19','M','M',':RET:2106-3','N','021','DEN','1664313','18575LA002000201','2014-03-01','2014-01-27 00:49:25','0.00',NULL,NULL,'29.22','29.22','R-LA002','LA0','14.61',NULL,0,'2014-01-27 21:00:31'),(4800,3804,'Y','18','021','EC','A','','','AC','0000839005','0000839005','LA00000251989','IL','1','Chatham','Joseph','','','','34','587564697','43 FRONT ST',0,'MINDEN','LA','71055','8101','CY','22119','1951-09-02','M','M',':RET:2106-3','N','021','DEN','196436','18575LA002000201','2014-01-01','2013-12-07 20:55:27','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:16:28'),(1034,848,'Y','18','021','EC','A','','','AC','0001131775','0001131775','TX00001248982','IL','1','MUNIZ','DANIEL','','','','34','450997643','2816 JENNIFER',0,'COLLEGE STATION','TX','77845',NULL,'CY','48041','1987-10-18','M','U',':RET:2106-3','N','021','DEN','380710','33348TX002000201','2014-01-01','2013-12-03 13:04:23','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 18:15:35'),(4335,3444,'Y','18','021','EC','A','','','AC','0000461917','0000461917','OH00001210469','IL','1','BENSMAN','JOHN','','','','34','291483622','908 METBLISS AVE',0,'DELPHOS','OH','45833',NULL,'CY','39161','1951-09-30','M','M',NULL,'N','021','HLT','1624117','92036OH002001501','2014-01-01','2013-12-17 10:52:00','901.00',NULL,NULL,'1444.41','543.41','R-OH002','OH0','730.20',NULL,0,'2013-12-25 21:53:08'),(19635,15649,'Y','18','021','EC','A','','','AC','0000166403','0000166403','OH00001639167','IL','1','WALDROOP','SAMUEL','EUGENE','','Jr','34','277608986','10953 COMANCHE DR',0,'SIDNEY','OH','45365','9566','CY','39149','1963-02-02','M','M',':RET:2106-3','N','021','DEN','3321419','99734OH005000401','2014-03-01','2014-01-23 16:44:26','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-23 21:00:11'),(2060,1687,'Y','18','021','EC','A','','','AC','0000552609','0000552609','OH00001028517','IL','1','Macaluso','Joseph','','','','34','272507690','2 CURRY LN',0,'MILFORD','OH','45150','1891','CY','39025','1951-10-17','M','M',':RET:2106-3','N','021','DEN','732002','99734OH005000301','2014-01-01','2013-12-10 14:33:04','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-25 19:16:05'),(17739,14174,'N','19','021','EC','A',NULL,NULL,'','0000250269','0000049516','','S1','1','Hindel','Scott','','','','34','876228983','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2011-12-16','M','',':RET:2106-3','N','021','HLT','2130210','52664OH151001304','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-14 01:33:23'),(16252,13012,'N','19','021','EC','A',NULL,NULL,'','0000236286','0000775106','','IL','1','bonenfant','Brandon','l','','','34','271982735','25271 SPRAGUE RD',0,'COLUMBIA STATION','OH','44028','9602','CY','39093','1994-07-26','M','',':RET:2106-3','N','021','DEN','2522495','99734OH005000301','2014-02-01','2014-01-04 15:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:39'),(7026,5579,'Y','18','021','EC','A','','','AC','0000821770','0000821770','TX00000144161','IL','1','Alejo','Michelle','','','','34','454551537','615 W NORRIS ST',0,'EL CAMPO','TX','77437','2429','CY','48481','1981-04-03','F','M',NULL,'N','021','DEN','2448836','33348TX002000201','2014-01-01','2013-12-24 22:25:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:59'),(7891,6240,'N','01','021','EC','A',NULL,NULL,'','0000659881','0001236552','','IL','1','Brown','Roy','A','','','34','290524445','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1956-06-29','M','',':RET:2106-3','N','021','HLT','1394898','92036OH005002605','2014-01-01','2013-12-20 08:35:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.21',NULL,0,'2013-12-26 03:05:37'),(9624,7622,'Y','18','021','EC','A','','','AC','0000463223','0000463223','OH00000070458','31','1','Freemal','Laura','','','','34','285626215','PO Box 2185',0,'Hudson','OH','44236',NULL,'CY','39153','1968-01-07','F','U',':RET:2106-3','N','021','HLT','1540996','52664OH151001501','2014-01-01','2013-12-20 20:02:35','247.00',NULL,NULL,'386.22','139.22','R-OH012','OH0','386.22',NULL,0,'2013-12-26 04:38:00'),(13024,10382,'Y','18','021','EC','A','','','AC','0000829275','0000829275','OH00000036471','IL','1','Brown','Branford','','','','34','299625116','10189 Amberwood Court',0,'Cincinnati','OH','45241',NULL,'CY','39061','1958-11-25','M','U',':RET:2054-5','N','021','DEN','1781650','99734OH005000401','2014-01-01','2013-12-22 21:53:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:09'),(15582,12469,'Y','18','024','14','A','','','TE','0000114189','0000114189','','IL','1','Smith','Todd',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-29','M','',NULL,NULL,NULL,'','1495047','','2013-12-30','2013-12-30 19:25:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:13'),(13537,10793,'Y','18','021','EC','A','','','AC','0001360993','0001360993','LA00000742965','IL','1','Calloway','Cameron','','','','34','433815981','1438 S WOODHAVEN ST',0,'BATON ROUGE','LA','70815','4753','CY','22033','1990-10-10','M','U',':RET:2106-3','N','021','DEN','1624511','18575LA002000201','2014-01-01','2013-12-23 12:53:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:03:38'),(25659,20357,'Y','18','021','EC','A','','','AC','0000561724','0000561724','OH00002056845','IL','1','BLAIR','DOUG','','','','34','170485392','265 STATE ROUTE 95',0,'JEROMESVILLE','OH','44840','9610','CY','39005','1956-01-05','M','U',':RET:2106-3','N','021','HLT','2968214','52664OH152000901','2014-04-01','2014-02-22 11:36:00','256.00',NULL,NULL,'416.19','160.19','R-OH012','OH0','416.19',NULL,0,'2014-02-26 08:30:43'),(21573,17231,'Y','18','021','EC','A','','','AC','0000349299','0000349299','OH00001575903','IL','1','SCOTT','RAYMONE','','','','34','285787390','1020 JEFFERSON AVE',0,'AKRON','OH','44302',NULL,'CY','39153','1976-09-22','M','U',':RET:2054-5','N','021','HLT','3386398','52664OH151001304','2014-03-01','2014-02-05 09:19:41','118.00',NULL,NULL,'276.08','158.08','R-OH012','OH0','276.08',NULL,0,'2014-02-05 21:30:22'),(16442,13156,'Y','18','021','EC','A','','','AC','0000289080','0000289080','MS00002023414','IL','1','dressner','jennifer','','','','34','227558711','31 virgil mitchell rd',0,'picayune','MS','39466',NULL,'CY','28109','1987-07-26','F','M',':RET:2106-3','N','021','DEN','1555615','46300MS002000101','2014-02-01','2014-01-05 23:11:50','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,0,'2014-01-07 04:05:09'),(686,564,'N','01','021','EC','A',NULL,NULL,'','0000990051','0001199480','','IL','1','ferreri','susan','h','','','34','274585986','25 FIELDSTONE',0,'POLAND','OH','44514','4201','CY','39099','1955-04-23','F','',':RET:2106-3','N','021','DEN','2466880','99734OH005000301','2014-01-01','2013-12-16 12:25:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:31'),(23375,18626,'N','01','021','EC','A',NULL,NULL,'','0000350616','0000553959','','IL','1','SARRIS','MARY','','','','34','271786971','1617 CRESTWOOD RD',0,'CLEVELAND','OH','44124',NULL,'CY','39035','1962-05-04','F','',':RET:2106-3','N','021','DEN','3590773','99734OH005000401','2014-03-01','2014-02-13 09:13:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:56'),(24591,19521,'N','19','021','EC','A',NULL,NULL,'','0000278358','0000988936','','IL','1','BOGGAN','ALYA','','','','34','291025826','20551 MILLER AVE',0,'EUCLID','OH','44119','2312','CY','39035','1997-12-27','F','',NULL,'N','021','DEN','3495804','99734OH005000301','2014-04-01','2014-02-19 13:13:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:10:43'),(21433,17130,'Y','18','021','EC','A','','','AC','0000913717','0000913717','TX00001869087','IL','1','Austin','Bonnie','','','','34','453676584','130 CEDAR',0,'ONALASKA','TX','77360','7028','CY','48373','1978-01-24','F','U',':RET:2106-3','N','021','DEN','2959220','33348TX002000101','2014-03-01','2014-02-04 16:23:46','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-04 21:01:19'),(1075,881,'Y','18','021','EC','A','','','AC','0000721317','0000721317','OH00000308049','IL','1','Heskamp','Joshua','','','','34','129728619','419 Kellyann Ct.',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-10-22','M','U',':RET:2106-3','N','021','DEN','329132','99734OH005000401','2014-01-01','2013-12-03 09:09:09','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:16:37'),(20600,16459,'N','01','021','EC','A',NULL,NULL,'','0000287127','0001170867','','IL','1','ALLISON','VICKI','L','','','34','277645640','3521 HARRISON AVE NW',0,'CANTON','OH','44709','2762','CY','39151','1956-07-24','F','',':RET:2106-3','N','021','DEN','3370150','99734OH005000401','2014-03-01','2014-01-30 12:51:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:12'),(20183,16107,'Y','18','021','EC','A','','','AC','0001135198','0001135198','OH00001800996','IL','1','Williams','Ryan','','','','34','276923551','249 CENTER RD',0,'BEDFORD','OH','44146','2732','CY','39035','1988-09-06','M','U',':RET:2054-5^:RET:2106-3','N','021','HLT','1774581','92036OH001000801','2014-03-01','2014-01-26 23:46:50','0.00',NULL,NULL,'283.15','283.15','R-OH011','OH0','283.15',NULL,0,'2014-01-27 21:01:22'),(18983,15124,'Y','18','024','14','A','','','TE','0000408502','0000408502','','IL','1','Andrews','Tonya',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-31','F','',NULL,NULL,NULL,'','2850751','','2014-01-17','2014-01-17 12:12:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:06:08'),(3368,2699,'Y','18','021','EC','A','','','AC','0000348881','0000348881','TX00000950322','31','1','Curry','Matthew','William','','','34','452454305','400 N. Val Verde Load',0,'BONNA','TX','78537',NULL,'CY','48381','1964-12-03','M','M',NULL,'N','021','DEN','1700790','33348TX002000201','2014-01-01','2013-12-22 15:24:18','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 21:17:10'),(13715,10944,'Y','18','021','EC','A','','','AC','0000905597','0000905597','OH00001157795','IL','1','Walder','Michelle','','','','34','280868891','2562 GRAHAM RD',0,'STOW','OH','44224','3504','CY','39153','1984-05-01','F','U',':RET:2106-3','N','021','HLT','2605595','52664OH151001304','2014-01-01','2013-12-23 15:23:45','82.00',NULL,NULL,'249.55','167.55','R-OH012','OH0','249.55',NULL,0,'2013-12-26 13:09:02'),(17422,13942,'Y','18','021','EC','A','','','AC','0000271440','0000271440','OH00001609355','IL','1','ruby','jennifer','','','','34','278905499','1470alphadaave',0,'akron','OH','44310',NULL,'CY','39153','1971-03-27','F','U',':RET:2106-3','T','021','HLT','2619168','52664OH151001306','2014-02-01','2014-01-10 12:39:24','224.00',NULL,NULL,'339.81','115.81','R-OH012','OH0','339.81',NULL,0,'2014-01-13 03:00:27'),(9165,7269,'Y','18','024','14','A','','','TE','0000321005','0000321005','','IL','1','Shupp','Steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-01-27','M','',NULL,NULL,NULL,'','842123','','2013-12-18','2013-12-18 08:37:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:08:47'),(1974,1613,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000880226','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','1245360','33348TX002000101','2014-01-01','2013-11-19 23:03:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:33'),(8865,7029,'Y','18','021','EC','A','','','AC','0000035657','0000035657','TX00000708340','IL','1','Liles','Patricia','','','','34','461394226','205 COUNTY ROAD 2455',0,'MINEOLA','TX','75773','6931','CY','48499','1963-01-14','F','M',':RET:2106-3','N','021','DEN','2311519','33348TX002000201','2014-01-01','2013-12-18 12:42:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:24'),(2358,1923,'Y','18','021','EC','A','','','AC','0000680814','0000680814','OH00000495728','IL','1','Shafitz','Michael','','','','34','420782243','4021 Eastern Avenue',0,'Cincinnati','OH','45226',NULL,'CY','39061','1952-08-25','M','M',NULL,'N','021','DEN','24288','99734OH005000401','2014-01-01','2013-12-08 21:01:16','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:32:27'),(8922,7074,'Y','18','021','EC','A','','','AC','0000137558','0000137558','OH00000366978','IL','1','Brewer','Nancy','Ann','','','34','299567614','10220 GREENVILLE SAINT MARYS RD',0,'VERSAILLES','OH','45380','9538','CY','39037','1954-10-30','F','M',':RET:2106-3','N','021','DEN','1410153','99734OH005000401','2014-01-01','2013-12-18 07:49:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:02:48'),(2694,2183,'Y','18','021','EC','A','','','AC','0000485197','0000485197','TX00000043868','IL','1','Habib','Mohamed','','','','34','329683615','1907 MIDNIGHT LN',0,'HOUSTON','TX','77047','2559','CY','48201','1950-03-15','M','M',':RET:2029-7','N','021','DEN','203102','33348TX002000201','2014-01-01','2013-12-02 17:24:35','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:47:35'),(13578,10829,'Y','18','021','EC','A','','','AC','0001532857','0001532857','LA00000213049','IL','1','Thomas','Nathan','','','','34','436908411','3413 TAYLOR ST',0,'LAKE CHARLES','LA','70607','2107','CY','22019','1950-01-31','M','U',':RET:2054-5','N','021','DEN','1865673','18575LA002000201','2014-01-01','2013-12-23 18:09:50','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 13:04:49'),(6273,4973,'N','01','021','EC','A',NULL,NULL,'','0000877097','0000467072','','IL','1','Winkler','James','','','','34','295644972','132 N 4TH ST',0,'RITTMAN','OH','44270','1336','CY','39169','1960-09-12','M','',':RET:2106-3','N','021','DEN','1190631','99734OH005000401','2014-01-01','2013-12-10 18:44:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:45:09'),(22691,18118,'Y','18','021','EC','A','','','AC','0000818059','0000818059','TX00001659907','IL','1','LATSON','LINDA','','','','34','449980055','2606 SYMPHONY PARK DR',0,'BRYAN','TX','77802','5931','CY','48041','1951-06-08','F','U',':RET:2054-5','N','021','DEN','3661668','33348TX002000101','2014-03-01','2014-02-10 19:14:29','0.00',NULL,NULL,'25.02','25.02','R-TX006','TX0','25.02',NULL,0,'2014-02-11 21:00:52'),(24475,19443,'Y','18','021','EC','A','','','AC','0000994019','0000994019','OH00001691944','IL','1','ALLEN','PRECIOUS','','','','34','292921293','3406 MIDDLESEX DR',0,'TOLEDO','OH','43606','1621','CY','39095','1990-10-04','F','U',':RET:2054-5','N','021','HLT','2802996','92036OH004002601','2014-04-01','2014-02-18 17:12:30','0.00',NULL,NULL,'156.79','156.79','R-OH001','OH0','156.79',NULL,0,'2014-02-18 22:01:41'),(28693,22707,'Y','18','021','EC','A','','','AC','0002064256','0002064256','LA00003006412','IL','1','dunn','diannia','','','','34','439419177','435 BAYOU LOOP',0,'BOSSIER CITY','LA','71112','8783','CY','22015','1966-03-31','F','M',NULL,'N','021','DEN','3592857','18575LA002000101','2014-04-01','2014-03-07 22:20:22','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-03-08 21:31:04'),(18667,14881,'Y','18','021','EC','A','','','AC','0000759807','0000759807','TX00002185765','IL','1','Christian','Randy','','','','34','467985814','1617 EL CAMINO REAL',0,'EULESS','TX','76040','3562','CY','48439','1953-04-18','M','U',':RET:2106-3','N','021','DEN','2163760','33348TX002000201','2014-03-01','2014-01-16 17:04:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:16'),(96,85,'Y','18','021','EC','A','','','AC','0001092888','0001092888','TX00001129597','IL','1','Huber','Gregory','','','','34','459351809','3023 MILLER RD',0,'ROSHARON','TX','77583','4557','CY','48157','1961-10-24','M','R',':RET:2106-3','N','021','DEN','847559','33348TX002000201','2014-01-01','2013-12-05 09:09:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:17:35'),(341,279,'N','01','021','EC','A',NULL,NULL,'','0000243701','0000262693','','IL','1','lagreca','amy','h','','','34','269664342','4030 carrie ave.',0,'cincinnati','OH','45211',NULL,'CY','39061','1959-07-19','F','',':RET:2106-3','T','021','DEN','178379','99734OH005000401','2014-01-01','2013-11-08 20:09:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:31:58'),(365,302,'Y','18','021','EC','A','','','AC','0000361659','0000361659','TX00000921027','IL','1','Kay','Richard','','','','34','493561657','14722 CELESTIAL PL',0,'DALLAS','TX','75254','7560','CY','48113','1950-04-04','M','M',':RET:2106-3','N','021','DEN','39002','33348TX002000201','2014-01-01','2013-12-03 22:15:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:45:17'),(4811,3813,'Y','18','021','EC','A','','','AC','0000643207','0000643207','OH00000068642','IL','1','owings','Tara','','','','34','300583322','17EAST NORMAN AVE',0,'DAYTON','OH','45405',NULL,'CY','39113','1958-06-27','F','U',':RET:2054-5','N','021','DEN','207394','99734OH005000301','2014-01-01','2013-12-08 13:59:06','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:16:47'),(1124,924,'Y','18','021','EC','A','','','AC','0000993940','0000993940','OH00000289730','IL','1','Wenning','Curtis','','','','34','283504820','803 Fox St.',0,'New Bremen','OH','45869',NULL,'CY','39011','1951-05-07','M','U',':RET:2106-3','N','021','HLT','1177839','92036OH003001501','2014-01-01','2013-12-03 13:47:06','573.00',NULL,NULL,'660.32','87.32','R-OH002','OH0','660.32',NULL,0,'2013-12-25 18:17:51'),(13345,10657,'Y','18','021','EC','A','','','AC','0000524040','0000524040','TX00000728404','IL','1','Uprety','Nisha','','','','34','303278283','2 ORANGE CT',0,'LONGVIEW','TX','75604','5840','CY','48183','1976-11-04','F','M',NULL,'N','021','DEN','2412529','33348TX002000201','2014-01-01','2013-12-23 18:49:11','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 12:59:03'),(22135,17667,'Y','18','021','EC','A','','','AC','0001050678','0001050678','OH00001739694','IL','1','Gibson','Kevin','','','','34','272729618','300 CEDARBROOK DR',0,'PAINESVILLE','OH','44077','2814','CY','39085','1967-07-19','M','U',':RET:2054-5','N','021','DEN','3176879','99734OH005000401','2014-03-01','2014-02-08 15:47:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-08 19:00:45'),(22145,17676,'Y','18','021','EC','A','','','AC','0000550107','0000550107','OH00002375080','IL','1','Knerem','Christine','','','','34','293621708','8249 Newton Falls Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1959-10-24','F','M',':RET:2106-3','T','021','HLT','3064179','52664OH152000901','2014-03-01','2014-02-08 17:16:52','401.04',NULL,NULL,'401.04','0.00','R-OH012','OH0','401.04',NULL,0,'2014-02-08 19:00:50'),(24201,19221,'N','19','021','EC','A',NULL,NULL,'','0000221366','0000207178','','IL','1','Albrinck','Nathan','','','','34','288080882','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','2003-10-01','M','',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:18'),(25184,19976,'Y','18','021','EC','A','','','AC','0000293243','0000293243','OH00002303245','IL','1','Smith','Michael','','','','34','280926006','39 east court street',0,'Cincinnati','OH','45202',NULL,'CY','39061','1988-03-30','M','U',':RET:2106-3','N','021','DEN','3344895','99734OH005000401','2014-04-01','2014-02-21 15:31:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-21 22:00:35'),(28824,22812,'Y','18','021','EC','A','','','AC','0000413425','0000413425','OH00002777184','IL','1','cousino','shelly',NULL,NULL,NULL,NULL,NULL,'103 TYLER DR',0,'WALBRIDGE','OH','43465','1459','CY','39173','1963-07-29','F','U',NULL,'N','021','HLT','4354966','92036OH004002601','2014-04-01','2014-03-09 14:26:29','145.00',NULL,NULL,'280.03','135.03','R-OH001','OH0','280.03',NULL,0,'2014-03-09 21:01:02'),(719,594,'Y','18','024','14','A','','','TE','0000540730','0000540730','','IL','1','Steinbach','Vicki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-12-14','F','',NULL,NULL,NULL,'','125443','','2013-12-15','2013-12-15 23:48:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:03:24'),(17721,14160,'N','01','021','EC','A',NULL,NULL,'','0000783254','0000057352','','IL','1','Brown','Laura','E','','','34','270803911','541 CLARK DR',0,'TALLMADGE','OH','44278','1549','CY','39153','1973-01-11','F','',':RET:2106-3','N','021','HLT','2720438','52664OH152000901','2014-02-01','2014-01-13 15:10:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','212.67',NULL,0,'2014-01-14 01:33:14'),(1169,964,'Y','18','021','EC','A','','','AC','0000334350','0000334350','LA00001259342','IL','1','Teer','Miki','Elizabeth','','','34','435595778','587 DEMERY BLVD',0,'SHREVEPORT','LA','71115','3648','CY','22017','1985-11-05','F','U',':RET:2106-3','N','021','DEN','146745','18575LA002000201','2014-01-01','2013-12-03 17:54:03','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:19:06'),(1288,1065,'Y','18','021','EC','A','','','AC','0001192630','0001192630','OH00000399015','IL','1','Burks','Stephanie','','','','34','273905942','5080 LONGRIFLE RD',0,'WESTERVILLE','OH','43081','4491','CY','39049','1988-10-17','F','U',':RET:2054-5','N','021','DEN','341881','99734OH005000301','2014-01-01','2013-11-29 14:20:00','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:30:46'),(13346,10658,'Y','18','021','EC','A','','','AC','0000731543','0000731543','TX00000629744','31','1','willis-barbosa','pedro','','','','34','447844653','238 east state st',0,'badgen ridge','LA','70802',NULL,'CY','48423','1984-11-26','M','U',NULL,'N','021','DEN','1504629','33348TX002000201','2014-01-01','2013-12-23 18:50:36','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-26 12:59:04'),(17417,13939,'Y','18','021','EC','A','','','AC','0000484810','0000484810','OH00002276200','IL','1','Boyd','Debra','','','','34','270744086','12789 STATE ROUTE 774',0,'BETHEL','OH','45106','8672','CY','39015','1965-07-29','F','M',':RET:2106-3','N','021','HLT','1858143','92036OH003000605','2014-02-01','2014-01-10 10:17:20','663.00',NULL,NULL,'950.09','287.09','R-OH005','OH0','366.54',NULL,0,'2014-01-13 03:00:25'),(16256,13014,'N','01','021','EC','A',NULL,NULL,'','0000205160','0000313796','','IL','1','PERRY','RONALD','','','','34','423088405','130 SANDERSON RD',0,'LUCEDALE','MS','39452','3585','CY','28039','1969-12-19','M','',NULL,'N','021','DEN','2447712','46300MS002000201','2014-02-01','2014-01-04 10:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-05 00:02:45'),(19968,15928,'N','19','021','EC','A',NULL,NULL,'','0000520989','0000984876','','IL','1','PODLICH','CHRISTOPHER','MARTIN','','','34','283920442','360 HENRY ST',0,'AMHERST','OH','44001','2427','CY','39093','1990-06-18','M','',':RET:2106-3','N','021','DEN','2865151','99734OH005000301','2014-03-01','2014-01-25 13:22:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:10'),(21117,16873,'Y','18','021','EC','A','','','AC','0000041182','0000041182','TX00002408921','IL','1','Randolph','Alisa','','','','34','312880285','19002 KEMBLE RD',0,'HUMBLE','TX','77346','2621','CY','48201','1976-01-12','F','M',':RET:2106-3','N','021','DEN','2772464','33348TX002000201','2014-03-01','2014-02-03 10:08:34','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-03 21:00:10'),(22850,18232,'Y','18','021','EC','A','','','AC','0000728755','0000728755','OH00001515693','IL','1','Dotson','Katlynn','','','','34','590966220','370 W. Maple Ave',0,'Van Wert','OH','45891',NULL,'CY','39161','1990-03-01','F','U',':RET:2106-3','N','021','HLT','2803926','92036OH005001505','2014-03-01','2014-02-11 15:20:03','134.00',NULL,NULL,'220.08','86.08','R-OH002','OH0','220.08',NULL,0,'2014-02-11 21:02:20'),(23081,18403,'Y','18','021','EC','A','','','AC','0001146007','0001146007','OH00001983053','IL','1','Kossick','Kevin','','','','34','278828943','103 HALL ST',0,'AKRON','OH','44303','2117','CY','39153','1966-09-03','M','M',':RET:2106-3','N','021','DEN','3609479','99734OH005000401','2014-03-01','2014-02-11 19:43:42','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-12 21:31:03'),(23108,18420,'N','19','021','EC','A',NULL,NULL,'','0000504509','0000486986','','S1','1','wong','christina','','','','34','272155640','8111 EAGLE RIDGE DR',0,'WEST CHESTER','OH','45069','1976','CY','39017','2008-12-01','F','',':RET:2028-9^:RET:2500-7','N','021','DEN','2782996','99734OH005000401','2014-03-01','2014-02-12 17:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:17'),(23530,18744,'Y','18','021','EC','A','','','AC','0001220858','0001220858','LA00002087448','IL','1','Ivey','Adria','','','','34','438117133','1803 8TH AVE',0,'LAKE CHARLES','LA','70601','6605','CY','22019','1970-11-22','F','U',':RET:2054-5','N','021','DEN','3695736','18575LA002000201','2014-03-01','2014-02-13 11:17:17','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-13 22:02:25'),(25629,20332,'N','19','021','EC','A',NULL,NULL,'','0000685891','0000194106','','IL','1','Tucker','Casey','','','','34','291068322','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2001-12-03','M','',':RET:2106-3','N','021','DEN','3742050','99734OH005000301','2014-04-01','2014-02-21 19:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 08:30:22'),(28055,22201,'Y','18','021','EC','A','','','AC','0000359171','0000359171','MS00002894129','IL','1','hay','rico','','','','34','426555030','6609 HIGHWAY 27',0,'UTICA','MS','39175','9225','CY','28049','1986-06-15','M','U',':RET:2054-5','N','021','DEN','3073984','46300MS002000201','2014-04-01','2014-03-06 17:51:29','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:40'),(28456,22516,'N','01','021','EC','A',NULL,NULL,'','0001974573','0001402653','','IL','1','Diaz Mcnab','Luis','Evans',NULL,NULL,NULL,NULL,'12743 ROE DR',0,'WALKER','LA','70785','5536','CY','22063','1960-10-16','M','',':RET:2106-3','N','021','DEN','3562425','18575LA002000201','2014-04-01','2014-03-07 12:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-07 21:31:22'),(28654,22674,'Y','18','021','EC','A','','','AC','0001671608','0001671608','LA00003085607','IL','1','SMITH','TORI','','','','34','437698366','611 HANSON AVE',0,'KENNER','LA','70062',NULL,'CY','22051','1976-07-19','F','M',':RET:2054-5','N','021','DEN','3775557','18575LA002000201','2014-04-01','2014-03-07 18:33:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:39'),(771,637,'Y','18','024','14','A','','','TE','0000987102','0000987102','','IL','1','Chapin','Carl',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-02-22','M','',NULL,NULL,NULL,'','1627992','','2013-12-16','2013-12-16 12:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:04:49'),(18603,14831,'Y','18','021','EC','A','','','AC','0000314724','0000314724','OH00002153850','IL','1','Rigney','Janet','','','','34','246061684','1069 SADDLEBACK DR',0,'BATAVIA','OH','45103','1421','CY','39025','1959-02-08','F','U',':RET:2106-3','T','021','HLT','2366279','92036OH004000601','2014-02-01','2014-01-15 12:18:22','222.00',NULL,NULL,'423.81','201.81','R-OH005','OH0','423.81',NULL,0,'2014-01-16 08:47:20'),(1121,923,'N','19','021','EC','A',NULL,NULL,'','0001118687','0001179589','','IL','1','Winegardner','Taryn',NULL,NULL,NULL,NULL,NULL,'100 MASTERS CT',0,'LIMA','OH','45805','4007','CY','39003','2007-06-12','F','',':RET:2106-3','N','021','HLT','1096653','92036OH003001501','2014-01-01','2013-12-02 19:33:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 18:17:49'),(3371,2701,'Y','18','024','14','A','','','TE','0001201183','0001201183','','IL','1','Green-Parks','Holly','Nicole',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-04-11','F','',NULL,NULL,NULL,'','2139979','','2013-12-22','2013-12-22 15:38:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:17:16'),(6054,4796,'Y','18','021','EC','A','','','AC','0000382123','0000382123','OH00000980841','IL','1','Weslek','Adam','','','','34','285805798','1296 west 116th st',0,'cleveland','OH','44102',NULL,'CY','39035','1983-05-11','M','U',':RET:2106-3','N','021','DEN','1170621','99734OH005000401','2014-01-01','2013-12-01 08:35:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:01:47'),(1628,1360,'Y','18','021','EC','A','','','AC','0000277730','0000277730','TX00000173777','IL','1','MARTINEZ','JUAN',NULL,NULL,NULL,NULL,NULL,'2808 JUNIPER AVE',0,'LUBBOCK','TX','79404','1805','CY','48303','1958-08-18','M','M',NULL,'N','021','DEN','2359825','33348TX002000201','2014-01-01','2013-12-24 14:54:07','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:52:46'),(2138,1756,'Y','18','021','EC','A','','','AC','0000291953','0000291953','OH00000563899','IL','1','Hernandez','Angel','','','','34','331724891','212 W NORTHWOOD DR',0,'LEBANON','OH','45036','1344','CY','39165','1949-04-09','M','U',NULL,'N','021','DEN','139246','99734OH005000401','2014-01-01','2013-12-10 16:56:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:18:10'),(20072,16011,'Y','18','021','EC','A','','','AC','0001051303','0001051303','TX00001834508','IL','1','Patel','Rajesh','','','','34','547537678','2525 CARLISLE ST',0,'DALLAS','TX','75201','1376','CY','48113','1978-02-28','M','U',':RET:2029-7','N','021','DEN','1465799','33348TX002000201','2014-03-01','2014-01-27 14:31:46','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-27 21:00:18'),(20613,16471,'Y','18','021','EC','A','','','AC','0001777009','0001777009','LA00001428021','IL','1','Prevost','Richard','','','','34','309087246','850 Martin Behrman Ave.',0,'Metairie','LA','70005',NULL,'CY','22051','1987-07-17','M','U',':RET:2106-3','N','021','DEN','3404315','18575LA002000101','2014-03-01','2014-01-29 18:27:28','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-30 21:00:19'),(22973,18317,'N','01','021','EC','A',NULL,NULL,'','0000059156','0001055959','','IL','1','Prater','Michael','Scot','','','34','240651600','705 GEORGE FORD RD',0,'CARRIERE','MS','39426','7486','CY','28109','1989-10-10','M','',':RET:2106-3','N','021','DEN','3142139','46300MS002000201','2014-03-01','2014-02-12 12:27:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85','CIC',0,'2014-02-12 21:00:18'),(23470,18694,'Y','18','021','EC','A','','','AC','0000707360','0000707360','TX00001927848','IL','1','Le','Thuy','','','','34','732186509','147 N SPRING CREEK DR',0,'RICHARDSON','TX','75081','3962','CY','48113','1988-09-20','F','M',':RET:2047-9','N','021','DEN','3248056','33348TX002000201','2014-03-01','2014-02-13 16:02:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:48'),(23860,18985,'Y','18','024','14','A','','','TE','0001935595','0001935595','','IL','1','CARNEY','CAROLINE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-11-13','F','',NULL,NULL,NULL,'','2569033','','2014-02-14','2014-02-14 13:09:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-14 21:32:04'),(25881,20521,'Y','18','021','EC','A','','','AC','0001036860','0001036860','TX00002842344','31','1','Solis','Ernesto','','','','34','450921384','Po box 587',0,'La Grulla','TX','78548',NULL,'CY','48427','1954-05-06','M','U',':RET:2106-3','N','021','DEN','3813707','33348TX002000201','2014-03-01','2014-02-26 08:41:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:00:58'),(26623,21109,'N','19','021','EC','A',NULL,NULL,'','0000200559','0001110765','','S1','1','Carter','Stanwyn','Jay',NULL,NULL,NULL,NULL,'3615 Rosedale St',0,'Houston','TX','77004',NULL,'CY','48201','2006-08-18','F','',':RET:2054-5','N','021','DEN','3137373','33348TX002000201','2014-04-01','2014-02-28 12:35:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-28 21:30:53'),(29044,22987,'Y','18','021','EC','A','','','AC','0000588039','0000588039','OH00002790869','IL','1','SPENCE','HAZEL','','','','34','270707850','5115 E LAKE RD',0,'SHEFFIELD LAKE','OH','44054','1733','CY','39093','1963-01-26','F','U',NULL,'T','021','DEN','3515745','99734OH005000401','2014-04-01','2014-03-10 13:40:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:42'),(13444,10720,'N','01','021','EC','A',NULL,NULL,'','0000279552','0000934665','','IL','1','STROUD','ANTHONY','','','','34','279748087','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','1973-05-30','M','',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:17'),(15398,12316,'Y','18','021','EC','A','','','AC','0000679796','0000679796','TX00001613840','IL','1','Stone','Brad','','','','34','446928158','4490 w eldorado',0,'mckinney','TX','75070',NULL,'CY','48085','1978-12-04','M','U',':RET:2106-3','N','021','DEN','2013436','33348TX002000201','2014-02-01','2013-12-30 18:42:28','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:26:41'),(20422,16311,'N','01','021','EC','A',NULL,NULL,'','0000373656','0001030393','','IL','1','Vance','Randy','L',NULL,NULL,NULL,NULL,'11217 Tecumseh Path',0,'Lakeview','OH','43331',NULL,'CY','39091','1956-08-10','M','',':RET:2106-3','N','021','DEN','3399830','99734OH005000301','2014-03-01','2014-01-29 10:16:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:30'),(21001,16780,'Y','18','021','EC','A','','','AC','0001103474','0001103474','OH00002200237','IL','1','Wallace','Sharon','','','','34','293766686','6218 Mill Stone Ct',0,'Milford','OH','45150',NULL,'CY','39025','1965-09-18','F','U',':RET:2106-3','N','021','HLT','3250550','92036OH004000601','2014-03-01','2014-01-31 21:13:34','0.00',NULL,NULL,'282.22','282.22','R-OH005','OH0','282.22',NULL,0,'2014-02-01 19:00:28'),(22401,17886,'Y','18','021','EC','A','','','AC','0000950713','0000950713','OH00001949501','IL','1','Smith','Terri','','','','34','281587399','107 Pfeiffer Ave',0,'Akron','OH','44312',NULL,'CY','39153','1955-09-15','F','U',NULL,'T','021','HLT','2990217','52664OH151001304','2014-03-01','2014-02-10 15:44:14','324.00',NULL,NULL,'653.46','329.46','R-OH012','OH0','653.46',NULL,0,'2014-02-10 21:30:20'),(25711,20396,'Y','18','021','EC','A','','','AC','0000106646','0000106646','TX00002611623','IL','1','LIRA','JOANN','R','','','34','585457503','413 S ALBERTA ST',0,'PECOS','TX','79772',NULL,'CY','48389','1971-04-30','F','M',NULL,'N','021','DEN','3736046','33348TX002000201','2014-04-01','2014-02-24 16:13:15','0.00',NULL,NULL,'43.83','43.83','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:23'),(14778,11801,'Y','18','021','EC','A','','','AC','0000264202','0000264202','OH00000805734','IL','1','Peterson','Aaron','','','','34','259630592','8238 EMERALD AVE NE',0,'CANTON','OH','44721','1772','CY','39151','1977-05-08','M','R',':RET:2106-3','N','021','HLT','1732662','52664OH151001501','2014-01-01','2013-12-23 20:51:18','0.00',NULL,NULL,'328.98','328.98','R-OH015','OH0','328.98',NULL,1,'2013-12-29 11:13:09'),(14937,11936,'Y','18','021','EC','A','','','AC','0000902213','0000902213','OH00001243817','IL','1','Bramer','Michelle','','','','34','277727661','2047 CONGO ST',0,'AKRON','OH','44305','3774','CY','39153','1975-03-09','F','U',':RET:2106-3','N','021','HLT','2331100','52664OH151001305','2014-02-01','2013-12-29 15:54:29','186.00',NULL,NULL,'277.87','91.87','R-OH012','OH0','277.87',NULL,0,'2013-12-30 00:02:11'),(13284,10603,'Y','18','021','EC','A','','','AC','0000963307','0000963307','TX00000075688','IL','1','Nordin','Richard','','','','34','320525063','5303 KITE TAIL DR',0,'AUSTIN','TX','78730','1423','CY','48453','1957-04-16','M','M',':RET:2106-3','N','021','DEN','2245532','33348TX002000201','2014-01-01','2013-12-23 13:07:35','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:57:18'),(13737,10964,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00000968838','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','2435955','52664OH151001305','2014-01-01','2013-12-23 18:30:05','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:34'),(24091,19153,'N','19','021','EC','A',NULL,NULL,'','0001109274','0000692974','','S1','1','Krause','Gary','Jay','','Jr','34','280065929','3024 Frost Road',0,'Mantua','OH','44255',NULL,'CY','39133','2001-04-24','M','',':RET:2106-3','N','021','HLT','3679734','52664OH151001304','2014-03-01','2014-02-15 14:30:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:26'),(26021,20637,'Y','18','021','EC','A','','','AC','0001206217','0001206217','TX00003070523','IL','1','Osborn','Jacqueline','','','','34','522723597','310 Comanche Drive East',0,'Lake Kiowa','TX','76240',NULL,'CY','48097','1951-04-04','F','M',':RET:2106-3','N','021','DEN','3372002','33348TX002000101','2014-04-01','2014-02-26 13:18:47','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-26 21:02:15'),(26326,20886,'Y','18','021','EC','A','','','AC','0000767936','0000767936','MS00003236743','31','1','MORTON','SONYA','','','','34','367789925','P.O BOX 486',0,'HERNANDO','MS','38632',NULL,'CY','28033','1975-07-17','F','U',':RET:2054-5','T','021','DEN','3114735','46300MS002000101','2014-03-01','2014-02-27 12:47:55','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-28 06:31:38'),(28400,22470,'Y','18','021','EC','A','','','AC','0000858549','0000858549','OH00002718865','IL','1','KIELSKI','NATHAN',NULL,NULL,NULL,NULL,NULL,'27900 BISHOP PARK DR',0,'WILLOUGHBY HILLS','OH','44092',NULL,'CY','39085','1983-12-20','M','M',NULL,'N','021','DEN','3876635','99734OH005000401','2014-04-01','2014-03-06 23:15:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:50'),(17087,13675,'Y','18','021','EC','A','','','AC','0001090661','0001090661','TX00001700093','IL','1','MARTINEZ','VERONICA','','','','34','455656665','214 DORSEY',0,'SAN ANTONIO','TX','78221',NULL,'CY','48029','1976-08-13','F','U',NULL,'N','021','DEN','2277021','33348TX002000201','2014-02-01','2014-01-08 14:48:11','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:21:25'),(9662,7655,'Y','18','021','EC','A','','','AC','0000437968','0000437968','OH00001296197','IL','1','Box','Michael','','','','34','268526480','1620 BRIM DR',0,'TOLEDO','OH','43612','4007','CY','39095','1950-10-02','M','M',NULL,'T','021','HLT','1799166','92036OH004002601','2014-01-01','2013-12-21 17:53:04','818.00',NULL,NULL,'1021.63','203.63','R-OH001','OH0','532.27',NULL,0,'2013-12-26 04:39:01'),(16427,13144,'Y','18','021','EC','A','','','AC','0001895562','0001895562','LA00002335807','IL','1','Hyatt','Toshia','','','','34','433656610','1105 North 1st Street',0,'Monroe','LA','71201',NULL,'CY','22073','1983-01-18','F','U',':RET:2106-3','N','021','DEN','2362725','18575LA002000101','2014-02-01','2014-01-06 15:38:03','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-07 04:04:41'),(5034,3987,'Y','18','021','EC','A','','','AC','0000031911','0000031911','OH00001188889','IL','1','Vaughn','Jill','','','','34','287464328','1213 Mitchell Rd.',0,'Wilmington','OH','45177',NULL,'CY','39027','1957-12-20','F','M',':RET:2106-3','N','021','HLT','1203080','92036OH002000601','2014-01-01','2013-12-07 08:53:32','803.00',NULL,NULL,'1156.72','353.72','R-OH005','OH0','578.36',NULL,0,'2013-12-25 22:47:49'),(4969,3945,'Y','18','024','14','A','','','TE','0000449280','0000449280','','IL','1','Jernigan','Janice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-01-04','F','',NULL,NULL,NULL,'','1200563','','2013-12-06','2013-12-06 18:54:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:46:23'),(3641,2913,'Y','18','021','EC','A','','','AC','0000057766','0000057766','MS00001125919','IL','1','Cain','Jacqueline','','','','34','427061768','279 E LONGVIEW DR',0,'JACKSON','MS','39213','9782','CY','28049','1958-06-15','F','U',NULL,'N','021','DEN','330737','46300MS002000201','2014-01-01','2013-12-13 15:05:47','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:22'),(21811,17418,'Y','18','021','EC','A','','','AC','0000200799','0000200799','OH00001788898','IL','1','SHUPPE','SUSAN','','','','34','270702718','2695 BERRY RD',0,'AKRON','OH','44320','3803','CY','39153','1962-03-04','F','M',':RET:2106-3','N','021','HLT','3147902','52664OH151001304','2014-03-01','2014-02-06 12:14:21','116.00',NULL,NULL,'415.91','299.91','R-OH012','OH0','415.91',NULL,0,'2014-02-06 21:00:54'),(28518,22568,'Y','18','021','EC','A','','','AC','0000292036','0000292036','OH00003565432','31','1','Burress','Kathy','','','','34','281541718','PO Box 604',0,'Hillsboro','OH','45133',NULL,'CY','39071','1954-02-16','F','U',':RET:2106-3','N','021','HLT','3352075','92036OH004000601','2014-04-01','2014-03-06 20:58:32','432.00',NULL,NULL,'468.46','36.46','R-OH005','OH0','468.46',NULL,0,'2014-03-07 21:31:58'),(467,381,'N','19','021','EC','A',NULL,NULL,'','0000626707','0000966879','','IL','1','Farnsworth','Lilian','','','','34','683665939','279 COUNTY ROAD 40',0,'SULLIVAN','OH','44880','9731','CY','39005','2012-08-03','F','',':RET:2106-3','N','021','HLT','476605','52664OH151001301','2014-01-01','2013-12-04 10:57:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 17:47:47'),(1028,843,'Y','18','021','EC','A','','','AC','0000544975','0000544975','TX00001129536','IL','1','Smith','Gary','','','','34','452786083','2610 MILLERS FALLS CT',0,'RICHMOND','TX','77406','1867','CY','48157','1950-08-28','M','M',':RET:2106-3','N','021','DEN','778771','33348TX002000201','2014-01-01','2013-12-03 09:01:24','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:15:27'),(14111,11246,'Y','18','021','EC','A','','','AC','0000902212','0000902212','OH00001727362','IL','1','Mathews','Elizabeth','Ann','','','34','269541175','9340 RORYANNA DR',0,'CHARDON','OH','44024','8669','CY','39055','1955-01-25','F','M',':RET:2106-3','N','021','DEN','1513217','99734OH005000401','2014-02-01','2013-12-26 14:15:13','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:51'),(20078,16017,'Y','18','021','EC','A','','','AC','0001059944','0001059944','TX00002183530','IL','1','Nguyen','Kevin','','','','34','564579672','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1969-08-06','M','M',':RET:2047-9','N','021','DEN','2886948','33348TX002000201','2014-03-01','2014-01-27 17:29:53','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:21'),(19929,15893,'Y','18','024','14','A','','','TE','0000103119','0000103119','','IL','1','Whitelaw','Shammery',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-10-31','M','',NULL,NULL,NULL,'','2114033','','2014-01-24','2014-01-24 13:54:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-24 21:01:08'),(19353,15426,'Y','18','021','EC','A','','','AC','0000347943','0000347943','OH00001880213','IL','1','WILSON','GERALD','','','','34','283782545','4365 W ANDERSON RD',0,'CLEVELAND','OH','44121','3574','CY','39035','1966-07-04','M','M',':RET:2054-5','N','021','DEN','2083155','99734OH005000301','2014-03-01','2014-01-21 14:20:50','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-22 03:22:26'),(6468,5125,'N','01','021','EC','A',NULL,NULL,'','0000452717','0000456498','','IL','1','Slayton','Dale','','','','34','288560070','10815 OVERTON RD',0,'BURBANK','OH','44214','9765','CY','39169','1955-09-14','M','',':RET:2106-3','N','021','HLT','236789','52664OH151001304','2014-01-01','2013-12-10 19:54:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2013-12-26 00:50:05'),(4396,3494,'N','01','021','EC','A',NULL,NULL,'','0001115918','0000596257','','IL','1','Mendez','Amber','','','','34','278905709','180 College Park Dr.',0,'Elyria','OH','44035',NULL,'CY','39093','1982-09-15','F','',':RET:2106-3','N','021','DEN','1170921','99734OH005000401','2014-01-01','2013-12-12 13:32:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:01'),(16455,13168,'Y','18','021','EC','A','','','AC','0000246461','0000246461','OH00001700035','IL','1','Dickens','Glenn','','','','34','289745157','3250 COUNTY ROAD EF',0,'SWANTON','OH','43558','9269','CY','39051','1966-12-16','M','M',':RET:2106-3','T','021','HLT','2021177','92036OH002002601','2014-02-01','2014-01-06 09:43:05','0.00',NULL,NULL,'404.77','404.77','R-OH001','OH0','404.77',NULL,0,'2014-01-07 04:05:33'),(4980,3954,'Y','18','021','EC','A','','','AC','0000355096','0000355096','TX00000879058','31','1','Adan','Felix','','','','34','466514364','P.O. Box 322',0,'Premont','TX','78375',NULL,'CY','48249','1956-07-29','M','M',NULL,'N','021','DEN','39788','33348TX002000201','2014-01-01','2013-12-07 01:18:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:41'),(14572,11627,'Y','18','021','EC','A','','','AC','0001132764','0001132764','OH00001043831','IL','1','KOYFMAN','IZABELLA','','','','34','286948425','2609 AMARA DRIVE',0,'TOLEDO','OH','43615',NULL,'CY','39095','1951-10-21','F','M',NULL,'N','021','HLT','1462229','92036OH005002605','2014-02-01','2013-12-27 11:29:08','428.00',NULL,NULL,'560.22','132.22','R-OH001','OH0','560.22',NULL,0,'2013-12-28 03:35:34'),(15237,12179,'Y','18','024','14','A','','','TE','0000743093','0000743093','','IL','1','Mitchell','Marguerite',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-24','F','',NULL,NULL,NULL,'','1450757','','2013-12-30','2013-12-30 06:33:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:08:29'),(16105,12899,'N','01','021','EC','A',NULL,NULL,'','0000091156','0000658430','','IL','1','Russel','Nikieda','F','','','34','072808629','13885 MERMILL RD',0,'RUDOLPH','OH','43462','9799','CY','39173','1992-03-22','F','',':RET:2106-3','N','021','HLT','1992943','92036OH003002605','2014-02-01','2014-01-02 22:07:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2014-01-04 02:04:53'),(20311,16214,'Y','18','021','EC','A','','','AC','0001072893','0001072893','TX00001878931','IL','1','Alcibar','Susan','','','','34','591226371','11401 Alpine Court',0,'Haslet','TX','76052',NULL,'CY','48439','1973-06-24','F','U',NULL,'N','021','DEN','2630990','33348TX002000201','2014-03-01','2014-01-28 12:41:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-28 21:00:49'),(22838,18223,'Y','18','021','EC','A','','','AC','0000407413','0000407413','OH00001842192','IL','1','Cain','Diane','m','','','34','297807583','1232 PEACH WOOD WAY',0,'UNIONTOWN','OH','44685','9500','CY','39153','1978-03-14','F','U',':RET:2106-3','N','021','HLT','3032970','52664OH151001301','2014-03-01','2014-02-11 17:53:34','0.00',NULL,NULL,'272.52','272.52','R-OH012','OH0','272.52',NULL,0,'2014-02-11 21:02:12'),(25086,19895,'Y','18','021','EC','A','','','AC','0001478788','0001478788','LA00002409376','IL','1','Dorsey','faith','','','','34','433872198','2421 ROBLEY DR',0,'LAFAYETTE','LA','70503','6600','CY','22055','1993-01-06','F','U',':RET:2054-5','N','021','DEN','2637810','18575LA002000101','2014-03-01','2014-02-20 21:53:15','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02','CIC',0,'2014-02-21 21:30:02'),(27964,22122,'N','01','021','EC','A',NULL,NULL,'','0001783011','0001363836','','IL','1','Nguyen','Huyen','','','','34','662053973','1301 ARTESA DR',0,'MARRERO','LA','70072','5974','CY','22051','1968-10-05','F','',':RET:2047-9','N','021','DEN','3675265','18575LA002000201','2014-04-01','2014-03-05 22:12:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-06 21:00:46'),(19,15,'Y','18','021','EC','A','','','AC','0000039778','0000039778','OH00000119696','IL','1','Moran','Linda','','','','34','290469504','3869 RIDGEVIEW DR',0,'RICHFIELD','OH','44286','9510','CY','39153','1949-03-02','F','U',':RET:2106-3','N','021','DEN','418234','99734OH005000401','2014-01-01','2013-12-05 10:40:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:29'),(14943,11942,'Y','18','021','EC','A','','','AC','0000577331','0000577331','OH00001457088','IL','1','MEXICOTT','MICHELLE','','','','34','269684811','A805 COUNTY ROAD 13',0,'NEW BAVARIA','OH','43548','9744','CY','39069','1966-11-07','F','M',':RET:2106-3','N','021','HLT','2049803','92036OH002002601','2014-02-01','2013-12-29 14:51:21','0.00',NULL,NULL,'351.97','351.97','R-OH001','OH0','351.97',NULL,0,'2013-12-30 00:02:23'),(2456,1997,'N','01','021','EC','A',NULL,NULL,'','0000807068','0000859202','','IL','1','BLACK','CYNTHIA','','','','34','457234007','1485 LAKEVIEW DR',0,'ST PAUL','TX','75098','4745','CY','48085','1959-05-30','F','',':RET:2106-3','N','021','DEN','284551','33348TX002000101','2014-01-01','2013-12-09 12:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 19:34:47'),(20818,16637,'Y','18','021','EC','A','','','AC','0001527185','0001527185','LA00001991582','IL','1','Mohon','JD','','','','34','587725025','37164 FORE RD',0,'DENHAM SPRINGS','LA','70706','1230','CY','22063','1952-01-04','M','U',NULL,'N','021','DEN','3672991','18575LA002000201','2014-03-01','2014-01-31 11:28:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-31 21:00:33'),(22506,17966,'Y','18','024','14','A','','','TE','0000253078','0000253078','','IL','1','Winters','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-02-18','F','',NULL,NULL,NULL,'','2107235','','2014-02-10','2014-02-10 18:06:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:15'),(23285,18563,'Y','18','021','EC','A','','','AC','0002239319','0002239319','LA00002807517','IL','1','Nguyen','Aaron','','','','34','066767210','104 BOBBIE ST',0,'ABBEVILLE','LA','70510','5506','CY','22113','1978-08-31','M','M',':RET:2047-9','N','021','DEN','3137041','18575LA002000101','2014-03-01','2014-02-13 15:48:57','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02','CIC',0,'2014-02-13 21:30:18'),(995,815,'Y','18','021','EC','A','','','AC','0000737818','0000737818','OH00001056941','IL','1','Fraley','Samantha','','','','34','452579167','7030 S Kessler Frederick Rd',0,'West Milton','OH','45383',NULL,'CY','39109','1981-05-28','F','U',':RET:2106-3','N','021','DEN','584954','99734OH005000301','2014-01-01','2013-11-11 13:06:46','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:10:45'),(20110,16045,'Y','18','021','EC','A','','','AC','0000070334','0000070334','OH00001565516','IL','1','Lanza','Sandra','','','','34','271767694','1738 STATE ROUTE 303  APARTMENT 112',0,'Streetsboro','OH','44241',NULL,'CY','39133','1966-05-14','F','U',':RET:2106-3','T','021','HLT','3438996','52664OH152000901','2014-03-01','2014-01-26 19:33:58','269.00',NULL,NULL,'293.60','24.60','R-OH012','OH0','293.60',NULL,0,'2014-01-27 21:00:40'),(13891,11080,'Y','18','021','EC','A','','','AC','0000209630','0000209630','OH00001056693','IL','1','TULK','MARY','','','','34','368583578','3230 CENTENNIAL RD LOT 132',0,'SYLVANIA','OH','43560',NULL,'CY','39095','1951-02-03','F','U',NULL,'N','021','HLT','2076038','92036OH005002605','2014-01-01','2013-12-23 15:34:57','450.00',NULL,NULL,'560.22','110.22','R-OH001','OH0','560.22',NULL,0,'2013-12-26 13:13:28'),(13375,10681,'Y','18','021','EC','A','','','AC','0000514445','0000514445','OH00000261249','IL','1','Bartholomew','Patrick','','','','34','227491613','3556 Madison Park Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1982-07-23','M','M',NULL,'T','021','DEN','2341357','99734OH005000301','2014-01-01','2013-12-22 22:27:22','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:59:49'),(9404,7460,'Y','18','024','14','A','','','TE','0000782711','0000782711','','IL','1','Serrano','Mary','Helen',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-22','F','',NULL,NULL,NULL,'','552026','','2013-12-21','2013-12-21 08:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:41'),(3268,2635,'Y','18','021','EC','A','','','AC','0000244944','0000244944','OH00000072310','IL','1','Peth','Cassandra','A','','','34','268525951','3641 Heatherdowns',0,'Toledo','OH','43614',NULL,'CY','39095','1950-10-01','F','M',':RET:2106-3','N','021','HLT','684199','92036OH003002601','2014-01-01','2013-11-27 19:35:50','615.00',NULL,NULL,'1202.24','587.24','R-OH001','OH0','601.12',NULL,0,'2013-12-25 20:47:07'),(19260,15349,'Y','18','021','EC','A','','','AC','0001775727','0001775727','LA00002072214','IL','1','Harris','Melvina','','','','34','433943742','2225 CHAMBERLAIN AVE',0,'BAKER','LA','70714','1602','CY','22033','1956-06-12','F','U',NULL,'N','021','DEN','2590753','18575LA002000201','2014-03-01','2014-01-20 16:38:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:46:48'),(19102,15219,'Y','18','021','EC','A','','','AC','0001470459','0001470459','LA00002579709','IL','1','Murray','Brandi','C','','','34','437672380','3201 Kaliste Saloom Rd. Lot 304',0,'Lafayette','LA','70508',NULL,'CY','22055','1980-06-18','F','U',':RET:2054-5','N','021','DEN','2915823','18575LA002000201','2014-03-01','2014-01-18 17:37:05','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-21 08:44:39'),(16534,13226,'Y','18','021','EC','A','','','AC','0000450941','0000450941','MS00001309272','IL','1','Branch','Andrea','','','','34','385139519','534 West Hill Drive',0,'Jackson','MS','39209',NULL,'CY','28049','1992-01-15','F','U',':RET:2054-5','N','021','DEN','2133771','46300MS002000201','2014-02-01','2014-01-05 12:59:08','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2014-01-07 10:22:06'),(18039,14411,'Y','18','021','EC','A','','','AC','0000415983','0000415983','OH00001476487','IL','1','GRAY','CRYSTAL','A','','','34','291600883','1107 WOODVILLE RD',0,'TOLEDO','OH','43605',NULL,'CY','39095','1963-01-19','F','M',':RET:2106-3','T','021','HLT','2513326','92036OH003002606','2014-02-01','2014-01-14 17:15:38','651.00',NULL,NULL,'914.49','263.49','R-OH001','OH0','436.76',NULL,0,'2014-01-15 02:07:11'),(21068,16834,'Y','18','021','EC','A','','','AC','0000053091','0000053091','OH00002523200','IL','1','yaegel','joseph','','','','34','407196485','4283 BANTAM LN',0,'CINCINNATI','OH','45245','1406','CY','39025','1979-01-05','M','M',':RET:2106-3','N','021','DEN','3063048','99734OH005000401','2014-03-01','2014-02-01 20:31:36','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-02 19:00:15'),(21447,17142,'Y','18','021','EC','A','','','AC','0000469573','0000469573','OH00001709508','IL','1','Cross','Elayne','','','','34','288545079','321 SUZANNE DR',0,'KENT','OH','44240','1931','CY','39133','1965-07-20','F','M',NULL,'N','021','HLT','2878000','52664OH151001301','2014-03-01','2014-02-03 21:59:28','339.00',NULL,NULL,'982.35','643.35','R-OH012','OH0','364.62',NULL,0,'2014-02-04 21:01:27'),(7424,5875,'Y','18','021','EC','A','','','AC','0000764925','0000764925','OH00001071902','IL','1','Saviciunas','Ray','','','','34','279500518','3169 Pondview Dr.',0,'Ravenna','OH','44266',NULL,'CY','39133','1956-05-05','M','U',':RET:2106-3','N','021','HLT','596267','52664OH152000901','2014-01-01','2013-10-26 18:40:36','0.00',NULL,NULL,'398.06','398.06','R-OH012','OH0','398.06',NULL,0,'2013-12-26 02:17:07'),(3926,3142,'Y','18','021','EC','A','','','AC','0000360995','0000360995','OH00000047847','IL','1','Schmidt','Valerie','','','','34','281487272','750 ARBORRUN DR',0,'CINCINNATI','OH','45233','3500','CY','39061','1956-01-16','F','U',':RET:2106-3','N','021','HLT','1056127','92036OH005001204','2014-01-01','2013-12-12 19:51:45','217.00',NULL,NULL,'523.16','306.16','R-OH004','OH0','523.16',NULL,0,'2013-12-25 21:37:29'),(3936,3150,'Y','18','024','14','A','','','TE','0001020401','0001020401','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','597882','','2013-12-13','2013-12-13 09:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:37:47'),(22140,17671,'Y','18','021','EC','A','','','AC','0000413399','0000413399','OH00002209825','IL','1','barnett','wendy','','','','34','290742136','7824 peachmont ave nw',0,'north canton','OH','44720',NULL,'CY','39151','1963-08-31','F','U',':RET:2106-3','N','021','HLT','3629635','52664OH152000901','2014-03-01','2014-02-08 05:18:26','161.00',NULL,NULL,'291.73','130.73','R-OH015','OH0','291.73',NULL,0,'2014-02-08 19:00:48'),(24376,19362,'Y','18','021','EC','A','','','AC','0000578829','0000578829','OH00002468360','IL','1','Dietrick','David','','','','34','280481030','12510 Rd. Y',0,'New Bavaria','OH','43548',NULL,'CY','39069','1951-07-22','M','U',':RET:2106-3','N','021','HLT','3347353','92036OH005002604','2014-04-01','2014-02-18 07:05:35','395.00',NULL,NULL,'560.22','165.22','R-OH001','OH0','560.22',NULL,0,'2014-02-18 22:00:41'),(28427,22495,'Y','18','024','14','A','','','TE','0000108209','0000108209','','IL','1','RENTSCHLER','CINDY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-03-18','F','',NULL,NULL,NULL,'','2618926','','2014-03-07','2014-03-07 15:59:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:07'),(1062,870,'Y','18','021','EC','A','','','AC','0001144743','0001144743','OH00000186715','IL','1','RAYOUM','DAVID','','','','34','294464969','5464 FLEET RD',0,'TOLEDO','OH','43615','3520','CY','39095','1950-01-01','M','U',NULL,'N','021','HLT','1034464','92036OH003002605','2014-01-01','2013-12-03 16:47:37','479.00',NULL,NULL,'610.89','131.89','R-OH001','OH0','610.89',NULL,0,'2013-12-25 18:16:19'),(6412,5082,'Y','18','024','14','A','','','TE','0000073910','0000073910','','IL','1','Cole','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-22','M','',NULL,NULL,NULL,'','567406','','2013-12-11','2013-12-11 11:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:48:39'),(19902,15873,'N','19','021','EC','A',NULL,NULL,'','0000679562','0001152218','','S1','1','Sherman','Darris','Leroy','','','34','287022647','600 GLENWOOD RD',0,'ROSSFORD','OH','43460','1508','CY','39173','1997-05-31','M','',NULL,'N','021','HLT','2925974','92036OH002002601','2014-03-01','2014-01-23 20:08:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-01-24 21:00:56'),(4812,3814,'Y','18','021','EC','A','','','AC','0000584251','0000584251','OH00000146059','IL','1','Gundy','Hardwick','','','','34','269603112','129 FAIRFAX RD',0,'MARION','OH','43302','6458','CY','39101','1959-07-19','M','U',':RET:2054-5','T','021','DEN','1055973','99734OH005000301','2014-01-01','2013-12-08 15:04:02','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','0.00',NULL,0,'2013-12-25 22:16:49'),(4291,3413,'N','19','021','EC','A',NULL,NULL,'','0000869506','0000010053','','IL','1','Johnson','LaPortia','','','','34','428719531','237 Baker Lane',0,'Brandon','MS','39047',NULL,'CY','28121','1991-08-11','F','',':RET:2054-5','N','021','DEN','1474854','46300MS002000201','2014-01-01','2013-12-16 21:33:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:52:09'),(17091,13679,'Y','18','021','EC','A','','','AC','0000629484','0000629484','TX00002147135','IL','1','Williams','Randal','','','','34','455732942','809 ROSE ST',0,'ALBANY','TX','76430','4731','CY','48417','1974-10-30','M','U',':RET:2106-3','N','021','DEN','1942543','33348TX002000201','2014-02-01','2014-01-08 15:07:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:21:27'),(15224,12170,'Y','18','021','EC','A','','','AC','0002052877','0002052877','LA00001849825','IL','1','Hebert','Bennie','','','','34','434061287','10051 LEXINGTON DR',0,'DENHAM SPRINGS','LA','70706','8554','CY','22063','1959-09-30','M','M',':RET:2054-5','N','021','DEN','1982953','18575LA002000101','2014-02-01','2013-12-30 15:55:36','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-01-01 12:08:07'),(14262,11376,'Y','18','021','EC','A','','','AC','0001488428','0001488428','LA00001793254','31','1','BEACH','MICAH','','','','34','436477475','P.O BOX 61',0,'WISNER','LA','71378',NULL,'CY','22041','1981-08-17','M','U',':RET:2106-3','N','021','DEN','1851283','18575LA002000101','2014-02-01','2013-12-26 14:35:47','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-27 02:05:50'),(29012,22961,'N','19','021','EC','A',NULL,NULL,'','0000848418','0000639592','','S3','1','rickett','bruce','','','','34','680246751','132 KEYSTONE RD',0,'VINTON','OH','45686','9073','CY','39053','2000-07-13','M','',':RET:2106-3','N','021','DEN','4367183','99734OH005000401','2014-04-01','2014-03-09 19:53:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:24'),(85,74,'Y','18','021','EC','A','','','AC','0000915622','0000915622','OH00000325209','IL','1','Kukielski','David','Robert','','','34','506723887','835 SHOREHAM DR',0,'NEWARK','OH','43055','1513','CY','39089','1953-06-17','M','M',':RET:2106-3','N','021','DEN','196377','99734OH005000301','2014-01-01','2013-12-05 12:50:28','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:17:16'),(22123,17658,'N','19','021','EC','A',NULL,NULL,'','0000763556','0000317372','','IL','1','Weaver','Nola','','','','34','293151819','2745 DWIGHT RD',0,'SPRINGFIELD','OH','45503','5015','CY','39023','2010-03-06','F','',':RET:2106-3','N','021','HLT','3495535','92036OH004000501','2014-03-01','2014-02-08 15:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-02-08 19:00:40'),(181,150,'Y','18','021','EC','A','','','AC','0000453880','0000453880','OH00000063592','IL','1','McMahon','Katy','','','','34','284922787','2726 WILLIAMSBURG CIR',0,'STOW','OH','44224','5111','CY','39153','1990-05-22','F','U',':RET:2106-3','N','021','HLT','1238373','52664OH151001305','2014-01-01','2013-12-05 13:03:27','143.00',NULL,NULL,'223.01','80.01','R-OH012','OH0','223.01',NULL,0,'2013-12-25 17:19:41'),(13168,10504,'Y','18','021','EC','A','','','AC','0001014375','0001014375','OH00001248706','IL','1','Scheiner','David','','','','34','301740819','1143 SLEEPING MEADOW DR',0,'NEW ALBANY','OH','43054','9556','CY','39049','1969-07-22','M','U',':RET:2106-3','N','021','DEN','1373196','99734OH005000401','2014-01-01','2013-12-23 18:28:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:54:00'),(619,510,'Y','18','021','EC','A','','','AC','0000217573','0000217573','OH00000842530','IL','1','Francis','Karen','','','','34','291525890','23 MERRY ROBIN RD',0,'TROY','OH','45373','1522','CY','39109','1952-08-05','F','R',':RET:2106-3','N','021','DEN','2063886','99734OH005000401','2014-01-01','2013-12-16 11:27:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:00:47'),(13070,10418,'Y','18','021','EC','A','','','AC','0000847152','0000847152','OH00000392430','IL','1','Wynn','Yinitrus','','','','34','287525997','2145 N TAYLOR RD',0,'CLEVELAND HTS','OH','44112','3001','CY','39035','1953-12-28','F','R',':RET:2054-5','N','021','DEN','2017484','99734OH005000401','2014-01-01','2013-12-23 10:11:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:17'),(7692,6091,'Y','18','021','EC','A','','','AC','0000961857','0000961857','OH00000737090','IL','1','Fleischer','David','','','','34','133489787','2320 SAYBROOK RD',0,'UNIVERSITY HEIGHTS','OH','44118','3708','CY','39035','1954-10-14','M','M',':RET:2106-3','N','021','DEN','1477603','99734OH005000401','2014-01-01','2013-12-19 21:27:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:04'),(23359,18613,'Y','18','021','EC','A','','','AC','0001146013','0001146013','OH00001568344','IL','1','Maroun','George','','','','34','294883999','83 TRUNKO RD',0,'FAIRLAWN','OH','44333','3403','CY','39153','1963-04-23','M','M',NULL,'N','021','HLT','3205619','52664OH151001306','2014-03-01','2014-02-13 15:01:12','629.00',NULL,NULL,'746.85','117.85','R-OH012','OH0','398.29',NULL,0,'2014-02-13 22:00:45'),(27503,21759,'Y','18','021','EC','A','','','AC','0001243027','0001243027','OH00002596902','IL','1','Horsey','Cindy','','','','34','276664223','502 tiedeman ave',0,'Defiance','OH','43512',NULL,'CY','39039','1957-12-26','F','U',NULL,'N','021','HLT','3897451','92036OH004002601','2014-04-01','2014-03-04 14:25:12','295.00',NULL,NULL,'365.79','70.79','R-OH001','OH0','365.79',NULL,0,'2014-03-04 21:02:29'),(28113,22250,'Y','18','021','EC','A','','','AC','0000795592','0000795592','OH00003060108','31','1','Fisher','Stacie','','','','34','295866543','4816 Whyem Dr',0,'Akron','OH','44319',NULL,'CY','39153','1987-08-05','F','U',':RET:2106-3','N','021','HLT','3088134','52664OH152000901','2014-04-01','2014-03-06 16:17:18','0.00',NULL,NULL,'167.26','167.26','R-OH012','OH0','167.26',NULL,0,'2014-03-06 21:02:16'),(28722,22731,'Y','18','021','EC','A','','','AC','0000150711','0000150711','OH00003645260','IL','1','Pepin','Melanie','','','','34','366783957','130 MONROE AVE',0,'FINDLAY','OH','45840','3734','CY','39063','1968-03-12','F','U',':RET:2106-3','T','021','HLT','3706134','92036OH003001501','2014-04-01','2014-03-08 15:42:46','0.00',NULL,NULL,'396.46','396.46','R-OH002','OH0','396.46',NULL,0,'2014-03-08 21:31:21'),(19434,15492,'N','01','021','EC','A',NULL,NULL,'','0000376165','0001204563','','IL','1','Rodarmel','Nicholas','','','','34','624489008','2375 DORR ST',0,'TOLEDO','OH','43607','3407','CY','39095','1991-06-17','M','',NULL,'N','021','HLT','2207733','92036OH003002605','2014-03-01','2014-01-21 12:56:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,1,'2014-01-22 03:23:09'),(17787,14209,'Y','18','021','EC','A','','','AC','0000022814','0000022814','OH00001415732','IL','1','MERKLE','JAY','J','','','34','282485788','3140 WOODLEY RD',0,'TOLEDO','OH','43606','1256','CY','39095','1965-10-05','M','U',':RET:2106-3','N','021','HLT','2339187','92036OH005002604','2014-02-01','2014-01-13 14:37:16','179.00',NULL,NULL,'318.82','139.82','R-OH001','OH0','318.82',NULL,0,'2014-01-14 01:33:45'),(14853,11859,'N','01','021','EC','A',NULL,NULL,'','0000181010','0000008419','','IL','1','Leising','Linda','','','','34','283660765','13673 Cinnamon Lane Ave NW',0,'Mogadore','OH','44260',NULL,'CY','39151','1971-09-04','F','',NULL,'N','021','HLT','2294928','52664OH151001304','2014-01-01','2013-12-23 19:37:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,1,'2013-12-29 11:15:08'),(25626,20332,'Y','18','021','EC','A','','','AC','0000685891','0000685891','OH00002871001','IL','1','Tucker','Christopher','','','','34','284883934','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','1974-04-10','M','M',':RET:2106-3','N','021','DEN','3742050','99734OH005000301','2014-04-01','2014-02-21 19:35:28','20.79',NULL,NULL,'87.78','66.99','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:30:21'),(26182,20763,'Y','18','021','EC','A','','','AC','0000521021','0000521021','OH00003204744','IL','1','Fowler','Michael','','','','34','293865267','7854 FAIRFAX LOOP DR',0,'BLACKLICK','OH','43004','9112','CY','39049','1978-06-29','M','U',':RET:2106-3','N','021','DEN','3804974','99734OH005000301','2014-04-01','2014-02-26 21:54:06','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:41'),(20577,16445,'Y','18','021','EC','A','','','AC','0000609559','0000609559','OH00002508390','IL','1','Shannawi','Sameer','','','','34','603581086','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1966-04-29','M','M',':RET:2106-3','N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2014-01-30 21:00:03'),(3365,2696,'N','01','021','EC','A',NULL,NULL,'','0000211896','0000898573','','IL','1','Nation','Tiffany','Kaye','','','34','643209872','3420 s coulter',0,'Amarillo','TX','79109',NULL,'CY','48381','1988-08-10','F','',':RET:2106-3','N','021','DEN','2414982','33348TX002000201','2014-01-01','2013-12-22 14:01:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:17:05'),(7138,5664,'N','19','021','EC','A',NULL,NULL,'','0000083660','0000500739','','IL','1','Cage','Jaylyn','','','','34','637686049','10907 RADFORD LN',0,'HOUSTON','TX','77099','4724','CY','48201','1999-10-19','F','',':RET:2054-5','N','021','DEN','1586864','33348TX002000101','2014-01-01','2013-12-24 19:50:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2013-12-26 01:51:50'),(3482,2795,'Y','18','021','EC','A','','','AC','0000429034','0000429034','OH00000309979','IL','1','Rivers','Teresa','','','','34','367601756','118 MONROE ST',0,'MIDDLETOWN','OH','45042','3213','CY','39017','1953-04-13','F','U',':RET:2106-3','T','021','DEN','1451644','99734OH005000401','2014-01-01','2013-12-22 11:08:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:20:12'),(6386,5064,'Y','18','021','EC','A','','','AC','0000976691','0000976691','OH00000006154','IL','1','Motto','Irene','','','','34','282529162','4655 LINDA LN',0,'SHEFFIELD VILLAGE','OH','44054','2725','CY','39093','1952-10-21','F','M',':RET:2106-3','N','021','DEN','898723','99734OH005000301','2014-01-01','2013-12-11 11:11:05','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:48:03'),(8005,6335,'Y','18','024','14','A','','','TE','0001001473','0001001473','','IL','1','Decker','Elsa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-01-11','F','',NULL,NULL,NULL,'','2463123','','2013-12-19','2013-12-19 23:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:08:29'),(19234,15326,'Y','18','021','EC','A','','','AC','0001178203','0001178203','OH00002100547','IL','1','Pittman','Kathryn','','','','34','273542139','431 SNIVELY AVE NW',0,'MASSILLON','OH','44646','3571','CY','39151','1952-08-02','F','M',':RET:2106-3','N','021','DEN','2660471','99734OH005000301','2014-03-01','2014-01-20 12:59:51','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-21 08:46:34'),(14454,11531,'Y','18','021','EC','A','','','AC','0001158839','0001158839','LA00001237395','IL','1','Domingo','Elden','','','','34','439358460','105 BARON DR',0,'LAFAYETTE','LA','70501','4043','CY','22055','1964-10-25','M','U',':RET:2106-3','N','021','DEN','2192244','18575LA002000201','2014-02-01','2013-12-27 14:08:17','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-28 03:32:34'),(14687,11726,'Y','18','024','14','A','','','TE','0001018221','0001018221','','IL','1','Rammel','Jared',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-01-14','M','',NULL,NULL,NULL,'','1471240','','2013-12-28','2013-12-28 12:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:08:43'),(22727,18146,'N','01','021','EC','A',NULL,NULL,'','0001970837','0001567517','','IL','1','Berroa','Body','','','','34','599100899','1526 London Cross Rd',0,'Harvey','LA','70058',NULL,'CY','22051','1962-04-02','M','',NULL,'N','021','DEN','3214343','18575LA002000201','2014-03-01','2014-02-11 13:54:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:13'),(26080,20682,'Y','18','021','EC','A','','','AC','0001849695','0001849695','LA00003095271','IL','1','Garner','Eartha','','','','34','439117670','1420 EARL ST',0,'SHREVEPORT','LA','71108','3116','CY','22017','1956-09-14','F','U',NULL,'N','021','DEN','3320975','18575LA002000201','2014-04-01','2014-02-26 18:32:07','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-28 06:30:04'),(29068,23005,'Y','18','021','EC','A','','','AC','0000237654','0000237654','OH00003706974','IL','1','KLEMAN','MELVIN','','','','34','292629670','13925 ORIS AVE',0,'DEFIANCE','OH','43512','8749','CY','39039','1957-04-14','M','U',NULL,'T','021','HLT','4331438','92036OH004002601','2014-04-01','2014-03-10 12:17:21','0.00',NULL,NULL,'420.66','420.66','R-OH001','OH0','420.66',NULL,0,'2014-03-10 21:01:55'),(2494,2032,'Y','18','021','EC','A','','','AC','0000872294','0000872294','LA00001302264','IL','1','BROWN','DEREK','','','','34','425291754','103 COUNTRY LANE',0,'LAFAYETTE','LA','70508',NULL,'CY','22055','1963-08-31','M','U',NULL,'N','021','DEN','1205773','18575LA002000201','2014-01-01','2013-12-09 16:35:14','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:35:52'),(2730,2208,'Y','18','021','EC','A','','','AC','0000985502','0000985502','LA00000795012','IL','1','fazande','dwayne','','','','34','512882053','963 Ave. B',0,'Westwego','LA','70094',NULL,'CY','22051','1984-07-26','M','M',':RET:2054-5','N','021','DEN','850014','18575LA002000201','2014-01-01','2013-12-02 18:07:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:27'),(3685,2950,'Y','18','021','EC','A','','','AC','0000612978','0000612978','OH00000762127','IL','1','shepherd','Linda','','','','34','406257575','7463 BRIDGE POINT PASS',0,'CINCINNATI','OH','45248','1917','CY','39061','1982-04-02','F','M',':RET:2106-3','N','021','DEN','873632','99734OH005000401','2014-01-01','2013-12-13 10:12:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:34'),(20877,16685,'Y','18','021','EC','A','','','AC','0001894155','0001894155','LA00002075199','IL','1','GRAVES','ANGELA','','','','34','438152611','603 S 12TH ST',0,'MONROE','LA','71202','2341','CY','22073','1964-08-16','F','U',NULL,'N','021','DEN','2920680','18575LA002000101','2014-03-01','2014-01-31 17:21:06','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-31 21:01:06'),(4082,3262,'N','19','021','EC','A',NULL,NULL,'','0000656919','0001205808','','IL','1','CHESMAR','LINDSEY','MARIE','','','34','285984986','5759 CANTERBURY RD',0,'AKRON','OH','44319','5101','CY','39153','1995-08-25','F','',':RET:2106-3','N','021','HLT','1756079','52664OH152000901','2014-01-01','2013-12-17 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:47:13'),(5556,4410,'Y','18','021','EC','A','','','AC','0000398582','0000398582','OH00000273556','IL','1','Triola','Carl','John','','Jr','34','294564485','697 N MAIN ST',0,'AKRON','OH','44310','3016','CY','39153','1964-04-06','M','U',':RET:2106-3','N','021','HLT','760861','52664OH151001501','2014-01-01','2013-11-27 17:38:55','324.00',NULL,NULL,'456.30','132.30','R-OH012','OH0','456.30',NULL,0,'2013-12-25 23:16:17'),(7992,6325,'N','19','021','EC','A',NULL,NULL,'','0000563130','0000296782','','IL','1','Hockstra','Lillian','','','','34','277132608','3170 BENT OAK TRL',0,'RAVENNA','OH','44266','8285','CY','39133','2006-03-14','F','',NULL,'N','021','HLT','2591260','52664OH151001304','2014-01-01','2013-12-20 15:06:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 03:08:11'),(18046,14417,'Y','18','021','EC','A','','','AC','0000227781','0000227781','MS00002411192','IL','1','Gibson','Betty','','','','34','587088048','811 Forest Ave',0,'Jackson','MS','39206',NULL,'CY','28049','1961-05-31','F','U',':RET:2054-5','T','021','DEN','2067499','46300MS002000101','2014-02-01','2014-01-13 23:33:07','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-15 02:07:14'),(8971,7116,'N','19','021','EC','A',NULL,NULL,'','0000370007','0000793456','','S1','1','Ward','Benjamin','','','','34','292119306','2525 BRENDEL DR',0,'COLUMBUS','OH','43235','8004','CY','39049','2006-02-07','M','',NULL,'N','021','DEN','2186646','99734OH005000401','2014-01-01','2013-12-18 15:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:04:06'),(17755,14187,'Y','18','021','EC','A','','','AC','0000319049','0000319049','MS00001859827','IL','1','Spann','Claire','','','','34','267874344','103 Joe Myers Rd.',0,'Brandon','MS','39047',NULL,'CY','28121','1969-08-25','F','M',':RET:2106-3','N','021','DEN','1729595','46300MS002000101','2014-02-01','2014-01-13 14:58:25','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-14 01:33:30'),(17514,14001,'Y','18','021','EC','A','','','AC','0000721360','0000721360','OH00002296248','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','N','021','DEN','1522304','99734OH005000401','2014-02-01','2014-01-12 09:33:23','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:32'),(25101,19909,'Y','18','021','EC','A','','','AC','0001156225','0001156225','TX00002912807','31','1','Cobos','Santiago','','','','34','450270185','PO Box 141',0,'GOLDSMITH','TX','79741',NULL,'CY','48135','1964-09-01','M','U',NULL,'N','021','DEN','3581631','33348TX002000101','2014-04-01','2014-02-21 16:19:16','0.00',NULL,NULL,'25.02','25.02','R-TX017','TX0','25.02','CIC',0,'2014-02-21 21:30:10'),(26338,20897,'Y','18','021','EC','A','','','AC','0000904319','0000904319','OH00002765168','IL','1','Klucas','David','','','','34','286461137','5331 EDGEWATER DR',0,'TOLEDO','OH','43611','2640','CY','39095','1962-09-07','M','M',NULL,'T','021','HLT','2868388','92036OH006002601','2014-04-01','2014-02-27 13:55:50','617.00',NULL,NULL,'844.77','227.77','R-OH001','OH0','331.68',NULL,0,'2014-02-28 06:31:43'),(14590,11645,'Y','18','024','14','A','','','TE','0000154649','0000154649','','IL','1','Whitis','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-14','F','',NULL,NULL,NULL,'','1962986','','2013-12-27','2013-12-27 10:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:07'),(2443,1990,'Y','18','021','EC','A','','','AC','0000731169','0000731169','OH00000676060','IL','1','Ostervich','Bonnie','','','','34','278520996','3552 Elmhurst Circle',0,'Uniontown','OH','44685','6714','CY','39153','1952-11-08','F','M',':RET:2106-3','N','021','HLT','677074','52664OH151001301','2014-01-01','2013-12-09 17:15:18','167.00',NULL,NULL,'626.65','459.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 19:34:29'),(23679,18855,'Y','18','021','EC','A','','','AC','0001314149','0001314149','LA00002186327','IL','1','Brown','Myrthe','','','','34','433597033','8370 S Saint Landry Rd',0,'Gonzales','LA','70737',NULL,'CY','22005','1974-02-05','F','U',':RET:2054-5','N','021','DEN','3317786','18575LA002000201','2014-03-01','2014-02-14 06:08:35','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-14 21:30:29'),(26087,20688,'Y','18','021','EC','A','','','AC','0001390920','0001390920','LA00003175568','IL','1','Spanne','Matthew','','','','34','550897991','930 Poydras St',0,'New Orleans','LA','70112',NULL,'CY','22071','1986-02-12','M','U',':RET:2106-3','N','021','DEN','3647877','18575LA002000201','2014-04-01','2014-02-26 22:56:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:06'),(26283,20848,'Y','18','021','EC','A','','','AC','0001643598','0001643598','LA00003245928','IL','1','Matlock','Jennifer','','','','34','433753563','1006 S. Kenilworth Pkwy',0,'Baton Rouge','LA','70820',NULL,'CY','22033','1987-02-10','F','U',':RET:2106-3','N','021','DEN','3143577','18575LA002000101','2014-03-01','2014-02-27 10:52:23','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-28 06:31:21'),(28955,22916,'Y','18','021','EC','A','','','AC','0001784088','0001784088','LA00003568754','IL','1','phillips','stephen','michael','','','34','437659425','824 oakwood dr.',0,'terrytown','LA','70056',NULL,'CY','22051','1983-08-17','M','U',':RET:2106-3','N','021','DEN','4329031','18575LA002000201','2014-04-01','2014-03-10 11:21:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:52'),(1360,1126,'Y','18','021','EC','A','','','AC','0000739999','0000739999','TX00000324623','IL','1','murphy','susan','','','','34','456230597','400 rolling oaks drive',0,'giddings','TX','78942',NULL,'CY','48287','1961-11-05','F','M',':RET:2106-3','N','021','DEN','1632376','33348TX002000101','2014-01-01','2013-12-24 13:58:55','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:45:28'),(22913,18264,'Y','18','021','EC','A','','','AC','0000870668','0000870668','OH00001972879','IL','1','Richards','Kathryn','','','','34','383524176','3476 W 136TH ST',0,'CLEVELAND','OH','44111','2424','CY','39035','1949-05-03','F','U',':RET:2106-3','N','021','HLT','3804571','92036OH004000801','2014-03-01','2014-02-11 14:56:28','525.00',NULL,NULL,'563.97','38.97','R-OH011','OH0','563.97',NULL,0,'2014-02-11 21:02:49'),(22559,18016,'Y','18','021','EC','A','','','AC','0000346933','0000346933','OH00001813021','IL','1','EVENSON','TAYLOR','R','','','34','282909823','2310 BRISTOL RD',0,'COLUMBUS','OH','43221','1206','CY','39049','1982-06-26','M','R',':RET:2106-3','N','021','DEN','3088569','99734OH005000401','2014-03-01','2014-02-10 12:02:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-10 21:31:50'),(20991,16774,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000173845','','IL','1','Al-Shinnawi','Ibrahim','S','','','34','296949376','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1992-03-31','M','',':RET:2106-3','N','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:25'),(5458,4336,'Y','18','021','EC','A','','','AC','0000159404','0000159404','OH00000711140','IL','1','Sengstock','Loren','C','','','34','283561603','2704 Arbor Glen Drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1953-08-02','M','M',':RET:2106-3','N','021','HLT','2448398','52664OH151001501','2014-01-01','2013-12-19 15:29:55','626.00',NULL,NULL,'1349.90','723.90','R-OH012','OH0','725.90',NULL,0,'2013-12-25 23:10:20'),(19363,15434,'Y','18','021','EC','A','','','AC','0000309469','0000309469','OH00002058648','IL','1','Johnson','Zenobia','','','','34','278687422','697 Moreley Avenue',0,'Akron','OH','44320',NULL,'CY','39153','1961-10-20','F','U',':RET:2054-5','N','021','HLT','3045416','52664OH151001305','2014-03-01','2014-01-21 11:31:59','295.00',NULL,NULL,'435.31','140.31','R-OH012','OH0','435.31',NULL,1,'2014-01-22 03:22:32'),(24060,19133,'Y','18','021','EC','A','','','AC','0001227074','0001227074','OH00002453075','IL','1','Cherry','Debbie','','','','34','286500568','700 Kentucky Ave',0,'Fremont','OH','43420',NULL,'CY','39143','1951-02-02','F','U',NULL,'N','021','DEN','3516591','99734OH005000301','2014-03-01','2014-02-14 20:56:50','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-15 22:01:08'),(27889,22062,'Y','18','021','EC','A','','','AC','0000373687','0000373687','OH00003363966','IL','1','MCKAY','FRANCES','','','','34','279520797','37 MARSHALL ST',0,'NORWALK','OH','44857','1722','CY','39077','1951-05-14','F','U',':RET:2106-3','N','021','HLT','2887880','92036OH006002701','2014-04-01','2014-03-05 12:55:18','441.04',NULL,NULL,'444.29','3.25','R-OH006','OH0','444.29',NULL,0,'2014-03-05 21:32:38'),(27957,22117,'Y','18','021','EC','A','','','AC','0002023014','0002023014','LA00002931294','IL','1','JOSEPH','NAKEITRIA','TWAN','','','34','438198177','2598 LIONEL WASHINGTON ST',0,'LUTCHER','LA','70071','5344','CY','22093','1973-06-09','F','U',':RET:2054-5','N','021','DEN','3169562','18575LA002000201','2014-04-01','2014-03-05 18:21:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:42'),(913,758,'Y','18','021','EC','A','','','AC','0000794478','0000794478','OH00000030088','IL','1','Russo','Philip','A','','','34','282489224','4133 ROSE GARDEN DR',0,'TOLEDO','OH','43623','3417','CY','39095','1952-10-15','M','U',':RET:2106-3','N','021','HLT','1913995','92036OH004002601','2014-01-01','2013-12-16 17:42:57','437.38',NULL,NULL,'440.60','3.22','R-OH001','OH0','440.60',NULL,0,'2013-12-25 18:08:36'),(20438,16325,'Y','18','021','EC','A','','','AC','0000683397','0000683397','OH00001981772','IL','1','JONES','VANESSA','','','','34','290705633','313 JEFFERSON AVE',0,'SAINT BERNARD','OH','45217','1710','CY','39061','1971-06-24','F','U',':RET:2054-5','T','021','DEN','2318858','99734OH005000301','2014-03-01','2014-01-29 17:21:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:39'),(2136,1754,'Y','18','021','EC','A','','','AC','0000309414','0000309414','OH00001015919','IL','1','Fletcher','Roy',NULL,NULL,NULL,NULL,NULL,'5021 BUFFALO RUN',0,'WESTERVILLE','OH','43081','6705','CY','39049','1955-06-29','M','R',':RET:2106-3','N','021','DEN','742046','99734OH005000401','2014-01-01','2013-12-10 16:55:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:18:06'),(16943,13561,'Y','18','021','EC','A','','','AC','0001633557','0001633557','LA00002103456','IL','1','russo','matthew','john','','III','34','437883284','3825 HIGHWAY 308',0,'RACELAND','LA','70394','2946','CY','22057','1954-08-05','M','M',':RET:2106-3','N','021','DEN','1385078','18575LA002000201','2014-02-01','2014-01-09 13:55:24','0.00',NULL,NULL,'29.22','29.22','R-LA002','LA0','14.61',NULL,0,'2014-01-13 02:19:55'),(6060,4801,'Y','18','024','14','A','','','TE','0000235175','0000235175','','IL','1','Lawhon','Vickie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-12-31','F','',NULL,NULL,NULL,'','299224','','2013-12-01','2013-12-01 09:35:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:01:55'),(2675,2168,'N','19','021','EC','A',NULL,NULL,'','0000280804','0000092472','','IL','1','thomson','joseph','','','Jr','34','278049036','1700 WOODWARD AVE',0,'SPRINGFIELD','OH','45506','3147','CY','39023','1999-04-16','M','',':RET:2106-3','N','021','DEN','697055','99734OH005000301','2014-01-01','2013-12-02 15:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:06'),(16219,12989,'Y','18','021','EC','A','','','AC','0000254546','0000254546','OH00001481772','IL','1','Burnette','Timothy','','','','34','298604445','605 COLEBERRY CT',0,'CLEVES','OH','45002','1391','CY','39061','1960-07-05','M','U',':RET:2106-3','N','021','DEN','1697510','99734OH005000401','2014-02-01','2014-01-03 20:44:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-05 00:01:45');
INSERT INTO `EdiParticipant` VALUES (24381,19366,'Y','18','021','EC','A','','','AC','0000149394','0000149394','OH00001606714','IL','1','Eichert','Jean','Karen','','','34','181388911','7104 BLUECREST DR',0,'CINCINNATI','OH','45230','2203','CY','39061','1951-10-04','F','U',':RET:2106-3','N','021','DEN','3365549','99734OH005000401','2014-04-01','2014-02-18 10:12:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:44'),(22498,17960,'N','19','021','EC','A',NULL,NULL,'','0000665687','0000516951','','S3','1','VU','THANH','','','','34','895363268','7230 HOSBROOK RD',0,'CINCINNATI','OH','45243','1710','CY','39061','2013-08-20','M','',NULL,'N','021','DEN','2684479','99734OH005000301','2014-03-01','2014-02-10 14:31:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:11'),(6376,5056,'Y','18','021','EC','A','','','AC','0000529416','0000529416','OH00000691017','IL','1','BAILOSKY','KEVIN','','','','34','283862692','2811 Greenville Lane',0,'Fairlawn','OH','44333',NULL,'CY','39153','1983-06-21','M','U',':RET:2106-3','N','021','DEN','968199','99734OH005000301','2014-01-01','2013-12-11 09:36:29','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:48'),(21485,17168,'Y','18','021','EC','A','','','AC','0000655860','0000655860','OH00001924936','IL','1','Young','Jami','','','','34','279820266','6031 CARPENTER RD',0,'DEFIANCE','OH','43512','8292','CY','39039','1979-02-07','F','U',':RET:2106-3','N','021','DEN','3251855','99734OH005000301','2014-03-01','2014-02-04 17:52:30','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-04 21:01:45'),(7792,6170,'Y','18','021','EC','A','','','AC','0000320388','0000320388','TX00001167596','IL','1','COCKRELL','LISA','','','','34','548314137','1004 E 8TH ST',0,'COLORADO CITY','TX','79512','5358','CY','48335','1958-02-19','F','U',':RET:2106-3','N','021','DEN','1971656','33348TX002000201','2014-01-01','2013-12-20 15:18:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:26'),(5645,4478,'Y','18','021','EC','A','','','AC','0000432962','0000432962','TX00000604471','IL','1','rawls','alan','','','','34','456572161','709 s. broadway',0,'tyler','TX','75701',NULL,'CY','48423','1968-02-20','M','U',':RET:2106-3','T','021','DEN','853723','33348TX002000201','2014-01-01','2013-11-26 11:35:53','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 23:31:20'),(3921,3139,'Y','18','021','EC','A','','','AC','0000026602','0000026602','OH00000193613','IL','1','Ritter','Donald','','','','34','285442430','1819 Crystal Avenue',0,'Findlay','OH','45840',NULL,'CY','39063','1949-10-04','M','U',':RET:2106-3','N','021','HLT','256227','92036OH005001506','2014-01-01','2013-12-13 14:07:16','655.41',NULL,NULL,'660.24','4.83','R-OH002','OH0','660.24',NULL,0,'2013-12-25 21:37:23'),(8851,7017,'Y','18','021','EC','A','','','AC','0000049304','0000049304','TX00000470775','IL','1','FLOWERS','BELINDA','ANN','','','34','254846944','221 MOSSY TREE GLEN',0,'HOLLY LAKE RANCH','TX','75765',NULL,'CY','48499','1952-01-02','F','U',':RET:2106-3','T','021','DEN','1583979','33348TX002000201','2014-01-01','2013-12-18 10:05:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:01'),(9014,7153,'Y','18','021','EC','A','','','AC','0000296774','0000296774','OH00000879420','IL','1','Garling','Gordon','','','','34','268600130','1729 st rt 511',0,'Ashland','OH','44805',NULL,'CY','39005','1956-07-14','M','M',':RET:2106-3','T','021','HLT','1636978','52664OH151001301','2014-01-01','2013-12-17 18:45:34','650.00',NULL,NULL,'1193.21','543.21','R-OH012','OH0','624.99',NULL,0,'2013-12-26 04:05:10'),(14136,11268,'Y','18','021','EC','A','','','AC','0001262195','0001262195','LA00000238580','IL','1','irvin','lance','','','','34','434694347','515 HERITAGE AVE',0,'TERRYTOWN','LA','70056','4045','CY','22051','1979-08-06','M','M',':RET:2054-5','N','021','DEN','1780422','18575LA002000201','2014-02-01','2013-12-26 11:44:25','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:31'),(17817,14232,'Y','18','021','EC','A','','','AC','0000825819','0000825819','MS00002296294','IL','1','mccarty','derida','','','','34','425083292','1615 thorton ave',0,'gulf port','MS','39501',NULL,'CY','28047','1963-02-07','F','U',':RET:2054-5','T','021','DEN','1979800','46300MS002000201','2014-02-01','2014-01-13 19:43:45','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-15 02:05:54'),(23965,19054,'Y','18','021','EC','A','','','AC','0001232037','0001232037','TX00001865783','IL','1','Ahmed','Tahir','','','','34','344765108','8426 SEA ASH CIR',0,'ROUND ROCK','TX','78681','3410','CY','48491','1953-02-18','M','M',NULL,'N','021','DEN','3639652','33348TX002000101','2014-03-01','2014-02-15 13:47:40','0.00',NULL,NULL,'54.30','54.30','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:10'),(24713,19622,'Y','18','021','EC','A','','','AC','0000584317','0000584317','OH00002870921','IL','1','promen','stephen','','','','34','268569160','5415 dunmere ln',0,'dublin','OH','43017',NULL,'CY','39049','1954-09-14','M','U',':RET:2106-3','T','021','DEN','3151518','99734OH005000401','2014-04-01','2014-02-19 00:03:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:36:08'),(24894,19737,'Y','18','021','EC','A','','','AC','0000288338','0000288338','OH00002589902','IL','1','FERRELL','DENISE','','','','34','301468210','2420 15TH ST',0,'CUYAHOGA FALLS','OH','44223','2040','CY','39153','1952-07-07','F','U',':RET:2106-3','N','021','HLT','2718360','52664OH151001305','2014-04-01','2014-02-19 13:57:40','470.00',NULL,NULL,'626.65','156.65','R-OH012','OH0','626.65','CIC',0,'2014-02-20 05:39:40'),(28898,22873,'Y','18','021','EC','A','','','AC','0000871859','0000871859','TX00002601732','IL','1','NASER','HAYDER','','','','34','681204100','12250 ABRAMS RD',0,'DALLAS','TX','75243',NULL,'CY','48113','1979-10-06','M','U',NULL,'N','021','DEN','3808999','33348TX002000201','2014-04-01','2014-03-10 16:18:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-10 21:00:19'),(20306,16209,'N','01','021','EC','A',NULL,NULL,'','0000248181','0000901183','','IL','1','Black','Brenda','Kay','','','34','454470373','415 Sunset St',0,'Blossom','TX','75416',NULL,'CY','48277','1974-12-30','F','',':RET:2106-3','N','021','DEN','2895530','33348TX002000201','2014-03-01','2014-01-28 10:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-28 21:00:46'),(14043,11188,'Y','18','021','EC','A','','','AC','0000690744','0000690744','OH00000172288','IL','1','Corfield','Christine','','','','34','194522380','8267 GRADINGTON DR',0,'WESTERVILLE','OH','43081','8948','CY','39049','1957-03-07','F','M',':RET:2106-3','N','021','DEN','2341608','99734OH005000301','2014-02-01','2013-12-25 19:56:01','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:05'),(1693,1413,'N','19','021','EC','A',NULL,NULL,'','0000096402','0000062537','','IL','1','Lin','Ruth','','','','34','314253139','26693 Amberwood Dr.',0,'Perrysburg','OH','43551',NULL,'CY','39173','2002-08-24','F','',':RET:2034-7','N','021','HLT','2565943','92036OH004002601','2014-01-01','2013-12-24 07:13:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-25 18:54:30'),(5719,4540,'Y','18','021','EC','A','','','AC','0002312700','0002312700','LA00000601641','31','1','Shelby','Conrad','Penman','','','34','403944431','6221 S. Claiborne Ave.',0,'New Orleans','LA','70125',NULL,'CY','22071','1971-11-22','M','U',':RET:2106-3','N','021','DEN','1943319','18575LA002000201','2014-01-01','2013-12-23 21:28:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:21'),(23721,18887,'Y','18','021','EC','A','','','AC','0000405442','0000405442','TX00001734579','IL','1','Matthews','Anetra','','','','34','435512765','13842 Salmon Dr',0,'Frisco','TX','75035',NULL,'CY','48085','1983-06-12','F','U',':RET:2054-5','N','021','DEN','3432714','33348TX002000101','2014-03-01','2014-02-13 18:31:52','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-14 21:30:53'),(25072,19884,'Y','18','021','EC','A','','','AC','0000290854','0000290854','OH00003144042','IL','1','MCDUNNELL','CHERYL','','','','34','253339058','204 W SUGAR ST',0,'CRIDERSVILLE','OH','45806','2346','CY','39011','1963-04-23','F','M',NULL,'N','021','HLT','3320838','92036OH005001506','2014-04-01','2014-02-20 10:59:43','813.00',NULL,NULL,'876.82','63.82','R-OH002','OH0','393.06',NULL,0,'2014-02-20 22:01:31'),(26843,21275,'Y','18','021','EC','A','','','AC','0001809850','0001809850','LA00002664518','IL','1','Sims','Victor','','','','34','434780636','2625 S BIRCHFIELD DR',0,'HARVEY','LA','70058','2014','CY','22051','1952-10-07','M','M',':RET:2054-5','N','021','DEN','3645119','18575LA002000201','2014-04-01','2014-03-01 09:43:53','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-01 21:00:46'),(28046,22192,'N','01','021','EC','A',NULL,NULL,'','0000366840','0000417192','','IL','1','Stepteau','Lesley','T','','','34','428674671','157B N WIND RIDGE LN',0,'PURVIS','MS','39475','5839','CY','28073','1985-01-27','F','',':RET:2054-5','N','021','DEN','3734913','46300MS002000201','2014-04-01','2014-03-05 18:43:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-03-06 21:01:34'),(23602,18801,'Y','18','024','14','A','','','TE','0000267571','0000267571','','IL','1','harlan','deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-15','F','',NULL,NULL,NULL,'','2993721','','2014-02-13','2014-02-13 15:51:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:03:08'),(2476,2016,'Y','18','021','EC','A','','','AC','0000067923','0000067923','LA00000286179','IL','1','Thompson','Arthelma','','','','34','433821560','21879 LIGON RD',0,'ZACHARY','LA','70791','6916','CY','22033','1949-03-10','F','M',':RET:2054-5','N','021','DEN','950521','18575LA002000201','2014-01-01','2013-12-09 13:19:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:23'),(23085,18405,'Y','18','021','EC','A','','','AC','0000632726','0000632726','OH00002583798','IL','1','Stahl','John','','','','34','295807297','3151 Hwy 123',0,'Blanchester','OH','45107',NULL,'CY','39015','1978-11-17','M','M',NULL,'N','021','DEN','2821595','99734OH005000401','2014-03-01','2014-02-12 11:27:43','0.00',NULL,NULL,'50.05','50.05','R-OH005','OH0','0.00',NULL,0,'2014-02-12 21:31:05'),(3415,2741,'N','01','021','EC','A',NULL,NULL,'','0001326483','0001853919','','IL','1','McGee','Shirlene','','','','34','433042498','1212 LAKE LOUISE DR',0,'GRETNA','LA','70056','8341','CY','22051','1957-04-03','F','',':RET:2054-5','N','021','DEN','2141109','18575LA002000201','2014-01-01','2013-12-22 16:12:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 21:18:29'),(13128,10470,'Y','18','024','14','A','','','TE','0000155774','0000155774','','IL','1','hiser','timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-11-24','M','',NULL,NULL,NULL,'','1849804','','2013-12-23','2013-12-23 14:25:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:52:57'),(14093,11231,'Y','18','021','EC','A','','','AC','0000751021','0000751021','OH00001512255','IL','1','LEA','JACKIE','D','','','34','292647980','718 TRENTON AVE',0,'CINCINNATI','OH','45205','2045','CY','39061','1960-07-09','M','M',':RET:2106-3','N','021','DEN','2204407','99734OH005000401','2014-02-01','2013-12-26 11:15:45','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:01:24'),(14114,11248,'Y','18','021','EC','A','','','AC','0000025296','0000025296','OH00001420021','IL','1','Puplampu','Baruch','','','','34','269703018','6277 Karl Rd',0,'Columbus','OH','43229',NULL,'CY','39049','1950-11-19','M','U',':RET:2054-5','N','021','DEN','1776691','99734OH005000401','2014-02-01','2013-12-26 14:17:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:55'),(15806,12653,'Y','18','021','EC','A','','','AC','0002123798','0002123798','LA00001776576','IL','1','breaux','charles','','','','34','437198236','1746 Richard School  Road',0,'Church Point','LA','70525',NULL,'CY','22001','1965-03-29','M','M',':RET:2106-3','T','021','DEN','2377783','18575LA002000201','2014-02-01','2014-01-02 15:06:16','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-01-03 02:03:03'),(22368,17863,'Y','18','024','14','A','','','TE','0002134557','0002134557','','IL','1','nicholas','erica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-14','F','',NULL,NULL,NULL,'','3099030','','2014-02-28','2014-02-10 14:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-10 21:00:12'),(19149,15256,'Y','18','021','EC','A','','','AC','0000858383','0000858383','TX00001382882','IL','1','Gatewood','Lasonya','','','','34','453595477','215 HARRIS HBR',0,'POINT','TX','75472','7164','CY','48379','1980-11-24','F','U',':RET:2106-3','N','021','DEN','2672211','33348TX002000101','2014-03-01','2014-01-19 17:40:43','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-21 08:45:33'),(1022,837,'Y','18','021','EC','A','','','AC','0000829250','0000829250','OH00000126935','IL','1','Parsons','Kathleen','','','','34','335441940','2464 GREENHAVEN DR',0,'AKRON','OH','44333','2734','CY','39153','1952-12-12','F','M',':RET:2106-3','N','021','HLT','205788','52664OH152000901','2014-01-01','2013-12-02 20:36:06','0.00',NULL,NULL,'458.99','458.99','R-OH012','OH0','458.99',NULL,0,'2013-12-25 18:15:16'),(5905,4678,'Y','18','021','EC','A','','','AC','0001011567','0001011567','OH00001356669','IL','1','Angel','Gary','','','','34','281485680','201 Miller Rd',0,'Lebanon','OH','45036',NULL,'CY','39165','1950-06-16','M','U',':RET:2106-3','N','021','DEN','2044656','99734OH005000301','2014-01-01','2013-12-24 00:32:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:49:52'),(5359,4250,'Y','18','021','EC','A','','','AC','0001145964','0001145964','OH00000622535','IL','1','ALSTROM','LARRY','','','','34','290467020','3364 S MAIN ST',0,'AKRON','OH','44319','3052','CY','39153','1949-05-24','M','M',NULL,'N','021','HLT','1878907','52664OH152000901','2014-01-01','2013-12-19 17:20:47','730.00',NULL,NULL,'972.18','242.18','R-OH012','OH0','490.00',NULL,0,'2013-12-25 23:07:48'),(2055,1684,'Y','18','021','EC','A','','','AC','0000281982','0000281982','OH00000032372','IL','1','Tanner','Linda','','','','34','232886147','6610 OAKWOOD DR',0,'INDEPENDENCE','OH','44131','4604','CY','39035','1954-11-14','F','M',':RET:2106-3','N','021','DEN','470558','99734OH005000301','2014-01-01','2013-12-09 20:24:29','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:15:59'),(4352,3454,'N','01','021','EC','A',NULL,NULL,'','0001003284','0000521933','','IL','1','Mohon','Pamela','','','','34','411290136','443 NORTH ST',0,'GREENFIELD','OH','45123','1337','CY','39071','1962-11-21','F','',NULL,'N','021','HLT','2051646','92036OH002000601','2014-01-01','2013-12-17 13:03:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','462.36',NULL,0,'2013-12-25 21:53:29'),(17207,13770,'Y','18','021','EC','A','','','AC','0001032622','0001032622','OH00001368293','31','1','Orton','Steve','','','','34','288582592','1531 FIrst Street P.O. Box 614',0,'Lakemore','OH','44250',NULL,'CY','39153','1958-11-04','M','M',':RET:2106-3','N','021','HLT','1434943','52664OH151001305','2014-02-01','2014-01-08 09:48:26','661.00',NULL,NULL,'975.61','314.61','R-OH012','OH0','497.31',NULL,0,'2014-01-13 02:22:27'),(14496,11564,'Y','18','021','EC','A','','','AC','0000773078','0000773078','TX00001290092','IL','1','Gutierrez','Gerardo','','','','34','452572467','2419 Briarwood Dr',0,'Mission','TX','78574',NULL,'CY','48215','1980-04-06','M','U',':RET:2106-3','N','021','DEN','1450745','33348TX002000201','2014-02-01','2013-12-27 13:06:10','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-28 03:33:38'),(13968,11133,'Y','18','021','EC','A','','','AC','0000303368','0000303368','OH00000495172','31','1','Roberts','Kyle','','','','34','300741814','po box 258',0,'Saint Paris','OH','43072',NULL,'CY','39021','1976-06-12','M','U',':RET:2106-3','T','021','HLT','2189361','92036OH003000505','2014-01-01','2013-12-23 19:00:18','210.00',NULL,NULL,'353.41','143.41','R-OH003','OH0','353.41',NULL,0,'2013-12-26 13:15:19'),(8924,7076,'Y','18','021','EC','A','','','AC','0000468103','0000468103','OH00001298574','IL','1','Landfeld','Laura',NULL,NULL,NULL,NULL,NULL,'12802 Morning Glory Trail',0,'Chesterland','OH','44026',NULL,'CY','39055','1960-09-02','F','M',':RET:2106-3','N','021','DEN','1514161','99734OH005000401','2014-01-01','2013-12-18 09:08:02','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:02:52'),(22617,18061,'N','19','021','EC','A',NULL,NULL,'','0000981193','0000972471','','IL','1','CHAU','PHAT','N','','','34','729263194','4101 s custer rd',0,'mckinney','TX','75070',NULL,'CY','48085','1990-04-02','M','',':RET:2047-9','N','021','DEN','2664550','33348TX002000201','2014-03-01','2014-02-10 20:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:08'),(24605,19529,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000840579','','IL','1','Sexton','Lola','Avery','','','34','298130362','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2008-05-12','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:13:22'),(25164,19960,'Y','18','021','EC','A','','','AC','0000606008','0000606008','OH00002394873','IL','1','PORTWOOD','MAUREEN','LYNN','','','34','301546170','1303 STONINGTON DR',0,'YOUNGSTOWN','OH','44505','1657','CY','39155','1953-09-21','F','U',':RET:2106-3','N','021','DEN','3787609','99734OH005000401','2014-04-01','2014-02-20 23:24:42','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-21 22:00:24'),(28704,22716,'N','19','021','EC','A',NULL,NULL,'','0000314760','0000412282','','S1','1','Rorrer','David','B','','','34','288025672','175 HERMANN ST',0,'BARBERTON','OH','44203','1422','CY','39153','1997-10-11','F','',':RET:2106-3','N','021','HLT','3646802','52664OH151001301','2014-04-01','2014-03-08 13:02:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-08 21:31:11'),(1206,992,'Y','18','021','EC','A','','','AC','0000376127','0000376127','OH00000149859','IL','1','Brophy','Karen','','','','34','281669100','28 Schwinn Drive',0,'Barberton','OH','44203',NULL,'CY','39153','1959-09-11','F','R',':RET:2106-3','N','021','DEN','93341','99734OH005000301','2014-01-01','2013-12-03 14:32:36','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:19:59'),(21232,16966,'N','01','021','EC','A',NULL,NULL,'','0000634849','0001149901','','IL','1','BLESSING','CAROL','S','','','34','189440797','1520 QUEEN ANNES GATE',0,'WESTLAKE','OH','44145','2636','CY','39035','1952-04-25','F','',NULL,'N','021','DEN','3105087','99734OH005000301','2014-03-01','2014-02-03 11:06:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:01:09'),(20710,16548,'Y','18','021','EC','A','','','AC','0002353135','0002353135','LA00002015855','IL','1','Lynch','Ivy','','','','34','458834263','607 COMMERCIAL AVE',0,'LAKE ARTHUR','LA','70549','3117','CY','22053','1972-11-28','F','U',':RET:2054-5','T','021','DEN','3136741','18575LA002000201','2014-03-01','2014-01-30 13:28:05','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-30 21:01:08'),(2152,1770,'Y','18','021','EC','A','','','AC','0000060161','0000060161','LA00000064750','IL','1','Bruce','Kezie','N','','','34','433392299','1117 NORTH ST',0,'BATON ROUGE','LA','70802','4547','CY','22033','1979-09-19','F','U',':RET:2054-5','N','021','DEN','724840','18575LA002000101','2014-01-01','2013-12-09 19:07:12','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:18:37'),(4976,3951,'Y','18','021','EC','A','','','AC','0001208263','0001208263','TX00000645894','IL','1','JOHNSON','MIYESHA','','','','34','604050829','18081 MIDWAY RD',0,'DALLAS','TX','75287','6500','CY','48121','1978-01-16','F','U',':RET:2054-5','N','021','DEN','792427','33348TX002000201','2014-01-01','2013-12-06 22:03:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:46:35'),(20243,16152,'Y','18','021','EC','A','','','AC','0000195432','0000195432','MS00002241887','IL','1','BOYD','ANGELA','','','','34','428535312','307 TILLERY ST',0,'RIPLEY','MS','38663','1853','CY','28139','1979-05-12','F','M',NULL,'N','021','DEN','3507921','46300MS002000101','2014-03-01','2014-01-28 17:49:25','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2014-01-28 21:00:09'),(3883,3111,'Y','18','024','14','A','','','TE','0000373600','0000373600','','IL','1','Anderson','Robin','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-22','M','',NULL,NULL,NULL,'','650255','','2013-12-13','2013-12-13 18:05:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:36:30'),(18958,15104,'N','01','021','EC','A',NULL,NULL,'','0000845833','0000034479','','IL','1','Liu','Zhen','','','','34','637886724','2044 PALACE WAY',0,'ALLEN','TX','75013','3007','CY','48085','1975-12-06','F','',':RET:2034-7','N','021','DEN','3067798','33348TX002000201','2014-03-01','2014-01-16 22:42:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-20 08:05:53'),(18873,15035,'Y','18','021','EC','A','','','AC','0001571183','0001571183','LA00002058583','IL','1','Penton','Bambi','','','','34','439312516','1206 Amelia st',0,'Gretna','LA','70053',NULL,'CY','22051','1962-11-10','F','U',':RET:2106-3','N','021','DEN','3007783','18575LA002000201','2014-03-01','2014-01-16 13:00:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:25'),(17316,13849,'Y','18','021','EC','A','','','AC','0000157827','0000157827','TX00002280044','IL','1','Clark','Anna','M','','','34','456831458','5922 OAK HOLLOW CIR',0,'BRYAN','TX','77808','6276','CY','48041','1978-10-12','F','M',NULL,'N','021','DEN','1985569','33348TX002000201','2014-02-01','2014-01-10 14:53:38','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-13 02:23:47'),(7958,6298,'Y','18','021','EC','A','','','AC','0000358080','0000358080','MS00001306547','IL','1','LOCKWOOD','MARY','','','','34','587764876','4132 WILL O RUN DR',0,'JACKSON','MS','39212','3418','CY','28049','1951-11-20','F','U',NULL,'N','021','DEN','2445887','46300MS002000201','2014-01-01','2013-12-19 19:35:36','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:22'),(22779,18187,'Y','18','021','EC','A','','','AC','0000939829','0000939829','OH00001392190','31','1','May','Tangeana','','','','34','301706740','po box 713',0,'lineria','OH','44036',NULL,'CY','39093','1970-03-17','F','U',NULL,'N','021','DEN','2930041','99734OH005000401','2014-03-01','2014-02-11 15:39:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-11 21:01:43'),(24318,19313,'Y','18','021','EC','A','','','AC','0001075649','0001075649','TX00001853154','IL','1','Ortega','Jesse','','','','34','455298467','19402 Velvet Shadow Court',0,'Tomball','TX','77375',NULL,'CY','48201','1958-10-20','M','M',NULL,'T','021','DEN','2797811','33348TX002000201','2014-04-01','2014-02-18 10:37:08','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-18 22:00:06'),(28966,22925,'N','01','021','EC','A',NULL,NULL,'','0001601688','0002365465','','IL','1','REESE','MARY','','','','34','439087460','313 W WASHINGTON ST',0,'NEW IBERIA','LA','70560','4365','CY','22045','1959-08-25','F','',NULL,'N','021','DEN','4127115','18575LA002000201','2014-04-01','2014-03-10 15:14:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-10 21:00:59'),(31,26,'Y','18','021','EC','A','','','AC','0000344110','0000344110','OH00000790389','IL','1','Corcodel','Juanita','','','','34','294701729','1186 NEVILLE AVE',0,'AKRON','OH','44306','2947','CY','39153','1960-11-30','F','M',':RET:2106-3','N','021','DEN','783004','99734OH005000401','2014-01-01','2013-12-05 17:06:49','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:48'),(21918,17505,'Y','18','021','EC','A','','','AC','0001015621','0001015621','TX00001661286','IL','1','Collins','Peggy','','','','34','457042942','3900 E Loop 335 North',0,'Amarillo','TX','79108',NULL,'CY','48375','1953-06-10','F','U',':RET:2106-3','N','021','DEN','2690771','33348TX002000201','2014-03-01','2014-02-06 18:21:51','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-07 19:00:04'),(15026,12009,'N','01','021','EC','A',NULL,NULL,'','0001553038','0001637434','','IL','1','Dollar','John','','','','34','439255852','6003 JONI LN',0,'BOSSIER CITY','LA','71111','5724','CY','22015','1975-05-16','M','',':RET:2106-3','N','021','DEN','2167272','18575LA002000201','2014-02-01','2013-12-29 23:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:02:28'),(6599,5233,'Y','18','024','14','A','','','TE','0000823113','0000823113','','IL','1','Bourland','Brent',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-07','M','',NULL,NULL,NULL,'','1217814','','2013-12-11','2013-12-11 15:20:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 00:53:30'),(5172,4103,'Y','18','024','14','A','','','TE','0001228040','0001228040','','IL','1','Trokan','Peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-05-08','M','',NULL,NULL,NULL,'','333293','','2013-12-19','2013-12-19 11:40:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:21'),(13468,10742,'Y','18','021','EC','A','','','AC','0001125439','0001125439','OH00000900227','IL','1','SHAW','HORACE','','','','34','302482160','1012 PROSPECT AVE E',0,'CLEVELAND','OH','44115','1242','CY','39035','1950-06-23','M','U',NULL,'N','021','DEN','1879190','99734OH005000301','2014-01-01','2013-12-23 16:08:55','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:57'),(9192,7290,'Y','18','024','14','A','','','TE','0000180978','0000180978','','IL','1','Barton','Laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-06-24','F','',NULL,NULL,NULL,'','175935','','2013-12-18','2013-12-18 10:35:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:25'),(448,368,'Y','18','021','EC','A','','','AC','0001015543','0001015543','OH00000594972','IL','1','Kearney','Charles','','','','34','403151024','7456 Placid Lake Dr',0,'Mason','OH','45040',NULL,'CY','39165','1966-02-03','M','U',':RET:2106-3','N','021','DEN','236651','99734OH005000401','2014-01-01','2013-12-04 17:35:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:47:20'),(1735,1441,'N','19','021','EC','A',NULL,NULL,'','0000813089','0000394939','','IL','1','Pressel','Jonah','Christopher','','','34','299116807','1480 WAINSCOTT WAY',0,'DAYTON','OH','45414','5915','CY','39113','2006-06-30','M','',':RET:2106-3','N','021','DEN','1480239','99734OH005000301','2014-01-01','2013-12-24 11:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:26'),(2784,2250,'Y','18','021','EC','A','','','AC','0000425058','0000425058','OH00001252501','IL','1','Huebner','Sandra','','','','34','276489472','7420 Nightingale',0,'Holland','OH','43528',NULL,'CY','39095','1949-12-21','F','M',':RET:2106-3','N','021','HLT','707888','92036OH004002601','2014-01-01','2013-12-02 12:54:48','193.00',NULL,NULL,'470.37','277.37','R-OH001','OH0','470.37',NULL,0,'2013-12-25 19:49:57'),(3219,2590,'Y','18','021','EC','A','','','AC','0000434563','0000434563','LA00001145210','IL','1','Thomas','Noel','','','','34','229319036','69 SAINT ANTHONY ST',0,'LULING','LA','70070','5131','CY','22089','1983-10-12','F','U',':RET:2054-5','N','021','DEN','848560','18575LA002000201','2014-01-01','2013-10-31 18:03:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:45:39'),(1434,1196,'Y','18','021','EC','A','','','AC','0001483460','0001483460','LA00000165905','31','1','Breaux','Berton','','','','34','438597809','400 W Saint Mary Blvd',0,'Lafayette','LA','70506',NULL,'CY','22055','1969-08-27','M','U',':RET:1002-5','N','021','DEN','2455725','18575LA002000201','2014-01-01','2013-12-24 17:40:13','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:47:39'),(26939,21350,'Y','18','021','EC','A','','','AC','0000618418','0000618418','OH00002668039','IL','1','Chmura','Greg','','','','34','271489168','1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','1965-06-18','M','M',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 01:00:23'),(27625,21850,'Y','18','021','EC','A','','','AC','0000047146','0000047146','OH00003266540','IL','1','kamau','joan','','','','34','209769932','2963 black kettle trail',0,'dublin','OH','43017',NULL,'CY','39049','1972-02-11','F','U',':RET:2054-5','N','021','DEN','2910957','99734OH005000401','2014-04-01','2014-03-04 18:10:08','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-05 21:30:07'),(28859,22837,'N','01','021','EC','A',NULL,NULL,'','0000953307','0000397407','','IL','1','Gillespie','Jimmy','','','','34','288601469','4533 E MIAMI RIVER RD',0,'CLEVES','OH','45002','9540','CY','39061','1962-07-21','M','',NULL,'T','021','HLT','3518522','92036OH003001205','2014-04-01','2014-03-09 12:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','480.83','CIC',0,'2014-03-09 21:30:02'),(29095,23029,'Y','18','021','EC','A','','','AC','0001176329','0001176329','TX00003026901','IL','1','SINCLAIR','KIMBERLY','','','','34','458695487','508 N CHURCH ST',0,'MCKINNEY','TX','75069','2735','CY','48085','1966-12-06','F','M',NULL,'N','021','DEN','3020233','33348TX002000101','2014-04-01','2014-03-10 17:40:56','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-03-10 21:02:12'),(16622,13297,'N','01','021','EC','A',NULL,NULL,'','0000812039','0000712535','','IL','1','MUTURI','ESTHER','','','','34','027153217','4327 CHESFORD RD',0,'COLUMBUS','OH','43224','1787','CY','39049','1949-12-27','F','',NULL,'N','021','DEN','2132584','99734OH005000401','2014-02-01','2014-01-07 12:49:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:11'),(16402,13124,'Y','18','021','EC','A','','','AC','0000428443','0000428443','TX00000310523','31','1','Reagan','Jordan','','','','34','635075864','PO Box 3714',0,'Amarillo','TX','79116',NULL,'CY','48375','1987-09-16','M','U',':RET:2106-3','N','021','DEN','2513122','33348TX002000201','2014-02-01','2014-01-06 16:32:43','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-07 04:03:55'),(15011,11999,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00000017977','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','2337543','52664OH151001306','2014-02-01','2013-12-30 10:08:49','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2014-01-01 12:02:01'),(14342,11441,'Y','18','021','EC','A','','','AC','0000661359','0000661359','OH00000671602','IL','1','France','John','','','','34','092445522','2921 EVERGREEN RD',0,'TOLEDO','OH','43606','2723','CY','39095','1951-05-24','M','M',':RET:2106-3','N','021','HLT','2017754','92036OH005002605','2014-02-01','2013-12-26 15:39:44','969.00',NULL,NULL,'1120.44','151.44','R-OH001','OH0','560.22',NULL,0,'2013-12-27 02:07:55'),(22851,18233,'Y','18','021','EC','A','','','AC','0000475013','0000475013','OH00001488798','IL','1','Jones','Tiffany','','','','34','274742875','320 JACKSON ST',0,'SAINT MARYS','OH','45885','2142','CY','39011','1978-06-23','F','M',':RET:2106-3','N','021','HLT','2959390','92036OH005001505','2014-03-01','2014-02-11 15:46:17','504.00',NULL,NULL,'567.58','63.58','R-OH002','OH0','268.93',NULL,0,'2014-02-11 21:02:21'),(24024,19106,'Y','18','024','14','A','','','TE','0000054510','0000054510','','IL','1','White','Arliss','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-11-07','M','',NULL,NULL,NULL,'','3713573','','2014-02-15','2014-02-15 16:39:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:00:48'),(1867,1524,'Y','18','021','EC','A','','','AC','0000494445','0000494445','OH00001212309','IL','1','Durbin','Glenn','','','','34','279684575','6034 Concord Dr.',0,'Bowerston','OH','44695',NULL,'CY','39019','1960-10-17','M','U',':RET:2106-3','N','021','HLT','1579684','52664OH152000901','2014-01-01','2013-12-24 12:23:23','0.00',NULL,NULL,'333.21','333.21','R-OH015','OH0','333.21',NULL,0,'2013-12-25 18:58:12'),(1934,1575,'Y','18','021','EC','A','','','AC','0001182267','0001182267','TX00000124352','IL','1','Morales','Ovelia','','','','34','449026373','402 w 5th street',0,'bishop','TX','78343','2506','CY','48355','1949-10-24','F','U',NULL,'N','021','DEN','127724','33348TX002000201','2014-01-01','2013-11-20 10:16:39','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 19:00:29'),(21737,17357,'N','01','021','EC','A',NULL,NULL,'','0001232010','0001078111','','IL','1','Simpson','Willie','J','','','34','452980602','2506 BARRON RD',0,'COLLEGE STATION','TX','77845','9164','CY','48041','1952-08-23','M','',':RET:2106-3','N','021','DEN','3176846','33348TX002000201','2014-03-01','2014-02-06 17:24:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:13'),(2633,2141,'Y','18','024','14','A','','','TE','0000474926','0000474926','','IL','1','Toth','Jeffrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-23','M','',NULL,NULL,NULL,'','223776','','2013-12-02','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:46:11'),(5565,4418,'N','19','021','EC','A',NULL,NULL,'','0001050608','0001049333','','IL','1','Coakley','Autumn','D',NULL,NULL,NULL,NULL,'1044 MCCOY CT',0,'PATASKALA','OH','43062','7098','CY','39089','2011-11-17','F','',':RET:2106-3','N','021','DEN','276530','99734OH005000301','2014-01-01','2013-11-05 19:28:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:35'),(4760,3775,'Y','18','021','EC','A','','','AC','0001139481','0001139481','OH00000228809','31','1','Smith','Kathleen','','','','34','275521635','1848 DEVILS BACKBONE RD',0,'CINCINNATI','OH','45233','4405','CY','39061','1950-05-04','F','U',':RET:2106-3','N','021','DEN','576304','99734OH005000401','2014-01-01','2013-12-07 18:30:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:15:32'),(21309,17028,'Y','18','021','EC','A','','','AC','0002145832','0002145832','LA00001877944','IL','1','McAuley','Dennis','B','','','34','436780675','229 CENTRAL AVE',0,'JEFFERSON','LA','70121','3403','CY','22051','1952-02-09','M','U',':RET:2106-3','N','021','DEN','2694573','18575LA002000201','2014-03-01','2014-02-04 11:59:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:17'),(4162,3315,'Y','18','021','EC','A','','','AC','0000752061','0000752061','OH00000275367','IL','1','Reser','Jacquelyn','','','','34','294807051','5909 Thornberry Ct',0,'mason','OH','45040',NULL,'CY','39165','1983-03-30','F','M',':RET:2106-3','N','021','DEN','1493295','99734OH005000301','2014-01-01','2013-12-17 15:59:55','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:49:00'),(15750,12601,'Y','18','021','EC','A','','','AC','0000651200','0000651200','TX00001750868','IL','1','MCNUTT','JANET','','','','34','001462751','3402 HUNTINGTON CIR',0,'NACOGDOCHES','TX','75965',NULL,'CY','48347','1952-12-01','F','U',NULL,'N','021','DEN','1691448','33348TX002000201','2014-02-01','2014-01-02 16:12:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:08'),(15752,12602,'N','01','021','EC','A',NULL,NULL,'','0000970859','0000165191','','IL','1','CABRERA','ELIZABETH','','','','34','645509510','4300 MONREAL RD',0,'EDINBURG','TX','78541','5318','CY','48215','1969-10-21','F','',NULL,'N','021','DEN','2192387','33348TX002000201','2014-02-01','2014-01-02 16:16:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-03 02:01:11'),(16618,13294,'Y','18','021','EC','A','','','AC','0000990068','0000990068','OH00000590746','IL','1','gerhart','chris','','','','34','295768154','629 SKYLES RD',0,'UNION','OH','45322','3229','CY','39113','1979-01-07','M','M',':RET:2106-3','N','021','DEN','2155668','99734OH005000401','2014-02-01','2014-01-07 12:15:56','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:10'),(22187,17707,'Y','18','024','14','A','','','TE','0000852787','0000852787','','IL','1','LINDE','BARBARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-09','F','',NULL,NULL,NULL,'','934813','','2014-02-28','2014-02-09 13:03:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-09 19:00:07'),(25014,19836,'Y','18','021','EC','A','','','AC','0000777711','0000777711','OH00002991852','IL','1','DAVIS','MATTHEW','','','','34','300965919','5742 RYEWYCK DR',0,'TOLEDO','OH','43614','4584','CY','39095','1994-05-15','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3488383','99734OH005000301','2014-04-01','2014-02-20 09:28:22','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','21.13',NULL,0,'2014-02-20 22:00:54'),(27966,22124,'Y','18','024','14','A','','','TE','0002151075','0002151075','','IL','1','allen','lakeisha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-10-23','F','',NULL,NULL,NULL,'','3731333','','2014-03-05','2014-03-05 23:27:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-06 21:00:47'),(558,457,'N','01','021','EC','A',NULL,NULL,'','0000084933','0000611469','','IL','1','MOLINA','LORENA','','','','34','435572421','117 MARK TWAIN DR',0,'RIVER RIDGE','LA','70123','2489','CY','22051','1955-09-15','F','',NULL,'N','021','DEN','29969','18575LA002000101','2014-01-01','2013-12-04 14:38:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 17:50:12'),(4704,3728,'N','01','021','EC','A',NULL,NULL,'','0001178159','0000489228','','IL','1','STAFFEN','RANDY','','','','34','298642822','8255 COUNTY ROAD 3',0,'SWANTON','OH','43558',NULL,'CY','39051','1961-09-11','M','',':RET:2106-3','N','021','HLT','838337','92036OH004002601','2014-01-01','2013-12-12 10:46:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','306.05',NULL,0,'2013-12-25 22:08:31'),(3007,2417,'Y','18','021','EC','A','','','AC','0001199468','0001199468','OH00000452137','IL','1','DAVIS','HARRY','','','','34','283483838','1037 REED AVE',0,'AKRON','OH','44306',NULL,'CY','39153','1952-03-06','M','M',':RET:2106-3','N','021','HLT','991465','52664OH151001304','2014-01-01','2013-12-05 19:28:02','373.00',NULL,NULL,'626.65','253.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 20:17:48'),(19543,15577,'Y','18','021','EC','A','','','AC','0000905376','0000905376','MS00001930054','IL','1','TRIPLETT','PATRICIA','','','','34','426519290','4076 HIGHWAY 8',0,'CLEVELAND','MS','38732','8565','CY','28011','1970-02-08','F','U',':RET:2054-5','N','021','DEN','1937182','46300MS002000101','2014-03-01','2014-01-21 20:06:25','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-23 03:02:25'),(18301,14611,'Y','18','021','EC','A','','','AC','0001044503','0001044503','OH00001634216','IL','1','EDMOND','DOROTHY','','','','34','285527118','922 FERNDALE AVE',0,'DAYTON','OH','45406','5111','CY','39113','1949-11-15','F','U',NULL,'N','021','DEN','2314902','99734OH005000401','2014-02-01','2014-01-15 10:14:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-16 08:44:57'),(16814,13449,'Y','18','021','EC','A','','','AC','0000499918','0000499918','MS00001395255','IL','1','Warren','Jerry','','','','34','593586008','127 HAMPTON HILL BLVD',0,'CANTON','MS','39046','4409','CY','28089','1978-10-16','M','U',':RET:2106-3','N','021','DEN','1603364','46300MS002000201','2014-02-01','2014-01-10 18:34:06','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:18:18'),(23555,18766,'Y','18','024','14','A','','','TE','0000943453','0000943453','','IL','1','Lucke','Juanita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-12','F','',NULL,NULL,NULL,'','2638746','','2014-02-13','2014-02-13 09:29:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:02:41'),(25501,20231,'Y','18','024','14','A','','','TE','0000789866','0000789866','','IL','1','Parsons','Patrice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-14','F','',NULL,NULL,NULL,'','89249','','2014-03-12','2014-02-25 13:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-25 21:31:55'),(25889,20527,'Y','18','021','EC','A','','','AC','0000327017','0000327017','TX00003243497','IL','1','BALLEZA','ANTONIA','','','','34','630904793','205 FAWN STREET',0,'CALDWELL','TX','77836',NULL,'CY','48051','1952-05-16','F','M',':RET:2106-3','N','021','DEN','3379606','33348TX002000201','2014-04-01','2014-02-26 10:56:13','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-02-26 21:01:02'),(26689,21160,'Y','18','024','14','A','','','TE','0002310008','0002310008','','IL','1','Prock','Suzanne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-08-12','F','',NULL,NULL,NULL,'','2184492','','2014-03-14','2014-02-27 20:59:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-28 21:31:28'),(27037,21413,'Y','18','021','EC','A','','','AC','0001030547','0001030547','TX00003105921','31','1','HARVEY PEACE','ALICIA','N','','','34','463597272','PO Box 864',0,'Omaha','TX','75571',NULL,'CY','48343','1974-07-15','F','M',':RET:2106-3','N','021','DEN','3491222','33348TX002000201','2014-04-01','2014-03-03 15:40:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-03 21:00:19'),(21336,17051,'Y','18','021','EC','A','','','AC','0000778219','0000778219','TX00002301391','IL','1','Jaquez','Jose','','','','34','629907200','1572 W BOURNE',0,'CLINT','TX','79836','5204','CY','48141','1972-07-03','M','U',NULL,'N','021','DEN','3712024','33348TX002000201','2014-03-01','2014-02-03 20:28:28','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-04 21:00:31'),(2637,2142,'N','01','021','EC','A',NULL,NULL,'','0000474926','0000611928','','IL','1','Toth','Robin','l',NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1964-08-18','F','',':RET:2106-3','N','021','DEN','236591','99734OH005000401','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:14'),(18452,14719,'Y','18','024','14','A','','','TE','0001492074','0001492074','','IL','1','DAVIS','Lenard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-18','M','',NULL,NULL,NULL,'','2477450','','2014-01-14','2014-01-14 20:28:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-16 08:46:08'),(9711,7692,'Y','18','021','EC','A','','','AC','0000777644','0000777644','OH00000515968','IL','1','hannah','sheryl','','','','34','272640566','1830 SHIRLEY AVE',0,'HAMILTON','OH','45011','1856','CY','39017','1957-03-12','F','U',':RET:2106-3','N','021','DEN','658395','99734OH005000401','2014-01-01','2013-11-14 19:59:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:11'),(3468,2785,'Y','18','021','EC','A','','','AC','0000835455','0000835455','OH00000869548','31','1','BILLOPS','WALTER','','','','34','369905597','P.O. BOX 306',0,'GALLOWAY','OH','43119',NULL,'CY','39049','1971-08-23','M','U',':RET:2054-5','N','021','DEN','1412800','99734OH005000401','2014-01-01','2013-12-22 07:48:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:19:52'),(5378,4265,'Y','18','021','EC','A','','','AC','0002280073','0002280073','LA00001200798','IL','1','Layman','Charles','','','','34','434062398','6368 PONTCHARTRAIN BLVD',0,'NEW ORLEANS','LA','70124','2052','CY','22071','1957-11-06','M','U',':RET:2054-5','N','021','DEN','1896221','18575LA002000201','2014-01-01','2013-12-19 15:10:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:16'),(26206,20784,'Y','18','021','EC','A','','','AC','0000110569','0000110569','OH00003206127','IL','1','Kniola','Denese','','','','34','282484705','4355 VALLEY WOODS DR',0,'INDEPENDENCE','OH','44131','5235','CY','39035','1957-10-11','F','U',':RET:2106-3','N','021','HLT','3092620','52664OH151001305','2014-04-01','2014-02-27 11:37:13','369.00',NULL,NULL,'586.79','217.79','R-OH011','OH0','586.79',NULL,0,'2014-02-28 06:30:51'),(26811,21246,'N','01','021','EC','A',NULL,NULL,'','0000840585','0001104508','','IL','1','Adkins','John','Douglas','','','34','481747219','1830  Peacock Lane',0,'Holland','OH','43528',NULL,'CY','39095','1951-12-23','M','',':RET:2106-3','N','021','HLT','3868694','92036OH006002601','2014-04-01','2014-02-28 18:41:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','444.29',NULL,0,'2014-03-01 21:00:28'),(22099,17641,'Y','18','021','EC','A','','','AC','0000022832','0000022832','OH00001879145','IL','1','barnett','wendy','','','','34','290742136','7824 peachmont ave nw',0,'north canton','OH','44720',NULL,'CY','39151','1963-08-31','F','U',':RET:2106-3','N','021','DEN','2681973','99734OH005000301','2014-03-01','2014-02-08 05:18:26','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-08 19:00:29'),(17323,13856,'Y','18','021','EC','A','','','AC','0001061218','0001061218','TX00002048892','IL','1','TAYLOR','RONALD','','','','34','573755172','901 S 23RD ST',0,'COPPERAS COVE','TX','76522','2757','CY','48099','1969-07-17','M','U',':RET:2106-3','N','021','DEN','2152514','33348TX002000201','2014-02-01','2014-01-10 17:44:34','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-13 02:23:52'),(16041,12844,'Y','18','021','EC','A','','','AC','0001237975','0001237975','TX00001362050','IL','1','RAMSEY','KELLIE','','','','34','640502960','408 WOODLAWN CIR',0,'LUFKIN','TX','75904','8423','CY','48005','1987-12-29','F','U',':RET:2106-3','N','021','DEN','1556904','33348TX002000101','2014-02-01','2014-01-02 23:05:15','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-04 02:02:50'),(15413,12329,'Y','18','021','EC','A','','','AC','0000819110','0000819110','TX00001501382','IL','1','pecan','stacy','','','','34','454534265','464 Deer Valley',0,'canyon lake','TX','78133',NULL,'CY','48091','1974-02-13','F','U',':RET:2106-3','N','021','DEN','1551702','33348TX002000201','2014-02-01','2013-12-31 01:26:30','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,1,'2014-01-02 04:27:10'),(3467,2784,'N','01','021','EC','A',NULL,NULL,'','0000346893','0001010204','','IL','1','KAY','ABRAHAM','F','','','34','302481816','21075 FARNSLEIGH RD',0,'SHAKER HEIGHTS','OH','44122','3845','CY','39035','1950-05-13','M','',':RET:2106-3','N','021','DEN','1610449','99734OH005000401','2014-01-01','2013-12-22 07:29:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:50'),(7913,6257,'Y','18','021','EC','A','','','AC','0001642149','0001642149','LA00000281673','IL','1','Eidelman','David','','','','34','183680438','2905 Pine St',0,'New Orleans','LA','70125',NULL,'CY','22071','1986-05-14','M','U',':RET:2106-3','N','021','DEN','2284249','18575LA002000201','2014-01-01','2013-12-19 21:30:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:09'),(7709,6103,'N','01','021','EC','A',NULL,NULL,'','0000625419','0001028066','','IL','1','Nason','Rebecca','Sue','','','34','268563191','311 MILL ST',0,'ANNA','OH','45302','8624','CY','39149','1951-12-31','F','',NULL,'N','021','DEN','1884183','99734OH005000401','2014-01-01','2013-12-20 09:54:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:27'),(22214,17731,'Y','18','021','EC','A','','','AC','0001726655','0001726655','LA00001803787','IL','1','Hester','Michael','','','','34','434534444','2106 Cherry Palm Circle',0,'New Iberia','LA','70563',NULL,'CY','22045','1976-08-04','M','U',':RET:2106-3','T','021','DEN','2865439','18575LA002000201','2014-03-01','2014-02-09 12:58:35','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-09 19:00:22'),(22438,17916,'Y','18','024','14','A','','','TE','0000563052','0000563052','','IL','1','Whitley','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-10-04','F','',NULL,NULL,NULL,'','3671695','','2014-02-10','2014-02-10 11:29:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:40'),(24769,19652,'Y','18','021','EC','A','','','AC','0001165319','0001165319','OH00001564682','IL','1','ANAYA','MAURA','KENNEDY','','','34','251843487','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-22','F','M',':RET:2106-3','T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:44:05'),(25751,20424,'Y','18','024','14','A','','','TE','0000234081','0000234081','','IL','1','shaferly','hannah','rose',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2005-04-04','F','',NULL,NULL,NULL,'','2665488','','2014-02-24','2014-02-24 16:29:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 09:30:46'),(20535,16409,'Y','18','021','EC','A','','','AC','0000111924','0000111924','OH00002387331','IL','1','FUQUA','NIKOLE','MARIE','','','34','298906623','11178 VALLEY VIEW RD',0,'SAGAMORE HILLS','OH','44067','1849','CY','39153','1984-04-03','F','U',':RET:2054-5','N','021','HLT','2852311','52664OH152000901','2014-03-01','2014-01-29 10:01:31','0.00',NULL,NULL,'182.78','182.78','R-OH012','OH0','182.78',NULL,0,'2014-01-29 21:01:32'),(19177,15278,'Y','18','021','EC','A','','','AC','0000067029','0000067029','TX00002333462','IL','1','Saltzman','Angel','Michelle-Harris','','','34','636286159','2811 LA FRONTERA BLVD',0,'Austin','TX','78728',NULL,'CY','48453','1990-05-27','F','M',NULL,'N','021','DEN','2730131','33348TX002000201','2014-03-01','2014-01-20 15:54:51','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-21 08:46:05'),(15323,12255,'Y','18','021','EC','A','','','AC','0001236605','0001236605','TX00000881473','IL','1','depina','juan','','','','34','592474676','800 E VERMONT AVE',0,'MCALLEN','TX','78503','1724','CY','48215','1986-11-10','M','R',':RET:2106-3','N','021','DEN','2255906','33348TX002000201','2014-02-01','2013-12-31 22:23:59','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,1,'2014-01-02 04:23:37'),(828,685,'Y','18','021','EC','A','','','AC','0000812006','0000812006','OH00000443775','IL','1','Henrick','Joelle','A','','','34','097385435','1467 EDGEMOOR AVE',0,'AKRON','OH','44313','7413','CY','39153','1950-03-02','F','U',':RET:2106-3','N','021','HLT','1940124','52664OH151001306','2014-01-01','2013-12-16 15:29:44','573.00',NULL,NULL,'658.32','85.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 18:06:15'),(15130,12091,'N','19','021','EC','A',NULL,NULL,'','0001063253','0000322151','','IL','1','Mcguire','Elizabeth','','','','34','290960133','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1993-11-12','F','',NULL,'N','021','DEN','1658127','99734OH005000301','2014-02-01','2013-12-30 17:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:26'),(8134,6436,'Y','18','021','EC','A','','','AC','0000388616','0000388616','OH00000123169','IL','1','Snyder','Ellen','','','','34','283601764','20 WILTSHIRE BLVD',0,'DAYTON','OH','45419','2519','CY','39113','1958-02-17','F','U',':RET:2106-3','N','021','DEN','1002456','99734OH005000301','2014-01-01','2013-11-22 16:25:41','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:15:36'),(22529,17987,'Y','18','021','EC','A','','','AC','0000779144','0000779144','OH00001834795','IL','1','Carr','Jesse','','','','34','281907592','1300 WOOSTER RD W',0,'BARBERTON','OH','44203','7228','CY','39153','1988-05-26','M','U',':RET:1002-5^:RET:2106-3','T','021','HLT','3234346','52664OH152000901','2014-03-01','2014-02-10 10:09:59','133.00',NULL,NULL,'188.59','55.59','R-OH012','OH0','188.59',NULL,0,'2014-02-10 21:31:30'),(26020,20636,'Y','18','021','EC','A','','','AC','0000719035','0000719035','TX00002996510','IL','1','TORRES','JOSE','L','','','34','453992231','1929 WOLSEY DR',0,'MISSION','TX','78572','4511','CY','48215','1980-11-02','M','R',NULL,'N','021','DEN','2936111','33348TX002000101','2014-04-01','2014-02-26 13:04:36','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-02-26 21:02:14'),(28854,22833,'Y','18','021','EC','A','','','AC','0000257195','0000257195','OH00003614526','IL','1','Jones','Todd','E','','','34','298766195','4481 Eastwood Drive',0,'Batavia','OH','45103',NULL,'CY','39025','1972-05-25','M','U',':RET:2106-3','N','021','HLT','4072323','92036OH004000601','2014-04-01','2014-03-09 16:24:07','189.00',NULL,NULL,'224.74','35.74','R-OH005','OH0','224.74',NULL,0,'2014-03-09 21:01:20'),(21867,17459,'N','01','021','EC','A',NULL,NULL,'','0002310036','0002183534','','IL','1','MORALES','MILAGROSA','','','','34','050483051','103 MARY ST',0,'GRAY','LA','70359','4901','CY','22109','1955-10-06','F','',NULL,'N','021','DEN','2926261','18575LA002000201','2014-03-01','2014-02-06 13:47:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-06 21:01:23'),(6840,5423,'Y','18','021','EC','A','','','AC','0000781405','0000781405','LA00000839260','IL','1','gordy','david','','','','34','439639516','117 E MERRICK ST',0,'SHREVEPORT','LA','71104','2517','CY','22017','1973-05-23','M','U',':RET:2106-3','T','021','DEN','254468','18575LA002000201','2014-01-01','2013-11-14 07:29:19','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 01:31:04'),(8014,6343,'Y','18','024','14','A','','','TE','0000290784','0000290784','','IL','1','Zacharias','Anna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-08-18','F','',NULL,NULL,NULL,'','1022269','','2013-12-20','2013-12-20 09:26:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:08:43'),(25569,20284,'Y','18','021','EC','A','','','AC','0000496798','0000496798','OH00003081284','IL','1','Gibson','Deborah','','','','34','302607765','3550 FREEMAN AVE',0,'HAMILTON','OH','45015','1755','CY','39017','1966-05-30','F','U',':RET:2106-3','N','021','HLT','3734580','92036OH004001201','2014-04-01','2014-02-23 13:36:39','100.00',NULL,NULL,'269.80','169.80','R-OH004','OH0','269.80',NULL,0,'2014-02-26 08:00:29'),(26648,21128,'Y','18','021','EC','A','','','AC','0000672817','0000672817','OH00002322246','IL','1','Kroh','Gregory','','','','34','278745554','813  N. Main St.',0,'North Canton','OH','44720',NULL,'CY','39151','1962-12-10','M','M',':RET:2106-3','N','021','HLT','3047338','52664OH151001305','2014-03-01','2014-02-28 11:49:09','604.00',NULL,NULL,'973.43','369.43','R-OH015','OH0','415.91',NULL,0,'2014-02-28 21:31:06'),(20957,16746,'N','01','021','EC','A',NULL,NULL,'','0000563052','0000437009','','IL','1','Whitley','William','L','','','34','465888550','2846 FM 2410 SPUR',0,'Belton','TX','76513',NULL,'CY','48027','1950-04-12','M','',':RET:2106-3','N','021','DEN','3671695','33348TX002000201','2014-03-01','2014-02-01 11:52:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-01 19:00:07'),(15617,12490,'N','01','021','EC','A',NULL,NULL,'','0000282616','0000068508','','IL','1','Ross','Jackie','','','','34','503609709','103 SUNRISE POINT DR',0,'BRANDON','MS','39047','6523','CY','28121','1949-12-26','F','',NULL,'N','021','DEN','1832816','46300MS002000101','2014-02-01','2013-12-30 21:26:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,1,'2014-01-02 04:32:59'),(14526,11590,'Y','18','021','EC','A','','','AC','0000148137','0000148137','TX00000085902','IL','1','Mayfield','Ronald','','','','34','452275952','16235 FM 2293',0,'BREMOND','TX','76629','5096','CY','48395','1964-07-11','M','U',':RET:2106-3','T','021','DEN','2012315','33348TX002000201','2014-02-01','2013-12-27 17:39:21','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-28 03:34:26'),(23184,18485,'Y','18','021','EC','A','','','AC','0001180730','0001180730','MS00002196640','31','1','Yarbrough','Faris','Walker','','','34','428558501','PO BOX 1582',0,'Collins','MS','39428',NULL,'CY','28031','1986-09-25','F','M',':RET:2106-3','N','021','DEN','2686011','46300MS002000101','2014-03-01','2014-02-12 17:33:30','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-12 21:31:59'),(24083,19149,'N','19','021','EC','A',NULL,NULL,'','0000432810','0000057381','','IL','1','DRENNEN','GARRETT','D','','','34','290066321','4899 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','2002-11-20','M','',':RET:2106-3','N','021','HLT','3259633','52664OH151001305','2014-03-01','2014-02-15 12:10:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:22'),(24101,19159,'Y','18','021','EC','A','','','AC','0000921578','0000921578','TX00001984578','IL','1','QUIROZ','RAMIRO','','','','34','635126289','905 W POWELL ST',0,'BEEVILLE','TX','78102','6614','CY','48025','1990-01-15','M','U',NULL,'N','021','DEN','3499627','33348TX002000201','2014-03-01','2014-02-15 11:36:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-15 22:01:31'),(28265,22366,'Y','18','021','EC','A','','','AC','0000938123','0000938123','TX00003137183','IL','1','Nevling','David','','','','34','293466225','4311 14TH ST',0,'BACLIFF','TX','77518','2310','CY','48167','1951-08-10','M','U',':RET:2106-3','N','021','DEN','3856418','33348TX002000201','2014-04-01','2014-03-06 22:56:08','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-03-07 21:00:19'),(255,212,'Y','18','021','EC','A','','','AC','0000396783','0000396783','LA00000886495','IL','1','Ambeau','Hugh','Aaron','','','34','436069447','8939 Jefferson Hwy',0,'Baton Rouge','LA','70809',NULL,'CY','22033','1963-03-30','M','U',':RET:2106-3','N','021','DEN','240047','18575LA002000101','2014-01-01','2013-12-05 12:08:13','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 17:21:41'),(19618,15637,'Y','18','021','EC','A','','','AC','0000818542','0000818542','OH00001390394','IL','1','Muntz','Diane','','','','34','291769989','9 PARK LANE DR',0,'NAPOLEON','OH','43545','1325','CY','39069','1965-03-17','F','M',':RET:2106-3','N','021','HLT','1817341','92036OH003002605','2014-03-01','2014-01-22 11:23:43','208.00',NULL,NULL,'332.95','124.95','R-OH001','OH0','332.95',NULL,0,'2014-01-23 03:02:54'),(17786,14208,'N','19','021','EC','A',NULL,NULL,'','0001060928','0000259249','','IL','1','Seay','Kyland','','','','34','292408268','11651 Norbourne Drive',0,'Cincincinnati','OH','45240',NULL,'CY','39061','2000-01-24','M','',':RET:2054-5^:RET:2106-3','N','021','HLT','2140652','92036OH002001201','2014-02-01','2014-01-13 13:47:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-14 01:33:45'),(6602,5235,'N','01','021','EC','A',NULL,NULL,'','0001207128','0000703765','','IL','1','GOULD','DEBRA','','','','34','300501458','47 summerberry lane',0,'NILES','OH','44446',NULL,'CY','39155','1955-06-14','F','',NULL,'N','021','HLT','111825','92036OH002003201','2014-01-01','2013-12-11 08:55:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','712.23',NULL,0,'2013-12-26 00:53:34'),(6669,5289,'Y','18','021','EC','A','','','AC','0000515455','0000515455','TX00000414003','31','1','Phillips','Nicole','','','','34','307961159','po box 5836',0,'midland','TX','79704',NULL,'CY','48135','1972-12-22','F','U',':RET:2106-3','T','021','DEN','117543','33348TX002000201','2014-01-01','2013-11-16 15:03:15','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-26 01:01:02'),(23940,19034,'Y','18','021','EC','A','','','AC','0000187503','0000187503','OH00001770086','IL','1','ROBBINS','SINDY','','','','34','171465851','4147 FOX HOLLOW DR',0,'BLUE ASH','OH','45241','2938','CY','39061','1954-05-26','F','U',':RET:2106-3','N','021','DEN','3745327','99734OH005000301','2014-03-01','2014-02-15 09:01:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00','CIC',0,'2014-02-15 21:00:08'),(23987,19072,'Y','18','021','EC','A','','','AC','0001346699','0001346699','LA00002066378','IL','1','McCarthy','Colleen','Sue','','','34','312661913','4302 BANKS ST',0,'NEW ORLEANS','LA','70119','6717','CY','22071','1964-11-02','F','U',':RET:2106-3','N','021','DEN','2829588','18575LA002000201','2014-03-01','2014-02-15 13:56:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:24'),(24143,19186,'Y','18','021','EC','A','','','AC','0000444955','0000444955','OH00002475204','IL','1','Bingamon','William','','','','34','284704749','3533 NEALS CIR',0,'BATAVIA','OH','45103','9709','CY','39025','1971-08-04','M','M',':RET:2106-3','N','021','HLT','3320747','92036OH004000601','2014-03-01','2014-02-15 11:05:49','267.01',NULL,NULL,'557.55','290.54','R-OH005','OH0','228.72',NULL,0,'2014-02-15 22:01:53'),(25126,19930,'Y','18','024','14','A','','','TE','0002048902','0002048902','','IL','1','Slocum','Tommy','a',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-12-05','M','',NULL,NULL,NULL,'','2993692','','2014-03-31','2014-02-21 12:55:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-21 21:30:23'),(18508,14760,'N','01','021','EC','A',NULL,NULL,'','0000230464','0000345607','','IL','1','Bourn','Cristal','','','','34','281623279','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1969-09-17','F','',':RET:2106-3','N','021','HLT','1900415','52664OH151001305','2014-02-01','2014-01-15 17:50:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-01-16 08:46:32'),(13015,10373,'Y','18','024','14','A','','','TE','0001231748','0001231748','','IL','1','Crutcher','Carrie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-15','F','',NULL,NULL,NULL,'','928690','','2013-12-22','2013-12-22 19:34:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:49:54'),(1154,952,'Y','18','021','EC','A','','','AC','0000617805','0000617805','LA00000049898','IL','1','Byrd','Annette','','','','34','433173267','3648 GREENBRIAR DR',0,'SHREVEPORT','LA','71109','1728','CY','22017','1958-04-17','F','U',':RET:2054-5','N','021','DEN','891414','18575LA002000201','2014-01-01','2013-12-03 14:12:54','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:18:43'),(1305,1080,'N','01','021','EC','A',NULL,NULL,'','0000493005','0000698153','','IL','1','McGee','Jeremy','Scott','','','34','634070808','1112 GLENN ST',0,'DAINGERFIELD','TX','75638','1808','CY','48343','1981-04-07','M','',':RET:2106-3','N','021','DEN','507160','33348TX002000201','2014-01-01','2013-11-04 11:36:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:31:17'),(1603,1341,'Y','18','021','EC','A','','','AC','0001026853','0001026853','TX00000599448','31','1','STEGMAN','TANNER','','','','34','585618435','137 SUGAR RUN RD',0,'EIGHTY FOUR','PA','15330','2551','CY','48251','1986-09-18','M','M',NULL,'N','021','DEN','1803376','33348TX002000201','2014-01-01','2013-12-24 12:44:29','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:52:06'),(18432,14706,'Y','18','021','EC','A','','','AC','0002212038','0002212038','LA00001371825','IL','1','Bernard','Desiree','Delandria','','','34','433984558','608 2ND ST',0,'NEW ORLEANS','LA','70130','5438','CY','22071','1955-10-10','F','U',NULL,'N','021','DEN','2902808','18575LA002000201','2014-02-01','2014-01-15 13:14:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:59'),(3541,2843,'Y','18','021','EC','A','','','AC','0000595630','0000595630','TX00001122712','IL','1','Woodruff','Lacey','','','','34','473020927','1241 RED RANCH CIR',0,'CEDAR PARK','TX','78613','4900','CY','48491','1978-08-18','F','U',':RET:2106-3','N','021','DEN','2185781','33348TX002000101','2014-01-01','2013-12-22 16:08:00','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:21:47'),(17748,14180,'Y','18','021','EC','A','','','AC','0000636031','0000636031','OH00001670686','IL','1','MUHAMMAD','NIYRA','R','','','34','291760774','2352 CHEYENNE BLVD',0,'TOLEDO','OH','43614',NULL,'CY','39095','1980-11-01','F','U',':RET:2054-5','N','021','HLT','2556018','92036OH004002601','2014-02-01','2014-01-13 11:24:32','142.00',NULL,NULL,'187.83','45.83','R-OH001','OH0','187.83',NULL,0,'2014-01-14 01:33:26'),(16397,13120,'Y','18','021','EC','A','','','AC','0001256813','0001256813','TX00000154921','IL','1','Bondurant','David','','','','34','542868317','1031 STEWART AVE',0,'DUNCANVILLE','TX','75137','3548','CY','48113','1961-11-09','M','M',':RET:2106-3','N','021','DEN','2257225','33348TX002000201','2014-02-01','2014-01-06 13:11:12','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:45'),(4453,3538,'N','01','021','EC','A',NULL,NULL,'','0000195113','0000725042','','IL','1','Spencer','Richard','O','','Sr','34','288480556','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1950-12-29','M','',':RET:2054-5','N','021','DEN','61616','99734OH005000301','2014-01-01','2013-12-12 10:29:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:26'),(7151,5674,'Y','18','021','EC','A','','','AC','0000904268','0000904268','OH00001560938','IL','1','shumaker','donald','','','','34','289583042','209 wagoner street',0,'fort recovery','OH','45846',NULL,'CY','39107','1966-05-18','M','U',':RET:2106-3','N','021','HLT','1450686','92036OH004001501','2014-01-01','2013-12-24 20:17:45','274.58',NULL,NULL,'276.60','2.02','R-OH002','OH0','276.60',NULL,0,'2013-12-26 01:52:12'),(16028,12831,'Y','18','021','EC','A','','','AC','0001153725','0001153725','LA00002258776','IL','1','Paille','Randy','','','','34','434379670','702 Chipley st',0,'westwego','LA','70094',NULL,'CY','22051','1978-08-06','M','U',NULL,'N','021','DEN','1997923','18575LA002000201','2014-02-01','2014-01-03 11:00:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:22'),(14996,11985,'N','01','021','EC','A',NULL,NULL,'','0000964649','0000843425','','IL','1','Jolley','Mary','A','','','34','458131243','418 CR 2010',0,'Center','TX','75935',NULL,'CY','48419','1959-09-27','F','',':RET:2106-3','N','021','DEN','2320714','33348TX002000201','2014-02-01','2013-12-30 16:48:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-01 12:01:34'),(15074,12049,'Y','18','021','EC','A','','','AC','0001111908','0001111908','TX00000780348','IL','1','Graves','Jeremy','L','','','34','462614948','605 AUDREY ST',0,'LONGVIEW','TX','75601','6004','CY','48203','1981-02-07','M','M',':RET:2106-3','N','021','DEN','1603097','33348TX002000101','2014-02-01','2013-12-29 19:27:39','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-01 12:03:59'),(23036,18365,'Y','18','021','EC','A','','','AC','0000216105','0000216105','TX00002141790','IL','1','gonzalez','Martha','','','','34','463954152','3252 HIGH LARK DR',0,'DALLAS','TX','75234','7734','CY','48113','1959-03-01','F','U',':RET:2106-3','N','021','DEN','3584957','33348TX002000201','2014-03-01','2014-02-12 15:11:39','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:37'),(28686,22702,'Y','18','021','EC','A','','','AC','0000808721','0000808721','OH00003101107','IL','1','Lee','Nathan','','','','34','270920094','4149 WALTER RD',0,'NORTH OLMSTED','OH','44070','2117','CY','39035','1987-03-19','M','U',':RET:2106-3','N','021','HLT','3424685','52664OH152000901','2014-04-01','2014-03-07 21:49:46','39.00',NULL,NULL,'193.07','154.07','R-OH011','OH0','193.07',NULL,0,'2014-03-08 21:31:00'),(426,349,'Y','18','021','EC','A','','','AC','0000489211','0000489211','OH00001042764','IL','1','Powell','Connie','','','','34','297583968','810 w second st',0,'Waverly','OH','45690',NULL,'CY','39131','1955-10-05','F','U',':RET:2106-3','N','021','DEN','350652','99734OH005000401','2014-01-01','2013-12-04 13:49:54','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 17:46:47'),(13190,10523,'Y','18','021','EC','A','','','AC','0000969783','0000969783','TX00000486233','IL','1','Lallier','Lee','','','','34','462805943','167 SQUIRREL RDG',0,'WYLIE','TX','75098','6838','CY','48085','1949-10-04','M','R',':RET:2106-3','N','021','DEN','1392433','33348TX002000101','2014-01-01','2013-12-23 08:54:29','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:35'),(7554,5978,'N','01','021','EC','A',NULL,NULL,'','0000869266','0000943408','','IL','1','Maxwell','Suzanne','M','','','34','299746153','1258 RANDOLPH RD',0,'MOGADORE','OH','44260','9741','CY','39133','1965-11-04','F','',':RET:2106-3','N','021','HLT','692542','52664OH152000901','2014-01-01','2013-12-14 21:41:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.06',NULL,0,'2013-12-26 02:33:18'),(6550,5193,'Y','18','021','EC','A','','','AC','0001062282','0001062282','TX00001285415','IL','1','Dudley','Phil','','','','34','459138324','11702 ABBEY WAY',0,'SAN ANTONIO','TX','78253','5958','CY','48029','1956-11-07','M','R',NULL,'N','021','DEN','814626','33348TX002000201','2014-01-01','2013-12-11 12:00:48','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 00:52:09'),(20487,16366,'N','19','021','EC','A',NULL,NULL,'','0000692954','0000066284','','IL','1','BANIC','ANTHONY','ERIC','','','34','687396408','17713 EDWARDS RD',0,'DOYLESTOWN','OH','44230','9302','CY','39169','2012-11-28','M','',':RET:2106-3','N','021','HLT','2932100','52664OH151001305','2014-03-01','2014-01-29 15:52:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-29 21:01:04'),(19978,15935,'N','01','021','EC','A',NULL,NULL,'','0001205840','0000330911','','IL','1','Stauffer','Caryn','','','','34','299681308','578 S. East St.',0,'Bucyrus','OH','44820',NULL,'CY','39033','1960-01-10','F','',':RET:2106-3','N','021','DEN','1462886','99734OH005000401','2014-03-01','2014-01-25 10:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:14'),(17499,13992,'N','01','021','EC','A',NULL,NULL,'','0001215430','0001150834','','IL','1','Pickett','Heather','','','','34','280764462','33718 weiss rd',0,'walker','LA','70785',NULL,'CY','22063','1964-07-21','F','',':RET:2106-3','N','021','DEN','1702666','18575LA002000201','2014-02-01','2014-01-12 15:30:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 03:01:24'),(5506,4372,'Y','18','021','EC','A','','','AC','0001079108','0001079108','TX00001113004','IL','1','Strickland','Kathy','','','','34','456048108','481 LCR 794',0,'Groesbeck','TX','76642',NULL,'CY','48293','1953-04-12','F','M',':RET:2106-3','N','021','DEN','56181','33348TX002000101','2014-01-01','2013-11-26 18:15:23','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:15:03'),(16349,13086,'Y','18','021','EC','A','','','AC','0000317355','0000317355','OH00001641305','IL','1','Thacker','Richard','','','','34','307809501','3210 MAIN ST',0,'MINERAL RIDGE','OH','44440','9745','CY','39155','1963-03-31','M','M',':RET:2106-3','N','021','DEN','2553573','99734OH005000301','2014-02-01','2014-01-06 07:22:24','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-01-07 04:02:27'),(5005,3969,'Y','18','021','EC','A','','','AC','0000288277','0000288277','OH00000638720','IL','1','RUSHIN','michael','','','','34','294788149','4570 trickle creek lane',0,'columbus','OH','43228',NULL,'CY','39049','1968-03-09','M','R',':RET:2054-5','N','021','DEN','1028013','99734OH005000301','2014-01-01','2013-12-07 16:32:25','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:47:13'),(22382,17873,'N','19','021','EC','A',NULL,NULL,'','0001156236','0001109263','','IL','1','Cassiday','Kendra','','','','34','292088468','2955 PREAKNESS DR',0,'STOW','OH','44224','6235','CY','39153','2003-12-24','F','',':RET:2106-3','N','021','HLT','2648777','52664OH151001306','2014-03-01','2014-02-10 10:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-10 21:30:09'),(23923,19024,'Y','18','021','EC','A','','','AC','0001960960','0001960960','LA00002013988','IL','1','Yekani-Fard','Sharifah','','','','34','435550525','1353 JIM TAYLOR DR',0,'BATON ROUGE','LA','70820','3608','CY','22033','1982-04-10','F','U',':RET:2028-9^:RET:2500-7','N','021','DEN','2830563','18575LA002000101','2014-03-01','2014-02-14 16:16:09','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02','CIC',0,'2014-02-14 22:00:07'),(26255,20824,'N','01','021','EC','A',NULL,NULL,'','0000134224','0000396352','','IL','1','IBARRA CRESPO','ANTONIO','','','','34','628366393','418 ALMA AVE',0,'ALAMO','TX','78516','3201','CY','48215','1985-08-21','M','',NULL,'N','021','DEN','3196455','33348TX002000201','2014-04-01','2014-02-27 15:05:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 06:31:10'),(17482,13977,'Y','18','021','EC','A','','','AC','0001100398','0001100398','TX00002431107','IL','1','Daniels','Sabrina','','','','34','640186726','2051 W CUMBERLAND RD',0,'TYLER','TX','75703','5351','CY','48423','1990-07-17','F','U',':RET:2106-3','N','021','DEN','1462560','33348TX002000201','2014-02-01','2014-01-12 13:35:18','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-13 03:01:13'),(175,145,'Y','18','021','EC','A','','','AC','0000876028','0000876028','OH00000674507','IL','1','sullivan','thomas','','','','34','219881425','7706 Norwalk Rd',0,'Medina','OH','44256',NULL,'CY','39103','1977-02-07','M','M',NULL,'N','021','HLT','547990','52664OH151001306','2014-01-01','2013-12-05 09:47:36','387.00',NULL,NULL,'548.60','161.60','R-OH012','OH0','274.30',NULL,0,'2013-12-25 17:19:32'),(2683,2173,'Y','18','021','EC','A','','','AC','0000772612','0000772612','OH00000459625','IL','1','Tinker','Todd','','','','34','279648279','208 ELM ST',0,'CHILLICOTHE','OH','45601','2309','CY','39141','1962-11-27','M','U',NULL,'N','021','DEN','1085118','99734OH005000301','2014-01-01','2013-12-02 16:42:14','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 19:47:16'),(2849,2302,'Y','18','021','EC','A','','','AC','0000247852','0000247852','OH00000463963','IL','1','Nottingham','Mary','','','','34','578767446','3469 W 54TH ST',0,'CLEVELAND','OH','44102','5742','CY','39035','1963-11-20','F','U',':RET:2106-3','N','021','DEN','894932','99734OH005000301','2014-01-01','2013-11-01 18:34:17','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:01:17'),(15914,12743,'N','19','021','EC','A',NULL,NULL,'','0000797000','0001052232','','S1','1','geloach','ruth','','','','34','639885734','286 fm1696 rd west',0,'huntsville','TX','77320',NULL,'CY','48471','2003-09-30','M','',':RET:2106-3','N','021','DEN','2537657','33348TX002000101','2014-02-01','2014-01-02 18:19:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-01-03 02:06:27'),(13011,10369,'N','19','021','EC','A',NULL,NULL,'','0000898454','0000200759','','IL','1','Elbeyli','Enis','','','','34','294065205','4837 PRINCE CHARLES WAY',0,'HILLIARD','OH','43026','9283','CY','39049','1994-01-18','M','',':RET:2106-3','N','021','DEN','1578412','99734OH005000401','2014-01-01','2013-12-22 19:53:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:49:47'),(6471,5127,'Y','18','021','EC','A','','','AC','0000249099','0000249099','OH00000385150','IL','1','Hall','Jeffrey','','','','34','272884271','3776 MONTEVISTA RD',0,'CLEVELAND HTS','OH','44121','1615','CY','39035','1978-06-30','M','M',NULL,'N','021','HLT','632011','52664OH151001301','2014-01-01','2013-12-10 20:22:48','0.00',NULL,NULL,'307.36','307.36','R-OH011','OH0','307.36',NULL,0,'2013-12-26 00:50:07'),(15636,12507,'Y','18','021','EC','A','','','AC','0001888247','0001888247','LA00000547195','31','1','LANDIX','CHARMAN','','','','34','434906339','PO BOX 2276',0,'HARVEY','LA','70059',NULL,'CY','22051','1953-11-23','F','U',NULL,'T','021','DEN','2545227','18575LA002000101','2014-02-01','2013-12-31 15:48:59','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:33:39'),(24008,19092,'Y','18','021','EC','A','','','AC','0000374752','0000374752','OH00002625935','IL','1','Hill','Janine','','','','34','268641828','712 EAST DR',0,'SHEFFIELD LAKE','OH','44054','1029','CY','39093','1959-12-05','F','U',':RET:2106-3','N','021','DEN','3064384','99734OH005000401','2014-03-01','2014-02-15 11:27:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:38'),(26432,20964,'N','01','021','EC','A',NULL,NULL,'','0001078905','0000688298','','IL','1','Bender','Lynda','M','','','34','262915976','117 SHAY ST',0,'DELAWARE','OH','43015','5026','CY','39041','1963-08-21','F','',NULL,'N','021','DEN','2932773','99734OH005000401','2014-04-01','2014-02-27 07:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:30:16'),(14945,11944,'Y','18','021','EC','A','','','AC','0000696820','0000696820','OH00000111922','IL','1','Peak','John','David','','','34','250732408','109 EDGEWOOD ST',0,'BOTKINS','OH','45306','8702','CY','39149','1981-12-24','M','U',':RET:2106-3','N','021','HLT','1467894','92036OH005000501','2014-02-01','2013-12-29 18:03:34','62.00',NULL,NULL,'281.21','219.21','R-OH003','OH0','281.21',NULL,0,'2013-12-30 00:02:27'),(19539,15573,'Y','18','021','EC','A','','','AC','0000053087','0000053087','OH00001764032','IL','1','Wehrmeister','Nathan','','','','34','278863081','3935 S DETROIT AVE',0,'TOLEDO','OH','43614','5646','CY','39095','1986-04-15','M','U',':RET:2106-3','N','021','HLT','3046470','92036OH004002601','2014-03-01','2014-01-22 10:36:15','134.00',NULL,NULL,'164.31','30.31','R-OH001','OH0','164.31',NULL,0,'2014-01-23 03:02:24'),(928,769,'N','19','021','EC','A',NULL,NULL,'','0000115452','0000564171','','IL','1','Rini','Thomas','Robert','','','34','297156220','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','2010-06-10','M','',':RET:2106-3','N','021','DEN','19531','99734OH005000401','2014-01-01','2013-10-28 23:21:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:01'),(18382,14672,'Y','18','021','EC','A','','','AC','0000154680','0000154680','OH00001442030','IL','1','Kirsch','Ashley','','','','34','288906078','31704 Daniel Dr.',0,'Willowick','OH','44095',NULL,'CY','39085','1988-12-20','F','U',':RET:2106-3','N','021','DEN','1841290','99734OH005000301','2014-02-01','2014-01-15 11:10:34','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:35'),(17723,14162,'Y','18','021','EC','A','','','AC','0001060931','0001060931','OH00001918095','IL','1','Trent','Karoline','','','','34','290608087','3063 HICKORY ST',0,'CLINTON','OH','44216','9115','CY','39153','1962-08-12','F','M',':RET:2106-3','T','021','HLT','2729921','52664OH152000901','2014-02-01','2014-01-13 16:29:59','430.00',NULL,NULL,'751.36','321.36','R-OH012','OH0','350.32',NULL,0,'2014-01-14 01:33:15'),(16765,13411,'Y','18','021','EC','A','','','AC','0000121553','0000121553','OH00001522647','IL','1','RIEBESEHL','CONNIE','','','','34','277829709','11075 COUNTY ROAD J',0,'DELTA','OH','43515','9134','CY','39051','1970-08-16','F','U',NULL,'N','021','HLT','2004676','92036OH006002601','2014-02-01','2014-01-07 12:03:57','126.00',NULL,NULL,'209.85','83.85','R-OH001','OH0','209.85',NULL,0,'2014-01-08 18:24:59'),(15885,12719,'N','01','021','EC','A',NULL,NULL,'','0001785152','0002256539','','IL','1','GUILLORY','TAMMY','D','','','34','436317622','301 ELM ST',0,'MAMOU','LA','70554',NULL,'CY','22039','1973-04-03','F','',':RET:2106-3','N','021','DEN','2275285','18575LA002000101','2014-02-01','2014-01-02 13:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-03 02:05:31'),(21657,17296,'Y','18','021','EC','A','','','AC','0001453627','0001453627','LA00002394496','IL','1','keller','herman','','','','34','433436474','20195 SISTERS RD',0,'PONCHATOULA','LA','70454','5119','CY','22105','1964-12-24','M','M',NULL,'T','021','DEN','3510903','18575LA002000201','2014-03-01','2014-02-05 11:14:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:53'),(27413,21697,'Y','18','021','EC','A','','','AC','0000585592','0000585592','OH00003066636','IL','1','Manning','Joseph','','','','34','300809549','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','1976-07-29','M','M',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:36'),(28887,22863,'Y','18','021','EC','A','','','AC','0000806038','0000806038','TX00003426987','IL','1','CLARK','JANE','','','','34','318464320','1903 CR 2430',0,'ALBA','TX','75410',NULL,'CY','48379','1949-09-05','F','U',':RET:2106-3','N','021','DEN','4237302','33348TX002000201','2014-04-01','2014-03-10 14:21:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:12'),(9004,7145,'Y','18','021','EC','A','','','AC','0000289516','0000289516','OH00000288778','IL','1','Thorp','Alexandra','','','','34','288748056','4601 BURGER AVE',0,'CLEVELAND','OH','44109','5323','CY','39035','1963-01-22','F','U',':RET:2106-3','N','021','HLT','2384584','52664OH152000901','2014-01-01','2013-12-18 11:13:38','180.00',NULL,NULL,'517.67','337.67','R-OH011','OH0','329.02',NULL,0,'2013-12-26 04:04:57'),(387,320,'Y','18','024','14','A','','','TE','0000827126','0000827126','','IL','1','McRae-Gibson','Margaret',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-04-08','F','',NULL,NULL,NULL,'','25262','','2013-12-03','2013-12-03 18:55:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:45:51'),(18903,15062,'Y','18','021','EC','A','','','AC','0000499330','0000499330','OH00001935135','IL','1','Perkins','Donna','','','','34','293548650','630 S Sandusky St.',0,'Tiffin','OH','44883',NULL,'CY','39147','1953-11-24','F','U',':RET:2106-3','T','021','HLT','1689033','92036OH004002701','2014-03-01','2014-01-16 14:51:57','480.00',NULL,NULL,'489.36','9.36','R-OH006','OH0','489.36',NULL,0,'2014-01-17 03:36:37'),(596,491,'Y','18','021','EC','A','','','AC','0001039739','0001039739','OH00000493138','IL','1','Wiley','Robert','','','','34','293489359','3050 GLENFINNAN DR',0,'ALBANY','OH','45710','9462','CY','39009','1950-05-23','M','M',':RET:2106-3','N','021','DEN','629721','99734OH005000401','2014-01-01','2013-12-15 20:25:57','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2013-12-25 18:00:12'),(8849,7015,'Y','18','021','EC','A','','','AC','0000029428','0000029428','TX00000117512','IL','1','Mahaffey','Frank','','','','34','451906286','320 East Main Street',0,'Mount Vernon','TX','75457',NULL,'CY','48159','1954-09-21','M','U',':RET:2106-3','T','021','DEN','2220149','33348TX002000201','2014-01-01','2013-12-18 09:42:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:58'),(17831,14244,'Y','18','021','EC','A','','','AC','0000169953','0000169953','MS00001813814','IL','1','COTTEN','VALERIE','','','','34','426271292','150 CARL AVE',0,'RIDGELAND','MS','39157',NULL,'CY','28089','1972-10-23','F','U',NULL,'N','021','DEN','2396060','46300MS002000201','2014-02-01','2014-01-14 15:45:38','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:59'),(6321,5011,'Y','18','021','EC','A','','','AC','0001011523','0001011523','OH00000708048','IL','1','JONES','CECIL','','','','34','284489630','7885 MAPLE GROVE DR',0,'LEWIS CENTER','OH','43035','9350','CY','39041','1951-11-27','M','M',NULL,'N','021','DEN','1077389','99734OH005000401','2014-01-01','2013-12-11 11:05:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:21'),(6048,4790,'Y','18','021','EC','A','','','AC','0000308236','0000308236','OH00000122198','IL','1','Teggart','Michael','','','','34','292606131','554 Boal Street',0,'Cincinnati','OH','45202',NULL,'CY','39061','1976-04-18','M','U',':RET:2106-3','N','021','DEN','775376','99734OH005000401','2014-01-01','2013-12-01 13:54:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:01:35'),(5563,4417,'Y','18','021','EC','A','','','AC','0000853070','0000853070','TX00001182797','IL','1','Riley','Benjamin','','','','34','576667034','3412 BRETT JACKSON DR',0,'CROWLEY','TX','76036','5628','CY','48251','1953-12-09','M','U',':RET:2106-3','N','021','DEN','1031584','33348TX002000101','2014-01-01','2013-11-06 13:07:26','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:16:32'),(4404,3501,'Y','18','021','EC','A','','','AC','0001192653','0001192653','OH00000849321','IL','1','Hill','Mark','','','','34','076609009','2321 BAIRD RD',0,'FOSTORIA','OH','44830','9723','CY','39173','1961-11-21','M','M',':RET:2106-3','N','021','DEN','939975','99734OH005000401','2014-01-01','2013-12-12 14:36:05','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:01:14'),(20515,16392,'Y','18','021','EC','A','','','AC','0000889695','0000889695','TX00002567086','IL','1','Doberson','Chad','','','','34','449657937','2655 SKYVIEW RIDGE CT',0,'HOUSTON','TX','77047','6518','CY','48201','1970-12-23','M','M',NULL,'N','021','DEN','3595669','33348TX002000101','2014-03-01','2014-01-28 21:43:18','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-01-29 21:01:21'),(20892,16697,'Y','18','021','EC','A','','','AC','0001244198','0001244198','OH00002052783','IL','1','robinson','mary','ann','','','34','279589069','740 W ALEXIS RD',0,'TOLEDO','OH','43612','4373','CY','39095','1957-03-17','F','U',':RET:2054-5','N','021','DEN','3293682','99734OH005000401','2014-03-01','2014-01-31 10:37:26','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-31 21:01:15'),(21627,17267,'N','01','021','EC','A',NULL,NULL,'','0000042236','0000535212','','IL','1','Sadruddin','Azmina','','','','34','640562884','1432 SUMMERHILL DR',0,'CARROLLTON','TX','75007','6048','CY','48121','1967-12-12','F','',NULL,'N','021','DEN','3849168','33348TX002000201','2014-03-01','2014-02-05 09:56:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-05 21:30:39'),(21702,17330,'Y','18','024','14','A','','','TE','0000636971','0000636971','','IL','1','Pough','Zeder',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-07','F','',NULL,NULL,NULL,'','1909758','','2014-02-05','2014-02-05 12:11:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-05 21:31:11'),(26914,21330,'Y','18','024','14','A','','','TE','0000992729','0000992729','','IL','1','Stone','david',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-13','M','',NULL,NULL,NULL,'','3890595','','2014-03-01','2014-03-01 19:12:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 01:00:13'),(18996,15130,'Y','18','021','EC','A','','','AC','0000040975','0000040975','OH00002030920','IL','1','peet','ashley','','','','34','287805470','142 W HIGHLAND AVE',0,'WOOSTER','OH','44691','1350','CY','39169','1979-12-31','F','M',':RET:2106-3','N','021','HLT','1917833','52664OH151001305','2014-03-01','2014-01-16 20:38:19','260.00',NULL,NULL,'546.81','286.81','R-OH014','OH0','270.73',NULL,0,'2014-01-20 08:06:13'),(70,63,'Y','18','021','EC','A','','','AC','0000822031','0000822031','OH00000420605','IL','1','koerner','kristy','','','','34','295807280','10503 ASHEVILLE PINE CT',0,'HARRISON','OH','45030','5007','CY','39061','1979-07-07','F','U',':RET:2106-3','N','021','DEN','1103633','99734OH005000301','2014-01-01','2013-12-05 14:13:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:54'),(13298,10615,'Y','18','021','EC','A','','','AC','0000956312','0000956312','TX00000977739','IL','1','MARLAR','CLARENCE','O','','','34','450784907','641 F M RD 2820',0,'SUMNER','TX','75486',NULL,'CY','48277','1951-11-20','M','U',':RET:2106-3','T','021','DEN','1803261','33348TX002000201','2014-01-01','2013-12-23 14:37:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:41'),(24535,19489,'Y','18','021','EC','A','','','AC','0000416993','0000416993','TX00002887334','IL','1','Ruiz','Maria',NULL,NULL,NULL,NULL,NULL,'3918 PENA ST',0,'MISSION','TX','78572','1538','CY','48215','1951-09-25','F','U',':RET:2106-3','N','021','DEN','3773886','33348TX002000201','2014-04-01','2014-02-19 16:56:44','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-20 04:01:11'),(24781,19656,'Y','18','021','EC','A','','','AC','0000639575','0000639575','OH00002581785','IL','1','Parks','Carlye','','','','34','268961058','517 HEATHERBROOKE WAY',0,'WESTERVILLE','OH','43081','5661','CY','39049','1989-10-19','F','U',':RET:2106-3','N','021','DEN','3244212','99734OH005000401','2014-04-01','2014-02-19 13:17:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:45:08'),(25817,20471,'N','19','021','EC','A',NULL,NULL,'','0000003628','0000608498','','IL','1','MIKLOS','KAITLYN','','','','34','288064180','12760 CARTER RD',0,'PAINESVILLE','OH','44077','9790','CY','39085','2001-09-27','F','',NULL,'N','021','DEN','3115883','99734OH005000301','2014-03-01','2014-02-26 14:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:24'),(20035,15978,'Y','18','021','EC','A','','','AC','0000519866','0000519866','OH00002572364','IL','1','Wyatt','Tina','M','','','34','275882749','1697 MEADOWS RD',0,'MADISON','OH','44057','1831','CY','39085','1978-08-05','F','M',':RET:2106-3','N','021','DEN','3294938','99734OH005000301','2014-03-01','2014-01-26 15:22:22','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-26 19:00:22'),(19877,15856,'Y','18','021','EC','A','','','AC','0000851864','0000851864','OH00001480729','IL','1','Zawisza','Andrzej','','','','34','014806004','248 AUGUSTA DR',0,'ELYRIA','OH','44035','8299','CY','39093','1963-08-23','M','M',NULL,'N','021','DEN','2968736','99734OH005000401','2014-03-01','2014-01-24 10:55:45','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-24 21:00:44'),(19161,15266,'Y','18','021','EC','A','','','AC','0001003330','0001003330','OH00002319034','IL','1','Waggoner','Kurt','','','','34','306826525','150 BRINKER ST',0,'BELLEVUE','OH','44811','1502','CY','39077','1965-01-22','M','M',':RET:2106-3','T','021','HLT','2590735','92036OH003002705','2014-03-01','2014-01-19 00:13:51','643.00',NULL,NULL,'797.01','154.01','R-OH006','OH0','399.52',NULL,0,'2014-01-21 08:45:41'),(7114,5644,'Y','18','021','EC','A','','','AC','0001279795','0001279795','LA00000866391','IL','1','Peterson','Christopher','','','','34','469967476','237 14TH ST',0,'NEW ORLEANS','LA','70124','1211','CY','22071','1981-01-26','M','U',':RET:2106-3','N','021','DEN','1621130','18575LA002000101','2014-02-01','2013-12-25 00:48:09','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 01:51:08'),(7174,5689,'Y','18','021','EC','A','','','AC','0000284391','0000284391','OH00001066264','IL','1','Liptok','Ruth','Z','','','34','279587019','148 NAPLES DR',0,'ELYRIA','OH','44035','1521','CY','39093','1956-08-07','F','M',':RET:2106-3','N','021','DEN','214927','99734OH005000301','2014-01-01','2013-12-13 18:25:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:03'),(14607,11658,'Y','18','021','EC','A','','','AC','0001203226','0001203226','OH00000589236','IL','1','Crum','Emily','','','','34','273925627','7428 PLANKTOWN NORTH RD',0,'SHILOH','OH','44878','8802','CY','39139','1987-06-20','F','U',':RET:2106-3','N','021','DEN','1386341','99734OH005000301','2014-02-01','2013-12-27 12:18:50','0.00',NULL,NULL,'21.13','21.13','R-OH007','OH0','0.00',NULL,0,'2013-12-28 03:36:32'),(3740,2991,'Y','18','021','EC','A','','','AC','0001231763','0001231763','TX00000063811','IL','1','Steeghs','Peter','','','','34','450591943','812 WHELESS AVE',0,'KERRVILLE','TX','78028','3363','CY','48265','1952-03-01','M','U',':RET:2106-3','T','021','DEN','1238624','33348TX002000201','2014-01-01','2013-12-13 12:50:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:51'),(2594,2106,'N','01','021','EC','A',NULL,NULL,'','0000474926','0000611928','','IL','1','Toth','Robin','l',NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1964-08-18','F','',':RET:2106-3','N','021','DEN','223776','99734OH005000401','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:07'),(3068,2466,'Y','18','021','EC','A','','','AC','0000261001','0000261001','LA00000969456','31','1','Bennett','Shirley','','','','34','437907590','p.o box 771',0,'natalbany','LA','70451',NULL,'CY','22105','1955-08-15','F','U',':RET:2054-5','N','021','DEN','1228575','18575LA002000101','2014-01-01','2013-12-06 11:26:23','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 20:19:24'),(3167,2548,'Y','18','021','EC','A','','','AC','0000714933','0000714933','OH00000548766','IL','1','Truong','Michael','','','','34','298780493','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','1965-06-01','M','M',':RET:2047-9','N','021','DEN','227690','99734OH005000401','2014-01-01','2013-11-18 13:20:56','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:28'),(3291,2654,'Y','18','021','EC','A','','','AC','0000461933','0000461933','OH00001030284','IL','1','Lowell','Geoffrey','','','','34','299626430','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','1972-09-22','M','M',':RET:2106-3','T','021','DEN','1417328','99734OH005000301','2014-01-01','2013-12-22 08:50:08','0.00',NULL,NULL,'87.78','87.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:15:31'),(24686,19595,'Y','18','021','EC','A','','','AC','0000991176','0000991176','TX00002083800','IL','1','snider','susan','','','','34','459926046','110w 1st st',0,'shiner','TX','77984',NULL,'CY','48285','1950-06-01','F','U',':RET:2106-3','N','021','DEN','3007336','33348TX002000101','2014-04-01','2014-02-19 14:24:51','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:31:26'),(28425,22493,'Y','18','021','EC','A','','','AC','0000780578','0000780578','OH00003498766','IL','1','adem','kadir','','','','34','295110969','1887 westbrook village dr',0,'columbus','OH','43228',NULL,'CY','39049','1985-01-01','M','U',':RET:2054-5','N','021','DEN','3428418','99734OH005000401','2014-04-01','2014-03-07 14:50:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:05'),(28507,22559,'Y','18','021','EC','A','','','AC','0001060977','0001060977','OH00002625491','31','1','Britenriker','John','','','','34','291585180','1416 Piedmont Ave',0,'Akron','OH','44310',NULL,'CY','39103','1955-12-08','M','M',':RET:2106-3','N','021','HLT','4120839','52664OH151001304','2014-04-01','2014-03-07 12:39:37','643.00',NULL,NULL,'1003.53','360.53','R-OH012','OH0','568.22',NULL,0,'2014-03-07 21:31:52'),(17281,13819,'N','01','021','EC','A',NULL,NULL,'','0000885609','0000773994','','IL','1','Yarnell','James','','','','34','300444582','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1953-07-06','M','',':RET:2106-3','N','021','HLT','2246097','52664OH152000901','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.31',NULL,0,'2014-01-13 02:23:25'),(403,331,'Y','18','021','EC','A','','','AC','0000504449','0000504449','OH00000264465','IL','1','Boakye','Joyce','','','','34','269085871','4804 Mockingbird Ct S',0,'Columbus','OH','43229',NULL,'CY','39049','1974-03-25','F','U',':RET:2054-5','N','021','DEN','258878','99734OH005000401','2014-01-01','2013-12-04 09:13:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:12'),(445,365,'N','01','021','EC','A',NULL,NULL,'','0000443426','0001093120','','IL','1','Gephart','Marla','M','','','34','300684248','1519 HENLEY RD',0,'TROY','OH','45373','2616','CY','39109','1962-12-23','F','',':RET:2106-3','N','021','DEN','563748','99734OH005000401','2014-01-01','2013-12-04 11:43:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:16'),(16238,13004,'Y','18','021','EC','A','','','AC','0002378831','0002378831','LA00002262077','IL','1','Wilkins','Chad','','','','34','433730838','70237 Highway59',0,'Abita Springs','LA','70420',NULL,'CY','22103','1981-05-26','M','U',':RET:2106-3','N','021','DEN','2234880','18575LA002000101','2014-02-01','2014-01-04 12:01:24','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-05 00:02:16'),(14112,11246,'N','01','021','EC','A',NULL,NULL,'','0000902212','0000600805','','IL','1','Mathews','Jessib','Carl','','','34','295483907','9340 RORYANNA DR',0,'CHARDON','OH','44024','8669','CY','39055','1951-03-09','M','',':RET:2106-3','N','021','DEN','1513217','99734OH005000401','2014-02-01','2013-12-26 14:15:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:53'),(3833,3067,'N','19','021','EC','A',NULL,NULL,'','0001124051','0001073126','','IL','1','Scholten','Jason','','','','34','427739424','2106 PRESSLER RD',0,'AKRON','OH','44312','4328','CY','39153','1992-05-06','M','',':RET:2106-3','N','021','DEN','85836','99734OH005000301','2014-01-01','2013-12-13 16:51:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:35:12'),(13847,11051,'Y','18','021','EC','A','','','AC','0000121538','0000121538','OH00000722803','IL','1','McCarthy','Kathy','','','','34','275485664','2674 OAK PARK BLVD',0,'CUYAHOGA FALLS','OH','44221','2962','CY','39153','1951-09-15','F','U',':RET:2106-3','N','021','HLT','1538368','52664OH152000901','2014-01-01','2013-12-23 18:44:14','346.00',NULL,NULL,'469.28','123.28','R-OH012','OH0','469.28',NULL,0,'2013-12-26 13:12:29'),(23448,18679,'Y','18','021','EC','A','','','AC','0001219368','0001219368','TX00002220395','IL','1','CAROLSON','LEE','','','','34','865521924','11001 S 1ST ST',0,'AUSTIN','TX','78748','6762','CY','48453','1976-04-20','M','M',':RET:2106-3','N','021','DEN','2898416','33348TX002000201','2014-03-01','2014-02-13 13:06:37','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-13 22:01:36'),(23474,18697,'Y','18','021','EC','A','','','AC','0000530783','0000530783','TX00002163528','IL','1','martin','kevin','','','','34','452635035','8011 BRIARIDGE DR',0,'SAN ANTONIO','TX','78230','4911','CY','48029','1967-05-30','M','U',':RET:2106-3','N','021','DEN','3296812','33348TX002000201','2014-03-01','2014-02-13 16:41:10','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-13 22:01:50'),(25238,20020,'Y','18','021','EC','A','','','AC','0000067712','0000067712','OH00002840016','31','1','Pruitt','Robyn','','','','34','279841321','PO Box 314',0,'Mowrystown','OH','45155',NULL,'CY','39071','1973-12-22','F','U',':RET:2106-3','N','021','HLT','3435497','92036OH003000606','2014-04-01','2014-02-21 11:24:42','240.00',NULL,NULL,'286.51','46.51','R-OH005','OH0','286.51',NULL,0,'2014-02-21 22:01:06'),(27562,21801,'N','01','021','EC','A',NULL,NULL,'','0000195113','0000725042','','IL','1','Spencer','Richard','O','','Sr','34','288480556','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1950-12-29','M','',':RET:2054-5','N','021','DEN','2926918','99734OH005000301','2014-04-01','2014-03-04 11:13:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:17'),(575,470,'Y','18','021','EC','A','','','AC','0000790851','0000790851','OH00000618598','IL','1','Parker','Melvin','','','','34','272507379','327 Eight Mile Road',0,'Cincinnati','OH','45255',NULL,'CY','39061','1951-06-29','M','U',':RET:2106-3','N','021','HLT','276696','92036OH005001205','2014-01-01','2013-12-04 10:44:08','400.00',NULL,NULL,'616.74','216.74','R-OH004','OH0','616.74',NULL,0,'2013-12-25 17:50:41'),(16023,12826,'N','19','021','EC','A',NULL,NULL,'','0002159652','0001914731','','IL','1','williams','vanessa','','','','34','433850286','55145 AUCOIN ST',0,'WHITE CASTLE','LA','70788','2702','CY','22047','1992-04-03','F','',NULL,'N','021','DEN','2283532','18575LA002000201','2014-02-01','2014-01-03 10:01:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-04 02:02:13'),(1545,1288,'Y','18','021','EC','A','','','AC','0000467102','0000467102','OH00000030603','IL','1','SHELLER','ANNE','','','','34','483740582','1102 KENT ST',0,'PORTSMOUTH','OH','45662','2585','CY','39145','1953-05-19','F','U',NULL,'N','021','DEN','1911857','99734OH005000401','2014-01-01','2013-12-24 17:53:37','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:50:26'),(13587,10837,'Y','18','021','EC','A','','','AC','0002043874','0002043874','LA00000353637','IL','1','PARSON','SHENNA','ANTOINETTE','','','34','439635313','46416L WEST WOOD PARK DRIVE',0,'SHERVEPORT','LA','71109',NULL,'CY','22017','1987-04-05','F','U',':RET:2054-5','N','021','DEN','2458488','18575LA002000201','2014-01-01','2013-12-23 18:49:18','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:05:03'),(1911,1562,'N','19','021','EC','A',NULL,NULL,'','0000828235','0000396162','','IL','1','Schultz','Emma','','','','34','277025878','5865 SQUIREHILL CT',0,'CINCINNATI','OH','45241','6021','CY','39061','1997-04-13','F','',':RET:2106-3','N','021','HLT','1521879','92036OH003001201','2014-01-01','2013-12-24 17:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 18:59:25'),(2948,2373,'Y','18','021','EC','A','','','AC','0000243711','0000243711','OH00000916407','IL','1','Lockhart','Rebecca','Jean','','','34','282564018','6796 Harrison Ave',0,'Cincinnati','OH','45247',NULL,'CY','39061','1954-01-14','F','U',':RET:2106-3','N','021','DEN','672086','99734OH005000401','2014-01-01','2013-12-06 13:57:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:16:27'),(6681,5299,'Y','18','021','EC','A','','','AC','0000520916','0000520916','OH00000361374','IL','1','Ryan-fisher','Molly','','','','34','292769897','524 GLENMONT AVE',0,'COLUMBUS','OH','43214','3260','CY','39049','1974-07-09','F','U',':RET:2106-3','N','021','DEN','262546','99734OH005000401','2014-01-01','2013-11-04 21:10:37','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:01:24'),(26365,20913,'Y','18','021','EC','A','','','AC','0001055374','0001055374','OH00002985430','IL','1','Harp','Keisha','','','','34','275900628','1920 Lotushill Dr',0,'Cincinnati','OH','45240',NULL,'CY','39061','1989-01-05','F','U',':RET:2106-3','N','021','DEN','3133334','99734OH005000301','2014-04-01','2014-02-26 14:18:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00','CIC',0,'2014-02-28 07:00:08'),(28293,22386,'N','01','021','EC','A',NULL,NULL,'','0000198629','0000382223','','IL','1','Reddy','James','Martin','','','34','281883275','2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','1981-08-12','M','',':RET:2106-3','N','021','HLT','3096511','92036OH004000601','2014-04-01','2014-03-07 11:10:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.20','CIC',0,'2014-03-07 21:00:29'),(29003,22954,'Y','18','021','EC','A','','','AC','0000121613','0000121613','OH00003300480','IL','1','Boggs','Kathryn','','','','34','173744076','2297 26TH ST SW',0,'AKRON','OH','44314','1958','CY','39153','1992-12-22','F','M',':RET:2106-3','N','021','HLT','4355998','52664OH152000901','2014-04-01','2014-03-09 23:38:44','163.34',NULL,NULL,'163.34','0.00','R-OH012','OH0','163.34',NULL,0,'2014-03-10 21:01:20'),(4110,3285,'Y','18','021','EC','A','','','AC','0000515823','0000515823','OH00000935603','IL','1','Henderson','Gregory','','','','34','302709590','4753 HIGH HILL RD',0,'CAMBRIDGE','OH','43725','9792','CY','39059','1974-09-16','M','M',':RET:2106-3','N','021','DEN','1994619','99734OH005000301','2014-01-01','2013-12-16 19:23:53','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:47:58'),(5383,4270,'Y','18','021','EC','A','','','AC','0001429841','0001429841','LA00000296443','IL','1','Frierson','Jane','','','','34','433867629','302 SCHLIEF DR',0,'BELLE CHASSE','LA','70037','2423','CY','22075','1951-09-20','F','U',':RET:2106-3','N','021','DEN','1968252','18575LA002000201','2014-01-01','2013-12-19 15:52:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:25'),(8139,6440,'N','01','021','EC','A',NULL,NULL,'','0000550034','0000723867','','IL','1','Best','Jamie','','','','34','302804511','110 N SYCAMORE ST',0,'ARCANUM','OH','45304','1169','CY','39037','1977-07-16','M','',':RET:2106-3','N','021','HLT','318666','92036OH005000506','2014-01-01','2013-11-21 22:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','292.39',NULL,0,'2013-12-26 03:15:45'),(20594,16456,'Y','18','021','EC','A','','','AC','0001257359','0001257359','OH00002494117','IL','1','Fragapane','Elizabeth','','','','34','293569239','30632 ROYAL WOODS PL',0,'WESTLAKE','OH','44145','3772','CY','39035','1961-11-25','F','M',':RET:2106-3','N','021','DEN','3410167','99734OH005000401','2014-03-01','2014-01-30 10:11:02','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-30 21:00:10'),(15455,12367,'Y','18','021','EC','A','','','AC','0000301192','0000301192','TX00001853468','IL','1','Arney','Victor','','','','34','546130625','401 N 4th st',0,'rosebud','TX','76570',NULL,'CY','48145','1956-02-07','M','U',NULL,'N','021','DEN','2174780','33348TX002000201','2014-02-01','2013-12-31 16:57:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:28:29'),(15251,12189,'Y','18','021','EC','A','','','AC','0000230443','0000230443','OH00001258908','IL','1','Coovert','Allen','','','','34','270542498','12367 State Route 224',0,'Attica','OH','44807',NULL,'CY','39147','1951-11-11','M','U',':RET:2106-3','N','021','HLT','1747448','92036OH003002705','2014-02-01','2013-12-30 11:06:29','483.00',NULL,NULL,'585.04','102.04','R-OH006','OH0','585.04',NULL,0,'2014-01-01 12:08:57'),(23570,18778,'Y','18','021','EC','A','','','AC','0000553960','0000553960','OH00002365007','IL','1','Glaze','Steven','M','','','34','278849517','108 W Harrison St',0,'Maumee','OH','43537',NULL,'CY','39095','1985-06-17','M','U',NULL,'N','021','HLT','3797088','92036OH003002605','2014-03-01','2014-02-13 11:06:52','114.00',NULL,NULL,'221.36','107.36','R-OH001','OH0','221.36',NULL,0,'2014-02-13 22:02:51'),(24974,19807,'Y','18','021','EC','A','','','AC','0000233332','0000233332','TX00002373965','IL','1','Magness','Shirley','','','','34','510708436','1511 Dogwood Drive',0,'Huntsville','TX','77340',NULL,'CY','48471','1967-10-17','F','M',':RET:2106-3','T','021','DEN','3721386','33348TX002000201','2014-04-01','2014-02-20 07:26:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 22:00:29'),(25015,19837,'Y','18','021','EC','A','','','AC','0001199554','0001199554','OH00003121287','IL','1','Camden','Miranda','','','','34','271784147','601 SUNCREST DR',0,'SPRINGFIELD','OH','45503','5308','CY','39023','1980-03-03','F','U',NULL,'N','021','DEN','2940508','99734OH005000301','2014-04-01','2014-02-20 14:58:14','0.00',NULL,NULL,'59.76','59.76','R-OH003','OH0','0.00',NULL,0,'2014-02-20 22:00:54'),(28697,22711,'Y','18','021','EC','A','','','AC','0001375473','0001375473','LA00003391068','IL','1','STAGGS','MARTY','','','','34','466558455','2026 KENTUCKY AVE',0,'KENNER','LA','70062','5943','CY','22051','1981-09-30','M','M',':RET:2106-3','N','021','DEN','3636907','18575LA002000101','2014-04-01','2014-03-08 14:58:48','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-03-08 21:31:07'),(28963,22923,'Y','18','021','EC','A','','','AC','0001664173','0001664173','LA00003361382','IL','1','TRAN','QUANG','VIET','','','34','433890821','1056 FAIRFAX DR',0,'GRETNA','LA','70056','8103','CY','22051','1982-08-10','M','U',':RET:2047-9','N','021','DEN','4102802','18575LA002000201','2014-04-01','2014-03-10 13:53:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:58'),(21273,17002,'Y','18','021','EC','A','','','AC','0000881661','0000881661','OH00001454499','IL','1','Loving','Elvie','','','','34','296508857','838 ARMSTRONG RD',0,'WOOSTER','OH','44691','9629','CY','39169','1952-09-01','M','M',':RET:2106-3','N','021','HLT','2821390','52664OH152000901','2014-03-01','2014-02-03 18:00:53','713.00',NULL,NULL,'875.18','162.18','R-OH014','OH0','458.99',NULL,0,'2014-02-03 21:01:32'),(7747,6136,'Y','18','024','14','A','','','TE','0001119947','0001119947','','IL','1','Bougie','Kristine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-27','F','',NULL,NULL,NULL,'','1473795','','2013-12-20','2013-12-20 16:08:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:26'),(7226,5728,'Y','18','021','EC','A','','','AC','0000584258','0000584258','OH00001138567','IL','1','Gaugh','Sarah','','','','34','287840931','304 Bailey Rd.',0,'Conneaut','OH','44030',NULL,'CY','39007','1986-05-19','F','U',':RET:2106-3','N','021','DEN','855417','99734OH005000401','2014-01-01','2013-12-14 15:49:00','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:01:15'),(16051,12853,'N','01','021','EC','A',NULL,NULL,'','0000630386','0001059484','','IL','1','McKinney','Alan','','','','34','279905827','8261 CHEVIOT RD',0,'CINCINNATI','OH','45247','3801','CY','39061','1984-05-29','M','',NULL,'N','021','DEN','2159439','99734OH005000401','2014-02-01','2014-01-02 21:36:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:03:12'),(6021,4765,'Y','18','021','EC','A','','','AC','0000134546','0000134546','OH00001074517','IL','1','Johnson','Theresa','','','','34','300503292','2277 US 50  box 520',0,'Owensville','OH','45103',NULL,'CY','39025','1950-12-05','F','U',':RET:2106-3','N','021','HLT','669639','92036OH005000606','2014-01-01','2013-12-01 10:33:04','525.00',NULL,NULL,'633.70','108.70','R-OH005','OH0','633.70',NULL,0,'2013-12-26 00:00:51'),(5746,4561,'N','01','021','EC','A',NULL,NULL,'','0001363786','0001528342','','IL','1','Nguyen','Myvan','','','','34','604211732','145 B AND G LOOP',0,'LEESVILLE','LA','71446','6434','CY','22115','1969-03-15','F','',':RET:2047-9','N','021','DEN','1616426','18575LA002000201','2014-01-01','2013-12-24 00:44:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:46:04'),(294,243,'Y','18','021','EC','A','','','AC','0001157523','0001157523','OH00001105269','IL','1','ross','bonnie','','','','34','287662504','9380 jericho dr',0,'cincinnati','OH','45231',NULL,'CY','39061','1960-11-17','F','U',':RET:2054-5','N','021','DEN','595195','99734OH005000401','2014-01-01','2013-11-13 10:58:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:30:38'),(15882,12718,'Y','18','021','EC','A','','','AC','0001203573','0001203573','LA00001440300','IL','1','Gafford','Gaines','','','','34','439471697','9465 MCADOO ST',0,'SHREVEPORT','LA','71118','3807','CY','22017','1969-07-08','M','M',NULL,'N','021','DEN','1541519','18575LA002000101','2014-02-01','2014-01-02 11:23:26','0.00',NULL,NULL,'50.04','50.04','R-LA008','LA0','25.02',NULL,0,'2014-01-03 02:05:27'),(22792,18196,'N','19','021','EC','A',NULL,NULL,'','0000247938','0000865909','','IL','1','Arthur','Joseph','Armanus','','','34','258915620','118 CASTLE DR',0,'KETTERING','OH','45429','1722','CY','39113','1994-08-17','M','',':RET:2106-3','N','021','DEN','2815543','99734OH005000301','2014-03-01','2014-02-11 12:10:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:50'),(24753,19642,'Y','18','021','EC','A','','','AC','0000934709','0000934709','OH00002902512','IL','1','KOMYATI','ANTOINETTE','M','','','34','287642324','1939 GLENWOOD DR',0,'TWINSBURG','OH','44087','1256','CY','39153','1956-11-16','F','M',':RET:2106-3','T','021','DEN','3264613','99734OH005000401','2014-04-01','2014-02-19 11:36:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-20 04:41:18'),(25068,19880,'N','01','021','EC','A',NULL,NULL,'','0000972791','0001207202','','IL','1','Holland','Amber','','','','34','299862412','1024 AUBURN ST',0,'MIDDLETOWN','OH','45042','2329','CY','39017','1979-10-09','F','',':RET:2106-3','T','021','DEN','3809828','99734OH005000401','2014-04-01','2014-02-20 14:55:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:01:28'),(28569,22608,'Y','18','021','EC','A','','','AC','0001216314','0001216314','OH00002621761','IL','1','Hitt','Penny','','','','34','281542325','405 RULF ST',0,'DEFIANCE','OH','43512','3061','CY','39039','1953-06-29','F','U',NULL,'N','021','HLT','3786760','92036OH001002601','2014-04-01','2014-03-07 15:12:28','366.00',NULL,NULL,'638.35','272.35','R-OH001','OH0','638.35',NULL,0,'2014-03-07 21:32:30'),(29187,23101,'Y','18','024','14','A','','','TE','0000815378','0000815378','','IL','1','Sebe','Paul',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-09-11','M','',NULL,NULL,NULL,'','3372930','','2014-03-10','2014-03-10 16:59:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-10 21:30:03'),(14179,11305,'Y','18','021','EC','A','','','AC','0000064347','0000064347','TX00000170815','IL','1','Barrett','James','','','','34','438330255','102 N TIMBERLANE',0,'LONE STAR','TX','75668','1900','CY','48343','1971-10-11','M','M',':RET:2106-3','T','021','DEN','1847887','33348TX002000201','2014-02-01','2013-12-26 09:58:06','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:40'),(13426,10710,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000181005','','IL','1','Mecklenborg','Jack','Lawrence',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2009-09-26','M','',NULL,'N','021','DEN','2321841','99734OH005000301','2014-01-01','2013-12-23 11:34:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:55'),(8154,6451,'Y','18','021','EC','A','','','AC','0000832665','0000832665','TX00001148015','IL','1','McCall','Lila','','','','34','461947700','PO Box 217',0,'Wimberley','TX','78676',NULL,'CY','48209','1951-08-16','F','U',':RET:2106-3','N','021','DEN','424190','33348TX002000201','2014-01-01','2013-11-22 15:04:55','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 03:16:08'),(4758,3773,'Y','18','021','EC','A','','','AC','0000243586','0000243586','TX00000714912','IL','1','hawe','timothy','','','','34','530902745','14910 chetland place drive',0,'houston','TX','77095',NULL,'CY','48201','1965-08-06','M','R',':RET:2106-3','N','021','DEN','1140432','33348TX002000101','2014-01-01','2013-12-08 11:32:25','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:15:27'),(2431,1980,'Y','18','021','EC','A','','','AC','0000656902','0000656902','OH00000777847','IL','1','Dicintio','Vincent','','','','34','293524043','1570 CONGRESS LAKE RD',0,'MOGADORE','OH','44260','1925','CY','39133','1952-05-07','M','M',':RET:2106-3','N','021','HLT','642860','52664OH151001301','2014-01-01','2013-12-08 20:52:12','744.00',NULL,NULL,'1284.97','540.97','R-OH012','OH0','626.65',NULL,0,'2013-12-25 19:34:11'),(2312,1879,'Y','18','021','EC','A','','','AC','0000932372','0000932372','TX00000165095','IL','1','MOORE','MARY','H','','','34','449929197','1059 COUNTY ROAD 2603',0,'SHELBYVILLE','TX','75973','2414','CY','48419','1949-11-04','F','U',':RET:2054-5','N','021','DEN','79064','33348TX002000201','2014-01-01','2013-12-08 19:35:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:12'),(25869,20510,'Y','18','021','EC','A','','','AC','0002102222','0002102222','LA00002811701','IL','1','Nguyen','Toan','','','','34','434694670','140 COMMERCE ST',0,'GRETNA','LA','70056','7030','CY','22051','1987-07-01','M','U',':RET:2047-9','N','021','DEN','3744495','18575LA002000201','2014-03-01','2014-02-26 15:36:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:49'),(27110,21457,'N','01','021','EC','A',NULL,NULL,'','0000044327','0000431431','','IL','1','Mendoza','Cristina','','','','34','360045897','207 Rosemarie Dr',0,'Lebanon','OH','45036',NULL,'CY','39165','1975-07-24','F','',NULL,'N','021','DEN','3005502','99734OH005000301','2014-04-01','2014-03-03 10:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:25'),(28719,22728,'Y','18','021','EC','A','','','AC','0000920886','0000920886','OH00003627630','IL','1','HAYNES','LORALYN','','','','34','310666312','4918 DEPOY ST',0,'DAYTON','OH','45424','1710','CY','39057','1956-11-15','F','M',':RET:2106-3','N','021','HLT','3308181','92036OH004000501','2014-04-01','2014-03-08 14:20:26','224.00',NULL,NULL,'465.80','241.80','R-OH003','OH0','465.80',NULL,0,'2014-03-08 21:31:19'),(17534,14019,'Y','18','021','EC','A','','','AC','0000844722','0000844722','OH00002048914','IL','1','Champlin','Robert','','','','34','270529762','7394 dawson Road',0,'Cincinnati','OH','45243',NULL,'CY','39061','1951-10-23','M','M',':RET:2106-3','N','021','HLT','1458436','92036OH005001205','2014-02-01','2014-01-12 10:44:39','949.00',NULL,NULL,'1219.98','270.98','R-OH004','OH0','616.74',NULL,0,'2014-01-13 03:01:44'),(16697,13362,'Y','18','021','EC','A','','','AC','0000514238','0000514238','TX00001964869','IL','1','Satcher','David','Lerone','','','34','411412704','1611 N EL PASO ST',0,'EL PASO','TX','79902','3440','CY','48141','1970-04-19','M','U',':RET:2054-5','N','021','DEN','2604596','33348TX002000201','2014-02-01','2014-01-07 14:33:00','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-08 18:24:37'),(16457,13170,'Y','18','021','EC','A','','','AC','0000227069','0000227069','OH00001400667','IL','1','Schackmann','Michael','','','','34','302881828','326 PALM SPRINGS DR',0,'FAIRFIELD','OH','45014','8638','CY','39017','1973-08-04','M','M',':RET:2106-3','N','021','HLT','2087598','92036OH003001205','2014-02-01','2014-01-06 10:06:33','323.00',NULL,NULL,'564.04','241.04','R-OH004','OH0','286.51',NULL,0,'2014-01-07 04:05:38'),(16228,12996,'Y','18','021','EC','A','','','AC','0000031952','0000031952','OH00001180571','IL','1','Gross','Jess','','','','34','282708098','34 KENMORE AVE',0,'BARBERTON','OH','44203','1236','CY','39153','1973-10-02','M','M',':RET:2106-3','N','021','HLT','2323260','52664OH151001305','2014-02-01','2014-01-03 20:34:45','386.00',NULL,NULL,'580.48','194.48','R-OH012','OH0','285.00',NULL,0,'2014-01-05 00:01:59'),(14690,11728,'N','01','021','EC','A',NULL,NULL,'','0000186121','0000953260','','IL','1','McKee','Janice','','','','34','301509696','4221 Perry Ridge Road',0,'Nelsonville','OH','45764',NULL,'CY','39009','1953-06-06','F','',':RET:2106-3','N','021','DEN','2255828','99734OH005000401','2014-02-01','2013-12-28 16:57:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:08:46'),(4001,3195,'N','01','021','EC','A',NULL,NULL,'','0000556704','0000505724','','IL','1','Vroman','Anna','Marie','','','34','294826627','537 CANVAS BACK CIR',0,'SPRINGDALE','OH','45246','1535','CY','39061','1985-01-13','F','',':RET:2106-3','N','021','DEN','1877331','99734OH005000401','2014-01-01','2013-12-16 19:04:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:12'),(5652,4484,'Y','18','021','EC','A','','','AC','0000452937','0000452937','TX00000750993','IL','1','Torres','Estela','','','','34','460450642','691 JEWEL DR',0,'SOCORRO','TX','79927','4536','CY','48141','1964-01-01','F','M',':RET:2106-3','N','021','DEN','387799','33348TX002000201','2014-01-01','2013-11-26 13:57:36','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:31:32'),(26917,21333,'Y','18','021','EC','A','','','AC','0000717877','0000717877','OH00003316363','IL','1','Estep','Geoffrey','','','','34','272786732','59 BEECHVIEW DR',0,'BROOKVILLE','OH','45309','9206','CY','39113','1972-11-10','M','M',':RET:2106-3','N','021','DEN','2656678','99734OH005000401','2014-04-01','2014-03-01 19:35:13','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-03 01:00:14'),(27764,21955,'Y','18','021','EC','A','','','AC','0001558838','0001558838','LA00002630987','IL','1','Gaspard','Glendora','','','','34','425379412','3922 Juno Drive',0,'Chalmette','LA','70043',NULL,'CY','22087','1967-03-23','F','U',':RET:2054-5','N','021','DEN','3921707','18575LA002000201','2014-04-01','2014-03-05 13:10:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:22'),(2738,2216,'Y','18','021','EC','A','','','AC','0000864790','0000864790','OH00000554849','IL','1','Elchert','Carol','','','','34','281528594','15094 Township Road 74',0,'Findlay','OH','45840',NULL,'CY','39063','1951-11-12','F','M',':RET:2106-3','N','021','HLT','433248','92036OH005001506','2014-01-01','2013-12-02 12:11:43','591.00',NULL,NULL,'632.30','41.30','R-OH002','OH0','632.30',NULL,0,'2013-12-25 19:48:42'),(21268,16997,'Y','18','024','14','A','','','TE','0000511344','0000511344','','IL','1','POKORNY','JULIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-01-23','F','',NULL,NULL,NULL,'','201593','','2014-02-03','2014-02-03 14:36:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:01:29'),(15191,12139,'N','01','021','EC','A',NULL,NULL,'','0000828241','0000421475','','IL','1','Hartney','Patricia','','','','34','292606137','1063 EAGLE DR',0,'AKRON','OH','44312','5859','CY','39153','1963-02-03','F','',':RET:2106-3','N','021','HLT','2427861','52664OH152000901','2014-02-01','2013-12-30 10:43:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.73',NULL,0,'2014-01-01 12:07:06'),(21266,16995,'Y','18','021','EC','A','','','AC','0001194306','0001194306','TX00002213453','IL','1','Lam','Oanh','','','','34','631346488','15015 MOSS BRIDGE LN',0,'SUGAR LAND','TX','77498','0934','CY','48157','1967-11-03','F','U',':RET:2047-9','N','021','DEN','2960372','33348TX002000101','2014-03-01','2014-02-03 11:44:50','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-03 21:01:27'),(24904,19744,'Y','18','021','EC','A','','','AC','0000544019','0000544019','TX00002824316','IL','1','Jeffreys','Glenna','','','','34','461374857','55  E Canyonview Dr.',0,'Ransom Canyon','TX','79366',NULL,'CY','48303','1962-12-02','F','M',':RET:2106-3','N','021','DEN','3330744','33348TX002000201','2014-04-01','2014-02-19 21:11:44','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61','CIC',0,'2014-02-20 21:30:03'),(27775,21965,'Y','18','021','EC','A','','','AC','0000625487','0000625487','OH00003447513','IL','1','Ferguson','Beth','Teschan','','','34','297702421','957 WINTON AVE',0,'AKRON','OH','44320','2847','CY','39153','1974-05-03','F','U',':RET:2054-5','N','021','HLT','2916895','52664OH152000901','2014-04-01','2014-03-04 23:45:41','0.00',NULL,NULL,'206.14','206.14','R-OH012','OH0','206.14',NULL,0,'2014-03-05 21:31:29'),(25643,20342,'N','01','021','EC','A',NULL,NULL,'','0000055977','0000224768','','IL','1','Blue','Jacque','','','','34','272564066','18592 EDWARDS RD',0,'DOYLESTOWN','OH','44230','9546','CY','39169','1952-09-12','F','',NULL,'N','021','HLT','3069700','52664OH151001301','2014-04-01','2014-02-21 18:38:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-02-26 08:30:32'),(21800,17410,'Y','18','021','EC','A','','','AC','0001118758','0001118758','OH00001681783','IL','1','Brandt','Rebecca','','','','34','342482612','18400 STATE RD',0,'VAN WERT','OH','45891','8842','CY','39161','1953-11-26','F','M',':RET:2106-3','N','021','HLT','3694182','92036OH004001501','2014-03-01','2014-02-06 15:21:33','420.00',NULL,NULL,'480.28','60.28','R-OH002','OH0','480.28',NULL,0,'2014-02-06 21:00:49'),(8066,6387,'Y','18','024','14','A','','','TE','0000047080','0000047080','','IL','1','COOK','RORY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-02-15','M','',NULL,NULL,NULL,'','1633121','','2013-12-20','2013-12-20 09:13:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:05'),(21177,16924,'N','19','021','EC','A',NULL,NULL,'','0000932135','0000646034','','IL','1','McGee','Christopher','','','','34','273969001','1965 N GARDEN CT',0,'AKRON','OH','44312','1946','CY','39153','1992-12-17','M','',':RET:2106-3','T','021','DEN','3340564','99734OH005000401','2014-03-01','2014-02-03 16:40:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:41'),(18672,14885,'Y','18','021','EC','A','','','AC','0000210559','0000210559','TX00001620395','IL','1','Curry','Gloria','','','','34','461198192','2202 W ACADIA ST',0,'HARLINGEN','TX','78552','7471','CY','48061','1957-12-01','F','U',NULL,'N','021','DEN','1708911','33348TX002000201','2014-02-01','2014-01-15 19:14:16','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-17 03:35:17'),(25903,20538,'N','01','021','EC','A',NULL,NULL,'','0000805910','0000298921','','IL','1','SANTOS','REI','R','','','34','628314493','2813 E NOPAL DR',0,'EDINBURG','TX','78542','0576','CY','48215','1986-12-28','M','',':RET:2036-2','N','021','DEN','3443411','33348TX002000201','2014-04-01','2014-02-26 13:45:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:09'),(23296,18571,'Y','18','021','EC','A','','','AC','0000626779','0000626779','OH00001379687','IL','1','Snyder','Jeffrey','','','','34','280809833','2213 HIGH ST',0,'PORTSMOUTH','OH','45662','3213','CY','39145','1967-04-25','M','U',':RET:2106-3','N','021','DEN','3201461','99734OH005000301','2014-03-01','2014-02-12 23:39:59','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-13 22:00:10'),(23049,18376,'Y','18','024','14','A','','','TE','0001044259','0001044259','','IL','1','MATHIS','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-27','F','',NULL,NULL,NULL,'','2983713','','2014-02-12','2014-02-12 16:13:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-12 21:30:44'),(1611,1346,'Y','18','021','EC','A','','','AC','0000920150','0000920150','TX00001588257','IL','1','Harrison','Alissa','','','','34','509969084','5826 PICASSO PL',0,'HOUSTON','TX','77096','3913','CY','48201','1983-09-15','F','U',':RET:2106-3','N','021','DEN','2453131','33348TX002000201','2014-01-01','2013-12-24 13:07:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:52:18'),(2434,1982,'Y','18','021','EC','A','','','AC','0000706170','0000706170','OH00000320176','IL','1','Davidson','Cary','A','','','34','285766870','520 Massillon Rd',0,'Akron','OH','44306',NULL,'CY','39153','1965-02-22','M','U',':RET:2106-3','N','021','HLT','343150','52664OH151001301','2014-01-01','2013-12-09 11:37:26','107.00',NULL,NULL,'364.62','257.62','R-OH012','OH0','364.62',NULL,0,'2013-12-25 19:34:15'),(22900,18254,'Y','18','021','EC','A','','','AC','0000262767','0000262767','OH00002128831','IL','1','SAMPLE','ROBIN','','','','34','505027007','1908 FRAIL RD',0,'LIMA','OH','45806','1741','CY','39003','1966-06-24','F','R',':RET:2106-3','N','021','HLT','3010580','92036OH003001501','2014-03-01','2014-02-11 10:38:24','0.00',NULL,NULL,'359.24','359.24','R-OH002','OH0','359.24',NULL,0,'2014-02-11 21:02:41'),(21472,17159,'Y','18','024','14','A','','','TE','0001053065','0001053065','','IL','1','courtney','justin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-07-18','M','',NULL,NULL,NULL,'','1576205','','2014-02-19','2014-02-04 09:49:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-04 21:01:39'),(19683,15686,'Y','18','021','EC','A','','','AC','0001197803','0001197803','TX00002594550','IL','1','Ceasar','Stephanie','','','','34','465437938','306 South Colorado',0,'Edna','TX','77957',NULL,'CY','48239','1978-07-12','F','U',NULL,'N','021','DEN','1787958','33348TX002000201','2014-03-01','2014-01-23 10:24:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:39'),(15065,12043,'Y','18','021','EC','A','','','AC','0001334122','0001334122','LA00001650381','IL','1','Harvey','Eddie','','','','34','433178916','7041 E. Tamaron Blvd.',0,'New Orleans','LA','70128',NULL,'CY','22071','1970-09-21','M','M',':RET:2054-5','N','021','DEN','1536040','18575LA002000201','2014-02-01','2013-12-30 16:48:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:03:43'),(16890,13515,'Y','18','021','EC','A','','','AC','0000215980','0000215980','TX00002139795','IL','1','Hickman','Ashley','','','','34','444869380','4700 S. Ridge Rd.',0,'McKinney','TX','75070',NULL,'CY','48085','1983-06-27','F','U',':RET:2106-3','T','021','DEN','1862088','33348TX002000201','2014-02-01','2014-01-09 15:47:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:19:27'),(19210,15305,'Y','18','021','EC','A','','','AC','0000720274','0000720274','OH00002120550','IL','1','Smith','Patrick','','','','34','281743510','5607 LONGRIFLE RD',0,'WESTERVILLE','OH','43081','5214','CY','39049','1965-01-29','M','U',':RET:2106-3','N','021','DEN','1449976','99734OH005000401','2014-03-01','2014-01-20 09:41:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:46:21'),(18975,15120,'Y','18','021','EC','A','','','AC','0000968239','0000968239','OH00002509577','31','1','Hummer','Michael',NULL,NULL,NULL,NULL,NULL,'PO Box 6584',0,'Columbus','OH','43206',NULL,'CY','39049','1949-05-10','M','U',':RET:2106-3','N','021','DEN','1750843','99734OH005000301','2014-03-01','2014-01-17 05:09:48','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-20 08:06:04'),(28005,22160,'Y','18','021','EC','A','','','AC','0000609600','0000609600','OH00003055149','IL','1','Ruffner','Jasmine','Rose','','','34','281920974','4303 GREEN ARBORS LN',0,'CINCINNATI','OH','45249','8007','CY','39165','1990-04-23','F','U',':RET:2054-5','N','021','DEN','3976552','99734OH005000401','2014-04-01','2014-03-06 06:05:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:11'),(28212,22324,'N','19','021','EC','A',NULL,NULL,'','0001062169','0000552669','','IL','1','Gonzales','Lucien','','','','34','012259573','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','2013-07-25','M','',NULL,'N','021','HLT','4072223','52664OH151001304','2014-04-01','2014-03-06 12:51:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-03-06 21:30:14'),(28855,22834,'Y','18','024','14','A','','','TE','0000566664','0000566664','','IL','1','Stevens','Camaree',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-11-11','F','',NULL,NULL,NULL,'','2933610','','2014-03-08','2014-03-09 16:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-09 21:01:21'),(209,174,'Y','18','021','EC','A','','','AC','0000006363','0000006363','LA00000015415','IL','1','Ross','Mariea','','','','34','433495351','5124 HICKORY RIDGE BLVD',0,'BATON ROUGE','LA','70817','2050','CY','22033','1983-01-04','F','U',':RET:2054-5','N','021','DEN','694819','18575LA002000201','2014-01-01','2013-12-04 21:18:45','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:24'),(16924,13543,'N','01','021','EC','A',NULL,NULL,'','0002256543','0002372350','','IL','1','Dao','Hong','Anh','','','34','692582814','1071 ROBERT BLVD',0,'SLIDELL','LA','70458','2048','CY','22103','1985-10-21','F','',NULL,'N','021','DEN','2441487','18575LA002000201','2014-02-01','2014-01-08 18:40:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:19:45'),(1554,1297,'Y','18','021','EC','A','','','AC','0001180714','0001180714','MS00001618638','IL','1','JONES','LINDA','D','','','34','427080513','207 SANDY CREEK RD',0,'OVETT','MS','39464','3609','CY','28067','1957-02-22','F','U',NULL,'T','021','DEN','1672741','46300MS002000201','2014-01-01','2013-12-24 14:01:34','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:50:42'),(16674,13344,'Y','18','021','EC','A','','','AC','0000650794','0000650794','OH00001611903','IL','1','Franz','Brent','','','','34','335787065','117 S Enterprise St',0,'Celina','OH','45822',NULL,'CY','39107','1981-10-12','M','U',':RET:2106-3','N','021','DEN','1813867','99734OH005000301','2014-02-01','2014-01-07 11:52:50','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-08 18:24:29'),(15477,12381,'Y','18','024','14','A','','','TE','0000996536','0000996536','','IL','1','Reeves','Kristiana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-19','F','',NULL,NULL,NULL,'','1708467','','2013-12-30','2013-12-30 20:26:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:01'),(13668,10906,'Y','18','021','EC','A','','','AC','0001675230','0001675230','LA00001152197','IL','1','Nissel','Laura','','','','34','439156257','3820 North Woodlawn Ave',0,'Metairie','LA','70006',NULL,'CY','22051','1958-11-16','F','U',':RET:2106-3','N','021','DEN','2413978','18575LA002000101','2014-01-01','2013-12-23 15:34:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:50'),(9582,7587,'N','01','021','EC','A',NULL,NULL,'','0000089814','0000561666','','IL','1','tadros','nelson','','','','34','333743521','6535 DOROTHYS CRK',0,'CANAL WINCHESTER','OH','43110','8097','CY','39049','1981-07-14','M','',':RET:2106-3','N','021','DEN','1835142','99734OH005000301','2014-01-01','2013-12-21 17:53:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:55'),(13082,10429,'Y','18','021','EC','A','','','AC','0001192673','0001192673','OH00000975416','IL','1','BONARRIGO','JACQUELINE','','','','34','273501817','186 TIMBER TRL',0,'MEDINA','OH','44256','3303','CY','39103','1949-07-04','F','M',':RET:2106-3','N','021','DEN','1657806','99734OH005000401','2014-01-01','2013-12-23 11:06:42','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:51:36'),(23874,18997,'N','19','021','EC','A',NULL,NULL,'','0001066019','0001034707','','IL','1','Simmons','Alexandra',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1994-07-11','F','',NULL,'N','021','HLT','3387705','52664OH151001501','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-02-14 21:32:12'),(25345,20110,'Y','18','021','EC','A','','','AC','0000350623','0000350623','OH00002024536','IL','1','Purtty','Jamey','','','','34','302827724','540 E 124TH ST',0,'CLEVELAND','OH','44108','1809','CY','39035','1985-06-08','F','U',':RET:2054-5','N','021','HLT','3254875','52664OH152001001','2014-04-01','2014-02-24 18:34:13','0.00',NULL,NULL,'150.31','150.31','R-OH011','OH0','150.31',NULL,0,'2014-02-25 21:30:27'),(26686,21157,'Y','18','021','EC','A','','','AC','0002190935','0002190935','LA00003067745','IL','1','HARDMAN','VICTORIA','M','','','34','433559883','106 PARK WEST DRIVE',0,'WEST MONROE','LA','71291',NULL,'CY','22073','1984-04-09','F','U',NULL,'N','021','DEN','3622293','18575LA002000101','2014-04-01','2014-02-27 18:50:17','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-28 21:31:26'),(18857,15019,'Y','18','021','EC','A','','','AC','0001985970','0001985970','LA00002427851','IL','1','Thompson','Jerrydean','','','','34','434193319','3100 Rue Parc Fontaine Apt.  2126',0,'New Orleans','LA','70131',NULL,'CY','22071','1970-02-24','F','U',':RET:2054-5','N','021','DEN','2444002','18575LA002000201','2014-02-01','2014-01-15 22:14:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:18'),(18770,14954,'Y','18','021','EC','A','','','AC','0000239712','0000239712','TX00001361141','IL','1','SHERER','ROBIN','','','','34','319501890','515 PINE RD',0,'CLEAR LAKE SHORES','TX','77565','2422','CY','48167','1958-10-08','M','M',NULL,'N','021','DEN','3021306','33348TX002000101','2014-02-01','2014-01-15 19:41:05','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:50'),(17216,13777,'Y','18','021','EC','A','','','AC','0000808946','0000808946','MS00002049876','IL','1','Jones','Racheal','','','','34','587343297','35 SCR 101A',0,'LOUIN','MS','39338','5040','CY','28129','1951-02-15','F','U',':RET:2054-5','N','021','DEN','1561870','46300MS002000201','2014-02-01','2014-01-08 10:39:01','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-13 02:22:31'),(15112,12079,'Y','18','021','EC','A','','','AC','0000744408','0000744408','OH00001797599','IL','1','Lingafelter','Ruth','','','','34','287588571','3331 WINDING CREEK DR',0,'COLUMBUS','OH','43223','3561','CY','39049','1954-05-26','F','U',':RET:2106-3','N','021','DEN','1549390','99734OH005000301','2014-02-01','2013-12-30 13:29:04','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:04:59'),(13663,10901,'Y','18','021','EC','A','','','AC','0001514048','0001514048','LA00000815949','IL','1','Sterling','Tomika','','','','34','229497171','2245 BROADWAY AVE',0,'HARVEY','LA','70058','3221','CY','22051','1988-07-08','F','U',':RET:2054-5','T','021','DEN','2262408','18575LA002000101','2014-01-01','2013-12-23 11:28:08','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:40'),(26827,21262,'Y','18','021','EC','A','','','AC','0000716399','0000716399','OH00002606374','IL','1','COLEY','XAVIER','','','','34','267573931','295 EAST 156 DOWN SOUTH',0,'CLEVLEND','OH','44110',NULL,'CY','39035','1971-08-17','M','U',NULL,'T','021','DEN','3712660','99734OH005000401','2014-04-01','2014-03-01 14:26:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:38'),(28222,22330,'Y','18','024','14','A','','','TE','0000115550','0000115550','','IL','1','habli','yara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2006-08-28','F','',NULL,NULL,NULL,'','3477411','','2014-03-31','2014-03-06 15:30:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-06 21:30:19'),(492,402,'Y','18','021','EC','A','','','AC','0000071587','0000071587','LA00000422987','31','1','JOHNSON','SHAWN','','','','34','436335616','PO BOX 1142',0,'MARRERO','LA','70073',NULL,'CY','22051','1976-11-12','M','U',':RET:2054-5','N','021','DEN','105347','18575LA002000201','2014-01-01','2013-12-04 13:48:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:26'),(23395,18643,'N','01','021','EC','A',NULL,NULL,'','0000766018','0000086469','','IL','1','Cress','John','F','','','34','270543314','200 Maple St.',0,'Sugar Grove','OH','43155',NULL,'CY','39045','1953-08-03','M','',':RET:2106-3','N','021','DEN','3593617','99734OH005000401','2014-03-01','2014-02-13 15:40:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:08'),(937,775,'Y','18','021','EC','A','','','AC','0000860936','0000860936','OH00000195790','IL','1','Bashor','Harold','','','','34','268485568','100 E GAY ST',0,'COLUMBUS','OH','43215','3248','CY','39049','1951-02-06','M','U',':RET:2106-3','N','021','DEN','439589','99734OH005000401','2014-01-01','2013-10-31 12:32:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:09:13'),(2710,2192,'N','01','021','EC','A',NULL,NULL,'','0000655790','0000243704','','IL','1','Toth','Robin','l',NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1964-08-18','F','',':RET:2106-3','N','021','HLT','428018','52664OH151001501','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','456.30',NULL,0,'2013-12-25 19:47:56'),(22181,17702,'Y','18','024','14','A','','','TE','0000830375','0000830375','','IL','1','VASQUES','TOMMIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-09-22','F','',NULL,NULL,NULL,'','2483193','','2014-02-28','2014-02-08 18:12:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-09 19:00:03'),(4903,3888,'Y','18','021','EC','A','','','AC','0000165035','0000165035','OH00000740517','IL','1','Miles','Julie','','','','34','295880654','9878 Creekside Way',0,'Streetsboro','OH','44241',NULL,'CY','39133','1983-09-20','F','U',':RET:2106-3','N','021','DEN','40625','99734OH005000401','2014-01-01','2013-10-26 11:25:27','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:31:50'),(21892,17481,'Y','18','021','EC','A','','','AC','0000235393','0000235393','MS00002136355','IL','1','Polk','Darald','','','','34','426133037','5929 FLORAL DR',0,'JACKSON','MS','39206','2413','CY','28049','1977-04-28','M','U',NULL,'N','021','DEN','3485779','46300MS002000201','2014-03-01','2014-02-05 20:30:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-06 21:01:39'),(17287,13825,'Y','18','021','EC','A','','','AC','0000936608','0000936608','TX00001754665','31','1','CHAVEZ','ANA','','','','34','644502782','PO BOX 230118',0,'HOUSTON','TX','77223',NULL,'CY','48201','1964-09-24','F','U',NULL,'N','021','DEN','1685291','33348TX002000201','2014-02-01','2014-01-09 19:48:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:23:30'),(17114,13697,'Y','18','024','14','A','','','TE','0000538283','0000538283','','IL','1','Neiman','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-04','M','',NULL,NULL,NULL,'','1677372','','2014-01-07','2014-01-07 21:50:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:21:39'),(13937,11117,'Y','18','021','EC','A','','','AC','0001008945','0001008945','OH00000774735','IL','1','Maurer','James','','','','34','380864451','14015 SHERMAN WHITE RD',0,'SWANTON','OH','43558','9112','CY','39095','1964-03-04','M','M',':RET:2106-3','N','021','HLT','1879201','92036OH004002601','2014-01-01','2013-12-23 17:27:02','351.00',NULL,NULL,'627.43','276.43','R-OH001','OH0','267.49',NULL,0,'2013-12-26 13:14:40'),(27334,21644,'Y','18','021','EC','A','','','AC','0000481137','0000481137','OH00003474458','IL','1','Tochtermann','Eric','','','','34','283464501','5828 TREE MOSS LN',0,'NORTH RIDGEVILLE','OH','44039','2558','CY','39093','1956-03-29','M','U',':RET:2106-3','N','021','DEN','2731104','99734OH005000401','2014-04-01','2014-03-03 23:11:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:00:54'),(28665,22683,'Y','18','021','EC','A','','','AC','0002251366','0002251366','LA00002737089','IL','1','Rogers','Lisa','','','','34','434655080','4737 CARTHAGE ST',0,'METAIRIE','LA','70002','1410','CY','22051','1971-12-06','F','U',':RET:2106-3','N','021','DEN','4278512','18575LA002000201','2014-04-01','2014-03-08 12:44:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:45'),(21991,17562,'Y','18','021','EC','A','','','AC','0001377708','0001377708','LA00001924995','IL','1','LeBlanc','Thomas','','','','34','433577035','519 JENA ST',0,'NEW ORLEANS','LA','70115','1529','CY','22071','1984-10-12','M','U',':RET:2106-3','N','021','DEN','3336866','18575LA002000201','2014-03-01','2014-02-06 22:35:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-07 19:00:42'),(21131,16886,'Y','18','021','EC','A','','','AC','0000008928','0000008928','TX00001862690','IL','1','Kline','Gayle','','','','34','454115884','502 EAST ST',0,'GRAHAM','TX','76450','3118','CY','48503','1958-06-30','F','U',':RET:2106-3','N','021','DEN','2983519','33348TX002000201','2014-03-01','2014-02-03 15:20:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:18'),(19036,15161,'Y','18','021','EC','A','','','AC','0001157013','0001157013','MS00001970100','IL','1','FLOWERS','SONYA','CLAUDETTE',NULL,NULL,NULL,NULL,'1921 BARRETT AVE',0,'JACKSON','MS','39204','2317','CY','28049','1966-10-29','F','U',':RET:2054-5','N','021','DEN','2349898','46300MS002000201','2014-03-01','2014-01-17 12:13:11','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-20 08:06:34'),(18588,14820,'N','19','021','EC','A',NULL,NULL,'','0000199678','0000305834','','IL','1','BIESENBENDER','CLAUDIA','RENEE','','','34','300029152','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1998-06-28','F','',':RET:2106-3','N','021','HLT','1654416','92036OH002000601','2014-02-01','2014-01-15 02:13:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-16 08:47:12'),(18106,14462,'Y','18','021','EC','A','','','AC','0001347690','0001347690','LA00001704168','IL','1','Giglio','Anthony','','','','34','436539990','115 Mireille Lane',0,'Raceland','LA','70394',NULL,'CY','22057','1969-04-28','M','U',':RET:2106-3','T','021','DEN','2755629','18575LA002000201','2014-02-01','2014-01-14 17:04:02','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-15 02:07:35'),(5263,4174,'Y','18','021','EC','A','','','AC','0000672747','0000672747','OH00000081704','IL','1','Sullivan','Bartholomew','','','','34','269828832','1776 24th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1983-10-07','M','U',':RET:2106-3','N','021','HLT','1581847','52664OH151001305','2014-01-01','2013-12-19 11:18:55','135.00',NULL,NULL,'253.11','118.11','R-OH012','OH0','253.11',NULL,0,'2013-12-25 23:05:24'),(15897,12729,'N','01','021','EC','A',NULL,NULL,'','0000266537','0000597313','','IL','1','Geith','Rosemary','','','','34','286589748','3486 WATKINS RD',0,'MEDINA','OH','44256','8327','CY','39103','1955-09-15','F','',':RET:2106-3','N','021','HLT','2198960','52664OH152000901','2014-02-01','2014-01-02 17:00:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.19',NULL,0,'2014-01-03 02:05:56'),(2739,2217,'Y','18','021','EC','A','','','AC','0000700353','0000700353','OH00000233782','IL','1','ROBINSON','LORETTA','M','','','34','281587211','1728 14TH ST',0,'CUYAHOGA FALLS','OH','44223','2337','CY','39153','1953-10-29','F','U',':RET:2106-3','N','021','HLT','907402','52664OH152000901','2014-01-01','2013-12-01 20:03:23','373.00',NULL,NULL,'443.31','70.31','R-OH012','OH0','443.31',NULL,0,'2013-12-25 19:48:44'),(15331,12262,'N','01','021','EC','A',NULL,NULL,'','0000007457','0000704899','','IL','1','juarez','rosamaria','','','','34','629142337','9920 GENIE DR',0,'EL PASO','TX','79924','5016','CY','48141','1966-12-12','F','',':RET:2106-3','T','021','DEN','2325787','33348TX002000201','2014-02-01','2014-01-01 15:01:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:23:55'),(2961,2384,'Y','18','021','EC','A','','','AC','0000933848','0000933848','TX00000660415','IL','1','TOON','EUGENIA','','','','34','455787326','1022 COUNTY ROAD 325',0,'CLEVELAND','TX','77327',NULL,'CY','48291','1959-03-02','F','M',':RET:2106-3','N','021','DEN','532314','33348TX002000201','2014-01-01','2013-12-06 17:18:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:16:45'),(26691,21162,'Y','18','021','EC','A','','','AC','0001262234','0001262234','LA00002728036','IL','1','Canizales','Linda','','','','34','455986627','1614 JUNIPER DR',0,'SHREVEPORT','LA','71118','2214','CY','22017','1960-09-30','F','M',':RET:2106-3','N','021','DEN','3758620','18575LA002000101','2014-04-01','2014-02-28 00:15:01','0.00',NULL,NULL,'100.08','100.08','R-LA008','LA0','25.02',NULL,0,'2014-02-28 21:31:29'),(7195,5702,'Y','18','021','EC','A','','','AC','0000707600','0000707600','OH00000033567','IL','1','bregar','mark','','','','34','289927487','335 w. salem st',0,'columbiana','OH','44408',NULL,'CY','39029','1988-03-14','M','M',':RET:2106-3','T','021','DEN','661106','99734OH005000301','2014-01-01','2013-12-14 16:30:01','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:00:31'),(16485,13192,'N','19','021','EC','A',NULL,NULL,'','0000209652','0001241877','','IL','1','BADER','EMILY','','','','34','291080712','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','2003-12-01','F','',NULL,'N','021','HLT','2166183','92036OH004000801','2014-02-01','2014-01-06 14:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.38',NULL,0,'2014-01-07 04:06:23'),(2188,1800,'Y','18','024','14','A','','','TE','0001038568','0001038568','','IL','1','HILLIARD','DIANA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-17','F','',NULL,NULL,NULL,'','815893','','2013-12-10','2013-12-10 08:36:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:19:40'),(8931,7080,'Y','18','021','EC','A','','','AC','0000253036','0000253036','OH00000103393','IL','1','WEBER','GREGORY','','','','34','289442713','4391 LUNAR DR',0,'STOW','OH','44224',NULL,'CY','39153','1950-08-09','M','M',NULL,'N','021','DEN','1984637','99734OH005000401','2014-01-01','2013-12-18 09:54:40','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:03:01'),(9007,7146,'N','01','021','EC','A',NULL,NULL,'','0000449855','0000780496','','IL','1','YOUNGBLOOD','JANICE','','','','34','273588554','4242 S HAMETOWN RD',0,'NORTON','OH','44203','5446','CY','39153','1954-01-08','F','',':RET:2106-3','N','021','HLT','1429101','52664OH152000901','2014-01-01','2013-12-18 11:49:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','425.18',NULL,0,'2013-12-26 04:05:00'),(20020,15966,'N','01','021','EC','A',NULL,NULL,'','0001190381','0000247051','','IL','1','MEDRANO','ORTENCIA','Q','','','34','461839500','506 S WALNUT ST',0,'PECOS','TX','79772','4128','CY','48389','1954-12-15','F','',NULL,'N','021','DEN','1937257','33348TX002000201','2014-03-01','2014-01-26 15:54:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-26 19:00:14'),(21397,17099,'Y','18','021','EC','A','','','AC','0000411157','0000411157','OH00001461613','IL','1','PAPKAR','PADMAJA','','','','34','286767821','8090 CLEARMEADOW DRIVE',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','1957-02-04','F','M',':RET:2029-7','N','021','DEN','2914860','99734OH005000401','2014-03-01','2014-02-04 12:07:54','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:00'),(21441,17137,'Y','18','021','EC','A','','','AC','0000105658','0000105658','MS00002114469','IL','1','Thompson','Jesse','','','','34','212889347','1154 NORTHSIDE DR',0,'PORT GIBSON','MS','39150','4241','CY','28021','1962-05-01','M','U',':RET:2054-5','N','021','DEN','2750538','46300MS002000101','2014-03-01','2014-02-04 14:39:41','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-04 21:01:24'),(22035,17589,'Y','18','021','EC','A','','','AC','0000718953','0000718953','OH00002441448','IL','1','Sharp','Sherry','','','','34','299541820','120 EMERY ST',0,'TOLEDO','OH','43609','2023','CY','39095','1967-11-23','F','U',':RET:2106-3','N','021','HLT','3386454','92036OH003002606','2014-03-01','2014-02-07 15:39:47','230.00',NULL,NULL,'305.45','75.45','R-OH001','OH0','305.45',NULL,0,'2014-02-07 19:01:05'),(27437,21714,'Y','18','021','EC','A','','','AC','0001891969','0001891969','LA00002833496','IL','1','andrich','edith','a','','','34','412020623','431 VALLETTE ST',0,'NEW ORLEANS','LA','70114','1151','CY','22071','1955-11-16','F','U',':RET:2106-3','N','021','DEN','2676163','18575LA002000201','2014-04-01','2014-03-04 14:34:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:50'),(27844,22024,'Y','18','021','EC','A','','','AC','0000315634','0000315634','TX00003488499','31','1','PEREZ','MARIBEL','','','','34','453839186','PO BOX',0,'LA BLANCA','TX','78558',NULL,'CY','48215','1966-08-13','F','M',NULL,'N','021','DEN','4096392','33348TX002000101','2014-04-01','2014-03-05 12:52:05','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-03-05 21:32:09'),(29050,22992,'Y','18','021','EC','A','','','AC','0001228131','0001228131','OH00003096712','IL','1','heart','theresa','','','','34','282648065','1811 WOODLAWN AVE',0,'MIDDLETOWN','OH','45044','4527','CY','39017','1959-05-26','F','M',':RET:2054-5','T','021','DEN','4285870','99734OH005000401','2014-04-01','2014-03-10 14:25:03','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:45'),(19453,15505,'Y','18','021','EC','A','','','AC','0000634841','0000634841','OH00002182271','IL','1','Hussong','Tiffany','','','','34','279723608','1375 LUNBECK RD',0,'CHILLICOTHE','OH','45601','8751','CY','39141','1974-01-26','F','U',':RET:2106-3','N','021','DEN','2500264','99734OH005000301','2014-03-01','2014-01-22 15:03:26','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-23 03:01:53'),(615,507,'Y','18','021','EC','A','','','AC','0000005817','0000005817','OH00000822862','IL','1','MINTON','ROBERT','JOE','','','34','296487658','1190 GIBSON RD',0,'MARTINSVILLE','OH','45146','9517','CY','39027','1949-11-14','M','M',':RET:2106-3','N','021','DEN','2245086','99734OH005000401','2014-01-01','2013-12-16 10:53:35','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:00:42'),(19328,15407,'Y','18','021','EC','A','','','AC','0000697124','0000697124','TX00001394517','IL','1','Keating','Mike','','','','34','523785968','6318 RICHMOND AVE',0,'DALLAS','TX','75214','3681','CY','48113','1961-04-14','M','U',NULL,'N','021','DEN','3154724','33348TX002000201','2014-03-01','2014-01-21 14:38:02','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:14'),(6527,5176,'Y','18','021','EC','A','','','AC','0000222380','0000222380','OH00001017083','IL','1','Heffner','George','','','','34','296846942','732 ELM AVE',0,'TERRACE PARK','OH','45174','1262','CY','39061','1985-10-28','M','R',':RET:2106-3','N','021','HLT','1196017','92036OH002001201','2014-01-01','2013-12-11 15:35:01','0.00',NULL,NULL,'720.19','720.19','R-OH004','OH0','269.48',NULL,0,'2013-12-26 00:51:36'),(7381,5845,'Y','18','021','EC','A','','','AC','0001233017','0001233017','OH00000340311','IL','1','Cameron','Christopher','','','','34','299769943','735 AMBERLY DR',0,'HAMILTON','OH','45013','3458','CY','39017','1974-02-23','M','U',':RET:2106-3','N','021','DEN','914454','99734OH005000401','2014-01-01','2013-11-23 10:53:43','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:15:56'),(3640,2912,'Y','18','021','EC','A','','','AC','0000227767','0000227767','MS00001197883','IL','1','medina','Deborah','jean','','','34','427239661','1249 MARYDALE DR',0,'JACKSON','MS','39212','2725','CY','28049','1959-12-16','F','U',':RET:2106-3','N','021','DEN','15781','46300MS002000201','2014-01-01','2013-12-13 12:39:39','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:20'),(7385,5846,'Y','18','021','EC','A','','','AC','0000029007','0000029007','OH00000255251','IL','1','Frenton','Richard','','','','34','279563149','514 BRENTWOOD DR',0,'NEWARK','OH','43055','9707','CY','39089','1954-09-08','M','M',':RET:2106-3','N','021','DEN','1030460','99734OH005000401','2014-01-01','2013-11-23 14:23:10','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:16:00'),(24406,19386,'N','01','021','EC','A',NULL,NULL,'','0000950722','0000021434','','IL','1','Miller','Timothy','','','','34','286867277','11700 ALPINE HWY',0,'FRAZEYSBURG','OH','43822',NULL,'CY','39119','1978-08-04','M','',NULL,'N','021','DEN','3296924','99734OH005000401','2014-04-01','2014-02-18 16:41:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:58'),(24721,19627,'N','01','021','EC','A',NULL,NULL,'','0000467141','0000298280','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:37:50'),(26968,21366,'Y','18','021','EC','A','','','AC','0000226169','0000226169','TX00002837063','IL','1','GHIRONTE','IONEL','','','','34','453735698','504 Colesher St',0,'McKinney','TX','75069',NULL,'CY','48085','1965-05-08','M','M',':RET:2106-3','T','021','DEN','2978031','33348TX002000101','2014-04-01','2014-03-01 23:23:14','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-03-03 01:00:33'),(28851,22831,'Y','18','021','EC','A','','','AC','0000715030','0000715030','OH00003470661','IL','1','PETERSON','DENNIS','P','','','34','476526714','05009 County Road 33 A',0,'Saint Marys','OH','45885',NULL,'CY','39011','1950-12-17','M','M',':RET:2106-3','N','021','HLT','3157209','92036OH005001504','2014-04-01','2014-03-09 15:14:02','995.00',NULL,NULL,'1222.57','227.57','R-OH002','OH0','649.68',NULL,0,'2014-03-09 21:01:19'),(18773,14956,'Y','18','021','EC','A','','','AC','0000794535','0000794535','OH00001403280','IL','1','Siebert','Jennifer','','','','34','277829901','13391 WARDLOW RD',0,'SARDINIA','OH','45171','9706','CY','39015','1972-03-01','F','M',':RET:2106-3','N','021','HLT','2984581','92036OH004000601','2014-02-01','2014-01-15 18:35:55','390.00',NULL,NULL,'661.79','271.79','R-OH005','OH0','224.74',NULL,0,'2014-01-17 03:35:51'),(13708,10937,'Y','18','021','EC','A','','','AC','0000868231','0000868231','OH00001060740','IL','1','Hill','Micheal','','','','34','365528774','4333 CANFIELD RD',0,'CANFIELD','OH','44406','9377','CY','39099','1949-02-03','M','U',':RET:2106-3','N','021','HLT','1601811','52664OH151001306','2014-01-01','2013-12-23 13:35:53','613.00',NULL,NULL,'758.67','145.67','R-OH013','OH0','758.67',NULL,0,'2013-12-26 13:08:52'),(472,385,'Y','18','021','EC','A','','','AC','0000388618','0000388618','OH00000272512','IL','1','Gorsuch','James','','','','34','272469750','2540 TREMAINSVILLE RD',0,'TOLEDO','OH','43613','2508','CY','39095','1962-04-28','M','U',':RET:2106-3','T','021','HLT','887422','92036OH001002601','2014-01-01','2013-12-03 18:51:03','0.00',NULL,NULL,'504.48','504.48','R-OH001','OH0','504.48',NULL,0,'2013-12-25 17:47:54'),(5224,4147,'Y','18','021','EC','A','','','AC','0001119947','0001119947','OH00000707275','IL','1','Bougie','Kristine','','','','34','288520364','615 Stanley Street',0,'Middletown','OH','45044',NULL,'CY','39017','1950-09-27','F','U',':RET:2106-3','N','021','DEN','1473795','99734OH005000401','2014-01-01','2013-12-19 17:52:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:37'),(5100,4042,'Y','18','021','EC','A','','','AC','0000336428','0000336428','TX00000432007','31','1','DUDLEY','ELVIN','','','','34','459552025','PO box 100',0,'Lindale','TX','75771',NULL,'CY','48423','1965-09-26','M','M',':RET:2106-3','N','021','DEN','1459094','33348TX002000201','2014-01-01','2013-12-19 16:46:14','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 23:01:25'),(7884,6236,'N','19','021','EC','A',NULL,NULL,'','0000637097','0001100589','','S3','1','AGARWAL','NEIL','PRAHLAD','','','34','286062106','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','2001-08-18','F','',':RET:2029-7','N','021','DEN','1767706','99734OH005000301','2014-01-01','2013-12-20 18:44:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:29'),(1221,1004,'Y','18','021','EC','A','','','AC','0000159382','0000159382','OH00000546064','31','1','Ashley','Robert','Edward','','','34','276445191','po box 141',0,'rock creek','OH','44084',NULL,'CY','39007','1950-05-13','M','U',':RET:2106-3','T','021','HLT','1107329','52664OH151001306','2014-01-01','2013-12-03 01:14:44','714.00',NULL,NULL,'853.86','139.86','R-OH011','OH0','853.86',NULL,0,'2013-12-25 18:20:25'),(4567,3616,'Y','18','021','EC','A','','','AC','0000136433','0000136433','TX00000836976','IL','1','Kirkland','Bruce','W','','','34','459988643','1801 Westlake Drive',0,'Austin','TX','78746',NULL,'CY','48453','1951-09-28','M','U',':RET:2106-3','N','021','DEN','644098','33348TX002000101','2014-01-01','2013-12-12 00:36:46','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 22:04:51'),(4471,3552,'N','19','021','EC','A',NULL,NULL,'','0000129245','0000949496','','IL','1','Dail','Madison',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','2001-10-04','F','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:51'),(3480,2793,'Y','18','021','EC','A','','','AC','0000418888','0000418888','OH00001016461','S3','1','Watrous','Shawn','n','','','34','296987188','1760 HOLLOW RUN DR',0,'COLUMBUS','OH','43223','3413','CY','39049','1996-03-15','F','U',':RET:2106-3','N','021','DEN','1561222','99734OH005000401','2014-01-01','2013-12-22 11:05:02','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-25 21:20:09'),(21455,17146,'Y','18','024','14','A','','','TE','0000659932','0000659932','','IL','1','Lyttle','Rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-14','F','',NULL,NULL,NULL,'','2654794','','2014-02-04','2014-02-04 13:08:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:30'),(23325,18590,'Y','18','021','EC','A','','','AC','0001125479','0001125479','OH00001934215','IL','1','Storer','Amy','L','','','34','293863236','906 E TEMPLE ST',0,'WASHINGTON COURT HOUSE','OH','43160','1661','CY','39047','1987-08-28','F','M',':RET:2106-3','T','021','DEN','3303889','99734OH005000301','2014-03-01','2014-02-13 13:57:43','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:27'),(23911,19018,'N','01','021','EC','A',NULL,NULL,'','0000874746','0000814331','','IL','1','Vanculin','Lyle','','','','34','298641262','189 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1424','CY','39023','1969-10-11','M','',':RET:2106-3','N','021','HLT','3411645','92036OH002000501','2014-03-01','2014-02-14 16:44:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','383.50',NULL,0,'2014-02-14 21:32:29'),(24133,19181,'Y','18','021','EC','A','','','AC','0001228106','0001228106','OH00002026883','S1','1','Jones','Terry','','','','34','274116913','3201 MECHANICSBURG RD',0,'SPRINGFIELD','OH','45503','1828','CY','39023','2004-11-20','M','U',':RET:2106-3','N','021','DEN','3223673','99734OH005000101','2014-03-01','2014-02-15 10:01:38','0.00',NULL,NULL,'27.59','27.59','R-OH003','OH0','27.59',NULL,0,'2014-02-15 22:01:49'),(25222,20006,'Y','18','024','14','A','','','TE','0001005068','0001005068','','IL','1','Piper','Darlene',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-10-19','F','',NULL,NULL,NULL,'','2714397','','2014-02-20','2014-02-20 20:52:17',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-21 22:00:57'),(368,305,'Y','18','021','EC','A','','','AC','0000661432','0000661432','TX00000411236','IL','1','DeVore','Forest','','','','34','495601985','1431 SULPHUR ST',0,'HOUSTON','TX','77034','1036','CY','48201','1953-04-11','M','U',':RET:2106-3','N','021','DEN','1184004','33348TX002000201','2014-01-01','2013-12-04 12:36:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:45:22'),(18678,14890,'Y','18','021','EC','A','','','AC','0000916250','0000916250','TX00002463823','IL','1','Trolinger','Michael','A','','','34','466234225','704 Myrah',0,'Mcallen','TX','78504',NULL,'CY','48215','1952-01-08','M','M',':RET:2106-3','N','021','DEN','1360597','33348TX002000201','2014-02-01','2014-01-15 20:00:05','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-17 03:35:19'),(18254,14573,'Y','18','021','EC','A','','','AC','0000972370','0000972370','TX00002421657','IL','1','Fuentes','Guillermo','','','','34','628167445','11561 MEADOWBROOK DR',0,'EL PASO','TX','79936','5636','CY','48141','1954-03-21','M','M',NULL,'N','021','DEN','1406039','33348TX002000201','2014-02-01','2014-01-15 13:21:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-16 08:44:32'),(1013,830,'Y','18','021','EC','A','','','AC','0000294323','0000294323','MS00001080726','IL','1','FOX','CALVIN','JOSEPH','','','34','435275748','2410 MCINNIS LOOP',0,'HATTIESBURG','MS','39402',NULL,'CY','28035','1966-01-15','M','U',NULL,'N','021','DEN','580999','46300MS002000201','2014-01-01','2013-12-02 18:21:09','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:15:03'),(16120,12912,'N','01','021','EC','A',NULL,NULL,'','0001604385','0002164548','','IL','1','HUGHES','DIANNE','','','','34','438111165','6993 WHITMORE PL',0,'NEW ORLEANS','LA','70128',NULL,'CY','22071','1960-03-02','F','',NULL,'T','021','DEN','2066200','18575LA002000101','2014-02-01','2014-01-03 11:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-04 02:05:23'),(1627,1359,'Y','18','021','EC','A','','','AC','0000387953','0000387953','TX00000895567','IL','1','Thomas','Melinda','','','','34','467986155','17865 Park Valley Dr.',0,'Round Rock','TX','78681',NULL,'CY','48491','1966-01-30','F','U',':RET:2106-3','N','021','DEN','1982765','33348TX002000201','2014-01-01','2013-12-24 14:24:01','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:52:44'),(15168,12121,'N','01','021','EC','A',NULL,NULL,'','0001192681','0001140787','','IL','1','Smith','Matthew','C','','','34','278780476','308 S APPLE ST',0,'GEORGETOWN','OH','45121','1534','CY','39015','1981-09-11','M','',':RET:2106-3','T','021','DEN','2292399','99734OH005000401','2014-02-01','2013-12-30 15:07:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:28'),(15146,12105,'Y','18','021','EC','A','','','AC','0001028078','0001028078','OH00000437956','IL','1','Hartman','Amanda','','','','34','288820775','1961 E 123RD ST',0,'CLEVELAND','OH','44106','4344','CY','39035','1982-05-17','F','U',':RET:2106-3','N','021','DEN','1688600','99734OH005000401','2014-02-01','2013-12-30 11:42:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:05:53'),(3822,3060,'Y','18','021','EC','A','','','AC','0000879468','0000879468','OH00000921322','IL','1','Ugie','Taylor','Douglas','','','34','275944106','1108 RIVER ST',0,'DRESDEN','OH','43821','9702','CY','39119','1991-05-16','M','U',':RET:2106-3','N','021','DEN','648982','99734OH005000301','2014-01-01','2013-12-13 14:50:27','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:34:58'),(3029,2436,'N','01','021','EC','A',NULL,NULL,'','0000257109','0000590758','','IL','1','Patel','Bharti','','','','34','353680736','8224 STATE ROUTE 108',0,'WAUSEON','OH','43567','9663','CY','39051','1960-10-25','F','',':RET:2029-7','N','021','HLT','123165','92036OH004002601','2014-01-01','2013-12-05 21:15:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.86',NULL,0,'2013-12-25 20:18:23'),(491,401,'Y','18','021','EC','A','','','AC','0000550629','0000550629','LA00000027579','IL','1','Kennedy','Carla','','','','34','434379431','203 Curve Drive',0,'Monroe','LA','71203',NULL,'CY','22073','1969-05-19','F','U',':RET:2054-5','N','021','DEN','421694','18575LA002000201','2014-01-01','2013-12-04 13:31:59','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 17:48:25'),(600,493,'Y','18','021','EC','A','','','AC','0000319650','0000319650','OH00000674806','IL','1','CLARK','RENEE','KAY','','','34','273563596','4151 CLEVELAND AVE',0,'COLUMBUS','OH','43224','4717','CY','39049','1954-03-28','F','U',':RET:2054-5','N','021','DEN','412697','99734OH005000401','2014-01-01','2013-12-15 21:52:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:00:17'),(20259,16167,'Y','18','021','EC','A','','','AC','0000127001','0000127001','OH00002184785','IL','1','Highbaugh','Theresa','','','','34','139589163','9912 Aetna',0,'Cleveland','OH','44105',NULL,'CY','39035','1963-07-05','F','M',NULL,'N','021','DEN','3500443','99734OH005000301','2014-03-01','2014-01-27 21:44:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-28 21:00:18'),(19354,15427,'Y','18','021','EC','A','','','AC','0000408509','0000408509','OH00002493965','IL','1','BEASLEY','SUSAN','','','','34','509568325','3411 PECAN LN',0,'WOOSTER','OH','44691','5903','CY','39169','1950-07-08','F','U',NULL,'N','021','DEN','2889192','99734OH005000301','2014-03-01','2014-01-21 17:14:17','0.00',NULL,NULL,'21.13','21.13','R-OH014','OH0','0.00',NULL,1,'2014-01-22 03:22:27'),(1585,1323,'Y','18','021','EC','A','','','AC','0000972263','0000972263','TX00000551078','IL','1','WILLIAMS','ANGELA','','','','34','420047835','4280 TRINITY MILLS RD',0,'DALLAS','TX','75287',NULL,'CY','48085','1964-04-07','F','U',':RET:2054-5','N','021','DEN','2329848','33348TX002000201','2014-01-01','2013-12-24 11:00:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:51:34'),(18583,14818,'Y','18','021','EC','A','','','AC','0000322165','0000322165','OH00001634208','IL','1','Marmer','Randy','','','','34','292463379','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1956-11-28','M','M',':RET:2106-3','N','021','HLT','1856858','92036OH002001201','2014-02-01','2014-01-15 01:42:53','778.00',NULL,NULL,'1339.95','561.95','R-OH004','OH0','604.16',NULL,0,'2014-01-16 08:47:10'),(9438,7487,'Y','18','021','EC','A','','','AC','0000475962','0000475962','OH00001099893','IL','1','Darnell','Pamela','Ann','','','34','276529949','1498 BEACON ST',0,'CINCINNATI','OH','45230','2855','CY','39061','1953-09-10','F','U',':RET:2106-3','N','021','HLT','1372999','92036OH006001201','2014-01-01','2013-12-21 12:15:54','300.00',NULL,NULL,'462.04','162.04','R-OH004','OH0','462.04',NULL,0,'2013-12-26 04:33:36'),(21861,17454,'Y','18','021','EC','A','','','AC','0000929872','0000929872','OH00002376043','S3','1','Mcghee','Ashley','','','','34','443693271','3883 HEATHERGLEN DR',0,'COLUMBUS','OH','43221','5816','CY','39049','2013-01-02','F','U',':RET:2106-3','N','021','DEN','3543761','99734OH005000301','2014-03-01','2014-02-06 14:49:14','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13',NULL,0,'2014-02-06 21:01:19'),(24135,19182,'N','19','021','EC','A',NULL,NULL,'','0000043263','0000465965','','S1','1','Jones','Terry','','','','34','274116913','3201 MECHANICSBURG RD',0,'SPRINGFIELD','OH','45503','1828','CY','39023','2004-11-20','M','',':RET:2106-3','N','021','HLT','3439441','92036OH003000501','2014-03-01','2014-02-15 10:01:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.64',NULL,0,'2014-02-15 22:01:50'),(24246,19252,'Y','18','021','EC','A','','','AC','0000117841','0000117841','OH00002617114','31','1','Howard','Kathy','','','','34','268605480','PO Box 943',0,'Coraopolis','PA','15108',NULL,'CY','39099','1957-04-27','F','U',':RET:2054-5','N','021','HLT','3681211','92036OH005003201','2014-03-01','2014-02-15 23:55:21','250.00',NULL,NULL,'564.70','314.70','R-OH013','OH0','564.70',NULL,0,'2014-02-16 19:00:41'),(25396,20147,'Y','18','021','EC','A','','','AC','0000917040','0000917040','OH00002690744','IL','1','KIETH','TINA','','','','34','285725698','107 MITCHELL ST',0,'BARBERTON','OH','44203','1511','CY','39153','1971-01-20','F','M',':RET:2106-3','T','021','HLT','3009727','52664OH151001305','2014-04-01','2014-02-25 13:58:55','151.00',NULL,NULL,'348.01','197.01','R-OH012','OH0','348.01',NULL,0,'2014-02-25 21:30:53'),(26263,20831,'Y','18','021','EC','A','','','AC','0000923928','0000923928','TX00003376168','IL','1','GARZA','ELOY','','','','34','307580682','2918 E RICHARDSON RD',0,'EDINBURG','TX','78542','0464','CY','48215','1956-11-24','M','M',NULL,'N','021','DEN','3183628','33348TX002000201','2014-04-01','2014-02-27 15:59:04','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-28 06:31:13'),(28345,22428,'Y','18','021','EC','A','','','AC','0000929401','0000929401','TX00002917014','IL','1','RAMOS','JOSE LUIS','','','','34','605038050','2300 SOUTH TERRELL ST',0,'MIDLAND','TX','79701',NULL,'CY','48329','1961-01-05','M','M',NULL,'N','021','DEN','3703484','33348TX002000201','2014-04-01','2014-03-07 11:44:07','0.00',NULL,NULL,'29.22','29.22','R-TX016','TX0','14.61',NULL,0,'2014-03-07 21:30:19'),(19541,15575,'Y','18','021','EC','A','','','AC','0000574469','0000574469','OH00002263776','IL','1','Gonzales','Linda','','','','34','290782538','315 S GREENLER',0,'HOLGATE','OH','43527','0392','CY','39069','1966-10-14','F','U',':RET:2106-3','N','021','HLT','2134198','92036OH004002601','2014-03-01','2014-01-22 14:08:28','146.00',NULL,NULL,'245.07','99.07','R-OH001','OH0','245.07',NULL,0,'2014-01-23 03:02:24'),(19212,15307,'Y','18','021','EC','A','','','AC','0000029072','0000029072','OH00002054790','IL','1','Pilkington','Scot','','','','34','280423685','5930 Lake Rd W',0,'Ashtabula','OH','44004',NULL,'CY','39007','1959-04-12','M','U',':RET:2106-3','N','021','DEN','1512462','99734OH005000401','2014-03-01','2014-01-20 11:41:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:22'),(18936,15089,'Y','18','021','EC','A','','','AC','0001201917','0001201917','OH00001636547','IL','1','COWAN','MARILYN','','','','34','272507371','5322 RAWHIDE CT',0,'CINCINNATI','OH','45238','4235','CY','39061','1950-02-16','F','U',':RET:2106-3','N','021','DEN','2754348','99734OH005000401','2014-03-01','2014-01-16 20:46:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:05:41'),(502,410,'N','19','021','EC','A',NULL,NULL,'','0000089796','0001234100','','IL','1','Peters','Joseph','','','','34','302062341','5068 BECKENHAM CT',0,'GAHANNA','OH','43230','1263','CY','39049','2002-07-17','M','',':RET:2106-3','N','021','DEN','621891','99734OH005000301','2014-01-01','2013-12-04 09:44:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:48:44'),(5281,4184,'Y','18','021','EC','A','','','AC','0000062525','0000062525','OH00000591590','IL','1','THOMAS','MARTIN','','','','34','288505467','1523 NORTHMORELAND BLVD',0,'CUYAHOGA FALLS','OH','44221','5226','CY','39153','1955-11-22','M','U',':RET:2106-3','N','021','HLT','1391172','52664OH151001305','2014-01-01','2013-12-19 14:41:13','413.00',NULL,NULL,'568.22','155.22','R-OH012','OH0','568.22',NULL,0,'2013-12-25 23:05:45'),(4803,3806,'N','01','021','EC','A',NULL,NULL,'','0000565608','0000590773','','IL','1','Turner','Cedric','','','','34','437236933','10320 ROOSEVELT ST',0,'CLINTON','LA','70722','3511','CY','22037','1967-05-21','M','',':RET:2054-5','T','021','DEN','299376','18575LA002000201','2014-01-01','2013-12-08 10:22:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:16:33'),(1449,1209,'Y','18','024','14','A','','','TE','0000195130','0000195130','','IL','1','kochersperger','matt',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-05-07','M','',NULL,NULL,NULL,'','1675216','','2013-12-24','2013-12-24 05:06:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:04'),(1824,1496,'N','19','021','EC','A',NULL,NULL,'','0000593684','0001139506','','IL','1','tariq','haroon','','','','34','283068422','1613 RIDGE CROSS RD',0,'PERRYSBURG','OH','43551','9055','CY','39173','1986-09-19','M','',NULL,'N','021','HLT','1708312','92036OH005002605','2014-01-01','2013-12-24 14:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.35',NULL,0,'2013-12-25 18:57:17'),(1967,1606,'Y','18','021','EC','A','','','AC','0001172410','0001172410','TX00000174102','IL','1','Diggins','Lupita','','','','34','456278578','3421 MICHELLE RIDGE DR',0,'FORT WORTH','TX','76123','2090','CY','48439','1974-05-10','F','U',':RET:2054-5','N','021','DEN','1165596','33348TX002000101','2014-01-01','2013-11-20 15:11:07','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:22'),(2103,1724,'Y','18','021','EC','A','','','AC','0000653171','0000653171','OH00001130855','IL','1','ADU','RICHSON','','','','34','286067864','2098 SPRUCEFIELD RD',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1972-06-11','M','M',':RET:2054-5','N','021','DEN','428221','99734OH005000401','2014-01-01','2013-12-09 22:09:08','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:17:13'),(2119,1739,'Y','18','021','EC','A','','','AC','0000595112','0000595112','OH00000819098','IL','1','Dorey','John','','','','34','430985024','2668 CYCLORAMA DR',0,'CINCINNATI','OH','45211','8315','CY','39061','1952-08-23','M','U',NULL,'N','021','DEN','1142825','99734OH005000401','2014-01-01','2013-12-10 13:10:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:40'),(3900,3122,'Y','18','021','EC','A','','','AC','0001114511','0001114511','OH00000156634','IL','1','Pavliga','Gail',NULL,NULL,NULL,NULL,NULL,'1965 NEW MILFORD RD',0,'ATWATER','OH','44201','7701','CY','39133','1960-10-07','F','M',':RET:2106-3','N','021','HLT','1012859','52664OH152000901','2014-01-01','2013-12-13 16:57:27','894.61',NULL,NULL,'894.61','0.00','R-OH012','OH0','333.21',NULL,0,'2013-12-25 21:36:50'),(17311,13845,'Y','18','021','EC','A','','','AC','0001058736','0001058736','TX00002297242','IL','1','Lindberg','Kayla','','','','34','636019337','1523 N COLLEGE ST',0,'GONZALES','TX','78629','2415','CY','48177','1988-08-13','F','M',':RET:2106-3','N','021','DEN','2250939','33348TX002000201','2014-02-01','2014-01-10 14:30:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:44'),(3260,2627,'Y','18','021','EC','A','','','AC','0000038349','0000038349','OH00000163724','IL','1','Dunlavy','Carolyn','','','','34','271543705','216 CASTERTON AVE',0,'AKRON','OH','44303','1517','CY','39153','1953-03-28','F','U',':RET:2106-3','N','021','HLT','273138','52664OH151001306','2014-01-01','2013-11-27 19:39:16','503.00',NULL,NULL,'605.24','102.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 20:46:51'),(22391,17879,'N','01','021','EC','A',NULL,NULL,'','0001076607','0000416000','','IL','1','Pillitiere','Catherine','L','','','34','288600991','717 COLUMBIA AVE',0,'AKRON','OH','44310','2312','CY','39153','1955-10-20','F','',':RET:2106-3','N','021','HLT','2874130','52664OH151001304','2014-03-01','2014-02-10 13:21:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2014-02-10 21:30:15'),(23373,18625,'Y','18','021','EC','A','','','AC','0001062165','0001062165','OH00001880668','IL','1','Mayo','Connie','','','','34','283509204','969 St Rt 28 Lot 54',0,'Milford','OH','45150',NULL,'CY','39025','1951-06-26','F','U',':RET:2106-3','N','021','DEN','2803971','99734OH005000401','2014-03-01','2014-02-13 08:59:57','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:00:55'),(23548,18760,'Y','18','021','EC','A','','','AC','0001804553','0001804553','LA00002540490','IL','1','GUZMAN','LESLIE','','','','34','450652957','2155 PARK DR',0,'SLIDELL','LA','70458',NULL,'CY','22103','1982-10-12','F','M',NULL,'N','021','DEN','3337045','18575LA002000201','2014-03-01','2014-02-13 15:42:53','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:37'),(24468,19437,'Y','18','021','EC','A','','','AC','0000639574','0000639574','OH00002533056','31','1','Bryant','Jerry','','','Jr','34','330643108','P.O. Box 823',0,'Piqua','OH','45356',NULL,'CY','39149','1966-09-26','M','M',':RET:2054-5','T','021','HLT','3729504','92036OH003000505','2014-04-01','2014-02-18 12:11:33','243.00',NULL,NULL,'446.20','203.20','R-OH003','OH0','446.20',NULL,0,'2014-02-18 22:01:36'),(26509,21025,'Y','18','024','14','A','','','TE','0000496746','0000496746','','IL','1','Grande','Kristen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-02-21','F','',NULL,NULL,NULL,'','1590351','','2014-02-28','2014-02-28 15:49:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:18'),(13209,10541,'Y','18','021','EC','A','','','AC','0000230610','0000230610','TX00000866245','IL','1','Thirugnanasambandam','Ramakrishna','','','','34','644112567','6119 BARKERMIST LN',0,'KATY','TX','77450','5690','CY','48157','1967-01-11','M','U',':RET:2029-7','N','021','DEN','1839331','33348TX002000101','2014-01-01','2013-12-23 19:15:18','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:55:12'),(13181,10515,'Y','18','021','EC','A','','','AC','0000826860','0000826860','TX00000273249','IL','1','Luckie','Barry','','','','34','462336880','303 Stonewood Blvd.',0,'Bartonville','TX','76226',NULL,'CY','48121','1964-02-27','M','U',':RET:2106-3','N','021','DEN','1515742','33348TX002000101','2014-01-01','2013-12-22 21:48:51','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:19'),(13035,10391,'Y','18','021','EC','A','','','AC','0000721339','0000721339','OH00000788689','IL','1','STEPHENS','ANGELA','DAWN','','','34','292684714','507 S MAIN ST-STRT 133',0,'BETHEL','OH','45106',NULL,'CY','39025','1973-03-22','F','U',':RET:2106-3','N','021','DEN','1388857','99734OH005000401','2014-01-01','2013-12-23 04:17:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 12:50:27'),(2284,1861,'N','19','021','EC','A',NULL,NULL,'','0001237681','0000452715','','S1','1','Johnson','Michael','I','','','34','590497326','2610 KEMPERWOOD DR',0,'BLACKLICK','OH','43004','8667','CY','39049','1995-01-20','M','',NULL,'N','021','DEN','551987','99734OH005000301','2014-01-01','2013-12-09 12:47:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:35'),(2850,2303,'Y','18','021','EC','A','','','AC','0000939732','0000939732','OH00000649670','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',':RET:2106-3','N','021','DEN','830500','99734OH005000301','2014-01-01','2013-11-01 21:33:59','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:01:19'),(16691,13357,'Y','18','021','EC','A','','','AC','0000961056','0000961056','TX00001915727','IL','1','Nardi-Unger','Susan','','','','34','225667226','7575 Gosling Rd Apt 1217',0,'SPRING','TX','77382',NULL,'CY','48339','1964-03-03','F','U',NULL,'N','021','DEN','2381602','33348TX002000201','2014-02-01','2014-01-07 12:49:23','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-08 18:24:35'),(7056,5605,'N','01','021','EC','A',NULL,NULL,'','0001233055','0000211011','','IL','1','Koha','Mary','Lynne','','','34','279587134','2358 RIDGEVIEW DR SW',0,'SHERRODSVILLE','OH','44675','9700','CY','39019','1960-04-16','F','',':RET:2106-3','N','021','DEN','1529316','99734OH005000301','2014-01-01','2013-12-24 20:41:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:49:49'),(7935,6276,'Y','18','021','EC','A','','','AC','0001926231','0001926231','LA00000117666','31','1','Shipp','Linda','','','','34','434902794','P O Box 737',0,'Saint Martinsville','LA','70582',NULL,'CY','22099','1952-01-12','F','M',':RET:2106-3','T','021','DEN','1719668','18575LA002000201','2014-01-01','2013-12-20 14:06:02','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2013-12-26 03:06:43'),(4860,3851,'Y','18','021','EC','A','','','AC','0000352891','0000352891','TX00000917443','IL','1','Jenkins','Laura','','','','34','419781713','170 N LAKE DR',0,'MURCHISON','TX','75778','4572','CY','48467','1953-08-18','F','M',':RET:2106-3','N','021','DEN','172958','33348TX002000101','2014-01-01','2013-11-08 09:53:06','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 22:30:39'),(22905,18257,'Y','18','021','EC','A','','','AC','0000882888','0000882888','OH00001543792','IL','1','pankratz','denise','','','','34','276546224','12733 LAGOON DR',0,'CURTICE','OH','43412','9472','CY','39095','1952-04-06','F','M',':RET:2106-3','N','021','HLT','3606955','92036OH004002601','2014-03-01','2014-02-11 11:13:13','126.00',NULL,NULL,'440.60','314.60','R-OH001','OH0','440.60',NULL,0,'2014-02-11 21:02:44'),(24795,19662,'N','01','021','EC','A',NULL,NULL,'','0001165319','0000930893','','IL','1','ANAYA','GEORGE','ANTONIO','','','34','279963007','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-21','M','',NULL,'T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:47:14'),(26479,21003,'Y','18','024','14','A','','','TE','0001057309','0001057309','','IL','1','Kindle','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-15','F','',NULL,NULL,NULL,'','1675731','','2014-03-31','2014-02-28 16:02:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-28 21:00:03'),(170,142,'N','19','021','EC','A',NULL,NULL,'','0000635981','0000501588','','IL','1','Votaw','Joseph','','','','34','302962937','4891 W Main St',0,'Berlin','OH','44610',NULL,'CY','39075','1994-06-25','M','',':RET:2106-3','N','021','HLT','469132','52664OH151001305','2014-01-01','2013-12-04 21:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 17:19:25'),(196,163,'N','19','021','EC','A',NULL,NULL,'','0000357163','0000027867','','IL','1','Anderson','Jonathan','','','','34','290045230','2180 PLYMOUTH DR',0,'UNIONTOWN','OH','44685','9743','CY','39153','1999-10-20','M','',NULL,'N','021','HLT','1067464','52664OH151001501','2014-01-01','2013-12-04 19:50:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 17:20:05'),(512,417,'N','01','021','EC','A',NULL,NULL,'','0001044450','0001155082','','IL','1','reynolds','craig','s','','','34','281769207','5921 Cedaridge Dr.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1980-03-21','M','',':RET:2106-3','N','021','DEN','1027934','99734OH005000301','2014-01-01','2013-12-03 21:00:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:48:57'),(18099,14457,'N','19','021','EC','A',NULL,NULL,'','0001571181','0001346672','','IL','1','Dennis','Wayne','','','Jr',NULL,NULL,'209 NEWMAN ST',0,'MONROE','LA','71202','5813','CY','22073','1991-11-06','M','',':RET:2054-5','N','021','DEN','1962218','18575LA002000201','2014-02-01','2014-01-14 15:47:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:33'),(14491,11561,'Y','18','021','EC','A','','','AC','0000490389','0000490389','TX00000693122','IL','1','Smith','Patricia','','','','34','457111138','2437 FRANKSTON HWY',0,'TYLER','TX','75701','3891','CY','48423','1954-10-28','F','M',':RET:2054-5','N','021','DEN','2121358','33348TX002000201','2014-02-01','2013-12-27 11:11:40','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-28 03:33:32'),(6938,5509,'Y','18','021','EC','A','','','AC','0000757149','0000757149','OH00001622519','IL','1','Selick','Tammy','Lynn','','','34','281649122','107 WESTMINSTER DR',0,'SAINT CLAIRSVILLE','OH','43950','1656','CY','39013','1973-02-14','F','U',':RET:2106-3','N','021','DEN','1625905','99734OH005000401','2014-01-01','2013-12-24 20:22:11','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:46:43'),(3756,3005,'N','01','021','EC','A',NULL,NULL,'','0000155751','0000777659','','IL','1','mccroskey','connie','','','','34','293529177','3026 west main street',0,'kingsville','OH','44048',NULL,'CY','39007','1952-07-23','F','',':RET:2106-3','N','021','HLT','31394','52664OH151001306','2014-01-01','2013-12-13 17:58:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','706.77',NULL,0,'2013-12-25 21:33:18'),(6441,5108,'Y','18','021','EC','A','','','AC','0000526813','0000526813','LA00000812429','IL','1','Hyndman','Elton','','','','34','395119890','8236 BOONE AVE',0,'BATON ROUGE','LA','70808','6812','CY','22033','1975-12-19','M','M',':RET:2106-3','N','021','DEN','618320','18575LA002000201','2014-01-01','2013-12-11 17:53:34','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:49:27'),(5081,4027,'Y','18','021','EC','A','','','AC','0000485233','0000485233','TX00000302839','IL','1','Moreno','Francisco','','','','34','451982648','222 PIKE RD',0,'SAN ANTONIO','TX','78209','3515','CY','48029','1956-10-08','M','M',':RET:2500-7','N','021','DEN','1744231','33348TX002000201','2014-01-01','2013-12-19 14:01:25','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:00:57'),(20930,16727,'Y','18','024','14','A','','','TE','0001197046','0001197046','','IL','1','Lathon','Bruce',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-10-07','M','',NULL,NULL,NULL,'','1459940','','2014-01-31','2014-01-31 17:25:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-31 21:01:36'),(29155,23079,'Y','18','021','EC','A','','','AC','0000691894','0000691894','OH00003803046','IL','1','Hill','Thomas','','','','34','289568428','1029 CLYMENA ST',0,'TOLEDO','OH','43612','1720','CY','39095','1962-12-29','M','M',NULL,'N','021','HLT','4105432','92036OH003002601','2014-04-01','2014-03-10 12:34:26','259.00',NULL,NULL,'727.20','468.20','R-OH001','OH0','379.79',NULL,0,'2014-03-10 21:02:51'),(14157,11285,'Y','18','021','EC','A','','','AC','0002156019','0002156019','LA00001029305','IL','1','armstrong','matthew','','','','34','428232810','1443 Lakewood Drive',0,'Slidell','LA','70458',NULL,'CY','22103','1961-09-08','M','U',':RET:2106-3','N','021','DEN','1840786','18575LA002000201','2014-02-01','2013-12-26 14:17:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:03'),(13149,10489,'Y','18','021','EC','A','','','AC','0000739022','0000739022','OH00000136830','IL','1','BIRL','BERNITA','','','','34','287561027','2488 ZIRCON ST NE',0,'CANTON','OH','44721','1743','CY','39151','1953-08-17','F','U',':RET:2054-5','N','021','DEN','1593256','99734OH005000401','2014-01-01','2013-12-23 16:55:05','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 12:53:33'),(1460,1217,'Y','18','021','EC','A','','','AC','0000501619','0000501619','OH00001092855','IL','1','MUMPHREY','DARRYL','','','','34','297646553','5816 LINDA LN',0,'GARFIELD HEIGHTS','OH','44125','4312','CY','39035','1959-12-26','M','U',':RET:2054-5','N','021','DEN','1698434','99734OH005000401','2014-01-01','2013-12-24 08:29:00','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:48:18'),(20012,15961,'Y','18','024','14','A','','','TE','0001138430','0001138430','','IL','1','Eatmon','Javonne','Deshye',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-02','F','',NULL,NULL,NULL,'','1920115','','2014-01-25','2014-01-25 19:18:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-26 19:00:10'),(19410,15475,'N','19','021','EC','A',NULL,NULL,'','0000196164','0000126996','','IL','1','Gruich','Alexandra','','','','34','271964190','2449 GREENHAVEN DR',0,'AKRON','OH','44333','2753','CY','39153','1992-10-06','F','',':RET:2106-3','N','021','HLT','3023737','52664OH152000901','2014-03-01','2014-01-21 11:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,1,'2014-01-22 03:22:57'),(18296,14607,'Y','18','021','EC','A','','','AC','0001113163','0001113163','OH00001384983','IL','1','Glener','Gary','','','','34','295922121','1539 Burney Lane',0,'Cincinnati','OH','45230',NULL,'CY','39061','1990-11-16','M','U',':RET:2106-3','N','021','DEN','1773121','99734OH005000401','2014-02-01','2014-01-14 21:53:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:44:54'),(5087,4031,'N','01','021','EC','A',NULL,NULL,'','0000224374','0000921346','','IL','1','Leggett','Joe','','','','34','457822773','17582 HIGHWAY 105 E',0,'CONROE','TX','77306','5908','CY','48339','1953-01-09','M','',':RET:2106-3','N','021','DEN','1919441','33348TX002000201','2014-01-01','2013-12-19 14:32:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:01:06'),(17949,14341,'Y','18','021','EC','A','','','AC','0001099291','0001099291','TX00002397432','31','1','Ondreas','Sandra','Kaye','','','34','449082939','400 Broadway',0,'Port Lavaca','TX','77979',NULL,'CY','48057','1958-11-07','F','M',':RET:2106-3','N','021','DEN','2036165','33348TX002000201','2014-02-01','2014-01-14 16:41:05','0.00',NULL,NULL,'29.22','29.22','R-TX023','TX0','14.61',NULL,0,'2014-01-15 02:06:42'),(7124,5653,'Y','18','021','EC','A','','','AC','0000156985','0000156985','MS00000020594','IL','1','Dennison','Lisa','','','','34','428253168','36 Timber Drive',0,'Columbus','MS','39705',NULL,'CY','28087','1961-04-08','F','U',':RET:2106-3','N','021','DEN','1855027','46300MS002000201','2014-01-01','2013-12-24 22:44:57','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 01:51:25'),(18547,14792,'Y','18','021','EC','A','','','AC','0001107133','0001107133','MS00002282640','IL','1','DO','UYEN','','','','34','449617367','58 EASTVIEW CIR',0,'LAUREL','MS','39443','2623','CY','28067','1982-11-10','F','M',':RET:2028-9','N','021','DEN','1833212','46300MS002000101','2014-02-01','2014-01-15 09:39:32','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,0,'2014-01-16 08:46:52'),(4875,3866,'Y','18','021','EC','A','','','AC','0000208445','0000208445','OH00000476051','IL','1','Szymanski','Kazimer','','','','34','274909566','6367 SPRINGWOOD RD',0,'PARMA HEIGHTS','OH','44130','3214','CY','39035','1989-01-03','M','U',NULL,'N','021','DEN','648529','99734OH005000301','2014-01-01','2013-10-10 01:07:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:31:07'),(1762,1455,'Y','18','021','EC','A','','','AC','0001114538','0001114538','OH00000154616','IL','1','Sisson','Christopher','','','','34','276543894','6803 westin Ridge',0,'Cleves','OH','45002',NULL,'CY','39061','1952-03-13','M','M',':RET:2106-3','N','021','DEN','2190892','99734OH005000301','2014-01-01','2013-12-24 13:37:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:55:54'),(24931,19770,'Y','18','024','14','A','','','TE','0000888171','0000888171','','IL','1','ANGERSTIEN','DENISE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-30','F','',NULL,NULL,NULL,'','1533078','','2014-02-28','2014-02-20 16:08:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:20'),(28915,22885,'N','01','021','EC','A',NULL,NULL,'','0000643296','0000481141','','IL','1','Kolar','Nikola','Senior','','','34','183484094','6510 Morrow Cozaddale',0,'Morrow','OH','45152',NULL,'CY','39165','1957-04-14','M','',':RET:2106-3','N','021','DEN','3470217','99734OH005000301','2014-04-01','2014-03-10 09:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:28'),(17923,14317,'Y','18','024','14','A','','','TE','0000977683','0000977683','','IL','1','krpoun','robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-09-01','M','',NULL,NULL,NULL,'','2718998','','2014-01-14','2014-01-14 11:23:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:32'),(6504,5154,'Y','18','021','EC','A','','','AC','0000058733','0000058733','OH00000207671','IL','1','PELLSHAW','EDWARD','','','','34','302485408','173 N LYMAN ST',0,'WADSWORTH','OH','44281','1812','CY','39103','1949-10-03','M','U',':RET:2106-3','N','021','HLT','922535','52664OH152000901','2014-01-01','2013-12-10 18:58:44','0.00',NULL,NULL,'490.00','490.00','R-OH012','OH0','490.00',NULL,0,'2013-12-26 00:50:56'),(16319,13066,'Y','18','021','EC','A','','','AC','0001566453','0001566453','LA00002290999','IL','1','Arthur','Julie','','','','34','433899959','1235 S ALAMEDA DR',0,'BATON ROUGE','LA','70815','1006','CY','22033','1970-12-31','F','M',NULL,'N','021','DEN','1910662','18575LA002000201','2014-02-01','2014-01-06 16:55:48','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:39'),(15053,12032,'Y','18','021','EC','A','','','AC','0001800770','0001800770','LA00000132001','IL','1','BRUNO','MARCUS','W','','','34','439115743','102 MARSH DR',0,'LAFAYETTE','LA','70507','4950','CY','22055','1963-10-30','M','M',':RET:2054-5','N','021','DEN','1529446','18575LA002000201','2014-02-01','2013-12-30 14:32:18','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-01-01 12:03:19'),(14421,11501,'Y','18','021','EC','A','','','AC','0000531832','0000531832','TX00001438670','IL','1','Rodriguez-Fuentes','Maria','','','','34','631602079','5915 LIMESTONE MILL DR',0,'SAN ANTONIO','TX','78244','2502','CY','48029','1991-09-18','F','U',':RET:2106-3','N','021','DEN','1517336','33348TX002000101','2014-02-01','2013-12-27 12:48:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-28 03:31:41'),(4254,3389,'Y','18','021','EC','A','','','AC','0000546460','0000546460','OH00000849491','IL','1','Zuelsdorf','Donna','K','','','34','284524087','2123 MARTIN RD',0,'MOGADORE','OH','44260','1332','CY','39133','1951-04-22','F','M',':RET:2106-3','N','021','HLT','2272092','52664OH151001501','2014-01-01','2013-12-16 22:49:23','322.00',NULL,NULL,'768.43','446.43','R-OH012','OH0','768.43',NULL,0,'2013-12-25 21:51:22'),(25460,20200,'Y','18','021','EC','A','','','AC','0000558117','0000558117','TX00003358397','IL','1','Rothkrug','Daniel','','','','34','451493611','1015 GORDON ST',0,'AMARILLO','TX','79104','3300','CY','48375','1978-01-03','M','M',':RET:2106-3','N','021','DEN','3481038','33348TX002000201','2014-04-01','2014-02-25 15:31:16','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-25 21:31:31'),(28194,22310,'Y','18','021','EC','A','','','AC','0001236848','0001236848','TX00002601577','IL','1','Barraza','Maria','Elena','','','34','452821803','122 AVENUE W',0,'LUBBOCK','TX','79415','3704','CY','48303','1949-12-16','F','U',NULL,'N','021','DEN','2682682','33348TX002000201','2014-04-01','2014-03-05 21:27:17','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61','CIC',0,'2014-03-06 21:30:05'),(534,435,'Y','18','021','EC','A','','','AC','0000766803','0000766803','MS00000368943','IL','1','Bateman','Rachell','','','','34','427477350','140 EAGLE DR',0,'BRANDON','MS','39047','7775','CY','28121','1968-04-06','F','U',':RET:2106-3','N','021','DEN','412370','46300MS002000201','2014-01-01','2013-12-04 07:51:56','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 17:49:31'),(22100,17642,'Y','18','021','EC','A','','','AC','0001261244','0001261244','OH00001623496','IL','1','Motz','Christina','','','','34','294902830','2874 PINERIDGE AVE',0,'CINCINNATI','OH','45208','2818','CY','39061','1986-01-19','F','U',':RET:2106-3','N','021','DEN','3573589','99734OH005000301','2014-03-01','2014-02-08 11:06:09','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-08 19:00:29'),(1063,871,'Y','18','021','EC','A','','','AC','0000160752','0000160752','OH00000048864','IL','1','DeVincentis','Dean','','','','34','269506789','96 BUTTERNUT LN',0,'NORTHFIELD','OH','44067','1950','CY','39153','1952-05-15','M','M',':RET:2106-3','N','021','DEN','293750','99734OH005000401','2014-01-01','2013-12-02 19:18:57','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:16:21'),(18038,14410,'Y','18','021','EC','A','','','AC','0000100081','0000100081','OH00002132180','IL','1','McQuillin','Larry','','','','34','292423078','4320 COUNTY ROAD K',0,'DELTA','OH','43515','9705','CY','39051','1952-01-28','M','U',':RET:2106-3','N','021','HLT','2287533','92036OH003002604','2014-02-01','2014-01-13 19:19:03','344.00',NULL,NULL,'585.04','241.04','R-OH001','OH0','585.04',NULL,0,'2014-01-15 02:07:11'),(17669,14119,'N','01','021','EC','A',NULL,NULL,'','0001050659','0000258181','','IL','1','Sarafin','Joyce','E','','','34','296680502','3241 SUGARTREE RD',0,'BETHEL','OH','45106','9329','CY','39025','1959-10-19','F','',':RET:2106-3','N','021','DEN','2301264','99734OH005000301','2014-02-01','2014-01-13 16:48:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:48'),(15669,12536,'N','19','021','EC','A',NULL,NULL,'','0000910535','0000314710','','S3','1','Ayers','Deziree',NULL,NULL,NULL,NULL,NULL,'1802 Rosewood Drive',0,'Wapakoneta','OH','45895',NULL,'CY','39011','2005-02-16','F','',':RET:2106-3','N','021','HLT','1392798','92036OH004001501','2014-02-01','2013-12-31 08:35:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,1,'2014-01-02 04:34:41'),(15016,12003,'Y','18','021','EC','A','','','AC','0000843344','0000843344','OH00002030475','IL','1','KANUCKLE','TESSA','','','','34','278888617','1817 state route 83',0,'millersburg','OH','44654',NULL,'CY','39075','1983-04-06','F','M',NULL,'N','021','HLT','1647404','52664OH151001306','2014-02-01','2013-12-30 18:03:16','474.00',NULL,NULL,'516.93','42.93','R-OH014','OH0','253.11',NULL,0,'2014-01-01 12:02:09'),(4891,3879,'Y','18','021','EC','A','','','AC','0000042017','0000042017','OH00000588057','IL','1','JONES','ALBERTA','','','','34','280683950','1150 PITKIN AVE',0,'AKRON','OH','44310','1121','CY','39153','1971-01-14','F','U',NULL,'N','021','DEN','786731','99734OH005000301','2014-01-01','2013-10-04 14:04:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:31:31'),(4669,3701,'N','19','021','EC','A',NULL,NULL,'','0000008568','0000196517','','IL','1','Jones','Benjamin','b','','Jr','34','661015986','12538 N OAK HILLS PKWY',0,'BATON ROUGE','LA','70810','3239','CY','22033','1999-10-21','M','',':RET:2106-3','N','021','DEN','803427','18575LA002000201','2014-01-01','2013-12-12 13:55:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2013-12-25 22:07:33'),(7926,6267,'Y','18','021','EC','A','','','AC','0001665283','0001665283','LA00001311307','IL','1','Olivier','Shannon','','','','34','436517692','102 PLAUCHE DR',0,'CARENCRO','LA','70520','5707','CY','22055','1982-08-16','M','U',':RET:2106-3','N','021','DEN','1526698','18575LA002000201','2014-01-01','2013-12-20 09:07:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 03:06:27'),(24407,19387,'Y','18','021','EC','A','','','AC','0000731246','0000731246','OH00002541726','IL','1','SMITH','CATHERINE','','','','34','279600594','233 CRAFT ST',0,'CINCINNATI','OH','45232','1603','CY','39061','1956-09-18','F','U',NULL,'N','021','DEN','3540421','99734OH005000401','2014-04-01','2014-02-18 17:05:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:58'),(24901,19741,'N','01','021','EC','A',NULL,NULL,'','0000737896','0000388674','','IL','1','MARTIN','BRANDON','','','','34','298804861','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','1983-03-11','M','',NULL,'N','021','HLT','3420153','92036OH003002705','2014-01-01','2014-02-19 17:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.13','CIC',0,'2014-02-20 05:41:19'),(26251,20821,'Y','18','021','EC','A','','','AC','0000834371','0000834371','TX00002854543','31','1','Villa','Angelica','R','','','34','453212874','P.O. Box 5683',0,'San Angelo','TX','76902',NULL,'CY','48451','1958-03-21','F','M',NULL,'N','021','DEN','2799174','33348TX002000201','2014-03-01','2014-02-27 14:03:32','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-28 06:31:08'),(708,585,'Y','18','021','EC','A','','','AC','0000304855','0000304855','LA00001197955','31','1','LaHaye','DeAnna','','','','34','438868322','32 Hyacinth Dr.',0,'Covington','LA','70433',NULL,'CY','22033','1952-11-13','F','U',':RET:2106-3','N','021','DEN','278345','18575LA002000201','2014-01-01','2013-12-15 22:33:35','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:03:06'),(6597,5231,'Y','18','021','EC','A','','','AC','0000740930','0000740930','MS00001213096','IL','1','Spencer','Mary','','','','34','216782079','194 HIGHWAY 30',0,'BALDWYN','MS','38824','8927','CY','28117','1969-03-18','F','U',':RET:2106-3','T','021','DEN','1140518','46300MS002000101','2014-01-01','2013-12-11 14:14:05','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 00:53:26'),(6538,5184,'Y','18','021','EC','A','','','AC','0000478205','0000478205','TX00001205139','IL','1','mancine','steven','','','','34','007469873','4302 SW 51ST AVE',0,'AMARILLO','TX','79109','6162','CY','48381','1950-07-30','M','M',':RET:2106-3','N','021','DEN','1103756','33348TX002000201','2014-01-01','2013-12-10 22:52:22','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-26 00:51:51'),(20027,15971,'N','01','021','EC','A',NULL,NULL,'','0001435407','0001883134','','IL','1','Le','Son','Thi','','','34','566592335','198 EVANGELINE RD',0,'LA PLACE','LA','70068','8916','CY','22095','1961-10-04','F','',':RET:2047-9','N','021','DEN','2867625','18575LA002000201','2014-03-01','2014-01-25 22:41:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-26 19:00:17'),(13834,11039,'N','19','021','EC','A',NULL,NULL,'','0001031448','0000655813','','IL','1','Sisouphanh','Sebastian','','','','34','277024796','3140 GRENFALL RD',0,'NORTON','OH','44203','5677','CY','39153','1997-04-13','M','',':RET:2028-9','N','021','HLT','1914416','52664OH152000901','2014-01-01','2013-12-23 09:36:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 13:12:08'),(4362,3464,'Y','18','021','EC','A','','','AC','0000051897','0000051897','OH00000717643','IL','1','Meddock','Marsha','','','','34','292420726','2401 BRAHMS BLVD',0,'DAYTON','OH','45449','3327','CY','39113','1957-04-15','F','U',':RET:2106-3','N','021','DEN','1046398','99734OH005000401','2014-01-01','2013-12-11 18:25:04','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:00:03'),(3885,3113,'Y','18','021','EC','A','','','AC','0000928484','0000928484','OH00000697219','IL','1','Heaton','John','M','','','34','298644856','2793 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','2263','CY','39153','1958-01-17','M','M',':RET:2106-3','N','021','HLT','1146485','52664OH152000901','2014-01-01','2013-12-13 11:11:35','643.00',NULL,NULL,'869.01','226.01','R-OH012','OH0','364.25',NULL,0,'2013-12-25 21:36:34'),(13535,10791,'Y','18','021','EC','A','','','AC','0002061638','0002061638','LA00000296666','IL','1','chisholm','terrie','','','','34','435061344','100 DOPSON PL',0,'WEST MONROE','LA','71291','7413','CY','22073','1957-12-01','F','U',':RET:2106-3','N','021','DEN','2489170','18575LA002000201','2014-01-01','2013-12-23 12:34:35','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:03:35'),(8061,6383,'N','01','021','EC','A',NULL,NULL,'','0000230428','0001073140','','IL','1','Koenigseker','Kathleen','G','','','34','300486235','9411 BRINT RD',0,'SYLVANIA','OH','43560','9616','CY','39095','1952-11-20','F','',':RET:2106-3','N','021','HLT','2268413','92036OH003002604','2014-01-01','2013-12-20 13:16:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','572.23',NULL,0,'2013-12-26 03:09:58'),(3602,2888,'Y','18','021','EC','A','','','AC','0000974086','0000974086','OH00000315128','IL','1','COWELL','BRENDA','KAY','','','34','298622892','2448 NORTH NISSEN ROAD',0,'MARTIN','OH','43445',NULL,'CY','39123','1959-05-02','F','M',':RET:2106-3','N','021','HLT','1604073','92036OH002002701','2014-01-01','2013-12-22 11:38:49','1.00',NULL,NULL,'480.78','479.78','R-OH006','OH0','480.78',NULL,0,'2013-12-25 21:23:18'),(1566,1307,'Y','18','021','EC','A','','','AC','0001233014','0001233014','TX00000670401','31','1','Jensen','Eric','','','','34','216602795','6614 S Broadway Ave',0,'Tyler','TX','75703',NULL,'CY','48423','1954-01-13','M','R',':RET:2106-3','N','021','DEN','1599424','33348TX002000201','2014-01-01','2013-12-24 08:04:58','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 18:51:03'),(2009,1648,'Y','18','021','EC','A','','','AC','0000059168','0000059168','LA00000604445','IL','1','Severin','Hietz','','','','34','437920720','7531 E.Oakridge Ct.',0,'New Orleans','LA','70128',NULL,'CY','22071','1953-10-22','M','M',':RET:2054-5','N','021','DEN','312143','18575LA002000201','2014-01-01','2013-11-20 10:22:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:02:26'),(2461,2002,'Y','18','021','EC','A','','','AC','0000904448','0000904448','LA00000448408','IL','1','JENKINS','LILLIAN','','','','34','439177805','861 RWE JONES DR',0,'GRAMBLING','LA','71245',NULL,'CY','22061','1959-09-28','F','U',':RET:2054-5','N','021','DEN','457912','18575LA002000101','2014-01-01','2013-12-08 21:08:19','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 19:34:56'),(25732,20411,'Y','18','021','EC','A','','','AC','0001435416','0001435416','LA00002527610','IL','1','Nicotra','Pamela','','','','34','425132311','201 HIGHLAND DR',0,'HOUMA','LA','70364','2629','CY','22109','1962-11-16','F','M',NULL,'T','021','DEN','3786348','18575LA002000201','2014-04-01','2014-02-24 15:43:36','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-02-26 09:30:36'),(26998,21383,'Y','18','021','EC','A','','','AC','0000624029','0000624029','OH00003466882','IL','1','Burgett','Carol','','','','34','273583588','4947 SMOKETALK LN',0,'WESTERVILLE','OH','43081','4432','CY','39049','1955-02-24','F','U',':RET:2106-3','N','021','DEN','3881826','99734OH005000401','2014-04-01','2014-03-03 07:44:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-03-03 21:00:00'),(27488,21751,'N','19','021','EC','A',NULL,NULL,'','0000891866','0000575983','','IL','1','PHILLIPS','DEMETRIUS','','','','34','282966817','539 LLOYD ST',0,'BARBERTON','OH','44203',NULL,'CY','39153','1993-07-21','M','',':RET:2106-3','N','021','HLT','3953584','52664OH151001304','2014-04-01','2014-03-04 10:48:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-04 21:02:21'),(220,185,'Y','18','021','EC','A','','','AC','0000588231','0000588231','LA00000910292','IL','1','Ford','Agatha','','','','34','438575594','611 SAINT JOHN ST',0,'FRANKLIN','LA','70538','4801','CY','22101','1967-06-07','F','U',':RET:2054-5','N','021','DEN','157757','18575LA002000201','2014-01-01','2013-12-05 11:26:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 17:20:44'),(7284,5776,'N','01','021','EC','A',NULL,NULL,'','0000296769','0000247871','','IL','1','Walker','Willis','R','','','34','287482932','2653 MAYFAIR RD',0,'AKRON','OH','44312','5409','CY','39153','1966-01-14','M','',':RET:2106-3','T','021','HLT','1062341','52664OH151001501','2014-01-01','2013-12-13 20:55:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','480.76',NULL,0,'2013-12-26 02:02:47'),(20037,15979,'N','01','021','EC','A',NULL,NULL,'','0000730002','0000260500','','IL','1','Mason','Leslie','','','','34','276760147','1043 BRAXTON BLVD',0,'LONDON','OH','43140','8424','CY','39097','1975-09-22','F','',NULL,'N','021','DEN','3104934','99734OH005000301','2014-03-01','2014-01-26 17:57:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:24'),(7004,5559,'N','01','021','EC','A',NULL,NULL,'','0001065061','0000880003','','IL','1','Hill','Earnist','','','','34','457695564','392 PRIVATE ROAD 7533',0,'HAWKINS','TX','75765','4815','CY','48499','1980-09-11','M','',':RET:2106-3','N','021','DEN','1600904','33348TX002000201','2014-01-01','2013-12-24 19:19:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:48:21'),(18321,14627,'N','01','021','EC','A',NULL,NULL,'','0000060285','0000863487','','IL','1','MCCUE','SCOTT','','','','34','287487088','1050 N CARPENTER RD',0,'BRUNSWICK','OH','44212','2236','CY','39103','1965-08-10','M','',NULL,'T','021','DEN','2041286','99734OH005000401','2014-02-01','2014-01-15 09:47:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:07'),(16592,13272,'Y','18','021','EC','A','','','AC','0001264685','0001264685','LA00002365289','IL','1','Dudley','William','Lee','','','34','492765274','1630 PARKER ST',0,'FRANKLINTON','LA','70438','1318','CY','22117','1960-09-03','M','M',':RET:2054-5','T','021','DEN','1426448','18575LA002000201','2014-02-01','2014-01-07 16:57:46','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:01'),(6123,4855,'N','01','021','EC','A',NULL,NULL,'','0000111712','0000450463','','IL','1','Yuen','Tina','','','','34','025586876','10737 QUARRY OAKS TRL',0,'AUSTIN','TX','78717','4437','CY','48491','1968-05-17','F','',':RET:2034-7','N','021','DEN','322612','33348TX002000201','2014-01-01','2013-11-20 22:04:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:15:47'),(15775,12624,'Y','18','021','EC','A','','','AC','0001165419','0001165419','TX00000403683','IL','1','zurita','david',NULL,NULL,NULL,NULL,NULL,'304 ensenada',0,'dallas','TX','75211',NULL,'CY','48113','1955-03-15','M','U',NULL,'N','021','DEN','1864683','33348TX002000201','2014-02-01','2014-01-02 15:22:32','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:01:57'),(13782,10999,'N','01','021','EC','A',NULL,NULL,'','0001113390','0000358084','','IL','1','WHITE','ANTONIO','','','','34','427557845','107 SANDSTONE',0,'BRANDON','MS','39047','7421','CY','28121','1971-10-06','M','',':RET:2054-5','N','021','DEN','2238179','46300MS002000201','2014-01-01','2013-12-23 16:17:21',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:46'),(8987,7129,'Y','18','024','14','A','','','TE','0000338853','0000338853','','IL','1','McKinney','Debra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-12','F','',NULL,NULL,NULL,'','2306352','','2013-12-18','2013-12-18 16:50:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:04:29'),(553,453,'N','01','021','EC','A',NULL,NULL,'','0001234073','0000963205','','IL','1','Halcomb','Ajeana','K','','','34','450089574','7525 DAVID DR',0,'N RICHLAND HILLS','TX','76180','6349','CY','48439','1956-03-10','F','',':RET:2106-3','N','021','DEN','664711','33348TX002000101','2014-01-01','2013-12-04 14:47:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 17:50:05'),(801,662,'Y','18','021','EC','A','','','AC','0000573657','0000573657','TX00000297500','IL','1','Jimenez','Gloria','','','','34','462848356','3332 HAGEN CT',0,'LAREDO','TX','78045','8294','CY','48479','1950-10-02','F','M',':RET:2106-3','N','021','DEN','1966607','33348TX002000201','2014-01-01','2013-12-16 17:14:13','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 18:05:33'),(17726,14164,'Y','18','021','EC','A','','','AC','0000055933','0000055933','OH00002389404','IL','1','Connerth','David','','','','34','284662274','3712 SACHEM AVE',0,'CINCINNATI','OH','45226','1754','CY','39061','1961-06-01','M','R',':RET:2106-3','N','021','HLT','2126522','92036OH006001201','2014-02-01','2014-01-13 15:57:26','0.00',NULL,NULL,'332.32','332.32','R-OH004','OH0','332.32',NULL,0,'2014-01-14 01:33:16'),(21032,16805,'Y','18','021','EC','A','','','AC','0000890787','0000890787','OH00002013665','IL','1','GILBERT','DIANE','','','','34','295447885','4820 296TH ST',0,'TOLEDO','OH','43611','2141','CY','39095','1958-12-15','F','U',NULL,'N','021','HLT','3338223','92036OH003002606','2014-03-01','2014-02-01 11:35:15','375.00',NULL,NULL,'454.11','79.11','R-OH001','OH0','454.11',NULL,0,'2014-02-01 19:00:45'),(2709,2192,'N','19','021','EC','A',NULL,NULL,'','0000655790','0000192700','','IL','1','Toth','Caroline',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-05-01','F','',':RET:2106-3','N','021','HLT','428018','52664OH151001501','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 19:47:55'),(14321,11421,'Y','18','021','EC','A','','','AC','0000117806','0000117806','OH00000553494','IL','1','Potts','Laura','L','','','34','296468656','552 S.R. 302',0,'ashland','OH','44805',NULL,'CY','39005','1949-09-24','F','M',NULL,'N','021','HLT','2016526','52664OH151001306','2014-02-01','2013-12-26 12:55:45','645.00',NULL,NULL,'669.00','24.00','R-OH012','OH0','669.00',NULL,0,'2013-12-27 02:07:14'),(13700,10930,'Y','18','021','EC','A','','','AC','0001096757','0001096757','OH00000310075','IL','1','Markle','Paul','','','','34','289707682','5482 LAKEVIEW RD',0,'CORTLAND','OH','44410','9513','CY','39155','1960-09-03','M','U',':RET:2106-3','N','021','HLT','1450493','52664OH151001305','2014-01-01','2013-12-23 12:11:11','346.00',NULL,NULL,'515.91','169.91','R-OH013','OH0','515.91',NULL,0,'2013-12-26 13:08:39'),(13489,10754,'N','19','021','EC','A',NULL,NULL,'','0001205814','0000277272','','IL','1','Koller','Tyler','','','','34','274046105','8770 HILLTOP DR',0,'MENTOR','OH','44060','1932','CY','39085','1998-11-20','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','1533151','99734OH005000301','2014-01-01','2013-12-23 18:04:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:23'),(23473,18696,'Y','18','021','EC','A','','','AC','0000237168','0000237168','TX00001762147','IL','1','Decker','John','','','','34','452907958','2109 Coleman St',0,'san angelo','TX','76901',NULL,'CY','48451','1950-05-15','M','M',':RET:2106-3','N','021','DEN','3582608','33348TX002000201','2014-03-01','2014-02-13 16:29:10','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-13 22:01:49'),(24709,19618,'Y','18','021','EC','A','','','AC','0000194106','0000194106','OH00003008678','S1','1','tucker','christopher','','','','34','291068322','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2001-12-03','M','U',':RET:2106-3','N','021','DEN','3274450','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:35:26'),(26887,21310,'Y','18','021','EC','A','','','AC','0000493301','0000493301','OH00002884745','IL','1','Gaskill','Hollis','','','','34','286806141','506 Collins Ave',0,'Van Wert','OH','45891',NULL,'CY','39161','1974-10-13','M','M',':RET:2106-3','N','021','HLT','3516931','92036OH003001505','2014-04-01','2014-03-02 15:31:39','625.00',NULL,NULL,'866.48','241.48','R-OH002','OH0','290.05',NULL,0,'2014-03-03 01:00:02'),(21769,17384,'Y','18','021','EC','A','','','AC','0000163718','0000163718','OH00002156568','IL','1','Marinelli','Gregory','','','','34','298566041','5941 BALBOA RD',0,'WESTERVILLE','OH','43081','4145','CY','39049','1963-09-11','M','U',':RET:2106-3','N','021','DEN','3839277','99734OH005000401','2014-03-01','2014-02-06 11:19:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:31'),(20381,16281,'Y','18','021','EC','A','','','AC','0000652734','0000652734','TX00001536835','IL','1','FLORES','VERONICA','','','','34','449651796','152 BENSON',0,'BROWNSVILLE','TX','78521','6735','CY','48061','1978-12-09','F','U',NULL,'N','021','DEN','3053202','33348TX002000201','2014-03-01','2014-01-28 20:56:29','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-29 21:00:11'),(15299,12233,'Y','18','021','EC','A','','','AC','0001284859','0001284859','LA00000247895','IL','1','Zachariah','Woodrow','','','','34','439765928','13858 JEFFERSON HWY',0,'BATON ROUGE','LA','70817','5117','CY','22033','1949-08-17','M','U',NULL,'N','021','DEN','1859030','18575LA002000201','2014-02-01','2013-12-31 19:53:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:22:45'),(14323,11423,'Y','18','021','EC','A','','','AC','0001105541','0001105541','OH00000534582','IL','1','Sullivan','Patricia','','','','34','299862176','7453 GOLDENROD DR',0,'MENTOR','OH','44060','3347','CY','39085','1984-10-18','F','U',':RET:2106-3','N','021','HLT','2073968','52664OH151001306','2014-02-01','2013-12-26 14:44:57','193.00',NULL,NULL,'281.45','88.45','R-OH011','OH0','281.45',NULL,0,'2013-12-27 02:07:18'),(9641,7638,'N','01','021','EC','A',NULL,NULL,'','0000446927','0000319213','','IL','1','Burdette','Robert','','','','34','467213173','908 PALITINE LN',0,'PFLUGERVILLE','TX','78660','5148','CY','48453','1958-05-13','M','',':RET:2106-3','N','021','DEN','1560034','33348TX002000101','2014-01-01','2013-12-21 13:44:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 04:38:29'),(5603,4446,'Y','18','021','EC','A','','','AC','0000521921','0000521921','OH00001228969','IL','1','BAAFOUR-AMOAKO','KENNETH','','','','34','071761138','4665 EAST MAIN ST',0,'COLUMBUS','OH','43213',NULL,'CY','39049','1952-09-10','M','U',':RET:2054-5','N','021','DEN','1023919','99734OH005000401','2014-01-01','2013-11-25 19:05:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:30:19'),(4962,3938,'Y','18','021','EC','A','','','AC','0000515258','0000515258','LA00000209756','IL','1','Woods','Jean','','','','34','437110683','3430 HARDY ST',0,'SHREVEPORT','LA','71109','4239','CY','22017','1958-09-10','F','U',':RET:2054-5','N','021','DEN','266505','18575LA002000201','2014-01-01','2013-12-07 10:43:14','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:46:11'),(8981,7124,'Y','18','021','EC','A','','','AC','0000249111','0000249111','OH00000137927','IL','1','Rickett','Annette','','','','34','288523228','811 LESCAR LN',0,'GALLOWAY','OH','43119','8543','CY','39049','1957-12-28','F','U',':RET:2106-3','T','021','DEN','1723742','99734OH005000401','2014-01-01','2013-12-18 15:56:22','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:04:20'),(8044,6368,'Y','18','021','EC','A','','','AC','0000082559','0000082559','OH00000745150','IL','1','FRITZ','DAVID','','','','34','297460429','2854 LAUREL WOODS BLVD',0,'STOW','OH','44224','5120','CY','39153','1949-06-23','M','M',':RET:2106-3','N','021','HLT','2035283','52664OH152000901','2014-01-01','2013-12-20 14:41:44','743.00',NULL,NULL,'980.00','237.00','R-OH012','OH0','490.00',NULL,0,'2013-12-26 03:09:29'),(23216,18507,'Y','18','021','EC','A','','','AC','0001191233','0001191233','MS00002119595','IL','1','Apple White','Barbara','','','','34','428273445','3817 WIGGINS AVE',0,'MOSS POINT','MS','39563','3852','CY','28059','1962-10-06','F','U',':RET:2054-5','T','021','DEN','2646321','46300MS002000201','2014-03-01','2014-02-12 15:11:35','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-12 21:32:16'),(25682,20375,'Y','18','021','EC','A','','','AC','0000823128','0000823128','MS00002617258','IL','1','Pearson','Cedric','','','','34','587574056','2040 Rebecca street',0,'Laurel','MS','39440',NULL,'CY','28067','1980-06-30','M','U',':RET:2054-5','N','021','DEN','3244303','46300MS002000201','2014-04-01','2014-02-23 19:50:20','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-26 09:30:05'),(956,786,'Y','18','021','EC','A','','','AC','0000560512','0000560512','OH00001043896','IL','1','Hollaman','Deotis','Dominic','','','34','288863588','16133 FRIEND AVE',0,'MAPLE HEIGHTS','OH','44137','2841','CY','39035','1986-05-14','M','U',':RET:2054-5','N','021','DEN','619039','99734OH005000301','2014-01-01','2013-10-31 15:46:12','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:09:40'),(7533,5963,'Y','18','021','EC','A','','','AC','0000295924','0000295924','TX00001291970','IL','1','Islam','Syed','','','','34','122632648','13355 US HWY 183 N',0,'Austin','TX','78750',NULL,'CY','48491','1964-01-01','M','M',':RET:2028-9','N','021','DEN','1162495','33348TX002000201','2014-01-01','2013-12-15 11:28:29','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 02:32:44'),(2309,1877,'Y','18','021','EC','A','','','AC','0001005688','0001005688','OH00000038478','IL','1','Cordos','Grigore','','','','34','297026834','2299 HOLLYLANE DR',0,'BROADVIEW HTS','OH','44147','1113','CY','39035','1955-07-19','M','M',':RET:2106-3','N','021','DEN','230865','99734OH005000301','2014-01-01','2013-12-09 17:58:52','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:31:07'),(6963,5528,'Y','18','021','EC','A','','','AC','0000208511','0000208511','OH00001399248','IL','1','Lee','Charranda','','','','34','424943186','5920 Maple Canyon Ave',0,'Columbus','OH','43229',NULL,'CY','39049','1960-05-09','F','M',':RET:2054-5','N','021','DEN','1711863','99734OH005000401','2014-01-01','2013-12-24 22:45:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:18'),(15054,12032,'N','01','021','EC','A',NULL,NULL,'','0001800770','0001371318','','IL','1','BRUNO','TRACI','C','','','34','435539034','102 MARSH DR',0,'LAFAYETTE','LA','70507','4950','CY','22055','1968-06-13','F','',':RET:2054-5','N','021','DEN','1529446','18575LA002000201','2014-02-01','2013-12-30 14:32:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:03:21'),(5709,4532,'Y','18','021','EC','A','','','AC','0000544121','0000544121','OH00000596837','IL','1','JULIANO','JANET','','','','34','019524130','57 LEILA ST',0,'AKRON','OH','44310','3109','CY','39153','1961-05-31','F','U',':RET:2106-3','N','021','HLT','1604231','52664OH151001305','2014-01-01','2013-12-23 21:08:07','269.00',NULL,NULL,'435.31','166.31','R-OH012','OH0','435.31',NULL,0,'2013-12-25 23:45:05'),(4637,3674,'Y','18','021','EC','A','','','AC','0000797767','0000797767','MS00000320278','IL','1','ALISON','DIANE','','','','34','396628859','76 PEARIDGE RD',0,'PIGUNE','MS','39466',NULL,'CY','28109','1955-07-11','F','M',':RET:2106-3','N','021','DEN','95995','46300MS002000201','2014-01-01','2013-12-11 22:41:10','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 22:06:41'),(3025,2433,'Y','18','021','EC','A','','','AC','0000261888','0000261888','MS00000503109','IL','1','Fields','Dorothy','A','','','34','427136120','813 Oakwood Dr',0,'Clinton','MS','39056',NULL,'CY','28049','1962-07-13','F','U',':RET:2054-5','N','021','DEN','650277','46300MS002000201','2014-01-01','2013-12-05 19:34:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 20:18:17'),(14090,11229,'Y','18','021','EC','A','','','AC','0000240355','0000240355','OH00000862472','IL','1','COLEMAN','ANTHONY','','','','34','298663185','1849 ALCOY ROAD',0,'CLEVELAND','OH','44112',NULL,'CY','39035','1960-03-09','M','U',':RET:2054-5','T','021','DEN','2458654','99734OH005000401','2014-02-01','2013-12-26 11:03:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:19'),(22952,18300,'Y','18','021','EC','A','','','AC','0000327240','0000327240','OH00002153234','IL','1','ROLLER','PATRICIA','','','','34','147448027','27192 CLIFFSIDE CIR',0,'OLMSTED TWP','OH','44138','8171','CY','39035','1951-01-08','F','U',':RET:2106-3','N','021','HLT','3727844','52664OH151001306','2014-03-01','2014-02-11 16:55:46','553.00',NULL,NULL,'742.48','189.48','R-OH011','OH0','742.48','CIC',0,'2014-02-11 21:30:29'),(23403,18645,'N','01','021','EC','A',NULL,NULL,'','0000546511','0000529489','','IL','1','Johnson','Jenny','','','','34','295806678','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','1972-10-28','F','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:10'),(23560,18768,'N','01','021','EC','A',NULL,NULL,'','0001236630','0000383402','','IL','1','OVIAHON','ROBIN','','','','34','278706647','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1968-10-29','F','',':RET:2054-5','T','021','HLT','3515021','92036OH005002604','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','323.82',NULL,0,'2014-02-13 22:02:43'),(25299,20072,'Y','18','024','14','A','','','TE','0000270056','0000270056','','IL','1','CLARKE','ELYSE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-15','F','',NULL,NULL,NULL,'','2856415','','2014-03-31','2014-02-25 15:37:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:27'),(27568,21804,'N','19','021','EC','A',NULL,NULL,'','0000209610','0000062593','','IL','1','Tupaz','Josh','Benjamin','','','34','297113562','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','2006-04-11','M','',':RET:2036-2^:RET:2106-3','N','021','DEN','3012426','99734OH005000301','2014-04-01','2014-03-04 14:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:19'),(27944,22106,'Y','18','021','EC','A','','','AC','0000688449','0000688449','TX00003136087','IL','1','STEELMAN','ALLISON','A','','','34','466028868','5445 CARUTH HAVEN LN',0,'DALLAS','TX','75225','8108','CY','48113','1967-05-16','F','U',':RET:2106-3','N','021','DEN','3668581','33348TX002000201','2014-04-01','2014-03-06 15:15:02','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:34'),(28696,22710,'Y','18','021','EC','A','','','AC','0001659591','0001659591','LA00003315589','IL','1','SMITH','IRMA','','','','34','438219768','58733 IRON FARM RD',0,'PLAQUEMINE','LA','70764','3025','CY','22047','1961-07-10','F','U',':RET:2054-5','N','021','DEN','2969799','18575LA002000101','2014-04-01','2014-03-08 13:30:01','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-08 21:31:06'),(19533,15567,'N','01','021','EC','A',NULL,NULL,'','0000828263','0000622516','','IL','1','dukett','donald','webster','','III','34','285705094','2423 W ALEXIS RD',0,'TOLEDO','OH','43613','2138','CY','39095','1966-08-20','M','',':RET:2106-3','N','021','DEN','2554978','99734OH005000401','2014-03-01','2014-01-22 12:50:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:21'),(17049,13642,'Y','18','021','EC','A','','','AC','0000287111','0000287111','OH00001809527','IL','1','Murr','Dawn','','','','34','286762861','8490 E. State Route 162',0,'Republic','OH','44867',NULL,'CY','39147','1977-04-15','F','M',':RET:2106-3','T','021','HLT','2131246','92036OH001002701','2014-02-01','2014-01-09 16:15:27','0.00',NULL,NULL,'332.71','332.71','R-OH006','OH0','332.71',NULL,0,'2014-01-13 02:20:56'),(1472,1227,'Y','18','021','EC','A','','','AC','0000748187','0000748187','OH00001042119','IL','1','White','Daniel','','','','34','299824924','248 MARILEE DR',0,'NEW LEBANON','OH','45345','1449','CY','39113','1984-10-26','M','U',':RET:2106-3','T','021','DEN','1898788','99734OH005000401','2014-01-01','2013-12-24 09:42:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:48:36'),(1726,1437,'N','19','021','EC','A',NULL,NULL,'','0000876064','0000555371','','IL','1','Lynch','Luisa Maria','Maisto','','','34','215552732','287 CASTLE BLVD',0,'AKRON','OH','44313','6534','CY','39153','1999-05-24','F','',':RET:2036-2^:RET:2106-3','N','021','DEN','1370597','99734OH005000301','2014-01-01','2013-12-24 10:25:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:17'),(15815,12660,'Y','18','021','EC','A','','','AC','0000744445','0000744445','OH00001533889','IL','1','Jordan','Renee','','','','34','269862994','631 WORTHINGTON FOREST PL',0,'COLUMBUS','OH','43229','4183','CY','39049','1986-08-18','F','U',':RET:2054-5','N','021','DEN','2129950','99734OH005000401','2014-02-01','2014-01-01 23:55:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:03:20'),(15390,12311,'Y','18','021','EC','A','','','AC','0000108163','0000108163','OH00000144346','IL','1','RHOADES','ELIZABETH','','','','34','283483665','1320 TURKEYFOOT LAKE RD',0,'BARBERTON','OH','44203','4845','CY','39153','1951-09-18','F','M',':RET:2106-3','T','021','HLT','2355435','52664OH151001501','2014-02-01','2014-01-01 11:33:54','131.00',NULL,NULL,'883.69','752.69','R-OH012','OH0','883.69',NULL,1,'2014-01-02 04:25:43'),(6255,4957,'Y','18','021','EC','A','','','AC','0001125401','0001125401','OH00001168038','IL','1','MEADE','ELMER','MALCOM','','','34','284587638','821 FOLEY DR',0,'VANDALIA','OH','45377',NULL,'CY','39113','1956-12-18','M','U',':RET:2106-3','T','021','HLT','1071022','92036OH006000501','2014-01-01','2013-11-19 13:07:15','250.00',NULL,NULL,'528.33','278.33','R-OH003','OH0','528.33',NULL,0,'2013-12-26 00:32:06'),(2652,2155,'Y','18','021','EC','A','','','AC','0000682399','0000682399','TX00000083395','IL','1','Galvan','Cynthia','','','','34','456692387','903 E AVENUE B',0,'SWEETWATER','TX','79556','5502','CY','48353','1983-04-29','F','U',':RET:2106-3','N','021','DEN','365061','33348TX002000101','2014-01-01','2013-12-02 10:12:52','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:46:38'),(3161,2543,'Y','18','021','EC','A','','','AC','0000426390','0000426390','OH00000158748','31','1','Witherspoon','Terrince','','','','34','284729880','416 Knecht Dr.',0,'Dayton','OH','45405',NULL,'CY','39113','1974-05-17','M','U',':RET:2054-5','N','021','DEN','766447','99734OH005000401','2014-01-01','2013-11-18 10:58:12','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:31:19'),(14610,11661,'Y','18','024','14','A','','','TE','0000042017','0000042017','','IL','1','JONES','ALBERTA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-14','F','',NULL,NULL,NULL,'','786731','','2013-12-27','2013-12-27 14:49:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:39'),(3400,2729,'Y','18','021','EC','A','','','AC','0002397094','0002397094','LA00000359790','IL','1','Davis','Dennis','','','','34','439020854','9411 Pitchpine Dr.',0,'Shreveport','LA','71118',NULL,'CY','22017','1963-04-29','M','M',':RET:2054-5','N','021','DEN','1733742','18575LA002000201','2014-01-01','2013-12-22 10:47:42','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2013-12-25 21:18:05'),(4447,3534,'Y','18','021','EC','A','','','AC','0000690721','0000690721','OH00000406371','IL','1','Bond','Karen','','','','34','282604372','2842 State Route 335',0,'Portsmouth','OH','45662',NULL,'CY','39145','1956-09-15','F','U',':RET:2106-3','N','021','DEN','871051','99734OH005000301','2014-01-01','2013-12-12 09:35:35','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 22:02:18'),(24382,19367,'Y','18','021','EC','A','','','AC','0000899617','0000899617','OH00002825584','IL','1','CURTIS','DAEBORAH','','','','34','301442474','6121 BROADWELL CT',0,'GALLOWAY','OH','43119','8516','CY','39049','1952-06-11','F','M',':RET:2106-3','N','021','DEN','3479566','99734OH005000401','2014-04-01','2014-02-18 10:13:20','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-18 22:00:45'),(24952,19786,'Y','18','021','EC','A','','','AC','0002264058','0002264058','LA00002705921','IL','1','Salinas','Jose','','','','34','639010247','73211 plantation st',0,'Covington','LA','70435',NULL,'CY','22103','1966-08-11','M','U',NULL,'N','021','DEN','2959618','18575LA002000201','2014-04-01','2014-02-20 00:07:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:12'),(299,247,'N','01','021','EC','A',NULL,NULL,'','0000236226','0000465881','','IL','1','Veyon','Rebecca','','','','34','299843556','18883 PINKLEY RD',0,'FREDERICKTOWN','OH','43019','9363','CY','39083','1969-12-27','F','',':RET:2106-3','N','021','DEN','111511','99734OH005000401','2014-01-01','2013-11-13 17:34:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:30:46'),(7013,5567,'Y','18','021','EC','A','','','AC','0001015436','0001015436','TX00000221508','IL','1','neill','hannah','','','','34','630165697','4413 40th street',0,'lubbock','TX','79414',NULL,'CY','48303','1990-03-19','F','U',':RET:2106-3','N','021','DEN','1976833','33348TX002000201','2014-01-01','2013-12-24 20:06:20','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 01:48:35'),(21098,16861,'Y','18','021','EC','A','','','AC','0000357231','0000357231','OH00002221283','IL','1','Phillips','Robin','','','','34','290522132','1304 Brookview',0,'Toledo','OH','43615',NULL,'CY','39095','1956-10-15','F','U',':RET:2054-5','N','021','HLT','2940059','92036OH004002601','2014-03-01','2014-02-02 16:40:46','310.00',NULL,NULL,'382.11','72.11','R-OH001','OH0','382.11',NULL,0,'2014-02-02 19:00:33'),(20719,16556,'Y','18','021','EC','A','','','AC','0000560561','0000560561','OH00002169134','IL','1','KOCH','MARY','','','','34','277583977','2005 STILL WATER LN',0,'MILFORD','OH','45150','4510','CY','39025','1955-08-07','F','U',NULL,'T','021','HLT','2932122','92036OH006000601','2014-03-01','2014-01-30 12:11:08','414.00',NULL,NULL,'498.84','84.84','R-OH005','OH0','498.84',NULL,0,'2014-01-30 21:01:13'),(17339,13870,'Y','18','021','EC','A','','','AC','0000938539','0000938539','OH00002545784','IL','1','Vasquez','Blanca','','','','34','287809469','1543 CRESTWOOD RD',0,'TOLEDO','OH','43612','2770','CY','39095','1983-08-05','F','U',NULL,'N','021','HLT','1438736','92036OH002002601','2014-02-01','2014-01-09 18:38:28','0.00',NULL,NULL,'255.59','255.59','R-OH001','OH0','255.59',NULL,0,'2014-01-13 02:24:01'),(17594,14063,'Y','18','021','EC','A','','','AC','0001124576','0001124576','MS00002566721','IL','1','Suttle','Karen','','','','34','425116332','1924 LONGWOOD DR',0,'JACKSON','MS','39212','2510','CY','28049','1956-10-09','F','M',':RET:2106-3','T','021','DEN','1364654','46300MS002000201','2014-02-01','2014-01-12 18:48:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-14 01:32:12'),(14228,11346,'Y','18','021','EC','A','','','AC','0000935312','0000935312','TX00001608997','IL','1','Brown','Chris','','','','34','461471507','1610 ridgeway',0,'Temple','TX','76502',NULL,'CY','48027','1964-08-02','M','U',':RET:2106-3','N','021','DEN','2128495','33348TX002000201','2014-02-01','2013-12-26 18:17:03','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-27 02:04:53'),(4828,3825,'Y','18','021','EC','A','','','AC','0000133291','0000133291','OH00000489419','IL','1','ickes','michael','','','','34','289805918','116 n maple st.',0,'Oak harbor','OH','43449',NULL,'CY','39123','1979-12-10','M','U',':RET:2106-3','N','021','HLT','1163519','92036OH005002706','2014-01-01','2013-12-08 14:42:47','200.00',NULL,NULL,'236.72','36.72','R-OH006','OH0','236.72',NULL,0,'2013-12-25 22:17:15'),(9596,7600,'Y','18','021','EC','A','','','AC','0000088553','0000088553','OH00000632076','IL','1','Vaughan','Jordan','','','','34','281962854','961 E Main St',0,'Geneva','OH','44041',NULL,'CY','39007','1993-03-18','M','M',':RET:2106-3','N','021','HLT','1803110','52664OH151001306','2014-01-01','2013-12-21 00:07:32','127.00',NULL,NULL,'159.71','32.71','R-OH011','OH0','159.71',NULL,0,'2013-12-26 04:37:17'),(23866,18990,'Y','18','024','14','A','','','TE','0001181061','0001181061','','IL','1','Germani','Gerard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-22','M','',NULL,NULL,NULL,'','3120955','','2014-02-14','2014-02-14 11:08:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:32:07'),(26011,20630,'Y','18','021','EC','A','','','AC','0000584321','0000584321','OH00002836955','IL','1','Schlechty','Michael','','','','34','299641576','511 N WASHINGTON ST',0,'VAN WERT','OH','45891','1262','CY','39161','1960-01-25','M','U',':RET:2106-3','N','021','HLT','3243268','92036OH003001501','2014-04-01','2014-02-26 10:34:38','262.00',NULL,NULL,'490.70','228.70','R-OH002','OH0','490.70',NULL,0,'2014-02-26 21:02:10'),(27880,22055,'Y','18','021','EC','A','','','AC','0000588036','0000588036','OH00003457771','IL','1','klewer','mark','','','','34','290849311','5202.5 WILLOW CT',0,'CELINA','OH','45822','8880','CY','39107','1970-08-22','M','U',':RET:2106-3','N','021','HLT','3846556','92036OH005001506','2014-04-01','2014-03-05 11:03:52','236.00',NULL,NULL,'298.65','62.65','R-OH002','OH0','298.65',NULL,0,'2014-03-05 21:32:32'),(792,654,'Y','18','021','EC','A','','','AC','0001229370','0001229370','TX00000087692','IL','1','Bell','Bryan','Marsh','','','34','453804353','714 BURLESON ST',0,'SAN MARCOS','TX','78666','4335','CY','48209','1951-04-01','M','R',':RET:2106-3','N','021','DEN','2394994','33348TX002000201','2014-01-01','2013-12-16 16:35:44','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:05:21'),(22590,18043,'Y','18','021','EC','A','','','AC','0001020454','0001020454','OH00002364917','IL','1','Douglas','Gregory','','','','34','366761483','627 Virginia Street',0,'Toledo','OH','43620',NULL,'CY','39095','1974-10-19','M','M',NULL,'N','021','HLT','3051090','92036OH006002601','2014-03-01','2014-02-10 12:24:13','98.00',NULL,NULL,'195.16','97.16','R-OH001','OH0','195.16',NULL,0,'2014-02-10 21:32:08'),(1089,895,'Y','18','021','EC','A','','','AC','0000818541','0000818541','OH00000355587','IL','1','BRATKA','CHRISTINE','L','','','34','284546723','4117 KARL RD',0,'COLUMBUS','OH','43224','2079','CY','39049','1951-10-21','F','U',':RET:2106-3','N','021','DEN','771573','99734OH005000401','2014-01-01','2013-12-03 13:37:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:16:59'),(20130,16063,'Y','18','024','14','A','','','TE','0000243760','0000243760','','IL','1','Williams','Carla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-18','F','',NULL,NULL,NULL,'','1605989','','2014-01-27','2014-01-27 12:02:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:51'),(19901,15873,'N','19','021','EC','A',NULL,NULL,'','0000679562','0000377491','','S1','1','Sherman','Darris','Leroy','','','34','273045499','600 GLENWOOD RD',0,'ROSSFORD','OH','43460','1508','CY','39173','1998-12-26','M','',NULL,'N','021','HLT','2925974','92036OH002002601','2014-03-01','2014-01-23 20:08:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-01-24 21:00:56'),(18485,14744,'Y','18','021','EC','A','','','AC','0000092543','0000092543','OH00002159297','IL','1','Ransom','Brent','','','','34','296743011','515 7th Street NW',0,'North Canton','OH','44720',NULL,'CY','39151','1979-09-15','M','M',':RET:1002-5^:RET:2106-3','N','021','HLT','2342101','52664OH151001305','2014-02-01','2014-01-15 12:12:34','271.00',NULL,NULL,'537.89','266.89','R-OH015','OH0','270.73',NULL,0,'2014-01-16 08:46:23'),(18258,14577,'Y','18','021','EC','A','','','AC','0000233201','0000233201','TX00002464878','IL','1','FLORES','TANYA','','','','34','571736368','10380 THOR ST',0,'EL PASO','TX','79924',NULL,'CY','48141','1981-03-19','F','M',NULL,'N','021','DEN','2765553','33348TX002000201','2014-02-01','2014-01-15 16:28:45','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-16 08:44:35'),(17539,14022,'Y','18','024','14','A','','','TE','0000025308','0000025308','','IL','1','Gilmer','Martin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-05','M','',NULL,NULL,NULL,'','2133686','','2014-01-12','2014-01-12 17:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:47'),(13194,10527,'Y','18','021','EC','A','','','AC','0000932448','0000932448','TX00001097828','IL','1','Lee','Kimberly','','','','34','465912601','2501 KENILWORTH DR',0,'CORINTH','TX','76208','4818','CY','48121','1978-02-11','F','M',':RET:2106-3','N','021','DEN','1793327','33348TX002000101','2014-01-01','2013-12-23 12:20:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:44'),(14576,11631,'Y','18','021','EC','A','','','AC','0001810943','0001810943','LA00000218141','IL','1','JACKSON','GLORIA','','','','34','433276884','7652 BLES AVE',0,'BATON ROUGE','LA','70810',NULL,'CY','22033','1961-10-02','F','U',':RET:2054-5','T','021','DEN','2592694','18575LA002000101','2014-02-01','2013-12-27 09:48:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-28 03:35:42'),(15209,12155,'Y','18','024','14','A','','','TE','0000522506','0000522506','','IL','1','Nguyen','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-11','M','',NULL,NULL,NULL,'','1456950','','2013-12-30','2013-12-30 18:29:00',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-01 12:07:39'),(15551,12444,'Y','18','021','EC','A','','','AC','0001345305','0001345305','LA00000609734','IL','1','KEMP','DAWANDA','','','','34','433718706','10210 AVENUE',0,'baton rouge','LA','70807',NULL,'CY','22033','1987-10-02','F','U',':RET:2054-5','N','021','DEN','2581483','18575LA002000201','2014-02-01','2013-12-31 16:30:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:31:17'),(15854,12693,'Y','18','021','EC','A','','','AC','0001144780','0001144780','OH00001688498','IL','1','Huff','Ronda','','','','34','288560395','2163 COUNTY ROAD 175',0,'JEROMESVILLE','OH','44840','9626','CY','39005','1966-12-08','F','U',':RET:2106-3','T','021','HLT','2146332','52664OH151001306','2014-02-01','2014-01-01 19:09:34','319.00',NULL,NULL,'400.84','81.84','R-OH012','OH0','400.84',NULL,0,'2014-01-03 02:04:30'),(25343,20108,'Y','18','021','EC','A','','','AC','0000350623','0000350623','OH00002891341','IL','1','Purtty','Jamey','','','','34','302827724','540 E 124TH ST',0,'CLEVELAND','OH','44108','1809','CY','39035','1985-06-08','F','U',':RET:2054-5','N','021','HLT','2883016','52664OH152001001','2014-04-01','2014-02-24 18:08:43','0.00',NULL,NULL,'150.31','150.31','R-OH011','OH0','150.31',NULL,0,'2014-02-25 21:30:26'),(22096,17638,'Y','18','021','EC','A','','','AC','0000008455','0000008455','OH00002154321','IL','1','Dugas','Elizabeth','','','','34','295720925','7461 Quail Hollow St NW',0,'Massillon','OH','44646',NULL,'CY','39151','1972-12-29','F','R',':RET:2106-3','N','021','DEN','2819200','99734OH005000301','2014-03-01','2014-02-07 18:58:09','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-08 19:00:27'),(21647,17286,'N','01','021','EC','A',NULL,NULL,'','0000356066','0000079944','','IL','1','khosa','sarabjit','k','','','34','272178690','4001 SHARON PARK LN',0,'CINCINNATI','OH','45241','4001','CY','39061','1970-09-09','F','',':RET:2029-7','N','021','HLT','3417618','92036OH006001201','2014-03-01','2014-02-04 19:25:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.02',NULL,0,'2014-02-05 21:30:48'),(7650,6057,'Y','18','021','EC','A','','','AC','0000642518','0000642518','TX00000342443','IL','1','Caceres','Josephine','','','','34','546591183','9115 Mission Pass',0,'San Antonio','TX','78223',NULL,'CY','48029','1969-05-23','F','U',':RET:2106-3','N','021','DEN','156299','33348TX002000201','2014-01-01','2013-11-10 11:14:11','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 02:46:50'),(17172,13740,'N','19','021','EC','A',NULL,NULL,'','0000789678','0000284419','','S1','1','Crates','James','Frederick','','','34','278983247','339 East Maple Street',0,'Granville','OH','43023',NULL,'CY','39089','1995-01-30','M','',':RET:2106-3','N','021','DEN','1377404','99734OH005000301','2014-02-01','2014-01-07 19:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:22:08'),(7397,5854,'N','01','021','EC','A',NULL,NULL,'','0000653161','0000115458','','IL','1','Hoffman','Carol','Ann','','','34','298563764','221 BEERSHEBA RD SE',0,'GNADENHUTTEN','OH','44629','9773','CY','39157','1955-03-04','F','',':RET:2106-3','N','021','DEN','379539','99734OH005000301','2014-01-01','2013-11-23 08:09:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:16:19'),(15651,12521,'Y','18','021','EC','A','','','AC','0001000346','0001000346','MS00001137962','IL','1','Hart','Dessie','','','','34','426922655','P O Box 77',0,'Jonestown','MS','38639',NULL,'CY','28027','1951-10-21','F','U',':RET:2054-5','N','021','DEN','1674432','46300MS002000201','2014-02-01','2013-12-31 16:08:51','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,1,'2014-01-02 04:34:07'),(2867,2317,'Y','18','021','EC','A','','','AC','0000694155','0000694155','OH00000477354','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',':RET:2106-3','N','021','HLT','56646','92036OH005000506','2014-01-01','2013-11-01 21:33:59','421.00',NULL,NULL,'424.53','3.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 20:01:48'),(6534,5181,'Y','18','021','EC','A','','','AC','0001000382','0001000382','TX00000631614','IL','1','Kwong','Chi','','','','34','632586952','17618 Cleeves Dr.',0,'Richmond','TX','77407',NULL,'CY','48157','1950-09-12','M','M',':RET:2034-7','N','021','DEN','688784','33348TX002000201','2014-01-01','2013-12-10 22:24:27','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:51:45'),(6304,5001,'Y','18','021','EC','A','','','AC','0000031913','0000031913','OH00001144464','IL','1','sell','walter','allan','','','34','295488640','5762 AUSTER RD',0,'WAKEMAN','OH','44889','9735','CY','39077','1952-10-13','M','M',':RET:2106-3','N','021','DEN','148117','99734OH005000401','2014-01-01','2013-12-11 09:54:33','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 00:46:00'),(5318,4217,'Y','18','021','EC','A','','','AC','0000762277','0000762277','OH00000270324','IL','1','Stein','Sara','L','','','34','279421493','24160 BUCKHURST DR',0,'BEACHWOOD','OH','44122','1676','CY','39035','1954-10-12','F','M',':RET:2106-3','N','021','DEN','2325172','99734OH005000301','2014-01-01','2013-12-18 20:18:19','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:06:45'),(13161,10499,'Y','18','021','EC','A','','','AC','0000120089','0000120089','OH00000706369','IL','1','Pierson','Ramie','','','','34','302489050','700 EWING RD',0,'BAINBRIDGE','OH','45612','9476','CY','39141','1950-08-18','M','M',':RET:2106-3','N','021','DEN','2288100','99734OH005000401','2014-01-01','2013-12-23 18:01:46','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2013-12-26 12:53:51'),(23313,18583,'Y','18','021','EC','A','','','AC','0000251668','0000251668','OH00002370130','IL','1','BAGGETT','MICHELLE','','','','34','298604678','4573 ANTHONY ST',0,'CINCINNATI','OH','45223','1720','CY','39061','1963-03-13','F','U',NULL,'N','021','DEN','3555842','99734OH005000301','2014-03-01','2014-02-13 12:25:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:21'),(23578,18785,'Y','18','024','14','A','','','TE','0000927348','0000927348','','IL','1','Duggins','Angela','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-04-28','F','',NULL,NULL,NULL,'','3545034','','2014-02-13','2014-02-13 11:50:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:02:56'),(24072,19144,'Y','18','021','EC','A','','','AC','0000859738','0000859738','OH00001486300','IL','1','GRABSKI','BRANDON','LEE','','','34','277929035','6615 CLEVELAND RD',0,'RABENNA','OH','44266',NULL,'CY','39133','1989-03-04','M','U',':RET:2106-3','N','021','HLT','2628946','52664OH151001304','2014-03-01','2014-02-15 09:54:57','79.00',NULL,NULL,'223.01','144.01','R-OH012','OH0','223.01',NULL,0,'2014-02-15 22:01:17'),(26378,20926,'Y','18','021','EC','A','','','AC','0001747612','0001747612','LA00002731593','IL','1','Bates','Dorey','Lee','','','34','433738020','11156 OAK RIDGE DR',0,'DENHAM SPRINGS','LA','70726','7108','CY','22063','1980-10-02','F','M',':RET:2106-3','N','021','DEN','3635282','18575LA002000201','2014-04-01','2014-02-26 13:32:27','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61','CIC',0,'2014-02-28 07:00:18'),(26436,20968,'Y','18','021','EC','A','','','AC','0001081765','0001081765','OH00003040094','31','1','Bencar','Chris','','','','34','272909722','PO Box 593',0,'GENEVA','OH','44041',NULL,'CY','39007','1988-11-18','M','U',':RET:2106-3','N','021','DEN','3126532','99734OH005000401','2014-03-01','2014-02-27 13:06:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-28 07:30:18'),(28176,22298,'N','19','021','EC','A',NULL,NULL,'','0000285689','0001162664','','S1','1','RAFEEDIE','JACOB','ISSA','','','34','275177237','4018 BAYMAR DR',0,'YOUNGSTOWN','OH','44511','3439','CY','39099','2011-04-05','F','',NULL,'N','021','HLT','3906018','92036OH001003201','2014-04-01','2014-03-06 12:39:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','185.41',NULL,0,'2014-03-06 21:02:52'),(3115,2503,'Y','18','021','EC','A','','','AC','0000023454','0000023454','TX00000479589','IL','1','Baker','Nancy','Ann','','','34','350480350','7519 BROMPTON ST',0,'HOUSTON','TX','77025','2203','CY','48201','1954-07-31','F','U',NULL,'N','021','DEN','1206879','33348TX002000201','2014-01-01','2013-10-12 18:56:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:30:09'),(19921,15885,'N','19','021','EC','A',NULL,NULL,'','0000707455','0000101659','','IL','1','THOMPSON','WILLIAM','J','','','34','425673038','110 WINNSBORO CT',0,'JACKSON','MS','39206','2520','CY','28049','1989-07-29','M','',NULL,'N','021','DEN','2920526','46300MS002000101','2014-03-01','2014-01-24 12:06:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-24 21:01:04'),(19851,15833,'Y','18','021','EC','A','','','AC','0001030397','0001030397','OH00001923729','IL','1','WISE','STEPHEN','','','','34','221409885','14724 CLIFTON BLVD',0,'LAKEWOOD','OH','44107','2522','CY','39035','1953-02-16','M','M',':RET:2106-3','N','021','DEN','1535155','99734OH005000301','2014-03-01','2014-01-24 15:20:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-24 21:00:31'),(4249,3384,'N','01','021','EC','A',NULL,NULL,'','0001220248','0000088359','','IL','1','Crepps','Christopher','Lynn','','','34','557255068','3101 HARPERS FERRY LN',0,'AUSTIN','TX','78745','6720','CY','48453','1965-05-28','M','',':RET:2106-3','T','021','DEN','1792963','33348TX002000201','2014-01-01','2013-12-17 17:13:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:51:14'),(5752,4567,'Y','18','021','EC','A','','','AC','0000355195','0000355195','TX00001218315','IL','1','Johnson','Clarence','','','','34','571118455','P.O. Box 301',0,'Euless','TX','70639',NULL,'CY','22115','1969-05-18','M','U',':RET:2054-5','N','021','DEN','2246860','18575LA002000201','2014-01-01','2013-12-24 01:04:16','0.00',NULL,NULL,'14.61','14.61','R-LA006','TX0','14.61',NULL,0,'2013-12-25 23:46:15'),(18410,14687,'Y','18','021','EC','A','','','AC','0001959790','0001959790','LA00001931202','IL','1','Matkowski','Kent','','','','34','530944396','521 Beau Chene Dr',0,'Mandeville','LA','70471',NULL,'CY','22103','1978-12-06','M','U',':RET:2040-4','N','021','DEN','2263105','18575LA002000201','2014-02-01','2014-01-14 19:21:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:47'),(16547,13237,'Y','18','021','EC','A','','','AC','0000595157','0000595157','OH00000532115','IL','1','Hodge','Aaron','','','','34','277709962','20400 HALIFAX RD',0,'BEACHWOOD','OH','44122','6346','CY','39035','1966-05-09','M','U',':RET:2054-5','N','021','DEN','1706482','99734OH005000401','2014-02-01','2014-01-05 16:49:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-07 10:22:35'),(14446,11523,'Y','18','021','EC','A','','','AC','0002071042','0002071042','LA00001064384','IL','1','CLARK','NAEEM','','','','34','437598175','3315 MARTIN LUTHER KING BLVD',0,'NEW ORLEANS','LA','70125',NULL,'CY','22071','1986-01-13','M','U',':RET:2054-5','N','021','DEN','2309885','18575LA002000201','2014-02-01','2013-12-27 12:13:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:21'),(15721,12576,'N','19','021','EC','A',NULL,NULL,'','0001128010','0001068277','','IL','1','Jamison','Claire','','','','34','274178928','160 HICKORY HILLS DR',0,'SPRINGBORO','OH','45066','8625','CY','39165','2011-03-15','F','',':RET:2106-3','N','021','DEN','1945838','99734OH005000301','2014-02-01','2014-01-02 14:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:00:13'),(23331,18596,'Y','18','021','EC','A','','','AC','0000264246','0000264246','OH00002037766','IL','1','Emery','Richard','','','','34','286585424','2435 SIR MARTIN DR',0,'HAMILTON','OH','45013','4274','CY','39017','1955-09-09','M','M',':RET:2106-3','N','021','DEN','3365449','99734OH005000301','2014-03-01','2014-02-13 16:05:10','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:30'),(25757,20430,'Y','18','021','EC','A','','','AC','0001178788','0001178788','TX00001749391','IL','1','ZHOU','TONG','','','','34','638297799','618 GO MAN GO DR',0,'STAFFORD','TX','77477','6360','CY','48157','1958-09-11','F','U',':RET:2034-7','N','021','DEN','3264703','33348TX002000101','2014-04-01','2014-02-24 00:15:45','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-26 09:30:49'),(1810,1488,'Y','18','024','14','A','','','TE','0000077560','0000077560','','IL','1','Paris','Stephen','Douglas',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-23','M','',NULL,NULL,NULL,'','2507712','','2013-12-24','2013-12-24 11:30:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:57:01'),(20195,16115,'Y','18','024','14','A','','','TE','0001090011','0001090011','','IL','1','perkins','willie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-15','F','',NULL,NULL,NULL,'','2486451','','2014-01-27','2014-01-27 10:50:57',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-27 21:01:29'),(17342,13873,'Y','18','024','14','A','','','TE','0000783663','0000783663','','IL','1','Rice','Darius',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-10-16','M','',NULL,NULL,NULL,'','2168348','','2014-01-10','2014-01-10 14:38:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-13 02:24:03'),(3557,2855,'N','01','021','EC','A',NULL,NULL,'','0000768875','0000949509','','IL','1','Brown','Denise','Ann','','','34','269507145','8630 Lawton Dr',0,'Macedonia','OH','44056',NULL,'CY','39153','1951-08-07','F','',NULL,'T','021','HLT','1480023','52664OH151001305','2014-01-01','2013-12-22 12:34:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','736.81',NULL,0,'2013-12-25 21:22:12'),(4952,3930,'N','01','021','EC','A',NULL,NULL,'','0000025403','0000024358','','IL','1','Minson','Amy','D','','','34','434733008','9989 WILCOX ST',0,'SAINT FRANCISVILLE','LA','70775','4407','CY','22125','1988-10-19','F','',NULL,'N','021','DEN','693656','18575LA002000201','2014-01-01','2013-12-06 18:34:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:45:58'),(6785,5381,'Y','18','021','EC','A','','','AC','0001149559','0001149559','TX00000312929','IL','1','Hernandez','Sophie','','','','34','567335730','10126 Lucore',0,'Houston','TX','77017',NULL,'CY','48201','1966-11-30','F','U',':RET:2106-3','N','021','DEN','293688','33348TX002000201','2014-01-01','2013-11-25 17:56:50','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:16:56'),(6680,5298,'Y','18','021','EC','A','','','AC','0000106676','0000106676','OH00000036724','IL','1','Felter','Ashley','','','','34','301849893','24 COOPER ST',0,'WAKEMAN','OH','44889','9790','CY','39077','1987-01-01','F','U',':RET:2106-3','N','021','HLT','865306','92036OH003002706','2014-01-01','2013-11-16 16:22:13','187.00',NULL,NULL,'213.40','26.40','R-OH006','OH0','213.40',NULL,0,'2013-12-26 01:01:21'),(6222,4932,'Y','18','021','EC','A','','','AC','0000204762','0000204762','LA00000864092','IL','1','WAGNER','ASHLEY','','','','34','438592258','3429 Duhon St',0,'Lake Charles','LA','70607',NULL,'CY','22019','1983-08-06','F','U',NULL,'T','021','DEN','1078270','18575LA002000201','2014-01-01','2013-10-16 14:53:24','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 00:31:12'),(145,124,'Y','18','021','EC','A','','','AC','0000447433','0000447433','OH00000222989','IL','1','Dinier','Janet','','','','34','075440782','101 CORNERSTONE AVE',0,'WELLINGTON','OH','44090','1182','CY','39093','1950-11-22','F','U',':RET:2106-3','N','021','HLT','886389','52664OH152000901','2014-01-01','2013-12-05 17:47:47','460.00',NULL,NULL,'543.83','83.83','R-OH011','OH0','543.83',NULL,0,'2013-12-25 17:18:49'),(9077,7203,'Y','18','021','EC','A','','','AC','0000407357','0000407357','OH00000747492','IL','1','FLORES','VICTORIA','','','','34','290624648','10940 AARON DR',0,'CLEVELAND','OH','44130',NULL,'CY','39035','1959-02-11','F','M',':RET:2106-3','N','021','DEN','1732285','99734OH005000301','2014-01-01','2013-12-17 19:22:38','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:06:43'),(8133,6435,'Y','18','021','EC','A','','','AC','0000691804','0000691804','OH00000797178','IL','1','Martin','Tenee','','','','34','294885450','2553 LEXINGTON AVE',0,'COLUMBUS','OH','43211','1357','CY','39049','1988-05-04','F','M',':RET:2054-5','T','021','DEN','28474','99734OH005000301','2014-01-01','2013-11-21 20:37:11','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:15:34'),(8037,6363,'Y','18','021','EC','A','','','AC','0000413355','0000413355','OH00000112841','31','1','Moxley','Robert','Howard','','','34','296483812','PO Box 719',0,'Brunswick','OH','44212',NULL,'CY','39103','1950-10-13','M','R',':RET:2106-3','N','021','HLT','1392276','52664OH152000901','2014-01-01','2013-12-19 21:25:43','0.00',NULL,NULL,'482.18','482.18','R-OH012','OH0','482.18',NULL,0,'2013-12-26 03:09:19'),(529,431,'Y','18','021','EC','A','','','AC','0000064379','0000064379','MS00000445886','IL','1','HUMES','JOHN','E','','','34','370603090','2224 PASS ROAD',0,'BILOXI','MS','39531',NULL,'CY','28047','1955-05-31','M','U',':RET:2054-5','N','021','DEN','362859','46300MS002000201','2014-01-01','2013-12-03 20:50:25','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 17:49:24'),(21293,17014,'N','01','021','EC','A',NULL,NULL,'','0001180852','0001211621','','IL','1','Picquet','Wilson','','','','34','439804687','10953 MAY BELLE CT',0,'BATON ROUGE','LA','70815','5102','CY','22033','1950-12-03','M','',':RET:2054-5','N','021','DEN','3194839','18575LA002000101','2014-03-01','2014-02-04 13:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-04 21:00:07'),(4418,3510,'Y','18','021','EC','A','','','AC','0000966890','0000966890','OH00000538757','IL','1','Brown','Eric','','','','34','292803286','P.O Box 17050',0,'Euclid','OH','44117',NULL,'CY','39035','1972-03-06','M','R',NULL,'N','021','DEN','216360','99734OH005000401','2014-01-01','2013-12-12 15:53:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:33'),(19842,15825,'Y','18','021','EC','A','','','AC','0002339706','0002339706','LA00002049207','IL','1','Galatas','Shelly','','','','34','439677773','358 DAVIS DR',0,'LULING','LA','70070','6002','CY','22089','1974-08-31','F','U',NULL,'N','021','DEN','2750320','18575LA002000201','2014-03-01','2014-01-24 13:08:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-24 21:00:26'),(3471,2788,'Y','18','021','EC','A','','','AC','0001032607','0001032607','OH00000652022','IL','1','HO','AMY','','','','34','284983742','8264 VENTLE DR',0,'WEST CHESTER','OH','45069','2713','CY','39017','1960-03-07','F','M',':RET:2047-9','N','021','DEN','2244155','99734OH005000401','2014-01-01','2013-12-22 10:23:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:19:58'),(23856,18981,'Y','18','021','EC','A','','','AC','0001240100','0001240100','LA00001446856','IL','1','Helfen','Matthias','','','','34','259730111','2251 N DERBIGNY ST',0,'NEW ORLEANS','LA','70117','8250','CY','22071','1987-04-18','M','U',':RET:2106-3','N','021','DEN','3256108','18575LA002000101','2014-03-01','2014-02-14 01:36:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:01'),(22935,18284,'Y','18','021','EC','A','','','AC','0002121098','0002121098','LA00002516302','IL','1','Guitreau','Danny','','','','34','437118134','18681 Scivicque Lane',0,'Port Vincent','LA','70726',NULL,'CY','22063','1955-11-22','M','M',':RET:2106-3','N','021','DEN','2668142','18575LA002000101','2014-03-01','2014-02-10 19:59:43','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02','CIC',0,'2014-02-11 21:30:14'),(9761,7729,'N','01','021','EC','A',NULL,NULL,'','0000496721','0000425051','','IL','1','Ditcher','Nancy','','','','34','272526930','4574 MAPLE GROVE RD SE',0,'UHRICHSVILLE','OH','44683','1350','CY','39157','1953-08-19','F','',NULL,'N','021','DEN','939557','99734OH005000401','2014-01-01','2013-10-20 17:18:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:12'),(15482,12386,'Y','18','021','EC','A','','','AC','0000584282','0000584282','OH00001829266','IL','1','Cooper','Stephanie','Louise','','','34','231667373','924 MORRIS ST',0,'CINCINNATI','OH','45206','2506','CY','39061','1951-04-21','F','M',':RET:2106-3','N','021','DEN','1940832','99734OH005000401','2014-02-01','2013-12-31 08:59:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:29:10'),(16018,12822,'Y','18','021','EC','A','','','AC','0001286276','0001286276','LA00002269563','IL','1','Wilson','Linda','','','','34','434866898','4448 BAYOU DES FAMILLES DR',0,'MARRERO','LA','70072','6500','CY','22051','1954-06-03','F','U',':RET:2054-5','T','021','DEN','1912083','18575LA002000201','2014-02-01','2014-01-02 22:37:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:04'),(16245,13009,'N','01','021','EC','A',NULL,NULL,'','0000468125','0000607171','','IL','1','Patel','Jiviben','K','','','34','366232883','1435 S CARPENTER RD',0,'BRUNSWICK','OH','44212','3861','CY','39103','1963-03-10','F','',':RET:2029-7','N','021','DEN','1530718','99734OH005000301','2014-02-01','2014-01-04 10:41:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:30'),(28517,22567,'Y','18','024','14','A','','','TE','0000376178','0000376178','','IL','1','landrum','jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-01-07','F','',NULL,NULL,NULL,'','2856339','','2014-03-22','2014-03-07 13:02:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-07 21:31:58'),(23008,18343,'Y','18','021','EC','A','','','AC','0001572281','0001572281','LA00001780051','IL','1','Curtis','Willie','','','','34','436047578','2210 VANCE AVE',0,'ALEXANDRIA','LA','71301','4637','CY','22079','1958-02-14','F','U',':RET:2054-5','N','021','DEN','2886171','18575LA002000101','2014-03-01','2014-02-11 18:56:58','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-12 21:30:22'),(9112,7230,'N','19','021','EC','A',NULL,NULL,'','0000814273','0000603348','','IL','1','Hall','Dylan','','','','34','286060017','26 Virginia Avenue',0,'Centerville','OH','45458',NULL,'CY','39113','2001-08-09','M','',':RET:2106-3','N','021','DEN','1840295','99734OH005000301','2014-01-01','2013-12-18 15:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:35'),(22169,17692,'N','01','021','EC','A',NULL,NULL,'','0000891849','0000799930','','IL','1','Colson','Nicholas','Yancy','','','34','284940692','432 E Cleveland St',0,'Delphos','OH','45833',NULL,'CY','39003','1986-01-10','M','',':RET:2106-3','T','021','HLT','3856729','92036OH004001501','2014-03-01','2014-02-08 17:58:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','221.22',NULL,0,'2014-02-08 19:01:03'),(21781,17394,'Y','18','021','EC','A','','','AC','0001075341','0001075341','OH00002519754','IL','1','JANCEWICZ','DAVID','','','','34','275525394','7418 MEADOW LN',0,'PARMA','OH','44134','5937','CY','39035','1964-01-04','M','U',':RET:2106-3','T','021','DEN','2801188','99734OH005000401','2014-03-01','2014-02-05 22:51:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:00:38'),(21446,17141,'Y','18','024','14','A','','','TE','0001104484','0001104484','','IL','1','Ford','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-24','F','',NULL,NULL,NULL,'','1631816','','2014-02-04','2014-02-04 12:15:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:26'),(20501,16379,'Y','18','021','EC','A','','','AC','0002065291','0002065291','LA00002195102','IL','1','Delatte','Deanna','','','','34','433553166','173 West Pinewood Drive',0,'Slidell','LA','70458',NULL,'CY','22103','1968-12-26','F','U',':RET:2106-3','T','021','DEN','3236689','18575LA002000201','2014-03-01','2014-01-29 14:03:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:13'),(18710,14916,'N','19','021','EC','A',NULL,NULL,'','0000854219','0001086806','','IL','1','Henry','Grace',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','2000-10-14','F','',':RET:2106-3','N','021','DEN','3018902','99734OH005000301','2014-02-01','2014-01-15 21:39:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:31'),(18297,14608,'Y','18','024','14','A','','','TE','0001113163','0001113163','','IL','1','Glener','Gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-11-16','M','',NULL,NULL,NULL,'','1773121','','2014-01-14','2014-01-14 22:15:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:44:55'),(18175,14512,'Y','18','021','EC','A','','','AC','0000808675','0000808675','OH00001753455','IL','1','EVES','JOHN','','','','34','191400630','54 VALLEY VIEW PL',0,'TIFFIN','OH','44883',NULL,'CY','39147','1951-04-13','M','M',':RET:2106-3','N','021','HLT','1854279','92036OH005002705','2014-02-01','2014-01-14 12:25:33','934.00',NULL,NULL,'1015.14','81.14','R-OH006','OH0','560.22',NULL,0,'2014-01-15 02:07:59'),(15371,12294,'Y','18','021','EC','A','','','AC','0000056277','0000056277','MS00002111012','IL','1','Walston','Jeannine','','','','34','420963388','4061 34TH AVE',0,'MERIDIAN','MS','39305','3229','CY','28075','1968-07-31','F','U',':RET:1002-5','N','021','DEN','2174789','46300MS002000201','2014-02-01','2013-12-31 22:24:31','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,1,'2014-01-02 04:25:05'),(17233,13791,'Y','18','021','EC','A','','','AC','0000404189','0000404189','MS00002008417','IL','1','TATE','PATRICIA','','','','34','425399562','39 TOLLIVER COVE EXT',0,'CLEVELAND','MS','38732','8789','CY','28011','1970-01-15','F','U',':RET:2054-5','N','021','DEN','2331340','46300MS002000101','2014-02-01','2014-01-08 16:38:32','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:22:40'),(26389,20933,'Y','18','021','EC','A','','','AC','0000194050','0000194050','OH00003235589','IL','1','Taylor','Kathleen','','','','34','277801472','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1981-07-24','F','M',':RET:2106-3','N','021','HLT','2681139','52664OH151001301','2014-03-01','2014-02-26 12:37:30','0.00',NULL,NULL,'658.54','658.54','R-OH012','OH0','263.82','CIC',0,'2014-02-28 07:00:25'),(28828,22815,'Y','18','021','EC','A','','','AC','0000604768','0000604768','OH00002830891','IL','1','MAY','MARY','','','','34','291489172','2907 S BYRNE RD',0,'TOLEDO','OH','43614','5202','CY','39095','1950-03-04','F','U',NULL,'N','021','HLT','3673987','92036OH006002601','2014-04-01','2014-03-09 11:18:49','452.00',NULL,NULL,'463.92','11.92','R-OH001','OH0','463.92',NULL,0,'2014-03-09 21:01:05'),(312,255,'Y','18','021','EC','A','','','AC','0000070783','0000070783','LA00000351172','IL','1','Lombardino','Michael','C','','','34','439212935','31687 Strawberry Lane',0,'Hammond','LA','70403',NULL,'CY','22063','1961-12-13','M','U',':RET:2106-3','N','021','DEN','472725','18575LA002000201','2014-01-01','2013-11-12 21:39:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:31:03'),(21891,17480,'Y','18','021','EC','A','','','AC','0000139216','0000139216','MS00001713158','IL','1','EVANS','PAULA','','','','34','587622065','17 LAUREL GARDEN DR',0,'LAUREL','MS','39440','6102','CY','28067','1954-12-21','F','U',':RET:2054-5','N','021','DEN','2757348','46300MS002000201','2014-03-01','2014-02-06 17:46:53','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-06 21:01:38'),(720,595,'Y','18','021','EC','A','','','AC','0000540730','0000540730','TX00000756887','IL','1','Steinbach','Vicki','','','','34','450962940','6629 VICTORIA AVE',0,'NORTH RICHLAND HILLS','TX','76180','8113','CY','48439','1951-12-14','F','M',':RET:2106-3','N','021','DEN','1032087','33348TX002000101','2014-01-01','2013-12-15 23:48:02','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:03:25'),(21297,17018,'Y','18','021','EC','A','','','AC','0001853950','0001853950','LA00002555107','IL','1','Fine','Angela','','','','34','437572742','370 ANDERSON RD',0,'GRAND CANE','LA','71032','5672','CY','22031','1977-10-08','F','U',':RET:2106-3','T','021','DEN','3566634','18575LA002000101','2014-03-01','2014-02-04 17:02:31','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-04 21:00:10'),(18050,14421,'Y','18','021','EC','A','','','AC','0000186894','0000186894','MS00001936501','31','1','BALDWIN','ADA','D','','','34','426199873','PO BOX 292',0,'HOLLINDALE','MS','38748',NULL,'CY','28151','1957-06-07','F','M',':RET:2054-5','N','021','DEN','1361703','46300MS002000101','2014-02-01','2014-01-14 12:25:50','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-15 02:07:16'),(17511,13998,'N','01','021','EC','A',NULL,NULL,'','0001234135','0000615530','','IL','1','Davis','Sherry','','','','34','302522412','1884 KALE ADAMS RD SW',0,'WARREN','OH','44481','9781','CY','39155','1953-01-27','F','',':RET:2106-3','N','021','DEN','1570118','99734OH005000401','2014-02-01','2014-01-11 21:00:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:29'),(17298,13834,'Y','18','021','EC','A','','','AC','0000368306','0000368306','TX00001549505','IL','1','Hernandez','Maricela','','','','34','243258795','7115 SYLVIA HANDY ST',0,'WESLACO','TX','78596','9059','CY','48215','1975-10-10','F','M',':RET:2106-3','N','021','DEN','1537336','33348TX002000201','2014-02-01','2014-01-10 11:32:14','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-13 02:23:37'),(14554,11612,'N','01','021','EC','A',NULL,NULL,'','0000961874','0000076309','','IL','1','Partin','Edward','Warren','','Jr','34','280469731','799 FAIRWOOD RD',0,'AKRON','OH','44319','4760','CY','39153','1949-05-11','M','',':RET:2106-3','N','021','HLT','2007118','52664OH152000901','2014-02-01','2013-12-27 11:19:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.00',NULL,0,'2013-12-28 03:35:07'),(13268,10589,'Y','18','021','EC','A','','','AC','0001120654','0001120654','TX00000117816','IL','1','Perez','James','','','','34','456779645','64 SUNSHINE RD',0,'BROWNSVILLE','TX','78521','1652','CY','48061','1986-04-11','M','M',':RET:2106-3','N','021','DEN','1929171','33348TX002000201','2014-01-01','2013-12-23 12:19:22','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 12:56:48'),(26420,20953,'Y','18','021','EC','A','','','AC','0000981259','0000981259','TX00002849578','IL','1','Ramos','Adriana','','','','34','558796470','9285 RAILROAD DR',0,'EL PASO','TX','79924','7432','CY','48141','1976-03-28','F','U',NULL,'N','021','DEN','2801663','33348TX002000201','2014-04-01','2014-02-26 20:24:34','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61','CIC',0,'2014-02-28 07:30:07'),(26616,21104,'Y','18','021','EC','A','','','AC','0001114364','0001114364','TX00003092546','IL','1','RIVERA ARROYO','JUAN','FRANCISCO','','','34','467478985','302 N JOHNSON',0,'AMARILLO','TX','79107',NULL,'CY','48375','1950-11-29','M','M',NULL,'N','021','DEN','3569782','33348TX002000201','2014-04-01','2014-02-28 11:17:18','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2014-02-28 21:30:49'),(27463,21734,'Y','18','021','EC','A','','','AC','0000349324','0000349324','OH00003287940','IL','1','McInnes','Debra','Diane','','','34','287560225','2727 CONNECTICUT ST SW',0,'MASSILLON','OH','44646','3955','CY','39151','1954-09-13','F','M',':RET:2106-3','N','021','HLT','3974311','52664OH152000901','2014-04-01','2014-03-04 14:10:06','353.00',NULL,NULL,'425.18','72.18','R-OH015','OH0','425.18',NULL,0,'2014-03-04 21:02:06'),(28343,22426,'Y','18','021','EC','A','','','AC','0000076533','0000076533','TX00002949474','IL','1','bell','rodrick','','','','34','459197182','3628 KILLIAN ST',0,'FORT WORTH','TX','76119','3554','CY','48439','1972-08-16','M','U',':RET:2054-5','N','021','DEN','3478866','33348TX002000201','2014-04-01','2014-03-07 11:06:15','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:18'),(362,299,'Y','18','021','EC','A','','','AC','0000791018','0000791018','TX00000944234','IL','1','Smith','Vickie','','','','34','453619775','523 E 26TH ST',0,'SAN ANGELO','TX','76903','2450','CY','48451','1976-03-17','F','M',':RET:2106-3','T','021','DEN','757207','33348TX002000201','2014-01-01','2013-12-03 20:43:27','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 17:45:12'),(23828,18959,'Y','18','021','EC','A','','','AC','0000061531','0000061531','MS00001785008','IL','1','Lawrence','Mary','','','','34','608564743','409 PARKWAY RD',0,'BRANDON','MS','39047','6125','CY','28121','1972-04-28','F','U',':RET:2036-2','N','021','DEN','3716394','46300MS002000101','2014-03-01','2014-02-13 23:35:28','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-14 21:31:44'),(22294,17797,'Y','18','021','EC','A','','','AC','0000221344','0000221344','OH00002050313','IL','1','behr','jordan','','','','34','271924842','201 N HIGH ST',0,'LEESBURG','OH','45135','9322','CY','39071','1990-02-07','M','U',':RET:2106-3','N','021','DEN','3181806','99734OH005000301','2014-03-01','2014-01-28 19:12:28','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-10 11:00:31'),(9417,7471,'Y','18','024','14','A','','','TE','0000140542','0000140542','','IL','1','Ramirez','Hector',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-31','M','',NULL,NULL,NULL,'','1455253','','2013-12-21','2013-12-21 13:51:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:33:01'),(22227,17742,'Y','18','021','EC','A','','','AC','0002003907','0002003907','LA00002173320','IL','1','Wright','Kelly','','','','34','437416631','6081 FEDERAL 80 HWY',0,'RAYVILLE','LA','71269','6705','CY','22083','1979-10-25','F','M',':RET:2106-3','T','021','DEN','2982680','18575LA002000101','2014-03-01','2014-02-09 17:04:15','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2014-02-09 19:00:30'),(4481,3555,'N','01','021','EC','A',NULL,NULL,'','0000713616','0000087470','','IL','1','Roberts','Mark','D','','','34','268708722','4255 OLD WHEELING RD',0,'ZANESVILLE','OH','43701','7442','CY','39119','1960-04-03','M','',':RET:2106-3','N','021','DEN','477838','99734OH005000301','2014-01-01','2013-12-12 15:17:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:58'),(13211,10542,'N','01','021','EC','A',NULL,NULL,'','0000529280','0000486757','','IL','1','Mount','LaBrina','','','','34','436214745','208 White Oak',0,'Burkeville','TX','75932',NULL,'CY','48351','1960-02-08','F','',':RET:2106-3','T','021','DEN','2168058','33348TX002000201','2014-01-01','2013-12-22 18:37:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:55:15'),(20910,16714,'Y','18','021','EC','A','','','AC','0000251654','0000251654','OH00001881440','IL','1','Richey','Roger','','','','34','280683857','6865 Wharton Rd.',0,'Holland','OH','43528',NULL,'CY','39095','1974-07-06','M','M',':RET:2106-3','N','021','HLT','3548364','92036OH006002601','2014-03-01','2014-01-31 08:38:47','0.00',NULL,NULL,'195.16','195.16','R-OH001','OH0','195.16',NULL,0,'2014-01-31 21:01:26'),(20771,16595,'Y','18','021','EC','A','','','AC','0000646030','0000646030','OH00001586716','IL','1','Carter','Barbara','','','','34','292427425','10107 WILL ALLMAN RD',0,'GEORGETOWN','OH','45121','9228','CY','39015','1956-07-10','F','U',NULL,'N','021','HLT','3525272','92036OH004000601','2014-03-01','2014-01-30 15:22:43','309.00',NULL,NULL,'420.66','111.66','R-OH005','OH0','420.66',NULL,0,'2014-01-30 21:01:40'),(18490,14748,'Y','18','021','EC','A','','','AC','0000399906','0000399906','OH00001362362','IL','1','Weisel','Raymond','','','','34','269843030','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1976-09-08','M','M',':RET:2106-3','N','021','HLT','2092959','52664OH151001306','2014-02-01','2014-01-15 14:58:37','443.00',NULL,NULL,'553.95','110.95','R-OH012','OH0','276.08',NULL,0,'2014-01-16 08:46:25'),(20494,16373,'Y','18','021','EC','A','','','AC','0002048895','0002048895','LA00002349653','IL','1','GRISSOM','VELMA','','','','34','437083295','1801 BOOTH ST',0,'MONROE','LA','71201','8303','CY','22073','1955-03-10','F','U',':RET:2054-5','T','021','DEN','1600313','18575LA002000201','2014-03-01','2014-01-29 10:01:14','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-29 21:01:09'),(25810,20467,'Y','18','021','EC','A','','','AC','0000371532','0000371532','OH00002956864','IL','1','Davis','Denise','','','','34','272483742','445 Gilpin Dr.',0,'Springboro','OH','45066',NULL,'CY','39165','1953-10-14','F','U',':RET:2054-5','T','021','DEN','3002757','99734OH005000301','2014-03-01','2014-02-26 13:27:14','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:21'),(26216,20792,'Y','18','021','EC','A','','','AC','0000043275','0000043275','OH00003363759','IL','1','ULM','EMILY','M','','','34','268888705','533 ROCKWELL ST',0,'KENT','OH','44240','2245','CY','39133','1980-01-03','F','M',NULL,'N','021','HLT','3728246','52664OH151001305','2014-04-01','2014-02-27 17:20:46','399.00',NULL,NULL,'605.24','206.24','R-OH012','OH0','270.73',NULL,0,'2014-02-28 06:30:55'),(5249,4163,'Y','18','021','EC','A','','','AC','0000035745','0000035745','OH00000216349','IL','1','stalnaker','courtney','','','','34','274866517','1140 jessie ave',0,'kent','OH','44240',NULL,'CY','39133','1969-02-01','F','U',':RET:2106-3','T','021','HLT','1690788','52664OH151001305','2014-01-01','2013-12-19 08:45:01','168.00',NULL,NULL,'358.27','190.27','R-OH012','OH0','358.27',NULL,0,'2013-12-25 23:05:05'),(17641,14101,'Y','18','021','EC','A','','','AC','0000329660','0000329660','OH00002298584','IL','1','ROBERSON','HORACE','','','Sr','34','302443031','5984 BAGDAD DR',0,'CINCINNATI','OH','45230','1301','CY','39061','1949-10-23','M','M',NULL,'N','021','DEN','1608696','99734OH005000301','2014-02-01','2014-01-13 07:32:30','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:36'),(6838,5421,'Y','18','021','EC','A','','','AC','0000767371','0000767371','OH00001152753','IL','1','Dougherty','Patrick','','','','34','287561203','21 E.Court St.',0,'Cincinnati','OH','45202',NULL,'CY','39061','1956-04-23','M','U',':RET:2106-3','N','021','DEN','360443','99734OH005000401','2014-01-01','2013-11-14 17:27:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:30:59'),(6265,4967,'Y','18','021','EC','A','','','AC','0000141467','0000141467','OH00000580443','IL','1','Hamilton','Teri','','','','34','292586136','4414 Roosevelt blvd',0,'Middletown','OH','45044',NULL,'CY','39017','1967-01-22','F','U',NULL,'N','021','HLT','744090','92036OH004001201','2014-01-01','2013-10-07 17:16:32','0.00',NULL,NULL,'258.91','258.91','R-OH004','OH0','258.91',NULL,0,'2013-12-26 00:32:21'),(16373,13101,'N','01','021','EC','A',NULL,NULL,'','0000248090','0000651211','','IL','1','Coronado','Debra','','','','34','459515568','4220 LANGDON DR',0,'CONVERSE','TX','78109','5159','CY','48029','1975-02-01','F','',NULL,'N','021','DEN','2215004','33348TX002000101','2014-02-01','2014-01-06 13:07:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-07 04:03:04'),(13218,10546,'N','19','021','EC','A',NULL,NULL,'','0000553050','0000393282','','IL','1','Legg','Caroline','','','','34','632113014','227 RED HAWK RDG',0,'SAN ANTONIO','TX','78258','4866','CY','48029','1991-06-21','F','',':RET:2106-3','N','021','DEN','1980234','33348TX002000201','2014-01-01','2013-12-22 19:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:55:25'),(13688,10922,'Y','18','021','EC','A','','','AC','0000346895','0000346895','OH00000586250','IL','1','Piekarski','Anthony','','','','34','279765141','702 KNOLLWOOD DR',0,'UNIONTOWN','OH','44685','9615','CY','39153','1980-06-03','M','U',':RET:2106-3','T','021','HLT','2235445','52664OH151001305','2014-01-01','2013-12-23 10:03:31','178.00',NULL,NULL,'307.24','129.24','R-OH012','OH0','307.24',NULL,0,'2013-12-26 13:08:23'),(23432,18666,'Y','18','021','EC','A','','','AC','0000874354','0000874354','TX00001849356','IL','1','Ringo','Mary','','','','34','450088231','1516 Southern Plantation Dr.',0,'College Station','TX','77845',NULL,'CY','48041','1954-12-20','F','M',':RET:2106-3','T','021','DEN','2651023','33348TX002000201','2014-03-01','2014-02-13 09:41:19','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-02-13 22:01:27'),(23669,18846,'Y','18','021','EC','A','','','AC','0001165575','0001165575','TX00001492969','IL','1','herrington','melissa','elizabeth','','','34','179620068','205 N TEXAS AVE',0,'BLOOMBURG','TX','75556','2259','CY','48067','1980-07-26','F','U',':RET:2106-3','N','021','DEN','2904926','33348TX002000201','2014-03-01','2014-02-14 15:48:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:23'),(25073,19884,'N','19','021','EC','A',NULL,NULL,'','0000290854','0000237633','','IL','1','MCDUNNELL','SAMANTHA','','','','34','667094427','204 W SUGAR ST',0,'CRIDERSVILLE','OH','45806','2346','CY','39011','1994-11-29','F','',NULL,'N','021','HLT','3320838','92036OH005001506','2014-04-01','2014-02-20 10:59:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-02-20 22:01:32'),(26872,21297,'N','01','021','EC','A',NULL,NULL,'','0000921982','0000110572','','IL','1','loveland','elisa','','','','34','501984387','3047 LOVERS LN',0,'RAVENNA','OH','44266','8929','CY','39133','1963-06-16','F','',':RET:2106-3','N','021','HLT','3446111','52664OH151001301','2014-04-01','2014-03-01 13:22:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.29',NULL,0,'2014-03-01 21:01:03'),(27137,21484,'Y','18','021','EC','A','','','AC','0000171285','0000171285','OH00003450070','IL','1','Moody','JoAnn','','','','34','291503304','895 STATE ROUTE 302',0,'ASHLAND','OH','44805','9577','CY','39005','1949-12-07','F','U',NULL,'N','021','DEN','2909486','99734OH005000401','2014-04-01','2014-03-03 11:35:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-03 21:30:44'),(28952,22913,'Y','18','021','EC','A','','','AC','0001969407','0001969407','LA00003456627','IL','1','Dugas','Jessica','lynn','','','34','438657231','124 S MILITARY RD',0,'SLIDELL','LA','70461','4157','CY','22103','1987-05-11','F','U',':RET:2106-3','N','021','DEN','2958653','18575LA002000201','2014-04-01','2014-03-10 10:21:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:50'),(366,303,'Y','18','021','EC','A','','','AC','0000817778','0000817778','TX00001190278','IL','1','parks','carissa','','','','34','453854356','1101 HIGHLAND AVE',0,'ABILENE','TX','79605','4209','CY','48441','1971-12-12','F','U',':RET:2106-3','N','021','DEN','1191841','33348TX002000201','2014-01-01','2013-12-04 00:17:18','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-25 17:45:19'),(23055,18382,'Y','18','021','EC','A','','','AC','0001255755','0001255755','LA00001570989','IL','1','Russo','Rusty','D','','','34','439350342','209 MASTERS POINT CT',0,'SLIDELL','LA','70458','5786','CY','22103','1979-01-09','M','M',':RET:2106-3','N','021','DEN','3767594','18575LA002000201','2014-03-01','2014-02-11 23:07:57','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:48'),(2664,2164,'Y','18','021','EC','A','','','AC','0000987360','0000987360','OH00000733957','IL','1','Carnes','Michael','','','','34','310548586','461 SANOMA CT',0,'CINCINNATI','OH','45255','5645','CY','39025','1951-01-09','M','M',':RET:2106-3','N','021','DEN','438721','99734OH005000301','2014-01-01','2013-12-02 11:45:40','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-25 19:46:54'),(6577,5215,'Y','18','021','EC','A','','','AC','0001248307','0001248307','OH00000681847','IL','1','Noertker','Daniel','','','Jr','34','289843353','4555 STATE ROUTE 276',0,'BATAVIA','OH','45103','2108','CY','39025','1982-09-09','M','M',':RET:2106-3','N','021','HLT','494804','92036OH005000604','2014-01-01','2013-12-10 20:28:13','207.00',NULL,NULL,'497.62','290.62','R-OH005','OH0','248.81',NULL,0,'2013-12-26 00:52:52'),(3346,2681,'N','01','021','EC','A',NULL,NULL,'','0001156018','0001166407','','IL','1','Samudio','Sterling','Ray','','','34','417940825','13221 BLUFF VIEW DR',0,'WILLIS','TX','77318','5304','CY','48339','1968-10-07','M','',':RET:2106-3','N','021','DEN','2170313','33348TX002000201','2014-01-01','2013-12-21 23:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:16:37'),(22701,18127,'Y','18','021','EC','A','','','AC','0000388146','0000388146','TX00002603472','IL','1','dao','tam thuy','thi','','','34','642421911','1617 ARBOR CREEK DR',0,'GARLAND','TX','75040','8922','CY','48113','1952-04-29','F','M',':RET:2047-9','N','021','DEN','2757442','33348TX002000101','2014-03-01','2014-02-11 15:39:35','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-11 21:00:59'),(13474,10745,'N','19','021','EC','A',NULL,NULL,'','0001240556','0000545244','','IL','1','HUNT','JONATHON','H','','','34','766209986','8330 MEETING ST',0,'WEST CHESTER','OH','45069','5164','CY','39017','2003-03-30','M','',':RET:2106-3','N','021','DEN','1727612','99734OH005000301','2014-01-01','2013-12-23 16:30:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:04'),(22602,18051,'N','01','021','EC','A',NULL,NULL,'','0000039853','0000011194','','IL','1','Frail','Brian','G','','','34','289861881','10423 BAILEY RD',0,'WATERVILLE','OH','43566','9716','CY','39095','1977-03-07','M','',':RET:2106-3','N','021','HLT','3051099','92036OH005002606','2014-03-01','2014-02-10 14:03:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','239.85',NULL,0,'2014-02-10 21:32:15'),(14250,11364,'N','01','021','EC','A',NULL,NULL,'','0000689556','0000902173','','IL','1','Gutierrez','Nohemi','','','','34','611685997','2512 quince lane',0,'Mcallen','TX','78501',NULL,'CY','48215','1966-07-27','F','',NULL,'N','021','DEN','2409183','33348TX002000101','2014-02-01','2013-12-26 13:04:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-27 02:05:29'),(22343,17844,'Y','18','021','EC','A','','','AC','0000926299','0000926299','OH00001899326','IL','1','Sobieck','William','','','','34','282524315','14452 COUNTY ROAD 424',0,'SHERWOOD','OH','43556','9761','CY','39039','1950-12-17','M','U',':RET:2106-3','N','021','HLT','2947457','92036OH006002601','2014-03-01','2014-01-31 14:42:54','453.16',NULL,NULL,'456.50','3.34','R-OH001','OH0','456.50',NULL,0,'2014-02-10 11:01:10'),(14588,11643,'Y','18','021','EC','A','','','AC','0001208305','0001208305','OH00000194344','IL','1','Williams','David','W','','','34','277880857','57 DIAMOND AVE',0,'BARBERTON','OH','44203','2635','CY','39153','1982-02-02','M','U',':RET:2106-3','N','021','HLT','2305856','52664OH151001305','2014-02-01','2013-12-26 23:40:11','164.00',NULL,NULL,'258.47','94.47','R-OH012','OH0','258.47',NULL,0,'2013-12-28 03:36:03'),(14726,11758,'Y','18','021','EC','A','','','AC','0002315140','0002315140','LA00001779042','IL','1','WHITE','ALONZO','','','','34','437573700','2311 CONTI ST',0,'NEW ORLEANS','LA','70119','5707','CY','22071','1984-12-09','M','U',':RET:2054-5','N','021','DEN','1446888','18575LA002000201','2014-02-01','2013-12-28 13:06:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2013-12-29 11:09:40'),(16463,13172,'Y','18','021','EC','A','','','AC','0000346910','0000346910','OH00001856109','IL','1','Webster','Douglas','','','','34','280508996','502 E 7TH ST',0,'MANCHESTER','OH','45144','1562','CY','39001','1950-09-21','M','M',':RET:2106-3','N','021','HLT','1838341','92036OH004000601','2014-02-01','2014-01-06 13:05:12','505.82',NULL,NULL,'509.54','3.72','R-OH005','OH0','509.54',NULL,0,'2014-01-07 04:05:44'),(17610,14077,'Y','18','021','EC','A','','','AC','0000247980','0000247980','TX00001621602','IL','1','Gonzalez','Jose','','','','34','451210510','812 Southeast Avenue C',0,'Hamlin','TX','79520',NULL,'CY','48253','1968-03-08','M','U',NULL,'N','021','DEN','2004808','33348TX002000201','2014-02-01','2014-01-13 10:06:48','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-01-14 01:32:21'),(17618,14084,'Y','18','024','14','A','','','TE','0000641398','0000641398','','IL','1','rodriguez','nevelyn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-03-12','F','',NULL,NULL,NULL,'','2030964','','2014-01-13','2014-01-13 11:52:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-14 01:32:26'),(19187,15286,'Y','18','021','EC','A','','','AC','0001030382','0001030382','TX00002150084','IL','1','Sisak','SuzAnne','','','','34','189660229','1812 HICKORY ST',0,'HOUSTON','TX','77007','4132','CY','48201','1980-02-27','F','R',':RET:2106-3','N','021','DEN','2445464','33348TX002000101','2014-03-01','2014-01-19 21:17:31','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-21 08:46:10'),(19029,15155,'Y','18','021','EC','A','','','AC','0000625451','0000625451','OH00002456434','IL','1','Mcwhorter','Robin','','','','34','276744651','464 GATES RD',0,'HAMILTON','OH','45013','9023','CY','39017','1962-03-02','F','M',':RET:2106-3','N','021','HLT','2380512','92036OH004001201','2014-03-01','2014-01-17 15:56:55','200.00',NULL,NULL,'660.58','460.58','R-OH004','OH0','321.93',NULL,0,'2014-01-20 08:06:30'),(23889,19003,'Y','18','021','EC','A','','','AC','0000099044','0000099044','OH00001617239','IL','1','Stone','Carol','R',NULL,NULL,NULL,NULL,'2977 BETHEL CONCORD RD',0,'BETHEL','OH','45106','8487','CY','39025','1953-06-23','F','U',':RET:2106-3','N','021','HLT','3780288','92036OH003000605','2014-03-01','2014-02-14 13:54:33','454.00',NULL,NULL,'608.42','154.42','R-OH005','OH0','608.42',NULL,0,'2014-02-14 21:32:17'),(24540,19494,'Y','18','021','EC','A','','','AC','0000558196','0000558196','OH00002436681','IL','1','JOHNSON','ALVIN','','','','34','298486212','155 YOUNGSTOWN RD',0,'HUBBARD','OH','44425',NULL,'CY','39155','1950-05-10','M','U',':RET:2054-5','N','021','HLT','2902346','52664OH151001305','2014-04-01','2014-02-18 18:04:53','553.00',NULL,NULL,'746.55','193.55','R-OH013','OH0','746.55',NULL,0,'2014-02-20 04:02:17'),(24556,19505,'Y','18','021','EC','A','','','AC','0000777708','0000777708','OH00003014762','IL','1','Parker','Robert','','','','34','289829447','518 E SANDUSKY ST',0,'FINDLAY','OH','45840','5920','CY','39063','1984-12-11','M','U',':RET:2106-3','T','021','DEN','3070959','99734OH005000301','2014-04-01','2014-02-18 20:44:05','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-20 04:05:17'),(2268,1853,'N','19','021','EC','A',NULL,NULL,'','0000363754','0000383338','','IL','1','Dalton','Joshua','Thomas','','','34','289084892','540 THACKERAY RD',0,'MAUMEE','OH','43537','2359','CY','39095','2003-11-05','M','',':RET:2106-3','N','021','DEN','163870','99734OH005000301','2014-01-01','2013-12-09 09:53:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:20'),(21562,17226,'Y','18','021','EC','A','','','AC','0000142861','0000142861','OH00001852859','IL','1','PRITT','DIANN','','','','34','278723568','4626 SPRING HILL RD',0,'HEATH','OH','43056','9023','CY','39089','1960-08-17','F','U',NULL,'N','021','DEN','3532714','99734OH005000401','2014-03-01','2014-02-05 17:27:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:19'),(7366,5834,'Y','18','024','14','A','','','TE','0000260999','0000260999','','IL','1','Lowe','Tamoria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-29','F','',NULL,NULL,NULL,'','558453','','2013-11-23','2013-11-23 00:54:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 02:15:32'),(21128,16883,'Y','18','024','14','A','','','TE','0001047682','0001047682','','IL','1','Kline','Gayle','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-30','F','',NULL,NULL,NULL,'','2790805','','2014-02-03','2014-02-03 15:00:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:00:16'),(7231,5732,'Y','18','021','EC','A','','','AC','0000253030','0000253030','OH00000334381','IL','1','Parkin','John','','','','34','280564848','323 Terrace Avenue',0,'Cincinnati','OH','45220',NULL,'CY','39061','1953-04-22','M','U',':RET:2106-3','N','021','DEN','23196','99734OH005000401','2014-01-01','2013-12-14 16:18:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:01:22'),(5928,4693,'N','01','021','EC','A',NULL,NULL,'','0000495608','0000022207','','IL','1','ling','claire','','','','34','616803607','1712 EDINBURG CT',0,'ALLEN','TX','75013','5335','CY','48085','1968-05-17','F','',':RET:2034-7','N','021','DEN','2450149','33348TX002000101','2014-01-01','2013-12-24 01:08:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:26'),(3572,2868,'N','19','021','EC','A',NULL,NULL,'','0000876057','0000983824','','IL','1','Gross','Michael','Kenneth','','','34','299844048','8480 Greenville Saint Marys Rd',0,'Greenville','OH','45331',NULL,'CY','39037','1986-12-08','M','',':RET:2106-3','N','021','HLT','1935101','92036OH005000506','2014-01-01','2013-12-22 07:24:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.11',NULL,0,'2013-12-25 21:22:35'),(4636,3673,'Y','18','021','EC','A','','','AC','0000409721','0000409721','OH00000868060','IL','1','Jackson','Robert','','','','34','276749517','362 GROVE ST',0,'WILMINGTON','OH','45177','1207','CY','39027','1975-05-16','M','U',':RET:2106-3','T','021','HLT','1148977','92036OH002000601','2014-01-01','2013-12-11 21:13:00','0.00',NULL,NULL,'355.25','355.25','R-OH005','OH0','355.25',NULL,0,'2013-12-25 22:06:40'),(20769,16593,'Y','18','021','EC','A','','','AC','0001224496','0001224496','OH00001483327','IL','1','Edgecomb','Kathleen','','','','34','270667352','310 Onalee Dr.',0,'Cridersville','OH','45806',NULL,'CY','39011','1960-09-19','F','M',':RET:2106-3','N','021','HLT','3566542','92036OH005001506','2014-03-01','2014-01-30 15:22:21','402.00',NULL,NULL,'448.97','46.97','R-OH002','OH0','448.97',NULL,0,'2014-01-30 21:01:39'),(19017,15144,'Y','18','021','EC','A','','','AC','0000942016','0000942016','OH00001919364','IL','1','Zemrock','Caleb',NULL,NULL,NULL,NULL,NULL,'903 TOWNSHIP ROAD 2850',0,'PERRYSVILLE','OH','44864','9756','CY','39005','1983-06-23','M','U',':RET:2106-3','N','021','HLT','2944816','52664OH152000901','2014-03-01','2014-01-16 23:27:21','180.00',NULL,NULL,'185.39','5.39','R-OH012','OH0','185.39',NULL,0,'2014-01-20 08:06:23'),(14143,11273,'N','01','021','EC','A',NULL,NULL,'','0001751413','0001851091','','IL','1','RORTVEDT','SWEN','','','','34','534901015','426 LIVE OAK',0,'ELIZABETH','LA','70638',NULL,'CY','22003','1969-12-29','M','',':RET:2106-3','N','021','DEN','2310944','18575LA002000201','2014-02-01','2013-12-26 12:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:02:42'),(14529,11592,'N','01','021','EC','A',NULL,NULL,'','0000549419','0000561865','','IL','1','mendez','gregorio','','','','34','449559541','828 olivas v aoy',0,'el paso','TX','79901',NULL,'CY','48141','1967-03-17','M','',':RET:2106-3','N','021','DEN','2436156','33348TX002000201','2014-02-01','2013-12-27 18:08:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:34:31'),(15312,12245,'Y','18','021','EC','A','','','AC','0000794830','0000794830','TX00000762979','IL','1','Williams','Angela','','','','34','433299279','1322 DELLA ST',0,'TEXARKANA','TX','75501','4942','CY','48037','1964-04-04','F','U',':RET:2054-5','N','021','DEN','2008304','33348TX002000101','2014-02-01','2014-01-01 04:31:01','0.00',NULL,NULL,'25.02','25.02','R-TX021','TX0','25.02',NULL,1,'2014-01-02 04:23:16'),(17926,14320,'Y','18','021','EC','A','','','AC','0000551966','0000551966','TX00001411878','IL','1','Gordoa','Kim','','','','34','265396060','5080 LOPER CIR',0,'STREETMAN','TX','75859','7214','CY','48349','1957-11-16','F','U',':RET:2106-3','N','021','DEN','2053683','33348TX002000201','2014-02-01','2014-01-14 11:42:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:33'),(24466,19436,'N','19','021','EC','A',NULL,NULL,'','0000042106','0000710187','','IL','1','Carper','Nathan','','','','34','279044038','2032 GRAYBILL RD',0,'UNIONTOWN','OH','44685','8170','CY','39153','1999-04-16','M','',':RET:2106-3','N','021','HLT','3564266','52664OH151001501','2014-04-01','2014-02-18 16:41:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-18 22:01:36'),(25095,19904,'Y','18','024','14','A','','','TE','0001046892','0001046892','','IL','1','martin','regina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-03-14','F','',NULL,NULL,NULL,'','3273014','','2014-03-31','2014-02-21 15:06:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:07'),(26114,20710,'Y','18','024','14','A','','','TE','0000847186','0000847186','','IL','1','Loomis','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-07-03','M','',NULL,NULL,NULL,'','3376436','','2014-02-26','2014-02-26 20:04:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:17'),(26257,20826,'Y','18','021','EC','A','','','AC','0000556666','0000556666','TX00002937508','IL','1','Gonzales','Yolanda','','','','34','564238689','3444 JAN DE ROOS PL',0,'EL PASO','TX','79936','2559','CY','48141','1965-10-31','F','M',':RET:2106-3','N','021','DEN','2825997','33348TX002000201','2014-04-01','2014-02-27 15:35:22','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-28 06:31:11'),(18761,14948,'N','01','021','EC','A',NULL,NULL,'','0000243816','0000692301','','IL','1','VARGAS','MARIA','','','','34','639548077','571 W 6TH ST',0,'LANCASTER','TX','75146',NULL,'CY','48113','1978-08-16','F','',NULL,'N','021','DEN','1454813','33348TX002000101','2014-02-01','2014-01-15 21:34:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-17 03:35:47'),(17909,14304,'N','01','021','EC','A',NULL,NULL,'','0001178637','0001160903','','IL','1','WILLARD','RICK','','','','34','455251900','4020 STATE HIGHWAY 155',0,'PALESTINE','TX','75803','1737','CY','48001','1959-08-03','M','',':RET:2106-3','N','021','DEN','2183989','33348TX002000201','2014-02-01','2014-01-13 20:00:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:26'),(17613,14080,'Y','18','021','EC','A','','','AC','0000961080','0000961080','TX00001622922','IL','1','MARTINEZ VALDEZ','LUCIA','','','','34','008491943','106 MANNING WAY',0,'EL PASO','TX','79915','3408','CY','48141','1953-12-15','F','U',NULL,'N','021','DEN','1811392','33348TX002000201','2014-02-01','2014-01-13 11:19:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-14 01:32:23'),(7512,5943,'Y','18','021','EC','A','','','AC','0000337071','0000337071','LA00001282744','31','1','DAVIS','ALISHA','','','','34','433815211','PO BOX 353',0,'NATALBANY','LA','70451',NULL,'CY','22105','1990-11-16','F','M',':RET:2054-5','N','021','DEN','1076453','18575LA002000201','2014-01-01','2013-12-15 09:11:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:32:07'),(6846,5427,'Y','18','021','EC','A','','','AC','0000109251','0000109251','OH00000348744','IL','1','Adams','Matthew','J','','','34','273084473','9185 MANN RD',0,'TIPP CITY','OH','45371','8777','CY','39109','2002-11-27','M','U',':RET:2106-3','N','021','HLT','1241666','92036OH002000501','2014-01-01','2013-11-14 14:48:42','0.00',NULL,NULL,'174.32','174.32','R-OH003','OH0','174.32',NULL,0,'2013-12-26 01:31:15'),(15895,12728,'Y','18','021','EC','A','','','AC','0000140293','0000140293','OH00001620020','IL','1','weaver','katherine','','','','34','283040437','379 CELTIC ST',0,'AKRON','OH','44314','3603','CY','39153','1981-06-12','F','U',':RET:2028-9','N','021','HLT','1681556','52664OH152000901','2014-02-01','2014-01-02 11:00:17','146.00',NULL,NULL,'193.23','47.23','R-OH012','OH0','193.23',NULL,0,'2014-01-03 02:05:53'),(4458,3543,'Y','18','021','EC','A','','','AC','0000453891','0000453891','OH00000443624','IL','1','BAYSORE','ROBERT','','','','34','280500076','2415 E FOSTER MAINEVILLE RD',0,'MORROW','OH','45152','8576','CY','39165','1955-06-07','M','U',NULL,'N','021','DEN','371710','99734OH005000301','2014-01-01','2013-12-12 11:32:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:02:34'),(9076,7202,'N','01','021','EC','A',NULL,NULL,'','0001212335','0000098980','','IL','1','Gohs','Joann','','','','34','406961077','5202 PARLOR CT',0,'MASON','OH','45040','2935','CY','39165','1966-01-10','F','',NULL,'T','021','DEN','2606601','99734OH005000301','2014-01-01','2013-12-17 19:16:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:06:42'),(3649,2920,'N','01','021','EC','A',NULL,NULL,'','0000313227','0001163814','','IL','1','Sawatsky','Sarah','','','','34','296749442','7105 ORCHARD GROVE AVE',0,'CLEVELAND','OH','44144','1556','CY','39035','1978-07-06','F','',':RET:2106-3','N','021','DEN','692480','99734OH005000401','2014-01-01','2013-12-12 18:39:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:35'),(389,321,'N','19','021','EC','A',NULL,NULL,'','0000827126','0000124177','','IL','1','McRae','Paul','','','','34','274943751','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1991-08-29','M','',':RET:2054-5','N','021','HLT','326885','92036OH004003201','2014-01-01','2013-12-03 18:55:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.63',NULL,0,'2013-12-25 17:45:53'),(8847,7013,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','36996','','2013-12-18','2013-12-18 07:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:00:55'),(1681,1403,'Y','18','021','EC','A','','','AC','0002266679','0002266679','LA00000662425','IL','1','Parker','Donald','F','','','34','421701272','60274 FENNER RD',0,'SLIDELL','LA','70460','4024','CY','22103','1950-06-03','M','U',NULL,'N','021','DEN','1568613','18575LA002000101','2014-01-01','2013-12-24 10:23:27','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:10'),(23103,18416,'Y','18','024','14','A','','','TE','0001155137','0001155137','','IL','1','Nelson','Alyse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-21','F','',NULL,NULL,NULL,'','2749483','','2014-02-12','2014-02-12 15:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:13'),(25295,20068,'N','19','021','EC','A',NULL,NULL,'','0000902258','0000833465','','IL','1','SATURDAY','SHAWN','','','Jr','34','619494427','676 GLENSPRINGS DR',0,'CINCINNATI','OH','45246','2125','CY','39061','2005-01-20','M','',':RET:2054-5','N','021','DEN','2817018','99734OH005000401','2014-03-01','2014-02-25 10:51:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:25'),(26929,21342,'Y','18','021','EC','A','','','AC','0001178240','0001178240','OH00002628671','IL','1','jenkins','tara','','','','34','594363675','5350 MAIN AVE',0,'NORTH RIDGEVILLE','OH','44039','2222','CY','39093','1978-06-23','F','M',':RET:2106-3','N','021','DEN','2921394','99734OH005000401','2014-04-01','2014-03-02 16:40:57','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-03-03 01:00:19'),(271,223,'Y','18','021','EC','A','','','AC','0000661318','0000661318','OH00000593719','IL','1','Turner','Bessie','','','','34','268568220','809 N Jefferson St',0,'Delphos','OH','45833',NULL,'CY','39161','1954-05-30','F','M',':RET:2106-3','N','021','HLT','958464','92036OH003001505','2014-01-01','2013-12-05 18:13:41','497.00',NULL,NULL,'598.27','101.27','R-OH002','OH0','598.27',NULL,0,'2013-12-25 17:22:04'),(19073,15195,'Y','18','021','EC','A','','','AC','0000422842','0000422842','OH00002068341','IL','1','Miller','Jordan','Ray',NULL,NULL,NULL,NULL,'1068 Alpine Blvd.',0,'Uniontown','OH','44685',NULL,'CY','39153','2010-03-22','M','R',':RET:2106-3','N','021','HLT','2596179','52664OH151001501','2014-03-01','2014-01-17 19:50:49','0.00',NULL,NULL,'169.84','169.84','R-OH012','OH0','169.84',NULL,0,'2014-01-21 08:44:21'),(18493,14750,'Y','18','024','14','A','','','TE','0000483504','0000483504','','IL','1','ROCK','MARY','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-09-08','F','',NULL,NULL,NULL,'','1520179','','2014-01-15','2014-01-15 09:44:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:46:26'),(4181,3326,'Y','18','021','EC','A','','','AC','0000981599','0000981599','OH00000598931','IL','1','Tisher','Laura','','','','34','295728783','325 REED RD',0,'WOOSTER','OH','44691','2137','CY','39169','1977-12-17','F','U',NULL,'N','021','HLT','1848412','52664OH151001305','2014-01-01','2013-12-16 22:16:57','144.00',NULL,NULL,'274.30','130.30','R-OH014','OH0','274.30',NULL,0,'2013-12-25 21:49:24'),(13228,10554,'Y','18','021','EC','A','','','AC','0001165354','0001165354','TX00001182643','IL','1','harrison','david','','','','34','438718056','301 w.hawkins',0,'longview','TX','75605',NULL,'CY','48183','1974-02-06','M','R',':RET:2106-3','N','021','DEN','2419055','33348TX002000201','2014-01-01','2013-12-22 21:18:34','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 12:55:41'),(16988,13597,'Y','18','021','EC','A','','','AC','0000693519','0000693519','TX00001630318','IL','1','Mathis','Kristin','','','','34','454919093','222 TERRACE CREEK CT',0,'RICHMOND','TX','77406','3590','CY','48157','1980-02-21','F','U',':RET:2106-3','N','021','DEN','1839827','33348TX002000101','2014-02-01','2014-01-09 18:11:36','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-13 02:20:22'),(13586,10836,'Y','18','021','EC','A','','','AC','0001284852','0001284852','LA00000932443','IL','1','Pierre','Oliver','','','','34','435880987','421 Portsmouth Dr.',0,'Slidell','LA','70460',NULL,'CY','22103','1954-03-28','M','M',':RET:2054-5','N','021','DEN','2219471','18575LA002000201','2014-01-01','2013-12-23 18:33:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:05:02'),(22778,18186,'Y','18','021','EC','A','','','AC','0001156237','0001156237','OH00002583774','IL','1','Garin','Maura','','','','34','274583727','146 COEN RD',0,'VERMILION','OH','44089','3100','CY','39043','1955-05-01','F','U',':RET:2106-3','N','021','DEN','3486932','99734OH005000401','2014-03-01','2014-02-11 15:05:01','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-11 21:01:42'),(22848,18230,'N','01','021','EC','A',NULL,NULL,'','0000933247','0001227070','','IL','1','SHAFFER','ROCKY','','','','34','283503734','4505 REDD  RD',0,'DELPHOS','OH','45833',NULL,'CY','39003','1950-04-24','M','',NULL,'N','021','HLT','3070761','92036OH005001505','2014-03-01','2014-02-11 11:25:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','649.68',NULL,0,'2014-02-11 21:02:18'),(26391,20933,'N','01','021','EC','A',NULL,NULL,'','0000194050','0000599760','','IL','1','Taylor','Brian','','','','34','272863807','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1983-03-22','M','',':RET:2106-3','N','021','HLT','2681139','52664OH151001301','2014-03-01','2014-02-26 12:37:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11','CIC',0,'2014-02-28 07:00:25'),(29213,23119,'N','19','021','EC','A',NULL,NULL,'','0001223240','0000928560','','IL','1','AYAD','HANNA','','','','34','208336417','3540 QUEENSWOOD BLVD',0,'TOLEDO','OH','43606','1136','CY','39095','2013-01-01','F','',NULL,'N','021','HLT','4057721','92036OH003002604','2014-04-01','2014-03-10 14:37:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-03-10 21:30:17'),(22661,18095,'N','19','021','EC','A',NULL,NULL,'','0000983819','0000768425','','IL','1','Baiza','Frances','Marie','','','34','628347531','4218 Juarez',0,'Laredo','TX','78041',NULL,'CY','48479','1992-11-04','F','',':RET:2106-3','N','021','DEN','3224666','33348TX002000201','2014-03-01','2014-02-11 13:12:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:35'),(21897,17486,'Y','18','021','EC','A','','','AC','0001246979','0001246979','OH00002462919','IL','1','Widmer','Jody','','','','34','292609527','195 LOUISE ST',0,'RITTMAN','OH','44270','1328','CY','39169','1974-07-13','F','R',':RET:2106-3','N','021','HLT','3512380','52664OH151001501','2014-03-01','2014-02-05 22:00:21','0.00',NULL,NULL,'337.54','337.54','R-OH014','OH0','337.54',NULL,0,'2014-02-06 21:01:44'),(20768,16592,'Y','18','021','EC','A','','','AC','0000349295','0000349295','OH00002585578','IL','1','Boos','Magaret','','','','34','292468315','5240 Grove Dr.',0,'Celina','OH','45822',NULL,'CY','39107','1959-01-18','F','U',':RET:2106-3','N','021','HLT','3001075','92036OH005001506','2014-03-01','2014-01-30 15:11:29','461.00',NULL,NULL,'490.79','29.79','R-OH002','OH0','490.79',NULL,0,'2014-01-30 21:01:38'),(16368,13099,'Y','18','021','EC','A','','','AC','0000486082','0000486082','MS00002124061','IL','1','Mudgett','James','','','','34','354440156','363 DELLWOOD DR',0,'JACKSON','MS','39212','4810','CY','28049','1951-01-11','M','U',':RET:2106-3','T','021','DEN','1671859','46300MS002000201','2014-02-01','2014-01-06 14:46:51','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-07 04:02:57'),(8824,6996,'Y','18','021','EC','A','','','AC','0000982436','0000982436','TX00000864698','IL','1','Nunez','Veronica','','','','34','318661712','1315 W ESPERANZA AVE',0,'MCALLEN','TX','78501','3992','CY','48215','1966-01-30','F','M',':RET:2106-3','N','021','DEN','2234075','33348TX002000201','2014-01-01','2013-12-17 19:02:57','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 04:00:21'),(23785,18928,'Y','18','021','EC','A','','','AC','0000452792','0000452792','OH00002717136','IL','1','WARD','DEBORAH','','','','34','295443618','741 INDIAN TRL',0,'AKRON','OH','44314','3161','CY','39153','1950-09-23','F','U',NULL,'N','021','HLT','3250835','52664OH151001304','2014-03-01','2014-02-13 19:30:38','466.00',NULL,NULL,'658.32','192.32','R-OH012','OH0','658.32',NULL,0,'2014-02-14 21:31:22'),(28309,22399,'Y','18','024','14','A','','','TE','0001175959','0001175959','','IL','1','Seay','Heather','Renee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-06-18','F','',NULL,NULL,NULL,'','300782','','2014-03-31','2014-03-07 17:35:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-03-07 21:00:35'),(28314,22402,'N','17','021','EC','A',NULL,NULL,'','0001179578','0000972711','','S3','1','Cantrell','Cassandra','Robert','','','34','297119202','65 W MAIN ST',0,'SARDINIA','OH','45171','8000','CY','39071','2006-05-21','M','',':RET:2106-3','N','021','HLT','3668637','92036OH002000601','2014-04-01','2014-03-07 16:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43','CIC',0,'2014-03-07 21:00:37'),(28339,22422,'N','01','021','EC','A',NULL,NULL,'','0000615277','0000519338','','IL','1','Bryce','Michele','Ivy','','','34','450177012','7609 SILVERTHORN DR',0,'ROWLETT','TX','75089','8657','CY','48397','1959-04-08','F','',':RET:2106-3','N','021','DEN','3575863','33348TX002000201','2014-04-01','2014-03-07 10:24:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-07 21:30:15'),(5349,4242,'N','01','021','EC','A',NULL,NULL,'','0001196802','0001105520','','IL','1','Mahony','James','','','','34','278505283','3049 Hamlin Rd',0,'Medina','OH','44256',NULL,'CY','39103','1952-01-07','M','',':RET:2106-3','N','021','HLT','1858452','52664OH152000901','2014-01-01','2013-12-19 10:50:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','458.99',NULL,0,'2013-12-25 23:07:34'),(505,413,'Y','18','021','EC','A','','','AC','0000911738','0000911738','OH00000824864','IL','1','Vranich','Sherry','','','','34','275507492','14335 MILL HOLLOW LN',0,'STRONGSVILLE','OH','44136','5423','CY','39035','1951-02-09','F','M',':RET:2106-3','N','021','DEN','741892','99734OH005000301','2014-01-01','2013-12-04 12:23:49','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:48:48'),(3454,2778,'Y','18','021','EC','A','','','AC','0001049365','0001049365','OH00001021275','IL','1','spain','christopher','','','','34','271807969','4260 delridge dr',0,'cincinnati','OH','45205',NULL,'CY','39061','1983-01-21','M','R',':RET:2054-5','N','021','DEN','2094956','99734OH005000401','2014-01-01','2013-12-21 23:07:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:19:35'),(23457,18685,'N','19','021','EC','A',NULL,NULL,'','0001049009','0000277934','','IL','1','CAMPBELL','CECELIA','','','','34','645329223','306 EDGEHILL BLVD',0,'RICHARDSON','TX','75081','2708','CY','48113','1989-07-27','F','',NULL,'N','021','DEN','2947766','33348TX002000201','2014-03-01','2014-02-13 14:09:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:40'),(24719,19628,'Y','18','021','EC','A','','','AC','0000655871','0000655871','OH00002365137','IL','1','Conti','Jordan','','','','34','299846606','5418 CYPRESS CHASE',0,'COLUMBUS','OH','43228','7215','CY','39049','1986-08-29','M','U',':RET:2106-3','N','021','DEN','3212081','99734OH005000401','2014-04-01','2014-02-19 01:08:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:37:36'),(24946,19781,'N','01','021','EC','A',NULL,NULL,'','0001254325','0001058245','','IL','1','BETONTI','BARBARA','A','','','34','526847974','2278 PIGEON ROOST RD',0,'BYHALIA','MS','38611','9370','CY','28093','1951-09-18','F','',':RET:2106-3','N','021','DEN','3495829','46300MS002000201','2014-04-01','2014-02-20 16:35:16',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 22:00:07'),(28450,22512,'Y','18','024','14','A','','','TE','0001922564','0001922564','','IL','1','NATHAN','GEORGE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-08','M','',NULL,NULL,NULL,'','2686888','','2014-03-31','2014-03-07 11:05:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-07 21:31:19'),(28713,22723,'Y','18','021','EC','A','','','AC','0000846443','0000846443','MS00003274114','IL','1','Abrams','Jason','','','','34','428678847','1217 LLOYD RD',0,'EDWARDS','MS','39066','9623','CY','28049','1986-10-14','M','U',':RET:2054-5','N','021','DEN','3760161','46300MS002000201','2014-04-01','2014-03-08 14:13:07','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-08 21:31:16'),(21801,17411,'Y','18','021','EC','A','','','AC','0001174433','0001174433','OH00002440005','IL','1','ulrick','peter','','','','34','271765322','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1979-08-19','M','M',':RET:2106-3','N','021','HLT','2942726','92036OH004001501','2014-03-01','2014-02-05 19:34:24','480.00',NULL,NULL,'557.62','77.62','R-OH002','OH0','214.83',NULL,0,'2014-02-06 21:00:49'),(7945,6285,'Y','18','021','EC','A','','','AC','0001270233','0001270233','LA00000220008','IL','1','Warren','Donald','','','','34','435960126','P O Box 37832',0,'Shreveport','LA','71133',NULL,'CY','22017','1956-04-01','M','U',':RET:2054-5','N','021','DEN','2235298','18575LA002000201','2014-01-01','2013-12-20 15:27:22','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:06:59'),(1706,1425,'Y','18','021','EC','A','','','AC','0000477459','0000477459','OH00000720536','IL','1','Gerrard','Chris','','','','34','282947666','4425 station ave',0,'cincinnati','OH','45232',NULL,'CY','39061','1984-03-20','M','R',':RET:2106-3','N','021','HLT','2016453','92036OH006001201','2014-01-01','2013-12-24 12:54:34','0.00',NULL,NULL,'190.50','190.50','R-OH004','OH0','190.50',NULL,0,'2013-12-25 18:54:53'),(3293,2654,'N','19','021','EC','A',NULL,NULL,'','0000461933','0000435295','','S1','1','Lowell','Ginger','','','','34','294041515','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','2000-02-22','F','',':RET:2106-3','N','021','DEN','1417328','99734OH005000301','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:33'),(7302,5788,'Y','18','021','EC','A','','','AC','0000614087','0000614087','OH00001237900','IL','1','STREET','LINDA','','','','34','274461605','3481 AKRON VIEW DR',0,'BARBERTON','OH','44203','3827','CY','39153','1957-10-22','F','M',':RET:2106-3','N','021','HLT','979989','52664OH151001306','2014-01-01','2013-12-14 13:45:35','878.00',NULL,NULL,'1063.75','185.75','R-OH012','OH0','520.28',NULL,0,'2013-12-26 02:03:10'),(21381,17088,'Y','18','021','EC','A','','','AC','0000654626','0000654626','OH00002278234','IL','1','Ford','Crystal','','','','34','294561447','865 PEERLESS AVE',0,'AKRON','OH','44320','2821','CY','39153','1956-12-24','F','U',':RET:2054-5','N','021','DEN','2771045','99734OH005000401','2014-03-01','2014-02-03 21:39:15','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-04 21:00:53'),(20894,16699,'Y','18','021','EC','A','','','AC','0001075338','0001075338','OH00001591733','IL','1','Epley','Terri','Lee','','','34','295589535','1180 S KUTHER RD',0,'SIDNEY','OH','45365','9504','CY','39149','1958-07-28','F','M',NULL,'N','021','DEN','3661472','99734OH005000401','2014-03-01','2014-01-31 11:23:18','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-31 21:01:17'),(6183,4900,'Y','18','021','EC','A','','','AC','0000683345','0000683345','OH00001148966','IL','1','Burgess','Samuel','','','','34','273526709','11128 forest ave',0,'cleveland','OH','44104',NULL,'CY','39035','1954-04-26','M','M',':RET:2054-5','N','021','DEN','1105853','99734OH005000401','2014-01-01','2013-10-22 22:05:05','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:30:07'),(4630,3669,'Y','18','021','EC','A','','','AC','0000784935','0000784935','MS00000655218','IL','1','Ingram','Susan','','','','34','587969646','350 Main st',0,'pope','MS','38658',NULL,'CY','28107','1957-05-25','F','M',':RET:2106-3','N','021','DEN','6641','46300MS002000101','2014-01-01','2013-12-12 12:33:11','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2013-12-25 22:06:31'),(20821,16640,'Y','18','021','EC','A','','','AC','0002055553','0002055553','LA00002254564','IL','1','johnson','betty','','','','34','434157639','1835 SYCAMORE ST',0,'JENA','LA','71342','4550','CY','22059','1956-09-12','F','U',':RET:2054-5','N','021','DEN','2690642','18575LA002000201','2014-03-01','2014-01-31 13:06:39','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-31 21:00:35'),(13276,10595,'N','01','021','EC','A',NULL,NULL,'','0000132479','0000443371','','IL','1','moore','alesia','','','','34','461047319','60 COUNTY ROAD 1516',0,'AVINGER','TX','75630','2727','CY','48067','1955-10-28','F','',':RET:2106-3','T','021','DEN','2300605','33348TX002000201','2014-01-01','2013-12-23 12:34:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:57:02'),(13717,10946,'Y','18','021','EC','A','','','AC','0000047087','0000047087','OH00001069310','IL','1','Hagner','Robert','','','','34','275700096','862 County Rd 801',0,'Ashland','OH','44805',NULL,'CY','39005','1975-04-15','M','U',NULL,'N','021','HLT','2366932','52664OH151001304','2014-01-01','2013-12-23 16:18:06','147.00',NULL,NULL,'277.87','130.87','R-OH012','OH0','277.87',NULL,0,'2013-12-26 13:09:07'),(14769,11792,'Y','18','021','EC','A','','','AC','0000295985','0000295985','TX00000861282','IL','1','Jones','Robert','','','','34','456498170','4301 MCCUTCHEN AVE',0,'WICHITA FALLS','TX','76308','2614','CY','48485','1964-05-02','M','U',':RET:2106-3','N','021','DEN','1897664','33348TX002000201','2014-01-01','2013-12-23 19:39:56','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,1,'2013-12-29 11:12:53'),(18116,14469,'Y','18','021','EC','A','','','AC','0000859716','0000859716','OH00002357068','IL','1','Davis','Jeffrey','','','','34','298828455','912 GLENSIDE RD',0,'SOUTH EUCLID','OH','44121','3442','CY','39035','1985-03-06','M','U',':RET:2054-5','N','021','HLT','2242253','52664OH152000901','2014-02-01','2014-01-14 09:54:53','160.00',NULL,NULL,'200.25','40.25','R-OH011','OH0','200.25',NULL,0,'2014-01-15 02:07:39'),(25603,20314,'Y','18','021','EC','A','','','AC','0001164583','0001164583','TX00002294524','IL','1','Varnell','Deborah','','','','34','456793767','3660 SPRING CANYON TRL',0,'ROUND ROCK','TX','78681','2263','CY','48491','1971-11-10','F','U',':RET:2106-3','N','021','DEN','3421348','33348TX002000201','2014-04-01','2014-02-21 18:21:37','34.28',NULL,NULL,'56.37','22.09','R-TX003','TX0','15.85',NULL,0,'2014-02-26 08:30:03'),(27981,22138,'Y','18','021','EC','A','','','AC','0002222174','0002222174','LA00002783113','IL','1','Hutto','Heather','','','','34','439774698','212 STANDARD REED RD',0,'WEST MONROE','LA','71291','1604','CY','22073','1990-04-17','F','U',NULL,'N','021','DEN','3977614','18575LA002000201','2014-04-01','2014-03-06 15:54:59','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-06 21:00:57'),(222,186,'N','01','021','EC','A',NULL,NULL,'','0000202366','0000244179','','IL','1','Prine','Robert','','','Jr','34','439574534','10416 Howell ln.',0,'Tickfaw','LA','70466',NULL,'CY','22105','1978-04-03','M','',':RET:2106-3','T','021','DEN','393862','18575LA002000201','2014-01-01','2013-12-05 11:39:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 17:20:48'),(8038,6364,'Y','18','024','14','A','','','TE','0000615505','0000615505','','IL','1','Matthiesen','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-10-17','F','',NULL,NULL,NULL,'','2496667','','2013-12-20','2013-12-20 07:54:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:09:21'),(22373,17866,'N','01','021','EC','A',NULL,NULL,'','0000300124','0000487972','','IL','1','Aziz','Ashrafunissa','','','','34','635923205','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1958-02-24','F','',':RET:2029-7','N','021','DEN','3129623','33348TX002000101','2014-03-01','2014-02-10 15:13:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-10 21:00:14'),(6089,4826,'Y','18','021','EC','A','','','AC','0000780470','0000780470','OH00000248049','IL','1','Treadway','Karen','','','','34','279500538','762 Sandy lake Rd.',0,'Kent','OH','44240',NULL,'CY','39133','1949-04-07','F','U',':RET:2106-3','T','021','HLT','43499','52664OH151001306','2014-01-01','2013-12-01 15:18:10','583.00',NULL,NULL,'769.35','186.35','R-OH012','OH0','769.35',NULL,0,'2013-12-26 00:02:41'),(5847,4643,'N','01','021','EC','A',NULL,NULL,'','0000041024','0001182383','','IL','1','Chambless','Rebecca','F','','','34','465299671','1121 OAKWOOD CIR',0,'KELLER','TX','76248','4010','CY','48439','1960-10-10','F','',NULL,'N','021','DEN','1359914','33348TX002000201','2014-01-01','2013-12-24 00:15:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:48:40'),(5561,4415,'Y','18','021','EC','A','','','AC','0000753356','0000753356','OH00000307997','IL','1','BARDWELL','LINDA','','','','34','298461088','2175 UNIVERSITY DR SE',0,'MASSILLON','OH','44646','7446','CY','39151','1949-06-19','F','M',NULL,'N','021','HLT','338320','52664OH152000901','2014-01-01','2013-11-27 16:05:05','427.00',NULL,NULL,'490.00','63.00','R-OH015','OH0','490.00',NULL,0,'2013-12-25 23:16:27'),(1929,1571,'Y','18','021','EC','A','','','AC','0000609702','0000609702','TX00000368833','IL','1','Masters','Linda','Joyce','','','34','058443422','1705 Lost Creek Boulevard',0,'Austin','TX','78746','6133','CY','48453','1954-12-04','F','U',':RET:2106-3','N','021','DEN','280314','33348TX002000201','2014-01-01','2013-11-20 09:07:06','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 19:00:19'),(24068,19140,'Y','18','021','EC','A','','','AC','0000204598','0000204598','OH00002210042','IL','1','White','Deborah','','','','34','271542748','211 STRATFORD AVE',0,'WADSWORTH','OH','44281','1230','CY','39103','1952-01-26','F','U',':RET:2106-3','N','021','HLT','2792454','52664OH151001304','2014-03-01','2014-02-14 23:02:33','444.00',NULL,NULL,'640.70','196.70','R-OH012','OH0','640.70',NULL,0,'2014-02-15 22:01:14'),(24117,19171,'Y','18','021','EC','A','','','AC','0000448285','0000448285','TX00002034274','IL','1','Whitehead','Brian','','','','34','466997486','2214 Westlake Dr.',0,'West Lake','TX','78746',NULL,'CY','48453','1973-06-21','M','U',':RET:2106-3','N','021','DEN','3087625','33348TX002000201','2014-03-01','2014-02-15 13:57:05','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-15 22:01:40'),(26595,21086,'Y','18','021','EC','A','','','AC','0000870682','0000870682','OH00002689423','IL','1','TENNEY','MARGARET','FAYE','','','34','527156984','1112 PROSPECT STREET',0,'BARBERTON','OH','44203',NULL,'CY','39153','1955-01-02','F','M',':RET:2106-3','N','021','HLT','3919288','52664OH152000901','2014-04-01','2014-02-28 15:35:25','342.00',NULL,NULL,'425.18','83.18','R-OH012','OH0','425.18',NULL,0,'2014-02-28 21:30:38'),(508,415,'Y','18','021','EC','A','','','AC','0000911737','0000911737','OH00001160778','IL','1','Rogolsky','Gary','','','','34','283426781','2806 WARSAW ST',0,'TOLEDO','OH','43608','2362','CY','39095','1951-08-02','M','M',':RET:2106-3','N','021','DEN','1234673','99734OH005000301','2014-01-01','2013-12-03 19:45:32','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-25 17:48:52'),(3540,2842,'Y','18','021','EC','A','','','AC','0000545059','0000545059','TX00000793318','IL','1','Velasco','Priscilla','','','','34','525890369','7110 QUAIL LNDG',0,'SAN ANTONIO','TX','78250','6221','CY','48029','1990-07-31','F','U',':RET:2106-3','N','021','DEN','1518355','33348TX002000101','2014-01-01','2013-12-22 15:15:36','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 21:21:45'),(22342,17843,'Y','18','021','EC','A','','','AC','0000637147','0000637147','OH00001942083','IL','1','DiBacco','Ted','','','','34','269668281','27945 PERGL RD',0,'SOLON','OH','44139','2118','CY','39035','1963-01-05','M','M',':RET:2106-3','N','021','HLT','3225615','92036OH004000801','2014-03-01','2014-02-03 09:02:46','238.34',NULL,NULL,'350.62','112.28','R-OH011','OH0','350.62',NULL,0,'2014-02-10 11:01:09'),(20923,16723,'N','01','021','EC','A',NULL,NULL,'','0001144804','0000555402','','IL','1','Brightbill','James','','','','34','297441553','2808 NORMA ST',0,'CUYAHOGA FALLS','OH','44223','1733','CY','39153','1949-10-09','M','',':RET:2106-3','N','021','HLT','3275328','52664OH151001501','2014-03-01','2014-01-31 11:45:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','802.38',NULL,0,'2014-01-31 21:01:34'),(17349,13880,'Y','18','021','EC','A','','','AC','0000443473','0000443473','OH00002080160','IL','1','AHMOUDA','TAMMY','','','','34','289748623','1366 VIMLA WAY',0,'XENIA','OH','45385','5731','CY','39057','1963-07-08','F','U',':RET:2106-3','N','021','HLT','1969042','92036OH005000506','2014-02-01','2014-01-09 19:48:56','406.00',NULL,NULL,'575.48','169.48','R-OH003','OH0','424.53',NULL,0,'2014-01-13 02:24:07'),(24668,19580,'N','19','021','EC','A',NULL,NULL,'','0000149395','0000362548','','IL','1','Van Dyke','Fallon','','','','34','269986042','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1994-09-22','F','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-02-20 04:26:57'),(25257,20036,'Y','18','021','EC','A','','','AC','0000449923','0000449923','OH00002217882','IL','1','Rosebrock','Jarod','','','','34','281841946','631 N MAIN ST',0,'HICKSVILLE','OH','43526','1145','CY','39039','1982-04-28','M','U',NULL,'N','021','HLT','3557099','92036OH005002605','2014-04-01','2014-02-21 17:44:58','149.00',NULL,NULL,'226.00','77.00','R-OH001','OH0','226.00',NULL,0,'2014-02-21 22:01:18'),(25672,20367,'Y','18','021','EC','A','','','AC','0000013831','0000013831','OH00002317060','IL','1','Jones','Rosemarie','','','','34','263377010','1506 S MARSHALL RD',0,'MIDDLETOWN','OH','45044','6830','CY','39017','1956-05-24','F','U',NULL,'N','021','HLT','3371919','92036OH004001201','2014-04-01','2014-02-22 11:00:12','400.00',NULL,NULL,'420.66','20.66','R-OH004','OH0','420.66',NULL,0,'2014-02-26 08:30:53'),(359,296,'Y','18','021','EC','A','','','AC','0000781869','0000781869','OH00001020597','IL','1','Martin','Bryan','','','','34','270962644','2346 Duncan Dr',0,'Fairborn','OH','45324',NULL,'CY','39057','1989-08-04','M','U',':RET:2106-3','N','021','HLT','714026','92036OH004000501','2014-01-01','2013-12-03 23:05:07','0.00',NULL,NULL,'191.13','191.13','R-OH003','OH0','191.13',NULL,0,'2013-12-25 17:45:06'),(20764,16588,'N','01','021','EC','A',NULL,NULL,'','0000995469','0001151111','','IL','1','LAMMERS','DIANE','','','','34','293644002','17451 FAIRWAY DR',0,'OTTAWA','OH','45875','9462','CY','39137','1959-03-11','F','',':RET:2106-3','N','021','HLT','3070507','92036OH003001505','2014-03-01','2014-01-30 14:30:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.70',NULL,0,'2014-01-30 21:01:36'),(19614,15633,'Y','18','021','EC','A','','','AC','0000308296','0000308296','OH00002037296','IL','1','Latone','John','','','','34','290925192','249 WINSTON RD',0,'AKRON','OH','44313','6055','CY','39153','1987-03-25','M','U',':RET:2106-3','N','021','HLT','3252769','52664OH152001001','2014-03-01','2014-01-22 16:33:48','0.00',NULL,NULL,'125.55','125.55','R-OH012','OH0','125.55',NULL,0,'2014-01-23 03:02:52'),(7377,5842,'Y','18','021','EC','A','','','AC','0000619602','0000619602','OH00001192693','IL','1','Dema','Luljeta','','','','34','013847304','1680 Cedarwood dr',0,'Westlake','OH','44145',NULL,'CY','39035','1972-12-29','F','U',':RET:2106-3','N','021','DEN','1042080','99734OH005000401','2014-01-01','2013-11-22 23:25:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:15:50'),(18188,14520,'N','01','021','EC','A',NULL,NULL,'','0001053077','0000696832','','IL','1','Brooks','Daniel','C','','','34','018569486','8063 St. Rt. 245',0,'North Lewisburg','OH','43060',NULL,'CY','39021','1963-06-27','M','',':RET:2106-3','T','021','HLT','1829294','92036OH004000501','2014-02-01','2014-01-14 15:37:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','392.56',NULL,0,'2014-01-15 02:08:03'),(6472,5128,'Y','18','021','EC','A','','','AC','0000317320','0000317320','OH00000241806','31','1','Sayavich','Sarah','M','','','34','166526732','PO Box 1271',0,'Andover','OH','44003',NULL,'CY','39007','1954-03-07','F','M',NULL,'N','021','HLT','484313','52664OH151001306','2014-01-01','2013-12-10 20:50:18','1334.00',NULL,NULL,'1397.18','63.18','R-OH011','OH0','654.70',NULL,0,'2013-12-26 00:50:09'),(1743,1446,'Y','18','024','14','A','','','TE','0000846132','0000846132','','IL','1','KOHR','DIANA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-25','F','',NULL,NULL,NULL,'','1828615','','2013-12-24','2013-12-24 11:29:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:55:34'),(5388,4275,'Y','18','021','EC','A','','','AC','0001448386','0001448386','LA00000390706','IL','1','Richard','Melrose','','','','34','434840698','837 St. Ferdinand St.',0,'New Orleans','LA','70117',NULL,'CY','22071','1952-01-05','F','U',':RET:2054-5','N','021','DEN','2101165','18575LA002000201','2014-01-01','2013-12-19 16:30:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:34'),(2193,1805,'Y','18','021','EC','A','','','AC','0000229416','0000229416','OH00000550335','IL','1','TAYLOR','DONALD','L','','','34','300503004','507 OGDEN RD',0,'WILMINGTON','OH','45177','9140','CY','39027','1951-02-08','M','U',':RET:2106-3','T','021','HLT','1003814','92036OH005000605','2014-01-01','2013-12-10 09:50:00','525.00',NULL,NULL,'709.26','184.26','R-OH005','OH0','709.26',NULL,0,'2013-12-25 19:19:49'),(4748,3763,'Y','18','021','EC','A','','','AC','0001097665','0001097665','TX00001190361','IL','1','Campbell','Steven','','','','34','458775298','303 Kasling',0,'Hughes Springs','TX','75638',NULL,'CY','48067','1985-04-14','M','U',':RET:2106-3','N','021','DEN','1107450','33348TX002000201','2014-01-01','2013-12-07 21:06:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:15:07'),(18118,14471,'Y','18','021','EC','A','','','AC','0000409765','0000409765','OH00001912142','IL','1','Reddick','Tania','','','','34','272561967','942 CANTON RD NW',0,'CARROLLTON','OH','44615','8402','CY','39019','1968-09-14','F','M',':RET:2106-3','N','021','HLT','1878356','52664OH152000901','2014-02-01','2014-01-14 13:17:28','437.00',NULL,NULL,'471.72','34.72','R-OH015','OH0','235.86',NULL,0,'2014-01-15 02:07:39'),(4068,3250,'Y','18','021','EC','A','','','AC','0000222384','0000222384','OH00000081616','S1','1','Zachrich','Kristine','J','','','34','288062147','9237 COUNTY ROAD P',0,'NAPOLEON','OH','43545','9351','CY','39069','2001-09-20','M','U',':RET:2106-3','N','021','DEN','2045222','99734OH005000401','2014-01-01','2013-12-17 17:28:16','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','15.78',NULL,0,'2013-12-25 21:46:52'),(16521,13217,'Y','18','021','EC','A','','','AC','0001087350','0001087350','TX00002290969','IL','1','Tracy','Joshua','','','','34','451839234','5006 35TH ST',0,'LUBBOCK','TX','79414','2505','CY','48303','1987-03-09','M','M',':RET:2106-3','N','021','DEN','2312270','33348TX002000201','2014-02-01','2014-01-05 15:46:19','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,1,'2014-01-07 10:21:43'),(27890,22063,'Y','18','024','14','A','','','TE','0000003621','0000003621','','IL','1','Hemenway','Maureen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-11','F','',NULL,NULL,NULL,'','3757008','','2014-03-20','2014-03-05 14:24:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-05 21:32:38'),(28313,22402,'N','19','021','EC','A',NULL,NULL,'','0001179578','0000759773','','IL','1','Cantrell','Elexa','','','','34','892922692','65 W MAIN ST',0,'SARDINIA','OH','45171','8000','CY','39071','2013-12-21','F','',':RET:2106-3','N','021','HLT','3668637','92036OH002000601','2014-04-01','2014-03-07 16:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43','CIC',0,'2014-03-07 21:00:37'),(20775,16598,'N','01','021','EC','A',NULL,NULL,'','0000132642','0000872763','','IL','1','Hawkins','Richard','A','','','34','465591352','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1979-01-05','M','',':RET:2054-5','N','021','DEN','3014159','33348TX002000201','2014-03-01','2014-01-30 18:44:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-31 21:00:06'),(19931,15895,'Y','18','021','EC','A','','','AC','0000003607','0000003607','OH00002509682','IL','1','JACKSON','MELODY','J','','','34','284668834','9100 BLUE CREEK RD',0,'BLUE CREEK','OH','45616','9045','CY','39001','1958-05-01','F','M',':RET:2106-3','N','021','HLT','3032614','92036OH005000605','2014-03-01','2014-01-24 12:14:19','380.00',NULL,NULL,'478.72','98.72','R-OH005','OH0','478.72',NULL,0,'2014-01-24 21:01:09'),(4040,3224,'N','01','021','EC','A',NULL,NULL,'','0000293172','0000357180','','IL','1','Kington','Cynthia','','','','34','299645178','714 Matthews Brook LN',0,'Powell','OH','43065',NULL,'CY','39041','1959-01-06','F','',NULL,'N','021','DEN','1548712','99734OH005000401','2014-01-01','2013-12-17 11:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:46:04'),(4719,3740,'N','01','021','EC','A',NULL,NULL,'','0000968206','0000703768','','IL','1','Cooper','Barbara','','','','34','355523829','536 CLEMRAY DR',0,'CINCINNATI','OH','45231','2763','CY','39061','1956-05-17','F','',NULL,'N','021','HLT','31700','92036OH005001205','2014-01-01','2013-12-12 13:41:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','523.16',NULL,0,'2013-12-25 22:08:54'),(19275,15363,'Y','18','024','14','A','','','TE','0000593684','0000593684','','IL','1','tariq','mohammad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-29','M','',NULL,NULL,NULL,'','1708312','','2014-01-20','2014-01-20 13:26:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:57'),(6003,4753,'Y','18','021','EC','A','','','AC','0000129507','0000129507','LA00000812180','IL','1','Wilson','Gilbert','','','','34','205409711','5709 RUTH ST',0,'METAIRIE','LA','70003','2329','CY','22051','1951-10-27','M','M',':RET:2106-3','N','021','DEN','440927','18575LA002000201','2014-01-01','2013-11-30 18:54:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:00:25'),(5584,4429,'Y','18','021','EC','A','','','AC','0000373982','0000373982','LA00000455594','IL','1','Fuenzalida','Patricia','','','','34','433929855','10 Gerie Ct.',0,'Jefferson','LA','70121',NULL,'CY','22051','1954-03-10','F','U',':RET:2106-3','N','021','DEN','151644','18575LA002000201','2014-01-01','2013-11-05 18:05:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:17:01'),(5180,4109,'N','19','021','EC','A',NULL,NULL,'','0000714933','0000132032','','IL','1','Truong','Brandon','','','','34','282066527','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','2001-05-28','M','',':RET:2047-9','N','021','DEN','2460550','99734OH005000401','2014-01-01','2013-12-19 12:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:03:30'),(17537,14020,'N','01','021','EC','A',NULL,NULL,'','0001060924','0000247919','','IL','1','usanovic','emira','','','','34','286025116','938 WESTVIEW CT',0,'MEDINA','OH','44256','7538','CY','39103','1979-01-12','F','',':RET:2106-3','N','021','HLT','2397439','52664OH151001305','2014-02-01','2014-01-12 11:06:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.52',NULL,0,'2014-01-13 03:01:46'),(25037,19854,'Y','18','021','EC','A','','','AC','0002090690','0002090690','LA00002075670','IL','1','Ancar','Donna','','','','34','434969792','921 RIDGELAKE DR',0,'METAIRIE','LA','70001','4256','CY','22051','1954-10-17','F','U',NULL,'N','021','DEN','3521702','18575LA002000101','2014-04-01','2014-02-20 17:31:29','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-20 22:01:07'),(28103,22244,'Y','18','021','EC','A','','','AC','0000963301','0000963301','OH00003347226','IL','1','Domer','Mary','C','','','34','297443464','1060 Shadybrook Drive',0,'Akron','OH','44312',NULL,'CY','39153','1951-06-16','F','U',NULL,'T','021','HLT','2936431','52664OH152000901','2014-04-01','2014-03-06 12:14:21','532.00',NULL,NULL,'539.67','7.67','R-OH012','OH0','539.67',NULL,0,'2014-03-06 21:02:11'),(1497,1250,'Y','18','021','EC','A','','','AC','0001256040','0001256040','OH00000252806','IL','1','jones','sherrie','','','','34','271660205','276 Turnstone Rd',0,'Columbus','OH','43235',NULL,'CY','39049','1960-04-24','F','U',':RET:2054-5','N','021','DEN','1840697','99734OH005000401','2014-01-01','2013-12-24 11:32:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:11'),(23543,18756,'Y','18','021','EC','A','','','AC','0002082243','0002082243','LA00001869316','IL','1','ELLIS','EDDIE','','','','34','435987656','204 CAPITOL DR',0,'WESTWEGO','LA','70094','2415','CY','22051','1957-12-11','M','U',NULL,'T','021','DEN','3651490','18575LA002000201','2014-03-01','2014-02-13 13:26:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:34'),(7967,6306,'Y','18','021','EC','A','','','AC','0001078769','0001078769','MS00000419856','IL','1','McCain','Zachary','','','','34','415639064','204 Caperton Ln',0,'Cleveland','MS','38732',NULL,'CY','28011','1987-06-19','M','M',NULL,'N','021','DEN','1936133','46300MS002000201','2014-01-01','2013-12-20 15:01:52','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 03:07:34'),(23363,18616,'Y','18','021','EC','A','','','AC','0000471058','0000471058','OH00001781258','IL','1','Dawson','Beth','','','','34','272549911','549 S FRANCIS ST',0,'KENT','OH','44240','3207','CY','39133','1953-01-26','F','M',':RET:2106-3','N','021','HLT','3264485','52664OH151001304','2014-03-01','2014-02-13 16:06:34','322.00',NULL,NULL,'626.65','304.65','R-OH012','OH0','626.65',NULL,0,'2014-02-13 22:00:47'),(21753,17371,'Y','18','021','EC','A','','','AC','0000950313','0000950313','TX00001555123','IL','1','MIRANDA','FRANCISCO','','','','34','635545445','875 S HIGHWAY 175',0,'SEAGOVILLE','TX','75159',NULL,'CY','48257','1977-08-27','M','M',NULL,'N','021','DEN','3441909','33348TX002000201','2014-03-01','2014-02-05 22:54:52','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:22'),(5897,4674,'N','19','021','EC','A',NULL,NULL,'','0001071787','0000741716','','S1','1','Clark','DeShon','','','','34','272173118','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','2011-01-14','F','',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:44'),(19941,15904,'Y','18','021','EC','A','','','AC','0000050716','0000050716','OH00002459942','IL','1','Schwieterman','Matthew','','','','34','294669203','127 West Logan',0,'Celina','OH','45822',NULL,'CY','39107','1974-06-04','M','U',':RET:2106-3','N','021','HLT','2976120','92036OH004001501','2014-03-01','2014-01-24 13:33:54','144.00',NULL,NULL,'223.33','79.33','R-OH002','OH0','223.33',NULL,0,'2014-01-24 21:01:15'),(5470,4346,'Y','18','021','EC','A','','','AC','0001046832','0001046832','OH00001072615','IL','1','Zafar','Syed','','','','34','591029242','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','1957-12-09','M','R',':RET:2028-9','T','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38','0.00',NULL,NULL,'1479.62','1479.62','R-OH001','OH0','523.16',NULL,0,'2013-12-25 23:10:39'),(18003,14386,'Y','18','021','EC','A','','','AC','0001068287','0001068287','OH00002574565','IL','1','Klunk','Janis','','','','34','280703625','1839 BEACON ST',0,'CINCINNATI','OH','45230','2052','CY','39061','1959-05-20','F','U',':RET:2106-3','N','021','DEN','2385548','99734OH005000301','2014-02-01','2014-01-13 22:12:23','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:07:00'),(4838,3832,'Y','18','021','EC','A','','','AC','0000048153','0000048153','OH00000006924','IL','1','Sotherden','Molly','','','','34','120625841','2667 STEWART DR',0,'RITTMAN','OH','44270','9618','CY','39169','1977-09-11','F','U',NULL,'N','021','HLT','1229402','52664OH152000901','2014-01-01','2013-11-07 19:18:14','0.00',NULL,NULL,'200.91','200.91','R-OH014','OH0','200.91',NULL,0,'2013-12-25 22:30:04'),(3523,2830,'Y','18','021','EC','A','','','AC','0001014719','0001014719','MS00001228507','IL','1','Dearman','Charles','','','','34','587642494','4114 SHELTON ST',0,'PEARL','MS','39208','4137','CY','28121','1952-10-24','M','M',':RET:2106-3','N','021','DEN','2002748','46300MS002000101','2014-01-01','2013-12-22 13:05:13','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-25 21:21:18'),(17996,14380,'N','01','021','EC','A',NULL,NULL,'','0000667803','0000235230','','IL','1','Maier','Kurt','','','','34','274522683','830 WOODBINE AVE',0,'CINCINNATI','OH','45246','4521','CY','39061','1959-06-23','M','',':RET:2106-3','N','021','DEN','1517733','99734OH005000301','2014-02-01','2014-01-13 20:30:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:58'),(15850,12689,'N','01','021','EC','A',NULL,NULL,'','0000798423','0000295505','','IL','1','Bacon','Brian','','','','34','292880303','1128 W State St',0,'Lima','OH','45805',NULL,'CY','39003','1977-08-26','M','',':RET:2106-3','N','021','DEN','2535120','99734OH005000401','2014-02-01','2014-01-02 17:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:04:22'),(16036,12839,'Y','18','021','EC','A','','','AC','0002274842','0002274842','LA00000827400','31','1','Jimerson','Chanell','','','','34','437553419','P.O. Box 91554',0,'Lafayette','LA','70509',NULL,'CY','22055','1970-09-14','F','U',':RET:2054-5','N','021','DEN','2193832','18575LA002000201','2014-02-01','2014-01-03 15:24:53','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-04 02:02:40'),(2955,2379,'N','01','021','EC','A',NULL,NULL,'','0000669510','0000577560','','IL','1','Hetrick','Pamella','','','','34','462967793','1232 S FANNIN ST',0,'AMARILLO','TX','79102','1426','CY','48375','1953-09-30','F','',':RET:2106-3','N','021','DEN','688668','33348TX002000201','2014-01-01','2013-12-06 11:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:16:37'),(9092,7216,'Y','18','021','EC','A','','','AC','0000355029','0000355029','OH00001182387','IL','1','Bennett','Joseph','','','','34','290562400','895 FRANKLIN DR',0,'CAMBRIDGE','OH','43725','1741','CY','39059','1954-11-04','M','U',':RET:2106-3','N','021','DEN','2223925','99734OH005000301','2014-01-01','2013-12-18 10:53:20','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:07:07'),(15612,12487,'N','01','021','EC','A',NULL,NULL,'','0000869293','0000183519','','IL','1','Haines','Anthony','B','','','34','278687147','202 W FOREST ST',0,'CELINA','OH','45822','1062','CY','39107','1972-12-30','M','',':RET:2106-3','N','021','DEN','2331173','99734OH005000301','2014-02-01','2013-12-31 18:30:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:51'),(6292,4990,'Y','18','021','EC','A','','','AC','0000180985','0000180985','OH00000986982','IL','1','Lynn','Kecia','','','','34','285761389','660 QUARRY LN',0,'RICHMOND HEIGHTS','OH','44143','2924','CY','39035','1965-06-13','F','U',':RET:2054-5','N','021','DEN','211147','99734OH005000401','2014-01-01','2013-12-11 06:42:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:40'),(15601,12482,'N','01','021','EC','A',NULL,NULL,'','0000283270','0000705156','','IL','1','Rengel','Judith','Lynne','','','34','283706514','3603 TURFSIDE CIR',0,'HURON','OH','44839','2193','CY','39043','1960-07-30','F','',':RET:2106-3','N','021','DEN','2124004','99734OH005000301','2014-02-01','2013-12-31 14:43:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:38'),(5038,3989,'N','01','021','EC','A',NULL,NULL,'','0001190027','0000393639','','IL','1','Sharkey','Kathy','Marie','','','34','268604490','2116 EAGLEBROOKE PKWY',0,'CELINA','OH','45822','8340','CY','39107','1956-07-09','F','',':RET:2106-3','N','021','HLT','696009','92036OH004001501','2014-01-01','2013-12-07 11:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','431.27',NULL,0,'2013-12-25 22:47:55'),(21153,16902,'N','01','021','EC','A',NULL,NULL,'','0000253085','0001094673','','IL','1','Huang','Candace','M','','','34','277721255','526 BEAVERBROOK DR',0,'COLUMBUS','OH','43230','4382','CY','39049','1976-02-05','F','',':RET:2106-3','N','021','DEN','2929842','99734OH005000401','2014-03-01','2014-02-02 22:17:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:28'),(22548,18005,'Y','18','021','EC','A','','','AC','0002052899','0002052899','LA00001914120','31','1','marange','edna','','','','34','433592215','PO Box 5394',0,'thibodaux','LA','70302',NULL,'CY','22057','1985-09-11','F','U',':RET:2106-3','T','021','DEN','2898311','18575LA002000101','2014-03-01','2014-02-10 15:15:03','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-02-10 21:31:43'),(23387,18636,'Y','18','021','EC','A','','','AC','0000749581','0000749581','OH00002169464','IL','1','WILSON','EZEKIEL','LESLIE','','','34','294666967','3692 ESQUIRE DR',0,'CANAL WINCHESTER','OH','43110','9412','CY','39049','1960-01-08','M','U',NULL,'N','021','DEN','3629746','99734OH005000401','2014-03-01','2014-02-13 14:12:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:01:03'),(24192,19217,'N','19','021','EC','A',NULL,NULL,'','0000076346','0000312240','','S1','1','Garrison','Gregory','L','','','34','302026660','88 Ralph Morrison Rd',0,'Peebles','OH','45660',NULL,'CY','39001','1998-08-23','F','',':RET:2106-3','N','021','DEN','3579054','99734OH005000301','2014-03-01','2014-02-15 19:30:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:14'),(25352,20117,'Y','18','024','14','A','','','TE','0000002313','0000002313','','IL','1','Brazelton','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-02','F','',NULL,NULL,NULL,'','2208958','','2014-03-11','2014-02-24 18:13:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:32'),(27004,21388,'Y','18','024','14','A','','','TE','0000556719','0000556719','','IL','1','Leighton','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-23','M','',NULL,NULL,NULL,'','1498868','','2014-03-31','2014-03-03 13:12:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:03'),(19220,15314,'Y','18','021','EC','A','','','AC','0000986035','0000986035','OH00001754943','IL','1','GRESHAM','STACY','','','','34','273600443','2668 BANNING RD',0,'CINCINNATI','OH','45239','5565','CY','39061','1962-10-27','F','U',':RET:2106-3','N','021','DEN','3183972','99734OH005000401','2014-03-01','2014-01-20 10:09:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-21 08:46:26'),(13701,10931,'Y','18','021','EC','A','','','AC','0000478477','0000478477','OH00000036521','IL','1','HAWKINS','ERICKA','','','','34','278701090','735 ROSCOE AVE',0,'AKRON','OH','44306','2561','CY','39153','1971-10-15','F','U',NULL,'N','021','HLT','2184633','52664OH151001304','2014-01-01','2013-12-23 12:29:16','139.00',NULL,NULL,'295.48','156.48','R-OH012','OH0','295.48',NULL,0,'2013-12-26 13:08:40'),(18371,14663,'Y','18','021','EC','A','','','AC','0000342755','0000342755','OH00002341246','IL','1','Tackett','Heather','','','','34','291644723','6201 SAND HILLS DR',0,'GOSHEN','OH','45122','8463','CY','39025','1973-11-28','F','U',':RET:2106-3','N','021','DEN','2602245','99734OH005000301','2014-02-01','2014-01-15 12:33:23','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:45:30'),(4484,3557,'Y','18','021','EC','A','','','AC','0000912935','0000912935','OH00000652868','IL','1','Williams','LaKisha','','','','34','287888848','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-05-18','F','R',':RET:2054-5','N','021','DEN','922603','99734OH005000301','2014-01-01','2013-12-12 15:40:37','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:03:02'),(7257,5754,'N','19','021','EC','A',NULL,NULL,'','0000038362','0000346878','','S1','1','McDowell','Chad','','','','34','280020678','127 Moores Road',0,'Seaman','OH','45679',NULL,'CY','39001','1997-06-18','M','',':RET:2106-3','N','021','HLT','996722','92036OH002000601','2014-01-01','2013-12-13 23:27:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 02:02:03'),(5944,4708,'Y','18','021','EC','A','','','AC','0001063245','0001063245','OH00000093088','IL','1','Adams','Carmen','','','','34','277522507','253 E CHURCH ST',0,'XENIA','OH','45385','3005','CY','39057','1952-10-25','F','U',':RET:2054-5','N','021','HLT','2005623','92036OH004000501','2014-01-01','2013-12-23 21:32:57','486.00',NULL,NULL,'537.11','51.11','R-OH003','OH0','537.11',NULL,0,'2013-12-25 23:50:55'),(4703,3728,'Y','18','021','EC','A','','','AC','0001178159','0001178159','OH00000972072','IL','1','STAFFEN','TAMMY','','','','34','277704717','8255 COUNTY ROAD 3',0,'SWANTON','OH','43558',NULL,'CY','39051','1962-06-05','F','M',':RET:2106-3','N','021','HLT','838337','92036OH004002601','2014-01-01','2013-12-12 10:46:56','424.00',NULL,NULL,'598.48','174.48','R-OH001','OH0','292.43',NULL,0,'2013-12-25 22:08:29'),(26018,20634,'Y','18','021','EC','A','','','AC','0001229752','0001229752','TX00002430988','IL','1','McCollum','Elizabeth','','','','34','585664867','1550 katy gap rd',0,'Katy','TX','77494',NULL,'CY','48157','1957-01-23','F','U',NULL,'N','021','DEN','3796152','33348TX002000101','2014-03-01','2014-02-26 07:39:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-26 21:02:13'),(26269,20836,'Y','18','021','EC','A','','','AC','0000068295','0000068295','TX00003515216','IL','1','Alvizo','Apolonio','','','','34','451977008','1315 W KUYKENDALL ST',0,'GRAND SALINE','TX','75140','1425','CY','48467','1953-02-09','M','U',NULL,'N','021','DEN','3002808','33348TX002000201','2014-04-01','2014-02-27 17:32:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:31:15'),(27455,21728,'Y','18','021','EC','A','','','AC','0001142236','0001142236','OH00002664602','IL','1','Berry','Marcia','','','','34','273525467','506 ORLANDO AVE',0,'AKRON','OH','44320','1220','CY','39153','1952-01-08','F','U',NULL,'N','021','HLT','3409792','52664OH152000901','2014-04-01','2014-03-03 20:42:31','372.00',NULL,NULL,'469.28','97.28','R-OH012','OH0','469.28',NULL,0,'2014-03-04 21:02:02'),(27611,21837,'Y','18','021','EC','A','','','AC','0001888275','0001888275','LA00003386114','31','1','RICHARD','JUANITA','','','','34','433780949','PO BOX 116',0,'MERMANTAU','LA','70556',NULL,'CY','22001','1949-08-03','F','U',':RET:2106-3','N','021','DEN','2996858','18575LA002000201','2014-04-01','2014-03-05 17:37:22','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61','CIC',0,'2014-03-05 21:00:28'),(28390,22462,'N','19','021','EC','A',NULL,NULL,'','0000498238','0000655887','','S1','1','Lantz','Michael','','','','34','646835260','701 RUDOLPH AVE',0,'CUYAHOGA FALLS','OH','44221','1939','CY','39153','2013-03-24','F','',NULL,'N','021','HLT','3434437','52664OH152000901','2014-04-01','2014-03-07 17:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-07 21:30:45'),(20154,16083,'Y','18','021','EC','A','','','AC','0000196167','0000196167','OH00001362582','IL','1','Davis','Page','','','','34','277967260','507 lowell ave',0,'cincinnati','OH','45220',NULL,'CY','39061','1993-03-25','F','U',':RET:2054-5','N','021','DEN','3239458','99734OH005000301','2014-03-01','2014-01-27 10:12:30','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','21.13',NULL,0,'2014-01-27 21:01:05'),(14923,11924,'Y','18','021','EC','A','','','AC','0002189762','0002189762','LA00000055729','IL','1','Burnom','Walter','','','','34','435118424','1414 Highland Ave',0,'Shreveport','LA','71101',NULL,'CY','22017','1962-05-03','M','U',':RET:2054-5','N','021','DEN','1888850','18575LA002000101','2014-02-01','2013-12-28 22:52:04','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-30 00:01:45'),(797,658,'Y','18','021','EC','A','','','AC','0000311517','0000311517','TX00000405270','IL','1','Robinson','Bilindra','','','','34','454491889','904 S ROCKWALL ST',0,'TERRELL','TX','75160','4412','CY','48257','1965-12-30','F','M',':RET:2054-5','N','021','DEN','1490560','33348TX002000201','2014-01-01','2013-12-16 16:51:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:05:27'),(19734,15727,'Y','18','021','EC','A','','','AC','0002354590','0002354590','LA00002406235','IL','1','WINDER','JEFFERY','','','','34','436476945','1104D POLK STREET',0,'WINNSBORO','LA','71295',NULL,'CY','22041','1981-07-18','M','U',':RET:2054-5','T','021','DEN','2694362','18575LA002000201','2014-03-01','2014-01-23 11:36:51','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-23 21:01:07'),(1855,1519,'Y','18','021','EC','A','','','AC','0000155783','0000155783','OH00000008050','IL','1','Kopp','Nancy','','','','34','300501249','1522 MAPLE AVE',0,'WYOMING','OH','45215','2118','CY','39061','1952-01-05','F','U',':RET:2106-3','N','021','HLT','2260352','92036OH005001201','2014-01-01','2013-12-24 16:00:35','315.00',NULL,NULL,'603.24','288.24','R-OH004','OH0','603.24',NULL,0,'2013-12-25 18:58:01'),(2449,1994,'Y','18','021','EC','A','','','AC','0000015218','0000015218','TX00000423076','IL','1','Sabath','Kenneth','Michael','','','34','141428373','4214 Waterside Ct.',0,'Missouri City','TX','77459',NULL,'CY','48157','1956-09-12','M','M',':RET:2106-3','N','021','DEN','613568','33348TX002000101','2014-01-01','2013-12-08 20:25:34','0.00',NULL,NULL,'128.55','128.55','R-TX010','TX0','27.15',NULL,0,'2013-12-25 19:34:38'),(17041,13636,'Y','18','021','EC','A','','','AC','0001074165','0001074165','OH00002370546','IL','1','Mize','Cindy','','','','34','378641339','2999 Carmody Blvd.',0,'Middletown','OH','45042',NULL,'CY','39017','1960-03-01','F','M',':RET:2106-3','T','021','HLT','1540283','92036OH004001201','2014-02-01','2014-01-08 19:22:38','555.00',NULL,NULL,'921.67','366.67','R-OH004','OH0','404.95',NULL,0,'2014-01-13 02:20:51'),(7453,5899,'N','19','021','EC','A',NULL,NULL,'','0000896969','0000177620','','IL','1','KOPPEL','SAMUEL','DALTON','','','34','277110169','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','2005-01-25','M','',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:30:45'),(14234,11352,'Y','18','021','EC','A','','','AC','0000902758','0000902758','MS00000374074','IL','1','Davis','William','','','','34','353445869','135 Sand Rd.',0,'Starkville','MS','39759',NULL,'CY','28105','1952-02-08','M','M',':RET:2054-5','N','021','DEN','1584477','46300MS002000101','2014-02-01','2013-12-26 00:18:36','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-27 02:05:06'),(5711,4534,'Y','18','021','EC','A','','','AC','0000153370','0000153370','OH00001343258','IL','1','Soskin','Joan','','','','34','470192467','1278 W. 9th Street',0,'Cleveland','OH','44113',NULL,'CY','39035','1989-05-10','F','R',':RET:2106-3','N','021','HLT','2398147','52664OH151001301','2014-01-01','2013-12-23 22:58:13','0.00',NULL,NULL,'251.52','251.52','R-OH011','OH0','251.52',NULL,0,'2013-12-25 23:45:09'),(6708,5318,'Y','18','021','EC','A','','','AC','0000242724','0000242724','MS00000773781','IL','1','Padgett','Albert','','','','34','454980409','215 GENEVA BLVD',0,'MADISON','MS','39110','7740','CY','28089','1953-05-08','M','U',':RET:2106-3','T','021','DEN','331514','46300MS002000101','2014-01-01','2013-11-05 02:37:07','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 01:02:08'),(24307,19306,'Y','18','021','EC','A','','','AC','0001885767','0001885767','LA00002713407','IL','1','STEWART','ANGELA','','','','34','437233363','216 EVELYN AVE',0,'HOUMA','LA','70363',NULL,'CY','22109','1970-05-03','F','M',':RET:2054-5','N','021','DEN','3121202','18575LA002000101','2014-03-01','2014-02-18 17:30:25','0.00',NULL,NULL,'183.69','183.69','R-LA002','LA0','25.02','CIC',0,'2014-02-18 21:30:23'),(28863,22841,'Y','18','021','EC','A','','','AC','0001153742','0001153742','LA00003362707','IL','1','owen','kevin','','','','34','086644126','1014 colonial dr',0,'jackson','LA','70748',NULL,'CY','22037','1979-07-01','M','U',':RET:2106-3','N','021','DEN','4332495','18575LA002000101','2014-04-01','2014-03-09 13:52:42','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02','CIC',0,'2014-03-09 21:30:05'),(1196,985,'Y','18','021','EC','A','','','AC','0000518373','0000518373','OH00000442108','IL','1','Hartley','Randy','','','','34','268522683','12205 Goshen Rd',0,'Salem','OH','44460',NULL,'CY','39099','1951-11-13','M','M',':RET:2106-3','N','021','DEN','25960','99734OH005000301','2014-01-01','2013-12-03 13:30:53','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:19:45'),(5336,4232,'Y','18','021','EC','A','','','AC','0000341326','0000341326','OH00001264961','IL','1','Rivers','Rausheen','','','','34','300765379','844 STADELMAN AVE',0,'AKRON','OH','44320','2275','CY','39153','1981-02-25','M','U',':RET:2054-5','T','021','DEN','1833600','99734OH005000301','2014-01-01','2013-12-19 14:38:19','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:07:12'),(4134,3300,'N','19','021','EC','A',NULL,NULL,'','0000843322','0000047077','','IL','1','Cater','Ann','','','','34','289963469','9871 N POINTE CIR',0,'BRECKSVILLE','OH','44141','3186','CY','39035','1993-08-10','F','',':RET:2106-3','N','021','DEN','2040203','99734OH005000301','2014-01-01','2013-12-17 10:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:27'),(20450,16334,'Y','18','024','14','A','','','TE','0000445396','0000445396','','IL','1','GRANT','SHIRLEY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-09','F','',NULL,NULL,NULL,'','3056742','','2014-01-29','2014-01-29 15:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-29 21:00:44'),(18108,14464,'Y','18','021','EC','A','','','AC','0001395992','0001395992','LA00002517104','IL','1','patterson','monique','','','','34','436278431','2308 marye st',0,'alexandria','LA','71301',NULL,'CY','22079','1975-01-21','F','M',':RET:2054-5','N','021','DEN','1437392','18575LA002000201','2014-02-01','2014-01-14 18:10:09','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-15 02:07:36'),(16732,13390,'N','19','021','EC','A',NULL,NULL,'','0000142840','0000765987','','S1','1','Marty','Michael','','','','34','270089196','2156 Steiner rd',0,'Creston','OH','44217',NULL,'CY','39169','2002-10-04','M','',':RET:2106-3','N','021','HLT','2533888','52664OH151001301','2014-02-01','2014-01-07 16:56:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:50'),(8911,7067,'N','01','021','EC','A',NULL,NULL,'','0001044471','0000381125','','IL','1','PAGANO','DIANNA','','','','34','302547664','2804 LEXINGTON AVE NW',0,'WARREN','OH','44485','1536','CY','39155','1954-01-07','F','',':RET:2106-3','N','021','DEN','2522825','99734OH005000401','2014-01-01','2013-12-17 20:40:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:34'),(15697,12558,'Y','18','021','EC','A','','','AC','0000226030','0000226030','OH00000019311','IL','1','Goist','Dale','','','','34','286466298','6504 Elm St',0,'Kinsman','OH','44428',NULL,'CY','39155','1955-11-08','M','M',':RET:2106-3','N','021','HLT','2292427','92036OH003003204','2014-02-01','2013-12-31 12:33:25','811.00',NULL,NULL,'1159.72','348.72','R-OH013','OH0','644.06',NULL,1,'2014-01-02 04:35:35'),(9661,7654,'Y','18','021','EC','A','','','AC','0000494433','0000494433','OH00000037520','IL','1','Crabtree','Donald','','','','34','271464667','6602 Convent Blvd',0,'Sylvania','OH','43560',NULL,'CY','39095','1950-10-24','M','U',':RET:2106-3','N','021','HLT','1939081','92036OH004002601','2014-01-01','2013-12-21 15:24:26','0.00',NULL,NULL,'462.84','462.84','R-OH001','OH0','462.84',NULL,0,'2013-12-26 04:38:59'),(14583,11638,'Y','18','021','EC','A','','','AC','0002076063','0002076063','LA00000606923','IL','1','HILL','PAULA','','','','34','434311109','114 APRICOT ST',0,'THIBODAUX','LA','70301','2020','CY','22057','1960-07-08','F','U',':RET:2054-5','N','021','DEN','1818046','18575LA002000101','2014-02-01','2013-12-27 18:01:42','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2013-12-28 03:35:54'),(14352,11446,'Y','18','021','EC','A','','','AC','0000420035','0000420035','OH00000529187','IL','1','KINDLE','EDWARD','','','','34','045780629','4377 HAIGHT AVE',0,'CINCINNATI','OH','45223','1748','CY','39061','1985-11-07','M','U',':RET:2106-3','N','021','DEN','1926527','99734OH005000401','2014-02-01','2013-12-26 18:30:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:03'),(20953,16743,'N','01','021','EC','A',NULL,NULL,'','0001235507','0000733937','','IL','1','LUNA','BERTHA ALICIA','','','','34','638139393','4312 PIZZARO DR',0,'EDINBURG','TX','78542',NULL,'CY','48215','1964-10-07','F','',NULL,'N','021','DEN','2801088','33348TX002000201','2014-03-01','2014-01-31 19:31:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-01 19:00:05'),(25254,20034,'Y','18','021','EC','A','','','AC','0000449922','0000449922','OH00003117490','IL','1','Alt','Tim','','','','34','618356675','988 Wadsworth',0,'Medina','OH','44256',NULL,'CY','39103','1989-11-13','M','R',':RET:2106-3','N','021','HLT','3695948','52664OH152001001','2014-04-01','2014-02-21 17:33:56','0.00',NULL,NULL,'122.61','122.61','R-OH012','OH0','122.61',NULL,0,'2014-02-21 22:01:16'),(26469,20996,'Y','18','021','EC','A','','','AC','0000482101','0000482101','MS00003307067','IL','1','sanderford','marisel','','','','34','261532017','409 pearce rd',0,'mt olive','MS','39119',NULL,'CY','28031','1968-07-12','F','U',':RET:2500-7','T','021','DEN','2903821','46300MS002000201','2014-04-01','2014-02-27 13:25:34','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85','CIC',0,'2014-02-28 07:30:36'),(26924,21337,'Y','18','021','EC','A','','','AC','0000934715','0000934715','OH00002602508','IL','1','Schweitzer','Teresa','','','','34','272606391','P. O. Box 245',0,'Defiance','OH','43512',NULL,'CY','39039','1963-12-21','F','U',':RET:2106-3','N','021','DEN','2748597','99734OH005000401','2014-04-01','2014-03-02 08:22:30','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-03 01:00:16'),(18266,14583,'Y','18','021','EC','A','','','AC','0000102399','0000102399','TX00001460104','IL','1','Smus','Tara','','','','34','368946108','2914 HUNTINGTON WAY',0,'PEARLAND','TX','77584','9423','CY','48039','1972-05-19','F','M',':RET:2106-3','N','021','DEN','2263147','33348TX002000201','2014-02-01','2014-01-15 15:58:45','0.00',NULL,NULL,'72.22','72.22','R-TX010','TX0','15.85',NULL,0,'2014-01-16 08:44:39'),(15749,12600,'Y','18','021','EC','A','','','AC','0000838530','0000838530','TX00001376375','IL','1','garcia','raul','','','','34','452864182','1242 GRAHAM ST',0,'ABILENE','TX','79603','4918','CY','48441','1950-09-17','M','M',NULL,'T','021','DEN','1863392','33348TX002000201','2014-02-01','2014-01-02 14:48:03','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-01-03 02:01:06'),(1527,1272,'Y','18','021','EC','A','','','AC','0000915652','0000915652','OH00000334967','IL','1','Vonhedemann','Kimberly','','','','34','290586023','1412 St Rte 125',0,'Hamersville','OH','45130',NULL,'CY','39015','1954-11-06','F','U',NULL,'N','021','DEN','1466415','99734OH005000401','2014-01-01','2013-12-24 15:50:57','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:49:54'),(5277,4182,'Y','18','021','EC','A','','','AC','0001090909','0001090909','OH00000276722','IL','1','Williams','Elizabeth','','','','34','282829973','4556 ROOTSTOWN RD',0,'RAVENNA','OH','44266','9571','CY','39133','1969-09-09','F','M',':RET:2106-3','T','021','HLT','1407594','52664OH151001306','2014-01-01','2013-12-19 14:06:48','247.00',NULL,NULL,'358.27','111.27','R-OH012','OH0','358.27',NULL,0,'2013-12-25 23:05:41'),(22113,17650,'Y','18','021','EC','A','','','AC','0000891175','0000891175','TX00002568294','IL','1','Michael','Charles','','','','34','452893414','16 Uvalde Rd',0,'Houston','TX','77015',NULL,'CY','48201','1974-06-10','M','U',':RET:2054-5','N','021','DEN','2974097','33348TX002000101','2014-03-01','2014-02-07 19:04:11','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-08 19:00:35'),(24986,19818,'Y','18','021','EC','A','','','AC','0000460804','0000460804','TX00002949030','IL','1','GAMEZ','JOSE','RODOLFO','','','34','461904176','661 ARTESANO RD',0,'SOCORRO','TX','79927','3070','CY','48141','1952-02-17','M','M',NULL,'N','021','DEN','3603473','33348TX002000201','2014-04-01','2014-02-20 13:57:24','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-20 22:00:37'),(26139,20726,'N','01','021','EC','A',NULL,NULL,'','0000153425','0001234171','','IL','1','BELISARI','JOHN','','','','34','302504075','501 E BROAD ST',0,'COLUMBUS','OH','43215','3822','CY','39049','1952-09-18','M','',NULL,'N','021','DEN','3744521','99734OH005000401','2014-04-01','2014-02-27 12:31:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:25'),(28761,22765,'Y','18','021','EC','A','','','AC','0000368559','0000368559','TX00003148194','IL','1','Godbolt','Johnduras','','','','34','593128142','412 SW 16th Ave',0,'Amarillo','TX','79101',NULL,'CY','48375','1977-05-13','M','U',':RET:2054-5','N','021','DEN','3895328','33348TX002000201','2014-04-01','2014-03-09 14:29:58','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-03-09 21:00:22'),(17972,14360,'N','01','021','EC','A',NULL,NULL,'','0001260031','0000191389','','IL','1','Minhas','Mohammad','Altaf',NULL,NULL,NULL,NULL,'4897 SHINING WILLOW BLVD',0,'STOW','OH','44224','5935','CY','39153','1957-01-13','M','',':RET:2029-7','N','021','HLT','1942667','52664OH151001306','2014-02-01','2014-01-14 03:45:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2014-01-15 02:06:50'),(1906,1558,'Y','18','021','EC','A','','','AC','0000357203','0000357203','OH00001445758','IL','1','Epley','Michael','','','','34','286901643','2221 LAKEWOOD AVE',0,'LIMA','OH','45805','3146','CY','39003','1986-12-17','M','R',':RET:2106-3','N','021','HLT','1849955','92036OH004001501','2014-01-01','2013-12-24 17:51:56','0.00',NULL,NULL,'185.46','185.46','R-OH002','OH0','185.46',NULL,0,'2013-12-25 18:59:16'),(9455,7500,'N','01','021','EC','A',NULL,NULL,'','0000496746','0000498151','','IL','1','Grande','Stephen','M','','','34','277806190','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','1968-12-05','M','',':RET:2106-3','N','021','DEN','1590351','99734OH005000401','2014-01-01','2013-12-20 22:20:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:05'),(14608,11659,'Y','18','021','EC','A','','','AC','0000389848','0000389848','OH00001496283','IL','1','Ziems','Frederick','R','','','34','276547357','4355 WILLYS PKWY',0,'TOLEDO','OH','43612','2167','CY','39095','1962-12-06','M','U',':RET:2106-3','N','021','DEN','1981833','99734OH005000301','2014-02-01','2013-12-27 12:37:54','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-28 03:36:34'),(7131,5658,'Y','18','021','EC','A','','','AC','0000844711','0000844711','OH00001378660','IL','1','Arvin','Karen','','','','34','296589469','10 WACO WAY',0,'HAMILTON','OH','45015','1342','CY','39017','1956-08-09','F','U',':RET:2106-3','N','021','HLT','1374545','92036OH005001201','2014-02-01','2013-12-25 09:36:40','127.00',NULL,NULL,'523.16','396.16','R-OH004','OH0','523.16',NULL,0,'2013-12-26 01:51:35'),(15608,12484,'N','01','021','EC','A',NULL,NULL,'','0000965780','0000399897','','IL','1','Armstrong','Lindsay','','','','34','293927658','943 Brittany Drive',0,'Delaware','OH','43015',NULL,'CY','39041','1988-03-24','F','',':RET:2106-3','N','021','DEN','2188430','99734OH005000301','2014-02-01','2013-12-31 15:41:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:44'),(27785,21975,'Y','18','021','EC','A','','','AC','0000508365','0000508365','MS00003558967','IL','1','COLLINS','BOMAN','','','','34','587608862','4503 IRONWOOD LN',0,'JACKSON','MS','39212','3519','CY','28049','1952-12-19','M','U',':RET:2054-5','N','021','DEN','4074913','46300MS002000201','2014-04-01','2014-03-04 20:35:40','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-05 21:31:36'),(28861,22839,'Y','18','021','EC','A','','','AC','0001840095','0001840095','LA00003760578','IL','1','Stevens','LeeAnna','','','','34','451026975','1413 ALVIN ST',0,'LAKE CHARLES','LA','70601','5801','CY','22019','1969-05-23','F','M',':RET:2106-3','N','021','DEN','3688643','18575LA002000201','2014-04-01','2014-03-09 13:14:28','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61','CIC',0,'2014-03-09 21:30:03'),(29168,23088,'Y','18','021','EC','A','','','AC','0000201983','0000201983','OH00003548894','IL','1','Badowski','Clint','David','','','34','198663113','303 S MAIN ST',0,'SPENCER','OH','44275','9747','CY','39103','1985-06-18','M','R',':RET:2106-3','N','021','HLT','4310531','52664OH151001501','2014-05-01','2014-03-10 15:11:21','0.00',NULL,NULL,'759.87','759.87','R-OH012','OH0','290.74',NULL,0,'2014-03-10 21:02:58'),(20708,16547,'Y','18','021','EC','A','','','AC','0002316275','0002316275','LA00002150289','IL','1','SINGLETON','SHANNON','','','','34','438137646','54915 TASSIN DR',0,'WHITE CASTLE','LA','70788',NULL,'CY','22047','1971-11-30','F','U',NULL,'N','021','DEN','3332844','18575LA002000201','2014-03-01','2014-01-30 13:10:18','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-30 21:01:07'),(388,321,'Y','18','021','EC','A','','','AC','0000827126','0000827126','OH00001274908','IL','1','McRae-Gibson','Margaret','','','','34','284624412','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1958-04-08','F','M',':RET:2054-5','N','021','HLT','326885','92036OH004003201','2014-01-01','2013-12-03 18:55:06','818.05',NULL,NULL,'824.07','6.02','R-OH013','OH0','434.03',NULL,0,'2013-12-25 17:45:52'),(16006,12810,'N','01','021','EC','A',NULL,NULL,'','0001094116','0000892511','','IL','1','VEGA','FERNANDO','','','','34','643727886','910 9H ST',0,'PALACIOS','TX','77465',NULL,'CY','48321','1982-09-17','M','',NULL,'N','021','DEN','1672990','33348TX002000201','2014-02-01','2014-01-03 16:26:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:01:38'),(883,731,'Y','18','021','EC','A','','','AC','0000612980','0000612980','OH00001162349','IL','1','Bowman','Linda','Lou','','','34','450028741','7344 Willow Dr',0,'Blanchester','OH','45107',NULL,'CY','39027','1952-07-21','F','U',':RET:2106-3','N','021','HLT','1934786','92036OH003000605','2014-01-01','2013-12-16 10:16:24','450.00',NULL,NULL,'629.96','179.96','R-OH005','OH0','629.96',NULL,0,'2013-12-25 18:07:47'),(974,797,'N','01','021','EC','A',NULL,NULL,'','0000014313','0000396780','','IL','1','Lirette','Lindsay','B','','','34','434479933','15650 BACCA ST',0,'PONCHATOULA','LA','70454','9436','CY','22105','1981-12-26','F','',':RET:2106-3','N','021','DEN','819201','18575LA002000201','2014-01-01','2013-10-29 00:42:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:10:05'),(4715,3738,'Y','18','024','14','A','','','TE','0000132047','0000132047','','IL','1','MOLONEY','NICOLE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-12','F','',NULL,NULL,NULL,'','618345','','2013-12-12','2013-12-12 16:54:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:08:49'),(14587,11642,'Y','18','021','EC','A','','','AC','0001124072','0001124072','OH00000195714','IL','1','Bruskotter','Christopher','','','','34','297921626','257 N. Main St.',0,'Glandorf','OH','45848',NULL,'CY','39137','1989-12-30','M','R',':RET:2106-3','N','021','HLT','1820313','92036OH005001501','2014-02-01','2013-12-27 16:38:27','0.00',NULL,NULL,'220.08','220.08','R-OH002','OH0','220.08',NULL,0,'2013-12-28 03:36:01'),(14493,11562,'Y','18','021','EC','A','','','AC','0000592152','0000592152','TX00000568456','IL','1','MIZZLES','OLGA','','','','34','630023802','2051 W CUMBERLAND',0,'TYLER','TX','75703',NULL,'CY','48423','1960-12-19','F','M',NULL,'N','021','DEN','1918745','33348TX002000201','2014-02-01','2013-12-27 12:23:37','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-28 03:33:34'),(3906,3124,'N','01','021','EC','A',NULL,NULL,'','0000857079','0000340268','','IL','1','MOOMEY','RAYMOND','','','','34','275649155','17231 W TRUE RD',0,'GRAYTOWN','OH','43432','9799','CY','39123','1960-08-11','M','',':RET:2106-3','N','021','HLT','394064','92036OH005002705','2014-01-01','2013-12-12 18:52:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','397.79',NULL,0,'2013-12-25 21:36:57'),(3152,2535,'Y','18','021','EC','A','','','AC','0000665595','0000665595','OH00000289599','IL','1','MEEKER','JASON','','','','34','285866602','60 MAYWOOD ST',0,'LUCASVILLE','OH','45648','8812','CY','39145','1977-10-08','M','U',':RET:2106-3','N','021','DEN','111525','99734OH005000301','2014-01-01','2013-11-17 21:58:19','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 20:31:04'),(3044,2445,'N','01','021','EC','A',NULL,NULL,'','0000970432','0001144749','','IL','1','Deger','Jacqueline','Margaret','','','34','287581081','1436 WATERS EDGE DR',0,'AKRON','OH','44313','8635','CY','39153','1955-11-02','F','',':RET:2106-3','N','021','HLT','662317','52664OH152000901','2014-01-01','2013-12-06 13:42:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.19',NULL,0,'2013-12-25 20:18:43'),(9748,7719,'Y','18','021','EC','A','','','AC','0000466512','0000466512','LA00000584301','IL','1','Stephens','Matthew','','','','34','232314198','114 HOLLYWOOD PARK RD',0,'LA PLACE','LA','70068','8940','CY','22089','1983-08-20','M','U',':RET:2106-3','N','021','DEN','1132824','18575LA002000101','2014-01-01','2013-11-15 16:15:03','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:46:08'),(21982,17555,'Y','18','021','EC','A','','','AC','0002205384','0002205384','LA00001707141','IL','1','THAMPAGNE','TONY','','','','34','439829632','9418 S LIBERALS DR',0,'BATONROGE','LA','70815',NULL,'CY','22033','1951-11-13','M','M',':RET:2054-5','N','021','DEN','2789793','18575LA002000201','2014-03-01','2014-02-06 18:45:07','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-07 19:00:38'),(22882,18247,'N','19','021','EC','A',NULL,NULL,'','0001004383','0001029410','','IL','1','Dao','Thuan','','','','34','615748778','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1994-06-10','M','',NULL,'N','021','HLT','3544978','52664OH151001501','2014-03-01','2014-02-11 11:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-11 21:02:34'),(26321,20882,'Y','18','021','EC','A','','','AC','0000190558','0000190558','MS00002831948','31','1','King','Belinda','','','','34','592306691','P O Box 654',0,'Corinth','MS','38835',NULL,'CY','28003','1979-11-05','F','U',':RET:2106-3','N','021','DEN','3627475','46300MS002000101','2014-04-01','2014-02-27 09:55:19','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-28 06:31:36'),(26935,21347,'Y','18','021','EC','A','','','AC','0000884280','0000884280','OH00003464206','IL','1','Kettler','Timothy','','','','34','298483214','29674 TOWNSHIP ROAD 30',0,'WARSAW','OH','43844','9754','CY','39031','1950-05-07','M','M',':RET:2106-3','N','021','DEN','2873243','99734OH005000301','2014-04-01','2014-03-02 11:04:38','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-03-03 01:00:21'),(20772,16596,'Y','18','021','EC','A','','','AC','0001012960','0001012960','OH00002472673','IL','1','Ritt','Wanda','','','','34','271688073','5631 RIBER RD',0,'HILLSBORO','OH','45133','7574','CY','39071','1960-04-08','F','M',NULL,'T','021','HLT','2858456','92036OH005000606','2014-03-01','2014-01-30 17:26:09','384.00',NULL,NULL,'503.62','119.62','R-OH005','OH0','503.62',NULL,0,'2014-01-30 21:01:41'),(18542,14787,'Y','18','021','EC','A','','','AC','0000256241','0000256241','MS00002548706','IL','1','Romine','Charles','','','','34','448662644','147 FOREST RIDGE DR',0,'BRANDON','MS','39042','2031','CY','28121','1968-08-08','M','U',':RET:2106-3','N','021','DEN','2716126','46300MS002000101','2014-02-01','2014-01-15 14:41:15','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-16 08:46:50'),(6646,5274,'Y','18','021','EC','A','','','AC','0001037553','0001037553','TX00001200110','IL','1','Arriaga','Juanita','','','','34','467477878','4623 County Road 1170',0,'Lubbock','TX','79407',NULL,'CY','48303','1964-04-01','F','M',':RET:2106-3','N','021','DEN','223668','33348TX002000201','2014-01-01','2013-11-12 15:31:27','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2013-12-26 01:00:28'),(16189,12961,'Y','18','021','EC','A','','','AC','0001141094','0001141094','TX00001189977','31','1','Darr','Kelly','','','','34','455257502','PO Box 161',0,'Vanderpool','TX','78885',NULL,'CY','48463','1965-09-15','M','U',':RET:2106-3','N','021','DEN','1904995','33348TX002000201','2014-02-01','2014-01-03 23:28:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-05 00:00:46'),(7596,6010,'Y','18','021','EC','A','','','AC','0000102791','0000102791','OH00000455618','IL','1','Burrows','Tammy','','','','34','283648544','501 Clifton Avenue',0,'Findlay','OH','45840',NULL,'CY','39063','1960-11-04','F','U',':RET:2106-3','T','021','DEN','667343','99734OH005000401','2014-01-01','2013-11-17 10:20:45','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 02:45:14'),(13647,10886,'Y','18','021','EC','A','','','AC','0001170986','0001170986','LA00000238318','IL','1','Tademy','Rose','','','','34','436042000','4110 BEECH ST',0,'BATON ROUGE','LA','70805','2903','CY','22033','1958-01-30','F','M',':RET:2054-5','N','021','DEN','2114702','18575LA002000101','2014-01-01','2013-12-22 19:42:29','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 13:07:10'),(13940,11118,'Y','18','021','EC','A','','','AC','0000661345','0000661345','OH00000491142','IL','1','Poshedley','Rocco','','','','34','290624439','11081 FAIRLAWN DR',0,'PARMA','OH','44130','1217','CY','39035','1966-04-14','M','M',NULL,'N','021','HLT','1777511','92036OH003000804','2014-01-01','2013-12-22 22:14:01','575.00',NULL,NULL,'1212.35','637.35','R-OH011','OH0','381.62',NULL,0,'2013-12-26 13:14:43'),(21267,16996,'Y','18','024','14','A','','','TE','0001237975','0001237975','','IL','1','RAMSEY','KELLIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-29','F','',NULL,NULL,NULL,'','1556904','','2014-02-03','2014-02-03 13:03:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:01:28'),(24156,19193,'Y','18','024','14','A','','','TE','0001258686','0001258686','','IL','1','Craft','Patsy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-03-01','F','',NULL,NULL,NULL,'','3036326','','2014-02-14','2014-02-14 18:44:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:02:00'),(521,426,'Y','18','021','EC','A','','','AC','0001053027','0001053027','OH00000331518','IL','1','Shonebarger','Gary','','','','34','279424312','1455 HILLBROOK DR NE',0,'LANCASTER','OH','43130','1106','CY','39045','1951-02-01','M','M',':RET:2106-3','N','021','DEN','4951','99734OH005000301','2014-01-01','2013-12-04 11:20:44','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:49:13'),(20950,16741,'Y','18','021','EC','A','','','AC','0000070799','0000070799','TX00001974804','31','1','bearden','valorie','ann','','','34','464884788','null null',0,'POWELL','TX','75153','0174','CY','48349','1951-12-05','F','M',':RET:2106-3','N','021','DEN','2626446','33348TX002000201','2014-03-01','2014-01-31 18:36:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-01 19:00:04'),(1567,1308,'Y','18','021','EC','A','','','AC','0000261582','0000261582','TX00001106248','IL','1','ortiz','eliceo','','','','34','634466065','315 E 95TH ST',0,'ODESSA','TX','79765','1464','CY','48135','1985-06-11','M','M',':RET:2106-3','N','021','DEN','2536000','33348TX002000201','2014-01-01','2013-12-24 08:44:31','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-25 18:51:04'),(20902,16707,'Y','18','021','EC','A','','','AC','0000715008','0000715008','OH00001924865','IL','1','Houchin','Tyler','','','','34','284800559','129 W 1ST AVE',0,'COLUMBUS','OH','43201','3489','CY','39049','1981-08-08','M','R',':RET:2106-3','N','021','DEN','2910137','99734OH005000401','2014-03-01','2014-01-31 14:53:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-31 21:01:21'),(18719,14921,'N','01','021','EC','A',NULL,NULL,'','0000175128','0000764990','','IL','1','Ervin','Alva','','','','34','276764195','277 Waterside Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1964-12-26','F','',':RET:2054-5','N','021','DEN','1817250','99734OH005000301','2014-02-01','2014-01-15 22:58:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:33'),(16325,13070,'Y','18','021','EC','A','','','AC','0001471488','0001471488','LA00000590707','IL','1','WILLIAMS','EUGENIA','','','','34','438233890','4305 ILLINOIS AVE',0,'SHREVEPORT','LA','71109',NULL,'CY','22017','1965-11-18','F','U',':RET:2054-5','T','021','DEN','2410492','18575LA002000201','2014-02-01','2014-01-06 09:28:27','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-07 04:01:48'),(16089,12885,'Y','18','021','EC','A','','','AC','0001209572','0001209572','MS00002215542','IL','1','FLOOD','ANNIE','K','','','34','587926473','3667  JAMES MONROE DR',0,'JACKSON','MS','39213',NULL,'CY','28049','1956-08-15','F','U',':RET:2054-5','N','021','DEN','2462530','46300MS002000201','2014-02-01','2014-01-02 19:50:54','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-04 02:04:21'),(2430,1979,'Y','18','021','EC','A','','','AC','0001097760','0001097760','OH00000985889','IL','1','Porozynski','Mary','Jane','','','34','277465042','9549 ANGELA DR',0,'TWINSBURG','OH','44087','3297','CY','39153','1955-09-13','F','U',':RET:2106-3','N','021','HLT','592979','52664OH151001304','2014-01-01','2013-12-08 19:45:17','372.00',NULL,NULL,'568.22','196.22','R-OH012','OH0','568.22',NULL,0,'2013-12-25 19:34:09'),(15063,12041,'Y','18','021','EC','A','','','AC','0002156022','0002156022','LA00001733557','IL','1','Burton','Lisa','','','','34','433434465','4549 Jonesboro Rd',0,'West Monroe','LA','71292',NULL,'CY','22073','1963-09-10','F','U',':RET:2106-3','N','021','DEN','2312147','18575LA002000201','2014-02-01','2013-12-30 15:55:38','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:03:38'),(14337,11437,'Y','18','021','EC','A','','','AC','0001088273','0001088273','OH00001745524','IL','1','Fugett','Rosemary','C','','','34','276548348','167 YANKEE RD',0,'WILMINGTON','OH','45177','9738','CY','39027','1951-05-26','F','U',':RET:2106-3','N','021','HLT','2379952','92036OH003000605','2014-02-01','2013-12-26 14:23:02','524.00',NULL,NULL,'644.07','120.07','R-OH005','OH0','644.07',NULL,0,'2013-12-27 02:07:46'),(3064,2462,'Y','18','021','EC','A','','','AC','0000265021','0000265021','LA00000436933','IL','1','cole','vivian','','','','34','587785563','9537 Crandon Drive',0,'Baton Rouge','LA','70810',NULL,'CY','22033','1952-11-08','F','U',':RET:2054-5','N','021','DEN','711718','18575LA002000201','2014-01-01','2013-12-06 16:39:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:19:15'),(13614,10855,'Y','18','021','EC','A','','','AC','0000533297','0000533297','OH00000510001','IL','1','Huffman','Gina','Gail','','','34','285743447','3683 MOONRIDGE DR',0,'CINCINNATI','OH','45248','4222','CY','39061','1963-08-13','F','U',':RET:2106-3','N','021','HLT','2603002','92036OH002001201','2014-01-01','2013-12-23 12:03:31','0.00',NULL,NULL,'442.75','442.75','R-OH004','OH0','442.75',NULL,0,'2013-12-26 13:05:41'),(14331,11431,'Y','18','021','EC','A','','','AC','0000382166','0000382166','OH00000213190','IL','1','Holeton','Gladys','','','','34','299505271','1145 WESTVIEW AVE',0,'ASHLAND','OH','44805','2958','CY','39005','1952-07-17','F','U',':RET:2106-3','N','021','HLT','2189525','52664OH151001501','2014-02-01','2013-12-26 14:45:22','351.00',NULL,NULL,'751.58','400.58','R-OH012','OH0','751.58',NULL,0,'2013-12-27 02:07:33'),(21976,17550,'Y','18','021','EC','A','','','AC','0002235421','0002235421','LA00002348430','IL','1','Gonzalez','Edwin','','','','34','102782331','1010 LAKE AVE',0,'METAIRIE','LA','70005','2565','CY','22051','1965-12-20','M','M',NULL,'N','021','DEN','3841776','18575LA002000101','2014-03-01','2014-02-06 18:35:44','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-02-07 19:00:33'),(28108,22248,'N','19','021','EC','A',NULL,NULL,'','0001019326','0000230508','','IL','1','Ulman','Duncan',NULL,NULL,NULL,NULL,NULL,'550 RAWLINS AVE',0,'AKRON','OH','44319','4343','CY','39153','2002-07-08','M','',':RET:2106-3','N','021','HLT','3177573','52664OH152000901','2014-04-01','2014-03-06 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-06 21:02:14'),(259,215,'N','19','021','EC','A',NULL,NULL,'','0000197129','0000516880','','IL','1','Mason','Dylan','','','','34','295962491','1947 providence ave',0,'Springfield','OH','45503',NULL,'CY','39023','1994-01-26','M','',':RET:2106-3','N','021','HLT','14504','92036OH004000501','2014-01-01','2013-12-05 08:24:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2013-12-25 17:21:48'),(19510,15550,'Y','18','021','EC','A','','','AC','0000795961','0000795961','TX00002279181','IL','1','Bates','Bobby','','','','34','632038333','285 LAKE FALLS RD',0,'HUNTSVILLE','TX','77320','2201','CY','48471','1977-01-31','M','U',':RET:2106-3','N','021','DEN','3132598','33348TX002000101','2014-03-01','2014-01-22 13:58:54','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-23 03:02:14'),(25833,20479,'N','19','021','EC','A',NULL,NULL,'','0000008467','0000440864','','IL','1','Love','Kaleb','','','','34','282063729','930 SARA CT',0,'PATASKALA','OH','43062','7060','CY','39089','2001-06-14','M','',':RET:2106-3','N','021','DEN','3219242','99734OH005000301','2014-04-01','2014-02-26 17:23:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:30'),(27145,21491,'Y','18','024','14','A','','','TE','0000590842','0000590842','','IL','1','Musarra','Dominic','Anthony','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-09-20','M','',NULL,NULL,NULL,'','3647970','','2014-03-03','2014-03-03 13:12:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:49'),(28002,22157,'Y','18','021','EC','A','','','AC','0000501676','0000501676','OH00002777056','IL','1','Lewis','Jamika','','','','34','284843029','1078 East 141st 3rd floor',0,'Cleveland','OH','44110',NULL,'CY','39035','1985-12-15','F','U',':RET:2054-5','N','021','DEN','3554181','99734OH005000401','2014-04-01','2014-03-05 20:06:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:09'),(1937,1577,'N','01','021','EC','A',NULL,NULL,'','0000311498','0000183187','','IL','1','Baker','Alicia','A','','','34','589427877','PO Box 933',0,'Snyder','TX','79550',NULL,'CY','48415','1985-12-22','F','',':RET:2106-3','T','021','DEN','1014929','33348TX002000201','2014-01-01','2013-11-20 12:13:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:00:33'),(17474,13970,'Y','18','021','EC','A','','','AC','0000326840','0000326840','TX00001800653','IL','1','SMITH','JUDY','','','','34','456945416','18458 N STATE HIGHWAY 19',0,'MONTALBA','TX','75853','2386','CY','48001','1952-02-01','F','U',':RET:2106-3','N','021','DEN','1461096','33348TX002000201','2014-02-01','2014-01-11 18:44:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 03:01:08'),(16894,13519,'Y','18','021','EC','A','','','AC','0000721359','0000721359','OH00002439427','IL','1','cottrell','julie','','','','34','269649940','525 LORELLA AVE',0,'DAYTON','OH','45404',NULL,'CY','39113','1963-11-16','F','U',NULL,'T','021','DEN','1669103','99734OH005000401','2014-02-01','2014-01-08 18:19:58','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:19:29'),(14956,11954,'Y','18','021','EC','A','','','AC','0001074293','0001074293','TX00000355320','IL','1','Jones','John','Tyrone','','','34','437476773','2300 Briarwest Blvd',0,'Houston','TX','77077',NULL,'CY','48201','1971-11-04','M','U',':RET:2054-5','N','021','DEN','1711971','33348TX002000201','2014-02-01','2013-12-30 07:41:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:00:22'),(16029,12832,'Y','18','021','EC','A','','','AC','0002385932','0002385932','LA00001829339','IL','1','lewis-green','xaicha','','','','34','338880545','920 twin bridges rd',0,'alexandria','LA','71303',NULL,'CY','22079','1993-01-30','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','2232343','18575LA002000201','2014-02-01','2014-01-03 11:26:29','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-04 02:02:25'),(5919,4687,'Y','18','021','EC','A','','','AC','0000753858','0000753858','TX00000682511','IL','1','Feagins','Elizabeth','','','','34','076527747','1614 RENO RUN',0,'LEWISVILLE','TX','75077','7522','CY','48121','1964-10-31','F','U',':RET:2106-3','N','021','DEN','2292180','33348TX002000101','2014-01-01','2013-12-24 00:25:13','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:13'),(5662,4492,'Y','18','021','EC','A','','','AC','0000459120','0000459120','OH00000581674','IL','1','Marquart','Stephen','','','','34','276787971','4100 ALDAWOOD HILLS DR',0,'AKRON','OH','44319','4041','CY','39153','1981-08-24','M','U',':RET:2106-3','N','021','HLT','520911','52664OH151001301','2014-01-01','2013-11-25 23:27:11','0.00',NULL,NULL,'263.82','263.82','R-OH012','OH0','263.82',NULL,0,'2013-12-25 23:31:48'),(4322,3433,'Y','18','021','EC','A','','','AC','0001242961','0001242961','OH00000338001','IL','1','Whitehead','Helen','','','','34','302483679','2348 GLENRIDGE RD',0,'EUCLID','OH','44117','2430','CY','39035','1951-04-30','F','M',NULL,'N','021','HLT','1880102','92036OH003000801','2014-01-01','2013-12-17 08:44:18','0.00',NULL,NULL,'701.46','701.46','R-OH011','OH0','701.46',NULL,0,'2013-12-25 21:52:47'),(25093,19902,'Y','18','024','14','A','','','TE','0000057312','0000057312','','IL','1','Stevens','Opal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-11-17','F','',NULL,NULL,NULL,'','5586','','2014-02-28','2014-02-21 12:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:06'),(25887,20526,'Y','18','021','EC','A','','','AC','0001009246','0001009246','TX00001889668','IL','1','Ayala','Jose','','','','34','450574351','20834 Lavanderwood Dr',0,'KATY','TX','77449',NULL,'CY','48201','1961-08-14','M','M',NULL,'N','021','DEN','2937404','33348TX002000201','2014-04-01','2014-02-26 10:52:07','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-26 21:01:01'),(27630,21855,'Y','18','021','EC','A','','','AC','0000785862','0000785862','OH00003580986','IL','1','Ferguson','Beth','Teschan','','','34','297702421','957 WINTON AVE',0,'AKRON','OH','44320','2847','CY','39153','1974-05-03','F','U',':RET:2054-5','N','021','DEN','3462488','99734OH005000401','2014-04-01','2014-03-04 23:45:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:10'),(91,80,'Y','18','021','EC','A','','','AC','0000017686','0000017686','TX00001127143','IL','1','PALOMARES','DENNIS','','','','34','264658243','608 CADUCEUS LN',0,'HURST','TX','76053','5719','CY','48439','1959-05-26','M','U',NULL,'N','021','DEN','493354','33348TX002000201','2014-01-01','2013-12-04 20:27:31','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:17:26'),(14472,11547,'Y','18','021','EC','A','','','AC','0001029136','0001029136','TX00000185484','IL','1','Urquieta','Enrique','','','','34','456731169','3144 LEOPARD ST',0,'BROWNSVILLE','TX','78521','4541','CY','48061','1979-04-20','M','M',NULL,'N','021','DEN','1623484','33348TX002000201','2014-02-01','2013-12-26 19:20:46','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2013-12-28 03:33:03'),(9229,7323,'Y','18','021','EC','A','','','AC','0000030529','0000030529','OH00000701247','IL','1','Poole','Charles','','','','34','286727393','806 HAMBURG ST',0,'RIPLEY','OH','45167','1343','CY','39015','1967-12-14','M','M',':RET:2106-3','N','021','HLT','2456739','92036OH003000605','2014-01-01','2013-12-18 14:55:43','401.00',NULL,NULL,'640.47','239.47','R-OH005','OH0','336.26',NULL,0,'2013-12-26 04:10:26'),(552,453,'Y','18','021','EC','A','','','AC','0001234073','0001234073','TX00000842193','IL','1','Halcomb','Donald','M','','','34','463158396','7525 DAVID DR',0,'N RICHLAND HILLS','TX','76180','6349','CY','48439','1961-12-22','M','M',':RET:2106-3','N','021','DEN','664711','33348TX002000101','2014-01-01','2013-12-04 14:47:37','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 17:50:04'),(3676,2942,'Y','18','021','EC','A','','','AC','0000765952','0000765952','OH00000484793','IL','1','Asher','Diana','','','','34','272584992','6194 CAMDEN COLLEGE CORNER RD',0,'COLLEGE CORNER','OH','45003','9279','CY','39135','1957-11-04','F','U',':RET:2106-3','N','021','DEN','272209','99734OH005000401','2014-01-01','2013-12-13 08:41:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:31:19'),(8127,6429,'Y','18','021','EC','A','','','AC','0000398580','0000398580','OH00001187405','IL','1','MCKINNEY','LARRY','H','','','34','299482279','2687 ROUTE 50',0,'BATAVIA','OH','45103',NULL,'CY','39025','1950-09-13','M','U',NULL,'N','021','DEN','584999','99734OH005000401','2014-01-01','2013-11-22 09:48:03','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:15:26'),(7963,6303,'Y','18','024','14','A','','','TE','0000240163','0000240163','','IL','1','Boone','Mary','Melissa',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-05-03','F','',NULL,NULL,NULL,'','1237109','','2013-12-20','2013-12-20 12:55:20',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 03:07:30'),(3247,2617,'Y','18','021','EC','A','','','AC','0000089793','0000089793','OH00000799755','IL','1','koshin','awes','','','','34','611847422','3355 Thornapple Cirrcle N',0,'Columbus','OH','43231',NULL,'CY','39049','1967-02-02','M','M',':RET:2054-5','N','021','DEN','250360','99734OH005000401','2014-01-01','2013-11-27 19:43:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:46:31'),(1197,986,'Y','18','021','EC','A','','','AC','0000951766','0000951766','OH00001304592','IL','1','Bier','Caroline','Sue','','','34','265631293','54221 STERN RD',0,'POWHATAN POINT','OH','43942','9758','CY','39013','1962-02-14','F','U',':RET:2106-3','N','021','DEN','1110289','99734OH005000301','2014-01-01','2013-12-03 15:33:32','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:19:46'),(1850,1515,'Y','18','021','EC','A','','','AC','0000209639','0000209639','OH00001058059','IL','1','FOX','CECILIA','DIANE','','','34','278547194','552 ORLANDO AVE',0,'AKRON','OH','44320','1342','CY','39153','1952-07-23','F','U',':RET:2106-3','N','021','HLT','2327116','52664OH151001304','2014-01-01','2013-12-24 17:48:34','395.00',NULL,NULL,'626.65','231.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 18:57:52'),(6818,5406,'Y','18','021','EC','A','','','AC','0000561633','0000561633','OH00001183929','IL','1','Szasz','Eva','','','','34','270503864','7913 Freedom Road',0,'Windham','OH','44288',NULL,'CY','39133','1954-11-05','F','U',NULL,'N','021','HLT','723274','52664OH151001305','2014-01-01','2013-11-14 10:18:50','437.00',NULL,NULL,'580.49','143.49','R-OH012','OH0','580.49',NULL,0,'2013-12-26 01:30:27'),(28301,22392,'Y','18','021','EC','A','','','AC','0000117784','0000117784','OH00003367797','IL','1','KALTENBACH','KAREN','','','','34','273661164','2986 TELBER CT',0,'STOW','OH','44224','2156','CY','39153','1958-04-16','F','M',':RET:2106-3','N','021','HLT','3321280','52664OH152000901','2014-04-01','2014-03-07 11:15:11','0.00',NULL,NULL,'364.25','364.25','R-OH012','OH0','364.25','CIC',0,'2014-03-07 21:00:32'),(1600,1338,'Y','18','021','EC','A','','','AC','0000786069','0000786069','TX00000895558','IL','1','CASTILLO','RICKY','','','','34','450533391','1213 COLT',0,'LA FERIA','TX','78559',NULL,'CY','48061','1962-09-14','M','M',':RET:2106-3','N','021','DEN','2578709','33348TX002000201','2014-01-01','2013-12-24 12:39:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:52:01'),(20019,15966,'Y','18','021','EC','A','','','AC','0001190381','0001190381','TX00001423298','IL','1','MEDRANO','OSCAR','O','','','34','450499001','506 S WALNUT ST',0,'PECOS','TX','79772','4128','CY','48389','1957-02-01','M','M',NULL,'N','021','DEN','1937257','33348TX002000201','2014-03-01','2014-01-26 15:54:46','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-26 19:00:13'),(4872,3863,'Y','18','021','EC','A','','','AC','0000446849','0000446849','TX00000508986','IL','1','Duran','Armando','','','','34','440929409','950 N. Inspiration Rd.',0,'Mission','TX','78572',NULL,'CY','48215','1982-06-08','M','U',NULL,'N','021','DEN','942429','33348TX002000101','2014-01-01','2013-10-09 18:59:15','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-25 22:31:02'),(19191,15290,'Y','18','021','EC','A','','','AC','0001196728','0001196728','TX00002058631','IL','1','Segura','Griselda','','','','34','454456064','23054 HILLTOP PEAKS',0,'ELMENDORF','TX','78112','6157','CY','48029','1976-10-10','F','U',NULL,'N','021','DEN','3091707','33348TX002000101','2014-03-01','2014-01-20 13:18:23','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-21 08:46:13'),(15555,12448,'Y','18','021','EC','A','','','AC','0001314122','0001314122','LA00000091939','IL','1','Paul','Darren','','','','34','439234359','3714 Laplace Street',0,'Chalmette','LA','70043',NULL,'CY','22087','1970-08-01','M','M',':RET:2054-5','N','021','DEN','2580390','18575LA002000201','2014-02-01','2013-12-31 17:09:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:31:26'),(14101,11237,'Y','18','021','EC','A','','','AC','0000577328','0000577328','OH00000481736','IL','1','Elliott','Latricia','','','','34','298709485','826 S WITTENBERG AVE',0,'SPRINGFIELD','OH','45506','2108','CY','39023','1976-09-10','F','U',':RET:2054-5','N','021','DEN','2303348','99734OH005000401','2014-02-01','2013-12-26 12:23:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-27 02:01:34'),(5712,4535,'Y','18','021','EC','A','','','AC','0000119071','0000119071','OH00000243731','31','1','Garrett','Allen','','','','34','269769563','POB 145',0,'North Lawrence','OH','44666',NULL,'CY','39151','1973-05-17','M','U',NULL,'N','021','HLT','2580122','52664OH151001305','2014-01-01','2013-12-23 23:16:35','171.00',NULL,NULL,'285.00','114.00','R-OH015','OH0','285.00',NULL,0,'2013-12-25 23:45:11'),(6764,5366,'Y','18','021','EC','A','','','AC','0000994365','0000994365','LA00000842094','IL','1','Lege','Jonathan','','','','34','436615519','806 HOUMA BLVD',0,'METAIRIE','LA','70001','4733','CY','22051','1985-07-18','M','U',':RET:2106-3','N','021','DEN','606505','18575LA002000201','2014-01-01','2013-11-25 15:12:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:16:25'),(13742,10969,'Y','18','021','EC','A','','','AC','0000835459','0000835459','OH00001050293','IL','1','Wolf','Charlene','','','','34','291466497','379 LOUISE AVE',0,'KENT','OH','44240','3260','CY','39133','1950-03-05','F','M',':RET:2106-3','N','021','HLT','2083695','52664OH151001305','2014-01-01','2013-12-23 19:28:46','458.00',NULL,NULL,'658.32','200.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 13:09:42'),(13355,10666,'Y','18','021','EC','A','','','AC','0000402456','0000402456','OH00001041961','IL','1','Knueven','Brian','','','','34','300660118','1634 BRUCE AVE',0,'CINCINNATI','OH','45223','2002','CY','39061','1966-04-02','M','U',':RET:2106-3','N','021','DEN','2093635','99734OH005000301','2014-01-01','2013-12-22 18:50:45','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:59:18'),(24009,19093,'Y','18','021','EC','A','','','AC','0000214711','0000214711','OH00001714659','IL','1','Jacques','Michael','','','','34','294905189','2304 ohio ave',0,'Cincinnati','OH','45219',NULL,'CY','39061','1984-09-20','M','U',':RET:2106-3','T','021','DEN','3572374','99734OH005000401','2014-03-01','2014-02-15 11:27:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:38'),(24233,19245,'Y','18','021','EC','A','','','AC','0000468854','0000468854','MS00002130312','IL','1','hathcox','stacy','','','','34','428115613','10 THREE OAKS RD',0,'CARRIERE','MS','39426','9114','CY','28109','1971-08-01','F','M',':RET:2106-3','N','021','DEN','2743198','46300MS002000201','2014-03-01','2014-02-15 20:37:40','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-16 19:00:35'),(1595,1333,'Y','18','021','EC','A','','','AC','0000235632','0000235632','TX00000341289','31','1','Couey','Deborah','Diann','','','34','458943442','PO Box 31',0,'Van','TX','75790',NULL,'CY','48423','1950-12-03','F','M',':RET:2106-3','N','021','DEN','2220595','33348TX002000201','2014-01-01','2013-12-24 12:19:04','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 18:51:53'),(5043,3993,'Y','18','021','EC','A','','','AC','0000932370','0000932370','TX00001018251','31','1','Butler','Marvin','','','','34','435849197','PO Box 311405',0,'Houston','TX','77231',NULL,'CY','48201','1954-03-03','M','U',':RET:2054-5','N','021','DEN','1098165','33348TX002000101','2014-01-01','2013-12-07 17:10:16','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:48:04'),(4553,3607,'Y','18','021','EC','A','','','AC','0000772618','0000772618','OH00000962040','IL','1','Alabakovski','Nada','','','','34','269606709','405 CONCORD ST NW',0,'MASSILLON','OH','44646','2013','CY','39151','1956-05-31','F','M',NULL,'N','021','HLT','395068','52664OH152000901','2014-01-01','2013-12-12 10:13:05','866.00',NULL,NULL,'880.24','14.24','R-OH015','OH0','398.06',NULL,0,'2013-12-25 22:04:35'),(13267,10588,'N','01','021','EC','A',NULL,NULL,'','0000865430','0000163788','','IL','1','Aycock','Lou','','','','34','453984262','1818 MESA OAKS CIR',0,'HARKER HEIGHTS','TX','76548','8765','CY','48027','1953-05-24','F','',':RET:2106-3','N','021','DEN','2151941','33348TX002000201','2014-01-01','2013-12-23 12:16:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:56:47'),(7944,6284,'Y','18','024','14','A','','','TE','0001270233','0001270233','','IL','1','Warren','Donald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-01','M','',NULL,NULL,NULL,'','1944137','','2013-12-20','2013-12-20 15:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 03:06:58'),(5965,4722,'Y','18','021','EC','A','','','AC','0000008421','0000008421','OH00001061919','IL','1','Jackson','Delores','','','','34','282486175','513 FEDERMAN ST',0,'TOLEDO','OH','43609','1938','CY','39095','1949-09-26','F','U',':RET:2054-5','N','021','HLT','1656597','92036OH004002601','2014-01-01','2013-12-23 22:11:19','387.00',NULL,NULL,'470.37','83.37','R-OH001','OH0','470.37',NULL,0,'2013-12-25 23:51:26'),(20974,16760,'Y','18','024','14','A','','','TE','0000164892','0000164892','','IL','1','Conville','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-06-21','M','',NULL,NULL,NULL,'','2901893','','2014-01-31','2014-01-31 18:53:41',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-01 19:00:17'),(21051,16820,'Y','18','021','EC','A','','','AC','0000222429','0000222429','OH00001512107','IL','1','Hilton','Scarlett','','','','34','512885208','10 krebs Drive',0,'Sabina','OH','45169',NULL,'CY','39027','1972-03-13','F','M',':RET:2106-3','N','021','HLT','3641948','92036OH006000601','2014-03-01','2014-02-01 18:58:15','434.00',NULL,NULL,'595.87','161.87','R-OH005','OH0','221.66',NULL,0,'2014-02-02 19:00:06'),(23739,18901,'N','01','021','EC','A',NULL,NULL,'','0000060312','0000553962','','IL','1','Nixon','Marcia','D','','','34','285885761','4520 Warrensville Center Rd',0,'North Randall','OH','44128',NULL,'CY','39035','1982-04-23','F','',':RET:2054-5','N','021','DEN','3302839','99734OH005000301','2014-03-01','2014-02-13 22:27:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:03'),(26179,20760,'Y','18','021','EC','A','','','AC','0000057389','0000057389','OH00003394239','IL','1','Borror','Melissa','','','','34','286803674','8850 BEACON HILL DR',0,'CHAGRIN FALLS','OH','44023','5852','CY','39055','1982-08-09','F','U',NULL,'N','021','DEN','3210793','99734OH005000301','2014-04-01','2014-02-26 19:51:32','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:39'),(28172,22295,'Y','18','021','EC','A','','','AC','0000906653','0000906653','OH00003259122','IL','1','Harshman','Suzanne','','','','34','284505533','7241 DORR ST',0,'TOLEDO','OH','43615','4109','CY','39095','1955-05-14','F','U',NULL,'N','021','HLT','3716946','92036OH002002601','2014-04-01','2014-03-06 12:38:50','301.00',NULL,NULL,'573.76','272.76','R-OH001','OH0','573.76',NULL,0,'2014-03-06 21:02:50'),(225,189,'Y','18','021','EC','A','','','AC','0000647174','0000647174','LA00000430113','IL','1','LeBoeuf','Danielle','','','','34','434495418','143 KAJUN ST',0,'GRAY','LA','70359','4909','CY','22057','1980-05-01','F','U',':RET:2106-3','T','021','DEN','1207102','18575LA002000201','2014-01-01','2013-12-05 14:36:07','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 17:20:53'),(19478,15526,'Y','18','024','14','A','','','TE','0000953797','0000953797','','IL','1','GUNERATNE','ARUNA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-10-29','M','',NULL,NULL,NULL,'','1928466','','2014-01-22','2014-01-22 17:08:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 03:02:02'),(9327,7394,'Y','18','021','EC','A','','','AC','0002199978','0002199978','LA00000819640','IL','1','Jacobs','Trenell','','','','34','439591904','904 FAIRWAY DR',0,'LA PLACE','LA','70068','2852','CY','22095','1986-02-19','F','U',':RET:2054-5','N','021','DEN','1965508','18575LA002000101','2014-01-01','2013-12-21 17:37:30','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:39'),(6652,5276,'Y','18','021','EC','A','','','AC','0000120038','0000120038','OH00000727412','IL','1','Sharpe','Keven','James','','','34','288867509','607 US HIGHWAY 224',0,'SULLIVAN','OH','44880','9718','CY','39005','1972-09-30','M','U',':RET:2106-3','N','021','HLT','629207','52664OH151001501','2014-01-01','2013-11-12 13:30:28','0.00',NULL,NULL,'348.24','348.24','R-OH012','OH0','348.24',NULL,0,'2013-12-26 01:00:35'),(6141,4870,'Y','18','021','EC','A','','','AC','0001235136','0001235136','OH00001219811','IL','1','McGinnis','Devin','','','','34','366063150','1568 BENDING WILLOW LN',0,'HILLIARD','OH','43026','8714','CY','39049','1983-01-19','M','M',':RET:2106-3','N','021','DEN','1043539','99734OH005000301','2014-01-01','2013-11-20 22:38:24','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:16:16'),(990,810,'Y','18','024','14','A','','','TE','0001100562','0001100562','','IL','1','debord','dawn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-07','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-11 11:21:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:10:36'),(20984,16770,'Y','18','021','EC','A','','','AC','0001607991','0001607991','LA00001784700','IL','1','Brown','Chris','','','','34','436154429','231 SAINT GEORGE AVE',0,'JEFFERSON','LA','70121','3218','CY','22051','1959-02-27','M','U',':RET:2106-3','T','021','DEN','3761493','18575LA002000201','2014-03-01','2014-02-01 15:43:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-01 19:00:21'),(26996,21381,'Y','18','024','14','A','','','TE','0000338847','0000338847','','IL','1','Grigsby','Scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-29','M','',NULL,NULL,NULL,'','47228','','2014-03-31','2014-03-02 15:43:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 01:30:00'),(27250,21577,'Y','18','021','EC','A','','','AC','0001071867','0001071867','TX00003646142','IL','1','Maldonado','Angel','','','','34','461990008','706 South Bend Street',0,'Rockport','TX','78382',NULL,'CY','48007','1950-05-05','M','M',':RET:2106-3','N','021','DEN','3149611','33348TX002000101','2014-04-01','2014-03-03 16:08:14','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-03-03 21:31:52'),(28436,22500,'Y','18','021','EC','A','','','AC','0000278373','0000278373','OH00002816793','IL','1','IMES','JULIANNE','','','','34','272608175','1010 N MCCLURE RD',0,'LIMA','OH','45801','8702','CY','39003','1956-02-02','F','M',':RET:2106-3','T','021','HLT','3244672','92036OH003001505','2014-04-01','2014-03-06 19:45:51','1091.00',NULL,NULL,'1271.72','180.72','R-OH002','OH0','673.45',NULL,0,'2014-03-07 21:31:10'),(21115,16871,'Y','18','024','14','A','','','TE','0000497145','0000497145','','IL','1','King','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-12-22','M','',NULL,NULL,NULL,'','2825314','','2014-02-02','2014-02-02 18:51:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:00:09'),(18233,14553,'Y','18','021','EC','A','','','AC','0000832874','0000832874','TX00001712701','IL','1','Jenevein','Catherine','','','','34','433512676','513 W Odell St',0,'Austin','TX','78752',NULL,'CY','48453','1968-12-12','F','U',':RET:2106-3','N','021','DEN','1394593','33348TX002000201','2014-02-01','2014-01-14 22:04:29','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-16 08:44:20'),(16991,13600,'Y','18','021','EC','A','','','AC','0000404258','0000404258','TX00001836683','IL','1','stuard','chanda','','','','34','453810328','2534 PAINT ROCK RD',0,'SAN ANGELO','TX','76905','8214','CY','48451','1986-12-02','F','U',':RET:2106-3','N','021','DEN','1939752','33348TX002000101','2014-02-01','2014-01-09 15:09:53','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2014-01-13 02:20:24'),(4388,3489,'Y','18','021','EC','A','','','AC','0000078743','0000078743','OH00000207730','IL','1','Dawson','John','','','','34','249112161','4000 WOODFORD RD',0,'CINCINNATI','OH','45213','2376','CY','39061','1968-06-18','M','M',NULL,'N','021','DEN','242434','99734OH005000401','2014-01-01','2013-12-12 11:12:41','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:00:48'),(15961,12775,'N','01','021','EC','A',NULL,NULL,'','0000103899','0001252127','','IL','1','Renzenbrink','Kimberly','A','','','34','313761661','1727 RIVERWOOD TRL',0,'KINGS MILLS','OH','45034','9772','CY','39165','1971-05-23','F','',NULL,'N','021','DEN','1474421','99734OH005000301','2014-02-01','2014-01-03 13:39:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:20'),(14802,11821,'Y','18','021','EC','A','','','AC','0001169447','0001169447','OH00000387147','IL','1','Hohman','Ryan','','','','34','299885646','1400 RANCHLAND DR',0,'MAYFIELD HEIGHTS','OH','44124','1500','CY','39035','1988-02-09','M','U',':RET:2106-3','N','021','DEN','2247904','99734OH005000401','2014-01-01','2013-12-23 19:53:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:47'),(24705,19614,'Y','18','021','EC','A','','','AC','0000584317','0000584317','OH00002870921','IL','1','promen','stephen','','','','34','268569160','5415 dunmere ln',0,'dublin','OH','43017',NULL,'CY','39049','1954-09-14','M','U',':RET:2106-3','T','021','DEN','3151518','99734OH005000401','2014-04-01','2014-02-19 00:03:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:34:43'),(26582,21076,'Y','18','021','EC','A','','','AC','0000483536','0000483536','OH00002962650','IL','1','MATTSCHECK','ROGER','','','','34','279547663','2578 MAPLE TREE CT',0,'READING','OH','45236','1165','CY','39061','1953-02-18','M','M',NULL,'N','021','DEN','3096256','99734OH005000401','2014-04-01','2014-02-28 14:57:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:31'),(26933,21345,'Y','18','021','EC','A','','','AC','0000976796','0000976796','OH00002940005','IL','1','Shoffner','Vanessa','','','','34','280840114','617 COOPER AVE',0,'BELLEFONTAINE','OH','43311','2607','CY','39091','1985-10-16','F','U',':RET:2106-3','N','021','DEN','3839906','99734OH005000301','2014-04-01','2014-03-01 21:15:47','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-03 01:00:20'),(20036,15979,'Y','18','021','EC','A','','','AC','0000730002','0000730002','OH00002003873','IL','1','Mason','Corey','','','','34','297702292','1043 BRAXTON BLVD',0,'LONDON','OH','43140','8424','CY','39097','1975-01-04','M','M',NULL,'N','021','DEN','3104934','99734OH005000301','2014-03-01','2014-01-26 17:57:32','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-26 19:00:23'),(9653,7649,'N','01','021','EC','A',NULL,NULL,'','0001028069','0000961862','','IL','1','perez','carolyn','','','','34','299620853','16339 State Rt 65',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1957-01-21','F','',':RET:2106-3','N','021','HLT','2380995','92036OH004001501','2014-01-01','2013-12-21 15:20:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','412.86',NULL,0,'2013-12-26 04:38:49'),(1969,1608,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001063253','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','979570','33348TX002000101','2014-01-01','2013-11-19 23:00:16','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:25'),(3511,2821,'Y','18','021','EC','A','','','AC','0001098925','0001098925','MS00001153561','IL','1','Sutton','James','Blake','','','34','425634030','350 NICKLAUS CV',0,'HERNANDO','MS','38632','6908','CY','28033','1984-02-01','M','M',':RET:2106-3','N','021','DEN','1525295','46300MS002000201','2014-01-01','2013-12-21 19:53:15','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85',NULL,0,'2013-12-25 21:21:01'),(20010,15959,'Y','18','021','EC','A','','','AC','0001368886','0001368886','LA00001436614','IL','1','Van Slyke','Daniel','','','','34','481087943','53385 HIGHWAY 436',0,'ANGIE','LA','70426','3335','CY','22117','1986-01-25','M','U',NULL,'T','021','DEN','3071514','18575LA002000101','2014-03-01','2014-01-26 18:02:19','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-26 19:00:09'),(19217,15311,'Y','18','021','EC','A','','','AC','0000850525','0000850525','OH00002119086','IL','1','Smith','Michael','','','','34','296547311','2313 STARBUCK RD',0,'WILMINGTON','OH','45177','9682','CY','39027','1954-02-10','M','M',':RET:2106-3','N','021','DEN','2754382','99734OH005000401','2014-03-01','2014-01-20 12:48:22','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-21 08:46:24'),(18940,15091,'N','19','021','EC','A',NULL,NULL,'','0001060937','0001018259','','IL','1','post','chloe',NULL,NULL,NULL,NULL,NULL,'4823 PARKSIDE DR',0,'SOUTH LEBANON','OH','45065','1383','CY','39165','1994-12-09','F','',NULL,'N','021','DEN','2692844','99734OH005000401','2014-03-01','2014-01-17 12:19:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:05:43'),(6368,5049,'Y','18','021','EC','A','','','AC','0000669160','0000669160','OH00001254065','IL','1','Holland','Peter','','','','34','276822262','4809 SCARBOROUGH CT',0,'MIDDLETOWN','OH','45042','4908','CY','39017','1983-07-30','M','U',':RET:2106-3','N','021','DEN','846539','99734OH005000301','2014-01-01','2013-12-10 22:47:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:47:33'),(13030,10386,'Y','18','021','EC','A','','','AC','0000381136','0000381136','OH00000847060','IL','1','Hawkins','Kristal','','','','34','269722171','5282 E 104TH ST',0,'GARFIELD HTS','OH','44125','2408','CY','39035','1972-02-09','F','U',':RET:2054-5','N','021','DEN','2539555','99734OH005000401','2014-01-01','2013-12-22 23:06:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:50:19'),(25121,19927,'N','19','021','EC','A',NULL,NULL,'','0001136698','0000691882','','IL','1','Spofford','Nicholas','A','','','34','276067634','1652 SHERIDAN DR',0,'LANCASTER','OH','43130','1366','CY','39045','2001-02-08','M','',':RET:2106-3','N','021','DEN','3468365','99734OH005000301','2014-03-01','2014-02-21 12:51:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-21 21:30:21'),(25221,20005,'Y','18','021','EC','A','','','AC','0000048385','0000048385','MS00002503766','IL','1','Tate','Lincoln','','','','34','426614224','1062 BULLRUN DR',0,'BYRAM','MS','39272','4401','CY','28049','1979-09-05','M','U',':RET:2054-5','N','021','DEN','2974442','46300MS002000201','2014-04-01','2014-02-20 20:49:00','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-21 22:00:56'),(27204,21539,'N','01','021','EC','A',NULL,NULL,'','0000076492','0000329589','','IL','1','Palm','Stacy','','','','34','180664134','415 N AVENUE G',0,'SHINER','TX','77984','5703','CY','48285','1974-12-11','F','',':RET:2106-3','N','021','DEN','3680098','33348TX002000201','2014-04-01','2014-03-03 17:33:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:24'),(28171,22294,'Y','18','021','EC','A','','','AC','0000670313','0000670313','OH00002779447','IL','1','Pierson','Diana','','','','34','290520028','3942 CANADA SOUTHERN AVE',0,'TOLEDO','OH','43612','1367','CY','39095','1950-05-23','F','U',NULL,'N','021','HLT','2834708','92036OH002002601','2014-04-01','2014-03-06 11:59:14','256.00',NULL,NULL,'664.74','408.74','R-OH001','OH0','664.74',NULL,0,'2014-03-06 21:02:49'),(29069,23006,'Y','18','021','EC','A','','','AC','0000385964','0000385964','OH00002790867','IL','1','Kerr','Caitlin','','','','34','295921137','4134 N Lockwood Ave',0,'Toledo','OH','43612',NULL,'CY','39095','1990-10-13','F','U',':RET:2106-3','N','021','HLT','2741179','92036OH004002601','2014-04-01','2014-03-10 13:30:31','98.00',NULL,NULL,'156.79','58.79','R-OH001','OH0','156.79',NULL,0,'2014-03-10 21:01:56'),(5758,4573,'Y','18','021','EC','A','','','AC','0000482191','0000482191','OH00001139092','IL','1','Hoover-Miller','Elizabeth','Ann','','','34','301523212','834Green Ave. SW',0,'Massillon','OH','44647',NULL,'CY','39151','1957-05-24','F','M',':RET:2106-3','N','021','DEN','2340008','99734OH005000401','2014-01-01','2013-12-23 21:40:36','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 23:46:26'),(8892,7050,'Y','18','021','EC','A','','','AC','0000881060','0000881060','TX00001246888','IL','1','Lambert','Angel','','','','34','419194031','1104 EASTSIDE DR',0,'KILLEEN','TX','76543','4220','CY','48027','1981-02-08','F','U',':RET:2106-3','N','021','DEN','2098424','33348TX002000201','2014-01-01','2013-12-18 17:23:37','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 04:02:02'),(21536,17204,'Y','18','021','EC','A','','','AC','0000848388','0000848388','OH00001373192','IL','1','Mansfield','Edward','','','','34','040709505','875 S. Roosevelt Ave',0,'Columbus','OH','43209',NULL,'CY','39049','1963-04-22','M','R',':RET:2054-5','N','021','DEN','3529208','99734OH005000401','2014-03-01','2014-02-04 18:57:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:08'),(20723,16559,'Y','18','021','EC','A','','','AC','0000752115','0000752115','OH00002441268','IL','1','GRADY','TERRENCE','','','','34','297528728','2927 STANFIELD DR',0,'PARMA','OH','44134',NULL,'CY','39035','1952-07-19','M','M',NULL,'T','021','HLT','2626403','52664OH151001301','2014-03-01','2014-01-30 09:58:35','784.00',NULL,NULL,'1567.32','783.32','R-OH011','OH0','812.78',NULL,0,'2014-01-30 21:01:15'),(20098,16035,'Y','18','021','EC','A','','','AC','0001246678','0001246678','LA00001370855','IL','1','Ordonez','Gladys','','','','34','439992513','2004 David Drive',0,'Metaire','LA','70003',NULL,'CY','22051','1965-02-04','F','U',NULL,'N','021','DEN','2683117','18575LA002000201','2014-03-01','2014-01-27 11:46:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-27 21:00:33'),(18860,15022,'Y','18','021','EC','A','','','AC','0002138109','0002138109','LA00002008673','IL','1','Shivers','Brenda','','','','34','437925890','618 W 67TH ST',0,'SHREVEPORT','LA','71106','2924','CY','22017','1955-01-26','F','U',':RET:2054-5','N','021','DEN','2254909','18575LA002000201','2014-02-01','2014-01-15 23:53:08','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-17 03:36:20'),(16379,13106,'Y','18','021','EC','A','','','AC','0000289274','0000289274','TX00000019432','IL','1','SCOTT','JENNIFER','L','','','34','443907512','7032 SAN LUIS TRL',0,'FORT WORTH','TX','76131','2853','CY','48439','1978-04-24','F','U',':RET:2106-3','N','021','DEN','2160718','33348TX002000201','2014-02-01','2014-01-06 12:54:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:15'),(6289,4988,'Y','18','021','EC','A','','','AC','0000735012','0000735012','OH00000650021','IL','1','Abdeljalil','Ramzy','','','','34','271945507','3076 WATERFALL WAY',0,'WESTLAKE','OH','44145','6811','CY','39035','1984-03-19','M','M',':RET:2106-3','T','021','DEN','903961','99734OH005000401','2014-01-01','2013-12-11 00:03:48','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:36'),(13521,10778,'N','01','021','EC','A',NULL,NULL,'','0001179676','0001315462','','IL','1','CURRY','HERMAN','','','Jr','34','439947646','3916 ELDER ST',0,'ALEXANDRIA','LA','71302',NULL,'CY','22079','1954-05-11','M','',':RET:2054-5','T','021','DEN','1442058','18575LA002000201','2014-01-01','2013-12-23 09:13:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:03:11'),(25140,19943,'Y','18','021','EC','A','','','AC','0000678784','0000678784','TX00002419670','IL','1','EDMUNDS','JUDITH','','','','34','492706281','930 MCCONNELL RD',0,'SOMERSET','TX','78069','3706','CY','48013','1963-12-28','F','U',':RET:2106-3','N','021','DEN','3305181','33348TX002000201','2014-04-01','2014-02-21 11:26:27','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-21 22:00:09'),(25403,20153,'Y','18','021','EC','A','','','AC','0000487000','0000487000','OH00002497260','IL','1','Bunce','Tresha','','','','34','275782762','3730 State Route 44',0,'Rootstown','OH','44272',NULL,'CY','39133','1967-06-14','F','U',':RET:2106-3','N','021','HLT','2790211','52664OH151001305','2014-04-01','2014-02-25 17:33:44','214.00',NULL,NULL,'334.51','120.51','R-OH012','OH0','334.51',NULL,0,'2014-02-25 21:30:57'),(26768,21215,'Y','18','021','EC','A','','','AC','0000245040','0000245040','OH00002642466','IL','1','Giovannelli','Joyce','','','','34','193566685','137 MULBERRY LN',0,'MUNROE FALLS','OH','44262','1095','CY','39153','1961-03-05','F','R',':RET:2106-3','N','021','HLT','3170639','52664OH151001501','2014-04-01','2014-03-01 13:41:09','0.00',NULL,NULL,'545.63','545.63','R-OH012','OH0','545.63','CIC',0,'2014-03-01 19:00:12'),(138,117,'N','01','021','EC','A',NULL,NULL,'','0000103864','0001122712','','IL','1','Wiandt','Thomas','P','','','34','292605526','7927 OVERTON RD',0,'BURBANK','OH','44214','9516','CY','39169','1969-12-24','M','',':RET:2106-3','N','021','HLT','6429','52664OH152000901','2014-01-01','2013-12-04 20:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','228.19',NULL,0,'2013-12-25 17:18:36'),(623,514,'Y','18','021','EC','A','','','AC','0000515820','0000515820','OH00000955081','IL','1','Key','Michael','','','','34','253652393','348-P Firwood Dr',0,'Dayton','OH','45419',NULL,'CY','39113','1987-03-12','M','U',':RET:2106-3','N','021','DEN','1714858','99734OH005000401','2014-01-01','2013-12-16 11:44:20','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:00:54'),(9692,7677,'Y','18','021','EC','A','','','AC','0000670253','0000670253','OH00001117813','IL','1','Warren','Charles','','','','34','271689421','213.5 1ST ST',0,'FINDLAY','OH','45840','5024','CY','39063','1973-10-09','M','U',':RET:2106-3','N','021','HLT','1731172','92036OH006001501','2014-01-01','2013-12-21 11:49:49','140.00',NULL,NULL,'223.07','83.07','R-OH002','OH0','223.07',NULL,0,'2013-12-26 04:39:44'),(9574,7583,'N','19','021','EC','A',NULL,NULL,'','0001218535','0000821001','','IL','1','Hinkle','Anna','Monica','','','34','279062704','2593 MAPLE DR',0,'TWINSBURG','OH','44087','2139','CY','39153','2001-04-03','F','',':RET:2106-3','N','021','DEN','2409970','99734OH005000301','2014-01-01','2013-12-21 17:04:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:46'),(23906,19017,'Y','18','021','EC','A','','','AC','0001018284','0001018284','OH00002211455','IL','1','Dunkelberger','Rebecca','','','','34','300523909','469 COE ST',0,'TIFFIN','OH','44883','3104','CY','39147','1951-07-08','F','U',':RET:2106-3','N','021','HLT','2978968','92036OH002002701','2014-03-01','2014-02-14 16:10:27','454.00',NULL,NULL,'646.96','192.96','R-OH006','OH0','646.96',NULL,0,'2014-02-14 21:32:27'),(22822,18211,'N','01','021','EC','A',NULL,NULL,'','0000504506','0000293229','','IL','1','Gruccio','Mary Ann','','','','34','297444392','225 CANTON RD',0,'AKRON','OH','44312','1505','CY','39153','1954-02-01','F','',':RET:2106-3','N','021','HLT','2919762','52664OH151001305','2014-03-01','2014-02-10 21:01:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2014-02-11 21:02:03'),(651,536,'Y','18','021','EC','A','','','AC','0000571979','0000571979','OH00000610450','IL','1','Braine','Jessica','','','','34','006564631','3975 SUNDAY LN',0,'MAINEVILLE','OH','45039','8856','CY','39165','1968-05-23','F','U',':RET:2106-3','N','021','DEN','1587427','99734OH005000401','2014-01-01','2013-12-16 16:27:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:35'),(22090,17633,'Y','18','021','EC','A','','','AC','0000414345','0000414345','MS00001352314','IL','1','Cowans','Rachelle','S','','','34','587535244','110 Swinney Lane',0,'Lexington','MS','39095',NULL,'CY','28051','1985-12-24','F','U',':RET:2054-5','N','021','DEN','3190866','46300MS002000201','2014-03-01','2014-02-07 20:12:06','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-08 19:00:24'),(1064,871,'N','01','021','EC','A',NULL,NULL,'','0000160752','0000758235','','IL','1','DeVincentis','Carol','Ann','','','34','272465213','96 BUTTERNUT LN',0,'NORTHFIELD','OH','44067','1950','CY','39153','1955-07-10','F','',':RET:2106-3','N','021','DEN','293750','99734OH005000401','2014-01-01','2013-12-02 19:18:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:16:22'),(6434,5102,'Y','18','021','EC','A','','','AC','0000485701','0000485701','LA00001002189','IL','1','Vavasseur','Crystal','','','','34','435949638','45285 Melancon Rd',0,'Saint Amant','LA','70774',NULL,'CY','22005','1956-08-28','F','U',':RET:2106-3','T','021','DEN','15692','18575LA002000201','2014-01-01','2013-12-11 13:38:19','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:49:14'),(5525,4382,'Y','18','021','EC','A','','','AC','0000603332','0000603332','OH00000289661','IL','1','Barker','Christina','','','','34','270986497','132 Karr Road',0,'Jackson','OH','45640',NULL,'CY','39079','1994-11-21','F','M',':RET:2106-3','N','021','DEN','1144906','99734OH005000401','2014-01-01','2013-11-26 18:58:47','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','15.78',NULL,0,'2013-12-25 23:15:25'),(19016,15143,'Y','18','021','EC','A','','','AC','0001916026','0001916026','LA00001832093','IL','1','LAVENE','ROBERT','','','','34','434767031','1226 PARK DR',0,'MANDEVILLE','LA','70471','3211','CY','22103','1963-07-07','M','U',NULL,'N','021','DEN','1625272','18575LA002000201','2014-03-01','2014-01-17 15:52:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-20 08:06:22'),(1289,1066,'Y','18','021','EC','A','','','AC','0000707584','0000707584','OH00000719563','IL','1','Connett','Gregory','','','','34','295607347','4010 BEAVERCREEK CIR',0,'SHARONVILLE','OH','45241','3008','CY','39061','1964-05-15','M','U',':RET:2106-3','N','021','DEN','925979','99734OH005000301','2014-01-01','2013-11-29 13:03:19','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:30:49'),(13946,11120,'Y','18','021','EC','A','','','AC','0000976716','0000976716','OH00000961232','IL','1','Clemons','Judith',NULL,NULL,NULL,NULL,NULL,'1430 Gibson Rd',0,'Goshen','OH','45122',NULL,'CY','39025','1949-04-04','F','U',':RET:2106-3','N','021','HLT','1527858','92036OH004000601','2014-01-01','2013-12-22 22:27:47','441.00',NULL,NULL,'517.83','76.83','R-OH005','OH0','517.83',NULL,0,'2013-12-26 13:14:49'),(25831,20479,'Y','18','021','EC','A','','','AC','0000008467','0000008467','OH00003152414','IL','1','Love','Heather','','','','34','269806281','930 SARA CT',0,'PATASKALA','OH','43062','7060','CY','39089','1983-01-03','F','U',':RET:2106-3','N','021','DEN','3219242','99734OH005000301','2014-04-01','2014-02-26 17:23:16','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:00:30'),(1446,1206,'Y','18','024','14','A','','','TE','0000478438','0000478438','','IL','1','Moore','Erica','Jane',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-08','F','',NULL,NULL,NULL,'','1018266','','2013-12-24','2013-12-24 04:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:47:59'),(24467,19436,'N','01','021','EC','A',NULL,NULL,'','0000042106','0000312241','','IL','1','Carper','Dawn','','','','34','296708354','2032 GRAYBILL RD',0,'UNIONTOWN','OH','44685','8170','CY','39153','1969-01-30','F','',':RET:2106-3','N','021','HLT','3564266','52664OH151001501','2014-04-01','2014-02-18 16:41:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','386.22',NULL,0,'2014-02-18 22:01:36'),(16793,13433,'Y','18','021','EC','A','','','AC','0000909920','0000909920','TX00002008485','IL','1','Garcia','Estella','','','','34','460921648','122 S MAYBERRY ST',0,'MISSION','TX','78572','5752','CY','48215','1952-01-12','F','U',NULL,'N','021','DEN','2471992','33348TX002000201','2014-02-01','2014-01-10 18:34:00','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-13 02:18:07'),(21287,17010,'N','01','021','EC','A',NULL,NULL,'','0001729348','0002249032','','IL','1','Dacruz','Lazaro',NULL,NULL,NULL,NULL,NULL,'6512 PARK MANOR DR',0,'METAIRIE','LA','70003','3926','CY','22051','1964-12-30','M','',NULL,'T','021','DEN','3138284','18575LA002000101','2014-03-01','2014-02-03 18:29:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-04 21:00:05'),(21563,17227,'Y','18','021','EC','A','','','AC','0001248370','0001248370','OH00002422041','IL','1','Crabiel','Christie','','','','34','268867398','4980 Maple Heights Drive',0,'Medina','OH','44256',NULL,'CY','39103','1971-03-01','F','M',':RET:2106-3','N','021','HLT','3214185','52664OH151001305','2014-03-01','2014-02-04 19:15:22','400.00',NULL,NULL,'888.46','488.46','R-OH012','OH0','302.62',NULL,0,'2014-02-05 21:30:19'),(22974,18318,'Y','18','021','EC','A','','','AC','0001170876','0001170876','OH00001628518','IL','1','KAMAN','SCOTT','','','','34','269802686','12480 DEER CREEK DR',0,'NORTH ROYALTON','OH','44133',NULL,'CY','39035','1982-04-28','M','U',':RET:2106-3','N','021','DEN','2802792','99734OH005000301','2014-03-01','2014-02-11 18:28:56','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:30:04'),(23389,18638,'Y','18','021','EC','A','','','AC','0000132110','0000132110','OH00001678391','IL','1','DENNISON','MAUREEN','','','','34','295485332','2155 MAYFLOWER AVE NW',0,'MASSILLON','OH','44647',NULL,'CY','39151','1950-01-13','F','M',':RET:2106-3','N','021','DEN','3143261','99734OH005000401','2014-03-01','2014-02-13 14:26:47','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-13 22:01:04'),(23591,18792,'N','01','021','EC','A',NULL,NULL,'','0000029090','0000864862','','IL','1','Thomas','Ryan','','','','34','292908648','264 HILBISH AVE',0,'AKRON','OH','44312','1967','CY','39153','1976-09-15','M','',':RET:2106-3','T','021','HLT','3613273','52664OH152000901','2014-03-01','2014-02-13 13:36:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','232.55',NULL,0,'2014-02-13 22:03:02'),(26029,20643,'N','01','021','EC','A',NULL,NULL,'','0000672626','0001223577','','IL','1','Williams','Christopher','D','','','34','426615743','4933 FOREST HILL RD',0,'JACKSON','MS','39272','5733','CY','28049','1984-09-06','M','',':RET:2054-5','N','021','DEN','3532223','46300MS002000101','2014-03-01','2014-02-26 12:24:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-26 21:02:20'),(26727,21184,'N','01','021','EC','A',NULL,NULL,'','0000533968','0001088567','','IL','1','ware','jennifer','l','','','34','432254495','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','1974-03-11','F','',':RET:2106-3','N','021','DEN','3332360','33348TX002000101','2014-04-01','2014-02-28 09:18:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-28 21:31:47'),(28793,22792,'N','01','021','EC','A',NULL,NULL,'','0000994041','0000931186','','IL','1','JURGENSEN','WILLIAM','','','','34','451824230','2637 WESTMINSTER AVE.',0,'DALLAS','TX','75205',NULL,'CY','48113','1954-03-22','M','',NULL,'T','021','DEN','4348043','33348TX002000101','2014-04-01','2014-03-09 14:40:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-03-09 21:00:43'),(1145,943,'Y','18','024','14','A','','','TE','0001048122','0001048122','','IL','1','reeves','laurie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-20','F','',NULL,NULL,NULL,'','230709','','2013-12-03','2013-12-03 13:46:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:18:27'),(1365,1130,'Y','18','021','EC','A','','','AC','0001106270','0001106270','TX00001246195','IL','1','SANDERSON','TAMMY','','','','34','458110851','101 NE ALSBURY BLVD',0,'BURLESON','TX','76028','2501','CY','48439','1962-09-01','F','U',':RET:2106-3','N','021','DEN','1817943','33348TX002000101','2014-01-01','2013-12-24 15:27:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:45:35'),(14570,11625,'Y','18','021','EC','A','','','AC','0000946116','0000946116','OH00001393892','IL','1','Bennett - Long','Subrina','','','','34','277802912','3801 Woodmont Rd',0,'Toledo','OH','43613',NULL,'CY','39095','1967-01-27','F','U',':RET:2054-5','N','021','HLT','2329945','92036OH005002605','2014-02-01','2013-12-26 20:57:36','216.00',NULL,NULL,'292.49','76.49','R-OH001','OH0','292.49',NULL,0,'2013-12-28 03:35:30'),(1989,1628,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000406003','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','122997','33348TX002000101','2014-01-01','2013-11-19 23:05:47','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:54'),(15587,12474,'Y','18','021','EC','A','','','AC','0000364898','0000364898','OH00000154802','IL','1','Hong','Ho Soon','','','','34','289112800','829 BITTERBRUSH LN',0,'FINDLAY','OH','45840','7101','CY','39063','1957-07-30','F','M',':RET:2040-4','N','021','DEN','2203466','99734OH005000301','2014-02-01','2013-12-30 21:22:15','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,1,'2014-01-02 04:32:22'),(2269,1853,'N','19','021','EC','A',NULL,NULL,'','0000363754','0000695611','','IL','1','Dalton','Matthew','Michael','','','34','268061291','540 THACKERAY RD',0,'MAUMEE','OH','43537','2359','CY','39095','2000-08-27','M','',':RET:2106-3','N','021','DEN','163870','99734OH005000301','2014-01-01','2013-12-09 09:53:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:20'),(6111,4845,'Y','18','021','EC','A','','','AC','0000024073','0000024073','OH00000144462','IL','1','Tussing','Susan','','','','34','275788056','66 W. Tallmadge Ave.',0,'Akron','OH','44310',NULL,'CY','39153','1981-05-24','F','U',':RET:2106-3','N','021','HLT','70207','52664OH151001305','2014-01-01','2013-11-20 20:50:37','176.00',NULL,NULL,'263.82','87.82','R-OH012','OH0','263.82',NULL,0,'2013-12-26 00:15:26'),(8131,6433,'Y','18','021','EC','A','','','AC','0000335122','0000335122','OH00001015643','31','1','KEBEDE','SELESHI','','','','34','411630159','P. O. Box  13914',0,'Whitehall','OH','43213',NULL,'CY','39049','1955-03-21','M','U',':RET:2054-5','N','021','DEN','613334','99734OH005000401','2014-01-01','2013-11-22 11:45:08','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:15:31'),(3732,2983,'Y','18','021','EC','A','','','AC','0000452980','0000452980','TX00001075905','31','1','Mitchell','Marva','','','','34','465881453','PO Box 8426',0,'Marshall','TX','75671',NULL,'CY','48203','1952-07-31','F','U',':RET:2054-5','N','021','DEN','1242039','33348TX002000201','2014-01-01','2013-12-12 23:34:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:37'),(21171,16919,'Y','18','024','14','A','','','TE','0001121383','0001121383','','IL','1','Rudolph','Saundra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-06-27','F','',NULL,NULL,NULL,'','2548275','','2014-02-03','2014-02-03 14:22:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:00:38'),(24140,19184,'N','19','021','EC','A',NULL,NULL,'','0000702823','0000172461','','IL','1','Raper','McKenzie','Z','','','34','296029905','4439 Happiness Lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','1998-04-21','F','',':RET:2106-3','N','021','HLT','3217890','92036OH004000601','2014-03-01','2014-02-15 10:42:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:52'),(24575,19514,'Y','18','021','EC','A','','','AC','0000256015','0000256015','OH00002425739','IL','1','ONWUAGBA','AUSTIN','','','','34','272176442','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1967-01-02','M','M',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:07:54'),(982,804,'Y','18','021','EC','A','','','AC','0000485179','0000485179','TX00000143021','IL','1','Miller','Gilda','','','','34','450909105','50 N BELFAIR PL',0,'THE WOODLANDS','TX','77382','5300','CY','48339','1951-03-27','F','U',NULL,'N','021','DEN','140268','33348TX002000101','2014-01-01','2013-10-29 08:24:41','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:10:20'),(18756,14945,'Y','18','021','EC','A','','','AC','0000689561','0000689561','TX00002581076','IL','1','Mirelez','David','','','','34','450158425','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1963-05-22','M','M',NULL,'N','021','DEN','2748913','33348TX002000101','2014-02-01','2014-01-15 18:45:54','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:45'),(1727,1438,'Y','18','021','EC','A','','','AC','0001008949','0001008949','OH00001483496','IL','1','Morris','Misty','','','','34','275780488','922 CLEVELAND AVE',0,'HAMILTON','OH','45013','2724','CY','39017','1980-12-01','F','U',NULL,'N','021','DEN','1752669','99734OH005000301','2014-01-01','2013-12-24 10:31:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:55:18'),(2618,2128,'Y','18','021','EC','A','','','AC','0000504445','0000504445','OH00001149124','IL','1','CALKINS','MAXINE','MARIE','','','34','298785097','4709 W 158TH ST',0,'CLEVELAND','OH','44135','2607','CY','39035','1979-05-24','F','U',':RET:2106-3','N','021','DEN','400376','99734OH005000401','2014-01-01','2013-12-02 17:14:05','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:45:47'),(17457,13959,'Y','18','021','EC','A','','','AC','0000304731','0000304731','OH00002484027','IL','1','Deidrick','Joan','','','','34','273429784','1308 GREENFIELD DR',0,'WILLARD','OH','44890','9727','CY','39077','1954-01-28','F','M',':RET:2106-3','N','021','HLT','2056143','92036OH005002701','2014-02-01','2014-01-10 09:07:23','121.00',NULL,NULL,'529.21','408.21','R-OH006','OH0','529.21',NULL,0,'2014-01-13 03:00:40'),(17204,13768,'Y','18','021','EC','A','','','AC','0000983846','0000983846','OH00001565111','IL','1','DOUGLAS','ANGELA','','','','34','268666892','15404 WAPAK FISHER RD',0,'WAPAKONETA','OH','45895',NULL,'CY','39011','1971-05-29','F','M',NULL,'N','021','HLT','2616678','92036OH005001506','2014-02-01','2014-01-08 00:07:21','273.00',NULL,NULL,'291.62','18.62','R-OH002','OH0','291.62',NULL,0,'2014-01-13 02:22:26'),(6212,4923,'Y','18','021','EC','A','','','AC','0000942990','0000942990','TX00000391448','IL','1','McLain','Kathy','','','','34','461358369','6124 BANDOLERO DR',0,'EL PASO','TX','79912','1952','CY','48141','1959-06-02','F','U',NULL,'N','021','DEN','293584','33348TX002000101','2014-01-01','2013-10-16 19:58:17','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2013-12-26 00:30:55'),(4155,3311,'N','01','021','EC','A',NULL,NULL,'','0000374693','0000093835','','IL','1','Smith','Judith','A','','','34','280547714','21506 HALBURTON RD',0,'BEACHWOOD','OH','44122','3919','CY','39035','1953-06-06','F','',NULL,'N','021','DEN','2277583','99734OH005000301','2014-01-01','2013-12-17 14:50:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:52'),(21209,16948,'N','01','021','EC','A',NULL,NULL,'','0002071065','0001492081','','IL','1','LE','XUAN','','','','34','467770077','22 CHERRY BLOSSOM LN',0,'MARRERO','LA','70072','2425','CY','22051','1954-11-08','F','',':RET:2047-9','N','021','DEN','2966219','18575LA002000201','2014-03-01','2014-02-03 11:40:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-03 21:00:58'),(23088,18405,'N','19','021','EC','A',NULL,NULL,'','0000632726','0000574484','','IL','1','Stahl','Peyton','','','','34','268139874','3151 Hwy 123',0,'Blanchester','OH','45107',NULL,'CY','39015','2006-07-01','M','',NULL,'N','021','DEN','2821595','99734OH005000401','2014-03-01','2014-02-12 11:27:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:05'),(24915,19755,'Y','18','024','14','A','','','TE','0000407413','0000407413','','IL','1','Cain','Diane','m',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-14','F','',NULL,NULL,NULL,'','3032970','','2014-03-31','2014-02-20 13:42:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:10'),(25106,19914,'Y','18','024','14','A','','','TE','0000389645','0000389645','','IL','1','SMITH','DONYA','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-12-19','F','',NULL,NULL,NULL,'','3348807','','2014-03-31','2014-02-21 15:31:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-21 21:30:13'),(25814,20471,'Y','18','021','EC','A','','','AC','0000003628','0000003628','OH00002892614','IL','1','MIKLOS','TINA','','','','34','281825740','12760 CARTER RD',0,'PAINESVILLE','OH','44077','9790','CY','39085','1971-07-26','F','M',NULL,'N','021','DEN','3115883','99734OH005000301','2014-03-01','2014-02-26 14:59:00','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:00:23'),(625,516,'Y','18','024','14','A','','','TE','0000579959','0000579959','','IL','1','Freeman','Edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-23','M','',NULL,NULL,NULL,'','701992','','2013-12-16','2013-12-16 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:00:57'),(18927,15081,'Y','18','021','EC','A','','','AC','0000915667','0000915667','OH00002085898','IL','1','Snyder','Becky','','','','34','285625004','522 Kibler Road',0,'New Waterford','OH','44445',NULL,'CY','39029','1958-06-19','F','U',':RET:2106-3','T','021','DEN','2093026','99734OH005000401','2014-03-01','2014-01-17 07:00:05','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-20 08:05:36'),(16355,13089,'N','19','021','EC','A',NULL,NULL,'','0000568041','0000319682','','IL','1','BADER','EMMANUEL','','','','34','290063017','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','2001-11-05','M','',NULL,'N','021','DEN','2467785','99734OH005000301','2014-02-01','2014-01-06 14:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:36'),(16291,13042,'Y','18','021','EC','A','','','AC','0000234063','0000234063','OH00001963823','IL','1','Brugger','Ann','','','','34','290683368','902 DUBLIN AVE',0,'ENGLEWOOD','OH','45322','2807','CY','39113','1971-07-01','F','M',':RET:2106-3','T','021','DEN','2211336','99734OH005000401','2014-02-01','2014-01-06 17:13:22','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-07 04:00:50'),(1877,1533,'Y','18','024','14','A','','','TE','0000109265','0000109265','','IL','1','Forsyth','Kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-06-26','M','',NULL,NULL,NULL,'','246118','','2013-12-24','2013-12-24 17:46:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:58:27'),(9370,7429,'Y','18','021','EC','A','','','AC','0001567489','0001567489','LA00000628549','IL','1','Sanchez','Rose','','','','34','436760651','1529 SWAN CT',0,'GRETNA','LA','70056','7792','CY','22051','1950-08-06','F','U',':RET:2106-3','N','021','DEN','1727442','18575LA002000201','2014-01-01','2013-12-21 12:42:25','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:47'),(1673,1396,'N','19','021','EC','A',NULL,NULL,'','0000175106','0000560557','','IL','1','Phelps','Ava','','','','34','287110132','500 HARRISON LN',0,'ANDERSON','OH','45244','2205','CY','39025','2005-09-18','F','',':RET:2106-3','N','021','HLT','1387674','92036OH005000605','2014-01-01','2013-12-24 05:22:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 18:53:56'),(5352,4245,'Y','18','021','EC','A','','','AC','0000981607','0000981607','OH00001236949','IL','1','Hepler','Sheila','','','','34','282566417','1511 Galaxy Drive',0,'Mogadore','OH','44260',NULL,'CY','39133','1956-09-17','F','U',':RET:2106-3','N','021','HLT','2247630','52664OH152000901','2014-01-01','2013-12-19 15:07:21','398.06',NULL,NULL,'398.06','0.00','R-OH012','OH0','398.06',NULL,0,'2013-12-25 23:07:39'),(1931,1573,'Y','18','021','EC','A','','','AC','0000475527','0000475527','TX00000689733','IL','1','Taylor','Julia','','','','34','455043087','10206 FARRELL DR',0,'HOUSTON','TX','77070','4521','CY','48201','1953-07-18','F','U',':RET:2106-3','N','021','DEN','697995','33348TX002000201','2014-01-01','2013-11-20 13:52:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:00:23'),(4028,3216,'Y','18','024','14','A','','','TE','0000843321','0000843321','','IL','1','Bates','Geneva',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-10-15','F','',NULL,NULL,NULL,'','2258852','','2013-12-17','2013-12-17 09:31:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:50'),(4419,3511,'Y','18','021','EC','A','','','AC','0000595116','0000595116','OH00001149393','IL','1','GEESAMAN','LAWREEN','K','','','34','280522315','516 S PEARS AVE',0,'LIMA','OH','45805','3109','CY','39003','1952-01-02','F','M',':RET:2106-3','N','021','DEN','284671','99734OH005000401','2014-01-01','2013-12-12 16:16:17','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 22:01:35'),(9064,7193,'Y','18','021','EC','A','','','AC','0000975069','0000975069','TX00000036220','IL','1','Ilfrey','Janie','','','','34','464827020','4741 BOULDER DR',0,'MIDLAND','TX','79707','3382','CY','48329','1950-01-22','F','U',':RET:2106-3','N','021','DEN','2477751','33348TX002000101','2014-01-01','2013-12-18 15:30:43','0.00',NULL,NULL,'25.02','25.02','R-TX016','TX0','25.02',NULL,0,'2013-12-26 04:06:26'),(9594,7598,'Y','18','021','EC','A','','','AC','0000370013','0000370013','OH00000257333','IL','1','Martin','James','','','','34','289889108','3318 HEARTHSTONE RD',0,'PARMA','OH','44134','2642','CY','39035','1986-04-24','M','U',':RET:2106-3','N','021','HLT','1819934','52664OH151001305','2014-01-01','2013-12-20 21:50:51','110.00',NULL,NULL,'263.59','153.59','R-OH011','OH0','263.59',NULL,0,'2013-12-26 04:37:14'),(14789,11812,'Y','18','021','EC','A','','','AC','0000754565','0000754565','OH00001030429','IL','1','Mckitrick','Larry','','','Sr','34','292569438','107 VINE ST',0,'MARIETTA','OH','45750','2326','CY','39167','1955-08-21','M','M',':RET:2106-3','T','021','DEN','1621000','99734OH005000401','2014-01-01','2013-12-23 20:25:36','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,1,'2013-12-29 11:13:27'),(20283,16188,'Y','18','021','EC','A','','','AC','0001058028','0001058028','OH00001815205','IL','1','Renieris','Bill','','','','34','403647835','642 PEDRETTI AVE',0,'Cincinnati','OH','45238',NULL,'CY','39061','1953-06-21','M','U',':RET:2106-3','N','021','DEN','2165224','99734OH005000401','2014-03-01','2014-01-28 16:04:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-28 21:00:30'),(19496,15538,'Y','18','021','EC','A','','','AC','0000659932','0000659932','OH00001909113','IL','1','Lyttle','Rebecca','','','','34','291441711','10825 RESERVOIR DR',0,'MANTUA','OH','44255','8400','CY','39133','1954-05-14','F','U',NULL,'N','021','HLT','2654794','52664OH151001301','2014-03-01','2014-01-22 14:31:17','307.00',NULL,NULL,'580.49','273.49','R-OH012','OH0','580.49',NULL,0,'2014-01-23 03:02:08'),(16663,13334,'Y','18','021','EC','A','','','AC','0001807208','0001807208','LA00002258816','31','1','Washington','Danielle','','','','34','438670976','P.O. box872745',0,'New Orleans','LA','70187',NULL,'CY','22071','1981-04-11','F','U',':RET:2054-5','N','021','DEN','2535213','18575LA002000101','2014-02-01','2014-01-06 22:31:53','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-08 18:24:25'),(17096,13682,'Y','18','024','14','A','','','TE','0000909870','0000909870','','IL','1','Gomez','Martha','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-16','F','',NULL,NULL,NULL,'','1870719','','2014-01-08','2014-01-08 15:48:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:21:30'),(17203,13767,'Y','18','021','EC','A','','','AC','0000264225','0000264225','OH00001944086','IL','1','Brandt','Jessie','','','','34','283428355','102 HIGHLAND BLVD',0,'ASHLAND','OH','44805','3351','CY','39005','1951-06-04','F','U',':RET:2106-3','N','021','HLT','1613368','52664OH151001501','2014-02-01','2014-01-08 16:06:31','444.00',NULL,NULL,'768.43','324.43','R-OH012','OH0','768.43',NULL,0,'2014-01-13 02:22:25'),(22049,17600,'Y','18','021','EC','A','','','AC','0000184880','0000184880','TX00002065045','IL','1','Hamann','Casey','','','','34','466438969','402 N ROSS ST',0,'COMANCHE','TX','76442','2260','CY','48093','1968-04-12','F','U',':RET:2106-3','T','021','DEN','3083136','33348TX002000201','2014-03-01','2014-02-07 18:13:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:03'),(24136,19182,'N','01','021','EC','A',NULL,NULL,'','0000043263','0000740326','','IL','1','Jones','Terry','','','','34','298707234','3201 MECHANICSBURG RD',0,'SPRINGFIELD','OH','45503','1828','CY','39023','1962-08-22','M','',':RET:2106-3','N','021','HLT','3439441','92036OH003000501','2014-03-01','2014-02-15 10:01:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','462.98',NULL,0,'2014-02-15 22:01:50'),(27142,21488,'Y','18','021','EC','A','','','AC','0000889661','0000889661','OH00002985565','IL','1','lewis','alicia','','','','34','294826258','137 N 4TH ST',0,'WILLIAMSBURG','OH','45176','1102','CY','39025','1973-12-15','F','U',':RET:2106-3','T','021','DEN','3803655','99734OH005000401','2014-04-01','2014-03-03 12:54:13','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-03 21:30:47'),(28288,22384,'Y','18','021','EC','A','','','AC','0001060977','0001060977','OH00003106119','31','1','Britenriker','John','','','','34','291585180','PO Box 4675',0,'Akron','OH','44310',NULL,'CY','39103','1955-12-08','M','M',':RET:2106-3','N','021','HLT','4089073','52664OH151001304','2014-04-01','2014-03-07 14:30:31','643.00',NULL,NULL,'1003.53','360.53','R-OH012','OH0','568.22','CIC',0,'2014-03-07 21:00:27'),(9246,7332,'N','19','021','EC','A',NULL,NULL,'','0001157551','0000356034','','IL','1','Roessner','Jill','K',NULL,NULL,NULL,NULL,'PO Box 380  704 Little Turtle Drive',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1998-09-11','F','',':RET:2106-3','N','021','HLT','2146728','92036OH002001501','2014-01-01','2013-12-18 17:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2013-12-26 04:10:43'),(13395,10691,'N','19','021','EC','A',NULL,NULL,'','0001057989','0000655811','','IL','1','Thomas','Siena','','','','34','270066430','5798 UNIVERSITY HEIGHTS DR',0,'ATHENS','OH','45701','9339','CY','39009','2000-10-10','F','',':RET:2106-3','N','021','DEN','2503092','99734OH005000301','2014-01-01','2013-12-23 08:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:13'),(16632,13306,'Y','18','021','EC','A','','','AC','0000197160','0000197160','OH00002214262','IL','1','Tillman','Barbara','','','','34','292689815','5007 DARBY RD',0,'DAYTON','OH','45431','1120','CY','39113','1967-07-13','F','U',':RET:2106-3','N','021','DEN','1872072','99734OH005000401','2014-02-01','2014-01-07 11:12:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:15'),(14637,11681,'Y','18','021','EC','A','','','AC','0000743093','0000743093','OH00000974212','IL','1','Mitchell','Marguerite','','','','34','302441894','2976 CAUDIL EAST RD',0,'BATAVIA','OH','45103','8415','CY','39025','1950-01-24','F','M',':RET:2106-3','N','021','HLT','1450757','92036OH006000601','2014-02-01','2013-12-27 16:02:26','379.00',NULL,NULL,'502.56','123.56','R-OH005','OH0','502.56',NULL,0,'2013-12-28 03:37:20'),(15475,12380,'Y','18','021','EC','A','','','AC','0000680853','0000680853','OH00001900101','IL','1','JONES','MERELYN','','','','34','296503045','7179 LEXINGTON CT',0,'NORTHFIELD','OH','44067',NULL,'CY','39153','1950-09-30','F','M',NULL,'N','021','DEN','1641360','99734OH005000401','2014-02-01','2013-12-30 19:56:37','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:28:59'),(27209,21543,'Y','18','021','EC','A','','','AC','0000349323','0000349323','OH00002869927','IL','1','McMahan','Crystal','Lynn','','','34','271764437','930 E. Broadway St.',0,'North Baltimore','OH','45872',NULL,'CY','39173','1978-04-15','F','U',':RET:2106-3','N','021','HLT','3592660','92036OH004002601','2014-04-01','2014-03-03 16:11:17','167.00',NULL,NULL,'191.59','24.59','R-OH001','OH0','191.59',NULL,0,'2014-03-03 21:31:26'),(27582,21813,'Y','18','021','EC','A','','','AC','0000348881','0000348881','TX00003751265','31','1','Curry','Matthew','William','','','34','452454305','400 N. Val Verde Rd. Lot 235',0,'DONNA','TX','78537',NULL,'CY','48381','1964-12-03','M','M',NULL,'N','021','DEN','2770441','33348TX002000201','2014-04-01','2014-03-05 10:34:24','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61','CIC',0,'2014-03-05 21:00:12'),(19811,15795,'Y','18','024','14','A','','','TE','0000604128','0000604128','','IL','1','Pittard','Theresa','Louise',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-02','F','',NULL,NULL,NULL,'','1759978','','2014-01-23','2014-01-23 19:14:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:09'),(7826,6198,'N','01','021','EC','A',NULL,NULL,'','0000178879','0000751013','','IL','1','nong','ngan','thi','','','34','605593363','405 reed rd apt 41B',0,'beavercreek','OH','45440',NULL,'CY','39113','1975-05-10','F','',':RET:2047-9','N','021','DEN','1963916','99734OH005000301','2014-01-01','2013-12-19 18:59:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:19'),(4069,3251,'Y','18','021','EC','A','','','AC','0000168874','0000168874','OH00000963447','IL','1','Reusser','Teresa','','','','34','281508245','1469 MOODY RIDGE RD',0,'VINCENT','OH','45784','5160','CY','39167','1949-06-03','F','U',NULL,'T','021','DEN','2152642','99734OH005000401','2014-01-01','2013-12-17 17:33:06','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:46:53'),(5401,4288,'Y','18','021','EC','A','','','AC','0000504463','0000504463','OH00000390656','IL','1','Houser','Robin','','','','34','281502682','8623 MEADOWVIEW DR',0,'WEST CHESTER','OH','45069','3431','CY','39017','1963-11-06','F','U',':RET:2106-3','T','021','HLT','1723759','92036OH006001201','2014-01-01','2013-12-18 20:56:09','214.00',NULL,NULL,'349.66','135.66','R-OH004','OH0','349.66',NULL,0,'2013-12-25 23:08:57'),(19104,15221,'Y','18','021','EC','A','','','AC','0002318755','0002318755','LA00002584382','IL','1','Boykins','Darius','Akeem','','','34','439776143','5505 SILVERLEAF AVE',0,'BATON ROUGE','LA','70812','2046','CY','22033','1989-12-17','M','U',':RET:2054-5','N','021','DEN','1647881','18575LA002000201','2014-03-01','2014-01-18 12:55:10','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:44:40'),(18011,14393,'Y','18','021','EC','A','','','AC','0001184903','0001184903','OH00001504242','IL','1','Manning','Wendy','','','','34','234295900','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','1971-01-13','F','M',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:07:03'),(17653,14109,'N','19','021','EC','A',NULL,NULL,'','0000948436','0001088285','','IL','1','Abou-Osman','Ali','Ahmad','','','34','269961978','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','2002-08-16','M','',':RET:2106-3','N','021','DEN','1526001','99734OH005000301','2014-02-01','2014-01-13 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:41'),(14597,11650,'Y','18','021','EC','A','','','AC','0000444920','0000444920','OH00001192480','IL','1','Gormley','Shawn','','','','34','273726244','2360 HAZELNUT DR',0,'FAIRBORN','OH','45324','2183','CY','39057','1973-08-22','M','U',':RET:2106-3','N','021','DEN','2357483','99734OH005000301','2014-02-01','2013-12-26 23:41:00','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-28 03:36:18'),(26867,21294,'Y','18','021','EC','A','','','AC','0000333284','0000333284','TX00003166960','IL','1','KIRK','MARY','','','','34','449750107','3913 Gannon Lane',0,'Dallas','TX','75237',NULL,'CY','48113','1969-07-06','F','U',':RET:2054-5','N','021','DEN','3343634','33348TX002000101','2014-04-01','2014-03-01 16:21:21','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-01 21:01:01'),(3339,2677,'Y','18','021','EC','A','','','AC','0001011470','0001011470','TX00001148793','IL','1','LEAL','NORMA','I','','','34','555357917','1101 QUARTZ ST',0,'PENITAS','TX','78579',NULL,'CY','48215','1961-02-15','F','M',NULL,'N','021','DEN','2565737','33348TX002000201','2014-01-01','2013-12-21 19:01:13','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:16:27'),(4794,3801,'Y','18','021','EC','A','','','AC','0000089799','0000089799','OH00000863040','IL','1','Duncan','Erik','','','','34','294785494','282 Pioneer St.',0,'Akron','OH','44305',NULL,'CY','39153','1980-09-03','M','U',':RET:2106-3','N','021','HLT','601127','52664OH151001301','2014-01-01','2013-12-08 14:54:56','0.00',NULL,NULL,'267.16','267.16','R-OH012','OH0','267.16',NULL,0,'2013-12-25 22:16:21'),(5608,4451,'Y','18','021','EC','A','','','AC','0000616836','0000616836','OH00000461695','IL','1','Whisner','philip','','','','34','300804736','1560 bethel New Richmond road',0,'New Richmond','OH','45157',NULL,'CY','39025','1968-02-29','M','U',':RET:2106-3','N','021','DEN','32617','99734OH005000401','2014-01-01','2013-11-25 21:22:37','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 23:30:29'),(22809,18204,'Y','18','021','EC','A','','','AC','0000806393','0000806393','OH00001968178','IL','1','KOHLI','MANPREET','','','','34','142043103','7615 SHADOW CREEK DR',0,'HAMILTON','OH','45011','6541','CY','39017','1973-02-03','M','M',NULL,'N','021','DEN','3180986','99734OH005000301','2014-03-01','2014-02-11 15:05:55','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:56'),(21182,16927,'N','01','021','EC','A',NULL,NULL,'','0000995093','0001130620','','IL','1','GWYN','MANDELYN','','','','34','428512536','2116 CUSTER DR',0,'SOUTHAVEN','MS','38671','5024','CY','28033','1980-06-10','F','',':RET:2106-3','N','021','DEN','3064066','46300MS002000101','2014-03-01','2014-02-02 22:39:05',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-03 21:00:43'),(9402,7458,'Y','18','021','EC','A','','','AC','0000426166','0000426166','TX00000409323','IL','1','Cantu','Robert','','','','34','463576265','10322 Staghill Dr',0,'Houston','TX','77064',NULL,'CY','48201','1970-01-02','M','U',NULL,'N','021','DEN','2181844','33348TX002000201','2014-01-01','2013-12-21 00:51:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:32:37'),(9477,7516,'N','19','021','EC','A',NULL,NULL,'','0000399882','0000247887','','S1','1','Bitonte','Tracy','Dawn','','','34','285062651','508 Chatham Court',0,'Pinkerington','OH','43147',NULL,'CY','39045','2001-07-18','F','',':RET:2106-3','N','021','DEN','2396650','99734OH005000401','2014-01-01','2013-12-21 11:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:34'),(13111,10455,'Y','18','021','EC','A','','','AC','0000013777','0000013777','OH00000163288','IL','1','Gaddis','Francine','R','','','34','278640803','3882 GREENBROOK DR',0,'AMELIA','OH','45102','9201','CY','39025','1965-05-28','F','M',NULL,'N','021','DEN','1820072','99734OH005000401','2014-01-01','2013-12-23 13:25:35','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 12:52:28'),(21003,16782,'Y','18','021','EC','A','','','AC','0002323826','0002323826','LA00001613461','IL','1','ROSE','REX','','','','34','266375092','70312 RAVINE ST',0,'ABITA SPRINGS','LA','70420','3134','CY','22103','1962-11-23','M','U',NULL,'N','021','DEN','3260322','18575LA002000101','2014-03-01','2014-02-01 12:07:52','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-01 19:00:30'),(17232,13790,'N','01','021','EC','A',NULL,NULL,'','0000250181','0000708733','','IL','1','Scott','Susan','','','','34','428043659','110 FAIROAKS DR',0,'JACKSON','MS','39212','2223','CY','28049','1956-08-01','F','',':RET:2054-5','N','021','DEN','2096722','46300MS002000101','2014-02-01','2014-01-08 12:52:20',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-13 02:22:40'),(19631,15646,'N','19','021','EC','A',NULL,NULL,'','0001210955','0000270044','','IL','1','HART','MADISON','','','','34','300047077','104 CHARTERHOUSE CT',0,'POWELL','OH','43065','9119','CY','39041','2000-06-26','M','',':RET:2106-3','N','021','DEN','2685574','99734OH005000401','2014-03-01','2014-01-23 10:36:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:09'),(19650,15659,'N','17','021','EC','A',NULL,NULL,'','0000741751','0000712552','','IL','1','Bowman','Logan','T',NULL,NULL,NULL,NULL,'517 S Marion St',0,'Cardington','OH','43315',NULL,'CY','39117','2001-03-25','M','',':RET:2106-3','N','021','DEN','3267520','99734OH005000401','2014-03-01','2014-01-23 12:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:19'),(19825,15808,'Y','18','021','EC','A','','','AC','0000234405','0000234405','TX00002572342','IL','1','Batres','Jessica','','','','34','243652430','10903 MILLER BARBER DR',0,'EL PASO','TX','79936','2720','CY','48141','1986-09-20','F','U',NULL,'N','021','DEN','3205176','33348TX002000201','2014-03-01','2014-01-24 13:14:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-24 21:00:16'),(23920,19022,'N','19','021','EC','A',NULL,NULL,'','0000613049','0000639569','','IL','1','Barr','Blake',NULL,NULL,NULL,NULL,NULL,'7191 TUMBLEBROOK DR',0,'NEW ALBANY','OH','43054','8890','CY','39049','2009-03-23','M','',NULL,'N','021','DEN','3604800','99734OH005000301','2014-03-01','2014-02-14 15:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:05'),(24483,19449,'N','01','021','EC','A',NULL,NULL,'','0000823565','0000894671','','IL','1','farwell','terre','j','','','34','385565008','4577 st rt 276',0,'batavia','OH','45103',NULL,'CY','39025','1952-07-29','F','',':RET:2106-3','N','021','HLT','3191098','92036OH003000605','2014-04-01','2014-02-18 16:09:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','629.96',NULL,0,'2014-02-18 22:01:46'),(25131,19934,'N','01','021','EC','A',NULL,NULL,'','0000830665','0001062599','','IL','1','Mai','Thuy',NULL,NULL,NULL,NULL,NULL,'3630 Gardenbrook Dr.',0,'Farmers Branch','TX','75234',NULL,'CY','48113','1972-05-23','F','',NULL,'N','021','DEN','3134713','33348TX002000201','2014-04-01','2014-02-20 21:02:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-21 22:00:03'),(27199,21536,'Y','18','021','EC','A','','','AC','0000411978','0000411978','TX00003359905','IL','1','JOLIVETTE','CORNELIUS','LEON','','','34','433538328','3131 HAYES RD',0,'HOUSTON','TX','77082','6627','CY','48201','1983-10-25','M','U',':RET:2054-5','N','021','DEN','3801409','33348TX002000201','2014-04-01','2014-03-03 17:18:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-03 21:31:21'),(47,42,'Y','18','021','EC','A','','','AC','0000542709','0000542709','MS00000502013','IL','1','McDowell','Linda','Gail','','','34','426112969','1009 ROBINSON RD',0,'MCCOMB','MS','39648','8517','CY','28113','1958-03-27','F','U',':RET:2054-5','N','021','DEN','141675','46300MS002000101','2014-01-01','2013-12-05 14:55:35','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 17:16:15'),(1149,947,'Y','18','021','EC','A','','','AC','0000091629','0000091629','LA00000635103','IL','1','Spell','Thomas','','','','34','437356464','15116 Cocodrie Ave',0,'Baton Rouge','LA','70817',NULL,'CY','22033','1963-08-22','M','U',':RET:2106-3','N','021','DEN','1104673','18575LA002000201','2014-01-01','2013-12-03 15:14:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:34'),(23306,18580,'Y','18','021','EC','A','','','AC','0000812069','0000812069','OH00001559477','IL','1','Stuckert','Carrie','','','','34','290885135','2746 FOXFIRE LN',0,'FINDLAY','OH','45840','7138','CY','39063','1978-01-20','F','U',':RET:2106-3','T','021','DEN','3214413','99734OH005000301','2014-03-01','2014-02-13 10:51:37','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-13 22:00:18'),(8860,7024,'Y','18','021','EC','A','','','AC','0000247970','0000247970','TX00000219878','IL','1','Woodward','Margaret','','','','34','636015009','2849 SINGLETREE CV',0,'CEDAR HILL','TX','75104','8235','CY','48113','1988-08-06','F','U',':RET:2106-3','N','021','DEN','2486713','33348TX002000201','2014-01-01','2013-12-18 11:09:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:01:14'),(8099,6409,'N','01','021','EC','A',NULL,NULL,'','0001224459','0001039745','','IL','1','Smith','Rodney','','','','34','284523094','736 EAST AVE',0,'TALLMADGE','OH','44278','2570','CY','39153','1953-07-12','M','',NULL,'N','021','HLT','1588821','52664OH151001501','2014-01-01','2013-12-20 16:46:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','725.90',NULL,0,'2013-12-26 03:10:51'),(1321,1092,'Y','18','021','EC','A','','','AC','0000647040','0000647040','OH00000817393','IL','1','Sommerstad','Keith','','','','34','107663673','33123 electric blvd',0,'Avon lake','OH','44012',NULL,'CY','39093','1982-02-20','M','U',':RET:2106-3','N','021','HLT','928398','52664OH152000901','2014-01-01','2013-11-04 07:32:46','0.00',NULL,NULL,'213.52','213.52','R-OH011','OH0','213.52',NULL,0,'2013-12-25 18:31:44'),(19840,15823,'Y','18','021','EC','A','','','AC','0002371045','0002371045','LA00001535677','IL','1','BELLAMORE','KEITH','L','','','34','436942827','1015 CENTRAL AVENUE',0,'WESTWEGO','LA','70094',NULL,'CY','22051','1957-07-25','M','U',':RET:2106-3','N','021','DEN','3078171','18575LA002000201','2014-03-01','2014-01-24 12:36:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-24 21:00:25'),(6300,4997,'Y','18','021','EC','A','','','AC','0001192645','0001192645','OH00000447138','IL','1','Vogel','Kevin','Edward','','','34','270482253','9010 E PARKVIEW CT',0,'MARBLEHEAD','OH','43440','1243','CY','39123','1956-01-21','M','R',':RET:2106-3','N','021','DEN','1217831','99734OH005000401','2014-01-01','2013-12-11 09:22:34','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 00:45:52'),(14850,11858,'Y','18','021','EC','A','','','AC','0000737860','0000737860','OH00001064204','IL','1','White','Katherine','','','','34','281609010','724 Pearlman Rd',0,'New Franklin','OH','44319',NULL,'CY','39153','1960-10-11','F','M',':RET:2106-3','N','021','HLT','1704943','52664OH151001306','2014-01-01','2013-12-23 20:51:41','856.00',NULL,NULL,'1023.16','167.16','R-OH012','OH0','454.94',NULL,1,'2013-12-29 11:15:05'),(25985,20608,'Y','18','021','EC','A','','','AC','0000279609','0000279609','OH00003088983','IL','1','McKnight','James','','','','34','287444200','2570 COVENTRY RD',0,'SHAKER HEIGHTS','OH','44120','1304','CY','39035','1957-08-17','M','M',':RET:2106-3','N','021','DEN','3840866','99734OH005000401','2014-03-01','2014-02-26 17:21:46','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:01:53'),(27873,22048,'Y','18','021','EC','A','','','AC','0000125491','0000125491','MS00002512111','IL','1','ROBERTS','MARY','','','','34','587825776','555 HIGHWAY 61 N',0,'NATCHEZ','MS','39120','8440','CY','28001','1955-05-07','F','U',NULL,'N','021','DEN','3572852','46300MS002000101','2014-04-01','2014-03-05 13:10:57','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-05 21:32:27'),(122,106,'Y','18','021','EC','A','','','AC','0000765941','0000765941','OH00000781778','IL','1','HILLIARD','DIANA','','','','34','279629882','6660 STATE ROUTE 753',0,'HILLSBORO','OH','45133','9324','CY','39071','1962-10-17','F','M',NULL,'N','021','HLT','397704','92036OH002000601','2014-01-01','2013-12-04 18:35:15','43.00',NULL,NULL,'462.36','419.36','R-OH005','OH0','462.36',NULL,0,'2013-12-25 17:18:13'),(18101,14459,'Y','18','021','EC','A','','','AC','0001426176','0001426176','LA00001866393','IL','1','thomas','Lois','','','','34','437883227','1861 BAYOU BLUE RD',0,'HOUMA','LA','70364','3904','CY','22109','1951-12-31','F','M',':RET:2106-3','N','021','DEN','1847025','18575LA002000201','2014-02-01','2014-01-14 16:36:02','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-15 02:07:34'),(22849,18231,'Y','18','021','EC','A','','','AC','0000525622','0000525622','OH00002226443','IL','1','Watkins','Andrew','','','','34','280921394','19487 Wetzel Rd',0,'Middle Point','OH','45863',NULL,'CY','39161','1989-05-18','M','U',':RET:2106-3','N','021','HLT','2627591','92036OH005001505','2014-03-01','2014-02-11 14:28:14','152.00',NULL,NULL,'220.08','68.08','R-OH002','OH0','220.08',NULL,0,'2014-02-11 21:02:19'),(1345,1114,'Y','18','021','EC','A','','','AC','0000669627','0000669627','TX00001388375','IL','1','Hennig','Cynthia','','','','34','387640584','190 LOCKWOOD DR',0,'DENISON','TX','75020','4862','CY','48181','1956-02-05','F','R',':RET:2106-3','N','021','DEN','2572112','33348TX002000101','2014-01-01','2013-12-24 07:01:15','0.00',NULL,NULL,'27.15','27.15','R-TX020','TX0','27.15',NULL,0,'2013-12-25 18:45:05'),(17243,13798,'Y','18','021','EC','A','','','AC','0001147352','0001147352','OH00002166102','IL','1','Brown','Stephanie','','','','34','271922237','5223 CHATEAU WAY',0,'FAIRFIELD','OH','45014','3209','CY','39017','1989-01-15','F','U',':RET:2106-3','N','021','HLT','1394404','92036OH005001206','2014-02-01','2014-01-08 14:58:37','150.00',NULL,NULL,'215.53','65.53','R-OH004','OH0','215.53',NULL,0,'2014-01-13 02:22:46'),(7469,5911,'Y','18','021','EC','A','','','AC','0000103874','0000103874','OH00000815499','IL','1','Tunstall','Larry','','','','34','291582362','9095 FOXHUNTER LN',0,'CINCINNATI','OH','45242','4631','CY','39061','1956-01-26','M','M',':RET:2106-3','N','021','DEN','1004010','99734OH005000401','2014-01-01','2013-12-14 20:12:24','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:08'),(16667,13338,'Y','18','021','EC','A','','','AC','0000403672','0000403672','OH00001382524','IL','1','Schatzel','Julie','','','','34','269886186','7814 HACKNEY CIR',0,'MAINEVILLE','OH','45039','9073','CY','39165','1979-11-24','F','U',':RET:2106-3','N','021','DEN','1693705','99734OH005000301','2014-02-01','2014-01-06 19:24:18','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-08 18:24:27'),(16275,13030,'N','01','021','EC','A',NULL,NULL,'','0000551429','0000277286','','IL','1','Collins','Alisha','Lynn','','','34','280804222','1121 TRUDY CT',0,'LEBANON','OH','45036','9694','CY','39165','1982-12-19','F','',NULL,'N','021','DEN','1972264','99734OH005000401','2014-02-01','2014-01-06 13:22:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:22'),(6755,5360,'Y','18','021','EC','A','','','AC','0000043197','0000043197','OH00001244028','IL','1','McMahon','Christopher','','','','34','286784756','147 E MAPLEDALE AVE',0,'AKRON','OH','44301','1731','CY','39153','1982-01-17','M','U',':RET:2106-3','T','021','HLT','481200','52664OH152000901','2014-01-01','2013-11-25 13:56:21','0.00',NULL,NULL,'217.71','217.71','R-OH012','OH0','217.71',NULL,0,'2013-12-26 01:16:11'),(6592,5226,'N','01','021','EC','A',NULL,NULL,'','0001116521','0001120581','','IL','1','Hamid','Wadad','S','','','34','465451537','4906 LakeLivingston',0,'CorpusChristi','TX','78413',NULL,'CY','48355','1959-12-02','F','',':RET:2028-9','N','021','DEN','351915','33348TX002000101','2014-01-01','2013-12-11 13:07:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-26 00:53:17'),(15500,12401,'Y','18','024','14','A','','','TE','0000474933','0000474933','','IL','1','Dockery','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-23','F','',NULL,NULL,NULL,'','379800','','2013-12-31','2013-12-31 12:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:44'),(21096,16859,'Y','18','021','EC','A','','','AC','0000832027','0000832027','OH00002310734','IL','1','Corbett','Joann','','','','34','297685261','25000 ROCKSIDE RD',0,'BEDFORD HEIGHTS','OH','44146','1918','CY','39035','1962-08-02','F','U',':RET:2054-5','N','021','HLT','3644454','92036OH004000801','2014-03-01','2014-02-02 14:31:51','334.00',NULL,NULL,'350.62','16.62','R-OH011','OH0','350.62',NULL,0,'2014-02-02 19:00:31'),(20560,16430,'Y','18','021','EC','A','','','AC','0000737893','0000737893','OH00001567019','IL','1','RAY','MIA','','','','34','287707307','2226 LINCOLN AVE',0,'CINCINNATI','OH','45224','1830','CY','39061','1965-01-15','F','U',NULL,'N','021','HLT','2963928','92036OH006001201','2014-03-01','2014-01-29 12:25:05','0.00',NULL,NULL,'290.44','290.44','R-OH004','OH0','290.44',NULL,0,'2014-01-29 21:01:46'),(20477,16358,'Y','18','021','EC','A','','','AC','0000878295','0000878295','OH00001474341','IL','1','Canini','Ronald','','','','34','281582725','7313 SCHOOLCRAFT LN',0,'COLUMBUS','OH','43235','7499','CY','39049','1954-10-23','M','M',':RET:2106-3','N','021','DEN','2730286','99734OH005000401','2014-03-01','2014-01-29 15:11:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:58'),(892,739,'Y','18','021','EC','A','','','AC','0000240331','0000240331','OH00000508321','IL','1','Louderback','Ruth','','','','34','298505058','8065 ST.RT.135',0,'LYNCHBURG','OH','45142',NULL,'CY','39071','1953-04-12','F','U',NULL,'N','021','HLT','1745555','92036OH002000601','2014-01-01','2013-12-16 16:16:08','371.00',NULL,NULL,'672.81','301.81','R-OH005','OH0','672.81',NULL,0,'2013-12-25 18:08:01'),(961,789,'Y','18','021','EC','A','','','AC','0000375278','0000375278','TX00000199443','IL','1','Ball','Donald','','','','34','463113896','1117 ROSEMARY DR',0,'WICHITA FALLS','TX','76306','6947','CY','48485','1955-11-07','M','U',NULL,'N','021','DEN','807947','33348TX002000201','2014-01-01','2013-10-28 22:10:39','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:09:47'),(17980,14367,'Y','18','021','EC','A','','','AC','0000977954','0000977954','OH00002110216','IL','1','CLAY','DAWN','','','','34','297609219','2294 NORTHWEST BLVD NW',0,'WARREN','OH','44485','2305','CY','39155','1977-08-23','F','U',':RET:2054-5','N','021','HLT','2379290','52664OH151001306','2014-02-01','2014-01-14 14:53:54','223.00',NULL,NULL,'311.06','88.06','R-OH013','OH0','311.06',NULL,0,'2014-01-15 02:06:52'),(5292,4193,'N','01','021','EC','A',NULL,NULL,'','0000976708','0000044263','','IL','1','Crowder','William','','','','34','407746656','6140 Vair Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1951-12-27','M','',':RET:2106-3','N','021','HLT','1488270','52664OH151001304','2014-01-01','2013-12-19 17:33:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-25 23:06:04'),(16279,13032,'N','01','021','EC','A',NULL,NULL,'','0001144784','0000899582','','IL','1','Booker','Paul','G','','','34','285880523','5219Daleside.Ave',0,'Parma','OH','44134',NULL,'CY','39035','1974-05-26','M','',':RET:2106-3','N','021','DEN','2097864','99734OH005000401','2014-02-01','2014-01-06 13:47:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:28'),(15742,12593,'Y','18','021','EC','A','','','AC','0000884913','0000884913','TX00000979339','IL','1','RODRIGUEZ','NANCY','','','','34','456638658','306 WESTHAM',0,'LAREDO','TX','78045','7746','CY','48479','1975-06-30','F','U',NULL,'N','021','DEN','2350856','33348TX002000201','2014-02-01','2014-01-02 12:22:16','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-03 02:00:51'),(15084,12057,'Y','18','021','EC','A','','','AC','0000776813','0000776813','TX00001374956','IL','1','Correa','Marjorie','','','','34','466902810','4931 FM 1863',0,'BULVERDE','TX','78163','2448','CY','48091','1951-04-11','F','M',':RET:2106-3','N','021','DEN','1692437','33348TX002000101','2014-02-01','2013-12-30 13:50:41','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-01 12:04:16'),(26482,21006,'Y','18','024','14','A','','','TE','0000959870','0000959870','','IL','1','malano','tarah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-11-03','F','',NULL,NULL,NULL,'','2373164','','2014-03-31','2014-02-28 17:54:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-28 21:00:05'),(22768,18178,'Y','18','021','EC','A','','','AC','0001037398','0001037398','OH00001620909','IL','1','Cole','Kay','','','','34','269643360','2341 18TH ST NE',0,'CANTON','OH','44705','2219','CY','39151','1957-04-11','F','M',NULL,'N','021','DEN','3143169','99734OH005000401','2014-03-01','2014-02-11 11:41:57','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-11 21:01:36'),(5853,4648,'N','01','021','EC','A',NULL,NULL,'','0001120665','0000582940','','IL','1','Shazima','Joy','','','','34','628988605','6103 hudsonwood drive',0,'arlington','TX','76001',NULL,'CY','48439','1972-09-27','F','',':RET:2054-5','N','021','DEN','1560234','33348TX002000201','2014-01-01','2013-12-24 00:49:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:48:51'),(2391,1952,'Y','18','021','EC','A','','','AC','0000004688','0000004688','OH00000748648','IL','1','Diener','Siegfried','','','','34','300500716','1294 SPRING BROOK CT',0,'WESTERVILLE','OH','43081','3788','CY','39049','1950-02-01','M','U',':RET:2106-3','N','021','DEN','81764','99734OH005000401','2014-01-01','2013-12-09 12:15:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:17'),(25284,20061,'Y','18','024','14','A','','','TE','0000304173','0000304173','','IL','1','TREVINO','AID',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-28','F','',NULL,NULL,NULL,'','3419559','','2014-03-31','2014-02-25 17:38:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-25 21:00:19'),(1907,1559,'Y','18','021','EC','A','','','AC','0000357201','0000357201','OH00000764047','IL','1','Carter','Richard','','','','34','298044943','670 JACOBY RD',0,'YELLOW SPRINGS','OH','45387','9730','CY','39057','1982-06-28','M','U',':RET:2106-3','N','021','HLT','2199902','92036OH004000501','2014-01-01','2013-12-24 15:04:22','135.00',NULL,NULL,'221.53','86.53','R-OH003','OH0','221.53',NULL,0,'2013-12-25 18:59:18'),(22930,18279,'Y','18','024','14','A','','','TE','0001054198','0001054198','','IL','1','Moss','Nicholas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-11-21','M','',NULL,NULL,NULL,'','1533830','','2014-02-28','2014-02-11 09:23:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:09'),(6299,4996,'Y','18','021','EC','A','','','AC','0001066955','0001066955','OH00000133578','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','DEN','973603','99734OH005000401','2014-01-01','2013-12-11 09:01:25','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:45:50'),(21535,17203,'N','01','021','EC','A',NULL,NULL,'','0000777703','0000911799','','IL','1','Bass','Rebecca','','','','34','460710395','4934 LAKOTA WOODS DR',0,'LIBERTY TOWNSHIP','OH','45044','3245','CY','39017','1969-10-30','F','',':RET:2106-3','N','021','HLT','3179559','92036OH001001201','2014-03-01','2014-02-04 18:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','361.74',NULL,0,'2014-02-05 21:30:08'),(4751,3766,'Y','18','021','EC','A','','','AC','0000311527','0000311527','TX00000795145','31','1','Rothschild','Theresa','','','','34','447585269','PO BOX 1937',0,'Port Isabel','TX','78578',NULL,'CY','48061','1957-06-29','F','M',':RET:2106-3','N','021','DEN','74295','33348TX002000201','2014-01-01','2013-12-08 10:12:39','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 22:15:12'),(9494,7529,'Y','18','021','EC','A','','','AC','0000814281','0000814281','OH00000498811','IL','1','Radford','Stephanie','LaShawn','','','34','282903778','3082 HIGHLANDER DR',0,'BEAVERCREEK','OH','45432','2475','CY','39057','1987-10-13','F','U',':RET:2054-5','N','021','DEN','2378521','99734OH005000401','2014-01-01','2013-12-21 13:58:09','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:34:59'),(21247,16978,'Y','18','021','EC','A','','','AC','0000008449','0000008449','OH00001539562','IL','1','Jenkins','Barbara','','','','34','300540251','707 E REAGAN PKWY',0,'MEDINA','OH','44256','1241','CY','39103','1956-05-20','F','M',NULL,'N','021','DEN','3418624','99734OH005000301','2014-03-01','2014-02-03 17:07:44','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-03 21:01:15'),(17190,13756,'Y','18','021','EC','A','','','AC','0000482203','0000482203','OH00002283729','IL','1','Veit','Robert','','','','34','280661585','412 West Vine Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1960-06-19','M','M',':RET:2106-3','N','021','HLT','1960959','92036OH003001505','2014-02-01','2014-01-07 20:37:29','700.00',NULL,NULL,'1063.45','363.45','R-OH002','OH0','468.87',NULL,0,'2014-01-13 02:22:18'),(19158,15264,'Y','18','021','EC','A','','','AC','0000195169','0000195169','OH00002534916','IL','1','Greathouse','Sara','','','','34','380883544','1350 PHELPS AVE',0,'LAKEWOOD','OH','44107','3106','CY','39035','1974-06-22','F','U',':RET:2106-3','T','021','DEN','2961183','99734OH005000301','2014-03-01','2014-01-19 17:42:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:45:40'),(23680,18856,'Y','18','021','EC','A','','','AC','0001405004','0001405004','LA00001938466','IL','1','Murphy','James','','','','34','276769361','6419 HIGHWAY 953',0,'JACKSON','LA','70748','3623','CY','22037','1965-08-31','M','U',':RET:2106-3','N','021','DEN','3568219','18575LA002000201','2014-03-01','2014-02-14 17:34:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-14 21:30:30'),(24965,19799,'Y','18','021','EC','A','','','AC','0000808508','0000808508','TX00002623960','IL','1','Zheng','Wei','','','','34','109846195','12481 NINA PEARL DR',0,'EL PASO','TX','79938','8184','CY','48141','1977-09-10','M','M',NULL,'N','021','DEN','3387849','33348TX002000201','2014-04-01','2014-02-19 18:56:07','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-20 22:00:23'),(26834,21268,'Y','18','021','EC','A','','','AC','0001151128','0001151128','OH00002376595','IL','1','Card','Barbara','Louise','','','34','298481930','3525 TUSCARAWAS ST W',0,'CANTON','OH','44708','5640','CY','39151','1949-06-17','F','U',':RET:2054-5','N','021','DEN','3150643','99734OH005000401','2014-04-01','2014-03-01 15:06:10','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-01 21:00:41'),(26868,21295,'Y','18','021','EC','A','','','AC','0000141564','0000141564','OH00003114938','IL','1','Simones','Terri','','','','34','282566023','445 SYCAMORE LN',0,'AURORA','OH','44202','7629','CY','39133','1962-10-09','F','U',':RET:2106-3','N','021','HLT','3503552','52664OH151001305','2014-03-01','2014-02-28 20:17:02','269.00',NULL,NULL,'415.91','146.91','R-OH012','OH0','415.91',NULL,0,'2014-03-01 21:01:02'),(458,374,'Y','18','021','EC','A','','','AC','0000790849','0000790849','OH00000978170','IL','1','Lawrence','Zachary','','','','34','603103858','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1980-10-09','M','M',':RET:2106-3','N','021','HLT','229261','52664OH151001301','2014-01-01','2013-12-03 22:41:59','0.00',NULL,NULL,'525.63','525.63','R-OH012','OH0','267.16',NULL,0,'2013-12-25 17:47:33'),(8890,7048,'Y','18','024','14','A','','','TE','0000714646','0000714646','','IL','1','Kinnibrugh','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-30','F','',NULL,NULL,NULL,'','1586279','','2013-12-18','2013-12-18 17:09:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:01:59'),(7886,6237,'Y','18','021','EC','A','','','AC','0000453910','0000453910','OH00001291182','IL','1','McCoy','Gina','','','','34','297728366','9545 COUNTY ROAD J',0,'MALINTA','OH','43535','9728','CY','39069','1961-10-01','F','U',':RET:2106-3','N','021','HLT','2445885','92036OH005002606','2014-01-01','2013-12-19 19:00:23','325.00',NULL,NULL,'380.63','55.63','R-OH001','OH0','380.63',NULL,0,'2013-12-26 03:05:30'),(7417,5869,'Y','18','021','EC','A','','','AC','0000659867','0000659867','OH00000971669','IL','1','Scharpenberg','Marsha','','','','34','268527687','2565 Martha Ln',0,'Hamilton','OH','45013',NULL,'CY','39017','1950-11-05','F','U',':RET:2106-3','N','021','DEN','1156527','99734OH005000401','2014-01-01','2013-10-28 15:37:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:16:54'),(7148,5672,'Y','18','021','EC','A','','','AC','0001077948','0001077948','TX00001303066','IL','1','English','Robert','','','','34','467021877','12319 PIN OAK DR',0,'MAGNOLIA','TX','77354','6255','CY','48339','1961-03-26','M','M',':RET:2034-7^:RET:2036-2^:RET:2106-3','N','021','DEN','1703693','33348TX002000101','2014-02-01','2013-12-25 00:55:40','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:52:07'),(21384,17090,'Y','18','024','14','A','','','TE','0000932135','0000932135','','IL','1','MCGEE','KATHLEEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-28','F','',NULL,NULL,NULL,'','3340564','','2014-02-03','2014-02-03 23:37:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:00:54'),(19056,15179,'Y','18','021','EC','A','','','AC','0000270527','0000270527','MS00001754932','IL','1','BURRELL','MICHAEL','','','','34','587151418','1880 BARNES RD',0,'CANTON','MS','39046','8984','CY','28089','1963-08-15','M','U',':RET:2106-3','N','021','DEN','1855648','46300MS002000201','2014-03-01','2014-01-18 17:34:14','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-21 08:44:12'),(14785,11808,'Y','18','021','EC','A','','','AC','0000165079','0000165079','OH00001237224','IL','1','Sabo','Corey','','','','34','270863482','47 federal plaza',0,'Youngstown','OH','44503',NULL,'CY','39099','1986-07-23','M','R',':RET:2106-3','N','021','DEN','2495612','99734OH005000401','2014-01-01','2013-12-23 19:38:41','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,1,'2013-12-29 11:13:19'),(14388,11476,'Y','18','021','EC','A','','','AC','0000328420','0000328420','OH00001290096','IL','1','STEVENSON','BRENDA','','','','34','412864045','6523 SILVERFOX DR',0,'CINCINNATI','OH','45230',NULL,'CY','39061','1949-08-03','F','U',':RET:2106-3','N','021','DEN','1880747','99734OH005000401','2014-02-01','2013-12-27 14:49:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:56'),(8963,7110,'N','01','021','EC','A',NULL,NULL,'','0000610852','0000411104','','IL','1','Carter','John','O','','','34','302707393','140 S MAIN ST',0,'SPRINGBORO','OH','45066','1600','CY','39165','1963-11-15','M','',':RET:2106-3','N','021','DEN','1610234','99734OH005000401','2014-01-01','2013-12-18 13:29:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:03:54'),(3535,2838,'Y','18','021','EC','A','','','AC','0000102261','0000102261','TX00001082949','IL','1','RIVERA','CARLOS','','','','34','060884421','1320 SUPERIOR DR',0,'FLOWER MOUND','TX','75028','2115','CY','48121','1969-08-13','M','M',':RET:2054-5^:RET:2106-3','N','021','DEN','1514381','33348TX002000101','2014-01-01','2013-12-22 09:34:32','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:21:36'),(3590,2880,'Y','18','021','EC','A','','','AC','0000652120','0000652120','OH00001011934','IL','1','Warren','Conny','','','Jr','34','282503332','524 CAMDEN AVE',0,'CINCINNATI','OH','45229','2004','CY','39061','1951-07-27','M','U',':RET:2054-5','N','021','HLT','2446040','92036OH005001206','2014-01-01','2013-12-22 17:56:25','512.00',NULL,NULL,'616.74','104.74','R-OH004','OH0','616.74',NULL,0,'2013-12-25 21:23:00'),(24646,19563,'Y','18','021','EC','A','','','AC','0001240103','0001240103','LA00002247373','31','1','SILAS','LINDA','','','','34','436299221','PO BOX 1173',0,'COTTONPORT','LA','71327',NULL,'CY','22009','1976-08-27','F','U',NULL,'N','021','DEN','2950258','18575LA002000201','2014-04-01','2014-02-19 12:41:24','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-20 04:21:17'),(22655,18090,'Y','18','021','EC','A','','','AC','0000261793','0000261793','TX00002700657','IL','1','Robles','Yolanda','','','','34','634343560','6721 BEAUFORD DR',0,'AUSTIN','TX','78750','8121','CY','48453','1977-07-11','F','U',':RET:2106-3','N','021','DEN','3189771','33348TX002000201','2014-03-01','2014-02-11 12:08:53','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-11 21:00:30'),(9016,7154,'Y','18','021','EC','A','','','AC','0000843324','0000843324','OH00001025867','IL','1','KENT','ALPHONSO','','','','34','175583999','6965 TRUCK WORLD BLVD',0,'HUBBARD','OH','44425','3258','CY','39155','1969-02-20','M','U',NULL,'N','021','HLT','1605019','52664OH151001306','2014-01-01','2013-12-17 19:02:22','254.00',NULL,NULL,'353.29','99.29','R-OH013','OH0','353.29',NULL,0,'2013-12-26 04:05:13'),(1030,844,'N','01','021','EC','A',NULL,NULL,'','0000953585','0000985836','','IL','1','Kearney','William','','','','34','467996710','2784 FM 2434',0,'Columbus','TX','78934',NULL,'CY','48089','1986-03-02','M','',':RET:2106-3','N','021','DEN','238836','33348TX002000201','2014-01-01','2013-12-03 09:37:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:15:29'),(1094,898,'N','01','021','EC','A',NULL,NULL,'','0001192637','0000862408','','IL','1','Xu','Jie','','','','34','507591427','793 So. St. Rt. 123',0,'Lebanon','OH','45036',NULL,'CY','39165','1962-05-18','F','',':RET:2034-7','N','021','DEN','1072171','99734OH005000401','2014-01-01','2013-12-03 15:23:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:17:05'),(6825,5410,'N','19','021','EC','A',NULL,NULL,'','0001169407','0000025262','','IL','1','Smas','Madeleine','','','','34','397374219','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','2012-08-02','F','',NULL,'N','021','DEN','1156560','99734OH005000301','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:30:39'),(21327,17042,'Y','18','021','EC','A','','','AC','0001018272','0001018272','OH00002494192','IL','1','Epley','Sheila','Rae','','','34','278543491','2750 Shelburn Ave.',0,'Akron','OH','44312',NULL,'CY','39153','1952-02-13','F','M',':RET:2106-3','N','021','HLT','3351181','52664OH152000901','2014-03-01','2014-02-03 18:42:36','161.00',NULL,NULL,'469.28','308.28','R-OH012','OH0','469.28',NULL,0,'2014-02-04 21:00:26'),(5416,4298,'Y','18','024','14','A','','','TE','0000987385','0000987385','','IL','1','Morton','Divante',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1995-09-12','M','',NULL,NULL,NULL,'','2167785','','2013-12-18','2013-12-18 22:03:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:09:16'),(21070,16836,'Y','18','021','EC','A','','','AC','0000960639','0000960639','OH00001772483','IL','1','goddard','charles','','','','34','271848148','5118 algean dr',0,'canal winchester','OH','43110',NULL,'CY','39049','1982-03-18','M','M',':RET:2106-3','N','021','DEN','2627400','99734OH005000401','2014-03-01','2014-02-01 21:09:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-02 19:00:16'),(4370,3472,'Y','18','021','EC','A','','','AC','0000639499','0000639499','OH00000739852','IL','1','Golden','Allison','','','','34','337809902','3379 LITTLER LN',0,'COLUMBUS','OH','43228','7026','CY','39049','1981-02-16','F','M',':RET:2106-3','N','021','DEN','369231','99734OH005000401','2014-01-01','2013-12-11 21:52:41','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:17'),(3956,3166,'Y','18','024','14','A','','','TE','0000357174','0000357174','','IL','1','BENSON','CYNTHIA','LOUISE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-03-13','F','',NULL,NULL,NULL,'','290151','','2013-12-13','2013-12-13 10:52:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:38:18'),(18621,14845,'Y','18','021','EC','A','','','AC','0000630399','0000630399','OH00002287484','IL','1','Lane','Regenia',NULL,NULL,NULL,NULL,NULL,'23717 East Baintree Rd',0,'Beachwood','OH','44122',NULL,'CY','39035','1968-08-29','F','M',NULL,'N','021','HLT','2812754','92036OH003000801','2014-02-01','2014-01-15 14:57:55','0.00',NULL,NULL,'352.57','352.57','R-OH011','OH0','352.57',NULL,0,'2014-01-16 08:47:28'),(2436,1984,'Y','18','021','EC','A','','','AC','0001039731','0001039731','OH00001257977','IL','1','Harris','Susan','','','','34','287483985','736 TALLKRON DR',0,'AKRON','OH','44305','2231','CY','39153','1949-11-03','F','U',NULL,'N','021','HLT','747192','52664OH151001305','2014-01-01','2013-12-09 13:11:12','525.00',NULL,NULL,'669.00','144.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 19:34:18'),(3015,2424,'Y','18','024','14','A','','','TE','0001186272','0001186272','','IL','1','DeCastro','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-09-09','M','',NULL,NULL,NULL,'','767508','','2013-12-06','2013-12-06 18:09:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:18:01'),(18122,14473,'N','01','021','EC','A',NULL,NULL,'','0000676735','0001092148','','IL','1','Meyers','Rita','','','','34','296500558','1770 AKRON PENINSULA RD',0,'AKRON','OH','44313','4815','CY','39153','1951-06-06','F','',NULL,'N','021','HLT','2628229','52664OH152000901','2014-02-01','2014-01-14 16:26:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','469.28',NULL,0,'2014-01-15 02:07:41'),(14963,11960,'Y','18','021','EC','A','','','AC','0000416770','0000416770','TX00001156697','IL','1','Autrey','Debbie','','','','34','215067345','1305 N 3RD ST',0,'PRINCETON','TX','75407','6788','CY','48085','1968-10-07','F','M',':RET:2106-3','N','021','DEN','2577603','33348TX002000201','2014-02-01','2013-12-30 10:56:54','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:34'),(14982,11973,'Y','18','021','EC','A','','','AC','0001236590','0001236590','TX00001933182','IL','1','Elliott','Marilyn','','','','34','467391104','193 SAINT DONOVAN ST',0,'FORT WORTH','TX','76107','1255','CY','48439','1961-08-02','F','U',':RET:2054-5','N','021','DEN','2038475','33348TX002000201','2014-02-01','2013-12-30 14:16:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:01:06'),(17711,14154,'Y','18','021','EC','A','','','AC','0001446950','0001446950','LA00002353057','IL','1','Jackson','Keiva','','','','34','438393045','4501 KILKENNY DR',0,'BATON ROUGE','LA','70814','7323','CY','22033','1976-10-29','F','U',':RET:2054-5','N','021','DEN','1374991','18575LA002000201','2014-02-01','2014-01-13 17:14:27','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:10'),(213,178,'Y','18','021','EC','A','','','AC','0000912287','0000912287','LA00000045125','IL','1','Sutton','Lee','','','','34','434676988','1287 Chevelle Drive',0,'Baton Rouge','LA','70806',NULL,'CY','22033','1977-12-28','M','U',':RET:2106-3','T','021','DEN','1011339','18575LA002000201','2014-01-01','2013-12-05 13:08:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:31'),(22656,18091,'Y','18','021','EC','A','','','AC','0000477236','0000477236','TX00002013863','IL','1','VIGIL','URSULA','V','','','34','460219840','4027 N PLANET CT',0,'ODESSA','TX','79764','8402','CY','48135','1958-10-21','F','U',NULL,'N','021','DEN','3350042','33348TX002000201','2014-03-01','2014-02-11 12:37:06','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-02-11 21:00:31'),(22555,18012,'Y','18','021','EC','A','','','AC','0000179941','0000179941','OH00002260736','IL','1','Deaton','Stephan','A','','','34','389823871','122 TERRY CT',0,'CAMDEN','OH','45311','1136','CY','39135','1977-06-25','M','M',':RET:2106-3','T','021','DEN','2895793','99734OH005000401','2014-03-01','2014-02-10 09:34:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-10 21:31:47'),(7817,6192,'N','01','021','EC','A',NULL,NULL,'','0001192671','0000926409','','IL','1','patel','binal','a','','','34','639948722','5121 Timber Creek Dr',0,'Tyler','TX','75703',NULL,'CY','48423','1977-05-09','F','',':RET:2029-7','N','021','DEN','1760231','33348TX002000201','2014-01-01','2013-12-20 18:02:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:04:06'),(22255,17762,'N','01','021','EC','A',NULL,NULL,'','0000136314','0000125487','','IL','1','MCCOLLUM','BEVERLY','','','','34','550706618','81 BIENVILLE TRCE',0,'HATTIESBURG','MS','39402','6114','CY','28073','1961-10-18','F','',NULL,'N','021','DEN','2618625','46300MS002000201','2014-03-01','2014-02-09 17:26:31',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-09 19:00:45'),(1099,903,'Y','18','021','EC','A','','','AC','0000772613','0000772613','OH00001061062','IL','1','Klaiber','Dennis','','','','34','295626129','12965 State Route 739',0,'Richwood','OH','43344',NULL,'CY','39159','1958-07-12','M','M',':RET:2106-3','N','021','DEN','835450','99734OH005000401','2014-01-01','2013-12-03 11:34:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:17:14'),(21398,17100,'Y','18','024','14','A','','','TE','0000654626','0000654626','','IL','1','Ford','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-24','F','',NULL,NULL,NULL,'','2771045','','2014-02-04','2014-02-04 12:15:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:01'),(6162,4886,'Y','18','021','EC','A','','','AC','0001151042','0001151042','OH00000327730','IL','1','Gibson','Harrison','','','','34','403740443','340 OHIO AVE',0,'TIFFIN','OH','44883','1752','CY','39147','1952-10-16','M','M',':RET:2106-3','N','021','HLT','486531','92036OH003002705','2014-01-01','2013-11-21 14:19:03','970.00',NULL,NULL,'1102.30','132.30','R-OH006','OH0','572.23',NULL,0,'2013-12-26 00:16:50'),(5424,4306,'Y','18','021','EC','A','','','AC','0000945971','0000945971','MS00001312438','IL','1','McCray','Jawon','','','','34','426530660','2009 GENERAL PERSHING ST',0,'LAUREL','MS','39440','4814','CY','28067','1985-05-18','M','U',':RET:2054-5','N','021','DEN','1877492','46300MS002000201','2014-01-01','2013-12-19 15:03:47','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 23:09:28'),(2842,2297,'Y','18','021','EC','A','','','AC','0000775062','0000775062','OH00000999379','IL','1','lenczewski','sara','','','','34','279907671','3205 PORTMAN AVE',0,'CLEVELAND','OH','44109','4956','CY','39035','1985-03-23','F','U',':RET:2106-3','N','021','DEN','1202877','99734OH005000401','2014-01-01','2013-11-24 15:59:45','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:01:05'),(5113,4052,'Y','18','021','EC','A','','','AC','0000201725','0000201725','TX00000980138','IL','1','Khan','Zafar','','','','34','455894459','22 MOCKINGBIRD LN',0,'DAYTON','TX','77535','9204','CY','48291','1956-06-23','M','M',':RET:2029-7','N','021','DEN','2393756','33348TX002000201','2014-01-01','2013-12-19 18:15:44','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:01:45'),(21013,16790,'Y','18','021','EC','A','','','AC','0000523442','0000523442','OH00002231300','IL','1','Cortes','Karen','','','','34','254693967','441 STODDART AVE',0,'COLUMBUS','OH','43205','2208','CY','39049','1984-05-15','F','U',NULL,'N','021','DEN','3134244','99734OH005000401','2014-03-01','2014-02-01 11:14:39','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:35'),(15275,12211,'Y','18','021','EC','A','','','AC','0001162607','0001162607','OH00001561122','IL','1','Crocker','Mary','Ann','','','34','191507204','8770 CARR BAILEY RD',0,'MILLFIELD','OH','45761','9738','CY','39009','1962-02-26','F','U',':RET:2106-3','T','021','DEN','1724365','99734OH005000401','2014-02-01','2014-01-01 09:02:24','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,1,'2014-01-02 04:21:56'),(16046,12849,'Y','18','021','EC','A','','','AC','0001080778','0001080778','TX00001567425','IL','1','LUMPKIN','CHERYL','E','','','34','551020958','2600 PRESTON RD 1212',0,'PLANO','TX','79093',NULL,'CY','48357','1956-12-01','F','U',':RET:2054-5','N','021','DEN','1587147','33348TX002000101','2014-02-01','2014-01-03 16:58:30','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-04 02:03:02'),(16429,13145,'N','01','021','EC','A',NULL,NULL,'','0001891947','0001471489','','IL','1','Jackson','Ernest','R','','','34','439312268','118 NORFOLK PL',0,'MONROE','LA','71202','3919','CY','22073','1962-07-18','M','',NULL,'N','021','DEN','2201374','18575LA002000101','2014-02-01','2014-01-06 18:10:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-07 04:04:44'),(18641,14860,'Y','18','024','14','A','','','TE','0000275166','0000275166','','IL','1','Broadway','Naomi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-07-10','F','',NULL,NULL,NULL,'','1958641','','2014-01-15','2014-01-15 23:27:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:06'),(18403,14684,'Y','18','021','EC','A','','','AC','0000711402','0000711402','OH00001833271','IL','1','Reynolds','Shannon','','','','34','407748275','515 MILL ST',0,'MILFORD','OH','45150','1029','CY','39025','1952-12-17','M','M',':RET:2106-3','N','021','DEN','2173797','99734OH005000301','2014-02-01','2014-01-15 17:50:33','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:45:44'),(18344,14647,'Y','18','021','EC','A','','','AC','0000689713','0000689713','OH00002295177','IL','1','Coleman','Terri','','','','34','293584958','305 S COLLEGE ST',0,'SABINA','OH','45169','1319','CY','39027','1956-02-15','F','U',':RET:2106-3','N','021','HLT','2895263','92036OH001000601','2014-02-01','2014-01-14 19:04:42','314.00',NULL,NULL,'631.05','317.05','R-OH005','OH0','631.05',NULL,0,'2014-01-16 08:45:19'),(23805,18941,'N','01','021','EC','A',NULL,NULL,'','0000974129','0001109272','','IL','1','ast','Charles','','','','34','278520959','1289 BROWNSTONE AVE',0,'AKRON','OH','44310','3977','CY','39153','1950-10-11','M','',':RET:2106-3','N','021','HLT','2895953','52664OH151001305','2014-03-01','2014-02-14 17:18:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,0,'2014-02-14 21:31:32'),(24035,19115,'N','19','021','EC','A',NULL,NULL,'','0000304757','0000547929','','IL','1','Hineline','Grant','','','','34','299048510','8368 HAMBLETONIAN DR',0,'CINCINNATI','OH','45249','1309','CY','39061','2000-05-04','M','',':RET:2106-3','N','021','DEN','2881544','99734OH005000301','2014-03-01','2014-02-15 08:58:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:00:55'),(25587,20298,'Y','18','024','14','A','','','TE','0000304855','0000304855','','IL','1','LaHaye','DeAnna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-13','F','',NULL,NULL,NULL,'','278345','','2014-03-31','2014-02-23 22:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-26 08:00:41'),(28308,22398,'N','01','021','EC','A',NULL,NULL,'','0000784935','0000023680','','IL','1','Ingram','Charles','Douglas','','','34','587742411','734 MEADOWBROOK RD',0,'GRENADA','MS','38901','9788','CY','28043','1953-09-19','M','',':RET:2106-3','N','021','DEN','4255218','46300MS002000101','2014-04-01','2014-03-07 16:02:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15','CIC',0,'2014-03-07 21:00:35'),(17181,13748,'Y','18','021','EC','A','','','AC','0000920825','0000920825','OH00000593436','IL','1','Wilson','Toni','','','','34','286749924','5019 PRICE RD',0,'MALTA','OH','43758','9716','CY','39115','1971-04-17','F','M',':RET:2106-3','N','021','DEN','2400722','99734OH005000301','2014-02-01','2014-01-08 12:51:29','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-13 02:22:13'),(8908,7065,'Y','18','021','EC','A','','','AC','0000240335','0000240335','OH00000274093','IL','1','WILLIAMS','ELIZABETH','','','','34','348443295','610 GRANT AVE',0,'MARTINS FERRY','OH','43935','1354','CY','39013','1950-02-16','F','U',NULL,'N','021','DEN','1554852','99734OH005000401','2014-01-01','2013-12-17 20:31:02','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:02:30'),(16657,13328,'Y','18','021','EC','A','','','AC','0001380429','0001380429','LA00001846118','IL','1','DOANE','RONALD','H','','','34','433131365','2045 LANDRY CT',0,'MERAUX','LA','70075','2853','CY','22087','1959-01-14','M','M',':RET:2106-3','N','021','DEN','2616558','18575LA002000101','2014-02-01','2014-01-06 18:31:35','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-08 18:24:23'),(2535,2062,'N','01','021','EC','A',NULL,NULL,'','0001223151','0000811993','','IL','1','Price','Cynthia','Ann','','','34','297443390','5520 Ridgewood Rd. W.',0,'Springfield','OH','45503',NULL,'CY','39023','1956-04-22','F','',':RET:2106-3','N','021','HLT','130316','92036OH005000506','2014-01-01','2013-12-09 14:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','579.30',NULL,0,'2013-12-25 19:36:52'),(6849,5430,'N','01','021','EC','A',NULL,NULL,'','0000200155','0000189704','','IL','1','Mewis','Mark','','','','34','450906070','20075 STATE HIGHWAY 159 W',0,'NEW ULM','TX','78950','5031','CY','48015','1952-03-13','M','',NULL,'N','021','DEN','985868','33348TX002000201','2014-01-01','2013-10-05 10:44:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:31:21'),(2623,2133,'Y','18','021','EC','A','','','AC','0000637079','0000637079','OH00000538466','IL','1','Lemons','Susan','','','','34','300749874','6763 BRITTON AVE',0,'CINCINNATI','OH','45227','3125','CY','39061','1965-11-21','F','U',NULL,'N','021','DEN','1178918','99734OH005000401','2014-01-01','2013-12-02 06:58:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:55'),(9693,7678,'Y','18','021','EC','A','','','AC','0000954294','0000954294','OH00000238243','IL','1','Patterson','John','','','','34','285524114','9480 TRACE ROAD',0,'Camden','OH','45311',NULL,'CY','39135','1951-08-06','M','U',':RET:2106-3','T','021','HLT','1594533','92036OH006000501','2014-01-01','2013-12-21 12:07:53','532.00',NULL,NULL,'622.85','90.85','R-OH003','OH0','622.85',NULL,0,'2013-12-26 04:39:46'),(2909,2345,'Y','18','021','EC','A','','','AC','0001024235','0001024235','OH00001188870','IL','1','SCHULTZ','GLORIA','ANN','','','34','289503487','12135 CROSSROADS DRIVE',0,'PAINSVILLE','OH','44077',NULL,'CY','39085','1950-02-28','F','M',':RET:2106-3','N','021','DEN','678121','99734OH005000401','2014-01-01','2013-12-06 11:21:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:15:31'),(4163,3315,'N','01','021','EC','A',NULL,NULL,'','0000752061','0001117231','','IL','1','Reser','Shannon','','','','34','301809370','5909 Thornberry Ct',0,'mason','OH','45040',NULL,'CY','39165','1977-05-17','M','',':RET:2106-3','N','021','DEN','1493295','99734OH005000301','2014-01-01','2013-12-17 15:59:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:49:02'),(3686,2951,'Y','18','021','EC','A','','','AC','0001219572','0001219572','OH00000529816','IL','1','Robbins','Richard','','','','34','291562419','4777 COTTON RUN RD',0,'HAMILTON','OH','45011','9656','CY','39017','1957-04-01','M','M',':RET:2106-3','N','021','DEN','493587','99734OH005000401','2014-01-01','2013-12-13 10:17:14','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:36'),(3717,2972,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000941969','','S1','1','Anaya','George','Antonio','','','34','299983325','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1996-04-30','M','',':RET:2106-3','N','021','DEN','210262','99734OH005000401','2014-01-01','2013-12-13 14:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:19'),(23816,18950,'Y','18','024','14','A','','','TE','0000885590','0000885590','','IL','1','Dible','Robert','V',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-12-17','M','',NULL,NULL,NULL,'','1716328','','2014-02-28','2014-02-13 19:28:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-14 21:31:38'),(25415,20165,'Y','18','024','14','A','','','TE','0000191380','0000191380','','IL','1','Catania','Catherine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-01-31','F','',NULL,NULL,NULL,'','2900086','','2014-03-31','2014-02-25 13:47:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:31:05'),(29207,23114,'Y','18','024','14','A','','','TE','0000906658','0000906658','','IL','1','Svetlik','George',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-10-04','M','',NULL,NULL,NULL,'','2793056','','2014-03-10','2014-03-10 13:10:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-10 21:30:13'),(1562,1304,'Y','18','021','EC','A','','','AC','0001114090','0001114090','TX00000591901','IL','1','HATTON','ANTONETTE','','','','34','428372130','926 SILVER SAGE DR',0,'WYLIE','TX','75098','8603','CY','48085','1977-11-11','F','M',':RET:2054-5','N','021','DEN','1863128','33348TX002000201','2014-01-01','2013-12-24 05:08:57','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:50:56'),(23361,18614,'Y','18','021','EC','A','','','AC','0001010255','0001010255','OH00002278472','IL','1','Smith','Kathy','','','','34','282562864','1239 Vanderhoof Rd.',0,'Barberton','OH','44203',NULL,'CY','39153','1954-05-19','F','M',':RET:2106-3','N','021','HLT','2798863','52664OH151001305','2014-03-01','2014-02-13 15:15:41','398.00',NULL,NULL,'580.49','182.49','R-OH012','OH0','580.49',NULL,0,'2014-02-13 22:00:46'),(7756,6144,'Y','18','021','EC','A','','','AC','0000236264','0000236264','OH00001301383','IL','1','SMITH','LISA','','','','34','287680105','11950 SPERRY RD',0,'CHESTERLAND','OH','44026','2225','CY','39055','1959-07-27','F','U',':RET:2106-3','N','021','DEN','1447533','99734OH005000401','2014-01-01','2013-12-20 16:47:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:38'),(21484,17167,'Y','18','021','EC','A','','','AC','0000021422','0000021422','OH00002069869','IL','1','Weigand','Jason','','','','34','275849053','917 TIMBERLINE DR',0,'AKRON','OH','44333','1563','CY','39153','1981-02-10','M','R',':RET:2106-3','N','021','DEN','2664435','99734OH005000301','2014-03-01','2014-02-04 16:00:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-04 21:01:44'),(7137,5664,'Y','18','021','EC','A','','','AC','0000083660','0000083660','TX00000146931','IL','1','Cage','Cynthia','','','','34','454373616','10907 RADFORD LN',0,'HOUSTON','TX','77099','4724','CY','48201','1967-09-11','F','R',':RET:2054-5','N','021','DEN','1586864','33348TX002000101','2014-01-01','2013-12-24 19:50:25','0.00',NULL,NULL,'128.55','128.55','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:51:48'),(4392,3491,'N','01','021','EC','A',NULL,NULL,'','0001051885','0000656909','','IL','1','Smith','Celeste','Adele','','','34','285661876','2070 JACQUELINE DR',0,'PARMA','OH','44134','6856','CY','39035','1973-03-10','F','',':RET:2106-3','N','021','DEN','232249','99734OH005000401','2014-01-01','2013-12-12 11:46:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:00:55'),(4394,3493,'Y','18','021','EC','A','','','AC','0000455293','0000455293','OH00001086385','IL','1','Robinson','TeArria','','','','34','298807730','924 OREGON AVE',0,'AKRON','OH','44314','2020','CY','39153','1983-03-09','F','U',':RET:2054-5','N','021','DEN','291341','99734OH005000401','2014-01-01','2013-12-12 13:13:35','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:00:58'),(4876,3867,'Y','18','021','EC','A','','','AC','0000315229','0000315229','TX00000597140','IL','1','Rasnic','Rhea','','','','34','406883570','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1970-06-27','M','U',NULL,'N','021','DEN','976957','33348TX002000201','2014-01-01','2013-10-10 01:37:42','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:31:08'),(15171,12123,'N','01','021','EC','A',NULL,NULL,'','0001006832','0000870639','','IL','1','DARBY','SUSAN','C','','','34','185467040','7 WHITEFRIARS DR',0,'AKRON','OH','44319',NULL,'CY','39153','1955-01-19','F','',':RET:2106-3','N','021','DEN','2397118','99734OH005000401','2014-02-01','2013-12-30 15:35:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:34'),(5554,4408,'Y','18','021','EC','A','','','AC','0000808618','0000808618','OH00000950787','IL','1','menchhofer','madelynn','nichole','','','34','291085952','605 ECHO ST',0,'CELINA','OH','45822','2305','CY','39107','2003-12-27','F','U',':RET:2106-3','N','021','HLT','166239','92036OH004001501','2014-01-01','2013-11-27 07:15:07','0.00',NULL,NULL,'112.38','112.38','R-OH002','OH0','112.38',NULL,0,'2013-12-25 23:16:13'),(13007,10366,'Y','18','021','EC','A','','','AC','0000602272','0000602272','OH00000254816','IL','1','Greene','Ryan','','','','34','269960116','5473 Kirby Rd',0,'Cincinnati','OH','45223',NULL,'CY','39061','1992-09-25','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','2489112','99734OH005000401','2014-01-01','2013-12-22 18:32:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:49:40'),(13593,10842,'N','01','021','EC','A',NULL,NULL,'','0001747612','0001968347','','IL','1','Natusicky','Kris','Patrick','','','34','433750390','11156 OAK RIDGE DR',0,'DENHAM SPRINGS','LA','70726','7108','CY','22063','1980-08-31','M','',':RET:2106-3','N','021','DEN','1970770','18575LA002000201','2014-01-01','2013-12-23 19:16:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:05:14'),(14987,11978,'Y','18','021','EC','A','','','AC','0000271734','0000271734','TX00001836431','IL','1','Arguellez','Guadalupe','','','','34','461988339','300 HUNTINGTON DR',0,'VICTORIA','TX','77905','5456','CY','48469','1956-12-12','F','U',':RET:2106-3','N','021','DEN','2295192','33348TX002000201','2014-02-01','2013-12-30 15:23:31','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-01 12:01:18'),(25727,20407,'Y','18','021','EC','A','','','AC','0002029265','0002029265','LA00003005985','IL','1','Busby','Cyndi','','','','34','436651252','114 Current Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1972-07-06','F','M',NULL,'N','021','DEN','2780474','18575LA002000201','2014-04-01','2014-02-24 13:20:13','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-26 09:30:32'),(26472,20998,'Y','18','021','EC','A','','','AC','0001934491','0001934491','LA00002887533','31','1','Mitchell','Emil','','','','34','433046356','P.O. Box 1106',0,'Gramercy','LA','70052',NULL,'CY','22093','1958-08-18','M','M',NULL,'N','021','DEN','2724786','18575LA002000101','2014-04-01','2014-02-27 15:55:56','0.00',NULL,NULL,'75.06','75.06','R-LA001','LA0','25.02','CIC',0,'2014-02-28 07:30:38'),(26655,21130,'N','19','021','EC','A',NULL,NULL,'','0000976793','0000803786','','IL','1','Barnette','Benjamin','','','','34','282064841','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2001-06-12','M','',':RET:2106-3','N','021','HLT','3502526','52664OH151001305','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:08'),(26693,21162,'N','19','021','EC','A',NULL,NULL,'','0001262234','0002127635','','IL','1','Canizales','Valerie','C','','','34','437737465','1614 JUNIPER DR',0,'SHREVEPORT','LA','71118','2214','CY','22017','1989-03-11','F','',':RET:2106-3','N','021','DEN','3758620','18575LA002000101','2014-04-01','2014-02-28 00:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 21:31:29'),(27837,22018,'Y','18','024','14','A','','','TE','0000367450','0000367450','','IL','1','Roth','Suzanne','Renee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-12','F','',NULL,NULL,NULL,'','3884289','','2014-03-05','2014-03-05 15:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:05'),(1741,1445,'Y','18','021','EC','A','','','AC','0000743090','0000743090','OH00001024926','IL','1','George','Jeffrey','','','','34','294521655','12489 STATE ROUTE 41 S',0,'GREENFIELD','OH','45123','9390','CY','39141','1953-11-13','M','M',':RET:2106-3','N','021','DEN','2491941','99734OH005000301','2014-01-01','2013-12-24 11:25:11','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:55:33'),(22736,18152,'N','01','021','EC','A',NULL,NULL,'','0001880829','0001799650','','IL','1','phan','chuong','thi','','','34','585811956','29795 hwy 23',0,'port sulpher','LA','70083',NULL,'CY','22075','1956-03-27','F','',':RET:2047-9','N','021','DEN','2828295','18575LA002000201','2014-03-01','2014-02-11 15:53:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:17'),(23009,18344,'Y','18','024','14','A','','','TE','0001709242','0001709242','','IL','1','London','Whitney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-07-04','F','',NULL,NULL,NULL,'','1648854','','2014-02-26','2014-02-11 19:49:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-12 21:30:22'),(4992,3961,'N','19','021','EC','A',NULL,NULL,'','0000327249','0000969419','','IL','1','Rice','Victoria','','','','34','293063338','5137 RIVERVIEW DR',0,'SOUTH LEBANON','OH','45065','8782','CY','39165','2001-12-24','F','',':RET:2106-3','N','021','DEN','272020','99734OH005000301','2014-01-01','2013-12-06 21:42:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:58'),(6176,4894,'Y','18','021','EC','A','','','AC','0000016576','0000016576','OH00000209473','IL','1','JONES','ALBERTA','','','','34','280683950','1150 PITKIN AVE',0,'AKRON','OH','44310','1121','CY','39153','1971-01-14','F','U',NULL,'N','021','HLT','207046','52664OH151001501','2014-01-01','2013-10-02 13:50:13','223.00',NULL,NULL,'354.39','131.39','R-OH012','OH0','354.39',NULL,0,'2013-12-26 00:17:11'),(17880,14280,'Y','18','021','EC','A','','','AC','0000011183','0000011183','OH00001595287','IL','1','FENIMORE','TONIMARIE','F','','','34','287807059','6669 NANCY DR',0,'NORTH OLMSTED','OH','44070','4949','CY','39035','1981-06-27','F','M',':RET:2106-3','N','021','DEN','2031028','99734OH005000401','2014-02-01','2014-01-14 14:29:12','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(13589,10839,'Y','18','021','EC','A','','','AC','0001560118','0001560118','LA00000180114','IL','1','Smith','Scott','','','','34','439454140','716 CAROL MARIE DR',0,'BATON ROUGE','LA','70806','5615','CY','22033','1982-03-01','M','U',':RET:2106-3','N','021','DEN','1865678','18575LA002000201','2014-01-01','2013-12-23 18:57:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:05:07'),(17533,14018,'Y','18','021','EC','A','','','AC','0000435943','0000435943','MS00001511658','IL','1','Lang','Margaret','','','','34','425210543','6997 HIGHWAY 510',0,'SHUBUTA','MS','39360','8815','CY','28023','1962-06-18','F','R',':RET:2054-5','N','021','DEN','2556002','46300MS002000201','2014-02-01','2014-01-12 10:58:44','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-13 03:01:44'),(14774,11797,'Y','18','024','14','A','','','TE','0000781445','0000781445','','IL','1','miranda miranda','janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-10-18','F','',NULL,NULL,NULL,'','1397558','','2013-12-23','2013-12-23 20:32:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:13:02'),(15056,12034,'Y','18','021','EC','A','','','AC','0002089494','0002089494','LA00001994614','IL','1','Gilmore','Ramona','','','','34','434947646','131 OAK HAVEN LN',0,'COLUMBIA','LA','71418','7662','CY','22021','1957-08-18','F','M',':RET:2106-3','N','021','DEN','1576221','18575LA002000201','2014-02-01','2013-12-30 14:50:13','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:03:24'),(28352,22432,'N','01','021','EC','A',NULL,NULL,'','0000227251','0000629749','','IL','1','Ibanez Lira','Reina','Lucero','','','34','728956274','8107 NELLIE ST',0,'HOUSTON','TX','77022','3455','CY','48201','1981-11-20','F','',NULL,'N','021','DEN','3281182','33348TX002000201','2014-04-01','2014-03-07 13:06:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-07 21:30:23'),(2259,1851,'N','19','021','EC','A',NULL,NULL,'','0000909454','0001121369','','IL','1','Andreadis','Brevin','','','','34','288067238','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','2001-10-05','M','',':RET:2106-3','N','021','DEN','19816','99734OH005000301','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:13'),(23275,18555,'Y','18','021','EC','A','','','AC','0000582236','0000582236','MS00002267032','IL','1','Bradberry','Barton',NULL,NULL,NULL,NULL,NULL,'63 BOB CHEEKS RD',0,'ELLISVILLE','MS','39437','8600','CY','28067','1965-04-22','M','U',NULL,'T','021','DEN','3460460','46300MS002000101','2014-03-01','2014-02-13 12:03:09','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15','CIC',0,'2014-02-13 21:30:14'),(9704,7686,'Y','18','021','EC','A','','','AC','0000303357','0000303357','OH00000954006','31','1','Steiner','Maria','','','','34','300769625','PO Box 37',0,'Jerry City','OH','43437',NULL,'CY','39173','1976-12-17','F','R',':RET:2036-2^:RET:2028-9','N','021','HLT','2217894','92036OH001002601','2014-01-01','2013-12-21 15:42:51','0.00',NULL,NULL,'291.18','291.18','R-OH001','OH0','291.18',NULL,0,'2013-12-26 04:40:03'),(22730,18149,'Y','18','024','14','A','','','TE','0001356215','0001356215','','IL','1','watson','zenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-06-06','F','',NULL,NULL,NULL,'','3604579','','2014-02-11','2014-02-11 15:46:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-11 21:01:15'),(18988,15127,'N','19','021','EC','A',NULL,NULL,'','0000551443','0000177659','','S1','1','Bernstein','Jeffrey','','','','34','270044765','2175 CAMPUS RD',0,'BEACHWOOD','OH','44122','1216','CY','39035','1998-10-18','F','',':RET:2106-3','N','021','HLT','2281072','52664OH151001304','2014-03-01','2014-01-17 11:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-01-20 08:06:10'),(15336,12265,'N','01','021','EC','A',NULL,NULL,'','0000710157','0000869294','','IL','1','Johnson','Rebecca','Gail','','','34','513801927','9344 ROCKY WATER CT',0,'SYLVANIA','OH','43560','9225','CY','39095','1965-10-22','F','',':RET:2106-3','N','021','HLT','2148800','92036OH005002601','2014-02-01','2014-01-01 15:35:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','318.82',NULL,1,'2014-01-02 04:24:04'),(7470,5911,'N','01','021','EC','A',NULL,NULL,'','0000103874','0000739007','','IL','1','Tunstall','Violet','','','','34','283625326','9095 FOXHUNTER LN',0,'CINCINNATI','OH','45242','4631','CY','39061','1958-08-18','F','',':RET:2106-3','N','021','DEN','1004010','99734OH005000401','2014-01-01','2013-12-14 20:12:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:10'),(7462,5905,'Y','18','021','EC','A','','','AC','0000052321','0000052321','MS00000236640','IL','1','Jackson','Jillian','','','','34','425755755','930 Forest Drive',0,'Brandon','MS','39042',NULL,'CY','28121','1984-01-23','F','M',NULL,'N','021','DEN','746039','46300MS002000201','2014-01-01','2013-12-15 09:19:33','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:30:57'),(6967,5529,'N','01','021','EC','A',NULL,NULL,'','0001096764','0001019278','','IL','1','SYNDER','KRISTAIN','','','','34','293820273','976 W WEBB RD',0,'MERIAL RIDGE','OH','44440',NULL,'CY','39155','1970-06-17','F','',NULL,'N','021','DEN','1819156','99734OH005000401','2014-01-01','2013-12-24 22:46:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:22'),(13731,10958,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00000286845','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','1557898','52664OH151001305','2014-01-01','2013-12-23 18:22:26','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:26'),(14184,11309,'Y','18','021','EC','A','','','AC','0000948962','0000948962','TX00000206961','IL','1','FRY','JACQULEINE','','','','34','269928710','103 E 30TH ST',0,'AUSTIN','TX','78705','3905','CY','48453','1987-09-13','F','U',NULL,'N','021','DEN','2170584','33348TX002000201','2014-02-01','2013-12-26 10:52:55','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-27 02:03:48'),(26609,21098,'Y','18','024','14','A','','','TE','0000896513','0000896513','','IL','1','Aguilar','Adrian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-01-13','M','',NULL,NULL,NULL,'','2812421','','2014-02-27','2014-02-27 22:54:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:46'),(26722,21182,'N','01','021','EC','A',NULL,NULL,'','0000186910','0000711130','','IL','1','COLEMAN','JERRY','','','','34','587270247','6019 SAMANTHA DR',0,'JACKSON','MS','39209','3590','CY','28049','1973-05-01','M','',NULL,'N','021','DEN','3720383','46300MS002000101','2014-03-01','2014-02-28 15:58:46',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-28 21:31:45'),(22177,17699,'Y','18','021','EC','A','','','AC','0000376178','0000376178','OH00001735668','IL','1','landrum','jessica','','','','34','301840420','51 SAN RAFAEL AVE',0,'TOLEDO','OH','43607','2413','CY','39095','1987-01-07','F','R',':RET:2106-3','N','021','HLT','2856339','92036OH006002601','2014-03-01','2014-02-08 13:16:36','0.00',NULL,NULL,'260.26','260.26','R-OH001','OH0','162.06','CIC',0,'2014-02-08 19:30:09'),(19148,15255,'N','01','021','EC','A',NULL,NULL,'','0000618990','0000881218','','IL','1','Sandoval','Angel','','','','34','466971122','68 CAMELLIA WAY',0,'SAN ANTONIO','TX','78209','2018','CY','48029','1962-09-02','M','',':RET:2106-3','N','021','DEN','1589836','33348TX002000101','2014-03-01','2014-01-18 19:44:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-21 08:45:33'),(13073,10421,'Y','18','021','EC','A','','','AC','0000828229','0000828229','OH00000389841','IL','1','vespucci','vincent','tom','','','34','270964563','1163 WASHINGTON BLVD',0,'MAYFIELD HTS','OH','44124','1623','CY','39035','1992-08-10','M','U',':RET:2106-3','T','021','DEN','1712991','99734OH005000401','2014-01-01','2013-12-23 10:24:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:22'),(8896,7054,'Y','18','021','EC','A','','','AC','0000131138','0000131138','TX00000867226','31','1','Hale','Tonia','','','','34','454153910','PO Box 931',0,'Whitney','TX','76692',NULL,'CY','48217','1953-09-03','F','U',':RET:2106-3','N','021','DEN','2586040','33348TX002000201','2014-01-01','2013-12-18 18:07:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:02:09'),(18669,14883,'Y','18','024','14','A','','','TE','0001007906','0001007906','','IL','1','Carther','LaNetra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-12-16','F','',NULL,NULL,NULL,'','2085314','','2014-01-16','2014-01-16 18:20:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:16'),(4313,3429,'Y','18','021','EC','A','','','AC','0000093834','0000093834','OH00000899819','IL','1','davis','teresa','','','','34','294745384','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1962-12-18','F','M',':RET:2106-3','T','021','HLT','1806855','92036OH003001201','2014-01-01','2013-12-17 07:29:50','240.00',NULL,NULL,'989.73','749.73','R-OH004','OH0','480.83',NULL,0,'2013-12-25 21:52:37'),(6153,4878,'Y','18','021','EC','A','','','AC','0000355080','0000355080','TX00000370214','31','1','Foster','Denisha','','','','34','467993111','PO Box 688',0,'Pearland','TX','77588',NULL,'CY','48039','1988-02-27','F','U',':RET:2054-5','N','021','DEN','226370','33348TX002000101','2014-01-01','2013-11-21 15:20:51','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 00:16:34'),(18577,14813,'N','01','021','EC','A',NULL,NULL,'','0000618388','0000870654','','IL','1','Youssefi','Kouroush','','','','34','278785665','1216 MAGDALYN DR',0,'AKRON','OH','44320','1426','CY','39153','1960-03-03','M','',':RET:2106-3','N','021','HLT','2686554','52664OH152000901','2014-02-01','2014-01-15 15:43:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','333.21',NULL,0,'2014-01-16 08:47:06'),(17008,13614,'Y','18','021','EC','A','','','AC','0000336440','0000336440','OH00001654405','IL','1','OCONNOR','DIANE','','','','34','283609815','2927 8 ROUTE 756',0,'FELICITY','OH','45120',NULL,'CY','39025','1960-08-21','F','M',NULL,'N','021','DEN','1455946','99734OH005000301','2014-02-01','2014-01-09 13:42:15','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-01-13 02:20:35'),(5159,4090,'Y','18','021','EC','A','','','AC','0000234042','0000234042','OH00001011733','IL','1','Martin','Jennifer','','','','34','592280204','6119 W. River Rd. S.',0,'Elyria','OH','44035',NULL,'CY','39093','1971-10-31','F','U',':RET:2106-3','N','021','DEN','2564256','99734OH005000401','2014-01-01','2013-12-19 10:37:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:00'),(4772,3786,'Y','18','021','EC','A','','','AC','0000255936','0000255936','OH00000519885','IL','1','Emery','Hazel','','','','34','382686257','935 KIRKWALL DR',0,'COPLEY','OH','44321','1724','CY','39153','1963-02-02','F','U',':RET:2106-3','T','021','DEN','1064964','99734OH005000401','2014-01-01','2013-12-08 13:56:40','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:15:51'),(16661,13332,'Y','18','021','EC','A','','','AC','0001341747','0001341747','LA00002357919','IL','1','Gallegos','Soraya','','','','34','464975216','P.O. 273',0,'Saint Francisville','LA','70775',NULL,'CY','22125','1986-01-21','F','U',NULL,'N','021','DEN','1859139','18575LA002000101','2014-02-01','2014-01-07 12:26:36','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-08 18:24:24'),(15514,12412,'Y','18','021','EC','A','','','AC','0002177764','0002177764','LA00000013097','IL','1','Lemmond','Wanda','M','','','34','435743490','1005 BRENDA CIR',0,'MINDEN','LA','71055','8306','CY','22119','1949-10-01','F','U',':RET:2106-3','N','021','DEN','1879476','18575LA002000201','2014-02-01','2013-12-30 18:45:18','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,1,'2014-01-02 04:30:07'),(800,661,'Y','18','024','14','A','','','TE','0000093404','0000093404','','IL','1','Williams','Melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-02','F','',NULL,NULL,NULL,'','2378240','','2013-12-16','2013-12-16 17:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:05:32'),(13423,10710,'Y','18','021','EC','A','','','AC','0000540299','0000540299','OH00000508723','IL','1','Mecklenborg','Evan','','','','34','300980342','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','1980-07-19','M','M',NULL,'N','021','DEN','2321841','99734OH005000301','2014-01-01','2013-12-23 11:34:57','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:52'),(23922,19023,'Y','18','021','EC','A','','','AC','0000582237','0000582237','MS00002368787','IL','1','Totten','Lorine','','','','34','408920898','127 WILLIAMS RD',0,'BYHALIA','MS','38611','8492','CY','28093','1951-03-16','F','U',':RET:2054-5','N','021','DEN','3846055','46300MS002000201','2014-03-01','2014-02-14 12:44:36','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85','CIC',0,'2014-02-14 22:00:06'),(16979,13589,'Y','18','021','EC','A','','','AC','0001117196','0001117196','MS00002050943','IL','1','Msonthi','Khambile','Mercy','','','34','740863050','1861 BELVEDERE DR',0,'JACKSON','MS','39204','4707','CY','28049','1978-04-22','F','M',':RET:2054-5','N','021','DEN','2127563','46300MS002000201','2014-02-01','2014-01-09 11:48:45','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:20:17'),(15857,12696,'Y','18','021','EC','A','','','AC','0000916971','0000916971','OH00001819767','IL','1','HICKS','MADISON','','','','34','270946896','2903 S MAIN ST',0,'AKRON','OH','44319','1848','CY','39153','1991-03-06','F','U',':RET:2106-3','N','021','HLT','1737882','52664OH151001306','2014-02-01','2014-01-02 11:21:08','100.00',NULL,NULL,'223.01','123.01','R-OH012','OH0','223.01',NULL,0,'2014-01-03 02:04:37'),(15797,12644,'N','01','021','EC','A',NULL,NULL,'','0001867134','0001597932','','IL','1','Huynh','Hung','Thanh','','','34','510025017','5202 Raval St.',0,'New Orleans','LA','70129',NULL,'CY','22071','1974-12-21','M','',NULL,'N','021','DEN','1480515','18575LA002000201','2014-02-01','2014-01-02 18:01:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-03 02:02:43'),(3588,2878,'Y','18','021','EC','A','','','AC','0000959095','0000959095','OH00000762531','IL','1','ORRA','AMNE','','','','34','291741463','1964 NEWBURY DR',0,'WESTLAKE','OH','44145','3333','CY','39035','1954-04-08','F','U',':RET:2106-3','N','021','HLT','2096087','92036OH005000804','2014-01-01','2013-12-22 10:20:27','362.00',NULL,NULL,'608.59','246.59','R-OH011','OH0','608.59',NULL,0,'2013-12-25 21:22:56'),(7732,6124,'Y','18','021','EC','A','','','AC','0000599749','0000599749','OH00000981525','IL','1','BROOKS','Michael','','','','34','292747529','1674 PRAIRIE RD',0,'WILMINGTON','OH','45177','9531','CY','39027','1965-03-30','M','U',NULL,'N','021','DEN','2101212','99734OH005000401','2014-01-01','2013-12-20 15:08:21','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:02:02'),(6865,5444,'Y','18','021','EC','A','','','AC','0000219950','0000219950','OH00000661367','IL','1','Solomon','Gary','Alan','','','34','300544777','4086 PARKSIDE DR',0,'BROOKLYN','OH','44144','1316','CY','39035','1954-02-15','M','M',':RET:2106-3','N','021','HLT','682864','92036OH004000801','2014-01-01','2013-11-03 09:06:23','71.00',NULL,NULL,'489.35','418.35','R-OH011','OH0','489.35',NULL,0,'2013-12-26 01:31:47'),(6631,5259,'Y','18','021','EC','A','','','AC','0000934639','0000934639','OH00000522437','IL','1','Williams','Teresa','','','','34','300821956','311 ARLINGTON RD',0,'BROOKVILLE','OH','45309','1322','CY','39113','1971-06-27','F','U',NULL,'N','021','HLT','790128','92036OH004000501','2014-01-01','2013-12-11 17:10:22','0.00',NULL,NULL,'253.26','253.26','R-OH003','OH0','253.26',NULL,0,'2013-12-26 00:54:21'),(3913,3131,'Y','18','021','EC','A','','','AC','0000088343','0000088343','TX00000656463','IL','1','cardenas','blanca','','','','34','455811024','4415 NAVAJO ST',0,'PASADENA','TX','77504','3421','CY','48201','1980-12-11','F','M',NULL,'N','021','DEN','714271','33348TX002000101','2014-01-01','2013-12-13 11:56:44','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 21:37:09'),(5813,4618,'N','19','021','EC','A',NULL,NULL,'','0000953700','0001075422','','IL','1','Livingston','Janie','Elisabeth','','','34','642220301','159 VZ COUNTY ROAD 3443',0,'WILLS POINT','TX','75169','9272','CY','48467','1990-12-20','F','',':RET:2106-3','N','021','DEN','1633466','33348TX002000201','2014-01-01','2013-12-23 21:51:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:47:50'),(3670,2936,'Y','18','021','EC','A','','','AC','0000336409','0000336409','OH00000816833','IL','1','Dormish','Jon','','','','34','300720587','52143 Boston Hill Rd',0,'Sardis','OH','43946',NULL,'CY','39111','1960-05-16','M','U',NULL,'N','021','DEN','40656','99734OH005000401','2014-01-01','2013-12-12 20:55:23','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:31:08'),(27466,21737,'Y','18','021','EC','A','','','AC','0000938591','0000938591','OH00003038877','IL','1','Alexander','Tia','','','','34','283788574','9 E MARTHA JEAN DR',0,'AMELIA','OH','45102','1416','CY','39025','1981-01-16','F','M',':RET:2106-3','N','021','HLT','3554078','92036OH003000605','2014-04-01','2014-03-03 20:59:37','215.00',NULL,NULL,'492.74','277.74','R-OH005','OH0','268.56',NULL,0,'2014-03-04 21:02:08'),(27906,22077,'N','19','021','EC','A',NULL,NULL,'','0000698591','0000073162','','IL','1','Larry','Khalla','','','','34','641389093','929 WHITEWATER TRL',0,'DESOTO','TX','75115','5444','CY','48113','1993-11-04','F','',NULL,'N','021','DEN','3811459','33348TX002000201','2014-04-01','2014-03-05 19:11:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-06 21:00:12'),(28357,22437,'Y','18','021','EC','A','','','AC','0001123826','0001123826','TX00003169597','IL','1','Madrid','Michael','','','','34','641090055','289 BRIGGS BLVD',0,'POINT','TX','75472','7141','CY','48379','1989-10-08','M','M',':RET:2106-3','N','021','DEN','4200488','33348TX002000201','2014-04-01','2014-03-07 14:00:52','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:26'),(307,252,'N','G8','021','EC','A',NULL,NULL,'','0000124058','0001211846','','IL','1','marivani','Ariadne','','','','34','642221600','5623 STAR VIEW DR',0,'EL PASO','TX','79912','6427','CY','48141','1990-05-14','F','',':RET:2106-3','N','021','DEN','555509','33348TX002000101','2014-01-01','2013-11-12 18:19:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 17:30:57'),(24069,19141,'Y','18','021','EC','A','','','AC','0000840577','0000840577','OH00002319616','IL','1','Frank','Charla','','','','34','286462792','878 Pinehurst Lane',0,'Akron','OH','44313',NULL,'CY','39153','1965-01-19','F','U',':RET:2106-3','T','021','HLT','2824234','52664OH151001306','2014-03-01','2014-02-15 08:40:20','294.00',NULL,NULL,'437.52','143.52','R-OH012','OH0','437.52',NULL,0,'2014-02-15 22:01:15'),(23834,18965,'Y','18','021','EC','A','','','AC','0000775131','0000775131','OH00001691852','IL','1','Kehling','Tammy','','','','34','276800485','1167 BISHOP AVE',0,'HAMILTON','OH','45015','2165','CY','39017','1966-03-30','F','U',':RET:2106-3','N','021','HLT','3243040','92036OH003001205','2014-03-01','2014-02-13 20:39:42','397.00',NULL,NULL,'635.12','238.12','R-OH004','OH0','350.40',NULL,0,'2014-02-14 21:31:48'),(17446,13954,'N','19','021','EC','A',NULL,NULL,'','0000336444','0000414713','','IL','1','Terrell','Cameron',NULL,NULL,NULL,NULL,NULL,'2033 UPTON AVE',0,'TOLEDO','OH','43607','1644','CY','39095','1993-06-07','M','',':RET:2054-5','N','021','HLT','1856745','92036OH004002601','2014-02-01','2014-01-10 16:51:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-01-13 03:00:37'),(2789,2254,'Y','18','021','EC','A','','','AC','0001109197','0001109197','OH00001252509','IL','1','Bender','Abigail','','','','34','296803345','3919 CHIPPLEGATE RD',0,'TOLEDO','OH','43614','5405','CY','39095','1980-11-01','F','U',':RET:2106-3','T','021','HLT','321201','92036OH004002601','2014-01-01','2013-12-02 16:35:53','195.00',NULL,NULL,'216.00','21.00','R-OH001','OH0','216.00',NULL,0,'2013-12-25 19:50:04'),(15665,12534,'Y','18','024','14','A','','','TE','0000211977','0000211977','','IL','1','Vann','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-07','F','',NULL,NULL,NULL,'','2422273','','2013-12-31','2013-12-31 17:21:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:34:35'),(9628,7626,'Y','18','021','EC','A','','','AC','0000303355','0000303355','OH00000150508','IL','1','Hollibaugh','Kim','','','','34','265353726','1156 Yukon Ave.',0,'Akron','OH','44320',NULL,'CY','39153','1957-04-27','F','U',':RET:2106-3','T','021','HLT','2452861','52664OH152000901','2014-01-01','2013-12-20 22:52:43','300.00',NULL,NULL,'438.23','138.23','R-OH012','OH0','438.23',NULL,0,'2013-12-26 04:38:07'),(24402,19383,'Y','18','021','EC','A','','','AC','0000726179','0000726179','OH00002912728','IL','1','CARTINO','TIMOTHY','','','','34','273708093','34138 GAIL DR',0,'NORTH RIDGEVILLE','OH','44039','3110','CY','39093','1973-11-12','M','U',NULL,'N','021','DEN','3290439','99734OH005000401','2014-04-01','2014-02-18 14:28:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:00:55'),(25127,19931,'Y','18','021','EC','A','','','AC','0002048902','0002048902','LA00001908345','IL','1','Slocum','Tommy','a','','','34','434575266','10626 LANDSBURY AVE',0,'BATON ROUGE','LA','70809','2829','CY','22033','1968-12-05','M','U',':RET:2106-3','N','021','DEN','3725235','18575LA002000201','2014-04-01','2014-02-21 12:55:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61','CIC',0,'2014-02-21 21:30:24'),(26069,20673,'Y','18','021','EC','A','','','AC','0000812076','0000812076','OH00001885858','IL','1','Johnson','Kathleen','','','','34','283662727','4351 DEBRA CT',0,'TOLEDO','OH','43615','6239','CY','39095','1958-12-24','F','U',NULL,'N','021','HLT','3208361','92036OH001002601','2014-04-01','2014-02-26 14:43:57','202.00',NULL,NULL,'524.52','322.52','R-OH001','OH0','524.52',NULL,0,'2014-02-26 21:02:43'),(29100,23033,'Y','18','021','EC','A','','','AC','0001026998','0001026998','OH00002891835','IL','1','Dunseith','Phillip','','','','34','274520256','3035 North Gath Road',0,'Sardinia','OH','45171',NULL,'CY','39071','1954-01-15','M','M',':RET:2106-3','T','021','HLT','3314180','92036OH004000601','2014-04-01','2014-03-10 11:26:45','303.00',NULL,NULL,'538.73','235.73','R-OH005','OH0','538.73',NULL,0,'2014-03-10 21:02:16'),(29123,23055,'N','01','021','EC','A',NULL,NULL,'','0000205856','0001016918','','IL','1','Klein','Meghan','Duffey','','','34','275758947','2548 INDIAN MOUND AVE',0,'NORWOOD','OH','45212','1759','CY','39061','1978-06-02','F','',':RET:2106-3','N','021','HLT','2906811','92036OH002001201','2014-04-01','2014-03-10 09:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.93',NULL,0,'2014-03-10 21:02:32'),(20933,16730,'Y','18','021','EC','A','','','AC','0000646031','0000646031','OH00002441297','IL','1','Mathew','Thomas','','','','34','275928045','317 ELIZABETH ST',0,'CONVOY','OH','45832','0131','CY','39161','1990-04-21','M','U',':RET:2106-3','N','021','HLT','1448708','92036OH006001501','2014-03-01','2014-01-31 13:35:24','166.00',NULL,NULL,'174.54','8.54','R-OH002','OH0','174.54',NULL,0,'2014-01-31 21:01:38'),(4697,3724,'Y','18','021','EC','A','','','AC','0001125418','0001125418','OH00000009683','IL','1','Thomas','Donna','','','','34','280541550','7396 AULD RD',0,'BRADFORD','OH','45308','9507','CY','39037','1954-06-14','F','U',':RET:2106-3','N','021','HLT','752515','92036OH005000506','2014-01-01','2013-12-12 16:46:39','595.00',NULL,NULL,'618.76','23.76','R-OH003','OH0','618.76',NULL,0,'2013-12-25 22:08:19'),(6953,5522,'Y','18','021','EC','A','','','AC','0000948420','0000948420','OH00000074447','IL','1','Colagross','Lisa','','','','34','287668964','14181 PAINESVILLE WARREN RD',0,'PAINESVILLE','OH','44077','9771','CY','39085','1970-05-19','F','M',':RET:2106-3','T','021','DEN','2083819','99734OH005000401','2014-01-01','2013-12-24 21:39:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:05'),(4651,3687,'Y','18','021','EC','A','','','AC','0000611939','0000611939','OH00001313103','IL','1','Hamilton','Jesse','','','','34','401119987','92 W MAIN ST',0,'SARDINIA','OH','45171','8001','CY','39071','1961-03-01','M','U',':RET:2106-3','N','021','HLT','83272','92036OH003000601','2014-01-01','2013-12-12 11:51:31','78.00',NULL,NULL,'437.59','359.59','R-OH005','OH0','437.59',NULL,0,'2013-12-25 22:07:05'),(4910,3895,'Y','18','021','EC','A','','','AC','0000708064','0000708064','TX00000709124','IL','1','Przeslak','Carrie','','','','34','380989117','5602 48th Street',0,'Lubbock','TX','79414',NULL,'CY','48303','1971-11-22','F','U',':RET:2106-3','N','021','DEN','236462','33348TX002000201','2014-01-01','2013-10-26 12:40:56','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 22:32:04'),(5872,4660,'Y','18','021','EC','A','','','AC','0000100065','0000100065','OH00001401514','IL','1','newberry','roy',NULL,NULL,NULL,NULL,NULL,'690 greenville- nashville rd.',0,'greenville','OH','45331',NULL,'CY','39037','1964-12-09','M','M',':RET:2106-3','T','021','HLT','2059567','92036OH005000504','2014-01-01','2013-12-23 21:52:52','738.00',NULL,NULL,'1020.92','282.92','R-OH003','OH0','466.36',NULL,0,'2013-12-25 23:49:15'),(24172,19204,'Y','18','021','EC','A','','','AC','0000763567','0000763567','OH00001448372','IL','1','Russell','Thomas','','','','34','296562674','5211 SHEILA DR',0,'TOLEDO','OH','43613','2441','CY','39095','1961-10-21','M','M',':RET:2106-3','N','021','HLT','2897387','92036OH006002601','2014-03-01','2014-02-15 16:20:41','0.00',NULL,NULL,'511.71','511.71','R-OH001','OH0','301.86',NULL,0,'2014-02-15 22:02:10'),(22285,17790,'Y','18','021','EC','A','','','AC','0000878294','0000878294','OH00001680620','IL','1','Payne Riley','Brenda','','','','34','288707541','11807 Browning Ave.',0,'Cleveland','OH','44120',NULL,'CY','39035','1963-01-27','F','M',':RET:2054-5','N','021','DEN','2652751','99734OH005000401','2014-03-01','2014-01-28 12:04:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 11:00:25'),(21720,17344,'Y','18','021','EC','A','','','AC','0001077792','0001077792','OH00002340229','IL','1','Allaer','Paul','','','','34','577117066','9669 Lansford Drive',0,'Cincinnati','OH','45242',NULL,'CY','39061','1960-08-01','M','R',':RET:2106-3','N','021','HLT','3335496','92036OH004001201','2014-03-01','2014-02-05 15:48:55','0.00',NULL,NULL,'352.13','352.13','R-OH004','OH0','352.13',NULL,0,'2014-02-05 21:31:19'),(1688,1410,'Y','18','021','EC','A','','','AC','0001793413','0001793413','LA00001422505','IL','1','Downs','Sheryl','','','','34','436252751','5101 Naff Avenue',0,'Bastrop','LA','71220',NULL,'CY','22067','1961-04-03','F','U',':RET:2054-5','N','021','DEN','2132255','18575LA002000101','2014-01-01','2013-12-24 16:55:31','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 18:54:22'),(19697,15695,'N','01','021','EC','A',NULL,NULL,'','0001196737','0000490500','','IL','1','Seymore','Barbara','','','','34','450171649','104 HUGHES ST',0,'HEARNE','TX','77859','2039','CY','48395','1954-10-20','F','',':RET:2054-5','N','021','DEN','1855708','33348TX002000201','2014-03-01','2014-01-23 11:58:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 21:00:45'),(19569,15600,'N','01','021','EC','A',NULL,NULL,'','0001781676','0002270838','','IL','1','APARICIO','ENRIQUE','','','','34','433112839','2716 HERO DR',0,'GRETNA','LA','70053','7530','CY','22051','1952-07-15','M','',NULL,'N','021','DEN','2848313','18575LA002000201','2014-03-01','2014-01-22 14:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 03:02:36'),(4720,3741,'Y','18','024','14','A','','','TE','0000142794','0000142794','','IL','1','Self-Stoehr','Lesha','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-26','F','',NULL,NULL,NULL,'','590324','','2013-12-12','2013-12-12 15:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:08:55'),(19388,15456,'Y','18','021','EC','A','','','AC','0001236606','0001236606','OH00002399817','IL','1','Vignos','Douglas','','','','34','294627675','303 WESTLAND AVE NW',0,'MASSILLON','OH','44646','3375','CY','39151','1957-04-22','M','U',':RET:2106-3','T','021','DEN','2757005','99734OH005000401','2014-03-01','2014-01-21 11:00:35','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,1,'2014-01-22 03:22:46'),(14497,11565,'Y','18','021','EC','A','','','AC','0000371999','0000371999','TX00001685849','IL','1','Williams-Moore','Floydie',NULL,NULL,NULL,NULL,NULL,'1008 N WEATHERFORD ST',0,'MIDLAND','TX','79701','3511','CY','48329','1964-12-23','F','U',':RET:2054-5','N','021','DEN','1510852','33348TX002000201','2014-02-01','2013-12-27 13:39:05','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-28 03:33:40'),(13167,10503,'Y','18','021','EC','A','','','AC','0000378574','0000378574','OH00000605378','IL','1','Burne','Jeremy','','','','34','291889179','6092 WILLOW LAKE DR',0,'HUDSON','OH','44236','3971','CY','39153','1960-03-20','M','R',NULL,'N','021','DEN','2565901','99734OH005000401','2014-01-01','2013-12-23 18:26:47','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:53:59'),(13226,10552,'Y','18','021','EC','A','','','AC','0001015398','0001015398','TX00000614471','IL','1','Campbell','Michael','','','','34','360487198','9815 Copper Creek Drive',0,'Austin','TX','78729',NULL,'CY','48491','1956-09-12','M','U',':RET:2106-3','N','021','DEN','1889883','33348TX002000201','2014-01-01','2013-12-22 21:06:40','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:55:37'),(27536,21784,'N','19','021','EC','A',NULL,NULL,'','0000616885','0000675512','','S1','1','THIERET','JAMES','J',NULL,NULL,NULL,NULL,'7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','2006-11-29','M','',':RET:2106-3','N','021','DEN','3776480','99734OH005000401','2014-04-01','2014-03-03 18:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:05'),(27928,22092,'Y','18','021','EC','A','','','AC','0001192079','0001192079','TX00003045152','IL','1','Mugno','Terece','','','','34','455151426','1227 Ottawa Dr.',0,'Richardson','TX','75080',NULL,'CY','48113','1968-04-02','F','U',':RET:2106-3','N','021','DEN','3382307','33348TX002000201','2014-04-01','2014-03-06 10:38:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:24'),(22472,17944,'Y','18','021','EC','A','','','AC','0000079717','0000079717','MS00001985874','IL','1','Knoth','Stephanie','','','','34','541846322','2009 TEMPLE RD',0,'MAGNOLIA','MS','39652','8004','CY','28113','1958-12-26','F','U',NULL,'N','021','DEN','3570708','46300MS002000101','2014-03-01','2014-02-10 13:02:51','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-10 21:30:59'),(21196,16939,'Y','18','021','EC','A','','','AC','0000375748','0000375748','MS00001943142','IL','1','Goodine','Wayne','','','','34','428437793','101 BELLE CT',0,'MADISON','MS','39110','6928','CY','28089','1954-02-27','M','M',':RET:2106-3','N','021','DEN','3800683','46300MS002000101','2014-03-01','2014-02-03 16:57:46','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-02-03 21:00:51'),(19602,15625,'N','19','021','EC','A',NULL,NULL,'','0000727314','0000720277','','IL','1','SPORLEDER','KEITH','AUSTIN','','','34','270049984','6020 MAIN ST',0,'SYLVANIA','OH','43560','1265','CY','39095','1997-04-24','M','',':RET:2106-3','N','021','HLT','2809126','92036OH005002604','2014-03-01','2014-01-22 10:49:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-01-23 03:02:48'),(2032,1663,'N','01','021','EC','A',NULL,NULL,'','0000240323','0001028050','','IL','1','Mankowski','Henry','G','','','34','278507180','2666 ROCKLYN RD',0,'SHAKER HEIGHTS','OH','44122','2124','CY','39035','1951-10-04','M','',':RET:2106-3','N','021','HLT','176084','52664OH152000901','2014-01-01','2013-12-10 16:57:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','529.28',NULL,0,'2013-12-25 19:15:22'),(19424,15484,'Y','18','024','14','A','','','TE','0000433900','0000433900','','IL','1','NING','KAM',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-14','M','',NULL,NULL,NULL,'','1792571','','2014-01-21','2014-01-21 14:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:23:03'),(5772,4585,'Y','18','021','EC','A','','','AC','0000278326','0000278326','OH00001498592','IL','1','Walsh','Kim','','','','34','302869780','9204 Hickory Ridge Drive',0,'Streetsboro','OH','44241',NULL,'CY','39133','1978-07-26','F','U',':RET:2106-3','N','021','DEN','2105170','99734OH005000401','2014-01-01','2013-12-23 22:40:40','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:46:49'),(5641,4475,'Y','18','021','EC','A','','','AC','0000086224','0000086224','TX00000663783','IL','1','Lenertz','Joseph','','','','34','457416990','606 W MARKET ST',0,'ROCKPORT','TX','78382','4932','CY','48007','1965-12-03','M','U',':RET:2106-3','N','021','DEN','136263','33348TX002000201','2014-01-01','2013-11-26 12:15:09','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 23:31:15'),(4217,3355,'Y','18','024','14','A','','','TE','0000390597','0000390597','','IL','1','HUTCHINSON','CARLIE','ROSE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-12-21','F','',NULL,NULL,NULL,'','2559084','','2013-12-17','2013-12-17 09:22:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:50:19'),(4466,3548,'Y','18','021','EC','A','','','AC','0000639477','0000639477','OH00000345246','IL','1','Burgwald','Susan','','','','34','277527805','4295 CASA BELLA DR',0,'PERRY','OH','44081','9749','CY','39085','1951-06-15','F','U',':RET:2106-3','N','021','DEN','925048','99734OH005000301','2014-01-01','2013-12-12 13:54:36','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:44'),(18010,14392,'N','01','021','EC','A',NULL,NULL,'','0000773998','0000646013','','IL','1','PRESUTTI','TOMMASO','','','','34','301585384','8351 LONDON GROVEPORT RD',0,'GROVE CITY','OH','43123','8817','CY','39049','1957-04-16','M','',':RET:2106-3','N','021','DEN','1851721','99734OH005000301','2014-02-01','2014-01-14 11:12:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:03'),(14489,11559,'Y','18','021','EC','A','','','AC','0000281753','0000281753','TX00001201286','IL','1','LEWIS','ANGELA','','','','34','461434705','524 BOB WHITE ST',0,'DESOTO','TX','75115','5078','CY','48113','1965-01-09','F','U',':RET:2054-5','N','021','DEN','2299751','33348TX002000201','2014-02-01','2013-12-27 10:21:45','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-28 03:33:29'),(16145,12931,'N','01','021','EC','A',NULL,NULL,'','0000315949','0001132768','','IL','1','SHEPPARD','JAMIE','','','','34','461572670','201 n high st',0,'leesburg','OH','45135',NULL,'CY','39071','1981-03-15','F','',NULL,'T','021','HLT','1771729','92036OH005000605','2014-02-01','2014-01-03 15:22:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','292.05',NULL,0,'2014-01-04 02:06:06'),(17036,13631,'Y','18','021','EC','A','','','AC','0001250731','0001250731','LA00002190739','IL','1','COFFEE','LATASHA','','','','34','434610685','2711 AMARILLO ST',0,'BATON ROUGE','LA','70805','2112','CY','22033','1985-04-05','F','U',NULL,'N','021','DEN','2385457','18575LA002000101','2014-02-01','2014-01-08 23:10:10','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:20:48'),(23960,19052,'Y','18','024','14','A','','','TE','0000769712','0000769712','','IL','1','Rush','Joel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-19','M','',NULL,NULL,NULL,'','3066918','','2014-02-15','2014-02-15 13:40:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-15 22:00:09'),(27501,21758,'N','19','021','EC','A',NULL,NULL,'','0000367445','0001128069','','S1','1','Wills','Brion','William','','','34','281111003','205 W WILLIAM ST',0,'MAUMEE','OH','43537','2179','CY','39095','2005-06-08','M','',':RET:2106-3','N','021','HLT','3506335','92036OH004002601','2014-04-01','2014-03-04 12:47:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-04 21:02:28'),(27596,21825,'Y','18','021','EC','A','','','AC','0000749581','0000749581','OH00003643797','IL','1','WILSON','EZEKIEL','LESLIE','','','34','294666967','40 w long st',0,'columbus','OH','43215',NULL,'CY','39049','1960-01-08','M','U',NULL,'N','021','DEN','3214942','99734OH005000401','2014-04-01','2014-03-05 09:03:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-03-05 21:00:20'),(27640,21862,'Y','18','021','EC','A','','','AC','0001111730','0001111730','OH00003470521','IL','1','ADAMS','VIE','','','','34','287705173','6947 GLORIA DR',0,'CINCINNATI','OH','45239',NULL,'CY','39061','1970-07-27','F','U',NULL,'N','021','DEN','3885734','99734OH005000401','2014-04-01','2014-03-05 11:48:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:30:15'),(28116,22252,'Y','18','021','EC','A','','','AC','0000841983','0000841983','OH00002735652','IL','1','Cutlip','Donald','','','','34','236803549','766 Caddo Ave',0,'Akron','OH','44305',NULL,'CY','39153','1951-09-26','M','M',':RET:2106-3','T','021','HLT','3308116','52664OH152000901','2014-04-01','2014-03-06 17:40:36','848.00',NULL,NULL,'1028.62','180.62','R-OH012','OH0','539.67',NULL,0,'2014-03-06 21:02:18'),(28957,22917,'N','01','021','EC','A',NULL,NULL,'','0001214444','0002217065','','IL','1','Guillory','Kent','J','','','34','433453882','4226 PRAIRIE RONDE HWY',0,'OPELOUSAS','LA','70570','1054','CY','22097','1963-04-01','M','',NULL,'N','021','DEN','3851520','18575LA002000201','2014-04-01','2014-03-10 11:25:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-10 21:00:54'),(22385,17874,'Y','18','021','EC','A','','','AC','0000722679','0000722679','OH00002083557','IL','1','MCCAUSLIN','PATRICIA','','','','34','482781176','188 LAKE TERRACE DR',0,'MUNROE FALLS','OH','44262','1024','CY','39153','1960-08-04','F','M',':RET:2106-3','N','021','HLT','3301581','52664OH151001305','2014-03-01','2014-02-10 11:06:19','322.00',NULL,NULL,'454.94','132.94','R-OH012','OH0','454.94',NULL,0,'2014-02-10 21:30:10'),(1252,1032,'Y','18','021','EC','A','','','AC','0000142794','0000142794','OH00000796163','IL','1','Self-Stoehr','Lesha','D','','','34','307887141','3020 GODA AVE',0,'CINCINNATI','OH','45211','2706','CY','39061','1966-04-26','F','M',':RET:2106-3','N','021','HLT','590324','92036OH005001206','2014-01-01','2013-12-03 10:58:58','260.00',NULL,NULL,'335.54','75.54','R-OH004','OH0','335.54',NULL,0,'2013-12-25 18:21:16'),(20800,16620,'Y','18','021','EC','A','','','AC','0000054487','0000054487','TX00002032501','IL','1','TEED','DANIEL','','','','34','431636406','200 Depot Street',0,'Avinger','TX','75630',NULL,'CY','48067','1971-05-12','M','U',NULL,'N','021','DEN','3561434','33348TX002000201','2014-03-01','2014-01-31 13:44:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-31 21:00:21'),(18712,14916,'N','01','021','EC','A',NULL,NULL,'','0000854219','0000613026','','IL','1','Henry','Melissa','','','','34','403172076','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1965-07-06','F','',':RET:2106-3','N','021','DEN','3018902','99734OH005000301','2014-02-01','2014-01-15 21:39:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:31'),(2530,2060,'N','19','021','EC','A',NULL,NULL,'','0001241834','0001028045','','IL','1','Andreadis','Saijal','','','','34','285028231','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1997-09-21','F','',':RET:2106-3','N','021','HLT','1176892','92036OH001001201','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-25 19:36:47'),(2862,2312,'Y','18','021','EC','A','','','AC','0000250211','0000250211','OH00000106291','IL','1','barnett','charles','','','','34','295784747','2080 S CENTER BLVD',0,'SPRINGFIELD','OH','45506','3509','CY','39023','1967-05-14','M','U',NULL,'N','021','DEN','643710','99734OH005000401','2014-01-01','2013-11-02 08:52:35','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:01:39'),(18237,14557,'Y','18','021','EC','A','','','AC','0001003027','0001003027','TX00002408562','IL','1','Liscano','Tammy','','','','34','642489458','920 S LEE AVE',0,'HEREFORD','TX','79045','6415','CY','48117','1988-05-25','F','U',NULL,'N','021','DEN','2421233','33348TX002000201','2014-02-01','2014-01-15 10:30:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:23'),(3847,3077,'Y','18','021','EC','A','','','AC','0000510004','0000510004','LA00000539892','IL','1','Lewis','Eula','','','','34','436430683','9555 JOOR RD',0,'BATON ROUGE','LA','70818','4910','CY','22033','1966-02-15','F','U',':RET:2106-3','T','021','DEN','906690','18575LA002000101','2014-01-01','2013-12-13 11:50:00','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 21:35:31'),(4610,3651,'Y','18','021','EC','A','','','AC','0000166355','0000166355','OH00000011194','IL','1','Stoll','David','','','','34','286569427','1410 CREST AVE',0,'CUYAHOGA FALLS','OH','44223','2060','CY','39153','1954-07-18','M','M',':RET:2106-3','N','021','HLT','865653','52664OH151001501','2014-01-01','2013-12-12 09:49:24','901.00',NULL,NULL,'1447.79','546.79','R-OH012','OH0','696.21',NULL,0,'2013-12-25 22:05:57'),(14708,11743,'N','01','021','EC','A',NULL,NULL,'','0000196147','0000729980','','IL','1','Christlieb','Sheryl','','','','34','268766009','4033 W LINCOLN HWY',0,'ELIDA','OH','45807','9790','CY','39003','1968-09-02','F','',':RET:2106-3','N','021','DEN','2341672','99734OH005000301','2014-02-01','2013-12-28 14:33:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:09:16'),(17075,13665,'Y','18','021','EC','A','','','AC','0000497075','0000497075','TX00001537855','IL','1','Mendoza','Maria','','','','34','450132059','1644 LEROY BONSE DR',0,'EL PASO','TX','79936','5717','CY','48141','1954-11-26','F','U',':RET:2106-3','N','021','DEN','2424595','33348TX002000201','2014-02-01','2014-01-08 11:44:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:21:19'),(15411,12327,'Y','18','021','EC','A','','','AC','0000466867','0000466867','TX00000641025','IL','1','nguyen','hanhdung','thuy','','','34','633313710','943 COUNTY ROAD 1105',0,'RIO VISTA','TX','76093','3815','CY','48251','1972-03-06','F','M',':RET:2047-9','N','021','DEN','2446461','33348TX002000201','2014-02-01','2013-12-31 00:06:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:27:06'),(15236,12178,'Y','18','021','EC','A','','','AC','0000743093','0000743093','OH00000459304','IL','1','Mitchell','Marguerite','','','','34','302441894','2976 CAUDIL EAST RD',0,'BATAVIA','OH','45103','8415','CY','39025','1950-01-24','F','M',':RET:2106-3','N','021','HLT','2149709','92036OH006000601','2014-02-01','2013-12-30 06:33:17','379.00',NULL,NULL,'502.56','123.56','R-OH005','OH0','502.56',NULL,0,'2014-01-01 12:08:26'),(15689,12551,'Y','18','021','EC','A','','','AC','0001219603','0001219603','OH00001180494','IL','1','Collier','David','','','','34','298869539','1326 SANDY LAKE RD',0,'RAVENNA','OH','44266','9581','CY','39133','1977-10-06','M','U',':RET:2106-3','T','021','HLT','2193773','52664OH152000901','2014-02-01','2013-12-31 16:15:30','0.00',NULL,NULL,'231.05','231.05','R-OH012','OH0','231.05',NULL,1,'2014-01-02 04:35:17'),(17222,13781,'Y','18','021','EC','A','','','AC','0001071775','0001071775','OH00002361738','IL','1','Brandman','Rebecca','','','','34','286568915','7043 RAMBLEHURST RD',0,'SYLVANIA','OH','43560','3573','CY','39095','1953-09-13','F','U',':RET:2106-3','N','021','HLT','1574012','92036OH005002606','2014-02-01','2014-01-08 09:26:08','342.00',NULL,NULL,'529.21','187.21','R-OH001','OH0','529.21',NULL,0,'2014-01-13 02:22:34'),(1343,1112,'Y','18','021','EC','A','','','AC','0000435614','0000435614','TX00000383274','IL','1','Shockey','Cory','Nathan','','','34','467651827','6547 AMBER OAK',0,'SAN ANTONIO','TX','78249','1587','CY','48029','1977-07-15','M','U',NULL,'N','021','DEN','1088926','33348TX002000101','2014-01-01','2013-10-09 13:14:25','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 18:32:29'),(1503,1253,'N','19','021','EC','A',NULL,NULL,'','0000122982','0000929844','','IL','1','Hollenbeck','Hailey','Elizabeth','','','34','277151248','10947 SHADOW GLEN DR',0,'LOVELAND','OH','45140','7800','CY','39061','2009-03-10','F','',':RET:2106-3','N','021','DEN','1642424','99734OH005000401','2014-01-01','2013-12-24 12:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:19'),(3941,3155,'Y','18','021','EC','A','','','AC','0000529420','0000529420','OH00000557747','IL','1','Patton','Dorene','','','','34','189521358','1065 KEELER ST',0,'MAUMEE','OH','43537','3040','CY','39095','1957-03-06','F','R',':RET:2106-3','T','021','HLT','716658','92036OH006002601','2014-01-01','2013-12-13 09:39:45','0.00',NULL,NULL,'414.89','414.89','R-OH001','OH0','414.89',NULL,0,'2013-12-25 21:37:56'),(5212,4138,'Y','18','024','14','A','','','TE','0000920790','0000920790','','IL','1','Bartlett','Joyce',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-10','F','',NULL,NULL,NULL,'','613750','','2013-12-19','2013-12-19 15:45:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:20'),(9488,7525,'Y','18','021','EC','A','','','AC','0000162263','0000162263','OH00000103583','IL','1','Stregl','Anton','','','','34','345449476','7817 Hidden Hollow Dr',0,'Mentor','OH','44060',NULL,'CY','39085','1952-08-13','M','M',':RET:2106-3','N','021','DEN','1639610','99734OH005000401','2014-01-01','2013-12-21 13:14:31','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:34:50'),(14156,11284,'Y','18','021','EC','A','','','AC','0001550678','0001550678','LA00001147894','IL','1','brown','tracy','','','','34','437597374','8508 GREENWELL ST',0,'BATON ROUGE','LA','70812',NULL,'CY','22033','1983-05-28','F','U',':RET:2054-5','N','021','DEN','2143716','18575LA002000201','2014-02-01','2013-12-26 14:10:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:03:01'),(14201,11324,'Y','18','021','EC','A','','','AC','0000077243','0000077243','TX00001441510','IL','1','virani','nilofer','','','','34','629486845','501 OSMAN DR',0,'KILLEEN','TX','76542','6238','CY','48027','1969-09-29','F','M',':RET:2028-9','N','021','DEN','1380918','33348TX002000201','2014-02-01','2013-12-26 13:25:08','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-27 02:04:15'),(20239,16148,'N','01','021','EC','A',NULL,NULL,'','0000206489','0000865881','','IL','1','PERKINS','SCYNTHIA','','','','34','427113988','1948 PERKINS RD',0,'CENTREVILLE','MS','39631','4371','CY','28005','1956-12-18','F','',':RET:2106-3','N','021','DEN','3444074','46300MS002000101','2014-03-01','2014-01-28 13:21:34',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-28 21:00:06'),(15836,12680,'Y','18','021','EC','A','','','AC','0000843347','0000843347','OH00000905771','IL','1','Stutler','Moriah','Leanne','','','34','273901597','3356 BATH HEIGHTS DR',0,'CUYAHOGA FALLS','OH','44223','3757','CY','39153','1987-12-10','F','U',NULL,'N','021','DEN','2406860','99734OH005000401','2014-02-01','2014-01-02 11:49:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-03 02:04:00'),(25301,20073,'N','19','021','EC','A',NULL,NULL,'','0000270056','0000486985','','S1','1','CLARKE','DEREK','','','','34','296023884','4205 HEGNER AVE',0,'CINCINNATI','OH','45236','3614','CY','39061','1998-04-05','M','',':RET:2106-3','N','021','DEN','3253499','99734OH005000401','2014-04-01','2014-02-25 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:28'),(25864,20506,'Y','18','021','EC','A','','','AC','0002175158','0002175158','LA00003122687','IL','1','TEMPLET','GERALD','','','','34','434024159','13330 GB TEMPLET RD',0,'GONZALEZ','LA','70737',NULL,'CY','22005','1955-11-29','M','M',NULL,'N','021','DEN','3856071','18575LA002000201','2014-04-01','2014-02-26 14:18:08','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-26 21:00:46'),(26288,20852,'Y','18','021','EC','A','','','AC','0001738680','0001738680','LA00003257373','IL','1','Rose','Chasity','','','','34','434793797','1905 Joyce',0,'Bastrop','LA','71220',NULL,'CY','22067','1990-06-21','F','U',':RET:2054-5','N','021','DEN','3448482','18575LA002000101','2014-04-01','2014-02-27 12:05:27','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-28 06:31:23'),(16202,12972,'Y','18','021','EC','A','','','AC','0001192779','0001192779','TX00002242584','IL','1','Vela','Caroline','','','','34','458192851','4814 Sterling manner Dr',0,'Temple','TX','76502',NULL,'CY','48027','1961-08-01','F','U',NULL,'N','021','DEN','2238604','33348TX002000201','2014-02-01','2014-01-04 16:47:00','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-05 00:01:10'),(18702,14911,'Y','18','024','14','A','','','TE','0001210947','0001210947','','IL','1','ANDERSON','JACQUELINE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-02-23','F','',NULL,NULL,NULL,'','1989188','','2014-01-15','2014-01-15 18:31:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:35:29'),(23867,18991,'Y','18','021','EC','A','','','AC','0000780554','0000780554','OH00002472031','IL','1','IRWIN','NORMAN','','','','34','295847993','900 W WAYNE ST',0,'MAUMEE','OH','43537','1934','CY','39095','1970-08-29','M','U',':RET:2106-3','N','021','HLT','2846664','92036OH002002601','2014-03-01','2014-02-14 15:37:02','0.00',NULL,NULL,'305.57','305.57','R-OH001','OH0','305.57',NULL,0,'2014-02-14 21:32:07'),(24399,19380,'Y','18','021','EC','A','','','AC','0000656980','0000656980','OH00001950709','IL','1','Lowen','William','','','','34','283544230','5296 E MIAMI RIVER RD',0,'CLEVES','OH','45002','9676','CY','39061','1953-07-28','M','M',':RET:1002-5','N','021','DEN','2800008','99734OH005000401','2014-04-01','2014-02-18 14:19:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:53'),(28944,22905,'Y','18','021','EC','A','','','AC','0002380039','0002380039','LA00003796965','IL','1','Howard','Richard','','','','34','434219861','1057 DAVIDSON LN',0,'SHREVEPORT','LA','71107','2701','CY','22017','1970-04-07','M','U',':RET:2106-3','N','021','DEN','3920781','18575LA002000201','2014-04-01','2014-03-09 20:36:38','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-10 21:00:45'),(688,566,'Y','18','024','14','A','','','TE','0000465885','0000465885','','IL','1','Schneider','Adam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-09-23','M','',NULL,NULL,NULL,'','1180107','','2013-12-16','2013-12-16 13:19:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:34'),(20364,16265,'Y','18','024','14','A','','','TE','0000959116','0000959116','','IL','1','Simes','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-13','F','',NULL,NULL,NULL,'','2011274','','2014-01-28','2014-01-28 17:15:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:22'),(1041,854,'Y','18','021','EC','A','','','AC','0000391835','0000391835','TX00000536267','IL','1','ramirez','maria','','','','34','631468423','33762 HOLLY LN',0,'LOS FRESNOS','TX','78566','4186','CY','48061','1954-02-20','F','U',NULL,'N','021','DEN','585103','33348TX002000201','2014-01-01','2013-12-03 11:43:36','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:15:46'),(18624,14847,'N','01','021','EC','A',NULL,NULL,'','0000696835','0000491902','','IL','1','Couture','Ashlee','M','','','34','274924555','609 S WESTWOOD AVE',0,'TOLEDO','OH','43609','1525','CY','39095','1985-08-01','F','',':RET:2054-5','N','021','HLT','1705572','92036OH001002601','2014-02-01','2014-01-14 18:58:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.68',NULL,0,'2014-01-16 08:47:29'),(7598,6012,'Y','18','021','EC','A','','','AC','0000073901','0000073901','OH00000744450','IL','1','lloyd','bruce','','','','34','290522441','246 charles st.',0,'toledo','OH','43609',NULL,'CY','39095','1954-11-23','M','U',':RET:2054-5','N','021','DEN','857287','99734OH005000401','2014-01-01','2013-11-17 11:30:38','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 02:45:18'),(1293,1069,'Y','18','021','EC','A','','','AC','0000816392','0000816392','OH00000559938','IL','1','Clayton','Beverly','','','','34','302648510','2638 hemlock street',0,'Cincinnati','OH','45206',NULL,'CY','39061','1960-02-26','F','U',':RET:2054-5','N','021','HLT','1052399','92036OH004001201','2014-01-01','2013-11-29 14:30:49','0.00',NULL,NULL,'352.13','352.13','R-OH004','OH0','352.13',NULL,0,'2013-12-25 18:30:55'),(15453,12365,'N','01','021','EC','A',NULL,NULL,'','0000976493','0000436880','','IL','1','Lopez','Jennifer','Y','','','34','465690345','717 N 4TH ST',0,'SANTA ROSA','TX','78593','2450','CY','48061','1984-08-20','F','',NULL,'N','021','DEN','2040938','33348TX002000201','2014-02-01','2013-12-31 15:52:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:28:26'),(14648,11691,'Y','18','021','EC','A','','','AC','0000678568','0000678568','TX00001236042','31','1','SUTTON','CHERYL','','','','34','453210591','PO BOX 631',0,'MOUNT PLEASANT','TX','75456',NULL,'CY','48449','1957-12-15','F','U',NULL,'N','021','DEN','2451858','33348TX002000201','2014-02-01','2013-12-28 14:47:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:07:39'),(9212,7307,'Y','18','021','EC','A','','','AC','0000333497','0000333497','MS00000574847','IL','1','Medlin','Regina','','','','34','425083658','380 ELM ST',0,'RALEIGH','MS','39153','2204','CY','28129','1969-10-22','F','U',':RET:2106-3','N','021','DEN','1956450','46300MS002000201','2014-01-01','2013-12-18 17:30:11','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 04:09:55'),(3224,2595,'Y','18','021','EC','A','','','AC','0000894586','0000894586','OH00001241169','IL','1','jackson','debra','a','','','34','273746683','1151 grant st',0,'akron','OH','44301',NULL,'CY','39153','1969-11-16','F','M',':RET:2106-3','T','021','HLT','424111','52664OH151001501','2014-01-01','2013-11-01 06:35:25','0.00',NULL,NULL,'429.70','429.70','R-OH012','OH0','429.70',NULL,0,'2013-12-25 20:45:50'),(2879,2326,'N','01','021','EC','A',NULL,NULL,'','0000339904','0000390528','','IL','1','NAGEL','DENNIS','HENRY','','','34','451808157','718 MCCURDY RD',0,'CUERO','TX','77954','6339','CY','48123','1951-06-23','M','',NULL,'N','021','DEN','665899','33348TX002000201','2014-01-01','2013-10-08 09:28:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:02:10'),(1951,1591,'Y','18','021','EC','A','','','AC','0001095224','0001095224','TX00001190150','IL','1','Rich','James','','','','34','451851079','26427 WALDEN OAK',0,'SAN ANTONIO','TX','78260','6006','CY','48029','1972-09-26','M','M',':RET:2106-3','N','021','DEN','1013885','33348TX002000101','2014-01-01','2013-11-19 22:42:05','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2013-12-25 19:00:59'),(2400,1960,'Y','18','021','EC','A','','','AC','0000415946','0000415946','OH00001319679','IL','1','SCHULER','Carol','s','','','34','281509662','1219 VANDERVEER AVE',0,'HAMILTON','OH','45011',NULL,'CY','39017','1949-11-27','F','U',':RET:2106-3','T','021','DEN','1094262','99734OH005000401','2014-01-01','2013-12-09 13:46:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:31'),(2124,1744,'Y','18','021','EC','A','','','AC','0000228317','0000228317','OH00000978323','IL','1','rodenberg','steven','','','','34','286624777','3921 HERRON AVE',0,'CINCINNATI','OH','45223','2332','CY','39061','1957-06-23','M','M',':RET:2106-3','N','021','DEN','6144','99734OH005000401','2014-01-01','2013-12-10 14:44:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:48'),(2164,1781,'Y','18','021','EC','A','','','AC','0001170812','0001170812','OH00001014886','IL','1','Benson','David','','','','34','270689987','2796 Mull Ave.',0,'Copley','OH','44321',NULL,'CY','39153','1963-02-03','M','U',NULL,'N','021','HLT','618282','52664OH151001501','2014-01-01','2013-12-10 15:31:01','145.00',NULL,NULL,'477.69','332.69','R-OH012','OH0','477.69',NULL,0,'2013-12-25 19:19:00'),(19771,15761,'Y','18','024','14','A','','','TE','0000768902','0000768902','','IL','1','McCune','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-26','M','',NULL,NULL,NULL,'','2131267','','2014-01-23','2014-01-23 14:59:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:29'),(17071,13661,'Y','18','021','EC','A','','','AC','0001215593','0001215593','TX00002224519','IL','1','thomas','Barbara','','','','34','142583186','558 COUNTY ROAD 3715',0,'WOLFE CITY','TX','75496','4806','CY','48147','1968-10-15','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2170876','33348TX002000201','2014-02-01','2014-01-08 09:20:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:21:17'),(2496,2034,'Y','18','021','EC','A','','','AC','0000309747','0000309747','LA00000873718','IL','1','jackson','erin','','','','34','437673115','1033 focis street',0,'metairie','LA','70005',NULL,'CY','22051','1971-01-06','F','U',':RET:2106-3','T','021','DEN','244670','18575LA002000201','2014-01-01','2013-12-09 17:28:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:56'),(6361,5043,'Y','18','021','EC','A','','','AC','0001083063','0001083063','OH00000817781','IL','1','balasooriya','hemantha','','','','34','279903408','8650 CHEVINGTON CHASE DR',0,'PICKERINGTON','OH','43147','9552','CY','39045','1964-07-15','M','U',':RET:2028-9','N','021','DEN','744453','99734OH005000401','2014-01-01','2013-12-11 18:01:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:47:21'),(6205,4917,'N','01','021','EC','A',NULL,NULL,'','0000481028','0000482152','','IL','1','Moore','Bruce','Edward','','','34','285765114','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1980-09-05','M','',NULL,'T','021','DEN','440801','99734OH005000401','2014-01-01','2013-10-16 20:06:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:30:43'),(3939,3153,'Y','18','021','EC','A','','','AC','0000246428','0000246428','OH00000193601','IL','1','Benschoter','Brian','','','','34','273707095','8266 PORTAGE RD',0,'PORTAGE','OH','43451','9715','CY','39173','1962-10-30','M','R',':RET:2106-3','N','021','HLT','31361','92036OH002002601','2014-01-01','2013-12-13 10:47:18','0.00',NULL,NULL,'419.99','419.99','R-OH001','OH0','419.99',NULL,0,'2013-12-25 21:37:52'),(24026,19108,'Y','18','021','EC','A','','','AC','0001011608','0001011608','OH00002613883','IL','1','BLOM','NICOLE','','','','34','290865762','745 Washington',0,'Toledo','OH','43604',NULL,'CY','39095','1981-02-07','F','M',':RET:2106-3','N','021','HLT','3593676','92036OH004002601','2014-03-01','2014-02-15 07:12:31','0.00',NULL,NULL,'187.83','187.83','R-OH001','OH0','187.83',NULL,0,'2014-02-15 22:00:50'),(26589,21083,'Y','18','021','EC','A','','','AC','0000211056','0000211056','OH00002455838','IL','1','CAMPOS','ROSARIO','','','','34','023173904','8595 WRENFORD CT',0,'MACEDONIA','OH','44056','1750','CY','39153','1940-01-14','F','M',':RET:2036-2','N','021','HLT','3429514','52664OH152000901','2014-04-01','2014-02-28 10:09:00','0.00',NULL,NULL,'490.00','490.00','R-OH012','OH0','490.00',NULL,0,'2014-02-28 21:30:35'),(27724,21925,'Y','18','021','EC','A','','','AC','0001025992','0001025992','TX00002599374','IL','1','Davis','Mary','','','','34','455578081','4943 GUADALUPE DR',0,'EL PASO','TX','79904','2009','CY','48141','1967-04-09','F','M',':RET:2039-6','N','021','DEN','3318362','33348TX002000201','2014-04-01','2014-03-05 14:58:21','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:31:00'),(22918,18268,'N','01','021','EC','A',NULL,NULL,'','0000849473','0000899612','','IL','1','Insko','Derek',NULL,NULL,NULL,NULL,NULL,'24 W 8TH ST',0,'MANCHESTER','OH','45144','1239','CY','39001','1974-11-10','M','',':RET:1002-5^:RET:2106-3','N','021','HLT','3837944','92036OH003000604','2014-03-01','2014-02-11 16:07:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','282.91',NULL,0,'2014-02-11 21:02:52'),(20248,16157,'Y','18','021','EC','A','','','AC','0000282946','0000282946','TX00001510619','IL','1','Valdez','Maria','','','','34','453270365','107 Weisenberger',0,'Houston','TX','77022',NULL,'CY','48201','1971-12-02','F','U',NULL,'N','021','DEN','3006825','33348TX002000101','2014-03-01','2014-01-28 14:45:07','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-28 21:00:11'),(2160,1777,'Y','18','021','EC','A','','','AC','0000751910','0000751910','LA00000851985','IL','1','MAY','TEDDY','','','','34','438741630','547 HIGHWAY 557',0,'WEST MONROE','LA','71292','3328','CY','22073','1951-05-15','M','R',':RET:2106-3','N','021','DEN','747239','18575LA002000101','2014-01-01','2013-12-10 17:50:49','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 19:18:51'),(4019,3209,'Y','18','024','14','A','','','TE','0000280820','0000280820','','IL','1','Griffith','Jeffery',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-28','M','',NULL,NULL,NULL,'','2132911','','2013-12-17','2013-12-17 08:08:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:37'),(17351,13881,'Y','18','024','14','A','','','TE','0000443473','0000443473','','IL','1','AHMOUDA','TAMMY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-08','F','',NULL,NULL,NULL,'','1969042','','2014-01-10','2014-01-10 09:55:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:24:08'),(6070,4810,'Y','18','021','EC','A','','','AC','0000106682','0000106682','OH00001273769','IL','1','SEWELL','REBBIE','','','','34','273705977','617 SACKMAN ST',0,'MANSFIELD','OH','44903','1096','CY','39139','1975-07-15','F','U',NULL,'N','021','DEN','180783','99734OH005000401','2014-01-01','2013-12-01 15:29:58','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-26 00:02:10'),(5579,4425,'N','01','021','EC','A',NULL,NULL,'','0000491838','0000439392','','IL','1','Snyder','Keith','','','','34','280848791','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1983-09-02','M','',':RET:2106-3','N','021','HLT','1128915','92036OH004002601','2014-01-01','2013-11-05 21:29:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','177.96',NULL,0,'2013-12-25 23:16:53'),(14200,11323,'N','01','021','EC','A',NULL,NULL,'','0000253290','0000018832','','IL','1','Chen','Meei-Yuh','','','','34','500820290','2392 HWY 71 West',0,'Cedar Creek','TX','78751',NULL,'CY','48453','1954-05-28','F','',':RET:2028-9','N','021','DEN','1552971','33348TX002000201','2014-02-01','2013-12-26 13:20:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-27 02:04:13'),(16928,13547,'Y','18','021','EC','A','','','AC','0001268775','0001268775','LA00002376910','IL','1','CESTEDES-MONTANO','EDUARD','I','','','34','598544676','339 HELEN ST',0,'TERRYTOWN','LA','70056','3816','CY','22051','1975-11-18','M','M',NULL,'N','021','DEN','1642789','18575LA002000201','2014-02-01','2014-01-09 16:05:17','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:47'),(24078,19148,'Y','18','021','EC','A','','','AC','0000652179','0000652179','OH00002070159','IL','1','Mahlendorf','John','','','','34','508700865','6351 Grove Road',0,'Clinton','OH','44216',NULL,'CY','39153','1952-02-27','M','M',':RET:2106-3','N','021','HLT','2927654','52664OH151001304','2014-03-01','2014-02-15 12:02:05','1035.00',NULL,NULL,'1444.20','409.20','R-OH012','OH0','640.70',NULL,0,'2014-02-15 22:01:21'),(723,598,'Y','18','021','EC','A','','','AC','0000821686','0000821686','TX00000787259','IL','1','Wilkerson','Jana','','','','34','456419856','10690 c.r. 214',0,'tyler','TX','75707',NULL,'CY','48423','1968-07-07','F','U',':RET:2106-3','T','021','DEN','1648027','33348TX002000101','2014-01-01','2013-12-16 11:44:43','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-25 18:03:31'),(1393,1157,'Y','18','024','14','A','','','TE','0001472769','0001472769','','IL','1','Rancifer','Cinuray',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-31','F','',NULL,NULL,NULL,'','1472912','','2013-12-24','2013-12-24 11:40:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:46:25'),(21004,16783,'Y','18','024','14','A','','','TE','0002323826','0002323826','','IL','1','ROSE','REX',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-11-23','M','',NULL,NULL,NULL,'','2962498','','2014-02-01','2014-02-01 12:07:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-01 19:00:30'),(21189,16933,'N','01','021','EC','A',NULL,NULL,'','0000647517','0000921200','','IL','1','Bryan-Martin','Michelle','','','','34','022818429','4222 BERWICK CASSELS RD',0,'GLOSTER','MS','39638','3521','CY','28005','1963-11-30','F','',':RET:2054-5','N','021','DEN','3374932','46300MS002000101','2014-03-01','2014-02-03 12:35:16',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-03 21:00:47'),(17815,14230,'Y','18','024','14','A','','','TE','0000289082','0000289082','','IL','1','Briggs','Justin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-08-18','M','',NULL,NULL,NULL,'','1565414','','2014-01-13','2014-01-13 18:37:31',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-15 02:05:54'),(17184,13750,'Y','18','021','EC','A','','','AC','0000352846','0000352846','OH00002269681','IL','1','mullin','sarah','','','','34','176727121','251 HIGH ST',0,'CONNEAUT','OH','44030','2821','CY','39007','1984-03-31','F','U',':RET:2106-3','T','021','DEN','2050037','99734OH005000301','2014-02-01','2014-01-08 17:13:54','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:22:14'),(5148,4081,'N','01','021','EC','A',NULL,NULL,'','0000259214','0000751008','','IL','1','Murphey','Yvonne','','','','34','290528728','12633 St Highway 152',0,'Toronto','OH','43964',NULL,'CY','39081','1951-02-16','F','',':RET:2106-3','N','021','DEN','1381700','99734OH005000401','2014-01-01','2013-12-19 09:09:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:02:43'),(4201,3341,'Y','18','021','EC','A','','','AC','0000393236','0000393236','TX00000386708','IL','1','Fawver','Trevor','','','','34','464975407','4612 COUNTY ROAD 919',0,'CROWLEY','TX','76036','5534','CY','48251','1982-08-24','M','U',NULL,'N','021','DEN','2097004','33348TX002000201','2014-01-01','2013-12-16 19:41:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:49:53'),(16501,13201,'N','01','021','EC','A',NULL,NULL,'','0000315950','0001109240','','IL','1','Schmidt','Marilyn','Ann','','','34','279508606','5725 RESIK DR',0,'HUBER HEIGHTS','OH','45424','4319','CY','39113','1950-06-18','F','',':RET:2106-3','N','021','HLT','1641515','92036OH005000506','2014-02-01','2014-01-06 14:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','701.70',NULL,0,'2014-01-07 04:06:51'),(27513,21765,'N','19','021','EC','A',NULL,NULL,'','0000809735','0000612016','','IL','1','Dunlea','Benjamin','Thomas','','','34','295964204','7305 WILLOWOOD DR',0,'WEST CHESTER','OH','45241','3707','CY','39017','1994-02-15','M','',':RET:2106-3','N','021','HLT','3867739','92036OH002001201','2014-04-01','2014-03-04 10:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-03-04 21:02:34'),(150,126,'Y','18','021','EC','A','','','AC','0000848316','0000848316','OH00000975980','IL','1','Canterbury','Teresa','Lynn','','','34','274708367','333 LAFAYETTE RD',0,'MEDINA','OH','44256','2335','CY','39103','1963-11-17','F','M',':RET:2106-3','N','021','HLT','1250349','52664OH152000901','2014-01-01','2013-12-05 15:24:58','556.00',NULL,NULL,'612.19','56.19','R-OH012','OH0','291.73',NULL,0,'2013-12-25 17:18:54'),(23957,19050,'Y','18','021','EC','A','','','AC','0001027054','0001027054','TX00002885838','31','1','Campos','Johnny','','','','34','458656292','PO Box 1349',0,'Marfa','TX','79843',NULL,'CY','48377','1983-09-03','M','M',':RET:2106-3','N','021','DEN','3340872','33348TX002000101','2014-03-01','2014-02-14 20:35:28','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-02-15 22:00:07'),(7941,6281,'Y','18','021','EC','A','','','AC','0002100943','0002100943','LA00000746236','IL','1','Watkins','Bruce','','','','34','439705270','369 Jessie Rd.',0,'Jamestown','LA','71045',NULL,'CY','22013','1958-06-20','M','U',':RET:2106-3','N','021','DEN','1950010','18575LA002000201','2014-01-01','2013-12-20 15:17:02','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:06:53'),(459,374,'N','01','021','EC','A',NULL,NULL,'','0000790849','0000915618','','IL','1','Lawrence','Amy','Nicole','','','34','555750539','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1982-07-29','F','',':RET:2106-3','N','021','HLT','229261','52664OH151001301','2014-01-01','2013-12-03 22:41:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','258.47',NULL,0,'2013-12-25 17:47:34'),(19523,15561,'Y','18','021','EC','A','','','AC','0000689722','0000689722','OH00002448779','IL','1','Ventura','Miguel','','','','34','299115616','7350 JAGUAR CT',0,'WAYNESVILLE','OH','45068','8210','CY','39165','1970-09-03','M','M',NULL,'N','021','DEN','2134178','99734OH005000401','2014-03-01','2014-01-21 18:59:46','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:02:19'),(18442,14714,'Y','18','021','EC','A','','','AC','0001670263','0001670263','LA00002049050','IL','1','Nguyen','Kevin','','','','34','439516064','2608 HIGHLAND RD',0,'BATON ROUGE','LA','70802','7338','CY','22033','1970-04-01','M','M',NULL,'N','021','DEN','2144223','18575LA002000201','2014-02-01','2014-01-15 17:25:30','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-16 08:46:04'),(3110,2498,'Y','18','021','EC','A','','','AC','0000519800','0000519800','OH00000979679','IL','1','longworth','maureen','a','','','34','269526138','4123 CERTIER RD',0,'LYNCHBURG','OH','45142',NULL,'CY','39071','1951-10-13','F','M',':RET:2106-3','N','021','HLT','408297','92036OH004000601','2014-01-01','2013-12-06 13:53:06','421.00',NULL,NULL,'495.91','74.91','R-OH005','OH0','495.91',NULL,0,'2013-12-25 20:20:30'),(3891,3115,'N','19','021','EC','A',NULL,NULL,'','0000021368','0000676690','','IL','1','Hartzell','Timothy','Paul','','','34','292923892','2901 perrydale st.nw',0,'greentown','OH','44630',NULL,'CY','39151','1990-09-24','M','',':RET:2106-3','N','021','HLT','19180','52664OH152000901','2014-01-01','2013-12-13 12:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2013-12-25 21:36:40'),(5917,4686,'N','17','021','EC','A',NULL,NULL,'','0000444506','0001178550','','IL','1','Juhl','Austin','','','','34','606546829','21272 EVA ST',0,'MONTGOMERY','TX','77356','1809','CY','48339','1991-11-26','M','',':RET:2106-3','N','021','DEN','1633478','33348TX002000101','2014-01-01','2013-12-23 23:59:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:11'),(17130,13708,'Y','18','024','14','A','','','TE','0000575937','0000575937','','IL','1','Randolph','Susan','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-14','F','',NULL,NULL,NULL,'','1609688','','2014-01-08','2014-01-08 11:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:21:46'),(16019,12823,'Y','18','021','EC','A','','','AC','0001729325','0001729325','LA00001356984','IL','1','WOODARD','GUSSIE','','','','34','439172961','1203 MARTIN LUTHER KING DR',0,'JONESBORO','LA','71251','2219','CY','22049','1957-03-11','F','U',':RET:2054-5','T','021','DEN','1936753','18575LA002000201','2014-02-01','2014-01-03 00:04:28','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-04 02:02:06'),(15385,12307,'Y','18','024','14','A','','','TE','0000539293','0000539293','','IL','1','Bonner','Holly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-12-15','F','',NULL,NULL,NULL,'','1859036','','2014-01-01','2014-01-01 10:44:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:25:34'),(13306,10623,'Y','18','021','EC','A','','','AC','0000621493','0000621493','TX00000844223','IL','1','MUNOZ','BERENICE','','','','34','642188526','513 N CEDAR ST',0,'BROWNFIELD','TX','79316','4022','CY','48445','1983-12-02','F','M',NULL,'N','021','DEN','1652336','33348TX002000201','2014-01-01','2013-12-23 15:25:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:56'),(26062,20669,'Y','18','021','EC','A','','','AC','0000182350','0000182350','OH00003298804','IL','1','alsept','ron','','','','34','272609123','1548 WONDERLICK RD',0,'LIMA','OH','45805','3936','CY','39003','1964-05-31','M','M',':RET:2106-3','N','021','HLT','3273127','92036OH002001501','2014-03-01','2014-02-26 12:49:13','380.00',NULL,NULL,'756.41','376.41','R-OH002','OH0','433.61',NULL,0,'2014-02-26 21:02:40'),(27278,21601,'Y','18','021','EC','A','','','AC','0000798469','0000798469','TX00003091650','IL','1','VALDEZ-ESPINOZA','MAYRA','HAYDEE','','','34','729286173','1460 PLAZA VERDE DR',0,'EL PASO','TX','79912','8427','CY','48141','1963-06-23','F','M',':RET:2106-3','N','021','DEN','3091417','33348TX002000201','2014-04-01','2014-03-03 21:08:11','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-04 21:00:20'),(19708,15705,'N','19','021','EC','A',NULL,NULL,'','0000850673','0001259533','','IL','1','Park','Diana','Na-Hyun','','','34','624608105','16705 ANJOU LN',0,'ROUND ROCK','TX','78681','5316','CY','48491','1992-12-11','F','',':RET:2040-4','N','021','DEN','3071475','33348TX002000201','2014-03-01','2014-01-23 15:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:51'),(9329,7395,'N','19','021','EC','A',NULL,NULL,'','0000683381','0000049481','','S1','1','Arkus','Alan','J','','','34','097048963','3746 White Chapel Ct.',0,'Amelia','OH','45102',NULL,'CY','39025','2011-08-18','F','',':RET:2106-3','N','021','HLT','1814248','92036OH004000601','2014-01-01','2013-12-20 18:52:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 04:30:43'),(3933,3148,'Y','18','021','EC','A','','','AC','0000640905','0000640905','OH00000698610','IL','1','Moore','Vena','','','','34','277482609','3407 Oak Alley Ct',0,'Toledo','OH','43606',NULL,'CY','39095','1950-01-15','F','U',NULL,'N','021','HLT','330736','92036OH004002601','2014-01-01','2013-12-13 15:02:11','224.00',NULL,NULL,'462.84','238.84','R-OH001','OH0','462.84',NULL,0,'2013-12-25 21:37:42'),(19379,15448,'N','01','021','EC','A',NULL,NULL,'','0000380605','0001031157','','IL','1','Taylor','Willie','E','','Jr','34','427419987','3063 J J CARTER RD',0,'MAGNOLIA','MS','39652','9362','CY','28113','1980-03-15','M','',NULL,'N','021','DEN','2914592','46300MS002000101','2014-03-01','2014-01-21 17:17:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,1,'2014-01-22 03:22:40'),(18111,14466,'Y','18','021','EC','A','','','AC','0001416166','0001416166','LA00001733938','IL','1','flores','jose','','','','34','260931840','10860 LETON DR',0,'BATON ROUGE','LA','70816','4126','CY','22033','1953-04-02','M','M',NULL,'N','021','DEN','1942708','18575LA002000201','2014-02-01','2014-01-14 18:35:42','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-15 02:07:37'),(6774,5374,'N','19','021','EC','A',NULL,NULL,'','0000566575','0000251589','','IL','1','BACOVIN','DEAN','A','','','34','282920923','10433 WALKINGFERN DR',0,'HARRISON','OH','45030','1654','CY','39061','1989-02-22','M','',':RET:2106-3','N','021','DEN','624387','99734OH005000301','2014-01-01','2013-11-25 15:36:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:16:42'),(17654,14109,'N','01','021','EC','A',NULL,NULL,'','0000948436','0001168019','','IL','1','Abou-Osman','Ahmad','','','','34','529413582','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','1962-07-20','M','',NULL,'T','021','DEN','1526001','99734OH005000301','2014-02-01','2014-01-13 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:41'),(17239,13795,'N','01','021','EC','A',NULL,NULL,'','0000455325','0000203101','','IL','1','chen','yu','','','','34','060824346','8172 CLEARBROOK DR',0,'FINDLAY','OH','45840','7809','CY','39063','1972-09-03','F','',':RET:2034-7','N','021','HLT','1584757','92036OH004001501','2014-02-01','2014-01-08 13:56:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','230.41',NULL,0,'2014-01-13 02:22:44'),(13349,10661,'Y','18','021','EC','A','','','AC','0000957428','0000957428','TX00001359377','IL','1','Dean','Jaime','','','','34','229115063','11245 Sir Winston Street',0,'San Antonio','TX','78216',NULL,'CY','48029','1976-09-27','F','U',':RET:2106-3','N','021','DEN','2044602','33348TX002000201','2014-01-01','2013-12-23 19:01:40','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:59:09'),(13756,10979,'N','01','021','EC','A',NULL,NULL,'','0000392500','0000201658','','IL','1','Patel','Dharmishthaben',NULL,NULL,NULL,NULL,NULL,'115 SUNNY DR',0,'CANTON','MS','39046','5129','CY','28089','1961-08-23','F','',NULL,'N','021','DEN','2173042','46300MS002000201','2014-01-01','2013-12-22 22:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:04'),(14930,11930,'Y','18','021','EC','A','','','AC','0000393337','0000393337','TX00001473676','IL','1','TORRES','ARMIDA','','','','34','632185196','7602 KENSICO RD',0,'HOUSTON','TX','77036','5724','CY','48201','1957-08-14','F','M',NULL,'N','021','DEN','2567235','33348TX002000101','2014-02-01','2013-12-29 12:18:04','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-30 00:01:58'),(29070,23007,'Y','18','021','EC','A','','','AC','0000201984','0000201984','OH00003591410','IL','1','Garrett','Mary','R','','','34','274504489','12336 LAFONTAINE DR',0,'CURTICE','OH','43412','9401','CY','39095','1951-08-09','F','U',NULL,'T','021','HLT','3980227','92036OH004002601','2014-04-01','2014-03-10 16:48:43','453.00',NULL,NULL,'518.03','65.03','R-OH001','OH0','518.03',NULL,0,'2014-03-10 21:01:57'),(1647,1376,'N','01','021','EC','A',NULL,NULL,'','0000493005','0000698153','','IL','1','McGee','Jeremy','Scott','','','34','634070808','1112 GLENN ST',0,'DAINGERFIELD','TX','75638','1808','CY','48343','1981-04-07','M','',':RET:2106-3','N','021','DEN','1901249','33348TX002000201','2014-01-01','2013-12-24 15:51:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:53:15'),(9133,7244,'Y','18','021','EC','A','','','AC','0000872294','0000872294','LA00000591522','IL','1','BROWN','DEREK','','','','34','425291754','103 COUNTRY LANE',0,'LAFAYETTE','LA','70508',NULL,'CY','22055','1963-08-31','M','U',NULL,'N','021','DEN','2026907','18575LA002000201','2014-01-01','2013-12-18 16:04:39','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 04:08:01'),(9070,7199,'Y','18','021','EC','A','','','AC','0001208284','0001208284','OH00000933509','IL','1','Bond','Trudy','','','','34','442584137','2212 INNISBROOK RD',0,'OTTAWA HILLS','OH','43606','2527','CY','39095','1952-07-21','F','U',':RET:2106-3','N','021','HLT','2066517','92036OH002002601','2014-01-01','2013-12-17 19:11:07','230.00',NULL,NULL,'632.79','402.79','R-OH001','OH0','632.79',NULL,0,'2013-12-26 04:06:36'),(8082,6398,'N','01','021','EC','A',NULL,NULL,'','0000923318','0000819772','','IL','1','Hoehn','Holly','M','','','34','300563414','7109 Daleview Road',0,'Cincinnati','OH','45247',NULL,'CY','39061','1962-11-15','F','',':RET:2106-3','N','021','HLT','2015120','92036OH004001201','2014-01-01','2013-12-20 14:51:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','321.93',NULL,0,'2013-12-26 03:10:26'),(22485,17951,'N','01','021','EC','A',NULL,NULL,'','0000963275','0000994011','','IL','1','Headrick','Debra','L','','','34','520721911','6513 Shaffer Road NW',0,'Warren','OH','44481',NULL,'CY','39155','1956-04-05','F','',NULL,'N','021','DEN','3118316','99734OH005000301','2014-03-01','2014-02-10 09:30:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:05'),(22328,17829,'Y','18','021','EC','A','','','AC','0000841948','0000841948','OH00001548643','IL','1','Chamberlain','David','','','','34','003528977','6104 DONNA JAY DR',0,'LOVELAND','OH','45140','8739','CY','39025','1970-07-24','M','M',NULL,'N','021','HLT','3148716','92036OH004000601','2014-03-01','2014-01-25 13:36:41','124.81',NULL,NULL,'234.23','109.42','R-OH005','OH0','234.23',NULL,0,'2014-02-10 11:00:59'),(2692,2181,'N','01','021','EC','A',NULL,NULL,'','0001102344','0001157137','','IL','1','VO','KIMBERLY','','','','34','143028849','9713 LINKS FAIRWAY DR',0,'ROWLETT','TX','75089','9534','CY','48113','1981-06-17','F','',':RET:2047-9','N','021','DEN','995070','33348TX002000201','2014-01-01','2013-12-02 17:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 19:47:33'),(17907,14303,'Y','18','021','EC','A','','','AC','0001007906','0001007906','TX00002084435','IL','1','Carther','LaNetra','','','','34','312844065','8109 Chipping',0,'San Antonio','TX','78239',NULL,'CY','48029','1979-12-16','F','U',':RET:2054-5','N','021','DEN','2085314','33348TX002000201','2014-02-01','2014-01-13 19:11:23','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:25'),(3061,2459,'Y','18','021','EC','A','','','AC','0000180082','0000180082','LA00000421807','IL','1','Gonzaque','Loretta','','','','34','086462731','1724 CROSS LAKE BLVD',0,'SHREVEPORT','LA','71109','1920','CY','22017','1953-08-23','F','M',':RET:2054-5','N','021','DEN','1121172','18575LA002000201','2014-01-01','2013-12-06 15:57:17','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 20:19:10'),(17632,14097,'Y','18','021','EC','A','','','AC','0001242993','0001242993','TX00002401053','IL','1','Harrison','Shawn','','','','34','629148304','807 W Lynn st.',0,'Austin','TX','78703',NULL,'CY','48453','1989-09-14','M','U',':RET:2106-3','N','021','DEN','2743710','33348TX002000201','2014-02-01','2014-01-13 17:35:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:33'),(17177,13744,'Y','18','021','EC','A','','','AC','0000099010','0000099010','OH00001434698','IL','1','DAVIS','SHELLEY','','','','34','181568304','433 FREBIS AVE',0,'COLUMBUS','OH','43206','3633','CY','39049','1967-05-19','F','U',':RET:2054-5','N','021','DEN','2292594','99734OH005000301','2014-02-01','2014-01-08 09:14:01','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:22:10'),(16569,13253,'N','19','021','EC','A',NULL,NULL,'','0001204544','0000066264','','IL','1','Johnson','Skylar','','','','34','269132010','2318 DEERPATH LN',0,'TOLEDO','OH','43614','5012','CY','39095','2006-08-15','F','',':RET:2054-5','N','021','HLT','2243536','92036OH003002604','2014-02-01','2014-01-04 20:22:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,1,'2014-01-07 10:23:15'),(14087,11226,'N','01','021','EC','A',NULL,NULL,'','0000103887','0000837696','','IL','1','louis','frank','','','','34','163443973','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-05-23','M','',':RET:2106-3','T','021','DEN','1649884','99734OH005000401','2014-02-01','2013-12-26 10:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:16'),(25397,20148,'Y','18','021','EC','A','','','AC','0001077810','0001077810','OH00002782753','IL','1','Green','Robin','','','','34','193568690','688 LAFAYETTE DR',0,'AKRON','OH','44303','1719','CY','39153','1966-05-10','F','U',':RET:2106-3','N','021','HLT','3457216','52664OH151001305','2014-04-01','2014-02-25 14:44:43','224.00',NULL,NULL,'348.56','124.56','R-OH012','OH0','348.56',NULL,0,'2014-02-25 21:30:54'),(26717,21179,'Y','18','021','EC','A','','','AC','0000595347','0000595347','MS00002755185','IL','1','Kelly','Hazel','','','','34','425063839','111 BRIGADE AVE',0,'CANTON','MS','39046','8025','CY','28089','1957-07-10','F','M',':RET:2054-5','N','021','DEN','3700669','46300MS002000201','2014-03-01','2014-02-28 16:21:42','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-28 21:31:42'),(27737,21934,'Y','18','021','EC','A','','','AC','0000362076','0000362076','TX00002946760','IL','1','Smith','Otis','','','','34','451313787','33215 Salee Rd',0,'Belton','TX','76513',NULL,'CY','48027','1967-07-10','M','U',':RET:2106-3','N','021','DEN','3806264','33348TX002000201','2014-04-01','2014-03-05 16:55:10','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-05 21:31:07'),(700,577,'Y','18','024','14','A','','','TE','0000172380','0000172380','','IL','1','Krenisky','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-20','F','',NULL,NULL,NULL,'','967082','','2013-12-16','2013-12-16 17:58:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:52'),(13090,10436,'Y','18','021','EC','A','','','AC','0000447461','0000447461','OH00000081919','IL','1','abriani','reid','','','','34','282882146','7640 PRIMROSE DR',0,'MENTOR ON THE LAKE','OH','44060','3316','CY','39085','1976-02-28','M','U',':RET:2106-3','N','021','DEN','2245521','99734OH005000401','2014-01-01','2013-12-23 11:27:18','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:50'),(23425,18664,'Y','18','021','EC','A','','','AC','0000555441','0000555441','TX00002094656','IL','1','Banda','Diana','','','','34','636164215','14259 Arthur St',0,'Ore City','TX','75683',NULL,'CY','48459','1990-04-01','F','U',':RET:2106-3','N','021','DEN','3274316','33348TX002000201','2014-03-01','2014-02-12 23:38:21','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-13 22:01:24'),(4310,3426,'Y','18','021','EC','A','','','AC','0000042041','0000042041','OH00000422152','IL','1','bloemker','katrina','','','','34','404118255','207 CRANEWOOD DR',0,'TRENTON','OH','45067','1111','CY','39017','1974-07-31','F','U',':RET:2106-3','T','021','HLT','1548732','92036OH004001201','2014-01-01','2013-12-17 14:46:12','0.00',NULL,NULL,'250.51','250.51','R-OH004','OH0','250.51',NULL,0,'2013-12-25 21:52:32'),(5745,4561,'Y','18','021','EC','A','','','AC','0001363786','0001363786','LA00001249874','IL','1','Vu','Quyen','','','','34','612505907','145 B AND G LOOP',0,'LEESVILLE','LA','71446','6434','CY','22115','1968-03-26','M','M',':RET:2047-9','T','021','DEN','1616426','18575LA002000201','2014-01-01','2013-12-24 00:44:00','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-25 23:46:04'),(22911,18262,'N','01','021','EC','A',NULL,NULL,'','0000218876','0001010252','','IL','1','Scales','Michael','Robert','','','34','272489350','3462 BEHYMER RD',0,'CINCINNATI','OH','45245','3102','CY','39025','1951-01-19','M','',':RET:2106-3','T','021','HLT','3334193','92036OH005000601','2014-03-01','2014-02-11 11:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','728.75',NULL,0,'2014-02-11 21:02:48'),(13606,10851,'Y','18','021','EC','A','','','AC','0000796957','0000796957','OH00000347037','IL','1','Behrmann','Tara','','','','34','273863081','9499 HADDINGTON CT',0,'CINCINNATI','OH','45251','2362','CY','39061','1974-04-24','F','M',':RET:2106-3','N','021','HLT','1676823','92036OH002001201','2014-01-01','2013-12-22 18:59:46','250.00',NULL,NULL,'936.62','686.62','R-OH004','OH0','312.85',NULL,0,'2013-12-26 13:05:33'),(7937,6277,'Y','18','021','EC','A','','','AC','0002085904','0002085904','LA00000302885','IL','1','Thomas','Robert','','','','34','435238899','4112 MILES ST',0,'SHREVEPORT','LA','71109','7846','CY','22017','1973-10-03','M','U',':RET:2054-5','N','021','DEN','1634445','18575LA002000201','2014-01-01','2013-12-20 14:38:47','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:06:46'),(15560,12451,'Y','18','021','EC','A','','','AC','0000262729','0000262729','OH00001535048','31','1','DENGG','VALERIE','T','','','34','274869575','PO BOX 172',0,'BATH','OH','44210',NULL,'CY','39153','1975-02-19','F','M',':RET:2106-3','N','021','HLT','2427889','52664OH151001301','2014-02-01','2013-12-30 20:15:51','0.00',NULL,NULL,'277.87','277.87','R-OH012','OH0','277.87',NULL,1,'2014-01-02 04:31:33'),(4114,3288,'Y','18','021','EC','A','','','AC','0001089542','0001089542','OH00000136378','IL','1','Reiff','Jonathan','','','','34','297803698','6055 OAK HILL LN',0,'CENTERVILLE','OH','45459','2138','CY','39113','1974-02-28','M','U',':RET:2106-3','T','021','DEN','1631876','99734OH005000301','2014-01-01','2013-12-16 20:43:37','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:48:04'),(5069,4018,'Y','18','021','EC','A','','','AC','0001127063','0001127063','TX00000359632','IL','1','GUERRA','MARIA','','','','34','637386113','1 JAMES CIRCLE',0,'THE COLONY','TX','75056',NULL,'CY','48121','1981-10-29','F','M',NULL,'N','021','DEN','1799031','33348TX002000201','2014-01-01','2013-12-19 11:38:34','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:00:40'),(6314,5009,'Y','18','021','EC','A','','','AC','0000648299','0000648299','OH00001080948','IL','1','Setser','Charles','Adam','','','34','591076901','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','1968-02-26','M','R',':RET:2036-2','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:16'),(6811,5403,'Y','18','021','EC','A','','','AC','0000609698','0000609698','TX00000945576','IL','1','Cornelison','Virgil','','','','34','455317934','402 N STATE ST',0,'DECATUR','TX','76234','1415','CY','48497','1963-12-26','M','U',':RET:2106-3','N','021','DEN','285632','33348TX002000201','2014-01-01','2013-11-14 14:48:51','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:30:19'),(5528,4384,'Y','18','021','EC','A','','','AC','0000725034','0000725034','OH00000336440','IL','1','Blount','Bryan','','','','34','254067497','4431 THORNBERRY DR',0,'COLUMBUS','OH','43231','6192','CY','39049','1975-12-21','M','U',':RET:2106-3','N','021','DEN','210903','99734OH005000401','2014-01-01','2013-11-26 20:53:39','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:30'),(27894,22067,'Y','18','021','EC','A','','','AC','0000484858','0000484858','OH00003650170','IL','1','URICH','DARLENE','K','','','34','296505641','37 E LEAGUE ST',0,'NORWALK','OH','44857','1345','CY','39077','1950-10-03','F','M',':RET:2106-3','N','021','HLT','3736366','92036OH003002705','2014-04-01','2014-03-05 14:35:54','494.00',NULL,NULL,'601.12','107.12','R-OH006','OH0','601.12',NULL,0,'2014-03-05 21:32:41'),(28236,22341,'Y','18','024','14','A','','','TE','0000904297','0000904297','','IL','1','haddad','elise',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-03','F','',NULL,NULL,NULL,'','3428920','','2014-03-31','2014-03-06 18:36:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:08'),(28243,22347,'N','01','021','EC','A',NULL,NULL,'','0000500465','0000920883','','IL','1','kingsland','michael','','','','34','320628018','340 KING AVE',0,'SOUTH LEBANON','OH','45065','1404','CY','39165','1970-02-28','M','',':RET:2106-3','T','021','DEN','3101192','99734OH005000401','2014-04-01','2014-03-07 12:32:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-07 21:00:11'),(1350,1118,'Y','18','021','EC','A','','','AC','0000148116','0000148116','TX00001452058','IL','1','KELLEY','SONYA','','','','34','464911909','3801 OAK VALLEY DR',0,'KILLEEN','TX','76542','4533','CY','48027','1970-09-16','F','U',NULL,'N','021','DEN','2054299','33348TX002000101','2014-01-01','2013-12-24 12:45:45','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-25 18:45:13'),(25134,19937,'Y','18','021','EC','A','','','AC','0001034155','0001034155','TX00002437805','IL','1','MARTINEK','BARBARA','','','','34','464866751','1031 MARTINEK RD',0,'COLUMBUS','TX','78934',NULL,'CY','48089','1952-07-30','F','M',NULL,'N','021','DEN','3523218','33348TX002000201','2014-04-01','2014-02-20 22:33:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:05'),(7931,6272,'Y','18','021','EC','A','','','AC','0001325073','0001325073','LA00001089087','IL','1','trahan','esther','','','','34','435274235','754 PARKVIEW DR',0,'ABBEVILLE','LA','70510','7306','CY','22113','1971-06-04','F','U',NULL,'N','021','DEN','2414864','18575LA002000201','2014-01-01','2013-12-20 09:34:40','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 03:06:38'),(7915,6259,'Y','18','021','EC','A','','','AC','0000013141','0000013141','LA00001292215','IL','1','cervini','brett','','','','34','439087082','1936 HICKORY AVE',0,'HARAHAN','LA','70123','1637','CY','22051','1958-03-12','M','M',':RET:2106-3','N','021','DEN','2551871','18575LA002000201','2014-01-01','2013-12-19 21:39:01','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:11'),(2859,2309,'N','01','021','EC','A',NULL,NULL,'','0000242668','0000634775','','IL','1','Saidy-Daffeh','Denae','Christina','','','34','471989153','5697 Forest Ash Lane',0,'Columbus','OH','43229',NULL,'CY','39049','1980-10-21','F','',':RET:2106-3','N','021','DEN','1250139','99734OH005000401','2014-01-01','2013-11-01 19:53:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:01:35'),(6381,5060,'Y','18','021','EC','A','','','AC','0000712499','0000712499','OH00000936743','IL','1','Roth','Wayne','','','','34','159403942','34371 SUMMERSET DR',0,'SOLON','OH','44139','5636','CY','39035','1951-04-22','M','M',':RET:2106-3','N','021','DEN','211153','99734OH005000301','2014-01-01','2013-12-11 10:13:18','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:56'),(24957,19791,'Y','18','021','EC','A','','','AC','0002367653','0002367653','LA00002700908','IL','1','Jamerson','Shamieka','','','','34','434394273','1911 WENDELL DR',0,'Monroe','LA','71202',NULL,'CY','22073','1976-07-12','F','U',':RET:2054-5','N','021','DEN','2910611','18575LA002000201','2014-04-01','2014-02-20 14:05:42','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 22:00:16'),(24254,19259,'Y','18','024','14','A','','','TE','0001057964','0001057964','','IL','1','staton','winston',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-03-04','M','',NULL,NULL,NULL,'','1050219','','2014-03-03','2014-02-16 19:23:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-17 19:00:05'),(21755,17372,'Y','18','021','EC','A','','','AC','0000560630','0000560630','TX00002139243','IL','1','Contreras','virginia','','','','34','641289940','206 DE GAIL ST',0,'GRAND SALINE','TX','75140','1332','CY','48467','1980-07-06','F','M',NULL,'N','021','DEN','2767043','33348TX002000201','2014-03-01','2014-02-05 23:39:31','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:23'),(5317,4216,'N','01','021','EC','A',NULL,NULL,'','0000772631','0000055906','','IL','1','Williams','Lauren','','','','34','276703134','3375 LINDSTROM DR',0,'COLUMBUS','OH','43228','7062','CY','39049','1961-03-09','F','',':RET:2106-3','N','021','DEN','1663111','99734OH005000301','2014-01-01','2013-12-18 20:02:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:06:43'),(14081,11221,'Y','18','021','EC','A','','','AC','0000794503','0000794503','OH00001157978','IL','1','Jones','Tameka','','','','34','296604590','1211 VIENNA WOODS DR',0,'CINCINNATI','OH','45211','2901','CY','39061','1974-05-12','F','U',':RET:2054-5','N','021','DEN','2160450','99734OH005000401','2014-02-01','2013-12-26 10:27:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:01:06'),(15748,12599,'Y','18','021','EC','A','','','AC','0001047682','0001047682','TX00000065806','IL','1','Kline','Gayle','D','','','34','454115884','502 EAST ST',0,'GRAHAM','TX','76450','3118','CY','48503','1958-06-30','F','U',NULL,'N','021','DEN','1581359','33348TX002000201','2014-02-01','2014-01-02 14:26:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:04'),(17997,14381,'Y','18','021','EC','A','','','AC','0000526795','0000526795','OH00001936483','IL','1','Duncan','David','','','','34','299482843','308 W BUCYRUS ST',0,'CRESTLINE','OH','44827','1819','CY','39033','1957-06-03','M','U',':RET:2106-3','N','021','DEN','2656939','99734OH005000301','2014-02-01','2014-01-13 20:38:33','0.00',NULL,NULL,'21.13','21.13','R-OH007','OH0','0.00',NULL,0,'2014-01-15 02:06:59'),(16670,13341,'Y','18','021','EC','A','','','AC','0000650793','0000650793','OH00001758448','IL','1','Meek','David','','','','34','232215634','1227 CLOVERVIEW ST',0,'BLACKLICK','OH','43004','6052','CY','39049','1970-09-29','M','M',':RET:2106-3','N','021','DEN','1534724','99734OH005000301','2014-02-01','2014-01-07 14:16:59','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:28'),(25570,20285,'Y','18','021','EC','A','','','AC','0000121598','0000121598','OH00002980288','IL','1','Smith','Diedra','Skye','','','34','269968134','5860 Highview Dr',0,'Milford','OH','45150',NULL,'CY','39025','1988-07-09','F','U',':RET:2106-3','T','021','HLT','3598729','92036OH006000601','2014-04-01','2014-02-23 13:40:01','111.00',NULL,NULL,'196.57','85.57','R-OH005','OH0','196.57',NULL,0,'2014-02-26 08:00:30'),(27230,21563,'Y','18','024','14','A','','','TE','0001368886','0001368886','','IL','1','Van Slyke','Daniel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-25','M','',NULL,NULL,NULL,'','3071514','','2014-03-18','2014-03-03 17:33:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-03 21:31:41'),(28099,22240,'Y','18','021','EC','A','','','AC','0000672696','0000672696','SC00003061593','IL','1','DENNIS','PATRIQIOUS','','','','34','249811218','391 D CROSSCREEK ROAD',0,'CENTRAL','SC','39630',NULL,'CY','28037','1989-12-14','M','U',NULL,'N','021','DEN','3327690','46300MS002000101','2014-04-01','2014-03-06 13:47:14','0.00',NULL,NULL,'27.15','27.15','R-MS006','SC0','27.15',NULL,0,'2014-03-06 21:02:09'),(21639,17279,'Y','18','021','EC','A','','','AC','0000968510','0000968510','TX00002009973','IL','1','Miller','Taya','','','','34','634128111','2600 W LOOP 250 N',0,'MIDLAND','TX','79705','3100','CY','48329','1989-10-08','F','U',':RET:2054-5','N','021','DEN','3297899','33348TX002000201','2014-03-01','2014-02-05 14:14:48','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-05 21:30:44'),(9691,7676,'Y','18','024','14','A','','','TE','0000422809','0000422809','','IL','1','Harsh','rodney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-05-06','M','',NULL,NULL,NULL,'','1721839','','2013-12-21','2013-12-21 14:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:43'),(21028,16802,'N','19','021','EC','A',NULL,NULL,'','0000878298','0000303400','','IL','1','CHAPPELL-DICK','SARA','','','','34','298989742','207 N. LAWN AVE',0,'BLUFFTON','OH','45817',NULL,'CY','39003','1996-05-14','F','',':RET:2106-3','N','021','HLT','3031528','92036OH006001501','2014-03-01','2014-01-31 23:04:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-02-01 19:00:43'),(20846,16662,'N','19','021','EC','A',NULL,NULL,'','0000024143','0001031481','','IL','1','Ganim','Grace','','','','34','302061927','852 EDGAR LN',0,'BRUNSWICK','OH','44212','5634','CY','39103','2002-07-21','F','',':RET:2106-3','N','021','DEN','3614093','99734OH005000301','2014-03-01','2014-01-30 20:04:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:49'),(2546,2072,'Y','18','021','EC','A','','','AC','0000138988','0000138988','OH00000407723','IL','1','EBERT','JAMES','','','','34','275489995','3540 WEYRICK DR',0,'NORTON','OH','44203','5549','CY','39153','1950-08-01','M','U',':RET:2106-3','N','021','HLT','939858','52664OH151001501','2014-01-01','2013-12-09 12:14:00','541.00',NULL,NULL,'789.56','248.56','R-OH012','OH0','789.56',NULL,0,'2013-12-25 19:37:10'),(3221,2592,'Y','18','021','EC','A','','','AC','0000717794','0000717794','OH00001101625','IL','1','Saw','Allison','','','','34','372338112','2912 SQUIRREL BND',0,'TOLEDO','OH','43617','1367','CY','39095','1976-12-05','F','U',':RET:2028-9','N','021','HLT','190886','92036OH004002601','2014-01-01','2013-10-31 18:37:14','162.00',NULL,NULL,'194.11','32.11','R-OH001','OH0','194.11',NULL,0,'2013-12-25 20:45:44'),(7128,5657,'Y','18','021','EC','A','','','AC','0000387281','0000387281','OH00000586450','IL','1','Bauer','Richard','','','','34','302527820','870 Oak canyon Drive',0,'Loveland','OH','45140',NULL,'CY','39061','1952-10-01','M','M',':RET:2106-3','N','021','HLT','2034375','92036OH005001204','2014-02-01','2013-12-25 00:45:24','835.00',NULL,NULL,'1286.53','451.53','R-OH004','OH0','603.24',NULL,0,'2013-12-26 01:51:33'),(20824,16643,'Y','18','021','EC','A','','','AC','0002164560','0002164560','LA00001645558','IL','1','Watson','Carolyn','Golden','','','34','437176254','44423 W PLEASANT RIDGE RD',0,'HAMMOND','LA','70403','0213','CY','22105','1961-02-12','F','M',':RET:2054-5','N','021','DEN','3005927','18575LA002000201','2014-03-01','2014-01-31 14:51:39','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-31 21:00:37'),(14333,11433,'Y','18','021','EC','A','','','AC','0000336432','0000336432','OH00001441509','IL','1','Cherewick','Robert','','','','34','371846286','855 HURD AVE',0,'FINDLAY','OH','45840','3019','CY','39063','1961-04-28','M','U',':RET:2106-3','N','021','HLT','2319522','92036OH004001501','2014-02-01','2013-12-26 13:22:30','342.90',NULL,NULL,'345.43','2.53','R-OH002','OH0','345.43',NULL,0,'2013-12-27 02:07:38'),(20525,16401,'Y','18','024','14','A','','','TE','0001071775','0001071775','','IL','1','BRADMAN','REBECCA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-09-13','F','',NULL,NULL,NULL,'','2112195','','2014-01-29','2014-01-29 15:11:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:27'),(20518,16394,'Y','18','021','EC','A','','','AC','0000351889','0000351889','TX00001725549','IL','1','Prochaska','Steven','','','','34','395902071','6172 BLUE SPRUCE CIR',0,'HALTOM CITY','TX','76137','2135','CY','48439','1983-04-14','M','U',':RET:2106-3','T','021','DEN','2716383','33348TX002000101','2014-03-01','2014-01-29 12:29:29','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-29 21:01:23'),(26963,21362,'Y','18','021','EC','A','','','AC','0001053110','0001053110','OH00003371128','IL','1','Sohrabi','Ray','','','','34','577864342','4261 Americana Dr',0,'Cuyahoga Falls','OH','44224',NULL,'CY','39153','1949-08-31','M','U',':RET:2106-3','N','021','HLT','3830810','52664OH151001305','2014-04-01','2014-03-02 14:27:43','531.00',NULL,NULL,'669.00','138.00','R-OH012','OH0','669.00',NULL,0,'2014-03-03 01:00:31'),(27498,21757,'Y','18','021','EC','A','','','AC','0000356087','0000356087','OH00003225674','IL','1','Cassabon','Franklin','O','','III','34','296828729','4022 ASBURY DR',0,'TOLEDO','OH','43612','1802','CY','39095','1985-02-21','M','U',':RET:2106-3','N','021','HLT','3467203','92036OH004002601','2014-04-01','2014-03-04 10:07:09','136.00',NULL,NULL,'175.45','39.45','R-OH001','OH0','175.45',NULL,0,'2014-03-04 21:02:27'),(27746,21940,'Y','18','021','EC','A','','','AC','0001108153','0001108153','OH00003508158','IL','1','Little','Jill','','','','34','290522341','314 CLINTON ST',0,'MAUMEE','OH','43537','2814','CY','39095','1951-11-25','F','M',':RET:2106-3','N','021','HLT','3432194','92036OH004002601','2014-04-01','2014-03-05 17:29:36','288.00',NULL,NULL,'450.46','162.46','R-OH001','OH0','450.46',NULL,0,'2014-03-05 21:31:12'),(25440,20185,'N','19','021','EC','A',NULL,NULL,'','0001022232','0000967148','','IL','1','GOODLEY','ANTWAN','','','','34','645244302','1407 E PENNSYLVANIA AVE',0,'MIDLAND','TX','79701','8343','CY','48329','1991-09-06','M','',':RET:2054-5','N','021','DEN','2821906','33348TX002000201','2014-04-01','2014-02-25 11:16:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:20'),(13408,10699,'Y','18','021','EC','A','','','AC','0000860975','0000860975','OH00001320325','IL','1','Cobb','David','','','','34','257439198','20102 WICKFIELD AVE',0,'WARRENSVILLE HEIGHTS','OH','44122','6553','CY','39035','1973-01-13','M','M',':RET:2054-5','N','021','DEN','1708138','99734OH005000301','2014-01-01','2013-12-23 09:56:32','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:30'),(24434,19408,'N','19','021','EC','A',NULL,NULL,'','0000524538','0000530747','','IL','1','Theodore','Lena','','','','34','283027370','889 ROBINSON AVE',0,'BARBERTON','OH','44203','3850','CY','39153','1997-07-18','F','',':RET:2106-3','N','021','HLT','3674864','52664OH151001305','2014-04-01','2014-02-18 13:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-18 22:01:15'),(1564,1305,'Y','18','021','EC','A','','','AC','0000821752','0000821752','TX00001208312','IL','1','Rhem','Nichelle','','','','34','198643394','7013 Sorcey Rd.',0,'Dallas','TX','75249',NULL,'CY','48113','1983-07-04','F','U',':RET:2054-5','N','021','DEN','1875084','33348TX002000201','2014-01-01','2013-12-24 05:44:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:50:59'),(23827,18958,'N','17','021','EC','A',NULL,NULL,'','0000246689','0000897139','','IL','1','Boyd','Joseph','','','','34','425750052','4786 OLD 8TH STREET RD N',0,'MERIDIAN','MS','39307','9781','CY','28075','1992-10-20','M','',NULL,'N','021','DEN','2787857','46300MS002000101','2014-03-01','2014-02-13 22:36:14',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-14 21:31:43'),(4678,3708,'Y','18','021','EC','A','','','AC','0000406375','0000406375','LA00000933287','IL','1','cage','ashley','','','','34','438774762','986 MONET DR',0,'BATON ROUGE','LA','70806','2273','CY','22033','1986-04-19','F','U',':RET:2054-5','N','021','DEN','448229','18575LA002000201','2014-01-01','2013-12-12 15:07:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:07:48'),(23307,18581,'Y','18','021','EC','A','','','AC','0000689734','0000689734','OH00002370127','IL','1','Walden','Charles','','','','34','276443304','405 BANK AVE',0,'CINCINNATI','OH','45217','1214','CY','39061','1959-04-05','M','M',':RET:2106-3','N','021','DEN','2721161','99734OH005000301','2014-03-01','2014-02-13 11:28:29','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:19'),(21427,17124,'Y','18','021','EC','A','','','AC','0001201926','0001201926','OH00001619625','IL','1','Thomas','David','','','','34','174747130','30 FLANDERS LN',0,'CINCINNATI','OH','45218','1502','CY','39061','1992-11-23','M','U',':RET:2054-5^:RET:2106-3','T','021','HLT','3800693','92036OH004001201','2014-03-01','2014-02-04 01:00:00','0.00',NULL,NULL,'198.50','198.50','R-OH004','OH0','198.50',NULL,0,'2014-02-04 21:01:15'),(16352,13088,'Y','18','021','EC','A','','','AC','0000678111','0000678111','OH00001372568','IL','1','HARRISON','PEGGIE','ANN','','','34','432218193','2141 KEMERY RD',0,'AKRON','OH','44333','1939','CY','39153','1958-09-04','F','M',':RET:2054-5','N','021','DEN','2303600','99734OH005000301','2014-02-01','2014-01-06 11:50:34','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-07 04:02:31'),(19380,15449,'Y','18','021','EC','A','','','AC','0000384112','0000384112','MS00002114176','IL','1','PHELPS','JAMAL','','','','34','171681857','41 CAVERS RD',0,'BUCKATUNNA','MS','39322','9661','CY','28153','1977-01-19','M','U',NULL,'N','021','DEN','3085046','46300MS002000101','2014-03-01','2014-01-21 12:20:30','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2014-01-22 03:22:41'),(27039,21415,'Y','18','021','EC','A','','','AC','0000550795','0000550795','TX00002381715','IL','1','Valenta','Timothy','','','','34','449316301','4029 WINDMILL RIDGE CIR',0,'OVILLA','TX','75154','5552','CY','48139','1965-11-19','M','M',':RET:2106-3','N','021','DEN','3791697','33348TX002000201','2014-04-01','2014-03-03 17:25:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-03-03 21:00:20'),(27380,21677,'N','19','021','EC','A',NULL,NULL,'','0001092477','0000733718','','IL','1','COOPER','ZAVEON','D','','Jr','34','427794189','850 PRIMOS AVE',0,'JACKSON','MS','39209','6137','CY','28049','1995-07-10','M','',':RET:2054-5','N','021','DEN','3700801','46300MS002000101','2014-04-01','2014-03-04 17:10:07',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-03-04 21:01:20'),(25150,19951,'Y','18','021','EC','A','','','AC','0000863234','0000863234','TX00002348832','IL','1','bechner','richard','','','','34','551087595','1631 fm 3251',0,'Hallsville','TX','75650',NULL,'CY','48203','1971-09-24','M','M',':RET:2106-3','N','021','DEN','3514031','33348TX002000201','2014-04-01','2014-02-21 13:18:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:16'),(23050,18377,'Y','18','021','EC','A','','','AC','0000644323','0000644323','TX00002571351','IL','1','Nguyen','Phat','','','','34','433953340','5205 HIGHBANK DR',0,'ARLINGTON','TX','76018','4923','CY','48439','1974-08-06','M','U',':RET:2047-9','T','021','DEN','2652106','33348TX002000201','2014-03-01','2014-02-12 16:27:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:45'),(24656,19573,'Y','18','021','EC','A','','','AC','0000457850','0000457850','OH00002547968','IL','1','Graham','Sharon','','','','34','290522434','2318 Kenwood Blvd',0,'Toledo','OH','43606',NULL,'CY','39095','1952-07-01','F','U',NULL,'N','021','HLT','2864581','92036OH004002601','2014-04-01','2014-02-18 21:51:57','167.00',NULL,NULL,'440.60','273.60','R-OH001','OH0','440.60',NULL,0,'2014-02-20 04:24:24'),(26387,20931,'N','01','021','EC','A',NULL,NULL,'','0000194050','0000599760','','IL','1','Taylor','Brian','','','','34','272863807','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1983-03-22','M','',':RET:2106-3','N','021','HLT','3232398','52664OH151001301','2014-03-01','2014-02-26 11:42:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11','CIC',0,'2014-02-28 07:00:23'),(26896,21316,'Y','18','024','14','A','','','TE','0000150508','0000150508','','IL','1','Coleman','Regina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-10-14','F','',NULL,NULL,NULL,'','3805637','','2014-03-16','2014-03-01 19:45:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-03 01:00:05'),(1947,1587,'Y','18','021','EC','A','','','AC','0000214617','0000214617','OH00000654915','IL','1','BURROWS','LINDA','','','','34','272769956','4615 ABBEYVILLE RD',0,'MEDINA','OH','44256',NULL,'CY','39103','1964-03-19','F','M',':RET:2106-3','T','021','DEN','973323','99734OH005000401','2014-01-01','2013-11-20 16:14:46','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:00:51'),(19873,15852,'Y','18','021','EC','A','','','AC','0000904291','0000904291','OH00002550094','IL','1','Malone','Demetrus','','','','34','300720975','10112 OLIVET AVE',0,'CLEVELAND','OH','44108','3548','CY','39035','1963-01-17','M','U',':RET:2054-5','N','021','DEN','2712687','99734OH005000401','2014-03-01','2014-01-24 13:27:05','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-24 21:00:42'),(18270,14585,'Y','18','021','EC','A','','','AC','0000280512','0000280512','TX00001760076','IL','1','LABURDA','RICHARD','','','','34','465850177','120 W RUSSELL AVE',0,'BONHAM','TX','75418',NULL,'CY','48147','1972-10-06','M','M',NULL,'T','021','DEN','2318602','33348TX002000201','2014-02-01','2014-01-15 17:14:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:41'),(7441,5889,'Y','18','021','EC','A','','','AC','0001066960','0001066960','OH00000857943','IL','1','Boes','Matthew','','','','34','294904624','53 S HIGHLAND AVE',0,'AKRON','OH','44303','1022','CY','39153','1989-12-02','M','U',':RET:2106-3','N','021','DEN','708241','99734OH005000301','2014-01-01','2013-12-14 18:42:46','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:30:25'),(16443,13156,'N','01','021','EC','A',NULL,NULL,'','0000289080','0000031738','','IL','1','dressner','joshua','','','','34','434573028','31 virgil mitchell rd',0,'picayune','MS','39466',NULL,'CY','28109','1981-10-31','M','',':RET:2106-3','N','021','DEN','1555615','46300MS002000101','2014-02-01','2014-01-05 23:11:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-07 04:05:09'),(7323,5802,'N','01','021','EC','A',NULL,NULL,'','0000566077','0000217985','','IL','1','dobbs','tahya','','','','34','426535351','648 lakewood cove',0,'brandon','MS','39042',NULL,'CY','28121','1970-10-08','F','',':RET:2106-3','N','021','DEN','754977','46300MS002000201','2014-01-01','2013-12-14 10:58:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 02:03:38'),(7285,5777,'Y','18','021','EC','A','','','AC','0000609515','0000609515','OH00001067606','IL','1','WERT','MARY','F','','','34','268647113','8929 S MAIN ST',0,'WINDHAM','OH','44288',NULL,'CY','39133','1962-03-18','F','M',':RET:2106-3','N','021','HLT','666388','52664OH151001501','2014-01-01','2013-12-14 09:35:11','425.00',NULL,NULL,'1020.91','595.91','R-OH012','OH0','498.82',NULL,0,'2013-12-26 02:02:48'),(15487,12391,'Y','18','021','EC','A','','','AC','0000144228','0000144228','OH00002089927','IL','1','OSBORNE','JENNIFER','','','','34','298664436','5689 WERKSHIRE TER',0,'MILFORD','OH','45150','2028','CY','39025','1970-07-18','F','U',':RET:2106-3','N','021','DEN','1840893','99734OH005000401','2014-02-01','2013-12-31 10:28:34','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,1,'2014-01-02 04:29:22'),(3472,2789,'Y','18','021','EC','A','','','AC','0000086420','0000086420','OH00001305292','IL','1','Sutherland','Phillip','','','','34','293119904','5120 Free Pike',0,'trotwood','OH','45426',NULL,'CY','39113','1962-02-13','M','M',':RET:2054-5','N','021','DEN','2570534','99734OH005000401','2014-01-01','2013-12-22 10:33:13','0.00',NULL,NULL,'50.05','50.05','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:00'),(5984,4736,'Y','18','021','EC','A','','','AC','0000353980','0000353980','OH00001257172','IL','1','Anderson','Brenda','','','','34','301483510','1429 S CENTER BLVD',0,'SPRINGFIELD','OH','45506','2709','CY','39023','1951-04-16','F','U',':RET:1002-5^:RET:2106-3','T','021','HLT','1518529','92036OH006000501','2014-01-01','2013-12-24 00:25:31','436.00',NULL,NULL,'622.85','186.85','R-OH003','OH0','622.85',NULL,0,'2013-12-25 23:52:00'),(5533,4389,'Y','18','021','EC','A','','','AC','0001081765','0001081765','OH00000015322','31','1','Bencar','Chris','','','','34','272909722','PO Box 593',0,'geneva','OH','44041',NULL,'CY','39007','1988-11-18','M','U',':RET:2106-3','N','021','DEN','927034','99734OH005000401','2014-01-01','2013-11-27 12:23:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:15:38'),(13843,11047,'Y','18','021','EC','A','','','AC','0000165074','0000165074','OH00001120471','IL','1','Franjesevic','Carol','A','','','34','197468094','64 WILSON AVE',0,'NILES','OH','44446','1929','CY','39155','1955-04-12','F','M',':RET:2106-3','T','021','HLT','2321872','52664OH152000901','2014-01-01','2013-12-23 15:03:15','539.00',NULL,NULL,'542.77','3.77','R-OH013','OH0','542.77',NULL,0,'2013-12-26 13:12:21'),(14045,11190,'Y','18','021','EC','A','','','AC','0001102097','0001102097','OH00001770296','IL','1','Dao','Phuong','','','','34','612036269','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1987-12-08','M','M',':RET:2047-9','N','021','DEN','2558216','99734OH005000301','2014-02-01','2013-12-26 08:47:01','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:00:08'),(14126,11259,'Y','18','021','EC','A','','','AC','0002397100','0002397100','LA00001231307','IL','1','Riche','Robert','','','','34','489902365','2901C LAFITTE ST',0,'NEW ORLEANS','LA','70119','4119','CY','22071','1980-02-17','M','U',':RET:2106-3','T','021','DEN','2474275','18575LA002000201','2014-02-01','2013-12-25 20:28:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:15'),(15414,12330,'Y','18','021','EC','A','','','AC','0000029526','0000029526','TX00002045974','IL','1','Lee','Anthony','','','','34','460399112','2802 FRANKLIN RD',0,'MARSHALL','TX','75670','5775','CY','48203','1976-09-25','M','M',':RET:2054-5','T','021','DEN','1522053','33348TX002000201','2014-02-01','2013-12-31 01:30:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:13'),(25161,19958,'Y','18','021','EC','A','','','AC','0000812200','0000812200','TX00002837940','IL','1','Austin','Tanya','','','','34','450515671','810 N MCCARTY AVE',0,'EAGLE LAKE','TX','77434','1319','CY','48089','1965-03-06','F','U',':RET:2054-5','N','021','DEN','3164108','33348TX002000201','2014-04-01','2014-02-21 17:39:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:22'),(25508,20237,'Y','18','021','EC','A','','','AC','0000253099','0000253099','OH00002702303','IL','1','Harden','Emily','','','','34','260736497','890 GARMAN LN',0,'BAINBRIDGE','OH','45612','9787','CY','39071','1989-12-27','F','U',':RET:2106-3','N','021','HLT','3839737','92036OH004000601','2014-04-01','2014-02-25 10:25:44','129.00',NULL,NULL,'172.61','43.61','R-OH005','OH0','172.61',NULL,0,'2014-02-25 21:31:59'),(27104,21455,'Y','18','021','EC','A','','','AC','0000241572','0000241572','OH00003076503','IL','1','overbey','jessica','','','','34','304067321','7835 3RD ST',0,'WEST CHESTER','OH','45069','2215','CY','39017','1985-05-24','F','U',':RET:2106-3','N','021','DEN','3711279','99734OH005000301','2014-04-01','2014-03-03 09:56:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:23'),(27314,21627,'Y','18','021','EC','A','','','AC','0000474772','0000474772','TX00002374310','31','1','BADILLO','ROBERTO','','','','34','460410771','PO BOX 733',0,'SANTA ROSA','TX','78593',NULL,'CY','48061','1963-10-06','M','M',':RET:2106-3','N','021','DEN','3879283','33348TX002000201','2014-04-01','2014-03-04 14:44:07','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-03-04 21:00:41'),(22641,18079,'Y','18','021','EC','A','','','AC','0000545260','0000545260','TX00002273046','IL','1','IBARRA GOMEZ','LIDIA','','','','34','458951043','236 LOVING LN',0,'CORRIGAN','TX','75939','8078','CY','48373','1957-05-10','F','M',NULL,'N','021','DEN','2700387','33348TX002000201','2014-03-01','2014-02-11 10:16:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:22'),(2442,1989,'N','01','021','EC','A',NULL,NULL,'','0001097761','0000652097','','IL','1','Preto','Robert','Edward','','','34','286629150','1206 WEISER AVE',0,'AKRON','OH','44314','1429','CY','39153','1957-08-24','M','',':RET:2106-3','N','021','HLT','550597','52664OH151001306','2014-01-01','2013-12-09 17:00:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-25 19:34:27'),(20739,16569,'N','01','021','EC','A',NULL,NULL,'','0000977970','0000159445','','IL','1','koons','chad','','','','34','313767758','327 MORROW ST',0,'GREENVILLE','OH','45331','1836','CY','39037','1973-01-18','M','',':RET:2106-3','N','021','HLT','3040152','92036OH005000501','2014-03-01','2014-01-29 20:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','309.50',NULL,0,'2014-01-30 21:01:22'),(4376,3477,'Y','18','021','EC','A','','','AC','0000267507','0000267507','OH00000735692','IL','1','BAN','LINDA','ANN','','','34','234867061','618 E YEASTING ST',0,'GIBSONBURG','OH','43431','1428','CY','39143','1951-09-14','F','M',':RET:2106-3','T','021','DEN','71986','99734OH005000401','2014-01-01','2013-12-12 08:10:07','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 22:00:28'),(20561,16431,'Y','18','021','EC','A','','','AC','0000605990','0000605990','OH00001946898','IL','1','gill','shadley','','','','34','535114863','5000 WOODRIDGE DR',0,'MIDDLETOWN','OH','45044','6244','CY','39017','1976-04-13','M','U',':RET:2106-3','N','021','HLT','2890645','92036OH006001201','2014-03-01','2014-01-29 13:07:53','143.14',NULL,NULL,'210.76','67.62','R-OH004','OH0','210.76',NULL,0,'2014-01-29 21:01:46'),(19805,15790,'Y','18','021','EC','A','','','AC','0000187461','0000187461','TX00001850415','31','1','ROMERO','SOCORRO','','','','34','641381279','PO BOX 393',0,'ROCKSPRINGS','TX','78880',NULL,'CY','48137','1954-11-22','F','M',NULL,'N','021','DEN','2987388','33348TX002000201','2014-03-01','2014-01-24 15:34:14','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-24 21:00:06'),(18243,14562,'Y','18','021','EC','A','','','AC','0000580367','0000580367','TX00002316243','IL','1','Ellis','Larissa','','','','34','463776846','2031 Shahan Rd',0,'San Angelo','TX','76904',NULL,'CY','48451','1971-08-12','F','M',':RET:2106-3','N','021','DEN','2579297','33348TX002000201','2014-02-01','2014-01-15 12:47:26','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-16 08:44:26'),(7379,5844,'Y','18','021','EC','A','','','AC','0000062503','0000062503','OH00000750973','IL','1','CLOSSON','MICHAEL','','','','34','293468478','1284 S BREDEICK ST',0,'DELPHOS','OH','45833','2299','CY','39161','1949-12-07','M','M',':RET:2106-3','N','021','DEN','144202','99734OH005000401','2014-01-01','2013-11-23 08:24:32','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-26 02:15:54'),(16384,13111,'Y','18','021','EC','A','','','AC','0000978851','0000978851','TX00000489116','IL','1','Nguyen','Quynh','','','','34','586384514','2915 GAINESBOROUGH DR',0,'DALLAS','TX','75287','3486','CY','48121','1951-10-12','M','M',':RET:2047-9','N','021','DEN','2368545','33348TX002000201','2014-02-01','2014-01-05 23:18:18','0.00',NULL,NULL,'47.55','47.55','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:25'),(28611,22644,'Y','18','021','EC','A','','','AC','0000440882','0000440882','OH00002858150','31','1','Shafer','Sharon','','','','34','288447017','PO Box 223',0,'Urbana','OH','43078',NULL,'CY','39021','1949-06-10','F','U',':RET:2106-3','T','021','DEN','3482759','99734OH005000401','2014-04-01','2014-03-08 16:46:18','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-08 21:30:15'),(1153,951,'Y','18','021','EC','A','','','AC','0000922190','0000922190','LA00001229048','IL','1','Nichols','Johnathan','','','','34','436811750','100 LAKEVIEW DR',0,'NATCHITOCHES','LA','71457','5454','CY','22069','1991-01-18','M','U',':RET:2054-5','T','021','DEN','1126722','18575LA002000201','2014-01-01','2013-12-03 11:04:24','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:18:41'),(22028,17586,'Y','18','021','EC','A','','','AC','0000951839','0000951839','OH00002603361','IL','1','COOK','SHENIKA','','','','34','297820144','135 CHESTNUT LN',0,'CLEVELAND','OH','44143',NULL,'CY','39035','1985-02-25','F','U',':RET:2054-5','N','021','HLT','2887171','52664OH152000901','2014-03-01','2014-02-07 09:08:34','132.00',NULL,NULL,'206.15','74.15','R-OH011','OH0','206.15',NULL,0,'2014-02-07 19:01:02'),(1617,1352,'Y','18','021','EC','A','','','AC','0000088430','0000088430','TX00000439284','IL','1','Rayburn','Paedric','','','','34','459979490','111 N Pear St',0,'Alpine','TX','79830',NULL,'CY','48043','1981-10-18','M','M',':RET:2106-3','T','021','DEN','2538506','33348TX002000201','2014-01-01','2013-12-24 13:23:54','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:52:29'),(21277,17004,'N','01','021','EC','A',NULL,NULL,'','0001136679','0000407411','','IL','1','Hysell','Crystal','','','','34','286824550','249 S BEECHGROVE RD',0,'WILMINGTON','OH','45177','7617','CY','39027','1983-09-29','F','',':RET:2106-3','N','021','HLT','3238278','92036OH005000605','2014-03-01','2014-02-03 16:18:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','243.66',NULL,0,'2014-02-03 21:01:34'),(14505,11571,'N','01','021','EC','A',NULL,NULL,'','0000449392','0000950146','','IL','1','Montano','Frances','','','','34','563154781','6803 MICHELLE DR',0,'AMARILLO','TX','79109','7419','CY','48381','1956-12-23','F','',':RET:2106-3','N','021','DEN','2504523','33348TX002000201','2014-02-01','2013-12-27 14:39:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:54'),(13367,10677,'Y','18','021','EC','A','','','AC','0000034370','0000034370','OH00000487485','IL','1','Coleman','Vicky','','','','34','268628897','2518 ORLAND AVE',0,'CINCINNATI','OH','45211','8306','CY','39061','1956-10-31','F','U',':RET:2054-5','N','021','DEN','1493570','99734OH005000301','2014-01-01','2013-12-22 20:15:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:59:39'),(24374,19360,'Y','18','021','EC','A','','','AC','0002168375','0002168375','LA00002849383','IL','1','BHATT','GAYATRI','','','','34','283741869','9634 HIGHWAY 65 S',0,'LAKE PROVIDENCE','LA','71254','4010','CY','22035','1954-08-15','F','M',NULL,'N','021','DEN','2809661','18575LA002000201','2014-04-01','2014-02-18 17:46:53','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-18 22:00:40'),(25202,19992,'Y','18','021','EC','A','','','AC','0001344251','0001344251','LA00002119841','IL','1','BROWN','ROBERT','','','','34','437132181','5224 COLISEUM ST',0,'NEW ORLEANS','LA','70115','3006','CY','22071','1958-09-10','M','U',':RET:2106-3','N','021','DEN','3367908','18575LA002000201','2014-04-01','2014-02-21 15:46:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-21 22:00:46'),(26962,21361,'N','01','021','EC','A',NULL,NULL,'','0000927364','0000326247','','IL','1','MOZINA','KIRK','','','','34','276647830','9102 TANGLEWOOD RD',0,'MACEDONIA','OH','44056',NULL,'CY','39153','1958-09-17','M','',NULL,'N','021','HLT','2807667','52664OH151001301','2014-04-01','2014-03-02 13:46:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-03-03 01:00:30'),(569,467,'Y','18','021','EC','A','','','AC','0000846115','0000846115','OH00000880335','IL','1','Reynolds','Jennifer','','','','34','295806509','5921 Cedaridge Dr.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1983-10-06','F','M',':RET:2106-3','N','021','HLT','330460','92036OH005001205','2014-01-01','2013-12-03 21:00:56','328.00',NULL,NULL,'500.82','172.82','R-OH004','OH0','243.66',NULL,0,'2013-12-25 17:50:33'),(23863,18988,'Y','18','021','EC','A','','','AC','0001415065','0001415065','LA00001916646','IL','1','Grace','Patsy','','','','34','099464508','4474 Arts Street',0,'New Orleans','LA','70122',NULL,'CY','22071','1966-07-27','F','U',':RET:2106-3','N','021','DEN','2713154','18575LA002000101','2014-03-01','2014-02-14 16:12:51','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:06'),(22603,18052,'Y','18','021','EC','A','','','AC','0000879487','0000879487','OH00001530556','IL','1','Taylor','Nicole','','','','34','283846655','8695 MCMECHAM RD',0,'GREENVILLE','OH','45331','9466','CY','39037','1983-01-02','F','M',':RET:2106-3','N','021','HLT','2860955','92036OH003000505','2014-03-01','2014-02-10 14:12:59','154.00',NULL,NULL,'287.71','133.71','R-OH003','OH0','287.71',NULL,0,'2014-02-10 21:32:16'),(22212,17729,'Y','18','021','EC','A','','','AC','0001520689','0001520689','LA00001882836','IL','1','QUAN','TRINH','','','','34','439935228','129 COLONIAL HEIGHTS RD',0,'RIVER RIDGE','LA','70123','3518','CY','22051','1965-08-25','F','M',':RET:2047-9','N','021','DEN','2782889','18575LA002000201','2014-03-01','2014-02-08 18:44:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:21'),(21172,16920,'Y','18','021','EC','A','','','AC','0001204571','0001204571','OH00001406309','IL','1','MYERS','CASSANDRA','LEE','','','34','297883024','235 PARMELY AVE',0,'ELYRIA','OH','44035','2645','CY','39093','1988-07-09','F','U',':RET:2106-3','T','021','DEN','3789473','99734OH005000401','2014-03-01','2014-02-03 14:26:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:38'),(18579,14815,'Y','18','021','EC','A','','','AC','0001043414','0001043414','OH00002004843','IL','1','cover','ronald','','','','34','284480007','1128 county road 620',0,'ashland','OH','44805',NULL,'CY','39005','1950-02-24','M','M',NULL,'N','021','HLT','2632161','52664OH151001501','2014-02-01','2014-01-15 00:40:55','1067.00',NULL,NULL,'1541.14','474.14','R-OH012','OH0','789.56',NULL,0,'2014-01-16 08:47:08'),(6677,5296,'Y','18','021','EC','A','','','AC','0001158882','0001158882','OH00000789099','IL','1','Vasari','Terrence','','','','34','300980768','1945 Copley rd',0,'Copley','OH','44320',NULL,'CY','39153','1981-08-13','M','U',':RET:2106-3','N','021','HLT','116433','52664OH152000901','2014-01-01','2013-11-16 12:30:35','0.00',NULL,NULL,'193.23','193.23','R-OH012','OH0','193.23',NULL,0,'2013-12-26 01:01:17'),(16389,13114,'Y','18','021','EC','A','','','AC','0000253329','0000253329','TX00001780371','IL','1','Suciu','Susana','','','','34','641483270','7007 Sable Ln',0,'Sachse','TX','75048',NULL,'CY','48085','1955-11-14','F','M',':RET:2106-3','N','021','DEN','1902593','33348TX002000201','2014-02-01','2014-01-06 10:16:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:30'),(25020,19839,'Y','18','024','14','A','','','TE','0000359707','0000359707','','IL','1','Swanson','Alia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-03','F','',NULL,NULL,NULL,'','2190168','','2014-02-20','2014-02-20 17:47:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 22:00:56'),(25476,20212,'Y','18','021','EC','A','','','AC','0000956584','0000956584','TX00003037502','IL','1','Ostert','Cindy','','','','34','533649720','1317 AUSTIN ST',0,'COLUMBUS','TX','78934','2501','CY','48089','1956-06-16','F','M',':RET:2106-3','N','021','DEN','3798653','33348TX002000201','2014-04-01','2014-02-25 17:50:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:40'),(26554,21054,'Y','18','021','EC','A','','','AC','0001030419','0001030419','OH00002704639','IL','1','Supe','Kyle','','','','34','396882505','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','1982-04-12','M','M',':RET:2106-3','N','021','DEN','2969530','99734OH005000301','2014-03-01','2014-02-28 15:58:36','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:16'),(27460,21732,'N','01','021','EC','A',NULL,NULL,'','0001234176','0000398673','','IL','1','FRANKLIN','DEBRA','','','','34','280681600','4434 MINOR RD',0,'COPLEY','OH','44321','2430','CY','39153','1961-07-05','F','',':RET:2106-3','N','021','HLT','2868556','52664OH152000901','2014-04-01','2014-03-04 12:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','318.84',NULL,0,'2014-03-04 21:02:05'),(24150,19188,'Y','18','021','EC','A','','','AC','0000212216','0000212216','OH00002211488','IL','1','Spray','Karen','','','','34','275662924','216 N EAST ST',0,'MASON','OH','45040','1759','CY','39165','1974-05-17','F','R',':RET:2106-3','T','021','HLT','3394059','92036OH005001201','2014-03-01','2014-02-15 11:06:58','0.00',NULL,NULL,'311.54','311.54','R-OH004','OH0','311.54',NULL,0,'2014-02-15 22:01:55'),(19598,15623,'Y','18','021','EC','A','','','AC','0000422844','0000422844','OH00002307274','IL','1','Lynch','Michelle','','','','34','296764032','95 OLSON SPUR',0,'MUNROE FALLS','OH','44262','1025','CY','39153','1966-10-12','F','U',':RET:2106-3','N','021','HLT','2632361','52664OH151001501','2014-03-01','2014-01-22 17:59:18','182.00',NULL,NULL,'587.89','405.89','R-OH012','OH0','418.05',NULL,0,'2014-01-23 03:02:47'),(18213,14537,'Y','18','021','EC','A','','','AC','0000121562','0000121562','OH00002426334','IL','1','Rose','Delia','','','','34','291569892','10575 BIDDULPH RD',0,'BROOKLYN','OH','44144','3036','CY','39035','1955-03-04','F','U',':RET:2106-3','N','021','HLT','1485736','92036OH004000801','2014-02-01','2014-01-14 16:57:48','0.00',NULL,NULL,'479.00','479.00','R-OH011','OH0','479.00',NULL,0,'2014-01-15 02:08:11'),(16601,13278,'Y','18','021','EC','A','','','AC','0001746227','0001746227','LA00001272559','IL','1','Smith','Kim','','','','34','433021239','1205 STEEN LOOP',0,'JENA','LA','71342','6648','CY','22059','1957-03-30','F','M',':RET:2106-3','N','021','DEN','1392952','18575LA002000201','2014-02-01','2014-01-07 13:23:37','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-08 18:24:04'),(6044,4787,'Y','18','021','EC','A','','','AC','0000642041','0000642041','OH00001091980','IL','1','Heskamp','Joshua','','','','34','129728619','419 Kellyann Ct.',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-10-22','M','U',':RET:2106-3','N','021','HLT','140382','52664OH152001001','2014-01-01','2013-12-01 13:31:24','0.00',NULL,NULL,'125.55','125.55','R-OH012','OH0','125.55',NULL,0,'2013-12-26 00:01:28'),(15672,12537,'Y','18','021','EC','A','','','AC','0000749537','0000749537','OH00001763553','IL','1','Haines','Heather','','','','34','286724532','202 W FOREST ST',0,'CELINA','OH','45822','1062','CY','39107','1971-11-23','F','M',':RET:2106-3','N','021','HLT','2183681','92036OH004001501','2014-02-01','2013-12-31 18:30:14','171.00',NULL,NULL,'464.90','293.90','R-OH002','OH0','234.49',NULL,1,'2014-01-02 04:34:44'),(14675,11715,'Y','18','021','EC','A','','','AC','0000061512','0000061512','MS00000250574','IL','1','Odom','Michele','','','','34','042524089','5 SWALLOW LN',0,'LAUREL','MS','39443','9408','CY','28067','1966-01-20','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1596118','46300MS002000201','2014-02-01','2013-12-28 14:00:09','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,1,'2013-12-29 11:08:22'),(14492,11561,'N','01','021','EC','A',NULL,NULL,'','0000490389','0000272920','','IL','1','Smith','Henry','','','','34','460987793','2437 FRANKSTON HWY',0,'TYLER','TX','75701','3891','CY','48423','1954-12-22','M','',':RET:2054-5','N','021','DEN','2121358','33348TX002000201','2014-02-01','2013-12-27 11:11:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:33'),(9791,7753,'Y','18','021','EC','A','','','AC','0000265017','0000265017','LA00000686831','IL','1','liverett','curtis','','','','34','435048038','7676 CHEF MENTEUR HWY',0,'NEW ORLEANS','LA','70126','5320','CY','22071','1956-09-14','M','U',':RET:2106-3','N','021','DEN','1235785','18575LA002000101','2014-01-01','2013-10-20 13:16:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 05:00:58'),(24301,19301,'Y','18','021','EC','A','','','AC','0000105167','0000105167','TX00002378936','IL','1','Kerns','Carolyn','','','','34','461697728','6717 DEEP VALLEY LN',0,'FORT WORTH','TX','76132','1121','CY','48439','1971-02-19','F','U',':RET:2106-3','N','021','DEN','3682345','33348TX002000201','2014-04-01','2014-02-18 17:05:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-18 21:30:19'),(24366,19352,'Y','18','021','EC','A','','','AC','0002031707','0002031707','LA00002113409','IL','1','STEWART','DENISE','','','','34','439040520','436 MARVIN GARDEN ST',0,'LA PLACE','LA','70068','4214','CY','22095','1960-02-22','F','U',':RET:2054-5','N','021','DEN','2837024','18575LA002000201','2014-04-01','2014-02-18 13:22:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:34'),(24537,19491,'Y','18','024','14','A','','','TE','0000897710','0000897710','','IL','1','Leandro','Beatriz',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-08-10','F','',NULL,NULL,NULL,'','2722904','','2014-02-19','2014-02-19 17:02:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-20 04:01:37'),(25910,20545,'Y','18','021','EC','A','','','AC','0000227177','0000227177','TX00002775426','IL','1','Diab','Samar','','','','34','461772669','2418 FARRINGTON DR',0,'GARLAND','TX','75044','3316','CY','48113','1972-05-10','F','R',':RET:2054-5','N','021','DEN','3245608','33348TX002000201','2014-04-01','2014-02-26 14:44:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:14'),(26758,21206,'Y','18','024','14','A','','','TE','0000216049','0000216049','','IL','1','Wright','Webb',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-11-30','M','',NULL,NULL,NULL,'','3509304','','2014-02-28','2014-02-28 18:36:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-01 19:00:06'),(28252,22354,'Y','18','024','14','A','','','TE','0001045637','0001045637','','IL','1','Muraya','Nancy','N',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-12','F','',NULL,NULL,NULL,'','16120','','2014-03-31','2014-03-07 15:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:13'),(28652,22673,'Y','18','021','EC','A','','','AC','0000632749','0000632749','OH00002822576','IL','1','Hall','Britanny','','','','34','274924340','3894 DAVIDSON RD',0,'HILLSBORO','OH','45133','8797','CY','39071','1990-03-26','F','M',':RET:2106-3','N','021','HLT','3711540','92036OH003000605','2014-04-01','2014-03-08 15:16:59','307.00',NULL,NULL,'449.26','142.26','R-OH005','OH0','224.18',NULL,0,'2014-03-08 21:30:38'),(3453,2777,'Y','18','021','EC','A','','','AC','0000854190','0000854190','OH00000055348','IL','1','Ring','Julie','Anna','','','34','578962139','3825 Petoskey Avenue',0,'Cincinnati','OH','45227',NULL,'CY','39061','1968-06-13','F','U',':RET:2106-3','N','021','DEN','2420415','99734OH005000401','2014-01-01','2013-12-21 22:44:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:19:34'),(20323,16226,'Y','18','024','14','A','','','TE','0000248181','0000248181','','IL','1','Black','Kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-12-24','M','',NULL,NULL,NULL,'','2895530','','2014-01-28','2014-01-28 15:34:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:57'),(7641,6050,'Y','18','021','EC','A','','','AC','0000865820','0000865820','OH00000663715','IL','1','HART','BRAD','','','','34','293529093','6281 IROQUOIS TRL',0,'MENTOR','OH','44060','2905','CY','39085','1956-06-16','M','M',':RET:2106-3','N','021','DEN','397544','99734OH005000401','2014-01-01','2013-11-10 08:44:00','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:46:35'),(15484,12388,'Y','18','021','EC','A','','','AC','0001106792','0001106792','OH00002060361','IL','1','GENTILE','NEALE','','','','34','271748530','2677 COVENTRY RD',0,'SHAKER HEIGHTS','OH','44120','1305','CY','39035','1962-01-05','M','U',':RET:2106-3','N','021','DEN','1681505','99734OH005000401','2014-02-01','2013-12-31 09:41:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:29:15'),(13217,10546,'N','19','021','EC','A',NULL,NULL,'','0000553050','0000922435','','IL','1','Legg','Calvin','','','','34','632112503','227 RED HAWK RDG',0,'SAN ANTONIO','TX','78258','4866','CY','48029','1995-05-18','M','',':RET:2106-3','N','021','DEN','1980234','33348TX002000201','2014-01-01','2013-12-22 19:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2013-12-26 12:55:25'),(25439,20185,'Y','18','021','EC','A','','','AC','0001022232','0001022232','TX00002530347','IL','1','BOWERS','LASANDRA','','','','34','460439056','1407 E PENNSYLVANIA AVE',0,'MIDLAND','TX','79701','8343','CY','48329','1974-10-20','F','U',':RET:2054-5','N','021','DEN','2821906','33348TX002000201','2014-04-01','2014-02-25 11:16:05','0.00',NULL,NULL,'29.22','29.22','R-TX016','TX0','14.61',NULL,0,'2014-02-25 21:31:19'),(27912,22082,'Y','18','021','EC','A','','','AC','0000447261','0000447261','TX00003126976','IL','1','Sapp','Virginia','','','','34','433809866','375 ODEN DR',0,'WASKOM','TX','75692','4029','CY','48203','1950-09-08','F','M',':RET:2106-3','N','021','DEN','2887903','33348TX002000201','2014-04-01','2014-03-05 21:28:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:16'),(24372,19358,'Y','18','021','EC','A','','','AC','0002294916','0002294916','LA00002538196','IL','1','Babb','Amalia','','','','34','637246493','214 MELODY DR',0,'LAFAYETTE','LA','70503','5621','CY','22055','1962-02-07','F','U',NULL,'N','021','DEN','3608224','18575LA002000201','2014-04-01','2014-02-18 16:05:51','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-18 22:00:39'),(19551,15584,'Y','18','021','EC','A','','','AC','0000788234','0000788234','OH00001411025','IL','1','Haefner','Constance','','','','34','274566808','4150 THORNTON AVE',0,'TOLEDO','OH','43612','1751','CY','39095','1952-05-09','F','U',':RET:2106-3','N','021','HLT','3172366','92036OH006002601','2014-03-01','2014-01-22 14:18:18','393.00',NULL,NULL,'434.56','41.56','R-OH001','OH0','434.56',NULL,0,'2014-01-23 03:02:29'),(7188,5697,'N','01','021','EC','A',NULL,NULL,'','0000604701','0000825895','','IL','1','Kameoka','Ichiro','','','','34','210667304','1320 TRANQUIL DR',0,'WORTHINGTON','OH','43085','1579','CY','39049','1971-07-18','M','',':RET:2039-6','N','021','DEN','240309','99734OH005000301','2014-01-01','2013-12-14 11:58:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:20'),(15653,12523,'Y','18','021','EC','A','','','AC','0000377470','0000377470','OH00001269603','IL','1','Mack','Charles','','','','34','274946658','201 E 5TH ST',0,'MANCHESTER','OH','45144','1374','CY','39001','1991-05-30','M','U',':RET:2106-3','N','021','HLT','2040909','92036OH003000605','2014-02-01','2013-12-30 21:07:25','129.00',NULL,NULL,'224.18','95.18','R-OH005','OH0','224.18',NULL,1,'2014-01-02 04:34:11'),(2335,1901,'Y','18','021','EC','A','','','AC','0000608600','0000608600','TX00001026994','IL','1','Garcia','Altagracia','','','','34','645967931','2107 N CELIA DR',0,'CEDAR PARK','TX','78613','4619','CY','48491','1971-01-06','F','U',':RET:2106-3','N','021','DEN','315171','33348TX002000201','2014-01-01','2013-12-09 12:33:50','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 19:31:48'),(15436,12350,'Y','18','024','14','A','','','TE','0000506565','0000506565','','IL','1','Housh','Carla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-29','F','',NULL,NULL,NULL,'','5311','','2013-12-31','2013-12-31 13:31:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:27:55'),(3358,2691,'Y','18','021','EC','A','','','AC','0000110393','0000110393','TX00000627344','31','1','Kuhlman','Blake','','','','34','460119999','P. O. Box 158',0,'Pontotoc','TX','76869',NULL,'CY','48319','1955-04-27','M','M',':RET:2106-3','N','021','DEN','1481056','33348TX002000201','2014-01-01','2013-12-22 12:27:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:16:54'),(3567,2864,'Y','18','021','EC','A','','','AC','0000781895','0000781895','OH00001167666','IL','1','MEADOWS','WILLIAM','','','','34','296564274','6609 EMASSY CT',0,'MAUMEE','OH','43537',NULL,'CY','39095','1957-11-25','M','M',':RET:2106-3','T','021','HLT','2456973','92036OH005002601','2014-01-01','2013-12-22 06:51:41','0.00',NULL,NULL,'523.16','523.16','R-OH001','OH0','523.16',NULL,0,'2013-12-25 21:22:27'),(25499,20229,'Y','18','021','EC','A','','','AC','0000224693','0000224693','TX00002535693','IL','1','SHARP','EVELYN','','','','34','223924786','1525 E PALM VALLEY BLVD',0,'ROUND ROCK','TX','78664',NULL,'CY','48491','1954-12-14','F','U',NULL,'N','021','DEN','3174508','33348TX002000101','2014-04-01','2014-02-25 12:35:24','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-25 21:31:53'),(26922,21335,'N','01','021','EC','A',NULL,NULL,'','0001190120','0001199560','','IL','1','Hamric','Craig','Allen','','','34','276841750','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1969-10-10','M','',':RET:2106-3','N','021','DEN','3289675','99734OH005000401','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:15'),(28572,22611,'Y','18','021','EC','A','','','AC','0000232163','0000232163','TX00003051718','IL','1','YEUNG','MINOON','','','','34','451392465','1702 BUTTERCUP CREEK BLVD',0,'CEDAR PARK','TX','78613',NULL,'CY','48491','1963-03-12','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','3949022','33348TX002000201','2014-04-01','2014-03-07 18:29:02','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-03-08 21:00:02'),(28773,22776,'N','01','021','EC','A',NULL,NULL,'','0000863532','0000823580','','IL','1','OMAR','DEKA','','','','34','230732197','498 RENE CT',0,'WESTERVILLE','OH','43081','4937','CY','39049','1969-01-01','F','',':RET:2054-5','N','021','DEN','4130383','99734OH005000401','2014-04-01','2014-03-09 11:36:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:30'),(16385,13111,'N','19','021','EC','A',NULL,NULL,'','0000978851','0001019875','','IL','1','nguyen','christina','','','','34','630242490','2915 GAINESBOROUGH DR',0,'DALLAS','TX','75287','3486','CY','48121','1991-02-03','F','',':RET:2047-9','N','021','DEN','2368545','33348TX002000201','2014-02-01','2014-01-05 23:18:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-07 04:03:26'),(7389,5849,'Y','18','021','EC','A','','','AC','0000005801','0000005801','OH00001082121','IL','1','Reyes','April','','','','34','093722921','1500 Herbert DR',0,'Lorain','OH','44053',NULL,'CY','39093','1987-04-23','F','U',NULL,'T','021','HLT','348273','52664OH152001001','2014-01-01','2013-11-23 09:50:32','0.00',NULL,NULL,'162.84','162.84','R-OH011','OH0','162.84',NULL,0,'2013-12-26 02:16:07'),(6624,5253,'Y','18','021','EC','A','','','AC','0000732564','0000732564','OH00000217367','IL','1','thabit','carol','','','','34','286425450','5742 Acres Rd.',0,'Sylvania','OH','43560',NULL,'CY','39095','1957-06-25','F','U',':RET:2106-3','N','021','HLT','1015228','92036OH005002605','2014-01-01','2013-12-11 13:12:01','368.00',NULL,NULL,'454.92','86.92','R-OH001','OH0','454.92',NULL,0,'2013-12-26 00:54:08'),(9684,7670,'N','01','021','EC','A',NULL,NULL,'','0000124201','0000303356','','IL','1','Hall','Mary-Anne','','','','34','406155095','8421 COX RD',0,'WEST CHESTER','OH','45069','3339','CY','39017','1971-07-05','F','',':RET:2106-3','N','021','HLT','1930215','92036OH001001201','2014-01-01','2013-12-21 11:34:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','343.10',NULL,0,'2013-12-26 04:39:32'),(9680,7669,'Y','18','021','EC','A','','','AC','0000839048','0000839048','OH00001307790','IL','1','Hayden','Adam','','','','34','305026306','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','1980-06-18','M','M',':RET:2106-3','N','021','HLT','1434306','92036OH001001201','2014-01-01','2013-12-21 11:01:12','265.00',NULL,NULL,'768.54','503.54','R-OH004','OH0','310.20',NULL,0,'2013-12-26 04:39:28'),(15761,12611,'Y','18','021','EC','A','','','AC','0001174965','0001174965','TX00001496430','IL','1','Burrier','Mable','K','','','34','453966625','418 saint Micheal',0,'Gonzales','TX','78629',NULL,'CY','48177','1949-11-14','F','M',':RET:2106-3','N','021','DEN','1692496','33348TX002000201','2014-02-01','2014-01-02 11:39:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:29'),(3561,2859,'Y','18','021','EC','A','','','AC','0000175097','0000175097','OH00000300350','IL','1','Fritz','Kathleen','','','','34','298760246','2881 HEATHERWOOD CT',0,'STOW','OH','44224','4369','CY','39153','1982-12-24','F','U',':RET:2106-3','N','021','HLT','1647025','52664OH151001304','2014-01-01','2013-12-22 16:02:05','75.00',NULL,NULL,'258.47','183.47','R-OH012','OH0','258.47',NULL,0,'2013-12-25 21:22:19'),(4904,3889,'Y','18','021','EC','A','','','AC','0000162237','0000162237','OH00000018072','IL','1','logan','samuel','','','','34','277584401','6064 EUCLID RD',0,'CINCINNATI','OH','45236','4206','CY','39061','1956-12-16','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','1160642','99734OH005000401','2014-01-01','2013-10-26 17:48:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:31:52'),(27057,21424,'N','19','021','EC','A',NULL,NULL,'','0000399894','0000062590','','IL','1','GREEN','KYLER','','','','34','276981572','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1995-01-23','M','',':RET:2106-3','N','021','HLT','3076432','92036OH003002704','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-03-03 21:00:27'),(28524,22574,'Y','18','021','EC','A','','','AC','0000440879','0000440879','OH00003576164','IL','1','king','jack','','','','34','269768642','601 SONANDER RD',0,'URBANA','OH','43078','9321','CY','39021','1966-08-29','M','U',':RET:2106-3','T','021','HLT','3493826','92036OH004000501','2014-04-01','2014-03-07 07:24:21','225.00',NULL,NULL,'343.56','118.56','R-OH003','OH0','343.56',NULL,0,'2014-03-07 21:32:02'),(28968,22927,'Y','18','021','EC','A','','','AC','0001377728','0001377728','LA00002602840','IL','1','Jolivette','priscilla','','','','34','434043021','105 AMAUNT ST',0,'LAFAYETTE','LA','70501','1301','CY','22055','1957-08-05','F','M',NULL,'N','021','DEN','3956497','18575LA002000201','2014-04-01','2014-03-10 16:32:20','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-03-10 21:01:01'),(1687,1409,'Y','18','021','EC','A','','','AC','0001633549','0001633549','LA00000108867','IL','1','Hayes','Daniel','','','','34','043609414','100 OCELOT DR',0,'ARABI','LA','70032','2146','CY','22087','1959-06-06','M','M',':RET:2106-3','N','021','DEN','2578742','18575LA002000101','2014-01-01','2013-12-24 16:03:15','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:20'),(23783,18926,'Y','18','021','EC','A','','','AC','0000349299','0000349299','OH00001684522','IL','1','SCOTT','RAYMONE','','','','34','285787390','1020 JEFFERSON AVE',0,'AKRON','OH','44302','1046','CY','39153','1976-09-22','M','U',':RET:2054-5','N','021','HLT','3667992','52664OH151001304','2014-03-01','2014-02-13 18:53:52','106.00',NULL,NULL,'276.08','170.08','R-OH012','OH0','276.08',NULL,0,'2014-02-14 21:31:21'),(9608,7609,'Y','18','021','EC','A','','','AC','0001084140','0001084140','OH00000606546','IL','1','benedict','robert','lucius','','','34','275423686','2785 MANSARD LN',0,'AKRON','OH','44312','5394','CY','39153','1952-01-31','M','M',NULL,'N','021','HLT','2273480','52664OH151001301','2014-01-01','2013-12-21 13:49:39','0.00',NULL,NULL,'626.65','626.65','R-OH012','OH0','626.65',NULL,0,'2013-12-26 04:37:33'),(15407,12324,'Y','18','021','EC','A','','','AC','0000327856','0000327856','TX00001423675','IL','1','RAMIREZ','MARIA','ELENA','','','34','458873470','317 PEACH ST',0,'ABILENE','TX','79602','1132','CY','48441','1950-11-01','F','U',NULL,'N','021','DEN','2570940','33348TX002000201','2014-02-01','2013-12-30 23:16:48','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,1,'2014-01-02 04:26:59'),(13429,10712,'N','01','021','EC','A',NULL,NULL,'','0000184940','0001195504','','IL','1','MARTIN','TODD','A','','','34','285600094','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1966-05-30','M','',':RET:2106-3','T','021','DEN','1987465','99734OH005000301','2014-01-01','2013-12-23 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:59'),(2608,2119,'Y','18','024','14','A','','','TE','0000976676','0000976676','','IL','1','BULLOCK','VICTOR','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-26','M','',NULL,NULL,NULL,'','469066','','2013-12-02','2013-12-02 09:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:45:31'),(7537,5964,'N','19','021','EC','A',NULL,NULL,'','0000048245','0000054232','','IL','1','Zander','Andrew','','','','34','633240173','2900 Shalimar Dr.',0,'Plano','TX','75023',NULL,'CY','48085','1991-03-08','M','',':RET:2106-3','T','021','DEN','942959','33348TX002000201','2014-01-01','2013-12-15 11:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:32:48'),(2385,1946,'Y','18','021','EC','A','','','AC','0001148694','0001148694','OH00001013745','IL','1','HONECK','ARLENE','','','','34','270502360','6904 GIDDINGS RD',0,'ATWATER','OH','44201','9538','CY','39133','1949-12-10','F','U',':RET:2106-3','N','021','DEN','1160930','99734OH005000401','2014-01-01','2013-12-09 11:19:47','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:33:07'),(25479,20215,'Y','18','024','14','A','','','TE','0000616924','0000616924','','IL','1','friend','shelli',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-07-15','F','',NULL,NULL,NULL,'','3620764','','2014-02-24','2014-02-24 18:46:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-25 21:31:42'),(26818,21253,'Y','18','021','EC','A','','','AC','0000837755','0000837755','OH00002575605','IL','1','ross','bonnie','','','','34','287662504','9380 JERICHO DR',0,'CINCINNATI','OH','45231','2817','CY','39061','1960-11-17','F','U',':RET:2054-5','N','021','DEN','3447126','99734OH005000401','2014-04-01','2014-03-01 00:13:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:33'),(18557,14799,'Y','18','021','EC','A','','','AC','0000669203','0000669203','OH00001739176','31','1','Grooms','Levi','','','','34','297762498','7345 Pondlick Rd',0,'Seaman','OH','45679',NULL,'CY','39001','1980-07-10','M','U',':RET:2106-3','T','021','HLT','1976106','92036OH005000604','2014-02-01','2014-01-14 22:58:03','97.00',NULL,NULL,'295.74','198.74','R-OH005','OH0','295.74',NULL,0,'2014-01-16 08:46:57'),(14604,11656,'Y','18','021','EC','A','','','AC','0000039822','0000039822','OH00001651598','IL','1','EHRENKRANTZ','JONATHAN','','','','34','052648155','5720 REIGART RD',0,'HAMILTON','OH','45011',NULL,'CY','39017','1965-07-27','M','U',NULL,'N','021','DEN','1734077','99734OH005000301','2014-02-01','2013-12-27 12:07:41','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:36:28'),(20063,16002,'Y','18','021','EC','A','','','AC','0000885009','0000885009','TX00001865330','IL','1','LOPEZ-LARA','JUAN','MIGUEL','','','34','457978619','396 PANAHI RD',0,'EL PASO','TX','79927','3262','CY','48141','1977-01-07','M','U',NULL,'N','021','DEN','1844423','33348TX002000201','2014-03-01','2014-01-27 12:33:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-27 21:00:12'),(19086,15205,'N','19','021','EC','A',NULL,NULL,'','0000312218','0000980565','','IL','1','HAUPRICHT','MADISON','','','','34','299960256','4830 ELM PLCE',0,'TOLEDO','OH','43613',NULL,'CY','39095','1994-03-21','F','',':RET:2106-3','N','021','DEN','2983261','99734OH005000401','2014-03-01','2014-01-18 15:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:44:29'),(17081,13670,'Y','18','021','EC','A','','','AC','0000699525','0000699525','TX00002092374','IL','1','SHERETTE','ROBIN','LYNN','','','34','517826150','1218 JOSEPH LN',0,'SAN ANGELO','TX','76905','2302','CY','48451','1953-01-23','F','U',':RET:2106-3','N','021','DEN','2400724','33348TX002000201','2014-02-01','2014-01-08 13:56:22','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-13 02:21:22'),(18147,14491,'N','01','021','EC','A',NULL,NULL,'','0001767790','0002297325','','IL','1','SKIPPER','WALTER','','','','34','437114056','706 KELLI DR',0,'PATTERSON','LA','70392','4214','CY','22101','1958-01-07','M','',':RET:2054-5','N','021','DEN','1802786','18575LA002000101','2014-02-01','2014-01-14 16:36:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-15 02:07:49'),(25306,20076,'Y','18','021','EC','A','','','AC','0000761132','0000761132','OH00001934489','IL','1','L\'Heureux','Jennifer',NULL,NULL,NULL,NULL,NULL,'357 W WASHINGTON ST',0,'NELSONVILLE','OH','45764','1164','CY','39009','1969-03-04','F','M',':RET:2106-3','T','021','DEN','3445971','99734OH005000301','2014-03-01','2014-02-25 16:09:31','0.00',NULL,NULL,'59.76','59.76','R-OH017','OH0','0.00','CIC',0,'2014-02-25 21:00:30'),(25513,20240,'Y','18','021','EC','A','','','AC','0001258707','0001258707','OH00002736660','IL','1','Shumway','Mary','','','','34','272440453','423 DARTMOUTH CIR',0,'CINCINNATI','OH','45244','1805','CY','39025','1957-07-11','F','U',NULL,'N','021','HLT','3553863','92036OH004000601','2014-04-01','2014-02-25 15:49:06','312.00',NULL,NULL,'402.70','90.70','R-OH005','OH0','402.70',NULL,0,'2014-02-25 21:32:01'),(24383,19367,'N','01','021','EC','A',NULL,NULL,'','0000899617','0000240400','','IL','1','CURTIS','HARRISON','','','','34','274528817','6121 BROADWELL CT',0,'GALLOWAY','OH','43119','8516','CY','39049','1952-02-29','M','',':RET:2106-3','N','021','DEN','3479566','99734OH005000401','2014-04-01','2014-02-18 10:13:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:45'),(24217,19233,'N','01','021','EC','A',NULL,NULL,'','0001246737','0000667410','','IL','1','Bhatpuria','Pravin','','','','34','631542367','5905 AVERY ISLAND AVE',0,'AUSTIN','TX','78727','6924','CY','48453','1954-10-26','M','',':RET:2029-7','N','021','DEN','2744502','33348TX002000201','2014-03-01','2014-02-15 20:45:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-16 19:00:26'),(9740,7712,'Y','18','021','EC','A','','','AC','0000802815','0000802815','TX00001198735','IL','1','WINN','DIANNE','','','','34','450791923','1702 77TH ST',0,'LUBBOCK','TX','79423','1621','CY','48303','1974-11-08','F','U',':RET:2054-5','N','021','DEN','858613','33348TX002000201','2014-01-01','2013-11-15 01:13:03','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 04:45:54'),(3410,2738,'Y','18','021','EC','A','','','AC','0001936875','0001936875','LA00000186393','IL','1','Conner','Wanda','','','','34','438861389','931 Brady St',0,'Sulphur','LA','70663',NULL,'CY','22019','1951-10-31','F','U',':RET:2106-3','N','021','DEN','2142251','18575LA002000201','2014-01-01','2013-12-22 15:27:23','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 21:18:21'),(9278,7361,'Y','18','021','EC','A','','','AC','0000753357','0000753357','OH00000325117','IL','1','TARELLARI','LINDA','','','','34','291741137','10814 WINDHAM RD',0,'PARMA','OH','44130','1573','CY','39035','1977-06-08','F','M',':RET:2106-3','N','021','DEN','15448','99734OH005000301','2014-01-01','2013-11-30 11:46:28','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:15:52'),(3889,3115,'Y','18','021','EC','A','','','AC','0000021368','0000021368','OH00000379775','31','1','Hartzell','Paula','','','','34','281742244','PO Box 207',0,'Greentown','OH','44630',NULL,'CY','39151','1965-04-27','F','M',':RET:2106-3','N','021','HLT','19180','52664OH152000901','2014-01-01','2013-12-13 12:40:19','762.00',NULL,NULL,'860.80','98.80','R-OH015','OH0','267.06',NULL,0,'2013-12-25 21:36:39'),(23910,19018,'N','19','021','EC','A',NULL,NULL,'','0000874746','0001234161','','S1','1','Vanculin','Lyle','','','','34','285981541','189 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1424','CY','39023','1995-06-22','M','',':RET:2106-3','N','021','HLT','3411645','92036OH002000501','2014-03-01','2014-02-14 16:44:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','174.32',NULL,0,'2014-02-14 21:32:29'),(19314,15396,'Y','18','021','EC','A','','','AC','0000143230','0000143230','TX00002219848','IL','1','Chiem','Phan','','','','34','637085306','6218 N SHILOH RD',0,'GARLAND','TX','75044','3802','CY','48113','1981-08-01','F','M',':RET:2047-9','N','021','DEN','2597435','33348TX002000201','2014-03-01','2014-01-20 23:48:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:07'),(22550,18007,'Y','18','024','14','A','','','TE','0000987352','0000987352','','IL','1','Light','Kristine','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-01-24','F','',NULL,NULL,NULL,'','510565','','2014-02-24','2014-02-09 23:49:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-10 21:31:44'),(5142,4076,'Y','18','021','EC','A','','','AC','0000697905','0000697905','OH00000564209','IL','1','Glass','Cena','','','','34','437171166','438 Baldwin Road',0,'Akron','OH','44312',NULL,'CY','39153','1957-07-12','F','U',':RET:2106-3','N','021','DEN','1934936','99734OH005000401','2014-01-01','2013-12-18 20:46:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:02:34'),(13271,10592,'Y','18','021','EC','A','','','AC','0000828166','0000828166','TX00000778512','IL','1','williams','jeffrey','','','','34','453753228','95 S CASTLEGREEN CIR',0,'THE WOODLANDS','TX','77381','6336','CY','48339','1985-08-26','M','U',':RET:2106-3','N','021','DEN','1784617','33348TX002000201','2014-01-01','2013-12-23 12:24:22','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:56:54'),(4825,3823,'N','01','021','EC','A',NULL,NULL,'','0000783200','0000073912','','IL','1','Drake','John','','','','34','379648656','6800 KRISTI LYNNE LN',0,'TOLEDO','OH','43617','1279','CY','39095','1956-02-25','M','',':RET:2106-3','N','021','HLT','30044','92036OH005002601','2014-01-01','2013-12-08 12:53:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.21',NULL,0,'2013-12-25 22:17:11'),(24439,19412,'Y','18','021','EC','A','','','AC','0000664231','0000664231','OH00002338029','IL','1','Caudill','Rhonda','','','','34','268584771','606 Cumberland Drive',0,'Celina','OH','45822',NULL,'CY','39107','1958-06-13','F','U',':RET:2106-3','N','021','HLT','3786219','92036OH006001501','2014-04-01','2014-02-18 09:00:24','370.00',NULL,NULL,'389.23','19.23','R-OH002','OH0','389.23',NULL,0,'2014-02-18 22:01:18'),(27715,21917,'Y','18','024','14','A','','','TE','0000784040','0000784040','','IL','1','SPARKS','ALICE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-26','F','',NULL,NULL,NULL,'','3700495','','2014-03-05','2014-03-05 13:25:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:55'),(29183,23097,'Y','18','021','EC','A','','','AC','0000865940','0000865940','OH00003554133','IL','1','Perry','Shirley','','','','34','101703579','505 HAESSLER AVE',0,'ZANESVILLE','OH','43701','5014','CY','39119','1976-05-30','F','U',':RET:2106-3','N','021','DEN','3398378','99734OH005000401','2014-04-01','2014-03-10 11:11:10','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00','CIC',0,'2014-03-10 21:29:59'),(652,537,'Y','18','021','EC','A','','','AC','0000638488','0000638488','OH00000394214','IL','1','CHEN','KATIE','','','','34','293828058','6306 MAPELWOOD ROAD.',0,'MAYFIELD','OH','44124',NULL,'CY','39035','1954-05-21','F','U',NULL,'N','021','DEN','1403940','99734OH005000401','2014-01-01','2013-12-16 16:43:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:01:37'),(706,583,'Y','18','021','EC','A','','','AC','0000378999','0000378999','LA00000322942','31','1','Scott','Carolyn','','','','34','437888061','3596 LA 44',0,'PAULINA','LA','70763','2443','CY','22093','1951-02-23','F','U',':RET:2054-5','N','021','DEN','112940','18575LA002000201','2014-01-01','2013-12-15 21:04:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:03:02'),(909,754,'Y','18','021','EC','A','','','AC','0000394923','0000394923','OH00000136349','IL','1','Brosee','Mark','','','','34','300545201','3796 Settle Road',0,'Cincinnati','OH','45227',NULL,'CY','39061','1953-05-18','M','R',':RET:2106-3','T','021','HLT','1461591','92036OH006001201','2014-01-01','2013-12-16 13:53:55','0.00',NULL,NULL,'531.35','531.35','R-OH004','OH0','531.35',NULL,0,'2013-12-25 18:08:30'),(21770,17385,'Y','18','021','EC','A','','','AC','0000251660','0000251660','OH00001614709','IL','1','Figley','James','','','','34','286860148','660 Thurber Dr. West',0,'Columbus','OH','43215',NULL,'CY','39049','1977-10-08','M','U',':RET:2106-3','N','021','DEN','3376447','99734OH005000401','2014-03-01','2014-02-06 13:07:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:31'),(2144,1762,'Y','18','021','EC','A','','','AC','0000959074','0000959074','OH00001067442','IL','1','Smith','Deborah','','','','34','159449384','131 Brook Drive',0,'Brookfield','OH','44403',NULL,'CY','39155','1952-02-13','F','U',':RET:2106-3','N','021','HLT','706992','92036OH002003201','2014-01-01','2013-12-09 18:46:13','516.00',NULL,NULL,'785.50','269.50','R-OH013','OH0','785.50',NULL,0,'2013-12-25 19:18:21'),(3709,2968,'Y','18','021','EC','A','','','AC','0000959080','0000959080','OH00000894902','IL','1','Hirst','Michael','Robert','','','34','300509510','1434 CHURCHILL RD',0,'GIRARD','OH','44420','2430','CY','39155','1952-03-15','M','M',':RET:2106-3','N','021','DEN','1117656','99734OH005000401','2014-01-01','2013-12-13 14:26:53','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:32:09'),(20928,16725,'Y','18','021','EC','A','','','AC','0000171424','0000171424','MS00001829960','IL','1','MONTANA','LYDIA','','','','34','585428662','20120 W WORTHAM RD',0,'SAUCIER','MS','39574','7105','CY','28047','1963-03-02','F','U',NULL,'N','021','DEN','3546106','46300MS002000201','2014-03-01','2014-01-31 11:50:06','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-31 21:01:35'),(20353,16254,'Y','18','021','EC','A','','','AC','0000597336','0000597336','OH00001686576','IL','1','CARTER','FLOYD','A','','','34','295689980','2630 EAST GATE',0,'TOLEDO','OH','43614',NULL,'CY','39095','1968-02-01','M','U',NULL,'N','021','HLT','3407772','92036OH005002601','2014-03-01','2014-01-28 11:41:19','0.00',NULL,NULL,'292.49','292.49','R-OH001','OH0','292.49',NULL,0,'2014-01-28 21:01:15'),(3830,3067,'Y','18','021','EC','A','','','AC','0001124051','0001124051','OH00001121211','IL','1','Scholten','Mark','','','','34','380884299','2106 PRESSLER RD',0,'AKRON','OH','44312','4328','CY','39153','1964-11-23','M','M',':RET:2106-3','N','021','DEN','85836','99734OH005000301','2014-01-01','2013-12-13 16:51:31','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:35:10'),(13973,11136,'Y','18','021','EC','A','','','AC','0000880512','0000880512','OH00001307862','IL','1','HUX','VELVETTEE','','','','34','262849045','732 BECKLEY FARM WAY',0,'SPRINGBORO','OH','45066','9485','CY','39165','1954-09-21','F','M',':RET:2054-5','N','021','HLT','2395361','92036OH004001201','2014-01-01','2013-12-22 23:54:25','0.00',NULL,NULL,'803.52','803.52','R-OH004','OH0','449.32',NULL,0,'2013-12-26 13:15:26'),(16690,13356,'Y','18','021','EC','A','','','AC','0000261653','0000261653','TX00002038457','IL','1','Sellers','Christopher','','','','34','452750533','7002 50TH ST',0,'LUBBOCK','TX','79407','5112','CY','48303','1985-11-11','M','M',':RET:2106-3','T','021','DEN','2586769','33348TX002000201','2014-02-01','2014-01-07 12:46:38','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-08 18:24:34'),(27129,21476,'Y','18','024','14','A','','','TE','0001102069','0001102069','','IL','1','Myles','Mildred',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-01-16','F','',NULL,NULL,NULL,'','526081','','2014-03-18','2014-03-03 10:35:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 21:30:38'),(27693,21901,'Y','18','021','EC','A','','','AC','0000032325','0000032325','TX00003404989','IL','1','Estrada','Jessenia','','','','34','450831074','6201 BARREDA CIR',0,'EDINBURG','TX','78542','7174','CY','48215','1986-11-09','F','U',NULL,'N','021','DEN','3542095','33348TX002000201','2014-04-01','2014-03-05 10:35:37','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-05 21:30:44'),(28111,22248,'N','01','021','EC','A',NULL,NULL,'','0001019326','0000790935','','IL','1','Badowski','Jeffrey','','','','34','296501241','550 RAWLINS AVE',0,'AKRON','OH','44319','4343','CY','39153','1961-03-02','M','',':RET:2106-3','N','021','HLT','3177573','52664OH152000901','2014-04-01','2014-03-06 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','333.21',NULL,0,'2014-03-06 21:02:15'),(28948,22909,'Y','18','021','EC','A','','','AC','0002326380','0002326380','LA00002704965','31','1','Guidry','Donald','James','','Sr','34','434983537','null null',0,'OPELOUSAS','LA','70571','2022','CY','22097','1958-12-18','M','U',':RET:2054-5','N','021','DEN','3025937','18575LA002000201','2014-04-01','2014-03-09 22:37:15','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-10 21:00:48'),(212,177,'Y','18','021','EC','A','','','AC','0000053990','0000053990','LA00000763227','IL','1','Racheau','Susie','','','','34','433882514','2301 Terre Ruelle',0,'New Iberia','LA','70563',NULL,'CY','22045','1951-01-09','F','R',':RET:2106-3','N','021','DEN','330499','18575LA002000201','2014-01-01','2013-12-05 13:03:44','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 17:20:30'),(21952,17529,'Y','18','021','EC','A','','','AC','0000322186','0000322186','OH00002245767','IL','1','Johnson','Kimberly','','','','34','288860915','1740 RUNIK PL W',0,'REYNOLDSBURG','OH','43068','3050','CY','39049','1987-08-10','F','U',':RET:2054-5','N','021','DEN','3035416','99734OH005000401','2014-03-01','2014-02-06 20:33:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:21'),(9096,7220,'Y','18','024','14','A','','','TE','0000538228','0000538228','','IL','1','PRESSLEY','RICKEY','LAMAR','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-02-08','M','',NULL,NULL,NULL,'','685662','','2013-12-18','2013-12-18 13:51:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:07:14'),(9091,7215,'Y','18','021','EC','A','','','AC','0000988871','0000988871','OH00000306163','IL','1','PICKEL','ALECIA','','','','34','400065295','1503 MABERT RD',0,'PORTSMOUTH','OH','45662','4817','CY','39145','1964-06-22','F','U',':RET:2106-3','T','021','DEN','2425072','99734OH005000301','2014-01-01','2013-12-18 10:50:57','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-26 04:07:05'),(1333,1103,'N','01','021','EC','A',NULL,NULL,'','0000422776','0000002256','','IL','1','Cobay','Jacquelyn','A','','','34','079564850','4350 SWEENEY LN',0,'HILLSBORO','OH','45133','4303','CY','39071','1959-02-26','F','',':RET:2106-3','N','021','HLT','595165','92036OH005000601','2014-01-01','2013-10-25 09:21:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','458.32',NULL,0,'2013-12-25 18:32:09'),(4955,3933,'Y','18','021','EC','A','','','AC','0000037448','0000037448','LA00001101871','IL','1','yang','betty','','','','34','438776369','212 GEORGIA CT',0,'METAIRIE','LA','70005','1943','CY','22051','1969-01-08','F','U',':RET:2034-7','N','021','DEN','626739','18575LA002000201','2014-01-01','2013-12-06 20:40:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:01'),(2141,1759,'Y','18','021','EC','A','','','AC','0000435925','0000435925','MS00001238804','IL','1','Buxton-Piearce','Mable','','','','34','587520016','307 Sunflower Street',0,'Belzoni','MS','39038',NULL,'CY','28053','1951-08-22','F','U',':RET:2054-5','N','021','DEN','771725','46300MS002000101','2014-01-01','2013-12-10 00:45:01','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 19:18:16'),(3772,3020,'Y','18','021','EC','A','','','AC','0000792207','0000792207','OH00000790625','IL','1','Cottle','Kristy','','','','34','286760114','434 HILBISH AVE',0,'AKRON','OH','44312','2250','CY','39153','1978-03-09','F','U',':RET:2106-3','N','021','HLT','139374','52664OH151001306','2014-01-01','2013-12-13 15:46:44','174.00',NULL,NULL,'272.52','98.52','R-OH012','OH0','272.52',NULL,0,'2013-12-25 21:33:43'),(7196,5703,'Y','18','021','EC','A','','','AC','0000273768','0000273768','OH00000865728','31','1','Lynch','Matthew','','','','34','274803902','380 Brevoort Rd',0,'Columbus','OH','43214',NULL,'CY','39113','1974-01-30','M','U',':RET:2106-3','N','021','DEN','1090760','99734OH005000301','2014-01-01','2013-12-14 17:44:57','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:00:33'),(5278,4183,'Y','18','021','EC','A','','','AC','0001221930','0001221930','OH00001062813','IL','1','KELLER','BRIAN','','','','34','278428692','6407 CANTERBURY DR',0,'HUDSON','OH','44236','3487','CY','39153','1955-08-29','M','M',':RET:2106-3','N','021','HLT','2017288','52664OH151001301','2014-01-01','2013-12-19 14:38:55','41.00',NULL,NULL,'1290.32','1249.32','R-OH012','OH0','568.22',NULL,0,'2013-12-25 23:05:43'),(6822,5409,'Y','18','021','EC','A','','','AC','0000949473','0000949473','OH00000448164','IL','1','nagy','michael','','','','34','232085468','1720 lexington ave',0,'springfield','OH','45505',NULL,'CY','39023','1965-10-17','M','M',':RET:2106-3','N','021','HLT','244391','92036OH004000501','2014-01-01','2013-11-13 21:34:14','342.00',NULL,NULL,'642.21','300.21','R-OH003','OH0','312.51',NULL,0,'2013-12-26 01:30:35'),(4386,3487,'Y','18','021','EC','A','','','AC','0000296764','0000296764','OH00000175510','IL','1','Myers','Tiffany','','','','34','272786254','260 HEATH RD',0,'HEATH','OH','43056','1142','CY','39089','1980-02-02','F','U',':RET:2106-3','N','021','DEN','983803','99734OH005000401','2014-01-01','2013-12-12 10:56:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:46'),(4725,3744,'N','01','021','EC','A',NULL,NULL,'','0000806340','0000472247','','IL','1','Sandys','Erik','','','','34','298627016','2158 LONGPORT DR',0,'MAUMEE','OH','43537','1152','CY','39095','1972-08-17','M','',':RET:2106-3','T','021','HLT','439028','92036OH003002601','2014-01-01','2013-12-12 15:05:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.91',NULL,0,'2013-12-25 22:09:02'),(28873,22850,'N','01','021','EC','A',NULL,NULL,'','0000936835','0000996642','','IL','1','Joslin','Joshua','','','','34','460596228','125 S SPRING ST',0,'GRAND SALINE','TX','75140','2331','CY','48467','1974-03-25','M','',':RET:2106-3','N','021','DEN','4006209','33348TX002000201','2014-04-01','2014-03-09 21:24:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-10 21:00:03'),(22129,17661,'Y','18','021','EC','A','','','AC','0000994009','0000994009','OH00002351035','IL','1','Stage','Richard','','','','34','575809067','2692 WOODLAND AVE',0,'COLUMBUS','OH','43211','1757','CY','39049','1973-05-23','M','M',':RET:2106-3','N','021','DEN','3224604','99734OH005000401','2014-03-01','2014-02-07 23:18:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-08 19:00:42'),(397,327,'Y','18','021','EC','A','','','AC','0000767376','0000767376','OH00000361526','IL','1','Ulam','Mary','Jo','','','34','263116546','3419 EAGLES LOFT',0,'CORTLAND','OH','44410','9163','CY','39155','1951-03-13','F','M',':RET:2106-3','N','021','DEN','20199','99734OH005000401','2014-01-01','2013-12-03 20:18:05','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:46:04'),(21989,17560,'Y','18','021','EC','A','','','AC','0001815607','0001815607','LA00001531878','IL','1','LU','WEIQING','','','','34','115942453','14050 GARDEN COVE CT',0,'GONZALES','LA','70737','8948','CY','22005','1987-09-21','M','U',':RET:2034-7','N','021','DEN','3347063','18575LA002000201','2014-03-01','2014-02-06 21:18:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-07 19:00:41'),(1498,1251,'Y','18','021','EC','A','','','AC','0001008950','0001008950','OH00000130534','IL','1','Wright','Laurie','','','','34','301763432','1705 BLUE ROCK ST',0,'CINCINNATI','OH','45223',NULL,'CY','39061','1981-02-04','F','U',':RET:2106-3','N','021','DEN','2268710','99734OH005000401','2014-01-01','2013-12-24 11:33:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:13'),(13394,10691,'N','19','021','EC','A',NULL,NULL,'','0001057989','0000035752','','IL','1','Thomas','Alexandria','','','','34','295060297','5798 UNIVERSITY HEIGHTS DR',0,'ATHENS','OH','45701','9339','CY','39009','2002-02-25','F','',':RET:2106-3','N','021','DEN','2503092','99734OH005000301','2014-01-01','2013-12-23 08:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:13'),(2128,1747,'Y','18','021','EC','A','','','AC','0000484750','0000484750','OH00000438474','IL','1','DOWNING','DANNY','LEE','','','34','302521509','2358 CLEARVIEW DR NW',0,'WARREN','OH','44483',NULL,'CY','39155','1953-12-03','M','M',':RET:2106-3','N','021','DEN','1073711','99734OH005000401','2014-01-01','2013-12-10 15:22:56','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:17:53'),(23046,18373,'Y','18','024','14','A','','','TE','0000490505','0000490505','','IL','1','WHITE','LARRY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-09-21','M','',NULL,NULL,NULL,'','2563877','','2014-02-12','2014-02-12 10:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-12 21:30:42'),(9281,7361,'N','19','021','EC','A',NULL,NULL,'','0000753357','0000720214','','IL','1','TARELLARI','DOMINIC','','','','34','269110880','10814 WINDHAM RD',0,'PARMA','OH','44130','1573','CY','39035','2004-08-30','M','',':RET:2106-3','N','021','DEN','15448','99734OH005000301','2014-01-01','2013-11-30 11:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:15:54'),(3094,2486,'Y','18','021','EC','A','','','AC','0000810758','0000810758','OH00000152563','IL','1','Lacey','Charlotte','','','','34','286500753','41 E UNION ST',0,'GREENWICH','OH','44837','1116','CY','39077','1950-10-01','F','U',':RET:2106-3','N','021','HLT','972120','92036OH005002706','2014-01-01','2013-12-06 12:59:05','571.41',NULL,NULL,'575.62','4.21','R-OH006','OH0','575.62',NULL,0,'2013-12-25 20:20:05'),(21493,17173,'Y','18','021','EC','A','','','AC','0001069353','0001069353','OH00002116967','IL','1','Warren','Robert','','','','34','284782709','606 WOODBINE ST',0,'WILLARD','OH','44890','1559','CY','39077','1978-05-26','M','U',':RET:2106-3','T','021','HLT','3736830','92036OH002002701','2014-03-01','2014-02-04 18:03:43','0.00',NULL,NULL,'316.44','316.44','R-OH006','OH0','316.44',NULL,0,'2014-02-04 21:01:48'),(19077,15198,'Y','18','021','EC','A','','','AC','0002190915','0002190915','LA00001766576','IL','1','Simpson','Leroy','','','','34','439515310','1511 MYRTLE WALK',0,'BATON ROUGE','LA','70802','4170','CY','22033','1983-10-12','M','U',NULL,'N','021','DEN','2810193','18575LA002000101','2014-03-01','2014-01-18 15:56:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-21 08:44:23'),(18076,14436,'Y','18','021','EC','A','','','AC','0002100969','0002100969','LA00001875137','IL','1','Seal','Robert','','','','34','436020258','4425 Greenwood Blvd',0,'Shreveport','LA','71119',NULL,'CY','22017','1956-06-26','M','U',':RET:2106-3','N','021','DEN','1563112','18575LA002000201','2014-02-01','2014-01-14 09:46:49','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-15 02:07:25'),(15641,12512,'Y','18','024','14','A','','','TE','0000412070','0000412070','','IL','1','DAQUIN','DENNIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-07-09','M','',NULL,NULL,NULL,'','1958110','','2013-12-31','2013-12-31 09:23:34',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2014-01-02 04:33:49'),(16932,13550,'Y','18','021','EC','A','','','AC','0001368873','0001368873','LA00001409467','IL','1','Laxina','Joana',NULL,NULL,NULL,NULL,NULL,'75 AUDUBON BLVD',0,'NEW ORLEANS','LA','70118','5537','CY','22071','1977-11-16','F','U',':RET:2036-2','N','021','DEN','1851591','18575LA002000201','2014-02-01','2014-01-08 19:25:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:49'),(17617,14083,'Y','18','021','EC','A','','','AC','0000641398','0000641398','TX00001386363','IL','1','rodriguez','nevelyn','','','','34','449942767','2624 ECHO POINT DR',0,'FORT WORTH','TX','76123','1138','CY','48439','1950-03-12','F','U',':RET:2106-3','N','021','DEN','2030964','33348TX002000201','2014-02-01','2014-01-13 11:39:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-14 01:32:25'),(26195,20774,'Y','18','021','EC','A','','','AC','0000743142','0000743142','OH00002483893','31','1','Gray','Linda','','','','34','291582842','P. O. Box 14075',0,'Cincinnati','OH','45250',NULL,'CY','39061','1959-12-15','F','U',':RET:2054-5','N','021','DEN','3724206','99734OH005000301','2014-04-01','2014-02-27 15:55:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:46'),(27521,21772,'N','01','021','EC','A',NULL,NULL,'','0000378637','0000653261','','IL','1','bao','renjun','','','','34','284086714','4437 GROVELAND RD',0,'UNIVERSITY HEIGHTS','OH','44118','3920','CY','39035','1977-02-02','M','',':RET:2034-7','N','021','HLT','2739689','92036OH004000801','2014-04-01','2014-03-04 13:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','232.73',NULL,0,'2014-03-04 21:02:40'),(2258,1851,'Y','18','021','EC','A','','','AC','0000909454','0000909454','OH00001119762','IL','1','Andreadis','Steve','','','','34','292642644','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1966-04-28','M','M',':RET:2106-3','N','021','DEN','19816','99734OH005000301','2014-01-01','2013-12-09 08:04:19','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:13'),(24358,19347,'Y','18','021','EC','A','','','AC','0001194926','0001194926','LA00002848152','IL','1','LEE','SETHDRIC','','','','34','438435464','7834 NEVADA ST',0,'METAIRIE','LA','70003','6416','CY','22051','1973-01-02','F','M',':RET:2054-5','N','021','DEN','3537821','18575LA002000201','2014-04-01','2014-02-18 09:57:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:31'),(7681,6082,'Y','18','024','14','A','','','TE','0000767386','0000767386','','IL','1','Turner','Nicole','Renee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-01','F','',NULL,NULL,NULL,'','1914082','','2013-12-19','2013-12-19 19:29:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:00:48'),(4426,3517,'Y','18','024','14','A','','','TE','0001194097','0001194097','','IL','1','MONCOL','SALLY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-20','F','',NULL,NULL,NULL,'','819628','','2013-12-12','2013-12-12 16:54:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:01:44'),(22157,17684,'N','01','021','EC','A',NULL,NULL,'','0000237617','0001099223','','IL','1','Kuhn','Janet','','','','34','148704313','838 OLD MILL DR',0,'LOVELAND','OH','45140','8077','CY','39025','1963-05-26','F','',':RET:2106-3','N','021','HLT','3338375','92036OH004000601','2014-03-01','2014-02-08 10:32:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.28',NULL,0,'2014-02-08 19:00:56'),(5029,3984,'N','19','021','EC','A',NULL,NULL,'','0000194026','0000296759','','IL','1','Crehan','Jacob',NULL,NULL,NULL,NULL,NULL,'7350 S TIMBERLANE DR',0,'CINCINNATI','OH','45243','1844','CY','39061','1998-04-07','M','',':RET:2106-3','N','021','HLT','141721','92036OH004001201','2014-01-01','2013-12-07 11:34:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 22:47:42'),(14811,11830,'Y','18','021','EC','A','','','AC','0001471473','0001471473','LA00000598129','IL','1','COLEMAN','NATHANIEL','','','','34','437511962','11687 FAIR OAK AVE',0,'BATON ROUGE','LA','70815','2356','CY','22033','1981-12-24','M','U',':RET:2054-5','N','021','DEN','2396836','18575LA002000201','2014-01-01','2013-12-23 19:50:36','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2013-12-29 11:14:04'),(26489,21012,'Y','18','021','EC','A','','','AC','0002280124','0002280124','LA00003191917','IL','1','Turner','Tress','','','','34','439378400','823 NAVARRE AVE',0,'NEW ORLEANS','LA','70124','2707','CY','22071','1965-06-20','F','U',':RET:2106-3','N','021','DEN','3715324','18575LA002000201','2014-04-01','2014-02-27 22:40:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-28 21:00:09'),(26634,21118,'N','01','021','EC','A',NULL,NULL,'','0000051898','0000371980','','IL','1','MONSIVAIS','MARIA','GUAVALUPE','','','34','331802323','6916 ALEXANDRIA CT',0,'FORT WORTH','TX','76133','6301','CY','48439','1983-04-21','F','',':RET:2106-3','N','021','DEN','3736206','33348TX002000201','2014-04-01','2014-02-28 16:31:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 21:30:59'),(25341,20106,'Y','18','021','EC','A','','','AC','0002159683','0002159683','LA00003216410','IL','1','Curley','Lisa','','','','34','433862842','4219 Clara St',0,'New Orleans','LA','70115',NULL,'CY','22071','1967-02-27','F','U',':RET:2106-3','N','021','DEN','3264760','18575LA002000201','2014-04-01','2014-02-25 17:13:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:25'),(13110,10454,'Y','18','021','EC','A','','','AC','0000982710','0000982710','OH00001112622','IL','1','lovelace','sonja','','','','34','294525659','519 CEDARHURST AVE',0,'DAYTON','OH','45402','5511','CY','39113','1954-01-04','F','U',':RET:2054-5','N','021','DEN','2310749','99734OH005000401','2014-01-01','2013-12-23 13:25:26','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:52:26'),(13067,10415,'Y','18','021','EC','A','','','AC','0000813082','0000813082','OH00000521709','IL','1','Wieland','Dennis','','','','34','275448942','832 WATKINS GLEN BLVD',0,'MARYSVILLE','OH','43040','8483','CY','39159','1954-02-09','M','U',':RET:2106-3','N','021','DEN','1881817','99734OH005000401','2014-01-01','2013-12-23 09:44:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:12'),(9037,7171,'Y','18','021','EC','A','','','AC','0000707603','0000707603','OH00000169127','IL','1','Foust','Kimberly','','','','34','301669134','8483 TIFFIN CT',0,'MENTOR','OH','44060','2200','CY','39085','1959-06-28','F','M',NULL,'T','021','HLT','1358081','52664OH151001306','2014-01-01','2013-12-18 15:08:23','888.00',NULL,NULL,'1422.27','534.27','R-OH011','OH0','617.54',NULL,0,'2013-12-26 04:05:44'),(7907,6251,'Y','18','021','EC','A','','','AC','0001291228','0001291228','LA00000913277','IL','1','Reynolds','Felicia','','','','34','436135658','201.5 Pine Street',0,'Vidalia','LA','71373',NULL,'CY','22029','1970-12-04','F','U',':RET:2054-5','N','021','DEN','2377180','18575LA002000201','2014-01-01','2013-12-19 20:30:14','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 03:05:58'),(21310,17029,'Y','18','021','EC','A','','','AC','0001462820','0001462820','LA00001724488','IL','1','Steib','Joseph','','','Sr','34','438944807','22870 JACOCK RD',0,'SLAUGHTER','LA','70777','9615','CY','22037','1954-11-06','M','M',':RET:2054-5','N','021','DEN','3698838','18575LA002000201','2014-03-01','2014-02-04 12:12:19','0.00',NULL,NULL,'43.83','43.83','R-LA005','LA0','14.61',NULL,0,'2014-02-04 21:00:17'),(6877,5454,'Y','18','021','EC','A','','','AC','0000573025','0000573025','OH00000487712','IL','1','Metcalf','John','','','','34','270485716','283 S WARDELL ST',0,'UHRICHSVILLE','OH','44683','2251','CY','39157','1949-08-20','M','M',':RET:2054-5','N','021','DEN','227645','99734OH005000401','2014-01-01','2013-11-03 17:05:57','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:32:09'),(21979,17552,'Y','18','021','EC','A','','','AC','0001841404','0001841404','LA00002432776','IL','1','Smith','Karen','','','','34','434433023','733 RAY WALTERS RD',0,'DELHI','LA','71232','7367','CY','22041','1966-02-28','F','U',':RET:2106-3','T','021','DEN','3768830','18575LA002000101','2014-03-01','2014-02-06 20:44:34','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-07 19:00:35'),(13694,10925,'N','01','021','EC','A',NULL,NULL,'','0000623975','0000356044','','IL','1','Bragg','Vicki','L','','','34','285622985','885 Walls Lake Dr',0,'Vignna','OH','44473',NULL,'CY','39155','1957-02-12','F','',':RET:2106-3','N','021','HLT','2329725','52664OH151001305','2014-01-01','2013-12-23 11:09:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','590.00',NULL,0,'2013-12-26 13:08:30'),(14163,11290,'Y','18','021','EC','A','','','AC','0001157723','0001157723','LA00001672983','IL','1','Perry','Raquell','','','','34','435236201','2337 BELLAIRE LN',0,'HARVEY','LA','70058','2206','CY','22051','1955-09-28','F','U',':RET:2054-5','N','021','DEN','1504785','18575LA002000201','2014-02-01','2013-12-26 16:11:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:13'),(14556,11613,'N','01','021','EC','A',NULL,NULL,'','0000961874','0000076309','','IL','1','Partin','Edward','Warren','','Jr','34','280469731','799 FAIRWOOD RD',0,'AKRON','OH','44319','4760','CY','39153','1949-05-11','M','',':RET:2106-3','N','021','HLT','1960712','52664OH152000901','2014-02-01','2013-12-27 11:25:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.00',NULL,0,'2013-12-28 03:35:10'),(21742,17361,'Y','18','024','14','A','','','TE','0001090764','0001090764','','IL','1','Trinh','June',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-03-06','F','',NULL,NULL,NULL,'','3783757','','2014-02-06','2014-02-06 18:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-06 21:00:16'),(14627,11674,'Y','18','024','14','A','','','TE','0000235170','0000235170','','IL','1','held','james',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-05-04','M','',NULL,NULL,NULL,'','1002356','','2013-12-27','2013-12-27 12:10:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:37:05'),(14988,11979,'Y','18','021','EC','A','','','AC','0000590868','0000590868','TX00000756210','IL','1','Garcia','Gloria','Angelica','','','34','453573569','2815 GRAHAM AVE',0,'MISSION','TX','78574','5261','CY','48215','1954-11-17','F','M',':RET:2106-3','N','021','DEN','1813698','33348TX002000201','2014-02-01','2013-12-30 16:07:58','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-01 12:01:20'),(21156,16905,'Y','18','021','EC','A','','','AC','0000961898','0000961898','OH00001985736','IL','1','Wertz','Donald','G','','Jr','34','293567497','50 COLUMBUS ST',0,'BEDFORD','OH','44146','2819','CY','39035','1955-07-07','M','M',':RET:2106-3','N','021','DEN','3620359','99734OH005000401','2014-03-01','2014-02-02 23:01:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:30'),(25947,20577,'Y','18','021','EC','A','','','AC','0000496801','0000496801','OH00002127748','IL','1','MOREY','THOMAS','','','','34','136528049','1252 KNOX AVE',0,'AKRON','OH','44314','2569','CY','39153','1956-08-19','M','U',NULL,'N','021','DEN','2651298','99734OH005000401','2014-03-01','2014-02-26 09:33:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-26 21:01:34'),(26815,21250,'Y','18','024','14','A','','','TE','0000634800','0000634800','','IL','1','Whittridge','Kimberly','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-15','F','',NULL,NULL,NULL,'','1696910','','2014-03-15','2014-02-28 19:52:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-01 21:00:31'),(26908,21326,'Y','18','021','EC','A','','','AC','0001657238','0001657238','LA00003042350','IL','1','HUVAL','CHESTER','','','','34','435293140','4508 JEFFERSON ISLAND RD',0,'NEW IBERIA','LA','70560','2554','CY','22045','1962-12-19','M','U',':RET:2106-3','N','021','DEN','3242305','18575LA002000201','2014-04-01','2014-03-02 12:02:33','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-03 01:00:10'),(27106,21457,'Y','18','021','EC','A','','','AC','0000044327','0000044327','OH00002966543','IL','1','mendoza','victor','','','','34','349867308','207 Rosemarie Dr',0,'Lebanon','OH','45036',NULL,'CY','39165','1977-07-01','M','M',NULL,'N','021','DEN','3005502','99734OH005000301','2014-04-01','2014-03-03 10:59:18','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:24'),(27686,21896,'Y','18','021','EC','A','','','AC','0000018083','0000018083','TX00002894041','IL','1','Cunningham','Sandra','Marie','','','34','450178928','113 Melba',0,'Longview','TX','75602',NULL,'CY','48183','1954-05-27','F','M',':RET:2106-3','N','021','DEN','4037892','33348TX002000201','2014-04-01','2014-03-05 05:05:06','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2014-03-05 21:30:41'),(28712,22722,'Y','18','021','EC','A','','','AC','0000528655','0000528655','MS00002901735','IL','1','Bogan','Arie','','','','34','587984340','238 MONTICELLO ST',0,'HAZLEHURST','MS','39083','3436','CY','28029','1952-12-23','F','U',':RET:2054-5','N','021','DEN','3849068','46300MS002000201','2014-04-01','2014-03-08 13:26:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-08 21:31:15'),(28734,22742,'Y','18','021','EC','A','','','AC','0001250715','0001250715','LA00003620994','IL','1','Tademy','Charnell','','','','34','439797011','4110 BEECH ST',0,'BATON ROUGE','LA','70805','2903','CY','22033','1990-10-05','F','U',NULL,'N','021','DEN','3448830','18575LA002000101','2014-04-01','2014-03-09 16:20:11','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-09 21:00:05'),(22496,17959,'Y','18','021','EC','A','','','AC','0000205826','0000205826','OH00002014954','IL','1','ALLEN','RENEE','K','','','34','288624145','982 BENNETT AVE NW',0,'WARREN','OH','44485','2205','CY','39155','1957-02-25','F','U',':RET:2054-5','N','021','DEN','2758705','99734OH005000301','2014-03-01','2014-02-10 14:23:03','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-10 21:31:11'),(21238,16969,'N','01','021','EC','A',NULL,NULL,'','0001105571','0000195175','','IL','1','AERI','ISHITA','','','','34','289087800','6060 ROUND TOWER LN',0,'DUBLIN','OH','43017','3451','CY','39049','1975-06-28','F','',':RET:2029-7','N','021','DEN','3426351','99734OH005000301','2014-03-01','2014-02-03 13:10:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:01:11'),(19923,15887,'Y','18','021','EC','A','','','AC','0000845246','0000845246','MS00002424118','IL','1','Smith','Kimberly','','','','34','428531152','67 COUNTY ROAD 173',0,'OXFORD','MS','38655','5906','CY','28071','1985-11-28','F','U',':RET:2054-5','N','021','DEN','2642303','46300MS002000101','2014-03-01','2014-01-24 16:45:31','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-24 21:01:05'),(7970,6308,'Y','18','021','EC','A','','','AC','0000064384','0000064384','MS00000192497','IL','1','mora','clara','','','','34','111586594','13121 rosemont st',0,'ocean springs','MS','39564',NULL,'CY','28059','1963-11-16','F','U',':RET:2106-3','N','021','DEN','1728802','46300MS002000201','2014-01-01','2013-12-20 15:43:17','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 03:07:38'),(2177,1789,'Y','18','021','EC','A','','','AC','0000242690','0000242690','OH00000763319','IL','1','GAERTNER','DEBORAH','','','','34','281528470','8175 MAPLEWOOD DR',0,'FINDLAY','OH','45840','8506','CY','39063','1953-05-27','F','M',':RET:2106-3','N','021','HLT','598832','92036OH003001506','2014-01-01','2013-12-10 09:58:02','587.00',NULL,NULL,'623.76','36.76','R-OH002','OH0','623.76',NULL,0,'2013-12-25 19:19:17'),(25580,20291,'Y','18','021','EC','A','','','AC','0001158618','0001158618','TX00002210209','IL','1','MEHOJAH','MATHEW','W','','','34','460795568','131 ESTACADO TRL',0,'FRITCH','TX','79036','8007','CY','48233','1979-08-25','M','M',':RET:1002-5^:RET:2106-3','T','021','DEN','2654385','33348TX002000201','2014-04-01','2014-02-24 15:01:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-26 08:00:36'),(7582,5997,'Y','18','021','EC','A','','','AC','0000825896','0000825896','OH00001158792','IL','1','Gilmore','Marty','','','','34','291640625','19308 SIDNEY PLATTSVILLE RD',0,'SIDNEY','OH','45365','9719','CY','39149','1957-11-16','M','U',':RET:2106-3','T','021','HLT','38764','92036OH002000501','2014-01-01','2013-12-15 14:40:02','410.00',NULL,NULL,'736.49','326.49','R-OH003','OH0','736.49',NULL,0,'2013-12-26 02:33:57'),(25210,19997,'N','19','021','EC','A',NULL,NULL,'','0000471066','0001069363','','IL','1','Thrasher','Emily',NULL,NULL,NULL,NULL,NULL,'7609 ROAD 82',0,'PAYNE','OH','45880','9518','CY','39125','2006-03-08','F','',':RET:2106-3','N','021','DEN','3518034','99734OH005000301','2014-04-01','2014-02-21 12:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:51'),(24722,19629,'Y','18','021','EC','A','','','AC','0000937327','0000937327','OH00002629452','IL','1','LOPEZ DE PORTILLO','ROSA','','','','34','289063548','1826 PLEASANT AVE',0,'HAMILTON','OH','45015','1041','CY','39017','1962-09-15','F','U',NULL,'N','021','DEN','3831681','99734OH005000401','2014-04-01','2014-02-19 10:16:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:38:06'),(16694,13360,'Y','18','021','EC','A','','','AC','0000412780','0000412780','TX00002013084','IL','1','Hernandez','Brenda','','','','34','630565854','8313 ROSEWAY DR',0,'EL PASO','TX','79907','5219','CY','48141','1984-03-25','F','U',NULL,'N','021','DEN','1475774','33348TX002000201','2014-02-01','2014-01-07 14:03:25','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-08 18:24:36'),(2707,2192,'Y','18','021','EC','A','','','AC','0000655790','0000655790','OH00001272743','IL','1','Toth','Jeffrey','','','','34','269783194','1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1965-04-23','M','M',':RET:2106-3','N','021','HLT','428018','52664OH151001501','2014-01-01','2013-12-01 18:45:57','621.00',NULL,NULL,'1233.29','612.29','R-OH012','OH0','437.31',NULL,0,'2013-12-25 19:47:53'),(26178,20759,'Y','18','021','EC','A','','','AC','0000283318','0000283318','OH00002670498','IL','1','Cook','Cherie','','','','34','302860002','1925 ROOKWOOD RD',0,'CLEVELAND','OH','44112','1326','CY','39035','1980-07-24','F','U',':RET:2054-5','N','021','DEN','2907877','99734OH005000301','2014-03-01','2014-02-26 19:17:35','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:39'),(9695,7679,'N','01','021','EC','A',NULL,NULL,'','0000610860','0000801254','','IL','1','Wilson','Kathleen','A','','','34','279585282','7626 STEARNS RD',0,'OLMSTED FALLS','OH','44138','1047','CY','39035','1956-12-16','F','',NULL,'N','021','HLT','1968344','92036OH005000801','2014-01-01','2013-12-21 12:50:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','569.77',NULL,0,'2013-12-26 04:39:49'),(8094,6408,'N','19','021','EC','A',NULL,NULL,'','0000230429','0001056684','','IL','1','Miller','Katherine','L','','','34','273085101','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','2002-12-04','F','',':RET:2106-3','N','021','HLT','2479133','52664OH151001501','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 03:10:47'),(5099,4041,'N','01','021','EC','A',NULL,NULL,'','0001120622','0000858215','','IL','1','Robinson','Barbara','','','','34','480685820','1601 FM 3036',0,'ROCKPORT','TX','78382','7675','CY','48007','1951-07-08','F','',':RET:2106-3','N','021','DEN','2031279','33348TX002000201','2014-01-01','2013-12-19 16:23:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:24'),(5165,4096,'Y','18','024','14','A','','','TE','0000234042','0000234042','','IL','1','Martin','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-31','F','',NULL,NULL,NULL,'','2564256','','2013-12-19','2013-12-19 10:48:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:10'),(22253,17761,'Y','18','021','EC','A','','','AC','0000918294','0000918294','OH00002077971','IL','1','Zimmer','Chester','','','','34','282881857','1695 PAXTON SOUTH DR',0,'LOVELAND','OH','45140','8004','CY','39025','1980-04-03','M','U',NULL,'N','021','HLT','2757382','92036OH003000606','2014-03-01','2014-02-09 16:19:06','206.00',NULL,NULL,'268.56','62.56','R-OH005','OH0','268.56',NULL,0,'2014-02-09 19:00:44'),(21459,17150,'Y','18','021','EC','A','','','AC','0000863505','0000863505','OH00001743193','IL','1','Yasin','Jennifer','','','','34','286689875','1653 VICGROSS AVE',0,'AKRON','OH','44310','2711','CY','39153','1975-04-02','F','M',':RET:2106-3','N','021','HLT','2672504','52664OH151001306','2014-03-01','2014-02-04 15:37:28','443.00',NULL,NULL,'545.03','102.03','R-OH012','OH0','277.87',NULL,0,'2014-02-04 21:01:33'),(6268,4970,'Y','18','021','EC','A','','','AC','0000013134','0000013134','LA00001212716','IL','1','HARRISON','ROBERT','','','','34','499528313','712 KELLI DR',0,'PATTERSON','LA','70392',NULL,'CY','22101','1958-04-03','M','U',NULL,'N','021','DEN','322516','18575LA002000201','2014-01-01','2013-10-07 18:31:53','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:32:27'),(21087,16850,'Y','18','021','EC','A','','','AC','0000387322','0000387322','OH00002485931','IL','1','Lindsey','Veronica','','','','34','268589295','1204 JOHNSON ST SE',0,'MASSILLON','OH','44646','8235','CY','39151','1955-07-16','F','U',':RET:2054-5','N','021','DEN','3075739','99734OH005000301','2014-03-01','2014-02-02 13:19:59','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-02 19:00:25'),(14535,11598,'Y','18','021','EC','A','','','AC','0000518986','0000518986','MS00001744530','IL','1','ALDRIDGE','CHARLES','','','','34','587454127','5600 KEELE STREET',0,'JACKSON','MS','39206',NULL,'CY','28049','1968-12-06','M','U',':RET:2054-5','T','021','DEN','1921289','46300MS002000201','2014-02-01','2013-12-27 09:21:36','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:40'),(16392,13117,'Y','18','021','EC','A','','','AC','0000145768','0000145768','TX00001901328','31','1','Rodriguez','Ida','','','','34','467350471','P O Box 2685',0,'Edinburg','TX','78540',NULL,'CY','48215','1960-10-25','F','M',':RET:2106-3','N','021','DEN','1746433','33348TX002000201','2014-02-01','2014-01-06 10:30:11','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-07 04:03:36'),(17794,14214,'Y','18','021','EC','A','','','AC','0001100613','0001100613','OH00001861033','IL','1','Woods','James','','','','34','298748216','824 LOCUST CORNER RD',0,'CINCINNATI','OH','45245','3112','CY','39025','1963-10-08','M','U',NULL,'N','021','HLT','2042426','92036OH006000601','2014-02-01','2014-01-13 15:42:54','0.00',NULL,NULL,'304.05','304.05','R-OH005','OH0','304.05',NULL,0,'2014-01-14 01:33:49'),(20537,16410,'N','01','021','EC','A',NULL,NULL,'','0000129285','0001250875','','IL','1','Moffat','Robert','G','','','34','292589966','4520 FAIRHAVEN AVE NW',0,'CANTON','OH','44709','1345','CY','39151','1956-09-05','M','',':RET:2106-3','N','021','HLT','3212609','52664OH152000901','2014-03-01','2014-01-29 12:10:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2014-01-29 21:01:33'),(27546,21789,'Y','18','021','EC','A','','','AC','0001129077','0001129077','OH00002802799','IL','1','BOSHKOZSKI','MILE','','','','34','831927849','7994 EQUITANA WAY',0,'BLACKLICK','OH','43004','9176','CY','39049','1968-06-24','M','M',':RET:2106-3','N','021','DEN','3912098','99734OH005000401','2014-04-01','2014-03-04 13:09:32','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00','CIC',0,'2014-03-04 21:30:08'),(581,476,'Y','18','021','EC','A','','','AC','0000255930','0000255930','OH00001128298','IL','1','Gniewkowski','Janet','','','','34','292428152','249 JENNINGS RD',0,'ROSSFORD','OH','43460','1141','CY','39173','1950-03-08','F','U',':RET:2106-3','N','021','HLT','1116111','92036OH002002601','2014-01-01','2013-12-04 11:16:46','208.00',NULL,NULL,'664.74','456.74','R-OH001','OH0','664.74',NULL,0,'2013-12-25 17:50:53'),(22938,18287,'Y','18','021','EC','A','','','AC','0000684086','0000684086','LA00001588096','IL','1','BAUER','KRISTIN','','','','34','435416044','313 JADE AVE',0,'METAIRIE','LA','70003','6616','CY','22051','1980-06-13','F','U',':RET:2106-3','N','021','DEN','3847142','18575LA002000201','2014-03-01','2014-02-11 12:05:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-11 21:30:16'),(22803,18200,'N','19','021','EC','A',NULL,NULL,'','0000356070','0000611995','','IL','1','Brook','Tegist','','','','34','692124079','725 DIANDREA DR',0,'FAIRLAWN','OH','44333','2906','CY','39153','1995-05-27','F','',':RET:2054-5','N','021','DEN','3675876','99734OH005000301','2014-03-01','2014-02-11 13:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:53'),(22543,18001,'Y','18','021','EC','A','','','AC','0001153742','0001153742','LA00002558403','IL','1','owen','kevin','','','','34','086644126','1014 colonial dr',0,'jackson','LA','70748',NULL,'CY','22037','1979-07-01','M','U',':RET:2106-3','N','021','DEN','2872736','18575LA002000101','2014-03-01','2014-02-10 11:00:21','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-10 21:31:40'),(21985,17557,'Y','18','021','EC','A','','','AC','0001344247','0001344247','LA00002630263','IL','1','Lucido','Michael','','','','34','433217747','11132 HIGHWAY 1063',0,'INDEPENDENCE','LA','70443','3052','CY','22105','1957-11-10','M','M',':RET:2106-3','N','021','DEN','3690339','18575LA002000201','2014-03-01','2014-02-06 20:46:20','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-07 19:00:39'),(5764,4579,'Y','18','021','EC','A','','','AC','0000276274','0000276274','OH00001056740','IL','1','CLARK','VOYICE','','','','34','279808359','2472 MORRIS BLACK PL',0,'CLEVELAND','OH','44104','2652','CY','39035','1979-11-30','F','U',':RET:2054-5','N','021','DEN','1495204','99734OH005000401','2014-01-01','2013-12-23 22:13:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:46:36'),(19081,15202,'Y','18','021','EC','A','','','AC','0001008968','0001008968','OH00002437095','IL','1','Jackson','Maijic','','','','34','522398272','1575 Gelhot Dr',0,'Fairfield','OH','45014',NULL,'CY','39017','1983-08-28','F','U',':RET:2054-5','N','021','DEN','3017612','99734OH005000401','2014-03-01','2014-01-18 11:33:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-21 08:44:26'),(14286,11396,'Y','18','021','EC','A','','','AC','0000701703','0000701703','OH00001219621','IL','1','Birsen','Monica','','','','34','281621036','9486 Rudolph Rd',0,'Rudolph','OH','43462',NULL,'CY','39173','1958-05-31','F','U',':RET:2106-3','N','021','HLT','2108026','92036OH004002601','2014-02-01','2013-12-26 10:01:50','344.00',NULL,NULL,'349.65','5.65','R-OH001','OH0','349.65',NULL,0,'2013-12-27 02:06:26'),(25689,20382,'Y','18','021','EC','A','','','AC','0000351621','0000351621','OH00002504900','IL','1','cooper','ivonne','','','','34','269985507','3560 w alexis rd',0,'toledo','OH','43623',NULL,'CY','39095','1962-06-03','F','R',NULL,'N','021','HLT','3540531','92036OH006002601','2014-04-01','2014-02-23 19:55:10','0.00',NULL,NULL,'288.42','288.42','R-OH001','OH0','288.42',NULL,0,'2014-02-26 09:30:11'),(26759,21207,'Y','18','021','EC','A','','','AC','0000216049','0000216049','TX00003028851','IL','1','Wright','Webb','','','','34','454634086','4803 TX HWY 24 North',0,'Cooper','TX','75432',NULL,'CY','48119','1968-11-30','M','U',':RET:2106-3','N','021','DEN','3141185','33348TX002000101','2014-03-01','2014-02-28 18:36:12','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15','CIC',0,'2014-03-01 19:00:07'),(27116,21463,'Y','18','021','EC','A','','','AC','0000682209','0000682209','OH00003271415','IL','1','Ezell','Taundra','LaVae','','','34','270581606','28 W CENTRAL AVE',0,'TOLEDO','OH','43608','1710','CY','39095','1958-08-10','F','U',':RET:2054-5','N','021','DEN','2898851','99734OH005000301','2014-04-01','2014-03-03 12:59:13','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-03 21:30:30'),(28750,22755,'Y','18','021','EC','A','','','AC','0000825803','0000825803','TX00003693952','IL','1','GURROLA','EDUARDO','','','','34','008238594','5300 STANDARD AVE',0,'SAN JUAN','TX','78589','4984','CY','48215','1974-11-23','M','M',NULL,'N','021','DEN','3941251','33348TX002000201','2014-04-01','2014-03-08 23:38:44','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-09 21:00:16'),(806,666,'Y','18','021','EC','A','','','AC','0000070572','0000070572','TX00000691222','IL','1','Smith','Michael','','','','34','459372513','4630 ELVIRA DR',0,'CORPUS CHRISTI','TX','78416','2449','CY','48355','1975-01-02','M','U',NULL,'N','021','DEN','2461773','33348TX002000201','2014-01-01','2013-12-16 18:21:54','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 18:05:41'),(23682,18858,'Y','18','021','EC','A','','','AC','0000205834','0000205834','OH00002255995','IL','1','lindsey','dorian','','','','34','355544303','1068 PIERMONT RD',0,'SOUTH EUCLID','OH','44121','2935','CY','39035','1975-09-19','M','U',':RET:2054-5','N','021','DEN','2812074','99734OH005000401','2014-03-01','2014-02-13 18:28:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:30:31'),(23224,18514,'Y','18','021','EC','A','','','AC','0000675494','0000675494','OH00002216460','IL','1','Akunne','Chinonye','','','','34','271945882','634 W Foulke Ave',0,'Findlay','OH','45840',NULL,'CY','39063','1988-04-13','F','U',':RET:2054-5','N','021','HLT','3265721','92036OH003001505','2014-03-01','2014-02-12 17:18:54','164.00',NULL,NULL,'230.76','66.76','R-OH002','OH0','230.76',NULL,0,'2014-02-12 21:32:20'),(20241,16150,'Y','18','021','EC','A','','','AC','0000687928','0000687928','MS00001501991','31','1','FEAZELL','VICKI','','','','34','587063330','P.O. BOX 55',0,'CORINTH','MS','38834',NULL,'CY','28003','1963-04-26','F','U',':RET:2106-3','N','021','DEN','3294973','46300MS002000101','2014-03-01','2014-01-28 16:23:47','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-28 21:00:07'),(19297,15383,'Y','18','021','EC','A','','','AC','0002112197','0002112197','LA00001376866','IL','1','Hall','Vanesse','','','','34','434212296','632 W Marlin Ct',0,'Terrytown','LA','70056',NULL,'CY','22051','1961-07-15','F','M',':RET:2054-5','N','021','DEN','2491267','18575LA002000201','2014-03-01','2014-01-21 16:40:42','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,1,'2014-01-22 03:21:58'),(19276,15364,'Y','18','024','14','A','','','TE','0000672544','0000672544','','IL','1','Schlatter','Ellen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-02','F','',NULL,NULL,NULL,'','1970627','','2014-01-20','2014-01-20 13:34:59',NULL,NULL,NULL,NULL,NULL,NULL,'IN0',NULL,'CANCEL',0,'2014-01-21 08:46:57'),(2997,2409,'N','01','021','EC','A',NULL,NULL,'','0000705120','0001097757','','IL','1','Isenbarger','Stephanie','','','','34','273766352','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1979-10-11','F','',':RET:2106-3','N','021','DEN','728312','99734OH005000301','2014-01-01','2013-12-05 20:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:33'),(3241,2611,'Y','18','021','EC','A','','','AC','0000096359','0000096359','OH00000746829','IL','1','Bonko','Mary','','','','34','293523683','324 Westberry Circle',0,'Tallmadge','OH','44278',NULL,'CY','39153','1952-08-27','F','U',NULL,'N','021','HLT','319801','52664OH151001501','2014-01-01','2013-10-05 18:02:27','309.00',NULL,NULL,'751.58','442.58','R-OH012','OH0','751.58',NULL,0,'2013-12-25 20:46:20'),(17031,13626,'Y','18','021','EC','A','','','AC','0000823530','0000823530','OH00001784150','IL','1','Wyss','Elizabeth','','','','34','302620093','3453 MAPLEVIEW DR',0,'TOLEDO','OH','43623','1915','CY','39095','1971-10-22','F','R',':RET:2106-3','N','021','HLT','1993081','92036OH004002601','2014-02-01','2014-01-09 10:38:17','0.00',NULL,NULL,'207.75','207.75','R-OH001','OH0','207.75',NULL,0,'2014-01-13 02:20:44'),(5773,4586,'Y','18','024','14','A','','','TE','0000105370','0000105370','','IL','1','Williams','Kareema',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-08','F','',NULL,NULL,NULL,'','2118526','','2013-12-23','2013-12-23 22:41:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:46:51'),(24652,19569,'Y','18','021','EC','A','','','AC','0000616924','0000616924','OH00001622462','IL','1','friend','shelli','','','','34','294608233','1803 KINGSBURY DR',0,'SAINT MARYS','OH','45885','1345','CY','39011','1961-07-15','F','U',':RET:2106-3','T','021','HLT','3620764','92036OH005001504','2014-04-01','2014-02-18 18:55:24','263.00',NULL,NULL,'494.04','231.04','R-OH002','OH0','494.04',NULL,0,'2014-02-20 04:23:12'),(25303,20073,'N','01','021','EC','A',NULL,NULL,'','0000270056','0000745483','','IL','1','CLARKE','DEREK','','','','34','219644876','4205 HEGNER AVE',0,'CINCINNATI','OH','45236','3614','CY','39061','1965-02-10','M','',':RET:2106-3','N','021','DEN','3253499','99734OH005000401','2014-04-01','2014-02-25 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:28'),(29043,22986,'Y','18','021','EC','A','','','AC','0000919452','0000919452','OH00003554152','IL','1','Bowman','Bambi','','','','34','300687345','236 BARKLEY PL E',0,'COLUMBUS','OH','43213','2002','CY','39049','1961-12-15','F','U',':RET:2054-5','T','021','DEN','4302226','99734OH005000401','2014-04-01','2014-03-10 13:39:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:01:41'),(1183,975,'Y','18','021','EC','A','','','AC','0001059452','0001059452','OH00000935171','31','1','Gill','Roger','','','','34','293621946','122 S GLENWOOD AVE',0,'LIMA','OH','45805','2601','CY','39003','1957-03-02','M','U',':RET:2106-3','N','021','DEN','479008','99734OH005000301','2014-01-01','2013-12-03 07:06:23','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:19:26'),(1266,1044,'Y','18','021','EC','A','','','AC','0000938949','0000938949','TX00001181843','IL','1','Caceres','Peter','','','','34','452530017','105 E MAXAN ST',0,'PORT ISABEL','TX','78578','4504','CY','48061','1959-05-02','M','U',':RET:2106-3','N','021','DEN','524827','33348TX002000201','2014-01-01','2013-11-28 19:38:34','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:30:06'),(8958,7106,'Y','18','021','EC','A','','','AC','0001233041','0001233041','OH00000802688','IL','1','COLLINS','CYNTHIA','SUE','','','34','300684219','2299 CARRIAGE HILL DR',0,'BELLEFONTAINE','OH','43311','9430','CY','39091','1961-02-25','F','M',':RET:2106-3','N','021','DEN','2143216','99734OH005000401','2014-01-01','2013-12-18 12:40:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:03:47'),(8828,6999,'N','01','021','EC','A',NULL,NULL,'','0000047108','0000077162','','IL','1','DE SANTIAGO','JOSEFINA','','','','34','635806793','5664 BURNING TREE',0,'EL PASO','TX','79912',NULL,'CY','48141','1942-04-06','F','',NULL,'N','021','DEN','2591080','33348TX002000201','2014-01-01','2013-12-17 20:06:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','16.22',NULL,0,'2013-12-26 04:00:27'),(8113,6418,'Y','18','021','EC','A','','','AC','0000765129','0000765129','LA00001010037','IL','1','Schexnider','Marvin','G','','','34','439846411','610 INDEPENDENCE ST',0,'NEW ORLEANS','LA','70117','5722','CY','22071','1951-09-12','M','M',':RET:2106-3','N','021','DEN','617046','18575LA002000201','2014-01-01','2013-11-22 10:25:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:15:05'),(1635,1366,'Y','18','021','EC','A','','','AC','0000291938','0000291938','TX00000535771','IL','1','Horlander','Benjamin','','','','34','450838926','2308 SARASOTA DR',0,'TYLER','TX','75701','4943','CY','48423','1981-08-11','M','M',':RET:2106-3','N','021','DEN','2298613','33348TX002000201','2014-01-01','2013-12-24 15:10:19','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 18:52:56'),(23053,18380,'Y','18','021','EC','A','','','AC','0001429878','0001429878','LA00002347199','IL','1','Franklin','Terrion','','','','34','436512285','62395 Bayou Rd.',0,'Plaquemine','LA','70764',NULL,'CY','22047','1967-06-10','F','U',':RET:2054-5','N','021','DEN','3639509','18575LA002000201','2014-03-01','2014-02-11 20:34:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:47'),(4350,3453,'Y','18','021','EC','A','','','AC','0000675438','0000675438','OH00000722385','IL','1','Hutchinson','Dorothea','','','','34','584656533','2110 Louden Road',0,'Peebles','OH','45660',NULL,'CY','39001','1953-04-02','F','M',':RET:2106-3','N','021','HLT','1602431','92036OH002000601','2014-01-01','2013-12-17 12:20:09','335.00',NULL,NULL,'672.81','337.81','R-OH005','OH0','672.81',NULL,0,'2013-12-25 21:53:27'),(22432,17911,'Y','18','024','14','A','','','TE','0000925341','0000925341','','IL','1','Barrera','Maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-25','F','',NULL,NULL,NULL,'','3059837','','2014-02-09','2014-02-09 22:05:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:37'),(21550,17214,'Y','18','021','EC','A','','','AC','0000894658','0000894658','OH00001893243','IL','1','Jas','Trudy','','','','34','260944393','5300 Hamilton Ave',0,'Cincinnati','OH','45224',NULL,'CY','39061','1951-08-04','F','U',':RET:2106-3','N','021','DEN','3151198','99734OH005000401','2014-03-01','2014-02-05 13:40:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:13'),(20546,16419,'Y','18','021','EC','A','','','AC','0000240376','0000240376','OH00002590573','IL','1','Traxler','Mary','L','','','34','271602385','188 HUDSON ST',0,'TIFFIN','OH','44883','1420','CY','39147','1956-09-08','F','U',':RET:2106-3','N','021','HLT','2375598','92036OH006002701','2014-03-01','2014-01-29 10:05:18','364.00',NULL,NULL,'376.87','12.87','R-OH006','OH0','376.87',NULL,0,'2014-01-29 21:01:38'),(24557,19506,'Y','18','024','14','A','','','TE','0000706180','0000706180','','IL','1','Smith','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-28','M','',NULL,NULL,NULL,'','1966643','','2014-03-05','2014-02-18 18:08:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-20 04:05:38'),(15592,12477,'N','19','021','EC','A',NULL,NULL,'','0001063253','0000322151','','IL','1','Mcguire','Elizabeth','','','','34','290960133','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1993-11-12','F','',NULL,'N','021','DEN','2167311','99734OH005000301','2014-02-01','2013-12-31 10:46:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:26'),(15610,12486,'Y','18','021','EC','A','','','AC','0000350584','0000350584','OH00000506535','IL','1','Rutkowski','Melinda','','','','34','232237589','1403 DIFFORD DR',0,'NILES','OH','44446','2830','CY','39155','1971-03-07','F','U',':RET:2106-3','N','021','DEN','1587072','99734OH005000301','2014-02-01','2013-12-31 17:32:19','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,1,'2014-01-02 04:32:47'),(17103,13688,'Y','18','021','EC','A','','','AC','0000550712','0000550712','TX00001872346','IL','1','McInturff','Ronald','','','','34','442509174','1301 Limestone Drive',0,'Corpus Christi','TX','78412',NULL,'CY','48355','1950-10-01','M','M',':RET:2106-3','N','021','DEN','2507059','33348TX002000201','2014-02-01','2014-01-08 17:26:43','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-01-13 02:21:33'),(17384,13909,'N','01','021','EC','A',NULL,NULL,'','0001234133','0000156952','','IL','1','Nissen','Marlene','S','','','34','280527084','29454 MILLBURY RD',0,'MILLBURY','OH','43447','9454','CY','39173','1952-09-09','F','',':RET:2106-3','T','021','DEN','2531694','99734OH005000401','2014-02-01','2014-01-10 10:09:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:00:08'),(19780,15768,'N','01','021','EC','A',NULL,NULL,'','0000251651','0000885627','','IL','1','Kaemming','Nick','L','','','34','290848351','2132 RAGAN WOODS DR',0,'TOLEDO','OH','43614','1009','CY','39095','1980-03-29','M','',':RET:2106-3','N','021','HLT','2169927','92036OH005002606','2014-03-01','2014-01-22 23:29:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.59',NULL,0,'2014-01-23 21:01:33'),(19198,15294,'Y','18','024','14','A','','','TE','0000427340','0000427340','','IL','1','WADE','HOWARD',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-10-28','M','',NULL,NULL,NULL,'','2815071','','2014-01-20','2014-01-20 14:19:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:46:15'),(23536,18749,'Y','18','021','EC','A','','','AC','0001627544','0001627544','LA00002158830','IL','1','Toomer','Lisa','A','','','34','439210300','1498 MANDOLIN ST',0,'NEW ORLEANS','LA','70122','1895','CY','22071','1967-05-27','F','U',':RET:2054-5','T','021','DEN','3825588','18575LA002000201','2014-03-01','2014-02-13 12:14:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:29'),(22239,17751,'N','01','021','EC','A',NULL,NULL,'','0000975273','0000032996','','IL','1','SHULKO','DAVID','WILLIAM','','','34','270445489','10345 WEST PIKE',0,'HOPEWELL','OH','43746','9771','CY','39119','1949-09-22','M','',':RET:2106-3','T','021','DEN','3740266','99734OH005000301','2014-03-01','2014-02-09 12:17:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-09 19:00:37'),(15989,12797,'Y','18','021','EC','A','','','AC','0000528293','0000528293','TX00002210471','IL','1','Garriolo','Elias','','','','34','631208499','324 S 83RD ST',0,'EDINBURG','TX','78542','2111','CY','48215','1954-06-26','M','U',':RET:2106-3','N','021','DEN','1624893','33348TX002000201','2014-02-01','2014-01-03 11:39:38','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-04 02:01:11'),(8157,6453,'Y','18','021','EC','A','','','AC','0000577006','0000577006','MS00000859033','IL','1','Bonura','Rocco','','','','34','436966559','8560 MINT JULEP DR',0,'PERKINSTON','MS','39573','4553','CY','28045','1953-11-14','M','U',':RET:2106-3','N','021','DEN','138985','46300MS002000201','2014-01-01','2013-11-22 10:39:13','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 03:16:13'),(1869,1526,'Y','18','021','EC','A','','','AC','0000578790','0000578790','OH00001128040','IL','1','Barnett','Oretha','','','','34','291540125','3974 Colony Rd',0,'South Euclid','OH','44118',NULL,'CY','39035','1954-08-20','F','M',':RET:2054-5','N','021','HLT','2138772','52664OH152000901','2014-01-01','2013-12-24 14:29:09','737.00',NULL,NULL,'997.20','260.20','R-OH011','OH0','479.53',NULL,0,'2013-12-25 18:58:15'),(1885,1541,'Y','18','021','EC','A','','','AC','0000665652','0000665652','OH00001533697','IL','1','Sartin','David','','','','34','290883685','420 UTAH ST',0,'TOLEDO','OH','43605','2248','CY','39095','1988-03-08','M','U',':RET:2106-3','T','021','HLT','1558008','92036OH006002601','2014-01-01','2013-12-24 18:03:30','118.00',NULL,NULL,'178.56','60.56','R-OH001','OH0','178.56',NULL,0,'2013-12-25 18:58:38'),(3024,2432,'Y','18','021','EC','A','','','AC','0000798392','0000798392','OH00000820194','IL','1','hasley','karen','','','','34','369543857','1259 MYRTLE AVE',0,'CUYAHOGA FALLS','OH','44221','4349','CY','39153','1949-09-24','F','U',':RET:2106-3','N','021','HLT','242268','52664OH151001305','2014-01-01','2013-12-06 10:45:06','510.00',NULL,NULL,'669.00','159.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 20:18:15'),(24909,19749,'Y','18','024','14','A','','','TE','0000544082','0000544082','','IL','1','McCarver','Floyd',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-05','M','',NULL,NULL,NULL,'','496823','','2014-03-31','2014-02-20 11:15:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:07'),(26645,21127,'N','19','021','EC','A',NULL,NULL,'','0000759761','0000237640','','IL','1','Torres','Miranda','','','','34','269155234','4523 Vista Circle',0,'Kent','OH','44240',NULL,'CY','39133','2008-09-23','F','',NULL,'N','021','HLT','2980732','52664OH151001304','2014-04-01','2014-02-28 10:31:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:05'),(23205,18500,'Y','18','021','EC','A','','','AC','0000740320','0000740320','OH00002639296','IL','1','Ellis','Kimberlee','','','','34','282701421','40 HOPEWELL AVE',0,'TIFFIN','OH','44883','2601','CY','39147','1959-12-25','F','M',':RET:2106-3','T','021','HLT','3696798','92036OH003002705','2014-03-01','2014-02-12 13:04:02','347.00',NULL,NULL,'499.98','152.98','R-OH006','OH0','499.98',NULL,0,'2014-02-12 21:32:10'),(195,163,'Y','18','021','EC','A','','','AC','0000357163','0000357163','OH00000345038','IL','1','Anderson','Patricia','','','','34','413375709','2180 PLYMOUTH DR',0,'UNIONTOWN','OH','44685','9743','CY','39153','1967-12-22','F','M',NULL,'N','021','HLT','1067464','52664OH151001501','2014-01-01','2013-12-04 19:50:34','0.00',NULL,NULL,'989.09','989.09','R-OH012','OH0','401.20',NULL,0,'2013-12-25 17:20:05'),(17441,13953,'Y','18','021','EC','A','','','AC','0001030389','0001030389','OH00002454777','IL','1','DUFRESNE','DAWN','','','','34','274809638','3522 WALBRIDGE RD',0,'MILLBURY','OH','43447','9741','CY','39173','1967-04-09','F','M',':RET:2106-3','N','021','HLT','2394519','92036OH004002601','2014-02-01','2014-01-10 16:49:59','613.00',NULL,NULL,'874.92','261.92','R-OH001','OH0','235.18',NULL,0,'2014-01-13 03:00:36'),(16331,13076,'Y','18','021','EC','A','','','AC','0001380428','0001380428','LA00001887139','IL','1','Jones','Deatra','','','','34','350608220','41154 Clearwater Avenue',0,'Gonzales','LA','70737',NULL,'CY','22005','1960-02-02','F','M',':RET:2054-5','N','021','DEN','1879623','18575LA002000201','2014-02-01','2014-01-06 17:56:55','0.00',NULL,NULL,'43.83','43.83','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:02:00'),(16197,12967,'Y','18','021','EC','A','','','AC','0001233083','0001233083','TX00002331620','IL','1','Crawford','Vicki','','','','34','465783203','925 POMPANO DR',0,'ARANSAS PASS','TX','78336','5336','CY','48409','1949-09-02','F','U',':RET:2106-3','N','021','DEN','2474489','33348TX002000201','2014-02-01','2014-01-04 12:12:26','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-05 00:01:01'),(15909,12740,'Y','18','021','EC','A','','','AC','0000473663','0000473663','OH00001715047','IL','1','HAYDEN','ERIC','ANTHONY','','','34','293603752','4680 NORTHRIDGE DR',0,'BATAVIA','OH','45103','1389','CY','39025','1967-09-02','M','U',':RET:2106-3','N','021','HLT','1902535','92036OH006000601','2014-02-01','2014-01-02 15:14:29','145.00',NULL,NULL,'255.36','110.36','R-OH005','OH0','255.36',NULL,0,'2014-01-03 02:06:19'),(14944,11943,'Y','18','021','EC','A','','','AC','0000063723','0000063723','OH00000911341','IL','1','Amato','Lucas','','','','34','298901792','58 W ELM ST',0,'NORWALK','OH','44857','2025','CY','39077','1988-03-25','M','U',':RET:2106-3','N','021','HLT','1753938','92036OH002002701','2014-02-01','2013-12-29 16:58:43','78.00',NULL,NULL,'226.09','148.09','R-OH006','OH0','226.09',NULL,0,'2013-12-30 00:02:25'),(14621,11670,'Y','18','024','14','A','','','TE','0000618374','0000618374','','IL','1','Jordan','Robin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-03-07','F','',NULL,NULL,NULL,'','1637549','','2013-12-27','2013-12-27 18:21:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:56'),(1815,1490,'Y','18','021','EC','A','','','AC','0000151976','0000151976','OH00001650211','IL','1','Chan','Hing','','','','34','067705112','453 SEAMAN AVE',0,'AKRON','OH','44305','3850','CY','39153','1979-07-26','M','U',':RET:2034-7','N','021','HLT','2488206','52664OH151001501','2014-01-01','2013-12-24 15:43:31','102.00',NULL,NULL,'324.70','222.70','R-OH012','OH0','324.70',NULL,0,'2013-12-25 18:57:04'),(2482,2021,'Y','18','021','EC','A','','','AC','0000696998','0000696998','LA00001124329','IL','1','LEE','KATHLEEN','','','','34','435862961','2619 NORTH CENTRAL AVE',0,'LUTCHER','LA','70071',NULL,'CY','22093','1952-10-04','F','U',':RET:2054-5','N','021','DEN','913666','18575LA002000201','2014-01-01','2013-12-09 14:36:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:33'),(3186,2562,'Y','18','021','EC','A','','','AC','0000808614','0000808614','OH00000899323','IL','1','Good','Christopher','','','','34','270844912','231 ORCHARD AVE',0,'CUYAHOGA FALLS','OH','44221','4938','CY','39153','1976-11-16','M','M',NULL,'N','021','HLT','255829','52664OH151001501','2014-01-01','2013-11-18 10:18:51','0.00',NULL,NULL,'331.12','331.12','R-OH012','OH0','331.12',NULL,0,'2013-12-25 20:31:59'),(13163,10500,'Y','18','021','EC','A','','','AC','0001168001','0001168001','OH00000901411','IL','1','Markowitz','Robert','A','','','34','302468387','3446 OLD GREEN RD',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1955-11-30','M','M',':RET:2106-3','N','021','DEN','1955347','99734OH005000401','2014-01-01','2013-12-23 18:12:18','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:54'),(3277,2642,'Y','18','021','EC','A','','','AC','0001019265','0001019265','OH00000445335','IL','1','Bradley','Mary','','','','34','276523663','304 Snider Ct',0,'Mason','OH','45040',NULL,'CY','39165','1951-12-20','F','U',':RET:2106-3','N','021','HLT','1792150','92036OH004001201','2014-01-01','2013-12-22 14:43:40','373.00',NULL,NULL,'495.91','122.91','R-OH004','OH0','495.91',NULL,0,'2013-12-25 21:15:08'),(20369,16270,'Y','18','021','EC','A','','','AC','0001528367','0001528367','LA00001791572','IL','1','KNIGHTEN','JESSE','ANN','','','34','545888423','1079 HIGHWAY 846 N',0,'COLUMBIA','LA','71418','5037','CY','22021','1951-01-14','F','M',':RET:2106-3','N','021','DEN','3386257','18575LA002000101','2014-03-01','2014-01-28 19:24:21','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-29 21:00:04'),(5305,4205,'Y','18','021','EC','A','','','AC','0000087515','0000087515','MS00001006930','IL','1','SIMPSON','ZAKIA','','','','34','425594662','1903 MARSHALL PL',0,'JACKSON','MS','39213','4450','CY','28049','1981-01-12','F','U',':RET:2054-5','N','021','DEN','2560264','46300MS002000101','2014-01-01','2013-12-18 21:34:50','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 23:06:24'),(3448,2772,'Y','18','021','EC','A','','','AC','0000501608','0000501608','OH00001183561','IL','1','Hammond','Hope','','','','34','270905218','180 College Park Drive',0,'Elyria','OH','44053',NULL,'CY','39093','1984-04-23','F','U',':RET:2106-3','N','021','DEN','1927746','99734OH005000401','2014-01-01','2013-12-21 21:40:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:19:25'),(20348,16249,'Y','18','021','EC','A','','','AC','0000245022','0000245022','OH00001380861','IL','1','Darnell','Pamela','','','','34','276529949','1498 Beacon St.',0,'Cincinnati','OH','45230',NULL,'CY','39061','1953-09-10','F','U',':RET:2106-3','N','021','HLT','2802499','92036OH005001201','2014-03-01','2014-01-28 15:25:25','297.00',NULL,NULL,'582.60','285.60','R-OH004','OH0','582.60',NULL,0,'2014-01-28 21:01:12'),(14206,11328,'N','01','021','EC','A',NULL,NULL,'','0000750139','0000484289','','IL','1','defilippo','anjelo','','','','34','059460252','5015 W HANOVER AVE',0,'DALLAS','TX','75209','3309','CY','48113','1952-12-17','M','',NULL,'N','021','DEN','1788679','33348TX002000201','2014-02-01','2013-12-26 14:11:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-27 02:04:22'),(20245,16154,'Y','18','021','EC','A','','','AC','0001199297','0001199297','TX00001508006','IL','1','SIMONS','RAYMOND','','','','34','282868603','1479 ASTOR CRK',0,'NEW BRAUNFELS','TX','78130','3776','CY','48187','1979-09-26','M','M',':RET:2106-3','N','021','DEN','2521566','33348TX002000101','2014-03-01','2014-01-28 02:48:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-28 21:00:10'),(16841,13472,'Y','18','021','EC','A','','','AC','0000919417','0000919417','OH00001739073','IL','1','sands','ellen','','','','34','273448558','1858 INDIAN HILLS TRL',0,'AKRON','OH','44313','4790','CY','39153','1953-03-27','F','U',':RET:2106-3','N','021','HLT','1979733','52664OH151001305','2014-02-01','2014-01-11 10:51:07','439.00',NULL,NULL,'605.24','166.24','R-OH012','OH0','605.24',NULL,0,'2014-01-13 02:18:33'),(19461,15513,'Y','18','021','EC','A','','','AC','0001169072','0001169072','TX00002579751','IL','1','TROUTMAN','WALTER','','','','34','460739664','106 RETAMA CT',0,'GEORGETOWN','TX','78626','6348','CY','48491','1970-12-24','M','M',':RET:2106-3','N','021','DEN','2883466','33348TX002000201','2014-03-01','2014-01-21 23:18:03','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-23 03:01:56'),(26902,21321,'Y','18','021','EC','A','','','AC','0000717600','0000717600','TX00003007588','IL','1','Crosby','Cheryl','','','','34','281568481','4740 N MESA ST',0,'EL PASO','TX','79912','6115','CY','48141','1957-06-26','F','U',':RET:2106-3','N','021','DEN','3419314','33348TX002000201','2014-04-01','2014-03-02 15:24:10','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-03 01:00:07'),(4405,3501,'N','01','021','EC','A',NULL,NULL,'','0001192653','0000209609','','IL','1','Hill','Cornelia','','','','34','161646464','2321 BAIRD RD',0,'FOSTORIA','OH','44830','9723','CY','39173','1964-03-12','F','',':RET:2106-3','N','021','DEN','939975','99734OH005000401','2014-01-01','2013-12-12 14:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:16'),(3648,2920,'Y','18','021','EC','A','','','AC','0000313227','0000313227','OH00000745868','31','1','Sawatsky','Will','','','','34','302700850','7105 ORCHARD GROVE AVE',0,'CLEVELAND','OH','44144','1556','CY','39035','1976-09-28','M','M',':RET:2106-3','N','021','DEN','692480','99734OH005000401','2014-01-01','2013-12-12 18:39:41','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:30:34'),(9318,7388,'Y','18','021','EC','A','','','AC','0001183184','0001183184','LA00000815848','IL','1','Cooper','Mary','','','','34','439966968','214 CHARLOTTE ST',0,'MONROE','LA','71202','3906','CY','22073','1953-12-23','F','M',':RET:2054-5','N','021','DEN','1788364','18575LA002000101','2014-01-01','2013-12-21 13:31:44','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2013-12-26 04:30:26'),(4303,3422,'Y','18','021','EC','A','','','AC','0001175697','0001175697','OH00001157411','IL','1','Martin','Thomas','','','','34','297487867','1559 OLD STATE ROUTE 74',0,'BATAVIA','OH','45103','1604','CY','39025','1950-12-04','M','M',':RET:2106-3','N','021','HLT','2570296','92036OH005000604','2014-01-01','2013-12-17 16:32:10','842.00',NULL,NULL,'1192.50','350.50','R-OH005','OH0','633.70',NULL,0,'2013-12-25 21:52:24'),(139,118,'Y','18','021','EC','A','','','AC','0000353942','0000353942','OH00000507964','IL','1','Workman','Connie','','','','34','289582310','122 E. Church St.',0,'Perrysville','OH','44864',NULL,'CY','39005','1957-03-03','F','U',':RET:2106-3','N','021','HLT','50896','52664OH152000901','2014-01-01','2013-12-04 21:08:02','0.00',NULL,NULL,'381.07','381.07','R-OH012','OH0','381.07',NULL,0,'2013-12-25 17:18:37'),(13681,10916,'Y','18','021','EC','A','','','AC','0001036135','0001036135','OH00000116405','IL','1','Moore','David','','','','34','241553404','12817 OAKWOOD AVE NW',0,'UNIONTOWN','OH','44685','8405','CY','39151','1984-04-15','M','U',NULL,'N','021','HLT','2208338','52664OH151001301','2014-01-01','2013-12-22 21:55:51','0.00',NULL,NULL,'249.55','249.55','R-OH015','OH0','249.55',NULL,0,'2013-12-26 13:08:11'),(24574,19513,'Y','18','021','EC','A','','','AC','0000178939','0000178939','OH00001618582','IL','1','Saladino','Liberato','','','','34','299025254','6391 WILLOW BROOKE DR',0,'LIBERTY TWP','OH','45011','0401','CY','39017','1952-10-28','M','M',':RET:2036-2','N','021','DEN','3061186','99734OH005000301','2014-04-01','2014-02-18 23:42:27','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:07:53'),(23642,18826,'Y','18','024','14','A','','','TE','0000610032','0000610032','','IL','1','johnson','cedrick',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-01-08','M','',NULL,NULL,NULL,'','3800900','','2014-02-13','2014-02-13 20:54:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-14 21:30:09'),(9611,7612,'Y','18','021','EC','A','','','AC','0000258145','0000258145','OH00001045992','IL','1','Riffle','David','','','','34','282564960','2318 Killian Rd',0,'Akron','OH','44312',NULL,'CY','39153','1954-06-12','M','M',NULL,'N','021','HLT','2525711','52664OH151001301','2014-01-01','2013-12-21 16:35:31','729.00',NULL,NULL,'1185.73','456.73','R-OH012','OH0','580.49',NULL,0,'2013-12-26 04:37:39'),(23638,18822,'Y','18','021','EC','A','','','AC','0000001346','0000001346','TX00001714604','31','1','rangel','jose','','','','34','456873819','po box 1321',0,'bay city','TX','77414',NULL,'CY','48321','1959-08-01','M','U',NULL,'N','021','DEN','3448154','33348TX002000201','2014-03-01','2014-02-13 19:56:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:07'),(20889,16694,'Y','18','021','EC','A','','','AC','0001243006','0001243006','OH00001791626','IL','1','Hoffmaster','Amanda','','','','34','314967009','4309 GREENLEE AVE',0,'CINCINNATI','OH','45217','1844','CY','39061','1987-02-02','F','U',':RET:2106-3','N','021','DEN','3519862','99734OH005000401','2014-03-01','2014-01-31 09:14:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:13'),(9437,7486,'Y','18','021','EC','A','','','AC','0001207152','0001207152','OH00001062893','IL','1','Merusi','Mary','','','','34','269743048','1859 FAIRFAX AVE',0,'CINCINNATI','OH','45207','1811','CY','39061','1962-07-03','F','M',NULL,'N','021','HLT','1587696','92036OH006001201','2014-01-01','2013-12-20 19:34:55','114.00',NULL,NULL,'317.52','203.52','R-OH004','OH0','317.52',NULL,0,'2013-12-26 04:33:34'),(185,154,'Y','18','021','EC','A','','','AC','0001252092','0001252092','OH00000378296','IL','1','gabriel','lisa','','','','34','017462145','2810 cedar hill road',0,'cuyahoga falls','OH','44223',NULL,'CY','39153','1954-01-17','F','U',':RET:2106-3','N','021','HLT','260196','52664OH151001301','2014-01-01','2013-12-05 16:44:17','0.00',NULL,NULL,'580.49','580.49','R-OH012','OH0','580.49',NULL,0,'2013-12-25 17:19:47'),(19790,15777,'Y','18','021','EC','A','','','AC','0000550098','0000550098','OH00002496503','IL','1','Dennis','Patricia','','','','34','281721202','3868 ARLINGTON RD',0,'UNIONTOWN','OH','44685','9604','CY','39153','1964-01-19','F','M',':RET:2106-3','N','021','HLT','2403323','52664OH151001501','2014-03-01','2014-01-23 09:44:19','448.69',NULL,NULL,'745.16','296.47','R-OH012','OH0','477.69',NULL,0,'2014-01-23 21:01:40'),(3370,2700,'Y','18','021','EC','A','','','AC','0001201183','0001201183','TX00000729612','IL','1','Green-Parks','Holly','Nicole','','','34','464856498','6116 GASTON AVE',0,'DALLAS','TX','75214','4326','CY','48113','1979-04-11','F','R',':RET:2106-3','T','021','DEN','2139979','33348TX002000201','2014-01-01','2013-12-22 15:33:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:17:14'),(4072,3254,'Y','18','021','EC','A','','','AC','0000785776','0000785776','OH00000806622','IL','1','Gentile','Nicholas','','','','34','285907388','6096 UPLAND RIDGE DR',0,'MEDINA','OH','44256','6147','CY','39103','1986-08-06','M','U',':RET:2106-3','N','021','DEN','1621868','99734OH005000401','2014-01-01','2013-12-17 18:00:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:46:57'),(4365,3467,'Y','18','021','EC','A','','','AC','0000612975','0000612975','OH00000341732','IL','1','Chen','Cindy Xin Fang','','','','34','562879608','581 FOREST CREEK DR',0,'WOOSTER','OH','44691','4920','CY','39169','1958-10-11','F','U',NULL,'N','021','DEN','913769','99734OH005000401','2014-01-01','2013-12-11 19:22:24','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2013-12-25 22:00:08'),(18205,14530,'Y','18','021','EC','A','','','AC','0000486963','0000486963','OH00002017914','IL','1','renaud','ashley','','','','34','300925944','9278 LIBERTY RD',0,'TWINSBURG','OH','44087','1834','CY','39153','1991-04-12','F','R',':RET:2106-3','N','021','HLT','1523644','52664OH152001001','2014-02-01','2014-01-14 14:15:49','0.00',NULL,NULL,'200.47','200.47','R-OH012','OH0','122.61',NULL,0,'2014-01-15 02:08:08'),(18200,14528,'Y','18','021','EC','A','','','AC','0000964638','0000964638','OH00002538644','IL','1','Shaferly','Sarah','','','','34','297740915','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','1978-08-01','F','M',':RET:2106-3','N','021','HLT','2743747','92036OH002001501','2014-02-01','2014-01-14 12:10:47','417.00',NULL,NULL,'964.29','547.29','R-OH002','OH0','310.57',NULL,0,'2014-01-15 02:08:06'),(18098,14457,'Y','18','021','EC','A','','','AC','0001571181','0001571181','LA00001535422','IL','1','Dennis','Mary','','','','34','434152141','209 NEWMAN ST',0,'MONROE','LA','71202','5813','CY','22073','1960-11-08','F','U',':RET:2054-5','N','021','DEN','1962218','18575LA002000201','2014-02-01','2014-01-14 15:47:03','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:33'),(14646,11689,'Y','18','021','EC','A','','','AC','0000152946','0000152946','TX00000459282','IL','1','Boatright','Debra','','','','34','324587625','5155 S Cnty Rd 73',0,'Robstown','TX','78380',NULL,'CY','48355','1961-05-12','F','U',':RET:2106-3','T','021','DEN','2455829','33348TX002000201','2014-02-01','2013-12-28 08:50:32','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2013-12-29 11:07:35'),(25007,19831,'N','01','021','EC','A',NULL,NULL,'','0001071837','0000670300','','IL','1','ESCRIBANO','CELESTE','','','','34','605996098','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1982-10-13','F','',NULL,'N','021','HLT','3814806','52664OH151001304','2014-04-01','2014-02-20 14:21:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.11',NULL,0,'2014-02-20 22:00:50'),(25099,19908,'Y','18','021','EC','A','','','AC','0000746968','0000746968','TX00001646048','IL','1','ZAVALA','ATILIO','','','','34','643207676','8379 TAMIAMI TRAIL',0,'FORTWORTH','TX','76137',NULL,'CY','48439','1968-04-01','M','M',NULL,'N','021','DEN','2820623','33348TX002000101','2014-04-01','2014-02-21 10:51:37','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15','CIC',0,'2014-02-21 21:30:09'),(9722,7700,'Y','18','021','EC','A','','','AC','0001198073','0001198073','OH00000941712','IL','1','Morris','Nicholas','','','','34','286846246','1277 Oakmont Ave.',0,'Hamilton','OH','45013',NULL,'CY','39017','1981-03-22','M','U',':RET:2054-5','N','021','DEN','626515','99734OH005000401','2014-01-01','2013-11-15 18:22:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:29'),(19924,15888,'Y','18','021','EC','A','','','AC','0000845246','0000845246','MS00001984096','IL','1','Smith','Kimberly','','','','34','428531152','67 COUNTY ROAD 173',0,'OXFORD','MS','38655','5906','CY','28071','1985-11-28','F','U',':RET:2054-5','N','021','DEN','2666805','46300MS002000101','2014-03-01','2014-01-24 16:47:13','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-24 21:01:05'),(17215,13776,'Y','18','021','EC','A','','','AC','0001057134','0001057134','MS00001913420','IL','1','Durr','Tremayne','','','','34','324784745','664 Highway 541 S',0,'Magee','MS','39111',NULL,'CY','28127','1979-06-23','M','U',':RET:2054-5','N','021','DEN','1824232','46300MS002000201','2014-02-01','2014-01-08 08:01:22','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:22:31'),(7694,6092,'N','01','021','EC','A',NULL,NULL,'','0001143311','0000385891','','IL','1','Kou','Fu Tai','','','','34','289826287','10812 WILLFLEET DR',0,'CINCINNATI','OH','45241','2831','CY','39061','1955-10-03','M','',':RET:2034-7','T','021','DEN','1726367','99734OH005000401','2014-01-01','2013-12-19 22:28:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:06'),(2667,2165,'N','01','021','EC','A',NULL,NULL,'','0000352801','0000567999','','IL','1','Scharrer','Debra','','','','34','288508256','7159 TRILLIUM DR',0,'LEWIS CENTER','OH','43035','9670','CY','39041','1952-03-29','F','',':RET:2106-3','N','021','DEN','370130','99734OH005000301','2014-01-01','2013-12-02 17:56:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:57'),(4141,3303,'N','19','021','EC','A',NULL,NULL,'','0000930898','0000108138','','IL','1','NAKKA','JOSHUA','','','','34','294116658','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','2006-02-22','M','',':RET:2029-7','N','021','DEN','1476001','99734OH005000301','2014-01-01','2013-12-17 12:33:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:36'),(25369,20128,'N','01','021','EC','A',NULL,NULL,'','0000431425','0000514501','','IL','1','SANDERS','JOHNATHAN','CRAIG','','','34','279887136','132 LEFT FORK RD',0,'BIDWELL','OH','45614','9267','CY','39053','1981-07-09','M','',':RET:2106-3','N','021','DEN','3142469','99734OH005000301','2014-04-01','2014-02-25 13:48:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:40'),(25809,20466,'N','01','021','EC','A',NULL,NULL,'','0000948478','0000539343','','IL','1','Baglia','Michael','','','','34','271543677','7097 BRIGHTWOOD DR',0,'PAINESVILLE','OH','44077','2170','CY','39085','1954-01-05','M','',':RET:2106-3','N','021','DEN','3742148','99734OH005000301','2014-04-01','2014-02-26 13:14:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:20'),(28975,22932,'Y','18','021','EC','A','','','AC','0002101003','0002101003','LA00002880579','IL','1','DeKeyzer','Natalie','','','','34','438751597','3025 JACKSON ST',0,'ALEXANDRIA','LA','71301','4744','CY','22079','1988-03-18','F','U',':RET:2106-3','T','021','DEN','4316539','18575LA002000201','2014-04-01','2014-03-10 17:27:59','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-03-10 21:01:05'),(453,370,'N','19','021','EC','A',NULL,NULL,'','0000001005','0000029013','','IL','1','smith','breeanna','e','','','34','271029424','2110 PLEASANT HILL RD',0,'MARION','OH','43302','9474','CY','39101','1996-10-05','F','',':RET:2106-3','N','021','DEN','630463','99734OH005000401','2014-01-01','2013-12-04 17:54:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:25'),(20298,16203,'Y','18','021','EC','A','','','AC','0001729345','0001729345','LA00002047858','IL','1','BASS','MICHAEL','D','','','34','438192218','203 IRIS LANE',0,'LAFAYETTE','LA','70506',NULL,'CY','22055','1974-10-23','M','M',':RET:2106-3','N','021','DEN','2696834','18575LA002000201','2014-03-01','2014-01-28 17:52:43','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-28 21:00:41'),(18310,14618,'Y','18','021','EC','A','','','AC','0000194070','0000194070','OH00002038700','IL','1','PERKEY','RONALD','','','','34','293506822','8832 MAPLE ST',0,'LAKEVIEW','OH','43331','9438','CY','39091','1953-10-16','M','U',NULL,'N','021','DEN','1552131','99734OH005000401','2014-02-01','2014-01-15 12:27:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:01'),(4909,3894,'Y','18','021','EC','A','','','AC','0000254502','0000254502','OH00000733838','IL','1','Kroeger','Michael','','','','34','272447918','114 Anderson Ferry Road',0,'Cincinnati','OH','45238',NULL,'CY','39061','1950-04-18','M','U',':RET:2106-3','N','021','DEN','971873','99734OH005000301','2014-01-01','2013-10-26 00:11:03','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:32:02'),(18021,14396,'Y','18','021','EC','A','','','AC','0000739043','0000739043','OH00002273645','IL','1','Henry','Laurie','','','','34','251219081','2824 WERK RD',0,'CINCINNATI','OH','45211','7107','CY','39061','1958-12-03','F','U',':RET:2106-3','N','021','DEN','2665175','99734OH005000301','2014-02-01','2014-01-14 13:00:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:07:05'),(15378,12301,'Y','18','024','14','A','','','TE','0000153379','0000153379','','IL','1','harrison','danette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-02-18','F','',NULL,NULL,NULL,'','2322191','','2014-01-01','2014-01-01 10:29:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:25:20'),(17402,13926,'Y','18','021','EC','A','','','AC','0000972822','0000972822','MS00001946476','IL','1','Holcomb','Jordan','','','','34','587719471','1503 LAURELWOOD CIR',0,'LAUREL','MS','39440','1872','CY','28067','1991-10-04','F','U',':RET:2106-3','N','021','DEN','1436117','46300MS002000101','2014-02-01','2014-01-09 23:32:44','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-13 03:00:17'),(15529,12424,'Y','18','021','EC','A','','','AC','0001477750','0001477750','LA00001800399','31','1','PAYTON','TRACY','M','','','34','436252060','PO BOX 583',0,'GEISMAR','LA','70734',NULL,'CY','22005','1967-12-27','F','U',NULL,'N','021','DEN','1612083','18575LA002000201','2014-02-01','2013-12-31 11:06:04','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:33'),(17229,13788,'Y','18','021','EC','A','','','AC','0000630632','0000630632','MS00001540401','IL','1','jones','robiviere','','','','34','587396099','958 POPLAR DR',0,'LAUREL','MS','39440','4960','CY','28067','1973-02-22','M','U',':RET:2054-5','N','021','DEN','2046098','46300MS002000101','2014-02-01','2014-01-08 11:07:13','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-13 02:22:39'),(21969,17543,'Y','18','021','EC','A','','','AC','0000948458','0000948458','OH00002099813','IL','1','ANDERSON','MAURA','','','','34','284923518','2059 LAKELAND AVE',0,'LAKEWOOD','OH','44107','5713','CY','39035','1990-06-18','F','U',NULL,'N','021','HLT','3249318','52664OH151001305','2014-03-01','2014-02-06 18:32:00','98.00',NULL,NULL,'251.52','153.52','R-OH011','OH0','251.52',NULL,0,'2014-02-07 19:00:30'),(21489,17172,'Y','18','021','EC','A','','','AC','0000103920','0000103920','OH00002272895','IL','1','Lyons','Cynthia','','','','34','281785851','185 Forest Green Dr.',0,'Marblehead','OH','43440',NULL,'CY','39123','1978-08-04','F','R',':RET:2106-3','T','021','HLT','3702652','92036OH002002701','2014-03-01','2014-02-04 14:07:38','0.00',NULL,NULL,'879.43','879.43','R-OH006','OH0','316.44',NULL,0,'2014-02-04 21:01:47'),(28431,22498,'Y','18','021','EC','A','','','AC','0001147410','0001147410','OH00003725002','IL','1','QUINN','DANIEL','','','','34','271606182','10054 INDEPENDENCE BLVD',0,'PARMA HEIGHTS','OH','44130','4645','CY','39035','1961-11-09','M','U',':RET:2106-3','N','021','DEN','3847856','99734OH005000401','2014-04-01','2014-03-07 17:13:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:31:08'),(28760,22764,'Y','18','024','14','A','','','TE','0001050184','0001050184','','IL','1','LARA','SUSIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-02','F','',NULL,NULL,NULL,'','3077691','','2014-03-08','2014-03-09 13:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-09 21:00:22'),(28902,22876,'Y','18','021','EC','A','','','AC','0000627591','0000627591','TX00003641368','IL','1','Castillo','Jose','','','','34','630033802','2524 PRINCETON AVE',0,'SAN ANGELO','TX','76904','5845','CY','48451','1988-12-13','M','R',':RET:2106-3','N','021','DEN','3582172','33348TX002000201','2014-04-01','2014-03-10 16:57:01','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-03-10 21:00:21'),(22191,17711,'Y','18','024','14','A','','','TE','0000247892','0000247892','','IL','1','ERWIN','GERALDINE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-10-19','F','',NULL,NULL,NULL,'','552755','','2014-02-24','2014-02-09 11:06:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-09 19:00:10'),(1832,1502,'Y','18','021','EC','A','','','AC','0001070478','0001070478','OH00000626259','IL','1','Snodgrass','Kathleen','J','','','34','298545163','34754 Lakeshore Blvd',0,'Eastlake','OH','44095',NULL,'CY','39085','1953-11-14','F','U',':RET:2106-3','N','021','HLT','1894233','52664OH151001305','2014-01-01','2013-12-24 10:46:22','440.00',NULL,NULL,'682.62','242.62','R-OH011','OH0','682.62',NULL,0,'2013-12-25 18:57:26'),(1884,1540,'Y','18','021','EC','A','','','AC','0000076305','0000076305','OH00000539428','IL','1','NELSON','SHIRLEY','MARIE','','','34','291421156','28180 OREGON ROAD',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1950-03-18','F','U',':RET:2106-3','N','021','HLT','2609714','92036OH006002601','2014-01-01','2013-12-24 15:50:21','340.00',NULL,NULL,'456.50','116.50','R-OH001','OH0','456.50',NULL,0,'2013-12-25 18:58:37'),(13326,10639,'N','01','021','EC','A',NULL,NULL,'','0000321786','0001080693','','IL','1','Wreyford','Robert','N','','','34','465854691','1204 SAN BERNARD ST',0,'AUSTIN','TX','78702','1129','CY','48453','1975-06-14','M','',':RET:2106-3','N','021','DEN','1967057','33348TX002000201','2014-01-01','2013-12-23 17:07:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:58:29'),(9492,7527,'Y','18','021','EC','A','','','AC','0001244159','0001244159','OH00000677673','IL','1','HOLTKAMP','JOHN','','','Sr','34','274540492','766 HALLE DR',0,'FAYETTEVILLE','OH','45118',NULL,'CY','39015','1952-01-04','M','U',NULL,'N','021','DEN','1530171','99734OH005000401','2014-01-01','2013-12-21 13:35:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:34:56'),(16476,13185,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','2159480','','2014-01-06','2014-01-06 05:19:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:06:07'),(2078,1702,'Y','18','021','EC','A','','','AC','0000460645','0000460645','LA00000192038','IL','1','Devillier','Christopher','','','','34','433436104','1017 HEBERT LN',0,'SAINT MARTINVILLE','LA','70582','6108','CY','22099','1980-10-06','M','M',':RET:2106-3','N','021','DEN','942780','18575LA002000201','2014-01-01','2013-12-09 23:33:03','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:16:33'),(6856,5436,'Y','18','021','EC','A','','','AC','0000050661','0000050661','OH00000864079','IL','1','Brown','Maurus','V','','','34','336587013','138 LOCKNER RD',0,'PORTSMOUTH','OH','45662','8820','CY','39145','1958-09-27','M','U',NULL,'N','021','DEN','525690','99734OH005000401','2014-01-01','2013-10-04 19:37:17','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-26 01:31:32'),(5252,4166,'Y','18','021','EC','A','','','AC','0000780470','0000780470','OH00000946221','IL','1','Treadway','Karen','A','','','34','279500538','762 SANDY LAKE RD',0,'KENT','OH','44240','6753','CY','39133','1949-04-07','F','U',NULL,'T','021','HLT','2556552','52664OH151001306','2014-01-01','2013-12-19 09:55:11','561.00',NULL,NULL,'769.35','208.35','R-OH012','OH0','769.35',NULL,0,'2013-12-25 23:05:09'),(6157,4881,'N','01','021','EC','A',NULL,NULL,'','0000397833','0000546895','','IL','1','butorsky','faina','d','','','34','179602218','330 WILD CEDAR PL',0,'BRANDON','MS','39042','2620','CY','28121','1953-07-27','F','',':RET:2106-3','N','021','DEN','659599','46300MS002000201','2014-01-01','2013-11-21 15:22:14',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 00:16:40'),(5856,4651,'Y','18','021','EC','A','','','AC','0001040852','0001040852','OH00001360429','IL','1','lawson','nathan','','','','34','301726739','3702 VICTORY AVE',0,'TOLEDO','OH','43607','2214','CY','39095','1967-06-25','M','M',':RET:2054-5','T','021','HLT','2603086','92036OH005002601','2014-01-01','2013-12-23 21:07:57','0.00',NULL,NULL,'600.96','600.96','R-OH001','OH0','336.36',NULL,0,'2013-12-25 23:48:56'),(16446,13159,'Y','18','024','14','A','','','TE','0000031738','0000031738','','IL','1','dressner','joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-10-31','M','',NULL,NULL,NULL,'','1561794','','2014-01-05','2014-01-05 21:50:27',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-07 04:05:15'),(13907,11092,'Y','18','021','EC','A','','','AC','0001089552','0001089552','OH00001212135','31','1','Collins','Phillip','','','','34','276688284','P.O. Box 171',0,'Bloomville','OH','44818',NULL,'CY','39147','1975-03-01','M','M',':RET:2106-3','N','021','HLT','2186917','92036OH005002706','2014-01-01','2013-12-22 22:36:59','137.41',NULL,NULL,'242.98','105.57','R-OH006','OH0','242.98',NULL,0,'2013-12-26 13:13:51'),(15200,12148,'Y','18','024','14','A','','','TE','0000286293','0000286293','','IL','1','Pitalo','Sherri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-06','F','',NULL,NULL,NULL,'','1623553','','2013-12-30','2013-12-30 11:07:20',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-01 12:07:23'),(15553,12446,'Y','18','021','EC','A','','','AC','0001848288','0001848288','LA00001175235','IL','1','ROBINSON','LARONDA','','','','34','438752830','609 TUPELO DR',0,'PONCHATOULA','LA','70454','3940','CY','22105','1987-09-10','F','U',':RET:2054-5','N','021','DEN','1387925','18575LA002000201','2014-02-01','2013-12-31 16:32:31','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:31:22'),(25801,20461,'Y','18','021','EC','A','','','AC','0000748238','0000748238','OH00003349687','IL','1','Xu','Don','','','','34','509024297','8841 Montgomery Rd',0,'Cincinnati','OH','45236',NULL,'CY','39061','1966-10-11','M','R',NULL,'N','021','DEN','3243278','99734OH005000301','2014-03-01','2014-02-26 11:34:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:16'),(26148,20732,'Y','18','021','EC','A','','','AC','0000762343','0000762343','OH00002439204','IL','1','upshaw','albert','','','','34','287704919','2972 HIGH FOREST LN',0,'CINCINNATI','OH','45223','1321','CY','39061','1964-05-25','M','U',':RET:2054-5','T','021','DEN','3452207','99734OH005000401','2014-03-01','2014-02-27 13:55:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:28'),(26760,21208,'Y','18','021','EC','A','','','AC','0000106694','0000106694','OH00003314236','IL','1','SUTTON','MARK','KERRY','','','34','268584664','3054 VERA WAY',0,'LIMA','OH','45805','5905','CY','39003','1954-10-27','M','U',':RET:2106-3','T','021','HLT','3373206','92036OH005001504','2014-03-01','2014-02-28 18:22:20','417.00',NULL,NULL,'658.83','241.83','R-OH002','OH0','658.83','CIC',0,'2014-03-01 19:00:08'),(26772,21217,'N','01','021','EC','A',NULL,NULL,'','0000650824','0000577373','','IL','1','Reser','Timothy','C','','','34','286744635','4478 St Rt 121',0,'Greenville','OH','45331',NULL,'CY','39037','1964-03-14','M','',':RET:2106-3','T','021','HLT','2725909','92036OH004000501','2014-04-01','2014-02-28 18:08:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','392.56',NULL,0,'2014-03-01 21:00:08'),(1928,1570,'N','01','021','EC','A',NULL,NULL,'','0001168776','0000972131','','IL','1','Geistweidt','Raynette','','','','34','457063962','169 T ANCHOR RD',0,'FREDERICKSBURG','TX','78624','6562','CY','48171','1957-08-31','F','',':RET:2106-3','N','021','DEN','825918','33348TX002000201','2014-01-01','2013-11-19 18:25:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:00:18'),(24675,19584,'Y','18','021','EC','A','','','AC','0000088602','0000088602','OH00002745113','IL','1','Harper','Walter','','','','34','296646330','54 Ridge St. - Po Box 11',0,'Belmore','OH','45815',NULL,'CY','39137','1959-09-11','M','U',':RET:2106-3','N','021','HLT','3449639','92036OH004001501','2014-04-01','2014-02-19 10:40:43','375.06',NULL,NULL,'377.82','2.76','R-OH002','OH0','377.82',NULL,0,'2014-02-20 04:28:22'),(2024,1658,'Y','18','021','EC','A','','','AC','0000998756','0000998756','OH00001313010','IL','1','Austin','Jay','Michael','','','34','280947981','3560 MARCELLA AVE',0,'STOW','OH','44224','4134','CY','39153','1987-12-16','M','M',':RET:2106-3','N','021','HLT','80449','52664OH152000901','2014-01-01','2013-12-09 21:28:01','100.00',NULL,NULL,'350.04','250.04','R-OH012','OH0','167.26',NULL,0,'2013-12-25 19:15:10'),(9648,7645,'Y','18','021','EC','A','','','AC','0000355039','0000355039','OH00000256005','IL','1','Robinett','Mary','','','','34','287800066','2576 HOLLANSBURG SAMPSON RD',0,'NEW MADISON','OH','45346','8751','CY','39037','1978-10-05','F','U',':RET:2106-3','N','021','HLT','2459527','92036OH004000501','2014-01-01','2013-12-21 09:18:04','229.00',NULL,NULL,'233.56','4.56','R-OH003','OH0','233.56',NULL,0,'2013-12-26 04:38:41'),(21923,17509,'Y','18','021','EC','A','','','AC','0001199332','0001199332','TX00002403800','IL','1','RIVERA','BENITO','','','','34','633568599','19723 MOUNTAIN DALE DR',0,'CYPRESS','TX','77433','1096','CY','48201','1975-12-07','M','M',NULL,'N','021','DEN','2839028','33348TX002000201','2014-03-01','2014-02-06 20:00:59','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-07 19:00:07'),(19679,15683,'Y','18','021','EC','A','','','AC','0001065186','0001065186','TX00002406225','IL','1','Boyd','Logan','','','','34','456950946','3417 Fruitland Farm Court',0,'San Angelo','TX','76903',NULL,'CY','48451','1987-12-29','M','U',':RET:2106-3','N','021','DEN','1370030','33348TX002000201','2014-03-01','2014-01-22 22:07:33','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-23 21:00:37'),(5300,4200,'N','01','021','EC','A',NULL,NULL,'','0000781886','0000752062','','IL','1','Warner','Joe','','','','34','291763442','809 Morse St.',0,'Findlay','OH','45840',NULL,'CY','39063','1974-11-08','M','',':RET:2054-5','N','021','HLT','2435645','92036OH003001505','2014-01-01','2013-12-18 22:03:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.05',NULL,0,'2013-12-25 23:06:16'),(6445,5111,'Y','18','021','EC','A','','','AC','0000293163','0000293163','OH00000439753','IL','1','Farnsworth','Jennifer','','','','34','299865559','1465 MICHIGAN AVE',0,'MAUMEE','OH','43537','2610','CY','39095','1977-11-15','F','M',NULL,'N','021','HLT','818110','92036OH004002601','2014-01-01','2013-12-10 21:34:49','387.87',NULL,NULL,'390.73','2.86','R-OH001','OH0','192.86',NULL,0,'2013-12-26 00:49:33'),(14135,11267,'Y','18','021','EC','A','','','AC','0001776988','0001776988','LA00001059446','IL','1','GRAY','TYLENE','','','','34','434572128','1706 TROY RD',0,'NEW IBERIA','LA','70563',NULL,'CY','22045','1971-10-24','F','M',':RET:2054-5','N','021','DEN','2075258','18575LA002000201','2014-02-01','2013-12-26 11:43:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-27 02:02:30'),(14145,11274,'N','01','021','EC','A',NULL,NULL,'','0002036740','0001881822','','IL','1','Kandous','Melissa','','','','34','438437995','309 SERPAS DR',0,'ARABI','LA','70032','1840','CY','22087','1978-10-12','F','',':RET:2054-5','T','021','DEN','1974517','18575LA002000201','2014-02-01','2013-12-26 12:36:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:02:45'),(16824,13457,'Y','18','021','EC','A','','','AC','0001814428','0001814428','LA00001842600','IL','1','VENEGAS','SILVIA','','','','34','435573332','4936 ZENITH ST',0,'METAIRIE','LA','70001','1060','CY','22051','1960-09-08','F','U',':RET:2106-3','N','021','DEN','1608672','18575LA002000201','2014-02-01','2014-01-11 12:48:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:18:24'),(16627,13302,'Y','18','021','EC','A','','','AC','0001008959','0001008959','OH00001665313','IL','1','DWERTMAN','ANTHONY','','','','34','280706013','4444 SHIRE MILL RD',0,'HILLIARD','OH','43026','2733','CY','39049','1968-11-14','M','M',NULL,'N','021','DEN','2261880','99734OH005000401','2014-02-01','2014-01-07 16:18:29','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:13'),(26757,21205,'Y','18','024','14','A','','','TE','0000963527','0000963527','','IL','1','Marquez','Marynka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-11-06','F','',NULL,NULL,NULL,'','3094453','','2014-03-31','2014-02-28 18:03:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-01 19:00:06'),(28511,22562,'Y','18','024','14','A','','','TE','0000920875','0000920875','','IL','1','JONES','PAMELA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-10-20','F','',NULL,NULL,NULL,'','3501322','','2014-03-07','2014-03-07 14:38:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:54'),(1107,911,'Y','18','021','EC','A','','','AC','0000110494','0000110494','OH00000964441','IL','1','Masarik','Maxwell','','','','34','298020639','12536 CLIFTON BLVD',0,'LAKEWOOD','OH','44107','1526','CY','39035','1998-05-01','M','R',':RET:2106-3','N','021','DEN','217534','99734OH005000401','2014-01-01','2013-12-03 16:20:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2013-12-25 18:17:25'),(28491,22544,'Y','18','021','EC','A','','','AC','0000950985','0000950985','MS00002931351','31','1','Murriel','Lacresia','','','','34','587371922','PO BOX 441',0,'Ridgeland','MS','31158',NULL,'CY','28089','1980-10-08','F','M',NULL,'N','021','DEN','3629257','46300MS002000201','2014-04-01','2014-03-06 20:10:20','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-03-07 21:31:42'),(15950,12769,'N','01','021','EC','A',NULL,NULL,'','0000633746','0001025507','','IL','1','Citro','Claudia','','','','34','270485621','5980 S MAYFLOWER DR',0,'LORAIN','OH','44053','4120','CY','39093','1958-02-20','F','',':RET:2106-3','N','021','DEN','1925493','99734OH005000301','2014-02-01','2014-01-02 18:29:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:05'),(1110,913,'Y','18','021','EC','A','','','AC','0000587954','0000587954','OH00000360418','IL','1','harvey','anne','','','','34','268709174','1627 E TAMARRON CT',0,'SPRINGBORO','OH','45066','9213','CY','39165','1961-01-26','F','R',':RET:2106-3','N','021','DEN','48348','99734OH005000401','2014-01-01','2013-12-03 16:38:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:17:28'),(2939,2364,'N','01','021','EC','A',NULL,NULL,'','0000608417','0001078859','','IL','1','PATEL','DEVYANI','','','','34','298119108','4947 GLEN SPRINGS DR',0,'LIBERTY TWP','OH','45011','2637','CY','39017','1946-11-07','F','',':RET:2029-7','N','021','DEN','1007455','99734OH005000401','2014-01-01','2013-12-06 07:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:16:10'),(14067,11209,'Y','18','021','EC','A','','','AC','0000603369','0000603369','OH00000004712','IL','1','Gifford','Henry','','','','34','297746356','119 N SPERLING AVE',0,'DAYTON','OH','45403','1711','CY','39113','1964-10-13','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','2177084','99734OH005000401','2014-02-01','2013-12-26 08:51:41','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-27 02:00:44'),(1313,1087,'Y','18','021','EC','A','','','AC','0000413319','0000413319','OH00000533432','IL','1','VanVorst','Kimberly','','','','34','273442404','224 LIME ST',0,'WOODVILLE','OH','43469','1010','CY','39143','1952-03-27','F','U',':RET:2106-3','T','021','DEN','1241641','99734OH005000401','2014-01-01','2013-11-04 08:40:53','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 18:31:32'),(13491,10755,'Y','18','021','EC','A','','','AC','0000645986','0000645986','OH00000059203','IL','1','Giovannazzo','Dominic','','','','34','298606764','26311 LAKE RD',0,'BAY VILLAGE','OH','44140','2570','CY','39035','1977-07-26','M','M',':RET:2106-3','N','021','DEN','2373290','99734OH005000301','2014-01-01','2013-12-23 18:14:25','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:02:25'),(2689,2179,'Y','18','021','EC','A','','','AC','0000735893','0000735893','TX00000403875','IL','1','Martinez','Raul','','','','34','525197237','908 FERN LN',0,'VICTORIA','TX','77904','2167','CY','48469','1962-05-22','M','U',NULL,'N','021','DEN','434678','33348TX002000201','2014-01-01','2013-12-02 07:53:50','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-25 19:47:27'),(27018,21401,'Y','18','021','EC','A','','','AC','0000195181','0000195181','OH00002618845','IL','1','MAROUS','TAMMY','','','','34','297664313','1432 GENESEE AVE',0,'MAYFIELD HEIGHTS','OH','44124','1720','CY','39035','1959-12-14','F','U',':RET:2106-3','N','021','DEN','3885617','99734OH005000301','2014-04-01','2014-03-03 10:49:28','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00','CIC',0,'2014-03-03 21:00:11'),(28412,22481,'Y','18','021','EC','A','','','AC','0000120152','0000120152','OH00003422820','IL','1','STAPLETON','TRAVIS','','','','34','271905844','37438 EUCLID AVE',0,'WILLOUGHBY','OH','44094','5644','CY','39085','1984-03-24','M','U',NULL,'N','021','DEN','4198072','99734OH005000401','2014-04-01','2014-03-07 11:20:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:57'),(28999,22950,'N','01','021','EC','A',NULL,NULL,'','0000240423','0000817602','','IL','1','Mckinney','Jonathan',NULL,NULL,NULL,NULL,NULL,'20 Surrey Court',0,'monroeville','OH','44847',NULL,'CY','39077','1992-10-13','M','',NULL,'N','021','HLT','3499043','92036OH004002701','2014-04-01','2014-03-09 19:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','156.79',NULL,0,'2014-03-10 21:01:17'),(24501,19464,'N','19','021','EC','A',NULL,NULL,'','0000598463','0000880244','','IL','1','jones','wilneshia','','','','34','635283742','2110 BRUNDAGE DR',0,'HOUSTON','TX','77090','6400','CY','48201','1991-10-11','F','',':RET:2054-5','N','021','DEN','3419024','33348TX002000201','2014-04-01','2014-02-18 21:30:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 03:49:12'),(24497,19461,'Y','18','024','14','A','','','TE','0000610812','0000610812','','IL','1','Kirby-Rogers','Amber',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-07-26','F','',NULL,NULL,NULL,'','755585','','2014-03-05','2014-02-18 19:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-20 03:47:26'),(20752,16582,'Y','18','021','EC','A','','','AC','0000381179','0000381179','OH00001756574','IL','1','Ahrmann','Ericka','','','','34','270868642','364 Hawthrone Drive',0,'Wilmington','OH','45177',NULL,'CY','39027','1980-01-15','F','M',':RET:2106-3','N','021','HLT','2977304','92036OH002000601','2014-03-01','2014-01-30 11:12:17','165.00',NULL,NULL,'601.92','436.92','R-OH005','OH0','300.96',NULL,0,'2014-01-30 21:01:31'),(13461,10735,'Y','18','021','EC','A','','','AC','0000706193','0000706193','OH00001111352','IL','1','Moon','Danielle','','','','34','282905340','17935 Whitney rd',0,'Strongsville','OH','44136',NULL,'CY','39035','1989-02-10','F','M',':RET:2106-3','N','021','DEN','1721991','99734OH005000301','2014-01-01','2013-12-23 15:16:47','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:45'),(25842,20486,'Y','18','021','EC','A','','','AC','0001153666','0001153666','OH00003260229','31','1','Baker','Mark','T','','','34','297443998','P.O. Box 95357',0,'Canton','OH','44735',NULL,'CY','39151','1950-07-10','M','M',':RET:2106-3','T','021','HLT','2949207','52664OH152000901','2014-03-01','2014-02-26 07:06:01','790.00',NULL,NULL,'1109.02','319.02','R-OH015','OH0','554.51',NULL,0,'2014-02-26 21:00:36'),(7657,6064,'Y','18','021','EC','A','','','AC','0001632261','0001632261','LA00000044496','IL','1','VO','TUAN','','','','34','433857995','12367 DUTCHTOWN VILLA DR',0,'GEISMAR','LA','70734','3160','CY','22005','1976-05-23','M','M',NULL,'N','021','DEN','2414862','18575LA002000101','2014-01-01','2013-12-20 09:20:58','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:10'),(19664,15669,'Y','18','021','EC','A','','','AC','0000207159','0000207159','OH00002070773','IL','1','Blankenship','Lea','Ann','','','34','604016302','577 E. Reagan Parkway',0,'Medina','OH','44256',NULL,'CY','39103','1984-04-28','F','R',':RET:2106-3','N','021','HLT','2861662','52664OH152001001','2014-03-01','2014-01-22 18:42:40','0.00',NULL,NULL,'137.20','137.20','R-OH012','OH0','137.20',NULL,0,'2014-01-23 21:00:26'),(18610,14835,'Y','18','021','EC','A','','','AC','0000790893','0000790893','OH00001715369','IL','1','Luce','Sandra','','','','34','268549842','11241 BEACHPARK DR',0,'CURTICE','OH','43412','9443','CY','39095','1953-11-17','F','M',':RET:2106-3','N','021','HLT','1655767','92036OH002002601','2014-02-01','2014-01-15 12:35:39','0.00',NULL,NULL,'611.15','611.15','R-OH001','OH0','611.15',NULL,0,'2014-01-16 08:47:22'),(15664,12533,'Y','18','021','EC','A','','','AC','0000211977','0000211977','TX00001924204','IL','1','Vann','Janet','','','','34','515606828','2308 Stonegate Circle',0,'Denton','TX','76205',NULL,'CY','48121','1955-02-07','F','U',':RET:2106-3','N','021','DEN','2422273','33348TX002000101','2014-02-01','2013-12-31 16:56:05','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2014-01-02 04:34:33'),(2736,2214,'Y','18','021','EC','A','','','AC','0000290240','0000290240','LA00001287709','IL','1','MAYSHACK','JOHN','','','','34','435901412','5216 TIMOTHY TRL',0,'BOSSIER CITY','LA','71111','6223','CY','22015','1953-05-03','M','U',':RET:2054-5','N','021','DEN','1042142','18575LA002000201','2014-01-01','2013-12-02 16:04:48','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 19:48:38'),(29092,23026,'N','01','021','EC','A',NULL,NULL,'','0000524372','0000047298','','IL','1','Nguyen','Destinie','','','','34','457635688','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1970-09-30','F','',NULL,'N','021','DEN','4251530','33348TX002000101','2014-04-01','2014-03-10 14:52:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-10 21:02:10'),(21184,16929,'Y','18','021','EC','A','','','AC','0000284891','0000284891','MS00001629748','IL','1','LOFTON','SHENIKA','','','','34','426650923','1433 PLUM ST',0,'JACKSON','MS','39209','4638','CY','28049','1980-12-11','F','U',NULL,'N','021','DEN','2275904','46300MS002000101','2014-03-01','2014-02-03 00:14:35','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-03 21:00:45'),(20273,16178,'Y','18','021','EC','A','','','AC','0000194084','0000194084','OH00001385233','IL','1','SUPER','DONNA','','','','34','271589710','931 WRIGHT AVE',0,'XENIA','OH','45385','5365','CY','39057','1955-11-12','F','U',':RET:2106-3','N','021','DEN','3032660','99734OH005000401','2014-03-01','2014-01-27 19:56:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-28 21:00:25'),(4149,3307,'Y','18','021','EC','A','','','AC','0000706180','0000706180','OH00000085246','IL','1','Smith','Michael','','','','34','290546413','8883 HARAD CT',0,'MACEDONIA','OH','44056','2424','CY','39153','1965-12-28','M','M',':RET:2106-3','N','021','DEN','1966643','99734OH005000301','2014-01-01','2013-12-17 13:21:20','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:48:43'),(6696,5308,'Y','18','021','EC','A','','','AC','0000979272','0000979272','OH00000439407','IL','1','Williams','Christina','','','','34','278887703','35 Lori Lane',0,'Amelia','OH','45102',NULL,'CY','39025','1982-05-09','F','U',':RET:2106-3','N','021','HLT','1123719','92036OH004000601','2014-01-01','2013-11-04 20:06:37','166.00',NULL,NULL,'200.06','34.06','R-OH005','OH0','200.06',NULL,0,'2013-12-26 01:01:44'),(7653,6060,'Y','18','021','EC','A','','','AC','0001654669','0001654669','LA00000745128','IL','1','Johnson','Carl','Henry','','Jr','34','438376264','20213 SKINNER DR',0,'HAMMOND','LA','70401','4024','CY','22105','1978-11-16','M','U',':RET:2054-5','N','021','DEN','1715084','18575LA002000101','2014-01-01','2013-12-19 18:47:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:03'),(14461,11538,'Y','18','021','EC','A','','','AC','0000258164','0000258164','OH00000640929','IL','1','Nickelsen','Judith','','','','34','268523480','1428 BRIARHILL DR',0,'AKRON','OH','44333','1126','CY','39153','1950-06-17','F','R',':RET:2106-3','N','021','HLT','1797276','52664OH151001501','2014-02-01','2013-12-26 18:37:43','0.00',NULL,NULL,'789.56','789.56','R-OH012','OH0','789.56',NULL,0,'2013-12-28 03:32:47'),(19599,15623,'N','19','021','EC','A',NULL,NULL,'','0000422844','0000987431','','IL','1','Lynch','Anna','','','','34','273989301','95 OLSON SPUR',0,'MUNROE FALLS','OH','44262','1025','CY','39153','1995-02-04','F','',':RET:2106-3','N','021','HLT','2632361','52664OH151001501','2014-03-01','2014-01-22 17:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-01-23 03:02:47'),(15622,12495,'Y','18','021','EC','A','','','AC','0000939552','0000939552','MS00001529703','IL','1','Skinner','Dafina','','','','34','428591441','104 WOODBURN WAY',0,'PEARL','MS','39208','8636','CY','28121','1980-01-23','F','U',':RET:2054-5','N','021','DEN','2426758','46300MS002000101','2014-02-01','2013-12-31 16:12:54','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:33:12'),(23853,18978,'N','01','021','EC','A',NULL,NULL,'','0000137621','0000084097','','IL','1','POTTKOTTER','ALAN','','','','34','268568479','282 SIEGRIST JUTTE RD',0,'FORT RECOVERY','OH','45846','9573','CY','39107','1960-11-30','M','',NULL,'N','021','HLT','3021951','92036OH005001501','2014-03-01','2014-02-14 16:35:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.97',NULL,0,'2014-02-14 21:31:59'),(18966,15112,'Y','18','021','EC','A','','','AC','0000807303','0000807303','TX00001510465','31','1','VILLARREAL','BETHANY','','','','34','463570396','P.O. BOX 13 QUTRO',0,'CUERO','TX','77954',NULL,'CY','48123','1982-06-18','F','U',':RET:2106-3','T','021','DEN','2607669','33348TX002000201','2014-03-01','2014-01-17 15:17:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-20 08:05:59'),(18468,14734,'Y','18','021','EC','A','','','AC','0001570026','0001570026','LA00001380625','IL','1','Newlands','Michael','','','','34','434451695','3111 JOLIET ST',0,'NEW ORLEANS','LA','70118','4443','CY','22071','1981-10-03','M','U',NULL,'N','021','DEN','2274391','18575LA002000101','2014-02-01','2014-01-15 17:41:33','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-16 08:46:16'),(27390,21686,'Y','18','021','EC','A','','','AC','0001042351','0001042351','OH00003042403','IL','1','MacNeel','Carolyn','','','','34','273602277','6424 ASHLEY OAKS CT',0,'WEST CHESTER','OH','45069','5107','CY','39017','1969-07-21','F','R',':RET:2106-3','N','021','DEN','3740872','99734OH005000301','2014-04-01','2014-03-03 18:44:34','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-03-04 21:01:27'),(27753,21947,'Y','18','021','EC','A','','','AC','0001596732','0001596732','LA00003144395','IL','1','eames','wardell','','','','34','435298604','6771 bradley st',0,'baton rouge','LA','70805',NULL,'CY','22033','1973-12-20','M','M',':RET:2054-5','N','021','DEN','3908519','18575LA002000201','2014-04-01','2014-03-05 09:28:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:16'),(934,772,'N','01','021','EC','A',NULL,NULL,'','0000848302','0000847117','','IL','1','Harr','Marilyn','Kay','','','34','266136362','8 FLEETWOOD AVE',0,'JACKSON','OH','45640','1807','CY','39079','1954-05-04','F','',':RET:2106-3','N','021','DEN','457607','99734OH005000401','2014-01-01','2013-10-29 12:26:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:09'),(1168,963,'N','01','021','EC','A',NULL,NULL,'','0000050834','0000981858','','IL','1','Taylor','Al','','','Jr','34','435419247','12223 villa park drive',0,'Geismar','LA','70734',NULL,'CY','22005','1965-05-19','M','',':RET:2054-5','N','021','DEN','718551','18575LA002000201','2014-01-01','2013-12-03 17:31:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:19:05'),(19041,15164,'Y','18','021','EC','A','','','AC','0000971491','0000971491','OH00001576892','IL','1','Deering','Robert','','','','34','378545997','2874 Harrison Ave.',0,'Cincinnati','OH','45211',NULL,'CY','39061','1949-05-20','M','M',':RET:2106-3','T','021','HLT','2938700','92036OH006001201','2014-03-01','2014-01-17 13:48:27','0.00',NULL,NULL,'587.34','587.34','R-OH004','OH0','587.34',NULL,0,'2014-01-20 08:06:37'),(17767,14195,'Y','18','021','EC','A','','','AC','0000999118','0000999118','TX00001641465','IL','1','AJANI','ZAIB','','','','34','644169284','12431 S DAIRY ASHFORD RD',0,'HOUSTON','TX','77099','3934','CY','48201','1974-10-29','F','U',':RET:2028-9','N','021','DEN','1917674','33348TX002000101','2014-02-01','2014-01-13 12:01:15','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:36'),(17211,13773,'Y','18','021','EC','A','','','AC','0000443471','0000443471','OH00002385577','IL','1','GRAVES','TANYA','','','','34','268523083','1206 HARPSTER AVE',0,'AKRON','OH','44314','2246','CY','39153','1951-12-02','F','M',NULL,'N','021','HLT','2062442','52664OH151001304','2014-02-01','2014-01-08 14:52:24','921.00',NULL,NULL,'1281.40','360.40','R-OH012','OH0','640.70',NULL,0,'2014-01-13 02:22:29'),(16679,13348,'N','19','021','EC','A',NULL,NULL,'','0000012450','0000442196','','IL','1','KNUTSON','QUINN','','','','34','443519300','6982 FRANCIS DR',0,'LIBERTY TOWNSHIP','OH','45044','9254','CY','39017','2013-02-02','M','',':RET:2106-3','N','021','DEN','1575019','99734OH005000301','2014-02-01','2014-01-07 15:25:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(7710,6104,'Y','18','021','EC','A','','','AC','0000676703','0000676703','OH00000174782','IL','1','Engel','Jeffrey','','','','34','297461042','5137 CHICKADEE LN',0,'LYNDHURST','OH','44124','2728','CY','39035','1951-02-25','M','U',':RET:2106-3','N','021','DEN','1411341','99734OH005000401','2014-01-01','2013-12-20 09:55:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:28'),(4460,3544,'N','19','021','EC','A',NULL,NULL,'','0000575896','0000040927','','IL','1','Warren','Edward','G','','Jr','34','302024137','1410 Springfield Pike',0,'Wyoming','OH','45215',NULL,'CY','39061','1998-08-10','M','',':RET:2054-5','N','021','DEN','986308','99734OH005000301','2014-01-01','2013-12-12 12:01:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:37'),(15794,12642,'Y','18','021','EC','A','','','AC','0002365413','0002365413','LA00000321195','IL','1','roach','carol','','','','34','435888248','724 melody dr.',0,'metairie','LA','70002',NULL,'CY','22051','1952-09-17','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','2524733','18575LA002000201','2014-02-01','2014-01-02 16:26:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:37'),(5075,4021,'N','01','021','EC','A',NULL,NULL,'','0000780305','0000380396','','IL','1','bahadori','fariba','','','','34','633803493','13115 Marble Falls Cove',0,'Austin','TX','78729',NULL,'CY','48453','1964-07-17','F','',':RET:2106-3','N','021','DEN','2324111','33348TX002000201','2014-01-01','2013-12-19 13:03:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:00:49'),(15217,12163,'Y','18','021','EC','A','','','AC','0000744443','0000744443','OH00001864741','IL','1','alvarado','andrea','danielle','','','34','289887159','613  N. Main St',0,'urbana','OH','43078',NULL,'CY','39021','1982-01-16','F','M',':RET:2106-3','T','021','HLT','2189626','92036OH005000506','2014-02-01','2013-12-30 17:44:04','237.00',NULL,NULL,'316.83','79.83','R-OH003','OH0','316.83',NULL,0,'2014-01-01 12:07:53'),(26153,20736,'Y','18','024','14','A','','','TE','0000486941','0000486941','','IL','1','McNulty','George',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-06-12','M','',NULL,NULL,NULL,'','1547384','','2014-03-14','2014-02-27 15:03:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 06:30:29'),(832,688,'N','01','021','EC','A',NULL,NULL,'','0000146867','0000120062','','IL','1','Swanson','Patricia','','','','34','192407126','2540 46TH ST NE',0,'CANTON','OH','44705','2902','CY','39151','1951-02-18','F','',':RET:2106-3','N','021','HLT','2073345','52664OH151001301','2014-01-01','2013-12-16 17:41:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-25 18:06:23'),(7669,6075,'Y','18','021','EC','A','','','AC','0002295930','0002295930','LA00000343256','IL','1','Shaffer','Donald','Otto','','Jr','34','433046260','16313 SHETLAND AVE',0,'GREENWELL SPRINGS','LA','70739','5926','CY','22033','1956-12-18','M','M',':RET:2106-3','N','021','DEN','1478703','18575LA002000101','2014-01-01','2013-12-20 18:10:54','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:31'),(24797,19667,'Y','18','021','EC','A','','','AC','0000639575','0000639575','OH00002581785','IL','1','Parks','Carlye','','','','34','268961058','517 HEATHERBROOKE WAY',0,'WESTERVILLE','OH','43081','5661','CY','39049','1989-10-19','F','U',':RET:2106-3','N','021','DEN','3244212','99734OH005000401','2014-04-01','2014-02-19 13:17:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:47:37'),(24453,19425,'Y','18','021','EC','A','','','AC','0000178556','0000178556','MS00002045635','31','1','Barefield','Michael','','','','34','587461760','null null',0,'HATTIESBURG','MS','39404','6826','CY','28035','1962-12-26','M','U',':RET:2106-3','T','021','DEN','3246785','46300MS002000201','2014-04-01','2014-02-18 15:00:47','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-18 22:01:27'),(22690,18117,'N','01','021','EC','A',NULL,NULL,'','0000126951','0001028282','','IL','1','Hicks','Yvette','Martinez','','','34','450977305','9356 MECHLER LN',0,'LA COSTE','TX','78039','9417','CY','48029','1972-11-09','F','',NULL,'N','021','DEN','2654099','33348TX002000101','2014-03-01','2014-02-11 18:17:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-11 21:00:52'),(21176,16924,'Y','18','021','EC','A','','','AC','0000932135','0000932135','OH00002359751','IL','1','MCGEE','KATHLEEN','','','','34','278523842','1965 N GARDEN CT',0,'AKRON','OH','44312','1946','CY','39153','1953-08-28','F','U',':RET:2106-3','T','021','DEN','3340564','99734OH005000401','2014-03-01','2014-02-03 16:40:52','0.00',NULL,NULL,'50.05','50.05','R-OH012','OH0','0.00',NULL,0,'2014-02-03 21:00:40'),(6751,5357,'Y','18','021','EC','A','','','AC','0001252087','0001252087','OH00000604462','IL','1','Lambertson','Michael','','','','34','272906243','327 Miami street',0,'Seven Mile','OH','45062',NULL,'CY','39017','1983-10-05','M','U',':RET:2106-3','N','021','HLT','453118','92036OH004001201','2014-01-01','2013-11-25 13:14:49','0.00',NULL,NULL,'195.92','195.92','R-OH004','OH0','195.92',NULL,0,'2013-12-26 01:16:06'),(2019,1656,'N','01','021','EC','A',NULL,NULL,'','0001126841','0000088532','','IL','1','Chiofolo','Anthony','B','','','34','268441521','2785 BYRON DR',0,'NORTH CANTON','OH','44720','1201','CY','39153','1950-07-08','M','',':RET:2106-3','T','021','HLT','970695','52664OH152000901','2014-01-01','2013-12-09 19:38:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','554.51',NULL,0,'2013-12-25 19:15:06'),(15679,12541,'Y','18','021','EC','A','','','AC','0000273793','0000273793','OH00001970920','IL','1','Yancey','Connie','Jean','','','34','274724485','21 S HOWARD ST',0,'SABINA','OH','45169','1314','CY','39027','1973-03-19','F','U',':RET:2106-3','T','021','HLT','1886244','92036OH005000606','2014-02-01','2013-12-31 13:43:21','230.00',NULL,NULL,'315.50','85.50','R-OH005','OH0','315.50',NULL,1,'2014-01-02 04:34:54'),(4502,3569,'Y','18','021','EC','A','','','AC','0000415450','0000415450','TX00000021049','IL','1','anderson','amy','','','','34','440847801','7150 OLD VALDASTA RD',0,'BLUE RIDGE','TX','75424','3767','CY','48085','1976-02-05','F','M',':RET:2106-3','N','021','DEN','966030','33348TX002000201','2014-01-01','2013-12-11 22:21:42','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:25'),(15544,12438,'Y','18','021','EC','A','','','AC','0001479778','0001479778','LA00001779129','IL','1','BOURGEOIS','LISA','M','','','34','439411161','1803 COLE DR',0,'FRANKLIN','LA','70538','5508','CY','22101','1965-10-01','F','U',':RET:2106-3','N','021','DEN','1986416','18575LA002000201','2014-02-01','2013-12-31 15:42:26','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:31:03'),(13223,10549,'Y','18','024','14','A','','','TE','0000006115','0000006115','','IL','1','HERNANDEZ','OLGA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-12','F','',NULL,NULL,NULL,'','666278','','2013-12-22','2013-12-22 19:47:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:55:32'),(7232,5733,'Y','18','021','EC','A','','','AC','0001046823','0001046823','OH00000908452','31','1','Weaver','Gary','D','','Sr','34','460984313','PO BOX 1',0,'Franklin Furnace','OH','45629',NULL,'CY','39145','1954-01-07','M','M',':RET:2106-3','N','021','DEN','72074','99734OH005000401','2014-01-01','2013-12-14 16:38:20','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-26 02:01:24'),(23549,18760,'N','01','021','EC','A',NULL,NULL,'','0001804553','0002361868','','IL','1','GUZMAN','GUSTAVO','','','','34','663038941','2155 PARK DR',0,'SLIDELL','LA','70458',NULL,'CY','22103','1975-01-12','M','',NULL,'N','021','DEN','3337045','18575LA002000201','2014-03-01','2014-02-13 15:42:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-13 22:02:37'),(26455,20982,'Y','18','024','14','A','','','TE','0000105658','0000105658','','IL','1','Thompson','Jesse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-01','M','',NULL,NULL,NULL,'','2750538','','2014-02-27','2014-02-27 11:06:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCELCIC',0,'2014-02-28 07:30:27'),(3758,3007,'Y','18','021','EC','A','','','AC','0000281989','0000281989','OH00001170892','IL','1','Boenker','Diane','','','','34','324580258','3635 Ira Road',0,'Akron','OH','44333',NULL,'CY','39153','1959-10-17','F','U',NULL,'N','021','HLT','428322','52664OH151001306','2014-01-01','2013-12-13 09:11:02','396.00',NULL,NULL,'476.12','80.12','R-OH012','OH0','476.12',NULL,0,'2013-12-25 21:33:21'),(20666,16514,'Y','18','021','EC','A','','','AC','0000369504','0000369504','MS00001769673','IL','1','banks','Trenton','Rashard','','','34','427473282','5880 Ridgewood Rd',0,'Jackson','MS','39211',NULL,'CY','28049','1983-07-13','M','U',':RET:2054-5','N','021','DEN','3199860','46300MS002000201','2014-03-01','2014-01-29 18:44:41','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-30 21:00:46'),(19359,15430,'N','01','021','EC','A',NULL,NULL,'','0000212191','0000071665','','IL','1','Bergdorf','Diane','MARIE','','','34','273587069','5868 GROVE RD',0,'CLINTON','OH','44216','9719','CY','39153','1955-10-26','F','',':RET:2106-3','N','021','HLT','2648361','52664OH151001305','2014-03-01','2014-01-20 19:33:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,1,'2014-01-22 03:22:30'),(7135,5662,'Y','18','021','EC','A','','','AC','0000265618','0000265618','MS00001677207','IL','1','SANDERS','NEYSHA','','','','34','428515989','401 RIVER RD',0,'GREENWOOD','MS','38930','4212','CY','28083','1970-02-04','F','U',':RET:2054-5','T','021','DEN','1382148','46300MS002000101','2014-02-01','2013-12-25 00:34:50','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 01:51:44'),(13671,10908,'Y','18','021','EC','A','','','AC','0001423564','0001423564','LA00000865083','IL','1','McConnell','Kathy','Marie','','','34','462697819','1123 CONGRESS ST',0,'NEW ORLEANS','LA','70117','6105','CY','22071','1969-11-16','F','U',':RET:2106-3','N','021','DEN','1519546','18575LA002000101','2014-01-01','2013-12-23 17:22:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:54'),(21490,17172,'N','19','021','EC','A',NULL,NULL,'','0000103920','0000821050','','IL','1','Lyons','Paige','','','','34','272156199','185 Forest Green Dr.',0,'Marblehead','OH','43440',NULL,'CY','39123','2008-12-05','F','',':RET:2106-3','N','021','HLT','3702652','92036OH002002701','2014-03-01','2014-02-04 14:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-02-04 21:01:47'),(25390,20145,'Y','18','021','EC','A','','','AC','0000493295','0000493295','OH00002105964','IL','1','KRANES','DENNIS','','','','34','293509483','35888 CHESTNUT RIDGE RD',0,'NORTH RIDGEVILLE','OH','44039','3928','CY','39093','1951-07-07','M','M',NULL,'N','021','HLT','2960853','52664OH151001301','2014-04-01','2014-02-25 10:31:14','637.00',NULL,NULL,'1427.51','790.51','R-OH011','OH0','722.61',NULL,0,'2014-02-25 21:30:51'),(25781,20446,'Y','18','021','EC','A','','','AC','0001216298','0001216298','OH00002479856','IL','1','Scardino','John','','','','34','295706380','351 VINEYARD DR',0,'BROADVIEW HEIGHTS','OH','44147','3379','CY','39035','1975-08-03','M','U',':RET:2106-3','N','021','HLT','3051443','92036OH006000801','2014-04-01','2014-02-24 14:17:03','157.00',NULL,NULL,'231.04','74.04','R-OH011','OH0','231.04',NULL,0,'2014-02-26 09:31:02'),(21504,17179,'N','01','021','EC','A',NULL,NULL,'','0001204573','0000192766','','IL','1','Bissinger','Joanne','','','','34','275503883','3630 HIGHLAND GRN',0,'CINCINNATI','OH','45245','1755','CY','39025','1957-06-27','F','',':RET:2106-3','N','021','HLT','2857520','92036OH005000605','2014-03-01','2014-02-04 17:16:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','500.82',NULL,0,'2014-02-04 21:01:54'),(22658,18093,'Y','18','021','EC','A','','','AC','0000296191','0000296191','TX00002428356','IL','1','Gaitan','Dora','','','','34','640014359','1602 N HAYES ST',0,'AMARILLO','TX','79107','6520','CY','48375','1966-12-27','F','M',NULL,'N','021','DEN','3289214','33348TX002000201','2014-03-01','2014-02-11 13:05:40','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-11 21:00:33'),(24506,19467,'Y','18','021','EC','A','','','AC','0000758431','0000758431','TX00002592362','IL','1','Strong','Toby','','','','34','494926459','3225 Turtle Creek Blvd',0,'Dallas','TX','75219',NULL,'CY','48113','1981-01-12','M','R',':RET:2106-3','N','021','DEN','2771417','33348TX002000201','2014-04-01','2014-02-18 23:06:51','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:51:08'),(28942,22903,'Y','18','021','EC','A','','','AC','0002236651','0002236651','LA00003805401','IL','1','HORTON','KYLE','','','','34','436759470','706 GLADWAY RD',0,'QUITMAN','LA','71268','1235','CY','22049','1987-10-02','M','U',NULL,'N','021','DEN','3610211','18575LA002000201','2014-04-01','2014-03-09 18:39:08','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-10 21:00:43'),(17932,14326,'Y','18','021','EC','A','','','AC','0000920245','0000920245','TX00001612099','IL','1','AYALA','ROSARIO','R','','','34','639544555','328 IBERIS DR',0,'ARLINGTON','TX','76018','1407','CY','48439','1960-04-11','F','U',NULL,'N','021','DEN','2139261','33348TX002000201','2014-02-01','2014-01-14 13:15:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:35'),(17527,14013,'Y','18','021','EC','A','','','AC','0000128116','0000128116','OH00002494918','IL','1','weston','barbara','','','','34','294628793','7564 ROB ST NW',0,'MASSILLON','OH','44646','1069','CY','39151','1955-12-22','F','M',':RET:2106-3','N','021','DEN','1512258','99734OH005000401','2014-02-01','2014-01-12 14:16:34','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-13 03:01:40'),(6429,5098,'Y','18','021','EC','A','','','AC','0000042935','0000042935','LA00000899626','IL','1','SINS','JOHN','R','','','34','557314898','2600 N SIBLEY ST',0,'METAIRIE','LA','70003','5352','CY','22051','1959-09-18','M','U',':RET:2054-5','N','021','DEN','355642','18575LA002000201','2014-01-01','2013-12-11 12:38:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:49:07'),(2353,1918,'Y','18','021','EC','A','','','AC','0000415441','0000415441','TX00000796323','IL','1','olvera','maria','','','','34','290508889','1005 S DAKOTA ST',0,'HARLINGEN','TX','78552','7626','CY','48061','1954-06-15','F','M',NULL,'N','021','DEN','195234','33348TX002000201','2014-01-01','2013-12-09 17:20:10','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 19:32:18'),(1543,1286,'Y','18','021','EC','A','','','AC','0001102095','0001102095','OH00000355189','IL','1','Shepard','Sandra','','','','34','287562555','921 WELSTED ST',0,'NAPOLEON','OH','43545','1334','CY','39069','1954-10-03','F','U',NULL,'N','021','DEN','1620015','99734OH005000401','2014-01-01','2013-12-24 17:45:41','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:50:22'),(20931,16728,'Y','18','021','EC','A','','','AC','0000340329','0000340329','OH00001751524','IL','1','Lester','Kimberly','','','','34','290705998','420 BEECH AVE',0,'FAIRFIELD','OH','45014','1612','CY','39017','1969-11-27','F','U',':RET:2106-3','N','021','HLT','2761024','92036OH003001205','2014-03-01','2014-01-31 12:02:08','143.00',NULL,NULL,'313.18','170.18','R-OH004','OH0','313.18',NULL,0,'2014-01-31 21:01:37'),(26200,20778,'Y','18','021','EC','A','','','AC','0001192728','0001192728','OH00002738166','IL','1','MORRIS','JOHN','M','','','34','288588213','3100 SHADYSIDE AVE',0,'ASHTABULA','OH','44004','9254','CY','39007','1968-08-24','M','U',NULL,'N','021','HLT','2830839','52664OH151001304','2014-04-01','2014-02-26 19:29:36','229.00',NULL,NULL,'363.19','134.19','R-OH011','OH0','363.19',NULL,0,'2014-02-28 06:30:48'),(29017,22966,'Y','18','021','EC','A','','','AC','0000257197','0000257197','OH00003483348','IL','1','Kehr','Jillian','','','','34','007904190','132 Ringgold',0,'Dayton','OH','45403',NULL,'CY','39113','1988-01-07','F','U',':RET:2106-3','N','021','DEN','3868991','99734OH005000401','2014-04-01','2014-03-10 07:28:16','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:01:27'),(3028,2436,'Y','18','021','EC','A','','','AC','0000257109','0000257109','OH00000796232','IL','1','Patel','Dinesh','','','','34','342686246','8224 STATE ROUTE 108',0,'WAUSEON','OH','43567','9663','CY','39051','1956-01-18','M','M',':RET:2029-7','N','021','HLT','123165','92036OH004002601','2014-01-01','2013-12-05 21:15:07','545.00',NULL,NULL,'701.97','156.97','R-OH001','OH0','382.11',NULL,0,'2013-12-25 20:18:22'),(20135,16068,'Y','18','021','EC','A','','','AC','0001093169','0001093169','OH00001924772','IL','1','Jackson','Kessandra','','','','34','233863247','34700 Park East Drive',0,'Solon','OH','44139',NULL,'CY','39035','1965-10-21','F','U',':RET:2054-5','N','021','DEN','2514997','99734OH005000401','2014-03-01','2014-01-27 13:25:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:00:54'),(17735,14171,'Y','18','021','EC','A','','','AC','0000007000','0000007000','OH00002087901','IL','1','Shoffner','Susanne','','','','34','362682145','2110 10TH ST',0,'CUYAHOGA FALLS','OH','44221','3131','CY','39153','1952-08-01','F','U',NULL,'N','021','HLT','1669210','52664OH151001304','2014-02-01','2014-01-13 12:08:41','428.00',NULL,NULL,'626.65','198.65','R-OH012','OH0','626.65',NULL,0,'2014-01-14 01:33:21'),(13151,10491,'Y','18','021','EC','A','','','AC','0000903232','0000903232','OH00001111370','IL','1','Snipes','Coreta','','','','34','291785801','1622 W 19TH St',0,'Lorain','OH','44052',NULL,'CY','39093','1981-06-22','F','U',NULL,'N','021','DEN','2572060','99734OH005000401','2014-01-01','2013-12-23 17:02:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:36'),(25436,20182,'Y','18','024','14','A','','','TE','0000723115','0000723115','','IL','1','LIN','YU PAO',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-01-09','F','',NULL,NULL,NULL,'','3125017','','2014-02-25','2014-02-25 00:53:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-25 21:31:17'),(22623,18065,'Y','18','021','EC','A','','','AC','0000460754','0000460754','TX00002195351','IL','1','chau','van','','','','34','604675205','4101 s custer rd',0,'mckinney','TX','75070',NULL,'CY','48085','1988-09-11','F','U',':RET:2047-9','N','021','DEN','3722545','33348TX002000201','2014-03-01','2014-02-10 20:37:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:12'),(24637,19554,'Y','18','021','EC','A','','','AC','0001862429','0001862429','LA00001648696','IL','1','SIMIEN','LAVONDA','CHARLES','','','34','369789588','217 W VINE ST',0,'OPELOUSAS','LA','70570','5155','CY','22097','1973-05-24','F','U',':RET:2054-5','N','021','DEN','3051340','18575LA002000201','2014-04-01','2014-02-19 11:21:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 04:19:17'),(19100,15217,'Y','18','021','EC','A','','','AC','0001895578','0001895578','LA00002158352','IL','1','FRUGA','DEMETRIOS','','','','34','437833672','1120 WASHINGTON ST',0,'NATCHITOCHES','LA','71457',NULL,'CY','22069','1992-01-15','F','U',':RET:2054-5','N','021','DEN','2826373','18575LA002000201','2014-03-01','2014-01-18 11:25:50','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-21 08:44:37'),(390,321,'N','19','021','EC','A',NULL,NULL,'','0000827126','0001253513','','IL','1','McRae','Donald','','','','34','294887989','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1988-05-08','M','',':RET:2054-5','N','021','HLT','326885','92036OH004003201','2014-01-01','2013-12-03 18:55:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.41',NULL,0,'2013-12-25 17:45:53'),(5298,4199,'Y','18','024','14','A','','','TE','0000781886','0000781886','','IL','1','Warner','Harmony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-11-03','F','',NULL,NULL,NULL,'','1864009','','2013-12-18','2013-12-18 22:03:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:06:14'),(622,513,'Y','18','021','EC','A','','','AC','0001055301','0001055301','OH00000869247','IL','1','Speaks','Jacqueline','','','','34','273584870','3575 BABBITT RD',0,'BLACKLICK','OH','43004','9653','CY','39049','1955-05-07','F','R',':RET:2106-3','T','021','DEN','1847272','99734OH005000401','2014-01-01','2013-12-16 11:43:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:00:52'),(5193,4120,'Y','18','021','EC','A','','','AC','0000654587','0000654587','OH00000923850','IL','1','Nguyen','Quan','','','','34','004968375','1918 CARLTON RD',0,'KENT','OH','44240','4213','CY','39133','1977-06-18','M','M',NULL,'N','021','DEN','2481971','99734OH005000401','2014-01-01','2013-12-19 13:42:41','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:03:50'),(17186,13752,'Y','18','021','EC','A','','','AC','0000353102','0000353102','TX00001721397','IL','1','Cooper','Tracy','','','','34','573595444','1679 ELK DR',0,'GEORGETOWN','TX','78626','4612','CY','48491','1963-10-25','F','U',':RET:2106-3','N','021','DEN','2424601','33348TX002000101','2014-02-01','2014-01-08 12:40:05','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-13 02:22:16'),(3250,2620,'Y','18','021','EC','A','','','AC','0000359653','0000359653','OH00000742085','IL','1','Robinson','Debra','','','','34','185507380','7870 Third St',0,'Masury','OH','44438',NULL,'CY','39155','1955-09-26','F','M',':RET:2106-3','T','021','DEN','520923','99734OH005000401','2014-01-01','2013-11-28 15:24:42','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:46:36'),(1424,1186,'Y','18','021','EC','A','','','AC','0001459145','0001459145','LA00000165902','IL','1','Pasquier','Elizabeth','','','','34','589449878','19469 SCHLUMBRECHT RD',0,'COVINGTON','LA','70435','7742','CY','22103','1949-06-12','F','M',NULL,'N','021','DEN','2256915','18575LA002000201','2014-01-01','2013-12-24 16:04:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:20'),(2172,1787,'Y','18','021','EC','A','','','AC','0000317319','0000317319','OH00000853066','IL','1','kutzli','darcy','l','','','34','269548438','126 TIMOTHY ST',0,'DEFIANCE','OH','43512','2369','CY','39039','1954-02-04','F','U',':RET:2106-3','N','021','HLT','636898','92036OH006002601','2014-01-01','2013-12-10 16:41:54','260.00',NULL,NULL,'402.54','142.54','R-OH001','OH0','402.54',NULL,0,'2013-12-25 19:19:12'),(1943,1583,'Y','18','024','14','A','','','TE','0000767371','0000767371','','IL','1','Dougherty','Patrick',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-23','M','',NULL,NULL,NULL,'','360443','','2013-11-20','2013-11-20 02:29:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:00:44'),(1921,1567,'Y','18','021','EC','A','','','AC','0001214756','0001214756','OH00000494224','IL','1','porter','peter','','','','34','301888189','177 CRESTLINE AVE',0,'MANSFIELD','OH','44903','4118','CY','39139','1985-01-08','M','M',':RET:2106-3','N','021','DEN','945090','99734OH005000301','2014-01-01','2013-11-20 13:52:43','0.00',NULL,NULL,'42.26','42.26','R-OH007','OH0','0.00',NULL,0,'2013-12-25 19:00:11'),(7793,6171,'Y','18','024','14','A','','','TE','0000660277','0000660277','','IL','1','HO','THANH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-19','F','',NULL,NULL,NULL,'','1947799','','2013-12-20','2013-12-20 15:21:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:28'),(8950,7098,'Y','18','021','EC','A','','','AC','0000235195','0000235195','OH00000243324','IL','1','Still','James','','','','34','268509716','806 N 1ST ST',0,'DENNISON','OH','44621','1004','CY','39157','1949-03-31','M','R',':RET:2106-3','N','021','DEN','1876055','99734OH005000401','2014-01-01','2013-12-18 11:43:17','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:03:33'),(8986,7128,'Y','18','021','EC','A','','','AC','0000338853','0000338853','OH00001098610','IL','1','McKinney','Debra','','','','34','291428895','137 HIRN ST',0,'CHILLICOTHE','OH','45601','2627','CY','39141','1952-03-12','F','U',':RET:2106-3','N','021','DEN','2442979','99734OH005000401','2014-01-01','2013-12-18 16:50:29','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-26 04:04:28'),(9550,7569,'Y','18','021','EC','A','','','AC','0000254527','0000254527','OH00000026777','31','1','Beam','William','M','','','34','287727302','P.O. Box 78',0,'Port William','OH','45164',NULL,'CY','39027','1962-06-21','M','M',':RET:2106-3','N','021','DEN','1867652','99734OH005000301','2014-01-01','2013-12-21 12:45:03','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:36:16'),(17052,13645,'Y','18','021','EC','A','','','AC','0000273800','0000273800','OH00002388255','IL','1','BRAMMER','JAYNE','','','','34','292646071','214 FREEMAN AVE',0,'URBANA','OH','43078','1539','CY','39021','1959-05-01','F','U',':RET:2106-3','N','021','HLT','2154557','92036OH004000501','2014-02-01','2014-01-09 18:00:49','361.00',NULL,NULL,'408.08','47.08','R-OH003','OH0','408.08',NULL,0,'2014-01-13 02:20:58'),(21707,17334,'Y','18','021','EC','A','','','AC','0000442130','0000442130','MS00001657169','31','1','Collins','Joe','','','','34','587948931','P. O. Box 9325',0,'Jackson','MS','39206',NULL,'CY','28049','1955-02-12','M','U',':RET:2054-5','N','021','DEN','3459254','46300MS002000101','2014-03-01','2014-02-04 23:46:17','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-05 21:31:13'),(27127,21474,'Y','18','024','14','A','','','TE','0000976797','0000976797','','IL','1','finnell','patrick',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-28','M','',NULL,NULL,NULL,'','3398103','','2014-03-03','2014-03-03 09:55:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:37'),(22383,17873,'N','19','021','EC','A',NULL,NULL,'','0001156236','0001133977','','IL','1','Cassiday','Mackinzie','','','','34','273061599','2955 PREAKNESS DR',0,'STOW','OH','44224','6235','CY','39153','2000-12-05','F','',':RET:2106-3','N','021','HLT','2648777','52664OH151001306','2014-03-01','2014-02-10 10:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-10 21:30:10'),(23048,18375,'Y','18','024','14','A','','','TE','0000584548','0000584548','','IL','1','NGUYEN','HEIDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-01','F','',NULL,NULL,NULL,'','3198797','','2014-02-12','2014-02-12 14:50:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-12 21:30:44'),(28090,22232,'Y','18','021','EC','A','','','AC','0000639479','0000639479','MS00002677403','31','1','hale','peggy','l','','','34','411924222','po box 676',0,'florence','MS','39073',NULL,'CY','28121','1953-09-30','F','M',':RET:2106-3','N','021','DEN','3023536','46300MS002000101','2014-04-01','2014-03-05 19:34:22','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-06 21:02:04'),(19445,15499,'N','19','021','EC','A',NULL,NULL,'','0000802607','0000322176','','IL','1','Brock','Connor','','','','34','270082114','464 E PEKIN RD',0,'LEBANON','OH','45036','8191','CY','39165','2002-09-13','M','',':RET:2106-3','N','021','DEN','1458692','99734OH005000301','2014-03-01','2014-01-22 13:52:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:01:50'),(19113,15229,'Y','18','021','EC','A','','','AC','0000362522','0000362522','OH00001414841','IL','1','MAY','JANELLE','','','','34','300906256','2308 CANDLEWOOD DR',0,'DAYTON','OH','45419','2825','CY','39113','1986-06-04','F','M',':RET:2106-3','N','021','HLT','2884595','92036OH005000505','2014-03-01','2014-01-18 15:30:35','53.00',NULL,NULL,'249.11','196.11','R-OH003','OH0','249.11',NULL,0,'2014-01-21 08:44:46'),(3402,2730,'Y','18','021','EC','A','','','AC','0001813281','0001813281','LA00000094237','IL','1','Araiza','Cristina','M','','','34','466907296','1211 BERMUDA RD',0,'NATCHEZ','LA','71456','3747','CY','22069','1963-09-30','F','U',':RET:2106-3','N','021','DEN','1598217','18575LA002000201','2014-01-01','2013-12-22 13:14:06','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 21:18:08'),(18079,14439,'Y','18','024','14','A','','','TE','0001594344','0001594344','','IL','1','MILLER','FRANCES','RENEE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-02-14','F','',NULL,NULL,NULL,'','2501430','','2014-01-14','2014-01-14 10:48:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-15 02:07:26'),(7616,6027,'Y','18','021','EC','A','','','AC','0001188760','0001188760','OH00000107781','IL','1','Stephens','Randy','','','','34','270687166','2557Bramble rd sw',0,'Carrollton','OH','44615',NULL,'CY','39019','1959-03-08','M','M',':RET:2106-3','N','021','DEN','684141','99734OH005000301','2014-01-01','2013-11-17 09:52:10','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-26 02:45:47'),(14065,11207,'N','01','021','EC','A',NULL,NULL,'','0000893158','0000498168','','IL','1','Rasmussen','Teresa','Ann','','','34','632464706','7292 PORTER DR',0,'CANAL WINCHESTER','OH','43110','8230','CY','39049','1960-03-20','F','',':RET:2106-3','N','021','DEN','1956929','99734OH005000401','2014-02-01','2013-12-26 08:28:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:00:41'),(21943,17523,'Y','18','021','EC','A','','','AC','0000411585','0000411585','TX00002124780','IL','1','Kerr','Charles','','','','34','456962942','48 MARCY DR',0,'BORGER','TX','79007','8432','CY','48233','1953-05-21','M','M',':RET:2106-3','N','021','DEN','3640773','33348TX002000201','2014-03-01','2014-02-07 16:48:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-07 19:00:16'),(26611,21100,'Y','18','024','14','A','','','TE','0000113143','0000113143','','IL','1','PATEL','KAMLESH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-13','M','',NULL,NULL,NULL,'','3707086','','2014-02-28','2014-02-28 00:01:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:47'),(27405,21694,'N','19','021','EC','A',NULL,NULL,'','0000195195','0000672820','','IL','1','Watkins','Lauryn','Elona','','','34','289130303','20700 Wilmore Avenue',0,'Euclid','OH','44123',NULL,'CY','39035','2007-10-23','F','',':RET:2054-5','N','021','DEN','3485352','99734OH005000301','2014-04-01','2014-03-04 10:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:33'),(29072,23009,'Y','18','024','14','A','','','TE','0001023435','0001023435','','IL','1','storey','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-27','M','',NULL,NULL,NULL,'','2719655','','2014-03-31','2014-03-09 21:18:57',NULL,NULL,NULL,NULL,NULL,NULL,'WI0',NULL,'TERM',0,'2014-03-10 21:01:58'),(184,153,'Y','18','021','EC','A','','','AC','0001242944','0001242944','OH00000510266','IL','1','BELACIC','FRANK','','','','34','291466243','2171 PORTAGE LINE RD',0,'MOGADORE','OH','44260',NULL,'CY','39153','1949-05-31','M','R',':RET:2106-3','N','021','HLT','799334','52664OH151001301','2014-01-01','2013-12-05 16:26:33','0.00',NULL,NULL,'669.00','669.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 17:19:46'),(18852,15014,'Y','18','021','EC','A','','','AC','0000878285','0000878285','OH00002552312','IL','1','Morrison','Douglas','','','','34','290643121','803 Staeger Street',0,'Akron','OH','44306',NULL,'CY','39153','1963-01-26','M','U',':RET:2106-3','N','021','HLT','2326166','52664OH151001305','2014-02-01','2014-01-15 20:27:02','312.00',NULL,NULL,'415.91','103.91','R-OH012','OH0','415.91',NULL,0,'2014-01-17 03:36:16'),(4273,3404,'Y','18','024','14','A','','','TE','0000661336','0000661336','','IL','1','Eversole','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-24','F','',NULL,NULL,NULL,'','1413576','','2013-12-16','2013-12-16 21:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:49'),(18757,14945,'N','01','021','EC','A',NULL,NULL,'','0000689561','0000183344','','IL','1','Mirelez','Nancy','Y','','','34','533311633','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1971-01-24','F','',NULL,'N','021','DEN','2748913','33348TX002000101','2014-02-01','2014-01-15 18:45:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-17 03:35:46'),(2575,2092,'Y','18','021','EC','A','','','AC','0000130671','0000130671','OH00000772798','IL','1','Garnica','Jaime','','','','34','401865023','28051 Settlers Reserve Way',0,'Westlake','OH','44145',NULL,'CY','39035','1953-09-17','M','U',NULL,'N','021','HLT','1028057','92036OH004000801','2014-01-01','2013-12-09 16:00:43','319.00',NULL,NULL,'510.20','191.20','R-OH011','OH0','510.20',NULL,0,'2013-12-25 19:37:47'),(14677,11717,'Y','18','021','EC','A','','','AC','0000208940','0000208940','MS00001457067','IL','1','Drake','Lemichal','','','','34','425654959','635 hampton way',0,'jackson','MS','39211',NULL,'CY','28049','1986-06-26','M','U',':RET:2054-5','N','021','DEN','1419038','46300MS002000201','2014-02-01','2013-12-27 18:58:32','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2013-12-29 11:08:26'),(22390,17879,'Y','18','021','EC','A','','','AC','0001076607','0001076607','OH00002304244','IL','1','Pillitiere','Thomas','','','','34','288547574','717 COLUMBIA AVE',0,'AKRON','OH','44310','2312','CY','39153','1954-07-20','M','M',':RET:2106-3','T','021','HLT','2874130','52664OH151001304','2014-03-01','2014-02-10 13:21:51','834.00',NULL,NULL,'1235.78','401.78','R-OH012','OH0','667.56',NULL,0,'2014-02-10 21:30:15'),(22400,17885,'Y','18','021','EC','A','','','AC','0000359721','0000359721','OH00001862850','IL','1','McCall','Kevin','W','','','34','275743792','1534 Frederick Blvd',0,'Akron','OH','44320',NULL,'CY','39153','1974-08-08','M','U',NULL,'N','021','HLT','2634816','52664OH151001304','2014-03-01','2014-02-10 14:56:53','112.00',NULL,NULL,'281.44','169.44','R-OH012','OH0','281.44',NULL,0,'2014-02-10 21:30:19'),(24576,19513,'N','01','021','EC','A',NULL,NULL,'','0000178939','0001125482','','IL','1','Saladino','Cristeta','A','','','34','299025250','6391 WILLOW BROOKE DR',0,'LIBERTY TWP','OH','45011','0401','CY','39017','1951-10-28','F','',':RET:2036-2','N','021','DEN','3061186','99734OH005000301','2014-04-01','2014-02-18 23:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:05'),(24796,19666,'Y','18','021','EC','A','','','AC','0000984904','0000984904','OH00003029793','IL','1','MCGOWAN','APRIL','','','','34','289905832','1009 3RD ST',0,'MARIETTA','OH','45750','1836','CY','39167','1989-09-15','F','M',NULL,'N','021','DEN','3100708','99734OH005000401','2014-04-01','2014-02-19 16:30:01','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2014-02-20 04:47:26'),(28618,22648,'N','01','021','EC','A',NULL,NULL,'','0000427550','0000075325','','IL','1','McNeill','Fernanda','Rebeca','','','34','644151066','3049 SNOWBERRY',0,'NEW BRAUNFELS','TX','78130','7055','CY','48091','1972-04-04','F','',':RET:2106-3','N','021','DEN','3447391','33348TX002000201','2014-04-01','2014-03-07 22:53:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:19'),(455,371,'Y','18','021','EC','A','','','AC','0000955508','0000955508','OH00000645825','IL','1','RAMEY','DEBRA','','','','34','270709350','201 Superior St Apt 5',0,'ROSSFORD','OH','43460',NULL,'CY','39173','1960-08-07','F','U',NULL,'N','021','HLT','687234','92036OH003002606','2014-01-01','2013-12-03 18:31:15','357.00',NULL,NULL,'415.41','58.41','R-OH001','OH0','415.41',NULL,0,'2013-12-25 17:47:27'),(17772,14199,'Y','18','021','EC','A','','','AC','0001122211','0001122211','TX00002534731','IL','1','Zayas','Robert',NULL,NULL,NULL,NULL,NULL,'12121 JONES RD',0,'HOUSTON','TX','77070','5208','CY','48201','1970-08-26','M','U',NULL,'N','021','DEN','2142947','33348TX002000101','2014-02-01','2014-01-13 14:25:13','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:39'),(16752,13401,'Y','18','021','EC','A','','','AC','0000795894','0000795894','TX00002034613','IL','1','Keller','Gregory','','','','34','463028064','2004 N 12TH ST',0,'MCALLEN','TX','78501','4159','CY','48215','1955-12-02','M','U',':RET:2106-3','N','021','DEN','2310146','33348TX002000101','2014-02-01','2014-01-07 16:50:56','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-01-08 18:24:55'),(2444,1991,'Y','18','021','EC','A','','','AC','0000188827','0000188827','OH00000820237','IL','1','Dinh','Lan','','','','34','279927307','3365 LAKE CREST DR',0,'HAMILTON','OH','45011','8167','CY','39017','1958-04-22','F','M',':RET:2047-9','N','021','HLT','1256918','92036OH004001201','2014-01-01','2013-12-08 19:57:20','0.00',NULL,NULL,'667.15','667.15','R-OH004','OH0','384.93',NULL,0,'2013-12-25 19:34:32'),(3967,3170,'N','19','021','EC','A',NULL,NULL,'','0000951775','0001241842','','IL','1','Cickovskis','Krista','Inga','','','34','294926513','3440 W SPRAGUE RD',0,'PARMA','OH','44134','6378','CY','39035','1990-10-01','F','',':RET:2106-3','N','021','HLT','584244','52664OH151001501','2014-01-01','2013-12-13 16:16:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2013-12-25 21:38:30'),(9801,7760,'N','G8','021','EC','A',NULL,NULL,'','0000227019','0000111848','','IL','1','weiner','chad','jacob','','','34','385131967','6745 SWEET BUSH CT',0,'SYLVANIA','OH','43560','3585','CY','39095','1992-02-05','M','',':RET:2106-3','N','021','HLT','126474','92036OH006002601','2014-01-01','2013-10-20 18:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','154.64',NULL,0,'2013-12-26 05:01:13'),(7088,5622,'Y','18','021','EC','A','','','AC','0000679537','0000679537','OH00001283349','IL','1','HARRIS','PEARLEAN','','','','34','281706946','719 FERN ST',0,'AKRON','OH','44307','1816','CY','39153','1961-06-05','F','U',':RET:2054-5','N','021','HLT','1593403','52664OH152000901','2014-01-01','2013-12-24 22:00:38','318.84',NULL,NULL,'318.84','0.00','R-OH012','OH0','318.84',NULL,0,'2013-12-26 01:50:28'),(9714,7695,'Y','18','021','EC','A','','','AC','0001152157','0001152157','OH00000129553','IL','1','Muncy','Stephen','Michael','','','34','299463293','2455 E LIVINGSTON AVE',0,'COLUMBUS','OH','43209','2911','CY','39049','1951-04-18','M','M',':RET:2106-3','N','021','DEN','1000939','99734OH005000401','2014-01-01','2013-11-15 11:00:38','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:45:17'),(25482,20218,'Y','18','021','EC','A','','','AC','0000289578','0000289578','OH00002465728','IL','1','Werring','David','','','','34','272662140','2896 STATE ROUTE 286',0,'WILLIAMSBURG','OH','45176','6527','CY','39015','1961-07-20','M','M',':RET:2106-3','N','021','HLT','3367977','92036OH005000601','2014-04-01','2014-02-25 10:39:11','320.00',NULL,NULL,'1027.21','707.21','R-OH005','OH0','419.03',NULL,0,'2014-02-25 21:31:44'),(28677,22693,'Y','18','021','EC','A','','','AC','0000970520','0000970520','OH00003123068','IL','1','Newlon','Roy','','','','34','282545518','512 E WATER ST',0,'NORTH BALTIMORE','OH','45872','1429','CY','39173','1953-11-30','M','M',NULL,'N','021','HLT','3783194','92036OH004002601','2014-04-01','2014-03-07 19:54:32','120.00',NULL,NULL,'425.53','305.53','R-OH001','OH0','425.53',NULL,0,'2014-03-08 21:30:53'),(1716,1430,'N','01','021','EC','A',NULL,NULL,'','0000851841','0000920812','','IL','1','Handley','Tina','','','','34','302705469','5320 HI LO DR',0,'FRAZEYSBURG','OH','43822','9002','CY','39119','1962-06-26','F','',':RET:2106-3','N','021','DEN','1668699','99734OH005000301','2014-01-01','2013-12-24 08:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:05'),(2644,2148,'Y','18','024','14','A','','','TE','0000999820','0000999820','','IL','1','Lordi','Joe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-28','M','',NULL,NULL,NULL,'','1158154','','2013-12-02','2013-12-02 16:56:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:46:25'),(19147,15255,'Y','18','021','EC','A','','','AC','0000618990','0000618990','TX00002585379','IL','1','Sandoval','Laura','','','','34','222825721','68 CAMELLIA WAY',0,'SAN ANTONIO','TX','78209','2018','CY','48029','1970-08-21','F','M',':RET:2106-3','N','021','DEN','1589836','33348TX002000101','2014-03-01','2014-01-18 19:44:30','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2014-01-21 08:45:32'),(7186,5696,'Y','18','021','EC','A','','','AC','0000095218','0000095218','OH00000904912','IL','1','Duncan','Roy','','','','34','594072570','1388 EASTWOOD AVE',0,'AKRON','OH','44305','1370','CY','39153','1981-08-28','M','U',':RET:2106-3','N','021','DEN','886654','99734OH005000301','2014-01-01','2013-12-14 11:42:22','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:00:18'),(4780,3794,'Y','18','021','EC','A','','','AC','0001092441','0001092441','MS00000119751','31','1','Shepherd','LaToya','','','','34','427678832','105 W POND ST',0,'DODDSVILLE','MS','38736','9701','CY','28133','1989-11-21','F','U',':RET:2054-5','N','021','DEN','802102','46300MS002000101','2014-01-01','2013-12-07 19:08:21','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 22:16:05'),(24271,19275,'N','19','021','EC','A',NULL,NULL,'','0000944916','0000368596','','IL','1','saeidi','anthony','F','','','34','363257160','8152 PEPPERWOOD DR',0,'WEST CHESTER','OH','45069','1861','CY','39017','1988-06-15','M','',':RET:2106-3','N','021','HLT','3249596','92036OH006001201','2014-04-01','2014-02-17 14:41:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','170.93',NULL,0,'2014-02-17 19:00:17'),(25154,19954,'Y','18','024','14','A','','','TE','0000389645','0000389645','','IL','1','SMITH','DONYA','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-12-19','F','',NULL,NULL,NULL,'','3684637','','2014-02-21','2014-02-21 15:33:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-21 22:00:18'),(26723,21183,'Y','18','024','14','A','','','TE','0000533968','0000533968','','IL','1','samaha','muhammad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-05-20','M','',NULL,NULL,NULL,'','2702806','','2014-02-28','2014-02-28 09:15:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:31:46'),(28810,22803,'Y','18','021','EC','A','','','AC','0000214729','0000214729','OH00002697596','IL','1','HENSON','LAURA','','','','34','278547952','923 E 15TH ST',0,'ASHTABULA','OH','44004','3623','CY','39007','1953-08-28','F','U',NULL,'T','021','HLT','3522230','52664OH151001306','2014-04-01','2014-03-09 11:06:44','597.00',NULL,NULL,'785.02','188.02','R-OH011','OH0','785.02',NULL,0,'2014-03-09 21:00:54'),(335,275,'Y','18','021','EC','A','','','AC','0000518872','0000518872','TX00000512616','IL','1','Hollar','Everett','','','','34','457921051','4214 LEONA RIV',0,'SAN ANTONIO','TX','78253','5709','CY','48029','1952-04-10','M','U',NULL,'N','021','DEN','1239176','33348TX002000101','2014-01-01','2013-10-10 22:33:06','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 17:31:47'),(21541,17206,'Y','18','021','EC','A','','','AC','0000598792','0000598792','OH00002030054','IL','1','DAVIS','LYDIA','','','','34','299548144','3314 YORKSHIRE RD',0,'CLEVELAND','OH','44118','2503','CY','39035','1950-09-08','F','U',':RET:2054-5','N','021','DEN','3174020','99734OH005000401','2014-03-01','2014-02-04 23:02:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:09'),(1248,1028,'Y','18','021','EC','A','','','AC','0000834436','0000834436','OH00000264441','IL','1','McGarvey','Steve','','','','34','298884011','635 ROMBACH AVE',0,'WILMINGTON','OH','45177','2486','CY','39027','1982-06-23','M','U',':RET:2106-3','T','021','HLT','1127936','92036OH004000601','2014-01-01','2013-12-03 11:29:44','0.00',NULL,NULL,'230.07','230.07','R-OH005','OH0','230.07',NULL,0,'2013-12-25 18:21:07'),(18505,14759,'N','01','021','EC','A',NULL,NULL,'','0000529466','0001016878','','IL','1','Goodell','Sherry','','','','34','278544917','9370 Peck Road',0,'Mantua','OH','44255',NULL,'CY','39133','1952-08-09','F','',NULL,'N','021','HLT','2619341','52664OH151001305','2014-02-01','2014-01-15 15:40:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-01-16 08:46:31'),(18004,14387,'Y','18','021','EC','A','','','AC','0000038409','0000038409','OH00001932239','IL','1','Fuller','LuAnn','','','','34','289686950','7004 RETTON RD',0,'REYNOLDSBURG','OH','43068','3069','CY','39049','1961-05-26','F','U',NULL,'N','021','DEN','1373790','99734OH005000301','2014-02-01','2014-01-13 23:13:27','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:07:01'),(16483,13191,'Y','18','021','EC','A','','','AC','0000026636','0000026636','OH00001351560','IL','1','jackson','rochelle','','','','34','026625838','3682 E 143RD ST',0,'CLEVELAND','OH','44120','4805','CY','39035','1967-08-23','F','U',NULL,'T','021','HLT','1909183','92036OH004000801','2014-02-01','2014-01-06 13:10:05','221.00',NULL,NULL,'324.28','103.28','R-OH011','OH0','324.28',NULL,0,'2014-01-07 04:06:19'),(15202,12150,'Y','18','021','EC','A','','','AC','0000651579','0000651579','MS00000137092','IL','1','Traylor','Yvonne','','','','34','587067923','564 SCHOOL CIR',0,'JACKSON','MS','39209','4368','CY','28049','1965-11-14','F','U',NULL,'N','021','DEN','2348155','46300MS002000201','2014-02-01','2013-12-30 12:12:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-01 12:07:26'),(4680,3710,'Y','18','021','EC','A','','','AC','0000614154','0000614154','LA00000264679','IL','1','hoffpauir','howard','','','','34','434194462','7793 HIGHWAY 27',0,'BELL CITY','LA','70630','3010','CY','22019','1959-08-19','M','R',':RET:2106-3','T','021','DEN','30310','18575LA002000201','2014-01-01','2013-12-12 16:15:01','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2013-12-25 22:07:52'),(15139,12099,'Y','18','021','EC','A','','','AC','0000412217','0000412217','OH00001287511','IL','1','GESSNER','PAMELA','JOYCE','','','34','280566814','2543 WARSAW AVE',0,'CINCINATTI','OH','45204',NULL,'CY','39061','1954-08-16','F','U',':RET:2106-3','T','021','DEN','2582965','99734OH005000401','2014-02-01','2013-12-30 07:41:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:40'),(7213,5717,'Y','18','021','EC','A','','','AC','0000247873','0000247873','OH00000698630','IL','1','clausen','joseph','','','','34','297525815','13121 SAINT JAMES AVE',0,'CLEVELAND','OH','44135','1636','CY','39035','1954-03-22','M','U',':RET:2106-3','N','021','DEN','352046','99734OH005000401','2014-01-01','2013-12-14 11:09:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:59'),(7655,6062,'Y','18','021','EC','A','','','AC','0001173591','0001173591','LA00000623641','IL','1','Smith','Keith','Cornell','','','34','439436441','4846 ROSALIA DR',0,'NEW ORLEANS','LA','70127','3561','CY','22071','1968-08-14','M','U',':RET:2054-5','N','021','DEN','1380491','18575LA002000101','2014-01-01','2013-12-19 19:45:53','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 03:00:06'),(9683,7670,'Y','18','021','EC','A','','','AC','0000124201','0000124201','OH00000916978','IL','1','Hall','William','','','','34','280668380','8421 COX RD',0,'WEST CHESTER','OH','45069','3339','CY','39017','1966-02-13','M','M',':RET:2106-3','N','021','HLT','1930215','92036OH001001201','2014-01-01','2013-12-21 11:34:38','268.00',NULL,NULL,'747.83','479.83','R-OH004','OH0','404.73',NULL,0,'2013-12-26 04:39:31'),(13287,10605,'Y','18','021','EC','A','','','AC','0000784812','0000784812','TX00000512258','IL','1','Simmons','Bertha','','','','34','304909819','2166 Baja Circle',0,'Los Fresnos','TX','78566',NULL,'CY','48061','1972-06-14','F','M',NULL,'N','021','DEN','1612899','33348TX002000201','2014-01-01','2013-12-23 13:17:15','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 12:57:22'),(14804,11823,'Y','18','021','EC','A','','','AC','0001627525','0001627525','LA00000016243','IL','1','PAYNE','DUDLEY','','','','34','436980625','1401 HERMOSA ST',0,'NEW ORLEANS','LA','70114','5917','CY','22071','1955-07-27','M','U',NULL,'N','021','DEN','2378705','18575LA002000101','2014-01-01','2013-12-23 20:50:32','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2013-12-29 11:13:50'),(21817,17422,'Y','18','021','EC','A','','','AC','0000942034','0000942034','OH00002536640','IL','1','Watkins','Robin','','','','34','591179631','5067 S Hametown Rd',0,'Norton','OH','44203',NULL,'CY','39153','1991-10-07','F','U',NULL,'N','021','HLT','2935671','52664OH151001306','2014-03-01','2014-02-06 16:07:28','174.00',NULL,NULL,'223.01','49.01','R-OH012','OH0','223.01',NULL,0,'2014-02-06 21:00:57'),(22124,17659,'Y','18','021','EC','A','','','AC','0000101467','0000101467','OH00001820586','IL','1','Ratliff','Jeff','','','','34','400330514','2108 INDIAN RIDGE DR',0,'PIQUA','OH','45356','8268','CY','39109','1978-02-03','M','M',':RET:2106-3','N','021','HLT','2819217','92036OH004000501','2014-03-01','2014-02-08 17:01:32','354.00',NULL,NULL,'714.48','360.48','R-OH003','OH0','235.10',NULL,0,'2014-02-08 19:00:41'),(22688,18117,'Y','18','021','EC','A','','','AC','0000126951','0000126951','TX00002405236','IL','1','Hicks','Ronald','','','','34','458790928','9356 MECHLER LN',0,'LA COSTE','TX','78039','9417','CY','48029','1971-11-08','M','M',':RET:2106-3','N','021','DEN','2654099','33348TX002000101','2014-03-01','2014-02-11 18:17:19','0.00',NULL,NULL,'94.59','94.59','R-TX019','TX0','25.02',NULL,0,'2014-02-11 21:00:51'),(22796,18198,'N','19','021','EC','A',NULL,NULL,'','0000347943','0000672798','','IL','1','WILSON-FORTE','BRANDY','MICHELE','','','34','295021785','4365 W ANDERSON RD',0,'CLEVELAND','OH','44121','3574','CY','39035','1998-03-18','F','',':RET:2054-5','N','021','DEN','2982740','99734OH005000301','2014-03-01','2014-02-11 13:01:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:51'),(18313,14621,'Y','18','021','EC','A','','','AC','0000494467','0000494467','OH00002168830','IL','1','Fahnle','Barbara','','','','34','402646505','3531 werk Road',0,'Cincinnati','OH','45248',NULL,'CY','39061','1951-05-16','F','M',':RET:2106-3','N','021','DEN','1618210','99734OH005000401','2014-02-01','2014-01-15 12:50:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:03'),(14798,11818,'Y','18','021','EC','A','','','AC','0000980540','0000980540','OH00001300226','IL','1','holland','randi','','','','34','283665599','8104 Puritan Dr.',0,'Mentor','OH','44060',NULL,'CY','39085','1963-03-17','F','M',':RET:2106-3','N','021','DEN','1650947','99734OH005000401','2014-01-01','2013-12-23 20:49:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:40'),(14742,11771,'Y','18','024','14','A','','','TE','0001992210','0001992210','','IL','1','Guy','Gussie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-06','F','',NULL,NULL,NULL,'','2569762','','2013-12-27','2013-12-27 20:18:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2013-12-29 11:10:03'),(13257,10580,'Y','18','021','EC','A','','','AC','0000277712','0000277712','TX00000694133','IL','1','Arnold','Sheldon','','','','34','452026650','6991 GLENDALE RD',0,'TRINITY','TX','75862','5625','CY','48455','1953-08-10','M','U',':RET:2106-3','N','021','DEN','1739746','33348TX002000201','2014-01-01','2013-12-23 11:41:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:34'),(1548,1291,'Y','18','021','EC','A','','','AC','0000369488','0000369488','MS00000104998','IL','1','Howell','Michael','','','','34','426259765','275 Sandy Run Rd.',0,'Hattiesburg','MS','39402',NULL,'CY','28073','1972-07-11','M','U',':RET:2106-3','N','021','DEN','1767964','46300MS002000201','2014-01-01','2013-12-24 07:52:41','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:50:31'),(3151,2534,'Y','18','021','EC','A','','','AC','0000215786','0000215786','TX00000270896','IL','1','Davis','Patricia','','','','34','208387209','302 DEBORA DR',0,'GEORGETOWN','TX','78628','8995','CY','48491','1949-11-14','F','U',':RET:2106-3','N','021','DEN','433155','33348TX002000201','2014-01-01','2013-11-18 17:39:32','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 20:31:02'),(1640,1370,'Y','18','021','EC','A','','','AC','0000028235','0000028235','TX00000410725','IL','1','Espinoza','Victoriano','','','','34','450948034','2206 ARBOR ST',0,'HOUSTON','TX','77004','6027','CY','48201','1951-03-23','M','U',NULL,'N','021','DEN','2460943','33348TX002000201','2014-01-01','2013-12-24 15:22:47','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:53:03'),(9359,7419,'Y','18','021','EC','A','','','AC','0001466566','0001466566','LA00001200889','IL','1','Hayes','Laci','','','','34','433750484','311 S DIVISION ST',0,'DEQUINCY','LA','70633','3901','CY','22019','1988-02-27','F','U',':RET:2106-3','N','021','DEN','2417566','18575LA002000201','2014-01-01','2013-12-21 08:10:28','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 04:31:29'),(9784,7749,'Y','18','021','EC','A','','','AC','0000631477','0000631477','OH00000685425','IL','1','Thompson','Shannon','','','','34','404210236','1274 SERENITY LN',0,'COLUMBUS','OH','43085','4796','CY','39049','1972-10-19','F','M',':RET:2106-3','N','021','DEN','582269','99734OH005000301','2014-01-01','2013-10-21 12:15:51','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 05:00:49'),(26342,20899,'Y','18','021','EC','A','','','AC','0001208367','0001208367','OH00002934898','IL','1','LAWMAN','ALLAN','W','','','34','489524449','121 PERRY ST',0,'PEMBERVILLE','OH','43450','0025','CY','39173','1950-07-20','M','U',NULL,'T','021','HLT','3310654','92036OH003002606','2014-04-01','2014-02-27 11:47:02','492.00',NULL,NULL,'691.29','199.29','R-OH001','OH0','691.29',NULL,0,'2014-02-28 06:31:44'),(27036,21412,'Y','18','021','EC','A','','','AC','0000521477','0000521477','TX00003457693','IL','1','MENDIOLA','MARTHA','','','','34','458849779','2502 W TWOHIG AVE',0,'SAN ANGELO','TX','76901','3658','CY','48451','1949-08-16','F','U',':RET:2106-3','N','021','DEN','3529836','33348TX002000201','2014-04-01','2014-03-03 15:22:36','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61','CIC',0,'2014-03-03 21:00:18'),(27676,21890,'Y','18','021','EC','A','','','AC','0000641578','0000641578','TX00002684966','IL','1','vilchis','rudy','','','','34','615461567','306 MELINDA LN',0,'TYLER','TX','75702','6527','CY','48423','1991-01-27','M','M',':RET:2106-3','N','021','DEN','3919428','33348TX002000201','2014-04-01','2014-03-04 20:02:46','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-03-05 21:30:36'),(2051,1680,'Y','18','021','EC','A','','','AC','0000735921','0000735921','TX00000936731','IL','1','Miller','Barbara','','','','34','403965160','653 COUNTY ROAD 367',0,'UVALDE','TX','78801','1149','CY','48463','1959-06-20','F','U',':RET:2106-3','N','021','DEN','212359','33348TX002000201','2014-01-01','2013-12-10 18:09:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:15:51'),(20835,16653,'N','01','021','EC','A',NULL,NULL,'','0000940889','0000456556','','IL','1','Wright','Mark Wilber','','','Jr','34','279782102','917 Bunker Hill Rd.',0,'Ashtabula','OH','44004',NULL,'CY','39007','1980-07-16','M','',':RET:2106-3','T','021','HLT','3527921','52664OH151001306','2014-03-01','2014-01-30 19:38:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','346.52',NULL,0,'2014-01-31 21:00:43'),(18728,14926,'N','19','021','EC','A',NULL,NULL,'','0000060293','0000992701','','IL','1','Moseley','Vann','Edward','','','34','480957709','5178 CONCORD CROSSING DR',0,'MASON','OH','45040','3608','CY','39165','2012-11-18','M','',':RET:2106-3','N','021','DEN','2689230','99734OH005000301','2014-02-01','2014-01-15 23:46:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:36'),(3999,3194,'Y','18','021','EC','A','','','AC','0000236255','0000236255','OH00001035083','IL','1','Cron','Karen','','','','34','284885450','4264 COUNTY ROAD T',0,'LIBERTY CENTER','OH','43532','9524','CY','39069','1987-12-08','F','U',':RET:2106-3','N','021','DEN','1734520','99734OH005000401','2014-01-01','2013-12-16 18:46:55','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:45:08'),(2746,2222,'N','01','021','EC','A',NULL,NULL,'','0000796924','0000727253','','IL','1','Wells','Kathleen','A','','','34','352488172','390-1 WINDWARD LN',0,'AURORA','OH','44202','8208','CY','39133','1953-07-13','F','',':RET:2106-3','N','021','HLT','1116071','52664OH152000901','2014-01-01','2013-12-02 16:34:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.31',NULL,0,'2013-12-25 19:48:56'),(3272,2638,'Y','18','021','EC','A','','','AC','0000982674','0000982674','OH00000887872','IL','1','snyder','mark','','','','34','287441869','712 JACKSON AVE',0,'DEFIANCE','OH','43512','2717','CY','39039','1961-10-23','M','M',':RET:2106-3','N','021','HLT','318703','92036OH005002606','2014-01-01','2013-11-28 08:22:05','879.00',NULL,NULL,'909.84','30.84','R-OH001','OH0','380.63',NULL,0,'2013-12-25 20:47:14'),(18105,14461,'Y','18','021','EC','A','','','AC','0001596709','0001596709','LA00002183250','IL','1','Bodin','Alicia','','','','34','434535541','2790 Rodeo Road',0,'Abbeville','LA','70510',NULL,'CY','22113','1965-12-29','F','M',':RET:2106-3','N','021','DEN','2557513','18575LA002000201','2014-02-01','2014-01-14 16:57:37','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-15 02:07:35'),(8121,6423,'N','01','021','EC','A',NULL,NULL,'','0000525545','0000749482','','IL','1','Best','Jamie','','','','34','302804511','110 N SYCAMORE ST',0,'ARCANUM','OH','45304','1169','CY','39037','1977-07-16','M','',':RET:2106-3','N','021','DEN','285669','99734OH005000401','2014-01-01','2013-11-21 22:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:15:16'),(15956,12773,'N','01','021','EC','A',NULL,NULL,'','0000484800','0000364896','','IL','1','LENGEL','BETTY JO','','','','34','302426542','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-06-20','F','',':RET:2106-3','N','021','DEN','2494771','99734OH005000301','2014-02-01','2014-01-03 11:48:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:14'),(17733,14169,'N','01','021','EC','A',NULL,NULL,'','0000625442','0000067685','','IL','1','Sweigert','Christine','Marie','','','34','282841356','14285 Kauffman Ave.',0,'Sterling','OH','44276',NULL,'CY','39169','1969-09-17','F','',NULL,'N','021','HLT','2088921','52664OH151001305','2014-02-01','2014-01-13 10:14:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-01-14 01:33:20'),(23992,19076,'N','01','021','EC','A',NULL,NULL,'','0001869509','0001985990','','IL','1','McCray','Mary','Dunn','','','34','439980701','22203 ROLLING ACRES DR',0,'DENHAM SPRINGS','LA','70726','7308','CY','22063','1957-11-15','F','',':RET:2106-3','T','021','DEN','3409382','18575LA002000201','2014-03-01','2014-02-15 14:57:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-15 22:00:27'),(25261,20040,'Y','18','024','14','A','','','TE','0000069564','0000069564','','IL','1','poole','zachary','g',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-12-23','M','',NULL,NULL,NULL,'','2724507','','2014-03-31','2014-02-22 10:27:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-22 19:00:13'),(25480,20216,'Y','18','024','14','A','','','TE','0000171204','0000171204','','IL','1','BRAUN','JANEEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-10','F','',NULL,NULL,NULL,'','398817','','2014-03-12','2014-02-25 11:31:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:31:43'),(26891,21311,'Y','18','024','14','A','','','TE','0000828253','0000828253','','IL','1','williams','amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-07','F','',NULL,NULL,NULL,'','2099390','','2014-03-16','2014-03-01 18:30:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 01:00:03'),(27386,21683,'Y','18','021','EC','A','','','AC','0000971446','0000971446','MS00002636129','IL','1','HOBBS','DONNELL','','','','34','427114146','332 JAMES BOYAKIN BARNETT RD',0,'MAGEE','MS','39111','5049','CY','28127','1958-10-12','M','M',':RET:2054-5','N','021','DEN','3268483','46300MS002000201','2014-04-01','2014-03-04 16:04:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:24'),(28364,22443,'Y','18','021','EC','A','','','AC','0000737505','0000737505','TX00002859556','IL','1','NINO','MIGDALIA','','','','34','626016870','4168 BEECH AVE',0,'MERCEDES','TX','78570',NULL,'CY','48215','1963-09-22','F','M',NULL,'N','021','DEN','3623684','33348TX002000201','2014-04-01','2014-03-07 15:40:31','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-07 21:30:30'),(28548,22594,'Y','18','021','EC','A','','','AC','0000120155','0000120155','OH00002823539','IL','1','BRAXTON','CANDICE','','','','34','268925480','2930 LATONIA BLVD',0,'TOLEDO','OH','43606','3626','CY','39095','1986-07-26','F','U',':RET:2054-5','N','021','HLT','3470150','92036OH005002606','2014-04-01','2014-03-07 12:01:16','172.00',NULL,NULL,'204.35','32.35','R-OH001','OH0','204.35',NULL,0,'2014-03-07 21:32:19'),(29139,23067,'Y','18','021','EC','A','','','AC','0000711435','0000711435','OH00003207930','31','1','Bates','Timothy','Edward','','','34','298720144','P.O.Box 3',0,'Custar','OH','43511',NULL,'CY','39173','1963-07-25','M','U',':RET:2106-3','N','021','HLT','3906140','92036OH005002606','2014-04-01','2014-03-10 11:19:37','272.00',NULL,NULL,'348.25','76.25','R-OH001','OH0','348.25',NULL,0,'2014-03-10 21:02:42'),(296,245,'Y','18','021','EC','A','','','AC','0001081759','0001081759','OH00000584290','IL','1','Bermingham','Robert','','','','34','149828006','140 BENT TREE DR',0,'FAIRFIELD','OH','45014','6735','CY','39017','1986-07-16','M','U',':RET:2106-3','N','021','DEN','1201461','99734OH005000401','2014-01-01','2013-11-13 13:19:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:30:42'),(17227,13786,'Y','18','021','EC','A','','','AC','0000259246','0000259246','OH00001742633','IL','1','Bailey','Harry','','','','34','281540480','18 CITY PARK AVE',0,'TOLEDO','OH','43609','2469','CY','39095','1952-11-08','M','M',NULL,'N','021','HLT','2149929','92036OH004002601','2014-02-01','2014-01-08 17:16:29','391.00',NULL,NULL,'440.60','49.60','R-OH001','OH0','440.60',NULL,0,'2014-01-13 02:22:37'),(1898,1552,'N','01','021','EC','A',NULL,NULL,'','0001152195','0001255032','','IL','1','Murray','Dan','','','','34','269865223','117 E Walton Street',0,'Willard','OH','44890',NULL,'CY','39077','1978-03-30','M','',':RET:2106-3','N','021','HLT','2177030','92036OH004002701','2014-01-01','2013-12-24 16:08:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.59',NULL,0,'2013-12-25 18:59:03'),(2148,1766,'Y','18','021','EC','A','','','AC','0000720231','0000720231','OH00001205101','IL','1','dittiacur','michael','','','','34','289785243','1620 glen parker ave',0,'cincinnati','OH','45223',NULL,'CY','39061','1981-03-07','M','R',':RET:2106-3','T','021','HLT','883998','92036OH006001201','2014-01-01','2013-12-09 19:01:16','0.00',NULL,NULL,'231.61','231.61','R-OH004','OH0','231.61',NULL,0,'2013-12-25 19:18:29'),(6628,5256,'Y','18','024','14','A','','','TE','0000239010','0000239010','','IL','1','Jones','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-06-30','F','',NULL,NULL,NULL,'','751033','','2013-12-11','2013-12-11 17:45:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:54:16'),(9635,7633,'Y','18','021','EC','A','','','AC','0000256069','0000256069','TX00000163141','IL','1','Torres','Javier','A','','','34','463295304','1815 STAFFORD DR',0,'EAGLE PASS','TX','78852','4056','CY','48323','1954-02-09','M','U',NULL,'N','021','DEN','1749879','33348TX002000101','2014-01-01','2013-12-20 21:38:31','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 04:38:19'),(9705,7687,'Y','18','021','EC','A','','','AC','0000498154','0000498154','OH00001167648','IL','1','YOUNKER','MARY','','','','34','274565340','30630 DROUILLARD RD',0,'WALBRIDGE','OH','43465',NULL,'CY','39173','1956-12-20','F','U',':RET:2106-3','N','021','HLT','2506453','92036OH002002601','2014-01-01','2013-12-21 17:01:39','184.00',NULL,NULL,'548.79','364.79','R-OH001','OH0','548.79',NULL,0,'2013-12-26 04:40:05'),(22442,17919,'Y','18','021','EC','A','','','AC','0001185284','0001185284','TX00002483450','IL','1','osikpa','emmanuel','','','','34','247359367','1603 anna mills ct.',0,'richmond','TX','77469',NULL,'CY','48157','1953-08-25','M','M',':RET:2054-5','N','021','DEN','3599558','33348TX002000201','2014-03-01','2014-02-10 13:12:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-10 21:30:42'),(25260,20039,'Y','18','021','EC','A','','','AC','0000069564','0000069564','TX00002781476','IL','1','poole','zachary','g','','','34','632345867','714 W 9TH ST',0,'TEXARKANA','TX','75501','5141','CY','48037','1992-12-23','M','U',':RET:2106-3','N','021','DEN','2869597','33348TX002000101','2014-04-01','2014-02-22 10:27:03','0.00',NULL,NULL,'25.02','25.02','R-TX021','TX0','25.02','CIC',0,'2014-02-22 19:00:13'),(25789,20453,'Y','18','021','EC','A','','','AC','0000321084','0000321084','OH00002700966','IL','1','OSTENKAMP','SANDRA','LEE','','','34','287548103','995 GLASGOW DRIVE',0,'CINCINNATI','OH','45240',NULL,'CY','39061','1951-08-10','F','M',':RET:2106-3','N','021','HLT','3539425','92036OH003001204','2014-04-01','2014-02-24 17:27:54','352.00',NULL,NULL,'644.07','292.07','R-OH004','OH0','644.07',NULL,0,'2014-02-26 09:31:08'),(27499,21758,'Y','18','021','EC','A','','','AC','0000367445','0000367445','OH00002579436','IL','1','Wills','Heather','Elaine','','','34','282842126','205 W WILLIAM ST',0,'MAUMEE','OH','43537','2179','CY','39095','1980-01-08','F','M',':RET:2106-3','T','021','HLT','3506335','92036OH004002601','2014-04-01','2014-03-04 12:47:06','302.00',NULL,NULL,'638.37','336.37','R-OH001','OH0','218.90',NULL,0,'2014-03-04 21:02:27'),(27736,21933,'Y','18','021','EC','A','','','AC','0000510575','0000510575','TX00003035256','31','1','wooldridge','deborah','','','','34','451814911','702 debra dr',0,'taylor','TX','76574',NULL,'CY','48491','1986-05-29','F','U',':RET:2054-5','N','021','DEN','3579528','33348TX002000201','2014-04-01','2014-03-05 16:21:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-05 21:31:06'),(27931,22095,'Y','18','021','EC','A','','','AC','0000872922','0000872922','TX00002814515','IL','1','Denbow','Jayna','E','','','34','631178733','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1979-02-20','F','M',':RET:2106-3','N','021','DEN','3860455','33348TX002000201','2014-04-01','2014-03-06 12:21:36','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:25'),(28012,22166,'Y','18','021','EC','A','','','AC','0000834523','0000834523','OH00002813163','IL','1','pytlik','james','','','','34','279480684','3153 NILES CORTLAND RD NE',0,'CORTLAND','OH','44410','1737','CY','39155','1954-01-02','M','U',':RET:2106-3','N','021','DEN','3661319','99734OH005000401','2014-04-01','2014-03-06 11:44:47','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-03-06 21:01:15'),(188,157,'Y','18','021','EC','A','','','AC','0000738984','0000738984','OH00001050950','IL','1','Dennison','David','','','','34','282729217','4240 Americana Dr.',0,'Cuyahoga Falls','OH','44224',NULL,'CY','39153','1965-04-02','M','U',':RET:2106-3','N','021','HLT','993933','52664OH151001305','2014-01-01','2013-12-05 12:11:47','228.00',NULL,NULL,'364.62','136.62','R-OH012','OH0','364.62',NULL,0,'2013-12-25 17:19:52'),(5599,4443,'N','01','021','EC','A',NULL,NULL,'','0000163099','0000003315','','IL','1','crochet','cheryl','','','','34','434153128','15081 chenal road',0,'Jarreau','LA','70749',NULL,NULL,NULL,'1957-08-04','F','',':RET:2106-3','N','021','DEN','1080882','18575LA002000201','2014-01-01','2013-11-26 12:32:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:30:12'),(20533,16407,'Y','18','021','EC','A','','','AC','0001152131','0001152131','MS00002179918','IL','1','Green','Rafael','','','','34','587534877','4539 meadowridge dr',0,'Jackson','MS','39206',NULL,'CY','28049','1986-02-22','M','U',':RET:2054-5','N','021','DEN','3020527','46300MS002000201','2014-03-01','2014-01-29 17:31:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-29 21:01:31'),(3750,3000,'Y','18','021','EC','A','','','AC','0001215443','0001215443','TX00000277877','IL','1','Ray','Mozell','','','','34','463259623','2812 LESTER ST',0,'TEXARKANA','TX','75501','4118','CY','48037','1960-07-16','F','M',NULL,'N','021','DEN','7671','33348TX002000201','2014-01-01','2013-12-13 15:25:18','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-25 21:33:08'),(2839,2294,'N','01','021','EC','A',NULL,NULL,'','0000486919','0001229279','','IL','1','Couch','Denise','C','','','34','297543694','7713 Shadowleaf Ln.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1954-07-08','F','',':RET:2106-3','N','021','DEN','70230','99734OH005000401','2014-01-01','2013-11-24 13:03:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:01:00'),(19933,15897,'Y','18','021','EC','A','','','AC','0000844730','0000844730','OH00001736775','IL','1','Stacy','Barbara','','','','34','274805257','223 E WATER ST',0,'DESHLER','OH','43516','1322','CY','39069','1969-06-05','F','U',':RET:2106-3','N','021','HLT','3370052','92036OH004002601','2014-03-01','2014-01-24 12:48:51','72.00',NULL,NULL,'219.04','147.04','R-OH001','OH0','219.04',NULL,0,'2014-01-24 21:01:10'),(21738,17358,'Y','18','021','EC','A','','','AC','0000484456','0000484456','TX00001992845','IL','1','Hurtado','Rachel','','','','34','638078585','1504 37th street',0,'Lubbock','TX','79412',NULL,'CY','48303','1984-12-10','F','M',':RET:2106-3','N','021','DEN','3622893','33348TX002000201','2014-03-01','2014-02-06 17:37:03','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-02-06 21:00:13'),(24771,19654,'Y','18','021','EC','A','','','AC','0000387336','0000387336','OH00002849396','IL','1','Troendly','Benjamin','','','','34','282888063','835 KENILWORTH AVE',0,'COSHOCTON','OH','43812','2367','CY','39031','1977-08-02','M','U',':RET:2106-3','N','021','DEN','3815789','99734OH005000401','2014-04-01','2014-02-19 11:52:35','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-20 04:44:15'),(27425,21704,'Y','18','021','EC','A','','','AC','0002126148','0002126148','LA00003311741','IL','1','TAYLOR','NICOLE','','','','34','433538897','204 E CLUB DR',0,'SAINT ROSE','LA','70087','3414','CY','22089','1972-01-22','F','U',NULL,'N','021','DEN','3991329','18575LA002000201','2014-04-01','2014-03-04 09:12:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:42'),(759,627,'Y','18','021','EC','A','','','AC','0000788442','0000788442','TX00000302654','IL','1','Titsworth','Matthew','','','','34','627261218','510 BEDFORD DR',0,'RICHARDSON','TX','75080','3317','CY','48113','1984-09-16','M','M',':RET:2106-3','N','021','DEN','2238895','33348TX002000201','2014-01-01','2013-12-16 11:11:28','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:04:31'),(21190,16934,'Y','18','021','EC','A','','','AC','0001124585','0001124585','MS00002183654','IL','1','Daniels','Allison','','','','34','426637697','4340 BLAINE CIR',0,'BYRAM','MS','39272','4474','CY','28049','1983-02-08','F','M',':RET:2106-3','N','021','DEN','3267716','46300MS002000101','2014-03-01','2014-02-03 12:39:39','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-03 21:00:47'),(21250,16981,'Y','18','024','14','A','','','TE','0000735019','0000735019','','IL','1','Chapman','Elizabeth','Lee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-07','F','',NULL,NULL,NULL,'','1972672','','2014-02-03','2014-02-03 10:25:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:17'),(26748,21197,'Y','18','021','EC','A','','','AC','0000172474','0000172474','OH00002527756','IL','1','SCACCIO','ROSETE','','','','34','291624221','417 STARR LINE DR',0,'TALLMADGE','OH','44278','1067','CY','39153','1964-12-18','F','R',':RET:2106-3','N','021','HLT','3005461','52664OH151001501','2014-04-01','2014-02-28 16:57:30','0.00',NULL,NULL,'456.30','456.30','R-OH012','OH0','456.30',NULL,0,'2014-02-28 21:31:57'),(27876,22051,'Y','18','021','EC','A','','','AC','0000333927','0000333927','OH00002599359','IL','1','KIESSLING','RICKEY','','','','34','279589485','1250 TUENDAWIE',0,'DESIANCE','OH','43512',NULL,'CY','39039','1955-07-01','M','M',':RET:2106-3','N','021','HLT','3853726','92036OH003002605','2014-04-01','2014-03-05 10:53:45','390.00',NULL,NULL,'518.85','128.85','R-OH001','OH0','518.85',NULL,0,'2014-03-05 21:32:29'),(28543,22590,'N','01','021','EC','A',NULL,NULL,'','0001248393','0000287167','','IL','1','Simmons','Dennis','','','','34','285688458','416 W PENNSYLVANIA AVE',0,'SEBRING','OH','44672','1141','CY','39099','1974-06-28','M','',':RET:2106-3','N','021','HLT','2770535','52664OH151001501','2014-04-01','2014-03-07 11:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.78',NULL,0,'2014-03-07 21:32:15'),(28575,22613,'N','01','021','EC','A',NULL,NULL,'','0000736304','0001151299','','IL','1','CANALES','DORA','GRACIELA','','','34','454373503','3209 CALLE TERESA',0,'EAGLE PASS','TX','78852','5670','CY','48323','1959-10-12','F','',NULL,'N','021','DEN','2941033','33348TX002000201','2014-04-01','2014-03-08 11:21:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-08 21:00:04'),(2156,1773,'Y','18','021','EC','A','','','AC','0000430495','0000430495','LA00000744720','IL','1','WHITTEN','BARRY','','','','34','435318870','1625 MITCHELL ST',0,'LAKE CHARLES','LA','70607','1943','CY','22019','1960-12-05','M','R',':RET:2106-3','N','021','DEN','450500','18575LA002000101','2014-01-01','2013-12-10 15:46:37','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2013-12-25 19:18:43'),(3496,2807,'Y','18','024','14','A','','','TE','0000229430','0000229430','','IL','1','Stephens','Hollie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-02-01','F','',NULL,NULL,NULL,'','1895075','','2013-12-22','2013-12-22 14:44:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:20:34'),(5094,4038,'Y','18','021','EC','A','','','AC','0000244595','0000244595','TX00000790918','IL','1','Bailey','Tucker','','','','34','627011925','204 LOCKLEAR AVE',0,'LONGVIEW','TX','75605','5416','CY','48183','1983-08-09','M','U',':RET:2106-3','N','021','DEN','2333346','33348TX002000201','2014-01-01','2013-12-19 15:31:53','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 23:01:17'),(4717,3740,'Y','18','021','EC','A','','','AC','0000968206','0000968206','OH00001154474','IL','1','Cooper','Barry','','','','34','298564971','536 CLEMRAY DR',0,'CINCINNATI','OH','45231','2763','CY','39061','1954-02-19','M','M',NULL,'N','021','HLT','31700','92036OH005001205','2014-01-01','2013-12-12 13:41:02','995.00',NULL,NULL,'1296.63','301.63','R-OH004','OH0','558.80',NULL,0,'2013-12-25 22:08:53'),(6841,5424,'Y','18','021','EC','A','','','AC','0000657010','0000657010','LA00000555923','IL','1','gillum','isiah','','','','34','438411622','1031 lamanche street',0,'new orleans','LA','70117',NULL,'CY','22071','1967-04-19','M','U',':RET:2054-5','N','021','DEN','1155450','18575LA002000201','2014-01-01','2013-11-14 07:40:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:31:06'),(18368,14661,'N','19','021','EC','A',NULL,NULL,'','0000948436','0001088285','','IL','1','Abou-Osman','Ali','Ahmad','','','34','269961978','4996 CANFIELD RD',0,'CANFIELD','OH','44406','9325','CY','39099','2002-08-16','M','',':RET:2106-3','N','021','DEN','1558565','99734OH005000301','2014-02-01','2014-01-15 10:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:29'),(7571,5992,'N','19','021','EC','A',NULL,NULL,'','0000996517','0001001142','','S1','1','Lee','Marc','','','','34','395332490','459 S WASHINGTON ST',0,'TIFFIN','OH','44883','3313','CY','39147','2011-01-26','F','',NULL,'N','021','HLT','140720','92036OH001002701','2014-01-01','2013-12-15 10:22:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','149.37',NULL,0,'2013-12-26 02:33:45'),(17175,13742,'N','01','021','EC','A',NULL,NULL,'','0000338890','0000106732','','IL','1','Weisel','Tamara','Jean','','','34','276684698','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1975-05-28','F','',':RET:2106-3','N','021','DEN','2412958','99734OH005000301','2014-02-01','2014-01-08 00:22:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:22:09'),(14703,11740,'Y','18','021','EC','A','','','AC','0000773986','0000773986','OH00000671645','IL','1','Lowry','John','','','','34','282487385','2339 ROYCE RD',0,'TOLEDO','OH','43615','2621','CY','39095','1950-03-02','M','M',':RET:2106-3','N','021','DEN','1897894','99734OH005000301','2014-02-01','2013-12-28 12:11:01','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,1,'2013-12-29 11:09:08'),(16761,13408,'N','01','021','EC','A',NULL,NULL,'','0000408497','0000221307','','IL','1','Corfman','Martha','','','','34','288583547','3074 ECHO HILLS RD',0,'AKRON','OH','44333','2132','CY','39153','1960-07-31','F','',':RET:2106-3','N','021','HLT','2097885','52664OH152000901','2014-02-01','2014-01-07 10:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','333.21',NULL,0,'2014-01-08 18:24:58'),(22304,17805,'N','19','021','EC','A',NULL,NULL,'','0000639555','0000435330','','S3','1','Chamberlain','David',NULL,NULL,NULL,NULL,NULL,'6104 DONNA JAY DR',0,'LOVELAND','OH','45140','8739','CY','39025','2009-09-08','F','',NULL,'N','021','DEN','2982394','99734OH005000301','2014-03-01','2014-01-25 13:36:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 11:00:39'),(25926,20560,'N','01','021','EC','A',NULL,NULL,'','0000823246','0001251951','','IL','1','Hurt','Joel','Wayne','','','34','463930677','326 Old Stadium Dr',0,'Port Isabel','TX','78578',NULL,'CY','48061','1972-08-06','M','',':RET:2106-3','N','021','DEN','2863720','33348TX002000201','2014-04-01','2014-02-26 16:07:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:23'),(20061,16000,'N','01','021','EC','A',NULL,NULL,'','0000490513','0000249401','','IL','1','Sadler','Angela','Renee','','','34','450830737','1604 GLENWICK DR',0,'PLANO','TX','75075','4201','CY','48085','1975-07-21','F','',':RET:2106-3','N','021','DEN','3169858','33348TX002000201','2014-03-01','2014-01-27 11:40:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-27 21:00:11'),(17691,14138,'Y','18','021','EC','A','','','AC','0001941251','0001941251','LA00001895212','IL','1','Luckett','Josh','','','','34','436479445','2545 MARTIN LUTHER KING JR BLVD',0,'NEW ORLEANS','LA','70113','2825','CY','22071','1982-08-08','M','R',':RET:2054-5','T','021','DEN','2465300','18575LA002000201','2014-02-01','2014-01-13 11:46:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:32:59'),(16904,13526,'Y','18','021','EC','A','','','AC','0000974108','0000974108','OH00001806975','IL','1','Crist','William','','','','34','288822490','129 W 1ST AVE',0,'COLUMBUS','OH','43201','3489','CY','39049','1984-07-25','M','U',':RET:2106-3','T','021','DEN','1425146','99734OH005000401','2014-02-01','2014-01-09 14:56:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:19:34'),(2787,2252,'Y','18','021','EC','A','','','AC','0000207093','0000207093','OH00000946833','IL','1','Swick','Garry',NULL,NULL,NULL,NULL,NULL,'142 23rd Street',0,'Toledo','OH','43604',NULL,'CY','39095','1954-06-20','M','U',':RET:2106-3','N','021','HLT','94346','92036OH004002601','2014-01-01','2013-12-02 16:19:35','0.00',NULL,NULL,'408.14','408.14','R-OH001','OH0','408.14',NULL,0,'2013-12-25 19:50:01'),(4601,3643,'Y','18','021','EC','A','','','AC','0001113123','0001113123','OH00000293622','IL','1','Pettit','Diane','','','','34','283600920','1381 W OHIO PIKE',0,'AMELIA','OH','45102','1340','CY','39025','1956-03-20','F','U',':RET:2106-3','N','021','HLT','268050','92036OH006000601','2014-01-01','2013-12-12 10:38:37','235.00',NULL,NULL,'414.90','179.90','R-OH005','OH0','414.90',NULL,0,'2013-12-25 22:05:43'),(21317,17034,'Y','18','021','EC','A','','','AC','0002087253','0002087253','LA00002216264','IL','1','Huete','Francis','','','','34','243571642','11 SPARROW LN',0,'RIVER RIDGE','LA','70123','2033','CY','22051','1987-12-19','M','U',':RET:2106-3','N','021','DEN','3761545','18575LA002000201','2014-03-01','2014-02-04 15:26:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:20'),(21907,17495,'Y','18','021','EC','A','','','AC','0000020256','0000020256','MS00001719690','IL','1','brown','gail','','','','34','470881558','184 harvey crossing',0,'canton','MS','39046',NULL,'CY','28089','1970-03-17','F','U',':RET:2054-5','N','021','DEN','3548481','46300MS002000101','2014-03-01','2014-02-06 16:17:55','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-06 21:01:51'),(24061,19134,'Y','18','021','EC','A','','','AC','0000270061','0000270061','OH00002172022','IL','1','phifer','kim','','','','34','269706296','2400 SAYBROOK RD',0,'UNIVERSITY HEIGHTS','OH','44118','3702','CY','39035','1967-08-17','F','M',NULL,'N','021','DEN','3367779','99734OH005000301','2014-03-01','2014-02-15 14:05:11','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:01:09'),(1202,989,'N','19','021','EC','A',NULL,NULL,'','0000571963','0000854166','','IL','1','Pielech','Matthew','A','','','34','274949688','435 W 48TH ST',0,'SHADYSIDE','OH','43947','1050','CY','39013','1991-05-23','M','',':RET:2106-3','N','021','DEN','1159487','99734OH005000301','2014-01-01','2013-12-03 03:54:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:54'),(16980,13590,'Y','18','021','EC','A','','','AC','0000570662','0000570662','MS00001358469','IL','1','GRIFFIN','ROGER','','','','34','587322480','14 PINE HILL DR',0,'NATCHEZ','MS','39120','8829','CY','28001','1950-09-17','M','U',NULL,'N','021','DEN','1517654','46300MS002000201','2014-02-01','2014-01-09 13:35:11','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-13 02:20:18'),(2239,1840,'Y','18','021','EC','A','','','AC','0000027873','0000027873','OH00001289224','IL','1','yates','tighe','','','','34','529799626','112 HIGH ST',0,'NEW LONDON','OH','44851','1119','CY','39077','1978-02-21','M','R',':RET:2106-3','T','021','HLT','1254209','92036OH002002701','2014-01-01','2013-12-10 16:19:03','0.00',NULL,NULL,'316.44','316.44','R-OH006','OH0','316.44',NULL,0,'2013-12-25 19:20:58'),(22740,18155,'Y','18','021','EC','A','','','AC','0001296212','0001296212','LA00001548969','IL','1','Imbornone','Gia','','','','34','435657828','28455 TWILIGHT DR',0,'PONCHATOULA','LA','70454','8452','CY','22105','1983-01-19','F','U',':RET:2106-3','N','021','DEN','2718141','18575LA002000201','2014-03-01','2014-02-11 16:54:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-11 21:01:19'),(26854,21285,'Y','18','021','EC','A','','','AC','0000658161','0000658161','MS00003395405','IL','1','Harper','Jillian','','','','34','587579164','1856 LINCOLNSHIRE BLVD',0,'RIDGELAND','MS','39157','1213','CY','28089','1986-06-26','F','U',':RET:2054-5','N','021','DEN','3446100','46300MS002000201','2014-04-01','2014-03-01 00:42:32','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-01 21:00:52'),(27451,21724,'Y','18','021','EC','A','','','AC','0000895778','0000895778','OH00003488465','IL','1','Downing','Benjamin','William','','','34','287884282','5390 PALMYRA RD SW',0,'WARREN','OH','44481','9785','CY','39155','1976-02-06','M','U',':RET:2106-3','T','021','HLT','3767010','52664OH151001501','2014-04-01','2014-03-04 16:57:05','84.00',NULL,NULL,'434.62','350.62','R-OH013','OH0','434.62',NULL,0,'2014-03-04 21:01:58'),(27833,22014,'Y','18','021','EC','A','','','AC','0001241927','0001241927','OH00002692372','IL','1','MCCOY','CONNIE','','','','34','276488594','3663 HARDSCRABBLE RD',0,'ALEXANDRIA','OH','43001','9794','CY','39089','1949-12-07','F','U',NULL,'T','021','DEN','3405172','99734OH005000301','2014-04-01','2014-03-05 11:02:35','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-05 21:32:02'),(28568,22607,'N','19','021','EC','A',NULL,NULL,'','0001026995','0001223238','','IL','1','HELMS','KARLIE','','','','34','286025344','3065 SWANEY RD',0,'HARROD','OH','45850','8420','CY','39003','1997-10-06','F','',NULL,'N','021','HLT','3838613','92036OH006001501','2014-04-01','2014-03-07 14:52:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-03-07 21:32:29'),(20228,16139,'Y','18','024','14','A','','','TE','0000071644','0000071644','','IL','1','MERUNSKI','KEN','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-11','M','',NULL,NULL,NULL,'','2107851','','2014-01-27','2014-01-27 15:45:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:49'),(3816,3056,'Y','18','021','EC','A','','','AC','0000930892','0000930892','OH00000335649','IL','1','Burkhart','Max','','','','34','289903512','10633 BRANDYWINE LN',0,'MONTGOMERY','OH','45242','3439','CY','39061','1959-06-07','M','R',NULL,'N','021','DEN','963481','99734OH005000301','2014-01-01','2013-12-13 14:22:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:49'),(5943,4707,'Y','18','021','EC','A','','','AC','0001293667','0001293667','LA00000214291','IL','1','Taylor','Michael','','','','34','436532274','3204 GALAXY DR',0,'BOSSIER CITY','LA','71112','3112','CY','22015','1973-05-29','M','U',NULL,'N','021','DEN','2506655','18575LA002000101','2014-01-01','2013-12-24 02:37:07','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 23:50:53'),(19197,15293,'N','01','021','EC','A',NULL,NULL,'','0000427340','0000908905','','IL','1','WADE','STACY','','','','34','453696531','2610 CODY CT',0,'MIDLOTHIAN','TX','76065',NULL,'CY','48139','1969-01-29','F','',NULL,'N','021','DEN','2105914','33348TX002000101','2014-03-01','2014-01-20 14:18:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-21 08:46:14'),(7067,5611,'N','01','021','EC','A',NULL,NULL,'','0000816435','0000910530','','IL','1','Chen','Yan Rong','','','','34','120748481','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1974-10-28','F','',':RET:2034-7','N','021','DEN','2566021','99734OH005000301','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:02'),(7129,5657,'N','19','021','EC','A',NULL,NULL,'','0000387281','0000911770','','IL','1','Bauer','Alyson','Leigh','','','34','281069748','870 Oak canyon Drive',0,'Loveland','OH','45140',NULL,'CY','39061','2000-10-20','F','',':RET:2106-3','N','021','HLT','2034375','92036OH005001204','2014-02-01','2013-12-25 00:45:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-26 01:51:34'),(18176,14512,'N','01','021','EC','A',NULL,NULL,'','0000808675','0000687233','','IL','1','EVES','SHARON','','','','34','297645736','54 VALLEY VIEW PL',0,'TIFFIN','OH','44883',NULL,'CY','39147','1958-01-28','F','',':RET:2106-3','N','021','HLT','1854279','92036OH005002705','2014-02-01','2014-01-14 12:25:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.92',NULL,0,'2014-01-15 02:07:59'),(13240,10565,'Y','18','021','EC','A','','','AC','0000062894','0000062894','TX00000430832','IL','1','DAWSON','HELEN','','','','34','461575053','202 E WOODLAND RD',0,'MARSHALL','TX','75672','7240','CY','48203','1967-03-27','F','M',NULL,'N','021','DEN','1471489','33348TX002000201','2014-01-01','2013-12-23 03:19:47','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:02'),(13601,10847,'N','01','021','EC','A',NULL,NULL,'','0000133313','0000809674','','IL','1','Runk','Megan','L','','','34','213043012','5468 N DIXIE HWY',0,'LIMA','OH','45807','9559','CY','39003','1969-09-05','F','',':RET:2106-3','N','021','HLT','1967024','92036OH003001504','2014-01-01','2013-12-23 13:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','321.08',NULL,0,'2013-12-26 13:05:25'),(17602,14070,'N','01','021','EC','A',NULL,NULL,'','0000983698','0000373193','','IL','1','Patel','Neeruben','H','','','34','628212993','2502 W FERGUSON RD',0,'MOUNT PLEASANT','TX','75455','2942','CY','48449','1962-05-18','F','',':RET:2029-7','N','021','DEN','2672002','33348TX002000201','2014-02-01','2014-01-12 19:20:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-14 01:32:16'),(16481,13190,'Y','18','021','EC','A','','','AC','0001032621','0001032621','OH00001259077','IL','1','Laurianti','Christopher','','','','34','298527159','8591 SHORTHORN DR',0,'SAGAMORE HILLS','OH','44067','3228','CY','39153','1956-12-29','M','M',NULL,'N','021','HLT','2422391','52664OH151001306','2014-02-01','2014-01-06 14:54:37','823.00',NULL,NULL,'959.38','136.38','R-OH012','OH0','543.47',NULL,0,'2014-01-07 04:06:16'),(17258,13808,'N','01','021','EC','A',NULL,NULL,'','0000515851','0000203102','','IL','1','SCHEIENNER','MAI','','','','34','586407205','30387 HILLIARD BLVD',0,'WESTLAKE','OH','44145','3715','CY','39035','1960-07-29','F','',NULL,'N','021','DEN','2460263','99734OH005000301','2014-02-01','2014-01-10 11:19:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:15'),(27109,21457,'N','19','021','EC','A',NULL,NULL,'','0000044327','0001138097','','S1','1','Mendoza','Cristina','','','','34','337068743','207 Rosemarie Dr',0,'Lebanon','OH','45036',NULL,'CY','39165','2005-05-17','F','',NULL,'N','021','DEN','3005502','99734OH005000301','2014-04-01','2014-03-03 10:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:25'),(27397,21689,'N','19','021','EC','A',NULL,NULL,'','0000214721','0000713689','','IL','1','Payne','Samantha','','','','34','287130813','328 Beech Street',0,'Green Camp','OH','43322',NULL,'CY','39101','2007-09-10','F','',':RET:2106-3','N','021','DEN','2955789','99734OH005000301','2014-04-01','2014-03-03 21:44:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:30'),(28449,22511,'Y','18','021','EC','A','','','AC','0002212068','0002212068','LA00003181537','IL','1','FONTENOT','MARY ELLEN','','','','34','439176872','6128 RIVER RD',0,'LAKE CHARLES','LA','70615','3505','CY','22019','1959-01-16','F','U',NULL,'T','021','DEN','3477671','18575LA002000201','2014-04-01','2014-03-07 10:57:35','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-07 21:31:19'),(511,417,'Y','18','021','EC','A','','','AC','0001044450','0001044450','OH00001092029','IL','1','Reynolds','Jennifer','','','','34','295806509','5921 Cedaridge Dr.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1983-10-06','F','M',':RET:2106-3','N','021','DEN','1027934','99734OH005000301','2014-01-01','2013-12-03 21:00:56','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:48:55'),(1061,869,'Y','18','021','EC','A','','','AC','0000004682','0000004682','OH00000344974','IL','1','breeden','kelly','','','','34','276845330','9010 LINDEN LAKE RD',0,'SYLVANIA','OH','43560','8961','CY','39095','1970-02-04','F','R',':RET:2106-3','N','021','HLT','1152911','92036OH003002601','2014-01-01','2013-12-02 18:49:32','0.00',NULL,NULL,'276.33','276.33','R-OH001','OH0','276.33',NULL,0,'2013-12-25 18:16:18'),(18271,14586,'Y','18','021','EC','A','','','AC','0000347577','0000347577','TX00002250314','IL','1','RINEHART','DENISE','MARCEIL','','','34','452025239','1019 BASS RD',0,'GARWOOD','TX','77442','4248','CY','48089','1954-05-07','F','M',':RET:2106-3','N','021','DEN','2741303','33348TX002000201','2014-02-01','2014-01-15 17:21:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:41'),(15942,12763,'Y','18','021','EC','A','','','AC','0000307108','0000307108','OH00001964750','IL','1','Martin','Mary','','','','34','277648196','2300 BULLE RD',0,'SIDNEY','OH','45365','9442','CY','39149','1959-12-22','F','M',':RET:2106-3','N','021','HLT','2349497','92036OH005000506','2014-02-01','2014-01-02 09:31:11','1042.00',NULL,NULL,'1126.27','84.27','R-OH003','OH0','507.51',NULL,0,'2014-01-03 02:07:14'),(9380,7438,'Y','18','021','EC','A','','','AC','0001809807','0001809807','LA00001106044','31','1','Brown','Patrick','','','','34','438068130','PO BOX 1513',0,'Hammon','LA','70404',NULL,'CY','22105','1969-10-31','M','U',':RET:2054-5','N','021','DEN','1503286','18575LA002000201','2014-01-01','2013-12-21 17:19:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:32:04'),(24247,19253,'Y','18','021','EC','A','','','AC','0000426488','0000426488','OH00002968727','IL','1','leal','alfredo','','','','34','107748889','223 LOWELL AVE',0,'YOUNGSTOWN','OH','44512','1230','CY','39099','1968-08-15','M','U',NULL,'N','021','HLT','3539254','92036OH005003206','2014-04-01','2014-02-16 14:10:35','261.00',NULL,NULL,'349.53','88.53','R-OH013','OH0','349.53',NULL,0,'2014-02-16 19:00:42'),(26532,21040,'Y','18','021','EC','A','','','AC','0000273849','0000273849','OH00002864517','IL','1','Robinson','Thelsherr','','','','34','293643818','844 Ashburton Rd',0,'Columbus','OH','43227',NULL,'CY','39049','1969-04-09','F','U',':RET:2054-5','N','021','DEN','2635297','99734OH005000301','2014-03-01','2014-02-27 18:02:08','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:03'),(378,313,'N','01','021','EC','A',NULL,NULL,'','0000151570','0001125806','','IL','1','Londoff','Donna','Thaden','','','34','466231012','14773 COUNTY ROAD 1125',0,'TYLER','TX','75703','6707','CY','48423','1957-11-11','F','',':RET:2106-3','N','021','DEN','813250','33348TX002000201','2014-01-01','2013-12-03 23:35:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 17:45:37'),(26467,20994,'Y','18','021','EC','A','','','AC','0000428999','0000428999','OH00003159687','31','1','Bencar','Chris','','','','34','272909722','PO Box 593',0,'GENEVA','OH','44041',NULL,'CY','39007','1988-11-18','M','U',':RET:2106-3','N','021','HLT','3081396','52664OH152001001','2014-03-01','2014-02-27 13:06:26','0.00',NULL,NULL,'138.84','138.84','R-OH011','OH0','138.84','CIC',0,'2014-02-28 07:30:35'),(28592,22627,'Y','18','021','EC','A','','','AC','0000053120','0000053120','OH00003498782','IL','1','WILLIAMS','ANDRE','','','','34','275704130','2614 OBSERVATORY AVE',0,'CINCINATTI','OH','45208',NULL,'CY','39061','1975-07-17','M','U',':RET:2054-5','N','021','DEN','3638117','99734OH005000401','2014-04-01','2014-03-07 22:10:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-08 21:30:03'),(21510,17185,'Y','18','021','EC','A','','','AC','0000038423','0000038423','OH00002368497','IL','1','Underwood','Natasha','','','','34','574981806','215 E HIGH ST',0,'PIQUA','OH','45356','2486','CY','39109','1988-06-05','F','U',':RET:2106-3','N','021','HLT','3753994','92036OH004000501','2014-03-01','2014-02-04 16:00:58','161.00',NULL,NULL,'191.91','30.91','R-OH003','OH0','191.91',NULL,0,'2014-02-04 21:01:57'),(18796,14970,'N','19','021','EC','A',NULL,NULL,'','0000298257','0000777694','','IL','1','Huynh','Benjamin','','','','34','272083275','1250 WINFREE DR',0,'WESTERVILLE','OH','43081','3773','CY','39049','2002-10-05','M','',':RET:2047-9','N','021','DEN','1461272','99734OH005000401','2014-03-01','2014-01-16 10:20:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:58'),(17906,14302,'Y','18','021','EC','A','','','AC','0001247916','0001247916','TX00001932231','IL','1','KNOTT','SHEILA','S','','','34','452216663','3603 Rejillas',0,'San Antonio','TX','78228',NULL,'CY','48029','1959-05-04','F','U',':RET:2106-3','N','021','DEN','1627799','33348TX002000201','2014-02-01','2014-01-13 18:59:43','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:25'),(16073,12872,'Y','18','021','EC','A','','','AC','0000765986','0000765986','OH00001996002','IL','1','Panchal','Nikul','M','','','34','407613492','9886 HUMPHREY RD',0,'CINCINNATI','OH','45242','5445','CY','39061','1987-11-21','M','U',':RET:2029-7','N','021','DEN','2297706','99734OH005000401','2014-02-01','2014-01-03 12:38:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:52'),(3337,2675,'Y','18','021','EC','A','','','AC','0000835178','0000835178','TX00000252602','IL','1','Mack','Ronnie','Eugene','','','34','463238782','6628 JOLLYN CT',0,'DALLAS','TX','75241','3700','CY','48113','1966-09-01','M','U',':RET:2054-5','N','021','DEN','1623142','33348TX002000201','2014-01-01','2013-12-21 18:29:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:16:24'),(1808,1486,'Y','18','024','14','A','','','TE','0000171215','0000171215','','IL','1','Gradomski','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-09-22','F','',NULL,NULL,NULL,'','507618','','2013-12-24','2013-12-24 10:34:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:56:57'),(5596,4441,'Y','18','021','EC','A','','','AC','0000463248','0000463248','LA00000621919','IL','1','Oettli','Albert','R','','','34','434841333','821 N HOWARD AVE',0,'METAIRIE','LA','70003','6317','CY','22051','1949-05-02','M','U',':RET:2106-3','N','021','DEN','984524','18575LA002000201','2014-01-01','2013-11-25 19:38:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:30:07'),(3924,3141,'Y','18','021','EC','A','','','AC','0000058738','0000058738','OH00001155942','IL','1','MANUEL','RHONDA','RAE','','','34','270542591','7292 FAIR RIDGE RD',0,'HILLSBORO','OH','45133','6677','CY','39071','1951-07-25','F','M',':RET:2106-3','N','021','HLT','442343','92036OH001000601','2014-01-01','2013-12-13 16:12:49','1039.00',NULL,NULL,'1446.68','407.68','R-OH005','OH0','743.93',NULL,0,'2013-12-25 21:37:26'),(26809,21245,'Y','18','021','EC','A','','','AC','0000905647','0000905647','OH00002440628','IL','1','Stolfo','Paul','','','','34','284520918','1660 BREIDING RD',0,'AKRON','OH','44310','2635','CY','39153','1951-07-18','M','U',':RET:2106-3','N','021','DEN','3405031','99734OH005000301','2014-04-01','2014-03-01 13:46:05','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-01 21:00:27'),(49,44,'Y','18','021','EC','A','','','AC','0000099191','0000099191','MS00000541192','IL','1','Vaughn','Norma','','','','34','457235850','11387 GOULD RD',0,'GULFPORT','MS','39503','5626','CY','28047','1958-04-08','F','U',':RET:2106-3','T','021','DEN','131425','46300MS002000101','2014-01-01','2013-12-05 15:45:05','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 17:16:20'),(1653,1381,'Y','18','021','EC','A','','','AC','0000889708','0000889708','TX00000844351','IL','1','Lopez','Maria','S','','','34','459590952','2905 Fierro Dr',0,'El Paso','TX','79935',NULL,'CY','48141','1962-05-24','F','M',':RET:2106-3','T','021','DEN','1475445','33348TX002000201','2014-01-01','2013-12-24 16:38:48','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:53:24'),(18954,15101,'N','01','021','EC','A',NULL,NULL,'','0000941761','0000269129','','IL','1','Ha','Henry','','','','34','602385514','13631 SPRING POINT VW',0,'HOUSTON','TX','77083','6541','CY','48201','1970-04-26','M','',NULL,'N','021','DEN','1665655','33348TX002000201','2014-03-01','2014-01-17 17:49:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-20 08:05:51'),(15249,12188,'N','19','021','EC','A',NULL,NULL,'','0000627884','0000362509','','IL','1','nicholas','lindsay','','','','34','296046216','206 n lincoln st',0,'christiansbrg','OH','45389',NULL,'CY','39021','2000-04-19','F','',':RET:2106-3','N','021','HLT','1411810','92036OH003000505','2014-02-01','2013-12-30 11:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.64',NULL,0,'2014-01-01 12:08:54'),(7190,5699,'Y','18','021','EC','A','','','AC','0000714953','0000714953','OH00000521253','IL','1','Escribano','Giovanny','','','','34','597204898','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1974-01-28','M','R',':RET:2106-3','N','021','DEN','166636','99734OH005000301','2014-01-01','2013-12-14 13:07:41','0.00',NULL,NULL,'87.78','87.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:00:25'),(6661,5284,'Y','18','021','EC','A','','','AC','0000764637','0000764637','TX00001096893','IL','1','Gazzaway','Ofeira','','','','34','575925207','108 KELLEY BLVD',0,'WOODVILLE','TX','75979','4712','CY','48457','1956-10-05','F','M',':RET:2080-0','N','021','DEN','550330','33348TX002000201','2014-01-01','2013-11-15 20:55:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:00:52'),(15174,12126,'Y','18','024','14','A','','','TE','0000141522','0000141522','','IL','1','FESTAGALLO','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-05-25','F','',NULL,NULL,NULL,'','2490723','','2013-12-30','2013-12-30 16:12:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:40'),(6175,4893,'N','01','021','EC','A',NULL,NULL,'','0000009809','0000011115','','IL','1','Higham','Marilyn','','','','34','299724779','4429 Robinson Rd',0,'Hillsboro','OH','45133',NULL,'CY','39071','1962-11-06','F','',NULL,'T','021','DEN','105089','99734OH005000301','2014-01-01','2013-10-02 07:22:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:17:09'),(2089,1710,'Y','18','021','EC','A','','','AC','0000176635','0000176635','LA00000029858','IL','1','Theriot','Rhonda','','','','34','436352560','63182 PIGOTT CROSSING RD',0,'BOGALUSA','LA','70427',NULL,'CY','22117','1965-08-22','F','U',NULL,'N','021','DEN','532383','18575LA002000201','2014-01-01','2013-12-10 16:31:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:49'),(4446,3533,'Y','18','021','EC','A','','','AC','0000239017','0000239017','OH00000886681','IL','1','Baker','Tammy','','','','34','276665357','217 Inwood St.',0,'Zanesville','OH','43701',NULL,'CY','39119','1959-03-26','F','U',':RET:2106-3','N','021','DEN','275510','99734OH005000301','2014-01-01','2013-12-12 08:32:47','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:02:16'),(8953,7101,'Y','18','021','EC','A','','','AC','0001104429','0001104429','OH00000282712','IL','1','Caul','Robert','','','','34','281507036','5375 PLEASANT HILL RD',0,'ATHENS','OH','45701','9577','CY','39009','1953-02-07','M','U',':RET:2106-3','N','021','DEN','1510318','99734OH005000401','2014-01-01','2013-12-18 12:21:03','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 04:03:38'),(5419,4301,'Y','18','021','EC','A','','','AC','0000510722','0000510722','MS00001232372','IL','1','Walker','Thomas','','','','34','587599470','153 STONEGATE DR',0,'MADISON','MS','39110','8720','CY','28089','1987-10-23','M','U',':RET:2106-3','N','021','DEN','1984714','46300MS002000201','2014-01-01','2013-12-19 00:04:17','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:09:21'),(29018,22967,'Y','18','021','EC','A','','','AC','0000964676','0000964676','OH00003134789','IL','1','TONYA','TERESA','','','','34','280685251','719 LOCKWOOD RD',0,'BARBERTON','OH','44203','4527','CY','39153','1959-07-05','F','M',NULL,'N','021','DEN','4206808','99734OH005000401','2014-04-01','2014-03-10 09:01:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:01:28'),(23963,19053,'N','19','021','EC','A',NULL,NULL,'','0000019033','0000845931','','IL','1','Martin','Ellison','Leticia','','','34','640047489','1101 KAREN AVE',0,'AUSTIN','TX','78757','3013','CY','48453','2006-08-16','F','',NULL,'N','021','DEN','2703305','33348TX002000101','2014-03-01','2014-02-15 13:45:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-02-15 22:00:10'),(13856,11056,'Y','18','021','EC','A','','','AC','0000321041','0000321041','OH00000882446','IL','1','Hamilton','Josh','','','','34','155626097','206 SENTRY HILL DR',0,'LOVELAND','OH','45140','6657','CY','39165','1976-01-18','M','U',':RET:2106-3','N','021','HLT','2544855','92036OH006001201','2014-01-01','2013-12-23 10:29:46','166.00',NULL,NULL,'210.76','44.76','R-OH004','OH0','210.76',NULL,0,'2013-12-26 13:12:41'),(2064,1689,'Y','18','021','EC','A','','','AC','0001245575','0001245575','OH00000167838','IL','1','Nelson','John','','','','34','301804575','1408 FORESTER DR',0,'CINCINNATI','OH','45240','1104','CY','39061','1983-03-23','M','U',':RET:2106-3','T','021','DEN','383112','99734OH005000301','2014-01-01','2013-12-10 15:45:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:16:11'),(16473,13182,'Y','18','021','EC','A','','','AC','0000091163','0000091163','OH00002377945','IL','1','Pedro','Dennis','','','','34','270507110','2558 FLICKINGER HILL RD',0,'WOOSTER','OH','44691','8514','CY','39169','1950-12-05','M','M',':RET:2106-3','N','021','HLT','2536368','52664OH151001305','2014-02-01','2014-01-06 16:20:04','471.00',NULL,NULL,'658.32','187.32','R-OH014','OH0','658.32',NULL,0,'2014-01-07 04:06:01'),(2513,2048,'Y','18','021','EC','A','','','AC','0001034826','0001034826','MS00001275043','IL','1','Valentine','Luanne','','','','34','414040363','743 HAINES RD',0,'IUKA','MS','38852','9325','CY','28141','1958-04-08','F','U',':RET:2106-3','T','021','DEN','85663','46300MS002000101','2014-01-01','2013-12-09 10:48:40','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 19:36:21'),(6238,4944,'N','01','021','EC','A',NULL,NULL,'','0001153720','0000465584','','IL','1','VALERIO','DOLORES','M','','','34','462192310','3320 1ST PL',0,'LUBBOCK','TX','79415','2510','CY','48303','1957-08-03','F','',NULL,'N','021','DEN','780056','33348TX002000201','2014-01-01','2013-11-19 12:52:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:31:37'),(25258,20037,'Y','18','021','EC','A','','','AC','0000100118','0000100118','OH00002511788','IL','1','Chambers','Richard','','','','34','279504115','130 N ROSE BLVD',0,'AKRON','OH','44302','1032','CY','39153','1952-03-01','M','U',':RET:2054-5','N','021','HLT','3110355','52664OH151001301','2014-04-01','2014-02-21 18:30:10','0.00',NULL,NULL,'640.70','640.70','R-OH012','OH0','640.70','CIC',0,'2014-02-22 19:00:11'),(25442,20187,'Y','18','021','EC','A','','','AC','0000521748','0000521748','TX00003215301','IL','1','SALGADO','MARIBEL','','','','34','644721017','541 CIRUELA DR',0,'BROWNSVILLE','TX','78521',NULL,'CY','48061','1972-05-25','F','M',NULL,'N','021','DEN','2903743','33348TX002000201','2014-04-01','2014-02-25 11:46:15','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-02-25 21:31:21'),(26311,20875,'Y','18','021','EC','A','','','AC','0001025948','0001025948','TX00002985472','IL','1','Garza','Rosa','','','','34','449797384','411 Lozano Street',0,'Harlingen','TX','78552',NULL,'CY','48061','1968-09-09','F','U',':RET:2106-3','N','021','DEN','3658458','33348TX002000101','2014-04-01','2014-02-27 15:07:54','0.00',NULL,NULL,'25.02','25.02','R-TX005','TX0','25.02',NULL,0,'2014-02-28 06:31:33'),(27916,22085,'Y','18','021','EC','A','','','AC','0000248355','0000248355','TX00002750424','IL','1','ALVARADO','JESUS','','','','34','593709947','3045 YASMEEN CIR',0,'FLINT','TX','75762','6734','CY','48423','1969-04-20','M','M',NULL,'N','021','DEN','3758819','33348TX002000201','2014-04-01','2014-03-05 21:56:51','0.00',NULL,NULL,'105.66','105.66','R-TX022','TX0','14.61',NULL,0,'2014-03-06 21:00:18'),(27924,22088,'Y','18','021','EC','A','','','AC','0000891301','0000891301','TX00002667102','IL','1','Obale','Michelle','','','','34','432953495','7211 Foxbrick lane',0,'Humble','TX','77338',NULL,'CY','48201','1978-01-16','F','R',':RET:2054-5','N','021','DEN','3832135','33348TX002000201','2014-04-01','2014-03-05 23:12:47','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-06 21:00:21'),(109,96,'Y','18','021','EC','A','','','AC','0001194065','0001194065','TX00000342645','IL','1','Stillson','Sarah','Christine','','','34','453950186','4604 MELODY LN',0,'WICHITA FALLS','TX','76302','2906','CY','48485','1987-03-25','F','U',NULL,'N','021','DEN','513416','33348TX002000201','2014-01-01','2013-12-05 11:52:45','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 17:17:55'),(21672,17307,'N','19','021','EC','A',NULL,NULL,'','0001640013','0002106179','','IL','1','Francios','Brittani','','','','34','435739508','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1988-07-28','F','',NULL,'N','021','DEN','2853811','18575LA002000201','2014-03-01','2014-02-05 16:15:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:30:59'),(20794,16614,'N','01','021','EC','A',NULL,NULL,'','0000381648','0001182521','','IL','1','LE','LOAN','','','','34','204767503','4844 FM 39 N',0,'MEXIA','TX','76667','5022','CY','48293','1970-04-01','F','',':RET:2047-9','N','021','DEN','1990797','33348TX002000201','2014-03-01','2014-01-31 10:45:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-31 21:00:17'),(18552,14795,'Y','18','021','EC','A','','','AC','0000331208','0000331208','MS00002108898','IL','1','tims','albert','','','','34','428415380','309 pine st',0,'lumberton','MS','39455',NULL,'CY','28073','1971-07-22','M','M',':RET:2106-3','N','021','DEN','2770660','46300MS002000101','2014-02-01','2014-01-15 15:57:02','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,0,'2014-01-16 08:46:54'),(17655,14110,'Y','18','021','EC','A','','','AC','0000596299','0000596299','OH00002476749','IL','1','Loudermilk','Mark','A','','','34','279725056','10767 CHILLICOTHE PIKE',0,'JACKSON','OH','45640','8746','CY','39079','1963-04-04','M','U',NULL,'N','021','DEN','2266556','99734OH005000301','2014-02-01','2014-01-13 12:43:45','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-14 01:32:42'),(14815,11834,'Y','18','021','EC','A','','','AC','0000948415','0000948415','OH00001153717','IL','1','Herrin','Susan','K','','','34','299603824','133 BOURBON ST',0,'BLANCHESTER','OH','45107','1467','CY','39027','1962-08-30','F','M',':RET:2106-3','T','021','HLT','2315685','92036OH001000601','2014-01-01','2013-12-23 20:50:42','601.00',NULL,NULL,'1132.82','531.82','R-OH005','OH0','555.38',NULL,1,'2013-12-29 11:14:11'),(23004,18339,'Y','18','024','14','A','','','TE','0000408509','0000408509','','IL','1','BEASLEY','SUSAN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-08','F','',NULL,NULL,NULL,'','3800714','','2014-02-12','2014-02-12 14:41:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:30:20'),(17047,13640,'Y','18','021','EC','A','','','AC','0000401260','0000401260','OH00002383291','IL','1','brittain','susan','','','','34','296504511','904 e smith rd',0,'medina','OH','44256',NULL,'CY','39103','1950-07-01','F','M',':RET:2106-3','N','021','HLT','2522611','52664OH151001501','2014-02-01','2014-01-09 13:55:24','350.00',NULL,NULL,'789.56','439.56','R-OH012','OH0','789.56',NULL,0,'2014-01-13 02:20:55'),(17147,13720,'N','01','021','EC','A',NULL,NULL,'','0001185719','0001705662','','IL','1','Schillage','Shannon','Michelle','','','34','437236114','17366 Grove St.',0,'Walker','LA','70785',NULL,'CY','22063','1966-12-21','F','',':RET:1002-5','N','021','DEN','1454560','18575LA002000201','2014-02-01','2014-01-07 20:21:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:21:55'),(25759,20431,'N','01','021','EC','A',NULL,NULL,'','0000988938','0000337650','','IL','1','Lehman','Susan','G','','','34','268687443','5677 SALEM RD',0,'CINCINNATI','OH','45230','2721','CY','39061','1959-09-14','F','',':RET:2106-3','N','021','HLT','3526941','92036OH002001201','2014-04-01','2014-02-24 07:14:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','529.28',NULL,0,'2014-02-26 09:30:50'),(26678,21151,'Y','18','021','EC','A','','','AC','0001985996','0001985996','LA00003405951','IL','1','GRAY','MARILYN','','','','34','435319925','312 CHESTER ST',0,'ALEXANDRIA','LA','71301',NULL,'CY','22079','1961-10-12','F','U',NULL,'N','021','DEN','3022284','18575LA002000201','2014-04-01','2014-02-28 13:13:19','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-28 21:31:21'),(26912,21329,'N','19','021','EC','A',NULL,NULL,'','0001620090','0001800802','','IL','1','Ghashghaee','Sean','','','','34','433791861','59655 Highway 1148 Lot 180',0,'Plaquemine','LA','70764',NULL,'CY','22047','1990-02-13','M','',':RET:2106-3','N','021','DEN','3511496','18575LA002000201','2014-04-01','2014-03-02 16:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-03 01:00:12'),(24181,19210,'Y','18','021','EC','A','','','AC','0000570607','0000570607','OH00002360061','IL','1','Kendall','Carolyn','May','','','34','291845808','1383 BUCKINGHAM GATE BLVD',0,'CUYAHOGA FALLS','OH','44221','5394','CY','39153','1980-06-11','F','U',':RET:2106-3','N','021','HLT','3347339','52664OH151001306','2014-03-01','2014-02-15 18:13:37','219.00',NULL,NULL,'267.16','48.16','R-OH012','OH0','267.16',NULL,0,'2014-02-16 19:00:07'),(22403,17888,'Y','18','021','EC','A','','','AC','0001021509','0001021509','OH00001901080','IL','1','Morlan','Carl','Edward','','','34','301460455','1261 CARNEGIE AVE',0,'AKRON','OH','44314','1151','CY','39153','1949-11-02','M','M',':RET:2106-3','T','021','HLT','3410397','52664OH151001306','2014-03-01','2014-02-10 16:44:35','1118.00',NULL,NULL,'1538.70','420.70','R-OH012','OH0','769.35',NULL,0,'2014-02-10 21:30:21'),(5321,4219,'Y','18','021','EC','A','','','AC','0000865848','0000865848','OH00000048112','IL','1','searles','tenerina','','','','34','281488642','5860 RANLYN AVE',0,'CINCINNATI','OH','45239','6314','CY','39061','1965-07-08','F','U',':RET:2106-3','T','021','DEN','2524070','99734OH005000301','2014-01-01','2013-12-18 23:40:43','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:06:49'),(7997,6329,'Y','18','021','EC','A','','','AC','0000752069','0000752069','OH00000779882','IL','1','Reiman','Robert','L','','','34','273482782','369 Northcoast Pointe Dr.',0,'Eastlake','OH','44095',NULL,'CY','39085','1949-09-24','M','M',':RET:2106-3','N','021','HLT','1882938','52664OH151001301','2014-01-01','2013-12-20 15:45:34','150.00',NULL,NULL,'754.54','604.54','R-OH011','OH0','754.54',NULL,0,'2013-12-26 03:08:18'),(20097,16034,'Y','18','024','14','A','','','TE','0001415026','0001415026','','IL','1','mayfield','william',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-11-22','M','',NULL,NULL,NULL,'','2607043','','2014-01-27','2014-01-27 11:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:33'),(7515,5946,'Y','18','021','EC','A','','','AC','0000928584','0000928584','LA00000931963','IL','1','Harris','Shannon','','','','34','428593465','1513 S MEADOW LN',0,'LAKE CHARLES','LA','70605','5333','CY','22019','1975-11-26','M','M',':RET:2106-3','N','021','DEN','129396','18575LA002000201','2014-01-01','2013-12-15 12:36:17','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 02:32:13'),(6998,5554,'Y','18','021','EC','A','','','AC','0000917441','0000917441','TX00000120558','IL','1','Stowell','Tiffany','','','','34','570399970','5050 Ambassador Way',0,'Houston','TX','77056',NULL,'CY','48201','1965-05-26','F','R',':RET:2106-3','N','021','DEN','2009499','33348TX002000201','2014-01-01','2013-12-24 18:46:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:48:11'),(15646,12516,'Y','18','021','EC','A','','','AC','0000943373','0000943373','MS00001393987','31','1','Henderson','Virginia','','','','34','587766819','PO Box 376',0,'Raymond','MS','39154',NULL,'CY','28049','1955-08-08','F','U',':RET:2054-5','N','021','DEN','2474406','46300MS002000201','2014-02-01','2013-12-31 12:18:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2014-01-02 04:33:57'),(19442,15497,'Y','18','021','EC','A','','','AC','0000740308','0000740308','OH00002398814','IL','1','JACKSON','SHAMECA','','','','34','345827395','2915 W TOWER AVE',0,'CINCINNATI','OH','45238','2517','CY','39061','1988-01-07','F','U',':RET:2054-5','N','021','DEN','2405849','99734OH005000301','2014-03-01','2014-01-21 19:01:36','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:01:49'),(28136,22265,'Y','18','021','EC','A','','','AC','0001163901','0001163901','OH00002654848','IL','1','DEMARCO','BROOKS','','','','34','279504093','995 EAST TALLMADGE AVE.',0,'AKRON','OH','44310',NULL,'CY','39153','1956-10-16','M','U',':RET:2106-3','N','021','HLT','3843972','52664OH151001304','2014-04-01','2014-03-06 16:26:23','349.00',NULL,NULL,'543.47','194.47','R-OH012','OH0','543.47',NULL,0,'2014-03-06 21:02:27'),(28255,22357,'Y','18','021','EC','A','','','AC','0001165333','0001165333','OH00003795437','IL','1','Mann','Corey','','','','34','295740136','1128 STONE DR',0,'HARRISON','OH','45030','1652','CY','39061','1963-10-03','M','U',':RET:2106-3','T','021','DEN','3548140','99734OH005000301','2014-04-01','2014-03-06 18:41:53','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00','CIC',0,'2014-03-07 21:00:15'),(24319,19313,'N','01','021','EC','A',NULL,NULL,'','0001075649','0001052427','','IL','1','Ortega','Beverly','Kay','','','34','459277454','19402 Velvet Shadow Court',0,'Tomball','TX','77375',NULL,'CY','48201','1960-10-25','F','',':RET:2106-3','T','021','DEN','2797811','33348TX002000201','2014-04-01','2014-02-18 10:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-18 22:00:07'),(23074,18398,'Y','18','021','EC','A','','','AC','0001284884','0001284884','LA00002756105','31','1','LEE','Frances','','','','34','437062524','PO Box 367',0,'MANSFIELD','LA','71052',NULL,'CY','22031','1953-02-15','F','M',':RET:2054-5','N','021','DEN','2869341','18575LA002000201','2014-03-01','2014-02-12 14:56:53','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-02-12 21:30:59'),(457,373,'Y','18','021','EC','A','','','AC','0000235178','0000235178','OH00000935193','IL','1','Mezger','Roger','John','','','34','285485495','346 DORCHESTER RD',0,'AKRON','OH','44320','1352','CY','39153','1950-01-06','M','M',NULL,'N','021','HLT','34618','52664OH151001301','2014-01-01','2013-12-03 18:40:23','0.00',NULL,NULL,'658.32','658.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 17:47:31'),(8917,7072,'Y','18','021','EC','A','','','AC','0000767386','0000767386','OH00000182179','IL','1','Turner','Nicole','Renee','','','34','301805693','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','1970-12-01','F','U',NULL,'N','021','DEN','1914082','99734OH005000401','2014-01-01','2013-12-18 05:39:13','0.00',NULL,NULL,'50.05','50.05','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:02:43'),(3245,2615,'Y','18','021','EC','A','','','AC','0000089793','0000089793','OH00000872364','IL','1','koshin','awes','','','','34','611847422','3355 Thornapple Cirrcle N',0,'Columbus','OH','43231',NULL,'CY','39049','1967-02-02','M','M',':RET:2054-5','N','021','DEN','1055813','99734OH005000401','2014-01-01','2013-11-27 19:19:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:46:28'),(21357,17069,'Y','18','021','EC','A','','','AC','0000319445','0000319445','TX00001718172','IL','1','Crider','Meagan','','','','34','457977105','1034 COUNTY ROAD 4371',0,'DECATUR','TX','76234','5126','CY','48497','1986-10-13','F','M',':RET:2106-3','N','021','DEN','3096921','33348TX002000201','2014-03-01','2014-02-04 13:59:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-04 21:00:41'),(19098,15216,'Y','18','021','EC','A','','','AC','0001163379','0001163379','LA00002402220','IL','1','HEHOLT','DAVID','','','','34','561456452','2553 COURT STREET',0,'PORT ALLEN','LA','70767',NULL,'CY','22121','1961-12-09','M','M',NULL,'N','021','DEN','1683024','18575LA002000201','2014-03-01','2014-01-18 09:55:57','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:44:37'),(16451,13164,'Y','18','021','EC','A','','','AC','0000928364','0000928364','MS00002272266','31','1','Roberson','Annie','M','','','34','337507053','PO Box 762',0,'Quitman','MS','39355',NULL,'CY','28023','1955-01-13','F','U',NULL,'N','021','DEN','1763473','46300MS002000101','2014-02-01','2014-01-06 14:48:25','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-07 04:05:24'),(23615,18808,'N','01','021','EC','A',NULL,NULL,'','0000703826','0000565587','','IL','1','VELASQUEZ','LETISIA','','','','34','268663380','494 CLEVELAND AVE',0,'DEFIANCE','OH','43512','3517','CY','39039','1957-12-27','F','',NULL,'N','021','HLT','3642228','92036OH002002601','2014-03-01','2014-02-13 14:37:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','525.35',NULL,0,'2014-02-13 22:03:14'),(21244,16975,'Y','18','021','EC','A','','','AC','0000374734','0000374734','OH00002204794','S3','1','Jones','Courtney','V','','','34','275119450','10234 Johnny Cake Ridge Rd',0,'Painesville','OH','44077',NULL,'CY','39085','2005-02-07','M','U',':RET:2106-3','N','021','DEN','2652864','99734OH005000301','2014-03-01','2014-02-03 14:53:06','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2014-02-03 21:01:14'),(8084,6400,'Y','18','024','14','A','','','TE','0000390864','0000390864','','IL','1','Romer','Georgia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-08-26','F','',NULL,NULL,NULL,'','82866','','2013-12-20','2013-12-20 15:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:29'),(3093,2485,'N','01','021','EC','A',NULL,NULL,'','0001081774','0000712495','','IL','1','COPSEY','TERRY','','','Sr','34','270487000','3942 GREENWICH MILAN TOWNLINE RD',0,'GREENWICH','OH','44837','9437','CY','39077','1955-12-10','M','',':RET:2106-3','T','021','HLT','1002607','92036OH005002706','2014-01-01','2013-12-06 07:49:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','571.36',NULL,0,'2013-12-25 20:20:03'),(24923,19763,'Y','18','024','14','A','','','TE','0000468854','0000468854','','IL','1','hathcox','stacy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-01','F','',NULL,NULL,NULL,'','2743198','','2014-03-31','2014-02-20 14:00:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-20 21:30:15'),(28277,22377,'Y','18','024','14','A','','','TE','0000500463','0000500463','','IL','1','Cunningham','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-08-13','M','',NULL,NULL,NULL,'','3116203','','2014-03-07','2014-03-07 09:32:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:24'),(15396,12315,'N','19','021','EC','A',NULL,NULL,'','0000771447','0001110370','','IL','1','tone','breanna','l',NULL,NULL,NULL,NULL,'173 S FAIRFIELD ST',0,'LEESBURG','OH','45135','9262','CY','39071','2002-01-16','F','',':RET:2106-3','N','021','HLT','2215975','92036OH006000601','2014-02-01','2014-01-01 17:55:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,1,'2014-01-02 04:25:52'),(2046,1676,'Y','18','021','EC','A','','','AC','0000396010','0000396010','TX00000651482','IL','1','FERNANDEZ','EUSTACIA','T','','','34','453338344','711 S COUNTY RD W',0,'ODESSA','TX','79763','4805','CY','48135','1949-01-22','F','U',NULL,'N','021','DEN','650384','33348TX002000201','2014-01-01','2013-12-10 13:47:37','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-25 19:15:43'),(15386,12308,'Y','18','021','EC','A','','','AC','0000903245','0000903245','OH00001654205','IL','1','Fox','Adina','','','','34','269722200','1344 W MAIN ST',0,'ASHLAND','OH','44805','1479','CY','39005','1974-12-02','F','M',':RET:2106-3','N','021','HLT','2530127','52664OH151001306','2014-02-01','2014-01-01 10:47:25','450.00',NULL,NULL,'600.99','150.99','R-OH012','OH0','281.44',NULL,1,'2014-01-02 04:25:35'),(4161,3314,'Y','18','021','EC','A','','','AC','0000814272','0000814272','OH00001093637','IL','1','Cybulski','Leonard','','','','34','268669991','135 Eastwood Street',0,'Geneva','OH','44041',NULL,'CY','39007','1973-09-10','M','U',':RET:2106-3','N','021','DEN','1786700','99734OH005000301','2014-01-01','2013-12-17 15:39:46','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:48:58'),(8128,6430,'Y','18','024','14','A','','','TE','0000156896','0000156896','','IL','1','Jennings','Eileen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-02','F','',NULL,NULL,NULL,'','704305','','2013-11-22','2013-11-22 11:04:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:15:27'),(6659,5282,'Y','18','021','EC','A','','','AC','0000836604','0000836604','OH00000180216','IL','1','ROBERTS','ELIZABETH','','','','34','276422392','2324 15TH ST.',0,'CUYAHOGA FALLS','OH','44223','2038','CY','39153','1949-03-16','F','U',NULL,'N','021','HLT','95642','52664OH151001306','2014-01-01','2013-11-16 12:52:35','586.00',NULL,NULL,'669.00','83.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 01:00:49'),(6889,5465,'Y','18','021','EC','A','','','AC','0001632271','0001632271','LA00001414179','IL','1','Wright','Benjamin','','','','34','438980229','2101 ROSE DR',0,'GRETNA','LA','70053','7427','CY','22051','1956-01-28','M','M',':RET:2054-5','N','021','DEN','2281880','18575LA002000201','2014-01-01','2013-12-24 20:41:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:20'),(24887,19732,'N','03','021','EC','A',NULL,NULL,'','0001152250','0000043265','','IL','1','Irby','Donald','','','','34','230615043','2237 SARATOGA DR',0,'FINDLAY','OH','45840','7400','CY','39063','1991-06-18','M','',':RET:2106-3','N','021','HLT','3229869','92036OH003001505','2014-04-01','2014-02-19 10:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.83','CIC',0,'2014-02-20 05:38:06'),(26017,20633,'Y','18','021','EC','A','','','AC','0001251948','0001251948','TX00002620018','31','1','Belardi','Rebecca','','','','34','452964519','PO Box 7344',0,'Fort Worth','TX','76111',NULL,'CY','48439','1950-10-08','F','M',NULL,'N','021','DEN','3180064','33348TX002000101','2014-04-01','2014-02-26 11:46:17','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-26 21:02:13'),(26167,20749,'Y','18','021','EC','A','','','AC','0000555844','0000555844','MS00002738168','IL','1','long','tanya','','','','34','587490883','440 Parker Street',0,'Florence','MS','39073',NULL,'CY','28121','1983-05-12','F','M',':RET:2106-3','N','021','DEN','3876355','46300MS002000201','2014-04-01','2014-02-26 20:12:10','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-28 06:30:35'),(23294,18570,'N','19','021','EC','A',NULL,NULL,'','0000407418','0000321074','','IL','1','Perry-Moore','Isabella','','','','34','360906944','1779 Rockland Avenue',0,'Rocky River','OH','44116',NULL,'CY','39035','1995-06-08','F','',':RET:2106-3','N','021','DEN','3414101','99734OH005000301','2014-03-01','2014-02-12 23:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:10'),(13965,11131,'Y','18','021','EC','A','','','AC','0000516910','0000516910','OH00000070558','IL','1','DeGrange','Lauren','','','','34','497904646','8618 BRADFORD BLOOMER RD',0,'BRADFORD','OH','45308','9755','CY','39109','1985-03-30','F','M',':RET:2106-3','N','021','HLT','2178043','92036OH003000501','2014-01-01','2013-12-22 22:54:28','0.00',NULL,NULL,'518.07','518.07','R-OH003','OH0','269.84',NULL,0,'2013-12-26 13:15:14'),(22879,18246,'N','01','021','EC','A',NULL,NULL,'','0000050726','0000200805','','IL','1','Paris','Caroline','','','','34','292600871','5450 PARKS AVE',0,'LOUISVILLE','OH','44641','9522','CY','39151','1969-01-17','F','',NULL,'N','021','HLT','3696746','52664OH151001501','2014-03-01','2014-02-11 09:18:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','386.22',NULL,0,'2014-02-11 21:02:33'),(13528,10784,'Y','18','021','EC','A','','','AC','0002341141','0002341141','LA00000563320','IL','1','WILLIAMS','APRIL','DIANNE','','','34','435911953','4639 DALE ST',0,'NEW ORLEANS','LA','70126','4040','CY','22071','1984-04-14','F','U',':RET:2054-5','N','021','DEN','1572179','18575LA002000201','2014-01-01','2013-12-23 10:52:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:23'),(13370,10680,'Y','18','021','EC','A','','','AC','0000636002','0000636002','OH00001293833','IL','1','Szilagyi','Nathalie','','','','34','169588134','18800 State Route 47 East',0,'Sidney','OH','45365',NULL,'CY','39149','1965-08-12','F','R',':RET:2106-3','N','021','DEN','2046709','99734OH005000301','2014-01-01','2013-12-22 21:24:46','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:59:45'),(16626,13301,'Y','18','021','EC','A','','','AC','0000940869','0000940869','OH00001938873','31','1','Rakestraw','Debbra','','','','34','273545502','4866 Becker Drive',0,'Dayton','OH','45417',NULL,'CY','39113','1954-06-15','F','U',':RET:2054-5','N','021','DEN','2526282','99734OH005000401','2014-02-01','2014-01-07 16:03:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:13'),(5274,4180,'Y','18','021','EC','A','','','AC','0000469528','0000469528','OH00000664404','IL','1','JOHNSON','LUCIOUS','','','','34','252041455','1448 ALPHADA AVE',0,'AKRON','OH','44310','2772','CY','39153','1957-09-07','M','U',':RET:2054-5','N','021','HLT','1450263','52664OH151001304','2014-01-01','2013-12-19 13:21:58','343.00',NULL,NULL,'520.28','177.28','R-OH012','OH0','520.28',NULL,0,'2013-12-25 23:05:36'),(4165,3317,'Y','18','021','EC','A','','','AC','0000571981','0000571981','OH00000071619','IL','1','Conley','Richard','','','','34','279546979','9771 RAVENNA AVE',0,'LOUISVILLE','OH','44641','9778','CY','39151','1954-09-25','M','M',':RET:2106-3','N','021','DEN','1918172','99734OH005000301','2014-01-01','2013-12-17 16:10:07','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 21:49:06'),(27855,22031,'Y','18','021','EC','A','','','AC','0000747043','0000747043','TX00002724955','IL','1','NEWELL','EDWARD','','','','34','564113473','1516 ARROW HEAD TRL',0,'KINGSLAND','TX','78639',NULL,'CY','48299','1955-04-28','M','U',NULL,'N','021','DEN','2701011','33348TX002000101','2014-04-01','2014-03-05 16:35:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-03-05 21:32:15'),(24933,19771,'N','19','021','EC','A',NULL,NULL,'','0000888171','0000154710','','IL','1','ANGERSTIEN','BLAKE','','','','34','284082011','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','2003-07-09','M','',':RET:2106-3','N','021','DEN','3404832','99734OH005000301','2014-03-01','2014-02-20 16:08:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-20 21:30:20'),(13916,11099,'N','01','021','EC','A',NULL,NULL,'','0001250836','0000388641','','IL','1','Rayman','Sharon','','','','34','373683155','2117 Eastbrook Drive',0,'Toledo','OH','43613',NULL,'CY','39095','1958-06-06','F','',':RET:2106-3','N','021','HLT','1846280','92036OH003002605','2014-01-01','2013-12-22 21:51:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.11',NULL,0,'2013-12-26 13:14:05'),(21041,16811,'Y','18','021','EC','A','','','AC','0000510679','0000510679','OH00002301350','IL','1','Gott','Christopher','','','','34','564274613','11088 PHILLIPS RD',0,'BLUFFTON','OH','45817','9512','CY','39003','1973-07-05','M','M',NULL,'N','021','HLT','3395017','92036OH005001505','2014-03-01','2014-02-01 14:57:58','486.00',NULL,NULL,'588.73','102.73','R-OH002','OH0','281.27',NULL,0,'2014-02-01 19:00:50'),(16791,13431,'N','01','021','EC','A',NULL,NULL,'','0000108170','0000851855','','IL','1','Reedy','Charles','Thomas','','','34','277567082','1670 W ST RT 122',0,'Lebanon','OH','45036',NULL,'CY','39165','1954-04-15','M','',':RET:2106-3','N','021','DEN','2386861','99734OH005000301','2014-02-01','2014-01-11 09:26:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:18:06'),(1522,1268,'N','19','021','EC','A',NULL,NULL,'','0001075301','0000308266','','IL','1','Danner','Sarah','Grace','','','34','291020906','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1997-07-29','F','',':RET:2106-3','N','021','DEN','2363707','99734OH005000401','2014-01-01','2013-12-24 14:59:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:48'),(16494,13196,'N','01','021','EC','A',NULL,NULL,'','0001144785','0000278338','','IL','1','BACH','THU','','','','34','281068039','1866 LATHAM AVE',0,'LIMA','OH','45805','1636','CY','39003','1971-04-14','F','',':RET:2047-9','N','021','HLT','1452164','92036OH006001501','2014-02-01','2014-01-06 16:20:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.27',NULL,0,'2014-01-07 04:06:36'),(5267,4178,'Y','18','021','EC','A','','','AC','0000430253','0000430253','OH00001166159','IL','1','HILTON','CAROLYN','D','','','34','652834880','9 DOUGLAS LN',0,'MEDINA','OH','44256','1308','CY','39103','1975-12-21','F','M',NULL,'N','021','HLT','2587354','52664OH151001306','2014-01-01','2013-12-19 12:35:59','206.00',NULL,NULL,'277.87','71.87','R-OH012','OH0','277.87',NULL,0,'2013-12-25 23:05:30'),(7802,6180,'Y','18','021','EC','A','','','AC','0000892412','0000892412','TX00000147925','IL','1','mccreight','marlaine','','','','34','467718628','10602 YORK AVE',0,'LUBBOCK','TX','79424','7413','CY','48303','1968-07-25','F','M',':RET:2106-3','N','021','DEN','1679665','33348TX002000201','2014-01-01','2013-12-20 16:27:10','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2013-12-26 03:03:43'),(2478,2017,'N','01','021','EC','A',NULL,NULL,'','0000049603','0000001007','','IL','1','DOMINIC','TERRY','','','','34','554190781','2314 MADRID ST',0,'NEW ORLEANS','LA','70122','5514','CY','22071','1967-11-26','M','',':RET:2054-5','N','021','DEN','376169','18575LA002000201','2014-01-01','2013-12-09 13:26:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:35:25'),(3155,2538,'Y','18','021','EC','A','','','AC','0000977902','0000977902','OH00001218487','IL','1','Seay','Justen','','','','34','364980960','1011 Arrowhead Drive',0,'Oxford','OH','45056',NULL,'CY','39017','1982-05-30','M','M',':RET:2054-5','N','021','DEN','84217','99734OH005000401','2014-01-01','2013-11-17 20:56:00','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:09'),(3182,2559,'Y','18','021','EC','A','','','AC','0000495493','0000495493','LA00000798278','IL','1','Reid','Helen','','','','34','433534334','700 PETIT BERDOT DR',0,'KENNER','LA','70065','1128','CY','22051','1970-07-24','F','U',':RET:2054-5','N','021','DEN','1215187','18575LA002000201','2014-01-01','2013-11-18 15:48:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:31:53'),(6207,4918,'N','01','021','EC','A',NULL,NULL,'','0000481028','0000482152','','IL','1','Moore','Bruce','Edward','','','34','285765114','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1980-09-05','M','',NULL,'T','021','DEN','1245273','99734OH005000401','2014-01-01','2013-10-16 20:05:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:30:46'),(5980,4733,'N','01','021','EC','A',NULL,NULL,'','0000768881','0001224465','','IL','1','Chambers','Cynthia','Ann','','','34','369708545','5040 LEBANON RD',0,'SOUTH LEBANON','OH','45065','1418','CY','39165','1958-02-05','F','',':RET:2106-3','N','021','HLT','2185931','92036OH004001201','2014-01-01','2013-12-23 23:09:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','384.93',NULL,0,'2013-12-25 23:51:54'),(5444,4325,'Y','18','021','EC','A','','','AC','0002031666','0002031666','LA00000043198','IL','1','Dupuis','Jeffrey','','','','34','433294926','1523 DUBLIN ST',0,'NEW ORLEANS','LA','70118','2837','CY','22071','1974-01-08','M','U',':RET:2106-3','N','021','DEN','2494137','18575LA002000101','2014-01-01','2013-12-19 17:19:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:59'),(24188,19215,'Y','18','021','EC','A','','','AC','0000032276','0000032276','TX00002625949','IL','1','Tippler','Vivian','','','','34','628603569','10722 BRIAR FOREST DR',0,'HOUSTON','TX','77042','2321','CY','48201','1951-07-01','F','U',':RET:2106-3','N','021','DEN','3525666','33348TX002000101','2014-03-01','2014-02-15 19:27:18','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-16 19:00:12'),(23951,19045,'Y','18','021','EC','A','','','AC','0000069564','0000069564','TX00002051808','IL','1','poole','zachary','g','','','34','632345867','714w9th',0,'texarkana','TX','75501',NULL,'CY','48037','1992-12-23','M','U',':RET:2106-3','N','021','DEN','2724507','33348TX002000101','2014-03-01','2014-02-14 23:28:48','0.00',NULL,NULL,'25.02','25.02','R-TX021','TX0','25.02',NULL,0,'2014-02-15 22:00:04'),(13488,10754,'N','19','021','EC','A',NULL,NULL,'','0001205814','0000443457','','IL','1','McGuinness','Timothy','J','','','34','278088710','8770 HILLTOP DR',0,'MENTOR','OH','44060','1932','CY','39085','2003-03-17','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','1533151','99734OH005000301','2014-01-01','2013-12-23 18:04:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:23'),(20713,16551,'Y','18','021','EC','A','','','AC','0001190765','0001190765','LA00001434008','IL','1','castillo','vilma','','','','34','089864210','5144 EDEN ROC DR',0,'MARRERO','LA','70072','4900','CY','22051','1980-10-30','F','M',NULL,'N','021','DEN','2642419','18575LA002000201','2014-03-01','2014-01-30 16:30:19','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-30 21:01:10'),(20148,16078,'Y','18','021','EC','A','','','AC','0000708973','0000708973','OH00001728086','IL','1','Barletto','Douglas','','','','34','277543317','4042 Ryland Dr.',0,'Springfield','OH','45503',NULL,'CY','39023','1952-07-01','M','U',NULL,'N','021','DEN','2809205','99734OH005000401','2014-03-01','2014-01-27 17:43:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-27 21:01:02'),(7372,5838,'Y','18','024','14','A','','','TE','0000258116','0000258116','','IL','1','williams','terri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-21','F','',NULL,NULL,NULL,'','1185264','','2013-11-23','2013-11-23 09:44:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:15:42'),(5706,4529,'Y','18','021','EC','A','','','AC','0000053026','0000053026','OH00000056084','IL','1','Whisner','philip','','','','34','300804736','1560 bethel New Richmond road',0,'New Richmond','OH','45157',NULL,'CY','39025','1968-02-29','M','U',':RET:2106-3','N','021','HLT','1094048','92036OH003000606','2014-01-01','2013-11-26 17:37:06','245.00',NULL,NULL,'323.72','78.72','R-OH005','OH0','323.72',NULL,0,'2013-12-25 23:33:05'),(2490,2029,'Y','18','021','EC','A','','','AC','0000750578','0000750578','LA00000842313','IL','1','GRANGER','PATRICIA','T','','','34','437905424','8304 RENO ST',0,'METAIRIE','LA','70003',NULL,'CY','22051','1955-06-24','F','M',':RET:2054-5','N','021','DEN','554391','18575LA002000201','2014-01-01','2013-12-09 16:32:51','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:47'),(19987,15943,'Y','18','021','EC','A','','','AC','0000377492','0000377492','OH00002305064','IL','1','Melnek','Mary',NULL,NULL,NULL,NULL,NULL,'107 Warner St',0,'Walbridge','OH','43465',NULL,'CY','39173','1954-12-09','F','U',NULL,'N','021','HLT','1585136','92036OH004002601','2014-03-01','2014-01-25 15:23:45','258.00',NULL,NULL,'408.14','150.14','R-OH001','OH0','408.14',NULL,0,'2014-01-25 19:00:17'),(16378,13105,'N','01','021','EC','A',NULL,NULL,'','0000630962','0001047692','','IL','1','MONTOYA','GEORGE','','','','34','637902129','520 SCISSORTAIL LN',0,'FORT STOCKTON','TX','79735','9657','CY','48371','1985-04-01','M','',NULL,'T','021','DEN','1932849','33348TX002000201','2014-02-01','2014-01-06 12:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-07 04:03:14'),(27342,21650,'N','01','021','EC','A',NULL,NULL,'','0000787257','0000988948','','IL','1','LEWIS','ANITA',NULL,NULL,NULL,NULL,NULL,'734 CARLSBAD RD',0,'CINCINNATI','OH','45240','3646','CY','39061','1955-08-25','F','',':RET:2054-5','T','021','DEN','3080223','99734OH005000401','2014-04-01','2014-03-04 10:25:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:00:59'),(2684,2174,'Y','18','021','EC','A','','','AC','0000506565','0000506565','TX00000439539','IL','1','Housh','Carla','','','','34','462158691','8407 OLYMPIA DR',0,'AMARILLO','TX','79110','4909','CY','48381','1974-09-29','F','M',':RET:2106-3','N','021','DEN','5311','33348TX002000201','2014-01-01','2013-12-01 18:40:24','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 19:47:18'),(2751,2227,'Y','18','021','EC','A','','','AC','0000765935','0000765935','OH00000696900','IL','1','Lean','Stewart','','','','34','218521217','6340 TRAIL RIDGE CT',0,'LOVELAND','OH','45140','8156','CY','39025','1950-08-04','M','M',':RET:2106-3','T','021','HLT','257361','92036OH005000605','2014-01-01','2013-12-01 23:49:33','989.00',NULL,NULL,'1362.45','373.45','R-OH005','OH0','728.75',NULL,0,'2013-12-25 19:49:05'),(13166,10502,'Y','18','024','14','A','','','TE','0000359653','0000359653','','IL','1','Robinson','Debra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-26','F','',NULL,NULL,NULL,'','520923','','2013-12-23','2013-12-23 18:25:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:53:57'),(26329,20889,'Y','18','021','EC','A','','','AC','0001120983','0001120983','MS00002327617','IL','1','Sanders','Jonathan','','','','34','257750598','6433 TULANE RD',0,'HORN LAKE','MS','38637','2135','CY','28033','1990-04-17','M','M',':RET:2106-3','N','021','DEN','3069836','46300MS002000101','2014-04-01','2014-02-27 17:04:46','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2014-02-28 06:31:39'),(9604,7607,'Y','18','021','EC','A','','','AC','0000502980','0000502980','OH00001197011','IL','1','wilde','jeffrey','','','','34','301446230','10956 AMBLER LN',0,'MANTUA','OH','44255','9224','CY','39133','1950-06-17','M','M',':RET:2106-3','N','021','HLT','2012957','52664OH151001306','2014-01-01','2013-12-21 13:18:48','999.00',NULL,NULL,'1461.82','462.82','R-OH012','OH0','658.32',NULL,0,'2013-12-26 04:37:29'),(9530,7554,'Y','18','021','EC','A','','','AC','0000550061','0000550061','OH00000967520','IL','1','ROBINETTE','KATHERINE','M','','','34','289569565','5942 ISCH RD',0,'WALBRIDGE','OH','43465','9555','CY','39173','1956-01-13','F','M',':RET:2106-3','N','021','DEN','1877579','99734OH005000301','2014-01-01','2013-12-21 08:23:59','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-26 04:35:45'),(25668,20364,'Y','18','021','EC','A','','','AC','0000840433','0000840433','MS00002136716','IL','1','Tart','Charley','Mae','','','34','427278248','239 Boyd Street',0,'Canton','MS','39046',NULL,'CY','28089','1961-02-05','F','M',':RET:2054-5','N','021','DEN','3195282','46300MS002000201','2014-04-01','2014-02-21 21:54:30','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-26 08:30:50'),(7715,6109,'Y','18','024','14','A','','','TE','0000950650','0000950650','','IL','1','Wenning','Curtis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-07','M','',NULL,NULL,NULL,'','986065','','2013-12-20','2013-12-20 13:00:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:01:36'),(22425,17906,'Y','18','021','EC','A','','','AC','0002196403','0002196403','LA00001713230','IL','1','Walls','Patricia','','','','34','433062272','3827 DELACHAISE ST',0,'NEW ORLEANS','LA','70125','3718','CY','22071','1959-08-07','F','M',NULL,'N','021','DEN','3848270','18575LA002000201','2014-03-01','2014-02-10 18:04:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:33'),(20257,16165,'N','01','021','EC','A',NULL,NULL,'','0000141537','0000473678','','IL','1','ANTAUER','JANET','','','','34','286520340','3193 MIDDLEBORO',0,'DUBLIN','OH','43017',NULL,'CY','39049','1950-07-16','F','',':RET:2106-3','N','021','DEN','2685659','99734OH005000301','2014-03-01','2014-01-27 19:46:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-28 21:00:17'),(7176,5690,'N','01','021','EC','A',NULL,NULL,'','0000057316','0000269996','','IL','1','Walker','Willis','R','','','34','287482932','2653 MAYFAIR RD',0,'AKRON','OH','44312','5409','CY','39153','1966-01-14','M','',':RET:2106-3','T','021','DEN','222945','99734OH005000301','2014-01-01','2013-12-13 20:55:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:05'),(3484,2797,'Y','18','021','EC','A','','','AC','0001054209','0001054209','OH00001106064','IL','1','Tarkany','James','','','','34','295729510','459 E RAHN RD',0,'DAYTON','OH','45429','5948','CY','39113','1964-04-04','M','M',':RET:2106-3','N','021','DEN','1547522','99734OH005000401','2014-01-01','2013-12-22 11:36:36','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:16'),(6385,5063,'Y','18','021','EC','A','','','AC','0000151954','0000151954','OH00000972030','IL','1','Knueven','Emily','','','','34','275900777','2837 MINOT AVE',0,'CINCINNATI','OH','45209','1648','CY','39061','1986-06-19','F','R',':RET:2106-3','N','021','DEN','1238526','99734OH005000301','2014-01-01','2013-12-11 11:10:31','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:48:01'),(3774,3022,'Y','18','021','EC','A','','','AC','0000120057','0000120057','OH00000654221','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,'23872 Glenhill',0,'Cleveland','OH','44122',NULL,'CY','39035','1950-01-06','F','U',':RET:2106-3','N','021','HLT','769343','52664OH151001306','2014-01-01','2013-12-13 16:18:01','549.00',NULL,NULL,'742.48','193.48','R-OH011','OH0','742.48',NULL,0,'2013-12-25 21:33:47'),(18199,14527,'N','19','021','EC','A',NULL,NULL,'','0000451295','0000840547','','IL','1','Montoney','Mason','William','','','34','275066491','901 SYCAMORE BLVD',0,'CINCINNATI','OH','45245','1321','CY','39025','2001-01-25','M','',':RET:2106-3','N','021','HLT','1414599','92036OH006000601','2014-02-01','2014-01-14 12:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-01-15 02:08:06'),(14925,11926,'Y','18','021','EC','A','','','AC','0000303377','0000303377','OH00001599548','IL','1','Swartz','Robert','','','','34','268527921','8083 CLEARMEADOW DR',0,'WEST CHESTER','OH','45069','6809','CY','39017','1957-09-20','M','M',':RET:2106-3','N','021','HLT','2547549','92036OH004001201','2014-02-01','2013-12-28 19:21:48','0.00',NULL,NULL,'852.02','852.02','R-OH004','OH0','402.70',NULL,0,'2013-12-30 00:01:49'),(15051,12030,'N','01','021','EC','A',NULL,NULL,'','0001409920','0001776989','','IL','1','BURNS','michael','anthony','','','34','433255857','1105 SHERRON AVE',0,'BAKER','LA','70714','3956','CY','22033','1961-10-07','M','',NULL,'N','021','DEN','1914724','18575LA002000201','2014-02-01','2013-12-30 14:07:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:03:15'),(17178,13745,'Y','18','021','EC','A','','','AC','0000236289','0000236289','OH00002451123','IL','1','Trowbridge','James','','','','34','286626869','6109 BUTLER AVE',0,'CLEVELAND','OH','44127','1330','CY','39035','1960-06-10','M','M',':RET:2106-3','T','021','DEN','2091290','99734OH005000301','2014-02-01','2014-01-08 09:34:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:22:11'),(15833,12677,'Y','18','021','EC','A','','','AC','0000858498','0000858498','OH00001937432','IL','1','Vaughn','Sharon','','','','34','297508762','4608 SAINT JAMES AVE',0,'DAYTON','OH','45406','2323','CY','39113','1950-03-24','F','U',NULL,'N','021','DEN','2297677','99734OH005000401','2014-02-01','2014-01-02 11:24:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:03:54'),(16861,13491,'Y','18','021','EC','A','','','AC','0000275166','0000275166','TX00002001250','IL','1','Broadway','Naomi','','','','34','245630965','2121 Dickson Dr',0,'Austin','TX','78704',NULL,'CY','48453','1989-07-10','F','U',':RET:2106-3','N','021','DEN','1958641','33348TX002000201','2014-02-01','2014-01-09 00:23:52','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:19:10'),(17050,13643,'Y','18','021','EC','A','','','AC','0000231519','0000231519','OH00002262200','31','1','RAMSKILL','SARA','','','','34','281503461','PO BOX 117',0,'ATTICA','OH','44807',NULL,'CY','39147','1950-08-21','F','U',NULL,'N','021','HLT','2503667','92036OH003002704','2014-02-01','2014-01-09 16:29:11','474.00',NULL,NULL,'601.12','127.12','R-OH006','OH0','601.12',NULL,0,'2014-01-13 02:20:57'),(28098,22239,'N','01','021','EC','A',NULL,NULL,'','0000232046','0001120990','','IL','1','DUBOIS','DIANA','','','','34','129669816','51 KARLA DR',0,'VICKSBURG','MS','39180','9761','CY','28149','1971-05-15','F','',NULL,'T','021','DEN','3784507','46300MS002000101','2014-04-01','2014-03-06 17:57:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-06 21:02:08'),(25241,20023,'Y','18','024','14','A','','','TE','0001174433','0001174433','','IL','1','ulrick','peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-19','M','',NULL,NULL,NULL,'','2942726','','2014-02-20','2014-02-20 19:22:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-21 22:01:08'),(2484,2023,'Y','18','021','EC','A','','','AC','0000235052','0000235052','LA00000240257','IL','1','Robert','Ronald','','','','34','438989855','224 Trinity Road',0,'Opelousas','LA','70570',NULL,'CY','22097','1956-02-04','M','U',NULL,'N','021','DEN','566338','18575LA002000201','2014-01-01','2013-12-09 14:54:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:35:36'),(13951,11123,'N','19','021','EC','A',NULL,NULL,'','0000196137','0000665642','','IL','1','Gelter','Derek','T','','','34','283021226','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','1997-06-11','M','',':RET:2106-3','N','021','HLT','1462002','92036OH004000601','2014-01-01','2013-12-23 12:07:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 13:14:55'),(3314,2662,'Y','18','021','EC','A','','','AC','0000769988','0000769988','OH00000968722','IL','1','Riesenberg','Gary','','','','34','283509947','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1963-05-22','M','M',':RET:2106-3','N','021','DEN','1482483','99734OH005000301','2014-01-01','2013-12-22 14:18:21','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:55'),(9732,7707,'Y','18','021','EC','A','','','AC','0000949473','0000949473','OH00000401339','IL','1','nagy','michael','','','','34','232085468','1720 lexington ave',0,'springfield','OH','45505',NULL,'CY','39023','1965-10-17','M','M',':RET:2106-3','N','021','HLT','193577','92036OH004000501','2014-01-01','2013-11-14 20:34:13','342.00',NULL,NULL,'642.21','300.21','R-OH003','OH0','312.51',NULL,0,'2013-12-26 04:45:43'),(24929,19769,'Y','18','021','EC','A','','','AC','0000836638','0000836638','OH00003095107','IL','1','ANGERSTIEN','DENISE','','','','34','292601297','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','1977-05-30','F','U',':RET:2106-3','N','021','HLT','3279747','52664OH151001501','2014-03-01','2014-02-20 16:08:14','213.00',NULL,NULL,'498.82','285.82','R-OH012','OH0','328.98','CIC',0,'2014-02-20 21:30:18'),(24880,19728,'Y','18','021','EC','A','','','AC','0000540301','0000540301','OH00002680661','IL','1','Johnson','Scott','','','','34','590481299','6986 COUNTY ROAD 39',0,'HUNTSVILLE','OH','43324','9615','CY','39091','1972-03-04','M','R',':RET:2106-3','N','021','DEN','3096036','99734OH005000301','2014-04-01','2014-02-19 10:20:07','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00','CIC',0,'2014-02-20 05:35:56'),(15884,12719,'Y','18','021','EC','A','','','AC','0001785152','0001785152','LA00001678717','IL','1','Gravois','Randy','P','','Jr','34','439375561','301 ELM ST',0,'MAMOU','LA','70554',NULL,'CY','22039','1969-01-05','M','M',':RET:2106-3','N','021','DEN','2275285','18575LA002000101','2014-02-01','2014-01-02 13:26:54','0.00',NULL,NULL,'50.04','50.04','R-LA003','LA0','25.02',NULL,0,'2014-01-03 02:05:30'),(23724,18889,'N','01','021','EC','A',NULL,NULL,'','0000117065','0000678755','','IL','1','timbs','sophie','m','','','34','460913642','3104 walnut hill ln',0,'dallas','TX','75229',NULL,'CY','48113','1987-11-01','F','',':RET:2106-3','N','021','DEN','3193914','33348TX002000101','2014-03-01','2014-02-13 23:02:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-14 21:30:54'),(17979,14366,'Y','18','021','EC','A','','','AC','0000042079','0000042079','OH00002530909','IL','1','SURGEN','SUSAN','','','','34','268521650','2500 INCOME DR',0,'AKRON','OH','44305','2223','CY','39153','1951-10-29','F','M',':RET:2106-3','N','021','HLT','1557165','52664OH151001305','2014-02-01','2014-01-14 13:10:46','374.00',NULL,NULL,'640.70','266.70','R-OH012','OH0','640.70',NULL,0,'2014-01-15 02:06:52'),(18228,14548,'N','01','021','EC','A',NULL,NULL,'','0001181477','0000574940','','IL','1','Mock','Julie','Amanda','','','34','458698980','26755 BAYOU TESCH DR',0,'MAGNOLIA','TX','77354','2818','CY','48339','1960-12-26','F','',':RET:2106-3','N','021','DEN','1626402','33348TX002000201','2014-02-01','2014-01-14 20:57:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-16 08:44:17'),(23123,18429,'Y','18','021','EC','A','','','AC','0000840573','0000840573','OH00002716038','IL','1','hill','valerie','frances','','','34','289782693','5187 STRAWBERRY LN',0,'WILLOUGHBY','OH','44094','4329','CY','39085','1968-07-07','F','U',':RET:2106-3','N','021','DEN','3279508','99734OH005000401','2014-03-01','2014-02-12 12:31:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:24'),(23072,18396,'Y','18','021','EC','A','','','AC','0002119895','0002119895','LA00002333929','31','1','Harper','Suzanne','','','','34','435886378','P.O. Box 592',0,'Abita Springs','LA','70420',NULL,'CY','22103','1953-12-19','F','U',':RET:2106-3','N','021','DEN','3233051','18575LA002000201','2014-03-01','2014-02-12 14:11:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:58'),(26563,21059,'Y','18','021','EC','A','','','AC','0000550126','0000550126','OH00003294369','IL','1','Murphy','Tonia','','','','34','404137128','3457 SUNBURY LN',0,'CINCINNATI','OH','45251','2398','CY','39061','1979-08-27','F','R',':RET:2054-5','N','021','DEN','3060306','99734OH005000401','2014-03-01','2014-02-27 23:15:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:21'),(14367,11458,'Y','18','021','EC','A','','','AC','0001055327','0001055327','OH00001249996','IL','1','BREWER','EDWARD','','','','34','282785475','103 CROMWELL PLACE',0,'DAYTON','OH','45406',NULL,'CY','39113','1965-12-25','M','U',':RET:2054-5','N','021','DEN','1531949','99734OH005000401','2014-02-01','2013-12-27 09:13:45','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-28 03:30:26'),(22519,17978,'Y','18','021','EC','A','','','AC','0001120865','0001120865','TX00002584813','IL','1','alexander','willie','','','','34','450049188','6941 atha dr',0,'dallas','TX','75217',NULL,'CY','48113','1956-11-29','M','U',':RET:2054-5','T','021','DEN','2940232','33348TX002000101','2014-03-01','2014-02-10 16:38:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-10 21:31:24'),(2820,2279,'N','19','021','EC','A',NULL,NULL,'','0000214252','0000659597','','IL','1','Redmond','Nitika','','','','34','587694715','257 Sigler Ave',0,'Sledge','MS','38670',NULL,'CY','28119','1990-12-07','F','',':RET:2054-5','N','021','DEN','368941','46300MS002000201','2014-01-01','2013-11-24 16:32:46',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 20:00:29'),(3276,2641,'Y','18','021','EC','A','','','AC','0001235174','0001235174','OH00000441653','IL','1','spain','christopher','','','','34','271807969','4260 delridge dr',0,'cincinnati','OH','45205',NULL,'CY','39061','1983-01-21','M','R',':RET:2054-5','N','021','HLT','1374245','92036OH004001201','2014-01-01','2013-12-21 23:07:24','0.00',NULL,NULL,'195.92','195.92','R-OH004','OH0','195.92',NULL,0,'2013-12-25 21:15:06'),(18293,14604,'Y','18','021','EC','A','','','AC','0000330902','0000330902','OH00001450163','IL','1','JONES','ELVIA','IBARRA','','','34','282787545','925 OLIVE RD',0,'DAYTON','OH','45426',NULL,'CY','39113','1954-05-09','F','U',NULL,'N','021','DEN','2096883','99734OH005000401','2014-02-01','2014-01-14 21:44:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-16 08:44:53'),(3669,2935,'Y','18','021','EC','A','','','AC','0001224450','0001224450','OH00001058719','IL','1','MITCHELL','PAMELA','J','','','34','273484324','2147 PEBBLE CREEK DRIVE',0,'TWINSBURG','OH','44087',NULL,'CY','39153','1950-03-28','F','M',':RET:2054-5','N','021','DEN','1047865','99734OH005000401','2014-01-01','2013-12-12 20:52:43','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:31:06'),(3958,3168,'Y','18','021','EC','A','','','AC','0000246429','0000246429','OH00000040665','IL','1','Sokol','Caroline','','','','34','275748421','1782 Middleton Rd',0,'Hudson','OH','44236',NULL,'CY','39153','1963-01-21','F','M',':RET:2106-3','N','021','HLT','919943','52664OH151001501','2014-01-01','2013-12-13 13:18:51','0.00',NULL,NULL,'1511.45','1511.45','R-OH012','OH0','477.69',NULL,0,'2013-12-25 21:38:21'),(9303,7376,'Y','18','021','EC','A','','','AC','0002310008','0002310008','LA00000840045','IL','1','Prock','Suzanne','','','','34','437650629','9224 Greenwood Road',0,'Greenwood','LA','71033',NULL,'CY','22017','1970-08-12','F','U',':RET:2106-3','N','021','DEN','2184492','18575LA002000101','2014-01-01','2013-12-20 18:47:22','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-26 04:30:03'),(4468,3550,'Y','18','021','EC','A','','','AC','0000500368','0000500368','OH00000568973','31','1','Bodi','Amanda','','','','34','300906228','PO Box 313',0,'Castalia','OH','44824',NULL,'CY','39043','1987-11-13','F','M',':RET:2106-3','N','021','DEN','43797','99734OH005000301','2014-01-01','2013-12-12 14:52:46','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 22:02:46'),(17230,13789,'Y','18','021','EC','A','','','AC','0000836862','0000836862','MS00001636251','IL','1','lewis','jim','','','','34','587061748','3006 MEAGAN DR',0,'BYRAM','MS','39272','4447','CY','28049','1967-06-28','M','U',NULL,'N','021','DEN','1924314','46300MS002000101','2014-02-01','2014-01-08 11:39:11','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-13 02:22:39'),(27223,21556,'Y','18','021','EC','A','','','AC','0000889351','0000889351','MS00003195682','IL','1','TERRY','MONICA','','','','34','587576696','4802 BERRY RD',0,'UTICA','MS','39175','9256','CY','28049','1981-12-16','F','U',NULL,'N','021','DEN','3965540','46300MS002000201','2014-04-01','2014-03-03 16:10:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:36'),(27224,21557,'Y','18','021','EC','A','','','AC','0002240790','0002240790','LA00003228306','IL','1','Duet','Daniel','','','','34','437797734','124 MERLIN ST',0,'GRAY','LA','70359','6200','CY','22109','1990-09-18','M','U',':RET:2106-3','N','021','DEN','3879198','18575LA002000101','2014-04-01','2014-03-02 20:45:24','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-03-03 21:31:37'),(28421,22489,'Y','18','021','EC','A','','','AC','0001045754','0001045754','OH00003381413','IL','1','Bishop','Brenda','','','','34','268542249','2420 E DUBLIN GRANVILLE RD',0,'COLUMBUS','OH','43229','3520','CY','39049','1954-03-12','F','U',':RET:2054-5','N','021','DEN','3244701','99734OH005000401','2014-04-01','2014-03-07 14:04:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:03'),(28951,22912,'Y','18','021','EC','A','','','AC','0001486248','0001486248','LA00003005054','IL','1','Mireles','Christopher','Ruiz','','','34','435675451','9443 NASH LN',0,'LAKE CHARLES','LA','70607','0355','CY','22019','1987-02-18','M','M',':RET:2106-3','N','021','DEN','3924675','18575LA002000201','2014-04-01','2014-03-10 00:10:54','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-10 21:00:50'),(24872,19720,'Y','18','021','EC','A','','','AC','0001010258','0001010258','OH00002570059','IL','1','Irby','Melissa','','','','34','226660459','2237 SARATOGA DR',0,'FINDLAY','OH','45840','7400','CY','39063','1954-07-12','F','M',':RET:2106-3','N','021','DEN','3203018','99734OH005000401','2014-04-01','2014-02-19 10:59:04','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00','CIC',0,'2014-02-20 05:33:36'),(22258,17765,'Y','18','021','EC','A','','','AC','0000183476','0000183476','TX00001462676','IL','1','Zamarron','Dennis','','','','34','465857621','1711 CHARLES CIR',0,'EDINBURG','TX','78541','2801','CY','48215','1978-08-22','M','U',NULL,'N','021','DEN','3486670','33348TX002000201','2014-03-01','2014-01-30 10:10:00','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-10 11:00:05'),(6727,5337,'Y','18','021','EC','A','','','AC','0000836608','0000836608','OH00001100513','IL','1','Scarlato','Nicholas','','','','34','286683690','3633 Darwin ave',0,'Cincinnati','OH','45211',NULL,'CY','39061','1975-06-02','M','M',':RET:2106-3','N','021','DEN','1051284','99734OH005000401','2014-01-01','2013-11-24 23:30:48','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:24'),(19279,15366,'Y','18','024','14','A','','','TE','0000679539','0000679539','','IL','1','Davis','Sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-09','F','',NULL,NULL,NULL,'','1946785','','2014-01-20','2014-01-20 16:15:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:59'),(17341,13872,'Y','18','021','EC','A','','','AC','0000276961','0000276961','MS00001756130','IL','1','nichols','alexia','','','','34','425452632','4674 NORWAY DR',0,'JACKSON','MS','39206','3356','CY','28049','1982-08-06','F','U',':RET:2054-5','N','021','DEN','2318410','46300MS002000201','2014-02-01','2014-01-09 22:27:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:24:03'),(16211,12981,'Y','18','021','EC','A','','','AC','0000564011','0000564011','TX00002076016','IL','1','GUIDRY','ANDREA','','','','34','453935603','613 SOUTHWYND ST',0,'MESQUITE','TX','75150','4723','CY','48113','1977-06-04','F','U',':RET:2054-5','N','021','DEN','2227247','33348TX002000201','2014-02-01','2014-01-04 17:35:09','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-05 00:01:28'),(5926,4693,'Y','18','021','EC','A','','','AC','0000495608','0000495608','TX00000399952','IL','1','ling','steve','','','','34','521859808','1712 EDINBURG CT',0,'ALLEN','TX','75013','5335','CY','48085','1968-06-27','M','R',':RET:2034-7','T','021','DEN','2450149','33348TX002000101','2014-01-01','2013-12-24 01:08:09','0.00',NULL,NULL,'101.40','101.40','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:25'),(14568,11623,'Y','18','021','EC','A','','','AC','0000885596','0000885596','OH00001465384','IL','1','DETZEL','ELIZABETH','','','','34','285482807','3790 BENHILL DR',0,'CINCINNATI','OH','45247',NULL,'CY','39061','1949-07-12','F','M',NULL,'N','021','HLT','2310979','92036OH006001201','2014-02-01','2013-12-27 12:26:53','421.00',NULL,NULL,'510.73','89.73','R-OH004','OH0','510.73',NULL,0,'2013-12-28 03:35:27'),(14194,11319,'Y','18','021','EC','A','','','AC','0000669649','0000669649','TX00000696573','IL','1','MOLINAR','ALMA','','','','34','451416362','711 MUNDY DR',0,'EL PASO','TX','79902','3720','CY','48141','1974-10-24','F','U',NULL,'N','021','DEN','2342838','33348TX002000201','2014-02-01','2013-12-26 13:00:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-27 02:04:05'),(26125,20719,'Y','18','021','EC','A','','','AC','0000064942','0000064942','OH00002864498','IL','1','ASBURY','KAREN','','','','34','272664546','119 MILL STREAM CIR',0,'ELYRIA','OH','44035',NULL,'CY','39093','1962-02-18','F','M',':RET:2106-3','N','021','DEN','3881704','99734OH005000401','2014-04-01','2014-02-27 10:17:36','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:20'),(26445,20976,'Y','18','021','EC','A','','','AC','0000575896','0000575896','OH00003052643','IL','1','WARREN','EDWARD','GERARD','','','34','289620801','1410 SPRINGFIELD PIKE',0,'WYOMING','OH','45215',NULL,'CY','39061','1959-12-27','M','U',':RET:2054-5','N','021','DEN','3725357','99734OH005000301','2014-04-01','2014-02-27 09:08:42','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00','CIC',0,'2014-02-28 07:30:23'),(26978,21372,'Y','18','024','14','A','','','TE','0000178878','0000178878','','IL','1','Richardson','Erin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-10-23','F','',NULL,NULL,NULL,'','1744210','','2014-03-17','2014-03-02 12:14:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 01:00:37'),(27152,21497,'Y','18','021','EC','A','','','AC','0001130284','0001130284','OH00003515308','IL','1','Crolley','Marcia','','','','34','279503887','3240 7TH ST',0,'CUYAHOGA FALLS','OH','44221','1310','CY','39153','1951-02-20','F','M',':RET:2106-3','N','021','DEN','3884168','99734OH005000401','2014-04-01','2014-03-03 14:19:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-03 21:30:53'),(27274,21597,'Y','18','021','EC','A','','','AC','0000778351','0000778351','TX00002761529','IL','1','Moore','Holly','','','','34','489829133','7021 VALHALLA RD',0,'FORT WORTH','TX','76116','9019','CY','48439','1964-04-24','F','U',':RET:2106-3','N','021','DEN','3704758','33348TX002000201','2014-04-01','2014-03-03 18:22:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-04 21:00:17'),(27412,21696,'N','01','021','EC','A',NULL,NULL,'','0001124133','0000644733','','IL','1','Gandy','Stephanie','Marie','','','34','301800865','3090 Livingston Rd',0,'Cleveland','OH','44120',NULL,'CY','39035','1983-02-15','F','',':RET:2054-5','N','021','DEN','2943428','99734OH005000301','2014-04-01','2014-03-04 14:21:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:35'),(23079,18401,'N','01','021','EC','A',NULL,NULL,'','0000854237','0001004385','','IL','1','Kossick','Lori','','','','34','278624885','103 HALL ST',0,'AKRON','OH','44303','2117','CY','39153','1963-05-09','F','',':RET:2106-3','N','021','HLT','3174177','52664OH151001501','2014-03-01','2014-02-11 19:43:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','477.69',NULL,0,'2014-02-12 21:31:02'),(22126,17659,'N','19','021','EC','A',NULL,NULL,'','0000101467','0000087525','','S1','1','Ratliff','Melissa','','','','34','403594810','2108 INDIAN RIDGE DR',0,'PIQUA','OH','45356','8268','CY','39109','2002-03-12','M','',':RET:2106-3','N','021','HLT','2819217','92036OH004000501','2014-03-01','2014-02-08 17:01:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-02-08 19:00:41'),(18912,15071,'Y','18','021','EC','A','','','AC','0000020201','0000020201','OH00002107487','IL','1','Neace','Gwen','','','','34','459694909','9767 COBBLEWOOD CT',0,'CENTERVILLE','OH','45458','6100','CY','39113','1973-10-04','F','M',':RET:2106-3','N','021','HLT','2074494','92036OH001000501','2014-02-01','2014-01-15 19:15:16','0.00',NULL,NULL,'746.36','746.36','R-OH003','OH0','366.44',NULL,0,'2014-01-17 03:36:41'),(18448,14716,'N','01','021','EC','A',NULL,NULL,'','0000618384','0000823537','','IL','1','Link','Edward','Glen','','III','34','289704065','1453 LANGDON DR',0,'SIDNEY','OH','45365','6202','CY','39149','1976-06-12','M','',':RET:2106-3','N','021','HLT','1806607','92036OH001000501','2014-02-01','2014-01-14 19:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','354.96',NULL,0,'2014-01-16 08:46:06'),(18251,14570,'Y','18','021','EC','A','','','AC','0000821862','0000821862','TX00001466966','IL','1','TOWNSEND','CHAUNCEY','','','','34','456047741','19641 COUNTY ROAD 366',0,'WINONA','TX','75792','5809','CY','48423','1954-11-29','F','U',':RET:2106-3','N','021','DEN','1806635','33348TX002000201','2014-02-01','2014-01-15 11:09:35','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-16 08:44:30'),(2626,2136,'Y','18','021','EC','A','','','AC','0000093813','0000093813','OH00001191476','IL','1','JONES','CAROL','','','','34','271507031','1600 CEDAR ST. LOT 13 GG',0,'FREMONT','OH','43420',NULL,'CY','39143','1950-01-09','F','M',':RET:2106-3','N','021','DEN','996405','99734OH005000401','2014-01-01','2013-12-02 12:57:25','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-25 19:46:00'),(16884,13510,'Y','18','021','EC','A','','','AC','0000879050','0000879050','TX00000207279','IL','1','Hudson','Callie','','','','34','642526774','2707 TOWNES LN',0,'AUSTIN','TX','78703','1642','CY','48453','1985-01-28','F','U',':RET:2106-3','N','021','DEN','2170911','33348TX002000201','2014-02-01','2014-01-09 11:37:44','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:19:23'),(6525,5174,'Y','18','021','EC','A','','','AC','0000129244','0000129244','OH00000341704','IL','1','Schneder','Michael','','','','34','291861206','3940 WEBSTER AVE',0,'CINCINNATI','OH','45236','3455','CY','39061','1972-07-23','M','U',':RET:2106-3','T','021','HLT','644049','92036OH002001201','2014-01-01','2013-12-11 00:25:37','0.00',NULL,NULL,'371.20','371.20','R-OH004','OH0','371.20',NULL,0,'2013-12-26 00:51:32'),(3668,2934,'Y','18','021','EC','A','','','AC','0000586673','0000586673','OH00001127379','IL','1','WISEMAN','KARL','','','','34','233803137','1361 SINCLAIR AVE',0,'STEUBENVILLE','OH','43952',NULL,'CY','39081','1950-04-27','M','U',':RET:2106-3','N','021','DEN','742143','99734OH005000401','2014-01-01','2013-12-12 20:50:38','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:31:05'),(14390,11477,'N','01','021','EC','A',NULL,NULL,'','0001048005','0000621114','','IL','1','robinson','debra','ann','','','34','277705663','959 4 MILE RD',0,'CINCINNATI','OH','45230','5221','CY','39061','1960-01-01','F','',':RET:2106-3','N','021','DEN','2299761','99734OH005000401','2014-02-01','2013-12-27 14:55:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:59'),(14573,11628,'Y','18','021','EC','A','','','AC','0000088565','0000088565','OH00001577446','IL','1','Ziems','Frederick','R','','','34','276547357','4355 WILLYS PKWY',0,'TOLEDO','OH','43612','2167','CY','39095','1962-12-06','M','U',':RET:2106-3','N','021','HLT','2211104','92036OH005002604','2014-02-01','2013-12-27 12:37:54','185.00',NULL,NULL,'363.68','178.68','R-OH001','OH0','363.68',NULL,0,'2013-12-28 03:35:35'),(16348,13085,'N','01','021','EC','A',NULL,NULL,'','0000717845','0000477470','','IL','1','Shephard','Leiann','','','','34','270883522','71 HAMILTON DR',0,'TORONTO','OH','43964','2004','CY','39081','1976-05-07','F','',NULL,'N','021','DEN','1751807','99734OH005000301','2014-02-01','2014-01-06 10:26:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:24'),(28162,22285,'Y','18','021','EC','A','','','AC','0001212392','0001212392','OH00003172042','IL','1','Goins','Charles','','','','34','290425417','9628 KOHLER RD',0,'BOTKINS','OH','45306','8923','CY','39011','1951-02-07','M','U',NULL,'N','021','HLT','3239098','92036OH005001501','2014-04-01','2014-03-06 15:55:05','480.00',NULL,NULL,'649.68','169.68','R-OH002','OH0','649.68',NULL,0,'2014-03-06 21:02:42'),(316,259,'Y','18','021','EC','A','','','AC','0000208451','0000208451','OH00000048722','IL','1','Sargent','Vernon','L','','Jr','34','227869843','1770 Evergreen ave.',0,'Akron','OH','44301',NULL,'CY','39153','1961-01-28','M','U',':RET:2054-5','T','021','HLT','876834','52664OH152000901','2014-01-01','2013-11-12 20:10:04','0.00',NULL,NULL,'366.67','366.67','R-OH012','OH0','366.67',NULL,0,'2013-12-25 17:31:11'),(640,529,'Y','18','021','EC','A','','','AC','0000251603','0000251603','OH00000897316','IL','1','HILL','STANLEY','','','','34','300460375','8103 CONSTITUTION DR',0,'CINCINNATI','OH','45215',NULL,'CY','39061','1952-11-20','M','U',':RET:2054-5','N','021','DEN','1632945','99734OH005000401','2014-01-01','2013-12-16 14:55:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:20'),(21049,16818,'Y','18','021','EC','A','','','AC','0000163956','0000163956','TX00001592798','IL','1','Hernandez','Edgar','','','','34','629285914','527 North Fulton',0,'Lubbock','TX','79416',NULL,'CY','48303','1987-12-08','M','U',NULL,'N','021','DEN','3020601','33348TX002000201','2014-03-01','2014-02-01 22:18:49','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-02 19:00:05'),(19992,15948,'Y','18','024','14','A','','','TE','0001109251','0001109251','','IL','1','Jerels','Ashaki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-02-14','F','',NULL,NULL,NULL,'','2670149','','2014-01-25','2014-01-25 12:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-25 19:00:20'),(1060,868,'N','01','021','EC','A',NULL,NULL,'','0000352919','0001175898','','IL','1','Lopez','Esperanza','','','','34','464336362','2116 LIBERTY ST',0,'MISSION','TX','78573','9863','CY','48215','1962-04-08','F','',':RET:2106-3','N','021','DEN','607981','33348TX002000201','2014-01-01','2013-12-03 17:43:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:16:16'),(18884,15046,'Y','18','021','EC','A','','','AC','0001884409','0001884409','LA00002543454','IL','1','Vicknair','Thomas','','','','34','436376029','6512 MITCHELL AVE',0,'METAIRIE','LA','70003','4855','CY','22051','1979-06-01','M','M',':RET:2106-3','N','021','DEN','1790244','18575LA002000201','2014-02-01','2014-01-15 20:34:35','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:29'),(16594,13273,'Y','18','021','EC','A','','','AC','0001322520','0001322520','LA00002245075','IL','1','Tran','Quoc','','','','34','437818912','1917 N. Village Green St.',0,'Harvey','LA','70058',NULL,'CY','22051','1971-12-04','M','U',':RET:2047-9','N','021','DEN','1778052','18575LA002000201','2014-02-01','2014-01-06 20:24:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:24:02'),(8089,6405,'Y','18','021','EC','A','','','AC','0000096388','0000096388','OH00000517923','IL','1','King','Christine','','','','34','298787926','10864 CABLE AVE',0,'WHITEHOUSE','OH','43571','9609','CY','39095','1982-02-08','F','M',':RET:2106-3','N','021','HLT','1994855','92036OH002002601','2014-01-01','2013-12-20 18:31:02','131.00',NULL,NULL,'598.18','467.18','R-OH001','OH0','261.00',NULL,0,'2013-12-26 03:10:38'),(1987,1626,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001046431','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','1244210','33348TX002000101','2014-01-01','2013-11-19 23:05:09','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:51'),(15920,12748,'Y','18','021','EC','A','','','AC','0001210849','0001210849','MS00000125618','IL','1','Dawson','Jerald','Renoil','','','34','425718723','5845 RIDGEWOOD RD',0,'JACKSON','MS','39211','2662','CY','28049','1988-01-14','M','U',':RET:2054-5','N','021','DEN','2441359','46300MS002000201','2014-02-01','2014-01-02 16:27:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-03 02:06:38'),(15293,12227,'Y','18','021','EC','A','','','AC','0001690463','0001690463','LA00001858256','IL','1','Anderson','Gamaliel','','','','34','437674863','758 kingtown pl',0,'Shreveport','LA','71108',NULL,'CY','22017','1973-02-11','M','U',':RET:2054-5','N','021','DEN','2471781','18575LA002000101','2014-02-01','2014-01-01 14:39:08','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-02 04:22:32'),(14195,11320,'Y','18','021','EC','A','','','AC','0000956341','0000956341','TX00001201265','31','1','WILSON','SHARON','','','','34','465885372','P.O. BOX 292',0,'MARLIN','TX','76661',NULL,'CY','48145','1962-03-03','F','M',':RET:2054-5','N','021','DEN','1840783','33348TX002000201','2014-02-01','2013-12-26 13:05:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:04:06'),(14239,11354,'N','19','021','EC','A',NULL,NULL,'','0000120613','0000776511','','IL','1','LI','ISABELLE','','','','34','316253440','462 FAIRFIELD DR',0,'MADISON','MS','39110','7543','CY','28089','2002-10-31','F','',':RET:2034-7','N','021','DEN','2466300','46300MS002000101','2014-02-01','2013-12-26 13:29:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2013-12-27 02:05:11'),(27579,21810,'Y','18','024','14','A','','','TE','0000751423','0000751423','','IL','1','Taylor','Calvin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-14','M','',NULL,NULL,NULL,'','2990657','','2014-03-31','2014-03-04 18:29:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:10'),(24812,19677,'Y','18','021','EC','A','','','AC','0000757194','0000757194','OH00003028633','IL','1','Nowland','Deanna','','','','34','301605166','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1972-01-31','F','M',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05','372.00',NULL,NULL,'798.53','426.53','R-OH005','OH0','228.72',NULL,0,'2014-02-20 04:50:01'),(24618,19539,'Y','18','021','EC','A','','','AC','0000017613','0000017613','MS00002757418','IL','1','Scott','Linda','','','','34','587114454','623 WOODBURY RD',0,'JACKSON','MS','39206','4915','CY','28049','1959-11-08','F','U',':RET:2054-5','N','021','DEN','2617641','46300MS002000201','2014-04-01','2014-02-19 11:50:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:15:21'),(16834,13465,'Y','18','021','EC','A','','','AC','0000680863','0000680863','OH00002357001','IL','1','Satterfield','John','','','','34','606529579','727 GRIFTON AVE',0,'AKRON','OH','44305','1731','CY','39153','1990-12-10','M','U',':RET:2106-3','N','021','DEN','1616894','99734OH005000401','2014-02-01','2014-01-11 14:35:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:18:30'),(16589,13269,'Y','18','021','EC','A','','','AC','0001604388','0001604388','LA00002293530','IL','1','HOPKINS','KENT','','','','34','436725274','1714 INGLESIDE DR',0,'BATON ROUGE','LA','70808',NULL,'CY','22033','1954-06-27','F','R',':RET:2106-3','N','021','DEN','1763507','18575LA002000201','2014-02-01','2014-01-07 16:23:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:00'),(15862,12701,'Y','18','021','EC','A','','','AC','0000385179','0000385179','MS00001992072','IL','1','Ducksworth','Wasaki',NULL,NULL,NULL,NULL,NULL,'220 SCR 78B',0,'Taylorsville','MS','39168',NULL,'CY','28129','1980-04-23','F','U',':RET:2054-5','N','021','DEN','2563360','46300MS002000101','2014-02-01','2014-01-02 12:30:00','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-03 02:04:48'),(26970,21367,'Y','18','021','EC','A','','','AC','0000493404','0000493404','TX00002369182','IL','1','Pho','Quoc','','','','34','632588496','9289 LYNDON B JOHNSON FWY',0,'DALLAS','TX','75243','4494','CY','48113','1984-08-12','M','U',':RET:2047-9','N','021','DEN','2968423','33348TX002000101','2014-04-01','2014-03-02 00:39:07','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-03 01:00:34'),(28921,22890,'Y','18','021','EC','A','','','AC','0000739088','0000739088','OH00003492454','IL','1','BERNARD','AMANDA','','','','34','404636741','970 SANDY LN',0,'MEDINA','OH','44256','2026','CY','39103','1976-06-12','F','M',NULL,'N','021','DEN','3492816','99734OH005000301','2014-04-01','2014-03-10 10:42:15','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:00:31'),(433,356,'Y','18','021','EC','A','','','AC','0000064854','0000064854','OH00001159771','IL','1','CODA-MILLER','DARLENE','','','','34','279661182','3498 WILSON ST',0,'CUYAHOGA FALLS','OH','44221','1022','CY','39153','1966-06-10','F','M',':RET:2106-3','N','021','DEN','607993','99734OH005000401','2014-01-01','2013-12-04 08:06:23','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:46:59'),(14082,11222,'Y','18','024','14','A','','','TE','0000240355','0000240355','','IL','1','COLEMAN','ANTHONY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-03-09','M','',NULL,NULL,NULL,'','2319510','','2013-12-26','2013-12-26 10:30:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:01:08'),(24936,19774,'Y','18','024','14','A','','','TE','0000114836','0000114836','','IL','1','TAYLOR','GLENDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-29','F','',NULL,NULL,NULL,'','1460871','','2014-03-31','2014-02-20 16:48:48',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-20 21:30:23'),(24178,19208,'N','19','021','EC','A',NULL,NULL,'','0000688335','0000178937','','IL','1','Porter','Grace','R','','','34','268981334','522 Ledge Rd.',0,'Macedonia','OH','44056',NULL,'CY','39153','1994-08-01','F','',':RET:2106-3','N','021','HLT','3797182','52664OH152000901','2014-03-01','2014-02-15 18:01:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-02-16 19:00:06'),(7042,5592,'N','01','021','EC','A',NULL,NULL,'','0000380459','0000325367','','IL','1','Floyd','Jonathan','','','','34','632039054','1805 COZUMEL DR',0,'MANSFIELD','TX','76063','5916','CY','48439','1977-10-14','M','',':RET:2106-3','T','021','DEN','2197527','33348TX002000201','2014-02-01','2013-12-25 00:51:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:49:27'),(6922,5494,'N','01','021','EC','A',NULL,NULL,'','0000179903','0001258661','','IL','1','SHAMANSKY','ROBERT','','','','34','300622305','9568 CLIFFVIEW ST NW',0,'CLINTON TOWNSHIP','OH','44216',NULL,'CY','39151','1957-04-01','M','',':RET:2106-3','N','021','DEN','2573614','99734OH005000401','2014-01-01','2013-12-24 18:59:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:46:14'),(22982,18323,'Y','18','021','EC','A','','','AC','0000933248','0000933248','OH00001821812','IL','1','Wilson','Rae','','','','34','295865039','24 W 8TH ST',0,'MANCHESTER','OH','45144','1239','CY','39001','1981-12-14','F','M',':RET:2106-3','N','021','DEN','3102867','99734OH005000301','2014-03-01','2014-02-11 21:53:11','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-02-12 21:30:09'),(17410,13934,'Y','18','021','EC','A','','','AC','0000187402','0000187402','TX00002527994','IL','1','hill','marilyn','','','','34','461350946','307 north Jordan street',0,'Whitesboro','TX','76273',NULL,'CY','48181','1962-11-05','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','1506486','33348TX002000101','2014-02-01','2014-01-10 15:36:24','0.00',NULL,NULL,'54.30','54.30','R-TX020','TX0','27.15',NULL,0,'2014-01-13 03:00:21'),(16140,12928,'Y','18','021','EC','A','','','AC','0001110371','0001110371','OH00001448700','IL','1','Jelinek','Julie','Bess','','','34','391806999','24 METLIN AVE',0,'AKRON','OH','44302','1023','CY','39153','1976-02-11','F','M',':RET:2106-3','N','021','HLT','1457089','52664OH151001501','2014-02-01','2014-01-03 12:43:07','319.00',NULL,NULL,'651.54','332.54','R-OH012','OH0','331.12',NULL,0,'2014-01-04 02:05:58'),(25484,20218,'N','19','021','EC','A',NULL,NULL,'','0000289578','0000854247','','IL','1','Werring','Megan','N','','','34','271987701','2896 STATE ROUTE 286',0,'WILLIAMSBURG','OH','45176','6527','CY','39015','1994-10-07','F','',':RET:2106-3','N','021','HLT','3367977','92036OH005000601','2014-04-01','2014-02-25 10:39:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-02-25 21:31:44'),(25652,20351,'Y','18','021','EC','A','','','AC','0000178944','0000178944','OH00003187502','IL','1','Schneider','Rachael','','','','34','284880705','18 W 5TH ST',0,'FREDERICKTOWN','OH','43019','1279','CY','39083','1988-01-14','F','U',':RET:2106-3','N','021','DEN','3007414','99734OH005000401','2014-04-01','2014-02-22 11:56:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:39'),(28925,22892,'Y','18','021','EC','A','','','AC','0000578849','0000578849','OH00003612179','31','1','Clarke','Laura','','','','34','301448959','7191 hart st',0,'Mentor','OH','44060',NULL,'CY','39085','1959-08-24','F','U',':RET:2106-3','T','021','DEN','4226708','99734OH005000301','2014-04-01','2014-03-10 13:01:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:00:33'),(334,274,'Y','18','021','EC','A','','','AC','0000243697','0000243697','OH00000223894','IL','1','Johnson','Michael','','','','34','283708964','5827 BEECHAM DR',0,'HUBER HEIGHTS','OH','45424','4207','CY','39113','1974-08-04','M','U',NULL,'N','021','DEN','831731','99734OH005000301','2014-01-01','2013-10-11 15:54:42','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:31:45'),(1159,956,'Y','18','021','EC','A','','','AC','0000105095','0000105095','LA00000917581','IL','1','Charters','Riley','','','','34','533171076','7926 NELSON ST',0,'NEW ORLEANS','LA','70125','4037','CY','22071','1987-12-20','M','U',':RET:2106-3','N','021','DEN','742966','18575LA002000201','2014-01-01','2013-12-03 14:24:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:51'),(14062,11205,'Y','18','021','EC','A','','','AC','0001210928','0001210928','OH00001489053','IL','1','Wood','Leslie','','','','34','295740847','1024 Chandler Ave',0,'Akron','OH','44314',NULL,'CY','39153','1979-06-18','F','M',':RET:2106-3','T','021','DEN','1938024','99734OH005000401','2014-02-01','2013-12-26 00:01:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:00:36'),(24281,19283,'N','01','021','EC','A',NULL,NULL,'','0000614154','0000821060','','IL','1','Gay','Vicki','Michelle','','','34','291666265','2600 EDGEBROOK AVE',0,'AKRON','OH','44312','1569','CY','39153','1958-02-16','F','',':RET:2106-3','N','021','DEN','3234618','99734OH005000401','2014-03-01','2014-02-18 17:04:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-18 21:30:07'),(2708,2192,'N','19','021','EC','A',NULL,NULL,'','0000655790','0000661315','','IL','1','Toth','Kayla',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-02-08','F','',':RET:2106-3','N','021','HLT','428018','52664OH151001501','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 19:47:55'),(2919,2353,'Y','18','021','EC','A','','','AC','0000031910','0000031910','OH00000240208','IL','1','Curry','Rodney','','','','34','291722798','2490 ST RT 545',0,'Mansfield','OH','44905',NULL,'CY','39139','1961-04-26','M','M',':RET:2106-3','N','021','DEN','312315','99734OH005000401','2014-01-01','2013-12-06 17:15:37','0.00',NULL,NULL,'31.57','31.57','R-OH007','OH0','0.00',NULL,0,'2013-12-25 20:15:44'),(7819,6194,'Y','18','021','EC','A','','','AC','0001194122','0001194122','TX00000007716','IL','1','Campbell','Deidra','','','','34','455576941','3017 SW 27th Ave.',0,'Amarillo','TX','79109',NULL,'CY','48375','1979-06-13','F','U',':RET:2054-5','T','021','DEN','1914295','33348TX002000201','2014-01-01','2013-12-20 18:16:32','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 03:04:08'),(7634,6043,'Y','18','021','EC','A','','','AC','0000290753','0000290753','OH00001185950','IL','1','Everhart','Laura','','','','34','343584418','325 Forest Avenue',0,'Cincinnati','OH','45229',NULL,'CY','39061','1968-03-25','F','U',NULL,'N','021','DEN','1161997','99734OH005000301','2014-01-01','2013-10-14 12:06:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:46:21'),(7271,5766,'Y','18','021','EC','A','','','AC','0000732696','0000732696','TX00000133710','IL','1','simmons','warreneka','','','','34','453679124','229 N 10TH ST',0,'ARANSAS PASS','TX','78336','4134','CY','48409','1983-08-10','F','U',NULL,'N','021','DEN','371799','33348TX002000201','2014-01-01','2013-12-14 11:27:14','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 02:02:25'),(4808,3811,'Y','18','021','EC','A','','','AC','0000540275','0000540275','OH00000302407','IL','1','Miller','Danny','','','','34','280706048','1215 BROCKLEY AVE',0,'LAKEWOOD','OH','44107','2438','CY','39035','1974-08-28','M','U',':RET:2106-3','N','021','DEN','1091855','99734OH005000301','2014-01-01','2013-12-08 06:51:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:16:43'),(23926,19026,'Y','18','024','14','A','','','TE','0000949487','0000949487','','IL','1','Overfield','Jon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-02-02','M','',NULL,NULL,NULL,'','56941','','2014-02-28','2014-02-14 17:08:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-14 22:00:09'),(6444,5110,'Y','18','021','EC','A','','','AC','0000340263','0000340263','OH00000297260','IL','1','Momenee','Jackie','','','','34','276640605','7509 NORDIC WAY CT',0,'MAUMEE','OH','43537','9484','CY','39095','1963-08-11','F','R',':RET:2106-3','N','021','HLT','71922','92036OH004002601','2014-01-01','2013-12-10 20:00:30','0.00',NULL,NULL,'280.03','280.03','R-OH001','OH0','280.03',NULL,0,'2013-12-26 00:49:32'),(22679,18110,'N','01','021','EC','A',NULL,NULL,'','0000097671','0000849610','','IL','1','AGUILAR','MARIA','G','','','34','467894062','2007 OLMITOS AVE',0,'SAN JUAN','TX','78589','9793','CY','48215','1960-12-24','F','',':RET:2106-3','N','021','DEN','3824477','33348TX002000201','2014-03-01','2014-02-11 16:43:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:46'),(6042,4785,'Y','18','024','14','A','','','TE','0001239086','0001239086','','IL','1','DENSON','KIRBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-25','M','',NULL,NULL,NULL,'','362812','','2013-12-01','2013-12-01 13:20:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:01:26'),(20637,16491,'Y','18','021','EC','A','','','AC','0000370871','0000370871','TX00002275231','IL','1','Nuno','Fidel','','','','34','548674512','4914 Monteith Drive',0,'Spring','TX','77373',NULL,'CY','48201','1981-06-06','M','M',NULL,'N','021','DEN','3483239','33348TX002000201','2014-03-01','2014-01-30 11:30:27','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-30 21:00:31'),(19369,15440,'Y','18','021','EC','A','','','AC','0000624003','0000624003','OH00002379603','IL','1','Little','Dianna','','','','34','282743100','356 Munroe Falls ave.',0,'Cuyahoga falls','OH','44221',NULL,'CY','39153','1963-01-01','F','M',':RET:2106-3','T','021','HLT','1491768','52664OH151001304','2014-03-01','2014-01-21 17:05:33','168.00',NULL,NULL,'478.30','310.30','R-OH012','OH0','478.30',NULL,1,'2014-01-22 03:22:35'),(18870,15032,'Y','18','021','EC','A','','','AC','0002288765','0002288765','LA00001442087','31','1','Gilleland','James','','','','34','426967946','POBOX 1684',0,'Gray','LA','70359',NULL,'CY','22057','1950-11-01','M','U',':RET:2106-3','T','021','DEN','2919282','18575LA002000201','2014-03-01','2014-01-16 12:03:57','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-17 03:36:23'),(26204,20782,'Y','18','021','EC','A','','','AC','0000827219','0000827219','OH00002625193','IL','1','DELUCA','JOSEPH','','','','34','285585440','1476 S CARPENTER RD',0,'BRUNSWICK','OH','44212','3855','CY','39103','1958-07-22','M','U',NULL,'T','021','HLT','3858200','52664OH151001304','2014-04-01','2014-02-27 10:54:33','319.00',NULL,NULL,'571.90','252.90','R-OH012','OH0','571.90',NULL,0,'2014-02-28 06:30:50'),(105,92,'Y','18','021','EC','A','','','AC','0000753756','0000753756','TX00000641345','IL','1','McKinney','Daniel','','','','34','457885702','1701 WINDSONG TRL',0,'RICHARDSON','TX','75081','4615','CY','48113','1952-02-19','M','R',':RET:2106-3','N','021','DEN','1227482','33348TX002000201','2014-01-01','2013-12-05 16:17:44','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:17:48'),(748,618,'Y','18','021','EC','A','','','AC','0000977523','0000977523','TX00001035042','IL','1','Harrington','Patrick','Joseph','','','34','506021243','1402 LAWNMONT DR',0,'ROUND ROCK','TX','78664','7665','CY','48491','1975-11-29','M','U',':RET:2106-3','N','021','DEN','956159','33348TX002000201','2014-01-01','2013-12-16 00:56:54','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:12'),(24942,19779,'N','19','021','EC','A',NULL,NULL,'','0000992656','0000582242','','IL','1','HUGHES','ALEX','','','','34','426939625','133 ASHTON DR',0,'BRANDON','MS','39047',NULL,'CY','28121','2003-01-04','M','',NULL,'N','021','DEN','3767833','46300MS002000201','2014-04-01','2014-02-19 21:54:42',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2014-02-20 22:00:06'),(24876,19724,'Y','18','021','EC','A','','','AC','0000630413','0000630413','OH00001922852','IL','1','GANTZ','MARGARET','I','','','34','283505398','1604 SYCAMORE ST',0,'CINCINNATI','OH','45202','6523','CY','39061','1950-10-22','F','U',':RET:2106-3','N','021','HLT','3503297','92036OH003001205','2014-04-01','2014-02-19 09:22:03','480.00',NULL,NULL,'661.77','181.77','R-OH004','OH0','661.77','CIC',0,'2014-02-20 05:34:35'),(24087,19151,'N','19','021','EC','A',NULL,NULL,'','0000289573','0000175152','','IL','1','ZILER','ABIGAIL','LOUISE','','','34','297084167','4870 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','2004-03-22','F','',':RET:2106-3','N','021','HLT','2907628','52664OH151001305','2014-03-01','2014-02-15 14:09:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:24'),(22797,18199,'Y','18','021','EC','A','','','AC','0000229477','0000229477','OH00002599670','IL','1','Swisher','Michelle','','','','34','282661844','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1964-08-12','F','M',':RET:2106-3','N','021','DEN','3292565','99734OH005000301','2014-03-01','2014-02-11 13:07:40','0.00',NULL,NULL,'87.78','87.78','R-OH006','OH0','0.00',NULL,0,'2014-02-11 21:01:52'),(7328,5807,'Y','18','021','EC','A','','','AC','0000347885','0000347885','OH00000902184','IL','1','Cross','Patricia','','','','34','288563227','688 REDWOOD CT',0,'CINCINNATI','OH','45244','1118','CY','39025','1954-09-10','F','M',NULL,'N','021','HLT','842657','92036OH003000601','2014-01-01','2013-12-14 12:43:51','628.00',NULL,NULL,'1191.97','563.97','R-OH005','OH0','583.55',NULL,0,'2013-12-26 02:03:46'),(22530,17988,'Y','18','021','EC','A','','','AC','0000321021','0000321021','OH00002185063','IL','1','REED','RICHARD','','','','34','299443334','1336 INMAN ST',0,'AKRON','OH','44306','2604','CY','39153','1949-07-29','M','M',NULL,'T','021','HLT','3380582','52664OH152000901','2014-03-01','2014-02-10 10:46:14','155.00',NULL,NULL,'563.50','408.50','R-OH012','OH0','563.50',NULL,0,'2014-02-10 21:31:31'),(3688,2952,'Y','18','021','EC','A','','','AC','0000262707','0000262707','OH00000087580','IL','1','Troyan','Jason','','','','34','278743672','PO Box 104',0,'Saint Clairsville','OH','43950',NULL,'CY','39013','1978-11-23','M','U',':RET:2106-3','N','021','DEN','532492','99734OH005000401','2014-01-01','2013-12-13 10:29:39','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:31:39'),(17153,13724,'Y','18','021','EC','A','','','AC','0001571177','0001571177','LA00001561273','IL','1','Morse','Darren','J','','','34','433732538','70330 A ST',0,'COVINGTON','LA','70433','5451','CY','22103','1976-07-07','M','M',':RET:2106-3','N','021','DEN','2051438','18575LA002000201','2014-02-01','2014-01-07 23:37:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:57'),(3792,3038,'Y','18','021','EC','A','','','AC','0000142808','0000142808','OH00000509483','IL','1','Norton','Ruth','','','','34','298505352','9496 Oak Dr',0,'LOVELAND','OH','45140',NULL,'CY','39165','1950-12-30','F','U',':RET:2106-3','N','021','DEN','56048','99734OH005000301','2014-01-01','2013-12-13 10:51:50','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:16'),(5849,4645,'Y','18','021','EC','A','','','AC','0000180341','0000180341','TX00000162168','IL','1','Corprew','Gerren','Demon','','','34','457816860','500 West Cartwright Rd',0,'Balch Springs','TX','75180',NULL,'CY','48113','1972-04-13','M','U',':RET:2054-5','N','021','DEN','2422023','33348TX002000201','2014-01-01','2013-12-24 00:20:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:44'),(5045,3994,'N','01','021','EC','A',NULL,NULL,'','0000207101','0000713607','','IL','1','Mohr','Cynthia','Joan','','','34','294600382','5191 SPENCER RD',0,'SPENCER','OH','44275','9704','CY','39103','1961-02-27','F','',NULL,'N','021','HLT','741981','52664OH151001501','2014-01-01','2013-12-07 17:34:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-25 22:48:07'),(21352,17065,'Y','18','024','14','A','','','TE','0000978851','0000978851','','IL','1','Nguyen','Quynh',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-12','M','',NULL,NULL,NULL,'','2368545','','2014-02-19','2014-02-04 10:26:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-04 21:00:38'),(13327,10640,'Y','18','021','EC','A','','','AC','0000824152','0000824152','TX00001171466','31','1','Alvarez','Israel','','','','34','465656110','p.o. Box 303',0,'Crystal City','TX','78839',NULL,'CY','48507','1983-12-04','M','U',NULL,'T','021','DEN','1943294','33348TX002000201','2014-01-01','2013-12-23 17:16:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:31'),(4115,3289,'Y','18','021','EC','A','','','AC','0001179611','0001179611','OH00000598924','IL','1','YATES','TINA','','','','34','299764066','2397 ANGELFIRE DR',0,'GROVE CITY','OH','43123','1053','CY','39049','1979-09-20','F','R',':RET:2106-3','N','021','DEN','2095780','99734OH005000301','2014-01-01','2013-12-16 20:51:04','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:06'),(9044,7176,'Y','18','021','EC','A','','','AC','0000318398','0000318398','OH00000394341','IL','1','Park','James','P','','','34','274849709','7189 Bender Road',0,'Canal Fulton','OH','44614',NULL,'CY','39153','1985-10-16','M','U',':RET:2106-3','N','021','HLT','2460498','52664OH151001304','2014-01-01','2013-12-18 16:26:02','37.00',NULL,NULL,'242.41','205.41','R-OH012','OH0','242.41',NULL,0,'2013-12-26 04:05:54'),(8040,6365,'N','01','021','EC','A',NULL,NULL,'','0000700370','0000568019','','IL','1','ZELLER','AIMEE','L','','','34','274587920','1501 MERRILL AVE',0,'KENT','OH','44240','6315','CY','39133','1956-12-09','F','',':RET:2106-3','N','021','HLT','1878932','52664OH152000901','2014-01-01','2013-12-20 08:08:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2013-12-26 03:09:24'),(20779,16601,'Y','18','021','EC','A','','','AC','0000167730','0000167730','TX00002340124','IL','1','Garrison','Kathy','','','','34','453476407','4615 S. Virginia',0,'Amarillo','TX','79109',NULL,'CY','48381','1973-01-30','F','U',':RET:2106-3','N','021','DEN','3125894','33348TX002000201','2014-03-01','2014-01-30 19:43:49','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-31 21:00:08'),(16266,13024,'Y','18','021','EC','A','','','AC','0000600811','0000600811','OH00002269618','IL','1','Mckee','Shawn','','','','34','293923488','4940 COLUMBIA CIR',0,'WEST CHESTER','OH','45011','9761','CY','39017','1988-06-27','M','R',':RET:2106-3','N','021','DEN','2399552','99734OH005000401','2014-02-01','2014-01-06 15:14:48','0.00',NULL,NULL,'50.05','50.05','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:10'),(5840,4639,'Y','18','021','EC','A','','','AC','0000921394','0000921394','TX00000605434','IL','1','regian','jamie','','','','34','641093982','10852 Chickasha Dr',0,'Tyler','TX','75703',NULL,'CY','48423','1989-06-12','F','U',':RET:2106-3','N','021','DEN','1623337','33348TX002000201','2014-01-01','2013-12-23 23:50:41','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 23:48:32'),(7478,5917,'Y','18','021','EC','A','','','AC','0001109203','0001109203','OH00000485850','IL','1','Scheetz','Teresa','','','','34','277568034','3353 MEHAFFIE DR NE',0,'CANTON','OH','44721','2286','CY','39151','1952-06-05','F','U',NULL,'N','021','DEN','443491','99734OH005000401','2014-01-01','2013-12-15 10:57:00','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 02:31:19'),(23973,19060,'Y','18','021','EC','A','','','AC','0001476653','0001476653','LA00002172006','IL','1','WICKER','JOHN','','','','34','240116557','1416 JACKSON ST',0,'MONROE','LA','71202','2026','CY','22073','1958-08-04','M','M',':RET:2106-3','N','021','DEN','3131012','18575LA002000201','2014-03-01','2014-02-14 22:15:33','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-15 22:00:16'),(26458,20985,'Y','18','024','14','A','','','TE','0000923227','0000923227','','IL','1','Casby','Fred',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-02-14','M','',NULL,NULL,NULL,'','1215517','','2014-03-31','2014-02-27 10:37:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:30:29'),(28630,22657,'Y','18','024','14','A','','','TE','0000672450','0000672450','','IL','1','SMITH','MARGARET',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-02-02','F','',NULL,NULL,NULL,'','3745560','','2014-03-07','2014-03-07 19:03:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-08 21:30:26'),(24503,19465,'N','01','021','EC','A',NULL,NULL,'','0000344040','0000078437','','IL','1','RAMIREZ','DIANA','','','','34','462974393','321 CIRUELA LN',0,'BROWNSVILLE','TX','78521','7368','CY','48061','1979-11-06','F','',':RET:2106-3','N','021','DEN','2800017','33348TX002000201','2014-04-01','2014-02-18 22:42:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:49:53'),(20458,16342,'Y','18','021','EC','A','','','AC','0000780542','0000780542','OH00002083305','IL','1','Cooper','Leslie','','','','34','270708435','135 CHESTNUT LN',0,'CLEVELAND','OH','44143','1030','CY','39035','1962-08-12','F','M',NULL,'N','021','DEN','3197262','99734OH005000401','2014-03-01','2014-01-29 08:54:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:49'),(1335,1105,'Y','18','021','EC','A','','','AC','0000860936','0000860936','OH00000826130','IL','1','Bashor','Harold','','','','34','268485568','100 E GAY ST',0,'COLUMBUS','OH','43215','3248','CY','39049','1951-02-06','M','U',':RET:2106-3','N','021','DEN','138932','99734OH005000401','2014-01-01','2013-11-06 20:22:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:32:14'),(16600,13277,'N','01','021','EC','A',NULL,NULL,'','0002268057','0001677509','','IL','1','WILEY','MICHAEL','','','','34','438988079','39389 BAYRIDGE DR',0,'PRAIRIEVILLE','LA','70769','4978','CY','22005','1956-03-07','M','',NULL,'N','021','DEN','2394431','18575LA002000201','2014-02-01','2014-01-07 13:13:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-08 18:24:04'),(16372,13101,'Y','18','021','EC','A','','','AC','0000248090','0000248090','TX00002253967','IL','1','Coronado','Francisco','Javier','','','34','455871157','4220 LANGDON DR',0,'CONVERSE','TX','78109','5159','CY','48029','1972-01-22','M','M',NULL,'N','021','DEN','2215004','33348TX002000101','2014-02-01','2014-01-06 13:07:46','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2014-01-07 04:03:04'),(9024,7160,'Y','18','024','14','A','','','TE','0000780470','0000780470','','IL','1','Treadway','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-04-07','F','',NULL,NULL,NULL,'','43499','','2013-12-18','2013-12-18 09:22:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:24'),(5829,4629,'Y','18','021','EC','A','','','AC','0000189820','0000189820','TX00001101504','IL','1','Moreno','Gregorio','','','','34','507748645','106 W WANDA DR',0,'GARLAND','TX','75040','7964','CY','48113','1950-03-12','M','U',':RET:2106-3','N','021','DEN','2196262','33348TX002000201','2014-01-01','2013-12-23 23:13:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:14'),(25661,20358,'N','01','021','EC','A',NULL,NULL,'','0001084198','0000821065','','IL','1','KAUR','PARVINDER','','','','34','299042763','374 PRESERVE LN',0,'MACEDONIA','OH','44056','1793','CY','39153','1977-12-20','F','',':RET:2029-7','N','021','HLT','3179987','52664OH152000901','2014-04-01','2014-02-22 12:00:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','200.91',NULL,0,'2014-02-26 08:30:45'),(26055,20664,'Y','18','021','EC','A','','','AC','0001022835','0001022835','OH00003422494','IL','1','Hernandez','Eliezer','','','','34','583937625','1634 20TH ST',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1976-08-10','M','U',NULL,'T','021','HLT','3298391','52664OH151001501','2014-04-01','2014-02-26 17:38:36','67.00',NULL,NULL,'380.79','313.79','R-OH012','OH0','380.79',NULL,0,'2014-02-26 21:02:36'),(17990,14377,'Y','18','021','EC','A','','','AC','0000165104','0000165104','OH00002052461','IL','1','Forsch','Jamie','','','','34','272743638','1104 GEORGIA AVE',0,'AKRON','OH','44306','3032','CY','39153','1976-12-12','F','U',NULL,'N','021','HLT','2818728','52664OH151001304','2014-02-01','2014-01-14 17:46:33','94.00',NULL,NULL,'276.08','182.08','R-OH012','OH0','276.08',NULL,0,'2014-01-15 02:06:56'),(5197,4123,'Y','18','021','EC','A','','','AC','0000200751','0000200751','OH00000476793','IL','1','Caryl Ropp','Paul','','','','34','299600761','53 MUTUAL UNION RD N',0,'CABLE','OH','43009','9607','CY','39021','1963-12-13','M','U',':RET:2106-3','N','021','DEN','1824771','99734OH005000401','2014-01-01','2013-12-19 14:11:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:03:55'),(6876,5453,'Y','18','021','EC','A','','','AC','0000230400','0000230400','OH00000354086','IL','1','stidham','scott','','','','34','274881300','2287 HIBISCUS DR',0,'LOVELAND','OH','45140','1355','CY','39165','1972-11-19','M','U',':RET:2106-3','N','021','DEN','736895','99734OH005000401','2014-01-01','2013-11-03 12:25:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:32:07'),(15526,12422,'Y','18','021','EC','A','','','AC','0001958377','0001958377','LA00001126775','IL','1','DeDon','Linda','','','','34','438982417','21374 N Dutch Rd',0,'Franklinton','LA','70438',NULL,'CY','22117','1956-10-18','F','M',':RET:2106-3','N','021','DEN','1513343','18575LA002000201','2014-02-01','2013-12-31 10:07:52','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:28'),(14060,11203,'Y','18','021','EC','A','','','AC','0000323508','0000323508','OH00001677218','IL','1','bulti','magersa','','','','34','606138063','4884 NOBILITY DR',0,'COLUMBUS','OH','43231','8800','CY','39049','1981-02-08','M','M',':RET:2054-5','N','021','DEN','1781885','99734OH005000401','2014-02-01','2013-12-25 21:59:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:33'),(23016,18351,'Y','18','021','EC','A','','','AC','0001959810','0001959810','LA00001935656','IL','1','Cummings','Ashley','','','','34','434614444','14924 FOREST GROVE AVE',0,'BATON ROUGE','LA','70818','4228','CY','22033','1983-11-09','F','U',NULL,'N','021','DEN','2690892','18575LA002000101','2014-03-01','2014-02-12 12:02:37','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-12 21:30:27'),(23445,18676,'Y','18','024','14','A','','','TE','0000324261','0000324261','','IL','1','griffith','melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-12','F','',NULL,NULL,NULL,'','3839264','','2014-02-13','2014-02-13 12:40:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-13 22:01:34'),(89,78,'Y','18','021','EC','A','','','AC','0001190116','0001190116','TX00001108209','IL','1','Franklin','Eugene','','','','34','459924794','922 HANNAH FALLS LN',0,'FRESNO','TX','77545','7196','CY','48157','1951-03-26','M','U',':RET:2054-5','N','021','DEN','791064','33348TX002000201','2014-01-01','2013-12-04 19:06:26','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:17:23'),(19137,15248,'Y','18','021','EC','A','','','AC','0000316891','0000316891','TX00001510483','IL','1','Carson','Annette','','','','34','466158389','1902 PECAN ST',0,'SAN ANGELO','TX','76903','3061','CY','48451','1966-07-24','F','M',':RET:2054-5','T','021','DEN','1889400','33348TX002000201','2014-03-01','2014-01-18 22:44:35','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-21 08:45:27'),(2213,1823,'Y','18','021','EC','A','','','AC','0001065954','0001065954','OH00000597462','IL','1','Tomer','Kathleen','','','','34','298482936','695 Newton Street',0,'Barberton','OH','44203',NULL,'CY','39153','1949-08-14','F','U',':RET:2106-3','N','021','HLT','603654','52664OH151001305','2014-01-01','2013-12-10 16:37:08','521.00',NULL,NULL,'669.00','148.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 19:20:21'),(15485,12389,'Y','18','021','EC','A','','','AC','0000796971','0000796971','OH00001156737','IL','1','Knott','Darlene','','','','34','287664518','72 Waynesburg Rd.',0,'Carrollton','OH','44615',NULL,'CY','39019','1962-06-05','F','M',':RET:2106-3','N','021','DEN','1860404','99734OH005000401','2014-02-01','2013-12-31 09:41:13','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,1,'2014-01-02 04:29:18'),(3818,3057,'N','01','021','EC','A',NULL,NULL,'','0000130677','0000496735','','IL','1','Reno','John','C','','','34','301781544','180 Starr Drive',0,'Nelsonville','OH','45764',NULL,'CY','39009','1978-07-06','M','',':RET:2106-3','N','021','DEN','958682','99734OH005000301','2014-01-01','2013-12-13 14:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:52'),(14350,11444,'N','01','021','EC','A',NULL,NULL,'','0000514453','0000741720','','IL','1','Chen','Yuannan','','','','34','515061720','1079 STREAM RIDGE LN',0,'CINCINNATI','OH','45255','4323','CY','39061','1968-05-18','M','',':RET:2034-7','N','021','HLT','1945675','92036OH006001201','2014-02-01','2013-12-26 17:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.84',NULL,0,'2013-12-27 02:08:05'),(7239,5740,'Y','18','021','EC','A','','','AC','0000909629','0000909629','LA00000941113','IL','1','Slattery','Ian','','','','34','436435358','5142 MURPHY DR',0,'METAIRIE','LA','70006','2164','CY','22051','1977-05-19','M','U',':RET:2106-3','N','021','DEN','673583','18575LA002000201','2014-01-01','2013-12-13 22:18:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:37'),(3398,2727,'Y','18','024','14','A','','','TE','0001375430','0001375430','','IL','1','Levy','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-09','M','',NULL,NULL,NULL,'','2560441','','2013-12-22','2013-12-22 10:08:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:18:03'),(27903,22075,'Y','18','021','EC','A','','','AC','0000755609','0000755609','TX00002548395','IL','1','MIRANDA','MARTHA','','','','34','560973246','12448 FLORA ALBA DRIVE',0,'EL PASO','TX','79928',NULL,'CY','48141','1987-05-28','F','U',NULL,'N','021','DEN','3088103','33348TX002000201','2014-04-01','2014-03-05 18:30:02','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-06 21:00:10'),(28802,22798,'Y','18','021','EC','A','','','AC','0000963305','0000963305','OH00003457904','IL','1','Bower','Norman','Ray','','','34','288702110','5207 SOUTH ST',0,'VERMILION','OH','44089','1348','CY','39043','1963-09-28','M','U',':RET:2106-3','T','021','DEN','4279564','99734OH005000301','2014-04-01','2014-03-09 12:58:09','0.00',NULL,NULL,'59.76','59.76','R-OH006','OH0','0.00',NULL,0,'2014-03-09 21:00:49'),(1131,931,'Y','18','021','EC','A','','','AC','0000295881','0000295881','TX00000366532','IL','1','Cordova','Rosario','G','','','34','458576036','163 Yucca Trailer Park Rd',0,'Del Rio','TX','78840',NULL,'CY','48465','1970-11-25','F','U',':RET:2106-3','N','021','DEN','476585','33348TX002000101','2014-01-01','2013-12-03 17:40:17','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:18:04'),(2279,1859,'Y','18','021','EC','A','','','AC','0000618341','0000618341','OH00000199747','IL','1','Jordan','Keith','','','','34','279645492','4770 RIVERWOOD DR',0,'MADISON','OH','44057','9794','CY','39085','1958-09-18','M','M',':RET:2106-3','N','021','DEN','321330','99734OH005000301','2014-01-01','2013-12-09 12:27:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:30:31'),(20661,16511,'Y','18','021','EC','A','','','AC','0000132642','0000132642','TX00002204737','IL','1','Hawkins','Robin','','','','34','465658246','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1981-03-05','F','R',':RET:2054-5','N','021','DEN','3106001','33348TX002000201','2014-03-01','2014-01-30 17:28:09','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2014-01-30 21:00:43'),(3145,2529,'Y','18','021','EC','A','','','AC','0000146742','0000146742','TX00001088363','31','1','bennett','felicia','','','','34','461435990','p.o. box 994',0,'huntsville','TX','77342',NULL,'CY','48471','1977-12-14','F','U',':RET:2054-5','N','021','DEN','572573','33348TX002000201','2014-01-01','2013-11-18 10:22:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:53'),(19259,15348,'Y','18','021','EC','A','','','AC','0002154905','0002154905','LA00002159412','IL','1','Lewis','Joann','','','','34','436794303','2504 St. Phillips St',0,'New Orleans','LA','70119',NULL,'CY','22071','1990-08-14','F','U',':RET:2054-5','T','021','DEN','2021575','18575LA002000201','2014-03-01','2014-01-20 16:03:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:46:48'),(17192,13756,'N','01','021','EC','A',NULL,NULL,'','0000482203','0000212178','','IL','1','Veit','Lisa','K','','','34','287720895','412 West Vine Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1961-03-19','F','',':RET:2106-3','N','021','HLT','1960959','92036OH003001505','2014-02-01','2014-01-07 20:37:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.63',NULL,0,'2014-01-13 02:22:19'),(16881,13507,'Y','18','021','EC','A','','','AC','0000048401','0000048401','TX00001693599','IL','1','Ingram','Karla','','','','34','463880028','5519 W CROSS ST',0,'ODESSA','TX','79763','8836','CY','48135','1951-01-13','F','U',':RET:2106-3','N','021','DEN','2277038','33348TX002000201','2014-02-01','2014-01-09 09:48:04','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-13 02:19:21'),(15252,12190,'Y','18','021','EC','A','','','AC','0000521955','0000521955','OH00001426151','IL','1','Courtney','Brian','L','','','34','296581108','176 schonhardt st',0,'Tiffin','OH','44883',NULL,'CY','39147','1964-02-23','M','U',':RET:2106-3','N','021','HLT','1997826','92036OH003002706','2014-02-01','2013-12-30 15:01:44','290.00',NULL,NULL,'347.41','57.41','R-OH006','OH0','347.41',NULL,0,'2014-01-01 12:08:59'),(13790,11007,'Y','18','021','EC','A','','','AC','0000391350','0000391350','MS00000848423','IL','1','Stein','Anne','','','','34','456330167','402 Ruby Cove',0,'Madison','MS','39110',NULL,'CY','28089','1956-08-18','F','U',':RET:2106-3','N','021','DEN','1910136','46300MS002000101','2014-01-01','2013-12-22 22:47:24','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:02'),(22522,17981,'Y','18','021','EC','A','','','AC','0000165126','0000165126','OH00001897131','IL','1','davidson','michelle','','','','34','268847027','1077 SPLIT RAIL CT',0,'BATAVIA','OH','45103','1422','CY','39025','1984-09-15','F','U',':RET:2106-3','N','021','HLT','2852559','92036OH004000601','2014-03-01','2014-02-10 17:56:16','116.00',NULL,NULL,'193.15','77.15','R-OH005','OH0','193.15',NULL,0,'2014-02-10 21:31:26'),(24129,19179,'N','19','021','EC','A',NULL,NULL,'','0002157211','0001689470','','IL','1','Strohmeyer','Christina','Marie','','','34','435891983','110 EVANGELINE LN',0,'DESTREHAN','LA','70047','3045','CY','22089','1994-05-01','F','',':RET:2106-3','N','021','DEN','2932534','18575LA002000101','2014-03-01','2014-02-15 14:42:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2014-02-15 22:01:47'),(25551,20272,'Y','18','021','EC','A','','','AC','0001904943','0001904943','LA00001776279','IL','1','JONES','RONETTA','','','','34','437614055','5314 LASALLE ST',0,'NEW ORLEANS','LA','70115','6453','CY','22071','1985-11-18','F','U',':RET:2054-5','N','021','DEN','3129951','18575LA002000201','2014-04-01','2014-02-23 15:52:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 08:00:18'),(2451,1994,'N','19','021','EC','A',NULL,NULL,'','0000015218','0000193432','','IL','1','Sabath','Zena','Rei','','','34','576597426','4214 Waterside Ct.',0,'Missouri City','TX','77459',NULL,'CY','48157','1992-03-31','F','',':RET:2039-6^:RET:2106-3','N','021','DEN','613568','33348TX002000101','2014-01-01','2013-12-08 20:25:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 19:34:40'),(19820,15803,'Y','18','024','14','A','','','TE','0000206707','0000206707','','IL','1','Michlin','Laurence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-07-20','M','',NULL,NULL,NULL,'','1866116','','2014-01-24','2014-01-24 12:39:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:13'),(5825,4626,'Y','18','021','EC','A','','','AC','0000709415','0000709415','TX00001140226','IL','1','Balahutrak','Michael','','','','34','290469093','2528 DRYDEN RD',0,'HOUSTON','TX','77030','1004','CY','48201','1951-02-15','M','M',':RET:2106-3','N','021','DEN','1456753','33348TX002000201','2014-01-01','2013-12-23 22:55:53','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:48:07'),(5143,4077,'Y','18','021','EC','A','','','AC','0000934649','0000934649','OH00001096333','IL','1','ROWLAND','CHARLES','','','','34','296620546','9 KATHY CT',0,'NEW PARIS','OH','45347','1315','CY','39135','1956-08-21','M','M',':RET:2106-3','N','021','DEN','1898433','99734OH005000401','2014-01-01','2013-12-18 21:48:26','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:02:36'),(3603,2889,'Y','18','021','EC','A','','','AC','0000309439','0000309439','OH00000214105','IL','1','Haven','Alan','','','','34','275706108','5992 HEYL RD',0,'WOOSTER','OH','44691','7454','CY','39169','1959-10-22','M','M',NULL,'N','021','HLT','1869103','52664OH152000901','2014-01-01','2013-12-22 12:30:16','699.00',NULL,NULL,'863.29','164.29','R-OH014','OH0','348.73',NULL,0,'2013-12-25 21:23:20'),(19256,15345,'Y','18','024','14','A','','','TE','0000517634','0000517634','','IL','1','paul','paula',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-04-19','F','',NULL,NULL,NULL,'','886319','','2014-01-20','2014-01-20 10:18:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-21 08:46:46'),(17965,14356,'Y','18','021','EC','A','','','AC','0001096778','0001096778','OH00001492236','IL','1','ANDREWS','DEBRA','','','','34','294561632','2336 24TH ST',0,'CUYAHOGA FALLS','OH','44223','1510','CY','39153','1965-11-03','F','M',':RET:2106-3','N','021','HLT','2117705','52664OH151001305','2014-02-01','2014-01-13 19:11:53','619.00',NULL,NULL,'799.93','180.93','R-OH012','OH0','364.62',NULL,0,'2014-01-15 02:06:47'),(23500,18719,'Y','18','021','EC','A','','','AC','0000038585','0000038585','TX00002181414','IL','1','ROGERS','RANDY','','','','34','458578226','117 PR 6254',0,'MINEOLA','TX','75773',NULL,'CY','48499','1979-10-25','M','M',':RET:2106-3','T','021','DEN','3799697','33348TX002000101','2014-03-01','2014-02-13 08:23:45','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-02-13 22:02:07'),(26460,20987,'Y','18','024','14','A','','','TE','0001157723','0001157723','','IL','1','Perry','Raquell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-28','F','',NULL,NULL,NULL,'','1504785','','2014-03-31','2014-02-27 11:37:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:30:30'),(27518,21770,'Y','18','021','EC','A','','','AC','0000699332','0000699332','OH00002868592','IL','1','Randolph','Clayton','','','Jr','34','280629828','740 Inwood St.',0,'Maumee','OH','43537',NULL,'CY','39095','1966-02-21','M','U',':RET:2106-3','N','021','HLT','3392001','92036OH006002601','2014-04-01','2014-03-04 16:31:30','0.00',NULL,NULL,'252.84','252.84','R-OH001','OH0','252.84',NULL,0,'2014-03-04 21:02:38'),(82,71,'Y','18','021','EC','A','','','AC','0001230358','0001230358','OH00001113118','IL','1','Whitehouse','Tamara','','','','34','270680616','1250 LANE WEST RD SW',0,'WARREN','OH','44481','9753','CY','39155','1966-05-09','F','U',':RET:2106-3','N','021','DEN','333240','99734OH005000301','2014-01-01','2013-12-05 17:44:11','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:17:10'),(703,580,'Y','18','021','EC','A','','','AC','0000933603','0000933603','LA00000267505','IL','1','Nathan','Kathryn','Leigh','','','34','433742127','2019 Royal Street',0,'New Orleans','LA','70116',NULL,'CY','22071','1963-09-09','F','U',':RET:2106-3','N','021','DEN','1020169','18575LA002000201','2014-01-01','2013-12-15 19:23:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:02:57'),(18849,15011,'N','01','021','EC','A',NULL,NULL,'','0001129038','0000697939','','IL','1','DAVIS','TREVA','','','','34','301665636','417 RED ROCK DRIVE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1959-01-16','F','',':RET:2106-3','N','021','HLT','2529099','52664OH151001301','2014-02-01','2014-01-15 19:05:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-01-17 03:36:15'),(4128,3296,'Y','18','021','EC','A','','','AC','0000092494','0000092494','OH00000249920','IL','1','KING','DAVID','','','','34','302586256','52744 TRINTER RD',0,'VERMILION','OH','44089','9407','CY','39093','1957-02-03','M','U',NULL,'N','021','DEN','2242653','99734OH005000301','2014-01-01','2013-12-17 05:02:34','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:48:20'),(7050,5600,'Y','18','021','EC','A','','','AC','0000173817','0000173817','OH00000037788','IL','1','Gunsher','Joshua','','','','34','149749632','5360 PINEVALLEY DR',0,'WEST CHESTER','OH','45069','1868','CY','39017','1976-07-14','M','M',NULL,'T','021','DEN','2576297','99734OH005000301','2014-01-01','2013-12-24 18:44:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:49:40'),(17387,13912,'Y','18','021','EC','A','','','AC','0000653212','0000653212','OH00001537894','IL','1','Jones','Amanda','','','','34','288909909','553 Aston View Ln',0,'Cleves','OH','45002',NULL,'CY','39061','1987-05-23','F','U',NULL,'N','021','DEN','1553330','99734OH005000401','2014-02-01','2014-01-10 11:57:20','0.00',NULL,NULL,'50.05','50.05','R-OH004','OH0','0.00',NULL,0,'2014-01-13 03:00:09'),(9224,7319,'Y','18','021','EC','A','','','AC','0000645967','0000645967','OH00000441428','IL','1','Cleland','Joella','','','','34','383642362','6083 THIEL RD',0,'HICKSVILLE','OH','43526','9739','CY','39039','1957-08-12','F','M',NULL,'N','021','HLT','1556135','92036OH005002604','2014-01-01','2013-12-18 12:22:49','214.00',NULL,NULL,'454.92','240.92','R-OH001','OH0','454.92',NULL,0,'2013-12-26 04:10:18'),(9323,7390,'Y','18','021','EC','A','','','AC','0001620051','0001620051','LA00001073722','IL','1','HOOPER','MEGHAN','','','','34','632245320','704 DARLENE AVE',0,'METAIRIE','LA','70003','3808','CY','22051','1991-01-13','F','U',':RET:2106-3','N','021','DEN','1429320','18575LA002000101','2014-01-01','2013-12-21 13:51:24','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:32'),(23491,18712,'N','01','021','EC','A',NULL,NULL,'','0000220020','0000204596','','IL','1','Dodds','Sean','Eugene','','','34','274866716','909 PRIMROSE DR',0,'WAPAKONETA','OH','45895','1050','CY','39011','1974-08-08','M','',':RET:2106-3','N','021','HLT','3412805','92036OH006001501','2014-03-01','2014-02-12 20:29:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.27',NULL,0,'2014-02-13 22:02:02'),(23905,19016,'Y','18','021','EC','A','','','AC','0001004390','0001004390','OH00002461813','IL','1','Edwards','Cynthia','','','','34','591054531','902 COMMONS DR',0,'MILFORD','OH','45150','1925','CY','39025','1972-07-24','F','U',':RET:2106-3','N','021','HLT','3201528','92036OH002000601','2014-03-01','2014-02-14 15:55:11','39.00',NULL,NULL,'322.78','283.78','R-OH005','OH0','322.78',NULL,0,'2014-02-14 21:32:26'),(24956,19790,'Y','18','021','EC','A','','','AC','0002074923','0002074923','LA00002189058','IL','1','Pang','Laurel','','','','34','576419261','1204 LOWERLINE ST',0,'NEW ORLEANS','LA','70118','5235','CY','22071','1987-03-11','F','U',':RET:2034-7^:RET:2106-3','N','021','DEN','3093630','18575LA002000201','2014-04-01','2014-02-20 13:40:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:15'),(25516,20242,'N','01','021','EC','A',NULL,NULL,'','0000740334','0001066037','','IL','1','FREELAND','MARK','','','','34','281681605','14893 STATE ROUTE 136',0,'WINCHESTER','OH','45697',NULL,'CY','39001','1967-08-24','M','',':RET:2106-3','T','021','HLT','3084691','92036OH001000601','2014-04-01','2014-02-25 10:29:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','446.66',NULL,0,'2014-02-25 21:32:03'),(25756,20429,'Y','18','024','14','A','','','TE','0000853013','0000853013','','IL','1','davis','freddie','travis',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-07','M','',NULL,NULL,NULL,'','813117','','2014-03-11','2014-02-24 17:56:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 09:30:48'),(28239,22344,'Y','18','021','EC','A','','','AC','0000578830','0000578830','OH00003155173','S3','1','Bregitzer','Kelly','','','','34','291152235','1551 POLK DR',0,'BRUNSWICK','OH','44212','3713','CY','39103','2009-12-29','F','U',':RET:2106-3','N','021','DEN','3873102','99734OH005000401','2014-04-01','2014-03-07 10:03:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78','CIC',0,'2014-03-07 21:00:09'),(6140,4869,'Y','18','021','EC','A','','','AC','0001005587','0001005587','LA00001175484','IL','1','ORGERON','CYNTHIA','','','','34','433923589','1616 LISA DR',0,'MARRERO','LA','70072','3624','CY','22051','1952-10-22','F','U',':RET:2106-3','N','021','DEN','1059182','18575LA002000201','2014-01-01','2013-11-21 16:26:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:16:13'),(21600,17249,'N','19','021','EC','A',NULL,NULL,'','0001076598','0000040985','','IL','1','SAMI','HAMZA','','','','34','274046251','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','1998-12-22','M','',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(21130,16885,'Y','18','021','EC','A','','','AC','0000304202','0000304202','TX00001667056','IL','1','NGUYEN','QUYNH','','','','34','231594666','2000 E ARAPAHO RD',0,'RICHARDSON','TX','75081','3180','CY','48113','1987-04-13','F','R',':RET:2047-9','N','021','DEN','3066732','33348TX002000201','2014-03-01','2014-02-03 15:06:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-03 21:00:17'),(15159,12115,'N','19','021','EC','A',NULL,NULL,'','0000116595','0001055328','','IL','1','Ustaszewski','Natasha','R','','','34','283984600','3201 Arctic Avenue',0,'Lewis Center','OH','43035',NULL,'CY','39041','1995-05-09','F','',NULL,'N','021','DEN','2566146','99734OH005000401','2014-02-01','2013-12-30 13:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:15'),(967,793,'Y','18','021','EC','A','','','AC','0000427107','0000427107','TX00000886312','IL','1','Ray','Larry','','','','34','456840646','1225 BUTTERCUP',0,'NEW BRAUNFELS','TX','78130','3559','CY','48091','1951-04-01','M','M',':RET:2106-3','N','021','DEN','676763','33348TX002000201','2014-01-01','2013-10-31 14:55:00','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-25 18:09:55'),(1451,1211,'Y','18','021','EC','A','','','AC','0000277274','0000277274','OH00000127856','IL','1','Knippen','Shannon','','','','34','302747886','26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','1975-07-16','F','M',':RET:2106-3','N','021','DEN','2201030','99734OH005000401','2014-01-01','2013-12-24 07:56:06','0.00',NULL,NULL,'71.95','71.95','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:48:07'),(14459,11536,'Y','18','021','EC','A','','','AC','0001567500','0001567500','LA00000131950','IL','1','Devoe','Lakuenya','','','','34','438691087','7041 East Tamaron Blvd.',0,'New Orleans','LA','70128',NULL,'CY','22071','1974-05-27','F','M',':RET:2054-5','N','021','DEN','2367134','18575LA002000201','2014-02-01','2013-12-27 16:07:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:43'),(14068,11210,'Y','18','021','EC','A','','','AC','0000544126','0000544126','OH00001177871','31','1','owens','barbara','','','','34','273529286','16803 talford st',0,'cleveland','OH','44128',NULL,'CY','39035','1951-02-11','F','U',NULL,'N','021','DEN','2543866','99734OH005000401','2014-02-01','2013-12-26 08:58:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:00:45'),(13659,10897,'N','01','021','EC','A',NULL,NULL,'','0002282432','0002122512','','IL','1','Wooten','Elton','','','Jr','34','438929716','2222 NIXON DR',0,'HOUMA','LA','70363','7031','CY','22109','1962-12-28','M','',':RET:2054-5','N','021','DEN','2451556','18575LA002000101','2014-01-01','2013-12-23 07:17:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 13:07:34'),(9063,7192,'Y','18','021','EC','A','','','AC','0001264324','0001264324','TX00001275399','IL','1','PRUITT','RUTH','NOEMI','','','34','210481377','1675 HAWES AVE',0,'WICHITA FALLS','TX','76301','7906','CY','48485','1973-02-20','F','M',NULL,'N','021','DEN','2425085','33348TX002000101','2014-01-01','2013-12-18 13:01:44','0.00',NULL,NULL,'27.15','27.15','R-TX025','TX0','27.15',NULL,0,'2013-12-26 04:06:24'),(21678,17311,'Y','18','021','EC','A','','','AC','0001255750','0001255750','LA00001586829','IL','1','wagner','sheena','','','','34','439559075','1338Maximilian st.',0,'baton rouge','LA','70802',NULL,'CY','22033','1984-12-18','F','U',':RET:2054-5','T','021','DEN','2931141','18575LA002000201','2014-03-01','2014-02-05 16:49:27','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:31:01'),(22477,17946,'N','19','021','EC','A',NULL,NULL,'','0000505768','0000851879','','IL','1','lindhorst','Madelyn','','','','34','271113625','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','2004-10-25','F','',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:01'),(24211,19229,'Y','18','021','EC','A','','','AC','0002264055','0002264055','LA00001860570','IL','1','Bethancourt','Angelica','','','','34','545896077','1212 S LEXINGTON ST',0,'GONZALES','LA','70737','5142','CY','22005','1985-12-30','F','U',':RET:2054-5','N','021','DEN','3809761','18575LA002000201','2014-04-01','2014-02-16 17:21:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-16 19:00:23'),(24403,19384,'Y','18','021','EC','A','','','AC','0000227099','0000227099','OH00002590997','IL','1','Roe','Mary','','','','34','274847375','5584 LUCENNA DR',0,'CINCINNATI','OH','45238','1949','CY','39061','1975-11-10','F','U',':RET:2106-3','N','021','DEN','3014557','99734OH005000401','2014-04-01','2014-02-18 15:32:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:56'),(24925,19765,'Y','18','021','EC','A','','','AC','0000468854','0000468854','MS00002458171','IL','1','hathcox','stacy','L','','','34','428115613','10 THREE OAKS RD',0,'CARRIERE','MS','39426','9114','CY','28109','1971-08-01','F','M',':RET:2106-3','N','021','DEN','3613467','46300MS002000201','2014-04-01','2014-02-20 14:00:51','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85','CIC',0,'2014-02-20 21:30:16'),(26267,20834,'Y','18','021','EC','A','','','AC','0000502339','0000502339','TX00002576806','IL','1','MONROE','DEBORAH','','','','34','463470896','1440 BRAZOS DR',0,'HUNTSVILLE','TX','77320','3527','CY','48471','1963-09-21','F','U',':RET:2106-3','N','021','DEN','3612384','33348TX002000201','2014-03-01','2014-02-27 17:12:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:31:14'),(21355,17068,'Y','18','021','EC','A','','','AC','0000499775','0000499775','TX00002371135','IL','1','Harris','Terrisha','','','','34','429515506','1817 S 17TH ST',0,'TEMPLE','TX','76504','3202','CY','48027','1969-05-01','F','M',':RET:2106-3','T','021','DEN','3354776','33348TX002000201','2014-03-01','2014-02-04 13:48:30','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-02-04 21:00:40'),(5995,4747,'Y','18','021','EC','A','','','AC','0000908129','0000908129','LA00000016860','IL','1','wesley','leon','','','','34','436809995','219 LATHAM LN',0,'MONROE','LA','71202','8566','CY','22073','1949-07-16','M','M',':RET:2054-5','N','021','DEN','555620','18575LA002000201','2014-01-01','2013-12-01 16:39:55','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2013-12-26 00:00:11'),(6508,5158,'Y','18','021','EC','A','','','AC','0001125416','0001125416','OH00000940981','IL','1','Taylor','Tony','','','','34','290501925','938 SHERIDAN ST',0,'AKRON','OH','44307','1151','CY','39153','1952-12-19','M','U',':RET:2054-5','N','021','HLT','1205817','52664OH152000901','2014-01-01','2013-12-11 09:09:01','458.99',NULL,NULL,'458.99','0.00','R-OH012','OH0','458.99',NULL,0,'2013-12-26 00:51:03'),(19133,15245,'Y','18','021','EC','A','','','AC','0000076326','0000076326','OH00002144939','31','1','Barnes','Jessica','','','','34','623366143','P.O. Box 217',0,'Ottoville','OH','45876',NULL,'CY','39137','1987-06-21','F','M',':RET:2106-3','T','021','HLT','1983464','92036OH003001505','2014-03-01','2014-01-19 16:41:22','100.00',NULL,NULL,'270.65','170.65','R-OH002','OH0','270.65',NULL,0,'2014-01-21 08:45:25'),(17904,14300,'N','01','021','EC','A',NULL,NULL,'','0000375476','0000063033','','IL','1','Wherry','Debra','Lynn','','','34','458944422','6736 FM 933',0,'BLUM','TX','76627','3108','CY','48217','1952-11-08','F','',':RET:2106-3','N','021','DEN','2231523','33348TX002000201','2014-02-01','2014-01-13 18:54:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:24'),(9286,7365,'Y','18','021','EC','A','','','AC','0000874664','0000874664','OH00000295838','IL','1','kleinschmidt','shirley','','','','34','553475057','117 ashleigh dr',0,'brunswick','OH','44212',NULL,'CY','39103','1961-06-03','F','M',':RET:2106-3','T','021','DEN','1073488','99734OH005000301','2014-01-01','2013-11-30 17:00:04','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:16:01'),(9583,7588,'Y','18','021','EC','A','','','AC','0000626726','0000626726','OH00000787589','31','1','Piatt','Darlene','','','','34','292561711','PO BOX 95',0,'Stratton','OH','43961',NULL,'CY','39081','1954-03-11','F','M',':RET:2106-3','N','021','DEN','1871444','99734OH005000301','2014-01-01','2013-12-21 18:02:02','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:36:57'),(15763,12613,'Y','18','021','EC','A','','','AC','0000813226','0000813226','TX00000436484','IL','1','colman','donna','','','','34','463960971','1329 EAGLE CANYON DR',0,'CHINA SPRING','TX','76633','3241','CY','48309','1951-03-08','F','M',NULL,'N','021','DEN','2323213','33348TX002000201','2014-02-01','2014-01-02 13:05:06','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-01-03 02:01:33'),(15256,12194,'Y','18','024','14','A','','','TE','0001062114','0001062114','','IL','1','Becker','Matthew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-08-25','M','',NULL,NULL,NULL,'','2508921','','2013-12-30','2013-12-30 12:28:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:09:08'),(21461,17151,'Y','18','021','EC','A','','','AC','0000888215','0000888215','OH00002255753','IL','1','Ebert','Rachel','','','','34','276941157','1092 WEXFORD CT',0,'AKRON','OH','44312','4635','CY','39153','1989-12-22','F','U',':RET:2106-3','N','021','HLT','2712902','52664OH151001305','2014-03-01','2014-02-04 17:40:53','68.00',NULL,NULL,'223.01','155.01','R-OH012','OH0','223.01',NULL,0,'2014-02-04 21:01:33'),(21524,17196,'Y','18','021','EC','A','','','AC','0000857180','0000857180','TX00001856736','IL','1','CHU','NANCY','','','','34','519786005','5645 Lucerne Street',0,'Bellaire','TX','77401',NULL,'CY','48201','1955-08-12','F','U',':RET:2034-7','N','021','DEN','2871662','33348TX002000101','2014-03-01','2014-02-04 18:36:49','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-05 21:30:03'),(21881,17470,'Y','18','024','14','A','','','TE','0001868282','0001868282','','IL','1','MCGRAW','CAROLYN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-22','F','',NULL,NULL,NULL,'','2749331','','2014-02-06','2014-02-06 14:04:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-06 21:01:31'),(23247,18534,'Y','18','024','14','A','','','TE','0000132073','0000132073','','IL','1','Payten','Steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-21','M','',NULL,NULL,NULL,'','2101453','','2014-02-28','2014-02-13 09:29:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:05'),(25214,19999,'Y','18','021','EC','A','','','AC','0000582853','0000582853','OH00002580457','IL','1','Swander','Tony','Allan','','','34','296561121','6969 SHELLEY RD',0,'ROCKFORD','OH','45882','9534','CY','39107','1959-08-09','M','M',NULL,'T','021','DEN','3464375','99734OH005000301','2014-04-01','2014-02-21 14:40:35','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-21 22:00:52'),(25718,20399,'Y','18','021','EC','A','','','AC','0000860957','0000860957','TX00002346282','IL','1','Brown','Kheresentha','','','','34','463519878','345 16th Street SW',0,'Parish','TX','75460',NULL,'CY','48277','1964-02-24','F','U',NULL,'N','021','DEN','2677280','33348TX002000201','2014-04-01','2014-02-24 16:52:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:26'),(20563,16433,'Y','18','021','EC','A','','','AC','0000449904','0000449904','OH00002152960','IL','1','Gill','Evan','','','','34','302081572','5009 ROOSEVELT AVE',0,'MIDDLETOWN','OH','45044','6227','CY','39017','2004-07-27','M','R',':RET:2106-3','N','021','HLT','2647355','92036OH006001201','2014-03-01','2014-01-29 13:07:53','73.43',NULL,NULL,'108.11','34.68','R-OH004','OH0','108.11',NULL,0,'2014-01-29 21:01:47'),(18573,14812,'Y','18','021','EC','A','','','AC','0000705177','0000705177','OH00002214505','IL','1','HAMMER','DANE','','','','34','277906594','1195 INGLEWOOD AVE',0,'MOGADORE','OH','44260',NULL,'CY','39153','1985-09-04','M','U',':RET:2106-3','N','021','HLT','2802277','52664OH152000901','2014-02-01','2014-01-15 15:31:47','76.00',NULL,NULL,'177.55','101.55','R-OH012','OH0','177.55',NULL,0,'2014-01-16 08:47:05'),(3856,3086,'Y','18','021','EC','A','','','AC','0000996927','0000996927','LA00000207763','IL','1','Oneal','Debra','','','','34','436291895','1825 WILLIE MAYS ST',0,'SHREVEPORT','LA','71107','5031','CY','22017','1960-05-08','F','U',':RET:2054-5','N','021','DEN','606833','18575LA002000201','2014-01-01','2013-12-12 18:58:12','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 21:35:47'),(7352,5822,'Y','18','021','EC','A','','','AC','0000383812','0000383812','TX00000746946','IL','1','Elms','Deborah','','','','34','461985784','206 Bailey Brook Lane',0,'Dickinson','TX','77539',NULL,'CY','48167','1952-09-08','F','M',':RET:2106-3','N','021','DEN','849947','33348TX002000201','2014-01-01','2013-11-22 18:48:22','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:15:08'),(18292,14603,'N','01','021','EC','A',NULL,NULL,'','0000806371','0000695655','','IL','1','Stein','Timothy','','','','34','277523014','2824 RESEARCH BLVD',0,'KETTERING','OH','45420','3632','CY','39113','1968-01-28','M','',':RET:2106-3','N','021','DEN','2632152','99734OH005000401','2014-02-01','2014-01-14 21:30:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:44:53'),(17978,14365,'N','01','021','EC','A',NULL,NULL,'','0000642091','0000402481','','IL','1','IRWIN','JENNIE','','','','34','272503698','2040 BROADWAY AVE NE',0,'EAST CANTON','OH','44730','1716','CY','39151','1957-01-15','F','',':RET:2106-3','N','021','HLT','2746117','52664OH151001301','2014-02-01','2014-01-14 12:29:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2014-01-15 02:06:52'),(17738,14174,'Y','18','021','EC','A','','','AC','0000250269','0000250269','OH00001858546','IL','1','Hindel','Sarah','','','','34','299601175','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','1977-07-15','F','M',':RET:2106-3','N','021','HLT','2130210','52664OH151001304','2014-02-01','2014-01-13 15:04:29','559.00',NULL,NULL,'975.21','416.21','R-OH012','OH0','274.30',NULL,0,'2014-01-14 01:33:22');
INSERT INTO `EdiParticipant` VALUES (24526,19483,'Y','18','021','EC','A','','','AC','0000063169','0000063169','TX00001968402','IL','1','SMITH','MARIE','','','','34','438923024','1332 ROYAL OAK ST',0,'DESOTO','TX','75115',NULL,'CY','48113','1953-04-10','F','M',':RET:2054-5','N','021','DEN','2990474','33348TX002000201','2014-04-01','2014-02-19 15:54:51','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:59:01'),(26292,20856,'Y','18','021','EC','A','','','AC','0000139064','0000139064','OH00003266312','IL','1','BAER','JANET','','','','34','289704654','3961 UPTON AVE',0,'TOLEDO','OH','43613','4540','CY','39095','1973-11-16','F','U',':RET:2106-3','N','021','HLT','2773042','92036OH005002606','2014-04-01','2014-02-26 19:30:45','205.00',NULL,NULL,'249.21','44.21','R-OH001','OH0','249.21',NULL,0,'2014-02-28 06:31:24'),(27211,21545,'Y','18','024','14','A','','','TE','0000650824','0000650824','','IL','1','Reser','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-06-21','F','',NULL,NULL,NULL,'','2725909','','2014-03-02','2014-03-02 18:29:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:31:28'),(28369,22448,'Y','18','021','EC','A','','','AC','0000554597','0000554597','TX00003334771','IL','1','NORWOOD','LINDSEY','','','','34','458945439','5608 GREENWOOD CREEK DR',0,'BENBROOK','TX','76109',NULL,'CY','48439','1950-05-27','F','U',NULL,'N','021','DEN','4159542','33348TX002000201','2014-04-01','2014-03-07 17:44:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:33'),(15400,12318,'Y','18','021','EC','A','','','AC','0000864113','0000864113','TX00001476137','IL','1','WILSON','TAMARA','N','','','34','455068075','2003 W COLLIN ST',0,'CORSICANA','TX','75110','4242','CY','48349','1955-01-31','F','U',':RET:2106-3','N','021','DEN','1946859','33348TX002000201','2014-02-01','2013-12-30 19:29:36','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:26:45'),(22074,17619,'Y','18','021','EC','A','','','AC','0001837268','0001837268','LA00002583699','IL','1','Rapp','Michael','','','','34','587521402','836 CAMBRONNE ST',0,'NEW ORLEANS','LA','70118','1004','CY','22071','1951-01-10','M','U',':RET:2054-5','N','021','DEN','3570664','18575LA002000201','2014-03-01','2014-02-07 18:17:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-08 19:00:15'),(22269,17774,'Y','18','021','EC','A','','','AC','0000023737','0000023737','TX00002235479','31','1','Gonzalez','Adriana','','','','34','806985821','po.box 53101',0,'Midland','TX','79710',NULL,'CY','48329','1982-04-11','F','M',NULL,'N','021','DEN','3238165','33348TX002000201','2014-03-01','2014-01-28 01:41:18','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-10 11:00:13'),(23066,18390,'Y','18','021','EC','A','','','AC','0002088461','0002088461','LA00002089740','IL','1','Loar','Rodney','','','','34','439085976','5801 walnut creek',0,'River ridge','LA','70123',NULL,'CY','22051','1957-09-20','M','U',':RET:2106-3','N','021','DEN','3797070','18575LA002000201','2014-03-01','2014-02-12 17:57:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:53'),(23310,18581,'N','19','021','EC','A',NULL,NULL,'','0000689734','0000977982','','IL','1','Walden','Caroline','','','','34','274029351','405 BANK AVE',0,'CINCINNATI','OH','45217','1214','CY','39061','1996-12-09','F','',':RET:2106-3','N','021','DEN','2721161','99734OH005000301','2014-03-01','2014-02-13 11:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:20'),(18497,14754,'Y','18','021','EC','A','','','AC','0000142850','0000142850','OH00002344132','IL','1','ARRIGO','JAMES','V','','','34','287741235','6871 BRECK CT',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1966-02-07','M','M',NULL,'N','021','HLT','2707604','52664OH151001306','2014-02-01','2014-01-15 16:19:35','536.00',NULL,NULL,'770.40','234.40','R-OH011','OH0','393.12',NULL,0,'2014-01-16 08:46:28'),(16196,12966,'N','01','021','EC','A',NULL,NULL,'','0000812005','0000225787','','IL','1','Escobar','Melissa','R','','','34','460714668','1434 PLAZA ROJA CT',0,'EL PASO','TX','79912','8449','CY','48141','1969-03-03','F','',':RET:2106-3','N','021','DEN','2037062','33348TX002000201','2014-02-01','2014-01-04 11:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-05 00:01:00'),(3434,2759,'Y','18','021','EC','A','','','AC','0002071034','0002071034','LA00000117748','IL','1','Dozier','Regina','','','','34','148603400','4139 Loire Dr',0,'Kenner','LA','70065',NULL,'CY','22051','1961-02-24','F','U',':RET:2054-5','N','021','DEN','2060490','18575LA002000101','2014-01-01','2013-12-22 12:33:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:19:02'),(2861,2311,'Y','18','021','EC','A','','','AC','0000669141','0000669141','OH00000855075','IL','1','Jung','Rose','','','','34','236827020','3849 BELMONT AVE',0,'CINCINNATI','OH','45227','3042','CY','39061','1951-09-29','F','U',NULL,'N','021','DEN','696939','99734OH005000401','2014-01-01','2013-11-02 07:44:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:01:37'),(3300,2657,'N','19','021','EC','A',NULL,NULL,'','0000524487','0001001156','','S1','1','Murphy','Patrick','Charles',NULL,NULL,NULL,NULL,'255 GUILFORD BLVD',0,'MEDINA','OH','44256','2134','CY','39103','1995-07-24','M','',':RET:2106-3','N','021','DEN','1471448','99734OH005000301','2014-01-01','2013-12-22 12:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:41'),(14209,11331,'Y','18','021','EC','A','','','AC','0000400559','0000400559','TX00000119433','IL','1','PARKER','RICHARD','','','','34','453063866','6102 MILWEE ST',0,'HOUSTON','TX','77092',NULL,'CY','48201','1956-09-21','M','M',':RET:2106-3','T','021','DEN','1513221','33348TX002000201','2014-02-01','2013-12-26 14:57:35','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-27 02:04:27'),(15190,12139,'Y','18','021','EC','A','','','AC','0000828241','0000828241','OH00001418977','IL','1','Hartney','Jon','','','','34','271661803','1063 EAGLE DR',0,'AKRON','OH','44312','5859','CY','39153','1961-08-31','M','M',':RET:2106-3','N','021','HLT','2427861','52664OH152000901','2014-02-01','2013-12-30 10:43:56','610.57',NULL,NULL,'610.57','0.00','R-OH012','OH0','318.84',NULL,0,'2014-01-01 12:07:05'),(21973,17547,'Y','18','021','EC','A','','','AC','0000664218','0000664218','OH00002134140','IL','1','WHITE','JULIA','','','','34','294708169','411 BROWN AVE NW',0,'CANTON','OH','44703','2849','CY','39151','1964-07-14','F','U',':RET:2054-5','N','021','HLT','2761163','52664OH151001306','2014-03-01','2014-02-07 17:19:03','278.00',NULL,NULL,'380.45','102.45','R-OH015','OH0','380.45',NULL,0,'2014-02-07 19:00:32'),(28651,22672,'Y','18','021','EC','A','','','AC','0001116013','0001116013','OH00002727285','IL','1','Stanley','Keryl',NULL,NULL,NULL,NULL,NULL,'5806 Stonebridge Circle',0,'Milford','OH','45150',NULL,'CY','39025','1956-01-01','F','U',NULL,'N','021','HLT','3867889','92036OH003000601','2014-04-01','2014-03-08 08:57:39','162.00',NULL,NULL,'571.20','409.20','R-OH005','OH0','571.20',NULL,0,'2014-03-08 21:30:38'),(18948,15097,'Y','18','021','EC','A','','','AC','0001039241','0001039241','TX00001868740','IL','1','franklin','micheal','','','','34','251277668','903 TOUCHE ST',0,'HOUSTON','TX','77015','3329','CY','48201','1960-11-15','M','M',':RET:2054-5','T','021','DEN','2936614','33348TX002000201','2014-03-01','2014-01-17 13:45:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:47'),(4936,3917,'Y','18','021','EC','A','','','AC','0000828195','0000828195','OH00001241457','IL','1','Burns','Kristina','','','','34','271906055','5642 MONICA DR',0,'FAIRFIELD','OH','45014','3958','CY','39017','1987-04-18','F','U',':RET:2106-3','N','021','DEN','1155653','99734OH005000401','2014-01-01','2013-12-07 12:43:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:33'),(19268,15356,'N','01','021','EC','A',NULL,NULL,'','0000001062','0000759732','','IL','1','Crouch','Raymond','Louis','','','34','299588427','338 OCONNELL ST',0,'TOLEDO','OH','43608','1027','CY','39095','1956-03-04','M','',':RET:2106-3','N','021','HLT','2713704','92036OH006002601','2014-03-01','2014-01-19 20:45:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','376.87',NULL,0,'2014-01-21 08:46:52'),(18998,15131,'Y','18','021','EC','A','','','AC','0001038637','0001038637','OH00002282726','IL','1','Warman','Brandon','','','','34','290900014','1068 ALPINE BLVD',0,'UNIONTOWN','OH','44685','9509','CY','39153','1989-07-06','M','U',':RET:2106-3','N','021','HLT','2760782','52664OH151001304','2014-03-01','2014-01-16 20:48:17','58.00',NULL,NULL,'223.01','165.01','R-OH012','OH0','223.01',NULL,0,'2014-01-20 08:06:14'),(3605,2889,'N','19','021','EC','A',NULL,NULL,'','0000309439','0000642074','','IL','1','Haven','Lane','E','','','34','294967237','5992 HEYL RD',0,'WOOSTER','OH','44691','7454','CY','39169','1994-02-24','F','',NULL,'N','021','HLT','1869103','52664OH152000901','2014-01-01','2013-12-22 12:30:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:23:21'),(18165,14506,'Y','18','021','EC','A','','','AC','0000748205','0000748205','OH00001599938','IL','1','Dean','Jamie','','','','34','292600648','3715 West US Highway 22',0,'Wilmington','OH','45177',NULL,'CY','39027','1977-06-27','F','M',':RET:2106-3','N','021','HLT','1734468','92036OH005000606','2014-02-01','2014-01-14 10:33:01','502.00',NULL,NULL,'575.59','73.59','R-OH005','OH0','264.05',NULL,0,'2014-01-15 02:07:55'),(17948,14340,'Y','18','021','EC','A','','','AC','0000186017','0000186017','TX00002287433','IL','1','PHAM','NAM','','','','34','629921754','8001 South Loop East 111',0,'Houston','TX','77012',NULL,'CY','48201','1972-04-17','M','U',':RET:2047-9','N','021','DEN','2160941','33348TX002000201','2014-02-01','2014-01-14 16:23:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-15 02:06:42'),(15955,12773,'Y','18','021','EC','A','','','AC','0000484800','0000484800','OH00001793434','IL','1','LENGEL','JOSEPH','','','','34','269486487','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-12-01','M','M',':RET:2106-3','N','021','DEN','2494771','99734OH005000301','2014-02-01','2014-01-03 11:48:06','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:00:13'),(13661,10899,'Y','18','021','EC','A','','','AC','0001875504','0001875504','LA00000649195','IL','1','Moore','Bobbie','','','','34','433807112','8019 Aegean Lane',0,'Shreveport','LA','71106',NULL,'CY','22017','1950-10-27','F','U',':RET:2054-5','N','021','DEN','2593929','18575LA002000101','2014-01-01','2013-12-23 09:23:18','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-26 13:07:37'),(15809,12655,'Y','18','021','EC','A','','','AC','0001648890','0001648890','LA00001979886','IL','1','HORNSBY','VINCENT','G','','','34','439632924','219 MARTIN LUTHER KING JR DR',0,'NATCHITOCHES','LA','71457','3939','CY','22069','1967-09-16','M','U',':RET:2054-5','N','021','DEN','1691451','18575LA002000201','2014-02-01','2014-01-02 17:15:26','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-03 02:03:08'),(26781,21225,'Y','18','021','EC','A','','','AC','0000605853','0000605853','TX00002892728','IL','1','Guerrero','Juan','','','','34','460906393','2414 CRIMSON AVE',0,'MISSION','TX','78574','2245','CY','48215','1950-07-23','M','M',':RET:2106-3','N','021','DEN','2700866','33348TX002000201','2014-04-01','2014-03-01 10:26:50','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-01 21:00:13'),(513,418,'Y','18','021','EC','A','','','AC','0001198083','0001198083','OH00001152896','IL','1','Dixon','Barbara','','','','34','283541519','3650 Solar Vista Pl',0,'Cincinnati','OH','45213',NULL,'CY','39061','1952-11-22','F','U',':RET:2054-5','N','021','DEN','361816','99734OH005000301','2014-01-01','2013-12-03 23:19:18','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:48:59'),(21201,16941,'Y','18','021','EC','A','','','AC','0000117830','0000117830','OH00001544994','IL','1','Knape','Steven','','','','34','503904461','128 MEEKER ST',0,'BOWLING GREEN','OH','43402','2215','CY','39173','1963-03-19','M','U',':RET:2106-3','N','021','HLT','3107446','92036OH002002601','2014-03-01','2014-02-03 05:27:52','50.00',NULL,NULL,'402.18','352.18','R-OH001','OH0','402.18',NULL,0,'2014-02-03 21:00:53'),(5844,4642,'Y','18','021','EC','A','','','AC','0000902144','0000902144','TX00000016269','IL','1','Xue','Jing','','','','34','632565320','306 ROUEN DR',0,'PORT LAVACA','TX','77979','2020','CY','48057','1959-12-21','F','M',':RET:2034-7','N','021','DEN','2504354','33348TX002000201','2014-01-01','2013-12-24 00:13:31','0.00',NULL,NULL,'29.22','29.22','R-TX023','TX0','14.61',NULL,0,'2013-12-25 23:48:37'),(4625,3664,'Y','18','021','EC','A','','','AC','0000236285','0000236285','LA00000331707','IL','1','Messina','Gary','E','','','34','438043501','4411 San Remo Rd',0,'New Orleans','LA','70129',NULL,'CY','22071','1963-03-10','M','M',':RET:2106-3','N','021','DEN','362062','18575LA002000101','2014-01-01','2013-12-12 15:50:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 22:06:21'),(4283,3410,'Y','18','021','EC','A','','','AC','0000689680','0000689680','OH00000465595','IL','1','Halker','Ricky','','','','34','296645377','9323 dt rt 12',0,'columbus grove','OH','45830',NULL,'CY','39137','1962-02-10','M','U',':RET:2106-3','N','021','HLT','2079510','92036OH005001501','2014-01-01','2013-12-17 13:22:43','268.00',NULL,NULL,'770.31','502.31','R-OH002','OH0','410.47',NULL,0,'2013-12-25 21:52:02'),(1923,1568,'Y','18','021','EC','A','','','AC','0000204533','0000204533','OH00001150201','IL','1','Ancona','Anthony','','','','34','096664380','3620 WASHINGTON AVE',0,'CINCINNATI','OH','45229','2038','CY','39061','1981-09-08','M','U',NULL,'N','021','DEN','920888','99734OH005000301','2014-01-01','2013-11-20 08:44:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:00:13'),(19868,15847,'N','01','021','EC','A',NULL,NULL,'','0000055948','0000249152','','IL','1','Cho','Chong','','','','34','271860682','2405 Cedar Creek Drive',0,'Grove City','OH','43123',NULL,'CY','39049','1957-02-20','F','',':RET:2040-4','N','021','DEN','2228990','99734OH005000401','2014-03-01','2014-01-23 21:36:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-24 21:00:39'),(18033,14405,'Y','18','021','EC','A','','','AC','0000878282','0000878282','OH00001674931','IL','1','Kilbane','Beth','','','','34','175668667','12900 LAKE AVE',0,'LAKEWOOD','OH','44107','1577','CY','39035','1970-09-25','F','U',':RET:2106-3','N','021','DEN','2671041','99734OH005000301','2014-02-01','2014-01-14 16:38:32','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:09'),(13009,10368,'Y','18','021','EC','A','','','AC','0000920805','0000920805','OH00000999104','IL','1','Swansiger','Chris','','','','34','286806507','483 Sunrise Blvd',0,'Kent','OH','44240',NULL,'CY','39133','1982-07-27','M','U',':RET:2106-3','N','021','DEN','1558999','99734OH005000401','2014-01-01','2013-12-22 19:55:33','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:49:45'),(17398,13922,'Y','18','021','EC','A','','','AC','0001038626','0001038626','OH00001966256','IL','1','Neumeier','James','','','','34','302720008','789 HOLLY ST',0,'LIMA','OH','45804','1010','CY','39003','1962-06-27','M','U',':RET:2106-3','T','021','HLT','2522639','92036OH006001501','2014-02-01','2014-01-10 10:59:02','323.00',NULL,NULL,'374.36','51.36','R-OH002','OH0','374.36',NULL,0,'2014-01-13 03:00:15'),(13208,10540,'Y','18','021','EC','A','','','AC','0000490354','0000490354','TX00000265242','IL','1','De La Cruz','Irma','','','','34','636165704','1015 E. Yager Ln.',0,'Austin','TX','78753',NULL,'CY','48453','1990-04-19','F','U',':RET:2106-3','N','021','DEN','2520669','33348TX002000101','2014-01-01','2013-12-23 18:13:18','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 12:55:09'),(16744,13394,'Y','18','021','EC','A','','','AC','0000986023','0000986023','OH00002039666','IL','1','Bertison','Douglas','','','','34','299584003','5742 BROOKWOOD DR',0,'AKRON','OH','44319','4223','CY','39153','1958-10-16','M','M',':RET:2106-3','N','021','HLT','2540045','52664OH151001304','2014-02-01','2014-01-07 17:08:29','693.00',NULL,NULL,'994.62','301.62','R-OH012','OH0','497.31',NULL,0,'2014-01-08 18:24:52'),(21502,17178,'Y','18','021','EC','A','','','AC','0000420059','0000420059','OH00001957973','IL','1','KERN','LINDA','MARIE','','','34','279647949','1545 WILD CHERRY DR',0,'MILFORD','OH','45150','9411','CY','39025','1959-08-16','F','U',NULL,'N','021','HLT','2851208','92036OH005000601','2014-03-01','2014-02-04 13:12:01','159.00',NULL,NULL,'458.32','299.32','R-OH005','OH0','458.32',NULL,0,'2014-02-04 21:01:53'),(21802,17411,'N','19','021','EC','A',NULL,NULL,'','0001174433','0000824623','','S1','1','ulrick','beverly','','','','34','279150483','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','2009-04-27','M','',':RET:2106-3','N','021','HLT','2942726','92036OH004001501','2014-03-01','2014-02-05 19:34:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-02-06 21:00:50'),(22032,17587,'N','19','021','EC','A',NULL,NULL,'','0001066019','0000893188','','IL','1','Simmons','Michael','J',NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1989-03-13','M','',NULL,'N','021','HLT','2731792','52664OH151001501','2014-03-01','2014-02-07 10:25:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2014-02-07 19:01:03'),(24436,19409,'N','01','021','EC','A',NULL,NULL,'','0001110410','0000292019','','IL','1','CARPENTER','CYNTHIA','','','','34','288582979','4621 STATE ROUTE 43',0,'KENT','OH','44240','6431','CY','39133','1961-04-14','F','',':RET:2106-3','T','021','HLT','2968113','52664OH151001305','2014-04-01','2014-02-18 14:49:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','500.61',NULL,0,'2014-02-18 22:01:15'),(25938,20569,'Y','18','021','EC','A','','','AC','0000938253','0000938253','TX00003076374','31','1','Varner','Miles','','','','34','459191716','1030 East Franklin St',0,'Hillsboror','TX','76645',NULL,'CY','48217','1958-11-08','M','U',NULL,'N','021','DEN','3682530','33348TX002000201','2014-04-01','2014-02-26 17:05:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:30'),(26870,21296,'N','19','021','EC','A',NULL,NULL,'','0000195192','0001068320','','IL','1','Anthony','Derren','','','','34','272988878','745 GRACE AVE',0,'AKRON','OH','44320','3748','CY','39153','1995-02-03','M','',NULL,'N','021','HLT','3040877','52664OH151001305','2014-04-01','2014-03-01 09:13:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-01 21:01:03'),(20826,16645,'Y','18','021','EC','A','','','AC','0001658415','0001658415','LA00001946951','IL','1','Ictech','Gaye','carmen','','','34','434578346','3612 MEADOW LAKE DR W',0,'SLIDELL','LA','70461','5559','CY','22103','1973-04-17','F','U',':RET:2106-3','T','021','DEN','3005929','18575LA002000201','2014-03-01','2014-01-31 15:14:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:38'),(15037,12019,'Y','18','021','EC','A','','','AC','0002072531','0002072531','LA00000711647','IL','1','Reniff','Beth','','','','34','540089110','1617 MARAIS ST',0,'NEW ORLEANS','LA','70116','1430','CY','22071','1979-09-05','F','U',':RET:2106-3','N','021','DEN','2225706','18575LA002000201','2014-02-01','2013-12-30 12:15:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:49'),(2223,1830,'Y','18','021','EC','A','','','AC','0001074125','0001074125','OH00001061225','IL','1','Hoang','Thanh','','','','34','594416904','523 S WYNN RD',0,'OREGON','OH','43616','3020','CY','39095','1963-11-20','M','M',':RET:2047-9','T','021','HLT','908870','92036OH003002605','2014-01-01','2013-12-10 14:32:14','455.00',NULL,NULL,'723.69','268.69','R-OH001','OH0','418.24',NULL,0,'2013-12-25 19:20:34'),(5120,4057,'Y','18','024','14','A','','','TE','0001097688','0001097688','','IL','1','Graham','Clinton',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-17','M','',NULL,NULL,NULL,'','203419','','2013-12-18','2013-12-18 18:33:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:56'),(7780,6160,'Y','18','021','EC','A','','','AC','0000073892','0000073892','TX00001132317','31','1','Davis','Sammie','','','','34','451353699','P O Box 555',0,'Karnack','TX','75661',NULL,'CY','48203','1961-01-05','F','U',NULL,'N','021','DEN','2427391','33348TX002000201','2014-01-01','2013-12-19 23:39:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:10'),(3449,2773,'Y','18','024','14','A','','','TE','0000501608','0000501608','','IL','1','Hammond','Hope',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-23','F','',NULL,NULL,NULL,'','1927746','','2013-12-21','2013-12-21 21:50:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:19:27'),(22846,18229,'Y','18','021','EC','A','','','AC','0001003344','0001003344','OH00001509574','IL','1','Richards','Vicky','L','','','34','272487339','537 Touvelle St Lot 34',0,'Celina','OH','45822',NULL,'CY','39107','1952-02-13','F','U',':RET:2106-3','N','021','HLT','2933348','92036OH005001505','2014-03-01','2014-02-10 21:44:01','591.00',NULL,NULL,'632.30','41.30','R-OH002','OH0','632.30',NULL,0,'2014-02-11 21:02:17'),(23668,18845,'Y','18','024','14','A','','','TE','0000530783','0000530783','','IL','1','martin','kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-05-30','M','',NULL,NULL,NULL,'','3296812','','2014-02-14','2014-02-14 15:29:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-14 21:30:22'),(26157,20740,'Y','18','021','EC','A','','','AC','0000870680','0000870680','OH00003218790','IL','1','AREVALOS','MARIA G','','','','34','292020274','225 GALEWOOD DR.',0,'NEW CARLISLE','OH','45344',NULL,'CY','39023','1955-07-22','F','M',NULL,'N','021','DEN','3409670','99734OH005000401','2014-04-01','2014-02-27 17:18:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-28 06:30:31'),(18329,14635,'Y','18','021','EC','A','','','AC','0000191380','0000191380','OH00001643964','IL','1','Catania','Catherine','','','','34','283863556','754 SHERWOOD DR',0,'AURORA','OH','44202','7826','CY','39133','1982-01-31','F','U',NULL,'N','021','DEN','2900086','99734OH005000401','2014-02-01','2014-01-15 13:43:28','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:11'),(14905,11907,'Y','18','021','EC','A','','','AC','0000086407','0000086407','MS00001371340','IL','1','Bailey','Brandon','','','','34','425677649','836 Serville Drive',0,'Jackson','MS','39206',NULL,'CY','28049','1989-08-30','M','U',':RET:2054-5','T','021','DEN','1701144','46300MS002000201','2014-02-01','2013-12-28 19:01:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-30 00:01:16'),(6086,4823,'N','01','021','EC','A',NULL,NULL,'','0001108066','0001155080','','IL','1','Csepegi','Joshua','','','','34','277888547','208 N AVON AVE',0,'WADSWORTH','OH','44281','1203','CY','39103','1979-05-15','M','',':RET:2106-3','N','021','HLT','1099446','52664OH151001305','2014-01-01','2013-12-01 17:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','270.73',NULL,0,'2013-12-26 00:02:35'),(14756,11782,'Y','18','021','EC','A','','','AC','0000208514','0000208514','OH00001791838','IL','1','Knitz','kenneth','','','','34','273746298','241 N v ine St',0,'Deshler','OH','43516',NULL,'CY','39069','1965-02-05','M','M',':RET:2106-3','N','021','HLT','1879432','92036OH004002601','2014-02-01','2013-12-28 17:56:17','437.00',NULL,NULL,'501.43','64.43','R-OH001','OH0','256.36',NULL,1,'2013-12-29 11:10:28'),(2950,2375,'Y','18','021','EC','A','','','AC','0000035724','0000035724','OH00001145442','IL','1','FARISH','EDWIN','','','','34','294823656','265 N MAIN ST',0,'LONDON','OH','43140','1145','CY','39097','1970-03-17','M','U',':RET:2106-3','T','021','DEN','1207113','99734OH005000401','2014-01-01','2013-12-05 18:20:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:16:30'),(13789,11006,'Y','18','021','EC','A','','','AC','0001031145','0001031145','MS00000968743','IL','1','Smith','Casenna','','','','34','426598054','6530 ABRAHAM LINCOLN DR',0,'JACKSON','MS','39213','3109','CY','28049','1980-02-04','F','U',':RET:2054-5','N','021','DEN','2374634','46300MS002000101','2014-01-01','2013-12-22 19:56:00','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:00'),(7421,5872,'N','01','021','EC','A',NULL,NULL,'','0000762244','0000622448','','IL','1','Burts-Cooper','Ellen','','','','34','423025768','4244 BROWNSTONE LN',0,'MEDINA','OH','44256','5551','CY','39103','1974-08-29','F','',':RET:2054-5','N','021','DEN','138922','99734OH005000301','2014-01-01','2013-10-26 18:17:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:17:02'),(7627,6036,'N','01','021','EC','A',NULL,NULL,'','0001102055','0000397307','','IL','1','Beaverson','Allyssa','Mary','','','34','289825249','817 VALE CT',0,'BOWLING GREEN','OH','43402','4845','CY','39173','1978-11-24','F','',':RET:2106-3','N','021','HLT','610623','92036OH004002601','2014-01-01','2013-11-17 13:06:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.59',NULL,0,'2013-12-26 02:46:06'),(8826,6998,'Y','18','021','EC','A','','','AC','0000952436','0000952436','TX00000052420','IL','1','Torshizi','Arman','','','','34','729246724','12001 Metric BLVD',0,'Austin','TX','78758',NULL,'CY','48453','1992-07-27','M','U',':RET:2106-3','N','021','DEN','2555082','33348TX002000201','2014-01-01','2013-12-17 20:00:12','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:00:24'),(9750,7720,'N','01','021','EC','A',NULL,NULL,'','0000465882','0000847121','','IL','1','Reich','Kathy','','','','34','270506906','2421 SUCROSE DR',0,'AKRON','OH','44312','5571','CY','39153','1949-07-29','F','',NULL,'N','021','HLT','762200','52664OH151001501','2014-01-01','2013-11-15 11:15:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','802.38',NULL,0,'2013-12-26 04:46:12'),(23452,18682,'Y','18','021','EC','A','','','AC','0000790179','0000790179','TX00002505901','IL','1','Longfellow','Mary','','','','34','001448447','13501 Nelson Houser Street',0,'Manor','TX','78653',NULL,'CY','48453','1952-11-04','F','U',':RET:2106-3','N','021','DEN','3395289','33348TX002000201','2014-03-01','2014-02-13 13:44:01','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-13 22:01:38'),(26113,20709,'Y','18','021','EC','A','','','AC','0000757203','0000757203','OH00003121425','IL','1','Cox','Cara','','','','34','291609528','4231 SCHIRTZINGER RD',0,'HILLIARD','OH','43026','2548','CY','39049','1962-11-16','F','M',':RET:2106-3','N','021','DEN','2767570','99734OH005000401','2014-04-01','2014-02-26 19:35:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:16'),(28232,22337,'Y','18','021','EC','A','','','AC','0000183576','0000183576','OH00002984304','IL','1','Marsh','Rhonda','','','','34','299725901','1762 JOSEPH RD',0,'LUCKEY','OH','43443','9730','CY','39173','1961-10-21','F','M',NULL,'N','021','HLT','3122782','92036OH006002601','2014-04-01','2014-03-06 16:05:51','0.00',NULL,NULL,'301.86','301.86','R-OH001','OH0','301.86','CIC',0,'2014-03-06 21:30:23'),(2102,1723,'Y','18','021','EC','A','','','AC','0000536895','0000536895','OH00001245405','IL','1','haussler','sarah','','','','34','285860532','817 4TH ST',0,'READING','OH','45215','4829','CY','39061','1987-05-15','F','U',':RET:2106-3','N','021','DEN','15285','99734OH005000401','2014-01-01','2013-12-09 22:07:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:11'),(2201,1812,'Y','18','021','EC','A','','','AC','0000378543','0000378543','OH00000546249','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','HLT','269311','92036OH003000505','2014-01-01','2013-12-10 14:49:15','368.00',NULL,NULL,'506.41','138.41','R-OH003','OH0','506.41',NULL,0,'2013-12-25 19:20:01'),(20143,16074,'Y','18','021','EC','A','','','AC','0000767431','0000767431','OH00001710761','IL','1','FOSU','KOFI','','','','34','103844606','2953 MORALITY DR',0,'COLUMBUS','OH','43231','8830','CY','39049','1966-03-03','M','M',':RET:2054-5','N','021','DEN','3314441','99734OH005000401','2014-03-01','2014-01-27 16:11:01','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-27 21:00:59'),(19522,15560,'Y','18','024','14','A','','','TE','0000942012','0000942012','','IL','1','Nicholson','Kelley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-09-01','F','',NULL,NULL,NULL,'','2014848','','2014-01-22','2014-01-22 10:00:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:18'),(3059,2457,'Y','18','021','EC','A','','','AC','0000990520','0000990520','LA00000588345','IL','1','Pontious','Zachary','','','','34','183700325','3207 CHIPPEWA ST',0,'NEW ORLEANS','LA','70115','1143','CY','22071','1987-04-11','M','U',':RET:2106-3','N','021','DEN','597709','18575LA002000201','2014-01-01','2013-12-06 12:39:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:19:06'),(2228,1834,'Y','18','021','EC','A','','','AC','0000005813','0000005813','OH00000346463','IL','1','okeeffe','karen','a','','','34','365507485','1011 TAFT ST',0,'PORT CLINTON','OH','43452','2245','CY','39123','1949-06-09','F','M',NULL,'N','021','HLT','1024163','92036OH003002705','2014-01-01','2013-12-10 16:12:04','483.00',NULL,NULL,'610.89','127.89','R-OH006','OH0','610.89',NULL,0,'2013-12-25 19:20:43'),(19817,15800,'Y','18','024','14','A','','','TE','0000617530','0000617530','','IL','1','Cruz','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-01-13','F','',NULL,NULL,NULL,'','1495144','','2014-01-24','2014-01-24 12:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:12'),(17857,14265,'Y','18','021','EC','A','','','AC','0000933230','0000933230','OH00001586301','IL','1','HAMMOND','DAVID','','','','34','232358835','2126 SIBBY LN',0,'COLUMBUS','OH','43235','4295','CY','39049','1982-12-19','M','U',':RET:2106-3','N','021','DEN','1750718','99734OH005000401','2014-02-01','2014-01-14 11:01:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:09'),(4836,3830,'Y','18','021','EC','A','','','AC','0000036965','0000036965','OH00000366636','IL','1','Dewey','Abbey','','','','34','274883802','4189 BRANDONMORE DR',0,'CINCINNATI','OH','45255','3705','CY','39025','1984-04-20','F','U',':RET:2106-3','N','021','HLT','1042287','92036OH004000601','2014-01-01','2013-12-08 17:20:23','0.00',NULL,NULL,'193.15','193.15','R-OH005','OH0','193.15',NULL,0,'2013-12-25 22:17:28'),(16054,12856,'Y','18','021','EC','A','','','AC','0000116602','0000116602','OH00001444507','IL','1','CATALANO','KELI','','','','34','314902659','4101 SPRING GROVE AVE',0,'CINNCINNATI','OH','45223',NULL,'CY','39061','1982-09-21','F','U',':RET:2106-3','N','021','DEN','2297700','99734OH005000401','2014-02-01','2014-01-03 00:36:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:19'),(17508,13996,'N','01','021','EC','A',NULL,NULL,'','0000530709','0000858505','','IL','1','Lampert','Anthony','','','Jr','34','046764067','7291 Lauren J Drive',0,'Mentor','OH','44060',NULL,'CY','39085','1972-08-25','M','',':RET:2106-3','N','021','HLT','1596454','52664OH151001501','2014-02-01','2014-01-11 19:22:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','392.76',NULL,0,'2014-01-13 03:01:28'),(1441,1202,'N','01','021','EC','A',NULL,NULL,'','0000640929','0000132074','','IL','1','phipps','kirsten','lee','','','34','268585621','3775 TATER KNOB RD',0,'PEEBLES','OH','45660','9333','CY','39001','1959-02-14','F','',':RET:2106-3','N','021','HLT','2046838','92036OH003000605','2014-01-01','2013-12-24 04:26:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.63',NULL,0,'2013-12-25 18:47:52'),(2290,1866,'Y','18','021','EC','A','','','AC','0001046818','0001046818','OH00000250926','IL','1','booker','runata','schanaun','','','34','285848504','691 s highland ave',0,'columbus','OH','43223',NULL,'CY','39049','1967-09-29','F','U',':RET:2054-5','N','021','DEN','959642','99734OH005000301','2014-01-01','2013-12-09 14:09:16','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:44'),(8081,6398,'N','19','021','EC','A',NULL,NULL,'','0000923318','0000254524','','IL','1','Hoehn','Travis','P','','','34','270969376','7109 Daleview Road',0,'Cincinnati','OH','45247',NULL,'CY','39061','1992-10-14','M','',':RET:2106-3','N','021','HLT','2015120','92036OH004001201','2014-01-01','2013-12-20 14:51:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2013-12-26 03:10:26'),(24328,19321,'Y','18','024','14','A','','','TE','0001036844','0001036844','','IL','1','MILLNER','DONNA','JEAN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-11-13','F','',NULL,NULL,NULL,'','3214529','','2014-02-18','2014-02-18 13:30:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-18 22:00:12'),(24324,19318,'Y','18','021','EC','A','','','AC','0001036844','0001036844','TX00002881041','IL','1','MILLNER','DONNA','JEAN','','','34','465021303','1701B SHADOWVIEW DR',0,'AUSTIN','TX','78758',NULL,'CY','48453','1968-11-13','F','U',NULL,'N','021','DEN','3214529','33348TX002000201','2014-04-01','2014-02-18 12:42:32','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:10'),(7914,6258,'Y','18','024','14','A','','','TE','0000013141','0000013141','','IL','1','cervini','brett',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-03-12','M','',NULL,NULL,NULL,'','1185494','','2013-12-19','2013-12-19 21:39:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 03:06:10'),(7560,5984,'Y','18','024','14','A','','','TE','0000699257','0000699257','','IL','1','Foust','Ty','T',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-11-06','M','',NULL,NULL,NULL,'','272223','','2013-12-15','2013-12-15 17:53:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:33:28'),(7094,5626,'N','01','021','EC','A',NULL,NULL,'','0000846147','0000672763','','IL','1','bonifant','tina','m','','','34','300728358','731 6TH ST SW',0,'MASSILLON','OH','44647','7744','CY','39151','1961-06-25','F','',':RET:2106-3','N','021','HLT','2157728','52664OH151001304','2014-01-01','2013-12-24 19:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2013-12-26 01:50:36'),(3486,2798,'Y','18','021','EC','A','','','AC','0000388640','0000388640','OH00000565633','IL','1','withrow','kelly','','','','34','400040720','301 eight mile rd',0,'cincinnati','OH','45255',NULL,'CY','39061','1975-09-22','F','U',':RET:2106-3','N','021','DEN','1570860','99734OH005000401','2014-01-01','2013-12-22 12:02:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:20:18'),(4956,3934,'Y','18','021','EC','A','','','AC','0001049602','0001049602','LA00001111937','IL','1','Lindsey','Tammy','','','','34','439191733','43217 LAKE TERRACE DR',0,'GONZALES','LA','70737','7964','CY','22005','1959-07-06','F','U',NULL,'N','021','DEN','963279','18575LA002000201','2014-01-01','2013-12-06 21:10:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:46:04'),(23101,18414,'Y','18','021','EC','A','','','AC','0001235156','0001235156','OH00001979325','IL','1','MILLER','KATRINA','M','','','34','284861346','3245 RAINIER AVE',0,'COLUMBUS','OH','43231','3142','CY','39049','1987-02-10','F','U',':RET:2106-3','N','021','DEN','3517799','99734OH005000401','2014-03-01','2014-02-12 15:43:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:11'),(19709,15705,'N','01','021','EC','A',NULL,NULL,'','0000850673','0000950262','','IL','1','Park','Jong-Hua','','','','34','347845722','16705 ANJOU LN',0,'ROUND ROCK','TX','78681','5316','CY','48491','1961-10-02','M','',':RET:2040-4','N','021','DEN','3071475','33348TX002000201','2014-03-01','2014-01-23 15:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:51'),(19938,15902,'Y','18','021','EC','A','','','AC','0001074115','0001074115','OH00001614433','IL','1','FISHER','COLLEEN','','','','34','279704045','9014 STATE ROUTE 3 WEST',0,'CLARKSVILLE','OH','45113',NULL,'CY','39027','1960-06-09','F','M',':RET:2106-3','N','021','HLT','2658337','92036OH001000601','2014-03-01','2014-01-24 10:36:31','776.00',NULL,NULL,'1272.17','496.17','R-OH005','OH0','528.24',NULL,0,'2014-01-24 21:01:13'),(28605,22639,'Y','18','021','EC','A','','','AC','0001022855','0001022855','OH00003811119','IL','1','TOOKER','JON','JEFFREY','','','34','305907466','218 N DELMAR AVE',0,'DAYTON','OH','45403','1610','CY','39113','1966-03-29','M','U',':RET:2106-3','N','021','DEN','3080423','99734OH005000401','2014-04-01','2014-03-08 14:17:17','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-08 21:30:12'),(1314,1088,'Y','18','021','EC','A','','','AC','0000186069','0000186069','OH00001042576','IL','1','Purdy','Mark','','','','34','302868388','119 RAVINEWOOD TER',0,'LOVELAND','OH','45140','7744','CY','39061','1982-04-06','M','M',':RET:2106-3','N','021','DEN','335758','99734OH005000401','2014-01-01','2013-11-04 11:18:16','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:31:34'),(14105,11241,'Y','18','021','EC','A','','','AC','0000475979','0000475979','OH00001715933','IL','1','McFarland','Jan','','','','34','272689628','19 POWHATTON DR',0,'MILFORD','OH','45150','1621','CY','39025','1961-05-29','F','U',':RET:2106-3','N','021','DEN','2322073','99734OH005000401','2014-02-01','2013-12-26 13:35:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-27 02:01:42'),(23381,18631,'Y','18','021','EC','A','','','AC','0000976770','0000976770','OH00002134283','IL','1','West','Leia','','','','34','282742779','854 FRANKLIN ST',0,'HAMILTON','OH','45013','2514','CY','39017','1963-04-10','F','U',':RET:2106-3','N','021','DEN','3479458','99734OH005000401','2014-03-01','2014-02-13 13:33:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:59'),(2634,2142,'Y','18','021','EC','A','','','AC','0000474926','0000474926','OH00000300872','IL','1','Toth','Jeffrey','','','','34','269783194','1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1965-04-23','M','M',':RET:2106-3','N','021','DEN','236591','99734OH005000401','2014-01-01','2013-12-02 13:37:35','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:46:12'),(4746,3761,'Y','18','021','EC','A','','','AC','0000765682','0000765682','TX00000571706','IL','1','Aucoin','Michelle','','','','34','553854483','417 ALEXANDER ST',0,'LANCASTER','TX','75146','1507','CY','48113','1969-09-25','F','U',':RET:2106-3','N','021','DEN','517342','33348TX002000201','2014-01-01','2013-12-08 18:03:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:15:02'),(22504,17965,'Y','18','021','EC','A','','','AC','0001198145','0001198145','OH00002050565','IL','1','Morlan','Carl','Edward','','','34','301460455','1261 CARNEGIE AVE',0,'AKRON','OH','44314','1151','CY','39153','1949-11-02','M','M',':RET:2106-3','T','021','DEN','2971905','99734OH005000301','2014-03-01','2014-02-10 16:44:35','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-02-10 21:31:14'),(13083,10430,'Y','18','021','EC','A','','','AC','0000612999','0000612999','OH00000373869','IL','1','Rawlings','Timothy','','','','34','273549366','3751 Lytle Rd',0,'Waynesville','OH','45068',NULL,'CY','39165','1955-01-28','M','M',':RET:2106-3','N','021','DEN','1753619','99734OH005000401','2014-01-01','2013-12-23 11:09:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:51:38'),(22027,17585,'Y','18','021','EC','A','','','AC','0000915681','0000915681','OH00002169292','IL','1','kinser','john','','','','34','300748721','512 WALNUT ST',0,'FINDLAY','OH','45840','5744','CY','39063','1979-06-05','M','U',':RET:2106-3','T','021','HLT','3709318','92036OH001001501','2014-03-01','2014-02-07 08:24:50','0.00',NULL,NULL,'370.62','370.62','R-OH002','OH0','370.62',NULL,0,'2014-02-07 19:01:01'),(9566,7580,'N','01','021','EC','A',NULL,NULL,'','0000718911','0000498153','','IL','1','Pushkaran','Suvarnamala','','','','34','155921436','1395 STABLEVIEW CIR',0,'MAINEVILLE','OH','45039','7916','CY','39165','1977-07-03','F','',':RET:2029-7','N','021','DEN','1600650','99734OH005000301','2014-01-01','2013-12-21 16:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:38'),(21479,17162,'Y','18','024','14','A','','','TE','0000939732','0000939732','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','1811842','','2014-02-19','2014-02-04 12:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-04 21:01:41'),(26514,21030,'Y','18','024','14','A','','','TE','0000294433','0000294433','','IL','1','Dietrich','Keith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-07-03','M','',NULL,NULL,NULL,'','2494975','','2014-02-28','2014-02-28 14:25:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:21'),(20568,16438,'Y','18','021','EC','A','','','AC','0000739053','0000739053','OH00002589397','IL','1','christman','karen','','','','34','297569629','205 BALDWIN AVE',0,'FINDLAY','OH','45840','2203','CY','39063','1957-03-29','F','U',NULL,'N','021','HLT','2726308','92036OH004001501','2014-03-01','2014-01-29 15:06:15','358.00',NULL,NULL,'412.86','54.86','R-OH002','OH0','412.86',NULL,0,'2014-01-29 21:01:50'),(18335,14641,'Y','18','021','EC','A','','','AC','0001151105','0001151105','OH00002274959','IL','1','Kempf','Karen','','','','34','406646443','6946 Newbridge Drive',0,'Cincinnati','OH','45239',NULL,'CY','39061','1947-10-04','F','M',':RET:2106-3','N','021','DEN','1540480','99734OH005000401','2014-02-01','2014-01-15 17:12:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:14'),(27627,21852,'Y','18','021','EC','A','','','AC','0000194121','0000194121','OH00002460872','IL','1','Shrider','Pamela','','','','34','299621430','670 W GRAND AVE',0,'LIMA','OH','45801','3504','CY','39003','1958-06-16','F','U',':RET:2106-3','N','021','DEN','2944718','99734OH005000401','2014-04-01','2014-03-04 19:46:55','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-03-05 21:30:08'),(29186,23100,'Y','18','021','EC','A','','','AC','0000906658','0000906658','OH00003560431','31','1','Svetlik','George','','','','34','283480127','Po Box 4675',0,'Akron','OH','44310',NULL,'CY','39153','1949-10-04','M','M',':RET:2106-3','N','021','HLT','3398390','52664OH151001301','2014-04-01','2014-03-10 13:10:05','292.00',NULL,NULL,'669.00','377.00','R-OH012','OH0','669.00','CIC',0,'2014-03-10 21:30:02'),(577,472,'Y','18','021','EC','A','','','AC','0001001127','0001001127','OH00000476231','IL','1','harris','michael','','','','34','282508482','620 mentor ave',0,'dayton','OH','45404',NULL,'CY','39113','1951-02-12','M','U',':RET:2106-3','N','021','HLT','462819','92036OH002000501','2014-01-01','2013-12-03 21:15:25','0.00',NULL,NULL,'788.67','788.67','R-OH003','OH0','788.67',NULL,0,'2013-12-25 17:50:44'),(24283,19285,'Y','18','021','EC','A','','','AC','0002311279','0002311279','LA00002776600','IL','1','Peaden','Harold','','','','34','437906118','3348 KNIGHTSBRIDGE PL',0,'HARVEY','LA','70058','7414','CY','22051','1955-01-07','M','M',':RET:2054-5','N','021','DEN','3401596','18575LA002000201','2014-03-01','2014-02-17 22:55:59','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61','CIC',0,'2014-02-18 21:30:08'),(17625,14091,'Y','18','021','EC','A','','','AC','0000860776','0000860776','TX00002093948','IL','1','Pacharzina','Amy','','','','34','601201801','14745 MERRILTOWN RD',0,'AUSTIN','TX','78728','3681','CY','48453','1974-11-04','F','U',':RET:2106-3','N','021','DEN','2449276','33348TX002000201','2014-02-01','2014-01-13 15:16:18','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:29'),(9400,7456,'Y','18','021','EC','A','','','AC','0001103824','0001103824','TX00000465833','IL','1','MCKENZIE','LORETTA','A','','','34','629345166','1305 CALIFORNIA TRL',0,'GRAND PRAIRIE','TX','75052','2075','CY','48113','1992-12-11','F','U',':RET:2054-5','N','021','DEN','2315496','33348TX002000201','2014-01-01','2013-12-21 00:34:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:32:34'),(17040,13635,'Y','18','021','EC','A','','','AC','0000411130','0000411130','OH00001456254','IL','1','Reid','Constance','','','','34','288483519','208 SANDS AVE',0,'MONROE','OH','45050','1523','CY','39017','1949-10-14','F','U',':RET:2106-3','N','021','HLT','2501354','92036OH004001201','2014-02-01','2014-01-09 14:50:43','416.00',NULL,NULL,'517.83','101.83','R-OH004','OH0','517.83',NULL,0,'2014-01-13 02:20:51'),(22300,17803,'Y','18','021','EC','A','','','AC','0001059501','0001059501','OH00001456638','IL','1','Screngi','Cassie','','','','34','270829347','108 E Franklin Street',0,'Centerville','OH','45459',NULL,'CY','39113','1984-01-18','F','U',':RET:2106-3','N','021','DEN','2710199','99734OH005000301','2014-03-01','2014-01-27 13:03:22','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-10 11:00:36'),(5600,4444,'Y','18','021','EC','A','','','AC','0000574417','0000574417','OH00000970521','IL','1','NGUYUEN','VIVIAN','','','','34','604203436','2755 LOCH RAVEN BLVD',0,'COPLEY','OH','44321','2165','CY','39153','1966-12-31','F','M',NULL,'N','021','DEN','589013','99734OH005000401','2014-01-01','2013-11-25 18:38:21','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:30:13'),(5360,4250,'N','01','021','EC','A',NULL,NULL,'','0001145964','0000510644','','IL','1','ALSTROM','KATHLEEN','','','','34','290469083','3364 S MAIN ST',0,'AKRON','OH','44319','3052','CY','39153','1950-02-10','F','',NULL,'N','021','HLT','1878907','52664OH152000901','2014-01-01','2013-12-19 17:20:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2013-12-25 23:07:50'),(3292,2654,'N','19','021','EC','A',NULL,NULL,'','0000461933','0001080325','','S1','1','Lowell','Ginger','','','','34','296086140','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','2004-04-02','F','',':RET:2106-3','N','021','DEN','1417328','99734OH005000301','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:33'),(25795,20456,'N','01','021','EC','A',NULL,NULL,'','0000356080','0000443508','','IL','1','Ferguson','Garry','','','','34','283469237','7913 NATIONAL RD SW',0,'ETNA','OH','43062','8614','CY','39089','1953-06-29','M','',NULL,'T','021','DEN','2687428','99734OH005000301','2014-04-01','2014-02-26 10:07:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:13'),(22936,18285,'Y','18','024','14','A','','','TE','0002121098','0002121098','','IL','1','Guitreau','Danny',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-11-22','M','',NULL,NULL,NULL,'','3227027','','2014-02-28','2014-02-10 19:59:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-11 21:30:15'),(1426,1188,'Y','18','021','EC','A','','','AC','0002080795','0002080795','LA00000218065','IL','1','Spears','Devan','','','','34','438311938','5465 WASHINGTON AVE',0,'BATON ROUGE','LA','70806','1645','CY','22033','1977-09-04','M','U',':RET:2054-5','N','021','DEN','1866846','18575LA002000201','2014-01-01','2013-12-24 16:52:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:47:25'),(20592,16454,'Y','18','021','EC','A','','','AC','0000341368','0000341368','OH00002296656','IL','1','Fox','Lawrence','Paul','','','34','278646975','414 MYRTLE AVE',0,'NEWARK','OH','43055','3174','CY','39089','1958-04-17','M','U',':RET:2106-3','N','021','DEN','3284189','99734OH005000401','2014-03-01','2014-01-30 09:33:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:08'),(2808,2269,'Y','18','021','EC','A','','','AC','0000061500','0000061500','MS00000982929','IL','1','Red','Frederick','','','','34','427392110','4216 OAK LAKE DR',0,'JACKSON','MS','39212','5369','CY','28049','1969-12-19','M','U',NULL,'N','021','DEN','588894','46300MS002000201','2014-01-01','2013-10-14 23:03:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 20:00:09'),(17168,13738,'Y','18','021','EC','A','','','AC','0002198944','0002198944','LA00001868456','IL','1','ASHRAF','RAHIM','','','','34','437716085','1105 ROSELAWN AVE',0,'MONROE','LA','71201',NULL,'CY','22073','1981-10-30','M','U',':RET:2106-3','N','021','DEN','1963555','18575LA002000201','2014-02-01','2014-01-08 17:07:05','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-13 02:22:06'),(4202,3342,'Y','18','021','EC','A','','','AC','0000236881','0000236881','TX00000345398','IL','1','Cancel','Carlos','','','','34','583853566','515 S. Sugar rd',0,'Edinburg','TX','78539',NULL,'CY','48215','1977-11-25','M','M',NULL,'N','021','DEN','2180428','33348TX002000201','2014-01-01','2013-12-16 20:21:53','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:49:56'),(4658,3693,'Y','18','021','EC','A','','','AC','0000268450','0000268450','LA00000038574','IL','1','Hurt','Kerry',NULL,NULL,NULL,NULL,NULL,'8916 MELODY LN',0,'SHREVEPORT','LA','71118','2435','CY','22017','1971-06-13','F','R',':RET:2106-3','N','021','DEN','1051611','18575LA002000201','2014-01-01','2013-12-12 10:39:42','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:07:18'),(5107,4047,'Y','18','021','EC','A','','','AC','0000950081','0000950081','TX00001280440','IL','1','Rodriguez','Miguel','','','','34','467756505','7129 Orange Tree Lane',0,'El Paso','TX','79915',NULL,'CY','48141','1975-01-08','M','M',NULL,'N','021','DEN','2452802','33348TX002000201','2014-01-01','2013-12-19 17:30:27','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:01:36'),(14686,11725,'Y','18','024','14','A','','','TE','0000484800','0000484800','','IL','1','Lengel','Joseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-01','M','',NULL,NULL,NULL,'','1521995','','2013-12-28','2013-12-28 12:17:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:08:42'),(16399,13121,'Y','18','021','EC','A','','','AC','0000807245','0000807245','TX00001538922','IL','1','HARRIS','JANE','','','','34','463411760','7525 KINGSMILL TER',0,'FORT WORTH','TX','76112','6023','CY','48439','1964-09-11','F','U',':RET:2054-5','N','021','DEN','2307095','33348TX002000201','2014-02-01','2014-01-06 13:43:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:48'),(28274,22375,'Y','18','021','EC','A','','','AC','0000458256','0000458256','TX00002957214','IL','1','CASTILLO','DEADIRA','','','','34','457838127','1409 14TH ST',0,'CORPUS CHRISTI','TX','78404','3440','CY','48355','1957-04-13','F','U',NULL,'N','021','DEN','4068696','33348TX002000201','2014-04-01','2014-03-07 14:55:30','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61','CIC',0,'2014-03-07 21:00:22'),(1766,1458,'Y','18','021','EC','A','','','AC','0000117803','0000117803','OH00001563329','IL','1','RUTAN','RYAN','ASHLEY','','','34','409319632','467 N HIGH ST',0,'COLUMBUS','OH','43215','2007','CY','39049','1978-09-03','M','M',':RET:2106-3','N','021','DEN','1881993','99734OH005000301','2014-01-01','2013-12-24 14:14:49','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:56:02'),(2337,1902,'Y','18','021','EC','A','','','AC','0000222922','0000222922','TX00000457217','IL','1','solis','hermelinda','','','','34','464190275','108 TREMONT',0,'TIVOLI','TX','77990','4614','CY','48391','1958-12-10','F','U',NULL,'N','021','DEN','599844','33348TX002000201','2014-01-01','2013-12-09 12:35:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:49'),(14539,11602,'Y','18','021','EC','A','','','AC','0000539931','0000539931','MS00000640946','IL','1','Davis','George',NULL,NULL,NULL,NULL,NULL,'322 clubview drive',0,'jackson','MS','39209',NULL,'CY','28049','1955-01-05','M','M',':RET:2054-5','N','021','DEN','2563222','46300MS002000201','2014-02-01','2013-12-27 12:55:17','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:46'),(13948,11122,'Y','18','021','EC','A','','','AC','0001053048','0001053048','OH00000881091','IL','1','Johnson','Richard','','','','34','300644016','910 CARPENTER RD',0,'LOVELAND','OH','45140','8104','CY','39025','1960-01-04','M','U',':RET:2106-3','N','021','HLT','1429429','92036OH004000601','2014-01-01','2013-12-23 09:33:48','200.00',NULL,NULL,'352.13','152.13','R-OH005','OH0','352.13',NULL,0,'2013-12-26 13:14:52'),(25505,20235,'Y','18','021','EC','A','','','AC','0000347967','0000347967','OH00002916646','IL','1','Conner','Deborah','','','','34','273585164','1217 S DIAMOND ST',0,'RAVENNA','OH','44266','3504','CY','39133','1954-05-04','F','U',':RET:2106-3','T','021','HLT','3006509','52664OH152000901','2014-04-01','2014-02-25 11:06:38','262.00',NULL,NULL,'488.95','226.95','R-OH012','OH0','488.95',NULL,0,'2014-02-25 21:31:57'),(22580,18034,'Y','18','021','EC','A','','','AC','0000661318','0000661318','OH00001555192','IL','1','TURNER','BESSIE','','','','34','268568220','809 N JEFFERSON ST',0,'DELPHOS','OH','45833','1061','CY','39161','1954-05-30','F','M',NULL,'N','021','HLT','3406764','92036OH003001501','2014-03-01','2014-02-10 10:21:22','286.00',NULL,NULL,'598.27','312.27','R-OH002','OH0','598.27',NULL,0,'2014-02-10 21:32:02'),(21180,16926,'N','01','021','EC','A',NULL,NULL,'','0000214694','0001034703','','IL','1','Broughton','Ronald','','','','34','299603155','7805 GAIL DR',0,'CINCINNATI','OH','45236','2331','CY','39061','1963-06-15','M','',NULL,'N','021','DEN','3683061','99734OH005000401','2014-03-01','2014-02-03 17:09:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:42'),(15347,12276,'Y','18','021','EC','A','','','AC','0000047099','0000047099','OH00000065783','IL','1','Shade','Andrew','','','','34','201703865','425 E WALNUT ST',0,'ASHLAND','OH','44805','3261','CY','39005','1983-08-01','M','U',':RET:2106-3','T','021','HLT','1597670','52664OH152000901','2014-02-01','2014-01-01 14:47:45','197.00',NULL,NULL,'213.20','16.20','R-OH012','OH0','213.20',NULL,1,'2014-01-02 04:24:25'),(5376,4263,'Y','18','021','EC','A','','','AC','0002074880','0002074880','LA00001049979','IL','1','Buras','Locke','','','','34','435044650','1680 Oneil Ln',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1955-11-04','M','U',':RET:2106-3','N','021','DEN','1461781','18575LA002000201','2014-01-01','2013-12-19 13:49:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:08:12'),(24215,19232,'N','01','021','EC','A',NULL,NULL,'','0000834329','0000159439','','IL','1','PEREZ','ROBERT','','','','34','466657747','155 HILLCREST LN',0,'LIBERTY HILL','TX','78642','4436','CY','48491','1982-10-06','M','',NULL,'N','021','DEN','3676029','33348TX002000201','2014-03-01','2014-02-15 20:13:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-16 19:00:25'),(21046,16815,'Y','18','024','14','A','','','TE','0000027270','0000027270','','IL','1','haileselassie','gelila',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-10','F','',NULL,NULL,NULL,'','1359715','','2014-02-01','2014-02-01 18:39:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-02 19:00:03'),(19498,15540,'Y','18','021','EC','A','','','AC','0000367410','0000367410','OH00002246742','IL','1','Enoch','Colleen','','','','34','301903001','9820 SUNRISE BLVD',0,'NORTH ROYALTON','OH','44133','3479','CY','39035','1988-07-19','F','U',':RET:2106-3','N','021','HLT','2884663','52664OH151001305','2014-03-01','2014-01-22 17:09:26','110.00',NULL,NULL,'252.53','142.53','R-OH011','OH0','252.53',NULL,0,'2014-01-23 03:02:09'),(17825,14240,'Y','18','021','EC','A','','','AC','0000740937','0000740937','MS00001726557','IL','1','DAVIS','LOYD','','','','34','424880237','28 SHARMONT DR',0,'HATTIESBURG','MS','39402','1950','CY','28073','1957-07-07','M','M',':RET:2054-5','N','021','DEN','2768017','46300MS002000201','2014-02-01','2014-01-14 12:16:52','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2014-01-15 02:05:57'),(9700,7683,'Y','18','024','14','A','','','TE','0001188783','0001188783','','IL','1','HOLTKAMP','JOHN','','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-04','M','',NULL,NULL,NULL,'','1521597','','2013-12-21','2013-12-21 16:11:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:56'),(7590,6005,'Y','18','021','EC','A','','','AC','0000192698','0000192698','OH00000942846','IL','1','Shope','Rhonda','Kaye','','','34','298504348','4620 BELMONT CT',0,'HUBER HEIGHTS','OH','45424','3672','CY','39113','1952-06-05','F','U',':RET:2106-3','N','021','DEN','308604','99734OH005000401','2014-01-01','2013-11-16 20:32:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:45:07'),(7100,5631,'Y','18','021','EC','A','','','AC','0000722641','0000722641','OH00000119413','IL','1','jones','sandra','','','','34','307541256','7433 adrianne dr.',0,'andover','OH','44003',NULL,NULL,NULL,'1949-10-29','F','U',':RET:2106-3','T','021','HLT','2576332','52664OH151001304','2014-02-01','2013-12-25 07:45:13','628.00',NULL,NULL,'867.72','239.72',NULL,'OH0','867.72',NULL,0,'2013-12-26 01:50:44'),(9630,7628,'Y','18','021','EC','A','','','AC','0000808654','0000808654','OH00001164943','IL','1','Francek','Lynn','','','','34','275489813','26 TOWNSHIP ROAD 1300',0,'WEST SALEM','OH','44287','9603','CY','39005','1955-02-20','F','U',NULL,'N','021','HLT','2122115','52664OH152000901','2014-01-01','2013-12-21 14:45:56','367.00',NULL,NULL,'416.19','49.19','R-OH012','OH0','416.19',NULL,0,'2013-12-26 04:38:11'),(4555,3608,'Y','18','021','EC','A','','','AC','0000604695','0000604695','OH00000815416','IL','1','Posante','Shelley','','','','34','304528993','9741 DANIELS RD',0,'SEVILLE','OH','44273','9526','CY','39103','1949-09-05','F','M',':RET:2106-3','N','021','HLT','407012','52664OH152000901','2014-01-01','2013-12-12 12:24:01','297.00',NULL,NULL,'490.00','193.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 22:04:36'),(9360,7420,'Y','18','021','EC','A','','','AC','0001574792','0001574792','LA00000682281','IL','1','Ducote','Daniel','','','','34','436695963','15320 BECKY LEE DR',0,'BATON ROUGE','LA','70819','3403','CY','22033','1981-01-23','M','U',':RET:2106-3','T','021','DEN','1675218','18575LA002000201','2014-01-01','2013-12-21 10:09:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:31'),(233,195,'N','19','021','EC','A',NULL,NULL,'','0000337587','0001077709','','IL','1','reiser','kirsten','','','','34','269960315','415 FLEMRIDGE CT',0,'WYOMING','OH','45231','4015','CY','39061','1992-10-06','F','',':RET:2106-3','N','021','HLT','481342','92036OH006001201','2014-01-01','2013-12-05 18:00:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','170.24',NULL,0,'2013-12-25 17:21:05'),(1325,1096,'Y','18','021','EC','A','','','AC','0000722604','0000722604','OH00000280890','IL','1','Webster','Richard','','','','34','294708016','920 N FIRESTONE BLVD',0,'AKRON','OH','44306','2768','CY','39153','1970-05-10','M','U',':RET:2106-3','N','021','DEN','290936','99734OH005000401','2014-01-01','2013-10-25 12:11:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:31:53'),(26738,21191,'Y','18','024','14','A','','','TE','0000781876','0000781876','','IL','1','Donahue','Angela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-04-25','F','',NULL,NULL,NULL,'','993092','','2014-03-15','2014-02-28 13:38:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 21:31:53'),(26136,20725,'N','19','021','EC','A',NULL,NULL,'','0001204586','0000971518','','S1','1','HABLI','FIRAS','','','','34','302088105','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','2004-08-11','M','',':RET:2106-3','N','021','DEN','3501190','99734OH005000401','2014-03-01','2014-02-27 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:24'),(4734,3751,'Y','18','021','EC','A','','','AC','0000132047','0000132047','OH00000013553','IL','1','MOLONEY','NICOLE','','','','34','276742394','152 LARKINS STREET',0,'FINDLAY','OH','45840',NULL,'CY','39063','1978-08-12','F','M',NULL,'T','021','HLT','468152','92036OH003001505','2014-01-01','2013-12-12 16:54:02','558.00',NULL,NULL,'773.89','215.89','R-OH002','OH0','322.97',NULL,0,'2013-12-25 22:09:14'),(25882,20522,'Y','18','021','EC','A','','','AC','0000419348','0000419348','TX00002595238','IL','1','WINBOURN','DAVID','F','','','34','466131587','3502 OLD IOWA PARK ROAD',0,'WITCHITA FALLS','TX','76306',NULL,'CY','48485','1955-04-27','M','M',':RET:2106-3','N','021','DEN','3565722','33348TX002000201','2014-03-01','2014-02-26 10:40:36','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-26 21:00:58'),(6312,5007,'Y','18','021','EC','A','','','AC','0000969424','0000969424','OH00000565134','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','DEN','986258','99734OH005000401','2014-01-01','2013-12-11 10:44:09','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:46:12'),(25532,20255,'Y','18','021','EC','A','','','AC','0001082303','0001082303','TX00002729386','IL','1','Hernandez','Asmaa','Abdelaziz','','','34','634250912','1007 SHOFNER ST',0,'KILLEEN','TX','76541','7848','CY','48027','1985-07-16','F','M',NULL,'N','021','DEN','2875617','33348TX002000201','2014-04-01','2014-02-23 00:49:39','0.00',NULL,NULL,'67.44','67.44','R-TX011','TX0','14.61',NULL,0,'2014-02-26 08:00:05'),(22711,18136,'Y','18','021','EC','A','','','AC','0001815612','0001815612','LA00001991816','IL','1','Licona','Martha','Reimenda','','','34','438997976','545 LAURICELLA AVE',0,'JEFFERSON','LA','70121','1734','CY','22051','1958-03-18','F','M',NULL,'N','021','DEN','3013299','18575LA002000201','2014-03-01','2014-02-10 22:54:06','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:05'),(27472,21740,'N','01','021','EC','A',NULL,NULL,'','0001045750','0000712580','','IL','1','owens','jean','','','','34','295523325','1109 JUDITH ST',0,'LIMA','OH','45801','3534','CY','39003','1952-09-01','F','',':RET:2106-3','N','021','HLT','2625764','92036OH004001501','2014-04-01','2014-03-04 14:52:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.29',NULL,0,'2014-03-04 21:02:12'),(18055,14425,'Y','18','021','EC','A','','','AC','0001125455','0001125455','OH00002100371','IL','1','Talamantez','Patti','','','','34','266293522','32 Connelsville Ave.',0,'Toledo','OH','43615',NULL,'CY','39095','1957-02-22','F','U',':RET:2106-3','N','021','HLT','2169702','92036OH001002601','2014-02-01','2014-01-13 19:37:08','253.00',NULL,NULL,'548.73','295.73','R-OH001','OH0','548.73',NULL,0,'2014-01-15 02:07:18'),(18348,14648,'N','01','021','EC','A',NULL,NULL,'','0000234068','0001048013','','IL','1','Damon','Pamela','','','','34','272523652','8068 Quail Meadow Lane',0,'West Chester','OH','45069',NULL,'CY','39017','1952-02-22','F','',':RET:2106-3','N','021','DEN','1469552','99734OH005000301','2014-02-01','2014-01-14 19:15:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:20'),(20699,16539,'Y','18','021','EC','A','','','AC','0001760493','0001760493','LA00002513752','IL','1','Gaines','Denise','','','','34','438590715','4725 Bluebonnet Road',0,'Baton Rouge','LA','70809',NULL,'CY','22033','1985-01-10','F','U',':RET:2106-3','N','021','DEN','2150349','18575LA002000201','2014-03-01','2014-01-29 19:55:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-30 21:01:02'),(21998,17566,'Y','18','021','EC','A','','','AC','0002052897','0002052897','LA00001956999','IL','1','LANTIER','AMY','','','','34','438496630','1302 SAINT MARY ST',0,'SCOTT','LA','70583',NULL,'CY','22055','1970-02-19','F','U',':RET:2106-3','N','021','DEN','3788373','18575LA002000201','2014-03-01','2014-02-07 16:10:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-07 19:00:46'),(29205,23112,'Y','18','024','14','A','','','TE','0000640905','0000640905','','IL','1','Moore','Vena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-15','F','',NULL,NULL,NULL,'','330736','','2014-03-31','2014-03-10 12:38:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-10 21:30:12'),(929,769,'N','01','021','EC','A',NULL,NULL,'','0000115452','0000091098','','IL','1','Rini','Joseph','Benjamin','','Sr','34','302802854','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','1981-01-20','M','',':RET:2106-3','T','021','DEN','19531','99734OH005000401','2014-01-01','2013-10-28 23:21:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:02'),(14612,11663,'Y','18','021','EC','A','','','AC','0000352838','0000352838','OH00001406950','IL','1','Duskin','Sonja','','','','34','285866545','7718 Hamilton Ave',0,'Cincinnati','OH','45231',NULL,'CY','39061','1972-12-09','F','R',':RET:2054-5','N','021','DEN','1653974','99734OH005000301','2014-02-01','2013-12-27 17:06:45','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:36:41'),(13434,10717,'Y','18','024','14','A','','','TE','0000846132','0000846132','','IL','1','KOHR','DIANA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-25','F','',NULL,NULL,NULL,'','1982225','','2013-12-23','2013-12-23 12:55:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:01:07'),(15215,12161,'Y','18','021','EC','A','','','AC','0000132079','0000132079','OH00001772783','IL','1','HUTCHINSON','JOANN','','','','34','282522270','5625 WRIGHT PUTHOFF RD',0,'SIDNEY','OH','45365','8009','CY','39149','1952-04-06','F','M',':RET:2106-3','N','021','HLT','1736599','92036OH005000501','2014-02-01','2013-12-30 09:40:30','554.00',NULL,NULL,'667.97','113.97','R-OH003','OH0','667.97',NULL,0,'2014-01-01 12:07:49'),(26989,21378,'N','19','021','EC','A',NULL,NULL,'','0000805173','0001152255','','S1','1','Ulrich','Debra',NULL,NULL,NULL,NULL,NULL,'1828 W MAIN CROSS ST',0,'FINDLAY','OH','45840','1714','CY','39063','1998-11-16','M','',NULL,'N','021','HLT','2946834','92036OH006001501','2014-04-01','2014-03-02 14:46:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-03-03 01:00:41'),(986,806,'N','01','021','EC','A',NULL,NULL,'','0000525539','0000763484','','IL','1','Scalia','Sharon','','','','34','288782719','2931 OAKCREST DR',0,'NORTON','OH','44203','6385','CY','39153','1978-02-18','F','',':RET:2106-3','N','021','HLT','869301','52664OH151001501','2014-01-01','2013-10-31 12:40:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','326.84',NULL,0,'2013-12-25 18:10:26'),(25925,20560,'Y','18','021','EC','A','','','AC','0000823246','0000823246','TX00002376489','31','1','Hurt','Toni','','','','34','464130671','p.o. box 1331',0,'Port Isabel','TX','78578',NULL,'CY','48061','1963-07-07','F','M',':RET:2106-3','N','021','DEN','2863720','33348TX002000201','2014-04-01','2014-02-26 16:07:39','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-02-26 21:01:23'),(3554,2853,'Y','18','021','EC','A','','','AC','0000184937','0000184937','OH00000399782','IL','1','Laurianti','Wanda','','','','34','278504376','559 DALEVIEW DR',0,'AURORA','OH','44202','7311','CY','39133','1950-12-28','F','M',':RET:2106-3','N','021','HLT','1637225','52664OH151001305','2014-01-01','2013-12-22 10:48:00','492.00',NULL,NULL,'658.32','166.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 21:22:08'),(25083,19893,'Y','18','021','EC','A','','','AC','0000305891','0000305891','OH00002792603','IL','1','RINNER','MANDY','','','','34','274788332','2090 TOWNLINE ROAD 12',0,'WILLARD','OH','44890',NULL,'CY','39077','1977-10-21','F','U',NULL,'N','021','HLT','2753695','92036OH003002706','2014-04-01','2014-02-20 15:18:42','125.00',NULL,NULL,'379.79','254.79','R-OH006','OH0','250.48',NULL,0,'2014-02-20 22:01:40'),(6034,4778,'Y','18','021','EC','A','','','AC','0000291807','0000291807','TX00000791464','IL','1','McCorquodale','Angus','','','','34','457296106','2019 HADDON ST',0,'HOUSTON','TX','77019','5709','CY','48201','1963-04-26','M','R',':RET:2106-3','N','021','DEN','912197','33348TX002000201','2014-01-01','2013-11-30 18:41:24','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:01:13'),(15559,12450,'N','01','021','EC','A',NULL,NULL,'','0000408491','0000694208','','IL','1','JONES','PAUL','','','','34','296482930','7179 LEXINGTON CT',0,'NORTHFIELD','OH','44067',NULL,'CY','39153','1950-02-24','M','',NULL,'N','021','HLT','1801088','52664OH151001305','2014-02-01','2013-12-30 19:56:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,1,'2014-01-02 04:31:32'),(24414,19393,'Y','18','021','EC','A','','','AC','0000130745','0000130745','OH00001521017','31','1','Griffith','Linda','','','','34','277549867','PO Box 168',0,'Bergholz','OH','43908',NULL,'CY','39081','1952-06-14','F','M',':RET:2106-3','N','021','DEN','2915235','99734OH005000301','2014-04-01','2014-02-18 10:51:23','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-02-18 22:01:03'),(18152,14496,'Y','18','021','EC','A','','','AC','0000761133','0000761133','OH00002029585','IL','1','Neff','Phillip','','','','34','268909016','860 MAPLE AVE',0,'FINDLAY','OH','45840','5072','CY','39063','1983-04-06','M','U',':RET:2106-3','N','021','HLT','1791529','92036OH004001501','2014-02-01','2014-01-13 20:58:18','199.39',NULL,NULL,'200.86','1.47','R-OH002','OH0','200.86',NULL,0,'2014-01-15 02:07:50'),(20320,16223,'Y','18','021','EC','A','','','AC','0000037089','0000037089','TX00001838061','IL','1','Medina','Rebecca','','','','34','451966324','1102 E 13TH ST',0,'SWEETWATER','TX','79556','2531','CY','48353','1951-01-21','F','U',':RET:2106-3','N','021','DEN','3086166','33348TX002000201','2014-03-01','2014-01-28 14:34:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-28 21:00:55'),(22597,18049,'Y','18','021','EC','A','','','AC','0000262764','0000262764','OH00002182623','IL','1','Price','Christopher','','','','34','285708816','5967 BLACK OAK DR',0,'TOLEDO','OH','43615','1811','CY','39095','1974-09-13','M','M',':RET:2054-5','N','021','HLT','3159099','92036OH003002605','2014-03-01','2014-02-10 14:11:52','274.00',NULL,NULL,'507.46','233.46','R-OH001','OH0','256.98',NULL,0,'2014-02-10 21:32:13'),(28889,22865,'Y','18','021','EC','A','','','AC','0001075771','0001075771','TX00003092895','IL','1','Palomarez','Maria','','','','34','464968905','2421 COLGATE CIR',0,'COLLEGE STATION','TX','77840','4615','CY','48041','1954-04-14','F','U',':RET:2106-3','N','021','DEN','2728391','33348TX002000201','2014-04-01','2014-03-10 14:43:11','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-03-10 21:00:14'),(430,353,'Y','18','024','14','A','','','TE','0000745405','0000745405','','IL','1','Salyers','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-03-07','M','',NULL,NULL,NULL,'','1068321','','2013-12-04','2013-12-04 16:34:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:46:54'),(756,624,'Y','18','021','EC','A','','','AC','0000479622','0000479622','TX00000325502','IL','1','PETERS','TOM','','','','34','503629767','734 LAKE DAM ROAD',0,'BLACKWELL','TX','79506',NULL,'CY','48081','1950-10-02','M','M',':RET:2106-3','N','021','DEN','2392370','33348TX002000201','2014-01-01','2013-12-16 11:00:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:25'),(9747,7718,'Y','18','021','EC','A','','','AC','0000468880','0000468880','LA00000779118','IL','1','Lee','Henry','J','','','34','439020085','636 Cherry St',0,'Minden','LA','71055',NULL,'CY','22119','1957-03-14','M','U',':RET:2054-5','N','021','DEN','569974','18575LA002000101','2014-01-01','2013-11-15 02:46:26','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-26 04:46:06'),(9555,7573,'Y','18','021','EC','A','','','AC','0000915641','0000915641','OH00000211841','IL','1','Garey','John','','','','34','270865428','337 Chesterfield Ln.',0,'Maumee','OH','43537',NULL,'CY','39095','1986-06-14','M','U',NULL,'T','021','DEN','1632126','99734OH005000301','2014-01-01','2013-12-21 14:14:37','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-26 04:36:23'),(8844,7010,'Y','18','021','EC','A','','','AC','0000140522','0000140522','TX00000240575','IL','1','joseph','kristopher','conrad','','','34','100724832','1804 pete brown drive',0,'el paso','TX','79936',NULL,'CY','48141','1980-12-20','M','U',':RET:2054-5','N','021','DEN','1954964','33348TX002000201','2014-01-01','2013-12-17 23:46:37','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:00:50'),(26499,21021,'N','19','021','EC','A',NULL,NULL,'','0001064742','0000406178','','IL','1','PODOLL','ELIZA','','','','34','301048518','5625 NICHOLSON DR',0,'HUDSON','OH','44236','3700','CY','39153','2000-07-22','F','',NULL,'N','021','HLT','3055284','52664OH151001304','2014-03-01','2014-02-28 16:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 21:00:15'),(1126,926,'Y','18','021','EC','A','','','AC','0000451552','0000451552','TX00000696911','IL','1','charles','Chris','','','','34','400926478','8615 STRATHMORE DR',0,'DALLAS','TX','75238','3851','CY','48113','1958-12-23','M','U',':RET:2054-5','N','021','DEN','657255','33348TX002000101','2014-01-01','2013-12-02 19:35:20','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:17:55'),(1286,1063,'Y','18','021','EC','A','','','AC','0000929805','0000929805','OH00000581700','IL','1','Mayfield','Jack','','','','34','278523377','129 WATERLOO RD',0,'MOGADORE','OH','44260','1624','CY','39133','1951-07-08','M','U',':RET:2106-3','N','021','HLT','487889','52664OH151001301','2014-01-01','2013-11-29 10:53:38','0.00',NULL,NULL,'640.70','640.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 18:30:43'),(18919,15074,'N','19','021','EC','A',NULL,NULL,'','0001094663','0000559462','','IL','1','TOPP','TESSA','M','','','34','283960842','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1993-07-17','F','',':RET:2106-3','N','021','HLT','1606089','92036OH003001506','2014-02-01','2014-01-15 19:34:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-01-17 03:36:42'),(16767,13413,'Y','18','021','EC','A','','','AC','0000785808','0000785808','OH00001771904','IL','1','DAVIS','SHERRY','','','','34','289622429','963 GALSWORTHY CT',0,'CINCINNATI','OH','45240',NULL,'CY','39061','1968-05-20','F','M',':RET:2054-5','T','021','HLT','1631235','92036OH006001201','2014-02-01','2014-01-07 12:13:03','0.00',NULL,NULL,'282.72','282.72','R-OH004','OH0','282.72',NULL,0,'2014-01-08 18:25:00'),(3726,2977,'N','01','021','EC','A',NULL,NULL,'','0000195117','0000500384','','IL','1','Vorhees','Juanita','','','','34','298564421','9700 PUDDENBAG RD',0,'GERMANTOWN','OH','45327','8832','CY','39113','1953-08-11','F','',':RET:2106-3','N','021','DEN','802318','99734OH005000401','2014-01-01','2013-12-13 16:28:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:28'),(7854,6219,'Y','18','024','14','A','','','TE','0000192727','0000192727','','IL','1','Lehman','Ronald','H',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-10-28','M','',NULL,NULL,NULL,'','1509377','','2013-12-20','2013-12-20 09:45:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:54'),(3088,2482,'Y','18','021','EC','A','','','AC','0000662672','0000662672','OH00001005355','IL','1','Saunders','Gary','E','','Jr','34','126740343','721 Shawnee Run',0,'West Carrollton','OH','45449',NULL,'CY','39113','1988-11-02','M','U',NULL,'N','021','HLT','499550','92036OH005000506','2014-01-01','2013-12-05 22:22:39','179.00',NULL,NULL,'238.66','59.66','R-OH003','OH0','238.66',NULL,0,'2013-12-25 20:19:55'),(22805,18201,'Y','18','021','EC','A','','','AC','0001018278','0001018278','OH00002654184','IL','1','SHAMPTON','CHRISTINA','T','','','34','268644448','1760 SEA BREEZE  COURT',0,'DAYTON','OH','45458',NULL,'CY','39113','1965-09-02','F','U',NULL,'N','021','DEN','3685549','99734OH005000301','2014-03-01','2014-02-11 13:41:12','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-11 21:01:54'),(23317,18584,'N','01','021','EC','A',NULL,NULL,'','0000416004','0000672804','','IL','1','OVIAHON','ROBIN','','','','34','278706647','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1968-10-29','F','',':RET:2054-5','T','021','DEN','3381743','99734OH005000301','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:23'),(24649,19566,'Y','18','021','EC','A','','','AC','0002273754','0002273754','LA00002392410','IL','1','Javier','Lenny','','','','34','661209156','650 Bellemeade Blvd',0,'Gretna','LA','70056',NULL,'CY','22051','1978-02-10','M','U',NULL,'N','021','DEN','3222363','18575LA002000201','2014-04-01','2014-02-19 15:36:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 04:22:18'),(1463,1220,'Y','18','021','EC','A','','','AC','0000669182','0000669182','OH00000523155','IL','1','TENAGLIO','GEORGE ANN','','','','34','289548895','1418 CHURCHILL HUBBARD RD',0,'YOUNGSTOWN','OH','44505','1349','CY','39155','1952-04-08','F','M',':RET:2106-3','N','021','DEN','1444476','99734OH005000401','2014-01-01','2013-12-24 08:59:17','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:48:23'),(5828,4628,'Y','18','021','EC','A','','','AC','0000398416','0000398416','TX00001430625','31','1','Kornegay','James','','','','34','642071040','505 W Mckinley Avenue',0,'Harlingen','TX','78550',NULL,'CY','48061','1987-11-19','M','M',':RET:2106-3','N','021','DEN','1973179','33348TX002000201','2014-01-01','2013-12-23 23:06:27','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 23:48:11'),(16855,13485,'Y','18','021','EC','A','','','AC','0001005733','0001005733','OH00001365890','IL','1','parsley','william','','','','34','282847846','4851 STATE ROUTE 162 E',0,'NEW LONDON','OH','44851','9242','CY','39077','1971-03-17','M','U',':RET:2106-3','N','021','HLT','2348429','92036OH003002701','2014-02-01','2014-01-11 15:13:01','31.00',NULL,NULL,'269.82','238.82','R-OH006','OH0','269.82',NULL,0,'2014-01-13 02:18:43'),(7286,5777,'N','01','021','EC','A',NULL,NULL,'','0000609515','0000672739','','IL','1','WERT','KEVIN','C','','','34','286729984','8929 S MAIN ST',0,'WINDHAM','OH','44288',NULL,'CY','39133','1961-04-10','M','',':RET:2106-3','N','021','HLT','666388','52664OH151001501','2014-01-01','2013-12-14 09:35:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-26 02:02:49'),(13260,10582,'Y','18','024','14','A','','','TE','0000815505','0000815505','','IL','1','gomez','michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-11-30','F','',NULL,NULL,NULL,'','303241','','2013-12-23','2013-12-23 12:06:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:56:38'),(21716,17341,'Y','18','021','EC','A','','','AC','0000793502','0000793502','OH00002063806','IL','1','Florey','Carol','','','','34','268566610','402 E WATER ST',0,'GREENVILLE','OH','45331','2133','CY','39037','1953-12-04','F','U',NULL,'N','021','HLT','2678073','92036OH004000501','2014-03-01','2014-02-05 15:21:50','514.94',NULL,NULL,'518.73','3.79','R-OH003','OH0','518.73',NULL,0,'2014-02-05 21:31:17'),(25562,20278,'Y','18','021','EC','A','','','AC','0000769712','0000769712','TX00003069040','31','1','Rush','Joel','Wayne','','','34','460045281','PO Box 1562',0,'Forney','TX','75126',NULL,'CY','48257','1955-12-19','M','M',':RET:2106-3','N','021','DEN','3624495','33348TX002000101','2014-04-01','2014-02-23 17:10:24','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-26 08:00:23'),(25896,20533,'Y','18','021','EC','A','','','AC','0000770975','0000770975','TX00002130537','IL','1','Tillman','Marie','V','','','34','464940786','8003 MISTY BREEZE',0,'SAN ANTONIO','TX','78250','4643','CY','48029','1955-06-09','F','M',':RET:2106-3','N','021','DEN','2698591','33348TX002000201','2014-03-01','2014-02-26 13:02:39','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-02-26 21:01:06'),(27832,22013,'Y','18','021','EC','A','','','AC','0000913020','0000913020','OH00003652761','IL','1','METCALF','JAMES','','','','34','295583427','129 PALMER LN',0,'BRYAN','OH','43506','7800','CY','39171','1956-05-28','M','M',':RET:2106-3','T','021','DEN','3748256','99734OH005000301','2014-04-01','2014-03-05 10:44:21','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-05 21:32:01'),(409,337,'Y','18','021','EC','A','','','AC','0000281975','0000281975','OH00001158473','IL','1','STREAT','QUANATA','S','','','34','290705828','1815 GENESSEE AVE',0,'COLUBUS','OH','43211',NULL,'CY','39049','1971-03-24','F','M',NULL,'N','021','DEN','398934','99734OH005000401','2014-01-01','2013-12-04 15:06:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:21'),(19678,15682,'Y','18','024','14','A','','','TE','0001065186','0001065186','','IL','1','Boyd','Logan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-29','M','',NULL,NULL,NULL,'','2139467','','2014-01-22','2014-01-22 22:07:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:36'),(14324,11424,'Y','18','021','EC','A','','','AC','0000328419','0000328419','OH00000331128','IL','1','cuthbert','daniel','','','','34','283569013','58 MARSHALL AVE',0,'AKRON','OH','44303','1410','CY','39153','1954-10-25','M','U',':RET:2106-3','N','021','HLT','2364821','52664OH151001305','2014-02-01','2013-12-26 14:51:26','425.00',NULL,NULL,'580.49','155.49','R-OH012','OH0','580.49',NULL,0,'2013-12-27 02:07:19'),(9619,7618,'Y','18','021','EC','A','','','AC','0000318404','0000318404','OH00000933693','IL','1','Kesson','Luke','','','','34','380087541','2944 W CENTRAL AVE',0,'TOLEDO','OH','43606','3022','CY','39095','1986-05-25','M','M',':RET:2106-3','N','021','HLT','1487161','92036OH005002605','2014-01-01','2013-12-20 19:57:10','280.00',NULL,NULL,'408.70','128.70','R-OH001','OH0','204.35',NULL,0,'2013-12-26 04:37:51'),(5350,4243,'Y','18','021','EC','A','','','AC','0001231762','0001231762','OH00001292181','IL','1','Jones','Juan','D','','','34','285780248','637 Moon St',0,'Akron','OH','44307',NULL,'CY','39153','1982-01-07','M','R',':RET:2054-5','N','021','HLT','1575692','52664OH152000901','2014-01-01','2013-12-19 12:30:58','0.00',NULL,NULL,'189.31','189.31','R-OH012','OH0','189.31',NULL,0,'2013-12-25 23:07:36'),(3930,3145,'Y','18','021','EC','A','','','AC','0000604698','0000604698','OH00000904870','IL','1','Fahnestock','Christy','','','','34','296765921','315 South Enterprise',0,'Bowling Green','OH','43402',NULL,'CY','39173','1978-12-31','F','U',':RET:2106-3','T','021','HLT','427299','92036OH004002601','2014-01-01','2013-12-12 20:40:19','0.00',NULL,NULL,'220.33','220.33','R-OH001','OH0','220.33',NULL,0,'2013-12-25 21:37:37'),(4372,3473,'Y','18','021','EC','A','','','AC','0001045659','0001045659','OH00001286681','IL','1','Taulbee','Katie','','','','34','298841167','1531 S HIGH ST',0,'COLUMBUS','OH','43207','1832','CY','39049','1986-11-26','F','U',':RET:2106-3','N','021','DEN','781883','99734OH005000401','2014-01-01','2013-12-11 23:07:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:20'),(23129,18435,'Y','18','024','14','A','','','TE','0000084092','0000084092','','IL','1','christman','jerry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-11','M','',NULL,NULL,NULL,'','2932419','','2014-02-12','2014-02-12 16:31:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:29'),(23939,19033,'N','01','021','EC','A',NULL,NULL,'','0000979339','0000483528','','IL','1','Jorgenson','Lisa','Marie','','','34','299823896','754 POINTVIEW DR',0,'WESTERVILLE','OH','43081','3476','CY','39049','1984-06-03','F','',':RET:2106-3','N','021','DEN','3425477','99734OH005000301','2014-03-01','2014-02-15 06:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-15 21:00:07'),(24299,19300,'Y','18','021','EC','A','','','AC','0001041549','0001041549','TX00002882060','IL','1','FORD','ALISHA','','','','34','456633027','974 COUNTY ROAD 4445',0,'SPURGER','TX','77660','9206','CY','48457','1973-05-31','F','M',':RET:2106-3','T','021','DEN','3704439','33348TX002000201','2014-04-01','2014-02-18 15:48:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-02-18 21:30:18'),(26381,20928,'Y','18','024','14','A','','','TE','0002266676','0002266676','','IL','1','Jewell','Baylor','Looper','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-16','M','',NULL,NULL,NULL,'','2422009','','2014-03-31','2014-02-26 15:30:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:00:20'),(26950,21354,'Y','18','021','EC','A','','','AC','0000899621','0000899621','OH00002509192','IL','1','Ayotte','Daniel','','','','34','283863026','null null',0,'WILLISTON','OH','43468','0106','CY','39123','1986-07-10','M','R',':RET:2106-3','N','021','HLT','3632729','92036OH003002701','2014-05-01','2014-03-02 13:26:12','0.00',NULL,NULL,'213.40','213.40','R-OH006','OH0','213.40',NULL,0,'2014-03-03 01:00:26'),(5,4,'Y','18','021','EC','A','','','AC','0000371464','0000371464','OH00000480817','IL','1','Baker','Michael','','','','34','310885469','1080 GOVERNORS DR',0,'FAIRFIELD','OH','45014','2946','CY','39017','1980-01-22','M','U',':RET:2054-5','N','021','DEN','1234707','99734OH005000401','2014-01-01','2013-12-04 20:18:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:08'),(14631,11678,'Y','18','021','EC','A','','','AC','0000722644','0000722644','OH00000405907','IL','1','Anderson','Ronnie','','','','34','271528170','5381 E TOWNSHIP ROAD 138',0,'TIFFIN','OH','44883','9688','CY','39147','1951-10-22','M','M',':RET:2106-3','N','021','HLT','2144949','92036OH005002705','2014-02-01','2013-12-27 12:39:59','902.00',NULL,NULL,'1015.14','113.14','R-OH006','OH0','560.22',NULL,0,'2013-12-28 03:37:12'),(6198,4911,'Y','18','021','EC','A','','','AC','0000639477','0000639477','OH00000931444','IL','1','Burgwald','Susan','','','','34','277527805','4295 CASA BELLA DR',0,'PERRY','OH','44081','9749','CY','39085','1951-06-15','F','U',':RET:2106-3','N','021','DEN','571271','99734OH005000301','2014-01-01','2013-10-23 15:41:18','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:30:31'),(1982,1621,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000483215','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','1152817','33348TX002000101','2014-01-01','2013-11-19 23:04:27','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:44'),(2233,1837,'Y','18','021','EC','A','','','AC','0000009819','0000009819','OH00000337781','IL','1','Clark','Jonathan','','','','34','269884568','324 Wentworth Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','1981-03-16','M','M',NULL,'N','021','HLT','584104','92036OH005001201','2014-01-01','2013-12-10 16:24:10','277.00',NULL,NULL,'780.56','503.56','R-OH004','OH0','253.96',NULL,0,'2013-12-25 19:20:50'),(2645,2149,'Y','18','021','EC','A','','','AC','0000878864','0000878864','TX00000860322','IL','1','Duda','Dale','Stanley','','','34','366568490','3604 Cedar Springs Road',0,'Dallas','TX','75219',NULL,'CY','48113','1951-10-28','M','U',':RET:2106-3','N','021','DEN','604493','33348TX002000101','2014-01-01','2013-12-01 18:27:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:46:26'),(9249,7333,'Y','18','021','EC','A','','','AC','0000132059','0000132059','OH00000977441','IL','1','Stahl-Frakes','Wendy','','','','34','291448049','1407 BROOK LAWN',0,'FINDLAY','OH','45840','8104','CY','39063','1960-04-11','F','M',':RET:2106-3','N','021','HLT','1903101','92036OH002001501','2014-01-01','2013-12-18 17:31:24','252.00',NULL,NULL,'518.49','266.49','R-OH002','OH0','518.49',NULL,0,'2013-12-26 04:10:45'),(9783,7748,'Y','18','021','EC','A','','','AC','0000623941','0000623941','OH00000076967','IL','1','Smith','Floyd','','','','34','284708879','796 RINKER RD',0,'STEUBENVILLE','OH','43953','7145','CY','39081','1966-05-15','M','U',NULL,'N','021','DEN','243041','99734OH005000301','2014-01-01','2013-10-21 12:03:31','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 05:00:47'),(21544,17209,'Y','18','021','EC','A','','','AC','0000995471','0000995471','OH00001543658','IL','1','Cooper','Joanne','','','','34','301700433','19109 SHAWNEE AVE',0,'CLEVELAND','OH','44119','2715','CY','39035','1964-11-21','F','U',':RET:2054-5','N','021','DEN','3279333','99734OH005000401','2014-03-01','2014-02-05 09:50:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:10'),(22313,17814,'Y','18','021','EC','A','','','AC','0000013828','0000013828','MS00001654787','IL','1','Spencer','Sheletta','','','','34','587438567','42A Scott Drive',0,'Marks','MS','38646',NULL,'CY','28119','1982-07-01','F','U',':RET:2054-5','T','021','DEN','2936732','46300MS002000101','2014-03-01','2014-01-24 22:59:24','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-10 11:00:47'),(25856,20498,'Y','18','021','EC','A','','','AC','0001345333','0001345333','LA00002112297','IL','1','BORDELON','PRENTISS','','','','34','437496029','175 POPPY LN',0,'LA PLACE','LA','70068','5641','CY','22095','1970-02-18','F','M',NULL,'N','021','DEN','3593911','18575LA002000201','2014-03-01','2014-02-26 10:12:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:42'),(26803,21240,'Y','18','024','14','A','','','TE','0000296798','0000296798','','IL','1','Kennedy','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-09-11','F','',NULL,NULL,NULL,'','1495483','','2014-03-15','2014-02-28 19:55:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-01 21:00:24'),(2483,2022,'Y','18','021','EC','A','','','AC','0000924527','0000924527','LA00000638763','31','1','Lomas','Sharon','','','','34','435968053','P.O. Box 1132',0,'Gonzales','LA','70707',NULL,'CY','22093','1952-03-10','F','U',':RET:2054-5','N','021','DEN','1085288','18575LA002000201','2014-01-01','2013-12-09 14:38:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:34'),(20030,15974,'Y','18','021','EC','A','','','AC','0001993704','0001993704','LA00002079156','IL','1','Johnson','gabrielle','','','','34','437834162','4546 ALVIN DARK AVE',0,'BATON ROUGE','LA','70820','3708','CY','22033','1992-01-23','F','U',':RET:2054-5','N','021','DEN','3309887','18575LA002000201','2014-03-01','2014-01-26 15:08:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-26 19:00:19'),(14699,11736,'Y','18','021','EC','A','','','AC','0000205793','0000205793','OH00001781346','IL','1','Bidlencsik','Cynthia','','','','34','298525603','2614 WALBROOK AVE',0,'CLEVELAND','OH','44109','5547','CY','39035','1952-01-02','F','M',':RET:2106-3','N','021','DEN','2266199','99734OH005000401','2014-02-01','2013-12-28 00:37:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:09:00'),(5605,4448,'Y','18','021','EC','A','','','AC','0001213431','0001213431','OH00000444545','IL','1','Alicea','David','','','','34','581049759','3523 West 44Th St',0,'cleveland','OH','44109',NULL,'CY','39035','1955-10-19','M','U',NULL,'N','021','DEN','555572','99734OH005000401','2014-01-01','2013-11-25 20:36:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:23'),(9505,7538,'N','19','021','EC','A',NULL,NULL,'','0000112924','0000776425','','S1','1','Shimpo','Ryoge','','','','34','276134535','1730 KINGSLEY AVE',0,'AKRON','OH','44313','6109','CY','39153','2007-02-19','M','',':RET:2039-6^:RET:2106-3','N','021','DEN','1955187','99734OH005000401','2014-01-01','2013-12-21 15:27:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:15'),(23498,18718,'Y','18','021','EC','A','','','AC','0000814518','0000814518','TX00001518563','IL','1','HUANG','RONG','','','','34','634948124','6000 REIMS ROAD',0,'HOUSTON','TX','77036',NULL,'CY','48201','1955-09-29','M','M',':RET:2034-7','N','021','DEN','2754927','33348TX002000101','2014-03-01','2014-02-13 00:25:25','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-02-13 22:02:06'),(24013,19097,'Y','18','021','EC','A','','','AC','0000022839','0000022839','OH00002446870','IL','1','ACKON','KAMESHA','','','','34','300741991','4166 VINESHIRE DR',0,'COLUMBUS','OH','43227','3691','CY','39049','1979-10-19','F','U',':RET:2054-5','N','021','DEN','3664237','99734OH005000401','2014-03-01','2014-02-15 12:22:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:41'),(25136,19939,'Y','18','021','EC','A','','','AC','0000997964','0000997964','TX00001714782','IL','1','ORTIZ','JAIME','','','','34','606141185','1508 COGGIN AVE',0,'BROWNWOOD','TX','76801','4402','CY','48049','1962-08-09','M','U',':RET:2106-3','N','021','DEN','3055095','33348TX002000201','2014-04-01','2014-02-21 09:55:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:07'),(28469,22528,'Y','18','021','EC','A','','','AC','0000946174','0000946174','OH00003785865','IL','1','Xie','Zhengang','','','','34','081885622','7922 ALBRITTON PL',0,'WEST CHESTER','OH','45069','2057','CY','39017','1957-02-07','M','M',':RET:2034-7','N','021','DEN','3481385','99734OH005000301','2014-04-01','2014-03-07 00:45:05','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:31:31'),(19595,15621,'Y','18','021','EC','A','','','AC','0001037385','0001037385','OH00001784493','IL','1','SCHRAMM','JOHN','','','','34','298483657','618 DAY ST',0,'AKRON','OH','44305','1504','CY','39153','1950-03-07','M','U',':RET:2106-3','N','021','HLT','2108657','52664OH151001501','2014-03-01','2014-01-22 13:56:17','465.00',NULL,NULL,'789.56','324.56','R-OH012','OH0','789.56',NULL,0,'2014-01-23 03:02:46'),(2702,2187,'N','01','021','EC','A',NULL,NULL,'','0001038971','0000660207','','IL','1','Estes','James','','','','34','467088511','305 ROSE ST',0,'FREDERICKSBURG','TX','78624','3622','CY','48171','1954-10-02','M','',':RET:2106-3','N','021','DEN','416058','33348TX002000201','2014-01-01','2013-12-02 13:14:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:47:44'),(14121,11254,'Y','18','024','14','A','','','TE','0001203213','0001203213','','IL','1','Simpson','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-12-15','F','',NULL,NULL,NULL,'','1499818','','2013-12-26','2013-12-26 16:20:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:02:06'),(13713,10942,'Y','18','024','14','A','','','TE','0001186314','0001186314','','IL','1','Gelsinger','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-02-17','F','',NULL,NULL,NULL,'','1405368','','2013-12-23','2013-12-23 14:38:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:00'),(3168,2548,'N','19','021','EC','A',NULL,NULL,'','0000714933','0001006777','','IL','1','Truong','Tiffany','','','','34','275119346','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','2005-02-01','F','',':RET:2047-9','N','021','DEN','227690','99734OH005000401','2014-01-01','2013-11-18 13:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:31:29'),(18182,14517,'Y','18','021','EC','A','','','AC','0000864841','0000864841','OH00001915905','IL','1','Pliska','Kevin','','','','34','275603339','913 SUPERIOR ST',0,'GENOA','OH','43430','1532','CY','39123','1958-10-15','M','M',':RET:2106-3','N','021','HLT','2711115','92036OH003002705','2014-02-01','2014-01-14 10:44:12','701.00',NULL,NULL,'869.52','168.52','R-OH006','OH0','454.11',NULL,0,'2014-01-15 02:08:01'),(15852,12691,'Y','18','021','EC','A','','','AC','0000953261','0000953261','OH00001968512','IL','1','Bright','Harold','','','','34','292542931','1 E MAIN ST',0,'ASHLAND','OH','44805','2389','CY','39005','1953-11-28','M','M',':RET:2106-3','N','021','HLT','2282058','52664OH151001306','2014-02-01','2014-01-02 08:19:33','584.00',NULL,NULL,'605.24','21.24','R-OH012','OH0','605.24',NULL,0,'2014-01-03 02:04:26'),(17180,13747,'Y','18','021','EC','A','','','AC','0000253062','0000253062','OH00002412266','IL','1','Wallace','Amy','Elizabeth','','','34','284760288','1920 KNOLLRIDGE LN',0,'CINCINNATI','OH','45231','5239','CY','39061','1971-12-27','F','U',':RET:2106-3','T','021','DEN','2308725','99734OH005000301','2014-02-01','2014-01-08 11:10:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:22:12'),(17664,14116,'Y','18','021','EC','A','','','AC','0000761132','0000761132','OH00001537958','IL','1','L\'Heureux','Jennifer',NULL,NULL,NULL,NULL,NULL,'357 W WASHINGTON ST',0,'NELSONVILLE','OH','45764','1164','CY','39009','1969-03-04','F','M',':RET:2106-3','T','021','DEN','2492465','99734OH005000301','2014-02-01','2014-01-13 15:34:16','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-01-14 01:32:46'),(18036,14408,'Y','18','021','EC','A','','','AC','0000139035','0000139035','OH00001493605','IL','1','Robinson','ReBecca',NULL,NULL,NULL,NULL,NULL,'9049 FRANKFORT RD',0,'HOLLAND','OH','43528','8908','CY','39095','1981-12-28','F','R',':RET:1002-5^:RET:2054-5','N','021','DEN','1839958','99734OH005000301','2014-02-01','2014-01-14 18:30:37','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-15 02:07:10'),(26857,21287,'N','01','021','EC','A',NULL,NULL,'','0000177685','0000055985','','IL','1','Campton','Mindi','','','','34','301582182','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1971-04-03','F','',NULL,'N','021','HLT','3909716','92036OH003000601','2014-04-01','2014-03-01 11:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.05',NULL,0,'2014-03-01 21:00:54'),(27404,21694,'Y','18','021','EC','A','','','AC','0000195195','0000195195','OH00002544580','IL','1','Watkins','Tynetta','','','','34','295683607','20700 Wilmore Avenue',0,'Euclid','OH','44123',NULL,'CY','39035','1971-07-07','F','U',':RET:2054-5','N','021','DEN','3485352','99734OH005000301','2014-04-01','2014-03-04 10:34:23','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:32'),(27657,21875,'Y','18','021','EC','A','','','AC','0001042357','0001042357','OH00002896486','IL','1','NAPIER','BETTY','','','','34','285665117','2228 19TH ST SW',0,'AKRON','OH','44314','2329','CY','39153','1971-09-07','F','U',NULL,'N','021','DEN','3416170','99734OH005000401','2014-04-01','2014-03-05 14:13:59','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:24'),(28589,22624,'Y','18','021','EC','A','','','AC','0000807569','0000807569','OH00003216813','IL','1','GRANADOS','HOLLIE','','','','34','447861036','2708 SCIOTO TRL',0,'PORTSMOUTH','OH','45662','2500','CY','39145','1985-04-04','F','M',':RET:2106-3','N','021','DEN','3222887','99734OH005000401','2014-04-01','2014-03-07 21:18:31','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-03-08 21:30:01'),(4029,3217,'Y','18','021','EC','A','','','AC','0000843321','0000843321','OH00000829410','IL','1','Bates','Geneva','','','','34','407704489','335 GUINTHER CT',0,'GALION','OH','44833','2565','CY','39033','1952-10-15','F','M',':RET:2106-3','N','021','DEN','1621833','99734OH005000401','2014-01-01','2013-12-17 09:31:06','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 21:45:51'),(4603,3645,'Y','18','024','14','A','','','TE','0000783200','0000783200','','IL','1','Drake','Joan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-25','F','',NULL,NULL,NULL,'','30044','','2013-12-11','2013-12-11 21:23:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:05:46'),(21514,17189,'Y','18','024','14','A','','','TE','0000998771','0000998771','','IL','1','BROCKMAN','BETTY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-26','F','',NULL,NULL,NULL,'','1476101','','2014-02-28','2014-02-04 19:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-05 21:00:03'),(21141,16893,'Y','18','021','EC','A','','','AC','0000604411','0000604411','TX00001895718','IL','1','CRAIN','UTANAH','L','','','34','465024055','12124 TROTWOOD DR',0,'AUSTIN','TX','78753','6935','CY','48453','1954-03-27','F','M',':RET:2106-3','N','021','DEN','3471899','33348TX002000201','2014-03-01','2014-02-03 16:41:10','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-03 21:00:22'),(9667,7659,'Y','18','021','EC','A','','','AC','0000716330','0000716330','OH00000304219','IL','1','Fritz','Charles','','','','34','288568358','2450 OLD STATE RD',0,'MOUNT ORAB','OH','45154','9129','CY','39015','1954-10-23','M','U',':RET:2106-3','N','021','HLT','2409951','92036OH005000606','2014-01-01','2013-12-21 12:13:22','447.00',NULL,NULL,'558.80','111.80','R-OH005','OH0','558.80',NULL,0,'2013-12-26 04:39:08'),(8985,7127,'Y','18','021','EC','A','','','AC','0001046829','0001046829','OH00000405379','IL','1','PARISE','MARY','','','','34','298466887','412 DURST DR NW',0,'WARREN','OH','44483','1108','CY','39155','1949-04-24','F','M',':RET:2106-3','N','021','DEN','2583642','99734OH005000401','2014-01-01','2013-12-18 16:23:01','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:04:26'),(19965,15927,'Y','18','021','EC','A','','','AC','0000469568','0000469568','OH00002114252','IL','1','Givens','Nicholas','','','','34','229861188','320 BRENNAN RD',0,'CHILLICOTHE','OH','45601','2201','CY','39141','1955-01-23','M','M',':RET:2054-5','N','021','DEN','2890569','99734OH005000301','2014-03-01','2014-01-24 22:14:33','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-01-25 19:00:09'),(14876,11879,'Y','18','021','EC','A','','','AC','0001070223','0001070223','TX00000097368','IL','1','Owens','Rebecca','','','','34','451830094','18219 EASTSIDE RD',0,'TROUP','TX','75789','3601','CY','48423','1986-12-05','F','M',':RET:2106-3','N','021','DEN','2063568','33348TX002000201','2014-02-01','2013-12-29 12:36:48','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-30 00:00:21'),(14918,11919,'Y','18','024','14','A','','','TE','0000616874','0000616874','','IL','1','mccarthy','dan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-13','M','',NULL,NULL,NULL,'','2365774','','2013-12-29','2013-12-29 12:02:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-30 00:01:35'),(17953,14344,'Y','18','024','14','A','','','TE','0000861923','0000861923','','IL','1','Simmons','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-10-26','F','',NULL,NULL,NULL,'','2417079','','2014-01-14','2014-01-14 17:00:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:43'),(16126,12918,'Y','18','021','EC','A','','','AC','0000383372','0000383372','OH00002056921','IL','1','Jackson','Matthew','','','','34','298962090','10 CHATEAU PL',0,'MILFORD','OH','45150','1259','CY','39025','1989-05-15','M','M',':RET:2106-3','T','021','HLT','1849186','92036OH006000601','2014-02-01','2014-01-03 01:56:36','204.00',NULL,NULL,'499.67','295.67','R-OH005','OH0','195.78',NULL,0,'2014-01-04 02:05:34'),(28972,22930,'Y','18','021','EC','A','','','AC','0001847218','0001847218','LA00003751471','IL','1','Quiroz','Marc','','','','34','436432032','1 Caribbean Ct',0,'Mandeville','LA','70448',NULL,'CY','22103','1962-06-01','M','U',':RET:2036-2','N','021','DEN','3272166','18575LA002000201','2014-04-01','2014-03-10 17:14:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:01:03'),(24109,19165,'N','01','021','EC','A',NULL,NULL,'','0000926657','0000259206','','IL','1','holguin','raul','','','','34','449920134','4502 HAYNES AVE',0,'LAREDO','TX','78041','6637','CY','48479','1951-01-27','M','',':RET:2106-3','T','021','DEN','3005112','33348TX002000201','2014-03-01','2014-02-14 20:18:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-15 22:01:35'),(23604,18802,'N','01','021','EC','A',NULL,NULL,'','0000199711','0000109310','','IL','1','MOONEY','ROBERT','','','Sr','34','291629954','441 S DEWEY AVE',0,'LIMA','OH','45804','3015','CY','39003','1961-06-11','M','',':RET:2106-3','N','021','HLT','3636285','92036OH003001505','2014-03-01','2014-02-13 12:48:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.63',NULL,0,'2014-02-13 22:03:09'),(13660,10898,'Y','18','021','EC','A','','','AC','0001316592','0001316592','LA00001213671','IL','1','hanson','kevin','','','','34','426023527','9252 FOX RUN AVE',0,'BATON ROUGE','LA','70808','8107','CY','22033','1956-08-04','M','U',':RET:2106-3','T','021','DEN','2054149','18575LA002000101','2014-01-01','2013-12-23 08:49:36','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 13:07:35'),(1271,1049,'Y','18','024','14','A','','','TE','0000446858','0000446858','','IL','1','Godines','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-12-20','F','',NULL,NULL,NULL,'','448944','','2013-11-29','2013-11-29 17:16:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:30:16'),(20898,16703,'Y','18','021','EC','A','','','AC','0001067017','0001067017','OH00001763154','IL','1','Miller','Meghan','','','','34','589647428','945 WAGON WHEEL DR',0,'DAYTON','OH','45431','2742','CY','39113','1987-04-23','F','U',':RET:2106-3','N','021','DEN','2654964','99734OH005000401','2014-03-01','2014-01-31 12:57:10','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-31 21:01:19'),(20547,16420,'Y','18','021','EC','A','','','AC','0000827192','0000827192','OH00002120723','IL','1','Robinson','Teresa','','','','34','310705411','7005 MOORFIELD DR',0,'CINCINNATI','OH','45230','2258','CY','39061','1962-07-12','F','U',':RET:2106-3','N','021','HLT','2946094','92036OH005001204','2014-03-01','2014-01-29 10:18:24','125.00',NULL,NULL,'400.37','275.37','R-OH004','OH0','400.37',NULL,0,'2014-01-29 21:01:39'),(7569,5991,'N','19','021','EC','A',NULL,NULL,'','0000682137','0000351558','','IL','1','cramer','ruby','mae','','','34','384617513','10054 TOWNSHIP ROAD 10',0,'FINDLAY','OH','45840','9397','CY','39063','2011-10-04','F','',':RET:2106-3','N','021','HLT','333500','92036OH004001501','2014-01-01','2013-12-15 12:53:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2013-12-26 02:33:42'),(16868,13497,'Y','18','021','EC','A','','','AC','0000380515','0000380515','TX00001882156','IL','1','Jones','Andrew','','','','34','455906626','985 S JOHNSON ST',0,'SLATON','TX','79364','5808','CY','48303','1950-11-06','M','M',':RET:2054-5','N','021','DEN','2152484','33348TX002000201','2014-02-01','2014-01-09 12:35:21','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-01-13 02:19:14'),(25454,20195,'N','01','021','EC','A',NULL,NULL,'','0000169056','0000784079','','IL','1','WOOLBRIGHT','ROBERT','','','','34','453905479','311 W GRANT ST',0,'DIMMITT','TX','79027','3320','CY','48069','1952-04-01','M','',NULL,'N','021','DEN','3268239','33348TX002000201','2014-04-01','2014-02-25 14:00:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:27'),(26027,20642,'N','01','021','EC','A',NULL,NULL,'','0001083506','0000006462','','IL','1','Favela','Severiano','','','','34','318821149','123 CAROLYN AVE',0,'JACKSON','MS','39209','3610','CY','28049','1966-12-31','M','',NULL,'N','021','DEN','2713381','46300MS002000101','2014-04-01','2014-02-26 11:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-26 21:02:19'),(27391,21686,'N','19','021','EC','A',NULL,NULL,'','0001042351','0000636072','','IL','1','MacNeel','Margaret','','','','34','302061731','6424 ASHLEY OAKS CT',0,'WEST CHESTER','OH','45069','5107','CY','39017','2002-07-25','F','',':RET:2106-3','N','021','DEN','3740872','99734OH005000301','2014-04-01','2014-03-03 18:44:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:27'),(27867,22042,'N','01','021','EC','A',NULL,NULL,'','0000525638','0001156255','','IL','1','WILKINS','MICHEAL','A','','','34','268829300','399 SAIRVIEW AVE',0,'HAMILTON','OH','45015',NULL,'CY','39017','1967-11-18','M','',':RET:2106-3','T','021','HLT','3545586','92036OH004001201','2014-04-01','2014-03-05 12:09:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.75',NULL,0,'2014-03-05 21:32:22'),(22452,17926,'Y','18','021','EC','A','','','AC','0000702453','0000702453','TX00001530559','31','1','De la Rosa','Luara','','','','34','630604061','P.O. box 37',0,'canutillo','TX','79835',NULL,'CY','48141','1971-04-29','F','M',':RET:2106-3','T','021','DEN','3497031','33348TX002000201','2014-03-01','2014-02-10 14:49:53','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-10 21:30:47'),(177,146,'Y','18','021','EC','A','','','AC','0001090889','0001090889','OH00000867878','IL','1','Boyle','Kathleen','','','','34','278544737','590 INGALLS RD',0,'AKRON','OH','44312','2321','CY','39153','1952-02-24','F','U',':RET:2106-3','N','021','HLT','99421','52664OH151001305','2014-01-01','2013-12-05 09:58:06','341.02',NULL,NULL,'626.65','285.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 17:19:34'),(626,517,'Y','18','021','EC','A','','','AC','0000579959','0000579959','OH00001007983','IL','1','Freeman','Edward','','','','34','281465082','3134 WILLIAMSBURG ST NW',0,'WARREN','OH','44485','2255','CY','39155','1949-11-23','M','U',':RET:2054-5','N','021','DEN','1958848','99734OH005000401','2014-01-01','2013-12-16 12:34:49','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:00:58'),(19027,15153,'N','01','021','EC','A',NULL,NULL,'','0000251649','0000939812','','IL','1','Miller','Rhonda','','','','34','291780478','820 E Twp Road 130',0,'Tiffin','OH','44883',NULL,'CY','39147','1972-03-08','F','',':RET:2106-3','N','021','HLT','1704278','92036OH004002701','2014-03-01','2014-01-17 10:22:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.15',NULL,0,'2014-01-20 08:06:29'),(18745,14937,'Y','18','021','EC','A','','','AC','0000271450','0000271450','OH00001413383','IL','1','Sleeper','Christine','','','','34','301541899','321 E.N. Broadway',0,'Columbus','OH','43214',NULL,'CY','39049','1953-10-08','F','U',':RET:2106-3','N','021','DEN','1773187','99734OH005000301','2014-02-01','2014-01-15 20:06:36','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-17 03:35:41'),(4129,3297,'Y','18','021','EC','A','','','AC','0000461915','0000461915','OH00001254275','IL','1','AMMON','MARJORIE','ANN','','','34','177522204','51781 DARLINGTON',0,'MIDDLETON TOWNSHIP','OH','44441',NULL,'CY','39029','1958-12-05','F','U',':RET:2106-3','N','021','DEN','1893714','99734OH005000301','2014-01-01','2013-12-17 08:13:01','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:48:21'),(6161,4885,'Y','18','021','EC','A','','','AC','0000443419','0000443419','OH00001038534','IL','1','Sizelove','Melinda','','','','34','278749980','9 SHERYL CT',0,'HAMILTON','OH','45013','5144','CY','39017','1962-12-29','F','U',':RET:2106-3','N','021','HLT','971944','92036OH003001205','2014-01-01','2013-11-21 15:38:41','200.00',NULL,NULL,'418.11','218.11','R-OH004','OH0','418.11',NULL,0,'2013-12-26 00:16:47'),(14721,11754,'Y','18','024','14','A','','','TE','0002043874','0002043874','','IL','1','PARSON','SHENNA','ANTOINETTE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-05','F','',NULL,NULL,NULL,'','2458488','','2013-12-28','2013-12-28 14:08:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2013-12-29 11:09:35'),(17408,13932,'Y','18','021','EC','A','','','AC','0000397186','0000397186','TX00001629298','IL','1','Stout','Lisa','','','','34','450799900','3019 Reforma Drive',0,'San Antonio','TX','78211',NULL,'CY','48029','1982-05-04','F','U',':RET:2106-3','N','021','DEN','1959843','33348TX002000101','2014-02-01','2014-01-10 12:50:29','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-13 03:00:20'),(18202,14528,'N','19','021','EC','A',NULL,NULL,'','0000964638','0000850518','','S1','1','shaferly','michael','david','','','34','279083491','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','2003-04-04','M','',':RET:2106-3','N','021','HLT','2743747','92036OH002001501','2014-02-01','2014-01-14 12:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2014-01-15 02:08:06'),(27671,21887,'Y','18','021','EC','A','','','AC','0000731836','0000731836','TX00003248757','IL','1','Martinez','Blanca','','','','34','519586203','213 ESPERANZA DR',0,'LAREDO','TX','78041','2609','CY','48479','1952-10-18','F','M',NULL,'N','021','DEN','3409834','33348TX002000201','2014-04-01','2014-03-04 18:48:26','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-03-05 21:30:33'),(29202,23110,'Y','18','021','EC','A','','','AC','0000890776','0000890776','MS00003414387','IL','1','LOWMAN','TREASEA','','','','34','410474373','385 NAIL RD',0,'SOUTHAVEN','MS','38671','8858','CY','28033','1967-10-01','F','M',':RET:2106-3','N','021','DEN','3739983','46300MS002000201','2014-04-01','2014-03-10 15:50:54','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85','CIC',0,'2014-03-10 21:30:10'),(2159,1776,'Y','18','021','EC','A','','','AC','0000853976','0000853976','LA00000623232','31','1','Holland','Cheron','','','','34','352582071','P.O. Box 7363',0,'Alexandria','LA','71306',NULL,'CY','22079','1969-08-28','F','U',':RET:2054-5','T','021','DEN','518487','18575LA002000101','2014-01-01','2013-12-10 17:49:47','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-25 19:18:49'),(24701,19610,'Y','18','021','EC','A','','','AC','0000172464','0000172464','OH00003048651','S1','1','tucker','christopher','','','','34','295117035','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2006-02-14','M','U',':RET:2106-3','N','021','DEN','3785204','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:34:08'),(23559,18768,'N','19','021','EC','A',NULL,NULL,'','0001236630','0000418926','','IL','1','OVIAHON','ARIANA','','','','34','299988779','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1996-07-12','F','',':RET:2054-5','N','021','HLT','3515021','92036OH005002604','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-02-13 22:02:43'),(22802,18200,'N','19','021','EC','A',NULL,NULL,'','0000356070','0000260513','','IL','1','Brook','Natna','','','','34','691129668','725 DIANDREA DR',0,'FAIRLAWN','OH','44333','2906','CY','39153','1998-06-22','M','',':RET:2054-5','N','021','DEN','3675876','99734OH005000301','2014-03-01','2014-02-11 13:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:53'),(17643,14103,'Y','18','021','EC','A','','','AC','0000333880','0000333880','OH00002488339','IL','1','sands','ellen','','','','34','273448558','1858 INDIAN HILLS TRL',0,'AKRON','OH','44313','4790','CY','39153','1953-03-27','F','U',':RET:2106-3','N','021','DEN','1719376','99734OH005000301','2014-02-01','2014-01-13 09:49:30','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-14 01:32:37'),(2511,2046,'Y','18','021','EC','A','','','AC','0000727259','0000727259','OH00001279982','IL','1','RAFHEED','KHADIJAH','','','','34','290547953','15 BENNETT LN',0,'NORWALK','OH','44857','2648','CY','39077','1956-05-23','F','U',':RET:2054-5','N','021','HLT','861673','92036OH002002701','2014-01-01','2013-12-09 08:31:15','0.00',NULL,NULL,'548.79','548.79','R-OH006','OH0','548.79',NULL,0,'2013-12-25 19:36:18'),(17197,13761,'Y','18','021','EC','A','','','AC','0002076069','0002076069','LA00002516925','IL','1','SPENCE','KIM','','','','34','439294300','1306 COTTAGE DR',0,'HOUMA','LA','70360','3951','CY','22109','1961-05-08','F','U',NULL,'N','021','DEN','1397088','18575LA002000101','2014-02-01','2014-01-08 15:01:56','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-13 02:22:22'),(6861,5440,'Y','18','021','EC','A','','','AC','0000092463','0000092463','OH00000426064','IL','1','Bracken','Jennifer','','','','34','193620839','76 LAKEVIEW RD',0,'NILES','OH','44446','2102','CY','39155','1981-09-09','F','U',NULL,'N','021','DEN','1096496','99734OH005000401','2014-01-01','2013-10-05 17:26:16','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 01:31:41'),(3866,3095,'N','01','021','EC','A',NULL,NULL,'','0000439570','0001017552','','IL','1','Annan','Delphine','Jones','','','34','436961696','38135 SPRINGWOOD AVE',0,'PRAIRIEVILLE','LA','70769','4286','CY','22005','1954-09-05','F','',':RET:2054-5','N','021','DEN','703447','18575LA002000201','2014-01-01','2013-12-12 23:34:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 21:36:05'),(6403,5075,'Y','18','021','EC','A','','','AC','0000030519','0000030519','OH00000354444','IL','1','Donahue','Angela','','','','34','301862394','1143 Bonniebrook Dr',0,'Miamisburg','OH','45342',NULL,'CY','39113','1980-04-25','F','U',':RET:2106-3','N','021','DEN','159056','99734OH005000301','2014-01-01','2013-12-11 15:57:03','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:48:24'),(2888,2333,'Y','18','021','EC','A','','','AC','0000937244','0000937244','OH00000035810','IL','1','baughman','betty',NULL,NULL,NULL,NULL,NULL,'4014 ELEANOR ST',0,'MOGADORE','OH','44260','1509','CY','39133','1954-10-26','F','M',':RET:2106-3','N','021','HLT','678122','52664OH151001501','2014-01-01','2013-12-06 11:40:29','446.00',NULL,NULL,'696.21','250.21','R-OH012','OH0','696.21',NULL,0,'2013-12-25 20:15:06'),(25940,20570,'N','01','021','EC','A',NULL,NULL,'','0000470805','0000627509','','IL','1','Ayers','Zelda',NULL,NULL,NULL,NULL,NULL,'4011 City St.',0,'Caldwell','TX','77836',NULL,'CY','48051','1958-04-06','F','',':RET:2054-5','N','021','DEN','2659110','33348TX002000201','2014-04-01','2014-02-26 17:23:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:30'),(805,665,'N','01','021','EC','A',NULL,NULL,'','0000118031','0000423691','','IL','1','Murphy','Lynn','M','','','34','458929189','4213 MEADOWBROOK DR',0,'BRYAN','TX','77802','3516','CY','48041','1949-07-07','F','',':RET:2106-3','N','021','DEN','1872260','33348TX002000201','2014-01-01','2013-12-16 18:20:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:05:40'),(14635,11680,'Y','18','021','EC','A','','','AC','0000825919','0000825919','OH00001463130','IL','1','Morris','Eli','','','','34','270669880','1574 E High Street',0,'Lima','OH','45804',NULL,'CY','39003','1960-11-06','M','M',':RET:2106-3','T','021','HLT','2586548','92036OH004001501','2014-02-01','2013-12-27 15:24:58','836.00',NULL,NULL,'911.12','75.12','R-OH002','OH0','415.16',NULL,0,'2013-12-28 03:37:16'),(1112,915,'Y','18','021','EC','A','','','AC','0000349233','0000349233','OH00000283401','IL','1','FITZPATRICK','MARY ANN','','','','34','287509100','3710 WENZLER DR',0,'DAYTON','OH','45429','3366','CY','39113','1952-06-17','F','U',':RET:2106-3','N','021','DEN','19680','99734OH005000401','2014-01-01','2013-12-03 12:10:37','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:17:32'),(25342,20107,'Y','18','021','EC','A','','','AC','0000402506','0000402506','OH00002538329','IL','1','MEZA VILLANUEVA','ARMANDO','','','','34','283131387','214 E TIFFIN ST',0,'WILLARD','OH','44890','1521','CY','39077','1987-09-16','M','U',NULL,'N','021','HLT','2817006','92036OH005002706','2014-04-01','2014-02-24 18:03:39','177.00',NULL,NULL,'199.67','22.67','R-OH006','OH0','199.67',NULL,0,'2014-02-25 21:30:26'),(23132,18438,'Y','18','024','14','A','','','TE','0001155137','0001155137','','IL','1','Nelson','Alyse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-21','F','',NULL,NULL,NULL,'','2895885','','2014-02-12','2014-02-12 16:37:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:30'),(14281,11393,'Y','18','021','EC','A','','','AC','0000895744','0000895744','MS00000953123','IL','1','Claveau','Lou','','','','34','427355344','17 Chiniche Lane',0,'Long beach','MS','39560',NULL,'CY','28047','1964-11-17','F','M',':RET:2106-3','N','021','DEN','1538545','46300MS002000201','2014-02-01','2013-12-26 17:08:05','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2013-12-27 02:06:20'),(3504,2815,'Y','18','021','EC','A','','','AC','0000446286','0000446286','OH00000632156','IL','1','THOMPSON','THOMAS','','','','34','279928682','13545 HAMILTON ST NE',0,'MILLERSPORT','OH','43046','9777','CY','39045','1990-04-10','M','U',':RET:2106-3','T','021','DEN','2156288','99734OH005000401','2014-01-01','2013-12-22 17:22:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:20:48'),(25948,20578,'Y','18','021','EC','A','','','AC','0000272550','0000272550','OH00002807779','IL','1','hesser','cyle','','','','34','289967484','7950 mentor ave',0,'mentor','OH','44060',NULL,'CY','39085','1993-11-13','M','U',':RET:2106-3','N','021','DEN','3826904','99734OH005000401','2014-04-01','2014-02-26 10:04:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2014-02-26 21:01:35'),(22772,18180,'N','01','021','EC','A',NULL,NULL,'','0000376180','0001011600','','IL','1','Simonson','Dale','R','','','34','281846919','245 SCOTT DR',0,'ENGLEWOOD','OH','45322','1145','CY','39113','1970-05-24','M','',':RET:2106-3','N','021','DEN','2863326','99734OH005000401','2014-03-01','2014-02-11 12:25:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:38'),(21243,16974,'Y','18','021','EC','A','','','AC','0000274826','0000274826','OH00002091709','IL','1','MANDLEY','DEANNA','','','','34','278487493','3249 CARRIAGE WAY',0,'STOW','OH','44224','4753','CY','39153','1965-07-17','F','U',NULL,'N','021','DEN','3322751','99734OH005000301','2014-03-01','2014-02-03 14:37:39','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-03 21:01:14'),(3770,3018,'Y','18','024','14','A','','','TE','0001062091','0001062091','','IL','1','Starcher','Benjamin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-12-06','M','',NULL,NULL,NULL,'','1148923','','2013-12-13','2013-12-13 15:04:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:33:41'),(20730,16563,'N','01','021','EC','A',NULL,NULL,'','0000676747','0000479847','','IL','1','Prince','Rhonda','','','','34','300706628','344 Silver St',0,'Akron','OH','44303',NULL,'CY','39153','1965-06-16','F','',':RET:2054-5','N','021','HLT','3287722','52664OH152000901','2014-03-01','2014-01-29 20:23:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.06',NULL,0,'2014-01-30 21:01:18'),(8051,6374,'Y','18','021','EC','A','','','AC','0000976709','0000976709','OH00000712557','IL','1','Hosler','Jerry','','','','34','274524941','6831 WOODMEADOW DR',0,'TOLEDO','OH','43617','1142','CY','39095','1961-12-15','M','U',':RET:2106-3','N','021','HLT','1653553','92036OH004002601','2014-01-01','2013-12-20 14:17:49','0.00',NULL,NULL,'306.05','306.05','R-OH001','OH0','306.05',NULL,0,'2013-12-26 03:09:42'),(8022,6351,'Y','18','021','EC','A','','','AC','0000368540','0000368540','OH00000793206','IL','1','Wells','Cecil','','','','34','460789661','3607 LANSDOWNE AVE',0,'CINCINNATI','OH','45236','3007','CY','39061','1951-05-12','M','M',':RET:2106-3','N','021','HLT','1696870','92036OH006001201','2014-01-01','2013-12-19 21:11:16','0.00',NULL,NULL,'922.90','922.90','R-OH004','OH0','489.12',NULL,0,'2013-12-26 03:08:56'),(23790,18932,'Y','18','021','EC','A','','','AC','0000062578','0000062578','OH00001861784','IL','1','Cunningham','Janet','','','','34','299888147','212 East N. St.',0,'Medina','OH','44256',NULL,'CY','39103','1977-03-15','F','U',':RET:2106-3','N','021','HLT','3199083','52664OH151001305','2014-03-01','2014-02-14 10:59:59','208.00',NULL,NULL,'415.91','207.91','R-OH012','OH0','274.30',NULL,0,'2014-02-14 21:31:24'),(17688,14135,'Y','18','021','EC','A','','','AC','0001594344','0001594344','LA00001582829','IL','1','MILLER','FRANCES','RENEE','','','34','434232871','729 OLD HWY 1',0,'LENA','LA','71447',NULL,'CY','22079','1963-02-14','F','M',':RET:2054-5','N','021','DEN','2501430','18575LA002000201','2014-02-01','2014-01-13 11:16:42','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-14 01:32:58'),(5899,4674,'N','19','021','EC','A',NULL,NULL,'','0001071787','0000055920','','S1','1','Clark','DeShon','','','','34','283136214','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','2007-07-15','M','',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:45'),(15029,12012,'Y','18','021','EC','A','','','AC','0002144337','0002144337','LA00001793325','IL','1','Earl','Thomas','','','','34','436139251','174 WOOD LN',0,'RAYNE','LA','70578','8474','CY','22001','1955-09-11','M','U',NULL,'N','021','DEN','1990077','18575LA002000201','2014-02-01','2013-12-30 07:32:04','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-01 12:02:34'),(15064,12042,'Y','18','021','EC','A','','','AC','0001566444','0001566444','LA00002004455','IL','1','Walker','Cynthia','R','','','34','435214087','1370 SAINT FRANCIS LN',0,'SAINT GABRIEL','LA','70776','4916','CY','22047','1963-08-07','F','M',':RET:2054-5','N','021','DEN','2163295','18575LA002000201','2014-02-01','2013-12-30 16:11:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:41'),(179,148,'Y','18','021','EC','A','','','AC','0000170129','0000170129','OH00001196404','IL','1','KEARNEY','SILVIA','E','','','34','296962551','1470 GRAND PARK AVE',0,'AKRON','OH','44310','2623','CY','39153','1960-02-21','F','U',NULL,'N','021','HLT','329190','52664OH151001306','2014-01-01','2013-12-05 10:42:19','384.00',NULL,NULL,'454.94','70.94','R-OH012','OH0','454.94',NULL,0,'2013-12-25 17:19:37'),(8144,6441,'N','01','021','EC','A',NULL,NULL,'','0000176358','0000409709','','IL','1','Leis','Lori','','','','34','292682704','66 CRESTWOOD DR',0,'WILLARD','OH','44890','1607','CY','39077','1971-11-22','F','',':RET:2106-3','N','021','HLT','1222029','92036OH004002701','2014-01-01','2013-11-21 21:10:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','207.75',NULL,0,'2013-12-26 03:15:49'),(8073,6394,'Y','18','021','EC','A','','','AC','0000809668','0000809668','OH00000927549','IL','1','STUDER','RONALD','JOSEPH','','','34','273465327','537 TOUVELLE ST',0,'CELINA','OH','45822','1072','CY','39107','1949-08-27','M','M',':RET:2106-3','T','021','HLT','2102273','92036OH004001501','2014-01-01','2013-12-20 15:06:35','1000.40',NULL,NULL,'1007.77','7.37','R-OH002','OH0','610.52',NULL,0,'2013-12-26 03:10:17'),(252,209,'Y','18','021','EC','A','','','AC','0000231442','0000231442','LA00000879008','IL','1','Howard','Lynn','','','','34','433787917','403 Head street',0,'Monroe','LA','71203',NULL,'CY','22073','1950-04-06','F','U',':RET:2106-3','N','021','DEN','223862','18575LA002000101','2014-01-01','2013-12-05 11:50:39','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 17:21:35'),(13791,11008,'Y','18','021','EC','A','','','AC','0000665447','0000665447','MS00000858364','IL','1','Tyler','Adam','','','','34','412559737','137 PLANTERS ROW',0,'MADISON','MS','39110','7990','CY','28089','1980-01-18','M','M',':RET:2106-3','N','021','DEN','2246749','46300MS002000101','2014-01-01','2013-12-22 23:26:47','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:05'),(6503,5153,'Y','18','021','EC','A','','','AC','0000120057','0000120057','OH00000737814','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,'23872 Glenhill',0,'Cleveland','OH','44122',NULL,'CY','39035','1950-01-06','F','U',':RET:2106-3','N','021','HLT','1103784','52664OH151001306','2014-01-01','2013-12-11 17:02:54','549.00',NULL,NULL,'742.48','193.48','R-OH011','OH0','742.48',NULL,0,'2013-12-26 00:50:54'),(25105,19913,'Y','18','024','14','A','','','TE','0000276627','0000276627','','IL','1','rayos','rosa','r',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-28','F','',NULL,NULL,NULL,'','3403538','','2014-03-31','2014-02-21 14:00:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-21 21:30:12'),(272,224,'Y','18','021','EC','A','','','AC','0000070279','0000070279','OH00000167486','IL','1','Aun','Chung','','','','34','299789341','5667 SAVERIO CT',0,'COLUMBUS','OH','43235','2517','CY','39049','1957-06-23','M','U',NULL,'N','021','DEN','1128883','99734OH005000401','2014-01-01','2013-10-11 19:48:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:30:03'),(5132,4067,'Y','18','021','EC','A','','','AC','0001010229','0001010229','TX00000594212','IL','1','vattana','padasamai','','','','34','607489081','1468 santa anita blvd',0,'irving','TX','75060',NULL,'CY','48113','1990-04-02','F','U',':RET:2028-9','N','021','DEN','1418565','33348TX002000101','2014-01-01','2013-12-19 16:33:36','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:02:15'),(24930,19769,'N','19','021','EC','A',NULL,NULL,'','0000836638','0000159462','','IL','1','ANGERSTIEN','BLAKE','','','','34','284082011','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','2003-07-09','M','',':RET:2106-3','N','021','HLT','3279747','52664OH151001501','2014-03-01','2014-02-20 16:08:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84','CIC',0,'2014-02-20 21:30:19'),(24780,19653,'N','01','021','EC','A',NULL,NULL,'','0001165319','0000930893','','IL','1','ANAYA','GEORGE','ANTONIO','','','34','279963007','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-21','M','',NULL,'T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:45:02'),(2558,2080,'N','01','021','EC','A',NULL,NULL,'','0001124564','0000504361','','IL','1','Childers','Debra','K','','','34','415175951','155 COUNTY ROAD 157',0,'CORINTH','MS','38834','1314','CY','28003','1959-08-27','F','',':RET:2106-3','N','021','DEN','465205','46300MS002000201','2014-01-01','2013-12-09 14:15:03',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 19:37:26'),(14863,11868,'Y','18','021','EC','A','','','AC','0000614110','0000614110','OH00000094371','IL','1','Wright','Dixie','','','','34','295625383','8432 WOODREED DR',0,'WEST CHESTER','OH','45069','5897','CY','39017','1958-04-11','F','M',NULL,'N','021','HLT','1585678','92036OH001001201','2014-01-01','2013-12-23 20:28:18','209.00',NULL,NULL,'577.44','368.44','R-OH004','OH0','577.44',NULL,1,'2013-12-29 11:15:26'),(16133,12923,'Y','18','021','EC','A','','','AC','0000921927','0000921927','OH00001380309','IL','1','MILLIK','JOHN','','','','34','288489717','2090 HOWLAND WILSON RD',0,'CORTLAND','OH','44410','9485','CY','39155','1950-09-14','M','M',':RET:2106-3','N','021','HLT','1792640','52664OH151001306','2014-02-01','2014-01-03 13:07:38','1497.00',NULL,NULL,'1747.01','250.01','R-OH013','OH0','746.55',NULL,0,'2014-01-04 02:05:46'),(18102,14460,'Y','18','021','EC','A','','','AC','0001770496','0001770496','LA00001964022','IL','1','smith','rosiland','','','','34','437456423','320 PRAIRIE RD',0,'COLUMBIA','LA','71418','3442','CY','22021','1971-09-19','F','R',':RET:2106-3','N','021','DEN','1889268','18575LA002000201','2014-02-01','2014-01-14 16:42:14','0.00',NULL,NULL,'43.83','43.83','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:34'),(21471,17158,'Y','18','021','EC','A','','','AC','0000767438','0000767438','OH00002268939','IL','1','BOCK','WILLIAM','','','','34','292884574','1120 WILHELM ST',0,'DEFIANCE','OH','43512','2953','CY','39039','1988-04-13','M','U',':RET:2106-3','T','021','HLT','3111382','92036OH002002601','2014-03-01','2014-02-04 08:32:24','0.00',NULL,NULL,'260.01','260.01','R-OH001','OH0','260.01',NULL,0,'2014-02-04 21:01:38'),(19687,15688,'N','01','021','EC','A',NULL,NULL,'','0000219765','0001030392','','IL','1','Newsome','Winfred','','','','34','425171720','316 Parakeet Dr',0,'Desoto','TX','75115',NULL,'CY','48113','1956-09-05','F','',NULL,'N','021','DEN','2930896','33348TX002000201','2014-03-01','2014-01-23 13:40:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:40'),(26410,20945,'Y','18','021','EC','A','','','AC','0001259669','0001259669','TX00003385837','IL','1','Getz','Michelle','','','','34','466983720','3110 LAWRENCE ST',0,'HOUSTON','TX','77018','8330','CY','48201','1960-08-19','F','U',':RET:2106-3','N','021','DEN','3839786','33348TX002000201','2014-04-01','2014-02-26 14:39:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-28 07:00:38'),(27375,21676,'N','19','021','EC','A',NULL,NULL,'','0000302878','0000533815','','IL','1','ngo','nghia','phuc','','','34','428771916','7412 OLD FORT BAYOU RD',0,'OCEAN SPRINGS','MS','39564','8195','CY','28059','1994-07-21','M','',':RET:2047-9','N','021','DEN','3947696','46300MS002000101','2014-04-01','2014-03-04 13:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-03-04 21:01:18'),(76,68,'Y','18','021','EC','A','','','AC','0000049461','0000049461','OH00000649894','IL','1','Lauer','Marie','','','','34','288521902','564 COMMON WEALTH DR',0,'CINCINNATI','OH','45244','1031','CY','39025','1954-01-06','F','M',NULL,'N','021','DEN','241225','99734OH005000301','2014-01-01','2013-12-05 17:35:37','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-25 17:17:04'),(18075,14435,'N','19','021','EC','A',NULL,NULL,'','0001215431','0001504464','','IL','1','HALE','MARCUS','','','','34','437770422','142 BIRCHWOOD DR',0,'MONROE','LA','71203','2204','CY','22073','1989-12-05','M','',':RET:2054-5','N','021','DEN','2208973','18575LA002000201','2014-02-01','2014-01-14 09:13:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:25'),(16641,13314,'Y','18','021','EC','A','','','AC','0000314708','0000314708','OH00001937526','IL','1','stauter','elizabeth','','','','34','302886617','406 kater ave.',0,'harrison','OH','45030',NULL,'CY','39061','1987-07-22','F','U',':RET:2106-3','N','021','DEN','2124139','99734OH005000401','2014-02-01','2014-01-07 11:55:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-08 18:24:17'),(499,408,'Y','18','021','EC','A','','','AC','0000209596','0000209596','OH00000211165','IL','1','schleppi','michelle','','','','34','285862300','509 FAIRFORD CT',0,'WESTERVILLE','OH','43081','5045','CY','39049','1975-05-13','F','R',':RET:2106-3','N','021','DEN','1006170','99734OH005000301','2014-01-01','2013-12-04 00:58:51','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:48:38'),(15402,12320,'Y','18','021','EC','A','','','AC','0000849455','0000849455','TX00001465458','IL','1','BROWN','SHEILAHE','','','','34','465472164','330 LAS COLINAS BLVD E',0,'IRVING','TX','75039','5510','CY','48113','1963-08-02','F','U',NULL,'N','021','DEN','2229820','33348TX002000201','2014-02-01','2013-12-30 20:03:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:26:49'),(14950,11948,'Y','18','021','EC','A','','','AC','0000689569','0000689569','TX00001152461','IL','1','Little','Erik','','','','34','425111819','3110 Brook Glen Dr.',0,'Garland','TX','75044',NULL,'CY','48113','1972-05-09','M','U',':RET:2106-3','N','021','DEN','1795929','33348TX002000201','2014-02-01','2013-12-29 21:18:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:09'),(667,550,'Y','18','024','14','A','','','TE','0000433862','0000433862','','IL','1','Berry','Laura','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-09-14','F','',NULL,NULL,NULL,'','636690','','2013-12-16','2013-12-16 08:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:02'),(1137,935,'Y','18','021','EC','A','','','AC','0000603431','0000603431','LA00001271363','IL','1','CANDLER','PATSY','','','','34','439047762','1113 LARSON STREET',0,'RUSTON','LA','71270',NULL,'CY','22061','1957-06-18','F','M',':RET:2054-5','N','021','DEN','795880','18575LA002000201','2014-01-01','2013-12-03 05:09:11','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 18:18:13'),(2514,2049,'Y','18','021','EC','A','','','AC','0000953458','0000953458','MS00000430195','IL','1','Walker','Bonnie','','','','34','426758550','371 Coolidge Ave',0,'Biloxi','MS','39531',NULL,'CY','28047','1993-03-12','F','M',':RET:2106-3','T','021','DEN','939859','46300MS002000101','2014-01-01','2013-12-09 12:47:17','0.00',NULL,NULL,'47.10','47.10','R-MS005','MS0','47.10',NULL,0,'2013-12-25 19:36:23'),(22218,17735,'Y','18','021','EC','A','','','AC','0001948824','0001948824','LA00002571246','IL','1','Zametkin','Emily','','','','34','218080913','419 S ALEXANDER ST',0,'NEW ORLEANS','LA','70119','6706','CY','22071','1985-07-02','F','U',':RET:2106-3','N','021','DEN','3038085','18575LA002000201','2014-03-01','2014-02-09 16:33:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:25'),(22937,18286,'Y','18','024','14','A','','','TE','0001981888','0001981888','','IL','1','johnson','george',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-05-16','M','',NULL,NULL,NULL,'','2713881','','2014-02-28','2014-02-10 21:34:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-11 21:30:16'),(23534,18747,'Y','18','021','EC','A','','','AC','0001604414','0001604414','LA00001632082','IL','1','COBBS','BRITTANY','','','','34','638143000','608 HOLT ST',0,'TALLULAH','LA','71282','3422','CY','22065','1989-12-03','F','U',NULL,'N','021','DEN','3507163','18575LA002000201','2014-03-01','2014-02-13 12:07:39','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-13 22:02:28'),(24207,19225,'Y','18','021','EC','A','','','AC','0002098192','0002098192','LA00002596485','IL','1','Keller','Adam','','','','34','033700084','216 WALL BLVD',0,'GRETNA','LA','70056','7352','CY','22051','1988-01-01','M','U',':RET:2106-3','N','021','DEN','3717462','18575LA002000201','2014-03-01','2014-02-15 22:33:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-16 19:00:21'),(4949,3928,'Y','18','021','EC','A','','','AC','0000802547','0000802547','OH00001007690','31','1','JORDAN','ELIZABETH','','','','34','271544928','PO BOX 422',0,'GREEN','OH','44232',NULL,'CY','39153','1951-09-10','F','M',':RET:2106-3','N','021','HLT','1198237','52664OH152000901','2014-01-01','2013-12-06 18:21:25','200.01',NULL,NULL,'469.28','269.28','R-OH012','OH0','469.28',NULL,0,'2013-12-25 22:45:54'),(3778,3026,'Y','18','021','EC','A','','','AC','0000603345','0000603345','OH00000608934','IL','1','Knight','Amber','','','','34','297743547','352 RIPLEY AVE',0,'AKRON','OH','44312','2766','CY','39153','1979-07-26','F','U',':RET:2054-5','N','021','DEN','253389','99734OH005000301','2014-01-01','2013-12-12 19:24:36','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:33:54'),(27162,21507,'Y','18','024','14','A','','','TE','0000819360','0000819360','','IL','1','Nguyen','Long',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-31','M','',NULL,NULL,NULL,'','3871506','','2014-03-03','2014-03-03 10:28:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-03 21:31:00'),(28159,22283,'Y','18','021','EC','A','','','AC','0000298302','0000298302','OH00002827111','IL','1','JOHNSON','PAULA','','','','34','338481671','1227 LATHAM AVE',0,'LIMA','OH','45805','1927','CY','39003','1957-09-05','F','U',NULL,'N','021','HLT','3438797','92036OH005001505','2014-04-01','2014-03-06 11:39:01','450.00',NULL,NULL,'513.45','63.45','R-OH002','OH0','513.45',NULL,0,'2014-03-06 21:02:41'),(21809,17417,'Y','18','021','EC','A','','','AC','0000277306','0000277306','OH00001697103','IL','1','Leask','John','','','','34','284521928','538 S.R. 14',0,'Deerfield','OH','44411',NULL,'CY','39133','1952-02-29','M','M',':RET:2106-3','N','021','HLT','3172649','52664OH151001305','2014-03-01','2014-02-06 08:37:15','940.00',NULL,NULL,'1194.87','254.87','R-OH012','OH0','626.65',NULL,0,'2014-02-06 21:00:54'),(21591,17246,'Y','18','024','14','A','','','TE','0000930898','0000930898','','IL','1','NAKKA','COTTON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-04-24','M','',NULL,NULL,NULL,'','1675008','','2014-02-20','2014-02-05 10:33:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-05 21:30:29'),(13917,11100,'Y','18','021','EC','A','','','AC','0000273783','0000273783','OH00000996606','IL','1','Masters','Kathleen','','','','34','274568745','718 BARTLEY PL',0,'TOLEDO','OH','43609','3107','CY','39095','1954-08-04','F','M',':RET:2106-3','N','021','HLT','2150784','92036OH003002605','2014-01-01','2013-12-22 21:59:45','877.00',NULL,NULL,'1140.96','263.96','R-OH001','OH0','530.07',NULL,0,'2013-12-26 13:14:07'),(3204,2578,'Y','18','021','EC','A','','','AC','0000618316','0000618316','OH00001015558','IL','1','Hollins','Whitney','','','','34','286949696','15812 CLEVIDEN RD',0,'EAST CLEVELAND','OH','44112','4005','CY','39035','1986-03-04','F','U',':RET:2054-5','N','021','DEN','799096','99734OH005000301','2014-01-01','2013-11-01 12:35:25','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:45:16'),(21294,17015,'Y','18','021','EC','A','','','AC','0001377706','0001377706','LA00002593378','IL','1','Dugger','Barbara','','','','34','448545772','717 PATRICIA DR',0,'DENHAM SPRINGS','LA','70726','2636','CY','22063','1951-07-25','F','M',NULL,'N','021','DEN','3796851','18575LA002000101','2014-03-01','2014-02-04 14:10:55','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-04 21:00:08'),(21116,16872,'Y','18','021','EC','A','','','AC','0000248211','0000248211','TX00002347010','IL','1','Lloyd','Ronnie','','','','34','466198326','2722 Scotland Dr',0,'Dallas','TX','75216',NULL,'CY','48113','1962-06-04','M','U',':RET:2054-5','N','021','DEN','3063062','33348TX002000201','2014-03-01','2014-02-03 01:48:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-03 21:00:10'),(3536,2838,'N','01','021','EC','A',NULL,NULL,'','0000102261','0000705858','','IL','1','Rivera','Monica','','','','34','449856662','1320 SUPERIOR DR',0,'FLOWER MOUND','TX','75028','2115','CY','48121','1973-02-27','F','',':RET:2054-5','N','021','DEN','1514381','33348TX002000101','2014-01-01','2013-12-22 09:34:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 21:21:37'),(20479,16360,'Y','18','021','EC','A','','','AC','0000045804','0000045804','OH00001571996','IL','1','adams','justin','','','','34','300842689','1283 w9th st',0,'cleveland','OH','44113',NULL,'CY','39035','1981-09-06','M','U',':RET:2106-3','N','021','DEN','2684225','99734OH005000401','2014-03-01','2014-01-29 17:38:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:01:00'),(3607,2890,'Y','18','021','EC','A','','','AC','0000947403','0000947403','OH00000997945','IL','1','Kostoff','Thomas','','','','34','286461861','161 GRAYLING DR',0,'FAIRLAWN','OH','44333','2843','CY','39153','1954-02-06','M','U',':RET:2106-3','N','021','HLT','1762947','52664OH152000901','2014-01-01','2013-12-22 16:17:11','81.00',NULL,NULL,'425.18','344.18','R-OH012','OH0','425.18',NULL,0,'2013-12-25 21:23:22'),(6080,4819,'Y','18','021','EC','A','','','AC','0000145357','0000145357','OH00000489262','IL','1','Long','Clarissa','','','','34','279547693','7282 free soil rd',0,'Georgetown','OH','45121',NULL,'CY','39015','1953-09-30','F','M',':RET:2106-3','N','021','HLT','510687','92036OH004000601','2014-01-01','2013-12-01 14:06:00','107.00',NULL,NULL,'468.46','361.46','R-OH005','OH0','468.46',NULL,0,'2013-12-26 00:02:27'),(19829,15812,'Y','18','021','EC','A','','','AC','0001058792','0001058792','TX00001863819','31','1','Teneyuca','David','','','','34','463273056','PO Box 691593',0,'San Antonio','TX','78269',NULL,'CY','48029','1960-01-11','M','M',':RET:1002-5','N','021','DEN','2706582','33348TX002000201','2014-03-01','2014-01-24 17:40:47','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-24 21:00:18'),(18057,14426,'N','01','021','EC','A',NULL,NULL,'','0000701717','0000587992','','IL','1','Hill','Trudy','','','','34','318504132','5311 Sandra Dr',0,'Toledo','OH','43613',NULL,'CY','39095','1954-02-15','F','',NULL,'N','021','HLT','2596036','92036OH001002601','2014-02-01','2014-01-14 15:24:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','612.26',NULL,0,'2014-01-15 02:07:19'),(7262,5758,'Y','18','021','EC','A','','','AC','0000930079','0000930079','TX00000194967','IL','1','Escamilla','Violet','','','','34','643031064','319 Mae Drive',0,'Kerrville','TX','78028',NULL,'CY','48265','1989-02-13','F','U',':RET:2106-3','N','021','DEN','81948','33348TX002000201','2014-01-01','2013-12-13 20:48:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:02:10'),(7258,5754,'N','01','021','EC','A',NULL,NULL,'','0000038362','0000274767','','IL','1','McDowell','Chad','','','','34','286688722','127 Moores Road',0,'Seaman','OH','45679',NULL,'CY','39001','1972-10-15','M','',':RET:2106-3','N','021','HLT','996722','92036OH002000601','2014-01-01','2013-12-13 23:27:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.78',NULL,0,'2013-12-26 02:02:03'),(17740,14174,'N','19','021','EC','A',NULL,NULL,'','0000250269','0000078787','','S1','1','Hindel','Scott','','','','34','272139438','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2006-12-11','F','',':RET:2106-3','N','021','HLT','2130210','52664OH151001304','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-14 01:33:23'),(16174,12949,'N','01','021','EC','A',NULL,NULL,'','0001671571','0002059199','','IL','1','Huynh','Anh','','','','34','661109839','16352 Old Hammond Hwy.',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1975-12-18','M','',NULL,'N','021','DEN','1750501','18575LA002000201','2014-02-01','2014-01-04 12:41:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-05 00:00:19'),(23104,18417,'Y','18','021','EC','A','','','AC','0000955590','0000955590','OH00001937146','IL','1','Blaich','Gary','','','','34','281629259','215 Medina Street',0,'Lodi','OH','44254',NULL,'CY','39103','1958-07-22','M','U',NULL,'T','021','DEN','3608072','99734OH005000401','2014-03-01','2014-02-12 15:47:19','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-12 21:31:13'),(15395,12315,'Y','18','021','EC','A','','','AC','0000771447','0000771447','OH00001745683','IL','1','tone','scott','','','','34','301825997','173 S FAIRFIELD ST',0,'LEESBURG','OH','45135','9262','CY','39071','1970-05-30','M','M',':RET:2106-3','N','021','HLT','2215975','92036OH006000601','2014-02-01','2014-01-01 17:55:01','201.01',NULL,NULL,'447.24','246.23','R-OH005','OH0','231.02',NULL,1,'2014-01-02 04:25:51'),(15663,12532,'Y','18','021','EC','A','','','AC','0000348974','0000348974','TX00001786754','IL','1','Clark','Mary','','','','34','214887313','5303 MEDFORD DR',0,'AUSTIN','TX','78723','5427','CY','48453','1976-06-11','F','U',':RET:2106-3','N','021','DEN','1741305','33348TX002000101','2014-02-01','2013-12-31 16:38:01','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,1,'2014-01-02 04:34:31'),(26280,20845,'Y','18','021','EC','A','','','AC','0001685939','0001685939','LA00003043595','IL','1','Eanes','Chauncey','','','','34','221668784','4913 S ROBERTSON ST',0,'NEW ORLEANS','LA','70115','6472','CY','22071','1982-04-28','M','U',NULL,'N','021','DEN','3669786','18575LA002000101','2014-04-01','2014-02-26 23:25:59','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-28 06:31:19'),(27631,21856,'Y','18','021','EC','A','','','AC','0000699334','0000699334','OH00003150382','IL','1','Chung','Yong','','','','34','123685553','9424 EASTBROOK DR',0,'MIAMISBURG','OH','45342','7871','CY','39113','1957-07-29','M','U',':RET:2040-4','N','021','DEN','3199599','99734OH005000401','2014-04-01','2014-03-05 09:36:24','0.00',NULL,NULL,'50.05','50.05','R-OH003','OH0','0.00',NULL,0,'2014-03-05 21:30:11'),(28444,22507,'Y','18','021','EC','A','','','AC','0001736428','0001736428','LA00003562933','IL','1','Balsamo','Deborah','','','','34','439022483','103 Moelter Lane',0,'West Monroe','LA','71292',NULL,'CY','22073','1956-08-20','F','M',':RET:2106-3','T','021','DEN','3815243','18575LA002000201','2014-04-01','2014-03-06 22:21:04','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-07 21:31:16'),(28856,22835,'Y','18','021','EC','A','','','AC','0001181091','0001181091','OH00003383836','IL','1','Owens','Ashley','','','','34','272922836','5587 PLUM RUN RD',0,'MILFORD','OH','45150','9791','CY','39025','1985-04-11','F','U',':RET:2106-3','N','021','HLT','3766095','92036OH004000601','2014-04-01','2014-03-08 20:15:31','117.00',NULL,NULL,'187.64','70.64','R-OH005','OH0','187.64','CIC',0,'2014-03-09 21:29:59'),(21135,16888,'N','01','021','EC','A',NULL,NULL,'','0000823163','0000187500','','IL','1','TAJVAR','SHABNAM','','','','34','633278777','901 E 26TH ST',0,'HOUSTON','TX','77009','1005','CY','48201','1971-10-28','F','',':RET:2106-3','N','021','DEN','2673931','33348TX002000201','2014-03-01','2014-02-03 15:47:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-03 21:00:20'),(1481,1235,'Y','18','024','14','A','','','TE','0000993933','0000993933','','IL','1','CLAY','TERRY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-07-08','F','',NULL,NULL,NULL,'','835305','','2013-12-24','2013-12-24 10:27:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:48'),(1573,1313,'Y','18','021','EC','A','','','AC','0000843379','0000843379','TX00000353704','31','1','GIVENS','GLENDA','','','','34','466498713','P.O. BOX 6771',0,'HUNTSVILLE','TX','77342',NULL,'CY','48471','1962-12-10','F','U',':RET:2054-5','N','021','DEN','2454338','33348TX002000201','2014-01-01','2013-12-24 09:52:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:14'),(9252,7336,'Y','18','021','EC','A','','','AC','0000172393','0000172393','OH00000231818','IL','1','Osborne','Ryan','Patrick','','','34','268087837','3147 Kaiser Rd',0,'Fort Loramie','OH','45845',NULL,'CY','39149','2002-08-24','M','R',':RET:2106-3','N','021','HLT','1646807','92036OH002000501','2014-01-01','2013-12-18 18:04:44','0.00',NULL,NULL,'174.32','174.32','R-OH003','OH0','174.32',NULL,0,'2013-12-26 04:10:50'),(9128,7239,'Y','18','021','EC','A','','','AC','0000677564','0000677564','LA00000803991','IL','1','perrin','susan','','','','34','438902402','106  Alyene St',0,'Lafayette','LA','70506',NULL,'CY','22055','1954-12-02','F','U',':RET:2106-3','T','021','DEN','2293130','18575LA002000201','2014-01-01','2013-12-17 19:31:29','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 04:07:55'),(7674,6078,'Y','18','021','EC','A','','','AC','0000312176','0000312176','OH00001211982','IL','1','Spackey','Eric','','','','34','295628681','2917 CORY AVE',0,'AKRON','OH','44314','1027','CY','39153','1958-08-30','M','U',NULL,'N','021','DEN','1446424','99734OH005000401','2014-01-01','2013-12-19 18:52:27','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:00:40'),(24859,19709,'Y','18','021','EC','A','','','AC','0000093897','0000093897','OH00002429690','IL','1','Swingle','Mathew','','','','34','280821022','1001 WOODGLEN AVE',0,'NEWTON FALLS','OH','44444','9706','CY','39155','1968-08-22','M','U',':RET:2106-3','N','021','HLT','2856637','52664OH151001501','2014-04-01','2014-02-19 17:48:14','285.00',NULL,NULL,'437.98','152.98','R-OH013','OH0','437.98',NULL,0,'2014-02-20 04:56:40'),(1777,1464,'N','19','021','EC','A',NULL,NULL,'','0000432762','0000940857','','IL','1','miller','ava',NULL,NULL,NULL,NULL,NULL,'94 marion ave',0,'mogadore','OH','44260',NULL,'CY','39153','2007-04-10','F','',':RET:2106-3','N','021','DEN','2417846','99734OH005000301','2014-01-01','2013-12-24 15:00:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:16'),(3716,2972,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000141486','','S1','1','Anaya','George','Antonio','','','34','283049387','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1999-07-16','M','',':RET:2106-3','N','021','DEN','210262','99734OH005000401','2014-01-01','2013-12-13 14:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:18'),(5786,4597,'Y','18','021','EC','A','','','AC','0000518419','0000518419','OH00000869741','IL','1','Harper','Randal','','','','34','282788666','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1968-03-04','M','M',':RET:2106-3','N','021','DEN','1997609','99734OH005000401','2014-01-01','2013-12-24 00:09:12','0.00',NULL,NULL,'71.95','71.95','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:47:11'),(5707,4530,'Y','18','021','EC','A','','','AC','0000889174','0000889174','LA00000519712','IL','1','Bleichner','Barry','','','','34','438295635','302 PINE ST',0,'NEW ORLEANS','LA','70118','3616','CY','22071','1971-05-27','M','U',':RET:2106-3','T','021','DEN','887351','18575LA002000101','2014-01-01','2013-11-26 15:23:03','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:33:07'),(4895,3883,'Y','18','024','14','A','','','TE','0000016576','0000016576','','IL','1','JONES','ALBERTA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-14','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:31:39'),(24825,19678,'N','01','021','EC','A',NULL,NULL,'','0000757194','0000784410','','IL','1','Nowland','Steven','R','','','34','221332990','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1980-02-12','M','',':RET:2106-3','T','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.98',NULL,0,'2014-02-20 04:50:50'),(14985,11976,'Y','18','021','EC','A','','','AC','0000431816','0000431816','TX00001859495','IL','1','Molina','Diana','','','','34','509060907','4303 AVENUE D',0,'AUSTIN','TX','78751','3712','CY','48453','1982-07-25','F','U',':RET:2106-3','N','021','DEN','1865916','33348TX002000201','2014-02-01','2013-12-30 15:01:29','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-01 12:01:14'),(24679,19588,'Y','18','021','EC','A','','','AC','0000983854','0000983854','TX00002888782','IL','1','Park','David','','','','34','576433027','2312 TAHOE LN',0,'DENTON','TX','76210','2986','CY','48121','1983-05-26','M','U',':RET:2040-4^:RET:2106-3','N','021','DEN','3053656','33348TX002000101','2014-04-01','2014-02-18 22:51:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-20 04:29:52'),(27035,21411,'Y','18','024','14','A','','','TE','0000521477','0000521477','','IL','1','Mendiola','Martha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-16','F','',NULL,NULL,NULL,'','2406514','','2014-03-31','2014-03-03 15:22:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-03 21:00:18'),(27662,21880,'Y','18','021','EC','A','','','AC','0000752139','0000752139','OH00003469429','IL','1','Spilker','Pamela','','','','34','272460125','140 Clairhaven Drive',0,'Hudson','OH','44236',NULL,'CY','39153','1953-09-15','F','M',':RET:2106-3','N','021','DEN','3299678','99734OH005000401','2014-04-01','2014-03-05 16:16:02','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:28'),(1025,840,'Y','18','021','EC','A','','','AC','0000980506','0000980506','OH00000965719','IL','1','Evans Glasgo','Karen','Jane','','','34','288703638','3098 Grill Rd',0,'New Franklin','OH','44216',NULL,'CY','39153','1965-11-02','F','M',':RET:2106-3','N','021','HLT','572683','52664OH152000901','2014-01-01','2013-12-03 12:52:16','25.00',NULL,NULL,'267.06','242.06','R-OH012','OH0','267.06',NULL,0,'2013-12-25 18:15:21'),(4765,3780,'Y','18','021','EC','A','','','AC','0000093819','0000093819','OH00001055971','IL','1','YEFREMOV','ANDREY','','','','34','284960829','18383 COOK AVE',0,'STRONGSVILLE','OH','44136','5220','CY','39035','1979-01-25','M','U',':RET:2106-3','T','021','DEN','1197078','99734OH005000401','2014-01-01','2013-12-08 00:02:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:15:40'),(17509,13997,'Y','18','021','EC','A','','','AC','0000855652','0000855652','OH00001941608','IL','1','Olenik','Caitlin','Anne','','','34','285905948','13000 MARINER DR',0,'NORTH ROYALTON','OH','44133','5981','CY','39035','1989-01-06','F','U',':RET:2106-3','N','021','HLT','1864897','52664OH151001501','2014-02-01','2014-01-11 21:46:28','0.00',NULL,NULL,'302.87','302.87','R-OH011','OH0','302.87',NULL,0,'2014-01-13 03:01:28'),(22834,18219,'N','01','021','EC','A',NULL,NULL,'','0001118764','0000908072','','IL','1','Zanella','William','Gary','','','34','288464882','545 E MAPLE ST',0,'HARTVILLE','OH','44632','8840','CY','39151','1950-10-03','M','',':RET:2106-3','N','021','HLT','3583543','52664OH151001304','2014-03-01','2014-02-11 13:15:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,0,'2014-02-11 21:02:09'),(23007,18342,'Y','18','021','EC','A','','','AC','0001563833','0001563833','LA00002026757','IL','1','HAIK','NATHAN','','','','34','433732791','219 BEAUPRE DR',0,'LULING','LA','70070','3101','CY','22089','1983-09-03','M','U',':RET:2106-3','N','021','DEN','3411541','18575LA002000101','2014-03-01','2014-02-11 18:32:34','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-12 21:30:21'),(24577,19514,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000230489','','IL','1','ONWUAGBA','BRITTANY','','','','34','443172183','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','2002-07-10','F','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:05'),(27063,21427,'Y','18','021','EC','A','','','AC','0002277373','0002277373','LA00003580877','IL','1','Brown','Shoy','','','','34','435713900','101 BELAIRE DR',0,'NEW IBERIA','LA','70563','3011','CY','22045','1987-12-31','F','U',':RET:2054-5','N','021','DEN','2961035','18575LA002000201','2014-04-01','2014-03-03 09:17:47','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-03 21:30:00'),(4004,3198,'Y','18','021','EC','A','','','AC','0000280820','0000280820','OH00000782113','IL','1','Griffith','Jeffery','','','','34','277562485','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1961-11-28','M','M',':RET:2106-3','N','021','DEN','2132911','99734OH005000401','2014-01-01','2013-12-16 20:37:46','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:45:16'),(13649,10888,'Y','18','021','EC','A','','','AC','0001917246','0001917246','LA00001194727','IL','1','Valentine','Cranston','Leslie','','','34','453998415','814 DANTE ST',0,'NEW ORLEANS','LA','70118','1016','CY','22071','1969-08-29','M','R',':RET:2500-7','N','021','DEN','1748615','18575LA002000101','2014-01-01','2013-12-22 20:41:15','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:14'),(13244,10569,'Y','18','021','EC','A','','','AC','0001203690','0001203690','TX00001092734','IL','1','Smith','Callena','','','','34','612183545','1022 W AVENUE A',0,'GARLAND','TX','75040','6119','CY','48113','1988-03-28','F','U',':RET:2054-5','N','021','DEN','2186934','33348TX002000201','2014-01-01','2013-12-23 09:19:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:56:11'),(9418,7472,'Y','18','024','14','A','','','TE','0000848222','0000848222','','IL','1','Davis','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-12-14','M','',NULL,NULL,NULL,'','18526','','2013-12-21','2013-12-21 14:01:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:33:02'),(7925,6266,'N','01','021','EC','A',NULL,NULL,'','0001524559','0002193456','','IL','1','Johnson','Alyssa','A','','','34','438490014','513 Pleasant hill Rd',0,'DeRidder','LA','70634',NULL,'CY','22011','1976-04-18','F','',':RET:2106-3','N','021','DEN','1852338','18575LA002000201','2014-01-01','2013-12-20 08:57:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 03:06:26'),(281,232,'Y','18','021','EC','A','','','AC','0000260440','0000260440','OH00000349789','IL','1','Codispoti','Nicholas','','','Sr','34','294483316','7199 BLOUGH AVE SW',0,'NAVARRE','OH','44662','9295','CY','39151','1950-09-18','M','U',NULL,'N','021','HLT','1009814','52664OH151001305','2014-01-01','2013-10-12 08:53:31','1010.00',NULL,NULL,'1299.02','289.02','R-OH015','OH0','658.32',NULL,0,'2013-12-25 17:30:18'),(1245,1025,'Y','18','024','14','A','','','TE','0000736481','0000736481','','IL','1','Waugh','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-02-29','F','',NULL,NULL,NULL,'','830523','','2013-12-03','2013-12-03 09:43:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:21:04'),(16407,13129,'Y','18','021','EC','A','','','AC','0000066960','0000066960','TX00002102275','IL','1','VANDERDEER','BOBBY','DAN','','','34','462022456','3616 W NUGENT AVE',0,'TEMPLE','TX','76504','8856','CY','48027','1957-08-08','M','U',':RET:2106-3','N','021','DEN','2366039','33348TX002000201','2014-02-01','2014-01-06 14:10:17','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-07 04:04:05'),(18862,15024,'Y','18','021','EC','A','','','AC','0001976767','0001976767','LA00001845426','IL','1','sandifer','david','','','','34','436472584','15940 CONFEDERATE AVE',0,'BATON ROUGE','LA','70817','3619','CY','22033','1972-03-24','M','U',':RET:2106-3','T','021','DEN','3072777','18575LA002000201','2014-03-01','2014-01-16 00:23:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:20'),(19384,15452,'Y','18','021','EC','A','','','AC','0000824302','0000824302','TX00002059678','IL','1','Birchfield','Michael','','','','34','453356782','702 S Main Street',0,'Cotulla','TX','78014',NULL,'CY','48283','1969-02-28','M','U',':RET:2106-3','T','021','DEN','2593289','33348TX002000101','2014-03-01','2014-01-21 16:09:05','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,1,'2014-01-22 03:22:43'),(4863,3854,'Y','18','021','EC','A','','','AC','0000211806','0000211806','TX00000625190','IL','1','Kanj','Walid','','','','34','512118571','14811 WAVERTON CT',0,'SUGAR LAND','TX','77498','4507','CY','48157','1976-09-16','M','U',':RET:2106-3','N','021','DEN','789752','33348TX002000101','2014-01-01','2013-11-08 16:03:04','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:30:44'),(24308,19306,'N','19','021','EC','A',NULL,NULL,'','0001885767','0002326369','','S1','1','STEWART','CRAIG','','','Sr',NULL,NULL,'216 EVELYN AVE',0,'HOUMA','LA','70363',NULL,'CY','22109','2004-01-03','M','',':RET:2054-5','N','021','DEN','3121202','18575LA002000101','2014-03-01','2014-02-18 17:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55','CIC',0,'2014-02-18 21:30:24'),(2489,2028,'Y','18','021','EC','A','','','AC','0000031310','0000031310','LA00000090981','IL','1','ELZY','CAROLYN','A','','','34','437967601','4848 WINDSOR VLG DR',0,'BATON ROUGE','LA','70817','1374','CY','22033','1955-06-28','F','U',':RET:2054-5','N','021','DEN','1167110','18575LA002000201','2014-01-01','2013-12-09 16:12:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:45'),(3671,2937,'Y','18','021','EC','A','','','AC','0000822038','0000822038','OH00000654178','IL','1','Justin','Kathryn','','','','34','369563997','1433 RIVERWALK CT',0,'WATERVILLE','OH','43566','9542','CY','39095','1950-07-10','F','U',':RET:2106-3','N','021','DEN','11194','99734OH005000401','2014-01-01','2013-12-12 21:09:03','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:31:09'),(21347,17060,'Y','18','021','EC','A','','','AC','0000008932','0000008932','TX00002236692','IL','1','Munroe','Bonnie','','','','34','365568769','5727 QUAIL CROWN',0,'SAN ANTONIO','TX','78249','3137','CY','48029','1949-05-15','F','U',':RET:2106-3','N','021','DEN','3678232','33348TX002000201','2014-03-01','2014-02-04 00:19:49','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-04 21:00:35'),(15531,12426,'Y','18','021','EC','A','','','AC','0002003883','0002003883','LA00001159552','IL','1','Scott','Byron','','','','34','439531165','4809 FRANCIS DR',0,'NEW ORLEANS','LA','70126','3913','CY','22071','1984-03-26','M','U',':RET:2054-5','T','021','DEN','2514411','18575LA002000201','2014-02-01','2013-12-31 12:35:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:30:37'),(18506,14760,'Y','18','021','EC','A','','','AC','0000230464','0000230464','OH00001431254','IL','1','Bourn','Roy','','','','34','297683419','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1975-06-25','M','M',':RET:2106-3','N','021','HLT','1900415','52664OH151001305','2014-02-01','2014-01-15 17:50:01','499.00',NULL,NULL,'812.42','313.42','R-OH012','OH0','277.87',NULL,0,'2014-01-16 08:46:31'),(18902,15061,'Y','18','021','EC','A','','','AC','0000774008','0000774008','OH00002227025','IL','1','ONEY','MARY','','','','34','296426083','4166 STATE ROUTE 269 N',0,'BELLEVUE','OH','44811','9793','CY','39077','1951-10-01','F','M',':RET:2106-3','T','021','HLT','1924608','92036OH006002701','2014-03-01','2014-01-16 13:49:38','351.00',NULL,NULL,'510.93','159.93','R-OH006','OH0','510.93',NULL,0,'2014-01-17 03:36:37'),(22281,17786,'Y','18','021','EC','A','','','AC','0000955578','0000955578','OH00002431430','IL','1','Jerels','Ashaki','','','','34','284843607','417 FLAGLER LN',0,'YOUNGSTOWN','OH','44511','3734','CY','39099','1980-02-14','F','U',':RET:2054-5','N','021','DEN','2769505','99734OH005000401','2014-03-01','2014-01-25 12:00:07','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-10 11:00:22'),(22667,18101,'Y','18','021','EC','A','','','AC','0001191949','0001191949','TX00001918693','IL','1','CHRISTENSEN','JOHN','KELLY','','','34','529866236','909 S WASHINGTON ST',0,'PILOT POINT','TX','76258',NULL,'CY','48121','1954-02-23','M','U',':RET:2106-3','N','021','DEN','3627104','33348TX002000201','2014-03-01','2014-02-11 14:51:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:39'),(24987,19818,'N','01','021','EC','A',NULL,NULL,'','0000460804','0000677606','','IL','1','GAMEZ','GUADALUPE','','','','34','465356424','661 ARTESANO RD',0,'SOCORRO','TX','79927','3070','CY','48141','1950-04-18','F','',NULL,'N','021','DEN','3603473','33348TX002000201','2014-04-01','2014-02-20 13:57:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 22:00:37'),(15268,12205,'N','19','021','EC','A',NULL,NULL,'','0000680851','0000175110','','IL','1','Close','Brock','','','','34','287133424','120 CAROLIN CT',0,'PERRYSBURG','OH','43551','1607','CY','39173','2007-10-01','M','',':RET:2106-3','N','021','HLT','2315929','92036OH002002601','2014-02-01','2013-12-30 16:02:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2014-01-01 12:09:31'),(1280,1058,'Y','18','021','EC','A','','','AC','0001014341','0001014341','OH00001257782','IL','1','BEATTY','JAMES','','','','34','276601294','260 MAPLE TERRACE',0,'FAIRBORN','OH','45324',NULL,'CY','39057','1957-07-30','M','U',':RET:2106-3','N','021','DEN','10845','99734OH005000401','2014-01-01','2013-11-29 09:39:37','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:30:32'),(23151,18456,'Y','18','021','EC','A','','','AC','0000303406','0000303406','OH00002517717','IL','1','Bailey','James','','','','34','285680008','10753 Harrison Ave',0,'Harrison','OH','45030',NULL,'CY','39061','1965-03-14','M','R',':RET:2106-3','N','021','HLT','3256022','92036OH004001201','2014-03-01','2014-02-11 19:57:07','0.00',NULL,NULL,'516.45','516.45','R-OH004','OH0','282.22',NULL,0,'2014-02-12 21:31:41'),(14299,11407,'Y','18','021','EC','A','','','AC','0001058005','0001058005','OH00000496582','IL','1','Myers','Joyce','','','','34','276521978','24 3RD ST',0,'NEW LONDON','OH','44851','1132','CY','39077','1952-04-22','F','M',':RET:2106-3','N','021','HLT','2466297','92036OH005002705','2014-02-01','2013-12-26 12:34:38','489.00',NULL,NULL,'547.95','58.95','R-OH006','OH0','547.95',NULL,0,'2013-12-27 02:06:48'),(20321,16224,'Y','18','021','EC','A','','','AC','0000386687','0000386687','TX00001680629','IL','1','Martinez','Bianca','','','','34','525354736','6110 36th st',0,'Lubbock','TX','79407',NULL,'CY','48303','1979-12-24','F','U',NULL,'N','021','DEN','3283064','33348TX002000201','2014-03-01','2014-01-28 15:25:52','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-28 21:00:56'),(26390,20933,'N','19','021','EC','A',NULL,NULL,'','0000194050','0001224518','','IL','1','TAYLOR','OLIVIA','','','','34','277155468','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','2009-03-22','F','',NULL,'N','021','HLT','2681139','52664OH151001301','2014-03-01','2014-02-26 12:37:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:25'),(1663,1389,'Y','18','021','EC','A','','','AC','0000219640','0000219640','TX00000805824','IL','1','BROWN','CYNTHIA','','','','34','449616825','3003 FM 1651',0,'CANTON','TX','75103','5229','CY','48467','1966-04-05','F','M',NULL,'N','021','DEN','2498152','33348TX002000201','2014-01-01','2013-12-24 17:21:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:41'),(2134,1752,'Y','18','021','EC','A','','','AC','0000327254','0000327254','OH00000990792','IL','1','LEIS','NANCY','CATHERINE','','','34','273466100','705 MARKET ST',0,'YORKVILLE','OH','43971','1036','CY','39013','1950-01-23','F','U',NULL,'N','021','DEN','548113','99734OH005000401','2014-01-01','2013-12-10 16:50:23','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 19:18:03'),(3841,3073,'Y','18','021','EC','A','','','AC','0000776457','0000776457','LA00001105679','IL','1','Smith','Ricky','','','','34','433356400','9137 BEECHWOOD DR',0,'BASTROP','LA','71220','4801','CY','22067','1976-06-14','M','U',':RET:2054-5','N','021','DEN','5660','18575LA002000101','2014-01-01','2013-12-13 18:07:13','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 21:35:23'),(3912,3130,'Y','18','024','14','A','','','TE','0000088343','0000088343','','IL','1','cardenas','blanca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-12-11','F','',NULL,NULL,NULL,'','1024265','','2013-12-13','2013-12-13 11:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:37:08'),(25543,20264,'Y','18','021','EC','A','','','AC','0000072935','0000072935','OH00002397145','IL','1','Toth','Mary','','','','34','294549853','13701 Indian Creek Dr',0,'Middleburg Hts','OH','44130',NULL,'CY','39035','1968-10-28','F','U',':RET:2106-3','N','021','DEN','3651700','99734OH005000401','2014-04-01','2014-02-22 20:43:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 08:00:13'),(6282,4981,'Y','18','021','EC','A','','','AC','0000890732','0000890732','OH00000714981','IL','1','Caplinger','Richard','Paul','','','34','286706026','2217 PARK AVE',0,'NORWOOD','OH','45212','3204','CY','39061','1976-01-06','M','U',':RET:2106-3','N','021','DEN','774578','99734OH005000401','2014-01-01','2013-12-10 20:12:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:45:23'),(18026,14399,'N','19','021','EC','A',NULL,NULL,'','0000408502','0001036151','','IL','1','Andrews','Ryan','','','','34','297116326','6827 DRY RUN RD',0,'KINGSTON','OH','45644','9711','CY','39141','2006-05-16','M','',':RET:2106-3','N','021','DEN','2850751','99734OH005000301','2014-02-01','2014-01-14 13:19:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:07'),(17003,13609,'Y','18','021','EC','A','','','AC','0000854211','0000854211','OH00002385601','IL','1','Engles','Marie','','','','34','287545992','55 WILKERSON CT',0,'SPRINGBORO','OH','45066','8647','CY','39165','1956-01-28','F','M',NULL,'N','021','DEN','2127579','99734OH005000301','2014-02-01','2014-01-09 16:10:48','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:20:31'),(27349,21657,'Y','18','024','14','A','','','TE','0000637107','0000637107','','IL','1','Rice','Christine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-10','F','',NULL,NULL,NULL,'','2028271','','2014-03-19','2014-03-04 12:44:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-04 21:01:04'),(7064,5611,'N','19','021','EC','A',NULL,NULL,'','0000816435','0000214653','','IL','1','Yang','Brendon','','','','34','060946706','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','2004-03-11','M','',':RET:2034-7','N','021','DEN','2566021','99734OH005000301','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:01'),(15292,12226,'Y','18','021','EC','A','','','AC','0001545362','0001545362','LA00000200764','IL','1','CASTLE','JOSEPH','','','','34','439179317','144 JENNINGS LN',0,'HOUMA','LA','70360','2719','CY','22109','1968-05-23','M','U',':RET:2054-5','N','021','DEN','2124022','18575LA002000101','2014-02-01','2014-01-01 00:53:08','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,1,'2014-01-02 04:22:29'),(7823,6197,'Y','18','021','EC','A','','','AC','0000982460','0000982460','TX00000048243','IL','1','CONNER','KATHY','','','','34','217880029','417 ALEXANDER ST',0,'LANCASTER','TX','75146','1507','CY','48113','1976-03-13','F','U',NULL,'N','021','DEN','1457685','33348TX002000201','2014-01-01','2013-12-20 18:40:40','0.00',NULL,NULL,'56.37','56.37','R-TX008','TX0','15.85',NULL,0,'2013-12-26 03:04:14'),(22069,17616,'N','01','021','EC','A',NULL,NULL,'','0001182551','0000144696','','IL','1','Patel','Priyanka','','','','34','682473940','2310 WHITE ST',0,'CLIFTON','TX','76634','1135','CY','48035','1988-12-31','F','',':RET:2029-7','N','021','DEN','2629753','33348TX002000201','2014-03-01','2014-02-08 14:50:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-08 19:00:13'),(23821,18953,'N','01','021','EC','A',NULL,NULL,'','0000011204','0000350618','','IL','1','Greenler','Sandra','Lee','','','34','278763940','104 Madison Street',0,'Tiffin','OH','44883',NULL,'CY','39147','1964-06-08','F','',NULL,'N','021','HLT','3560716','92036OH005002705','2014-03-01','2014-02-14 15:37:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','332.67',NULL,0,'2014-02-14 21:31:40'),(24818,19677,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000455358','','IL','1','Burdick','Elliott','','','','34','274043242','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1998-12-21','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:26'),(27373,21675,'Y','18','021','EC','A','','','AC','0000012703','0000012703','MS00003028957','IL','1','CROWDER','NIGEL','','','','34','351469545','102 GUS GREEN RD',0,'FLORA','MS','39071','9579','CY','28089','1954-01-11','M','U',':RET:2054-5','T','021','DEN','2936331','46300MS002000101','2014-04-01','2014-03-04 12:43:14','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-04 21:01:17'),(2524,2057,'Y','18','021','EC','A','','','AC','0000827136','0000827136','OH00000235239','IL','1','Wojdacz','Patricia','A','','','34','300662830','900 Dawn Ct',0,'Medina','OH','44256',NULL,'CY','39103','1959-03-05','F','U',':RET:2106-3','T','021','HLT','775550','52664OH152000901','2014-01-01','2013-12-09 16:18:50','247.00',NULL,NULL,'401.04','154.04','R-OH012','OH0','401.04',NULL,0,'2013-12-25 19:36:39'),(6001,4751,'N','01','021','EC','A',NULL,NULL,'','0000596986','0000409956','','IL','1','BUTLER-GASPER','KATRESE','','','','34','438557317','1228 LEE ST',0,'MARRERO','LA','70072','2346','CY','22051','1976-10-14','F','',':RET:2054-5','N','021','DEN','538371','18575LA002000201','2014-01-01','2013-12-01 06:35:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:00:20'),(4174,3323,'Y','18','021','EC','A','','','AC','0000575887','0000575887','OH00000926074','IL','1','Kim','Suzanne','Lynn','','','34','003502713','89 E STREETSBORO ST',0,'HUDSON','OH','44236','3047','CY','39153','1970-09-14','F','U',':RET:2106-3','N','021','HLT','1644182','52664OH151001304','2014-01-01','2013-12-16 19:31:17','89.00',NULL,NULL,'302.62','213.62','R-OH012','OH0','302.62',NULL,0,'2013-12-25 21:49:19'),(9109,7229,'N','01','021','EC','A',NULL,NULL,'','0001135152','0000009831','','IL','1','Queen','Tammy','','','','34','284820022','46343 Scout Camp Rd',0,'Chester','OH','45720',NULL,'CY','39105','1975-03-20','F','',':RET:2106-3','N','021','DEN','2250070','99734OH005000301','2014-01-01','2013-12-18 15:33:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:33'),(6910,5484,'Y','18','024','14','A','','','TE','0001462800','0001462800','','IL','1','Olivers','Chanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-11-08','F','',NULL,NULL,NULL,'','1967229','','2013-12-25','2013-12-25 00:23:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 01:45:54'),(4646,3683,'Y','18','021','EC','A','','','AC','0000705950','0000705950','MS00000796438','IL','1','TORNS','LATONYA','','','','34','425657554','3627 HOOD DR',0,'PEARL','MS','39208','3806','CY','28121','1975-10-30','F','M',':RET:2054-5','N','021','DEN','1198421','46300MS002000201','2014-01-01','2013-12-12 18:32:05','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 22:06:55'),(6478,5130,'Y','18','021','EC','A','','','AC','0000396136','0000396136','OH00000129849','IL','1','Smith','Beth','','','','34','298740760','1274 ATWOOD AVE',0,'AKRON','OH','44301','1855','CY','39153','1968-12-29','F','U',':RET:2106-3','N','021','HLT','318930','52664OH151001305','2014-01-01','2013-12-11 00:46:24','196.00',NULL,NULL,'322.02','126.02','R-OH012','OH0','322.02',NULL,0,'2013-12-26 00:50:15'),(19818,15801,'Y','18','021','EC','A','','','AC','0000294983','0000294983','TX00001361296','IL','1','gil','armida','','','','34','551634238','346 redfish dr',0,'laredo','TX','78043',NULL,'CY','48479','1974-07-01','F','U',NULL,'N','021','DEN','2624801','33348TX002000201','2014-03-01','2014-01-24 12:14:49','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-24 21:00:13'),(19857,15838,'Y','18','024','14','A','','','TE','0000313215','0000313215','','IL','1','DIXON','HAROLD','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-20','M','',NULL,NULL,NULL,'','400210','','2014-01-24','2014-01-24 17:14:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:34'),(26023,20639,'Y','18','021','EC','A','','','AC','0001239575','0001239575','TX00003177972','IL','1','Gonzalez','Jessica','','','','34','467578407','4121 MOLINA DR',0,'CORPUS CHRISTI','TX','78416','2419','CY','48355','1982-02-08','F','U',':RET:2106-3','T','021','DEN','3726790','33348TX002000101','2014-04-01','2014-02-26 16:24:27','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-02-26 21:02:16'),(26313,20876,'N','01','021','EC','A',NULL,NULL,'','0000066313','0000876114','','IL','1','LITTLETON','KELLY','','','','34','294768255','3107 STATE ROUTE 41',0,'MANCHESTER','OH','45144','8194','CY','39001','1969-01-16','F','',NULL,'N','021','HLT','2925273','92036OH006000601','2014-04-01','2014-02-27 09:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.84',NULL,0,'2014-02-28 06:31:34'),(1,1,'Y','18','021','EC','A','','','AC','0000390876','0000390876','OH00000292053','IL','1','robinson','john','','','','34','288500780','1183 COUNTY ROAD 30A',0,'ASHLAND','OH','44805','9424','CY','39005','1950-10-11','M','M',':RET:2106-3','T','021','DEN','1054858','99734OH005000401','2014-01-01','2013-12-04 18:13:50','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:03'),(5796,4604,'Y','18','024','14','A','','','TE','0000209634','0000209634','','IL','1','Lange','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-02','F','',NULL,NULL,NULL,'','2379858','','2013-12-24','2013-12-24 01:45:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:47:23'),(5609,4452,'Y','18','021','EC','A','','','AC','0000736486','0000736486','OH00000771164','IL','1','Kane','Joseph','','','','34','271809138','8703 Outlook Dr',0,'Brooklyn','OH','44144',NULL,'CY','39035','1982-05-26','M','U',NULL,'T','021','DEN','1074574','99734OH005000401','2014-01-01','2013-11-25 22:26:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:31'),(13278,10597,'Y','18','021','EC','A','','','AC','0000122790','0000122790','TX00001234801','IL','1','HARE','DANIEL','','','','34','634125396','5815 BACK CT',0,'AUSTIN','TX','78731','3301','CY','48453','1989-09-19','M','U',':RET:2106-3','T','021','DEN','1608075','33348TX002000201','2014-01-01','2013-12-23 12:47:26','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:57:06'),(9781,7746,'Y','18','021','EC','A','','','AC','0000369984','0000369984','OH00000761717','IL','1','Ashcroft','Lisa','','','','34','276709725','403 CARY JAY BLVD',0,'RICHMOND HTS','OH','44143','1727','CY','39035','1961-01-19','F','U',':RET:2106-3','N','021','DEN','906222','99734OH005000301','2014-01-01','2013-10-20 20:15:21','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 05:00:43'),(7656,6063,'Y','18','021','EC','A','','','AC','0001412681','0001412681','LA00000624888','IL','1','Sullivan','Willie','','','','34','259359299','10720 LINKWOOD CT',0,'BATON ROUGE','LA','70810','2962','CY','22033','1980-06-11','M','R',':RET:2054-5','N','021','DEN','2348950','18575LA002000101','2014-01-01','2013-12-20 06:24:41','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:08'),(7489,5925,'Y','18','021','EC','A','','','AC','0000784343','0000784343','OH00000794351','IL','1','Blair','Rhonda','Allen','','','34','290506975','17543 COUNTY ROAD 297',0,'COSHOCTON','OH','43812','9525','CY','39031','1953-02-12','F','M',':RET:2106-3','N','021','DEN','569012','99734OH005000401','2014-01-01','2013-12-15 14:45:04','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-26 02:31:34'),(3578,2872,'Y','18','021','EC','A','','','AC','0001225702','0001225702','OH00000943727','IL','1','Lowell','Geoffrey','','','','34','299626430','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','1972-09-22','M','M',':RET:2106-3','T','021','HLT','2295943','92036OH006000601','2014-01-01','2013-12-22 08:50:08','491.00',NULL,NULL,'702.15','211.15','R-OH005','OH0','254.91',NULL,0,'2013-12-25 21:22:42'),(5066,4015,'Y','18','021','EC','A','','','AC','0000908718','0000908718','TX00000062615','IL','1','Stevenson','Barbara','Rena','','','34','467517645','521 WARREN ST',0,'GILMER','TX','75644','2533','CY','48459','1968-12-22','F','U',':RET:2054-5','N','021','DEN','2312810','33348TX002000201','2014-01-01','2013-12-19 10:58:23','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 23:00:36'),(16637,13310,'Y','18','024','14','A','','','TE','0000229446','0000229446','','IL','1','Woolery','Kristine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-19','F','',NULL,NULL,NULL,'','2523625','','2014-01-07','2014-01-07 11:38:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:24:16'),(17683,14130,'Y','18','021','EC','A','','','AC','0001199574','0001199574','LA00002337228','IL','1','WAMPLER','EDNA','DIANE','','','34','415861631','1025 PARADISE ROAD',0,'BALL','LA','71405',NULL,'CY','22079','1951-04-13','F','U',':RET:2106-3','N','021','DEN','1650322','18575LA002000101','2014-02-01','2014-01-13 15:57:02','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-01-14 01:32:55'),(18630,14850,'Y','18','021','EC','A','','','AC','0000260598','0000260598','TX00001543258','IL','1','Hendrix','Dianna','','','','34','457799591','502 VINE DR',0,'LUFKIN','TX','75904','4648','CY','48005','1973-11-11','F','U',':RET:2106-3','N','021','DEN','1537536','33348TX002000201','2014-02-01','2014-01-15 18:19:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:01'),(17237,13794,'Y','18','021','EC','A','','','AC','0000519851','0000519851','OH00001981276','IL','1','Stahl','Donna','Jean','','','34','274524512','1610 Woodridge Crescent',0,'Findlay','OH','45840',NULL,'CY','39063','1951-11-05','F','U',':RET:2106-3','N','021','HLT','2113960','92036OH004001501','2014-02-01','2014-01-08 13:21:21','504.70',NULL,NULL,'508.42','3.72','R-OH002','OH0','508.42',NULL,0,'2014-01-13 02:22:43'),(13285,10603,'N','01','021','EC','A',NULL,NULL,'','0000963307','0000817858','','IL','1','Lee-Nordin','Kristine','','','','34','474801374','5303 KITE TAIL DR',0,'AUSTIN','TX','78730','1423','CY','48453','1960-04-08','F','',':RET:2106-3','N','021','DEN','2245532','33348TX002000201','2014-01-01','2013-12-23 13:07:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:57:19'),(17027,13623,'N','01','021','EC','A',NULL,NULL,'','0001217387','0001019286','','IL','1','RUMMER','MELISSA','','','','34','273903598','3276 WHIPPLE DR',0,'NORTON','OH','44203','5221','CY','39153','1977-03-30','F','',':RET:2106-3','N','021','HLT','1701414','52664OH152000901','2014-02-01','2014-01-09 15:19:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','200.91',NULL,0,'2014-01-13 02:20:42'),(24560,19507,'N','19','021','EC','A',NULL,NULL,'','0000737910','0000783293','','IL','1','grubb','nicholas','','','','34','272134541','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','2006-11-13','M','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:06:09'),(1298,1074,'Y','18','021','EC','A','','','AC','0000553883','0000553883','OH00000710540','IL','1','Justice','Sara','','','','34','273924741','3561 Reimer Rd',0,'Norton','OH','44203',NULL,'CY','39153','1982-07-08','F','U',':RET:2106-3','N','021','HLT','694713','52664OH152000901','2014-01-01','2013-11-29 11:29:36','0.00',NULL,NULL,'189.31','189.31','R-OH012','OH0','189.31',NULL,0,'2013-12-25 18:31:04'),(15656,12526,'Y','18','021','EC','A','','','AC','0000077575','0000077575','OH00001920419','IL','1','ALEXANDER','MELISSA','KAY','','','34','278703710','626 JAY ST',0,'SAINT MARYS','OH','45885','2726','CY','39011','1970-07-21','F','U',':RET:2106-3','N','021','HLT','2132430','92036OH005001505','2014-02-01','2013-12-31 10:30:07','208.00',NULL,NULL,'298.65','90.65','R-OH002','OH0','298.65',NULL,1,'2014-01-02 04:34:17'),(7703,6099,'Y','18','021','EC','A','','','AC','0000231498','0000231498','OH00001230950','IL','1','Cantrell','Katie','','','','34','428651209','112EAST E 10TH ST',0,'MARYSVILLE','OH','43040','3700','CY','39159','1989-04-26','F','M',':RET:2106-3','N','021','DEN','2425218','99734OH005000401','2014-01-01','2013-12-20 09:10:03','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:01:19'),(3079,2474,'Y','18','021','EC','A','','','AC','0001050617','0001050617','OH00000929363','IL','1','Watt','Kevin','','','','34','314502083','12000 Edgewater Drive',0,'Lakewood','OH','44107',NULL,'CY','39035','1951-10-08','M','U',':RET:2106-3','N','021','HLT','22960','92036OH005000805','2014-01-01','2013-12-06 14:40:59','484.00',NULL,NULL,'671.70','187.70','R-OH011','OH0','671.70',NULL,0,'2013-12-25 20:19:40'),(4008,3202,'Y','18','021','EC','A','','','AC','0001207139','0001207139','OH00000526263','IL','1','Alvarado','Christopher','','','','34','457210858','1335 W 49TH ST',0,'CLEVELAND','OH','44102','2202','CY','39035','1972-08-18','M','R',':RET:2047-9','N','021','DEN','2428279','99734OH005000401','2014-01-01','2013-12-16 21:52:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:45:20'),(3790,3036,'Y','18','021','EC','A','','','AC','0000142808','0000142808','OH00000160185','IL','1','Norton','Ruth','','','','34','298505352','9496 Oak Dr',0,'LOVELAND','OH','45140',NULL,'CY','39165','1950-12-30','F','U',':RET:2106-3','N','021','DEN','732116','99734OH005000301','2014-01-01','2013-12-13 10:16:52','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:12'),(3384,2713,'Y','18','024','14','A','','','TE','0000245836','0000245836','','IL','1','wheaton','harvey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-23','M','',NULL,NULL,NULL,'','1467525','','2013-12-22','2013-12-22 18:22:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:17:36'),(5369,4257,'Y','18','024','14','A','','','TE','0001255006','0001255006','','IL','1','Trokan','Peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-05-08','M','',NULL,NULL,NULL,'','967065','','2013-12-19','2013-12-19 11:40:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:08:03'),(27635,21858,'Y','18','021','EC','A','','','AC','0000872115','0000872115','OH00003380018','IL','1','Lam','Tat Ming','','','','34','214025414','3161 AVALON RD',0,'UPPER ARLINGTON','OH','43221','2669','CY','39049','1957-11-03','M','M',':RET:2034-7','N','021','DEN','3606440','99734OH005000401','2014-04-01','2014-03-05 09:58:29','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-03-05 21:30:13'),(21376,17084,'Y','18','024','14','A','','','TE','0000217555','0000217555','','IL','1','Fredley','Richard','Andrew',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-12','M','',NULL,NULL,NULL,'','1033227','','2014-02-03','2014-02-03 18:58:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:00:50'),(14771,11794,'Y','18','021','EC','A','','','AC','0000781445','0000781445','TX00000828635','IL','1','miranda miranda','janet','','','','34','832450003','8205 GREENHOLLOW LN',0,'DALLAS','TX','75240','3818','CY','48113','1986-10-18','F','U',NULL,'N','021','DEN','1757966','33348TX002000201','2014-01-01','2013-12-23 20:32:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2013-12-29 11:12:56'),(19623,15641,'N','01','021','EC','A',NULL,NULL,'','0001250868','0000584305','','IL','1','Kaur','Manvir','','','','34','231916538','4785 SARAH LN',0,'MEDINA','OH','44256','6350','CY','39103','1972-01-02','F','',NULL,'N','021','DEN','1855703','99734OH005000401','2014-03-01','2014-01-22 19:09:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:05'),(18586,14819,'Y','18','021','EC','A','','','AC','0000396189','0000396189','OH00002555882','IL','1','Pinta','Jill','','','','34','295685519','153 FINKE RD',0,'OAK HARBOR','OH','43449','1457','CY','39123','1969-08-27','F','U',':RET:2106-3','N','021','HLT','2277236','92036OH005002705','2014-02-01','2014-01-15 01:52:16','163.00',NULL,NULL,'272.41','109.41','R-OH006','OH0','272.41',NULL,0,'2014-01-16 08:47:11'),(16775,13419,'Y','18','021','EC','A','','','AC','0000199186','0000199186','MS00001734981','IL','1','TORREY','REGENIA','','','','34','427433117','114 BELL DR',0,'CANTON','MS','39046','4983','CY','28089','1968-04-14','F','U',':RET:2054-5','N','021','DEN','2351955','46300MS002000101','2014-02-01','2014-01-07 11:34:07','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-08 18:25:03'),(3743,2994,'Y','18','021','EC','A','','','AC','0000230539','0000230539','TX00001015004','IL','1','GONZALES','MELISSA','M','','','34','456699090','2000 N ADAMS ST',0,'BEEVILLE','TX','78102','2451','CY','48025','1972-02-18','F','U',NULL,'N','021','DEN','533691','33348TX002000201','2014-01-01','2013-12-13 13:40:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:57'),(7838,6208,'Y','18','021','EC','A','','','AC','0000993963','0000993963','OH00000698914','IL','1','Tincher','Tony','','','','34','290567069','6987 LESLEY LN',0,'MIDDLETOWN','OH','45042','3123','CY','39017','1968-01-22','M','M',':RET:2106-3','N','021','DEN','2416177','99734OH005000301','2014-01-01','2013-12-19 21:54:27','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:04:33'),(4108,3283,'Y','18','021','EC','A','','','AC','0000560395','0000560395','TX00001282832','IL','1','Jackson','Robert','h','','','34','281842741','1807 JANIS DR',0,'KILLEEN','TX','76549','2131','CY','48027','1986-01-14','M','M',':RET:2054-5','N','021','DEN','1556089','33348TX002000101','2014-01-01','2013-12-17 15:58:00','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-25 21:47:56'),(5835,4634,'N','01','021','EC','A',NULL,NULL,'','0000628293','0000507705','','IL','1','Cisneros','Catherine','Olivia','','','34','450020463','1918 W HOUSTON ST',0,'SAN ANTONIO','TX','78207','3417','CY','48029','1953-05-24','F','',':RET:2106-3','N','021','DEN','2088402','33348TX002000201','2014-01-01','2013-12-23 23:20:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:48:24'),(26839,21273,'Y','18','021','EC','A','','','AC','0002193502','0002193502','LA00002900063','31','1','Calcagno Sr','David','','','','34','434114707','PO Box 2049',0,'Garyville','LA','70051',NULL,'CY','22095','1958-09-13','M','M',':RET:2106-3','T','021','DEN','3707131','18575LA002000201','2014-03-01','2014-02-28 23:15:31','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-03-01 21:00:44'),(27998,22154,'Y','18','021','EC','A','','','AC','0000629298','0000629298','OH00003167120','IL','1','Robinson','Desirae','','','','34','286946972','3799 SALISBURY RD',0,'SOUTH EUCLID','OH','44121','1909','CY','39035','1992-03-15','F','U',':RET:2054-5','N','021','DEN','3724433','99734OH005000401','2014-04-01','2014-03-05 19:56:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:07'),(28736,22743,'N','19','021','EC','A',NULL,NULL,'','0000069140','0001121464','','IL','1','Rutschilling','Bernard','','','','34','299968361','223 W. Walnut St.',0,'Coldwater','OH','45828',NULL,'CY','39107','1993-07-19','M','',':RET:2106-3','T','021','HLT','3616279','92036OH001001501','2014-04-01','2014-03-08 18:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','168.58',NULL,0,'2014-03-09 21:00:06'),(119,103,'Y','18','024','14','A','','','TE','0000745350','0000745350','','IL','1','KERVIN','PENNY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-30','F','',NULL,NULL,NULL,'','13983','','2013-12-05','2013-12-05 15:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 17:18:08'),(7769,6151,'N','19','021','EC','A',NULL,NULL,'','0000888520','0001072710','','IL','1','Ochoa','Danny','','','','34','632128875','2108 DOMINGO TREVINO DR',0,'MISSION','TX','78572','1435','CY','48215','1989-12-16','M','',NULL,'N','021','DEN','2600028','33348TX002000201','2014-01-01','2013-12-19 18:52:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:02:53'),(5291,4193,'Y','18','021','EC','A','','','AC','0000976708','0000976708','OH00000164356','IL','1','Crowder','Beverly','','','','34','406742977','6140 Vair Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1952-01-15','F','M',':RET:2106-3','N','021','HLT','1488270','52664OH151001304','2014-01-01','2013-12-19 17:33:21','976.00',NULL,NULL,'1267.35','291.35','R-OH012','OH0','626.65',NULL,0,'2013-12-25 23:06:02'),(15931,12755,'Y','18','021','EC','A','','','AC','0000030555','0000030555','OH00000597106','IL','1','Ousley','June','','','','34','273568683','5144 US Rte 250 N Lot 117',0,'Norwalk','OH','44857',NULL,'CY','39077','1956-06-19','F','M',':RET:2106-3','T','021','HLT','2545249','92036OH004002701','2014-02-01','2014-01-01 18:35:31','920.00',NULL,NULL,'971.70','51.70','R-OH006','OH0','439.43',NULL,0,'2014-01-03 02:06:55'),(16042,12845,'Y','18','021','EC','A','','','AC','0000088483','0000088483','TX00001256060','IL','1','Garcia','Francisco','','','','34','449711486','2018 Lowry Rd',0,'Laredo','TX','78045',NULL,'CY','48479','1961-10-18','M','M',':RET:2106-3','N','021','DEN','1867071','33348TX002000101','2014-02-01','2014-01-02 23:24:15','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-01-04 02:02:53'),(17494,13988,'Y','18','021','EC','A','','','AC','0001914738','0001914738','LA00001428805','IL','1','Franklin','Donna','','','','34','331521889','1140 N  Ardenwood',0,'Baton  Rouge','LA','70806',NULL,'CY','22033','1957-06-11','F','M',':RET:2054-5','N','021','DEN','1835830','18575LA002000201','2014-02-01','2014-01-12 09:18:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 03:01:21'),(19189,15288,'Y','18','021','EC','A','','','AC','0000322998','0000322998','TX00001519398','IL','1','MORALES','BEATRIZ','C','','','34','541259890','218 FLEISHEL AVE',0,'TYLER','TX','75702',NULL,'CY','48423','1965-07-29','F','M',NULL,'N','021','DEN','2905581','33348TX002000101','2014-03-01','2014-01-20 18:11:53','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2014-01-21 08:46:11'),(19385,15453,'Y','18','021','EC','A','','','AC','0000373658','0000373658','OH00002553660','IL','1','CHEEK','COREY','','','','34','294721593','23245 LAWRENCE RD',0,'CLEVELAND','OH','44128','4969','CY','39035','1972-01-03','M','R',':RET:2054-5','N','021','DEN','2437940','99734OH005000401','2014-03-01','2014-01-21 09:13:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-22 03:22:44'),(19549,15582,'Y','18','021','EC','A','','','AC','0000712548','0000712548','OH00001610724','IL','1','HAMMOND','DAVID','','','','34','300489858','5606 TARA WAY',0,'TOLEDO','OH','43615','2754','CY','39095','1950-05-03','M','M',':RET:2106-3','N','021','HLT','2105949','92036OH006002601','2014-03-01','2014-01-22 09:55:11','183.00',NULL,NULL,'456.50','273.50','R-OH001','OH0','456.50',NULL,0,'2014-01-23 03:02:28'),(27907,22077,'N','01','021','EC','A',NULL,NULL,'','0000698591','0000127049','','IL','1','Larry','Sylvester','','','','34','462907205','929 WHITEWATER TRL',0,'DESOTO','TX','75115','5444','CY','48113','1951-10-30','M','',NULL,'N','021','DEN','3811459','33348TX002000201','2014-04-01','2014-03-05 19:11:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-06 21:00:12'),(4965,3941,'Y','18','021','EC','A','','','AC','0000335791','0000335791','LA00000106525','IL','1','dillard','gladys','mae','','','34','437981386','1112 MADISON AVE',0,'SHREVEPORT','LA','71103','2424','CY','22017','1953-01-16','F','U',':RET:2054-5','N','021','DEN','891497','18575LA002000201','2014-01-01','2013-12-06 23:48:44','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:46:16'),(6174,4893,'Y','18','021','EC','A','','','AC','0000009809','0000009809','OH00000109155','IL','1','Higham','Michael','','','','34','285745640','4429 Robinson Rd',0,'Hillsboro','OH','45133',NULL,'CY','39071','1967-10-02','M','U',NULL,'T','021','DEN','105089','99734OH005000301','2014-01-01','2013-10-02 07:22:01','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:17:09'),(13696,10927,'Y','18','021','EC','A','','','AC','0001258640','0001258640','OH00000170617','IL','1','MARTIN','GAYLE','E','','','34','300625451','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1956-10-16','F','M',':RET:2106-3','N','021','HLT','2073754','52664OH151001305','2014-01-01','2013-12-23 11:43:31','897.00',NULL,NULL,'1065.04','168.04','R-OH011','OH0','612.95',NULL,0,'2013-12-26 13:08:33'),(7269,5764,'Y','18','021','EC','A','','','AC','0000374211','0000374211','TX00001091221','31','1','Truong','Thom','','','','34','225775512','18004 Golden ridge Drive',0,'Houston','TX','77084',NULL,'CY','48201','1957-06-10','F','U',':RET:2047-9','N','021','DEN','544814','33348TX002000201','2014-01-01','2013-12-14 10:16:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:02:22'),(16512,13209,'Y','18','021','EC','A','','','AC','0000103715','0000103715','TX00002129342','IL','1','EVANS','MARSHA','F','','','34','557845054','5705 INDIAN HILLS DR',0,'GARLAND','TX','75044',NULL,'CY','48113','1952-08-05','F','M',':RET:2106-3','N','021','DEN','1924248','33348TX002000201','2014-02-01','2014-01-04 19:21:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-07 10:21:23'),(18015,14393,'N','19','021','EC','A',NULL,NULL,'','0001184903','0000064908','','S1','1','Manning','Ted','M','','','34','291085893','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','2003-12-23','M','',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(18587,14820,'Y','18','021','EC','A','','','AC','0000199678','0000199678','OH00002458438','IL','1','AYERS','LISA','','','','34','274805391','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1970-02-05','F','R',':RET:2106-3','N','021','HLT','1654416','92036OH002000601','2014-02-01','2014-01-15 02:13:49','0.00',NULL,NULL,'493.84','493.84','R-OH005','OH0','336.41',NULL,0,'2014-01-16 08:47:12'),(19130,15242,'Y','18','021','EC','A','','','AC','0001666318','0001666318','LA00002466199','IL','1','Weatherspoon','Renata','','','','34','436431546','8516 FRERET ST',0,'NEW ORLEANS','LA','70118','1160','CY','22071','1980-10-23','F','U',':RET:2054-5','N','021','DEN','2119259','18575LA002000201','2014-03-01','2014-01-18 22:03:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:45:22'),(19237,15328,'N','01','021','EC','A',NULL,NULL,'','0000597328','0000261527','','IL','1','Powell','Lindsey','Leigh','','','34','647095054','1185 CAREY AVE',0,'AKRON','OH','44314','1935','CY','39153','1986-10-03','F','',':RET:2106-3','N','021','DEN','2513463','99734OH005000301','2014-03-01','2014-01-20 10:02:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:46:36'),(25232,20014,'Y','18','021','EC','A','','','AC','0001170884','0001170884','OH00002570126','IL','1','Uminski','Karen','','','','34','277643648','7391 Fulton Road',0,'Clinton','OH','44216',NULL,'CY','39153','1957-01-12','F','U',':RET:2106-3','N','021','HLT','2750999','52664OH151001306','2014-04-01','2014-02-21 16:36:14','440.00',NULL,NULL,'543.47','103.47','R-OH012','OH0','543.47',NULL,0,'2014-02-21 22:01:02'),(27462,21733,'N','01','021','EC','A',NULL,NULL,'','0001113196','0000190252','','IL','1','Miller','Debra',NULL,NULL,NULL,NULL,NULL,'1270 VANE AVE',0,'AKRON','OH','44310','3520','CY','39153','1959-07-07','F','',':RET:2106-3','T','021','HLT','3817213','52664OH152000901','2014-04-01','2014-03-04 13:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.04',NULL,0,'2014-03-04 21:02:06'),(27798,21987,'Y','18','021','EC','A','','','AC','0001063305','0001063305','OH00003143160','IL','1','Cottell','Claire','','','','34','286903982','2265 7TH ST',0,'CUYAHOGA FALLS','OH','44221','3164','CY','39153','1988-02-27','F','U',':RET:2106-3','T','021','HLT','3793086','52664OH151001305','2014-04-01','2014-03-04 21:24:58','99.00',NULL,NULL,'262.61','163.61','R-OH012','OH0','262.61',NULL,0,'2014-03-05 21:31:44'),(27991,22148,'Y','18','021','EC','A','','','AC','0000519892','0000519892','OH00002571960','IL','1','GIROUX-SCHLAF','SHELLEY','','','','34','300649369','14306 WOODLAWN DR',0,'NEWBURY','OH','44065','9655','CY','39055','1959-08-20','F','M',NULL,'T','021','DEN','3319693','99734OH005000401','2014-04-01','2014-03-05 18:20:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:04'),(4118,3290,'N','19','021','EC','A',NULL,NULL,'','0000309426','0000573044','','IL','1','Cipro','Maria','','','','34','270084272','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2002-09-15','F','',':RET:2106-3','N','021','DEN','1795221','99734OH005000301','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:09'),(854,708,'Y','18','021','EC','A','','','AC','0001218530','0001218530','OH00000020030','IL','1','SCHROEDER','SHELLY','','','','34','274681855','2441 MASSILLON ST',0,'FINDLAY','OH','45840','4685','CY','39063','1958-11-03','F','U',':RET:2106-3','N','021','HLT','1960025','92036OH005001506','2014-01-01','2013-12-16 11:18:24','452.00',NULL,NULL,'490.79','38.79','R-OH002','OH0','490.79',NULL,0,'2013-12-25 18:06:59'),(869,719,'Y','18','021','EC','A','','','AC','0000519814','0000519814','OH00000939073','IL','1','Heppner','Leianne','','','','34','290866927','3954 Mt. Vernon Blvd',0,'Norton','OH','44203',NULL,'CY','39153','1973-02-03','F','U',':RET:2106-3','N','021','HLT','2044119','52664OH151001501','2014-01-01','2013-12-16 12:13:43','0.00',NULL,NULL,'341.82','341.82','R-OH012','OH0','341.82',NULL,0,'2013-12-25 18:07:24'),(3034,2440,'Y','18','021','EC','A','','','AC','0000157969','0000157969','OH00001111916','IL','1','Faulkner','Peggy','Lou','','','34','453574364','3360 S PRICETOWN RD',0,'BERLIN CENTER','OH','44401','9738','CY','39099','1968-02-07','F','R',':RET:2106-3','T','021','HLT','56316','52664OH152000901','2014-01-01','2013-12-05 21:40:38','0.00',NULL,NULL,'671.01','671.01','R-OH013','OH0','307.60',NULL,0,'2013-12-25 20:18:29'),(1913,1562,'N','19','021','EC','A',NULL,NULL,'','0000828235','0000367387','','IL','1','Schultz','Aaron','','','','34','342845702','5865 SQUIREHILL CT',0,'CINCINNATI','OH','45241','6021','CY','39061','1989-08-19','M','',':RET:2106-3','N','021','HLT','1521879','92036OH003001201','2014-01-01','2013-12-24 17:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2013-12-25 18:59:26'),(9507,7539,'Y','18','021','EC','A','','','AC','0001127985','0001127985','OH00000356249','IL','1','Luebbers','Lauren','','','','34','403251106','2540 Madison Road',0,'Cincinnati','OH','45208',NULL,'CY','39061','1984-07-26','F','U',':RET:2106-3','N','021','DEN','2548358','99734OH005000401','2014-01-01','2013-12-21 15:38:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:35:17'),(21375,17083,'N','01','021','EC','A',NULL,NULL,'','0000481105','0000726168','','IL','1','McCarthy','Thomas','','','','34','302583467','6511 OLIVE BRANCH RD',0,'OREGONIA','OH','45054','9715','CY','39165','1956-10-17','M','',':RET:2106-3','N','021','DEN','3326761','99734OH005000401','2014-03-01','2014-02-03 18:49:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:50'),(23439,18672,'Y','18','021','EC','A','','','AC','0001070411','0001070411','TX00002390132','IL','1','PARRILL','ARLANA','','','','34','522157730','2323 W BAY AREA BLVD',0,'WEBSTER','TX','77598','3248','CY','48201','1973-11-17','F','U',':RET:2106-3','N','021','DEN','2633870','33348TX002000201','2014-03-01','2014-02-13 11:42:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-13 22:01:32'),(3341,2678,'Y','18','021','EC','A','','','AC','0000236920','0000236920','TX00001071271','IL','1','Butler','Scott','','','','34','527155693','756 WILTSHIRE DR',0,'HUTTO','TX','78634','5598','CY','48491','1955-08-30','M','M',':RET:2106-3','N','021','DEN','1919557','33348TX002000201','2014-01-01','2013-12-21 19:17:47','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:16:29'),(5499,4366,'Y','18','021','EC','A','','','AC','0000689686','0000689686','OH00000889952','IL','1','Dunn','Brian','','','','34','286808535','3180 ZENOBIA RD',0,'NORWALK','OH','44857','8818','CY','39077','1979-11-13','M','M',NULL,'N','021','HLT','1865416','92036OH005002705','2014-01-01','2013-12-19 15:56:24','261.00',NULL,NULL,'470.31','209.31','R-OH006','OH0','236.72',NULL,0,'2013-12-25 23:11:17'),(398,327,'N','01','021','EC','A',NULL,NULL,'','0000767376','0000597278','','IL','1','Ulam','Charles','Dennis','','','34','278529671','3419 EAGLES LOFT',0,'CORTLAND','OH','44410','9163','CY','39155','1951-12-07','M','',':RET:2106-3','N','021','DEN','20199','99734OH005000401','2014-01-01','2013-12-03 20:18:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:05'),(24969,19802,'Y','18','021','EC','A','','','AC','0001058883','0001058883','TX00001793067','31','1','Hamilton','Jackie','','','','34','457041965','P.O. Box 143',0,'Brookeland','TX','75931',NULL,'CY','48241','1962-11-19','M','U',':RET:2054-5','N','021','DEN','2927737','33348TX002000201','2014-04-01','2014-02-19 20:06:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 22:00:25'),(20014,15962,'N','19','021','EC','A',NULL,NULL,'','0001118253','0000926578','','IL','1','GUTIERREZ','STEPHANIA','ORTEGA','','','34','630924681','7109 WESTOVER DR',0,'EL PASO','TX','79912','7681','CY','48141','1991-12-31','F','',NULL,'N','021','DEN','2704179','33348TX002000201','2014-03-01','2014-01-25 22:15:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-26 19:00:11'),(2486,2025,'Y','18','021','EC','A','','','AC','0000894561','0000894561','LA00001180980','IL','1','MERRITT','TINA','','','','34','437156979','4742 CAMELOT DR',0,'NEW ORLEANS','LA','70127',NULL,'CY','22071','1964-01-05','F','M',':RET:2054-5','N','021','DEN','909880','18575LA002000201','2014-01-01','2013-12-09 15:38:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:39'),(2604,2115,'N','01','021','EC','A',NULL,NULL,'','0000569275','0000388617','','IL','1','Durbin','Norma','','','','34','263860307','891 STONEWATER DR',0,'KENT','OH','44240','2052','CY','39133','1949-04-08','F','',':RET:2106-3','N','021','DEN','591730','99734OH005000401','2014-01-01','2013-12-02 07:00:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:25'),(3674,2940,'Y','18','021','EC','A','','','AC','0000277258','0000277258','OH00000812479','IL','1','PARK','INAE','','','','34','292889425','1310 ANTHONY LN',0,'MASON','OH','45040','1141','CY','39165','1973-02-04','F','U',':RET:2040-4','N','021','DEN','47456','99734OH005000401','2014-01-01','2013-12-12 22:25:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:15'),(7079,5617,'Y','18','021','EC','A','','','AC','0000463240','0000463240','OH00001089504','IL','1','Skaggs','Stacey','','','','34','289860737','407 LAUREL ST',0,'CHILLICOTHE','OH','45601','1444','CY','39141','1986-07-27','F','M',':RET:2106-3','T','021','DEN','1930521','99734OH005000301','2014-02-01','2013-12-25 00:19:30','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2013-12-26 01:50:15'),(5516,4375,'N','01','021','EC','A',NULL,NULL,'','0000573031','0001068236','','IL','1','Walsh','Martha','','','','34','288841644','5278 ADENA TRL',0,'CINCINNATI','OH','45230','5103','CY','39061','1986-05-01','F','',':RET:2106-3','N','021','DEN','1250228','99734OH005000301','2014-01-01','2013-11-27 12:33:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:11'),(17902,14299,'N','01','021','EC','A',NULL,NULL,'','0001152462','0001241777','','IL','1','willis','marilla','','','','34','570803934','196 RAINBOW DR',0,'LIVINGSTON','TX','77399','1096','CY','48373','1952-01-06','F','',NULL,'N','021','DEN','1938477','33348TX002000201','2014-02-01','2014-01-13 18:44:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:23'),(14795,11815,'N','01','021','EC','A',NULL,NULL,'','0000132073','0000491883','','IL','1','Payten','Creshinda','J','','','34','279624056','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1964-08-02','F','',':RET:2054-5','N','021','DEN','2101453','99734OH005000401','2014-01-01','2013-12-23 19:41:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:13:35'),(28158,22282,'Y','18','021','EC','A','','','AC','0000199736','0000199736','OH00002601609','IL','1','Gilmer','Kashawnna','','','','34','290946902','3307 Middlesex Dr',0,'Toledo','OH','43606',NULL,'CY','39095','1992-01-16','F','U',':RET:2054-5','N','021','HLT','3566054','92036OH005002604','2014-04-01','2014-03-06 17:20:57','32.00',NULL,NULL,'194.99','162.99','R-OH001','OH0','194.99',NULL,0,'2014-03-06 21:02:40'),(24850,19702,'Y','18','021','EC','A','','','AC','0000214713','0000214713','OH00002400423','IL','1','Weber','Alan','','','','34','284445659','9470 BENCHMARK LN',0,'BLUE ASH','OH','45242','6004','CY','39061','1949-11-25','M','R',':RET:2106-3','N','021','HLT','2699454','92036OH005001201','2014-04-01','2014-02-19 14:28:38','0.00',NULL,NULL,'1247.24','1247.24','R-OH004','OH0','644.00',NULL,0,'2014-02-20 04:55:17'),(17199,13763,'Y','18','021','EC','A','','','AC','0000814303','0000814303','OH00001477805','IL','1','WILSON','GARY','','','','34','288508340','2887 E TURKEYFOOT LAKE RD',0,'UNIONTOWN','OH','44685','7532','CY','39153','1951-02-28','M','U',NULL,'T','021','HLT','2446623','52664OH152000901','2014-02-01','2014-01-08 11:49:03','514.00',NULL,NULL,'539.67','25.67','R-OH012','OH0','539.67',NULL,0,'2014-01-13 02:22:23'),(14860,11865,'Y','18','021','EC','A','','','AC','0000036781','0000036781','MS00000088144','IL','1','Tingle','Dorothy','','','','34','587342958','18386 ROBYN DR',0,'GULFPORT','MS','39503','7905','CY','28047','1949-12-24','F','U',':RET:2054-5','N','021','DEN','1362644','46300MS002000201','2014-01-01','2013-12-23 19:30:57','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,1,'2013-12-29 11:15:19'),(2847,2301,'Y','18','021','EC','A','','','AC','0000306335','0000306335','TX00000016706','IL','1','Noorani','Shamsha','','','','34','338747506','5810 WHITE CLOVER DR',0,'RICHMOND','TX','77469','6270','CY','48157','1964-09-26','F','M',':RET:2029-7','N','021','DEN','839220','33348TX002000101','2014-01-01','2013-11-02 08:26:46','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-25 20:01:14'),(2697,2185,'Y','18','021','EC','A','','','AC','0000867535','0000867535','TX00000077140','IL','1','rios','irma','','','','34','460592116','321 SUNSET DR',0,'MARBLE FALLS','TX','78654','1430','CY','48053','1970-06-21','F','M',':RET:2106-3','N','021','DEN','38414','33348TX002000201','2014-01-01','2013-12-02 15:41:06','0.00',NULL,NULL,'43.83','43.83','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:47:39'),(13573,10825,'N','01','021','EC','A',NULL,NULL,'','0001354828','0001401554','','IL','1','ALLEN','ANNIE','','','','34','427089202','62007 HOLLIS LESLIE RD',0,'ANGIE','LA','70426','2139','CY','22117','1957-12-21','F','',':RET:2054-5','N','021','DEN','2322902','18575LA002000201','2014-01-01','2013-12-23 17:12:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:43'),(13288,10606,'Y','18','021','EC','A','','','AC','0000485295','0000485295','TX00000629704','31','1','Tyler','Ronda','','','','34','458690436','PO Box 381446',0,'Duncanville','TX','75138',NULL,'CY','48113','1974-08-04','F','U',':RET:2054-5','N','021','DEN','2178089','33348TX002000201','2014-01-01','2013-12-23 13:22:15','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:24'),(1847,1513,'Y','18','021','EC','A','','','AC','0001095662','0001095662','OH00000198234','IL','1','KLINESMITH','JOHN','','','','34','278844333','16278 SHILLING RD',0,'BERLIN CENTER','OH','44401',NULL,'CY','39099','1972-06-29','M','M',NULL,'N','021','HLT','1710749','52664OH151001305','2014-01-01','2013-12-24 16:17:27','409.00',NULL,NULL,'648.42','239.42','R-OH013','OH0','329.27',NULL,0,'2013-12-25 18:57:49'),(6916,5489,'Y','18','021','EC','A','','','AC','0001250719','0001250719','LA00000475926','IL','1','cooper','kenneth','','','','34','259945203','221Fourth st',0,'slidell','LA','70460',NULL,'CY','22103','1963-04-18','M','U',':RET:2106-3','T','021','DEN','1579760','18575LA002000201','2014-02-01','2013-12-25 14:34:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:46:03'),(5865,4655,'Y','18','021','EC','A','','','AC','0000858492','0000858492','OH00000189919','IL','1','warnick','amy','','','','34','299881078','1520 N HAMETOWN RD',0,'AKRON','OH','44333','1058','CY','39153','1985-09-11','F','M',':RET:2106-3','T','021','HLT','2518207','52664OH152000901','2014-01-01','2013-12-23 22:53:15','250.00',NULL,NULL,'540.45','290.45','R-OH012','OH0','204.18',NULL,0,'2013-12-25 23:49:06'),(3892,3115,'N','01','021','EC','A',NULL,NULL,'','0000021368','0000763503','','IL','1','Hartzell','Timothy','Howard','','','34','298626101','2901 perrydale st.nw',0,'greentown','OH','44630',NULL,'CY','39151','1965-06-13','M','',':RET:2106-3','N','021','HLT','19180','52664OH152000901','2014-01-01','2013-12-13 12:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.06',NULL,0,'2013-12-25 21:36:40'),(2433,1981,'Y','18','021','EC','A','','','AC','0000160759','0000160759','OH00000263258','IL','1','GIORGIANNI','MARK',NULL,NULL,NULL,NULL,NULL,'6270 Greenwood Pkwy.',0,'Sagamore Hills','OH','44067',NULL,'CY','39153','1969-09-27','M','R',':RET:2106-3','N','021','HLT','646330','52664OH151001301','2014-01-01','2013-12-08 22:49:50','0.00',NULL,NULL,'311.54','311.54','R-OH012','OH0','311.54',NULL,0,'2013-12-25 19:34:14'),(27326,21637,'Y','18','024','14','A','','','TE','0000374570','0000374570','','IL','1','DURON LOPEZ','JESUS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-25','M','',NULL,NULL,NULL,'','2760332','','2014-03-04','2014-03-04 16:59:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-04 21:00:49'),(28574,22613,'Y','18','021','EC','A','','','AC','0000736304','0000736304','TX00002930283','31','1','CANALES','MARCO','ANTONIO','','','34','453711394','P.O BOX 5865',0,'EAGLE PASS','TX','78852',NULL,'CY','48323','1960-12-06','M','M',NULL,'N','021','DEN','2941033','33348TX002000201','2014-04-01','2014-03-08 11:21:31','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-03-08 21:00:03'),(25103,19911,'Y','18','024','14','A','','','TE','0000049516','0000049516','','IL','1','SMITH','ANTHONY','W',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-04-04','M','',NULL,NULL,NULL,'','1811752','','2014-02-28','2014-02-21 11:35:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-21 21:30:11'),(23136,18442,'Y','18','021','EC','A','','','AC','0000697946','0000697946','OH00001921408','IL','1','Kraus','Rhonda','','','','34','293701945','1880 ASHWOOD DR',0,'AKRON','OH','44313','5428','CY','39153','1966-02-20','F','U',':RET:2106-3','N','021','HLT','2793697','52664OH151001306','2014-03-01','2014-02-12 09:51:44','240.00',NULL,NULL,'364.62','124.62','R-OH012','OH0','364.62',NULL,0,'2014-02-12 21:31:33'),(20758,16584,'Y','18','021','EC','A','','','AC','0000658451','0000658451','OH00001713015','IL','1','Labert','KATHLENNE','','','','34','293484973','1470 FLEETWOOD AVE',0,'FINDLAY','OH','45840',NULL,'CY','39063','1952-12-18','F','U',':RET:2106-3','N','021','HLT','3446435','92036OH002001501','2014-03-01','2014-01-30 11:30:19','595.00',NULL,NULL,'714.21','119.21','R-OH002','OH0','714.21',NULL,0,'2014-01-30 21:01:33'),(18709,14916,'Y','18','021','EC','A','','','AC','0000854219','0000854219','OH00001792302','IL','1','Henry','Matthew','','','','34','576629098','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1953-07-14','M','M',NULL,'N','021','DEN','3018902','99734OH005000301','2014-02-01','2014-01-15 21:39:57','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:31'),(3447,2771,'Y','18','024','14','A','','','TE','0000501608','0000501608','','IL','1','Hammond','Hope',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-23','F','',NULL,NULL,NULL,'','1712911','','2013-12-21','2013-12-21 21:40:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:19:24'),(2195,1806,'N','01','021','EC','A',NULL,NULL,'','0000659881','0001236552','','IL','1','Brown','Roy','A','','','34','290524445','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1956-06-29','M','',':RET:2106-3','N','021','HLT','1255472','92036OH005002605','2014-01-01','2013-12-10 09:46:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.21',NULL,0,'2013-12-25 19:19:52'),(24042,19120,'Y','18','024','14','A','','','TE','0000546512','0000546512','','IL','1','Soutendijk','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-01','F','',NULL,NULL,NULL,'','2755005','','2014-02-15','2014-02-15 10:48:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:00:59'),(14057,11200,'Y','18','021','EC','A','','','AC','0001100602','0001100602','OH00001059459','IL','1','creamer','ryan','','','','34','284843745','767 worthington woods blvd.',0,'worthington','OH','43085',NULL,'CY','39049','1978-11-05','M','U',NULL,'N','021','DEN','1884594','99734OH005000301','2014-02-01','2013-12-26 16:22:50','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:27'),(21987,17558,'Y','18','021','EC','A','','','AC','0001372521','0001372521','LA00001869142','IL','1','Murray','Nicole','','','','34','437239315','5370 FAIRFIELDS AVE',0,'BATON ROUGE','LA','70806','1071','CY','22033','1970-11-01','F','U',':RET:2054-5','N','021','DEN','3760601','18575LA002000201','2014-03-01','2014-02-06 21:00:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-07 19:00:40'),(2062,1688,'Y','18','021','EC','A','','','AC','0000054443','0000054443','OH00001188976','IL','1','Jolliff','Heather','Renee','','','34','268804533','320 Liberty Street',0,'Ada','OH','45810',NULL,'CY','39065','1982-02-15','F','M',':RET:2106-3','N','021','DEN','364254','99734OH005000301','2014-01-01','2013-12-10 14:53:20','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,0,'2013-12-25 19:16:08'),(2935,2362,'N','01','021','EC','A',NULL,NULL,'','0001138022','0000258124','','IL','1','Raubenolt','Susan','Kay','','','34','295563369','276 TOWNSHIP ROAD 2450',0,'LOUDONVILLE','OH','44842','9624','CY','39005','1955-04-08','F','',':RET:2106-3','N','021','DEN','260208','99734OH005000401','2014-01-01','2013-12-05 22:42:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:16:05'),(17353,13883,'Y','18','021','EC','A','','','AC','0001884402','0001884402','LA00002203222','IL','1','Paul','Donna','','','','34','433022391','161 BELLE TRACE RD',0,'LECOMPTE','LA','71346','4730','CY','22079','1955-05-20','F','M',':RET:2106-3','N','021','DEN','1895743','18575LA002000101','2014-02-01','2014-01-10 11:12:28','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-01-13 02:24:09'),(15821,12665,'Y','18','021','EC','A','','','AC','0001190070','0001190070','OH00002195716','IL','1','Webb','Alice','K','','','34','285502899','3162 LIKENS RD',0,'MARION','OH','43302','8539','CY','39101','1952-10-09','F','U',NULL,'T','021','DEN','1623639','99734OH005000401','2014-02-01','2014-01-02 12:19:53','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2014-01-03 02:03:31'),(7960,6300,'Y','18','021','EC','A','','','AC','0001219757','0001219757','MS00000311376','IL','1','Irvin','Jametria','','','','34','587656338','613 BEAVERBROOK DR',0,'JACKSON','MS','39206','4418','CY','28049','1989-07-02','F','U',':RET:2054-5','N','021','DEN','1907202','46300MS002000201','2014-01-01','2013-12-19 20:44:58','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:25'),(3175,2553,'Y','18','021','EC','A','','','AC','0001064678','0001064678','OH00001209943','IL','1','murphy','lisa','','','','34','274782967','822 w bigelow ave',0,'findlay','OH','45840',NULL,'CY','39063','1976-06-24','F','M',':RET:2106-3','T','021','HLT','388834','92036OH004001501','2014-01-01','2013-11-18 11:07:11','0.00',NULL,NULL,'251.94','251.94','R-OH002','OH0','251.94',NULL,0,'2013-12-25 20:31:40'),(6639,5267,'Y','18','021','EC','A','','','AC','0000949471','0000949471','OH00000439422','IL','1','Zoslov','Pamela','Beth','','','34','278660248','2550 KEMPER RD',0,'SHAKER HEIGHTS','OH','44120','1269','CY','39035','1961-08-01','F','U',':RET:2106-3','N','021','HLT','694631','52664OH151001306','2014-01-01','2013-11-12 17:04:16','358.00',NULL,NULL,'490.97','132.97','R-OH011','OH0','490.97',NULL,0,'2013-12-26 01:00:16'),(3230,2600,'Y','18','024','14','A','','','TE','0000149312','0000149312','','IL','1','steffen','kathy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-10','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:46:02'),(3663,2930,'Y','18','021','EC','A','','','AC','0000054448','0000054448','OH00000288596','31','1','Schneider','Hazel','','','','34','409825180','P.O. Box 6074',0,'Oxford','OH','45056',NULL,'CY','39017','1950-12-13','F','M',':RET:2106-3','N','021','DEN','249521','99734OH005000401','2014-01-01','2013-12-12 20:21:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:30:56'),(26143,20729,'Y','18','021','EC','A','','','AC','0000983899','0000983899','OH00002055609','IL','1','DAVIS','DEBBY','','','','34','271580925','6632 NITRAM CT',0,'CINCINNATI','OH','45230','2842','CY','39061','1969-11-13','F','U',NULL,'N','021','DEN','3279911','99734OH005000401','2014-04-01','2014-02-27 12:43:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:26'),(28591,22626,'Y','18','021','EC','A','','','AC','0000586749','0000586749','OH00002913293','IL','1','knights','jennifer','','','','34','280827505','860 gaylord grove',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1971-01-27','F','U',':RET:2106-3','N','021','DEN','4262274','99734OH005000401','2014-04-01','2014-03-07 21:58:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-08 21:30:02'),(4441,3529,'N','01','021','EC','A',NULL,NULL,'','0000399863','0001241836','','IL','1','Buczkowski','Ryszard','','','','34','294801174','22627 MEADOWHILL LN',0,'ROCKY RIVER','OH','44116','2035','CY','39035','1969-09-05','M','',NULL,'N','021','DEN','624644','99734OH005000301','2014-01-01','2013-12-11 18:57:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:08'),(25713,20396,'N','01','021','EC','A',NULL,NULL,'','0000106646','0001218364','','IL','1','LIRA','ALFREDO','C','','','34','452636726','413 S ALBERTA ST',0,'PECOS','TX','79772',NULL,'CY','48389','1968-07-31','M','',NULL,'N','021','DEN','3736046','33348TX002000201','2014-04-01','2014-02-24 16:13:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:24'),(6414,5084,'Y','18','021','EC','A','','','AC','0000644652','0000644652','OH00000267324','IL','1','Harmon','Brittany','','','','34','300946809','378 W 4TH ST',0,'SEAMAN','OH','45679','9704','CY','39001','1992-07-24','F','U',':RET:2106-3','N','021','HLT','347240','92036OH003000605','2014-01-01','2013-12-10 18:35:35','139.00',NULL,NULL,'224.18','85.18','R-OH005','OH0','224.18',NULL,0,'2013-12-26 00:48:41'),(6929,5501,'Y','18','021','EC','A','','','AC','0000558150','0000558150','OH00000009221','IL','1','Rhodes','Elizabeth','','','','34','320869386','39 HOOPER ST',0,'ATHENS','OH','45701','3253','CY','39009','1983-04-11','F','U',':RET:2106-3','N','021','DEN','1630938','99734OH005000401','2014-01-01','2013-12-24 19:51:41','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 01:46:27'),(25639,20339,'Y','18','021','EC','A','','','AC','0001544103','0001544103','LA00001883192','31','1','Williamson','Cory','','','','34','435450285','PO Box 559',0,'Krotz Springs','LA','70750',NULL,'CY','22097','1981-08-17','M','U',':RET:2106-3','N','021','DEN','2955542','18575LA002000201','2014-04-01','2014-02-22 13:38:30','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 08:30:29'),(7625,6035,'Y','18','021','EC','A','','','AC','0000277944','0000277944','MS00001067183','31','1','halloway','dorothy','','','','34','587760754','p.o. box 2652',0,'Tunica','MS','38676',NULL,'CY','28143','1952-07-05','F','U',':RET:2054-5','N','021','DEN','13767','46300MS002000201','2014-01-01','2013-11-17 10:57:17','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-26 02:46:02'),(23930,19029,'Y','18','021','EC','A','','','AC','0000799917','0000799917','OH00002490572','IL','1','Buccino','Gina',NULL,NULL,NULL,NULL,NULL,'6408 INVERNESS WAY',0,'MASON','OH','45040','2054','CY','39165','1956-11-05','F','U',':RET:2106-3','N','021','DEN','3245407','99734OH005000401','2014-03-01','2014-02-15 07:45:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-15 21:00:03'),(15222,12168,'Y','18','021','EC','A','','','AC','0001455016','0001455016','LA00002004443','IL','1','Ducote','Troy','','','','34','438736018','9555 COMITE DR',0,'BAKER','LA','70714','6903','CY','22033','1989-03-15','M','U',':RET:2106-3','N','021','DEN','1377200','18575LA002000101','2014-02-01','2013-12-30 14:00:31','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-01 12:08:04'),(22892,18250,'N','17','021','EC','A',NULL,NULL,'','0000350609','0000332420','','IL','1','DeKay','Jeremy','','','','34','300966381','13555 NEAPOLIS WATERVILLE RD',0,'GRAND RAPIDS','OH','43522','9649','CY','39095','1994-06-18','M','',':RET:2106-3','N','021','HLT','2886147','92036OH003002604','2014-03-01','2014-02-11 13:16:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-11 21:02:37'),(2192,1804,'Y','18','021','EC','A','','','AC','0000142803','0000142803','OH00000383607','IL','1','Crosby','Debra','','','','34','287549643','5761 Lynne Clara Drive',0,'Milford','OH','45150',NULL,'CY','39025','1953-08-11','F','U',':RET:2106-3','N','021','HLT','104410','92036OH005000601','2014-01-01','2013-12-10 09:42:30','0.00',NULL,NULL,'582.60','582.60','R-OH005','OH0','582.60',NULL,0,'2013-12-25 19:19:47'),(15655,12525,'Y','18','021','EC','A','','','AC','0000901082','0000901082','OH00000535941','31','1','SHANK','BARBARA','','','','34','285802851','P.O. BOX 172',0,'WILLSHIRE','OH','45898',NULL,'CY','39161','1969-10-28','F','U',':RET:2106-3','N','021','HLT','2575044','92036OH005001505','2014-02-01','2013-12-31 10:20:38','249.00',NULL,NULL,'307.46','58.46','R-OH002','OH0','307.46',NULL,1,'2014-01-02 04:34:14'),(13911,11095,'N','01','021','EC','A',NULL,NULL,'','0000885590','0000076301','','IL','1','Dible','Rebbeca','J','','','34','504961493','7315 N Twp Rd 63',0,'Fostoria','OH','44830',NULL,'CY','39147','1967-05-17','F','',':RET:2106-3','N','021','HLT','1716328','92036OH005002705','2014-01-01','2013-12-23 13:52:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','292.49',NULL,0,'2013-12-26 13:13:57'),(5892,4672,'Y','18','021','EC','A','','','AC','0000057333','0000057333','OH00001310359','IL','1','Glover','Joseph','','','','34','290568569','3916 ARLINGTON RD',0,'UNIONTOWN','OH','44685','6951','CY','39153','1954-10-20','M','M',NULL,'N','021','DEN','1536883','99734OH005000301','2014-01-01','2013-12-23 22:58:08','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:49:39'),(13570,10823,'Y','18','021','EC','A','','','AC','0002367616','0002367616','LA00000336168','IL','1','tran','yen','n','','','34','433997392','148 32greenview circle',0,'west monroe','LA','71291',NULL,'CY','22073','1980-03-15','M','U',':RET:2047-9','N','021','DEN','1460546','18575LA002000201','2014-01-01','2013-12-23 17:01:09','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:04:39'),(27406,21694,'N','19','021','EC','A',NULL,NULL,'','0000195195','0001097832','','IL','1','Watkins','Matthew','Allan','','','34','274110431','20700 Wilmore Avenue',0,'Euclid','OH','44123',NULL,'CY','39035','2004-12-03','M','',':RET:2054-5','N','021','DEN','3485352','99734OH005000301','2014-04-01','2014-03-04 10:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:33'),(28770,22774,'Y','18','021','EC','A','','','AC','0001166866','0001166866','OH00002971633','IL','1','McLain','Whitney','','','','34','287862784','3390 FAIRWAY LN',0,'ZANESVILLE','OH','43701','1078','CY','39119','1987-08-18','F','U',':RET:2106-3','N','021','DEN','4309472','99734OH005000401','2014-04-01','2014-03-09 10:15:26','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-09 21:00:29'),(21569,17229,'N','01','021','EC','A',NULL,NULL,'','0001111693','0000136123','','IL','1','Shelton','Scott','','','','34','268647891','2405 Shadow Lane',0,'Stow','OH','44224',NULL,'CY','39153','1959-04-07','M','',':RET:2106-3','T','021','HLT','3517615','52664OH151001305','2014-03-01','2014-02-04 20:47:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','547.54',NULL,0,'2014-02-05 21:30:20'),(836,691,'N','01','021','EC','A',NULL,NULL,'','0000752056','0001130208','','IL','1','Kuhn','Jean','M','','','34','290460613','3801 SANDTRAP CIR',0,'MASON','OH','45040','2170','CY','39165','1961-09-26','F','',':RET:2106-3','N','021','HLT','350957','92036OH005001204','2014-01-01','2013-12-15 19:43:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','419.03',NULL,0,'2013-12-25 18:06:30'),(13352,10663,'Y','18','021','EC','A','','','AC','0000909825','0000909825','TX00000413520','IL','1','Pruitt','Elbert','','','','34','456510382','11381 COUNTY ROAD 2249',0,'TYLER','TX','75707','5309','CY','48423','1968-12-30','M','U',NULL,'N','021','DEN','1446693','33348TX002000201','2014-01-01','2013-12-23 19:21:04','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-26 12:59:13'),(889,736,'Y','18','021','EC','A','','','AC','0000279534','0000279534','OH00001193081','IL','1','Surharski','Presley','Sophia','','','34','271133119','982 S Beechgrove Rd',0,'Wilmington','OH','45177',NULL,'CY','39027','2006-11-06','F','R',':RET:2106-3','N','021','HLT','1834839','92036OH002000601','2014-01-01','2013-12-16 12:39:27','0.00',NULL,NULL,'157.43','157.43','R-OH005','OH0','157.43',NULL,0,'2013-12-25 18:07:57'),(13066,10414,'Y','18','021','EC','A','','','AC','0001241858','0001241858','OH00000869619','IL','1','Hudson-strahorn','Karen','','','','34','283642174','5188 FREE PIKE',0,'TROTWOOD','OH','45426','2305','CY','39113','1956-11-28','F','U',':RET:2054-5','N','021','DEN','1923806','99734OH005000401','2014-01-01','2013-12-23 09:34:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:51:10'),(3338,2676,'Y','18','021','EC','A','','','AC','0001083483','0001083483','TX00000524268','IL','1','Aguilar','Angelita','','','','34','457159622','219 N. Ave P',0,'Lubbock','TX','79401',NULL,'CY','48303','1956-04-19','F','U',NULL,'N','021','DEN','1639635','33348TX002000201','2014-01-01','2013-12-21 18:49:32','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 21:16:25'),(3319,2664,'Y','18','021','EC','A','','','AC','0001261205','0001261205','OH00000496321','IL','1','Cook-Gorsuch','Deborah','','','','34','270528970','300 MCMILLEN DR',0,'NEWARK','OH','43055','1815','CY','39089','1951-01-18','F','U',':RET:2106-3','N','021','DEN','1874896','99734OH005000301','2014-01-01','2013-12-22 14:51:58','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:16:01'),(1253,1033,'Y','18','021','EC','A','','','AC','0000998748','0000998748','OH00000204920','IL','1','Basher','Cern','','','','34','418336645','7858 WILD ORCHARD LN',0,'MONTGOMERY','OH','45242','4307','CY','39061','1970-11-25','M','R',':RET:2106-3','N','021','HLT','1103563','92036OH002001201','2014-01-01','2013-12-02 23:22:57','0.00',NULL,NULL,'639.34','639.34','R-OH004','OH0','336.41',NULL,0,'2013-12-25 18:21:18'),(9764,7731,'Y','18','021','EC','A','','','AC','0000157956','0000157956','OH00000044891','IL','1','Spears','Neda','','','','34','298746208','1734 W 28TH ST',0,'CLEVELAND','OH','44113','3049','CY','39035','1966-09-03','F','U',':RET:2054-5','T','021','DEN','388761','99734OH005000401','2014-01-01','2013-10-20 18:42:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 05:00:15'),(2871,2320,'N','01','021','EC','A',NULL,NULL,'','0000599175','0000998906','','IL','1','Sylvester','Dawn','','','','34','368561557','2414 FAIRWAY POINTE DR',0,'LEAGUE CITY','TX','77573','5551','CY','48167','1956-01-17','F','',NULL,'N','021','DEN','33202','33348TX002000201','2014-01-01','2013-10-21 19:43:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 20:01:56'),(22956,18302,'Y','18','021','EC','A','','','AC','0002255112','0002255112','LA00001553714','IL','1','Hall','MaryJo','','','','34','438238396','529 JEAN LAFITTE BLVD',0,'LAFITTE','LA','70067','5109','CY','22051','1963-02-27','F','U',':RET:2106-3','N','021','DEN','3448075','18575LA002000201','2014-03-01','2014-02-11 19:31:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-12 21:00:05'),(23809,18944,'N','01','021','EC','A',NULL,NULL,'','0000639566','0000927351','','IL','1','gipe','ann','lynn','','','34','288581697','6447 hampsher rd',0,'new franklin','OH','44216',NULL,'CY','39153','1956-09-30','F','',':RET:2106-3','N','021','HLT','3024252','52664OH152000901','2014-03-01','2014-02-13 19:25:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2014-02-14 21:31:34'),(25145,19947,'Y','18','021','EC','A','','','AC','0000784040','0000784040','TX00002702241','IL','1','SPARKS','ALICE','','','','34','461922207','135 WOODLAND TRL',0,'GUN BARREL CITY','TX','75156','3528','CY','48213','1950-05-26','F','M',':RET:2106-3','N','021','DEN','3700495','33348TX002000201','2014-04-01','2014-02-21 12:10:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:13'),(166,139,'N','19','021','EC','A',NULL,NULL,'','0000555348','0001063205','','IL','1','Brown II','Kevin','','','','34','277985724','2963 commdor lane',0,'cicinnatti','OH','45251',NULL,'CY','39061','1995-01-13','M','',':RET:2054-5','N','021','HLT','428114','92036OH004001201','2014-01-01','2013-12-05 17:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 17:19:19'),(927,769,'N','19','021','EC','A',NULL,NULL,'','0000115452','0000061283','','IL','1','Rini','Vincent','Nicholas','','','34','278174544','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','2011-06-07','M','',':RET:2106-3','N','021','DEN','19531','99734OH005000401','2014-01-01','2013-10-28 23:21:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:01'),(2120,1740,'Y','18','021','EC','A','','','AC','0000823487','0000823487','OH00000734145','IL','1','Maletz','Lisa','','','','34','270765572','1315 MADERIA DR',0,'WEST SALEM','OH','44287','9177','CY','39005','1969-10-17','F','R',':RET:2106-3','N','021','DEN','211121','99734OH005000401','2014-01-01','2013-12-10 13:26:33','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:17:41'),(2459,2000,'Y','18','021','EC','A','','','AC','0000540730','0000540730','TX00000110929','IL','1','Steinbach','Vicki','','','','34','450962940','6629 VICTORIA AVE',0,'NORTH RICHLAND HILLS','TX','76180','8113','CY','48439','1951-12-14','F','M',':RET:2106-3','N','021','DEN','125443','33348TX002000101','2014-01-01','2013-12-09 13:57:17','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:34:53'),(20773,16597,'Y','18','021','EC','A','','','AC','0000973811','0000973811','TX00001796894','IL','1','stephens','larry','','','','34','467067768','6058 F.M 9 south',0,'waskom','TX','75692',NULL,'CY','48203','1957-12-30','M','M',':RET:2054-5','N','021','DEN','3761483','33348TX002000201','2014-03-01','2014-01-31 18:09:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-31 21:00:05'),(2982,2400,'Y','18','024','14','A','','','TE','0000150617','0000150617','','IL','1','Cleghorn','John','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-15','M','',NULL,NULL,NULL,'','1224935','','2013-12-05','2013-12-05 21:45:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:17:14'),(5963,4721,'N','19','021','EC','A',NULL,NULL,'','0000599756','0000092518','','IL','1','Painter','August','V',NULL,NULL,NULL,NULL,'4333 Aaron Ct',0,'Cincinnati','OH','45241',NULL,'CY','39017','1998-05-22','M','',':RET:2106-3','N','021','HLT','1566099','92036OH005001201','2014-01-01','2013-12-23 22:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 23:51:24'),(5920,4688,'Y','18','021','EC','A','','','AC','0000131188','0000131188','TX00000278459','31','1','Washington','Lora','Lynn','','','34','439271776','P.O. Box 295395',0,'Lewisville','TX','75029',NULL,'CY','48121','1963-10-04','F','U',':RET:2054-5','N','021','DEN','1621033','33348TX002000101','2014-01-01','2013-12-24 00:35:28','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:15'),(5672,4500,'Y','18','021','EC','A','','','AC','0000087455','0000087455','OH00000072301','IL','1','taylor','michael','','','','34','289524672','508 SUNNYMEADE LN',0,'LIMA','OH','45804','3536','CY','39003','1953-10-28','M','M',':RET:2106-3','N','021','HLT','775331','92036OH005001505','2014-01-01','2013-11-25 20:27:00','908.00',NULL,NULL,'1049.32','141.32','R-OH002','OH0','597.30',NULL,0,'2013-12-25 23:32:04'),(4985,3959,'Y','18','021','EC','A','','','AC','0000136048','0000136048','OH00000897002','IL','1','Miller','Chana','','','','34','424086243','352 Enos Loomis st',0,'Pataskala','OH','43062',NULL,'CY','39089','1974-01-02','F','M',NULL,'N','021','DEN','667559','99734OH005000301','2014-01-01','2013-12-06 19:55:31','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:46:51'),(18790,14966,'Y','18','021','EC','A','','','AC','0000484818','0000484818','OH00001766532','IL','1','Stein','Matthew','','','','34','275981438','2824 RESEARCH BLVD',0,'KETTERING','OH','45420','3632','CY','39113','1994-11-29','M','U',':RET:2106-3','N','021','DEN','2327681','99734OH005000401','2014-02-01','2014-01-15 22:25:14','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-01-17 03:35:56'),(4027,3215,'Y','18','021','EC','A','','','AC','0000558134','0000558134','OH00001243181','IL','1','LEFFLER','DAVID','','','','34','288527239','17670 MURPHY RD.',0,'AMESVILLE','OH','45711',NULL,'CY','39009','1951-02-01','M','M',':RET:2106-3','N','021','DEN','2012691','99734OH005000401','2014-01-01','2013-12-17 09:10:26','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:45:48'),(7118,5648,'Y','18','021','EC','A','','','AC','0000167768','0000167768','OH00001050438','IL','1','Sharkey','Bart','','','','34','287840139','447 DARTMOUTH CIR',0,'CINCINNATI','OH','45244','1805','CY','39025','1970-05-06','M','M',':RET:2106-3','N','021','HLT','2559665','92036OH001000601','2014-01-01','2013-12-24 23:46:57','143.00',NULL,NULL,'702.76','559.76','R-OH005','OH0','351.38',NULL,0,'2013-12-26 01:51:15'),(7308,5792,'Y','18','021','EC','A','','','AC','0000647061','0000647061','OH00001228116','IL','1','Zemesarajs','Liga','','','','34','270664879','38 AVALON DR',0,'BEDFORD','OH','44146','2842','CY','39035','1958-01-07','F','U',':RET:2106-3','N','021','HLT','30379','52664OH151001305','2014-01-01','2013-12-14 17:00:50','300.00',NULL,NULL,'560.89','260.89','R-OH011','OH0','560.89',NULL,0,'2013-12-26 02:03:17'),(7735,6126,'Y','18','021','EC','A','','','AC','0000208487','0000208487','OH00000502565','IL','1','Kaufman','Mary','','','','34','297848783','912 HEATHERVIEW CT',0,'FINDLAY','OH','45840',NULL,'CY','39063','1976-12-21','F','M',NULL,'N','021','DEN','1989628','99734OH005000401','2014-01-01','2013-12-20 15:20:41','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-26 03:02:07'),(17551,14032,'Y','18','021','EC','A','','','AC','0000881643','0000881643','OH00001937641','IL','1','WHITE','JOANNE','','','','34','299585702','1268 ELEANOR AVE',0,'TOLEDO','OH','43612','2275','CY','39095','1958-04-07','F','U',':RET:2106-3','T','021','HLT','1766065','92036OH004002601','2014-02-01','2014-01-12 13:56:14','192.00',NULL,NULL,'402.10','210.10','R-OH001','OH0','402.10',NULL,0,'2014-01-13 03:01:54'),(17464,13966,'Y','18','021','EC','A','','','AC','0000631527','0000631527','OH00001934948','IL','1','Roberts','Jackie','','','','34','288467489','504 Robinson Ave',0,'Kenton','OH','43326',NULL,'CY','39065','1951-12-29','F','M',':RET:2106-3','N','021','DEN','1435030','99734OH005000301','2014-02-01','2014-01-11 18:38:54','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,0,'2014-01-13 03:01:04'),(14233,11351,'Y','18','024','14','A','','','TE','0000158440','0000158440','','IL','1','Skolnik','Randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-22','M','',NULL,NULL,NULL,'','2507919','','2013-12-25','2013-12-25 22:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-27 02:05:05'),(14466,11543,'Y','18','021','EC','A','','','AC','0000568991','0000568991','TX00000353816','IL','1','RODRIGUEZ','DEBORAH','','','','34','460792950','1138 BABCOCK RD',0,'SAN ANTONIO','TX','78201','6923','CY','48029','1965-09-29','F','U',':RET:2106-3','N','021','DEN','1523215','33348TX002000201','2014-02-01','2013-12-26 18:51:37','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-28 03:32:55'),(15212,12158,'Y','18','021','EC','A','','','AC','0000432769','0000432769','OH00001650355','IL','1','Quinter','Alicia','','','','34','274789959','440 Touvelle St',0,'Celina','OH','45822',NULL,'CY','39107','1980-09-15','F','U',':RET:2106-3','N','021','HLT','2405293','92036OH003001506','2014-02-01','2013-12-29 22:39:00','243.00',NULL,NULL,'275.33','32.33','R-OH002','OH0','275.33',NULL,0,'2014-01-01 12:07:44'),(16076,12874,'Y','18','021','EC','A','','','AC','0000603374','0000603374','OH00000266894','IL','1','Greene','Robert','','','','34','285940204','696 BRIGHT AVE',0,'VANDALIA','OH','45377','1542','CY','39113','1987-12-26','M','R',':RET:2106-3','N','021','DEN','2600623','99734OH005000401','2014-02-01','2014-01-03 13:11:47','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:03:56'),(22992,18330,'Y','18','021','EC','A','','','AC','0000011198','0000011198','OH00002666456','IL','1','Polmanteer','Logan','','','','34','089767165','916 S MAIN ST',0,'ENGLEWOOD','OH','45322','2815','CY','39113','1985-03-04','F','U',NULL,'N','021','DEN','2813319','99734OH005000301','2014-03-01','2014-02-12 15:46:36','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-12 21:30:14'),(23924,19025,'Y','18','021','EC','A','','','AC','0000614154','0000614154','OH00001859279','IL','1','Gay','Rodney','','','','34','273589879','2600 EDGEBROOK AVE',0,'AKRON','OH','44312','1569','CY','39153','1957-05-26','M','M',':RET:2106-3','N','021','DEN','3478244','99734OH005000401','2014-03-01','2014-02-14 17:06:27','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00','CIC',0,'2014-02-14 22:00:08'),(25384,20139,'Y','18','021','EC','A','','','AC','0001207207','0001207207','OH00002852098','IL','1','Zornes','Sharon','','','','34','288543094','1211 WOODS DR',0,'TALLMADGE','OH','44278','3357','CY','39153','1953-10-04','F','M',':RET:2106-3','N','021','HLT','3706989','52664OH151001304','2014-04-01','2014-02-24 18:31:29','316.00',NULL,NULL,'605.24','289.24','R-OH012','OH0','605.24',NULL,0,'2014-02-25 21:30:48'),(305,251,'Y','18','021','EC','A','','','AC','0000150613','0000150613','OH00000150910','IL','1','Patrick','Suzanne','','','','34','291441474','724 Fountain Abbey Pl',0,'Miamisburg','OH','45342',NULL,'CY','39113','1950-08-28','F','M',':RET:2106-3','N','021','DEN','1044594','99734OH005000301','2014-01-01','2013-11-13 10:09:08','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:30:53'),(2072,1696,'N','01','021','EC','A',NULL,NULL,'','0000753105','0000048421','','IL','1','Pierce','Diane','K','','','34','431119396','30785 PIERCE LN',0,'TICKFAW','LA','70466','4083','CY','22105','1954-12-07','F','',':RET:2106-3','N','021','DEN','914687','18575LA002000201','2014-01-01','2013-12-09 20:02:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:16:23'),(19427,15487,'Y','18','021','EC','A','','','AC','0000646023','0000646023','OH00001580657','IL','1','Mercer','Christopher','','','','34','501788467','1809 N BLANCHARD ST',0,'FINDLAY','OH','45840','4506','CY','39063','1975-08-14','M','M',':RET:2106-3','T','021','HLT','2445484','92036OH003001506','2014-03-01','2014-01-21 10:31:15','499.00',NULL,NULL,'642.03','143.03','R-OH002','OH0','329.35',NULL,1,'2014-01-22 03:23:05'),(19208,15303,'Y','18','024','14','A','','','TE','0001204560','0001204560','','IL','1','Jacobs','Margarite',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-20','F','',NULL,NULL,NULL,'','2085421','','2014-01-19','2014-01-19 21:16:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:20'),(14118,11252,'Y','18','021','EC','A','','','AC','0000474979','0000474979','OH00001724794','IL','1','Pacheco','Juan','','','','34','625163166','1214 POPLAR HILL DR',0,'LEBANON','OH','45036','8563','CY','39165','1964-04-24','M','M',NULL,'T','021','DEN','2555638','99734OH005000401','2014-02-01','2013-12-26 15:16:17','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:02:02'),(24559,19508,'Y','18','021','EC','A','','','AC','0000777708','0000777708','OH00003014762','IL','1','Parker','Robert','','','','34','289829447','518 E SANDUSKY ST',0,'FINDLAY','OH','45840','5920','CY','39063','1984-12-11','M','U',':RET:2106-3','T','021','DEN','3070959','99734OH005000301','2014-04-01','2014-02-18 20:44:05','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-20 04:05:56'),(28839,22821,'N','01','021','EC','A',NULL,NULL,'','0000830701','0000109327','','IL','1','Tolbert','Juanita','','','','34','269600983','1029 S 2ND ST',0,'HAMILTON','OH','45011','3133','CY','39017','1955-10-08','F','',NULL,'N','021','HLT','3587781','92036OH006001201','2014-04-01','2014-03-09 14:08:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','433.78',NULL,0,'2014-03-09 21:01:11'),(19837,15820,'Y','18','021','EC','A','','','AC','0002035565','0002035565','LA00002157441','IL','1','brooks','sonja','','','','34','439238495','718 CENTRAL AVE',0,'JEFFERSON','LA','70121','1340','CY','22051','1964-12-19','F','U',':RET:2054-5','N','021','DEN','3081691','18575LA002000201','2014-03-01','2014-01-24 11:03:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-24 21:00:23'),(6952,5521,'Y','18','021','EC','A','','','AC','0001114541','0001114541','OH00000246298','IL','1','Christoff','Donald','','','','34','301467074','155 EAGLES PT W',0,'LIMA','OH','45805','2849','CY','39003','1949-06-16','M','U',':RET:2106-3','N','021','DEN','1608250','99734OH005000401','2014-01-01','2013-12-24 21:13:17','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 01:47:04'),(16987,13596,'Y','18','021','EC','A','','','AC','0000749154','0000749154','TX00001936365','IL','1','Corso','Ashley','','','','34','641051335','2711 WILCREST DR',0,'AUSTIN','TX','78748','5118','CY','48453','1982-10-05','F','U',':RET:2106-3','N','021','DEN','2254724','33348TX002000101','2014-02-01','2014-01-09 14:48:13','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-13 02:20:22'),(770,636,'Y','18','021','EC','A','','','AC','0000341374','0000341374','TX00000442484','IL','1','Zulueta','Tammy','Marie','','','34','456750624','110 E Hawkins Pkwy',0,'Longview','TX','75605',NULL,'CY','48183','1968-10-29','F','U',':RET:2106-3','T','021','DEN','1490541','33348TX002000201','2014-01-01','2013-12-16 12:33:57','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:04:48'),(9541,7561,'Y','18','021','EC','A','','','AC','0001032604','0001032604','OH00001102452','IL','1','Jones-Stamets','Thea','M','','','34','289606680','3440 ARNSBY RD',0,'COLUMBUS','OH','43232','5912','CY','39049','1976-10-13','F','R',':RET:2106-3','N','021','DEN','1404225','99734OH005000301','2014-01-01','2013-12-21 11:43:56','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:36:01'),(13148,10488,'Y','18','021','EC','A','','','AC','0000317325','0000317325','OH00001136462','IL','1','Niedzialkowski','Carole','','','','34','318905271','4136 Florida ave',0,'Cincinnati','OH','45223',NULL,'CY','39061','1972-02-27','F','U',':RET:2106-3','T','021','DEN','1573530','99734OH005000401','2014-01-01','2013-12-23 16:29:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:31'),(14186,11311,'Y','18','021','EC','A','','','AC','0000066914','0000066914','TX00000744192','IL','1','HILL','EARL','','','','34','435765363','13100 PANDORA DR',0,'DALLAS','TX','75238','4048','CY','48113','1950-11-10','M','U',NULL,'N','021','DEN','1501130','33348TX002000201','2014-02-01','2013-12-26 11:44:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-27 02:03:51'),(14569,11624,'Y','18','021','EC','A','','','AC','0000640938','0000640938','OH00000512516','IL','1','Duskin','Sonja','','','','34','285866545','7718 Hamilton Ave',0,'Cincinnati','OH','45231',NULL,'CY','39061','1972-12-09','F','R',':RET:2054-5','N','021','HLT','1836614','92036OH006001201','2014-02-01','2013-12-27 17:06:45','0.00',NULL,NULL,'221.66','221.66','R-OH004','OH0','221.66',NULL,0,'2013-12-28 03:35:28'),(14909,11911,'Y','18','021','EC','A','','','AC','0001025504','0001025504','OH00000587829','IL','1','Savich','Charise','','','','34','268782548','724 INDIANA AVE',0,'NILES','OH','44446','1040','CY','39155','1975-03-14','F','M',':RET:2106-3','N','021','DEN','2091083','99734OH005000401','2014-02-01','2013-12-28 19:10:34','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-30 00:01:24'),(20534,16408,'Y','18','024','14','A','','','TE','0001083110','0001083110','','IL','1','Stiles','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-07-02','F','',NULL,NULL,NULL,'','2744887','','2014-01-28','2014-01-28 23:07:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:32'),(24351,19340,'Y','18','024','14','A','','','TE','0000012910','0000012910','','IL','1','JOHNSON','ROBERT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-02','M','',NULL,NULL,NULL,'','3530728','','2014-02-18','2014-02-18 17:44:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-18 22:00:27'),(24564,19510,'Y','18','021','EC','A','','','AC','0001228107','0001228107','OH00001668830','IL','1','Wingo','Cerra','','','','34','283845987','750 MULL AVE',0,'AKRON','OH','44313','7561','CY','39153','1985-11-27','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2914145','99734OH005000301','2014-04-01','2014-02-18 20:59:47','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-20 04:06:40'),(25006,19831,'Y','18','021','EC','A','','','AC','0001071837','0001071837','OH00002555482','IL','1','ESCRIBANO','GIOVANNY','FRANCISCO','','','34','597204898','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1974-01-28','M','M',NULL,'N','021','HLT','3814806','52664OH151001304','2014-04-01','2014-02-20 14:21:15','330.00',NULL,NULL,'616.31','286.31','R-OH013','OH0','323.20',NULL,0,'2014-02-20 22:00:49'),(26374,20922,'Y','18','021','EC','A','','','AC','0000237638','0000237638','OH00002664441','IL','1','Neher','Christina','','','','34','301603625','3395 SPENCE RD',0,'NEW CARLISLE','OH','45344','8120','CY','39023','1971-12-06','F','U',':RET:2106-3','N','021','DEN','3411889','99734OH005000401','2014-03-01','2014-02-26 17:15:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00','CIC',0,'2014-02-28 07:00:14'),(28943,22904,'Y','18','021','EC','A','','','AC','0001515331','0001515331','LA00002777191','IL','1','Stipe','Arlene','','','','34','437904479','2004 CARMEL VALLEY DR',0,'LA PLACE','LA','70068','1816','CY','22095','1951-01-13','F','U',':RET:2054-5','N','021','DEN','3793242','18575LA002000201','2014-04-01','2014-03-09 19:30:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:44'),(19860,15841,'Y','18','024','14','A','','','TE','0000876493','0000876493','','IL','1','BAREHERENY','TILBRUN','JR',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-12-28','M','',NULL,NULL,NULL,'','2480685','','2014-01-24','2014-01-24 10:11:18',NULL,NULL,NULL,NULL,NULL,NULL,'FL0',NULL,'CANCEL',0,'2014-01-24 21:00:35'),(18307,14616,'Y','18','021','EC','A','','','AC','0000685868','0000685868','OH00001488232','IL','1','Elliott','Kimberely','','','','34','300681216','23455 SNELL RD',0,'COLUMBIA STATION','OH','44028','9628','CY','39093','1970-05-04','F','M',':RET:2106-3','N','021','DEN','1368498','99734OH005000401','2014-02-01','2014-01-15 10:56:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:00'),(18082,14441,'N','01','021','EC','A',NULL,NULL,'','0001344237','0002270833','','IL','1','Miles','Cindy','Faye','','','34','437081809','1640 Lauderdale WoodYard Rd.',0,'Kinder','LA','70648',NULL,'CY','22003','1960-04-11','F','',':RET:2054-5','N','021','DEN','2061284','18575LA002000201','2014-02-01','2014-01-14 11:09:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:27'),(15426,12341,'Y','18','021','EC','A','','','AC','0000167619','0000167619','TX00001270996','IL','1','DYE','ASHLEY','KYM','','','34','636107413','2916 HAROLDS COURT',0,'ALVARADO','TX','76009',NULL,'CY','48251','1987-07-27','F','M',':RET:2106-3','N','021','DEN','1655395','33348TX002000201','2014-02-01','2013-12-31 11:53:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:27:36'),(2880,2327,'Y','18','021','EC','A','','','AC','0000396975','0000396975','TX00000946677','IL','1','Withers','Courtney','','','','34','316043141','2427 17TH AVE',0,'CANYON','TX','79015','5555','CY','48381','1988-09-16','F','U',NULL,'N','021','DEN','959308','33348TX002000201','2014-01-01','2013-10-08 11:27:51','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 20:02:11'),(23903,19014,'Y','18','021','EC','A','','','AC','0000013825','0000013825','OH00002474069','IL','1','Markley','Roger','','','','34','279645494','2122 Whitechapel',0,'Toledo','OH','43614',NULL,'CY','39095','1963-06-23','M','U',':RET:2106-3','N','021','HLT','3278403','92036OH005002606','2014-03-01','2014-02-14 10:52:47','301.00',NULL,NULL,'348.25','47.25','R-OH001','OH0','348.25',NULL,0,'2014-02-14 21:32:25'),(24519,19477,'Y','18','021','EC','A','','','AC','0001239551','0001239551','TX00002060332','IL','1','DUGAN','KRISTY','','','','34','628039309','11809 BOBCAT DR',0,'FORT WORTH','TX','76244','5516','CY','48439','1974-05-18','F','U',':RET:2106-3','N','021','DEN','2979062','33348TX002000201','2014-04-01','2014-02-19 13:19:34','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:56:23'),(26328,20888,'Y','18','021','EC','A','','','AC','0000757699','0000757699','MS00002583078','IL','1','LI','YONG','TONG','','','34','245891354','10101 IROQUOIS AVE',0,'OCEAN SPRINGS','MS','39564','3535','CY','28059','1978-08-26','M','U',':RET:2034-7','N','021','DEN','2724788','46300MS002000101','2014-04-01','2014-02-27 16:33:54','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-28 06:31:39'),(28655,22675,'Y','18','021','EC','A','','','AC','0002167223','0002167223','LA00003051730','IL','1','KELLEY','DERRICK','','','','34','193560407','417 Westwood Drive',0,'Marrero','LA','70072',NULL,'CY','22051','1970-04-05','M','U',NULL,'N','021','DEN','3657542','18575LA002000201','2014-04-01','2014-03-08 08:45:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:40'),(17140,13716,'Y','18','021','EC','A','','','AC','0001068282','0001068282','OH00001534052','IL','1','byrdlll','bayne','','','','34','279724323','1805 BROWNSTONE BLVD',0,'TOLEDO','OH','43614','1396','CY','39095','1970-03-25','M','U',NULL,'N','021','HLT','1987969','92036OH006002601','2014-02-01','2014-01-08 14:09:50','52.50',NULL,NULL,'209.85','157.35','R-OH001','OH0','209.85',NULL,0,'2014-01-13 02:21:51'),(5206,4132,'Y','18','021','EC','A','','','AC','0000197143','0000197143','OH00000838604','IL','1','CASTON','ANNE','','','','34','284729234','2042 DEMING ST',0,'CUYAHOGA FALLS','OH','44221','4132','CY','39153','1960-12-28','F','U',':RET:2106-3','N','021','DEN','2499238','99734OH005000401','2014-01-01','2013-12-19 15:12:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:04:10'),(6890,5466,'Y','18','021','EC','A','','','AC','0001433965','0001433965','LA00001586994','IL','1','Wright','Belinda','','','','34','434151699','2101 ROSE DR',0,'GRETNA','LA','70053','7427','CY','22051','1958-09-04','F','M',':RET:2054-5','N','021','DEN','2261571','18575LA002000201','2014-01-01','2013-12-24 20:41:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:21'),(14848,11856,'Y','18','021','EC','A','','','AC','0000629245','0000629245','OH00000183979','IL','1','Miller','Barbara','','','','34','298506070','4617 STEEPLECHASE DR',0,'BATAVIA','OH','45103','9201','CY','39025','1951-03-12','F','M',':RET:2106-3','N','021','HLT','2488127','92036OH002000601','2014-01-01','2013-12-23 20:37:58','298.00',NULL,NULL,'712.24','414.24','R-OH005','OH0','712.24',NULL,1,'2013-12-29 11:15:00'),(7901,6246,'Y','18','021','EC','A','','','AC','0000044264','0000044264','OH00000501268','IL','1','Reed','Gary','','','','34','268527805','140 KESWICK DR',0,'MONROE','OH','45050','1457','CY','39017','1951-09-09','M','M',':RET:2106-3','N','021','HLT','1668379','92036OH003001201','2014-01-01','2013-12-19 19:13:27','487.00',NULL,NULL,'1167.08','680.08','R-OH004','OH0','644.07',NULL,0,'2013-12-26 03:05:48'),(22439,17917,'Y','18','021','EC','A','','','AC','0000426395','0000426395','TX00002059029','IL','1','EXCELL','DEBRA','','','','34','547496639','110 MUSTANG TRL',0,'SHADY SHORES','TX','76208','5104','CY','48121','1961-09-08','F','M',NULL,'N','021','DEN','3763996','33348TX002000201','2014-03-01','2014-02-10 11:35:03','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:41'),(23188,18489,'Y','18','024','14','A','','','TE','0000037047','0000037047','','IL','1','Lenahan','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-04-21','F','',NULL,NULL,NULL,'','2640259','','2014-02-11','2014-02-11 22:01:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:32:02'),(23210,18504,'N','19','021','EC','A',NULL,NULL,'','0000196137','0000122976','','IL','1','Gelter','Trevor','J','','','34','296040792','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','2000-03-17','M','',':RET:2106-3','N','021','HLT','2825581','92036OH004000601','2014-03-01','2014-02-12 14:33:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-12 21:32:13'),(25163,19959,'N','01','021','EC','A',NULL,NULL,'','0001225760','0000834507','','IL','1','Decker','Hannah','','','','34','279869719','257 STERLING AVE',0,'RITTMAN','OH','44270','1269','CY','39169','1986-05-23','F','',':RET:2106-3','N','021','DEN','3113285','99734OH005000401','2014-04-01','2014-02-20 21:46:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:23'),(28383,22458,'Y','18','021','EC','A','','','AC','0000420082','0000420082','OH00003766958','IL','1','RAMSEY','JACQUELYN','D','','','34','285601605','1194 BIG FALLS AVE',0,'AKRON','OH','44310','1134','CY','39153','1961-01-24','F','U',':RET:2106-3','N','021','HLT','3025864','52664OH152000901','2014-04-01','2014-03-07 14:53:19','189.00',NULL,NULL,'436.93','247.93','R-OH012','OH0','333.21',NULL,0,'2014-03-07 21:30:41'),(20123,16056,'Y','18','024','14','A','','','TE','0000703789','0000703789','','IL','1','Koch','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-08-07','F','',NULL,NULL,NULL,'','2214734','','2014-01-27','2014-01-27 10:19:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:47'),(6039,4782,'N','01','021','EC','A',NULL,NULL,'','0000333094','0000979237','','IL','1','Huynh','Nga','','','','34','433456699','280 WYLIE DR',0,'BATON ROUGE','LA','70808','5572','CY','22033','1959-11-10','F','',':RET:2047-9','N','021','DEN','95725','18575LA002000101','2014-01-01','2013-11-30 21:00:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 00:01:21'),(15044,12026,'Y','18','021','EC','A','','','AC','0001767784','0001767784','LA00000994322','IL','1','MARTINEZ','JOSE','A','','','34','439311306','3237 DARTMOUTH ST',0,'KENNER','LA','70065','4001','CY','22051','1967-03-11','M','M',NULL,'N','021','DEN','2200028','18575LA002000201','2014-02-01','2013-12-30 13:37:41','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:03:04'),(5119,4056,'N','01','021','EC','A',NULL,NULL,'','0000749035','0000585492','','IL','1','Schoonover','Jannis','O','','','34','460924858','8304 HIGHWAY 70',0,'PAMPA','TX','79065','1753','CY','48179','1953-08-21','F','',':RET:2106-3','N','021','DEN','2039307','33348TX002000201','2014-01-01','2013-12-19 18:30:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:54'),(9445,7492,'N','01','021','EC','A',NULL,NULL,'','0001220830','0000244973','','IL','1','KAMIYA','HAKIZIMANA','','','','34','641580138','4195 GREENSBURY DR',0,'NEW ALBANY','OH','43054','9107','CY','39049','1967-09-03','M','',':RET:2054-5','N','021','DEN','1743204','99734OH005000401','2014-01-01','2013-12-20 19:08:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:33:48'),(4523,3584,'Y','18','021','EC','A','','','AC','0000798092','0000798092','TX00000180584','IL','1','Newton','Marc','','','','34','602056141','10028 SPRUCE RIDGE DR',0,'CONVERSE','TX','78109','2740','CY','48029','1982-09-02','M','U',':RET:2106-3','T','021','DEN','707083','33348TX002000201','2014-01-01','2013-12-12 14:02:51','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 22:03:53'),(26237,20809,'Y','18','021','EC','A','','','AC','0000287264','0000287264','TX00003163953','IL','1','Tukdi','Mohammad Ali','Hameed','','','34','348827191','17310 ABACO HARBOUR LN',0,'ROUND ROCK','TX','78664','7242','CY','48453','1967-10-23','M','M',':RET:2028-9','N','021','DEN','3401825','33348TX002000201','2014-04-01','2014-02-27 09:16:00','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-28 06:31:03'),(28117,22252,'N','01','021','EC','A',NULL,NULL,'','0000841983','0000231572','','IL','1','Cutlip','Linda','','','','34','293621403','766 Caddo Ave',0,'Akron','OH','44305',NULL,'CY','39153','1954-09-18','F','',':RET:2106-3','T','021','HLT','3308116','52664OH152000901','2014-04-01','2014-03-06 17:40:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','488.95',NULL,0,'2014-03-06 21:02:18'),(28535,22584,'Y','18','021','EC','A','','','AC','0000644739','0000644739','OH00003538911','IL','1','Lawson','Edward','','','','34','278563794','4525 Prices Creek Rd',0,'Lewisburg','OH','45338',NULL,'CY','39135','1953-05-26','M','M',':RET:2106-3','N','021','HLT','3496288','92036OH005000505','2014-05-01','2014-03-07 12:13:21','426.00',NULL,NULL,'645.13','219.13','R-OH003','OH0','645.13',NULL,0,'2014-03-07 21:32:10'),(16689,13355,'Y','18','021','EC','A','','','AC','0001230817','0001230817','TX00000682903','IL','1','baker','richard','','','','34','467270364','2400 REDBROOK CT',0,'ARLINGTON','TX','76014','2826','CY','48439','1961-07-28','M','U',':RET:2106-3','N','021','DEN','2474538','33348TX002000201','2014-02-01','2014-01-07 10:23:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-08 18:24:34'),(721,596,'Y','18','021','EC','A','','','AC','0000458073','0000458073','TX00000166673','IL','1','Shofner','Chance','','','','34','463697196','5310 RICHARD DR',0,'BEAUMONT','TX','77708','1924','CY','48245','1975-04-06','M','R',':RET:2106-3','N','021','DEN','1588574','33348TX002000101','2014-01-01','2013-12-16 08:32:59','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2013-12-25 18:03:28'),(16267,13024,'N','19','021','EC','A',NULL,NULL,'','0000600811','0000120104','','IL','1','Jones','Samuel','','','','34','891202870','4940 COLUMBIA CIR',0,'WEST CHESTER','OH','45011','9761','CY','39017','2013-10-17','M','',':RET:2106-3','N','021','DEN','2399552','99734OH005000401','2014-02-01','2014-01-06 15:14:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:10'),(13221,10548,'Y','18','021','EC','A','','','AC','0000856983','0000856983','TX00000235837','IL','1','Kang','Ik',NULL,NULL,NULL,NULL,NULL,'2402 LITTLER CT',0,'LAREDO','TX','78045','8150','CY','48479','1959-06-16','M','M',':RET:2040-4','N','021','DEN','1820010','33348TX002000201','2014-01-01','2013-12-22 19:22:32','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2013-12-26 12:55:29'),(2658,2160,'Y','18','021','EC','A','','','AC','0000912924','0000912924','OH00000673171','IL','1','Khramova','Ellina','','','','34','296117697','2706 SULGRAVE RD',0,'SHAKER HEIGHTS','OH','44122','2328','CY','39035','1964-09-04','F','U',':RET:2106-3','N','021','DEN','772984','99734OH005000301','2014-01-01','2013-12-01 23:53:25','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:46:48'),(5472,4346,'N','19','021','EC','A',NULL,NULL,'','0001046832','0000433879','','IL','1','Fasih','Zehra','','','','34','605043060','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','1997-12-31','F','',':RET:2028-9','N','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-25 23:10:40'),(7630,6039,'Y','18','021','EC','A','','','AC','0000377421','0000377421','OH00000686823','IL','1','Crain','Darrell','','','','34','285749790','2305 GRAND BLVD',0,'HAMILTON','OH','45011','4519','CY','39017','1979-04-02','M','U',NULL,'N','021','DEN','1034287','99734OH005000401','2014-01-01','2013-10-14 10:20:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:46:12'),(3751,3001,'Y','18','021','EC','A','','','AC','0000485233','0000485233','TX00000030005','IL','1','Moreno','Francisco','','','','34','451982648','222 PIKE RD',0,'SAN ANTONIO','TX','78209','3515','CY','48029','1956-10-08','M','M',':RET:2500-7','N','021','DEN','754970','33348TX002000201','2014-01-01','2013-12-13 16:06:15','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 21:33:09'),(25433,20180,'Y','18','021','EC','A','','','AC','0000472051','0000472051','TX00002943874','IL','1','Lopez','Elias','','','','34','512338661','5004 TRIPLEX BLVD',0,'EL PASO','TX','79938','8843','CY','48141','1978-04-20','M','M',NULL,'N','021','DEN','3301936','33348TX002000201','2014-04-01','2014-02-24 22:04:31','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-25 21:31:16'),(27891,22064,'Y','18','021','EC','A','','','AC','0000234116','0000234116','OH00003063829','IL','1','Hart','Marcia',NULL,NULL,NULL,NULL,NULL,'137 Ruth Ellen Drive',0,'Richmond Heights','OH','44143',NULL,'CY','39035','1957-12-02','F','U',NULL,'N','021','HLT','4074944','92036OH003000805','2014-04-01','2014-03-05 13:03:28','369.00',NULL,NULL,'569.61','200.61','R-OH011','OH0','569.61',NULL,0,'2014-03-05 21:32:39'),(28833,22819,'Y','18','021','EC','A','','','AC','0000519015','0000519015','MS00003347324','IL','1','WILLIAMS','RENA','','','','34','425351554','206 VANDERGRIFF ST',0,'JACKSON','MS','39209','5035','CY','28049','1971-09-25','F','U',':RET:2054-5','N','021','DEN','4310500','46300MS002000201','2014-04-01','2014-03-09 16:26:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-09 21:01:08'),(19021,15148,'Y','18','021','EC','A','','','AC','0000341238','0000341238','MS00001949042','IL','1','Reynolds','Tony','','','','34','508809014','1605 N. West St.',0,'Jackson','MS','39202',NULL,'CY','28049','1959-03-17','M','U',':RET:2054-5','N','021','DEN','3046392','46300MS002000101','2014-03-01','2014-01-17 11:28:20','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-20 08:06:26'),(7218,5721,'Y','18','024','14','A','','','TE','0000690707','0000690707','','IL','1','Sarisky','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-03','M','',NULL,NULL,NULL,'','1239419','','2013-12-14','2013-12-14 12:07:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:01:05'),(887,734,'Y','18','021','EC','A','','','AC','0000621102','0000621102','OH00000469174','IL','1','Jivoin','John','','','','34','300420021','5528 SURREY AVE',0,'CINCINNATI','OH','45248','4306','CY','39061','1950-03-26','M','U',':RET:2106-3','N','021','HLT','2036262','92036OH002001201','2014-01-01','2013-12-16 11:42:10','226.00',NULL,NULL,'731.81','505.81','R-OH004','OH0','731.81',NULL,0,'2013-12-25 18:07:53'),(15654,12524,'Y','18','021','EC','A','','','AC','0000088568','0000088568','OH00000063199','IL','1','Hong','Ho Soon','','','','34','289112800','829 BITTERBRUSH LN',0,'FINDLAY','OH','45840','7101','CY','39063','1957-07-30','F','M',':RET:2040-4','N','021','HLT','1482897','92036OH005001506','2014-02-01','2013-12-30 21:22:15','483.00',NULL,NULL,'513.45','30.45','R-OH002','OH0','513.45',NULL,1,'2014-01-02 04:34:13'),(5010,3972,'N','19','021','EC','A',NULL,NULL,'','0000581452','0000079883','','IL','1','watkins','veronica','','','','34','299041995','4816 forest glen trail',0,'ravenna','OH','44266',NULL,'CY','39133','2000-06-06','F','',':RET:2106-3','N','021','DEN','598783','99734OH005000301','2014-01-01','2013-12-07 17:19:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:19'),(5495,4362,'Y','18','021','EC','A','','','AC','0000384387','0000384387','OH00000600233','IL','1','Caryl Ropp','Paul','','','','34','299600761','53 MUTUAL UNION RD N',0,'CABLE','OH','43009','9607','CY','39021','1963-12-13','M','U',':RET:2106-3','N','021','HLT','1371630','92036OH002000501','2014-01-01','2013-12-19 14:11:15','228.00',NULL,NULL,'490.27','262.27','R-OH003','OH0','490.27',NULL,0,'2013-12-25 23:11:09'),(18104,14460,'N','01','021','EC','A',NULL,NULL,'','0001770496','0001908292','','IL','1','smith','william','g','','','34','434476992','320 PRAIRIE RD',0,'COLUMBIA','LA','71418','3442','CY','22021','1968-10-30','M','',':RET:2106-3','N','021','DEN','1889268','18575LA002000201','2014-02-01','2014-01-14 16:42:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:34'),(17868,14274,'Y','18','021','EC','A','','','AC','0000132092','0000132092','OH00002160476','IL','1','SURGEN','SUSAN','','','','34','268521650','2500 INCOME DR',0,'AKRON','OH','44305','2223','CY','39153','1951-10-29','F','M',':RET:2106-3','N','021','DEN','1461159','99734OH005000401','2014-02-01','2014-01-14 13:10:46','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:13'),(16430,13146,'Y','18','021','EC','A','','','AC','0001662948','0001662948','LA00001387356','IL','1','COLBERT','TINICA','L','','','34','435415148','3323 DARIEN ST',0,'SHREVEPORT','LA','71109','2610','CY','22017','1980-07-10','F','U',NULL,'N','021','DEN','2118920','18575LA002000101','2014-02-01','2014-01-06 13:51:51','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-07 04:04:46'),(15588,12475,'Y','18','024','14','A','','','TE','0000540299','0000540299','','IL','1','Mecklenborg','Evan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-07-19','M','',NULL,NULL,NULL,'','2321841','','2013-12-30','2013-12-30 23:07:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:23'),(7466,5908,'Y','18','021','EC','A','','','AC','0001105512','0001105512','OH00001011508','IL','1','Garland','Wendy','','','','34','274760166','1941 STARBRIDGE CT',0,'COLUMBUS','OH','43235','1876','CY','39049','1964-10-09','F','U',':RET:2106-3','N','021','DEN','450657','99734OH005000401','2014-01-01','2013-12-14 19:06:22','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:03'),(15093,12064,'Y','18','021','EC','A','','','AC','0000025302','0000025302','OH00001885951','IL','1','Le','Quang','','','','34','500983241','6756 WINDING CV',0,'CENTERVILLE','OH','45459','6913','CY','39113','1969-07-20','M','M',':RET:2047-9','T','021','DEN','2260489','99734OH005000301','2014-02-01','2013-12-29 22:07:44','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-01 12:04:30'),(22743,18157,'Y','18','024','14','A','','','TE','0002180108','0002180108','','IL','1','Burford','Carrie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-25','F','',NULL,NULL,NULL,'','1811497','','2014-02-26','2014-02-11 17:16:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-11 21:01:21'),(27372,21674,'N','19','021','EC','A',NULL,NULL,'','0000890773','0000152921','','IL','1','Washington','Hausentio','','','','34','587693505','404 Spruce Street',0,'Moorhead','MS','38761',NULL,'CY','28133','1990-10-25','M','',':RET:2054-5','N','021','DEN','3887008','46300MS002000101','2014-04-01','2014-03-03 23:30:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-04 21:01:17'),(27587,21817,'Y','18','024','14','A','','','TE','0000399766','0000399766','','IL','1','Pasaret','Adrian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-03-05','M','',NULL,NULL,NULL,'','3236100','','2014-03-05','2014-03-05 12:23:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-05 21:00:15'),(21724,17347,'N','01','021','EC','A',NULL,NULL,'','0000060567','0000847370','','IL','1','Pope','James','E','','','34','269648636','2724 Hwy 37 N',0,'Mt Vernon','TX','75457',NULL,'CY','48159','1960-05-26','M','',':RET:2054-5','N','021','DEN','3839278','33348TX002000201','2014-03-01','2014-02-06 11:30:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:05'),(21035,16807,'Y','18','021','EC','A','','','AC','0000919431','0000919431','OH00002428143','IL','1','Carnahan','Donna','','','','34','488747048','265 Mulberry Street',0,'Felicity','OH','45120',NULL,'CY','39025','1955-10-29','F','U',':RET:2106-3','N','021','HLT','3529148','92036OH003000604','2014-03-01','2014-02-01 15:43:23','334.00',NULL,NULL,'571.20','237.20','R-OH005','OH0','571.20',NULL,0,'2014-02-01 19:00:47'),(19719,15714,'Y','18','024','14','A','','','TE','0000837660','0000837660','','IL','1','Helinski','Nancy','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-03-22','F','',NULL,NULL,NULL,'','355509','','2014-01-23','2014-01-23 09:43:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:00:57'),(14606,11657,'N','01','021','EC','A',NULL,NULL,'','0000846148','0001214802','','IL','1','Abourida','Maha','','','','34','252454454','911 Manor Lane',0,'columbus','OH','43221',NULL,'CY','39049','1964-09-20','F','',NULL,'N','021','DEN','1450740','99734OH005000301','2014-02-01','2013-12-27 12:11:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:36:31'),(16103,12898,'N','01','021','EC','A',NULL,NULL,'','0000084053','0000841925','','IL','1','Inthasom','Souphansa','','','','34','245530994','8241 CELESTIAL CIR',0,'LIBERTY TOWNSHIP','OH','45044','8399','CY','39017','1984-04-04','F','',NULL,'N','021','HLT','1358794','92036OH005001206','2014-02-01','2014-01-02 22:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.21',NULL,0,'2014-01-04 02:04:51'),(16239,13005,'Y','18','021','EC','A','','','AC','0002315144','0002315144','LA00001781521','IL','1','HANKS','LINDA','MARIE','','','34','345563635','220 JOHNS CIR',0,'RAGLEY','LA','70657','6912','CY','22011','1961-06-05','F','M',':RET:2106-3','N','021','DEN','2589132','18575LA002000101','2014-02-01','2014-01-04 13:35:55','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-01-05 00:02:18'),(17895,14293,'Y','18','021','EC','A','','','AC','0001162614','0001162614','OH00002257895','S1','1','Oyer','Brittany','Danielle','','','34','161063870','215 Winkler Drive',0,'Wooster','OH','44691',NULL,'CY','39169','2013-10-28','F','U',':RET:2106-3','N','021','DEN','2381776','99734OH005000401','2014-02-01','2014-01-14 16:56:31','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','15.78',NULL,0,'2014-01-15 02:06:21'),(17943,14337,'Y','18','021','EC','A','','','AC','0000341552','0000341552','TX00001619196','IL','1','polanco','vanessa','','','','34','466410105','111460 Lake Nasser Dr.',0,'El Paso','TX','79936',NULL,'CY','48141','1977-01-12','F','U',':RET:2106-3','N','021','DEN','2476016','33348TX002000201','2014-02-01','2014-01-14 15:47:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-15 02:06:40'),(22669,18102,'N','01','021','EC','A',NULL,NULL,'','0000944473','0001034108','','IL','1','Crane','Joyce','','','','34','143502631','16711 Mount Everest',0,'San Antonio','TX','78232',NULL,'CY','48029','1955-01-12','F','',':RET:2106-3','N','021','DEN','3767581','33348TX002000201','2014-03-01','2014-02-11 15:09:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:40'),(23161,18464,'Y','18','021','EC','A','','','AC','0001119690','0001119690','TX00002083642','IL','1','JERNIGAN','BRENDA','','','','34','465966752','600 E BIRDSONG ST',0,'LONGVIEW','TX','75602','3029','CY','48183','1953-09-17','F','U',NULL,'N','021','DEN','2858723','33348TX002000101','2014-03-01','2014-02-12 15:29:19','0.00',NULL,NULL,'25.02','25.02','R-TX013','TX0','25.02',NULL,0,'2014-02-12 21:31:47'),(27795,21985,'Y','18','024','14','A','','','TE','0001231833','0001231833','','IL','1','Wright','Kellee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-03-17','F','',NULL,NULL,NULL,'','2885542','','2014-03-04','2014-03-04 18:45:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:31:43'),(27886,22060,'Y','18','021','EC','A','','','AC','0000221384','0000221384','OH00002839273','IL','1','Wurns','Kay','','','','34','281500837','139 S HALLETT AVE',0,'SWANTON','OH','43558','1513','CY','39095','1950-12-04','F','M',':RET:2106-3','T','021','HLT','3414736','92036OH005002605','2014-04-01','2014-03-05 15:09:27','930.00',NULL,NULL,'1209.91','279.91','R-OH001','OH0','661.96',NULL,0,'2014-03-05 21:32:36'),(501,410,'Y','18','021','EC','A','','','AC','0000089796','0000089796','OH00000908159','IL','1','Peters','David','','','','34','297800141','5068 BECKENHAM CT',0,'GAHANNA','OH','43230','1263','CY','39049','1968-01-11','M','R',':RET:2106-3','N','021','DEN','621891','99734OH005000301','2014-01-01','2013-12-04 09:44:50','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:48:42'),(3172,2550,'Y','18','021','EC','A','','','AC','0000195093','0000195093','OH00000156221','IL','1','MCILROY','WILLIAM','','','','34','272768678','2949 TUCKER CT',0,'TWINSBURG','OH','44087','2954','CY','39153','1968-10-11','M','U',NULL,'N','021','HLT','742861','52664OH151001306','2014-01-01','2013-11-18 07:29:14','237.00',NULL,NULL,'322.02','85.02','R-OH012','OH0','322.02',NULL,0,'2013-12-25 20:31:33'),(5660,4490,'Y','18','021','EC','A','','','AC','0000257102','0000257102','OH00000761815','IL','1','Crawford','Kim','','','','34','292604006','2625 CANTON RD',0,'AKRON','OH','44312','5019','CY','39153','1959-09-14','F','U',':RET:2106-3','T','021','HLT','1111700','52664OH152000901','2014-01-01','2013-11-26 15:37:13','401.04',NULL,NULL,'401.04','0.00','R-OH012','OH0','401.04',NULL,0,'2013-12-25 23:31:44'),(19082,15203,'Y','18','021','EC','A','','','AC','0000780538','0000780538','OH00002404781','IL','1','Mayne','Tammy','','','','34','269706484','1207 Beargrass Way',0,'Maineville','OH','45039',NULL,'CY','39165','1961-07-15','F','U',':RET:2106-3','N','021','DEN','2934111','99734OH005000401','2014-03-01','2014-01-18 13:11:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-21 08:44:27'),(14948,11946,'Y','18','021','EC','A','','','AC','0000847213','0000847213','TX00000578044','IL','1','HERNANDEZ','DANNY','','','','34','468862353','3035 CUNNINGHAM DR',0,'WICHITA FALLS','TX','76308','3501','CY','48485','1964-10-28','M','U',NULL,'N','021','DEN','2123950','33348TX002000201','2014-02-01','2013-12-29 20:03:58','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-01 12:00:05'),(7707,6102,'Y','18','021','EC','A','','','AC','0000029038','0000029038','OH00000916904','IL','1','Sharp','Christopher','','','','34','296809803','1502 FAIR OAKS DR',0,'SIDNEY','OH','45365','1009','CY','39149','1973-05-13','M','U',NULL,'N','021','DEN','2285500','99734OH005000401','2014-01-01','2013-12-20 09:40:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:01:26'),(3513,2822,'Y','18','024','14','A','','','TE','0000766803','0000766803','','IL','1','Bateman','Rachell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-04-06','F','',NULL,NULL,NULL,'','412370','','2013-12-22','2013-12-22 07:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 21:21:04'),(6736,5343,'Y','18','021','EC','A','','','AC','0000132037','0000132037','OH00000010854','IL','1','Ballou','Scott','H','','','34','297502264','51 LANDINGS WAY',0,'AVON LAKE','OH','44012','2248','CY','39093','1953-08-30','M','U',':RET:2106-3','N','021','DEN','6319','99734OH005000401','2014-01-01','2013-11-25 12:48:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:15:37'),(7165,5684,'Y','18','021','EC','A','','','AC','0000870633','0000870633','OH00000816141','IL','1','Yang','Wei','','','','34','052788617','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1970-07-02','M','M',':RET:2034-7','N','021','HLT','1985187','92036OH003002705','2014-01-01','2013-12-24 22:07:55','710.00',NULL,NULL,'921.24','211.24','R-OH006','OH0','276.33',NULL,0,'2013-12-26 01:52:37'),(24147,19186,'N','19','021','EC','A',NULL,NULL,'','0000444955','0001063289','','IL','1','Bingamon','Morgan','','','','34','302984031','3533 NEALS CIR',0,'BATAVIA','OH','45103','9709','CY','39025','1996-07-16','F','',':RET:2106-3','N','021','HLT','3320747','92036OH004000601','2014-03-01','2014-02-15 11:05:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:54'),(26847,21278,'Y','18','021','EC','A','','','AC','0002175160','0002175160','LA00003217737','IL','1','Douglas','Lisa','','','','34','439047183','3431 Oneal Lane',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1966-04-06','F','U',NULL,'N','021','DEN','3605145','18575LA002000201','2014-04-01','2014-03-01 14:51:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-01 21:00:48'),(27491,21752,'N','19','021','EC','A',NULL,NULL,'','0000829339','0001048052','','IL','1','ZIMMERMAN','ZACHARY','','','','34','276963250','105 PINELAND DR',0,'COPLEY','OH','44321','1319','CY','39153','1993-01-05','M','',':RET:2106-3','N','021','HLT','2817281','52664OH151001305','2014-05-01','2014-03-04 11:51:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-03-04 21:02:22'),(21095,16858,'Y','18','021','EC','A','','','AC','0000330919','0000330919','OH00001412283','IL','1','Carl','Ian','','','','34','275887355','1658 TOLLGATE CT',0,'LEBANON','OH','45036','8687','CY','39165','1982-03-30','M','M',':RET:2106-3','N','021','HLT','2071933','92036OH006001201','2014-03-01','2014-02-02 14:21:41','0.00',NULL,NULL,'197.32','197.32','R-OH004','OH0','197.32',NULL,0,'2014-02-02 19:00:30'),(15465,12375,'N','19','021','EC','A',NULL,NULL,'','0000191381','0000051924','','S1','1','TRAN','NGA','','','','34','290028116','4307 MANTELL CT',0,'DAYTON','OH','45440','3869','CY','39057','1998-01-01','M','',NULL,'N','021','HLT','2512995','92036OH004000501','2014-02-01','2013-12-31 11:20:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,1,'2014-01-02 04:28:46'),(14618,11667,'N','01','021','EC','A',NULL,NULL,'','0000398616','0000437979','','IL','1','Kutz','Joan','','','','34','294508523','4314 WUEBOLD LN',0,'CINCINNATI','OH','45245','1817','CY','39025','1953-09-06','F','',':RET:2106-3','N','021','HLT','2036896','92036OH005000601','2014-02-01','2013-12-27 08:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','582.60',NULL,0,'2013-12-28 03:36:52'),(14180,11305,'N','01','021','EC','A',NULL,NULL,'','0000064347','0000466837','','IL','1','Barrett','Deborah','A','','','34','135686728','102 N TIMBERLANE',0,'LONE STAR','TX','75668','1900','CY','48343','1977-10-09','F','',':RET:2106-3','T','021','DEN','1847887','33348TX002000201','2014-02-01','2013-12-26 09:58:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-27 02:03:41'),(6973,5533,'N','01','021','EC','A',NULL,NULL,'','0000388621','0000029016','','IL','1','Kennedy','Kevin','','','','34','273765574','5542 BOSWORTH PL',0,'CINCINNATI','OH','45212','1238','CY','39061','1978-01-08','M','',':RET:2054-5','N','021','DEN','1869407','99734OH005000401','2014-01-01','2013-12-24 23:18:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:30'),(24054,19131,'Y','18','021','EC','A','','','AC','0000558192','0000558192','OH00002336789','IL','1','BEGLEY','DEBORAH','','','','34','280665567','4238 WILLIAMSPORT DR',0,'BEAVERCREEK','OH','45430','1837','CY','39057','1958-07-17','F','M',':RET:2106-3','N','021','DEN','3143301','99734OH005000301','2014-03-01','2014-02-14 20:03:36','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-02-15 22:01:06'),(24444,19416,'Y','18','021','EC','A','','','AC','0000380106','0000380106','OH00002665454','IL','1','Akers','Jane','','','','34','294720094','3621 Fiesta Way',0,'Middletown','OH','45044',NULL,'CY','39017','1962-09-27','F','U',':RET:2106-3','N','021','HLT','2845469','92036OH005001205','2014-04-01','2014-02-18 10:09:58','289.00',NULL,NULL,'400.37','111.37','R-OH004','OH0','400.37',NULL,0,'2014-02-18 22:01:21'),(24495,19460,'Y','18','021','EC','A','','','AC','0000204349','0000204349','TX00002098815','IL','1','Vargas','Valentin','','','','34','457592053','1617 S. Lasater',0,'Falfurrias','TX','78355',NULL,'CY','48047','1980-01-18','M','M',NULL,'N','021','DEN','3435444','33348TX002000201','2014-04-01','2014-02-18 19:29:49','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-20 03:46:38'),(28032,22185,'Y','18','024','14','A','','','TE','0000542737','0000542737','','IL','1','Williams','Russell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-08','M','',NULL,NULL,NULL,'','3426767','','2014-03-06','2014-03-06 17:25:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:01:28'),(19747,15739,'Y','18','021','EC','A','','','AC','0000598349','0000598349','TX00001398869','IL','1','Sanchez','Carlos','','','','34','455968027','211 W ESPERANZA AVE',0,'MISSION','TX','78574','5840','CY','48215','1957-03-11','M','U',NULL,'N','021','DEN','2722873','33348TX002000101','2014-03-01','2014-01-23 00:24:48','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-01-23 21:01:15'),(6618,5248,'Y','18','021','EC','A','','','AC','0001148696','0001148696','OH00000310983','31','1','schwab','david','','','','34','270523087','po box 63',0,'new haven','OH','44850',NULL,'CY','39077','1951-02-05','M','U',NULL,'T','021','HLT','1038330','92036OH005002706','2014-01-01','2013-12-11 11:26:55','541.00',NULL,NULL,'644.25','103.25','R-OH006','OH0','644.25',NULL,0,'2013-12-26 00:53:56'),(6539,5184,'N','01','021','EC','A',NULL,NULL,'','0000478205','0000843292','','IL','1','mancine','joanne','j','','','34','007582133','4302 SW 51ST AVE',0,'AMARILLO','TX','79109','6162','CY','48381','1955-08-26','F','',':RET:2106-3','N','021','DEN','1103756','33348TX002000201','2014-01-01','2013-12-10 22:52:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:51:52'),(891,738,'Y','18','021','EC','A','','','AC','0000616852','0000616852','OH00000802570','IL','1','MCKEE','SANDRA','K','','','34','302547927','1020 HORSESHOE RD',0,'WILMINGTON','OH','45177','9621','CY','39027','1953-11-18','F','U',NULL,'N','021','HLT','1870058','92036OH002000601','2014-01-01','2013-12-16 15:34:43','198.00',NULL,NULL,'672.81','474.81','R-OH005','OH0','672.81',NULL,0,'2013-12-25 18:07:59'),(1631,1362,'Y','18','021','EC','A','','','AC','0000373106','0000373106','TX00000218054','IL','1','Chenault','Scotty','','','','34','453499267','3321 W MICHIGAN AVE',0,'MIDLAND','TX','79703','5609','CY','48329','1974-02-06','M','U',':RET:2106-3','T','021','DEN','2417847','33348TX002000201','2014-01-01','2013-12-24 15:05:47','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-25 18:52:49'),(4537,3595,'N','19','021','EC','A',NULL,NULL,'','0000410477','0000462959','','IL','1','SPIES','ELIZABETH','','','','34','639263257','13101 W STATE HIGHWAY 21',0,'DOUGLASS','TX','75943',NULL,'CY','48347','1991-09-05','F','',':RET:2106-3','N','021','DEN','137934','33348TX002000201','2014-01-01','2013-12-12 17:14:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:04:12'),(3560,2858,'Y','18','021','EC','A','','','AC','0001234122','0001234122','OH00000342190','IL','1','Davis','Spencer','','','','34','287923845','484 Barwell St.',0,'Akron','OH','44303',NULL,'CY','39153','1987-08-30','M','U',':RET:2106-3','N','021','HLT','1850971','52664OH151001305','2014-01-01','2013-12-22 15:45:18','133.00',NULL,NULL,'228.36','95.36','R-OH012','OH0','228.36',NULL,0,'2013-12-25 21:22:17'),(3552,2851,'Y','18','021','EC','A','','','AC','0000335157','0000335157','OH00000554519','IL','1','Gwinnup','Jason','','','','34','296705274','4085 BOSTON AVE',0,'AKRON','OH','44319','2877','CY','39153','1962-07-15','M','U',':RET:2106-3','T','021','HLT','1983842','52664OH151001305','2014-01-01','2013-12-22 09:28:52','250.00',NULL,NULL,'478.30','228.30','R-OH012','OH0','478.30',NULL,0,'2013-12-25 21:22:04'),(2264,1852,'N','19','021','EC','A',NULL,NULL,'','0000017600','0000130669','','IL','1','Blank','Merrill','Valentina','','','34','299067386','11082 Sage creek drive',0,'Galena','OH','43021',NULL,'CY','39041','2000-12-07','F','',':RET:2106-3','N','021','DEN','761032','99734OH005000301','2014-01-01','2013-12-09 09:27:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:17'),(18283,14596,'N','01','021','EC','A',NULL,NULL,'','0000703800','0000079937','','IL','1','SHARMA','SHAMPA','','','','34','287158668','4794 TIMBERKNOLL RD',0,'CINCINNATI','OH','45244','1125','CY','39025','1972-08-02','F','',':RET:2029-7','N','021','DEN','1372558','99734OH005000401','2014-02-01','2014-01-14 19:03:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:44:48'),(17352,13882,'Y','18','021','EC','A','','','AC','0001472781','0001472781','LA00002269719','IL','1','Cunningham','Ozzie','','','','34','436826076','6343 SAINT PIUS AVE',0,'BATON ROUGE','LA','70811','4226','CY','22033','1950-08-27','F','U',':RET:2054-5','N','021','DEN','2526344','18575LA002000101','2014-02-01','2014-01-09 20:13:12','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:24:09'),(16248,13010,'N','01','021','EC','A',NULL,NULL,'','0000705159','0000168903','','IL','1','Chow','Sheryl','','','','34','293865251','34078 MONICA DR',0,'NORTH RIDGEVILLE','OH','44039','2130','CY','39093','1972-11-21','F','',':RET:2106-3','N','021','DEN','2297738','99734OH005000301','2014-02-01','2014-01-04 11:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:33'),(8137,6439,'Y','18','021','EC','A','','','AC','0001139474','0001139474','OH00000622942','IL','1','Rizer','Matthew','','','','34','286824262','232 WINDING WAY',0,'KETTERING','OH','45429','1422','CY','39113','1984-02-12','M','U',':RET:2106-3','N','021','HLT','1069635','92036OH005000501','2014-01-01','2013-11-21 20:49:49','0.00',NULL,NULL,'265.99','265.99','R-OH003','OH0','265.99',NULL,0,'2013-12-26 03:15:43'),(13781,10999,'Y','18','021','EC','A','','','AC','0001113390','0001113390','MS00000608074','IL','1','WHITE','ANDREA','','','','34','587257910','107 SANDSTONE',0,'BRANDON','MS','39047','7421','CY','28121','1974-10-10','F','M',':RET:2054-5','N','021','DEN','2238179','46300MS002000201','2014-01-01','2013-12-23 16:17:21','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:45'),(14501,11568,'N','01','021','EC','A',NULL,NULL,'','0001157276','0000137897','','IL','1','phan','kevin','','','','34','645309102','201 SW 3RD ST',0,'DIMMITT','TX','79027','2519','CY','48069','1972-01-22','M','',':RET:2047-9','N','021','DEN','1380956','33348TX002000201','2014-02-01','2013-12-27 14:19:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:47'),(23044,18371,'Y','18','024','14','A','','','TE','0000490513','0000490513','','IL','1','Sadler','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-02-01','M','',NULL,NULL,NULL,'','3169858','','2014-02-12','2014-02-12 10:17:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-12 21:30:41'),(19413,15477,'Y','18','021','EC','A','','','AC','0001182516','0001182516','OH00001853954','IL','1','Jordan','Ericka','','','','34','270721456','402 DANESMOOR RD',0,'HOLLAND','OH','43528','8209','CY','39095','1974-05-20','F','R',':RET:2054-5^:RET:2106-3','N','021','HLT','2797211','92036OH006002601','2014-03-01','2014-01-21 17:48:37','0.00',NULL,NULL,'195.16','195.16','R-OH001','OH0','195.16',NULL,1,'2014-01-22 03:22:58'),(19960,15922,'Y','18','024','14','A','','','TE','0000959806','0000959806','','IL','1','Alvarado','Rosalina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-01-28','F','',NULL,NULL,NULL,'','584004','','2014-01-25','2014-01-25 11:31:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-25 19:00:07'),(21242,16973,'Y','18','021','EC','A','','','AC','0000593708','0000593708','OH00001814224','IL','1','Joseph','Jane','','','','34','281766218','8177 Chestnut Blvd',0,'BROADVIEW HEIGHTS','OH','44147',NULL,'CY','39035','1965-04-17','F','U',NULL,'N','021','DEN','3351174','99734OH005000301','2014-03-01','2014-02-03 14:15:51','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:01:13'),(22414,17897,'Y','18','021','EC','A','','','AC','0002021538','0002021538','LA00001787636','IL','1','GUICARA','ANA','','','','34','051085945','1411 LILA ST',0,'BATON ROUGE','LA','70820','6406','CY','22033','1984-09-26','F','U',NULL,'N','021','DEN','3188451','18575LA002000201','2014-03-01','2014-02-10 12:23:33','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 21:30:27'),(5345,4239,'Y','18','021','EC','A','','','AC','0000242702','0000242702','OH00000493306','IL','1','Szabo','Connie','Ann','','','34','273444244','783 CHESTER AVE',0,'AKRON','OH','44314','2940','CY','39153','1949-04-24','F','U',':RET:2106-3','N','021','HLT','1617220','52664OH152000901','2014-01-01','2013-12-18 19:38:51','350.00',NULL,NULL,'490.00','140.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 23:07:28'),(4759,3774,'Y','18','021','EC','A','','','AC','0000734744','0000734744','TX00000003828','IL','1','Sparkman','Patsy','','','','34','445585288','1703 NORWICH AVE',0,'LUBBOCK','TX','79416','6907','CY','48303','1953-11-17','F','U',':RET:2106-3','N','021','DEN','1033231','33348TX002000101','2014-01-01','2013-12-08 13:30:21','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 22:15:29'),(9443,7491,'Y','18','021','EC','A','','','AC','0000722631','0000722631','OH00001273423','IL','1','HAWKE','MARY','','','','34','567155640','16092 FISHER RD',0,'EAST LIVERPOOL','OH','43920','9582','CY','39029','1958-01-27','F','M',NULL,'N','021','DEN','1367704','99734OH005000401','2014-01-01','2013-12-20 19:08:08','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:33:44'),(4275,3406,'Y','18','021','EC','A','','','AC','0000906597','0000906597','OH00000366922','IL','1','COLLIER','ELAINE','','','','34','291423342','4216 TOWNSHIP NORTH ELLIS ROAD',0,'BATAVIA','OH','45103',NULL,'CY','39025','1954-08-29','F','M',':RET:2106-3','T','021','HLT','1521337','92036OH001000601','2014-01-01','2013-12-17 10:57:54','710.00',NULL,NULL,'1519.07','809.07','R-OH005','OH0','775.14',NULL,0,'2013-12-25 21:51:52'),(6330,5019,'Y','18','021','EC','A','','','AC','0000432730','0000432730','OH00001143232','IL','1','Freed','Lois','','','','34','400709270','3288 STATE ROUTE 123',0,'MORROW','OH','45152','8121','CY','39165','1949-07-31','F','M',':RET:2106-3','N','021','DEN','538632','99734OH005000401','2014-01-01','2013-12-11 11:32:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:35'),(2305,1875,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001025484','','IL','1','Isenbarger','Caleb','','','','34','284089439','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','2003-08-14','M','',':RET:2106-3','N','021','DEN','709237','99734OH005000301','2014-01-01','2013-12-09 17:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:04'),(20125,16058,'Y','18','021','EC','A','','','AC','0001003336','0001003336','OH00002099534','IL','1','WILLIAMS','GARRY','','','','34','530640535','4151 MAPLELEAF DR',0,'DAYTON','OH','45416','2017','CY','39113','1957-05-25','M','U',':RET:2054-5','T','021','DEN','3407738','99734OH005000401','2014-03-01','2014-01-27 10:23:34','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-27 21:00:48'),(22397,17884,'Y','18','021','EC','A','','','AC','0000035791','0000035791','OH00002460247','IL','1','Kaye','Regina','','','','34','286789495','938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1966-12-09','F','M',':RET:2106-3','N','021','HLT','3254528','52664OH151001304','2014-03-01','2014-02-10 14:26:45','428.00',NULL,NULL,'824.68','396.68','R-OH012','OH0','348.56',NULL,0,'2014-02-10 21:30:18'),(23368,18620,'Y','18','021','EC','A','','','AC','0000581542','0000581542','OH00002742568','IL','1','Kegelmeyer','M','','','','34','273583764','7726 HAVENS CT W',0,'BLACKLICK','OH','43004','9555','CY','39049','1955-08-15','F','U',':RET:2106-3','T','021','DEN','2777664','99734OH005000401','2014-03-01','2014-02-12 19:05:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:50'),(23952,19046,'Y','18','021','EC','A','','','AC','0001172752','0001172752','TX00002839889','IL','1','Woodruff','Ted','','','','34','456932148','13772 BIG OAK BAY RD',0,'TYLER','TX','75707','7214','CY','48423','1981-03-02','M','M',':RET:2106-3','T','021','DEN','3361632','33348TX002000101','2014-03-01','2014-02-15 10:36:41','0.00',NULL,NULL,'50.04','50.04','R-TX022','TX0','25.02',NULL,0,'2014-02-15 22:00:05'),(557,457,'Y','18','021','EC','A','','','AC','0000084933','0000084933','LA00000051012','IL','1','MOLINA','FELIPE','','','','34','433439522','117 MARK TWAIN DR',0,'RIVER RIDGE','LA','70123','2489','CY','22051','1952-11-14','M','M',NULL,'N','021','DEN','29969','18575LA002000101','2014-01-01','2013-12-04 14:38:00','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-25 17:50:12'),(14059,11202,'Y','18','021','EC','A','','','AC','0000145390','0000145390','OH00001409129','IL','1','Hetzer','Donald','','','','34','278883263','11976 TAVEL CT',0,'CINCINNATI','OH','45246','2616','CY','39061','1975-07-08','M','U',':RET:2106-3','T','021','DEN','2484577','99734OH005000401','2014-02-01','2013-12-25 19:42:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:31'),(6830,5413,'Y','18','021','EC','A','','','AC','0000004676','0000004676','OH00000592053','IL','1','Keomany','Somvilay','','','','34','586581546','2411 VALENCIA RD',0,'GALLOWAY','OH','43119','9579','CY','39049','1975-11-15','M','U',':RET:2028-9','N','021','DEN','255810','99734OH005000401','2014-01-01','2013-11-13 23:00:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:30:46'),(9171,7274,'Y','18','021','EC','A','','','AC','0000162256','0000162256','OH00000733183','IL','1','Shilton','John','','','','34','573801161','4157 Trebor Dr',0,'Cincinnati','OH','45236',NULL,'CY','39061','1957-02-18','M','M',':RET:2106-3','N','021','HLT','2253805','92036OH004001201','2014-01-01','2013-12-18 11:36:29','0.00',NULL,NULL,'402.70','402.70','R-OH004','OH0','402.70',NULL,0,'2013-12-26 04:08:56'),(7785,6165,'Y','18','021','EC','A','','','AC','0000844632','0000844632','TX00001312486','31','1','GARCILAZO','Josefina','S','','','34','451997217','P.O Box 5372',0,'zapata','TX','78076',NULL,'CY','48505','1965-01-28','F','U',NULL,'N','021','DEN','1726379','33348TX002000201','2014-01-01','2013-12-20 14:10:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:17'),(9730,7705,'N','01','021','EC','A',NULL,NULL,'','0000207089','0000418860','','IL','1','SPISAK','ROSA','LEE','','','34','400727533','608SHEFFIELD ROAD',0,'MIDDLETOWN','OH','45042',NULL,'CY','39017','1949-05-31','F','',':RET:2106-3','N','021','DEN','753165','99734OH005000301','2014-01-01','2013-11-15 12:11:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:39'),(18476,14739,'Y','18','021','EC','A','','','AC','0001183544','0001183544','OH00001496758','IL','1','bushner','juanita','','','','34','279762969','945clarkst',0,'akron','OH','44306',NULL,'CY','39153','1968-12-31','F','U',':RET:2054-5','T','021','HLT','1860774','52664OH151001306','2014-02-01','2014-01-14 21:06:06','248.00',NULL,NULL,'370.33','122.33','R-OH012','OH0','370.33',NULL,0,'2014-01-16 08:46:19'),(19051,15174,'Y','18','021','EC','A','','','AC','0002314096','0002314096','LA00002446234','IL','1','Stennett','Sharon','','','','34','436920468','560 RUBEN JOHNSON RD',0,'WEST MONROE','LA','71292','0915','CY','22073','1953-08-03','F','M',':RET:2106-3','N','021','DEN','1934548','18575LA002000101','2014-03-01','2014-01-17 15:41:17','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-20 08:06:44'),(22360,17856,'Y','18','021','EC','A','','','AC','0000932666','0000932666','TX00002208774','IL','1','Farkas','Jessamyn','','','','34','130682610','403 E 38TH ST',0,'AUSTIN','TX','78705','1620','CY','48453','1985-01-23','F','U',':RET:2106-3','T','021','DEN','3647450','33348TX002000201','2014-03-01','2014-02-10 10:44:19','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-02-10 21:00:07'),(23249,18535,'N','19','021','EC','A',NULL,NULL,'','0000132073','0000604714','','IL','1','Payten','Charity','D','','','34','296966835','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1994-02-17','F','',':RET:2054-5','N','021','DEN','3272818','99734OH005000401','2014-03-01','2014-02-13 09:29:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-13 21:30:05'),(24723,19630,'Y','18','021','EC','A','','','AC','0000937327','0000937327','OH00002629452','IL','1','LOPEZ DE PORTILLO','ROSA','','','','34','289063548','1826 PLEASANT AVE',0,'HAMILTON','OH','45015','1041','CY','39017','1962-09-15','F','U',NULL,'N','021','DEN','3831681','99734OH005000401','2014-04-01','2014-02-19 10:16:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:38:11'),(28201,22317,'Y','18','021','EC','A','','','AC','0000566636','0000566636','TX00002981933','IL','1','REYES','CRISTIANA','','','','34','082311308','12332 TIERRA BUENA DR',0,'EL PASO','TX','79938','4465','CY','48141','1950-11-30','F','U',NULL,'N','021','DEN','3452461','33348TX002000101','2014-04-01','2014-03-06 11:29:14','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02','CIC',0,'2014-03-06 21:30:09'),(28831,22817,'Y','18','021','EC','A','','','AC','0000196198','0000196198','OH00003708231','IL','1','Slone','Rebecca','Ann','','','34','276902431','327 Jackson St',0,'Port Clinton','OH','43452',NULL,'CY','39123','1974-06-01','F','M',':RET:2106-3','N','021','HLT','3366123','92036OH002002701','2014-04-01','2014-03-09 11:39:35','0.00',NULL,NULL,'284.18','284.18','R-OH006','OH0','284.18',NULL,0,'2014-03-09 21:01:07'),(5320,4218,'Y','18','021','EC','A','','','AC','0000921906','0000921906','OH00000009963','IL','1','adkins','Brandon','','','','34','296928732','11592 MELROSE CIR NW',0,'UNIONTOWN','OH','44685','8250','CY','39151','1986-02-07','M','U',':RET:2106-3','N','021','DEN','1456428','99734OH005000301','2014-01-01','2013-12-18 21:43:07','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 23:06:46'),(1018,834,'Y','18','021','EC','A','','','AC','0000865871','0000865871','MS00000344982','IL','1','Williams','Levi','','','','34','426239167','370 williams st.',0,'Canton','MS','39046',NULL,'CY','28089','1968-01-15','M','M',':RET:2054-5','N','021','DEN','412329','46300MS002000201','2014-01-01','2013-12-02 23:44:11','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:15:10'),(3636,2910,'Y','18','021','EC','A','','','AC','0001218349','0001218349','MS00000369165','31','1','McNeil','Sandra','','','','34','427062422','PO Box 59332',0,'Jackson','MS','39284',NULL,'CY','28049','1958-03-24','F','M',':RET:2054-5','N','021','DEN','732120','46300MS002000201','2014-01-01','2013-12-13 10:56:15','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:16'),(5998,4749,'Y','18','021','EC','A','','','AC','0000240248','0000240248','LA00000217083','IL','1','joubert','major','','','','34','438794175','10613 HILLGLEN AVE',0,'BATON ROUGE','LA','70810','7089','CY','22033','1976-10-13','M','U',':RET:2054-5','N','021','DEN','86820','18575LA002000201','2014-01-01','2013-11-30 21:03:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:00:16'),(17516,14003,'Y','18','024','14','A','','','TE','0000721360','0000721360','','IL','1','Mitchell','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-25','M','',NULL,NULL,NULL,'','1522304','','2014-01-12','2014-01-12 10:03:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:33'),(20590,16453,'Y','18','021','EC','A','','','AC','0001067016','0001067016','OH00001757655','IL','1','Le','Tien','','','','34','289924402','7927 Furrow Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1975-11-12','M','M',':RET:2047-9','N','021','DEN','3406537','99734OH005000401','2014-03-01','2014-01-30 09:15:25','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:08'),(23832,18963,'Y','18','021','EC','A','','','AC','0000771456','0000771456','MS00002762381','IL','1','jelinek','christopher','','','','34','462673080','146 E WATERWOOD DR',0,'BRANDON','MS','39047','6527','CY','28121','1967-09-02','M','U',':RET:2106-3','N','021','DEN','2694850','46300MS002000101','2014-03-01','2014-02-14 14:40:22','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-14 21:31:46'),(24021,19104,'Y','18','021','EC','A','','','AC','0001135218','0001135218','OH00002906456','IL','1','Barker','Deborah','','','','34','296521236','88 BISHOP SQ',0,'COLUMBUS','OH','43209','1494','CY','39049','1953-02-28','F','M',':RET:2106-3','N','021','DEN','3609612','99734OH005000401','2014-03-01','2014-02-15 15:03:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:47'),(26151,20734,'N','01','021','EC','A',NULL,NULL,'','0000145439','0000988942','','IL','1','DRAVIS','KEVIN','','','','34','270588068','2507 BARLOW ROAD',0,'HUDSON','OH','44236',NULL,'CY','39153','1965-09-16','M','',NULL,'N','021','DEN','3598843','99734OH005000401','2014-04-01','2014-02-27 14:22:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:29'),(27233,21564,'N','19','021','EC','A',NULL,NULL,'','0001117315','0000956706','','IL','1','Richardson','Jorden','','','','34','274178970','131 Noran Circle',0,'Bedford','OH','44146',NULL,'CY','39035','2011-03-16','M','',':RET:2054-5','N','021','HLT','3879202','92036OH004000801','2014-04-01','2014-03-02 21:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.38',NULL,0,'2014-03-03 21:31:42'),(28268,22369,'Y','18','024','14','A','','','TE','0001154107','0001154107','','IL','1','JARNER','JANET',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-16','F','',NULL,NULL,NULL,'','3412166','','2014-03-07','2014-03-07 11:27:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-07 21:00:20'),(4973,3949,'Y','18','021','EC','A','','','AC','0000674883','0000674883','TX00001300826','IL','1','Fuller','Kenneth','','','','34','456471496','308 CR 3062',0,'Newton','TX','75966',NULL,'CY','48351','1972-06-06','M','M',':RET:2106-3','T','021','DEN','417184','33348TX002000201','2014-01-01','2013-12-06 19:43:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:30'),(4776,3790,'Y','18','021','EC','A','','','AC','0000078738','0000078738','OH00000977042','IL','1','Housley','Cheryl','','','','34','286606442','6824 EVERGREEN CIR',0,'HUBER HEIGHTS','OH','45424','3985','CY','39113','1960-07-15','F','R',':RET:2106-3','N','021','HLT','1204397','92036OH004000501','2014-01-01','2013-12-07 18:33:29','0.00',NULL,NULL,'389.92','389.92','R-OH003','OH0','389.92',NULL,0,'2013-12-25 22:15:58'),(1744,1447,'Y','18','021','EC','A','','','AC','0001039753','0001039753','OH00001427128','IL','1','Ivory','Robert','','','','34','283722915','23917 Emery Road',0,'Warrensville Heights','OK','44128',NULL,'CY','39035','1965-06-28','M','U',':RET:2054-5','N','021','DEN','2616234','99734OH005000301','2014-01-01','2013-12-24 12:13:23','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:35'),(4744,3759,'Y','18','021','EC','A','','','AC','0001093130','0001093130','OH00000378470','IL','1','Buford','Cynthia','','','','34','403315864','411 Frankiln St.',0,'Piqua','OH','45356',NULL,'CY','39109','1981-03-10','F','U',':RET:2054-5','N','021','HLT','319005','92036OH003000506','2014-01-01','2013-12-12 16:34:32','219.00',NULL,NULL,'293.67','74.67','R-OH003','OH0','293.67',NULL,0,'2013-12-25 22:09:33'),(6007,4756,'Y','18','021','EC','A','','','AC','0001124038','0001124038','OH00001222481','IL','1','DAVENPORT','IRIS','','','','34','276800189','2699 BULEN AVE',0,'COLUMBUS','OH','43207','2721','CY','39049','1967-05-21','F','U',':RET:2106-3','T','021','DEN','350587','99734OH005000301','2014-01-01','2013-11-30 20:15:46','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:00:31'),(23663,18841,'Y','18','024','14','A','','','TE','0001165559','0001165559','','IL','1','Castro','Anita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-25','F','',NULL,NULL,NULL,'','3093393','','2014-02-14','2014-02-14 14:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-14 21:30:20'),(24199,19221,'N','19','021','EC','A',NULL,NULL,'','0000221366','0000767449','','IL','1','Albrinck','Benjamin','','','','34','277179052','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','2011-05-19','M','',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:17'),(25067,19880,'Y','18','021','EC','A','','','AC','0000972791','0000972791','OH00001530817','IL','1','holland','marcus','','','','34','293843322','1024 AUBURN ST',0,'MIDDLETOWN','OH','45042','2329','CY','39017','1980-02-21','M','M',':RET:2106-3','T','021','DEN','3809828','99734OH005000401','2014-04-01','2014-02-20 14:55:12','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:28'),(5310,4210,'Y','18','021','EC','A','','','AC','0000515384','0000515384','MS00000295009','IL','1','JOHNSON','WILLIE','j','','Jr','34','302345312','44 HART LANE',0,'CRAWFORD','MS','39743',NULL,'CY','28105','1941-04-29','M','U',':RET:2054-5','N','021','DEN','2377164','46300MS002000101','2014-01-01','2013-12-19 14:37:50','0.00',NULL,NULL,'33.64','33.64','R-MS006','MS0','33.64',NULL,0,'2013-12-25 23:06:32'),(4756,3771,'Y','18','021','EC','A','','','AC','0000763281','0000763281','TX00000580741','IL','1','Lozano','Laura','','','','34','631077538','2300 lazy hollow',0,'houston','TX','77063',NULL,'CY','48201','1978-11-28','F','M',':RET:2106-3','N','021','DEN','471529','33348TX002000101','2014-01-01','2013-12-07 18:21:39','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:15:23'),(8814,6987,'Y','18','021','EC','A','','','AC','0000397325','0000397325','OH00000200077','IL','1','Ginn','Tony','','','','34','286664879','1964 Laurel Moscow Rd',0,'Moscow','OH','45153',NULL,'CY','39025','1965-02-21','M','M',':RET:2106-3','T','021','HLT','2487723','92036OH004000601','2014-01-01','2013-12-17 20:26:20','273.00',NULL,NULL,'632.84','359.84','R-OH005','OH0','324.56',NULL,0,'2013-12-26 04:00:05'),(3332,2674,'Y','18','021','EC','A','','','AC','0000581483','0000581483','OH00000826928','IL','1','SMITH','MATTHEW','','','','34','297863382','217 IDAHO AVE',0,'LORAIN','OH','44052','2159','CY','39093','1975-03-09','M','M',':RET:1002-5^:RET:2106-3','T','021','DEN','1853563','99734OH005000301','2014-01-01','2013-12-22 18:14:16','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:16:20'),(2882,2329,'Y','18','021','EC','A','','','AC','0000312968','0000312968','TX00000118252','IL','1','Dalora','Joseph','','','','34','593863270','220 W. Alabama St.',0,'Houston','TX','77006',NULL,'CY','48201','1986-09-17','M','U',NULL,'N','021','DEN','1170508','33348TX002000101','2014-01-01','2013-10-08 12:49:49','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 20:02:15'),(3672,2938,'Y','18','021','EC','A','','','AC','0000228320','0000228320','OH00000669792','IL','1','Downs','Christopher','','','','34','291902157','1592 LAVAL DR',0,'CINCINNATI','OH','45255','3212','CY','39061','1986-04-04','M','U',':RET:2106-3','N','021','DEN','545933','99734OH005000401','2014-01-01','2013-12-12 21:39:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:12'),(16787,13428,'Y','18','021','EC','A','','','AC','0000295512','0000295512','OH00001384781','IL','1','Genis','Keith','Anthony','','','34','296887242','257 TOLBERT ST',0,'WADSWORTH','OH','44281','1522','CY','39103','1986-08-05','M','U',':RET:2106-3','N','021','HLT','1508921','52664OH151001501','2014-02-01','2014-01-07 15:48:28','66.00',NULL,NULL,'280.30','214.30','R-OH012','OH0','280.30',NULL,0,'2014-01-08 18:25:08'),(24291,19292,'Y','18','021','EC','A','','','AC','0000303382','0000303382','OH00002812661','IL','1','CHEATHAM','LATOYA','','','','34','275901991','742 ROSLYN AVE',0,'AKRON','OH','44320','1848','CY','39153','1983-04-06','F','U',':RET:2054-5','N','021','HLT','3758389','52664OH151001305','2014-04-01','2014-02-18 10:14:33','137.00',NULL,NULL,'253.11','116.11','R-OH012','OH0','253.11','CIC',0,'2014-02-18 21:30:13'),(24614,19534,'N','01','021','EC','A',NULL,NULL,'','0000319075','0001250165','','IL','1','PETERS','MARIO','D','','','34','427297142','76203 ELIZABETH LN',0,'BRANDON','MS','39042','2741','CY','28121','1976-06-10','M','',':RET:2054-5','N','021','DEN','3005194','46300MS002000201','2014-04-01','2014-02-18 18:28:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 04:14:32'),(21462,17152,'Y','18','021','EC','A','','','AC','0001114567','0001114567','OH00002562232','IL','1','BERNATOVICZ','JOHN','','','','34','296706062','1000 ROBINWOOD HILLS DR',0,'AKRON','OH','44333','1554','CY','39153','1973-10-25','M','M',NULL,'N','021','HLT','3471935','52664OH151001301','2014-03-01','2014-02-04 18:01:18','276.00',NULL,NULL,'846.09','570.09','R-OH012','OH0','285.00',NULL,0,'2014-02-04 21:01:34'),(21964,17540,'Y','18','021','EC','A','','','AC','0000960642','0000960642','OH00001807590','IL','1','hanson','laura','','','','34','313947774','14004 FELS BLVD',0,'MARYSVILLE','OH','43040','9781','CY','39159','1985-08-25','F','M',':RET:2106-3','N','021','DEN','3004887','99734OH005000401','2014-03-01','2014-02-07 15:49:05','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:27'),(26298,20862,'Y','18','021','EC','A','','','AC','0000102865','0000102865','OH00002507734','IL','1','Church','Robert','','','','34','538546294','1013 Albon Road',0,'Holland','OH','43528',NULL,'CY','39095','1951-12-18','M','U',NULL,'N','021','HLT','3144769','92036OH004002601','2014-04-01','2014-02-27 15:32:09','445.46',NULL,NULL,'450.46','5.00','R-OH001','OH0','450.46',NULL,0,'2014-02-28 06:31:27'),(26395,20935,'N','01','021','EC','A',NULL,NULL,'','0000194050','0000599760','','IL','1','Taylor','Brian','','','','34','272863807','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1983-03-22','M','',':RET:2106-3','N','021','HLT','3007504','52664OH151001301','2014-03-01','2014-02-26 13:08:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11','CIC',0,'2014-02-28 07:00:27'),(5203,4129,'Y','18','021','EC','A','','','AC','0000586679','0000586679','OH00000628464','31','1','Arthur','Kay','','','','34','203424482','2661 Willow Glen Rd',0,'Hilliard','OH','43026',NULL,'CY','39049','1952-02-12','F','U',':RET:2106-3','N','021','DEN','2380896','99734OH005000401','2014-01-01','2013-12-19 14:44:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:04:05'),(915,760,'Y','18','021','EC','A','','','AC','0000862420','0000862420','OH00000326868','IL','1','Coates','James','','','','34','271560473','4716 N EDGEWOOD AVE',0,'CINCINNATI','OH','45232','1739','CY','39061','1959-04-15','M','U',':RET:2054-5','N','021','HLT','1371424','92036OH003001205','2014-01-01','2013-12-16 15:06:34','290.00',NULL,NULL,'478.63','188.63','R-OH004','OH0','478.63',NULL,0,'2013-12-25 18:08:39'),(14817,11835,'Y','18','024','14','A','','','TE','0000430643','0000430643','','IL','1','Kirshner','Gayla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-16','F','',NULL,NULL,NULL,'','2586377','','2013-12-23','2013-12-23 20:16:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:14:15'),(1100,904,'Y','18','021','EC','A','','','AC','0000988853','0000988853','OH00000598526','IL','1','Klaiber','Leslie','','','','34','286740750','12965 STATE ROUTE 739',0,'RICHWOOD','OH','43344','9728','CY','39159','1963-07-03','F','M',':RET:2106-3','N','021','DEN','436118','99734OH005000401','2014-01-01','2013-12-03 11:34:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:17:15'),(14100,11236,'Y','18','021','EC','A','','','AC','0000399895','0000399895','OH00001774932','IL','1','Hartwick','Suzanne','','','','34','274983722','5225 Northtowne Blvd',0,'Columbus','OH','43229',NULL,'CY','39049','1985-08-03','F','U',':RET:2106-3','N','021','DEN','2004383','99734OH005000401','2014-02-01','2013-12-26 12:03:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:32'),(9767,7734,'Y','18','024','14','A','','','TE','0000605909','0000605909','','IL','1','bair','laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-10-30','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-20 20:37:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 05:00:21'),(9285,7364,'Y','18','021','EC','A','','','AC','0001153591','0001153591','OH00000793958','IL','1','Odenbach','Spence','Edward','','','34','290724631','425 BEITLER AVE NE',0,'NEW PHILADELPHIA','OH','44663','2918','CY','39157','1967-02-23','M','U',':RET:2106-3','N','021','DEN','682986','99734OH005000301','2014-01-01','2013-11-30 15:05:20','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:15:59'),(6734,5342,'Y','18','021','EC','A','','','AC','0000849408','0000849408','OH00001084758','IL','1','Vo','Thanh','','','','34','278157068','5708 Brandtmanor Dr',0,'Cincinnati','OH','45248',NULL,'CY','39061','1978-07-02','F','M',':RET:2047-9','N','021','DEN','178456','99734OH005000401','2014-01-01','2013-11-25 12:38:37','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:34'),(6496,5146,'N','19','021','EC','A',NULL,NULL,'','0000625403','0001246911','','IL','1','West','Brian','Zachary','','','34','295943625','34 West Woodsdale Avenue',0,'Akron','OH','44301',NULL,'CY','39153','1992-04-13','M','',':RET:2106-3','T','021','HLT','141822','52664OH151001305','2014-01-01','2013-12-11 14:33:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','256.46',NULL,0,'2013-12-26 00:50:42'),(3149,2532,'Y','18','021','EC','A','','','AC','0000800576','0000800576','TX00000265605','IL','1','Rode','Lester','','','','34','452822981','473 ROCKY RIDGE RANCH RD',0,'LLANO','TX','78643','2742','CY','48299','1949-10-18','M','U',':RET:2106-3','N','021','DEN','615812','33348TX002000201','2014-01-01','2013-11-18 11:46:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:58'),(18088,14447,'Y','18','021','EC','A','','','AC','0002230441','0002230441','LA00001712669','31','1','Mancuso','Therese','','','','34','436717753','PO Box 452',0,'Destrehan','LA','70047',NULL,'CY','22089','1976-03-14','F','U',':RET:2106-3','T','021','DEN','1762388','18575LA002000201','2014-02-01','2014-01-14 11:56:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:29'),(18673,14886,'Y','18','021','EC','A','','','AC','0000172518','0000172518','TX00002311706','IL','1','RIVERA','NOEMIS','','','','34','584193920','908 KERN RD',0,'KILLEEN','TX','76541','2385','CY','48027','1962-04-18','F','U',NULL,'N','021','DEN','2630768','33348TX002000201','2014-02-01','2014-01-15 19:18:16','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-17 03:35:17'),(19998,15952,'Y','18','021','EC','A','','','AC','0000946141','0000946141','OH00001702984','IL','1','McCown','Gregory','','','','34','280686528','1818 NASON AVE',0,'COLUMBUS','OH','43207','1678','CY','39049','1970-09-16','M','M',':RET:2106-3','T','021','DEN','2067773','99734OH005000401','2014-03-01','2014-01-26 11:06:59','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-26 19:00:03'),(25244,20024,'N','01','021','EC','A',NULL,NULL,'','0001174433','0000646036','','IL','1','ulrick','beverly','','','','34','278763644','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1972-03-12','F','',':RET:2106-3','N','021','HLT','3464360','92036OH004001501','2014-04-01','2014-02-20 20:15:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','234.49',NULL,0,'2014-02-21 22:01:09'),(26697,21164,'N','01','021','EC','A',NULL,NULL,'','0001666341','0001641094','','IL','1','Moffett','Glenn','W','','','34','436198768','5970 HIGHWAY 6',0,'NATCHITOCHES','LA','71457','7104','CY','22069','1969-05-13','M','',':RET:2054-5','N','021','DEN','3210854','18575LA002000101','2014-04-01','2014-02-28 14:21:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 21:31:31'),(28084,22226,'Y','18','024','14','A','','','TE','0000398552','0000398552','','IL','1','sconiers','adrian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-01-09','M','',NULL,NULL,NULL,'','3283008','','2014-03-31','2014-03-06 15:05:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-06 21:01:59'),(58,52,'N','01','021','EC','A',NULL,NULL,'','0000078732','0000858456','','IL','1','Mahone','Terence','','','','34','269528660','3919 BEECH ST',0,'CINCINNATI','OH','45227','3101','CY','39061','1965-11-24','M','',':RET:2106-3','N','021','DEN','1250336','99734OH005000301','2014-01-01','2013-12-04 22:47:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:16:35'),(14665,11707,'Y','18','021','EC','A','','','AC','0000142133','0000142133','TX00001654111','IL','1','BURGESS','KAY','','','','34','445549560','160 VANVANDT CR 2724',0,'MABANK','TX','75147',NULL,'CY','48467','1951-05-09','F','M',NULL,'N','021','DEN','1921323','33348TX002000201','2014-02-01','2013-12-28 15:39:16','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:08:06'),(14187,11312,'Y','18','021','EC','A','','','AC','0001102473','0001102473','TX00000436313','IL','1','WINN','TERESA','','','','34','261454025','14905 county road 318',0,'navasota','TX','77868',NULL,'CY','48185','1958-11-06','F','M',NULL,'N','021','DEN','2287080','33348TX002000201','2014-02-01','2013-12-26 12:00:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:54'),(9716,7696,'Y','18','021','EC','A','','','AC','0000223675','0000223675','OH00000337519','31','1','Phillips','Marion','V','','','34','287469910','PO Box 24033',0,'Cincinnati','OH','45224',NULL,'CY','39061','1950-08-06','M','M',':RET:2106-3','N','021','DEN','996297','99734OH005000401','2014-01-01','2013-11-15 11:31:08','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:20'),(9522,7551,'Y','18','021','EC','A','','','AC','0000253042','0000253042','OH00000892679','IL','1','BESECE','BYRON','','','','34','273562666','4861 STATE ROUTE 152',0,'DILLONVALE','OH','43917','7902','CY','39081','1954-07-07','M','M',NULL,'T','021','DEN','2268449','99734OH005000301','2014-01-01','2013-12-20 20:15:39','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:35:40'),(3435,2760,'Y','18','021','EC','A','','','AC','0002256532','0002256532','LA00000814401','IL','1','LOGAN','DOROTHY','','','','34','437902864','403 4TH ST',0,'PEARL RIVER','LA','70452','3305','CY','22103','1954-12-04','F','U',':RET:2106-3','N','021','DEN','2616029','18575LA002000101','2014-01-01','2013-12-22 12:37:51','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:19:03'),(1039,852,'Y','18','021','EC','A','','','AC','0000076097','0000076097','TX00000087299','IL','1','Newcombe','Timothy','','','','34','511960942','514 N FM 492',0,'PALMVIEW','TX','78574','3752','CY','48215','1981-05-08','M','U',':RET:2106-3','N','021','DEN','4923','33348TX002000201','2014-01-01','2013-12-02 23:35:20','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:15:42'),(6396,5068,'N','01','021','EC','A',NULL,NULL,'','0000355013','0000168859','','IL','1','Bressman','Karen','Renee','','','34','269760598','8633 BROADACRE DR',0,'POWELL','OH','43065','9010','CY','39049','1966-03-16','F','',':RET:2106-3','N','021','DEN','622071','99734OH005000301','2014-01-01','2013-12-11 11:46:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:13'),(1851,1516,'Y','18','021','EC','A','','','AC','0000317346','0000317346','OH00001392396','IL','1','Gooch','Kristi','','','','34','294820789','3020 N STATE ROUTE 48',0,'LEBANON','OH','45036','2420','CY','39165','1969-02-18','F','U',NULL,'N','021','HLT','2130824','92036OH005001206','2014-01-01','2013-12-24 10:27:17','213.00',NULL,NULL,'299.90','86.90','R-OH004','OH0','299.90',NULL,0,'2013-12-25 18:57:55'),(19285,15371,'N','01','021','EC','A',NULL,NULL,'','0001187862','0002180113','','IL','1','Walpon','Jeremy','','','','34','435631540','2356 S MAGNOLIA DR',0,'BAKER','LA','70714','3322','CY','22033','1979-07-05','M','',NULL,'N','021','DEN','1782517','18575LA002000201','2014-03-01','2014-01-20 18:35:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-22 03:21:52'),(24064,19136,'Y','18','021','EC','A','','','AC','0000037050','0000037050','OH00002580361','IL','1','Eaver','Jacquelyn','','','','34','296909188','231 SPRING ST',0,'WOOSTER','OH','44691','2968','CY','39169','1987-06-26','F','U',':RET:2106-3','N','021','DEN','2651110','99734OH005000301','2014-03-01','2014-02-15 14:14:31','0.00',NULL,NULL,'21.13','21.13','R-OH014','OH0','0.00',NULL,0,'2014-02-15 22:01:11'),(25449,20193,'Y','18','021','EC','A','','','AC','0001154077','0001154077','TX00002535696','IL','1','DOZIER','LINDA','','','','34','457086273','9221 PAGEWOOD LANE',0,'HOUSTON','TX','77063',NULL,'CY','48201','1956-02-14','F','M',':RET:2054-5','N','021','DEN','2997783','33348TX002000201','2014-04-01','2014-02-25 13:32:33','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:25'),(27677,21890,'N','01','021','EC','A',NULL,NULL,'','0000641578','0000912687','','IL','1','ponce otero','Yazmin','','','Sr','34','634327800','306 MELINDA LN',0,'TYLER','TX','75702','6527','CY','48423','1990-08-23','F','',':RET:2106-3','N','021','DEN','3919428','33348TX002000201','2014-04-01','2014-03-04 20:02:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:36'),(6283,4982,'Y','18','024','14','A','','','TE','0000254500','0000254500','','IL','1','Allen','Brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-09-23','M','',NULL,NULL,NULL,'','1104479','','2013-12-10','2013-12-10 20:21:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:45:25'),(15984,12794,'Y','18','021','EC','A','','','AC','0000412772','0000412772','TX00000098885','IL','1','BROWN','ANNIE','','','','34','457982074','1314 E 3RD',0,'HUGABEBE','TX','75656',NULL,'CY','48067','1954-06-07','F','U',':RET:2054-5','N','021','DEN','2569925','33348TX002000201','2014-02-01','2014-01-03 11:09:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:03'),(14827,11841,'N','01','021','EC','A',NULL,NULL,'','0000509204','0000176393','','IL','1','JONES','SUZANNE','P','','','34','374624466','10530 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','9649','CY','39173','1955-04-23','F','',NULL,'N','021','HLT','1822712','92036OH004002601','2014-01-01','2013-12-23 20:45:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','399.50',NULL,1,'2013-12-29 11:14:28'),(7920,6262,'N','01','021','EC','A',NULL,NULL,'','0002377630','0002172743','','IL','1','Williams','Frank','Durch','','','34','435960131','362 PORTER ST',0,'MANSFIELD','LA','71052','2157','CY','22031','1954-08-26','M','',':RET:2054-5','T','021','DEN','2508757','18575LA002000201','2014-01-01','2013-12-19 23:11:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 03:06:17'),(4580,3627,'Y','18','021','EC','A','','','AC','0000655798','0000655798','OH00000542461','IL','1','FLINNER','REBECCA','','','','34','269665664','7553 TOWNSHIP ROAD 105',0,'MILLERSBURG','OH','44654','9511','CY','39075','1959-08-08','F','M',':RET:2106-3','N','021','HLT','1130753','52664OH151001305','2014-01-01','2013-12-11 20:52:17','870.00',NULL,NULL,'1101.11','231.11','R-OH014','OH0','476.12',NULL,0,'2013-12-25 22:05:11'),(2415,1970,'Y','18','021','EC','A','','','AC','0000173793','0000173793','OH00000162613','IL','1','Brenner','Laura','','','','34','291668516','430 St Clair',0,'Hamilton','OH','45015',NULL,'CY','39017','1974-10-25','F','U',':RET:2106-3','T','021','DEN','205950','99734OH005000401','2014-01-01','2013-12-09 15:54:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:49'),(17714,14157,'Y','18','021','EC','A','','','AC','0001010229','0001010229','OH00002502884','IL','1','steele','andrew','','','','34','279948039','327 N ADAMS ST',0,'AKRON','OH','44304','1413','CY','39153','1989-07-17','M','U',NULL,'N','021','HLT','2232550','52664OH152000901','2014-02-01','2014-01-12 22:32:32','163.34',NULL,NULL,'163.34','0.00','R-OH012','OH0','163.34',NULL,0,'2014-01-14 01:33:11'),(18680,14891,'N','01','021','EC','A',NULL,NULL,'','0001251778','0000913675','','IL','1','DeWitt','Kimberly','','','','34','189567396','2900 Robin Rd',0,'Greenville','TX','75402',NULL,'CY','48231','1976-06-03','F','',':RET:2106-3','T','021','DEN','2273162','33348TX002000201','2014-02-01','2014-01-15 20:08:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-17 03:35:20'),(22297,17800,'Y','18','021','EC','A','','','AC','0000841949','0000841949','OH00001932497','IL','1','Chamberlain','David','','','','34','003528977','6104 DONNA JAY DR',0,'LOVELAND','OH','45140','8739','CY','39025','1970-07-24','M','M',NULL,'N','021','DEN','2065281','99734OH005000301','2014-03-01','2014-01-25 13:36:41','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-10 11:00:34'),(25714,20397,'Y','18','021','EC','A','','','AC','0001032948','0001032948','TX00003025255','IL','1','FINKELMAN','MARIN','','','','34','459981051','11103 US HIGHWAY 287 E',0,'CORRIGAN','TX','75939','9043','CY','48373','1951-12-01','F','M',NULL,'N','021','DEN','3543050','33348TX002000201','2014-04-01','2014-02-24 16:31:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:24'),(27252,21579,'Y','18','021','EC','A','','','AC','0000424084','0000424084','OH00003402198','IL','1','chinni','bradley','','','','34','294666177','2205 W LASKEY RD',0,'TOLEDO','OH','43613','3501','CY','39095','1970-11-15','M','R',NULL,'N','021','HLT','2854485','92036OH003002601','2014-04-01','2014-03-03 13:28:48','0.00',NULL,NULL,'276.33','276.33','R-OH001','OH0','276.33',NULL,0,'2014-03-03 21:31:54'),(141,120,'Y','18','021','EC','A','','','AC','0000384369','0000384369','OH00001278593','IL','1','Zaher','Mark','','','','34','288580404','5721 Newton Falls Rd.',0,'Ravenna','OH','44266',NULL,'CY','39133','1956-09-27','M','U',':RET:2106-3','T','021','HLT','838157','52664OH152000901','2014-01-01','2013-12-05 07:22:31','289.00',NULL,NULL,'457.77','168.77','R-OH012','OH0','457.77',NULL,0,'2013-12-25 17:18:41'),(6081,4820,'Y','18','021','EC','A','','','AC','0000029008','0000029008','OH00000933008','IL','1','Reindel','Gary','','','','34','287449933','19813 st rt 697',0,'Delphos','OH','45833',NULL,'CY','39161','1951-09-22','M','M',':RET:2106-3','N','021','HLT','910883','92036OH004001501','2014-01-01','2013-12-01 14:06:08','1009.40',NULL,NULL,'1016.84','7.43','R-OH002','OH0','508.42',NULL,0,'2013-12-26 00:02:29'),(14780,11803,'Y','18','024','14','A','','','TE','0000264202','0000264202','','IL','1','Peterson','Aaron',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-08','M','',NULL,NULL,NULL,'','1992547','','2013-12-23','2013-12-23 20:42:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:13:11'),(5052,4001,'Y','18','024','14','A','','','TE','0000772993','0000772993','','IL','1','barron','michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-11-07','M','',NULL,NULL,NULL,'','1901738','','2013-12-18','2013-12-18 20:42:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:00:13'),(8831,7001,'Y','18','021','EC','A','','','AC','0001196526','0001196526','TX00000007538','IL','1','Stotler','Terra','','','','34','509044385','2118A HIDDEN HOLLOW CIR',0,'BRYAN','TX','77807','2229','CY','48041','1984-09-20','F','M',':RET:2106-3','N','021','DEN','2445760','33348TX002000201','2014-01-01','2013-12-17 20:08:53','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2013-12-26 04:00:31'),(4944,3923,'Y','18','021','EC','A','','','AC','0000367355','0000367355','OH00000598631','IL','1','Arora','Marilyn','','','','34','286382449','752 North State St.',0,'Westerville','OH','43082',NULL,'CY','39041','1969-03-16','F','R',':RET:2106-3','N','021','DEN','27426','99734OH005000401','2014-01-01','2013-12-07 08:45:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:45:44'),(16496,13197,'N','01','021','EC','A',NULL,NULL,'','0000532118','0001132769','','IL','1','piwinski','david','a','','','34','270586799','8223 MANORFORD DR',0,'PARMA','OH','44129','5306','CY','39035','1957-07-01','M','',':RET:2106-3','N','021','HLT','2034650','92036OH002000801','2014-02-01','2014-01-06 16:52:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','629.90',NULL,0,'2014-01-07 04:06:38'),(20393,16290,'Y','18','021','EC','A','','','AC','0000121879','0000121879','TX00002303978','IL','1','Fuentes','Hugo','','','','34','463270305','3526 ALTURA AVE',0,'EL PASO','TX','79930','5204','CY','48141','1959-03-13','M','M',':RET:2106-3','N','021','DEN','2900333','33348TX002000201','2014-03-01','2014-01-29 12:18:23','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-29 21:00:16'),(22862,18238,'Y','18','021','EC','A','','','AC','0000520378','0000520378','MS00002137904','IL','1','RICHARDSON','BARBARA','J','','','34','425115156','406 RIDGE PARK CV',0,'RAYMOND','MS','39154','9654','CY','28049','1962-10-15','F','U',':RET:2054-5','N','021','DEN','2805096','46300MS002000201','2014-03-01','2014-02-11 12:16:19','40.52',NULL,NULL,'56.37','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-11 21:02:25'),(24627,19545,'N','19','021','EC','A',NULL,NULL,'','0001888236','0002395689','','IL','1','CAREY','JARIUS','J','','','34','437859923','36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1992-11-25','M','',':RET:2054-5','N','021','DEN','2875540','18575LA002000201','2014-04-01','2014-02-19 09:07:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-20 04:17:24'),(6269,4971,'Y','18','021','EC','A','','','AC','0000795489','0000795489','OH00000476396','IL','1','BENNETT','PATTY','','','','34','405065696','8207 LAKE AVE',0,'CINCINNATI','OH','45236','2423','CY','39061','1976-03-24','F','U',':RET:2106-3','T','021','DEN','553104','99734OH005000401','2014-01-01','2013-12-10 18:18:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:45:03'),(14130,11262,'Y','18','021','EC','A','','','AC','0001520669','0001520669','LA00001639684','IL','1','Vu','Liem','','','','34','435570942','2025 SUGARLOAF DR',0,'HARVEY','LA','70058','5414','CY','22051','1959-10-03','M','U',':RET:2047-9','N','021','DEN','1741161','18575LA002000201','2014-02-01','2013-12-26 08:41:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:02:22'),(1372,1137,'Y','18','021','EC','A','','','AC','0000931218','0000931218','TX00001597094','IL','1','hunt','adriel','','','','34','457352225','5990 arataho',0,'dallas','TX','75248',NULL,'CY','48113','1970-04-11','M','U',NULL,'N','021','DEN','2305782','33348TX002000101','2014-01-01','2013-12-24 17:30:53','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:45:49'),(9287,7365,'N','01','021','EC','A',NULL,NULL,'','0000874664','0000093810','','IL','1','kleinschmidt','william','','','','34','269449575','117 ashleigh dr',0,'brunswick','OH','44212',NULL,'CY','39103','1954-06-02','M','',':RET:2106-3','T','021','DEN','1073488','99734OH005000301','2014-01-01','2013-11-30 17:00:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:16:03'),(22060,17610,'Y','18','024','14','A','','','TE','0000672371','0000672371','','IL','1','PETEET','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-12','M','',NULL,NULL,NULL,'','3590658','','2014-02-08','2014-02-08 12:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-08 19:00:10'),(25522,20248,'Y','18','021','EC','A','','','AC','0000525633','0000525633','OH00002563922','IL','1','Black','Ronnie','','','','34','268780195','948 LUDLOW AVE',0,'CINCINNATI','OH','45220','1031','CY','39061','1981-03-17','M','R',':RET:2054-5','N','021','HLT','2839446','92036OH006001201','2014-04-01','2014-02-25 15:44:04','0.00',NULL,NULL,'203.95','203.95','R-OH004','OH0','203.95',NULL,0,'2014-02-25 21:32:07'),(28896,22871,'Y','18','021','EC','A','','','AC','0000714036','0000714036','TX00002653598','IL','1','CARRIFEE','CORY','','','','34','459275565','206 MACARTHUR ST',0,'TYLER','TX','75704','2017','CY','48423','1973-06-11','M','U',':RET:2106-3','N','021','DEN','3861290','33348TX002000201','2014-04-01','2014-03-10 15:42:04','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-03-10 21:00:17'),(599,492,'N','01','021','EC','A',NULL,NULL,'','0000145366','0000874679','','IL','1','Steed','Helene','Maria','','','34','302881331','208 Parkwood Avenue',0,'Columbus','OH','43203',NULL,'CY','39049','1983-07-16','F','',':RET:2034-7^:RET:2106-3','N','021','DEN','260484','99734OH005000401','2014-01-01','2013-12-15 20:49:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:00:16'),(1370,1135,'Y','18','021','EC','A','','','AC','0000765806','0000765806','TX00000093180','IL','1','PHILMON','EDDREA','JOELLE','','','34','628078445','2112 ADDAX TRL',0,'HARKER HEIGHTS','TX','76548','2351','CY','48027','1985-01-09','F','U',':RET:2054-5','N','021','DEN','2398219','33348TX002000101','2014-01-01','2013-12-24 17:15:27','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-25 18:45:45'),(5135,4069,'Y','18','021','EC','A','','','AC','0000337446','0000337446','TX00001244667','IL','1','Zeno','Olga','','','','34','581211756','9310 VILLAGE CENTER CT',0,'HOUSTON','TX','77064','3845','CY','48201','1961-08-07','F','U',':RET:2106-3','N','021','DEN','2602773','33348TX002000101','2014-01-01','2013-12-19 16:58:00','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:02:20'),(20220,16133,'Y','18','021','EC','A','','','AC','0001007916','0001007916','OH00002375838','IL','1','Seip','Nelson','','','','34','270440249','1103 RIDGEPOINT DR',0,'BATAVIA','OH','45103','2680','CY','39025','1951-08-17','M','M',':RET:2106-3','N','021','HLT','2930970','92036OH004000601','2014-03-01','2014-01-27 14:05:08','684.00',NULL,NULL,'991.82','307.82','R-OH005','OH0','495.91',NULL,0,'2014-01-27 21:01:44'),(15239,12180,'N','01','021','EC','A',NULL,NULL,'','0000003587','0000326198','','IL','1','Schellekens','Lamberta','M','','','34','270114575','5520 ELM SUGAR RD',0,'CONVOY','OH','45832','9580','CY','39161','1953-11-27','F','',':RET:2106-3','N','021','HLT','1888863','92036OH004001501','2014-02-01','2013-12-30 09:16:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','480.28',NULL,0,'2014-01-01 12:08:32'),(21710,17336,'Y','18','021','EC','A','','','AC','0000235242','0000235242','OH00001400206','IL','1','FISHBACK','JACOB','','','','34','280964729','1 ALLISON CT',0,'WILLIAMSBURG','OH','45176','9298','CY','39025','1993-03-31','M','U',':RET:2106-3','N','021','HLT','3268956','92036OH005000606','2014-03-01','2014-02-05 11:12:40','71.00',NULL,NULL,'136.32','65.32','R-OH005','OH0','136.32',NULL,0,'2014-02-05 21:31:15'),(21937,17517,'Y','18','024','14','A','','','TE','0000660325','0000660325','','IL','1','toups','calvin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-12-09','M','',NULL,NULL,NULL,'','1505964','','2014-02-22','2014-02-07 15:37:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-07 19:00:13'),(23340,18603,'Y','18','021','EC','A','','','AC','0000779148','0000779148','OH00001977908','IL','1','STONE','SARAH','','','','34','589828303','1607 CLOVERFIELD DR',0,'COPLEY','OH','44321','1922','CY','39153','1989-02-08','F','U',NULL,'N','021','HLT','2945330','52664OH151001305','2014-03-01','2014-02-12 19:44:02','128.00',NULL,NULL,'223.90','95.90','R-OH012','OH0','223.90',NULL,0,'2014-02-13 22:00:37'),(25807,20465,'Y','18','021','EC','A','','','AC','0000356081','0000356081','OH00003074065','IL','1','DAVIS','SHEA','','','','34','299709757','779 TERRAVIEW DR',0,'BOARDMAN','OH','44512',NULL,'CY','39099','1973-10-14','F','U',NULL,'N','021','DEN','3501151','99734OH005000301','2014-03-01','2014-02-26 13:01:45','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-26 21:00:19'),(26982,21374,'Y','18','021','EC','A','','','AC','0000586745','0000586745','OH00002633380','IL','1','House','Matthew','','','','34','018588682','402 W VINE ST',0,'COLDWATER','OH','45828','1149','CY','39107','1977-03-08','M','M',':RET:2106-3','N','021','HLT','2669639','92036OH004001501','2014-04-01','2014-03-02 12:40:21','165.00',NULL,NULL,'431.08','266.08','R-OH002','OH0','219.08',NULL,0,'2014-03-03 01:00:38'),(27874,22049,'Y','18','021','EC','A','','','AC','0000579482','0000579482','MS00003377571','IL','1','Tutor','Bobby','','','','34','587085822','198 WEBB CIR',0,'FLORENCE','MS','39073','9702','CY','28121','1962-11-05','M','M',NULL,'T','021','DEN','3140128','46300MS002000101','2014-04-01','2014-03-05 14:50:56','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-05 21:32:27'),(28161,22284,'N','01','021','EC','A',NULL,NULL,'','0000584338','0000213431','','IL','1','Deubler','Kenneth','','','','34','288729528','4750 STEWART RD',0,'LIMA','OH','45801','1324','CY','39003','1973-04-05','M','',':RET:2106-3','N','021','HLT','3529968','92036OH005001505','2014-04-01','2014-03-06 15:53:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.27',NULL,0,'2014-03-06 21:02:42'),(310,253,'Y','18','021','EC','A','','','AC','0000496913','0000496913','TX00001181753','IL','1','edmondson','karan','','','','34','219848613','1010 n high st',0,'san saba','TX','76877',NULL,'CY','48411','1961-02-23','F','U',':RET:2106-3','N','021','DEN','578674','33348TX002000101','2014-01-01','2013-11-13 01:00:04','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 17:30:58'),(21084,16848,'Y','18','021','EC','A','','','AC','0000528278','0000528278','OH00002051486','IL','1','BURSTION-DONBRAYE','DEBORAH','L','','','34','295568059','19808 LONGBROOK RD',0,'CLEVELAND','OH','44128','2767','CY','39035','1954-10-24','F','M',NULL,'N','021','DEN','3006923','99734OH005000301','2014-03-01','2014-02-02 10:50:24','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-02 19:00:23'),(5054,4003,'Y','18','021','EC','A','','','AC','0000043380','0000043380','TX00000573408','IL','1','Ritchie','Jack','','','','34','632281579','104 COMMERCE ST',0,'REFUGIO','TX','78377','3302','CY','48391','1989-11-07','M','U',NULL,'N','021','DEN','1549869','33348TX002000201','2014-01-01','2013-12-18 20:54:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:16'),(20715,16552,'Y','18','021','EC','A','','','AC','0001250745','0001250745','LA00002150298','31','1','Jackson','Tommy','','','','34','425069038','P.O. Box 172',0,'JOnesville','LA','71343',NULL,'CY','22025','1959-04-23','M','U',':RET:2054-5','N','021','DEN','2642429','18575LA002000201','2014-03-01','2014-01-30 17:50:26','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-30 21:01:11'),(9271,7355,'Y','18','021','EC','A','','','AC','0000969412','0000969412','OH00000528147','IL','1','Frazier','Daniel','','','','34','283509982','4524 Weiner Ln',0,'Cincinnati','OH','45244',NULL,'CY','39025','1965-11-25','M','U',':RET:2106-3','N','021','DEN','1006108','99734OH005000401','2014-01-01','2013-11-30 12:02:31','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:15:39'),(19565,15597,'Y','18','021','EC','A','','','AC','0002218167','0002218167','LA00002214632','IL','1','Edwards','John','','','','34','260048468','17555 S HARRELLS FERRY RD',0,'BATON ROUGE','LA','70816','3530','CY','22033','1956-06-07','M','U',NULL,'N','021','DEN','2529217','18575LA002000201','2014-03-01','2014-01-22 16:09:17','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-23 03:02:35'),(19269,15357,'Y','18','024','14','A','','','TE','0001012953','0001012953','','IL','1','ELMER','STEVEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-08-02','M','',NULL,NULL,NULL,'','2452369','','2014-01-20','2014-01-20 13:02:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:53'),(25264,20043,'Y','18','021','EC','A','','','AC','0001667627','0001667627','LA00002525082','IL','1','Wright','Mary','Elizabeth','','','34','433676969','237 S MARTIN LN',0,'WEST MONROE','LA','71292','2101','CY','22073','1972-01-21','F','M',':RET:2106-3','N','021','DEN','2672946','18575LA002000101','2014-04-01','2014-02-22 15:33:32','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02','CIC',0,'2014-02-22 19:00:14'),(26108,20707,'Y','18','021','EC','A','','','AC','0000589368','0000589368','OH00001883281','IL','1','Reese','Robert','','','','34','287640660','1407 S WEYANT AVE',0,'COLUMBUS','OH','43227','1912','CY','39049','1961-04-16','M','U',':RET:2106-3','N','021','DEN','3274619','99734OH005000401','2014-04-01','2014-02-26 18:34:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:15'),(27974,22131,'N','19','021','EC','A',NULL,NULL,'','0001218882','0002156066','','IL','1','Cannon','Whitney','','','','34','435790399','14475 SUMMERSET DR',0,'GONZALES','LA','70737','7087','CY','22005','1990-08-14','F','',':RET:2054-5','N','021','DEN','3267374','18575LA002000201','2014-04-01','2014-03-06 13:12:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-06 21:00:52'),(16631,13305,'Y','18','021','EC','A','','','AC','0000380072','0000380072','OH00001842491','IL','1','Holbrook','Rose','','','','34','286822029','104 Cumberland St',0,'Hebron','OH','43025',NULL,'CY','39089','1984-09-21','F','M',NULL,'N','021','DEN','2155664','99734OH005000401','2014-02-01','2014-01-07 11:10:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:14'),(16956,13572,'Y','18','021','EC','A','','','AC','0000627891','0000627891','OH00002318758','IL','1','JENKINS','ANTWONE','','','','34','273683587','706 MAIN ST',0,'CONNEAUT','OH','44030','2252','CY','39007','1969-02-07','M','M',NULL,'N','021','HLT','2367401','52664OH151001306','2014-02-01','2014-01-08 18:50:14','602.00',NULL,NULL,'672.81','70.81','R-OH011','OH0','351.37',NULL,0,'2014-01-13 02:20:04'),(22769,18178,'N','01','021','EC','A',NULL,NULL,'','0001037398','0000486983','','IL','1','Cole','Torrence','','','Jr','34','281665224','2341 18TH ST NE',0,'CANTON','OH','44705','2219','CY','39151','1958-08-21','M','',NULL,'N','021','DEN','3143169','99734OH005000401','2014-03-01','2014-02-11 11:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:37'),(22966,18311,'Y','18','021','EC','A','','','AC','0000025340','0000025340','OH00001925118','IL','1','Bryant','Debra','','','','34','286507627','815 US HIGHWAY 250 N',0,'ASHLAND','OH','44805','9479','CY','39005','1951-02-22','F','M',':RET:2106-3','N','021','HLT','3129689','52664OH151001305','2014-03-01','2014-02-12 13:30:43','555.00',NULL,NULL,'658.32','103.32','R-OH012','OH0','658.32','CIC',0,'2014-02-12 21:00:13'),(23033,18362,'N','01','021','EC','A',NULL,NULL,'','0000538663','0001040518','','IL','1','TAPIA','FRANCISCO','','','','34','463794371','10222 INWOOD SHADOWS ST',0,'HOUSTON','TX','77088','2227','CY','48201','1966-11-27','M','',NULL,'N','021','DEN','2930060','33348TX002000201','2014-03-01','2014-02-12 11:49:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-12 21:30:35'),(28174,22297,'Y','18','021','EC','A','','','AC','0000692985','0000692985','OH00003277542','IL','1','VONA','LYLY','','','','34','857482129','10510 TUDOR CIR',0,'NORTH ROYALTON','OH','44133','1973','CY','39035','1985-05-05','F','M',':RET:2047-9','N','021','HLT','3762337','52664OH152001001','2014-04-01','2014-03-06 12:27:43','0.00',NULL,NULL,'150.31','150.31','R-OH011','OH0','150.31',NULL,0,'2014-03-06 21:02:51'),(20992,16774,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000142860','','IL','1','Al-Shinnawi','Rami','S','','','34','296949375','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1992-03-31','M','',':RET:2106-3','N','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:25'),(20356,16257,'Y','18','021','EC','A','','','AC','0001081834','0001081834','OH00001847681','IL','1','MILLER','RICHARD','','','','34','302741319','835 E BUCHTEL AVE',0,'AKRON','OH','44305',NULL,'CY','39153','1968-08-01','M','U',':RET:2106-3','T','021','HLT','3084079','52664OH152000901','2014-03-01','2014-01-28 13:00:32','238.00',NULL,NULL,'271.24','33.24','R-OH012','OH0','271.24',NULL,0,'2014-01-28 21:01:17'),(725,600,'Y','18','021','EC','A','','','AC','0000206579','0000206579','TX00000868206','IL','1','Armstrong','Christie','','','','34','449817113','1403 Wright Blvd',0,'Baytown','TX','77520',NULL,'CY','48201','1973-06-24','F','U',':RET:2106-3','N','021','DEN','2392383','33348TX002000101','2014-01-01','2013-12-16 13:09:29','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:03:36'),(1421,1183,'Y','18','021','EC','A','','','AC','0001630021','0001630021','LA00000436257','IL','1','Landrieu','Ryan','','','','34','433551419','3420 Edenborn Ave',0,'Metairie','LA','70002',NULL,'CY','22051','1983-04-14','M','U',':RET:2106-3','T','021','DEN','2564633','18575LA002000201','2014-01-01','2013-12-24 15:15:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:14'),(3027,2435,'Y','18','021','EC','A','','','AC','0000990474','0000990474','MS00000772734','IL','1','Davis','Stanley','','','','34','587302947','812 Central st',0,'Greenville','MS','38701',NULL,'CY','28151','1951-01-02','M','U',':RET:2054-5','N','021','DEN','1024075','46300MS002000201','2014-01-01','2013-12-06 13:19:27','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 20:18:20'),(3518,2826,'Y','18','021','EC','A','','','AC','0001076560','0001076560','OH00000423641','IL','1','OKEEFE','HEATHER','LYNN','','','34','268866541','432 HARRISON ST',0,'PORT CLINTON','OH','43452','1809','CY','39123','1986-02-20','F','U',':RET:2106-3','N','021','HLT','1440554','92036OH005002705','2014-01-01','2013-12-21 20:26:00','116.00',NULL,NULL,'204.35','88.35','R-OH006','OH0','204.35',NULL,0,'2013-12-25 21:21:11'),(18625,14848,'Y','18','021','EC','A','','','AC','0000333893','0000333893','OH00002279062','IL','1','Scott','Roy','','','','34','288645071','9380 Hunt Club Trail NE',0,'Warren','OH','44484',NULL,'CY','39155','1959-02-02','M','R',':RET:2106-3','N','021','HLT','1745173','92036OH001003201','2014-02-01','2014-01-15 17:34:00','0.00',NULL,NULL,'1381.05','1381.05','R-OH013','OH0','623.36',NULL,0,'2014-01-16 08:47:30'),(8054,6377,'Y','18','021','EC','A','','','AC','0000820997','0000820997','OH00000971191','31','1','Shelton','Marvin',NULL,NULL,NULL,NULL,NULL,'P.O. Box 488',0,'Anna','OH','45302',NULL,'CY','39149','1949-02-11','M','R',':RET:2106-3','N','021','HLT','1393690','92036OH006000501','2014-01-01','2013-12-20 07:36:48','0.00',NULL,NULL,'565.54','565.54','R-OH003','OH0','565.54',NULL,0,'2013-12-26 03:09:47'),(9122,7236,'N','19','021','EC','A',NULL,NULL,'','0000323491','0000718905','','IL','1','Torres','Andrew','','','','34','302022085','7973 SCHOOL HOUSE LN',0,'MONTGOMERY','OH','45242','5928','CY','39061','1998-07-17','M','',':RET:2106-3','N','021','DEN','1795337','99734OH005000301','2014-01-01','2013-12-18 18:04:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:48'),(15827,12671,'Y','18','021','EC','A','','','AC','0000318417','0000318417','OH00001468956','IL','1','Ravenscraft','Cherylene','','','','34','289488293','2825 BELLEVUE AVE',0,'CINCINNATI','OH','45219','2328','CY','39061','1950-02-24','F','U',':RET:2106-3','N','021','DEN','2299905','99734OH005000401','2014-02-01','2014-01-02 16:36:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:03:44'),(15489,12393,'Y','18','021','EC','A','','','AC','0000471023','0000471023','OH00001802940','IL','1','stokes','angela','','','','34','298583490','7504 griffin drive',0,'cincinnati','OH','45237',NULL,'CY','39061','1963-08-21','F','U',':RET:2054-5','N','021','DEN','1623592','99734OH005000401','2014-02-01','2013-12-31 10:43:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:29:26'),(22457,17930,'Y','18','021','EC','A','','','AC','0000550795','0000550795','TX00001977831','IL','1','Valenta','Timothy','','','','34','449316301','4029 WINDMILL RIDGE CIR',0,'OVILLA','TX','75154','5552','CY','48139','1965-11-19','M','M',':RET:2106-3','N','021','DEN','3019390','33348TX002000201','2014-03-01','2014-02-10 15:15:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:50'),(23869,18993,'Y','18','021','EC','A','','','AC','0001001207','0001001207','OH00001735853','IL','1','koenig','susan','','','','34','268584726','09215 New Bremen New Knoxville Rd',0,'new knoxville','OH','45871',NULL,'CY','39011','1958-03-25','F','U',':RET:2106-3','T','021','HLT','3367737','92036OH004001501','2014-03-01','2014-02-14 11:08:16','345.00',NULL,NULL,'453.83','108.83','R-OH002','OH0','453.83',NULL,0,'2014-02-14 21:32:09'),(25388,20143,'Y','18','021','EC','A','','','AC','0000994023','0000994023','OH00003170515','IL','1','Liejaya','Wielanda','','','','34','186803929','316 KENRIDGE RD',0,'FAIRLAWN','OH','44333','3414','CY','39153','1964-05-07','F','U',NULL,'N','021','HLT','2703479','52664OH151001305','2014-04-01','2014-02-24 19:52:49','260.00',NULL,NULL,'380.45','120.45','R-OH012','OH0','380.45',NULL,0,'2014-02-25 21:30:50'),(28228,22334,'N','19','021','EC','A',NULL,NULL,'','0001204586','0000971518','','S1','1','Habli','firas','','','','34','302088105','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2004-08-11','M','',NULL,'N','021','DEN','2969726','99734OH005000301','2014-04-01','2014-03-06 15:47:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-06 21:30:21'),(20529,16403,'N','19','021','EC','A',NULL,NULL,'','0000474644','0001086039','','IL','1','WILLIAMS','ALISHA','','','','34','427732951','816 GEORGE ST',0,'MOUND BAYOU','MS','38762','9609','CY','28011','1992-04-03','F','',':RET:2054-5','N','021','DEN','3172477','46300MS002000201','2014-03-01','2014-01-28 23:00:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-29 21:01:29'),(2273,1857,'Y','18','021','EC','A','','','AC','0001085590','0001085590','OH00000827863','IL','1','Dunn','Allen','','','','34','415398364','515 Martha Drive',0,'Franklin','OH','45005',NULL,'CY','39165','1979-12-04','M','U',':RET:2106-3','N','021','DEN','623334','99734OH005000301','2014-01-01','2013-12-09 12:09:32','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:26'),(17869,14275,'Y','18','021','EC','A','','','AC','0000872069','0000872069','OH00002200927','IL','1','white','brenda','','','','34','298504507','744 E COURT ST',0,'URBANA','OH','43078','1868','CY','39021','1951-05-19','F','U',NULL,'N','021','DEN','2010017','99734OH005000401','2014-02-01','2014-01-14 13:17:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:13'),(6278,4978,'Y','18','021','EC','A','','','AC','0000656905','0000656905','OH00001185229','IL','1','Kampschmidt','Carla','','','','34','299745461','3934 LANSDOWNE AVE',0,'CINCINNATI','OH','45236','3024','CY','39061','1979-05-28','F','R',NULL,'N','021','DEN','723586','99734OH005000401','2014-01-01','2013-12-10 19:20:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:45:18'),(5551,4406,'Y','18','021','EC','A','','','AC','0000196192','0000196192','TX00001133069','IL','1','Taylor','Mandy','','','','34','456899602','117 Carrington Drive',0,'Rockwall','TX','75032',NULL,'CY','48397','1981-03-01','F','U',':RET:2106-3','N','021','DEN','916908','33348TX002000201','2014-01-01','2013-11-26 21:29:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:16:09'),(13471,10744,'N','01','021','EC','A',NULL,NULL,'','0001102089','0000983829','','IL','1','Farmer','Erin','','','','34','159681237','822 TEAKWOOD CT',0,'LEBANON','OH','45036','8650','CY','39165','1985-12-08','F','',':RET:2106-3','N','021','DEN','1583336','99734OH005000301','2014-01-01','2013-12-23 16:11:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:01'),(16079,12877,'Y','18','021','EC','A','','','AC','0001145984','0001145984','OH00001929593','IL','1','TRENT','ROBERT','LYNE','','','34','293803662','525 ABBE RD S',0,'ELYRIA','OH','44035','6343','CY','39093','1983-10-04','M','U',':RET:2106-3','N','021','DEN','2381526','99734OH005000401','2014-02-01','2014-01-03 14:56:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:04:03'),(26830,21265,'Y','18','021','EC','A','','','AC','0000829327','0000829327','OH00002476521','IL','1','Civitarese','April','Dawn','','','34','268824546','210 MONROE ST',0,'LOUDONVILLE','OH','44842','1328','CY','39005','1982-05-30','F','M',':RET:2106-3','N','021','DEN','3155632','99734OH005000401','2014-04-01','2014-03-01 14:37:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-01 21:00:39'),(20941,16735,'N','19','021','EC','A',NULL,NULL,'','0000780544','0001234148','','S1','1','Patel','Bhavesh','B','','','34','291063209','1839 CLOUGH PIKE',0,'BATAVIA','OH','45103','2621','CY','39025','2001-11-24','M','',':RET:2029-7^:RET:2106-3','N','021','HLT','3477931','92036OH003000604','2014-03-01','2014-01-31 16:20:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-31 21:01:43'),(21108,16865,'Y','18','021','EC','A','','','AC','0002045234','0002045234','LA00001901979','IL','1','Davis','James','','','','34','437572488','267 RANDY RD',0,'WEST MONROE','LA','71292','1699','CY','22073','1983-02-20','M','M',':RET:2106-3','N','021','DEN','3418607','18575LA002000101','2014-03-01','2014-02-02 18:28:57','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-03 21:00:05'),(22224,17740,'Y','18','021','EC','A','','','AC','0000473659','0000473659','OH00002399187','IL','1','Stadler','Nora','','','','34','287481123','2940 8TH ST',0,'CUYAHOGA FALLS','OH','44221','1622','CY','39153','1960-07-22','F','U',':RET:2106-3','N','021','HLT','3855626','52664OH151001305','2014-03-01','2014-02-09 17:17:40','381.00',NULL,NULL,'596.55','215.55','R-OH012','OH0','454.94',NULL,0,'2014-02-09 19:00:28'),(26003,20623,'Y','18','021','EC','A','','','AC','0001704412','0001704412','LA00002115003','IL','1','CARTER','LAWRENCE','','','','34','435353065','115 GEORGE TAYLOR',0,'SAREPTA','LA','71071',NULL,'CY','22119','1977-07-28','M','U',':RET:2054-5','N','021','DEN','3335992','18575LA002000101','2014-04-01','2014-02-26 13:49:19','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-26 21:02:05'),(27124,21471,'Y','18','021','EC','A','','','AC','0000872111','0000872111','OH00002393760','IL','1','Brent','Lakeisha','','','','34','426397690','63 COTTERREW DR',0,'BLACKLICK','OH','43004','9595','CY','39049','1978-09-08','F','U',':RET:2054-5','N','021','DEN','2884357','99734OH005000301','2014-04-01','2014-03-03 16:18:00','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:35'),(27163,21508,'Y','18','021','EC','A','','','AC','0000819360','0000819360','TX00002573214','IL','1','Nguyen','Long','','','','34','629927040','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1988-05-31','M','M',':RET:2047-9','N','021','DEN','3151799','33348TX002000201','2014-04-01','2014-03-03 10:28:23','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-03 21:31:00'),(28091,22233,'Y','18','021','EC','A','','','AC','0000355615','0000355615','MS00003326824','31','1','knox','rita',NULL,NULL,NULL,NULL,NULL,'po box 201',0,'alltoma','MS','38820',NULL,'CY','28115','1964-12-08','F','U',NULL,'N','021','DEN','3414764','46300MS002000101','2014-04-01','2014-03-06 10:29:34','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2014-03-06 21:02:05'),(477,389,'Y','18','021','EC','A','','','AC','0000412715','0000412715','LA00000753682','IL','1','JONES','KARL','MICHAEL OBYRON','','','34','439730747','2720 ALASKA STREET',0,'BATON ROUGE','LA','70802',NULL,'CY','22033','1988-07-25','M','U',':RET:2054-5','N','021','DEN','660827','18575LA002000201','2014-01-01','2013-12-03 20:31:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:48:02'),(3166,2547,'N','01','021','EC','A',NULL,NULL,'','0000034332','0000926231','','IL','1','Taylor','Richard','','','','34','293424045','4661 NATHANIEL GLEN DR',0,'CINCINNATI','OH','45248','1540','CY','39061','1950-01-09','M','',':RET:2106-3','N','021','DEN','852219','99734OH005000401','2014-01-01','2013-11-18 13:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:31:27'),(21673,17307,'N','01','021','EC','A',NULL,NULL,'','0001640013','0001624870','','IL','1','Leary','Terry','Lynn','','','34','434379044','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1971-01-12','F','',':RET:2054-5','N','021','DEN','2853811','18575LA002000201','2014-03-01','2014-02-05 16:15:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:30:59'),(21323,17039,'Y','18','021','EC','A','','','AC','0001834736','0001834736','LA00001777315','IL','1','Tucker','Amy','','','','34','439236831','316 Micro Tower Rd.',0,'Grayson','LA','71435',NULL,'CY','22021','1970-06-08','F','U',':RET:2106-3','N','021','DEN','3599456','18575LA002000201','2014-03-01','2014-02-04 17:31:14','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-04 21:00:23'),(24221,19235,'N','01','021','EC','A',NULL,NULL,'','0000277951','0001040539','','IL','1','Trevino','Carlos','','','','34','459998938','13407 SPRUCE HOLLOW CT',0,'HOUSTON','TX','77059','3237','CY','48201','1971-12-30','M','',':RET:2106-3','N','021','DEN','2692261','33348TX002000201','2014-04-01','2014-02-16 01:05:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-16 19:00:28'),(5478,4349,'Y','18','021','EC','A','','','AC','0000690734','0000690734','OH00000765214','IL','1','ALLEN','LYDIA','KAREN','','','34','271529927','1012 DIVISION ST',0,'TOLEDO','OH','43604','8102','CY','39095','1950-06-19','F','U',':RET:2054-5','N','021','HLT','2001155','92036OH005002605','2014-01-01','2013-12-19 11:04:27','472.00',NULL,NULL,'575.62','103.62','R-OH001','OH0','575.62',NULL,0,'2013-12-25 23:10:45'),(19462,15513,'N','01','021','EC','A',NULL,NULL,'','0001169072','0001220421','','IL','1','TROUTMAN','ADA','BELINA','','','34','459256224','106 RETAMA CT',0,'GEORGETOWN','TX','78626','6348','CY','48491','1971-06-28','F','',NULL,'N','021','DEN','2883466','33348TX002000201','2014-03-01','2014-01-21 23:18:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 03:01:56'),(19179,15279,'Y','18','021','EC','A','','','AC','0000781618','0000781618','TX00001619334','IL','1','Carter','Joe','','','','34','451066094','8151 W Rockwell Rd',0,'Canyon','TX','79015',NULL,'CY','48381','1956-12-14','M','U',':RET:2106-3','N','021','DEN','2810207','33348TX002000201','2014-03-01','2014-01-19 22:10:25','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-21 08:46:06'),(7768,6151,'Y','18','021','EC','A','','','AC','0000888520','0000888520','TX00000609224','31','1','Ochoa','Fernando','','','','34','450251786','2112 Domingo Trevino Dr',0,'Mission','TX','78572',NULL,'CY','48215','1958-11-11','M','M',NULL,'N','021','DEN','2600028','33348TX002000201','2014-01-01','2013-12-19 18:52:39','0.00',NULL,NULL,'43.83','43.83','R-TX015','TX0','14.61',NULL,0,'2013-12-26 03:02:52'),(7734,6125,'N','01','021','EC','A',NULL,NULL,'','0000132066','0001253527','','IL','1','WOLVERTON','JORDAN','','','','34','301906031','2054 SUMMER BANKS DR',0,'GROVE CITY','OH','43123','4861','CY','39049','1985-11-24','F','',':RET:2106-3','N','021','DEN','2308052','99734OH005000401','2014-01-01','2013-12-20 15:19:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:06'),(15589,12476,'Y','18','024','14','A','','','TE','0001063253','0001063253','','IL','1','McGuire','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-21','F','',NULL,NULL,NULL,'','1658127','','2013-12-31','2013-12-31 10:46:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:24'),(27019,21402,'Y','18','021','EC','A','','','AC','0000897042','0000897042','OH00003147950','IL','1','Kerr','Kenneth','','','','34','274829554','209 S. Ayres st.',0,'Nevada','OH','44849',NULL,'CY','39175','1978-04-17','M','M',':RET:2106-3','N','021','DEN','3550480','99734OH005000301','2014-04-01','2014-03-03 13:26:53','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00','CIC',0,'2014-03-03 21:00:12'),(1795,1474,'Y','18','021','EC','A','','','AC','0000234020','0000234020','OH00001662878','IL','1','Getz','Maria','','','','34','301680204','210 South Grove Street',0,'Bowling Green','OH','43402',NULL,'CY','39173','1975-10-19','F','U',':RET:2106-3','N','021','DEN','1746116','99734OH005000301','2014-01-01','2013-12-24 16:55:09','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:56:37'),(8838,7005,'N','01','021','EC','A',NULL,NULL,'','0000570150','0000578710','','IL','1','golriz khatami','azita','','','','34','627022677','15114 wells port dr',0,'austin','TX','78728',NULL,'CY','48453','1979-11-27','F','',':RET:2106-3','N','021','DEN','2430630','33348TX002000201','2014-01-01','2013-12-17 21:03:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:00:40'),(21670,17306,'Y','18','021','EC','A','','','AC','0001256796','0001256796','LA00002213516','IL','1','donnelly','mechelle','','','','34','347684318','5860 HIGHWAY 569',0,'FERRIDAY','LA','71334','4537','CY','22029','1973-12-04','F','U',':RET:2054-5','N','021','DEN','3723669','18575LA002000201','2014-03-01','2014-02-05 15:17:01','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-05 21:30:58'),(2180,1792,'Y','18','021','EC','A','','','AC','0000224704','0000224704','OH00001211577','IL','1','Hirt','JoAnna','','','','34','268646109','3118 cardinal dr',0,'Harrod','OH','45850',NULL,'CY','39003','1957-07-15','F','M',':RET:2106-3','N','021','HLT','385723','92036OH003001505','2014-01-01','2013-12-10 12:51:22','414.00',NULL,NULL,'536.20','122.20','R-OH002','OH0','536.20',NULL,0,'2013-12-25 19:19:22'),(18420,14695,'Y','18','021','EC','A','','','AC','0002358369','0002358369','LA00001388980','IL','1','Breland','Catherine','','','','34','587613556','7931 Bayou Fountain Avenue',0,'Baton Rouge','LA','70820',NULL,'CY','22033','1988-01-30','F','U',':RET:2106-3','N','021','DEN','2481403','18575LA002000201','2014-02-01','2014-01-14 23:51:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-16 08:45:52'),(4422,3513,'N','01','021','EC','A',NULL,NULL,'','0000680814','0000078740','','IL','1','Shafitz','Suzanne','','','','34','294508514','4021 Eastern Avenue',0,'Cincinnati','OH','45226',NULL,'CY','39061','1967-03-06','F','',NULL,'N','021','DEN','508619','99734OH005000401','2014-01-01','2013-12-12 16:37:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:38'),(16707,13371,'Y','18','021','EC','A','','','AC','0000369491','0000369491','TX00001603486','IL','1','Brassfield','Sarah','','','','34','522434337','810 Denver Ave',0,'Dalhart','TX','79022',NULL,'CY','48111','1980-03-10','F','M',':RET:2106-3','N','021','DEN','2542684','33348TX002000201','2014-02-01','2014-01-06 22:05:36','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:41'),(15185,12134,'N','01','021','EC','A',NULL,NULL,'','0000168900','0000858497','','IL','1','Bersee','James','Kent','','','34','280526736','9220 NOWARD RD',0,'WATERVILLE','OH','43566','9555','CY','39095','1953-06-28','M','',':RET:2106-3','N','021','HLT','1649963','92036OH004002601','2014-02-01','2013-12-30 08:37:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','425.53',NULL,0,'2014-01-01 12:06:55'),(15978,12788,'Y','18','021','EC','A','','','AC','0000904817','0000904817','TX00001566385','IL','1','Ornelas','Krystle','','','','34','585738032','10009 W 57TH ST',0,'ODESSA','TX','79764','9364','CY','48135','1985-06-26','F','U',':RET:2106-3','N','021','DEN','2308614','33348TX002000201','2014-02-01','2014-01-03 10:01:58','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-04 02:00:49'),(23257,18542,'Y','18','021','EC','A','','','AC','0001190448','0001190448','TX00002351153','IL','1','MEMON','ADEEL','','','','34','645948623','13002 HALWIN CIR',0,'DALLAS','TX','75243','2434','CY','48113','1977-10-13','M','M',':RET:2028-9','N','021','DEN','3767628','33348TX002000201','2014-03-01','2014-02-13 00:26:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-13 21:30:08'),(1607,1343,'N','01','021','EC','A',NULL,NULL,'','0001240358','0001042788','','IL','1','Collins','Jo Nell','','','','34','237841492','511 MUSTANG TRL',0,'HARKER HEIGHTS','TX','76548','2339','CY','48027','1954-12-05','F','',NULL,'N','021','DEN','1409309','33348TX002000201','2014-01-01','2013-12-24 13:01:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:11'),(9348,7409,'N','01','021','EC','A',NULL,NULL,'','0001899360','0001740033','','IL','1','Ketchens','Lawrence','','','','34','433314921','1736 Winchester Pl',0,'Harvey','LA','70058',NULL,'CY','22051','1963-03-19','M','',NULL,'T','021','DEN','2353952','18575LA002000201','2014-01-01','2013-12-20 23:04:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:31:10'),(9232,7324,'N','01','021','EC','A',NULL,NULL,'','0001090907','0000009832','','IL','1','Denehy','Dee Ann','','','','34','282585927','671 GREEN RD',0,'MARTINSVILLE','OH','45146','9551','CY','39027','1955-11-11','F','',':RET:2106-3','N','021','HLT','1981319','92036OH003000604','2014-01-01','2013-12-18 18:07:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','571.20',NULL,0,'2013-12-26 04:10:28'),(19722,15716,'N','01','021','EC','A',NULL,NULL,'','0001636345','0001746236','','IL','1','Yambra','Alicia','','','','34','436757298','6611 Center St.',0,'New Orleans','LA','70124',NULL,'CY','22071','1985-06-12','F','',':RET:2106-3','N','021','DEN','2394797','18575LA002000201','2014-03-01','2014-01-22 21:42:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 21:00:59'),(17808,14225,'Y','18','021','EC','A','','','AC','0000008869','0000008869','TX00002038638','IL','1','KEGG','KEVIN','','','','34','460138501','6117 CURVY DR',0,'HOUSTON','TX','77005',NULL,'CY','48201','1959-11-30','M','U',':RET:2106-3','N','021','DEN','2020226','33348TX002000101','2014-02-01','2014-01-14 11:24:45','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-15 02:05:51'),(15702,12561,'Y','18','021','EC','A','','','AC','0001094653','0001094653','OH00001986157','IL','1','Cumpston','Sarah','','','','34','645449627','3113 PARKWOOD AVE',0,'TOLEDO','OH','43610','1616','CY','39095','1994-12-23','F','R',':RET:2106-3','N','021','HLT','1845315','92036OH004002601','2014-02-01','2013-12-31 14:01:12','0.00',NULL,NULL,'99.57','99.57','R-OH001','OH0','99.57',NULL,1,'2014-01-02 04:35:45'),(4788,3798,'Y','18','021','EC','A','','','AC','0000927283','0000927283','OH00001170748','IL','1','HILTABIDEL','MARILYN','','','','34','284482577','743 OAKWOOD AVE',0,'SHEFFIELD LAKE','OH','44054','1328','CY','39093','1951-05-28','F','U',NULL,'T','021','HLT','684360','52664OH151001305','2014-01-01','2013-12-07 19:17:57','472.00',NULL,NULL,'831.01','359.01','R-OH011','OH0','831.01',NULL,0,'2013-12-25 22:16:14'),(4061,3244,'Y','18','021','EC','A','','','AC','0000026608','0000026608','OH00001127531','IL','1','Stranscak','Frank','','','','34','277529260','8921 TIMBERLANE TRL',0,'NORTH ROYALTON','OH','44133','1352','CY','39035','1955-09-29','M','U',':RET:2106-3','N','021','DEN','1920701','99734OH005000401','2014-01-01','2013-12-17 15:44:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:41'),(3330,2672,'Y','18','021','EC','A','','','AC','0000963224','0000963224','OH00000065339','IL','1','Smothers','Linda','Carol','','','34','271561879','6201 EAGLES LAKE CT',0,'CINCINNATI','OH','45248','6807','CY','39061','1954-10-16','F','M',':RET:2106-3','N','021','DEN','2238088','99734OH005000301','2014-01-01','2013-12-22 17:37:11','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:16:17'),(3846,3076,'N','01','021','EC','A',NULL,NULL,'','0000046988','0000454030','','IL','1','Hayes','James','Stephen','','','34','437772036','612 SPAIN ST',0,'NEW ORLEANS','LA','70117','7821','CY','22071','1986-01-27','M','',':RET:2106-3','N','021','DEN','645472','18575LA002000101','2014-01-01','2013-12-13 11:17:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 21:35:30'),(6391,5067,'N','19','021','EC','A',NULL,NULL,'','0000566593','0001037321','','IL','1','ABBOTT','CHARLES','DREW AUSTIN','','','34','205784553','1917 TILDEN AVE',0,'CINCINNATI','OH','45212','2519','CY','39061','1999-09-03','M','',':RET:2106-3','N','021','DEN','1187027','99734OH005000301','2014-01-01','2013-12-11 11:44:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:10'),(15076,12051,'Y','18','021','EC','A','','','AC','0000670759','0000670759','TX00000827264','IL','1','Graves','Brandie','','','','34','454756457','605 AUDREY ST',0,'LONGVIEW','TX','75601','6004','CY','48203','1980-04-27','F','M',':RET:2106-3','N','021','DEN','2009622','33348TX002000101','2014-02-01','2013-12-29 19:38:32','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-01-01 12:04:02'),(8823,6995,'Y','18','021','EC','A','','','AC','0000787054','0000787054','TX00001284218','IL','1','Harris','Sandra','','','','34','441786989','1081 W Hwy 86',0,'Dimmitt','TX','79027',NULL,'CY','48069','1968-03-02','F','M',':RET:2106-3','N','021','DEN','1405026','33348TX002000201','2014-01-01','2013-12-17 18:47:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:20'),(9629,7627,'Y','18','021','EC','A','','','AC','0000964614','0000964614','OH00000378874','IL','1','Chancey','Rexford','','','','34','293521348','161 2ND STREET NW',0,'Barberton','OH','44203',NULL,'CY','39153','1952-02-19','M','U',':RET:2106-3','T','021','HLT','1542298','52664OH152000901','2014-01-01','2013-12-21 12:46:39','420.00',NULL,NULL,'527.84','107.84','R-OH012','OH0','527.84',NULL,0,'2013-12-26 04:38:09'),(8891,7049,'Y','18','021','EC','A','','','AC','0000313050','0000313050','TX00000381236','IL','1','Landers','Pamela','','','','34','457158041','1916 NW 16TH AVE',0,'AMARILLO','TX','79107','1634','CY','48375','1960-03-05','F','U',':RET:2054-5','N','021','DEN','2491544','33348TX002000201','2014-01-01','2013-12-18 17:18:35','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 04:02:00'),(15490,12394,'Y','18','021','EC','A','','','AC','0000191380','0000191380','OH00000016501','IL','1','Catania','Catherine','','','','34','283863556','754 SHERWOOD DR',0,'AURORA','OH','44202','7826','CY','39133','1982-01-31','F','U',NULL,'N','021','DEN','1602182','99734OH005000401','2014-02-01','2013-12-31 11:18:39','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:29:28'),(17038,13633,'Y','18','021','EC','A','','','AC','0002090690','0002090690','LA00002297214','IL','1','Ancar','Donna','','','','34','434969792','921 RIDGELAKE DR',0,'METAIRIE','LA','70001','4256','CY','22051','1954-10-17','F','U',':RET:2054-5','N','021','DEN','2117589','18575LA002000101','2014-02-01','2014-01-09 11:51:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-13 02:20:50'),(21255,16986,'Y','18','021','EC','A','','','AC','0000607188','0000607188','OH00002115739','IL','1','Werner','Phillip','','','','34','288606405','4845 Oster Rd',0,'Sheffield Lake','OH','44054',NULL,'CY','39093','1968-08-30','M','M',':RET:2106-3','N','021','HLT','3305929','52664OH151001305','2014-03-01','2014-02-03 16:22:56','436.00',NULL,NULL,'726.38','290.38','R-OH011','OH0','363.19',NULL,0,'2014-02-03 21:01:20'),(21748,17367,'Y','18','024','14','A','','','TE','0001134379','0001134379','','IL','1','PORRAS','ERIKA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-11-17','F','',NULL,NULL,NULL,'','3035208','','2014-02-05','2014-02-05 19:30:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-06 21:00:19'),(22665,18099,'Y','18','021','EC','A','','','AC','0000103831','0000103831','TX00001945751','IL','1','Nichols','Amy','','','','34','467919254','1909 Baltimore Drive',0,'Allen','TX','75002',NULL,'CY','48085','1972-04-10','F','U',':RET:2106-3','N','021','DEN','3498311','33348TX002000201','2014-03-01','2014-02-11 14:22:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:37'),(23605,18803,'Y','18','021','EC','A','','','AC','0000051967','0000051967','OH00001421175','IL','1','Hamp','Tina','','','','34','407110552','732 w 1st st',0,'delphos','OH','45833',NULL,'CY','39161','1965-09-25','F','M',':RET:2106-3','T','021','HLT','3474683','92036OH003001501','2014-03-01','2014-02-13 15:10:01','185.99',NULL,NULL,'870.00','684.01','R-OH002','OH0','432.15',NULL,0,'2014-02-13 22:03:10'),(23681,18857,'Y','18','024','14','A','','','TE','0001405004','0001405004','','IL','1','Murphy','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-08-31','M','',NULL,NULL,NULL,'','3847196','','2014-02-14','2014-02-14 17:34:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-14 21:30:31'),(23723,18889,'Y','18','021','EC','A','','','AC','0000117065','0000117065','TX00002798447','IL','1','wassman','james','','','','34','344766516','3104 walnut hill ln',0,'dallas','TX','75229',NULL,'CY','48113','1986-07-08','M','M',':RET:2106-3','N','021','DEN','3193914','33348TX002000101','2014-03-01','2014-02-13 23:02:27','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-02-14 21:30:54'),(25363,20125,'Y','18','024','14','A','','','TE','0000884207','0000884207','','IL','1','BYERS-LOWERY','ERNESTINE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-02-08','F','',NULL,NULL,NULL,'','2328174','','2014-03-12','2014-02-25 09:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:37'),(208,173,'Y','18','021','EC','A','','','AC','0000019534','0000019534','LA00000625410','IL','1','Pham','Hanh','','','','34','438836186','607 wind haven ln',0,'lafayette','LA','70506',NULL,'CY','22055','1962-06-05','F','U',NULL,'N','021','DEN','1155604','18575LA002000201','2014-01-01','2013-12-04 20:40:03','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 17:20:23'),(13313,10629,'N','01','021','EC','A',NULL,NULL,'','0000536156','0000083640','','IL','1','Shah','Surya','','','','34','639621574','14707 Rich Valley Lane',0,'Sugar Land','TX','77498',NULL,'CY','48157','1953-06-01','F','',':RET:2029-7','N','021','DEN','2056788','33348TX002000201','2014-01-01','2013-12-23 16:17:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:58:09'),(15052,12031,'Y','18','021','EC','A','','','AC','0002355708','0002355708','LA00001609079','IL','1','Goins','Chaz','','','','34','117765834','3732 CIMWOOD DR',0,'HARVEY','LA','70058','1617','CY','22051','1987-05-10','M','U',NULL,'T','021','DEN','1769187','18575LA002000201','2014-02-01','2013-12-30 14:31:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:03:17'),(25537,20258,'Y','18','021','EC','A','','','AC','0001170885','0001170885','OH00002771602','IL','1','Gresham','Crystal','','','','34','290709260','1123 CLEARBROOK DR',0,'CINCINNATI','OH','45229','1105','CY','39061','1971-06-23','F','R',':RET:2054-5','N','021','DEN','2960821','99734OH005000301','2014-04-01','2014-02-22 19:48:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:00:08'),(26651,21129,'Y','18','021','EC','A','','','AC','0000371534','0000371534','OH00003125431','IL','1','Gidorkis','Steven','','','','34','306607361','3484 PARFOURE BLVD',0,'UNIONTOWN','OH','44685','7803','CY','39153','1952-07-17','M','U',NULL,'N','021','HLT','2950489','52664OH151001304','2014-04-01','2014-02-28 13:23:25','422.00',NULL,NULL,'626.65','204.65','R-OH012','OH0','626.65',NULL,0,'2014-02-28 21:31:07'),(207,172,'Y','18','021','EC','A','','','AC','0000019533','0000019533','LA00000323790','IL','1','Shoemichael','Vickey','','','','34','437198616','4979 Saint Louis',0,'Zachary','LA','70791',NULL,'CY','22033','1973-03-28','F','U',NULL,'N','021','DEN','963224','18575LA002000201','2014-01-01','2013-12-04 20:26:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:21'),(13925,11105,'Y','18','021','EC','A','','','AC','0000869282','0000869282','OH00000797005','IL','1','Arps','Amy','','','','34','295684337','740 Trail Dr',0,'Napoleon','OH','43545',NULL,'CY','39069','1973-09-28','F','U',':RET:2106-3','N','021','HLT','2546173','92036OH003002605','2014-01-01','2013-12-23 14:43:24','180.00',NULL,NULL,'260.25','80.25','R-OH001','OH0','260.25',NULL,0,'2013-12-26 13:14:17'),(414,340,'N','19','021','EC','A',NULL,NULL,'','0000847129','0000393637','','IL','1','New','Gavin','','','','34','695582901','5838 EDGEHILL DR',0,'PARMA HEIGHTS','OH','44130','2023','CY','39035','2011-08-03','M','',':RET:2106-3','N','021','DEN','1007424','99734OH005000401','2014-01-01','2013-12-04 15:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:29'),(1661,1387,'Y','18','021','EC','A','','','AC','0000296010','0000296010','TX00001468740','IL','1','WAYNE','CECELIA','','','','34','459335321','13300 HWY 154 EAST',0,'DIANA','TX','75640',NULL,'CY','48459','1969-12-08','F','U',':RET:2054-5','T','021','DEN','2218150','33348TX002000201','2014-01-01','2013-12-24 17:15:01','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:53:37'),(9308,7380,'Y','18','024','14','A','','','TE','0000383016','0000383016','','IL','1','Rick','Melanie','H',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-08-12','F','',NULL,NULL,NULL,'','1114789','','2013-12-20','2013-12-20 20:01:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 04:30:10'),(16044,12847,'Y','18','021','EC','A','','','AC','0001176048','0001176048','TX00002118664','IL','1','Thompson','Clifton','','','','34','462697149','591 RELIANCE DR',0,'BUDA','TX','78610','4995','CY','48209','1971-08-14','M','U',':RET:2106-3','N','021','DEN','1609674','33348TX002000101','2014-02-01','2014-01-03 13:25:54','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-04 02:02:57'),(19465,15515,'Y','18','021','EC','A','','','AC','0000632511','0000632511','TX00002395348','IL','1','Caballero','Joel','','','','34','461450343','502 E EDWARDS ST',0,'CRYSTAL CITY','TX','78839','2632','CY','48507','1970-10-12','M','U',':RET:2106-3','N','021','DEN','2305094','33348TX002000201','2014-03-01','2014-01-22 10:41:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 03:01:57'),(21508,17183,'Y','18','024','14','A','','','TE','0000687249','0000687249','','IL','1','Anderson','Terry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-20','F','',NULL,NULL,NULL,'','2825346','','2014-02-04','2014-02-04 17:22:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:56'),(22672,18105,'Y','18','021','EC','A','','','AC','0000012898','0000012898','TX00002207396','IL','1','MEDRANO','SILVIA','','','','34','623283402','4808 BIG BEND DR',0,'WICHITA FALLS','TX','76310','1108','CY','48485','1964-06-20','F','M',NULL,'N','021','DEN','2852585','33348TX002000201','2014-03-01','2014-02-11 15:22:53','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-11 21:00:42'),(25417,20167,'Y','18','021','EC','A','','','AC','0000191380','0000191380','OH00003308394','IL','1','Catania','Catherine','','','','34','283863556','754 SHERWOOD DR',0,'AURORA','OH','44202','7826','CY','39133','1982-01-31','F','U',NULL,'N','021','DEN','3824820','99734OH005000401','2014-04-01','2014-02-25 14:19:23','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:31:07'),(26979,21373,'Y','18','021','EC','A','','','AC','0001024334','0001024334','OH00003118937','IL','1','Blessing','Annetta','','','','34','276645788','4188 Kincheloe Rd.',0,'Georgetown','OH','45121',NULL,'CY','39015','1960-05-24','F','M',':RET:2106-3','N','021','HLT','3749471','92036OH004000601','2014-04-01','2014-03-02 12:31:19','753.42',NULL,NULL,'758.97','5.55','R-OH005','OH0','352.13',NULL,0,'2014-03-03 01:00:38'),(28559,22602,'Y','18','021','EC','A','','','AC','0000558117','0000558117','MS00003120578','IL','1','LEWES','FANNIE','M','','','34','425041426','1098 MACKS ROAD',0,'BOLTON','MS','39041',NULL,'CY','28049','1959-09-20','F','U',':RET:2054-5','N','021','DEN','3457590','46300MS002000101','2014-04-01','2014-03-07 17:25:55','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-07 21:32:24'),(160,134,'Y','18','021','EC','A','','','AC','0000822879','0000822879','TX00000591058','31','1','Moye','John','S','','','34','304629147','3705 CONCORD RD',0,'BEAUMONT','TX','77703','2705','CY','48245','1959-04-23','M','R',':RET:2106-3','N','021','DEN','606625','33348TX002000101','2014-01-01','2013-12-05 12:42:16','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2013-12-25 17:19:10'),(4672,3704,'Y','18','021','EC','A','','','AC','0000696999','0000696999','LA00000143426','IL','1','DAUGHERTY','AMANDA','','','','34','437961470','107 HAPPY LN',0,'FERRIDAY','LA','71334','3623','CY','22029','1969-10-15','F','M',':RET:2106-3','N','021','DEN','493548','18575LA002000201','2014-01-01','2013-12-12 14:34:15','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-25 22:07:39'),(8165,6460,'Y','18','021','EC','A','','','AC','0000794457','0000794457','OH00000962908','IL','1','STEINER','LAURIE','','','','34','299528161','116 E MAIN ST',0,'SOUTH AMHERST','OH','44001','2814','CY','39093','1952-10-17','F','M',NULL,'N','021','HLT','1238218','92036OH003000801','2014-01-01','2013-11-22 11:21:04','519.00',NULL,NULL,'686.10','167.10','R-OH011','OH0','686.10',NULL,0,'2013-12-26 03:16:28'),(17104,13688,'N','01','021','EC','A',NULL,NULL,'','0000550712','0000487912','','IL','1','McInturff','Catherine','S','','','34','442565088','1301 Limestone Drive',0,'Corpus Christi','TX','78412',NULL,'CY','48355','1950-12-11','F','',':RET:2106-3','N','021','DEN','2507059','33348TX002000201','2014-02-01','2014-01-08 17:26:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:21:33'),(17418,13939,'N','01','021','EC','A',NULL,NULL,'','0000484810','0000541662','','IL','1','Boyd','Robert','','','','34','280562107','12789 STATE ROUTE 774',0,'BETHEL','OH','45106','8672','CY','39015','1954-06-03','M','',':RET:2106-3','N','021','HLT','1858143','92036OH003000605','2014-02-01','2014-01-10 10:17:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','583.55',NULL,0,'2014-01-13 03:00:25'),(20141,16073,'Y','18','021','EC','A','','','AC','0000119094','0000119094','OH00002426601','IL','1','Darks','Jade','','','','34','295947723','3353 queen city ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1992-03-12','F','M',':RET:2054-5','N','021','DEN','2934263','99734OH005000401','2014-03-01','2014-01-27 16:05:04','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:00:58'),(22600,18050,'N','01','021','EC','A',NULL,NULL,'','0000218874','0000347955','','IL','1','MAYS','MICHAEL','','','','34','272582744','6839 BEECHWOOD RD',0,'HILLSBORO','OH','45133','8450','CY','39071','1955-04-01','M','',NULL,'N','021','HLT','2895812','92036OH002000601','2014-03-01','2014-02-10 13:51:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','631.66',NULL,0,'2014-02-10 21:32:14'),(28842,22823,'N','01','021','EC','A',NULL,NULL,'','0000432825','0001129084','','IL','1','Messenger','Gary','Dwaine','','','34','276420378','2972 PIKES AVE',0,'AKRON','OH','44314','1006','CY','39153','1946-12-18','M','',':RET:2106-3','N','021','HLT','3616292','52664OH151001501','2014-04-01','2014-03-09 13:10:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','802.38',NULL,0,'2014-03-09 21:01:13'),(1178,970,'Y','18','021','EC','A','','','AC','0000321013','0000321013','OH00000426249','IL','1','Cryder','Robert','','','','34','300841665','3721 Woodland Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1985-04-14','M','U',':RET:2106-3','N','021','HLT','382936','92036OH004001201','2014-01-01','2013-12-02 20:07:02','46.00',NULL,NULL,'187.64','141.64','R-OH004','OH0','187.64',NULL,0,'2013-12-25 18:19:18'),(14617,11667,'Y','18','021','EC','A','','','AC','0000398616','0000398616','OH00000496612','IL','1','Kutz','Jeffrey','','','','34','275563572','4314 WUEBOLD LN',0,'CINCINNATI','OH','45245','1817','CY','39025','1953-12-10','M','M',':RET:2106-3','N','021','HLT','2036896','92036OH005000601','2014-02-01','2013-12-27 08:38:15','562.00',NULL,NULL,'1165.20','603.20','R-OH005','OH0','582.60',NULL,0,'2013-12-28 03:36:51'),(13483,10751,'Y','18','021','EC','A','','','AC','0000111893','0000111893','OH00000390979','IL','1','Schilling','William','','','','34','285409601','984 HOMEWOOD AVE',0,'SALEM','OH','44460','3816','CY','39029','1950-03-28','M','R',NULL,'N','021','DEN','2023421','99734OH005000301','2014-01-01','2013-12-23 17:38:18','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-26 13:02:15'),(1652,1380,'Y','18','021','EC','A','','','AC','0001009017','0001009017','TX00001558299','IL','1','NEWSOME','TOSHIA','','','','34','452910721','1308 PATSYS GLEN',0,'BRYAN','TX','77803',NULL,'CY','48041','1977-04-08','F','U',':RET:2054-5','N','021','DEN','1417548','33348TX002000201','2014-01-01','2013-12-24 16:30:12','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 18:53:22'),(2260,1851,'N','19','021','EC','A',NULL,NULL,'','0000909454','0001060882','','IL','1','Andreadis','Devi','','','','34','294042314','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','2000-02-18','F','',':RET:2106-3','N','021','DEN','19816','99734OH005000301','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:14'),(3494,2805,'N','01','021','EC','A',NULL,NULL,'','0000271418','0001102086','','IL','1','Schwartz','Steven','','','','34','286426577','7790 Sugar Grove Road',0,'Covington','OH','45318',NULL,'CY','39109','1952-07-23','M','',':RET:2106-3','N','021','DEN','1993536','99734OH005000401','2014-01-01','2013-12-22 14:14:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:31'),(3430,2755,'Y','18','021','EC','A','','','AC','0002249006','0002249006','LA00000694024','31','1','Prejean','Alexius','','','','34','436512454','P.O. BOX 80871',0,'LAFAYETTE','LA','70598',NULL,'CY','22055','1982-08-19','F','U',':RET:2054-5','N','021','DEN','2254014','18575LA002000101','2014-01-01','2013-12-21 19:34:28','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 21:18:54'),(4611,3651,'N','01','021','EC','A',NULL,NULL,'','0000166355','0001089536','','IL','1','Stoll','Anita','','','','34','272463765','1410 CREST AVE',0,'CUYAHOGA FALLS','OH','44223','2060','CY','39153','1952-12-20','F','',':RET:2106-3','N','021','HLT','865653','52664OH151001501','2014-01-01','2013-12-12 09:49:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2013-12-25 22:05:59'),(19194,15293,'Y','18','021','EC','A','','','AC','0000427340','0000427340','TX00001502998','IL','1','WADE','HOWARD','','','','34','455048766','2610 CODY CT',0,'MIDLOTHIAN','TX','76065',NULL,'CY','48139','1969-10-28','M','M',NULL,'N','021','DEN','2105914','33348TX002000101','2014-03-01','2014-01-20 14:18:37','0.00',NULL,NULL,'148.50','148.50','R-TX008','TX0','27.15',NULL,0,'2014-01-21 08:46:14'),(1066,873,'Y','18','021','EC','A','','','AC','0000121502','0000121502','OH00001005273','IL','1','Sarkis','George','','','','34','290747813','1289 WARREN RD',0,'LAKEWOOD','OH','44107','2515','CY','39035','1951-12-05','M','M',':RET:2106-3','N','021','DEN','1092913','99734OH005000401','2014-01-01','2013-12-02 22:37:37','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:24'),(14671,11712,'Y','18','021','EC','A','','','AC','0000932501','0000932501','TX00001848313','IL','1','Harris','Anthony','','','','34','228474728','8128 County Road 3409',0,'Chandler','TX','75758',NULL,'CY','48213','1975-03-27','M','M',':RET:2106-3','N','021','DEN','2250650','33348TX002000201','2014-02-01','2013-12-28 17:51:40','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:08:15'),(1174,967,'Y','18','021','EC','A','','','AC','0000820976','0000820976','OH00001130691','IL','1','Smith','Don','','','','34','268521448','1715 Arndale Rd.',0,'Stow','OH','44224',NULL,'CY','39153','1951-10-26','M','M',':RET:2106-3','N','021','HLT','244527','52664OH151001501','2014-01-01','2013-12-03 14:12:28','675.00',NULL,NULL,'1520.01','845.01','R-OH012','OH0','768.43',NULL,0,'2013-12-25 18:19:12'),(2022,1657,'N','19','021','EC','A',NULL,NULL,'','0001075287','0000180984','','IL','1','Ridgeway','Steven','J','','','34','294085960','1522 Newton Pass',0,'Broadview Heights','OH','44147',NULL,'CY','39035','2000-10-04','M','',NULL,'N','021','HLT','1121237','52664OH152000901','2014-01-01','2013-12-09 21:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','116.98',NULL,0,'2013-12-25 19:15:08'),(7877,6231,'N','01','021','EC','A',NULL,NULL,'','0000062527','0000171228','','IL','1','schindler','sandra','','','','34','559824926','1580 CREEKSIDE RD',0,'AMELIA','OH','45102','1794','CY','39025','1957-01-25','F','',':RET:2106-3','N','021','DEN','1620752','99734OH005000301','2014-01-01','2013-12-20 17:20:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:19'),(15923,12750,'N','01','021','EC','A',NULL,NULL,'','0000681876','0000880491','','IL','1','Arrington','Robert','','','','34','426193822','142 Mansell Rd',0,'Camden','MS','39045',NULL,'CY','28089','1960-03-21','M','',':RET:2054-5','T','021','DEN','1938213','46300MS002000201','2014-02-01','2014-01-02 13:08:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-03 02:06:43'),(17515,14002,'Y','18','021','EC','A','','','AC','0000721360','0000721360','OH00001981345','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','N','021','DEN','1705471','99734OH005000401','2014-02-01','2014-01-12 10:03:38','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:32'),(17657,14112,'Y','18','021','EC','A','','','AC','0000572012','0000572012','OH00001593764','IL','1','ADKINS','DIANA','','','','34','286687906','386 MAUMEE DR',0,'CIRCLEVILLE','OH','43113',NULL,'CY','39129','1973-01-06','F','U',':RET:2106-3','N','021','DEN','2050135','99734OH005000301','2014-02-01','2014-01-13 14:45:05','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:32:43'),(18604,14832,'Y','18','024','14','A','','','TE','0000816438','0000816438','','IL','1','CAMPOLONGO','DANTE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-27','M','',NULL,NULL,NULL,'','2257217','','2014-01-15','2014-01-15 16:53:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:47:20'),(19420,15482,'Y','18','021','EC','A','','','AC','0000432789','0000432789','OH00001515255','IL','1','Livingston','Christen','','','','34','302742697','4722 BOWSER DR',0,'TOLEDO','OH','43613','3002','CY','39095','1979-07-26','M','M',NULL,'N','021','HLT','2315045','92036OH001002601','2014-03-01','2014-01-21 13:43:37','0.00',NULL,NULL,'713.17','713.17','R-OH001','OH0','285.54',NULL,1,'2014-01-22 03:23:02'),(23485,18707,'Y','18','021','EC','A','','','AC','0001912126','0001912126','LA00001435531','IL','1','Toman','Joseph','','','','34','383044715','1141 Decatur',0,'New Orleans','LA','70116',NULL,'CY','22071','1976-12-17','M','U',':RET:2106-3','N','021','DEN','3710862','18575LA002000101','2014-03-01','2014-02-13 14:09:43','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-13 22:01:58'),(26483,21007,'Y','18','021','EC','A','','','AC','0000959870','0000959870','TX00003438970','IL','1','malano','tarah','','','','34','336725057','7023 PINE VISTA LN',0,'HOUSTON','TX','77092','1012','CY','48201','1970-11-03','F','U',':RET:2106-3','N','021','DEN','3182540','33348TX002000201','2014-04-01','2014-02-28 17:55:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-28 21:00:05'),(27897,22070,'Y','18','021','EC','A','','','AC','0000380119','0000380119','OH00003000399','IL','1','Cropper','Sonja','','','','34','298562071','130 N 2nd Street',0,'Ripley','OH','45167',NULL,'CY','39015','1955-02-13','F','U',':RET:2106-3','N','021','HLT','4051477','92036OH003000605','2014-04-01','2014-03-05 16:41:47','432.00',NULL,NULL,'583.55','151.55','R-OH005','OH0','583.55',NULL,0,'2014-03-05 21:32:43'),(766,633,'Y','18','021','EC','A','','','AC','0001252967','0001252967','TX00000136342','IL','1','Anderson','Linda','Susan','','','34','465883281','5508 COUNTY ROAD 522',0,'STEPHENVILLE','TX','76401','7454','CY','48143','1950-06-22','F','M',':RET:2106-3','N','021','DEN','2496443','33348TX002000201','2014-01-01','2013-12-16 12:09:44','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:42'),(5520,4378,'N','01','021','EC','A',NULL,NULL,'','0001203186','0000697869','','IL','1','Bredenfoerder','John','Henry','','','34','274541770','8751 HAVERHILL LN',0,'CINCINNATI','OH','45236','2119','CY','39061','1952-01-27','M','',':RET:2106-3','N','021','DEN','815801','99734OH005000301','2014-01-01','2013-11-27 15:23:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:17'),(15111,12078,'Y','18','021','EC','A','','','AC','0000394943','0000394943','OH00000626444','IL','1','Craft','Rachel','','','','34','308868806','275 KINKER DR',0,'WHEELERSBURG','OH','45694','8103','CY','39145','1970-02-28','F','U',':RET:2106-3','N','021','DEN','2078832','99734OH005000301','2014-02-01','2013-12-30 13:26:15','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-01 12:04:58'),(17799,14218,'Y','18','021','EC','A','','','AC','0000733611','0000733611','OH00002350449','IL','1','Hancher','Maria','','','','34','579747840','55 MILTON AVE',0,'YOUNGSTOWN','OH','44509','2843','CY','39099','1952-12-19','F','M',NULL,'N','021','HLT','2270576','92036OH004003201','2014-02-01','2014-01-13 16:20:58','542.92',NULL,NULL,'546.92','4.00','R-OH013','OH0','546.92',NULL,0,'2014-01-14 01:33:53'),(18305,14614,'Y','18','021','EC','A','','','AC','0001231780','0001231780','OH00001582931','IL','1','MELLUSO','REBECCA','L','','','34','297885759','1411 IROQUOIS AVE',0,'MAYFIELD HEIGHTS','OH','44124','1550','CY','39035','1980-05-26','F','R',NULL,'N','021','DEN','2549151','99734OH005000401','2014-02-01','2014-01-15 10:54:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:44:59'),(19421,15482,'N','19','021','EC','A',NULL,NULL,'','0000432789','0000132098','','IL','1','Livingston','Nathan','','','','34','293085586','4722 BOWSER DR',0,'TOLEDO','OH','43613','3002','CY','39095','2004-02-03','M','',NULL,'N','021','HLT','2315045','92036OH001002601','2014-03-01','2014-01-21 13:43:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','149.37',NULL,1,'2014-01-22 03:23:02'),(25674,20369,'Y','18','021','EC','A','','','AC','0000072934','0000072934','OH00002555524','IL','1','Mkhize','Dumisani','','','','34','395177252','900 SELBY ST',0,'FINDLAY','OH','45840','6024','CY','39063','1956-06-18','M','M',':RET:2054-5','N','021','HLT','3581637','92036OH004001501','2014-04-01','2014-02-22 12:18:27','793.00',NULL,NULL,'932.79','139.79','R-OH002','OH0','431.27',NULL,0,'2014-02-26 08:30:54'),(27544,21787,'Y','18','024','14','A','','','TE','0000879493','0000879493','','IL','1','HILL','KIM',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-30','F','',NULL,NULL,NULL,'','1716452','','2014-03-31','2014-03-04 11:56:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:08'),(27555,21796,'Y','18','024','14','A','','','TE','0000273032','0000273032','','IL','1','RODRIGUEZ','DELIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-10','F','',NULL,NULL,NULL,'','2302617','','2014-03-31','2014-03-04 14:59:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-04 21:30:14'),(27664,21882,'Y','18','021','EC','A','','','AC','0000041009','0000041009','OH00002746897','IL','1','Wagner','Lowell','','','Jr','34','287465744','3943 OLD TROY PIKE',0,'DAYTON','OH','45404','1322','CY','39113','1957-08-09','M','M',':RET:2106-3','N','021','DEN','3858427','99734OH005000401','2014-05-01','2014-03-05 16:27:48','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-03-05 21:30:29'),(4009,3203,'Y','18','021','EC','A','','','AC','0001022763','0001022763','OH00000603566','IL','1','Nguyen','Tho','','','','34','543613935','5936 COTTONWOOD KNL',0,'HAMILTON','OH','45011','8487','CY','39017','1970-12-12','M','M',':RET:2047-9','T','021','DEN','2499078','99734OH005000401','2014-01-01','2013-12-16 21:54:33','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:22'),(3197,2571,'Y','18','021','EC','A','','','AC','0000794450','0000794450','OH00000743031','IL','1','wheeler','mary','','','','34','283582805','5320 ROMANCE LN',0,'CINCINNATI','OH','45238','5224','CY','39061','1960-09-12','F','U',':RET:2106-3','N','021','DEN','81457','99734OH005000401','2014-01-01','2013-11-01 08:15:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:45:03'),(25754,20427,'Y','18','021','EC','A','','','AC','0000739070','0000739070','OH00002448402','IL','1','Terrell','Catherine','','','','34','587667368','620 TAYLOR ST',0,'SANDUSKY','OH','44870','3441','CY','39043','1952-12-30','F','U',NULL,'N','021','DEN','3843592','99734OH005000401','2014-04-01','2014-02-24 16:42:29','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-26 09:30:47'),(27557,21798,'Y','18','024','14','A','','','TE','0000982460','0000982460','','IL','1','CONNER','KATHY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-03-13','F','',NULL,NULL,NULL,'','1457685','','2014-03-31','2014-03-04 16:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-04 21:30:15'),(28809,22802,'N','01','021','EC','A',NULL,NULL,'','0000615576','0000489313','','IL','1','robinson','carol','i','','','34','296502263','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1953-07-11','F','',':RET:2106-3','N','021','HLT','3047642','52664OH151001306','2014-05-01','2014-03-09 10:14:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2014-03-09 21:00:53'),(2818,2278,'N','01','021','EC','A',NULL,NULL,'','0000085143','0000646185','','IL','1','Parker','Jeffery','','','','34','587355991','147 Flag Chapel Circle',0,'Jackson','MS','39213',NULL,'CY','28049','1964-09-30','M','',':RET:2054-5','N','021','DEN','621801','46300MS002000201','2014-01-01','2013-11-23 20:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 20:00:25'),(13132,10474,'Y','18','021','EC','A','','','AC','0000300409','0000300409','OH00000081959','IL','1','Trigg','Chris','Jeffrey','','','34','287749012','3780 ABBE RD',0,'SHEFFIELD VILLAGE','OH','44054','2936','CY','39093','1963-05-29','M','M',':RET:2106-3','N','021','DEN','2413976','99734OH005000401','2014-01-01','2013-12-23 14:56:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:03'),(15597,12481,'Y','18','021','EC','A','','','AC','0001084159','0001084159','OH00000532018','31','1','brinkman','robert','','','','34','275508179','PO Box 7017',0,'cincinnati','OH','45205',NULL,'CY','39061','1979-08-04','M','U',NULL,'T','021','DEN','1855197','99734OH005000301','2014-02-01','2013-12-31 14:25:13','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:32:33'),(16310,13058,'Y','18','021','EC','A','','','AC','0001413920','0001413920','LA00002101268','IL','1','Baty','Charntel','','','','34','439331803','5027 BURNAMAN ST',0,'ALEXANDRIA','LA','71302','2902','CY','22079','1973-03-06','F','U',':RET:2054-5','N','021','DEN','1476781','18575LA002000201','2014-02-01','2014-01-06 13:10:59','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-07 04:01:23'),(22250,17759,'Y','18','021','EC','A','','','AC','0000050715','0000050715','OH00001676816','IL','1','CONTI','FRANCO','','','','34','278500559','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1959-12-19','M','M',':RET:2106-3','N','021','HLT','3549898','52664OH151001501','2014-03-01','2014-02-09 13:33:32','392.00',NULL,NULL,'1259.44','867.44','R-OH011','OH0','644.05',NULL,0,'2014-02-09 19:00:42'),(26141,20727,'N','01','021','EC','A',NULL,NULL,'','0000153425','0001234171','','IL','1','BELISARI','JOHN','','','','34','302504075','501 E BROAD ST',0,'COLUMBUS','OH','43215','3822','CY','39049','1952-09-18','M','',NULL,'N','021','DEN','3279910','99734OH005000401','2014-04-01','2014-02-27 12:38:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:25'),(27865,22041,'Y','18','024','14','A','','','TE','0000111950','0000111950','','IL','1','jewell','tara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-05-03','F','',NULL,NULL,NULL,'','2894030','','2014-03-05','2014-03-05 09:34:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:22'),(4584,3630,'Y','18','021','EC','A','','','AC','0000112913','0000112913','OH00000924823','IL','1','RUBINO','MERCEDES','','','','34','282543618','1493 APOLLO DR',0,'STOW','OH','44224',NULL,'CY','39153','1953-10-26','F','M',NULL,'N','021','HLT','1190687','52664OH151001301','2014-01-01','2013-12-12 07:39:21','743.00',NULL,NULL,'1274.24','531.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 22:05:18'),(1020,835,'Y','18','021','EC','A','','','AC','0000679559','0000679559','MS00001090881','31','1','Robinson','Ruthia','','','','34','587805825','P.O. Box 173',0,'Winona','MS','38967',NULL,'CY','28097','1953-02-07','F','U',':RET:2054-5','N','021','DEN','1156705','46300MS002000201','2014-01-01','2013-12-03 14:04:38','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:15:12'),(9081,7205,'N','01','021','EC','A',NULL,NULL,'','0001105518','0000542660','','IL','1','McIlvain','Robert','Scott','','','34','280909590','2134 miller',0,'Alliance','OH','44601',NULL,'CY','39151','1984-06-12','M','',':RET:2106-3','N','021','DEN','1798952','99734OH005000301','2014-01-01','2013-12-17 22:42:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:06:50'),(7816,6192,'N','19','021','EC','A',NULL,NULL,'','0001192671','0000409093','','IL','1','patel','dipesh','a',NULL,NULL,NULL,NULL,'5121 Timber Creek Dr',0,'Tyler','TX','75703',NULL,'CY','48423','2005-02-12','M','',':RET:2029-7','N','021','DEN','1760231','33348TX002000201','2014-01-01','2013-12-20 18:02:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2013-12-26 03:04:05'),(7173,5688,'Y','18','021','EC','A','','','AC','0000285648','0000285648','OH00000659908','IL','1','Gase','Bryan','','','','34','301822980','3087 Westminster Dr',0,'Beavercreek','OH','45431',NULL,'CY','39057','1982-06-03','M','R',':RET:2106-3','T','021','HLT','2071101','92036OH006000501','2014-02-01','2013-12-25 15:45:15','0.00',NULL,NULL,'251.27','251.27','R-OH003','OH0','251.27',NULL,0,'2013-12-26 01:52:46'),(2020,1657,'Y','18','021','EC','A','','','AC','0001075287','0001075287','OH00001256504','IL','1','Ridgeway','William','C','','Jr','34','272568359','1522 Newton Pass',0,'Broadview Heights','OH','44147',NULL,'CY','39035','1954-08-07','M','M',NULL,'N','021','HLT','1121237','52664OH152000901','2014-01-01','2013-12-09 21:02:02','615.00',NULL,NULL,'1143.28','528.28','R-OH011','OH0','479.53',NULL,0,'2013-12-25 19:15:07'),(6143,4872,'Y','18','021','EC','A','','','AC','0000814253','0000814253','OH00001018045','IL','1','Goeters','Grant','','','','34','388762714','2423 6TH ST NW',0,'CANTON','OH','44708','4411','CY','39151','1958-02-20','M','U',':RET:2106-3','N','021','DEN','210855','99734OH005000301','2014-01-01','2013-11-21 15:37:18','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 00:16:20'),(17329,13862,'Y','18','021','EC','A','','','AC','0001452405','0001452405','LA00001989925','IL','1','Brown','Jessabella','','','','34','426599187','116 ELMIRA AVE',0,'NEW ORLEANS','LA','70114',NULL,'CY','22071','1975-12-25','F','M',':RET:2106-3','N','021','DEN','2602108','18575LA002000201','2014-02-01','2014-01-10 12:14:44','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:23:56'),(19307,15390,'Y','18','021','EC','A','','','AC','0001791261','0001791261','LA00002325812','IL','1','Winn','Latosha','','','','34','433551001','8165 Plank rd',0,'baton rouge','LA','70811',NULL,'CY','22033','1983-09-06','F','U',':RET:2054-5','N','021','DEN','1700223','18575LA002000101','2014-03-01','2014-01-21 16:14:58','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-22 03:22:03'),(19488,15533,'Y','18','021','EC','A','','','AC','0001028211','0001028211','TX00002025198','IL','1','HERNANDEZ','JANIE','','','','34','467847213','1005 E COMAL ST',0,'PEARSALL','TX','78061','4201','CY','48163','1950-07-03','F','M',NULL,'N','021','DEN','2182865','33348TX002000201','2014-03-01','2014-01-22 15:25:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 03:02:05'),(20041,15982,'Y','18','021','EC','A','','','AC','0000648353','0000648353','OH00002222544','IL','1','stewart','stephen','','','','34','271705466','4464 west 8th. st.',0,'cincinnati','OH','45238',NULL,'CY','39061','1960-04-20','M','U',':RET:2106-3','T','021','HLT','2762134','92036OH006001201','2014-03-01','2014-01-26 08:55:48','156.00',NULL,NULL,'399.40','243.40','R-OH004','OH0','399.40',NULL,0,'2014-01-26 19:00:26'),(23119,18428,'Y','18','021','EC','A','','','AC','0000270056','0000270056','OH00001649924','IL','1','CLARKE','ELYSE','','','','34','165629583','4205 HEGNER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1965-03-15','F','M',':RET:2106-3','N','021','DEN','2856415','99734OH005000401','2014-03-01','2014-02-12 12:21:16','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:23'),(24050,19127,'N','01','021','EC','A',NULL,NULL,'','0000509252','0000469590','','IL','1','GILBERT','JOSHUA','E','','','34','379085960','3795 W 140TH ST',0,'CLEVELAND','OH','44111','4902','CY','39035','1983-12-21','M','',':RET:2054-5','N','021','DEN','3638616','99734OH005000301','2014-03-01','2014-02-15 11:20:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:04'),(24241,19250,'Y','18','021','EC','A','','','AC','0000177678','0000177678','OH00002449333','IL','1','Sexton','Jerry','','','','34','293722737','935 Hathaway Dr.',0,'Trenton','OH','45067',NULL,'CY','39017','1974-04-15','M','M',NULL,'T','021','HLT','2768781','92036OH004001201','2014-03-01','2014-02-15 22:14:08','332.00',NULL,NULL,'694.47','362.47','R-OH004','OH0','250.51',NULL,0,'2014-02-16 19:00:39'),(27365,21671,'Y','18','021','EC','A','','','AC','0000822115','0000822115','OH00002921740','IL','1','Poteet','Colleen','','','','34','278563784','4913 BATH RD',0,'DAYTON','OH','45424','1756','CY','39057','1967-02-21','F','M',':RET:2106-3','T','021','DEN','2782074','99734OH005000401','2014-04-01','2014-03-04 17:59:40','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00',NULL,0,'2014-03-04 21:01:13'),(379,314,'Y','18','021','EC','A','','','AC','0000815505','0000815505','TX00000484533','IL','1','gomez','michelle','','','','34','454693986','203 deer run',0,'pleasanton','TX','78064',NULL,'CY','48013','1969-11-30','F','U',':RET:2106-3','N','021','DEN','303241','33348TX002000201','2014-01-01','2013-12-04 03:54:10','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 17:45:39'),(13253,10577,'Y','18','021','EC','A','','','AC','0000201754','0000201754','TX00000881101','IL','1','Givens','Katrina','','','','34','467231246','310 Sorrel St',0,'Duncanville','TX','75137',NULL,'CY','48113','1970-04-20','F','U',':RET:2054-5','N','021','DEN','1742024','33348TX002000201','2014-01-01','2013-12-23 11:20:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:56:27'),(3781,3029,'Y','18','024','14','A','','','TE','0001227005','0001227005','','IL','1','Phillips','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-31','F','',NULL,NULL,NULL,'','1026823','','2013-12-12','2013-12-12 23:06:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:00'),(3983,3180,'Y','18','021','EC','A','','','AC','0000564191','0000564191','OH00001298404','IL','1','Sims','Steven','Troy','','','34','281828519','638 ELLEN DR',0,'CINCINNATI','OH','45255','4917','CY','39025','1972-09-04','M','U',':RET:2106-3','T','021','HLT','8867','92036OH006000601','2014-01-01','2013-12-13 13:09:03','116.00',NULL,NULL,'254.91','138.91','R-OH005','OH0','254.91',NULL,0,'2013-12-25 21:38:52'),(15028,12011,'Y','18','021','EC','A','','','AC','0002244822','0002244822','LA00001705198','IL','1','Jackson','Christine','Smith','','','34','438112246','701 FairFax Dr.',0,'TerryTown','LA','70056',NULL,'CY','22051','1957-12-10','F','U',':RET:2054-5','N','021','DEN','1602131','18575LA002000201','2014-02-01','2013-12-30 06:09:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:32'),(7110,5640,'Y','18','021','EC','A','','','AC','0001411253','0001411253','LA00001460727','IL','1','Vercher','Joshua','','','','34','436697968','604 N ADAMS AVE',0,'RAYNE','LA','70578','6035','CY','22001','1979-10-08','M','U',':RET:1002-5','N','021','DEN','1809566','18575LA002000101','2014-01-01','2013-12-24 21:31:44','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-26 01:51:00'),(18470,14736,'Y','18','021','EC','A','','','AC','0000930930','0000930930','OH00001380585','IL','1','Trump','Shelly','','','','34','285728592','112 Emerald Avenue',0,'Streetsboro','OH','44241',NULL,'CY','39133','1963-01-29','F','M',NULL,'N','021','HLT','2648242','52664OH151001304','2014-02-01','2014-01-14 20:06:54','645.00',NULL,NULL,'973.43','328.43','R-OH012','OH0','415.91',NULL,0,'2014-01-16 08:46:17'),(22453,17926,'N','01','021','EC','A',NULL,NULL,'','0000702453','0000069532','','IL','1','De la Rosa','Francisco','','','','34','454535499','7097 3RD ST',0,'CANUTILLO','TX','79835','5492','CY','48141','1969-01-01','M','',':RET:2106-3','N','021','DEN','3497031','33348TX002000201','2014-03-01','2014-02-10 14:49:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-10 21:30:47'),(26605,21094,'Y','18','024','14','A','','','TE','0000311547','0000311547','','IL','1','HARRISON','VICTOR',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-22','M','',NULL,NULL,NULL,'','2841319','','2014-02-27','2014-02-27 22:08:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:43'),(28080,22223,'N','01','021','EC','A',NULL,NULL,'','0000164094','0000390960','','IL','1','Gonzales','Cynthia','Y','','','34','467117787','122 STERLING DR',0,'SAN ANTONIO','TX','78220','3133','CY','48029','1957-04-22','F','',NULL,'N','021','DEN','3706027','33348TX002000101','2014-04-01','2014-03-05 22:01:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-06 21:01:57'),(6195,4908,'N','01','021','EC','A',NULL,NULL,'','0000960848','0000421447','','IL','1','Corbin','Bruce','Michael','','','34','640872548','2310 Stillmeadow Drive',0,'Missouri City','TX','77489',NULL,'CY','48157','1973-07-25','M','',':RET:2148-5^:RET:2106-3','N','021','DEN','679303','33348TX002000201','2014-01-01','2013-10-23 15:07:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:30:26'),(14222,11340,'N','01','021','EC','A',NULL,NULL,'','0000903632','0000171191','','IL','1','SMART','WILLIAM','ELLIS','','','34','451021638','1700 S COMMERCE ST',0,'KILGORE','TX','75662','3171','CY','48183','1954-12-20','M','',':RET:2106-3','T','021','DEN','2018728','33348TX002000201','2014-02-01','2013-12-26 16:52:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-27 02:04:45'),(1376,1141,'Y','18','021','EC','A','','','AC','0001276960','0001276960','LA00001474758','IL','1','Pratt','Laurie','','','','34','439118089','16135 CODY LN',0,'COVINGTON','LA','70435','7933','CY','22103','1957-03-11','F','U',':RET:2106-3','N','021','DEN','2391774','18575LA002000201','2014-01-01','2013-12-24 03:36:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:45:57'),(7631,6040,'Y','18','021','EC','A','','','AC','0000060215','0000060215','OH00001085934','IL','1','Clark','David','','','','34','285828868','530 PERRY ST',0,'KENT','OH','44240','2726','CY','39133','1981-03-25','M','U',NULL,'N','021','HLT','350441','52664OH151001306','2014-01-01','2013-10-13 20:10:26','100.00',NULL,NULL,'263.82','163.82','R-OH012','OH0','263.82',NULL,0,'2013-12-26 02:46:14'),(5681,4508,'Y','18','021','EC','A','','','AC','0000545205','0000545205','OH00000175208','IL','1','CARNAHAN','PAMELA','','','','34','295521099','1830 JONES FLORER RD',0,'BETHEL','OH','45106','8525','CY','39025','1949-11-04','F','M',NULL,'N','021','HLT','1063385','92036OH004000601','2014-01-01','2013-11-26 15:25:52','285.00',NULL,NULL,'517.83','232.83','R-OH005','OH0','517.83',NULL,0,'2013-12-25 23:32:19'),(4778,3792,'Y','18','024','14','A','','','TE','0000133518','0000133518','','IL','1','Jobe','Shemekisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-05-17','F','',NULL,NULL,NULL,'','1250398','','2013-12-08','2013-12-08 10:02:23',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 22:16:02'),(2065,1690,'Y','18','021','EC','A','','','AC','0000928481','0000928481','OH00000034455','31','1','Perryman','Tracee','','','','34','276768243','P. O. Box 5308',0,'Toledo','OH','43611',NULL,'CY','39095','1978-11-27','F','U',':RET:2054-5','N','021','DEN','830825','99734OH005000301','2014-01-01','2013-12-10 16:40:39','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 19:16:12'),(4203,3343,'Y','18','021','EC','A','','','AC','0000360260','0000360260','TX00000767768','IL','1','Lambert','Kayla','','','','34','448623739','P.O. Box 566',0,'Alpine','TX','79831',NULL,'CY','48043','1965-07-20','F','M',':RET:2106-3','T','021','DEN','2298101','33348TX002000201','2014-01-01','2013-12-16 20:25:54','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:49:58'),(2162,1779,'Y','18','021','EC','A','','','AC','0000638483','0000638483','OH00000965861','IL','1','METZGER','STACEY','ANN','','','34','295828391','3355 SPRING VALLEY RD',0,'AKRON','OH','44333','1239','CY','39153','1969-05-24','F','U',':RET:2106-3','N','021','HLT','1008841','52664OH151001501','2014-01-01','2013-12-09 19:46:41','162.00',NULL,NULL,'373.65','211.65','R-OH012','OH0','373.65',NULL,0,'2013-12-25 19:18:55'),(23181,18482,'Y','18','021','EC','A','','','AC','0000679586','0000679586','MS00001768533','IL','1','barnett','randall','','','','34','426631825','631 oak st lot 5',0,'mendenhall','MS','39114',NULL,'CY','28127','1988-05-20','M','M',':RET:2106-3','N','021','DEN','2871815','46300MS002000101','2014-03-01','2014-02-11 22:40:30','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-12 21:31:58'),(24860,19710,'Y','18','021','EC','A','','','AC','0000093897','0000093897','OH00002429690','IL','1','Swingle','Mathew','','','','34','280821022','1001 WOODGLEN AVE',0,'NEWTON FALLS','OH','44444','9706','CY','39155','1968-08-22','M','U',':RET:2106-3','N','021','HLT','2856637','52664OH151001501','2014-04-01','2014-02-19 17:48:14','285.00',NULL,NULL,'437.98','152.98','R-OH013','OH0','437.98',NULL,0,'2014-02-20 04:56:46'),(27400,21690,'Y','18','021','EC','A','','','AC','0000707674','0000707674','OH00003107285','S1','1','Ramos','Andrew','','','','34','680176319','8308 WAINSTEAD DR',0,'PARMA','OH','44129','4847','CY','39035','2009-11-12','F','U',':RET:2106-3','N','021','DEN','2752637','99734OH005000301','2014-04-01','2014-03-04 01:59:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2014-03-04 21:01:30'),(27450,21723,'Y','18','021','EC','A','','','AC','0000692982','0000692982','OH00002613212','IL','1','TRPKA','FRANK','','','','34','270502065','555 DAMON ST',0,'AKRON','OH','44310','3903','CY','39153','1956-04-21','M','U',NULL,'T','021','HLT','3387122','52664OH151001501','2014-04-01','2014-03-04 11:49:26','227.00',NULL,NULL,'749.59','522.59','R-OH012','OH0','749.59',NULL,0,'2014-03-04 21:01:58'),(27883,22057,'Y','18','021','EC','A','','','AC','0001055383','0001055383','OH00003628521','IL','1','Beining','Jennelle','','','','34','270841442','3463 PROVIDENCE CIR',0,'LIMA','OH','45801','1745','CY','39003','1981-04-29','F','U',NULL,'N','021','HLT','3873040','92036OH005001505','2014-04-01','2014-03-05 16:10:34','162.00',NULL,NULL,'260.36','98.36','R-OH002','OH0','260.36',NULL,0,'2014-03-05 21:32:33'),(27943,22105,'Y','18','021','EC','A','','','AC','0000347811','0000347811','TX00003012737','31','1','Dudley','Donna','','','','34','456985751','P.O. Box 1942',0,'Dilley','TX','78017',NULL,'CY','48163','1951-10-15','F','M',':RET:2106-3','N','021','DEN','4063820','33348TX002000201','2014-04-01','2014-03-06 14:13:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:33'),(28311,22401,'Y','18','024','14','A','','','TE','0001179578','0001179578','','IL','1','Cantrell','Tyler','Earl',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-28','M','',NULL,NULL,NULL,'','1117234','','2014-03-31','2014-03-07 16:23:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:36'),(28594,22629,'Y','18','021','EC','A','','','AC','0000515894','0000515894','OH00003687294','IL','1','hiris','victor','','','','34','271703672','154 HILLSDALE AVE',0,'ROSSFORD','OH','43460','1253','CY','39173','1960-05-20','M','U',':RET:2106-3','N','021','DEN','3626347','99734OH005000401','2014-04-01','2014-03-08 00:01:29','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-08 21:30:04'),(1549,1292,'Y','18','021','EC','A','','','AC','0001174837','0001174837','MS00000021720','IL','1','Gonzales','Rudy','','','','34','595091713','11775 KLEIN RD',0,'GULFPORT','MS','39503','2928','CY','28047','1965-05-19','M','U',NULL,'N','021','DEN','2592559','46300MS002000201','2014-01-01','2013-12-24 08:24:49','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 18:50:33'),(13722,10950,'Y','18','024','14','A','','','TE','0000872037','0000872037','','IL','1','Thielenhaus','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-29','M','',NULL,NULL,NULL,'','2392738','','2013-12-23','2013-12-23 17:29:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:14'),(13336,10648,'Y','18','021','EC','A','','','AC','0000126752','0000126752','TX00000519553','IL','1','RIOS','ANNETTE','G','','','34','465171625','6270 FM 2039',0,'CALDWELL','TX','77836',NULL,'CY','48051','1963-06-08','F','M',NULL,'N','021','DEN','1675374','33348TX002000201','2014-01-01','2013-12-23 18:04:01','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-26 12:58:45'),(9669,7661,'Y','18','021','EC','A','','','AC','0000172397','0000172397','OH00000975296','31','1','Beam','William','M','','','34','287727302','P.O. Box 78',0,'Port William','OH','45164',NULL,'CY','39027','1962-06-21','M','M',':RET:2106-3','N','021','HLT','2349016','92036OH002000601','2014-01-01','2013-12-21 12:45:03','483.00',NULL,NULL,'1066.52','583.52','R-OH005','OH0','462.36',NULL,0,'2013-12-26 04:39:10'),(15491,12395,'Y','18','021','EC','A','','','AC','0000261507','0000261507','OH00001593464','IL','1','Bennett','Andrew','N P','','','34','300902392','208 N WALNUT ST',0,'BALTIMORE','OH','43105','1238','CY','39045','1984-01-19','M','U',':RET:2106-3','N','021','DEN','1793678','99734OH005000401','2014-02-01','2013-12-31 11:48:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:30'),(7317,5799,'Y','18','021','EC','A','','','AC','0000107676','0000107676','TX00000549172','IL','1','LELEUX','LARA','LEIGH','','','34','456477245','4919 EAGLE TRAIL DR',0,'HOUSTON','TX','77084','2923','CY','48201','1977-02-16','F','U',':RET:2106-3','N','021','DEN','486952','33348TX002000101','2014-01-01','2013-12-14 16:31:26','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:03:30'),(7130,5657,'N','01','021','EC','A',NULL,NULL,'','0000387281','0001173231','','IL','1','Bauer','Linda','JoNelle','','','34','281526991','870 Oak canyon Drive',0,'Loveland','OH','45140',NULL,'CY','39061','1955-06-28','F','',':RET:2106-3','N','021','HLT','2034375','92036OH005001204','2014-02-01','2013-12-25 00:45:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','546.97',NULL,0,'2013-12-26 01:51:34'),(5997,4748,'Y','18','021','EC','A','','','AC','0000841402','0000841402','LA00001088424','IL','1','Coleman','Anthony','','','','34','436219873','2749 Hollywood street',0,'Baton Rouge','LA','70805',NULL,'CY','22033','1967-09-29','M','R',':RET:2054-5','N','021','DEN','943803','18575LA002000201','2014-01-01','2013-11-30 20:56:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:00:14'),(5578,4425,'Y','18','021','EC','A','','','AC','0000491838','0000491838','OH00000154997','IL','1','Snyder','Tabitha','','','','34','272922088','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1986-06-05','F','M',':RET:2106-3','N','021','HLT','1128915','92036OH004002601','2014-01-01','2013-11-05 21:29:15','0.00',NULL,NULL,'342.27','342.27','R-OH001','OH0','164.31',NULL,0,'2013-12-25 23:16:52'),(4785,3797,'N','19','021','EC','A',NULL,NULL,'','0000505713','0000505712','','IL','1','Ruedlinger','Mary','','','','34','277989778','125 GARFIELD ST',0,'WADSWORTH','OH','44281','1431','CY','39103','1995-02-11','F','',':RET:2106-3','N','021','HLT','1233676','52664OH151001305','2014-01-01','2013-12-07 19:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 22:16:12'),(16597,13275,'Y','18','021','EC','A','','','AC','0002016441','0002016441','LA00001354242','IL','1','Davis','Jaquel','','','','34','433718753','3000 Tulane Ave',0,'New Orleans','LA','70119',NULL,'CY','22071','1988-02-16','M','R',':RET:2054-5','N','021','DEN','2612516','18575LA002000201','2014-02-01','2014-01-07 09:51:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:24:03'),(16715,13378,'Y','18','021','EC','A','','','AC','0001153898','0001153898','TX00002181864','31','1','Arcudi','Jason','','','','34','192701448','PO Box 416',0,'Dodge','TX','77334',NULL,'CY','48471','1985-12-06','M','M',':RET:2106-3','N','021','DEN','1921532','33348TX002000201','2014-02-01','2014-01-07 14:59:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:44'),(19170,15273,'Y','18','021','EC','A','','','AC','0000439486','0000439486','TX00001615547','IL','1','Guasa','Rae Beaumont','Provido','','','34','632311902','1109 N MAIN ST',0,'MCALLEN','TX','78501','4330','CY','48215','1966-10-19','M','M',':RET:2036-2','N','021','DEN','1477154','33348TX002000201','2014-03-01','2014-01-20 11:58:29','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-21 08:46:03'),(22428,17908,'Y','18','021','EC','A','','','AC','0000867825','0000867825','TX00002556371','31','1','Klekar','Travis','','','','34','637246954','766 County Road 206',0,'Hallettsville','TX','77964',NULL,'CY','48469','1991-07-25','M','U',':RET:2106-3','N','021','DEN','3223479','33348TX002000201','2014-03-01','2014-02-09 18:40:50','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-10 21:30:34'),(23737,18900,'Y','18','021','EC','A','','','AC','0001105584','0001105584','OH00001976523','IL','1','UMPHENOUR','CAROL','','','','34','280506380','504 SYCAMORE TRL',0,'CORTLAND','OH','44410','1128','CY','39155','1949-11-14','F','U',':RET:2106-3','N','021','DEN','3039431','99734OH005000301','2014-03-01','2014-02-13 22:15:55','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-14 21:31:02'),(25193,19984,'Y','18','021','EC','A','','','AC','0002184664','0002184664','LA00002516574','IL','1','Alexander','Whitney','','','','34','438670746','1120 East 7th Street',0,'Bogalusa','LA','70427',NULL,'CY','22117','1987-11-06','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3027913','18575LA002000101','2014-04-01','2014-02-20 18:46:24','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-21 22:00:41'),(26500,21021,'N','19','021','EC','A',NULL,NULL,'','0001064742','0000103941','','IL','1','PODOLL','OLIVER','','','','34','182782839','5625 NICHOLSON DR',0,'HUDSON','OH','44236','3700','CY','39153','1998-12-28','M','',NULL,'N','021','HLT','3055284','52664OH151001304','2014-03-01','2014-02-28 16:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 21:00:15'),(27001,21385,'Y','18','024','14','A','','','TE','0000624029','0000624029','','IL','1','Burgett','Carol',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-24','F','',NULL,NULL,NULL,'','3881826','','2014-03-03','2014-03-03 08:22:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-03 21:00:02'),(27971,22129,'Y','18','021','EC','A','','','AC','0002393516','0002393516','LA00002826070','IL','1','PORRUA','JORGE','','','','34','435873360','2911 MAINE AVE',0,'KENNER','LA','70065','4715','CY','22051','1951-03-04','M','M',NULL,'N','021','DEN','3918383','18575LA002000201','2014-04-01','2014-03-06 12:51:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:50'),(210,175,'Y','18','021','EC','A','','','AC','0000951114','0000951114','LA00000749806','IL','1','moore','doris','','','','34','433134501','4386 JEFFERSON ST',0,'BAKER','LA','70714','3058','CY','22033','1965-01-14','F','U',':RET:2054-5','N','021','DEN','17656','18575LA002000201','2014-01-01','2013-12-05 09:04:14','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:26'),(6373,5053,'Y','18','021','EC','A','','','AC','0000225997','0000225997','OH00001270077','IL','1','Jackson','Kevin','','','','34','284808401','1984 PINEWOOD DR',0,'BRUNSWICK','OH','44212','4058','CY','39103','1983-06-03','M','U',':RET:2106-3','N','021','DEN','1019999','99734OH005000301','2014-01-01','2013-12-11 08:59:26','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:43'),(1751,1450,'Y','18','021','EC','A','','','AC','0000665651','0000665651','OH00001356716','IL','1','Brown','John','','','','34','232944690','109 S PRIMROSE PL',0,'LIMA','OH','45805','2623','CY','39003','1956-11-26','M','M',NULL,'N','021','DEN','2082437','99734OH005000301','2014-01-01','2013-12-24 12:24:08','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:55:43'),(13761,10984,'Y','18','021','EC','A','','','AC','0000221427','0000221427','MS00000039094','IL','1','Dahlin','Victoria','','','','34','572513145','1014 Carr Road',0,'McComb','MS','39648',NULL,'CY','28113','1968-08-08','F','U',':RET:2106-3','N','021','DEN','2543621','46300MS002000201','2014-01-01','2013-12-23 10:03:33','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:13'),(13303,10620,'Y','18','021','EC','A','','','AC','0001226616','0001226616','TX00000792315','IL','1','Garza','Abelardo','','','Jr','34','467801130','5027 FAIRFORD DR',0,'SAN ANTONIO','TX','78228','1060','CY','48029','1949-06-29','M','M',':RET:2106-3','N','021','DEN','2050974','33348TX002000201','2014-01-01','2013-12-23 14:57:36','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:57:51'),(4371,3472,'N','01','021','EC','A',NULL,NULL,'','0000639499','0000002274','','IL','1','Golden','Anton','','','','34','277767645','3379 LITTLER LN',0,'COLUMBUS','OH','43228','7026','CY','39049','1980-02-02','M','',':RET:2106-3','N','021','DEN','369231','99734OH005000401','2014-01-01','2013-12-11 21:52:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:00:18'),(2940,2365,'Y','18','021','EC','A','','','AC','0000338848','0000338848','OH00000490487','IL','1','Conaway','Matthew','','','','34','280926916','3344 UTICA RD',0,'LEBANON','OH','45036','9489','CY','39165','1986-05-03','M','U',':RET:2106-3','N','021','DEN','442083','99734OH005000401','2014-01-01','2013-12-06 07:39:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:16:11'),(20156,16085,'Y','18','021','EC','A','','','AC','0000178920','0000178920','OH00001507989','IL','1','POWELL','NICKOLAS','','','','34','118662583','1823 LEE RD',0,'CLEVELAND','OH','44118','2119','CY','39035','1971-05-16','M','U',':RET:2054-5','N','021','DEN','3419587','99734OH005000301','2014-03-01','2014-01-27 12:33:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:01:07'),(20340,16242,'N','01','021','EC','A',NULL,NULL,'','0001799647','0001193464','','IL','1','Fazzio','Joseph','G','','','34','433900236','613 LEGENDRE DR',0,'SLIDELL','LA','70460','3427','CY','22103','1955-02-28','M','',':RET:2106-3','N','021','DEN','2657237','18575LA002000101','2014-03-01','2014-01-28 17:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-28 21:01:07'),(20367,16268,'Y','18','021','EC','A','','','AC','0001792354','0001792354','LA00002415241','31','1','Antley','Tracy','','','','34','435411238','P O Box 25',0,'Rayville','LA','71269',NULL,'CY','22083','1962-09-22','F','U',':RET:2106-3','N','021','DEN','3559157','18575LA002000101','2014-03-01','2014-01-28 18:25:46','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-29 21:00:03'),(22948,18296,'Y','18','024','14','A','','','TE','0000300124','0000300124','','IL','1','Aziz','Sikander',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-29','M','',NULL,NULL,NULL,'','3129623','','2014-02-28','2014-02-11 11:42:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-11 21:30:26'),(25319,20086,'Y','18','021','EC','A','','','AC','0002093152','0002093152','LA00001848262','IL','1','SCOTT','KAREN','','','','34','439435656','4114 STATE RD',0,'BATCHELOR','LA','70715','3725','CY','22077','1973-08-26','F','M',':RET:2054-5','N','021','DEN','3093709','18575LA002000201','2014-04-01','2014-02-24 22:15:44','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:07'),(26974,21370,'Y','18','021','EC','A','','','AC','0001142233','0001142233','OH00003124028','IL','1','Carmany','Timothy','','','','34','289643056','556 BREITON CIR',0,'BARBERTON','OH','44203','7783','CY','39153','1957-11-16','M','M',':RET:2106-3','N','021','HLT','3493627','52664OH152000901','2014-04-01','2014-03-02 12:17:18','522.00',NULL,NULL,'849.04','327.04','R-OH012','OH0','381.07',NULL,0,'2014-03-03 01:00:36'),(4908,3893,'Y','18','021','EC','A','','','AC','0000270097','0000270097','TX00000471344','IL','1','Netter','Harry','','','','34','445585148','P. O. Box 2562',0,'Cedar Hill','TX','75106',NULL,'CY','48113','1956-04-23','M','U',NULL,'N','021','DEN','1133976','33348TX002000101','2014-01-01','2013-10-26 16:45:07','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 22:32:00'),(14828,11842,'Y','18','021','EC','A','','','AC','0000216105','0000216105','OH00001017725','IL','1','DeGroff','Leanna','','','','34','083447988','1918 W. Alexis Rd.',0,'Toledo','OH','43613',NULL,'CY','39095','1964-03-23','F','M',':RET:2106-3','T','021','HLT','2143577','92036OH004002601','2014-01-01','2013-12-23 20:16:35','244.00',NULL,NULL,'307.62','63.62','R-OH001','OH0','307.62',NULL,1,'2013-12-29 11:14:29'),(14019,11168,'Y','18','021','EC','A','','','AC','0000264199','0000264199','OH00001152128','IL','1','Cobb','David','','','','34','257439198','20102 WICKFIELD AVE',0,'WARRENSVILLE HEIGHTS','OH','44122','6553','CY','39035','1973-01-13','M','M',':RET:2054-5','N','021','HLT','1499936','92036OH002000801','2014-01-01','2013-12-23 09:56:32','0.00',NULL,NULL,'345.06','345.06','R-OH011','OH0','345.06',NULL,0,'2013-12-26 13:16:34'),(4789,3799,'Y','18','021','EC','A','','','AC','0000166353','0000166353','OH00000152598','IL','1','Chebra','Michael','A','','Jr','34','282482525','4919 CHESTNUT DR',0,'KENT','OH','44240','7069','CY','39133','1952-07-28','M','M',':RET:2106-3','N','021','HLT','2535','52664OH151001304','2014-01-01','2013-12-08 08:42:04','850.00',NULL,NULL,'1253.30','403.30','R-OH012','OH0','626.65',NULL,0,'2013-12-25 22:16:16'),(6926,5498,'Y','18','021','EC','A','','','AC','0000165086','0000165086','OH00000773630','IL','1','BAUMES','LEE','','','','34','298761343','4223 SAINT ANDREWS PL',0,'BLUE ASH','OH','45236','1057','CY','39061','1967-10-28','F','U',':RET:2106-3','N','021','DEN','2504448','99734OH005000401','2014-01-01','2013-12-24 19:22:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:21'),(16506,13205,'Y','18','021','EC','A','','','AC','0000322155','0000322155','OH00002065438','IL','1','PARMITER','DONALD','','','','34','277485398','8125 GOOSECREEK RD',0,'ROSEVILLE','OH','43777',NULL,'CY','39119','1952-01-12','M','M',NULL,'N','021','DEN','2563415','99734OH005000301','2014-02-01','2014-01-05 15:50:00','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,1,'2014-01-07 10:21:14'),(23895,19007,'N','01','021','EC','A',NULL,NULL,'','0000241565','0000108206','','IL','1','Wardrup','Carol',NULL,NULL,NULL,NULL,NULL,'4641 Melody Lane',0,'Cincinatti','OH','45245',NULL,'CY','39025','1953-12-28','F','',NULL,'N','021','HLT','3473564','92036OH004000601','2014-03-01','2014-02-14 16:00:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.46',NULL,0,'2014-02-14 21:32:20'),(26801,21238,'N','01','021','EC','A',NULL,NULL,'','0001094703','0001011616','','IL','1','EBERLE','GEMMA','','','','34','404747957','623 FLANDERS AVE',0,'BOWLING GREEN','OH','43402',NULL,'CY','39173','1956-10-20','F','',NULL,'N','021','DEN','3681525','99734OH005000301','2014-03-01','2014-02-28 18:39:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-01 21:00:23'),(27376,21676,'N','19','021','EC','A',NULL,NULL,'','0000302878','0001000378','','IL','1','tran','an','my thi','','','34','427739121','7412 OLD FORT BAYOU RD',0,'OCEAN SPRINGS','MS','39564','8195','CY','28059','1992-05-02','F','',':RET:2047-9','N','021','DEN','3947696','46300MS002000101','2014-04-01','2014-03-04 13:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-04 21:01:18'),(27554,21795,'Y','18','024','14','A','','','TE','0000605503','0000605503','','IL','1','RAMIREZ','NORA','G',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-04','F','',NULL,NULL,NULL,'','2460482','','2014-03-31','2014-03-04 12:57:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-04 21:30:13'),(27594,21823,'Y','18','021','EC','A','','','AC','0000647126','0000647126','OH00003215572','S3','1','Peterson','Heather','M','','','34','896253996','1060 High St PO Box 83',0,'Harrisburg','OH','43126',NULL,'CY','39049','2011-08-03','M','U',':RET:2106-3','N','021','DEN','3206158','99734OH005000401','2014-04-01','2014-03-05 08:47:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78','CIC',0,'2014-03-05 21:00:19'),(29006,22957,'Y','18','021','EC','A','','','AC','0001256103','0001256103','OH00003711745','IL','1','CONLEY','CAROL','A','','','34','279521426','1825 PARADISE RD',0,'ORRVILLE','OH','44667',NULL,'CY','39169','1954-03-27','F','U',':RET:2106-3','N','021','HLT','3634196','52664OH152000901','2014-04-01','2014-03-10 12:42:45','309.00',NULL,NULL,'443.31','134.31','R-OH014','OH0','443.31',NULL,0,'2014-03-10 21:01:21'),(4257,3392,'Y','18','021','EC','A','','','AC','0000720240','0000720240','OH00000100787','IL','1','TAYLOR','DORIS','','','','34','281547441','724 BARLOW RD',0,'HUDSON','OH','44236','3703','CY','39153','1951-02-04','F','M',':RET:2106-3','N','021','HLT','1920672','52664OH151001501','2014-01-01','2013-12-17 11:19:21','0.00',NULL,NULL,'768.43','768.43','R-OH012','OH0','768.43',NULL,0,'2013-12-25 21:51:27'),(13548,10804,'Y','18','021','EC','A','','','AC','0001413912','0001413912','LA00000503887','IL','1','Hubbard','Jessica','','','','34','433699176','6540 PROVINCE LN',0,'BATON ROUGE','LA','70808','3580','CY','22033','1984-10-14','F','U',':RET:2106-3','T','021','DEN','1460526','18575LA002000201','2014-01-01','2013-12-23 14:50:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:00'),(13861,11060,'Y','18','021','EC','A','','','AC','0001183527','0001183527','OH00001243498','IL','1','Quast','William','','','','34','297500012','9317 Shady Lake Drive',0,'Streetsboro','OH','44241',NULL,'CY','39133','1951-02-11','M','U',':RET:2106-3','T','021','HLT','1955268','52664OH151001501','2014-01-01','2013-12-22 22:57:00','372.00',NULL,NULL,'883.69','511.69','R-OH012','OH0','883.69',NULL,0,'2013-12-26 13:12:49'),(17988,14375,'Y','18','021','EC','A','','','AC','0000614124','0000614124','OH00001812475','IL','1','Burton','Rashaad','','','','34','270748757','1104 GEORGIA AVE',0,'AKRON','OH','44306','3032','CY','39153','1977-08-27','M','U',NULL,'T','021','HLT','2313753','52664OH151001306','2014-02-01','2014-01-14 17:15:08','202.00',NULL,NULL,'315.44','113.44','R-OH012','OH0','315.44',NULL,0,'2014-01-15 02:06:56'),(18602,14830,'N','19','021','EC','A',NULL,NULL,'','0000535778','0000363796','','IL','1','Houchins','Cheyenne','','','','34','302944411','9795 N LENA PALESTINE RD',0,'CONOVER','OH','45317','9754','CY','39109','1992-09-29','F','',NULL,'N','021','HLT','2738582','92036OH003000505','2014-02-01','2014-01-15 12:00:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','248.23',NULL,0,'2014-01-16 08:47:19'),(18965,15111,'Y','18','021','EC','A','','','AC','0000148225','0000148225','TX00002063478','IL','1','RHODES','LEE','','','','34','464061484','1318 MOSSRIDGE DR',0,'MISSOURI CITY','TX','77489','4125','CY','48157','1954-02-13','F','U',':RET:2054-5','N','021','DEN','1448480','33348TX002000201','2014-03-01','2014-01-17 12:46:23','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:57'),(23332,18596,'N','01','021','EC','A',NULL,NULL,'','0000264246','0000054507','','IL','1','Emery','Deborah','','','','34','234884954','2435 SIR MARTIN DR',0,'HAMILTON','OH','45013','4274','CY','39017','1952-04-13','F','',':RET:2106-3','N','021','DEN','3365449','99734OH005000301','2014-03-01','2014-02-13 16:05:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:31'),(27065,21429,'Y','18','021','EC','A','','','AC','0001981905','0001981905','LA00002433348','IL','1','BUSHNELL','DEMETRIUS','','','','34','433472902','2013 GERTSNER MEMORIAL DR',0,'LAKE CHARLES','LA','70601',NULL,'CY','22019','1978-01-12','M','U',':RET:2054-5','T','021','DEN','3437196','18575LA002000201','2014-04-01','2014-03-03 09:36:03','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-03 21:30:02'),(92,81,'Y','18','021','EC','A','','','AC','0001227910','0001227910','TX00000485560','IL','1','OBREGON','ALFREDO','','','III','34','463877498','107 KISSLING AVE',0,'ROBSTOWN','TX','78380','2218','CY','48355','1986-01-15','M','U',NULL,'N','021','DEN','826059','33348TX002000201','2014-01-01','2013-12-04 20:42:32','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 17:17:27'),(2094,1715,'Y','18','021','EC','A','','','AC','0000507955','0000507955','OH00000719771','IL','1','SCOTT','SHARON','K','','','34','273666820','12601 BENDWOOD AVE',0,'CLEVELAND','OH','44105',NULL,'CY','39035','1959-01-01','F','U',':RET:2054-5','T','021','DEN','77856','99734OH005000401','2014-01-01','2013-12-09 18:37:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:16:59'),(14826,11841,'Y','18','021','EC','A','','','AC','0000509204','0000509204','OH00000650698','IL','1','JONES','CHARLES','','','','34','092408370','10530 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','9649','CY','39173','1950-02-16','M','M',':RET:2106-3','T','021','HLT','1822712','92036OH004002601','2014-01-01','2013-12-23 20:45:34','306.00',NULL,NULL,'931.77','625.77','R-OH001','OH0','532.27',NULL,1,'2013-12-29 11:14:27'),(3436,2761,'Y','18','021','EC','A','','','AC','0001368857','0001368857','LA00001291301','IL','1','Lee','Jennifer','','','','34','427874498','71 MONTERREY AVE',0,'KENNER','LA','70065','3142','CY','22051','1951-11-27','F','M',':RET:2034-7','N','021','DEN','2600159','18575LA002000101','2014-01-01','2013-12-22 12:41:45','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:19:05'),(4871,3862,'Y','18','021','EC','A','','','AC','0000099701','0000099701','LA00000283202','IL','1','Farmer','John','','','','34','436737329','1107 TULANE AVE',0,'WEST MONROE','LA','71291','5248','CY','22073','1986-12-03','M','U',NULL,'N','021','DEN','1163236','18575LA002000201','2014-01-01','2013-10-10 10:23:29','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:31:00'),(17304,13838,'N','01','021','EC','A',NULL,NULL,'','0000574921','0000448148','','IL','1','Pitts','Jimmie','Ann','','','34','463370820','6821 HIGHWAY 6',0,'DE LEON','TX','76444','6933','CY','48093','1961-01-23','F','',':RET:2106-3','N','021','DEN','1939768','33348TX002000201','2014-02-01','2014-01-10 12:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:23:40'),(21967,17541,'N','01','021','EC','A',NULL,NULL,'','0000044308','0000835506','','IL','1','Gates','Pearl','','','','34','299565247','368 DEWFALL DR',0,'SUNBURY','OH','43074','8532','CY','39041','1955-06-06','F','',':RET:2106-3','N','021','DEN','2786505','99734OH005000401','2014-03-01','2014-02-07 16:21:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:28'),(22837,18222,'Y','18','021','EC','A','','','AC','0001053095','0001053095','OH00002580205','IL','1','Richmond','Diane','','','','34','270501096','3911 Lake Vista Rd',0,'Akron','OH','44319',NULL,'CY','39153','1958-04-20','F','U',':RET:2106-3','N','021','HLT','3783861','52664OH151001304','2014-03-01','2014-02-11 17:43:15','301.00',NULL,NULL,'497.31','196.31','R-OH012','OH0','497.31',NULL,0,'2014-02-11 21:02:11'),(6008,4757,'Y','18','021','EC','A','','','AC','0001006780','0001006780','OH00000699520','IL','1','Gonyer','Kevin','','','','34','279880228','4095 ELMHURST RD SW',0,'CARROLLTON','OH','44615','8982','CY','39019','1982-04-15','M','M',':RET:2106-3','N','021','DEN','10070','99734OH005000301','2014-01-01','2013-12-01 08:33:42','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-26 00:00:33'),(20619,16477,'Y','18','021','EC','A','','','AC','0001916031','0001916031','LA00002371064','IL','1','Perryman','Ann','Elizabeth','','','34','437987815','2155 COTEAU RD',0,'HOUMA','LA','70364','2138','CY','22109','1964-01-25','F','U',':RET:2106-3','T','021','DEN','3220847','18575LA002000101','2014-03-01','2014-01-30 16:35:04','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-30 21:00:22'),(20988,16774,'Y','18','021','EC','A','','','AC','0000609559','0000609559','OH00001735529','IL','1','Shannawi','Sameer','','','','34','603581086','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1966-04-29','M','M',':RET:2106-3','T','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-01 19:00:24'),(22436,17914,'Y','18','021','EC','A','','','AC','0000232027','0000232027','TX00002146352','IL','1','Howard','Myron','','','','34','460455325','719 FAIRVIEW ST',0,'EAGLE LAKE','TX','77434','2207','CY','48089','1975-05-12','M','U',NULL,'N','021','DEN','3832503','33348TX002000201','2014-03-01','2014-02-10 09:30:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 21:30:39'),(12,8,'N','01','021','EC','A',NULL,NULL,'','0000132043','0000342703','','IL','1','Beal','Tammy','','','','34','289600281','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1962-03-03','F','',':RET:2106-3','N','021','DEN','938477','99734OH005000401','2014-01-01','2013-12-04 23:45:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:15:17'),(5540,4395,'Y','18','021','EC','A','','','AC','0001122705','0001122705','OH00001101720','IL','1','Post','Ricky','','','','34','302567631','2125 Anderson Station Road',0,'Chillicothe','OH','45601',NULL,'CY','39141','1956-05-18','M','U',':RET:2106-3','N','021','DEN','964321','99734OH005000401','2014-01-01','2013-11-27 17:54:41','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 23:15:47'),(2852,2305,'Y','18','021','EC','A','','','AC','0000955496','0000955496','OH00000048704','IL','1','Barnes','Barbara','','','','34','286507492','1 E. Main St.',0,'Ashland','OH','44805',NULL,'CY','39005','1951-09-07','F','U',':RET:2106-3','N','021','HLT','307156','52664OH151001306','2014-01-01','2013-11-02 16:23:25','622.00',NULL,NULL,'640.70','18.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 20:01:24'),(14073,11215,'Y','18','021','EC','A','','','AC','0000240355','0000240355','OH00001476024','IL','1','COLEMAN','ANTHONY','','','','34','298663185','1849 ALCOY RD',0,'CLEVELAND','OH','44112',NULL,'CY','39035','1960-03-09','M','U',':RET:2054-5','T','021','DEN','2319510','99734OH005000401','2014-02-01','2013-12-26 09:58:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:00:56'),(5504,4370,'Y','18','024','14','A','','','TE','0000598733','0000598733','','IL','1','kitzmiller','jayne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-11-29','F','',NULL,NULL,NULL,'','531351','','2013-12-19','2013-12-19 17:50:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:11:25'),(4554,3607,'N','01','021','EC','A',NULL,NULL,'','0000772618','0000850480','','IL','1','Alabakovski','Vlade','','','','34','292589690','405 CONCORD ST NW',0,'MASSILLON','OH','44646','2013','CY','39151','1950-07-27','M','',NULL,'N','021','HLT','395068','52664OH152000901','2014-01-01','2013-12-12 10:13:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2013-12-25 22:04:35'),(7297,5783,'Y','18','021','EC','A','','','AC','0000111873','0000111873','OH00001262234','IL','1','Davis','Crystal','lynn','','','34','302768018','3564 HANOVER DR',0,'KENT','OH','44240','6614','CY','39133','1970-03-17','F','U',':RET:2106-3','T','021','HLT','395165','52664OH151001305','2014-01-01','2013-12-14 07:53:18','214.00',NULL,NULL,'348.01','134.01','R-OH012','OH0','348.01',NULL,0,'2013-12-26 02:03:02'),(15735,12587,'Y','18','021','EC','A','','','AC','0000271433','0000271433','OH00002233771','IL','1','CUPP','SHARON','','','','34','077466994','4317 LINCHMERE DR',0,'DAYTON','OH','45415','1810','CY','39113','1953-10-19','F','M',':RET:2106-3','N','021','DEN','1610926','99734OH005000301','2014-02-01','2014-01-02 15:00:35','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:00:39'),(18064,14429,'N','01','021','EC','A',NULL,NULL,'','0000484813','0000254555','','IL','1','Boone','Jesee','Lee','','','34','273905099','14 Oriole Court',0,'Amelia','OH','45102',NULL,'CY','39025','1980-03-19','M','',':RET:2106-3','T','021','HLT','1875690','92036OH003000604','2014-02-01','2014-01-14 16:42:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.84',NULL,0,'2014-01-15 02:07:21'),(20624,16480,'Y','18','021','EC','A','','','AC','0001134379','0001134379','TX00001598912','IL','1','PORRAS','ERIKA','','','','34','466639137','319 AVENIDA ESTRELLA',0,'BROWNSVILLE','TX','78526','4004','CY','48061','1982-11-17','F','M',NULL,'N','021','DEN','3035208','33348TX002000201','2014-03-01','2014-01-29 18:49:38','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-01-30 21:00:25'),(21149,16899,'N','01','021','EC','A',NULL,NULL,'','0000964774','0000961151','','IL','1','Chaparala','Amarendra','','','','34','641827241','2215 Cedar Springs Road',0,'Dallas','TX','75201',NULL,'CY','48113','1972-12-18','M','',':RET:2029-7','N','021','DEN','2867796','33348TX002000201','2014-03-01','2014-02-03 18:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-03 21:00:26'),(22247,17757,'Y','18','021','EC','A','','','AC','0000012472','0000012472','OH00002405167','IL','1','Bihn','Patti','','','','34','302648052','7447 Lunitas Ln',0,'Perrysburg','OH','43551',NULL,'CY','39173','1958-03-04','F','M',NULL,'N','021','HLT','3588176','92036OH004002601','2014-03-01','2014-02-09 13:14:44','752.00',NULL,NULL,'800.11','48.11','R-OH001','OH0','349.65',NULL,0,'2014-02-09 19:00:41'),(24695,19604,'Y','18','021','EC','A','','','AC','0001064763','0001064763','OH00002808958','IL','1','george','joe','','','','34','302529474','4456 matson ave',0,'cinn','OH','45236',NULL,'CY','39061','1952-09-16','M','U',':RET:2106-3','N','021','DEN','3172968','99734OH005000401','2014-04-01','2014-02-18 21:38:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:33:06'),(27095,21451,'Y','18','021','EC','A','','','AC','0000642135','0000642135','OH00003158610','IL','1','Grimm','Terry','','','','34','300682440','675 REED AVE',0,'AKRON','OH','44306','2670','CY','39153','1961-03-03','M','U',':RET:2106-3','N','021','HLT','3912050','52664OH151001305','2014-04-01','2014-03-03 15:04:28','354.00',NULL,NULL,'454.94','100.94','R-OH012','OH0','454.94',NULL,0,'2014-03-03 21:30:19'),(28625,22653,'N','01','021','EC','A',NULL,NULL,'','0000026416','0000894166','','IL','1','Flores','Guadalupe','L','','','34','451940018','910 FORT CLARK RD',0,'UVALDE','TX','78801','4507','CY','48463','1952-12-12','F','',NULL,'N','021','DEN','3194546','33348TX002000201','2014-04-01','2014-03-08 10:38:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:23'),(29110,23043,'Y','18','021','EC','A','','','AC','0001641102','0001641102','LA00002711796','IL','1','Farris','Alan','','','','34','449632620','15710 RIVERDALE AVE E',0,'BATON ROUGE','LA','70816','1580','CY','22033','1983-03-04','M','U',':RET:2106-3','T','021','DEN','3972318','18575LA002000101','2014-04-01','2014-03-10 14:55:25','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-10 21:02:23'),(4221,3359,'Y','18','021','EC','A','','','AC','0000320369','0000320369','TX00000549257','IL','1','Franklin','Carrie','','','','34','456043664','2403 GRAND TETON DR',0,'HOUSTON','TX','77067','1069','CY','48201','1954-08-23','F','M',':RET:2054-5','N','021','DEN','1389937','33348TX002000201','2014-01-01','2013-12-17 10:42:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:50:25'),(14169,11296,'Y','18','021','EC','A','','','AC','0002114762','0002114762','LA00001460783','IL','1','Castle','Julia','','','','34','434290380','620 SHANNON ST',0,'MORGAN CITY','LA','70380','1898','CY','22101','1959-08-18','F','U',':RET:2054-5','N','021','DEN','2026178','18575LA002000201','2014-02-01','2013-12-26 17:45:51','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-27 02:03:23'),(18242,14561,'Y','18','021','EC','A','','','AC','0000542424','0000542424','TX00001404558','IL','1','Burke','Bobette','','','','34','461192798','2524 Ridgemar Blvd',0,'Fort Worth','TX','76116',NULL,'CY','48439','1956-12-01','F','U',':RET:2106-3','N','021','DEN','2096909','33348TX002000201','2014-02-01','2014-01-15 12:39:23','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-16 08:44:26'),(23154,18458,'Y','18','021','EC','A','','','AC','0000956693','0000956693','OH00001713280','IL','1','Wright','Brian','','','','34','282884410','3603 Schwartze',0,'Cincinnati','OH','45211',NULL,'CY','39061','1980-01-28','M','U',':RET:2106-3','N','021','HLT','3770247','92036OH004001201','2014-03-01','2014-02-12 09:30:40','0.00',NULL,NULL,'209.55','209.55','R-OH004','OH0','209.55',NULL,0,'2014-02-12 21:31:43'),(23514,18731,'Y','18','021','EC','A','','','AC','0001092441','0001092441','MS00002568450','IL','1','SHEPHERD','LATOYA','DENISE','','','34','427678832','107 POND ST',0,'DODDSVILLE','MS','38736','9612','CY','28083','1989-11-21','F','U',NULL,'N','021','DEN','2912760','46300MS002000101','2014-03-01','2014-02-13 14:27:28','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-13 22:02:16'),(24756,19645,'Y','18','021','EC','A','','','AC','0000387336','0000387336','OH00002849396','IL','1','Troendly','Benjamin','','','','34','282888063','835 KENILWORTH AVE',0,'COSHOCTON','OH','43812','2367','CY','39031','1977-08-02','M','U',':RET:2106-3','N','021','DEN','3815789','99734OH005000401','2014-04-01','2014-02-19 11:52:35','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-20 04:42:07'),(26578,21072,'Y','18','021','EC','A','','','AC','0001191390','0001191390','OH00002849641','IL','1','Evans','Debra','','','','34','297581568','523 HARDING AVE SW',0,'MASSILLON','OH','44646','3410','CY','39151','1956-02-23','F','U',':RET:2106-3','T','021','DEN','3667293','99734OH005000401','2014-04-01','2014-02-28 13:10:49','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-28 21:30:29'),(27399,21689,'N','19','021','EC','A',NULL,NULL,'','0000214721','0000064945','','IL','1','Rowland','Lillian','','','','34','277047824','328 Beech Street',0,'Green Camp','OH','43322',NULL,'CY','39101','1999-03-23','F','',':RET:2106-3','N','021','DEN','2955789','99734OH005000301','2014-04-01','2014-03-03 21:44:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:30'),(27921,22087,'Y','18','021','EC','A','','','AC','0000386860','0000386860','TX00003251349','IL','1','ZAMARRIPA','DIANA','','','','34','451414123','2908 GRINNELL ST',0,'LUBBOCK','TX','79415','1640','CY','48303','1966-04-14','F','M',NULL,'N','021','DEN','4063809','33348TX002000201','2014-04-01','2014-03-05 22:56:36','0.00',NULL,NULL,'43.83','43.83','R-TX014','TX0','14.61',NULL,0,'2014-03-06 21:00:20'),(5514,4374,'N','01','021','EC','A',NULL,NULL,'','0000712484','0000277251','','IL','1','BAISDEN','VIRGINIA','A','','','34','287725144','972 CARRYBACK DR SW',0,'PATASKALA','OH','43062','9543','CY','39089','1960-12-18','F','',':RET:2106-3','N','021','DEN','494544','99734OH005000301','2014-01-01','2013-11-27 12:28:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:09'),(3720,2973,'Y','18','021','EC','A','','','AC','0000341319','0000341319','OH00000792898','IL','1','grim','cheryl','a','','','34','295683578','57211 spencer rd',0,'cumberland','OH','43732',NULL,'CY','39059','1960-10-01','F','M',':RET:2106-3','N','021','DEN','844018','99734OH005000401','2014-01-01','2013-12-13 15:18:42','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:32:20'),(16411,13133,'Y','18','021','EC','A','','','AC','0001037752','0001037752','TX00002066772','IL','1','LEWIS','MARCELLA','','','','34','459214770','1830 WACO AVE',0,'PORT ARTHUR','TX','77640',NULL,'CY','48245','1963-06-01','F','U',':RET:2054-5','N','021','DEN','1867149','33348TX002000201','2014-02-01','2014-01-06 17:08:05','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-01-07 04:04:12'),(18676,14889,'Y','18','021','EC','A','','','AC','0000292042','0000292042','TX00002007414','IL','1','Atilano','Luz','','','','34','454110166','11208 PEACEPIPE LN',0,'EL PASO','TX','79936','1244','CY','48141','1954-11-29','F','M',NULL,'N','021','DEN','2496298','33348TX002000201','2014-02-01','2014-01-15 19:58:09','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-17 03:35:19'),(22958,18303,'N','01','021','EC','A',NULL,NULL,'','0002332236','0002262778','','IL','1','Horton','Wilbert','','','Jr','34','434781729','7739 ALABAMA ST',0,'NEW ORLEANS','LA','70126','1309','CY','22071','1949-08-20','M','',':RET:2054-5','N','021','DEN','3317724','18575LA002000201','2014-03-01','2014-02-12 10:41:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-12 21:00:06'),(23019,18354,'Y','18','021','EC','A','','','AC','0001702932','0001702932','LA00002267001','IL','1','travis','tammy','','','','34','434117360','64294 pearl st',0,'pearl river','LA','70452',NULL,'CY','22103','1961-11-16','F','M',':RET:2106-3','N','021','DEN','3539116','18575LA002000101','2014-03-01','2014-02-12 16:56:50','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-12 21:30:29'),(24017,19101,'Y','18','021','EC','A','','','AC','0000946164','0000946164','OH00002942461','IL','1','Weeks','Stephen','','','','34','249820354','1768 E 25TH ST',0,'CLEVELAND','OH','44114','4418','CY','39035','1949-07-03','M','M',':RET:2106-3','N','021','DEN','3476108','99734OH005000401','2014-03-01','2014-02-15 14:51:49','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:44'),(24536,19490,'Y','18','021','EC','A','','','AC','0002107209','0002107209','LA00001912982','IL','1','Hills','Natashia','','','','34','587453362','2670 HOLLY RIDGE RD',0,'JACKSON','LA','70748','3209','CY','22037','1978-11-03','F','U',':RET:2054-5','N','021','DEN','2718367','18575LA002000101','2014-04-01','2014-02-19 15:10:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-20 04:01:21'),(27300,21617,'Y','18','021','EC','A','','','AC','0001173898','0001173898','TX00003137080','IL','1','Alejandro','Adriana','','','','34','640053692','3405 SOUTHLAND BLVD',0,'SAN ANGELO','TX','76904','7335','CY','48451','1989-02-27','F','U',NULL,'N','021','DEN','3096384','33348TX002000201','2014-04-01','2014-03-04 13:27:22','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-03-04 21:00:34'),(28947,22908,'Y','18','021','EC','A','','','AC','0001504496','0001504496','LA00002812108','IL','1','Carrier','Jeffrey','','','','34','439150292','22167 HIGHWAY 16',0,'AMITE','LA','70422','4847','CY','22105','1958-10-15','M','U',NULL,'T','021','DEN','2802033','18575LA002000201','2014-04-01','2014-03-09 21:33:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:00:47'),(295,244,'Y','18','021','EC','A','','','AC','0000645939','0000645939','OH00000331390','IL','1','Ludwig','Richard','','','','34','278443645','1166 N. Jefferson St.',0,'Medina','OH','44256',NULL,'CY','39103','1949-07-09','M','U',':RET:2106-3','N','021','DEN','797819','99734OH005000401','2014-01-01','2013-11-13 11:14:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:30:40'),(15425,12340,'Y','18','024','14','A','','','TE','0000970681','0000970681','','IL','1','Tarver','Jeremy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-07-19','M','',NULL,NULL,NULL,'','1004649','','2013-12-31','2013-12-31 11:49:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:27:34'),(1638,1368,'Y','18','021','EC','A','','','AC','0001225485','0001225485','TX00000756038','IL','1','scheib','larry','','','','34','532821335','910 PROSPECT ST',0,'EL PASO','TX','79902','3725','CY','48141','1962-01-05','M','R',':RET:2106-3','N','021','DEN','1649824','33348TX002000201','2014-01-01','2013-12-24 15:21:53','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:53:00'),(2615,2126,'Y','18','021','EC','A','','','AC','0000844677','0000844677','OH00000683082','IL','1','Elwell','Kellen','Ruth','','','34','223575400','633 COBBLESTONE DR',0,'AMHERST','OH','44001','1967','CY','39093','1986-01-19','F','M',':RET:2106-3','N','021','DEN','1190405','99734OH005000401','2014-01-01','2013-12-02 14:06:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:45:43'),(13274,10594,'N','01','021','EC','A',NULL,NULL,'','0001041322','0000752498','','IL','1','Gutierrez','Suyapa','E','','','34','465998107','16127 MORGAN RUN',0,'MISSOURI CITY','TX','77489','8008','CY','48157','1957-03-31','F','',NULL,'N','021','DEN','1526896','33348TX002000201','2014-01-01','2013-12-23 12:29:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:56:59'),(6992,5549,'Y','18','024','14','A','','','TE','0001044077','0001044077','','IL','1','granger','ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-06','F','',NULL,NULL,NULL,'','2612218','','2013-12-24','2013-12-24 18:26:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 01:48:02'),(7675,6079,'Y','18','021','EC','A','','','AC','0000658411','0000658411','OH00000367111','IL','1','Robinson','Tiffany','','','','34','290787240','1661 WINCHESTER CT',0,'WESTLAKE','OH','44145','2110','CY','39035','1967-03-31','F','U',':RET:2106-3','T','021','DEN','1402701','99734OH005000401','2014-01-01','2013-12-19 19:04:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:00:41'),(15645,12515,'Y','18','021','EC','A','','','AC','0000168488','0000168488','MS00001738835','IL','1','Johnson','Larry','Charles','','','34','427114240','1002 CARVER ST',0,'JACKSON','MS','39203','1007','CY','28049','1956-12-07','M','U',NULL,'N','021','DEN','1414279','46300MS002000201','2014-02-01','2013-12-31 11:01:50','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2014-01-02 04:33:55'),(18750,14939,'N','01','021','EC','A',NULL,NULL,'','0000153393','0000857128','','IL','1','Zarnick','Theresa','','','','34','134529592','5755 Red Leaf Lane',0,'Monclova','OH','43542',NULL,'CY','39095','1962-04-06','F','',':RET:2106-3','N','021','HLT','2833526','92036OH005002605','2014-02-01','2014-01-15 18:34:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.68',NULL,0,'2014-01-17 03:35:43'),(20233,16143,'Y','18','021','EC','A','','','AC','0001039028','0001039028','MS00001848969','IL','1','THOMAS','CHERYL','','','','34','526989697','605 LAKERIDGE LN',0,'CLINTON','MS','39056','6204','CY','28049','1951-04-20','F','U',':RET:2106-3','N','021','DEN','2741519','46300MS002000101','2014-03-01','2014-01-27 18:26:09','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-28 21:00:03'),(20346,16247,'Y','18','021','EC','A','','','AC','0000628090','0000628090','MS00001618083','IL','1','Anderson','Jackie','','','','34','341686595','3403 Bellbottom Rd',0,'Lexington','MS','39095',NULL,'CY','28051','1980-01-29','F','M',':RET:2054-5','N','021','DEN','3118056','46300MS002000201','2014-03-01','2014-01-28 12:05:33','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-28 21:01:11'),(21622,17264,'Y','18','021','EC','A','','','AC','0000906373','0000906373','TX00001839598','IL','1','HERNDON','LATEARRIA','','','','34','453972760','1810 WILLIAMS ST',0,'LUFKIN','TX','75904','1912','CY','48005','1988-03-18','F','U',':RET:2054-5','N','021','DEN','3166240','33348TX002000201','2014-03-01','2014-02-05 06:08:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:38'),(23102,18415,'Y','18','021','EC','A','','','AC','0001155137','0001155137','OH00002475099','IL','1','Nelson','Alyse','','','','34','282482442','3840 W 128TH ST',0,'CLEVELAND','OH','44111','4511','CY','39035','1952-01-21','F','M',':RET:2106-3','T','021','DEN','2895885','99734OH005000401','2014-03-01','2014-02-12 15:44:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:12'),(25474,20211,'Y','18','021','EC','A','','','AC','0000396337','0000396337','TX00003166824','IL','1','Rollfing','Jeffrey','','','','34','450414420','28130 LAURA CT',0,'CONROE','TX','77385','8959','CY','48339','1960-10-18','M','M',':RET:2106-3','N','021','DEN','3678748','33348TX002000201','2014-04-01','2014-02-25 17:37:08','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:39'),(26184,20765,'Y','18','021','EC','A','','','AC','0000839106','0000839106','OH00003263935','IL','1','Middlebrooks','Shanae','Latrice','','','34','272800199','4707 VALLEJO DR',0,'TOLEDO','OH','43615','6131','CY','39095','1980-12-10','F','U',':RET:2054-5','N','021','DEN','2977955','99734OH005000301','2014-03-01','2014-02-27 09:57:07','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-28 06:30:42'),(1881,1537,'Y','18','021','EC','A','','','AC','0000691835','0000691835','OH00001373358','IL','1','Riehm','Jenny','L','','','34','271682581','10249 DESMOND PL',0,'PERRYSBURG','OH','43551','7208','CY','39173','1960-08-16','F','U',':RET:2106-3','T','021','HLT','1510774','92036OH006002601','2014-01-01','2013-12-24 15:04:12','253.00',NULL,NULL,'362.79','109.79','R-OH001','OH0','362.79',NULL,0,'2013-12-25 18:58:32'),(13291,10609,'Y','18','024','14','A','','','TE','0000120533','0000120533','','IL','1','Castillo','Maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-01-13','F','',NULL,NULL,NULL,'','2608331','','2013-12-23','2013-12-23 13:34:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:57:29'),(21533,17203,'N','19','021','EC','A',NULL,NULL,'','0000777703','0000563175','','IL','1','Bass','Grady','','','','34','641824010','4934 LAKOTA WOODS DR',0,'LIBERTY TOWNSHIP','OH','45044','3245','CY','39017','2002-08-15','M','',':RET:2106-3','N','021','HLT','3179559','92036OH001001201','2014-03-01','2014-02-04 18:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2014-02-05 21:30:07'),(22024,17583,'N','01','021','EC','A',NULL,NULL,'','0000667817','0000277307','','IL','1','Hubbell','Kenneth','','','','34','296640262','491 N SPRING ST',0,'WILMINGTON','OH','45177','1630','CY','39027','1964-12-10','M','',':RET:2106-3','N','021','HLT','3098229','92036OH003000606','2014-03-01','2014-02-07 08:06:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.46',NULL,0,'2014-02-07 19:01:00'),(22627,18069,'Y','18','021','EC','A','','','AC','0000895078','0000895078','TX00002157801','IL','1','Hance','Melissa','','','','34','235238996','218A W WILLIAM CANNON DR',0,'AUSTIN','TX','78745','5690','CY','48453','1983-01-03','F','M',':RET:2106-3','N','021','DEN','3592124','33348TX002000201','2014-03-01','2014-02-10 22:27:43','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-11 21:00:14'),(24279,19282,'Y','18','021','EC','A','','','AC','0000991592','0000991592','OH00002463205','IL','1','REID','ISABEL','J','','','34','123542496','38 BONNER ST',0,'DAYTON','OH','45410','1224','CY','39113','1972-01-28','F','U',':RET:2040-4^:RET:2106-3','T','021','DEN','2725647','99734OH005000401','2014-03-01','2014-02-18 14:49:20','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00','CIC',0,'2014-02-18 21:30:06'),(25354,20118,'N','19','021','EC','A',NULL,NULL,'','0001120004','0000162318','','IL','1','STOGSDILL','LOGAN','EDWARD','','','34','277114206','5757 LAKE EERIE DR.',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','2005-03-07','M','',':RET:2106-3','N','021','DEN','3026771','99734OH005000301','2014-04-01','2014-02-24 18:33:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:33'),(1132,931,'N','19','021','EC','A',NULL,NULL,'','0000295881','0000255994','','IL','1','Cordova','Joe','Hector','','III','34','628189618','163 Yucca Trailer Park Rd',0,'Del Rio','TX','78840',NULL,'CY','48465','1990-09-05','M','',':RET:2106-3','N','021','DEN','476585','33348TX002000101','2014-01-01','2013-12-03 17:40:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 18:18:05'),(15567,12457,'Y','18','021','EC','A','','','AC','0001147345','0001147345','OH00001152511','IL','1','Guenther','Donald','','','','34','272547300','2885 PEASE DR',0,'ROCKY RIVER','OH','44116','3263','CY','39035','1952-09-19','M','U',':RET:2106-3','N','021','HLT','2386630','52664OH151001301','2014-02-01','2013-12-31 12:45:51','230.00',NULL,NULL,'706.77','476.77','R-OH011','OH0','706.77',NULL,1,'2014-01-02 04:31:46'),(6629,5257,'Y','18','021','EC','A','','','AC','0001217357','0001217357','OH00000111003','IL','1','GILBERT','KENNETH','','','','34','368587455','2822 118TH ST',0,'TOLEDO','OH','43611','2707','CY','39095','1955-03-18','M','U',':RET:2106-3','N','021','HLT','632036','92036OH001002601','2014-01-01','2013-12-11 16:54:51','299.39',NULL,NULL,'599.30','299.91','R-OH001','OH0','599.30',NULL,0,'2013-12-26 00:54:18'),(6383,5061,'N','01','021','EC','A',NULL,NULL,'','0000138990','0001221918','','IL','1','TAKACH','BARBARA','','','','34','272542341','680 WHIPPOORWILL LN',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1955-01-27','F','',':RET:2106-3','N','021','DEN','1219853','99734OH005000301','2014-01-01','2013-12-11 10:25:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:47:58'),(3474,2789,'N','19','021','EC','A',NULL,NULL,'','0000086420','0000910518','','IL','1','sutherland','atisha','','','','34','294113140','5120 Free Pike',0,'trotwood','OH','45426',NULL,'CY','39113','1990-10-06','F','',':RET:2054-5','N','021','DEN','2570534','99734OH005000401','2014-01-01','2013-12-22 10:33:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:02'),(17171,13740,'N','19','021','EC','A',NULL,NULL,'','0000789678','0000081300','','S3','1','Crates','James','Danford','','','34','276041850','339 East Maple Street',0,'Granville','OH','43023',NULL,'CY','39089','1999-01-19','M','',':RET:2106-3','N','021','DEN','1377404','99734OH005000301','2014-02-01','2014-01-07 19:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:22:08'),(17630,14095,'Y','18','021','EC','A','','','AC','0000861923','0000861923','TX00001712649','IL','1','Simmons','Sandra','','','','34','466840637','1049 FM 2493 W',0,'BULLARD','TX','75757','5582','CY','48073','1949-10-26','F','U',':RET:2106-3','N','021','DEN','1962175','33348TX002000201','2014-02-01','2014-01-13 17:13:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:32'),(17646,14105,'Y','18','021','EC','A','','','AC','0000561692','0000561692','OH00001999872','IL','1','Baldwin','Nathalie','','','','34','344562059','145 S PAINT ST',0,'CHILLICOTHE','OH','45601','3215','CY','39141','1973-04-22','F','R',':RET:2106-3','N','021','DEN','2256145','99734OH005000301','2014-02-01','2014-01-13 10:03:47','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-14 01:32:38'),(18807,14980,'Y','18','024','14','A','','','TE','0000387298','0000387298','','IL','1','thind','narain','singh',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-01-05','M','',NULL,NULL,NULL,'','2611524','','2014-01-16','2014-01-16 16:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:02'),(19985,15941,'Y','18','021','EC','A','','','AC','0000598784','0000598784','OH00001575705','IL','1','McNeely','Patrick','James','','','34','289567553','1210 RICHLAND ST',0,'MAUMEE','OH','43537','3238','CY','39095','1957-03-24','M','U',':RET:2106-3','N','021','HLT','3394870','92036OH004002601','2014-03-01','2014-01-25 13:05:22','0.00',NULL,NULL,'365.79','365.79','R-OH001','OH0','365.79',NULL,0,'2014-01-25 19:00:17'),(23271,18552,'N','19','021','EC','A',NULL,NULL,'','0000848565','0000710979','','IL','1','Nwanne','Faith','','','','34','644182504','8318 Lighthouse Drive',0,'Rowlett','TX','75089',NULL,'CY','48113','1990-08-15','F','',NULL,'N','021','DEN','3156478','33348TX002000101','2014-03-01','2014-02-13 09:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-13 21:30:13'),(7063,5611,'Y','18','021','EC','A','','','AC','0000816435','0000816435','OH00000568396','IL','1','Yang','Wei','','','','34','052788617','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1970-07-02','M','M',':RET:2034-7','N','021','DEN','2566021','99734OH005000301','2014-01-01','2013-12-24 22:07:55','0.00',NULL,NULL,'87.78','87.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 01:50:00'),(13600,10847,'Y','18','021','EC','A','','','AC','0000133313','0000133313','OH00000228334','IL','1','Runk','Timothy','','','','34','289583319','5468 N DIXIE HWY',0,'LIMA','OH','45807','9559','CY','39003','1966-07-15','M','M',':RET:2106-3','N','021','HLT','1967024','92036OH003001504','2014-01-01','2013-12-23 13:37:08','376.00',NULL,NULL,'680.32','304.32','R-OH002','OH0','359.24',NULL,0,'2013-12-26 13:05:24'),(14838,11849,'N','01','021','EC','A',NULL,NULL,'','0000170159','0000223708','','IL','1','Kirchmer','Megan','C','','','34','389028966','8014 CYPRESSTREE CIR',0,'WEST CHESTER','OH','45069','1625','CY','39017','1976-05-13','F','',':RET:2106-3','N','021','DEN','1578531','99734OH005000301','2014-01-01','2013-12-23 19:46:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:14:45'),(17998,14382,'Y','18','021','EC','A','','','AC','0000048215','0000048215','OH00002543363','IL','1','Watson','Thomas','','','','34','282722915','5646 Waterbury Avenue',0,'Maple Heights','OH','44137',NULL,'CY','39035','1962-12-11','M','M',NULL,'N','021','DEN','2021397','99734OH005000301','2014-02-01','2014-01-13 20:41:34','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:59'),(19058,15181,'Y','18','021','EC','A','','','AC','0000552124','0000552124','MS00001623121','IL','1','Ryals','Lawanda','','','','34','427372962','535 HEARTWOOD DR',0,'VICKSBURG','MS','39180','0827','CY','28149','1977-11-18','F','U',':RET:2054-5','N','021','DEN','1900477','46300MS002000201','2014-03-01','2014-01-18 16:32:07','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-21 08:44:13'),(21198,16940,'Y','18','021','EC','A','','','AC','0000523443','0000523443','OH00001495031','IL','1','Newell','Gregory','','','','34','277700100','12970 HARLON AVE',0,'LAKEWOOD','OH','44107','2812','CY','39035','1960-07-29','M','U',':RET:2106-3','N','021','HLT','3593362','92036OH005000801','2014-03-01','2014-02-02 23:41:32','433.00',NULL,NULL,'944.53','511.53','R-OH011','OH0','476.95',NULL,0,'2014-02-03 21:00:52'),(23645,18828,'Y','18','021','EC','A','','','AC','0000778265','0000778265','TX00002562444','IL','1','DEVAULT','ERRAL',NULL,NULL,NULL,NULL,NULL,'801 W JEFFERSON ST',0,'BRENHAM','TX','77833','3000','CY','48477','1960-01-25','M','U',':RET:2106-3','N','021','DEN','3101870','33348TX002000201','2014-03-01','2014-02-13 21:56:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:10'),(24320,19314,'Y','18','021','EC','A','','','AC','0000161655','0000161655','TX00002234850','IL','1','LIBARDO','REMEGIO','','','III','34','843541284','2720 HYACINTH DR',0,'MESQUITE','TX','75181','1894','CY','48113','1991-08-28','M','U',':RET:2036-2','N','021','DEN','3789872','33348TX002000201','2014-04-01','2014-02-18 10:50:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-18 22:00:07'),(24984,19816,'Y','18','021','EC','A','','','AC','0001025912','0001025912','TX00002443200','31','1','Swoboda','Deanna','','','','34','460877072','7010 Coyote Run',0,'Bryan','TX','77808',NULL,'CY','48041','1978-03-23','F','U',':RET:2106-3','N','021','DEN','3253412','33348TX002000201','2014-04-01','2014-02-20 12:31:33','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-02-20 22:00:36'),(25634,20336,'Y','18','021','EC','A','','','AC','0000296840','0000296840','OH00001903572','IL','1','Lawrence','Richard','','','','34','031447444','6436 colonial Orchard Ct.',0,'Liberty Township','OH','45011',NULL,'CY','39017','1969-09-10','M','U',':RET:2106-3','N','021','DEN','3766724','99734OH005000301','2014-04-01','2014-02-22 17:44:59','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:30:25'),(26121,20716,'Y','18','021','EC','A','','','AC','0001178233','0001178233','OH00001908452','IL','1','hummel','linda','','','','34','302687803','8611 EMERSON RD',0,'APPLE CREEK','OH','44606','9778','CY','39169','1962-06-20','F','M',NULL,'N','021','DEN','3072260','99734OH005000401','2014-04-01','2014-02-27 00:18:48','0.00',NULL,NULL,'31.57','31.57','R-OH014','OH0','0.00',NULL,0,'2014-02-28 06:30:19'),(27774,21964,'Y','18','021','EC','A','','','AC','0001044541','0001044541','OH00003561703','IL','1','Tuma','Mary','','','','34','273460385','10 CAPRI DR',0,'SAGAMORE HILLS','OH','44067','1178','CY','39153','1960-06-16','F','U',':RET:2106-3','N','021','HLT','3791766','52664OH152000901','2014-04-01','2014-03-04 18:32:40','80.00',NULL,NULL,'333.21','253.21','R-OH012','OH0','333.21',NULL,0,'2014-03-05 21:31:28'),(2179,1791,'Y','18','021','EC','A','','','AC','0000242690','0000242690','OH00000996021','IL','1','GAERTNER','DEBORAH','','','','34','281528470','8175 MAPLEWOOD DR',0,'FINDLAY','OH','45840','8506','CY','39063','1953-05-27','F','M',':RET:2106-3','N','021','HLT','1211452','92036OH003001506','2014-01-01','2013-12-10 10:09:34','587.00',NULL,NULL,'623.76','36.76','R-OH002','OH0','623.76',NULL,0,'2013-12-25 19:19:20'),(15476,12380,'N','01','021','EC','A',NULL,NULL,'','0000680853','0000287106','','IL','1','JONES','PAUL','','','','34','296482930','7179 LEXINGTON CT',0,'NORTHFIELD','OH','44067',NULL,'CY','39153','1950-02-24','M','',NULL,'N','021','DEN','1641360','99734OH005000401','2014-02-01','2013-12-30 19:56:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:00'),(14730,11762,'Y','18','021','EC','A','','','AC','0001128005','0001128005','OH00001486605','IL','1','Jundi','Michael','','','','34','269783226','324 ASHLAND AVE',0,'CUYAHOGA FALLS','OH','44221','2210','CY','39153','1977-04-06','M','M',':RET:2106-3','N','021','HLT','2297573','52664OH151001304','2014-02-01','2013-12-28 14:13:07','222.01',NULL,NULL,'699.13','477.12','R-OH012','OH0','274.30',NULL,1,'2013-12-29 11:09:48'),(6580,5217,'Y','18','021','EC','A','','','AC','0000019094','0000019094','OH00000790524','IL','1','Tuel','Daniel','','','','34','270525614','328 Circle Drive',0,'Ripley','OH','45167',NULL,'CY','39015','1951-07-16','M','U',':RET:2106-3','N','021','HLT','518508','92036OH005000604','2014-01-01','2013-12-11 13:07:57','422.00',NULL,NULL,'616.74','194.74','R-OH005','OH0','616.74',NULL,0,'2013-12-26 00:52:56'),(9562,7580,'Y','18','021','EC','A','','','AC','0000718911','0000718911','OH00000805534','IL','1','Pushkaran','Ashish','','','','34','275065032','1395 STABLEVIEW CIR',0,'MAINEVILLE','OH','45039','7916','CY','39165','1978-06-18','M','M',':RET:2029-7','N','021','DEN','1600650','99734OH005000301','2014-01-01','2013-12-21 16:06:06','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:36'),(7337,5811,'Y','18','021','EC','A','','','AC','0000452722','0000452722','OH00000782040','IL','1','Mest','Gary','','','Jr','34','175709668','403 N LYMAN ST',0,'WADSWORTH','OH','44281','1824','CY','39103','1983-09-09','M','M',':RET:2106-3','T','021','HLT','92166','52664OH152000901','2014-01-01','2013-12-14 13:55:54','89.00',NULL,NULL,'213.20','124.20','R-OH012','OH0','213.20',NULL,0,'2013-12-26 02:03:56'),(7248,5748,'Y','18','021','EC','A','','','AC','0000463248','0000463248','LA00000604825','IL','1','Oettli','Albert','R','','','34','434841333','821 N HOWARD AVE',0,'METAIRIE','LA','70003','6317','CY','22051','1949-05-02','M','U',':RET:2106-3','N','021','DEN','1116397','18575LA002000201','2014-01-01','2013-12-14 15:33:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:50'),(16296,13047,'Y','18','021','EC','A','','','AC','0001989812','0001989812','LA00000576782','IL','1','JONES','VIRGIE','','','','34','433114138','6982 CEMETARY HWY',0,'SAINT MARTINVILLE','LA','70582','7324','CY','22099','1956-09-30','F','U',':RET:2054-5','N','021','DEN','1632682','18575LA002000201','2014-02-01','2014-01-06 12:40:56','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-07 04:01:01'),(18322,14628,'Y','18','021','EC','A','','','AC','0000411140','0000411140','OH00001882313','IL','1','Asgede','Asmeret','Mekonnen','','','34','422179914','2360 PARKWOOD AVE',0,'COLUMBUS','OH','43211','2375','CY','39049','1972-05-15','F','U',NULL,'N','021','DEN','1829327','99734OH005000401','2014-02-01','2014-01-15 11:02:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:07'),(21212,16951,'Y','18','021','EC','A','','','AC','0001980434','0001980434','LA00001763195','IL','1','Stewart','James','','','','34','414635366','1826 S BRIGHTSIDE VIEW DR',0,'BATON ROUGE','LA','70820','4795','CY','22033','1986-06-26','M','U',':RET:2106-3','N','021','DEN','3377538','18575LA002000201','2014-03-01','2014-02-03 12:49:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-03 21:00:59'),(21947,17527,'Y','18','021','EC','A','','','AC','0000156973','0000156973','OH00001870524','IL','1','Jones','Shirley','','','','34','270542443','217 PARK ST',0,'WILLARD','OH','44890','1318','CY','39077','1951-09-28','F','M',':RET:2106-3','N','021','DEN','3467980','99734OH005000401','2014-03-01','2014-02-06 18:33:22','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-07 19:00:19'),(23743,18905,'Y','18','021','EC','A','','','AC','0000533347','0000533347','OH00002465491','IL','1','WALDRON','STEPHEN','','','','34','058745911','65666 BETHEL RD',0,'NEW PLYMOUTH','OH','45654','8936','CY','39163','1980-05-07','M','M',NULL,'N','021','DEN','3469550','99734OH005000301','2014-03-01','2014-02-14 00:58:47','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-02-14 21:31:05'),(23814,18949,'Y','18','021','EC','A','','','AC','0000625469','0000625469','OH00002096156','IL','1','Kreakie','Nicholas','','','','34','274904112','1882 BROOKWOOD CT',0,'ORRVILLE','OH','44667','2368','CY','39169','1983-08-30','M','M',':RET:2106-3','N','021','HLT','2897356','52664OH152000901','2014-03-01','2014-02-14 17:45:02','86.00',NULL,NULL,'368.17','282.17','R-OH014','OH0','185.39',NULL,0,'2014-02-14 21:31:37'),(26666,21140,'Y','18','021','EC','A','','','AC','0000904448','0000904448','LA00002444780','IL','1','JENKINS','LILLIAN','A','','','34','439177805','861 RWE JONES ST',0,'GRAMBLING','LA','71245','2102','CY','22061','1959-09-28','F','U',':RET:2054-5','N','021','DEN','3327431','18575LA002000201','2014-04-01','2014-02-27 21:52:22','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-28 21:31:15'),(1125,925,'Y','18','021','EC','A','','','AC','0000266506','0000266506','OH00001227796','IL','1','bodiker','rickey','','','','34','295588540','8089 STATE ROUTE 219',0,'CELINA','OH','45822','8809','CY','39107','1956-03-02','M','U',':RET:2106-3','N','021','HLT','1087692','92036OH003001506','2014-01-01','2013-12-03 15:35:17','556.03',NULL,NULL,'560.12','4.09','R-OH002','OH0','560.12',NULL,0,'2013-12-25 18:17:53'),(4519,3581,'N','01','021','EC','A',NULL,NULL,'','0000626066','0000686658','','IL','1','LAROCCA','MARK','','','','34','436826295','6615 ENTLE WIND LANE',0,'DALLAS','TX','75248',NULL,'CY','48113','1951-03-06','M','',':RET:2106-3','N','021','DEN','1091971','33348TX002000201','2014-01-01','2013-12-12 12:32:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:47'),(3091,2484,'N','01','021','EC','A',NULL,NULL,'','0001086756','0000676684','','IL','1','Marshall','Bennie','','','','34','430901280','2760 WENTWORTH AVE',0,'DAYTON','OH','45406','1640','CY','39113','1949-07-26','M','',':RET:2054-5','N','021','HLT','111718','92036OH004000501','2014-01-01','2013-12-05 22:44:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','573.40',NULL,0,'2013-12-25 20:20:00'),(14024,11171,'N','19','021','EC','A',NULL,NULL,'','0000865860','0000274778','','IL','1','HUA','KATHY','','','','34','270963268','1208 HOLLY DR',0,'SPRINGFIELD','OH','45504','4141','CY','39023','1993-02-17','F','',':RET:2047-9','N','021','HLT','2044515','92036OH002000501','2014-01-01','2013-12-23 10:50:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','174.32',NULL,0,'2013-12-26 13:16:42'),(4333,3442,'Y','18','024','14','A','','','TE','0000955508','0000955508','','IL','1','RAMEY','DEBRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-08-07','F','',NULL,NULL,NULL,'','687234','','2013-12-17','2013-12-17 10:47:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:53:04'),(8035,6362,'Y','18','021','EC','A','','','AC','0000276265','0000276265','OH00001312493','IL','1','Kaufman','Mary','','','','34','297848783','912 HEATHERVIEW CT',0,'FINDLAY','OH','45840',NULL,'CY','39063','1976-12-21','F','M',NULL,'N','021','HLT','1726386','92036OH005001505','2014-01-01','2013-12-20 15:20:41','449.00',NULL,NULL,'615.91','166.91','R-OH002','OH0','272.46',NULL,0,'2013-12-26 03:09:16'),(7018,5572,'Y','18','021','EC','A','','','AC','0000975135','0000975135','TX00000652281','IL','1','Thomas','Jane','','','','34','086744747','13327 LOST LAKE DR',0,'SAN ANTONIO','TX','78249','3605','CY','48029','1966-10-31','F','U',':RET:2106-3','N','021','DEN','1551556','33348TX002000201','2014-01-01','2013-12-24 20:37:57','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 01:48:44'),(17126,13706,'Y','18','021','EC','A','','','AC','0000414710','0000414710','OH00001949781','IL','1','manning','nathan','','','','34','284709491','554 iroquois trail',0,'willoughby','OH','44094',NULL,'CY','39085','1974-12-06','M','M',':RET:2106-3','N','021','DEN','1661027','99734OH005000401','2014-02-01','2014-01-08 11:10:36','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:21:44'),(21655,17294,'Y','18','021','EC','A','','','AC','0001649929','0001649929','LA00001577211','IL','1','MCALISTER','CHARLENE','','','','34','434218630','32744 CAROLEE CIR',0,'DENHAM SPRINGS','LA','70706','0958','CY','22063','1968-08-29','F','U',':RET:2106-3','T','021','DEN','3409102','18575LA002000201','2014-03-01','2014-02-05 10:25:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:52'),(23006,18341,'Y','18','024','14','A','','','TE','0001016891','0001016891','','IL','1','mccandless','Lawren',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-20','M','',NULL,NULL,NULL,'','3271258','','2014-02-12','2014-02-12 18:15:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:30:21'),(664,548,'Y','18','021','EC','A','','','AC','0000568009','0000568009','OH00000480146','IL','1','DiBiagio','Kathryn','','','','34','213137681','7658 COLDSTREAM DR',0,'CINCINNATI','OH','45255','3932','CY','39061','1986-02-14','F','U',':RET:2106-3','N','021','DEN','1759919','99734OH005000301','2014-01-01','2013-12-16 07:43:19','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:57'),(15847,12689,'N','19','021','EC','A',NULL,NULL,'','0000798423','0000430283','','S1','1','Bacon','Brian','','','','34','693478535','1128 W State St',0,'Lima','OH','45805',NULL,'CY','39003','2012-03-07','F','',':RET:2106-3','N','021','DEN','2535120','99734OH005000401','2014-02-01','2014-01-02 17:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:04:21'),(14391,11478,'Y','18','021','EC','A','','','AC','0000559446','0000559446','OH00000807172','IL','1','Abulella','Magdy','','','','34','271869369','1710 Wilshire Drive',0,'Columbus','OH','43221',NULL,'CY','39049','1956-01-12','M','U',NULL,'N','021','DEN','1392718','99734OH005000401','2014-02-01','2013-12-27 15:06:32','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:31:00'),(5293,4194,'Y','18','021','EC','A','','','AC','0001040843','0001040843','OH00000404454','IL','1','Crumb','Alice','','','','34','272746091','3194 HARTVILLE RD',0,'ROOTSTOWN','OH','44272','9663','CY','39133','1974-09-18','F','U',':RET:2106-3','N','021','HLT','1375397','52664OH151001306','2014-01-01','2013-12-19 17:33:59','199.00',NULL,NULL,'281.44','82.44','R-OH012','OH0','281.44',NULL,0,'2013-12-25 23:06:06'),(17078,13668,'Y','18','021','EC','A','','','AC','0000530655','0000530655','TX00002393883','IL','1','chavez','david','','','','34','465870474','2425 katy flewellen rd',0,'katy','TX','77494',NULL,'CY','48157','1980-01-05','M','M',NULL,'N','021','DEN','2217470','33348TX002000201','2014-02-01','2014-01-08 12:53:33','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:21:21'),(18513,14762,'N','19','021','EC','A',NULL,NULL,'','0000932125','0000081309','','S1','1','Mohr','J','Gregory','','','34','287132895','192 Garmatter St',0,'Bluffton','OH','45817',NULL,'CY','39003','2007-10-06','F','',':RET:2106-3','N','021','HLT','2043952','92036OH004001501','2014-02-01','2014-01-15 10:52:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-01-16 08:46:34'),(19561,15593,'N','01','021','EC','A',NULL,NULL,'','0002099469','0002068763','','IL','1','LANDRY','JEANNE','','','','34','467987315','59655 KEMBER DR',0,'PLAQUEMINE','LA','70764',NULL,'CY','22047','1954-04-16','F','',NULL,'T','021','DEN','2739995','18575LA002000201','2014-03-01','2014-01-22 10:02:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 03:02:33'),(25311,20079,'Y','18','024','14','A','','','TE','0000543705','0000543705','','IL','1','STACK','THOMAS','AIDAN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-09','M','',NULL,NULL,NULL,'','1841788','','2014-02-28','2014-02-25 13:32:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-25 21:00:32'),(25566,20281,'Y','18','021','EC','A','','','AC','0000832050','0000832050','OH00002932384','IL','1','FIXX','VINITA','','','','34','273508570','609 N WEST ST',0,'LIMA','OH','45801','4018','CY','39003','1950-11-04','F','M',NULL,'N','021','HLT','2691165','92036OH004001501','2014-04-01','2014-02-23 12:51:14','495.00',NULL,NULL,'522.40','27.40','R-OH002','OH0','522.40',NULL,0,'2014-02-26 08:00:26'),(27479,21745,'Y','18','021','EC','A','','','AC','0000816958','0000816958','TX00003699195','IL','1','Ferrell','Evelyn','','','','34','247673397','1306 Powder River Dr',0,'Killeen','TX','76549',NULL,'CY','48027','1971-11-15','F','M',':RET:2054-5','N','021','DEN','3273333','33348TX002000101','2014-04-01','2014-03-04 12:47:42','0.00',NULL,NULL,'50.04','50.04','R-TX011','TX0','25.02',NULL,0,'2014-03-04 21:02:16'),(5673,4500,'N','01','021','EC','A',NULL,NULL,'','0000087455','0000457786','','IL','1','Taylor','Evonne','','','','34','265753990','508 SUNNYMEADE LN',0,'LIMA','OH','45804','3536','CY','39003','1963-03-20','F','',':RET:2106-3','T','021','HLT','775331','92036OH005001505','2014-01-01','2013-11-25 20:27:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','452.02',NULL,0,'2013-12-25 23:32:06'),(4777,3791,'Y','18','021','EC','A','','','AC','0000133518','0000133518','MS00000302403','IL','1','Jobe','Shemekisa','','','','34','553719706','162 CROWN RD',0,'CAMDEN','MS','39045','9668','CY','28089','1982-05-17','F','M',':RET:2054-5','N','021','DEN','1250398','46300MS002000201','2014-01-01','2013-12-07 18:41:04','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 22:16:01'),(1791,1472,'N','19','021','EC','A',NULL,NULL,'','0000627876','0000427637','','IL','1','Landfair','Alana','F','','','34','649161116','4173 FOREST RIDGE BLVD',0,'DAYTON','OH','45424','4836','CY','39113','1998-11-12','F','',NULL,'N','021','DEN','2280430','99734OH005000301','2014-01-01','2013-12-24 16:43:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:34'),(14029,11175,'Y','18','021','EC','A','','','AC','0000071644','0000071644','OH00001069293','IL','1','MERUNSKI','KEN','R','','','34','289440458','6148 MEADVIEW DR',0,'SEVEN HILLS','OH','44131',NULL,'CY','39035','1952-04-11','M','U',':RET:2106-3','N','021','HLT','2107851','92036OH004000801','2014-01-01','2013-12-23 14:43:00','414.00',NULL,NULL,'528.27','114.27','R-OH011','OH0','528.27',NULL,0,'2013-12-26 13:16:49'),(7054,5604,'Y','18','021','EC','A','','','AC','0000493230','0000493230','OH00000453059','IL','1','veitch','francesca','','','','34','297921748','2928 LINWOOD AVE',0,'CINCINNATI','OH','45208','2827','CY','39061','1988-09-02','F','U',':RET:2106-3','N','021','DEN','2045746','99734OH005000301','2014-01-01','2013-12-24 19:52:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:49:47'),(9726,7703,'Y','18','024','14','A','','','TE','0000612954','0000612954','','IL','1','Fritsch','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-14','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-01-01','2013-11-14 23:56:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:45:35'),(9237,7329,'Y','18','021','EC','A','','','AC','0000685832','0000685832','OH00000614214','IL','1','Okes','Deborah','','','','34','294600436','11 phillip court',0,'elyria','OH','44035',NULL,'CY','39093','1966-10-19','F','U',':RET:2106-3','N','021','HLT','2256482','92036OH004000801','2014-01-01','2013-12-18 15:51:05','777.00',NULL,NULL,'789.96','12.96','R-OH011','OH0','293.84',NULL,0,'2013-12-26 04:10:36'),(7481,5919,'Y','18','021','EC','A','','','AC','0001165322','0001165322','OH00000349206','IL','1','Karr','Marjean','','','','34','268504253','4750 STATE ROUTE 412',0,'VICKERY','OH','43464','9793','CY','39143','1949-04-16','F','M',NULL,'N','021','DEN','377536','99734OH005000401','2014-01-01','2013-12-15 12:47:06','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 02:31:23'),(17845,14255,'Y','18','021','EC','A','','','AC','0001184902','0001184902','OH00001936487','IL','1','MCCULLOCK','LETICIA','JANET','','','34','464498515','7608 CYPRESS POINT DR',0,'PICKERINGTON','OH','43147','8749','CY','39045','1963-12-09','F','M',NULL,'N','021','DEN','1746629','99734OH005000401','2014-02-01','2014-01-13 23:37:25','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:05'),(18716,14919,'N','01','021','EC','A',NULL,NULL,'','0000785825','0000695661','','IL','1','Liccardi','Janet','','','','34','210605533','326 ROSEGARDEN DR NE',0,'WARREN','OH','44484','1827','CY','39155','1968-09-15','F','',':RET:2106-3','N','021','DEN','3054281','99734OH005000301','2014-02-01','2014-01-15 22:45:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:33'),(20754,16583,'Y','18','021','EC','A','','','AC','0000152011','0000152011','OH00001350844','IL','1','Henry','Matthew','','','','34','576629098','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1953-07-14','M','M',NULL,'N','021','HLT','3188235','92036OH005001201','2014-03-01','2014-01-30 11:12:51','633.00',NULL,NULL,'1206.23','573.23','R-OH004','OH0','582.60',NULL,0,'2014-01-30 21:01:32'),(22942,18290,'Y','18','024','14','A','','','TE','0000388650','0000388650','','IL','1','whitaker','norman',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-03-22','M','',NULL,NULL,NULL,'','2163191','','2014-02-28','2014-02-10 22:31:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:20'),(23077,18400,'Y','18','021','EC','A','','','AC','0001994808','0001994808','LA00002222895','IL','1','Maldonado','Marina','','','','34','437655725','3600 TULANE DR',0,'KENNER','LA','70065','2426','CY','22051','1953-02-28','F','U',NULL,'N','021','DEN','3275605','18575LA002000201','2014-03-01','2014-02-12 16:52:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:31:00'),(24739,19635,'N','01','021','EC','A',NULL,NULL,'','0000990107','0000504519','','IL','1','Lovingshimer','Carl','Lee','','Jr','34','299806976','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-06-11','M','',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:09'),(26527,21036,'N','19','021','EC','A',NULL,NULL,'','0000476002','0000241571','','IL','1','Stevens','Rebecca','Lynn','','','34','295981034','276 State Route 196',0,'New Hampshire','OH','45870',NULL,'CY','39011','1996-02-11','F','',':RET:2106-3','N','021','HLT','3425745','92036OH003001505','2014-03-01','2014-02-28 14:55:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95','CIC',0,'2014-02-28 21:00:26'),(26546,21049,'Y','18','021','EC','A','','','AC','0000858541','0000858541','OH00002586322','IL','1','Christy','Angela','','','','34','284826023','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1982-12-10','F','U',':RET:2106-3','N','021','DEN','3004039','99734OH005000301','2014-04-01','2014-02-28 13:43:52','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2014-02-28 21:30:11'),(27963,22122,'Y','18','021','EC','A','','','AC','0001783011','0001783011','LA00003639860','IL','1','Bui','Thuy','','','','34','480153601','1301 ARTESA DR',0,'MARRERO','LA','70072','5974','CY','22051','1970-08-09','M','M',':RET:2047-9','N','021','DEN','3675265','18575LA002000201','2014-04-01','2014-03-05 22:12:22','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:46'),(28451,22513,'Y','18','021','EC','A','','','AC','0002151075','0002151075','LA00002703715','IL','1','allen','lakeisha','','','','34','435738004','14409 ROYAL OAKS AVE',0,'BATON ROUGE','LA','70816','2650','CY','22033','1988-10-23','F','U',':RET:2054-5','N','021','DEN','3855014','18575LA002000201','2014-04-01','2014-03-07 11:32:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-07 21:31:20'),(28598,22632,'Y','18','021','EC','A','','','AC','0000402519','0000402519','OH00002962942','IL','1','Glasgow','Seth','','','','34','293886232','11 S HIGHLAND AVE',0,'AKRON','OH','44303','1059','CY','39153','1985-04-18','M','R',':RET:2106-3','T','021','DEN','4182759','99734OH005000401','2014-04-01','2014-03-08 10:01:47','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-08 21:30:06'),(875,724,'Y','18','021','EC','A','','','AC','0001020401','0001020401','OH00000005298','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',NULL,'N','021','HLT','1806812','92036OH005000506','2014-01-01','2013-12-16 11:19:14','397.00',NULL,NULL,'424.53','27.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 18:07:33'),(15234,12176,'Y','18','021','EC','A','','','AC','0000581504','0000581504','OH00000259062','IL','1','Terilla','Lee','Ann','','','34','278524859','225 WINSTON RD',0,'AKRON','OH','44313','6031','CY','39153','1956-05-24','F','M',':RET:2106-3','N','021','HLT','1682522','52664OH151001501','2014-02-01','2013-12-30 12:59:47','223.00',NULL,NULL,'651.81','428.81','R-OH012','OH0','651.81',NULL,0,'2014-01-01 12:08:22'),(14376,11467,'Y','18','024','14','A','','','TE','0000498169','0000498169','','IL','1','TITTLE','KELLY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-06-01','F','',NULL,NULL,NULL,'','2058238','','2013-12-27','2013-12-27 11:47:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:30:40'),(20900,16705,'Y','18','021','EC','A','','','AC','0000692958','0000692958','OH00002024015','IL','1','Ziegler','Jessica','','','','34','298848273','5071 REVERE CT',0,'MASON','OH','45040','3613','CY','39165','1986-09-04','F','U',':RET:2106-3','N','021','DEN','2989994','99734OH005000401','2014-03-01','2014-01-31 13:50:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:20'),(23297,18572,'Y','18','021','EC','A','','','AC','0001182543','0001182543','OH00001916582','S3','1','Smith','Jeffery','Jefferson','','','34','308193013','2303 MARION MOUNT GILEAD RD',0,'MARION','OH','43302','8912','CY','39101','1997-07-22','M','U',':RET:2106-3','N','021','DEN','3479439','99734OH005000301','2014-03-01','2014-02-13 01:12:11','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','21.13',NULL,0,'2014-02-13 22:00:12'),(24173,19204,'N','01','021','EC','A',NULL,NULL,'','0000763567','0001093184','','IL','1','Russell','Lauri','Anne','','','34','278827389','5211 SHEILA DR',0,'TOLEDO','OH','43613','2441','CY','39095','1970-10-08','F','',':RET:2106-3','N','021','HLT','2897387','92036OH006002601','2014-03-01','2014-02-15 16:20:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','209.85',NULL,0,'2014-02-15 22:02:10'),(26961,21361,'N','19','021','EC','A',NULL,NULL,'','0000927364','0000672819','','S1','1','MOZINA','KIRK','','','','34','272069836','9102 TANGLEWOOD RD',0,'MACEDONIA','OH','44056',NULL,'CY','39153','2000-11-30','F','',NULL,'N','021','HLT','2807667','52664OH151001301','2014-04-01','2014-03-02 13:46:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 01:00:30'),(27113,21460,'Y','18','021','EC','A','','','AC','0000965832','0000965832','OH00003077916','IL','1','Baer','Robert','C','','','34','272827344','120 SHERIDAN AVE',0,'XENIA','OH','45385','2248','CY','39057','1984-03-16','M','U',':RET:2106-3','T','021','DEN','3446133','99734OH005000301','2014-04-01','2014-03-02 20:53:37','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-03 21:30:28'),(27469,21739,'Y','18','021','EC','A','','','AC','0000990117','0000990117','OH00002611841','IL','1','FOWLER','GREGORY','','','','34','292668679','1701 DARLAND AVE',0,'LIMA','OH','45804',NULL,'CY','39003','1960-12-02','M','M',NULL,'N','021','HLT','3828458','92036OH004001501','2014-04-01','2014-03-03 21:01:34','535.00',NULL,NULL,'722.02','187.02','R-OH002','OH0','361.01',NULL,0,'2014-03-04 21:02:10'),(5726,4545,'N','01','021','EC','A',NULL,NULL,'','0002266676','0001428844','','IL','1','Jewell','Linda','Williams','','','34','456804143','13544 MINOU AVE',0,'BATON ROUGE','LA','70809','5425','CY','22033','1952-09-20','F','',':RET:2106-3','N','021','DEN','2422009','18575LA002000201','2014-01-01','2013-12-23 22:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:45:32'),(14074,11216,'Y','18','024','14','A','','','TE','0000291953','0000291953','','IL','1','Hernandez','Angel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-04-09','M','',NULL,NULL,NULL,'','139246','','2013-12-26','2013-12-26 09:59:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:00:57'),(1035,849,'Y','18','021','EC','A','','','AC','0000745347','0000745347','TX00000833174','IL','1','Lambert','Jeffrey','','','','34','466941035','5071 MEADOWLARK DR',0,'EL PASO','TX','79922','2025','CY','48141','1956-06-27','M','U',':RET:2106-3','N','021','DEN','1096669','33348TX002000201','2014-01-01','2013-12-03 15:02:49','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:15:37'),(13096,10441,'Y','18','021','EC','A','','','AC','0000895709','0000895709','OH00000605318','IL','1','Mitchell','Kyle','','','','34','301905669','6835 AUTUMN MIST CT',0,'MASON','OH','45040','9404','CY','39165','1988-03-28','M','U',':RET:2106-3','N','021','DEN','1773671','99734OH005000401','2014-01-01','2013-12-23 11:59:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:01'),(9775,7741,'N','01','021','EC','A',NULL,NULL,'','0000228701','0000230127','','IL','1','Dale','Bruce','','','','34','370860821','3308 Blanchard Dr.',0,'Chalmette','LA','70043',NULL,'CY','22087','1965-02-23','M','',NULL,'T','021','DEN','326675','18575LA002000201','2014-01-01','2013-10-20 18:38:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 05:00:35'),(1109,912,'N','01','021','EC','A',NULL,NULL,'','0000720220','0000483449','','IL','1','deter','katherine','','','','34','281841666','1050 THOMAS DR',0,'ASHLAND','OH','44805','2951','CY','39005','1985-02-07','F','',':RET:2106-3','N','021','DEN','1219681','99734OH005000401','2014-01-01','2013-12-03 16:30:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:17:27'),(8155,6452,'Y','18','021','EC','A','','','AC','0000951760','0000951760','OH00000669438','IL','1','HOFFMAN','SHARON','LYNN','','','34','299525537','2438 N HAVEN BLVD',0,'CUYAHOGA FALLS','OH','44223',NULL,'CY','39153','1952-09-25','F','M',':RET:2106-3','N','021','HLT','91745','52664OH151001305','2014-01-01','2013-11-22 10:34:04','1067.00',NULL,NULL,'1267.35','200.35','R-OH012','OH0','626.65',NULL,0,'2013-12-26 03:16:10'),(1399,1161,'N','01','021','EC','A',NULL,NULL,'','0002152355','0001174920','','IL','1','vilaysack','phit','','','','34','587565792','2250 turkey creek',0,'glenmora','LA','71433',NULL,'CY','22079','1952-05-02','F','',':RET:2028-9','N','021','DEN','1836488','18575LA002000201','2014-01-01','2013-12-24 12:19:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:46:33'),(7038,5589,'Y','18','021','EC','A','','','AC','0000390673','0000390673','TX00000129274','IL','1','Johnson','Sara','','','','34','474929930','6200 E SAM HOUSTON PKWY N',0,'HOUSTON','TX','77049','7260','CY','48201','1972-07-02','F','U',':RET:2106-3','N','021','DEN','2232138','33348TX002000201','2014-02-01','2013-12-25 00:17:03','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:49:19'),(2245,1843,'N','01','021','EC','A',NULL,NULL,'','0000991516','0000149326','','IL','1','Schriml','Michael','','','','34','279689093','7118 KIRKCALDY DR',0,'WEST CHESTER','OH','45069','4002','CY','39017','1966-04-17','M','',':RET:2106-3','N','021','HLT','420479','92036OH003001205','2014-01-01','2013-12-10 16:51:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','350.40',NULL,0,'2013-12-25 19:21:06'),(5531,4387,'Y','18','021','EC','A','','','AC','0000878232','0000878232','OH00000718471','IL','1','Twobulls','Lorene','','','','34','282466047','226 W. Allen St.',0,'Lancaster','OH','43130',NULL,'CY','39045','1959-07-19','F','M',':RET:2106-3','N','021','DEN','634207','99734OH005000401','2014-01-01','2013-11-27 10:31:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:34'),(3187,2563,'Y','18','021','EC','A','','','AC','0000642036','0000642036','OH00000984278','IL','1','Baughman','Susan','','','','34','266800690','1076 MIDDLECOFF DR',0,'AKRON','OH','44313','5242','CY','39153','1954-02-18','F','M',NULL,'N','021','HLT','987053','52664OH151001501','2014-01-01','2013-11-18 17:03:09','200.00',NULL,NULL,'696.21','496.21','R-OH012','OH0','696.21',NULL,0,'2013-12-25 20:32:01'),(4645,3682,'Y','18','021','EC','A','','','AC','0000377174','0000377174','MS00000035987','IL','1','ROBINSON','NANCY','','','','34','427986832','1744 STATEN RD',0,'ACKERMAN','MS','39735','6642','CY','28019','1949-10-03','F','U',':RET:2054-5','N','021','DEN','791267','46300MS002000201','2014-01-01','2013-12-12 15:56:26','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 22:06:53'),(18229,14549,'Y','18','021','EC','A','','','AC','0000679796','0000679796','TX00002430039','IL','1','Stone','Brad','','','','34','446928158','4490 w eldorado',0,'mckinney','TX','75070',NULL,'CY','48085','1978-12-04','M','U',':RET:2106-3','N','021','DEN','2188798','33348TX002000201','2014-02-01','2014-01-14 21:49:15','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-16 08:44:18'),(18920,15074,'N','01','021','EC','A',NULL,NULL,'','0001094663','0001016879','','IL','1','TOPP','KURT','M','','','34','301766699','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1971-02-17','M','',':RET:2106-3','N','021','HLT','1606089','92036OH003001506','2014-02-01','2014-01-15 19:34:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.54',NULL,0,'2014-01-17 03:36:43'),(21844,17445,'Y','18','021','EC','A','','','AC','0000915679','0000915679','OH00001577240','IL','1','gaglione','Elaine','','','','34','300441434','334 STANTON HALL CT',0,'KETTERING','OH','45429','1851','CY','39113','1961-11-20','F','M',':RET:2106-3','N','021','DEN','3130763','99734OH005000301','2014-03-01','2014-02-06 11:42:19','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-02-06 21:01:12'),(22366,17861,'Y','18','024','14','A','','','TE','0000815328','0000815328','','IL','1','hindsman','latoya','marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-04-15','F','',NULL,NULL,NULL,'','1898543','','2014-02-28','2014-02-10 14:35:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-10 21:00:10'),(24370,19356,'Y','18','021','EC','A','','','AC','0001927696','0001927696','LA00001658757','IL','1','Foster','Lora','','','','34','438376142','246 EUGENE RD',0,'FERRIDAY','LA','71334','2127','CY','22029','1963-08-30','F','U',':RET:2054-5','N','021','DEN','3606017','18575LA002000201','2014-04-01','2014-02-18 15:37:01','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-18 22:00:37'),(25867,20508,'Y','18','021','EC','A','','','AC','0001844896','0001844896','LA00003162610','IL','1','Gentris','Ashley','','','','34','438492414','1418 MEREDITH ST',0,'OPELOUSAS','LA','70570','2812','CY','22097','1983-05-16','F','M',':RET:2054-5','N','021','DEN','3515327','18575LA002000201','2014-03-01','2014-02-26 14:51:44','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 21:00:48'),(26028,20643,'Y','18','021','EC','A','','','AC','0000672626','0000672626','MS00002149545','IL','1','WILLIAMS','JAMANDA','','','','34','425593092','4933 FOREST HILL RD',0,'JACKSON','MS','39272','5733','CY','28049','1987-01-18','F','M',':RET:2054-5','N','021','DEN','3532223','46300MS002000101','2014-03-01','2014-02-26 12:24:13','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-02-26 21:02:19'),(454,370,'N','01','021','EC','A',NULL,NULL,'','0000001005','0000457790','','IL','1','smith','mandy','a','','','34','301786771','2110 PLEASANT HILL RD',0,'MARION','OH','43302','9474','CY','39101','1977-05-12','F','',':RET:2106-3','T','021','DEN','630463','99734OH005000401','2014-01-01','2013-12-04 17:54:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:25'),(24043,19121,'Y','18','024','14','A','','','TE','0000546512','0000546512','','IL','1','Soutendijk','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-01','F','',NULL,NULL,NULL,'','3563135','','2014-02-15','2014-02-15 10:51:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:00:59'),(28223,22331,'Y','18','021','EC','A','','','AC','0000971518','0000971518','OH00003480958','S1','1','Habli','firas','','','','34','302088105','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2004-08-11','M','U',NULL,'N','021','DEN','3168356','99734OH005000301','2014-04-01','2014-03-06 15:30:35','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13','CIC',0,'2014-03-06 21:30:20'),(1133,932,'Y','18','021','EC','A','','','AC','0000149183','0000149183','LA00000439559','IL','1','Mayfield','LaKitta','Marie','','','34','435675501','213 MAGNOLIA RIDGE RD',0,'BOUTTE','LA','70039','3215','CY','22089','1977-11-15','F','U',':RET:2054-5','N','021','DEN','70288','18575LA002000201','2014-01-01','2013-12-02 19:40:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:06'),(1470,1225,'Y','18','021','EC','A','','','AC','0001250845','0001250845','OH00000734868','IL','1','SWEENEY','JASON','L','','','34','283761902','1179 OXFORD RD',0,'CLEVELAND HEIGHTS','OH','44121','1827','CY','39035','1978-01-04','M','U',':RET:2054-5','N','021','DEN','2009447','99734OH005000401','2014-01-01','2013-12-24 09:28:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:48:33'),(5542,4397,'Y','18','021','EC','A','','','AC','0000553147','0000553147','MS00000499282','IL','1','Stoner','Rovella','','','','34','587727357','259 Old State Line Road',0,'Tylertown','MS','39667',NULL,'CY','28147','1953-04-11','F','U',':RET:2054-5','N','021','DEN','692157','46300MS002000201','2014-01-01','2013-11-26 18:57:16','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 23:15:51'),(14530,11593,'Y','18','021','EC','A','','','AC','0000837367','0000837367','TX00001292635','IL','1','Garcia','Maria','','','','34','464634737','225 S. Bryan Blvd.',0,'Alton','TX','78573',NULL,'CY','48215','1968-05-26','F','U',':RET:2106-3','N','021','DEN','2273888','33348TX002000201','2014-02-01','2013-12-27 18:16:36','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-28 03:34:32'),(13677,10913,'Y','18','021','EC','A','','','AC','0000872037','0000872037','OH00000736224','IL','1','Thielenhaus','Douglas','','','','34','501744196','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1966-06-29','M','M',':RET:2106-3','N','021','HLT','2392738','52664OH151001305','2014-01-01','2013-12-22 19:09:24','313.00',NULL,NULL,'660.10','347.10','R-OH012','OH0','348.56',NULL,0,'2013-12-26 13:08:04'),(9575,7583,'N','19','021','EC','A',NULL,NULL,'','0001218535','0000145376','','IL','1','Hinkle','Nora','Corina','','','34','273040015','2593 MAPLE DR',0,'TWINSBURG','OH','44087','2139','CY','39153','1998-12-04','F','',':RET:2106-3','N','021','DEN','2409970','99734OH005000301','2014-01-01','2013-12-21 17:04:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:47'),(7737,6127,'Y','18','021','EC','A','','','AC','0000687211','0000687211','OH00001105979','IL','1','Mason','Barbara','','','','34','273804065','4951 FAIRFIELD CIR',0,'FAIRFIELD','OH','45014','2901','CY','39017','1970-04-19','F','U',NULL,'N','021','DEN','2382284','99734OH005000401','2014-01-01','2013-12-20 15:21:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:02:10'),(2224,1830,'N','01','021','EC','A',NULL,NULL,'','0001074125','0000184916','','IL','1','Nguyen','Hong','Hiep Huong','','','34','653109362','523 S WYNN RD',0,'OREGON','OH','43616','3020','CY','39095','1967-10-08','F','',':RET:2047-9','N','021','HLT','908870','92036OH003002605','2014-01-01','2013-12-10 14:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','305.45',NULL,0,'2013-12-25 19:20:36'),(2916,2350,'Y','18','021','EC','A','','','AC','0000640897','0000640897','OH00001222618','IL','1','Hensley','Jessica','','','','34','287809240','2028 ELM AVE',0,'NORWOOD','OH','45212','2103','CY','39061','1979-02-25','F','U',':RET:2106-3','N','021','DEN','570186','99734OH005000401','2014-01-01','2013-12-06 14:10:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:39'),(20855,16670,'Y','18','021','EC','A','','','AC','0001165375','0001165375','OH00002503307','IL','1','White','Brandi','','','','34','281920726','408 E 149TH ST',0,'CLEVELAND','OH','44110','1853','CY','39035','1990-04-09','F','U',':RET:2054-5','N','021','DEN','3671679','99734OH005000301','2014-03-01','2014-01-31 13:00:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-31 21:00:55'),(25185,19977,'Y','18','021','EC','A','','','AC','0000533353','0000533353','OH00002932364','IL','1','Cowan','Pamela','','','','34','282640663','678 TUSCARAWAS AVE NW',0,'BREWSTER','OH','44613','1058','CY','39151','1957-09-03','F','M',':RET:2106-3','N','021','DEN','3029215','99734OH005000401','2014-04-01','2014-02-21 16:00:50','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-21 22:00:36'),(5145,4079,'Y','18','021','EC','A','','','AC','0000934649','0000934649','OH00000154235','IL','1','Rowland','Charles','','','','34','296620546','9 KATHY CT',0,'NEW PARIS','OH','45347','1315','CY','39135','1956-08-21','M','M',':RET:2106-3','N','021','DEN','2195871','99734OH005000401','2014-01-01','2013-12-19 08:08:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:02:39'),(15768,12618,'Y','18','021','EC','A','','','AC','0001101422','0001101422','TX00001809333','IL','1','magness','clifton','','','','34','464026132','809 Imperial Ln.',0,'Corsicana','TX','75110',NULL,'CY','48349','1955-01-11','M','M',':RET:2106-3','N','021','DEN','1558215','33348TX002000201','2014-02-01','2014-01-02 13:24:22','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:44'),(1310,1084,'Y','18','021','EC','A','','','AC','0000860936','0000860936','OH00000383296','IL','1','Bashor','Harold','','','','34','268485568','100 E GAY ST',0,'COLUMBUS','OH','43215','3248','CY','39049','1951-02-06','M','U',':RET:2106-3','N','021','DEN','485032','99734OH005000401','2014-01-01','2013-11-03 18:17:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:31:26'),(3878,3106,'Y','18','021','EC','A','','','AC','0000039704','0000039704','LA00001144581','IL','1','Bergeron','James','','','','34','439949696','306 SWEETBRIAR DR',0,'ALEXANDRIA','LA','71303','3334','CY','22079','1957-09-18','M','U',':RET:2106-3','N','021','DEN','647647','18575LA002000201','2014-01-01','2013-12-13 13:40:07','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 21:36:22'),(9167,7270,'N','01','021','EC','A',NULL,NULL,'','0000777665','0000221280','','IL','1','Joseph','Kathy','Lynn','','','34','268604104','7367 CLUM RD',0,'HARROD','OH','45850','9413','CY','39003','1955-11-07','F','',':RET:2106-3','T','021','HLT','1472476','92036OH004001501','2014-01-01','2013-12-18 11:01:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','518.54',NULL,0,'2013-12-26 04:08:49'),(1964,1603,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','1073422','','2013-11-19','2013-11-19 22:59:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:18'),(2325,1891,'Y','18','021','EC','A','','','AC','0000047067','0000047067','TX00000592320','IL','1','slaughter','john scott','','','','34','457848368','3734 ligustrum dr',0,'abilene','TX','79605',NULL,'CY','48441','1951-12-17','M','U',':RET:2106-3','N','021','DEN','968123','33348TX002000201','2014-01-01','2013-12-09 08:32:59','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-25 19:31:30'),(3724,2976,'Y','18','021','EC','A','','','AC','0000759692','0000759692','OH00001129864','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,'23872 Glenhill',0,'Cleveland','OH','44122',NULL,'CY','39035','1950-01-06','F','U',':RET:2106-3','N','021','DEN','19200','99734OH005000401','2014-01-01','2013-12-13 16:18:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:32:25'),(17916,14311,'Y','18','021','EC','A','','','AC','0000768327','0000768327','TX00002403304','IL','1','McCall','Jennifer','','','','34','467653287','124 COUNTY ROAD 337',0,'GEORGE WEST','TX','78022','3921','CY','48297','1979-04-01','F','M',':RET:2106-3','N','021','DEN','1746630','33348TX002000201','2014-02-01','2014-01-14 00:21:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:29'),(18997,15130,'N','01','021','EC','A',NULL,NULL,'','0000040975','0000822078','','IL','1','peet','Michael','','','','34','283867951','142 W HIGHLAND AVE',0,'WOOSTER','OH','44691','1350','CY','39169','1977-01-29','M','',':RET:2106-3','N','021','HLT','1917833','52664OH151001305','2014-03-01','2014-01-16 20:38:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','276.08',NULL,0,'2014-01-20 08:06:13'),(21850,17448,'Y','18','021','EC','A','','','AC','0000397382','0000397382','OH00002479479','IL','1','Whitacre','Rachel','','','','34','235393763','2051 Murray Hill Rd',0,'Cleveland','OH','44106',NULL,'CY','39035','1985-04-13','F','U',NULL,'N','021','DEN','3588140','99734OH005000301','2014-03-01','2014-02-06 15:18:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:01:15'),(21863,17456,'Y','18','021','EC','A','','','AC','0000969478','0000969478','OH00001926394','IL','1','Reiter','Jana','','','','34','281502635','1005 Leonard Ct.',0,'Fostoria','OH','44830',NULL,'CY','39147','1965-11-12','F','U',':RET:2106-3','N','021','HLT','3438049','92036OH003002705','2014-03-01','2014-02-06 11:46:13','181.00',NULL,NULL,'332.95','151.95','R-OH006','OH0','332.95',NULL,0,'2014-02-06 21:01:20'),(22812,18205,'N','01','021','EC','A',NULL,NULL,'','0000322190','0000835511','','IL','1','Etter','Michael','R','','','34','290808917','342 BRITTON LN',0,'MONROE','OH','45050','1102','CY','39017','1981-07-12','M','',':RET:2106-3','N','021','DEN','2762493','99734OH005000301','2014-03-01','2014-02-11 15:26:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:58'),(26133,20724,'N','01','021','EC','A',NULL,NULL,'','0000911816','0001022837','','IL','1','DAVIS','KEITH','','','','34','283760553','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1967-11-07','M','',':RET:2106-3','N','021','DEN','3709810','99734OH005000401','2014-03-01','2014-02-27 12:17:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:23'),(27615,21840,'Y','18','024','14','A','','','TE','0000837423','0000837423','','IL','1','PORTILLO','OLGA','MARINA',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-01','F','',NULL,NULL,NULL,'','1827883','','2014-03-31','2014-03-05 12:43:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:30'),(5970,4726,'Y','18','021','EC','A','','','AC','0000500913','0000500913','MS00001381080','IL','1','Oatis','Cal','','','','34','425022189','1613 MELROSE PL',0,'CLINTON','MS','39056','3924','CY','28049','1956-09-17','M','M',NULL,'N','021','DEN','2208457','46300MS002000101','2014-01-01','2013-12-23 23:07:18','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 23:51:36'),(14735,11764,'Y','18','021','EC','A','','','AC','0000424035','0000424035','OH00000379291','IL','1','Norris','Kristine','','','','34','277601471','633 S WEST ST',0,'HILLSBORO','OH','45133','1377','CY','39071','1956-08-01','F','U',':RET:2106-3','N','021','HLT','1756695','92036OH004000601','2014-02-01','2013-12-28 14:39:16','265.00',NULL,NULL,'420.66','155.66','R-OH005','OH0','420.66',NULL,1,'2013-12-29 11:09:52'),(2550,2075,'Y','18','021','EC','A','','','AC','0000414676','0000414676','OH00000076280','31','1','Hovan','Rhonda','','','','34','286481377','PO Box 1110',0,'Bath','OH','44210',NULL,'CY','39153','1952-12-27','F','U',':RET:2106-3','N','021','HLT','1133116','52664OH151001501','2014-01-01','2013-12-09 15:17:44','264.00',NULL,NULL,'751.58','487.58','R-OH012','OH0','751.58',NULL,0,'2013-12-25 19:37:15'),(5155,4087,'Y','18','021','EC','A','','','AC','0000912943','0000912943','OH00000218897','IL','1','SPENCE','MINDI','','','','34','295547066','3224 SUMMERTIME CT',0,'COLUMBUS','OH','43221','4637','CY','39049','1968-10-10','F','U',':RET:2106-3','N','021','DEN','2421685','99734OH005000401','2014-01-01','2013-12-19 10:27:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:02:54'),(3030,2437,'Y','18','021','EC','A','','','AC','0000728680','0000728680','OH00000748585','IL','1','Barrera','Sandra','','','','34','277682165','8351 DORR ST',0,'TOLEDO','OH','43617','1732','CY','39095','1956-08-24','F','M',':RET:2106-3','N','021','HLT','1153011','92036OH004002601','2014-01-01','2013-12-05 22:35:56','743.00',NULL,NULL,'764.22','21.22','R-OH001','OH0','382.11',NULL,0,'2013-12-25 20:18:24'),(4807,3810,'Y','18','021','EC','A','','','AC','0000884185','0000884185','OH00000075038','IL','1','Yam','Christopher','','','','34','412537745','4443 WHITE TAIL CT',0,'NASHPORT','OH','43830','9297','CY','39119','1986-07-23','M','R',':RET:2034-7','N','021','DEN','8694','99734OH005000301','2014-01-01','2013-12-07 20:14:16','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:16:41'),(25233,20015,'Y','18','021','EC','A','','','AC','0001143360','0001143360','OH00001671579','IL','1','Daniels','Doria','','','','34','297420689','1200 CEDAR ST',0,'KENT','OH','44240','3791','CY','39133','1951-04-22','F','U',':RET:2054-5','N','021','HLT','3558321','52664OH152000901','2014-04-01','2014-02-21 11:14:21','469.28',NULL,NULL,'469.28','0.00','R-OH012','OH0','469.28',NULL,0,'2014-02-21 22:01:03'),(5632,4467,'Y','18','021','EC','A','','','AC','0000452703','0000452703','OH00000846235','IL','1','Davis','Robert','','','','34','273903508','6752 Ashley Court',0,'Mason','OH','45040',NULL,'CY','39165','1972-12-31','M','U',':RET:2106-3','N','021','DEN','2500','99734OH005000401','2014-01-01','2013-11-26 11:54:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:59'),(16762,13409,'Y','18','021','EC','A','','','AC','0000264222','0000264222','OH00001697536','IL','1','Weekley','Mark','Allen','','','34','300441003','1360 HILLCREST DR',0,'CUYAHOGA FALLS','OH','44221','4840','CY','39153','1953-10-03','M','M',':RET:2106-3','N','021','HLT','2187409','52664OH152000901','2014-02-01','2014-01-07 11:10:07','692.00',NULL,NULL,'868.49','176.49','R-OH012','OH0','443.31',NULL,0,'2014-01-08 18:24:58'),(14727,11759,'Y','18','021','EC','A','','','AC','0001646344','0001646344','LA00001077946','IL','1','migues','margo','','','','34','433190465','8808 OLD JEANERETTE RD',0,'JEANERETTE','LA','70544','5829','CY','22045','1957-02-01','F','M',NULL,'T','021','DEN','1438482','18575LA002000201','2014-02-01','2013-12-28 13:57:22','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:09:42'),(2629,2137,'N','01','021','EC','A',NULL,NULL,'','0000701651','0001122709','','IL','1','Schleyer','Kathryn','Ann','','','34','272909929','8229 CATALPA RIDGE DR',0,'BLACKLICK','OH','43004','8279','CY','39049','1986-12-10','F','',NULL,'N','021','DEN','529842','99734OH005000401','2014-01-01','2013-12-02 15:04:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:04'),(13766,10988,'Y','18','021','EC','A','','','AC','0000582215','0000582215','MS00000552166','IL','1','MCNULTY','PHILLIP','','','','34','427252717','3504 CHISOLM ROAD',0,'SUMMIT','MS','39666',NULL,'CY','28085','1960-08-01','M','U',':RET:2054-5','T','021','DEN','1945453','46300MS002000201','2014-01-01','2013-12-23 10:44:10','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:22'),(18924,15078,'Y','18','021','EC','A','','','AC','0000640953','0000640953','OH00001720517','IL','1','johnson','nicholas','james','','','34','298900375','580 JAMES AVE',0,'AKRON','OH','44312','3770','CY','39153','1986-01-10','M','U',':RET:2106-3','T','021','DEN','2931871','99734OH005000401','2014-03-01','2014-01-16 19:57:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-20 08:05:34'),(19239,15330,'Y','18','024','14','A','','','TE','0000695628','0000695628','','IL','1','Peters','Lisa','Michelle',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-10','F','',NULL,NULL,NULL,'','2565754','','2014-01-20','2014-01-20 16:02:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:37'),(20171,16097,'Y','18','021','EC','A','','','AC','0000604736','0000604736','OH00001796767','IL','1','LUDWIG','MICHAEL','S','','','34','277564927','5837 EMERSON AVE NW',0,'WARREN','OH','44483','1121','CY','39155','1959-05-24','M','U',':RET:2106-3','N','021','HLT','3074185','52664OH151001305','2014-03-01','2014-01-27 10:57:06','393.00',NULL,NULL,'539.93','146.93','R-OH013','OH0','539.93',NULL,0,'2014-01-27 21:01:15'),(20193,16113,'Y','18','021','EC','A','','','AC','0000569504','0000569504','MS00002127043','IL','1','Moran','Steven','','','','34','405110657','8895 Scenic Ridge Cove',0,'Lake Cormorant','MS','38641',NULL,'CY','28033','1976-03-18','M','U',':RET:2106-3','T','021','DEN','3235163','46300MS002000101','2014-03-01','2014-01-27 09:31:06','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-27 21:01:28'),(25016,19837,'N','19','021','EC','A',NULL,NULL,'','0001199554','0001135225','','IL','1','Bignall','Roan','','','','34','278151907','601 SUNCREST DR',0,'SPRINGFIELD','OH','45503','5308','CY','39023','2009-04-08','M','',NULL,'N','021','DEN','2940508','99734OH005000301','2014-04-01','2014-02-20 14:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:00:55'),(7399,5856,'Y','18','021','EC','A','','','AC','0000538228','0000538228','OH00000983021','IL','1','PRESSLEY','RICKEY','LAMAR','','Sr','34','274569797','702 SEARLES RD',0,'TOLEDO','OH','43607','2847','CY','39095','1956-02-08','M','M',':RET:2054-5','N','021','DEN','685662','99734OH005000301','2014-01-01','2013-11-23 16:04:11','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-26 02:16:22'),(14831,11845,'Y','18','021','EC','A','','','AC','0000043231','0000043231','OH00000640770','IL','1','rude','robin','','','','34','268841755','2628 OLD CLIFTON RD',0,'SPRINGFIELD','OH','45502','9452','CY','39023','1970-12-03','F','M',':RET:2106-3','N','021','HLT','1722032','92036OH004000501','2014-01-01','2013-12-23 20:41:26','0.00',NULL,NULL,'259.37','259.37','R-OH003','OH0','259.37',NULL,1,'2013-12-29 11:14:35'),(14528,11592,'Y','18','021','EC','A','','','AC','0000549419','0000549419','TX00000589249','IL','1','mendez','florina','','','','34','548456539','828 olivas v aoy',0,'el paso','TX','79901',NULL,'CY','48141','1961-05-01','F','M',':RET:2106-3','N','021','DEN','2436156','33348TX002000201','2014-02-01','2013-12-27 18:08:49','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-28 03:34:30'),(6237,4944,'Y','18','021','EC','A','','','AC','0001153720','0001153720','TX00001241227','IL','1','VALERIO','JESSE','','','','34','464821939','3320 1ST PL',0,'LUBBOCK','TX','79415','2510','CY','48303','1951-08-22','M','M',NULL,'N','021','DEN','780056','33348TX002000201','2014-01-01','2013-11-19 12:52:35','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2013-12-26 00:31:36'),(5313,4213,'Y','18','024','14','A','','','TE','0000449857','0000449857','','IL','1','MYERS','BRENDA','SUE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-30','F','',NULL,NULL,NULL,'','2219109','','2013-12-18','2013-12-18 19:38:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:06:38'),(9658,7651,'N','01','021','EC','A',NULL,NULL,'','0000790870','0000615511','','IL','1','Logan','Gijsbartha','','','','34','308902423','6699 SOUTHERN VISTA DR',0,'ENON','OH','45323','1640','CY','39023','1962-08-16','F','',':RET:2106-3','N','021','HLT','1476234','92036OH005000501','2014-01-01','2013-12-20 23:29:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.34',NULL,0,'2013-12-26 04:38:55'),(4341,3448,'Y','18','024','14','A','','','TE','0000268872','0000268872','','IL','1','Caprilla','Frank',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-07-12','M','',NULL,NULL,NULL,'','463944','','2013-12-17','2013-12-17 11:36:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:53:17'),(25623,20329,'Y','18','021','EC','A','','','AC','0000932721','0000932721','TX00003211346','IL','1','HERNANDEZ','TARA','V','','','34','631266003','844 FRANK PL',0,'CANUTILLO','TX','79835',NULL,'CY','48141','1991-06-17','F','U',NULL,'N','021','DEN','3152942','33348TX002000201','2014-04-01','2014-02-22 16:05:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-26 08:30:18'),(26866,21293,'Y','18','021','EC','A','','','AC','0001168064','0001168064','TX00002859326','IL','1','Torres','Joe','','','','34','631126717','14236 RUDY VALDEZ DR',0,'EL PASO','TX','79938','1208','CY','48141','1990-02-02','M','U',':RET:2106-3','N','021','DEN','3487380','33348TX002000101','2014-04-01','2014-03-01 15:51:12','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-03-01 21:01:00'),(27181,21521,'Y','18','024','14','A','','','TE','0000353269','0000353269','','IL','1','wise','colleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-29','F','',NULL,NULL,NULL,'','3802219','','2014-03-03','2014-03-03 13:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-03 21:31:11'),(28192,22309,'Y','18','021','EC','A','','','AC','0001059944','0001059944','TX00003111586','IL','1','Nguyen','Kevin','','','','34','564579672','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1969-08-06','M','M',':RET:2047-9','N','021','DEN','3719113','33348TX002000201','2014-04-01','2014-03-05 19:08:19','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-03-06 21:30:04'),(23781,18924,'Y','18','024','14','A','','','TE','0000743192','0000743192','','IL','1','Wiggins','Tiffany',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-07','F','',NULL,NULL,NULL,'','3122229','','2014-02-14','2014-02-14 13:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-14 21:31:19'),(19009,15139,'Y','18','021','EC','A','','','AC','0001640013','0001640013','LA00002403430','IL','1','Leary','Arnold','F','','','34','437868233','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1953-07-11','M','M',':RET:2054-5','N','021','DEN','1433763','18575LA002000201','2014-03-01','2014-01-17 12:04:59','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-01-20 08:06:19'),(15726,12578,'Y','18','021','EC','A','','','AC','0000437983','0000437983','OH00002150837','IL','1','TAKACH','MARGARET','','','','34','291527548','109 S OHIO AVE',0,'COLUMBUS','OH','43205','1313','CY','39049','1952-04-07','F','U',NULL,'N','021','DEN','2003208','99734OH005000301','2014-02-01','2014-01-02 16:33:39','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:00:19'),(5628,4466,'N','19','021','EC','A',NULL,NULL,'','0000612960','0000223678','','IL','1','Holloway','Lillian','G','','','34','276086301','5091 ELNO AVE',0,'AKRON','OH','44319','4931','CY','39153','2003-01-30','F','',':RET:2106-3','N','021','DEN','223737','99734OH005000401','2014-01-01','2013-11-26 11:14:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:57'),(7778,6158,'N','01','021','EC','A',NULL,NULL,'','0000486735','0000488834','','IL','1','Moore','Deborah','','','','34','501600857','2809 N CEDAR BLUFF RD',0,'GARRISON','TX','75946','7342','CY','48347','1952-08-21','F','',':RET:2106-3','N','021','DEN','2033975','33348TX002000201','2014-01-01','2013-12-19 23:02:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:03:07'),(14327,11427,'Y','18','021','EC','A','','','AC','0000570565','0000570565','OH00001274740','IL','1','Elliott','Latricia','','','','34','298709485','826 S WITTENBERG AVE',0,'SPRINGFIELD','OH','45506','2108','CY','39023','1976-09-10','F','U',':RET:2054-5','N','021','HLT','1986269','92036OH002000501','2014-02-01','2013-12-26 12:23:54','0.00',NULL,NULL,'339.84','339.84','R-OH003','OH0','339.84',NULL,0,'2013-12-27 02:07:26'),(14551,11610,'Y','18','021','EC','A','','','AC','0000186119','0000186119','OH00000111857','IL','1','McCulley','Christopher','','','','34','293863089','14727 BENWOOD AVE',0,'CLEVELAND','OH','44128','1169','CY','39035','1987-10-02','M','U',':RET:2054-5','T','021','HLT','1800995','52664OH152000901','2014-02-01','2013-12-26 19:49:41','49.00',NULL,NULL,'216.94','167.94','R-OH011','OH0','216.94',NULL,0,'2013-12-28 03:35:02'),(24018,19101,'N','01','021','EC','A',NULL,NULL,'','0000946164','0000675500','','IL','1','Weeks','Ursula','H','','','34','222344405','1768 E 25TH ST',0,'CLEVELAND','OH','44114','4418','CY','39035','1950-07-25','F','',':RET:2106-3','N','021','DEN','3476108','99734OH005000401','2014-03-01','2014-02-15 14:51:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:00:45'),(28368,22447,'Y','18','021','EC','A','','','AC','0000171485','0000171485','TX00002673513','31','1','Lundgren','Kim','','','','34','321441432','PO box 2223',0,'Wimberley','TX','78676',NULL,'CY','48209','1950-08-21','F','U',':RET:2106-3','N','021','DEN','3555305','33348TX002000201','2014-04-01','2014-03-07 17:28:18','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-07 21:30:33'),(847,701,'Y','18','024','14','A','','','TE','0000489329','0000489329','','IL','1','Emerson','Lydell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-23','M','',NULL,NULL,NULL,'','528919','','2013-12-16','2013-12-16 09:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:06:47'),(21803,17411,'N','01','021','EC','A',NULL,NULL,'','0001174433','0000646036','','IL','1','ulrick','beverly','','','','34','278763644','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1972-03-12','F','',':RET:2106-3','N','021','HLT','2942726','92036OH004001501','2014-03-01','2014-02-05 19:34:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','230.41',NULL,0,'2014-02-06 21:00:50'),(17803,14221,'Y','18','021','EC','A','','','AC','0001130247','0001130247','OH00001758610','IL','1','Burt','Kris','Evans','','','34','279483858','1450 High St.',0,'Norwalk','OH','44857',NULL,'CY','39077','1953-10-24','M','M',':RET:2106-3','N','021','HLT','2077676','92036OH002002701','2014-02-01','2014-01-13 18:11:13','704.00',NULL,NULL,'1222.30','518.30','R-OH006','OH0','611.15',NULL,0,'2014-01-14 01:33:55'),(4942,3922,'Y','18','021','EC','A','','','AC','0000137543','0000137543','OH00000726193','IL','1','Reyes','Miguel','','','','34','636205318','3509 HILDA AVE',0,'CINCINNATI','OH','45211','4805','CY','39061','1957-06-13','M','M',NULL,'T','021','DEN','628200','99734OH005000401','2014-01-01','2013-12-07 16:32:52','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:42'),(16264,13022,'Y','18','021','EC','A','','','AC','0000680857','0000680857','OH00001490538','IL','1','Tulodzieski','Megan','','','','34','292849663','274 FRANKFORT SQ',0,'COLUMBUS','OH','43206','1059','CY','39049','1986-09-05','F','R',':RET:2106-3','N','021','DEN','1566473','99734OH005000401','2014-02-01','2014-01-06 12:37:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-07 04:00:05'),(15569,12459,'Y','18','021','EC','A','','','AC','0000899577','0000899577','OH00001804057','IL','1','Ventura','Sarah Jo','','','','34','282967024','4079   Greenridge Dr.',0,'Uniontown','OH','44685',NULL,'CY','39153','1993-06-04','F','U',':RET:2106-3','N','021','HLT','2603334','52664OH151001301','2014-02-01','2013-12-31 13:04:36','15.49',NULL,NULL,'141.61','126.12','R-OH012','OH0','141.61',NULL,1,'2014-01-02 04:31:50'),(9090,7214,'Y','18','021','EC','A','','','AC','0000560540','0000560540','OH00001267630','IL','1','Leyh','Brian','','','','34','270884121','207 WHITTINGTON DR',0,'CENTERVILLE','OH','45459','2131','CY','39113','1973-01-30','M','U',':RET:2106-3','N','021','DEN','1378045','99734OH005000301','2014-01-01','2013-12-18 10:29:54','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:07:03'),(9190,7288,'Y','18','021','EC','A','','','AC','0000459139','0000459139','OH00000235619','IL','1','Webb','Tim','Alan','','','34','294644728','219.5 WASHINGTON ST',0,'FINDLAY','OH','45840','3430','CY','39063','1970-10-27','M','U',':RET:2106-3','N','021','HLT','2575871','92036OH005001506','2014-01-01','2013-12-18 17:50:17','259.00',NULL,NULL,'298.65','39.65','R-OH002','OH0','298.65',NULL,0,'2013-12-26 04:09:21'),(14320,11420,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00001261635','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','2014333','52664OH151001306','2014-02-01','2013-12-26 11:52:25','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2013-12-27 02:07:13'),(22971,18316,'Y','18','021','EC','A','','','AC','0000776470','0000776470','OH00001668693','IL','1','Kopac','James','','','','34','294764557','6702 FOREST AVE',0,'SEVEN HILLS','OH','44129','2734','CY','39035','1965-03-25','M','U',':RET:2106-3','T','021','DEN','3077482','99734OH005000401','2014-03-01','2014-02-12 17:22:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-12 21:00:16'),(25534,20255,'N','01','021','EC','A',NULL,NULL,'','0001082303','0000172627','','IL','1','Hernandez','ismael','','','III','34','450832070','1007 SHOFNER ST',0,'KILLEEN','TX','76541','7848','CY','48027','1983-02-27','M','',NULL,'N','021','DEN','2875617','33348TX002000201','2014-04-01','2014-02-23 00:49:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 08:00:06'),(25575,20288,'N','19','021','EC','A',NULL,NULL,'','0000123023','0001179673','','IL','1','Hirn','Carter','Daniel','','','34','275112484','410 E 3RD ST',0,'DELPHOS','OH','45833','1771','CY','39003','2005-01-19','M','',':RET:2106-3','N','021','HLT','3347484','92036OH001001501','2014-04-01','2014-02-23 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','168.58',NULL,0,'2014-02-26 08:00:33'),(25729,20408,'Y','18','024','14','A','','','TE','0002243480','0002243480','','IL','1','Polk','Danielle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-03-26','F','',NULL,NULL,NULL,'','3038786','','2014-03-31','2014-02-24 13:40:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-26 09:30:34'),(27856,22032,'Y','18','021','EC','A','','','AC','0000195171','0000195171','TX00003398346','IL','1','Bidwell','Kathie','','','','34','464920365','5570 Wegner Rd',0,'NEW BRAUNFELS','TX','78132',NULL,'CY','48091','1952-04-18','F','M',':RET:2106-3','N','021','DEN','4041935','33348TX002000101','2014-04-01','2014-03-05 17:08:16','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-03-05 21:32:16'),(827,684,'Y','18','021','EC','A','','','AC','0000893135','0000893135','OH00001018492','IL','1','Rodriguez','Andrea','Marie','','','34','270985118','1200 MORNINGVIEW DR',0,'TALLMADGE','OH','44278','1179','CY','39153','1994-09-09','F','U',':RET:2106-3','N','021','HLT','2118012','52664OH151001306','2014-01-01','2013-12-16 15:11:54','84.00',NULL,NULL,'141.61','57.61','R-OH012','OH0','141.61',NULL,0,'2013-12-25 18:06:14'),(2981,2399,'N','01','021','EC','A',NULL,NULL,'','0000705120','0001097757','','IL','1','Isenbarger','Stephanie','','','','34','273766352','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1979-10-11','F','',':RET:2106-3','N','021','DEN','1211363','99734OH005000301','2014-01-01','2013-12-05 19:26:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:12'),(6919,5492,'Y','18','021','EC','A','','','AC','0001255033','0001255033','OH00000712905','IL','1','Austin','Marletta','','','','34','283645677','1231 Heard AV',0,'Springfield','OH','45506',NULL,'CY','39023','1957-07-17','F','U',':RET:2054-5','N','021','DEN','2554301','99734OH005000401','2014-01-01','2013-12-24 18:36:23','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:46:09'),(6804,5397,'Y','18','021','EC','A','','','AC','0000620224','0000620224','TX00000502927','IL','1','Acosta','Maria','','','','34','463252162','1518 18TH ST',0,'CORPUS CHRISTI','TX','78404','3412','CY','48355','1960-08-08','F','M',':RET:2106-3','N','021','DEN','1216447','33348TX002000101','2014-01-01','2013-11-13 18:26:43','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2013-12-26 01:30:05'),(22173,17696,'Y','18','024','14','A','','','TE','0000018993','0000018993','','IL','1','Pilgrim','Monnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-17','F','',NULL,NULL,NULL,'','3089688','','2014-02-28','2014-02-07 19:00:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-08 19:30:06'),(19047,15170,'Y','18','021','EC','A','','','AC','0000961888','0000961888','OH00002051196','IL','1','Danchisen','Jacquelyn','','','','34','291604738','2326 ROBINWOOD AVE',0,'TOLEDO','OH','43620','1022','CY','39095','1962-11-02','F','U',':RET:2106-3','N','021','HLT','2895372','92036OH006002601','2014-03-01','2014-01-17 17:59:08','0.00',NULL,NULL,'288.42','288.42','R-OH001','OH0','288.42',NULL,0,'2014-01-20 08:06:41'),(16919,13539,'Y','18','021','EC','A','','','AC','0000483498','0000483498','OH00002393917','IL','1','Morman','Gloria','','','','34','274489945','2323 E 101ST ST',0,'CLEVELAND','OH','44106','3509','CY','39035','1949-06-19','F','M',':RET:2054-5','N','021','DEN','2060028','99734OH005000401','2014-02-01','2014-01-09 15:51:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:19:42'),(7979,6317,'Y','18','021','EC','A','','','AC','0000790868','0000790868','OH00000611875','IL','1','Nowak','Richard','','','','34','300448827','13658 Chillicothe Rd.',0,'Novelty','OH','44072',NULL,'CY','39055','1950-12-28','M','U',':RET:2106-3','N','021','HLT','1406376','52664OH151001305','2014-01-01','2013-12-20 13:39:55','492.00',NULL,NULL,'742.48','250.48','R-OH011','OH0','742.48',NULL,0,'2013-12-26 03:07:55'),(15759,12609,'Y','18','021','EC','A','','','AC','0000945516','0000945516','TX00001809319','IL','1','Pando','Empress','','','','34','454757238','606 N Ave B',0,'Kermit','TX','79745',NULL,'CY','48495','1985-10-03','F','U',':RET:2106-3','N','021','DEN','2231229','33348TX002000201','2014-02-01','2014-01-02 00:30:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:24'),(14192,11317,'Y','18','021','EC','A','','','AC','0000748031','0000748031','TX00001008614','IL','1','john','sheldon','','','','34','452755519','2210 RUFFIAN LN',0,'STAFFORD','TX','77477','6365','CY','48157','1982-07-22','M','U',':RET:2054-5','N','021','DEN','2520826','33348TX002000201','2014-02-01','2013-12-26 12:51:19','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-27 02:04:01'),(14916,11917,'Y','18','021','EC','A','','','AC','0000950683','0000950683','OH00001673049','IL','1','HAHNER','SOMSRI','','','','34','274685918','15824 RADEMAKER BLVD',0,'BROOKPARK','OH','44142',NULL,'CY','39035','1954-12-04','F','M',':RET:2028-9','N','021','DEN','2426674','99734OH005000401','2014-02-01','2013-12-28 22:14:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-30 00:01:32'),(27436,21713,'Y','18','024','14','A','','','TE','0001469184','0001469184','','IL','1','MENENDEZ','LISSETTE','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-03-04','F','',NULL,NULL,NULL,'','3219028','','2014-03-19','2014-03-04 13:57:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-04 21:01:49'),(22860,18236,'N','01','021','EC','A',NULL,NULL,'','0000708982','0001128052','','IL','1','Swisher','Michael','','','','34','272643015','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1964-04-08','M','',':RET:2106-3','N','021','HLT','3585946','92036OH003002705','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','347.41',NULL,0,'2014-02-11 21:02:24'),(7597,6011,'Y','18','021','EC','A','','','AC','0000406095','0000406095','OH00001097958','IL','1','Groth','Jason','','','','34','507820186','1200 BAY LN',0,'BEAVERCREEK','OH','45430','1003','CY','39057','1972-04-03','M','U',':RET:2106-3','N','021','DEN','1155467','99734OH005000401','2014-01-01','2013-11-17 11:22:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:45:16'),(21974,17548,'Y','18','021','EC','A','','','AC','0000737901','0000737901','OH00002381069','IL','1','Jones','Shirley','','','','34','270542443','217 PARK ST',0,'WILLARD','OH','44890','1318','CY','39077','1951-09-28','F','M',':RET:2106-3','N','021','HLT','2931169','92036OH003002701','2014-03-01','2014-02-06 18:33:22','207.00',NULL,NULL,'585.04','378.04','R-OH006','OH0','585.04',NULL,0,'2014-02-07 19:00:32'),(15516,12414,'Y','18','021','EC','A','','','AC','0002039982','0002039982','LA00001026547','IL','1','Jones','Nelson','','','','34','434925695','513 FONTELIEU DR',0,'NEW IBERIA','LA','70560','5031','CY','22045','1950-09-15','M','M',NULL,'N','021','DEN','1476658','18575LA002000201','2014-02-01','2013-12-30 19:08:34','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:30:12'),(3262,2629,'Y','18','021','EC','A','','','AC','0000340829','0000340829','LA00000257963','IL','1','Williams','Heather','','','','34','436797771','26375 AVOYELLES AVE',0,'DENHAM SPRINGS','LA','70726','6958','CY','22063','1987-07-25','F','U',':RET:2106-3','N','021','DEN','39629','18575LA002000201','2014-01-01','2013-11-28 05:08:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:46:55'),(3981,3179,'Y','18','021','EC','A','','','AC','0000643212','0000643212','OH00001262217','IL','1','ludwig','scott','','','','34','284748054','1206 S BLANCHARD ST',0,'FINDLAY','OH','45840','6121','CY','39063','1972-12-12','M','M',':RET:2106-3','N','021','HLT','691255','92036OH003001506','2014-01-01','2013-12-13 14:15:20','500.00',NULL,NULL,'731.40','231.40','R-OH002','OH0','299.25',NULL,0,'2013-12-25 21:38:49'),(4034,3221,'Y','18','024','14','A','','','TE','0001253517','0001253517','','IL','1','Bushman','Melanie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-12-24','F','',NULL,NULL,NULL,'','696082','','2013-12-17','2013-12-17 10:01:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:58'),(27078,21438,'Y','18','021','EC','A','','','AC','0000951866','0000951866','OH00002883482','IL','1','Frey','Hettie','','','','34','279521730','12064 MILLY DR',0,'DOYLESTOWN','OH','44230','9719','CY','39169','1952-02-12','F','M',':RET:2106-3','N','021','HLT','3705915','52664OH152000901','2014-04-01','2014-03-03 15:24:01','469.28',NULL,NULL,'469.28','0.00','R-OH014','OH0','469.28',NULL,0,'2014-03-03 21:30:09'),(27283,21604,'Y','18','021','EC','A','','','AC','0000986216','0000986216','TX00003529345','IL','1','WHITE','SHERLAY','','','','34','420927863','1602 WILBURN DR',0,'BAYTOWN','TX','77520',NULL,'CY','48201','1960-01-07','F','M',':RET:2054-5','N','021','DEN','2662453','33348TX002000201','2014-04-01','2014-03-03 23:14:09','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:23'),(28457,22517,'Y','18','021','EC','A','','','AC','0001977804','0001977804','LA00003667443','IL','1','HENDERSON','CHANTEL','','','','34','437777247','1682 N LOBDELL BLVD',0,'BATON ROUGE','LA','70806','1760','CY','22033','1989-12-05','F','U',':RET:2054-5','N','021','DEN','2876067','18575LA002000201','2014-04-01','2014-03-07 14:00:34','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-07 21:31:23'),(1475,1229,'N','01','021','EC','A',NULL,NULL,'','0000926274','0000336428','','IL','1','Schroer','Karen','','','','34','275440382','1580 SIEGRIST JUTTE RD',0,'FORT RECOVERY','OH','45846','9514','CY','39107','1952-06-03','F','',':RET:2106-3','N','021','DEN','2000078','99734OH005000401','2014-01-01','2013-12-24 09:53:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:40'),(21890,17479,'Y','18','021','EC','A','','','AC','0000890765','0000890765','MS00001823023','IL','1','Miller','Kimberly','','','','34','427516506','524 COUNTRY CLUB DR',0,'PICAYUNE','MS','39466','2316','CY','28109','1977-09-09','F','U',NULL,'T','021','DEN','3343053','46300MS002000201','2014-03-01','2014-02-06 17:24:52','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-06 21:01:37'),(7815,6192,'Y','18','021','EC','A','','','AC','0001192671','0001192671','TX00000928826','IL','1','patel','alpesh','','','','34','644687641','5121 Timber Creek Dr',0,'Tyler','TX','75703',NULL,'CY','48423','1969-03-21','M','M',':RET:2029-7','N','021','DEN','1760231','33348TX002000201','2014-01-01','2013-12-20 18:02:53','0.00',NULL,NULL,'67.44','67.44','R-TX022','TX0','14.61',NULL,0,'2013-12-26 03:04:04'),(2588,2104,'Y','18','021','EC','A','','','AC','0000048167','0000048167','OH00000106574','31','1','Ward','Teresa','','','','34','283746050','PO Box 499',0,'Peebles','OH','45660',NULL,'CY','39001','1965-07-08','F','U',':RET:2106-3','N','021','HLT','609406','92036OH003000606','2014-01-01','2013-12-09 18:04:52','337.00',NULL,NULL,'366.54','29.54','R-OH005','OH0','366.54',NULL,0,'2013-12-25 19:38:13'),(19428,15487,'N','01','021','EC','A',NULL,NULL,'','0000646023','0000774011','','IL','1','Mercer','Tiffany','Lyn','','','34','110662547','1809 N BLANCHARD ST',0,'FINDLAY','OH','45840','4506','CY','39063','1981-04-21','F','',':RET:2106-3','T','021','HLT','2445484','92036OH003001506','2014-03-01','2014-01-21 10:31:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','312.68',NULL,1,'2014-01-22 03:23:06'),(18393,14679,'N','19','021','EC','A',NULL,NULL,'','0000246475','0000299277','','IL','1','Stone','Rachel','','','','34','291153414','237 OPAL BLVD',0,'STEUBENVILLE','OH','43952','2330','CY','39081','2010-01-21','F','',':RET:2106-3','N','021','DEN','2849573','99734OH005000301','2014-02-01','2014-01-15 17:09:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:40'),(6543,5187,'Y','18','021','EC','A','','','AC','0000128151','0000128151','TX00000817751','IL','1','Gomez','Senia','','','','34','645106521','2123 N MUSKINGUM AVE',0,'ODESSA','TX','79761','1247','CY','48135','1980-01-13','F','M',NULL,'N','021','DEN','1081147','33348TX002000201','2014-01-01','2013-12-11 10:43:58','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-26 00:51:58'),(17914,14309,'Y','18','021','EC','A','','','AC','0000681096','0000681096','TX00001596320','IL','1','Liao','Vincent','','','','34','644120848','6438 OLD HARBOR LN',0,'AUSTIN','TX','78739','1405','CY','48453','1988-01-13','M','U',NULL,'N','021','DEN','1603436','33348TX002000201','2014-02-01','2014-01-13 22:16:17','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:28'),(16676,13346,'Y','18','024','14','A','','','TE','0000230451','0000230451','','IL','1','Meley','Vanessa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-22','F','',NULL,NULL,NULL,'','1430949','','2014-01-07','2014-01-07 13:51:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:24:30'),(4186,3330,'Y','18','021','EC','A','','','AC','0001036122','0001036122','OH00000718938','IL','1','Davis','DWana','','','','34','280666597','10012 BURTON AVE',0,'BRATENAHL','OH','44108','1003','CY','39035','1960-10-02','F','U',':RET:2054-5','N','021','HLT','1915340','52664OH151001306','2014-01-01','2013-12-17 11:46:57','357.00',NULL,NULL,'513.10','156.10','R-OH011','OH0','513.10',NULL,0,'2013-12-25 21:49:31'),(15123,12086,'Y','18','021','EC','A','','','AC','0001221949','0001221949','OH00001934652','IL','1','Jones','Burldon','','','','34','299863607','6906 BUCKINGHAM PL',0,'CINCINNATI','OH','45227','2630','CY','39061','1973-07-27','M','U',':RET:2054-5','N','021','DEN','1667894','99734OH005000301','2014-02-01','2013-12-30 16:30:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:16'),(24220,19235,'Y','18','021','EC','A','','','AC','0000277951','0000277951','TX00001815649','IL','1','Trevino','Jessica','','','','34','466795273','13407 SPRUCE HOLLOW CT',0,'HOUSTON','TX','77059','3237','CY','48201','1977-03-02','F','M',':RET:2106-3','N','021','DEN','2692261','33348TX002000201','2014-04-01','2014-02-16 01:05:08','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-16 19:00:28'),(25753,20426,'Y','18','021','EC','A','','','AC','0000013832','0000013832','OH00002831856','IL','1','OPDYCKE','EDWARD','L','','','34','291526734','19891 COUNTY ROAD G',0,'STRYKER','OH','43557','9742','CY','39171','1951-04-24','M','M',NULL,'N','021','DEN','3030663','99734OH005000401','2014-04-01','2014-02-24 16:41:33','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-26 09:30:46'),(26784,21226,'N','01','021','EC','A',NULL,NULL,'','0000996574','0000333281','','IL','1','Polhemus','Rita','','','','34','457332131','2118 LANDCIRCLE CT',0,'SUGAR LAND','TX','77478','6018','CY','48157','1961-10-03','F','',':RET:2106-3','N','021','DEN','3042158','33348TX002000201','2014-04-01','2014-03-01 11:18:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-01 21:00:14'),(20531,16405,'Y','18','021','EC','A','','','AC','0000903961','0000903961','MS00001850491','IL','1','BOYD','SALLIE','MAE','','','34','587308894','108 COUNTRY OAKS CV',0,'RIPLEY','MS','38663','8234','CY','28139','1950-08-08','F','U',NULL,'N','021','DEN','2754587','46300MS002000201','2014-03-01','2014-01-29 14:05:32','0.00',NULL,NULL,'15.85','15.85','R-MS002','MS0','15.85',NULL,0,'2014-01-29 21:01:30'),(6325,5015,'Y','18','024','14','A','','','TE','0000180980','0000180980','','IL','1','firm','edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-17','M','',NULL,NULL,NULL,'','570278','','2013-12-11','2013-12-11 11:22:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:46:28'),(22238,17751,'Y','18','021','EC','A','','','AC','0000975273','0000975273','OH00002470635','IL','1','SHULKO','GAIL','','','','34','290527097','10345 WEST PIKE',0,'HOPEWELL','OH','43746','9771','CY','39119','1952-07-25','F','M',':RET:2106-3','N','021','DEN','3740266','99734OH005000301','2014-03-01','2014-02-09 12:17:36','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-02-09 19:00:37'),(3617,2896,'Y','18','021','EC','A','','','AC','0000763519','0000763519','OH00000341100','IL','1','Green','Melanie','','','','34','299869327','1529 BUNKER DR',0,'LIMA','OH','45805','3802','CY','39003','1979-02-20','F','U',':RET:2106-3','N','021','HLT','2565778','92036OH005001505','2014-01-01','2013-12-22 16:05:12','150.00',NULL,NULL,'267.18','117.18','R-OH002','OH0','267.18',NULL,0,'2013-12-25 21:23:36'),(3811,3053,'N','19','021','EC','A',NULL,NULL,'','0000912935','0000495433','','IL','1','Williams','Kingston',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2010-12-09','M','',':RET:2054-5','N','021','DEN','783233','99734OH005000301','2014-01-01','2013-12-13 14:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:44'),(4928,3909,'Y','18','021','EC','A','','','AC','0000242683','0000242683','OH00001190347','IL','1','HOLDERMAN','CAREN','','','','34','290723531','4737 EDINBURGH LN',0,'COLUMBUS','OH','43229','5845','CY','39049','1960-01-04','F','U',':RET:2106-3','N','021','DEN','719902','99734OH005000401','2014-01-01','2013-12-06 19:23:33','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:45:20'),(7585,6000,'Y','18','021','EC','A','','','AC','0001040258','0001040258','TX00000607586','IL','1','Russell','Robert','','','','34','456772618','11909 B Charing Cross RD',0,'Austin','TX','78759',NULL,'CY','48453','1986-05-09','M','U',':RET:2106-3','T','021','DEN','1099837','33348TX002000101','2014-01-01','2013-12-15 16:15:07','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 02:34:02'),(8107,6413,'Y','18','021','EC','A','','','AC','0001060900','0001060900','OH00000517908','IL','1','Mason','Mary','','','','34','291465902','218 W 4TH ST',0,'VAN WERT','OH','45891','1124','CY','39161','1950-07-04','F','M',':RET:2106-3','N','021','HLT','1410327','92036OH006001501','2014-01-01','2013-12-20 16:18:30','511.47',NULL,NULL,'515.24','3.77','R-OH002','OH0','515.24',NULL,0,'2013-12-26 03:11:00'),(9623,7621,'Y','18','021','EC','A','','','AC','0000162265','0000162265','OH00001003644','IL','1','NELSON','NORA','','','','34','276543679','715 JOHNSON ST',0,'MAUMEE','OH','43537','3529','CY','39095','1952-06-04','F','U',NULL,'N','021','HLT','1718681','92036OH005002605','2014-01-01','2013-12-21 18:06:56','430.00',NULL,NULL,'547.95','117.95','R-OH001','OH0','547.95',NULL,0,'2013-12-26 04:37:58'),(15125,12088,'Y','18','021','EC','A','','','AC','0000894628','0000894628','OH00001175196','IL','1','PIDDUBETSKYY','CATHY','','','','34','273745421','50 APPLEWOOD DR',0,'FAIRFIELD','OH','45014','5295','CY','39017','1963-08-21','F','U',NULL,'N','021','DEN','2336395','99734OH005000301','2014-02-01','2013-12-30 17:17:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:20'),(25774,20440,'N','19','021','EC','A',NULL,NULL,'','0001160463','0000822105','','IL','1','Karp','Steven','E','','','34','270084445','17306 Fairway Drive',0,'Lagrange','OH','44050',NULL,'CY','39093','2002-09-15','M','',':RET:2106-3','N','021','DEN','3063575','99734OH005000301','2014-04-01','2014-02-24 16:36:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:57'),(27218,21551,'Y','18','021','EC','A','','','AC','0000810077','0000810077','MS00002418505','IL','1','WOODS','MONTREAL','','','','34','426396596','4049 NW ST.',0,'JACKSON','MS','39206',NULL,'CY','28049','1979-06-18','M','U',':RET:2054-5','T','021','DEN','3507598','46300MS002000201','2014-04-01','2014-03-03 11:45:35','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:33'),(576,471,'Y','18','021','EC','A','','','AC','0000355001','0000355001','OH00000683137','IL','1','Sketch','Anne','','','','34','290460421','112 Danube Drive',0,'Fairfield','OH','45014',NULL,'CY','39017','1950-06-05','F','U',NULL,'N','021','HLT','555687','92036OH005001206','2014-01-01','2013-12-04 13:07:56','510.00',NULL,NULL,'633.70','123.70','R-OH004','OH0','633.70',NULL,0,'2013-12-25 17:50:43'),(6836,5419,'Y','18','024','14','A','','','TE','0001092083','0001092083','','IL','1','Merkt','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-25','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-01-01','2013-11-14 13:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:30:56'),(1377,1142,'Y','18','021','EC','A','','','AC','0001183189','0001183189','LA00000420149','IL','1','Davidson','Kim','','','','34','435130910','210 4TH ST',0,'SLIDELL','LA','70460','4958','CY','22103','1958-06-26','M','U',':RET:2106-3','N','021','DEN','2475461','18575LA002000201','2014-01-01','2013-12-24 07:29:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:45:59'),(4211,3350,'Y','18','024','14','A','','','TE','0000604128','0000604128','','IL','1','Pittard','Theresa','Louise',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-02','F','',NULL,NULL,NULL,'','299358','','2013-12-17','2013-12-17 07:59:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:50:11'),(18056,14426,'Y','18','021','EC','A','','','AC','0000701717','0000701717','OH00002110218','IL','1','Hill','Andy','','','','34','497584731','5311 Sandra Dr',0,'Toledo','OH','43613',NULL,'CY','39095','1951-11-06','M','M',NULL,'N','021','HLT','2596036','92036OH001002601','2014-02-01','2014-01-14 15:24:09','811.00',NULL,NULL,'1288.01','477.01','R-OH001','OH0','675.75',NULL,0,'2014-01-15 02:07:19'),(1656,1383,'Y','18','021','EC','A','','','AC','0000524059','0000524059','TX00000750727','31','1','sardina','floriberto','','','','34','457998173','p. o. 322',0,'corsicana','TX','75151',NULL,'CY','48349','1957-08-05','M','U',':RET:2106-3','N','021','DEN','1599479','33348TX002000201','2014-01-01','2013-12-24 16:41:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:29'),(13441,10720,'N','19','021','EC','A',NULL,NULL,'','0000279552','0000661347','','S1','1','STROUD','ANTHONY','JAMES','','','34','273116427','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','2004-10-13','M','',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:16'),(7162,5681,'Y','18','021','EC','A','','','AC','0000031944','0000031944','OH00000919634','IL','1','Hunt','Dolores','C','','','34','286581769','1931 GEFFS AVE',0,'FINDLAY','OH','45840','3837','CY','39063','1955-09-21','F','U',':RET:2106-3','N','021','HLT','1504747','92036OH003001504','2014-01-01','2013-12-24 21:26:50','455.00',NULL,NULL,'585.61','130.61','R-OH002','OH0','585.61',NULL,0,'2013-12-26 01:52:30'),(9435,7485,'Y','18','021','EC','A','','','AC','0000662687','0000662687','OH00001001168','IL','1','Merusi','Robert','','','','34','302660717','1859 FAIRFAX AVE',0,'CINCINNATI','OH','45207','1811','CY','39061','1961-01-01','M','M',NULL,'N','021','HLT','1998662','92036OH006001201','2014-01-01','2013-12-20 18:59:27','265.00',NULL,NULL,'455.41','190.41','R-OH004','OH0','347.30',NULL,0,'2013-12-26 04:33:31'),(13254,10578,'Y','18','021','EC','A','','','AC','0000036924','0000036924','TX00001177660','31','1','Ramon','J','Robert','','','34','451795813','2700 S 23rd St',0,'McAllen','TX','78503',NULL,'CY','48215','1986-07-01','M','U',NULL,'N','021','DEN','1648418','33348TX002000201','2014-01-01','2013-12-23 11:21:21','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 12:56:29'),(23898,19010,'Y','18','021','EC','A','','','AC','0000879530','0000879530','OH00002391190','IL','1','Cherry','Amy','','','','34','307069952','3868 HILLVILLE RD',0,'COLUMBUS GROVE','OH','45830','9449','CY','39003','1987-08-26','F','U',':RET:2106-3','N','021','HLT','3677026','92036OH003001506','2014-03-01','2014-02-14 10:32:46','193.00',NULL,NULL,'235.35','42.35','R-OH002','OH0','235.35',NULL,0,'2014-02-14 21:32:22'),(28203,22319,'Y','18','024','14','A','','','TE','0000848367','0000848367','','IL','1','Moser','Natalie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-04-24','F','',NULL,NULL,NULL,'','2409236','','2014-03-31','2014-03-06 16:21:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-06 21:30:10'),(28508,22559,'N','01','021','EC','A',NULL,NULL,'','0001060977','0000292037','','IL','1','Britenriker','Ramona','A','','','34','295603512','528 MAIN ST',0,'WADSWORTH','OH','44281','1357','CY','39103','1961-12-14','F','',':RET:2106-3','N','021','HLT','4120839','52664OH151001304','2014-04-01','2014-03-07 12:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2014-03-07 21:31:52'),(20629,16484,'Y','18','021','EC','A','','','AC','0000965903','0000965903','TX00001918444','31','1','FERNANDEZ','FELIX','','','','34','430457942','PO BOX 1105',0,'GEORGE WEST','TX','78022',NULL,'CY','48297','1952-03-31','M','M',NULL,'T','021','DEN','3046627','33348TX002000201','2014-03-01','2014-01-29 19:58:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:27'),(6878,5455,'Y','18','021','EC','A','','','AC','0000024361','0000024361','LA00000336338','IL','1','jones','gerald','','','','34','433353817','1040 st charles ave',0,'new orleans','LA','70130',NULL,'CY','22071','1972-07-21','M','U',':RET:2054-5','N','021','DEN','1130406','18575LA002000201','2014-01-01','2013-11-03 17:10:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:32:11'),(6458,5118,'N','01','021','EC','A',NULL,NULL,'','0000998757','0000487964','','IL','1','RICHARDSON','DIANA','L','','','34','268524043','249 E FORD AVE',0,'BARBERTON','OH','44203','3232','CY','39153','1952-09-15','F','',':RET:2106-3','N','021','HLT','22418','52664OH151001501','2014-01-01','2013-12-11 09:06:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2013-12-26 00:49:50'),(17310,13844,'Y','18','021','EC','A','','','AC','0000621577','0000621577','TX00002422604','IL','1','guthrie','gail','','','','34','452511296','217 CR 4342',0,'Tenaha','TX','75974',NULL,'CY','48365','1964-05-09','F','M',':RET:2106-3','N','021','DEN','2084212','33348TX002000201','2014-02-01','2014-01-10 13:54:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:44'),(2438,1986,'Y','18','021','EC','A','','','AC','0001190031','0001190031','OH00000812358','IL','1','STARCHER','LINDA','J','','','34','272562346','1085 EMOREY CIR',0,'AKRON','OH','44312',NULL,'CY','39153','1953-11-25','F','M',':RET:2106-3','N','021','HLT','143226','52664OH151001305','2014-01-01','2013-12-09 14:16:11','453.00',NULL,NULL,'605.24','152.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 19:34:22'),(9153,7260,'Y','18','021','EC','A','','','AC','0000987385','0000987385','OH00001065188','IL','1','Morton','Divante','','','','34','282986831','1016 Cherry Street',0,'Fostoria','OH','44830',NULL,'CY','39147','1995-09-12','M','U',':RET:2054-5^:RET:2106-3','N','021','HLT','2167785','92036OH004002701','2014-01-01','2013-12-17 21:30:14','98.84',NULL,NULL,'99.57','0.73','R-OH006','OH0','99.57',NULL,0,'2013-12-26 04:08:30'),(7367,5835,'Y','18','021','EC','A','','','AC','0000019532','0000019532','LA00001269812','IL','1','Skef','Natalia','','','','34','661057200','2404 JENA ST',0,'NEW ORLEANS','LA','70115','5908','CY','22071','1978-03-03','F','M',':RET:2106-3','N','021','DEN','638049','18575LA002000201','2014-01-01','2013-11-23 17:09:30','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:15:33'),(3700,2962,'Y','18','021','EC','A','','','AC','0000240325','0000240325','OH00000571846','IL','1','Williams','Brian','','','','34','301583863','134 VERMONT AVE',0,'CINCINNATI','OH','45215','2046','CY','39061','1957-06-23','M','M',':RET:2106-3','T','021','DEN','608255','99734OH005000401','2014-01-01','2013-12-13 13:19:44','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:58'),(3625,2899,'N','01','021','EC','A',NULL,NULL,'','0001064709','0001227025','','IL','1','Riegler','John','','','','34','286667127','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','1971-11-17','M','',':RET:2106-3','N','021','HLT','1527827','52664OH151001501','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','354.39',NULL,0,'2013-12-25 21:23:45'),(27726,21926,'Y','18','021','EC','A','','','AC','0000419411','0000419411','TX00003141897','IL','1','Grant','Stephanie','','','','34','608322205','3800 Commerce St.',0,'Dallas','TX','75226',NULL,'CY','48113','1983-05-23','F','U',':RET:2106-3','N','021','DEN','3679010','33348TX002000201','2014-04-01','2014-03-05 15:03:42','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-05 21:31:01'),(29131,23062,'Y','18','021','EC','A','','','AC','0000923384','0000923384','OH00003095686','IL','1','SCHETTER','LINDA','','','','34','225947476','135 SMITH ST',0,'URBANA','OH','43078','1243','CY','39021','1956-10-22','F','U',':RET:2106-3','T','021','HLT','4327822','92036OH004000501','2014-04-01','2014-03-10 13:50:58','431.00',NULL,NULL,'535.68','104.68','R-OH003','OH0','535.68',NULL,0,'2014-03-10 21:02:37'),(825,682,'Y','18','024','14','A','','','TE','0000790849','0000790849','','IL','1','Lawrence','Zachary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-09','M','',NULL,NULL,NULL,'','229261','','2013-12-16','2013-12-16 14:59:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:06:11'),(6377,5057,'Y','18','021','EC','A','','','AC','0000335133','0000335133','OH00000162665','IL','1','REED','DENNIS','','','','34','271464372','2221 mifflin ave',0,'ashland','OH','44805',NULL,'CY','39005','1950-09-30','M','M',NULL,'N','021','DEN','546873','99734OH005000301','2014-01-01','2013-12-11 09:47:25','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:50'),(1158,955,'Y','18','021','EC','A','','','AC','0000178947','0000178947','LA00000548876','IL','1','Hebert','Kennon','J','','','34','433860040','2651 Cypress Island Hwy',0,'St Martinville','LA','70582',NULL,'CY','22099','1950-10-08','M','M',':RET:2106-3','N','021','DEN','316421','18575LA002000201','2014-01-01','2013-12-03 14:24:57','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:18:48'),(5164,4095,'Y','18','021','EC','A','','','AC','0000234042','0000234042','OH00001185609','IL','1','Martin','Jennifer','','','','34','592280204','6119 W. River Rd. S.',0,'Elyria','OH','44035',NULL,'CY','39093','1971-10-31','F','U',':RET:2106-3','N','021','DEN','2577055','99734OH005000401','2014-01-01','2013-12-19 10:48:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:08'),(1263,1042,'Y','18','021','EC','A','','','AC','0000725035','0000725035','TX00001191448','IL','1','Watts','Casey','Joe','','','34','452713749','810 E PRESTON ST',0,'PHARR','TX','78577','5012','CY','48215','1976-06-22','M','U',NULL,'N','021','DEN','139022','33348TX002000201','2014-01-01','2013-11-28 19:09:33','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:30:03'),(21581,17239,'Y','18','021','EC','A','','','AC','0000070343','0000070343','OH00002018362','IL','1','Ingarra','Nick','','','','34','288509110','739 E GLENWOOD AVE',0,'AKRON','OH','44310','3406','CY','39153','1954-12-01','M','U',NULL,'N','021','HLT','2708023','52664OH151001305','2014-03-01','2014-02-05 15:43:13','423.00',NULL,NULL,'580.49','157.49','R-OH012','OH0','580.49',NULL,0,'2014-02-05 21:30:25'),(21483,17166,'Y','18','021','EC','A','','','AC','0000706230','0000706230','OH00001876823','IL','1','Grove','Tobius','','','','34','299766479','13021 Concord Church Road',0,'Glouster','OH','45732',NULL,'CY','39009','1977-07-22','M','U',NULL,'T','021','DEN','2951365','99734OH005000301','2014-03-01','2014-02-04 15:21:56','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-02-04 21:01:44'),(8880,7041,'Y','18','021','EC','A','','','AC','0000567513','0000567513','TX00000615282','IL','1','Bowers','Connie','','','','34','449790657','4443 OCEAN DR',0,'CORPUS CHRISTI','TX','78412','2582','CY','48355','1970-08-11','F','M',':RET:2106-3','N','021','DEN','1904270','33348TX002000201','2014-01-01','2013-12-18 15:23:35','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-26 04:01:46'),(20180,16104,'Y','18','021','EC','A','','','AC','0000477486','0000477486','OH00002383677','31','1','hartung','sandra','','','','34','287669603','po.box 846',0,'geneva','OH','44041',NULL,'CY','39007','1956-11-15','F','M',NULL,'N','021','HLT','3256863','52664OH151001304','2014-03-01','2014-01-27 16:01:28','361.00',NULL,NULL,'612.95','251.95','R-OH011','OH0','612.95',NULL,0,'2014-01-27 21:01:20'),(16022,12826,'Y','18','021','EC','A','','','AC','0002159652','0002159652','LA00001580247','IL','1','Williams','CONNIE','A','','','34','438291192','55145 AUCOIN ST',0,'WHITE CASTLE','LA','70788','2702','CY','22047','1963-06-26','F','U',NULL,'N','021','DEN','2283532','18575LA002000201','2014-02-01','2014-01-03 10:01:57','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-04 02:02:12'),(19061,15183,'N','01','021','EC','A',NULL,NULL,'','0000564069','0000855921','','IL','1','BAZAN','GUADALUPE','FLORES','','','34','633708336','4625 GLOBE WILLOW DR',0,'EL PASO','TX','79922','2221','CY','48141','1952-12-12','F','',':RET:2106-3','N','021','DEN','2759370','33348TX002000201','2014-03-01','2014-01-18 13:26:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:44:15'),(27320,21632,'Y','18','021','EC','A','','','AC','0001115877','0001115877','TX00002800375','IL','1','garcia','jessie','','','','34','628016602','11731 LIPPITT AVE',0,'DALLAS','TX','75218','2029','CY','48113','1988-06-28','M','U',NULL,'N','021','DEN','2892651','33348TX002000201','2014-04-01','2014-03-04 16:06:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-04 21:00:45'),(22321,17822,'Y','18','021','EC','A','','','AC','0002244839','0002244839','LA00001825602','IL','1','Davis','Trumaine','','','','34','434634930','200 MERCHANTS BLVD',0,'LAFAYETTE','LA','70508','3986','CY','22055','1986-11-24','M','U',':RET:2054-5','N','021','DEN','3452836','18575LA002000201','2014-03-01','2014-01-29 12:25:13','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-10 11:00:53'),(5956,4717,'Y','18','021','EC','A','','','AC','0001054215','0001054215','OH00001191135','IL','1','Ichrist','James','','','','34','293842886','2636 LAMBERT DR',0,'TOLEDO','OH','43613','3319','CY','39095','1985-06-07','M','U',':RET:2106-3','N','021','HLT','1382059','92036OH006002601','2014-01-01','2013-12-23 22:39:31','0.00',NULL,NULL,'168.10','168.10','R-OH001','OH0','168.10',NULL,0,'2013-12-25 23:51:15'),(20399,16294,'Y','18','021','EC','A','','','AC','0000440746','0000440746','TX00001726916','IL','1','Putman','Mary','','','','34','263863419','3345 FM 639',0,'Frost','TX','76641',NULL,'CY','48349','1949-07-22','F','M',':RET:2106-3','N','021','DEN','2120656','33348TX002000201','2014-03-01','2014-01-29 14:38:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:19'),(18863,15025,'Y','18','021','EC','A','','','AC','0001868276','0001868276','LA00001506853','IL','1','Gray','NaQuin','','','','34','414714730','5205 CUMBERLAND COVE DR',0,'BATON ROUGE','LA','70817','2291','CY','22033','1987-06-13','M','U',':RET:2054-5','N','021','DEN','2212758','18575LA002000201','2014-03-01','2014-01-16 00:29:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:21'),(1660,1386,'N','01','021','EC','A',NULL,NULL,'','0000963307','0000817858','','IL','1','Lee-Nordin','Kristine','','','','34','474801374','5303 KITE TAIL DR',0,'AUSTIN','TX','78730','1423','CY','48453','1960-04-08','F','',':RET:2106-3','N','021','DEN','2584054','33348TX002000201','2014-01-01','2013-12-24 17:09:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:53:36'),(7443,5891,'Y','18','021','EC','A','','','AC','0000384379','0000384379','OH00000320386','IL','1','Lowell','Staci','','','','34','279906319','37990 TAMARAC BLVD',0,'WILLOUGHBY','OH','44094','3495','CY','39085','1973-10-09','F','R',NULL,'N','021','DEN','273534','99734OH005000301','2014-01-01','2013-12-14 21:15:30','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:30:29'),(22178,17699,'N','19','021','EC','A',NULL,NULL,'','0000376178','0000317371','','IL','1','Costello','Jiovanni','','','','34','278172267','51 SAN RAFAEL AVE',0,'TOLEDO','OH','43607','2413','CY','39095','2011-06-04','M','',':RET:2106-3','N','021','HLT','2856339','92036OH006002601','2014-03-01','2014-02-08 13:16:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20','CIC',0,'2014-02-08 19:30:09'),(21529,17200,'Y','18','021','EC','A','','','AC','0000068203','0000068203','TX00002061165','31','1','batts','randi','','','','34','627427859','p o box 952',0,'somerville','TX','77879',NULL,'CY','48051','1994-04-25','F','U',':RET:2054-5','N','021','DEN','3616761','33348TX002000101','2014-03-01','2014-02-04 23:03:31','0.00',NULL,NULL,'44.55','44.55','R-TX006','TX0','44.55',NULL,0,'2014-02-05 21:30:05'),(20406,16298,'Y','18','021','EC','A','','','AC','0000923831','0000923831','TX00002052750','31','1','anderson','barbara','','','','34','464984029','2900 centery park blvd',0,'austin','TX','78727',NULL,'CY','48491','1954-01-18','F','U',NULL,'N','021','DEN','3301355','33348TX002000201','2014-03-01','2014-01-29 16:12:43','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-29 21:00:22'),(17319,13852,'Y','18','021','EC','A','','','AC','0000812030','0000812030','TX00002375500','IL','1','Martin','Richard','','','','34','251639239','489 FM 2276',0,'KILGORE','TX','75662','1895','CY','48183','1985-03-20','M','U',':RET:2106-3','N','021','DEN','2166317','33348TX002000201','2014-02-01','2014-01-10 16:14:33','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-13 02:23:49'),(5945,4709,'Y','18','021','EC','A','','','AC','0000796964','0000796964','OH00001270728','IL','1','Schneider','Todd','','','','34','290740655','15618 HENGSTLER RD',0,'WAPAKONETA','OH','45895','9132','CY','39011','1963-03-30','M','U',NULL,'N','021','HLT','1568584','92036OH005001501','2014-01-01','2013-12-23 21:37:49','284.02',NULL,NULL,'393.06','109.04','R-OH002','OH0','393.06',NULL,0,'2013-12-25 23:50:58'),(15817,12662,'Y','18','021','EC','A','','','AC','0000521956','0000521956','OH00002074568','IL','1','CODER','REBECCA','','','','34','281529922','5232 MULBERRY RD SE',0,'NEWARK','OH','43056','9458','CY','39089','1950-03-31','F','U',NULL,'N','021','DEN','2385291','99734OH005000401','2014-02-01','2014-01-02 10:31:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:03:25'),(15634,12505,'Y','18','021','EC','A','','','AC','0001566445','0001566445','LA00001384643','IL','1','ROBIDEAUX','CARRIE','','','','34','439335634','2321 LORECO ST',0,'BOSSIER CITY','LA','71112','2224','CY','22015','1961-01-20','F','U',':RET:2106-3','N','021','DEN','2074090','18575LA002000101','2014-02-01','2013-12-31 14:39:09','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-02 04:33:34'),(15298,12232,'Y','18','021','EC','A','','','AC','0001515295','0001515295','LA00001757027','31','1','Major Batiste','Letha','','','','34','439352589','P O Box 472',0,'Geismar','LA','70734',NULL,'CY','22005','1965-09-18','F','U',NULL,'N','021','DEN','2108174','18575LA002000201','2014-02-01','2013-12-31 19:48:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:22:44'),(7355,5825,'Y','18','021','EC','A','','','AC','0000728636','0000728636','TX00000282147','IL','1','SHIN','MYUNG','','','','34','632206512','810 KENSINGTON DR',0,'DUNCANVILLE','TX','75137','2118','CY','48113','1963-07-30','F','M',':RET:2040-4','N','021','DEN','445497','33348TX002000201','2014-01-01','2013-11-23 12:56:36','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:15:14'),(7917,6260,'Y','18','021','EC','A','','','AC','0001606819','0001606819','LA00000299096','IL','1','DOWED','SUILEMAN','','','','34','522471770','634 PAULINE ST',0,'NEW ORLEANS','LA','70116',NULL,'CY','22071','1957-02-02','M','U',':RET:2054-5','N','021','DEN','1624294','18575LA002000201','2014-01-01','2013-12-19 21:41:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:13'),(22473,17945,'Y','18','021','EC','A','','','AC','0001141429','0001141429','MS00002682928','IL','1','Johnson','Lashun','','','','34','395829528','635 RANKIN RD',0,'CANTON','MS','39046','8639','CY','28089','1971-06-18','F','U',NULL,'N','021','DEN','2842794','46300MS002000101','2014-03-01','2014-02-10 15:38:50','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-10 21:31:00'),(23126,18432,'Y','18','021','EC','A','','','AC','0001037400','0001037400','OH00002508709','IL','1','MUNFORD','CAROLYN','','','','34','296620442','937 HARRISON AVE SW',0,'CANTON','OH','44706',NULL,'CY','39151','1958-07-24','F','U',NULL,'T','021','DEN','3418859','99734OH005000401','2014-03-01','2014-02-12 14:04:30','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-12 21:31:26'),(23916,19021,'N','19','021','EC','A',NULL,NULL,'','0000813132','0000910564','','IL','1','Trimmer','Brooke','','','','34','289334066','2266 TIMBER RIDGE TRL',0,'STREETSBORO','OH','44241','4202','CY','39133','2013-01-22','F','',':RET:2106-3','N','021','DEN','3787451','99734OH005000301','2014-03-01','2014-02-13 23:40:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:04'),(25675,20369,'N','19','021','EC','A',NULL,NULL,'','0000072934','0000850551','','IL','1','Mkhize','Michael','Ziningi','','','34','395178102','900 SELBY ST',0,'FINDLAY','OH','45840','6024','CY','39063','1986-05-03','M','',':RET:2054-5','N','021','HLT','3581637','92036OH004001501','2014-04-01','2014-02-22 12:18:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','185.46',NULL,0,'2014-02-26 08:30:55'),(25771,20439,'Y','18','021','EC','A','','','AC','0000602326','0000602326','OH00002506132','IL','1','Price','Kimberly','','','','34','276827351','11319 DARROW RD',0,'VERMILION','OH','44089','9354','CY','39043','1968-05-09','F','U',':RET:2106-3','N','021','DEN','2784447','99734OH005000301','2014-04-01','2014-02-24 13:55:01','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-26 09:30:56'),(28303,22394,'Y','18','021','EC','A','','','AC','0000212216','0000212216','OH00002601643','IL','1','Spray','Karen','','','','34','275662924','216 N EAST ST',0,'MASON','OH','45040','1759','CY','39165','1974-05-17','F','U',':RET:2106-3','T','021','HLT','2998135','92036OH005001205','2014-04-01','2014-03-07 14:48:08','120.00',NULL,NULL,'311.54','191.54','R-OH004','OH0','311.54','CIC',0,'2014-03-07 21:00:33'),(980,802,'Y','18','024','14','A','','','TE','0000048151','0000048151','','IL','1','MCDONALD','NITAYA','Y',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-11-06','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-28 23:35:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:10:16'),(2080,1703,'Y','18','021','EC','A','','','AC','0000670280','0000670280','LA00000110952','IL','1','Whatley','Jerry','','','','34','438845580','2041 CONSTANTINE DR',0,'MARRERO','LA','70072','4558','CY','22051','1950-11-28','M','M',':RET:2054-5','N','021','DEN','743126','18575LA002000201','2014-01-01','2013-12-09 23:47:43','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:16:35'),(3559,2857,'Y','18','021','EC','A','','','AC','0000872035','0000872035','OH00000599234','IL','1','Lucas','Michael','','','','34','268523763','7054 Cleveland-Massillon Rd',0,'New Franklin','OH','44216',NULL,'CY','39153','1952-03-14','M','M',':RET:2106-3','N','021','HLT','2441871','52664OH151001305','2014-01-01','2013-12-22 14:01:55','433.00',NULL,NULL,'626.65','193.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 21:22:15'),(6049,4791,'Y','18','021','EC','A','','','AC','0000444875','0000444875','OH00000639897','IL','1','Levine','David','','','','34','220600594','2697 Wickliffe Road',0,'Columbus','OH','43221',NULL,'CY','39049','1952-01-24','M','U',':RET:2106-3','N','021','DEN','1082343','99734OH005000401','2014-01-01','2013-12-01 16:10:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:01:37'),(21912,17500,'Y','18','021','EC','A','','','AC','0000669217','0000669217','OH00002503416','IL','1','Bruce','Analena','Beate','','','34','122662102','7240 CAVE RD',0,'BAINBRIDGE','OH','45612','9536','CY','39071','1982-11-03','F','M',':RET:2106-3','N','021','HLT','2889524','92036OH003000605','2014-03-01','2014-02-06 15:55:19','400.00',NULL,NULL,'525.04','125.04','R-OH005','OH0','259.83','CIC',0,'2014-02-06 21:30:03'),(4255,3390,'Y','18','024','14','A','','','TE','0000546460','0000546460','','IL','1','Zuelsdorf','Donna','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-22','F','',NULL,NULL,NULL,'','2272092','','2013-12-16','2013-12-16 23:16:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:23'),(19925,15889,'Y','18','024','14','A','','','TE','0000845246','0000845246','','IL','1','Smith','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-28','F','',NULL,NULL,NULL,'','2642303','','2014-01-24','2014-01-24 16:47:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-24 21:01:06'),(9276,7359,'Y','18','021','EC','A','','','AC','0000404769','0000404769','OH00001268506','IL','1','Phillips','Diana','','','','34','292749748','2249 VALE DR',0,'KETTERING','OH','45420','3554','CY','39113','1966-04-02','F','U',':RET:2106-3','N','021','DEN','578765','99734OH005000401','2014-01-01','2013-11-30 16:21:57','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:15:48'),(19791,15777,'N','19','021','EC','A',NULL,NULL,'','0000550098','0000218857','','IL','1','Dennis','Caitlin','','','','34','277964227','3868 ARLINGTON RD',0,'UNIONTOWN','OH','44685','9604','CY','39153','1993-02-12','F','',':RET:1002-5^:RET:2106-3','N','021','HLT','2403323','52664OH151001501','2014-03-01','2014-01-23 09:44:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2014-01-23 21:01:40'),(13689,10923,'Y','18','021','EC','A','','','AC','0000532102','0000532102','OH00000068217','IL','1','Keenan','Kathleen','','','','34','285744787','2217 Elmwood Ave',0,'Stow','OH','44224',NULL,'CY','39153','1963-04-26','F','U',':RET:2106-3','N','021','HLT','2234409','52664OH151001301','2014-01-01','2013-12-23 10:41:42','50.00',NULL,NULL,'398.29','348.29','R-OH012','OH0','398.29',NULL,0,'2013-12-26 13:08:25'),(13924,11104,'Y','18','021','EC','A','','','AC','0000829277','0000829277','OH00000687813','IL','1','Nguyen','Kim Thanh','','','','34','619467970','3228 YORKTOWN DR',0,'OREGON','OH','43616','2991','CY','39095','1967-07-16','F','U',':RET:2047-9','N','021','HLT','2576164','92036OH003002606','2014-01-01','2013-12-23 13:50:51','228.00',NULL,NULL,'305.45','77.45','R-OH001','OH0','305.45',NULL,0,'2013-12-26 13:14:14'),(26367,20915,'Y','18','024','14','A','','','TE','0000460551','0000460551','','IL','1','Jacob','Elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-05','F','',NULL,NULL,NULL,'','699400','','2014-03-31','2014-02-26 15:27:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:09'),(29045,22988,'Y','18','021','EC','A','','','AC','0000041012','0000041012','OH00003237117','IL','1','OKERWALL','DONNA','','','','34','275769329','463 LIBERTY ST',0,'PAINESVILLE','OH','44077','3647','CY','39085','1965-01-23','F','M',NULL,'N','021','DEN','3101292','99734OH005000401','2014-04-01','2014-03-10 13:44:54','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:42'),(29057,22998,'Y','18','021','EC','A','','','AC','0000457867','0000457867','OH00003406340','IL','1','WHITT','DIANNA','','','','34','278642035','25514 COUNTY ROAD 10',0,'FRESNO','OH','43824','9742','CY','39031','1957-03-10','F','M',':RET:2106-3','N','021','DEN','3152087','99734OH005000401','2014-04-01','2014-03-10 16:21:57','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-03-10 21:01:49'),(258,215,'Y','18','021','EC','A','','','AC','0000197129','0000197129','OH00000007137','IL','1','mason','melissa','','','','34','286682333','1947 providence ave',0,'Springfield','OH','45503',NULL,'CY','39023','1971-10-22','F','R',':RET:2106-3','N','021','HLT','14504','92036OH004000501','2014-01-01','2013-12-05 08:24:20','0.00',NULL,NULL,'627.90','627.90','R-OH003','OH0','253.26',NULL,0,'2013-12-25 17:21:47'),(18138,14484,'Y','18','021','EC','A','','','AC','0002318750','0002318750','LA00001643903','IL','1','JONES','MARY','','','','34','434410360','1011 LAURIE LN',0,'SAINT MARTINVILLE','LA','70582','6523','CY','22099','1963-02-27','F','M',':RET:2054-5','N','021','DEN','1360468','18575LA002000101','2014-02-01','2014-01-13 23:19:06','0.00',NULL,NULL,'50.04','50.04','R-LA003','LA0','25.02',NULL,0,'2014-01-15 02:07:45'),(5024,3982,'Y','18','024','14','A','','','TE','0001125403','0001125403','','IL','1','Burns','Kristina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-18','F','',NULL,NULL,NULL,'','246759','','2013-12-07','2013-12-07 12:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:47:39'),(3445,2769,'N','01','021','EC','A',NULL,NULL,'','0000972734','0000667776','','IL','1','MYERS','KIRA','','','','34','291881940','5259 RELLUK DR',0,'CINCINNATI','OH','45238','3736','CY','39061','1983-08-01','F','',':RET:2106-3','N','021','DEN','1499857','99734OH005000401','2014-01-01','2013-12-21 20:40:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:20'),(17973,14361,'Y','18','024','14','A','','','TE','0001260031','0001260031','','IL','1','Minhas','Rubina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-20','F','',NULL,NULL,NULL,'','1942667','','2014-01-14','2014-01-14 03:47:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:06:50'),(9613,7613,'Y','18','024','14','A','','','TE','0000249099','0000249099','','IL','1','Hall','Jeffrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-30','M','',NULL,NULL,NULL,'','632011','','2013-12-21','2013-12-21 17:33:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:37:42'),(13165,10501,'Y','18','021','EC','A','','','AC','0000326189','0000326189','OH00000625125','IL','1','Smeltzer','Haley','','','','34','403733865','10962 AYER PL',0,'MIAMISBURG','OH','45342','4811','CY','39113','2010-09-15','F','U',':RET:2106-3','N','021','DEN','1992588','99734OH005000401','2014-01-01','2013-12-23 18:20:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2013-12-26 12:53:56'),(13381,10683,'Y','18','021','EC','A','','','AC','0000631506','0000631506','OH00000737256','IL','1','Porter','Hayden','','','','34','248613128','668 Wynne Dr.',0,'Akron','OH','44319',NULL,'CY','39153','1969-03-14','M','M',':RET:2106-3','N','021','DEN','1487252','99734OH005000301','2014-01-01','2013-12-22 22:57:57','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:59:54'),(15463,12374,'Y','18','024','14','A','','','TE','0000781869','0000781869','','IL','1','Martin','Bryan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-08-04','M','',NULL,NULL,NULL,'','714026','','2013-12-31','2013-12-31 09:52:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:28:44'),(16831,13462,'Y','18','021','EC','A','','','AC','0000924813','0000924813','OH00002401001','IL','1','Roberts','Tamara','','','','34','274888859','1858 LOTUSHILL DR',0,'CINCINNATI','OH','45240','3314','CY','39061','1973-08-24','F','U',':RET:2054-5','N','021','DEN','2164804','99734OH005000401','2014-02-01','2014-01-11 11:01:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:18:28'),(16606,13283,'Y','18','021','EC','A','','','AC','0002319934','0002319934','LA00002050892','IL','1','Tutson','David','','','Sr','34','437235554','904 HIGHWAY 397',0,'LAKE CHARLES','LA','70615','5321','CY','22019','1956-04-10','M','M',':RET:2054-5','N','021','DEN','1971228','18575LA002000201','2014-02-01','2014-01-07 17:37:00','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-08 18:24:06'),(24994,19823,'Y','18','021','EC','A','','','AC','0000820802','0000820802','TX00003068996','IL','1','ERSKINE','JALYNSIA','VONSHAY','','','34','457753271','11702 BILL ALLEN DR',0,'TYLER','TX','75706','5000','CY','48423','1985-10-29','F','U',':RET:2054-5','N','021','DEN','3221332','33348TX002000201','2014-04-01','2014-02-20 15:07:04','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-20 22:00:41'),(26346,20901,'N','01','021','EC','A',NULL,NULL,'','0001066040','0000308324','','IL','1','DAVIS','KEITH','','','','34','283760553','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1967-11-07','M','',':RET:2106-3','N','021','HLT','3569741','92036OH004000601','2014-03-01','2014-02-27 12:17:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','258.91',NULL,0,'2014-02-28 06:31:45'),(27393,21686,'N','01','021','EC','A',NULL,NULL,'','0001042351','0000411181','','IL','1','MacNeel','David','','','','34','282763818','6424 ASHLEY OAKS CT',0,'WEST CHESTER','OH','45069','5107','CY','39017','1969-07-29','M','',':RET:2106-3','N','021','DEN','3740872','99734OH005000301','2014-04-01','2014-03-03 18:44:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:27'),(27649,21871,'Y','18','021','EC','A','','','AC','0000134634','0000134634','OH00002745505','IL','1','Stinson','David','','','','34','273882678','2540 OWLCREST DR',0,'CINCINNATI','OH','45231','1152','CY','39061','1979-02-21','M','U',':RET:2054-5','T','021','DEN','2946972','99734OH005000401','2014-04-01','2014-03-05 13:17:30','0.00',NULL,NULL,'50.05','50.05','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:30:21'),(66,59,'Y','18','021','EC','A','','','AC','0001152168','0001152168','OH00000958128','IL','1','Reitman','Matthew','','','','34','545799664','379 CHITTENDEN AVE',0,'COLUMBUS','OH','43201','2222','CY','39049','1983-08-06','M','U',':RET:2106-3','N','021','DEN','843762','99734OH005000301','2014-01-01','2013-12-05 00:17:17','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:16:47'),(525,428,'Y','18','021','EC','A','','','AC','0000523378','0000523378','OH00000638638','IL','1','Herchenroeder','Susan','','','','34','272562193','398 RUTLAND AVE',0,'AKRON','OH','44305','3145','CY','39153','1950-10-21','F','M',':RET:2106-3','N','021','HLT','7383','52664OH151001501','2014-01-01','2013-12-03 20:24:21','323.00',NULL,NULL,'789.56','466.56','R-OH012','OH0','789.56',NULL,0,'2013-12-25 17:49:19'),(662,547,'Y','18','021','EC','A','','','AC','0001133930','0001133930','OH00000872767','IL','1','Fineran','Andrew','','','','34','199669784','2631 MAPLE AVE NE',0,'CANTON','OH','44714','1890','CY','39151','1986-11-30','M','R',':RET:2106-3','N','021','DEN','435071','99734OH005000301','2014-01-01','2013-12-15 23:42:04','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 18:01:55'),(7115,5645,'Y','18','021','EC','A','','','AC','0001760468','0001760468','LA00000307704','IL','1','Collins','Christine','','','','34','438175908','12 Ravenna Street',0,'Harvey','LA','70058',NULL,'CY','22051','1961-12-25','F','U',':RET:2054-5','N','021','DEN','2448845','18575LA002000101','2014-02-01','2013-12-25 10:54:28','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 01:51:10'),(20391,16289,'Y','18','021','EC','A','','','AC','0000896386','0000896386','TX00002123306','IL','1','Pipes','Johnnie','','','','34','455924353','2007 VANZANDY COUNTY Road',0,'FRUITVILLE','TX','75127',NULL,'CY','48467','1952-04-26','F','M',NULL,'N','021','DEN','3362523','33348TX002000201','2014-03-01','2014-01-29 12:10:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:15'),(2421,1974,'N','19','021','EC','A',NULL,NULL,'','0000133293','0001113118','','IL','1','Yablonsky','Laura','','','','34','298062251','5763 RUTLEDGE TRL',0,'LIBERTY TWP','OH','45011','1245','CY','39017','2002-04-30','F','',':RET:2106-3','N','021','DEN','1039687','99734OH005000401','2014-01-01','2013-12-09 16:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:57'),(20390,16288,'Y','18','021','EC','A','','','AC','0000936676','0000936676','TX00002011244','IL','1','Sanchez','Dora','','','','34','451836968','3024 S. County Road 120A',0,'Midland','TX','79706',NULL,'CY','48329','1954-01-13','F','M',NULL,'N','021','DEN','3302486','33348TX002000201','2014-03-01','2014-01-29 11:52:33','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-29 21:00:15'),(3766,3014,'Y','18','021','EC','A','','','AC','0000284390','0000284390','OH00000911813','IL','1','Baranowski','Tracey','','','','34','298760656','235 Longview Dr',0,'Wadsworth','OH','44281',NULL,'CY','39103','1965-12-08','F','U',':RET:2106-3','N','021','HLT','238063','52664OH151001301','2014-01-01','2013-12-13 13:36:51','0.00',NULL,NULL,'364.62','364.62','R-OH012','OH0','364.62',NULL,0,'2013-12-25 21:33:33'),(18366,14660,'Y','18','024','14','A','','','TE','0000948436','0000948436','','IL','1','abou-osman','wanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-16','F','',NULL,NULL,NULL,'','1526001','','2014-01-15','2014-01-15 10:53:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:28'),(17124,13704,'Y','18','024','14','A','','','TE','0000910534','0000910534','','IL','1','DEVORE','DREW',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-20','M','',NULL,NULL,NULL,'','2022527','','2014-01-08','2014-01-08 10:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:21:43'),(16965,13579,'Y','18','021','EC','A','','','AC','0000894637','0000894637','OH00001806972','IL','1','Irvin','Lenora','','','','34','296504729','1111 MURRAY AVE',0,'AKRON','OH','44310','1145','CY','39153','1950-10-13','F','U',NULL,'T','021','HLT','2113992','52664OH151001304','2014-02-01','2014-01-09 13:38:56','467.00',NULL,NULL,'757.07','290.07','R-OH012','OH0','757.07',NULL,0,'2014-01-13 02:20:10'),(5322,4220,'Y','18','021','EC','A','','','AC','0000787178','0000787178','OH00000697478','IL','1','Hizer','Danny','','','','34','302741736','7488 E KEMPER RD',0,'CINCINNATI','OH','45249','1637','CY','39061','1963-11-22','M','U',':RET:2106-3','N','021','DEN','2094796','99734OH005000301','2014-01-01','2013-12-19 06:20:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:06:51'),(4569,3618,'Y','18','021','EC','A','','','AC','0000439289','0000439289','TX00000483574','IL','1','Barney','Kathy','Lynn','','','34','463212918','5210 TOWER DR',0,'WICHITA FALLS','TX','76310','3067','CY','48485','1959-05-21','F','U',':RET:2106-3','N','021','DEN','308965','33348TX002000101','2014-01-01','2013-12-12 13:09:47','0.00',NULL,NULL,'27.15','27.15','R-TX025','TX0','27.15',NULL,0,'2013-12-25 22:04:55'),(9526,7552,'N','19','021','EC','A',NULL,NULL,'','0000667772','0000812020','','IL','1','AGARWAL','ANJALI','NEIL','','','34','296045870','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','2000-04-17','F','',':RET:2029-7','N','021','DEN','2028084','99734OH005000301','2014-01-01','2013-12-20 20:28:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:42'),(3931,3146,'Y','18','021','EC','A','','','AC','0000699257','0000699257','OH00000673488','IL','1','Foust','Ty','T','','','34','291763281','7051 Quail Lakes Drive',0,'Holland','OH','43528',NULL,'CY','39095','1980-11-06','M','U',':RET:2106-3','N','021','HLT','272223','92036OH004002601','2014-01-01','2013-12-13 12:57:34','0.00',NULL,NULL,'187.83','187.83','R-OH001','OH0','187.83',NULL,0,'2013-12-25 21:37:38'),(18357,14655,'Y','18','021','EC','A','','','AC','0000167789','0000167789','OH00001721561','IL','1','Schivelbein','David','M','','','34','273781237','5137 Bay Ridge Court',0,'Oregon','OH','43616',NULL,'CY','39095','1966-06-23','M','M',':RET:2106-3','N','021','DEN','2772125','99734OH005000301','2014-02-01','2014-01-14 22:51:26','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2014-01-16 08:45:25'),(19849,15831,'Y','18','024','14','A','','','TE','0000669160','0000669160','','IL','1','Holland','Peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-07-30','M','',NULL,NULL,NULL,'','846539','','2014-01-24','2014-01-24 11:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:30'),(21599,17249,'N','19','021','EC','A',NULL,NULL,'','0001076598','0000849466','','IL','1','SAMI','YAMHA','','','','34','289082035','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','2003-12-21','F','',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(21746,17365,'Y','18','024','14','A','','','TE','0000324261','0000324261','','IL','1','griffith','melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-09-12','F','',NULL,NULL,NULL,'','3063109','','2014-02-05','2014-02-05 18:55:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-06 21:00:18'),(22840,18224,'N','19','021','EC','A',NULL,NULL,'','0000027927','0000679570','','S1','1','Bazzy','Lubna','','','','34','165812554','10790 BIXEL RD',0,'BLUFFTON','OH','45817','9506','CY','39003','2011-08-04','M','',NULL,'N','021','HLT','3376536','92036OH004001501','2014-03-01','2014-02-10 21:15:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-02-11 21:02:13'),(24128,19179,'Y','18','021','EC','A','','','AC','0002157211','0002157211','LA00002116092','IL','1','Strohmeyer','Charles','','','','34','439430251','110 EVANGELINE LN',0,'DESTREHAN','LA','70047','3045','CY','22089','1966-03-17','M','M',':RET:2106-3','N','021','DEN','2932534','18575LA002000101','2014-03-01','2014-02-15 14:42:54','0.00',NULL,NULL,'119.61','119.61','R-LA001','LA0','25.02',NULL,0,'2014-02-15 22:01:46'),(24235,19246,'N','01','021','EC','A',NULL,NULL,'','0001034715','0001075346','','IL','1','LITTLE','LISA',NULL,NULL,NULL,NULL,NULL,'2815 KING LN',0,'HILLSBORO','OH','45133','8891','CY','39071','1963-06-22','F','',':RET:2106-3','N','021','HLT','2927675','92036OH003000604','2014-03-01','2014-02-15 21:12:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','400.38',NULL,0,'2014-02-16 19:00:36'),(29097,23030,'Y','18','021','EC','A','','','AC','0000357261','0000357261','OH00002790849','IL','1','Smoot','Jennifer','Marie','','','34','404211136','3241 Roesch Blvd',0,'Fairfield','OH','45014',NULL,'CY','39017','1982-01-11','F','U',':RET:2106-3','N','021','HLT','4292204','92036OH006001201','2014-04-01','2014-03-09 22:06:49','39.00',NULL,NULL,'201.40','162.40','R-OH004','OH0','201.40',NULL,0,'2014-03-10 21:02:14'),(6261,4963,'Y','18','024','14','A','','','TE','0000162235','0000162235','','IL','1','Cooper','Julian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-01','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:32:15'),(15352,12281,'Y','18','021','EC','A','','','AC','0000296798','0000296798','OH00001947551','31','1','Kennedy','Jessica','','','','34','296845342','314 East Union',0,'Medina','OH','44256',NULL,'CY','39103','1986-09-11','F','U',':RET:2106-3','N','021','DEN','1495483','99734OH005000301','2014-02-01','2013-12-31 22:15:23','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:24:35'),(833,689,'Y','18','021','EC','A','','','AC','0000746857','0000746857','OH00000573270','IL','1','Hicks','Alfred','','','','34','230356311','175 ERNEST DR',0,'TALLMADGE','OH','44278','1628','CY','39153','1967-09-01','M','R',':RET:2106-3','N','021','HLT','2560113','52664OH151001301','2014-01-01','2013-12-16 18:22:32','0.00',NULL,NULL,'334.51','334.51','R-OH012','OH0','334.51',NULL,0,'2013-12-25 18:06:24'),(2410,1967,'N','01','021','EC','A',NULL,NULL,'','0000667753','0000044247','','IL','1','elkins','douglas','c','','','34','287505878','2843 double eagle dr.',0,'beavercreek','OH','45431',NULL,'CY','39057','1957-11-22','M','',':RET:2106-3','N','021','DEN','1243416','99734OH005000401','2014-01-01','2013-12-09 15:06:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:43'),(7179,5692,'Y','18','021','EC','A','','','AC','0000582791','0000582791','OH00000889687','IL','1','Massie','Sandra','','','','34','284568461','1120 COUNTY ROAD 19',0,'KITTS HILL','OH','45645','8529','CY','39087','1956-01-08','F','M',':RET:2106-3','N','021','DEN','73773','99734OH005000301','2014-01-01','2013-12-13 23:01:28','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-26 02:00:09'),(7861,6221,'N','01','021','EC','A',NULL,NULL,'','0000951788','0000198553','','IL','1','Scott','Evan','L','','','34','280544884','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1965-01-26','M','',':RET:2106-3','N','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:59'),(15902,12734,'Y','18','021','EC','A','','','AC','0001244174','0001244174','OH00001577563','IL','1','Bolan','Mary','','','','34','268220965','6103 SHADOWSLOPE LN',0,'CINCINNATI','OH','45244','3916','CY','39061','1926-10-28','F','U',':RET:2106-3','N','021','HLT','2161868','92036OH005001201','2014-02-01','2014-01-01 22:03:16','0.00',NULL,NULL,'644.00','644.00','R-OH004','OH0','644.00',NULL,0,'2014-01-03 02:06:06'),(18300,14610,'Y','18','021','EC','A','','','AC','0000821036','0000821036','OH00001756273','IL','1','Newsome','Martha','','','','34','593882680','38817 STATE ROUTE 160',0,'HAMDEN','OH','45634','8809','CY','39163','1951-04-03','F','U',NULL,'N','021','DEN','1892083','99734OH005000401','2014-02-01','2014-01-15 10:07:15','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-01-16 08:44:56'),(19432,15491,'Y','18','021','EC','A','','','AC','0000278351','0000278351','OH00001935206','IL','1','Kiessling','Richard','','','','34','280886570','1256 TUENDAWIE ST',0,'DEFIANCE','OH','43512','2755','CY','39039','1973-09-09','M','U',':RET:2106-3','N','021','HLT','1817320','92036OH003002605','2014-03-01','2014-01-21 12:36:26','194.00',NULL,NULL,'260.25','66.25','R-OH001','OH0','260.25',NULL,1,'2014-01-22 03:23:08'),(26944,21350,'N','01','021','EC','A',NULL,NULL,'','0000618418','0000889660','','IL','1','Chmura','Therese','','','','34','271720160','1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','1970-02-02','F','',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:24'),(28870,22848,'Y','18','024','14','A','','','TE','0001173934','0001173934','','IL','1','Davila','Francisca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-15','F','',NULL,NULL,NULL,'','3789177','','2014-03-08','2014-03-09 20:15:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-10 21:00:02'),(244,205,'Y','18','021','EC','A','','','AC','0000796930','0000796930','OH00001028427','IL','1','Brunner','George','','','','34','277421561','7719 Topridge Drive',0,'West Chester','OH','45069',NULL,'CY','39017','1950-01-29','M','M',':RET:2106-3','N','021','HLT','273253','92036OH005001201','2014-01-01','2013-12-05 13:41:51','659.00',NULL,NULL,'1316.99','657.99','R-OH004','OH0','633.70',NULL,0,'2013-12-25 17:21:25'),(15547,12440,'Y','18','021','EC','A','','','AC','0001737483','0001737483','LA00001734829','IL','1','Hart','Anita','','','','34','435357709','2445 CAMBRIDGE DR',0,'LA PLACE','LA','70068','2309','CY','22095','1978-05-02','F','U',':RET:2054-5','N','021','DEN','1583648','18575LA002000201','2014-02-01','2013-12-31 15:53:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:31:09'),(15480,12384,'Y','18','021','EC','A','','','AC','0000787201','0000787201','OH00001039722','IL','1','Bahta','Alem','','','','34','273130447','577 MARTIN LUTHER KING DR W',0,'CINCINNATI','OH','45220','2461','CY','39061','1982-02-26','F','U',':RET:2054-5','N','021','DEN','1595022','99734OH005000401','2014-02-01','2013-12-31 01:24:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:29:07'),(4146,3305,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000764949','','IL','1','Shamy','Alexander','B',NULL,NULL,NULL,NULL,'13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',':RET:2106-3','N','021','DEN','1998433','99734OH005000301','2014-01-01','2013-12-17 12:46:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:40'),(14906,11908,'Y','18','021','EC','A','','','AC','0000125469','0000125469','MS00001081836','IL','1','Alexander','Patricia','','','','34','438357585','1955 popps ferry rd apt 1133CC',0,'Biloxi','MS','39532',NULL,'CY','28047','1978-10-22','F','U',':RET:2054-5','N','021','DEN','2239565','46300MS002000201','2014-02-01','2013-12-28 21:59:03','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-30 00:01:18'),(14309,11414,'N','01','021','EC','A',NULL,NULL,'','0000929847','0000149361','','IL','1','RIFE','BENJAMIN','','','','34','277806613','971 HOMEWOOD AVE SE',0,'WARREN','OH','44484','4908','CY','39155','1975-02-24','M','',':RET:2106-3','N','021','HLT','1770167','92036OH001003201','2014-02-01','2013-12-26 11:23:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.82',NULL,0,'2013-12-27 02:07:01'),(13577,10828,'Y','18','021','EC','A','','','AC','0002201191','0002201191','LA00000899061','IL','1','Lemus','Osmin','','','','34','437891204','212 GEORGETOWN DR',0,'KENNER','LA','70065','4050','CY','22051','1949-12-28','M','M',NULL,'N','021','DEN','1903425','18575LA002000201','2014-01-01','2013-12-23 18:00:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:48'),(1390,1154,'N','19','021','EC','A',NULL,NULL,'','0001888236','0002395689','','IL','1','Carey','Jarius','J',NULL,NULL,NULL,NULL,'36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1992-11-25','M','',':RET:2054-5','N','021','DEN','1422524','18575LA002000201','2014-01-01','2013-12-24 10:52:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:46:21'),(3899,3121,'Y','18','021','EC','A','','','AC','0000307084','0000307084','OH00000391951','IL','1','Bricker','Daniel','','','','34','276566730','771 Roselawn Ave.',0,'Akron','OH','44306',NULL,'CY','39153','1956-06-07','M','U',':RET:2106-3','T','021','HLT','1145290','52664OH152000901','2014-01-01','2013-12-13 16:11:35','410.00',NULL,NULL,'457.77','47.77','R-OH012','OH0','457.77',NULL,0,'2013-12-25 21:36:49'),(2139,1757,'Y','18','021','EC','A','','','AC','0000857076','0000857076','OH00001121077','IL','1','Acton','Felicia','','','','34','275828509','4320 ROCKY RIVER DR',0,'CLEVELAND','OH','44135','1979','CY','39035','1984-02-14','F','U',':RET:2106-3','N','021','DEN','366453','99734OH005000401','2014-01-01','2013-12-10 17:53:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:18:12'),(7502,5934,'Y','18','021','EC','A','','','AC','0000217572','0000217572','OH00000998734','IL','1','Sanders','Matthew','','','','34','296905144','12607 BENTLEY DR',0,'PICKERINGTON','OH','43147','8519','CY','39045','1987-02-14','M','U',':RET:2106-3','T','021','DEN','575458','99734OH005000401','2014-01-01','2013-12-15 16:19:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:52'),(16771,13416,'Y','18','021','EC','A','','','AC','0000736534','0000736534','OH00001256163','IL','1','Ashbrook','Fredrick','','','','34','286584889','1126 LAKE ST',0,'MARBLEHEAD','OH','43440','2034','CY','39123','1955-01-27','M','U',':RET:2106-3','N','021','HLT','1711097','92036OH003002705','2014-02-01','2014-01-07 16:37:39','460.00',NULL,NULL,'530.07','70.07','R-OH006','OH0','530.07',NULL,0,'2014-01-08 18:25:02'),(17206,13769,'N','01','021','EC','A',NULL,NULL,'','0000399906','0000599770','','IL','1','Weisel','Tamara','Jean','','','34','276684698','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1975-05-28','F','',':RET:2106-3','N','021','HLT','1538851','52664OH151001306','2014-02-01','2014-01-08 00:22:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2014-01-13 02:22:27'),(18295,14606,'Y','18','021','EC','A','','','AC','0000621131','0000621131','OH00002183260','IL','1','McLoughlin','Timothy','','','','34','406316928','22026 SHELBURNE RD',0,'SHAKER HEIGHTS','OH','44122','2048','CY','39035','1979-02-22','M','U',':RET:2106-3','N','021','DEN','2516233','99734OH005000401','2014-02-01','2014-01-14 21:47:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:44:54'),(19124,15237,'N','19','021','EC','A',NULL,NULL,'','0001003331','0000488014','','IL','1','Wang','Bethany',NULL,NULL,NULL,NULL,NULL,'27568 REMINGTON CIR',0,'WESTLAKE','OH','44145','2139','CY','39035','2001-11-10','F','',':RET:2034-7','N','021','DEN','2876390','99734OH005000401','2014-03-01','2014-01-19 16:16:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:45:19'),(21830,17432,'Y','18','021','EC','A','','','AC','0000488009','0000488009','TX00002419290','IL','1','Kershaw','Carolyn','','','','34','458764171','430E Buckinham Rd',0,'Richardson','TX','75081',NULL,'CY','48113','1951-12-27','F','U',':RET:2106-3','N','021','DEN','3410307','33348TX002000101','2014-03-01','2014-02-05 19:49:49','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-06 21:01:04'),(21877,17466,'Y','18','021','EC','A','','','AC','0001933128','0001933128','LA00002238052','IL','1','David','Jared','','','','34','436477613','18436 LAKE STREAM DR',0,'GREENWELL SPRINGS','LA','70739','4765','CY','22033','1977-03-07','M','U',':RET:2106-3','N','021','DEN','3089649','18575LA002000201','2014-03-01','2014-02-06 10:55:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-06 21:01:28'),(22520,17979,'Y','18','021','EC','A','','','AC','0000436641','0000436641','OH00002424386','IL','1','Rains','Leonard','','','','34','278703596','13358 fort hill rd',0,'Hillsboro','OH','45133',NULL,'CY','39071','1970-12-13','M','M',':RET:2106-3','T','021','HLT','3525441','92036OH004000601','2014-03-01','2014-02-09 19:52:28','62.00',NULL,NULL,'269.37','207.37','R-OH005','OH0','269.37',NULL,0,'2014-02-10 21:31:24'),(22790,18195,'N','01','021','EC','A',NULL,NULL,'','0001095701','0000292008','','IL','1','SELF','DEBORAH','K','','','34','268561230','816 WILLARD ST',0,'WASHINGTON COURT HOUSE','OH','43160','2157','CY','39047','1954-01-31','F','',':RET:2106-3','N','021','DEN','3144332','99734OH005000301','2014-03-01','2014-02-11 12:03:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:49'),(23152,18456,'N','01','021','EC','A',NULL,NULL,'','0000303406','0000119109','','IL','1','Bailey','Sheila','Lynn','','','34','287682506','10753 Harrison Ave',0,'Harrison','OH','45030',NULL,'CY','39061','1970-08-23','F','',':RET:2106-3','N','021','HLT','3256022','92036OH004001201','2014-03-01','2014-02-11 19:57:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','234.23',NULL,0,'2014-02-12 21:31:42'),(24413,19392,'Y','18','021','EC','A','','','AC','0000888222','0000888222','OH00002178106','IL','1','Chenzira','Sakile','Sala','','','34','291544321','2308 MADISON RD',0,'CINCINNATI','OH','45208','2631','CY','39061','1954-06-23','F','U',':RET:2054-5','N','021','DEN','3786223','99734OH005000301','2014-04-01','2014-02-18 10:27:37','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:01:02'),(25853,20495,'Y','18','021','EC','A','','','AC','0002089531','0002089531','LA00003074046','IL','1','DeLisle','Jacques','','','','34','595123891','30978 RIDGEWAY',0,'WALKER','LA','70785','5542','CY','22063','1976-11-13','M','M',':RET:2106-3','N','021','DEN','3218066','18575LA002000201','2014-03-01','2014-02-26 08:57:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-26 21:00:41'),(26837,21271,'Y','18','021','EC','A','','','AC','0002114803','0002114803','LA00003353411','IL','1','Nguyen','Marie','','','','34','566899384','41109 HIGHWAY 941',0,'GONZALES','LA','70737','8204','CY','22005','1986-06-17','F','U',NULL,'N','021','DEN','3151756','18575LA002000201','2014-04-01','2014-02-28 19:08:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-01 21:00:43'),(27323,21635,'Y','18','021','EC','A','','','AC','0000992711','0000992711','TX00002962791','IL','1','Dominguez','Ivan','','','','34','572838768','365 La Puesta apt 382',0,'El Paso','TX','79932',NULL,'CY','48141','1981-11-06','M','M',':RET:2106-3','N','021','DEN','3961936','33348TX002000201','2014-04-01','2014-03-04 16:34:08','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-04 21:00:47'),(7,6,'Y','18','021','EC','A','','','AC','0000894598','0000894598','OH00000953400','IL','1','english','kevin','','','','34','293623312','6501 germantown rd',0,'middletown','OH','45042',NULL,'CY','39017','1966-08-16','M','U',':RET:2106-3','T','021','DEN','377224','99734OH005000401','2014-01-01','2013-12-04 20:39:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:12'),(2315,1881,'N','01','021','EC','A',NULL,NULL,'','0000224327','0000878882','','IL','1','Chaplin','Lorie','Michelle','','','34','478132647','1113 HIGH ST',0,'BRENHAM','TX','77833','4067','CY','48477','1981-12-18','F','',':RET:2106-3','N','021','DEN','454558','33348TX002000201','2014-01-01','2013-12-08 21:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:31:17'),(5211,4137,'Y','18','021','EC','A','','','AC','0000595128','0000595128','OH00000258575','IL','1','Black','Julius','Tryston','','','34','225978952','1852 CANTERBURY LN',0,'WOOSTER','OH','44691','1567','CY','39169','2003-07-15','M','R',':RET:2054-5^:RET:2106-3','N','021','DEN','1632033','99734OH005000401','2014-01-01','2013-12-19 15:42:31','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','15.78',NULL,0,'2013-12-25 23:04:18'),(16162,12940,'N','19','021','EC','A',NULL,NULL,'','0000801241','0001097769','','IL','1','McDuff','Fahd','','','','34','287135694','1100 RING NECK DR',0,'BLACKLICK','OH','43004','7035','CY','39049','2007-10-08','M','',':RET:2054-5','N','021','DEN','1671017','99734OH005000401','2014-01-01','2013-12-16 22:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 06:00:12'),(16783,13424,'Y','18','021','EC','A','','','AC','0000336439','0000336439','OH00002333142','IL','1','Hill','Donald','','','','34','291600768','606 DURANGO DR',0,'TOLEDO','OH','43609','1706','CY','39095','1977-06-22','M','M',':RET:2106-3','N','021','HLT','1440000','92036OH004002601','2014-02-01','2014-01-07 13:26:37','0.00',NULL,NULL,'192.86','192.86','R-OH001','OH0','192.86',NULL,0,'2014-01-08 18:25:06'),(18303,14612,'N','01','021','EC','A',NULL,NULL,'','0000942012','0000523434','','IL','1','Nicholson','Jason','E','','','34','295806279','4330 N ST RT 61',0,'Sunbury','OH','43074',NULL,'CY','39041','1972-04-15','M','',':RET:2106-3','N','021','DEN','2014848','99734OH005000401','2014-02-01','2014-01-15 10:35:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:44:57'),(18527,14774,'Y','18','021','EC','A','','','AC','0000656585','0000656585','TX00001800799','31','1','VAN ZANT','MARY','','','','34','466333857','PO BOX',0,'DALEHART','TX','79022',NULL,'CY','48205','1958-09-24','F','M',':RET:2106-3','N','021','DEN','2192778','33348TX002000101','2014-02-01','2014-01-15 17:21:14','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-16 08:46:41'),(20150,16079,'N','01','021','EC','A',NULL,NULL,'','0000029078','0001054242','','IL','1','CARPENTER','CHAD','','','','34','235257743','425 WESTWOOD DR',0,'STEUBENVILLE','OH','43953','3646','CY','39081','1976-03-04','M','',':RET:2106-3','N','021','DEN','3339293','99734OH005000301','2014-03-01','2014-01-26 20:21:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:01:03'),(20875,16683,'Y','18','021','EC','A','','','AC','0002362929','0002362929','LA00002558225','IL','1','George','Lonnie','','','','34','439174172','3010 LULA AVE',0,'BATON ROUGE','LA','70802','2367','CY','22033','1960-08-05','M','U',':RET:2054-5','N','021','DEN','3281750','18575LA002000101','2014-03-01','2014-01-31 13:07:12','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-31 21:01:04'),(27586,21816,'Y','18','021','EC','A','','','AC','0000399766','0000399766','TX00002664684','IL','1','Pasaret','Adrian','','','','34','626200022','189 Commercial PMB',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1967-03-05','M','U',':RET:2106-3','T','021','DEN','2988365','33348TX002000201','2014-04-01','2014-03-05 12:23:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-05 21:00:14'),(28684,22700,'Y','18','021','EC','A','','','AC','0001132221','0001132221','TX00003100023','31','1','Riddlespurger','Monica','','','','34','639075148','Po Box 51183',0,'Amarillo','TX','79159',NULL,'CY','48375','1985-12-21','F','M',':RET:2106-3','T','021','DEN','3452552','33348TX002000101','2014-04-01','2014-03-08 16:15:49','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2014-03-08 21:30:58'),(29076,23013,'Y','18','021','EC','A','','','AC','0000890776','0000890776','MS00003338660','IL','1','LOWMAN','TREASEA','','','','34','410474373','385 NAIL RD',0,'SOUTHAVEN','MS','38671',NULL,'CY','28033','1967-10-01','F','M',':RET:2106-3','N','021','DEN','4183915','46300MS002000101','2014-04-01','2014-03-09 23:42:31','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2014-03-10 21:02:00'),(21435,17132,'Y','18','021','EC','A','','','AC','0000505695','0000505695','TX00002612538','IL','1','Broadhead','Timothy','','','','34','425043983','811 Bradford Avenue',0,'Kemah','TX','77565',NULL,'CY','48167','1958-03-26','M','R',':RET:2106-3','T','021','DEN','3680889','33348TX002000101','2014-03-01','2014-02-04 17:27:54','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-04 21:01:20'),(799,660,'Y','18','021','EC','A','','','AC','0001257939','0001257939','TX00001003383','IL','1','GROSS','KAREN','','','','34','044724851','2015 Riverview St',0,'Austin','TX','78702',NULL,'CY','48453','1978-11-26','F','U',':RET:2106-3','N','021','DEN','1359408','33348TX002000201','2014-01-01','2013-12-16 16:56:31','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:05:31'),(19892,15866,'Y','18','021','EC','A','','','AC','0001080362','0001080362','OH00001430248','IL','1','Haehn','Susan','K','','','34','300527211','9241 BOCKEY RD',0,'DELPHOS','OH','45833','8833','CY','39161','1952-08-15','F','M',':RET:2106-3','N','021','HLT','2891636','92036OH005001505','2014-03-01','2014-01-23 20:03:59','598.81',NULL,NULL,'618.46','19.65','R-OH002','OH0','618.46',NULL,0,'2014-01-24 21:00:51'),(3801,3047,'Y','18','021','EC','A','','','AC','0000304700','0000304700','OH00001286734','IL','1','DICKERSON','DARLENE','','','','34','280567389','5434 FOX RD',0,'CINCINNATI','OH','45239',NULL,'CY','39061','1958-02-22','F','M',':RET:2054-5','N','021','DEN','938693','99734OH005000301','2014-01-01','2013-12-13 12:39:19','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:31'),(17850,14259,'Y','18','021','EC','A','','','AC','0001179645','0001179645','OH00002004791','IL','1','OGLESBY','DONNA','M','','','34','286645220','1012 ROSELAND AVE',0,'DAYTON','OH','45402','4120','CY','39113','1967-07-25','F','U',':RET:2054-5','T','021','DEN','2589346','99734OH005000401','2014-02-01','2014-01-14 09:57:58','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:06'),(9770,7737,'Y','18','021','EC','A','','','AC','0000621081','0000621081','OH00000378051','IL','1','Geib','Ella','','','','34','293626587','5807 TROY VILLA BLVD',0,'DAYTON','OH','45424','2649','CY','39113','1962-09-02','F','M',':RET:2106-3','N','021','DEN','887236','99734OH005000401','2014-01-01','2013-10-21 11:50:51','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 05:00:26'),(13056,10408,'Y','18','021','EC','A','','','AC','0000530677','0000530677','OH00000955500','IL','1','BUCHER','LINDA','','','','34','302464616','1256 TIMBERCREEK DR',0,'HAMILTON','OH','45013','9318','CY','39017','1949-11-25','F','M',NULL,'N','021','DEN','2532414','99734OH005000401','2014-01-01','2013-12-23 09:14:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:57'),(16876,13503,'Y','18','021','EC','A','','','AC','0001120731','0001120731','TX00001955339','IL','1','hibbitts','jeffery','','','','34','467887491','909 s. main',0,'eldorado','TX','76936',NULL,'CY','48413','1950-11-07','M','M',':RET:2106-3','N','021','DEN','2025167','33348TX002000201','2014-02-01','2014-01-08 19:20:44','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:18'),(24471,19439,'Y','18','021','EC','A','','','AC','0001044526','0001044526','OH00002516512','IL','1','RONG','YUE YUAN','','','','34','370155947','22693 RIVER CHASE LN',0,'DEFIANCE','OH','43512','6870','CY','39039','1963-10-15','F','U',':RET:2034-7^:RET:2028-9','N','021','HLT','3139671','92036OH004002601','2014-04-01','2014-02-18 13:24:32','76.00',NULL,NULL,'280.03','204.03','R-OH001','OH0','280.03',NULL,0,'2014-02-18 22:01:38'),(25049,19865,'Y','18','021','EC','A','','','AC','0000542737','0000542737','OH00002092136','IL','1','Williams','Russell','','','','34','294741172','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','1975-11-08','M','M',':RET:2106-3','N','021','DEN','3426767','99734OH005000401','2014-04-01','2014-02-19 22:05:20','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:16'),(25168,19963,'Y','18','024','14','A','','','TE','0000595190','0000595190','','IL','1','Cotruta','Gabriel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-08-19','M','',NULL,NULL,NULL,'','2726837','','2014-02-21','2014-02-21 09:27:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-21 22:00:26'),(27008,21391,'Y','18','024','14','A','','','TE','0000614154','0000614154','','IL','1','Gay','Rodney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-26','M','',NULL,NULL,NULL,'','3234618','','2014-03-31','2014-03-03 14:46:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:05'),(28796,22794,'Y','18','021','EC','A','','','AC','0000720313','0000720313','OH00003237085','IL','1','Ebert','Jessica','Meghan','','','34','295903367','147 W WATERLOO ST',0,'CANAL WINCHESTER','OH','43110','1012','CY','39049','1988-08-06','F','M',':RET:2106-3','T','021','DEN','4065110','99734OH005000301','2014-05-01','2014-03-08 21:35:40','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-09 21:00:45'),(21825,17427,'N','01','021','EC','A',NULL,NULL,'','0000825672','0000830605','','IL','1','Wade','Rebecca','','','','34','631109429','15994 COUNTY ROAD 3138',0,'LINDALE','TX','75771','7358','CY','48423','1984-12-13','F','',':RET:2106-3','N','021','DEN','3697795','33348TX002000101','2014-03-01','2014-02-06 09:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-06 21:01:01'),(882,730,'Y','18','021','EC','A','','','AC','0001243624','0001243624','MS00001342745','IL','1','EDWARDS','JB','','','Jr','34','587440665','2065 SKY FARM AVE',0,'VICKSBURG','MS','39183',NULL,'CY','28149','1951-10-20','M','M',':RET:2054-5','N','021','DEN','1850659','46300MS002000201','2014-01-01','2013-12-16 17:45:28','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:07:45'),(3251,2621,'Y','18','021','EC','A','','','AC','0000261459','0000261459','OH00000583193','IL','1','fife','susan','','','','34','592241985','5021 ANGELITA AVE',0,'HUBER HEIGHTS','OH','45424','2704','CY','39113','1971-04-12','F','U',':RET:2106-3','N','021','DEN','846323','99734OH005000401','2014-01-01','2013-11-28 17:43:03','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:46:38'),(21241,16972,'Y','18','024','14','A','','','TE','0000054443','0000054443','','IL','1','Jolliff','Heather','Renee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-15','F','',NULL,NULL,NULL,'','364254','','2014-02-03','2014-02-03 13:58:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:13'),(20124,16057,'Y','18','021','EC','A','','','AC','0000330913','0000330913','OH00001639205','IL','1','MCCONNELL','JENNIFER','','','','34','289485425','5605 HAMILTON AVE',0,'CINCINNATI','OH','45224','3195','CY','39061','1952-03-18','F','U',':RET:2054-5','N','021','DEN','3431239','99734OH005000401','2014-03-01','2014-01-27 10:20:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:00:48'),(19046,15169,'Y','18','021','EC','A','','','AC','0000177660','0000177660','OH00001476599','IL','1','Kramer','Kevin','','','','34','292548616','2139 Rood St',0,'Toledo','OH','43613',NULL,'CY','39095','1959-03-16','M','M',':RET:2106-3','N','021','HLT','1660012','92036OH006002601','2014-03-01','2014-01-17 17:34:40','257.00',NULL,NULL,'330.16','73.16','R-OH001','OH0','330.16',NULL,0,'2014-01-20 08:06:40'),(18616,14840,'Y','18','024','14','A','','','TE','0001130241','0001130241','','IL','1','Ramirez Francis','Sacha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-28','F','',NULL,NULL,NULL,'','1492777','','2014-01-15','2014-01-15 15:30:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:47:26'),(3664,2931,'Y','18','021','EC','A','','','AC','0000357173','0000357173','OH00000281326','IL','1','Orf','Raymond','Joseph','','','34','493805920','1581 MEADOW POND CT',0,'DAYTON','OH','45458',NULL,'CY','39113','1970-12-07','M','M',':RET:2106-3','N','021','DEN','998018','99734OH005000401','2014-01-01','2013-12-12 20:29:09','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:30:58'),(4684,3713,'Y','18','021','EC','A','','','AC','0000934959','0000934959','LA00000885551','IL','1','BRIDGES','SUSAN','','','','34','436828975','247 CARDINAL ST',0,'LA PLACE','LA','70068',NULL,'CY','22095','1952-12-13','F','U',NULL,'N','021','DEN','80557','18575LA002000201','2014-01-01','2013-12-12 18:11:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:07:59'),(18083,14442,'Y','18','021','EC','A','','','AC','0001852462','0001852462','LA00001531407','IL','1','HILTUNEN','ASHLEY','','','','34','324885251','4426 KING ST',0,'METAIRIE','LA','70001','4632','CY','22051','1992-09-23','F','U',NULL,'N','021','DEN','1428899','18575LA002000201','2014-02-01','2014-01-14 11:28:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:27'),(9250,7334,'Y','18','021','EC','A','','','AC','0000271414','0000271414','OH00000885805','IL','1','Rammel','Jared','','','','34','286885633','116 E RACE ST',0,'MECHANICSBURG','OH','43044','1024','CY','39021','1975-01-14','M','M',':RET:2106-3','T','021','HLT','2259954','92036OH006000501','2014-01-01','2013-12-18 17:20:42','0.00',NULL,NULL,'270.14','270.14','R-OH003','OH0','270.14',NULL,0,'2013-12-26 04:10:47'),(22326,17827,'Y','18','021','EC','A','','','AC','0001736408','0001736408','LA00002419133','IL','1','Frugoli','Geno','','','','34','530029894','46180 Patti Rd',0,'Hammond','LA','70401',NULL,'CY','22105','1968-04-19','M','U',':RET:2106-3','N','021','DEN','3162101','18575LA002000201','2014-03-01','2014-01-29 19:28:19','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 11:00:57'),(23179,18480,'Y','18','021','EC','A','','','AC','0001066435','0001066435','MS00002704231','IL','1','WEBB','GEORGE','ADAM','','','34','425736569','2105 GRASS POND RD',0,'HERNANDO','MS','38632','9446','CY','28033','1988-12-29','M','U',':RET:2054-5','N','021','DEN','3655488','46300MS002000101','2014-03-01','2014-02-11 21:30:50','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-12 21:31:57'),(26185,20766,'Y','18','021','EC','A','','','AC','0000092571','0000092571','OH00002615257','IL','1','BARNHARD','JAMES','','','','34','286647722','12852 CHERRY LN',0,'CHESTERLAND','OH','44026','3021','CY','39055','1973-07-19','M','U',NULL,'N','021','DEN','3870129','99734OH005000301','2014-04-01','2014-02-27 10:34:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:42'),(27879,22054,'Y','18','024','14','A','','','TE','0000702833','0000702833','','IL','1','Brockman','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-19','M','',NULL,NULL,NULL,'','3589871','','2014-03-05','2014-03-05 17:05:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:31'),(1116,919,'Y','18','021','EC','A','','','AC','0000555343','0000555343','OH00000794006','IL','1','Staten','Dee','','','','34','282766597','2226 SPRUCEWOOD DR',0,'MANSFIELD','OH','44903','9644','CY','39139','1964-11-19','F','U',':RET:2106-3','N','021','DEN','980708','99734OH005000401','2014-01-01','2013-12-03 17:44:42','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 18:17:39'),(7241,5741,'N','01','021','EC','A',NULL,NULL,'','0000377848','0000119710','','IL','1','Webster','MIchael','','','','34','434172251','8806 WESTBROOK PL',0,'SHREVEPORT','LA','71108','6024','CY','22017','1959-01-29','M','',NULL,'N','021','DEN','177405','18575LA002000201','2014-01-01','2013-12-14 10:42:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 02:01:40'),(20330,16233,'Y','18','021','EC','A','','','AC','0000639556','0000639556','OH00002035077','IL','1','breisinger','tina','','','','34','300666690','5178 st rt 634',0,'continental','OH','45831',NULL,'CY','39137','1960-09-14','F','M',':RET:2106-3','N','021','HLT','2820061','92036OH001001501','2014-03-01','2014-01-27 20:44:04','310.00',NULL,NULL,'541.56','231.56','R-OH002','OH0','541.56',NULL,0,'2014-01-28 21:01:01'),(2878,2326,'Y','18','021','EC','A','','','AC','0000339904','0000339904','TX00001226354','IL','1','NAGEL','KATHERINE','KAY','','','34','459022533','718 MCCURDY RD',0,'CUERO','TX','77954','6339','CY','48123','1951-08-16','F','U',NULL,'N','021','DEN','665899','33348TX002000201','2014-01-01','2013-10-08 09:28:56','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:02:09'),(6116,4850,'Y','18','021','EC','A','','','AC','0000706161','0000706161','OH00001078108','IL','1','Micozzi','Sylvia','','','','34','162448889','3782 ALBRECHT AVE',0,'AKRON','OH','44312','3618','CY','39153','1952-10-02','F','U',NULL,'N','021','HLT','194982','52664OH151001305','2014-01-01','2013-11-21 12:12:36','511.00',NULL,NULL,'626.65','115.65','R-OH012','OH0','626.65',NULL,0,'2013-12-26 00:15:37'),(5898,4674,'N','19','021','EC','A',NULL,NULL,'','0001071787','0000813086','','S1','1','Clark','DeShon','','','','34','275159759','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','2009-02-11','F','',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:44'),(5863,4653,'N','01','021','EC','A',NULL,NULL,'','0000186118','0000954304','','IL','1','Harper','Johnna','Sheri','','','34','270581237','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1968-10-16','F','',':RET:2106-3','N','021','HLT','1829936','92036OH005002606','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.58',NULL,0,'2013-12-25 23:49:02'),(16954,13570,'Y','18','021','EC','A','','','AC','0000735043','0000735043','OH00001526234','IL','1','Omillian','Steve','','','','34','273665967','2390 County Road 43',0,'Republic','OH','44867',NULL,'CY','39147','1958-11-15','M','U',NULL,'N','021','HLT','1859184','92036OH005002705','2014-02-01','2014-01-08 18:35:04','366.00',NULL,NULL,'434.84','68.84','R-OH006','OH0','434.84',NULL,0,'2014-01-13 02:20:02'),(4199,3339,'Y','18','021','EC','A','','','AC','0000972728','0000972728','OH00000466927','IL','1','HAMM','JOAN','','','','34','287584642','63 ASBURY LN',0,'ELYRIA','OH','44035','0804','CY','39093','1958-05-26','F','U',':RET:2106-3','N','021','HLT','2312695','52664OH151001305','2014-01-01','2013-12-17 16:58:48','350.00',NULL,NULL,'560.89','210.89','R-OH011','OH0','560.89',NULL,0,'2013-12-25 21:49:49'),(16190,12962,'Y','18','021','EC','A','','','AC','0000381545','0000381545','TX00001146556','IL','1','NGUYEN','THUY','THI','','','34','535534751','449 SAND VERBENA ST',0,'EL PASO','TX','79928','5570','CY','48141','1971-05-02','F','M',':RET:2047-9','N','021','DEN','2292513','33348TX002000201','2014-02-01','2014-01-04 00:16:14','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-05 00:00:48'),(7398,5855,'Y','18','021','EC','A','','','AC','0000327239','0000327239','OH00000965639','IL','1','SOLOMON','MELINDA','LYNN','','','34','289961375','4086 PARKSIDE DR',0,'BROOKLYN','OH','44144','1316','CY','39035','1993-09-22','F','U',':RET:2106-3','N','021','DEN','141545','99734OH005000301','2014-01-01','2013-11-23 10:31:05','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2013-12-26 02:16:20'),(14933,11933,'Y','18','021','EC','A','','','AC','0000024629','0000024629','TX00000746685','IL','1','Schiller','Sander',NULL,NULL,NULL,NULL,NULL,'945 South  Mesa Hills Dr.',0,'El Paso','TX','79912',NULL,'CY','48141','1984-07-09','M','U',':RET:2106-3','N','021','DEN','1928125','33348TX002000101','2014-02-01','2013-12-29 17:06:12','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2013-12-30 00:02:05'),(9055,7184,'Y','18','021','EC','A','','','AC','0000260409','0000260409','TX00000338047','31','1','VAN DER WALL','GEOFFREY','','','','34','155704274','100 PROSPECTOR PASS',0,'GEORGETOWN','TX','78633',NULL,'CY','48453','1975-08-25','M','U',':RET:2106-3','N','021','DEN','2243902','33348TX002000101','2014-01-01','2013-12-17 22:03:50','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 04:06:09'),(1490,1243,'Y','18','021','EC','A','','','AC','0001173226','0001173226','OH00000674119','IL','1','Bascomb','Milton','Juan','','','34','290743494','880 East 105 St',0,'Cleveland','OH','44108',NULL,'CY','39035','1978-09-12','M','U',':RET:2054-5','N','021','DEN','2235591','99734OH005000401','2014-01-01','2013-12-24 11:17:00','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:00'),(20096,16033,'Y','18','021','EC','A','','','AC','0001902245','0001902245','LA00001374175','IL','1','Newton','Kaidismaris','','','','34','662033551','832 KENNON DR',0,'WINNSBORO','LA','71295','3427','CY','22041','1991-04-08','F','U',NULL,'N','021','DEN','2978564','18575LA002000201','2014-03-01','2014-01-27 10:25:06','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-27 21:00:32'),(6654,5277,'N','G8','021','EC','A',NULL,NULL,'','0000398578','0000470979','','IL','1','Susich','Wyatt','','','','34','625709881','6865 CLUBSIDE DR',0,'LOVELAND','OH','45140','6041','CY','39025','1993-06-25','M','',NULL,'N','021','DEN','386653','99734OH005000301','2014-01-01','2013-11-12 13:50:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:00:39'),(17780,14204,'Y','18','021','EC','A','','','AC','0000522785','0000522785','TX00001993665','IL','1','SADEGHBEGI','MEDI','','','','34','463777205','11152 WESTHEIMER RD',0,'HOUSTON','TX','77042','3208','CY','48201','1963-01-12','M','U',':RET:2106-3','N','021','DEN','1686484','33348TX002000101','2014-02-01','2014-01-13 17:24:03','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:42'),(16144,12931,'Y','18','021','EC','A','','','AC','0000315949','0000315949','OH00002273392','IL','1','SHEPPARD','MORGAN','','','','34','292827158','201 n high st',0,'leesburg','OH','45135',NULL,'CY','39071','1982-11-15','M','M',NULL,'N','021','HLT','1771729','92036OH005000605','2014-02-01','2014-01-03 15:22:43','234.00',NULL,NULL,'540.86','306.86','R-OH005','OH0','248.81',NULL,0,'2014-01-04 02:06:05'),(1753,1451,'Y','18','021','EC','A','','','AC','0000381138','0000381138','OH00001120558','IL','1','Jefferson','Harriet','','','','34','284460089','811 Heatherstone dr',0,'cincinnati','OH','45240',NULL,'CY','39061','1955-02-14','F','M',':RET:2054-5','N','021','DEN','2252738','99734OH005000301','2014-01-01','2013-12-24 12:40:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:55:46'),(13653,10892,'Y','18','021','EC','A','','','AC','0001267629','0001267629','LA00000761398','IL','1','Lazard','Leslie','','','','34','434953562','3000 Tulane Avenue Apt. 334',0,'New Orleans','LA','70119',NULL,'CY','22071','1985-11-12','F','U',':RET:2054-5','N','021','DEN','1686935','18575LA002000101','2014-01-01','2013-12-22 23:30:26','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:22'),(2817,2278,'Y','18','021','EC','A','','','AC','0000085143','0000085143','MS00000149793','IL','1','Parker','Wanda','Ann','','','34','426415354','147 Flag Chapel Circle',0,'Jackson','MS','39213',NULL,'CY','28049','1968-06-09','F','M',':RET:2054-5','N','021','DEN','621801','46300MS002000201','2014-01-01','2013-11-23 20:49:23','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 20:00:25'),(4241,3378,'Y','18','021','EC','A','','','AC','0000419032','0000419032','TX00000585932','IL','1','Whitney','Donald','','','','34','464897414','3417 DEEP VALLEY TRL',0,'PLANO','TX','75023','7930','CY','48085','1977-09-17','M','U',':RET:2106-3','N','021','DEN','1617140','33348TX002000201','2014-01-01','2013-12-17 16:03:32','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:51:02'),(23353,18609,'N','01','021','EC','A',NULL,NULL,'','0000373671','0000146930','','IL','1','Smith','Marie','Kyle',NULL,NULL,NULL,NULL,'4604 Garrett Dr',0,'Norton','OH','44203',NULL,'CY','39153','1965-07-29','F','',':RET:2106-3','N','021','HLT','2740488','52664OH151001304','2014-03-01','2014-02-13 13:48:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','364.62',NULL,0,'2014-02-13 22:00:42'),(25909,20544,'Y','18','021','EC','A','','','AC','0001258265','0001258265','TX00002926658','IL','1','FERNANDEZ','NATALY','','','','34','631106099','12010 VILLAGE GATE DR',0,'EL PASO','TX','79936','5569','CY','48141','1987-03-07','F','U',NULL,'N','021','DEN','2878532','33348TX002000201','2014-04-01','2014-02-26 14:39:49','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-26 21:01:13'),(1423,1185,'Y','18','021','EC','A','','','AC','0001387226','0001387226','LA00000244937','IL','1','verdon','june','','','','34','433984839','1451 GRANADA DR',0,'NEW ORLEANS','LA','70122',NULL,'CY','22071','1957-12-02','F','U',NULL,'N','021','DEN','2023525','18575LA002000201','2014-01-01','2013-12-24 15:25:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:18'),(15206,12152,'N','01','021','EC','A',NULL,NULL,'','0000633298','0001228277','','IL','1','Jones','Walter','','','','34','321460672','2425 HWY 84',0,'Meadville','MS','39653',NULL,'CY','28037','1951-07-23','M','',':RET:2054-5','N','021','DEN','1974619','46300MS002000201','2014-02-01','2013-12-30 15:14:38',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-01 12:07:33'),(7805,6182,'Y','18','021','EC','A','','','AC','0000198992','0000198992','TX00001214603','IL','1','hunt','colburn','','','','34','382545975','1310 terrance dr. apt 2',0,'killeen','TX','76541',NULL,'CY','48027','1951-05-06','M','U',':RET:2054-5','T','021','DEN','1547449','33348TX002000201','2014-01-01','2013-12-20 16:50:04','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 03:03:47'),(18751,14940,'Y','18','021','EC','A','','','AC','0000280860','0000280860','OH00002406113','IL','1','Donato','Lisa','','','','34','297668184','24261 COUNTY ROAD M',0,'FAYETTE','OH','43521','9526','CY','39051','1965-03-29','F','M',':RET:2106-3','N','021','HLT','2892978','92036OH005002601','2014-02-01','2014-01-15 21:34:39','24.00',NULL,NULL,'318.82','294.82','R-OH001','OH0','318.82',NULL,0,'2014-01-17 03:35:43'),(18791,14967,'Y','18','021','EC','A','','','AC','0000243766','0000243766','OH00001672299','IL','1','Licursi','Vincent','','','','34','289484129','1764 Maple Hill Dr',0,'Hinckley','OH','44233',NULL,'CY','39103','1951-08-01','M','U',':RET:2106-3','N','021','DEN','2571378','99734OH005000401','2014-02-01','2014-01-15 23:11:51','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:35:56'),(19596,15622,'Y','18','021','EC','A','','','AC','0000050715','0000050715','OH00002344272','IL','1','CONTI','FRANCO','','','','34','278500559','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1959-12-19','M','M',':RET:2106-3','N','021','HLT','3307000','52664OH151001501','2014-03-01','2014-01-22 14:09:01','392.00',NULL,NULL,'1259.44','867.44','R-OH011','OH0','644.05',NULL,0,'2014-01-23 03:02:46'),(20569,16439,'Y','18','021','EC','A','','','AC','0000568056','0000568056','OH00001838084','31','1','day','virgnia','','','','34','269568353','2103 traverse creek dr',0,'Milford','OH','45150',NULL,'CY','39071','1954-09-06','F','M',':RET:2106-3','N','021','HLT','2857384','92036OH004000601','2014-03-01','2014-01-29 15:45:31','446.04',NULL,NULL,'449.32','3.28','R-OH005','OH0','449.32',NULL,0,'2014-01-29 21:01:51'),(20647,16499,'Y','18','021','EC','A','','','AC','0000157902','0000157902','TX00001560417','IL','1','DAVIS','CRAIG','','','','34','549412938','8304 MAGNETIC ST',0,'EL PASO','TX','79904',NULL,'CY','48141','1962-07-10','M','M',NULL,'N','021','DEN','3179459','33348TX002000201','2014-03-01','2014-01-30 14:25:32','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-30 21:00:36'),(25174,19968,'Y','18','021','EC','A','','','AC','0000731247','0000731247','OH00002169651','IL','1','bowden','kevin','a','','','34','293868979','13725 LAKEWOOD HEIGHTS BLVD',0,'CLEVELAND','OH','44107','6155','CY','39035','1985-07-11','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3354184','99734OH005000401','2014-04-01','2014-02-20 18:33:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:29'),(27388,21685,'Y','18','021','EC','A','','','AC','0001022848','0001022848','OH00003637391','IL','1','GROVE','JAMES','','','','34','282788433','11272 LOCKPORT CT',0,'CINCINNATI','OH','45240','2327','CY','39061','1966-01-24','M','M',NULL,'N','021','DEN','3970596','99734OH005000301','2014-04-01','2014-03-03 18:08:48','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-03-04 21:01:26'),(27417,21697,'N','19','021','EC','A',NULL,NULL,'','0000585592','0000007043','','IL','1','Manning','Alyssa','','','','34','286081444','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','2003-06-24','F','',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:37'),(28626,22654,'Y','18','021','EC','A','','','AC','0000055677','0000055677','TX00003827263','IL','1','ALLEN','DETAYNISHA','','','','34','452698644','9700 LEAWOOD BLVD',0,'HOUSTON','TX','77099','2531','CY','48201','1983-09-22','F','U',NULL,'N','021','DEN','4263643','33348TX002000201','2014-04-01','2014-03-08 11:04:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-08 21:30:24'),(345,282,'Y','18','021','EC','A','','','AC','0000456483','0000456483','OH00000626502','IL','1','Beard','Rochelle','','','','34','277820840','3730 warrensville ctr rd',0,'shaker','OH','44122',NULL,'CY','39035','1968-10-15','F','U',':RET:2054-5','N','021','DEN','642591','99734OH005000401','2014-01-01','2013-11-09 14:26:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:32:04'),(16147,12932,'N','19','021','EC','A',NULL,NULL,'','0000532115','0000258172','','IL','1','wallbridge','evelyn','rose',NULL,NULL,NULL,NULL,'527 S REVERE RD',0,'CINCINNATI','OH','45255','5085','CY','39025','2011-05-08','F','',':RET:2106-3','N','021','HLT','1372273','92036OH001000601','2014-02-01','2014-01-03 15:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2014-01-04 02:06:10'),(6407,5078,'Y','18','021','EC','A','','','AC','0001012907','0001012907','OH00000072558','IL','1','Elliott','Candice','','','','34','281540073','10931 ROAD 87',0,'PAULDING','OH','45879','9166','CY','39125','1953-02-16','F','U',':RET:2106-3','N','021','DEN','905342','99734OH005000301','2014-01-01','2013-12-11 18:13:12','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:48:30'),(671,553,'Y','18','021','EC','A','','','AC','0000939732','0000939732','OH00001036297','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',':RET:2106-3','N','021','DEN','1811842','99734OH005000301','2014-01-01','2013-12-16 09:53:00','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:02:07'),(13888,11077,'Y','18','021','EC','A','','','AC','0000167757','0000167757','OH00000770929','IL','1','Hall','Erica','','','','34','272905591','5563 Trinity Rd',0,'Defiance','OH','43512',NULL,'CY','39039','1983-11-15','F','U',':RET:2106-3','N','021','HLT','1492262','92036OH005002606','2014-01-01','2013-12-22 20:42:37','146.00',NULL,NULL,'221.32','75.32','R-OH001','OH0','221.32',NULL,0,'2013-12-26 13:13:23'),(9510,7542,'Y','18','021','EC','A','','','AC','0000550064','0000550064','OH00000358630','IL','1','Kinkade','Debra','','','','34','276740794','2241 OPossum Hollow RD',0,'Newark','OH','43055',NULL,'CY','39089','1967-05-12','F','M',':RET:2106-3','N','021','DEN','1975287','99734OH005000401','2014-01-01','2013-12-21 16:25:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:35:23'),(6943,5513,'Y','18','024','14','A','','','TE','0000948420','0000948420','','IL','1','Colagross','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-05-19','F','',NULL,NULL,NULL,'','2340091','','2013-12-24','2013-12-24 20:29:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:46:50'),(8091,6406,'Y','18','021','EC','A','','','AC','0001030369','0001030369','OH00000433364','IL','1','Wooton','Jonathan','','','','34','295941336','1912 PARKAMO AVE',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','1247','CY','39017','1990-02-18','M','U',':RET:2106-3','N','021','HLT','1381796','92036OH002001201','2014-01-01','2013-12-20 15:29:45','49.00',NULL,NULL,'247.90','198.90','R-OH004','OH0','247.90',NULL,0,'2013-12-26 03:10:41'),(19055,15178,'Y','18','021','EC','A','','','AC','0000807806','0000807806','MS00001677845','IL','1','butler','christy','','','','34','427498597','304 S VICTORIA AVE',0,'CLEVELAND','MS','38732','3236','CY','28011','1969-04-28','F','U',':RET:2106-3','N','021','DEN','2462935','46300MS002000201','2014-03-01','2014-01-17 18:25:02','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-21 08:44:11'),(19632,15646,'N','19','021','EC','A',NULL,NULL,'','0001210955','0001245625','','IL','1','HART','JAMES','','','','34','268046521','104 CHARTERHOUSE CT',0,'POWELL','OH','43065','9119','CY','39041','1998-07-10','M','',':RET:2106-3','N','021','DEN','2685574','99734OH005000401','2014-03-01','2014-01-23 10:36:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:09'),(20115,16049,'Y','18','021','EC','A','','','AC','0000559467','0000559467','OH00001698027','IL','1','Hancock','Ryan',NULL,NULL,NULL,NULL,NULL,'5347 Belclare rd',0,'Cincinnati','OH','45247',NULL,'CY','39061','1983-04-02','M','U',':RET:2106-3','N','021','DEN','3366279','99734OH005000401','2014-03-01','2014-01-26 20:54:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:00:42'),(22016,17577,'Y','18','021','EC','A','','','AC','0000168924','0000168924','OH00001972776','IL','1','Robbins','Michelle','','','','34','278861342','4498 GREEN MEADOWS DR',0,'ENON','OH','45323','1728','CY','39023','1972-11-01','F','U',NULL,'N','021','HLT','3650058','92036OH004000501','2014-03-01','2014-02-06 19:20:48','57.00',NULL,NULL,'248.86','191.86','R-OH003','OH0','248.86',NULL,0,'2014-02-07 19:00:55'),(23677,18853,'Y','18','021','EC','A','','','AC','0001601673','0001601673','LA00002000626','IL','1','Stewart','Cynthia','','','','34','440704476','5306 Richard Avenue',0,'Alexandria','LA','71302',NULL,'CY','22079','1961-01-24','F','U',':RET:2054-5','N','021','DEN','3444476','18575LA002000201','2014-03-01','2014-02-14 11:24:40','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-14 21:30:28'),(24040,19118,'Y','18','021','EC','A','','','AC','0000753431','0000753431','OH00001713400','IL','1','Hillman','Joyce','L','','','34','330501740','2061 N BAILEY RD',0,'NORTH JACKSON','OH','44451','9643','CY','39099','1951-11-23','F','U',':RET:2106-3','N','021','DEN','3787491','99734OH005000301','2014-03-01','2014-02-15 10:37:12','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-15 22:00:58'),(24256,19261,'Y','18','021','EC','A','','','AC','0000617727','0000617727','TX00002441719','IL','1','Rodriguez','Karla','','','','34','452636466','3632 SANDY PLATEAU CIR',0,'EL PASO','TX','79936','0759','CY','48141','1977-12-14','F','U',':RET:2106-3','N','021','DEN','3825694','33348TX002000201','2014-04-01','2014-02-16 20:23:07','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-17 19:00:07'),(24432,19408,'Y','18','021','EC','A','','','AC','0000524538','0000524538','OH00002621236','IL','1','Theodore','Susan','','','','34','280720866','889 ROBINSON AVE',0,'BARBERTON','OH','44203','3850','CY','39153','1960-12-31','F','M',':RET:2106-3','N','021','HLT','3674864','52664OH151001305','2014-04-01','2014-02-18 13:51:29','408.00',NULL,NULL,'738.16','330.16','R-OH012','OH0','454.94',NULL,0,'2014-02-18 22:01:14'),(27969,22127,'Y','18','021','EC','A','','','AC','0001510426','0001510426','LA00003122990','IL','1','Castille','Peggy','B','','','34','438885736','1515 CARMEL DR',0,'LAFAYETTE','LA','70501','5307','CY','22055','1952-03-19','F','M',':RET:2106-3','N','021','DEN','2643272','18575LA002000201','2014-04-01','2014-03-06 11:24:59','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-06 21:00:49'),(6059,4800,'Y','18','021','EC','A','','','AC','0000235175','0000235175','OH00000326474','IL','1','Lawhon','Vickie','','','','34','289527553','1146 BISHOP AVE',0,'HAMILTON','OH','45015','2124','CY','39017','1967-12-31','F','U',':RET:2106-3','N','021','DEN','47173','99734OH005000401','2014-01-01','2013-12-01 09:35:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:01:53'),(15417,12333,'Y','18','021','EC','A','','','AC','0000723953','0000723953','TX00001702403','IL','1','LARA','NANCY','','','','34','466492325','69 HORSESHOE LAKE RD',0,'HUNTSVILLE','TX','77320','0413','CY','48471','1975-10-27','F','M',NULL,'N','021','DEN','2141519','33348TX002000201','2014-02-01','2013-12-31 10:36:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:20'),(2001,1640,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000241540','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','566090','33348TX002000101','2014-01-01','2013-11-19 23:08:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:02:11'),(17891,14290,'Y','18','021','EC','A','','','AC','0001043412','0001043412','OH00002365485','IL','1','Harnish','Elana','','','','34','302909369','4886 RITTER RD',0,'BELLVILLE','OH','44813','9225','CY','39139','1989-12-23','F','U',':RET:2106-3','N','021','DEN','2285131','99734OH005000401','2014-02-01','2014-01-14 15:49:22','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-01-15 02:06:20'),(19235,15327,'Y','18','021','EC','A','','','AC','0000165111','0000165111','OH00001690167','IL','1','Wilson','Megan','','','','34','282822500','1177 Lake Meadow Court',0,'Lebanon','OH','45036',NULL,'CY','39165','1981-07-01','F','U',':RET:2106-3','N','021','DEN','2728672','99734OH005000301','2014-03-01','2014-01-20 08:25:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-21 08:46:35'),(20044,15985,'Y','18','021','EC','A','','','AC','0001118749','0001118749','OH00001445007','IL','1','Fries','Megan','','','','34','277908287','206 CEDAR LN',0,'WATERVILLE','OH','43566','1101','CY','39095','1983-07-02','F','R',':RET:2106-3','T','021','HLT','1547123','92036OH006002601','2014-03-01','2014-01-26 11:41:29','0.00',NULL,NULL,'201.85','201.85','R-OH001','OH0','201.85',NULL,0,'2014-01-26 19:00:29'),(24681,19590,'Y','18','024','14','A','','','TE','0000277949','0000277949','','IL','1','Rivas','Sergio',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-24','M','',NULL,NULL,NULL,'','3820792','','2014-02-18','2014-02-18 23:03:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-20 04:30:40'),(25698,20388,'N','01','021','EC','A',NULL,NULL,'','0000885106','0000473346','','IL','1','PATEL','CHEPNA','','','','34','642448148','1213 E US HIGHWAY 80',0,'MINEOLA','TX','75773','5067','CY','48499','1971-04-24','F','',NULL,'N','021','DEN','3280778','33348TX002000201','2014-04-01','2014-02-24 09:30:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:17'),(26474,20998,'N','01','021','EC','A',NULL,NULL,'','0001934491','0002072562','','IL','1','Mitchell','Beatrice','','','','34','438238178','313 Belinda',0,'Gramercy','LA','70052',NULL,'CY','22093','1959-01-20','F','',NULL,'N','021','DEN','2724786','18575LA002000101','2014-04-01','2014-02-27 15:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02','CIC',0,'2014-02-28 07:30:38'),(27364,21670,'Y','18','021','EC','A','','','AC','0000913017','0000913017','OH00003417513','IL','1','Davis','Joann','','','','34','291468978','1310 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44223','2431','CY','39153','1949-12-20','F','U',':RET:2106-3','N','021','DEN','3750940','99734OH005000401','2014-04-01','2014-03-04 17:45:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-04 21:01:12'),(734,608,'N','01','021','EC','A',NULL,NULL,'','0000029413','0000254577','','IL','1','Rocha','Siria','','','','34','450796767','425 MAJESTIC MOUNTAIN DR',0,'EL PASO','TX','79912','6301','CY','48141','1973-05-04','F','',':RET:2106-3','N','021','DEN','337460','33348TX002000201','2014-01-01','2013-12-15 19:59:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:03:53'),(15730,12582,'Y','18','021','EC','A','','','AC','0001077749','0001077749','OH00000827348','IL','1','Madubata','Ugochi','','','','34','215270169','1442 ROBINWOOD AVE',0,'LAKEWOOD','OH','44107','4533','CY','39035','1987-12-20','F','U',':RET:2054-5','N','021','DEN','2087529','99734OH005000301','2014-02-01','2014-01-02 06:13:15','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:00:28'),(13705,10935,'Y','18','021','EC','A','','','AC','0000060265','0000060265','OH00000589022','IL','1','Kinney','Gregory','','','','34','293626408','3121 WATTOVA RD NW',0,'MASSILLON','OH','44646','3076','CY','39151','1960-09-05','M','M',NULL,'N','021','HLT','2087159','52664OH151001301','2014-01-01','2013-12-23 13:02:40','423.00',NULL,NULL,'890.25','467.25','R-OH015','OH0','454.94',NULL,0,'2013-12-26 13:08:48'),(931,770,'N','01','021','EC','A',NULL,NULL,'','0000242668','0000634775','','IL','1','Saidy-Daffeh','Denae','Christina','','','34','471989153','5697 Forest Ash Lane',0,'Columbus','OH','43229',NULL,'CY','39049','1980-10-21','F','',':RET:2106-3','N','021','DEN','20982','99734OH005000401','2014-01-01','2013-10-29 00:24:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:05'),(15262,12200,'Y','18','021','EC','A','','','AC','0001092138','0001092138','OH00001315388','IL','1','Keflar','Ronald','','','Jr','34','235171899','328 danville pike',0,'hilsborough','OH','45133',NULL,'CY','39071','1980-03-21','M','M',':RET:2106-3','T','021','HLT','2453320','92036OH004000601','2014-02-01','2013-12-30 18:00:47','130.00',NULL,NULL,'237.80','107.80','R-OH005','OH0','237.80',NULL,0,'2014-01-01 12:09:18'),(4062,3245,'Y','18','021','EC','A','','','AC','0000785775','0000785775','OH00000004160','IL','1','cravin/jado','nancy','marie','','','34','332583155','po box 44303',0,'cleveland','OH','44144',NULL,'CY','39035','1956-11-10','F','U',':RET:2054-5','N','021','DEN','2594975','99734OH005000401','2014-01-01','2013-12-17 16:03:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:42'),(7219,5722,'Y','18','021','EC','A','','','AC','0000690707','0000690707','OH00000201400','IL','1','Sarisky','Michael','','','','34','298441448','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1954-05-03','M','M',':RET:2106-3','N','021','DEN','1130861','99734OH005000401','2014-01-01','2013-12-14 12:12:07','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:01:06'),(7202,5706,'N','01','021','EC','A',NULL,NULL,'','0000500385','0000301865','','IL','1','Powell','Gerald','','','','34','275683327','209 WILTON DR',0,'WEST UNION','OH','45693','9623','CY','39001','1972-02-09','M','',':RET:2106-3','T','021','DEN','14266','99734OH005000401','2014-01-01','2013-12-13 18:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:40'),(5195,4121,'Y','18','021','EC','A','','','AC','0000960590','0000960590','OH00001239203','IL','1','Mathis','Leiann','','','','34','590769122','1347 Symmes Rd.',0,'Fairfield','OH','45014',NULL,'CY','39017','1987-03-06','F','M',':RET:2106-3','N','021','DEN','1485965','99734OH005000401','2014-01-01','2013-12-19 13:52:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:52'),(4798,3802,'N','01','021','EC','A',NULL,NULL,'','0000034344','0000350553','','IL','1','Hammond','David','R','','','34','278743750','23310 E BAINTREE RD',0,'BEACHWOOD','OH','44122','1246','CY','39035','1966-11-24','M','',':RET:2106-3','N','021','HLT','730796','52664OH151001301','2014-01-01','2013-12-08 15:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','393.12',NULL,0,'2013-12-25 22:16:25'),(4263,3397,'Y','18','021','EC','A','','','AC','0001084135','0001084135','OH00001168589','IL','1','Whitman','John','','','','34','292422936','257 HOLLYWOOD AVE',0,'AKRON','OH','44313','6740','CY','39153','1957-01-25','M','M',':RET:2106-3','N','021','HLT','1677983','52664OH151001501','2014-01-01','2013-12-17 15:42:38','358.00',NULL,NULL,'1010.22','652.22','R-OH012','OH0','624.00',NULL,0,'2013-12-25 21:51:35'),(16515,13211,'N','01','021','EC','A',NULL,NULL,'','0000410618','0000484337','','IL','1','Fuentes','Esther','','','','34','633059196','3801 CENTURY DR',0,'EL PASO','TX','79938','0400','CY','48141','1963-08-20','F','',':RET:2106-3','N','021','DEN','1970088','33348TX002000201','2014-02-01','2014-01-04 21:59:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-07 10:21:29'),(19443,15498,'Y','18','021','EC','A','','','AC','0000559465','0000559465','OH00001641692','IL','1','AUDI','EFFIE','','','','34','591420302','7634 STUHLDREHER ST NW',0,'MASSILLON','OH','44646','1962','CY','39151','1986-05-25','F','U',':RET:1002-5','N','021','DEN','1978649','99734OH005000301','2014-03-01','2014-01-22 09:07:48','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-23 03:01:50'),(21396,17098,'Y','18','021','EC','A','','','AC','0000119100','0000119100','OH00002552643','IL','1','RATLIFF','BARBARA','','','','34','286500646','531 S PATTERSON STREET',0,'CAREY','OH','43316',NULL,'CY','39175','1950-09-12','F','U',NULL,'N','021','DEN','3713262','99734OH005000401','2014-03-01','2014-02-04 11:38:35','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-04 21:01:00'),(21997,17565,'N','01','021','EC','A',NULL,NULL,'','0001945942','0002071071','','IL','1','Batista','Luis','Lorenzo','','','34','660103090','2813 BRITANNICA DR',0,'MARRERO','LA','70072','6031','CY','22051','1963-11-21','M','',':RET:2106-3','N','021','DEN','2701605','18575LA002000201','2014-03-01','2014-02-07 15:29:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:45'),(22466,17938,'Y','18','021','EC','A','','','AC','0000706233','0000706233','OH00001943287','IL','1','Arakelian','Alexis','','','','34','012707462','120 E FREEDOM WAY',0,'CINCINNATI','OH','45202','3452','CY','39061','1980-01-23','F','U',':RET:2106-3','N','021','HLT','3820580','92036OH006001201','2014-03-01','2014-02-09 18:50:42','0.00',NULL,NULL,'206.68','206.68','R-OH004','OH0','206.68',NULL,0,'2014-02-10 21:30:55'),(204,169,'Y','18','021','EC','A','','','AC','0001131415','0001131415','OH00000428771','IL','1','Crutcher','Evelyn','','','','34','415902461','115 Scarica',0,'Elyria','OH','44035',NULL,'CY','39093','1950-12-22','F','U',NULL,'T','021','HLT','278018','92036OH004000801','2014-01-01','2013-12-04 20:18:38','509.00',NULL,NULL,'638.19','129.19','R-OH011','OH0','638.19',NULL,0,'2013-12-25 17:20:16'),(14221,11340,'Y','18','021','EC','A','','','AC','0000903632','0000903632','TX00000862490','IL','1','SMART','LAURA','DENISE','','','34','460338397','1700 S COMMERCE ST',0,'KILGORE','TX','75662','3171','CY','48183','1961-09-09','F','M',':RET:2106-3','N','021','DEN','2018728','33348TX002000201','2014-02-01','2013-12-26 16:52:42','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2013-12-27 02:04:45'),(1666,1391,'Y','18','021','EC','A','','','AC','0000474496','0000474496','TX00000429681','IL','1','gallier','letitia','','','','34','451399341','3703 GLAZE RD',0,'KOUNTZE','TX','77625','8121','CY','48199','1970-12-05','F','U',':RET:2106-3','N','021','DEN','1440803','33348TX002000201','2014-01-01','2013-12-24 17:48:05','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2013-12-25 18:53:45'),(13440,10720,'N','19','021','EC','A',NULL,NULL,'','0000279552','0000788200','','S1','1','STROUD','ANTHONY','','','','34','300132345','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','2008-07-02','M','',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:16'),(13360,10670,'Y','18','024','14','A','','','TE','0001207154','0001207154','','IL','1','Lignoski','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-04-07','F','',NULL,NULL,NULL,'','1387456','','2013-12-22','2013-12-22 19:56:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:59:26'),(13187,10520,'Y','18','021','EC','A','','','AC','0000730183','0000730183','TX00000274383','IL','1','jones','yolvalda','','','','34','449875391','4310 BIRCHCROFT DR',0,'HOUSTON','TX','77088','6846','CY','48201','1974-04-06','F','U',':RET:2054-5','N','021','DEN','1707048','33348TX002000101','2014-01-01','2013-12-23 00:25:17','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:30'),(9399,7455,'Y','18','021','EC','A','','','AC','0001118079','0001118079','TX00000001833','IL','1','Skoog','Wayne','Anthony','','','34','465474003','11834 Ryewater Drive',0,'Houston','TX','77089',NULL,'CY','48201','1968-05-20','M','U',':RET:2106-3','T','021','DEN','1916970','33348TX002000201','2014-01-01','2013-12-21 00:27:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:32:31'),(9088,7212,'Y','18','024','14','A','','','TE','0000398578','0000398578','','IL','1','Susich','Jeffrey','Thomas',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-01','M','',NULL,NULL,NULL,'','386653','','2013-12-18','2013-12-18 10:17:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:07:00'),(5545,4400,'Y','18','021','EC','A','','','AC','0001245562','0001245562','OH00001204889','IL','1','Lloyd','Anna','','','','34','272866165','3400 CHARRING CROSS DR',0,'STOW','OH','44224','4609','CY','39153','1985-11-16','F','U',':RET:2106-3','N','021','HLT','69003','52664OH151001306','2014-01-01','2013-11-26 23:46:13','196.00',NULL,NULL,'242.41','46.41','R-OH012','OH0','242.41',NULL,0,'2013-12-25 23:15:57'),(3462,2782,'N','19','021','EC','A',NULL,NULL,'','0000139006','0001042290','','IL','1','Spieldenner','Molly','S','','','34','286022671','4424 BURNINGTREE DR',0,'TOLEDO','OH','43623','3186','CY','39095','1997-09-28','F','',':RET:2106-3','N','021','DEN','2500676','99734OH005000401','2014-01-01','2013-12-22 04:18:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:45'),(6082,4820,'N','01','021','EC','A',NULL,NULL,'','0000029008','0000518368','','IL','1','Reindel','Linda','Kay','','','34','291509351','19813 st rt 697',0,'Delphos','OH','45833',NULL,'CY','39161','1951-08-21','F','',':RET:2106-3','N','021','HLT','910883','92036OH004001501','2014-01-01','2013-12-01 14:06:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','508.42',NULL,0,'2013-12-26 00:02:29'),(22891,18250,'Y','18','021','EC','A','','','AC','0000350609','0000350609','OH00002413027','IL','1','Alt','Rosemary','','','','34','281622498','13555 NEAPOLIS WATERVILLE RD',0,'GRAND RAPIDS','OH','43522','9649','CY','39095','1964-06-02','F','M',':RET:2106-3','N','021','HLT','2886147','92036OH003002604','2014-03-01','2014-02-11 13:16:34','411.00',NULL,NULL,'809.67','398.67','R-OH001','OH0','347.41',NULL,0,'2014-02-11 21:02:37'),(22962,18307,'Y','18','021','EC','A','','','AC','0000045768','0000045768','MS00001617143','IL','1','Finney','Reda','','','','34','425117099','120 SOMERSET DR',0,'JACKSON','MS','39206','2620','CY','28049','1958-08-29','F','U',NULL,'N','021','DEN','2852603','46300MS002000101','2014-03-01','2014-02-11 22:16:54','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15','CIC',0,'2014-02-12 21:00:10'),(23172,18474,'Y','18','024','14','A','','','TE','0000849473','0000849473','','IL','1','Wilson','Rae',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-14','F','',NULL,NULL,NULL,'','3837944','','2014-02-11','2014-02-11 21:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:53'),(24237,19247,'N','01','021','EC','A',NULL,NULL,'','0000705202','0000609585','','IL','1','Privett','Jeffrey',NULL,NULL,NULL,NULL,NULL,'4579 georgeann lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','1958-05-22','M','',NULL,'N','021','HLT','3717465','92036OH003000605','2014-04-01','2014-02-16 15:26:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','499.92',NULL,0,'2014-02-16 19:00:37'),(25031,19849,'Y','18','021','EC','A','','','AC','0001783002','0001783002','LA00002955555','IL','1','HODGES','RUSSELL','','','','34','437886218','1945 TULIP ST',0,'BATON ROUGE','LA','70806','6639','CY','22033','1957-12-28','M','U',':RET:2106-3','N','021','DEN','3684603','18575LA002000101','2014-04-01','2014-02-20 11:35:03','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-20 22:01:03'),(25108,19916,'Y','18','021','EC','A','','','AC','0000389645','0000389645','TX00003059722','IL','1','SMITH','DONYA','R','','','34','465573699','7618 LEATHER MARKET ST',0,'HOUSTON','TX','77064','8223','CY','48201','1966-12-19','F','U',NULL,'N','021','DEN','3009660','33348TX002000201','2014-04-01','2014-02-21 15:34:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-21 21:30:14'),(246,205,'N','01','021','EC','A',NULL,NULL,'','0000796930','0000173789','','IL','1','Brunner','Patricia','','','','34','268440744','7719 Topridge Drive',0,'West Chester','OH','45069',NULL,'CY','39017','1955-03-02','F','',':RET:2106-3','N','021','HLT','273253','92036OH005001201','2014-01-01','2013-12-05 13:41:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','546.97',NULL,0,'2013-12-25 17:21:26'),(17166,13736,'Y','18','021','EC','A','','','AC','0001462806','0001462806','LA00001476339','IL','1','MOORE','JANICE','','','','34','439297303','9093 SYLVESTER RD',0,'BASTROP','LA','71220','8001','CY','22067','1963-07-31','F','U',':RET:2054-5','N','021','DEN','1532257','18575LA002000201','2014-02-01','2014-01-08 15:44:25','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-13 02:22:05'),(815,674,'Y','18','021','EC','A','','','AC','0000259209','0000259209','OH00001220231','IL','1','McQuigg','Susan','','','','34','281589189','1844 Canfield Ave.',0,'Akron','OH','44301',NULL,'CY','39153','1959-03-04','F','U',':RET:2106-3','N','021','HLT','2379325','52664OH151001305','2014-01-01','2013-12-16 10:58:35','312.00',NULL,NULL,'476.12','164.12','R-OH012','OH0','476.12',NULL,0,'2013-12-25 18:05:55'),(1392,1156,'Y','18','021','EC','A','','','AC','0001462798','0001462798','LA00001305500','IL','1','robertson','beverly','','','','34','437866989','4714 DONNA DR',0,'NEW ORLEANS','LA','70127','3508','CY','22071','1951-01-29','F','U',':RET:2054-5','N','021','DEN','2196298','18575LA002000201','2014-01-01','2013-12-24 11:23:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:24'),(1630,1361,'Y','18','024','14','A','','','TE','0000894919','0000894919','','IL','1','Willetts','Jacob',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-23','M','',NULL,NULL,NULL,'','1514575','','2013-12-24','2013-12-24 14:59:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:52:48'),(14048,11192,'Y','18','021','EC','A','','','AC','0000211013','0000211013','OH00000674193','IL','1','railey','regina','','','','34','383804127','796 W KEMPER RD',0,'CINCINNATI','OH','45240','2520','CY','39061','1967-02-16','F','M',NULL,'N','021','DEN','1981786','99734OH005000301','2014-02-01','2013-12-26 11:18:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:12'),(8076,6395,'N','01','021','EC','A',NULL,NULL,'','0000889600','0001097777','','IL','1','ring','angel','','','','34','446743747','3355 celina road',0,'saint marys','OH','45885',NULL,'CY','39011','1974-03-17','F','',':RET:2106-3','N','021','HLT','1516931','92036OH004001501','2014-01-01','2013-12-20 15:21:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.33',NULL,0,'2013-12-26 03:10:20'),(5610,4453,'Y','18','021','EC','A','','','AC','0000828195','0000828195','OH00000464057','IL','1','Burns','Kristina','','','','34','271906055','5642 MONICA DR',0,'FAIRFIELD','OH','45014','3958','CY','39017','1987-04-18','F','U',':RET:2106-3','N','021','DEN','980619','99734OH005000401','2014-01-01','2013-11-25 23:13:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:32'),(5614,4455,'N','19','021','EC','A',NULL,NULL,'','0000666729','0001230352','','IL','1','Yohe','Austin','','','','34','269116620','3436 ERHART RD',0,'LITCHFIELD','OH','44253','9731','CY','39103','2004-09-18','M','',':RET:2106-3','N','021','DEN','834245','99734OH005000401','2014-01-01','2013-11-26 08:16:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:36'),(3288,2651,'Y','18','021','EC','A','','','AC','0000141505','0000141505','OH00000630727','IL','1','Koon','Abigail','','','','34','291887766','118 Moss Rd',0,'Westerville','OH','43082',NULL,'CY','39041','1981-09-20','F','U',':RET:2106-3','N','021','DEN','1981488','99734OH005000301','2014-01-01','2013-12-22 00:49:41','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:15:26'),(2895,2336,'N','01','021','EC','A',NULL,NULL,'','0001169421','0001006786','','IL','1','Bodzin','Lisa','','','','34','278645211','4421 SILSBY RD',0,'UNIVERSITY HEIGHTS','OH','44118','3938','CY','39035','1972-03-03','F','',':RET:2106-3','N','021','HLT','235718','52664OH151001501','2014-01-01','2013-12-06 14:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','392.76',NULL,0,'2013-12-25 20:15:14'),(18749,14939,'Y','18','021','EC','A','','','AC','0000153393','0000153393','OH00002449910','IL','1','Zarnick','Eddie','','','','34','363649306','5755 Red Leaf Lane',0,'Monclova','OH','43542',NULL,'CY','39095','1954-10-01','M','M',':RET:2106-3','N','021','HLT','2833526','92036OH005002605','2014-02-01','2014-01-15 18:34:51','676.00',NULL,NULL,'871.26','195.26','R-OH001','OH0','507.58',NULL,0,'2014-01-17 03:35:43'),(21074,16840,'Y','18','024','14','A','','','TE','0000515820','0000515820','','IL','1','Key','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-12','M','',NULL,NULL,NULL,'','1714858','','2014-02-02','2014-02-02 12:30:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-02 19:00:18'),(22446,17923,'Y','18','021','EC','A','','','AC','0000925348','0000925348','TX00001831394','IL','1','Townsend','Charlotte','','','','34','509866201','11433 TURNING LEAF TRL',0,'FORT WORTH','TX','76244','4889','CY','48439','1972-03-13','F','M',':RET:2106-3','N','021','DEN','2928737','33348TX002000201','2014-03-01','2014-02-10 14:28:05','0.00',NULL,NULL,'112.74','112.74','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:44'),(22615,18060,'Y','18','021','EC','A','','','AC','0000646979','0000646979','TX00002521067','IL','1','le','hung','','','','34','570758614','3700 legacy dr',0,'frisco','TX','75034',NULL,'CY','48085','1979-05-10','M','U',':RET:2047-9','N','021','DEN','3568063','33348TX002000201','2014-03-01','2014-02-10 19:08:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:07'),(24012,19096,'Y','18','021','EC','A','','','AC','0000490522','0000490522','OH00001874682','IL','1','Parish','Nancy','','','','34','301681109','8500 Island Pines Place',0,'Maineville','OH','45039',NULL,'CY','39165','1964-01-03','F','U',':RET:2106-3','N','021','DEN','3708070','99734OH005000401','2014-03-01','2014-02-14 20:13:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:41'),(24517,19476,'Y','18','021','EC','A','','','AC','0000882618','0000882618','TX00001954730','IL','1','VERDUGO','ERIKA','','','','34','650147923','11701 CANARY PALM CT',0,'EL PASO','TX','79936',NULL,'CY','48141','1977-04-07','F','M',NULL,'N','021','DEN','2881620','33348TX002000201','2014-04-01','2014-02-19 12:53:00','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-20 03:55:42'),(24581,19514,'N','01','021','EC','A',NULL,NULL,'','0000256015','0000753434','','IL','1','ONWUAGBA','ALBERTA','','','','34','273116289','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1968-09-23','F','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:27'),(25828,20478,'N','19','021','EC','A',NULL,NULL,'','0000444962','0000201974','','IL','1','Weilnau','Brooklyn','M','','','34','299159227','1076 REVERES RUN',0,'LEBANON','OH','45036','8974','CY','39165','2010-07-27','F','',':RET:2106-3','N','021','DEN','2946724','99734OH005000301','2014-04-01','2014-02-26 16:54:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:29'),(243,204,'Y','18','021','EC','A','','','AC','0000805087','0000805087','OH00001030937','IL','1','tippie','jason','','','','34','243410984','701 S OHIO AVE',0,'SIDNEY','OH','45365','3213','CY','39149','1975-06-24','M','U',':RET:2106-3','N','021','HLT','1104708','92036OH003000505','2014-01-01','2013-12-05 10:33:21','115.00',NULL,NULL,'309.32','194.32','R-OH003','OH0','309.32',NULL,0,'2013-12-25 17:21:22'),(439,361,'Y','18','021','EC','A','','','AC','0000002265','0000002265','OH00000870072','IL','1','Taylor','Carla','','','','34','289848840','2539 Mustang Dr',0,'Cincinnati','OH','45211',NULL,'CY','39061','1968-08-11','F','U',':RET:2054-5','N','021','DEN','264994','99734OH005000401','2014-01-01','2013-12-04 11:09:44','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:47:08'),(7077,5616,'Y','18','021','EC','A','','','AC','0000137576','0000137576','OH00001090675','IL','1','Numbers','Kyle','','','','34','295900680','507 S Harrison St',0,'Montpelier','OH','43543',NULL,'CY','39171','1987-02-09','M','M',':RET:2106-3','T','021','DEN','2198745','99734OH005000301','2014-01-01','2013-12-24 23:53:54','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-26 01:50:13'),(3516,2825,'Y','18','021','EC','A','','','AC','0000163696','0000163696','MS00000304271','IL','1','Tran','Hoang','','','','34','586507852','15068 LOVELESS DR',0,'GULFPORT','MS','39503','2455','CY','28047','1951-08-19','M','M',':RET:2047-9','N','021','DEN','1880424','46300MS002000201','2014-01-01','2013-12-22 17:43:53','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2013-12-25 21:21:09'),(8115,6419,'N','01','021','EC','A',NULL,NULL,'','0000569429','0000271034','','IL','1','McKay','Joshua','f','','','34','438750543','322 WALKER RD',0,'POLLOCK','LA','71467','4329','CY','22043','1974-10-17','M','',':RET:2106-3','T','021','DEN','833172','18575LA002000201','2014-01-01','2013-11-22 15:16:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 03:15:08'),(15888,12722,'Y','18','021','EC','A','','','AC','0000659921','0000659921','OH00002175857','IL','1','Gannaway','Deborah','','','','34','302526978','3651 COLUMBUS AVE',0,'CINCINNATI','OH','45208','1512','CY','39061','1952-09-14','F','U',':RET:2106-3','N','021','HLT','1399355','92036OH004001201','2014-02-01','2014-01-02 12:19:01','313.00',NULL,NULL,'485.05','172.05','R-OH004','OH0','485.05',NULL,0,'2014-01-03 02:05:38'),(17386,13911,'Y','18','024','14','A','','','TE','0000653212','0000653212','','IL','1','Jones','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-23','F','',NULL,NULL,NULL,'','1506468','','2014-01-10','2014-01-10 11:30:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:09'),(17434,13948,'Y','18','021','EC','A','','','AC','0000768902','0000768902','OH00001788343','IL','1','McCune','Richard','','','','34','235760139','1025 W. Ohio Avenue',0,'Sebring','OH','44672',NULL,'CY','39099','1950-07-26','M','M',':RET:2106-3','N','021','HLT','2131267','92036OH005003201','2014-02-01','2014-01-10 12:51:49','0.00',NULL,NULL,'714.53','714.53','R-OH013','OH0','714.53',NULL,0,'2014-01-13 03:00:32'),(17917,14312,'Y','18','021','EC','A','','','AC','0001105113','0001105113','TX00001665465','IL','1','WHEAT','CHARLA','','','','34','451319607','190 KABARRU DR',0,'HUNTINGTON','TX','75949','3439','CY','48005','1962-08-05','F','U',NULL,'N','021','DEN','2348487','33348TX002000201','2014-02-01','2014-01-14 01:10:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:29'),(18657,14874,'Y','18','021','EC','A','','','AC','0000231952','0000231952','TX00001609551','IL','1','dominguz','elia','','','','34','631542217','422 MORGAN AVE',0,'TYLER','TX','75702','7655','CY','48423','1975-03-21','F','M',NULL,'N','021','DEN','1451266','33348TX002000201','2014-03-01','2014-01-16 14:28:27','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-01-17 03:35:12'),(18772,14955,'Y','18','021','EC','A','','','AC','0000360457','0000360457','TX00001697822','IL','1','LOPEZ','JUAN','','','','34','460830235','2907 STONE WAY DR',0,'HOUSTON','TX','77082','2025','CY','48201','1955-12-10','M','M',NULL,'N','021','DEN','2610295','33348TX002000101','2014-02-01','2014-01-15 20:54:05','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:50'),(19566,15598,'Y','18','021','EC','A','','','AC','0001977772','0001977772','LA00002118090','31','1','Williams','Byron','','','','34','439697364','1700 Indian Plaza Dr. NE',0,'Albuquerque','NM','87106',NULL,'CY','22071','1983-02-12','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','1778446','18575LA002000201','2014-03-01','2014-01-22 16:47:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 03:02:35'),(21123,16878,'Y','18','021','EC','A','','','AC','0001237975','0001237975','TX00001921189','IL','1','RAMSEY','KELLIE','','','','34','640502960','408 WOODLAWN CIR',0,'LUFKIN','TX','75904','8423','CY','48005','1987-12-29','F','U',':RET:2106-3','N','021','DEN','3455434','33348TX002000201','2014-03-01','2014-02-03 13:20:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:14'),(25503,20233,'Y','18','021','EC','A','','','AC','0001110745','0001110745','TX00002736668','IL','1','JACKSON','BRENDA','','','','34','451473001','936 US HIGHWAY 59 S',0,'LINDEN','TX','75563','6694','CY','48067','1963-04-05','F','U',':RET:2054-5','N','021','DEN','2781838','33348TX002000101','2014-04-01','2014-02-25 17:25:54','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-25 21:31:56'),(26726,21184,'N','19','021','EC','A',NULL,NULL,'','0000533968','0000921511','','IL','1','samaha','yasmeen','','','','34','444237216','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','2007-05-31','F','',':RET:2106-3','N','021','DEN','3332360','33348TX002000101','2014-04-01','2014-02-28 09:18:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-02-28 21:31:47'),(601,494,'Y','18','021','EC','A','','','AC','0000908008','0000908008','OH00000495965','31','1','Melasecca','Alicia','','','','34','589949122','6913 Kleindale Ave',0,'Cincinnati','OH','45231',NULL,'CY','39061','1985-11-17','F','R',':RET:2106-3','N','021','DEN','1077559','99734OH005000401','2014-01-01','2013-12-15 22:45:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:00:19'),(616,507,'N','01','021','EC','A',NULL,NULL,'','0000005817','0000005816','','IL','1','MINTON','AUDREY','A','','','34','295548629','1190 GIBSON RD',0,'MARTINSVILLE','OH','45146','9517','CY','39027','1953-07-21','F','',':RET:2106-3','N','021','DEN','2245086','99734OH005000401','2014-01-01','2013-12-16 10:53:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:00:43'),(3285,2648,'Y','18','021','EC','A','','','AC','0001186309','0001186309','OH00001194679','IL','1','Reid','Christopher','R','','','34','614097486','4556 Winton Rd',0,'Cincinnati','OH','45232',NULL,'CY','39061','1979-04-25','M','U',':RET:2106-3','N','021','DEN','1743267','99734OH005000301','2014-01-01','2013-12-21 23:12:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:21'),(14636,11680,'N','01','021','EC','A',NULL,NULL,'','0000825919','0000539289','','IL','1','Morris','Vicki','','','','34','278647873','1574 E High Street',0,'Lima','OH','45804',NULL,'CY','39003','1956-07-18','F','',':RET:2106-3','T','021','HLT','2586548','92036OH004001501','2014-02-01','2013-12-27 15:24:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','495.96',NULL,0,'2013-12-28 03:37:18'),(20351,16252,'Y','18','021','EC','A','','','AC','0000034409','0000034409','OH00001945468','IL','1','Dean','Edith','','','','34','289663131','16977 E TOWNSHIP ROAD 88',0,'ATTICA','OH','44807','9494','CY','39147','1968-04-13','F','M',NULL,'N','021','HLT','3416302','92036OH005002706','2014-03-01','2014-01-28 11:32:37','261.00',NULL,NULL,'281.58','20.58','R-OH006','OH0','281.58',NULL,0,'2014-01-28 21:01:14'),(20697,16537,'Y','18','021','EC','A','','','AC','0000761148','0000761148','OH00001817899','IL','1','Feldhaus','Peggy','','','','34','403747613','2101 S MAIN ST',0,'MIDDLETOWN','OH','45044','7494','CY','39017','1954-08-01','F','U',NULL,'N','021','DEN','2857409','99734OH005000301','2014-03-01','2014-01-30 14:21:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:01:01'),(4497,3564,'Y','18','021','EC','A','','','AC','0000126663','0000126663','TX00001036158','IL','1','Kungu','Jamie','','','','34','466655477','706 WILCOX ST',0,'WINNSBORO','TX','75494','2040','CY','48499','1977-06-26','F','M',':RET:2106-3','N','021','DEN','463037','33348TX002000201','2014-01-01','2013-12-11 20:19:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:03:15'),(15144,12103,'Y','18','021','EC','A','','','AC','0000801273','0000801273','OH00000403587','IL','1','Parton','Berneice','','','','34','406786889','1785 STATE ROUTE 28',0,'GOSHEN','OH','45122','9319','CY','39025','1952-09-27','F','U',NULL,'N','021','DEN','1378699','99734OH005000401','2014-02-01','2013-12-30 10:49:08','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-01 12:05:49'),(13931,11111,'Y','18','021','EC','A','','','AC','0000581488','0000581488','OH00000774673','IL','1','Robinson','Charlotte','L','','','34','283547857','1819 Calumet Street',0,'Toledo','OH','43607',NULL,'CY','39095','1955-08-20','F','U',':RET:2054-5','N','021','HLT','2084674','92036OH004002601','2014-01-01','2013-12-23 09:06:58','242.00',NULL,NULL,'399.50','157.50','R-OH001','OH0','399.50',NULL,0,'2013-12-26 13:14:28'),(13479,10748,'N','19','021','EC','A',NULL,NULL,'','0000771441','0000645985','','IL','1','Rawal','Anisha','','','','34','298117345','4998 SHADY CREST AVE NW',0,'MASSILLON','OH','44646','9554','CY','39151','2006-06-01','F','',':RET:2029-7','N','021','DEN','2193469','99734OH005000301','2014-01-01','2013-12-23 17:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:11'),(4050,3234,'Y','18','021','EC','A','','','AC','0000244964','0000244964','OH00000863384','IL','1','Gottenbusch','grace','','','','34','301681809','3566 ERIE AVE',0,'CINCINNATI','OH','45208','1761','CY','39061','1967-03-08','F','U',NULL,'N','021','DEN','1668208','99734OH005000401','2014-01-01','2013-12-17 13:33:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:22'),(1574,1314,'Y','18','021','EC','A','','','AC','0000828190','0000828190','TX00001223435','31','1','JACKSON','DOROTHY','','','','34','463961212','PO BOX 101',0,'LOTT','TX','76656',NULL,'CY','48145','1950-01-11','F','U',NULL,'N','021','DEN','2533524','33348TX002000201','2014-01-01','2013-12-24 10:13:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:16'),(2448,1993,'Y','18','021','EC','A','','','AC','0000510623','0000510623','OH00001160915','IL','1','Slouffman','James','Walter','','','34','290440485','3327 GLENHURST PL',0,'CINCINNATI','OH','45209','2312','CY','39061','1950-04-01','M','M',':RET:2106-3','N','021','HLT','154240','92036OH004001201','2014-01-01','2013-12-09 16:02:58','0.00',NULL,NULL,'509.54','509.54','R-OH004','OH0','509.54',NULL,0,'2013-12-25 19:34:36'),(17241,13797,'Y','18','021','EC','A','','','AC','0000773992','0000773992','OH00001561285','IL','1','Bowling','Kelli','','','','34','301809855','2274 STATE ROUTE 131',0,'GOSHEN','OH','45122','9430','CY','39025','1983-11-30','F','M',':RET:2106-3','N','021','HLT','1542952','92036OH001000601','2014-02-01','2014-01-08 13:49:38','227.00',NULL,NULL,'594.02','367.02','R-OH005','OH0','293.90',NULL,0,'2014-01-13 02:22:45'),(19415,15478,'N','01','021','EC','A',NULL,NULL,'','0000464782','0000536356','','IL','1','TRUONG','ANNA','','','','34','621403261','6660 CORTEZ CIR',0,'OCEAN SPRINGS','MS','39564','2323','CY','28059','1972-04-12','F','',':RET:2047-9','N','021','DEN','1965004','46300MS002000201','2014-03-01','2014-01-21 11:58:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,1,'2014-01-22 03:22:59'),(21482,17165,'Y','18','021','EC','A','','','AC','0000223731','0000223731','OH00001790204','IL','1','TUCKER','BRITTANY','','','','34','296825488','5668 SPRINGDALE RD',0,'CINCINNATI','OH','45251','1826','CY','39061','1972-07-15','F','U',':RET:2054-5','N','021','DEN','2912519','99734OH005000301','2014-03-01','2014-02-04 14:31:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:43'),(22820,18210,'N','01','021','EC','A',NULL,NULL,'','0001103479','0000749577','','IL','1','White','Kimberly','','','','34','288704258','1409 Grimes Circle',0,'Urbana','OH','43078',NULL,'CY','39021','1962-10-18','F','',':RET:2106-3','N','021','HLT','3303777','92036OH005000504','2014-03-01','2014-02-10 20:37:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.34',NULL,0,'2014-02-11 21:02:02'),(24348,19337,'Y','18','021','EC','A','','','AC','0000755555','0000755555','TX00002629434','IL','1','Blair','Thomas','','','','34','561777250','9725 N Lake Creek Pkwy',0,'Austin','TX','78717',NULL,'CY','48491','1978-08-22','M','U',':RET:2106-3','T','021','DEN','2700573','33348TX002000201','2014-04-01','2014-02-18 17:16:05','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:25'),(25308,20076,'N','19','021','EC','A',NULL,NULL,'','0000761132','0000653256','','S3','1','L\'Heureux','Wiliam',NULL,NULL,NULL,NULL,NULL,'357 W WASHINGTON ST',0,'NELSONVILLE','OH','45764','1164','CY','39009','2006-07-12','F','',':RET:2106-3','N','021','DEN','3445971','99734OH005000301','2014-03-01','2014-02-25 16:09:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:30'),(27443,21719,'Y','18','021','EC','A','','','AC','0001700534','0001700534','LA00003705373','IL','1','thirdkill','rose','','','','34','438232328','6299 HARRIS RD',0,'BASTROP','LA','71220','8934','CY','22067','1962-02-21','F','M',':RET:2054-5','N','021','DEN','3661262','18575LA002000201','2014-04-01','2014-03-04 15:53:55','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-04 21:01:54'),(28919,22888,'Y','18','024','14','A','','','TE','0000913020','0000913020','','IL','1','METCALF','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-28','M','',NULL,NULL,NULL,'','3748256','','2014-03-10','2014-03-10 10:06:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:00:30'),(29124,23056,'Y','18','021','EC','A','','','AC','0000982768','0000982768','OH00003830110','IL','1','McElrath','Mark','W','','','34','293549275','816 DAGGET DR',0,'NAPOLEON','OH','43545','1942','CY','39069','1954-09-28','M','U',NULL,'T','021','HLT','2728370','92036OH006002601','2014-04-01','2014-03-10 10:20:14','441.00',NULL,NULL,'462.93','21.93','R-OH001','OH0','462.93',NULL,0,'2014-03-10 21:02:32'),(261,216,'Y','18','021','EC','A','','','AC','0001077708','0001077708','OH00001143084','IL','1','Cloud','Marcia','Ann','','','34','279509629','373 STANTON AVE',0,'SPRINGFIELD','OH','45503','3758','CY','39023','1951-01-04','F','U',':RET:2106-3','N','021','HLT','624497','92036OH004000501','2014-01-01','2013-12-05 12:17:57','252.00',NULL,NULL,'549.13','297.13','R-OH003','OH0','549.13',NULL,0,'2013-12-25 17:21:50'),(7303,5788,'N','01','021','EC','A',NULL,NULL,'','0000614087','0000264183','','IL','1','STREET','KENNETH','','','','34','276644721','3481 AKRON VIEW DR',0,'BARBERTON','OH','44203','3827','CY','39153','1956-12-07','M','',':RET:2106-3','N','021','HLT','979989','52664OH151001306','2014-01-01','2013-12-14 13:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2013-12-26 02:03:11'),(13321,10636,'Y','18','021','EC','A','','','AC','0000904759','0000904759','TX00000667987','IL','1','Garcia','Ernestina','','','','34','454319637','464 E RODRIGUEZ AVE',0,'RAYMONDVILLE','TX','78580','2647','CY','48489','1963-11-06','F','U',':RET:2106-3','N','021','DEN','1812344','33348TX002000201','2014-01-01','2013-12-23 16:57:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:22'),(15747,12598,'Y','18','021','EC','A','','','AC','0000815686','0000815686','TX00002152306','IL','1','MICKENS','LARA','','','','34','497762690','10222 NORTH WALTON WALKER BLVD',0,'DALLAS','TX','75220',NULL,'CY','48113','1965-12-31','F','U',NULL,'N','021','DEN','1972193','33348TX002000201','2014-02-01','2014-01-02 14:21:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:01:01'),(15166,12120,'Y','18','021','EC','A','','','AC','0000802585','0000802585','OH00001380211','IL','1','TAYLOR','TIMOTHY','T','','','34','283906938','15704 EAST 155TH INDERMERE',0,'CLEVELAND','OH','44128',NULL,'CY','39035','1989-05-23','M','U',':RET:2054-5','T','021','DEN','2490719','99734OH005000401','2014-02-01','2013-12-30 15:05:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:06:24'),(7875,6230,'Y','18','024','14','A','','','TE','0000151954','0000151954','','IL','1','Knueven','Emily',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-19','F','',NULL,NULL,NULL,'','1238526','','2013-12-20','2013-12-20 17:13:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:05:17'),(20416,16307,'Y','18','021','EC','A','','','AC','0000187503','0000187503','OH00002568084','IL','1','ROBBINS','SINDY','','','','34','171465851','4147 FOX HOLLOW DR',0,'CICINATTI','OH','45241',NULL,'CY','39061','1954-05-26','F','U',':RET:2106-3','N','021','DEN','1540699','99734OH005000301','2014-03-01','2014-01-28 22:37:57','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:27'),(20643,16495,'Y','18','021','EC','A','','','AC','0000129880','0000129880','TX00002590605','IL','1','DAVIS','VERA','','','','34','464060752','3814 WENTWORTH ST',0,'HOUSTON','TX','77074',NULL,'CY','48201','1955-10-13','F','M',NULL,'N','021','DEN','3406542','33348TX002000201','2014-03-01','2014-01-30 12:37:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-30 21:00:34'),(21812,17419,'Y','18','021','EC','A','','','AC','0000616909','0000616909','OH00002511407','IL','1','Chryst','Laura','','','','34','301727473','15909 Clifton  Blvd',0,'Lakewood','OH','44107',NULL,'CY','39035','1964-06-03','F','U',NULL,'N','021','HLT','3214225','52664OH151001304','2014-03-01','2014-02-06 12:48:42','276.00',NULL,NULL,'588.80','312.80','R-OH011','OH0','429.09',NULL,0,'2014-02-06 21:00:55'),(26927,21340,'Y','18','021','EC','A','','','AC','0001140834','0001140834','OH00002526383','IL','1','Schum-Smith','Stephanie','','','','34','298824119','1356 Nicholas Drive',0,'Loveland','OH','45140',NULL,'CY','39025','1969-04-05','F','M',':RET:2106-3','N','021','DEN','3368128','99734OH005000401','2014-04-01','2014-03-02 13:35:18','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-03 01:00:18'),(28291,22386,'Y','18','021','EC','A','','','AC','0000198629','0000198629','OH00003328034','IL','1','Day','Jennifer','','','','34','291884850','2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','1982-10-29','F','M',':RET:2106-3','N','021','HLT','3096511','92036OH004000601','2014-04-01','2014-03-07 11:10:08','0.00',NULL,NULL,'513.87','513.87','R-OH005','OH0','200.06','CIC',0,'2014-03-07 21:00:28'),(6499,5149,'Y','18','021','EC','A','','','AC','0000510629','0000510629','OH00000807842','IL','1','Fannin','Jo','','','','34','298545721','37602 JORDAN DR',0,'WILLOUGHBY','OH','44094','5916','CY','39085','1953-05-31','F','U',':RET:2106-3','N','021','HLT','358017','52664OH151001305','2014-01-01','2013-12-11 15:49:06','463.00',NULL,NULL,'682.62','219.62','R-OH011','OH0','682.62',NULL,0,'2013-12-26 00:50:47'),(15274,12210,'N','01','021','EC','A',NULL,NULL,'','0000637121','0000987413','','IL','1','Fournier','Danielle','L','','','34','270925875','1961 PARKGATE AVE',0,'AKRON','OH','44320','1107','CY','39153','1986-05-26','F','',':RET:2106-3','T','021','DEN','1876756','99734OH005000401','2014-02-01','2013-12-31 21:25:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:21:54'),(14805,11824,'Y','18','021','EC','A','','','AC','0001319268','0001319268','LA00000834023','IL','1','Jackson','Andrew','','','','34','438394017','1803 TULLAMORE ST',0,'ALEXANDRIA','LA','71303','5259','CY','22079','1966-02-20','M','U',':RET:2054-5','N','021','DEN','2609623','18575LA002000101','2014-01-01','2013-12-23 20:36:28','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,1,'2013-12-29 11:13:52'),(13885,11076,'N','19','021','EC','A',NULL,NULL,'','0000685845','0001168000','','IL','1','Evans','Jonathan','Charles','','','34','297027566','18300 PARKLAND DR',0,'SHAKER HEIGHTS','OH','44122','3449','CY','39035','1998-04-30','M','',':RET:2106-3','N','021','HLT','1935254','52664OH151001501','2014-01-01','2013-12-23 17:12:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-26 13:13:21'),(1058,867,'Y','18','021','EC','A','','','AC','0000822873','0000822873','TX00000264459','IL','1','SAREEN','ANJANA','','','','34','092608554','1 INWOOD POINT DR',0,'SAN ANTONIO','TX','78248','1647','CY','48029','1957-07-28','F','U',':RET:2028-9','N','021','DEN','22252','33348TX002000201','2014-01-01','2013-12-03 17:42:07','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 18:16:13'),(4456,3541,'Y','18','021','EC','A','','','AC','0000701655','0000701655','OH00000320290','IL','1','Davidson','Danielle','M','','','34','298500836','486 Bay Hill Dr.',0,'Avon Lake','OH','44012',NULL,'CY','39093','1952-11-05','F','U',NULL,'N','021','DEN','56003','99734OH005000301','2014-01-01','2013-12-12 10:56:32','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:30'),(9760,7729,'Y','18','021','EC','A','','','AC','0000496721','0000496721','OH00000122054','IL','1','Ditcher','Steve','','','','34','298521693','4574 MAPLE GROVE RD SE',0,'UHRICHSVILLE','OH','44683','1350','CY','39157','1952-10-25','M','U',NULL,'N','021','DEN','939557','99734OH005000401','2014-01-01','2013-10-20 17:18:25','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-26 05:00:12'),(9607,7608,'Y','18','021','EC','A','','','AC','0000991533','0000991533','OH00001041902','IL','1','Armentrout','Courtney','Lee','','','34','276942058','992 Ravenna Rd',0,'Kent','OH','44240',NULL,'CY','39133','1990-11-20','F','U',':RET:2106-3','N','021','HLT','1765364','52664OH151001306','2014-01-01','2013-12-21 13:30:31','134.00',NULL,NULL,'223.01','89.01','R-OH012','OH0','223.01',NULL,0,'2013-12-26 04:37:32'),(8948,7096,'Y','18','021','EC','A','','','AC','0000699253','0000699253','OH00000321999','IL','1','BRAND','DON','','','','34','288521638','5948 ROAN ROAD',0,'MILFORD','OH','45150',NULL,'CY','39025','1951-08-02','M','U',':RET:2106-3','N','021','DEN','1434124','99734OH005000401','2014-01-01','2013-12-18 11:08:49','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:03:29'),(2877,2325,'Y','18','021','EC','A','','','AC','0000653155','0000653155','OH00000384770','IL','1','Ward','Jerry','','','','34','284645454','4909 Dutch Lane Rd',0,'Johnstown','OH','43031',NULL,'CY','39089','1970-02-27','M','U',':RET:2106-3','T','021','DEN','252939','99734OH005000301','2014-01-01','2013-10-21 20:48:21','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:02:06'),(2153,1771,'Y','18','021','EC','A','','','AC','0000383016','0000383016','LA00000020970','IL','1','Rick','Melanie','H','','','34','433196933','59561 COMPANY RD',0,'AMITE','LA','70422','3643','CY','22105','1961-08-12','F','M',':RET:2106-3','N','021','DEN','1114789','18575LA002000101','2014-01-01','2013-12-09 20:29:27','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:18:38'),(4066,3248,'Y','18','021','EC','A','','','AC','0000841906','0000841906','OH00000090169','IL','1','Drury','Sharon','','','','34','410133427','3097 ESSINGTON DR',0,'DUBLIN','OH','43017','1757','CY','39049','1960-06-13','F','U',':RET:2054-5','N','021','DEN','2060191','99734OH005000401','2014-01-01','2013-12-17 16:24:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:48'),(16933,13551,'Y','18','021','EC','A','','','AC','0002259036','0002259036','LA00002240146','IL','1','Bellas','Kaila',NULL,NULL,NULL,NULL,NULL,'3644 Johnson Street',0,'Metairie','LA','70001',NULL,'CY','22051','1989-02-03','F','U',NULL,'N','021','DEN','2479841','18575LA002000201','2014-02-01','2014-01-08 21:03:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:50'),(21876,17465,'Y','18','021','EC','A','','','AC','0001377681','0001377681','LA00002279454','IL','1','FOLEY','LILLIAN','','','','34','437313747','2020 PAILET STREET',0,'HARVEY','LA','70058',NULL,'CY','22051','1965-02-13','F','U',':RET:2054-5','T','021','DEN','2643846','18575LA002000201','2014-03-01','2014-02-06 08:51:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-06 21:01:28'),(24082,19149,'N','19','021','EC','A',NULL,NULL,'','0000432810','0000501659','','IL','1','DRENNEN','KEIRA','R','','','34','299114578','4899 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','2006-06-21','F','',':RET:2106-3','N','021','HLT','3259633','52664OH151001305','2014-03-01','2014-02-15 12:10:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:22'),(26116,20711,'N','01','021','EC','A',NULL,NULL,'','0000847186','0000957934','','IL','1','Loomis','Katrina','Y','','','34','292700706','5626 Summerville Dr',0,'Galloway','OH','43119',NULL,'CY','39049','1968-12-09','F','',':RET:2054-5','N','021','DEN','3374296','99734OH005000401','2014-03-01','2014-02-26 20:04:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:17'),(3901,3122,'N','19','021','EC','A',NULL,NULL,'','0001114511','0000183476','','IL','1','Pavliga','Kathryn',NULL,NULL,NULL,NULL,NULL,'1965 NEW MILFORD RD',0,'ATWATER','OH','44201','7701','CY','39133','1992-11-20','F','',':RET:2106-3','N','021','HLT','1012859','52664OH152000901','2014-01-01','2013-12-13 16:57:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2013-12-25 21:36:51'),(14283,11394,'Y','18','021','EC','A','','','AC','0000516389','0000516389','MS00001525971','IL','1','Dorsey','Clarence','Webster','','','34','587158620','338 SWAN LAKE DR',0,'JACKSON','MS','39212','5338','CY','28049','1959-12-17','M','M',':RET:2054-5','N','021','DEN','2427800','46300MS002000201','2014-02-01','2013-12-26 17:16:48','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:22'),(674,556,'Y','18','021','EC','A','','','AC','0000079893','0000079893','OH00000389393','IL','1','Barlage','Deborah','','','','34','282500876','1021 W BRIDLEPATH LN',0,'LOVELAND','OH','45140','8073','CY','39025','1967-01-22','F','U',':RET:2106-3','N','021','DEN','2369019','99734OH005000301','2014-01-01','2013-12-16 10:16:27','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:02:13'),(13481,10749,'Y','18','021','EC','A','','','AC','0000050690','0000050690','OH00000486316','IL','1','keller','amy','','','','34','284805361','651 ORIENT WAY',0,'HAMILTON','OH','45013','5013','CY','39017','1969-03-25','F','U',':RET:2106-3','N','021','DEN','1919681','99734OH005000301','2014-01-01','2013-12-23 17:20:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:02:12'),(3696,2958,'Y','18','021','EC','A','','','AC','0000346875','0000346875','OH00000313293','IL','1','Franko','Thomas','Joseph','','','34','288448026','10109 VIENNA DR',0,'PARMA','OH','44130','7540','CY','39035','1954-12-08','M','U',':RET:2106-3','N','021','DEN','1073828','99734OH005000401','2014-01-01','2013-12-13 10:56:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:31:51'),(16524,13219,'Y','18','021','EC','A','','','AC','0000703637','0000703637','TX00001656485','IL','1','BEDWELL','SHERRIE','','','','34','429470900','70 PIERCE RD',0,'TEXARKANA','TX','75501','1858','CY','48037','1965-12-16','F','U',':RET:2106-3','T','021','DEN','2453434','33348TX002000201','2014-02-01','2014-01-04 22:51:22','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,1,'2014-01-07 10:21:50'),(19788,15775,'Y','18','021','EC','A','','','AC','0000086449','0000086449','OH00001630651','IL','1','Anderson','Keith','','','','34','272865768','5340 HAMILTON AVE APT 302',0,'CLEVELAND','OH','44114',NULL,'CY','39035','1975-10-16','M','U',':RET:2106-3','N','021','HLT','2784885','52664OH151001501','2014-03-01','2014-01-23 14:05:09','0.00',NULL,NULL,'375.87','375.87','R-OH011','OH0','375.87',NULL,0,'2014-01-23 21:01:38'),(20873,16681,'Y','18','024','14','A','','','TE','0001930308','0001930308','','IL','1','Guggenheim','Tonya','Joanne',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-19','F','',NULL,NULL,NULL,'','2128875','','2014-01-30','2014-01-30 20:44:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-31 21:01:03'),(21330,17045,'Y','18','021','EC','A','','','AC','0000473682','0000473682','OH00001804824','IL','1','Gilchrist','Thomas','','','','34','298525568','222 clemmer ave',0,'akron','OH','44313',NULL,'CY','39153','1958-02-18','M','U',':RET:2106-3','N','021','HLT','3704069','52664OH152000901','2014-03-01','2014-02-04 17:52:50','268.00',NULL,NULL,'381.07','113.07','R-OH012','OH0','381.07',NULL,0,'2014-02-04 21:00:28'),(22242,17753,'Y','18','021','EC','A','','','AC','0000271467','0000271467','OH00002123517','IL','1','WHEELER','MORGAN','','','','34','279963788','190 WHEELER RD',0,'PIKETON','OH','45661','9552','CY','39131','1986-02-23','F','U',':RET:2106-3','N','021','DEN','3837883','99734OH005000301','2014-03-01','2014-02-09 15:45:19','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-09 19:00:38'),(22344,17845,'Y','18','021','EC','A','','','AC','0000988917','0000988917','OH00002533871','IL','1','Baden','Yvonne','','','','34','276589589','620 ROXBURY CT',0,'OREGON','OH','43616','2919','CY','39095','1968-04-08','F','U',':RET:2106-3','N','021','HLT','2890622','92036OH006002601','2014-03-01','2014-01-27 20:25:24','121.00',NULL,NULL,'223.31','102.31','R-OH001','OH0','223.31',NULL,0,'2014-02-10 11:01:10'),(22515,17974,'N','01','021','EC','A',NULL,NULL,'','0000563052','0000437009','','IL','1','Whitley','William','L','','','34','465888550','2846 FM 2410 SPUR',0,'Belton','TX','76513',NULL,'CY','48027','1950-04-12','M','',':RET:2106-3','N','021','DEN','3660612','33348TX002000101','2014-03-01','2014-02-10 11:29:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-10 21:31:21'),(14644,11687,'Y','18','021','EC','A','','','AC','0001143419','0001143419','TX00001464234','IL','1','Garza','Candy','','','','34','451027720','1232 WILLOW DR',0,'CANYON LAKE','TX','78133','2642','CY','48091','1952-09-08','F','M',':RET:1002-5','N','021','DEN','1906240','33348TX002000101','2014-02-01','2013-12-27 19:49:23','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,1,'2013-12-29 11:07:32'),(23233,18522,'Y','18','021','EC','A','','','AC','0000986051','0000986051','OH00001657362','IL','1','Gwiner','Theresa','','','','34','297568820','803 LEONARD ST',0,'FOSTORIA','OH','44830','2046','CY','39147','1953-10-24','F','M',':RET:2106-3','T','021','HLT','2652089','92036OH004002701','2014-03-01','2014-02-12 12:18:28','375.00',NULL,NULL,'489.36','114.36','R-OH006','OH0','489.36',NULL,0,'2014-02-12 21:32:26'),(24718,19627,'Y','18','021','EC','A','','','AC','0000467141','0000467141','OH00002367482','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-20 04:37:28'),(24743,19639,'N','19','021','EC','A',NULL,NULL,'','0000027939','0001135222','','IL','1','Dugan','Matthew','J','','','34','284988688','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1995-05-29','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:38'),(25366,20127,'Y','18','021','EC','A','','','AC','0000866950','0000866950','OH00003244470','IL','1','Wilson','Katie','','','','34','272825750','660 DELTA AVE',0,'CINCINNATI','OH','45226','1926','CY','39061','1984-01-16','F','M',':RET:2106-3','N','021','DEN','3537964','99734OH005000301','2014-04-01','2014-02-25 11:38:32','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:39'),(26453,20981,'N','19','021','EC','A',NULL,NULL,'','0000177461','0001051226','','S1','1','Bretheim','Shelly','','','','34','426955878','147 CHINQUIPIN CV',0,'RIDGELAND','MS','39157','1007','CY','28089','2004-01-18','F','',':RET:2106-3','N','021','DEN','3260961','46300MS002000101','2014-03-01','2014-02-27 07:32:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10','CIC',0,'2014-02-28 07:30:26'),(27155,21500,'Y','18','024','14','A','','','TE','0000802612','0000802612','','IL','1','SOMERVILLE','KATHLEEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-08','F','',NULL,NULL,NULL,'','3083008','','2014-03-18','2014-03-03 15:29:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 21:30:55'),(383,318,'Y','18','021','EC','A','','','AC','0000814195','0000814195','TX00000289778','IL','1','Galvan','Jacqueline','','','','34','463998509','6504 S GALAXY DR',0,'PHARR','TX','78577','8538','CY','48215','1986-11-26','F','U',NULL,'N','021','DEN','47811','33348TX002000201','2014-01-01','2013-12-04 17:59:44','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 17:45:46'),(485,395,'N','01','021','EC','A',NULL,NULL,'','0000019448','0000105328','','IL','1','Chance','Linda','Joyce','','','34','080443718','142 S GATE DR',0,'PONCHATOULA','LA','70454','9401','CY','22105','1951-01-12','F','',':RET:2106-3','N','021','DEN','811884','18575LA002000201','2014-01-01','2013-12-03 19:52:09',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 17:48:16'),(23147,18452,'N','01','021','EC','A',NULL,NULL,'','0000759741','0001176888','','IL','1','Gruesen','Susan','Jenelle',NULL,NULL,NULL,NULL,'2753 Glenhaven Ave',0,'Copley','OH','44321',NULL,'CY','39153','1986-12-08','F','',':RET:2106-3','N','021','HLT','3069440','52664OH151001305','2014-03-01','2014-02-12 14:17:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.71',NULL,0,'2014-02-12 21:31:39'),(2827,2284,'Y','18','021','EC','A','','','AC','0000808615','0000808615','OH00000779181','IL','1','Houghton','Helen','','','','34','288548643','5430 CLEVELAND MASSILLON RD',0,'NORTON','OH','44203','7824','CY','39153','1952-01-11','F','U',':RET:2106-3','N','021','HLT','1240567','52664OH151001305','2014-01-01','2013-11-23 20:56:25','463.00',NULL,NULL,'626.65','163.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 20:00:39'),(7316,5798,'Y','18','021','EC','A','','','AC','0000855715','0000855715','TX00000092566','IL','1','zamora','alicia','melissa','','','34','643056357','329 COLEMAN ST',0,'KERRVILLE','TX','78028','3127','CY','48265','1983-09-29','F','U',NULL,'N','021','DEN','316734','33348TX002000101','2014-01-01','2013-12-14 12:28:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 02:03:27'),(20429,16316,'Y','18','021','EC','A','','','AC','0000713662','0000713662','OH00001464958','IL','1','Newman','Neil','','','','34','286562076','890 WOODFIELD LN',0,'BRUNSWICK','OH','44212','4744','CY','39103','1962-05-01','M','U',':RET:2106-3','N','021','DEN','3249125','99734OH005000301','2014-03-01','2014-01-29 12:37:54','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-29 21:00:34'),(19520,15558,'N','19','021','EC','A',NULL,NULL,'','0001037384','0000073963','','IL','1','Scott','Aiden','David','','','34','287155263','142 BRIARCLIFF AVE',0,'ALLIANCE','OH','44601','2112','CY','39151','2009-10-21','M','',':RET:2106-3','N','021','DEN','2804688','99734OH005000401','2014-03-01','2014-01-22 09:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:18'),(18832,14999,'N','01','021','EC','A',NULL,NULL,'','0000019133','0000901094','','IL','1','WAGNER','JENNIFER','','','','34','278745790','27629 ELLIOTT RD',0,'DEFIANCE','OH','43512','9012','CY','39039','1976-06-25','F','',NULL,'N','021','HLT','2948334','92036OH001002601','2014-02-01','2014-01-15 18:54:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.18',NULL,0,'2014-01-17 03:36:10'),(5068,4017,'Y','18','021','EC','A','','','AC','0001234122','0001234122','TX00001051484','IL','1','Rather','Joshua','','','','34','601549668','197 GOAT CREEK CUT OFF RD',0,'KERRVILLE','TX','78028','4350','CY','48265','1974-10-17','M','U',':RET:2106-3','T','021','DEN','2507616','33348TX002000201','2014-01-01','2013-12-19 11:14:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:38'),(8967,7113,'Y','18','021','EC','A','','','AC','0001239112','0001239112','OH00001206585','IL','1','SZEKELY','REGINA','','','','34','290500083','1056 BELLVUE DR',0,'PAINESVILLE','OH','44077','4514','CY','39085','1951-05-14','F','M',NULL,'N','021','DEN','2209280','99734OH005000401','2014-01-01','2013-12-18 14:30:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:59'),(14353,11447,'Y','18','021','EC','A','','','AC','0001114543','0001114543','OH00000822141','IL','1','ARIDGE','PAMELA','','','','34','271528961','1454 W RIVER NORTH',0,'ELYRIA','OH','44035',NULL,'CY','39093','1952-10-26','F','U',':RET:2054-5','N','021','DEN','1734060','99734OH005000401','2014-02-01','2013-12-26 18:34:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:04'),(9194,7291,'N','19','021','EC','A',NULL,NULL,'','0000180978','0001166778','','IL','1','barton','andrew','d','','','34','271960987','5086 Norwich rd',0,'toledo','OH','43615',NULL,'CY','39095','1992-11-12','M','',':RET:2106-3','N','021','HLT','1424322','92036OH006002601','2014-01-01','2013-12-18 11:03:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','154.64',NULL,0,'2013-12-26 04:09:28'),(25069,19881,'Y','18','021','EC','A','','','AC','0000367433','0000367433','OH00001984686','IL','1','Garcia Diaz','Carlos','R','','','34','262857992','6915 MADISON AVE',0,'CLEVELAND','OH','44102','4039','CY','39035','1965-11-07','M','M',NULL,'N','021','DEN','3271602','99734OH005000401','2014-04-01','2014-02-20 17:14:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:01:29'),(25563,20279,'Y','18','021','EC','A','','','AC','0000087629','0000087629','TX00002699892','IL','1','Williams','Charlotte','Mitchell','','','34','460195691','121 S. Frank Rd.',0,'Trinity','TX','75862',NULL,'CY','48455','1968-12-18','F','M',':RET:2106-3','N','021','DEN','3144644','33348TX002000101','2014-04-01','2014-02-23 17:52:04','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-02-26 08:00:24'),(26246,20816,'Y','18','021','EC','A','','','AC','0000833052','0000833052','TX00002573108','IL','1','Butler','Patricia','','','','34','452157626','1008 N Church St',0,'Mckinney','TX','75069',NULL,'CY','48085','1957-10-14','F','M',NULL,'N','021','DEN','3242235','33348TX002000201','2014-04-01','2014-02-27 12:19:42','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-28 06:31:06'),(28754,22758,'Y','18','021','EC','A','','','AC','0000330696','0000330696','TX00003214381','IL','1','nava','eric','','','','34','464231467','345 Buena Vista',0,'El Paso','TX','79905',NULL,'CY','48141','1963-01-26','M','M',':RET:2106-3','N','021','DEN','3180475','33348TX002000201','2014-04-01','2014-03-09 00:02:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-09 21:00:18'),(23116,18425,'Y','18','021','EC','A','','','AC','0000741764','0000741764','OH00002283262','IL','1','Lukens','Lois','','','','34','282525098','119 INGLESIDE AVE',0,'MARIETTA','OH','45750','3412','CY','39167','1953-01-20','F','U',NULL,'N','021','DEN','2836847','99734OH005000401','2014-03-01','2014-02-12 10:30:41','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-02-12 21:31:21'),(1404,1166,'Y','18','021','EC','A','','','AC','0001947407','0001947407','LA00001209668','IL','1','BOLTON','SARAH','','','','34','501174388','41023 COTTO RD',0,'GONZALES','LA','70737','7031','CY','22005','1984-10-13','F','U',NULL,'N','021','DEN','1653859','18575LA002000201','2014-01-01','2013-12-24 12:32:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:41'),(3722,2974,'Y','18','021','EC','A','','','AC','0000529423','0000529423','OH00000224371','IL','1','Fiorvanti','Patti',NULL,NULL,NULL,NULL,NULL,'3026 Green Arbor Lane',0,'Dublin','OH','43017',NULL,'CY','39049','1949-10-15','F','U',':RET:2106-3','N','021','DEN','321485','99734OH005000401','2014-01-01','2013-12-13 15:20:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:32:23'),(21860,17453,'N','01','021','EC','A',NULL,NULL,'','0000378617','0000701733','','IL','1','SETON','CAROL','','','','34','189783653','2411 WIMBLEDON PARK BLVD',0,'TOLEDO','OH','43617','2237','CY','39095','1997-02-07','F','',NULL,'N','021','DEN','3239687','99734OH005000301','2014-03-01','2014-02-06 14:02:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:19'),(5200,4126,'Y','18','024','14','A','','','TE','0000924772','0000924772','','IL','1','meier','manfred',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-09-22','M','',NULL,NULL,NULL,'','1049292','','2013-12-19','2013-12-19 14:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:00'),(21042,16811,'N','01','021','EC','A',NULL,NULL,'','0000510679','0000392395','','IL','1','Gott','Liana','','','','34','304949725','11088 PHILLIPS RD',0,'BLUFFTON','OH','45817','9512','CY','39003','1969-09-30','F','',NULL,'N','021','HLT','3395017','92036OH005001505','2014-03-01','2014-02-01 14:57:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','307.46',NULL,0,'2014-02-01 19:00:50'),(14839,11850,'Y','18','021','EC','A','','','AC','0000614111','0000614111','OH00000050756','IL','1','Golden','Tracy','','','','34','287763882','6028 PINEMOOR  STREET',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1974-12-12','F','M',':RET:2106-3','T','021','DEN','1653797','99734OH005000301','2014-01-01','2013-12-23 20:35:46','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:14:47'),(16090,12886,'Y','18','021','EC','A','','','AC','0000455961','0000455961','MS00001938776','IL','1','POWELL','TIMOTHY','','','','34','426734556','9143 NEW ZION RD',0,'UTICH','MS','39175',NULL,'CY','28029','1992-01-02','M','U',NULL,'N','021','DEN','2383906','46300MS002000201','2014-02-01','2014-01-03 10:52:14','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-04 02:04:23'),(17154,13725,'Y','18','021','EC','A','','','AC','0001816688','0001816688','LA00002356907','IL','1','Morse','Clairesse','','','','34','553614966','70330 A ST',0,'COVINGTON','LA','70433','5451','CY','22103','1980-01-10','F','M',':RET:1002-5','N','021','DEN','1476825','18575LA002000201','2014-02-01','2014-01-07 23:37:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:58'),(17458,13960,'Y','18','021','EC','A','','','AC','0001063263','0001063263','OH00001448842','IL','1','Orzechowski','Frances','S','','','34','282489336','6052 BLOSSMAN RD',0,'TOLEDO','OH','43617','1004','CY','39095','1954-07-19','F','M',':RET:2106-3','N','021','HLT','2327496','92036OH003002601','2014-02-01','2014-01-10 15:34:46','0.00',NULL,NULL,'530.07','530.07','R-OH001','OH0','530.07',NULL,0,'2014-01-13 03:00:41'),(18274,14589,'Y','18','021','EC','A','','','AC','0000627354','0000627354','TX00001887401','IL','1','Jaskula','Robert','','','','34','358764036','2500 S 5TH ST',0,'AUSTIN','TX','78704','5337','CY','48453','1986-08-08','M','U',':RET:2106-3','N','021','DEN','2173796','33348TX002000201','2014-02-01','2014-01-15 17:43:07','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-16 08:44:43'),(19271,15359,'Y','18','021','EC','A','','','AC','0001855100','0001855100','LA00001550850','IL','1','Beam','Micheal','','','','34','436557493','4220 Reily Lane',0,'Shreveport','LA','71105',NULL,'CY','22017','1978-08-10','M','U',':RET:2106-3','N','021','DEN','2788411','18575LA002000101','2014-03-01','2014-01-19 20:01:44','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-21 08:46:54'),(24045,19123,'Y','18','024','14','A','','','TE','0000546512','0000546512','','IL','1','Soutendijk','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-01','F','',NULL,NULL,NULL,'','2740561','','2014-02-15','2014-02-15 10:51:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:01:01'),(26990,21379,'Y','18','021','EC','A','','','AC','0001104868','0001104868','MS00002842483','IL','1','Boteler','Mark','Stephen','','','34','426252493','214 BOTELER RD',0,'FLORENCE','MS','39073','8993','CY','28121','1970-09-04','M','M',':RET:2106-3','N','021','DEN','2898827','46300MS002000101','2014-04-01','2014-03-02 17:08:57','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-03-03 01:00:42'),(28545,22592,'Y','18','021','EC','A','','','AC','0001014439','0001014439','OH00002637256','IL','1','Bragg','Annette',NULL,NULL,NULL,NULL,NULL,'2260 COLUMBIA RD',0,'VALLEY CITY','OH','44280','9545','CY','39103','1963-08-17','F','M',':RET:2106-3','T','021','HLT','3248686','52664OH151001501','2014-04-01','2014-03-07 16:20:04','0.00',NULL,NULL,'1176.82','1176.82','R-OH012','OH0','549.35',NULL,0,'2014-03-07 21:32:17'),(26360,20909,'N','19','021','EC','A',NULL,NULL,'','0000060320','0000775146','','IL','1','Kulnane','Maxwell','Gaelen','','','34','271069525','582 MAGNOLIA DR',0,'PAINESVILLE','OH','44077','2624','CY','39085','2000-11-11','M','',':RET:2106-3','N','021','DEN','3087814','99734OH005000301','2014-03-01','2014-02-26 09:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:00:04'),(21980,17553,'Y','18','021','EC','A','','','AC','0001948823','0001948823','LA00001700754','IL','1','VENABLE','CATHERINE','','','','34','566112601','6901 W CONGRESS ST',0,'DUSON','LA','70529','3718','CY','22055','1958-12-22','F','M',NULL,'T','021','DEN','3285473','18575LA002000101','2014-03-01','2014-02-07 16:40:19','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-07 19:00:36'),(4375,3476,'Y','18','021','EC','A','','','AC','0000948390','0000948390','OH00000461997','IL','1','Goodfellow','Susan','','','','34','290560248','114 LONG ST',0,'NEW LEXINGTON','OH','43764','1509','CY','39127','1955-04-17','F','U',':RET:2106-3','N','021','DEN','374230','99734OH005000401','2014-01-01','2013-12-12 07:50:18','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:00:26'),(5104,4044,'N','01','021','EC','A',NULL,NULL,'','0000614928','0001227967','','IL','1','Munoz','Gustavo','','','','34','631321854','504 S OLIVE St',0,'Kermit','TX','79745',NULL,'CY','48495','1972-02-22','M','',':RET:2106-3','N','021','DEN','1640825','33348TX002000201','2014-01-01','2013-12-19 17:03:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:30'),(21628,17268,'Y','18','024','14','A','','','TE','0000030986','0000030986','','IL','1','Morris','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-01-15','M','',NULL,NULL,NULL,'','1829382','','2014-02-05','2014-02-05 10:00:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-05 21:30:39'),(20407,16299,'Y','18','021','EC','A','','','AC','0000096238','0000096238','TX00002460026','IL','1','SCOTT','LAMARCUS','JAMANE','','','34','456731066','1860 C R 302',0,'CARTHAGE','TX','75633',NULL,'CY','48365','1984-08-04','M','U',':RET:2054-5','N','021','DEN','2802527','33348TX002000201','2014-03-01','2014-01-29 16:15:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:23'),(9572,7583,'Y','18','021','EC','A','','','AC','0001218535','0001218535','OH00000833840','IL','1','Hinkle','Gregory','','','','34','222549096','2593 MAPLE DR',0,'TWINSBURG','OH','44087','2139','CY','39153','1974-10-08','M','M',':RET:2106-3','N','021','DEN','2409970','99734OH005000301','2014-01-01','2013-12-21 17:04:31','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:36:44'),(13454,10728,'Y','18','021','EC','A','','','AC','0000676709','0000676709','OH00000707487','IL','1','Arps','Amy','','','','34','295684337','740 Trail Dr',0,'Napoleon','OH','43545',NULL,'CY','39069','1973-09-28','F','U',':RET:2106-3','N','021','DEN','2523164','99734OH005000301','2014-01-01','2013-12-23 14:43:24','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-26 13:01:35'),(18792,14968,'Y','18','021','EC','A','','','AC','0000596305','0000596305','OH00002121956','IL','1','Kushner','Lauren','','','','34','268964965','1403 CROWN POINT CT',0,'BEAVERCREEK','OH','45434','6963','CY','39057','1992-10-21','F','U',':RET:2106-3','N','021','DEN','2456339','99734OH005000401','2014-03-01','2014-01-16 09:05:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:35:57'),(15703,12562,'Y','18','021','EC','A','','','AC','0000062547','0000062547','OH00001155413','IL','1','Walters','Larry',NULL,NULL,NULL,NULL,NULL,'2861 MARCIA BLVD',0,'CUYAHOGA FALLS','OH','44223','1145','CY','39153','1949-09-04','M','R',':RET:2106-3','N','021','HLT','2576470','52664OH151001501','2014-02-01','2013-12-31 13:31:43','0.00',NULL,NULL,'802.38','802.38','R-OH012','OH0','802.38',NULL,1,'2014-01-02 04:35:48'),(18261,14578,'N','01','021','EC','A',NULL,NULL,'','0001116709','0000087493','','IL','1','CONSTANCIO','CORINA','','','','34','464798193','6927 HIGHWAY 84',0,'SHALLOWATER','TX','79363','3763','CY','48303','1977-10-20','F','',NULL,'N','021','DEN','2192775','33348TX002000201','2014-02-01','2014-01-15 16:39:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-16 08:44:36'),(25961,20589,'N','19','021','EC','A',NULL,NULL,'','0000648379','0000737916','','S1','1','TAYLOR','DEMETRIUS','','','','34','271029696','231 S FINDLAY ST',0,'DAYTON','OH','45403','2658','CY','39113','1996-09-22','M','',NULL,'N','021','DEN','3479755','99734OH005000401','2014-04-01','2014-02-26 12:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:41'),(21063,16830,'Y','18','021','EC','A','','','AC','0001217398','0001217398','OH00002284299','31','1','Sattler','Kari','','','','34','302844529','P.O. Box 77',0,'Pemberville','OH','43450',NULL,'CY','39173','1983-04-27','F','U',':RET:2106-3','N','021','HLT','3328036','92036OH005002606','2014-03-01','2014-02-01 19:18:19','163.00',NULL,NULL,'221.32','58.32','R-OH001','OH0','221.32',NULL,0,'2014-02-02 19:00:13'),(903,749,'Y','18','021','EC','A','','','AC','0000846420','0000846420','MS00000257077','IL','1','Bridges','Javall','','','','34','426671464','20 SEVENTH AVE',0,'SILVER CREEK','MS','39663','2480','CY','28077','1984-10-03','F','M',':RET:2054-5','N','021','DEN','1606437','46300MS002000101','2014-01-01','2013-12-16 17:50:33','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 18:08:19'),(18444,14715,'Y','18','021','EC','A','','','AC','0001483476','0001483476','LA00001424098','31','1','MCMILLAN','MARIA','','','','34','439119715','po BOX 13224',0,'MONROE','LA','71213',NULL,'CY','22073','1957-09-30','F','U',':RET:2054-5','N','021','DEN','1805351','18575LA002000201','2014-02-01','2014-01-15 18:12:52','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-16 08:46:05'),(1088,894,'Y','18','024','14','A','','','TE','0000342698','0000342698','','IL','1','Thompson','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-10','F','',NULL,NULL,NULL,'','480068','','2013-12-03','2013-12-03 13:26:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:16:58'),(18438,14711,'Y','18','024','14','A','','','TE','0002294905','0002294905','','IL','1','Brown','Wayne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-07-14','M','',NULL,NULL,NULL,'','2368728','','2014-01-15','2014-01-15 15:26:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-16 08:46:02'),(2210,1820,'Y','18','021','EC','A','','','AC','0000859677','0000859677','OH00000236468','IL','1','Dickinson','Freda','Diane','','','34','294562079','2018 HIGHBRIDGE RD',0,'CUYAHOGA FALLS','OH','44223','1316','CY','39153','1954-10-06','F','R',':RET:2106-3','N','021','HLT','35905','52664OH151001301','2014-01-01','2013-12-10 14:21:14','0.00',NULL,NULL,'580.49','580.49','R-OH012','OH0','580.49',NULL,0,'2013-12-25 19:20:16'),(3123,2510,'Y','18','021','EC','A','','','AC','0000116560','0000116560','OH00000564744','IL','1','Gronbeck','Donald','','','','34','473176102','1751 OLDE HALEY DR',0,'CENTERVILLE','OH','45458','6053','CY','39113','1980-06-12','M','U',NULL,'N','021','DEN','654717','99734OH005000301','2014-01-01','2013-10-13 14:06:16','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:30:21'),(25594,20305,'Y','18','021','EC','A','','','AC','0000088637','0000088637','TX00002678387','IL','1','Willis','Kimberly','','','','34','453672909','2503 Panagrad',0,'Houston','TX','77082',NULL,'CY','48201','1980-12-05','F','U',':RET:2054-5','N','021','DEN','3146834','33348TX002000101','2014-03-01','2014-02-24 16:27:51','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15','CIC',0,'2014-02-26 08:00:45'),(25861,20503,'Y','18','021','EC','A','','','AC','0001785186','0001785186','LA00002613016','IL','1','Gorodnova','Irina',NULL,NULL,NULL,NULL,NULL,'304 PEAR TREE CIR',0,'BROUSSARD','LA','70518','7232','CY','22055','1991-04-14','F','M',NULL,'N','021','DEN','2639341','18575LA002000201','2014-03-01','2014-02-26 11:41:37','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 21:00:45'),(28338,22422,'Y','18','021','EC','A','','','AC','0000615277','0000615277','TX00003329441','IL','1','Bryce','Joe','','','','34','463258851','7609 SILVERTHORN DR',0,'ROWLETT','TX','75089','8657','CY','48397','1960-06-14','M','M',':RET:2106-3','N','021','DEN','3575863','33348TX002000201','2014-04-01','2014-03-07 10:24:49','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:15'),(4602,3644,'Y','18','021','EC','A','','','AC','0000214632','0000214632','OH00001160976','IL','1','Almond','John','','','','34','290502768','751 HAMMERSMITH CIR',0,'HOLLAND','OH','43528','7972','CY','39095','1952-01-13','M','M',':RET:2106-3','N','021','HLT','320213','92036OH005002605','2014-01-01','2013-12-11 19:44:56','300.00',NULL,NULL,'547.95','247.95','R-OH001','OH0','547.95',NULL,0,'2013-12-25 22:05:44'),(1218,1001,'Y','18','021','EC','A','','','AC','0000170129','0000170129','OH00000250784','IL','1','KEARNEY','SILVIA','E','','','34','296962551','1470 GRAND PARK AVE',0,'AKRON','OH','44310','2623','CY','39153','1960-02-21','F','U',NULL,'N','021','HLT','522223','52664OH151001306','2014-01-01','2013-12-03 00:40:09','384.00',NULL,NULL,'454.94','70.94','R-OH012','OH0','454.94',NULL,0,'2013-12-25 18:20:19'),(15979,12789,'Y','18','021','EC','A','','','AC','0000639964','0000639964','TX00001895014','IL','1','GREEN','GEORGIA','','','','34','550333425','1237 HANNA CIR',0,'DESOTO','TX','75115','3105','CY','48113','1963-08-24','F','U',NULL,'N','021','DEN','2245928','33348TX002000201','2014-02-01','2014-01-03 10:06:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-04 02:00:52'),(15374,12297,'Y','18','021','EC','A','','','AC','0000034371','0000034371','MS00001620009','IL','1','Delancey','Dale','','','','34','427138649','12001 OLD FORT BAYOU RD',0,'VANCLEAVE','MS','39565','9317','CY','28059','1964-06-18','M','U',':RET:2106-3','N','021','DEN','2401706','46300MS002000201','2014-02-01','2014-01-01 15:43:07','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,1,'2014-01-02 04:25:11'),(15327,12259,'Y','18','021','EC','A','','','AC','0000616198','0000616198','TX00000658672','IL','1','hill','marsha','','','','34','453131483','420 SHORT ST',0,'COLORADO CITY','TX','79512','6534','CY','48335','1971-08-06','F','R',':RET:2106-3','T','021','DEN','1599701','33348TX002000201','2014-02-01','2014-01-01 12:27:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:23:47'),(14949,11947,'Y','18','021','EC','A','','','AC','0000793441','0000793441','TX00000204594','IL','1','Duemler','Steven','','','','34','461996506','905 ROBERT E LEE RD',0,'AUSTIN','TX','78704','1401','CY','48453','1988-06-01','M','U',NULL,'N','021','DEN','1838161','33348TX002000201','2014-02-01','2013-12-29 20:49:52','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-01 12:00:06'),(9521,7550,'N','01','021','EC','A',NULL,NULL,'','0000934653','0000850493','','IL','1','Kesson','Jennifer','Marie','','','34','296844563','2944 W CENTRAL AVE',0,'TOLEDO','OH','43606','3022','CY','39095','1986-06-05','F','',NULL,'N','021','DEN','2149303','99734OH005000301','2014-01-01','2013-12-20 19:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:38'),(9307,7379,'N','01','021','EC','A',NULL,NULL,'','0000383016','0000862642','','IL','1','Rick','Elbert','Anthony','','','34','439862487','59561 COMPANY RD',0,'AMITE','LA','70422','3643','CY','22105','1954-10-31','M','',':RET:2106-3','N','021','DEN','2337092','18575LA002000101','2014-01-01','2013-12-20 20:01:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 04:30:09'),(3943,3157,'Y','18','024','14','A','','','TE','0000317319','0000317319','','IL','1','kutzli','darcy','l',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-04','F','',NULL,NULL,NULL,'','636898','','2013-12-13','2013-12-13 16:58:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:37:59'),(7008,5562,'Y','18','021','EC','A','','','AC','0001127119','0001127119','TX00000577941','IL','1','pipkin','Krystal','','','','34','641265398','7410 BOGGESS RD',0,'HOUSTON','TX','77016','3412','CY','48201','1988-03-06','F','U',':RET:2054-5','N','021','DEN','2532620','33348TX002000201','2014-01-01','2013-12-24 19:26:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:48:26'),(18545,14790,'Y','18','021','EC','A','','','AC','0000978194','0000978194','MS00001983930','IL','1','Doubet','Carla','','','','34','337464995','4002 SAINT ANDREWS CIR',0,'CORINTH','MS','38834','7243','CY','28003','1952-09-11','F','R',NULL,'N','021','DEN','2565213','46300MS002000101','2014-02-01','2014-01-15 14:54:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-16 08:46:51'),(19372,15442,'N','01','021','EC','A',NULL,NULL,'','0000881652','0000665671','','IL','1','Eaken','Linda','Kay','','','34','278524251','9481 WILLOW RD',0,'LODI','OH','44254','9630','CY','39103','1950-05-27','F','',':RET:2106-3','T','021','HLT','3079286','52664OH151001304','2014-03-01','2014-01-21 10:47:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','757.07',NULL,1,'2014-01-22 03:22:36'),(19532,15567,'Y','18','021','EC','A','','','AC','0000828263','0000828263','OH00001945363','IL','1','DUKETT','DELLA','','','','34','268646884','2423 W ALEXIS RD',0,'TOLEDO','OH','43613','2138','CY','39095','1963-08-27','F','M',':RET:2106-3','N','021','DEN','2554978','99734OH005000401','2014-03-01','2014-01-22 12:50:41','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2014-01-23 03:02:21'),(20482,16362,'Y','18','021','EC','A','','','AC','0000722667','0000722667','OH00001577079','IL','1','Brook','Claudia','','','','34','267923502','1399 Brimfield Drive',0,'Kent','OH','44240',NULL,'CY','39133','1951-10-14','F','U',':RET:2106-3','N','021','HLT','3177986','52664OH151001304','2014-03-01','2014-01-28 21:00:38','448.00',NULL,NULL,'640.70','192.70','R-OH012','OH0','640.70',NULL,0,'2014-01-29 21:01:01'),(27980,22137,'Y','18','021','EC','A','','','AC','0002305806','0002305806','LA00003631178','IL','1','COTTRELL','JOANNA','','','','34','439021809','1338 MAIN ST',0,'HAYNESVILLE','LA','71038','5920','CY','22027','1955-12-08','F','U',':RET:2054-5','N','021','DEN','3748331','18575LA002000201','2014-04-01','2014-03-06 15:52:51','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-06 21:00:56'),(192,161,'Y','18','021','EC','A','','','AC','0001171859','0001171859','OH00000491534','IL','1','Custer','Rebecca','','','','34','295623896','1655 OREGON RD',0,'TOLEDO','OH','43605','3324','CY','39095','1957-08-20','F','M',':RET:2106-3','N','021','HLT','18602','92036OH006002601','2014-01-01','2013-12-04 19:50:16','0.00',NULL,NULL,'360.78','360.78','R-OH001','OH0','360.78',NULL,0,'2013-12-25 17:20:00'),(15554,12447,'Y','18','021','EC','A','','','AC','0001896691','0001896691','LA00001436020','IL','1','Jackson','Christopher','','','','34','436217860','2445 CAMBRIDGE DR',0,'LA PLACE','LA','70068','2309','CY','22095','1967-08-20','M','U',':RET:2054-5','N','021','DEN','1985349','18575LA002000201','2014-02-01','2013-12-31 16:40:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:31:24'),(6127,4859,'Y','18','021','EC','A','','','AC','0000625007','0000625007','TX00000090748','IL','1','Picard','Debra','','','','34','457866936','119 BROOK LN N',0,'BROOKELAND','TX','75931','5710','CY','48241','1952-01-26','F','U',':RET:2106-3','N','021','DEN','1134038','33348TX002000201','2014-01-01','2013-11-21 15:58:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:15:54'),(4516,3579,'Y','18','021','EC','A','','','AC','0000515490','0000515490','TX00000856632','IL','1','colwill','joanna','','','','34','466579312','1408 SUMMERDALE LN',0,'WYLIE','TX','75098','8422','CY','48085','1976-02-24','F','U',':RET:2106-3','N','021','DEN','225291','33348TX002000201','2014-01-01','2013-12-12 11:19:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:43'),(7904,6248,'Y','18','021','EC','A','','','AC','0002352084','0002352084','LA00001240578','IL','1','rathke','chaco','','','','34','433514884','3046 burgundy st',0,'new orleans','LA','70117',NULL,'CY','22071','1982-04-17','M','U',':RET:2106-3','N','021','DEN','1868983','18575LA002000201','2014-01-01','2013-12-19 19:15:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:05:53'),(1494,1247,'Y','18','021','EC','A','','','AC','0000656935','0000656935','OH00000584172','IL','1','Lynch','Linda','','','','34','272643877','6317 Terrace Hills Dr',0,'Clinton','OH','44216',NULL,'CY','39153','1957-03-12','F','M',':RET:2106-3','N','021','DEN','1674199','99734OH005000401','2014-01-01','2013-12-24 11:22:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:49:06'),(7092,5626,'Y','18','021','EC','A','','','AC','0000846147','0000846147','OH00001287390','IL','1','bonifant','timothy','','','','34','274608090','731 6TH ST SW',0,'MASSILLON','OH','44647','7744','CY','39151','1959-06-28','M','M',':RET:2106-3','N','021','HLT','2157728','52664OH151001304','2014-01-01','2013-12-24 19:07:16','663.00',NULL,NULL,'1053.04','390.04','R-OH015','OH0','476.12',NULL,0,'2013-12-26 01:50:35'),(2822,2280,'N','01','021','EC','A',NULL,NULL,'','0000916966','0000356008','','IL','1','Cyganovich','Diana','','','','34','066440134','6718 FRANKLIN BLVD',0,'CLEVELAND','OH','44102','2915','CY','39035','1953-01-09','F','',':RET:2106-3','N','021','DEN','704342','99734OH005000301','2014-01-01','2013-11-23 18:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:00:31'),(2872,2321,'Y','18','021','EC','A','','','AC','0000247892','0000247892','TX00000233632','IL','1','ERWIN','GERALDINE','','','','34','459082112','705 PLUM CREEK RD',0,'LONGVIEW','TX','75605','7546','CY','48183','1953-10-19','F','M',':RET:2106-3','N','021','DEN','552755','33348TX002000201','2014-01-01','2013-10-21 20:19:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 20:01:57'),(19730,15723,'Y','18','021','EC','A','','','AC','0002045229','0002045229','LA00002540035','IL','1','Padilla','Marian','','','','34','435671094','123 Athania Pkwy',0,'Metairie','LA','70001',NULL,'CY','22051','1972-06-02','F','U',NULL,'N','021','DEN','2410934','18575LA002000201','2014-03-01','2014-01-23 16:41:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:05'),(22534,17992,'Y','18','021','EC','A','','','AC','0000568420','0000568420','MS00001445289','IL','1','watson','james','rodney','','','34','461150854','426 BOEHLE ST',0,'PEARL','MS','39208','5028','CY','28121','1974-04-01','M','U',':RET:2106-3','N','021','DEN','3691854','46300MS002000201','2014-03-01','2014-02-10 09:31:43','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 21:31:34'),(22659,18094,'Y','18','021','EC','A','','','AC','0000259175','0000259175','TX00002258483','IL','1','BURAYE','SANDRA','I','','','34','568574697','2009 78th street',0,'lubbock','TX','79423',NULL,'CY','48303','1956-07-21','F','U',NULL,'N','021','DEN','3256011','33348TX002000201','2014-03-01','2014-02-11 13:08:33','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-11 21:00:33'),(24275,19278,'Y','18','021','EC','A','','','AC','0000794468','0000794468','OH00002521278','IL','1','Kelby','Susan','','','','34','299684258','11277 W SPRAGUE RD',0,'NORTH ROYALTON','OH','44133','1265','CY','39035','1966-05-04','F','U',':RET:2106-3','N','021','DEN','3089943','99734OH005000401','2014-04-01','2014-02-18 09:27:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-18 21:30:03'),(24928,19768,'Y','18','024','14','A','','','TE','0000836638','0000836638','','IL','1','ANGERSTIEN','DENISE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-30','F','',NULL,NULL,NULL,'','1632218','','2014-02-28','2014-02-20 16:08:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:18'),(25487,20220,'Y','18','021','EC','A','','','AC','0000446825','0000446825','MS00003138282','31','1','WELLS','MICHAEL','','','','34','587411940','PO BOX 14903',0,'PHILADELPHIA','MO','39350',NULL,'CY','28099','1968-02-20','M','M',':RET:2106-3','N','021','DEN','3637743','46300MS002000201','2014-04-01','2014-02-25 12:06:02','0.00',NULL,NULL,'88.07','88.07','R-MS006','MS0','15.85',NULL,0,'2014-02-25 21:31:46'),(5266,4177,'Y','18','021','EC','A','','','AC','0000253038','0000253038','OH00001280405','IL','1','Norris','Robert','','','','34','301682668','1652 Chaffin Rd',0,'Akron','OH','44306',NULL,'CY','39153','1974-01-06','M','U',':RET:2106-3','N','021','HLT','1570677','52664OH151001306','2014-01-01','2013-12-19 11:46:16','190.00',NULL,NULL,'281.44','91.44','R-OH012','OH0','281.44',NULL,0,'2013-12-25 23:05:29'),(13064,10413,'Y','18','021','EC','A','','','AC','0000629231','0000629231','OH00001292373','IL','1','Robson','Elihudi','','','','34','288131590','3450 Partridge place',0,'Columbus','OH','43231',NULL,'CY','39049','1969-06-21','M','M',':RET:2054-5','N','021','DEN','2439429','99734OH005000401','2014-01-01','2013-12-23 09:31:35','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:07'),(9306,7379,'Y','18','021','EC','A','','','AC','0000383016','0000383016','LA00001107430','IL','1','Rick','Melanie','H','','','34','433196933','59561 COMPANY RD',0,'AMITE','LA','70422','3643','CY','22105','1961-08-12','F','M',':RET:2106-3','N','021','DEN','2337092','18575LA002000101','2014-01-01','2013-12-20 20:01:48','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-26 04:30:08'),(7392,5852,'Y','18','021','EC','A','','','AC','0000172370','0000172370','OH00000663774','IL','1','Smith','Lorry','Ann','','','34','290601728','685 East Main Street',0,'Williamsburg','OH','45176',NULL,'CY','39025','1969-10-17','F','U',':RET:2106-3','N','021','HLT','517143','92036OH001000601','2014-01-01','2013-11-23 17:23:09','0.00',NULL,NULL,'914.58','914.58','R-OH005','OH0','361.74',NULL,0,'2013-12-26 02:16:13'),(19959,15921,'Y','18','021','EC','A','','','AC','0001187790','0001187790','TX00001829856','IL','1','Johnson','Sandra','','','','34','465354354','603 N SCHOPMEYER ST',0,'GAINESVILLE','TX','76240','3322','CY','48097','1960-12-01','F','U',':RET:2106-3','N','021','DEN','2657182','33348TX002000201','2014-03-01','2014-01-25 13:22:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-25 19:00:06'),(23767,18913,'Y','18','021','EC','A','','','AC','0000205834','0000205834','OH00001959554','IL','1','lindsey','dorian','','','','34','355544303','1068 PIERMONT RD',0,'SOUTH EUCLID','OH','44121','2935','CY','39035','1975-09-19','M','U',':RET:2054-5','N','021','DEN','3718587','99734OH005000301','2014-03-01','2014-02-14 16:21:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:31:12'),(24926,19766,'Y','18','021','EC','A','','','AC','0000727656','0000727656','MS00002663097','IL','1','GRIFFIN','LEON','','','','34','425551284','3340 PATTERSON DR',0,'PEARL','MS','39208','3635','CY','28121','1985-07-04','M','U',':RET:2054-5','N','021','DEN','3431815','46300MS002000201','2014-04-01','2014-02-20 14:25:24','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85','CIC',0,'2014-02-20 21:30:17'),(25431,20179,'Y','18','021','EC','A','','','AC','0000375619','0000375619','TX00002444663','IL','1','HONG','YOUNG GI','','','','34','640847661','1009 LIVERMORE ST',0,'PORTLAND','TX','78374','4209','CY','48409','1964-05-18','M','M',':RET:2040-4','T','021','DEN','3174494','33348TX002000201','2014-04-01','2014-02-24 20:26:30','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-02-25 21:31:15'),(26264,20831,'N','01','021','EC','A',NULL,NULL,'','0000923928','0000056983','','IL','1','GARZA','ESTELA','','','','34','464044028','2918 E RICHARDSON RD',0,'EDINBURG','TX','78542','0464','CY','48215','1967-12-13','F','',NULL,'N','021','DEN','3183628','33348TX002000201','2014-04-01','2014-02-27 15:59:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 06:31:13'),(3852,3082,'Y','18','021','EC','A','','','AC','0000376474','0000376474','LA00000550458','IL','1','Fountain','Shantel','','','','34','463619785','418 W Chruch St',0,'Opelousas','LA','70570',NULL,'CY','22097','1982-05-04','F','U',':RET:2054-5','T','021','DEN','309009','18575LA002000101','2014-01-01','2013-12-13 14:09:27','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 21:35:40'),(3684,2949,'Y','18','021','EC','A','','','AC','0000186093','0000186093','OH00001087427','IL','1','Durbin','Donald','','','','34','048509261','1772 Allen Road',0,'Salem','OH','44460',NULL,'CY','39029','1953-12-08','M','R',':RET:2106-3','N','021','DEN','426022','99734OH005000401','2014-01-01','2013-12-13 10:09:43','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:31:32'),(14408,11490,'Y','18','024','14','A','','','TE','0000867606','0000867606','','IL','1','Day','Matthew','Wayne',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-21','M','',NULL,NULL,NULL,'','1792176','','2013-12-26','2013-12-26 18:31:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:31:22'),(9375,7433,'Y','18','021','EC','A','','','AC','0001942226','0001942226','LA00000210307','IL','1','willis','shalonda','','','','34','433276602','57947 center street',0,'plaquemine','LA','70764',NULL,'CY','22047','1975-03-24','F','U',':RET:2054-5','T','021','DEN','2546027','18575LA002000201','2014-01-01','2013-12-21 14:27:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:55'),(3214,2585,'N','01','021','EC','A',NULL,NULL,'','0000263911','0000764633','','IL','1','Hargrave','Leonard','Bruce','','','34','457802459','5613 WILLOWBROOK DR',0,'ROWLETT','TX','75088','7663','CY','48113','1951-02-04','M','',':RET:2106-3','N','021','DEN','224878','33348TX002000201','2014-01-01','2013-10-31 18:39:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 20:45:30'),(18706,14913,'N','01','021','EC','A',NULL,NULL,'','0000714999','0000808681','','IL','1','Dwillis','Teri','Lee','','','34','272789015','503 CALEB DR',0,'BROOKVILLE','OH','45309','1386','CY','39113','1964-12-26','F','',':RET:2106-3','N','021','DEN','2733689','99734OH005000301','2014-02-01','2014-01-15 21:02:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:30'),(20836,16654,'Y','18','021','EC','A','','','AC','0000696847','0000696847','OH00001932600','IL','1','Drugan','Cris','','','','34','273467246','1660 CREIGHTON AVE',0,'AKRON','OH','44310','2612','CY','39153','1963-02-08','M','M',':RET:2106-3','N','021','HLT','2698996','52664OH151001305','2014-03-01','2014-01-31 09:43:21','592.00',NULL,NULL,'831.82','239.82','R-OH012','OH0','415.91',NULL,0,'2014-01-31 21:00:44'),(21592,17247,'Y','18','021','EC','A','','','AC','0001160446','0001160446','OH00002361129','IL','1','Sheeley','Amy','','','','34','295749807','504 DAKOTA RD',0,'BELLEFONTAINE','OH','43311','2347','CY','39091','1978-10-26','F','M',':RET:2106-3','N','021','DEN','3810658','99734OH005000301','2014-03-01','2014-02-05 10:41:57','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:29'),(21697,17325,'Y','18','024','14','A','','','TE','0000460609','0000460609','','IL','1','Chung','Terrence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-11-29','M','',NULL,NULL,NULL,'','1596811','','2014-02-04','2014-02-04 20:51:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-05 21:31:09'),(24227,19239,'N','01','021','EC','A',NULL,NULL,'','0001142221','0001029422','','IL','1','Mahaseth','Binam','','','','34','270177762','2106 FARLEIGH RD',0,'UPPER ARLINGTON','OH','43221','2702','CY','39049','1970-06-18','F','',':RET:2028-9','N','021','DEN','3082253','99734OH005000401','2014-03-01','2014-02-15 22:51:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:31'),(25470,20207,'Y','18','021','EC','A','','','AC','0000488090','0000488090','TX00003041056','IL','1','DING','LIYA','','','','34','640403460','2210 CROSSMILL LN',0,'KATY','TX','77450','6778','CY','48201','1976-03-17','F','U',':RET:2034-7','N','021','DEN','2760157','33348TX002000201','2014-04-01','2014-02-25 16:37:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:36'),(26542,21046,'N','01','021','EC','A',NULL,NULL,'','0001231829','0000179965','','IL','1','Brown','Gail','D','','','34','290508899','7042 PINEVIEW DR',0,'HUBER HEIGHTS','OH','45424','2554','CY','39113','1955-12-30','F','',':RET:2106-3','N','021','DEN','2965706','99734OH005000301','2014-04-01','2014-02-28 12:02:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:09'),(28891,22867,'Y','18','024','14','A','','','TE','0000242590','0000242590','','IL','1','SANDERS','YVONE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-09-21','F','',NULL,NULL,NULL,'','2906700','','2014-03-10','2014-03-10 15:18:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-10 21:00:15'),(9403,7459,'Y','18','021','EC','A','','','AC','0001194125','0001194125','TX00000503725','IL','1','FERGUSON','LINDA','','','','34','451883752','919 CURRY ST',0,'BAYTOWN','TX','77521','6527','CY','48201','1949-05-17','F','M',':RET:2106-3','N','021','DEN','2066699','33348TX002000201','2014-01-01','2013-12-21 06:19:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:32:39'),(9615,7615,'Y','18','021','EC','A','','','AC','0000414692','0000414692','OH00000620437','IL','1','STEWART','JAMES','','','','34','292801013','5810 MILONA CT',0,'FAIRFIELD','OH','45014','5538','CY','39017','1967-09-14','M','U',':RET:2106-3','N','021','HLT','1947856','92036OH005001204','2014-01-01','2013-12-20 20:03:12','206.56',NULL,NULL,'458.32','251.76','R-OH004','OH0','322.00',NULL,0,'2013-12-26 04:37:45'),(15711,12568,'Y','18','021','EC','A','','','AC','0000667792','0000667792','OH00000540777','IL','1','Gorski','Theresa','','','','34','289760811','3820 WHITMAN AVE',0,'CLEVELAND','OH','44113','3233','CY','39035','1979-01-14','F','U',':RET:2106-3','N','021','HLT','2295239','92036OH005000805','2014-02-01','2013-12-31 15:51:36','171.00',NULL,NULL,'285.69','114.69','R-OH011','OH0','285.69',NULL,1,'2014-01-02 04:36:03'),(14418,11499,'Y','18','024','14','A','','','TE','0000689561','0000689561','','IL','1','Mirelez','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-05-22','M','',NULL,NULL,NULL,'','1586934','','2013-12-27','2013-12-27 10:33:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:31:38'),(26985,21376,'Y','18','021','EC','A','','','AC','0001120007','0001120007','OH00003108655','IL','1','BROOKS','JULIE','','','','34','269527406','5640 WINDRIDGE VW',0,'CINCINNATI','OH','45243','2979','CY','39061','1959-08-26','F','U',NULL,'N','021','HLT','3186387','92036OH005001206','2014-04-01','2014-03-02 15:29:38','352.00',NULL,NULL,'458.32','106.32','R-OH004','OH0','458.32',NULL,0,'2014-03-03 01:00:39'),(27348,21656,'Y','18','021','EC','A','','','AC','0000928555','0000928555','OH00002764220','IL','1','BURGESS','JOHN','F','','','34','273560050','6421 OLENTANGY RIVER RD',0,'DELWARE','OH','43015',NULL,'CY','39041','1959-12-30','M','U',':RET:2106-3','T','021','DEN','3359495','99734OH005000401','2014-04-01','2014-03-04 12:26:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-04 21:01:03'),(28650,22671,'Y','18','024','14','A','','','TE','0001179676','0001179676','','IL','1','Hayes','Beverly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-08-21','F','',NULL,NULL,NULL,'','3452252','','2014-03-07','2014-03-07 18:28:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-08 21:30:37'),(29176,23092,'Y','18','021','EC','A','','','AC','0000393743','0000393743','OH00003026896','IL','1','SNEED','DONNELL','','','','34','268745164','2444 WRIGHT RD',0,'AKRON','OH','44320','2448','CY','39153','1966-12-25','M','M',':RET:2054-5','N','021','HLT','4223964','52664OH151001501','2014-04-01','2014-03-10 16:58:34','306.00',NULL,NULL,'744.89','438.89','R-OH012','OH0','418.05',NULL,0,'2014-03-10 21:03:02'),(20952,16743,'Y','18','021','EC','A','','','AC','0001235507','0001235507','TX00001880405','IL','1','LUNA','RENE','','','','34','467139464','4312 PIZZARO DR',0,'EDINBURG','TX','78542',NULL,'CY','48215','1960-09-05','M','M',NULL,'T','021','DEN','2801088','33348TX002000201','2014-03-01','2014-01-31 19:31:08','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-01 19:00:05'),(14903,11905,'Y','18','021','EC','A','','','AC','0000108159','0000108159','OH00001359591','IL','1','Yoshimura','Shoko','','','','34','575356512','2850 CHURCHILL DR',0,'COLUMBUS','OH','43221','2542','CY','39049','1956-05-14','F','U',NULL,'N','021','DEN','1670334','99734OH005000301','2014-02-01','2013-12-29 06:01:20','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-30 00:01:11'),(21752,17370,'N','01','021','EC','A',NULL,NULL,'','0000563063','0000560629','','IL','1','Ros','Sarann','','','','34','528479374','4618 LAWLER RD',0,'GARLAND','TX','75042','4500','CY','48113','1984-03-16','F','',':RET:2028-9','N','021','DEN','2660797','33348TX002000201','2014-03-01','2014-02-05 21:17:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-06 21:00:21'),(3036,2441,'Y','18','021','EC','A','','','AC','0000137542','0000137542','OH00000063617','IL','1','Watkins','Martha','','','','34','283484119','3065 POWELL RD',0,'KENT','OH','44240','5234','CY','39153','1950-12-25','F','M',':RET:2106-3','N','021','HLT','861634','52664OH152000901','2014-01-01','2013-12-06 17:22:24','186.00',NULL,NULL,'482.18','296.18','R-OH012','OH0','482.18',NULL,0,'2013-12-25 20:18:32'),(5787,4597,'N','19','021','EC','A',NULL,NULL,'','0000518419','0000026622','','IL','1','Harper','Kolina','Sheri',NULL,NULL,NULL,NULL,'7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1992-11-22','F','',':RET:2106-3','N','021','DEN','1997609','99734OH005000401','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:47:12'),(5285,4188,'Y','18','021','EC','A','','','AC','0000061308','0000061308','OH00000539050','IL','1','Landry','Douglas','I','','','34','278547203','3188 SURREY HILL LN',0,'STOW','OH','44224','4757','CY','39153','1953-07-11','M','M',':RET:2106-3','N','021','HLT','2104845','52664OH151001305','2014-01-01','2013-12-19 15:26:58','997.00',NULL,NULL,'1263.56','266.56','R-OH012','OH0','605.24',NULL,0,'2013-12-25 23:05:53'),(14707,11743,'Y','18','021','EC','A','','','AC','0000196147','0000196147','OH00000241168','IL','1','Christlieb','Kevin','','','','34','269760980','4033 W LINCOLN HWY',0,'ELIDA','OH','45807','9790','CY','39003','1966-02-21','M','M',':RET:2106-3','T','021','DEN','2341672','99734OH005000301','2014-02-01','2013-12-28 14:33:54','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,1,'2013-12-29 11:09:14'),(3914,3132,'Y','18','021','EC','A','','','AC','0000980930','0000980930','TX00000892341','IL','1','Hernandez','Michael','','','','34','456373293','4943 PETTUS',0,'SAN ANTONIO','TX','78228','4644','CY','48029','1961-07-19','M','U',NULL,'N','021','DEN','865712','33348TX002000101','2014-01-01','2013-12-13 14:06:16','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 21:37:11'),(4130,3298,'Y','18','021','EC','A','','','AC','0000882836','0000882836','OH00000970983','IL','1','GAMBLE','WAYNE','WINFRED','','','34','291529443','3145 WILLIAMSBURG ST NW',0,'WARREN','OH','44485','2256','CY','39155','1955-06-15','M','M',':RET:2054-5','N','021','DEN','2065380','99734OH005000301','2014-01-01','2013-12-17 08:51:53','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:48:23'),(9552,7570,'Y','18','021','EC','A','','','AC','0000448766','0000448766','OH00000690447','IL','1','Armentrout','Courtney','Lee','','','34','276942058','992 Ravenna Rd',0,'Kent','OH','44240',NULL,'CY','39133','1990-11-20','F','U',':RET:2106-3','N','021','DEN','2342492','99734OH005000301','2014-01-01','2013-12-21 13:30:31','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:36:19'),(13224,10550,'Y','18','021','EC','A','','','AC','0000782785','0000782785','TX00001111273','IL','1','Jarmon','Tiana','','','','34','644284981','3411 VictoriaCircle',0,'killeen','TX','76543',NULL,'CY','48027','1992-01-21','F','U',':RET:2054-5','N','021','DEN','2532397','33348TX002000201','2014-01-01','2013-12-22 20:57:54','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 12:55:33'),(13041,10397,'Y','18','021','EC','A','','','AC','0001242972','0001242972','OH00000675211','IL','1','Mehaffey','Mapuka','','','','34','294921327','1721 BENSON DR',0,'DAYTON','OH','45406','4030','CY','39113','1966-06-16','F','M',':RET:2054-5','N','021','DEN','2440963','99734OH005000401','2014-01-01','2013-12-23 07:00:43','0.00',NULL,NULL,'50.05','50.05','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:50:38'),(27445,21720,'N','01','021','EC','A',NULL,NULL,'','0000292030','0000220031','','IL','1','Luttrell','Linda','J','','','34','278543516','2951 MEADOWLAND ST',0,'UNIONTOWN','OH','44685','9727','CY','39153','1953-01-26','F','',':RET:2106-3','N','021','HLT','3941019','52664OH151001501','2014-04-01','2014-03-03 19:29:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2014-03-04 21:01:55'),(27553,21794,'N','01','021','EC','A',NULL,NULL,'','0000605503','0000385271','','IL','1','RAMIREZ','RAUL','','','Jr','34','449024595','701 LA PALMA ST',0,'SAN BENITO','TX','78586','4209','CY','48061','1956-02-02','M','',NULL,'N','021','DEN','2751301','33348TX002000201','2014-04-01','2014-03-04 12:57:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-04 21:30:13'),(22395,17882,'Y','18','021','EC','A','','','AC','0000285673','0000285673','OH00001697193','IL','1','Shaw','Margaret','','','','34','176429931','5421 BEECHWOOD RD',0,'RAVENNA','OH','44266','9172','CY','39133','1950-05-01','F','U',':RET:2106-3','T','021','HLT','3756901','52664OH151001305','2014-03-01','2014-02-10 13:36:22','515.00',NULL,NULL,'757.07','242.07','R-OH012','OH0','757.07',NULL,0,'2014-02-10 21:30:17'),(7354,5824,'Y','18','021','EC','A','','','AC','0000780247','0000780247','TX00001156909','IL','1','Bernal','Rexana','','','','34','461792442','3033 BARDIN RD',0,'GRAND PRAIRIE','TX','75052','3872','CY','48113','1986-09-08','F','U',NULL,'N','021','DEN','578720','33348TX002000201','2014-01-01','2013-11-23 09:20:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:15:12'),(21463,17152,'N','19','021','EC','A',NULL,NULL,'','0001114567','0000025336','','IL','1','BERNATOVICZ','MALLORY','','','','34','290153667','1000 ROBINWOOD HILLS DR',0,'AKRON','OH','44333','1554','CY','39153','2009-12-28','F','',NULL,'N','021','HLT','3471935','52664OH151001301','2014-03-01','2014-02-04 18:01:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-04 21:01:34'),(19880,15858,'Y','18','021','EC','A','','','AC','0001125466','0001125466','OH00002250481','IL','1','VASEY','JODY','','','','34','302562517','871 DORIS DR',0,'HUBBARD','OH','44425','1206','CY','39155','1955-11-24','F','U',':RET:2106-3','N','021','DEN','2590831','99734OH005000401','2014-03-01','2014-01-24 14:41:52','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-24 21:00:46'),(16539,13230,'Y','18','021','EC','A','','','AC','0000603377','0000603377','OH00001175320','IL','1','DeBacco','Stephen','','','','34','286786731','179 GOODHUE DR',0,'AKRON','OH','44313','6167','CY','39153','1979-09-29','M','U',':RET:2106-3','N','021','HLT','2458925','52664OH152000901','2014-02-01','2014-01-05 14:06:56','37.00',NULL,NULL,'198.30','161.30','R-OH012','OH0','198.30',NULL,1,'2014-01-07 10:22:17'),(5116,4054,'Y','18','021','EC','A','','','AC','0000660277','0000660277','TX00000100956','IL','1','HO','THANH','','','','34','606236926','13306 Vineyard Falls Dr',0,'Houston','TX','77083',NULL,'CY','48201','1970-07-19','F','M',':RET:2047-9','N','021','DEN','1947799','33348TX002000201','2014-01-01','2013-12-19 18:19:14','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:01:49'),(14172,11299,'Y','18','021','EC','A','','','AC','0000533863','0000533863','TX00000818540','IL','1','Simmons','Paul','','','','34','500763996','4420 N HALL ST',0,'DALLAS','TX','75219','2006','CY','48113','1963-01-04','M','U',':RET:2106-3','N','021','DEN','1948178','33348TX002000201','2014-02-01','2013-12-25 21:55:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-27 02:03:29'),(13685,10920,'Y','18','021','EC','A','','','AC','0000190195','0000190195','OH00000362276','31','1','chick','joseph','','','','34','277821532','29920 euclid ave',0,'wickliffe','OH','44092',NULL,'CY','39085','1969-08-04','M','M',':RET:2106-3','N','021','HLT','1756418','52664OH151001305','2014-01-01','2013-12-23 09:43:06','306.00',NULL,NULL,'716.40','410.40','R-OH011','OH0','351.37',NULL,0,'2013-12-26 13:08:18'),(13437,10719,'Y','18','021','EC','A','','','AC','0001033655','0001033655','OH00001238357','IL','1','Woods','Cheryl','','','','34','283520392','874 WADE WALK',0,'CINCINNATI','OH','45214','3419','CY','39061','1952-03-30','F','M',':RET:2054-5','N','021','DEN','1744458','99734OH005000301','2014-01-01','2013-12-23 13:24:52','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:12'),(23909,19018,'N','19','021','EC','A',NULL,NULL,'','0000874746','0000253092','','S1','1','Vanculin','Lyle','','','','34','279044795','189 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1424','CY','39023','1999-04-26','M','',':RET:2106-3','N','021','HLT','3411645','92036OH002000501','2014-03-01','2014-02-14 16:44:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','174.32',NULL,0,'2014-02-14 21:32:28'),(24152,19190,'Y','18','021','EC','A','','','AC','0000003625','0000003625','OH00001896066','IL','1','Houston','Darlene','','','','34','413982793','4181 Otter Creek Drive',0,'Amelia','OH','45102',NULL,'CY','39025','1955-09-10','F','U',':RET:2106-3','N','021','HLT','2858823','92036OH005000604','2014-03-01','2014-02-15 11:28:20','317.00',NULL,NULL,'546.97','229.97','R-OH005','OH0','546.97',NULL,0,'2014-02-15 22:01:57'),(25217,20002,'Y','18','021','EC','A','','','AC','0001157590','0001157590','OH00002440442','IL','1','Collett','Robert','','','','34','275525116','6755 WINDWARD HILLS DR',0,'BRECKSVILLE','OH','44141','2469','CY','39035','1953-07-09','M','M',NULL,'N','021','DEN','3238736','99734OH005000301','2014-04-01','2014-02-21 17:36:10','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:54'),(26734,21188,'N','01','021','EC','A',NULL,NULL,'','0000739075','0001046901','','IL','1','kraft','david','d','','','34','338728452','623 SOUTH ST',0,'FINDLAY','OH','45840','5927','CY','39063','1970-12-01','M','',':RET:2106-3','N','021','HLT','2713469','92036OH004001501','2014-04-01','2014-02-28 12:50:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.14',NULL,0,'2014-02-28 21:31:50'),(27529,21779,'N','01','021','EC','A',NULL,NULL,'','0000536992','0000376201','','IL','1','Peterson','Dawn','','','','34','288609950','6731 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9414','CY','39123','1975-11-24','F','',':RET:2106-3','N','021','HLT','3477579','92036OH006002701','2014-04-01','2014-03-04 16:36:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','192.70',NULL,0,'2014-03-04 21:02:46'),(27812,21997,'Y','18','021','EC','A','','','AC','0000525639','0000525639','OH00003074328','IL','1','Ferzzell','Dianna','Lindsey','','','34','290502941','12315 WADE PARK AVE',0,'CLEVELAND','OH','44106','4442','CY','39035','1951-12-21','F','U',':RET:2054-5','N','021','HLT','3603841','52664OH151001301','2014-04-01','2014-03-05 15:34:00','325.00',NULL,NULL,'722.61','397.61','R-OH011','OH0','722.61',NULL,0,'2014-03-05 21:31:51'),(22138,17670,'Y','18','021','EC','A','','','AC','0001095701','0001095701','OH00002212372','IL','1','SELF','STEPHEN','A','','','34','293486538','816 WILLARD ST',0,'WASHINGTON COURT HOUSE','OH','43160','2157','CY','39047','1950-01-21','M','M',':RET:2106-3','N','021','DEN','3616832','99734OH005000401','2014-03-01','2014-02-08 17:35:21','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-08 19:00:47'),(19247,15337,'Y','18','024','14','A','','','TE','0001112200','0001112200','','IL','1','reed','wendy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-23','F','',NULL,NULL,NULL,'','2497056','','2014-01-20','2014-01-20 13:42:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-21 08:46:41'),(15860,12699,'Y','18','021','EC','A','','','AC','0001123430','0001123430','MS00001415443','IL','1','Manning','Mary','','','','34','587647267','353 E PEACE ST',0,'CANTON','MS','39046','4618','CY','28089','1955-04-15','F','M',':RET:2054-5','N','021','DEN','1789899','46300MS002000101','2014-02-01','2014-01-02 10:30:57','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-03 02:04:45'),(4347,3450,'N','01','021','EC','A',NULL,NULL,'','0000878253','0000322125','','IL','1','Schnipke','Terry','','','','34','298806206','3723 road 16',0,'continental','OH','45831',NULL,'CY','39137','1981-01-27','M','',':RET:2106-3','N','021','HLT','1431241','92036OH006001501','2014-01-01','2013-12-17 12:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','206.48',NULL,0,'2013-12-25 21:53:21'),(1461,1218,'Y','18','021','EC','A','','','AC','0000209634','0000209634','OH00001153758','IL','1','Lange','Nancy','','','','34','283486985','2715 Silver Springs Dr',0,'Norton','OH','44203',NULL,'CY','39153','1950-02-02','F','U',':RET:2106-3','N','021','DEN','2317935','99734OH005000401','2014-01-01','2013-12-24 08:53:46','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:48:20'),(2897,2337,'N','19','021','EC','A',NULL,NULL,'','0000949487','0000914408','','IL','1','Overfield','Kyle','W','','','34','287947937','1436 RUTH AVE',0,'CUYAHOGA FALLS','OH','44221','2938','CY','39153','1991-12-23','M','',':RET:2106-3','N','021','HLT','56941','52664OH151001501','2014-01-01','2013-12-06 15:24:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2013-12-25 20:15:16'),(6438,5106,'Y','18','021','EC','A','','','AC','0000902046','0000902046','LA00000329156','IL','1','celestin','wanda','','','','34','433516534','201 BARKSDALE DR',0,'BROUSSARD','LA','70518','9100','CY','22055','1974-02-19','F','M',NULL,'N','021','DEN','449226','18575LA002000201','2014-01-01','2013-12-11 16:31:17','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:49:22'),(5630,4466,'N','19','021','EC','A',NULL,NULL,'','0000612960','0000807467','','IL','1','Holloway','Hunter','G','','','34','268045798','5091 ELNO AVE',0,'AKRON','OH','44319','4931','CY','39153','1998-05-20','M','',':RET:2106-3','N','021','DEN','223737','99734OH005000401','2014-01-01','2013-11-26 11:14:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:57'),(1509,1258,'Y','18','021','EC','A','','','AC','0001219593','0001219593','OH00000568343','IL','1','SEEMANN','JEFF','','','','34','297747213','8180 WOOSTER PIKE',0,'CINCINNATI','OH','45227','4026','CY','39061','1969-04-07','M','U',NULL,'N','021','DEN','1528047','99734OH005000401','2014-01-01','2013-12-24 13:07:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:27'),(7503,5935,'Y','18','024','14','A','','','TE','0000696797','0000696797','','IL','1','Krueger','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-18','M','',NULL,NULL,NULL,'','115469','','2013-12-15','2013-12-15 16:59:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:31:54'),(2825,2283,'Y','18','021','EC','A','','','AC','0000740233','0000740233','OH00001196275','31','1','Reynolds','Karla','','','','34','273643486','P.O. Box 581',0,'Anover','OH','44003',NULL,'CY','39007','1958-06-07','F','M',':RET:2106-3','N','021','HLT','690882','52664OH151001306','2014-01-01','2013-11-23 18:36:42','1135.00',NULL,NULL,'1173.84','38.84','R-OH011','OH0','560.89',NULL,0,'2013-12-25 20:00:36'),(6101,4837,'Y','18','021','EC','A','','','AC','0000662667','0000662667','OH00001179257','IL','1','Cefalo','Wanda','','','','34','304548193','2251 VICTORY PKWY',0,'CINCINNATI','OH','45206','2821','CY','39061','1951-01-21','F','U',NULL,'N','021','DEN','963100','99734OH005000401','2014-01-01','2013-11-21 17:54:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:15:13'),(21094,16857,'Y','18','021','EC','A','','','AC','0001025535','0001025535','OH00001689213','IL','1','BRANDT','ALISA','','','','34','325804518','18400 STATE RD',0,'VAN WERT','OH','45891','8842','CY','39161','1980-04-08','F','U',':RET:2106-3','N','021','HLT','3538827','92036OH004001501','2014-03-01','2014-02-02 13:35:47','201.00',NULL,NULL,'212.00','11.00','R-OH002','OH0','212.00',NULL,0,'2014-02-02 19:00:30'),(5547,4402,'Y','18','021','EC','A','','','AC','0000526741','0000526741','OH00000198379','IL','1','Kuehm','Christian','','','','34','282742493','2741 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','2262','CY','39153','1962-11-17','M','U',':RET:2106-3','N','021','HLT','1021865','52664OH151001305','2014-01-01','2013-11-27 17:59:53','303.00',NULL,NULL,'415.91','112.91','R-OH012','OH0','415.91',NULL,0,'2013-12-25 23:16:01'),(20838,16655,'Y','18','021','EC','A','','','AC','0000155815','0000155815','OH00001912518','IL','1','SPECK','MATTHEW','','','','34','298828020','6231 E LAW RD',0,'VALLEY CITY','OH','44280','9772','CY','39103','1973-05-16','M','U',NULL,'T','021','HLT','2805918','52664OH151001306','2014-03-01','2014-01-31 11:17:24','200.00',NULL,NULL,'327.75','127.75','R-OH012','OH0','327.75',NULL,0,'2014-01-31 21:00:44'),(5208,4134,'Y','18','021','EC','A','','','AC','0000777673','0000777673','OH00000982590','IL','1','Arel','Paul','N','','Jr','34','296687348','14 Arbor Circle',0,'Cincinnati','OH','45255',NULL,'CY','39025','1961-10-31','M','U',':RET:2106-3','N','021','DEN','2527011','99734OH005000401','2014-01-01','2013-12-19 15:30:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 23:04:14'),(19509,15549,'Y','18','021','EC','A','','','AC','0000907825','0000907825','TX00001769528','IL','1','ONWUCHEKWA','CHRISTINA','','','','34','643104236','10750 WESTBRAE PKWY',0,'HOUSTON','TX','77031','2431','CY','48201','1985-06-11','F','M',':RET:2054-5','N','021','DEN','1433832','33348TX002000101','2014-03-01','2014-01-22 13:41:27','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-23 03:02:13'),(18595,14825,'Y','18','021','EC','A','','','AC','0001143337','0001143337','OH00001808295','IL','1','Salmon','Karleen','','','','34','290981616','5630 EAGLE LN',0,'WEST CHESTER','OH','45069','1050','CY','39017','1950-03-12','F','U',':RET:2054-5','N','021','HLT','2334302','92036OH003001205','2014-02-01','2014-01-15 10:37:50','467.00',NULL,NULL,'661.77','194.77','R-OH004','OH0','661.77',NULL,0,'2014-01-16 08:47:15'),(23025,18358,'Y','18','021','EC','A','','','AC','0000223207','0000223207','TX00002560944','IL','1','Levario','Patricia','','','','34','455734028','2123 20TH ST',0,'LUBBOCK','TX','79411','1101','CY','48303','1979-12-01','F','M',NULL,'N','021','DEN','2807192','33348TX002000201','2014-03-01','2014-02-11 22:50:52','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-02-12 21:30:32'),(24313,19308,'Y','18','021','EC','A','','','AC','0000621721','0000621721','TX00001857058','IL','1','Cohen','Laura','','','','34','453216156','5582 BUCKLEY DR',0,'EL PASO','TX','79912','6417','CY','48141','1959-08-26','F','M',NULL,'N','021','DEN','3679751','33348TX002000201','2014-04-01','2014-02-17 20:55:27','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-18 22:00:03'),(24995,19824,'Y','18','021','EC','A','','','AC','0000831683','0000831683','TX00002328795','IL','1','AGUIRRE','JOSEFINA','','','','34','449153774','305 E STOKES AVE',0,'MIDLAND','TX','79701','1924','CY','48329','1959-05-05','F','M',':RET:2106-3','N','021','DEN','3711054','33348TX002000201','2014-04-01','2014-02-20 15:11:35','0.00',NULL,NULL,'29.22','29.22','R-TX016','TX0','14.61',NULL,0,'2014-02-20 22:00:42'),(25172,19967,'Y','18','021','EC','A','','','AC','0000768924','0000768924','OH00002138185','IL','1','Dillon','Vickie','','','','34','302421611','16588 COUNTY ROAD 410',0,'COSHOCTON','OH','43812','9594','CY','39031','1955-03-01','F','M',NULL,'N','021','DEN','3763271','99734OH005000401','2014-04-01','2014-02-20 18:23:57','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-02-21 22:00:29'),(26671,21145,'Y','18','021','EC','A','','','AC','0001525792','0001525792','LA00002713649','IL','1','GENON','HILGON','','','','34','439170025','907 CRESCENT ST',0,'BREAUX BRIDGE','LA','70517','4111','CY','22099','1959-02-23','M','M',':RET:2054-5','N','021','DEN','2994110','18575LA002000201','2014-04-01','2014-02-28 11:41:24','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-28 21:31:18'),(2332,1898,'Y','18','021','EC','A','','','AC','0000137792','0000137792','TX00000367741','IL','1','BALINO','LETICIA','','','','34','457414410','260 SAN MARCOS',0,'EAGLE PASS','TX','78852',NULL,'CY','48323','1951-02-21','F','U',':RET:2106-3','N','021','DEN','85668','33348TX002000201','2014-01-01','2013-12-09 12:23:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:43'),(3611,2893,'N','19','021','EC','A',NULL,NULL,'','0000997747','0000547876','','IL','1','McDermott','Tess','','','','34','292040900','419 Cabot Drive',0,'Akron','OH','44333',NULL,'CY','39153','2000-01-06','F','',':RET:2106-3','N','021','HLT','1423401','52664OH152000901','2014-01-01','2013-12-22 18:15:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:23:29'),(9039,7171,'N','01','021','EC','A',NULL,NULL,'','0000707603','0000899553','','IL','1','Heinz','Allan','R','','','34','286644897','8483 TIFFIN CT',0,'MENTOR','OH','44060','2200','CY','39085','1958-03-12','M','',NULL,'T','021','HLT','1358081','52664OH151001306','2014-01-01','2013-12-18 15:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','645.02',NULL,0,'2013-12-26 04:05:45'),(9609,7610,'Y','18','021','EC','A','','','AC','0000284390','0000284390','OH00000381395','IL','1','Baranowski','Tracey','','','','34','298760656','235 Longview Dr',0,'Wadsworth','OH','44281',NULL,'CY','39103','1965-12-08','F','U',':RET:2106-3','N','021','HLT','2324240','52664OH151001305','2014-01-01','2013-12-21 13:58:10','209.00',NULL,NULL,'364.62','155.62','R-OH012','OH0','364.62',NULL,0,'2013-12-26 04:37:35'),(13407,10698,'N','19','021','EC','A',NULL,NULL,'','0000772641','0001080329','','IL','1','GUADIAN','ALEX','SAMUEL','','','34','276021582','4667 RATHBURN DR',0,'ENGLEWOOD','OH','45322','3721','CY','39113','1996-10-09','M','',':RET:2106-3','N','021','DEN','1652285','99734OH005000301','2014-01-01','2013-12-23 09:51:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:29'),(15447,12361,'Y','18','021','EC','A','','','AC','0001197726','0001197726','TX00000019319','IL','1','Brown','Rickie','S','','','34','462259540','462 County Road 44060',0,'Powderly','TX','75473',NULL,'CY','48277','1960-12-06','M','M',':RET:2106-3','N','021','DEN','1516155','33348TX002000201','2014-02-01','2013-12-31 15:05:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:28:15'),(16305,13054,'Y','18','021','EC','A','','','AC','0001555360','0001555360','LA00001281108','31','1','EZELL','CIARA','','','','34','433719388','PO BOX 4817',0,'PINEVILLE','LA','71361',NULL,'CY','22079','1986-11-21','F','U',NULL,'T','021','DEN','2266385','18575LA002000201','2014-02-01','2014-01-05 19:57:56','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-07 04:01:15'),(16961,13575,'Y','18','021','EC','A','','','AC','0000794522','0000794522','OH00001592301','IL','1','Eder','Nancy','','','','34','301561435','1899 Carter Ave',0,'Akron','OH','44301',NULL,'CY','39153','1957-03-02','F','U',':RET:2106-3','N','021','HLT','2395934','52664OH151001305','2014-02-01','2014-01-09 10:24:12','372.00',NULL,NULL,'520.28','148.28','R-OH012','OH0','520.28',NULL,0,'2014-01-13 02:20:07'),(16964,13578,'Y','18','021','EC','A','','','AC','0001153627','0001153627','OH00001551565','IL','1','Rivera','Jennifer','','','','34','302722978','131 FURNACE RUN DR',0,'AKRON','OH','44307','2259','CY','39153','1975-07-18','F','U',':RET:2106-3','N','021','HLT','1661051','52664OH151001305','2014-02-01','2014-01-08 19:48:15','181.00',NULL,NULL,'277.87','96.87','R-OH012','OH0','277.87',NULL,0,'2014-01-13 02:20:09'),(21129,16884,'Y','18','021','EC','A','','','AC','0000910002','0000910002','TX00002490227','31','1','johnson','cully','','','','34','457043708','po box 1940',0,'aransas pass','TX','78335',NULL,'CY','48409','1961-08-17','M','M',':RET:2106-3','N','021','DEN','2253678','33348TX002000201','2014-03-01','2014-02-03 15:00:35','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-03 21:00:17'),(24787,19661,'Y','18','021','EC','A','','','AC','0000108209','0000108209','OH00001952089','IL','1','RENTSCHLER','CINDY','','','','34','296608590','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247',NULL,'CY','39061','1962-03-18','F','U',':RET:2106-3','N','021','DEN','2618926','99734OH005000401','2014-04-01','2014-02-19 13:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:46:19'),(25030,19848,'Y','18','021','EC','A','','','AC','0002333555','0002333555','LA00003085075','IL','1','Burton','Jamal','James-Leigh','','','34','434753935','2100 PASADENA AVE',0,'METAIRIE','LA','70001','1459','CY','22051','1986-11-08','M','U',':RET:2054-5','N','021','DEN','3459635','18575LA002000101','2014-04-01','2014-02-19 19:34:37','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-20 22:01:02'),(19042,15165,'Y','18','024','14','A','','','TE','0000605970','0000605970','','IL','1','Givens','Cheryl','Annette',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-12','F','',NULL,NULL,NULL,'','1697540','','2014-01-17','2014-01-17 14:39:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:06:38'),(23558,18768,'N','19','021','EC','A',NULL,NULL,'','0001236630','0000093891','','IL','1','OVIAHON','ELIJAH','','','','34','279049897','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1999-05-10','M','',':RET:2054-5','N','021','HLT','3515021','92036OH005002604','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-02-13 22:02:43'),(28886,22862,'Y','18','021','EC','A','','','AC','0001142715','0001142715','TX00003261786','IL','1','COGER','PORTER JR','','','','34','342464381','16647 US HIGHWAY 82 W',0,'AVERY','TX','75554',NULL,'CY','48037','1952-01-21','M','U',NULL,'N','021','DEN','3818835','33348TX002000201','2014-04-01','2014-03-10 13:56:32','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-03-10 21:00:12'),(29094,23028,'Y','18','021','EC','A','','','AC','0001176328','0001176328','TX00003025749','IL','1','Fleming','Donna','','','','34','455591690','925 Saint Paul Dr.',0,'Richardson','TX','75080',NULL,'CY','48113','1965-10-12','F','U',':RET:2054-5','N','021','DEN','4061219','33348TX002000101','2014-04-01','2014-03-10 15:48:34','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-10 21:02:11'),(22110,17647,'Y','18','021','EC','A','','','AC','0000971501','0000971501','OH00002375076','IL','1','WHORTON','TODD','','','','34','299602258','738 EDGEHILL AVE',0,'ASHLAND','OH','44805','4118','CY','39005','1970-01-26','M','U',NULL,'N','021','DEN','2665673','99734OH005000301','2014-03-01','2014-02-08 14:32:47','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-08 19:00:33'),(2776,2243,'Y','18','021','EC','A','','','AC','0000432718','0000432718','OH00000731229','IL','1','Elwell','Kellen','Ruth','','','34','223575400','633 COBBLESTONE DR',0,'AMHERST','OH','44001','1967','CY','39093','1986-01-19','F','M',':RET:2106-3','N','021','HLT','716376','92036OH004000801','2014-01-01','2013-12-02 14:06:43','154.00',NULL,NULL,'197.01','43.01','R-OH011','OH0','197.01',NULL,0,'2013-12-25 19:49:42'),(18031,14403,'Y','18','021','EC','A','','','AC','0000878282','0000878282','OH00002246547','IL','1','Kilbane','Beth','','','','34','175668667','12900 LAKE AVE',0,'LAKEWOOD','OH','44107','1577','CY','39035','1970-09-25','F','U',':RET:2106-3','N','021','DEN','1582790','99734OH005000301','2014-02-01','2014-01-14 16:34:54','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:08'),(17746,14178,'Y','18','021','EC','A','','','AC','0000947423','0000947423','OH00001654484','IL','1','Wilson','Aimee','F','','','34','277805920','393 N Mad Anthony St.',0,'Millersburg','OH','44654',NULL,'CY','39075','1972-04-23','F','U',':RET:2106-3','T','021','HLT','2124296','52664OH151001305','2014-02-01','2014-01-13 16:25:12','181.00',NULL,NULL,'333.91','152.91','R-OH014','OH0','333.91',NULL,0,'2014-01-14 01:33:25'),(17461,13963,'Y','18','021','EC','A','','','AC','0001124072','0001124072','OH00001869928','IL','1','Bruskotter','Christopher','','','','34','297921626','257 N. Main St.',0,'Glandorf','OH','45848',NULL,'CY','39137','1989-12-30','M','U',':RET:2106-3','N','021','HLT','2115322','92036OH005001505','2014-02-01','2014-01-10 16:57:56','154.00',NULL,NULL,'220.08','66.08','R-OH002','OH0','220.08',NULL,0,'2014-01-13 03:00:42'),(4539,3596,'N','19','021','EC','A',NULL,NULL,'','0000621434','0000904682','','IL','1','Alvarez','Diana','','','','34','635122352','422 E RIX ST',0,'TYLER','TX','75701','1928','CY','48423','1990-02-10','F','',NULL,'N','021','DEN','452077','33348TX002000201','2014-01-01','2013-12-12 17:15:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:04:14'),(5421,4303,'Y','18','024','14','A','','','TE','0000945971','0000945971','','IL','1','McCray','Jawon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-05-18','M','',NULL,NULL,NULL,'','2093450','','2013-12-19','2013-12-19 01:28:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 23:09:25'),(17253,13805,'Y','18','024','14','A','','','TE','0000532122','0000532122','','IL','1','POPOLIZIO','LEAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-11','F','',NULL,NULL,NULL,'','2512015','','2014-01-10','2014-01-10 09:15:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:23:13'),(17082,13671,'Y','18','021','EC','A','','','AC','0001183697','0001183697','TX00002235006','31','1','Arizpe','Tiburcio','','','','34','457537298','PO Box 1556',0,'Gonzales','TX','78629',NULL,'CY','48177','1973-03-21','M','M',':RET:2106-3','N','021','DEN','2127553','33348TX002000201','2014-02-01','2014-01-08 13:57:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:21:23'),(13170,10505,'N','01','021','EC','A',NULL,NULL,'','0000574448','0000446292','','IL','1','tyler','shawn','','','','34','289482580','4512 catlin drive',0,'richmond heights','OH','44143',NULL,'CY','39035','1950-02-14','F','',':RET:2054-5','N','021','DEN','1768957','99734OH005000401','2014-01-01','2013-12-23 18:34:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:54:02'),(8952,7100,'Y','18','021','EC','A','','','AC','0000729964','0000729964','OH00001061526','IL','1','Ross','America','','','','34','313621254','1462 Mathias Dr',0,'Columbus','OH','43224',NULL,'CY','39049','1953-08-31','F','U',':RET:2054-5','N','021','DEN','1581785','99734OH005000401','2014-01-01','2013-12-18 12:11:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:03:37'),(9789,7751,'Y','18','021','EC','A','','','AC','0000592129','0000592129','OH00000157515','IL','1','Chritton','William','','','','34','390062299','3036 LINDALE ST',0,'AKRON','OH','44312','5543','CY','39153','1987-04-23','M','U',':RET:2106-3','T','021','HLT','1099296','52664OH151001305','2014-01-01','2013-10-20 16:15:47','122.00',NULL,NULL,'262.61','140.61','R-OH012','OH0','262.61',NULL,0,'2013-12-26 05:00:54'),(22829,18215,'Y','18','021','EC','A','','','AC','0000258202','0000258202','OH00002324745','IL','1','McKenzie','Sally','','','','34','295524025','11189 STEINER RD',0,'RITTMAN','OH','44270','9735','CY','39169','1952-06-05','F','U',':RET:2106-3','N','021','HLT','3114338','52664OH151001305','2014-03-01','2014-02-11 10:02:44','503.00',NULL,NULL,'626.65','123.65','R-OH014','OH0','626.65',NULL,0,'2014-02-11 21:02:06'),(27251,21578,'Y','18','021','EC','A','','','AC','0001198456','0001198456','MS00003554947','S3','1','Rash','Deshandra','','','','34','588013835','4017 36TH ST',0,'MERIDIAN','MS','39307','3564','CY','28075','2006-12-12','F','U',':RET:2054-5','N','021','DEN','3933023','46300MS001000101','2014-04-01','2014-03-03 13:26:14','0.00',NULL,NULL,'47.10','47.10','R-MS006','MS0','47.10',NULL,0,'2014-03-03 21:31:53'),(28610,22643,'N','01','021','EC','A',NULL,NULL,'','0001248394','0000414768','','IL','1','HENRY','DANIEL','','','','34','271540753','1297 W COMET RD',0,'CLINTON','OH','44216','9666','CY','39153','1953-10-20','M','',NULL,'N','021','DEN','4024884','99734OH005000401','2014-04-01','2014-03-08 15:31:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-08 21:30:15'),(28853,22832,'Y','18','024','14','A','','','TE','0000257195','0000257195','','IL','1','Jones','Todd','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-05-25','M','',NULL,NULL,NULL,'','3185162','','2014-03-08','2014-03-09 16:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-09 21:01:20'),(1182,974,'Y','18','021','EC','A','','','AC','0000671678','0000671678','OH00000631441','IL','1','Samba Elabd','Sidi','','','','34','578310622','6509Glen ave',0,'Cincinnati','OH','45213',NULL,'CY','39061','1973-11-01','M','R',NULL,'T','021','DEN','18554','99734OH005000301','2014-01-01','2013-12-02 22:55:14','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:19:24'),(18398,14680,'N','19','021','EC','A',NULL,NULL,'','0000505755','0000825934','','IL','1','Smith','Zion','D','','','34','230977400','11817 Crofton Road',0,'Garfield Heights','OH','44125',NULL,'CY','39035','2003-08-29','M','',':RET:2106-3','N','021','DEN','2210292','99734OH005000301','2014-02-01','2014-01-15 17:10:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:42'),(2495,2033,'Y','18','021','EC','A','','','AC','0000180085','0000180085','LA00000228843','IL','1','Bright','Charlotte','','','','34','434254403','1223 FLANDERS ST',0,'NEW ORLEANS','LA','70114','1717','CY','22071','1964-10-26','F','U',':RET:2054-5','T','021','DEN','85682','18575LA002000201','2014-01-01','2013-12-09 16:40:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:54'),(2611,2122,'Y','18','021','EC','A','','','AC','0000837655','0000837655','OH00000476194','IL','1','Douglas','Zachary','','','','34','300040454','444 GREEN MEADOWS DR W',0,'POWELL','OH','43065','8863','CY','39041','1984-08-16','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','253091','99734OH005000401','2014-01-01','2013-12-02 11:25:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:45:36'),(5389,4276,'Y','18','021','EC','A','','','AC','0001218831','0001218831','LA00000263717','31','1','ARAUJO','ANGIE',NULL,NULL,NULL,NULL,NULL,'P.O.BOX 612',0,'CUT OFF','LA','70345',NULL,'CY','22057','1973-08-15','F','M',NULL,'T','021','DEN','1849584','18575LA002000201','2014-01-01','2013-12-19 16:31:22','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 23:08:36'),(15898,12730,'Y','18','021','EC','A','','','AC','0000004721','0000004721','OH00001749647','IL','1','Hines','Theresa','','','','34','297686246','20438 St Rt 12',0,'Fostoria','OH','44830',NULL,'CY','39063','1959-11-23','F','U',':RET:2106-3','N','021','HLT','2122590','92036OH003001505','2014-02-01','2014-01-02 12:33:43','416.00',NULL,NULL,'490.70','74.70','R-OH002','OH0','490.70',NULL,0,'2014-01-03 02:05:58'),(13796,11013,'Y','18','021','EC','A','','','AC','0001152116','0001152116','MS00000217903','IL','1','Wheatley','Christopher','B','','','34','428233755','408 HUNTINGTON DR',0,'JACKSON','MS','39272','4486','CY','28049','1970-07-09','M','M',':RET:2054-5','N','021','DEN','1470001','46300MS002000101','2014-01-01','2013-12-23 11:07:36','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:14'),(24698,19607,'Y','18','021','EC','A','','','AC','0000152036','0000152036','OH00002879971','S1','1','tucker','christopher','','','','34','291082360','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2003-11-27','M','U',':RET:2106-3','N','021','DEN','3730892','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:33:46'),(26230,20804,'Y','18','024','14','A','','','TE','0000404402','0000404402','','IL','1','Tu','Phung',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-06-27','F','',NULL,NULL,NULL,'','2804081','','2014-02-26','2014-02-26 23:13:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:01'),(1685,1407,'Y','18','021','EC','A','','','AC','0001325082','0001325082','LA00000974115','IL','1','Chapman','Theodora','','','','34','433751876','26406 FELICIANA DR',0,'DENHAM SPRINGS','LA','70726','6961','CY','22063','1985-05-21','F','U',':RET:2054-5^:RET:2039-6','N','021','DEN','2577444','18575LA002000101','2014-01-01','2013-12-24 14:32:01','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:54:17'),(22720,18142,'N','19','021','EC','A',NULL,NULL,'','0001252238','0001420946','','IL','1','FAROOQUI','MOHAMMED','MUDASIR','','','34','664078520','6209 BLANKE ST',0,'METAIRIE','LA','70003','2914','CY','22051','1990-02-01','M','',':RET:2028-9','T','021','DEN','3066905','18575LA002000201','2014-03-01','2014-02-11 12:33:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:09'),(4124,3293,'N','01','021','EC','A',NULL,NULL,'','0001133930','0001034649','','IL','1','Fineran','Kayla','','','','34','612301862','2631 MAPLE AVE NE',0,'CANTON','OH','44714','1890','CY','39151','1986-08-26','F','',':RET:2106-3','N','021','DEN','1626766','99734OH005000301','2014-01-01','2013-12-16 22:51:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:15'),(13788,11005,'Y','18','021','EC','A','','','AC','0000763124','0000763124','MS00001275736','IL','1','Kenady','Fanchion','','','','34','337686967','606 W MARKET ST',0,'GREENWOOD','MS','38930','4208','CY','28083','1972-11-16','F','U',':RET:2054-5','N','021','DEN','1650933','46300MS002000201','2014-01-01','2013-12-23 18:49:49','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:57'),(5701,4524,'N','01','021','EC','A',NULL,NULL,'','0000374631','0000578093','','IL','1','Miller','Shinita','J','','','34','428064860','1962 BIENVILLE DR',0,'JACKSON','MS','39212','2536','CY','28049','1956-05-05','F','',':RET:2054-5','N','021','DEN','500564','46300MS002000201','2014-01-01','2013-11-26 16:02:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 23:32:54'),(13492,10755,'N','19','021','EC','A',NULL,NULL,'','0000645986','0000383361','','S1','1','Giovannazzo','Emily','J','','','34','039729411','26311 LAKE RD',0,'BAY VILLAGE','OH','44140','2570','CY','39035','2008-08-07','F','',NULL,'N','021','DEN','2373290','99734OH005000301','2014-01-01','2013-12-23 18:14:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:26'),(4463,3546,'Y','18','021','EC','A','','','AC','0001201870','0001201870','OH00001068709','IL','1','Koosed','Lawrence','','','','34','273460024','24259 W RIVER RD',0,'PERRYSBURG','OH','43551','9476','CY','39173','1951-11-24','M','M',':RET:2106-3','N','021','DEN','528827','99734OH005000301','2014-01-01','2013-12-12 13:53:17','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:02:40'),(5619,4459,'Y','18','021','EC','A','','','AC','0000706163','0000706163','OH00000652552','IL','1','Harris','Janet','','','','34','288547119','2371 CALL RD',0,'STOW','OH','44224','1538','CY','39153','1956-09-20','F','M',':RET:2106-3','N','021','DEN','360526','99734OH005000401','2014-01-01','2013-11-26 14:23:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:30:44'),(5311,4211,'Y','18','021','EC','A','','','AC','0000045753','0000045753','OH00000450232','IL','1','dorgiewicz','john','','','','34','290646148','11640 WATERVILLE SWANTON RD',0,'WHITEHOUSE','OH','43571','9356','CY','39095','1973-11-13','M','U',':RET:2106-3','N','021','DEN','1960181','99734OH005000301','2014-01-01','2013-12-18 19:32:18','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:06:34'),(7921,6263,'Y','18','021','EC','A','','','AC','0001187834','0001187834','LA00000728160','IL','1','magee','christopher','','','','34','438575244','1603 BENE ST',0,'FRANKLINTON','LA','70438','1366','CY','22117','1984-06-18','M','U',':RET:2054-5','N','021','DEN','2157381','18575LA002000201','2014-01-01','2013-12-20 00:04:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:06:19'),(24298,19299,'Y','18','021','EC','A','','','AC','0001205012','0001205012','TX00002612879','IL','1','GBONIA','SAHR','','','','34','630704392','10075 ROYAL LN',0,'DALLAS','TX','75238',NULL,'CY','48113','1965-01-31','M','U',':RET:2054-5','N','021','DEN','3807040','33348TX002000201','2014-03-01','2014-02-18 14:34:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-18 21:30:18'),(25297,20070,'Y','18','024','14','A','','','TE','0001096743','0001096743','','IL','1','Ceena','Sharon','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-04','F','',NULL,NULL,NULL,'','1614982','','2014-03-31','2014-02-25 13:42:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:26'),(26864,21291,'Y','18','021','EC','A','','','AC','0000745719','0000745719','TX00002790522','31','1','Lucero','Michael','','','','34','466850055','6510 Spring Rose St.',0,'San Antonio','TX','78249',NULL,'CY','48215','1981-12-13','M','U',':RET:2106-3','N','021','DEN','3226271','33348TX002000101','2014-04-01','2014-03-01 10:32:13','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-03-01 21:00:59'),(1755,1453,'Y','18','021','EC','A','','','AC','0000987405','0000987405','OH00001177803','IL','1','Stampley','Linda','','','','34','298504891','1413 Noel Drive',0,'Springfield','OH','45506',NULL,'CY','39023','1949-09-30','F','U',':RET:2054-5','N','021','DEN','2232085','99734OH005000301','2014-01-01','2013-12-24 12:51:32','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:55:49'),(13793,11010,'Y','18','021','EC','A','','','AC','0000247833','0000247833','MS00000835064','IL','1','Robinson','Charlotte','','','','34','426138886','4901 MCWILLIE CIR',0,'JACKSON','MS','39206','6210','CY','28049','1975-04-24','F','U',':RET:2054-5','N','021','DEN','2095034','46300MS002000101','2014-01-01','2013-12-23 09:44:18','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:09'),(13777,10997,'Y','18','021','EC','A','','','AC','0001076610','0001076610','MS00001171452','IL','1','Scallions','Jason','','','','34','426236673','1332 SUDDUTH RD',0,'STEENS','MS','39766','9665','CY','28087','1975-05-05','M','M',':RET:2106-3','N','021','DEN','1614235','46300MS002000201','2014-01-01','2013-12-23 15:28:58','0.00',NULL,NULL,'72.22','72.22','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:39'),(9493,7528,'Y','18','021','EC','A','','','AC','0000394932','0000394932','OH00000214080','IL','1','Gibson','Samantha','','','','34','279888973','210 massachusetts Ave',0,'Elyria','OH','44035',NULL,'CY','39093','1987-12-25','F','U',':RET:2106-3','T','021','DEN','1534087','99734OH005000401','2014-01-01','2013-12-21 13:51:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:34:57'),(9368,7427,'Y','18','021','EC','A','','','AC','0001571159','0001571159','LA00001041896','IL','1','Napoli','Karen','','','','34','434021453','59010 Postell Avenue',0,'Plaquemine','LA','70764',NULL,'CY','22047','1954-08-14','F','U',':RET:2106-3','N','021','DEN','2005429','18575LA002000201','2014-01-01','2013-12-21 12:39:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:44'),(4178,3325,'N','19','021','EC','A',NULL,NULL,'','0000021373','0001037339','','IL','1','Cipro','Maria','','','','34','270084272','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2002-09-15','F','',':RET:2106-3','N','021','HLT','2222362','52664OH151001304','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 21:49:22'),(9328,7395,'Y','18','021','EC','A','','','AC','0000683381','0000683381','OH00001283039','IL','1','Arkus','Laura','','','','34','291684008','3746 White Chapel Ct.',0,'Amelia','OH','45102',NULL,'CY','39025','1975-09-20','F','M',':RET:2106-3','N','021','HLT','1814248','92036OH004000601','2014-01-01','2013-12-20 18:52:40','0.00',NULL,NULL,'654.91','654.91','R-OH005','OH0','215.09',NULL,0,'2013-12-26 04:30:42'),(1999,1638,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','15024','','2013-11-19','2013-11-19 23:08:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:02:09'),(9012,7151,'Y','18','021','EC','A','','','AC','0001152180','0001152180','OH00000909662','31','1','GAYLORD','THOMAS','G','','','34','279501575','PO BOX 27683',0,'AKRON','OH','44319',NULL,'CY','39153','1950-08-26','M','U',':RET:2106-3','N','021','HLT','1421007','52664OH152000901','2014-01-01','2013-12-18 16:42:18','422.00',NULL,NULL,'482.18','60.18','R-OH012','OH0','482.18',NULL,0,'2013-12-26 04:05:06'),(16746,13395,'Y','18','021','EC','A','','','AC','0000917489','0000917489','TX00000778973','IL','1','Torres','Ebaristo','','','','34','457739696','1505 W Grande',0,'Tyler','TX','75703',NULL,'CY','48423','1980-06-26','M','U',NULL,'T','021','DEN','2243580','33348TX002000101','2014-02-01','2014-01-06 19:46:54','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2014-01-08 18:24:53'),(18071,14434,'Y','18','021','EC','A','','','AC','0001416165','0001416165','LA00002417388','IL','1','bamburg','crystal','','','','34','438594531','1214 hayes st',0,'west monroe','LA','71292',NULL,'CY','22073','1985-12-28','F','M',':RET:2106-3','T','021','DEN','1438845','18575LA002000201','2014-02-01','2014-01-14 08:37:50','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:24'),(18304,14613,'Y','18','021','EC','A','','','AC','0000088579','0000088579','OH00002288770','IL','1','Borger','Donald','','','','34','283420431','39193 WOODLAND TRL',0,'AVON','OH','44011','5709','CY','39093','1951-10-29','M','M',':RET:2106-3','N','021','DEN','2353517','99734OH005000401','2014-02-01','2014-01-15 10:38:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:44:58'),(23460,18688,'Y','18','021','EC','A','','','AC','0000814521','0000814521','TX00002059135','IL','1','Chavarria','Andres','','','','34','466996903','202 Allen Dr.',0,'Laredo','TX','78045',NULL,'CY','48479','1985-03-13','M','U',':RET:2106-3','N','021','DEN','3746608','33348TX002000201','2014-03-01','2014-02-13 14:27:18','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-13 22:01:42'),(23461,18689,'Y','18','021','EC','A','','','AC','0000409330','0000409330','TX00002297975','IL','1','Burress','Angela','','','','34','456673917','259 SUNSET RD',0,'GROVETON','TX','75845','4155','CY','48455','1966-10-14','F','U',':RET:2106-3','T','021','DEN','3651496','33348TX002000201','2014-03-01','2014-02-13 14:35:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:43'),(24598,19527,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000216158','','IL','1','Sexton','Cora','Lee','','','34','871338512','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2013-09-12','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:12:32'),(69,62,'Y','18','021','EC','A','','','AC','0000103865','0000103865','OH00000994644','IL','1','phillips','catherine','a','','','34','288521753','11625 KENN RD',0,'CINCINNATI','OH','45240','1928','CY','39061','1952-03-15','F','U',':RET:2054-5','N','021','DEN','475216','99734OH005000301','2014-01-01','2013-12-05 11:24:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:52'),(230,194,'Y','18','021','EC','A','','','AC','0000137537','0000137537','OH00000052050','IL','1','Kachuba','John','','','','34','046441065','3954 GLENCROSS AVE',0,'CINCINNATI','OH','45217','1913','CY','39061','1950-01-11','M','M',':RET:2106-3','N','021','HLT','213635','92036OH006001201','2014-01-01','2013-12-05 15:47:19','480.00',NULL,NULL,'502.56','22.56','R-OH004','OH0','502.56',NULL,0,'2013-12-25 17:21:02'),(470,383,'Y','18','021','EC','A','','','AC','0000976681','0000976681','OH00001109494','IL','1','KNOTTS','DEBORAH','MAY','','','34','268522746','1845 BAKER AVE',0,'AKRON','OH','44312','2004','CY','39153','1950-05-18','F','M',':RET:2106-3','N','021','HLT','270649','52664OH151001304','2014-01-01','2013-12-04 11:44:31','388.00',NULL,NULL,'658.32','270.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 17:47:50'),(4430,3521,'Y','18','021','EC','A','','','AC','0000081275','0000081275','OH00000028895','IL','1','Coulter','William','','','','34','291548883','2575 Roberts Ct',0,'Hilliard','OH','43026',NULL,'CY','39049','1952-02-06','M','U',NULL,'N','021','DEN','211222','99734OH005000401','2014-01-01','2013-12-12 17:41:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:51'),(7119,5648,'N','01','021','EC','A',NULL,NULL,'','0000167768','0000351571','','IL','1','Sharkey','Susan','','','','34','297747418','447 DARTMOUTH CIR',0,'CINCINNATI','OH','45244','1805','CY','39025','1970-04-13','F','',':RET:2106-3','N','021','HLT','2559665','92036OH001000601','2014-01-01','2013-12-24 23:46:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','351.38',NULL,0,'2013-12-26 01:51:16'),(6965,5529,'N','19','021','EC','A',NULL,NULL,'','0001096764','0000749527','','IL','1','SYNDER','JACOB','','','','34','268028495','976 W WEBB RD',0,'MERIAL RIDGE','OH','44440',NULL,'CY','39155','1996-07-06','M','',NULL,'N','021','DEN','1819156','99734OH005000401','2014-01-01','2013-12-24 22:46:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:22'),(6955,5524,'Y','18','021','EC','A','','','AC','0000049495','0000049495','OH00000052959','IL','1','Pau','Tung','','','','34','275069976','53 S POWELL AVE',0,'COLUMBUS','OH','43204','3031','CY','39049','1957-04-12','M','M',':RET:2028-9','N','021','DEN','1917274','99734OH005000401','2014-01-01','2013-12-24 21:58:26','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:08'),(19906,15876,'Y','18','024','14','A','','','TE','0000151976','0000151976','','IL','1','Chan','Hing',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-07-26','M','',NULL,NULL,NULL,'','2488206','','2014-01-23','2014-01-23 20:15:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:58'),(24085,19151,'Y','18','021','EC','A','','','AC','0000289573','0000289573','OH00001815637','IL','1','ZILER','RONALD','HARDE','','','34','273880655','4870 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','1974-11-02','M','U',':RET:2106-3','N','021','HLT','2907628','52664OH151001305','2014-03-01','2014-02-15 14:09:11','517.00',NULL,NULL,'706.27','189.27','R-OH012','OH0','281.44',NULL,0,'2014-02-15 22:01:23'),(24164,19198,'N','01','021','EC','A',NULL,NULL,'','0000397390','0000538314','','IL','1','Dressman','Steven','','','','34','404271948','3900 ONEIDA ST',0,'STOW','OH','44224','4217','CY','39153','1969-10-07','M','',':RET:2106-3','N','021','HLT','3222274','52664OH151001501','2014-03-01','2014-02-14 20:52:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.65',NULL,0,'2014-02-15 22:02:05'),(25545,20266,'Y','18','021','EC','A','','','AC','0000885646','0000885646','OH00001579890','IL','1','Gibson','Deborah','','','','34','302607765','3550 FREEMAN AVE',0,'HAMILTON','OH','45015','1755','CY','39017','1966-05-30','F','U',':RET:2106-3','N','021','DEN','3663172','99734OH005000401','2014-04-01','2014-02-23 13:36:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:00:14'),(27288,21608,'Y','18','021','EC','A','','','AC','0000077513','0000077513','TX00002814421','IL','1','SHAW','HERSHEL','GLENN','','','34','455274736','608 WALKER ST',0,'MARLIN','TX','76661','2351','CY','48145','1963-12-18','M','M',NULL,'N','021','DEN','3899816','33348TX002000201','2014-04-01','2014-03-04 09:22:22','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:27'),(28234,22339,'Y','18','024','14','A','','','TE','0000884230','0000884230','','IL','1','Stupar','Gillian','Rose',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-09-16','F','',NULL,NULL,NULL,'','1794835','','2014-03-31','2014-03-06 17:56:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-06 21:30:25'),(29208,23115,'Y','18','021','EC','A','','','AC','0001025684','0001025684','TX00003302987','IL','1','Boone','Sherlonda','','','','34','458196200','1425 CHEROKEE ST',0,'LONGVIEW','TX','75604','5780','CY','48183','1966-09-12','F','U',':RET:2054-5','N','021','DEN','3833329','33348TX002000201','2014-04-01','2014-03-10 13:21:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61','CIC',0,'2014-03-10 21:30:14'),(36,31,'Y','18','024','14','A','','','TE','0000745405','0000745405','','IL','1','Salyers','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-03-07','M','',NULL,NULL,NULL,'','1118626','','2013-12-05','2013-12-05 12:45:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:15:56'),(13592,10842,'Y','18','021','EC','A','','','AC','0001747612','0001747612','LA00000932447','IL','1','Bates','Dorey','Lee','','','34','433738020','11156 OAK RIDGE DR',0,'DENHAM SPRINGS','LA','70726','7108','CY','22063','1980-10-02','F','M',':RET:2106-3','N','021','DEN','1970770','18575LA002000201','2014-01-01','2013-12-23 19:16:34','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:05:13'),(13057,10409,'Y','18','024','14','A','','','TE','0001075301','0001075301','','IL','1','Danner','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-02','M','',NULL,NULL,NULL,'','2350448','','2013-12-23','2013-12-23 09:16:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:50:59'),(1096,900,'Y','18','021','EC','A','','','AC','0000504445','0000504445','OH00001196371','IL','1','CALKINS','MAXINE','','','','34','298785097','4709 W 158TH ST',0,'CLEVELAND','OH','44135','2607','CY','39035','1979-05-24','F','U',':RET:2106-3','N','021','DEN','1227428','99734OH005000401','2014-01-01','2013-12-03 18:10:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:08'),(8143,6441,'N','19','021','EC','A',NULL,NULL,'','0000176358','0001100565','','IL','1','Leis','Matthew','','','','34','282983257','66 CRESTWOOD DR',0,'WILLARD','OH','44890','1607','CY','39077','1995-05-09','M','',':RET:2106-3','N','021','HLT','1222029','92036OH004002701','2014-01-01','2013-11-21 21:10:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-26 03:15:49'),(1123,923,'N','01','021','EC','A',NULL,NULL,'','0001118687','0000623948','','IL','1','Winegardner','Jason','','','','34','293764410','100 MASTERS CT',0,'LIMA','OH','45805','4007','CY','39003','1978-01-21','M','',':RET:2106-3','N','021','HLT','1096653','92036OH003001501','2014-01-01','2013-12-02 19:33:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','280.84',NULL,0,'2013-12-25 18:17:50'),(1529,1274,'Y','18','021','EC','A','','','AC','0000596278','0000596278','OH00000984053','IL','1','Flakes','Sherman','','','','34','280546495','828 HUBER ST',0,'AKRON','OH','44306','2924','CY','39153','1955-04-23','M','M',':RET:2054-5','T','021','DEN','2383639','99734OH005000401','2014-01-01','2013-12-24 16:01:01','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:49:58'),(6643,5271,'Y','18','021','EC','A','','','AC','0000238194','0000238194','TX00000739508','IL','1','Chavez','Caroline','','','','34','454372847','937 Custer Ave',0,'Odessa','TX','79761',NULL,'CY','48135','1964-03-09','F','U',NULL,'N','021','DEN','421521','33348TX002000201','2014-01-01','2013-11-12 09:24:54','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-26 01:00:22'),(2628,2137,'Y','18','021','EC','A','','','AC','0000701651','0000701651','OH00000511486','IL','1','Schleyer','Cory','','','','34','407295207','8229 CATALPA RIDGE DR',0,'BLACKLICK','OH','43004','8279','CY','39049','1986-11-26','M','M',NULL,'N','021','DEN','529842','99734OH005000401','2014-01-01','2013-12-02 15:04:45','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:03'),(3307,2660,'N','19','021','EC','A',NULL,NULL,'','0000097572','0001129019','','IL','1','Manansala','Kian','','','','34','301158662','1085 TREELINE WAY',0,'DELAWARE','OH','43015','3547','CY','39041','2010-09-02','M','',':RET:2036-2','N','021','DEN','1644492','99734OH005000301','2014-01-01','2013-12-22 13:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:49'),(6561,5201,'N','01','021','EC','A',NULL,NULL,'','0000006115','0000226828','','IL','1','HERNANDEZ','ALFRED','','','','34','462499702','9100 Bradley Drive',0,'North Richland Hills','TX','76182',NULL,'CY','48439','1964-07-31','M','',NULL,'N','021','DEN','666278','33348TX002000201','2014-01-01','2013-12-11 13:23:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:52:26'),(3135,2520,'Y','18','021','EC','A','','','AC','0000153593','0000153593','LA00000508988','IL','1','BUTLER','MARTHA','','','','34','433840568','5866 S SUNSET HILL AVE',0,'BATON ROUGE','LA','70805','3218','CY','22033','1952-10-13','F','U',NULL,'N','021','DEN','454277','18575LA002000101','2014-01-01','2013-10-13 17:16:00','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 20:30:38'),(18744,14936,'Y','18','021','EC','A','','','AC','0000430297','0000430297','OH00001654623','31','1','Chose','William','','','','34','285840539','142 Florence Ave',0,'Jackson','OH','45640',NULL,'CY','39079','1974-12-15','M','U',':RET:2106-3','T','021','DEN','2375363','99734OH005000301','2014-02-01','2014-01-15 19:52:11','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-01-17 03:35:41'),(19689,15690,'Y','18','024','14','A','','','TE','0000791243','0000791243','','IL','1','Vasquez','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-06-10','F','',NULL,NULL,NULL,'','2209118','','2014-01-23','2014-01-23 16:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:42'),(20834,16653,'Y','18','021','EC','A','','','AC','0000940889','0000940889','OH00002313063','IL','1','Wright','Pamela','','','','34','271767176','917 Bunker Hill Rd.',0,'Ashtabula','OH','44004',NULL,'CY','39007','1980-02-20','F','M',':RET:2106-3','N','021','HLT','3527921','52664OH151001306','2014-03-01','2014-01-30 19:38:53','548.00',NULL,NULL,'651.86','103.86','R-OH011','OH0','305.34',NULL,0,'2014-01-31 21:00:43'),(22852,18233,'N','01','021','EC','A',NULL,NULL,'','0000475013','0001138084','','IL','1','Jones','Matthew','','','','34','292821684','320 JACKSON ST',0,'SAINT MARYS','OH','45885','2142','CY','39011','1970-03-12','M','',':RET:2106-3','N','021','HLT','2959390','92036OH005001505','2014-03-01','2014-02-11 15:46:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','298.65',NULL,0,'2014-02-11 21:02:21'),(23060,18384,'N','01','021','EC','A',NULL,NULL,'','0001453637','0002058094','','IL','1','Shugars','James','','','','34','425552772','18410 RIVER BEND RD',0,'MAUREPAS','LA','70449','5273','CY','22063','1967-10-24','M','',NULL,'T','021','DEN','3058622','18575LA002000201','2014-03-01','2014-02-12 11:33:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-12 21:30:50'),(27772,21962,'Y','18','021','EC','A','','','AC','0001624899','0001624899','LA00003020291','IL','1','Hardnett','Crystal','','','','34','435576802','9633 CUYHANGA PKWY',0,'BATON ROUGE','LA','70815','1022','CY','22033','1980-05-12','F','U',':RET:2054-5','N','021','DEN','3639098','18575LA002000201','2014-04-01','2014-03-05 16:56:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:27'),(6655,5278,'Y','18','021','EC','A','','','AC','0000563099','0000563099','OH00000184332','IL','1','Fulton','Gerald','','','','34','287767052','623 DAYTONIA AVE',0,'FAIRBORN','OH','45324','2330','CY','39057','1965-07-21','M','U',':RET:2106-3','T','021','DEN','108859','99734OH005000401','2014-01-01','2013-11-15 20:24:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:00:41'),(14097,11233,'Y','18','021','EC','A','','','AC','0000498169','0000498169','OH00001380124','IL','1','TITTLE','KELLY','','','','34','288885695','307 FAYE DR',0,'COLUMBUS','OH','43230','2911','CY','39049','1984-06-01','F','R',':RET:2106-3','N','021','DEN','2058238','99734OH005000401','2014-02-01','2013-12-26 11:35:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:28'),(14655,11697,'Y','18','021','EC','A','','','AC','0000381511','0000381511','TX00001412887','IL','1','Garza','Vanessa','','','','34','463591597','2505 W. 66th Street',0,'Mission','TX','78574',NULL,'CY','48215','1982-09-18','F','U',':RET:2106-3','T','021','DEN','1636063','33348TX002000201','2014-02-01','2013-12-27 20:35:45','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,1,'2013-12-29 11:07:50'),(9078,7203,'N','01','021','EC','A',NULL,NULL,'','0000407357','0001038584','','IL','1','FLORES','JOSEPH','','','','34','301569018','10940 AARON DR',0,'CLEVELAND','OH','44130',NULL,'CY','39035','1957-01-28','M','',NULL,'N','021','DEN','1732285','99734OH005000301','2014-01-01','2013-12-17 19:22:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:06:45'),(13120,10464,'Y','18','021','EC','A','','','AC','0000870628','0000870628','OH00000025495','IL','1','Packer','Edward','','','III','34','281669197','9483 Conklin Avenue',0,'Cincinnati','OH','45242',NULL,'CY','39061','1973-09-28','M','M',':RET:2106-3','N','021','DEN','1790866','99734OH005000401','2014-01-01','2013-12-23 14:06:35','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:43'),(19529,15564,'Y','18','024','14','A','','','TE','0000761073','0000761073','','IL','1','Stivaletti','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-04-20','M','',NULL,NULL,NULL,'','63757','','2014-01-22','2014-01-22 14:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:20'),(21026,16801,'N','01','021','EC','A',NULL,NULL,'','0000206490','0001225883','','IL','1','Draper','William','','','','34','351605667','7229 AKIKAI DR',0,'DIAMONDHEAD','MS','39525','3908','CY','28045','1961-10-02','M','',':RET:2106-3','T','021','DEN','3734128','46300MS002000201','2014-03-01','2014-02-01 14:03:57',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-01 19:00:42'),(24005,19089,'Y','18','021','EC','A','','','AC','0000362544','0000362544','OH00001832704','IL','1','Lenix','Charles','','','','34','299828692','3969 E29st.',0,'Newburg Heights','OH','44105',NULL,'CY','39035','1984-06-08','M','U',':RET:2054-5','N','021','DEN','3272903','99734OH005000401','2014-03-01','2014-02-15 10:51:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:36'),(24429,19405,'Y','18','021','EC','A','','','AC','0001219639','0001219639','OH00001530759','IL','1','Martin','Kathy','','','','34','272564473','2322 13TH ST SW',0,'AKRON','OH','44314','2032','CY','39153','1954-12-14','F','U',':RET:2106-3','N','021','HLT','3238634','52664OH151001305','2014-04-01','2014-02-18 11:09:02','457.00',NULL,NULL,'580.49','123.49','R-OH012','OH0','580.49',NULL,0,'2014-02-18 22:01:12'),(26679,21152,'Y','18','021','EC','A','','','AC','0002138124','0002138124','LA00002793739','IL','1','grisby','Sandra','','','','34','435175178','11558 WILLOW OAK AVE',0,'BATON ROUGE','LA','70815','2391','CY','22033','1971-01-02','F','M',':RET:2054-5','N','021','DEN','3919282','18575LA002000201','2014-04-01','2014-02-28 13:21:18','0.00',NULL,NULL,'43.83','43.83','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:22'),(88,77,'Y','18','021','EC','A','','','AC','0001236470','0001236470','TX00000591041','IL','1','Kincaid','Rick','','','','34','638055265','74 Hillview Ln',0,'Fredericksburg','TX','78624',NULL,'CY','48171','1973-10-28','M','U',':RET:2106-3','N','021','DEN','719846','33348TX002000201','2014-01-01','2013-12-04 18:54:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:17:21'),(16128,12918,'N','01','021','EC','A',NULL,NULL,'','0000383372','0000064900','','IL','1','Jackson','Nichole','Jessica','','','34','595929666','10 CHATEAU PL',0,'MILFORD','OH','45150','1259','CY','39025','1990-01-20','F','',':RET:2106-3','T','021','HLT','1849186','92036OH006000601','2014-02-01','2014-01-03 01:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.78',NULL,0,'2014-01-04 02:05:36'),(16003,12808,'Y','18','021','EC','A','','','AC','0000116912','0000116912','TX00002145565','IL','1','Kuykendall','Robbie','','','','34','453454353','4600 Seton Center Pkwy',0,'Austin','TX','78759',NULL,'CY','48453','1978-11-01','F','U',':RET:2054-5','N','021','DEN','1884802','33348TX002000201','2014-02-01','2014-01-03 15:49:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-04 02:01:33'),(14139,11270,'Y','18','021','EC','A','','','AC','0001600410','0001600410','LA00000862474','IL','1','Slay','Marjorie','','','','34','435844053','191 Kings Circle',0,'Grand Cane','LA','71032',NULL,'CY','22031','1954-01-01','F','M',':RET:2106-3','N','021','DEN','1969862','18575LA002000201','2014-02-01','2013-12-26 11:56:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-27 02:02:36'),(4996,3963,'N','01','021','EC','A',NULL,NULL,'','0001020392','0001219564','','IL','1','Shah','Ramesh','','','','34','283609612','696 HARCOURT DR',0,'CINCINNATI','OH','45246','1421','CY','39061','1953-08-12','M','',':RET:2029-7','N','021','DEN','679571','99734OH005000301','2014-01-01','2013-12-07 00:51:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:03'),(2771,2238,'N','01','021','EC','A',NULL,NULL,'','0000655790','0000243704','','IL','1','Toth','Robin','l',NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1964-08-18','F','',':RET:2106-3','N','021','HLT','212152','52664OH151001304','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45',NULL,0,'2013-12-25 19:49:31'),(17554,14035,'Y','18','021','EC','A','','','AC','0000959116','0000959116','OH00002208125','IL','1','Simes','Lisa','','','','34','539620645','506 Main Street',0,'Milford','OH','45150',NULL,'CY','39025','1958-07-13','F','U',':RET:2106-3','N','021','HLT','2011274','92036OH005000605','2014-02-01','2014-01-12 14:13:19','351.00',NULL,NULL,'478.72','127.72','R-OH005','OH0','478.72',NULL,0,'2014-01-13 03:01:56'),(17596,14065,'Y','18','021','EC','A','','','AC','0001072485','0001072485','MS00001443286','IL','1','ROBINSON','LACHATA','','','','34','427353114','577 ISABELLA ST',0,'CANTON','MS','39046','3438','CY','28089','1979-09-01','F','U',':RET:2054-5','N','021','DEN','1437325','46300MS002000201','2014-02-01','2014-01-13 13:00:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-14 01:32:13'),(21999,17567,'Y','18','021','EC','A','','','AC','0001743846','0001743846','LA00002596211','IL','1','DIEU','ELIZABETH','CHEN','','','34','567935570','16 GLACIER ST',0,'KENNER','LA','70065','1007','CY','22051','1963-12-14','F','M',':RET:2028-9','N','021','DEN','3180891','18575LA002000201','2014-03-01','2014-02-07 16:25:56','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-07 19:00:46'),(24057,19131,'N','19','021','EC','A',NULL,NULL,'','0000558192','0000362543','','IL','1','BEGLEY','SAMANTHA','','','','34','283921549','4238 WILLIAMSPORT DR',0,'BEAVERCREEK','OH','45430','1837','CY','39057','1990-06-02','F','',':RET:2106-3','N','021','DEN','3143301','99734OH005000301','2014-03-01','2014-02-14 20:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:07'),(24204,19222,'Y','18','021','EC','A','','','AC','0000254580','0000254580','OH00002424652','IL','1','Ranucci','Adam','','','','34','297888697','2154 MAPLEWOOD RD',0,'STOW','OH','44224','2645','CY','39153','1987-11-21','M','U',':RET:2106-3','N','021','DEN','3512658','99734OH005000301','2014-04-01','2014-02-16 17:09:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-16 19:00:18'),(1957,1596,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','267710','','2013-11-19','2013-11-19 22:58:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:08'),(4434,3524,'Y','18','021','EC','A','','','AC','0001135146','0001135146','OH00000976134','IL','1','BIDDLE','MELANIE','','','','34','284426089','5657 NAICHE RD',0,'COLUMBUS','OH','43213','3510','CY','39049','1950-03-01','F','U',':RET:2106-3','N','021','DEN','901286','99734OH005000301','2014-01-01','2013-12-11 18:25:34','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:57'),(17391,13915,'Y','18','021','EC','A','','','AC','0000035772','0000035772','OH00002157095','IL','1','Peek','Kristie','','','','34','104645662','1145 Robin Ct.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1970-02-02','F','U',':RET:2106-3','N','021','DEN','1930893','99734OH005000401','2014-02-01','2014-01-10 10:14:47','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-13 03:00:11'),(21256,16986,'N','01','021','EC','A',NULL,NULL,'','0000607188','0000652163','','IL','1','Werner','Lynn','','','','34','297622255','4845 Oster Rd',0,'Sheffield Lake','OH','44054',NULL,'CY','39093','1968-11-19','F','',':RET:2106-3','N','021','HLT','3305929','52664OH151001305','2014-03-01','2014-02-03 16:22:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.19',NULL,0,'2014-02-03 21:01:20'),(25349,20114,'Y','18','021','EC','A','','','AC','0001742471','0001742471','LA00002630680','IL','1','FLEMING','TAMMY','','','','34','434594218','327 YEARLING LOOP',0,'PEARL RIVER','LA','70452','5408','CY','22103','1967-11-09','F','M',NULL,'N','021','DEN','2862331','18575LA002000101','2014-04-01','2014-02-25 09:04:44','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-25 21:30:30'),(25576,20288,'N','19','021','EC','A',NULL,NULL,'','0000123023','0000190241','','IL','1','Hirn','Abby','Marie','','','34','278049832','410 E 3RD ST',0,'DELPHOS','OH','45833','1771','CY','39003','1999-04-21','F','',':RET:2106-3','N','021','HLT','3347484','92036OH001001501','2014-04-01','2014-02-23 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','168.58',NULL,0,'2014-02-26 08:00:33'),(26826,21261,'Y','18','021','EC','A','','','AC','0000590842','0000590842','OH00001979731','IL','1','Musarra','Dominic','Anthony','','Jr','34','292904949','33139 RoundHead Pl',0,'Solon','OH','44139',NULL,'CY','39035','1989-09-20','M','U',':RET:2106-3','N','021','DEN','3647970','99734OH005000401','2014-04-01','2014-03-01 13:21:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:37'),(6519,5168,'Y','18','021','EC','A','','','AC','0000948387','0000948387','OH00000017086','IL','1','Caplinger','Richard','Paul','','','34','286706026','2217 PARK AVE',0,'NORWOOD','OH','45212','3204','CY','39061','1976-01-06','M','U',':RET:2106-3','N','021','HLT','983746','92036OH006001201','2014-01-01','2013-12-10 20:12:52','0.00',NULL,NULL,'210.76','210.76','R-OH004','OH0','210.76',NULL,0,'2013-12-26 00:51:20'),(5225,4148,'Y','18','024','14','A','','','TE','0001119947','0001119947','','IL','1','Bougie','Kristine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-27','F','',NULL,NULL,NULL,'','2566595','','2013-12-19','2013-12-19 17:52:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:39'),(2252,1848,'N','19','021','EC','A',NULL,NULL,'','0000385874','0000431350','','IL','1','MESONES','INES','M','','','34','292081074','8717 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','2004-01-09','F','',':RET:2106-3','N','021','DEN','688704','99734OH005000301','2014-01-01','2013-12-08 19:49:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:08'),(13273,10594,'Y','18','021','EC','A','','','AC','0001041322','0001041322','TX00000481544','IL','1','Gutierrez','William','','','','34','467997185','16127 MORGAN RUN',0,'MISSOURI CITY','TX','77489','8008','CY','48157','1964-04-21','M','M',NULL,'N','021','DEN','1526896','33348TX002000201','2014-01-01','2013-12-23 12:29:48','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:56:58'),(18316,14623,'N','01','021','EC','A',NULL,NULL,'','0001199526','0000560575','','IL','1','Greathouse','Dwight','Lee','','','34','291689133','1304 SEVILLA AVE',0,'AKRON','OH','44314','1421','CY','39153','1963-02-15','M','',':RET:2054-5','T','021','DEN','1730789','99734OH005000401','2014-02-01','2014-01-15 14:04:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:05'),(18701,14910,'Y','18','021','EC','A','','','AC','0002224544','0002224544','LA00001413380','IL','1','Andrews','Camary','C','','','34','436757000','409 ASCOT CT',0,'BOSSIER CITY','LA','71111','2250','CY','22015','1989-08-18','F','U',':RET:2054-5','N','021','DEN','2574187','18575LA002000101','2014-02-01','2014-01-15 19:38:31','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-17 03:35:28'),(19348,15424,'Y','18','021','EC','A','','','AC','0000387310','0000387310','OH00002575947','IL','1','McCoy','Karen','','','','34','157729287','10210 WINSTEAD LN',0,'CINCINNATI','OH','45231','2720','CY','39061','1966-05-15','F','M',NULL,'N','021','DEN','3202365','99734OH005000301','2014-03-01','2014-01-21 14:02:09','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,1,'2014-01-22 03:22:25'),(21235,16969,'Y','18','021','EC','A','','','AC','0001105571','0001105571','OH00001396889','IL','1','AERI','PANKAJ','','','','34','096886549','6060 ROUND TOWER LN',0,'DUBLIN','OH','43017','3451','CY','39049','1969-05-27','M','M',':RET:2029-7','N','021','DEN','3426351','99734OH005000301','2014-03-01','2014-02-03 13:10:14','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-03 21:01:10'),(22676,18108,'Y','18','021','EC','A','','','AC','0001177660','0001177660','TX00002512999','IL','1','STEWART','JUDY','','','','34','465980942','1003 E DALLAS ST',0,'MANSFIELD','TX','76063',NULL,'CY','48439','1952-04-02','F','U',NULL,'N','021','DEN','3192417','33348TX002000201','2014-03-01','2014-02-11 16:11:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:44'),(26835,21269,'Y','18','021','EC','A','','','AC','0000242765','0000242765','OH00002944032','S3','1','Baggett','Jessica','J','','','34','295087254','9730 BUCHER RD',0,'WHITEHOUSE','OH','43571','9369','CY','39095','2004-03-18','M','U',':RET:2106-3','N','021','DEN','2924168','99734OH005000401','2014-04-01','2014-03-01 16:34:17','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','15.78',NULL,0,'2014-03-01 21:00:42'),(7612,6023,'N','01','021','EC','A',NULL,NULL,'','0000348758','0000049243','','IL','1','Warren','Lana','','','','34','449230110','7018 Wild Violet Dr.',0,'Humble','TX','77346',NULL,'CY','48201','1956-06-12','F','',':RET:2106-3','N','021','DEN','1222005','33348TX002000101','2014-01-01','2013-11-17 09:01:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 02:45:40'),(16837,13468,'Y','18','021','EC','A','','','AC','0000979315','0000979315','OH00002235077','IL','1','Babcock','Andy','','','','34','048903228','414 HILLCREST DR',0,'CINCINNATI','OH','45215','2502','CY','39061','1991-07-10','M','U',NULL,'N','021','HLT','2084227','92036OH005001205','2014-02-01','2014-01-11 10:04:20','122.00',NULL,NULL,'214.67','92.67','R-OH004','OH0','214.67',NULL,0,'2014-01-13 02:18:31'),(1217,1000,'Y','18','021','EC','A','','','AC','0000110495','0000110495','OH00001003025','IL','1','hopwood','william','','','','34','287425325','210 N MAIN ST',0,'DAYTON','OH','45402','1252','CY','39113','1957-06-05','M','U',':RET:2106-3','N','021','HLT','170752','92036OH004000501','2014-01-01','2013-12-03 16:48:51','0.00',NULL,NULL,'445.91','445.91','R-OH003','OH0','445.91',NULL,0,'2013-12-25 18:20:17'),(16675,13345,'Y','18','021','EC','A','','','AC','0000230451','0000230451','OH00002215612','IL','1','Meley','Vanessa','','','','34','302862119','679 HOGUE AVE',0,'AKRON','OH','44310','2423','CY','39153','1979-02-22','F','U',':RET:2106-3','N','021','DEN','1430949','99734OH005000301','2014-02-01','2014-01-07 13:18:06','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-08 18:24:30'),(15349,12278,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00002048676','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','1485397','52664OH152000901','2014-02-01','2014-01-01 14:50:49','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,1,'2014-01-02 04:24:28'),(15291,12225,'N','01','021','EC','A',NULL,NULL,'','0002232949','0001156310','','IL','1','PIKES','RONALD','PERRY','','','34','439177041','5964 HIGHWAY 6',0,'NATCHITOCHES','LA','71457','7104','CY','22069','1959-11-09','M','',':RET:2054-5','N','021','DEN','1556845','18575LA002000101','2014-02-01','2013-12-31 20:14:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,1,'2014-01-02 04:22:27'),(2422,1974,'N','19','021','EC','A',NULL,NULL,'','0000133293','0000912933','','IL','1','Yablonsky','Evan','','','','34','275064626','5763 RUTLEDGE TRL',0,'LIBERTY TWP','OH','45011','1245','CY','39017','2001-01-17','M','',':RET:2106-3','N','021','DEN','1039687','99734OH005000401','2014-01-01','2013-12-09 16:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:58'),(13655,10894,'Y','18','021','EC','A','','','AC','0001444292','0001444292','LA00000924066','IL','1','Miller','Deborah','','','','34','433902506','214 MORNING MEADOW CIR',0,'WEST MONROE','LA','71292','6164','CY','22073','1953-06-17','F','U',':RET:2106-3','N','021','DEN','1692124','18575LA002000101','2014-01-01','2013-12-22 23:49:08','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-26 13:07:26'),(5070,4018,'N','01','021','EC','A',NULL,NULL,'','0001127063','0000368141','','IL','1','GUERRA','JUAN','','','','34','640269037','1 JAMES CIRCLE',0,'THE COLONY','TX','75056',NULL,'CY','48121','1977-05-27','M','',NULL,'N','021','DEN','1799031','33348TX002000201','2014-01-01','2013-12-19 11:38:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:00:41'),(22587,18040,'Y','18','024','14','A','','','TE','0000268913','0000268913','','IL','1','Diamond','Ariel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-19','F','',NULL,NULL,NULL,'','1482882','','2014-02-25','2014-02-10 14:23:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-10 21:32:07'),(26741,21194,'Y','18','021','EC','A','','','AC','0000906653','0000906653','OH00002419877','IL','1','Harshman','Suzanne',NULL,NULL,NULL,NULL,NULL,'7241 Dorr St.',0,'Toledo','OH','43615',NULL,'CY','39095','1955-05-14','F','U',NULL,'N','021','HLT','2738320','92036OH001002601','2014-04-01','2014-02-28 15:10:03','306.00',NULL,NULL,'599.30','293.30','R-OH001','OH0','599.30',NULL,0,'2014-02-28 21:31:55'),(27257,21583,'Y','18','021','EC','A','','','AC','0000618422','0000618422','OH00003371176','IL','1','Branco','Gurli','','','','34','300543763','401 Castalia St.',0,'Bellevue','OH','44811',NULL,'CY','39077','1963-01-19','F','M',NULL,'N','021','HLT','3321125','92036OH003002704','2014-04-01','2014-03-03 17:33:41','661.00',NULL,NULL,'984.17','323.17','R-OH006','OH0','379.79',NULL,0,'2014-03-03 21:31:57'),(490,400,'Y','18','021','EC','A','','','AC','0000407680','0000407680','LA00000965745','IL','1','Eharb','Randall','','','','34','560735337','322 Bienville dr.',0,'Gretna','LA','70056',NULL,'CY','22051','1971-06-27','M','U',':RET:2106-3','N','021','DEN','567377','18575LA002000201','2014-01-01','2013-12-04 10:50:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:22'),(4218,3356,'Y','18','021','EC','A','','','AC','0000307605','0000307605','TX00001284183','IL','1','Rios','Jane','','','','34','458861419','6809 N 17TH ST',0,'MCALLEN','TX','78504','3325','CY','48215','1949-06-25','F','M',':RET:2106-3','N','021','DEN','1710247','33348TX002000201','2014-01-01','2013-12-17 10:28:45','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:50:20'),(16246,13010,'Y','18','021','EC','A','','','AC','0000705159','0000705159','OH00001570113','IL','1','Chow','Phillip','','','','34','093604016','34078 MONICA DR',0,'NORTH RIDGEVILLE','OH','44039','2130','CY','39093','1970-09-23','M','M',':RET:2034-7','N','021','DEN','2297738','99734OH005000301','2014-02-01','2014-01-04 11:35:44','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-05 00:02:31'),(15946,12766,'Y','18','021','EC','A','','','AC','0000380069','0000380069','OH00001372487','IL','1','Hall','Juliean','','','','34','275561342','7769 STATE ROUTE 29',0,'DE GRAFF','OH','43318','9525','CY','39021','1953-12-20','F','U',':RET:2106-3','N','021','HLT','2239675','92036OH002000501','2014-02-01','2014-01-02 11:49:19','558.00',NULL,NULL,'745.01','187.01','R-OH003','OH0','745.01',NULL,0,'2014-01-03 02:07:21'),(15865,12703,'Y','18','021','EC','A','','','AC','0001212004','0001212004','MS00001687168','IL','1','BROWN','JAMES','EDWARD','','Jr','34','428714433','208 GORDON ST',0,'HATTIESBURG','MS','39401',NULL,'CY','28035','1991-07-18','M','U',':RET:2054-5','T','021','DEN','2487393','46300MS002000101','2014-02-01','2014-01-02 12:38:31','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-03 02:04:54'),(4485,3557,'N','19','021','EC','A',NULL,NULL,'','0000912935','0000495433','','IL','1','Williams','Kingston',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2010-12-09','M','',':RET:2054-5','N','021','DEN','922603','99734OH005000301','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:03:02'),(14362,11454,'Y','18','021','EC','A','','','AC','0000498171','0000498171','OH00001660390','IL','1','BECKER','TERESA','','','','34','299687395','233 MILLPOND RD',0,'SUNBURY','OH','43074','8469','CY','39041','1968-11-19','F','U',':RET:2106-3','N','021','DEN','1834098','99734OH005000401','2014-02-01','2013-12-26 20:05:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:17'),(14273,11387,'Y','18','021','EC','A','','','AC','0000908140','0000908140','MS00000699347','IL','1','Smith','David','Douglas','','IV','34','587633035','5260 MATTOX ST',0,'JACKSON','MS','39209','2337','CY','28049','1979-10-01','M','U',':RET:2054-5','N','021','DEN','2144911','46300MS002000201','2014-02-01','2013-12-26 13:22:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:08'),(4804,3807,'Y','18','021','EC','A','','','AC','0000024366','0000024366','LA00000946955','IL','1','MORRIS','LINDA','','','','34','435351918','217 LA RUE RHIEMS',0,'DUSON','LA','70529','3324','CY','22055','1966-01-18','F','U',':RET:2054-5','N','021','DEN','1031852','18575LA002000201','2014-01-01','2013-12-08 16:53:20','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 22:16:35'),(18277,14592,'Y','18','021','EC','A','','','AC','0000008879','0000008879','TX00001897932','IL','1','Martinez','Fernando','','','Jr','34','637767379','6301 RUDY VIDOVIC',0,'EL PASO','TX','79932','1856','CY','48141','1980-05-19','M','U',':RET:2106-3','N','021','DEN','1820787','33348TX002000201','2014-02-01','2014-01-15 17:59:27','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-16 08:44:45'),(18449,14717,'Y','18','021','EC','A','','','AC','0000909497','0000909497','OH00001935050','IL','1','Newnam','Terri','','','','34','271520471','565 Countryside Dr South',0,'Troy','OH','45373',NULL,'CY','39109','1950-09-09','F','M',':RET:2106-3','N','021','HLT','2026613','92036OH006000501','2014-02-01','2014-01-14 19:27:03','1078.29',NULL,NULL,'1086.23','7.94','R-OH003','OH0','556.49',NULL,0,'2014-01-16 08:46:06'),(22349,17849,'Y','18','021','EC','A','','','AC','0001143344','0001143344','OH00001595649','IL','1','GRAHN','DEBORAH','SUE','','','34','085388827','6263 NEBRASKA AVE',0,'TOLEDO','OH','43615','4919','CY','39095','1953-09-19','F','M',':RET:2106-3','N','021','HLT','3549703','92036OH005002606','2014-03-01','2014-01-31 10:06:54','431.00',NULL,NULL,'529.21','98.21','R-OH001','OH0','529.21',NULL,0,'2014-02-10 11:01:14'),(1508,1257,'Y','18','021','EC','A','','','AC','0000568029','0000568029','OH00001196024','IL','1','Valles','Ismael','','','','34','417068948','1557 BIG HILL RD',0,'DAYTON','OH','45429','1206','CY','39113','1959-11-14','M','R',':RET:2106-3','N','021','DEN','2547407','99734OH005000401','2014-01-01','2013-12-24 12:37:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:49:25'),(1955,1594,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000186613','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','267710','33348TX002000101','2014-01-01','2013-11-19 22:57:57','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:04'),(20202,16120,'Y','18','021','EC','A','','','AC','0000728747','0000728747','OH00001948120','IL','1','Steinert','Holly','','','','34','292824341','4586 Lakeland Dr',0,'Batavia','OH','45103',NULL,'CY','39025','1974-12-31','F','M',NULL,'N','021','HLT','1868716','92036OH006000601','2014-03-01','2014-01-27 12:12:31','367.00',NULL,NULL,'418.80','51.80','R-OH005','OH0','214.85',NULL,0,'2014-01-27 21:01:33'),(2865,2315,'Y','18','021','EC','A','','','AC','0000532068','0000532068','OH00000038180','IL','1','Puckett','Brandon','','','','34','274842848','4967 BLENDON RAVINE CT',0,'COLUMBUS','OH','43230','4214','CY','39049','1985-04-08','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','454302','99734OH005000401','2014-01-01','2013-11-02 15:29:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:01:44'),(4544,3601,'Y','18','021','EC','A','','','AC','0000352946','0000352946','TX00000659159','IL','1','Rogers','Cindy','Lou','','','34','452379073','6742 COUNTY ROAD 281',0,'MCKINNEY','TX','75071','7938','CY','48085','1959-11-19','F','U',':RET:2106-3','N','021','DEN','925067','33348TX002000201','2014-01-01','2013-12-12 18:25:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:04:22'),(19764,15754,'N','01','021','EC','A',NULL,NULL,'','0001090011','0001028618','','IL','1','perkins','willie','','','Jr','34','411253720','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','1961-12-28','M','',':RET:2054-5','T','021','DEN','2486451','46300MS002000101','2014-03-01','2014-01-23 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-23 21:01:25'),(17849,14258,'Y','18','021','EC','A','','','AC','0000362518','0000362518','OH00002366612','IL','1','Gregus','Eric','','','','34','288944102','34414 HEATHERWOOD AVE',0,'AVON','OH','44011','2400','CY','39093','1989-07-30','M','U',':RET:2106-3','N','021','DEN','2314859','99734OH005000401','2014-02-01','2014-01-14 09:07:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:06'),(3521,2828,'Y','18','021','EC','A','','','AC','0000245358','0000245358','MS00000566774','IL','1','Goldstein','Robert','','','','34','125622712','123 Road 960',0,'Tupelo','MS','38804',NULL,'CY','28081','1979-09-18','M','M',':RET:2106-3','N','021','DEN','2548389','46300MS002000101','2014-01-01','2013-12-22 11:42:55','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2013-12-25 21:21:15'),(3599,2886,'Y','18','021','EC','A','','','AC','0001250833','0001250833','OH00001315011','IL','1','Ward','Jeffery','','','','34','591167999','230 Whittlesy Ave',0,'Norwalk','OH','44857',NULL,'CY','39077','1968-11-01','M','M',':RET:2106-3','N','021','HLT','2060485','92036OH006002701','2014-01-01','2013-12-22 11:30:16','0.00',NULL,NULL,'223.31','223.31','R-OH006','OH0','223.31',NULL,0,'2013-12-25 21:23:12'),(13204,10537,'Y','18','021','EC','A','','','AC','0000946796','0000946796','TX00000030470','IL','1','Kemper','Terry','','','','34','495663301','6605 RIVERHILL DR',0,'PLANO','TX','75024','7437','CY','48121','1956-01-13','M','R',':RET:2106-3','N','021','DEN','2425449','33348TX002000101','2014-01-01','2013-12-23 17:32:52','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:55:03'),(13364,10674,'Y','18','021','EC','A','','','AC','0000895707','0000895707','OH00000940534','IL','1','Smith','Michele','','','','34','286500916','292 S WOODLAND AVE',0,'CLYDE','OH','43410','1839','CY','39143','1963-07-26','F','U',':RET:2106-3','N','021','DEN','1881796','99734OH005000301','2014-01-01','2013-12-22 19:27:02','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-26 12:59:33'),(15618,12491,'Y','18','021','EC','A','','','AC','0000147665','0000147665','MS00001374977','IL','1','PLAISANCE','MELISSA','','','','34','439574312','69 S APPLE SOUTH DR',0,'CARRIERE','MS','39426','8935','CY','28109','1971-10-13','F','M',':RET:2106-3','N','021','DEN','1809693','46300MS002000101','2014-02-01','2013-12-31 00:28:43','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,1,'2014-01-02 04:33:02'),(14220,11339,'Y','18','021','EC','A','','','AC','0000109054','0000109054','TX00001242367','31','1','Rodriguez','Eric','','','','34','456794287','2111 N. Austin Ave',0,'Georgetown','TX','78626',NULL,'CY','48215','1983-09-25','M','U',':RET:2106-3','N','021','DEN','1847905','33348TX002000201','2014-02-01','2013-12-26 16:45:55','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-27 02:04:42'),(27828,22009,'Y','18','021','EC','A','','','AC','0001199564','0001199564','OH00002894047','S3','1','Lopez','John','Victoria','','','34','284020402','175 WEATHERSTONE CT',0,'COPLEY','OH','44321','3226','CY','39153','1997-06-12','F','U',':RET:2106-3','N','021','DEN','4074923','99734OH005000301','2014-04-01','2014-03-05 09:59:42','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','21.13',NULL,0,'2014-03-05 21:31:59'),(28986,22942,'Y','18','021','EC','A','','','AC','0001174457','0001174457','OH00003155282','IL','1','Archer','Rick','D','','','34','287641114','146 W. Market St.',0,'Canal Fulton','OH','44614',NULL,'CY','39151','1953-08-06','M','U',':RET:2106-3','N','021','HLT','4101778','52664OH151001304','2014-04-01','2014-03-10 13:46:57','342.00',NULL,NULL,'605.24','263.24','R-OH015','OH0','605.24',NULL,0,'2014-03-10 21:01:12'),(520,425,'Y','18','021','EC','A','','','AC','0000998750','0000998750','OH00001110555','IL','1','Ursetti','Maria','','','','34','270809683','772 Franklin Blvd',0,'Highland Heights','OH','44143',NULL,'CY','39035','1982-03-10','F','U',':RET:2106-3','N','021','DEN','345588','99734OH005000301','2014-01-01','2013-12-04 11:02:40','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:49:11'),(1193,982,'Y','18','021','EC','A','','','AC','0000012402','0000012402','OH00000518722','IL','1','Fore','Tonya','','','','34','278783869','2800 Linkside Drive',0,'Cincinnati','OH','45245',NULL,'CY','39025','1980-05-09','F','U',':RET:2106-3','T','021','DEN','1139229','99734OH005000301','2014-01-01','2013-12-03 13:00:32','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:19:39'),(15861,12700,'Y','18','021','EC','A','','','AC','0001185940','0001185940','MS00001478709','31','1','Starks','Kim','','','','34','234886310','Po box 1125',0,'Booneville','MS','38829',NULL,'CY','28117','1956-08-22','F','U',':RET:2054-5','N','021','DEN','2044930','46300MS002000101','2014-02-01','2014-01-02 12:16:04','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-03 02:04:46'),(1960,1599,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','982048','','2013-11-19','2013-11-19 22:58:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:12'),(4487,3557,'N','01','021','EC','A',NULL,NULL,'','0000912935','0001183516','','IL','1','Williams','Jason','','','','34','294865519','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-01-06','M','',':RET:2054-5','N','021','DEN','922603','99734OH005000301','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:03:03'),(9290,7367,'N','19','021','EC','A',NULL,NULL,'','0000225979','0000679503','','IL','1','Smith','Samuel','Jedidiah','','','34','419854498','919 BROOKCREST DR',0,'MASON','OH','45040','3435','CY','39165','2012-03-03','M','',':RET:2106-3','N','021','DEN','1094066','99734OH005000301','2014-01-01','2013-11-30 14:42:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:16:08'),(7810,6187,'Y','18','021','EC','A','','','AC','0000973608','0000973608','TX00000223534','IL','1','Danna','Andrew','','','','34','460736561','2718 RIVER BIRCH DR',0,'SUGAR LAND','TX','77479','1517','CY','48157','1985-03-18','M','U',':RET:2106-3','T','021','DEN','2339774','33348TX002000201','2014-01-01','2013-12-20 17:44:22','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 03:03:55'),(23988,19073,'Y','18','024','14','A','','','TE','0002100986','0002100986','','IL','1','EDGAR','JANE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-12-18','F','',NULL,NULL,NULL,'','3266808','','2014-02-15','2014-02-15 13:58:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-15 22:00:24'),(25148,19949,'Y','18','021','EC','A','','','AC','0000233337','0000233337','TX00002556721','IL','1','Elliott','Diana','','','','34','456941603','10500 LUKE CT',0,'AUSTIN','TX','78750','1004','CY','48453','1959-01-18','F','U',':RET:2106-3','N','021','DEN','3073529','33348TX002000201','2014-04-01','2014-02-21 12:36:04','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-21 22:00:15'),(28606,22640,'Y','18','021','EC','A','','','AC','0000039875','0000039875','OH00002911840','IL','1','NDiaye','Ousmane','','','','34','129823792','4110 Elaine Court',0,'Columbus','OH','43227',NULL,'CY','39049','1960-04-04','M','M',':RET:2054-5','N','021','DEN','2717391','99734OH005000401','2014-04-01','2014-03-08 14:43:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:30:13'),(21664,17302,'N','01','021','EC','A',NULL,NULL,'','0001671586','0002362931','','IL','1','FARRELL','PAULA','','','','34','433924044','1241 FAIRWAY ST',0,'KENNER','LA','70062',NULL,'CY','22051','1952-03-04','F','',NULL,'N','021','DEN','2943992','18575LA002000201','2014-03-01','2014-02-05 13:48:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:30:56'),(19996,15950,'N','01','021','EC','A',NULL,NULL,'','0000257154','0001208331','','IL','1','slone','gary','','','','34','288643282','5491 HIGH POINT RD',0,'GLENFORD','OH','43739','9727','CY','39127','1961-01-27','M','',':RET:2106-3','N','021','DEN','3124360','99734OH005000401','2014-03-01','2014-01-26 18:02:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:03'),(16759,13407,'Y','18','024','14','A','','','TE','0000642087','0000642087','','IL','1','Miller','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-30','F','',NULL,NULL,NULL,'','2086405','','2014-01-07','2014-01-07 10:24:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:24:58'),(5809,4615,'Y','18','021','EC','A','','','AC','0000415450','0000415450','TX00000632302','IL','1','anderson','amy','','','','34','440847801','7150 OLD VALDASTA RD',0,'BLUE RIDGE','TX','75424','3767','CY','48085','1976-02-05','F','M',':RET:2106-3','N','021','DEN','2060662','33348TX002000201','2014-01-01','2013-12-23 21:37:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:47:43'),(7808,6185,'Y','18','021','EC','A','','','AC','0000078184','0000078184','TX00000328501','IL','1','Wilson','Amber','','','','34','534213062','4900 E Oltorf St',0,'Austin','TX','78741',NULL,'CY','48453','1986-04-17','F','U',':RET:2106-3','N','021','DEN','1421135','33348TX002000201','2014-01-01','2013-12-20 17:31:24','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 03:03:51'),(9741,7713,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-01-01','2013-11-15 09:46:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:45:56'),(14894,11896,'Y','18','024','14','A','','','TE','0001546826','0001546826','','IL','1','bell','reginald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-09','M','',NULL,NULL,NULL,'','2575003','','2013-12-29','2013-12-29 12:05:24',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-30 00:00:54'),(14970,11965,'Y','18','021','EC','A','','','AC','0000100889','0000100889','TX00001738792','IL','1','Moncivais','Gloria','','','','34','454994548','821 N ALAMO RD',0,'ALAMO','TX','78516','6803','CY','48215','1983-04-26','F','U',':RET:2106-3','N','021','DEN','2541393','33348TX002000201','2014-02-01','2013-12-30 12:06:21','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-01 12:00:46'),(24020,19103,'Y','18','021','EC','A','','','AC','0000545289','0000545289','OH00002249885','IL','1','Lindsey','Okang','','','','34','104068857','2212 SAGAMORE RD',0,'COLUMBUS','OH','43219','1272','CY','39049','1977-03-24','M','M',NULL,'N','021','DEN','3312572','99734OH005000401','2014-03-01','2014-02-15 15:02:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:46'),(24826,19680,'Y','18','021','EC','A','','','AC','0000759752','0000759752','OH00002699801','IL','1','VALLEE','BRENDA DIANE','','','','34','278583433','220 WASHINGTON AVE',0,'WILMINGTON','OH','45177','1130','CY','39027','1955-10-28','F','U',':RET:2106-3','N','021','HLT','3814777','92036OH004000601','2014-04-01','2014-02-19 14:25:55','334.00',NULL,NULL,'439.81','105.81','R-OH005','OH0','439.81',NULL,0,'2014-02-20 04:51:03'),(27175,21515,'Y','18','021','EC','A','','','AC','0000611258','0000611258','TX00003084069','31','1','CASTILLO','JUANA','','','','34','456575506','PO BOX 351',0,'ALAMO','TX','78516',NULL,'CY','48215','1970-10-02','F','U',NULL,'N','021','DEN','3872914','33348TX002000201','2014-04-01','2014-03-03 11:44:36','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-03 21:31:07'),(27303,21619,'N','01','021','EC','A',NULL,NULL,'','0000105192','0000142369','','IL','1','STANLEY','BARBARA','','','','34','454359657','1007 W 12TH ST',0,'CISCO','TX','76437','3708','CY','48133','1961-12-31','F','',':RET:2106-3','N','021','DEN','2969629','33348TX002000201','2014-04-01','2014-03-04 13:36:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:35'),(27786,21976,'Y','18','021','EC','A','','','AC','0000296528','0000296528','MS00003266549','31','1','SPAN','DEXTER','','','','34','587511601','P O BOX 835',0,'SHAW','MS','38773',NULL,'CY','28011','1972-05-29','M','U',':RET:2054-5','N','021','DEN','3226403','46300MS002000201','2014-04-01','2014-03-04 22:03:38','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-05 21:31:37'),(28739,22745,'Y','18','021','EC','A','','','AC','0002095841','0002095841','LA00003652912','IL','1','Schultz','Ray','','','','34','436940492','1484 ATHIS ST',0,'NEW ORLEANS','LA','70122','2028','CY','22071','1953-12-16','M','U',':RET:2106-3','T','021','DEN','4039178','18575LA002000201','2014-04-01','2014-03-08 19:30:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-09 21:00:08'),(8043,6367,'N','01','021','EC','A',NULL,NULL,'','0000067665','0000060253','','IL','1','Young','Brian','Russell','','','34','209482324','6552 Wise Ave NW',0,'North Canton','OH','44720',NULL,'CY','39151','1975-09-23','M','',':RET:2106-3','N','021','HLT','1650675','52664OH152000901','2014-01-01','2013-12-20 14:29:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.52',NULL,0,'2013-12-26 03:09:28'),(2834,2290,'Y','18','021','EC','A','','','AC','0000588228','0000588228','LA00000051933','IL','1','Dupont','Sheila','','','','34','439495717','1163 BEL OIL RD',0,'ELTON','LA','70532','5412','CY','22003','1981-01-04','F','U',':RET:2106-3','N','021','DEN','337035','18575LA002000201','2014-01-01','2013-11-24 16:27:53','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 20:00:50'),(1458,1215,'Y','18','021','EC','A','','','AC','0001018236','0001018236','OH00001417352','IL','1','Frank','Jessica','','','','34','273823854','1730 E HIGH ST',0,'BELLEFONTAINE','OH','43311','9487','CY','39091','1983-05-13','F','U',':RET:2106-3','N','021','DEN','1431714','99734OH005000401','2014-01-01','2013-12-24 08:11:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:14'),(2480,2019,'Y','18','021','EC','A','','','AC','0000993072','0000993072','LA00000062193','IL','1','Bradford','Brian','','','','34','433352695','2471 OAK MANOR CT',0,'BATON ROUGE','LA','70810','1880','CY','22033','1965-02-04','M','U',':RET:2106-3','T','021','DEN','829778','18575LA002000201','2014-01-01','2013-12-09 14:09:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:29'),(4299,3419,'Y','18','021','EC','A','','','AC','0000943411','0000943411','OH00000564100','IL','1','Grant','Jason','M','','','34','295564426','7566 n cr 29',0,'Flat rock','OH','44828',NULL,'CY','39147','1970-07-31','M','M',NULL,'N','021','HLT','2074677','92036OH004002701','2014-01-01','2013-12-16 21:35:11','417.44',NULL,NULL,'420.51','3.07','R-OH006','OH0','212.76',NULL,0,'2013-12-25 21:52:19'),(25512,20239,'N','01','021','EC','A',NULL,NULL,'','0000906649','0000128152','','IL','1','Anders','Helen','','','','34','270643338','2547 CONCORD RD',0,'HILLSBORO','OH','45133','6656','CY','39071','1956-12-21','F','',':RET:2106-3','N','021','HLT','3299380','92036OH004000601','2014-04-01','2014-02-25 14:04:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','420.66',NULL,0,'2014-02-25 21:32:01'),(25745,20419,'Y','18','021','EC','A','','','AC','0000936106','0000936106','OH00003204651','IL','1','Cato','Kristin','Nelvena','','','34','282761624','2384 Park Ave',0,'Cincinnati','OH','45206',NULL,'CY','39061','1980-07-08','F','U',':RET:2106-3','N','021','DEN','2757743','99734OH005000401','2014-04-01','2014-02-24 14:54:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 09:30:42'),(28969,22927,'N','01','021','EC','A',NULL,NULL,'','0001377728','0002073903','','IL','1','Castille','Edward','Charles','','','34','437803415','105 AMAUNT ST',0,'LAFAYETTE','LA','70501','1301','CY','22055','1951-10-26','M','',NULL,'T','021','DEN','3956497','18575LA002000201','2014-04-01','2014-03-10 16:32:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-10 21:01:01'),(21370,17080,'Y','18','021','EC','A','','','AC','0000616318','0000616318','TX00002445452','IL','1','Chavira','Jose','','','','34','459431167','407 W North 1st Street',0,'Roby','TX','79543',NULL,'CY','48151','1972-08-20','M','M',':RET:2106-3','N','021','DEN','3206716','33348TX002000201','2014-03-01','2014-02-04 17:41:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:48'),(1379,1144,'Y','18','021','EC','A','','','AC','0001298626','0001298626','LA00000814602','IL','1','Noel','Bradford','','','','34','434571613','1050 HUNTINGTON PL',0,'BREAUX BRIDGE','LA','70517','6304','CY','22099','1985-01-30','M','U',':RET:2054-5','T','021','DEN','2058141','18575LA002000201','2014-01-01','2013-12-24 08:33:55','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:46:02'),(17703,14146,'N','01','021','EC','A',NULL,NULL,'','0001268775','0001349981','','IL','1','RAMOS-ALVAREZ','ROXANA','','','','34','581339896','339 HELEN ST',0,'TERRYTOWN','LA','70056','3816','CY','22051','1963-07-27','F','',NULL,'N','021','DEN','1645190','18575LA002000201','2014-02-01','2014-01-13 13:45:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-14 01:33:05'),(17542,14025,'Y','18','021','EC','A','','','AC','0001088284','0001088284','OH00002231942','IL','1','shanahan','sharon','','','','34','282548983','652 CORTLANDT AVE',0,'LIMA','OH','45801','3560','CY','39003','1953-04-29','F','U',':RET:2106-3','T','021','HLT','2611494','92036OH004001501','2014-02-01','2014-01-12 12:14:55','303.00',NULL,NULL,'552.32','249.32','R-OH002','OH0','552.32',NULL,0,'2014-01-13 03:01:49'),(6461,5120,'Y','18','021','EC','A','','','AC','0000003557','0000003557','OH00001289261','IL','1','Channel','Karen','','','','34','284522636','1062 STILLMEADOW DR',0,'TALLMADGE','OH','44278','1646','CY','39153','1950-11-13','F','U',':RET:2106-3','N','021','HLT','476781','52664OH151001501','2014-01-01','2013-12-11 10:37:06','240.00',NULL,NULL,'789.56','549.56','R-OH012','OH0','789.56',NULL,0,'2013-12-26 00:49:54'),(9432,7483,'N','01','021','EC','A',NULL,NULL,'','0000457812','0001217366','','IL','1','Pfeiffer','Bryan','','','','34','283545334','17145 W TOUSSAINT NORTH RD',0,'GRAYTOWN','OH','43432','9760','CY','39123','1966-03-04','M','',':RET:2106-3','N','021','HLT','1635654','92036OH003002705','2014-01-01','2013-12-20 18:58:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','318.29',NULL,0,'2013-12-26 04:33:26'),(9057,7186,'Y','18','021','EC','A','','','AC','0001023170','0001023170','TX00001075018','IL','1','Pangelinan','Brenda','Marie','','','34','586745447','4400 ALAN KENT DR',0,'KILLEEN','TX','76549','4537','CY','48027','1970-09-10','F','M',':RET:2086-7','N','021','DEN','2346493','33348TX002000101','2014-01-01','2013-12-17 23:19:23','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-26 04:06:14'),(5567,4418,'N','19','021','EC','A',NULL,NULL,'','0001050608','0000260442','','IL','1','Coakley','Kyle','K',NULL,NULL,NULL,NULL,'1044 MCCOY CT',0,'PATASKALA','OH','43062','7098','CY','39089','1995-08-04','M','',':RET:2106-3','N','021','DEN','276530','99734OH005000301','2014-01-01','2013-11-05 19:28:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:36'),(4839,3833,'Y','18','021','EC','A','','','AC','0000048153','0000048153','OH00000828858','IL','1','Sotherden','Molly','','','','34','120625841','2667 STEWART DR',0,'RITTMAN','OH','44270','9618','CY','39169','1977-09-11','F','U',NULL,'N','021','HLT','1032970','52664OH152000901','2014-01-01','2013-11-07 19:22:03','0.00',NULL,NULL,'200.91','200.91','R-OH014','OH0','200.91',NULL,0,'2013-12-25 22:30:05'),(23511,18729,'Y','18','021','EC','A','','','AC','0000955980','0000955980','MS00002300588','IL','1','kennedy','gwendolyn','','','','34','587620848','111 EUGENE DR',0,'GULFPORT','MS','39503','3308','CY','28047','1951-08-22','F','M',NULL,'N','021','DEN','3777327','46300MS002000101','2014-03-01','2014-02-13 12:31:34','0.00',NULL,NULL,'54.30','54.30','R-MS005','MS0','27.15',NULL,0,'2014-02-13 22:02:14'),(25761,20433,'Y','18','021','EC','A','','','AC','0000324882','0000324882','OH00001841067','IL','1','CHAFFIN','DAWN','','','','34','287625089','844 LORAIN ST',0,'AKRON','OH','44305','1545','CY','39153','1957-02-03','F','M',NULL,'N','021','HLT','3673494','52664OH151001305','2014-04-01','2014-02-24 13:12:39','378.00',NULL,NULL,'543.47','165.47','R-OH012','OH0','543.47',NULL,0,'2014-02-26 09:30:51'),(26443,20974,'N','01','021','EC','A',NULL,NULL,'','0000341397','0000278366','','IL','1','Groo','Abigail','C','','','34','183549184','560 EDINBOROUGH DR',0,'BAY VILLAGE','OH','44140','3014','CY','39035','1960-07-05','F','',':RET:2106-3','N','021','DEN','3847510','99734OH005000301','2014-03-01','2014-02-26 22:07:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:30:22'),(27778,21968,'Y','18','021','EC','A','','','AC','0000701759','0000701759','OH00002800405','IL','1','Quidgeon','Brittany','','','','34','250776774','448 W COLUMBIA ST',0,'ALLIANCE','OH','44601','2332','CY','39151','1989-03-29','F','M',':RET:2106-3','N','021','HLT','3954961','52664OH152000901','2014-04-01','2014-03-05 12:00:00','0.00',NULL,NULL,'163.99','163.99','R-OH015','OH0','163.99',NULL,0,'2014-03-05 21:31:31'),(28340,22423,'Y','18','021','EC','A','','','AC','0001105327','0001105327','TX00003052957','IL','1','TING','KIN','','','','34','457992571','4515 RANGER RUN',0,'SUGAR LAND','TX','77479','2013','CY','48157','1960-12-02','M','M',':RET:2034-7','N','021','DEN','3934516','33348TX002000201','2014-04-01','2014-03-07 10:38:11','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:16'),(28582,22620,'Y','18','024','14','A','','','TE','0001100653','0001100653','','IL','1','Lewis','Kathleen','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-30','F','',NULL,NULL,NULL,'','2680004','','2014-03-08','2014-03-08 13:35:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-08 21:00:08'),(29083,23019,'Y','18','021','EC','A','','','AC','0000453424','0000453424','MS00003334856','IL','1','NELSON','MAJOR','','','Jr','34','587351852','5230 WILLIAMS RD',0,'HERNANDO','MS','38632','4287','CY','28033','1964-10-19','M','U',':RET:2054-5','N','021','DEN','3736560','46300MS002000101','2014-04-01','2014-03-10 16:51:01','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-03-10 21:02:05'),(402,330,'N','01','021','EC','A',NULL,NULL,'','0000573032','0000207096','','IL','1','Fink','Paul','','','','34','292505661','4710 Dutch Ridge Rd.',0,'New Straitsville','OH','43766',NULL,'CY','39127','1952-04-22','M','',':RET:2106-3','N','021','DEN','1050137','99734OH005000401','2014-01-01','2013-12-04 09:09:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:10'),(6586,5221,'N','01','021','EC','A',NULL,NULL,'','0000920784','0001037322','','IL','1','Myers','Michael','','','','34','275746824','10140 STATE ROUTE 132',0,'PLEASANT PLAIN','OH','45162','9789','CY','39165','1962-09-18','M','',NULL,'N','021','HLT','187408','92036OH003001205','2014-01-01','2013-12-11 12:21:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','418.11',NULL,0,'2013-12-26 00:53:06'),(2581,2098,'Y','18','024','14','A','','','TE','0000834436','0000834436','','IL','1','McGarvey','Steve',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-06-23','M','',NULL,NULL,NULL,'','1127936','','2013-12-09','2013-12-09 16:53:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:38:00'),(3825,3063,'Y','18','021','EC','A','','','AC','0001246915','0001246915','OH00000033544','IL','1','Moore','Jeanie','','','','34','277702539','3841 Habitat Dr',0,'Columbus','OH','43228',NULL,'CY','39049','1961-11-21','F','U',':RET:2106-3','N','021','DEN','194034','99734OH005000301','2014-01-01','2013-12-13 15:13:27','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:35:03'),(17986,14373,'Y','18','021','EC','A','','','AC','0001033682','0001033682','OH00002022607','31','1','roberts','kraig','daniel','','','34','294644150','po box 756',0,'lakemore','OH','44250',NULL,'CY','39153','1962-12-28','M','U',':RET:2106-3','N','021','HLT','1548290','52664OH151001306','2014-02-01','2014-01-14 16:54:04','329.00',NULL,NULL,'415.91','86.91','R-OH012','OH0','415.91',NULL,0,'2014-01-15 02:06:55'),(21348,17061,'Y','18','021','EC','A','','','AC','0000439546','0000439546','TX00001855373','31','1','RIDDLE','JASON','','','','34','461936303','po box 37',0,'moscow','TX','75960',NULL,'CY','48373','1974-03-20','M','R',':RET:2106-3','T','021','DEN','2793524','33348TX002000201','2014-03-01','2014-02-04 09:18:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:36'),(24714,19623,'Y','18','021','EC','A','','','AC','0001152249','0001152249','OH00002270652','IL','1','kunsman','tabitha','','','','34','301747143','1100 WHITTLESAY LN',0,'ROCKY RIVER','OH','44116','2162','CY','39035','1979-09-15','F','U',':RET:2106-3','N','021','DEN','3136101','99734OH005000401','2014-04-01','2014-02-19 08:31:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:36:41'),(24833,19687,'Y','18','021','EC','A','','','AC','0000709756','0000709756','MS00003010949','IL','1','Thomas','James','Hoyat','','','34','587115418','208 VALLEY RIDGE DR',0,'JACKSON','MS','39206','3157','CY','28049','1961-09-02','M','M',':RET:2054-5','N','021','DEN','2622935','46300MS002000101','2014-04-01','2014-02-18 22:51:01','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:52:35'),(27066,21430,'Y','18','021','EC','A','','','AC','0001723224','0001723224','LA00002591307','31','1','Conerly','Mary','','','','34','437929832','PO BOX 254',0,'Amte','LA','70422',NULL,'CY','22105','1955-09-23','F','U',':RET:2054-5','N','021','DEN','3880439','18575LA002000201','2014-04-01','2014-03-03 10:40:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-03 21:30:02'),(27246,21573,'Y','18','021','EC','A','','','AC','0000759987','0000759987','TX00002374227','IL','1','HILL','ZELMA','','','','34','460335858','810 S MAJOR DR',0,'BEAUMONT','TX','77707',NULL,'CY','48245','1961-01-22','F','U',':RET:2054-5','N','021','DEN','2823507','33348TX002000101','2014-04-01','2014-03-03 11:53:29','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2014-03-03 21:31:50'),(6738,5345,'Y','18','021','EC','A','','','AC','0000045724','0000045724','OH00001121897','IL','1','BLUBAUGH','CYNTHIA','JANE','','','34','269646950','1737 OAK TRAIL ST NE',0,'MASSILLON','OH','44646',NULL,'CY','39151','1957-08-29','F','U',':RET:2106-3','T','021','DEN','1132875','99734OH005000401','2014-01-01','2013-11-25 16:57:11','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 01:15:41'),(16309,13057,'N','01','021','EC','A',NULL,NULL,'','0002185725','0001361006','','IL','1','Fasier','selia','K','','','34','433199210','21 BOONE RD',0,'DELHI','LA','71232','6708','CY','22083','1957-12-27','F','',':RET:2106-3','N','021','DEN','2066244','18575LA002000201','2014-02-01','2014-01-06 10:16:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:22'),(15161,12116,'Y','18','024','14','A','','','TE','0001068235','0001068235','','IL','1','Dunbar','Jacinta','N',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-24','F','',NULL,NULL,NULL,'','888742','','2013-12-30','2013-12-30 13:57:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:16'),(884,732,'Y','18','021','EC','A','','','AC','0000801240','0000801240','OH00000180708','IL','1','WILLIAMS','DEBORAH','JOE','','','34','287464305','69 OGLESBEE RD',0,'WILMINGTON','OH','45177',NULL,'CY','39027','1952-12-02','F','M',':RET:2106-3','N','021','HLT','1382883','92036OH003000601','2014-01-01','2013-12-16 13:00:10','217.00',NULL,NULL,'629.96','412.96','R-OH005','OH0','629.96',NULL,0,'2013-12-25 18:07:49'),(14560,11616,'N','19','021','EC','A',NULL,NULL,'','0001062127','0000455318','','IL','1','HENSAL','JEFFREY','','','','34','299987354','582 BELL MAWR PL',0,'BARBERTON','OH','44203','4371','CY','39153','1996-04-28','M','',':RET:2106-3','N','021','HLT','2559728','52664OH152000901','2014-02-01','2013-12-27 12:08:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-28 03:35:15'),(13996,11151,'Y','18','021','EC','A','','','AC','0000604713','0000604713','OH00001094004','IL','1','Klinger','Robert','','','','34','276906575','1046 MAIN ST',0,'CONVOY','OH','45832','9259','CY','39161','1988-08-04','M','U',':RET:2106-3','N','021','HLT','1666072','92036OH002001501','2014-01-01','2013-12-23 10:28:08','311.00',NULL,NULL,'416.59','105.59','R-OH002','OH0','255.19',NULL,0,'2013-12-26 13:15:56'),(1443,1203,'N','01','021','EC','A',NULL,NULL,'','0000168895','0000941996','','IL','1','Johnson','Tammy','Irene','','','34','280762013','520 SCHELL RD',0,'WILMINGTON','OH','45177','9425','CY','39027','1964-12-06','F','',':RET:2106-3','T','021','HLT','1359942','92036OH003000605','2014-01-01','2013-12-24 11:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','439.83',NULL,0,'2013-12-25 18:47:54'),(9411,7467,'Y','18','021','EC','A','','','AC','0000410521','0000410521','TX00001054288','IL','1','Jimenez','Samuel','','','','34','463131419','11474 ED MERRINS DR',0,'EL PASO','TX','79936','5621','CY','48141','1958-02-24','M','M',NULL,'N','021','DEN','1388765','33348TX002000201','2014-01-01','2013-12-21 12:40:49','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:32:52'),(5158,4089,'N','01','021','EC','A',NULL,NULL,'','0001187632','0000444898','','IL','1','BETTS','DONALD','CLIFFORD','','','34','291502647','1135 BLACKLICK RD',0,'MILLERSPORT','OH','43046','9726','CY','39045','1951-05-31','M','',':RET:2106-3','N','021','DEN','2216690','99734OH005000401','2014-01-01','2013-12-19 10:30:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:02:59'),(7378,5843,'Y','18','021','EC','A','','','AC','0000692882','0000692882','OH00000294387','IL','1','ROSE','SHARLENE','ANNETTE','','','34','556042401','1031 UNION AVE',0,'ASHTABULA','OH','44004','2563','CY','39007','1958-10-22','F','U',':RET:2106-3','N','021','DEN','1056956','99734OH005000401','2014-01-01','2013-11-22 23:39:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:15:52'),(4690,3718,'Y','18','024','14','A','','','TE','0001043382','0001043382','','IL','1','WALLACE','SHARON','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-08-06','F','',NULL,NULL,NULL,'','1058461','','2013-12-12','2013-12-12 15:30:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:08:09'),(19192,15291,'Y','18','024','14','A','','','TE','0001250581','0001250581','','IL','1','conklin','bethany',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-07-28','F','',NULL,NULL,NULL,'','2450828','','2014-01-20','2014-01-20 16:01:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:46:13'),(25278,20056,'Y','18','021','EC','A','','','AC','0000543705','0000543705','TX00002692085','IL','1','STACK','THOMAS','AIDAN','','','34','635328943','8113 SUN MEADOWS CT',0,'FORT WORTH','TX','76123','1960','CY','48439','1959-10-09','M','M',NULL,'N','021','DEN','3643899','33348TX002000201','2014-03-01','2014-02-25 13:32:50','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85','CIC',0,'2014-02-25 21:00:16'),(25850,20492,'N','01','021','EC','A',NULL,NULL,'','0000050742','0000972800','','IL','1','Koning','Christopher','','','','34','291868034','19 CARRIAGE SQ',0,'AURORA','OH','44202','9314','CY','39133','1981-04-07','M','',':RET:2106-3','N','021','HLT','3627460','52664OH152000901','2014-04-01','2014-02-26 17:32:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','193.23',NULL,0,'2014-02-26 21:00:40'),(26273,20840,'Y','18','021','EC','A','','','AC','0000665700','0000665700','OH00003266325','IL','1','Casady','Tabatha','','','','34','290767964','1256 Fairgreen Ave',0,'Lima','OH','45805',NULL,'CY','39003','1968-09-10','F','U',':RET:2106-3','N','021','HLT','3562104','92036OH005001506','2014-03-01','2014-02-27 10:01:33','239.00',NULL,NULL,'317.81','78.81','R-OH002','OH0','317.81',NULL,0,'2014-02-28 06:31:17'),(28601,22635,'Y','18','021','EC','A','','','AC','0001122798','0001122798','OH00003837240','IL','1','KEITH','DONNA','JEAN','','','34','296706092','1113 FRANKLIN STREET',0,'HAMILTON','OH','45013',NULL,'CY','39017','1960-10-31','F','U',NULL,'N','021','DEN','3542227','99734OH005000401','2014-04-01','2014-03-08 11:27:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-08 21:30:09'),(5131,4066,'Y','18','021','EC','A','','','AC','0000173764','0000173764','TX00000966241','IL','1','Redhead','Nancy','Gist','','','34','532589741','709 EDITHA DR',0,'KERRVILLE','TX','78028','5007','CY','48265','1953-02-17','F','U',':RET:2106-3','N','021','DEN','1452635','33348TX002000101','2014-01-01','2013-12-19 11:28:06','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:02:13'),(14379,11469,'N','01','021','EC','A',NULL,NULL,'','0000077573','0000789670','','IL','1','AREHART','BETH','','','','34','284785234','2968 WILSON RD',0,'WILMINGTON','OH','45177','9373','CY','39027','1969-04-01','F','',NULL,'N','021','DEN','2038412','99734OH005000401','2014-02-01','2013-12-27 12:03:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:44'),(14142,11273,'Y','18','021','EC','A','','','AC','0001751413','0001751413','LA00001610131','31','1','RORTVEDT','HANNAH','','','','34','537764323','PO BOX 354',0,'ELIZABETH','LA','70638',NULL,'CY','22003','1975-01-14','F','M',':RET:2106-3','N','021','DEN','2310944','18575LA002000201','2014-02-01','2013-12-26 12:35:22','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2013-12-27 02:02:41'),(13377,10682,'Y','18','021','EC','A','','','AC','0000110519','0000110519','OH00000463765','IL','1','JAKUPCA','MARISA','','','','34','269869392','9418 DOROTHY AVE',0,'GARFIELD HEIGHTS','OH','44125','1417','CY','39035','1982-08-20','F','M',NULL,'N','021','DEN','2538334','99734OH005000301','2014-01-01','2013-12-22 22:57:35','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:59:51'),(7319,5801,'Y','18','021','EC','A','','','AC','0000291636','0000291636','MS00001012529','IL','1','HOLDEN','MIRANDA','','','','34','421047074','425 MELISSA DR',0,'BILOXI','MS','39531','2307','CY','28047','1968-06-18','F','M',':RET:2106-3','N','021','DEN','1187160','46300MS002000201','2014-01-01','2013-12-14 10:41:11','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 02:03:34'),(3321,2666,'Y','18','021','EC','A','','','AC','0000507981','0000507981','OH00000837486','IL','1','Fritz','Kathleen','','','','34','298760246','2881 HEATHERWOOD CT',0,'STOW','OH','44224','4369','CY','39153','1982-12-24','F','U',':RET:2106-3','N','021','DEN','1727501','99734OH005000301','2014-01-01','2013-12-22 16:02:05','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:16:04'),(3872,3100,'Y','18','021','EC','A','','','AC','0000214217','0000214217','LA00001024300','IL','1','Matthews','Janie','','','','34','439842652','5457 HOWELL PARK AVE',0,'BATON ROUGE','LA','70805','6234','CY','22033','1951-12-07','F','M',':RET:2054-5','N','021','DEN','1099775','18575LA002000201','2014-01-01','2013-12-13 11:38:27','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:36:13'),(18689,14899,'Y','18','021','EC','A','','','AC','0001887157','0001887157','LA00001795275','IL','1','Marks','Brandon','','','','34','437370080','524 WALNUT ST',0,'LA PLACE','LA','70068','5118','CY','22095','1979-09-02','M','U',NULL,'N','021','DEN','2600968','18575LA002000101','2014-02-01','2014-01-15 23:16:13','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-17 03:35:23'),(19554,15587,'Y','18','021','EC','A','','','AC','0001988745','0001988745','LA00001740748','IL','1','BOZEMAN','BRIAN','','','','34','439755951','1860 BOULEVARD DE PROVINCE',0,'BATON ROUGE','LA','70816',NULL,'CY','22033','1984-07-20','M','U',NULL,'N','021','DEN','1709026','18575LA002000101','2014-03-01','2014-01-22 13:12:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-23 03:02:30'),(19629,15645,'Y','18','021','EC','A','','','AC','0001227058','0001227058','OH00002291403','IL','1','Brown','Robert','','','','34','281445732','310 Perkinswood Blvd',0,'Warren','OH','44483',NULL,'CY','39155','1955-01-04','M','U',':RET:2106-3','N','021','DEN','2841033','99734OH005000401','2014-03-01','2014-01-23 10:24:45','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-23 21:00:08'),(21619,17262,'Y','18','021','EC','A','','','AC','0001072923','0001072923','TX00002127227','IL','1','Loehman','Terry','','','','34','466946199','208 BLUEBONNET DR',0,'WINTERS','TX','79567','3040','CY','48399','1953-03-06','M','M',':RET:2106-3','N','021','DEN','2767004','33348TX002000201','2014-03-01','2014-02-04 21:09:49','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:37'),(23855,18980,'Y','18','021','EC','A','','','AC','0001426195','0001426195','LA00002320914','IL','1','SCORCE','GARY','','','','34','073841259','2633 JOSEPH ST',0,'NEW ORLEANS','LA','70115','7039','CY','22071','1986-09-27','M','U',NULL,'N','021','DEN','3023014','18575LA002000101','2014-03-01','2014-02-14 00:30:07','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:00'),(24249,19254,'N','01','021','EC','A',NULL,NULL,'','0000402502','0000819822','','IL','1','SCHULZE','SUSAN','','','','34','288645486','5025A STATE ROUTE 132',0,'BATAVIA','OH','45103','1219','CY','39025','1957-11-30','F','',':RET:2106-3','N','021','HLT','2783106','92036OH002000601','2014-04-01','2014-02-16 09:40:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','578.36',NULL,0,'2014-02-16 19:00:43'),(25010,19834,'Y','18','021','EC','A','','','AC','0000066305','0000066305','OH00002949034','IL','1','jarrett','linda','','','','34','302488489','12133 eaton blvd',0,'grafton','OH','44044',NULL,'CY','39093','1950-02-12','F','M',':RET:2106-3','N','021','HLT','3339829','52664OH151001304','2014-04-01','2014-02-20 16:30:09','930.00',NULL,NULL,'1497.02','567.02','R-OH011','OH0','754.54',NULL,0,'2014-02-20 22:00:51'),(26683,21154,'Y','18','021','EC','A','','','AC','0001921308','0001921308','LA00003246010','IL','1','Myles','Dianna','','','','34','437089707','211 EVANGELINE DR',0,'DONALDSONVILLE','LA','70346','4374','CY','22005','1958-08-18','F','U',':RET:2054-5','N','021','DEN','3613669','18575LA002000201','2014-04-01','2014-02-28 16:04:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:24'),(27877,22052,'Y','18','021','EC','A','','','AC','0001160479','0001160479','OH00002871352','IL','1','Rowe','Leota','','','','34','286467320','1257 LATHAM AVE',0,'LIMA','OH','45805','1927','CY','39003','1949-11-21','F','M',':RET:2106-3','N','021','HLT','3627682','92036OH003001501','2014-04-01','2014-03-05 10:55:01','0.00',NULL,NULL,'689.49','689.49','R-OH002','OH0','689.49',NULL,0,'2014-03-05 21:32:30'),(28351,22432,'Y','18','021','EC','A','','','AC','0000227251','0000227251','TX00002607966','IL','1','Banda','Rogelio','R','','','34','593744785','8107 NELLIE ST',0,'HOUSTON','TX','77022','3455','CY','48201','1966-06-11','M','M',NULL,'N','021','DEN','3281182','33348TX002000201','2014-04-01','2014-03-07 13:06:08','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:23'),(415,340,'N','17','021','EC','A',NULL,NULL,'','0000847129','0000605921','','IL','1','Greaige','Alyssa','','','','34','292087251','5838 EDGEHILL DR',0,'PARMA HEIGHTS','OH','44130','2023','CY','39035','2003-12-13','F','',':RET:2106-3','N','021','DEN','1007424','99734OH005000401','2014-01-01','2013-12-04 15:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:29'),(13183,10517,'Y','18','021','EC','A','','','AC','0000931186','0000931186','TX00001050191','IL','1','jurgensen','William','','','','34','451824230','2637 WESTMINSTER AVE',0,'DALLAS','TX','75205','1502','CY','48113','1954-03-22','M','M',':RET:2106-3','T','021','DEN','2250329','33348TX002000101','2014-01-01','2013-12-22 22:36:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:23'),(1204,990,'N','01','021','EC','A',NULL,NULL,'','0000300376','0000605918','','IL','1','Capretta','Diana','L','','','34','285584264','4559 E BERWALD RD',0,'SOUTH EUCLID','OH','44121','3925','CY','39035','1955-09-12','F','',':RET:2106-3','N','021','DEN','207252','99734OH005000301','2014-01-01','2013-12-03 08:20:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:56'),(1495,1248,'Y','18','021','EC','A','','','AC','0000592162','0000592162','OH00000311720','IL','1','Osborne','Michael','','','','34','289887040','1000 Kenosha Ave',0,'Kettering','OH','45429',NULL,'CY','39113','1975-02-19','M','U',NULL,'T','021','DEN','2197457','99734OH005000401','2014-01-01','2013-12-24 11:26:18','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:49:08'),(3922,3140,'Y','18','021','EC','A','','','AC','0000855614','0000855614','OH00001224196','IL','1','Bailey','Paul','','','','34','296668342','405 N. Wright St.',0,'Blanchester','OH','45107',NULL,'CY','39027','1960-09-16','M','M',':RET:2106-3','T','021','HLT','950639','92036OH001000601','2014-01-01','2013-12-12 19:45:20','620.00',NULL,NULL,'1094.35','474.35','R-OH005','OH0','607.47',NULL,0,'2013-12-25 21:37:24'),(17412,13935,'Y','18','021','EC','A','','','AC','0000424047','0000424047','OH00002066874','IL','1','Grigg','Douglas','','','','34','269667180','1724 S.R. 29 East',0,'Sidney','OH','45365',NULL,'CY','39149','1958-12-30','M','U',':RET:2106-3','N','021','HLT','2475915','92036OH002000501','2014-02-01','2014-01-10 00:15:10','382.00',NULL,NULL,'612.16','230.16','R-OH003','OH0','612.16',NULL,0,'2014-01-13 03:00:22'),(29082,23018,'Y','18','021','EC','A','','','AC','0000161224','0000161224','MS00002667256','IL','1','Flowers','Jeremy','','','','34','426695333','2926 ANGELA CIR',0,'JACKSON','MS','39209','6127','CY','28049','1990-05-16','M','U',':RET:2054-5','N','021','DEN','4005112','46300MS002000101','2014-04-01','2014-03-10 16:06:40','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-10 21:02:04'),(5575,4423,'Y','18','021','EC','A','','','AC','0000231466','0000231466','OH00000868734','IL','1','tomblin','jayson','','','','34','289745041','136 hagenbuch st',0,'urbana','OH','43078',NULL,'CY','39021','1972-09-22','M','U',':RET:2106-3','N','021','DEN','1180034','99734OH005000401','2014-01-01','2013-11-06 07:47:16','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:16:48'),(16118,12911,'Y','18','024','14','A','','','TE','0002189762','0002189762','','IL','1','Burnom','Walter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-03','M','',NULL,NULL,NULL,'','1888850','','2014-01-03','2014-01-03 11:13:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-04 02:05:20'),(9227,7322,'Y','18','021','EC','A','','','AC','0000374696','0000374696','OH00001269015','IL','1','Ilhardt','Mary','','','','34','302722846','1324 LIBBY LN',0,'NEW RICHMOND','OH','45157','9163','CY','39025','1963-05-16','F','M',':RET:2106-3','T','021','HLT','2089330','92036OH003000604','2014-01-01','2013-12-18 14:36:49','481.00',NULL,NULL,'986.36','505.36','R-OH005','OH0','460.43',NULL,0,'2013-12-26 04:10:22'),(14122,11255,'Y','18','021','EC','A','','','AC','0000997761','0000997761','OH00000904198','IL','1','SHEEL','MUSTAFA','','','','34','099741978','825 FORTUNEGATE DR',0,'WESTERVILLE','OH','43081','3521','CY','39049','1961-06-24','M','U',':RET:2054-5^:RET:2080-0','N','021','DEN','2227030','99734OH005000401','2014-02-01','2013-12-26 16:46:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:02:07'),(20467,16349,'N','19','021','EC','A',NULL,NULL,'','0000558181','0000062564','','S3','1','Berlean','Kellie','','','','34','270133394','7405 REFUGEE RD',0,'PICKERINGTON','OH','43147','9101','CY','39045','2006-10-18','F','',':RET:2106-3','N','021','DEN','3169905','99734OH005000401','2014-03-01','2014-01-29 11:46:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:53'),(22259,17766,'Y','18','021','EC','A','','','AC','0000852141','0000852141','TX00002478205','31','1','Manrrique','santiago','','','','34','459232755','P.O.BOX 890',0,'Los Fresnos','TX','78566',NULL,'CY','48061','1967-02-23','M','U',':RET:2106-3','N','021','DEN','3012927','33348TX002000201','2014-03-01','2014-01-22 15:58:22','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-10 11:00:06'),(23386,18635,'Y','18','024','14','A','','','TE','0001155137','0001155137','','IL','1','Nelson','Alyse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-21','F','',NULL,NULL,NULL,'','2679403','','2014-02-13','2014-02-13 13:58:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:01:02'),(25023,19842,'Y','18','021','EC','A','','','AC','0000491899','0000491899','TX00002962405','S3','1','Ali','Navroz',NULL,NULL,NULL,NULL,NULL,'3517 Dry Brook',0,'Pflugerville','TX','78660',NULL,'CY','48453','2004-09-08','F','U',NULL,'N','021','DEN','2768833','33348TX002000101','2014-04-01','2014-02-19 20:52:28','46.09',NULL,NULL,'47.10','1.01','R-TX003','TX0','47.10',NULL,0,'2014-02-20 22:00:58'),(26339,20897,'N','19','021','EC','A',NULL,NULL,'','0000904319','0000489303','','S1','1','Evans','Denise','Faith','','','34','301022937','5331 EDGEWATER DR',0,'TOLEDO','OH','43611','2640','CY','39095','1996-07-11','M','',NULL,'N','021','HLT','2868388','92036OH006002601','2014-04-01','2014-02-27 13:55:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2014-02-28 06:31:43'),(26603,21092,'Y','18','021','EC','A','','','AC','0000213550','0000213550','TX00002887540','IL','1','Bean','Catherine','','','','34','230021219','6148 PERCH DR',0,'FORT WORTH','TX','76179','7578','CY','48439','1964-01-15','F','U',':RET:2106-3','N','021','DEN','2770240','33348TX002000201','2014-04-01','2014-02-27 20:02:52','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-28 21:30:42'),(28011,22165,'N','01','021','EC','A',NULL,NULL,'','0001014438','0000968271','','IL','1','Geary','Jessica','','','','34','282887608','1961 MAPLE AVE',0,'NORWOOD','OH','45212','2027','CY','39061','1988-01-01','F','',':RET:2106-3','N','021','DEN','3892001','99734OH005000401','2014-04-01','2014-03-06 11:43:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:15'),(1587,1325,'Y','18','021','EC','A','','','AC','0001011512','0001011512','TX00001566113','IL','1','Lerma','Jesus','Jose','','','34','449434800','270 REVELES WAY',0,'EL PASO','TX','79927','3618','CY','48141','1959-07-20','M','M',':RET:2106-3','N','021','DEN','2315737','33348TX002000201','2014-01-01','2013-12-24 11:20:34','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:51:37'),(16220,12990,'Y','18','021','EC','A','','','AC','0000166393','0000166393','OH00001684787','IL','1','Bezik','Donna','','','','34','279567873','9200 Pleasantvale Ct.',0,'Mentor','OH','44060',NULL,'CY','39085','1956-12-24','F','U',':RET:2106-3','N','021','DEN','1835651','99734OH005000401','2014-02-01','2014-01-03 21:19:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-05 00:01:47'),(5823,4624,'N','01','021','EC','A',NULL,NULL,'','0000842342','0000810573','','IL','1','Lam','Vivian','WeiYan','','','34','024884377','4211 MERRIWEATHER ST',0,'SUGAR LAND','TX','77478','5281','CY','48157','1975-12-22','F','',':RET:2034-7','N','021','DEN','1471610','33348TX002000201','2014-01-01','2013-12-23 22:14:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:48:04'),(16053,12855,'Y','18','021','EC','A','','','AC','0001114549','0001114549','OH00001301991','IL','1','Green','Christopher','','','','34','289840617','4169 BOAT DR',0,'AKRON','OH','44319','3567','CY','39153','1973-08-12','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1665252','99734OH005000401','2014-02-01','2014-01-02 22:52:07','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-04 02:03:17'),(13357,10668,'Y','18','021','EC','A','','','AC','0000411110','0000411110','OH00001107515','IL','1','Winner','Jessica','','','','34','300606018','120 RALEIGH DR',0,'ELYRIA','OH','44035','8906','CY','39093','1976-09-15','F','U',':RET:2106-3','T','021','DEN','1499903','99734OH005000301','2014-01-01','2013-12-22 19:10:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:59:22'),(14193,11318,'Y','18','021','EC','A','','','AC','0000498420','0000498420','TX00001730961','IL','1','Riffey','Brenda','','','','34','452907172','8508 Saratoga',0,'El Paso','TX','79912',NULL,'CY','48141','1952-08-06','F','U',':RET:2106-3','N','021','DEN','2113655','33348TX002000201','2014-02-01','2013-12-26 12:55:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-27 02:04:02'),(17651,14108,'N','01','021','EC','A',NULL,NULL,'','0000664202','0001077762','','IL','1','Cogley','Joyce','','','','34','284542346','1337 HANSON ST',0,'REYNOLDSBURG','OH','43068','4769','CY','39089','1955-02-19','F','',':RET:2106-3','N','021','DEN','1491532','99734OH005000301','2014-02-01','2014-01-13 12:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:41'),(18741,14933,'N','01','021','EC','A',NULL,NULL,'','0000188875','0001100619','','IL','1','SALING','AIMEE','M','','','34','275885864','8808 STONEHILL CT',0,'SPRINGBORO','OH','45066','8608','CY','39165','1976-02-01','F','',':RET:2106-3','N','021','DEN','3049279','99734OH005000301','2014-03-01','2014-01-16 18:07:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:40'),(21086,16849,'Y','18','021','EC','A','','','AC','0000680886','0000680886','OH00002485930','IL','1','SCHEL','BILLIE','','','','34','298581062','3440 TELFORD sTREET',0,'CINCINNATI','OH','45220',NULL,'CY','39061','1955-10-04','F','U',':RET:2106-3','T','021','DEN','3585740','99734OH005000301','2014-03-01','2014-02-02 12:27:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-02 19:00:24'),(21481,17164,'Y','18','021','EC','A','','','AC','0001217400','0001217400','OH00001834686','IL','1','Day','Barbara','','','','34','279425023','11651 Norbourne Drive',0,'Forest Park','OH','45240',NULL,'CY','39061','1952-09-01','F','U',':RET:2106-3','N','021','DEN','2926212','99734OH005000301','2014-03-01','2014-02-04 14:26:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:42'),(1717,1431,'Y','18','021','EC','A','','','AC','0000623941','0000623941','OH00000399970','IL','1','Smith','Floyd','','','','34','284708879','796 RINKER RD',0,'STEUBENVILLE','OH','43953','7145','CY','39081','1966-05-15','M','R',NULL,'N','021','DEN','2306771','99734OH005000301','2014-01-01','2013-12-24 09:47:44','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:55:06'),(3469,2786,'Y','18','021','EC','A','','','AC','0000895706','0000895706','OH00001079993','IL','1','joseph','gerald','','','','34','291484004','7367 CLUM RD',0,'HARROD','OH','45850','9413','CY','39003','1950-09-17','M','M',':RET:2106-3','T','021','DEN','1885787','99734OH005000401','2014-01-01','2013-12-22 08:49:37','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:19:54'),(15788,12636,'N','01','021','EC','A',NULL,NULL,'','0001897902','0001757818','','IL','1','Folse','Herbert','','','','34','563896462','817 North 8th Street',0,'Thibodaux','LA','70301',NULL,'CY','22057','1973-10-13','M','',':RET:2054-5','N','021','DEN','2331196','18575LA002000201','2014-02-01','2014-01-02 12:16:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-03 02:02:23'),(9568,7581,'N','19','021','EC','A',NULL,NULL,'','0001245588','0000542671','','IL','1','STUNTEBECK','YVES','DOOSADEE','','','34','005799003','11588 KEMPER WOODS DR',0,'CINCINNATI','OH','45249','1752','CY','39061','2000-05-16','F','',':RET:2028-9','N','021','DEN','1827183','99734OH005000301','2014-01-01','2013-12-21 16:14:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:40'),(13146,10486,'Y','18','021','EC','A','','','AC','0000081287','0000081287','OH00001295246','IL','1','Woods','Tykisha','','','','34','298848073','3585 E.142nd St.',0,'Cleveland','OH','44120',NULL,'CY','39035','1985-12-18','F','U',':RET:2054-5','N','021','DEN','1447727','99734OH005000401','2014-01-01','2013-12-23 16:23:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:28'),(17775,14202,'Y','18','021','EC','A','','','AC','0001010357','0001010357','TX00002407132','IL','1','PRATKA','EDWARD','','','','34','462270728','13702 KINGSRIDE LN',0,'HOUSTON','TX','77079','5905','CY','48201','1959-03-05','M','U',':RET:2106-3','N','021','DEN','2722622','33348TX002000101','2014-02-01','2014-01-13 15:28:39','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-14 01:33:40'),(19340,15417,'N','01','021','EC','A',NULL,NULL,'','0000192557','0000389532','','IL','1','POWELL','DESHAUN','','','','34','437290910','2216 TANGLEWOOD ST',0,'MESQUITE','TX','75181','1797','CY','48113','1971-05-29','M','',':RET:2054-5','N','021','DEN','1495965','33348TX002000201','2014-03-01','2014-01-21 18:00:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,1,'2014-01-22 03:22:20'),(19405,15472,'Y','18','024','14','A','','','TE','0000976709','0000976709','','IL','1','Hosler','Jerry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-12-15','M','',NULL,NULL,NULL,'','1653553','','2014-01-21','2014-01-21 11:00:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:55'),(22338,17839,'Y','18','021','EC','A','','','AC','0001261236','0001261236','OH00001838101','IL','1','Buchholz','Laura','','','','34','214822889','904 COLUMBUS AVE',0,'DEFIANCE','OH','43512','3135','CY','39039','1958-12-29','F','M',':RET:2106-3','N','021','HLT','2638754','92036OH004002601','2014-03-01','2014-01-30 13:27:47','188.00',NULL,NULL,'349.65','161.65','R-OH001','OH0','349.65',NULL,0,'2014-02-10 11:01:06'),(29091,23026,'Y','18','021','EC','A','','','AC','0000524372','0000524372','TX00003600559','IL','1','Nguyen','Kevin','','','','34','564579672','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1969-08-06','M','M',NULL,'N','021','DEN','4251530','33348TX002000101','2014-04-01','2014-03-10 14:52:18','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-03-10 21:02:10'),(6977,5536,'Y','18','021','EC','A','','','AC','0000003584','0000003584','OH00001247334','IL','1','Vorwerck','James','','','','34','289488925','6624 HONEYSUCKLE LN',0,'MAINEVILLE','OH','45039','7060','CY','39165','1952-08-08','M','U',':RET:2106-3','N','021','DEN','1588050','99734OH005000401','2014-01-01','2013-12-24 23:32:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:35'),(16913,13534,'Y','18','021','EC','A','','','AC','0000598769','0000598769','OH00001580368','IL','1','MILLER','TARA','','','','34','298842501','1370 WAYNE ST',0,'TROY','OH','45373',NULL,'CY','39109','1986-11-22','F','U',':RET:2106-3','N','021','DEN','2233797','99734OH005000401','2014-02-01','2014-01-09 13:01:18','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:19:39'),(16788,13429,'Y','18','021','EC','A','','','AC','0001210934','0001210934','OH00001817377','IL','1','Neal','Earl','','','','34','420823885','1990 HOWELL AVE',0,'HAMILTON','OH','45011','4428','CY','39017','1957-02-24','M','U',NULL,'T','021','HLT','2349622','92036OH003001201','2014-02-01','2014-01-07 15:29:31','60.00',NULL,NULL,'601.46','541.46','R-OH004','OH0','601.46',NULL,0,'2014-01-08 18:25:08'),(4548,3605,'Y','18','021','EC','A','','','AC','0001183512','0001183512','OH00000915197','IL','1','Daugherty','Kevin','','','','34','277686556','9275 DANIELS RD',0,'SEVILLE','OH','44273','8843','CY','39103','1961-10-02','M','M',':RET:2106-3','N','021','HLT','918505','52664OH152000901','2014-01-01','2013-12-12 09:02:46','934.63',NULL,NULL,'934.63','0.00','R-OH012','OH0','318.84',NULL,0,'2013-12-25 22:04:30'),(13974,11136,'N','19','021','EC','A',NULL,NULL,'','0000880512','0000448769','','IL','1','HUX','JAMES','','','','34','176707387','732 BECKLEY FARM WAY',0,'SPRINGBORO','OH','45066','9485','CY','39165','1988-12-02','M','',':RET:2054-5','N','021','HLT','2395361','92036OH004001201','2014-01-01','2013-12-22 23:54:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','173.31',NULL,0,'2013-12-26 13:15:28'),(13583,10833,'Y','18','024','14','A','','','TE','0002201191','0002201191','','IL','1','Lemus','Osmin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-12-28','M','',NULL,NULL,NULL,'','1903425','','2013-12-23','2013-12-23 18:22:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:04:57'),(3887,3113,'N','01','021','EC','A',NULL,NULL,'','0000928484','0000750994','','IL','1','Heaton','Mary Ann','','','','34','268669514','2793 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','2263','CY','39153','1959-09-23','F','',':RET:2106-3','T','021','HLT','1146485','52664OH152000901','2014-01-01','2013-12-13 11:11:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.04',NULL,0,'2013-12-25 21:36:35'),(9768,7735,'Y','18','021','EC','A','','','AC','0000356004','0000356004','OH00000337479','IL','1','Main','Anthony','','','','34','283760288','3823 Iberis ave',0,'Cincinnati','OH','45213',NULL,'CY','39061','1977-04-12','M','U',':RET:2106-3','N','021','DEN','883664','99734OH005000401','2014-01-01','2013-10-21 07:31:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 05:00:22'),(17161,13731,'Y','18','021','EC','A','','','AC','0001163371','0001163371','LA00001960101','IL','1','WILSON','CARLOS','R','','','34','439459238','1413 GEORGIA ST',0,'MONROE','LA','71202','2629','CY','22073','1982-03-19','M','U',NULL,'N','021','DEN','2128778','18575LA002000201','2014-02-01','2014-01-08 12:53:07','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-13 02:22:02'),(17571,14049,'Y','18','024','14','A','','','TE','0001115960','0001115960','','IL','1','gamiere','kevin','l',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-07','M','',NULL,NULL,NULL,'','2607395','','2014-01-13','2014-01-13 13:02:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-14 01:32:01'),(17611,14078,'Y','18','021','EC','A','','','AC','0000787213','0000787213','TX00002551198','IL','1','Perez','Elvira','','','','34','452086258','854 W ROBERTSON ST',0,'SAN BENITO','TX','78586','5848','CY','48061','1961-08-24','F','U',NULL,'N','021','DEN','2295537','33348TX002000201','2014-02-01','2014-01-13 10:22:26','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-14 01:32:21'),(20915,16718,'Y','18','021','EC','A','','','AC','0000825939','0000825939','OH00002158565','IL','1','Kimberlin','Kenneth','','','','34','301464183','97 LINDSEY RD',0,'MUNROE FALLS','OH','44262','1157','CY','39153','1950-02-27','M','M',':RET:2106-3','N','021','HLT','2679120','52664OH152000901','2014-03-01','2014-01-31 12:19:28','410.00',NULL,NULL,'490.00','80.00','R-OH012','OH0','490.00',NULL,0,'2014-01-31 21:01:30'),(23893,19006,'Y','18','021','EC','A','','','AC','0000865920','0000865920','OH00002561064','IL','1','Schmid','Karl','','','','34','292505712','4264 ANTIOCH RD',0,'NEW VIENNA','OH','45159','9751','CY','39027','1950-08-11','M','U',':RET:2106-3','N','021','HLT','3500881','92036OH004000601','2014-03-01','2014-02-14 13:54:50','474.00',NULL,NULL,'509.54','35.54','R-OH005','OH0','509.54',NULL,0,'2014-02-14 21:32:19'),(23964,19053,'N','01','021','EC','A',NULL,NULL,'','0000019033','0000719000','','IL','1','Gavito','Victoria','Isabel','','','34','140840258','1101 KAREN AVE',0,'AUSTIN','TX','78757','3013','CY','48453','1978-06-09','F','',NULL,'N','021','DEN','2703305','33348TX002000101','2014-03-01','2014-02-15 13:45:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-15 22:00:10'),(27289,21608,'N','01','021','EC','A',NULL,NULL,'','0000077513','0000721675','','IL','1','SHAW','SHERLYN','','','','34','460292393','608 WALKER ST',0,'MARLIN','TX','76661','2351','CY','48145','1961-05-19','F','',NULL,'N','021','DEN','3899816','33348TX002000201','2014-04-01','2014-03-04 09:22:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:27'),(28978,22935,'Y','18','024','14','A','','','TE','0000816491','0000816491','','IL','1','FRAZEE','LYNN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-19','M','',NULL,NULL,NULL,'','4144277','','2014-03-08','2014-03-09 20:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:07'),(6869,5447,'N','01','021','EC','A',NULL,NULL,'','0000586903','0000142973','','IL','1','graves','jeffery','glen','','','34','457250517','6498 ORCHARD RD',0,'BOWIE','TX','76230','7177','CY','48337','1960-03-27','M','',':RET:2106-3','N','021','DEN','710362','33348TX002000201','2014-01-01','2013-11-03 17:20:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:31:55'),(16850,13480,'Y','18','021','EC','A','','','AC','0000103119','0000103119','MS00001952426','IL','1','Whitelaw','Shammery','','','','34','412575949','2954 BOOKER T WASHINGTON ST',0,'JACKSON','MS','39213','6609','CY','28049','1978-10-31','M','U',':RET:2054-5','T','021','DEN','2114033','46300MS002000101','2014-02-01','2014-01-11 12:35:11','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-13 02:18:39'),(5650,4482,'Y','18','021','EC','A','','','AC','0001150873','0001150873','TX00000187735','IL','1','GALLEN','JAMES','','','','34','041545671','231 COUNTY ROAD',0,'JASPER','TX','75951',NULL,'CY','48241','1954-12-27','M','M',':RET:2106-3','N','021','DEN','150652','33348TX002000201','2014-01-01','2013-11-26 11:54:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:31:28'),(15546,12439,'N','19','021','EC','A',NULL,NULL,'','0002038948','0001764371','','IL','1','BATISTE','JASMINE','','','','34','426753007','13031 PONDERS LN',0,'AMITE','LA','70422',NULL,'CY','22105','1993-01-20','F','',':RET:2054-5','N','021','DEN','1936697','18575LA002000201','2014-02-01','2013-12-31 15:43:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:31:07'),(5496,4363,'Y','18','021','EC','A','','','AC','0000649366','0000649366','OH00000672504','IL','1','Smith','Roger','L','','','34','297444724','4151 CARTHAGE RD',0,'TOLEDO','OH','43612','1604','CY','39095','1952-05-20','M','U',':RET:2106-3','N','021','HLT','2469678','92036OH002002601','2014-01-01','2013-12-19 14:19:52','394.00',NULL,NULL,'632.79','238.79','R-OH001','OH0','632.79',NULL,0,'2013-12-25 23:11:11'),(7841,6209,'N','01','021','EC','A',NULL,NULL,'','0000406122','0000012422','','IL','1','Hawkins','Wendy','Ellen','','','34','206449972','1 TANGLEWOOD LN',0,'CINCINNATI','OH','45224','2823','CY','39061','1953-08-06','F','',':RET:2106-3','N','021','DEN','2588493','99734OH005000301','2014-01-01','2013-12-19 22:50:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:36'),(17459,13961,'Y','18','021','EC','A','','','AC','0000218844','0000218844','OH00001420391','IL','1','orzechowski','kenneth','','','','34','270581521','6052 BLOSSMAN RD',0,'TOLEDO','OH','43617','1004','CY','39095','1955-04-22','M','M',':RET:2106-3','N','021','HLT','2599755','92036OH003002604','2014-02-01','2014-01-10 15:34:46','200.00',NULL,NULL,'518.85','318.85','R-OH001','OH0','518.85',NULL,0,'2014-01-13 03:00:41'),(18332,14638,'Y','18','021','EC','A','','','AC','0000401266','0000401266','OH00002338618','IL','1','ARRIGO','LISA','M','','','34','297629493','6871 BRECK CT',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1967-03-12','F','M',NULL,'N','021','DEN','1576668','99734OH005000401','2014-02-01','2014-01-15 16:19:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:13'),(19418,15481,'Y','18','021','EC','A','','','AC','0000728746','0000728746','OH00001851516','IL','1','Fichtner','Patricia','','','','34','278564931','525 STELTON RD',0,'XENIA','OH','45385','5226','CY','39057','1954-03-13','F','M',NULL,'N','021','HLT','2730155','92036OH004000501','2014-03-01','2014-01-21 17:02:02','881.00',NULL,NULL,'995.08','114.08','R-OH003','OH0','497.54',NULL,1,'2014-01-22 03:23:01'),(6344,5027,'Y','18','021','EC','A','','','AC','0000160764','0000160764','OH00000581942','IL','1','jackson','gregory','','','','34','302560387','125 PARKWOOD AVE',0,'ZANESVILLE','OH','43701','6146','CY','39119','1956-11-07','M','U',':RET:2106-3','N','021','DEN','841040','99734OH005000401','2014-01-01','2013-12-11 12:21:04','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 00:46:51'),(4092,3269,'Y','18','021','EC','A','','','AC','0000782334','0000782334','MS00000144964','31','1','JEFFERSON','ANGELA','','','','34','426457033','PO BOX 1049',0,'MCCOMB','MS','39648',NULL,'CY','28113','1971-10-11','F','M',NULL,'N','021','DEN','1850663','46300MS002000101','2014-01-01','2013-12-16 18:50:10','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 21:47:28'),(18130,14478,'N','19','021','EC','A',NULL,NULL,'','0000073961','0000684835','','IL','1','Ker','Robin','Elizabeth','','','34','273965920','423 SANDRA DR',0,'OXFORD','OH','45056','2542','CY','39017','1992-12-31','F','',':RET:2106-3','N','021','HLT','2576820','92036OH004001201','2014-02-01','2014-01-14 14:56:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-01-15 02:07:43'),(4583,3629,'Y','18','021','EC','A','','','AC','0000781877','0000781877','OH00001038871','IL','1','Lordi','Joe','','','','34','295868336','501 FRANKLIN AVE',0,'BARBERTON','OH','44203','2821','CY','39153','1979-02-28','M','U',':RET:2106-3','N','021','HLT','1126937','52664OH151001301','2014-01-01','2013-12-12 00:30:26','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,0,'2013-12-25 22:05:16'),(9797,7758,'Y','18','021','EC','A','','','AC','0000521371','0000521371','TX00000130721','IL','1','Taylor','Robert','','','','34','573259254','232 E Valley rd',0,'Harker Heights','TX','76548',NULL,'CY','48027','1971-09-20','M','U',':RET:2106-3','N','021','DEN','1193063','33348TX002000201','2014-01-01','2013-10-21 07:26:27','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 05:01:09'),(14908,11910,'Y','18','021','EC','A','','','AC','0000095248','0000095248','OH00000947869','IL','1','Knight','Shionna','','','','34','270923792','11017 NOTRE DAME AVE',0,'CLEVELAND','OH','44104','2545','CY','39035','1987-01-21','F','U',':RET:2054-5','T','021','DEN','2405271','99734OH005000401','2014-02-01','2013-12-28 18:58:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-30 00:01:22'),(23738,18901,'Y','18','021','EC','A','','','AC','0000060312','0000060312','OH00002523505','IL','1','Nixon','John','','','','34','281781000','4520 Warrensville Center Rd',0,'North Randall','OH','44128',NULL,'CY','39035','1979-09-17','M','M',':RET:2054-5','N','021','DEN','3302839','99734OH005000301','2014-03-01','2014-02-13 22:27:48','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:31:02'),(24712,19621,'Y','18','021','EC','A','','','AC','0000655871','0000655871','OH00002365137','IL','1','Conti','Jordan','','','','34','299846606','5418 CYPRESS CHASE',0,'COLUMBUS','OH','43228','7215','CY','39049','1986-08-29','M','U',':RET:2106-3','N','021','DEN','3212081','99734OH005000401','2014-04-01','2014-02-19 01:08:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:36:06'),(26079,20681,'Y','18','021','EC','A','','','AC','0001862434','0001862434','LA00003066449','IL','1','knickerbocker','brittian','','','','34','438834551','522 fern st',0,'new orleans','LA','70118',NULL,'CY','22071','1982-10-25','F','U',':RET:2106-3','N','021','DEN','3422907','18575LA002000201','2014-04-01','2014-02-26 18:21:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:03'),(750,620,'Y','18','021','EC','A','','','AC','0000133873','0000133873','TX00000463375','IL','1','Tappan','Mark','Leslie','','','34','480569174','5522 KINGS CIR',0,'CORPUS CHRISTI','TX','78413','2913','CY','48355','1956-09-11','M','M',':RET:2106-3','N','021','DEN','1515355','33348TX002000201','2014-01-01','2013-12-16 09:17:31','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-25 18:04:16'),(16099,12895,'Y','18','021','EC','A','','','AC','0000236285','0000236285','OH00002069172','IL','1','GUZMAN','JAMES','R','','','34','461156994','2622 ELM ST',0,'TOLEDO','OH','43608','2416','CY','39095','1964-07-17','M','M',NULL,'N','021','HLT','1794756','92036OH006002601','2014-02-01','2014-01-03 15:22:54','0.00',NULL,NULL,'263.83','263.83','R-OH001','OH0','263.83',NULL,0,'2014-01-04 02:04:42'),(2334,1900,'Y','18','021','EC','A','','','AC','0000909735','0000909735','TX00000407726','IL','1','Bullard','Clarence','','','','34','458298987','3950 Spring Valley Road',0,'Farmers Branch','TX','75244',NULL,'CY','48113','1965-01-10','M','M',':RET:2054-5','N','021','DEN','943978','33348TX002000201','2014-01-01','2013-12-09 12:32:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:31:47'),(5836,4635,'Y','18','021','EC','A','','','AC','0000230612','0000230612','TX00001376067','IL','1','DeBaun','Monica','','','','34','642091676','2709 LUCAS DR',0,'ARLINGTON','TX','76015','1013','CY','48439','1986-04-25','F','U',NULL,'N','021','DEN','2601615','33348TX002000201','2014-01-01','2013-12-23 23:23:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:26'),(5443,4324,'Y','18','021','EC','A','','','AC','0001633542','0001633542','LA00001189377','IL','1','CHAKRAVARTY','INDRA','','','','34','535900359','4413 RICHLAND AVE',0,'METAIRIE','LA','70002',NULL,'CY','22051','1950-09-18','F','M',':RET:2029-7','N','021','DEN','1628224','18575LA002000101','2014-01-01','2013-12-19 17:03:55','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:58'),(24567,19509,'N','01','021','EC','A',NULL,NULL,'','0000737910','0000283315','','IL','1','grubb','michelle','','','','34','301708059','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1973-04-22','F','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:07:01'),(27756,21949,'N','01','021','EC','A',NULL,NULL,'','0001219877','0002148444','','IL','1','PANIAGUA','MIGUEL','ANGEL','','','34','434692692','2400 N BROAD ST',0,'NEW ORLEANS','LA','70122','2930','CY','22071','1960-01-29','M','',NULL,'N','021','DEN','3417247','18575LA002000201','2014-04-01','2014-03-05 10:14:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-05 21:31:18'),(1046,858,'Y','18','021','EC','A','','','AC','0001163024','0001163024','TX00000704166','31','1','Whisenant','stanley','','','','34','443787505','2100 KINGS PASS',0,'HEATH','TX','75032','5917','CY','48397','1965-09-22','M','R',':RET:2106-3','N','021','DEN','791037','33348TX002000201','2014-01-01','2013-12-03 16:14:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:15:54'),(21453,17144,'N','01','021','EC','A',NULL,NULL,'','0001036162','0000095274','','IL','1','hagerty','brice','','','','34','292801581','3526 dotwood st nw',0,'north canton','OH','44720',NULL,'CY','39151','1973-01-05','M','',':RET:2106-3','N','021','HLT','2709253','52664OH151001304','2014-03-01','2014-02-04 12:08:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.36',NULL,0,'2014-02-04 21:01:29'),(21091,16854,'Y','18','021','EC','A','','','AC','0001318069','0001318069','LA00002101844','31','1','Davis','Candice','','','','34','433671202','463 E. 84th Street',0,'Shreveport','LA','71106',NULL,'CY','22017','1987-07-13','F','U',':RET:2054-5','N','021','DEN','3278099','18575LA002000101','2014-03-01','2014-02-01 23:05:08','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-02 19:00:27'),(5524,4381,'N','01','021','EC','A',NULL,NULL,'','0001045637','0000231473','','IL','1','kareithi','john','','','','34','419537499','3235 Tammery Ct',0,'Columbus','OH','43231',NULL,'CY','39049','1962-04-17','M','',':RET:2054-5','N','021','DEN','16120','99734OH005000401','2014-01-01','2013-11-26 18:40:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:23'),(1501,1253,'Y','18','021','EC','A','','','AC','0000122982','0000122982','OH00000223839','IL','1','Canning-Hollenbeck','Julie','','','','34','285868119','10947 SHADOW GLEN DR',0,'LOVELAND','OH','45140','7800','CY','39061','1976-11-05','F','M',':RET:2106-3','N','021','DEN','1642424','99734OH005000401','2014-01-01','2013-12-24 12:24:07','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:17'),(20001,15953,'N','19','021','EC','A',NULL,NULL,'','0000354005','0000874724','','IL','1','Pieffer','Annie',NULL,NULL,NULL,NULL,NULL,'3881 W 227TH ST',0,'FAIRVIEW PARK','OH','44126','1031','CY','39035','2012-08-10','F','',':RET:2106-3','N','021','DEN','2594871','99734OH005000401','2014-03-01','2014-01-26 11:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:05'),(3631,2905,'Y','18','021','EC','A','','','AC','0000154627','0000154627','OH00001089974','IL','1','COTTRELL','MICHAEL','K','','','34','270544369','10110 ST RT 124',0,'HILLSBORO','OH','45133',NULL,'CY','39071','1956-03-29','M','M',':RET:2106-3','N','021','HLT','265303','92036OH003000605','2014-01-01','2013-12-13 14:29:32','443.00',NULL,NULL,'546.34','103.34','R-OH005','OH0','546.34',NULL,0,'2013-12-25 21:30:08'),(16441,13155,'Y','18','021','EC','A','','','AC','0001104455','0001104455','OH00001351548','IL','1','BEEKMAN','LISA','','','','34','301484327','435 VILLA RD',0,'SPRINGFIELD','OH','45503','1324','CY','39023','1950-05-25','F','U',':RET:2106-3','N','021','HLT','1816914','92036OH002000501','2014-02-01','2014-01-05 18:31:58','447.00',NULL,NULL,'810.35','363.35','R-OH003','OH0','810.35',NULL,0,'2014-01-07 04:05:06'),(2015,1653,'N','01','021','EC','A',NULL,NULL,'','0000163643','0000142789','','IL','1','Hunsicker','Oscar','Aaron','','III','34','270505435','1334 HIGHBRIDGE RD',0,'CUYAHOGA FALLS','OH','44223','2327','CY','39153','1951-12-28','M','',':RET:2106-3','N','021','HLT','1183864','52664OH151001501','2014-01-01','2013-11-20 15:10:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','768.43',NULL,0,'2013-12-25 19:02:37'),(2485,2024,'Y','18','021','EC','A','','','AC','0000450057','0000450057','LA00001240164','IL','1','Hedges','Linda','','','','34','439940428','15037 JOE SEVARIO RD',0,'GONZALES','LA','70737','6918','CY','22005','1954-04-19','F','U',':RET:2106-3','N','021','DEN','1212917','18575LA002000201','2014-01-01','2013-12-09 15:09:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:38'),(2425,1975,'N','01','021','EC','A',NULL,NULL,'','0000902185','0000303338','','IL','1','HORVATH','FLORA','','','','34','281688512','861 WISTERIA DR',0,'BARBERTON','OH','44203','4467','CY','39153','1968-05-01','F','',':RET:2106-3','N','021','DEN','196464','99734OH005000401','2014-01-01','2013-12-09 16:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:34:00'),(24510,19471,'Y','18','021','EC','A','','','AC','0000034597','0000034597','TX00002914048','IL','1','Escobar','Laurette','','','','34','456234414','2514 SARITA ST',0,'CORPUS CHRISTI','TX','78405','1944','CY','48355','1966-04-12','F','U',':RET:2106-3','N','021','DEN','2634013','33348TX002000201','2014-04-01','2014-02-19 09:38:02','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-20 03:52:58'),(24966,19800,'Y','18','021','EC','A','','','AC','0000125701','0000125701','TX00002533094','IL','1','FAIRCHILD','EDWARD','LEE','','','34','435040086','112 BENNETT ST',0,'NORMANGEE','TX','77871','5286','CY','48289','1970-07-27','M','M',':RET:2106-3','N','021','DEN','3629919','33348TX002000201','2014-04-01','2014-02-19 19:40:37','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-20 22:00:23'),(26394,20935,'N','19','021','EC','A',NULL,NULL,'','0000194050','0001224518','','IL','1','TAYLOR','OLIVIA','','','','34','277155468','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','2009-03-22','F','',NULL,'N','021','HLT','3007504','52664OH151001301','2014-03-01','2014-02-26 13:08:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:27'),(26412,20946,'N','01','021','EC','A',NULL,NULL,'','0000027561','0000948180','','IL','1','Lively','Thomas','B','','','34','467850723','2013 SE 12TH ST',0,'MINERAL WELLS','TX','76067','6627','CY','48363','1986-10-03','M','',':RET:2106-3','N','021','DEN','3100857','33348TX002000201','2014-04-01','2014-02-26 15:36:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-02-28 07:00:40'),(26505,21024,'Y','18','021','EC','A','','','AC','0000496746','0000496746','OH00003566251','IL','1','Grande','Kristen','','','','34','280841299','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','1970-02-21','F','M',':RET:2106-3','N','021','DEN','3104329','99734OH005000401','2014-03-01','2014-02-28 15:49:57','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00','CIC',0,'2014-02-28 21:00:17'),(29074,23011,'Y','18','021','EC','A','','','AC','0001107146','0001107146','MS00003214394','S3','1','Davis','Kimberly','','','','34','427832182','534 BIRDIE DR',0,'BYRAM','MS','39272','5750','CY','28049','1997-08-25','M','U',':RET:2054-5','N','021','DEN','4188802','46300MS002000101','2014-04-01','2014-03-09 21:23:49','44.73',NULL,NULL,'47.10','2.37','R-MS003','MS0','47.10',NULL,0,'2014-03-10 21:01:59'),(22921,18271,'Y','18','021','EC','A','','','AC','0001023435','0001023435','WI00001569768','IL','1','storey','scott','','','','34','396809831','po 1535',0,'woodruff','WI','43468',NULL,'CY','39123','1965-12-27','M','U',':RET:2106-3','N','021','HLT','2719655','92036OH006002701','2014-03-01','2014-02-11 17:36:39','205.00',NULL,NULL,'252.84','47.84','R-OH006','WI0','252.84',NULL,0,'2014-02-11 21:02:55'),(22903,18256,'Y','18','021','EC','A','','','AC','0000061358','0000061358','OH00002359906','IL','1','STEPHENS','LYNNETTE','','','','34','275828886','3371 COUNTY ROAD 5 DASH 1',0,'DELTA','OH','43515',NULL,'CY','39051','1968-06-23','F','M',':RET:2106-3','T','021','HLT','3099406','92036OH002002601','2014-03-01','2014-02-11 11:02:51','362.00',NULL,NULL,'960.12','598.12','R-OH001','OH0','373.95',NULL,0,'2014-02-11 21:02:43'),(22800,18199,'N','01','021','EC','A',NULL,NULL,'','0000229477','0000593713','','IL','1','Swisher','Michael','','','','34','272643015','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1964-04-08','M','',':RET:2106-3','N','021','DEN','3292565','99734OH005000301','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:52'),(7723,6116,'Y','18','021','EC','A','','','AC','0000998775','0000998775','OH00001132323','IL','1','LAMBCKE','MARY','','','','34','280500224','240 W MAIN ST',0,'WILMINGTON','OH','45177','2241','CY','39027','1950-07-12','F','M',':RET:2106-3','N','021','DEN','1494946','99734OH005000401','2014-01-01','2013-12-20 13:59:19','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:01:47'),(22694,18121,'Y','18','021','EC','A','','','AC','0001240549','0001240549','TX00002684353','IL','1','righetti','rob','','','','34','557843725','3350 MCCUE RD',0,'HOUSTON','TX','77056','7125','CY','48201','1961-11-19','M','U',':RET:2106-3','N','021','DEN','3197512','33348TX002000101','2014-03-01','2014-02-10 21:19:54','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-11 21:00:54'),(21895,17484,'Y','18','021','EC','A','','','AC','0000231542','0000231542','OH00001961977','IL','1','Fontaine','Kandise','','','','34','272500006','1720 Carriage Ln.',0,'Alliance','OH','44601',NULL,'CY','39151','1952-07-06','F','M',':RET:2106-3','N','021','HLT','3739087','52664OH152000901','2014-03-01','2014-02-05 21:55:03','369.00',NULL,NULL,'458.99','89.99','R-OH015','OH0','458.99',NULL,0,'2014-02-06 21:01:42'),(3246,2616,'Y','18','024','14','A','','','TE','0000089793','0000089793','','IL','1','koshin','awes',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-02-02','M','',NULL,NULL,NULL,'','1055813','','2013-11-27','2013-11-27 19:43:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:46:30'),(6242,4946,'Y','18','021','EC','A','','','AC','0000084007','0000084007','OH00000859010','IL','1','Hebenstreit','Garret','','','','34','298581902','3748 W FORK RD',0,'CINCINNATI','OH','45247','7549','CY','39061','1971-08-08','M','M',NULL,'N','021','DEN','1206943','99734OH005000301','2014-01-01','2013-11-19 10:59:06','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:31:41'),(21744,17363,'Y','18','021','EC','A','','','AC','0000796017','0000796017','TX00002343084','IL','1','Gibson','Louise','','','','34','465781414','1512 DANCIGER DR',0,'FORT WORTH','TX','76112','3008','CY','48439','1951-08-07','F','M',NULL,'N','021','DEN','3274150','33348TX002000201','2014-03-01','2014-02-05 18:36:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:17'),(21537,17205,'Y','18','021','EC','A','','','AC','0000073971','0000073971','OH00001614679','IL','1','MacCarthy','Thomas','','','','34','272118403','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1962-06-01','M','M',NULL,'N','021','DEN','3765230','99734OH005000401','2014-03-01','2014-02-04 19:52:55','0.00',NULL,NULL,'71.95','71.95','R-OH001','OH0','0.00',NULL,0,'2014-02-05 21:30:08'),(17305,13839,'Y','18','024','14','A','','','TE','0000007457','0000007457','','IL','1','juarez','norberto',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-07','M','',NULL,NULL,NULL,'','1912130','','2014-01-10','2014-01-10 12:10:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:23:41'),(13384,10684,'N','01','021','EC','A',NULL,NULL,'','0000652124','0000798411','','IL','1','Homer','Jessie','','','','34','291901276','309 RICE ST',0,'ELMORE','OH','43416','9404','CY','39123','1982-03-14','F','',':RET:2106-3','N','021','DEN','2259194','99734OH005000301','2014-01-01','2013-12-22 23:36:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:58'),(26424,20957,'Y','18','021','EC','A','','','AC','0000300251','0000300251','TX00002861835','IL','1','Gonzalez','Celeste','Marie','','','34','458794403','2305 OAK SPRINGS CV',0,'ROUND ROCK','TX','78681','4089','CY','48491','1979-12-17','F','U',':RET:2106-3','N','021','DEN','3197965','33348TX002000201','2014-04-01','2014-02-27 12:25:10','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-02-28 07:30:10'),(20249,16158,'Y','18','021','EC','A','','','AC','0000280552','0000280552','TX00002100676','IL','1','LEDEZMA RAMIREZ','SALVADOR','','','','34','463713776','2389 COUNTY ROAD 429',0,'UVALDE','TX','78801','7292','CY','48463','1957-07-28','M','M',NULL,'N','021','DEN','3309923','33348TX002000101','2014-03-01','2014-01-28 15:00:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-28 21:00:12'),(9221,7316,'Y','18','021','EC','A','','','AC','0000899552','0000899552','OH00000680953','IL','1','Raspberry','Cynthia','','','','34','278506660','908 HERRICK RD',0,'CLEVELAND','OH','44108','2805','CY','39035','1953-10-31','F','M',':RET:2054-5','N','021','HLT','1801808','92036OH002000801','2014-01-01','2013-12-18 12:05:14','434.00',NULL,NULL,'732.76','298.76','R-OH011','OH0','732.76',NULL,0,'2013-12-26 04:10:12'),(18562,14803,'Y','18','021','EC','A','','','AC','0000373653','0000373653','OH00001825376','IL','1','smalley','kenneth','','','','34','273446258','819 BACON FLAT RD',0,'PEEBLES','OH','45660','9708','CY','39001','1957-06-02','M','R',':RET:2106-3','N','021','HLT','2424844','92036OH005000601','2014-02-01','2014-01-15 17:16:46','0.00',NULL,NULL,'500.82','500.82','R-OH005','OH0','500.82',NULL,0,'2014-01-16 08:47:00'),(13261,10583,'Y','18','021','EC','A','','','AC','0000402721','0000402721','TX00000620590','IL','1','STARKS','SHELIA','R','','','34','467216250','3701 COWHORN CREEK RD',0,'TEXARKANA','TX','75503','2410','CY','48037','1956-11-30','F','U',NULL,'N','021','DEN','1586691','33348TX002000201','2014-01-01','2013-12-23 12:10:09','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-26 12:56:39'),(18127,14477,'Y','18','021','EC','A','','','AC','0000475992','0000475992','OH00001488161','IL','1','Singleton','Brooke','','','','34','293848646','11751 Springfield Pike',0,'Springdale','OH','45246',NULL,'CY','39061','1985-03-26','F','U',NULL,'N','021','HLT','1833158','92036OH004001201','2014-02-01','2014-01-13 20:21:33','134.00',NULL,NULL,'187.64','53.64','R-OH004','OH0','187.64',NULL,0,'2014-01-15 02:07:42'),(14936,11935,'Y','18','021','EC','A','','','AC','0000209643','0000209643','OH00000639677','IL','1','ROTHHAAS','diane','','','','34','272704962','615 STEPHENS RD',0,'AKRON','OH','44312','2145','CY','39153','1960-10-03','F','U',NULL,'T','021','HLT','2377682','52664OH151001305','2014-02-01','2013-12-29 10:19:54','284.00',NULL,NULL,'523.18','239.18','R-OH012','OH0','523.18',NULL,0,'2013-12-30 00:02:09'),(16380,13107,'Y','18','021','EC','A','','','AC','0000730273','0000730273','TX00000310517','IL','1','najvar','allen','','','','34','456825854','8440 state highway 239 west',0,'goliad','TX','77963',NULL,'CY','48175','1950-09-12','M','M',':RET:2106-3','N','021','DEN','1654185','33348TX002000201','2014-02-01','2014-01-06 15:05:01','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-07 04:03:17'),(23690,18866,'Y','18','021','EC','A','','','AC','0000503022','0000503022','OH00002450502','IL','1','Roselli','Amanda','','','','34','294829551','4817 Hassan Cir',0,'Dayton','OH','45432',NULL,'CY','39113','1984-02-13','F','U',':RET:2106-3','N','021','DEN','3846043','99734OH005000401','2014-03-01','2014-02-13 20:59:37','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:30:36'),(24309,19306,'N','19','021','EC','A',NULL,NULL,'','0001885767','0001173633','','S1','1','STEWART','CRAIG','','','Sr',NULL,NULL,'216 EVELYN AVE',0,'HOUMA','LA','70363',NULL,'CY','22109','1998-12-28','F','',':RET:2054-5','N','021','DEN','3121202','18575LA002000101','2014-03-01','2014-02-18 17:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55','CIC',0,'2014-02-18 21:30:24'),(25046,19863,'Y','18','021','EC','A','','','AC','0000159459','0000159459','OH00002515290','IL','1','Whitmore','Wayne','','','','34','296748212','13601 BENWOOD AVE',0,'CLEVELAND','OH','44105','4611','CY','39035','1963-09-12','M','M',':RET:2054-5','N','021','DEN','2925115','99734OH005000401','2014-04-01','2014-02-19 20:05:00','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:01:13'),(25316,20083,'Y','18','021','EC','A','','','AC','0001800798','0001800798','LA00002927718','IL','1','WILLIAMS','BRITTANY','','','','34','438753891','1106 CYPRESS ROAD',0,'WEST WEGO','LA','70094',NULL,'CY','22051','1989-10-17','F','U',':RET:2054-5','N','021','DEN','2762814','18575LA002000201','2014-04-01','2014-02-24 20:44:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:05'),(5580,4426,'Y','18','021','EC','A','','','AC','0000035593','0000035593','TX00001053519','IL','1','burkett','regina','','','','34','467353282','3201 CROCKETT ST',0,'GRANBURY','TX','76049','7977','CY','48221','1960-05-10','F','U',':RET:2106-3','N','021','DEN','994943','33348TX002000201','2014-01-01','2013-11-05 22:56:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:16:55'),(15662,12531,'Y','18','024','14','A','','','TE','0000036941','0000036941','','IL','1','Sailors','Russell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-11-03','M','',NULL,NULL,NULL,'','1534307','','2013-12-31','2013-12-31 16:13:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:34:29'),(15339,12268,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00001617508','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','1654084','52664OH152000901','2014-02-01','2014-01-01 10:35:22','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,1,'2014-01-02 04:24:11'),(14442,11519,'Y','18','021','EC','A','','','AC','0002384875','0002384875','LA00001255901','31','1','Brown','Jessica','','','','34','435818051','633 E MARLIN CT',0,'TERRYTOWN','LA','70056','2976','CY','22051','1988-11-05','F','U',':RET:2054-5','N','021','DEN','1546422','18575LA002000201','2014-02-01','2013-12-27 11:46:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:13'),(13543,10799,'Y','18','021','EC','A','','','AC','0001564956','0001564956','LA00000311618','IL','1','riehl','vince','','','','34','354605081','942 HIGHWAY 90',0,'RACELAND','LA','70394','2418','CY','22057','1967-12-06','M','U',':RET:2106-3','N','021','DEN','2160257','18575LA002000201','2014-01-01','2013-12-23 14:08:30','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-26 13:03:51'),(3972,3173,'Y','18','024','14','A','','','TE','0000834436','0000834436','','IL','1','McGarvey','Steve',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-06-23','M','',NULL,NULL,NULL,'','882555','','2013-12-13','2013-12-13 12:24:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:38:37'),(17029,13624,'N','01','021','EC','A',NULL,NULL,'','0000026638','0000882867','','IL','1','Rohrs','Joya','Ann','','','34','298541191','1648 TINKERS VIEW DR',0,'TWINSBURG','OH','44087','1130','CY','39153','1953-08-12','F','',':RET:2106-3','N','021','HLT','2099288','52664OH152000901','2014-02-01','2014-01-09 15:38:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.31',NULL,0,'2014-01-13 02:20:43'),(17994,14380,'Y','18','021','EC','A','','','AC','0000667803','0000667803','OH00002210721','IL','1','Maier','Julie','','','','34','284466904','830 WOODBINE AVE',0,'CINCINNATI','OH','45246','4521','CY','39061','1959-04-04','F','M',':RET:2106-3','N','021','DEN','1517733','99734OH005000301','2014-02-01','2014-01-13 20:30:16','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:58'),(20995,16776,'Y','18','021','EC','A','','','AC','0000016652','0000016652','OH00001461561','IL','1','Stacy','Justin','','','','34','283922379','402 S 2ND ST',0,'MIAMISBURG','OH','45342','2929','CY','39113','1990-06-21','M','U',':RET:1002-5^:RET:2106-3','T','021','DEN','1941565','99734OH005000301','2014-03-01','2014-02-01 15:19:49','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-01 19:00:26'),(21211,16950,'Y','18','021','EC','A','','','AC','0002243492','0002243492','LA00001785955','IL','1','Jordan','Michael','','','','34','433419909','28477 WILDWOOD ST',0,'LACOMBE','LA','70445','3219','CY','22103','1966-08-22','M','U',':RET:2054-5','N','021','DEN','3181909','18575LA002000201','2014-03-01','2014-02-03 12:13:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:00:59'),(22542,18000,'Y','18','024','14','A','','','TE','0001314138','0001314138','','IL','1','Simmons','Angela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-05','F','',NULL,NULL,NULL,'','3080531','','2014-02-10','2014-02-10 10:30:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-10 21:31:40'),(26983,21374,'N','01','021','EC','A',NULL,NULL,'','0000586745','0000005899','','IL','1','House','Elizabeth','Ann','','','34','032681531','402 W VINE ST',0,'COLDWATER','OH','45828','1149','CY','39107','1980-05-09','F','',':RET:2106-3','N','021','HLT','2669639','92036OH004001501','2014-04-01','2014-03-02 12:40:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','212.00',NULL,0,'2014-03-03 01:00:39'),(6769,5371,'Y','18','021','EC','A','','','AC','0000413839','0000413839','LA00000899352','IL','1','Arnona','Toni','','','','34','437594305','3601 STATE STREET DR',0,'NEW ORLEANS','LA','70125','4248','CY','22071','1984-07-17','F','U',':RET:2106-3','N','021','DEN','544422','18575LA002000201','2014-01-01','2013-11-25 14:36:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:16:33'),(2242,1843,'Y','18','021','EC','A','','','AC','0000991516','0000991516','OH00000602074','IL','1','Schriml','Maureen','','','','34','270783054','7118 KIRKCALDY DR',0,'WEST CHESTER','OH','45069','4002','CY','39017','1974-05-23','F','M',':RET:2106-3','N','021','HLT','420479','92036OH003001205','2014-01-01','2013-12-10 16:51:57','522.00',NULL,NULL,'918.03','396.03','R-OH004','OH0','282.91',NULL,0,'2013-12-25 19:21:04'),(2577,2094,'Y','18','021','EC','A','','','AC','0000045728','0000045728','OH00001203785','IL','1','Weihrauch','Pamela','','','','34','291508296','109 Hartford Ct',0,'Lima','OH','45805',NULL,'CY','39003','1951-05-16','F','U',':RET:2106-3','N','021','HLT','1137971','92036OH002001501','2014-01-01','2013-12-09 16:25:02','396.00',NULL,NULL,'730.20','334.20','R-OH002','OH0','730.20',NULL,0,'2013-12-25 19:37:52'),(6413,5083,'Y','18','024','14','A','','','TE','0000408434','0000408434','','IL','1','JANSON','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-03','F','',NULL,NULL,NULL,'','980598','','2013-12-11','2013-12-11 13:34:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:48:40'),(4010,3203,'N','01','021','EC','A',NULL,NULL,'','0001022763','0001089543','','IL','1','Dao','Hang','Le','','','34','543613938','5936 COTTONWOOD KNL',0,'HAMILTON','OH','45011','8487','CY','39017','1975-10-01','F','',':RET:2047-9','N','021','DEN','2499078','99734OH005000401','2014-01-01','2013-12-16 21:54:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:23'),(5063,4012,'Y','18','021','EC','A','','','AC','0000870188','0000870188','TX00000276695','IL','1','elmi','tony','','','','34','459310485','2848 COUNTY ROAD 45600',0,'BLOSSOM','TX','75416','3752','CY','48277','1955-01-19','M','M',NULL,'N','021','DEN','2355944','33348TX002000201','2014-01-01','2013-12-19 09:21:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:29'),(5722,4542,'Y','18','021','EC','A','','','AC','0001760467','0001760467','LA00000055535','IL','1','caplan','byron','','','','34','216608112','11051 wardline rd.',0,'hammond','LA','70401',NULL,'CY','22105','1954-07-31','M','U',':RET:2106-3','N','021','DEN','1464876','18575LA002000201','2014-01-01','2013-12-23 21:33:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:25'),(22283,17788,'Y','18','021','EC','A','','','AC','0000283297','0000283297','OH00001487281','IL','1','Brown','Andrew','','','','34','405238483','925 ELM CT',0,'TERRACE PARK','OH','45174','1069','CY','39061','1983-12-10','M','U',':RET:2106-3','N','021','DEN','3084101','99734OH005000401','2014-03-01','2014-01-29 12:07:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-10 11:00:23'),(24672,19581,'N','01','021','EC','A',NULL,NULL,'','0000149395','0000664234','','IL','1','Schulte','Andrew','','','','34','293646397','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1973-05-08','M','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.07',NULL,0,'2014-02-20 04:27:17'),(831,688,'Y','18','021','EC','A','','','AC','0000146867','0000146867','OH00000941191','IL','1','Swanson','Robert','','','','34','185402971','2540 46TH ST NE',0,'CANTON','OH','44705','2902','CY','39151','1951-02-28','M','M',':RET:2106-3','N','021','HLT','2073345','52664OH151001301','2014-01-01','2013-12-16 17:41:13','648.00',NULL,NULL,'1281.40','633.40','R-OH015','OH0','640.70',NULL,0,'2013-12-25 18:06:22'),(1682,1404,'Y','18','021','EC','A','','','AC','0001776985','0001776985','LA00000111741','31','1','KENNEDY','GREGORY','','','','34','434110355','po box 36834',0,'sherevport','LA','71133',NULL,'CY','22017','1958-05-02','M','U',':RET:2054-5','N','021','DEN','1797165','18575LA002000101','2014-01-01','2013-12-24 10:35:45','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 18:54:11'),(16431,13147,'Y','18','021','EC','A','','','AC','0000699285','0000699285','OH00001705363','IL','1','Reichert','Debbie','','','','34','289565472','335 CHESTERFIELD LN',0,'MAUMEE','OH','43537','3817','CY','39095','1954-01-30','F','U',':RET:2106-3','N','021','HLT','2048686','92036OH006002601','2014-02-01','2014-01-06 15:52:18','304.00',NULL,NULL,'419.70','115.70','R-OH001','OH0','419.70',NULL,0,'2014-01-07 04:04:48'),(2360,1924,'Y','18','021','EC','A','','','AC','0000255937','0000255937','OH00001232982','IL','1','Cimachowski','John','Robert','','','34','280705773','3275 W 95TH ST',0,'CLEVELAND','OH','44102','4701','CY','39035','1976-01-02','M','U',':RET:2106-3','N','021','DEN','1132047','99734OH005000401','2014-01-01','2013-12-09 06:36:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:32:28'),(14219,11338,'Y','18','021','EC','A','','','AC','0000597061','0000597061','TX00000072169','IL','1','WELCH','LANITA','','','','34','449254256','605 LYNCH ST',0,'GAINESVILLE','TX','76240','2128','CY','48097','1965-06-24','F','U',NULL,'N','021','DEN','2323074','33348TX002000201','2014-02-01','2013-12-26 16:34:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:04:41'),(2393,1953,'N','01','021','EC','A',NULL,NULL,'','0001135143','0000551402','','IL','1','Brown','Marilyn','','','','34','501600189','10312 FORESTVIEW DR',0,'STRONGSVILLE','OH','44136','2662','CY','39035','1949-09-17','F','',':RET:2106-3','N','021','DEN','95898','99734OH005000401','2014-01-01','2013-12-09 12:16:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:20'),(19327,15406,'Y','18','024','14','A','','','TE','0000177799','0000177799','','IL','1','White','Timothy','B',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-09','M','',NULL,NULL,NULL,'','1463254','','2014-01-21','2014-01-21 14:00:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:14'),(19438,15495,'N','19','021','EC','A',NULL,NULL,'','0000431402','0000672788','','IL','1','Ladd','Sophia','','','','34','301138582','3380 WHISPERING TREES DR',0,'AMELIA','OH','45102','2327','CY','39025','2008-07-27','F','',':RET:2106-3','N','021','HLT','1465689','92036OH003000601','2014-03-01','2014-01-21 15:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,1,'2014-01-22 03:23:11'),(20410,16301,'Y','18','021','EC','A','','','AC','0000044816','0000044816','TX00002578586','IL','1','Hollister','Philip','','','','34','462534545','411 N 3RD ST',0,'WILLS POINT','TX','75169','2107','CY','48467','1966-01-21','M','M',':RET:2106-3','N','021','DEN','3519821','33348TX002000201','2014-03-01','2014-01-29 16:40:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:24'),(20536,16410,'Y','18','021','EC','A','','','AC','0000129285','0000129285','OH00001454403','IL','1','Moffat','Dolly','','','','34','269605250','4520 FAIRHAVEN AVE NW',0,'CANTON','OH','44709','1345','CY','39151','1959-06-27','F','M',':RET:2106-3','T','021','HLT','3212609','52664OH152000901','2014-03-01','2014-01-29 12:10:38','665.00',NULL,NULL,'799.10','134.10','R-OH015','OH0','401.04',NULL,0,'2014-01-29 21:01:33'),(20970,16756,'N','01','021','EC','A',NULL,NULL,'','0000968499','0000213460','','IL','1','De Leon','Hugo','','','','34','460350654','1419 N UVALDE ST',0,'ALTON','TX','78573','5804','CY','48215','1969-08-15','M','',':RET:2106-3','N','021','DEN','3162160','33348TX002000201','2014-03-01','2014-02-01 14:03:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-01 19:00:14'),(21624,17266,'Y','18','021','EC','A','','','AC','0000035871','0000035871','TX00002593396','31','1','Buxton','Dennis','','','','34','433961373','6650 FM 1006',0,'Orange','TX','77630',NULL,'CY','48241','1955-03-26','M','M',':RET:2106-3','N','021','DEN','3625473','33348TX002000201','2014-03-01','2014-02-05 09:40:40','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:38'),(22572,18027,'Y','18','021','EC','A','','','AC','0001012970','0001012970','OH00002659244','IL','1','HILL','JODELL','','','','34','276782608','2366 RIDGE RD',0,'HINCKLEY','OH','44233','9787','CY','39103','1970-04-03','F','U',':RET:2106-3','T','021','DEN','2729120','99734OH005000401','2014-03-01','2014-02-10 17:14:10','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-10 21:31:57'),(23727,18891,'Y','18','021','EC','A','','','AC','0000153141','0000153141','TX00002030313','IL','1','Bhatia','Ranjana','','','','34','595041558','16226 BREAKWATER PATH DR',0,'HOUSTON','TX','77044','1112','CY','48201','1958-03-10','F','M',':RET:2028-9','N','021','DEN','3570852','33348TX002000101','2014-03-01','2014-02-14 16:49:52','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-02-14 21:30:55'),(24793,19665,'Y','18','021','EC','A','','','AC','0000042107','0000042107','OH00002280950','IL','1','Baker','Jason','','','','34','283765267','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247','7023','CY','39061','1979-06-19','M','U',':RET:2106-3','N','021','DEN','2934802','99734OH005000401','2014-04-01','2014-02-19 15:26:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:47:02'),(27343,21651,'Y','18','021','EC','A','','','AC','0001142237','0001142237','OH00002947987','IL','1','MILLER','DEE','','','','34','268544569','12790 PICKERINGTON RD',0,'PICKERINGTON','OH','43147',NULL,'CY','39045','1960-01-30','F','U',':RET:2106-3','N','021','DEN','3744673','99734OH005000401','2014-04-01','2014-03-04 10:26:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-04 21:01:00'),(28023,22177,'Y','18','021','EC','A','','','AC','0000874765','0000874765','OH00002862120','IL','1','PADILLA','CRISTIAN','','','','34','598441091','4658 OBERLIN AVE',0,'LORAIN','OH','44053',NULL,'CY','39093','1994-09-23','M','M',NULL,'N','021','DEN','3051831','99734OH005000401','2014-04-01','2014-03-06 15:20:17','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:22'),(28621,22651,'Y','18','021','EC','A','','','AC','0000315685','0000315685','TX00003791374','IL','1','AVALOS','ARGURO','','','','34','643562649','9904 BROCKBANK DR.',0,'DALLAS','TX','75220',NULL,'CY','48113','1970-11-25','M','M',NULL,'N','021','DEN','4248889','33348TX002000201','2014-04-01','2014-03-07 23:26:38','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-08 21:30:21'),(6164,4887,'Y','18','021','EC','A','','','AC','0000662666','0000662666','OH00000955734','IL','1','McFerran','Angela','','','','34','300684286','6150 SHADE RD',0,'GREENVILLE','OH','45331','9577','CY','39037','1963-10-09','F','M',':RET:2106-3','N','021','HLT','821715','92036OH003000504','2014-01-01','2013-11-21 14:21:40','721.00',NULL,NULL,'973.33','252.33','R-OH003','OH0','443.34',NULL,0,'2013-12-26 00:16:53'),(5629,4466,'N','19','021','EC','A',NULL,NULL,'','0000612960','0000221253','','IL','1','Holloway','Colton','J','','','34','295042352','5091 ELNO AVE',0,'AKRON','OH','44319','4931','CY','39153','2000-02-15','M','',':RET:2106-3','N','021','DEN','223737','99734OH005000401','2014-01-01','2013-11-26 11:14:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:57'),(4598,3641,'Y','18','021','EC','A','','','AC','0000926247','0000926247','OH00000320314','IL','1','ARMSTRONG','CONNIE','','','','34','278522095','409 BREWER AVE',0,'AKRON','OH','44305','3109','CY','39153','1951-08-14','F','M',NULL,'N','021','HLT','405922','52664OH151001305','2014-01-01','2013-12-12 16:13:36','1068.00',NULL,NULL,'1309.70','241.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 22:05:38'),(3798,3044,'Y','18','021','EC','A','','','AC','0000280795','0000280795','OH00000652898','IL','1','Caserta','Zachary','','','','34','292908152','905 CHARLES ST',0,'TRENTON','OH','45067','1817','CY','39017','1987-07-01','M','U',':RET:2106-3','N','021','DEN','81919','99734OH005000301','2014-01-01','2013-12-13 11:56:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:26'),(14685,11724,'N','01','021','EC','A',NULL,NULL,'','0000484800','0000364896','','IL','1','Lengel','Betty','Jo','','','34','302426542','16284 Forgehill Dr.',0,'Garrettsville','OH','44231',NULL,'CY','39055','1952-06-20','F','',':RET:2106-3','N','021','DEN','1521995','99734OH005000401','2014-02-01','2013-12-28 12:14:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:08:41'),(1255,1034,'Y','18','021','EC','A','','','AC','0000987353','0000987353','OH00001198862','IL','1','HIRSCHFELD','SHEILA','R','','','34','291483629','215 STONE OAK CT',0,'HOLLAND','OH','43528','9256','CY','39095','1950-11-17','F','M',':RET:2106-3','N','021','HLT','1044747','92036OH001002601','2014-01-01','2013-12-03 11:49:26','0.00',NULL,NULL,'694.33','694.33','R-OH001','OH0','694.33',NULL,0,'2013-12-25 18:21:21'),(7706,6101,'Y','18','021','EC','A','','','AC','0001228052','0001228052','OH00000982621','IL','1','Harris','Alberta','','','','34','272506145','1826 BERKLEY AVE',0,'CINCINNATI','OH','45237','6116','CY','39061','1950-10-21','F','M',':RET:2054-5','N','021','DEN','1654889','99734OH005000401','2014-01-01','2013-12-20 09:34:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:01:24'),(2642,2146,'Y','18','021','EC','A','','','AC','0000999820','0000999820','OH00000434022','IL','1','Lordi','Joe','','','','34','295868336','501 FRANKLIN AVE',0,'BARBERTON','OH','44203','2821','CY','39153','1979-02-28','M','U',':RET:2106-3','N','021','DEN','1158154','99734OH005000401','2014-01-01','2013-12-02 16:44:40','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:46:21'),(20906,16710,'Y','18','021','EC','A','','','AC','0000779135','0000779135','OH00001509373','31','1','Sucher','Chelsea','','','','34','402273542','po box 18854',0,'fairfield','OH','45018',NULL,'CY','39017','1985-07-01','F','U',NULL,'T','021','DEN','2719411','99734OH005000401','2014-03-01','2014-01-31 16:45:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:24'),(20990,16774,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000232674','','IL','1','Al-Shinnawi','Yousef','S','','','34','286047764','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1999-09-23','M','',':RET:2106-3','N','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:25'),(21073,16839,'Y','18','021','EC','A','','','AC','0000746927','0000746927','OH00001850587','IL','1','legeza','suzanne','','','','34','293421744','5702 angola rd',0,'toledo','OH','43615',NULL,'CY','39095','1962-04-30','F','U',':RET:2106-3','N','021','DEN','3320378','99734OH005000401','2014-03-01','2014-02-02 10:26:57','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-02 19:00:18'),(22331,17832,'Y','18','021','EC','A','','','AC','0000571569','0000571569','TX00001553484','IL','1','Foster','James','Curtis','','','34','456910204','1801 N. Greenville Ave',0,'Richardson','TX','75081',NULL,'CY','48113','1981-08-04','M','U',':RET:2106-3','N','021','DEN','2983470','33348TX002000101','2014-03-01','2014-01-31 13:12:23','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-10 11:01:01'),(22588,18041,'Y','18','021','EC','A','','','AC','0000268913','0000268913','OH00002235748','IL','1','Diamond','Ariel','','','','34','344729683','1022 FAUROT AVE',0,'LIMA','OH','45805','3218','CY','39003','1983-02-19','F','U',':RET:2054-5','N','021','HLT','2926338','92036OH006001501','2014-03-01','2014-02-10 14:57:20','136.00',NULL,NULL,'202.30','66.30','R-OH002','OH0','202.30',NULL,0,'2014-02-10 21:32:07'),(24155,19192,'N','01','021','EC','A',NULL,NULL,'','0000261545','0000482231','','IL','1','Drum','Lucy','C','','','34','063602402','07847 Southland Rd',0,'New Knoxville','OH','45871',NULL,'CY','39011','1959-11-11','F','',':RET:2106-3','N','021','HLT','3344765','92036OH005001505','2014-03-01','2014-02-15 11:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','469.88',NULL,0,'2014-02-15 22:01:59'),(22858,18236,'N','19','021','EC','A',NULL,NULL,'','0000708982','0000288333','','IL','1','Swisher','Elizabeth','','','','34','300949725','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1992-08-03','F','',':RET:2106-3','N','021','HLT','3585946','92036OH003002705','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2014-02-11 21:02:24'),(27620,21845,'Y','18','021','EC','A','','','AC','0001208270','0001208270','LA00002896453','IL','1','BAKER','CRELISE','','','','34','433772384','2700 WHITNEY AVE',0,'HARVEY','LA','70058',NULL,'CY','22051','1988-11-26','F','M',':RET:2054-5','T','021','DEN','3173342','18575LA002000101','2014-04-01','2014-03-04 18:03:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-05 21:30:03'),(8910,7067,'Y','18','021','EC','A','','','AC','0001044471','0001044471','OH00000625826','IL','1','PAGANO','GIOVANNI','','','','34','302521547','2804 LEXINGTON AVE NW',0,'WARREN','OH','44485','1536','CY','39155','1951-08-09','M','M',':RET:2106-3','N','021','DEN','2522825','99734OH005000401','2014-01-01','2013-12-17 20:40:50','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:02:33'),(6171,4890,'Y','18','021','EC','A','','','AC','0000003312','0000003312','LA00000043699','IL','1','Gremillion','Patricia','','','','34','439821424','60269 WILLIAM DR',0,'LACOMBE','LA','70445','4305','CY','22103','1950-10-24','F','U',NULL,'T','021','DEN','153931','18575LA002000101','2014-01-01','2013-10-02 08:21:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:17:02'),(15314,12247,'Y','18','021','EC','A','','','AC','0001101417','0001101417','TX00001864780','IL','1','Duran-vigil','Patricia','','','','34','450178956','8704 MARBLE DR',0,'EL PASO','TX','79904','1710','CY','48141','1953-09-15','F','M',':RET:2106-3','N','021','DEN','2305979','33348TX002000101','2014-02-01','2014-01-01 13:58:32','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,1,'2014-01-02 04:23:19'),(2322,1888,'Y','18','024','14','A','','','TE','0000914738','0000914738','','IL','1','Witt','Cody',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-12','M','',NULL,NULL,NULL,'','180931','','2013-12-09','2013-12-09 08:00:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:31:26'),(22635,18075,'Y','18','021','EC','A','','','AC','0000098709','0000098709','TX00002063916','IL','1','PEREZ','MARIA','ESTER','','','34','632863765','2720 63RD ST',0,'LUBBOCK','TX','79413','5822','CY','48303','1962-07-27','F','M',NULL,'N','021','DEN','3675866','33348TX002000201','2014-03-01','2014-02-11 09:52:13','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-02-11 21:00:20'),(23096,18411,'N','19','021','EC','A',NULL,NULL,'','0000991586','0001230441','','IL','1','PENNINGTION','KAYLEIGH','','','','34','281064521','26407 LUNDA RD',0,'WEST MANSFIELD','OH','43358','9644','CY','39159','2001-05-16','F','',':RET:2106-3','N','021','DEN','3377749','99734OH005000401','2014-03-01','2014-02-12 13:55:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:09'),(23527,18741,'N','01','021','EC','A',NULL,NULL,'','0001647551','0002154915','','IL','1','VASALLE','RENELL','','','Sr','34','433026967','2611 BERTRAND AVE',0,'LAKE CHARLES','LA','70611','3617','CY','22019','1956-03-22','M','',':RET:2106-3','N','021','DEN','2916341','18575LA002000201','2014-03-01','2014-02-13 08:27:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-13 22:02:24'),(26510,21026,'Y','18','024','14','A','','','TE','0000418918','0000418918','','IL','1','Meek','Joshua','Wayne',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2001-05-07','M','',NULL,NULL,NULL,'','2786417','','2014-03-31','2014-02-28 17:40:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:19'),(782,645,'Y','18','021','EC','A','','','AC','0001172467','0001172467','TX00000531271','IL','1','Wood','Dean','','','','34','411454875','29106 LEGENDS VALLEY LN',0,'SPRING','TX','77386','4132','CY','48339','1967-06-23','M','M',NULL,'N','021','DEN','2394984','33348TX002000201','2014-01-01','2013-12-16 15:02:18','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:05:04'),(16829,13461,'Y','18','021','EC','A','','','AC','0001132774','0001132774','OH00002347824','IL','1','JENNINGS','DWIEGHT','','','','34','302542726','5926 KENTLAND AVE.',0,'PORTSMOUTH','OH','45662',NULL,'CY','39145','1953-07-21','M','M',':RET:2106-3','N','021','DEN','1398299','99734OH005000401','2014-02-01','2014-01-10 19:34:45','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2014-01-13 02:18:27'),(1296,1072,'Y','18','024','14','A','','','TE','0000566388','0000566388','','IL','1','Vanwie','Joseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-12-29','M','',NULL,NULL,NULL,'','511909','','2013-11-29','2013-11-29 15:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:31:01'),(6513,5163,'Y','18','021','EC','A','','','AC','0000696791','0000696791','OH00001080970','IL','1','Dhimal','Saraswati','','','','34','301135637','9237 N PLAZA DR',0,'NORTHFIELD','OH','44067','1349','CY','39153','1986-04-11','F','M',':RET:2029-7','N','021','HLT','1062236','52664OH152000901','2014-01-01','2013-12-11 17:51:10','15.00',NULL,NULL,'171.18','156.18','R-OH012','OH0','171.18',NULL,0,'2013-12-26 00:51:11'),(15361,12286,'Y','18','021','EC','A','','','AC','0001039760','0001039760','OH00001851037','IL','1','Rodriguez','Alexis',NULL,NULL,NULL,NULL,NULL,'2557 CHERRY LAKE RD',0,'SYLVANIA','OH','43560','8982','CY','39095','2000-01-03','F','R',':RET:2106-3','N','021','DEN','2372433','99734OH005000301','2014-02-01','2014-01-01 02:09:23','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','21.13',NULL,1,'2014-01-02 04:24:46'),(6056,4798,'Y','18','021','EC','A','','','AC','0000043198','0000043198','OH00000013294','IL','1','Carr','Leonard','','','','34','232170644','7945 ROYALTON RD SW',0,'LANCASTER','OH','43130','9238','CY','39045','1975-04-20','M','M',':RET:2106-3','N','021','DEN','715076','99734OH005000401','2014-01-01','2013-11-30 18:23:51','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:01:49'),(9554,7572,'Y','18','021','EC','A','','','AC','0001057973','0001057973','OH00001273452','IL','1','Johnson','Stacey','','','','34','299903762','4319 POST RAIL LN',0,'FRANKLIN','OH','45005','4950','CY','39165','1987-08-28','F','U',NULL,'N','021','DEN','2220348','99734OH005000301','2014-01-01','2013-12-21 14:04:33','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:22'),(5467,4343,'Y','18','021','EC','A','','','AC','0001234117','0001234117','OH00000869431','IL','1','Meiring','Sharon','','','','34','298549443','1809 PARK AVE',0,'PIQUA','OH','45356','4461','CY','39109','1953-08-29','F','M',':RET:2106-3','N','021','HLT','2007760','92036OH004000501','2014-01-01','2013-12-19 16:41:17','250.00',NULL,NULL,'518.73','268.73','R-OH003','OH0','518.73',NULL,0,'2013-12-25 23:10:34'),(4047,3231,'Y','18','021','EC','A','','','AC','0000067657','0000067657','OH00000244423','IL','1','Schneider','Mary','Alice','','','34','297502373','341 W MAIN ST',0,'GENEVA','OH','44041','1208','CY','39007','1951-11-24','F','U',':RET:2106-3','T','021','DEN','1600403','99734OH005000401','2014-01-01','2013-12-17 12:44:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:17'),(18934,15087,'Y','18','021','EC','A','','','AC','0000728743','0000728743','OH00001387672','IL','1','BLYTHE','DEBORAH','','','','34','268627118','5573 MARTIN AVE',0,'VERMILION','OH','44089','1239','CY','39043','1954-04-26','F','U',NULL,'N','021','DEN','1774454','99734OH005000401','2014-03-01','2014-01-17 13:47:05','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-20 08:05:40'),(21057,16824,'Y','18','021','EC','A','','','AC','0002220772','0002220772','LA00001522043','IL','1','Bethancourt','Dimitria','','','','34','436252343','1212 S LEXINGTON ST',0,'GONZALES','LA','70737','5142','CY','22005','1960-08-10','F','U',':RET:2054-5','N','021','DEN','2711541','18575LA002000201','2014-03-01','2014-02-01 21:20:35','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-02 19:00:09'),(22491,17955,'Y','18','021','EC','A','','','AC','0001227067','0001227067','OH00002254756','IL','1','FREEMAN','VERSIAL','','','','34','497900086','6369 BASKERVILLE DR.',0,'COLUMBUS','OH','43213',NULL,'CY','39049','1984-09-20','M','U',':RET:2054-5','N','021','DEN','2933328','99734OH005000301','2014-03-01','2014-02-10 12:55:29','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-10 21:31:07'),(23660,18840,'Y','18','021','EC','A','','','AC','0000226116','0000226116','TX00002651939','IL','1','Chui','Lam','','','','34','051766647','789 EIFFEL DR',0,'PLANO','TX','75023','7062','CY','48085','1979-08-27','M','M',':RET:2034-7','N','021','DEN','2804020','33348TX002000201','2014-03-01','2014-02-14 12:46:24','0.00',NULL,NULL,'72.22','72.22','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:19'),(26740,21193,'Y','18','021','EC','A','','','AC','0000022844','0000022844','OH00003204795','IL','1','BELOW','MARY','','','','34','290520015','1120 LEE AVE',0,'PORT CLINTON','OH','43452',NULL,'CY','39123','1950-07-25','F','M',':RET:2106-3','N','021','HLT','3068728','92036OH006002701','2014-04-01','2014-02-28 14:07:11','0.00',NULL,NULL,'456.50','456.50','R-OH006','OH0','456.50',NULL,0,'2014-02-28 21:31:54'),(7686,6086,'N','19','021','EC','A',NULL,NULL,'','0001004325','0000822047','','IL','1','biesenbender','claudia','renee','','','34','300029152','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1998-06-28','F','',':RET:2106-3','N','021','DEN','1676656','99734OH005000401','2014-01-01','2013-12-19 20:48:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:00:55'),(17822,14237,'Y','18','024','14','A','','','TE','0000957012','0000957012','','IL','1','WALKER','MICHAEL','RAY',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-29','M','',NULL,NULL,NULL,'','1880971','','2014-01-14','2014-01-14 10:23:44',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-15 02:05:56'),(7060,5608,'Y','18','021','EC','A','','','AC','0001030379','0001030379','OH00001089492','IL','1','Van','Emily','','','','34','457712345','96 Rosslyn Ave',0,'Columbus','OH','43214',NULL,'CY','39049','1973-01-31','F','U',':RET:2106-3','N','021','DEN','1480280','99734OH005000301','2014-01-01','2013-12-24 21:16:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:49:54'),(2181,1793,'Y','18','021','EC','A','','','AC','0000664157','0000664157','OH00000996017','IL','1','Laus','Sandra','','','','34','386523380','2730 LILLY DR',0,'ELIDA','OH','45807','1441','CY','39003','1950-03-20','F','M',NULL,'N','021','HLT','375196','92036OH002001501','2014-01-01','2013-12-09 21:26:50','547.00',NULL,NULL,'750.27','203.27','R-OH002','OH0','750.27',NULL,0,'2013-12-25 19:19:24'),(20644,16496,'Y','18','021','EC','A','','','AC','0001087458','0001087458','TX00001605035','IL','1','Ali','Mudather','','','','34','438953202','4212 West Northgate Drive',0,'Irving','TX','75016',NULL,'CY','48113','1961-03-21','M','U',':RET:2054-5','N','021','DEN','2869023','33348TX002000201','2014-03-01','2014-01-30 13:03:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:34'),(28632,22659,'Y','18','021','EC','A','','','AC','0000926782','0000926782','TX00003518036','IL','1','RASMUSSEN','MARTIN','ROBERT','','','34','465979464','538 TEAL DR',0,'DICKINSON','TX','77539',NULL,'CY','48167','1985-01-21','M','U',':RET:2106-3','N','021','DEN','4205558','33348TX002000201','2014-04-01','2014-03-07 19:14:11','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-08 21:30:27'),(8965,7112,'Y','18','021','EC','A','','','AC','0000437960','0000437960','OH00000946163','IL','1','Fidak','Donna','','','','34','290425759','928 BANFIELD AVE',0,'TORONTO','OH','43964','1104','CY','39081','1953-10-11','F','M',':RET:2106-3','N','021','DEN','2257562','99734OH005000401','2014-01-01','2013-12-18 14:26:26','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:03:57'),(17959,14350,'Y','18','021','EC','A','','','AC','0000717401','0000717401','TX00001370590','31','1','arias','lupe','','','','34','549133612','6024 los pueblos dr.',0,'el paso','TX','79912',NULL,'CY','48141','1958-07-17','F','U',NULL,'N','021','DEN','1824411','33348TX002000201','2014-02-01','2014-01-14 18:27:37','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-15 02:06:45'),(1686,1408,'Y','18','021','EC','A','','','AC','0001759217','0001759217','LA00000712878','IL','1','Rimes','Melissa','','','','34','433695823','10617 CARMEL DR',0,'BATON ROUGE','LA','70818','3132','CY','22033','1976-11-12','F','U',':RET:2106-3','N','021','DEN','2559627','18575LA002000101','2014-01-01','2013-12-24 14:34:57','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:54:18'),(17020,13620,'N','01','021','EC','A',NULL,NULL,'','0000071658','0001250859','','IL','1','SABO','MARC','','','','34','273707614','3740 WYNDHAM RIDGE DR',0,'STOW','OH','44224','6152','CY','39153','1975-11-21','M','',':RET:2106-3','N','021','HLT','2109833','52664OH152000901','2014-02-01','2014-01-08 19:30:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.52',NULL,0,'2014-01-13 02:20:40'),(13477,10748,'Y','18','021','EC','A','','','AC','0000771441','0000771441','OH00001008438','IL','1','Rawal','Ish','','','','34','277083836','4998 SHADY CREST AVE NW',0,'MASSILLON','OH','44646','9554','CY','39151','1977-01-10','M','R',':RET:2029-7','N','021','DEN','2193469','99734OH005000301','2014-01-01','2013-12-23 17:17:40','0.00',NULL,NULL,'87.78','87.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 13:02:09'),(3159,2541,'Y','18','021','EC','A','','','AC','0000671673','0000671673','OH00000643375','IL','1','Turner','Robert','','','','34','301746870','231 MARINA POINT DR',0,'SANDUSKY','OH','44870','6522','CY','39043','1979-11-08','M','U',':RET:2106-3','N','021','DEN','224923','99734OH005000401','2014-01-01','2013-11-18 08:27:58','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 20:31:15'),(4821,3821,'Y','18','021','EC','A','','','AC','0000829254','0000829254','OH00000819054','IL','1','Emery','Hazel','','','','34','382686257','935 KIRKWALL DR',0,'COPLEY','OH','44321','1724','CY','39153','1963-02-02','F','U',':RET:2106-3','T','021','HLT','315158','52664OH152000901','2014-01-01','2013-12-08 13:56:40','250.00',NULL,NULL,'335.49','85.49','R-OH012','OH0','335.49',NULL,0,'2013-12-25 22:17:06'),(19090,15209,'Y','18','021','EC','A','','','AC','0001253561','0001253561','OH00001564017','IL','1','VINKA','CATHERINE','','','','34','268663701','112 CLEARMOUNT AVE SE',0,'NORTH CANTON','OH','44720','3214','CY','39151','1958-03-29','F','U',':RET:2106-3','N','021','DEN','2010149','99734OH005000301','2014-03-01','2014-01-18 13:47:06','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-21 08:44:31'),(20374,16275,'Y','18','021','EC','A','','','AC','0001470466','0001470466','LA00002206053','IL','1','Moore','Oscar','','','','34','435311327','506 RICHARD AVE',0,'NEW IBERIA','LA','70560','8200','CY','22045','1963-09-07','M','U',':RET:2054-5','N','021','DEN','3241609','18575LA002000101','2014-03-01','2014-01-29 13:04:03','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-29 21:00:07'),(21071,16837,'Y','18','021','EC','A','','','AC','0000761150','0000761150','OH00002090672','IL','1','Lewis','Kelly','','','','34','290903625','4379 STRATTFORD CIR W',0,'ZANESVILLE','OH','43701','6744','CY','39119','1987-01-31','F','U',':RET:2106-3','N','021','DEN','3695492','99734OH005000401','2014-03-01','2014-02-01 22:35:58','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-02 19:00:17'),(23105,18418,'Y','18','021','EC','A','','','AC','0000084092','0000084092','OH00001739811','IL','1','christman','jerry','','','','34','605075032','6619 HIGHLAND AVE',0,'CINCINNATI','OH','45236','3914','CY','39061','1971-10-11','M','R',':RET:2106-3','T','021','DEN','2932419','99734OH005000401','2014-03-01','2014-02-12 15:47:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:14'),(24539,19493,'Y','18','021','EC','A','','','AC','0000840141','0000840141','TX00002219029','IL','1','Calzada','Elizabeth','','','','34','449616020','10249 SHARP DR',0,'EL PASO','TX','79924','3516','CY','48141','1981-10-16','F','M',NULL,'N','021','DEN','3034654','33348TX002000201','2014-04-01','2014-02-18 18:04:00','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-20 04:01:55'),(25567,20282,'Y','18','021','EC','A','','','AC','0001021520','0001021520','OH00001728675','31','1','Harbaugh','Annette','','','','34','277841013','P.O. Box 1746',0,'Wooster','OH','44691',NULL,'CY','39169','1975-02-03','F','U',':RET:2106-3','N','021','HLT','2863646','52664OH152000901','2014-04-01','2014-02-23 13:34:10','206.14',NULL,NULL,'206.14','0.00','R-OH014','OH0','206.14',NULL,0,'2014-02-26 08:00:27'),(25655,20354,'Y','18','021','EC','A','','','AC','0000521015','0000521015','OH00003168013','IL','1','DECKER','KEVIN','','','','34','290685436','975 MILLER AVE',0,'NEWARK','OH','43055',NULL,'CY','39089','1963-11-21','M','M',NULL,'N','021','DEN','3849584','99734OH005000401','2014-04-01','2014-02-22 16:52:26','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:41'),(28743,22749,'Y','18','021','EC','A','','','AC','0001687008','0001687008','LA00003037893','IL','1','Varise','Dedrick','','','','34','437558294','915 AVENUE A',0,'PORT ALLEN','LA','70767','2943','CY','22121','1983-07-18','M','U',':RET:2054-5','T','021','DEN','3157204','18575LA002000201','2014-04-01','2014-03-09 12:13:44','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-09 21:00:11'),(7281,5774,'Y','18','021','EC','A','','','AC','0000769485','0000769485','TX00000362914','IL','1','Biggs','Robert','','','','34','463697150','2109 AZALEA ST',0,'DENTON','TX','76205','7459','CY','48121','1983-02-24','M','M',':RET:2106-3','N','021','DEN','15492','33348TX002000201','2014-01-01','2013-12-14 17:44:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:02:41'),(18109,14465,'Y','18','021','EC','A','','','AC','0002255092','0002255092','LA00001690051','IL','1','Nguyen','Thuy','','','','34','603437158','1392 WELLINGTON DR',0,'BATON ROUGE','LA','70815','5337','CY','22033','1964-03-16','F','M',NULL,'N','021','DEN','2890364','18575LA002000201','2014-02-01','2014-01-14 18:33:18','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-15 02:07:36'),(17951,14342,'Y','18','021','EC','A','','','AC','0000861923','0000861923','TX00001566696','IL','1','Simmons','Sandra','','','','34','466840637','1049 FM 2493 W',0,'BULLARD','TX','75757','5582','CY','48073','1949-10-26','F','U',':RET:2106-3','N','021','DEN','2417079','33348TX002000201','2014-02-01','2014-01-14 16:57:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:42'),(14673,11713,'Y','18','021','EC','A','','','AC','0001141418','0001141418','MS00001277301','31','1','JEFFERSON','CANDACE','','','','34','425479120','PO BOX 825',0,'Gloster','MS','39638',NULL,'CY','28005','1982-11-20','F','M',':RET:2054-5','N','021','DEN','1493877','46300MS002000101','2014-02-01','2013-12-28 10:27:00','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2013-12-29 11:08:18'),(1675,1397,'Y','18','021','EC','A','','','AC','0001227029','0001227029','OH00001373312','IL','1','Groh','Megan','','','','34','307046890','6343 DUSTYWIND LN',0,'LOVELAND','OH','45140','8061','CY','39025','1987-12-23','F','U',':RET:2106-3','N','021','HLT','2429860','92036OH005000604','2014-01-01','2013-12-24 07:48:23','64.00',NULL,NULL,'219.82','155.82','R-OH005','OH0','219.82',NULL,0,'2013-12-25 18:53:58'),(2906,2343,'Y','18','021','EC','A','','','AC','0000678060','0000678060','OH00000770283','IL','1','Otchere','Baffour','','','','34','291766180','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1954-02-20','M','M',':RET:2054-5','N','021','DEN','34684','99734OH005000401','2014-01-01','2013-12-05 23:13:43','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:28'),(3647,2919,'Y','18','021','EC','A','','','AC','0000814264','0000814264','OH00000129919','IL','1','scalf','todd','','','','34','281888111','1220 HARRISON AVE',0,'CINCINNATI','OH','45214','1700','CY','39061','1972-02-13','M','U',':RET:2106-3','N','021','DEN','43806','99734OH005000401','2014-01-01','2013-12-12 18:34:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:30:33'),(19537,15571,'Y','18','021','EC','A','','','AC','0001248365','0001248365','OH00002069641','IL','1','Scott','Sherry','','','','34','558159988','1104 Liberty St',0,'Toledo','OH','43605',NULL,'CY','39095','1957-01-31','F','M',':RET:2106-3','T','021','HLT','3090410','92036OH004002601','2014-03-01','2014-01-21 20:00:40','211.00',NULL,NULL,'439.43','228.43','R-OH001','OH0','439.43',NULL,0,'2014-01-23 03:02:23'),(24424,19402,'Y','18','021','EC','A','','','AC','0000830688','0000830688','OH00001355231','IL','1','Ragonesi','Christopher','','','','34','041642831','102 SAINT ANDREWS DR',0,'CINCINNATI','OH','45245','2904','CY','39025','1961-09-26','M','U',':RET:2106-3','N','021','HLT','3505919','92036OH005000606','2014-04-01','2014-02-18 08:28:45','299.00',NULL,NULL,'419.03','120.03','R-OH005','OH0','419.03',NULL,0,'2014-02-18 22:01:10'),(19454,15506,'Y','18','021','EC','A','','','AC','0000951831','0000951831','OH00001382933','31','1','MALTRY','LINDA','L','','','34','272687352','PO BOX 204',0,'GRAND RIVER','OH','44045',NULL,'CY','39085','1959-05-16','F','M',':RET:2106-3','N','021','DEN','2021622','99734OH005000301','2014-03-01','2014-01-22 15:34:56','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:01:53'),(22878,18246,'N','19','021','EC','A',NULL,NULL,'','0000050726','0000756048','','IL','1','Paris','Zachary','','','','34','296960184','5450 PARKS AVE',0,'LOUISVILLE','OH','44641','9522','CY','39151','1994-03-25','M','',NULL,'N','021','HLT','3696746','52664OH151001501','2014-03-01','2014-02-11 09:18:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-11 21:02:32'),(27660,21878,'Y','18','021','EC','A','','','AC','0000387351','0000387351','OH00002765386','IL','1','SHANNON','KIMBERLY','','','','34','294585222','46153 MORT DR',0,'EAST LIVERPOOL','OH','43920',NULL,'CY','39029','1961-01-17','F','U',NULL,'T','021','DEN','3236165','99734OH005000401','2014-04-01','2014-03-05 14:49:53','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-03-05 21:30:26'),(4673,3704,'N','01','021','EC','A',NULL,NULL,'','0000696999','0000776464','','IL','1','DAUGHERTY','RODNEY','','','','34','296548246','107 HAPPY LN',0,'FERRIDAY','LA','71334','3623','CY','22029','1969-01-23','M','',':RET:2106-3','N','021','DEN','493548','18575LA002000201','2014-01-01','2013-12-12 14:34:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:40'),(7501,5933,'Y','18','021','EC','A','','','AC','0000280819','0000280819','OH00000336873','IL','1','Grossman','Brian','','','','34','309767387','399 W. Galbraith Road',0,'Cincinnati','OH','45215',NULL,'CY','39061','1974-03-16','M','U',':RET:2106-3','N','021','DEN','234786','99734OH005000401','2014-01-01','2013-12-15 16:19:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:50'),(15954,12772,'Y','18','021','EC','A','','','AC','0000745448','0000745448','OH00001671944','31','1','Stambaugh','Teena','','','','34','297661269','26581 MAIN ST',0,'COOLVILLE','OH','45723','9064','CY','39009','1959-03-25','F','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','2601937','99734OH005000301','2014-02-01','2014-01-02 23:44:51','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-01-04 02:00:11'),(14477,11551,'Y','18','021','EC','A','','','AC','0000562908','0000562908','TX00001480052','IL','1','doll','tracy','','','','34','459210626','24757 grand harbor dr.',0,'katy','TX','77494',NULL,'CY','48157','1957-05-28','F','M',':RET:2106-3','N','021','DEN','1999041','33348TX002000201','2014-02-01','2013-12-26 21:00:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-28 03:33:12'),(18836,15002,'Y','18','021','EC','A','','','AC','0000983862','0000983862','OH00002182157','31','1','Nelson','Jessca','','','','34','283888937','P.O. Box 173',0,'Geneva','OH','44041',NULL,'CY','39007','1977-10-27','F','U',':RET:2106-3','N','021','HLT','1537547','52664OH151001305','2014-02-01','2014-01-15 21:45:05','173.00',NULL,NULL,'309.37','136.37','R-OH011','OH0','309.37',NULL,0,'2014-01-17 03:36:11'),(18894,15054,'Y','18','021','EC','A','','','AC','0000431401','0000431401','OH00001619304','IL','1','Horn','Francie','','','','34','233880373','262 Lownsdale Ave',0,'Akron','OH','44313',NULL,'CY','39153','1956-11-23','F','M',':RET:2106-3','N','021','HLT','1624051','52664OH151001501','2014-03-01','2014-01-16 12:25:25','66.00',NULL,NULL,'651.81','585.81','R-OH012','OH0','651.81',NULL,0,'2014-01-17 03:36:33'),(18901,15060,'Y','18','021','EC','A','','','AC','0000133340','0000133340','OH00002133711','IL','1','mcintosh','sandra','','','','34','271483929','901 cherry',0,'Blanchester','OH','45107',NULL,'CY','39027','1949-07-16','F','M',':RET:2106-3','N','021','HLT','1877167','92036OH003000601','2014-03-01','2014-01-16 13:09:54','0.00',NULL,NULL,'672.53','672.53','R-OH005','OH0','672.53',NULL,0,'2014-01-17 03:36:36'),(23810,18945,'Y','18','021','EC','A','','','AC','0000570602','0000570602','OH00002212530','IL','1','Vyas','Annal','','','','34','295861435','4410 EASTWICKE BLVD',0,'STOW','OH','44224','2115','CY','39153','1981-01-14','M','U',':RET:2029-7','N','021','HLT','3246694','52664OH152000901','2014-03-01','2014-02-13 22:06:27','0.00',NULL,NULL,'195.68','195.68','R-OH012','OH0','195.68',NULL,0,'2014-02-14 21:31:34'),(24991,19820,'N','19','021','EC','A',NULL,NULL,'','0000746962','0000145958','','IL','1','ZHANG','NING','','','','34','628136382','7623 TUSSENDO DR',0,'HOUSTON','TX','77083','3452','CY','48201','1990-05-09','F','',':RET:2034-7','N','021','DEN','2807435','33348TX002000201','2014-04-01','2014-02-20 14:05:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 22:00:39'),(25194,19985,'Y','18','021','EC','A','','','AC','0002292254','0002292254','LA00002834454','IL','1','Miller','Adam','','','','34','437414642','5186 SHERWOOD ST',0,'BATON ROUGE','LA','70805','4540','CY','22033','1966-05-10','M','M',':RET:2054-5','N','021','DEN','3535481','18575LA002000101','2014-04-01','2014-02-21 12:32:04','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-21 22:00:41'),(26577,21071,'Y','18','021','EC','A','','','AC','0000385954','0000385954','OH00003080394','IL','1','SEIDU','IDDRISU','','','','34','287081744','5654 FOREST HILLS BLVD',0,'COLUMBUS','OH','43231','2947','CY','39049','1968-04-22','M','M',':RET:2054-5','N','021','DEN','3146978','99734OH005000401','2014-04-01','2014-02-28 12:49:55','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:28'),(27011,21394,'Y','18','021','EC','A','','','AC','0000209648','0000209648','OH00003057517','IL','1','hinkle','susan','','','','34','294700974','3995 ALEXANDER LN',0,'BATAVIA','OH','45103','3301','CY','39025','1962-11-07','F','M',':RET:2106-3','T','021','DEN','3659772','99734OH005000401','2014-04-01','2014-03-03 17:15:35','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00','CIC',0,'2014-03-03 21:00:07'),(27583,21813,'N','01','021','EC','A',NULL,NULL,'','0000348881','0001005508','','IL','1','Curry','Rhonda','Catherine','','','34','226864052','10445 TRUMAN ST',0,'AMARILLO','TX','79118','5330','CY','48381','1955-01-01','F','',':RET:2106-3','N','021','DEN','2770441','33348TX002000201','2014-04-01','2014-03-05 10:34:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-05 21:00:12'),(28387,22460,'N','01','021','EC','A',NULL,NULL,'','0000919448','0000830699','','IL','1','JONES','ALFRED','','','III','34','294841879','73 EASTGAY DR',0,'AKRON','OH','44313',NULL,'CY','39153','1981-06-12','M','',NULL,'N','021','HLT','4173852','52664OH152000901','2014-04-01','2014-03-07 16:51:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','193.23',NULL,0,'2014-03-07 21:30:43'),(5221,4145,'Y','18','021','EC','A','','','AC','0000672749','0000672749','OH00000920394','IL','1','MOTTLE','DEBRA','','','','34','272440794','4400 LOT 267',0,'WOOSTER','OH','44691',NULL,'CY','39169','1952-08-22','F','M',':RET:2106-3','N','021','DEN','1633168','99734OH005000401','2014-01-01','2013-12-19 16:52:35','0.00',NULL,NULL,'31.57','31.57','R-OH014','OH0','0.00',NULL,0,'2013-12-25 23:04:32'),(16341,13080,'N','01','021','EC','A',NULL,NULL,'','0000910539','0000541656','','IL','1','CONRAD','CURT','W','','','34','403780172','4609 CREEKRUN DR',0,'MASON','OH','45040',NULL,'CY','39165','1968-06-30','M','',NULL,'N','021','DEN','2064786','99734OH005000301','2014-02-01','2014-01-06 12:31:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:13'),(15822,12666,'Y','18','021','EC','A','','','AC','0000640941','0000640941','OH00001559779','IL','1','Fitzgerald','Sean','','','','34','286888659','12427 FAIRHILL RD',0,'CLEVELAND','OH','44120','1015','CY','39035','1988-01-01','M','U',NULL,'N','021','DEN','2569888','99734OH005000401','2014-02-01','2014-01-02 12:56:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:03:33'),(15183,12133,'Y','18','021','EC','A','','','AC','0000380066','0000380066','OH00000837815','IL','1','Carson','David','','','','34','370061167','615 Second Street',0,'Bowling Green','OH','43402',NULL,'CY','39173','1987-11-18','M','U',':RET:2106-3','N','021','HLT','2316911','92036OH004002601','2014-02-01','2013-12-29 20:18:38','124.00',NULL,NULL,'160.55','36.55','R-OH001','OH0','160.55',NULL,0,'2014-01-01 12:06:52'),(5027,3984,'N','19','021','EC','A',NULL,NULL,'','0000194026','0001180996','','IL','1','Crehan','Henry',NULL,NULL,NULL,NULL,NULL,'7350 S TIMBERLANE DR',0,'CINCINNATI','OH','45243','1844','CY','39061','2009-02-15','M','',':RET:2106-3','N','021','HLT','141721','92036OH004001201','2014-01-01','2013-12-07 11:34:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 22:47:41'),(13921,11102,'Y','18','021','EC','A','','','AC','0001239125','0001239125','OH00000020400','IL','1','Gilbert','David','','','','34','290445530','2845 ELSIE AVE',0,'TOLEDO','OH','43613','3337','CY','39095','1949-11-15','M','M',':RET:2106-3','N','021','HLT','2326936','92036OH003002605','2014-01-01','2013-12-23 11:19:59','999.00',NULL,NULL,'1195.93','196.93','R-OH001','OH0','610.89',NULL,0,'2013-12-26 13:14:11'),(4582,3628,'Y','18','021','EC','A','','','AC','0000652100','0000652100','OH00001125851','IL','1','Rodriguez','Carmen','','','','34','287961896','1200 MORNINGVIEW DR',0,'TALLMADGE','OH','44278','1179','CY','39153','1993-07-31','F','U',NULL,'N','021','HLT','956034','52664OH151001306','2014-01-01','2013-12-11 22:42:02','84.00',NULL,NULL,'141.61','57.61','R-OH012','OH0','141.61',NULL,0,'2013-12-25 22:05:14'),(3690,2953,'N','01','021','EC','A',NULL,NULL,'','0001056674','0000358306','','IL','1','GOODMAN','TERI','SUE','','','34','287567305','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1959-12-18','F','',':RET:2106-3','N','021','DEN','321464','99734OH005000401','2014-01-01','2013-12-13 10:39:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:31:42'),(3195,2569,'N','01','021','EC','A',NULL,NULL,'','0000015736','0000016769','','IL','1','Polsky','David','Kurt','','','34','128608731','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','1978-01-04','M','',NULL,'N','021','DEN','150521','18575LA002000101','2014-01-01','2013-10-02 23:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 20:32:15'),(26330,20889,'N','01','021','EC','A',NULL,NULL,'','0001120983','0000740953','','IL','1','Sanders','Mercedes','','','','34','272947950','6433 TULANE RD',0,'HORN LAKE','MS','38637','2135','CY','28033','1989-09-23','F','',':RET:2106-3','N','021','DEN','3069836','46300MS002000101','2014-04-01','2014-02-27 17:04:46',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-28 06:31:40'),(29015,22964,'Y','18','021','EC','A','','','AC','0000976812','0000976812','OH00002634892','IL','1','AREGAY','AMANUEL','F','','','34','156231960','730 RIVERVIEW DR',0,'COLUMBUS','OH','43202',NULL,'CY','39049','1983-01-01','M','U',':RET:2054-5','N','021','DEN','3668699','99734OH005000401','2014-04-01','2014-03-09 23:23:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:01:26'),(4495,3562,'Y','18','021','EC','A','','','AC','0000542205','0000542205','TX00000077389','IL','1','montanez','stefanie','','','','34','639010774','100 NW 8th',0,'big spring','TX','79720',NULL,'CY','48227','1988-09-11','F','M',':RET:2106-3','N','021','DEN','397886','33348TX002000201','2014-01-01','2013-12-11 19:04:14','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:03:13'),(16110,12904,'Y','18','021','EC','A','','','AC','0000434502','0000434502','MS00001427431','IL','1','Jernigan','Jeremy','','','','34','587653224','2396 Mount Olive Road',0,'Louisville','MS','39339',NULL,'CY','28159','1989-06-07','M','U',':RET:2054-5','N','021','DEN','1829015','46300MS002000101','2014-02-01','2014-01-03 12:38:40','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-04 02:05:03'),(19066,15188,'Y','18','024','14','A','','','TE','0000938539','0000938539','','IL','1','Vasquez','Blanca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-05','F','',NULL,NULL,NULL,'','1438736','','2014-01-17','2014-01-17 19:03:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:44:17'),(24161,19198,'Y','18','021','EC','A','','','AC','0000397390','0000397390','OH00001963339','IL','1','Hamrich','Lynn','','','','34','300828963','3900 ONEIDA ST',0,'STOW','OH','44224','4217','CY','39153','1970-06-25','F','R',':RET:2106-3','N','021','HLT','3222274','52664OH151001501','2014-03-01','2014-02-14 20:52:17','0.00',NULL,NULL,'1076.28','1076.28','R-OH012','OH0','362.95',NULL,0,'2014-02-15 22:02:04'),(25401,20151,'Y','18','021','EC','A','','','AC','0000491933','0000491933','OH00001823505','IL','1','WEIMER','MICHAEL','LYNN','','','34','289824186','571 ETTER RD',0,'MOGADORE','OH','44260','9601','CY','39153','1984-10-25','M','U',':RET:2106-3','T','021','HLT','2627923','52664OH151001305','2014-04-01','2014-02-25 16:22:05','157.00',NULL,NULL,'286.98','129.98','R-OH012','OH0','286.98',NULL,0,'2014-02-25 21:30:56'),(25456,20196,'N','01','021','EC','A',NULL,NULL,'','0001114346','0000314388','','IL','1','GOMEZ','COSME','','','Sr','34','457756263','5815 W MILE 5 RD',0,'MISSIO N','TX','78574',NULL,'CY','48215','1977-05-06','M','',NULL,'T','021','DEN','3630042','33348TX002000201','2014-04-01','2014-02-25 14:06:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:28'),(28777,22779,'Y','18','021','EC','A','','','AC','0001235249','0001235249','OH00003154197','IL','1','brisbine','stephen','','','','34','278526317','5031 piccadilly st sw',0,'canton','OH','44706',NULL,'CY','39151','1952-01-18','M','U',':RET:2106-3','N','021','DEN','2779449','99734OH005000401','2014-05-01','2014-03-09 13:33:52','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-09 21:00:33'),(6057,4798,'N','01','021','EC','A',NULL,NULL,'','0000043198','0001049340','','IL','1','Carr','Melinda','','','','34','234191579','7945 ROYALTON RD SW',0,'LANCASTER','OH','43130','9238','CY','39045','1977-12-09','F','',':RET:2106-3','N','021','DEN','715076','99734OH005000401','2014-01-01','2013-11-30 18:23:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:01:51'),(16069,12868,'N','01','021','EC','A',NULL,NULL,'','0000783243','0000461946','','IL','1','HEY','PETER','','','','34','404154493','1462 DELYNN DR',0,'DAYTON','OH','45459','5417','CY','39113','1949-07-13','M','',':RET:2028-9','N','021','DEN','1955689','99734OH005000401','2014-02-01','2014-01-03 11:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:03:45'),(14115,11249,'Y','18','021','EC','A','','','AC','0000902212','0000902212','OH00000744200','IL','1','Mathews','Elizabeth','Ann','','','34','269541175','9340 RORYANNA DR',0,'CHARDON','OH','44024','8669','CY','39055','1955-01-25','F','M',':RET:2106-3','N','021','DEN','2399303','99734OH005000401','2014-02-01','2013-12-26 14:24:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:57'),(3844,3075,'Y','18','021','EC','A','','','AC','0000661712','0000661712','LA00000767663','IL','1','Keithly','Kevin','','','','34','230135482','9555 JOOR RD',0,'BATON ROUGE','LA','70818','4910','CY','22033','1966-08-12','M','U',':RET:2106-3','T','021','DEN','1039827','18575LA002000101','2014-01-01','2013-12-13 09:02:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 21:35:27'),(9486,7523,'Y','18','021','EC','A','','','AC','0000337605','0000337605','OH00000186346','IL','1','Nagy','Pamela','jo','','','34','272461400','5794  Observation Court',0,'Milford','OH','45150',NULL,'CY','39025','1953-11-05','F','M',':RET:2106-3','N','021','DEN','1445381','99734OH005000401','2014-01-01','2013-12-21 12:57:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:34:47'),(7868,6226,'N','19','021','EC','A',NULL,NULL,'','0000328405','0001005703','','IL','1','Miller','Katherine','L','','','34','273085101','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','2002-12-04','F','',':RET:2106-3','N','021','DEN','2279031','99734OH005000301','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:09'),(18671,14884,'N','01','021','EC','A',NULL,NULL,'','0000911033','0000196416','','IL','1','Garcia','Maria','','','','34','595566156','6521 CARLTON SPEED RANCH RD',0,'WALLER','TX','77484','6615','CY','48185','1968-10-13','F','',NULL,'N','021','DEN','2628326','33348TX002000201','2014-03-01','2014-01-16 18:21:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:17'),(19641,15654,'Y','18','021','EC','A','','','AC','0000509235','0000509235','OH00001631660','IL','1','hildreth','angel','marie priscilla','','','34','004765074','674 BRISTOL CHAMPION TOWNLINE RD NE',0,'BRISTOLVILLE','OH','44402',NULL,'CY','39155','1974-11-25','F','M',NULL,'T','021','DEN','3081676','99734OH005000401','2014-03-01','2014-01-23 14:22:39','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-01-23 21:00:15'),(20485,16365,'Y','18','021','EC','A','','','AC','0000390926','0000390926','OH00002163187','IL','1','DICKINSON','JODI','','','','34','293683275','578 US HIGHWAY 250',0,'GREENWICH','OH','44837','9518','CY','39005','1964-11-15','F','U',':RET:2106-3','T','021','HLT','3061869','52664OH151001305','2014-03-01','2014-01-29 15:14:53','312.00',NULL,NULL,'437.52','125.52','R-OH012','OH0','437.52',NULL,0,'2014-01-29 21:01:03'),(20542,16415,'Y','18','021','EC','A','','','AC','0000637144','0000637144','OH00001846636','IL','1','Barhite','Karen','','','','34','283420855','2329 GLENROSE LN',0,'MAUMEE','OH','43537','1112','CY','39095','1953-03-08','F','M',':RET:2106-3','N','021','HLT','3554285','92036OH006002601','2014-03-01','2014-01-29 11:15:19','86.00',NULL,NULL,'419.70','333.70','R-OH001','OH0','419.70',NULL,0,'2014-01-29 21:01:36'),(24542,19495,'Y','18','021','EC','A','','','AC','0000700436','0000700436','OH00002873566','IL','1','Wingo','Cerra','','','','34','283845987','750 MULL AVE',0,'AKRON','OH','44313','7561','CY','39153','1985-11-27','F','U',':RET:1002-5^:RET:2054-5','N','021','HLT','3299255','52664OH151001305','2014-04-01','2014-02-18 20:59:47','126.00',NULL,NULL,'242.41','116.41','R-OH012','OH0','242.41',NULL,0,'2014-02-20 04:02:51'),(14886,11888,'N','01','021','EC','A',NULL,NULL,'','0002349629','0001956082','','IL','1','Williams','Jacqueline','','','','34','434114988','5613 OLD BOYCE RD',0,'BOYCE','LA','71409','9202','CY','22079','1963-01-17','F','',':RET:2054-5','N','021','DEN','2554408','18575LA002000201','2014-02-01','2013-12-28 18:29:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-30 00:00:39'),(19720,15715,'Y','18','021','EC','A','','','AC','0000105401','0000105401','OH00002548849','IL','1','EHRHARDT','AMANDA','','','','34','284920559','1835 STRATHMOOR AVE',0,'TOLEDO','OH','43614','3922','CY','39095','1990-03-27','F','M',NULL,'N','021','HLT','2721714','92036OH004002601','2014-03-01','2014-01-23 15:00:16','0.00',NULL,NULL,'156.79','156.79','R-OH001','OH0','156.79',NULL,0,'2014-01-23 21:00:58'),(22501,17962,'N','01','021','EC','A',NULL,NULL,'','0000807535','0001201932','','IL','1','GAO','WENGANG','','','','34','321894581','1210 ASHMORE CT',0,'CINCINNATI','OH','45231','5590','CY','39061','1967-10-06','M','',':RET:2034-7','N','021','DEN','3526612','99734OH005000301','2014-03-01','2014-02-10 15:15:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:13'),(22512,17972,'Y','18','021','EC','A','','','AC','0001154009','0001154009','TX00002111893','IL','1','FIGUEROA','DIEGO','','','','34','758290770','912 N YALE DR',0,'EDINBURG','TX','78541',NULL,'CY','48215','1989-07-27','M','U',':RET:2106-3','N','021','DEN','2994910','33348TX002000101','2014-03-01','2014-02-09 19:44:56','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-02-10 21:31:19'),(22751,18163,'Y','18','024','14','A','','','TE','0001757836','0001757836','','IL','1','Jennings','Laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-05','F','',NULL,NULL,NULL,'','3299014','','2014-02-11','2014-02-11 12:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-11 21:01:26'),(24333,19324,'Y','18','021','EC','A','','','AC','0001133295','0001133295','TX00002225504','IL','1','Nguyen','Bau','','','','34','634267585','4143 LUFBOROUGH DR',0,'HOUSTON','TX','77066','3505','CY','48201','1953-03-30','F','M',':RET:2047-9','N','021','DEN','3509738','33348TX002000201','2014-04-01','2014-02-18 13:41:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-18 22:00:14'),(1864,1522,'N','01','021','EC','A',NULL,NULL,'','0001230390','0000216108','','IL','1','Wilke','Pamela','R','','','34','293868611','9336 BRYANT RD',0,'WINDHAM','OH','44288','9547','CY','39133','1975-06-15','F','',':RET:2106-3','N','021','HLT','2563089','52664OH152000901','2014-01-01','2013-12-24 10:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.52',NULL,0,'2013-12-25 18:58:10'),(6369,5050,'Y','18','021','EC','A','','','AC','0001227005','0001227005','OH00000062250','IL','1','Phillips','Deborah','','','','34','299508657','7340 Cayman Way',0,'Maineville','OH','45039',NULL,'CY','39165','1951-07-31','F','U',':RET:2054-5','T','021','DEN','1026823','99734OH005000301','2014-01-01','2013-12-10 23:13:49','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:47:35'),(5815,4620,'Y','18','021','EC','A','','','AC','0000876732','0000876732','TX00000581471','IL','1','Ghneim','Said','Nimr','','','34','446780204','5807 MANCHESTER DR',0,'RICHARDSON','TX','75082','2709','CY','48085','1953-11-15','M','M',':RET:2106-3','N','021','DEN','1632313','33348TX002000201','2014-01-01','2013-12-23 21:56:43','0.00',NULL,NULL,'63.40','63.40','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:47:53'),(23887,19002,'Y','18','021','EC','A','','','AC','0000217651','0000217651','OH00002305507','IL','1','Jackson','Edward','','','','34','277582449','6955 EDENTON PLEASANT PLAIN RD',0,'PLEASANT PLAIN','OH','45162','9633','CY','39025','1957-03-23','M','M',':RET:2106-3','N','021','HLT','3664199','92036OH003000605','2014-03-01','2014-02-14 08:08:17','737.00',NULL,NULL,'1001.64','264.64','R-OH005','OH0','523.01',NULL,0,'2014-02-14 21:32:16'),(27697,21904,'N','01','021','EC','A',NULL,NULL,'','0001224477','0000569280','','IL','1','wiley','trina','','','','34','620421624','2315 w park ave',0,'corsicana','TX','75110',NULL,'CY','48349','1988-04-27','F','',':RET:2106-3','N','021','DEN','3927000','33348TX002000201','2014-04-01','2014-03-05 11:48:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:47'),(28660,22679,'Y','18','021','EC','A','','','AC','0002318782','0002318782','LA00003530515','IL','1','LEJEUNE','CHRISTINA','','','','34','051662792','517 N 1ST ST',0,'VILLE PLATTE','LA','70586','6965','CY','22039','1981-06-15','F','M',':RET:2054-5','N','021','DEN','4008684','18575LA002000201','2014-04-01','2014-03-07 19:31:05','0.00',NULL,NULL,'52.83','52.83','R-LA003','LA0','14.61',NULL,0,'2014-03-08 21:30:43'),(22483,17950,'Y','18','021','EC','A','','','AC','0000092560','0000092560','OH00001390702','IL','1','Black','Terri','','','','34','293428695','625 5TH AVE',0,'FOSTORIA','OH','44830','2772','CY','39147','1958-09-23','F','U',':RET:2106-3','N','021','DEN','3431527','99734OH005000301','2014-03-01','2014-02-10 08:43:28','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-10 21:31:04'),(2240,1841,'Y','18','021','EC','A','','','AC','0000711345','0000711345','OH00000514069','31','1','Perryman','Tracee','','','','34','276768243','P. O. Box 5308',0,'Toledo','OH','43611',NULL,'CY','39095','1978-11-27','F','U',':RET:2054-5','N','021','HLT','819538','92036OH002002601','2014-01-01','2013-12-10 16:40:39','0.00',NULL,NULL,'275.16','275.16','R-OH001','OH0','275.16',NULL,0,'2013-12-25 19:21:00'),(6832,5415,'Y','18','021','EC','A','','','AC','0000085133','0000085133','OH00000663725','IL','1','Singleton','Mary','','','','34','556024507','674 Stafford Dr',0,'Hamilton','OH','45013',NULL,'CY','39017','1954-06-29','F','M',':RET:2106-3','T','021','DEN','1215163','99734OH005000401','2014-01-01','2013-11-14 07:41:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:30:50'),(22048,17599,'Y','18','021','EC','A','','','AC','0000772687','0000772687','OH00002002942','IL','1','Fisher','Aaron','','','','34','291885283','18383 STATE ROUTE 49',0,'WILLSHIRE','OH','45898','9780','CY','39161','1988-02-20','M','U',':RET:2106-3','N','021','HLT','2971838','92036OH004001501','2014-03-01','2014-02-06 23:14:11','120.00',NULL,NULL,'181.21','61.21','R-OH002','OH0','181.21','CIC',0,'2014-02-07 19:30:05'),(6532,5179,'Y','18','021','EC','A','','','AC','0000222927','0000222927','TX00001164488','IL','1','Rodriguez','Amber','','','','34','463796092','1306 PRINCE DR',0,'CORPUS CHRISTI','TX','78412','4027','CY','48355','1986-09-30','F','U',':RET:2106-3','N','021','DEN','94567','33348TX002000201','2014-01-01','2013-12-10 21:18:48','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 00:51:41'),(6247,4950,'Y','18','021','EC','A','','','AC','0000637253','0000637253','LA00000195837','IL','1','MULLIN','ZINA','S','','','34','433417524','3804 GLENOAK DR',0,'HARVEY','LA','70058','1919','CY','22051','1965-08-14','F','U',':RET:2054-5','N','021','DEN','99267','18575LA002000201','2014-01-01','2013-11-19 15:16:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:31:50'),(21944,17524,'Y','18','021','EC','A','','','AC','0000238511','0000238511','TX00001787591','IL','1','Mascarenhas','Irene','','','','34','353989518','1314 MEREDITH DR',0,'ALLEN','TX','75002','3615','CY','48085','1950-08-24','F','M',':RET:2029-7','N','021','DEN','3215458','33348TX002000201','2014-03-01','2014-02-07 17:22:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-07 19:00:17'),(19305,15388,'N','01','021','EC','A',NULL,NULL,'','0001634957','0002240774','','IL','1','Hemenway','Robin','','','','34','438193690','59330 SEXTON DR',0,'PLAQUEMINE','LA','70764','6575','CY','22047','1962-11-25','F','',':RET:2106-3','N','021','DEN','2964841','18575LA002000101','2014-03-01','2014-01-21 13:00:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,1,'2014-01-22 03:22:02'),(18397,14680,'N','19','021','EC','A',NULL,NULL,'','0000505755','0001214824','','IL','1','Smith','Azlan','A','','','34','578392866','11817 Crofton Road',0,'Garfield Heights','OH','44125',NULL,'CY','39035','2005-02-01','F','',':RET:2106-3','N','021','DEN','2210292','99734OH005000301','2014-02-01','2014-01-15 17:10:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:41'),(18166,14506,'N','01','021','EC','A',NULL,NULL,'','0000748205','0001208325','','IL','1','Dean','Shane','Herrmann','','','34','022668558','3715 West US Highway 22',0,'Wilmington','OH','45177',NULL,'CY','39027','1974-02-09','M','',':RET:2106-3','T','021','HLT','1734468','92036OH005000606','2014-02-01','2014-01-14 10:33:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-01-15 02:07:55'),(8962,7110,'Y','18','021','EC','A','','','AC','0000610852','0000610852','OH00001121409','IL','1','carter','rebecca','','','','34','279581442','140 S MAIN ST',0,'SPRINGBORO','OH','45066','1600','CY','39165','1963-11-22','F','M',':RET:2106-3','N','021','DEN','1610234','99734OH005000401','2014-01-01','2013-12-18 13:29:15','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:52'),(9361,7421,'Y','18','021','EC','A','','','AC','0001554335','0001554335','LA00001177547','IL','1','Pearson','Sandra','','','','34','436783523','2215 GENERAL CLEBURNE AVE',0,'BATON ROUGE','LA','70810','6867','CY','22033','1950-01-10','F','U',':RET:2054-5','N','021','DEN','2225265','18575LA002000201','2014-01-01','2013-12-21 10:43:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:33'),(14767,11790,'Y','18','021','EC','A','','','AC','0001256748','0001256748','TX00000882519','IL','1','cao','sophia','','','','34','465531754','2609 SUNSTONE LN',0,'PEARLAND','TX','77584','3246','CY','48039','1959-08-14','F','U',':RET:2047-9','N','021','DEN','1605444','33348TX002000201','2014-01-01','2013-12-23 19:49:50','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2013-12-29 11:12:50'),(23701,18872,'N','01','021','EC','A',NULL,NULL,'','0000616874','0000609581','','IL','1','MCCARTHY','LAURA','','','','34','302769215','3386 PALMHILL LN',0,'CINCINNATI','OH','45239','7162','CY','39061','1965-06-10','F','',NULL,'T','021','DEN','3576493','99734OH005000401','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:42'),(25441,20186,'Y','18','021','EC','A','','','AC','0000617423','0000617423','TX00002370335','IL','1','MOLINA','CARMEN','T','','','34','457947030','3694 HAWTHORNE TRL',0,'ROCKWALL','TX','75032','9209','CY','48397','1949-06-22','F','M',NULL,'N','021','DEN','3126449','33348TX002000201','2014-04-01','2014-02-25 11:18:40','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-25 21:31:20'),(27242,21571,'Y','18','021','EC','A','','','AC','0000784423','0000784423','OH00002443499','IL','1','Owens','Tina','','','','34','279620409','2470 A State Rt 756',0,'Moscow','OH','45153',NULL,'CY','39025','1968-01-20','F','U',NULL,'N','021','HLT','3970552','92036OH004000601','2014-04-01','2014-03-03 11:28:32','340.00',NULL,NULL,'431.52','91.52','R-OH005','OH0','258.91',NULL,0,'2014-03-03 21:31:48'),(418,343,'Y','18','021','EC','A','','','AC','0000404772','0000404772','OH00000519778','IL','1','BURROUGHS','DAVID','','','','34','510607244','2204 FELDMAN AVE',0,'CINCINNATI','OH','45212','1519','CY','39061','1954-10-25','M','U',':RET:2106-3','N','021','DEN','1152946','99734OH005000401','2014-01-01','2013-12-03 21:12:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:46:33'),(23163,18466,'Y','18','021','EC','A','','','AC','0000081116','0000081116','TX00001599200','IL','1','Kennedy','Steven','','','','34','425558352','3742 Whitehall dr',0,'Dallas','TX','75229',NULL,'CY','48113','1986-06-09','M','U',':RET:2106-3','N','021','DEN','2937118','33348TX002000101','2014-03-01','2014-02-12 17:00:19','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-12 21:31:48'),(21173,16921,'Y','18','021','EC','A','','','AC','0000117831','0000117831','OH00001375742','IL','1','Caputo','Corey','','','','34','281945378','236 E TULANE RD',0,'COLUMBUS','OH','43202','2224','CY','39049','1989-04-06','F','M',':RET:2106-3','N','021','DEN','3548408','99734OH005000401','2014-03-01','2014-02-03 14:39:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-03 21:00:39'),(20303,16208,'Y','18','021','EC','A','','','AC','0000528383','0000528383','TX00002001652','IL','1','LOZANO','BLANCA','','','','34','467979227','17 N COLIMA ST',0,'ROMA','TX','78584','8528','CY','48427','1958-09-26','F','M',NULL,'N','021','DEN','3469155','33348TX002000201','2014-03-01','2014-01-28 10:30:01','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-28 21:00:45'),(19401,15468,'Y','18','021','EC','A','','','AC','0001195530','0001195530','OH00002334920','IL','1','PALL','ELIZABETH','','','','34','049564548','7351 DUNMORE CT',0,'WEST CHESTER','OH','45069','4947','CY','39017','1970-12-26','F','U',NULL,'N','021','DEN','2481566','99734OH005000401','2014-03-01','2014-01-21 12:51:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-22 03:22:53'),(19156,15262,'Y','18','021','EC','A','','','AC','0000679557','0000679557','OH00001716517','IL','1','Cook','Julie','','','','34','275644222','500 Coventry Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1971-05-06','F','U',':RET:2106-3','N','021','HLT','3092957','92036OH005001501','2014-03-01','2014-01-19 10:53:15','0.00',NULL,NULL,'291.62','291.62','R-OH002','OH0','291.62',NULL,0,'2014-01-21 08:45:38'),(13732,10959,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00000602733','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','2144754','52664OH151001305','2014-01-01','2013-12-23 18:22:59','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:27'),(9101,7224,'Y','18','021','EC','A','','','AC','0001080313','0001080313','OH00001217924','IL','1','Barlow','Jerry','','','','34','301547929','1484 JONQUILMEADOW DR',0,'CINCINNATI','OH','45240','2940','CY','39061','1953-12-09','M','U',':RET:2106-3','N','021','DEN','2336950','99734OH005000301','2014-01-01','2013-12-18 14:43:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:07:23'),(24006,19090,'Y','18','021','EC','A','','','AC','0000524537','0000524537','OH00002593664','IL','1','Reinhart','Hannah','','','','34','220254888','41 CHAPEL HILL DR',0,'FAIRFIELD','OH','45014','5282','CY','39061','1989-11-22','F','U',':RET:2106-3','N','021','DEN','3390268','99734OH005000401','2014-03-01','2014-02-15 11:09:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:36'),(28350,22431,'Y','18','021','EC','A','','','AC','0000232163','0000232163','TX00002851204','IL','1','YEUNG','MINOON','','','','34','431392465','1702 BUTTERCUP CREEK BLVD',0,'CEDAR PARK','TX','78613',NULL,'CY','48491','1963-03-12','F','U',':RET:2028-9','N','021','DEN','3976602','33348TX002000201','2014-04-01','2014-03-07 12:54:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-07 21:30:22'),(1742,1445,'N','01','021','EC','A',NULL,NULL,'','0000743090','0000329648','','IL','1','George','Brenda','R','','','34','302548592','12489 STATE ROUTE 41 S',0,'GREENFIELD','OH','45123','9390','CY','39141','1954-04-17','F','',':RET:2106-3','N','021','DEN','2491941','99734OH005000301','2014-01-01','2013-12-24 11:25:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:33'),(3327,2669,'Y','18','021','EC','A','','','AC','0001157560','0001157560','OH00000644257','IL','1','Jensen','Scott','','','','34','023684488','5660 Chesapeake Way',0,'Farfield','OH','45014',NULL,'CY','39017','1973-09-02','M','U',':RET:2106-3','N','021','DEN','2229429','99734OH005000301','2014-01-01','2013-12-22 17:06:14','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:16:12'),(17254,13806,'Y','18','021','EC','A','','','AC','0000257142','0000257142','OH00002381831','IL','1','Rodgers','Nancy','','','','34','290505537','12231 US HIGHWAY 50',0,'HILLSBORO','OH','45133','9727','CY','39071','1950-09-22','F','U',':RET:2106-3','N','021','DEN','1926867','99734OH005000301','2014-02-01','2014-01-10 10:53:00','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-01-13 02:23:13'),(7260,5756,'Y','18','021','EC','A','','','AC','0001097688','0001097688','TX00000429054','31','1','Graham','Clinton','','','','34','386980417','4833 Saratoga Blvd.',0,'Corpus Christi','TX','78413',NULL,'CY','48355','1978-05-17','M','R',':RET:2054-5','T','021','DEN','203419','33348TX002000201','2014-01-01','2013-12-13 19:45:45','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 02:02:07'),(7113,5643,'Y','18','021','EC','A','','','AC','0001975741','0001975741','LA00001532257','IL','1','Lane','Elizabeth','','','','34','460916539','1855 PECK DR',0,'BATON ROUGE','LA','70810','3362','CY','22033','1974-05-07','F','U',':RET:2106-3','N','021','DEN','1663569','18575LA002000101','2014-01-01','2013-12-24 23:29:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 01:51:06'),(5627,4466,'Y','18','021','EC','A','','','AC','0000612960','0000612960','OH00000506762','IL','1','Holloway','Douglas','','','','34','299600256','5091 ELNO AVE',0,'AKRON','OH','44319','4931','CY','39153','1962-10-14','M','M',':RET:2106-3','N','021','DEN','223737','99734OH005000401','2014-01-01','2013-11-26 11:14:33','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:30:56'),(9513,7544,'N','01','021','EC','A',NULL,NULL,'','0000122972','0000051916','','IL','1','Thompson','Dallas',NULL,NULL,NULL,NULL,NULL,'856 S BROADLEIGH RD',0,'COLUMBUS','OH','43209','2504','CY','39049','1973-04-06','M','',':RET:2106-3','N','021','DEN','2571889','99734OH005000401','2014-01-01','2013-12-21 17:12:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:27'),(24511,19472,'Y','18','021','EC','A','','','AC','0000796061','0000796061','TX00002251058','IL','1','TROTT','MARY','M','','','34','005546985','196 RAINBOW DRIVE',0,'LIVINGSTON','TX','77399',NULL,'CY','48373','1952-11-30','F','M',':RET:2106-3','N','021','DEN','3129864','33348TX002000201','2014-04-01','2014-02-19 10:09:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 03:53:31'),(25490,20220,'N','01','021','EC','A',NULL,NULL,'','0000446825','0000995121','','IL','1','WELLS','ANGELA','','','','34','426531296','10490 ROAD 773',0,'PHILADELPHIA','MS','39350',NULL,'CY','28099','1970-02-04','F','',':RET:2106-3','N','021','DEN','3637743','46300MS002000201','2014-04-01','2014-02-25 12:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-25 21:31:47'),(26920,21335,'N','19','021','EC','A',NULL,NULL,'','0001190120','0000740343','','S1','1','Hamric','Craig','Allen','','','34','270067040','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','2000-10-02','F','',':RET:2106-3','N','021','DEN','3289675','99734OH005000401','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:15'),(13378,10682,'N','19','021','EC','A',NULL,NULL,'','0000110519','0000175098','','S1','1','jakupca','jason','','','','34','288155744','9418 DOROTHY AVE',0,'GARFIELD HEIGHTS','OH','44125','1417','CY','39035','2009-11-14','F','',NULL,'N','021','DEN','2538334','99734OH005000301','2014-01-01','2013-12-22 22:57:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:52'),(9269,7353,'Y','18','021','EC','A','','','AC','0000511928','0000511928','OH00001033152','IL','1','Ryan','Corey','','','','34','276901271','8111 CAMNER AVE',0,'CINCINNATI','OH','45236','2713','CY','39061','1983-10-28','M','U',':RET:2106-3','T','021','DEN','723369','99734OH005000401','2014-01-01','2013-11-30 11:19:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:15:35'),(6908,5482,'Y','18','021','EC','A','','','AC','0001934457','0001934457','LA00000366008','IL','1','Poche','John','','','','34','438863749','44 ALLARD BLVD',0,'NEW ORLEANS','LA','70119','3706','CY','22071','1958-01-03','M','M',':RET:2106-3','N','021','DEN','1453048','18575LA002000201','2014-02-01','2013-12-25 00:08:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:50'),(3139,2524,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-17 19:21:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 20:30:46'),(6554,5196,'Y','18','021','EC','A','','','AC','0000632290','0000632290','TX00001251756','IL','1','LEE','ZEING','SHIOU','','','34','238492550','1625 AVENUE P',0,'HUNTSVILLE','TX','77340',NULL,'CY','48471','1961-10-26','M','M',':RET:2028-9','N','021','DEN','450537','33348TX002000201','2014-01-01','2013-12-11 12:53:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:15'),(3978,3177,'N','19','021','EC','A',NULL,NULL,'','0000971452','0000254517','','IL','1','King','Jordyn','Ashlee','','','34','273178476','910 CORNELL DR',0,'LIMA','OH','45805','1622','CY','39003','2011-02-22','F','',':RET:2106-3','N','021','HLT','155695','92036OH003001504','2014-01-01','2013-12-13 12:17:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 21:38:46'),(4577,3624,'N','01','021','EC','A',NULL,NULL,'','0000560376','0000511402','','IL','1','Wilkins','Daphanie','','','','34','437298977','808 COUNTY ROAD 4777',0,'TIMPSON','TX','75975','3200','CY','48419','1976-04-10','F','',':RET:2106-3','N','021','DEN','579070','33348TX002000101','2014-01-01','2013-12-12 17:36:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 22:05:06'),(1147,945,'Y','18','021','EC','A','','','AC','0000818239','0000818239','LA00001221122','IL','1','Brown','Summer','','','','34','437798561','5122 BRADLEY ST',0,'BATON ROUGE','LA','70805','7013','CY','22033','1988-03-24','F','U',':RET:2054-5','N','021','DEN','36727','18575LA002000201','2014-01-01','2013-12-03 13:54:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:30'),(155,129,'Y','18','021','EC','A','','','AC','0000225787','0000225787','TX00000898269','IL','1','Escobar','Melissa','','','','34','460714668','1434 PLAZA ROJA CT',0,'EL PASO','TX','79912','8449','CY','48141','1969-03-03','F','M',':RET:2106-3','N','021','DEN','529926','33348TX002000101','2014-01-01','2013-12-05 16:27:24','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2013-12-25 17:19:01'),(22223,17739,'Y','18','021','EC','A','','','AC','0000812006','0000812006','OH00002055149','IL','1','HENDRICK','JOELLE','','','','34','097385435','1467 EDGEMOOR AVE',0,'AKRON','OH','44313','7413','CY','39153','1950-03-02','F','U',':RET:2106-3','N','021','HLT','3837879','52664OH151001305','2014-03-01','2014-02-09 14:24:30','512.00',NULL,NULL,'658.32','146.32','R-OH012','OH0','658.32',NULL,0,'2014-02-09 19:00:27'),(7321,5802,'N','19','021','EC','A',NULL,NULL,'','0000566077','0000890750','','IL','1','dobbs','candy','lee','','','34','424476244','648 lakewood cove',0,'brandon','MS','39042',NULL,'CY','28121','1998-04-07','F','',':RET:2106-3','N','021','DEN','754977','46300MS002000201','2014-01-01','2013-12-14 10:58:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2013-12-26 02:03:37'),(21081,16846,'Y','18','024','14','A','','','TE','0001034633','0001034633','','IL','1','Solari','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-20','F','',NULL,NULL,NULL,'','913482','','2014-02-01','2014-02-01 21:17:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-02 19:00:22'),(4923,3906,'Y','18','021','EC','A','','','AC','0001217354','0001217354','OH00001278644','IL','1','Whitman','Donald','','','','34','288500706','10568 CHARNEY AVE NW',0,'UNIONTOWN','OH','44685','9404','CY','39151','1956-10-24','M','M',':RET:2106-3','N','021','HLT','573912','52664OH151001305','2014-01-01','2013-12-07 14:12:59','763.00',NULL,NULL,'1063.75','300.75','R-OH015','OH0','543.47',NULL,0,'2013-12-25 22:45:13'),(3507,2818,'Y','18','021','EC','A','','','AC','0000340289','0000340289','OH00000024250','IL','1','Sikora','Diane','M','','','34','299663175','6079 FLEMINGTON RD',0,'DAYTON','OH','45459','1901','CY','39113','1960-08-08','F','M',':RET:2106-3','N','021','DEN','1925020','99734OH005000401','2014-01-01','2013-12-22 18:17:06','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:53'),(4150,3307,'N','01','021','EC','A',NULL,NULL,'','0000706180','0000649364','','IL','1','Smith','Jodi','Marie','','','34','298782025','8883 HARAD CT',0,'MACEDONIA','OH','44056','2424','CY','39153','1966-09-29','F','',':RET:2106-3','N','021','DEN','1966643','99734OH005000301','2014-01-01','2013-12-17 13:21:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:44'),(20907,16711,'Y','18','021','EC','A','','','AC','0000071674','0000071674','OH00001418297','IL','1','JACKSON','ROSE','','','','34','277643180','782 E 130TH ST',0,'CLEVELAND','OH','44108','2544','CY','39035','1960-03-16','F','U',NULL,'N','021','DEN','2346361','99734OH005000401','2014-03-01','2014-01-31 16:47:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-31 21:01:25'),(13319,10634,'Y','18','021','EC','A','','','AC','0000796945','0000796945','TX00000771011','IL','1','Saeger','Kimberly','','','','34','525134175','360 WAGON XING',0,'UNIVERSAL CITY','TX','78148','3634','CY','48029','1966-02-14','F','U',':RET:2106-3','N','021','DEN','2482222','33348TX002000201','2014-01-01','2013-12-23 16:36:03','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:58:18'),(18029,14401,'Y','18','021','EC','A','','','AC','0000995457','0000995457','OH00001712685','IL','1','Leever','Carol','','','','34','287645274','5816 HIGH ST',0,'CINCINNATI','OH','45227','3518','CY','39061','1959-05-08','F','U',':RET:2106-3','N','021','DEN','2337921','99734OH005000301','2014-02-01','2014-01-14 15:23:18','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:07:07'),(16295,13046,'Y','18','021','EC','A','','','AC','0002381179','0002381179','LA00001773948','IL','1','sterling','shane','','','','34','436232902','402 WARRINGTON DR',0,'NEW ORLEANS','LA','70122','3040','CY','22071','1970-12-22','M','U',':RET:2054-5','N','021','DEN','2066251','18575LA002000201','2014-02-01','2014-01-06 12:40:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:00'),(15288,12223,'Y','18','021','EC','A','','','AC','0000964342','0000964342','MS00001750848','IL','1','Breland','Gina','','','','34','437579290','111 Lakeshore Dr',0,'Brandon','MS','39047',NULL,'CY','28121','1976-08-18','F','U',':RET:2106-3','N','021','DEN','2077389','46300MS002000101','2014-02-01','2014-01-01 14:58:11','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:22:21'),(22636,18075,'N','01','021','EC','A',NULL,NULL,'','0000098709','0000962446','','IL','1','PEREZ PINEDA','ARTURO','','','','34','538115539','2720 63RD ST',0,'LUBBOCK','TX','79413','5822','CY','48303','1960-05-13','M','',NULL,'N','021','DEN','3675866','33348TX002000201','2014-03-01','2014-02-11 09:52:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:20'),(24440,19413,'Y','18','021','EC','A','','','AC','0001074194','0001074194','OH00002088729','IL','1','bailey','sabrina',NULL,NULL,NULL,NULL,NULL,'1400 W MARKET ST',0,'CELINA','OH','45822','8212','CY','39107','1970-11-02','F','U',NULL,'N','021','HLT','2892229','92036OH006001501','2014-04-01','2014-02-18 09:32:02','126.00',NULL,NULL,'236.85','110.85','R-OH002','OH0','236.85',NULL,0,'2014-02-18 22:01:19'),(25302,20073,'N','19','021','EC','A',NULL,NULL,'','0000270056','0000759740','','IL','1','CLARKE','LAUREN','','','','34','283943826','4205 HEGNER AVE',0,'CINCINNATI','OH','45236','3614','CY','39061','1991-09-28','F','',':RET:2106-3','N','021','DEN','3253499','99734OH005000401','2014-04-01','2014-02-25 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:28'),(27595,21824,'Y','18','024','14','A','','','TE','0000749581','0000749581','','IL','1','WILSON','EZEKIEL','LESLIE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-01-08','M','',NULL,NULL,NULL,'','3629746','','2014-03-31','2014-03-05 09:03:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-05 21:00:19'),(28064,22208,'Y','18','021','EC','A','','','AC','0000227118','0000227118','OH00003543494','IL','1','JAMES','MICHAEL','WAYNE','','','34','302644386','221 WASHINGTON AVE',0,'GREENVILLE','OH','45331',NULL,'CY','39037','1964-03-28','M','U',':RET:2106-3','N','021','DEN','2774521','99734OH005000301','2014-04-01','2014-03-06 11:48:31','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-06 21:01:45'),(1403,1165,'Y','18','021','EC','A','','','AC','0001610446','0001610446','LA00000620726','IL','1','Collignon','Robert','','','','34','435434879','3176 CAREY ST',0,'SLIDELL','LA','70458','4602','CY','22103','1977-06-13','M','U',':RET:2106-3','T','021','DEN','2222925','18575LA002000201','2014-01-01','2013-12-24 12:30:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:40'),(20939,16735,'Y','18','021','EC','A','','','AC','0000780544','0000780544','OH00002609828','IL','1','Patel','Stacy','L','','','34','405042899','1839 CLOUGH PIKE',0,'BATAVIA','OH','45103','2621','CY','39025','1973-11-30','F','M',':RET:2106-3','N','021','HLT','3477931','92036OH003000604','2014-03-01','2014-01-31 16:20:46','420.00',NULL,NULL,'868.28','448.28','R-OH005','OH0','286.51',NULL,0,'2014-01-31 21:01:42'),(19430,15489,'Y','18','021','EC','A','','','AC','0000893179','0000893179','OH00001386595','IL','1','VARGO','DEBORAH','LEE','','','34','287541072','1 S HAMILTON ST',0,'MONROEVILLE','OH','44847',NULL,'CY','39077','1954-07-25','F','U',':RET:2106-3','N','021','HLT','2931938','92036OH003002705','2014-03-01','2014-01-21 16:38:55','440.00',NULL,NULL,'530.07','90.07','R-OH006','OH0','530.07',NULL,1,'2014-01-22 03:23:07'),(7037,5588,'N','01','021','EC','A',NULL,NULL,'','0000022226','0000088440','','IL','1','Castillo','Lucia','','','','34','370605016','3326 JAMAICA WAY',0,'MESQUITE','TX','75150','1719','CY','48113','1953-02-08','F','',':RET:2106-3','N','021','DEN','1737715','33348TX002000201','2014-01-01','2013-12-24 23:52:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:49:17'),(17327,13860,'Y','18','021','EC','A','','','AC','0002385938','0002385938','LA00002095342','IL','1','Wahl','Erik','Saunders','','','34','044849242','4723 S LIBERTY ST',0,'NEW ORLEANS','LA','70115','5953','CY','22071','1981-07-01','M','U',':RET:2106-3','T','021','DEN','2259785','18575LA002000201','2014-02-01','2014-01-09 19:29:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:23:54'),(14591,11646,'Y','18','021','EC','A','','','AC','0000960613','0000960613','OH00001103859','IL','1','rigby','charles','','','','34','265634496','4126 WAXWING TRL',0,'STOW','OH','44224','2573','CY','39153','1959-04-10','M','M',':RET:2106-3','N','021','HLT','1366984','52664OH151001306','2014-02-01','2013-12-27 10:37:37','831.00',NULL,NULL,'952.24','121.24','R-OH012','OH0','476.12',NULL,0,'2013-12-28 03:36:08'),(6240,4945,'N','03','021','EC','A',NULL,NULL,'','0001221906','0000915607','','IL','1','Miller','Mahayla','Marie','','','34','301119383','313 FRANKLIN ST',0,'MIDDLETOWN','OH','45042','3245','CY','39017','2006-08-10','F','',':RET:2106-3','N','021','DEN','736952','99734OH005000301','2014-01-01','2013-11-18 23:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:31:39'),(14153,11282,'Y','18','024','14','A','','','TE','0001630023','0001630023','','IL','1','Powell','Glenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-09-21','F','',NULL,NULL,NULL,'','1373359','','2013-12-26','2013-12-26 13:42:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:57'),(4480,3555,'Y','18','021','EC','A','','','AC','0000713616','0000713616','OH00001149390','IL','1','Roberts','Wendy','J','','','34','294768044','4255 OLD WHEELING RD',0,'ZANESVILLE','OH','43701','7442','CY','39119','1966-09-14','F','M',':RET:2106-3','N','021','DEN','477838','99734OH005000301','2014-01-01','2013-12-12 15:17:01','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:02:57'),(4796,3802,'N','19','021','EC','A',NULL,NULL,'','0000034344','0000128081','','IL','1','Hammond','Morgan','D','','','34','299062185','23310 E BAINTREE RD',0,'BEACHWOOD','OH','44122','1246','CY','39035','2002-05-28','F','',':RET:2106-3','N','021','HLT','730796','52664OH151001301','2014-01-01','2013-12-08 15:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2013-12-25 22:16:24'),(2700,2186,'Y','18','021','EC','A','','','AC','0001144712','0001144712','TX00000035717','IL','1','Hailey','Karen','','','','34','459968161','2019 TOLER RD',0,'LONGVIEW','TX','75605','2241','CY','48183','1953-07-18','F','U',':RET:2106-3','N','021','DEN','46066','33348TX002000201','2014-01-01','2013-12-02 15:48:48','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 19:47:41'),(22729,18148,'Y','18','021','EC','A','','','AC','0002287744','0002287744','LA00002714510','31','1','WARREN','LEATRICE','','','','34','037369233','8801 LAKE FOREST BLVD',0,'NEW ORLEANS','LA','70126',NULL,'CY','22071','1956-11-29','F','U',':RET:2054-5','N','021','DEN','3284431','18575LA002000201','2014-03-01','2014-02-11 15:13:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:14'),(23034,18363,'Y','18','021','EC','A','','','AC','0000808484','0000808484','TX00002186245','IL','1','KING','ANITA','','','','34','576565759','6770 EDGEMERE BLVD',0,'EL PASO','TX','79925',NULL,'CY','48141','1949-11-01','F','U',NULL,'N','021','DEN','2652086','33348TX002000201','2014-03-01','2014-02-12 11:56:11','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-12 21:30:35'),(807,667,'Y','18','021','EC','A','','','AC','0001045666','0001045666','OH00000325487','IL','1','Zebari','Jane','','','','34','378642507','3800 Fairway Park Drive',0,'Copley','OH','44321',NULL,'CY','39153','1955-04-25','F','U',':RET:2106-3','N','021','HLT','20541','52664OH151001306','2014-01-01','2013-12-15 19:38:21','461.00',NULL,NULL,'568.22','107.22','R-OH012','OH0','568.22',NULL,0,'2013-12-25 18:05:42'),(1302,1078,'Y','18','021','EC','A','','','AC','0000053169','0000053169','TX00000761735','IL','1','Bautista','Maria','','','','34','464898141','808 RAYNOLDS ST',0,'EL PASO','TX','79903','4730','CY','48141','1950-07-09','F','U',NULL,'N','021','DEN','703015','33348TX002000201','2014-01-01','2013-11-03 22:31:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:31:12'),(18060,14428,'Y','18','021','EC','A','','','AC','0000828253','0000828253','OH00002254158','IL','1','williams','amanda','','','','34','284740187','837 Mirabeau Street',0,'Greenfield','OH','45123',NULL,'CY','39071','1976-09-07','F','U',':RET:2106-3','N','021','HLT','2099390','92036OH003000604','2014-02-01','2014-01-13 20:47:38','42.00',NULL,NULL,'277.53','235.53','R-OH005','OH0','277.53',NULL,0,'2014-01-15 02:07:20'),(21840,17441,'Y','18','021','EC','A','','','AC','0000801299','0000801299','OH00002120909','IL','1','Porter','Julia','','','','34','302625994','1367 NAEGELE RD',0,'AMELIA','OH','45102','1303','CY','39025','1958-06-22','F','U',':RET:2106-3','N','021','HLT','3847024','92036OH003000605','2014-03-01','2014-02-06 11:26:19','311.00',NULL,NULL,'499.92','188.92','R-OH005','OH0','499.92',NULL,0,'2014-02-06 21:01:10'),(21779,17393,'Y','18','021','EC','A','','','AC','0000688322','0000688322','OH00002115810','IL','1','shaffer','ronald','','','','34','276769002','4934 state route 276',0,'batavia','OH','45103',NULL,'CY','39025','1978-04-23','M','U',':RET:2106-3','T','021','DEN','2986182','99734OH005000401','2014-03-01','2014-02-05 21:52:43','0.00',NULL,NULL,'50.05','50.05','R-OH005','OH0','0.00',NULL,0,'2014-02-06 21:00:37'),(6184,4900,'N','01','021','EC','A',NULL,NULL,'','0000683345','0000682114','','IL','1','burgess','wonda','mae','','','34','294542849','11128 forest ave',0,'cleveland','OH','44104',NULL,'CY','39035','1954-07-08','F','',':RET:2054-5','N','021','DEN','1105853','99734OH005000401','2014-01-01','2013-10-22 22:05:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:30:08'),(15376,12299,'Y','18','024','14','A','','','TE','0000285651','0000285651','','IL','1','Penhorwood','Patti',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-01-22','F','',NULL,NULL,NULL,'','1894461','','2014-01-01','2014-01-01 09:04:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:25:16'),(13997,11151,'N','19','021','EC','A',NULL,NULL,'','0000604713','0000341343','','IL','1','Klinger','Korie','','','','34','021691379','1046 MAIN ST',0,'CONVOY','OH','45832','9259','CY','39161','2012-09-05','F','',':RET:2106-3','N','021','HLT','1666072','92036OH002001501','2014-01-01','2013-12-23 10:28:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2013-12-26 13:15:57'),(4358,3460,'Y','18','024','14','A','','','TE','0000005813','0000005813','','IL','1','okeeffe','karen','a',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-09','F','',NULL,NULL,NULL,'','1024163','','2013-12-17','2013-12-17 13:41:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:53:39'),(8919,7072,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000298206','','IL','1','TURNER','BRYCE','P','','','34','284083584','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2003-07-17','M','',NULL,'N','021','DEN','1914082','99734OH005000401','2014-01-01','2013-12-18 05:39:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:45'),(28876,22853,'Y','18','021','EC','A','','','AC','0001060136','0001060136','TX00002645330','IL','1','LUCAS','LATONYA','','','','34','462250085','302 N RACE ST',0,'EVERMAN','TX','76140','3252','CY','48439','1973-01-17','F','U',':RET:2054-5','T','021','DEN','4237288','33348TX002000201','2014-04-01','2014-03-10 11:20:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-10 21:00:05'),(20978,16764,'Y','18','021','EC','A','','','AC','0001444326','0001444326','LA00002075205','IL','1','SIMON','ARLENE','TILLEY','','','34','438150696','3750 HOLLYWOOD ST',0,'BATON ROUGE','LA','70805','2323','CY','22033','1962-08-01','F','U',NULL,'N','021','DEN','3405409','18575LA002000201','2014-03-01','2014-01-31 19:00:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-01 19:00:19'),(2979,2399,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001025484','','IL','1','Isenbarger','Caleb','','','','34','284089439','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','2003-08-14','M','',':RET:2106-3','N','021','DEN','1211363','99734OH005000301','2014-01-01','2013-12-05 19:26:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:12'),(19203,15299,'Y','18','021','EC','A','','','AC','0000726155','0000726155','OH00002564313','IL','1','Phillips','Jerry','','','','34','283664012','466 13th St',0,'Campbell','OH','44405',NULL,'CY','39099','1959-05-27','M','M',':RET:2106-3','N','021','HLT','1718238','52664OH151001304','2014-03-01','2014-01-20 18:06:47','760.00',NULL,NULL,'1129.93','369.93','R-OH013','OH0','539.93',NULL,0,'2014-01-21 08:46:18'),(5048,3997,'Y','18','021','EC','A','','','AC','0000487794','0000487794','TX00000490921','IL','1','HADLEY','JAMES','','','','34','632264892','807 17TH ST SE',0,'PARIS','TX','75460','7416','CY','48277','1988-12-19','M','U',':RET:2106-3','T','021','DEN','2116776','33348TX002000201','2014-01-01','2013-12-18 19:11:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:05'),(5574,4422,'Y','18','021','EC','A','','','AC','0000112899','0000112899','OH00000104033','IL','1','painter','frederick','','','','34','232271176','1344 WOODSMILL RD',0,'BIDWELL','OH','45614','9180','CY','39053','1975-04-08','M','U',':RET:2106-3','N','021','DEN','16024','99734OH005000401','2014-01-01','2013-11-05 20:41:44','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 23:16:46'),(6494,5145,'Y','18','021','EC','A','','','AC','0000415952','0000415952','OH00000365223','IL','1','Boeff','Nancy','','','','34','271481853','4883 DEBBIE DR',0,'MEDINA','OH','44256','7967','CY','39103','1949-12-30','F','U',':RET:2106-3','N','021','HLT','918480','52664OH151001304','2014-01-01','2013-12-11 13:41:07','426.00',NULL,NULL,'669.00','243.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 00:50:39'),(5830,4630,'Y','18','021','EC','A','','','AC','0000815620','0000815620','TX00000110235','IL','1','Flores','Rene','','','','34','467638707','3157 saint Dominic circle',0,'Dallas','TX','75233',NULL,'CY','48113','1952-01-01','M','M',NULL,'N','021','DEN','1922644','33348TX002000201','2014-01-01','2013-12-23 23:15:44','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:16'),(13458,10732,'Y','18','024','14','A','','','TE','0000921906','0000921906','','IL','1','adkins','Brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-02-07','M','',NULL,NULL,NULL,'','1456428','','2013-12-23','2013-12-23 14:21:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:01:41'),(17267,13812,'N','01','021','EC','A',NULL,NULL,'','0000669198','0001042317','','IL','1','Yarnell','James','','','','34','300444582','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1953-07-06','M','',':RET:2106-3','N','021','DEN','1797637','99734OH005000301','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:19'),(16410,13132,'Y','18','024','14','A','','','TE','0000839981','0000839981','','IL','1','HOLT','JUSTIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-20','M','',NULL,NULL,NULL,'','2336509','','2014-01-06','2014-01-06 14:56:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-07 04:04:11'),(23502,18720,'Y','18','024','14','A','','','TE','0000372005','0000372005','','IL','1','Alaniz','Becky',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-04-19','F','',NULL,NULL,NULL,'','2088593','','2014-02-28','2014-02-13 10:32:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-13 22:02:08'),(23878,18998,'Y','18','021','EC','A','','','AC','0000650816','0000650816','OH00002763727','IL','1','Crowe','Marilyn','','','','34','284523658','205 TREASE RD',0,'WADSWORTH','OH','44281','1124','CY','39103','1950-06-13','F','M',NULL,'N','021','HLT','3338562','52664OH151001501','2014-03-01','2014-02-14 12:06:46','215.00',NULL,NULL,'789.56','574.56','R-OH012','OH0','789.56',NULL,0,'2014-02-14 21:32:12'),(25055,19869,'Y','18','021','EC','A','','','AC','0000541694','0000541694','OH00003099524','IL','1','Yousas','Ghulam','M','','','34','680309306','5309 EDGER DR',0,'CINCINNATI','OH','45239','7738','CY','39061','1972-12-09','M','M',NULL,'N','021','DEN','3811040','99734OH005000401','2014-04-01','2014-02-20 10:07:57','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:19'),(25514,20241,'Y','18','021','EC','A','','','AC','0000680906','0000680906','OH00002755075','IL','1','Humphries','Roberta','','','','34','288807003','141 CENTRAL AVE',0,'BLANCHESTER','OH','45107','1425','CY','39027','1975-06-09','F','U',NULL,'N','021','HLT','3709752','92036OH004000601','2014-04-01','2014-02-25 17:00:09','126.00',NULL,NULL,'215.09','89.09','R-OH005','OH0','215.09',NULL,0,'2014-02-25 21:32:02'),(21452,17144,'Y','18','021','EC','A','','','AC','0001036162','0001036162','OH00001649738','IL','1','Hagerty','Nicole','','','','34','273904812','3526 dotwood st nw',0,'north canton','OH','44720',NULL,'CY','39151','1974-09-26','F','M',':RET:2106-3','N','021','HLT','2709253','52664OH151001304','2014-03-01','2014-02-04 12:08:33','281.00',NULL,NULL,'571.80','290.80','R-OH015','OH0','281.44',NULL,0,'2014-02-04 21:01:28'),(6397,5069,'Y','18','021','EC','A','','','AC','0000483458','0000483458','OH00001079521','IL','1','Ringler','Larry','','','','34','272502735','873 BLANDING AVE',0,'AKRON','OH','44310','4004','CY','39153','1952-06-23','M','U',NULL,'N','021','DEN','914736','99734OH005000301','2014-01-01','2013-12-11 12:17:18','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:48:14'),(16656,13327,'Y','18','021','EC','A','','','AC','0001187420','0001187420','MS00001806924','IL','1','Burney','Angela','','','','34','416137804','2005 Dailey Rd.',0,'Gautier','MS','39553',NULL,'CY','28059','1976-05-31','F','U',':RET:2106-3','N','021','DEN','1616803','46300MS002000201','2014-02-01','2014-01-07 18:14:49','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-08 18:24:22');
INSERT INTO `EdiParticipant` VALUES (16234,13000,'Y','18','021','EC','A','','','AC','0000449892','0000449892','OH00001932037','IL','1','Jackson','javaughn','','','','34','274942794','1236 bender ave',0,'east Cleveland','OH','44112',NULL,'CY','39035','1991-04-04','M','R',':RET:2054-5','N','021','HLT','1633787','52664OH151001301','2014-02-01','2014-01-04 14:35:27','0.00',NULL,NULL,'251.52','251.52','R-OH011','OH0','251.52',NULL,0,'2014-01-05 00:02:07'),(2571,2089,'Y','18','021','EC','A','','','AC','0000027872','0000027872','OH00001070724','IL','1','Grega','Robert','','','','34','297660394','2981 S U Route 20 E',0,'Collins','OH','44826',NULL,'CY','39077','1960-10-06','M','M',NULL,'T','021','HLT','791152','92036OH005002705','2014-01-01','2013-12-09 14:45:28','827.00',NULL,NULL,'1041.18','214.18','R-OH006','OH0','457.46',NULL,0,'2013-12-25 19:37:41'),(3526,2832,'Y','18','021','EC','A','','','AC','0000582901','0000582901','TX00000565614','IL','1','Shockey','Cory','','','','34','467651827','6547 AMBER OAK',0,'SAN ANTONIO','TX','78249','1587','CY','48029','1977-07-15','M','R',':RET:2106-3','T','021','DEN','1564681','33348TX002000101','2014-01-01','2013-12-21 21:21:07','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2013-12-25 21:21:23'),(4314,3429,'N','19','021','EC','A',NULL,NULL,'','0000093834','0000571980','','IL','1','davis','jonathan','c','','','34','298045358','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','2000-05-17','M','',':RET:2106-3','N','021','HLT','1806855','92036OH003001201','2014-01-01','2013-12-17 07:29:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 21:52:38'),(23258,18543,'Y','18','021','EC','A','','','AC','0000542205','0000542205','TX00002328605','IL','1','montanez','stefanie','','','','34','639010774','100 NW 8th',0,'big spring','TX','79720',NULL,'CY','48227','1988-09-11','F','M',':RET:2106-3','N','021','DEN','2828347','33348TX002000201','2014-03-01','2014-02-13 11:15:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-13 21:30:08'),(26071,20675,'Y','18','021','EC','A','','','AC','0000404857','0000404857','OH00003404740','IL','1','KNAPP','PATRICK','J','','','34','296623370','35 WASHINGTON AVE',0,'NILES','OH','44446','2433','CY','39155','1957-04-13','M','M',':RET:2106-3','N','021','HLT','3631497','92036OH003003205','2014-05-01','2014-02-26 16:12:31','831.00',NULL,NULL,'1087.46','256.46','R-OH013','OH0','616.02',NULL,0,'2014-02-26 21:02:45'),(656,541,'Y','18','021','EC','A','','','AC','0001199479','0001199479','OH00000358316','IL','1','NANGLE','AMY','','','','34','269781914','724 HYER ST',0,'NEW CARLISLE','OH','45344','2626','CY','39023','1971-06-05','F','U',':RET:2106-3','N','021','DEN','1095873','99734OH005000301','2014-01-01','2013-12-15 18:33:20','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:01:44'),(26954,21358,'Y','18','021','EC','A','','','AC','0000485913','0000485913','OH00003072090','IL','1','RAYBURN','STEFFANI','','','','34','271928804','310 VENICE DR',0,'NORTHWOOD','OH','43619','1151','CY','39173','1986-08-14','F','M',NULL,'N','021','HLT','3747045','92036OH006002601','2014-04-01','2014-03-02 12:22:35','68.00',NULL,NULL,'162.06','94.06','R-OH001','OH0','162.06',NULL,0,'2014-03-03 01:00:28'),(27685,21895,'Y','18','021','EC','A','','','AC','0000816963','0000816963','TX00003365008','IL','1','kirksey','brian','','','','34','460938377','5828 LLANO AVE',0,'DALLAS','TX','75206','6318','CY','48113','1985-03-06','M','U',':RET:2106-3','N','021','DEN','2869934','33348TX002000201','2014-04-01','2014-03-05 02:20:22','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-05 21:30:41'),(1225,1008,'Y','18','021','EC','A','','','AC','0000300377','0000300377','OH00001093197','IL','1','Brophy','Karen','','','','34','281669100','28 Schwinn Drive',0,'Barberton','OH','44203',NULL,'CY','39153','1959-09-11','F','R',':RET:2106-3','N','021','HLT','43538','52664OH151001301','2014-01-01','2013-12-03 14:32:36','0.00',NULL,NULL,'476.12','476.12','R-OH012','OH0','476.12',NULL,0,'2013-12-25 18:20:31'),(6777,5375,'N','19','021','EC','A',NULL,NULL,'','0001008913','0000195099','','IL','1','Fox','Atwood','Lee','','','34','295156037','315 BAILEY RD',0,'BEAVER','OH','45613','9763','CY','39131','2010-05-01','M','',':RET:2106-3','N','021','DEN','1188835','99734OH005000301','2014-01-01','2013-11-24 19:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:16:45'),(1330,1101,'Y','18','021','EC','A','','','AC','0000362464','0000362464','OH00000900406','IL','1','crawford','james','','','','34','280602287','148 WASHINGTON ST NE',0,'WARREN','OH','44483','4925','CY','39155','1972-08-08','M','U',':RET:2106-3','T','021','HLT','398729','52664OH152000901','2014-01-01','2013-10-25 12:19:48','266.00',NULL,NULL,'277.35','11.35','R-OH013','OH0','277.35',NULL,0,'2013-12-25 18:32:04'),(3577,2871,'N','01','021','EC','A',NULL,NULL,'','0000777665','0000221280','','IL','1','Joseph','Kathy','Lynn','','','34','268604104','7367 CLUM RD',0,'HARROD','OH','45850','9413','CY','39003','1955-11-07','F','',':RET:2106-3','T','021','HLT','1404270','92036OH004001501','2014-01-01','2013-12-22 08:49:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','518.54',NULL,0,'2013-12-25 21:22:41'),(4525,3585,'N','01','021','EC','A',NULL,NULL,'','0000204014','0000129630','','IL','1','Sanchez','Ena','C','','','34','459339583','212 STEART ST',0,'ROCKPORT','TX','78382','5933','CY','48007','1962-12-01','F','',':RET:2106-3','N','021','DEN','273451','33348TX002000201','2014-01-01','2013-12-12 14:10:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:03:55'),(3594,2882,'Y','18','024','14','A','','','TE','0000124201','0000124201','','IL','1','Hall','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-02-13','M','',NULL,NULL,NULL,'','1930215','','2013-12-22','2013-12-22 10:43:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:23:05'),(21662,17301,'Y','18','021','EC','A','','','AC','0002019039','0002019039','LA00002571176','IL','1','Johnson','Fredrick','','','','34','434557926','217 WREN ST',0,'MORGAN CITY','LA','70380','7207','CY','22101','1983-09-05','M','M',':RET:2054-5','N','021','DEN','3136853','18575LA002000201','2014-03-01','2014-02-05 13:22:31','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-05 21:30:55'),(9469,7511,'Y','18','021','EC','A','','','AC','0000874690','0000874690','OH00000130289','IL','1','Meadows','Gillian','','','','34','283849407','5903 WOODMONT AVE',0,'CINCINNATI','OH','45213','1709','CY','39061','1976-11-28','F','R',':RET:2106-3','N','021','DEN','2441812','99734OH005000401','2014-01-01','2013-12-21 10:29:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:23'),(21545,17210,'Y','18','021','EC','A','','','AC','0000478518','0000478518','OH00001709548','31','1','CURLUTU','EUGENIA','G','','','34','274688278','PO BOX 97',0,'SANDYVILLE','OH','44671',NULL,'CY','39157','1957-12-06','F','M',':RET:2106-3','N','021','DEN','2768492','99734OH005000401','2014-03-01','2014-02-05 09:57:25','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-05 21:30:11'),(21488,17171,'Y','18','021','EC','A','','','AC','0000349298','0000349298','OH00001861516','IL','1','FIELDS','RITA','','','','34','293546947','3497 WOODHILL DR',0,'PORT CLINTON','OH','43452',NULL,'CY','39123','1957-07-30','F','U',':RET:2106-3','N','021','HLT','2929865','92036OH002002701','2014-03-01','2014-02-04 10:07:51','250.00',NULL,NULL,'525.35','275.35','R-OH006','OH0','525.35',NULL,0,'2014-02-04 21:01:47'),(14298,11406,'N','01','021','EC','A',NULL,NULL,'','0001055326','0000106721','','IL','1','BLACK','FREDDY','L','','','34','292680331','411 MOORE AVE',0,'BELLEVUE','OH','44811','1148','CY','39077','1964-12-13','M','',NULL,'N','021','HLT','1516017','92036OH005002706','2014-02-01','2013-12-26 11:58:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','332.67',NULL,0,'2013-12-27 02:06:46'),(16306,13055,'Y','18','024','14','A','','','TE','0001555360','0001555360','','IL','1','EZELL','CIARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-11-21','F','',NULL,NULL,NULL,'','2266385','','2014-01-05','2014-01-05 20:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-07 04:01:17'),(21027,16802,'Y','18','021','EC','A','','','AC','0000878298','0000878298','OH00001539522','31','1','CHAPPELL-DICK','ANDREW','','','','34','101785742','P.O. BOX 23',0,'BLUFFTON','OH','45817',NULL,'CY','39003','1969-02-26','M','M',':RET:2106-3','N','021','HLT','3031528','92036OH006001501','2014-03-01','2014-01-31 23:04:21','564.00',NULL,NULL,'606.72','42.72','R-OH002','OH0','252.04',NULL,0,'2014-02-01 19:00:42'),(20198,16116,'N','01','021','EC','A',NULL,NULL,'','0001090011','0001028618','','IL','1','perkins','willie','','','Jr','34','411253720','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','1961-12-28','M','',':RET:2054-5','T','021','DEN','3156092','46300MS002000101','2014-03-01','2014-01-27 10:50:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-27 21:01:30'),(18964,15110,'Y','18','021','EC','A','','','AC','0000239721','0000239721','TX00001604819','IL','1','Jones','Kara','','','','34','455978045','5810 72ND ST',0,'LUBBOCK','TX','79424','1916','CY','48303','1986-07-17','F','U',':RET:2106-3','N','021','DEN','2701196','33348TX002000201','2014-03-01','2014-01-17 12:41:59','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-20 08:05:57'),(17438,13950,'N','01','021','EC','A',NULL,NULL,'','0000194064','0000501634','','IL','1','Fifer','Mary','Catherine','','','34','289567650','7147 SALISBURY RD',0,'MAUMEE','OH','43537','9714','CY','39095','1953-01-09','F','',':RET:2106-3','N','021','HLT','2344638','92036OH006002601','2014-02-01','2014-01-10 14:02:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','434.56',NULL,0,'2014-01-13 03:00:34'),(18812,14984,'Y','18','021','EC','A','','','AC','0001113165','0001113165','OH00001595352','IL','1','WILSON','JOHN','','','','34','274520863','1693 LICK RUN RD',0,'CHILLICOTHE','OH','45601','9098','CY','39141','1951-12-07','M','M',':RET:2106-3','N','021','DEN','1427755','99734OH005000401','2014-02-01','2014-01-15 19:09:45','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2014-01-17 03:36:03'),(25444,20188,'Y','18','021','EC','A','','','AC','0001177718','0001177718','TX00002712445','IL','1','escovedo','rose','','','','34','461798389','316 w schunior',0,'edinburg','TX','78541',NULL,'CY','48215','1986-10-15','F','U',NULL,'N','021','DEN','3366962','33348TX002000201','2014-04-01','2014-02-25 12:06:27','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-25 21:31:22'),(25934,20565,'N','01','021','EC','A',NULL,NULL,'','0001246766','0000271930','','IL','1','Beam','Daulton','','','','34','467571768','903 N WALKER ST',0,'ALPINE','TX','79830','3207','CY','48043','1980-05-19','M','',':RET:2106-3','T','021','DEN','3794045','33348TX002000201','2014-03-01','2014-02-26 16:41:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:28'),(27359,21666,'N','19','021','EC','A',NULL,NULL,'','0001031515','0000939849','','S1','1','Iliev','Vall','','','','34','277024440','4323 LORWOOD DR',0,'STOW','OH','44224','2734','CY','39153','1997-04-10','M','',NULL,'N','021','DEN','3803723','99734OH005000401','2014-04-01','2014-03-04 15:59:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:10'),(548,449,'Y','18','021','EC','A','','','AC','0000998928','0000998928','TX00000425240','IL','1','ROWE','KEMALA','','','','34','456890711','5990 ARAPAHO RD APT 7C',0,'DALLAS','TX','75248',NULL,'CY','48113','1982-03-06','F','U',':RET:2054-5','N','021','DEN','57991','33348TX002000101','2014-01-01','2013-12-03 22:55:16','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 17:49:57'),(7687,6087,'Y','18','021','EC','A','','','AC','0001121383','0001121383','OH00000998974','IL','1','Rudolph','Saundra','','','','34','296627140','12524 WOODSIDE AVE',0,'CLEVELAND','OH','44108','2423','CY','39035','1963-06-27','F','U',':RET:2054-5','N','021','DEN','2548275','99734OH005000401','2014-01-01','2013-12-19 20:49:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:00:56'),(18952,15100,'Y','18','021','EC','A','','','AC','0000458256','0000458256','TX00002258014','IL','1','CASTILLO','DEADIRA','','','','34','457838127','1409 14TH ST',0,'CORPUS CHRISTI','TX','78404',NULL,'CY','48355','1957-04-13','F','U',NULL,'N','021','DEN','2210345','33348TX002000201','2014-03-01','2014-01-17 14:22:35','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-20 08:05:50'),(1677,1399,'Y','18','021','EC','A','','','AC','0001661896','0001661896','LA00001262809','31','1','Wright','Verta','','','','34','433752683','P O BOX 29462',0,'Shreveport','LA','71149',NULL,'CY','22017','1979-10-26','F','U',':RET:2054-5','N','021','DEN','1906069','18575LA002000101','2014-01-01','2013-12-24 05:40:33','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 18:54:02'),(4018,3208,'N','01','021','EC','A',NULL,NULL,'','0000532084','0000280820','','IL','1','Griffith','Jeffery','','','','34','277562485','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1961-11-28','M','',':RET:2106-3','N','021','DEN','2086744','99734OH005000401','2014-01-01','2013-12-17 08:08:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:35'),(9297,7370,'N','01','021','EC','A',NULL,NULL,'','0000772610','0000005802','','IL','1','MCKINNEY','JEFFERY','','','','34','276424415','12514 SPRINGWATER AVE NW',0,'UNIONTOWN','OH','44685','8292','CY','39151','1954-11-17','M','',NULL,'N','021','HLT','685693','52664OH151001305','2014-01-01','2013-11-30 12:26:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-26 04:16:16'),(14198,11322,'N','01','021','EC','A',NULL,NULL,'','0000443422','0000618869','','IL','1','NVUYEN','EANX','','','','34','536594248','5001 N STATE LINE AVE',0,'TEXARKANA','TX','75503',NULL,'CY','48037','1978-10-15','F','',':RET:2047-9','N','021','DEN','1692354','33348TX002000201','2014-02-01','2013-12-26 13:08:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-27 02:04:10'),(15001,11990,'Y','18','021','EC','A','','','AC','0000020855','0000020855','TX00001156723','IL','1','Clark','Alexis','','','','34','449594085','1617 canyon creek dr',0,'temple','TX','76502',NULL,'CY','48027','1982-09-14','M','U',':RET:2054-5','N','021','DEN','1387894','33348TX002000201','2014-02-01','2013-12-30 18:11:56','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-01 12:01:43'),(15430,12344,'Y','18','021','EC','A','','','AC','0001019860','0001019860','TX00001727454','IL','1','HARRISON','DONALD','WAYNE','','','34','453060728','6627 BRITTANY FERRY LN',0,'HOUSTON','TX','77049','1652','CY','48201','1954-02-20','M','M',':RET:2054-5','N','021','DEN','1918839','33348TX002000201','2014-02-01','2013-12-31 12:10:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:27:42'),(18617,14841,'Y','18','024','14','A','','','TE','0001005722','0001005722','','IL','1','Hollinger','Rocksand',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-10-14','F','',NULL,NULL,NULL,'','1795862','','2014-01-15','2014-01-15 15:45:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:47:26'),(16921,13541,'Y','18','021','EC','A','','','AC','0001912102','0001912102','LA00001897729','IL','1','Percy','Isabelle','','','','34','427318764','124 East 24th Ave',0,'Covington','LA','70433',NULL,'CY','22103','1973-12-11','F','R',':RET:2106-3','N','021','DEN','1803746','18575LA002000201','2014-02-01','2014-01-08 18:28:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:43'),(23710,18878,'Y','18','021','EC','A','','','AC','0000188899','0000188899','OH00002004324','IL','1','Hammond','Nana','','','','34','093593295','7171 AUSTRIAN WAY',0,'REYNOLDSBURG','OH','43068','5626','CY','39049','1987-03-06','F','U',':RET:2054-5','N','021','DEN','2869410','99734OH005000401','2014-03-01','2014-02-14 13:39:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-14 21:30:46'),(25635,20337,'Y','18','021','EC','A','','','AC','0001935607','0001935607','LA00002860323','IL','1','ROBERTSON','ADAM','','','','34','434773345','6820 NORWOOD CT',0,'NEW ORLEANS','LA','70126','3248','CY','22071','1988-09-28','M','M',':RET:2054-5','N','021','DEN','2893818','18575LA002000201','2014-04-01','2014-02-21 18:21:50','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-26 08:30:27'),(27533,21782,'N','01','021','EC','A',NULL,NULL,'','0001094709','0000728773','','IL','1','Morgan','Melissa','Sue','','','34','269920993','2489 Neal Rd',0,'Urbana','OH','43078',NULL,'CY','39021','1987-09-21','F','',':RET:2106-3','N','021','HLT','2674713','92036OH004000501','2014-04-01','2014-03-04 17:06:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.72',NULL,0,'2014-03-04 21:02:48'),(28768,22772,'Y','18','021','EC','A','','','AC','0001132830','0001132830','OH00002885021','IL','1','Holbert','Terrance','','','','34','276763303','2327 n. Summit st.',0,'Toledo','OH','43611',NULL,'CY','39095','1979-02-06','M','U',':RET:2054-5','N','021','DEN','3318467','99734OH005000401','2014-04-01','2014-03-08 22:32:33','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-09 21:00:27'),(21885,17474,'Y','18','021','EC','A','','','AC','0001465320','0001465320','LA00001845819','IL','1','Keber','Lillian','','','','34','242415286','7909 OAK ST',0,'NEW ORLEANS','LA','70118','2705','CY','22071','1982-06-03','F','U',':RET:2106-3','N','021','DEN','3377627','18575LA002000101','2014-03-01','2014-02-06 14:48:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-06 21:01:33'),(19662,15667,'Y','18','021','EC','A','','','AC','0000648352','0000648352','OH00001554847','IL','1','Peyton','Nichole','','','','34','217049081','1491 FAIRHILL CT',0,'XENIA','OH','45385','7053','CY','39057','1968-11-05','F','U',':RET:2106-3','T','021','DEN','3078159','99734OH005000401','2014-03-01','2014-01-23 15:45:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-23 21:00:25'),(2614,2125,'Y','18','021','EC','A','','','AC','0001105502','0001105502','OH00001285186','IL','1','Wagher','Mark','','','','34','347549678','5713 PLANET DR',0,'FAIRFIELD','OH','45014','5043','CY','39017','1961-03-15','M','U',':RET:2106-3','N','021','DEN','689698','99734OH005000401','2014-01-01','2013-12-02 11:59:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:41'),(1844,1510,'N','01','021','EC','A',NULL,NULL,'','0000100067','0000426433','','IL','1','Triola','Amy Joy','Prather','','','34','274885954','577 Parkway Blvd',0,'Norton','OH','44203',NULL,'CY','39153','1975-03-31','F','',NULL,'N','021','HLT','1377035','52664OH151001304','2014-01-01','2013-12-24 12:17:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2013-12-25 18:57:42'),(5753,4568,'Y','18','024','14','A','','','TE','0000355195','0000355195','','IL','1','Johnson','Clarence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-05-18','M','',NULL,NULL,NULL,'','2246860','','2013-12-24','2013-12-24 01:29:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:46:17'),(28667,22685,'Y','18','021','EC','A','','','AC','0001416195','0001416195','LA00003671816','IL','1','Chavez','Nairy','A','','','34','439537663','3031 Sienna Drive',0,'Harvey','LA','70058',NULL,'CY','22051','1966-08-23','F','U',NULL,'N','021','DEN','3931927','18575LA002000201','2014-04-01','2014-03-08 15:43:25','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:47'),(1655,1382,'N','01','021','EC','A',NULL,NULL,'','0000051898','0000371980','','IL','1','monsivais','maria','g','','','34','331802323','6916 ALEXANDRIA CT',0,'FORT WORTH','TX','76133','6301','CY','48439','1983-04-21','F','',':RET:2106-3','N','021','DEN','1358546','33348TX002000201','2014-01-01','2013-12-24 16:38:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:53:27'),(7859,6221,'N','19','021','EC','A',NULL,NULL,'','0000951788','0000227048','','S1','1','Scott','Evan','L','','','34','288028081','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1997-06-25','M','',':RET:2106-3','N','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:58'),(3492,2804,'Y','18','021','EC','A','','','AC','0000578777','0000578777','OH00001097740','IL','1','Belcher','Audrey','Renee','','','34','290702462','5721 W. Pine Tree Street',0,'Columbus','OH','43229',NULL,'CY','39049','1965-03-05','F','U',':RET:2054-5','N','021','DEN','1846259','99734OH005000401','2014-01-01','2013-12-22 14:12:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:20:28'),(20307,16210,'Y','18','024','14','A','','','TE','0000008810','0000008810','','IL','1','Barranco','Martha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-01','F','',NULL,NULL,NULL,'','1879649','','2014-01-28','2014-01-28 11:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:47'),(19700,15698,'Y','18','021','EC','A','','','AC','0000978933','0000978933','TX00001440831','IL','1','Acosta','Beverly','','','','34','466874559','14016 TOWER POINT WAY',0,'EL PASO','TX','79938','4000','CY','48141','1982-01-12','F','R',NULL,'N','021','DEN','3188105','33348TX002000201','2014-03-01','2014-01-23 12:15:58','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-23 21:00:47'),(19332,15411,'Y','18','021','EC','A','','','AC','0000100964','0000100964','TX00001888890','IL','1','Granoff','Harry','','','','34','061443497','49 Masland Circle',0,'Dallas','TX','75230',NULL,'CY','48113','1952-07-24','M','U',NULL,'N','021','DEN','2169882','33348TX002000201','2014-03-01','2014-01-21 10:12:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:16'),(15693,12554,'N','01','021','EC','A',NULL,NULL,'','0000156943','0001118731','','IL','1','Rogacki','Thomas','V','','','34','268549696','1914 AYERS RD',0,'MILLBURY','OH','43447','9604','CY','39173','1953-07-19','M','',':RET:2106-3','T','021','HLT','2156682','92036OH002002601','2014-02-01','2013-12-31 12:16:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','702.82',NULL,1,'2014-01-02 04:35:26'),(16751,13400,'Y','18','024','14','A','','','TE','0000776813','0000776813','','IL','1','Correa','Marjorie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-11','F','',NULL,NULL,NULL,'','1692437','','2014-01-07','2014-01-07 14:55:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-08 18:24:55'),(22972,18317,'Y','18','021','EC','A','','','AC','0000059156','0000059156','MS00001871937','IL','1','Prater','Kayla','','','','34','427712848','705 GEORGE FORD RD',0,'CARRIERE','MS','39426','7486','CY','28109','1991-04-18','F','M',':RET:2106-3','N','021','DEN','3142139','46300MS002000201','2014-03-01','2014-02-12 12:27:49','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85','CIC',0,'2014-02-12 21:00:17'),(17388,13912,'N','19','021','EC','A',NULL,NULL,'','0000653212','0000685864','','IL','1','Jones','Caden','','','','34','296137820','553 Aston View Ln',0,'Cleves','OH','45002',NULL,'CY','39061','2008-02-06','M','',NULL,'N','021','DEN','1553330','99734OH005000401','2014-02-01','2014-01-10 11:57:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:00:10'),(17608,14075,'Y','18','021','EC','A','','','AC','0000901131','0000901131','TX00001981356','IL','1','LAZARINE','GREGG','ALLEN','','Jr','34','461777785','295 COUNTY ROAD 133',0,'GARY','TX','75643',NULL,'CY','48365','1986-04-22','M','U',':RET:2106-3','N','021','DEN','1690206','33348TX002000201','2014-02-01','2014-01-12 23:46:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:20'),(23268,18552,'Y','18','021','EC','A','','','AC','0000848565','0000848565','TX00001942351','IL','1','Nwanne','Theodore','','','','34','084669590','8318 Lighthouse Drive',0,'Rowlett','TX','75089',NULL,'CY','48113','1954-12-23','M','M',NULL,'N','021','DEN','3156478','33348TX002000101','2014-03-01','2014-02-13 09:41:34','0.00',NULL,NULL,'135.75','135.75','R-TX008','TX0','27.15','CIC',0,'2014-02-13 21:30:12'),(25402,20152,'Y','18','021','EC','A','','','AC','0000844753','0000844753','OH00003256043','IL','1','Prentiss','Rhonda','','','','34','280848054','110 Greenwich Rd.',0,'Seville','OH','44273',NULL,'CY','39103','1970-03-08','F','U',':RET:2106-3','N','021','HLT','3426900','52664OH151001306','2014-04-01','2014-02-25 17:04:17','249.00',NULL,NULL,'311.54','62.54','R-OH012','OH0','311.54',NULL,0,'2014-02-25 21:30:57'),(862,713,'N','01','021','EC','A',NULL,NULL,'','0000201897','0000093812','','IL','1','berry','michael','','','','34','275608673','12 n hazelwood',0,'youngstown','OH','44509',NULL,'CY','39099','1958-01-05','M','',':RET:2106-3','N','021','HLT','1758833','92036OH002003201','2014-01-01','2013-12-16 08:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','623.35',NULL,0,'2013-12-25 18:07:12'),(21596,17248,'Y','18','021','EC','A','','','AC','0000361049','0000361049','OH00001668494','IL','1','bricker','kevin','','','','34','288505828','2501 THURMONT RD',0,'AKRON','OH','44313','5467','CY','39153','1958-06-14','M','U',':RET:2106-3','N','021','DEN','3194870','99734OH005000301','2014-03-01','2014-02-05 10:42:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-05 21:30:30'),(27338,21647,'Y','18','024','14','A','','','TE','0001016904','0001016904','','IL','1','Arnold','Gregory',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-06-02','M','',NULL,NULL,NULL,'','3506062','','2014-03-04','2014-03-04 10:13:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:00:57'),(27500,21758,'N','19','021','EC','A',NULL,NULL,'','0000367445','0000570620','','S1','1','Wills','Brion','William','','','34','291137187','205 W WILLIAM ST',0,'MAUMEE','OH','43537','2179','CY','39095','2008-01-07','F','',':RET:2106-3','N','021','HLT','3506335','92036OH004002601','2014-04-01','2014-03-04 12:47:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-04 21:02:28'),(126,109,'Y','18','021','EC','A','','','AC','0000979548','0000979548','MS00000790364','IL','1','Jones','Savannah','','','','34','427652198','4105 MARKET ST',0,'PASCAGOULA','MS','39567','2218','CY','28059','1989-02-05','F','U',':RET:2054-5','N','021','DEN','1035582','46300MS002000201','2014-01-01','2013-12-04 18:53:28','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 17:18:19'),(6326,5016,'Y','18','021','EC','A','','','AC','0000180980','0000180980','OH00000891106','IL','1','firm','edward','','','','34','268500507','492 fairview hts.',0,'toronto','OH','43964',NULL,'CY','39081','1949-02-17','M','M',':RET:2106-3','N','021','DEN','432405','99734OH005000401','2014-01-01','2013-12-11 11:22:03','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 00:46:29'),(15466,12375,'N','19','021','EC','A',NULL,NULL,'','0000191381','0000810795','','S1','1','TRAN','NGA','','','','34','281985039','4307 MANTELL CT',0,'DAYTON','OH','45440','3869','CY','39057','1995-08-28','M','',NULL,'N','021','HLT','2512995','92036OH004000501','2014-02-01','2013-12-31 11:20:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,1,'2014-01-02 04:28:47'),(9515,7546,'Y','18','021','EC','A','','','AC','0000941985','0000941985','OH00000402078','IL','1','SHARP','HERBERT','','','Sr','34','287523943','730 MILLSDALE ST',0,'CINCINNATI','OH','45216',NULL,'CY','39061','1954-09-13','M','M',':RET:2054-5','N','021','DEN','2272346','99734OH005000401','2014-01-01','2013-12-21 17:51:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:35:30'),(1369,1134,'Y','18','021','EC','A','','','AC','0000849421','0000849421','TX00000961447','IL','1','Kosta','Elinor','','','','34','561920376','2604 BERKETT DR',0,'AUSTIN','TX','78745','4320','CY','48453','1954-02-09','F','U',':RET:2106-3','N','021','DEN','2300767','33348TX002000101','2014-01-01','2013-12-24 15:55:25','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:43'),(2101,1722,'Y','18','021','EC','A','','','AC','0000136051','0000136051','OH00000608843','IL','1','Vanvelzel','Bruce','','','','34','274541084','9866 BALLANTREE CT',0,'PERRYSBURG','OH','43551','3757','CY','39173','1953-01-01','M','R',NULL,'N','021','DEN','1126874','99734OH005000401','2014-01-01','2013-12-09 21:50:08','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 19:17:09'),(20284,16189,'Y','18','021','EC','A','','','AC','0001249617','0001249617','OH00002394308','IL','1','Napier','Jim','','','','34','286702426','6188 Main Street',0,'Oxford','OH','45056',NULL,'CY','39017','1960-12-26','M','U',NULL,'N','021','DEN','2881110','99734OH005000401','2014-03-01','2014-01-28 16:08:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-28 21:00:31'),(21205,16945,'Y','18','021','EC','A','','','AC','0001929125','0001929125','LA00001896969','IL','1','JAMES','JOHNATHAN','N','','','34','439451679','726 LABARRE RD',0,'JEFFERSON','LA','70121',NULL,'CY','22051','1982-03-02','M','U',':RET:2054-5','N','021','DEN','3386353','18575LA002000201','2014-03-01','2014-02-03 10:24:25','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:00:56'),(27997,22153,'Y','18','021','EC','A','','','AC','0000249177','0000249177','OH00003733656','IL','1','crookall','michael','','','','34','295903393','1776 EMPIRE RD',0,'WICKLIFFE','OH','44092','1135','CY','39085','1987-02-09','M','U',':RET:2106-3','N','021','DEN','3908556','99734OH005000401','2014-04-01','2014-03-05 19:44:00','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:06'),(2705,2190,'Y','18','021','EC','A','','','AC','0000086231','0000086231','TX00000827715','31','1','BLAIR-SIMS','BRITTANY','N','','','34','459974821','P.O. BOX 1237',0,'CORSICANA','TX','75151',NULL,'CY','48349','1988-04-11','F','U',':RET:2054-5','N','021','DEN','440956','33348TX002000201','2014-01-01','2013-12-02 16:14:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:47:49'),(15258,12196,'Y','18','024','14','A','','','TE','0001036099','0001036099','','IL','1','Kowalski','Kelly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-11-18','F','',NULL,NULL,NULL,'','38273','','2013-12-30','2013-12-30 12:03:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:09:11'),(14818,11836,'Y','18','021','EC','A','','','AC','0000430643','0000430643','TX00001179155','IL','1','Kirshner','Gayla','','','','34','460815690','4435 CHEENA DR',0,'HOUSTON','TX','77096','4403','CY','48201','1987-03-16','F','U',':RET:2106-3','N','021','DEN','2586377','33348TX002000101','2014-01-01','2013-12-23 19:45:26','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,1,'2013-12-29 11:14:16'),(5950,4712,'N','19','021','EC','A',NULL,NULL,'','0000077568','0001133948','','IL','1','Jayne','Kayla','','','','34','300909369','26169 s u rte 52',0,'stout','OH','45684',NULL,'CY','39001','1989-02-06','F','',NULL,'N','021','HLT','1760503','92036OH003000605','2014-01-01','2013-12-23 23:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2013-12-25 23:51:03'),(20229,16140,'Y','18','021','EC','A','','','AC','0001257358','0001257358','OH00001484307','IL','1','Bonifas','Patricia','','','','34','280520047','12198 MIDDLEPOINT WETZEL RD',0,'DELPHOS','OH','45833','8808','CY','39161','1958-11-20','F','M',NULL,'N','021','HLT','3223216','92036OH005001501','2014-03-01','2014-01-27 16:49:28','590.00',NULL,NULL,'1027.15','437.15','R-OH002','OH0','490.79',NULL,0,'2014-01-27 21:01:49'),(20770,16594,'Y','18','021','EC','A','','','AC','0001140811','0001140811','OH00002185986','IL','1','Myers','Susan','','','','34','272828844','5 EDGEBROOK DR',0,'WAPAKONETA','OH','45895','1788','CY','39011','1972-04-07','F','M',':RET:2106-3','T','021','HLT','3175349','92036OH005001505','2014-03-01','2014-01-30 17:09:06','40.00',NULL,NULL,'329.54','289.54','R-OH002','OH0','329.54',NULL,0,'2014-01-30 21:01:39'),(23398,18645,'N','19','021','EC','A',NULL,NULL,'','0000546511','0000526829','','S1','1','Johnson','Jenny','','','','34','290138069','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','2007-11-20','F','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:09'),(26350,20904,'N','01','021','EC','A',NULL,NULL,'','0000938588','0000638568','','IL','1','howard','quentin','','','','34','295668602','103 ROGER AVE',0,'BELLEVUE','OH','44811','1152','CY','39077','1965-12-20','M','',NULL,'N','021','HLT','2966815','92036OH004002701','2014-04-01','2014-02-27 13:31:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','256.36',NULL,0,'2014-02-28 06:31:47'),(27385,21682,'Y','18','021','EC','A','','','AC','0000364218','0000364218','MS00002872800','IL','1','RUSSELL','IDA','','','','34','587227576','2535 OAK ST',0,'VICKSBURG','MS','39180','4059','CY','28149','1952-02-02','F','U',':RET:2054-5','N','021','DEN','2770411','46300MS002000201','2014-04-01','2014-03-04 14:33:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:23'),(28502,22554,'Y','18','021','EC','A','','','AC','0001196877','0001196877','OH00002645247','IL','1','lindsay','carol','','','','34','297428298','2280 COVINGTON RD',0,'AKRON','OH','44313','4302','CY','39153','1950-03-05','F','M',':RET:2106-3','N','021','HLT','3653544','52664OH151001305','2014-05-01','2014-03-07 10:39:37','459.00',NULL,NULL,'669.00','210.00','R-OH012','OH0','669.00',NULL,0,'2014-03-07 21:31:49'),(679,559,'Y','18','021','EC','A','','','AC','0000635994','0000635994','OH00000301303','IL','1','Vargas','Tammy','','','','34','126543973','496 N Firestone Blvd',0,'Akron','OH','44301',NULL,'CY','39153','1965-10-25','F','M',':RET:2106-3','N','021','DEN','2609121','99734OH005000301','2014-01-01','2013-12-16 10:49:53','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:02:20'),(1924,1569,'Y','18','021','EC','A','','','AC','0001162559','0001162559','OH00000328794','IL','1','McAllister','Kimberly','Mathews','','','34','225331512','7019 DORAN DR',0,'NEW ALBANY','OH','43054','9320','CY','39049','1972-07-05','F','U',':RET:2106-3','N','021','DEN','1165593','99734OH005000301','2014-01-01','2013-11-20 12:49:13','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:00:14'),(2622,2132,'Y','18','021','EC','A','','','AC','0000293156','0000293156','OH00001308083','IL','1','Lapushansky','John','Alexander','','','34','230433590','6414 MEADOWBROOK RD',0,'GARFIELD HEIGHTS','OH','44125','4930','CY','39035','1986-05-31','M','U',':RET:2106-3','N','021','DEN','338364','99734OH005000401','2014-01-01','2013-12-02 18:02:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:45:53'),(13557,10812,'Y','18','021','EC','A','','','AC','0001462795','0001462795','LA00000847113','IL','1','murray','christina','','','','34','589461221','384 TOWNSVILLE RD',0,'MARION','LA','71260','3614','CY','22111','1971-11-18','F','M',NULL,'T','021','DEN','2025980','18575LA002000201','2014-01-01','2013-12-23 15:33:14','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:04:15'),(6815,5405,'N','19','021','EC','A',NULL,NULL,'','0000449829','0000384365','','IL','1','Smas','Madeleine','','','','34','397374219','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','2012-08-02','F','',NULL,'N','021','HLT','629212','52664OH151001305','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 01:30:25'),(8050,6373,'Y','18','021','EC','A','','','AC','0001030368','0001030368','OH00000658129','IL','1','PHOENIX','CLETUS','','','','34','302682548','5541 CHRISTOPHER CT',0,'TOLEDO','OH','43614','1211','CY','39095','1973-06-10','M','U',':RET:2054-5','N','021','HLT','2010479','92036OH004002601','2014-01-01','2013-12-20 13:54:56','0.00',NULL,NULL,'200.38','200.38','R-OH001','OH0','200.38',NULL,0,'2013-12-26 03:09:39'),(5951,4712,'N','01','021','EC','A',NULL,NULL,'','0000077568','0000688287','','IL','1','Jayne','michael','','','','34','302544460','26169 s u rte 52',0,'stout','OH','45684',NULL,'CY','39001','1951-06-19','M','',NULL,'N','021','HLT','1760503','92036OH003000605','2014-01-01','2013-12-23 23:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','644.07',NULL,0,'2013-12-25 23:51:04'),(19349,15424,'N','19','021','EC','A',NULL,NULL,'','0000387310','0000632714','','S1','1','McCoy','Andrew','Michael','','','34','294086652','10210 WINSTEAD LN',0,'CINCINNATI','OH','45231','2720','CY','39061','2003-11-25','M','',NULL,'N','021','DEN','3202365','99734OH005000301','2014-03-01','2014-01-21 14:02:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:25'),(20663,16512,'Y','18','021','EC','A','','','AC','0000132642','0000132642','TX00001493907','IL','1','Hawkins','Robin','','','','34','465658246','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1981-03-05','F','R',':RET:2054-5','N','021','DEN','2912423','33348TX002000201','2014-03-01','2014-01-30 17:35:28','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2014-01-30 21:00:45'),(21687,17316,'N','01','021','EC','A',NULL,NULL,'','0000099034','0000634850','','IL','1','MacCarthy','Eunice','','','','34','077949273','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1963-08-28','F','',NULL,'N','021','HLT','3404444','92036OH004002601','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','280.03',NULL,0,'2014-02-05 21:31:04'),(21794,17406,'Y','18','024','14','A','','','TE','0000264237','0000264237','','IL','1','Hall','Krystian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-08-23','F','',NULL,NULL,NULL,'','3387403','','2014-02-06','2014-02-06 16:10:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-06 21:00:46'),(23244,18531,'Y','18','024','14','A','','','TE','0000533271','0000533271','','IL','1','Lloyd','Anna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-16','F','',NULL,NULL,NULL,'','309972','','2014-02-28','2014-02-12 21:11:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:04'),(23657,18838,'Y','18','021','EC','A','','','AC','0000805913','0000805913','TX00002518831','IL','1','TEIXIRA','ISABEL','APARECIDA','','','34','629235161','3600 WHEELER ST',0,'DALLAS','TX','75209',NULL,'CY','48113','1956-08-02','F','U',NULL,'N','021','DEN','2807283','33348TX002000201','2014-03-01','2014-02-14 07:30:32','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:18'),(26475,20999,'Y','18','024','14','A','','','TE','0001934491','0001934491','','IL','1','Mitchell','Emil',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-08-18','M','',NULL,NULL,NULL,'','3837030','','2014-02-27','2014-02-27 15:55:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-28 07:30:39'),(26547,21049,'N','19','021','EC','A',NULL,NULL,'','0000858541','0001219646','','IL','1','Christy','Abbie','','','','34','279138277','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2007-05-05','F','',':RET:2106-3','N','021','DEN','3004039','99734OH005000301','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:11'),(6006,4755,'Y','18','021','EC','A','','','AC','0001230354','0001230354','OH00001216102','IL','1','Finke','Donna','','','','34','282548168','1709 NAGEL ST',0,'SAINT MARYS','OH','45885','1415','CY','39011','1953-10-28','F','U',':RET:2106-3','T','021','DEN','1029141','99734OH005000301','2014-01-01','2013-12-01 13:53:21','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:00:29'),(16573,13256,'N','01','021','EC','A',NULL,NULL,'','0000481091','0000244999','','IL','1','ALEXANDER','KIMBERLY','SUE','','','34','294726240','9998 BROWNS RUN RD',0,'GERMANTOWN','OH','45327','9737','CY','39113','1961-02-05','F','',':RET:2106-3','N','021','HLT','1860504','92036OH003000505','2014-02-01','2014-01-04 22:24:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','484.55',NULL,1,'2014-01-07 10:23:25'),(15818,12663,'Y','18','021','EC','A','','','AC','0000115503','0000115503','OH00000762992','IL','1','Demoulin','Geraldine','','','','34','151489806','2925 Kerrwood Dr.',0,'Columbus','OH','43231',NULL,'CY','39049','1954-06-22','F','M',':RET:2106-3','N','021','DEN','1808624','99734OH005000401','2014-02-01','2014-01-02 12:01:08','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:03:27'),(728,603,'Y','18','021','EC','A','','','AC','0000725092','0000725092','TX00000423305','IL','1','Nesmith','Marilynn','M','','','34','466927468','13919 Far Hills Ln',0,'Dallas','TX','75240',NULL,'CY','48113','1950-11-11','F','U',':RET:2106-3','N','021','DEN','1430089','33348TX002000101','2014-01-01','2013-12-16 16:41:45','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:03:42'),(2346,1911,'Y','18','021','EC','A','','','AC','0000508723','0000508723','TX00000839552','IL','1','Coleman','Lillie','','','','34','466943339','2020 fm 909',0,'Clarksville','TX','75426',NULL,'CY','48387','1950-12-25','F','U',':RET:2054-5','N','021','DEN','1179076','33348TX002000201','2014-01-01','2013-12-09 14:17:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:32:06'),(7870,6226,'N','19','021','EC','A',NULL,NULL,'','0000328405','0000145372','','IL','1','Miller','Megan','M','','','34','289027437','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1997-09-13','F','',':RET:2106-3','N','021','DEN','2279031','99734OH005000301','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:10'),(2952,2377,'Y','18','021','EC','A','','','AC','0001206889','0001206889','TX00000407662','31','1','KASSA','ZEWDITU','','','','34','449597958','PO BOX 16242',0,'SUGARLAND','TX','77496',NULL,'CY','48157','1960-07-09','F','U',':RET:2054-5','N','021','DEN','276746','33348TX002000201','2014-01-01','2013-12-05 19:15:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:16:33'),(5834,4634,'Y','18','021','EC','A','','','AC','0000628293','0000628293','TX00000998089','IL','1','Cisneros','Joseph','George','','','34','453965489','1918 W HOUSTON ST',0,'SAN ANTONIO','TX','78207','3417','CY','48029','1951-12-15','M','M',':RET:2106-3','N','021','DEN','2088402','33348TX002000201','2014-01-01','2013-12-23 23:20:18','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:48:23'),(5781,4593,'Y','18','021','EC','A','','','AC','0000645975','0000645975','OH00000900287','IL','1','ECK','KYLE','','','','34','399024791','1065 NORTHFIELD PLASE S',0,'REYNOLDSBURG','OH','43068',NULL,'CY','39049','1986-09-02','M','R',':RET:2106-3','N','021','DEN','2261464','99734OH005000401','2014-01-01','2013-12-23 23:24:08','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:47:03'),(17553,14034,'Y','18','021','EC','A','','','AC','0000899910','0000899910','MS00002580951','IL','1','HOWELL','ZAMA','','','','34','428352270','7616 SOUTHAVEN CIR W',0,'SOUTHAVEN','MS','38671','5224','CY','28033','1964-06-17','F','U',':RET:2106-3','N','021','DEN','2121746','46300MS002000101','2014-02-01','2014-01-12 18:00:14','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-13 03:01:55'),(19252,15342,'Y','18','021','EC','A','','','AC','0000517634','0000517634','LA00002349491','IL','1','paul','paula','','','','34','436436402','250 n 14th street apt 18',0,'port allen','LA','70767',NULL,'CY','22121','1981-04-19','F','U',NULL,'T','021','DEN','1660031','18575LA002000201','2014-03-01','2014-01-20 11:14:31','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:46:44'),(19807,15791,'Y','18','021','EC','A','','','AC','0000697124','0000697124','TX00002315076','IL','1','Keating','Mike','','','','34','523785968','6318 RICHMOND AVE',0,'DALLAS','TX','75214','3681','CY','48113','1961-04-14','M','U',NULL,'N','021','DEN','2964923','33348TX002000201','2014-03-01','2014-01-24 15:34:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-24 21:00:07'),(21758,17374,'Y','18','021','EC','A','','','AC','0000290701','0000290701','TX00001678210','IL','1','LEE','EVELYN','','','','34','463450120','725 Macarthur Ave',0,'Wake Village','TX','75501',NULL,'CY','48037','1964-05-19','F','U',':RET:2106-3','N','021','DEN','3153749','33348TX002000201','2014-03-01','2014-02-06 00:21:56','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-06 21:00:24'),(27202,21538,'N','01','021','EC','A',NULL,NULL,'','0000379450','0000364607','','IL','1','Eatmon','Curtis','','','III','34','450670935','1526 REYNOLDSTON LN',0,'DALLAS','TX','75232','2414','CY','48113','1980-01-02','M','',':RET:2054-5','N','021','DEN','2979352','33348TX002000201','2014-04-01','2014-03-03 17:31:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-03 21:31:23'),(27696,21904,'Y','18','021','EC','A','','','AC','0001224477','0001224477','TX00002698993','IL','1','wiley','clifford','ray','','','34','450857345','2315 w park ave',0,'corsicana','TX','75110',NULL,'CY','48349','1974-08-30','M','M',':RET:2106-3','N','021','DEN','3927000','33348TX002000201','2014-04-01','2014-03-05 11:48:15','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:30:47'),(27813,21998,'Y','18','021','EC','A','','','AC','0000128156','0000128156','OH00003633690','IL','1','sperner','david','','','','34','301643911','4493 Bridge crest drive',0,'copley','OH','44321',NULL,'CY','39153','1967-03-16','M','U',NULL,'N','021','HLT','2943481','52664OH151001305','2014-04-01','2014-03-05 15:48:04','242.00',NULL,NULL,'348.56','106.56','R-OH012','OH0','348.56',NULL,0,'2014-03-05 21:31:52'),(27989,22146,'Y','18','021','EC','A','','','AC','0001725446','0001725446','LA00003712905','IL','1','JONES','OCTAVIA','','','','34','433812208','6021 KUEBEL DR',0,'NEW ORLEANS','LA','70126','1317','CY','22071','1988-08-12','F','U',NULL,'N','021','DEN','3969402','18575LA002000201','2014-04-01','2014-03-06 17:11:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:01:02'),(7936,6276,'N','01','021','EC','A',NULL,NULL,'','0001926231','0001349963','','IL','1','Shipp','Walter','Craig','','','34','464980830','611 ELMORE ST',0,'SAINT MARTINVILLE','LA','70582','4909','CY','22099','1953-06-12','M','',':RET:2106-3','N','021','DEN','1719668','18575LA002000201','2014-01-01','2013-12-20 14:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 03:06:45'),(645,532,'N','01','021','EC','A',NULL,NULL,'','0000784346','0000481054','','IL','1','Bates','Diana','','','','34','274022310','2664 N KEARNEY CT',0,'XENIA','OH','45385','5705','CY','39057','1978-12-14','F','',':RET:2036-2','N','021','DEN','1892374','99734OH005000401','2014-01-01','2013-12-16 15:38:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:27'),(2815,2276,'Y','18','021','EC','A','','','AC','0000107637','0000107637','TX00001154138','IL','1','Gonzales','Ashley','','','','34','641100742','3406 SANDIE LN',0,'EDINBURG','TX','78542','7038','CY','48215','1989-09-20','F','U',':RET:2106-3','N','021','DEN','344206','33348TX002000201','2014-01-01','2013-11-24 12:44:13','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 20:00:22'),(23561,18769,'Y','18','021','EC','A','','','AC','0000145428','0000145428','OH00002263050','IL','1','Park','Margo','','','','34','302427862','2614 DALEFORD DR',0,'TOLEDO','OH','43614','5641','CY','39095','1952-01-18','F','M',NULL,'N','021','HLT','3195090','92036OH005002605','2014-03-01','2014-02-13 14:55:30','422.00',NULL,NULL,'560.22','138.22','R-OH001','OH0','560.22',NULL,0,'2014-02-13 22:02:43'),(8090,6405,'N','01','021','EC','A',NULL,NULL,'','0000096388','0000126963','','IL','1','King','Sherdian','','','','34','405886873','10864 CABLE AVE',0,'WHITEHOUSE','OH','43571','9609','CY','39095','1972-09-24','M','',':RET:2106-3','T','021','HLT','1994855','92036OH002002601','2014-01-01','2013-12-20 18:31:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','337.18',NULL,0,'2013-12-26 03:10:39'),(326,268,'Y','18','021','EC','A','','','AC','0000366812','0000366812','MS00000022066','IL','1','Gonzalez','Valerie','','','','34','643017288','1773 Popps Ferry Rd',0,'Biloxi','MS','39532',NULL,'CY','28047','1987-01-29','F','U',NULL,'N','021','DEN','631698','46300MS002000101','2014-01-01','2013-11-13 14:06:15','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 17:31:30'),(23538,18751,'Y','18','021','EC','A','','','AC','0001815613','0001815613','LA00002773888','IL','1','DANIELS','PAT','TURNER','','','34','436170360','532 CHINANOOK RD',0,'ELM GROVE','LA','71051','8602','CY','22015','1960-01-24','F','U',':RET:2054-5','N','021','DEN','3588320','18575LA002000201','2014-03-01','2014-02-13 12:32:07','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-13 22:02:31'),(22503,17964,'Y','18','021','EC','A','','','AC','0000195181','0000195181','OH00002126095','IL','1','MAROUS','TAMMY','','','','34','297664313','1432 GENESEE AVE',0,'MAYFIELD HEIGHTS','OH','44124','1720','CY','39035','1959-12-14','F','U',':RET:2106-3','N','021','DEN','3742724','99734OH005000301','2014-03-01','2014-02-10 15:54:30','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:14'),(20325,16228,'Y','18','024','14','A','','','TE','0001183755','0001183755','','IL','1','VASQUEZ','MARIA','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-27','F','',NULL,NULL,NULL,'','3049375','','2014-01-28','2014-01-28 16:19:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:58'),(5718,4539,'Y','18','021','EC','A','','','AC','0001721766','0001721766','LA00000983981','IL','1','Freeman','Ludwig','','','','34','435836686','2225 College Dr.',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1987-01-02','M','U',':RET:2054-5','N','021','DEN','2495626','18575LA002000201','2014-01-01','2013-12-23 21:02:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:19'),(5025,3983,'Y','18','021','EC','A','','','AC','0000894603','0000894603','OH00000211253','IL','1','Valentine','Traimone','Ishmael','','','34','287969940','463 Dewdrop Circle',0,'Forest Park','OH','45240',NULL,'CY','39061','1993-09-26','M','U',':RET:1002-5^:RET:2054-5','N','021','HLT','50146','92036OH004001201','2014-01-01','2013-12-07 11:18:29','50.36',NULL,NULL,'109.61','59.25','R-OH004','OH0','109.61',NULL,0,'2013-12-25 22:47:40'),(2605,2116,'Y','18','021','EC','A','','','AC','0000159380','0000159380','OH00000999435','IL','1','Upshaw','Deva','','','','34','286684991','2072 BICKEL AVE',0,'CINCINNATI','OH','45214','1110','CY','39061','1971-10-29','F','U',':RET:2054-5','T','021','DEN','16471','99734OH005000401','2014-01-01','2013-12-02 07:59:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:27'),(19721,15716,'Y','18','021','EC','A','','','AC','0001636345','0001636345','LA00002213260','31','1','Yambra','Kenneth','','','','34','433532585','4420 Newlands St.',0,'Metairie','LA','70006',NULL,'CY','22071','1981-11-29','M','M',':RET:2106-3','N','021','DEN','2394797','18575LA002000201','2014-03-01','2014-01-22 21:42:12','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:00:59'),(13865,11062,'Y','18','021','EC','A','','','AC','0000166374','0000166374','OH00001048805','IL','1','Thompson','James','','','','34','299644575','1677 LILLIAN RD',0,'STOW','OH','44224','2536','CY','39153','1963-07-06','M','U',':RET:2106-3','T','021','HLT','1593182','52664OH151001501','2014-01-01','2013-12-23 07:53:26','158.00',NULL,NULL,'719.19','561.19','R-OH012','OH0','549.35',NULL,0,'2013-12-26 13:12:54'),(14386,11474,'Y','18','021','EC','A','','','AC','0000796970','0000796970','OH00000055699','IL','1','Love','Nathaniel','','','Sr','34','258083010','1097 LANCER WAY',0,'COLUMBUS','OH','43213','3370','CY','39049','1959-10-17','M','M',':RET:2054-5','N','021','DEN','1926552','99734OH005000401','2014-02-01','2013-12-27 14:14:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:52'),(19173,15274,'N','01','021','EC','A',NULL,NULL,'','0001228130','0000405330','','IL','1','Mixon','Kelsey',NULL,NULL,NULL,NULL,NULL,'907 W 4TH ST',0,'LAMPASAS','TX','76550','2522','CY','48281','1981-06-02','F','',':RET:2106-3','N','021','DEN','2758280','33348TX002000201','2014-03-01','2014-01-20 11:58:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:46:03'),(18609,14834,'Y','18','021','EC','A','','','AC','0000374726','0000374726','OH00002322713','IL','1','WILSON-GENTRY','TERRY','A','','','34','295547172','1124 HOLLY AVE',0,'DAYTON','OH','45410',NULL,'CY','39113','1953-08-15','F','M',':RET:2106-3','N','021','HLT','2344785','92036OH002000501','2014-02-01','2014-01-15 12:35:13','300.00',NULL,NULL,'745.01','445.01','R-OH003','OH0','745.01',NULL,0,'2014-01-16 08:47:22'),(26593,21084,'N','01','021','EC','A',NULL,NULL,'','0000717875','0000106768','','IL','1','CAVILEER','JOHN','','','','34','289784818','40 WALDORF DR',0,'AKRON','OH','44313','6226','CY','39153','1981-12-31','M','',':RET:2106-3','N','021','HLT','3847575','52664OH152000901','2014-01-01','2014-02-28 12:21:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','193.23',NULL,0,'2014-02-28 21:30:37'),(17209,13771,'Y','18','021','EC','A','','','AC','0000983847','0000983847','OH00001272578','IL','1','Loucks','Debra','','','','34','279507365','525 TAYLOR AVE',0,'AKRON','OH','44312','3573','CY','39153','1951-03-26','F','U',':RET:2106-3','N','021','HLT','2056087','52664OH151001304','2014-02-01','2014-01-08 10:49:37','447.00',NULL,NULL,'640.70','193.70','R-OH012','OH0','640.70',NULL,0,'2014-01-13 02:22:28'),(27383,21680,'Y','18','021','EC','A','','','AC','0000592937','0000592937','MS00003099834','IL','1','Gooden','Shondra','','','','34','587554559','1045 Flynt Drive',0,'Flowood','MS','39232',NULL,'CY','28121','1982-04-05','F','U',':RET:2054-5','N','021','DEN','2965820','46300MS002000201','2014-04-01','2014-03-03 23:28:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:22'),(27613,21838,'N','19','021','EC','A',NULL,NULL,'','0000008568','0000196517','','S1','1','Jones','Benjamin','B','','Sr','34','661015986','12538 N OAK HILLS PKWY',0,'BATON ROUGE','LA','70810','3239','CY','22033','1999-10-21','M','',':RET:2106-3','N','021','DEN','3113654','18575LA002000201','2014-04-01','2014-03-05 17:39:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22','CIC',0,'2014-03-05 21:00:29'),(386,319,'N','19','021','EC','A',NULL,NULL,'','0000827126','0001253513','','IL','1','McRae','Donald','','','','34','294887989','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1988-05-08','M','',':RET:2054-5','N','021','HLT','25262','92036OH004003201','2014-01-01','2013-12-03 18:22:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.41',NULL,0,'2013-12-25 17:45:50'),(23475,18698,'Y','18','021','EC','A','','','AC','0000836544','0000836544','TX00002428449','IL','1','CRAYTON','VIVIAN','','','','34','455495562','1703 RANDALL ST',0,'LONGVIEW','TX','75602','1449','CY','48183','1963-02-27','F','U',NULL,'N','021','DEN','3175678','33348TX002000201','2014-03-01','2014-02-13 16:48:38','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-13 22:01:51'),(2487,2026,'Y','18','021','EC','A','','','AC','0000066624','0000066624','LA00000056284','IL','1','young','sharon','','','','34','269463749','1025a Royal Street',0,'New Orleans','LA','70116',NULL,'CY','22071','1954-03-31','F','M',':RET:2106-3','N','021','DEN','446882','18575LA002000201','2014-01-01','2013-12-09 16:01:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:41'),(21154,16903,'Y','18','021','EC','A','','','AC','0000260503','0000260503','OH00001889129','IL','1','Butcher','Simone','','','','34','324868210','1848 Sunset Ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1988-12-08','F','U',':RET:2054-5','N','021','DEN','1890963','99734OH005000401','2014-03-01','2014-02-02 22:28:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:29'),(4961,3937,'N','01','021','EC','A',NULL,NULL,'','0000811959','0001024988','','IL','1','Governale','Janice','','','','34','433866709','30175 HUFF CHAPEL RD',0,'SPRINGFIELD','LA','70462','6927','CY','22063','1951-01-28','F','',':RET:2106-3','N','021','DEN','1031836','18575LA002000201','2014-01-01','2013-12-07 10:30:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:46:09'),(20192,16112,'N','01','021','EC','A',NULL,NULL,'','0000471047','0000951833','','IL','1','Longmire','Ronnie','Eugene','','','34','301484364','3230 Leatherwood Creek road',0,'Sidney','OH','45365',NULL,'CY','39149','1948-08-12','M','',NULL,'N','021','HLT','3028613','92036OH004000501','2014-03-01','2014-01-27 03:48:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','573.40',NULL,0,'2014-01-27 21:01:27'),(4647,3683,'N','01','021','EC','A',NULL,NULL,'','0000705950','0000974301','','IL','1','HENRY','ANTHONY','GLENN','','','34','336646475','3627 HOOD DR',0,'PEARL','MS','39208','3806','CY','28121','1972-06-03','M','',':RET:2054-5','N','021','DEN','1198421','46300MS002000201','2014-01-01','2013-12-12 18:32:05',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 22:06:56'),(4550,3605,'N','19','021','EC','A',NULL,NULL,'','0001183512','0000538242','','IL','1','Daugherty','Megan','','','','34','301941497','9275 DANIELS RD',0,'SEVILLE','OH','44273','8843','CY','39103','1992-08-04','F','',':RET:2106-3','N','021','HLT','918505','52664OH152000901','2014-01-01','2013-12-12 09:02:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2013-12-25 22:04:32'),(19952,15915,'Y','18','024','14','A','','','TE','0001747632','0001747632','','IL','1','oneal','timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-10','M','',NULL,NULL,NULL,'','1654623','','2014-01-25','2014-01-25 10:47:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-25 19:00:04'),(19233,15325,'N','01','021','EC','A',NULL,NULL,'','0001157590','0000561706','','IL','1','Collett','Kathleen','','','','34','277525011','6755 WINDWARD HILLS DR',0,'BRECKSVILLE','OH','44141','2469','CY','39035','1952-12-28','F','',NULL,'N','021','DEN','1801575','99734OH005000301','2014-03-01','2014-01-20 12:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:46:33'),(19001,15133,'Y','18','021','EC','A','','','AC','0001834726','0001834726','LA00001785657','IL','1','kempe','bruce','','','','34','111423610','1660 ORLEANS ST',0,'MANDEVILLE','LA','70448','3949','CY','22103','1951-10-10','M','U',':RET:2106-3','N','021','DEN','2672176','18575LA002000201','2014-03-01','2014-01-16 21:27:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-20 08:06:16'),(13460,10734,'Y','18','021','EC','A','','','AC','0000723902','0000723902','OH00000305425','S3','1','Caldwell','Rachel','','','','34','289114988','3131 ARLINGTOWNE LN',0,'UPPER ARLINGTON','OH','43221','2504','CY','39049','2005-11-10','F','U',':RET:1002-5^:RET:2054-5^:RET:2039-6^:RET:2106','N','021','DEN','2441987','99734OH005000301','2014-01-01','2013-12-23 15:02:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13',NULL,0,'2013-12-26 13:01:44'),(16551,13241,'Y','18','021','EC','A','','','AC','0000908038','0000908038','OH00001940196','31','1','smith','Miriam','','','','34','282583910','Po Box 638',0,'Saint Paris','OH','43072',NULL,'CY','39021','1956-04-10','F','M',':RET:2106-3','N','021','HLT','1708595','92036OH004000501','2014-02-01','2014-01-05 13:26:56','1075.55',NULL,NULL,'1083.47','7.92','R-OH003','OH0','465.80',NULL,1,'2014-01-07 10:22:44'),(24142,19185,'Y','18','021','EC','A','','','AC','0001044525','0001044525','OH00002176922','IL','1','WOODWARD','DANITA','','','','34','406087322','122 southern trace',0,'cincinnati','OH','45255',NULL,'CY','39025','1962-12-29','F','U',':RET:2106-3','T','021','HLT','3195156','92036OH004000601','2014-03-01','2014-02-15 10:59:52','140.00',NULL,NULL,'370.22','230.22','R-OH005','OH0','370.22',NULL,0,'2014-02-15 22:01:52'),(25996,20617,'Y','18','021','EC','A','','','AC','0001070314','0001070314','MS00001936032','IL','1','franklin','tekita','','','','34','425696652','144 melrose drive',0,'jackson','MS','39211',NULL,'CY','28049','1990-03-24','F','U',':RET:2054-5','N','021','DEN','3842250','46300MS002000201','2014-03-01','2014-02-26 16:47:00','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:02:00'),(28440,22503,'Y','18','021','EC','A','','','AC','0001459188','0001459188','LA00003572692','IL','1','WASHINGTON','ARLANDA','','','','34','435969331','1330 BURCHETT ST',0,'BOSSIER CITY','LA','71112','3321','CY','22015','1955-04-22','F','M',':RET:2054-5','T','021','DEN','4050357','18575LA002000201','2014-04-01','2014-03-06 18:45:52','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-07 21:31:13'),(215,180,'Y','18','021','EC','A','','','AC','0000111724','0000111724','LA00000054729','IL','1','Hanson','Sarah','','','','34','434617857','333 N SAINT PATRICK ST',0,'NEW ORLEANS','LA','70119','4426','CY','22071','1982-07-10','F','U',':RET:2106-3','N','021','DEN','676979','18575LA002000201','2014-01-01','2013-12-05 06:04:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:20:35'),(23360,18613,'N','01','021','EC','A',NULL,NULL,'','0001146013','0000265287','','IL','1','Maroun','Nada','','','','34','286157532','83 TRUNKO RD',0,'FAIRLAWN','OH','44333','3403','CY','39153','1966-04-03','F','',NULL,'N','021','HLT','3205619','52664OH151001306','2014-03-01','2014-02-13 15:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.56',NULL,0,'2014-02-13 22:00:45'),(20788,16610,'Y','18','021','EC','A','','','AC','0000168969','0000168969','TX00002455208','IL','1','Trauthwein','Carol','','','','34','386609802','4 MUSKMALLOW CT',0,'THE WOODLANDS','TX','77380','1520','CY','48339','1953-12-22','F','M',':RET:2106-3','N','021','DEN','3266534','33348TX002000201','2014-03-01','2014-01-31 09:17:46','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-31 21:00:14'),(1033,847,'Y','18','021','EC','A','','','AC','0000361659','0000361659','TX00001035942','IL','1','Kay','Richard','','','','34','493561657','14722 CELESTIAL PL',0,'DALLAS','TX','75254','7560','CY','48113','1950-04-04','M','M',':RET:2106-3','N','021','DEN','919683','33348TX002000201','2014-01-01','2013-12-03 13:00:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:15:33'),(14544,11604,'N','01','021','EC','A',NULL,NULL,'','0000319055','0000596575','','IL','1','McNEAL','GWENDOLYN','','','','34','587644631','151 MCCARTY RD',0,'JACKSON','MS','39212','9674','CY','28049','1952-05-15','F','',':RET:2054-5','N','021','DEN','2029579','46300MS002000201','2014-02-01','2013-12-27 14:19:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-28 03:34:50'),(14338,11438,'Y','18','024','14','A','','','TE','0000110495','0000110495','','IL','1','hopwood','william',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-06-05','M','',NULL,NULL,NULL,'','594232','','2013-12-26','2013-12-26 14:57:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:07:48'),(25009,19833,'Y','18','021','EC','A','','','AC','0000438023','0000438023','OH00001864431','IL','1','LAWHORN','ELIZABETH','','','','34','280763080','8117 GARFIELD BLVD',0,'GARFIELD HEIGHTS','OH','44125','1227','CY','39035','1965-12-29','F','U',':RET:2106-3','T','021','HLT','3339824','52664OH151001304','2014-04-01','2014-02-20 15:01:40','149.00',NULL,NULL,'472.92','323.92','R-OH011','OH0','472.92',NULL,0,'2014-02-20 22:00:51'),(25802,20462,'Y','18','024','14','A','','','TE','0001138034','0001138034','','IL','1','Freed','Brandi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-07-16','F','',NULL,NULL,NULL,'','149639','','2014-03-13','2014-02-26 12:04:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 21:00:17'),(1756,1454,'Y','18','021','EC','A','','','AC','0001260013','0001260013','OH00000268030','IL','1','Bepler','Gary','Michael','','','34','288784310','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','1970-04-30','M','M',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:55:51'),(9599,7602,'N','01','021','EC','A',NULL,NULL,'','0000929834','0000937265','','IL','1','Morris','Carol','','','','34','291426536','3166 BIRD DR',0,'RAVENNA','OH','44266','9532','CY','39133','1949-10-09','F','',':RET:2106-3','N','021','HLT','1575777','52664OH151001304','2014-01-01','2013-12-21 09:33:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','669.00',NULL,0,'2013-12-26 04:37:22'),(17405,13929,'Y','18','024','14','A','','','TE','0001075471','0001075471','','IL','1','Bagwell','Ronnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-12-24','M','',NULL,NULL,NULL,'','2228452','','2014-01-09','2014-01-09 23:35:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 03:00:19'),(15997,12803,'Y','18','021','EC','A','','','AC','0000390704','0000390704','TX00000063281','IL','1','COLLINS','DWIGHT','','','','34','449943285','16930 WHIPPOORWILL RD',0,'NAVASOTA','TX','77868','8301','CY','48185','1951-07-20','M','U',':RET:2106-3','T','021','DEN','2043674','33348TX002000201','2014-02-01','2014-01-03 13:57:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:23'),(7623,6033,'Y','18','021','EC','A','','','AC','0001132939','0001132939','TX00000629915','IL','1','Limon','Mary','A','','','34','449949351','17970 S US HIGHWAY 281',0,'SAN BENITO','TX','78586','7095','CY','48061','1950-07-09','F','U',NULL,'N','021','DEN','621765','33348TX002000201','2014-01-01','2013-11-17 13:08:01','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 02:45:58'),(14424,11503,'Y','18','021','EC','A','','','AC','0000645366','0000645366','TX00000945259','IL','1','Voisine-Allen','Joan','M','','','34','525213462','210 NUNN AVE',0,'WHITEHOUSE','TX','75791','3428','CY','48423','1972-03-17','F','U',':RET:2106-3','N','021','DEN','1521978','33348TX002000101','2014-02-01','2013-12-27 14:43:26','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-28 03:31:45'),(7078,5616,'N','01','021','EC','A',NULL,NULL,'','0000137576','0001075308','','IL','1','Numbers','Ashley','','','','34','291989459','507 S Harrison St',0,'Montpelier','OH','43543',NULL,'CY','39171','1988-08-21','F','',':RET:2106-3','N','021','DEN','2198745','99734OH005000301','2014-01-01','2013-12-24 23:53:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:14'),(2794,2259,'Y','18','021','EC','A','','','AC','0000676436','0000676436','LA00000201056','IL','1','CORKERN','CYNTHIA','J','','','34','434849474','41481 MOCKINGBIRD HILL RD',0,'FRANKLINTON','LA','70438','4698','CY','22117','1951-01-21','F','M',':RET:2106-3','N','021','DEN','1126698','18575LA002000101','2014-01-01','2013-12-02 13:13:23','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:50:13'),(6710,5320,'Y','18','021','EC','A','','','AC','0000553879','0000553879','OH00000269632','IL','1','Bagoly','Matthew','','','','34','292907956','1636 WARREN RD',0,'LAKEWOOD','OH','44107','4016','CY','39035','1986-05-16','M','U',':RET:2106-3','N','021','HLT','274116','92036OH004000801','2014-01-01','2013-11-05 12:13:49','181.00',NULL,NULL,'197.01','16.01','R-OH011','OH0','197.01',NULL,0,'2013-12-26 01:02:13'),(5649,4481,'Y','18','021','EC','A','','','AC','0000943004','0000943004','TX00001256274','IL','1','Neal','Patricia','','','','34','450395101','404 COUNTY ROAD 1505',0,'CENTER','TX','75935','5707','CY','48419','1959-06-22','F','U',':RET:2106-3','N','021','DEN','440904','33348TX002000201','2014-01-01','2013-11-26 11:49:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:31:26'),(13842,11046,'Y','18','021','EC','A','','','AC','0000870629','0000870629','OH00000622791','S3','1','Malcolm','Amber','Michael',NULL,NULL,NULL,NULL,'185 Heartwood Dr',0,'Mogadore','OH','44260',NULL,'CY','39133','2007-09-28','M','U',':RET:2106-3','N','021','HLT','1362604','52664OH152000901','2014-01-01','2013-12-23 14:12:56','0.00',NULL,NULL,'103.72','103.72','R-OH012','OH0','103.72',NULL,0,'2013-12-26 13:12:20'),(3040,2444,'Y','18','021','EC','A','','','AC','0000664150','0000664150','OH00000563803','IL','1','Cook','Colleen','','','','34','301828510','533 EASTERN AVE',0,'ASHLAND','OH','44805','3324','CY','39005','1985-04-29','F','M',':RET:2106-3','N','021','HLT','485239','52664OH152000901','2014-01-01','2013-12-05 22:52:52','382.00',NULL,NULL,'466.66','84.66','R-OH012','OH0','177.55',NULL,0,'2013-12-25 20:18:38'),(24170,19202,'Y','18','021','EC','A','','','AC','0000711122','0000711122','MS00002463181','31','1','Williams','Dana','','','','34','427391952','P O Box 2026',0,'Ridgeland','MS','39158',NULL,'CY','28121','1964-06-04','F','U',':RET:2054-5','N','021','DEN','3612122','46300MS002000101','2014-03-01','2014-02-15 15:40:18','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-15 22:02:08'),(28361,22440,'Y','18','021','EC','A','','','AC','0000983967','0000983967','TX00003804091','IL','1','Scott','Amy','','','','34','458890002','20211 Emerald Cliff Ln',0,'Richmond','TX','77407',NULL,'CY','48157','1979-06-12','F','U',':RET:2054-5^:RET:2500-7','N','021','DEN','2796929','33348TX002000201','2014-04-01','2014-03-07 15:21:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:28'),(2316,1882,'Y','18','021','EC','A','','','AC','0000023490','0000023490','TX00000618690','IL','1','sandoval ore','maria','','','','34','621189137','4719 READING RD',0,'ROSENBERG','TX','77471','2151','CY','48157','1967-06-30','F','M',NULL,'N','021','DEN','457913','33348TX002000201','2014-01-01','2013-12-08 23:01:55','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:31:18'),(2943,2368,'Y','18','021','EC','A','','','AC','0001015547','0001015547','OH00000963070','IL','1','HAMILTON','CHERYL','LYNN','','','34','291626110','7330 MAR DEL DR',0,'CINCINNATI','OH','45243',NULL,'CY','39061','1962-06-12','F','U',':RET:2106-3','N','021','DEN','14009','99734OH005000401','2014-01-01','2013-12-06 12:36:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:16:18'),(17536,14020,'Y','18','021','EC','A','','','AC','0001060924','0001060924','OH00001527523','IL','1','usanovic','damir','','','','34','270028859','938 WESTVIEW CT',0,'MEDINA','OH','44256','7538','CY','39103','1973-02-24','M','M',':RET:2106-3','T','021','HLT','2397439','52664OH151001305','2014-02-01','2014-01-12 11:06:57','220.00',NULL,NULL,'600.27','380.27','R-OH012','OH0','327.75',NULL,0,'2014-01-13 03:01:45'),(17752,14184,'Y','18','021','EC','A','','','AC','0000541274','0000541274','MS00002295106','IL','1','Thompson','Kammie','','','','34','428570164','3077 VIRLILIA RD',0,'FLORA','MS','39071','9493','CY','28089','1985-06-29','F','U',':RET:2054-5','N','021','DEN','1846971','46300MS002000101','2014-02-01','2014-01-13 13:13:03','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-14 01:33:29'),(19776,15765,'N','01','021','EC','A',NULL,NULL,'','0000453948','0000160816','','IL','1','Richardson','Ethel','','','','34','293727007','144 W. Plumber St',0,'Toledo','OH','43605',NULL,'CY','39095','1964-11-27','F','',NULL,'N','021','HLT','1796581','92036OH006002601','2014-03-01','2014-01-23 16:39:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','263.83',NULL,0,'2014-01-23 21:01:31'),(21970,17544,'Y','18','021','EC','A','','','AC','0000706232','0000706232','OH00002218766','IL','1','nguyen','hieu','','','','34','293942409','765 corice st',0,'akron','OH','44306',NULL,'CY','39153','1989-03-15','M','U',':RET:2047-9','N','021','HLT','3201308','52664OH151001306','2014-03-01','2014-02-07 00:34:39','161.00',NULL,NULL,'223.01','62.01','R-OH012','OH0','223.01',NULL,0,'2014-02-07 19:00:30'),(22575,18030,'Y','18','021','EC','A','','','AC','0000614149','0000614149','OH00001824535','S3','1','ESTEP','DANIEL','','','','34','281116545','800 E CENTER ST',0,'BLANCHESTER','OH','45107',NULL,'CY','39027','2005-05-11','M','U',':RET:2106-3','N','021','HLT','3813323','92036OH005000604','2014-03-01','2014-02-10 09:28:42','0.00',NULL,NULL,'136.32','136.32','R-OH005','OH0','136.32',NULL,0,'2014-02-10 21:31:59'),(24892,19736,'Y','18','021','EC','A','','','AC','0001142218','0001142218','OH00002056776','IL','1','PATEL','BIPIN','R','','','34','314112645','9060 COUNTRY CLUB RD',0,'PIQUA','OH','45356','8570','CY','39109','1960-08-16','M','M',NULL,'N','021','HLT','3160392','92036OH004000501','2014-04-01','2014-02-19 12:19:20','702.00',NULL,NULL,'763.01','61.01','R-OH003','OH0','389.92','CIC',0,'2014-02-20 05:39:07'),(25382,20138,'Y','18','021','EC','A','','','AC','0000107087','0000107087','MS00002520204','IL','1','Morgan','Joseph','','','','34','529083167','1011 DANIEL ST',0,'WAVELAND','MS','39576','3407','CY','28045','1974-03-16','M','M',':RET:2106-3','T','021','DEN','3852214','46300MS002000101','2014-04-01','2014-02-25 11:12:38','0.00',NULL,NULL,'54.30','54.30','R-MS005','MS0','27.15',NULL,0,'2014-02-25 21:30:47'),(26890,21310,'N','01','021','EC','A',NULL,NULL,'','0000493301','0000199729','','IL','1','Gaskill','Stephanie','','','','34','298841499','506 Collins Ave',0,'Van Wert','OH','45891',NULL,'CY','39161','1976-09-15','F','',':RET:2106-3','N','021','HLT','3516931','92036OH003001505','2014-04-01','2014-03-02 15:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','284.53',NULL,0,'2014-03-03 01:00:02'),(7719,6113,'Y','18','024','14','A','','','TE','0000327246','0000327246','','IL','1','Adams','Edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-05-07','M','',NULL,NULL,NULL,'','1250327','','2013-12-20','2013-12-20 13:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:01:42'),(5637,4472,'Y','18','021','EC','A','','','AC','0000315246','0000315246','TX00000764622','IL','1','valderas','adam','','','','34','463711398','412 13th',0,'levelland','TX','79336',NULL,'CY','48219','1983-09-22','M','M',':RET:2106-3','N','021','DEN','499422','33348TX002000201','2014-01-01','2013-11-25 21:18:46','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:31:08'),(4294,3416,'Y','18','021','EC','A','','','AC','0001098922','0001098922','MS00000812617','IL','1','Cross','Roosevelt','','','','34','587326850','126 Brown Road East',0,'Canton','MS','39046',NULL,'CY','28089','1950-05-17','M','M',':RET:2054-5','N','021','DEN','2290217','46300MS002000201','2014-01-01','2013-12-17 12:59:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:52:13'),(15100,12069,'Y','18','024','14','A','','','TE','0000590764','0000590764','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','1610099','','2013-12-30','2013-12-30 09:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:04:41'),(13282,10601,'Y','18','021','EC','A','','','AC','0000168812','0000168812','TX00000826988','IL','1','chavez','nelda','','','','34','453459738','15914 GONZALEZ RD',0,'RAYMONDVILLE','TX','78580','4138','CY','48489','1969-11-14','F','U',':RET:2106-3','N','021','DEN','1467591','33348TX002000201','2014-01-01','2013-12-23 13:03:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:13'),(13040,10396,'Y','18','021','EC','A','','','AC','0000670256','0000670256','OH00000373850','IL','1','Crook','James','bryan','','','34','271504312','2008 GRANNY SMITH LN',0,'MIDDLETOWN','OH','45044','7998','CY','39017','1951-03-10','M','M',':RET:2106-3','N','021','DEN','1436660','99734OH005000401','2014-01-01','2013-12-23 07:00:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:35'),(4991,3961,'N','19','021','EC','A',NULL,NULL,'','0000327249','0000249096','','IL','1','Rice','Zachary','','','','34','293086205','5137 RIVERVIEW DR',0,'SOUTH LEBANON','OH','45065','8782','CY','39165','2004-01-30','M','',':RET:2106-3','N','021','DEN','272020','99734OH005000301','2014-01-01','2013-12-06 21:42:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:58'),(21373,17082,'N','19','021','EC','A',NULL,NULL,'','0000926620','0000850709','','IL','1','Ortega','Amanda','Rose','','','34','613360465','1037 TWIN ESTATES DR',0,'KYLE','TX','78640',NULL,'CY','48209','1988-05-23','F','',':RET:2106-3','N','021','DEN','2980138','33348TX002000201','2014-03-01','2014-02-04 17:43:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-04 21:00:49'),(23706,18875,'N','19','021','EC','A',NULL,NULL,'','0000231548','0001093180','','IL','1','KIM','TERRY','','','','34','374213088','5656 E FOUNTAIN CIR',0,'MASON','OH','45040','7310','CY','39165','1997-01-24','M','',':RET:2040-4','N','021','DEN','2796352','99734OH005000401','2014-03-01','2014-02-14 12:16:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:44'),(25021,19840,'Y','18','024','14','A','','','TE','0000780238','0000780238','','IL','1','perry','kwame',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-23','M','',NULL,NULL,NULL,'','517067','','2014-03-06','2014-02-19 19:30:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-20 22:00:57'),(26168,20749,'N','01','021','EC','A',NULL,NULL,'','0000555844','0000167469','','IL','1','long','james','','','','34','460657742','440 Parker Street',0,'Florence','MS','39073',NULL,'CY','28121','1983-03-07','M','',':RET:2106-3','N','021','DEN','3876355','46300MS002000201','2014-04-01','2014-02-26 20:12:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-28 06:30:35'),(28562,22605,'Y','18','021','EC','A','','','AC','0000130763','0000130763','OH00003451374','IL','1','Henderson','Jeffrey','R','','','34','273907879','4132 ROUTT LN',0,'FRANKLIN','OH','45005','4648','CY','39165','1981-10-27','M','M',':RET:2106-3','N','021','HLT','3450176','92036OH003001205','2014-04-01','2014-03-07 14:00:46','541.00',NULL,NULL,'822.08','281.08','R-OH004','OH0','265.21',NULL,0,'2014-03-07 21:32:26'),(110,97,'Y','18','021','EC','A','','','AC','0000097382','0000097382','TX00001059987','IL','1','le','bill','','','','34','586425269','4400 texas blvd',0,'texarkana','TX','75503',NULL,'CY','48037','1968-06-10','M','M',':RET:2047-9','N','021','DEN','535951','33348TX002000201','2014-01-01','2013-12-05 11:59:15','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2013-12-25 17:17:57'),(17173,13741,'Y','18','021','EC','A','','','AC','0000538283','0000538283','OH00001566491','IL','1','Neiman','Robert','','','','34','279501531','2054 LARCHMONT RD',0,'AKRON','OH','44313','6053','CY','39153','1953-11-04','M','U',NULL,'N','021','DEN','1873125','99734OH005000301','2014-02-01','2014-01-07 21:50:34','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:22:08'),(5761,4576,'Y','18','021','EC','A','','','AC','0000495456','0000495456','OH00001239508','IL','1','craig','denna','ann','','','34','311721690','12382 BENTWOOD FARMS DR',0,'PICKERINGTON','OH','43147','8483','CY','39045','1962-10-31','F','U',NULL,'T','021','DEN','2547354','99734OH005000401','2014-01-01','2013-12-23 21:56:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:31'),(16454,13167,'Y','18','021','EC','A','','','AC','0000813101','0000813101','OH00002003353','IL','1','GRIFFIN','STANLEY','J','','Jr','34','382686817','857 BURKE GLEN RD',0,'TOLEDO','OH','43607','2508','CY','39095','1958-09-19','M','U',':RET:2054-5','N','021','HLT','1592410','92036OH002002601','2014-02-01','2014-01-06 10:05:38','342.00',NULL,NULL,'502.17','160.17','R-OH001','OH0','502.17',NULL,0,'2014-01-07 04:05:31'),(5173,4104,'Y','18','021','EC','A','','','AC','0000912943','0000912943','OH00001039182','IL','1','SPENCE','MINDI','','','','34','295547066','3224 SUMMERTIME CT',0,'COLUMBUS','OH','43221','4637','CY','39049','1968-10-10','F','U',':RET:2106-3','N','021','DEN','1531482','99734OH005000401','2014-01-01','2013-12-19 11:53:24','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:03:22'),(15801,12648,'Y','18','021','EC','A','','','AC','0001959782','0001959782','LA00000055821','IL','1','Dedon','Stacy','','','','34','437457897','1335 BELLE TERRE DR',0,'SAINT GABRIEL','LA','70776','5221','CY','22047','1977-11-14','F','R',':RET:2106-3','N','021','DEN','1802490','18575LA002000201','2014-02-01','2014-01-02 09:58:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:52'),(15104,12072,'Y','18','021','EC','A','','','AC','0001053065','0001053065','OH00001106425','IL','1','courtney','justin','','','','34','279821699','268 MAIN ST',0,'ADDYSTON','OH','45001','5000','CY','39061','1978-07-18','M','U',':RET:2106-3','N','021','DEN','1576205','99734OH005000301','2014-02-01','2013-12-30 10:00:40','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:04:46'),(14515,11581,'Y','18','021','EC','A','','','AC','0000440633','0000440633','TX00000295448','IL','1','JONES','HOLLIS','','','','34','546311194','702 S CLAY ST',0,'MIDLAND','TX','79701','7634','CY','48329','1959-12-09','M','U',NULL,'N','021','DEN','2310993','33348TX002000201','2014-02-01','2013-12-27 16:18:06','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-28 03:34:09'),(14378,11469,'Y','18','021','EC','A','','','AC','0000077573','0000077573','OH00000415199','IL','1','AREHART','WILLIAM','','','','34','268747549','2968 WILSON RD',0,'WILMINGTON','OH','45177','9373','CY','39027','1967-11-09','M','M',NULL,'N','021','DEN','2038412','99734OH005000401','2014-02-01','2013-12-27 12:03:57','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-28 03:30:43'),(2885,2332,'Y','18','021','EC','A','','','AC','0001241833','0001241833','OH00001289128','IL','1','domer','david','','','','34','297582411','2965 SMITH KRAMER ST NE',0,'HARTVILLE','OH','44632','9706','CY','39151','1956-07-13','M','M',':RET:2106-3','N','021','HLT','1087758','52664OH151001501','2014-01-01','2013-12-05 19:02:51','666.00',NULL,NULL,'1515.73','849.73','R-OH015','OH0','651.81',NULL,0,'2013-12-25 20:15:03'),(8935,7084,'Y','18','021','EC','A','','','AC','0000665627','0000665627','OH00001067751','IL','1','Mole','Thomas','','','','34','083706757','515 and a half Evergreen Street',0,'Ashland','OH','44805',NULL,'CY','39005','1980-12-19','M','U',':RET:2106-3','N','021','DEN','2113107','99734OH005000401','2014-01-01','2013-12-18 10:29:45','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:03:09'),(18126,14476,'Y','18','021','EC','A','','','AC','0000542704','0000542704','OH00001459002','IL','1','MARTIN','LINDA','LOU','','','34','300447017','586 KIMBER RD',0,'WOOSTER','OH','44691','8325','CY','39169','1950-05-16','F','M',':RET:2106-3','N','021','HLT','1801451','52664OH152000901','2014-02-01','2014-01-14 18:27:22','305.00',NULL,NULL,'482.18','177.18','R-OH014','OH0','482.18',NULL,0,'2014-01-15 02:07:42'),(19500,15541,'N','01','021','EC','A',NULL,NULL,'','0000584304','0000142856','','IL','1','Caskey','Sandra','','','','34','293724589','14847 FOSNIGHT RD',0,'ORRVILLE','OH','44667','9716','CY','39169','1964-02-22','F','',NULL,'N','021','HLT','2307491','52664OH151001305','2014-03-01','2014-01-22 12:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.29',NULL,0,'2014-01-23 03:02:10'),(23872,18996,'Y','18','024','14','A','','','TE','0001066019','0001066019','','IL','1','Simmons','Kathrine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-10-03','F','',NULL,NULL,NULL,'','2731792','','2014-02-14','2014-02-14 11:23:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:32:11'),(27358,21666,'Y','18','021','EC','A','','','AC','0001031515','0001031515','OH00002576966','IL','1','Iliev','Pepa','','','','34','293983283','4323 LORWOOD DR',0,'STOW','OH','44224','2734','CY','39153','1961-06-09','F','M',NULL,'N','021','DEN','3803723','99734OH005000401','2014-04-01','2014-03-04 15:59:14','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2014-03-04 21:01:10'),(7160,5679,'Y','18','021','EC','A','','','AC','0000432764','0000432764','OH00001507261','IL','1','Calcutta','Amanda','','','','34','281746568','1808 PERSHING BLVD',0,'DAYTON','OH','45420','2427','CY','39113','1975-01-10','F','U',':RET:2106-3','N','021','HLT','1906154','92036OH004000501','2014-01-01','2013-12-24 21:11:00','0.00',NULL,NULL,'238.17','238.17','R-OH003','OH0','238.17',NULL,0,'2013-12-26 01:52:25'),(3387,2716,'Y','18','021','EC','A','','','AC','0001837241','0001837241','LA00001092644','IL','1','Handy','Amor','','','','34','433611911','5140 Weaver Rd',0,'Lake Charles','LA','70605',NULL,'CY','22019','1979-06-24','M','U',':RET:2054-5','N','021','DEN','1809272','18575LA002000201','2014-01-01','2013-12-21 18:57:53','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 21:17:42'),(15115,12082,'Y','18','021','EC','A','','','AC','0000280843','0000280843','OH00001767508','IL','1','Butto','Joseph','','','','34','279481191','221 BEAVER AVE',0,'NILES','OH','44446','2606','CY','39155','1951-10-17','M','M',':RET:2106-3','T','021','DEN','1678632','99734OH005000301','2014-02-01','2013-12-30 15:17:16','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-01-01 12:05:06'),(4431,3522,'Y','18','021','EC','A','','','AC','0001095634','0001095634','OH00001304827','IL','1','Piesciuk','Stephen','','','','34','066469661','3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-07-18','M','M',':RET:2106-3','N','021','DEN','601255','99734OH005000401','2014-01-01','2013-12-12 18:11:27','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:01:53'),(18928,15082,'Y','18','021','EC','A','','','AC','0000500418','0000500418','OH00001597731','IL','1','Sterling','Mary','K','','','34','405725523','2896 LINWOOD AVE',0,'CINCINNATI','OH','45208','2851','CY','39061','1949-08-16','F','U',NULL,'T','021','DEN','2660435','99734OH005000401','2014-03-01','2014-01-17 10:08:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:05:36'),(21072,16838,'Y','18','021','EC','A','','','AC','0000600832','0000600832','OH00002314200','IL','1','Priess','Elizabeth','','','','34','283465220','112 WARWICK CT',0,'ELYRIA','OH','44035','4626','CY','39093','1961-03-19','F','U',':RET:2106-3','N','021','DEN','3547271','99734OH005000401','2014-03-01','2014-02-01 22:43:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-02 19:00:17'),(26533,21040,'N','19','021','EC','A',NULL,NULL,'','0000273849','0000843393','','IL','1','Robinson','Jolecia','','','','34','286087469','844 Ashburton Rd',0,'Columbus','OH','43227',NULL,'CY','39049','2003-08-23','F','',':RET:2054-5','N','021','DEN','2635297','99734OH005000301','2014-03-01','2014-02-27 18:02:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:03'),(26776,21221,'Y','18','021','EC','A','','','AC','0000395046','0000395046','TX00002844753','IL','1','Elwood','Danielle','','','','34','643282345','702 E HUBBARD ST',0,'LINDALE','TX','75771','3323','CY','48423','1987-12-16','F','M',':RET:2106-3','N','021','DEN','2646766','33348TX002000201','2014-03-01','2014-02-28 21:04:32','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-03-01 21:00:10'),(28060,22205,'Y','18','021','EC','A','','','AC','0000516968','0000516968','OH00002882525','IL','1','McAlpin','James','','','','34','407112994','6719 SHELBURNE CT',0,'LIBERTY TOWNSHIP','OH','45044','9685','CY','39017','1964-09-05','M','U',':RET:2106-3','N','021','DEN','2801913','99734OH005000301','2014-04-01','2014-03-05 23:05:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:43'),(28376,22452,'N','19','021','EC','A',NULL,NULL,'','0000175171','0000241583','','IL','1','Werring','William','','','','34','271988396','4009 MOORE MARATHON RD',0,'WILLIAMSBURG','OH','45176','8231','CY','39025','1994-10-11','M','',':RET:2106-3','N','021','HLT','4225138','92036OH005000601','2014-04-01','2014-03-07 10:43:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-03-07 21:30:36'),(232,195,'N','19','021','EC','A',NULL,NULL,'','0000337587','0000112907','','IL','1','reiser','angela','','','','34','268984771','415 FLEMRIDGE CT',0,'WYOMING','OH','45231','4015','CY','39061','1994-07-27','F','',':RET:2106-3','N','021','HLT','481342','92036OH006001201','2014-01-01','2013-12-05 18:00:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-25 17:21:05'),(977,800,'Y','18','021','EC','A','','','AC','0000128068','0000128068','OH00000668098','IL','1','MOORE','JENNIFER','','','','34','291788981','1233 WILSON RD',0,'WILMINGTON','OH','45177','8712','CY','39027','1972-01-12','F','U',':RET:2106-3','N','021','HLT','101526','92036OH005000606','2014-01-01','2013-10-28 20:37:15','251.00',NULL,NULL,'279.50','28.50','R-OH005','OH0','279.50',NULL,0,'2013-12-25 18:10:11'),(13515,10773,'Y','18','021','EC','A','','','AC','0002029223','0002029223','LA00000041128','IL','1','Layfield','Luke','','','','34','438718863','760 Magazine St',0,'New Orleans','LA','70130',NULL,'CY','22071','1986-02-20','M','U',':RET:2106-3','N','021','DEN','2593916','18575LA002000201','2014-01-01','2013-12-23 00:11:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:02'),(13380,10682,'N','01','021','EC','A',NULL,NULL,'','0000110519','0000708934','','IL','1','jakupca','jason','','','','34','271808724','9418 DOROTHY AVE',0,'GARFIELD HEIGHTS','OH','44125','1417','CY','39035','1979-06-03','M','',NULL,'N','021','DEN','2538334','99734OH005000301','2014-01-01','2013-12-22 22:57:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:53'),(8990,7132,'Y','18','024','14','A','','','TE','0000165035','0000165035','','IL','1','Miles','Julie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-20','F','',NULL,NULL,NULL,'','40625','','2013-12-18','2013-12-18 17:08:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:04:33'),(8913,7069,'Y','18','021','EC','A','','','AC','0001136643','0001136643','OH00000252351','IL','1','ryan','james','','','','34','284541280','82 S 33RD ST',0,'NEWARK','OH','43055','1919','CY','39089','1954-03-29','M','M',':RET:2106-3','N','021','DEN','2055272','99734OH005000401','2014-01-01','2013-12-17 23:42:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:37'),(4461,3544,'N','19','021','EC','A',NULL,NULL,'','0000575896','0000319642','','IL','1','Warren','Danielle','A','','','34','268029794','1410 Springfield Pike',0,'Wyoming','OH','45215',NULL,'CY','39061','1996-08-06','F','',':RET:2054-5','N','021','DEN','986308','99734OH005000301','2014-01-01','2013-12-12 12:01:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:37'),(1356,1123,'N','17','021','EC','A',NULL,NULL,'','0001135501','0000042071','','IL','1','Maresh','Sophie','','','','34','627427549','2303 GREENLEE DR',0,'AUSTIN','TX','78703','1710','CY','48453','1994-03-18','F','',NULL,'N','021','DEN','1696004','33348TX002000101','2014-01-01','2013-12-24 13:37:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2013-12-25 18:45:24'),(6002,4752,'Y','18','021','EC','A','','','AC','0000030130','0000030130','LA00001254857','31','1','Jackson','Kayla','','','','34','438810430','P.o box 961',0,'Baldwin','LA','70514',NULL,'CY','22101','1991-05-28','F','R',':RET:2054-5','N','021','DEN','1117322','18575LA002000201','2014-01-01','2013-12-01 11:22:50','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:00:23'),(27002,21386,'Y','18','021','EC','A','','','AC','0000569275','0000569275','OH00003075203','IL','1','Brown','Dennis','','','','34','270504376','891 STONEWATER DR',0,'KENT','OH','44240','2052','CY','39133','1950-04-03','M','M',':RET:2106-3','N','021','DEN','3800132','99734OH005000401','2014-04-01','2014-03-03 08:58:07','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-03-03 21:00:02'),(27632,21856,'N','19','021','EC','A',NULL,NULL,'','0000699334','0001077818','','IL','1','Chung','Katherine','','','','34','306156664','9424 EASTBROOK DR',0,'MIAMISBURG','OH','45342','7871','CY','39113','1994-02-10','F','',':RET:2040-4','N','021','DEN','3199599','99734OH005000401','2014-04-01','2014-03-05 09:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:11'),(157,131,'Y','18','021','EC','A','','','AC','0000008681','0000008681','TX00000591068','IL','1','Robledo','Esther','G','','','34','627503315','126 FUTURE DR',0,'SAN ANTONIO','TX','78213','3539','CY','48029','1956-07-02','F','M',':RET:2106-3','N','021','DEN','1037029','33348TX002000101','2014-01-01','2013-12-05 17:17:05','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 17:19:05'),(666,549,'N','01','021','EC','A',NULL,NULL,'','0000433862','0000727252','','IL','1','berry','michael','','','','34','275608673','12 n hazelwood',0,'youngstown','OH','44509',NULL,'CY','39099','1958-01-05','M','',':RET:2106-3','N','021','DEN','1703099','99734OH005000301','2014-01-01','2013-12-16 08:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:00'),(13509,10767,'Y','18','021','EC','A','','','AC','0002250111','0002250111','LA00000921732','IL','1','Nguyen','Phuong','','','','34','435792045','837 MORNINGSIDE DR',0,'TERRYTOWN','LA','70056','4504','CY','22051','1962-08-03','M','U',':RET:2047-9','N','021','DEN','2527166','18575LA002000201','2014-01-01','2013-12-22 21:55:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:02:50'),(768,634,'Y','18','021','EC','A','','','AC','0000811898','0000811898','TX00000911888','IL','1','MARTINEZ','LUIS','','','','34','451027296','1929 KING ARTHUR',0,'EAGLE PASS','TX','78852',NULL,'CY','48323','1952-03-13','M','U',NULL,'N','021','DEN','2104636','33348TX002000201','2014-01-01','2013-12-16 12:12:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:44'),(3915,3133,'Y','18','021','EC','A','','','AC','0000771881','0000771881','TX00001103189','IL','1','MILO','SCHOSKEY','','','','34','436045692','2200 MARY ST',0,'HOUSTON','TX','77026','6828','CY','48201','1958-01-31','M','U',NULL,'N','021','DEN','338674','33348TX002000101','2014-01-01','2013-12-13 15:18:02','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 21:37:13'),(17325,13858,'Y','18','021','EC','A','','','AC','0001452404','0001452404','LA00002071923','IL','1','APFFEL','CYNTHIA','','','','34','433985794','526 JEFFERSON ST',0,'NEW ORLEANS','LA','70121','1512','CY','22051','1955-11-12','F','U',NULL,'N','021','DEN','2403019','18575LA002000201','2014-02-01','2014-01-09 18:26:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:23:53'),(17437,13950,'Y','18','021','EC','A','','','AC','0000194064','0000194064','OH00002564078','IL','1','Fifer','Kevin','L','','','34','300486106','7147 SALISBURY RD',0,'MAUMEE','OH','43537','9714','CY','39095','1953-11-12','M','M',':RET:2106-3','N','021','HLT','2344638','92036OH006002601','2014-02-01','2014-01-10 14:02:41','805.00',NULL,NULL,'854.26','49.26','R-OH001','OH0','419.70',NULL,0,'2014-01-13 03:00:34'),(21289,17012,'Y','18','021','EC','A','','','AC','0002181286','0002181286','LA00002500915','IL','1','HARTFIELD','STEVEN','RAY','','','34','436733871','22317 WALKER SOUTH ROAD',0,'DENHAM SPRINGS','LA','70726',NULL,'CY','22063','1975-07-03','M','M',':RET:2106-3','T','021','DEN','3115338','18575LA002000101','2014-03-01','2014-02-03 20:53:14','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-02-04 21:00:05'),(22556,18013,'Y','18','021','EC','A','','','AC','0000203124','0000203124','OH00002309642','IL','1','Goers','Nicholas','','','','34','273846689','1350 NICHOLSON AVE',0,'LAKEWOOD','OH','44107','2712','CY','39035','1985-06-17','M','U',':RET:2106-3','N','021','DEN','3712163','99734OH005000401','2014-03-01','2014-02-10 10:12:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:48'),(24871,19719,'N','01','021','EC','A',NULL,NULL,'','0000227044','0001196803','','IL','1','Oliver','William','C','','Jr','34','278724447','23 S WILLIAMS ST',0,'DAYTON','OH','45402','8236','CY','39113','1967-02-27','M','',':RET:2054-5','N','021','DEN','3718664','99734OH005000401','2014-03-01','2014-02-19 09:53:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-20 05:33:14'),(29056,22997,'Y','18','024','14','A','','','TE','0000859759','0000859759','','IL','1','Groya','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-12','F','',NULL,NULL,NULL,'','3566174','','2014-03-10','2014-03-10 16:18:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:49'),(369,306,'Y','18','021','EC','A','','','AC','0000410458','0000410458','TX00001073149','IL','1','Bell','Kathleen','Sullivan','','','34','451907173','1536 COUNTY ROAD 4580',0,'WINNSBORO','TX','75494','5058','CY','48499','1952-04-17','F','M',':RET:2106-3','N','021','DEN','725853','33348TX002000201','2014-01-01','2013-12-04 15:08:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:45:24'),(16519,13215,'Y','18','021','EC','A','','','AC','0000841117','0000841117','TX00002361678','IL','1','JONES','MARILYN','GALE','','','34','462313005','1706 GELLHORN DR',0,'HOUSTON','TX','77029','3347','CY','48201','1957-08-21','F','U',NULL,'N','021','DEN','2430196','33348TX002000201','2014-02-01','2014-01-05 13:51:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-07 10:21:37'),(1073,879,'Y','18','024','14','A','','','TE','0001174374','0001174374','','IL','1','LONGBOTTOM','BARBARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-31','F','',NULL,NULL,NULL,'','835425','','2013-12-03','2013-12-03 09:08:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:16:34'),(1285,1062,'Y','18','021','EC','A','','','AC','0000092468','0000092468','OH00001207350','IL','1','RITSON','JANET','','','','34','273643192','1409 LAUREL AVE',0,'TOLEDO','OH','43614','2741','CY','39095','1956-11-26','F','U',':RET:2106-3','N','021','HLT','436057','92036OH004002601','2014-01-01','2013-11-29 10:43:50','0.00',NULL,NULL,'382.11','382.11','R-OH001','OH0','382.11',NULL,0,'2013-12-25 18:30:41'),(9746,7717,'Y','18','021','EC','A','','','AC','0000209589','0000209589','OH00000101590','IL','1','Kanney','Nathan','','','','34','281760431','155 W COUNTY ROAD 6',0,'TIFFIN','OH','44883','8955','CY','39147','1980-04-25','M','U',':RET:2106-3','N','021','HLT','896088','92036OH005002701','2014-01-01','2013-11-14 21:20:29','0.00',NULL,NULL,'233.59','233.59','R-OH006','OH0','233.59',NULL,0,'2013-12-26 04:46:04'),(2687,2177,'Y','18','021','EC','A','','','AC','0000759589','0000759589','TX00000796141','IL','1','Hernandez','Jessica','','','','34','457598294','2205 BAGBY AVE',0,'WACO','TX','76706','3330','CY','48309','1982-11-18','F','U',':RET:2106-3','N','021','DEN','28528','33348TX002000201','2014-01-01','2013-12-01 20:02:01','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2013-12-25 19:47:24'),(4877,3867,'N','01','021','EC','A',NULL,NULL,'','0000315229','0000079284','','IL','1','Rasnic','Deanna','Rogers','','','34','437317339','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1971-10-11','F','',NULL,'N','021','DEN','976957','33348TX002000201','2014-01-01','2013-10-10 01:37:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:31:10'),(3389,2718,'Y','18','021','EC','A','','','AC','0002094531','0002094531','LA00000294071','IL','1','Crosland','Enoch','','','','34','089667512','2236 D Abadie Street',0,'New Orleans','LA','70119',NULL,'CY','22071','1981-12-31','M','U',':RET:2054-5','N','021','DEN','1908634','18575LA002000201','2014-01-01','2013-12-21 19:46:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:17:46'),(19801,15786,'N','01','021','EC','A',NULL,NULL,'','0001132025','0000595796','','IL','1','Castillo','Rosa','Linda','','','34','450134127','1252 INDIANA ST',0,'EL PASO','TX','79930','1131','CY','48141','1956-01-30','F','',':RET:2106-3','N','021','DEN','2649596','33348TX002000201','2014-03-01','2014-01-24 11:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-24 21:00:04'),(21623,17265,'Y','18','024','14','A','','','TE','0000906373','0000906373','','IL','1','HERNDON','LATEARRIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-03-18','F','',NULL,NULL,NULL,'','3166240','','2014-02-05','2014-02-05 06:19:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-05 21:30:38'),(21641,17281,'Y','18','024','14','A','','','TE','0000410458','0000410458','','IL','1','Bell','Kathleen','Sullivan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-17','F','',NULL,NULL,NULL,'','725853','','2014-02-20','2014-02-05 15:04:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-05 21:30:45'),(22274,17779,'Y','18','021','EC','A','','','AC','0001089682','0001089682','TX00002560731','31','1','Harmison','Gregory','D','','','34','452796143','P.O. Box 69',0,'Utopia','TX','78884',NULL,'CY','48463','1971-03-10','M','M',':RET:2106-3','N','021','DEN','2941420','33348TX002000201','2014-03-01','2014-02-02 14:20:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:16'),(24945,19781,'Y','18','021','EC','A','','','AC','0001254325','0001254325','MS00002502710','IL','1','HABANEK','DANIEL','S','','','34','399789818','2278 PIGEON ROOST RD',0,'BYHALIA','MS','38611','9370','CY','28093','1960-11-09','M','M',':RET:2106-3','N','021','DEN','3495829','46300MS002000201','2014-04-01','2014-02-20 16:35:16','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85',NULL,0,'2014-02-20 22:00:07'),(26343,20900,'Y','18','021','EC','A','','','AC','0001250893','0001250893','OH00003006069','IL','1','Diederichs','Kathleen','','','','34','298643025','3865 CRARY DR',0,'TOLEDO','OH','43613','4101','CY','39095','1958-09-18','F','U',':RET:2106-3','N','021','HLT','3809994','92036OH003002605','2014-04-01','2014-02-27 12:27:10','312.00',NULL,NULL,'454.11','142.11','R-OH001','OH0','454.11',NULL,0,'2014-02-28 06:31:44'),(28386,22460,'Y','18','021','EC','A','','','AC','0000919448','0000919448','OH00003635196','IL','1','JONES','JESSICA','','','','34','286840549','73 EASTGAY DR',0,'AKRON','OH','44313',NULL,'CY','39153','1986-04-07','F','M',NULL,'N','021','HLT','4173852','52664OH152000901','2014-04-01','2014-03-07 16:51:43','231.00',NULL,NULL,'364.41','133.41','R-OH012','OH0','171.18',NULL,0,'2014-03-07 21:30:42'),(28620,22650,'Y','18','021','EC','A','','','AC','0000330696','0000330696','TX00002702695','IL','1','nava','eric','','','','34','464231467','345 Buena Vista',0,'El Paso','TX','79905',NULL,'CY','48141','1963-01-26','M','M',':RET:2106-3','N','021','DEN','3505274','33348TX002000201','2014-04-01','2014-03-07 23:24:06','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-08 21:30:20'),(1729,1440,'Y','18','021','EC','A','','','AC','0000809681','0000809681','OH00001458404','IL','1','Funkhouser','Mirna','','','','34','271582911','401 Bell Ave',0,'Sandusky','OH','44870',NULL,'CY','39043','1963-08-18','F','U',':RET:2106-3','N','021','DEN','2527329','99734OH005000301','2014-01-01','2013-12-24 10:59:37','0.00',NULL,NULL,'59.76','59.76','R-OH006','OH0','0.00',NULL,0,'2013-12-25 18:55:21'),(14747,11775,'N','19','021','EC','A',NULL,NULL,'','0001016863','0000119075','','IL','1','Murphy','Blayke','','','','34','284041266','105 HILL TOP LN',0,'MOSCOW','OH','45153','8904','CY','39025','1999-08-03','F','',':RET:2106-3','N','021','HLT','2083898','92036OH006000601','2014-02-01','2013-12-27 20:06:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,1,'2013-12-29 11:10:13'),(14701,11738,'Y','18','021','EC','A','','','AC','0001179632','0001179632','OH00001567297','IL','1','Piwko','Agnieszka','','','','34','523835563','5560 ONeall',0,'Waynesville','OH','45068',NULL,'CY','39165','1978-07-28','F','U',':RET:2106-3','N','021','DEN','1730359','99734OH005000401','2014-02-01','2013-12-28 09:11:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:09:04'),(13159,10497,'Y','18','021','EC','A','','','AC','0000637107','0000637107','OH00001097871','IL','1','Rice','Christine','','','','34','298905674','710 Jefferson Ave',0,'Cleveland','OH','44113',NULL,'CY','39035','1987-04-10','F','U',':RET:2106-3','N','021','DEN','2028271','99734OH005000401','2014-01-01','2013-12-23 17:34:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:47'),(9347,7409,'Y','18','021','EC','A','','','AC','0001899360','0001899360','LA00000903812','IL','1','Ketchens','Doreen','','','','34','437316035','1736 Winchester Pl',0,'Harvey','LA','70058',NULL,'CY','22051','1964-10-03','F','M',NULL,'N','021','DEN','2353952','18575LA002000201','2014-01-01','2013-12-20 23:04:07','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:09'),(9230,7323,'N','01','021','EC','A',NULL,NULL,'','0000030529','0000764956','','IL','1','Poole','Michelle','','','','34','292725266','806 HAMBURG ST',0,'RIPLEY','OH','45167','1343','CY','39015','1970-01-12','F','',':RET:2106-3','N','021','HLT','2456739','92036OH003000605','2014-01-01','2013-12-18 14:55:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.21',NULL,0,'2013-12-26 04:10:27'),(7452,5899,'N','19','021','EC','A',NULL,NULL,'','0000896969','0000471002','','IL','1','KOPPEL','APRIL','ELISABETH','','','34','296112920','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','2006-04-25','F','',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:30:45'),(6740,5347,'Y','18','021','EC','A','','','AC','0001171852','0001171852','OH00000796085','IL','1','Vestal','Gary','','','','34','294560083','645 Senn Drive',0,'Tallmadge','OH','44278',NULL,'CY','39153','1953-01-04','M','M',':RET:2106-3','N','021','HLT','862829','52664OH151001306','2014-01-01','2013-11-25 11:53:43','854.00',NULL,NULL,'1021.15','167.15','R-OH012','OH0','605.24',NULL,0,'2013-12-26 01:15:45'),(7361,5829,'N','01','021','EC','A',NULL,NULL,'','0000091102','0000982672','','IL','1','Miracle','Pamela','J','','','34','273588896','872 SKYSIDE DR',0,'CLINTON','OH','44216','9659','CY','39153','1956-05-13','F','',':RET:2106-3','N','021','HLT','575059','52664OH151001501','2014-01-01','2013-11-22 19:57:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','651.81',NULL,0,'2013-12-26 02:15:24'),(6950,5520,'Y','18','021','EC','A','','','AC','0001110363','0001110363','OH00001079133','IL','1','Smith','Mark','','','','34','294608847','8833 NATIONAL RD',0,'THORNVILLE','OH','43076','8337','CY','39089','1963-07-08','M','M',':RET:2106-3','T','021','DEN','2133520','99734OH005000401','2014-01-01','2013-12-24 21:03:23','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:01'),(20945,16737,'Y','18','021','EC','A','','','AC','0000473263','0000473263','TX00002542741','IL','1','Chambers','Joe','','','','34','457573938','714 LIBERTY ST',0,'MALAKOFF','TX','75148','9731','CY','48213','1965-12-21','M','U',':RET:2054-5','N','021','DEN','2702919','33348TX002000101','2014-03-01','2014-01-31 17:50:51','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-31 21:01:44'),(21040,16810,'N','01','021','EC','A',NULL,NULL,'','0000942028','0000775122','','IL','1','Luhn','Jason','','','','34','285763498','1024 CLEPPER LN',0,'BATAVIA','OH','45103','2351','CY','39025','1980-07-12','M','',':RET:2106-3','N','021','HLT','2757257','92036OH005000605','2014-03-01','2014-02-01 14:27:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','257.16',NULL,0,'2014-02-01 19:00:50'),(21515,17190,'Y','18','021','EC','A','','','AC','0000528284','0000528284','OH00001982905','IL','1','Washock','Joseph','','','','34','291661827','6078 MAGNOLIA DR',0,'MENTOR','OH','44060','3130','CY','39085','1959-07-19','M','U',':RET:2106-3','N','021','DEN','2914903','99734OH005000401','2014-03-01','2014-02-05 17:59:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-05 21:00:03'),(22236,17749,'Y','18','024','14','A','','','TE','0000970494','0000970494','','IL','1','Swank','Jeffery',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-07-19','M','',NULL,NULL,NULL,'','2811918','','2014-02-09','2014-02-09 08:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-09 19:00:35'),(25649,20348,'Y','18','021','EC','A','','','AC','0000508046','0000508046','OH00002908077','31','1','RUNYON','JONI','','','','34','276548934','PO BOX 165',0,'HARVEYSBURG','OH','45032',NULL,'CY','39165','1954-11-23','F','U',':RET:2106-3','N','021','DEN','3435519','99734OH005000401','2014-04-01','2014-02-21 22:36:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:30:37'),(25730,20409,'Y','18','021','EC','A','','','AC','0002010379','0002010379','LA00001768820','IL','1','chentlen','dennessa','larose','','','34','434578411','1036 spencer loop',0,'new iberia','LA','70560',NULL,'CY','22045','1968-06-22','F','M',':RET:2054-5','N','021','DEN','3209688','18575LA002000201','2014-04-01','2014-02-24 14:22:46','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 09:30:34'),(28538,22586,'N','01','021','EC','A',NULL,NULL,'','0001213360','0000172701','','IL','1','FUENTES','MARTHA','','','','34','464087990','227 STAR ST',0,'HEREFORD','TX','79045',NULL,'CY','48117','1955-11-11','F','',NULL,'N','021','DEN','3549231','33348TX002000101','2014-04-01','2014-03-07 11:21:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-07 21:32:12'),(156,130,'Y','18','021','EC','A','','','AC','0001064940','0001064940','TX00001050960','IL','1','Thompson','Mae','Marie','','','34','450924132','1713 E 2ND ST',0,'LUBBOCK','TX','79403','4013','CY','48303','1951-07-18','F','U',':RET:2054-5','N','021','DEN','1053719','33348TX002000101','2014-01-01','2013-12-05 14:28:35','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 17:19:03'),(15165,12119,'Y','18','021','EC','A','','','AC','0000864834','0000864834','OH00000031977','IL','1','Ruland','Donna','','','','34','269449031','2502 Wellington Avenue',0,'Parma','OH','44134',NULL,'CY','39035','1951-08-17','F','M',':RET:2106-3','N','021','DEN','1492607','99734OH005000401','2014-02-01','2013-12-30 15:04:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:06:22'),(3223,2594,'Y','18','021','EC','A','','','AC','0000890705','0000890705','OH00000989235','IL','1','Hall','jack','','','','34','302824161','208 LANCELOT DR',0,'DEFIANCE','OH','43512','9668','CY','39039','1985-05-31','M','U',':RET:2106-3','N','021','HLT','307155','92036OH002002601','2014-01-01','2013-10-31 21:09:47','198.00',NULL,NULL,'244.79','46.79','R-OH001','OH0','244.79',NULL,0,'2013-12-25 20:45:48'),(4954,3932,'Y','18','021','EC','A','','','AC','0000681580','0000681580','LA00000677114','IL','1','KELSON','ERIC','','','','34','438131599','500 NW 2ND ST',0,'RESERVE','LA','70084',NULL,'CY','22095','1958-07-14','M','U',NULL,'N','021','DEN','980794','18575LA002000201','2014-01-01','2013-12-06 18:48:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:00'),(17187,13753,'Y','18','021','EC','A','','','AC','0001182449','0001182449','TX00001426369','31','1','Hook','Jonathan','','','','34','311623389','PO Box 40',0,'Lelindio','TX','78860',NULL,'CY','48323','1953-12-30','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1814905','33348TX002000101','2014-02-01','2014-01-08 15:17:33','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-13 02:22:16'),(17901,14299,'Y','18','021','EC','A','','','AC','0001152462','0001152462','TX00002076239','IL','1','willis','jack','','','','34','548043551','196 RAINBOW DR',0,'LIVINGSTON','TX','77399','1096','CY','48373','1958-12-31','M','M',NULL,'N','021','DEN','1938477','33348TX002000201','2014-02-01','2014-01-13 18:44:56','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:23'),(19074,15196,'Y','18','021','EC','A','','','AC','0000496778','0000496778','OH00001822636','IL','1','Bechstein','Cindy','','','','34','290522109','535 W Gypsy Lane',0,'Bowling Green','OH','43402',NULL,'CY','39173','1952-06-25','F','U',':RET:2106-3','N','021','HLT','1775951','92036OH001002601','2014-03-01','2014-01-17 19:53:26','0.00',NULL,NULL,'660.95','660.95','R-OH001','OH0','660.95',NULL,0,'2014-01-21 08:44:22'),(23691,18867,'Y','18','021','EC','A','','','AC','0001214848','0001214848','OH00002127460','IL','1','BLACKWOOD','PAMELA','','','','34','277629376','267 SOUTH BLVD',0,'WADSWORTH','OH','44281','1782','CY','39103','1955-03-05','F','M',':RET:2106-3','N','021','DEN','2934668','99734OH005000401','2014-03-01','2014-02-13 22:27:21','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:37'),(25024,19843,'Y','18','021','EC','A','','','AC','0000876978','0000876978','TX00001628746','IL','1','Brown','Nancy','','','','34','462391552','1065 COUNTY ROAD 91',0,'BISHOP','TX','78343','3218','CY','48355','1967-02-07','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3470821','33348TX002000101','2014-04-01','2014-02-20 10:19:26','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-02-20 22:00:58'),(27480,21745,'N','01','021','EC','A',NULL,NULL,'','0000816958','0000138175','','IL','1','Ferrell','Steven','L','','','34','577924401','1306 Powder River Dr',0,'Killeen','TX','76549',NULL,'CY','48027','1962-04-24','M','',':RET:2054-5','N','021','DEN','3273333','33348TX002000101','2014-04-01','2014-03-04 12:47:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-04 21:02:16'),(24543,19496,'Y','18','021','EC','A','','','AC','0000558196','0000558196','OH00002436681','IL','1','JOHNSON','ALVIN','','','','34','298486212','155 YOUNGSTOWN RD',0,'HUBBARD','OH','44425',NULL,'CY','39155','1950-05-10','M','U',':RET:2054-5','N','021','HLT','2902346','52664OH151001305','2014-04-01','2014-02-18 18:04:53','553.00',NULL,NULL,'746.55','193.55','R-OH013','OH0','746.55',NULL,0,'2014-02-20 04:02:54'),(26417,20951,'Y','18','021','EC','A','','','AC','0000834324','0000834324','TX00003243529','IL','1','Robertson','Demetra','','','','34','456539284','1232 McCary St',0,'Cedar Hill','TX','75104',NULL,'CY','48113','1970-01-17','F','U',':RET:2054-5','N','021','DEN','3375537','33348TX002000201','2014-04-01','2014-02-26 18:34:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-28 07:30:05'),(27580,21811,'Y','18','021','EC','A','','','AC','0000603058','0000603058','TX00003610879','IL','1','TREMILLO','LILVIA','','','','34','640602666','5901 S MILAM ST',0,'AMARILLO','TX','79118','8811','CY','48381','1971-07-16','F','U',':RET:2106-3','N','021','DEN','3659859','33348TX002000201','2014-04-01','2014-03-05 10:11:59','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61','CIC',0,'2014-03-05 21:00:11'),(27639,21861,'Y','18','021','EC','A','','','AC','0000805175','0000805175','OH00003265495','IL','1','Adams','Heather','','','','34','285789535','491 LOCK SEVENTEEN RD SE',0,'GNADENHUTTEN','OH','44629','9771','CY','39157','1982-02-23','F','U',NULL,'T','021','DEN','2873366','99734OH005000401','2014-04-01','2014-03-05 11:12:52','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-05 21:30:15'),(28791,22791,'Y','18','021','EC','A','','','AC','0000448378','0000448378','TX00003613199','IL','1','Gaines','Nicholas','','','','34','449612333','6014 Lisa Ln',0,'Houston','TX','77021',NULL,'CY','48201','1981-01-05','M','U',':RET:2054-5','N','021','DEN','3667587','33348TX002000101','2014-04-01','2014-03-08 23:26:58','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-09 21:00:42'),(1872,1528,'Y','18','021','EC','A','','','AC','0000426434','0000426434','OH00001623903','IL','1','Adams','Alonna','','','','34','298545476','313 Hillcrest Drive',0,'Ashland','OH','44805',NULL,'CY','39005','1953-04-18','F','M',':RET:2106-3','T','021','HLT','1930476','52664OH152000901','2014-01-01','2013-12-24 16:08:27','199.00',NULL,NULL,'509.80','310.80','R-OH012','OH0','509.80',NULL,0,'2013-12-25 18:58:19'),(17132,13710,'Y','18','021','EC','A','','','AC','0000758283','0000758283','OH00001114343','IL','1','THOMAS','ANGELA','','','','34','297626286','4523 FAIRHAVEN AVE NW',0,'CANTON','OH','44709','1344','CY','39151','1955-11-08','F','U',NULL,'T','021','DEN','1490125','99734OH005000401','2014-02-01','2014-01-08 12:49:07','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-13 02:21:47'),(14296,11405,'Y','18','021','EC','A','','','AC','0001133953','0001133953','OH00000653664','IL','1','Jones','Chris','','','','34','279484889','12 Elmwood Dr.',0,'Greenwich','OH','44837',NULL,'CY','39077','1965-05-10','M','U',':RET:2106-3','N','021','HLT','2233465','92036OH005002706','2014-02-01','2013-12-26 10:33:43','311.00',NULL,NULL,'318.82','7.82','R-OH006','OH0','318.82',NULL,0,'2013-12-27 02:06:44'),(2205,1816,'Y','18','021','EC','A','','','AC','0000658398','0000658398','OH00001015908','IL','1','Wallace','Linda','','','','34','271540278','1830 SUNSET AVE',0,'AKRON','OH','44301','3228','CY','39153','1953-04-23','F','U',NULL,'T','021','HLT','754833','52664OH151001305','2014-01-01','2013-12-10 13:06:16','455.00',NULL,NULL,'696.03','241.03','R-OH012','OH0','696.03',NULL,0,'2013-12-25 19:20:09'),(2944,2369,'Y','18','021','EC','A','','','AC','0001092098','0001092098','OH00000316976','IL','1','Nicholson','Mae','','','','34','288502076','395 LOURDES LN',0,'CAMPBELL','OH','44405','1851','CY','39099','1951-03-28','F','M',':RET:2054-5','N','021','DEN','1135395','99734OH005000401','2014-01-01','2013-12-06 15:08:10','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:16:20'),(18451,14718,'Y','18','021','EC','A','','','AC','0002121084','0002121084','LA00001509012','IL','1','Johnson','Robert','T','','','34','428450531','605 AVENUE B',0,'BOGALUSA','LA','70427','3713','CY','22117','1982-01-01','M','U',NULL,'N','021','DEN','2652499','18575LA002000101','2014-02-01','2014-01-14 19:51:17','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:07'),(18538,14783,'Y','18','021','EC','A','','','AC','0000327637','0000327637','MS00002250266','IL','1','durr','natasha','','','','34','427316207','35 shelby mcgee rd',0,'collins','MS','39428',NULL,'CY','28031','1977-11-06','F','U',':RET:2054-5','N','021','DEN','2122912','46300MS002000101','2014-02-01','2014-01-14 21:55:09','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-16 08:46:47'),(22683,18113,'N','19','021','EC','A',NULL,NULL,'','0000894039','0001255498','','IL','1','Bosire','Jeanine','Isabela','','','34','635867752','1415 Seely street',0,'Arlington','TX','76018',NULL,'CY','48439','2003-04-24','F','',':RET:2054-5','N','021','DEN','3482023','33348TX002000201','2014-03-01','2014-02-11 17:17:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-11 21:00:49'),(26393,20935,'Y','18','021','EC','A','','','AC','0000194050','0000194050','OH00002689324','IL','1','Taylor','Kathleen','','','','34','277801472','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1981-07-24','F','M',':RET:2106-3','N','021','HLT','3007504','52664OH151001301','2014-03-01','2014-02-26 13:08:30','0.00',NULL,NULL,'658.54','658.54','R-OH012','OH0','263.82','CIC',0,'2014-02-28 07:00:27'),(381,316,'Y','18','021','EC','A','','','AC','0000851935','0000851935','TX00000618615','IL','1','Black','Christopher','','','','34','452773656','600 University Oaks Blvd.',0,'College Station','TX','77840',NULL,'CY','48041','1982-09-10','M','M',':RET:2106-3','N','021','DEN','21507','33348TX002000201','2014-01-01','2013-12-04 16:46:52','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 17:45:42'),(17083,13671,'N','01','021','EC','A',NULL,NULL,'','0001183697','0000511568','','IL','1','Arizpe','Alejandra','','','','34','629700566','122 SOUTH ST',0,'GONZALES','TX','78629','3430','CY','48177','1975-04-08','F','',':RET:2106-3','N','021','DEN','2127553','33348TX002000201','2014-02-01','2014-01-08 13:57:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:21:23'),(17037,13632,'Y','18','021','EC','A','','','AC','0002152368','0002152368','LA00001602213','IL','1','Mundell','Bradley','','','','34','433639529','4905 PICONE ST',0,'METAIRIE','LA','70006','1040','CY','22051','1984-11-07','M','U',':RET:2106-3','N','021','DEN','1458374','18575LA002000101','2014-02-01','2014-01-08 23:36:27','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-13 02:20:49'),(16063,12864,'Y','18','021','EC','A','','','AC','0000751028','0000751028','OH00001028036','IL','1','METZGER','THERESA','','','','34','289501964','2337 KNOXEL HILL BRACKEN RDG',0,'OTWAY','OH','45657',NULL,'CY','39145','1950-06-25','F','U',NULL,'N','021','DEN','1813790','99734OH005000401','2014-02-01','2014-01-03 10:38:46','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-01-04 02:03:35'),(16033,12836,'Y','18','024','14','A','','','TE','0001520669','0001520669','','IL','1','Vu','Liem',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-03','M','',NULL,NULL,NULL,'','1741161','','2014-01-03','2014-01-03 14:04:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-04 02:02:35'),(15223,12169,'Y','18','024','14','A','','','TE','0000117045','0000117045','','IL','1','Heuer','Frank',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-07-01','M','',NULL,NULL,NULL,'','1007377','','2013-12-30','2013-12-30 14:52:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-01 12:08:05'),(988,808,'Y','18','021','EC','A','','','AC','0000390864','0000390864','OH00000319889','IL','1','Romer','Georgia','','','','34','292664114','8779 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','1960-08-26','F','U',':RET:2106-3','N','021','HLT','82866','92036OH004001201','2014-01-01','2013-10-31 15:07:52','0.00',NULL,NULL,'352.13','352.13','R-OH004','OH0','352.13',NULL,0,'2013-12-25 18:10:31'),(2025,1658,'N','01','021','EC','A',NULL,NULL,'','0000998756','0000165051','','IL','1','Austin','Beth','Ann','','','34','273904220','3560 MARCELLA AVE',0,'STOW','OH','44224','4134','CY','39153','1984-03-03','F','',':RET:2106-3','N','021','HLT','80449','52664OH152000901','2014-01-01','2013-12-09 21:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.78',NULL,0,'2013-12-25 19:15:11'),(4373,3474,'Y','18','021','EC','A','','','AC','0000388626','0000388626','OH00000241856','IL','1','MEKKER','JOSEPH','','','','34','269580964','8649 CARMICHAEL DR',0,'CHESTERLAND','OH','44026','3503','CY','39055','1956-12-29','M','R',':RET:2106-3','N','021','DEN','485404','99734OH005000401','2014-01-01','2013-12-12 01:54:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:22'),(13042,10397,'N','19','021','EC','A',NULL,NULL,'','0001242972','0000796959','','IL','1','Mehaffey','Vanessa','A','','','34','284067892','1721 BENSON DR',0,'DAYTON','OH','45406','4030','CY','39113','2001-08-02','F','',':RET:2054-5','N','021','DEN','2440963','99734OH005000401','2014-01-01','2013-12-23 07:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:39'),(6583,5219,'N','01','021','EC','A',NULL,NULL,'','0000064863','0000183471','','IL','1','Abrams','Crystal','','','','34','292760735','3159 Delhi Ave',0,'Cincinnati','OH','45204',NULL,'CY','39061','1975-06-15','F','',NULL,'N','021','HLT','704593','92036OH003001201','2014-01-01','2013-12-11 08:05:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','279.34',NULL,0,'2013-12-26 00:53:02'),(4797,3802,'N','19','021','EC','A',NULL,NULL,'','0000034344','0000992662','','IL','1','Hammond','Arthur','K','','','34','295049638','23310 E BAINTREE RD',0,'BEACHWOOD','OH','44122','1246','CY','39035','2000-03-23','M','',':RET:2106-3','N','021','HLT','730796','52664OH151001301','2014-01-01','2013-12-08 15:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2013-12-25 22:16:25'),(23327,18592,'Y','18','021','EC','A','','','AC','0000134574','0000134574','OH00001734568','IL','1','WOYSHVILLE','BETH','','','','34','294588375','3255 W 43RD ST',0,'CLEVELAND','OH','44109','1061','CY','39035','1964-11-02','F','U',NULL,'N','021','DEN','3421148','99734OH005000301','2014-03-01','2014-02-13 14:49:24','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:28'),(23345,18604,'N','01','021','EC','A',NULL,NULL,'','0000110556','0000372648','','IL','1','Bencina','Lisa','Ann','','','34','280581745','38278 Roselawn Street',0,'Willoughby','OH','44094',NULL,'CY','39085','1966-06-07','F','',NULL,'N','021','HLT','3683295','52664OH151001305','2014-03-01','2014-02-12 21:48:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','393.12',NULL,0,'2014-02-13 22:00:39'),(23494,18715,'Y','18','021','EC','A','','','AC','0000895757','0000895757','OH00001968240','IL','1','WILLEY','ANGELA','','','','34','276644018','340 CHILLICOTHE AVE',0,'HILLSBORO','OH','45133','8566','CY','39071','1959-06-22','F','M',NULL,'N','021','HLT','3655522','92036OH005000601','2014-03-01','2014-02-13 09:36:40','185.00',NULL,NULL,'458.32','273.32','R-OH005','OH0','458.32',NULL,0,'2014-02-13 22:02:04'),(25848,20491,'Y','18','021','EC','A','','','AC','0000212225','0000212225','OH00003139610','IL','1','FORGACS','KYLE','','','','34','293946078','2304 ECHO VALLEY DR',0,'CUYAHOGA FALLS','OH','44224','2700','CY','39153','1992-03-08','M','U',':RET:2106-3','T','021','HLT','3497436','52664OH152000901','2014-04-01','2014-02-26 17:27:10','106.00',NULL,NULL,'187.84','81.84','R-OH012','OH0','187.84',NULL,0,'2014-02-26 21:00:39'),(9616,7615,'N','19','021','EC','A',NULL,NULL,'','0000414692','0000036986','','IL','1','Stewart','Brittany','','','','34','404497645','5810 MILONA CT',0,'FAIRFIELD','OH','45014','5538','CY','39017','1995-12-19','F','',':RET:2106-3','N','021','HLT','1947856','92036OH005001204','2014-01-01','2013-12-20 20:03:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-26 04:37:46'),(17848,14257,'Y','18','024','14','A','','','TE','0001143335','0001143335','','IL','1','Davis','Jeffrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-03-06','M','',NULL,NULL,NULL,'','2107113','','2014-01-14','2014-01-14 08:58:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:06:06'),(17476,13972,'Y','18','021','EC','A','','','AC','0000958745','0000958745','TX00001489434','IL','1','Waters','Erin','','','','34','644189350','6565 McCallum Blvd.',0,'Dallas','TX','75252',NULL,'CY','48085','1987-04-11','F','U',':RET:2106-3','N','021','DEN','1864898','33348TX002000201','2014-02-01','2014-01-11 21:56:39','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 03:01:10'),(14523,11588,'Y','18','021','EC','A','','','AC','0000677422','0000677422','TX00001581113','IL','1','farishta','sadiq','','','','34','345823918','7422 LAKE TRAVIS DR',0,'CORPUS CHRISTI','TX','78413','5812','CY','48355','1969-08-16','M','M',':RET:2029-7','T','021','DEN','2156603','33348TX002000201','2014-02-01','2013-12-27 17:12:56','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-28 03:34:21'),(14358,11451,'N','01','021','EC','A',NULL,NULL,'','0000801269','0000609543','','IL','1','Czaplicki','Jennifer','Lynn','','','34','300846225','61 HENDERSON ST',0,'SOUTH BLOOMFIELD','OH','43103','8500','CY','39129','1986-11-28','F','',':RET:2106-3','N','021','DEN','1857810','99734OH005000401','2014-02-01','2013-12-26 19:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:13'),(1326,1097,'Y','18','021','EC','A','','','AC','0000727244','0000727244','OH00000212037','IL','1','Witzke','Alan','','','','34','299880602','8093 N HILLS DR',0,'BROADVIEW HEIGHTS','OH','44147','1016','CY','39035','1985-12-13','M','U',NULL,'N','021','DEN','67536','99734OH005000401','2014-01-01','2013-10-25 14:36:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:31:55'),(3491,2803,'Y','18','021','EC','A','','','AC','0000997745','0000997745','OH00001093954','IL','1','Collingwood','Jean','','','','34','275566830','6840 REID DR',0,'CLEVELAND','OH','44130','4505','CY','39035','1958-05-21','F','U',':RET:2106-3','N','021','DEN','2462090','99734OH005000401','2014-01-01','2013-12-22 14:05:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:27'),(18765,14952,'Y','18','021','EC','A','','','AC','0000427340','0000427340','TX00002274994','IL','1','WADE','HOWARD','','','','34','455048766','2610 CODY CT',0,'MIDLOTHIAN','TX','76065','7023','CY','48139','1969-10-28','M','M',NULL,'N','021','DEN','2815071','33348TX002000101','2014-03-01','2014-01-16 17:16:43','0.00',NULL,NULL,'148.50','148.50','R-TX008','TX0','27.15',NULL,0,'2014-01-17 03:35:48'),(19772,15762,'Y','18','021','EC','A','','','AC','0000768902','0000768902','OH00001635594','IL','1','McCune','Richard','','','','34','235760139','1025 W. Ohio Avenue',0,'Sebring','OH','44672',NULL,'CY','39099','1950-07-26','M','M',':RET:2106-3','N','021','HLT','2758359','92036OH005003201','2014-03-01','2014-01-23 15:29:14','0.00',NULL,NULL,'714.53','714.53','R-OH013','OH0','714.53',NULL,0,'2014-01-23 21:01:29'),(20312,16215,'Y','18','021','EC','A','','','AC','0000266829','0000266829','TX00002563297','IL','1','BALDWIN','JAMES','','','','34','557430979','2569 Surrey Hills Estate Road',0,'McKinney','TX','75069',NULL,'CY','48085','1975-10-22','M','U',':RET:2106-3','N','021','DEN','3028652','33348TX002000201','2014-03-01','2014-01-28 12:58:31','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-28 21:00:50'),(21605,17252,'Y','18','021','EC','A','','','AC','0000895755','0000895755','OH00002297765','IL','1','Carver','Sherry','','','','34','276820223','4577 CARNOUSTIE',0,'BATAVIA','OH','45103','4008','CY','39025','1967-10-06','F','U',':RET:2106-3','N','021','DEN','3280349','99734OH005000301','2014-03-01','2014-02-05 13:20:55','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2014-02-05 21:30:32'),(23446,18677,'Y','18','021','EC','A','','','AC','0000740200','0000740200','TX00002320888','IL','1','MEDDERS','ROSE','','','','34','460061683','622 E 46TH ST',0,'SAN ANGELO','TX','76903','1410','CY','48451','1955-04-28','F','U',NULL,'T','021','DEN','3227147','33348TX002000201','2014-03-01','2014-02-13 12:42:09','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-13 22:01:35'),(24824,19678,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000149396','','IL','1','Burdick','Tanner','','','','34','302982628','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1996-06-20','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:43'),(2603,2115,'Y','18','021','EC','A','','','AC','0000569275','0000569275','OH00000589493','IL','1','Brown','Dennis','','','','34','270504376','891 STONEWATER DR',0,'KENT','OH','44240','2052','CY','39133','1950-04-03','M','M',':RET:2106-3','N','021','DEN','591730','99734OH005000401','2014-01-01','2013-12-02 07:00:54','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:45:24'),(18622,14846,'Y','18','021','EC','A','','','AC','0001071800','0001071800','OH00001501743','IL','1','NEE','YONG','','','','34','276806902','3225 OLD BRAINARD RD',0,'PEPPER PIKE','OH','44124','5626','CY','39035','1961-07-19','M','M',NULL,'N','021','HLT','1981068','92036OH003000801','2014-02-01','2014-01-15 13:36:21','0.00',NULL,NULL,'476.59','476.59','R-OH011','OH0','476.59',NULL,0,'2014-01-16 08:47:29'),(1485,1239,'Y','18','021','EC','A','','','AC','0000792220','0000792220','OH00000398707','31','1','Helmick','Jack','R','','','34','286421593','P. O. Box 05',0,'BRISTOLVILLE','OH','44402',NULL,'CY','39155','1951-04-04','M','M',':RET:2106-3','N','021','DEN','1984042','99734OH005000401','2014-01-01','2013-12-24 10:56:12','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:48:54'),(16338,13080,'Y','18','021','EC','A','','','AC','0000910539','0000910539','OH00001817350','IL','1','CONRAD','LAUREL','','','','34','301606725','4609 CREEKRUN DR',0,'MASON','OH','45040',NULL,'CY','39165','1973-03-31','F','M',NULL,'N','021','DEN','2064786','99734OH005000301','2014-02-01','2014-01-06 12:31:41','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:02:11'),(15279,12215,'Y','18','021','EC','A','','','AC','0000802587','0000802587','OH00001603390','IL','1','Mixer','Danette','','','','34','297600403','3925 N Ridge E',0,'Ashtabula','OH','44004',NULL,'CY','39007','1970-03-19','F','U',':RET:2106-3','N','021','DEN','1488830','99734OH005000401','2014-02-01','2014-01-01 14:31:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:22:02'),(14869,11873,'Y','18','021','EC','A','','','AC','0001116639','0001116639','TX00001499848','IL','1','OGWUMIKE','CAROL','CHIKA','','','34','524634060','2807 PEARL ST',0,'NACOGDOCHES','TX','75965','3323','CY','48347','1983-06-04','F','M',':RET:2054-5','N','021','DEN','1771602','33348TX002000201','2014-02-01','2013-12-28 22:05:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-30 00:00:10'),(14601,11654,'Y','18','021','EC','A','','','AC','0000087492','0000087492','OH00001242380','IL','1','jacques','donna','','','','34','285607156','32 burlington ave',0,'dayton','OH','45403',NULL,'CY','39113','1971-08-14','F','U',':RET:2106-3','T','021','DEN','2489389','99734OH005000301','2014-02-01','2013-12-27 11:05:14','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-28 03:36:24'),(18823,14992,'Y','18','021','EC','A','','','AC','0001103756','0001103756','MS00002037192','IL','1','owens','renda','','','','34','428712149','129 CLUBVIEW DR',0,'JACKSON','MS','39209','3116','CY','28049','1991-06-23','F','U',':RET:2054-5','N','021','DEN','3021309','46300MS002000201','2014-02-01','2014-01-15 21:25:30','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:07'),(18960,15106,'Y','18','021','EC','A','','','AC','0001264498','0001264498','TX00001770887','IL','1','Fennell','Dirrectrick','','','','34','635289613','1819 FALL MEADOW DR',0,'MISSOURI CITY','TX','77459','3443','CY','48157','1987-12-07','M','U',':RET:2054-5','N','021','DEN','1938630','33348TX002000201','2014-03-01','2014-01-16 22:59:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:54'),(21880,17469,'Y','18','021','EC','A','','','AC','0001868282','0001868282','LA00001684327','IL','1','MCGRAW','CAROLYN','','','','34','316584932','118 ROSEWOOD DR',0,'Hammond','LA','70401',NULL,'CY','22105','1951-10-22','F','M',NULL,'N','021','DEN','2749331','18575LA002000201','2014-03-01','2014-02-06 14:02:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-06 21:01:30'),(22176,17698,'N','01','021','EC','A',NULL,NULL,'','0000586666','0000012406','','IL','1','Schimmel','Carolyn','Ann','','','34','299748639','2239 RICHMAND DR',0,'NORTHWOOD','OH','43619','1124','CY','39173','1978-07-02','F','',':RET:2106-3','N','021','DEN','3246499','99734OH005000301','2014-03-01','2014-02-08 00:24:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-08 19:30:08'),(23299,18574,'Y','18','021','EC','A','','','AC','0000961906','0000961906','OH00002639333','S3','1','Smith','Jeffery','Linn','','','34','540676210','2303 MARION MOUNT GILEAD RD',0,'MARION','OH','43302','8912','CY','39101','2004-04-16','F','U',':RET:2106-3','N','021','DEN','3856844','99734OH005000301','2014-03-01','2014-02-13 01:12:11','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','21.13',NULL,0,'2014-02-13 22:00:13'),(6870,5448,'Y','18','021','EC','A','','','AC','0000482154','0000482154','OH00001011006','IL','1','Solomon','Gary','Alan','','','34','300544777','4086 PARKSIDE DR',0,'BROOKLYN','OH','44144','1316','CY','39035','1954-02-15','M','M',':RET:2106-3','N','021','DEN','584939','99734OH005000301','2014-01-01','2013-11-03 09:06:23','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:31:57'),(4933,3914,'Y','18','021','EC','A','','','AC','0000563109','0000563109','OH00000255448','IL','1','Charette','Michael','Vernon','','','34','294643521','1649 Dorothy lane',0,'Kettering','OH','45429',NULL,'CY','39113','1960-04-09','M','U',NULL,'N','021','DEN','840950','99734OH005000401','2014-01-01','2013-12-07 12:42:03','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:45:29'),(18618,14842,'Y','18','021','EC','A','','','AC','0000385925','0000385925','OH00001663405','IL','1','Jordan','Justin','','','','34','445965929','154 N MAIN ST',0,'CAMDEN','OH','45311','1121','CY','39135','1989-10-24','M','U',':RET:2106-3','N','021','HLT','1950933','92036OH004000501','2014-02-01','2014-01-15 17:23:05','79.00',NULL,NULL,'191.13','112.13','R-OH003','OH0','191.13',NULL,0,'2014-01-16 08:47:27'),(20232,16142,'Y','18','024','14','A','','','TE','0000902179','0000902179','','IL','1','Yerian','Regina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-06','F','',NULL,NULL,NULL,'','1117404','','2014-01-27','2014-01-27 17:17:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:50'),(22750,18162,'N','19','021','EC','A',NULL,NULL,'','0001423587','0001340436','','IL','1','Beary','Lauren','','','','34','595451255','730 Goode Street',0,'Thibodaux','LA','70301',NULL,'CY','22057','1994-10-03','F','',':RET:2106-3','N','021','DEN','3014349','18575LA002000101','2014-03-01','2014-02-10 19:18:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2014-02-11 21:01:25'),(24074,19146,'Y','18','021','EC','A','','','AC','0000790924','0000790924','OH00001671444','IL','1','morris','lori','','','','34','275688161','104 CENTER ST',0,'SEVILLE','OH','44273','9504','CY','39103','1965-01-10','F','M',':RET:2106-3','N','021','HLT','3076050','52664OH151001305','2014-03-01','2014-02-14 19:15:25','656.00',NULL,NULL,'920.35','264.35','R-OH012','OH0','380.45',NULL,0,'2014-02-15 22:01:19'),(28429,22497,'Y','18','021','EC','A','','','AC','0000976807','0000976807','OH00002930264','IL','1','JONES','JESSICA','','','','34','286840549','73 EASTGAY DR',0,'AKRON','OH','44313',NULL,'CY','39153','1986-04-07','F','M',NULL,'N','021','DEN','3690096','99734OH005000401','2014-04-01','2014-03-07 16:51:43','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-03-07 21:31:07'),(6087,4824,'Y','18','021','EC','A','','','AC','0000596243','0000596243','OH00000713310','IL','1','Reams','Gary','','','','34','279645991','1133 N HOWARD ST',0,'AKRON','OH','44310','1065','CY','39153','1957-06-24','M','U',':RET:2106-3','N','021','HLT','275254','52664OH151001305','2014-01-01','2013-12-01 12:26:47','377.00',NULL,NULL,'520.28','143.28','R-OH012','OH0','520.28',NULL,0,'2013-12-26 00:02:37'),(9803,7762,'Y','18','024','14','A','','','TE','0000093803','0000093803','','IL','1','bair','laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-10-30','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-20 20:37:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 05:01:17'),(17963,14354,'Y','18','021','EC','A','','','AC','0000940431','0000940431','TX00001779443','IL','1','BIEHL','CAROLE','','','','34','107562404','6501 GEORGIANNA DR',0,'PASADENA','TX','77503','4434','CY','48201','1961-09-02','F','U',':RET:2106-3','N','021','DEN','2748859','33348TX002000201','2014-02-01','2014-01-14 18:36:28','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-15 02:06:46'),(19038,15163,'Y','18','021','EC','A','','','AC','0000440816','0000440816','MS00001707923','IL','1','agrawal','prakash','','','','34','362927325','8 TWELVE OAKS PL',0,'MADISON','MS','39110','7537','CY','28089','1953-06-19','M','M',':RET:2029-7','N','021','DEN','1535019','46300MS002000201','2014-03-01','2014-01-17 12:42:55','0.00',NULL,NULL,'47.55','47.55','R-MS003','MS0','15.85',NULL,0,'2014-01-20 08:06:36'),(20043,15984,'Y','18','021','EC','A','','','AC','0001161570','0001161570','OH00001400028','IL','1','Kelly','Robert','','','','34','421298030','868 WASSON RD',0,'UNION CITY','OH','45390','9016','CY','39037','1982-11-27','M','U',':RET:2106-3','T','021','HLT','2643638','92036OH003000504','2014-03-01','2014-01-26 10:42:20','130.00',NULL,NULL,'330.87','200.87','R-OH003','OH0','330.87',NULL,0,'2014-01-26 19:00:28'),(21351,17064,'Y','18','021','EC','A','','','AC','0000385481','0000385481','TX00002589488','IL','1','Kegel','Robert','','','','34','456060285','1438 Curtain St',0,'Houston','TX','77018',NULL,'CY','48201','1961-12-05','M','U',NULL,'T','021','DEN','3393747','33348TX002000201','2014-03-01','2014-02-04 10:08:51','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-04 21:00:38'),(21729,17351,'Y','18','021','EC','A','','','AC','0000716209','0000716209','TX00001432875','IL','1','GARZA','SYLVIA','','','','34','368529771','422 N ALAMEDA ST',0,'CORPUS CHRISTI','TX','78401','2604','CY','48355','1951-01-09','F','M',NULL,'N','021','DEN','2711645','33348TX002000201','2014-03-01','2014-02-06 15:09:02','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-06 21:00:08'),(22262,17768,'N','01','021','EC','A',NULL,NULL,'','0000297413','0000838653','','IL','1','Baird','Chelci','','','','34','464518884','1269 County Road 175',0,'Colorado City','TX','79512',NULL,'CY','48335','1967-08-07','F','',':RET:2106-3','N','021','DEN','3210242','33348TX002000201','2014-03-01','2014-01-31 18:35:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-10 11:00:08'),(22815,18208,'Y','18','021','EC','A','','','AC','0000551460','0000551460','OH00001922657','IL','1','Kirkpatrick','Thomas','','','','34','302463739','8717 meadowlark dr.',0,'Franklin','OH','45005',NULL,'CY','39165','1951-01-11','M','M',':RET:2106-3','N','021','DEN','3063289','99734OH005000301','2014-03-01','2014-02-11 17:03:31','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:59'),(23583,18789,'Y','18','021','EC','A','','','AC','0000897031','0000897031','OH00001644599','31','1','Worley','Joel','','','','34','283820175','PO Box 82',0,'Hillsboro','OH','45133',NULL,'CY','39071','1984-07-26','M','U',':RET:2106-3','N','021','HLT','3121077','92036OH004000601','2014-03-01','2014-02-13 16:07:42','176.00',NULL,NULL,'193.15','17.15','R-OH005','OH0','193.15',NULL,0,'2014-02-13 22:02:58'),(24480,19447,'N','01','021','EC','A',NULL,NULL,'','0000968256','0001162645','','IL','1','Woods','Melissa','M','','','34','286864332','1723 MEADOWHILL CT',0,'TOLEDO','OH','43614','1837','CY','39095','1983-11-30','F','',':RET:2106-3','N','021','HLT','3043314','92036OH001002601','2014-04-01','2014-02-18 14:03:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','266.97',NULL,0,'2014-02-18 22:01:44'),(24792,19662,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000941969','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','299983325','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1996-04-30','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:46:59'),(319,262,'Y','18','021','EC','A','','','AC','0000411225','0000411225','LA00000885174','IL','1','Tharpe','Lindsey','','','','34','436639588','321 Duclos Street',0,'Lafayette','LA','70506',NULL,'CY','22055','1984-12-06','F','U',':RET:2106-3','N','021','DEN','368892','18575LA002000101','2014-01-01','2013-11-12 21:28:03','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 17:31:18'),(16887,13512,'N','01','021','EC','A',NULL,NULL,'','0000567646','0001120734','','IL','1','flores','amadeo','','','','34','453713800','4703 HERRERA ST',0,'ROBSTOWN','TX','78380','4326','CY','48355','1959-04-10','M','',NULL,'N','021','DEN','2456100','33348TX002000201','2014-02-01','2014-01-09 13:10:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:19:25'),(16557,13246,'Y','18','021','EC','A','','','AC','0002036750','0002036750','LA00001037094','IL','1','Carter','Nichelle','','','','34','437154596','8304 PALM ST',0,'NEW ORLEANS','LA','70118','4724','CY','22071','1971-01-07','F','U',':RET:2054-5','N','021','DEN','1806353','18575LA002000201','2014-02-01','2014-01-05 17:36:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-07 10:22:55'),(15557,12449,'N','01','021','EC','A',NULL,NULL,'','0000706202','0000899575','','IL','1','CHEN','TING','','','','34','749578142','176 E COMET RD',0,'CLINTON','OH','44216','9424','CY','39153','1988-10-20','F','',':RET:2034-7','N','021','HLT','2460019','52664OH151001306','2014-02-01','2013-12-30 18:46:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.90',NULL,1,'2014-01-02 04:31:30'),(15308,12241,'Y','18','021','EC','A','','','AC','0001902232','0001902232','LA00002088801','IL','1','Mabou','Cainan','','','','34','439753023','802 BREANON ST',0,'METAIRIE','LA','70001','4924','CY','22051','1987-06-30','M','U',':RET:2106-3','N','021','DEN','1572569','18575LA002000201','2014-02-01','2014-01-01 17:31:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:23:05'),(7834,6205,'Y','18','024','14','A','','','TE','0000733581','0000733581','','IL','1','DZIAK','MICHAEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-02-04','M','',NULL,NULL,NULL,'','2025757','','2013-12-19','2013-12-19 20:11:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:29'),(612,504,'Y','18','021','EC','A','','','AC','0000801239','0000801239','OH00000112604','IL','1','CORNELIUS','DENNIS','','','','34','274449357','951 W MAIN ST',0,'OTTAWA','OH','45875','1322','CY','39137','1952-06-19','M','U',':RET:2106-3','N','021','DEN','1430065','99734OH005000401','2014-01-01','2013-12-16 10:26:00','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:00:35'),(14465,11542,'Y','18','021','EC','A','','','AC','0000631514','0000631514','OH00000108979','IL','1','SLEIGHTER','SUSAN','','','','34','290600370','641 SHERRI AVE NE',0,'MASSILLON','OH','44646',NULL,'CY','39151','1962-10-10','F','U',':RET:2106-3','N','021','HLT','2405253','52664OH151001501','2014-02-01','2013-12-27 17:19:12','148.00',NULL,NULL,'498.82','350.82','R-OH015','OH0','498.82',NULL,0,'2013-12-28 03:32:53'),(9460,7504,'Y','18','024','14','A','','','TE','0000506946','0000506946','','IL','1','hawthorne','kirk',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-08','M','',NULL,NULL,NULL,'','828629','','2013-12-20','2013-12-20 23:34:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:34:12'),(4225,3363,'Y','18','021','EC','A','','','AC','0000794711','0000794711','TX00000083844','IL','1','ERWIN','YUVETTE','ELAINE','','','34','449436835','1400 N HAWTHORNE AVE',0,'TYLER','TX','75702','2817','CY','48423','1961-08-28','F','U',':RET:2054-5','N','021','DEN','1792937','33348TX002000201','2014-01-01','2013-12-17 11:16:12','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 21:50:32'),(7154,5676,'Y','18','021','EC','A','','','AC','0000102823','0000102823','OH00001493127','IL','1','PUGH','ANDREA','','','','34','296809193','1115 E ARCHWOOD AVE',0,'AKRON','OH','44306','2857','CY','39153','1973-11-20','F','U',':RET:2054-5','N','021','HLT','1564965','52664OH151001501','2014-01-01','2013-12-24 22:00:07','0.00',NULL,NULL,'511.66','511.66','R-OH012','OH0','341.82',NULL,0,'2013-12-26 01:52:16'),(6071,4811,'Y','18','021','EC','A','','','AC','0000933180','0000933180','OH00000940765','IL','1','JONES','TERRY','L','','','34','290585424','6698 PIN OAK DR',0,'LOVELAND','OH','45140','9435','CY','39025','1956-10-28','M','U',':RET:2106-3','N','021','HLT','744229','92036OH001000601','2014-01-01','2013-11-30 19:50:57','402.00',NULL,NULL,'631.05','229.05','R-OH005','OH0','631.05',NULL,0,'2013-12-26 00:02:12'),(18581,14816,'Y','18','021','EC','A','','','AC','0000966929','0000966929','OH00001779471','IL','1','MENASSA','ALEXANDER','','','','34','270708889','377 HIGHPOINTS DR',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1961-10-01','M','R',NULL,'N','021','HLT','2640922','52664OH151001501','2014-02-01','2014-01-15 11:16:18','0.00',NULL,NULL,'522.09','522.09','R-OH012','OH0','522.09',NULL,0,'2014-01-16 08:47:08'),(19291,15377,'Y','18','021','EC','A','','','AC','0002163502','0002163502','LA00001381881','IL','1','KING','HERBERT','','','','34','438177476','5816 hwy 9',0,'chescnut','LA','71070',NULL,'CY','22013','1962-02-25','M','U',':RET:2054-5','N','021','DEN','3075502','18575LA002000201','2014-03-01','2014-01-21 11:24:11','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,1,'2014-01-22 03:21:55'),(20304,16208,'N','01','021','EC','A',NULL,NULL,'','0000528383','0001223196','','IL','1','Lozano','Raul','','','','34','624123653','17 N COLIMA ST',0,'ROMA','TX','78584','8528','CY','48427','1956-12-31','M','',NULL,'N','021','DEN','3469155','33348TX002000201','2014-03-01','2014-01-28 10:30:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-28 21:00:45'),(25535,20256,'Y','18','021','EC','A','','','AC','0000956574','0000956574','TX00003182362','IL','1','Moreland','Jonnie','','','','34','462989281','3608 NEBRASKA ST',0,'AMARILLO','TX','79109','4334','CY','48381','1952-06-03','F','M',':RET:2106-3','N','021','DEN','2654363','33348TX002000201','2014-04-01','2014-02-23 10:34:59','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-26 08:00:07'),(27747,21941,'Y','18','021','EC','A','','','AC','0002051553','0002051553','LA00002625381','IL','1','Dorsey','Tamakica','','','','34','435831997','3243 JOYCE DR',0,'BATON ROUGE','LA','70814','2574','CY','22033','1991-09-18','F','U',':RET:2054-5','N','021','DEN','3345222','18575LA002000201','2014-04-01','2014-03-04 18:24:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:12'),(343,280,'N','01','021','EC','A',NULL,NULL,'','0001108063','0000754530','','IL','1','Roberts','Kevin','L','','','34','290826619','1083 Spring Lake ave.',0,'washington CH','OH','43160',NULL,'CY','39047','1985-01-04','M','',':RET:2106-3','N','021','DEN','614350','99734OH005000401','2014-01-01','2013-11-08 22:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:32:00'),(7193,5700,'Y','18','021','EC','A','','','AC','0000538249','0000538249','OH00000763465','IL','1','Jucha','Jacquelyn','','','','34','163545591','16915 S RED OAK DR',0,'STRONGSVILLE','OH','44136','7521','CY','39035','1961-10-10','F','U',':RET:2106-3','N','021','DEN','628401','99734OH005000301','2014-01-01','2013-12-14 13:12:57','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:27'),(17024,13623,'N','19','021','EC','A',NULL,NULL,'','0001217387','0000908039','','IL','1','RUMMER','JACOB','','','','34','295113716','3276 WHIPPLE DR',0,'NORTON','OH','44203','5221','CY','39153','2006-03-25','M','',':RET:2106-3','N','021','HLT','1701414','52664OH152000901','2014-02-01','2014-01-09 15:19:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:20:42'),(15934,12757,'Y','18','021','EC','A','','','AC','0000076315','0000076315','OH00000203209','IL','1','Moreno','Rebecca','','','','34','284508462','N299 COUNTY ROAD 3A',0,'MC CLURE','OH','43534','9750','CY','39069','1951-10-08','F','U',':RET:2106-3','N','021','HLT','1475648','92036OH005002605','2014-02-01','2014-01-01 20:19:54','522.00',NULL,NULL,'560.22','38.22','R-OH001','OH0','560.22',NULL,0,'2014-01-03 02:07:00'),(2191,1803,'Y','18','021','EC','A','','','AC','0000541620','0000541620','OH00000758010','IL','1','Edwards','Jacqueline','','','','34','272608453','2960 LOESCHER RD',0,'LIMA','OH','45801','1252','CY','39003','1961-10-20','F','M',':RET:2106-3','N','021','HLT','964517','92036OH004001501','2014-01-01','2013-12-10 09:27:11','179.00',NULL,NULL,'345.43','166.43','R-OH002','OH0','345.43',NULL,0,'2013-12-25 19:19:45'),(5638,4472,'N','01','021','EC','A',NULL,NULL,'','0000315246','0000194758','','IL','1','valderas','maria','','','','34','640283884','412 13th',0,'levelland','TX','79336',NULL,'CY','48219','1979-02-28','F','',':RET:2106-3','N','021','DEN','499422','33348TX002000201','2014-01-01','2013-11-25 21:18:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:31:09'),(6058,4799,'Y','18','021','EC','A','','','AC','0000235175','0000235175','OH00000083377','IL','1','Lawhon','Vickie','','','','34','289527553','1146 BISHOP AVE',0,'HAMILTON','OH','45015','2124','CY','39017','1967-12-31','F','U',':RET:2106-3','N','021','DEN','299224','99734OH005000401','2014-01-01','2013-12-01 09:35:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:01:52'),(4713,3737,'Y','18','021','EC','A','','','AC','0000132047','0000132047','OH00000596228','IL','1','MOLONEY','NICOLE','','','','34','276742394','152 LARKINS STREET',0,'FINDLAY','OH','45840',NULL,'CY','39063','1978-08-12','F','M',NULL,'T','021','HLT','618345','92036OH005001505','2014-01-01','2013-12-12 15:49:43','558.00',NULL,NULL,'741.06','183.06','R-OH002','OH0','309.27',NULL,0,'2013-12-25 22:08:47'),(4575,3623,'Y','18','024','14','A','','','TE','0000763281','0000763281','','IL','1','Lozano','Laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-11-28','F','',NULL,NULL,NULL,'','471529','','2013-12-12','2013-12-12 17:08:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:05:04'),(18212,14536,'Y','18','021','EC','A','','','AC','0000986032','0000986032','OH00001713913','IL','1','CABIGON','ALEX','','','','34','268904488','8132 FAWN LAKE CT',0,'CINCINNATI','OH','45247','4503','CY','39061','1983-04-30','M','U',':RET:2036-2','N','021','HLT','2286302','92036OH002001201','2014-02-01','2014-01-14 16:20:50','135.00',NULL,NULL,'281.38','146.38','R-OH004','OH0','281.38',NULL,0,'2014-01-15 02:08:10'),(21837,17439,'Y','18','021','EC','A','','','AC','0000361052','0000361052','OH00002373657','IL','1','Reed','Cynthia','','','','34','280586304','6161 BERKINSHAW DR',0,'CINCINNATI','OH','45230','3675','CY','39061','1955-09-23','F','M',':RET:2106-3','N','021','HLT','3055847','92036OH006001201','2014-03-01','2014-02-06 11:07:28','695.00',NULL,NULL,'922.90','227.90','R-OH004','OH0','433.78',NULL,0,'2014-02-06 21:01:08'),(21874,17463,'Y','18','021','EC','A','','','AC','0001589104','0001589104','LA00001834725','IL','1','Bloxson','Antwon','','','','34','593506798','349 MARYVIEW FARM RD',0,'LAFAYETTE','LA','70507','4625','CY','22055','1987-06-24','M','U',':RET:2054-5','N','021','DEN','2819167','18575LA002000201','2014-03-01','2014-02-05 22:25:17','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-06 21:01:26'),(21935,17515,'N','01','021','EC','A',NULL,NULL,'','0000560635','0000975299','','IL','1','SOWEMIMO','LINDA','','','','34','456491802','5830 COASTAL WAY',0,'HOUSTON','TX','77085','1922','CY','48201','1964-10-17','F','',':RET:2054-5','N','021','DEN','3222083','33348TX002000201','2014-03-01','2014-02-07 10:12:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-07 19:00:12'),(22419,17901,'Y','18','021','EC','A','','','AC','0001636345','0001636345','LA00001930456','31','1','Yambra','Kenneth','','','','34','433532585','4420 Newlands St.',0,'Metairie','LA','70006',NULL,'CY','22071','1981-11-29','M','M',':RET:2106-3','N','021','DEN','3015494','18575LA002000201','2014-03-01','2014-02-10 13:53:18','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:29'),(23117,18426,'Y','18','021','EC','A','','','AC','0000846180','0000846180','OH00001518528','IL','1','richardson','a\'shaya','','','','34','301949261','6507 MARSOL RD',0,'MAYFIELD HEIGHTS','OH','44124','3570','CY','39035','1992-05-30','F','U',':RET:2054-5','N','021','DEN','2752097','99734OH005000401','2014-03-01','2014-02-12 10:50:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:22'),(24737,19637,'Y','18','021','EC','A','','','AC','0000937327','0000937327','OH00002629452','IL','1','LOPEZ DE PORTILLO','ROSA','','','','34','289063548','1826 PLEASANT AVE',0,'HAMILTON','OH','45015','1041','CY','39017','1962-09-15','F','U',NULL,'N','021','DEN','3831681','99734OH005000401','2014-04-01','2014-02-19 10:16:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:40:07'),(26976,21370,'N','01','021','EC','A',NULL,NULL,'','0001142233','0001071842','','IL','1','Carmany','Cynthia','Lynn','','','34','299641917','556 BREITON CIR',0,'BARBERTON','OH','44203','7783','CY','39153','1958-09-29','F','',':RET:2106-3','N','021','HLT','3493627','52664OH152000901','2014-04-01','2014-03-02 12:17:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','364.25',NULL,0,'2014-03-03 01:00:36'),(5488,4356,'Y','18','021','EC','A','','','AC','0000155763','0000155763','OH00001067854','IL','1','Richards','Judy','','','','34','288562951','6623 OAKLAND RD',0,'LOVELAND','OH','45140','9456','CY','39025','1954-04-06','F','U',NULL,'N','021','HLT','2028012','92036OH004000601','2014-01-01','2013-12-19 13:07:42','425.00',NULL,NULL,'449.32','24.32','R-OH005','OH0','449.32',NULL,0,'2013-12-25 23:10:59'),(13744,10971,'Y','18','021','EC','A','','','AC','0000129261','0000129261','OH00001043608','IL','1','Sweeney','Susan','','','','34','404820528','6415 CANASTOTA DR',0,'HAMILTON','OH','45011','5003','CY','39017','1952-05-25','F','M',NULL,'N','021','HLT','2243122','92036OH003001201','2014-01-01','2013-12-23 15:43:01','237.00',NULL,NULL,'629.96','392.96','R-OH004','OH0','629.96',NULL,0,'2013-12-26 13:09:47'),(3573,2868,'N','01','021','EC','A',NULL,NULL,'','0000876057','0000439416','','IL','1','Gross','James','Franklin','','','34','279703364','8480 Greenville Saint Marys Rd',0,'Greenville','OH','45331',NULL,'CY','39037','1962-11-18','M','',':RET:2106-3','N','021','HLT','1935101','92036OH005000506','2014-01-01','2013-12-22 07:24:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.34',NULL,0,'2013-12-25 21:22:36'),(9031,7166,'Y','18','021','EC','A','','','AC','0001055305','0001055305','OH00000833630','IL','1','healy','anthony',NULL,NULL,NULL,NULL,NULL,'204 MORNINGVIEW AVE',0,'AKRON','OH','44305','3530','CY','39153','1973-07-31','M','U',NULL,'T','021','HLT','1468577','52664OH151001305','2014-01-01','2013-12-18 11:20:26','191.07',NULL,NULL,'327.75','136.68','R-OH012','OH0','327.75',NULL,0,'2013-12-26 04:05:34'),(20676,16523,'Y','18','021','EC','A','','','AC','0000095224','0000095224','MS00001695596','31','1','REED','MARY','','','','34','425193748','PO BOX 354',0,'COFFEEVILLE','MS','38922',NULL,'CY','28161','1959-05-01','F','U',':RET:2054-5','N','021','DEN','3292311','46300MS002000101','2014-03-01','2014-01-30 10:41:58','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-30 21:00:52'),(19293,15379,'Y','18','021','EC','A','','','AC','0001283682','0001283682','LA00002469096','IL','1','rafidi','kylie','','','','34','438475460','4524 WADE DR',0,'METAIRIE','LA','70003','2710','CY','22051','1982-11-18','F','U',':RET:2106-3','T','021','DEN','2853530','18575LA002000201','2014-03-01','2014-01-21 17:17:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-22 03:21:56'),(18963,15109,'Y','18','021','EC','A','','','AC','0000106534','0000106534','TX00002275006','IL','1','harvey','yanett','','','','34','636848767','10580 Hammerly',0,'Houston','TX','77043',NULL,'CY','48201','1959-05-28','F','U',NULL,'N','021','DEN','1610066','33348TX002000201','2014-03-01','2014-01-17 12:35:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:56'),(18735,14929,'Y','18','021','EC','A','','','AC','0000536946','0000536946','OH00002274990','IL','1','Foraker','Lisa','','','','34','299727983','4176 Fremar NE',0,'Lancaster','OH','43130',NULL,'CY','39045','1977-02-15','F','M',':RET:2106-3','N','021','DEN','2639784','99734OH005000301','2014-03-01','2014-01-16 14:04:52','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-17 03:35:38'),(25614,20322,'Y','18','024','14','A','','','TE','0000830665','0000830665','','IL','1','Mai','Nhien',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-07-03','M','',NULL,NULL,NULL,'','3134713','','2014-02-22','2014-02-22 11:18:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-26 08:30:11'),(21993,17563,'N','01','021','EC','A',NULL,NULL,'','0001580010','0001773114','','IL','1','Boanca','Irina','','','','34','895388347','9124 OLD HAMMOND HWY',0,'BATON ROUGE','LA','70809',NULL,'CY','22033','1954-09-10','F','',NULL,'N','021','DEN','2739000','18575LA002000201','2014-03-01','2014-02-06 23:08:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:43'),(16490,13195,'N','01','021','EC','A',NULL,NULL,'','0000132084','0000085181','','IL','1','CLARK','VERNON','','','','34','290660234','150 S LEONARD AVE',0,'LIMA','OH','45804','2926','CY','39003','1956-10-26','M','',NULL,'N','021','HLT','1751826','92036OH002001501','2014-02-01','2014-01-06 16:18:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','619.40',NULL,0,'2014-01-07 04:06:31'),(6772,5374,'Y','18','021','EC','A','','','AC','0000566575','0000566575','OH00000336422','IL','1','BACOVIN','MARY','KIMBERLY','','','34','273600190','10433 WALKINGFERN DR',0,'HARRISON','OH','45030','1654','CY','39061','1958-07-13','F','M',NULL,'N','021','DEN','624387','99734OH005000301','2014-01-01','2013-11-25 15:36:34','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:16:40'),(3083,2478,'Y','18','021','EC','A','','','AC','0000776401','0000776401','OH00000030981','IL','1','Post','Pamela','Leigh','','','34','264847394','9810 SPENCERVILLE RD',0,'SPENCERVILLE','OH','45887','9726','CY','39003','1956-05-02','F','M',':RET:2106-3','N','021','HLT','1039627','92036OH004001501','2014-01-01','2013-12-06 17:00:36','154.00',NULL,NULL,'543.65','389.65','R-OH002','OH0','431.27',NULL,0,'2013-12-25 20:19:47'),(2573,2090,'Y','18','021','EC','A','','','AC','0000240321','0000240321','OH00000001317','IL','1','Ball','Mamie','','','','34','289528806','507 NORTH ST NW',0,'WARREN','OH','44483','3723','CY','39155','1952-10-27','F','M',':RET:2054-5','N','021','HLT','254734','92036OH004003201','2014-01-01','2013-12-09 15:08:31','349.00',NULL,NULL,'546.92','197.92','R-OH013','OH0','546.92',NULL,0,'2013-12-25 19:37:44'),(23598,18798,'Y','18','021','EC','A','','','AC','0001106830','0001106830','OH00002351168','IL','1','Smith','Judy','','','','34','235860558','1310 W SENECA AVE',0,'TIFFIN','OH','44883','2652','CY','39147','1951-01-27','F','M',':RET:2106-3','N','021','HLT','2645288','92036OH003002705','2014-03-01','2014-02-13 12:26:04','456.00',NULL,NULL,'601.12','145.12','R-OH006','OH0','601.12',NULL,0,'2014-02-13 22:03:06'),(23606,18803,'N','19','021','EC','A',NULL,NULL,'','0000051967','0000805157','','IL','1','Hemp','Kaitlyn','','','','34','769035596','732 w 1st st',0,'delphos','OH','45833',NULL,'CY','39161','2001-05-30','F','',':RET:2106-3','N','021','HLT','3474683','92036OH003001501','2014-03-01','2014-02-13 15:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-13 22:03:10'),(23222,18512,'Y','18','024','14','A','','','TE','0000022691','0000022691','','IL','1','Friedman','Bert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-18','M','',NULL,NULL,NULL,'','3808208','','2014-02-12','2014-02-12 14:36:26',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-12 21:32:20'),(2977,2398,'Y','18','021','EC','A','','','AC','0000482162','0000482162','OH00000352872','IL','1','MCENTIRE','SHARON','','','','34','272443247','22935 US HIGHWAY 224',0,'FOSTORIA','OH','44830','9624','CY','39063','1951-08-20','F','M',':RET:2106-3','N','021','DEN','1066296','99734OH005000301','2014-01-01','2013-12-05 19:22:42','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 20:17:09'),(6456,5117,'N','01','021','EC','A',NULL,NULL,'','0001089534','0000368533','','IL','1','Watson','Nancy','Ann','','','34','745717833','1041 Cosmos St. NW',0,'Hartville','OH','44632',NULL,'CY','39151','1961-12-28','F','',':RET:2106-3','T','021','HLT','1250473','52664OH151001501','2014-01-01','2013-12-11 07:48:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','600.41',NULL,0,'2013-12-26 00:49:49'),(6323,5013,'Y','18','024','14','A','','','TE','0000180980','0000180980','','IL','1','firm','edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-17','M','',NULL,NULL,NULL,'','949064','','2013-12-11','2013-12-11 11:16:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:46:25'),(17383,13909,'Y','18','021','EC','A','','','AC','0001234133','0001234133','OH00002311512','IL','1','Nissen','Ray','','','','34','280523587','29454 MILLBURY RD',0,'MILLBURY','OH','43447','9454','CY','39173','1951-11-15','M','M',':RET:2106-3','T','021','DEN','2531694','99734OH005000401','2014-02-01','2014-01-10 10:09:49','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2014-01-13 03:00:07'),(3621,2898,'N','01','021','EC','A',NULL,NULL,'','0000142828','0000387268','','IL','1','Houchin','Jeffrey','','','','34','290781830','611 GEORGIA DR',0,'BETHEL','OH','45106','1035','CY','39025','1966-05-10','M','',NULL,'N','021','HLT','2408887','92036OH001000601','2014-01-01','2013-12-22 16:14:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','404.73',NULL,0,'2013-12-25 21:23:41'),(3406,2734,'Y','18','021','EC','A','','','AC','0001681039','0001681039','LA00000325842','IL','1','Page','Tyrannie','','','','34','280923850','2200 Severn Ave',0,'Metairie','LA','70001',NULL,'CY','22051','1990-08-28','F','U',':RET:2054-5','N','021','DEN','2610859','18575LA002000201','2014-01-01','2013-12-22 14:40:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:15'),(16504,13203,'N','01','021','EC','A',NULL,NULL,'','0000891823','0000151989','','IL','1','mandato','leia','m','','','34','268800333','2697 US HIGHWAY 224 E',0,'GREENWICH','OH','44837','9553','CY','39077','1980-08-30','F','',':RET:2106-3','T','021','HLT','2181317','92036OH002002701','2014-02-01','2014-01-06 14:49:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','310.23',NULL,0,'2014-01-07 04:06:57'),(13821,11031,'N','01','021','EC','A',NULL,NULL,'','0001143316','0000581485','','IL','1','Kuntz','Erica','','','','34','275863185','2684 WADSWORTH RD',0,'NORTON','OH','44203','5368','CY','39153','1976-07-25','F','',':RET:2106-3','N','021','HLT','2184575','52664OH152000901','2014-01-01','2013-12-22 20:11:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','202.22',NULL,0,'2013-12-26 13:11:53'),(14574,11629,'Y','18','021','EC','A','','','AC','0000287102','0000287102','OH00001774971','IL','1','Moreo','Kristen','','','','34','564592696','2750 Pickle Rd',0,'Oregon','OH','43616',NULL,'CY','39095','1979-11-02','F','U',NULL,'N','021','HLT','1479136','92036OH005002606','2014-02-01','2013-12-27 15:51:52','170.00',NULL,NULL,'236.72','66.72','R-OH001','OH0','236.72',NULL,0,'2013-12-28 03:35:38'),(25829,20478,'N','19','021','EC','A',NULL,NULL,'','0000444962','0000467146','','IL','1','Weilnau','Evan','C','','','34','286117603','1076 REVERES RUN',0,'LEBANON','OH','45036','8974','CY','39165','2005-09-13','M','',':RET:2106-3','N','021','DEN','2946724','99734OH005000301','2014-04-01','2014-02-26 16:54:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:29'),(26244,20815,'Y','18','021','EC','A','','','AC','0000834369','0000834369','TX00002410845','IL','1','Tran','Lam','','','','34','730268615','814 BROKEN FEATHER TRL',0,'PFLUGERVILLE','TX','78660','3702','CY','48453','1969-01-02','M','M',':RET:2047-9','N','021','DEN','3322202','33348TX002000201','2014-04-01','2014-02-27 12:01:37','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-28 06:31:06'),(28532,22581,'Y','18','021','EC','A','','','AC','0000220037','0000220037','OH00002923201','IL','1','DEGEER','DEBORAH','L','','','34','303627850','3157 NILES ST',0,'CINCINNATI','OH','45208','2903','CY','39061','1957-01-21','F','U',':RET:2106-3','T','021','HLT','3842564','92036OH002001201','2014-04-01','2014-03-07 10:41:44','222.00',NULL,NULL,'694.78','472.78','R-OH004','OH0','694.78',NULL,0,'2014-03-07 21:32:08'),(21553,17217,'Y','18','021','EC','A','','','AC','0000309484','0000309484','OH00001676732','IL','1','Gibson','Paul','','','','34','219922621','3157 GERBERT RD',0,'COLUMBUS','OH','43224','4261','CY','39049','1963-07-31','M','U',':RET:2054-5','N','021','DEN','3655326','99734OH005000401','2014-03-01','2014-02-05 14:40:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:14'),(17167,13737,'Y','18','021','EC','A','','','AC','0001612808','0001612808','LA00001368310','IL','1','spurgeon','lugene','','','','34','437022703','15360 BLACKWATER RD',0,'ZACHARY','LA','70791','8701','CY','22033','1955-07-29','F','M',':RET:2106-3','N','021','DEN','1549601','18575LA002000201','2014-02-01','2014-01-08 16:15:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:22:06'),(6679,5297,'N','01','021','EC','A',NULL,NULL,'','0001069294','0000682116','','IL','1','Wright','Carolyn','Maxine','','','34','282529590','3820 TOWNSEND ANGLING RD',0,'COLLINS','OH','44826','9761','CY','39077','1954-02-20','F','',':RET:2106-3','N','021','HLT','669565','92036OH002002701','2014-01-01','2013-11-16 14:55:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.17',NULL,0,'2013-12-26 01:01:19'),(13062,10411,'Y','18','021','EC','A','','','AC','0001055317','0001055317','OH00001289825','IL','1','miller','charles','','','','34','287586646','354 ABBOTSBURY CT',0,'WESTERVILLE','OH','43082','9122','CY','39041','1958-10-22','M','R',':RET:2054-5','N','021','DEN','2084676','99734OH005000401','2014-01-01','2013-12-23 09:18:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:04'),(3734,2985,'Y','18','021','EC','A','','','AC','0000966821','0000966821','TX00000123519','31','1','ibarra','jennifer','','','','34','449971280','po box 842',0,'petersburg','TX','79250',NULL,'CY','48189','1979-11-09','F','M',':RET:2106-3','N','021','DEN','1169878','33348TX002000201','2014-01-01','2013-12-13 10:20:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:41'),(5230,4153,'Y','18','021','EC','A','','','AC','0000446277','0000446277','OH00001275432','IL','1','Kress','Richard','','','','34','276822520','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','1976-01-03','M','M',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54','315.00',NULL,NULL,'975.21','660.21','R-OH012','OH0','276.08',NULL,0,'2013-12-25 23:04:46'),(438,360,'Y','18','021','EC','A','','','AC','0000122941','0000122941','OH00000739665','IL','1','pavich','mark','','','','34','291744776','350 TIBET RD',0,'COLUMBUS','OH','43202','1462','CY','39049','1971-07-18','M','U',':RET:2106-3','N','021','DEN','396241','99734OH005000401','2014-01-01','2013-12-04 11:00:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:47:06'),(23519,18736,'Y','18','021','EC','A','','','AC','0000384444','0000384444','OH00002587263','IL','1','FRANKOWSKI','DAVID','','','','34','292866647','370 EDEN LANE UNIT 3',0,'MEDINA','OH','44256',NULL,'CY','39103','1982-06-19','M','U',':RET:2106-3','N','021','HLT','2887311','52664OH151001501','2014-03-01','2014-02-13 11:26:24','189.00',NULL,NULL,'309.99','120.99','R-OH012','OH0','309.99',NULL,0,'2014-02-13 22:02:19'),(830,687,'Y','18','021','EC','A','','','AC','0001010193','0001010193','OH00000287452','IL','1','Durham','Cassondra','G','','','34','413043783','4391 Sandy Lake Road',0,'Ravenna','OH','44266',NULL,'CY','39133','1970-04-20','F','M',NULL,'N','021','HLT','1644168','52664OH151001304','2014-01-01','2013-12-16 16:38:08','78.00',NULL,NULL,'302.62','224.62','R-OH012','OH0','302.62',NULL,0,'2013-12-25 18:06:20'),(21688,17317,'Y','18','021','EC','A','','','AC','0001785170','0001785170','LA00001443794','IL','1','Brenckle','Rita','R','','','34','438117765','2945 MOUNT KENNEDY DR',0,'MARRERO','LA','70072','5210','CY','22051','1957-02-16','F','U',NULL,'T','021','DEN','2678052','18575LA002000101','2014-03-01','2014-02-04 20:23:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-05 21:31:04'),(924,767,'Y','18','021','EC','A','','','AC','0000806322','0000806322','OH00000034136','IL','1','LoGrande','Elizabeth','','','','34','299763643','14201 G.A.R HWY',0,'CHARDON','OH','44024','0705','CY','39055','1980-06-29','F','U',':RET:2106-3','T','021','DEN','1012348','99734OH005000401','2014-01-01','2013-10-28 19:44:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:08:56'),(6417,5087,'Y','18','024','14','A','','','TE','0001147312','0001147312','','IL','1','Oliver','Bonita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-01-27','F','',NULL,NULL,NULL,'','1028097','','2013-12-11','2013-12-11 08:42:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:48:46'),(20916,16719,'Y','18','021','EC','A','','','AC','0000793499','0000793499','OH00001539505','IL','1','Small','Dawyn','','','','34','278829078','3401 CURTIS ST',0,'MOGADORE','OH','44260','1009','CY','39153','1972-05-25','F','M',':RET:2106-3','T','021','HLT','3571998','52664OH152000901','2014-03-01','2014-01-31 15:26:06','178.00',NULL,NULL,'603.19','425.19','R-OH012','OH0','244.57',NULL,0,'2014-01-31 21:01:30'),(3495,2806,'Y','18','024','14','A','','','TE','0000769988','0000769988','','IL','1','Riesenberg','Gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-05-22','M','',NULL,NULL,NULL,'','1874880','','2013-12-22','2013-12-22 14:18:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:20:32'),(4571,3620,'Y','18','021','EC','A','','','AC','0001184956','0001184956','TX00000667413','IL','1','PATTERSON','HOLLY','','','','34','450556458','1420 W MCDERMOTT DR',0,'ALLEN','TX','75013','3333','CY','48085','1978-08-09','F','U',':RET:2106-3','N','021','DEN','933781','33348TX002000101','2014-01-01','2013-12-12 14:08:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 22:04:59'),(13874,11070,'Y','18','021','EC','A','','','AC','0000264202','0000264202','OH00001008403','IL','1','Peterson','Aaron','','','','34','259630592','8238 EMERALD AVE NE',0,'CANTON','OH','44721','1772','CY','39151','1977-05-08','M','R',':RET:2106-3','N','021','HLT','1992547','52664OH151001501','2014-01-01','2013-12-23 13:38:12','0.00',NULL,NULL,'328.98','328.98','R-OH015','OH0','328.98',NULL,0,'2013-12-26 13:13:08'),(19303,15388,'Y','18','021','EC','A','','','AC','0001634957','0001634957','LA00001565438','IL','1','Hemenway','Brad','','','','34','578945563','59330 SEXTON DR',0,'PLAQUEMINE','LA','70764','6575','CY','22047','1955-10-05','M','M',':RET:2106-3','N','021','DEN','2964841','18575LA002000101','2014-03-01','2014-01-21 13:00:58','0.00',NULL,NULL,'94.59','94.59','R-LA005','LA0','25.02',NULL,1,'2014-01-22 03:22:02'),(22306,17807,'Y','18','021','EC','A','','','AC','0000050718','0000050718','OH00001881346','IL','1','kabbes','connor','','','','34','270989809','5663 HIGHLAND TER',0,'MILFORD','OH','45150','1816','CY','39025','1993-01-14','M','U',':RET:2106-3','N','021','HLT','3128020','92036OH005000605','2014-03-01','2014-01-25 12:41:48','105.00',NULL,NULL,'214.67','109.67','R-OH005','OH0','214.67',NULL,0,'2014-02-10 11:00:40'),(21258,16988,'Y','18','024','14','A','','','TE','0000227069','0000227069','','IL','1','Schackmann','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-08-04','M','',NULL,NULL,NULL,'','2087598','','2014-02-03','2014-02-03 11:14:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:21'),(7463,5905,'N','01','021','EC','A',NULL,NULL,'','0000052321','0000327619','','IL','1','Smart','Toni','','','','34','426398509','930 Forest Drive',0,'Brandon','MS','39042',NULL,'CY','28121','1981-03-26','M','',NULL,'N','021','DEN','746039','46300MS002000201','2014-01-01','2013-12-15 09:19:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 02:30:58'),(7198,5704,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000764949','','IL','1','Shamy','Alexander','B',NULL,NULL,NULL,NULL,'13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',':RET:2106-3','N','021','DEN','1081283','99734OH005000301','2014-01-01','2013-12-14 17:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:35'),(6805,5398,'Y','18','021','EC','A','','','AC','0000121579','0000121579','TX00000253946','IL','1','Andrews','Kenyon','Eugene','','','34','628227718','5202 Bangor Avenue',0,'Lubbock','TX','79414',NULL,'CY','48303','1991-01-12','M','M',':RET:2054-5','N','021','DEN','918133','33348TX002000101','2014-01-01','2013-11-14 09:21:47','0.00',NULL,NULL,'50.04','50.04','R-TX014','TX0','25.02',NULL,0,'2013-12-26 01:30:07'),(6754,5359,'Y','18','021','EC','A','','','AC','0000865825','0000865825','OH00000323681','IL','1','Harris','Janet','','','','34','288547119','2371 CALL RD',0,'STOW','OH','44224','1538','CY','39153','1956-09-20','F','M',':RET:2106-3','N','021','HLT','883760','52664OH152000901','2014-01-01','2013-11-25 13:15:02','398.06',NULL,NULL,'398.06','0.00','R-OH012','OH0','398.06',NULL,0,'2013-12-26 01:16:09'),(8996,7138,'Y','18','021','EC','A','','','AC','0001025496','0001025496','OH00000642921','IL','1','Williams','Gregory','','','','34','269602495','16 CLARK ST',0,'MIDDLETOWN','OH','45042','2069','CY','39017','1956-10-12','M','U',':RET:1002-5^:RET:2106-3','T','021','DEN','2102164','99734OH005000401','2014-01-01','2013-12-18 17:59:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:43'),(5913,4683,'Y','18','021','EC','A','','','AC','0000173819','0000173819','TX00001487576','IL','1','Nolley','Marilyn','Estelle','','','34','455210773','640 PEACEFUL WOODS TRL',0,'HOLLY LAKE RANCH','TX','75765','7564','CY','48499','1956-11-19','F','U',':RET:2106-3','N','021','DEN','1867870','33348TX002000101','2014-01-01','2013-12-23 22:52:52','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:50:04'),(1565,1306,'Y','18','021','EC','A','','','AC','0000700815','0000700815','TX00000363440','IL','1','fenton','rebecca','','','','34','460859067','2815 W MCCRAINIE ST',0,'NACOGDOCHES','TX','75961','8855','CY','48347','1970-08-18','F','M',':RET:2106-3','N','021','DEN','2448724','33348TX002000201','2014-01-01','2013-12-24 05:47:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:01'),(20265,16170,'Y','18','021','EC','A','','','AC','0000188881','0000188881','OH00002258182','IL','1','Petush','Tambra','','','','34','291641992','887 Georgia Ave.',0,'Akron','OH','44306',NULL,'CY','39153','1959-04-22','F','U',':RET:2106-3','N','021','DEN','2047650','99734OH005000301','2014-03-01','2014-01-28 11:05:18','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-28 21:00:20'),(20017,15964,'Y','18','021','EC','A','','','AC','0000526926','0000526926','TX00001595546','IL','1','Salazar','Esmeralda','','','','34','462552486','409 NE GOODWIN',0,'COTULLA','TX','78014','2525','CY','48283','1977-12-25','F','U',NULL,'N','021','DEN','3107297','33348TX002000201','2014-03-01','2014-01-26 09:37:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-26 19:00:12'),(4648,3684,'Y','18','021','EC','A','','','AC','0000352812','0000352812','OH00001282635','IL','1','Scharf','Eric','','','','34','289745223','564 NASH AVE',0,'NILES','OH','44446','1458','CY','39155','1971-07-30','M','R',':RET:2106-3','N','021','HLT','1093184','92036OH001003201','2014-01-01','2013-12-11 22:52:15','0.00',NULL,NULL,'386.87','386.87','R-OH013','OH0','386.87',NULL,0,'2013-12-25 22:06:58'),(18991,15127,'N','01','021','EC','A',NULL,NULL,'','0000551443','0000463260','','IL','1','Bernstein','Jeffrey','','','','34','283703001','2175 CAMPUS RD',0,'BEACHWOOD','OH','44122','1216','CY','39035','1961-09-02','M','',':RET:2106-3','N','021','HLT','2281072','52664OH151001304','2014-03-01','2014-01-17 11:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.97',NULL,0,'2014-01-20 08:06:11'),(767,633,'N','01','021','EC','A',NULL,NULL,'','0001252967','0000280312','','IL','1','Anderson','Douglas','Wayne','','','34','300484697','5508 COUNTY ROAD 522',0,'STEPHENVILLE','TX','76401','7454','CY','48143','1950-07-19','M','',':RET:2106-3','N','021','DEN','2496443','33348TX002000201','2014-01-01','2013-12-16 12:09:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:04:43'),(2439,1987,'Y','18','021','EC','A','','','AC','0000082538','0000082538','OH00000774085','IL','1','Kail','Becky','','','','34','278521405','763 BEVERLY AVE',0,'CANAL FULTON','OH','44614','8474','CY','39151','1956-09-28','F','M',':RET:2106-3','T','021','HLT','927219','52664OH151001305','2014-01-01','2013-12-09 15:09:25','372.00',NULL,NULL,'624.99','252.99','R-OH015','OH0','624.99',NULL,0,'2013-12-25 19:34:23'),(22142,17673,'Y','18','021','EC','A','','','AC','0000970494','0000970494','OH00001502215','IL','1','Swank','Jeffery','','','','34','288766718','3465 SOUTH ARLINGTON ROAD',0,'AKRON','OH','44312',NULL,'CY','39153','1965-07-19','M','U',':RET:2106-3','T','021','HLT','2811918','52664OH152000901','2014-03-01','2014-02-08 12:14:51','0.00',NULL,NULL,'307.12','307.12','R-OH012','OH0','307.12',NULL,0,'2014-02-08 19:00:49'),(21650,17289,'Y','18','021','EC','A','','','AC','0001323679','0001323679','LA00001847812','IL','1','WASCOM','RALEE','','','','34','438839871','30254 SIMMONS RD',0,'FRANKLINTON','LA','70438',NULL,'CY','22117','1992-03-16','F','U',NULL,'N','021','DEN','3107505','18575LA002000201','2014-03-01','2014-02-04 20:12:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:49'),(9551,7569,'N','01','021','EC','A',NULL,NULL,'','0000254527','0000216097','','IL','1','Beam','Valerie','L','','','34','284641230','56 PORT WILLIAM RD',0,'PORT WILLIAM','OH','45164','1011','CY','39027','1956-12-19','F','',':RET:2106-3','N','021','DEN','1867652','99734OH005000301','2014-01-01','2013-12-21 12:45:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:17'),(20685,16528,'Y','18','021','EC','A','','','AC','0001147375','0001147375','TX00001696980','IL','1','Ortiz','Raul','','','','34','457088267','1101 W. Sheer St.',0,'Fort Stocaton','TX','79735',NULL,'CY','48371','1956-03-17','M','U',NULL,'N','021','DEN','3576157','33348TX002000101','2014-03-01','2014-01-30 15:21:53','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-30 21:00:56'),(20651,16502,'Y','18','021','EC','A','','','AC','0000803079','0000803079','TX00002545131','IL','1','Govea','Edgar','','','','34','644206349','615 N. Lomaland Dr',0,'El Paso','TX','79907',NULL,'CY','48141','1990-09-14','M','U',':RET:2106-3','N','021','DEN','3001078','33348TX002000201','2014-03-01','2014-01-30 15:34:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-30 21:00:38'),(20604,16463,'Y','18','021','EC','A','','','AC','0000327304','0000327304','OH00002256817','IL','1','DELONG','JULIE','','','','34','244116910','22260 SYCAMORE RD',0,'MOUNT VERNON','OH','43050',NULL,'CY','39083','1959-02-19','F','M',':RET:2106-3','N','021','DEN','2730305','99734OH005000401','2014-03-01','2014-01-30 14:15:41','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:14'),(16602,13279,'Y','18','024','14','A','','','TE','0001746227','0001746227','','IL','1','Smith','Kim',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-30','F','',NULL,NULL,NULL,'','2571080','','2014-01-07','2014-01-07 13:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-08 18:24:04'),(17085,13673,'Y','18','021','EC','A','','','AC','0001090661','0001090661','TX00001371604','IL','1','MARTINEZ','VERONICA','','','','34','455656665','214 DORSEY',0,'SAN ANTONIO','TX','78221',NULL,'CY','48029','1976-08-13','F','U',NULL,'N','021','DEN','2521141','33348TX002000201','2014-02-01','2014-01-08 14:44:45','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:21:24'),(18524,14771,'Y','18','021','EC','A','','','AC','0001018902','0001018902','TX00001478037','IL','1','Heaton','Krista','','','','34','449998155','15101 GUADALUPE RIVER DR',0,'CORPUS CHRISTI','TX','78410','5710','CY','48355','1986-09-25','F','R',NULL,'N','021','DEN','1967757','33348TX002000101','2014-02-01','2014-01-15 16:12:51','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-01-16 08:46:40'),(19943,15906,'Y','18','021','EC','A','','','AC','0000229464','0000229464','OH00001664604','IL','1','Jackson','Brandy','','','','34','287803426','3643 HOILES AVE',0,'TOLEDO','OH','43612','1026','CY','39095','1983-06-30','F','M',NULL,'N','021','HLT','1513916','92036OH006002601','2014-03-01','2014-01-24 10:02:58','69.00',NULL,NULL,'175.52','106.52','R-OH001','OH0','175.52',NULL,0,'2014-01-24 21:01:16'),(19394,15461,'N','01','021','EC','A',NULL,NULL,'','0000728745','0000156963','','IL','1','Kunkler','Collette','A','','','34','281504540','435 Shell Park road',0,'marysville','OH','43040',NULL,'CY','39159','1964-07-17','F','',':RET:2106-3','N','021','DEN','3205122','99734OH005000401','2014-03-01','2014-01-21 11:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:49'),(19550,15583,'Y','18','021','EC','A','','','AC','0000089854','0000089854','OH00002094207','IL','1','Martinez','Donald','','','','34','523110858','1646 GOODWIN AVE',0,'TOLEDO','OH','43605','3310','CY','39095','1961-06-10','M','M',':RET:2106-3','N','021','HLT','2091640','92036OH006002601','2014-03-01','2014-01-22 18:06:40','189.00',NULL,NULL,'301.86','112.86','R-OH001','OH0','301.86',NULL,0,'2014-01-23 03:02:28'),(23537,18750,'Y','18','021','EC','A','','','AC','0002388444','0002388444','LA00001648557','IL','1','CHAPMAN','SHARON','','','','34','437063663','5703 LANNY ST',0,'ALEXANDRIA','LA','71303',NULL,'CY','22079','1965-05-29','F','U',NULL,'N','021','DEN','3364121','18575LA002000201','2014-03-01','2014-02-13 12:22:15','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-13 22:02:30'),(23938,19033,'N','19','021','EC','A',NULL,NULL,'','0000979339','0000404848','','IL','1','Jorgenson','Ella','Grace','','','34','276159304','754 POINTVIEW DR',0,'WESTERVILLE','OH','43081','3476','CY','39049','2009-03-09','F','',':RET:2106-3','N','021','DEN','3425477','99734OH005000301','2014-03-01','2014-02-15 06:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-15 21:00:07'),(24322,19316,'Y','18','021','EC','A','','','AC','0001021177','0001021177','TX00002698560','IL','1','GONZALES','DANNY','D','','','34','451086730','310 HESTER AVE',0,'DONNA','TX','78537','2572','CY','48215','1955-12-17','M','U',NULL,'N','021','DEN','3706860','33348TX002000201','2014-04-01','2014-02-18 11:30:14','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-18 22:00:09'),(25943,20573,'Y','18','024','14','A','','','TE','0000880577','0000880577','','IL','1','Rock','Jacqueline',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-04-06','F','',NULL,NULL,NULL,'','3249751','','2014-02-26','2014-02-26 08:42:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:01:32'),(26234,20807,'Y','18','021','EC','A','','','AC','0001148709','0001148709','TX00002724729','IL','1','Bentley','Lowell','','','','34','529450421','1400 Eldorado Pkwy',0,'McKinney','TX','75069',NULL,'CY','48085','1982-11-10','M','M',':RET:2106-3','N','021','DEN','2792736','33348TX002000201','2014-03-01','2014-02-27 01:04:12','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-28 06:31:02'),(27085,21443,'Y','18','021','EC','A','','','AC','0000289584','0000289584','OH00002784236','IL','1','Strayer','Dennis','','','','34','270506697','1364 WATERLOO RD',0,'MOGADORE','OH','44260','9608','CY','39133','1951-07-27','M','U',':RET:2106-3','N','021','HLT','3294433','52664OH151001305','2014-04-01','2014-03-03 11:06:20','480.00',NULL,NULL,'640.70','160.70','R-OH012','OH0','640.70',NULL,0,'2014-03-03 21:30:13'),(28914,22885,'N','19','021','EC','A',NULL,NULL,'','0000643296','0001110431','','S1','1','Kolar','Nikola','Senior','','','34','280984105','6510 Morrow Cozaddale',0,'Morrow','OH','45152',NULL,'CY','39165','1995-03-22','F','',':RET:2106-3','N','021','DEN','3470217','99734OH005000301','2014-04-01','2014-03-10 09:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:28'),(1027,842,'Y','18','021','EC','A','','','AC','0000487737','0000487737','TX00001086120','IL','1','Cheung','Melissa','','','','34','503967204','226 Derringer St',0,'Tuscola','TX','79562',NULL,'CY','48441','1966-10-11','F','M',':RET:2047-9','N','021','DEN','1083777','33348TX002000201','2014-01-01','2013-12-02 22:41:34','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-25 18:15:26'),(7851,6217,'Y','18','021','EC','A','','','AC','0001245587','0001245587','OH00000610667','IL','1','Smith','William','G','','','34','066387844','6207 Denise Dr',0,'North Ridgeville','OH','44039',NULL,'CY','39093','1952-02-23','M','U',':RET:2106-3','N','021','DEN','2403688','99734OH005000301','2014-01-01','2013-12-20 09:32:39','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:04:50'),(22229,17743,'Y','18','021','EC','A','','','AC','0000183552','0000183552','OH00001850729','S3','1','Urton','Maria','','','','34','293082931','501 LANTERN GLOW CT',0,'LEBANON','OH','45036','8029','CY','39165','2004-01-31','M','U',':RET:1002-5^:RET:2106-3','N','021','HLT','3584867','92036OH002001201','2014-03-01','2014-02-08 19:46:35','0.00',NULL,NULL,'157.43','157.43','R-OH004','OH0','157.43',NULL,0,'2014-02-09 19:00:31'),(20225,16137,'Y','18','024','14','A','','','TE','0000496778','0000496778','','IL','1','Bechstein','Cindy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-25','F','',NULL,NULL,NULL,'','1775951','','2014-01-27','2014-01-27 14:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:47'),(17658,14113,'Y','18','021','EC','A','','','AC','0000163704','0000163704','OH00002173816','IL','1','Fisher','William','','','','34','297721016','4444 STATE ROUTE 763',0,'RIPLEY','OH','45167','8201','CY','39015','1975-02-20','M','M',':RET:2106-3','T','021','DEN','2645671','99734OH005000301','2014-02-01','2014-01-13 14:47:36','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-01-14 01:32:43'),(17137,13713,'N','01','021','EC','A',NULL,NULL,'','0001018246','0000211026','','IL','1','Carr','David','P','','','34','274648418','1708 WHITE BIRCH',0,'AMELIA','OH','45102','2200','CY','39025','1955-06-16','M','',':RET:2106-3','N','021','DEN','2576660','99734OH005000401','2014-02-01','2014-01-08 17:58:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:49'),(4938,3918,'N','01','021','EC','A',NULL,NULL,'','0001220815','0000236240','','IL','1','Hensley','Lucille','May','','','34','293527781','288 E BEECH ST',0,'JEFFERSON','OH','44047','9490','CY','39007','1953-02-25','F','',':RET:2106-3','N','021','DEN','834401','99734OH005000401','2014-01-01','2013-12-07 13:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:45:36'),(5166,4097,'Y','18','021','EC','A','','','AC','0000810776','0000810776','OH00001299910','IL','1','rox','regina','','','','34','273708192','25450 euclid ave',0,'euclid','OH','44117',NULL,'CY','39035','1966-09-05','F','U',':RET:2054-5','T','021','DEN','2177852','99734OH005000401','2014-01-01','2013-12-19 10:53:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:11'),(17032,13627,'Y','18','021','EC','A','','','AC','0001216277','0001216277','OH00001360915','IL','1','Moore','Nicole','','','','34','280681585','3957 COUNTY ROAD L',0,'SWANTON','OH','43558','9504','CY','39051','1974-12-21','F','M',':RET:2106-3','T','021','HLT','2228618','92036OH004002601','2014-02-01','2014-01-09 11:05:42','101.00',NULL,NULL,'227.55','126.55','R-OH001','OH0','227.55',NULL,0,'2014-01-13 02:20:45'),(16815,13450,'Y','18','021','EC','A','','','AC','0001086035','0001086035','MS00001739074','IL','1','PERRY','LARRY','','','','34','428154031','1896 N FRONTAGE RD',0,'CLINTON','MS','39056','6233','CY','28049','1958-06-29','M','M',NULL,'N','021','DEN','1738110','46300MS002000201','2014-02-01','2014-01-11 11:56:33','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:18:18'),(15333,12264,'Y','18','021','EC','A','','','AC','0000616876','0000616876','OH00001796211','IL','1','FLORES','CARLOS','','','','34','287785316','1051 RALSTON AVE',0,'DEFIANCE','OH','43512',NULL,'CY','39039','1972-09-28','M','U',NULL,'N','021','HLT','1901455','92036OH005002606','2014-02-01','2013-12-31 19:38:31','231.00',NULL,NULL,'253.89','22.89','R-OH001','OH0','253.89',NULL,1,'2014-01-02 04:23:59'),(16150,12933,'Y','18','021','EC','A','','','AC','0000868244','0000868244','OH00001828254','31','1','HARTZEL','SANDRA','','','','34','280584077','PO BOX 4',0,'PUT IN BAY','OH','43456',NULL,'CY','39123','1955-04-08','F','M',':RET:2106-3','N','021','HLT','1907812','92036OH006002701','2014-02-01','2014-01-03 15:36:32','685.00',NULL,NULL,'813.72','128.72','R-OH006','OH0','394.02',NULL,0,'2014-01-04 02:06:12'),(27512,21765,'N','19','021','EC','A',NULL,NULL,'','0000809735','0000732649','','IL','1','Dunlea','Susan','Elizabeth','','','34','288024354','7305 WILLOWOOD DR',0,'WEST CHESTER','OH','45241','3707','CY','39017','1997-10-08','F','',':RET:2106-3','N','021','HLT','3867739','92036OH002001201','2014-04-01','2014-03-04 10:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-03-04 21:02:34'),(28170,22293,'Y','18','021','EC','A','','','AC','0000997810','0000997810','OH00002769322','IL','1','Schwartz','Paul','Jeffrey','','','34','481569278','7124 HARBOUR TOWN DR',0,'WEST CHESTER','OH','45069','6345','CY','39017','1957-09-19','M','R',':RET:2106-3','N','021','HLT','3911015','92036OH002001201','2014-04-01','2014-03-06 11:55:13','0.00',NULL,NULL,'578.36','578.36','R-OH004','OH0','578.36',NULL,0,'2014-03-06 21:02:48'),(14404,11487,'Y','18','021','EC','A','','','AC','0000915654','0000915654','OH00000904250','IL','1','Keene','Debra','','','','34','233865312','944 Main Ave SW',0,'Warren','OH','44483',NULL,'CY','39155','1956-09-20','F','M',':RET:2106-3','T','021','DEN','1742289','99734OH005000401','2014-02-01','2013-12-27 17:46:59','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-28 03:31:16'),(14212,11333,'Y','18','021','EC','A','','','AC','0000690971','0000690971','TX00001360603','IL','1','Lopez','Maria','','','','34','458088776','244 W HANDY DR',0,'PHARR','TX','78577','9036','CY','48215','1955-12-21','F','U',NULL,'N','021','DEN','2110988','33348TX002000201','2014-02-01','2013-12-26 15:45:17','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-27 02:04:31'),(7479,5918,'Y','18','021','EC','A','','','AC','0000444893','0000444893','OH00000424338','IL','1','Orecchio','Mark','','','','34','275709763','346 SAND ST',0,'CROOKSVILLE','OH','43731','1229','CY','39127','1970-04-15','M','M',':RET:2106-3','N','021','DEN','1043968','99734OH005000401','2014-01-01','2013-12-15 11:39:15','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-26 02:31:21'),(4977,3952,'Y','18','021','EC','A','','','AC','0000231732','0000231732','TX00000442209','IL','1','McCann','Mabinthy','','','','34','217218551','301 LA CASA DR',0,'KERRVILLE','TX','78028','5968','CY','48265','1987-12-02','F','U',NULL,'N','021','DEN','646314','33348TX002000201','2014-01-01','2013-12-06 22:53:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:37'),(291,240,'Y','18','021','EC','A','','','AC','0000134624','0000134624','LA00000671767','IL','1','VINSON','JOY','','','','34','433734340','2205 BECKETT STREET',0,'BOSSIER CITY','LA','71111',NULL,'CY','22015','1988-10-15','F','U',NULL,'N','021','DEN','1034284','18575LA002000201','2014-01-01','2013-10-12 16:10:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 17:30:32'),(1435,1197,'Y','18','021','EC','A','','','AC','0001208230','0001208230','LA00001615954','IL','1','CROCE','MICK','','','','34','016568215','1906 GENERAL TAYLOR ST',0,'NEW ORLEANS','LA','70115','5350','CY','22071','1973-03-19','M','M',NULL,'T','021','DEN','1791018','18575LA002000201','2014-01-01','2013-12-24 17:48:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:41'),(1767,1458,'N','01','021','EC','A',NULL,NULL,'','0000117803','0001188798','','IL','1','RUTAN','NARGES','','','','34','535730375','467 N HIGH ST',0,'COLUMBUS','OH','43215','2007','CY','39049','1984-04-23','F','',':RET:2028-9','N','021','DEN','1881993','99734OH005000301','2014-01-01','2013-12-24 14:14:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:03'),(5862,4653,'N','19','021','EC','A',NULL,NULL,'','0000186118','0001050642','','IL','1','Harper','Randal','Kalai','','','34','292922222','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1990-08-23','M','',':RET:2106-3','N','021','HLT','1829936','92036OH005002606','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99',NULL,0,'2013-12-25 23:49:02'),(21604,17251,'Y','18','021','EC','A','','','AC','0000873273','0000873273','OH00001574617','IL','1','Jeffries','Stephone',NULL,NULL,NULL,NULL,NULL,'1000 DELIA AVE',0,'AKRON','OH','44320','2120','CY','39153','1964-07-16','M','U',':RET:2054-5','N','021','DEN','3763912','99734OH005000301','2014-03-01','2014-02-05 12:50:47','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-05 21:30:32'),(4560,3610,'N','01','021','EC','A',NULL,NULL,'','0000426405','0000972724','','IL','1','Williams','Jason','','','','34','294865519','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-01-06','M','',':RET:2054-5','N','021','HLT','1132180','52664OH152000901','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','199.60',NULL,0,'2013-12-25 22:04:41'),(2749,2225,'Y','18','021','EC','A','','','AC','0001230355','0001230355','OH00001001946','IL','1','Jackman','Susan','','','','34','273468869','10657 CAROLINA TRACE RD',0,'HARRISON','OH','45030','1611','CY','39061','1949-06-12','F','M',':RET:2106-3','N','021','HLT','1104642','92036OH003001205','2014-01-01','2013-12-01 22:45:28','480.00',NULL,NULL,'672.53','192.53','R-OH004','OH0','672.53',NULL,0,'2013-12-25 19:49:01'),(20997,16778,'Y','18','021','EC','A','','','AC','0000469571','0000469571','OH00001708193','IL','1','LAHEY','JENNIFER','','','','34','289622654','8330 TUCKER DRIVE',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','1965-04-27','F','U',':RET:2106-3','N','021','DEN','3262694','99734OH005000301','2014-03-01','2014-02-01 14:09:44','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-02-01 19:00:27'),(20686,16529,'Y','18','024','14','A','','','TE','0001240556','0001240556','','IL','1','LEE','KRISTEN','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-01-10','F','',NULL,NULL,NULL,'','1727612','','2014-01-29','2014-01-29 19:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:56'),(14674,11714,'Y','18','021','EC','A','','','AC','0001010938','0001010938','MS00001039674','31','1','Richard','Kima','Lucille','','','34','436597863','1988 THOMAS ST',0,'HORN LAKE','MS','38637','3317','CY','28033','1985-09-10','F','U',':RET:2054-5','T','021','DEN','1838127','46300MS002000201','2014-02-01','2013-12-28 10:33:42','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,1,'2013-12-29 11:08:20'),(14784,11807,'Y','18','024','14','A','','','TE','0000208501','0000208501','','IL','1','Peterson','Aaron',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-08','M','',NULL,NULL,NULL,'','1525396','','2013-12-23','2013-12-23 20:42:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:13:18'),(19757,15749,'Y','18','024','14','A','','','TE','0000197173','0000197173','','IL','1','Sturgill','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-06-27','F','',NULL,NULL,NULL,'','1854339','','2014-01-23','2014-01-23 14:59:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:21'),(24635,19552,'Y','18','021','EC','A','','','AC','0001828593','0001828593','LA00002210119','IL','1','WALKER','DONNA','','','','34','435256618','45263 SAINT PAUL LOOP',0,'HAMMOND','LA','70401','5008','CY','22105','1967-03-27','F','U',':RET:2054-5','N','021','DEN','2790072','18575LA002000201','2014-04-01','2014-02-19 10:43:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:18:52'),(27168,21510,'N','01','021','EC','A',NULL,NULL,'','0000541102','0000891267','','IL','1','Berry','Wes','Blaine','','','34','539080900','4314 Faith Rd',0,'Wichita Falls','TX','76308',NULL,'CY','48485','1976-10-01','M','',':RET:2106-3','N','021','DEN','3176103','33348TX002000201','2014-04-01','2014-03-03 00:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-03 21:31:03'),(1538,1281,'Y','18','021','EC','A','','','AC','0000716339','0000716339','OH00000658492','IL','1','patel','hansaben','','','','34','198729218','7233 ENGLE RD',0,'CLEVELAND','OH','44130','3428','CY','39035','1952-01-12','F','M',NULL,'N','021','DEN','2426556','99734OH005000401','2014-01-01','2013-12-24 17:03:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:12'),(22632,18073,'Y','18','021','EC','A','','','AC','0000600649','0000600649','TX00002515054','IL','1','sides-evans','danette','','','','34','464391984','175 FITZGERALD LN',0,'LIVINGSTON','TX','77351','4633','CY','48373','1977-03-09','F','U',':RET:2106-3','N','021','DEN','3239764','33348TX002000201','2014-03-01','2014-02-11 02:54:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:18'),(5886,4669,'N','19','021','EC','A',NULL,NULL,'','0000125559','0001071786','','IL','1','Walker','Cadin','','','','34','302115899','6803 BREMEN RD SE',0,'LANCASTER','OH','43130','9417','CY','39045','2006-08-28','M','',':RET:2106-3','N','021','DEN','2554208','99734OH005000301','2014-01-01','2013-12-23 22:43:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:33'),(22518,17977,'Y','18','021','EC','A','','','AC','0000622751','0000622751','TX00001642060','IL','1','Longoria','Crystal','','','','34','631306621','102 DAWNRIDGE DR',0,'SAN ANTONIO','TX','78213','3102','CY','48029','1992-04-20','F','U',NULL,'N','021','DEN','3767541','33348TX002000101','2014-03-01','2014-02-10 16:06:13','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-10 21:31:23'),(22286,17791,'Y','18','021','EC','A','','','AC','0000737888','0000737888','OH00002056080','IL','1','Shanes','Peter','','','','34','290545881','5042 EVERTON AVE',0,'SOLON','OH','44139','1281','CY','39035','1958-11-14','M','M',':RET:2106-3','N','021','DEN','2924440','99734OH005000401','2014-03-01','2014-01-19 19:33:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 11:00:26'),(22056,17606,'Y','18','024','14','A','','','TE','0000310424','0000310424','','IL','1','wilson','linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-22','F','',NULL,NULL,NULL,'','2440720','','2014-02-22','2014-02-07 22:44:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-08 19:00:07'),(20797,16617,'Y','18','024','14','A','','','TE','0000145768','0000145768','','IL','1','Rodriguez','Ida',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-10-25','F','',NULL,NULL,NULL,'','1746433','','2014-01-31','2014-01-31 11:29:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-31 21:00:19'),(18194,14525,'Y','18','021','EC','A','','','AC','0000305858','0000305858','OH00002489813','IL','1','Murphy','Matthew','','','','34','288908836','13528 KAUFMAN AVE NW',0,'HARTVILLE','OH','44632','9042','CY','39151','1984-05-26','M','M',':RET:2106-3','N','021','HLT','2223456','52664OH151001501','2014-02-01','2014-01-14 15:17:14','117.00',NULL,NULL,'598.58','481.58','R-OH015','OH0','299.29',NULL,0,'2014-01-15 02:08:05'),(17778,14203,'N','19','021','EC','A',NULL,NULL,'','0000406596','0001031693','','IL','1','CLAY','LAKEISHA','','','','34','628247664','8702 BROOKHOLLOW DR',0,'ROWLETT','TX','75089','8621','CY','48113','1991-01-24','F','',NULL,'N','021','DEN','1581611','33348TX002000101','2014-02-01','2014-01-13 16:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-14 01:33:41'),(16136,12924,'Y','18','021','EC','A','','','AC','0000176400','0000176400','OH00001943952','IL','1','COSTILOW','REBECCA','L','','','34','272648406','1015 WASHINGTON AVE',0,'CUYAHOGA FALLS','OH','44221','2063','CY','39153','1956-09-28','F','M',':RET:2106-3','N','021','HLT','2393206','52664OH152000901','2014-02-01','2014-01-03 10:05:17','352.00',NULL,NULL,'398.06','46.06','R-OH012','OH0','398.06',NULL,0,'2014-01-04 02:05:50'),(9398,7454,'Y','18','024','14','A','','','TE','0000140542','0000140542','','IL','1','Ramirez','Hector',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-05-31','M','',NULL,NULL,NULL,'','2125706','','2013-12-20','2013-12-20 23:54:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:30'),(13295,10612,'Y','18','021','EC','A','','','AC','0001227995','0001227995','TX00000833966','IL','1','Henrikson','John','','','','34','634146737','705 VILLAGE WAY',0,'NEW BRAUNFELS','TX','78130','2589','CY','48091','1987-02-18','M','U',':RET:2106-3','N','021','DEN','2505575','33348TX002000201','2014-01-01','2013-12-23 14:04:04','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:57:35'),(25447,20191,'Y','18','021','EC','A','','','AC','0000289446','0000289446','TX00002689298','IL','1','MALDONADO','VALENTE','','','','34','462089210','4938 OLD ESCOBARES HIGHWAY 83',0,'ROMA','TX','78584','5822','CY','48427','1956-08-01','M','M',NULL,'N','021','DEN','3359275','33348TX002000201','2014-04-01','2014-02-25 12:37:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:24'),(26590,21084,'Y','18','021','EC','A','','','AC','0000717875','0000717875','OH00002786799','IL','1','CAVILEER','BREANNE','','','','34','292784922','40 WALDORF DR',0,'AKRON','OH','44313','6226','CY','39153','1982-04-30','F','M',':RET:2106-3','N','021','HLT','3847575','52664OH152000901','2014-01-01','2014-02-28 12:21:32','389.00',NULL,NULL,'589.98','200.98','R-OH012','OH0','189.31',NULL,0,'2014-02-28 21:30:36'),(28585,22623,'Y','18','021','EC','A','','','AC','0001228127','0001228127','OH00003726171','IL','1','Jarrett','Stephanie','','','','34','290680590','1677 ABBY DR',0,'NEWARK','OH','43055','9416','CY','39089','1973-11-29','F','R',':RET:2106-3','N','021','DEN','3070144','99734OH005000401','2014-04-01','2014-03-07 18:00:24','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:29:59'),(1216,999,'Y','18','021','EC','A','','','AC','0000360983','0000360983','OH00000864258','IL','1','dover','marisa','','','','34','298705579','333 e. john st',0,'springfield','OH','45505',NULL,'CY','39023','1976-08-19','F','M',':RET:2054-5','N','021','HLT','42255','92036OH004000501','2014-01-01','2013-12-03 00:11:19','0.00',NULL,NULL,'236.62','236.62','R-OH003','OH0','236.62',NULL,0,'2013-12-25 18:20:15'),(22579,18033,'Y','18','021','EC','A','','','AC','0001181061','0001181061','OH00002690361','IL','1','Germani','Gerard','','','','34','380824943','2106 NORTHRIDGE DR',0,'TOLEDO','OH','43611','2959','CY','39095','1959-10-22','M','U',':RET:2106-3','N','021','HLT','3120955','92036OH002002601','2014-03-01','2014-02-10 11:54:52','79.00',NULL,NULL,'480.78','401.78','R-OH001','OH0','480.78',NULL,0,'2014-02-10 21:32:01'),(20188,16109,'Y','18','021','EC','A','','','AC','0000892601','0000892601','TX00002369718','IL','1','Goldberg','Dana','Robin','','','34','462838344','4704 W NORTHGATE DR',0,'IRVING','TX','75062','2563','CY','48113','1977-01-20','F','U',':RET:2106-3','N','021','DEN','3376235','33348TX002000101','2014-03-01','2014-01-27 11:17:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-27 21:01:24'),(19727,15721,'Y','18','021','EC','A','','','AC','0002100979','0002100979','LA00001439348','IL','1','Davis','Lee Joyce','Levon','','','34','433158866','139 BROOKWOOD DR',0,'MONROE','LA','71203','2217','CY','22073','1956-12-17','F','U',':RET:2054-5','N','021','DEN','1937218','18575LA002000201','2014-03-01','2014-01-23 13:40:00','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-23 21:01:03'),(2591,2106,'Y','18','021','EC','A','','','AC','0000474926','0000474926','OH00001286422','IL','1','Toth','Jeffrey','','','','34','269783194','1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1965-04-23','M','M',':RET:2106-3','N','021','DEN','223776','99734OH005000401','2014-01-01','2013-12-01 18:45:57','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:45:05'),(4410,3503,'N','01','021','EC','A',NULL,NULL,'','0000803710','0000385881','','IL','1','Devore','Abby','','','','34','269882832','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1987-06-19','F','',NULL,'N','021','DEN','252161','99734OH005000401','2014-01-01','2013-12-12 14:40:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:20'),(6063,4804,'Y','18','021','EC','A','','','AC','0000314668','0000314668','OH00000913910','IL','1','GARGANO','ALBERT','D','','','34','294505967','3460 WOODSIDE DR',0,'WARREN','OH','44483',NULL,'CY','39155','1950-11-04','M','U',':RET:2106-3','N','021','DEN','1256763','99734OH005000401','2014-01-01','2013-12-01 12:01:16','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:02:00'),(5408,4293,'N','01','021','EC','A',NULL,NULL,'','0000777672','0000751009','','IL','1','Moss','Janet','','','','34','269706038','54 MOUNT HOLLY LN',0,'AMELIA','OH','45102','9753','CY','39025','1960-11-15','F','',':RET:2106-3','N','021','HLT','2001164','92036OH003000601','2014-01-01','2013-12-19 12:37:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','457.33',NULL,0,'2013-12-25 23:09:06'),(13596,10845,'Y','18','021','EC','A','','','AC','0000649371','0000649371','OH00000943766','IL','1','Hodosko','William','','','','34','280462948','4000 Yellowood St.',0,'Lima','OH','45806',NULL,'CY','39003','1960-10-03','M','M',':RET:2106-3','N','021','HLT','2395344','92036OH003001505','2014-01-01','2013-12-22 20:41:48','950.00',NULL,NULL,'1091.74','141.74','R-OH002','OH0','468.87',NULL,0,'2013-12-26 13:05:20'),(19485,15531,'N','01','021','EC','A',NULL,NULL,'','0000161556','0001245482','','IL','1','Lillie','Nathan','','','','34','461995778','Po box 778',0,'Freer','TX','78357',NULL,'CY','48131','1978-02-11','M','',':RET:2106-3','N','021','DEN','3226625','33348TX002000201','2014-03-01','2014-01-22 12:50:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 03:02:04'),(19040,15163,'N','01','021','EC','A',NULL,NULL,'','0000440816','0000810066','','IL','1','agrawal','sadhana','','','','34','427457494','8 TWELVE OAKS PL',0,'MADISON','MS','39110','7537','CY','28089','1954-06-20','F','',':RET:2029-7','N','021','DEN','1535019','46300MS002000201','2014-03-01','2014-01-17 12:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-20 08:06:36'),(18059,14427,'N','01','021','EC','A',NULL,NULL,'','0000398639','0000776449','','IL','1','Schriner','Lola','M','','','34','277803811','2501 St Rt 138',0,'Sardinia','OH','45171',NULL,'CY','39071','1982-08-18','F','',':RET:2054-5^:RET:2106-3','N','021','HLT','1369814','92036OH003000606','2014-02-01','2014-01-13 19:45:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','259.83',NULL,0,'2014-01-15 02:07:20'),(23651,18832,'N','01','021','EC','A',NULL,NULL,'','0000828373','0000755534','','IL','1','Humeda','Inas','','','','34','868202351','8023 YORK BEACH PL',0,'ARLINGTON','TX','76002','3782','CY','48439','1981-12-16','F','',':RET:2054-5','N','021','DEN','3637514','33348TX002000201','2014-03-01','2014-02-13 23:23:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-14 21:30:14'),(25911,20546,'Y','18','021','EC','A','','','AC','0000192680','0000192680','TX00002816468','IL','1','HARMON','ERIC','','','','34','633240799','109 ASHWORTH RD',0,'HUNTSVILLE','TX','77320','2010','CY','48471','1988-01-18','M','U',':RET:2106-3','N','021','DEN','2677331','33348TX002000201','2014-03-01','2014-02-26 14:45:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:14'),(22634,18074,'N','01','021','EC','A',NULL,NULL,'','0001165553','0000758403','','IL','1','Cardenas','Maria','Del Carmen','','','34','642032597','3851 LAS CASITAS DR',0,'EL PASO','TX','79938','9454','CY','48141','1961-07-17','F','',NULL,'N','021','DEN','2874146','33348TX002000201','2014-03-01','2014-02-11 07:16:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:19'),(8064,6385,'Y','18','021','EC','A','','','AC','0000181000','0000181000','OH00000698937','IL','1','Holcombe','Melissa','','','','34','210543465','27484 OREGON RD',0,'PERRYSBURG','OH','43551','6514','CY','39173','1976-01-06','F','M',':RET:2106-3','N','021','HLT','2324182','92036OH003002605','2014-01-01','2013-12-20 15:07:16','54.00',NULL,NULL,'252.10','198.10','R-OH001','OH0','252.10',NULL,0,'2013-12-26 03:10:02'),(21722,17346,'Y','18','021','EC','A','','','AC','0000498569','0000498569','TX00002191347','IL','1','Zaitoun','Ahmed','','','','34','074966608','2410 14th Street',0,'Lubbock','TX','79401',NULL,'CY','48303','1985-08-13','M','U',':RET:2106-3','N','021','DEN','3700118','33348TX002000201','2014-03-01','2014-02-06 01:31:41','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-06 21:00:04'),(7031,5583,'N','01','021','EC','A',NULL,NULL,'','0000246917','0000861854','','IL','1','Spencer','Christa','Meyahl','','','34','442800334','2040 PINE KNOT DR',0,'HEARTLAND','TX','75126','8283','CY','48257','1981-01-14','F','',':RET:2054-5','N','021','DEN','2183527','33348TX002000201','2014-01-01','2013-12-24 23:21:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:49:07'),(4348,3451,'Y','18','021','EC','A','','','AC','0000397323','0000397323','OH00000248511','IL','1','MIHM','JAMES','ALLEN','','','34','300503884','15700 SAINT MARYS RIVER RD',0,'SAINT MARYS','OH','45885','9228','CY','39011','1950-03-28','M','U',':RET:2106-3','T','021','HLT','2520245','92036OH004001501','2014-01-01','2013-12-17 11:46:13','0.00',NULL,NULL,'600.76','600.76','R-OH002','OH0','600.76',NULL,0,'2013-12-25 21:53:23'),(19765,15755,'Y','18','021','EC','A','','','AC','0000400382','0000400382','MS00002058711','IL','1','BENTON','WILLIAM','','','','34','426219363','264 BARNES RD',0,'FLORENCE','MS','39073','8066','CY','28121','1959-10-19','M','U',NULL,'T','021','DEN','2346207','46300MS002000101','2014-03-01','2014-01-23 18:15:03','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-23 21:01:26'),(9675,7666,'Y','18','021','EC','A','','','AC','0000957908','0000957908','OH00000519386','IL','1','JULIUS','MICHAEL','','','','34','280525544','5713 TIBARON LN',0,'TOLEDO','OH','43615',NULL,'CY','39095','1952-09-09','M','M',':RET:2106-3','T','021','HLT','2118305','92036OH006002601','2014-01-01','2013-12-21 12:08:47','929.00',NULL,NULL,'1009.26','80.26','R-OH001','OH0','499.74',NULL,0,'2013-12-26 04:39:21'),(13529,10785,'Y','18','021','EC','A','','','AC','0001719000','0001719000','LA00000640683','IL','1','Gunther','Gregory','','','','34','218069809','1136 MERRILL ST',0,'NEW ORLEANS','LA','70114','1650','CY','22071','1971-09-26','M','U',':RET:2106-3','N','021','DEN','1761729','18575LA002000201','2014-01-01','2013-12-23 10:59:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:24'),(17500,13993,'Y','18','021','EC','A','','','AC','0001600421','0001600421','LA00001543106','IL','1','Coker','Patricia','','','','34','439906141','112 Eglin St',0,'Columbia','LA','71418',NULL,'CY','22021','1954-07-29','F','U',':RET:2106-3','N','021','DEN','1545447','18575LA002000201','2014-02-01','2014-01-12 17:43:11','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-13 03:01:24'),(15878,12714,'N','01','021','EC','A',NULL,NULL,'','0001755268','0001364916','','IL','1','West','David','C','','Jr','34','437159370','429 PARLANGE DR',0,'PEARL RIVER','LA','70452','3911','CY','22103','1957-09-12','M','',':RET:2054-5','N','021','DEN','2558391','18575LA002000101','2014-02-01','2014-01-02 12:15:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-03 02:05:19'),(24047,19125,'Y','18','024','14','A','','','TE','0000546512','0000546512','','IL','1','Soutendijk','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-01','F','',NULL,NULL,NULL,'','3623126','','2014-02-15','2014-02-15 11:01:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:01:02'),(25025,19844,'Y','18','021','EC','A','','','AC','0000290753','0000290753','TX00002797340','IL','1','Leach','Cori','','','','34','451239226','350 N Resler',0,'El Paso','TX','79912','3061','CY','48141','1958-02-09','F','U',':RET:2106-3','N','021','DEN','3776202','33348TX002000101','2014-04-01','2014-02-20 12:34:47','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-20 22:00:59'),(29014,22963,'Y','18','021','EC','A','','','AC','0000011215','0000011215','OH00003822619','31','1','Stephens','Thomas','','','','34','302860967','661 Seward Ave.',0,'Akron','OH','44320',NULL,'CY','39153','1977-10-06','M','M',':RET:2054-5','N','021','DEN','3725744','99734OH005000401','2014-04-01','2014-03-09 21:49:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:01:25'),(29181,23095,'N','01','021','EC','A',NULL,NULL,'','0000695706','0000487012','','IL','1','sabatino','jill','','','','34','273644807','56953 W 53RD ST',0,'SHADYSIDE','OH','43947','9719','CY','39013','1956-06-13','F','',':RET:2106-3','N','021','DEN','4211319','99734OH005000401','2014-04-01','2014-03-09 22:21:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-10 21:29:58'),(23399,18645,'N','19','021','EC','A',NULL,NULL,'','0000546511','0000730020','','S1','1','Johnson','Jenny','','','','34','272118186','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','2004-06-19','M','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:09'),(20636,16490,'Y','18','024','14','A','','','TE','0000978937','0000978937','','IL','1','Bonner','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-24','F','',NULL,NULL,NULL,'','3180604','','2014-01-30','2014-01-30 11:01:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-30 21:00:31'),(19241,15332,'Y','18','021','EC','A','','','AC','0000301912','0000301912','OH00002558001','IL','1','foit','robert','','','','34','272560671','2771 STATE ROUTE 14',0,'ROOTSTOWN','OH','44272','9801','CY','39133','1955-07-09','M','M',':RET:2106-3','N','021','HLT','1415868','52664OH151001501','2014-03-01','2014-01-19 21:47:36','738.00',NULL,NULL,'1277.95','539.95','R-OH012','OH0','681.50',NULL,0,'2014-01-21 08:46:37'),(7708,6103,'Y','18','021','EC','A','','','AC','0000625419','0000625419','OH00001249581','31','1','Nason','Aaron','','','','34','281501275','PO Box 296',0,'Anna','OH','45302',NULL,'CY','39149','1951-12-18','M','M',NULL,'N','021','DEN','1884183','99734OH005000401','2014-01-01','2013-12-20 09:54:02','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:01:27'),(7507,5939,'Y','18','021','EC','A','','','AC','0000708449','0000708449','LA00000298841','IL','1','jones','susannah','','','','34','439333376','8155 Jefferson Hwy',0,'Baton Rouge','LA','70809',NULL,'CY','22033','1971-05-20','F','U',NULL,'N','021','DEN','1139558','18575LA002000201','2014-01-01','2013-12-14 21:25:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:32:00'),(9688,7673,'Y','18','024','14','A','','','TE','0000429018','0000429018','','IL','1','Gingerich','Jacob',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-09-05','M','',NULL,NULL,NULL,'','239167','','2013-12-21','2013-12-21 12:37:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:38'),(13322,10637,'Y','18','021','EC','A','','','AC','0000022199','0000022199','TX00000801896','IL','1','PATEL','JAYESH','MANUBHAI','','','34','635866730','14405 RIO BONITO ROAD',0,'HOUSTON','TX','77083',NULL,'CY','48201','1960-11-24','M','M',':RET:2029-7','N','021','DEN','1655120','33348TX002000201','2014-01-01','2013-12-23 16:58:00','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:23'),(14414,11496,'Y','18','024','14','A','','','TE','0000298712','0000298712','','IL','1','Aguirre','Noemi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-28','F','',NULL,NULL,NULL,'','1550352','','2013-12-27','2013-12-27 06:47:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:31:32'),(14980,11971,'N','01','021','EC','A',NULL,NULL,'','0000718801','0000836379','','IL','1','CANTU','DAVID','','','','34','449476875','2390 SANTA MARIA LANE',0,'CORPUS CHRISTI','TX','78415',NULL,'CY','48355','1962-11-16','M','',NULL,'N','021','DEN','2471734','33348TX002000201','2014-02-01','2013-12-30 13:44:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-01 12:01:02'),(23868,18992,'Y','18','021','EC','A','','','AC','0001181061','0001181061','OH00002283372','IL','1','Germani','Gerard','','','','34','380824943','2106 NORTHRIDGE DR',0,'TOLEDO','OH','43611','2959','CY','39095','1959-10-22','M','U',':RET:2106-3','N','021','HLT','2740535','92036OH002002601','2014-03-01','2014-02-14 16:04:16','0.00',NULL,NULL,'480.78','480.78','R-OH001','OH0','480.78',NULL,0,'2014-02-14 21:32:08'),(27255,21581,'Y','18','021','EC','A','','','AC','0000733660','0000733660','OH00002768009','IL','1','Cooper','Betty','Fay','','','34','403804852','7251 BETHLEHEM RD',0,'WINCHESTER','OH','45697','9416','CY','39001','1952-12-14','F','U',':RET:2106-3','N','021','HLT','3555118','92036OH002000601','2014-04-01','2014-03-03 16:50:52','417.00',NULL,NULL,'696.64','279.64','R-OH005','OH0','696.64',NULL,0,'2014-03-03 21:31:55'),(27741,21937,'Y','18','021','EC','A','','','AC','0000337804','0000337804','TX00003085512','IL','1','rodriguez','velna','','','','34','461514811','608 W IRELAND ST',0,'BEEVILLE','TX','78102','3830','CY','48025','1967-07-07','F','U',NULL,'N','021','DEN','4015970','33348TX002000201','2014-04-01','2014-03-05 17:58:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:31:09'),(28439,22502,'Y','18','021','EC','A','','','AC','0000634871','0000634871','OH00002858102','IL','1','LOWE','RANDY','','','','34','292647415','209 Ash Ave',0,'Findlay','OH','45840',NULL,'CY','39063','1965-08-30','M','U',':RET:2106-3','N','021','HLT','4123464','92036OH003001501','2014-04-01','2014-03-07 11:13:22','0.00',NULL,NULL,'375.78','375.78','R-OH002','OH0','375.78',NULL,0,'2014-03-07 21:31:12'),(1072,878,'Y','18','021','EC','A','','','AC','0001174374','0001174374','OH00000807606','IL','1','LONGBOTTOM','BARBARA','','','','34','272524510','118 E WOODLAND AVE',0,'COLUMBIANA','OH','44408','1519','CY','39029','1953-01-31','F','M',':RET:2106-3','N','021','DEN','1099481','99734OH005000401','2014-01-01','2013-12-03 09:08:21','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:16:33'),(1141,939,'Y','18','021','EC','A','','','AC','0000517634','0000517634','LA00000093484','IL','1','paul','paula','','','','34','436436402','250 n 14th street apt 18',0,'port allen','LA','70767',NULL,'CY','22121','1981-04-19','F','U',NULL,'T','021','DEN','886319','18575LA002000201','2014-01-01','2013-12-03 10:18:17','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:20'),(2165,1782,'Y','18','021','EC','A','','','AC','0001198092','0001198092','OH00000884234','IL','1','kruger','edward','','','','34','290648864','1147 GLENVIEW DR',0,'MOGADORE','OH','44260','9546','CY','39133','1960-02-05','M','M',':RET:2106-3','N','021','HLT','46862','52664OH151001501','2014-01-01','2013-12-10 15:37:33','467.00',NULL,NULL,'1067.72','600.72','R-OH012','OH0','545.63',NULL,0,'2013-12-25 19:19:01'),(7480,5918,'N','01','021','EC','A',NULL,NULL,'','0000444893','0000168867','','IL','1','Orecchio','Masako','','','','34','606908660','346 SAND ST',0,'CROOKSVILLE','OH','43731','1229','CY','39127','1956-03-23','F','',':RET:2039-6','N','021','DEN','1043968','99734OH005000401','2014-01-01','2013-12-15 11:39:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:22'),(28717,22726,'N','01','021','EC','A',NULL,NULL,'','0000333930','0000781958','','IL','1','BROWNING','CONSTANCE','','','','34','546060631','4997 STATE ROUTE 350',0,'CLARKSVILLE','OH','45113','9420','CY','39027','1955-07-19','F','',':RET:2106-3','T','021','HLT','3481439','92036OH004000601','2014-04-01','2014-03-08 15:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','505.78',NULL,0,'2014-03-08 21:31:18'),(24121,19174,'Y','18','021','EC','A','','','AC','0000402934','0000402934','TX00001818292','IL','1','Salazar','Kenneth','','','','34','458969657','232 County Rd 4702',0,'Winnsboro','TX','75494',NULL,'CY','48499','1954-07-14','M','M',NULL,'N','021','DEN','3118511','33348TX002000201','2014-03-01','2014-02-15 15:46:28','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-15 22:01:42'),(23748,18906,'N','19','021','EC','A',NULL,NULL,'','0000137619','0001241912','','IL','1','MIDAMBA','LOIS','','','','34','286025848','3909 PINE CREST DRIVE',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1997-09-20','F','',':RET:2054-5','N','021','DEN','2972052','99734OH005000301','2014-03-01','2014-02-14 05:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:06'),(9059,7188,'Y','18','021','EC','A','','','AC','0000809298','0000809298','TX00000576060','IL','1','King','Barbara','','','','34','463926311','13326 BALDWIN RDG',0,'SAN ANTONIO','TX','78249','2319','CY','48029','1951-03-10','F','U',NULL,'N','021','DEN','2553822','33348TX002000101','2014-01-01','2013-12-18 11:28:50','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 04:06:17'),(2716,2197,'Y','18','021','EC','A','','','AC','0000803372','0000803372','LA00000107854','IL','1','Toups','Jessica','Amanda','','','34','433512457','2231 CONSTANCE ST',0,'NEW ORLEANS','LA','70130','5541','CY','22071','1979-07-28','F','M',':RET:2106-3','N','021','DEN','873329','18575LA002000201','2014-01-01','2013-12-01 18:55:29','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:04'),(8111,6416,'Y','18','021','EC','A','','','AC','0000910515','0000910515','OH00000362140','31','1','Cole','Alan','','','','34','281700404','PO Box 289',0,'Mt Orab','OH','45154',NULL,'CY','39015','1961-02-28','M','U',':RET:2106-3','N','021','HLT','1577252','92036OH002000601','2014-01-01','2013-12-20 17:45:32','271.00',NULL,NULL,'483.91','212.91','R-OH005','OH0','483.91',NULL,0,'2013-12-26 03:11:06'),(21896,17485,'Y','18','021','EC','A','','','AC','0000607190','0000607190','OH00001784794','IL','1','SHAHEEN','SHARON','E','','','34','289542618','205 STATE ROUTE 58',0,'SULLIVAN','OH','44880',NULL,'CY','39005','1953-01-15','F','M',':RET:2106-3','N','021','HLT','3200000','52664OH152000901','2014-03-01','2014-02-06 12:27:02','457.00',NULL,NULL,'458.99','1.99','R-OH012','OH0','458.99',NULL,0,'2014-02-06 21:01:43'),(2902,2340,'Y','18','021','EC','A','','','AC','0001010179','0001010179','OH00001342427','IL','1','Lyons','Robert','','','','34','298546591','1600 OAKWOOD DR',0,'CLEVELAND HTS','OH','44121','1710','CY','39035','1956-12-17','M','M',NULL,'N','021','DEN','857485','99734OH005000401','2014-01-01','2013-12-05 19:11:46','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:15:24'),(5612,4455,'Y','18','021','EC','A','','','AC','0000666729','0000666729','OH00000231259','IL','1','Yohe','Robin','','','','34','286740927','3436 ERHART RD',0,'LITCHFIELD','OH','44253','9731','CY','39103','1976-08-13','F','M',':RET:2106-3','N','021','DEN','834245','99734OH005000401','2014-01-01','2013-11-26 08:16:44','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:30:35'),(3487,2799,'Y','18','021','EC','A','','','AC','0000091136','0000091136','OH00000344699','IL','1','Carney','Patrick','','','','34','302841783','1101 Ripplecreek ct',0,'Centervile','OH','45458',NULL,'CY','39113','1975-08-27','M','U',':RET:2106-3','N','021','DEN','2174321','99734OH005000401','2014-01-01','2013-12-22 12:07:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:19'),(5147,4081,'Y','18','021','EC','A','','','AC','0000259214','0000259214','OH00000853398','IL','1','Murphey','James','','','','34','273521423','12633 St Highway 152',0,'Toronto','OH','43964',NULL,'CY','39081','1952-01-20','M','M',':RET:2106-3','N','021','DEN','1381700','99734OH005000401','2014-01-01','2013-12-19 09:09:13','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:02:42'),(13691,10924,'N','01','021','EC','A',NULL,NULL,'','0000762291','0000627868','','IL','1','Roberts','Rebekah',NULL,NULL,NULL,NULL,NULL,'793 LENOX NEW LYME RD',0,'JEFFERSON','OH','44047','9570','CY','39007','1987-05-26','F','',':RET:2106-3','N','021','HLT','1839254','52664OH151001304','2014-01-01','2013-12-23 10:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','257.56',NULL,0,'2013-12-26 13:08:28'),(21711,17337,'Y','18','021','EC','A','','','AC','0000453958','0000453958','OH00001836080','IL','1','NELSON','ANITA','','','','34','299448824','117 S MULBERRY ST',0,'WILMINGTON','OH','45177','2259','CY','39027','1958-05-06','F','U',':RET:2106-3','N','021','HLT','3669273','92036OH005000605','2014-03-01','2014-02-05 15:56:03','400.00',NULL,NULL,'478.72','78.72','R-OH005','OH0','478.72',NULL,0,'2014-02-05 21:31:15'),(20145,16075,'Y','18','021','EC','A','','','AC','0000911795','0000911795','OH00002037395','IL','1','Dickerson','Oscar','','','','34','275743814','4100 West Brook Drive',0,'Cleveland','OH','44144',NULL,'CY','39035','1946-08-25','M','U',':RET:2054-5','N','021','DEN','2705492','99734OH005000401','2014-03-01','2014-01-27 17:14:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:01:00'),(15558,12450,'Y','18','021','EC','A','','','AC','0000408491','0000408491','OH00000582807','IL','1','JONES','MERELYN','','','','34','296503045','7179 LEXINGTON CT',0,'NORTHFIELD','OH','44067',NULL,'CY','39153','1950-09-30','F','M',NULL,'N','021','HLT','1801088','52664OH151001305','2014-02-01','2013-12-30 19:56:37','1065.00',NULL,NULL,'1316.64','251.64','R-OH012','OH0','658.32',NULL,1,'2014-01-02 04:31:31'),(25552,20273,'Y','18','021','EC','A','','','AC','0002180132','0002180132','LA00002386619','IL','1','Dunomes','Lakendra','','','','34','433739014','108 MITCHELL DR',0,'HAMMOND','LA','70401','1408','CY','22105','1984-09-15','F','U',NULL,'N','021','DEN','3235841','18575LA002000201','2014-04-01','2014-02-23 17:30:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-26 08:00:19'),(22112,17649,'Y','18','021','EC','A','','','AC','0000332418','0000332418','OH00002567289','IL','1','Dugas','Elizabeth','','','','34','295720925','7461 Quail Hollow St NW',0,'Massillon','OH','44646',NULL,'CY','39151','1972-12-29','F','R',':RET:2106-3','N','021','HLT','3722465','52664OH151001501','2014-03-01','2014-02-07 18:58:09','0.00',NULL,NULL,'348.24','348.24','R-OH015','OH0','348.24',NULL,0,'2014-02-08 19:00:34'),(18619,14843,'Y','18','024','14','A','','','TE','0000979311','0000979311','','IL','1','Gorman','Sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-12','F','',NULL,NULL,NULL,'','2302149','','2014-01-15','2014-01-15 17:46:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:47:27'),(16209,12979,'Y','18','021','EC','A','','','AC','0000118148','0000118148','TX00001625385','IL','1','williams','kathleen','','','','34','456250866','2988 STATE HIGHWAY 154 E',0,'GILMER','TX','75645','6932','CY','48459','1961-07-25','F','U',':RET:2054-5','T','021','DEN','1514877','33348TX002000201','2014-02-01','2014-01-04 15:44:29','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-05 00:01:24'),(13026,10384,'Y','18','021','EC','A','','','AC','0000830627','0000830627','OH00000508681','IL','1','Hurst','Michael','','','','34','291526417','21395 COUNTY ROAD U',0,'NAPOLEON','OH','43545','9407','CY','39069','1952-08-18','M','M',':RET:2106-3','N','021','DEN','1744409','99734OH005000401','2014-01-01','2013-12-22 22:03:33','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-26 12:50:14'),(15900,12732,'Y','18','021','EC','A','','','AC','0001203230','0001203230','OH00001830566','IL','1','MAZUK','SANDRA','','','','34','293564539','7008 NOBLE CT',0,'CINCINNATI','OH','45239','4454','CY','39061','1954-01-11','F','U',NULL,'N','021','HLT','1725549','92036OH005001206','2014-02-01','2014-01-02 14:27:00','462.00',NULL,NULL,'582.60','120.60','R-OH004','OH0','582.60',NULL,0,'2014-01-03 02:06:03'),(14792,11814,'N','01','021','EC','A',NULL,NULL,'','0000984847','0000862434','','IL','1','Cummings','Lynda','J','','','34','284681991','3841 BAINBRIDGE RD',0,'CLEVELAND HEIGHTS','OH','44118','2245','CY','39035','1960-06-02','F','',':RET:2054-5','N','021','DEN','1903441','99734OH005000401','2014-01-01','2013-12-23 20:37:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:13:32'),(14946,11945,'Y','18','021','EC','A','','','AC','0001249240','0001249240','TX00000893120','IL','1','Abascal','Mario','','','','34','564692245','10002 PALE STAR DR',0,'HOUSTON','TX','77064','5486','CY','48201','1955-04-01','M','M',':RET:2106-3','N','021','DEN','1988795','33348TX002000201','2014-02-01','2013-12-29 18:40:38','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:00:03'),(15332,12263,'Y','18','021','EC','A','','','AC','0001022024','0001022024','TX00002017623','IL','1','Strackbein','Erin','','','','34','459930744','213 RANCH ROAD 1376',0,'FREDERICKSBURG','TX','78624','7895','CY','48171','1975-10-30','F','M',':RET:2106-3','N','021','DEN','1453220','33348TX002000201','2014-02-01','2014-01-01 17:39:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:23:56'),(26754,21203,'Y','18','024','14','A','','','TE','0000674883','0000674883','','IL','1','Fuller','Kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-06-06','M','',NULL,NULL,NULL,'','417184','','2014-03-31','2014-03-01 17:48:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-01 19:00:04'),(26793,21235,'Y','18','021','EC','A','','','AC','0000884279','0000884279','OH00003268856','IL','1','Light','Robert','','','','34','278602952','240 5TH ST',0,'MC CLURE','OH','43534','9541','CY','39069','1956-04-25','M','M',':RET:2106-3','N','021','HLT','2860359','92036OH003002605','2014-03-01','2014-02-28 18:38:58','354.00',NULL,NULL,'496.27','142.27','R-OH001','OH0','496.27',NULL,0,'2014-03-01 21:00:20'),(28468,22527,'Y','18','021','EC','A','','','AC','0000920882','0000920882','OH00003096623','IL','1','VARLAMOS','VALARIE','','','','34','298866740','1175 ROCKSIDE RD',0,'SEVEN HILLS','OH','44131','1772','CY','39035','1972-10-17','F','U',NULL,'N','021','DEN','3101177','99734OH005000301','2014-04-01','2014-03-06 22:53:29','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:31:30'),(28829,22816,'Y','18','021','EC','A','','','AC','0000179976','0000179976','OH00003129734','IL','1','WARNECKE','NATHAN','','','','34','301783088','19736 ROAD 22S',0,'FORT JENNINGS','OH','45844','9359','CY','39137','1976-06-16','M','M',NULL,'N','021','HLT','3227875','92036OH003001504','2014-04-01','2014-03-09 11:21:01','311.00',NULL,NULL,'578.26','267.26','R-OH002','OH0','284.53',NULL,0,'2014-03-09 21:01:06'),(22398,17884,'N','19','021','EC','A',NULL,NULL,'','0000035791','0000762274','','IL','1','Kaye','Mason','T',NULL,NULL,NULL,NULL,'938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1997-10-15','M','',':RET:2106-3','N','021','HLT','3254528','52664OH151001304','2014-03-01','2014-02-10 14:26:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-10 21:30:19'),(9516,7547,'Y','18','021','EC','A','','','AC','0000481069','0000481069','OH00000432135','IL','1','PAULIC','KRISTINA','','','','34','273908515','8595 PALOMINO TRL',0,'KIRTLAND','OH','44094','5146','CY','39085','1986-04-21','F','U',':RET:2106-3','N','021','DEN','2023272','99734OH005000401','2014-01-01','2013-12-21 18:02:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:35:32'),(9339,7403,'Y','18','021','EC','A','','','AC','0001553025','0001553025','LA00001127727','IL','1','ELLSWORTH','WHITNEY','','','','34','438983402','1644 SHADOW LAKE CT',0,'HARVEY','LA','70058','6606','CY','22051','1954-08-27','M','M',':RET:2054-5','N','021','DEN','1602660','18575LA002000201','2014-01-01','2013-12-20 20:17:26','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:30:57'),(1057,866,'Y','18','021','EC','A','','','AC','0001077814','0001077814','TX00001088484','IL','1','Griffin','Pamela','','','','34','456511879','111 DAVID DR',0,'HUTTO','TX','78634','5080','CY','48491','1967-12-01','F','U',':RET:2054-5','N','021','DEN','1239377','33348TX002000201','2014-01-01','2013-12-03 17:37:39','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:16:12'),(9235,7327,'Y','18','021','EC','A','','','AC','0001065962','0001065962','OH00001108646','IL','1','doughman','joshua','','','','34','276807533','4600 A storms creek rd',0,'urbana','OH','43078',NULL,'CY','39021','1983-01-06','M','U',':RET:2106-3','N','021','HLT','2010357','92036OH001000501','2014-01-01','2013-12-18 14:50:04','0.00',NULL,NULL,'325.44','325.44','R-OH003','OH0','325.44',NULL,0,'2013-12-26 04:10:33'),(19547,15580,'Y','18','021','EC','A','','','AC','0000205167','0000205167','MS00001791438','IL','1','Booker','Adrianne','','','','34','587492644','119 COUNTY ROAD 2011',0,'OXFORD','MS','38655','5884','CY','28071','1984-02-24','F','U',NULL,'N','021','DEN','2500258','46300MS002000101','2014-03-01','2014-01-22 12:17:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-23 03:02:27'),(5018,3977,'Y','18','021','EC','A','','','AC','0000611924','0000611924','OH00001257944','31','1','Bonnington','Thomas','Edward','','','34','535729368','PO Box 4701',0,'Toledo','OH','43610',NULL,'CY','39095','1964-01-23','M','R',':RET:2106-3','N','021','HLT','1251547','92036OH004002601','2014-01-01','2013-12-07 14:04:25','0.00',NULL,NULL,'267.49','267.49','R-OH001','OH0','267.49',NULL,0,'2013-12-25 22:47:28'),(16488,13194,'Y','18','021','EC','A','','','AC','0000622495','0000622495','OH00001404282','IL','1','Stiles','Mary','','','','34','293444572','6507 Field Ave',0,'Whitehouse','OH','43571',NULL,'CY','39095','1950-04-07','F','U',':RET:2106-3','N','021','HLT','2353287','92036OH004002601','2014-02-01','2014-01-06 14:28:15','260.00',NULL,NULL,'462.84','202.84','R-OH001','OH0','462.84',NULL,0,'2014-01-07 04:06:27'),(27492,21752,'N','01','021','EC','A',NULL,NULL,'','0000829339','0001156251','','IL','1','ZIMMERMAN','MARK','','','','34','299580858','105 PINELAND DR',0,'COPLEY','OH','44321','1319','CY','39153','1959-02-25','M','',':RET:2106-3','N','021','HLT','2817281','52664OH151001305','2014-05-01','2014-03-04 11:51:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-03-04 21:02:22'),(132,114,'N','01','021','EC','A',NULL,NULL,'','0000502954','0000998752','','IL','1','Lindenau','Darlene','','','','34','294665047','434 ROCKY HOLLOW DR',0,'MEDINA','OH','44256','7356','CY','39103','1959-04-01','F','',NULL,'N','021','HLT','56886','52664OH152000901','2014-01-01','2013-12-04 19:07:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.73',NULL,0,'2013-12-25 17:18:30'),(24394,19376,'Y','18','021','EC','A','','','AC','0000829327','0000829327','OH00001968368','IL','1','Civitarese','April','Dawn','','','34','268824546','210 MONROE ST',0,'LOUDONVILLE','OH','44842','1328','CY','39005','1982-05-30','F','M',':RET:2106-3','N','021','DEN','3848495','99734OH005000401','2014-04-01','2014-02-18 13:52:02','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:00:51'),(3570,2867,'Y','18','021','EC','A','','','AC','0000271399','0000271399','OH00000452776','IL','1','Wuest','Frances','','','','34','283563683','1606 CEDAR BROWN RD',0,'CURTICE','OH','43412','9703','CY','39095','1954-06-04','F','R',':RET:2106-3','N','021','HLT','1360999','92036OH005002601','2014-01-01','2013-12-22 11:32:27','0.00',NULL,NULL,'507.58','507.58','R-OH001','OH0','507.58',NULL,0,'2013-12-25 21:22:32'),(20808,16627,'Y','18','021','EC','A','','','AC','0000439532','0000439532','TX00001608745','IL','1','Casas','Maria','Luisa','','','34','459834468','9147 COUNTY ROAD 35',0,'TYLER','TX','75706','7259','CY','48423','1949-11-22','F','M',':RET:2106-3','N','021','DEN','2798592','33348TX002000201','2014-03-01','2014-01-31 16:33:23','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-31 21:00:26'),(16658,13329,'Y','18','021','EC','A','','','AC','0001408578','0001408578','LA00002205530','IL','1','thornton','alberta','','','','34','438154300','3002 LINDHOLM ST',0,'SHREVEPORT','LA','71108','2614','CY','22017','1958-02-23','F','U',':RET:2054-5','N','021','DEN','1514928','18575LA002000101','2014-02-01','2014-01-07 10:14:14','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-08 18:24:23'),(7774,6155,'Y','18','021','EC','A','','','AC','0000781445','0000781445','TX00000736086','IL','1','miranda miranda','janet','','','','34','832450003','8205 GREENHOLLOW LN',0,'DALLAS','TX','75240','3818','CY','48113','1986-10-18','F','U',NULL,'N','021','DEN','1397558','33348TX002000201','2014-01-01','2013-12-19 20:12:20','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 03:03:00'),(15791,12639,'Y','18','021','EC','A','','','AC','0002122518','0002122518','LA00001477667','IL','1','Hursey','Charles','','','','34','439114250','2565 Rittiner Dr.',0,'Baton Rouge','LA','70806',NULL,'CY','22033','1968-11-14','M','U',':RET:2106-3','T','021','DEN','1871964','18575LA002000201','2014-02-01','2014-01-02 14:38:28','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:29'),(13814,11026,'Y','18','021','EC','A','','','AC','0001005714','0001005714','OH00000649215','IL','1','Edwards','Steven','','','','34','296448351','5431 TALLAWANDA LN',0,'OXFORD','OH','45056','1442','CY','39017','1955-10-26','M','U',':RET:2106-3','N','021','HLT','2514063','92036OH005001201','2014-01-01','2013-12-23 12:08:00','244.00',NULL,NULL,'546.97','302.97','R-OH004','OH0','546.97',NULL,0,'2013-12-26 13:11:40'),(24520,19478,'Y','18','021','EC','A','','','AC','0000504756','0000504756','TX00002378959','IL','1','LARA','DIANA','','','','34','459694030','6349 MODESTA RD',0,'EL PASO','TX','79932','1138','CY','48141','1983-11-29','F','U',NULL,'N','021','DEN','3033167','33348TX002000201','2014-04-01','2014-02-19 14:18:27','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-20 03:56:51'),(27600,21829,'Y','18','021','EC','A','','','AC','0000246511','0000246511','OH00003103598','IL','1','Emch','Bryan','D','','','34','275825613','7699 N HONEYTOWN RD',0,'SMITHVILLE','OH','44677','9747','CY','39169','1976-05-18','M','M',':RET:2106-3','N','021','HLT','3737607','52664OH151001305','2014-04-01','2014-03-05 08:01:00','322.00',NULL,NULL,'499.09','177.09','R-OH014','OH0','276.08','CIC',0,'2014-03-05 21:00:22'),(28475,22531,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000752055','','IL','1','Shamy','Austin','','','','34','300115138','13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',NULL,'N','021','DEN','4102709','99734OH005000301','2014-04-01','2014-03-07 09:25:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:33'),(23886,19001,'N','01','021','EC','A',NULL,NULL,'','0000833460','0001006866','','IL','1','Orue','Anthony','','','','34','270865431','6720 GREENFIELD DR',0,'CINCINNATI','OH','45224','1643','CY','39061','1977-11-17','M','',':RET:2106-3','T','021','HLT','2952696','92036OH002001201','2014-03-01','2014-02-14 13:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','350.67',NULL,0,'2014-02-14 21:32:15'),(21124,16879,'Y','18','021','EC','A','','','AC','0001250620','0001250620','TX00001877922','IL','1','Lanham','Spencer','','','','34','449978924','101 PURPLE GRANITE W',0,'HORSESHOE BAY','TX','78657','6379','CY','48299','1980-07-26','M','M',':RET:2106-3','T','021','DEN','3423752','33348TX002000201','2014-03-01','2014-02-03 14:04:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:14'),(3783,3030,'N','01','021','EC','A',NULL,NULL,'','0001218525','0001259985','','IL','1','Socciarelli','Geri','','','','34','289647094','319 W MADISON ST',0,'GIBSONBURG','OH','43431','1321','CY','39143','1957-05-23','F','',':RET:2106-3','N','021','DEN','468172','99734OH005000301','2014-01-01','2013-12-13 00:00:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:02'),(6187,4903,'Y','18','021','EC','A','','','AC','0001115428','0001115428','TX00001000394','IL','1','Collander','Christopher','','','','34','458853551','4613 Circle C Drive',0,'Waco','TX','76705',NULL,NULL,NULL,'1987-01-07','M','U',':RET:2106-3','N','021','DEN','511796','33348TX002000101','2014-01-01','2013-10-22 22:39:46','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2013-12-26 00:30:14'),(4101,3277,'Y','18','024','14','A','','','TE','0000343683','0000343683','','IL','1','Wright','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-08-14','M','',NULL,NULL,NULL,'','1201414','','2013-12-16','2013-12-16 22:49:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:47:44'),(14099,11235,'Y','18','021','EC','A','','','AC','0001038615','0001038615','OH00001663945','IL','1','Potter','Daniel','Hank','','','34','272929624','7681 LOCHES RD',0,'SAINT LOUISVILLE','OH','43071','9677','CY','39089','1986-05-09','M','M',':RET:2106-3','N','021','DEN','1943462','99734OH005000401','2014-02-01','2013-12-26 11:55:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:31'),(1909,1561,'Y','18','021','EC','A','','','AC','0000499312','0000499312','OH00001208370','IL','1','hartmann','david','','','','34','277841435','217 north st',0,'batavia','OH','45103',NULL,'CY','39025','1970-02-25','M','M',':RET:2106-3','N','021','HLT','2498153','92036OH002000601','2014-01-01','2013-12-24 17:24:06','0.00',NULL,NULL,'336.41','336.41','R-OH005','OH0','336.41',NULL,0,'2013-12-25 18:59:22'),(3558,2856,'Y','18','021','EC','A','','','AC','0001010205','0001010205','OH00000169335','IL','1','Allred','Sarah','','','','34','275985946','3235 ROBINS TRCE',0,'AKRON','OH','44319','3885','CY','39153','1991-08-02','F','U',':RET:2106-3','N','021','HLT','2158970','52664OH151001305','2014-01-01','2013-12-22 12:39:56','0.00',NULL,NULL,'223.01','223.01','R-OH012','OH0','223.01',NULL,0,'2013-12-25 21:22:13'),(1945,1585,'Y','18','021','EC','A','','','AC','0000188817','0000188817','OH00000723194','IL','1','burnett','angela','','','','34','403296188','6265 DAWES LN',0,'CINCINNATI','OH','45230','2067','CY','39061','1970-10-03','F','U',':RET:2106-3','N','021','DEN','251806','99734OH005000401','2014-01-01','2013-11-20 10:43:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:00:48'),(21017,16794,'Y','18','021','EC','A','','','AC','0000384435','0000384435','OH00001841985','IL','1','Wolf','Jennifer',NULL,NULL,NULL,NULL,NULL,'6618 SLOEBIG RD',0,'MIDDLETOWN','OH','45042','9447','CY','39017','1979-04-07','F','R',':RET:2106-3','T','021','DEN','2699025','99734OH005000401','2014-03-01','2014-02-01 10:36:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-01 19:00:37'),(23137,18443,'Y','18','021','EC','A','','','AC','0001178217','0001178217','OH00001649922','IL','1','STOUGH','DANA','SUE','','','34','288549652','426 SPRUCE ST',0,'BARBERTON','OH','44203','4285','CY','39153','1953-12-31','F','U',':RET:2106-3','N','021','HLT','3837962','52664OH151001305','2014-03-01','2014-02-12 11:21:36','474.00',NULL,NULL,'605.24','131.24','R-OH012','OH0','605.24',NULL,0,'2014-02-12 21:31:34'),(1775,1463,'Y','18','024','14','A','','','TE','0001075301','0001075301','','IL','1','Danner','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-02','M','',NULL,NULL,NULL,'','2539568','','2013-12-24','2013-12-24 14:59:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:56:14'),(16450,13163,'Y','18','021','EC','A','','','AC','0000088682','0000088682','MS00001557087','IL','1','German','Brianna','','','','34','358883579','918 a south natchez',0,'koscisuko','MS','39090',NULL,'CY','28007','1993-08-25','F','U',':RET:2054-5','N','021','DEN','2167442','46300MS002000101','2014-02-01','2014-01-06 14:42:44','0.00',NULL,NULL,'47.10','47.10','R-MS006','MS0','47.10',NULL,0,'2014-01-07 04:05:22'),(4354,3456,'Y','18','021','EC','A','','','AC','0001198102','0001198102','OH00001132155','IL','1','Chandler','Gregory','','','','34','496586540','5995 WANDERLING LN',0,'CINCINNATI','OH','45237','2559','CY','39061','1954-10-20','M','R',':RET:2054-5','N','021','HLT','1995834','92036OH005001201','2014-01-01','2013-12-17 17:33:57','0.00',NULL,NULL,'558.80','558.80','R-OH004','OH0','558.80',NULL,0,'2013-12-25 21:53:33'),(9213,7308,'Y','18','021','EC','A','','','AC','0000614059','0000614059','MS00000258513','IL','1','Butler','Carolyn','','','','34','587325993','409 OLD WESSON RD NE',0,'BROOKHAVEN','MS','39601','2833','CY','28085','1950-12-23','F','M',':RET:2054-5','N','021','DEN','1953926','46300MS002000201','2014-01-01','2013-12-18 18:02:38','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 04:09:57'),(13607,10851,'N','19','021','EC','A',NULL,NULL,'','0000796957','0000708932','','IL','1','Behrmann','Jenna','','','','34','284021734','9499 HADDINGTON CT',0,'CINCINNATI','OH','45251','2362','CY','39061','1997-08-16','F','',':RET:2106-3','N','021','HLT','1676823','92036OH002001201','2014-01-01','2013-12-22 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 13:05:34'),(21690,17319,'Y','18','021','EC','A','','','AC','0001351099','0001351099','LA00002307545','IL','1','AUBERT','CHARLES','','','','34','436865103','601 LAURICELLA AVE',0,'JEFFERSON','LA','70121','1711','CY','22051','1953-04-30','M','U',NULL,'N','021','DEN','3462989','18575LA002000101','2014-03-01','2014-02-05 13:39:32','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-05 21:31:05'),(22696,18123,'Y','18','021','EC','A','','','AC','0000613948','0000613948','TX00001757860','IL','1','Adames','Ariel','','','','34','632402451','8718 THISTLEMOOR LN',0,'HOUSTON','TX','77044','6548','CY','48201','1992-08-25','F','U',NULL,'N','021','DEN','3670870','33348TX002000101','2014-03-01','2014-02-11 01:29:04','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-11 21:00:56'),(22721,18142,'N','01','021','EC','A',NULL,NULL,'','0001252238','0001725431','','IL','1','TABASSUM','RAFIA','','','','34','664073027','6209 BLANKE ST',0,'METAIRIE','LA','70003','2914','CY','22051','1964-08-05','F','',':RET:2028-9','T','021','DEN','3066905','18575LA002000201','2014-03-01','2014-02-11 12:33:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:10'),(22739,18154,'Y','18','021','EC','A','','','AC','0001540043','0001540043','LA00002713202','IL','1','smith','barbara','','','','34','437130533','109 BROWN ST',0,'RAYVILLE','LA','71269','2509','CY','22083','1959-02-25','F','U',NULL,'N','021','DEN','3629691','18575LA002000201','2014-03-01','2014-02-11 16:31:34','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-11 21:01:19'),(23023,18357,'N','19','021','EC','A',NULL,NULL,'','0000814510','0000430852','','IL','1','Martinez','Leslie','','','','34','643645611','6450 Midway',0,'Canutillo','TX','79835',NULL,'CY','48141','1999-02-04','F','',':RET:2106-3','N','021','DEN','3084385','33348TX002000201','2014-03-01','2014-02-11 22:05:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-12 21:30:31'),(24452,19424,'Y','18','021','EC','A','','','AC','0000411016','0000411016','MS00002207577','IL','1','SAUCIER','MICHAEL','A','','','34','587386764','200 LYNN CIRCLE',0,'PASS CHRISTIAN','MS','39571',NULL,'CY','28047','1950-08-24','M','M',':RET:2054-5','T','021','DEN','3256192','46300MS002000201','2014-04-01','2014-02-18 11:08:06','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-18 22:01:27'),(30,25,'Y','18','021','EC','A','','','AC','0000744404','0000744404','OH00000658940','IL','1','FADEL','PATRICIA','','','','34','130422001','7004 DODGE RD',0,'ROME','OH','44085','9561','CY','39007','1950-08-12','F','U',':RET:2106-3','N','021','DEN','703222','99734OH005000401','2014-01-01','2013-12-05 14:59:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:15:47'),(7995,6327,'Y','18','021','EC','A','','','AC','0000720248','0000720248','OH00000623672','IL','1','Litvin','Lorraine','','','','34','279786913','121 SHIAWASSEE AVE',0,'FAIRLAWN','OH','44333','3733','CY','39153','1965-11-30','F','U',':RET:2106-3','N','021','HLT','2246617','52664OH151001305','2014-01-01','2013-12-20 15:26:46','227.00',NULL,NULL,'364.62','137.62','R-OH012','OH0','364.62',NULL,0,'2013-12-26 03:08:14'),(17451,13956,'N','19','021','EC','A',NULL,NULL,'','0001005730','0001131463','','IL','1','Kennedy','Josiah',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','2007-11-21','M','',':RET:2106-3','N','021','HLT','1698891','92036OH002000601','2014-02-01','2014-01-10 14:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-13 03:00:38'),(16509,13207,'Y','18','024','14','A','','','TE','0000741727','0000741727','','IL','1','levert','billie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-26','F','',NULL,NULL,NULL,'','1656962','','2014-01-05','2014-01-05 12:40:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-07 10:21:19'),(15346,12275,'Y','18','021','EC','A','','','AC','0000694209','0000694209','OH00001657670','IL','1','cline','cheryl','','','','34','275705498','6171 lake rd',0,'medina','OH','44256',NULL,'CY','39103','1958-05-19','F','U',':RET:2106-3','T','021','HLT','2526166','52664OH152000901','2014-02-01','2014-01-01 12:40:06','378.00',NULL,NULL,'418.89','40.89','R-OH012','OH0','418.89',NULL,1,'2014-01-02 04:24:23'),(14955,11953,'Y','18','021','EC','A','','','AC','0000664311','0000664311','TX00001733536','IL','1','Martin','LaTau','','','','34','254470819','3312 Bright Star Way',0,'Plano','TX','75074',NULL,'CY','48085','1983-04-01','F','U',NULL,'N','021','DEN','2466370','33348TX002000201','2014-02-01','2013-12-30 03:34:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:20'),(2469,2009,'Y','18','021','EC','A','','','AC','0000558008','0000558008','LA00001125770','IL','1','Ellis','John','Charles','','Jr','34','451841538','3836 GREENWAY PL',0,'SHREVEPORT','LA','71105','2016','CY','22017','1958-02-12','M','U',NULL,'N','021','DEN','579971','18575LA002000101','2014-01-01','2013-12-09 17:05:40','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 19:35:09'),(6971,5532,'Y','18','024','14','A','','','TE','0000388621','0000388621','','IL','1','Kennedy','Melisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-06-24','F','',NULL,NULL,NULL,'','28646','','2013-12-24','2013-12-24 23:18:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:47:27'),(20572,16442,'Y','18','021','EC','A','','','AC','0000521982','0000521982','OH00002158526','31','1','PITLER','AMY','','','','34','385882441','P. O. BOX 43194',0,'TOLEDO','OH','43613',NULL,'CY','39095','1966-07-01','F','M',NULL,'N','021','HLT','2730295','92036OH002002601','2014-03-01','2014-01-29 17:35:51','54.00',NULL,NULL,'351.97','297.97','R-OH001','OH0','351.97',NULL,0,'2014-01-29 21:01:53'),(21405,17107,'Y','18','021','EC','A','','','AC','0000298268','0000298268','OH00002017219','IL','1','Weaver','Michelle','','','','34','279821884','1330 Hanover Rd.',0,'Delaware','OH','43015',NULL,'CY','39041','1984-04-12','F','U',NULL,'N','021','DEN','3459241','99734OH005000401','2014-03-01','2014-02-04 13:56:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:01:04'),(21888,17477,'Y','18','021','EC','A','','','AC','0001136683','0001136683','OH00002534092','IL','1','Allen','Joseph','','','','34','296865761','4721 ZENOBIA RD',0,'WAKEMAN','OH','44889','9368','CY','39077','1983-11-02','M','U',':RET:2106-3','T','021','HLT','2767065','92036OH006002701','2014-03-01','2014-02-06 15:26:18','0.00',NULL,NULL,'201.85','201.85','R-OH006','OH0','201.85',NULL,0,'2014-02-06 21:01:36'),(24978,19810,'N','01','021','EC','A',NULL,NULL,'','0001067962','0000617744','','IL','1','Ali','Sarah','Ann','','','34','639068470','23003 WALDERFORD DR',0,'KATY','TX','77450','1487','CY','48201','1963-05-24','F','',':RET:2106-3','N','021','DEN','3664330','33348TX002000201','2014-04-01','2014-02-20 10:26:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-20 22:00:32'),(25429,20177,'Y','18','021','EC','A','','','AC','0001021203','0001021203','TX00003107054','IL','1','Garcia','Ronald','','','','34','150860446','5211 DONEGAL BAY CT',0,'KILLEEN','TX','76549','4964','CY','48027','1989-01-19','M','U',NULL,'N','021','DEN','3426867','33348TX002000201','2014-04-01','2014-02-24 18:36:21','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-25 21:31:14'),(26430,20963,'Y','18','024','14','A','','','TE','0001078905','0001078905','','IL','1','Bender','Randy','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-03','M','',NULL,NULL,NULL,'','2547671','','2014-03-31','2014-02-27 07:41:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:15'),(27424,21703,'Y','18','021','EC','A','','','AC','0001250763','0001250763','LA00003587476','IL','1','BRUGIER','CHRISTINA','','','','34','608321101','119 CAROLINE AVE',0,'NEW ORLEANS','LA','70123',NULL,'CY','22051','1983-10-13','F','U',NULL,'N','021','DEN','3587568','18575LA002000201','2014-04-01','2014-03-03 23:53:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:41'),(28615,22647,'Y','18','021','EC','A','','','AC','0000616477','0000616477','TX00003254052','IL','1','Soliman','Mohammed','','','','34','634235292','6704 shadow glen dr',0,'frisco','TX','75035',NULL,'CY','48085','1946-07-20','M','M',':RET:2029-7','N','021','DEN','3122842','33348TX002000201','2014-04-01','2014-03-07 21:46:00','0.00',NULL,NULL,'33.45','33.45','R-TX008','TX0','17.60',NULL,0,'2014-03-08 21:30:18'),(9452,7499,'Y','18','021','EC','A','','','AC','0001042287','0001042287','OH00000628527','IL','1','Bruns','Billy','','','','34','277861687','4673 ANTHONY WAYNE AVE',0,'FAIRFIELD','OH','45014','1701','CY','39017','1983-04-16','M','M',':RET:2106-3','N','021','DEN','1809235','99734OH005000401','2014-01-01','2013-12-20 21:49:01','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:00'),(14336,11436,'Y','18','021','EC','A','','','AC','0000911771','0000911771','OH00001493162','IL','1','CARDENAS','LINDA','','','','34','281541024','416 LESTER AVE',0,'FINDLAY','OH','45840','3846','CY','39063','1951-02-16','F','M',':RET:2106-3','N','021','HLT','2457299','92036OH005001504','2014-02-01','2013-12-26 14:13:22','448.00',NULL,NULL,'632.30','184.30','R-OH002','OH0','632.30',NULL,0,'2013-12-27 02:07:44'),(15494,12398,'Y','18','021','EC','A','','','AC','0000772654','0000772654','OH00001471292','S3','1','REES','THOMAS','','','','34','274492383','3577 AUDUBON RD',0,'COLUMBUS','OH','43224','2749','CY','39049','2012-09-02','F','U',':RET:2106-3','N','021','DEN','2568353','99734OH005000401','2014-02-01','2013-12-31 12:14:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,1,'2014-01-02 04:29:37'),(19748,15740,'Y','18','021','EC','A','','','AC','0000020945','0000020945','TX00001632971','IL','1','Anderson','Brigitte','','','','34','267636759','811 W Slaughter Lane',0,'Austin','TX','78748',NULL,'CY','48453','1973-05-22','F','R',':RET:2054-5','N','021','DEN','3332732','33348TX002000101','2014-03-01','2014-01-23 09:48:21','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-23 21:01:16'),(20507,16385,'Y','18','021','EC','A','','','AC','0001594352','0001594352','LA00001360314','IL','1','TRAN','LIEN','','','','34','543023895','1685 NOTTINGHAM DR',0,'MARRERO','LA','70072','4380','CY','22051','1974-08-20','F','M',NULL,'N','021','DEN','3144070','18575LA002000201','2014-03-01','2014-01-29 16:49:15','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:17'),(21614,17258,'Y','18','024','14','A','','','TE','0001029276','0001029276','','IL','1','sanchez','eva',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-12-30','F','',NULL,NULL,NULL,'','3268947','','2014-02-04','2014-02-04 19:42:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-05 21:30:35'),(24981,19813,'Y','18','021','EC','A','','','AC','0000917645','0000917645','TX00002568614','IL','1','GUERRA','MARIA','','','','34','464844828','715 E KIMBALL AVE',0,'RAYMONDVILLE','TX','78580','2638','CY','48489','1950-05-28','F','U',NULL,'N','021','DEN','2850301','33348TX002000201','2014-04-01','2014-02-20 11:47:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 22:00:33'),(26205,20783,'Y','18','021','EC','A','','','AC','0000072939','0000072939','OH00003092508','IL','1','allgyer','derek','e','','','34','275924352','450 MADISON ST',0,'RAVENNA','OH','44266','2663','CY','39133','1987-06-16','M','U',NULL,'N','021','HLT','3048573','52664OH151001305','2014-04-01','2014-02-27 11:16:35','138.00',NULL,NULL,'228.36','90.36','R-OH012','OH0','228.36',NULL,0,'2014-02-28 06:30:50'),(26673,21147,'Y','18','021','EC','A','','','AC','0002282464','0002282464','LA00002683344','IL','1','JONES','SARRELL','','','','34','530705360','2034 SHERWOOD MEADOW DR',0,'BATON ROUGE','LA','70816','8549','CY','22033','1973-03-19','F','M',':RET:2054-5','T','021','DEN','3102214','18575LA002000201','2014-04-01','2014-02-28 11:55:06','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:19'),(26816,21251,'Y','18','021','EC','A','','','AC','0001067042','0001067042','OH00003333023','IL','1','Luna','Bryan','','','','34','625608048','7431 GLENN FARMS DR',0,'WEST CHESTER','OH','45069','4980','CY','39017','1992-05-10','M','U',':RET:2106-3','N','021','DEN','3696125','99734OH005000401','2014-03-01','2014-02-28 22:01:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:31'),(27121,21468,'Y','18','024','14','A','','','TE','0000992729','0000992729','','IL','1','Stone','david',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-13','M','',NULL,NULL,NULL,'','2912027','','2014-03-03','2014-03-03 13:11:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:34'),(28276,22376,'N','01','021','EC','A',NULL,NULL,'','0000404857','0000268949','','IL','1','KNAPP','SUSAN','','','','34','295726940','35 WASHINGTON AVE',0,'NILES','OH','44446','2433','CY','39155','1962-05-25','F','',':RET:2106-3','N','021','HLT','3785669','92036OH003003201','2014-04-01','2014-03-07 09:27:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','471.44','CIC',0,'2014-03-07 21:00:23'),(29211,23118,'Y','18','021','EC','A','','','AC','0000525592','0000525592','TX00003687364','IL','1','Thomas','Alica','','','','34','452954900','1350 YORKSHIRE ST',0,'FORT WORTH','TX','76134','5522','CY','48439','1981-08-05','F','U',':RET:2054-5','N','021','DEN','3733998','33348TX002000201','2014-04-01','2014-03-10 16:28:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-03-10 21:30:16'),(1866,1523,'N','01','021','EC','A',NULL,NULL,'','0001186317','0000207128','','IL','1','Moses','Mark','','','','34','269806773','43 TALLMADGE RD',0,'KENT','OH','44240','7207','CY','39133','1963-07-17','M','',':RET:2106-3','T','021','HLT','1884497','52664OH152000901','2014-01-01','2013-12-24 11:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','335.49',NULL,0,'2013-12-25 18:58:11'),(2677,2169,'Y','18','021','EC','A','','','AC','0001167969','0001167969','OH00000143146','IL','1','Kadlub','Leonard',NULL,NULL,NULL,NULL,NULL,'10300 SPRINGBROOK CT',0,'PAINESVILLE','OH','44077','9349','CY','39085','1951-08-25','M','M',NULL,'N','021','DEN','755740','99734OH005000301','2014-01-01','2013-12-02 10:36:08','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:47:08'),(16917,13538,'Y','18','021','EC','A','','','AC','0000243752','0000243752','OH00002005834','IL','1','Bell','Sharon','Lynn','','','34','277581532','1977 ASHBURN DR',0,'DELAWARE','OH','43015','9128','CY','39041','1950-06-20','F','M',':RET:2106-3','N','021','DEN','1899239','99734OH005000401','2014-02-01','2014-01-09 15:43:55','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:19:41'),(7340,5814,'Y','18','021','EC','A','','','AC','0001200874','0001200874','OH00000766311','IL','1','Bunton','William','','','','34','509643458','1135 STONER ST',0,'AKRON','OH','44320','3507','CY','39153','1957-12-16','M','M',':RET:2054-5','N','021','HLT','1213088','52664OH152000901','2014-01-01','2013-12-14 16:12:54','592.00',NULL,NULL,'797.26','205.26','R-OH012','OH0','381.07',NULL,0,'2013-12-26 02:04:00'),(7046,5596,'Y','18','021','EC','A','','','AC','0000253287','0000253287','TX00001363236','IL','1','Thorbahn','Jared','','','','34','292823662','1202 HILL ST',0,'HENDERSON','TX','75654','4017','CY','48401','1985-02-03','M','U',':RET:2106-3','N','021','DEN','1662128','33348TX002000201','2014-02-01','2013-12-25 13:30:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 01:49:33'),(6685,5301,'N','01','021','EC','A',NULL,NULL,'','0000955497','0000432712','','IL','1','Fluharty','Melinda','','','','34','273585624','14022 LEROY AVE',0,'CLEVELAND','OH','44135','1444','CY','39035','1957-07-17','F','',':RET:2106-3','N','021','DEN','19544','99734OH005000401','2014-01-01','2013-11-05 05:21:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:29'),(19651,15659,'N','17','021','EC','A',NULL,NULL,'','0000741751','0000510675','','IL','1','Bowman','Jaryd','M',NULL,NULL,NULL,NULL,'517 S Marion St',0,'Cardington','OH','43315',NULL,'CY','39117','2000-08-04','M','',':RET:2106-3','N','021','DEN','3267520','99734OH005000401','2014-03-01','2014-01-23 12:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:19'),(26841,21273,'N','01','021','EC','A',NULL,NULL,'','0002193502','0001999972','','IL','1','Calcagno','Kathleen','Vicknair','','','34','438279586','153 MIANO ST',0,'GARYVILLE','LA','70051','3218','CY','22095','1962-05-02','F','',':RET:2106-3','T','021','DEN','3707131','18575LA002000201','2014-03-01','2014-02-28 23:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-01 21:00:45'),(27330,21640,'Y','18','024','14','A','','','TE','0000568032','0000568032','','IL','1','Andrews','Clark','Daniel',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-05-22','M','',NULL,NULL,NULL,'','1760634','','2014-03-18','2014-03-03 18:04:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-04 21:00:51'),(29021,22970,'Y','18','021','EC','A','','','AC','0001191400','0001191400','OH00003679349','IL','1','kennedy','felecia','dawn','','','34','448989592','2305 Raider dr',0,'fairborn','OH','45324',NULL,'CY','39057','1990-12-26','F','U',':RET:2106-3','N','021','DEN','3492814','99734OH005000401','2014-04-01','2014-03-10 10:24:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:01:30'),(292,241,'Y','18','021','EC','A','','','AC','0000409703','0000409703','OH00000279715','IL','1','Sargent','Vernon','L','','Jr','34','227869843','1770 Evergreen ave.',0,'Akron','OH','44301',NULL,'CY','39153','1961-01-28','M','U',':RET:2054-5','T','021','DEN','980543','99734OH005000401','2014-01-01','2013-11-12 20:10:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:30:35'),(5497,4364,'Y','18','021','EC','A','','','AC','0000725051','0000725051','OH00000418322','IL','1','Albrecht','Denise','','','','34','296563144','11562 LAKEWAY DR',0,'CURTICE','OH','43412','9411','CY','39095','1953-05-09','F','U',':RET:2106-3','N','021','HLT','1391175','92036OH002002601','2014-01-01','2013-12-19 16:02:19','282.00',NULL,NULL,'611.15','329.15','R-OH001','OH0','611.15',NULL,0,'2013-12-25 23:11:13'),(14694,11732,'Y','18','021','EC','A','','','AC','0000250258','0000250258','OH00000945274','IL','1','Zhang','Francis','','','','34','471069563','375 ALLYN ST',0,'AKRON','OH','44304','1701','CY','39153','1955-02-01','M','U',':RET:2034-7','N','021','DEN','1541422','99734OH005000401','2014-02-01','2013-12-27 21:30:43','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,1,'2013-12-29 11:08:53'),(16362,13094,'Y','18','021','EC','A','','','AC','0000889320','0000889320','MS00001698698','IL','1','Hill','Lakeisha','Monque','','','34','426433032','610 ARCO LN',0,'LAUREL','MS','39440','3506','CY','28067','1979-08-07','F','U',':RET:2054-5','N','021','DEN','2470424','46300MS002000201','2014-02-01','2014-01-06 12:30:59','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-07 04:02:47'),(19416,15479,'Y','18','021','EC','A','','','AC','0000494913','0000494913','MS00001764017','IL','1','foxworth','sedgie','','','','34','428022174','11 FOXWORTH CIR',0,'FOXWORTH','MS','39483','4907','CY','28091','1960-07-15','M','U',':RET:2054-5','N','021','DEN','2481563','46300MS002000201','2014-03-01','2014-01-21 12:08:19','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,1,'2014-01-22 03:23:00'),(21478,17161,'N','19','021','EC','A',NULL,NULL,'','0001106814','0001237745','','IL','1','CRESSIE','SEAN','','','','34','478191345','2211 SANDSTON RD',0,'COLUMBUS','OH','43220','5406','CY','39049','1990-06-12','M','',':RET:2039-6','T','021','DEN','3517600','99734OH005000301','2014-03-01','2014-02-04 12:09:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:01:41'),(23165,18468,'Y','18','021','EC','A','','','AC','0000449558','0000449558','TX00002181372','IL','1','benford','danica','','','','34','568194355','1615 Ridgebriar Drive',0,'Houston','TX','77014',NULL,'CY','48201','1977-05-02','F','U',':RET:2054-5','N','021','DEN','2698249','33348TX002000101','2014-03-01','2014-02-12 10:00:01','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-12 21:31:49'),(28100,22241,'Y','18','021','EC','A','','','AC','0000597367','0000597367','OH00003785817','IL','1','Sheets','Theresa','','','','34','270646210','12610 W WAGNER ST',0,'FOSTORIA','OH','44830','2567','CY','39147','1959-07-17','F','M',NULL,'N','021','HLT','3154549','92036OH004002701','2014-04-01','2014-03-05 19:45:11','332.00',NULL,NULL,'334.75','2.75','R-OH006','OH0','334.75',NULL,0,'2014-03-06 21:02:09'),(1555,1298,'Y','18','021','EC','A','','','AC','0000639454','0000639454','MS00001532199','IL','1','LEE','ELIZABETH','','','','34','438733610','1828 TOWNSHIP RD',0,'LAUREL','MS','39443',NULL,'CY','28067','1987-04-24','F','M',':RET:2106-3','N','021','DEN','2554267','46300MS002000201','2014-01-01','2013-12-24 14:06:33','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:50:43'),(2039,1669,'Y','18','021','EC','A','','','AC','0000449280','0000449280','TX00001158602','31','1','Jernigan','Janice','','','','34','435430034','null null',0,'PANOLA','TX','75685','0282','CY','48365','1965-01-04','F','U',':RET:2106-3','N','021','DEN','177264','33348TX002000201','2014-01-01','2013-12-09 22:42:27','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:15:31'),(9557,7575,'Y','18','021','EC','A','','','AC','0000021385','0000021385','OH00001258502','IL','1','Charlier','Gloria','','','','34','296505648','8679 Schoolhouse Place',0,'Maineville','OH','45039',NULL,'CY','39165','1951-09-26','F','U',':RET:2106-3','N','021','DEN','1777449','99734OH005000301','2014-01-01','2013-12-21 14:52:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:26'),(14986,11977,'Y','18','021','EC','A','','','AC','0001082107','0001082107','TX00001964694','IL','1','kinard','james','','','','34','465945218','12898 hwy 82 w',0,'brookston','TX','75421',NULL,'CY','48277','1953-09-22','M','U',':RET:2106-3','N','021','DEN','2357550','33348TX002000201','2014-02-01','2013-12-30 15:15:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:16'),(15283,12219,'Y','18','021','EC','A','','','AC','0000259157','0000259157','MS00000604283','IL','1','Smith','Phelisa','Renae','','','34','426375084','5951 Baxter Dr.',0,'Jackson','MS','39211',NULL,'CY','28049','1969-12-10','F','M',':RET:2054-5','N','021','DEN','2159397','46300MS002000101','2014-02-01','2013-12-31 18:49:00','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:22:12'),(18483,14743,'Y','18','021','EC','A','','','AC','0001049403','0001049403','OH00001483010','IL','1','Won','Edward','SehChang','','','34','270787401','49 FORESTWOOD DR',0,'NORTHFIELD','OH','44067','1918','CY','39153','1953-12-12','M','M',':RET:2040-4','N','021','HLT','2707566','52664OH151001301','2014-02-01','2014-01-14 22:37:08','745.00',NULL,NULL,'1185.73','440.73','R-OH012','OH0','605.24',NULL,0,'2014-01-16 08:46:22'),(23858,18983,'Y','18','024','14','A','','','TE','0001775734','0001775734','','IL','1','Egan','Emily',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-08-07','F','',NULL,NULL,NULL,'','2652001','','2014-02-14','2014-02-14 10:35:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-14 21:32:03'),(28216,22326,'N','19','021','EC','A',NULL,NULL,'','0000477434','0001227097','','IL','1','Smith','Kayla','J','','','34','275066520','2484 LITTLE DRY RUN RD',0,'CINCINNATI','OH','45244','3247','CY','39061','2001-01-24','F','',':RET:2054-5','N','021','HLT','4039106','92036OH005001201','2014-04-01','2014-03-06 13:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32','CIC',0,'2014-03-06 21:30:16'),(29143,23070,'Y','18','021','EC','A','','','AC','0000268967','0000268967','OH00002867466','IL','1','Davis','Julian','','','','34','272760744','6610 TRIESTA CT',0,'CINCINNATI','OH','45230','1434','CY','39061','1979-12-25','M','M',':RET:2106-3','N','021','HLT','4255288','92036OH005001205','2014-04-01','2014-03-10 11:25:59','200.00',NULL,NULL,'493.96','293.96','R-OH004','OH0','260.61',NULL,0,'2014-03-10 21:02:44'),(358,295,'Y','18','024','14','A','','','TE','0000110495','0000110495','','IL','1','hopwood','william',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-06-05','M','',NULL,NULL,NULL,'','170752','','2013-12-03','2013-12-03 18:15:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:45:04'),(7261,5757,'Y','18','024','14','A','','','TE','0000930079','0000930079','','IL','1','Escamilla','Violet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-02-13','F','',NULL,NULL,NULL,'','1053498','','2013-12-13','2013-12-13 20:48:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 02:02:09'),(7108,5638,'Y','18','021','EC','A','','','AC','0001735367','0001735367','LA00001569847','IL','1','Daquanno','Randall','','','','34','437799290','2750 Millerville Rd',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1988-03-23','M','U',NULL,'N','021','DEN','2072575','18575LA002000101','2014-01-01','2013-12-24 19:46:55','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 01:50:57'),(5910,4681,'Y','18','021','EC','A','','','AC','0000651144','0000651144','TX00000816035','IL','1','Walker','Rebecca','','','','34','451351455','3131 SIMPSON STUART RD',0,'DALLAS','TX','75241','5065','CY','48113','1975-07-12','F','U',':RET:2054-5','N','021','DEN','1876474','33348TX002000101','2014-01-01','2013-12-23 21:19:22','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:00'),(4868,3859,'Y','18','021','EC','A','','','AC','0000224679','0000224679','OH00000279662','IL','1','ROBINSON','JOSEPH','','','','34','269783691','4923 MARION AVE',0,'CINCINNATI','OH','45212',NULL,'CY','39061','1972-09-03','M','U',NULL,'N','021','DEN','539513','99734OH005000401','2014-01-01','2013-10-10 16:59:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:30:55'),(4045,3229,'Y','18','021','EC','A','','','AC','0000155758','0000155758','OH00000707132','IL','1','White','Luther','','','','34','280660376','1060 LOVELAND MADEIRA RD',0,'LOVELAND','OH','45140','8987','CY','39061','1960-08-12','M','U',':RET:2106-3','T','021','DEN','2311462','99734OH005000401','2014-01-01','2013-12-17 12:27:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:13'),(4689,3717,'N','01','021','EC','A',NULL,NULL,'','0001043382','0001237683','','IL','1','WALLACE','TERRY','R','','','34','292629981','4771 DELHI ARNHEIM RD',0,'GEORGETOWN','OH','45121','8228','CY','39015','1957-04-22','M','',':RET:2106-3','N','021','HLT','1058461','92036OH005000605','2014-01-01','2013-12-12 15:29:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','500.82',NULL,0,'2013-12-25 22:08:07'),(20108,16043,'Y','18','021','EC','A','','','AC','0001255719','0001255719','LA00001935309','IL','1','Woodard','James','','','','34','439886863','4422 BACCICH ST',0,'NEW ORLEANS','LA','70122','6114','CY','22071','1953-05-31','M','U',NULL,'N','021','DEN','3463807','18575LA002000201','2014-03-01','2014-01-27 16:30:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-27 21:00:39'),(25986,20608,'N','19','021','EC','A',NULL,NULL,'','0000279609','0000085223','','IL','1','McKnight','William','','','','34','279027555','2570 COVENTRY RD',0,'SHAKER HEIGHTS','OH','44120','1304','CY','39035','1996-12-21','M','',':RET:2106-3','N','021','DEN','3840866','99734OH005000401','2014-03-01','2014-02-26 17:21:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:54'),(26958,21359,'N','01','021','EC','A',NULL,NULL,'','0000245041','0000647122','','IL','1','Hamric','Craig','Allen','','','34','276841750','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1969-10-10','M','',':RET:2106-3','N','021','HLT','3266135','52664OH151001305','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-03-03 01:00:29'),(27427,21706,'Y','18','021','EC','A','','','AC','0001977801','0001977801','LA00003254957','IL','1','BROWN','DONNA','','','','34','435968731','1534 COURT ST TRLR 28',0,'PORT ALLEN','LA','70767',NULL,'CY','22121','1955-11-29','F','U',':RET:2106-3','N','021','DEN','2902713','18575LA002000201','2014-04-01','2014-03-04 11:14:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-04 21:01:43'),(1071,877,'Y','18','021','EC','A','','','AC','0000608414','0000608414','OH00001319537','IL','1','Gedra','David','','','','34','272449802','3032 Windsor place SW',0,'Canton','OH','44710',NULL,'CY','39151','1949-09-15','M','U',':RET:2106-3','N','021','DEN','406750','99734OH005000401','2014-01-01','2013-12-03 07:49:37','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 18:16:31'),(16734,13390,'N','01','021','EC','A',NULL,NULL,'','0000142840','0000437989','','IL','1','Marty','Michael','','','','34','280885600','2156 Steiner rd',0,'Creston','OH','44217',NULL,'CY','39169','1974-03-06','M','',':RET:2106-3','N','021','HLT','2533888','52664OH151001301','2014-02-01','2014-01-07 16:56:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.44',NULL,0,'2014-01-08 18:24:50'),(15393,12313,'N','01','021','EC','A',NULL,NULL,'','0000825921','0000796972','','IL','1','Carmichael','Melinda','','','','34','276641680','1001 BIRCHAVEN ST',0,'ALLIANCE','OH','44601','5242','CY','39151','1961-01-19','F','',':RET:2106-3','N','021','HLT','1786104','52664OH151001501','2014-02-01','2014-01-01 15:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','545.63',NULL,1,'2014-01-02 04:25:48'),(6270,4972,'Y','18','021','EC','A','','','AC','0000054445','0000054445','OH00000536458','IL','1','Wheeler','Eric','','','','34','269929295','2567 Shiloh Park',0,'Westlake','OH','44145',NULL,'CY','39035','1978-01-14','M','M',':RET:2106-3','N','021','DEN','623390','99734OH005000401','2014-01-01','2013-12-10 18:29:33','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:05'),(5793,4601,'Y','18','024','14','A','','','TE','0000209634','0000209634','','IL','1','Lange','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-02','F','',NULL,NULL,NULL,'','2170479','','2013-12-24','2013-12-24 01:19:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:47:19'),(20810,16629,'Y','18','021','EC','A','','','AC','0001233194','0001233194','TX00002189889','IL','1','Seal','Christine','','','','34','449137107','6418 Depriest St.',0,'Houston','TX','77091',NULL,'CY','48201','1956-01-21','F','M',':RET:2054-5','T','021','DEN','3417543','33348TX002000201','2014-03-01','2014-01-31 16:58:42','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-31 21:00:27'),(22131,17663,'Y','18','021','EC','A','','','AC','0000139049','0000139049','OH00001843205','IL','1','Fishwick','Roberta','','','','34','289685824','1024 CHEROKEE TRL',0,'WILLOUGHBY','OH','44094','7211','CY','39085','1964-12-05','F','U',NULL,'N','021','DEN','3447978','99734OH005000401','2014-03-01','2014-02-08 11:35:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-08 19:00:44'),(24385,19369,'Y','18','024','14','A','','','TE','0000612960','0000612960','','IL','1','Holloway','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-14','M','',NULL,NULL,NULL,'','223737','','2014-03-05','2014-02-18 11:34:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-18 22:00:46'),(25170,19965,'Y','18','021','EC','A','','','AC','0001236637','0001236637','OH00002661897','IL','1','MCAFEE','CLARA','','','','34','274844227','832 RED OAK TRL',0,'MANSFIELD','OH','44904','1850','CY','39139','1969-10-09','F','U',NULL,'N','021','DEN','3460645','99734OH005000401','2014-04-01','2014-02-21 10:16:12','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-02-21 22:00:27'),(25792,20455,'N','19','021','EC','A',NULL,NULL,'','0000394984','0000679581','','IL','1','Roth','Jacob','','','','34','296022544','1155 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1998-04-08','M','',':RET:2106-3','N','021','DEN','3284779','99734OH005000301','2014-03-01','2014-02-26 10:00:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:12'),(26829,21264,'Y','18','024','14','A','','','TE','0000829327','0000829327','','IL','1','Civitarese','April','Dawn',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-05-30','F','',NULL,NULL,NULL,'','3848495','','2014-03-01','2014-03-01 14:37:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-01 21:00:39'),(28318,22405,'Y','18','021','EC','A','','','AC','0000033573','0000033573','TX00003600435','31','1','Long','Katie','','','','34','640540595','1920 Grassmere Ln',0,'Mckinney','TX','75071',NULL,'CY','48027','1987-07-09','F','R',':RET:2106-3','N','021','DEN','3857480','33348TX002000201','2014-04-01','2014-03-06 18:13:44','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-07 21:30:03'),(86,75,'Y','18','021','EC','A','','','AC','0000891779','0000891779','OH00000554924','IL','1','Allen','Deborah','','','','34','289443361','2346 16th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1950-11-30','F','U',':RET:2106-3','T','021','DEN','597689','99734OH005000301','2014-01-01','2013-12-05 15:14:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:17:17'),(1953,1592,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000011887','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','156338','33348TX002000101','2014-01-01','2013-11-19 22:57:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:01'),(14791,11814,'Y','18','021','EC','A','','','AC','0000984847','0000984847','OH00000459061','IL','1','Cummings','Timothy','M','','','34','281685383','3841 BAINBRIDGE RD',0,'CLEVELAND HEIGHTS','OH','44118','2245','CY','39035','1960-10-31','M','M',':RET:2054-5','N','021','DEN','1903441','99734OH005000401','2014-01-01','2013-12-23 20:37:30','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:30'),(2423,1974,'N','01','021','EC','A',NULL,NULL,'','0000133293','0000236243','','IL','1','Yablonsky','Kenneth','','','','34','281627610','5763 RUTLEDGE TRL',0,'LIBERTY TWP','OH','45011','1245','CY','39017','1972-10-26','M','',':RET:2106-3','N','021','DEN','1039687','99734OH005000401','2014-01-01','2013-12-09 16:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:58'),(4075,3256,'Y','18','021','EC','A','','','AC','0000167749','0000167749','OH00001309871','IL','1','aylward','timothy','','','','34','275664997','715 W. Market St',0,'Akron','OH','44303',NULL,'CY','39153','1957-10-02','M','U',':RET:2106-3','N','021','HLT','2291639','52664OH152000901','2014-01-01','2013-12-16 18:41:34','326.00',NULL,NULL,'381.07','55.07','R-OH012','OH0','381.07',NULL,0,'2013-12-25 21:47:01'),(7155,5676,'N','19','021','EC','A',NULL,NULL,'','0000102823','0000102822','','IL','1','PUGH-NESBY','SHYANNE','','','','34','270065024','1115 E ARCHWOOD AVE',0,'AKRON','OH','44306','2857','CY','39153','2000-09-12','F','',':RET:2054-5','N','021','HLT','1564965','52664OH151001501','2014-01-01','2013-12-24 22:00:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 01:52:18'),(2595,2107,'Y','18','021','EC','A','','','AC','0000499281','0000499281','OH00000699526','IL','1','Render','Annette','','','','34','283867504','5257 ROCKPORT AVE',0,'DAYTON','OH','45417','8336','CY','39113','1971-04-22','F','M',':RET:2054-5','N','021','DEN','86830','99734OH005000401','2014-01-01','2013-12-01 19:37:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:45:09'),(19573,15602,'N','19','021','EC','A',NULL,NULL,'','0001647541','0002051534','','S1','1','Caston','CaSandra','Tillman','','','34','436933329','6316 Timberman Place',0,'Shreveport','LA','71119',NULL,'CY','22017','1996-05-14','F','',':RET:2054-5','N','021','DEN','1758740','18575LA002000201','2014-03-01','2014-01-22 14:23:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-01-23 03:02:37'),(21546,17211,'Y','18','021','EC','A','','','AC','0000690775','0000690775','OH00002061169','IL','1','Mathias','Donna','','','','34','270767021','8516 PRIESTLEY DR',0,'REYNOLDSBURG','OH','43068','4776','CY','39089','1965-05-31','F','M',':RET:2106-3','N','021','DEN','3124567','99734OH005000401','2014-03-01','2014-02-05 11:23:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:11'),(23010,18345,'Y','18','021','EC','A','','','AC','0001795889','0001795889','LA00002477405','IL','1','Baudoin','Susan','','','','34','439043594','485 CREDEUR RD',0,'CANKTON','LA','70584','6003','CY','22097','1958-09-01','F','U',':RET:2106-3','N','021','DEN','2698245','18575LA002000101','2014-03-01','2014-02-11 22:23:46','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-12 21:30:23'),(29145,23071,'Y','18','021','EC','A','','','AC','0001071848','0001071848','OH00002631155','IL','1','Burns','Jamour','','','','34','490763969','5411 Edger Dr.',0,'Cincinnati','OH','45239',NULL,'CY','39061','1974-01-28','M','U',':RET:2054-5','N','021','HLT','3931954','92036OH005001205','2014-04-01','2014-03-10 11:42:29','168.00',NULL,NULL,'274.35','106.35','R-OH004','OH0','274.35',NULL,0,'2014-03-10 21:02:45'),(7123,5652,'Y','18','024','14','A','','','TE','0000891955','0000891955','','IL','1','Kincaid','Erich',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-09','M','',NULL,NULL,NULL,'','1897772','','2013-12-24','2013-12-24 20:11:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 01:51:23'),(16288,13039,'Y','18','021','EC','A','','','AC','0001075317','0001075317','OH00001747061','IL','1','Geslak','Janet','','','','34','302645945','635 west main street',0,'malvern','OH','44644',NULL,'CY','39019','1959-09-14','F','M',':RET:2106-3','N','021','DEN','1641519','99734OH005000401','2014-02-01','2014-01-06 14:49:30','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-07 04:00:46'),(1512,1261,'Y','18','021','EC','A','','','AC','0000741717','0000741717','OH00000499059','IL','1','Perkins','Natasha','','','','34','281844455','1349 LOUIS DR',0,'COLUMBUS','OH','43207','1544','CY','39049','1985-12-30','F','U',':RET:2054-5','N','021','DEN','1694825','99734OH005000401','2014-01-01','2013-12-24 13:22:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:33'),(13498,10758,'Y','18','021','EC','A','','','AC','0000701698','0000701698','OH00001208254','IL','1','Bufford','Lashawnda','','','','34','401113043','1010 Holderness lane',0,'cincinnati','OH','45240',NULL,'CY','39061','1978-02-19','F','U',':RET:2054-5','N','021','DEN','2214579','99734OH005000301','2014-01-01','2013-12-23 19:05:53','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:02:31'),(13256,10579,'N','01','021','EC','A',NULL,NULL,'','0000539715','0001094049','','IL','1','Mack','Carol','','','','34','454087965','207 Grayson',0,'Teague','TX','75860',NULL,'CY','48161','1955-04-01','F','',':RET:2054-5','N','021','DEN','2393930','33348TX002000201','2014-01-01','2013-12-23 11:30:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:56:32'),(2379,1941,'Y','18','021','EC','A','','','AC','0000546449','0000546449','OH00000644833','IL','1','HARUTHUNIAN','ZARDIK','','','','34','564717768','5380 AKINS RD',0,'NORTH ROYALTON','OH','44133','5247','CY','39035','1959-06-03','F','M',':RET:2106-3','N','021','DEN','1033244','99734OH005000401','2014-01-01','2013-12-09 10:25:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:32:58'),(18430,14704,'Y','18','021','EC','A','','','AC','0002037780','0002037780','LA00002153862','IL','1','Price','Emily','Ann','','','34','436796538','8 Patricia Ct',0,'Luling','LA','70070',NULL,'CY','22089','1990-08-01','F','U',NULL,'N','021','DEN','2465409','18575LA002000201','2014-02-01','2014-01-15 14:45:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:57'),(19084,15204,'N','01','021','EC','A',NULL,NULL,'','0000701723','0000661378','','IL','1','Patel','Dinesh','','','','34','332765374','2416 SPRINGMILL RD',0,'FINDLAY','OH','45840','2864','CY','39063','1958-08-13','M','',':RET:2029-7','N','021','DEN','2793247','99734OH005000401','2014-03-01','2014-01-18 15:03:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:44:28'),(23566,18774,'Y','18','021','EC','A','','','AC','0000910562','0000910562','OH00001735793','IL','1','Wietecha','JoAnn','','','','34','272607370','5166 CHERRINGTON RD',0,'TOLEDO','OH','43623','2711','CY','39095','1956-08-14','F','M',':RET:2106-3','N','021','HLT','2722144','92036OH004002601','2014-03-01','2014-02-12 18:35:21','249.00',NULL,NULL,'382.11','133.11','R-OH001','OH0','382.11',NULL,0,'2014-02-13 22:02:47'),(23928,19027,'N','01','021','EC','A',NULL,NULL,'','0000949487','0000881598','','IL','1','Overfield','Carrie','','','','34','281662400','1436 RUTH AVE',0,'CUYAHOGA FALLS','OH','44221','2938','CY','39153','1967-07-15','F','',':RET:2106-3','T','021','HLT','2733265','52664OH151001501','2014-03-01','2014-02-14 17:08:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','461.38','CIC',0,'2014-02-14 22:00:09'),(25262,20041,'Y','18','024','14','A','','','TE','0001107788','0001107788','','IL','1','moreno','katanna','lee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1993-01-31','F','',NULL,NULL,NULL,'','2788423','','2014-03-31','2014-02-22 15:29:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-22 19:00:13'),(26109,20708,'Y','18','021','EC','A','','','AC','0000950727','0000950727','OH00002454448','IL','1','Vo','Van','','','','34','288968376','4540 HIDDEN RIDGE CT',0,'COLUMBUS','OH','43230','4124','CY','39049','1973-01-01','F','M',':RET:2047-9','N','021','DEN','3623342','99734OH005000401','2014-04-01','2014-02-26 19:03:59','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:15'),(42,37,'Y','18','021','EC','A','','','AC','0000785757','0000785757','OH00001124257','IL','1','Gardner','Russell',NULL,NULL,NULL,NULL,NULL,'6781 VINEYARD HAVEN LOOP',0,'DUBLIN','OH','43016','7371','CY','39159','1949-12-18','M','R',':RET:2106-3','T','021','DEN','1002595','99734OH005000401','2014-01-01','2013-12-05 15:51:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:16:06'),(15326,12258,'Y','18','021','EC','A','','','AC','0000386596','0000386596','TX00001527297','IL','1','loya','dora','','','','34','461578227','1407 W 18TH ST',0,'ODESSA','TX','79763','2731','CY','48135','1979-11-04','F','U',NULL,'N','021','DEN','1879513','33348TX002000201','2014-02-01','2014-01-01 11:56:50','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,1,'2014-01-02 04:23:45'),(13669,10907,'Y','18','021','EC','A','','','AC','0001751407','0001751407','LA00000502784','IL','1','TAYLOR','ANGELIA','','','','34','410965110','1819 MCKINNEY RD',0,'SLIDELL','LA','70458','8011','CY','22103','1961-12-20','F','M',':RET:2054-5','N','021','DEN','1764541','18575LA002000101','2014-01-01','2013-12-23 16:51:12','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:52'),(13554,10809,'Y','18','021','EC','A','','','AC','0002400257','0002400257','LA00000343425','IL','1','Vazquez','Albert','Luis','','','34','583921602','116 SARATOGA ST',0,'BELLE CHASSE','LA','70037','1058','CY','22075','1959-05-03','M','U',NULL,'N','021','DEN','2267427','18575LA002000201','2014-01-01','2013-12-23 15:16:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:10'),(963,791,'Y','18','021','EC','A','','','AC','0000323969','0000323969','TX00001183888','IL','1','Xiong','Ge','','','','34','586144252','2107 Rohne Drive',0,'Cedar Hill','TX','75104',NULL,'CY','48139','1953-05-08','M','M',':RET:2028-9','N','021','DEN','153957','33348TX002000201','2014-01-01','2013-10-29 11:14:51','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:09:50'),(6454,5116,'Y','18','021','EC','A','','','AC','0000731172','0000731172','OH00000092421','IL','1','Bucklan','Matthew','','','','34','275848558','14998 SURREY DOWNS',0,'NOVELTY','OH','44072','9639','CY','39055','1984-12-08','M','U',NULL,'N','021','HLT','605721','52664OH151001501','2014-01-01','2013-12-10 23:27:53','173.00',NULL,NULL,'337.56','164.56','R-OH011','OH0','337.56',NULL,0,'2013-12-26 00:49:46'),(1136,934,'N','01','021','EC','A',NULL,NULL,'','0000648469','0000370052','','IL','1','Harper','Terri','','','','34','519965928','38308 LEVI CRAWFORD LN',0,'PEARL RIVER','LA','70452','4632','CY','22103','1965-02-24','F','',':RET:2106-3','N','021','DEN','1103562','18575LA002000201','2014-01-01','2013-12-02 21:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:18:12'),(1143,941,'Y','18','021','EC','A','','','AC','0001048122','0001048122','LA00000607253','IL','1','reeves','laurie','','','','34','220869031','363 WHIPPOORWILL RD',0,'DERIDDER','LA','70634','7123','CY','22011','1965-03-20','F','M',':RET:2106-3','N','021','DEN','230709','18575LA002000201','2014-01-01','2013-12-03 13:36:30','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 18:18:24'),(1612,1347,'Y','18','021','EC','A','','','AC','0000085112','0000085112','TX00001136563','IL','1','Munoz','Oralia','','','','34','465416785','2300 Passage Pl',0,'El Paso','TX','79936',NULL,'CY','48141','1969-10-11','F','U',':RET:2106-3','N','021','DEN','2008103','33348TX002000201','2014-01-01','2013-12-24 13:08:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:52:20'),(18822,14991,'N','01','021','EC','A',NULL,NULL,'','0000264237','0000693388','','IL','1','DAMPEER','LYTONIA','M','','','34','425419237','2741 SHIVERS RD',0,'MENDENHALL','MS','39114','4943','CY','28127','1974-10-22','F','',':RET:2054-5','N','021','DEN','2733678','46300MS002000201','2014-02-01','2014-01-15 18:47:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-17 03:36:06'),(19527,15562,'Y','18','021','EC','A','','','AC','0000881655','0000881655','OH00001752396','IL','1','Flores','Ximena','','','','34','292906602','4271 LEONARD AVE',0,'CINCINNATI','OH','45217','1532','CY','39061','1962-11-12','F','U',NULL,'N','021','DEN','2620903','99734OH005000401','2014-03-01','2014-01-22 11:39:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:02:19'),(21324,17040,'Y','18','021','EC','A','','','AC','0002133329','0002133329','LA00002025446','IL','1','JARAMILLO','EDITH','NANCY','','','34','437619809','901 VOURAY DR',0,'KENNER','LA','70065',NULL,'CY','22051','1954-10-27','F','M',NULL,'N','021','DEN','3617954','18575LA002000201','2014-03-01','2014-02-04 17:46:42','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:24'),(23495,18716,'Y','18','021','EC','A','','','AC','0001127305','0001127305','TX00002131694','IL','1','Balogh','Kristina','','','','34','542025966','9550 Dyer Street',0,'El Paso','TX','79924',NULL,'CY','48141','1981-05-21','F','U',':RET:2106-3','N','021','DEN','2659887','33348TX002000101','2014-03-01','2014-02-12 22:08:05','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-13 22:02:05'),(25434,20181,'Y','18','021','EC','A','','','AC','0000723115','0000723115','TX00002615162','IL','1','LIN','YU PAO','','','','34','621380310','2715 ARROWHEAD DR',0,'SUGAR LAND','TX','77479','1515','CY','48157','1958-01-09','F','M',':RET:2034-7','N','021','DEN','3125017','33348TX002000201','2014-04-01','2014-02-25 00:43:08','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:16'),(25602,20313,'Y','18','021','EC','A','','','AC','0000627491','0000627491','TX00002275724','IL','1','DURAN','ENEDILIA','','','','34','460456939','1731 N EMERSON AVE',0,'TYLER','TX','75702','3402','CY','48423','1962-01-15','F','M',NULL,'N','021','DEN','2989315','33348TX002000201','2014-04-01','2014-02-21 18:05:18','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-26 08:30:03'),(26046,20656,'Y','18','021','EC','A','','','AC','0000228386','0000228386','OH00002555611','IL','1','Miller','Gayle','','','','34','271544523','3279 Bailey Road',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1953-07-03','F','U',':RET:2106-3','T','021','HLT','3030727','52664OH151001306','2014-03-01','2014-02-26 15:43:21','529.00',NULL,NULL,'696.03','167.03','R-OH012','OH0','696.03',NULL,0,'2014-02-26 21:02:30'),(4180,3325,'N','01','021','EC','A',NULL,NULL,'','0000021373','0000225993','','IL','1','Cipro','Romualdo','','','Jr','34','298760256','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1970-06-25','M','',':RET:2106-3','N','021','HLT','2222362','52664OH151001304','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2013-12-25 21:49:23'),(8057,6380,'Y','18','024','14','A','','','TE','0000964721','0000964721','','IL','1','WARSAW','STACY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-01-25','F','',NULL,NULL,NULL,'','2231794','','2013-12-20','2013-12-20 13:24:34',NULL,NULL,NULL,NULL,NULL,NULL,'MI0',NULL,'CANCEL',0,'2013-12-26 03:09:53'),(17409,13933,'Y','18','021','EC','A','','','AC','0001001607','0001001607','TX00002360588','IL','1','Yee','Michael','','','','34','639206794','20543 Atascocita Shores',0,'Humble','TX','77346',NULL,'CY','48201','1985-09-08','M','U',':RET:2040-4','N','021','DEN','1955870','33348TX002000101','2014-02-01','2014-01-10 14:34:56','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-13 03:00:21'),(16156,12938,'Y','18','021','EC','A','','','AC','0001261194','0001261194','OH00001237971','IL','1','Gatiss','John','Howard','','IV','34','385989418','293 CROSS WIND LOOP',0,'WESTERVILLE','OH','43081','3554','CY','39049','1979-02-12','M','U',':RET:2106-3','N','021','DEN','1537916','99734OH005000301','2014-01-01','2013-12-17 03:03:15','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-04 06:00:04'),(13947,11121,'Y','18','021','EC','A','','','AC','0001250837','0001250837','OH00000973952','IL','1','Arnett','Connie','','','','34','275524002','1307 Betty Ln',0,'Milford','OH','45150',NULL,'CY','39025','1950-02-08','F','U',NULL,'T','021','HLT','1480074','92036OH004000601','2014-01-01','2013-12-23 08:26:14','398.00',NULL,NULL,'585.97','187.97','R-OH005','OH0','585.97',NULL,0,'2013-12-26 13:14:50'),(15715,12571,'Y','18','021','EC','A','','','AC','0000022802','0000022802','OH00001713619','IL','1','KELLER','DOUGLAS','','','','34','313841580','544 N DALE DR',0,'LIMA','OH','45805','2224','CY','39003','1965-06-09','M','U',NULL,'N','021','HLT','2087508','92036OH001001501','2014-02-01','2013-12-31 17:47:25','241.00',NULL,NULL,'434.05','193.05','R-OH002','OH0','434.05',NULL,1,'2014-01-02 04:36:11'),(15316,12248,'N','19','021','EC','A',NULL,NULL,'','0000740046','0000759751','','IL','1','Rios','Desiree',NULL,NULL,NULL,NULL,NULL,'507 E FAIRMEADOWS DR',0,'DUNCANVILLE','TX','75116','2718','CY','48113','1990-10-30','F','',':RET:2106-3','N','021','DEN','2302125','33348TX002000101','2014-02-01','2014-01-01 14:09:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,1,'2014-01-02 04:23:22'),(23293,18570,'Y','18','021','EC','A','','','AC','0000407418','0000407418','OH00001532034','IL','1','Moore','David','','','','34','077461424','1779 Rockland Avenue',0,'Rocky River','OH','44116',NULL,'CY','39035','1965-07-23','M','U',':RET:2106-3','N','021','DEN','3414101','99734OH005000301','2014-03-01','2014-02-12 23:23:53','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:09'),(28270,22371,'Y','18','024','14','A','','','TE','0001009017','0001009017','','IL','1','NEWSOME','TOSHIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-04-08','F','',NULL,NULL,NULL,'','1417548','','2014-03-31','2014-03-07 12:01:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-07 21:00:21'),(28939,22901,'N','19','021','EC','A',NULL,NULL,'','0000827226','0000809747','','IL','1','Nisch Quan','Kamlin','','','','34','277066509','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','2001-03-06','F','',':RET:2029-7^:RET:2034-7^:RET:2106-3','N','021','DEN','4285886','99734OH005000301','2014-04-01','2014-03-10 17:13:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:41'),(9739,7711,'Y','18','021','EC','A','','','AC','0001249077','0001249077','TX00001040031','IL','1','Childers','kenneth','','','','34','549022704','353 NW LORNA ST',0,'BURLESON','TX','76028','3401','CY','48439','1956-09-27','M','U',':RET:2106-3','T','021','DEN','125181','33348TX002000201','2014-01-01','2013-11-14 22:52:25','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:45:52'),(180,149,'Y','18','024','14','A','','','TE','0000170129','0000170129','','IL','1','KEARNEY','SILVIA','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-02-21','F','',NULL,NULL,NULL,'','522223','','2013-12-05','2013-12-05 10:42:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:19:40'),(363,300,'Y','18','021','EC','A','','','AC','0000714613','0000714613','TX00001040166','IL','1','Jones','Mark','','','','34','425454666','5421 FLO DR',0,'WICHITA FALLS','TX','76302','5136','CY','48485','1979-06-16','M','M',':RET:2054-5','N','021','DEN','1102207','33348TX002000201','2014-01-01','2013-12-03 20:45:47','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 17:45:14'),(6996,5552,'Y','18','021','EC','A','','','AC','0000766801','0000766801','TX00000697893','IL','1','DeCamp','Reba','','','','34','466295414','145 FOREST RIDGE LN',0,'ZAVALLA','TX','75980','3815','CY','48005','1952-11-04','F','M',NULL,'T','021','DEN','2347009','33348TX002000201','2014-01-01','2013-12-24 18:35:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:08'),(959,788,'Y','18','021','EC','A','','','AC','0000561727','0000561727','TX00000561245','IL','1','duong','Cindy','','','','34','438352486','1120 KIRKWOOD LN',0,'PROSPER','TX','75078','7941','CY','48085','1977-10-10','F','M',':RET:2047-9','T','021','DEN','363906','33348TX002000201','2014-01-01','2013-10-28 21:16:29','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:09:44'),(14252,11366,'Y','18','021','EC','A','','','AC','0000811975','0000811975','TX00001774946','IL','1','Ibarra','San Juana','','','','34','452995042','10298 COUNTY ROAD 2254',0,'TYLER','TX','75707','3216','CY','48423','1951-12-29','F','M',NULL,'N','021','DEN','2350714','33348TX002000101','2014-02-01','2013-12-26 16:36:24','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-27 02:05:32'),(14452,11529,'Y','18','024','14','A','','','TE','0000001004','0000001004','','IL','1','Bruce','Staci',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-27','F','',NULL,NULL,NULL,'','255921','','2013-12-27','2013-12-27 13:59:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-28 03:32:31'),(14723,11755,'N','01','021','EC','A',NULL,NULL,'','0001537834','0002118629','','IL','1','MILLER','JOEL','','','','34','438594660','1044 NECESSITY LN',0,'BASILE','LA','70515','5315','CY','22039','1985-06-22','M','',':RET:2106-3','N','021','DEN','1864587','18575LA002000201','2014-02-01','2013-12-28 14:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2013-12-29 11:09:37'),(19190,15289,'Y','18','021','EC','A','','','AC','0000941767','0000941767','TX00002349488','IL','1','Thigpen','Toncha','','','','34','457613886','1401 ARKANSAS AVE',0,'KILLEEN','TX','76541','8278','CY','48027','1956-05-15','F','M',NULL,'N','021','DEN','2944848','33348TX002000101','2014-03-01','2014-01-19 20:05:51','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2014-01-21 08:46:12'),(21417,17118,'Y','18','021','EC','A','','','AC','0001214837','0001214837','OH00001825697','IL','1','Austin','Corey','','','','34','290886675','4284 Monroe St.',0,'toledo','OH','43606',NULL,'CY','39095','1983-06-19','F','U',':RET:2106-3','N','021','HLT','3647322','92036OH006002601','2014-03-01','2014-02-03 19:36:07','134.00',NULL,NULL,'175.52','41.52','R-OH001','OH0','175.52',NULL,0,'2014-02-04 21:01:11'),(26190,20770,'Y','18','021','EC','A','','','AC','0001204586','0001204586','OH00002471123','IL','1','ALSHAHAL','MANAL','','','','34','271860960','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','1978-05-18','F','M',':RET:2106-3','N','021','DEN','2693744','99734OH005000301','2014-03-01','2014-02-27 12:46:02','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:44'),(26647,21127,'N','01','021','EC','A',NULL,NULL,'','0000759761','0000397400','','IL','1','Gomez','Yuliana','Y','','','34','635189657','4523 Vista Circle',0,'Kent','OH','44240',NULL,'CY','39133','1984-07-26','F','',NULL,'N','021','HLT','2980732','52664OH151001304','2014-04-01','2014-02-28 10:31:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.55',NULL,0,'2014-02-28 21:31:06'),(568,466,'Y','18','021','EC','A','','','AC','0000665604','0000665604','OH00000390137','IL','1','accoo','ahron','','','','34','505276648','393 Howard st',0,'Wilmington','OH','45177',NULL,'CY','39027','1984-08-09','M','U',NULL,'N','021','HLT','885209','92036OH004000601','2014-01-01','2013-12-03 19:45:28','0.00',NULL,NULL,'193.15','193.15','R-OH005','OH0','193.15',NULL,0,'2013-12-25 17:50:31'),(749,619,'Y','18','021','EC','A','','','AC','0000404107','0000404107','TX00000531244','IL','1','Aljabbari','Odeaa','','','','34','640195122','2801 Broadmead drive',0,'Houston','TX','77025',NULL,'CY','48201','1982-03-27','M','U',':RET:2106-3','N','021','DEN','1707691','33348TX002000201','2014-01-01','2013-12-16 07:34:08','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:04:14'),(9699,7682,'Y','18','024','14','A','','','TE','0000711364','0000711364','','IL','1','BELL','MARILYN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-30','F','',NULL,NULL,NULL,'','2189191','','2013-12-21','2013-12-21 15:20:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:55'),(18564,14805,'Y','18','021','EC','A','','','AC','0000917014','0000917014','OH00002349415','IL','1','Fetters','Joby','','','','34','274788998','4000 HARRIET RD',0,'HILLSBORO','OH','45133','7867','CY','39071','1976-04-19','M','M',':RET:2106-3','N','021','HLT','1976172','92036OH005000606','2014-02-01','2014-01-15 18:01:08','350.00',NULL,NULL,'528.07','178.07','R-OH005','OH0','265.76',NULL,0,'2014-01-16 08:47:01'),(17141,13717,'Y','18','021','EC','A','','','AC','0001294861','0001294861','LA00002306863','IL','1','Thompson','Willard','','','','34','435855598','3741 LAUSAT ST',0,'METAIRIE','LA','70001','5762','CY','22051','1992-06-26','M','U',':RET:2054-5','N','021','DEN','2606059','18575LA002000201','2014-02-01','2014-01-07 18:22:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:52'),(15524,12420,'Y','18','021','EC','A','','','AC','0001924738','0001924738','LA00001393979','IL','1','Rouse','Jennifer','','','','34','438650195','1605 HIMALAYA AVE',0,'THIBODAUX','LA','70301','5228','CY','22057','1983-06-26','F','U',':RET:2106-3','T','021','DEN','1623586','18575LA002000201','2014-02-01','2013-12-31 00:54:57','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,1,'2014-01-02 04:30:23'),(14287,11397,'Y','18','021','EC','A','','','AC','0000011166','0000011166','OH00000773675','IL','1','Kirkbride','Amy','','','','34','286442295','315 Parkview Dr.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1965-02-02','F','U',':RET:2106-3','N','021','HLT','1870649','92036OH004002601','2014-02-01','2013-12-26 17:24:45','253.00',NULL,NULL,'256.36','3.36','R-OH001','OH0','256.36',NULL,0,'2013-12-27 02:06:28'),(7053,5603,'Y','18','021','EC','A','','','AC','0000303373','0000303373','OH00001686985','IL','1','norris','kathleen','','','','34','282503768','2928 LINWOOD AVE',0,'CINCINNATI','OH','45208','2827','CY','39061','1950-09-14','F','U',':RET:2106-3','N','021','DEN','2412654','99734OH005000301','2014-01-01','2013-12-24 19:21:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:49:45'),(7365,5833,'Y','18','021','EC','A','','','AC','0000260999','0000260999','LA00000471428','IL','1','Lowe','Tamoria','','','','34','437511572','43660 TOB WILSON RD',0,'FRANKLINTON','LA','70438','5234','CY','22117','1973-03-29','F','U',':RET:2054-5','N','021','DEN','558453','18575LA002000201','2014-01-01','2013-11-23 00:23:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:15:30'),(9537,7559,'Y','18','021','EC','A','','','AC','0000546469','0000546469','OH00000090380','IL','1','Hayden','Adam','','','','34','305026306','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','1980-06-18','M','M',':RET:2106-3','N','021','DEN','2490277','99734OH005000301','2014-01-01','2013-12-21 11:01:12','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:35:57'),(4076,3257,'Y','18','021','EC','A','','','AC','0000035739','0000035739','OH00000227945','IL','1','MURDOCK','RANDY','','','','34','412949917','12419 ASHWOOD LANE',0,'GARRETTSVILLE','OH','44231',NULL,'CY','39133','1954-09-25','M','U',':RET:2106-3','N','021','HLT','2455167','52664OH152000901','2014-01-01','2013-12-17 09:57:25','420.00',NULL,NULL,'425.18','5.18','R-OH012','OH0','425.18',NULL,0,'2013-12-25 21:47:02'),(3827,3065,'Y','18','021','EC','A','','','AC','0000581462','0000581462','OH00000078735','IL','1','Husseini','Raef','','','','34','457650471','5618 E KEMPER RD',0,'CINCINNATI','OH','45241','2143','CY','39061','1965-03-17','M','U',NULL,'N','021','DEN','117963','99734OH005000301','2014-01-01','2013-12-13 16:00:44','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:35:06'),(3735,2986,'Y','18','021','EC','A','','','AC','0000872546','0000872546','TX00001173276','IL','1','Landers','Mickey','','','','34','465805342','2270 FM 1519 N',0,'LEESBURG','TX','75451','2221','CY','48063','1951-04-10','F','M',':RET:2106-3','N','021','DEN','14724','33348TX002000201','2014-01-01','2013-12-13 10:40:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:43'),(9152,7259,'Y','18','024','14','A','','','TE','0000928472','0000928472','','IL','1','Barker','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-12','F','',NULL,NULL,NULL,'','528492','','2013-12-18','2013-12-18 15:07:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:08:28'),(921,764,'Y','18','021','EC','A','','','AC','0000060243','0000060243','OH00000944613','IL','1','SELKA','STEVEN','ALAN','','','34','287528520','11 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1953-08-02','M','U',':RET:2106-3','N','021','HLT','1759961','92036OH006002701','2014-01-01','2013-12-16 17:45:43','405.00',NULL,NULL,'419.70','14.70','R-OH006','OH0','419.70',NULL,0,'2013-12-25 18:08:49'),(3769,3017,'Y','18','021','EC','A','','','AC','0000888159','0000888159','OH00000763442','IL','1','Blemenschutz','Thomas','','','','34','278543816','430 Malacca St',0,'Akron','OH','44305',NULL,'CY','39153','1951-04-13','M','U',':RET:2106-3','N','021','HLT','105638','52664OH151001305','2014-01-01','2013-12-13 14:57:42','518.00',NULL,NULL,'640.70','122.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 21:33:39'),(3202,2576,'Y','18','021','EC','A','','','AC','0000112897','0000112897','OH00000465017','IL','1','grau','donna','','','','34','273768479','2011 SUMMERS AVE',0,'STREETSBORO','OH','44241','5824','CY','39133','1966-09-27','F','U',':RET:2106-3','T','021','DEN','758180','99734OH005000401','2014-01-01','2013-11-01 16:49:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:45:12'),(3162,2544,'Y','18','021','EC','A','','','AC','0000156896','0000156896','OH00000507819','IL','1','Jennings','Eileen','','','','34','274569493','30630 Drouillard Road Lot360',0,'Walbridge','OH','43465',NULL,'CY','39173','1953-11-02','F','M',':RET:2106-3','N','021','DEN','704305','99734OH005000401','2014-01-01','2013-11-18 12:24:18','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 20:31:21'),(20696,16536,'Y','18','021','EC','A','','','AC','0000340324','0000340324','OH00002240630','IL','1','VARGO','DEBORAH','LEE','','','34','287541072','1 S HAMILTON ST',0,'MONREVILLE','OH','44847',NULL,'CY','39077','1954-07-25','F','U',':RET:2106-3','N','021','DEN','3089509','99734OH005000301','2014-03-01','2014-01-30 13:42:57','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-01-30 21:01:00'),(23002,18337,'N','01','021','EC','A',NULL,NULL,'','0000784404','0001135212','','IL','1','Avyerina','Larysa','Ivanivna','','','34','270132563','1015 MCDOWELL ST NE',0,'CANTON','OH','44721','3136','CY','39151','1970-02-02','F','',':RET:2106-3','N','021','DEN','2627613','99734OH005000301','2014-03-01','2014-02-12 14:00:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:19'),(25455,20196,'Y','18','021','EC','A','','','AC','0001114346','0001114346','TX00003345745','IL','1','REYES','BONNIE','','','','34','458594161','5815 W MILE 5 RD',0,'MISSIO N','TX','78574',NULL,'CY','48215','1978-10-01','F','M',NULL,'N','021','DEN','3630042','33348TX002000201','2014-04-01','2014-02-25 14:06:50','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-25 21:31:28'),(26771,21217,'N','19','021','EC','A',NULL,NULL,'','0000650824','0001078954','','IL','1','Landis','Shelby','L','','','34','277989458','4478 St Rt 121',0,'Greenville','OH','45331',NULL,'CY','39037','1995-02-16','F','',':RET:2106-3','N','021','HLT','2725909','92036OH004000501','2014-04-01','2014-02-28 18:08:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-03-01 21:00:08'),(28974,22931,'N','01','021','EC','A',NULL,NULL,'','0001833728','0002346058','','IL','1','Johnson','Vincent',NULL,NULL,NULL,NULL,NULL,'1345 fiesta dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1967-03-28','M','',':RET:2054-5','N','021','DEN','3626419','18575LA002000201','2014-04-01','2014-03-10 17:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-10 21:01:04'),(5838,4637,'Y','18','021','EC','A','','','AC','0000356399','0000356399','TX00001416282','IL','1','ANJUM','AFSHAN','','','','34','733267916','503 S Avenue f',0,'Clifton','TX','76634',NULL,'CY','48035','1979-07-28','F','M',':RET:2029-7','N','021','DEN','1539867','33348TX002000201','2014-01-01','2013-12-23 23:29:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:48:29'),(17407,13931,'Y','18','021','EC','A','','','AC','0001089591','0001089591','TX00002101378','IL','1','RAMOS','SANTOS','','','','34','452904587','108 LEAL ST',0,'MISSION','TX','78572',NULL,'CY','48215','1949-12-28','F','U',NULL,'N','021','DEN','1635207','33348TX002000101','2014-02-01','2014-01-10 12:04:04','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-01-13 03:00:19'),(3704,2964,'Y','18','021','EC','A','','','AC','0001103416','0001103416','OH00000832118','IL','1','wygum','susan','','','','34','293447380','723 Rutter Avenue',0,'lancaster','OH','43130',NULL,'CY','39045','1959-05-23','F','U',':RET:2106-3','N','021','DEN','925089','99734OH005000401','2014-01-01','2013-12-13 14:02:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:32:03'),(15536,12431,'Y','18','024','14','A','','','TE','0001501884','0001501884','','IL','1','durbin','patrick',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-01-29','M','',NULL,NULL,NULL,'','2442112','','2013-12-31','2013-12-31 13:57:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2014-01-02 04:30:49'),(3411,2739,'Y','18','021','EC','A','','','AC','0002253929','0002253929','LA00000942535','IL','1','Cavalier','Curtis','','','','34','437215143','58321 Harbor Road',0,'Slidell','LA','70460',NULL,'CY','22103','1960-01-15','M','M',':RET:2106-3','N','021','DEN','2379692','18575LA002000201','2014-01-01','2013-12-22 15:48:36','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:23'),(19482,15529,'Y','18','024','14','A','','','TE','0000585433','0000585433','','IL','1','Odum','Carol','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-09','F','',NULL,NULL,NULL,'','425764','','2014-01-22','2014-01-22 17:48:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 03:02:04'),(19501,15542,'Y','18','021','EC','A','','','AC','0000886938','0000886938','OH00001549787','IL','1','Edwards','Gail','','','','34','278544552','667 SANFORD AVE',0,'AKRON','OH','44305','1743','CY','39153','1951-02-20','F','U',':RET:2106-3','N','021','HLT','2442830','52664OH151001301','2014-03-01','2014-01-22 12:24:16','268.00',NULL,NULL,'658.32','390.32','R-OH012','OH0','658.32',NULL,0,'2014-01-23 03:02:10'),(22295,17798,'Y','18','021','EC','A','','','AC','0000530721','0000530721','OH00002128413','IL','1','Ditrick','Darrell','','','','34','287449592','1428 King Ave.',0,'Columbus','OH','43212',NULL,'CY','39049','1951-08-27','M','U',':RET:2106-3','N','021','DEN','1830647','99734OH005000301','2014-03-01','2014-01-20 09:40:31','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-10 11:00:32'),(22687,18116,'N','01','021','EC','A',NULL,NULL,'','0000071819','0001158564','','IL','1','Sweely','Teresa','','','','34','268508563','801 Pampa St',0,'Sulphur Springs','TX','75482',NULL,'CY','48223','1961-08-26','F','',':RET:2106-3','N','021','DEN','3259488','33348TX002000201','2014-03-01','2014-02-11 17:59:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:50'),(24972,19805,'Y','18','021','EC','A','','','AC','0000313329','0000313329','TX00002790303','IL','1','DE LEON','JOSE','','','','34','459979636','10931 CLEAR VILLA LN',0,'HOUSTON','TX','77034',NULL,'CY','48201','1986-06-22','M','U',NULL,'N','021','DEN','3801093','33348TX002000201','2014-04-01','2014-02-20 00:04:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:27'),(25518,20244,'Y','18','021','EC','A','','','AC','0000878316','0000878316','OH00003112549','IL','1','Bradley','Richelle','','','','34','300902012','954 CRESTWOOD DR',0,'LIMA','OH','45805','1626','CY','39003','1987-11-16','F','R',':RET:2106-3','N','021','HLT','2840556','92036OH004001501','2014-04-01','2014-02-25 15:53:17','0.00',NULL,NULL,'181.21','181.21','R-OH002','OH0','181.21',NULL,0,'2014-02-25 21:32:04'),(28221,22329,'N','01','021','EC','A',NULL,NULL,'','0000356080','0000443508','','IL','1','Ferguson','Garry','','','','34','283469237','7913 NATIONAL RD SW',0,'ETNA','OH','43062','8614','CY','39089','1953-06-29','M','',NULL,'T','021','DEN','3360660','99734OH005000301','2014-04-01','2014-03-06 13:52:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-06 21:30:19'),(9048,7177,'N','01','021','EC','A',NULL,NULL,'','0000168879','0000021377','','IL','1','Yokie','Nicole','Annette','','','34','277767736','7155 CHAPEL RD',0,'MADISON','OH','44057','2240','CY','39085','1964-06-18','F','',NULL,'N','021','HLT','2472454','52664OH151001306','2014-01-01','2013-12-18 16:30:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','429.09',NULL,0,'2013-12-26 04:05:57'),(5675,4502,'Y','18','021','EC','A','','','AC','0000053026','0000053026','OH00001064650','IL','1','Whisner','philip','','','','34','300804736','1560 bethel New Richmond road',0,'New Richmond','OH','45157',NULL,'CY','39025','1968-02-29','M','U',':RET:2106-3','N','021','HLT','506074','92036OH005000606','2014-01-01','2013-11-25 21:22:37','245.00',NULL,NULL,'309.99','64.99','R-OH005','OH0','309.99',NULL,0,'2013-12-25 23:32:10'),(16644,13316,'N','01','021','EC','A',NULL,NULL,'','0000310865','0001105550','','IL','1','Ross','Janie','','','','34','306681725','5708 Terrace Park Drive',0,'Kettering','OH','45429',NULL,'CY','39113','1957-01-11','F','',':RET:2106-3','N','021','DEN','1809841','99734OH005000401','2014-02-01','2014-01-07 15:40:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:18'),(9309,7381,'Y','18','021','EC','A','','','AC','0001666291','0001666291','LA00000545679','IL','1','Talbot','Thomas','N','','','34','454886280','2207 VINE ST',0,'SULPHUR','LA','70663','6369','CY','22019','1950-08-12','M','M',':RET:2106-3','N','021','DEN','2564354','18575LA002000101','2014-01-01','2013-12-20 22:20:33','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2013-12-26 04:30:12'),(5061,4010,'Y','18','024','14','A','','','TE','0001040265','0001040265','','IL','1','VERETTE','MARCIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','F','',NULL,NULL,NULL,'','2434314','','2013-12-19','2013-12-19 07:19:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:00:26'),(4185,3329,'Y','18','021','EC','A','','','AC','0001084134','0001084134','OH00000206374','IL','1','Vincent','Gary','','','','34','236769073','680 WOODBROOK RD',0,'CUYAHOGA FALLS','OH','44223','2754','CY','39153','1952-04-04','M','M',':RET:2106-3','N','021','HLT','1861203','52664OH151001305','2014-01-01','2013-12-17 10:26:05','417.00',NULL,NULL,'626.65','209.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 21:49:29'),(1843,1510,'Y','18','021','EC','A','','','AC','0000100067','0000100067','OH00000375232','IL','1','Triola','Christian','','','','34','285869618','577 Parkway Blvd',0,'Norton','OH','44203',NULL,'CY','39153','1976-08-31','M','M',':RET:2106-3','N','021','HLT','1377035','52664OH151001304','2014-01-01','2013-12-24 12:17:31','308.00',NULL,NULL,'553.95','245.95','R-OH012','OH0','276.08',NULL,0,'2013-12-25 18:57:41'),(3379,2708,'Y','18','021','EC','A','','','AC','0000484245','0000484245','TX00000919394','IL','1','Smith','Terrence','J','','','34','452041161','113 Forest Lane',0,'Bastrop','TX','78602',NULL,'CY','48021','1956-02-17','M','M',NULL,'N','021','DEN','1926269','33348TX002000201','2014-01-01','2013-12-22 17:15:16','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:17:28'),(2390,1951,'Y','18','021','EC','A','','','AC','0001231745','0001231745','OH00000977077','IL','1','gillenwater','stephen','','','','34','280541887','4961 waynesville jamestown rd',0,'jamestown','OH','45335',NULL,'CY','39057','1953-03-31','M','M',':RET:2106-3','N','021','DEN','116702','99734OH005000401','2014-01-01','2013-12-09 12:03:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:33:15'),(19853,15835,'Y','18','024','14','A','','','TE','0001249599','0001249599','','IL','1','Bangura','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-09','F','',NULL,NULL,NULL,'','1977115','','2014-01-24','2014-01-24 00:05:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:32'),(19927,15891,'Y','18','021','EC','A','','','AC','0000047242','0000047242','MS00001761712','IL','1','WELLS','DORIS','','','','34','587609777','3856 CLAYTON AVENUE',0,'JACKSON','MS','39213',NULL,'CY','28049','1951-07-08','F','U',NULL,'N','021','DEN','2841060','46300MS002000101','2014-03-01','2014-01-24 13:05:36','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-24 21:01:07'),(20149,16079,'Y','18','021','EC','A','','','AC','0000029078','0000029078','OH00002057454','IL','1','CARPENTER','JACQUELYN','','','','34','272800397','425 WESTWOOD DR',0,'STEUBENVILLE','OH','43953','3646','CY','39081','1974-09-29','F','M',':RET:2106-3','T','021','DEN','3339293','99734OH005000301','2014-03-01','2014-01-26 20:21:50','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-27 21:01:03'),(20977,16763,'Y','18','021','EC','A','','','AC','0000739906','0000739906','MS00001788800','31','1','BRYANT','ROSE','','','','34','587544348','P O BOX 423',0,'EDWARDS','MS','39066',NULL,'CY','28049','1951-04-28','F','U',':RET:2054-5','N','021','DEN','2690660','46300MS002000101','2014-03-01','2014-02-01 16:26:46','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-01 19:00:18'),(24451,19423,'Y','18','021','EC','A','','','AC','0000807550','0000807550','OH00002920239','IL','1','Cartier','Shannon','','','','34','271882743','6159 ELDRIDGE BLVD',0,'BEDFORD HEIGHTS','OH','44146','4002','CY','39035','1977-01-26','F','U',':RET:2106-3','T','021','HLT','2633972','92036OH004000801','2014-04-01','2014-02-18 10:40:11','0.00',NULL,NULL,'267.64','267.64','R-OH011','OH0','267.64',NULL,0,'2014-02-18 22:01:26'),(27000,21384,'N','01','021','EC','A',NULL,NULL,'','0000221380','0000123031','','IL','1','MILLER','ANTHONY','','','','34','278827338','9010 DRUMS BOTTOM RD NE',0,'THORNVILLE','OH','43076','9537','CY','39045','1972-06-30','M','',':RET:2106-3','N','021','DEN','2961031','99734OH005000401','2014-04-01','2014-03-02 22:54:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:01'),(28396,22466,'Y','18','021','EC','A','','','AC','0000519893','0000519893','OH00002980704','IL','1','Hatfield','Kristina','','','','34','284862362','918 BRADFORD CT',0,'CINCINNATI','OH','45233','1460','CY','39061','1985-12-26','F','M',NULL,'N','021','DEN','3766029','99734OH005000401','2014-04-01','2014-03-06 19:37:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:30:47'),(5640,4474,'Y','18','021','EC','A','','','AC','0000446858','0000446858','TX00000562471','IL','1','Godines','Bonnie','','','','34','466934435','10015 Boston PL',0,'Dallas','TX','75217',NULL,'CY','48113','1980-12-20','F','M',':RET:2106-3','N','021','DEN','448944','33348TX002000201','2014-01-01','2013-11-26 12:12:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:31:13'),(17060,13653,'Y','18','021','EC','A','','','AC','0000768311','0000768311','TX00001846149','IL','1','brindis','adolfo','','','','34','609920518','705 mimosa trail',0,'cedar hill','TX','75104',NULL,'CY','48113','1961-02-27','M','M',':RET:2106-3','N','021','DEN','1849284','33348TX002000201','2014-02-01','2014-01-07 21:08:22','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:11'),(1733,1441,'Y','18','021','EC','A','','','AC','0000813089','0000813089','OH00000148197','IL','1','Pressel','Amanda','','','','34','281762779','1480 WAINSCOTT WAY',0,'DAYTON','OH','45414','5915','CY','39113','1978-12-05','F','R',':RET:2106-3','N','021','DEN','1480239','99734OH005000301','2014-01-01','2013-12-24 11:00:11','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:55:25'),(15197,12145,'Y','18','021','EC','A','','','AC','0000453405','0000453405','MS00001759629','IL','1','Roundtree','Juanita','B','','','34','587326256','325 LAKE OF PINES DR',0,'JACKSON','MS','39206','3228','CY','28049','1950-02-15','F','U',':RET:2054-5','N','021','DEN','2405297','46300MS002000201','2014-02-01','2013-12-30 10:07:27','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-01 12:07:17'),(2777,2244,'Y','18','021','EC','A','','','AC','0000744401','0000744401','MS00001124176','IL','1','Scales','Timothy','L','','','34','587119718','308 S 2ND ST',0,'BALDWYN','MS','38824','2219','CY','28081','1963-08-01','M','M',':RET:2054-5','N','021','DEN','326840','46300MS002000101','2014-01-01','2013-12-02 14:19:39','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2013-12-25 19:49:43'),(2021,1657,'N','19','021','EC','A',NULL,NULL,'','0001075287','0000690716','','IL','1','Ridgeway','Liam','C','','','34','292139755','1522 Newton Pass',0,'Broadview Heights','OH','44147',NULL,'CY','39035','2002-06-07','M','',NULL,'N','021','HLT','1121237','52664OH152000901','2014-01-01','2013-12-09 21:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','116.98',NULL,0,'2013-12-25 19:15:08'),(21865,17458,'Y','18','021','EC','A','','','AC','0000245027','0000245027','OH00002424324','IL','1','PAULEY','PEGGY','','','','34','271500876','176 E LEWIS AVE',0,'SABINA','OH','45169','1347','CY','39027','1950-11-09','F','M',':RET:2106-3','N','021','HLT','3433605','92036OH005000605','2014-03-01','2014-02-06 10:31:22','526.00',NULL,NULL,'633.70','107.70','R-OH005','OH0','633.70',NULL,0,'2014-02-06 21:01:22'),(24311,19306,'N','01','021','EC','A',NULL,NULL,'','0001885767','0002163514','','IL','1','STEWART','CRAIG','','','Sr','34','439416327','216 EVELYN AVE',0,'HOUMA','LA','70363',NULL,'CY','22109','1965-10-31','M','',':RET:2054-5','N','021','DEN','3121202','18575LA002000101','2014-03-01','2014-02-18 17:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02','CIC',0,'2014-02-18 21:30:24'),(26370,20918,'Y','18','021','EC','A','','','AC','0000319650','0000319650','OH00003234433','IL','1','CLARK','RENEE','KAY','','','34','273563596','4151 CLEVELAND AVE',0,'COLUMBUS','OH','43224','4717','CY','39049','1954-03-28','F','U',':RET:2054-5','N','021','DEN','3610918','99734OH005000401','2014-04-01','2014-02-26 11:04:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-28 07:00:11'),(28857,22836,'Y','18','021','EC','A','','','AC','0000256028','0000256028','OH00002745656','IL','1','Vasbinder','Jann','','','','34','290064903','627 BERRY RD',0,'HOWARD','OH','43028','9542','CY','39083','1951-01-31','F','M',':RET:2106-3','N','021','DEN','3564807','99734OH005000401','2014-04-01','2014-03-09 12:25:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-03-09 21:30:00'),(1679,1401,'Y','18','021','EC','A','','','AC','0001330170','0001330170','LA00000124146','IL','1','Rousselle','Dan','','','Sr','34','439827432','328 COMMERCE ST',0,'GRETNA','LA','70056','7216','CY','22051','1952-04-03','M','M',':RET:2106-3','N','021','DEN','1435691','18575LA002000101','2014-01-01','2013-12-24 09:42:07','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:06'),(17290,13828,'Y','18','024','14','A','','','TE','0000612374','0000612374','','IL','1','Rawlins','Heather',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-08-04','F','',NULL,NULL,NULL,'','1729531','','2014-01-09','2014-01-09 21:45:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:23:32'),(3733,2984,'Y','18','021','EC','A','','','AC','0000625042','0000625042','TX00001298389','IL','1','Gomez','Eufemia','','','','34','457924936','25269 N KANSAS CITY RD',0,'LA FERIA','TX','78559','4510','CY','48061','1952-09-22','F','M',NULL,'N','021','DEN','503498','33348TX002000201','2014-01-01','2013-12-13 00:17:58','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 21:32:38'),(4652,3688,'Y','18','021','EC','A','','','AC','0001240537','0001240537','OH00000420790','IL','1','Warden','Dewey','','','','34','277544735','861 W ANSON DR',0,'CINCINNATI','OH','45245','7030','CY','39025','1952-11-11','M','M',':RET:2106-3','N','021','HLT','48010','92036OH003000605','2014-01-01','2013-12-12 16:25:22','439.00',NULL,NULL,'629.96','190.96','R-OH005','OH0','629.96',NULL,0,'2013-12-25 22:07:06'),(14034,11179,'Y','18','021','EC','A','','','AC','0000370022','0000370022','OH00001371058','IL','1','BREWSTER','CARL','','','','34','269463530','16770 W STATE ROUTE 105',0,'ELMORE','OH','43416','9412','CY','39123','1950-01-30','M','U',NULL,'T','021','HLT','2109338','92036OH006002701','2014-01-01','2013-12-23 14:57:28','313.00',NULL,NULL,'524.98','211.98','R-OH006','OH0','524.98',NULL,0,'2013-12-26 13:16:57'),(9602,7605,'Y','18','021','EC','A','','','AC','0000571990','0000571990','OH00000610716','IL','1','Davis','Gary','','','','34','279507225','1019 E Nimisila rd.',0,'Akron','OH','44319',NULL,'CY','39153','1950-09-23','M','U',':RET:2106-3','N','021','HLT','2152852','52664OH151001305','2014-01-01','2013-12-21 11:35:04','535.00',NULL,NULL,'658.32','123.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 04:37:26'),(20251,16160,'Y','18','021','EC','A','','','AC','0000827041','0000827041','TX00001750280','IL','1','Kemper','Ashley','','','','34','356824703','6605 RIVERHILL DR',0,'PLANO','TX','75024','7437','CY','48121','1983-04-20','F','R',':RET:2106-3','N','021','DEN','2042778','33348TX002000101','2014-03-01','2014-01-28 15:43:05','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-28 21:00:13'),(21497,17174,'N','01','021','EC','A',NULL,NULL,'','0000639560','0000511984','','IL','1','LUONG','CHANH','HUY','','','34','573879778','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1973-08-20','M','',NULL,'N','021','HLT','3733016','92036OH003001204','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','286.51',NULL,0,'2014-02-04 21:01:49'),(22092,17635,'Y','18','021','EC','A','','','AC','0000003752','0000003752','MS00001957013','IL','1','Hudson','Kendrick','','','','34','427131827','118 Willis Road',0,'Flora','MS','39207',NULL,'CY','28049','1973-12-11','M','U',':RET:2054-5','T','021','DEN','3151253','46300MS002000201','2014-03-01','2014-02-08 12:59:43','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-08 19:00:25'),(9713,7694,'Y','18','021','EC','A','','','AC','0000725033','0000725033','OH00000172638','IL','1','Weirick','Kathleen','Mary','','','34','298487518','5103 5th Ave Ext',0,'Youngstown','OH','44505',NULL,'CY','39155','1950-05-29','F','U',':RET:2106-3','N','021','DEN','1186706','99734OH005000401','2014-01-01','2013-11-15 10:45:20','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:45:15'),(18151,14495,'Y','18','021','EC','A','','','AC','0001292253','0001292253','LA00002560353','IL','1','Hollis','Karen','','','','34','433027816','2000 CARTER ST',0,'WEST MONROE','LA','71291','7602','CY','22073','1956-04-21','F','U',':RET:2106-3','N','021','DEN','2512139','18575LA002000101','2014-02-01','2014-01-14 17:37:18','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-15 02:07:50'),(18691,14901,'Y','18','021','EC','A','','','AC','0002310027','0002310027','LA00001547241','IL','1','Boudreaux','Connie','','','','34','436252475','6861 Hwy 1 South Lot 5',0,'Addis','LA','70710',NULL,'CY','22121','1961-02-20','F','U',':RET:2106-3','N','021','DEN','1902899','18575LA002000101','2014-03-01','2014-01-16 00:10:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-17 03:35:24'),(25859,20501,'Y','18','021','EC','A','','','AC','0001810978','0001810978','LA00003016412','IL','1','Nguyen','Linh','','','','34','659145151','67 TERRA AVE',0,'ALEXANDRIA','LA','71303','2259','CY','22079','1985-01-22','F','U',':RET:2047-9','N','021','DEN','3601175','18575LA002000201','2014-03-01','2014-02-26 10:25:28','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-26 21:00:44'),(28160,22284,'Y','18','021','EC','A','','','AC','0000584338','0000584338','OH00003419000','IL','1','Deubler','Wendy','A','','','34','280806340','4750 STEWART RD',0,'LIMA','OH','45801','1324','CY','39003','1973-11-28','F','M',':RET:2106-3','N','021','HLT','3529968','92036OH005001505','2014-04-01','2014-03-06 15:53:00','449.00',NULL,NULL,'562.54','113.54','R-OH002','OH0','281.27',NULL,0,'2014-03-06 21:02:41'),(1384,1149,'Y','18','021','EC','A','','','AC','0001970804','0001970804','LA00000565827','31','1','Hale-Arnold','Andrea','','','','34','290748958','PO Box 279',0,'Tickfaw','LA','70466',NULL,'CY','22105','1974-07-19','F','M',':RET:1002-5^:RET:2028-9^:RET:2106-3','N','021','DEN','2532562','18575LA002000201','2014-01-01','2013-12-24 10:21:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:10'),(23655,18836,'Y','18','021','EC','A','','','AC','0000784040','0000784040','TX00001874650','IL','1','Sparks','Alice','','','','34','461922207','135 WOODLAND TRL',0,'GUN BARREL CITY','TX','75156','3528','CY','48213','1950-05-26','F','M',':RET:2106-3','N','021','DEN','3760819','33348TX002000201','2014-03-01','2014-02-14 01:16:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:16'),(23396,18644,'Y','18','021','EC','A','','','AC','0000696857','0000696857','OH00001685718','IL','1','DeForest','Michelle','','','','34','285782737','16360 Hautala Rd',0,'Montville','OH','44064',NULL,'CY','39055','1978-03-18','F','U',NULL,'N','021','DEN','3509640','99734OH005000401','2014-03-01','2014-02-13 15:42:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:01:08'),(19653,15659,'N','01','021','EC','A',NULL,NULL,'','0000741751','0000129283','','IL','1','Bowman','Jason','A','','','34','272886825','517 S Marion St',0,'Cardington','OH','43315',NULL,'CY','39117','1979-10-16','M','',':RET:2106-3','T','021','DEN','3267520','99734OH005000401','2014-03-01','2014-01-23 12:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:20'),(9396,7452,'Y','18','024','14','A','','','TE','0000479695','0000479695','','IL','1','Rylander','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-06-23','M','',NULL,NULL,NULL,'','1843362','','2013-12-20','2013-12-20 22:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:28'),(4631,3669,'N','01','021','EC','A',NULL,NULL,'','0000784935','0000023680','','IL','1','Ingram','Charles','Douglas','','','34','587742411','350 Main st',0,'pope','MS','38658',NULL,'CY','28107','1953-09-19','M','',':RET:2106-3','N','021','DEN','6641','46300MS002000101','2014-01-01','2013-12-12 12:33:11',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 22:06:32'),(26296,20860,'Y','18','021','EC','A','','','AC','0000279611','0000279611','OH00002616283','IL','1','Rowe','Cheryl','','','','34','406925992','19048 County Road D',0,'Archbold','OH','43502',NULL,'CY','39051','1964-07-26','F','U',':RET:2106-3','T','021','HLT','3048565','92036OH004002601','2014-04-01','2014-02-26 20:06:13','181.00',NULL,NULL,'307.62','126.62','R-OH001','OH0','307.62',NULL,0,'2014-02-28 06:31:26'),(27291,21610,'Y','18','021','EC','A','','','AC','0000182164','0000182164','TX00003179159','IL','1','Durham','Marissa','','','','34','465908598','1723 E BROADWAY ST',0,'BROWNFIELD','TX','79316','4801','CY','48445','1966-04-11','F','R',':RET:2106-3','N','021','DEN','3133507','33348TX002000201','2014-04-01','2014-03-04 10:26:40','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:29'),(27590,21820,'Y','18','021','EC','A','','','AC','0000693636','0000693636','TX00003455073','IL','1','Moss','Carrie','','','','34','455412208','1401 Hartford Rd',0,'Austin','TX','78703',NULL,'CY','48453','1967-10-07','F','U',':RET:1002-5','N','021','DEN','3830956','33348TX002000201','2014-04-01','2014-03-05 16:38:11','0.00',NULL,NULL,'56.37','56.37','R-TX003','TX0','15.85','CIC',0,'2014-03-05 21:00:17'),(540,441,'Y','18','021','EC','A','','','AC','0000426398','0000426398','OH00000993217','IL','1','Brooker','Lee','','','','34','288549784','814 HUDSON RD',0,'KENT','OH','44240','2106','CY','39133','1968-12-03','M','U',':RET:2106-3','N','021','HLT','912272','52664OH152000901','2014-01-01','2013-12-04 15:49:41','207.00',NULL,NULL,'235.86','28.86','R-OH012','OH0','235.86',NULL,0,'2013-12-25 17:49:41'),(3324,2667,'N','19','021','EC','A',NULL,NULL,'','0000581482','0000446285','','S1','1','Riegler','John','','','','34','297084402','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','2004-04-19','M','',':RET:2106-3','N','021','DEN','2144635','99734OH005000301','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:08'),(23885,19001,'N','19','021','EC','A',NULL,NULL,'','0000833460','0000221363','','IL','1','Orue','Alexis','','','','34','274063223','6720 GREENFIELD DR',0,'CINCINNATI','OH','45224','1643','CY','39061','2000-12-03','F','',':RET:2106-3','N','021','HLT','2952696','92036OH002001201','2014-03-01','2014-02-14 13:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-02-14 21:32:15'),(4649,3685,'Y','18','021','EC','A','','','AC','0000615491','0000615491','OH00000535027','IL','1','Angel','Mark','','','','34','457714448','4263 IVY POINTE BLVD',0,'CINCINNATI','OH','45245','1056','CY','39025','1982-03-08','M','U',NULL,'N','021','HLT','97244','92036OH003000605','2014-01-01','2013-12-11 23:15:37','132.00',NULL,NULL,'259.83','127.83','R-OH005','OH0','259.83',NULL,0,'2013-12-25 22:07:00'),(7028,5581,'Y','18','021','EC','A','','','AC','0000782834','0000782834','TX00000310261','IL','1','CHUKWU','NKECI','AHUDIA','','','34','460970639','9637 FORREST LANE',0,'DALLAS','TX','75243',NULL,'CY','48113','1987-08-11','F','U',':RET:2054-5','N','021','DEN','2584077','33348TX002000201','2014-01-01','2013-12-24 23:04:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:02'),(6894,5470,'Y','18','021','EC','A','','','AC','0001551831','0001551831','LA00000705153','IL','1','Cotton','Olivia','','','','34','439595469','5215 CUMBERLAND COVE DR',0,'BATON ROUGE','LA','70817','2291','CY','22033','1986-03-24','F','U',':RET:2106-3','N','021','DEN','1414155','18575LA002000201','2014-01-01','2013-12-24 21:35:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:27'),(6698,5310,'Y','18','021','EC','A','','','AC','0001012891','0001012891','OH00000210996','IL','1','Williams','Christina','','','','34','278887703','35 Lori Lane',0,'Amelia','OH','45102',NULL,'CY','39025','1982-05-09','F','U',':RET:2106-3','N','021','DEN','97926','99734OH005000301','2014-01-01','2013-11-04 20:06:37','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 01:01:49'),(6520,5169,'Y','18','024','14','A','','','TE','0000910496','0000910496','','IL','1','stefanelli','paul',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-12-14','M','',NULL,NULL,NULL,'','26419','','2013-12-11','2013-12-11 14:51:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:51:22'),(22715,18139,'Y','18','021','EC','A','','','AC','0001167342','0001167342','LA00001442583','IL','1','NGUYEN','DU','','','','34','620184071','544 ATWOOD DR',0,'CROWLEY','LA','70526','0968','CY','22001','1971-10-30','M','M',':RET:2028-9','T','021','DEN','3078508','18575LA002000201','2014-03-01','2014-02-11 09:36:04','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-02-11 21:01:07'),(21024,16800,'Y','18','021','EC','A','','','AC','0000893054','0000893054','MS00002236639','IL','1','TUN','TUN','','','','34','292115714','919 OLD TOWNE ST',0,'GULFPORT','MS','39507','6004','CY','28047','1970-04-25','M','U',':RET:2028-9','N','021','DEN','3666625','46300MS002000201','2014-03-01','2014-01-31 22:51:02','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-01 19:00:41'),(19309,15392,'Y','18','021','EC','A','','','AC','0000721505','0000721505','TX00001621832','IL','1','Zubia','Cruz','','','','34','585064310','1515 N JACKSON AVE',0,'ODESSA','TX','79761','2608','CY','48135','1965-10-06','F','U',NULL,'N','021','DEN','2093075','33348TX002000201','2014-03-01','2014-01-20 19:13:34','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,1,'2014-01-22 03:22:05'),(17582,14056,'N','19','021','EC','A',NULL,NULL,'','0000050708','0001135190','','S1','1','Hindel','Scott','','','','34','272139438','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2006-12-11','F','',':RET:2106-3','N','021','DEN','1970276','99734OH005000401','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:06'),(15983,12793,'Y','18','021','EC','A','','','AC','0000014061','0000014061','TX00001589677','IL','1','Stots','Monica','','','','34','467350697','3200 Saint Juliet St',0,'Fortworth','TX','76107',NULL,'CY','48439','1966-09-14','F','U',':RET:2054-5','N','021','DEN','1768258','33348TX002000201','2014-02-01','2014-01-03 11:06:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-04 02:01:00'),(15688,12550,'Y','18','024','14','A','','','TE','0000176400','0000176400','','IL','1','COSTILOW','REBECCA','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-28','F','',NULL,NULL,NULL,'','2591642','','2013-12-31','2013-12-31 11:39:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:35:16'),(25920,20555,'Y','18','021','EC','A','','','AC','0001029356','0001029356','TX00003416158','IL','1','ADELEYE','EDUWEM','','','','34','634044085','5402 MUSTANG RIDGE LANE',0,'FULSHEAR','TX','77441',NULL,'CY','48157','1977-06-22','F','R',':RET:2054-5','N','021','DEN','3535587','33348TX002000201','2014-04-01','2014-02-26 15:41:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 21:01:20'),(28043,22190,'Y','18','021','EC','A','','','AC','0001214593','0001214593','MS00003155126','IL','1','Ammons','Orise','Joshua','','','34','426652813','208 W leake ST',0,'CLINTON','MS','39056',NULL,'CY','28049','1982-04-03','M','M',':RET:2106-3','T','021','DEN','3772122','46300MS002000201','2014-04-01','2014-03-05 18:42:58','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:32'),(28443,22506,'Y','18','021','EC','A','','','AC','0002224571','0002224571','LA00003600447','IL','1','Cozad','Molly','','','','34','438671417','118 rosewood dr',0,'metairie','LA','70005',NULL,'CY','22051','1979-03-13','F','U',':RET:2106-3','T','021','DEN','4037977','18575LA002000201','2014-04-01','2014-03-06 22:12:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:15'),(22907,18259,'Y','18','021','EC','A','','','AC','0001100633','0001100633','OH00001359166','IL','1','Lilly','Cindy','','','','34','270581499','214  hopkins',0,'Defiance','OH','43512',NULL,'CY','39039','1957-03-09','F','U',NULL,'N','021','HLT','3143188','92036OH004002601','2014-03-01','2014-02-11 16:30:18','363.12',NULL,NULL,'365.79','2.67','R-OH001','OH0','365.79',NULL,0,'2014-02-11 21:02:45'),(9413,7468,'Y','18','021','EC','A','','','AC','0001247790','0001247790','TX00000888575','IL','1','Woodruff','Shannon','','','','34','437820489','1203 B East Grand Ave',0,'Marshall','TX','75670',NULL,'CY','48203','1950-12-06','F','U',':RET:2106-3','N','021','DEN','2611951','33348TX002000201','2014-01-01','2013-12-21 13:12:27','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:32:55'),(22523,17982,'Y','18','021','EC','A','','','AC','0000688323','0000688323','OH00001970545','IL','1','Shively','Vernon','','','','34','275727554','932 old cincinnati pike',0,'West Union','OH','45693',NULL,'CY','39001','1970-05-07','M','U',':RET:2106-3','N','021','HLT','2867923','92036OH003000605','2014-03-01','2014-02-09 20:58:31','218.00',NULL,NULL,'304.21','86.21','R-OH005','OH0','304.21',NULL,0,'2014-02-10 21:31:27'),(21031,16804,'Y','18','021','EC','A','','','AC','0000553946','0000553946','OH00001384188','IL','1','Hackett','Therese','M','','','34','301642366','1922 SEATTLE ST',0,'CUYAHOGA FALLS','OH','44221','4455','CY','39153','1958-07-03','F','M',':RET:2106-3','N','021','HLT','3326727','52664OH151001301','2014-03-01','2014-02-01 14:09:17','43.00',NULL,NULL,'497.31','454.31','R-OH012','OH0','497.31',NULL,0,'2014-02-01 19:00:44'),(4726,3745,'Y','18','021','EC','A','','','AC','0000728688','0000728688','OH00001102063','IL','1','Schmidt','Elissa','','','','34','296869262','1806 BRIERHEATH AVE',0,'TOLEDO','OH','43614','3706','CY','39095','1980-03-09','F','U',':RET:2106-3','N','021','HLT','276923','92036OH003002606','2014-01-01','2013-12-12 16:22:22','175.00',NULL,NULL,'243.94','68.94','R-OH001','OH0','243.94',NULL,0,'2013-12-25 22:09:03'),(1747,1448,'N','19','021','EC','A',NULL,NULL,'','0000784364','0000671703','','IL','1','Haikal','Ann','','','','34','279967761','13882 LAKE AVE',0,'LAKEWOOD','OH','44107','1425','CY','39035','1993-07-29','F','',NULL,'N','021','DEN','2188206','99734OH005000301','2014-01-01','2013-12-24 12:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:39'),(13860,11059,'N','01','021','EC','A',NULL,NULL,'','0000229432','0000197145','','IL','1','Piecuch','Heidi','','','','34','282884970','2427 BARCLAY MESSERLY RD',0,'SOUTHINGTON','OH','44470','9740','CY','39155','1974-01-15','F','',':RET:2106-3','N','021','HLT','2060525','52664OH151001501','2014-01-01','2013-12-22 21:02:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.78',NULL,0,'2013-12-26 13:12:48'),(14008,11160,'Y','18','021','EC','A','','','AC','0000751018','0000751018','OH00001193494','IL','1','Boitnott','Melissa','','','','34','294762476','2830 Hamilton Mason Rd',0,'Hamilton','OH','45011',NULL,'CY','39017','1968-07-13','F','M',':RET:2106-3','N','021','HLT','2296047','92036OH001001201','2014-01-01','2013-12-23 11:53:25','369.00',NULL,NULL,'762.32','393.32','R-OH004','OH0','373.92',NULL,0,'2013-12-26 13:16:17'),(14902,11904,'Y','18','021','EC','A','','','AC','0000414705','0000414705','OH00001085803','IL','1','PATEL','SHILPA','','','','34','274179638','10411 GRANGER RD',0,'GARFIELD HEIGHTS','OH','44125','3109','CY','39035','1988-08-26','F','U',NULL,'N','021','DEN','1476620','99734OH005000301','2014-02-01','2013-12-28 22:26:20','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-30 00:01:09'),(15355,12283,'N','19','021','EC','A',NULL,NULL,'','0000377471','0000265247','','IL','1','Toalston','Angus','A','','','34','286133514','5069 Apollo Rd NE',0,'Salineville','OH','43945',NULL,'CY','39019','2007-09-14','M','',':RET:2106-3','N','021','DEN','1934105','99734OH005000301','2014-02-01','2013-12-31 23:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:24:40'),(15998,12804,'Y','18','021','EC','A','','','AC','0000783872','0000783872','TX00002025864','IL','1','ISASSI','ALBERT','','','','34','465153433','10115 RACOON DR',0,'EL PASO','TX','79924','4318','CY','48141','1961-10-25','M','M',NULL,'N','021','DEN','2470387','33348TX002000201','2014-02-01','2014-01-03 14:12:21','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-04 02:01:25'),(24677,19586,'Y','18','021','EC','A','','','AC','0000178090','0000178090','TX00002916522','IL','1','Murphree','Shelly','','','','34','459813320','333 COUNTY ROAD 2592',0,'SHELBYVILLE','TX','75973','2615','CY','48419','1971-12-11','F','U',':RET:2106-3','N','021','DEN','3720135','33348TX002000101','2014-04-01','2014-02-18 21:01:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:29:07'),(27240,21569,'N','01','021','EC','A',NULL,NULL,'','0000301380','0000204057','','IL','1','Blair','Rebecca','','','','34','404291837','102 NORTHAMPTON RD',0,'NATCHEZ','MS','39120','5241','CY','28001','1970-12-02','F','',':RET:2106-3','N','021','DEN','3069944','46300MS002000101','2014-04-01','2014-03-03 15:31:36',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-03 21:31:46'),(28927,22894,'Y','18','021','EC','A','','','AC','0000994032','0000994032','OH00002692561','IL','1','HOLMAN','MARISHA','','','','34','280786771','1008 13TH ST NW',0,'CANTON','OH','44703','1563','CY','39151','1972-01-05','F','U',NULL,'N','021','DEN','4350745','99734OH005000301','2014-04-01','2014-03-10 13:04:24','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-03-10 21:00:35'),(20056,15996,'Y','18','021','EC','A','','','AC','0000394902','0000394902','TX00002150204','IL','1','Hogan','Melanie','','','','34','446823728','323 DAVIS ST N',0,'SULPHUR SPRINGS','TX','75482','2615','CY','48223','1972-08-03','F','U',':RET:2106-3','N','021','DEN','3267566','33348TX002000201','2014-03-01','2014-01-27 11:03:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:08'),(3003,2414,'Y','18','021','EC','A','','','AC','0000789642','0000789642','OH00001099326','IL','1','Deger','Richard','','','','34','159383105','1436 WATERS EDGE DR',0,'AKRON','OH','44313','8635','CY','39153','1951-02-12','M','M',':RET:2106-3','N','021','DEN','2626','99734OH005000301','2014-01-01','2013-12-06 13:42:40','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:17:42'),(3122,2509,'Y','18','021','EC','A','','','AC','0000309399','0000309399','OH00000051841','IL','1','Langworthy','Jeremy','','','','34','276882080','19720 STATE ROUTE 58',0,'WELLINGTON','OH','44090','9434','CY','39093','1979-06-30','M','U',NULL,'N','021','DEN','127648','99734OH005000301','2014-01-01','2013-10-13 13:13:46','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:30:19'),(18879,15041,'Y','18','021','EC','A','','','AC','0001220858','0001220858','LA00001688913','IL','1','Ivey','Adria','','','','34','438117133','1803 8TH AVE',0,'LAKE CHARLES','LA','70601','6605','CY','22019','1970-11-22','F','U',':RET:2054-5','N','021','DEN','2838649','18575LA002000201','2014-03-01','2014-01-16 16:20:59','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-17 03:36:27'),(4849,3841,'Y','18','021','EC','A','','','AC','0000304688','0000304688','OH00000785600','IL','1','brewer','alisha','','','','34','297868151','2609 Chesterhill drive',0,'Cincinnati','OH','45231',NULL,'CY','39061','1981-08-20','F','U',':RET:2106-3','T','021','DEN','242048','99734OH005000401','2014-01-01','2013-11-08 11:29:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:30:18'),(18407,14686,'Y','18','021','EC','A','','','AC','0001075328','0001075328','OH00002320314','IL','1','Menasian','Carey','','','','34','277668885','3016 117TH ST',0,'TOLEDO','OH','43611','2705','CY','39095','1971-03-31','F','M',NULL,'T','021','DEN','2932843','99734OH005000301','2014-02-01','2014-01-15 18:10:23','0.00',NULL,NULL,'87.78','87.78','R-OH001','OH0','0.00',NULL,0,'2014-01-16 08:45:46'),(6814,5405,'Y','18','021','EC','A','','','AC','0000449829','0000449829','OH00000565913','IL','1','Trainer Smas','Ashley','','','','34','300868807','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','1980-08-28','F','M',':RET:2106-3','N','021','HLT','629212','52664OH151001305','2014-01-01','2013-11-13 22:31:32','288.00',NULL,NULL,'822.90','534.90','R-OH012','OH0','267.16',NULL,0,'2013-12-26 01:30:23'),(18203,14528,'N','01','021','EC','A',NULL,NULL,'','0000964638','0000891832','','IL','1','shaferly','michael','david','','','34','289844118','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','1972-10-13','M','',':RET:2106-3','N','021','HLT','2743747','92036OH002001501','2014-02-01','2014-01-14 12:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','330.92',NULL,0,'2014-01-15 02:08:07'),(15894,12727,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00001493307','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','1389263','52664OH152000901','2014-02-01','2014-01-01 18:47:41','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,0,'2014-01-03 02:05:50'),(17471,13969,'N','19','021','EC','A',NULL,NULL,'','0000268919','0000447490','','IL','1','Saxton','Travis','','','','34','269061699','4287 mahoning rd',0,'Diamond','OH','44412',NULL,'CY','39133','2000-09-15','M','',':RET:2106-3','N','021','DEN','1625084','99734OH005000301','2014-02-01','2014-01-12 16:27:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:07'),(9514,7545,'Y','18','021','EC','A','','','AC','0000745432','0000745432','OH00000160596','IL','1','Korner','James','','','','34','301566765','812 S SANDUSKY AVE',0,'BUCYRUS','OH','44820','2665','CY','39033','1959-05-17','M','U',':RET:2106-3','N','021','DEN','1866573','99734OH005000401','2014-01-01','2013-12-21 17:45:15','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-26 04:35:28'),(13478,10748,'N','19','021','EC','A',NULL,NULL,'','0000771441','0001246937','','IL','1','rawal','Manav','','','','34','294138202','4998 SHADY CREST AVE NW',0,'MASSILLON','OH','44646','9554','CY','39151','2008-03-07','M','',':RET:2029-7','N','021','DEN','2193469','99734OH005000301','2014-01-01','2013-12-23 17:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:10'),(20505,16383,'Y','18','021','EC','A','','','AC','0001981888','0001981888','LA00001898186','IL','1','johnson','george','','','','34','322681624','13267 CURRAN RD',0,'NEW ORLEANS','LA','70128','1449','CY','22071','1966-05-16','M','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','2713881','18575LA002000201','2014-03-01','2014-01-29 16:25:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:15'),(25995,20616,'Y','18','021','EC','A','','','AC','0000296521','0000296521','MS00002750140','IL','1','Jackson','Anthony','','','','34','426379017','107 Suzanne Cove',0,'Clinton','MS','39056',NULL,'CY','28049','1974-02-02','M','U',':RET:2054-5','N','021','DEN','3212268','46300MS002000201','2014-04-01','2014-02-26 16:44:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:59'),(19011,15139,'N','01','021','EC','A',NULL,NULL,'','0001640013','0001624870','','IL','1','Leary','Terry','Lynn','','','34','434379044','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1971-01-12','F','',':RET:2054-5','N','021','DEN','1433763','18575LA002000201','2014-03-01','2014-01-17 12:04:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-20 08:06:20'),(1146,944,'Y','18','021','EC','A','','','AC','0001048122','0001048122','LA00000912694','IL','1','reeves','laurie','','','','34','220869031','363 WHIPPOORWILL RD',0,'DERIDDER','LA','70634','7123','CY','22011','1965-03-20','F','M',':RET:2106-3','N','021','DEN','1113200','18575LA002000201','2014-01-01','2013-12-03 13:46:02','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 18:18:28'),(9265,7349,'Y','18','021','EC','A','','','AC','0000179927','0000179927','MS00000391588','IL','1','Flynn','Daniel','James','','III','34','561845188','10541 COLLINSVILLE MARTIN RD',0,'COLLINSVILLE','MS','39325','9378','CY','28075','1950-06-01','M','U',':RET:2106-3','N','021','DEN','780121','46300MS002000201','2014-01-01','2013-11-30 14:36:28','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 04:15:27'),(23167,18470,'Y','18','021','EC','A','','','AC','0000567775','0000567775','TX00002604888','IL','1','KISHKIN','TOMMY','','','','34','642198045','12970 AMBROSE DR',0,'FRISCO','TX','75035',NULL,'CY','48085','1974-10-07','M','M',':RET:2106-3','N','021','DEN','2852629','33348TX002000101','2014-03-01','2014-02-12 16:18:27','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-02-12 21:31:50'),(22155,17684,'N','19','021','EC','A',NULL,NULL,'','0000237617','0000149384','','IL','1','Kuhn','Julia','','','','34','286153076','838 OLD MILL DR',0,'LOVELAND','OH','45140','8077','CY','39025','2008-04-14','F','',':RET:2034-7','N','021','HLT','3338375','92036OH004000601','2014-03-01','2014-02-08 10:32:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-08 19:00:56'),(1875,1531,'Y','18','021','EC','A','','','AC','0000746892','0000746892','OH00000093177','IL','1','Drodouski','James','','','','34','297529374','3718 SHAFFER RD',0,'ROCK CREEK','OH','44084','9728','CY','39007','1952-01-17','M','M',':RET:2106-3','N','021','HLT','1722112','52664OH152000901','2014-01-01','2013-12-24 17:01:20','515.00',NULL,NULL,'517.67','2.67','R-OH011','OH0','517.67',NULL,0,'2013-12-25 18:58:23'),(7558,5982,'Y','18','021','EC','A','','','AC','0000532083','0000532083','OH00000393152','IL','1','Siefert','Rickie','','','','34','290524158','2024 SANDOWN RD',0,'TOLEDO','OH','43615','3334','CY','39095','1951-07-31','M','U',':RET:2106-3','N','021','HLT','603816','92036OH004002601','2014-01-01','2013-12-14 22:31:44','317.00',NULL,NULL,'450.46','133.46','R-OH001','OH0','450.46',NULL,0,'2013-12-26 02:33:25'),(7325,5804,'Y','18','021','EC','A','','','AC','0001071755','0001071755','OH00000557785','IL','1','Dewiel','Ashley','','','','34','268849324','734 BRITTAIN RD',0,'AKRON','OH','44305','2039','CY','39153','1985-06-21','F','U',':RET:2106-3','N','021','HLT','177406','52664OH152001001','2014-01-01','2013-12-14 10:46:12','0.00',NULL,NULL,'133.27','133.27','R-OH012','OH0','133.27',NULL,0,'2013-12-26 02:03:41'),(4109,3284,'Y','18','024','14','A','','','TE','0000593095','0000593095','','IL','1','Rosales','Amanda','Lee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-07-26','F','',NULL,NULL,NULL,'','1223549','','2013-12-17','2013-12-17 17:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:47:57'),(19742,15734,'Y','18','021','EC','A','','','AC','0001175737','0001175737','OH00001834431','IL','1','PLOTNICK','NEAL','','','','34','294400683','10852 PONDS LN',0,'CINCINNATI','OH','45242',NULL,'CY','39061','1950-04-14','M','U',':RET:2106-3','N','021','HLT','3080581','92036OH005001205','2014-03-01','2014-01-22 21:44:29','471.00',NULL,NULL,'633.70','162.70','R-OH004','OH0','633.70',NULL,0,'2014-01-23 21:01:12'),(23509,18727,'Y','18','021','EC','A','','','AC','0000625303','0000625303','TX00001911697','IL','1','Abernathy','Laurieanne','','','','34','460833658','100 Branch Street',0,'Pittsburg','TX','75686',NULL,'CY','48063','1975-06-15','F','U',':RET:2106-3','N','021','DEN','3341849','33348TX002000101','2014-03-01','2014-02-13 16:50:37','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-13 22:02:13'),(27483,21748,'Y','18','021','EC','A','','','AC','0000830713','0000830713','TX00003296755','IL','1','Cobb','Marilyn','','','','34','379927205','3939 rosemeade 1201',0,'dallas','TX','75287',NULL,'CY','48085','1983-06-17','F','U',':RET:2054-5','N','021','DEN','3938477','33348TX002000101','2014-04-01','2014-03-04 17:34:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-04 21:02:18'),(28009,22164,'Y','18','024','14','A','','','TE','0000468095','0000468095','','IL','1','EMBRY','CURITIA','V',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-07-21','F','',NULL,NULL,NULL,'','1022950','','2014-03-31','2014-03-06 11:27:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-06 21:01:14'),(22847,18230,'Y','18','021','EC','A','','','AC','0000933247','0000933247','OH00001858055','IL','1','SHAFFER','PAULINE','','','','34','283503650','4505 REDD  RD',0,'DELPHOS','OH','45833',NULL,'CY','39003','1951-10-16','F','M',':RET:2106-3','N','021','HLT','3070761','92036OH005001505','2014-03-01','2014-02-11 11:25:50','1199.00',NULL,NULL,'1281.98','82.98','R-OH002','OH0','632.30',NULL,0,'2014-02-11 21:02:18'),(22441,17918,'Y','18','021','EC','A','','','AC','0000024782','0000024782','TX00001617091','IL','1','GARZA','GUADALUPE','','','','34','459597780','708 E SAN ANTONIO AVE',0,'PHARR','TX','78577','3428','CY','48215','1973-12-28','F','U',NULL,'N','021','DEN','3376514','33348TX002000201','2014-03-01','2014-02-10 13:10:40','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-10 21:30:42'),(15452,12365,'Y','18','021','EC','A','','','AC','0000976493','0000976493','TX00000101490','31','1','Cardenas','Javier','','','','34','457676515','Po box 1486',0,'Santa Rosa','TX','78593',NULL,'CY','48061','1982-09-08','M','M',NULL,'N','021','DEN','2040938','33348TX002000201','2014-02-01','2013-12-31 15:52:31','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,1,'2014-01-02 04:28:25'),(24250,19255,'Y','18','021','EC','A','','','AC','0001459180','0001459180','LA00002642181','IL','1','LOPEZ','CONCION','','','','34','548917705','4462 PLUM GROVE RD',0,'PIONEER','LA','71266','7622','CY','22123','1963-12-08','M','M',NULL,'N','021','DEN','3099594','18575LA002000101','2014-04-01','2014-02-16 14:49:09','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-16 19:00:43'),(27951,22111,'Y','18','021','EC','A','','','AC','0001035644','0001035644','TX00002808137','IL','1','THOMAS','MICHEAL','','','','34','640100593','null ROUTE 2',0,'SAN AUGUSTINE','TX','75972','0001','CY','48405','1986-04-16','M','U',':RET:2054-5','T','021','DEN','3580727','33348TX002000201','2014-04-01','2014-03-06 16:56:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:38'),(20709,16547,'N','19','021','EC','A',NULL,NULL,'','0002316275','0001827225','','IL','1','SINGLETON','SHAINA','','','','34','434818371','54915 TASSIN DR',0,'WHITE CASTLE','LA','70788',NULL,'CY','22047','1991-01-06','F','',NULL,'N','021','DEN','3332844','18575LA002000201','2014-03-01','2014-01-30 13:10:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-30 21:01:07'),(9105,7228,'Y','18','024','14','A','','','TE','0000418863','0000418863','','IL','1','HENRY','LLOYD',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-06','M','',NULL,NULL,NULL,'','1098011','','2013-12-18','2013-12-18 15:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:07:30'),(15036,12018,'Y','18','021','EC','A','','','AC','0001766754','0001766754','LA00000017989','IL','1','LAVIGNE','CASHMIR','','','','34','434791594','2485 LYNNBROOK DR',0,'HARVEY','LA','70058','2130','CY','22051','1985-08-21','F','M',':RET:2054-5','N','021','DEN','2095339','18575LA002000201','2014-02-01','2013-12-30 11:59:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:46'),(14310,11415,'Y','18','021','EC','A','','','AC','0000399894','0000399894','OH00000553490','IL','1','Green','Angela','','','','34','278840124','PO Box 332',0,'Republic','OH','44867',NULL,'CY','39147','1974-09-19','F','M',NULL,'T','021','HLT','1656723','92036OH003002706','2014-02-01','2013-12-26 11:05:58','652.00',NULL,NULL,'794.69','142.69','R-OH006','OH0','295.53',NULL,0,'2013-12-27 02:07:02'),(6648,5275,'Y','18','021','EC','A','','','AC','0000736481','0000736481','OH00000415319','IL','1','Waugh','Jennifer','','','','34','590600500','6853 CLUBSIDE DR',0,'LOVELAND','OH','45140','6040','CY','39025','1980-02-29','F','M',NULL,'N','021','HLT','830523','92036OH004000601','2014-01-01','2013-11-12 12:13:16','127.00',NULL,NULL,'636.92','509.92','R-OH005','OH0','206.78',NULL,0,'2013-12-26 01:00:31'),(6329,5018,'Y','18','021','EC','A','','','AC','0000831976','0000831976','OH00000271204','IL','1','McDowall','Candeus','','','','34','296786971','8229 LARAMIE PL',0,'POWELL','OH','43065','9249','CY','39049','1966-07-31','F','U',':RET:2106-3','N','021','DEN','480274','99734OH005000401','2014-01-01','2013-12-11 11:31:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:33'),(13864,11061,'N','01','021','EC','A',NULL,NULL,'','0001127991','0000650771','','IL','1','Davis','Jack','E','','','34','291789708','2542 RANFIELD RD',0,'MOGADORE','OH','44260','9457','CY','39133','1970-08-04','M','',':RET:2106-3','N','021','HLT','1864308','52664OH151001501','2014-01-01','2013-12-22 23:20:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','362.95',NULL,0,'2013-12-26 13:12:53'),(1477,1231,'Y','18','021','EC','A','','','AC','0001018237','0001018237','OH00000901479','31','1','Onyeaghor','Christopher','N','','','34','281883421','PO Box 10198',0,'Columbus','OH','43201',NULL,'CY','39049','1987-11-09','M','U',':RET:2054-5','N','021','DEN','1377019','99734OH005000401','2014-01-01','2013-12-24 10:03:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:42'),(3366,2697,'Y','18','021','EC','A','','','AC','0000977556','0000977556','TX00000906767','IL','1','GOMEZ','MARIA','','','','34','263674589','434 West Sonora',0,'Raymondville','TX','78580',NULL,'CY','48489','1962-04-01','F','M',':RET:2106-3','N','021','DEN','2395320','33348TX002000201','2014-01-01','2013-12-22 14:13:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:06'),(24063,19135,'Y','18','021','EC','A','','','AC','0000021431','0000021431','OH00002933491','IL','1','Homeyer','Keith','','','','34','282924242','2930 DEBRECK AVE',0,'CINCINNATI','OH','45211','7804','CY','39061','1986-07-25','M','U',':RET:2106-3','T','021','DEN','2842984','99734OH005000301','2014-03-01','2014-02-15 14:13:02','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:01:10'),(25052,19866,'Y','18','021','EC','A','','','AC','0000972790','0000972790','OH00002356436','IL','1','Burnette','Robin','','','','34','281944970','2157 Haviland Dr.',0,'Columbus','OH','43207',NULL,'CY','39049','1989-05-28','F','U',':RET:2106-3','N','021','DEN','3136127','99734OH005000401','2014-04-01','2014-02-19 22:31:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 22:01:17'),(25847,20490,'Y','18','021','EC','A','','','AC','0000063759','0000063759','OH00001864563','IL','1','Johns','Jane',NULL,NULL,NULL,NULL,NULL,'5251 COREY HUNT RD',0,'BRISTOLVILLE','OH','44402','9627','CY','39155','1956-12-23','F','M',':RET:2106-3','N','021','HLT','2949227','52664OH152000901','2014-03-01','2014-02-26 15:00:21','317.00',NULL,NULL,'451.41','134.41','R-OH013','OH0','451.41',NULL,0,'2014-02-26 21:00:38'),(25908,20543,'Y','18','021','EC','A','','','AC','0000324336','0000324336','TX00002207778','31','1','Canava','Pedro','','','','34','455574639','PO Box 275',0,'Anton','TX','79313',NULL,'CY','48303','1968-07-08','M','U',NULL,'N','021','DEN','3102140','33348TX002000201','2014-04-01','2014-02-26 14:30:24','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-26 21:01:12'),(18343,14646,'N','01','021','EC','A',NULL,NULL,'','0000064914','0000282042','','IL','1','BROWNING','MISTY','N','','','34','291804601','21 STATE ROUTE 56 SW',0,'LONDON','OH','43140',NULL,'CY','39097','1981-10-06','F','',NULL,'N','021','DEN','2042543','99734OH005000401','2014-02-01','2014-01-15 18:13:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:18'),(21807,17415,'Y','18','021','EC','A','','','AC','0000117833','0000117833','OH00001601751','IL','1','Bianco','Thomas','','','','34','269864117','2598 HIDDEN SPRING LN',0,'WADSWORTH','OH','44281','8456','CY','39103','1985-07-11','M','U',':RET:2106-3','N','021','HLT','3296624','52664OH151001306','2014-03-01','2014-02-06 15:22:29','170.00',NULL,NULL,'242.41','72.41','R-OH012','OH0','242.41',NULL,0,'2014-02-06 21:00:52'),(563,462,'Y','18','021','EC','A','','','AC','0000643203','0000643203','OH00001200280','IL','1','Frisch','Sandra','','','','34','297662347','371 BENNER ST',0,'TIFFIN','OH','44883','2708','CY','39147','1967-03-07','F','M',':RET:2106-3','N','021','HLT','207305','92036OH004002701','2014-01-01','2013-12-04 14:45:40','0.00',NULL,NULL,'235.18','235.18','R-OH006','OH0','235.18',NULL,0,'2013-12-25 17:50:23'),(8148,6445,'Y','18','021','EC','A','','','AC','0000484156','0000484156','TX00001168071','IL','1','Sowders','Dianne','','','','34','439905602','18642 CLOVER PATH',0,'PORTER','TX','77365','6726','CY','48339','1950-10-14','F','U',':RET:2054-5','N','021','DEN','408135','33348TX002000101','2014-01-01','2013-11-22 16:40:46','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 03:15:57'),(17340,13871,'Y','18','021','EC','A','','','AC','0000260613','0000260613','MS00001674808','IL','1','walker','kenneth','','','','34','427677532','101 ELISE RD',0,'BRANDON','MS','39047','9102','CY','28121','1986-05-08','M','U',':RET:2054-5','N','021','DEN','1490180','46300MS002000201','2014-02-01','2014-01-09 18:46:28','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:24:02'),(5012,3972,'N','19','021','EC','A',NULL,NULL,'','0000581452','0000524460','','IL','1','watkins','michael','','','','34','276929674','4816 forest glen trail',0,'ravenna','OH','44266',NULL,'CY','39133','1990-05-08','M','',':RET:2106-3','N','021','DEN','598783','99734OH005000301','2014-01-01','2013-12-07 17:19:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:20'),(1456,1213,'N','01','021','EC','A',NULL,NULL,'','0000763526','0000895712','','IL','1','Pamphilis','Phillip','','','','34','291629461','4801 SPRUCEWOOD ST',0,'AVON','OH','44011','2716','CY','39093','1958-05-19','M','',':RET:2106-3','N','021','DEN','2219502','99734OH005000401','2014-01-01','2013-12-24 08:03:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:11'),(2265,1852,'N','19','021','EC','A',NULL,NULL,'','0000017600','0000598726','','IL','1','Blank','Hannah','Maria','','','34','300066521','11082 Sage creek drive',0,'Galena','OH','43021',NULL,'CY','39041','2000-12-07','F','',':RET:2106-3','N','021','DEN','761032','99734OH005000301','2014-01-01','2013-12-09 09:27:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:17'),(7418,5870,'Y','18','021','EC','A','','','AC','0000784317','0000784317','OH00000696780','IL','1','Ivory','Patricia','','','','34','282881117','3420 Wonderview Drive',0,'Dayton','OH','45414',NULL,'CY','39113','1980-10-07','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','485023','99734OH005000401','2014-01-01','2013-10-28 16:40:34','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:16:56'),(3515,2824,'Y','18','021','EC','A','','','AC','0000245358','0000245358','MS00000733412','IL','1','Goldstein','Robert','','','','34','125622712','123 Road 960',0,'Tupelo','MS','38804',NULL,'CY','28081','1979-09-18','M','M',':RET:2106-3','N','021','DEN','1950099','46300MS002000201','2014-01-01','2013-12-22 12:16:38','0.00',NULL,NULL,'15.85','15.85','R-MS002','MS0','15.85',NULL,0,'2013-12-25 21:21:07'),(6435,5103,'Y','18','021','EC','A','','','AC','0000923227','0000923227','LA00001177118','IL','1','Casby','Fred','','','','34','433113802','6108 Singleton Dr.',0,'Marrero','LA','70072',NULL,'CY','22051','1958-02-14','M','U',':RET:2054-5','N','021','DEN','1215517','18575LA002000201','2014-01-01','2013-12-11 14:45:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:49:16'),(26247,20817,'Y','18','024','14','A','','','TE','0000978937','0000978937','','IL','1','Bonner','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-24','F','',NULL,NULL,NULL,'','2919548','','2014-02-27','2014-02-27 12:29:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:07'),(27646,21868,'Y','18','021','EC','A','','','AC','0000362559','0000362559','OH00002510696','IL','1','McConnell','Margaret','','','','34','207668856','524 Sandpiper Lane',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-03-25','F','U',':RET:2106-3','N','021','DEN','3680186','99734OH005000401','2014-04-01','2014-03-05 13:01:20','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:19'),(23733,18896,'Y','18','021','EC','A','','','AC','0001171928','0001171928','OH00001960940','IL','1','SIMS','ASHLEY','','','','34','292802788','13425 CROSSBURN AVE',0,'CLEVELAND','OH','44135','5025','CY','39035','1983-09-09','F','U',NULL,'N','021','DEN','3266827','99734OH005000301','2014-03-01','2014-02-13 19:50:06','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:30:59'),(22163,17687,'N','01','021','EC','A',NULL,NULL,'','0001246982','0001078934','','IL','1','Hartwig','Emily','A','','','34','288901436','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','1985-06-01','F','',':RET:2106-3','N','021','HLT','3385475','92036OH005001201','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.35',NULL,0,'2014-02-08 19:00:59'),(9546,7565,'Y','18','021','EC','A','','','AC','0000461930','0000461930','OH00000342133','IL','1','Dudley','Theresa','','','','34','286649623','5652 viewpointe drive',0,'Cincinnati','OH','45213',NULL,'CY','39061','1960-04-24','F','U',':RET:2054-5','N','021','DEN','1708022','99734OH005000301','2014-01-01','2013-12-21 12:09:43','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:09'),(20034,15977,'Y','18','021','EC','A','','','AC','0000283294','0000283294','OH00001930129','IL','1','Smith','Robert','','','','34','569943820','14481 QUARRY RD',0,'OBERLIN','OH','44074','9264','CY','39093','1954-08-19','M','U',':RET:2054-5','N','021','DEN','2676623','99734OH005000301','2014-03-01','2014-01-26 13:28:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-26 19:00:22'),(14585,11640,'Y','18','021','EC','A','','','AC','0000425092','0000425092','OH00000699367','IL','1','Daniel','Katherine','','','','34','295589770','2988 Lakewood Ave.',0,'Lima','OH','45805',NULL,'CY','39003','1965-10-10','F','U',':RET:2054-5','N','021','HLT','1668833','92036OH005001504','2014-02-01','2013-12-26 22:49:42','252.00',NULL,NULL,'359.84','107.84','R-OH002','OH0','359.84',NULL,0,'2013-12-28 03:35:58'),(13010,10369,'Y','18','021','EC','A','','','AC','0000898454','0000898454','OH00000555616','IL','1','Elbeyli','Ahmet','','','','34','293068871','4837 PRINCE CHARLES WAY',0,'HILLIARD','OH','43026','9283','CY','39049','1954-08-21','M','U',':RET:2106-3','N','021','DEN','1578412','99734OH005000401','2014-01-01','2013-12-22 19:53:46','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:49:46'),(23877,18997,'N','01','021','EC','A',NULL,NULL,'','0001066019','0000264239','','IL','1','Simmons','Clifton',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1962-02-12','M','',NULL,'N','021','HLT','3387705','52664OH151001501','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','588.84',NULL,0,'2014-02-14 21:32:12'),(7022,5575,'N','01','021','EC','A',NULL,NULL,'','0000890999','0000794789','','IL','1','SALAHUDEEN','HALEELDEEN','','','','34','066825878','805 CARLETON DR',0,'RICHARDSON','TX','75081','5908','CY','48113','1961-02-19','M','',':RET:2028-9','N','021','DEN','2261579','33348TX002000201','2014-01-01','2013-12-24 21:43:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:48:52'),(20218,16131,'N','01','021','EC','A',NULL,NULL,'','0001008972','0001040883','','IL','1','KINHALT','BRENDA','','','','34','276641073','800 West fork road',0,'STOUT','OH','45684',NULL,'CY','39001','1961-11-08','F','',NULL,'N','021','HLT','2389733','92036OH003000605','2014-03-01','2014-01-27 13:55:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','437.59',NULL,0,'2014-01-27 21:01:42'),(18707,14914,'Y','18','021','EC','A','','','AC','0000695660','0000695660','OH00002493869','IL','1','MacMichael','Robert','','','','34','193447907','8250 Olentangy River Road',0,'Columbus','OH','43235',NULL,'CY','39049','1952-08-07','M','R',':RET:2106-3','T','021','DEN','2705279','99734OH005000301','2014-02-01','2014-01-15 21:08:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-17 03:35:30'),(4591,3636,'Y','18','021','EC','A','','','AC','0000532080','0000532080','OH00000146182','IL','1','Watkins','John','','','','34','283480518','3123 BUTTERCUP AVE',0,'AKRON','OH','44319','3103','CY','39153','1949-06-29','M','M',':RET:2106-3','N','021','HLT','439008','52664OH151001304','2014-01-01','2013-12-12 11:33:58','945.00',NULL,NULL,'1309.70','364.70','R-OH012','OH0','669.00',NULL,0,'2013-12-25 22:05:29'),(18523,14770,'Y','18','021','EC','A','','','AC','0000181968','0000181968','TX00002055991','IL','1','Wilson','Roseina','','','','34','458793849','525 SAINT BARBE ST',0,'HEMPSTEAD','TX','77445','5447','CY','48473','1986-10-24','F','U',NULL,'N','021','DEN','1869944','33348TX002000101','2014-02-01','2014-01-15 13:29:39','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-16 08:46:39'),(18077,14437,'Y','18','021','EC','A','','','AC','0002327418','0002327418','LA00001971189','IL','1','Brierley','Janell','','','','34','436865758','1904 W CONGRESS ST',0,'LAFAYETTE','LA','70506','4434','CY','22055','1960-11-19','F','U',':RET:2106-3','N','021','DEN','2723796','18575LA002000201','2014-02-01','2014-01-14 10:20:55','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-15 02:07:25'),(16401,13123,'Y','18','021','EC','A','','','AC','0000373169','0000373169','TX00000889160','IL','1','Golman','Zachary','','','','34','641223430','11348 CREST BROOK DR',0,'DALLAS','TX','75230','3009','CY','48113','1984-10-25','M','R',':RET:2106-3','N','021','DEN','1528396','33348TX002000201','2014-02-01','2014-01-06 16:31:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:53'),(24163,19198,'N','19','021','EC','A',NULL,NULL,'','0000397390','0000218882','','IL','1','Dressman','Alyssa','','','','34','302027365','3900 ONEIDA ST',0,'STOW','OH','44224','4217','CY','39153','1998-08-12','F','',':RET:2106-3','N','021','HLT','3222274','52664OH151001501','2014-03-01','2014-02-14 20:52:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-15 22:02:05'),(25579,20290,'Y','18','024','14','A','','','TE','0000933848','0000933848','','IL','1','TOON','EUGENIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-03-02','F','',NULL,NULL,NULL,'','532314','','2014-03-31','2014-02-24 14:01:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-26 08:00:36'),(27187,21526,'Y','18','021','EC','A','','','AC','0000512954','0000512954','TX00003031263','IL','1','Dixon','Danna','Thomas','','','34','450020930','770 Meadows Rd.',0,'Poteet','TX','78065',NULL,'CY','48013','1951-01-05','F','M',':RET:2106-3','N','021','DEN','3812590','33348TX002000201','2014-04-01','2014-03-03 15:38:07','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-03 21:31:14'),(28593,22628,'Y','18','021','EC','A','','','AC','0000091225','0000091225','OH00003661288','IL','1','Harmon','Matthew','','','','34','296909780','107 W WILLIAMS AVE',0,'BELLEFONTAINE','OH','43311','2153','CY','39091','1989-12-27','M','U',':RET:2106-3','N','021','DEN','4208898','99734OH005000401','2014-04-01','2014-03-07 23:00:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:30:04'),(22854,18235,'Y','18','021','EC','A','','','AC','0001208353','0001208353','OH00002177922','IL','1','Keiffer','Charles','B','','','34','291763528','1418 S TOWNSHIP ROAD 37',0,'FOSTORIA','OH','44830','9622','CY','39147','1980-08-25','M','M',':RET:2106-3','N','021','HLT','2797614','92036OH003002704','2014-03-01','2014-02-10 22:09:48','328.00',NULL,NULL,'577.70','249.70','R-OH006','OH0','243.94',NULL,0,'2014-02-11 21:02:23'),(7739,6129,'Y','18','021','EC','A','','','AC','0000170151','0000170151','OH00000687627','IL','1','Litvin','Lorraine','','','','34','279786913','121 SHIAWASSEE AVE',0,'FAIRLAWN','OH','44333','3733','CY','39153','1965-11-30','F','U',':RET:2106-3','N','021','DEN','2439287','99734OH005000401','2014-01-01','2013-12-20 15:26:46','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:02:13'),(7544,5970,'Y','18','021','EC','A','','','AC','0000440542','0000440542','TX00000093838','IL','1','Courville','Raegan','','','','34','439771468','11829 PLAINS VALLEY DR',0,'DEL VALLE','TX','78617','3508','CY','48453','1990-03-31','F','U',':RET:2106-3','T','021','DEN','893958','33348TX002000201','2014-01-01','2013-12-15 17:29:38','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 02:33:00'),(6699,5311,'Y','18','021','EC','A','','','AC','0000614068','0000614068','OH00000050816','IL','1','Whitaker','Janet','Ann','','','34','292427145','3383 HAMMERSMITH LN',0,'CINCINNATI','OH','45248','2874','CY','39061','1951-04-12','F','M',':RET:2106-3','N','021','DEN','95616','99734OH005000301','2014-01-01','2013-11-05 14:25:37','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:01:51'),(15677,12539,'N','01','021','EC','A',NULL,NULL,'','0000043240','0001174410','','IL','1','Milefchik','Michael','Christopher','','','34','274741373','322 Wilson Ave',0,'Port Clinton','OH','43452',NULL,'CY','39123','1977-10-21','M','',':RET:2106-3','N','021','HLT','2474421','92036OH004002701','2014-02-01','2013-12-31 16:54:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','192.86',NULL,1,'2014-01-02 04:34:50'),(5128,4064,'Y','18','021','EC','A','','','AC','0001221656','0001221656','TX00001079834','IL','1','Herron','Algernon','','','','34','463699160','4303 Nicholas Court',0,'Grand Prairie','TX','75052',NULL,'CY','48113','1971-08-03','M','R',':RET:2054-5','N','021','DEN','2298223','33348TX002000101','2014-01-01','2013-12-18 19:22:59','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:02:09'),(14479,11552,'N','19','021','EC','A',NULL,NULL,'','0000699469','0000322906','','IL','1','Arredondo','Ana Paula','','','','34','628827119','1403 Camp Craft Rd',0,'Austin','TX','78746',NULL,'CY','48453','1992-12-01','F','',NULL,'N','021','DEN','2265116','33348TX002000201','2014-02-01','2013-12-26 21:31:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-28 03:33:15'),(14471,11546,'N','01','021','EC','A',NULL,NULL,'','0000478205','0000843292','','IL','1','mancine','joanne','j','','','34','007582133','4302 SW 51ST AVE',0,'AMARILLO','TX','79109','6162','CY','48381','1955-08-26','F','',':RET:2106-3','N','021','DEN','2105321','33348TX002000201','2014-02-01','2013-12-26 19:07:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:02'),(9377,7435,'Y','18','021','EC','A','','','AC','0000711968','0000711968','LA00000433406','IL','1','Meche','Janie','','','','34','433314297','219 4TH ST',0,'ABBEVILLE','LA','70510','6649','CY','22113','1962-06-06','F','M',':RET:2106-3','N','021','DEN','2256639','18575LA002000201','2014-01-01','2013-12-21 15:02:47','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 04:31:59'),(25725,20405,'Y','18','021','EC','A','','','AC','0001876910','0001876910','LA00002966347','IL','1','VENIBLE','JERMAINE','','','','34','437373684','6334 WINBOURNE AVE',0,'BATON ROUGE','LA','70805','6271','CY','22033','1978-05-15','M','U',':RET:2054-5','T','021','DEN','2950342','18575LA002000201','2014-04-01','2014-02-24 12:16:44','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-26 09:30:31'),(324,266,'Y','18','021','EC','A','','','AC','0000449828','0000449828','OH00000246575','IL','1','Kneisley','Barbara','E','','','34','281542216','707Ronmar Dr',0,'Defiance','OH','43512',NULL,'CY','39039','1952-05-23','F','M',':RET:2106-3','N','021','HLT','48229','92036OH005002601','2014-01-01','2013-11-13 11:11:36','388.00',NULL,NULL,'547.95','159.95','R-OH001','OH0','547.95',NULL,0,'2013-12-25 17:31:26'),(20693,16534,'N','19','021','EC','A',NULL,NULL,'','0000854219','0000590814','','IL','1','Henry','Lily',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1998-05-26','F','',':RET:2106-3','N','021','DEN','2798559','99734OH005000301','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:59'),(23021,18356,'Y','18','021','EC','A','','','AC','0000986128','0000986128','TX00002196604','31','1','Goldsum','Chris','','','','34','458234068','P O Box 2265',0,'Victoria','TX','77902',NULL,'CY','48469','1958-10-19','M','M',':RET:2106-3','N','021','DEN','3103851','33348TX002000201','2014-03-01','2014-02-11 19:23:08','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-12 21:30:30'),(16836,13467,'Y','18','021','EC','A','','','AC','0000532127','0000532127','OH00001953868','IL','1','Babcock','Matt','','','','34','048845088','414 HILLCREST DR',0,'CINCINNATI','OH','45215','2502','CY','39061','1987-08-23','M','U',NULL,'N','021','HLT','2400794','92036OH005001205','2014-02-01','2014-01-10 22:22:47','127.00',NULL,NULL,'219.82','92.82','R-OH004','OH0','219.82',NULL,0,'2014-01-13 02:18:31'),(13912,11096,'Y','18','021','EC','A','','','AC','0000105367','0000105367','OH00000824481','31','1','Hodgson','Sandra','','','','34','377744997','PO Box 221',0,'Genoa','OH','43430',NULL,'CY','39123','1956-11-21','F','M',':RET:2106-3','N','021','HLT','1560161','92036OH005002704','2014-01-01','2013-12-23 15:10:02','290.00',NULL,NULL,'475.21','185.21','R-OH006','OH0','475.21',NULL,0,'2013-12-26 13:13:58'),(2855,2307,'N','01','021','EC','A',NULL,NULL,'','0000468879','0000467564','','IL','1','Ducote','Roy','','','','34','433042130','16929 HIGHLAND CLUB AVE',0,'BATON ROUGE','LA','70817','7036','CY','22033','1956-06-04','M','',':RET:2106-3','N','021','DEN','384139','18575LA002000201','2014-01-01','2013-11-01 21:13:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:01:29'),(28906,22880,'Y','18','024','14','A','','','TE','0000627591','0000627591','','IL','1','Castillo','Jose',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-12-13','M','',NULL,NULL,NULL,'','3582172','','2014-03-10','2014-03-10 17:51:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-10 21:00:24'),(450,370,'Y','18','021','EC','A','','','AC','0000001005','0000001005','OH00001254916','IL','1','smith','jason','','','','34','281781963','2110 PLEASANT HILL RD',0,'MARION','OH','43302','9474','CY','39101','1976-01-27','M','M',':RET:2106-3','T','021','DEN','630463','99734OH005000401','2014-01-01','2013-12-04 17:54:09','0.00',NULL,NULL,'71.95','71.95','R-OH008','OH0','0.00',NULL,0,'2013-12-25 17:47:24'),(9470,7512,'Y','18','021','EC','A','','','AC','0000142824','0000142824','OH00000438992','IL','1','Smith','Bryant','','','','34','272464219','2674 KNIGHT AVE',0,'CINCINNATI','OH','45212','1314','CY','39061','1950-07-15','M','M',NULL,'N','021','DEN','1417282','99734OH005000401','2014-01-01','2013-12-21 10:40:59','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:25'),(19162,15266,'N','01','021','EC','A',NULL,NULL,'','0001003330','0000214681','','IL','1','Waggoner','Teresa','','','','34','288683984','150 BRINKER ST',0,'BELLEVUE','OH','44811','1502','CY','39077','1961-03-14','F','',NULL,'N','021','HLT','2590735','92036OH003002705','2014-03-01','2014-01-19 00:13:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','397.49',NULL,0,'2014-01-21 08:45:42'),(6390,5067,'Y','18','021','EC','A','','','AC','0000566593','0000566593','OH00000209854','IL','1','ABBOTT','RICHARD','DREW','','','34','261318899','1917 TILDEN AVE',0,'CINCINNATI','OH','45212','2519','CY','39061','1962-01-20','M','U',':RET:2106-3','N','021','DEN','1187027','99734OH005000301','2014-01-01','2013-12-11 11:44:38','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:48:10'),(2918,2352,'Y','18','021','EC','A','','','AC','0000898429','0000898429','OH00001306053','IL','1','Evans','Paula','','','','34','450113370','2 PROMONT CT',0,'MILFORD','OH','45150','1762','CY','39025','1954-04-19','F','R',':RET:2106-3','N','021','DEN','978517','99734OH005000401','2014-01-01','2013-12-06 17:05:32','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 20:15:42'),(3374,2704,'Y','18','021','EC','A','','','AC','0000654021','0000654021','TX00000285323','IL','1','Ward','Christopher','','','','34','560775200','435 N SWANSON RD',0,'MINERAL WELLS','TX','76067','0622','CY','48363','1977-06-15','M','R',':RET:2106-3','N','021','DEN','2324296','33348TX002000201','2014-01-01','2013-12-22 16:53:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:20'),(5379,4266,'Y','18','021','EC','A','','','AC','0001936871','0001936871','LA00001223088','IL','1','PERRY','IVY','','','','34','547152298','638 WYANDOTTE STREET',0,'SHREVEPORT','LA','71101',NULL,'CY','22017','1966-05-08','F','U',':RET:2054-5','T','021','DEN','1634409','18575LA002000201','2014-01-01','2013-12-19 15:28:26','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 23:08:18'),(18700,14909,'Y','18','021','EC','A','','','AC','0001418489','0001418489','LA00002273775','31','1','Johnson','Ricka','','','','34','433177889','PO Box 115',0,'Grayson','LA','71435',NULL,'CY','22021','1963-12-14','F','U',NULL,'N','021','DEN','2839767','18575LA002000101','2014-03-01','2014-01-16 17:07:56','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-17 03:35:28'),(15858,12697,'Y','18','021','EC','A','','','AC','0000627881','0000627881','OH00001593507','IL','1','shearer','randall','','','','34','272763670','2405 NORTHWEST BLVD NW',0,'WARREN','OH','44485','2310','CY','39155','1965-05-30','M','U',':RET:2106-3','N','021','HLT','2373628','92036OH004003201','2014-02-01','2014-01-02 10:16:53','272.00',NULL,NULL,'318.22','46.22','R-OH013','OH0','318.22',NULL,0,'2014-01-03 02:04:40'),(14474,11548,'Y','18','021','EC','A','','','AC','0000506704','0000506704','TX00000927914','IL','1','Avila','Veronica','','','','34','342747675','214 S KAUFMAN ST',0,'SEAGOVILLE','TX','75159','3104','CY','48113','1984-10-12','F','U',NULL,'N','021','DEN','1832721','33348TX002000201','2014-02-01','2013-12-26 19:43:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-28 03:33:05'),(24615,19536,'Y','18','021','EC','A','','','AC','0001193435','0001193435','MS00002775262','IL','1','COURSE','JUSTIN','','','','34','425634941','1926 SOUTHWOOD PL',0,'JACKSON','MS','39213','7932','CY','28049','1985-07-02','M','U',NULL,'T','021','DEN','2739305','46300MS002000201','2014-04-01','2014-02-18 20:02:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:14:50'),(27948,22109,'Y','18','021','EC','A','','','AC','0000452002','0000452002','TX00003128217','IL','1','Tobar','Alfredo','M','','','34','520809627','1103 Pecan St',0,'Ozona','TX','76943',NULL,'CY','48105','1957-03-23','M','M',NULL,'N','021','DEN','3400744','33348TX002000201','2014-04-01','2014-03-06 16:21:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:36'),(331,272,'Y','18','021','EC','A','','','AC','0000238996','0000238996','OH00000048676','IL','1','Klaing','Michael','Stuart','','','34','272448661','530 Crawley Run',0,'Centerville','OH','45458',NULL,NULL,NULL,'1950-07-16','M','U',NULL,'N','021','DEN','1080760','99734OH005000401','2014-01-01','2013-10-11 11:18:08','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:31:40'),(7773,6154,'Y','18','021','EC','A','','','AC','0000286960','0000286960','TX00000695003','31','1','esquivel','alma','','','','34','455353873','po box 674',0,'Zapata','TX','78076',NULL,'CY','48505','1970-01-18','F','U',':RET:2106-3','N','021','DEN','2018326','33348TX002000201','2014-01-01','2013-12-19 20:08:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:02:58'),(7307,5791,'Y','18','021','EC','A','','','AC','0000533268','0000533268','OH00000053722','IL','1','EMERUWA','CAROL','','','','34','269544250','3775 BRIDGEVIEW DR',0,'SOUTH EUCLID','OH','44121','1930','CY','39035','1952-10-06','F','U',':RET:2054-5','N','021','HLT','273527','52664OH151001306','2014-01-01','2013-12-14 16:07:21','522.00',NULL,NULL,'706.77','184.77','R-OH011','OH0','706.77',NULL,0,'2013-12-26 02:03:16'),(613,505,'Y','18','021','EC','A','','','AC','0001089539','0001089539','OH00000812558','IL','1','makar','philip','g','','','34','298725236','3001 14TH ST',0,'CUYAHOGA FALLS','OH','44223','2222','CY','39153','1961-09-04','M','U',':RET:2106-3','T','021','DEN','2424957','99734OH005000401','2014-01-01','2013-12-16 10:27:48','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:00:38'),(21815,17420,'N','19','021','EC','A',NULL,NULL,'','0000666797','0000459197','','IL','1','Pryseski','Hannah','Mary','','','34','270985757','63 CASTLE BLVD',0,'AKRON','OH','44313','6528','CY','39153','1994-08-02','F','',':RET:2106-3','N','021','HLT','2650855','52664OH151001305','2014-03-01','2014-02-06 12:52:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-06 21:00:56'),(21611,17255,'Y','18','021','EC','A','','','AC','0000647106','0000647106','OH00002211215','IL','1','Smith','Susan','','','','34','288508649','1611 OAKWOOD AVE',0,'AKRON','OH','44301','2745','CY','39153','1949-06-05','F','U',':RET:2106-3','T','021','DEN','2641336','99734OH005000301','2014-03-01','2014-02-05 15:28:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-05 21:30:34'),(3763,3011,'Y','18','021','EC','A','','','AC','0000049468','0000049468','OH00000921305','31','1','Wright','Kevin','','','','34','282665376','P.O. Box 245',0,'Munroe Falls','OH','44262',NULL,'CY','39153','1959-12-07','M','M',':RET:2106-3','N','021','HLT','26236','52664OH151001305','2014-01-01','2013-12-13 10:59:44','306.00',NULL,NULL,'476.12','170.12','R-OH012','OH0','476.12',NULL,0,'2013-12-25 21:33:28'),(20439,16326,'Y','18','021','EC','A','','','AC','0000404836','0000404836','OH00001907760','IL','1','Mason','Tiffany','','','','34','280867503','2907 ASHLAND AVE',0,'CINCINNATI','OH','45206','1366','CY','39061','1987-06-30','F','U',':RET:2054-5','N','021','DEN','2712787','99734OH005000301','2014-03-01','2014-01-29 17:41:04','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:39'),(15751,12602,'Y','18','021','EC','A','','','AC','0000970859','0000970859','TX00002178183','IL','1','CABRERA','CATARINO','','','','34','453279470','4300 MONREAL RD',0,'EDINBURG','TX','78541','5318','CY','48215','1971-03-25','M','M',NULL,'N','021','DEN','2192387','33348TX002000201','2014-02-01','2014-01-02 16:16:19','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-03 02:01:10'),(18883,15045,'Y','18','021','EC','A','','','AC','0002243480','0002243480','LA00001420551','IL','1','Polk','Danielle','','','','34','436297610','14533 MORA DR',0,'BATON ROUGE','LA','70819','4016','CY','22033','1976-03-26','F','U',NULL,'T','021','DEN','3038786','18575LA002000201','2014-02-01','2014-01-15 19:37:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:29'),(18874,15036,'Y','18','021','EC','A','','','AC','0001192102','0001192102','LA00001586424','IL','1','BRITTON','LATANYA','','','','34','436352540','75 CARRIAGE LANE',0,'DESTREHAN','LA','70047',NULL,'CY','22089','1978-08-18','F','U',':RET:2054-5','N','021','DEN','2442746','18575LA002000201','2014-03-01','2014-01-16 13:53:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:25'),(18696,14905,'Y','18','021','EC','A','','','AC','0001667627','0001667627','LA00001803373','IL','1','Wright','Mary','Elizabeth','','','34','433676969','237 south martin lane',0,'west monroe','LA','71292',NULL,'CY','22073','1972-01-21','F','M',':RET:2106-3','N','021','DEN','1665628','18575LA002000101','2014-03-01','2014-01-16 12:00:14','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-17 03:35:26'),(17573,14051,'Y','18','021','EC','A','','','AC','0001073171','0001073171','OH00002522786','IL','1','Biddle','Pam','','','','34','293564482','230 MIAMI TRCE',0,'HARRISON','OH','45030','5110','CY','39061','1956-02-23','F','M',NULL,'N','021','DEN','1933008','99734OH005000401','2014-02-01','2014-01-13 13:27:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:03'),(17727,14165,'Y','18','021','EC','A','','','AC','0000504488','0000504488','OH00001960210','IL','1','herbell','elizabeth','','','','34','294588300','6075 COMMANCHE CT',0,'CLEVELAND','OH','44130','9051','CY','39035','1965-11-04','F','U',NULL,'N','021','HLT','1483172','52664OH151001306','2014-02-01','2014-01-13 07:35:54','263.00',NULL,NULL,'411.23','148.23','R-OH011','OH0','411.23',NULL,0,'2014-01-14 01:33:17'),(16161,12940,'N','19','021','EC','A',NULL,NULL,'','0000801241','0000232642','','IL','1','Muktar','Alima','','','','34','281159903','1100 RING NECK DR',0,'BLACKLICK','OH','43004','7035','CY','39049','2009-06-28','F','',':RET:2054-5','N','021','DEN','1671017','99734OH005000401','2014-01-01','2013-12-16 22:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 06:00:11'),(2230,1835,'N','01','021','EC','A',NULL,NULL,'','0000921892','0000758240','','IL','1','Macaluso','Sandra','','','','34','285485365','2 CURRY LN',0,'MILFORD','OH','45150','1891','CY','39025','1949-07-08','F','',':RET:2106-3','N','021','HLT','869616','92036OH001000601','2014-01-01','2013-12-10 14:33:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','776.81',NULL,0,'2013-12-25 19:20:46'),(15545,12439,'Y','18','021','EC','A','','','AC','0002038948','0002038948','LA00001643615','IL','1','HOWARD','STELLA','M','','','34','436411932','13031 PONDERS LN',0,'AMITE','LA','70422',NULL,'CY','22105','1964-08-10','F','U',':RET:2054-5','N','021','DEN','1936697','18575LA002000201','2014-02-01','2013-12-31 15:43:35','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:31:06'),(3593,2881,'N','01','021','EC','A',NULL,NULL,'','0001218537','0000093834','','IL','1','davis','teresa','d','','','34','294745384','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1962-12-18','F','',':RET:2106-3','N','021','HLT','2277857','92036OH003001201','2014-01-01','2013-12-22 10:38:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','418.11',NULL,0,'2013-12-25 21:23:03'),(5219,4143,'Y','18','021','EC','A','','','AC','0000335153','0000335153','OH00000862081','IL','1','Reyes','Rainier','','','','34','296804793','10210 GLOUCESTER RD',0,'STREETSBORO','OH','44241','4891','CY','39133','1982-02-08','M','U',NULL,'N','021','DEN','2095967','99734OH005000401','2014-01-01','2013-12-19 16:13:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:04:29'),(29120,23053,'Y','18','021','EC','A','','','AC','0000695526','0000695526','MS00002755506','IL','1','Williams','Gloria','','','','34','587347423','350 Debuys Rd',0,'Biloxi','MS','39531',NULL,'CY','28047','1950-02-16','F','U',':RET:2054-5','N','021','DEN','4017516','46300MS002000201','2014-04-01','2014-03-10 15:59:29','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-03-10 21:02:29'),(876,725,'Y','18','021','EC','A','','','AC','0000305823','0000305823','OH00000422070','IL','1','Chadwick','Andrew','','','','34','012704909','17 EDGEWOOD DR',0,'ARCANUM','OH','45304','1431','CY','39037','1975-03-03','M','M',':RET:2106-3','N','021','HLT','1528684','92036OH001000501','2014-01-01','2013-12-16 10:10:01','483.00',NULL,NULL,'730.60','247.60','R-OH003','OH0','357.28',NULL,0,'2013-12-25 18:07:35'),(6980,5539,'Y','18','021','EC','A','','','AC','0000772651','0000772651','OH00001672950','IL','1','Bailey','Jamal','','','','34','160640680','4231 WYANDOTTE WOODS BLVD',0,'DUBLIN','OH','43016','9423','CY','39049','1976-12-27','M','U',':RET:2054-5','N','021','DEN','2098927','99734OH005000401','2014-01-01','2013-12-24 23:54:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:41'),(16934,13552,'Y','18','024','14','A','','','TE','0002389493','0002389493','','IL','1','Dejoie','shondrica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-03-31','F','',NULL,NULL,NULL,'','1735506','','2014-01-08','2014-01-08 21:04:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 02:19:50'),(15208,12154,'Y','18','021','EC','A','','','AC','0000269142','0000269142','MS00001684669','IL','1','Lewis','Mary','','','','34','587325459','2032 Barnes RD',0,'Crystal Springs','MS','39059',NULL,'CY','28029','1951-04-07','F','M',':RET:2106-3','N','021','DEN','1474301','46300MS002000201','2014-02-01','2013-12-30 16:30:52','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-01 12:07:37'),(2453,1995,'Y','18','021','EC','A','','','AC','0000893765','0000893765','TX00000327941','IL','1','PEREZ','BRENDA','','','','34','605623986','1607 PEACH DALE CT.',0,'CONROE','TX','77301',NULL,'CY','48339','1992-09-04','F','U',NULL,'N','021','DEN','673383','33348TX002000101','2014-01-01','2013-12-08 20:53:07','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 19:34:41'),(4755,3770,'Y','18','021','EC','A','','','AC','0001089405','0001089405','TX00000309377','IL','1','ODell','Jerrod','','','','34','463753651','5401 4th St',0,'Lubbock','TX','79416',NULL,'CY','48303','1984-08-21','M','U',NULL,'N','021','DEN','761021','33348TX002000201','2014-01-01','2013-12-08 16:33:43','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 22:15:20'),(18328,14634,'Y','18','024','14','A','','','TE','0000191380','0000191380','','IL','1','Catania','Catherine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-01-31','F','',NULL,NULL,NULL,'','1602182','','2014-01-15','2014-01-15 13:43:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:11'),(20071,16010,'Y','18','021','EC','A','','','AC','0001105156','0001105156','TX00002012331','IL','1','Montes','Gracie','','','','34','628108131','2313 GENE LITTLER DR',0,'EL PASO','TX','79936','2707','CY','48141','1989-04-23','F','U',':RET:2106-3','N','021','DEN','2724063','33348TX002000201','2014-03-01','2014-01-27 14:11:53','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-27 21:00:17'),(20114,16048,'Y','18','021','EC','A','','','AC','0000287124','0000287124','OH00002465065','IL','1','Weaver','Tamra','','','','34','268963647','7151 CABOT LN',0,'CHAGRIN FALLS','OH','44022','2649','CY','39055','1989-02-01','F','U',':RET:2106-3','N','021','DEN','3301289','99734OH005000401','2014-03-01','2014-01-26 20:43:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:00:42'),(22275,17780,'Y','18','021','EC','A','','','AC','0000333149','0000333149','TX00002512635','IL','1','VASQUEZ','FRANCISCO','','','','34','457319767','898 W 10TH ST',0,'YORKTOWN','TX','78164','5281','CY','48123','1970-07-27','M','U',NULL,'T','021','DEN','2827958','33348TX002000201','2014-03-01','2014-01-27 09:48:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:17'),(23945,19039,'Y','18','021','EC','A','','','AC','0002277357','0002277357','LA00002425639','IL','1','Bucalan','Normita','','','','34','436755264','4005 W LOUISIANA STATE DR',0,'KENNER','LA','70065','1603','CY','22051','1962-12-15','F','U',':RET:2028-9','N','021','DEN','3377827','18575LA002000201','2014-03-01','2014-02-14 18:03:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-15 21:00:11'),(24572,19511,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000317383','','IL','1','ONWUAGBA','CHUKWUEBUKA','','','','34','284110056','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1998-05-26','M','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:07:32'),(27999,22155,'Y','18','021','EC','A','','','AC','0000054528','0000054528','OH00002953445','IL','1','Earhart','Robert','','','','34','285804583','4360 KALAMA CT',0,'CINCINNATI','OH','45236','3714','CY','39061','1983-04-28','M','M',':RET:2106-3','N','021','DEN','3904985','99734OH005000401','2014-04-01','2014-03-05 19:59:00','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:07'),(28694,22708,'Y','18','021','EC','A','','','AC','0001743857','0001743857','LA00003426937','IL','1','TAYLOR','PEGGY','','','','34','436042963','24655 PECAN PL',0,'PLAQUEMINE','LA','70764','3804','CY','22047','1955-05-21','F','U',':RET:2054-5','N','021','DEN','3395951','18575LA002000101','2014-04-01','2014-03-08 11:55:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-08 21:31:05'),(8123,6425,'Y','18','021','EC','A','','','AC','0000950644','0000950644','OH00001055778','IL','1','JANSON','LINDA','','','','34','276448198','4383 W 180TH ST',0,'CLEVELAND','OH','44135','3820','CY','39035','1950-08-03','F','U',':RET:2106-3','N','021','DEN','292227','99734OH005000401','2014-01-01','2013-11-22 12:27:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:15:19'),(17961,14352,'Y','18','024','14','A','','','TE','0000717401','0000717401','','IL','1','arias','lupe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-17','F','',NULL,NULL,NULL,'','1824411','','2014-01-14','2014-01-14 18:32:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:46'),(5583,4428,'Y','18','021','EC','A','','','AC','0000327236','0000327236','OH00000383303','IL','1','Ries','Janelle','','','','34','279504631','12795 SHONDEL RD',0,'RITTMAN','OH','44270','9513','CY','39169','1950-08-18','F','U',':RET:2106-3','N','021','HLT','1122321','52664OH151001501','2014-01-01','2013-11-06 11:41:37','526.00',NULL,NULL,'789.56','263.56','R-OH014','OH0','789.56',NULL,0,'2013-12-25 23:17:00'),(14625,11673,'Y','18','021','EC','A','','','AC','0000357204','0000357204','OH00000649463','IL','1','Koester','Jennifer','','','','34','290765264','6081 N. Martin Williston Rd',0,'Williston','OH','43468',NULL,'CY','39123','1980-03-01','F','M',':RET:2106-3','T','021','HLT','1617692','92036OH001002701','2014-02-01','2013-12-27 11:45:03','378.00',NULL,NULL,'701.91','323.91','R-OH006','OH0','324.03',NULL,0,'2013-12-28 03:37:02'),(13582,10832,'Y','18','021','EC','A','','','AC','0001767779','0001767779','LA00000100093','IL','1','howe','heather','','','','34','433796039','po box 2018',0,'reserve','LA','70084',NULL,'CY','22095','1990-03-17','F','U',':RET:2106-3','N','021','DEN','1563680','18575LA002000201','2014-01-01','2013-12-23 18:21:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:55'),(9519,7549,'N','01','021','EC','A',NULL,NULL,'','0000654590','0000455304','','IL','1','STOFF','CHRISTINE','A','','','34','284587279','2833 FERNCLIFF AVE',0,'DAYTON','OH','45420','3201','CY','39113','1962-07-11','F','',':RET:2106-3','T','021','DEN','1945323','99734OH005000301','2014-01-01','2013-12-20 19:14:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:36'),(5431,4313,'Y','18','021','EC','A','','','AC','0002239319','0002239319','LA00001219173','IL','1','Nguyen','Aaron','','','','34','066767210','104 BOBBIE ST',0,'ABBEVILLE','LA','70510','5506','CY','22113','1978-08-31','M','M',':RET:2047-9','N','021','DEN','2431866','18575LA002000101','2014-01-01','2013-12-19 14:44:48','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 23:09:39'),(19321,15402,'Y','18','021','EC','A','','','AC','0000655563','0000655563','TX00001514022','IL','1','Cox','Terrall','','','','34','465253009','810 CARLISLE AVE',0,'KILLEEN','TX','76541','7314','CY','48027','1958-08-18','M','U',':RET:2106-3','N','021','DEN','2291440','33348TX002000201','2014-03-01','2014-01-21 11:37:46','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,1,'2014-01-22 03:22:11'),(21700,17328,'Y','18','021','EC','A','','','AC','0000226592','0000226592','MS00001804831','IL','1','Murrell','Katherine','','','','34','428577806','412 NORTHSIDE CIR',0,'JACKSON','MS','39206','4607','CY','28049','1980-06-18','F','U',':RET:2054-5','N','021','DEN','3197387','46300MS002000201','2014-03-01','2014-02-04 21:00:51','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-05 21:31:10'),(22765,18176,'Y','18','021','EC','A','','','AC','0000910560','0000910560','OH00002156680','IL','1','GALLEDOU','BAKARY','','','','34','093808734','3659 EMERY CLUB WAY',0,'COLUMBUS','OH','43219','3160','CY','39049','1960-01-01','M','M',':RET:2054-5','N','021','DEN','3211853','99734OH005000401','2014-03-01','2014-02-11 11:32:03','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-11 21:01:35'),(28290,22385,'Y','18','024','14','A','','','TE','0001060977','0001060977','','IL','1','Britenriker','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-08','M','',NULL,NULL,NULL,'','4120839','','2014-03-07','2014-03-07 14:30:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:28'),(6859,5439,'Y','18','021','EC','A','','','AC','0000082525','0000082525','OH00000979376','IL','1','Bolin-Devore','Tenaya','Erica','','','34','302725611','1300 4TH ST',0,'LOGAN','OH','43138','1049','CY','39073','1969-05-13','F','U',NULL,'N','021','DEN','621696','99734OH005000401','2014-01-01','2013-10-05 12:01:16','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2013-12-26 01:31:38'),(1804,1482,'Y','18','021','EC','A','','','AC','0000775098','0000775098','OH00000258910','IL','1','morris','julia','','','','34','513378642','2335 INDIAN MOUND AVE',0,'NORWOOD','OH','45212','1763','CY','39061','1958-05-26','F','U',':RET:2106-3','N','021','HLT','1961694','92036OH004001201','2014-01-01','2013-12-24 12:18:23','131.00',NULL,NULL,'384.93','253.93','R-OH004','OH0','384.93',NULL,0,'2013-12-25 18:56:51'),(6824,5410,'Y','18','021','EC','A','','','AC','0001169407','0001169407','OH00000215694','IL','1','Trainer Smas','Ashley','','','','34','300868807','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','1980-08-28','F','M',':RET:2106-3','N','021','DEN','1156560','99734OH005000301','2014-01-01','2013-11-13 22:31:32','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:30:37'),(13909,11094,'Y','18','021','EC','A','','','AC','0000062535','0000062535','OH00001012971','IL','1','Skinner','Joan',NULL,NULL,NULL,NULL,NULL,'253 Jackson st.',0,'Elmore','OH','43416',NULL,'CY','39123','1953-11-21','F','U',':RET:2106-3','N','021','HLT','2336091','92036OH005002705','2014-01-01','2013-12-23 13:41:38','450.00',NULL,NULL,'529.21','79.21','R-OH006','OH0','529.21',NULL,0,'2013-12-26 13:13:54'),(4586,3631,'Y','18','021','EC','A','','','AC','0000569289','0000569289','OH00001258074','IL','1','HAYES','RONALD','DEAN','','','34','307640294','92 TIMOTHY AVE',0,'CUYAHOGA FALLS','OH','44223',NULL,'CY','39153','1955-05-30','M','U',':RET:2106-3','N','021','HLT','55348','52664OH151001305','2014-01-01','2013-12-12 10:10:35','440.00',NULL,NULL,'568.22','128.22','R-OH012','OH0','568.22',NULL,0,'2013-12-25 22:05:20'),(13075,10423,'Y','18','024','14','A','','','TE','0000995428','0000995428','','IL','1','MOROSKY','HARRISE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-20','F','',NULL,NULL,NULL,'','2347654','','2013-12-23','2013-12-23 10:29:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:51:25'),(4890,3878,'Y','18','021','EC','A','','','AC','0000137763','0000137763','TX00000678978','IL','1','Johnson','Ronald','','','','34','453113971','9514 WATER EDGE POINT LN',0,'HUMBLE','TX','77396','1906','CY','48201','1966-02-05','M','U',NULL,'N','021','DEN','817767','33348TX002000101','2014-01-01','2013-10-04 15:21:10','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:31:29'),(18374,14665,'Y','18','021','EC','A','','','AC','0000136104','0000136104','OH00001390252','IL','1','HARDWAY','CLINTON','JAMES','','','34','296501902','10644 CHATHAM RD',0,'SPENCER','OH','44275','9333','CY','39103','1954-03-25','M','U',NULL,'N','021','DEN','1618209','99734OH005000301','2014-02-01','2014-01-15 12:47:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:31'),(18503,14758,'Y','18','024','14','A','','','TE','0000001059','0000001059','','IL','1','KIGHTLINGER','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-31','F','',NULL,NULL,NULL,'','2565164','','2014-01-15','2014-01-15 15:08:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:46:30'),(23391,18640,'Y','18','021','EC','A','','','AC','0000380102','0000380102','OH00002758637','IL','1','KLEIN','M SUSAN','','','','34','275548555','47235 TOWNSHIP ROAD 204',0,'COSHOCTON','OH','43812','8809','CY','39031','1955-05-25','F','U',':RET:2106-3','N','021','DEN','3289298','99734OH005000401','2014-03-01','2014-02-13 14:49:34','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-13 22:01:05'),(24426,19403,'N','19','021','EC','A',NULL,NULL,'','0000815378','0000823564','','S1','1','Sebe','Jennifer','','','','34','299067202','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','2002-06-03','F','',':RET:2106-3','N','021','HLT','3372930','52664OH151001301','2014-04-01','2014-02-18 08:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-18 22:01:11'),(28452,22514,'Y','18','021','EC','A','','','AC','0002102227','0002102227','LA00002842686','IL','1','kullman','eric','','','','34','434740588','5811 NORLAND AVE',0,'NEW ORLEANS','LA','70131','3947','CY','22071','1963-08-16','M','U',':RET:2106-3','N','021','DEN','3861197','18575LA002000201','2014-04-01','2014-03-07 11:55:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:20'),(2468,2008,'Y','18','021','EC','A','','','AC','0000016946','0000016946','LA00000226592','IL','1','Thomson','Judy','L','','','34','439949735','1708 HENRY ST',0,'PINEVILLE','LA','71360','5073','CY','22079','1952-06-26','F','U',':RET:2106-3','N','021','DEN','551998','18575LA002000101','2014-01-01','2013-12-09 16:47:38','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-25 19:35:07'),(14311,11415,'N','19','021','EC','A',NULL,NULL,'','0000399894','0000340297','','IL','1','Johnson','Tyler','','','','34','269963818','PO Box 332',0,'Republic','OH','44867',NULL,'CY','39147','1992-10-09','M','',NULL,'N','021','HLT','1656723','92036OH003002706','2014-02-01','2013-12-26 11:05:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2013-12-27 02:07:03'),(15023,12007,'Y','18','021','EC','A','','','AC','0001424914','0001424914','LA00001354081','IL','1','Tavormina','Mark','','','','34','133580401','6801 Veterans Memorial Blvd',0,'Metairie','LA','70003',NULL,'CY','22051','1963-06-13','M','U',':RET:2106-3','T','021','DEN','1996532','18575LA002000201','2014-02-01','2013-12-29 21:46:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:21'),(26551,21051,'Y','18','021','EC','A','','','AC','0001007939','0001007939','OH00003509037','IL','1','Thomas','Mark','','','','34','291662598','77 S. Center St.',0,'West Jefferson','OH','43162',NULL,'CY','39097','1961-07-20','M','U',':RET:2106-3','N','021','DEN','2792792','99734OH005000301','2014-04-01','2014-02-28 14:31:21','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:13'),(26694,21162,'N','01','021','EC','A',NULL,NULL,'','0001262234','0002038976','','IL','1','Canizales','Hector','Robledo','','Sr','34','458894603','1614 JUNIPER DR',0,'SHREVEPORT','LA','71118','2214','CY','22017','1963-10-20','M','',':RET:2106-3','N','021','DEN','3758620','18575LA002000101','2014-04-01','2014-02-28 00:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 21:31:30'),(28150,22277,'Y','18','021','EC','A','','','AC','0000653265','0000653265','OH00002863390','IL','1','SCHWARK','CORY','','','','34','293862958','600 SUNSET DR',0,'SPENCERVILLE','OH','45887','1259','CY','39003','1986-12-06','M','U',NULL,'N','021','HLT','3615031','92036OH004001501','2014-04-01','2014-03-06 10:37:22','184.00',NULL,NULL,'185.46','1.46','R-OH002','OH0','185.46',NULL,0,'2014-03-06 21:02:36'),(28894,22869,'Y','18','021','EC','A','','','AC','0000843734','0000843734','TX00003787041','IL','1','RAY','MASIKA','','','','34','449656682','501 LURA ST',0,'LONGVIEW','TX','75603','9332','CY','48183','1974-03-27','F','U',NULL,'N','021','DEN','3398402','33348TX002000201','2014-04-01','2014-03-10 15:23:09','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-03-10 21:00:16'),(29038,22984,'Y','18','021','EC','A','','','AC','0000380124','0000380124','OH00003045306','IL','1','Griffiths','Rebecca','','','','34','054746861','2662 BAYHILL CT',0,'CINCINNATI','OH','45233','4200','CY','39061','1985-12-29','F','U',':RET:2106-3','N','021','DEN','3784643','99734OH005000401','2014-04-01','2014-03-10 13:11:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:39'),(7731,6123,'Y','18','021','EC','A','','','AC','0000895701','0000895701','OH00000549474','IL','1','LIPOVEC','LINDA','','','','34','296582952','2651 BISHOP RD',0,'WICKLIFFE','OH','44092','2669','CY','39085','1962-04-18','F','U',':RET:2106-3','N','021','DEN','1581916','99734OH005000401','2014-01-01','2013-12-20 14:54:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:00'),(7070,5613,'N','19','021','EC','A',NULL,NULL,'','0000566628','0000273791','','IL','1','Blair','John Paul','William','','','34','287155867','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','2009-10-26','M','',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:06'),(6228,4937,'Y','18','021','EC','A','','','AC','0000550032','0000550032','OH00001075512','IL','1','Freeland','Phillip','','','','34','276504426','8970 LANCASTER THORNVILLE RD NE',0,'PLEASANTVILLE','OH','43148','9763','CY','39045','1950-10-24','M','M',':RET:2106-3','N','021','DEN','1183858','99734OH005000401','2014-01-01','2013-11-19 15:45:35','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:31:22'),(13309,10626,'Y','18','021','EC','A','','','AC','0000193507','0000193507','TX00000982878','IL','1','Bennett','Peggy','','','','34','539620062','618 Lowry',0,'Pampa','TX','79065',NULL,'CY','48179','1955-08-27','F','M',':RET:2106-3','N','021','DEN','2329756','33348TX002000201','2014-01-01','2013-12-23 15:45:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:02'),(4710,3734,'Y','18','021','EC','A','','','AC','0000106694','0000106694','OH00000173040','IL','1','Sutton','Mark','Kerry','','','34','268584664','3054 VERA WAY',0,'LIMA','OH','45805','5905','CY','39003','1954-10-27','M','U',':RET:2106-3','T','021','HLT','1080143','92036OH005001504','2014-01-01','2013-12-12 11:11:46','432.00',NULL,NULL,'658.83','226.83','R-OH002','OH0','658.83',NULL,0,'2013-12-25 22:08:42'),(21349,17062,'Y','18','021','EC','A','','','AC','0001157411','0001157411','TX00002387456','IL','1','Fuentes','Olga','','','','34','467512521','2974 ELENA ST',0,'BROWNSVILLE','TX','78521','4762','CY','48061','1979-08-17','F','U',NULL,'N','021','DEN','2953926','33348TX002000201','2014-03-01','2014-02-04 09:29:18','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-04 21:00:37'),(23142,18448,'Y','18','021','EC','A','','','AC','0000912998','0000912998','OH00002625833','IL','1','HILDRETH','MICHELLE','R','','','34','297749391','146 GOODVIEW AVE',0,'AKRON','OH','44305','3619','CY','39153','1963-04-20','F','U',':RET:2106-3','N','021','HLT','3656823','52664OH151001306','2014-03-01','2014-02-12 12:03:02','306.00',NULL,NULL,'398.29','92.29','R-OH012','OH0','398.29',NULL,0,'2014-02-12 21:31:37'),(25933,20565,'Y','18','021','EC','A','','','AC','0001246766','0001246766','TX00002803957','IL','1','Beam','Elizabeth','','','','34','460874299','903 N WALKER ST',0,'ALPINE','TX','79830','3207','CY','48043','1986-06-29','F','M',':RET:2106-3','N','021','DEN','3794045','33348TX002000201','2014-03-01','2014-02-26 16:41:40','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:27'),(26398,20937,'N','19','021','EC','A',NULL,NULL,'','0001167985','0000899620','','IL','1','Mollohan','Zachary','','','','34','283119164','3955 PEARL RD',0,'MEDINA','OH','44256','9036','CY','39103','2005-07-26','M','',':RET:2106-3','N','021','HLT','3432996','52664OH151001305','2014-03-01','2014-02-26 14:11:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:29'),(27169,21511,'Y','18','021','EC','A','','','AC','0000584668','0000584668','TX00003202157','IL','1','Perez','Daisy','D','','','34','525714500','500 Ruben Dr',0,'El Paso','TX','79912',NULL,'CY','48141','1983-01-09','F','U',NULL,'N','021','DEN','3095037','33348TX002000201','2014-04-01','2014-03-03 11:02:12','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-03 21:31:04'),(1235,1018,'Y','18','021','EC','A','','','AC','0000776457','0000776457','LA00000237597','IL','1','Smith','Ricky','','','','34','433356400','9137 BEECHWOOD DR',0,'BASTROP','LA','71220','4801','CY','22067','1976-06-14','M','U',':RET:2054-5','N','021','DEN','132719','18575LA002000101','2014-01-01','2013-12-03 01:07:05','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 18:20:49'),(5242,4157,'Y','18','021','EC','A','','','AC','0000521938','0000521938','OH00000005456','IL','1','Glass','Cena','','','','34','437171166','438 Baldwin Road',0,'Akron','OH','44312',NULL,'CY','39153','1957-07-12','F','U',':RET:2106-3','N','021','HLT','2060289','52664OH151001306','2014-01-01','2013-12-18 20:46:41','399.00',NULL,NULL,'520.28','121.28','R-OH012','OH0','520.28',NULL,0,'2013-12-25 23:04:56'),(13304,10621,'Y','18','021','EC','A','','','AC','0000087368','0000087368','TX00000835115','IL','1','Goolsby','Trey','','','','34','633100209','109 PRESTON ST',0,'BRAZORIA','TX','77422','8898','CY','48039','1986-02-23','M','U',':RET:2106-3','N','021','DEN','1553835','33348TX002000201','2014-01-01','2013-12-23 15:01:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:57:52'),(16391,13116,'Y','18','021','EC','A','','','AC','0001245424','0001245424','TX00001788230','IL','1','RIVERA','NORA','','','','34','457453814','613 E MILE 10 N',0,'WESLACO','TX','78596','2228','CY','48215','1964-06-10','F','M',NULL,'N','021','DEN','1554278','33348TX002000201','2014-02-01','2014-01-06 10:22:40','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-07 04:03:34'),(15831,12675,'Y','18','021','EC','A','','','AC','0000427645','0000427645','OH00001666342','IL','1','MEANEY','GEORGE','','','','34','090504809','1841 W MAIN ST',0,'TROY','OH','45373','2303','CY','39109','1957-02-20','M','U',NULL,'N','021','DEN','2405378','99734OH005000401','2014-02-01','2014-01-02 00:19:22','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:03:51'),(13727,10954,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00001411307','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','1889996','52664OH151001305','2014-01-01','2013-12-23 18:19:22','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:20'),(18404,14684,'N','01','021','EC','A',NULL,NULL,'','0000711402','0000926296','','IL','1','Campbell-Reynolds','Maggie','','','','34','251906908','515 MILL ST',0,'MILFORD','OH','45150','1029','CY','39025','1951-02-18','F','',':RET:2106-3','N','021','DEN','2173797','99734OH005000301','2014-02-01','2014-01-15 17:50:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:44'),(18488,14746,'Y','18','021','EC','A','','','AC','0001214823','0001214823','OH00001883839','IL','1','laurianti','carl','','','','34','269485510','559 DALEVIEW DR',0,'AURORA','OH','44202','7311','CY','39133','1949-07-29','M','M',NULL,'N','021','HLT','2988478','52664OH151001305','2014-02-01','2014-01-15 14:58:33','502.00',NULL,NULL,'669.00','167.00','R-OH012','OH0','669.00',NULL,0,'2014-01-16 08:46:24'),(19982,15938,'N','01','021','EC','A',NULL,NULL,'','0000387318','0000427665','','IL','1','Pasternack','Georgia','','','','34','286568931','9740 Deltona dr',0,'New Middletown','OH','44442',NULL,'CY','39099','1955-01-18','F','',NULL,'N','021','DEN','2919451','99734OH005000401','2014-03-01','2014-01-25 17:41:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:16'),(23969,19056,'Y','18','021','EC','A','','','AC','0000935499','0000935499','TX00001421270','IL','1','beals','susan','','','','34','420801183','7708 san Felipe Blvd',0,'Austin','TX','78729',NULL,'CY','48491','1952-01-15','F','U',':RET:2106-3','N','021','DEN','3156585','33348TX002000101','2014-03-01','2014-02-15 14:36:11','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:13'),(442,363,'Y','18','021','EC','A','','','AC','0001180994','0001180994','OH00000705578','IL','1','Kozlowski','Drena','','','','34','269549502','3960 HILLTOP DR',0,'VERMILION','OH','44089','2091','CY','39093','1953-04-23','F','U',':RET:2106-3','N','021','DEN','1064857','99734OH005000401','2014-01-01','2013-12-04 11:15:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:47:11'),(16718,13380,'Y','18','021','EC','A','','','AC','0000412782','0000412782','TX00002145630','IL','1','Maldonado','Rodolfo','','','','34','467413746','107 ALBERTO TREVINO ST',0,'MISSION','TX','78572','6788','CY','48215','1962-01-16','M','M',':RET:2106-3','T','021','DEN','1571424','33348TX002000201','2014-02-01','2014-01-07 15:43:46','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-08 18:24:45'),(1420,1182,'Y','18','021','EC','A','','','AC','0002298507','0002298507','LA00001392430','IL','1','Dulock','Pamela','','','','34','437967314','321 Eureka Dr',0,'Gray','LA','70359',NULL,'CY','22109','1958-05-03','F','M',':RET:2106-3','N','021','DEN','1487422','18575LA002000201','2014-01-01','2013-12-24 15:08:45','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 18:47:12'),(16514,13211,'Y','18','021','EC','A','','','AC','0000410618','0000410618','TX00001365752','IL','1','Fuentes','Felix','','','','34','460558400','3801 CENTURY DR',0,'EL PASO','TX','79938','0400','CY','48141','1959-04-05','M','M',':RET:2106-3','N','021','DEN','1970088','33348TX002000201','2014-02-01','2014-01-04 21:59:11','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,1,'2014-01-07 10:21:27'),(14456,11533,'Y','18','021','EC','A','','','AC','0001158839','0001158839','LA00001797551','IL','1','DOMINGO','ELDEN','','','','34','439358460','105 BARON DR',0,'LAFAYETTE','LA','70501','4043','CY','22055','1964-10-25','M','U',NULL,'N','021','DEN','2232208','18575LA002000201','2014-02-01','2013-12-27 14:45:18','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-28 03:32:38'),(13442,10720,'N','19','021','EC','A',NULL,NULL,'','0000279552','0000761107','','S1','1','STROUD','ANTHONY','','','','34','278087248','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','2003-03-29','F','',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:17'),(7980,6318,'Y','18','021','EC','A','','','AC','0000749518','0000749518','OH00000397009','IL','1','STIDD','SARAH','','','','34','298480895','2030 13TH ST',0,'CUYAHOGA FALLS','OH','44223','2415','CY','39153','1950-10-29','F','M',':RET:2106-3','N','021','HLT','1620732','52664OH151001305','2014-01-01','2013-12-20 14:06:33','497.00',NULL,NULL,'658.32','161.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 03:07:56'),(5356,4248,'Y','18','021','EC','A','','','AC','0000088547','0000088547','OH00000448854','IL','1','Frogge','William','A','','','34','268520250','618 Melrose St',0,'Akron','OH','44305',NULL,'CY','39153','1951-08-14','M','M',':RET:2106-3','T','021','HLT','2290363','52664OH152000901','2014-01-01','2013-12-19 16:25:08','1027.00',NULL,NULL,'1049.47','22.47','R-OH012','OH0','539.67',NULL,0,'2013-12-25 23:07:45'),(6668,5288,'N','01','021','EC','A',NULL,NULL,'','0000361646','0000362966','','IL','1','duffy','velva','','','','34','457065741','3114 HUMBLE AVE',0,'MIDLAND','TX','79705','8208','CY','48329','1954-02-11','F','',':RET:2106-3','N','021','DEN','386672','33348TX002000201','2014-01-01','2013-11-16 14:51:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:01:01'),(22589,18042,'Y','18','024','14','A','','','TE','0000199700','0000199700','','IL','1','LONG','DORIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-03-01','F','',NULL,NULL,NULL,'','2375728','','2014-02-10','2014-02-10 12:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:32:08'),(23419,18660,'Y','18','024','14','A','','','TE','0000047026','0000047026','','IL','1','Stanley','Melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-05-31','F','',NULL,NULL,NULL,'','700651','','2014-02-27','2014-02-12 21:13:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-13 22:01:21'),(28149,22276,'Y','18','024','14','A','','','TE','0000906653','0000906653','','IL','1','Harshman','Suzanne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-05-14','F','',NULL,NULL,NULL,'','2738320','','2014-03-06','2014-03-06 12:15:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:02:35'),(28959,22919,'Y','18','021','EC','A','','','AC','0002055575','0002055575','LA00003559162','IL','1','Penn','Doris','','','','34','439983604','23405 BURVANT ST',0,'ABITA SPRINGS','LA','70420','2411','CY','22103','1955-11-05','F','U',':RET:2054-5','N','021','DEN','3200930','18575LA002000201','2014-04-01','2014-03-10 12:43:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:55'),(7581,5996,'N','01','021','EC','A',NULL,NULL,'','0000440802','0000327260','','IL','1','Kienzle','Todd','M','','','34','386707682','2238 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','1102','CY','39095','1957-04-08','M','',':RET:2106-3','N','021','HLT','394135','92036OH001002601','2014-01-01','2013-12-15 12:30:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','548.73',NULL,0,'2013-12-26 02:33:55'),(15119,12085,'Y','18','021','EC','A','','','AC','0001063253','0001063253','OH00001423653','IL','1','McGuire','Crystal','','','','34','402338190','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1974-02-21','F','M',NULL,'N','021','DEN','2611229','99734OH005000301','2014-02-01','2013-12-30 15:51:27','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-01-01 12:05:13'),(14377,11468,'Y','18','021','EC','A','','','AC','0001038616','0001038616','OH00000785429','IL','1','Johnson','Scott','','','','34','284801104','1667 E 40th St',0,'Cleveland','OH','44103',NULL,'CY','39035','1967-11-03','M','R',':RET:2106-3','N','021','DEN','1588092','99734OH005000401','2014-02-01','2013-12-27 12:01:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:41'),(13768,10990,'Y','18','021','EC','A','','','AC','0001022612','0001022612','MS00000573666','IL','1','Harley','Barbara','','','','34','587547092','4402 OAK FORREST DR',0,'HATTIESBURG','MS','39402','1211','CY','28073','1953-01-22','F','M',NULL,'N','021','DEN','2221758','46300MS002000201','2014-01-01','2013-12-23 12:02:12','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 13:10:26'),(1796,1475,'Y','18','024','14','A','','','TE','0000234020','0000234020','','IL','1','Getz','Maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-19','F','',NULL,NULL,NULL,'','531050','','2013-12-24','2013-12-24 16:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:56:39'),(9036,7170,'Y','18','024','14','A','','','TE','0000781877','0000781877','','IL','1','Lordi','Joe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-28','M','',NULL,NULL,NULL,'','1126937','','2013-12-18','2013-12-18 15:04:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:43'),(4268,3400,'Y','18','021','EC','A','','','AC','0001152170','0001152170','OH00000943422','IL','1','Griffith','Tereasa','','','','34','275763673','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1967-07-18','F','M',':RET:2106-3','N','021','HLT','1863949','92036OH003001501','2014-01-01','2013-12-17 08:08:43','431.00',NULL,NULL,'793.38','362.38','R-OH002','OH0','344.75',NULL,0,'2013-12-25 21:51:41'),(19169,15272,'Y','18','021','EC','A','','','AC','0000938123','0000938123','TX00002170363','IL','1','Nevling','David','','','','34','293466225','4311 14th st',0,'Bacliff','TX','77518',NULL,'CY','48167','1951-08-10','M','U',':RET:2106-3','N','021','DEN','1770785','33348TX002000201','2014-03-01','2014-01-20 11:49:51','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-21 08:46:02'),(22706,18132,'Y','18','021','EC','A','','','AC','0001503389','0001503389','LA00002588662','IL','1','Quinn','Karen','','','','34','435763954','176 Leisure Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1949-10-01','F','M',':RET:2106-3','N','021','DEN','2860969','18575LA002000201','2014-03-01','2014-02-10 18:57:05','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-11 21:01:02'),(23830,18961,'Y','18','024','14','A','','','TE','0001077639','0001077639','','IL','1','Pearson','Dania',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-12','F','',NULL,NULL,NULL,'','3208112','','2014-02-14','2014-02-14 02:15:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-14 21:31:45'),(24038,19116,'Y','18','021','EC','A','','','AC','0000561720','0000561720','OH00002010248','IL','1','Watson','Linda','','','','34','298543668','19101  Van Aken Blvd',0,'Shaker Heights','OH','44122',NULL,'CY','39035','1953-10-01','F','U',':RET:2106-3','N','021','DEN','3859911','99734OH005000301','2014-03-01','2014-02-15 09:25:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:56'),(24153,19191,'Y','18','021','EC','A','','','AC','0000146934','0000146934','OH00002231637','IL','1','Mullins','Diane','','','','34','273661272','397 BLACK ST',0,'AKRON','OH','44306','1146','CY','39153','1958-12-18','F','U',':RET:2106-3','T','021','HLT','3258504','52664OH152000901','2014-03-01','2014-02-15 11:38:45','396.00',NULL,NULL,'418.89','22.89','R-OH012','OH0','418.89',NULL,0,'2014-02-15 22:01:58'),(24228,19240,'Y','18','021','EC','A','','','AC','0001100641','0001100641','OH00001632177','IL','1','Williamson','Minet','','','','34','272760371','1279 AVON DR',0,'CINCINNATI','OH','45229','1209','CY','39061','1975-07-01','F','U',':RET:2054-5','N','021','DEN','2764883','99734OH005000401','2014-03-01','2014-02-15 23:09:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-16 19:00:32'),(24937,19775,'Y','18','024','14','A','','','TE','0001679957','0001679957','','IL','1','alonzo','angel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-02-15','M','',NULL,NULL,NULL,'','2568899','','2014-03-31','2014-02-20 17:28:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-20 21:30:23'),(9009,7148,'Y','18','024','14','A','','','TE','0000711341','0000711341','','IL','1','Aylward','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-02','M','',NULL,NULL,NULL,'','293776','','2013-12-18','2013-12-18 13:48:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:02'),(8855,7020,'N','01','021','EC','A',NULL,NULL,'','0000791069','0000793356','','IL','1','Hall','Laura','Anne','','','34','266277398','625 East Dallas Ave',0,'McAllen','TX','78501',NULL,'CY','48215','1954-01-18','F','',':RET:2106-3','T','021','DEN','2500424','33348TX002000201','2014-01-01','2013-12-18 10:32:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:07'),(17235,13793,'Y','18','021','EC','A','','','AC','0000130711','0000130711','OH00002125410','IL','1','Geyer','Florinda','','','','34','193425625','13301 GILMORE AVE',0,'CLEVELAND','OH','44135','2131','CY','39035','1962-02-12','F','M',':RET:2106-3','N','021','HLT','1542948','92036OH003000806','2014-02-01','2014-01-08 12:50:38','665.00',NULL,NULL,'910.74','245.74','R-OH011','OH0','455.37',NULL,0,'2014-01-13 02:22:42'),(14149,11278,'Y','18','021','EC','A','','','AC','0001944621','0001944621','LA00000157341','IL','1','Hopkins','Brandi','','','','34','433634814','615 RUE SAINT MARTIN',0,'HAMMOND','LA','70403','5327','CY','22105','1984-12-03','F','U',':RET:2106-3','N','021','DEN','2487219','18575LA002000201','2014-02-01','2013-12-26 13:06:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:02:50'),(15957,12774,'Y','18','021','EC','A','','','AC','0000608468','0000608468','OH00001786808','IL','1','HERNANDEZ','LUIS','A','','','34','406494980','9693 ADAIR CT',0,'CINCINNATI','OH','45251','2109','CY','39061','1977-05-24','M','M',':RET:2106-3','N','021','DEN','2183743','99734OH005000301','2014-02-01','2014-01-03 13:23:39','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:00:15'),(7270,5765,'Y','18','021','EC','A','','','AC','0000817806','0000817806','TX00000052301','IL','1','PERMENTER','KRISTIE','','','','34','451827717','1705 BREEZY DR',0,'Waco','TX','76712',NULL,'CY','48309','1954-05-17','F','U',NULL,'N','021','DEN','886649','33348TX002000201','2014-01-01','2013-12-14 10:18:02','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2013-12-26 02:02:24'),(18511,14762,'Y','18','021','EC','A','','','AC','0000932125','0000932125','OH00001360032','IL','1','Mohr','Rebecca','','','','34','287780031','192 Garmatter St',0,'Bluffton','OH','45817',NULL,'CY','39003','1979-05-10','F','M',':RET:2106-3','N','021','HLT','2043952','92036OH004001501','2014-02-01','2014-01-15 10:52:02','660.89',NULL,NULL,'665.76','4.87','R-OH002','OH0','214.83',NULL,0,'2014-01-16 08:46:33'),(19006,15136,'Y','18','021','EC','A','','','AC','0001343063','0001343063','LA00001469358','31','1','WILLIAMS','REGEANER','','','','34','436397667','PO BOX 1512',0,'MINDEN','LA','71058',NULL,'CY','22119','1968-05-12','F','U',NULL,'N','021','DEN','1763813','18575LA002000201','2014-03-01','2014-01-17 16:47:55','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-20 08:06:18'),(20726,16561,'Y','18','021','EC','A','','','AC','0001208339','0001208339','OH00002171624','IL','1','PITSINGER','DEBORAH','K','','','34','291649431','9681 SILICA SAND RD',0,'GARRETTSVILLE','OH','44231',NULL,'CY','39133','1958-07-08','F','M',':RET:2054-5^:RET:2106-3','T','021','HLT','3242693','52664OH151001304','2014-03-01','2014-01-30 12:32:33','728.00',NULL,NULL,'1170.22','442.22','R-OH012','OH0','571.90',NULL,0,'2014-01-30 21:01:17'),(21926,17511,'Y','18','021','EC','A','','','AC','0000945659','0000945659','TX00001814308','IL','1','Akhtar','Seema','','','','34','644629892','10930 Maple Bough Lane',0,'Houston','TX','77067',NULL,'CY','48201','1962-08-15','F','M',NULL,'N','021','DEN','3796921','33348TX002000201','2014-03-01','2014-02-06 20:36:37','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-07 19:00:08'),(22675,18107,'Y','18','021','EC','A','','','AC','0000096287','0000096287','TX00002226446','IL','1','Castillo','Hilda','','','','34','635409661','639 DEREK RD',0,'EDDY','TX','76524','3906','CY','48309','1988-10-20','F','U',':RET:2106-3','N','021','DEN','2856396','33348TX002000201','2014-03-01','2014-02-11 15:32:27','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-02-11 21:00:44'),(24415,19393,'N','01','021','EC','A',NULL,NULL,'','0000130745','0000026662','','IL','1','Griffith','Gary','','','','34','301407083','224 2ND ST',0,'BERGHOLZ','OH','43908','7979','CY','39081','1955-01-14','M','',':RET:2106-3','N','021','DEN','2915235','99734OH005000301','2014-04-01','2014-02-18 10:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:01:03'),(24515,19474,'Y','18','021','EC','A','','','AC','0000796063','0000796063','TX00001406701','IL','1','GOINES','JANICE','','','','34','439478768','8110 CREEKBEND DR.',0,'HOUSTON','TX','77071',NULL,'CY','48201','1983-01-21','F','U',NULL,'N','021','DEN','3181214','33348TX002000201','2014-04-01','2014-02-19 11:28:09','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 03:54:41'),(24622,19542,'Y','18','021','EC','A','','','AC','0000863067','0000863067','MS00002342035','IL','1','TUCKER','TYSHA','','','','34','428494080','402 PEARL DR',0,'PEARL','MS','39208','4521','CY','28121','1968-12-04','F','M',NULL,'N','021','DEN','2727834','46300MS002000201','2014-04-01','2014-02-19 15:23:39','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:16:12'),(29013,22962,'Y','18','024','14','A','','','TE','0000221388','0000221388','','IL','1','Willis','Lelith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-09-09','F','',NULL,NULL,NULL,'','2822386','','2014-03-08','2014-03-09 20:23:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:25'),(1973,1612,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','301754','','2013-11-19','2013-11-19 23:01:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:32'),(21606,17252,'N','19','021','EC','A',NULL,NULL,'','0000895755','0000625459','','IL','1','Carver','Johnathan','Zander','','','34','302131028','4577 CARNOUSTIE',0,'BATAVIA','OH','45103','4008','CY','39025','2008-05-17','M','',':RET:2106-3','N','021','DEN','3280349','99734OH005000301','2014-03-01','2014-02-05 13:20:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:33'),(25418,20168,'Y','18','021','EC','A','','','AC','0000404854','0000404854','OH00002355421','IL','1','HESTON','CARLA','','','','34','277706130','1604 MAPLEDALE RD',0,'WICKLIFFE','OH','44092','1025','CY','39085','1961-05-13','F','U',NULL,'N','021','DEN','2700740','99734OH005000401','2014-04-01','2014-02-25 14:38:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-25 21:31:07'),(818,677,'Y','18','021','EC','A','','','AC','0001167985','0001167985','OH00000853240','IL','1','Mollohan','Nicole','','','','34','293748506','3955 Pearl Rd.',0,'Medina','OH','44256',NULL,'CY','39103','1969-12-08','F','U',':RET:2106-3','N','021','HLT','1744072','52664OH151001305','2014-01-01','2013-12-16 13:10:48','100.00',NULL,NULL,'311.54','211.54','R-OH012','OH0','311.54',NULL,0,'2013-12-25 18:06:00'),(1962,1601,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000214564','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','1073422','33348TX002000101','2014-01-01','2013-11-19 22:59:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:15'),(17686,14133,'Y','18','021','EC','A','','','AC','0002146942','0002146942','LA00002484077','IL','1','SMITH','KIM','','','','34','438791281','1040 RUE CHINON',0,'MANDEVILLE','LA','70471','1211','CY','22103','1987-12-26','F','U',':RET:2106-3','N','021','DEN','2503723','18575LA002000201','2014-02-01','2014-01-12 20:31:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:32:56'),(9794,7755,'Y','18','021','EC','A','','','AC','0000153783','0000153783','TX00000794851','IL','1','Obregon','Alfredo III','','','','34','463877498','107 KISSLING AVE',0,'ROBSTOWN','TX','78380','2218','CY','48355','1986-01-16','M','U',':RET:2148-5^:RET:2106-3','N','021','DEN','725631','33348TX002000201','2014-01-01','2013-10-20 13:30:38','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 05:01:03'),(16682,13348,'N','01','021','EC','A',NULL,NULL,'','0000012450','0000731217','','IL','1','KNUTSON','EMILY','','','','34','336667903','6982 FRANCIS DR',0,'LIBERTY TOWNSHIP','OH','45044','9254','CY','39017','1978-03-28','F','',':RET:2106-3','N','021','DEN','1575019','99734OH005000301','2014-02-01','2014-01-07 15:25:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(15107,12075,'Y','18','021','EC','A','','','AC','0000057344','0000057344','OH00000488974','IL','1','Sivec','James','','','','34','269844934','45295 PARSONS RD',0,'OBERLIN','OH','44074','9602','CY','39093','1977-04-08','M','R',':RET:2106-3','T','021','DEN','2023671','99734OH005000301','2014-02-01','2013-12-30 12:24:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:04:51'),(7894,6242,'N','19','021','EC','A',NULL,NULL,'','0000689688','0000022786','','S1','1','McGuire','Thomas','','','','34','273135160','1004 LONES DR',0,'PERRYSBURG','OH','43551','2332','CY','39173','2006-12-21','F','',':RET:2106-3','N','021','HLT','1836189','92036OH005002601','2014-01-01','2013-12-20 15:11:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-26 03:05:41'),(4193,3336,'Y','18','021','EC','A','','','AC','0000036978','0000036978','OH00000286464','IL','1','Labocki','Eva','','','','34','278503403','3626 APPLE HILL CT',0,'BRUNSWICK','OH','44212','3100','CY','39103','1952-05-12','F','M',':RET:2106-3','N','021','HLT','1389965','52664OH151001305','2014-01-01','2013-12-17 16:11:45','433.00',NULL,NULL,'626.65','193.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 21:49:42'),(21085,16848,'N','01','021','EC','A',NULL,NULL,'','0000528278','0000376171','','IL','1','DONBRAYE','FRANKLIN','P','','','34','030605598','19808 LONGBROOK RD',0,'CLEVELAND','OH','44128','2767','CY','39035','1954-05-23','M','',NULL,'N','021','DEN','3006923','99734OH005000301','2014-03-01','2014-02-02 10:50:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-02 19:00:24'),(24685,19594,'Y','18','021','EC','A','','','AC','0001039350','0001039350','TX00002373939','IL','1','Musharbash','Basel','Jalal','','','34','641988141','2470 RIDGEVIEW RD',0,'PARIS','TX','75460','3204','CY','48277','1992-07-08','M','U',':RET:2028-9','N','021','DEN','3200339','33348TX002000101','2014-04-01','2014-02-19 00:10:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:31:16'),(25989,20610,'Y','18','021','EC','A','','','AC','0000406683','0000406683','MS00002630723','IL','1','Alexander','Lelama','','','','34','435173653','817 LAFAYETTE AVE',0,'PASCAGOULA','MS','39567','6421','CY','28059','1963-11-08','F','M',':RET:2106-3','N','021','DEN','2988098','46300MS002000201','2014-04-01','2014-02-26 12:02:21','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-26 21:01:55'),(1416,1178,'Y','18','021','EC','A','','','AC','0001560121','0001560121','LA00000125382','IL','1','Suleiman','Summer','','','','34','436738788','3256 TIMBERLANE WAY DR',0,'HARVEY','LA','70058','6613','CY','22051','1987-11-15','F','U',':RET:2106-3','N','021','DEN','1379591','18575LA002000201','2014-01-01','2013-12-24 14:22:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:05'),(17389,13913,'Y','18','021','EC','A','','','AC','0000684830','0000684830','OH00001974341','IL','1','Kissinger','David','','','','34','294569741','7601 scotts mill road',0,'rogers','OH','44455',NULL,'CY','39029','1957-07-05','M','M',':RET:2106-3','N','021','DEN','2467903','99734OH005000401','2014-02-01','2014-01-10 13:45:03','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-13 03:00:10'),(15678,12540,'Y','18','021','EC','A','','','AC','0000748194','0000748194','OH00001883435','IL','1','VANCE','NANCY','','','','34','224844172','1645 LOUISVILLE RD',0,'SEAMAN','OH','45679',NULL,'CY','39001','1967-02-28','F','M',':RET:2106-3','N','021','HLT','1681508','92036OH005000605','2014-02-01','2013-12-31 10:34:23','228.00',NULL,NULL,'322.00','94.00','R-OH005','OH0','322.00',NULL,1,'2014-01-02 04:34:52'),(2764,2235,'Y','18','021','EC','A','','','AC','0001183494','0001183494','OH00000747021','IL','1','Poff','Deborah','','','','34','298661008','1120 GRIGGS RD',0,'JEFFERSON','OH','44047','9754','CY','39007','1959-02-20','F','M',':RET:2106-3','N','021','HLT','544468','52664OH151001305','2014-01-01','2013-12-02 15:13:47','1106.00',NULL,NULL,'1243.76','137.76','R-OH011','OH0','536.99',NULL,0,'2013-12-25 19:49:23'),(15397,12315,'N','19','021','EC','A',NULL,NULL,'','0000771447','0000426437','','IL','1','tone','cassandra','m',NULL,NULL,NULL,NULL,'173 S FAIRFIELD ST',0,'LEESBURG','OH','45135','9262','CY','39071','1997-03-04','F','',':RET:2054-5','N','021','HLT','2215975','92036OH006000601','2014-02-01','2014-01-01 17:55:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,1,'2014-01-02 04:25:53'),(13623,10862,'Y','18','021','EC','A','','','AC','0000695630','0000695630','OH00001240773','IL','1','Jordan','Daneda','','','','34','294782560','386 park ave',0,'ottawa','OH','45875',NULL,'CY','39137','1970-02-16','F','M',':RET:2106-3','N','021','HLT','2420499','92036OH005001506','2014-01-01','2013-12-23 09:19:37','289.12',NULL,NULL,'298.65','9.53','R-OH002','OH0','298.65',NULL,0,'2013-12-26 13:05:55'),(7090,5624,'Y','18','024','14','A','','','TE','0000426434','0000426434','','IL','1','Adams','Alonna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-04-18','F','',NULL,NULL,NULL,'','1930476','','2013-12-25','2013-12-25 06:51:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:50:31'),(3566,2863,'Y','18','021','EC','A','','','AC','0000156932','0000156932','OH00000503801','IL','1','Oberhauser','Paula','','','','34','271526764','5411 S Fulton Lucas Rd',0,'Swanton','OH','43558',NULL,'CY','39095','1952-05-29','F','M',':RET:2106-3','N','021','HLT','1698295','92036OH004002601','2014-01-01','2013-12-22 17:22:58','170.00',NULL,NULL,'440.60','270.60','R-OH001','OH0','440.60',NULL,0,'2013-12-25 21:22:25'),(20474,16355,'Y','18','024','14','A','','','TE','0001142203','0001142203','','IL','1','Tolber','Nika',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-02-26','F','',NULL,NULL,NULL,'','3571950','','2014-01-29','2014-01-29 14:15:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:57'),(26859,21287,'N','19','021','EC','A',NULL,NULL,'','0000177685','0001044539','','IL','1','campton','allyson','','','','34','288021037','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1997-11-03','F','',NULL,'N','021','HLT','3909716','92036OH003000601','2014-04-01','2014-03-01 11:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-01 21:00:55'),(27212,21546,'Y','18','021','EC','A','','','AC','0001214858','0001214858','OH00003370135','31','1','BROWN','BRIAN','','','','34','290663633','P.O. BOX 291',0,'MIDDLE POINT','OH','45863',NULL,'CY','39161','1964-01-22','M','M',':RET:2106-3','T','021','HLT','2787050','92036OH004001501','2014-04-01','2014-03-02 18:49:06','652.53',NULL,NULL,'657.34','4.81','R-OH002','OH0','363.46',NULL,0,'2014-03-03 21:31:29'),(27986,22143,'Y','18','021','EC','A','','','AC','0001396015','0001396015','LA00002777088','IL','1','Doresy','Horace','','','','34','438450563','315 West 10th St',0,'Thibodaux','LA','70301',NULL,'CY','22057','1969-08-03','M','U',NULL,'N','021','DEN','4144231','18575LA002000201','2014-04-01','2014-03-06 16:40:30','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-03-06 21:01:00'),(28973,22931,'Y','18','021','EC','A','','','AC','0001833728','0001833728','LA00003481089','IL','1','Johnson','Antoinette',NULL,NULL,NULL,NULL,NULL,'1345 fiesta dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1963-06-18','F','M',':RET:2054-5','N','021','DEN','3626419','18575LA002000201','2014-04-01','2014-03-10 17:18:52','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:01:04'),(13034,10390,'Y','18','024','14','A','','','TE','0000898454','0000898454','','IL','1','Elbeyli','Ahmet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-21','M','',NULL,NULL,NULL,'','1578412','','2013-12-23','2013-12-23 01:35:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:50:26'),(9457,7502,'Y','18','021','EC','A','','','AC','0001203213','0001203213','OH00000740260','IL','1','Simpson','Susan','','','','34','301868329','120 North Mechanic Street',0,'Lebanon','OH','45036',NULL,'CY','39165','1979-12-15','F','M',':RET:2106-3','N','021','DEN','1499818','99734OH005000401','2014-01-01','2013-12-20 23:27:32','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:08'),(14577,11632,'Y','18','021','EC','A','','','AC','0001697869','0001697869','LA00001469909','IL','1','taylor','zachary','','','','34','438377816','7822 KEATS ST',0,'NEW ORLEANS','LA','70126','1420','CY','22071','1978-11-10','M','U',':RET:2054-5','N','021','DEN','2007119','18575LA002000101','2014-02-01','2013-12-27 11:20:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-28 03:35:44'),(14178,11304,'Y','18','021','EC','A','','','AC','0001025684','0001025684','TX00000256386','IL','1','BOONE','SHERLONDA','','','','34','458196200','1425 CHEROKEE ST',0,'LONGVIEW','TX','75604','5780','CY','48183','1966-09-12','F','U',':RET:2054-5','N','021','DEN','1458030','33348TX002000201','2014-02-01','2013-12-26 09:33:06','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-27 02:03:38'),(9295,7369,'Y','18','021','EC','A','','','AC','0000304691','0000304691','OH00000647220','IL','1','Hill','Charles','','','','34','281905104','5617 BROOKS HOLDING',0,'MILFORD','OH','45150','1593','CY','39025','1988-11-20','M','U',':RET:2106-3','N','021','HLT','1163367','92036OH005000606','2014-01-01','2013-11-30 12:12:27','167.00',NULL,NULL,'215.53','48.53','R-OH005','OH0','215.53',NULL,0,'2013-12-26 04:16:13'),(2894,2336,'N','19','021','EC','A',NULL,NULL,'','0001169421','0001078860','','IL','1','Bodzin','Madison','','','','34','280110132','4421 SILSBY RD',0,'UNIVERSITY HEIGHTS','OH','44118','3938','CY','39035','2005-03-27','F','',':RET:2106-3','N','021','HLT','235718','52664OH151001501','2014-01-01','2013-12-06 14:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-25 20:15:14'),(5670,4498,'N','01','021','EC','A',NULL,NULL,'','0001207116','0000564173','','IL','1','Wilson','Michael','Alan','','','34','296600562','2001 W BEAL RD',0,'JAMESTOWN','OH','45335','9747','CY','39057','1961-02-06','M','',':RET:2106-3','T','021','HLT','843665','92036OH004000501','2014-01-01','2013-11-25 20:20:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','429.06',NULL,0,'2013-12-25 23:32:02'),(25704,20391,'N','01','021','EC','A',NULL,NULL,'','0000719027','0000018034','','IL','1','Haley','John','','','','34','459966830','2601 FM 3136',0,'CLEBURNE','TX','76031','9070','CY','48251','1953-09-04','M','',NULL,'N','021','DEN','3253464','33348TX002000201','2014-04-01','2014-02-24 13:27:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-26 09:30:20'),(25775,20440,'N','01','021','EC','A',NULL,NULL,'','0001160463','0000328459','','IL','1','Karp','Lori','A','','','34','300589279','17306 Fairway Drive',0,'Lagrange','OH','44050',NULL,'CY','39093','1970-06-21','F','',':RET:2106-3','N','021','DEN','3063575','99734OH005000301','2014-04-01','2014-02-24 16:36:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:57'),(28664,22682,'Y','18','024','14','A','','','TE','0002093152','0002093152','','IL','1','SCOTT','KAREN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-08-26','F','',NULL,NULL,NULL,'','2837170','','2014-03-08','2014-03-08 12:37:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-08 21:30:45'),(13301,10618,'Y','18','021','EC','A','','','AC','0000923653','0000923653','TX00000861229','IL','1','NGUYEN','TUAN','','','','34','462553109','1030 RIVERWOOD DR',0,'DICKINSON','TX','77539','8330','CY','48167','1963-12-02','M','M',':RET:2047-9','N','021','DEN','2169132','33348TX002000201','2014-01-01','2013-12-23 14:55:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:57:47'),(13233,10558,'Y','18','021','EC','A','','','AC','0000479695','0000479695','TX00001205700','IL','1','Rylander','Joshua','','','','34','461699321','2009 PLYMOUTH ROCK DR',0,'RICHARDSON','TX','75081','3946','CY','48113','1984-06-23','M','U',':RET:2106-3','N','021','DEN','1927819','33348TX002000201','2014-01-01','2013-12-22 22:30:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:55:48'),(17378,13904,'N','01','021','EC','A',NULL,NULL,'','0000616885','0000061334','','IL','1','THIERET','JAMES','J','','','34','163448764','7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','1952-11-08','M','',':RET:2106-3','N','021','DEN','1926859','99734OH005000401','2014-02-01','2014-01-09 20:13:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:00:04'),(13175,10509,'Y','18','021','EC','A','','','AC','0000795517','0000795517','OH00001050288','IL','1','Johnson','Ryan','','','','34','277867198','3133 CREIGHTON PL',0,'REYNOLDSBURG','OH','43068','5073','CY','39049','1974-05-26','M','U',':RET:2106-3','N','021','DEN','2236874','99734OH005000401','2014-01-01','2013-12-23 19:11:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:54:09'),(6428,5097,'Y','18','021','EC','A','','','AC','0000206608','0000206608','LA00000346490','IL','1','DUTRUCH','ALVIN','','','','34','439022966','20664 HIGHWAY 40',0,'BUSH','LA','70431','2633','CY','22103','1956-07-15','M','U',':RET:2106-3','N','021','DEN','922555','18575LA002000201','2014-01-01','2013-12-11 12:36:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:49:05'),(1918,1564,'N','19','021','EC','A',NULL,NULL,'','0000949475','0000414667','','IL','1','leese','sean',NULL,NULL,NULL,NULL,NULL,'895 WATERVILLE MONCLOVA RD',0,'WATERVILLE','OH','43566','1163','CY','39095','2006-07-04','M','',':RET:2106-3','N','021','DEN','70200','99734OH005000301','2014-01-01','2013-11-20 09:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:00:05'),(7207,5711,'Y','18','021','EC','A','','','AC','0000317325','0000317325','OH00000695838','IL','1','Niedzialkowski','Carole','','','','34','318905271','4136 Florida ave',0,'Cincinnati','OH','45223',NULL,'CY','39061','1972-02-27','F','U',':RET:2106-3','T','021','DEN','204914','99734OH005000401','2014-01-01','2013-12-13 21:18:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:00:49'),(19581,15608,'Y','18','021','EC','A','','','AC','0001785166','0001785166','LA00002491311','IL','1','KENNER','GLORESTINE','','','','34','433081697','36429 HIGHWAY 74',0,'GEISMAR','LA','70734','3128','CY','22005','1954-02-24','F','U',':RET:2054-5','N','021','DEN','1540593','18575LA002000201','2014-03-01','2014-01-22 12:33:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-23 03:02:40'),(20007,15956,'Y','18','021','EC','A','','','AC','0000828269','0000828269','OH00002241843','IL','1','DAVIS','MARVA','','','','34','280686572','342 W STATE ST',0,'BARBERTON','OH','44203',NULL,'CY','39153','1969-08-02','F','U',':RET:2054-5','N','021','DEN','2329255','99734OH005000401','2014-03-01','2014-01-26 15:32:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-26 19:00:07'),(24488,19454,'Y','18','021','EC','A','','','AC','0000840141','0000840141','TX00002219029','IL','1','Calzada','Elizabeth','','','','34','449616020','10249 SHARP DR',0,'EL PASO','TX','79924','3516','CY','48141','1981-10-16','F','M',NULL,'N','021','DEN','3034654','33348TX002000201','2014-04-01','2014-02-18 18:04:00','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-20 03:43:20'),(24758,19646,'Y','18','021','EC','A','','','AC','0000027939','0000027939','OH00002503722','IL','1','Dugan','Vincent','A','','Jr','34','196428448','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1955-06-13','M','M',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:42:35'),(26945,21351,'Y','18','021','EC','A','','','AC','0000532169','0000532169','OH00003113857','IL','1','Neff','Ricky','William','','','34','288667237','900 Lodge Road',0,'Norwich','OH','43767',NULL,'CY','39119','1960-08-03','M','M',':RET:2106-3','N','021','DEN','3935724','99734OH005000301','2014-04-01','2014-03-02 17:20:55','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-03-03 01:00:24'),(774,640,'Y','18','021','EC','A','','','AC','0000926384','0000926384','TX00000303923','IL','1','Maestas','Rodney','','','','34','218927832','6060 ABILENE TRL',0,'AUSTIN','TX','78749','2823','CY','48453','1964-11-12','M','M',NULL,'N','021','DEN','2294460','33348TX002000201','2014-01-01','2013-12-16 12:55:48','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:54'),(16683,13349,'Y','18','021','EC','A','','','AC','0000917005','0000917005','OH00001689859','IL','1','RAIDA','JOHN','J','','','34','286505648','11145 OLD MILL RD',0,'SPENCER','OH','44275',NULL,'CY','39103','1950-12-29','M','M',':RET:2106-3','N','021','DEN','2547757','99734OH005000301','2014-02-01','2014-01-07 15:39:24','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(21971,17545,'Y','18','021','EC','A','','','AC','0000436638','0000436638','OH00002434250','IL','1','Yarbrough','Ja\'Nya','K',NULL,NULL,NULL,NULL,'1032 Independence',0,'Akron','OH','44310',NULL,'CY','39153','2007-10-21','F','R',':RET:2054-5','N','021','HLT','3727749','52664OH151001306','2014-03-01','2014-02-07 07:33:20','72.41',NULL,NULL,'141.61','69.20','R-OH012','OH0','141.61',NULL,0,'2014-02-07 19:00:31'),(26155,20738,'Y','18','021','EC','A','','','AC','0000429097','0000429097','OH00002790484','IL','1','Estep','Rita','','','','34','268521717','125 MEDINA ST',0,'RITTMAN','OH','44270','1532','CY','39169','1950-08-24','F','M',':RET:2106-3','N','021','DEN','3729753','99734OH005000401','2014-03-01','2014-02-27 15:52:04','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-02-28 06:30:30'),(26850,21281,'Y','18','024','14','A','','','TE','0000508360','0000508360','','IL','1','Street','Roshanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-01','F','',NULL,NULL,NULL,'','2795567','','2014-02-28','2014-02-28 23:17:32',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-01 21:00:50'),(27217,21550,'Y','18','021','EC','A','','','AC','0000524661','0000524661','MS00002277375','IL','1','Jackson','Schelerria','','','','34','427691495','132 Body Rd',0,'Pickens','MS','39146',NULL,'CY','28089','1990-06-07','F','U',':RET:2054-5','N','021','DEN','3645163','46300MS002000201','2014-04-01','2014-03-03 11:12:37','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:32'),(240,201,'Y','18','024','14','A','','','TE','0000491838','0000491838','','IL','1','Snyder','Tabitha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-05','F','',NULL,NULL,NULL,'','1128915','','2013-12-05','2013-12-05 13:45:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:21:17'),(952,784,'N','19','021','EC','A',NULL,NULL,'','0000115452','0000061283','','IL','1','Rini','Vincent','Nicholas','','','34','278174544','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','2011-06-07','M','',':RET:2106-3','N','021','DEN','735562','99734OH005000301','2014-01-01','2013-10-31 11:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:35'),(14356,11450,'Y','18','021','EC','A','','','AC','0000932112','0000932112','OH00001607960','IL','1','Hutchison','Bruce',NULL,NULL,NULL,NULL,NULL,'4495 HAGERTY RD',0,'ASHVILLE','OH','43103','9783','CY','39129','1957-09-16','M','M',':RET:2106-3','T','021','DEN','1702280','99734OH005000401','2014-02-01','2013-12-26 19:07:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:09'),(14979,11971,'Y','18','021','EC','A','','','AC','0000718801','0000718801','TX00001629017','IL','1','CANTU','CAROLINA','','','','34','099642322','2390 SANTA MARIA LANE',0,'CORPUS CHRISTI','TX','78415',NULL,'CY','48355','1965-06-03','F','M',NULL,'N','021','DEN','2471734','33348TX002000201','2014-02-01','2013-12-30 13:44:08','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-01-01 12:01:01'),(16215,12985,'Y','18','021','EC','A','','','AC','0000671367','0000671367','MS00001368230','IL','1','Edwards','Tony','','','','34','425190613','136 Clem Thornhill Rd',0,'Foxworth','MS','39483',NULL,'CY','28091','1971-10-18','M','U',NULL,'N','021','DEN','2369875','46300MS002000101','2014-02-01','2014-01-04 00:49:35','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-05 00:01:36'),(16911,13532,'Y','18','021','EC','A','','','AC','0001015590','0001015590','OH00002532119','IL','1','Jones','Wendy','','','','34','298501239','104 ANNIS RD',0,'SOUTH AMHERST','OH','44001','3020','CY','39093','1961-03-16','F','M',':RET:2106-3','T','021','DEN','1557045','99734OH005000401','2014-02-01','2014-01-09 11:46:44','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:19:38'),(17265,13812,'N','19','021','EC','A',NULL,NULL,'','0000669198','0001010226','','IL','1','Karasek','Nicole','','','','34','268022519','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1996-09-07','F','',':RET:2106-3','N','021','DEN','1797637','99734OH005000301','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:19'),(20057,15997,'Y','18','021','EC','A','','','AC','0001023386','0001023386','TX00001694032','IL','1','Layne','Luther','','','','34','412880621','2011 FM 3277',0,'Livingston','TX','77351',NULL,'CY','48373','1952-07-26','M','M',':RET:2106-3','N','021','DEN','3392286','33348TX002000201','2014-03-01','2014-01-27 11:04:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:09'),(24885,19731,'N','01','021','EC','A',NULL,NULL,'','0000495492','0000640975','','IL','1','Kontout','Karen','','','','34','300645751','8191 SQUIRREL HOLLOW RDG',0,'WEST CHESTER','OH','45069','2115','CY','39017','1958-02-14','F','',':RET:2106-3','N','021','DEN','2845507','99734OH005000301','2014-03-01','2014-02-19 12:53:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-20 05:37:35'),(25323,20090,'Y','18','021','EC','A','','','AC','0001336664','0001336664','LA00002146717','IL','1','Ellis','Tammie','','','','34','436313038','504 Scott Street',0,'Lake Charles','LA','70601',NULL,'CY','22019','1977-06-15','F','U',NULL,'N','021','DEN','2679673','18575LA002000201','2014-04-01','2014-02-25 10:10:02','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-25 21:30:11'),(28522,22572,'Y','18','024','14','A','','','TE','0000284429','0000284429','','IL','1','Peiples','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-05-17','M','',NULL,NULL,NULL,'','2036130','','2014-03-31','2014-03-06 21:19:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-07 21:32:01'),(1488,1241,'Y','18','021','EC','A','','','AC','0001030376','0001030376','OH00000936103','IL','1','Nicholas','John','','','','34','277685018','252 Ohio Ave',0,'McDonald','OH','44437',NULL,'CY','39099','1959-07-13','M','U',NULL,'N','021','DEN','2527330','99734OH005000401','2014-01-01','2013-12-24 10:59:51','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:48:58'),(21322,17038,'N','01','021','EC','A',NULL,NULL,'','0002045234','0001808501','','IL','1','Davis','Kindra','','','','34','435775384','267 randy road',0,'West monroe','LA','71292',NULL,'CY','22073','1983-11-29','F','',':RET:2106-3','N','021','DEN','2672512','18575LA002000201','2014-03-01','2014-02-04 17:13:09',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:23'),(21262,16991,'Y','18','021','EC','A','','','AC','0000368308','0000368308','MS00002304077','IL','1','Robison','Jackie','','','','34','587409731','136 Benson Lake Rd',0,'Sunflower','MS','38778',NULL,'CY','28133','1951-12-14','M','U',':RET:2106-3','T','021','DEN','3667745','46300MS002000201','2014-03-01','2014-02-03 12:07:11','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-03 21:01:24'),(19399,15466,'Y','18','021','EC','A','','','AC','0000862458','0000862458','OH00001853944','IL','1','Cooper','Christopher','','','','34','275700340','231 S MONROE AVE',0,'COLUMBUS','OH','43205','1776','CY','39049','1975-12-05','M','U',':RET:2106-3','N','021','DEN','2795777','99734OH005000401','2014-03-01','2014-01-21 08:55:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-22 03:22:52'),(18856,15018,'Y','18','024','14','A','','','TE','0001981859','0001981859','','IL','1','Recio Torres','Martha','G',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-10-22','F','',NULL,NULL,NULL,'','1471708','','2014-01-15','2014-01-15 22:08:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-17 03:36:18'),(16741,13392,'N','01','021','EC','A',NULL,NULL,'','0000370039','0000384411','','IL','1','Sambor','Paul','R','','','34','302629120','112 RIDGEVIEW DR',0,'SEVEN HILLS','OH','44131','5618','CY','39035','1958-03-06','M','',':RET:2106-3','T','021','HLT','2071371','52664OH151001305','2014-02-01','2014-01-07 11:24:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','645.02',NULL,0,'2014-01-08 18:24:51'),(6384,5062,'Y','18','021','EC','A','','','AC','0000853024','0000853024','OH00000183313','IL','1','Bell','Justin','','','','34','268868405','819 Rockybrook Dr',0,'Akron','OH','44313',NULL,'CY','39153','1982-02-13','M','U',':RET:2106-3','N','021','DEN','150891','99734OH005000301','2014-01-01','2013-12-11 11:06:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:59'),(13499,10759,'Y','18','021','EC','A','','','AC','0001060908','0001060908','OH00000257547','IL','1','Gonzalez','Amanda','','','','34','296803534','59 E 1ST ST',0,'THE PLAINS','OH','45780','1213','CY','39009','1983-10-21','F','M',':RET:2106-3','T','021','DEN','1781751','99734OH005000301','2014-01-01','2013-12-23 19:12:47','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2013-12-26 13:02:33'),(15099,12068,'Y','18','021','EC','A','','','AC','0001138055','0001138055','OH00001859469','IL','1','Byerly','Trisha','Lynn','','','34','294904297','535 Cedarwood Road',0,'Columbus','OH','43207',NULL,'CY','39049','1984-12-14','F','U',':RET:2106-3','N','021','DEN','2398330','99734OH005000301','2014-02-01','2013-12-30 08:20:02','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:04:39'),(814,673,'N','01','021','EC','A',NULL,NULL,'','0001258640','0001216247','','IL','1','MARTIN','TODD','A','','','34','285600094','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1966-05-30','M','',':RET:2106-3','T','021','HLT','1411108','52664OH151001305','2014-01-01','2013-12-16 10:26:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','452.09',NULL,0,'2013-12-25 18:05:53'),(24612,19534,'Y','18','021','EC','A','','','AC','0000319075','0000319075','MS00001445544','IL','1','WASHINGTON','CAROLYN','','','','34','427110973','76203 ELIZABETH LN',0,'BRANDON','MS','39042','2741','CY','28121','1959-07-16','F','M',':RET:2054-5','N','021','DEN','3005194','46300MS002000201','2014-04-01','2014-02-18 18:28:43','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:14:17'),(1246,1026,'Y','18','021','EC','A','','','AC','0000115461','0000115461','OH00000911528','IL','1','grooms','gary','','','','34','283469969','175 KEPP RD',0,'LYNX','OH','45650','9737','CY','39001','1949-09-25','M','U',':RET:2106-3','N','021','HLT','599700','92036OH004000601','2014-01-01','2013-12-03 11:26:18','0.00',NULL,NULL,'517.83','517.83','R-OH005','OH0','517.83',NULL,0,'2013-12-25 18:21:05'),(15267,12205,'Y','18','021','EC','A','','','AC','0000680851','0000680851','OH00001417548','IL','1','Oliver','Tracy','','','','34','276820379','120 CAROLIN CT',0,'PERRYSBURG','OH','43551','1607','CY','39173','1968-06-28','F','U',':RET:2106-3','N','021','HLT','2315929','92036OH002002601','2014-02-01','2013-12-30 16:02:11','21.00',NULL,NULL,'468.18','447.18','R-OH001','OH0','325.18',NULL,0,'2014-01-01 12:09:30'),(9068,7197,'Y','18','021','EC','A','','','AC','0000291791','0000291791','TX00000565429','31','1','STEERS','TERRI','ANN','','','34','455111784','PO BOX 372',0,'FAIRFIELD','TX','75840',NULL,'CY','48161','1954-09-17','F','U',NULL,'N','021','DEN','2309352','33348TX002000101','2014-01-01','2013-12-18 17:00:42','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 04:06:32'),(7898,6244,'Y','18','024','14','A','','','TE','0000993940','0000993940','','IL','1','Wenning','Curtis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-07','M','',NULL,NULL,NULL,'','1177839','','2013-12-20','2013-12-20 13:00:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:05:45'),(7871,6226,'N','01','021','EC','A',NULL,NULL,'','0000328405','0000879479','','IL','1','Miller','Rebecca','L','','','34','270809109','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1969-06-25','F','',':RET:2106-3','N','021','DEN','2279031','99734OH005000301','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:11'),(3193,2569,'N','G8','021','EC','A',NULL,NULL,'','0000015736','0000014312','','IL','1','Polsky','Toby','Charlotte','','','34','351918704','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','2012-08-06','F','',NULL,'N','021','DEN','150521','18575LA002000101','2014-01-01','2013-10-02 23:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2013-12-25 20:32:14'),(6656,5279,'Y','18','021','EC','A','','','AC','0000731152','0000731152','OH00001101656','IL','1','TALLIERE','THEODORE','','','','34','282528411','723 UNIVERSITY RD',0,'CLEVELAND','OH','44113','3686','CY','39035','1954-03-09','M','U',':RET:2106-3','N','021','DEN','983455','99734OH005000401','2014-01-01','2013-11-16 08:25:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:00:42'),(5721,4541,'N','01','021','EC','A',NULL,NULL,'','0001566439','0002209205','','IL','1','Guy','Anita','','','','34','434170973','3429 W PARC GREEN ST',0,'HARVEY','LA','70058','7043','CY','22051','1960-08-16','F','',':RET:2054-5','N','021','DEN','1724098','18575LA002000201','2014-01-01','2013-12-23 21:32:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:45:24'),(5334,4230,'Y','18','021','EC','A','','','AC','0001053035','0001053035','OH00000290292','IL','1','newell','esther','','','','34','277542256','3062 CADWALLADER SONK RD',0,'CORTLAND','OH','44410','8801','CY','39155','1953-04-02','F','M',NULL,'N','021','DEN','2379523','99734OH005000301','2014-01-01','2013-12-19 14:09:10','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:07:10'),(5553,4407,'N','01','021','EC','A',NULL,NULL,'','0000230491','0000015199','','IL','1','ramos','susana','','','','34','525084743','216 E COTTONWOOD ST',0,'AMARILLO','TX','79108','2108','CY','48375','1961-09-18','F','',':RET:2106-3','N','021','DEN','1204219','33348TX002000201','2014-01-01','2013-11-26 22:17:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:16:12'),(15009,11997,'N','19','021','EC','A',NULL,NULL,'','0000473659','0001069327','','IL','1','USBERGHI','CAITLIN','ELIZABETH','','','34','288965926','2940 8TH ST',0,'CUYAHOGA FALLS','OH','44221','1622','CY','39153','1993-09-12','F','',':RET:2106-3','N','021','HLT','1875283','52664OH151001306','2014-02-01','2013-12-29 20:25:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-01 12:01:58'),(24949,19784,'Y','18','021','EC','A','','','AC','0001398774','0001398774','LA00001860631','IL','1','BAUMANN','BRUCE','ANTHONY','','','34','438118968','3211 SAINT ANN ST',0,'NEW ORLEANS','LA','70119','3918','CY','22071','1958-01-06','M','U',':RET:2106-3','N','021','DEN','2803033','18575LA002000201','2014-04-01','2014-02-19 22:39:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:10'),(25946,20576,'Y','18','024','14','A','','','TE','0000654587','0000654587','','IL','1','Nguyen','Quan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-06-18','M','',NULL,NULL,NULL,'','2481971','','2014-03-13','2014-02-26 09:23:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 21:01:33'),(28880,22856,'Y','18','021','EC','A','','','AC','0000193843','0000193843','TX00003264290','IL','1','Siglar','Tawanna','','','','34','455696493','201 BARBEE ST',0,'BRENHAM','TX','77833','3282','CY','48477','1982-09-21','F','U',':RET:2054-5','N','021','DEN','4280996','33348TX002000201','2014-04-01','2014-03-10 11:40:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:08'),(1010,827,'Y','18','021','EC','A','','','AC','0000630775','0000630775','TX00000333882','IL','1','Turella','Marcus','John','','','34','452879800','6112 Bridlington Circle',0,'Austin','TX','78745',NULL,'CY','48453','1975-02-18','M','M',':RET:2106-3','N','021','DEN','785465','33348TX002000201','2014-01-01','2013-10-23 18:26:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:11:13'),(22916,18267,'Y','18','024','14','A','','','TE','0000058794','0000058794','','IL','1','Hemmer','Kaitlin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-06-11','F','',NULL,NULL,NULL,'','3297941','','2014-02-11','2014-02-11 15:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:02:52'),(13887,11076,'N','01','021','EC','A',NULL,NULL,'','0000685845','0000955536','','IL','1','Evans','Cynthia','Elise','','','34','277743052','18300 PARKLAND DR',0,'SHAKER HEIGHTS','OH','44122','3449','CY','39035','1967-05-06','F','',':RET:2106-3','N','021','HLT','1935254','52664OH151001501','2014-01-01','2013-12-23 17:12:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','452.49',NULL,0,'2013-12-26 13:13:22'),(5581,4427,'Y','18','021','EC','A','','','AC','0001184944','0001184944','TX00000039227','IL','1','mcgee','john','','','','34','459939691','555 county road 4315',0,'omaha','TX','75571',NULL,'CY','48449','1976-02-01','M','M',':RET:2106-3','T','021','DEN','199100','33348TX002000201','2014-01-01','2013-11-06 00:05:59','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:16:57'),(9795,7756,'Y','18','021','EC','A','','','AC','0001046265','0001046265','TX00000421527','IL','1','Cotton','Kathryn','','','','34','510603564','3403 ROSS LN',0,'LAGO VISTA','TX','78645','7063','CY','48453','1954-12-18','F','M',':RET:2106-3','N','021','DEN','930959','33348TX002000201','2014-01-01','2013-10-20 14:58:11','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 05:01:05'),(4363,3465,'Y','18','021','EC','A','','','AC','0000924772','0000924772','OH00001264625','31','1','meier','manfred','','','','34','286561917','34520 maple dr',0,'solon','OH','44139',NULL,'CY','39133','1954-09-22','M','U',':RET:2106-3','N','021','DEN','1049292','99734OH005000401','2014-01-01','2013-12-11 19:03:13','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:00:05'),(3477,2792,'Y','18','021','EC','A','','','AC','0000769988','0000769988','OH00000514588','IL','1','Riesenberg','Gary','','','','34','283509947','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1963-05-22','M','M',':RET:2106-3','N','021','DEN','1874880','99734OH005000401','2014-01-01','2013-12-22 11:02:05','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:20:07'),(24853,19703,'Y','18','021','EC','A','','','AC','0000566664','0000566664','OH00001776211','IL','1','Stevens','Camaree','','','','34','269761538','2728 E HIGH ST',0,'SPRINGFIELD','OH','45505','1415','CY','39023','1977-11-11','F','U',':RET:2106-3','N','021','HLT','2933610','92036OH003000505','2014-04-01','2014-02-19 15:22:35','182.00',NULL,NULL,'305.34','123.34','R-OH003','OH0','305.34',NULL,0,'2014-02-20 04:55:43'),(25065,19878,'Y','18','024','14','A','','','TE','0000754565','0000754565','','IL','1','Mckitrick','Larry','','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-08-21','M','',NULL,NULL,NULL,'','1621000','','2014-03-31','2014-02-20 14:20:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-20 22:01:26'),(26615,21103,'N','01','021','EC','A',NULL,NULL,'','0000698566','0000987472','','IL','1','Gaona-Castellanos','Nacivivav','Samuel  Samuel','','','34','888537838','8901 Bissonnet St.',0,'HOUSTON','TX','77074',NULL,'CY','48201','1981-09-19','M','',NULL,'N','021','DEN','3014789','33348TX002000201','2014-04-01','2014-02-28 11:11:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 21:30:49'),(23497,18717,'N','01','021','EC','A',NULL,NULL,'','0001036819','0000595862','','IL','1','Mask','Joshua','James','','','34','466970766','6055 DOOLEY DR',0,'THE COLONY','TX','75056','1520','CY','48121','1987-01-05','M','',':RET:2106-3','N','021','DEN','3145544','33348TX002000101','2014-03-01','2014-02-12 22:45:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-13 22:02:06'),(22079,17623,'Y','18','021','EC','A','','','AC','0001555380','0001555380','LA00002080840','IL','1','Gebremeskel','Fetene','','','','34','660057262','4225 Hudson St',0,'Metairie','LA','70006',NULL,'CY','22051','1953-07-01','M','M',':RET:2054-5','N','021','DEN','2883765','18575LA002000201','2014-03-01','2014-02-08 13:24:28','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-08 19:00:17'),(18100,14458,'Y','18','021','EC','A','','','AC','0001590276','0001590276','LA00001983876','IL','1','Irvin','Michael','','','','34','437534548','2526 SAINT MAURICE AVE',0,'NEW ORLEANS','LA','70117','1626','CY','22071','1984-01-24','M','R',':RET:2054-5','T','021','DEN','2854828','18575LA002000201','2014-02-01','2014-01-14 16:04:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:33'),(16978,13588,'Y','18','024','14','A','','','TE','0000079712','0000079712','','IL','1','Picazo','Lilia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-11-21','F','',NULL,NULL,NULL,'','2000489','','2014-01-09','2014-01-09 09:57:31',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-13 02:20:17'),(16863,13492,'N','01','021','EC','A',NULL,NULL,'','0000086426','0001082144','','IL','1','Orr','Robert','Lyle','','','34','456611343','7700 State Highway 98',0,'Simms','TX','75574',NULL,'CY','48037','1982-06-22','M','',NULL,'N','021','DEN','1755512','33348TX002000201','2014-02-01','2014-01-09 10:26:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:19:11'),(6954,5523,'Y','18','021','EC','A','','','AC','0000117804','0000117804','OH00000766957','IL','1','tarsitano','thomas','','','','34','273688290','7970 mentor avenue',0,'mentor','OH','44060',NULL,'CY','39085','1964-10-06','M','U',':RET:2106-3','N','021','DEN','1383459','99734OH005000401','2014-01-01','2013-12-24 21:47:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:07'),(16526,13221,'Y','18','021','EC','A','','','AC','0000043493','0000043493','TX00002053261','IL','1','POWERS','KATHY','','','','34','465929414','147 FAIRGROUNDS RD',0,'REFUGIO','TX','78377',NULL,'CY','48391','1953-10-21','F','U',':RET:2106-3','N','021','DEN','2109755','33348TX002000201','2014-02-01','2014-01-05 14:01:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-07 10:21:55'),(945,780,'N','19','021','EC','A',NULL,NULL,'','0000321006','0000505699','','IL','1','Bundy','Liam','','','','34','302088196','218 BAKER ST',0,'LODI','OH','44254','1407','CY','39103','2004-08-12','M','',':RET:2106-3','N','021','DEN','133654','99734OH005000301','2014-01-01','2013-10-28 22:38:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:26'),(14812,11831,'Y','18','021','EC','A','','','AC','0001395982','0001395982','LA00000728414','IL','1','Philavong','Baxter','','','','34','557917813','730 S MAIN ST',0,'SAINT MARTINVILLE','LA','70582','4410','CY','22099','1950-12-13','M','M',NULL,'N','021','DEN','1422463','18575LA002000201','2014-01-01','2013-12-23 19:53:26','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:14:05'),(26172,20753,'Y','18','021','EC','A','','','AC','0000056301','0000056301','MS00002815293','IL','1','McClung','James','','','','34','428672975','210 North Second Avenue',0,'Cleveland','MS','38732',NULL,'CY','28011','1986-06-23','M','U',':RET:2106-3','N','021','DEN','3847523','46300MS002000201','2014-04-01','2014-02-27 11:39:41','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-28 06:30:36'),(28115,22251,'N','01','021','EC','A',NULL,NULL,'','0000968210','0000418858','','IL','1','MUSIL','TIMOTHY','I',NULL,NULL,NULL,NULL,'6810 CHIPPEWA ROAD',0,'MEDINA','OH','44256',NULL,'CY','39103','1959-09-08','M','',':RET:2106-3','T','021','HLT','4105330','52664OH152000901','2014-04-01','2014-03-06 16:54:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.04',NULL,0,'2014-03-06 21:02:17'),(23807,18943,'Y','18','021','EC','A','','','AC','0000977799','0000977799','TX00002849291','IL','1','GREEN','KYLIE','','','','34','628199001','3909 E 30TH',0,'ODESSA','TX','79762',NULL,'CY','48135','2008-12-24','F','R',':RET:2106-3','N','021','DEN','3588347','33348TX001000201','2014-03-01','2014-02-13 19:11:17','0.00',NULL,NULL,'38.22','38.22','R-TX017','TX0','38.22',NULL,0,'2014-02-14 21:31:33'),(13400,10694,'Y','18','021','EC','A','','','AC','0001075301','0001075301','OH00000169393','IL','1','Danner','David','','','','34','299649604','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1958-09-02','M','U',':RET:2106-3','N','021','DEN','2539568','99734OH005000301','2014-01-01','2013-12-23 09:16:03','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:19'),(682,561,'Y','18','024','14','A','','','TE','0000590764','0000590764','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','833538','','2013-12-16','2013-12-16 11:19:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:02:25'),(18040,14411,'N','01','021','EC','A',NULL,NULL,'','0000415983','0000885619','','IL','1','GRAY','TIMOTHY','K','','','34','367704893','1107 WOODVILLE RD',0,'TOLEDO','OH','43605',NULL,'CY','39095','1960-10-14','M','',':RET:2106-3','T','021','HLT','2513326','92036OH003002606','2014-02-01','2014-01-14 17:15:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','477.73',NULL,0,'2014-01-15 02:07:12'),(8132,6434,'Y','18','021','EC','A','','','AC','0000067638','0000067638','OH00000709207','IL','1','Hoener','Constance','Colleen','','','34','267023201','713 Talbott Dr',0,'Kettering','OH','45429',NULL,'CY','39113','1952-01-22','F','M',':RET:2106-3','N','021','DEN','300500','99734OH005000401','2014-01-01','2013-11-22 17:55:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:15:33'),(3316,2662,'N','01','021','EC','A',NULL,NULL,'','0000769988','0000053058','','IL','1','Riesenberg','Ann','','','','34','279660819','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1965-08-05','F','',':RET:2106-3','N','021','DEN','1482483','99734OH005000301','2014-01-01','2013-12-22 14:18:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:56'),(4330,3440,'Y','18','021','EC','A','','','AC','0000040937','0000040937','OH00001081190','IL','1','Wilson','Jamie','','','','34','272822473','117 ARMSTRONG ST',0,'GREENVILLE','OH','45331','1501','CY','39037','1984-02-23','F','M',':RET:2106-3','N','021','HLT','2352477','92036OH005000504','2014-01-01','2013-12-17 09:35:57','276.00',NULL,NULL,'531.98','255.98','R-OH003','OH0','265.99',NULL,0,'2013-12-25 21:53:00'),(5498,4365,'Y','18','021','EC','A','','','AC','0001169435','0001169435','OH00000053935','IL','1','HOOT','PEGGY','SUE','','','34','284582105','3561 TRUMAN RD',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1961-08-26','F','M',':RET:2106-3','T','021','HLT','2245320','92036OH002002601','2014-01-01','2013-12-19 17:01:49','0.00',NULL,NULL,'505.49','505.49','R-OH001','OH0','505.49',NULL,0,'2013-12-25 23:11:14'),(14308,11414,'Y','18','021','EC','A','','','AC','0000929847','0000929847','OH00000148304','IL','1','RIFE','CARMEN','','','','34','291841230','971 HOMEWOOD AVE SE',0,'WARREN','OH','44484','4908','CY','39155','1971-08-14','F','M',':RET:2054-5^:RET:2106-3','N','021','HLT','1770167','92036OH001003201','2014-02-01','2013-12-26 11:23:51','292.00',NULL,NULL,'750.69','458.69','R-OH013','OH0','386.87',NULL,0,'2013-12-27 02:07:00'),(13943,11118,'N','19','021','EC','A',NULL,NULL,'','0000661345','0001094640','','IL','1','Poshedley','Christopher','','','','34','289963679','11081 FAIRLAWN DR',0,'PARMA','OH','44130','1217','CY','39035','1993-09-01','M','',NULL,'T','021','HLT','1777511','92036OH003000804','2014-01-01','2013-12-22 22:14:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','155.05',NULL,0,'2013-12-26 13:14:45'),(13016,10374,'Y','18','021','EC','A','','','AC','0000909476','0000909476','OH00000857136','IL','1','Bowman','Kelly','','','','34','295788987','626 WOODFORD ST',0,'HAMILTON','OH','45013','3207','CY','39017','1965-12-24','F','R',NULL,'N','021','DEN','1667509','99734OH005000401','2014-01-01','2013-12-22 19:18:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:49:55'),(18509,14761,'Y','18','021','EC','A','','','AC','0000720266','0000720266','OH00002151141','IL','1','Schwieterman','Kyle','','','','34','273908716','03347 Shanverton Dr.',0,'New Bremen','OH','45869',NULL,'CY','39011','1988-11-04','M','U',NULL,'N','021','HLT','1730753','92036OH004001501','2014-02-01','2014-01-14 20:22:12','16.00',NULL,NULL,'290.06','274.06','R-OH002','OH0','177.68',NULL,0,'2014-01-16 08:46:33'),(19673,15677,'Y','18','024','14','A','','','TE','0000180341','0000180341','','IL','1','Corprew','Gerren','Demon',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-04-13','M','',NULL,NULL,NULL,'','2422023','','2014-01-22','2014-01-22 19:41:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:33'),(20581,16445,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000173845','','IL','1','Alshinnawi','Ibrahim','S','','','34','296949376','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1992-03-31','M','',':RET:2106-3','N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(20781,16603,'Y','18','021','EC','A','','','AC','0000684147','0000684147','TX00002160849','IL','1','Potts','Terry','','','','34','452860932','2911 SULPHER WELLS RD',0,'BELTON','TX','76513','7919','CY','48027','1953-02-20','M','M',':RET:2106-3','N','021','DEN','3394987','33348TX002000201','2014-03-01','2014-01-30 21:01:05','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-31 21:00:09'),(22085,17628,'Y','18','021','EC','A','','','AC','0001554365','0001554365','LA00002387539','IL','1','HUMBLE','DEBORAH','CAROL','','','34','439967285','359 JOHN KENT RD',0,'CALHOUN','LA','71225','8222','CY','22073','1952-08-31','F','U',NULL,'N','021','DEN','3629630','18575LA002000101','2014-03-01','2014-02-07 18:31:39','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-08 19:00:20'),(22340,17841,'Y','18','021','EC','A','','','AC','0000274814','0000274814','OH00001365032','IL','1','MEYERS','LARRY','','','','34','179405861','1544 GURLEY AVE',0,'AKRON','OH','44310','2513','CY','39153','1952-03-28','M','M',':RET:2106-3','N','021','HLT','3403211','52664OH151001501','2014-03-01','2014-01-24 10:47:43','444.52',NULL,NULL,'751.58','307.06','R-OH012','OH0','751.58',NULL,0,'2014-02-10 11:01:07'),(22614,18059,'Y','18','021','EC','A','','','AC','0000105131','0000105131','TX00002364930','IL','1','Vidal','Abigail','','','','34','638031763','601 South Louisiana',0,'San Diego','TX','78384',NULL,'CY','48131','1988-04-12','F','U',':RET:2106-3','N','021','DEN','2740378','33348TX002000201','2014-03-01','2014-02-10 18:51:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:06'),(25205,19994,'Y','18','021','EC','A','','','AC','0001697900','0001697900','LA00002239901','IL','1','BAGLAY','JOSHUA','','','','34','435617953','100 MCDONALD STREET',0,'LAFAYETTE','LA','70506',NULL,'CY','22055','1986-03-04','M','M',NULL,'N','021','DEN','3102049','18575LA002000201','2014-04-01','2014-02-21 17:27:37','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-02-21 22:00:48'),(25435,20181,'N','01','021','EC','A',NULL,NULL,'','0000723115','0000390902','','IL','1','LEE','CHING YUN','','','','34','621380315','2715 ARROWHEAD DR',0,'SUGAR LAND','TX','77479','1515','CY','48157','1953-02-20','M','',':RET:2034-7','N','021','DEN','3125017','33348TX002000201','2014-04-01','2014-02-25 00:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-25 21:31:17'),(25583,20294,'Y','18','024','14','A','','','TE','0000730002','0000730002','','IL','1','Mason','Corey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-01-04','M','',NULL,NULL,NULL,'','3104934','','2014-02-24','2014-02-24 13:11:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-26 08:00:38'),(26163,20745,'N','01','021','EC','A',NULL,NULL,'','0000422866','0001213513','','IL','1','Orelli','Carol','J','','','34','287520279','153 DEERFIELD LN',0,'AURORA','OH','44202','7521','CY','39133','1951-12-17','F','',':RET:2106-3','N','021','DEN','2813689','99734OH005000401','2014-04-01','2014-02-27 17:54:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:33'),(28120,22254,'N','19','021','EC','A',NULL,NULL,'','0001109284','0000120149','','IL','1','Rowland','Riley','J','','','34','791275465','1568 COUNTY ROAD P',0,'MC CLURE','OH','43534','9714','CY','39069','2013-05-09','F','',':RET:2106-3','N','021','HLT','3666103','92036OH003002601','2014-04-01','2014-03-05 22:31:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-06 21:02:20'),(194,162,'N','01','021','EC','A',NULL,NULL,'','0000194024','0001024234','','IL','1','Beverly','Ronald','Lee','','Sr','34','270561771','607 E HIGH ST',0,'HICKSVILLE','OH','43526','1222','CY','39039','1954-04-28','M','',':RET:2106-3','T','021','HLT','959545','92036OH006002601','2014-01-01','2013-12-05 10:26:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','462.93',NULL,0,'2013-12-25 17:20:02'),(9181,7282,'Y','18','024','14','A','','','TE','0001125407','0001125407','','IL','1','King','Diane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-06','F','',NULL,NULL,NULL,'','20221','','2013-12-18','2013-12-18 12:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:11'),(17784,14207,'N','01','021','EC','A',NULL,NULL,'','0000294433','0000295517','','IL','1','Dietrich','Kara','M','','','34','296660761','320 W 5th Street',0,'Port Clinton','OH','43452',NULL,'CY','39123','1974-11-15','F','',NULL,'N','021','HLT','2494975','92036OH005002706','2014-02-01','2014-01-13 13:26:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','246.08',NULL,0,'2014-01-14 01:33:44'),(6884,5460,'Y','18','021','EC','A','','','AC','0001413915','0001413915','LA00001120604','IL','1','Skidmore','Shanti','','','','34','433851349','632 University Walk',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1992-05-18','F','U',':RET:2054-5','N','021','DEN','2187122','18575LA002000201','2014-01-01','2013-12-24 19:05:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:09'),(14284,11394,'N','01','021','EC','A',NULL,NULL,'','0000516389','0000795113','','IL','1','Dorsey','Carrie','','','','34','587063595','338 SWAN LAKE DR',0,'JACKSON','MS','39212','5338','CY','28049','1965-05-01','F','',':RET:2054-5','N','021','DEN','2427800','46300MS002000201','2014-02-01','2013-12-26 17:16:48',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-27 02:06:24'),(2727,2205,'Y','18','021','EC','A','','','AC','0000941343','0000941343','LA00000881659','IL','1','BATEMAN','THERESA','FOWLER','','','34','436112430','17266 SUMMERFIELD RD S',0,'PRAIRIEVILLE','LA','70769',NULL,'CY','22005','1959-09-26','F','M',':RET:2106-3','N','021','DEN','1009981','18575LA002000201','2014-01-01','2013-12-02 17:06:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:48:21'),(20761,16587,'Y','18','021','EC','A','','','AC','0000182328','0000182328','OH00001538311','IL','1','SIMONS','LINDA','','','','34','271529431','1854 COUNTY ROAD 140',0,'VAN BUREN','OH','45889','9625','CY','39063','1950-04-20','F','M',':RET:2106-3','N','021','HLT','2709173','92036OH003001501','2014-03-01','2014-01-30 13:54:53','451.00',NULL,NULL,'824.41','373.41','R-OH002','OH0','678.46',NULL,0,'2014-01-30 21:01:35'),(21249,16980,'Y','18','021','EC','A','','','AC','0000240385','0000240385','OH00002577505','IL','1','DeCrane','James','','','','34','269861949','4345 APPLE ORCH',0,'ROOTSTOWN','OH','44272','9303','CY','39133','1970-07-30','M','U',':RET:2106-3','T','021','DEN','1811824','99734OH005000301','2014-03-01','2014-02-03 18:20:41','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-03 21:01:16'),(21920,17507,'Y','18','024','14','A','','','TE','0000764941','0000764941','','IL','1','Rice','Beatrica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-07-06','F','',NULL,NULL,NULL,'','3782338','','2014-02-06','2014-02-06 18:51:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-07 19:00:05'),(23431,18665,'N','01','021','EC','A',NULL,NULL,'','0000520158','0000799729','','IL','1','Tippett','William','','','','34','457937749','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','1981-02-05','M','',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:26'),(24225,19238,'Y','18','021','EC','A','','','AC','0001253587','0001253587','OH00002568539','IL','1','Hurley','Pamela','','','','34','284725819','511 N NIXON AVE',0,'LIMA','OH','45805','1811','CY','39003','1961-02-16','F','M',NULL,'T','021','DEN','2623865','99734OH005000401','2014-03-01','2014-02-15 20:29:08','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-16 19:00:31'),(28065,22209,'Y','18','021','EC','A','','','AC','0000928558','0000928558','OH00002982975','IL','1','Whipkey','Patricia','','','','34','301447823','1956 LAKESIDE DR',0,'MADISON','OH','44057','2168','CY','39085','1951-02-19','F','U',':RET:2106-3','N','021','DEN','3861144','99734OH005000301','2014-04-01','2014-03-06 12:05:07','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:46'),(2911,2346,'N','01','021','EC','A',NULL,NULL,'','0000162247','0000172377','','IL','1','SHORT','ALEXANDRIA','','','','34','301886535','4973 WABASH DR',0,'FAIRFIELD','OH','45014','1564','CY','39017','1988-09-07','F','',':RET:2106-3','T','021','DEN','991471','99734OH005000401','2014-01-01','2013-12-06 11:24:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:33'),(14385,11473,'N','01','021','EC','A',NULL,NULL,'','0000294418','0000659917','','IL','1','HUNDLEY','SUSAN','JO','','','34','262398804','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-07-07','F','',NULL,'N','021','DEN','2213563','99734OH005000401','2014-02-01','2013-12-27 14:07:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:51'),(3043,2445,'Y','18','021','EC','A','','','AC','0000970432','0000970432','OH00001061148','IL','1','Deger','Richard','','','','34','159383105','1436 WATERS EDGE DR',0,'AKRON','OH','44313','8635','CY','39153','1951-02-12','M','M',':RET:2106-3','N','021','HLT','662317','52664OH152000901','2014-01-01','2013-12-06 13:42:40','678.00',NULL,NULL,'885.47','207.47','R-OH012','OH0','469.28',NULL,0,'2013-12-25 20:18:41'),(19002,15134,'Y','18','021','EC','A','','','AC','0001640013','0001640013','LA00001947962','IL','1','Leary','Arnold','F','','','34','437868233','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1953-07-11','M','M',':RET:2054-5','N','021','DEN','1639262','18575LA002000201','2014-03-01','2014-01-17 11:55:35','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-01-20 08:06:16'),(19809,15793,'Y','18','021','EC','A','','','AC','0001162013','0001162013','TX00002123215','IL','1','waller','terry','','','','34','449020214','4712 COUNTRY AIRE DR',0,'WACO','TX','76708','5629','CY','48309','1955-05-11','M','U',':RET:2106-3','N','021','DEN','2480201','33348TX002000201','2014-03-01','2014-01-24 15:38:13','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-01-24 21:00:08'),(22316,17817,'Y','18','021','EC','A','','','AC','0000221341','0000221341','OH00001826573','IL','1','Morgan','Carol','E','','','34','291505072','3171 Preserve Ln',0,'Cincinnati','OH','45239',NULL,'CY','39061','1951-04-11','F','U',':RET:2106-3','N','021','HLT','3179365','92036OH005001205','2014-03-01','2014-01-27 12:37:15','434.00',NULL,NULL,'616.74','182.74','R-OH004','OH0','616.74',NULL,0,'2014-02-10 11:00:50'),(22545,18002,'N','01','021','EC','A',NULL,NULL,'','0002091948','0001716331','','IL','1','ROWTON','CHAD','','','','34','433396771','841 SAM HEAD RD',0,'EROS','LA','71238','8448','CY','22073','1976-05-09','M','',':RET:2106-3','N','021','DEN','3519032','18575LA002000101','2014-03-01','2014-02-10 12:13:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-10 21:31:41'),(23793,18933,'N','19','021','EC','A',NULL,NULL,'','0000153413','0001001206','','IL','1','McAdoo','Matthew','','','','34','270020278','324 Huntsford Drive',0,'Macedonia','OH','44056',NULL,'CY','39153','1996-08-07','M','',NULL,'N','021','HLT','2869404','52664OH151001304','2014-03-01','2014-02-14 10:18:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-14 21:31:25'),(24148,19187,'Y','18','021','EC','A','','','AC','0000493282','0000493282','OH00001771561','IL','1','Coffey','Mark','','','','34','278629870','3124 LINDALE MOUNT HOLLY RD',0,'AMELIA','OH','45102','9703','CY','39025','1961-04-08','M','M',':RET:2106-3','N','021','HLT','3285701','92036OH004000601','2014-03-01','2014-02-15 12:50:50','287.00',NULL,NULL,'689.06','402.06','R-OH005','OH0','336.93',NULL,0,'2014-02-15 22:01:54'),(24508,19469,'Y','18','021','EC','A','','','AC','0000052143','0000052143','TX00002983845','IL','1','TINDALL','KYIA','','','','34','497861434','11201 VERANS MEMORIAL DR',0,'HOUSTON','TX','77067',NULL,'CY','48201','1983-01-11','F','U',':RET:2054-5','N','021','DEN','3164043','33348TX002000201','2014-04-01','2014-02-19 01:35:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 03:52:11'),(27409,21695,'N','01','021','EC','A',NULL,NULL,'','0001111728','0000321092','','IL','1','LASKY','ANTHONY','J','','','34','294920807','3195 LINCOLN ST',0,'LORAIN','OH','44052','2714','CY','39093','1988-05-22','M','',':RET:2106-3','N','021','DEN','3441137','99734OH005000301','2014-04-01','2014-03-04 10:56:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:34'),(28413,22482,'Y','18','021','EC','A','','','AC','0000178960','0000178960','OH00003783526','IL','1','Turner','Teresa','','','','34','286666433','4308 32ND AVE',0,'CINCINNATI','OH','45209','1625','CY','39061','1964-06-20','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3833234','99734OH005000401','2014-04-01','2014-03-07 12:09:56','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:30:58'),(6750,5356,'Y','18','021','EC','A','','','AC','0000411079','0000411079','OH00000188977','IL','1','NETH','MARY','','','','34','293467631','1420 GLENN AVE',0,'LIMA','OH','45804','2744','CY','39003','1949-09-25','F','U',':RET:2106-3','N','021','HLT','906324','92036OH003001505','2014-01-01','2013-11-25 13:07:17','684.00',NULL,NULL,'689.49','5.49','R-OH002','OH0','689.49',NULL,0,'2013-12-26 01:16:04'),(5855,4650,'Y','18','021','EC','A','','','AC','0000789971','0000789971','TX00000424887','IL','1','Hames','Glen','Patrick','','','34','558539599','65 N. Kessler Avenue',0,'Schulenburg','TX','78956',NULL,'CY','48149','1963-08-13','M','U',':RET:2106-3','T','021','DEN','2197433','33348TX002000201','2014-01-01','2013-12-24 01:26:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:48:53'),(15905,12737,'Y','18','021','EC','A','','','AC','0001223181','0001223181','OH00000207136','IL','1','Hubert','Tina','','','','34','404861162','630 Liberty street',0,'Van Wert','OH','45891',NULL,'CY','39161','1960-10-27','F','M',':RET:2106-3','N','021','HLT','2068753','92036OH005001505','2014-02-01','2014-01-02 18:01:53','316.00',NULL,NULL,'448.97','132.97','R-OH002','OH0','448.97',NULL,0,'2014-01-03 02:06:12'),(2342,1907,'Y','18','021','EC','A','','','AC','0000692080','0000692080','TX00000871458','IL','1','Duncan','Michael','','','','34','439298281','3327 WHIRLAWAY RD',0,'DALLAS','TX','75229','5941','CY','48113','1960-12-23','M','R',':RET:2106-3','T','021','DEN','538567','33348TX002000201','2014-01-01','2013-12-09 13:47:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:31:59'),(2870,2320,'Y','18','021','EC','A','','','AC','0000599175','0000599175','TX00000101545','IL','1','Sylvester','Jerry','','','','34','386620023','2414 FAIRWAY POINTE DR',0,'LEAGUE CITY','TX','77573','5551','CY','48167','1954-12-23','M','M',NULL,'N','021','DEN','33202','33348TX002000201','2014-01-01','2013-10-21 19:43:21','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:01:55'),(20226,16138,'Y','18','021','EC','A','','','AC','0001250873','0001250873','OH00001431458','IL','1','Schlueter','Joseph',NULL,NULL,NULL,NULL,NULL,'10534 JOHN WOODS RD',0,'WINCHESTER','OH','45697','9627','CY','39015','1955-10-22','M','M',':RET:2106-3','N','021','HLT','3182869','92036OH005000604','2014-03-01','2014-01-27 15:34:17','400.00',NULL,NULL,'984.90','584.90','R-OH005','OH0','546.97',NULL,0,'2014-01-27 21:01:48'),(22631,18072,'Y','18','021','EC','A','','','AC','0000906394','0000906394','TX00001945737','IL','1','Newhouse','Jerica','','','','34','628165646','5480 Preakness ln',0,'Dallas','TX','75211',NULL,'CY','48113','1989-03-05','F','U',':RET:2054-5','N','021','DEN','3060965','33348TX002000201','2014-03-01','2014-02-11 00:18:57','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:17'),(22951,18299,'Y','18','024','14','A','','','TE','0000327240','0000327240','','IL','1','ROLLER','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-08','F','',NULL,NULL,NULL,'','3204086','','2014-02-28','2014-02-11 16:55:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:29'),(26198,20776,'Y','18','021','EC','A','','','AC','0001021524','0001021524','OH00002410833','IL','1','Suveges','Jane','','','','34','282482366','9100 OLDE 8 RD',0,'NORTHFIELD','OH','44067','2773','CY','39153','1956-08-29','F','U',':RET:2106-3','N','021','HLT','2862382','52664OH151001304','2014-04-01','2014-02-26 18:45:17','326.00',NULL,NULL,'543.47','217.47','R-OH012','OH0','543.47',NULL,0,'2014-02-28 06:30:47'),(28500,22552,'Y','18','024','14','A','','','TE','0001100651','0001100651','','IL','1','Mallardi','Chloe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-08-05','F','',NULL,NULL,NULL,'','3831002','','2014-03-06','2014-03-06 20:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:48'),(3048,2448,'Y','18','021','EC','A','','','AC','0000294318','0000294318','LA00000211217','IL','1','Phan','Tuyen','','','','34','439453581','7509 HICKORY RIDGE DR',0,'DENHAM SPRINGS','LA','70706','1940','CY','22063','1956-05-30','F','M',':RET:2047-9','N','021','DEN','693631','18575LA002000201','2014-01-01','2013-12-05 21:46:35','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:18:49'),(1626,1358,'Y','18','024','14','A','','','TE','0000440537','0000440537','','IL','1','MATTICK','CAROL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-01-13','F','',NULL,NULL,NULL,'','1103883','','2013-12-24','2013-12-24 14:07:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:52:43'),(17381,13907,'Y','18','021','EC','A','','','AC','0000647084','0000647084','OH00001749838','IL','1','Eichler','Nicholas','','','','34','430519827','129 W 1ST AVE',0,'COLUMBUS','OH','43201','3489','CY','39049','1979-08-31','M','U',':RET:2106-3','T','021','DEN','2012586','99734OH005000401','2014-02-01','2014-01-09 23:17:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 03:00:06'),(16860,13490,'Y','18','021','EC','A','','','AC','0001186492','0001186492','TX00001636275','IL','1','Madkins','Dusty','','','','34','446789316','2309 34th street',0,'Lubbock','TX','79411',NULL,'CY','48303','1981-06-16','M','U',':RET:2054-5','T','021','DEN','1424000','33348TX002000201','2014-02-01','2014-01-08 22:49:45','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-13 02:19:09'),(26993,21380,'N','19','021','EC','A',NULL,NULL,'','0000779160','0000658480','','IL','1','Vo','Matthew','','','','34','285156010','6938 Hawksbeard dr',0,'Westerville','OH','43082',NULL,'CY','39041','2009-09-07','M','',':RET:2047-9','N','021','DEN','3839908','99734OH005000301','2014-04-01','2014-03-02 11:43:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 01:29:59'),(159,133,'Y','18','021','EC','A','','','AC','0000713579','0000713579','TX00000813764','IL','1','Hooper','Elizabeth','C','','','34','459212171','3705 CONCORD RD',0,'BEAUMONT','TX','77703','2705','CY','48245','1965-03-26','F','R',':RET:2106-3','N','021','DEN','205854','33348TX002000101','2014-01-01','2013-12-05 12:42:16','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2013-12-25 17:19:08'),(9558,7576,'Y','18','021','EC','A','','','AC','0000998760','0000998760','OH00000075572','IL','1','Horner','Torey','','','','34','273661184','347 DEER CREEK TRL',0,'CORTLAND','OH','44410','2606','CY','39155','1959-06-20','F','M',':RET:2106-3','N','021','DEN','2548355','99734OH005000301','2014-01-01','2013-12-21 15:12:20','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:36:28'),(22251,17759,'N','01','021','EC','A',NULL,NULL,'','0000050715','0000149375','','IL','1','CONTI','CATHERINE','','','','34','278602593','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1960-03-29','F','',':RET:2106-3','N','021','HLT','3549898','52664OH151001501','2014-03-01','2014-02-09 13:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','615.39',NULL,0,'2014-02-09 19:00:42'),(21968,17542,'Y','18','021','EC','A','','','AC','0000542724','0000542724','OH00002266868','IL','1','Gerding','Katherine','','','','34','286883852','719 E State St',0,'Port Clinton','OH','43452',NULL,'CY','39123','1980-05-07','F','U',':RET:2106-3','N','021','HLT','3690334','92036OH004002701','2014-03-01','2014-02-06 18:26:07','160.00',NULL,NULL,'187.83','27.83','R-OH006','OH0','187.83',NULL,0,'2014-02-07 19:00:29'),(18385,14674,'Y','18','021','EC','A','','','AC','0000234070','0000234070','OH00002432362','IL','1','Caley','Brenda','Sue','','','34','278509697','1450 SLEEPY HOLLOW DR',0,'COSHOCTON','OH','43812','2933','CY','39031','1951-03-07','F','M',':RET:2106-3','N','021','DEN','1658511','99734OH005000301','2014-02-01','2014-01-15 16:00:11','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-01-16 08:45:37'),(18117,14470,'Y','18','021','EC','A','','','AC','0000330901','0000330901','OH00001726556','IL','1','kelly','michael','','','','34','278526676','2000 RUSTIC TRL',0,'MOGADORE','OH','44260','1837','CY','39133','1951-06-02','M','M',':RET:2106-3','N','021','HLT','1389553','52664OH152000901','2014-02-01','2014-01-14 11:35:16','346.00',NULL,NULL,'469.28','123.28','R-OH012','OH0','469.28',NULL,0,'2014-01-15 02:07:39'),(16535,13227,'Y','18','021','EC','A','','','AC','0000499319','0000499319','OH00001415513','31','1','LEE','TERESA','','','','34','298768923','P.O. BOX 266',0,'WADSWORTH','OH','44282',NULL,'CY','39103','1965-04-05','F','U',':RET:2106-3','N','021','HLT','1968912','52664OH152000901','2014-02-01','2014-01-04 23:43:32','268.00',NULL,NULL,'370.78','102.78','R-OH012','OH0','267.06',NULL,1,'2014-01-07 10:22:09'),(16414,13136,'Y','18','021','EC','A','','','AC','0000618379','0000618379','OH00001973206','IL','1','Daugherty','Dexter','','','','34','401372022','5653 View Pointe Dr',0,'Cincinnati','OH','45213',NULL,'CY','39061','1988-11-21','M','U',':RET:2054-5','T','021','HLT','2571076','92036OH006001201','2014-02-01','2014-01-06 15:00:02','0.00',NULL,NULL,'196.57','196.57','R-OH004','OH0','196.57',NULL,0,'2014-01-07 04:04:19'),(13988,11144,'Y','18','021','EC','A','','','AC','0000810787','0000810787','OH00001157772','IL','1','TARRANT','MARGARET','DOWELL','','','34','235154996','211 LARCH LN',0,'SWANTON','OH','43558','8698','CY','39051','1967-01-16','F','R',':RET:2054-5','N','021','HLT','1873855','92036OH001002601','2014-01-01','2013-12-23 13:01:30','0.00',NULL,NULL,'705.62','705.62','R-OH001','OH0','352.81',NULL,0,'2013-12-26 13:15:44'),(14132,11264,'Y','18','024','14','A','','','TE','0000025403','0000025403','','IL','1','Minson','Beau','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-09-26','M','',NULL,NULL,NULL,'','693656','','2013-12-26','2013-12-26 09:50:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:25'),(14458,11535,'Y','18','024','14','A','','','TE','0000180085','0000180085','','IL','1','Bright','Charlotte',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-10-26','F','',NULL,NULL,NULL,'','85682','','2013-12-27','2013-12-27 15:34:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-28 03:32:42'),(15568,12458,'Y','18','021','EC','A','','','AC','0000413362','0000413362','OH00000582824','IL','1','Shaheen','Terrie','Lee','','','34','269605350','6061 LAKEWOOD ST NW',0,'CANTON','OH','44718','1346','CY','39151','1956-07-08','F','U',':RET:2106-3','N','021','HLT','2293788','52664OH151001306','2014-02-01','2013-12-31 12:50:12','446.00',NULL,NULL,'543.47','97.47','R-OH015','OH0','543.47',NULL,1,'2014-01-02 04:31:48'),(26146,20731,'Y','18','021','EC','A','','','AC','0001003356','0001003356','OH00002066644','IL','1','HUBER','JUDY','','','','34','294628870','75 MAPLE DR',0,'YOUNGSTOWN','OH','44512','1521','CY','39099','1957-01-03','F','M',':RET:2106-3','N','021','DEN','3863017','99734OH005000401','2014-04-01','2014-02-27 13:42:29','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-02-28 06:30:27'),(26653,21130,'N','19','021','EC','A',NULL,NULL,'','0000976793','0000491936','','IL','1','Christy','Abbie','','','','34','279138277','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2007-05-05','F','',':RET:2106-3','N','021','HLT','3502526','52664OH151001305','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:08'),(27532,21782,'Y','18','021','EC','A','','','AC','0001094709','0001094709','OH00002526487','IL','1','Morgan','Zachary','Thomas','','','34','352829610','2489 Neal Rd',0,'Urbana','OH','43078',NULL,'CY','39021','1989-02-09','M','M',':RET:2106-3','N','021','HLT','2674713','92036OH004000501','2014-04-01','2014-03-04 17:06:34','384.80',NULL,NULL,'387.63','2.83','R-OH003','OH0','191.91',NULL,0,'2014-03-04 21:02:48'),(28317,22404,'Y','18','021','EC','A','','','AC','0001045556','0001045556','TX00003028038','IL','1','FRANK','AL','','','','34','431579908','6207 RETLIN CT',0,'HOUSTON','TX','77041','5975','CY','48201','1962-10-10','M','U',':RET:2106-3','N','021','DEN','2770513','33348TX002000201','2014-04-01','2014-03-06 18:09:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:02'),(28397,22467,'Y','18','021','EC','A','','','AC','0000861027','0000861027','OH00003197013','IL','1','MARTIN','ROGER','','','','34','287740490','1154 S CASSINGHAM RD',0,'COLUMBUS','OH','43209','2825','CY','39049','1964-07-11','M','M',':RET:2054-5','N','021','DEN','4057617','99734OH005000401','2014-04-01','2014-03-06 20:12:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:30:48'),(507,414,'Y','18','021','EC','A','','','AC','0000481040','0000481040','OH00000512828','IL','1','Sorkin','Adam','','','','34','055623059','2222 Detroit Ave.',0,'Cleveland','OH','44113',NULL,'CY','39035','1978-03-29','M','R',':RET:2106-3','N','021','DEN','527172','99734OH005000301','2014-01-01','2013-12-03 19:37:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:48:50'),(1546,1289,'Y','18','021','EC','A','','','AC','0000919395','0000919395','OH00000512418','IL','1','SUN','YANFEN','','','','34','276040794','21710 FAIRMOUNT BLVD',0,'SHAKER HEIGHTS','OH','44118','4814','CY','39035','1962-04-12','F','R',':RET:2034-7','N','021','DEN','1869377','99734OH005000401','2014-01-01','2013-12-24 18:10:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:27'),(21855,17451,'N','01','021','EC','A',NULL,NULL,'','0000984886','0000752061','','IL','1','RESER','JACQUELYN','','','','34','294807051','5909 THORNBERRY CT',0,'MASON','OH','45040','7757','CY','39165','1983-03-30','F','',NULL,'N','021','DEN','3253048','99734OH005000301','2014-03-01','2014-02-05 23:34:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:17'),(9108,7229,'N','19','021','EC','A',NULL,NULL,'','0001135152','0000122968','','IL','1','Cremeans','Samual','','','','34','284115489','46343 Scout Camp Rd',0,'Chester','OH','45720',NULL,'CY','39105','2005-08-10','M','',':RET:2106-3','N','021','DEN','2250070','99734OH005000301','2014-01-01','2013-12-18 15:33:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:32'),(21165,16914,'Y','18','021','EC','A','','','AC','0000077594','0000077594','OH00001375730','31','1','SANDIDGE','JEFF','','','','34','274580044','P.O BOX 1394',0,'ASHTABULA','OH','44005',NULL,'CY','39007','1957-08-01','M','U',':RET:2054-5','N','021','DEN','3127156','99734OH005000401','2014-03-01','2014-02-03 11:41:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:35'),(19013,15141,'Y','18','021','EC','A','','','AC','0002123804','0002123804','LA00002380684','IL','1','Shackelford','Taj','','','','34','616226247','200 CARONDELET ST',0,'NEW ORLEANS','LA','70130','2922','CY','22071','1989-02-03','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','1363347','18575LA002000201','2014-03-01','2014-01-17 15:06:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-20 08:06:21'),(18227,14548,'Y','18','021','EC','A','','','AC','0001181477','0001181477','TX00001733950','IL','1','Mock','George','','','','34','184363208','26755 BAYOU TESCH DR',0,'MAGNOLIA','TX','77354','2818','CY','48339','1950-04-21','M','R',':RET:2106-3','N','021','DEN','1626402','33348TX002000201','2014-02-01','2014-01-14 20:57:06','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-16 08:44:17'),(4073,3255,'Y','18','021','EC','A','','','AC','0000629231','0000629231','OH00000942280','IL','1','Robson','Elihudi','','','','34','288131590','3450 Partridge place',0,'Columbus','OH','43231',NULL,'CY','39049','1969-06-21','M','M',':RET:2054-5','N','021','DEN','1615999','99734OH005000401','2014-01-01','2013-12-17 18:22:13','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:58'),(13566,10819,'Y','18','021','EC','A','','','AC','0001873149','0001873149','LA00001072878','IL','1','Mack','Roy','','','','34','435866362','11070 MEAD RD',0,'BATON ROUGE','LA','70816','2295','CY','22033','1952-02-28','M','U',':RET:2054-5','N','021','DEN','2527249','18575LA002000201','2014-01-01','2013-12-23 16:36:53','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:30'),(6146,4874,'N','01','021','EC','A',NULL,NULL,'','0001188762','0000939734','','IL','1','WAGNER','THRESIA','S','','','34','279725518','1782 DRY BONE ROAD',0,'PEEPLES','OH','45660',NULL,'CY','39131','1964-12-23','F','',':RET:2106-3','T','021','DEN','1140206','99734OH005000301','2014-01-01','2013-11-21 10:24:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:16:24'),(7359,5828,'Y','18','021','EC','A','','','AC','0000937869','0000937869','TX00000454315','IL','1','Jackson','Noreen','','','','34','461862664','103 Habitat Ct.',0,'Longveiw','TX','75601',NULL,'CY','48183','1952-02-17','F','U',':RET:2054-5','N','021','DEN','1006071','33348TX002000201','2014-01-01','2013-11-23 16:06:08','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 02:15:20'),(5858,4652,'Y','18','021','EC','A','','','AC','0001070474','0001070474','OH00000368457','IL','1','SMART','DAVID','','','','34','277589450','1660 N STADIUM RD',0,'OREGON','OH','43616','1119','CY','39095','1955-07-08','M','M',NULL,'N','021','HLT','1585686','92036OH005002605','2014-01-01','2013-12-23 21:46:03','823.00',NULL,NULL,'993.68','170.68','R-OH001','OH0','496.84',NULL,0,'2013-12-25 23:48:58'),(27506,21762,'Y','18','024','14','A','','','TE','0001243027','0001243027','','IL','1','Horsey','Cindy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-26','F','',NULL,NULL,NULL,'','3421646','','2014-03-04','2014-03-04 14:51:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:31'),(27776,21966,'Y','18','021','EC','A','','','AC','0000795588','0000795588','OH00002728210','IL','1','SCOTT','ERIC','','','','34','269605212','7054 AVON LAKE RD',0,'SPENCER','OH','44275',NULL,'CY','39103','1962-01-12','M','M',':RET:2106-3','N','021','HLT','3780748','52664OH152000901','2014-04-01','2014-03-05 10:25:25','24.00',NULL,NULL,'318.84','294.84','R-OH012','OH0','318.84',NULL,0,'2014-03-05 21:31:30'),(23166,18469,'Y','18','021','EC','A','','','AC','0001240554','0001240554','TX00001514494','IL','1','MERCADO','DAISY','','','','34','582061461','1710 KYLIE CIR',0,'KILLEEN','TX','76549','1208','CY','48027','1960-05-14','F','M',':RET:2106-3','N','021','DEN','2952627','33348TX002000101','2014-03-01','2014-02-12 14:27:00','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2014-02-12 21:31:50'),(3062,2460,'Y','18','021','EC','A','','','AC','0000906717','0000906717','LA00000302366','IL','1','CEJA','GLORIA','','','','34','437982329','1220 LAMPKIN STREET',0,'BOSSIER CITY','LA','71111',NULL,'CY','22015','1954-10-17','F','M',':RET:2054-5','N','021','DEN','1197042','18575LA002000201','2014-01-01','2013-12-06 10:53:23','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 20:19:12'),(20067,16006,'Y','18','024','14','A','','','TE','0000374425','0000374425','','IL','1','ALLEN','DION',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-11-21','M','',NULL,NULL,NULL,'','2617080','','2014-01-27','2014-01-27 13:34:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:15'),(8903,7060,'Y','18','024','14','A','','','TE','0000396145','0000396145','','IL','1','Phillips','Brenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-26','F','',NULL,NULL,NULL,'','1631920','','2013-12-17','2013-12-17 19:59:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:02:20'),(18337,14643,'Y','18','021','EC','A','','','AC','0000129277','0000129277','OH00001554684','IL','1','dehart','Melissa','','','','34','269901971','5491 st rt 138',0,'hillsboro','OH','45133',NULL,'CY','39071','1983-03-14','F','U',NULL,'N','021','DEN','1626444','99734OH005000401','2014-02-01','2014-01-15 17:38:32','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:45:15'),(16542,13233,'Y','18','021','EC','A','','','AC','0000767412','0000767412','OH00001703915','IL','1','LANCE','DEBORAH','LEE','','','34','302585112','359 PROSPECT ST',0,'WELLINGTON','OH','44090','1231','CY','39093','1955-11-24','F','U',':RET:2106-3','T','021','DEN','2240947','99734OH005000401','2014-02-01','2014-01-05 13:15:45','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-07 10:22:24'),(7829,6201,'Y','18','024','14','A','','','TE','0000822039','0000822039','','IL','1','Petro','Mary Beth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-01-07','F','',NULL,NULL,NULL,'','304931','','2013-12-19','2013-12-19 19:23:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:23'),(13697,10927,'N','01','021','EC','A',NULL,NULL,'','0001258640','0001216247','','IL','1','MARTIN','TODD','A','','','34','285600094','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1966-05-30','M','',':RET:2106-3','T','021','HLT','2073754','52664OH151001305','2014-01-01','2013-12-23 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','452.09',NULL,0,'2013-12-26 13:08:34'),(7015,5569,'Y','18','021','EC','A','','','AC','0000561852','0000561852','TX00000046053','IL','1','McCants','Alissa','','','','34','463832361','66 Daughtrey Avenue',0,'Waco','TX','76706',NULL,'CY','48309','1987-04-15','F','U',':RET:2106-3','N','021','DEN','2002987','33348TX002000201','2014-01-01','2013-12-24 20:23:24','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2013-12-26 01:48:38'),(24938,19776,'Y','18','021','EC','A','','','AC','0001679957','0001679957','LA00002510324','IL','1','alonzo','angel','','','','34','438250899','1201 west esplanade ave.',0,'kenner','LA','70065',NULL,'CY','22051','1958-02-15','M','M',NULL,'N','021','DEN','2668413','18575LA002000201','2014-04-01','2014-02-20 17:28:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-20 21:30:24'),(25766,20437,'Y','18','021','EC','A','','','AC','0001168054','0001168054','OH00001648788','IL','1','mason','eric','','','','34','298748393','3800 Milner rd',0,'Newark','OH','43055',NULL,'CY','39089','1963-11-15','M','M',NULL,'N','021','DEN','3409536','99734OH005000301','2014-04-01','2014-02-24 13:04:44','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 09:30:54'),(26560,21056,'Y','18','021','EC','A','','','AC','0001239177','0001239177','OH00003170608','IL','1','KEITA','KARIFA','','','','34','066846858','2843 WAMBLI DR',0,'COLUMBUS','OH','43219','3281','CY','39049','1957-02-02','M','U',NULL,'N','021','DEN','3669829','99734OH005000401','2014-03-01','2014-02-27 18:06:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:18'),(27107,21457,'N','19','021','EC','A',NULL,NULL,'','0000044327','0000495498','','S1','1','Mendoza','Cristina','','','','34','358087020','207 Rosemarie Dr',0,'Lebanon','OH','45036',NULL,'CY','39165','2009-11-10','F','',NULL,'N','021','DEN','3005502','99734OH005000301','2014-04-01','2014-03-03 10:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:25'),(27520,21772,'Y','18','021','EC','A','','','AC','0000378637','0000378637','OH00003540162','IL','1','zheng','qiao','','','','34','054945151','4437 GROVELAND RD',0,'UNIVERSITY HEIGHTS','OH','44118','3920','CY','39035','1973-08-08','F','M',':RET:2034-7','N','021','HLT','2739689','92036OH004000801','2014-04-01','2014-03-04 13:06:54','469.53',NULL,NULL,'472.99','3.46','R-OH011','OH0','240.26',NULL,0,'2014-03-04 21:02:39'),(28335,22419,'Y','18','021','EC','A','','','AC','0000237292','0000237292','TX00003772178','31','1','Barnes','Crystal','','','','34','631107898','126 e. Buchanan',0,'San Antonio','TX','78221',NULL,'CY','48029','1986-01-21','F','M',':RET:2106-3','N','021','DEN','3803827','33348TX002000201','2014-04-01','2014-03-07 08:58:41','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-07 21:30:13'),(28631,22658,'Y','18','021','EC','A','','','AC','0000672450','0000672450','TX00002852521','IL','1','SMITH','MARGARET','','','','34','480766048','600 STATE HWY 495',0,'ALAMO','TX','78516',NULL,'CY','48215','1956-02-02','F','M',NULL,'N','021','DEN','3856458','33348TX002000201','2014-04-01','2014-03-07 19:03:31','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-08 21:30:27'),(22084,17627,'Y','18','024','14','A','','','TE','0001436526','0001436526','','IL','1','MYLES','BRANDON','W',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-06','M','',NULL,NULL,NULL,'','3680977','','2014-02-08','2014-02-08 17:48:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-08 19:00:20'),(22042,17595,'Y','18','021','EC','A','','','AC','0001194173','0001194173','OH00001586869','IL','1','Crooks','Rita','','','','34','275626979','10515 DETRICK JORDAN PIKE',0,'NEW CARLISLE','OH','45344','9390','CY','39023','1954-11-20','F','M',':RET:2106-3','T','021','HLT','3326880','92036OH005000506','2014-03-01','2014-02-07 17:29:33','468.00',NULL,NULL,'711.58','243.58','R-OH003','OH0','711.58',NULL,0,'2014-02-07 19:01:09'),(21548,17212,'N','01','021','EC','A',NULL,NULL,'','0000406168','0000268934','','IL','1','mccarty','chad','','','','34','278648704','304 n. catherine st.',0,'mount vernon','OH','43050',NULL,'CY','39083','1972-03-21','M','',':RET:2106-3','T','021','DEN','3825371','99734OH005000401','2014-03-01','2014-02-05 11:28:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:12'),(19733,15726,'Y','18','021','EC','A','','','AC','0002077161','0002077161','LA00001945377','IL','1','Mcafee','Dana','Antoinette','','','34','436251708','4004 S WINDMERE ST',0,'HARVEY','LA','70058','2238','CY','22051','1961-10-20','F','U',':RET:2054-5','N','021','DEN','2089192','18575LA002000201','2014-03-01','2014-01-23 11:13:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:07'),(17469,13969,'Y','18','021','EC','A','','','AC','0000268919','0000268919','OH00001737573','IL','1','Saxton','Andrew','','','','34','284823939','4287 mahoning rd',0,'Diamond','OH','44412',NULL,'CY','39133','1975-01-28','M','M',':RET:2106-3','N','021','DEN','1625084','99734OH005000301','2014-02-01','2014-01-12 16:27:06','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:07'),(17754,14186,'Y','18','024','14','A','','','TE','0000319049','0000319049','','IL','1','Spann','Claire',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-25','F','',NULL,NULL,NULL,'','1782037','','2014-01-13','2014-01-13 14:23:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-14 01:33:30'),(26421,20954,'Y','18','021','EC','A','','','AC','0000440873','0000440873','TX00002820771','IL','1','OLMSTEAD','CAROL','','','','34','128429477','3304 PLANTATION RD.',0,'AUSTIN','TX','78745',NULL,'CY','48453','1950-12-10','F','U',':RET:2106-3','N','021','DEN','3782870','33348TX002000201','2014-03-01','2014-02-26 21:27:03','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-02-28 07:30:08'),(25178,19971,'N','01','021','EC','A',NULL,NULL,'','0000762339','0000388689','','IL','1','Newman','Ashley','','','','34','285904411','1604 TAYLOR AVE',0,'MIDDLETOWN','OH','45044','5937','CY','39017','1989-06-15','F','',':RET:2106-3','N','021','DEN','3835478','99734OH005000401','2014-04-01','2014-02-21 12:40:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:32'),(28259,22361,'Y','18','024','14','A','','','TE','0000951788','0000951788','','IL','1','Scott','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-09-06','F','',NULL,NULL,NULL,'','1673900','','2014-03-31','2014-03-07 09:02:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:16'),(29170,23088,'N','01','021','EC','A',NULL,NULL,'','0000201983','0000580048','','IL','1','Badowski','Stacey','Anne','','','34','191706737','303 S MAIN ST',0,'SPENCER','OH','44275','9747','CY','39103','1985-01-30','F','',':RET:2106-3','N','021','HLT','4310531','52664OH151001501','2014-05-01','2014-03-10 15:11:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','299.29',NULL,0,'2014-03-10 21:02:59'),(22861,18237,'Y','18','021','EC','A','','','AC','0000003753','0000003753','MS00002165524','IL','1','THOMPSON','JESSICA','','','','34','433359308','2344 KILN DELISLE RD',0,'KILN','MS','39556','6664','CY','28045','1978-05-24','F','M',':RET:2106-3','T','021','DEN','3421051','46300MS002000201','2014-03-01','2014-02-10 22:22:04','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-11 21:02:24'),(20851,16666,'Y','18','021','EC','A','','','AC','0001066014','0001066014','OH00001420838','31','1','HIGH','JEFFREY','L','','','34','299640548','P.O. BOX 121',0,'MENDEN','OH','45862',NULL,'CY','39107','1961-02-03','M','U',':RET:2106-3','N','021','DEN','3595736','99734OH005000301','2014-03-01','2014-01-31 08:51:44','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-31 21:00:52'),(2980,2399,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001163808','','IL','1','Isenbarger','Jacob','','','','34','294022081','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1998-02-22','M','',':RET:2106-3','N','021','DEN','1211363','99734OH005000301','2014-01-01','2013-12-05 19:26:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:12'),(18947,15096,'Y','18','021','EC','A','','','AC','0000102413','0000102413','TX00002132316','IL','1','Roa Pineda','Monica','Rocio','','','34','067611099','10505 Gran Cima Ln',0,'El Paso','TX','79935',NULL,'CY','48141','1966-08-25','F','U',':RET:2106-3','N','021','DEN','2292884','33348TX002000201','2014-03-01','2014-01-17 11:44:30','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-20 08:05:46'),(4462,3545,'Y','18','021','EC','A','','','AC','0000949495','0000949495','OH00001169396','IL','1','MITCHELL','BRENDA','','','','34','268686102','906 RIVERSIDE DRIVE',0,'ELYRIA','OH','44035',NULL,'CY','39093','1959-04-08','F','U',NULL,'N','021','DEN','724919','99734OH005000301','2014-01-01','2013-12-12 12:50:52','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:39'),(4556,3609,'Y','18','021','EC','A','','','AC','0000634789','0000634789','OH00001255154','IL','1','Blagg','Shirley','','','','34','298461986','533 LONGVIEW AVE',0,'CANAL FULTON','OH','44614','8804','CY','39151','1949-07-07','F','U',':RET:2106-3','N','021','HLT','1034724','52664OH152000901','2014-01-01','2013-12-12 14:56:41','474.00',NULL,NULL,'490.00','16.00','R-OH015','OH0','490.00',NULL,0,'2013-12-25 22:04:38'),(5426,4308,'Y','18','021','EC','A','','','AC','0001214558','0001214558','MS00000969930','IL','1','lugo','Crystal','','','','34','439393692','220 Cross Park Dr',0,'Pearl','MS','39208',NULL,'CY','28121','1978-09-26','F','M',':RET:2106-3','T','021','DEN','2092032','46300MS002000201','2014-01-01','2013-12-19 16:38:32','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:09:31'),(6226,4935,'Y','18','021','EC','A','','','AC','0001085583','0001085583','OH00000848966','IL','1','Riley','Pamela','','','','34','276522647','5901 Fairdale Drive',0,'Fairfield','OH','45014',NULL,'CY','39017','1951-02-02','F','M',':RET:2106-3','N','021','DEN','1251335','99734OH005000401','2014-01-01','2013-11-19 12:07:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:31:18'),(14932,11932,'Y','18','021','EC','A','','','AC','0001235370','0001235370','TX00001440196','IL','1','BREZINA','SARAH','','','','34','383065089','839 HAINES AVE',0,'DALLAS','TX','75208','4035','CY','48113','1983-12-02','F','R',':RET:2106-3','N','021','DEN','1764768','33348TX002000101','2014-02-01','2013-12-29 13:05:21','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-30 00:02:03'),(29148,23074,'Y','18','021','EC','A','','','AC','0000844768','0000844768','OH00003604590','IL','1','Carlier-Smyth','Nancy','','','','34','296461763','6127 WASIGO DR',0,'CINCINNATI','OH','45230','1257','CY','39061','1951-08-21','F','U',':RET:2106-3','N','021','HLT','3893223','92036OH003001205','2014-04-01','2014-03-10 11:33:18','451.00',NULL,NULL,'644.07','193.07','R-OH004','OH0','644.07',NULL,0,'2014-03-10 21:02:47'),(29215,23120,'Y','18','024','14','A','','','TE','0000890776','0000890776','','IL','1','LOWMAN','TREASEA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-10-01','F','',NULL,NULL,NULL,'','4183915','','2014-03-10','2014-03-10 15:50:53',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCELCIC',0,'2014-03-10 21:30:18'),(1357,1123,'N','01','021','EC','A',NULL,NULL,'','0001135501','0000504505','','IL','1','Kehoe','Nanci','','','','34','556274006','2303 GREENLEE DR',0,'AUSTIN','TX','78703','1710','CY','48453','1959-06-01','F','',NULL,'N','021','DEN','1696004','33348TX002000101','2014-01-01','2013-12-24 13:37:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 18:45:24'),(22620,18062,'N','01','021','EC','A',NULL,NULL,'','0001152570','0000226102','','IL','1','Normann','Cheri','','','','34','375567420','11772 FM905',0,'Pattonville','TX','75468',NULL,'CY','48277','1953-05-05','F','',NULL,'N','021','DEN','3416580','33348TX002000201','2014-03-01','2014-02-10 20:07:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:09'),(8003,6333,'Y','18','021','EC','A','','','AC','0001134157','0001134157','TX00000323170','IL','1','Martinez','Maria','','','','34','621882128','1915 Wells Branch Pkwy',0,'Austin','TX','78728',NULL,'CY','48453','1962-07-13','F','U',':RET:2106-3','N','021','DEN','1968271','33348TX002000101','2014-01-01','2013-12-19 21:07:58','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 03:08:25'),(2516,2051,'Y','18','021','EC','A','','','AC','0000560857','0000560857','MS00000873714','IL','1','LINDSEY-BENNETT','MAE','FRANCES','','','34','587269680','2937 RANDOLPH ST',0,'JACKSON','MS','39213','6640','CY','28049','1951-05-31','F','U',NULL,'N','021','DEN','776659','46300MS002000101','2014-01-01','2013-12-09 16:40:30','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 19:36:27'),(20819,16638,'Y','18','021','EC','A','','','AC','0001888264','0001888264','LA00002357440','IL','1','WILLIAMS','ELOUISE','','','','34','439551790','27 WESTPARK CT',0,'NEW ORLEANS','LA','70114','8905','CY','22071','1967-09-25','F','U',NULL,'T','021','DEN','3115290','18575LA002000201','2014-03-01','2014-01-31 12:05:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:34'),(13113,10457,'Y','18','021','EC','A','','','AC','0000910520','0000910520','OH00000148090','IL','1','HEINZ','MARY','','','','34','293489386','1832 CLYDE RD',0,'MADISON','OH','44057','1888','CY','39085','1951-09-12','F','M',NULL,'N','021','DEN','1731303','99734OH005000401','2014-01-01','2013-12-23 13:33:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:33'),(13263,10585,'Y','18','021','EC','A','','','AC','0000370693','0000370693','TX00000558274','IL','1','TAYLOR','NATHANIEL','','','','34','458274130','184 COUNTY ROAD',0,'WINNSBORO','TX','75494',NULL,'CY','48499','1959-05-04','M','U',':RET:2106-3','N','021','DEN','2328329','33348TX002000201','2014-01-01','2013-12-23 12:12:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:42'),(17118,13700,'Y','18','021','EC','A','','','AC','0000884230','0000884230','OH00001405719','IL','1','Stupar','Gillian','Rose','','','34','295767460','3615 IRA RD',0,'AKRON','OH','44333','1211','CY','39153','1969-09-16','F','U',':RET:2106-3','N','021','DEN','1794835','99734OH005000401','2014-02-01','2014-01-08 10:07:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:21:41'),(15066,12044,'Y','18','021','EC','A','','','AC','0001298631','0001298631','LA00000355350','IL','1','smith','becky','','','','34','434590142','603 highway 486',0,'campti','LA','71411',NULL,'CY','22069','1984-02-08','F','M',':RET:2106-3','N','021','DEN','1420274','18575LA002000201','2014-02-01','2013-12-30 17:32:33','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-01 12:03:45'),(15782,12631,'Y','18','021','EC','A','','','AC','0000888635','0000888635','TX00001414381','IL','1','Wright','Ronald','Dade','','','34','450812889','5651 OAK HOLLOW CIR',0,'BRYAN','TX','77808','6273','CY','48041','1986-02-13','M','U',':RET:2106-3','T','021','DEN','2404287','33348TX002000201','2014-02-01','2014-01-02 17:51:35','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-03 02:02:10'),(16192,12963,'Y','18','021','EC','A','','','AC','0000660392','0000660392','TX00001365736','IL','1','Hernandez','Cindy','','','','34','643184135','1501 MILAM WAY',0,'CARROLLTON','TX','75006','7635','CY','48113','1988-09-09','F','U',':RET:2106-3','N','021','DEN','1576353','33348TX002000201','2014-02-01','2014-01-04 00:28:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-05 00:00:51'),(16207,12977,'Y','18','024','14','A','','','TE','0000985990','0000985990','','IL','1','Hymel','Ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-12-16','F','',NULL,NULL,NULL,'','2239732','','2014-01-04','2014-01-04 15:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-05 00:01:21'),(26638,21122,'Y','18','024','14','A','','','TE','0000096238','0000096238','','IL','1','SCOTT','LAMARCUS','JAMANE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-04','M','',NULL,NULL,NULL,'','2802527','','2014-02-28','2014-02-28 17:29:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:31:01'),(72,65,'Y','18','021','EC','A','','','AC','0000482154','0000482154','OH00001005343','IL','1','Solomon','Gary','Alan','','','34','300544777','4086 PARKSIDE DR',0,'BROOKLYN','OH','44144','1316','CY','39035','1954-02-15','M','M',':RET:2106-3','N','021','DEN','516107','99734OH005000301','2014-01-01','2013-12-05 14:18:29','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:16:57'),(1537,1280,'Y','18','021','EC','A','','','AC','0000371483','0000371483','OH00001137794','IL','1','Tandy','Nathan','','','','34','307025210','1418 John Glenn Rd.',0,'Dayton','OH','45410',NULL,'CY','39113','1987-10-29','M','U',':RET:2106-3','N','021','DEN','1426117','99734OH005000401','2014-01-01','2013-12-24 16:55:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:50:10'),(22884,18247,'N','19','021','EC','A',NULL,NULL,'','0001004383','0000084090','','IL','1','Dao','Loc','','','','34','619186525','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1988-11-20','M','',NULL,'N','021','HLT','3544978','52664OH151001501','2014-03-01','2014-02-11 11:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','268.54',NULL,0,'2014-02-11 21:02:34'),(22546,18003,'Y','18','021','EC','A','','','AC','0002144366','0002144366','LA00002491678','IL','1','Stewart','Sarah','','','','34','435630866','129 SHIRLEY ROSE RD',0,'HAUGHTON','LA','71037','8404','CY','22015','1974-11-14','F','U',':RET:2106-3','N','021','DEN','3247931','18575LA002000101','2014-03-01','2014-02-10 12:49:47','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-10 21:31:42'),(21119,16874,'Y','18','021','EC','A','','','AC','0000202999','0000202999','TX00001505685','IL','1','ANCHONDO','VALERIE','','','','34','634073230','1003 W ADA ST',0,'ODESSA','TX','79763','4608','CY','48135','1989-05-26','F','U',NULL,'N','021','DEN','2667986','33348TX002000201','2014-03-01','2014-02-03 10:43:22','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-02-03 21:00:12'),(2225,1831,'Y','18','021','EC','A','','','AC','0000108125','0000108125','OH00000207667','IL','1','Toth','Rebecca','','','','34','291585258','237 ROOD ST',0,'NORTHWOOD','OH','43619','1749','CY','39173','1955-08-26','F','U',':RET:2106-3','N','021','HLT','608146','92036OH003002601','2014-01-01','2013-12-10 16:29:18','129.00',NULL,NULL,'518.85','389.85','R-OH001','OH0','518.85',NULL,0,'2013-12-25 19:20:37'),(3058,2456,'Y','18','021','EC','A','','','AC','0000064175','0000064175','LA00000580696','IL','1','JACKSON','KEITH','','','','34','433710065','15825 CHIVRE AVE',0,'GREENWELL SPRINGS','LA','70739','3852','CY','22033','1974-11-24','M','U',':RET:2106-3','N','021','DEN','12407','18575LA002000201','2014-01-01','2013-12-05 20:15:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:19:04'),(14875,11878,'N','01','021','EC','A',NULL,NULL,'','0000197683','0000581491','','IL','1','Spyres','Rosie','','','','34','442703789','801 QUAIL RUN CIR',0,'QUINLAN','TX','75474','2638','CY','48231','1961-03-10','F','',':RET:2106-3','T','021','DEN','2084968','33348TX002000201','2014-02-01','2013-12-29 12:17:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-30 00:00:20'),(24891,19735,'Y','18','024','14','A','','','TE','0001142218','0001142218','','IL','1','PATEL','BIPIN','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-08-16','M','',NULL,NULL,NULL,'','2697198','','2014-03-31','2014-02-19 12:19:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:38:53'),(24975,19808,'Y','18','021','EC','A','','','AC','0000204353','0000204353','TX00002329910','IL','1','IVY','BILLIE','','','','34','445520402','7997 FM 603',0,'CLYDE','TX','79510','6629','CY','48059','1949-12-03','F','M',':RET:2106-3','N','021','DEN','3007351','33348TX002000201','2014-04-01','2014-02-20 08:39:09','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-02-20 22:00:30'),(26068,20672,'Y','18','021','EC','A','','','AC','0000299305','0000299305','OH00003236699','31','1','Eichelman','Elizabeth','','','','34','347748184','1034 Burns Ave',0,'Wyoming','OH','45216',NULL,'CY','39165','1984-11-22','F','U',NULL,'N','021','HLT','2799127','92036OH005001205','2014-04-01','2014-02-26 14:19:59','140.00',NULL,NULL,'240.21','100.21','R-OH004','OH0','240.21',NULL,0,'2014-02-26 21:02:42'),(27173,21514,'Y','18','021','EC','A','','','AC','0000042349','0000042349','TX00002351623','IL','1','Thai','Hung','','','','34','023608395','4133 NE STALLINGS DR',0,'NACOGDOCHES','TX','75965','1630','CY','48347','1961-11-10','F','M',NULL,'T','021','DEN','3644067','33348TX002000201','2014-04-01','2014-03-03 11:36:38','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:06'),(20046,15987,'Y','18','021','EC','A','','','AC','0000813781','0000813781','MS00001861343','IL','1','GHOLSTON','HENRY','','','','34','426029475','2120 HIGHWAY 404',0,'DUCK HILL','MS','38925','9237','CY','28097','1957-09-13','M','U',NULL,'T','021','DEN','3182847','46300MS002000101','2014-03-01','2014-01-26 15:21:11','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-26 19:00:31'),(13045,10399,'Y','18','021','EC','A','','','AC','0000039810','0000039810','OH00000215412','IL','1','Melragon','Meredith','','','','34','276789402','2311 SHREWSBURY RD',0,'COLUMBUS','OH','43221','1259','CY','39049','1966-07-12','F','U',':RET:2106-3','N','021','DEN','2390204','99734OH005000401','2014-01-01','2013-12-23 08:21:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:50:42'),(964,791,'N','01','021','EC','A',NULL,NULL,'','0000323969','0001201091','','IL','1','Xiong','Youa','V','','','34','586144240','2107 Rohne Drive',0,'Cedar Hill','TX','75104',NULL,'CY','48139','1954-09-04','F','',':RET:2028-9','N','021','DEN','153957','33348TX002000201','2014-01-01','2013-10-29 11:14:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:09:52'),(18725,14925,'Y','18','021','EC','A','','','AC','0001113169','0001113169','OH00001991294','IL','1','TURNER-YAMAMOTO','JUDITH','','','','34','240941993','2324 MADISON RD',0,'CINCINNATI','OH','45208',NULL,'CY','39061','1953-01-05','F','M',':RET:2106-3','N','021','DEN','2132845','99734OH005000301','2014-02-01','2014-01-15 23:37:18','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:35'),(17331,13863,'Y','18','021','EC','A','','','AC','0001949868','0001949868','LA00002561650','IL','1','BREWSTER','TOMMY','','','','34','438192298','381 TWIN OAKS DRIVE',0,'MANY','LA','71449',NULL,'CY','22085','1969-04-26','M','M',NULL,'N','021','DEN','2074315','18575LA002000201','2014-02-01','2014-01-10 12:37:14','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-13 02:23:57'),(7736,6126,'N','01','021','EC','A',NULL,NULL,'','0000208487','0000364879','','IL','1','KAUFMAN','GREGORY','','','','34','269702365','912 HEATHERVIEW CT',0,'FINDLAY','OH','45840',NULL,'CY','39063','1970-02-23','M','',':RET:2106-3','T','021','DEN','1989628','99734OH005000401','2014-01-01','2013-12-20 15:20:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:08'),(15771,12620,'Y','18','021','EC','A','','','AC','0000595714','0000595714','TX00000177807','IL','1','Quijas','Yvonne','','','','34','547490277','1820 Dan Drive',0,'Edinburg','TX','78539',NULL,'CY','48215','1961-08-30','F','U',':RET:2106-3','N','021','DEN','1693599','33348TX002000201','2014-02-01','2014-01-02 13:45:48','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-03 02:01:48'),(15769,12618,'N','01','021','EC','A',NULL,NULL,'','0001101422','0000398474','','IL','1','magness','sherry','lorene','','','34','455291569','809 Imperial Ln.',0,'Corsicana','TX','75110',NULL,'CY','48349','1961-03-28','F','',':RET:2106-3','N','021','DEN','1558215','33348TX002000201','2014-02-01','2014-01-02 13:24:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-03 02:01:45'),(6873,5450,'Y','18','021','EC','A','','','AC','0000484733','0000484733','OH00000327668','IL','1','khalil','mikhail','','','','34','383900644','3575 sterling park circle',0,'grove city','OH','43123',NULL,'CY','39049','1967-11-05','M','U',':RET:2106-3','N','021','DEN','144139','99734OH005000301','2014-01-01','2013-11-03 17:21:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:32:02'),(6335,5022,'N','19','021','EC','A',NULL,NULL,'','0001088245','0000149327','','IL','1','Jordan','Kane','','','','34','268156371','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','2008-08-28','M','',NULL,'N','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:41'),(26142,20728,'Y','18','024','14','A','','','TE','0000153425','0000153425','','IL','1','FOUT','CAROL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-04-24','F','',NULL,NULL,NULL,'','3744521','','2014-02-27','2014-02-27 12:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:26'),(26401,20939,'N','19','021','EC','A',NULL,NULL,'','0000042085','0000287155','','IL','1','Older','Logan','','','','34','283083012','1060 E MILLTOWN RD',0,'WOOSTER','OH','44691','1848','CY','39169','2003-06-17','M','',':RET:2106-3','N','021','HLT','2973579','52664OH151001304','2014-03-01','2014-02-26 15:04:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:31'),(26496,21019,'Y','18','021','EC','A','','','AC','0000345647','0000345647','OH00003277308','IL','1','PALUMBO','JENNIFER','','','','34','299926243','2532 4TH ST',0,'CUYAHOGA FALLS','OH','44221','2633','CY','39153','1988-02-02','F','U',NULL,'T','021','HLT','3130090','52664OH151001305','2014-03-01','2014-02-28 10:32:35','133.00',NULL,NULL,'262.61','129.61','R-OH012','OH0','262.61','CIC',0,'2014-02-28 21:00:13'),(27836,22017,'Y','18','021','EC','A','','','AC','0000930980','0000930980','OH00003542340','IL','1','Honican','Lori','','','','34','297620538','10184 ZIG ZAG RD',0,'BLUE ASH','OH','45242','5742','CY','39061','1958-10-25','F','U',':RET:2106-3','T','021','DEN','4057553','99734OH005000301','2014-04-01','2014-03-05 15:26:38','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:32:04'),(21528,17199,'N','01','021','EC','A',NULL,NULL,'','0001086099','0000910005','','IL','1','Hutto','Rex','','','Jr','34','454511313','895 COUNTY ROAD 3322',0,'JACKSONVILLE','TX','75766','6709','CY','48073','1980-06-27','M','',NULL,'N','021','DEN','2646148','33348TX002000101','2014-03-01','2014-02-04 21:45:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-05 21:30:05'),(344,281,'Y','18','021','EC','A','','','AC','0000067635','0000067635','OH00000453233','IL','1','Powers','Christopher','','','','34','274960425','407 Broad st',0,'Conneaut','OH','44030',NULL,'CY','39007','1993-01-28','M','U',':RET:2106-3','N','021','DEN','499359','99734OH005000401','2014-01-01','2013-11-09 11:58:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2013-12-25 17:32:02'),(20646,16498,'Y','18','021','EC','A','','','AC','0000651303','0000651303','TX00002504385','IL','1','natera','renee','','','','34','465617411','8622 N.Loop Dr.',0,'El Paso','TX','79907',NULL,'CY','48141','1978-11-16','M','M',NULL,'N','021','DEN','2957636','33348TX002000201','2014-03-01','2014-01-30 13:54:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-30 21:00:36'),(6474,5129,'Y','18','021','EC','A','','','AC','0000217560','0000217560','OH00001148286','IL','1','Cord','Nora','','','','34','298801457','741 ABINGTON RD',0,'AKRON','OH','44312','2440','CY','39153','1975-01-09','F','M',':RET:2106-3','N','021','HLT','596609','52664OH151001306','2014-01-01','2013-12-10 23:35:31','679.00',NULL,NULL,'846.09','167.09','R-OH012','OH0','277.87',NULL,0,'2013-12-26 00:50:11'),(3630,2904,'Y','18','021','EC','A','','','AC','0000479822','0000479822','OH00000832109','IL','1','Flores','Teresa','JEAN','','','34','431254557','5365 OLD US HIGHWAY 68',0,'RIPLEY','OH','45167','9715','CY','39015','1958-02-06','F','M',':RET:2106-3','N','021','HLT','902776','92036OH003000606','2014-01-01','2013-12-13 11:31:51','352.00',NULL,NULL,'499.92','147.92','R-OH005','OH0','499.92',NULL,0,'2013-12-25 21:30:06'),(18530,14777,'Y','18','021','EC','A','','','AC','0001096772','0001096772','OH00002339795','IL','1','Fahnle','Barbara','','','','34','402646505','3531 werk Road',0,'Cincinnati','OH','45248',NULL,'CY','39061','1951-05-16','F','M',':RET:2106-3','N','021','HLT','1766175','92036OH005001206','2014-02-01','2014-01-15 12:50:26','461.00',NULL,NULL,'616.74','155.74','R-OH004','OH0','616.74',NULL,0,'2014-01-16 08:46:43'),(1180,972,'Y','18','021','EC','A','','','AC','0000866863','0000866863','OH00000448291','IL','1','Barnes','Geoffrey','','','','34','279762679','1298 ZEBULON AVE',0,'COLUMBUS','OH','43224','2759','CY','39049','1965-01-16','M','M',':RET:2054-5','N','021','DEN','567339','99734OH005000301','2014-01-01','2013-12-02 21:19:49','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:19:21'),(18453,14720,'Y','18','021','EC','A','','','AC','0001492074','0001492074','LA00002115379','IL','1','DAVIS','Lenard','','','','34','436434667','1418 KING DEAN DR',0,'BATON ROUGE','LA','70810','3217','CY','22033','1964-09-18','M','U',':RET:2054-5','N','021','DEN','1591186','18575LA002000101','2014-02-01','2014-01-14 20:32:08','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:08'),(2406,1965,'Y','18','021','EC','A','','','AC','0000701660','0000701660','OH00000536416','IL','1','STARCHER','LINDA','J','','','34','272562346','1085 EMOREY CIR',0,'AKRON','OH','44312',NULL,'CY','39153','1953-11-25','F','M',':RET:2106-3','N','021','DEN','1160940','99734OH005000401','2014-01-01','2013-12-09 14:16:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:33:39'),(17807,14224,'Y','18','021','EC','A','','','AC','0000231927','0000231927','TX00001743890','IL','1','davenport','rebecca','','','','34','230880643','3797 Towne Crossing Blvd.',0,'Mesqite','TX','75150',NULL,'CY','48113','1956-10-28','F','U',':RET:2106-3','N','021','DEN','2446753','33348TX002000101','2014-02-01','2014-01-13 21:54:20','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-15 02:05:51'),(2741,2219,'Y','18','021','EC','A','','','AC','0000616838','0000616838','OH00001190226','IL','1','christy','candy','','','','34','293684566','7366 West Lake Blvd',0,'Kent','OH','44240',NULL,'CY','39133','1968-07-30','F','M',':RET:2106-3','T','021','HLT','181923','52664OH152000901','2014-01-01','2013-12-02 09:17:12','200.00',NULL,NULL,'526.54','326.54','R-OH012','OH0','271.24',NULL,0,'2013-12-25 19:48:48'),(7104,5634,'N','01','021','EC','A',NULL,NULL,'','0000294416','0000595150','','IL','1','Mejia','Adrian','Jerome','','','34','266259187','9211 Deercross Pkwy 1B',0,'Cincinnati','OH','45236',NULL,'CY','39061','1954-09-28','M','',':RET:2106-3','N','021','HLT','1945638','92036OH004001201','2014-01-01','2013-12-24 23:05:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','449.32',NULL,0,'2013-12-26 01:50:50'),(5049,3998,'Y','18','021','EC','A','','','AC','0001200119','0001200119','TX00000258521','IL','1','Estrada','Rosemary','','','','34','626549830','4707 CYPRESS COLONY LN',0,'KATY','TX','77449','4096','CY','48201','1992-03-27','F','U',':RET:2106-3','N','021','DEN','2445824','33348TX002000201','2014-01-01','2013-12-18 19:13:13','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:00:07'),(18825,14994,'Y','18','021','EC','A','','','AC','0000955970','0000955970','MS00001646737','IL','1','Hill','Sheila','','','','34','330627594','P.O. Box 614',0,'Bolton','MS','39041',NULL,'CY','28049','1962-09-08','F','U',':RET:2054-5','N','021','DEN','1941266','46300MS002000201','2014-02-01','2014-01-15 23:20:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:07'),(22642,18080,'Y','18','021','EC','A','','','AC','0000121927','0000121927','TX00002627067','IL','1','HOANG','JOSEPH','','','','34','729039062','3355 BEACON VIEW CT',0,'PEARLAND','TX','77584',NULL,'CY','48039','1958-03-04','M','M',NULL,'N','021','DEN','3827885','33348TX002000201','2014-03-01','2014-02-11 10:26:24','0.00',NULL,NULL,'88.07','88.07','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:23'),(23983,19069,'Y','18','021','EC','A','','','AC','0001994813','0001994813','LA00002074188','IL','1','nelson','robin','','','','34','437338794','22177 GROVER ST',0,'ABITA SPRINGS','LA','70420','2341','CY','22103','1970-12-28','F','U',':RET:2106-3','N','021','DEN','3842014','18575LA002000201','2014-03-01','2014-02-15 12:05:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:21'),(24773,19652,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000941969','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','299983325','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1996-04-30','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:34'),(28054,22200,'Y','18','021','EC','A','','','AC','0000210374','0000210374','MS00002824747','IL','1','jacobs','walter','','','Jr','34','427473855','109 CLAUDE DR',0,'JACKSON','MS','39209','2594','CY','28049','1983-07-30','M','M',':RET:2054-5','N','021','DEN','3366049','46300MS002000201','2014-04-01','2014-03-06 16:36:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:39'),(28735,22743,'Y','18','021','EC','A','','','AC','0000069140','0000069140','OH00003274123','IL','1','rutschilling','robert','','','','34','270663632','223 W. Walnut St.',0,'Coldwater','OH','45828',NULL,'CY','39107','1959-10-05','M','U',':RET:2106-3','T','021','HLT','3616279','92036OH001001501','2014-04-01','2014-03-08 18:15:22','0.00',NULL,NULL,'1085.85','1085.85','R-OH002','OH0','651.80',NULL,0,'2014-03-09 21:00:06'),(336,276,'Y','18','021','EC','A','','','AC','0000244939','0000244939','OH00000893360','IL','1','Higgins','Patrick','','','','34','124743052','149 madison ave',0,'findlay','OH','45840',NULL,'CY','39063','1977-11-08','M','U',NULL,'T','021','HLT','345378','92036OH006001501','2014-01-01','2013-10-11 16:23:44','0.00',NULL,NULL,'246.89','246.89','R-OH002','OH0','246.89',NULL,0,'2013-12-25 17:31:49'),(2077,1701,'Y','18','021','EC','A','','','AC','0000148174','0000148174','LA00000283553','IL','1','Little','John','','','','34','434597889','208 CENTERVILLE ST NE',0,'DENHAM SPRINGS','LA','70726','3416','CY','22063','1970-01-12','M','U',':RET:2106-3','N','021','DEN','281885','18575LA002000201','2014-01-01','2013-12-09 23:31:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:31'),(6235,4943,'Y','18','021','EC','A','','','AC','0000315241','0000315241','TX00001201392','31','1','King','Michael','','','','34','467294996','PO Box 1326',0,'Winnsboro','TX','75494',NULL,'CY','48499','1960-05-10','M','M',':RET:2106-3','N','021','DEN','128983','33348TX002000201','2014-01-01','2013-11-19 10:15:50','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:31:33'),(18006,14389,'Y','18','021','EC','A','','','AC','0000506993','0000506993','OH00001664382','IL','1','Stegall','Shannon','','','','34','279887763','2669 MOHICAN AVE',0,'KETTERING','OH','45429','3734','CY','39113','1981-12-13','F','U',':RET:2106-3','N','021','DEN','2378030','99734OH005000301','2014-02-01','2014-01-14 09:29:59','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:07:02'),(17878,14279,'N','19','021','EC','A',NULL,NULL,'','0001126890','0001015597','','IL','1','Vollmer','Daniel','','','Jr','34','686147437','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','2007-11-07','M','',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(17717,14159,'N','01','021','EC','A',NULL,NULL,'','0000680864','0000097592','','IL','1','Mitchell','Leesa','Kay','','','34','269648989','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1957-06-27','F','',':RET:2106-3','T','021','HLT','2230115','52664OH152000901','2014-02-01','2014-01-13 09:08:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','438.23',NULL,0,'2014-01-14 01:33:13'),(2580,2097,'Y','18','021','EC','A','','','AC','0000834436','0000834436','OH00001158589','IL','1','McGarvey','Steve','','','','34','298884011','635 ROMBACH AVE',0,'WILMINGTON','OH','45177','2486','CY','39027','1982-06-23','M','U',':RET:2106-3','T','021','HLT','882555','92036OH004000601','2014-01-01','2013-12-09 16:53:57','0.00',NULL,NULL,'230.07','230.07','R-OH005','OH0','230.07',NULL,0,'2013-12-25 19:37:58'),(15718,12574,'Y','18','021','EC','A','','','AC','0001093150','0001093150','OH00001853490','IL','1','MARTIN','KIMBERLY','GEAN','','','34','317703541','3643 HARDING DR',0,'COLUMBUS','OH','43228',NULL,'CY','39049','1957-06-24','F','U',':RET:2106-3','N','021','DEN','1691425','99734OH005000301','2014-02-01','2014-01-02 08:00:14','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:00:06'),(3355,2689,'Y','18','021','EC','A','','','AC','0000027270','0000027270','TX00001018785','IL','1','haileselassie','gelila','','','','34','212736059','13740 Montfort Dr',0,'Dallas','TX','75240',NULL,'CY','48113','1987-09-10','F','R',':RET:2054-5','N','021','DEN','1359715','33348TX002000201','2014-01-01','2013-12-22 11:17:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:16:50'),(15090,12062,'Y','18','024','14','A','','','TE','0000388616','0000388616','','IL','1','Snyder','Ellen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-02-17','F','',NULL,NULL,NULL,'','1002456','','2013-12-29','2013-12-29 20:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:04:27'),(20497,16375,'Y','18','021','EC','A','','','AC','0002225566','0002225566','LA00002512698','IL','1','NORRIS','JOYCE','MARIE','','','34','435212337','27 PLUM TREE DR',0,'RAYVILLE','LA','71269','7301','CY','22083','1968-08-30','F','U',NULL,'N','021','DEN','3164820','18575LA002000201','2014-03-01','2014-01-29 11:32:49','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-29 21:01:10'),(22785,18191,'N','01','021','EC','A',NULL,NULL,'','0000163722','0000869326','','IL','1','Garcia','Michael','J','','','34','294481872','11624 CORUNDITE RD NW',0,'MASSILLON','OH','44647','9432','CY','39151','1950-07-23','M','',':RET:2106-3','N','021','DEN','3806844','99734OH005000301','2014-03-01','2014-02-11 09:05:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:46'),(24065,19137,'Y','18','021','EC','A','','','AC','0000422859','0000422859','OH00001734644','IL','1','Alexander','Jaqueta','','','','34','269927912','3341 BOXWOOD CIR',0,'CINCINNATI','OH','45241','3183','CY','39061','1984-07-08','F','U',':RET:2054-5','N','021','DEN','3857971','99734OH005000301','2014-03-01','2014-02-15 14:42:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:01:11'),(26986,21377,'Y','18','021','EC','A','','','AC','0000106770','0000106770','OH00002707652','S3','1','Greenlief','Kristi','Shantelle','','','34','297151465','489 E ROYAL FOREST BLVD',0,'COLUMBUS','OH','43214','1809','CY','39049','2010-05-28','F','U',':RET:2106-3','N','021','DEN','3346286','99734OH005000101','2014-04-01','2014-03-02 14:45:25','0.00',NULL,NULL,'27.59','27.59','R-OH009','OH0','27.59',NULL,0,'2014-03-03 01:00:40'),(7376,5841,'Y','18','021','EC','A','','','AC','0000372571','0000372571','OH00000530774','IL','1','CROSBY','VIRGINIA','','','','34','286589004','134 RANDOLPH ST.',0,'ASHVILLE','OH','43103',NULL,'CY','39129','1958-11-30','F','M',':RET:2106-3','N','021','DEN','334421','99734OH005000401','2014-01-01','2013-11-23 17:14:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:15:48'),(16695,13361,'Y','18','021','EC','A','','','AC','0000685455','0000685455','TX00001750979','IL','1','GARCIA','ARACELI','','','','34','632119179','1103 E VALLE VISTA AVE',0,'PHARR','TX','78577',NULL,'CY','48215','1958-12-16','F','M',NULL,'N','021','DEN','2489619','33348TX002000201','2014-02-01','2014-01-07 14:07:43','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-08 18:24:36'),(18236,14556,'Y','18','021','EC','A','','','AC','0000821862','0000821862','TX00001573139','IL','1','TOWNSEND','CHAUNCEY','','','','34','456047741','19641 COUNTY ROAD 366',0,'WINONA','TX','75792','5809','CY','48423','1954-11-29','F','U',':RET:2106-3','N','021','DEN','1393175','33348TX002000201','2014-02-01','2014-01-15 10:29:08','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-16 08:44:22'),(18054,14424,'N','01','021','EC','A',NULL,NULL,'','0000638321','0000196498','','IL','1','fonville','ciara','','','','34','587788601','147 DREW RULEVILLE RD',0,'RULEVILLE','MS','38771','9731','CY','28133','1951-07-11','F','',':RET:2054-5','N','021','DEN','2758135','46300MS002000101','2014-02-01','2014-01-14 16:41:16',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-15 02:07:17'),(13550,10805,'N','01','021','EC','A',NULL,NULL,'','0002239328','0001786540','','IL','1','Denney','John','Wesley','','','34','547963148','3436 Dryades St.',0,'New Orleans','LA','70115',NULL,'CY','22071','1953-04-11','M','',':RET:2106-3','N','021','DEN','1649695','18575LA002000201','2014-01-01','2013-12-23 14:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:03'),(4326,3437,'Y','18','021','EC','A','','','AC','0000885575','0000885575','OH00000779697','IL','1','kerr','susan','','','','34','511847644','229 CARLWOOD DR',0,'MIAMISBURG','OH','45342','3510','CY','39113','1966-10-02','F','U',':RET:2106-3','N','021','HLT','2395042','92036OH004000501','2014-01-01','2013-12-17 15:38:37','0.00',NULL,NULL,'298.75','298.75','R-OH003','OH0','298.75',NULL,0,'2013-12-25 21:52:54'),(6533,5180,'Y','18','021','EC','A','','','AC','0000537345','0000537345','TX00000021009','31','1','Deatherage','Rebecca','G','','','34','459802742','2601 Osborne Dr.',0,'Norman','OK','73069',NULL,'CY','48441','1949-11-23','F','R',':RET:2106-3','N','021','DEN','773191','33348TX002000201','2014-01-01','2013-12-10 21:44:36','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-26 00:51:43'),(4784,3797,'N','19','021','EC','A',NULL,NULL,'','0000505713','0000915624','','IL','1','Ruedlinger','Jenna','','','','34','285049193','125 GARFIELD ST',0,'WADSWORTH','OH','44281','1431','CY','39103','1999-09-06','F','',':RET:2106-3','N','021','HLT','1233676','52664OH151001305','2014-01-01','2013-12-07 19:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 22:16:12'),(4783,3797,'Y','18','021','EC','A','','','AC','0000505713','0000505713','OH00001016971','IL','1','Ruedlinger','Richard','','','Jr','34','300760348','125 GARFIELD ST',0,'WADSWORTH','OH','44281','1431','CY','39103','1967-08-28','M','M',':RET:2106-3','T','021','HLT','1233676','52664OH151001305','2014-01-01','2013-12-07 19:10:01','697.00',NULL,NULL,'1202.46','505.46','R-OH012','OH0','384.69',NULL,0,'2013-12-25 22:16:11'),(4478,3553,'Y','18','024','14','A','','','TE','0000500368','0000500368','','IL','1','Bodi','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-13','F','',NULL,NULL,NULL,'','43797','','2013-12-12','2013-12-12 15:00:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:54'),(29133,23064,'Y','18','021','EC','A','','','AC','0001198163','0001198163','OH00002765539','IL','1','GREINER','BONNIE','A','','','34','280584755','10738 COUNTY ROAD 32',0,'GREEN SPRINGS','OH','44836',NULL,'CY','39147','1956-01-09','F','M',NULL,'N','021','HLT','3443848','92036OH003002705','2014-04-01','2014-03-10 10:53:19','365.00',NULL,NULL,'518.85','153.85','R-OH006','OH0','518.85',NULL,0,'2014-03-10 21:02:38'),(9723,7701,'Y','18','021','EC','A','','','AC','0000216064','0000216064','OH00000412518','IL','1','Berg','Rachel','L','','','34','300883775','41 Carpenters Run',0,'Cinncinati','OH','45241',NULL,'CY','39061','1977-08-11','F','U',':RET:2106-3','N','021','DEN','950267','99734OH005000301','2014-01-01','2013-11-14 20:21:42','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:31'),(6052,4794,'Y','18','021','EC','A','','','AC','0001068238','0001068238','OH00000861495','31','1','jones','cynthia','','','','34','293702434','782 stambaugh ave',0,'columbus','OH','43207',NULL,'CY','39049','1967-08-13','F','U',':RET:2054-5','T','021','DEN','814410','99734OH005000401','2014-01-01','2013-11-30 23:15:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:01:44'),(15315,12248,'Y','18','021','EC','A','','','AC','0000740046','0000740046','TX00000782831','IL','1','Barrientos','Lori','','','','34','455834163','507 E FAIRMEADOWS DR',0,'DUNCANVILLE','TX','75116','2718','CY','48113','1970-05-07','F','U',':RET:2106-3','N','021','DEN','2302125','33348TX002000101','2014-02-01','2014-01-01 14:09:36','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,1,'2014-01-02 04:23:21'),(20370,16271,'Y','18','024','14','A','','','TE','0001528367','0001528367','','IL','1','Knighton','Jesse','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-14','F','',NULL,NULL,NULL,'','1516617','','2014-01-28','2014-01-28 19:55:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-29 21:00:05'),(22888,18249,'N','19','021','EC','A',NULL,NULL,'','0000401282','0000484835','','S1','1','Bray','Timothy','','','','34','287065989','2275 ORCHARD HILLS BLVD',0,'TOLEDO','OH','43615','2638','CY','39095','2001-09-11','M','',':RET:2106-3','N','021','HLT','3603202','92036OH003002604','2014-03-01','2014-02-11 10:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-11 21:02:36'),(24777,19653,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000941969','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','299983325','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1996-04-30','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:50'),(25081,19891,'Y','18','021','EC','A','','','AC','0001011614','0001011614','OH00002797341','IL','1','Reinhard','Sandra','','','','34','285623985','590 S. Sandusky St.',0,'Tiffin','OH','44883',NULL,'CY','39147','1965-11-24','F','U',NULL,'N','021','HLT','2832074','92036OH005002705','2014-04-01','2014-02-20 13:16:36','247.00',NULL,NULL,'318.82','71.82','R-OH006','OH0','318.82',NULL,0,'2014-02-20 22:01:38'),(25832,20479,'N','19','021','EC','A',NULL,NULL,'','0000008467','0001054272','','IL','1','Love','Jasmine','','','','34','276119449','930 SARA CT',0,'PATASKALA','OH','43062','7060','CY','39089','2005-02-23','F','',NULL,'N','021','DEN','3219242','99734OH005000301','2014-04-01','2014-02-26 17:23:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:30'),(26640,21123,'N','01','021','EC','A',NULL,NULL,'','0001102742','0000692465','','IL','1','TERRAZAS','CLAUDIA','IVETTE','','','34','463752006','339 JUDGEBEAN CIRCLE',0,'CLINT','TX','79836',NULL,'CY','48141','1985-12-01','F','',':RET:2106-3','N','021','DEN','3756073','33348TX002000201','2014-04-01','2014-02-28 17:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 21:31:02'),(13182,10516,'Y','18','021','EC','A','','','AC','0000355173','0000355173','TX00000030393','IL','1','Measher','Joseph','','','','34','636127643','12345 LAMPLIGHT VILLAGE AVE',0,'AUSTIN','TX','78758','2550','CY','48453','1987-08-18','M','U',':RET:2106-3','N','021','DEN','2247818','33348TX002000101','2014-01-01','2013-12-22 22:33:09','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 12:54:22'),(13086,10433,'Y','18','021','EC','A','','','AC','0000934663','0000934663','OH00000634832','IL','1','COSTIGAN','DANIEL','S','','','34','299903845','201 W ROYAL FOREST BLVD',0,'COLUMBUS','OH','43214','2028','CY','39049','1983-03-18','M','U',NULL,'N','021','DEN','1395084','99734OH005000401','2014-01-01','2013-12-23 11:16:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:43'),(18639,14858,'Y','18','021','EC','A','','','AC','0000041128','0000041128','TX00002094083','IL','1','huey','don','','','','34','574765278','3625 Marwick Dr',0,'Plano','TX','75075',NULL,'CY','48085','1957-01-01','M','U',':RET:2040-4','N','021','DEN','2962321','33348TX002000201','2014-02-01','2014-01-15 23:05:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:05'),(17600,14069,'Y','18','021','EC','A','','','AC','0000962338','0000962338','TX00001659274','IL','1','MARTINEZ','ADELA','F','','','34','459949323','3785 E HIGHWAY 285',0,'FALFURRIAS','TX','78355','5813','CY','48047','1951-10-01','F','U',NULL,'N','021','DEN','1369784','33348TX002000201','2014-02-01','2014-01-12 19:20:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:16'),(7549,5974,'Y','18','021','EC','A','','','AC','0000489329','0000489329','LA00001092314','IL','1','Emerson','Lydell','','','','34','439351796','6564 CAMBRIDGE ST',0,'BATON ROUGE','LA','70807','6476','CY','22033','1976-02-23','M','U',':RET:2054-5','N','021','DEN','528919','18575LA002000101','2014-01-01','2013-12-15 10:16:08','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 02:33:09'),(13524,10781,'Y','18','021','EC','A','','','AC','0001382887','0001382887','LA00000182492','IL','1','Smith','Lanetta','','','','34','437536958','13 MARSHALL LN',0,'MONROE','LA','71202','6007','CY','22073','1980-10-09','F','U',NULL,'N','021','DEN','2463459','18575LA002000201','2014-01-01','2013-12-23 10:26:54','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:03:17'),(487,397,'Y','18','024','14','A','','','TE','0001048122','0001048122','','IL','1','reeves','laurie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-20','F','',NULL,NULL,NULL,'','1113200','','2013-12-03','2013-12-03 21:07:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 17:48:19'),(17065,13657,'Y','18','021','EC','A','','','AC','0001138430','0001138430','TX00002395029','IL','1','Eatmon','Javonne','Deshye','','','34','642182014','1526 Reynoldston',0,'Dallas','TX','75232',NULL,'CY','48113','1981-06-02','F','M',':RET:2054-5','N','021','DEN','1545352','33348TX002000201','2014-02-01','2014-01-07 21:43:43','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:14'),(16194,12965,'Y','18','021','EC','A','','','AC','0001057309','0001057309','TX00002029363','IL','1','Kindle','Linda','','','','34','459157141','189 VZCR 1114',0,'Fruitvale','TX','75127',NULL,'CY','48467','1956-09-15','F','M',':RET:2106-3','N','021','DEN','1675731','33348TX002000201','2014-02-01','2014-01-04 10:38:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-05 00:00:56'),(15330,12262,'Y','18','021','EC','A','','','AC','0000007457','0000007457','TX00001989708','IL','1','juarez','norberto','','','','34','452235764','9920 GENIE DR',0,'EL PASO','TX','79924','5016','CY','48141','1966-06-07','M','M',':RET:2106-3','T','021','DEN','2325787','33348TX002000201','2014-02-01','2014-01-01 15:01:35','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,1,'2014-01-02 04:23:54'),(15178,12129,'Y','18','024','14','A','','','TE','0000155774','0000155774','','IL','1','hiser','timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-11-24','M','',NULL,NULL,NULL,'','2199786','','2013-12-30','2013-12-30 17:36:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:45'),(536,437,'Y','18','021','EC','A','','','AC','0000510718','0000510718','MS00000639949','31','1','Spiers','Deborah','','','','34','414941495','2305 TAHOE CV',0,'NESBIT','MS','38651','9043','CY','28033','1952-08-03','F','U',':RET:2106-3','N','021','DEN','829667','46300MS002000101','2014-01-01','2013-12-03 20:54:31','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 17:49:34'),(7521,5952,'Y','18','021','EC','A','','','AC','0000556697','0000556697','OH00000849427','IL','1','Rajendran','Chandrakanthi','','','','34','299885421','12192 BENADIR RD',0,'SPRINGDALE','OH','45246','1949','CY','39061','1951-01-14','F','M',':RET:2029-7','N','021','HLT','210314','92036OH006001201','2014-01-01','2013-12-15 12:22:34','118.00',NULL,NULL,'489.12','371.12','R-OH004','OH0','489.12',NULL,0,'2013-12-26 02:32:23'),(6728,5337,'N','01','021','EC','A',NULL,NULL,'','0000836608','0000692883','','IL','1','Scarlato','Victoria','Lynn','','','34','284802728','3633 Darwin ave',0,'Cincinnati','OH','45211',NULL,'CY','39061','1973-03-30','F','',':RET:2106-3','N','021','DEN','1051284','99734OH005000401','2014-01-01','2013-11-24 23:30:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:15:24'),(5044,3994,'Y','18','021','EC','A','','','AC','0000207101','0000207101','OH00001150405','IL','1','Mohr','Carltan','','','','34','293423015','5191 SPENCER RD',0,'SPENCER','OH','44275','9704','CY','39103','1956-09-29','M','M',NULL,'N','021','HLT','741981','52664OH151001501','2014-01-01','2013-12-07 17:34:59','721.00',NULL,NULL,'1173.90','452.90','R-OH012','OH0','651.81',NULL,0,'2013-12-25 22:48:06'),(19311,15394,'Y','18','021','EC','A','','','AC','0000842455','0000842455','TX00001663485','IL','1','Le','Chrissy','','','','34','630283244','6715 FAIRFIELD WAY',0,'SACHSE','TX','75048','2867','CY','48113','1991-11-09','F','U',':RET:2047-9','N','021','DEN','3159746','33348TX002000201','2014-03-01','2014-01-20 22:17:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:06'),(23937,19033,'N','19','021','EC','A',NULL,NULL,'','0000979339','0000234102','','IL','1','Jorgenson','Michael','Gary','','','34','300156091','754 POINTVIEW DR',0,'WESTERVILLE','OH','43081','3476','CY','39049','2010-08-12','M','',':RET:2106-3','N','021','DEN','3425477','99734OH005000301','2014-03-01','2014-02-15 06:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-15 21:00:07'),(27239,21569,'N','19','021','EC','A',NULL,NULL,'','0000301380','0000245385','','IL','1','Blair','Emily','','','','34','405452410','102 NORTHAMPTON RD',0,'NATCHEZ','MS','39120','5241','CY','28001','1993-05-07','F','',':RET:2106-3','N','021','DEN','3069944','46300MS002000101','2014-04-01','2014-03-03 15:31:36',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-03-03 21:31:46'),(28993,22949,'Y','18','021','EC','A','','','AC','0000177685','0000177685','OH00003841163','IL','1','Campton','Duane','','','','34','274721698','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1970-06-08','M','M',NULL,'N','021','HLT','4056302','92036OH003000601','2014-04-01','2014-03-09 18:58:47','545.00',NULL,NULL,'1028.34','483.34','R-OH005','OH0','304.21',NULL,0,'2014-03-10 21:01:15'),(7678,6081,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000691823','','IL','1','TURNER','BRIAN','A','','','34','301087538','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2004-07-24','M','',NULL,'N','021','DEN','2276263','99734OH005000401','2014-01-01','2013-12-19 19:29:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:00:46'),(16640,13313,'Y','18','024','14','A','','','TE','0000314708','0000314708','','IL','1','stauter','elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-07-22','F','',NULL,NULL,NULL,'','2400398','','2014-01-07','2014-01-07 11:53:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-08 18:24:17'),(1996,1635,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','634156','','2013-11-19','2013-11-19 23:07:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:02:05'),(14998,11987,'Y','18','021','EC','A','','','AC','0000374332','0000374332','TX00001388608','IL','1','ransom','kathy','','','','34','494622386','847 RIDGEWAY',0,'TOW','TX','78672','4989','CY','48299','1956-08-17','F','M',':RET:2106-3','N','021','DEN','1671710','33348TX002000201','2014-02-01','2013-12-30 17:28:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:37'),(14605,11657,'Y','18','021','EC','A','','','AC','0000846148','0000846148','OH00001722465','IL','1','Salama','Moustapha','','','','34','260413906','911 Manor Lane',0,'columbus','OH','43221',NULL,'CY','39049','1957-01-24','M','M',NULL,'N','021','DEN','1450740','99734OH005000301','2014-02-01','2013-12-27 12:11:12','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:36:31'),(14511,11577,'Y','18','021','EC','A','','','AC','0000193546','0000193546','TX00000013027','IL','1','PENA','VALERIE','','','','34','460673811','19923 MORRISON ST',0,'SOMERSET','TX','78069','4487','CY','48029','1974-01-26','F','U',NULL,'N','021','DEN','2548710','33348TX002000201','2014-02-01','2013-12-27 15:53:51','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-28 03:34:02'),(6855,5435,'Y','18','021','EC','A','','','AC','0000012393','0000012393','OH00000203333','IL','1','macaulay','kacie','','','','34','284984284','201 Hugill ct',0,'Akron','OH','44304',NULL,'CY','39153','1987-09-15','F','U',NULL,'T','021','DEN','166107','99734OH005000401','2014-01-01','2013-10-04 19:05:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:31:30'),(5819,4621,'Y','18','021','EC','A','','','AC','0000146874','0000146874','TX00000552245','IL','1','Duncan','Meghann','','','','34','259559883','106 SADDLE DR',0,'COPPERAS COVE','TX','76522','1010','CY','48099','1986-04-15','F','R',':RET:2054-5','N','021','DEN','1833919','33348TX002000201','2014-01-01','2013-12-23 22:05:42','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 23:47:57'),(3791,3037,'Y','18','021','EC','A','','','AC','0000678071','0000678071','OH00000054932','IL','1','Krakora','Elena','','','','34','291640139','30116 THOMAS ST',0,'WILLOWICK','OH','44095','4826','CY','39085','1950-07-22','F','M',':RET:2036-2','N','021','DEN','898806','99734OH005000301','2014-01-01','2013-12-13 10:44:23','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:34:14'),(23262,18547,'Y','18','021','EC','A','','','AC','0000376183','0000376183','OH00001941047','IL','1','Klippel','Keri','','','','34','290925720','17 GRANGER RD',0,'MEDINA','OH','44256','8410','CY','39103','1986-01-30','F','U',':RET:2106-3','N','021','HLT','2707007','52664OH151001501','2014-03-01','2014-02-13 04:57:44','193.00',NULL,NULL,'290.74','97.74','R-OH012','OH0','290.74','CIC',0,'2014-02-13 21:30:10'),(23962,19053,'N','19','021','EC','A',NULL,NULL,'','0000019033','0000555455','','IL','1','Martin','Lucy','Carmela','','','34','629259073','1101 KAREN AVE',0,'AUSTIN','TX','78757','3013','CY','48453','2009-07-30','F','',NULL,'N','021','DEN','2703305','33348TX002000101','2014-03-01','2014-02-15 13:45:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-02-15 22:00:10'),(24337,19327,'Y','18','021','EC','A','','','AC','0000538690','0000538690','TX00001486355','IL','1','Read','Alan','','','','34','462809929','100 HIDEAWAY CIR',0,'INGRAM','TX','78025','5074','CY','48265','1949-08-05','M','U',':RET:2106-3','N','021','DEN','3487102','33348TX002000201','2014-04-01','2014-02-18 14:17:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:17'),(26405,20941,'Y','18','024','14','A','','','TE','0000424047','0000424047','','IL','1','Grigg','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-30','M','',NULL,NULL,NULL,'','2475915','','2014-03-31','2014-02-26 12:26:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:34'),(27757,21950,'Y','18','021','EC','A','','','AC','0001173640','0001173640','LA00002940133','IL','1','Prendergast','Danielle','','','','34','437714014','340 Ridgewood Loop',0,'Mandeville','LA','70471',NULL,'CY','22103','1986-12-28','F','M',':RET:2106-3','N','021','DEN','3791782','18575LA002000201','2014-04-01','2014-03-05 10:56:37','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:18'),(279,230,'Y','18','021','EC','A','','','AC','0000609694','0000609694','TX00000895669','IL','1','Ramsey','Jared','','','','34','467879715','2604 Country Ridge Ln',0,'Arlington','TX','76006',NULL,NULL,NULL,'1980-10-07','M','U',NULL,'T','021','DEN','998742','33348TX002000201','2014-01-01','2013-10-12 14:04:07','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:30:14'),(17838,14250,'Y','18','021','EC','A','','','AC','0000367398','0000367398','OH00002384623','IL','1','Semler','Betty','','','','34','284524926','3081 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','1711','CY','39153','1951-05-24','F','U',NULL,'N','021','DEN','1812947','99734OH005000401','2014-02-01','2014-01-13 19:35:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:02'),(17313,13846,'N','01','021','EC','A',NULL,NULL,'','0000151741','0000564027','','IL','1','Silva','Gilbert','','','','34','353165619','1021 BEECHWOOD DR',0,'TYLER','TX','75701','7630','CY','48423','1921-02-04','M','',NULL,'N','021','DEN','1403492','33348TX002000201','2014-02-01','2014-01-10 14:30:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','16.22',NULL,0,'2014-01-13 02:23:45'),(14381,11471,'Y','18','021','EC','A','','','AC','0000683399','0000683399','OH00001692222','IL','1','Anderson','Ronnie','','','','34','271528170','5381 E TOWNSHIP ROAD 138',0,'TIFFIN','OH','44883','9688','CY','39147','1951-10-22','M','M',':RET:2106-3','N','021','DEN','1908980','99734OH005000401','2014-02-01','2013-12-27 12:39:59','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-28 03:30:47'),(13724,10952,'Y','18','021','EC','A','','','AC','0000872037','0000872037','OH00001017699','IL','1','Thielenhaus','Douglas','','','','34','501744196','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1966-06-29','M','M',':RET:2106-3','N','021','HLT','2009388','52664OH151001305','2014-01-01','2013-12-23 17:32:55','313.00',NULL,NULL,'660.10','347.10','R-OH012','OH0','348.56',NULL,0,'2013-12-26 13:09:16'),(4892,3880,'Y','18','021','EC','A','','','AC','0000120429','0000120429','TX00000730035','IL','1','Bourdeau-Greene','Wislande','','','','34','612078126','5557 DENNIS CAVIN LN',0,'EL PASO','TX','79934','3281','CY','48141','1976-01-14','F','U',NULL,'N','021','DEN','427869','33348TX002000201','2014-01-01','2013-10-04 12:37:16','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 22:31:33'),(9299,7372,'Y','18','021','EC','A','','','AC','0000444874','0000444874','OH00000430006','IL','1','Shannon','Francine','','','','34','384748738','120 1 2  East  San Dusky St',0,'FINDLAY','OH','45840',NULL,'CY','39063','1961-10-19','F','U',':RET:2054-5','T','021','HLT','413579','92036OH003001506','2014-01-01','2013-11-30 13:10:02','415.00',NULL,NULL,'515.93','100.93','R-OH002','OH0','515.93',NULL,0,'2013-12-26 04:16:19'),(3562,2860,'Y','18','024','14','A','','','TE','0000521938','0000521938','','IL','1','Glass','Cena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-12','F','',NULL,NULL,NULL,'','2060289','','2013-12-22','2013-12-22 18:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:22:20'),(2093,1714,'Y','18','021','EC','A','','','AC','0000353765','0000353765','LA00000143357','IL','1','ELKINS','SHARON','','','','34','437159400','3557 DEER RUN RD',0,'LAKE CHARLES','LA','70611',NULL,'CY','22019','1957-09-04','F','M',':RET:2106-3','N','021','DEN','1072324','18575LA002000201','2014-01-01','2013-12-10 18:10:27','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 19:16:57'),(3270,2636,'Y','18','021','EC','A','','','AC','0000422201','0000422201','MS00001291558','IL','1','Milton','Terrie','','','','34','587415275','151 Broadway St',0,'Clinton','MS','39056',NULL,'CY','28049','1970-10-04','M','U',':RET:2054-5','N','021','DEN','129027','46300MS002000201','2014-01-01','2013-11-27 19:48:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 20:47:10'),(2832,2288,'Y','18','021','EC','A','','','AC','0000588228','0000588228','LA00000746956','IL','1','Dupont','Sheila','','','','34','439495717','1163 BEL OIL RD',0,'ELTON','LA','70532','5412','CY','22003','1981-01-04','F','U',':RET:2106-3','N','021','DEN','104165','18575LA002000201','2014-01-01','2013-11-24 16:13:52','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 20:00:47'),(2733,2211,'Y','18','021','EC','A','','','AC','0000263672','0000263672','LA00000751038','IL','1','MILLER','FREDDIE','MAE','','','34','436823697','7546 KAREN LN',0,'NEW ORLEANS','LA','70126','7520','CY','22071','1949-07-16','F','U',':RET:2054-5','N','021','DEN','490793','18575LA002000201','2014-01-01','2013-12-02 12:45:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:32'),(21318,17035,'Y','18','021','EC','A','','','AC','0001840099','0001840099','LA00001508159','IL','1','LEGGETT','MELBA','','','','34','355561872','1744 TENNESSEE ST',0,'NEW ORLEANS','LA','70117','4148','CY','22071','1956-09-05','F','U',NULL,'N','021','DEN','2953943','18575LA002000201','2014-03-01','2014-02-04 16:26:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:21'),(21460,17150,'N','01','021','EC','A',NULL,NULL,'','0000863505','0000715010','','IL','1','Yasin','Abdalla','','','','34','300064718','1653 VICGROSS AVE',0,'AKRON','OH','44310','2711','CY','39153','1980-11-20','M','',':RET:2106-3','N','021','HLT','2672504','52664OH151001306','2014-03-01','2014-02-04 15:37:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.16',NULL,0,'2014-02-04 21:01:33'),(21634,17274,'Y','18','021','EC','A','','','AC','0000386724','0000386724','TX00002419270','IL','1','Stork','Debra','','','','34','430023143','125 E GARDENIA',0,'SOUTH PADRE ISLAND','TX','78597','4290','CY','48061','1950-04-24','F','M',':RET:2106-3','T','021','DEN','2929898','33348TX002000201','2014-03-01','2014-02-05 12:49:49','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-05 21:30:42'),(23823,18955,'Y','18','021','EC','A','','','AC','0001213504','0001213504','OH00001477200','IL','1','FOURNIER','HEATHER','','','','34','300909419','1723 Milroy St',0,'Toledo','OH','43605',NULL,'CY','39095','1987-03-11','F','U',NULL,'N','021','HLT','3745271','92036OH001002601','2014-03-01','2014-02-13 19:43:19','157.00',NULL,NULL,'240.85','83.85','R-OH001','OH0','240.85',NULL,0,'2014-02-14 21:31:41'),(24932,19771,'Y','18','021','EC','A','','','AC','0000888171','0000888171','OH00002525047','IL','1','ANGERSTIEN','DENISE','','','','34','292601297','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','1977-05-30','F','U',':RET:2106-3','N','021','DEN','3404832','99734OH005000301','2014-03-01','2014-02-20 16:08:14','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00','CIC',0,'2014-02-20 21:30:20'),(25612,20321,'Y','18','021','EC','A','','','AC','0000834345','0000834345','TX00002816374','IL','1','Rueda','Maria',NULL,NULL,NULL,NULL,NULL,'2017 Rosita Valley Road',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1964-05-26','F','M',':RET:2106-3','N','021','DEN','2797906','33348TX002000201','2014-04-01','2014-02-22 09:52:07','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 08:30:09'),(25838,20482,'N','01','021','EC','A',NULL,NULL,'','0000637168','0000977989','','IL','1','SHERWOOD','STEPHEN','','','','34','279520044','20145 TAYLOR ST',0,'WESTON','OH','43569','9714','CY','39173','1950-10-18','M','',':RET:2106-3','N','021','HLT','2700748','92036OH003002601','2014-03-01','2014-02-26 08:17:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','601.12',NULL,0,'2014-02-26 21:00:33'),(27290,21609,'Y','18','021','EC','A','','','AC','0000656755','0000656755','TX00002825963','IL','1','burger','wanda',NULL,NULL,NULL,NULL,NULL,'1601 FM 3036',0,'ROCKPORT','TX','78382','7675','CY','48007','1952-11-10','F','U',':RET:2106-3','N','021','DEN','2662455','33348TX002000201','2014-04-01','2014-03-04 09:35:57','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-03-04 21:00:28'),(9352,7412,'Y','18','021','EC','A','','','AC','0001429846','0001429846','LA00000540267','IL','1','LEAR','REGINA','','','','34','437394927','4412 CLEARLAKE DR',0,'METAIRIE','LA','70006','2218','CY','22051','1979-09-21','F','U',NULL,'N','021','DEN','2259097','18575LA002000201','2014-01-01','2013-12-20 23:38:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:16'),(18286,14599,'Y','18','021','EC','A','','','AC','0001036152','0001036152','OH00001683859','IL','1','Mazur','Linda','','','','34','280468342','404 Somerset Road',0,'Akron','OH','44313',NULL,'CY','39153','1950-02-20','F','M',':RET:2106-3','N','021','DEN','2126584','99734OH005000401','2014-02-01','2014-01-14 20:04:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:44:50'),(7061,5609,'Y','18','021','EC','A','','','AC','0001166822','0001166822','OH00000926665','IL','1','Hunt','Dolores','C','','','34','286581769','1931 GEFFS AVE',0,'FINDLAY','OH','45840','3837','CY','39063','1955-09-21','F','U',':RET:2106-3','N','021','DEN','2315811','99734OH005000301','2014-01-01','2013-12-24 21:26:50','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 01:49:56'),(16369,13100,'Y','18','021','EC','A','','','AC','0000071699','0000071699','TX00002252727','IL','1','Hooper','Susanna','','','','34','460776583','4200 SCOTLAND ST',0,'HOUSTON','TX','77007',NULL,'CY','48201','1975-03-31','F','R',':RET:2106-3','N','021','DEN','1673024','33348TX002000101','2014-02-01','2014-01-06 12:32:14','0.00',NULL,NULL,'101.40','101.40','R-TX010','TX0','27.15',NULL,0,'2014-01-07 04:03:00'),(6596,5230,'Y','18','021','EC','A','','','AC','0001175959','0001175959','MS00000621140','IL','1','Seay','Heather','Renee','','','34','467991771','308 KIMBERLY DR',0,'GULFPORT','MS','39503','2904','CY','28047','1988-06-18','F','M',':RET:2106-3','N','021','DEN','300782','46300MS002000101','2014-01-01','2013-12-11 11:03:43','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-26 00:53:25'),(14779,11802,'Y','18','021','EC','A','','','AC','0000264202','0000264202','OH00000003309','IL','1','Peterson','Aaron','','','','34','259630592','8238 EMERALD AVE NE',0,'CANTON','OH','44721','1772','CY','39151','1977-05-08','M','R',':RET:2106-3','N','021','HLT','2544931','52664OH151001501','2014-01-01','2013-12-23 20:42:16','0.00',NULL,NULL,'328.98','328.98','R-OH015','OH0','328.98',NULL,1,'2013-12-29 11:13:10'),(4472,3552,'N','19','021','EC','A',NULL,NULL,'','0000129245','0000205763','','IL','1','Dail','Olivia',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1997-06-06','F','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:51'),(19411,15475,'N','01','021','EC','A',NULL,NULL,'','0000196164','0000114229','','IL','1','Gruich','Sandra','','','','34','286623781','2449 GREENHAVEN DR',0,'AKRON','OH','44333','2753','CY','39153','1967-08-24','F','',':RET:2106-3','N','021','HLT','3023737','52664OH152000901','2014-03-01','2014-01-21 11:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.01',NULL,1,'2014-01-22 03:22:57'),(23729,18892,'Y','18','021','EC','A','','','AC','0001243014','0001243014','OH00002326316','IL','1','Parker','MaryLouise','','','','34','283545232','4550 INDIAN RD',0,'OTTAWA HILLS','OH','43615','2226','CY','39095','1950-12-22','F','U',':RET:2106-3','N','021','HLT','3838030','92036OH003002604','2014-03-01','2014-02-13 18:37:50','385.00',NULL,NULL,'601.12','216.12','R-OH001','OH0','601.12',NULL,0,'2014-02-14 21:30:56'),(1848,1513,'N','01','021','EC','A',NULL,NULL,'','0001095662','0000507994','','IL','1','KLINESMITH','REBECCA','','','','34','273827425','16278 SHILLING RD',0,'BERLIN CENTER','OH','44401',NULL,'CY','39099','1974-02-15','F','',NULL,'N','021','HLT','1710749','52664OH151001305','2014-01-01','2013-12-24 16:17:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.15',NULL,0,'2013-12-25 18:57:50'),(15510,12408,'Y','18','021','EC','A','','','AC','0000039824','0000039824','OH00001716078','IL','1','Jones','Theresa','M','','','34','282504032','2671 Montana Ave',0,'Cincinnati','OH','45211',NULL,'CY','39061','1954-03-14','F','M',':RET:2054-5','N','021','DEN','1396926','99734OH005000401','2014-02-01','2013-12-31 16:49:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:29:57'),(15835,12679,'Y','18','021','EC','A','','','AC','0001231780','0001231780','OH00000079557','IL','1','MELLUSO','REBECCA','L','','','34','297885759','1411 IROQUOIS AVE',0,'MAYFIELD HEIGHTS','OH','44124','1550','CY','39035','1980-05-26','F','R',NULL,'N','021','DEN','1579912','99734OH005000401','2014-02-01','2014-01-02 11:46:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:03:58'),(20476,16357,'Y','18','021','EC','A','','','AC','0000234081','0000234081','OH00001398990','S1','1','shaferly','michael','david','','','34','281113012','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','2005-04-04','F','U',':RET:2106-3','N','021','DEN','2665488','99734OH005000401','2014-03-01','2014-01-29 15:11:14','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','15.78',NULL,0,'2014-01-29 21:00:58'),(23149,18454,'Y','18','021','EC','A','','','AC','0000680894','0000680894','OH00001769984','IL','1','Young','Deborah','','','','34','272564373','1750 Adelaide Blvd.',0,'Akron','OH','44305',NULL,'CY','39153','1954-02-20','F','U',':RET:2106-3','N','021','HLT','3733229','52664OH151001304','2014-03-01','2014-02-12 14:37:29','423.00',NULL,NULL,'605.24','182.24','R-OH012','OH0','605.24',NULL,0,'2014-02-12 21:31:40'),(25529,20252,'Y','18','021','EC','A','','','AC','0000538710','0000538710','MS00002221790','31','1','TRIPLETT','LINDA','','','','34','426432441','P O BOX 1644',0,'PASCAGOULA','MS','39568',NULL,'CY','28059','1980-10-18','F','U',':RET:2054-5','N','021','DEN','2753739','46300MS002000101','2014-04-01','2014-02-22 19:01:42','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-26 08:00:03'),(26293,20857,'Y','18','021','EC','A','','','AC','0000367437','0000367437','OH00002618725','IL','1','MCKEE','KRISTY','','','','34','271706558','17555 BEECH ST',0,'GRAND RAPIDS','OH','43522','9728','CY','39173','1971-07-19','F','U',':RET:2106-3','N','021','HLT','3115901','92036OH005002605','2014-04-01','2014-02-27 07:55:01','68.00',NULL,NULL,'258.38','190.38','R-OH001','OH0','258.38',NULL,0,'2014-02-28 06:31:25'),(27072,21435,'Y','18','021','EC','A','','','AC','0000961923','0000961923','OH00002594045','IL','1','Berman','Gail','L','','','34','271541436','486 TULIP TRL',0,'WADSWORTH','OH','44281','1247','CY','39103','1953-01-04','F','U',':RET:2106-3','N','021','HLT','3046308','52664OH152000901','2014-04-01','2014-03-03 06:45:11','362.00',NULL,NULL,'458.99','96.99','R-OH012','OH0','458.99',NULL,0,'2014-03-03 21:30:06'),(28385,22459,'Y','18','021','EC','A','','','AC','0000975299','0000975299','OH00002921845','IL','1','Duncan','Darodd','','','','34','268522760','201 BLUFF ST',0,'AKRON','OH','44304','1231','CY','39153','1953-04-01','M','U',':RET:2054-5','T','021','HLT','3059312','52664OH152000901','2014-04-01','2014-03-07 15:19:00','500.00',NULL,NULL,'527.84','27.84','R-OH012','OH0','527.84',NULL,0,'2014-03-07 21:30:42'),(1190,979,'Y','18','024','14','A','','','TE','0001200866','0001200866','','IL','1','Morris','Lloyd',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-01','M','',NULL,NULL,NULL,'','634259','','2013-12-03','2013-12-03 10:07:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:19:34'),(17450,13956,'N','01','021','EC','A',NULL,NULL,'','0001005730','0001007898','','IL','1','Kennedy','Tabitha',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','1984-01-29','F','',':RET:2106-3','N','021','HLT','1698891','92036OH002000601','2014-02-01','2014-01-10 14:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.38',NULL,0,'2014-01-13 03:00:38'),(16851,13481,'Y','18','021','EC','A','','','AC','0000562228','0000562228','MS00001915838','IL','1','prezel-parker','stacey','','','','34','310946264','2173 BARNETT RD',0,'SUMMIT','MS','39666','9187','CY','28113','1969-08-18','F','U',':RET:2106-3','T','021','DEN','1729559','46300MS002000101','2014-02-01','2014-01-11 14:40:10','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:18:40'),(15513,12411,'Y','18','021','EC','A','','','AC','0000751026','0000751026','OH00001583785','IL','1','Maldonado','Michael','Anthony','','','34','282461213','4214 DOVER CENTER RD',0,'NORTH OLMSTED','OH','44070','2506','CY','39035','1961-02-13','M','U',':RET:2106-3','N','021','DEN','2133675','99734OH005000401','2014-02-01','2013-12-31 18:20:44','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:30:04'),(14481,11553,'Y','18','021','EC','A','','','AC','0001012975','0001012975','TX00001410405','IL','1','Dominguez','Maria','','','','34','459842361','2734 Sarita St.',0,'Corpus Christi','TX','78405',NULL,NULL,NULL,'1951-07-27','F','M',':RET:2106-3','N','021','DEN','1894342','33348TX002000201','2014-02-01','2013-12-26 21:33:17','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-28 03:33:16'),(4737,3753,'Y','18','021','EC','A','','','AC','0000261473','0000261473','OH00000181986','IL','1','Stout','Sandra','','','','34','268465501','9160 ARMSTRONG RD',0,'SPENCERVILLE','OH','45887','9718','CY','39003','1949-09-14','F','M',':RET:2106-3','N','021','HLT','565330','92036OH002001501','2014-01-01','2013-12-12 15:12:16','320.00',NULL,NULL,'762.47','442.47','R-OH002','OH0','762.47',NULL,0,'2013-12-25 22:09:20'),(19856,15837,'N','01','021','EC','A',NULL,NULL,'','0000344169','0000340325','','IL','1','Evans','Susan','B','','','34','163443352','867 OVERLOOK DR',0,'WINTERSVILLE','OH','43953','7405','CY','39081','1951-11-02','F','',':RET:2106-3','N','021','DEN','2853599','99734OH005000301','2014-03-01','2014-01-24 13:46:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-24 21:00:33'),(20109,16044,'Y','18','024','14','A','','','TE','0000019448','0000019448','','IL','1','Chance','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-20','M','',NULL,NULL,NULL,'','811884','','2014-01-27','2014-01-27 16:31:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:39'),(21230,16966,'Y','18','021','EC','A','','','AC','0000634849','0000634849','OH00002297717','IL','1','BLESSING','MARC','L','','','34','303560627','1520 QUEEN ANNES GATE',0,'WESTLAKE','OH','44145','2636','CY','39035','1953-11-14','M','M',NULL,'N','021','DEN','3105087','99734OH005000301','2014-03-01','2014-02-03 11:06:58','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:01:09'),(21754,17371,'N','01','021','EC','A',NULL,NULL,'','0000950313','0000511668','','IL','1','MIRANDA','IRENE','','','','34','639445202','875 S HIGHWAY 175',0,'SEAGOVILLE','TX','75159',NULL,'CY','48257','1976-05-04','F','',NULL,'N','021','DEN','3441909','33348TX002000201','2014-03-01','2014-02-05 22:54:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-06 21:00:22'),(23707,18875,'N','01','021','EC','A',NULL,NULL,'','0000231548','0000802622','','IL','1','KIM','JOO HYUN','','','','34','297045897','5656 E FOUNTAIN CIR',0,'MASON','OH','45040','7310','CY','39165','1970-11-23','F','',':RET:2040-4','N','021','DEN','2796352','99734OH005000401','2014-03-01','2014-02-14 12:16:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:44'),(24717,19626,'Y','18','021','EC','A','','','AC','0000467141','0000467141','OH00002367482','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-20 04:37:22'),(25092,19901,'Y','18','024','14','A','','','TE','0000471065','0000471065','','IL','1','Vegara','Koviljka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-09-27','F','',NULL,NULL,NULL,'','3354189','','2014-02-28','2014-02-20 20:52:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:05'),(27771,21961,'Y','18','021','EC','A','','','AC','0001254673','0001254673','LA00003231073','IL','1','SHEARRY','DONALD','','','','34','570751391','2313 ALEX KORMAN BLVD',0,'HARVEY','LA','70058',NULL,'CY','22051','1980-10-10','M','U',NULL,'N','021','DEN','3033543','18575LA002000201','2014-04-01','2014-03-05 16:48:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:26'),(28148,22275,'N','01','021','EC','A',NULL,NULL,'','0000069137','0000566678','','IL','1','Smith','Raymond','','','','34','271528308','234 NORTHDALE DR',0,'TOLEDO','OH','43612','3673','CY','39095','1952-01-22','M','',NULL,'N','021','HLT','3946623','92036OH001002601','2014-04-01','2014-03-06 11:40:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','675.75',NULL,0,'2014-03-06 21:02:35'),(574,469,'N','01','021','EC','A',NULL,NULL,'','0000639489','0000344106','','IL','1','Wagner','John','','','','34','292644846','2106 KNIGHTSBRIDGE DR',0,'CINCINNATI','OH','45244','2629','CY','39061','1973-07-05','M','',':RET:2106-3','N','021','HLT','1123905','92036OH005001201','2014-01-01','2013-12-03 23:11:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','274.35',NULL,0,'2013-12-25 17:50:40'),(1165,962,'Y','18','021','EC','A','','','AC','0000140842','0000140842','LA00000168677','IL','1','Saucier','Deborah','','','','34','438471475','11710 SIMMS RD',0,'DENHAM SPRINGS','LA','70706','0399','CY','22063','1967-02-18','F','M',':RET:2106-3','N','021','DEN','115126','18575LA002000201','2014-01-01','2013-12-03 17:18:07','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:19:01'),(9788,7750,'Y','18','021','EC','A','','','AC','0000563092','0000563092','OH00000553638','IL','1','Clark','Michael','','','','34','274845132','6157 CALIFORNIA RD',0,'WILLIAMSFIELD','OH','44093','9789','CY','39007','1983-02-16','M','U',':RET:2106-3','N','021','HLT','28375','52664OH151001306','2014-01-01','2013-10-20 11:42:27','264.00',NULL,NULL,'285.47','21.47','R-OH011','OH0','285.47',NULL,0,'2013-12-26 05:00:53'),(7035,5587,'Y','18','024','14','A','','','TE','0000043439','0000043439','','IL','1','Cannon','Stephanie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-15','F','',NULL,NULL,NULL,'','1746149','','2013-12-24','2013-12-24 23:50:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 01:49:14'),(6806,5398,'N','01','021','EC','A',NULL,NULL,'','0000121579','0000834004','','IL','1','Andrews','Hanna','Lynn','','','34','438792751','5202 Bangor Avenue',0,'Lubbock','TX','79414',NULL,'CY','48303','1987-08-30','F','',':RET:2106-3','N','021','DEN','918133','33348TX002000101','2014-01-01','2013-11-14 09:21:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-26 01:30:09'),(21059,16826,'Y','18','021','EC','A','','','AC','0001193467','0001193467','LA00002133995','IL','1','Whaley','Benjamin','','','','34','438497600','7001 WALMSLEY AVE',0,'NEW ORLEANS','LA','70125','3505','CY','22071','1975-03-04','M','R',':RET:2106-3','N','021','DEN','2810443','18575LA002000201','2014-03-01','2014-02-02 10:56:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-02 19:00:10'),(21379,17086,'N','01','021','EC','A',NULL,NULL,'','0000364923','0000479886','','IL','1','Elliott','Michael','L','','','34','284525768','10270 Danvers Drive',0,'Concord','OH','44077',NULL,'CY','39085','1953-09-19','M','',':RET:2106-3','N','021','DEN','2683285','99734OH005000401','2014-03-01','2014-02-03 21:07:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:51'),(23562,18770,'Y','18','021','EC','A','','','AC','0000866932','0000866932','OH00001560708','31','1','KOLB','JEREMY','R','','','34','288802413','POX 305',0,'SHERWOOD','OH','43556',NULL,'CY','39039','1978-12-06','M','U',NULL,'N','021','HLT','3105339','92036OH005002604','2014-03-01','2014-02-12 18:46:22','104.00',NULL,NULL,'238.27','134.27','R-OH001','OH0','238.27',NULL,0,'2014-02-13 22:02:44'),(26258,20826,'N','01','021','EC','A',NULL,NULL,'','0000556666','0001096922','','IL','1','Gonzalez Alderete','Ricardo','','','','34','614379470','3444 JAN DE ROOS PL',0,'EL PASO','TX','79936','2559','CY','48141','1961-02-26','M','',':RET:2106-3','N','021','DEN','2825997','33348TX002000201','2014-04-01','2014-02-27 15:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 06:31:11'),(27609,21835,'Y','18','021','EC','A','','','AC','0002277357','0002277357','LA00002400792','IL','1','Bucalan','Normita','','','','34','436755264','4005 W LOUISIANA STATE DR',0,'KENNER','LA','70065','1603','CY','22051','1962-12-15','F','U',':RET:2028-9','N','021','DEN','3976523','18575LA002000201','2014-04-01','2014-03-05 12:14:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-03-05 21:00:27'),(117,102,'Y','18','021','EC','A','','','AC','0000745350','0000745350','TX00000023602','IL','1','KERVIN','PENNY','','','','34','445549990','10865 COLONIAL HEIGHTS LANE',0,'FORT WORTH','TX','76179',NULL,'CY','48439','1953-01-30','F','U',NULL,'N','021','DEN','117708','33348TX002000201','2014-01-01','2013-12-05 15:21:04','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:18:06'),(18502,14757,'Y','18','021','EC','A','','','AC','0000893173','0000893173','OH00002192178','IL','1','Rood','Donald','','','','34','286542225','314 27TH ST NW',0,'MASSILLON','OH','44647','6041','CY','39151','1953-12-06','M','M',NULL,'N','021','HLT','1796418','52664OH151001305','2014-02-01','2014-01-15 15:01:11','414.00',NULL,NULL,'605.24','191.24','R-OH015','OH0','605.24',NULL,0,'2014-01-16 08:46:30'),(17884,14283,'Y','18','021','EC','A','','','AC','0001067008','0001067008','OH00002108822','IL','1','zafuto','isaac','','','','34','285880672','12505 EDGEWATER DR',0,'LAKEWOOD','OH','44107','1678','CY','39035','1982-11-06','M','U',':RET:2106-3','N','021','DEN','1490309','99734OH005000401','2014-02-01','2014-01-14 14:42:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:17'),(17098,13684,'Y','18','021','EC','A','','','AC','0000629485','0000629485','TX00001863496','IL','1','Preston','Laurie','','','','34','279529789','9111 Ridge Post',0,'San Antonio','TX','78250',NULL,'CY','48029','1950-11-02','F','M',':RET:2106-3','N','021','DEN','2295428','33348TX002000201','2014-02-01','2014-01-08 16:22:19','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:21:30'),(7587,6002,'Y','18','021','EC','A','','','AC','0000303965','0000303965','TX00000335708','IL','1','Johnson','Laura','','','','34','455946767','13811 Beckledge Ln',0,'Houston','TX','77047',NULL,'CY','48201','1949-11-09','F','M',':RET:2054-5','N','021','DEN','382150','33348TX002000101','2014-01-01','2013-12-15 17:55:26','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:34:06'),(3575,2870,'Y','18','024','14','A','','','TE','0000777665','0000777665','','IL','1','joseph','gerald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-17','M','',NULL,NULL,NULL,'','1472476','','2013-12-22','2013-12-22 08:49:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:22:38'),(20252,16161,'Y','18','021','EC','A','','','AC','0000216049','0000216049','TX00002265355','IL','1','Wright','Webb','','','','34','454634086','4803 TX HWY 24 North',0,'Cooper','TX','75432',NULL,'CY','48119','1968-11-30','M','U',':RET:2106-3','N','021','DEN','3509304','33348TX002000101','2014-03-01','2014-01-28 17:31:53','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-28 21:00:14'),(24711,19620,'Y','18','021','EC','A','','','AC','0000655871','0000655871','OH00002365137','IL','1','Conti','Jordan','','','','34','299846606','5418 CYPRESS CHASE',0,'COLUMBUS','OH','43228','7215','CY','39049','1986-08-29','M','U',':RET:2106-3','N','021','DEN','3212081','99734OH005000401','2014-04-01','2014-02-19 01:08:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:36:02'),(25426,20175,'Y','18','021','EC','A','','','AC','0000148390','0000148390','OH00003369984','IL','1','sparks','genoa','j','','','34','400762435','8865 canoe dr',0,'galloway','OH','43119',NULL,'CY','39049','1952-07-01','F','M',NULL,'N','021','DEN','3836997','99734OH005000401','2014-04-01','2014-02-25 17:33:24','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-25 21:31:12'),(27551,21793,'Y','18','024','14','A','','','TE','0000673739','0000673739','','IL','1','Davila','Delila',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-08','F','',NULL,NULL,NULL,'','3771543','','2014-03-31','2014-03-03 20:29:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-04 21:30:12'),(393,323,'Y','18','021','EC','A','','','AC','0000960569','0000960569','OH00001206101','IL','1','McCreary','Patrick','','','','34','305605797','1204 HOLLOWBROOK DR',0,'DAYTON','OH','45458','1828','CY','39113','1951-06-21','M','U',':RET:2106-3','N','021','DEN','42283','99734OH005000401','2014-01-01','2013-12-03 18:25:09','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:45:56'),(16505,13204,'Y','18','021','EC','A','','','AC','0000741727','0000741727','OH00002058237','IL','1','levert','billie','','','','34','291540655','16000 oak hill rd east',0,'cleveland','OH','44112','2925','CY','39035','1956-05-26','F','U',':RET:2054-5','N','021','DEN','1656962','99734OH005000301','2014-02-01','2014-01-04 18:32:34','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-07 10:21:12'),(15235,12177,'Y','18','021','EC','A','','','AC','0000597311','0000597311','OH00001276023','IL','1','FLOWER','NANCY','','','','34','272446239','512 EVERGREEN DR',0,'TALLMADGE','OH','44278','1359','CY','39153','1960-05-30','F','U',':RET:2106-3','T','021','HLT','1613182','52664OH151001501','2014-02-01','2013-12-30 15:55:39','177.00',NULL,NULL,'627.47','450.47','R-OH012','OH0','627.47',NULL,0,'2014-01-01 12:08:24'),(1524,1270,'Y','18','021','EC','A','','','AC','0000225973','0000225973','OH00001559547','31','1','warner','robert','','','','34','341627334','P.O. Box 603216',0,'cleveland','OH','44103',NULL,'CY','39035','1964-03-25','M','R',':RET:2106-3','N','021','DEN','2382590','99734OH005000401','2014-01-01','2013-12-24 15:19:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:50'),(5930,4694,'N','01','021','EC','A',NULL,NULL,'','0000036941','0000273913','','IL','1','Sailors','Elena','','','','34','457533686','51 S Burberry Park Cir',0,'The Woodlands','TX','77382',NULL,'CY','48339','1981-03-12','F','',':RET:2036-2^:RET:2106-3','N','021','DEN','1534307','33348TX002000101','2014-01-01','2013-12-24 01:27:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:28'),(21649,17288,'Y','18','024','14','A','','','TE','0001963571','0001963571','','IL','1','parker','monique',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-04-08','F','',NULL,NULL,NULL,'','1877236','','2014-02-04','2014-02-04 19:51:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-05 21:30:49'),(24306,19305,'Y','18','024','14','A','','','TE','0001200874','0001200874','','IL','1','Bunton','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-16','M','',NULL,NULL,NULL,'','1213088','','2014-03-31','2014-02-18 16:35:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:23'),(25186,19978,'Y','18','021','EC','A','','','AC','0000805938','0000805938','TX00002753751','IL','1','Alimi','Mohammad','','','','34','457576676','1113 WATERFORD WAY',0,'ALLEN','TX','75013','5622','CY','48085','1957-01-15','M','M',':RET:2028-9','N','021','DEN','3701651','33348TX002000101','2014-04-01','2014-02-20 22:53:34','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-02-21 22:00:37'),(26669,21143,'Y','18','021','EC','A','','','AC','0001407502','0001407502','LA00002804011','IL','1','RENDELL','JUSTIN','','','','34','435653107','4735 GOVERNMENT ST',0,'BATON ROUGE','LA','70806','0802','CY','22033','1987-05-23','M','U',':RET:2054-5','N','021','DEN','3468531','18575LA002000201','2014-04-01','2014-02-28 00:14:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:17'),(27810,21995,'Y','18','021','EC','A','','','AC','0000054525','0000054525','OH00003303831','IL','1','stuhldreher','heather','','','','34','292600780','617 EDGEHILL AVE',0,'ASHLAND','OH','44805','4117','CY','39005','1976-09-20','F','U',':RET:2106-3','T','021','HLT','2996841','52664OH151001306','2014-04-01','2014-03-05 14:47:53','204.00',NULL,NULL,'317.50','113.50','R-OH012','OH0','317.50',NULL,0,'2014-03-05 21:31:49'),(29156,23079,'N','01','021','EC','A',NULL,NULL,'','0000691894','0000182358','','IL','1','Hill','Brenda',NULL,NULL,NULL,NULL,NULL,'1029 CLYMENA ST',0,'TOLEDO','OH','43612','1720','CY','39095','1964-12-18','F','',NULL,'N','021','HLT','4105432','92036OH003002601','2014-04-01','2014-03-10 12:34:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','347.41',NULL,0,'2014-03-10 21:02:51'),(7742,6131,'Y','18','021','EC','A','','','AC','0000777676','0000777676','OH00000948863','IL','1','Alexander','Christopher','','','','34','290909508','2140 W 29TH ST',0,'CLEVELAND','OH','44113','4007','CY','39035','1986-01-07','M','U',':RET:2106-3','N','021','DEN','1781517','99734OH005000401','2014-01-01','2013-12-20 15:43:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:18'),(19949,15912,'Y','18','021','EC','A','','','AC','0001987419','0001987419','LA00002214687','IL','1','BERNAL','TERESA','','','','34','635664793','305 N FRANCES AVE',0,'GONZALES','LA','70737','3221','CY','22005','1975-11-10','F','M',NULL,'N','021','DEN','1810245','18575LA002000201','2014-03-01','2014-01-24 18:27:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-25 19:00:02'),(15318,12250,'Y','18','021','EC','A','','','AC','0000099825','0000099825','TX00001071728','31','1','KIRBY','ADRAINE','M','','','34','464771246','8004 W VIRGINIA DR',0,'DALLAS','TX','75237',NULL,'CY','48113','1973-02-25','F','U',':RET:2054-5','N','021','DEN','2261752','33348TX002000201','2014-02-01','2013-12-31 19:49:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:23:26'),(18473,14737,'Y','18','021','EC','A','','','AC','0000494464','0000494464','OH00002059507','IL','1','Bilinovich','Stephanie','','','','34','280882132','6393 HAMPSHER RD',0,'CLINTON','OH','44216','9140','CY','39153','1985-10-17','F','U',':RET:2106-3','N','021','HLT','2645728','52664OH151001305','2014-02-01','2014-01-14 20:37:51','146.00',NULL,NULL,'242.41','96.41','R-OH012','OH0','242.41',NULL,0,'2014-01-16 08:46:18'),(15324,12256,'Y','18','021','EC','A','','','AC','0001251721','0001251721','TX00001732563','IL','1','ARLAND','MARILYN','','','','34','466882193','5113 94TH ST',0,'LUBBOCK','TX','79424',NULL,'CY','48303','1951-02-03','F','U',NULL,'N','021','DEN','2569866','33348TX002000201','2014-02-01','2013-12-31 22:48:58','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,1,'2014-01-02 04:23:40'),(15705,12564,'Y','18','021','EC','A','','','AC','0000683403','0000683403','OH00001604400','IL','1','pies','julie','','','','34','297762988','117 S WALNUT ST',0,'YELLOW SPRINGS','OH','45387','1728','CY','39057','1970-04-27','F','U',NULL,'N','021','HLT','1569886','92036OH006000501','2014-02-01','2013-12-31 14:54:51','233.00',NULL,NULL,'255.81','22.81','R-OH003','OH0','255.81',NULL,1,'2014-01-02 04:35:53'),(19439,15495,'N','19','021','EC','A',NULL,NULL,'','0000431402','0001227055','','IL','1','Ladd','Jack','','','','34','271132120','3380 WHISPERING TREES DR',0,'AMELIA','OH','45102','2327','CY','39025','2006-10-10','M','',':RET:2106-3','N','021','HLT','1465689','92036OH003000601','2014-03-01','2014-01-21 15:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,1,'2014-01-22 03:23:12'),(23539,18752,'Y','18','021','EC','A','','','AC','0002100986','0002100986','LA00002309775','IL','1','EDGAR','JANE','','','','34','615150549','8 RIVER LN',0,'LAKE CHARLES','LA','70605','7712','CY','22019','1962-12-18','F','U',':RET:2106-3','N','021','DEN','3266808','18575LA002000201','2014-03-01','2014-02-13 12:34:12','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-13 22:02:31'),(24058,19131,'N','01','021','EC','A',NULL,NULL,'','0000558192','0000212214','','IL','1','BEGLEY','DOUGLAS','','','','34','268489046','4238 WILLIAMSPORT DR',0,'BEAVERCREEK','OH','45430','1837','CY','39057','1959-02-07','M','',':RET:2106-3','N','021','DEN','3143301','99734OH005000301','2014-03-01','2014-02-14 20:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:07'),(24789,19663,'Y','18','021','EC','A','','','AC','0000108209','0000108209','OH00001952089','IL','1','RENTSCHLER','CINDY','','','','34','296608590','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247',NULL,'CY','39061','1962-03-18','F','U',':RET:2106-3','N','021','DEN','2618926','99734OH005000401','2014-04-01','2014-02-19 13:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:46:39'),(25834,20480,'Y','18','021','EC','A','','','AC','0001074198','0001074198','OH00003180186','IL','1','Dorman','Kenneth','','','','34','286843599','1072 TINKERS GREEN DR',0,'STREETSBORO','OH','44241','4993','CY','39133','1985-11-28','M','U',':RET:2054-5','N','021','DEN','3711168','99734OH005000301','2014-03-01','2014-02-26 17:36:06','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-26 21:00:31'),(26516,21031,'N','19','021','EC','A',NULL,NULL,'','0000294433','0000541704','','S1','1','Dietrich','Kara','M','','','34','268060473','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','2000-08-20','M','',NULL,'N','021','HLT','3280933','92036OH003002706','2014-03-01','2014-02-28 14:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-28 21:00:22'),(27566,21803,'Y','18','024','14','A','','','TE','0000209610','0000209610','','IL','1','Tupaz','Benjamin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-07','M','',NULL,NULL,NULL,'','1028217','','2014-03-31','2014-03-04 14:02:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:19'),(28069,22213,'Y','18','021','EC','A','','','AC','0001080395','0001080395','OH00003433479','IL','1','Weimer','Wayne','W','','','34','273521157','310 ELRUTH CT',0,'GIRARD','OH','44420','3028','CY','39155','1950-01-08','M','U',':RET:2106-3','N','021','DEN','3668566','99734OH005000301','2014-04-01','2014-03-06 13:11:31','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-03-06 21:01:49'),(549,450,'Y','18','021','EC','A','','','AC','0000322751','0000322751','TX00000944249','IL','1','Drucker','Laurie','','','','34','227661661','2909 SILVERLEAF DR',0,'AUSTIN','TX','78757','1606','CY','48453','1958-03-18','F','U',':RET:2106-3','N','021','DEN','723447','33348TX002000101','2014-01-01','2013-12-04 12:38:54','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 17:49:58'),(9448,7495,'Y','18','021','EC','A','','','AC','0001131435','0001131435','OH00001000085','IL','1','Wilczak','Kay','','','','34','282789146','16071 COUNTY ROAD 46',0,'BELLEVUE','OH','44811','9561','CY','39147','1972-10-16','F','U',':RET:2106-3','N','021','DEN','2581007','99734OH005000401','2014-01-01','2013-12-20 20:06:50','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 04:33:53'),(4547,3604,'Y','18','021','EC','A','','','AC','0000392352','0000392352','OH00000439793','IL','1','warden','karen','e','','','34','234064178','8202 SHERMAN RD',0,'CHESTERLAND','OH','44026','2141','CY','39055','1959-08-12','F','R',':RET:2106-3','N','021','HLT','1231149','52664OH152000901','2014-01-01','2013-12-11 20:55:11','0.00',NULL,NULL,'393.32','393.32','R-OH011','OH0','393.32',NULL,0,'2013-12-25 22:04:28'),(15127,12090,'Y','18','024','14','A','','','TE','0001063253','0001063253','','IL','1','McGuire','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-21','F','',NULL,NULL,NULL,'','2611229','','2013-12-30','2013-12-30 17:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:05:23'),(13500,10759,'N','01','021','EC','A',NULL,NULL,'','0001060908','0000976721','','IL','1','Gonzalez','Ricardo','A','','','34','630120400','59 E 1ST ST',0,'THE PLAINS','OH','45780','1213','CY','39009','1985-06-14','M','',':RET:2106-3','N','021','DEN','1781751','99734OH005000301','2014-01-01','2013-12-23 19:12:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:35'),(2631,2139,'Y','18','021','EC','A','','','AC','0000759679','0000759679','OH00001229023','IL','1','WASHINGTON','DARLENE','','','','34','284462353','5946 SUNRIDGE DR',0,'CINCINNATI','OH','45224','2738','CY','39061','1950-03-26','F','U',':RET:2054-5','N','021','DEN','233044','99734OH005000401','2014-01-01','2013-12-02 13:07:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:46:07'),(20683,16526,'Y','18','021','EC','A','','','AC','0001095488','0001095488','TX00002046616','IL','1','BLACKWELL','GREGORY','CHARLES','','','34','465156121','3312 JONES ST',0,'TEXARKANA','TX','75501','7238','CY','48037','1977-04-02','M','U',':RET:2054-5','N','021','DEN','3112765','33348TX002000101','2014-03-01','2014-01-29 20:31:53','0.00',NULL,NULL,'25.02','25.02','R-TX021','TX0','25.02',NULL,0,'2014-01-30 21:00:55'),(22179,17700,'Y','18','024','14','A','','','TE','0001160447','0001160447','','IL','1','Quaye','Isaac',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-02-16','M','',NULL,NULL,NULL,'','3211744','','2014-02-28','2014-02-08 15:36:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-08 19:30:10'),(22622,18064,'Y','18','021','EC','A','','','AC','0000798365','0000798365','TX00001918669','IL','1','nguyen','viet','','','','34','733100278','4101 s custer rd',0,'mckinney','TX','75070',NULL,'CY','48085','1989-07-31','M','U',':RET:2047-9','N','021','DEN','3780164','33348TX002000201','2014-03-01','2014-02-10 20:25:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:11'),(22794,18197,'Y','18','024','14','A','','','TE','0000347943','0000347943','','IL','1','WILSON','GERALD',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-07-04','M','',NULL,NULL,NULL,'','2083155','','2014-02-11','2014-02-11 12:41:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:01:50'),(22995,18333,'Y','18','021','EC','A','','','AC','0000873277','0000873277','OH00002142925','IL','1','Hartgrove','Tenesha','','','','34','290784387','5557 CHOWNING WAY',0,'COLUMBUS','OH','43213','1478','CY','39049','1979-08-26','F','U',':RET:2054-5','N','021','DEN','3086501','99734OH005000301','2014-03-01','2014-02-12 10:31:49','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:30:15'),(23031,18362,'Y','18','021','EC','A','','','AC','0000538663','0000538663','TX00002547778','IL','1','TAPIA','MIRIAM','','','','34','645121435','10222 INWOOD SHADOWS ST',0,'HOUSTON','TX','77088','2227','CY','48201','1960-10-11','F','M',NULL,'N','021','DEN','2930060','33348TX002000201','2014-03-01','2014-02-12 11:49:26','0.00',NULL,NULL,'47.55','47.55','R-TX010','TX0','15.85',NULL,0,'2014-02-12 21:30:34'),(23876,18997,'N','19','021','EC','A',NULL,NULL,'','0001066019','0000893188','','IL','1','Simmons','Michael',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1989-03-13','M','',NULL,'N','021','HLT','3387705','52664OH151001501','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2014-02-14 21:32:12'),(27682,21893,'Y','18','021','EC','A','','','AC','0000038656','0000038656','TX00002678703','IL','1','GARCIA','CLARA','','','','34','455110497','4529 PRESCOTT ST',0,'CORPUS CHRISTI','TX','78416','1109','CY','48355','1955-07-03','F','U',NULL,'N','021','DEN','3585475','33348TX002000201','2014-04-01','2014-03-04 23:33:21','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-03-05 21:30:39'),(349,286,'Y','18','021','EC','A','','','AC','0000674031','0000674031','OH00001030731','IL','1','Wiessinger','Lori','','','','34','298668165','723 6TH AVE',0,'SIDNEY','OH','45365','1062','CY','39149','1970-11-02','F','U',':RET:2106-3','N','021','DEN','639166','99734OH005000301','2014-01-01','2013-11-09 00:48:29','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:32:12'),(17440,13952,'Y','18','021','EC','A','','','AC','0000201940','0000201940','OH00001394222','IL','1','bowers','justin','','','','34','273927860','24370 st rt 199',0,'perrysburg','OH','43551',NULL,'CY','39173','1990-03-19','M','U',':RET:2106-3','T','021','HLT','2082878','92036OH004002601','2014-02-01','2014-01-10 16:17:06','0.00',NULL,NULL,'180.31','180.31','R-OH001','OH0','180.31',NULL,0,'2014-01-13 03:00:36'),(1608,1344,'Y','18','021','EC','A','','','AC','0000026101','0000026101','TX00001494103','IL','1','CAMACHO','LESLIE','','','','34','461353065','4507 JOHN STOCKBAUER DR',0,'VICTORIA','TX','77904','1941','CY','48469','1974-08-08','F','M',':RET:2106-3','N','021','DEN','2261515','33348TX002000201','2014-01-01','2013-12-24 13:07:14','0.00',NULL,NULL,'29.22','29.22','R-TX023','TX0','14.61',NULL,0,'2013-12-25 18:52:12'),(15632,12503,'Y','18','021','EC','A','','','AC','0002278612','0002278612','LA00000152182','IL','1','Kashan','Kazeem','','','','34','437355612','7765 GREENWELL ST',0,'BATON ROUGE','LA','70812','2620','CY','22033','1955-10-30','M','U',NULL,'N','021','DEN','2259578','18575LA002000101','2014-02-01','2013-12-31 13:05:09','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-02 04:33:30'),(15033,12016,'Y','18','021','EC','A','','','AC','0001190747','0001190747','LA00000989127','IL','1','smith','brandon','','','','34','439653756','411 austin oaks circle',0,'west monroe','LA','71292',NULL,'CY','22073','1981-03-08','M','R',':RET:2106-3','N','021','DEN','1846652','18575LA002000201','2014-02-01','2013-12-30 11:38:13','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:02:42'),(5737,4554,'Y','18','021','EC','A','','','AC','0001853922','0001853922','LA00000153411','IL','1','tran','hoa','','','','34','532236818','1121 LOUISIANA AVE',0,'MINDEN','LA','71055','2325','CY','22119','1970-07-26','M','M',':RET:2029-7^:RET:2047-9','N','021','DEN','1814485','18575LA002000201','2014-01-01','2013-12-23 23:23:00','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 23:45:51'),(22747,18161,'Y','18','021','EC','A','','','AC','0000034419','0000034419','OH00002470704','IL','1','Kummer','Stanley','','','','34','403649879','6710 LINDER LN',0,'CINCINNATI','OH','45244','3507','CY','39061','1954-08-17','M','M',':RET:2106-3','N','021','HLT','3219939','92036OH006001201','2014-03-01','2014-02-11 16:37:33','600.00',NULL,NULL,'905.20','305.20','R-OH004','OH0','443.16',NULL,0,'2014-02-11 21:01:23'),(24852,19702,'N','01','021','EC','A',NULL,NULL,'','0000214713','0000392413','','IL','1','Weber','Diane','','','','34','293423090','9470 BENCHMARK LN',0,'BLUE ASH','OH','45242','6004','CY','39061','1953-01-13','F','',':RET:2106-3','N','021','HLT','2699454','92036OH005001201','2014-04-01','2014-02-19 14:28:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2014-02-20 04:55:33'),(27324,21635,'N','01','021','EC','A',NULL,NULL,'','0000992711','0000896544','','IL','1','Dominguez','Miriam','T','','','34','298453384','365 La Puesta apt 382',0,'El Paso','TX','79932',NULL,'CY','48141','1988-07-25','F','',':RET:2106-3','N','021','DEN','3961936','33348TX002000201','2014-04-01','2014-03-04 16:34:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:48'),(8074,6394,'N','01','021','EC','A',NULL,NULL,'','0000809668','0000039805','','IL','1','STUDER','TERESA','SUE','','','34','290663002','537 TOUVELLE ST',0,'CELINA','OH','45822','1072','CY','39107','1961-11-01','F','',':RET:2106-3','T','021','HLT','2102273','92036OH004001501','2014-01-01','2013-12-20 15:06:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','397.25',NULL,0,'2013-12-26 03:10:18'),(17100,13686,'Y','18','021','EC','A','','','AC','0001199228','0001199228','TX00002233931','IL','1','Pearson','Patricia','','','','34','455453944','919 TUBBS ST',0,'TYLER','TX','75701','1258','CY','48423','1963-09-25','F','M',':RET:2054-5','N','021','DEN','2211393','33348TX002000201','2014-02-01','2014-01-08 16:43:19','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-01-13 02:21:32'),(1237,1019,'N','19','021','EC','A',NULL,NULL,'','0000805935','0000160700','','IL','1','Allen','Mark','Wayne','','Jr','34','436877392','32455 Leona Ave',0,'White Castle','LA','70788',NULL,'CY','22047','1993-08-25','M','',':RET:2054-5','N','021','DEN','532233','18575LA002000101','2014-01-01','2013-12-03 16:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2013-12-25 18:20:52'),(16164,12941,'N','19','021','EC','A',NULL,NULL,'','0000772993','0000608634','','IL','1','Barron','Jeremy','','','','34','634182928','2119 Quite Falls Lane',0,'League City','TX','77573',NULL,'CY','48167','1990-07-03','M','',NULL,'N','021','DEN','1901738','33348TX002000201','2014-01-01','2013-12-16 22:28:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-04 06:00:15'),(1896,1551,'Y','18','021','EC','A','','','AC','0000815340','0000815340','OH00000178992','IL','1','Kummerer','Brenda','','','','34','301501299','308 7TH AVE',0,'TIFFIN','OH','44883','1013','CY','39147','1951-10-06','F','U',NULL,'N','021','HLT','2280419','92036OH004002701','2014-01-01','2013-12-24 14:56:43','447.17',NULL,NULL,'450.46','3.29','R-OH006','OH0','450.46',NULL,0,'2013-12-25 18:59:00'),(1535,1278,'Y','18','021','EC','A','','','AC','0000587980','0000587980','OH00000156038','IL','1','HARPER','MARY','','','','34','301721292','388 W MAIN ST',0,'LEESBURG','OH','45135','9301','CY','39071','1962-09-15','F','U',NULL,'N','021','DEN','2487178','99734OH005000401','2014-01-01','2013-12-24 16:23:23','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:50:07'),(3465,2783,'Y','18','021','EC','A','','','AC','0000694189','0000694189','OH00000309971','IL','1','Mays','Elizabeth','','','','34','294709294','2081 LYNBRIDGE DR',0,'REYNOLDSBURG','OH','43068','3598','CY','39049','1967-07-08','F','U',':RET:2054-5','N','021','DEN','1556355','99734OH005000401','2014-01-01','2013-12-22 06:48:10','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:19:47'),(24988,19819,'Y','18','021','EC','A','','','AC','0000320645','0000320645','TX00002195602','IL','1','Abu-ashour','Nedal','','','','34','643623260','3634 WINGATE PARK',0,'HOUSTON','TX','77082','9001','CY','48201','1970-10-26','M','M',':RET:2028-9','N','021','DEN','3404827','33348TX002000201','2014-04-01','2014-02-20 13:58:58','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:38'),(1781,1466,'Y','18','021','EC','A','','','AC','0000102819','0000102819','OH00001111467','IL','1','Novak','Elena','','','','34','294947464','2970 ROYALWOOD DR',0,'DUBLIN','OH','43017','1904','CY','39049','1955-04-04','F','U',':RET:2106-3','N','021','DEN','2258025','99734OH005000301','2014-01-01','2013-12-24 15:12:21','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:56:20'),(18132,14479,'Y','18','021','EC','A','','','AC','0000383378','0000383378','OH00001687500','IL','1','Bowman','Dana','','','','34','292585362','4161 AUGSPURGER RD',0,'HAMILTON','OH','45011','9536','CY','39017','1954-12-18','F','M',':RET:2106-3','N','021','HLT','2392342','92036OH004001201','2014-02-01','2014-01-14 16:34:34','136.00',NULL,NULL,'449.32','313.32','R-OH004','OH0','449.32',NULL,0,'2014-01-15 02:07:43'),(9458,7502,'N','01','021','EC','A',NULL,NULL,'','0001203213','0000533294','','IL','1','Simpson','Dan','','','','34','282662146','120 North Mechanic Street',0,'Lebanon','OH','45036',NULL,'CY','39165','1974-07-20','M','',':RET:2106-3','N','021','DEN','1499818','99734OH005000401','2014-01-01','2013-12-20 23:27:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:09'),(14823,11838,'N','01','021','EC','A',NULL,NULL,'','0000860687','0000550632','','IL','1','Borromeo','Ma Stella','Tonggao','','','34','631161431','15707 Pinyon Creek Dr',0,'Houston','TX','77095',NULL,'CY','48201','1969-12-18','F','',':RET:2036-2','N','021','DEN','2013174','33348TX002000101','2014-01-01','2013-12-23 20:51:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,1,'2013-12-29 11:14:21'),(17530,14016,'Y','18','021','EC','A','','','AC','0000533798','0000533798','MS00002292343','IL','1','Hardin','Stephanie','','','','34','587172865','12711 ROAD 339',0,'UNION','MS','39365','6810','CY','28099','1969-03-15','F','U',':RET:2106-3','N','021','DEN','2007484','46300MS002000201','2014-02-01','2014-01-11 22:44:11','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-13 03:01:42'),(24532,19487,'Y','18','021','EC','A','','','AC','0001953632','0001953632','LA00002772938','IL','1','HUDSON','MICHAEL','','','','34','434846173','18429 BARNEY LN',0,'FRANKLINTON','LA','70438','5948','CY','22117','1960-05-28','M','U',':RET:2106-3','N','021','DEN','2973385','18575LA002000101','2014-04-01','2014-02-18 18:02:53','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-20 04:00:30'),(28346,22428,'N','01','021','EC','A',NULL,NULL,'','0000929401','0001027156','','IL','1','RAMOS','MARIA','B','','','34','467959042','2300 SOUTH TERRELL ST',0,'MIDLAND','TX','79701',NULL,'CY','48329','1960-08-27','F','',NULL,'N','021','DEN','3703484','33348TX002000201','2014-04-01','2014-03-07 11:44:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-07 21:30:20'),(1899,1553,'Y','18','021','EC','A','','','AC','0000626738','0000626738','OH00001593266','IL','1','Barnett','Rocky','','','','34','227025101','9211 OUTLOOK DR',0,'BROOKLYN','OH','44144','2453','CY','39035','1961-09-15','M','R',':RET:2106-3','N','021','HLT','1813521','92036OH005000801','2014-01-01','2013-12-24 13:00:04','0.00',NULL,NULL,'456.37','456.37','R-OH011','OH0','456.37',NULL,0,'2013-12-25 18:59:04'),(16790,13431,'Y','18','021','EC','A','','','AC','0000108170','0000108170','OH00001415677','IL','1','Reedy','Kimberly','','','','34','280605119','1670 W ST RT 122',0,'Lebanon','OH','45036',NULL,'CY','39165','1960-08-21','F','R',':RET:2106-3','N','021','DEN','2386861','99734OH005000301','2014-02-01','2014-01-11 09:26:43','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:18:05'),(2132,1750,'Y','18','021','EC','A','','','AC','0000547859','0000547859','OH00000813860','IL','1','Beeson','Susan','','','','34','279827832','641 BRAE BURN RD',0,'MANSFIELD','OH','44907','1915','CY','39139','1974-08-28','F','U',NULL,'N','021','DEN','1002709','99734OH005000401','2014-01-01','2013-12-10 16:38:29','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 19:17:59'),(3173,2551,'Y','18','021','EC','A','','','AC','0000364848','0000364848','OH00000940693','IL','1','Parker','Sharon','','','','34','274487686','32263 PETTIBONE RD',0,'SOLON','OH','44139','5448','CY','39035','1953-12-20','F','U',':RET:2106-3','T','021','HLT','470273','52664OH151001301','2014-01-01','2013-11-18 14:46:35','0.00',NULL,NULL,'785.02','785.02','R-OH011','OH0','785.02',NULL,0,'2013-12-25 20:31:36'),(14739,11768,'Y','18','024','14','A','','','TE','0002332204','0002332204','','IL','1','Negrotto','Brad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-31','M','',NULL,NULL,NULL,'','1798444','','2013-12-28','2013-12-28 16:52:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2013-12-29 11:09:59'),(14500,11568,'Y','18','021','EC','A','','','AC','0001157276','0001157276','TX00001301830','IL','1','la','lai','','','','34','641900940','201 SW 3RD ST',0,'DIMMITT','TX','79027','2519','CY','48069','1981-09-10','F','M',':RET:2047-9','N','021','DEN','1380956','33348TX002000201','2014-02-01','2013-12-27 14:19:50','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:46'),(17969,14358,'N','01','021','EC','A',NULL,NULL,'','0000655842','0000793484','','IL','1','hasrouni','georgette','','','','34','301961743','5151 DENTON CIR',0,'BRUNSWICK','OH','44212','6455','CY','39103','1975-06-16','F','',':RET:2106-3','N','021','HLT','2639649','52664OH151001306','2014-02-01','2014-01-13 20:03:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2014-01-15 02:06:49'),(18315,14623,'Y','18','021','EC','A','','','AC','0001199526','0001199526','OH00001411941','IL','1','Greathouse','Lynn','','','','34','280685002','1304 SEVILLA AVE',0,'AKRON','OH','44314','1421','CY','39153','1961-08-26','F','M',':RET:2054-5','N','021','DEN','1730789','99734OH005000401','2014-02-01','2014-01-15 14:04:13','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:04'),(24697,19606,'Y','18','021','EC','A','','','AC','0000024826','0000024826','TX00001552501','IL','1','Gilson','Cimarron','','','','34','452539182','3777 FM 1518',0,'Selma','TX','78154',NULL,'CY','48187','1980-08-28','M','U',':RET:2106-3','N','021','DEN','3194029','33348TX002000101','2014-04-01','2014-02-19 17:35:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-20 04:33:33'),(27599,21828,'Y','18','021','EC','A','','','AC','0000338853','0000338853','OH00002620315','IL','1','McKinney','Deborah','','','','34','291428895','5447 SOUTHGATE BLVD',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','1952-03-12','F','U',':RET:2106-3','N','021','DEN','3677568','99734OH005000401','2014-04-01','2014-03-05 15:40:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-03-05 21:00:21'),(29108,23041,'Y','18','021','EC','A','','','AC','0002137009','0002137009','LA00002818256','31','1','WILLIAMS','LISA','A','','','34','435157638','PO BOX 857',0,'BALDWIN','LA','70514',NULL,'CY','22101','1966-03-08','F','U',':RET:2054-5','N','021','DEN','3693907','18575LA002000101','2014-04-01','2014-03-10 11:28:51','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-10 21:02:22'),(29154,23078,'N','01','021','EC','A',NULL,NULL,'','0000937344','0000111967','','IL','1','Fink','Lisa','','','','34','269842427','393 JARONTE DR',0,'BOARDMAN','OH','44512','4429','CY','39099','1967-05-24','F','',NULL,'N','021','HLT','4361192','92036OH005003204','2014-04-01','2014-03-10 12:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.07',NULL,0,'2014-03-10 21:02:50'),(1770,1460,'N','19','021','EC','A',NULL,NULL,'','0001192675','0000377462','','S1','1','Jellison','Penny','','','','34','273042758','150 Filly Lane',0,'Northfield','OH','44067',NULL,'CY','39153','1998-05-11','M','',':RET:2106-3','N','021','DEN','1856328','99734OH005000301','2014-01-01','2013-12-24 14:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:07'),(23802,18939,'N','01','021','EC','A',NULL,NULL,'','0001192716','0001147381','','IL','1','Craddock','Debra','','','','34','291444617','6979 EGYPT RD',0,'MEDINA','OH','44256','8595','CY','39103','1960-06-02','F','',':RET:2106-3','N','021','HLT','3356420','52664OH151001304','2014-03-01','2014-02-14 15:54:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.94',NULL,0,'2014-02-14 21:31:30'),(23367,18619,'Y','18','021','EC','A','','','AC','0000027934','0000027934','OH00001771494','IL','1','KENNA','DAN','','','','34','270681811','120 MONTROSE WEST AVE',0,'COPLEY','OH','44321','1372','CY','39153','1960-02-03','M','U',':RET:2106-3','N','021','HLT','3145577','52664OH151001305','2014-03-01','2014-02-13 17:22:14','285.00',NULL,NULL,'476.12','191.12','R-OH012','OH0','476.12',NULL,0,'2014-02-13 22:00:49'),(23333,18597,'Y','18','021','EC','A','','','AC','0000501655','0000501655','OH00002254914','IL','1','mahovlich','walter','','','','34','283527632','2176 WEST BLVD',0,'CLEVELAND','OH','44102','3643','CY','39035','1952-06-16','M','U',':RET:2106-3','N','021','DEN','3249496','99734OH005000301','2014-03-01','2014-02-13 16:15:49','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:32'),(4213,3352,'Y','18','021','EC','A','','','AC','0001040265','0001040265','TX00000583663','IL','1','VERETTE','MARCIA','','','','34','461788198','405 E GRANITE ST',0,'LLANO','TX','78643','3057','CY','48299','1953-05-14','F','U',':RET:2106-3','N','021','DEN','2434314','33348TX002000201','2014-01-01','2013-12-17 08:06:56','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:14'),(6285,4984,'Y','18','021','EC','A','','','AC','0000210984','0000210984','OH00000925869','IL','1','Grossman','Jerry','','','','34','271905762','2036 WHISPERING WILLOW LN',0,'AMELIA','OH','45102','2296','CY','39025','1982-09-24','M','U',':RET:2106-3','N','021','DEN','667655','99734OH005000401','2014-01-01','2013-12-10 20:38:41','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:45:28'),(6949,5519,'Y','18','021','EC','A','','','AC','0001173229','0001173229','OH00001257256','IL','1','BONEWELL','CATHY','','','','34','570963906','1001 HUFFMAN CT',0,'CINCINNATI','OH','45231','3728','CY','39061','1956-10-21','F','U',':RET:2106-3','N','021','DEN','2167179','99734OH005000401','2014-01-01','2013-12-24 21:01:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:59'),(20856,16671,'Y','18','024','14','A','','','TE','0000234068','0000234068','','IL','1','Damon','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-10-18','M','',NULL,NULL,NULL,'','1469552','','2014-01-31','2014-01-31 14:20:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:00:55'),(14423,11502,'N','01','021','EC','A',NULL,NULL,'','0000184728','0001167841','','IL','1','Jackson','Kristina','','','','34','627185198','1410 MARTINSVILLE ST',0,'NACOGDOCHES','TX','75961','4955','CY','48347','1990-08-07','F','',':RET:2106-3','N','021','DEN','1438456','33348TX002000101','2014-02-01','2013-12-27 13:29:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-28 03:31:44'),(14995,11985,'Y','18','021','EC','A','','','AC','0000964649','0000964649','TX00001109230','IL','1','Jolley','Joe','','','','34','457271951','418 CR 2010',0,'Center','TX','75935',NULL,'CY','48419','1959-12-22','M','M',':RET:2106-3','T','021','DEN','2320714','33348TX002000201','2014-02-01','2013-12-30 16:48:32','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:33'),(17392,13916,'Y','18','021','EC','A','','','AC','0000284425','0000284425','OH00001526282','IL','1','Wilson','Guyia','','','','34','287743643','317 MONROE ST',0,'SPRINGFIELD','OH','45505','1038','CY','39023','1979-04-25','F','U',':RET:2054-5','N','021','DEN','2357784','99734OH005000401','2014-02-01','2014-01-10 14:37:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 03:00:11'),(18871,15033,'Y','18','021','EC','A','','','AC','0002117308','0002117308','LA00002521707','IL','1','Farquhar','Cameron','Abbott','','','34','623343815','11959 Nicholson Drive',0,'Baton Rouge','LA','70810',NULL,'CY','22033','1989-08-02','M','U',':RET:2106-3','N','021','DEN','3041214','18575LA002000201','2014-03-01','2014-01-16 12:06:14','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:24'),(24863,19713,'Y','18','021','EC','A','','','AC','0000676444','0000676444','TX00002564954','IL','1','NEJTEK','LISA','','','','34','467538061','1438 COUNTY ROAD 438',0,'THORNDALE','TX','76577','2732','CY','48331','1969-07-31','F','U',':RET:2106-3','N','021','DEN','3064442','33348TX002000201','2014-04-01','2014-02-18 23:19:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-20 05:30:54'),(25003,19829,'N','01','021','EC','A',NULL,NULL,'','0001071837','0000670300','','IL','1','ESCRIBANO','CELESTE','','','','34','605996098','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1982-10-13','F','',NULL,'N','021','HLT','3111785','52664OH151001304','2014-04-01','2014-02-20 14:08:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.11',NULL,0,'2014-02-20 22:00:48'),(25143,19946,'Y','18','021','EC','A','','','AC','0000805939','0000805939','TX00003066331','IL','1','thomas','ericka','','','','34','455219540','3210 VILLAGE POND LN',0,'FRESNO','TX','77545','8780','CY','48157','1972-10-04','F','U',':RET:2054-5','N','021','DEN','3615831','33348TX002000201','2014-04-01','2014-02-21 12:07:01','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-21 22:00:12'),(2216,1825,'Y','18','021','EC','A','','','AC','0000818550','0000818550','OH00000758016','IL','1','Baker','Tamara','Lynn','','','34','300662132','480 Starling Court',0,'Wadsworth','OH','44281',NULL,'CY','39103','1966-05-27','F','U',':RET:2106-3','N','021','HLT','774571','52664OH151001305','2014-01-01','2013-12-10 16:53:54','191.00',NULL,NULL,'348.56','157.56','R-OH012','OH0','348.56',NULL,0,'2013-12-25 19:20:24'),(3067,2465,'Y','18','021','EC','A','','','AC','0000750984','0000750984','OH00001208863','31','1','Curry','Mary','','','','34','220604697','PO Box 25',0,'New London','OH','44851',NULL,'CY','39077','1951-10-22','F','M',':RET:2106-3','N','021','HLT','1168438','92036OH004002701','2014-01-01','2013-12-06 11:00:22','0.00',NULL,NULL,'450.46','450.46','R-OH006','OH0','450.46',NULL,0,'2013-12-25 20:19:22'),(8817,6989,'Y','18','021','EC','A','','','AC','0001004320','0001004320','OH00000796646','IL','1','Gerding','Robert','','','','34','270527282','3626 Appomatox Dr',0,'Amelia','OH','45102',NULL,'CY','39025','1951-10-13','M','M',':RET:2106-3','N','021','HLT','1404023','92036OH004000601','2014-01-01','2013-12-18 10:23:27','229.00',NULL,NULL,'495.91','266.91','R-OH005','OH0','495.91',NULL,0,'2013-12-26 04:00:08'),(23027,18359,'Y','18','021','EC','A','','','AC','0000805891','0000805891','TX00001390787','IL','1','hernandez','georgina','alejandra','','','34','640280701','3665 trina pl.',0,'el paso','TX','79936',NULL,'CY','48141','1969-02-05','F','M',NULL,'N','021','DEN','3661707','33348TX002000201','2014-03-01','2014-02-12 00:10:12','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-12 21:30:33'),(3920,3138,'Y','18','021','EC','A','','','AC','0000341318','0000341318','OH00000778009','IL','1','Schulze','Karen','','','','34','291509356','118 S MAIN ST',0,'MINSTER','OH','45865','1304','CY','39107','1949-11-30','F','U',':RET:2106-3','N','021','HLT','79242','92036OH005001505','2014-01-01','2013-12-13 10:00:11','312.00',NULL,NULL,'660.24','348.24','R-OH002','OH0','660.24',NULL,0,'2013-12-25 21:37:21'),(22406,17890,'Y','18','021','EC','A','','','AC','0001786566','0001786566','LA00001765544','IL','1','White','Graham','','','','34','212213681','3029 St Claude',0,'New Orleans','LA','70117',NULL,'CY','22071','1984-06-30','M','U',':RET:2106-3','N','021','DEN','2781438','18575LA002000201','2014-03-01','2014-02-09 20:28:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:22'),(21356,17068,'N','01','021','EC','A',NULL,NULL,'','0000499775','0000689720','','IL','1','Harris','Thomas','Russell','','','34','450271947','1817 S 17TH ST',0,'TEMPLE','TX','76504','3202','CY','48027','1966-10-21','M','',':RET:2106-3','N','021','DEN','3354776','33348TX002000201','2014-03-01','2014-02-04 13:48:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-04 21:00:40'),(6549,5192,'N','19','021','EC','A',NULL,NULL,'','0000776704','0000494332','','IL','1','LAHAYE','KATHERINE','PAIGE','','','34','632586427','16139 OLD STABLE RD',0,'SAN ANTONIO','TX','78247','4490','CY','48029','1992-08-23','F','',':RET:2106-3','N','021','DEN','115325','33348TX002000201','2014-01-01','2013-12-11 11:38:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:52:08'),(19387,15455,'Y','18','021','EC','A','','','AC','0000598781','0000598781','OH00001390367','IL','1','Saul','Evan','Thomas','','','34','593491289','4361 Long Lake Drive',0,'Batavia','OH','45103',NULL,'CY','39025','1995-02-14','M','R',':RET:2106-3','N','021','DEN','2683018','99734OH005000401','2014-03-01','2014-01-21 09:56:02','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','15.78',NULL,1,'2014-01-22 03:22:45'),(16276,13031,'Y','18','021','EC','A','','','AC','0000644683','0000644683','OH00002173675','IL','1','HILL','WILLIAM','','','','34','294666917','524 CHERRY HILL LN',0,'LEBANON','OH','45036',NULL,'CY','39165','1974-04-19','M','M',':RET:2106-3','N','021','DEN','2601997','99734OH005000401','2014-02-01','2014-01-06 13:46:12','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:24'),(5678,4505,'Y','18','021','EC','A','','','AC','0000834436','0000834436','OH00001055801','IL','1','McGarvey','Steve','','','','34','298884011','635 ROMBACH AVE',0,'WILMINGTON','OH','45177','2486','CY','39027','1982-06-23','M','U',':RET:2106-3','T','021','HLT','762262','92036OH004000601','2014-01-01','2013-11-25 22:08:54','0.00',NULL,NULL,'230.07','230.07','R-OH005','OH0','230.07',NULL,0,'2013-12-25 23:32:14'),(9757,7727,'Y','18','021','EC','A','','','AC','0000459116','0000459116','OH00000540939','IL','1','Buck','Brandon','','','','34','292865198','3800 Neville Dr',0,'Kent','OH','44240',NULL,'CY','39133','1983-08-02','M','U',':RET:2080-0','T','021','DEN','520783','99734OH005000401','2014-01-01','2013-10-19 22:10:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 05:00:07'),(25927,20561,'Y','18','021','EC','A','','','AC','0000318486','0000318486','TX00002951790','IL','1','TREVIZO','OMAR','','','','34','520966924','4522 W LOOP 281',0,'LONGVIEW','TX','75604','5873','CY','48183','1963-11-10','M','M',NULL,'N','021','DEN','3796193','33348TX002000201','2014-03-01','2014-02-26 16:11:53','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2014-02-26 21:01:24'),(27545,21788,'Y','18','024','14','A','','','TE','0000277258','0000277258','','IL','1','PARK','INAE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-02-04','F','',NULL,NULL,NULL,'','47456','','2014-03-31','2014-03-04 12:17:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:08'),(27820,22002,'N','01','021','EC','A',NULL,NULL,'','0000878331','0000874762','','IL','1','Clark','Josh',NULL,NULL,NULL,NULL,NULL,'643 BLAIN LN',0,'GREENFIELD','OH','45123','9660','CY','39141','1981-04-06','M','',':RET:2106-3','N','021','DEN','3888152','99734OH005000301','2014-04-01','2014-03-04 19:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:31:55'),(21390,17092,'N','01','021','EC','A',NULL,NULL,'','0000552661','0000766009','','IL','1','Mason','Angela','','','','34','291785797','3800 MILNER RD',0,'NEWARK','OH','43055','9304','CY','39089','1982-05-31','F','',':RET:2106-3','N','021','DEN','3762814','99734OH005000401','2014-03-01','2014-02-04 09:27:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:56'),(2813,2274,'Y','18','021','EC','A','','','AC','0000788388','0000788388','TX00000168586','IL','1','Sumantri','Kris','','','','34','633803624','215 N Center',0,'san antonio','TX','78202',NULL,'CY','48029','1973-12-22','M','U',NULL,'N','021','DEN','250329','33348TX002000201','2014-01-01','2013-11-23 18:49:07','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 20:00:18'),(23030,18361,'Y','18','021','EC','A','','','AC','0000762457','0000762457','TX00002589704','IL','1','MEDELLIN JIMENEZ','GLORIA','','','','34','523275095','25210 CANARY POINT DR',0,'RICHMOND','TX','77406','7267','CY','48157','1953-12-01','F','U',NULL,'N','021','DEN','2964238','33348TX002000201','2014-03-01','2014-02-12 11:37:17','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-12 21:30:34'),(7881,6235,'Y','18','021','EC','A','','','AC','0001174396','0001174396','OH00001090324','IL','1','Thornton','Christine','','','','34','299825891','8317 WAINSTEAD DR',0,'PARMA','OH','44129','4846','CY','39035','1985-01-27','F','M',':RET:2106-3','N','021','DEN','2601350','99734OH005000301','2014-01-01','2013-12-20 17:55:20','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:05:26'),(2858,2309,'Y','18','021','EC','A','','','AC','0000242668','0000242668','OH00000693167','IL','1','Daffeh','Sankung','','','','34','010331954','5697 Forest Ash Lane',0,'Columbus','OH','43229',NULL,'CY','39049','1971-12-25','M','M',':RET:2054-5','N','021','DEN','1250139','99734OH005000401','2014-01-01','2013-11-01 19:53:44','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:01:33'),(16460,13171,'N','19','021','EC','A',NULL,NULL,'','0000816438','0001209602','','IL','1','CAMPOLONGO','DANIELLE','','','','34','301068777','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','2002-07-14','F','',NULL,'N','021','HLT','2257217','92036OH004000601','2014-02-01','2014-01-06 10:24:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-07 04:05:42'),(3315,2662,'N','19','021','EC','A',NULL,NULL,'','0000769988','0001106785','','IL','1','Riesenberg','Meg','','','','34','268969624','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1992-08-08','F','',':RET:2106-3','N','021','DEN','1482483','99734OH005000301','2014-01-01','2013-12-22 14:18:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:56'),(3539,2841,'Y','18','021','EC','A','','','AC','0001232978','0001232978','TX00000610776','IL','1','Lowe','Phillip','','','','34','306646256','11935 PAINTED CANYON DR',0,'TOMBALL','TX','77377','7613','CY','48201','1955-07-02','M','M',':RET:2106-3','N','021','DEN','2183253','33348TX002000101','2014-01-01','2013-12-22 15:01:19','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 21:21:43'),(2881,2328,'Y','18','021','EC','A','','','AC','0000004781','0000004781','TX00000246521','IL','1','Bibbs','John','','','','34','645073270','855 E. Ash Lane',0,'Euless','TX','76039',NULL,'CY','48439','1984-06-26','M','U',NULL,'N','021','DEN','617942','33348TX002000201','2014-01-01','2013-10-08 11:51:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:02:13'),(4614,3654,'Y','18','021','EC','A','','','AC','0000171215','0000171215','OH00000846560','IL','1','Gradomski','Deborah','','','','34','263131323','5411 N River Rd W9',0,'Geneva','OH','44041',NULL,'CY','39007','1953-09-22','F','M',':RET:2106-3','N','021','HLT','507618','52664OH151001501','2014-01-01','2013-12-12 14:55:59','0.00',NULL,NULL,'818.71','818.71','R-OH011','OH0','818.71',NULL,0,'2013-12-25 22:06:04'),(4032,3220,'Y','18','021','EC','A','','','AC','0000678076','0000678076','OH00001014056','IL','1','Sun','Tianling','','','','34','014922871','3763 Catalina Drive',0,'Beavercreek','OH','45431',NULL,'CY','39057','1971-01-04','F','M',':RET:2034-7','N','021','DEN','1586327','99734OH005000401','2014-01-01','2013-12-17 10:00:26','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:45:56'),(25865,20506,'N','01','021','EC','A',NULL,NULL,'','0002175158','0002017722','','IL','1','TEMPLET','CATHERINE','','','','34','436968798','13330 GB TEMPLET RD',0,'GONZALEZ','LA','70737',NULL,'CY','22005','1952-07-05','F','',NULL,'N','021','DEN','3856071','18575LA002000201','2014-04-01','2014-02-26 14:18:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-26 21:00:47'),(25966,20592,'Y','18','021','EC','A','','','AC','0000055982','0000055982','OH00002761346','IL','1','ENGLE','ANNE','','','','34','280669516','18 FAIRGREEN CIRCLE',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','1958-07-21','F','U',':RET:2106-3','T','021','DEN','3479756','99734OH005000401','2014-03-01','2014-02-26 12:40:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:01:43'),(2428,1978,'Y','18','021','EC','A','','','AC','0000885570','0000885570','OH00000058568','31','1','MCCAFFERTY','CHERYL','','','','34','271607870','PO BOX 55',0,'PLEASANTVILLE','OH','43148',NULL,'CY','39045','1966-10-15','F','M',':RET:2106-3','N','021','DEN','456848','99734OH005000401','2014-01-01','2013-12-09 17:28:08','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:34:05'),(24079,19148,'N','19','021','EC','A',NULL,NULL,'','0000652179','0001131493','','IL','1','Mahlendorf','Mariah','','','','34','256851499','6351 Grove Road',0,'Clinton','OH','44216',NULL,'CY','39153','1991-12-15','F','',':RET:2106-3','N','021','HLT','2927654','52664OH151001304','2014-03-01','2014-02-15 12:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-02-15 22:01:21'),(17710,14153,'Y','18','021','EC','A','','','AC','0001705668','0001705668','LA00001372742','IL','1','Friedley','Charlotte','','','','34','260922523','18426 JEFFERSON HWY',0,'BATON ROUGE','LA','70817','7450','CY','22033','1952-09-29','F','U',':RET:2106-3','N','021','DEN','1824354','18575LA002000201','2014-02-01','2014-01-13 16:42:39','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:09'),(8969,7115,'Y','18','021','EC','A','','','AC','0000785777','0000785777','OH00000008751','IL','1','POTTER','NANCY','B','','','34','229867538','1589 ROAMONT DR',0,'CENTERVILLE','OH','45459','3361','CY','39113','1954-06-22','F','U',':RET:2106-3','N','021','DEN','2044252','99734OH005000401','2014-01-01','2013-12-18 14:55:20','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:04:03'),(2914,2348,'Y','18','021','EC','A','','','AC','0000062512','0000062512','OH00001205029','IL','1','ALFRED','KAREN','','','','34','286481262','2920 S BAY DR',0,'WESTLAKE','OH','44145','6003','CY','39035','1951-03-28','F','U',NULL,'N','021','DEN','39768','99734OH005000401','2014-01-01','2013-12-06 11:31:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:15:36'),(17035,13630,'Y','18','021','EC','A','','','AC','0001413922','0001413922','LA00000261790','IL','1','Sterling','Crystal','','','','34','434909583','104 PARISH LINE PARK',0,'PRINCETON','LA','71067','4830','CY','22119','1968-12-31','F','U',':RET:2106-3','N','021','DEN','1923088','18575LA002000101','2014-02-01','2014-01-08 19:53:36','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-13 02:20:47'),(22987,18327,'Y','18','021','EC','A','','','AC','0000843378','0000843378','OH00002576411','IL','1','Rohr','Justina','','','','34','283862691','2108 Ben Fulton Rd',0,'North Lawrence','OH','44666',NULL,'CY','39151','1982-02-14','F','M',NULL,'N','021','DEN','3370430','99734OH005000301','2014-03-01','2014-02-12 09:24:58','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2014-02-12 21:30:12'),(4842,3836,'Y','18','021','EC','A','','','AC','0001070444','0001070444','OH00000060649','IL','1','Busse','Deborah','','','','34','287546692','8253 CARDNIA CT',0,'LIBERTY TOWNSHIP','OH','45044','1196','CY','39017','1954-09-19','F','U',':RET:2106-3','N','021','HLT','105150','92036OH006001201','2014-01-01','2013-11-07 19:51:20','384.00',NULL,NULL,'443.16','59.16','R-OH004','OH0','443.16',NULL,0,'2013-12-25 22:30:08'),(21924,17509,'N','01','021','EC','A',NULL,NULL,'','0001199332','0000983803','','IL','1','RIVERA','CLAUDIA','','','','34','630276080','19723 MOUNTAIN DALE DR',0,'CYPRESS','TX','77433','1096','CY','48201','1989-05-15','F','',NULL,'N','021','DEN','2839028','33348TX002000201','2014-03-01','2014-02-06 20:00:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-07 19:00:07'),(6501,5151,'Y','18','024','14','A','','','TE','0000830606','0000830606','','IL','1','PRESTAS','TERRY','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-22','F','',NULL,NULL,NULL,'','1110496','','2013-12-11','2013-12-11 16:06:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:50:51'),(6799,5393,'Y','18','021','EC','A','','','AC','0000171204','0000171204','OH00001164260','IL','1','BRAUN','JANEEN','','','','34','290707675','4217 MUD PIKE RD',0,'CELINA','OH','45822','9743','CY','39107','1962-05-10','F','U',NULL,'N','021','HLT','398817','92036OH005001501','2014-01-01','2013-11-24 22:10:29','107.00',NULL,NULL,'410.47','303.47','R-OH002','OH0','410.47',NULL,0,'2013-12-26 01:17:20'),(13980,11139,'Y','18','021','EC','A','','','AC','0000484788','0000484788','OH00000503870','IL','1','Hawkins','Brenda','','','','34','404761566','3421 Amberway Court',0,'CINCINATTI','OH','45251',NULL,'CY','39061','1953-02-24','F','M',NULL,'N','021','HLT','2183325','92036OH004001201','2014-01-01','2013-12-23 13:15:44','920.00',NULL,NULL,'978.00','58.00','R-OH004','OH0','468.46',NULL,0,'2013-12-26 13:15:34'),(14244,11359,'Y','18','021','EC','A','','','AC','0000597056','0000597056','TX00001528171','IL','1','Graves','Waymon','','','','34','431900403','705 MARTINE ST',0,'TEXARKANA','TX','75501','3031','CY','48037','1950-04-07','M','M',NULL,'T','021','DEN','2310940','33348TX002000101','2014-02-01','2013-12-26 11:08:19','0.00',NULL,NULL,'25.02','25.02','R-TX021','TX0','25.02',NULL,0,'2013-12-27 02:05:21'),(19282,15369,'Y','18','021','EC','A','','','AC','0001128032','0001128032','OH00002014556','IL','1','kinman','troy','','','','34','310761469','220 sara st.',0,'urbana','OH','43078',NULL,'CY','39021','1974-06-15','M','U',':RET:2106-3','N','021','HLT','2612847','92036OH004000501','2014-03-01','2014-01-20 17:11:43','204.00',NULL,NULL,'241.21','37.21','R-OH003','OH0','241.21',NULL,0,'2014-01-21 08:47:00'),(14855,11861,'Y','18','021','EC','A','','','AC','0000479847','0000479847','OH00001107643','IL','1','Prince','Rhonda','','','','34','300706628','344 SILVER ST',0,'AKRON','OH','44303','2237','CY','39153','1965-06-16','F','M',':RET:2054-5','N','021','HLT','1422462','52664OH152000901','2014-01-01','2013-12-23 19:52:21','0.00',NULL,NULL,'512.07','512.07','R-OH012','OH0','267.06',NULL,1,'2013-12-29 11:15:12'),(15078,12052,'Y','18','021','EC','A','','','AC','0000872641','0000872641','TX00001771702','31','1','Burns','Penny','','','','34','464110747','PO Box 224',0,'Point','TX','75472',NULL,'CY','48379','1956-11-22','F','M',':RET:2106-3','N','021','DEN','2081272','33348TX002000101','2014-02-01','2013-12-29 20:06:17','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-01-01 12:04:05'),(16031,12834,'Y','18','021','EC','A','','','AC','0001823356','0001823356','LA00000436513','IL','1','Picou','Gail','','','','34','436965552','9128 WATERTOWER STREET',0,'CONVENT','LA','70723',NULL,'CY','22093','1955-12-08','F','U',':RET:2054-5','N','021','DEN','1374771','18575LA002000201','2014-02-01','2014-01-03 13:16:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:30'),(27143,21489,'Y','18','021','EC','A','','','AC','0000785861','0000785861','OH00002927907','IL','1','Price','Derris','','','','34','289767160','1618 s dixon circle',0,'cincinnati','OH','45224',NULL,'CY','39061','1980-10-18','M','U',':RET:2054-5','T','021','DEN','2816074','99734OH005000401','2014-04-01','2014-03-03 12:59:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:48'),(594,489,'Y','18','021','EC','A','','','AC','0000075224','0000075224','OH00000909490','IL','1','Deffenbaugh','Mitchell','','','','34','274783135','590 W MAIN ST',0,'WASHINGTONVILLE','OH','44490','9638','CY','39029','1981-08-17','M','U',':RET:2106-3','T','021','DEN','987529','99734OH005000401','2014-01-01','2013-12-15 19:09:09','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:00:08'),(1331,1102,'Y','18','021','EC','A','','','AC','0000545200','0000545200','OH00000362448','IL','1','Kirchner','Chad','','','','34','289804400','531 N WASHINGTON ST',0,'TIFFIN','OH','44883','1075','CY','39147','1983-07-19','M','U',':RET:2106-3','N','021','HLT','954224','92036OH002002701','2014-01-01','2013-10-24 18:27:55','0.00',NULL,NULL,'255.59','255.59','R-OH006','OH0','255.59',NULL,0,'2013-12-25 18:32:06'),(13173,10507,'Y','18','021','EC','A','','','AC','0001207160','0001207160','OH00001018928','IL','1','Westcott','Cathie','','','','34','270440238','1802 St Rte 113 E',0,'Milan','OH','44846',NULL,'CY','39043','1949-07-04','F','R',':RET:2106-3','N','021','DEN','2474147','99734OH005000401','2014-01-01','2013-12-23 18:52:56','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 12:54:06'),(24763,19646,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000507028','','IL','1','Dugan','Vincent','A','','III','34','300945929','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1992-07-07','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:42:58'),(23483,18705,'Y','18','021','EC','A','','','AC','0002295957','0002295957','LA00001945828','31','1','BREWER','STEPHANIE','','','','34','439714557','588 CHAPEL LAKE DR',0,'VIRGINIA BEACH','VA','23454','4144','CY','22031','1988-11-08','F','U',':RET:2054-5','N','021','DEN','2950109','18575LA002000101','2014-03-01','2014-02-13 11:35:01','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-13 22:01:56'),(16297,13048,'Y','18','021','EC','A','','','AC','0001746227','0001746227','LA00002258810','IL','1','Smith','Kim','','','','34','433021239','1205 STEEN LOOP',0,'JENA','LA','71342','6648','CY','22059','1957-03-30','F','M',':RET:2106-3','N','021','DEN','2571080','18575LA002000201','2014-02-01','2014-01-06 15:28:12','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-07 04:01:02'),(4773,3787,'Y','18','021','EC','A','','','AC','0001228040','0001228040','OH00000992073','IL','1','Trokan','Peter','','','','34','393948788','5375 SULTANA DR',0,'CINCINNATI','OH','45238','5225','CY','39061','1984-05-08','M','U',':RET:2106-3','T','021','DEN','333293','99734OH005000401','2014-01-01','2013-12-08 15:04:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:15:53'),(6709,5319,'Y','18','021','EC','A','','','AC','0000250165','0000250165','MS00000960424','IL','1','Watkins','Deirdre','','','','34','426490340','416 DEBBIE CIR',0,'PASS CHRISTIAN','MS','39571','4239','CY','28047','1969-11-15','F','U',':RET:2106-3','T','021','DEN','476447','46300MS002000101','2014-01-01','2013-11-05 13:56:24','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-26 01:02:10'),(6320,5010,'Y','18','024','14','A','','','TE','0001011523','0001011523','','IL','1','JONES','CECIL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-11-27','M','',NULL,NULL,NULL,'','1160723','','2013-12-11','2013-12-11 11:05:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:46:20'),(25335,20102,'Y','18','021','EC','A','','','AC','0001473935','0001473935','LA00002661978','IL','1','Jackson','Melanie','','','','34','434418661','2040 Expressway Dr. Apt.105',0,'Pineville','LA','71360',NULL,'CY','22079','1978-11-30','F','M',':RET:2054-5','N','021','DEN','2845622','18575LA002000201','2014-04-01','2014-02-25 14:54:12','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-25 21:30:21'),(27361,21667,'Y','18','021','EC','A','','','AC','0000095303','0000095303','OH00002648782','IL','1','Johnson','James','','','','34','286506600','3215 COLUMBIA RD',0,'WESTLAKE','OH','44145','5523','CY','39035','1951-08-03','M','U',NULL,'N','021','DEN','2620418','99734OH005000401','2014-04-01','2014-03-04 16:10:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:11'),(27800,21989,'Y','18','021','EC','A','','','AC','0001248388','0001248388','OH00002745488','IL','1','MERVINE','TRACY','','','','34','279629226','2332 BILLMAN PL',0,'CUYAHOGA FALLS','OH','44221','3020','CY','39153','1964-04-25','F','U',NULL,'T','021','HLT','3975437','52664OH151001306','2014-04-01','2014-03-04 21:54:29','320.00',NULL,NULL,'437.52','117.52','R-OH012','OH0','437.52',NULL,0,'2014-03-05 21:31:45'),(21557,17221,'Y','18','021','EC','A','','','AC','0000203121','0000203121','OH00002630230','IL','1','Heindl','Edward','','','','34','297680578','2244 ONTARIO AVE',0,'DAYTON','OH','45414','5634','CY','39113','1959-11-16','M','U',':RET:2106-3','N','021','DEN','3102706','99734OH005000401','2014-03-01','2014-02-05 16:07:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-05 21:30:16'),(20667,16515,'Y','18','021','EC','A','','','AC','0000221436','0000221436','MS00001794021','IL','1','Sutton','Valerie','','','','34','427373649','4645 Kirkley Drive',0,'Jackson','MS','39206',NULL,'CY','28049','1979-05-14','F','U',':RET:2054-5','N','021','DEN','3399854','46300MS002000201','2014-03-01','2014-01-30 02:15:51','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-30 21:00:47'),(13778,10997,'N','19','021','EC','A',NULL,NULL,'','0001076610','0000771440','','S1','1','Scallions','Diane','','','Jr',NULL,NULL,'1332 SUDDUTH RD',0,'STEENS','MS','39766','9665','CY','28087','2008-09-24','M','',':RET:2106-3','N','021','DEN','1614235','46300MS002000201','2014-01-01','2013-12-23 15:28:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2013-12-26 13:10:40'),(13036,10392,'Y','18','021','EC','A','','','AC','0000683385','0000683385','OH00001282006','IL','1','DANNER','KAREN','','','','34','302503109','8593 HEMPLE RD',0,'GERMANTOWN','OH','45327','9520','CY','39113','1950-08-12','F','M',':RET:2106-3','N','021','DEN','2567973','99734OH005000401','2014-01-01','2013-12-23 05:16:25','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:50:29'),(5460,4337,'Y','18','021','EC','A','','','AC','0000482179','0000482179','OH00000199028','IL','1','Hoskinson','Brandon','','','','34','289827404','4 HOMESTEAD ST',0,'SEVILLE','OH','44273','9522','CY','39103','1979-08-23','M','U',':RET:2106-3','N','021','HLT','1919457','52664OH151001501','2014-01-01','2013-12-19 17:11:15','60.00',NULL,NULL,'324.70','264.70','R-OH012','OH0','324.70',NULL,0,'2013-12-25 23:10:22'),(4228,3366,'Y','18','021','EC','A','','','AC','0001208303','0001208303','TX00001255332','IL','1','wisner','jacqueline','Nicole','','','34','459797566','908 MARBLE CREEK DR',0,'WYLIE','TX','75098','6981','CY','48085','1984-08-17','F','U',':RET:2054-5','N','021','DEN','2170064','33348TX002000201','2014-01-01','2013-12-17 12:50:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:50:37'),(7594,6008,'Y','18','021','EC','A','','','AC','0001068235','0001068235','OH00000969245','IL','1','Dunbar','Jacinta','N','','','34','233617176','6332 CURLWOOD CT',0,'HUBER HEIGHTS','OH','45424','3655','CY','39113','1978-03-24','F','M',NULL,'N','021','DEN','888742','99734OH005000401','2014-01-01','2013-11-17 09:23:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:45:12'),(26765,21212,'Y','18','021','EC','A','','','AC','0000590841','0000590841','OH00003433280','IL','1','martin','darrell','','','','34','298701206','6780 W RIVER RD S',0,'ELYRIA','OH','44035','7053','CY','39093','1968-08-24','M','U',':RET:2106-3','N','021','DEN','3261029','99734OH005000401','2014-03-01','2014-02-28 19:40:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-03-01 19:00:10'),(26937,21348,'Y','18','021','EC','A','','','AC','0000578836','0000578836','OH00002168371','IL','1','Morrison','Delta','','','','34','296766333','669 Bailey Rd.',0,'Peebles','OH','45660',NULL,'CY','39001','1975-05-17','F','U',':RET:2106-3','N','021','DEN','3217095','99734OH005000301','2014-04-01','2014-03-02 13:17:08','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-03-03 01:00:22'),(9,8,'Y','18','021','EC','A','','','AC','0000132043','0000132043','OH00000795079','IL','1','Beal','Bart','','','','34','274607659','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1960-04-08','M','M',':RET:2106-3','N','021','DEN','938477','99734OH005000401','2014-01-01','2013-12-04 23:45:54','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:15'),(21408,17110,'Y','18','024','14','A','','','TE','0000559476','0000559476','','IL','1','Fink','Joseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-11-03','M','',NULL,NULL,NULL,'','2745284','','2014-02-04','2014-02-04 15:11:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:06'),(24044,19122,'Y','18','021','EC','A','','','AC','0000546512','0000546512','OH00002589833','IL','1','Soutendijk','Diana','','','','34','295581081','3299 State Route 82',0,'Mantua','OH','44255',NULL,'CY','39133','1957-10-01','F','U',NULL,'N','021','DEN','2740561','99734OH005000301','2014-03-01','2014-02-15 10:51:09','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-15 22:01:00'),(5925,4692,'Y','18','021','EC','A','','','AC','0000069323','0000069323','TX00001499692','IL','1','Salas','Gloria','','','','34','464087538','715 E LANNY AVE',0,'BROWNFIELD','TX','79316','2719','CY','48445','1954-01-02','F','U',':RET:2106-3','N','021','DEN','2335120','33348TX002000101','2014-01-01','2013-12-24 01:06:56','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:50:23'),(4858,3849,'Y','18','021','EC','A','','','AC','0000034141','0000034141','LA00000537299','IL','1','English','Jamie','','','','34','433377134','135 DV BYRD LN',0,'WEST MONROE','LA','71292','0470','CY','22073','1965-07-09','F','U',':RET:2106-3','T','021','DEN','774237','18575LA002000201','2014-01-01','2013-11-08 09:21:12','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:30:35'),(25666,20362,'Y','18','021','EC','A','','','AC','0002079719','0002079719','LA00002448365','IL','1','Elgarm','Jenalyn','','','','34','431410445','703 Tillman Dr',0,'Minden','LA','71055',NULL,'CY','22119','1962-12-26','F','M',':RET:2106-3','N','021','DEN','3175853','18575LA002000101','2014-04-01','2014-02-22 11:59:52','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-26 08:30:48'),(18598,14827,'Y','18','021','EC','A','','','AC','0000442126','0000442126','MS00002407205','IL','1','williams','jessie','','','','34','587688988','1424 BUNCH ST',0,'CORINTH','MS','38834','4215','CY','28003','1953-10-23','F','M',':RET:2106-3','N','021','DEN','2050220','46300MS002000201','2014-02-01','2014-01-15 10:47:33','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-16 08:47:17'),(18392,14679,'N','19','021','EC','A',NULL,NULL,'','0000246475','0001187666','','IL','1','Stone','Sarah','','','','34','743529509','237 OPAL BLVD',0,'STEUBENVILLE','OH','43952','2330','CY','39081','2011-10-14','F','',':RET:2106-3','N','021','DEN','2849573','99734OH005000301','2014-02-01','2014-01-15 17:09:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:40'),(17279,13819,'N','19','021','EC','A',NULL,NULL,'','0000885609','0001124087','','IL','1','Karasek','Nicole','','','','34','268022519','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1996-09-07','F','',':RET:2106-3','N','021','HLT','2246097','52664OH152000901','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:23:25'),(6125,4857,'Y','18','021','EC','A','','','AC','0000431657','0000431657','TX00000451973','31','1','Fuller','Janice','','','','34','451312121','9450 SW GEMINI DR',0,'BEAVERTON','OR','97008','7105','CY','48439','1960-10-12','F','U',':RET:2106-3','N','021','DEN','201681','33348TX002000201','2014-01-01','2013-11-21 15:23:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:15:50'),(15879,12715,'Y','18','021','EC','A','','','AC','0002334853','0002334853','LA00002033247','IL','1','Stutts','Alvin','dE gRATTE','','Jr','34','422746562','203 WOODLAND CIR',0,'NEW IBERIA','LA','70563','2912','CY','22045','1954-01-16','M','U',':RET:2106-3','N','021','DEN','2550059','18575LA002000101','2014-02-01','2014-01-02 14:53:44','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-03 02:05:21'),(14740,11769,'Y','18','021','EC','A','','','AC','0002238058','0002238058','LA00001378709','IL','1','ANDERSEN','MARY','','','','34','433749840','10439 R L BERGERON LN',0,'NEW ROADS','LA','70760','4120','CY','22077','1958-11-14','F','U',':RET:2106-3','N','021','DEN','2115012','18575LA002000101','2014-02-01','2013-12-27 18:38:39','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2013-12-29 11:10:00'),(25243,20024,'N','19','021','EC','A',NULL,NULL,'','0001174433','0000824623','','S1','1','ulrick','beverly','','','','34','279150483','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','2009-04-27','M','',':RET:2106-3','N','021','HLT','3464360','92036OH004001501','2014-04-01','2014-02-20 20:15:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-02-21 22:01:09'),(26602,21091,'Y','18','021','EC','A','','','AC','0001205050','0001205050','TX00002846184','IL','1','Carter','Hayden','','','','34','629348913','15581 BUCKWHEAT ST',0,'EL PASO','TX','79938','8412','CY','48141','1992-12-11','M','U',':RET:2106-3','N','021','DEN','3274672','33348TX002000201','2014-04-01','2014-02-27 19:15:08','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:30:42'),(28578,22616,'Y','18','021','EC','A','','','AC','0000926782','0000926782','TX00003139972','IL','1','RASMUSSEN','MARTIN','ROBERT','','','34','465979464','538 TEAL DR',0,'DICKINSON','TX','77539','4027','CY','48167','1985-01-21','M','U',':RET:2106-3','N','021','DEN','3278998','33348TX002000201','2014-04-01','2014-03-08 14:16:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-03-08 21:00:06'),(1452,1211,'N','19','021','EC','A',NULL,NULL,'','0000277274','0000453922','','S1','1','Knippen','Rick','L',NULL,NULL,NULL,NULL,'26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','2006-11-27','M','',':RET:2106-3','N','021','DEN','2201030','99734OH005000401','2014-01-01','2013-12-24 07:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:07'),(3405,2733,'Y','18','021','EC','A','','','AC','0001803384','0001803384','LA00000628610','IL','1','Lambert','Glenda','','','','34','436792502','132 North Cemetery Road',0,'Saint Martinville','LA','70582',NULL,'CY','22099','1990-06-15','F','U',':RET:2054-5','T','021','DEN','1529028','18575LA002000201','2014-01-01','2013-12-22 14:32:55','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 21:18:14'),(22630,18071,'N','01','021','EC','A',NULL,NULL,'','0000239793','0000677560','','IL','1','Mehdi-Kashi','Bibi','','','','34','528216087','5507 Azalea Trail Lane',0,'Sugar Land','TX','77479',NULL,'CY','48157','1955-02-15','F','',':RET:2106-3','N','021','DEN','3384033','33348TX002000201','2014-03-01','2014-02-11 00:09:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:16'),(20813,16632,'Y','18','021','EC','A','','','AC','0000593707','0000593707','OH00002507079','IL','1','Bloomfield','Sandra','','','','34','274502237','1748 N THYRE DR',0,'GENOA','OH','43430','1132','CY','39123','1953-05-30','F','M',':RET:2106-3','N','021','HLT','3398782','92036OH004002701','2014-03-01','2014-01-31 18:26:28','311.00',NULL,NULL,'425.53','114.53','R-OH006','OH0','425.53',NULL,0,'2014-01-31 21:00:30'),(20386,16286,'Y','18','021','EC','A','','','AC','0000769696','0000769696','TX00001850483','IL','1','Poovathummoottil','Anns','','','','34','643133080','1809 CREEK LEDGE PL',0,'ROUND ROCK','TX','78664','7795','CY','48491','1978-03-19','F','M',':RET:2029-7','N','021','DEN','3081763','33348TX002000201','2014-03-01','2014-01-29 00:26:55','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-29 21:00:14'),(19947,15910,'Y','18','021','EC','A','','','AC','0000214683','0000214683','OH00001924736','IL','1','VASEY','JODY','','','','34','302562517','871 DORIS DR',0,'HUBBARD','OH','44425','1206','CY','39155','1955-11-24','F','U',':RET:2106-3','N','021','HLT','3403218','92036OH003003201','2014-03-01','2014-01-24 14:41:52','320.00',NULL,NULL,'644.06','324.06','R-OH013','OH0','644.06',NULL,0,'2014-01-24 21:01:18'),(5299,4200,'Y','18','021','EC','A','','','AC','0000781886','0000781886','OH00000081685','IL','1','Warner','Harmony','','','','34','536846193','809 Morse St.',0,'Findlay','OH','45840',NULL,'CY','39063','1979-11-03','F','M',':RET:2054-5^:RET:2106-3','N','021','HLT','2435645','92036OH003001505','2014-01-01','2013-12-18 22:03:19','452.06',NULL,NULL,'569.07','117.01','R-OH002','OH0','279.02',NULL,0,'2013-12-25 23:06:15'),(5449,4329,'Y','18','021','EC','A','','','AC','0000089812','0000089812','OH00000405410','IL','1','Hille','Matthew','','','','34','268744793','520 ALICE ST',0,'PORT CLINTON','OH','43452','2142','CY','39123','1978-05-01','M','U',':RET:2106-3','T','021','HLT','1616066','92036OH006002701','2014-01-01','2013-12-19 06:38:26','103.00',NULL,NULL,'217.31','114.31','R-OH006','OH0','217.31',NULL,0,'2013-12-25 23:10:07'),(18895,15055,'Y','18','021','EC','A','','','AC','0001037380','0001037380','OH00001398762','IL','1','Smith','Jamison','','','','34','285849870','410 Lakeview Ave',0,'Put in Bay','OH','43456',NULL,'CY','39123','1973-12-11','M','M',':RET:2106-3','T','021','HLT','2126656','92036OH003002701','2014-02-01','2014-01-15 23:46:14','0.00',NULL,NULL,'299.29','299.29','R-OH006','OH0','299.29',NULL,0,'2014-01-17 03:36:34'),(18977,15121,'N','19','021','EC','A',NULL,NULL,'','0000228366','0000920836','','IL','1','WHITLATCH','KATELYNN','M','','','34','291087849','537 FOWLER ST',0,'NEW LEXINGTON','OH','43764',NULL,'CY','39127','2003-12-19','F','',':RET:2106-3','N','021','DEN','2237610','99734OH005000301','2014-03-01','2014-01-17 13:47:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:06'),(19290,15376,'Y','18','021','EC','A','','','AC','0002082218','0002082218','LA00002563165','31','1','Hooge','Jonathon','','','','34','437690191','26086 Willow Wood St.',0,'Denham Springs','LA','70726',NULL,'CY','22103','1978-11-03','M','U',':RET:2106-3','N','021','DEN','3060548','18575LA002000201','2014-03-01','2014-01-20 22:53:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-22 03:21:54'),(25582,20293,'Y','18','021','EC','A','','','AC','0000129880','0000129880','TX00003239310','IL','1','DAVIS','VERA','','','','34','464060752','3814 WENTWORTH ST',0,'HOUSTON','TX','77004','6510','CY','48201','1955-10-13','F','M',NULL,'N','021','DEN','3428051','33348TX002000201','2014-04-01','2014-02-24 15:47:37','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-26 08:00:37'),(26111,20708,'N','19','021','EC','A',NULL,NULL,'','0000950727','0000332435','','S1','1','Tran','lee','','','','34','284087665','4540 HIDDEN RIDGE CT',0,'COLUMBUS','OH','43230','4124','CY','39049','2003-07-20','M','',':RET:2047-9','N','021','DEN','3623342','99734OH005000401','2014-04-01','2014-02-26 19:03:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:16'),(9664,7656,'Y','18','021','EC','A','','','AC','0000054828','0000054828','MS00000004378','IL','1','Zenner','Karen','','','','34','415176479','11325 High Road',0,'Hernando','MS','38632',NULL,'CY','28033','1958-12-05','F','M',':RET:2106-3','T','021','DEN','1568378','46300MS002000101','2014-01-01','2013-12-21 07:17:53','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-26 04:39:04'),(8008,6338,'Y','18','024','14','A','','','TE','0000734744','0000734744','','IL','1','Sparkman','Patsy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-17','F','',NULL,NULL,NULL,'','1033231','','2013-12-20','2013-12-20 14:39:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:08:34'),(7767,6150,'Y','18','021','EC','A','','','AC','0000918250','0000918250','OH00000116301','IL','1','Dreifort','Cindy','','','','34','273524975','232B CHAGRIN BLVD',0,'CHAGRIN FALLS','OH','44022','2739','CY','39035','1953-03-27','F','U',':RET:2106-3','N','021','DEN','2106303','99734OH005000401','2014-01-01','2013-12-20 18:46:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:50'),(17182,13748,'N','01','021','EC','A',NULL,NULL,'','0000920825','0000084059','','IL','1','Wilson','Lewis','','','','34','295741175','5019 PRICE RD',0,'MALTA','OH','43758','9716','CY','39115','1964-01-30','M','',':RET:2106-3','N','021','DEN','2400722','99734OH005000301','2014-02-01','2014-01-08 12:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:22:13'),(16115,12909,'Y','18','021','EC','A','','','AC','0001802267','0001802267','LA00001687192','IL','1','Narcisse','Sherita','','','','34','433496549','701 TEURLINGS DR',0,'LAFAYETTE','LA','70501','2603','CY','22055','1982-05-23','F','M',':RET:2054-5','N','021','DEN','2473138','18575LA002000101','2014-02-01','2014-01-03 00:09:09','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-04 02:05:14'),(13510,10768,'Y','18','024','14','A','','','TE','0000344180','0000344180','','IL','1','Lavis','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-07','M','',NULL,NULL,NULL,'','510912','','2013-12-22','2013-12-22 22:32:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:02:52'),(4701,3726,'Y','18','021','EC','A','','','AC','0001028053','0001028053','OH00001224156','IL','1','Gable','Gregory','','','Jr','34','297563920','1490 E 193rd St',0,'Ukron','OH','44117',NULL,'CY','39035','1958-02-06','M','U',':RET:2054-5','T','021','HLT','376260','92036OH004000801','2014-01-01','2013-12-12 09:37:10','330.00',NULL,NULL,'482.11','152.11','R-OH011','OH0','482.11',NULL,0,'2013-12-25 22:08:25'),(5022,3980,'Y','18','021','EC','A','','','AC','0000045708','0000045708','LA00000550271','IL','1','Miller','Michael','','','','34','433747096','203 RIM RD',0,'LAFAYETTE','LA','70507','4509','CY','22055','1949-12-28','M','U',':RET:2106-3','N','021','DEN','765243','18575LA002000101','2014-01-01','2013-12-07 14:46:01','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 22:47:34'),(7637,6046,'Y','18','021','EC','A','','','AC','0000141935','0000141935','TX00000337471','IL','1','schwertner','brandy','','','','34','452790939','1002 N. 1st St',0,'Temple','TX','76501',NULL,'CY','48027','1980-04-20','F','U',NULL,'N','021','DEN','796753','33348TX002000201','2014-01-01','2013-10-13 19:03:43','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 02:46:27'),(7518,5949,'Y','18','021','EC','A','','','AC','0000959554','0000959554','LA00000135130','IL','1','Harris','Camilo','','','','34','437598745','2809 Cambridge Drive',0,'Laplace','LA','70068',NULL,'CY','22095','1985-04-30','M','U',':RET:2054-5','N','021','DEN','1104972','18575LA002000201','2014-01-01','2013-12-15 13:26:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:32:17'),(3080,2475,'Y','18','021','EC','A','','','AC','0000427608','0000427608','OH00000781810','IL','1','Jaeger','Janet','Lee','','','34','281589138','1302 IRVING AVE',0,'CLEVELAND','OH','44109','3538','CY','39035','1954-06-26','F','U',':RET:2106-3','N','021','HLT','47272','92036OH005000804','2014-01-01','2013-12-05 18:34:47','374.00',NULL,NULL,'608.59','234.59','R-OH011','OH0','608.59',NULL,0,'2013-12-25 20:19:42'),(19559,15592,'Y','18','021','EC','A','','','AC','0001451366','0001451366','LA00001506956','IL','1','WILLIS','BRENDA','ANN','','','34','439866362','264 WILLIS RD',0,'sibley','LA','71073',NULL,'CY','22119','1951-12-16','F','M',':RET:2054-5','N','021','DEN','2632338','18575LA002000201','2014-03-01','2014-01-21 21:25:46','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-23 03:02:32'),(20445,16330,'Y','18','021','EC','A','','','AC','0000433197','0000433197','MS00001900825','IL','1','Hughes','Alana','','','','34','426656775','1047 WEST ST',0,'WESSON','MS','39191','7714','CY','28029','1987-02-24','F','M',':RET:2106-3','N','021','DEN','2790881','46300MS002000101','2014-03-01','2014-01-29 10:49:46','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-01-29 21:00:42'),(23292,18569,'Y','18','021','EC','A','','','AC','0001205854','0001205854','OH00001661423','IL','1','elzinga','marna',NULL,NULL,NULL,NULL,NULL,'4645 HARBORD DR',0,'TOLEDO','OH','43623','3964','CY','39095','1976-11-25','F','U',NULL,'N','021','DEN','3763064','99734OH005000301','2014-03-01','2014-02-12 22:32:55','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-13 22:00:08'),(26388,20932,'Y','18','024','14','A','','','TE','0000194050','0000194050','','IL','1','Taylor','Kathleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-24','F','',NULL,NULL,NULL,'','3232398','','2014-02-26','2014-02-26 12:37:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:00:24'),(28019,22173,'Y','18','024','14','A','','','TE','0000461997','0000461997','','IL','1','SUPPLENUSBAUM','Donna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-12','F','',NULL,NULL,NULL,'','3703413','','2014-03-06','2014-03-06 14:21:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:01:20'),(394,324,'Y','18','021','EC','A','','','AC','0000078730','0000078730','OH00000302298','IL','1','Murtland','Bethany','','','','34','283862147','5763 MARMION LN',0,'CINCINNATI','OH','45212','1924','CY','39061','1986-09-07','F','R',':RET:2106-3','N','021','DEN','67708','99734OH005000401','2014-01-01','2013-12-03 18:51:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:45:58'),(18269,14584,'Y','18','024','14','A','','','TE','0000213354','0000213354','','IL','1','MORALES','CINTHYA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-01-08','F','',NULL,NULL,NULL,'','1906460','','2014-01-15','2014-01-15 17:03:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-16 08:44:40'),(17566,14045,'Y','18','021','EC','A','','','AC','0000313268','0000313268','OH00001801956','IL','1','BABIOR','YURI','','','','34','731125429','8588 BROADACRE DR',0,'POWELL','OH','43065',NULL,'CY','39049','1972-06-15','M','M',NULL,'N','021','DEN','1432202','99734OH005000401','2014-02-01','2014-01-13 00:03:35','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:31:59'),(9597,7601,'Y','18','021','EC','A','','','AC','0000834460','0000834460','OH00000378864','IL','1','Allred','Zachary','Vadim','','','34','275985947','2540 SHORELINE DR',0,'AKRON','OH','44314','1267','CY','39153','1990-08-15','M','U',':RET:2106-3','N','021','HLT','1725047','52664OH151001306','2014-01-01','2013-12-21 07:59:39','178.00',NULL,NULL,'223.01','45.01','R-OH012','OH0','223.01',NULL,0,'2013-12-26 04:37:19'),(15461,12372,'Y','18','024','14','A','','','TE','0000067675','0000067675','','IL','1','Ronda','Alan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-07-09','M','',NULL,NULL,NULL,'','2464769','','2013-12-30','2013-12-30 18:43:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:28:41'),(14877,11880,'Y','18','021','EC','A','','','AC','0000594372','0000594372','TX00000646883','IL','1','Ponder','Janice','','','','34','466111681','521 PICKETTS DR',0,'MESQUITE','TX','75149','8712','CY','48113','1955-11-16','F','U',':RET:2106-3','N','021','DEN','2091091','33348TX002000201','2014-02-01','2013-12-29 12:50:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-30 00:00:23'),(6714,5324,'Y','18','021','EC','A','','','AC','0000252478','0000252478','MS00000455592','IL','1','WILSON','TINA','','','','34','428237141','3430 LAKEHURST CV',0,'HORN LAKE','MS','38637','1544','CY','28033','1962-09-20','F','M',':RET:2106-3','N','021','DEN','1088962','46300MS002000201','2014-01-01','2013-11-05 14:08:45','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-26 01:02:22'),(5972,4728,'Y','18','021','EC','A','','','AC','0000751742','0000751742','MS00001352682','IL','1','Rasco','Jacoquyn','','','','34','426735155','77 SCHOOL ST',0,'LAKE','MS','39092','9760','CY','28123','1992-01-28','M','U',':RET:2054-5','N','021','DEN','2505664','46300MS002000101','2014-01-01','2013-12-24 02:21:11','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 23:51:39'),(4168,3318,'N','01','021','EC','A',NULL,NULL,'','0001031437','0000424014','','IL','1','Shaffer','Wendy','A','','','34','302682658','5585 Steamtown Road',0,'Ashley','OH','43003',NULL,'CY','39041','1959-10-18','F','',':RET:2106-3','T','021','DEN','2427233','99734OH005000301','2014-01-01','2013-12-17 16:37:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:49:09'),(3444,2769,'Y','18','021','EC','A','','','AC','0000972734','0000972734','OH00000910932','IL','1','MYERS','MICHAEL','','','','34','286823919','5259 RELLUK DR',0,'CINCINNATI','OH','45238','3736','CY','39061','1984-05-19','M','M',':RET:2106-3','N','021','DEN','1499857','99734OH005000401','2014-01-01','2013-12-21 20:40:31','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:19:20'),(19326,15405,'N','01','021','EC','A',NULL,NULL,'','0000676350','0000242386','','IL','1','DANG','TAM','','','','34','434773825','3617 COLONY CREEK DR',0,'NACOGDOCHES','TX','75965','6977','CY','48347','1967-06-13','M','',':RET:2047-9','N','021','DEN','1791725','33348TX002000201','2014-03-01','2014-01-21 13:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-22 03:22:13'),(25608,20318,'Y','18','021','EC','A','','','AC','0000665971','0000665971','TX00002277152','IL','1','Owens','Marsha','','','','34','460177034','598 N HARBIN DR',0,'STEPHENVILLE','TX','76401','2819','CY','48143','1952-06-04','F','M',':RET:2106-3','N','021','DEN','3064517','33348TX002000201','2014-04-01','2014-02-21 23:28:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 08:30:07'),(26272,20839,'Y','18','021','EC','A','','','AC','0001168060','0001168060','OH00003116248','IL','1','WILLIAMS','KIMBERLY','','','','34','288725580','1800 RESERVOIR RD LOT 153',0,'LIMA','OH','45804',NULL,'CY','39003','1960-12-31','F','U',NULL,'T','021','HLT','3121395','92036OH005001505','2014-03-01','2014-02-26 19:00:16','346.00',NULL,NULL,'516.32','170.32','R-OH002','OH0','516.32',NULL,0,'2014-02-28 06:31:16'),(26519,21032,'Y','18','021','EC','A','','','AC','0000294433','0000294433','OH00003087831','IL','1','Dietrich','Keith','','','','34','298720882','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1975-07-03','M','M',NULL,'N','021','HLT','2621755','92036OH003002706','2014-03-01','2014-02-28 14:37:58','679.00',NULL,NULL,'769.34','90.34','R-OH006','OH0','253.74','CIC',0,'2014-02-28 21:00:23'),(27156,21501,'Y','18','021','EC','A','','','AC','0000127029','0000127029','OH00003577220','IL','1','Korgan','Dan','W','','','34','542802509','2677 e 126',0,'Cleveland','OH','44120',NULL,'CY','39035','1961-06-28','M','U',':RET:2106-3','N','021','DEN','3935765','99734OH005000401','2014-04-01','2014-03-03 15:31:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:55'),(7982,6320,'Y','18','021','EC','A','','','AC','0000273777','0000273777','OH00001171224','IL','1','Satina','Florence','','','','34','271540735','3738 Cynwood Drive',0,'Norton','OH','44203',NULL,'CY','39153','1950-12-09','F','U',':RET:2106-3','N','021','HLT','1634443','52664OH151001301','2014-01-01','2013-12-20 14:22:28','200.00',NULL,NULL,'658.32','458.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 03:08:00'),(16972,13584,'Y','18','021','EC','A','','','AC','0000079712','0000079712','MS00001405741','IL','1','Picazo','Lilia','','','','34','426994296','2749 Oak Grove Rd Lot 213',0,'Hattiesburg','MS','39402',NULL,'CY','28073','1958-11-21','F','M',NULL,'N','021','DEN','2000489','46300MS002000201','2014-02-01','2014-01-08 20:23:43','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-13 02:20:13'),(2838,2294,'Y','18','021','EC','A','','','AC','0000486919','0000486919','OH00000658792','IL','1','Couch','John','','','','34','292423117','7713 Shadowleaf Ln.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1951-08-21','M','M',':RET:2106-3','N','021','DEN','70230','99734OH005000401','2014-01-01','2013-11-24 13:03:21','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:00:59'),(7387,5847,'Y','18','021','EC','A','','','AC','0001011523','0001011523','OH00000166198','IL','1','JONES','CECIL','','','','34','284489630','7885 MAPLE GROVE DR',0,'LEWIS CENTER','OH','43035','9350','CY','39041','1951-11-27','M','M',NULL,'N','021','DEN','1160723','99734OH005000401','2014-01-01','2013-11-23 16:03:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:16:03'),(15773,12622,'Y','18','021','EC','A','','','AC','0000713734','0000713734','TX00000315597','IL','1','Goodsheller','Judy','','','','34','452986593','17404 DOGWOOD CREEK RD',0,'THORNTON','TX','76687','2005','CY','48395','1952-12-06','F','U',':RET:2106-3','N','021','DEN','2128644','33348TX002000201','2014-02-01','2014-01-02 15:00:05','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-03 02:01:53'),(15572,12462,'Y','18','021','EC','A','','','AC','0000484804','0000484804','OH00001378779','IL','1','REED','STEPHANIE','','','','34','297847503','6781 ROBERTS LN',0,'WOOSTER','OH','44691','7769','CY','39169','1973-12-13','F','M',':RET:2106-3','N','021','HLT','2324680','52664OH151001305','2014-02-01','2013-12-31 14:23:37','320.00',NULL,NULL,'633.01','313.01','R-OH014','OH0','285.00',NULL,1,'2014-01-02 04:31:55'),(15114,12081,'Y','18','021','EC','A','','','AC','0000191379','0000191379','OH00001926798','IL','1','CLARK','BRITTANY','JO','','','34','271926757','62260 BEECH CIRCLE RD',0,'CAMBRIDGE','OH','43725','8991','CY','39059','1990-03-14','F','U',':RET:2106-3','N','021','DEN','2362571','99734OH005000301','2014-02-01','2013-12-30 14:13:30','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-01-01 12:05:04'),(5854,4649,'Y','18','021','EC','A','','','AC','0000023581','0000023581','TX00001262806','IL','1','Okokhere','Andrew','','','','34','458535959','2826 PARK SPRINGS LN',0,'SUGAR LAND','TX','77479','8860','CY','48157','1958-11-30','M','U',NULL,'N','021','DEN','1881945','33348TX002000201','2014-01-01','2013-12-24 00:56:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:48:52'),(5743,4559,'Y','18','024','14','A','','','TE','0000917721','0000917721','','IL','1','Smith','Ava',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-01','F','',NULL,NULL,NULL,'','543534','','2013-12-24','2013-12-24 00:38:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 23:46:01'),(6729,5338,'Y','18','021','EC','A','','','AC','0000326152','0000326152','OH00001196281','IL','1','Dawson','Nancy','','','','34','327466186','5386 Sultana Dr',0,'Cincinnati','OH','45238',NULL,'CY','39061','1967-04-19','F','M',':RET:2106-3','N','021','DEN','843657','99734OH005000401','2014-01-01','2013-11-25 09:04:41','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:25'),(4397,3495,'Y','18','021','EC','A','','','AC','0000481049','0000481049','OH00000578633','IL','1','Marshall','Susan','','','','34','281624191','655 E 5TH AVE',0,'LANCASTER','OH','43130','3108','CY','39045','1963-03-24','F','M',':RET:2106-3','T','021','DEN','1429','99734OH005000401','2014-01-01','2013-12-12 13:36:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:02'),(19681,15684,'N','01','021','EC','A',NULL,NULL,'','0001129521','0001113199','','IL','1','CABRERA','DANIEL','','','','34','644723641','3112 37TH PL',0,'SNYDER','TX','79549','5701','CY','48415','1975-04-03','M','',':RET:2106-3','N','021','DEN','1810211','33348TX002000201','2014-03-01','2014-01-22 22:26:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 21:00:38'),(19871,15850,'Y','18','021','EC','A','','','AC','0000392389','0000392389','OH00002142542','IL','1','DUNHAM','GUIOMAR','','','','34','590471511','232 MEEK AVE',0,'BYESVILLE','OH','43723',NULL,'CY','39059','1960-06-20','F','U',NULL,'N','021','DEN','2173946','99734OH005000401','2014-03-01','2014-01-24 13:09:41','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-24 21:00:41'),(22202,17720,'N','01','021','EC','A',NULL,NULL,'','0000968249','0001165381','','IL','1','TURNER','STEPHANIE','','','','34','273827591','575 BRUNNER DR',0,'CINCINNATI','OH','45240','3925','CY','39061','1970-09-30','F','',':RET:2106-3','N','021','DEN','2881331','99734OH005000401','2014-03-01','2014-02-09 12:33:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-09 19:00:15'),(23423,18663,'Y','18','021','EC','A','','','AC','0001197873','0001197873','TX00002479621','IL','1','Lopez','Teresa','','','','34','452133773','216 E OCEAN BLVD',0,'LOS FRESNOS','TX','78566','3227','CY','48061','1954-04-28','F','M',':RET:2106-3','N','021','DEN','3566845','33348TX002000201','2014-03-01','2014-02-12 23:25:57','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-02-13 22:01:23'),(25665,20361,'Y','18','021','EC','A','','','AC','0001695408','0001695408','LA00002024511','IL','1','Carte','John','','','','34','436736884','2211 Patton St.',0,'sulphur','LA','70665',NULL,'CY','22019','1987-07-15','M','U',':RET:2106-3','N','021','DEN','3832841','18575LA002000101','2014-04-01','2014-02-21 23:48:27','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-02-26 08:30:47'),(27760,21952,'Y','18','021','EC','A','','','AC','0001957147','0001957147','LA00003572614','IL','1','WARD','ONESIA','','','','34','439773334','11555 SOUTHFORK AVE',0,'BATON ROUGE','LA','70816','2269','CY','22033','1990-04-02','F','M',NULL,'N','021','DEN','3278867','18575LA002000201','2014-04-01','2014-03-05 11:34:44','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:19'),(13594,10843,'Y','18','021','EC','A','','','AC','0001413913','0001413913','LA00000543045','IL','1','stewart','shendrell','','','','34','438611732','8721 ORLEANS DR',0,'BATON ROUGE','LA','70810','2161','CY','22033','1983-08-29','F','U',NULL,'N','021','DEN','2079969','18575LA002000201','2014-01-01','2013-12-23 19:22:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:05:15'),(24530,19485,'N','01','021','EC','A',NULL,NULL,'','0000663254','0000926670','','IL','1','MECINAS','FLAVIA','','','','34','570876273','10972 SOMBRA VERDE DR',0,'EL PASO','TX','79935','3709','CY','48141','1969-03-26','F','',NULL,'N','021','DEN','3300508','33348TX002000201','2014-04-01','2014-02-19 16:31:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 04:00:14'),(24631,19548,'Y','18','021','EC','A','','','AC','0002213411','0002213411','LA00002140721','IL','1','Elie','Shilonda','','','','34','437370520','412 13TH ST',0,'ALEXANDRIA','LA','71301','7013','CY','22079','1977-10-08','F','U',':RET:2054-5','N','021','DEN','2870873','18575LA002000201','2014-04-01','2014-02-19 09:38:59','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-20 04:17:59'),(25422,20171,'Y','18','021','EC','A','','','AC','0000612007','0000612007','OH00002627398','IL','1','Bickle','Chestene','','','','34','232905905','277 ARBUCKLE RD',0,'GALLIPOLIS','OH','45631','8803','CY','39053','1953-10-22','F','R',':RET:2106-3','N','021','DEN','3457219','99734OH005000401','2014-04-01','2014-02-25 15:24:30','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-02-25 21:31:09'),(8065,6386,'Y','18','021','EC','A','','','AC','0000258112','0000258112','OH00000806779','IL','1','Eaton','Susan','','','','34','369660017','3339 DRUMMOND RD',0,'TOLEDO','OH','43606','1672','CY','39095','1956-08-13','F','M',NULL,'N','021','HLT','2575970','92036OH003002601','2014-01-01','2013-12-20 15:27:06','0.00',NULL,NULL,'496.27','496.27','R-OH001','OH0','496.27',NULL,0,'2013-12-26 03:10:03'),(993,813,'Y','18','024','14','A','','','TE','0001100562','0001100562','','IL','1','debord','dawn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-07','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-11 15:24:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:10:41'),(17715,14158,'Y','18','024','14','A','','','TE','0001010229','0001010229','','IL','1','steele','andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-07-17','M','',NULL,NULL,NULL,'','2232550','','2014-01-12','2014-01-12 22:35:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-14 01:33:12'),(16271,13027,'Y','18','021','EC','A','','','AC','0001056707','0001056707','OH00001638752','IL','1','MOBLEY','CHARLOTTE','','','','34','295500372','53859 BELMONT RIDGE RD',0,'BEALLSVILLE','OH','43716',NULL,'CY','39013','1951-06-18','F','U',':RET:2106-3','N','021','DEN','2267846','99734OH005000401','2014-02-01','2014-01-05 19:45:15','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-07 04:00:17'),(1316,1088,'N','17','021','EC','A',NULL,NULL,'','0000186069','0000102789','','IL','1','Cortes','Jake','','','','34','602838676','119 RAVINEWOOD TER',0,'LOVELAND','OH','45140','7744','CY','39061','2010-06-17','M','',NULL,'N','021','DEN','335758','99734OH005000401','2014-01-01','2013-11-04 11:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:31:35'),(14598,11651,'Y','18','024','14','A','','','TE','0000012402','0000012402','','IL','1','Fore','Tonya',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-05-09','F','',NULL,NULL,NULL,'','1139229','','2013-12-27','2013-12-27 06:31:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:19'),(5523,4381,'Y','18','021','EC','A','','','AC','0001045637','0001045637','OH00000115590','IL','1','Muraya','Nancy','N','','','34','419538001','3235 Tammery Ct',0,'Columbus','OH','43231',NULL,'CY','39049','1965-12-12','F','M',':RET:2054-5','N','021','DEN','16120','99734OH005000401','2014-01-01','2013-11-26 18:40:49','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:23'),(2207,1818,'Y','18','021','EC','A','','','AC','0000279524','0000279524','OH00001006565','IL','1','Stephens','Jesse','','','','34','298469693','1974 St. Rt. 179',0,'Jeromesville','OH','44840',NULL,'CY','39005','1951-04-17','M','M',':RET:2106-3','N','021','HLT','139232','52664OH151001305','2014-01-01','2013-12-10 13:42:01','607.00',NULL,NULL,'640.70','33.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 19:20:12'),(2734,2212,'Y','18','021','EC','A','','','AC','0000296845','0000296845','LA00001127073','IL','1','Ross','Marie','','','','34','436940114','61333 Highway 11',0,'Slidell','LA','70458',NULL,'CY','22103','1956-03-06','F','U',':RET:2054-5','N','021','DEN','777577','18575LA002000201','2014-01-01','2013-12-02 15:36:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:34'),(4171,3320,'N','01','021','EC','A',NULL,NULL,'','0000793453','0000796945','','IL','1','Smith','Phyllis','Jean','','','34','279628805','657 Eastern Ave',0,'Bellefontaine','OH','43311',NULL,'CY','39091','1957-01-06','F','',':RET:2106-3','N','021','DEN','1490619','99734OH005000301','2014-01-01','2013-12-17 17:17:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:49:13'),(18550,14793,'N','01','021','EC','A',NULL,NULL,'','0000075947','0000679580','','IL','1','HOLLIMAN','AMY','MAE','','','34','428458628','503 E TRACY ST',0,'GULFPORT','MS','39503','3794','CY','28047','1970-07-12','F','',':RET:2106-3','N','021','DEN','1705610','46300MS002000101','2014-02-01','2014-01-15 13:12:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-16 08:46:53'),(23503,18721,'Y','18','021','EC','A','','','AC','0000871724','0000871724','TX00002115994','IL','1','TOVAR','FRANCISCA','','','','34','640203612','924 ABE ST',0,'LONGVIEW','TX','75601','4618','CY','48183','1988-05-10','F','U',':RET:2106-3','N','021','DEN','3331935','33348TX002000101','2014-03-01','2014-02-13 10:54:24','0.00',NULL,NULL,'25.02','25.02','R-TX013','TX0','25.02',NULL,0,'2014-02-13 22:02:08'),(26209,20786,'N','01','021','EC','A',NULL,NULL,'','0000972801','0000636065','','IL','1','Terry','Daniel','','','','34','270861419','1886 COVENTRY DR',0,'BRUNSWICK','OH','44212','4178','CY','39103','1972-03-02','M','',':RET:2106-3','N','021','HLT','3606227','52664OH151001305','2014-03-01','2014-02-27 11:49:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.36',NULL,0,'2014-02-28 06:30:52'),(28227,22334,'N','19','021','EC','A',NULL,NULL,'','0001204586','0000115550','','S1','1','Habli','firas','','','','34','269130210','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2006-08-28','F','',NULL,'N','021','DEN','2969726','99734OH005000301','2014-04-01','2014-03-06 15:47:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-06 21:30:21'),(28406,22476,'Y','18','021','EC','A','','','AC','0000843405','0000843405','OH00003207859','IL','1','Huddleston','Danielle','','','','34','285901523','3930 DILLON DR',0,'COLUMBUS','OH','43227','1707','CY','39049','1989-06-14','F','U',':RET:2054-5','T','021','DEN','3414808','99734OH005000401','2014-04-01','2014-03-07 10:50:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:30:54'),(29005,22956,'Y','18','024','14','A','','','TE','0000203147','0000203147','','IL','1','EVANS-HENRY','BECKY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-30','F','',NULL,NULL,NULL,'','3724542','','2014-03-10','2014-03-10 12:32:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:21'),(214,179,'Y','18','021','EC','A','','','AC','0000736354','0000736354','LA00000600802','IL','1','FORD','CARLOS','WAYNE','','','34','433219926','708 W WASHINGTON ST',0,'TALLULAH','LA','71282','2440','CY','22065','1960-03-09','M','U',':RET:2054-5','N','021','DEN','33434','18575LA002000201','2014-01-01','2013-12-05 13:29:16','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 17:20:33'),(18495,14752,'Y','18','021','EC','A','','','AC','0000585551','0000585551','OH00002392668','IL','1','Purcell','Steven','','','','34','292863211','1075 Tall Grass Circle',0,'Stow','OH','44224',NULL,'CY','39153','1986-12-29','M','U',NULL,'N','021','HLT','2563688','52664OH151001305','2014-02-01','2014-01-15 11:52:31','148.00',NULL,NULL,'233.71','85.71','R-OH012','OH0','233.71',NULL,0,'2014-01-16 08:46:27'),(9444,7492,'Y','18','021','EC','A','','','AC','0001220830','0001220830','OH00000670156','IL','1','KAMIYA','UWIMANA','','','','34','631661702','4195 GREENSBURY DR',0,'NEW ALBANY','OH','43054','9107','CY','39049','1974-11-21','F','M',':RET:2054-5','N','021','DEN','1743204','99734OH005000401','2014-01-01','2013-12-20 19:08:49','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:33:46'),(7205,5709,'Y','18','021','EC','A','','','AC','0001239104','0001239104','OH00000691132','IL','1','Donaldson','Keith','','','','34','518766974','944 Fruitland Rd.',0,'Springfield','OH','45503',NULL,'CY','39023','1956-08-05','M','U',':RET:2106-3','N','021','DEN','1187147','99734OH005000401','2014-01-01','2013-12-13 20:08:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:00:45'),(14306,11412,'N','01','021','EC','A',NULL,NULL,'','0000929847','0000149361','','IL','1','RIFE','BENJAMIN','','','','34','277806613','971 HOMEWOOD AVE SE',0,'WARREN','OH','44484','4908','CY','39155','1975-02-24','M','',':RET:2106-3','N','021','HLT','1611962','92036OH001003201','2014-02-01','2013-12-26 10:57:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.82',NULL,0,'2013-12-27 02:06:58'),(3530,2834,'N','19','021','EC','A',NULL,NULL,'','0001194131','0000155074','','IL','1','Steormann','Jackson','Brett','','','34','635905523','1165 Mount Gilead Road',0,'Keller','TX','76262',NULL,'CY','48439','2004-02-10','M','',':RET:2106-3','N','021','DEN','2600144','33348TX002000101','2014-01-01','2013-12-21 22:43:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2013-12-25 21:21:29'),(19128,15240,'Y','18','021','EC','A','','','AC','0001489456','0001489456','LA00002178588','IL','1','Terry','Eva','','','','34','613966394','7942 PRICE AVE',0,'BATON ROUGE','LA','70811','1864','CY','22033','1990-10-12','F','U',':RET:2054-5','N','021','DEN','2363078','18575LA002000201','2014-03-01','2014-01-19 16:31:30','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:45:21'),(22151,17681,'Y','18','021','EC','A','','','AC','0000748227','0000748227','OH00001479543','IL','1','Jacobs','John','','','','34','279505431','181 HAWK AVE',0,'AKRON','OH','44312','1435','CY','39153','1966-04-06','M','U',':RET:2106-3','T','021','HLT','3059813','52664OH151001304','2014-03-01','2014-02-08 12:32:24','172.00',NULL,NULL,'400.84','228.84','R-OH012','OH0','400.84',NULL,0,'2014-02-08 19:00:54'),(22814,18207,'Y','18','021','EC','A','','','AC','0000425127','0000425127','OH00002511523','IL','1','Clark','Christopher',NULL,NULL,NULL,NULL,NULL,'P.O. Box 248',0,'Owensville','OH','45160',NULL,'CY','39025','1978-06-10','M','U',':RET:2106-3','N','021','DEN','3602146','99734OH005000301','2014-03-01','2014-02-11 16:44:23','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-11 21:01:59'),(24650,19567,'Y','18','021','EC','A','','','AC','0001702936','0001702936','LA00001963435','IL','1','Carney','MARCENETTE','','','','34','436457746','2741 N DAY DR',0,'BAKER','LA','70714','3213','CY','22033','1968-08-17','F','U',':RET:2054-5','N','021','DEN','3592362','18575LA002000201','2014-04-01','2014-02-19 15:30:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:22:27'),(26566,21062,'Y','18','021','EC','A','','','AC','0001151126','0001151126','OH00001900002','IL','1','STEWART','DORNETTE','','','','34','283645103','7082 Glenmeadow Ln',0,'Cincinnati','OH','45237',NULL,'CY','39061','1959-03-27','F','U',':RET:2054-5','T','021','DEN','2837282','99734OH005000401','2014-04-01','2014-02-28 10:51:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:23'),(9291,7367,'N','19','021','EC','A',NULL,NULL,'','0000225979','0000911732','','IL','1','Smith','Benjamin','Robert','','','34','651401452','919 BROOKCREST DR',0,'MASON','OH','45040','3435','CY','39165','2006-05-07','M','',':RET:2106-3','N','021','DEN','1094066','99734OH005000301','2014-01-01','2013-11-30 14:42:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:16:09'),(7102,5633,'Y','18','021','EC','A','','','AC','0000948421','0000948421','OH00001529513','IL','1','crawford','kimberly','','','','34','566379101','7098 Baribill Pl',0,'Cincinnati','OH','45230',NULL,'CY','39061','1958-10-09','F','M',':RET:2106-3','T','021','HLT','1845146','92036OH004001201','2014-01-01','2013-12-24 20:07:45','340.00',NULL,NULL,'442.67','102.67','R-OH004','OH0','442.67',NULL,0,'2013-12-26 01:50:47'),(17495,13989,'Y','18','021','EC','A','','','AC','0001294865','0001294865','LA00002160405','31','1','Bernard','Adam','','','','34','433511682','P.O. Box 792374',0,'New Orleans','LA','70179',NULL,'CY','22051','1983-06-01','M','U',':RET:2106-3','N','021','DEN','2247355','18575LA002000201','2014-02-01','2014-01-12 09:18:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 03:01:22'),(2627,2136,'N','01','021','EC','A',NULL,NULL,'','0000093813','0000173783','','IL','1','JONES','TOMMY','','','','34','542607377','1600 CEDAR ST. LOT 13 GG',0,'FREMONT','OH','43420',NULL,'CY','39143','1951-08-22','M','',':RET:2106-3','N','021','DEN','996405','99734OH005000401','2014-01-01','2013-12-02 12:57:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:01'),(3144,2528,'Y','18','021','EC','A','','','AC','0000364405','0000364405','TX00000423881','IL','1','Craig','Leigh','Ann','','','34','450310545','140 Priddy Lane',0,'Fort Worth','TX','76114',NULL,'CY','48439','1959-09-10','F','U',NULL,'N','021','DEN','984491','33348TX002000201','2014-01-01','2013-11-18 08:44:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:30:51'),(13162,10499,'N','01','021','EC','A',NULL,NULL,'','0000120089','0000807503','','IL','1','Pierson','Betsy','B','','','34','274542160','700 EWING RD',0,'BAINBRIDGE','OH','45612','9476','CY','39141','1952-01-09','F','',':RET:2106-3','N','021','DEN','2288100','99734OH005000401','2014-01-01','2013-12-23 18:01:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:53'),(5462,4339,'Y','18','021','EC','A','','','AC','0000728698','0000728698','OH00001095068','IL','1','Meyer','Grace','','','','34','285900462','5800 FESSLER BUXTON RD',0,'HOUSTON','OH','45333','9771','CY','39149','1986-01-04','F','M',':RET:2106-3','N','021','HLT','1661679','92036OH006000501','2014-01-01','2013-12-19 09:03:44','180.00',NULL,NULL,'395.12','215.12','R-OH003','OH0','197.56',NULL,0,'2013-12-25 23:10:27'),(18782,14960,'Y','18','021','EC','A','','','AC','0001204560','0001204560','OH00002094064','IL','1','Jacobs','Margarite','','','','34','270521726','16813 ELSIENNA AVE',0,'CLEVELAND','OH','44135','1901','CY','39035','1951-10-20','F','U',':RET:2106-3','N','021','DEN','2085421','99734OH005000401','2014-02-01','2014-01-15 18:38:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:53'),(21288,17011,'Y','18','024','14','A','','','TE','0002223458','0002223458','','IL','1','Parkman','Diane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-09','F','',NULL,NULL,NULL,'','1950115','','2014-02-03','2014-02-03 19:36:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-04 21:00:05'),(24361,19349,'N','01','021','EC','A',NULL,NULL,'','0001652357','0001194927','','IL','1','BROWN','KRISTY','','','','34','434456545','10797 SHELTON RD.',0,'BASTROP','LA','71220',NULL,'CY','22067','1981-10-02','F','',NULL,'N','021','DEN','3623162','18575LA002000201','2014-04-01','2014-02-18 10:39:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-18 22:00:32'),(24460,19432,'Y','18','021','EC','A','','','AC','0000493360','0000493360','TX00001533452','IL','1','Creel','Ramona','','','','34','261891628','100 RAINBOW DR',0,'LIVINGSTON','TX','77351','9340','CY','48373','1972-03-01','F','M',':RET:2106-3','N','021','DEN','3592331','33348TX002000101','2014-04-01','2014-02-18 13:54:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-18 22:01:32'),(25413,20163,'Y','18','024','14','A','','','TE','0000309414','0000309414','','IL','1','Fletcher','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-06-29','M','',NULL,NULL,NULL,'','742046','','2014-03-12','2014-02-25 13:05:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:31:04'),(26724,21184,'Y','18','021','EC','A','','','AC','0000533968','0000533968','TX00002319912','IL','1','samaha','muhammad','','','','34','443763155','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','1961-05-20','M','M',':RET:2106-3','N','021','DEN','3332360','33348TX002000101','2014-04-01','2014-02-28 09:18:59','0.00',NULL,NULL,'148.50','148.50','R-TX008','TX0','27.15',NULL,0,'2014-02-28 21:31:46'),(9785,7749,'N','19','021','EC','A',NULL,NULL,'','0000631477','0000629212','','IL','1','Thompson','Joseph','','','','34','289138920','1274 SERENITY LN',0,'COLUMBUS','OH','43085','4796','CY','39049','2007-11-09','M','',':RET:2106-3','N','021','DEN','582269','99734OH005000301','2014-01-01','2013-10-21 12:15:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:51'),(18533,14779,'N','19','021','EC','A',NULL,NULL,'','0000432782','0000555392','','IL','1','Haley','Landan',NULL,NULL,NULL,NULL,NULL,'28220 SIMMONS RD',0,'PERRYSBURG','OH','43551','4132','CY','39173','1996-12-09','M','',':RET:2106-3','N','021','HLT','2802236','92036OH006002601','2014-02-01','2014-01-14 21:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2014-01-16 08:46:44'),(17452,13957,'Y','18','024','14','A','','','TE','0001005730','0001005730','','IL','1','Kennedy','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-04-23','M','',NULL,NULL,NULL,'','1698891','','2014-01-10','2014-01-10 14:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:39'),(2761,2233,'Y','18','021','EC','A','','','AC','0000259197','0000259197','OH00000143156','IL','1','Griggs','Keith','','','','34','269700920','1667 JUNIATA RD',0,'AKRON','OH','44305','1444','CY','39153','1971-05-30','M','M',':RET:2054-5','N','021','HLT','371453','52664OH151001304','2014-01-01','2013-12-02 17:51:56','131.00',NULL,NULL,'437.09','306.09','R-OH012','OH0','295.48',NULL,0,'2013-12-25 19:49:19'),(2986,2402,'Y','18','021','EC','A','','','AC','0000230400','0000230400','OH00000952208','IL','1','Stidham','Scott','','','','34','274881300','2287 HIBISCUS DR',0,'LOVELAND','OH','45140','1355','CY','39165','1972-11-19','M','U',':RET:2106-3','N','021','DEN','1221079','99734OH005000301','2014-01-01','2013-12-06 11:13:44','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:17:17'),(9079,7204,'Y','18','021','EC','A','','','AC','0000827148','0000827148','OH00000794471','IL','1','Kildow','Nancy','Lee','','','34','292506208','2985 Fairway Lane',0,'Zanesville','OH','43701',NULL,'CY','39119','1960-03-22','F','U',':RET:2106-3','N','021','DEN','2154831','99734OH005000301','2014-01-01','2013-12-17 19:59:42','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:06:46'),(22305,17806,'Y','18','021','EC','A','','','AC','0000718942','0000718942','OH00001760236','IL','1','PURDIE JUNIOR','NATHANIEL','','','','34','284522026','553 VILLA AVE',0,'AKRON','OH','44310','3943','CY','39153','1953-10-03','M','U',NULL,'T','021','DEN','2822645','99734OH005000301','2014-03-01','2014-01-24 09:42:39','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-10 11:00:39'),(24312,19307,'Y','18','021','EC','A','','','AC','0000105165','0000105165','TX00002930845','IL','1','rios','veronica','','','','34','467953458','33902 fm 510',0,'San Benito','TX','78586',NULL,'CY','48061','1974-06-10','F','M',NULL,'N','021','DEN','3078689','33348TX002000201','2014-04-01','2014-02-17 19:30:32','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-18 22:00:02'),(25735,20414,'Y','18','021','EC','A','','','AC','0000622541','0000622541','OH00001928087','IL','1','MICHAELS','FRANCIS','','','','34','113588266','5475 MASON RD',0,'MASON','OH','45040','1611','CY','39165','1973-08-09','M','U',':RET:2106-3','N','021','DEN','3619600','99734OH005000401','2014-04-01','2014-02-23 23:27:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 09:30:38'),(13038,10394,'Y','18','024','14','A','','','TE','0001081795','0001081795','','IL','1','Hodson','Walker',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1994-09-10','M','',NULL,NULL,NULL,'','2581100','','2013-12-23','2013-12-23 05:53:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:50:32'),(6614,5244,'Y','18','021','EC','A','','','AC','0000823491','0000823491','OH00001033395','IL','1','Livers','Deborah','','','','34','279584380','9542 NEWGATE LN',0,'CINCINNATI','OH','45231','3713','CY','39061','1958-08-29','F','M',':RET:2054-5','T','021','HLT','1238535','92036OH004001201','2014-01-01','2013-12-11 13:07:55','380.00',NULL,NULL,'442.67','62.67','R-OH004','OH0','442.67',NULL,0,'2013-12-26 00:53:50'),(3993,3188,'Y','18','021','EC','A','','','AC','0000372585','0000372585','OH00000239338','IL','1','Vondenhuevel','Thomas','','','','34','281928428','2501 Hardin-Wapak Rd',0,'Sidney','OH','45365',NULL,'CY','39149','1988-11-16','M','U',':RET:2106-3','N','021','HLT','941421','92036OH003000501','2014-01-01','2013-12-13 15:18:50','0.00',NULL,NULL,'249.24','249.24','R-OH003','OH0','249.24',NULL,0,'2013-12-25 21:39:09'),(22939,18288,'Y','18','024','14','A','','','TE','0000684086','0000684086','','IL','1','BAUER','KRISTIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-06-13','F','',NULL,NULL,NULL,'','396545','','2014-02-28','2014-02-11 12:05:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-11 21:30:18'),(23228,18518,'Y','18','021','EC','A','','','AC','0001173261','0001173261','OH00001875846','IL','1','Nelson','Alyse','','','','34','282482442','3840 W 128TH ST',0,'CLEVELAND','OH','44111','4511','CY','39035','1952-01-21','F','M',':RET:2106-3','T','021','HLT','2762536','92036OH004000801','2014-03-01','2014-02-12 16:37:33','387.00',NULL,NULL,'621.12','234.12','R-OH011','OH0','621.12',NULL,0,'2014-02-12 21:32:23'),(24500,19464,'Y','18','021','EC','A','','','AC','0000598463','0000598463','TX00002493239','31','1','jones','janelle','','','','34','437804463','p.o.box 682074',0,'houston','TX','77268',NULL,'CY','48201','1949-10-08','F','U',':RET:2054-5','T','021','DEN','3419024','33348TX002000201','2014-04-01','2014-02-18 21:30:32','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 03:48:51'),(1323,1094,'Y','18','021','EC','A','','','AC','0000376117','0000376117','OH00000445723','IL','1','calderone','helen','','','','34','409374633','122 e columbus rd',0,'south charleston','OH','45368',NULL,'CY','39023','1981-03-13','F','U',':RET:2106-3','N','021','HLT','420156','92036OH002000501','2014-01-01','2013-11-04 15:55:59','0.00',NULL,NULL,'324.75','324.75','R-OH003','OH0','324.75',NULL,0,'2013-12-25 18:31:48'),(22889,18249,'N','19','021','EC','A',NULL,NULL,'','0000401282','0000231543','','S1','1','Bray','Timothy','','','','34','301981100','2275 ORCHARD HILLS BLVD',0,'TOLEDO','OH','43615','2638','CY','39095','1996-05-04','M','',':RET:2106-3','N','021','HLT','3603202','92036OH003002604','2014-03-01','2014-02-11 10:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-11 21:02:36'),(20210,16126,'Y','18','021','EC','A','','','AC','0000675479','0000675479','OH00001368739','IL','1','DePaolo','Michelle','','','','34','271865252','38155 STATE ROUTE 303',0,'GRAFTON','OH','44044','9013','CY','39093','1971-08-11','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','2833724','52664OH151001501','2014-03-01','2014-01-27 12:09:46','0.00',NULL,NULL,'591.25','591.25','R-OH011','OH0','399.70',NULL,0,'2014-01-27 21:01:37'),(7121,5650,'Y','18','021','EC','A','','','AC','0000404183','0000404183','MS00001584810','IL','1','Ford','Dennis','','','','34','427026871','12399 HIGHWAY 35',0,'MIZE','MS','39116','5007','CY','28129','1956-07-16','M','U',':RET:2106-3','N','021','DEN','2015477','46300MS002000201','2014-01-01','2013-12-24 19:23:03','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 01:51:19'),(16491,13196,'Y','18','021','EC','A','','','AC','0001144785','0001144785','OH00001413096','IL','1','TA','TRI','','','','34','415430607','1866 LATHAM AVE',0,'LIMA','OH','45805','1636','CY','39003','1970-05-17','M','M',':RET:2047-9','N','021','HLT','1452164','92036OH006001501','2014-02-01','2014-01-06 16:20:26','382.00',NULL,NULL,'689.80','307.80','R-OH002','OH0','236.85',NULL,0,'2014-01-07 04:06:34'),(5827,4627,'Y','18','021','EC','A','','','AC','0000676226','0000676226','TX00000265275','IL','1','Padilla','Juanita','','','','34','460838244','21135 CHANCE LN',0,'EDINBURG','TX','78542','1678','CY','48215','1976-12-06','F','M',NULL,'N','021','DEN','2541171','33348TX002000201','2014-01-01','2013-12-23 23:04:44','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 23:48:09'),(25437,20183,'Y','18','021','EC','A','','','AC','0000102536','0000102536','TX00002631850','IL','1','Newsome','David','','','','34','238494879','521 N. San Antonio St.',0,'Port Lavaca','TX','77979',NULL,'CY','48057','1973-07-20','M','U',':RET:2106-3','N','021','DEN','2800137','33348TX002000201','2014-04-01','2014-02-25 01:08:04','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-25 21:31:18'),(26030,20644,'Y','18','021','EC','A','','','AC','0000470964','0000470964','MS00003043567','IL','1','Williams','Martwain','','','','34','428632088','199 Mitchener Road',0,'Tutwiler','MS','38963',NULL,'CY','28135','1988-09-28','M','U',':RET:2054-5','N','021','DEN','2644330','46300MS002000101','2014-04-01','2014-02-26 13:17:39','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-26 21:02:21'),(106,93,'Y','18','021','EC','A','','','AC','0001007712','0001007712','TX00000145990','IL','1','Elliott','Steven','','','','34','447903631','1617 WHELESS LN',0,'AUSTIN','TX','78723','1146','CY','48453','1985-11-01','M','U',':RET:2106-3','N','021','DEN','610796','33348TX002000201','2014-01-01','2013-12-05 11:19:13','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 17:17:50'),(999,819,'Y','18','021','EC','A','','','AC','0000816562','0000816562','TX00000588105','31','1','Franklin','Nicholas','','','','34','463550522','3617 Willow St',0,'Amarillo','TX','79118',NULL,'CY','48381','1980-11-04','M','U',':RET:2106-3','N','021','DEN','75338','33348TX002000101','2014-01-01','2013-11-11 04:22:56','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2013-12-25 18:10:53'),(24662,19577,'Y','18','021','EC','A','','','AC','0000981669','0000981669','OH00002180420','IL','1','Wilson','Jill','','','','34','366620143','807 STANDISH DR',0,'BOWLING GREEN','OH','43402','1228','CY','39173','1952-04-23','F','U',NULL,'T','021','HLT','2921129','92036OH004002601','2014-04-01','2014-02-19 15:53:20','271.00',NULL,NULL,'506.69','235.69','R-OH001','OH0','506.69',NULL,0,'2014-02-20 04:25:32'),(9520,7550,'Y','18','021','EC','A','','','AC','0000934653','0000934653','OH00000317551','IL','1','Kesson','Luke','','','','34','380087541','2944 W CENTRAL AVE',0,'TOLEDO','OH','43606','3022','CY','39095','1986-05-25','M','M',':RET:2106-3','N','021','DEN','2149303','99734OH005000301','2014-01-01','2013-12-20 19:57:10','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-26 04:35:37'),(5571,4419,'N','01','021','EC','A',NULL,NULL,'','0001057951','0001059448','','IL','1','Scrivner','Lori','C','','','34','297784977','8072 MILL CREEK CIR',0,'WEST CHESTER','OH','45069','1649','CY','39017','1964-09-19','F','',':RET:2106-3','T','021','DEN','174461','99734OH005000301','2014-01-01','2013-11-06 09:38:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:40'),(20852,16667,'Y','18','021','EC','A','','','AC','0000156968','0000156968','OH00002159624','IL','1','BRADFORD','TAFFY','','','','34','291806875','223 GLENKIRK DR',0,'BLACKLICK','OH','43004','9464','CY','39049','1979-11-13','F','U',':RET:2054-5','N','021','DEN','3523904','99734OH005000301','2014-03-01','2014-01-31 09:42:37','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-31 21:00:53'),(1352,1120,'Y','18','021','EC','A','','','AC','0001065056','0001065056','TX00000372754','31','1','Barkley','Timber','','','','34','644187334','Box 714',0,'Gruver','TX','79040',NULL,'CY','48381','1987-10-03','F','U',':RET:2106-3','N','021','DEN','2432240','33348TX002000101','2014-01-01','2013-12-24 12:53:09','0.00',NULL,NULL,'25.02','25.02','R-TX002','TX0','25.02',NULL,0,'2013-12-25 18:45:17'),(19716,15711,'Y','18','021','EC','A','','','AC','0001216282','0001216282','OH00001962838','IL','1','Forfman','Kay','','','','34','385629293','28345 SIMMONS RD',0,'PERRYSBURG','OH','43551','4157','CY','39173','1957-07-27','F','U',NULL,'N','021','HLT','2988633','92036OH004002601','2014-03-01','2014-01-22 19:34:47','0.00',NULL,NULL,'365.79','365.79','R-OH001','OH0','365.79',NULL,0,'2014-01-23 21:00:55'),(2084,1706,'Y','18','021','EC','A','','','AC','0000125376','0000125376','LA00000087471','IL','1','Canterbury','Elizabeth','','','','34','434216690','504 TRACEY CIR',0,'LAFAYETTE','LA','70503','4365','CY','22055','1957-09-19','F','U',':RET:2106-3','N','021','DEN','239017','18575LA002000201','2014-01-01','2013-12-10 11:35:01','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:16:41'),(21835,17437,'Y','18','021','EC','A','','','AC','0000622751','0000622751','TX00002181242','IL','1','Longoria','Crystal','','','','34','631306621','102 DAWNRIDGE DR',0,'SAN ANTONIO','TX','78213','3102','CY','48029','1992-04-20','F','U',NULL,'N','021','DEN','2821450','33348TX002000101','2014-03-01','2014-02-06 16:50:35','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-06 21:01:07'),(2411,1968,'Y','18','021','EC','A','','','AC','0000184915','0000184915','OH00000889504','IL','1','McDermott','Rick','','','','34','294508792','5985 MARSH CIR',0,'LOVELAND','OH','45140','9267','CY','39025','1951-06-03','M','U',':RET:2106-3','N','021','DEN','203261','99734OH005000401','2014-01-01','2013-12-09 15:09:39','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 19:33:44'),(17750,14182,'Y','18','021','EC','A','','','AC','0001007900','0001007900','OH00002273589','IL','1','Shepherd','Ed','','','','34','297604478','104 LONGFELLOW DR',0,'TIFFIN','OH','44883','3224','CY','39147','1962-07-12','M','U',':RET:2106-3','T','021','HLT','2383018','92036OH003002705','2014-02-01','2014-01-13 10:39:03','312.00',NULL,NULL,'436.76','124.76','R-OH006','OH0','436.76',NULL,0,'2014-01-14 01:33:27'),(3450,2774,'Y','18','021','EC','A','','','AC','0000501608','0000501608','OH00001276936','IL','1','Hammond','Hope','','','','34','270905218','180 College Park Drive',0,'Elyria','OH','44053',NULL,'CY','39093','1984-04-23','F','U',':RET:2106-3','N','021','DEN','2273494','99734OH005000401','2014-01-01','2013-12-21 21:50:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:19:28'),(15272,12209,'Y','18','021','EC','A','','','AC','0000988892','0000988892','OH00001664087','IL','1','Keith','Angela','','','','34','290847198','232 BAKER DR',0,'RITTMAN','OH','44270','1302','CY','39169','1970-12-03','F','U',':RET:2106-3','N','021','DEN','2474424','99734OH005000401','2014-02-01','2013-12-31 20:10:53','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,1,'2014-01-02 04:21:50'),(14558,11615,'Y','18','021','EC','A','','','AC','0000022800','0000022800','OH00000343665','IL','1','VAGO','JUDITH','','','','34','286505328','15 EMERSON AVE NW',0,'NORTH CANTON','OH','44720',NULL,'CY','39151','1949-09-10','F','U',':RET:2106-3','N','021','HLT','2123915','52664OH152000901','2014-02-01','2013-12-27 12:01:13','490.00',NULL,NULL,'490.00','0.00','R-OH015','OH0','490.00',NULL,0,'2013-12-28 03:35:12'),(25693,20384,'Y','18','021','EC','A','','','AC','0001022227','0001022227','TX00003211355','IL','1','Parrish','William','E','','','34','466691590','5050 TANGLEWOOD LN',0,'ODESSA','TX','79762','4804','CY','48135','1984-11-25','M','R',':RET:2054-5','N','021','DEN','3150464','33348TX002000201','2014-04-01','2014-02-23 20:44:50','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-02-26 09:30:13'),(29194,23105,'Y','18','021','EC','A','','','AC','0001275681','0001275681','LA00003279075','IL','1','KNAPP','PAULA','','','','34','399524684','23 PARK LANE',0,'FOLSOM','LA','70437',NULL,'CY','22103','1950-04-09','F','M',':RET:2106-3','N','021','DEN','3747399','18575LA002000201','2014-04-01','2014-03-10 17:37:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-03-10 21:30:07'),(268,220,'N','01','021','EC','A',NULL,NULL,'','0000073910','0001210893','','IL','1','Cole','Nancy','','','','34','277526123','43373 HASTINGS RD',0,'OBERLIN','OH','44074','9504','CY','39093','1951-11-17','F','',':RET:2106-3','N','021','HLT','567406','92036OH005000801','2014-01-01','2013-12-05 12:24:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','671.70',NULL,0,'2013-12-25 17:22:00'),(24200,19221,'N','19','021','EC','A',NULL,NULL,'','0000221366','0000101474','','IL','1','Albrinck','Grace','','','','34','280138648','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','2007-05-17','F','',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:18'),(20602,16461,'Y','18','024','14','A','','','TE','0000075214','0000075214','','IL','1','Detrick','Daniel','Harold','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-09-22','M','',NULL,NULL,NULL,'','481303','','2014-01-30','2014-01-30 14:07:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:13'),(15976,12786,'Y','18','021','EC','A','','','AC','0000615028','0000615028','TX00000835485','IL','1','Fuentes','Bryant','','','','34','461795466','1678 Dennis Babjack',0,'El Paso','TX','79936',NULL,'CY','48141','1986-01-27','M','U',NULL,'N','021','DEN','2368490','33348TX002000201','2014-02-01','2014-01-03 00:05:35','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-04 02:00:46'),(5723,4543,'Y','18','021','EC','A','','','AC','0001460337','0001460337','LA00000966541','IL','1','bennett','sheldon','','','','34','438772974','3210 violet st',0,'Alexandria','LA','71301',NULL,'CY','22079','1989-12-11','M','U',':RET:2054-5','N','021','DEN','2208453','18575LA002000201','2014-01-01','2013-12-23 22:06:49','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 23:45:28'),(14013,11163,'Y','18','021','EC','A','','','AC','0000891812','0000891812','OH00000135592','IL','1','GROOMS','DONNA','J','','','34','285502658','638 PANHANDLE AVE',0,'WEST UNION','OH','45693','1237','CY','39001','1951-03-17','F','U',':RET:2106-3','N','021','HLT','2289224','92036OH003000604','2014-01-01','2013-12-23 14:36:01','500.00',NULL,NULL,'644.07','144.07','R-OH005','OH0','644.07',NULL,0,'2013-12-26 13:16:26'),(13622,10861,'Y','18','021','EC','A','','','AC','0001030373','0001030373','OH00000389826','IL','1','Jordan','Matt','','','','34','286863329','386 PARK AVE',0,'OTTAWA','OH','45875','9428','CY','39137','1974-04-15','M','M',':RET:2106-3','N','021','HLT','1896444','92036OH005001506','2014-01-01','2013-12-23 09:19:37','268.88',NULL,NULL,'277.74','8.86','R-OH002','OH0','277.74',NULL,0,'2013-12-26 13:05:53'),(24858,19708,'Y','18','024','14','A','','','TE','0000295545','0000295545','','IL','1','Minnich','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-10-09','F','',NULL,NULL,NULL,'','3229708','','2014-02-19','2014-02-19 16:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 04:56:31'),(1260,1039,'Y','18','021','EC','A','','','AC','0000417368','0000417368','OH00000041575','IL','1','Stumpf','Dennis','','','','34','294527297','PO box 224',0,'Mendon','OH','45862',NULL,'CY','39107','1950-07-14','M','M',':RET:2106-3','N','021','HLT','866816','92036OH002001501','2014-01-01','2013-12-03 14:46:03','0.00',NULL,NULL,'750.27','750.27','R-OH002','OH0','750.27',NULL,0,'2013-12-25 18:21:30'),(7811,6188,'Y','18','021','EC','A','','','AC','0000429384','0000429384','TX00000836337','31','1','KELSEY','BARBARA','','','','34','492603052','5868 WESTHEIMER RD',0,'HOUSTON','TX','77057',NULL,'CY','48201','1951-09-08','F','U',':RET:2106-3','N','021','DEN','2551909','33348TX002000201','2014-01-01','2013-12-20 17:45:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 03:03:57'),(19759,15751,'Y','18','021','EC','A','','','AC','0000414728','0000414728','OH00002192314','IL','1','Dennis','Caitlin','','','','34','277964227','3868 ARLINGTON RD',0,'UNIONTOWN','OH','44685','9604','CY','39153','1993-02-12','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','1462853','99734OH005000301','2014-03-01','2014-01-23 09:44:19','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-23 21:01:22'),(7638,6047,'Y','18','021','EC','A','','','AC','0000164285','0000164285','LA00000190324','IL','1','Briemel','Jacob','','','','34','436892513','214 Lee Street',0,'Pineville','LA','71360',NULL,'CY','22079','1992-11-02','M','U',NULL,'T','021','DEN','942433','18575LA002000201','2014-01-01','2013-10-14 01:04:30','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 02:46:29'),(7204,5708,'Y','18','021','EC','A','','','AC','0000049470','0000049470','OH00001048293','IL','1','Rainey','Lathel','','','','34','298506306','2900 COLONIAL RIDGE CT',0,'CINCINNATI','OH','45212','1904','CY','39061','1950-08-18','F','U',':RET:2054-5','N','021','DEN','871121','99734OH005000401','2014-01-01','2013-12-13 19:13:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:00:43'),(4791,3800,'Y','18','021','EC','A','','','AC','0000229411','0000229411','OH00000235214','IL','1','Bonner','Carlton','','','','34','285663882','900 ELMORE AVE',0,'AKRON','OH','44302','1239','CY','39153','1957-03-27','M','M',':RET:2106-3','N','021','HLT','35841','52664OH151001304','2014-01-01','2013-12-08 13:23:55','958.00',NULL,NULL,'1323.78','365.78','R-OH012','OH0','520.28',NULL,0,'2013-12-25 22:16:18'),(19749,15741,'Y','18','021','EC','A','','','AC','0000006332','0000006332','TX00002525560','IL','1','Kocur','Stacy','','','','34','455450920','3225 McCart Ave',0,'Fort Worth','TX','76110',NULL,'CY','48439','1969-06-24','F','U',NULL,'N','021','DEN','3100152','33348TX002000101','2014-03-01','2014-01-23 15:29:41','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-23 21:01:16'),(6186,4902,'Y','18','021','EC','A','','','AC','0000723767','0000723767','TX00001124011','IL','1','Robinson','Moses','','','','34','554876277','9306 S. Dairy Ashford',0,'Houston','TX','77099',NULL,'CY','48201','1985-09-23','M','U',':RET:2054-5','N','021','DEN','276506','33348TX002000101','2014-01-01','2013-10-22 21:13:44','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 00:30:11'),(19265,15354,'Y','18','021','EC','A','','','AC','0001078785','0001078785','MS00001367181','IL','1','Hill','Hudson','','','','34','428236320','307 MEADOWOOD DR',0,'AMORY','MS','38821','4824','CY','28095','1961-10-22','M','U',':RET:2054-5','N','021','DEN','2804648','46300MS002000201','2014-03-01','2014-01-20 12:38:15','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-21 08:46:51'),(18867,15029,'Y','18','021','EC','A','','','AC','0002084491','0002084491','LA00002481602','IL','1','Ducote','Brenda','','','','34','439330722','801 Kent AVe',0,'Metairie','LA','70001',NULL,'CY','22051','1963-08-16','F','U',NULL,'N','021','DEN','2655728','18575LA002000201','2014-03-01','2014-01-16 10:29:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:22'),(18561,14802,'Y','18','021','EC','A','','','AC','0000221327','0000221327','OH00002454920','IL','1','heyne','doug','e','','Jr','34','299788299','1272 STATE ROUTE 134',0,'SARDINIA','OH','45171','8217','CY','39071','1982-06-23','M','U',':RET:2106-3','N','021','HLT','2271839','92036OH005000605','2014-02-01','2014-01-15 15:59:22','173.00',NULL,NULL,'248.81','75.81','R-OH005','OH0','248.81',NULL,0,'2014-01-16 08:46:59'),(13523,10780,'Y','18','021','EC','A','','','AC','0002061637','0002061637','LA00001181575','IL','1','LYMUEL','JOVAN','C','','','34','437536557','4819 CORONADO DR',0,'NEW ORLANS','LA','70127',NULL,'CY','22071','1983-08-21','M','U',':RET:2054-5','N','021','DEN','2198551','18575LA002000201','2014-01-01','2013-12-23 10:12:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:15'),(13824,11034,'Y','18','021','EC','A','','','AC','0000540298','0000540298','OH00000725383','IL','1','GAY','ANTHONY','REGINALD','','Jr','34','273702177','559 TREESIDE DR',0,'AKRON','OH','44313','5603','CY','39153','1962-06-14','M','U',':RET:2054-5','T','021','HLT','1844932','52664OH152000901','2014-01-01','2013-12-23 00:08:24','263.00',NULL,NULL,'350.32','87.32','R-OH012','OH0','350.32',NULL,0,'2013-12-26 13:11:57'),(14270,11384,'Y','18','021','EC','A','','','AC','0000927260','0000927260','MS00000400074','IL','1','zoukas','sabrina','','','','34','428253722','1360 foxwood pl',0,'goveport','MS','39507',NULL,'CY','28047','1960-02-28','F','U',':RET:2106-3','N','021','DEN','1893011','46300MS002000201','2014-02-01','2013-12-26 12:10:35','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-27 02:06:02'),(15696,12557,'Y','18','021','EC','A','','','AC','0000299259','0000299259','OH00001619980','IL','1','MESSER','RODNEY','L','','Jr','34','285902361','805 W MAIN ST',0,'WILLIAMSBURG','OH','45176','1138','CY','39025','1989-06-02','M','U',':RET:2106-3','N','021','HLT','1647423','92036OH006000601','2014-02-01','2013-12-31 12:25:08','127.00',NULL,NULL,'170.24','43.24','R-OH005','OH0','170.24',NULL,1,'2014-01-02 04:35:32'),(15824,12668,'Y','18','021','EC','A','','','AC','0000932115','0000932115','OH00000615945','IL','1','Jackman','Diane','','','','34','281528350','9336 TOWNSHIP HIGHWAY 121',0,'UPPER SANDUSKY','OH','43351','9797','CY','39175','1963-01-17','F','U',':RET:2106-3','N','021','DEN','1644961','99734OH005000401','2014-02-01','2014-01-02 16:12:26','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-03 02:03:37'),(15971,12782,'Y','18','021','EC','A','','','AC','0000068102','0000068102','TX00001535128','IL','1','ROGERSON','JONEVA','','','','34','449434991','988 RIVERVIEW RD',0,'WACO','TX','76706','7332','CY','48309','1960-12-17','F','U',':RET:2106-3','N','021','DEN','1504964','33348TX002000201','2014-02-01','2014-01-02 19:52:54','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-01-04 02:00:36'),(16236,13002,'Y','18','021','EC','A','','','AC','0000102351','0000102351','TX00000727272','IL','1','Olcheski','Laurie','','','','34','139567716','111 PEACHTREE DR',0,'ROCKPORT','TX','78382','6837','CY','48007','1964-06-22','F','U',NULL,'N','021','DEN','1402055','33348TX002000101','2014-02-01','2014-01-04 07:03:32','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-01-05 00:02:11'),(26676,21149,'Y','18','021','EC','A','','','AC','0001945963','0001945963','LA00002637008','IL','1','Morgan','Lisa','','','','34','263376781','287 HURRICANE CREEK RD',0,'DOWNSVILLE','LA','71234','3419','CY','22111','1959-01-15','F','U',':RET:2106-3','N','021','DEN','2816008','18575LA002000201','2014-04-01','2014-02-28 12:23:11','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-28 21:31:21'),(28442,22505,'Y','18','021','EC','A','','','AC','0001389558','0001389558','LA00002928085','IL','1','HOLMES','JUANITA','','','','34','574025037','1615 CAROL SUE AVE',0,'GRETNA','LA','70056',NULL,'CY','22051','1990-02-13','F','U',':RET:2054-5','N','021','DEN','3970769','18575LA002000201','2014-04-01','2014-03-06 21:06:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:14'),(20300,16205,'Y','18','021','EC','A','','','AC','0001256791','0001256791','LA00002538972','IL','1','LOUIS','SHARON','','','','34','433962696','2009 14TH ST',0,'LAKE CHARLES','LA','70601','7809','CY','22019','1958-08-24','F','U',NULL,'N','021','DEN','2714871','18575LA002000201','2014-03-01','2014-01-28 18:06:34','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-28 21:00:43'),(19773,15763,'Y','18','021','EC','A','','','AC','0000505760','0000505760','OH00001454292','IL','1','Barman','Lynn','','','','34','370787034','149 Baraboo Street',0,'Hamilton','OH','45011',NULL,'CY','39017','1961-10-09','M','U',':RET:2106-3','N','021','HLT','1580418','92036OH004001201','2014-03-01','2014-01-23 16:25:31','279.00',NULL,NULL,'336.93','57.93','R-OH004','OH0','336.93',NULL,0,'2014-01-23 21:01:30'),(13771,10993,'Y','18','021','EC','A','','','AC','0000104383','0000104383','MS00000676705','IL','1','Reed','Mary','Jean','','','34','427064381','4631 N CHAPEL HILL RD',0,'EDWARDS','MS','39066','9174','CY','28049','1957-02-27','F','M',':RET:2054-5','N','021','DEN','2049494','46300MS002000201','2014-01-01','2013-12-23 12:49:48','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:31'),(18596,14826,'Y','18','021','EC','A','','','AC','0000322166','0000322166','OH00002004858','IL','1','Smith','Teresa','D','','','34','478684431','5136 MOUNTVIEW CT',0,'LIBERTY TWP','OH','45011','9274','CY','39017','1952-02-25','F','M',':RET:2054-5','N','021','HLT','1889300','92036OH003001201','2014-02-01','2014-01-15 10:56:07','739.00',NULL,NULL,'1302.49','563.49','R-OH004','OH0','629.96',NULL,0,'2014-01-16 08:47:16'),(18330,14636,'Y','18','024','14','A','','','TE','0000910548','0000910548','','IL','1','VanAlmen','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-01-04','F','',NULL,NULL,NULL,'','2736238','','2014-01-15','2014-01-15 13:47:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:12'),(18338,14644,'Y','18','021','EC','A','','','AC','0000029072','0000029072','OH00001536610','IL','1','PILKINGTON','SCOT','','','','34','280423685','5930 LAKE ROAD WEST',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1959-04-12','M','U',NULL,'N','021','DEN','3017560','99734OH005000401','2014-02-01','2014-01-15 17:45:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:16'),(24404,19385,'Y','18','021','EC','A','','','AC','0000848403','0000848403','OH00001939864','IL','1','JOO','MICHEAL','S','','Sr','34','284566247','541 SHERMAN DR',0,'FRANKLIN','OH','45005','7102','CY','39165','1954-09-07','M','U',':RET:2106-3','T','021','DEN','2726775','99734OH005000401','2014-04-01','2014-02-18 16:35:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:56'),(21776,17390,'Y','18','021','EC','A','','','AC','0001036165','0001036165','OH00001475826','31','1','ZIMMERS','DONALD','','','','34','289644874','PO BOX 136',0,'SEVEN MILE','OH','45062',NULL,'CY','39017','1964-03-30','M','U',':RET:2106-3','N','021','DEN','3666743','99734OH005000401','2014-03-01','2014-02-06 17:03:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:00:35'),(21133,16888,'Y','18','021','EC','A','','','AC','0000823163','0000823163','TX00002100780','IL','1','PAHLAVAN','ABBAS','','','','34','456399563','901 E 26TH ST',0,'HOUSTON','TX','77009','1005','CY','48201','1951-03-01','M','M',':RET:2106-3','N','021','DEN','2673931','33348TX002000201','2014-03-01','2014-02-03 15:47:58','0.00',NULL,NULL,'47.55','47.55','R-TX010','TX0','15.85',NULL,0,'2014-02-03 21:00:19'),(20820,16639,'Y','18','024','14','A','','','TE','0002038948','0002038948','','IL','1','HOWARD','STELLA','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-10','F','',NULL,NULL,NULL,'','1936697','','2014-01-31','2014-01-31 12:51:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-31 21:00:35'),(1550,1293,'Y','18','021','EC','A','','','AC','0000654278','0000654278','MS00000655883','IL','1','Lenaz','Jimmy','','','','34','587483019','1125 dye road',0,'Gulfport','MS','39503',NULL,'CY','28047','1951-07-19','M','U',':RET:2106-3','N','021','DEN','1467712','46300MS002000201','2014-01-01','2013-12-24 10:08:57','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 18:50:35'),(20305,16209,'Y','18','021','EC','A','','','AC','0000248181','0000248181','TX00002246837','IL','1','Black','Kevin','','','','34','467858499','415 Sunset St',0,'Blossom','TX','75416',NULL,'CY','48277','1971-12-24','M','M',':RET:2106-3','N','021','DEN','2895530','33348TX002000201','2014-03-01','2014-01-28 10:47:51','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-28 21:00:46'),(15784,12633,'Y','18','021','EC','A','','','AC','0001721773','0001721773','LA00000298271','IL','1','Nash','Alexander','','','','34','396983101','2514 GRAVIER ST',0,'NEW ORLEANS','LA','70119','7429','CY','22071','1980-12-11','M','U',':RET:2106-3','N','021','DEN','2283499','18575LA002000201','2014-02-01','2014-01-01 23:28:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:14'),(15432,12346,'Y','18','021','EC','A','','','AC','0000968381','0000968381','TX00002067857','IL','1','coleman','laderal','','','','34','459295375','3755 OAK HILL DR',0,'FLINT','TX','75762','6900','CY','48423','1974-09-17','M','U',':RET:2054-5','N','021','DEN','2250703','33348TX002000201','2014-02-01','2013-12-31 12:33:53','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,1,'2014-01-02 04:27:45'),(24533,19486,'N','01','021','EC','A',NULL,NULL,'','0000011603','0000569212','','IL','1','Rodriguez','Ignacio','','','Jr','34','502862729','2512 S INDIA AVE',0,'LAREDO','TX','78046','6947','CY','48479','1960-04-09','M','',':RET:2106-3','T','021','DEN','2738101','33348TX002000201','2014-04-01','2014-02-19 16:53:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 04:00:52'),(27508,21763,'N','19','021','EC','A',NULL,NULL,'','0000851896','0000484856','','IL','1','Gupta','Reena','Rose','','','34','827247915','2450 UNDERHILL RD',0,'OTTAWA HILLS','OH','43615','2332','CY','39095','2013-12-27','F','',':RET:2029-7^:RET:2106-3','N','021','HLT','3948896','92036OH004002601','2014-04-01','2014-03-04 15:10:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-04 21:02:32'),(23315,18584,'N','19','021','EC','A',NULL,NULL,'','0000416004','0000901112','','IL','1','OVIAHON','ELIJAH','','','','34','279049897','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1999-05-10','M','',':RET:2054-5','N','021','DEN','3381743','99734OH005000301','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:22'),(3937,3151,'Y','18','021','EC','A','','','AC','0001020401','0001020401','OH00000137724','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',NULL,'N','021','HLT','1006471','92036OH005000506','2014-01-01','2013-12-13 09:01:25','397.00',NULL,NULL,'424.53','27.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 21:37:48'),(23261,18546,'Y','18','021','EC','A','','','AC','0000600455','0000600455','TX00002454126','IL','1','PURIFOY','MARCIE','','','','34','422153395','2705 BERMUDA DR',0,'KILLEEN','TX','76549','8204','CY','48027','1970-12-10','F','U',NULL,'N','021','DEN','3706755','33348TX002000201','2014-03-01','2014-02-13 15:21:32','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61','CIC',0,'2014-02-13 21:30:09'),(5890,4670,'Y','18','021','EC','A','','','AC','0000422822','0000422822','OH00000630915','IL','1','Maxey','Dean','','','','34','276548147','10764 HOEL RD',0,'CAMDEN','OH','45311','8651','CY','39135','1953-08-01','M','M',':RET:2106-3','N','021','DEN','1785818','99734OH005000301','2014-01-01','2013-12-23 22:44:15','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:49:35'),(20918,16719,'N','01','021','EC','A',NULL,NULL,'','0000793499','0000619670','','IL','1','Small','Robert','','','','34','293601733','3401 CURTIS ST',0,'MOGADORE','OH','44260','1009','CY','39153','1970-06-03','M','',':RET:2106-3','T','021','HLT','3571998','52664OH152000901','2014-03-01','2014-01-31 15:26:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','254.90',NULL,0,'2014-01-31 21:01:31'),(6989,5546,'Y','18','021','EC','A','','','AC','0000148342','0000148342','OH00001748014','IL','1','dimarco','marco','','','','34','276444597','3382 palm hill lane',0,'cincinnati','OH','45239',NULL,'CY','39061','1964-02-26','M','U',':RET:2106-3','N','021','DEN','2170577','99734OH005000401','2014-02-01','2013-12-25 12:42:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:56'),(27083,21441,'N','01','021','EC','A',NULL,NULL,'','0001231833','0000500452','','IL','1','Wright','James','Lewis','','','34','301801273','1845 BEECH RD',0,'STOW','OH','44224','3912','CY','39153','1969-04-24','M','',':RET:2106-3','N','021','HLT','2885542','52664OH151001304','2014-04-01','2014-03-03 07:27:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-03-03 21:30:12'),(1702,1421,'Y','18','021','EC','A','','','AC','0000108156','0000108156','OH00001287340','IL','1','Hopkins','Lorie','','','','34','274503968','2336 Tremainsville Road',0,'Toledo','OH','43613',NULL,'CY','39095','1957-06-12','F','M',NULL,'N','021','HLT','2179521','92036OH001002601','2014-01-01','2013-12-24 12:13:32','0.00',NULL,NULL,'548.73','548.73','R-OH001','OH0','548.73',NULL,0,'2013-12-25 18:54:45'),(22806,18202,'Y','18','021','EC','A','','','AC','0000382207','0000382207','OH00002285829','IL','1','Niblock','Samuel','','','','34','555138346','5435 EDALBERT DR',0,'CINCINNATI','OH','45239','7603','CY','39061','1961-11-22','M','M',NULL,'N','021','DEN','2643948','99734OH005000301','2014-03-01','2014-02-11 13:41:40','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:55'),(3942,3156,'Y','18','021','EC','A','','','AC','0000876039','0000876039','OH00000391925','IL','1','Smith','Ethel','','','','34','291489729','1554 Avondale Ave',0,'Toledo','OH','43607',NULL,'CY','39095','1951-06-25','F','U',NULL,'N','021','HLT','957456','92036OH006002601','2014-01-01','2013-12-13 11:09:13','359.00',NULL,NULL,'444.29','85.29','R-OH001','OH0','444.29',NULL,0,'2013-12-25 21:37:57'),(22393,17880,'N','01','021','EC','A',NULL,NULL,'','0001181063','0001248374','','IL','1','TEMPLE','ASHELEY','','','','34','592428847','1843 SEDRO ST',0,'CUYAHOGA FALLS','OH','44221','5242','CY','39153','1984-12-26','F','',':RET:2106-3','N','021','HLT','3661657','52664OH151001305','2014-03-01','2014-02-10 13:32:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.55',NULL,0,'2014-02-10 21:30:16'),(7725,6118,'Y','18','021','EC','A','','','AC','0000385892','0000385892','OH00000778338','IL','1','Berry','Barbara','','','','34','275541055','800 LONG ST',0,'ASHVILLE','OH','43103','9346','CY','39129','1952-07-31','F','U',':RET:2106-3','N','021','DEN','2360963','99734OH005000401','2014-01-01','2013-12-20 14:23:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:01:50'),(14103,11239,'Y','18','021','EC','A','','','AC','0000081292','0000081292','OH00001463080','IL','1','jones','deborah','','','','34','294687306','425 heather lane',0,'medina','OH','44256',NULL,'CY','39103','1961-07-01','F','U',':RET:2106-3','N','021','DEN','2098954','99734OH005000401','2014-02-01','2013-12-26 13:01:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:01:38'),(19740,15732,'Y','18','021','EC','A','','','AC','0001583873','0001583873','LA00001715545','IL','1','Johnson','Alice','','','','34','435110112','11848 DUNN LN',0,'CLINTON','LA','70722','4463','CY','22037','1959-01-29','F','M',':RET:2054-5','N','021','DEN','2628438','18575LA002000201','2014-03-01','2014-01-23 15:47:04','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-23 21:01:10'),(15648,12518,'Y','18','021','EC','A','','','AC','0000984234','0000984234','MS00002050756','IL','1','COLEMAN','FELISSA','','','','34','425084634','63 SULLIVAN KILRAIN RD',0,'HATTIESBURG','MS','39402','8040','CY','28035','1957-12-28','F','M',NULL,'N','021','DEN','2208692','46300MS002000201','2014-02-01','2013-12-31 13:44:15','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,1,'2014-01-02 04:34:00'),(16360,13092,'Y','18','021','EC','A','','','AC','0000880531','0000880531','OH00001961290','IL','1','Siegfried','Windy','','','','34','530212989','12503 PARKHILL AVE',0,'CLEVELAND','OH','44120','3055','CY','39035','1971-01-10','F','U',':RET:1002-5^:RET:2054-5^:RET:2079-2^:RET:2106','N','021','DEN','1533597','99734OH005000301','2014-02-01','2014-01-06 17:08:25','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-07 04:02:43'),(16386,13111,'N','01','021','EC','A',NULL,NULL,'','0000978851','0000931262','','IL','1','hoang','truc','','','','34','490847979','2915 GAINESBOROUGH DR',0,'DALLAS','TX','75287','3486','CY','48121','1958-02-11','F','',':RET:2047-9','N','021','DEN','2368545','33348TX002000201','2014-02-01','2014-01-05 23:18:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-07 04:03:26'),(16946,13563,'Y','18','021','EC','A','','','AC','0001272883','0001272883','LA00002431077','IL','1','Williams','Desirea','','','','34','439798291','5483 HOWELL PARK AVE',0,'BATON ROUGE','LA','70805','6234','CY','22033','1990-11-22','F','U',':RET:2054-5','N','021','DEN','2036022','18575LA002000201','2014-02-01','2014-01-09 17:30:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:19:57'),(19502,15543,'Y','18','021','EC','A','','','AC','0000114231','0000114231','OH00002234253','IL','1','Klein','Susan','','','','34','298482000','128 North State St',0,'Rittman','OH','44270',NULL,'CY','39169','1951-04-07','F','M',NULL,'N','021','HLT','1477195','52664OH151001305','2014-03-01','2014-01-22 12:43:17','478.00',NULL,NULL,'640.70','162.70','R-OH014','OH0','640.70',NULL,0,'2014-01-23 03:02:11'),(25114,19922,'Y','18','024','14','A','','','TE','0001078769','0001078769','','IL','1','McCain','Zachary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-19','M','',NULL,NULL,NULL,'','1936133','','2014-03-31','2014-02-21 16:03:00',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-21 21:30:17'),(171,142,'N','19','021','EC','A',NULL,NULL,'','0000635981','0000611932','','IL','1','Votaw','Emily','','','','34','296942851','4891 W Main St',0,'Berlin','OH','44610',NULL,'CY','39075','1992-04-29','F','',':RET:2106-3','N','021','HLT','469132','52664OH151001305','2014-01-01','2013-12-04 21:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-25 17:19:26'),(738,611,'N','01','021','EC','A',NULL,NULL,'','0000516678','0000925072','','IL','1','Hoffman','Jessica','Leann','','','34','642368113','4800 Brookdale Dr.',0,'Wichita Falls','TX','76310',NULL,'CY','48485','1988-01-02','F','',':RET:2106-3','N','021','DEN','830002','33348TX002000201','2014-01-01','2013-12-15 20:49:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:03:58'),(13262,10584,'Y','18','021','EC','A','','','AC','0001059791','0001059791','TX00000901353','IL','1','Zavala','Jose','L','','','34','579984048','1812 SH 75 N',0,'Huntsville','TX','77320',NULL,'CY','48471','1950-04-20','M','M',':RET:2106-3','N','021','DEN','1881831','33348TX002000201','2014-01-01','2013-12-23 12:10:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:41'),(764,631,'Y','18','021','EC','A','','','AC','0000923608','0000923608','TX00000647624','IL','1','Castro','Elisa',NULL,NULL,NULL,NULL,NULL,'2910 S. Highland',0,'Amarillo','TX','79103',NULL,'CY','48381','1959-10-26','F','M',NULL,'N','021','DEN','1934793','33348TX002000201','2014-01-01','2013-12-16 11:55:11','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 18:04:39'),(22544,18002,'Y','18','021','EC','A','','','AC','0002091948','0002091948','LA00002310873','IL','1','ROWTON','CANDIE','','','','34','434738316','841 SAM HEAD RD',0,'EROS','LA','71238','8448','CY','22073','1976-01-22','F','M',':RET:2106-3','N','021','DEN','3519032','18575LA002000101','2014-03-01','2014-02-10 12:13:31','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2014-02-10 21:31:41'),(22415,17898,'Y','18','021','EC','A','','','AC','0002188711','0002188711','LA00002097443','IL','1','MONTERROSO','MANUEL','','','','34','434572536','648 MORNINGSIDE DR',0,'TERRYTOWN','LA','70056','2906','CY','22051','1958-10-16','M','M',NULL,'N','021','DEN','2713006','18575LA002000201','2014-03-01','2014-02-10 13:26:46','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:28'),(21343,17057,'N','01','021','EC','A',NULL,NULL,'','0000440765','0000995121','','IL','1','Halladay','Mathew','Louis','','','34','451916723','2105 singing Wind Dr',0,'Kerrville','TX','78028',NULL,'CY','48265','1987-09-09','M','',':RET:2106-3','T','021','DEN','2747941','33348TX002000201','2014-03-01','2014-02-03 21:49:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-04 21:00:33'),(18636,14855,'Y','18','021','EC','A','','','AC','0000079537','0000079537','TX00001750056','31','1','Velasquez','Jackeline','','','','34','639164465','2471 Elizabeth Circle',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1989-08-31','F','U',':RET:2106-3','N','021','DEN','2930778','33348TX002000201','2014-02-01','2014-01-15 22:05:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:04'),(18620,14844,'Y','18','021','EC','A','','','AC','0000091172','0000091172','OH00001830898','IL','1','Greathouse','Cynthia','','','','34','280507474','33 FRANKLIN AVE',0,'NILES','OH','44446','5116','CY','39155','1950-04-14','F','M',':RET:2106-3','N','021','HLT','2099483','92036OH004003201','2014-02-01','2014-01-15 14:57:13','507.00',NULL,NULL,'574.54','67.54','R-OH013','OH0','574.54',NULL,0,'2014-01-16 08:47:27'),(15591,12477,'N','19','021','EC','A',NULL,NULL,'','0001063253','0001071789','','S1','1','mcguire','david','','','','34','299029570','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1998-06-22','M','',NULL,'N','021','DEN','2167311','99734OH005000301','2014-02-01','2013-12-31 10:46:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:26'),(3896,3118,'N','01','021','EC','A',NULL,NULL,'','0000278304','0000165057','','IL','1','Piesciuk','Delores',NULL,NULL,NULL,NULL,NULL,'3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-09-11','F','',':RET:2106-3','N','021','HLT','550746','52664OH152000901','2014-01-01','2013-12-13 14:24:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2013-12-25 21:36:44'),(573,469,'N','19','021','EC','A',NULL,NULL,'','0000639489','0000775067','','IL','1','Wagner','Lucy','','','','34','275173161','2106 KNIGHTSBRIDGE DR',0,'CINCINNATI','OH','45244','2629','CY','39061','2011-03-23','F','',':RET:2106-3','N','021','HLT','1123905','92036OH005001201','2014-01-01','2013-12-03 23:11:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 17:50:39'),(1968,1607,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','821707','','2013-11-19','2013-11-19 23:00:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:24'),(24107,19164,'N','01','021','EC','A',NULL,NULL,'','0001037890','0000520547','','IL','1','LALUMIA','CONSTANCE','','','','34','110461940','9304 LOCARNO DR',0,'DALLAS','TX','75243','7218','CY','48113','1952-11-05','F','',':RET:2106-3','N','021','DEN','3215683','33348TX002000201','2014-03-01','2014-02-14 19:14:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-15 22:01:34'),(22170,17693,'Y','18','024','14','A','','','TE','0000545205','0000545205','','IL','1','CARNAHAN','PAMELA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-04','F','',NULL,NULL,NULL,'','1063385','','2014-02-28','2014-02-07 18:33:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-08 19:30:03'),(20262,16168,'N','19','021','EC','A',NULL,NULL,'','0000768911','0000899598','','IL','1','Mayberry','Shalimar',NULL,NULL,NULL,NULL,NULL,'1434 HARVARD BLVD',0,'DAYTON','OH','45406','5960','CY','39113','1999-06-10','F','',':RET:2054-5','N','021','DEN','2111747','99734OH005000301','2014-03-01','2014-01-27 22:50:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-28 21:00:19'),(5860,4653,'Y','18','021','EC','A','','','AC','0000186118','0000186118','OH00001270746','IL','1','Harper','Randal','','','','34','282788666','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1968-03-04','M','M',':RET:2106-3','N','021','HLT','1829936','92036OH005002606','2014-01-01','2013-12-24 00:09:12','500.00',NULL,NULL,'953.14','453.14','R-OH001','OH0','281.58',NULL,0,'2013-12-25 23:49:01'),(14926,11926,'N','01','021','EC','A',NULL,NULL,'','0000303377','0001044486','','IL','1','Swartz','Patricia','','','','34','287548111','8083 CLEARMEADOW DR',0,'WEST CHESTER','OH','45069','6809','CY','39017','1954-12-30','F','',':RET:2106-3','N','021','HLT','2547549','92036OH004001201','2014-02-01','2013-12-28 19:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','449.32',NULL,0,'2013-12-30 00:01:50'),(18339,14645,'Y','18','021','EC','A','','','AC','0000514473','0000514473','OH00002369494','IL','1','Bourn','Roy','','','','34','297683419','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1975-06-25','M','M',':RET:2106-3','N','021','DEN','2732603','99734OH005000401','2014-02-01','2014-01-15 17:50:01','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:16'),(18222,14543,'Y','18','021','EC','A','','','AC','0000992512','0000992512','TX00001992393','IL','1','MAGANO','LUIS','','','','34','556258606','3202 SPARKS RD',0,'BAY CITY','TX','77414','9218','CY','48321','1951-12-13','M','M',NULL,'N','021','DEN','2895264','33348TX002000201','2014-02-01','2014-01-14 19:34:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:14'),(22610,18056,'Y','18','021','EC','A','','','AC','0000751355','0000751355','TX00001689414','IL','1','Pounds','Phillip','','','','34','633107794','2104 East Anderson Lane',0,'Austin','TX','78752',NULL,'CY','48453','1987-12-12','M','U',':RET:2106-3','T','021','DEN','3530667','33348TX002000201','2014-03-01','2014-02-11 18:07:34','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-11 21:00:04'),(19736,15729,'Y','18','021','EC','A','','','AC','0002268065','0002268065','LA00002573508','IL','1','SMITH','DEBBIE','','','','34','438133616','111 MAYS DR',0,'MONROE','LA','71202','7213','CY','22073','1958-11-20','F','M',NULL,'N','021','DEN','2793326','18575LA002000201','2014-03-01','2014-01-23 14:52:15','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-23 21:01:08'),(19460,15512,'Y','18','021','EC','A','','','AC','0000857133','0000857133','TX00001569344','IL','1','Maserang','Shaun','','','','34','514046607','5625 126TH ST',0,'LUBBOCK','TX','79424','6226','CY','48303','1991-01-05','M','U',':RET:2039-6^:RET:2106-3','N','021','DEN','3097913','33348TX002000201','2014-03-01','2014-01-21 22:13:49','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-23 03:01:56'),(5646,4479,'Y','18','021','EC','A','','','AC','0000372978','0000372978','TX00000284537','IL','1','Cox','Patrick','','','','34','405275313','901 LAKESIDE CIR',0,'LEWISVILLE','TX','75057','5052','CY','48121','1975-11-21','M','U',':RET:2106-3','N','021','DEN','339375','33348TX002000201','2014-01-01','2013-11-26 11:37:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:31:22'),(3188,2564,'Y','18','021','EC','A','','','AC','0000854155','0000854155','OH00001055753','IL','1','olowu-briggs','clementine','','','','34','587242140','2440 noble road',0,'cleveland heights','OH','44121',NULL,'CY','39035','1950-02-10','F','U',':RET:2054-5','N','021','HLT','408111','92036OH003000805','2014-01-01','2013-11-18 12:44:43','511.00',NULL,NULL,'720.74','209.74','R-OH011','OH0','720.74',NULL,0,'2013-12-25 20:32:03'),(17603,14071,'Y','18','021','EC','A','','','AC','0000225988','0000225988','TX00002311562','IL','1','LY','DUC','','','','34','608547911','8308 SHALLOT WAY',0,'AUSTIN','TX','78748','1046','CY','48453','1969-05-10','M','M',':RET:2047-9','N','021','DEN','1790110','33348TX002000201','2014-02-01','2014-01-12 19:39:09','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:17'),(15380,12303,'Y','18','021','EC','A','','','AC','0001104451','0001104451','OH00001775080','IL','1','Keethler','Scott','','','','34','284808632','2393 FERGUSON RD',0,'CINCINNATI','OH','45238','3502','CY','39061','1981-10-07','M','U',':RET:2106-3','T','021','HLT','1486569','92036OH006001201','2014-02-01','2014-01-01 16:59:18','74.00',NULL,NULL,'231.61','157.61','R-OH004','OH0','231.61',NULL,1,'2014-01-02 04:25:23'),(15424,12339,'Y','18','021','EC','A','','','AC','0000179377','0000179377','TX00001025126','IL','1','JENKINS','ANDREW','BERNARD','','','34','454790693','3755 OAK HILL DR',0,'FLINT','TX','75762','6900','CY','48423','1984-07-27','M','U',':RET:2054-5','N','021','DEN','2066119','33348TX002000201','2014-02-01','2013-12-31 11:41:15','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,1,'2014-01-02 04:27:33'),(15845,12688,'Y','18','021','EC','A','','','AC','0001030384','0001030384','OH00000438044','IL','1','Morris','Christopher','','','','34','289862629','7680 Clearcreek Ct.',0,'Blacklick','OH','43004',NULL,'CY','39049','1971-10-06','M','U',':RET:2106-3','N','021','DEN','1737906','99734OH005000401','2014-02-01','2014-01-02 17:21:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:04:16'),(15609,12485,'Y','18','021','EC','A','','','AC','0000184952','0000184952','OH00000245132','IL','1','WALKER','LARRY','','','','34','297647657','3926 HOOVER AVE',0,'DAYTON','OH','45402','5235','CY','39113','1958-12-15','M','U',NULL,'N','021','DEN','2564826','99734OH005000301','2014-02-01','2013-12-31 17:18:14','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,1,'2014-01-02 04:32:45'),(20509,16386,'Y','18','021','EC','A','','','AC','0002112199','0002112199','LA00001673743','IL','1','Barney','Marilyn','','','','34','447641881','3636 Greenacres Pl Dr',0,'Bossier City','LA','71111',NULL,'CY','22015','1958-07-27','F','U',':RET:2106-3','N','021','DEN','3232759','18575LA002000201','2014-03-01','2014-01-29 16:59:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-29 21:01:17'),(20942,16735,'N','01','021','EC','A',NULL,NULL,'','0000780544','0000287128','','IL','1','Patel','Bhavesh','B','','','34','309927079','1839 CLOUGH PIKE',0,'BATAVIA','OH','45103','2621','CY','39025','1971-09-27','M','',':RET:2029-7','N','021','HLT','3477931','92036OH003000604','2014-03-01','2014-01-31 16:20:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.05',NULL,0,'2014-01-31 21:01:43'),(26130,20723,'Y','18','021','EC','A','','','AC','0001241921','0001241921','OH00002515478','S3','1','Carmichael','Shelley','L','','','34','283062113','3033 INDIAN RIPPLE RD',0,'BEAVERCREEK','OH','45440','3644','CY','39057','2001-06-29','M','U',':RET:2106-3','N','021','DEN','3781819','99734OH005000401','2014-03-01','2014-02-27 11:53:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-02-28 06:30:22'),(27275,21598,'Y','18','021','EC','A','','','AC','0001210991','0001210991','TX00002899002','IL','1','TAYLOR','SHERRY','','','','34','466909397','634 COUNTY ROAD 146',0,'OVALO','TX','79541','2514','CY','48441','1952-08-23','F','U',':RET:2106-3','N','021','DEN','3469988','33348TX002000201','2014-04-01','2014-03-03 19:54:26','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-03-04 21:00:18'),(9660,7653,'Y','18','024','14','A','','','TE','0000933185','0000933185','','IL','1','PIOTROWSKI','WILLIAM','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-29','M','',NULL,NULL,NULL,'','873472','','2013-12-21','2013-12-21 06:38:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:38:58'),(7796,6174,'Y','18','021','EC','A','','','AC','0000316713','0000316713','TX00001019848','IL','1','King','Carol','','','','34','585583012','502 N 8TH ST',0,'ALPINE','TX','79830','3402','CY','48043','1952-12-15','F','U',':RET:2106-3','T','021','DEN','2525642','33348TX002000201','2014-01-01','2013-12-20 15:40:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:32'),(2466,2006,'N','01','021','EC','A',NULL,NULL,'','0000842837','0000477160','','IL','1','sibille','brent','','','','34','434575354','5719 HIGHWAY 14 E',0,'IOWA','LA','70647','5205','CY','22019','1982-10-13','M','',':RET:2106-3','N','021','DEN','678179','18575LA002000101','2014-01-01','2013-12-09 15:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 19:35:05'),(7099,5630,'N','01','021','EC','A',NULL,NULL,'','0000194050','0000599760','','IL','1','Taylor','Brian','','','','34','272863807','427 S. Prospect',0,'Medina','OH','44256',NULL,'CY','39103','1983-03-22','M','',':RET:2106-3','N','021','HLT','1598503','52664OH151001305','2014-01-01','2013-12-24 23:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11',NULL,0,'2013-12-26 01:50:43'),(5714,4536,'N','01','021','EC','A',NULL,NULL,'','0000575924','0000921921','','IL','1','Lewis','Lenora','L','','','34','276801865','773 Marie Ave',0,'Akron','OH','44314',NULL,'CY','39153','1981-10-20','F','',':RET:2054-5','N','021','HLT','2276578','52664OH151001306','2014-01-01','2013-12-23 23:16:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','263.82',NULL,0,'2013-12-25 23:45:14'),(4233,3370,'Y','18','021','EC','A','','','AC','0000094693','0000094693','TX00000775597','IL','1','Norman','Natalie','','','','34','457896295','3423 TIDEWATER DR',0,'HOUSTON','TX','77045','4529','CY','48201','1977-11-13','F','U',':RET:2054-5','N','021','DEN','2123314','33348TX002000201','2014-01-01','2013-12-17 13:13:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:50:45'),(5992,4744,'Y','18','021','EC','A','','','AC','0001166773','0001166773','OH00000985716','IL','1','Miller','Charles','Richard','','','34','280480974','124 W HIGH ST',0,'HICKSVILLE','OH','43526','1065','CY','39039','1950-11-05','M','M',':RET:2106-3','N','021','HLT','35475','92036OH004002601','2014-01-01','2013-12-01 10:07:37','449.00',NULL,NULL,'462.84','13.84','R-OH001','OH0','462.84',NULL,0,'2013-12-26 00:00:05'),(6139,4868,'Y','18','024','14','A','','','TE','0000313846','0000313846','','IL','1','MacDougall','Glenn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-07-23','M','',NULL,NULL,NULL,'','140323','','2013-11-21','2013-11-21 17:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 00:16:12'),(23162,18465,'Y','18','021','EC','A','','','AC','0001070405','0001070405','TX00002652866','IL','1','Aldredge','Alana','','','','34','633039299','929 CHEYENNE TRL',0,'HEWITT','TX','76643','3288','CY','48309','1988-02-20','F','U',NULL,'N','021','DEN','3847198','33348TX002000101','2014-03-01','2014-02-12 15:59:24','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2014-02-12 21:31:48'),(27754,21948,'Y','18','021','EC','A','','','AC','0001408607','0001408607','LA00002698984','IL','1','ROBINSON','SHERIANA','','','','34','434370074','4709 AVENUE A',0,'ZACHARY','LA','70791','3303','CY','22033','1965-05-18','F','U',':RET:2054-5','N','021','DEN','3002978','18575LA002000201','2014-04-01','2014-03-05 10:09:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:17'),(29206,23113,'Y','18','021','EC','A','','','AC','0000640905','0000640905','OH00002934117','IL','1','Moore','Vena','','','','34','277482609','3407 OAK ALLEY CT',0,'TOLEDO','OH','43606','1331','CY','39095','1950-01-15','F','U',NULL,'N','021','HLT','3967125','92036OH004002601','2014-04-01','2014-03-10 12:38:38','273.00',NULL,NULL,'470.37','197.37','R-OH001','OH0','470.37','CIC',0,'2014-03-10 21:30:12'),(13507,10765,'Y','18','021','EC','A','','','AC','0001343045','0001343045','LA00001103611','IL','1','tran','mai','','','','34','433618947','837 Morningside drive',0,'gretna','LA','70056',NULL,'CY','22051','1959-03-23','F','U',':RET:2047-9','N','021','DEN','2444592','18575LA002000201','2014-01-01','2013-12-22 21:20:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:02:47'),(6448,5112,'N','19','021','EC','A',NULL,NULL,'','0000987374','0001053033','','IL','1','King','Samantha','','','','34','280967227','468 E MAIN ST',0,'PORTAGE','OH','43451','9701','CY','39173','1993-05-01','F','',':RET:2106-3','N','021','HLT','843910','92036OH004002601','2014-01-01','2013-12-10 22:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-26 00:49:37'),(20058,15998,'Y','18','024','14','A','','','TE','0000028447','0000028447','','IL','1','HOLMES','BOBBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-06-27','M','',NULL,NULL,NULL,'','3003186','','2014-01-27','2014-01-27 11:20:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:09'),(5273,4179,'N','01','021','EC','A',NULL,NULL,'','0000696804','0000226014','','IL','1','Vaccaro','Raphael','M','','','34','299522921','2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','1964-12-22','M','',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45',NULL,0,'2013-12-25 23:05:34'),(2247,1844,'N','01','021','EC','A',NULL,NULL,'','0001044459','0001100577','','IL','1','Massie','Robert','','','','34','245881979','2891 LAYER RD SW',0,'WARREN','OH','44481','9161','CY','39155','1953-02-21','M','',':RET:2054-5','T','021','HLT','77876','92036OH005003206','2014-01-01','2013-12-10 17:04:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','755.46',NULL,0,'2013-12-25 19:21:09'),(16221,12991,'Y','18','021','EC','A','','','AC','0000396177','0000396177','OH00000125646','IL','1','campbell','rebecca','jo','','','34','279861984','3756 MIDDLEBROOK AVE',0,'CINCINNATI','OH','45208','1119','CY','39061','1979-03-08','F','M',NULL,'N','021','DEN','2585646','99734OH005000401','2014-02-01','2014-01-03 22:22:09','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-05 00:01:49'),(2655,2158,'Y','18','021','EC','A','','','AC','0000649346','0000649346','OH00001274871','IL','1','Pardo','Sara','','','','34','273889991','960 EASTMAN ST',0,'ZANESVILLE','OH','43701','4008','CY','39119','1982-04-22','F','U',NULL,'N','021','DEN','947742','99734OH005000301','2014-01-01','2013-12-01 19:58:57','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 19:46:43'),(4488,3558,'Y','18','021','EC','A','','','AC','0000287077','0000287077','OH00000424249','IL','1','Leyda','George','','','','34','278486753','102 W WOOD ST',0,'MALVERN','OH','44644','9401','CY','39019','1950-02-16','M','M',':RET:2106-3','N','021','DEN','753509','99734OH005000301','2014-01-01','2013-12-12 15:50:07','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 22:03:04'),(21007,16786,'Y','18','021','EC','A','','','AC','0001587670','0001587670','LA00002596055','IL','1','Kenard','Robert','','','','34','336466444','4535 LONGFELLOW DR',0,'NEW ORLEANS','LA','70127','4105','CY','22071','1950-07-02','M','U',NULL,'N','021','DEN','3166172','18575LA002000101','2014-03-01','2014-02-01 14:07:47','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-01 19:00:32'),(23078,18401,'Y','18','021','EC','A','','','AC','0000854237','0000854237','OH00002527280','IL','1','Kossick','Kevin','','','','34','278828943','103 HALL ST',0,'AKRON','OH','44303','2117','CY','39153','1966-09-03','M','M',':RET:2106-3','N','021','HLT','3174177','52664OH151001501','2014-03-01','2014-02-11 19:43:42','0.00',NULL,NULL,'895.74','895.74','R-OH012','OH0','418.05',NULL,0,'2014-02-12 21:31:01'),(26580,21074,'Y','18','021','EC','A','','','AC','0000869342','0000869342','OH00002926722','IL','1','Jahn','Charles','James','','','34','291981694','7725 JOLAIN DR',0,'MONTGOMERY','OH','45242','6315','CY','39061','1995-10-10','M','U',':RET:2106-3','N','021','DEN','3233470','99734OH005000401','2014-03-01','2014-02-28 13:42:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-28 21:30:30'),(28901,22875,'N','01','021','EC','A',NULL,NULL,'','0000749402','0000275395','','IL','1','VILLASENOR','MARCO','A','','','34','356649439','613 E ARAPAHO AVE',0,'PHARR','TX','78577','8137','CY','48215','1962-01-04','M','',NULL,'N','021','DEN','3656256','33348TX002000201','2014-04-01','2014-03-10 16:37:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-10 21:00:21'),(4750,3765,'Y','18','021','EC','A','','','AC','0000976337','0000976337','TX00000304722','IL','1','campos','james','','','','34','461060590','1411 GRISSOM LN',0,'EL PASO','TX','79903','2309','CY','48141','1955-03-31','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','417202','33348TX002000201','2014-01-01','2013-12-08 08:41:42','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 22:15:10'),(7280,5773,'Y','18','024','14','A','','','TE','0000775711','0000775711','','IL','1','Hallett','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-26','M','',NULL,NULL,NULL,'','56084','','2013-12-14','2013-12-14 17:31:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 02:02:40'),(18597,14826,'N','01','021','EC','A',NULL,NULL,'','0000322166','0000432783','','IL','1','Smith','Richard','','','','34','480641123','5136 MOUNTVIEW CT',0,'LIBERTY TWP','OH','45011','9274','CY','39017','1949-09-03','M','',':RET:2054-5','N','021','HLT','1889300','92036OH003001201','2014-02-01','2014-01-15 10:56:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','672.53',NULL,0,'2014-01-16 08:47:16'),(14965,11961,'Y','18','021','EC','A','','','AC','0000285556','0000285556','TX00000711645','IL','1','RATLIFF','THELMA','','','','34','438767231','1505 W GRANDE BLVD',0,'TYLER','TX','75703','5692','CY','48423','1951-01-16','F','U',':RET:2106-3','N','021','DEN','1918799','33348TX002000201','2014-02-01','2013-12-30 11:22:03','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-01 12:00:37'),(15433,12347,'Y','18','021','EC','A','','','AC','0001230793','0001230793','TX00000735086','IL','1','WILLIS','WILLIAM','C','','','34','567137966','611 SW 1ST ST',0,'MINERAL WELLS','TX','76067',NULL,'CY','48363','1959-09-09','M','U',':RET:2106-3','N','021','DEN','2237160','33348TX002000201','2014-02-01','2013-12-31 12:35:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:48'),(20975,16761,'Y','18','024','14','A','','','TE','0000708738','0000708738','','IL','1','Gibbs','christoyua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-03-30','F','',NULL,NULL,NULL,'','2642295','','2014-02-01','2014-02-01 12:59:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-01 19:00:17'),(24203,19221,'N','01','021','EC','A',NULL,NULL,'','0000221366','0000141554','','IL','1','Hartman','Angela','','','','34','403083156','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','1970-05-15','F','',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:18'),(27031,21409,'Y','18','021','EC','A','','','AC','0001065207','0001065207','TX00002626258','IL','1','CISNEROS','ALBA','','','','34','456938640','440 BROTHERS RD',0,'CANUTILLO','TX','79835','6205','CY','48141','1957-09-21','F','U',NULL,'N','021','DEN','3057644','33348TX002000201','2014-04-01','2014-03-03 14:13:21','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61','CIC',0,'2014-03-03 21:00:16'),(27151,21496,'Y','18','021','EC','A','','','AC','0001022847','0001022847','OH00002687356','IL','1','DANIELS','NORMA','JEAN','','','34','362581904','2716 LAFEUILLE CIR',0,'CINCINNATI','OH','45211','8249','CY','39061','1953-09-04','F','U',':RET:2054-5','N','021','DEN','3476480','99734OH005000401','2014-04-01','2014-03-03 14:10:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:52'),(27745,21939,'Y','18','021','EC','A','','','AC','0000290862','0000290862','OH00002790684','IL','1','Miller','Jeanne','','','','34','285668039','847 WELSTED ST',0,'NAPOLEON','OH','43545','1332','CY','39069','1960-01-13','F','U',':RET:2106-3','N','021','HLT','4068594','92036OH004002601','2014-04-01','2014-03-05 13:38:21','229.00',NULL,NULL,'334.75','105.75','R-OH001','OH0','334.75',NULL,0,'2014-03-05 21:31:11'),(205,170,'Y','18','021','EC','A','','','AC','0000219950','0000219950','OH00001044126','IL','1','Solomon','Gary','Alan','','','34','300544777','4086 PARKSIDE DR',0,'BROOKLYN','OH','44144','1316','CY','39035','1954-02-15','M','M',':RET:2106-3','N','021','HLT','1019878','92036OH004000801','2014-01-01','2013-12-05 14:18:29','71.00',NULL,NULL,'489.35','418.35','R-OH011','OH0','489.35',NULL,0,'2013-12-25 17:20:17'),(16052,12854,'Y','18','021','EC','A','','','AC','0000431392','0000431392','OH00001985064','IL','1','boyer','kellie','','','','34','268648851','5796 VICTORIA CT',0,'WESTERVILLE','OH','43082','8680','CY','39041','1957-06-04','F','U',':RET:2106-3','N','021','DEN','1887511','99734OH005000401','2014-02-01','2014-01-02 22:02:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-04 02:03:14'),(15896,12729,'Y','18','021','EC','A','','','AC','0000266537','0000266537','OH00002079976','IL','1','Geith','William','','','','34','293508402','3486 WATKINS RD',0,'MEDINA','OH','44256','8327','CY','39103','1951-07-03','M','M',':RET:2106-3','N','021','HLT','2198960','52664OH152000901','2014-02-01','2014-01-02 17:00:20','777.00',NULL,NULL,'885.47','108.47','R-OH012','OH0','469.28',NULL,0,'2014-01-03 02:05:55'),(7127,5656,'Y','18','024','14','A','','','TE','0000201900','0000201900','','IL','1','Carpenter','Randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-09-04','M','',NULL,NULL,NULL,'','747075','','2013-12-24','2013-12-24 19:29:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:51:31'),(14373,11464,'Y','18','021','EC','A','','','AC','0000659916','0000659916','OH00000063127','IL','1','REINKE','CYNTHIA','R','','','34','273465291','1965 LAKESIDE DRIVE',0,'MADISON','OH','44057',NULL,'CY','39085','1952-11-22','F','U',':RET:2106-3','N','021','DEN','2296273','99734OH005000401','2014-02-01','2013-12-27 11:23:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:35'),(1938,1578,'Y','18','021','EC','A','','','AC','0000335121','0000335121','OH00001096908','IL','1','Walker','Bruce','Edwin','','','34','276684538','3817 TAFT AVE NE',0,'CANTON','OH','44705','2853','CY','39151','1959-02-11','M','U',NULL,'N','021','DEN','639201','99734OH005000401','2014-01-01','2013-11-19 19:03:56','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 19:00:34'),(24644,19561,'Y','18','021','EC','A','','','AC','0002020263','0002020263','LA00002957733','IL','1','JOLIVETTE','JOSEPH','','','','34','434314902','281 TRINITY RD',0,'OPELOUSAS','LA','70570','0609','CY','22097','1961-08-08','M','U',':RET:2054-5','N','021','DEN','3678614','18575LA002000201','2014-04-01','2014-02-19 12:20:29','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 04:20:48'),(26775,21220,'Y','18','021','EC','A','','','AC','0001244523','0001244523','TX00003059917','IL','1','Fitzsimmons','Larry','','','','34','514802427','4019 PREFERRED PL',0,'DALLAS','TX','75237','2921','CY','48113','1963-07-18','M','U',NULL,'N','021','DEN','2682497','33348TX002000201','2014-04-01','2014-02-28 21:00:34','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-01 21:00:09'),(375,311,'Y','18','021','EC','A','','','AC','0000585433','0000585433','TX00000246732','IL','1','Odum','Carol','Ann','','','34','460884211','922 SYCAMORE CREEK RD',0,'ALLEN','TX','75002','2319','CY','48085','1950-02-09','F','M',':RET:2106-3','N','021','DEN','425764','33348TX002000201','2014-01-01','2013-12-03 19:20:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:45:32'),(7547,5972,'Y','18','021','EC','A','','','AC','0001008933','0001008933','OH00001302463','IL','1','King','Mikki','','','','34','276789335','787 S SANDUSKY ST',0,'TIFFIN','OH','44883','3802','CY','39147','1981-10-04','F','M',':RET:2106-3','N','021','HLT','1004012','92036OH003002701','2014-01-01','2013-12-14 20:50:58','0.00',NULL,NULL,'240.90','240.90','R-OH006','OH0','240.90',NULL,0,'2013-12-26 02:33:05'),(7044,5594,'Y','18','021','EC','A','','','AC','0000027310','0000027310','TX00000188735','IL','1','Hunter','Donald','','','','34','449435834','4741 Tumbleweed Ave',0,'El Paso','TX','79924',NULL,'CY','48141','1963-05-12','M','U',':RET:2054-5','N','021','DEN','1433197','33348TX002000201','2014-02-01','2013-12-25 01:56:59','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 01:49:29'),(9534,7557,'Y','18','021','EC','A','','','AC','0000519826','0000519826','OH00000515750','IL','1','Trbovich','Gregory','M','','','34','294480273','1019 35TH ST NW',0,'CANTON','OH','44709','2606','CY','39151','1950-04-26','M','U',':RET:2106-3','N','021','DEN','2391540','99734OH005000301','2014-01-01','2013-12-21 10:16:38','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 04:35:52'),(20309,16212,'Y','18','021','EC','A','','','AC','0000479864','0000479864','TX00002410111','IL','1','WALSH','ANNE','','','','34','465832157','4581 GUADALAJARA DR',0,'SAN ANTONIO','TX','78233','6829','CY','48029','1971-01-25','F','U',NULL,'N','021','DEN','3058309','33348TX002000201','2014-03-01','2014-01-28 12:05:20','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-28 21:00:48'),(20363,16264,'Y','18','021','EC','A','','','AC','0000648358','0000648358','OH00001604986','IL','1','bear','anthony','','','','34','302660201','3064 AQUADALE LN',0,'CINCINNATI','OH','45211','8004','CY','39061','1975-01-22','M','U',':RET:2106-3','N','021','HLT','2820080','92036OH006001201','2014-03-01','2014-01-28 16:05:24','0.00',NULL,NULL,'214.85','214.85','R-OH004','OH0','214.85',NULL,0,'2014-01-28 21:01:21'),(20944,16736,'N','01','021','EC','A',NULL,NULL,'','0000573877','0001224348','','IL','1','Johnson','Joseph','','','','34','438909205','726 S WALKER ST',0,'MESQUITE','TX','75149','4941','CY','48113','1954-05-20','M','',':RET:2054-5','N','021','DEN','2440468','33348TX002000101','2014-03-01','2014-01-31 16:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-31 21:01:44'),(25183,19975,'Y','18','021','EC','A','','','AC','0000483529','0000483529','OH00002968827','IL','1','VODRAZKA','TODD','','','','34','269563711','10780 PARTRIDGE TRL',0,'BRECKSVILLE','OH','44141','1419','CY','39035','1970-01-18','M','U',NULL,'N','021','DEN','3492346','99734OH005000401','2014-04-01','2014-02-21 15:12:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:35'),(25385,20140,'Y','18','021','EC','A','','','AC','0001195546','0001195546','OH00001694667','IL','1','Beers','Jennifer','','','','34','293868619','1514 COLLINWOOD CIR',0,'CUYAHOGA FALLS','OH','44221','3630','CY','39153','1980-01-21','F','U',NULL,'N','021','HLT','3835524','52664OH151001301','2014-04-01','2014-02-24 18:40:20','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,0,'2014-02-25 21:30:49'),(28455,22516,'N','19','021','EC','A',NULL,NULL,'','0001974573','0002094581','','IL','1','Diaz Hernandez','Michael','Evans',NULL,NULL,NULL,NULL,'12743 ROE DR',0,'WALKER','LA','70785','5536','CY','22063','1994-02-06','M','',':RET:2106-3','N','021','DEN','3562425','18575LA002000201','2014-04-01','2014-03-07 12:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-03-07 21:31:22'),(8852,7018,'Y','18','021','EC','A','','','AC','0000979820','0000979820','TX00000839877','IL','1','LARSEN','RICKY','F','','','34','551133282','142 WILSON WAY',0,'GUN BARREL CITY','TX','75156','4210','CY','48213','1958-06-11','M','U',':RET:2106-3','T','021','DEN','1484748','33348TX002000201','2014-01-01','2013-12-18 10:10:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:03'),(18482,14742,'N','01','021','EC','A',NULL,NULL,'','0000793489','0000886930','','IL','1','Ziss','Lori','Anne','','','34','297766751','4076 KINGSBURY BLVD',0,'COPLEY','OH','44321','2841','CY','39153','1966-05-25','F','',NULL,'N','021','HLT','2557525','52664OH151001301','2014-02-01','2014-01-14 21:44:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.56',NULL,0,'2014-01-16 08:46:21'),(18361,14656,'N','01','021','EC','A',NULL,NULL,'','0000701719','0000273810','','IL','1','Marmer Hashimoto','Tsuneko','','','','34','294028393','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1958-01-31','F','',':RET:2039-6','N','021','DEN','1466950','99734OH005000301','2014-02-01','2014-01-15 01:42:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:26'),(17588,14058,'N','01','021','EC','A',NULL,NULL,'','0000317359','0001153633','','IL','1','Trent','William','Todd','','Jr','34','274441192','3063 HICKORY ST',0,'CLINTON','OH','44216','9115','CY','39153','1959-04-21','M','',':RET:2106-3','T','021','DEN','1461125','99734OH005000401','2014-02-01','2014-01-13 16:29:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:08'),(16794,13434,'Y','18','021','EC','A','','','AC','0000546566','0000546566','TX00001463469','IL','1','Sterns','LaToya','','','','34','449510179','2525 Whippoorwill Dr',0,'Mesquite','TX','75149',NULL,'CY','48113','1975-03-04','F','M',':RET:2054-5','N','021','DEN','2450633','33348TX002000201','2014-02-01','2014-01-10 21:52:38','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:18:08'),(7197,5704,'Y','18','021','EC','A','','','AC','0000614088','0000614088','OH00000006305','IL','1','Shamy','Rachel','','','','34','268885750','13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','1977-10-04','F','R',':RET:2106-3','N','021','DEN','1081283','99734OH005000301','2014-01-01','2013-12-14 17:57:46','0.00',NULL,NULL,'59.76','59.76','R-OH001','OH0','0.00',NULL,0,'2013-12-26 02:00:35'),(16155,12937,'Y','18','021','EC','A','','','AC','0001160422','0001160422','OH00000569925','IL','1','nash','brittany','','','','34','280962141','1949 GREEN RD',0,'CLEVELAND','OH','44121',NULL,'CY','39035','1993-03-17','F','U',NULL,'N','021','HLT','1681592','92036OH004000801','2014-02-01','2014-01-03 17:11:03','67.00',NULL,NULL,'119.38','52.38','R-OH011','OH0','119.38',NULL,0,'2014-01-04 02:06:23'),(20413,16304,'Y','18','021','EC','A','','','AC','0000431925','0000431925','TX00002103882','IL','1','Ferreira-Lopes','Carlos','','','','34','620167364','1801 S HORSE ST',0,'PHARR','TX','78577','5276','CY','48215','1971-10-02','M','U',':RET:2106-3','N','021','DEN','3185626','33348TX002000201','2014-03-01','2014-01-29 17:25:16','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-29 21:00:26'),(20720,16557,'Y','18','021','EC','A','','','AC','0000547919','0000547919','OH00001994021','IL','1','Baker','Rebecca','','','','34','271760553','2374 PARKER RIDGE RD',0,'PEEBLES','OH','45660','9104','CY','39001','1972-02-16','F','M',':RET:2106-3','T','021','HLT','2821306','92036OH006000601','2014-03-01','2014-01-30 14:17:38','502.00',NULL,NULL,'532.93','30.93','R-OH005','OH0','259.42',NULL,0,'2014-01-30 21:01:13'),(22944,18292,'Y','18','024','14','A','','','TE','0001148732','0001148732','','IL','1','GROTENRATH','DONNA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-17','F','',NULL,NULL,NULL,'','2105404','','2014-02-28','2014-02-11 12:38:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:22'),(23454,18683,'N','01','021','EC','A',NULL,NULL,'','0001113287','0001256975','','IL','1','Armstrong','Jewel','','','','34','458157319','709 STAIN GLASS DR',0,'DESOTO','TX','75115','6057','CY','48113','1956-12-08','F','',':RET:2054-5','N','021','DEN','3416683','33348TX002000201','2014-03-01','2014-02-13 13:50:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:39'),(6817,5405,'N','01','021','EC','A',NULL,NULL,'','0000449829','0000087448','','IL','1','Smas','James','','','','34','467497301','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','1978-07-03','M','',NULL,'N','021','HLT','629212','52664OH151001305','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.52',NULL,0,'2013-12-26 01:30:26'),(1865,1523,'Y','18','021','EC','A','','','AC','0001186317','0001186317','OH00001497364','IL','1','Moses','Paula','','','','34','547399158','43 TALLMADGE RD',0,'KENT','OH','44240','7207','CY','39133','1963-03-29','F','M',':RET:2106-3','N','021','HLT','1884497','52664OH152000901','2014-01-01','2013-12-24 11:14:16','343.00',NULL,NULL,'627.22','284.22','R-OH012','OH0','291.73',NULL,0,'2013-12-25 18:58:11'),(17763,14192,'Y','18','021','EC','A','','','AC','0001085633','0001085633','OH00001373858','IL','1','Honeycutt','Clarian','','','','34','409826668','317 rayford st',0,'Blanchester','OH','45107',NULL,'CY','39027','1949-07-18','F','M',':RET:2106-3','N','021','HLT','1867317','92036OH004000601','2014-02-01','2014-01-13 13:42:16','322.00',NULL,NULL,'517.83','195.83','R-OH005','OH0','517.83',NULL,0,'2014-01-14 01:33:34'),(15904,12736,'Y','18','021','EC','A','','','AC','0001043397','0001043397','OH00001486702','IL','1','Copeland','Christina','L','','','34','298663527','1643 W BREESE RD',0,'LIMA','OH','45806','1764','CY','39003','1961-07-30','F','M',':RET:2106-3','N','021','HLT','1641437','92036OH005001505','2014-02-01','2014-01-02 14:33:47','358.00',NULL,NULL,'429.60','71.60','R-OH002','OH0','429.60',NULL,0,'2014-01-03 02:06:10'),(17262,13810,'N','01','021','EC','A',NULL,NULL,'','0000898470','0000674085','','IL','1','Waldock','John','Henry','','III','34','269900202','901 S. Fountain Ave',0,'Springfield','OH','45506',NULL,'CY','39023','1988-09-29','M','',':RET:2106-3','N','021','DEN','1564200','99734OH005000301','2014-02-01','2014-01-10 12:40:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:17'),(19577,15605,'Y','18','021','EC','A','','','AC','0002251344','0002251344','LA00001900699','IL','1','davis','cortez','','','','34','434519789','463 E 84TH ST',0,'SHREVEPORT','LA','71106','5705','CY','22017','1981-05-31','M','U',':RET:2054-5','N','021','DEN','2492708','18575LA002000201','2014-03-01','2014-01-22 17:56:23','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-23 03:02:38'),(20263,16169,'Y','18','021','EC','A','','','AC','0000869314','0000869314','OH00001440899','IL','1','huang','ru','','','','34','097841563','243 ERNEST DR',0,'TALLMADGE','OH','44278','1665','CY','39153','1974-12-25','M','M',':RET:2034-7','N','021','DEN','3269916','99734OH005000301','2014-03-01','2014-01-27 23:28:49','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-28 21:00:19'),(24913,19753,'Y','18','021','EC','A','','','AC','0000909487','0000909487','OH00002129107','IL','1','Fowlkes','William','','','','34','316805554','55 JESSICA WAY',0,'GAHANNA','OH','43230','4408','CY','39049','1964-10-07','M','M',':RET:2054-5','N','021','DEN','3363083','99734OH005000401','2014-04-01','2014-02-20 17:01:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-20 21:30:09'),(26949,21353,'N','01','021','EC','A',NULL,NULL,'','0000513386','0000220028','','IL','1','Graham','Laura','','','','34','277888525','403 Lincoln St',0,'Elmore','OH','43416',NULL,'CY','39123','1985-03-30','F','',NULL,'N','021','HLT','2959874','92036OH003002705','2014-04-01','2014-03-01 20:32:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','227.86',NULL,0,'2014-03-03 01:00:25'),(7621,6031,'Y','18','024','14','A','','','TE','0000866366','0000866366','','IL','1','lau','yat','tung',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-24','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-17 10:12:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 02:45:55'),(6120,4853,'N','01','021','EC','A',NULL,NULL,'','0000315241','0001006675','','IL','1','King','Kimberly','S','','','34','467410054','1490 E FM 852',0,'WINNSBORO','TX','75494','3810','CY','48499','1962-10-21','F','',':RET:2106-3','N','021','DEN','97979','33348TX002000201','2014-01-01','2013-11-20 20:52:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:15:43'),(9712,7693,'Y','18','021','EC','A','','','AC','0000713596','0000713596','OH00001047832','IL','1','powell','cody','','','','34','295926787','166 HILLTOP RD',0,'OXFORD','OH','45056','1572','CY','39017','1985-07-16','M','U',':RET:2106-3','N','021','DEN','416970','99734OH005000401','2014-01-01','2013-11-14 23:42:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:13'),(5727,4546,'Y','18','021','EC','A','','','AC','0000650772','0000650772','LA00000481622','IL','1','Sanders','Donald','','','','34','437829629','143 hwy 1014',0,'Napoleonville','LA','70390',NULL,'CY','22007','1951-10-19','M','U',':RET:2054-5','N','021','DEN','1592016','18575LA002000201','2014-01-01','2013-12-23 22:36:58','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 23:45:34'),(5932,4696,'Y','18','021','EC','A','','','AC','0001428843','0001428843','LA00000546929','IL','1','Augustine','Paris','Michael','','','34','434319675','2145 MONACO DR',0,'BATON ROUGE','LA','70815','1234','CY','22033','1973-02-20','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2368193','18575LA002000101','2014-01-01','2013-12-23 21:20:58','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:50:32'),(5415,4297,'Y','18','021','EC','A','','','AC','0000840504','0000840504','OH00000901137','IL','1','Feehan','Timothy',NULL,NULL,NULL,NULL,NULL,'108 Franklin St PO Box 503',0,'Bettsville','OH','44815',NULL,'CY','39147','1958-01-21','M','R',':RET:2106-3','N','021','HLT','1864113','92036OH003002701','2014-01-01','2013-12-19 12:46:32','0.00',NULL,NULL,'454.11','454.11','R-OH006','OH0','454.11',NULL,0,'2013-12-25 23:09:14'),(5390,4277,'Y','18','021','EC','A','','','AC','0002039970','0002039970','LA00001028906','IL','1','Klein','Diana','','','','34','061642911','1901 Highway 190',0,'Mandeville','LA','70448',NULL,'CY','22103','1978-08-18','F','R',':RET:2106-3','N','021','DEN','2129347','18575LA002000201','2014-01-01','2013-12-19 16:41:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:38'),(2903,2340,'N','01','021','EC','A',NULL,NULL,'','0001010179','0000209599','','IL','1','Lyons','Shirley','','','','34','290588993','1600 OAKWOOD DR',0,'CLEVELAND HTS','OH','44121','1710','CY','39035','1958-02-19','F','',NULL,'N','021','DEN','857485','99734OH005000401','2014-01-01','2013-12-05 19:11:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:24'),(9512,7544,'Y','18','021','EC','A','','','AC','0000122972','0000122972','OH00000694014','IL','1','Thompson','Caroline','','','','34','296863940','856 S BROADLEIGH RD',0,'COLUMBUS','OH','43209','2504','CY','39049','1981-01-26','F','M',':RET:2106-3','N','021','DEN','2571889','99734OH005000401','2014-01-01','2013-12-21 17:12:40','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:35:25'),(3864,3094,'Y','18','021','EC','A','','','AC','0000650772','0000650772','LA00000491752','IL','1','Sanders','Donald','','','','34','437829629','143 hwy 1014',0,'Napoleonville','LA','70390',NULL,'CY','22007','1951-10-19','M','U',':RET:2054-5','N','021','DEN','877251','18575LA002000201','2014-01-01','2013-12-12 21:28:13','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 21:36:02'),(2945,2370,'Y','18','021','EC','A','','','AC','0000579959','0000579959','OH00000724679','IL','1','Freeman','Edward','','','','34','281465082','3134 WILLIAMSBURG ST NW',0,'WARREN','OH','44485','2255','CY','39155','1949-11-23','M','U',':RET:2054-5','N','021','DEN','701992','99734OH005000401','2014-01-01','2013-12-06 10:30:38','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:16:21'),(21382,17089,'Y','18','021','EC','A','','','AC','0000276306','0000276306','OH00002613551','IL','1','Vega','Michelle','','','','34','370068328','4951 E. Lake Rd.',0,'Sheffield Lake','OH','44054',NULL,'CY','39093','1981-07-01','F','M',':RET:2106-3','N','021','DEN','3544834','99734OH005000401','2014-03-01','2014-02-03 23:03:11','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-04 21:00:53'),(22088,17631,'Y','18','021','EC','A','','','AC','0001162303','0001162303','LA00001530513','IL','1','DIAZ','LARIZA','','','','34','768524614','3320 WALL BLVD',0,'GRETNA','LA','70056','8634','CY','22051','1981-12-02','F','U',NULL,'N','021','DEN','2678139','18575LA002000101','2014-03-01','2014-02-08 17:52:31','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-08 19:00:23'),(25862,20504,'Y','18','021','EC','A','','','AC','0001150855','0001150855','LA00002275793','IL','1','WILLIAMS','MARY','','','','34','434922657','1110 CARRILLOX',0,'HAMMOND','LA','70401',NULL,'CY','22105','1957-07-14','F','U',':RET:2054-5','N','021','DEN','3463481','18575LA002000201','2014-04-01','2014-02-26 11:56:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-26 21:00:45'),(27050,21421,'N','19','021','EC','A',NULL,NULL,'','0001025151','0000672606','','IL','1','Elkhatib','Alia','','','','34','587717504','515 FLORENCE DR',0,'MADISON','MS','39110','7326','CY','28089','1987-11-02','F','',NULL,'N','021','DEN','3255070','46300MS002000101','2014-04-01','2014-03-03 11:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15','CIC',0,'2014-03-03 21:00:25'),(1719,1433,'Y','18','021','EC','A','','','AC','0000477458','0000477458','OH00000680084','IL','1','Valentine','Patricia','','','','34','277503170','19100 WICKFIELD AVE',0,'WARRENSVILLE HEIGHTS','OH','44122','6533','CY','39035','1951-08-07','F','U',':RET:2054-5','N','021','DEN','1974422','99734OH005000301','2014-01-01','2013-12-24 09:48:35','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:09'),(7728,6121,'Y','18','021','EC','A','','','AC','0000765967','0000765967','OH00000726653','IL','1','Blocher','Robert','','','','34','060464731','21 Grouse Dr',0,'Amelia','OH','45102',NULL,'CY','39025','1955-02-06','M','M',':RET:2106-3','T','021','DEN','1404174','99734OH005000401','2014-01-01','2013-12-20 14:38:54','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:01:56'),(17644,14104,'Y','18','021','EC','A','','','AC','0000394947','0000394947','OH00002432241','IL','1','Chiuchiarelli','Rick','','','','34','289509431','14825 LANCELOT LN W',0,'NORTH ROYALTON','OH','44133','4309','CY','39035','1961-12-18','M','M',':RET:2106-3','N','021','DEN','2565101','99734OH005000301','2014-02-01','2014-01-13 09:55:02','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-14 01:32:37'),(15232,12174,'Y','18','021','EC','A','','','AC','0000479857','0000479857','OH00001722514','IL','1','Lewis','Roger','','','','34','297583703','4384 EASTWOOD DR',0,'BATAVIA','OH','45103','2419','CY','39025','1957-07-19','M','U',':RET:2106-3','N','021','HLT','2229797','92036OH005000601','2014-02-01','2013-12-30 09:34:47','236.00',NULL,NULL,'500.82','264.82','R-OH005','OH0','500.82',NULL,0,'2014-01-01 12:08:17'),(7516,5947,'Y','18','021','EC','A','','','AC','0000464425','0000464425','LA00000309593','IL','1','Webb','Shameika','','','','34','433712694','12400 Jefferson Hwy',0,'baton rouge','LA','70816',NULL,'CY','22033','1988-02-14','F','U',':RET:2054-5','N','021','DEN','1117700','18575LA002000201','2014-01-01','2013-12-15 13:09:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:32:15'),(7615,6026,'Y','18','021','EC','A','','','AC','0000294362','0000294362','OH00000686889','IL','1','North','Karen','','','','34','279764981','1605 South Main St',0,'North Canton','OH','44709',NULL,'CY','39151','1978-06-24','F','U',':RET:2106-3','N','021','DEN','155289','99734OH005000301','2014-01-01','2013-11-17 09:24:48','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 02:45:45'),(3226,2596,'N','01','021','EC','A',NULL,NULL,'','0000521917','0000801212','','IL','1','cole','jerry','','','','34','297905371','11414 pool kuntz rd',0,'sardinia','OH','45171',NULL,'CY','39015','1989-12-30','M','',':RET:2106-3','N','021','HLT','939568','92036OH006000601','2014-01-01','2013-11-01 16:24:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','170.24',NULL,0,'2013-12-25 20:45:54'),(4641,3678,'Y','18','021','EC','A','','','AC','0001194652','0001194652','MS00000546317','IL','1','Giust','Amy','','','','34','274540685','106 Pinewood Drive',0,'Hattiesburg','MS','39402',NULL,'CY','28073','1952-09-14','F','U',':RET:2106-3','T','021','DEN','202028','46300MS002000201','2014-01-01','2013-12-12 11:15:21','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 22:06:47'),(23248,18535,'Y','18','021','EC','A','','','AC','0000132073','0000132073','OH00002050662','IL','1','Payten','Steven','','','','34','302642350','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1964-01-21','M','M',':RET:1002-5^:RET:2054-5','N','021','DEN','3272818','99734OH005000401','2014-03-01','2014-02-13 09:29:07','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00','CIC',0,'2014-02-13 21:30:05'),(23254,18539,'Y','18','021','EC','A','','','AC','0001245562','0001245562','OH00002259633','IL','1','Lloyd','Anna','','','','34','272866165','3400 CHARRING CROSS DR',0,'STOW','OH','44224','4609','CY','39153','1985-11-16','F','U',':RET:2106-3','N','021','HLT','3307469','52664OH151001305','2014-03-01','2014-02-12 21:11:04','101.00',NULL,NULL,'242.41','141.41','R-OH012','OH0','242.41','CIC',0,'2014-02-13 21:30:07'),(26232,20805,'N','01','021','EC','A',NULL,NULL,'','0000149582','0001075682','','IL','1','Hernandez','Yvette','N','','','34','460697295','1640 RICK RHODES DR',0,'EL PASO','TX','79936','5689','CY','48141','1983-08-24','F','',NULL,'N','021','DEN','3580477','33348TX002000201','2014-04-01','2014-02-26 23:55:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 06:31:01'),(26323,20884,'Y','18','024','14','A','','','TE','0000101669','0000101669','','IL','1','REED','BRITTANY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-04-23','F','',NULL,NULL,NULL,'','3122522','','2014-02-27','2014-02-27 11:08:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-28 06:31:37'),(18516,14764,'Y','18','021','EC','A','','','AC','0001075327','0001075327','OH00001682848','31','1','Frank','Lisa','Ann','','','34','293681695','P.O. Box 66',0,'Middle Point','OH','45863',NULL,'CY','39161','1966-12-29','F','M',':RET:2106-3','N','021','HLT','2936540','92036OH004001501','2014-02-01','2014-01-15 15:51:43','226.00',NULL,NULL,'276.60','50.60','R-OH002','OH0','276.60',NULL,0,'2014-01-16 08:46:35'),(13388,10687,'Y','18','024','14','A','','','TE','0000653161','0000653161','','IL','1','Hoffman','Donald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-18','M','',NULL,NULL,NULL,'','379539','','2013-12-23','2013-12-23 05:08:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:00:05'),(2271,1855,'Y','18','021','EC','A','','','AC','0000590760','0000590760','OH00000086403','IL','1','Zimmer','James','','','','34','294527038','4808 BARNHART AVE',0,'DAYTON','OH','45432','3306','CY','39113','1956-08-14','M','U',NULL,'N','021','DEN','634392','99734OH005000301','2014-01-01','2013-12-09 10:19:16','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:30:23'),(15340,12269,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1654084','','2014-01-01','2014-01-01 10:40:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:24:13'),(15196,12144,'Y','18','021','EC','A','','','AC','0000415731','0000415731','MS00001192547','IL','1','Humphries','Michael','','','','34','587881627','48 Harvest Drive',0,'Columbus','MS','39705',NULL,'CY','28087','1954-03-17','M','U',':RET:2054-5','N','021','DEN','2409268','46300MS002000201','2014-02-01','2013-12-30 10:01:08','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-01 12:07:16'),(15034,12016,'N','01','021','EC','A',NULL,NULL,'','0001190747','0001787685','','IL','1','smith','hannah','','','','34','438752470','411 austin oaks circle',0,'west monroe','LA','71292',NULL,'CY','22073','1986-10-07','F','',':RET:2106-3','N','021','DEN','1846652','18575LA002000201','2014-02-01','2013-12-30 11:38:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:02:43'),(5975,4731,'Y','18','021','EC','A','','','AC','0001020422','0001020422','OH00000330983','IL','1','McSheehy','Lynn','','','','34','290809677','912 KIEFFER ST',0,'WOOSTER','OH','44691','2465','CY','39169','1974-06-14','F','M',':RET:2106-3','N','021','HLT','2474174','52664OH151001501','2014-01-01','2013-12-23 22:57:19','282.00',NULL,NULL,'730.63','448.63','R-OH014','OH0','337.54',NULL,0,'2013-12-25 23:51:47'),(5587,4432,'Y','18','021','EC','A','','','AC','0000950641','0000950641','OH00000288156','IL','1','Robinson','Iann','','','','34','104706202','5315 HUNTER AVE',0,'NORWOOD','OH','45212','1436','CY','39061','1971-03-28','M','U',':RET:2106-3','N','021','HLT','532094','92036OH006001201','2014-01-01','2013-11-05 23:48:29','0.00',NULL,NULL,'225.58','225.58','R-OH004','OH0','225.58',NULL,0,'2013-12-25 23:17:08'),(2729,2207,'Y','18','021','EC','A','','','AC','0000796898','0000796898','LA00000289712','IL','1','Spratlin','Tausha','','','','34','427396209','15569 E.Hoffman Rd.',0,'Ponchatoula','LA','70454',NULL,'CY','22105','1972-08-07','F','U',':RET:2106-3','N','021','DEN','915761','18575LA002000201','2014-01-01','2013-12-02 17:59:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:48:25'),(4939,3919,'Y','18','021','EC','A','','','AC','0000916978','0000916978','OH00000583354','IL','1','Porter','Gregory','L','','','34','300584444','1041 CLOVERLY DR',0,'GAHANNA','OH','43230','6219','CY','39049','1957-07-09','M','M',':RET:2054-5','N','021','DEN','711732','99734OH005000401','2014-01-01','2013-12-07 13:51:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:45:38'),(4588,3633,'Y','18','021','EC','A','','','AC','0000498139','0000498139','OH00001117379','IL','1','Phillips','Kathy','','','','34','275641271','9760 HULBERT RD',0,'SEVILLE','OH','44273','9563','CY','39103','1960-12-15','F','U',':RET:2106-3','N','021','HLT','203338','52664OH151001304','2014-01-01','2013-12-12 10:42:43','129.00',NULL,NULL,'454.94','325.94','R-OH012','OH0','454.94',NULL,0,'2013-12-25 22:05:24'),(21616,17260,'Y','18','021','EC','A','','','AC','0000727426','0000727426','TX00002211196','IL','1','Bell','Nicholas','','','','34','454978738','15455 ELLA BLVD',0,'HOUSTON','TX','77090','5396','CY','48201','1987-12-05','M','U',':RET:2054-5','N','021','DEN','3556682','33348TX002000201','2014-03-01','2014-02-04 20:05:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-05 21:30:36'),(22122,17658,'Y','18','021','EC','A','','','AC','0000763556','0000763556','OH00002432809','IL','1','Weaver','Francis','','','Jr','34','299809417','2745 DWIGHT RD',0,'SPRINGFIELD','OH','45503','5015','CY','39023','1982-01-28','M','R',':RET:2106-3','N','021','HLT','3495535','92036OH004000501','2014-03-01','2014-02-08 15:08:35','0.00',NULL,NULL,'347.50','347.50','R-OH003','OH0','226.12',NULL,0,'2014-02-08 19:00:40'),(24509,19470,'Y','18','024','14','A','','','TE','0000344040','0000344040','','IL','1','Ramirez','Ricardo',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-31','M','',NULL,NULL,NULL,'','2800017','','2014-02-19','2014-02-19 07:57:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-20 03:52:39'),(13292,10610,'Y','18','021','EC','A','','','AC','0001240339','0001240339','TX00000909959','IL','1','godfrey','thomas','','','','34','262961352','206 South Caddo Street',0,'Cleburne','TX','76031',NULL,'CY','48251','1950-03-03','M','M',':RET:2106-3','N','021','DEN','1788491','33348TX002000201','2014-01-01','2013-12-23 13:42:46','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:30'),(2054,1683,'Y','18','021','EC','A','','','AC','0000733564','0000733564','OH00000405047','IL','1','Schneeberger','Katherine','','','','34','269925396','7601 Lucerne Drive',0,'Middleburg Heights','OH','44130',NULL,'CY','39035','1986-07-02','F','U',NULL,'N','021','DEN','1169745','99734OH005000301','2014-01-01','2013-12-09 19:48:03','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:15:57'),(2583,2100,'Y','18','021','EC','A','','','AC','0000526755','0000526755','OH00000231481','IL','1','McCarty','Diana','Maria','','','34','301582046','2863 state route 132',0,'new richmond','OH','45157',NULL,'CY','39025','1958-09-24','F','M',':RET:2106-3','N','021','HLT','714144','92036OH001000601','2014-01-01','2013-12-09 17:19:00','803.00',NULL,NULL,'1237.21','434.21','R-OH005','OH0','577.44',NULL,0,'2013-12-25 19:38:03'),(7790,6168,'N','01','021','EC','A',NULL,NULL,'','0000174943','0001236532','','IL','1','GONZALES','IRMA','','','','34','453450836','402 S AVENUE L',0,'LAMESA','TX','79331','6038','CY','48115','1961-08-03','F','',NULL,'N','021','DEN','2187897','33348TX002000201','2014-01-01','2013-12-20 14:43:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:03:24'),(14026,11172,'Y','18','024','14','A','','','TE','0000815307','0000815307','','IL','1','Greene','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-02-06','M','',NULL,NULL,NULL,'','1126687','','2013-12-23','2013-12-23 11:52:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:16:44'),(20137,16069,'N','01','021','EC','A',NULL,NULL,'','0000153400','0000009875','','IL','1','Seip','Pamela','','','','34','284464006','1103 RIDGEPOINT DR',0,'BATAVIA','OH','45103','2680','CY','39025','1951-10-05','F','',':RET:2106-3','N','021','DEN','3116731','99734OH005000401','2014-03-01','2014-01-27 14:05:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:00:55'),(21311,17029,'N','19','021','EC','A',NULL,NULL,'','0001462820','0001880827','','IL','1','Steib','Princess','','','','34','436813994','22870 JACOCK RD',0,'SLAUGHTER','LA','70777','9615','CY','22037','1991-02-28','F','',':RET:2054-5','N','021','DEN','3698838','18575LA002000201','2014-03-01','2014-02-04 12:12:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:17'),(21848,17446,'Y','18','021','EC','A','','','AC','0001261240','0001261240','OH00002604730','31','1','ATER','NINA','L','','','34','275548508','PO BOX 213',0,'CROOKSVILLE','OH','43731',NULL,'CY','39127','1952-10-11','F','U',':RET:2106-3','N','021','DEN','3271226','99734OH005000301','2014-03-01','2014-02-06 11:55:05','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-02-06 21:01:14'),(27482,21747,'Y','18','021','EC','A','','','AC','0001224474','0001224474','TX00003164130','IL','1','PINZON','CHRISTIAN','','','','34','589100545','6825 NORMA ST',0,'FORT WORTH','TX','76112','5616','CY','48439','1965-06-16','M','U',NULL,'N','021','DEN','2769186','33348TX002000101','2014-04-01','2014-03-04 14:23:01','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-04 21:02:18'),(13227,10553,'Y','18','021','EC','A','','','AC','0000955066','0000955066','TX00001076389','IL','1','Kolz','Gregory','','','','34','550846448','2425 Ashdale',0,'Austin','TX','78757',NULL,'CY','48453','1950-08-30','M','U',':RET:2106-3','N','021','DEN','1618702','33348TX002000201','2014-01-01','2013-12-22 21:13:24','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:55:39'),(5417,4299,'Y','18','021','EC','A','','','AC','0000341325','0000341325','OH00000012533','IL','1','Hamilton','Linda','','','','34','284480754','17 KLAHR ST',0,'BLOOMVILLE','OH','44818','0351','CY','39147','1950-01-14','F','U',':RET:2106-3','N','021','HLT','2124611','92036OH004002701','2014-01-01','2013-12-19 10:32:51','264.00',NULL,NULL,'462.84','198.84','R-OH006','OH0','462.84',NULL,0,'2013-12-25 23:09:17'),(17512,13999,'Y','18','021','EC','A','','','AC','0000721360','0000721360','OH00001757258','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','N','021','DEN','2088910','99734OH005000401','2014-02-01','2014-01-12 09:31:15','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:30'),(16808,13443,'N','01','021','EC','A',NULL,NULL,'','0000710854','0000901124','','IL','1','khan','elma','r','','','34','466357296','1213 N GRAY ST',0,'KILLEEN','TX','76541','3440','CY','48027','1970-01-02','F','',NULL,'N','021','DEN','2192619','33348TX002000201','2014-02-01','2014-01-11 14:02:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:18:15'),(15458,12370,'Y','18','021','EC','A','','','AC','0001069176','0001069176','TX00001973084','IL','1','French','Joseph','','','','34','639447119','210A KIMBERLY LN',0,'LONGVIEW','TX','75604','1315','CY','48183','1986-03-17','M','U',':RET:2106-3','T','021','DEN','2207224','33348TX002000201','2014-02-01','2013-12-31 17:38:46','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,1,'2014-01-02 04:28:34'),(15872,12709,'N','01','021','EC','A',NULL,NULL,'','0000626764','0000990486','','IL','1','Cain','Margaret','T','','','34','587236849','4399 SCR 99',0,'Bay Springs','MS','39422',NULL,'CY','28129','1967-12-24','F','',':RET:2106-3','N','021','DEN','1742446','46300MS002000101','2014-02-01','2014-01-02 16:39:07',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-03 02:05:08'),(19711,15707,'Y','18','021','EC','A','','','AC','0000755464','0000755464','TX00002526893','IL','1','Vergil','Patricia','','','','34','569022643','2335 WEBSTER RANCH RD',0,'FRIENDSWOOD','TX','77546','2660','CY','48201','1953-05-22','F','M',':RET:2106-3','N','021','DEN','1863890','33348TX002000201','2014-03-01','2014-01-23 15:55:55','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-23 21:00:52'),(23451,18681,'Y','18','024','14','A','','','TE','0000645514','0000645514','','IL','1','HURTADO','NOEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-10','M','',NULL,NULL,NULL,'','3376455','','2014-02-13','2014-02-13 13:13:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-13 22:01:37'),(25111,19919,'Y','18','021','EC','A','','','AC','0000207641','0000207641','MS00002365195','IL','1','Hill','Trachelle','','','','34','428354704','129 23RD ST',0,'GULFPORT','MS','39507','1701','CY','28047','1965-06-28','F','M',':RET:2106-3','N','021','DEN','3087724','46300MS002000201','2014-04-01','2014-02-20 18:41:01','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85','CIC',0,'2014-02-21 21:30:15'),(25648,20347,'Y','18','024','14','A','','','TE','0000172464','0000172464','','IL','1','tucker','riley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2006-02-14','M','',NULL,NULL,NULL,'','3785204','','2014-02-21','2014-02-21 19:33:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 08:30:36'),(27710,21912,'Y','18','021','EC','A','','','AC','0000405514','0000405514','TX00003265498','IL','1','Elmore','Heath','','','','34','631033177','506 Pine Street',0,'Graham','TX','76450',NULL,'CY','48503','1976-09-29','M','U',':RET:1002-5','T','021','DEN','3101091','33348TX002000201','2014-04-01','2014-03-05 12:38:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:30:52'),(28817,22806,'Y','18','021','EC','A','','','AC','0001048064','0001048064','OH00003743935','IL','1','ARKENBURG','TONYA','','','','34','272560895','393 TAMMERY DR',0,'TALLMADGE','OH','44278','3034','CY','39153','1965-01-16','F','M',':RET:2106-3','N','021','HLT','3794426','52664OH151001305','2014-04-01','2014-03-09 16:42:07','617.00',NULL,NULL,'835.39','218.39','R-OH012','OH0','380.45',NULL,0,'2014-03-09 21:00:56'),(28866,22844,'Y','18','024','14','A','','','TE','0000017608','0000017608','','IL','1','DiDonato','Cory',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-01-01','M','',NULL,NULL,NULL,'','140666','','2014-03-31','2014-03-09 16:40:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-09 21:30:07'),(29075,23012,'Y','18','021','EC','A','','','AC','0000475719','0000475719','MS00003615580','S3','1','Davis','Kimberly','','','','34','426811657','534 BIRDIE DR',0,'BYRAM','MS','39272','5750','CY','28049','1996-05-13','M','U',':RET:2054-5','N','021','DEN','4071030','46300MS002000101','2014-04-01','2014-03-09 21:23:49','44.73',NULL,NULL,'47.10','2.37','R-MS003','MS0','47.10',NULL,0,'2014-03-10 21:01:59'),(29147,23073,'Y','18','021','EC','A','','','AC','0000851901','0000851901','OH00003170987','IL','1','Hill','Obelia','','','','34','282502790','6466 Montgomery Rd',0,'Cincinnati','OH','45213',NULL,'CY','39061','1949-12-17','F','U',NULL,'N','021','HLT','3784658','92036OH005001206','2014-04-01','2014-03-10 15:42:22','540.00',NULL,NULL,'644.00','104.00','R-OH004','OH0','644.00',NULL,0,'2014-03-10 21:02:46'),(717,592,'Y','18','021','EC','A','','','AC','0000600783','0000600783','OH00000946033','IL','1','Thatcher','Amber','','','','34','300882235','103 BONNEWITZ AVE',0,'VAN WERT','OH','45891','1103','CY','39161','1988-08-19','F','U',':RET:2106-3','T','021','HLT','349810','92036OH003001506','2014-01-01','2013-12-15 18:53:18','160.00',NULL,NULL,'265.38','105.38','R-OH002','OH0','265.38',NULL,0,'2013-12-25 18:03:20'),(16848,13478,'Y','18','021','EC','A','','','AC','0000298248','0000298248','OH00001451359','IL','1','OLIVER','GLENN','','','','34','276607016','5134 ITSIT RD',0,'CELINA','OH','45822',NULL,'CY','39107','1957-12-30','M','M',':RET:2106-3','N','021','HLT','1878267','92036OH006001501','2014-02-01','2014-01-11 11:37:32','282.00',NULL,NULL,'407.20','125.20','R-OH002','OH0','407.20',NULL,0,'2014-01-13 02:18:38'),(16363,13095,'Y','18','021','EC','A','','','AC','0000414332','0000414332','MS00001394103','IL','1','SCHAFFER','REGINA','','','','34','427215246','824 W JASPER ST',0,'BRANDON','MS','39042','4401','CY','28121','1964-07-02','F','U',NULL,'N','021','DEN','2613879','46300MS002000201','2014-02-01','2014-01-06 10:40:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-07 04:02:49'),(2420,1974,'Y','18','021','EC','A','','','AC','0000133293','0000133293','OH00000080128','IL','1','Yablonsky','Brenda','','','','34','298684684','5763 RUTLEDGE TRL',0,'LIBERTY TWP','OH','45011','1245','CY','39017','1972-03-09','F','R',':RET:2106-3','N','021','DEN','1039687','99734OH005000401','2014-01-01','2013-12-09 16:05:28','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:56'),(3275,2640,'Y','18','021','EC','A','','','AC','0000700373','0000700373','OH00000491081','IL','1','Ring','Julie','Anna','','','34','578962139','3825 Petoskey Avenue',0,'Cincinnati','OH','45227',NULL,'CY','39061','1968-06-13','F','U',':RET:2106-3','N','021','HLT','1527808','92036OH004001201','2014-01-01','2013-12-21 22:44:20','55.00',NULL,NULL,'249.26','194.26','R-OH004','OH0','249.26',NULL,0,'2013-12-25 21:15:05'),(3146,2530,'Y','18','021','EC','A','','','AC','0001069001','0001069001','TX00000378115','IL','1','Mejia','Alfredo','','','','34','457118430','P.O. Box 91',0,'Lopeno','TX','78564',NULL,'CY','48505','1962-03-26','M','U',NULL,'N','021','DEN','978320','33348TX002000201','2014-01-01','2013-11-18 12:38:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:55'),(19789,15776,'Y','18','021','EC','A','','','AC','0000096431','0000096431','OH00002487268','31','1','Dennis','Joey','','','','34','301729443','3868 Arlington Road',0,'Uniontown','OH','44685',NULL,'CY','39153','1963-07-24','M','M',':RET:1002-5^:RET:2106-3','N','021','HLT','1631608','52664OH151001502','2014-03-01','2014-01-23 09:44:19','342.31',NULL,NULL,'477.69','135.38','R-OH012','OH0','477.69',NULL,0,'2014-01-23 21:01:39'),(20759,16585,'Y','18','024','14','A','','','TE','0001157551','0001157551','','IL','1','Roessner','Jeff',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-31','M','',NULL,NULL,NULL,'','2146728','','2014-01-30','2014-01-30 17:46:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:34'),(22946,18294,'Y','18','024','14','A','','','TE','0000012419','0000012419','','IL','1','CHELLATH','SEEMA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-04-24','F','',NULL,NULL,NULL,'','1969442','','2014-02-28','2014-02-11 15:21:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:23'),(25267,20046,'Y','18','021','EC','A','','','AC','0000288334','0000288334','OH00002381468','IL','1','Neal','Shannon','','','','34','284769659','704 EUCLID AVE',0,'DELPHOS','OH','45833','2117','CY','39003','1969-06-27','F','U',':RET:2106-3','N','021','HLT','3642449','92036OH006001501','2014-04-01','2014-02-22 16:13:19','242.06',NULL,NULL,'243.84','1.78','R-OH002','OH0','243.84','CIC',0,'2014-02-22 19:00:16'),(27787,21977,'Y','18','024','14','A','','','TE','0001117196','0001117196','','IL','1','Msonthi','Khambile','Mercy',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-04-22','F','',NULL,NULL,NULL,'','2127563','','2014-03-20','2014-03-05 10:40:25',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERM',0,'2014-03-05 21:31:38'),(27913,22083,'Y','18','021','EC','A','','','AC','0000449691','0000449691','TX00002700224','IL','1','Terry','Charles','Lyle','','','34','629104840','3701 GRAPEVINE MILLS PKWY',0,'GRAPEVINE','TX','76051','1900','CY','48439','1989-05-28','M','U',':RET:2106-3','N','021','DEN','3612615','33348TX002000201','2014-04-01','2014-03-05 21:45:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:17'),(28006,22161,'Y','18','021','EC','A','','','AC','0001121460','0001121460','OH00003341271','IL','1','hugley','jiair','m','','','34','272023843','2305 WILLOW DR SW',0,'WARREN','OH','44485','3347','CY','39155','1996-12-24','M','U',NULL,'N','021','DEN','3362145','99734OH005000401','2014-04-01','2014-03-06 09:48:01','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','15.78',NULL,0,'2014-03-06 21:01:12'),(13926,11106,'Y','18','021','EC','A','','','AC','0000478479','0000478479','OH00000810807','IL','1','Pinson','Celinda','','','','34','273485844','17300 COUNTY ROAD G1',0,'HOLGATE','OH','43527','9527','CY','39069','1949-10-27','F','M',NULL,'N','021','HLT','1819021','92036OH003002604','2014-01-01','2013-12-23 17:16:56','429.00',NULL,NULL,'610.89','181.89','R-OH001','OH0','610.89',NULL,0,'2013-12-26 13:14:18'),(2844,2298,'N','01','021','EC','A',NULL,NULL,'','0000132034','0000146851','','IL','1','WOLFORD','CYNTHIA','','','','34','314663332','9269 WORTH RD',0,'UNION CITY','OH','45390','8609','CY','39037','1956-07-30','F','',':RET:2106-3','N','021','DEN','961987','99734OH005000401','2014-01-01','2013-11-24 16:44:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:01:08'),(18972,15117,'Y','18','024','14','A','','','TE','0000984871','0000984871','','IL','1','johnson','barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-11-04','F','',NULL,NULL,NULL,'','2597386','','2014-01-16','2014-01-16 21:27:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:06:02'),(18387,14676,'Y','18','021','EC','A','','','AC','0000758294','0000758294','OH00001800795','IL','1','Jackson','Rebecca','','','','34','299860028','7204 CRINSTEAD CT',0,'CINCINNATI','OH','45243','1202','CY','39061','1981-10-27','F','U',':RET:2106-3','N','021','DEN','2216333','99734OH005000301','2014-02-01','2014-01-15 16:45:33','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:38'),(5199,4125,'Y','18','024','14','A','','','TE','0000732579','0000732579','','IL','1','Itomlenskis','Larissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-09-01','F','',NULL,NULL,NULL,'','1665876','','2013-12-19','2013-12-19 14:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:59'),(16243,13008,'Y','18','024','14','A','','','TE','0000012444','0000012444','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','1960765','','2014-01-04','2014-01-04 08:35:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-05 00:02:27'),(15134,12094,'Y','18','021','EC','A','','','AC','0000839060','0000839060','OH00001694863','IL','1','Pettey','Benjamin','','','','34','388086430','6917 FRANKLIN BLVD',0,'CLEVELAND','OH','44102','2917','CY','39035','1987-11-08','M','U',':RET:2106-3','N','021','DEN','1444669','99734OH005000401','2014-02-01','2013-12-29 21:09:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:05:31'),(6760,5363,'N','01','021','EC','A',NULL,NULL,'','0001113109','0001037316','','IL','1','Forrer','Brent','A','','','34','276901258','152 WALDORF DR',0,'AKRON','OH','44313','6228','CY','39153','1974-04-12','M','',':RET:2106-3','N','021','HLT','712871','52664OH152000901','2014-01-01','2013-11-25 08:05:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','206.14',NULL,0,'2013-12-26 01:16:19'),(27186,21525,'Y','18','021','EC','A','','','AC','0001201478','0001201478','TX00002853339','IL','1','Rudge','Elizabeth','','','','34','534552977','1505 N 25TH ST',0,'HARLINGEN','TX','78550','4401','CY','48061','1963-10-30','F','M',NULL,'N','021','DEN','3064772','33348TX002000201','2014-04-01','2014-03-03 15:16:27','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-03 21:31:13'),(27681,21892,'N','01','021','EC','A',NULL,NULL,'','0000552165','0000427523','','IL','1','estrada','carolina','','','','34','186237037','305 HUMPHREY AVE',0,'PALACIOS','TX','77465','4439','CY','48321','1977-06-11','F','',':RET:2106-3','N','021','DEN','2853165','33348TX002000201','2014-04-01','2014-03-04 20:21:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:38'),(9529,7553,'N','01','021','EC','A',NULL,NULL,'','0000160787','0000615510','','IL','1','Gruber','S Michelle','','','','34','252921353','1027 Vernon Road',0,'Bexley','OH','43209',NULL,'CY','39049','1970-04-16','F','',NULL,'N','021','DEN','1782972','99734OH005000301','2014-01-01','2013-12-20 22:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:44'),(6968,5530,'Y','18','021','EC','A','','','AC','0000862439','0000862439','OH00001204631','IL','1','crawford','michael','','','','34','271723643','12607 FERRIS AVE',0,'CLEVELAND','OH','44105','5426','CY','39035','1975-12-08','M','U',':RET:2054-5','N','021','DEN','1950361','99734OH005000401','2014-01-01','2013-12-24 22:49:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:23'),(15614,12489,'Y','18','021','EC','A','','','AC','0000960908','0000960908','MS00001573831','IL','1','Williams','Johnathan','','','','34','587575431','178 WHITFIELD ST',0,'JACKSON','MS','39202','1937','CY','28049','1987-02-25','M','U',':RET:2054-5','N','021','DEN','2235782','46300MS002000101','2014-02-01','2013-12-30 20:11:06','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:32:55'),(2995,2409,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001025484','','IL','1','Isenbarger','Caleb','','','','34','284089439','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','2003-08-14','M','',':RET:2106-3','N','021','DEN','728312','99734OH005000301','2014-01-01','2013-12-05 20:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:32'),(5059,4008,'Y','18','021','EC','A','','','AC','0000172343','0000172343','TX00000522766','IL','1','Allen','Alicia','','','','34','464765199','26 CINNAMON LN',0,'SAN ANGELO','TX','76901','5432','CY','48451','1953-12-10','F','M',':RET:2106-3','N','021','DEN','1439225','33348TX002000201','2014-01-01','2013-12-19 00:10:47','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 23:00:22'),(3824,3062,'Y','18','021','EC','A','','','AC','0000794474','0000794474','OH00000247014','IL','1','Starcher','Benjamin','','','','34','287749582','4470 BEACHVIEW DR',0,'RAVENNA','OH','44266','9330','CY','39133','1973-12-06','M','U',':RET:2106-3','T','021','DEN','28852','99734OH005000301','2014-01-01','2013-12-13 15:04:33','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:35:02'),(4106,3281,'Y','18','021','EC','A','','','AC','0000054240','0000054240','TX00000514326','IL','1','Andrade','Kara','','','','34','240570659','8114 EXMOOR DR',0,'AUSTIN','TX','78757','7725','CY','48453','1977-07-03','F','M',NULL,'N','021','DEN','1529902','33348TX002000101','2014-01-01','2013-12-17 11:45:20','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:47:51'),(20603,16462,'Y','18','021','EC','A','','','AC','0000788239','0000788239','OH00001782096','IL','1','HAYES','JOANNE','S','','','34','078424118','5424 WESTGROVE DR',0,'COLUMBUS','OH','43228','5721','CY','39049','1950-05-12','F','U',':RET:2054-5','N','021','DEN','3600590','99734OH005000401','2014-03-01','2014-01-30 14:14:24','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:14'),(20896,16701,'Y','18','021','EC','A','','','AC','0000929867','0000929867','OH00002555026','IL','1','Lester','Kimberly','','','','34','290705998','420 BEECH AVE',0,'FAIRFIELD','OH','45014','1612','CY','39017','1969-11-27','F','U',':RET:2106-3','N','021','DEN','3217520','99734OH005000401','2014-03-01','2014-01-31 12:02:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:18'),(21683,17315,'N','01','021','EC','A',NULL,NULL,'','0001012964','0000045811','','IL','1','Rowe','Jeffrey','','','','34','286664443','7160 LAZY TRL',0,'HILLSBORO','OH','45133','6440','CY','39071','1960-08-09','M','',':RET:2106-3','T','021','HLT','2773746','92036OH004000601','2014-03-01','2014-02-05 18:09:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','404.95',NULL,0,'2014-02-05 21:31:03'),(28877,22854,'Y','18','021','EC','A','','','AC','0000888892','0000888892','TX00003461638','IL','1','YBARRA','JEANNETTE','','','','34','462497447','506 MARINA DR',0,'PORT ISABEL','TX','78578',NULL,'CY','48061','1966-06-18','F','U',NULL,'N','021','DEN','4235995','33348TX002000201','2014-04-01','2014-03-10 11:27:42','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-03-10 21:00:06'),(1513,1262,'Y','18','021','EC','A','','','AC','0000645990','0000645990','OH00000569656','IL','1','Lupson','Shawn','','','','34','284503535','4204 W 223RD ST',0,'FAIRVIEW PARK','OH','44126','1020','CY','39035','1951-09-25','M','U',':RET:2106-3','N','021','DEN','1642434','99734OH005000401','2014-01-01','2013-12-24 13:24:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:35'),(6507,5157,'Y','18','021','EC','A','','','AC','0000273764','0000273764','OH00000912860','IL','1','Easterling','Darryl','','','','34','226379625','3597 AVALON RD',0,'SHAKER HEIGHTS','OH','44120','5204','CY','39035','1982-10-27','M','R',':RET:2054-5','T','021','HLT','494809','52664OH152000901','2014-01-01','2013-12-10 22:52:04','0.00',NULL,NULL,'245.54','245.54','R-OH011','OH0','245.54',NULL,0,'2013-12-26 00:51:02'),(16556,13245,'Y','18','021','EC','A','','','AC','0002036750','0002036750','LA00001723831','IL','1','Carter','Nichelle','','','','34','437154596','8304 PALM ST',0,'NEW ORLEANS','LA','70118','4724','CY','22071','1971-01-07','F','U',':RET:2054-5','N','021','DEN','1875469','18575LA002000201','2014-02-01','2014-01-05 17:30:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-07 10:22:53'),(22003,17568,'N','19','021','EC','A',NULL,NULL,'','0000658460','0000295542','','IL','1','Mennetti','Eva',NULL,NULL,NULL,NULL,NULL,'612 DOUGLAS DR',0,'WAUSEON','OH','43567','1613','CY','39051','2004-04-07','F','',':RET:2106-3','N','021','DEN','3010499','99734OH005000301','2014-03-01','2014-02-06 19:01:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:48'),(22469,17941,'Y','18','021','EC','A','','','AC','0000829398','0000829398','MS00001465164','IL','1','Winter','William','','','','34','425696055','1006 LAKEVIEW DR',0,'GRENADA','MS','38901','4309','CY','28043','1990-03-27','M','M',':RET:2106-3','N','021','DEN','2811940','46300MS002000101','2014-03-01','2014-02-09 19:06:37','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-10 21:30:57'),(24639,19556,'Y','18','021','EC','A','','','AC','0001202245','0001202245','LA00002744088','IL','1','DANIEL','SAMUEL','L','','Sr','34','433880206','112 ALTHEA DR',0,'MONROE','LA','71202','6033','CY','22073','1959-01-25','M','U',':RET:2054-5','T','021','DEN','3219078','18575LA002000201','2014-04-01','2014-02-19 11:34:06','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 04:19:46'),(25796,20457,'Y','18','021','EC','A','','','AC','0000205834','0000205834','OH00002440516','IL','1','lindsey','dorian','','','','34','355544303','1068 piermont rd',0,'south euclid','OH','44121',NULL,'CY','39035','1975-09-19','M','U',NULL,'N','021','DEN','3230011','99734OH005000301','2014-03-01','2014-02-26 10:31:57','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:00:14'),(26544,21047,'N','19','021','EC','A',NULL,NULL,'','0001121453','0000881693','','IL','1','POKORNY','KIMBERLY','ANN','','','34','275969842','11430 WOODIEBROOK RD',0,'CHARDON','OH','44024','8496','CY','39055','1992-09-03','F','',NULL,'N','021','DEN','2898781','99734OH005000301','2014-03-01','2014-02-28 12:20:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:10'),(15590,12477,'Y','18','021','EC','A','','','AC','0001063253','0001063253','OH00001283499','IL','1','McGuire','Crystal','','','','34','402338190','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1974-02-21','F','M',NULL,'N','021','DEN','2167311','99734OH005000301','2014-02-01','2013-12-31 10:46:22','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,1,'2014-01-02 04:32:26'),(18769,14953,'Y','18','021','EC','A','','','AC','0001106368','0001106368','TX00002297406','IL','1','Long','Molly','','','','34','429713840','4802 ALF AVE',0,'AUSTIN','TX','78721','2409','CY','48453','1988-01-31','F','U',':RET:2106-3','N','021','DEN','2456324','33348TX002000101','2014-02-01','2014-01-15 19:33:32','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-17 03:35:49'),(15828,12672,'Y','18','024','14','A','','','TE','0000979310','0000979310','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1955666','','2014-01-02','2014-01-02 16:50:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:03:45'),(15962,12776,'Y','18','021','EC','A','','','AC','0000471025','0000471025','OH00001983628','IL','1','Clark','Jessica','','','','34','278865861','303 Mt. Tabor Rd',0,'Waverly','OH','45690',NULL,'CY','39131','1987-05-18','F','M',':RET:2106-3','N','021','DEN','2276887','99734OH005000301','2014-02-01','2014-01-03 13:40:49','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-01-04 02:00:21'),(19699,15697,'Y','18','021','EC','A','','','AC','0000282939','0000282939','TX00001628126','IL','1','Vincent','Tonya','S','','','34','465591271','8112 DIANE DR',0,'KAUFMAN','TX','75142','4603','CY','48257','1965-04-26','F','U',':RET:2106-3','T','021','DEN','1467141','33348TX002000201','2014-03-01','2014-01-23 17:54:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 21:00:46'),(20848,16663,'Y','18','021','EC','A','','','AC','0000008449','0000008449','OH00002473715','IL','1','Jenkins','Barbara','K','','','34','300540251','707 E REAGAN PKWY',0,'MEDINA','OH','44256','1241','CY','39103','1952-05-20','F','M',NULL,'N','021','DEN','3563820','99734OH005000301','2014-03-01','2014-01-30 22:22:03','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-31 21:00:50'),(21056,16823,'Y','18','021','EC','A','','','AC','0001646369','0001646369','LA00002116916','IL','1','LeDoux','Heather',NULL,NULL,NULL,NULL,NULL,'5229 Elm Grove Road',0,'Port Allen','LA','70767',NULL,'CY','22121','1984-10-16','F','U',NULL,'N','021','DEN','3625410','18575LA002000201','2014-03-01','2014-02-01 21:12:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-02 19:00:09'),(24268,19273,'Y','18','021','EC','A','','','AC','0001790174','0001790174','LA00002476255','IL','1','Darby','Allen','','','','34','437028413','629 ASHTON ST',0,'NEW IBERIA','LA','70563','1860','CY','22045','1971-10-09','M','U',':RET:2106-3','N','021','DEN','3068450','18575LA002000201','2014-04-01','2014-02-17 14:31:58','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-17 19:00:15'),(25944,20574,'Y','18','021','EC','A','','','AC','0000880577','0000880577','OH00002617311','IL','1','Rock','Jacqueline','','','','34','280847223','2775 MOONLIGHT LN',0,'COLUMBUS','OH','43207','4655','CY','39049','1970-04-06','F','U',NULL,'N','021','DEN','3392956','99734OH005000401','2014-04-01','2014-02-26 08:42:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:32'),(277,229,'Y','18','021','EC','A','','','AC','0000607558','0000607558','TX00000185516','IL','1','Reyna','Maria','','','','34','465877633','2239 WALNUT FAIR LN',0,'SPRING','TX','77373','2312','CY','48201','1959-09-26','F','U',NULL,'T','021','DEN','760727','33348TX002000201','2014-01-01','2013-10-12 13:34:30','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:30:12'),(18890,15051,'Y','18','021','EC','A','','','AC','0000124238','0000124238','OH00002265148','IL','1','Boring','John','','','','34','288608799','730 W Portage Tr Ext',0,'Akron','OH','44313',NULL,'CY','39153','1961-11-12','M','M',':RET:2106-3','T','021','HLT','2606346','52664OH152000901','2014-03-01','2014-01-16 16:39:09','742.00',NULL,NULL,'921.18','179.18','R-OH012','OH0','366.67',NULL,0,'2014-01-17 03:36:31'),(650,535,'N','01','021','EC','A',NULL,NULL,'','0001078879','0000409728','','IL','1','Hartman','Randall','J','','','34','296529703','212 EDGEFIELD BLVD',0,'MARION','OH','43302','5802','CY','39101','1953-11-21','M','',':RET:2106-3','N','021','DEN','1536411','99734OH005000401','2014-01-01','2013-12-16 16:13:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:33'),(17614,14081,'Y','18','021','EC','A','','','AC','0001019904','0001019904','TX00001411843','IL','1','Spotswood','Jasmine','','','','34','499903573','9497 PAGEWOOD LN',0,'HOUSTON','TX','77063','5355','CY','48201','1974-07-08','F','M',':RET:2028-9','N','021','DEN','1912276','33348TX002000201','2014-02-01','2014-01-13 11:30:25','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-14 01:32:23'),(9589,7593,'Y','18','021','EC','A','','','AC','0000214254','0000214254','MS00000952766','IL','1','Jackson','Rosie','','','','34','428904772','2845 Lakewood Drive',0,'Jackson','MS','39212',NULL,'CY','28049','1952-05-16','F','U',NULL,'N','021','DEN','1509446','46300MS002000201','2014-01-01','2013-12-21 11:14:28','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:37:06'),(4285,3410,'N','19','021','EC','A',NULL,NULL,'','0000689680','0001249572','','IL','1','Halker','Brittany','','','','34','289944848','9323 dt rt 12',0,'columbus grove','OH','45830',NULL,'CY','39137','1992-01-13','F','',':RET:2106-3','N','021','HLT','2079510','92036OH005001501','2014-01-01','2013-12-17 13:22:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.08',NULL,0,'2013-12-25 21:52:03'),(3712,2970,'Y','18','021','EC','A','','','AC','0000422797','0000422797','OH00000270082','IL','1','Carey','Vicki','Jo','','','34','313587590','515 E CENTRAL AVE',0,'VAN WERT','OH','45891','1838','CY','39161','1953-11-03','F','U',':RET:2106-3','N','021','DEN','852612','99734OH005000401','2014-01-01','2013-12-13 14:37:23','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:32:13'),(4395,3494,'Y','18','021','EC','A','','','AC','0001115918','0001115918','OH00000046555','IL','1','Mendez','Carlos','','','','34','291807085','180 College Park Dr.',0,'Elyria','OH','44035',NULL,'CY','39093','1982-02-22','M','M',':RET:2106-3','N','021','DEN','1170921','99734OH005000401','2014-01-01','2013-12-12 13:32:40','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:00'),(6847,5428,'Y','18','021','EC','A','','','AC','0000030743','0000030743','TX00000153528','IL','1','LYLES','NATHANIEL','','','Jr','34','249864582','1535 AUTUMN DAWN CT',0,'MISSOURI CITY','TX','77489','5245','CY','48157','1951-09-07','M','U',NULL,'T','021','DEN','424077','33348TX002000201','2014-01-01','2013-10-04 18:59:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:31:17'),(6517,5166,'N','01','021','EC','A',NULL,NULL,'','0001191309','0001252096','','IL','1','Rexford','Kenneth','','','','34','282661099','1636 LAKEWOOD AVE',0,'LIMA','OH','45805','3350','CY','39003','1968-11-29','M','',':RET:2106-3','N','021','HLT','19881','92036OH003001505','2014-01-01','2013-12-11 10:13:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','331.89',NULL,0,'2013-12-26 00:51:17'),(19244,15334,'Y','18','021','EC','A','','','AC','0000347734','0000347734','MS00001370724','IL','1','Stout','Jeffrey','','','','34','437591651','114 JOHNSON RD',0,'LUMBERTON','MS','39455','9188','CY','28073','1981-03-30','M','U',':RET:2106-3','N','021','DEN','2442787','46300MS002000101','2014-03-01','2014-01-19 23:41:43','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-21 08:46:39'),(19878,15856,'N','01','021','EC','A',NULL,NULL,'','0000851864','0000145409','','IL','1','Zawisza','Malgorzata','','','','34','014806005','248 AUGUSTA DR',0,'ELYRIA','OH','44035','8299','CY','39093','1969-01-19','F','',NULL,'N','021','DEN','2968736','99734OH005000401','2014-03-01','2014-01-24 10:55:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-24 21:00:44'),(20328,16231,'Y','18','021','EC','A','','','AC','0001247972','0001247972','TX00001384109','IL','1','Mandujano','Maria','','','','34','455891702','12555 WHEELER RD',0,'ATASCOSA','TX','78002','4398','CY','48029','1983-10-07','F','U',':RET:2106-3','N','021','DEN','3523839','33348TX002000201','2014-03-01','2014-01-28 18:02:22','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-28 21:00:59'),(20714,16551,'N','01','021','EC','A',NULL,NULL,'','0001190765','0002298537','','IL','1','moreno','jose','w','','','34','604282653','5144 EDEN ROC DR',0,'MARRERO','LA','70072','4900','CY','22051','1974-08-21','M','',NULL,'N','021','DEN','2642419','18575LA002000201','2014-03-01','2014-01-30 16:30:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-30 21:01:10'),(21186,16931,'Y','18','021','EC','A','','','AC','0000857584','0000857584','MS00002116929','IL','1','GRAY','KENNY','','','','34','428639160','88 MEADOWLANE DR',0,'LAUREL','MS','39440','1734','CY','28067','1988-08-12','M','M',':RET:2054-5','N','021','DEN','3413881','46300MS002000101','2014-03-01','2014-02-03 11:09:13','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-03 21:00:46'),(21501,17177,'Y','18','024','14','A','','','TE','0000694155','0000694155','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','2192994','','2014-02-19','2014-02-04 12:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-04 21:01:52'),(22887,18249,'N','19','021','EC','A',NULL,NULL,'','0000401282','0000288332','','S1','1','Bray','Timothy','','','','34','278132229','2275 ORCHARD HILLS BLVD',0,'TOLEDO','OH','43615','2638','CY','39095','2007-03-02','M','',':RET:2106-3','N','021','HLT','3603202','92036OH003002604','2014-03-01','2014-02-11 10:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-11 21:02:35'),(23489,18711,'Y','18','021','EC','A','','','AC','0000597349','0000597349','OH00002243494','IL','1','STRICKLER','DOUGLAS','','','','34','294642181','15047 MAIN ST',0,'VENEDOCIA','OH','45894','9645','CY','39161','1958-07-29','M','M',NULL,'T','021','HLT','3731873','92036OH004001501','2014-03-01','2014-02-13 08:44:57','385.00',NULL,NULL,'453.83','68.83','R-OH002','OH0','453.83',NULL,0,'2014-02-13 22:02:00'),(25839,20483,'Y','18','021','EC','A','','','AC','0000976789','0000976789','OH00002190511','31','1','SALINAS','LOUIS','','','','34','291526270','P.O. BOX 604',0,'HOLGATE','OH','43527',NULL,'CY','39069','1955-12-13','M','U',NULL,'N','021','HLT','3872794','92036OH003002605','2014-03-01','2014-02-26 15:06:10','394.00',NULL,NULL,'518.85','124.85','R-OH001','OH0','518.85',NULL,0,'2014-02-26 21:00:33'),(27103,21454,'N','01','021','EC','A',NULL,NULL,'','0000199730','0000471077','','IL','1','McGuire','Amber','J','','','34','297766274','313 Michael Ave.',0,'Hamilton','OH','45011',NULL,'CY','39017','1981-03-03','F','',':RET:2106-3','N','021','DEN','3920518','99734OH005000301','2014-04-01','2014-03-03 09:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:23'),(330,271,'N','01','021','EC','A',NULL,NULL,'','0000116558','0000036949','','IL','1','Covert','Kay','Ann','','','34','279606704','5655 QUAIL HOLLOW WAY',0,'WESTERVILLE','OH','43082','8182','CY','39041','1955-12-31','F','',NULL,'N','021','DEN','409256','99734OH005000401','2014-01-01','2013-10-11 10:01:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:31:39'),(901,748,'Y','18','021','EC','A','','','AC','0000062896','0000062896','MS00000438682','IL','1','OWENS','PHILLIP','Q','','','34','323486224','7207 LONDONDERRY DR',0,'SOUTHAVEN','MS','38671','5945','CY','28033','1953-11-18','M','M',':RET:2054-5','N','021','DEN','2078157','46300MS002000101','2014-01-01','2013-12-16 14:52:33','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2013-12-25 18:08:17'),(9666,7658,'Y','18','021','EC','A','','','AC','0000027886','0000027886','OH00000594293','IL','1','haas','jacob','w','','','34','298506790','628 REGENT RD',0,'CINCINNATI','OH','45245','1626','CY','39025','1955-01-22','M','M',':RET:2106-3','N','021','HLT','2206764','92036OH005000605','2014-01-01','2013-12-21 07:18:52','381.00',NULL,NULL,'546.97','165.97','R-OH005','OH0','546.97',NULL,0,'2013-12-26 04:39:06'),(6551,5194,'Y','18','021','EC','A','','','AC','0001230670','0001230670','TX00000117229','IL','1','Pitts','Kenneth','','','','34','317828182','3400 Craig Drive',0,'Mckinney','TX','75070',NULL,'CY','48085','1962-09-27','M','M',':RET:2054-5','N','021','DEN','61576','33348TX002000201','2014-01-01','2013-12-11 12:14:13','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:52:10'),(16477,13186,'Y','18','021','EC','A','','','AC','0000179916','0000179916','OH00001734949','IL','1','Ninni','Anthony','','','','34','279501736','1732 STEESE RD',0,'UNIONTOWN','OH','44685','7712','CY','39153','1950-12-21','M','M',':RET:2106-3','N','021','HLT','2360145','52664OH151001305','2014-02-01','2014-01-06 11:09:26','451.00',NULL,NULL,'658.32','207.32','R-OH012','OH0','658.32',NULL,0,'2014-01-07 04:06:08'),(16636,13309,'Y','18','021','EC','A','','','AC','0000229446','0000229446','OH00001567485','IL','1','Woolery','Kristine','','','','34','099423273','367 N JAY ST',0,'WEST MILTON','OH','45383','1712','CY','39109','1951-10-19','F','M',':RET:2106-3','N','021','DEN','2531611','99734OH005000401','2014-02-01','2014-01-07 11:38:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:16'),(5811,4617,'Y','18','021','EC','A','','','AC','0000789963','0000789963','TX00001284629','IL','1','Sifuentes','Jesus','','','','34','467231630','7327 Wilcox Dr.',0,'El Paso','TX','79915',NULL,'CY','48141','1955-12-25','M','M',':RET:2106-3','N','021','DEN','1535796','33348TX002000201','2014-01-01','2013-12-23 21:51:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:47:46'),(16403,13125,'Y','18','021','EC','A','','','AC','0000848405','0000848405','TX00002137124','IL','1','ADAMS','ASTRID','LACHELL','','','34','457618474','3719 NEW COPELAND RD',0,'TYLER','TX','75701','8876','CY','48423','1983-01-31','F','U',':RET:2054-5','N','021','DEN','2375108','33348TX002000201','2014-02-01','2014-01-06 16:42:45','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-07 04:03:58'),(21358,17070,'Y','18','021','EC','A','','','AC','0000587176','0000587176','TX00001662810','IL','1','Enriquez','Sandra','','','','34','459271836','224 Toledo',0,'El Paso','TX','79905',NULL,'CY','48141','1961-10-26','F','M',NULL,'N','021','DEN','2765908','33348TX002000201','2014-03-01','2014-02-04 14:05:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-04 21:00:42'),(22451,17925,'Y','18','024','14','A','','','TE','0001023407','0001023407','','IL','1','Duran','Annaeli',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-10-01','F','',NULL,NULL,NULL,'','2540604','','2014-02-10','2014-02-10 14:44:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:46'),(22908,18260,'Y','18','021','EC','A','','','AC','0000624018','0000624018','OH00002380003','IL','1','KOPAC','JAMES','','','','34','294764557','6702 FOREST AVE',0,'PARMA','OH','44129','2734','CY','39035','1965-03-25','M','R',NULL,'N','021','HLT','2976463','52664OH152000901','2014-03-01','2014-02-11 11:19:09','0.00',NULL,NULL,'301.21','301.21','R-OH011','OH0','301.21',NULL,0,'2014-02-11 21:02:46'),(24982,19814,'Y','18','021','EC','A','','','AC','0000888793','0000888793','TX00002058014','IL','1','MARTINEZ','ROSA','','','','34','457459418','1201 S WHEELER ST',0,'VICTORIA','TX','77901','9157','CY','48469','1951-06-06','F','M',':RET:2106-3','N','021','DEN','3144595','33348TX002000201','2014-04-01','2014-02-20 12:02:44','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-20 22:00:34'),(25622,20328,'Y','18','021','EC','A','','','AC','0000430909','0000430909','TX00002717324','IL','1','ORTIZ','JOEL','','','','34','596055093','1010 EASTRIDE DR',0,'KILLEEN','TX','76543',NULL,'CY','48027','1981-02-03','M','M',':RET:2106-3','N','021','DEN','3804859','33348TX002000201','2014-04-01','2014-02-22 14:42:47','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-26 08:30:17'),(25782,20447,'Y','18','021','EC','A','','','AC','0000312245','0000312245','OH00001891028','IL','1','HERNANDEZ','LUCIANO','','','Jr','34','280343550','1201 PARKSIDE PL',0,'FINDLAY','OH','45840','5537','CY','39063','1939-11-12','M','M',':RET:2106-3','N','021','HLT','3068584','92036OH005001506','2014-04-01','2014-02-24 15:06:30','917.00',NULL,NULL,'978.05','61.05','R-OH002','OH0','660.24',NULL,0,'2014-02-26 09:31:03'),(27132,21479,'Y','18','021','EC','A','','','AC','0000893203','0000893203','OH00003395432','IL','1','Cameron','Derrick',NULL,NULL,NULL,NULL,NULL,'490 MEDINA RD',0,'MEDINA','OH','44256','8126','CY','39103','1984-11-04','M','R',':RET:2106-3','T','021','DEN','3941999','99734OH005000401','2014-04-01','2014-03-02 22:16:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-03 21:30:40'),(1930,1572,'Y','18','021','EC','A','','','AC','0000325213','0000325213','TX00000627790','IL','1','Lane','Shelly','','','','34','467495514','7601 west 42nd st space number5',0,'Odessa','TX','79764',NULL,'CY','48135','1980-05-14','F','U',':RET:2106-3','T','021','DEN','740578','33348TX002000201','2014-01-01','2013-11-20 13:46:10','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-25 19:00:21'),(13210,10542,'Y','18','021','EC','A','','','AC','0000529280','0000529280','TX00000432185','IL','1','Mount','Scott','','','','34','435923494','208 White Oak',0,'Burkeville','TX','75932',NULL,'CY','48351','1952-02-06','M','M',':RET:2106-3','N','021','DEN','2168058','33348TX002000201','2014-01-01','2013-12-22 18:37:13','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:55:14'),(18264,14581,'Y','18','021','EC','A','','','AC','0000055458','0000055458','TX00002054694','IL','1','anaya','sandra','','','','34','351728221','2499 w Austin st',0,'port lavaca','TX','77979',NULL,'CY','48057','1970-02-09','F','U',NULL,'N','021','DEN','2362981','33348TX002000201','2014-02-01','2014-01-15 15:07:51','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-16 08:44:38'),(18161,14503,'N','01','021','EC','A',NULL,NULL,'','0000333886','0000810808','','IL','1','Young','Lisa','','','','34','274720893','9536 HOUSTON RD',0,'SIDNEY','OH','45365','8034','CY','39149','1968-04-20','F','',NULL,'N','021','HLT','1819573','92036OH003000504','2014-02-01','2014-01-14 11:33:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','358.46',NULL,0,'2014-01-15 02:07:54'),(13126,10468,'Y','18','021','EC','A','','','AC','0000209628','0000209628','OH00001017679','IL','1','murdock','reginald','','','','34','268686219','436 EVERETT ST',0,'TOLEDO','OH','43608','2439','CY','39095','1961-05-12','M','U',':RET:2054-5','T','021','DEN','2244259','99734OH005000401','2014-01-01','2013-12-23 14:24:25','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 12:52:53'),(7112,5642,'Y','18','021','EC','A','','','AC','0002201197','0002201197','LA00000107359','IL','1','Martin','Alice','','','','34','492624888','1657 LUCKY ST',0,'SHREVEPORT','LA','71108','3411','CY','22017','1955-08-22','F','U',':RET:2054-5','N','021','DEN','1694879','18575LA002000101','2014-01-01','2013-12-24 22:56:02','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-26 01:51:04'),(5250,4164,'Y','18','024','14','A','','','TE','0000507961','0000507961','','IL','1','miller','gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-06','M','',NULL,NULL,NULL,'','847738','','2013-12-19','2013-12-19 09:28:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:05:07'),(21302,17021,'Y','18','021','EC','A','','','AC','0001688319','0001688319','LA00001425757','IL','1','DURAN','SHELLEY','C','','','34','437679594','411 Dulles Dr',0,'Lafayette','LA','70506',NULL,'CY','22055','1987-09-21','F','U',':RET:2106-3','N','021','DEN','3181922','18575LA002000201','2014-03-01','2014-02-03 20:33:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-04 21:00:12'),(23277,18556,'N','01','021','EC','A',NULL,NULL,'','0001142218','0000421508','','IL','1','PATEL','NILA','B','','','34','268155736','9060 COUNTRY CLUB RD',0,'PIQUA','OH','45356','8570','CY','39109','1961-06-25','F','',NULL,'N','021','HLT','2697198','92036OH004000501','2014-03-01','2014-02-13 11:59:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.09','CIC',0,'2014-02-13 21:30:15'),(26681,21152,'N','01','021','EC','A',NULL,NULL,'','0002138124','0001287365','','IL','1','Grisby','michael','','','','34','438045351','11558 WILLOW OAK AVE',0,'BATON ROUGE','LA','70815','2391','CY','22033','1970-06-27','M','',':RET:2054-5','N','021','DEN','3919282','18575LA002000201','2014-04-01','2014-02-28 13:21:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-28 21:31:23'),(27237,21568,'Y','18','021','EC','A','','','AC','0000358112','0000358112','MS00003025472','IL','1','cobb','kenton','','','','34','427353803','1195 BLUFF SPRINGS RD',0,'GLOSTER','MS','39638','3505','CY','28005','1964-07-21','M','U',':RET:2054-5','N','021','DEN','2989573','46300MS002000101','2014-04-01','2014-03-03 15:10:48','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-03 21:31:45'),(28204,22320,'Y','18','021','EC','A','','','AC','0000848367','0000848367','TX00003776724','IL','1','Moser','Natalie','','','','34','644149207','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1974-04-24','F','M',':RET:2106-3','N','021','DEN','3200824','33348TX002000101','2014-04-01','2014-03-06 16:21:36','0.00',NULL,NULL,'148.50','148.50','R-TX010','TX0','27.15','CIC',0,'2014-03-06 21:30:10'),(29104,23037,'Y','18','021','EC','A','','','AC','0000436672','0000436672','OH00003151727','IL','1','Reese','Andrew','','','','34','289902007','184 SUSAN DR',0,'BLUFFTON','OH','45817','1424','CY','39003','1987-10-01','M','R',':RET:2106-3','T','021','HLT','4007667','92036OH002001501','2014-04-01','2014-03-10 13:05:30','0.00',NULL,NULL,'299.29','299.29','R-OH002','OH0','299.29',NULL,0,'2014-03-10 21:02:19'),(895,742,'Y','18','021','EC','A','','','AC','0001063197','0001063197','OH00000314744','IL','1','Martin','Mary','Kathern','','','34','271528454','4345 Darr Hopfinger Road',0,'Port Clinton','OH','43452',NULL,'CY','39123','1952-01-18','F','M',':RET:2106-3','N','021','HLT','2506157','92036OH003002701','2014-01-01','2013-12-16 12:43:20','424.00',NULL,NULL,'572.23','148.23','R-OH006','OH0','572.23',NULL,0,'2013-12-25 18:08:07'),(20119,16052,'N','01','021','EC','A',NULL,NULL,'','0000532142','0000092550','','IL','1','Hixenbaugh','Johnny','Leroy','','','34','272862149','26 JEFFERSON AVE',0,'ASHVILLE','OH','43103','1208','CY','39129','1976-10-08','M','',':RET:2106-3','N','021','DEN','3331523','99734OH005000401','2014-03-01','2014-01-26 22:52:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:00:45'),(14120,11253,'Y','18','021','EC','A','','','AC','0000706199','0000706199','OH00000828804','IL','1','Asplin','Jeff','','','','34','288661710','714 WOODLAKE DR',0,'AURORA','OH','44202','7656','CY','39133','1960-07-29','M','U',NULL,'N','021','DEN','2425616','99734OH005000401','2014-02-01','2013-12-26 16:01:35','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:02:05'),(18000,14383,'Y','18','021','EC','A','','','AC','0001077764','0001077764','OH00001958830','IL','1','cain','uriah','','','','34','554310080','15535 COOLVILLE RIDGE RD',0,'ATHENS','OH','45701','9686','CY','39009','1974-05-06','M','U',':RET:2106-3','T','021','DEN','2197971','99734OH005000301','2014-02-01','2014-01-13 20:45:45','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-01-15 02:06:59'),(9203,7300,'Y','18','021','EC','A','','','AC','0000236259','0000236259','OH00000822983','IL','1','Agee','Brittani','','','','34','275968708','6053 APPLECREST CT',0,'BOARDMAN','OH','44512','3176','CY','39099','1993-01-16','F','U',':RET:2054-5','N','021','HLT','2319004','92036OH002003201','2014-01-01','2013-12-18 11:01:36','122.00',NULL,NULL,'177.51','55.51','R-OH013','OH0','177.51',NULL,0,'2013-12-26 04:09:43'),(3443,2768,'Y','18','021','EC','A','','','AC','0000229430','0000229430','OH00000095621','IL','1','Stephens','Hollie','','','','34','285864901','3822 Pilgrim Rd',0,'Dayton','OH','45414',NULL,'CY','39113','1980-02-01','F','U',':RET:2106-3','N','021','DEN','1895075','99734OH005000401','2014-01-01','2013-12-21 20:37:50','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:19:17'),(23312,18582,'Y','18','021','EC','A','','','AC','0000413402','0000413402','OH00002675549','IL','1','Elias','Georgette','','','','34','269607988','6822 Old Royalton Rd.',0,'Brecksville','OH','44141',NULL,'CY','39035','1956-07-23','F','U',':RET:2106-3','N','021','DEN','3020881','99734OH005000301','2014-03-01','2014-02-13 12:01:12','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:20'),(27444,21720,'Y','18','021','EC','A','','','AC','0000292030','0000292030','OH00002851056','IL','1','Luttrell','Gerald','D','','','34','296501360','2951 MEADOWLAND ST',0,'UNIONTOWN','OH','44685','9727','CY','39153','1951-02-15','M','M',':RET:2106-3','N','021','HLT','3941019','52664OH151001501','2014-04-01','2014-03-03 19:29:54','888.00',NULL,NULL,'1541.14','653.14','R-OH012','OH0','789.56',NULL,0,'2014-03-04 21:01:55'),(28321,22408,'Y','18','024','14','A','','','TE','0000761226','0000761226','','IL','1','TRAN','TUYEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-01-23','F','',NULL,NULL,NULL,'','3016212','','2014-03-06','2014-03-06 19:50:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-07 21:30:05'),(28804,22799,'Y','18','021','EC','A','','','AC','0000813149','0000813149','OH00003808163','IL','1','hall','caren','','','','34','284946700','10 ROBBIE RDG',0,'MILFORD','OH','45150','1646','CY','39025','1990-02-20','F','U',':RET:2054-5','N','021','HLT','3715631','92036OH006000601','2014-04-01','2014-03-08 21:55:20','66.00',NULL,NULL,'170.24','104.24','R-OH005','OH0','170.24',NULL,0,'2014-03-09 21:00:50'),(14052,11196,'Y','18','021','EC','A','','','AC','0000385909','0000385909','OH00001595891','IL','1','Reese','Latonya','','','','34','293741167','2014 QUAIL CT',0,'CINCINNATI','OH','45240','4668','CY','39061','1978-05-30','F','U',':RET:2054-5','N','021','DEN','1977981','99734OH005000301','2014-02-01','2013-12-26 15:06:59','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:19'),(18909,15068,'Y','18','024','14','A','','','TE','0000526801','0000526801','','IL','1','Wright','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-27','F','',NULL,NULL,NULL,'','2596156','','2014-01-16','2014-01-16 17:37:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:39'),(15499,12400,'Y','18','024','14','A','','','TE','0000910534','0000910534','','IL','1','DEVORE','DREW',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-20','M','',NULL,NULL,NULL,'','1454396','','2013-12-31','2013-12-31 12:18:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:42'),(2175,1788,'N','19','021','EC','A',NULL,NULL,'','0000393642','0000725040','','IL','1','Loughridge','Nathan','M','','','34','277962429','219 S BRANDON AVE',0,'CELINA','OH','45822','2012','CY','39107','1993-02-18','M','',':RET:2106-3','N','021','HLT','1182800','92036OH003001501','2014-01-01','2013-12-09 20:34:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 19:19:15'),(2752,2227,'N','01','021','EC','A',NULL,NULL,'','0000765935','0001208268','','IL','1','Lean','Robin','J','','','34','173388168','6340 TRAIL RIDGE CT',0,'LOVELAND','OH','45140','8156','CY','39025','1950-01-25','F','',':RET:2106-3','N','021','HLT','257361','92036OH005000605','2014-01-01','2013-12-01 23:49:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','633.70',NULL,0,'2013-12-25 19:49:07'),(7975,6313,'Y','18','021','EC','A','','','AC','0000652111','0000652111','OH00001069069','IL','1','Sznajkart','Charlotte','J','','','34','298486355','3607 COLUMBIANA RD',0,'NEW SPRINGFIELD','OH','44443','9776','CY','39099','1950-03-02','F','U',':RET:2106-3','N','021','HLT','1366571','52664OH151001305','2014-01-01','2013-12-19 21:40:18','591.00',NULL,NULL,'746.55','155.55','R-OH013','OH0','746.55',NULL,0,'2013-12-26 03:07:48'),(13435,10718,'Y','18','021','EC','A','','','AC','0000540301','0000540301','OH00000424805','IL','1','Johnson','Scott','','','','34','590481299','6986 COUNTY ROAD 39',0,'HUNTSVILLE','OH','43324','9615','CY','39091','1972-03-04','M','R',':RET:2106-3','N','021','DEN','1908737','99734OH005000301','2014-01-01','2013-12-23 13:03:50','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:01:08'),(3113,2501,'Y','18','021','EC','A','','','AC','0000013897','0000013897','TX00000711768','IL','1','Hunter','Robbie','','','','34','467657323','2534 HONDO AVE',0,'DALLAS','TX','75219','2599','CY','48113','1970-05-10','M','U',NULL,'N','021','DEN','1235778','33348TX002000101','2014-01-01','2013-10-12 18:55:38','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 20:30:05'),(9702,7684,'N','01','021','EC','A',NULL,NULL,'','0000923323','0001161536','','IL','1','SEIBERT','MARILYN','','','','34','288520405','2139 BROADHURST AVE',0,'CINCINNATI','OH','45240','1413','CY','39061','1950-12-08','F','',':RET:2106-3','N','021','HLT','1711557','92036OH002001201','2014-01-01','2013-12-21 13:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','731.81',NULL,0,'2013-12-26 04:39:59'),(22912,18263,'Y','18','021','EC','A','','','AC','0000539330','0000539330','OH00002281881','IL','1','Niblock','Samuel','','','','34','555138346','5435 EDALBERT DR',0,'CINCINNATI','OH','45239','7603','CY','39061','1961-11-22','M','M',NULL,'N','021','HLT','2856393','92036OH005001201','2014-03-01','2014-02-11 13:41:40','37.00',NULL,NULL,'419.03','382.03','R-OH004','OH0','419.03',NULL,0,'2014-02-11 21:02:49'),(24555,19504,'Y','18','021','EC','A','','','AC','0001252177','0001252177','OH00002461913','IL','1','BARNETTE','JUDITH','','','','34','448522568','6553 CLEVELAND RD',0,'RAVENNA','OH','44266','1861','CY','39133','1951-07-06','F','U',':RET:2106-3','N','021','HLT','2815777','52664OH151001305','2014-04-01','2014-02-19 16:00:54','462.00',NULL,NULL,'640.70','178.70','R-OH012','OH0','640.70',NULL,0,'2014-02-20 04:05:04'),(24948,19783,'Y','18','021','EC','A','','','AC','0002021543','0002021543','LA00001941212','IL','1','SCHEXNAIDER','SUZETTE','','','','34','437983996','15234 SAINT MARY RD',0,'ERATH','LA','70533','5861','CY','22113','1957-01-11','F','M',':RET:2106-3','N','021','DEN','2660084','18575LA002000201','2014-04-01','2014-02-19 19:05:18','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 22:00:09'),(26695,21163,'Y','18','021','EC','A','','','AC','0001525793','0001525793','LA00003311611','IL','1','Alexander','Marvin','','','','34','437112322','3000 tulane Ave.',0,'New orleans','LA','70119',NULL,'CY','22071','1958-09-20','M','U',':RET:2054-5','N','021','DEN','3346253','18575LA002000101','2014-03-01','2014-02-28 12:12:27','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-28 21:31:30'),(28480,22534,'Y','18','021','EC','A','','','AC','0000013844','0000013844','OH00002827165','IL','1','Davis','Donald','','','','34','292641276','7103 EVENTRAIL DR',0,'POWELL','OH','43065','7342','CY','39041','1957-10-23','M','M',':RET:2106-3','N','021','DEN','3666152','99734OH005000301','2014-04-01','2014-03-07 11:40:43','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:35'),(572,469,'Y','18','021','EC','A','','','AC','0000639489','0000639489','OH00000067468','IL','1','Wagner','Katherine','','','','34','274743766','2106 KNIGHTSBRIDGE DR',0,'CINCINNATI','OH','45244','2629','CY','39061','1978-07-29','F','M',':RET:2106-3','N','021','HLT','1123905','92036OH005001201','2014-01-01','2013-12-03 23:11:14','101.00',NULL,NULL,'672.98','571.98','R-OH004','OH0','262.31',NULL,0,'2013-12-25 17:50:38'),(1966,1605,'Y','18','021','EC','A','','','AC','0001194047','0001194047','TX00000652517','IL','1','DeShazer','Jeremy','','','','34','445848555','19100 Glenwest Drive',0,'Friendswood','TX','77546',NULL,'CY','48201','1983-12-05','M','U',NULL,'N','021','DEN','579743','33348TX002000101','2014-01-01','2013-11-20 09:29:41','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 19:01:21'),(6341,5025,'Y','18','021','EC','A','','','AC','0000964594','0000964594','OH00000268485','IL','1','Stec','William','','','','34','277527611','25785 Folley Road',0,'Columbia Station','OH','44028',NULL,'CY','39093','1951-06-21','M','M',':RET:2106-3','N','021','DEN','298166','99734OH005000401','2014-01-01','2013-12-11 12:13:20','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:46:46'),(16976,13587,'Y','18','021','EC','A','','','AC','0001191222','0001191222','MS00001691015','IL','1','Barrera','Kembral','','','','34','587555948','549 PLANTERS DR',0,'PEARL','MS','39208','7028','CY','28121','1980-01-28','F','M',NULL,'N','021','DEN','2053553','46300MS002000201','2014-02-01','2014-01-08 23:32:38','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:20:15'),(5518,4377,'Y','18','021','EC','A','','','AC','0000460551','0000460551','OH00001064661','IL','1','Jacob','Elizabeth','','','','34','269563461','13920 EASTWOOD BLVD',0,'CLEVELAND','OH','44125','6051','CY','39035','1954-02-05','F','M',':RET:2106-3','N','021','DEN','699400','99734OH005000301','2014-01-01','2013-11-27 13:33:37','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:15:14'),(24760,19647,'Y','18','021','EC','A','','','AC','0000514496','0000514496','OH00002707401','IL','1','Moore','Nancy','','','','34','277689072','307 FLINT ROCK DR',0,'DELAWARE','OH','43015','6206','CY','39041','1963-10-14','F','U',':RET:2106-3','N','021','DEN','2897440','99734OH005000401','2014-04-01','2014-02-19 11:59:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:42:45'),(26860,21287,'N','19','021','EC','A',NULL,NULL,'','0000177685','0001131503','','IL','1','campton','abby','','','','34','287045171','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1999-10-07','F','',NULL,'N','021','HLT','3909716','92036OH003000601','2014-04-01','2014-03-01 11:08:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-01 21:00:55'),(27084,21442,'Y','18','021','EC','A','','','AC','0001195555','0001195555','OH00002317263','IL','1','VonGunten','Justin','','','','34','277825207','2249 28 th street',0,'cuyahoga falls','OH','44223',NULL,'CY','39153','1981-04-03','M','U',':RET:2106-3','N','021','HLT','3126618','52664OH151001305','2014-04-01','2014-03-02 22:22:22','154.00',NULL,NULL,'263.82','109.82','R-OH012','OH0','263.82',NULL,0,'2014-03-03 21:30:13'),(29184,23098,'Y','18','021','EC','A','','','AC','0000409801','0000409801','OH00003040475','IL','1','KOLOFF','MIKE','','','','34','281561323','15003 PALMER RD SW',0,'REYNOLDSBURG','OH','43068',NULL,'CY','39089','1954-02-08','M','M',NULL,'T','021','DEN','3226568','99734OH005000401','2014-04-01','2014-03-10 11:12:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-03-10 21:30:00'),(123,107,'Y','18','021','EC','A','','','AC','0000927280','0000927280','OH00000209717','IL','1','Snider','Donna','S','','','34','299481461','5383 MAPLE GROVE AVE',0,'BLANCHESTER','OH','45107','1533','CY','39027','1949-07-25','F','M',':RET:2106-3','N','021','HLT','1205668','92036OH002000601','2014-01-01','2013-12-05 13:22:15','573.00',NULL,NULL,'743.71','170.71','R-OH005','OH0','743.71',NULL,0,'2013-12-25 17:18:15'),(1701,1420,'Y','18','021','EC','A','','','AC','0001026942','0001026942','OH00001286134','IL','1','Kozlowski','Kathi-Anne','','','','34','292503376','3085 County Road D',0,'Swanton','OH','43558',NULL,'CY','39051','1953-06-21','F','U',NULL,'N','021','HLT','2032882','92036OH001002601','2014-01-01','2013-12-24 11:54:14','252.00',NULL,NULL,'638.35','386.35','R-OH001','OH0','638.35',NULL,0,'2013-12-25 18:54:43'),(17698,14143,'Y','18','021','EC','A','','','AC','0001970818','0001970818','LA00002046242','IL','1','Miller','Megan','','','','34','433655769','1009 Louise St.',0,'Lake Charles','LA','70601',NULL,'CY','22019','1984-10-13','F','R',':RET:2054-5','N','021','DEN','1372499','18575LA002000201','2014-02-01','2014-01-13 13:38:47','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-14 01:33:03'),(13595,10844,'Y','18','021','EC','A','','','AC','0000244981','0000244981','OH00001261375','IL','1','Seay','Philip','','','','34','592584945','308 SMEAD AVE',0,'LIMA','OH','45804','3240','CY','39003','1983-10-10','M','U',':RET:2106-3','N','021','HLT','1442023','92036OH003001505','2014-01-01','2013-12-22 18:56:28','129.00',NULL,NULL,'260.87','131.87','R-OH002','OH0','260.87',NULL,0,'2013-12-26 13:05:18'),(17001,13607,'N','01','021','EC','A',NULL,NULL,'','0000177647','0000105389','','IL','1','Nuss','Thomas','','','','34','294564294','1143 S. Cleve-Mass Rd',0,'Copley','OH','44321',NULL,'CY','39153','1955-02-23','M','',':RET:2106-3','N','021','DEN','2043809','99734OH005000301','2014-02-01','2014-01-09 16:02:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:30'),(5218,4142,'Y','18','021','EC','A','','','AC','0000264191','0000264191','OH00001161334','IL','1','OILER','FRANCES','DIANE','','','34','291503109','2808 TOWNTERRACE DR',0,'CINCINNATI','OH','45251','1104','CY','39061','1951-04-14','F','U',':RET:2106-3','N','021','DEN','2392577','99734OH005000401','2014-01-01','2013-12-19 16:09:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:27'),(15699,12559,'Y','18','021','EC','A','','','AC','0000313253','0000313253','OH00000428361','IL','1','MAZAR','LAURA','ELLEN','','','34','217703646','8627 GIBSON ROAD',0,'CANFIELD','OH','44406',NULL,'CY','39099','1954-02-08','F','M',':RET:2106-3','N','021','HLT','1603160','92036OH003003205','2014-02-01','2013-12-31 14:34:12','453.00',NULL,NULL,'657.99','204.99','R-OH013','OH0','657.99',NULL,1,'2014-01-02 04:35:38'),(13511,10769,'Y','18','021','EC','A','','','AC','0001690455','0001690455','LA00000033969','IL','1','SCOTT','MIKEL','','','','34','438437748','1640 N 44 ST',0,'BATON ROUGE','LA','70802',NULL,'CY','22033','1977-10-01','M','U',':RET:2054-5','N','021','DEN','1858651','18575LA002000201','2014-01-01','2013-12-22 22:33:28','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:02:53'),(14813,11832,'Y','18','021','EC','A','','','AC','0001412690','0001412690','LA00000658387','IL','1','Akhtar','Aziz','','','','34','436554025','1005 HELENES WAY',0,'SLIDELL','LA','70461','5366','CY','22103','1983-03-24','M','U',':RET:2029-7','N','021','DEN','2599250','18575LA002000201','2014-01-01','2013-12-23 20:28:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2013-12-29 11:14:07'),(14649,11692,'Y','18','021','EC','A','','','AC','0001000494','0001000494','TX00001378710','IL','1','Arroyos','Ramon','','','','34','461638868','9313 SAN LORENZO AVE',0,'EL PASO','TX','79907','6843','CY','48141','1978-05-21','M','U',':RET:2106-3','N','021','DEN','2569761','33348TX002000201','2014-02-01','2013-12-27 18:43:44','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:07:41'),(6415,5085,'Y','18','021','EC','A','','','AC','0001147312','0001147312','OH00000661705','IL','1','Oliver','Bonita','','','','34','172382719','6177 Roundhead Rd',0,'New Vienna','OH','45159',NULL,'CY','39071','1954-01-27','F','M',':RET:2106-3','N','021','HLT','1028097','92036OH003000605','2014-01-01','2013-12-11 08:29:12','453.00',NULL,NULL,'583.55','130.55','R-OH005','OH0','583.55',NULL,0,'2013-12-26 00:48:44'),(14670,11711,'Y','18','021','EC','A','','','AC','0000798206','0000798206','TX00001933151','IL','1','JIMENEZ','MARIA','E','','','34','632013666','557 LISA DIANE RD',0,'SOCORRO','TX','79927','3205','CY','48141','1960-01-27','F','U',NULL,'N','021','DEN','1699646','33348TX002000201','2014-02-01','2013-12-28 17:41:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:08:13'),(18628,14848,'N','01','021','EC','A',NULL,NULL,'','0000333893','0000864846','','IL','1','Scott','Kimberly','L','','','34','275844171','9380 Hunt Club Trail NE',0,'Warren','OH','44484',NULL,'CY','39155','1971-05-21','F','',':RET:2106-3','N','021','HLT','1745173','92036OH001003201','2014-02-01','2014-01-15 17:34:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','386.87',NULL,0,'2014-01-16 08:47:30'),(20704,16544,'Y','18','021','EC','A','','','AC','0002071063','0002071063','LA00001610879','IL','1','Jackson','Rosia','Jane','','','34','434215936','136 PALM LN',0,'LABADIEVILLE','LA','70372','2427','CY','22007','1958-03-12','F','M',NULL,'N','021','DEN','3221910','18575LA002000201','2014-03-01','2014-01-30 12:01:51','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-30 21:01:05'),(23150,18455,'Y','18','021','EC','A','','','AC','0001190102','0001190102','OH00002773859','IL','1','Schiffbauer','Stephanie','','','','34','293907274','17835 OWEN RD',0,'MIDDLEFIELD','OH','44062','9111','CY','39055','1988-02-23','F','U',':RET:2106-3','N','021','HLT','3463154','52664OH151001305','2014-03-01','2014-02-12 16:40:42','121.00',NULL,NULL,'257.56','136.56','R-OH011','OH0','257.56',NULL,0,'2014-02-12 21:31:41'),(28378,22453,'Y','18','021','EC','A','','','AC','0000810852','0000810852','OH00003802985','IL','1','DAVIS','BONNIE','','','','34','272489183','958 MOUNT ORAB PIKE',0,'GEORGETOWN','OH','45121','9314','CY','39015','1952-08-28','F','M',':RET:2106-3','N','021','HLT','3928322','92036OH005000605','2014-04-01','2014-03-07 15:27:56','415.00',NULL,NULL,'603.24','188.24','R-OH005','OH0','603.24',NULL,0,'2014-03-07 21:30:37'),(29023,22972,'Y','18','024','14','A','','','TE','0000810832','0000810832','','IL','1','Russell','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-10-21','M','',NULL,NULL,NULL,'','2820520','','2014-03-31','2014-03-10 10:35:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:01:31'),(29128,23060,'Y','18','021','EC','A','','','AC','0000846201','0000846201','OH00003021630','IL','1','Schroeder','Joseph','','','Jr','34','278848455','13704 CROSSBURN AVE',0,'CLEVELAND','OH','44135','5032','CY','39035','1985-04-22','M','U',NULL,'N','021','HLT','3640311','92036OH004000801','2014-04-01','2014-03-10 10:49:35','178.00',NULL,NULL,'204.35','26.35','R-OH011','OH0','204.35',NULL,0,'2014-03-10 21:02:35'),(2040,1670,'Y','18','024','14','A','','','TE','0000449280','0000449280','','IL','1','Jernigan','Janice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-01-04','F','',NULL,NULL,NULL,'','245871','','2013-12-09','2013-12-09 22:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:15:34'),(16237,13003,'Y','18','021','EC','A','','','AC','0001936890','0001936890','LA00001611848','IL','1','Johnson','Joshua','','','','34','436815635','1828 LESSEPS ST',0,'NEW ORLEANS','LA','70117','4528','CY','22071','1990-05-26','M','U',':RET:2054-5','N','021','DEN','1659621','18575LA002000101','2014-02-01','2014-01-03 22:35:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-05 00:02:14'),(3053,2453,'Y','18','021','EC','A','','','AC','0000753105','0000753105','LA00000187897','31','1','Pierce','Joseph','Whittenton','','','34','431922982','P.O. Box 1894',0,'Hammond','LA','70404',NULL,'CY','22105','1949-11-29','M','M',':RET:2106-3','N','021','DEN','705504','18575LA002000201','2014-01-01','2013-12-06 17:12:40','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:18:58'),(16935,13553,'Y','18','021','EC','A','','','AC','0002158528','0002158528','LA00001759863','IL','1','Hurst','Meshonda','','','','34','437712956','2734 TIFTON ST',0,'KENNER','LA','70062','5218','CY','22051','1988-05-23','F','U',NULL,'N','021','DEN','2152472','18575LA002000201','2014-02-01','2014-01-08 21:21:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:51'),(15303,12236,'Y','18','021','EC','A','','','AC','0001779227','0001779227','LA00001732567','IL','1','Coleman','Daniel','','','','34','436699547','6881 PARC BRITTANY BLVD',0,'NEW ORLEANS','LA','70126','7251','CY','22071','1979-06-12','M','U',':RET:2054-5','N','021','DEN','1964542','18575LA002000201','2014-02-01','2014-01-01 10:32:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:22:54'),(13603,10849,'Y','18','021','EC','A','','','AC','0001084148','0001084148','OH00001396985','IL','1','Smith','Anthony','','','','34','300720606','10530 SPENCERVILLE RD',0,'SPENCERVILLE','OH','45887','9710','CY','39003','1970-06-05','M','M',NULL,'N','021','HLT','1455439','92036OH003001501','2014-01-01','2013-12-23 17:20:31','297.00',NULL,NULL,'590.90','293.90','R-OH002','OH0','311.88',NULL,0,'2013-12-26 13:05:28'),(4662,3696,'N','01','021','EC','A',NULL,NULL,'','0000785022','0000046987','','IL','1','Lowery','Gary','','','','34','439928448','12043 Shelton Rd',0,'Bastrop','LA','71220',NULL,'CY','22067','1953-10-09','M','',':RET:2106-3','T','021','DEN','598912','18575LA002000201','2014-01-01','2013-12-12 11:54:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:24'),(3802,3048,'Y','18','021','EC','A','','','AC','0000017608','0000017608','OH00001255185','IL','1','DiDonato','Cory','','','','34','277927005','1915 State Route 59',0,'Kent','OH','44240',NULL,'CY','39133','1988-01-01','M','U',':RET:2106-3','N','021','DEN','140666','99734OH005000301','2014-01-01','2013-12-13 12:41:55','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:34:33'),(20746,16576,'Y','18','021','EC','A','','','AC','0000803759','0000803759','OH00001980495','IL','1','MURPHY','TIMOTHY','','','','34','087724428','1017 S MAIN ST',0,'BOWLING GREEN','OH','43402','4757','CY','39173','1970-04-20','M','U',':RET:2106-3','N','021','HLT','3538761','92036OH006002601','2014-03-01','2014-01-30 13:16:04','124.00',NULL,NULL,'209.85','85.85','R-OH001','OH0','209.85',NULL,0,'2014-01-30 21:01:26'),(24895,19738,'Y','18','024','14','A','','','TE','0000864125','0000864125','','IL','1','molina','patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-03-17','F','',NULL,NULL,NULL,'','2116267','','2014-03-31','2014-02-19 14:47:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 05:40:06'),(25080,19890,'Y','18','021','EC','A','','','AC','0000865923','0000865923','OH00002562592','IL','1','Hogue','Thomas','','','','34','295508787','2308 Danberry St',0,'Port Clinton','OH','43452',NULL,'CY','39123','1959-03-09','M','U',':RET:2106-3','N','021','HLT','3701635','92036OH005002701','2014-04-01','2014-02-20 12:42:25','0.00',NULL,NULL,'434.84','434.84','R-OH006','OH0','434.84',NULL,0,'2014-02-20 22:01:37'),(26633,21118,'Y','18','021','EC','A','','','AC','0000051898','0000051898','TX00002537230','IL','1','Monsivais','Jesse','','','Jr','34','459693477','6916 ALEXANDRIA CT',0,'FORT WORTH','TX','76133','6301','CY','48439','1984-05-11','M','M',':RET:2106-3','N','021','DEN','3736206','33348TX002000201','2014-04-01','2014-02-28 16:31:57','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-28 21:30:58'),(14158,11286,'Y','18','021','EC','A','','','AC','0002393466','0002393466','LA00000559642','IL','1','COTTON','LETITIA','','','','34','433570344','40464 WILLIAM FICKLIN RD',0,'GONZALES','LA','70737',NULL,'CY','22005','1980-04-11','F','U',':RET:2106-3','N','021','DEN','1630996','18575LA002000201','2014-02-01','2013-12-26 14:29:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:03:05'),(1473,1228,'Y','18','021','EC','A','','','AC','0001030376','0001030376','OH00000045984','IL','1','Nicholas','John','','','','34','277685018','252 Ohio Ave',0,'McDonald','OH','44437',NULL,'CY','39099','1959-07-13','M','U',NULL,'N','021','DEN','1622297','99734OH005000401','2014-01-01','2013-12-24 09:47:05','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:48:38'),(19281,15368,'Y','18','021','EC','A','','','AC','0000226044','0000226044','OH00002279145','IL','1','howell','Alexis','','','','34','284541682','2409 State Route 235 North',0,'St paris','OH','43072',NULL,'CY','39021','1953-09-12','F','U',':RET:2106-3','N','021','HLT','3206428','92036OH004000501','2014-03-01','2014-01-20 16:52:35','514.94',NULL,NULL,'518.73','3.79','R-OH003','OH0','518.73',NULL,0,'2014-01-21 08:47:00'),(7098,5630,'Y','18','021','EC','A','','','AC','0000194050','0000194050','OH00001435854','IL','1','Taylor','Kathleen','','','','34','277801472','427 S. Prospect',0,'Medina','OH','44256',NULL,'CY','39103','1981-07-24','F','M',':RET:2106-3','N','021','HLT','1598503','52664OH151001305','2014-01-01','2013-12-24 23:59:18','293.00',NULL,NULL,'516.93','223.93','R-OH012','OH0','263.82',NULL,0,'2013-12-26 01:50:42'),(17470,13969,'N','19','021','EC','A',NULL,NULL,'','0000268919','0000195157','','IL','1','Saxton','Trevor','','','','34','288089317','4287 mahoning rd',0,'Diamond','OH','44412',NULL,'CY','39133','2003-10-07','M','',':RET:2106-3','N','021','DEN','1625084','99734OH005000301','2014-02-01','2014-01-12 16:27:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:07'),(3361,2693,'N','01','021','EC','A',NULL,NULL,'','0000604202','0000679742','','IL','1','Reeise','Yuridia','','','','34','457699733','3533 BARCLAY DR',0,'AMARILLO','TX','79109','4009','CY','48381','1983-02-02','F','',NULL,'N','021','DEN','1413912','33348TX002000201','2014-01-01','2013-12-22 13:22:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:16:59'),(3836,3069,'Y','18','021','EC','A','','','AC','0000663153','0000663153','LA00001268849','IL','1','Dearie','Sarah','','','','34','437733644','1103 CAMBRONNE ST',0,'NEW ORLEANS','LA','70118','2019','CY','22071','1978-12-15','F','M',':RET:2106-3','N','021','DEN','363138','18575LA002000101','2014-01-01','2013-12-13 17:51:20','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:35:16'),(20702,16542,'Y','18','021','EC','A','','','AC','0001976774','0001976774','LA00001546432','IL','1','cummings','patricia','','','','34','068500225','1937 BARTHOLOMEW ST',0,'NEW ORLEANS','LA','70117','5057','CY','22071','1956-01-09','F','U',':RET:2106-3','N','021','DEN','3172516','18575LA002000201','2014-03-01','2014-01-30 11:35:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-30 21:01:04'),(24551,19501,'Y','18','021','EC','A','','','AC','0000009892','0000009892','OH00002670364','IL','1','Mahone','Celia','','','','34','278625417','3378 Whitebeech Lane',0,'Youngstown','OH','44511',NULL,'CY','39099','1961-11-03','F','U',':RET:2054-5','T','021','HLT','3026681','52664OH151001305','2014-04-01','2014-02-19 15:59:36','484.00',NULL,NULL,'728.29','244.29','R-OH013','OH0','567.70',NULL,0,'2014-02-20 04:04:22'),(14155,11283,'N','01','021','EC','A',NULL,NULL,'','0001548247','0001221864','','IL','1','Huang','Qun','Min','','','34','665208174','458 Kay Dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1974-04-07','F','',':RET:2034-7','N','021','DEN','2167210','18575LA002000201','2014-02-01','2013-12-26 13:56:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:03:00'),(18734,14928,'Y','18','021','EC','A','','','AC','0000489270','0000489270','OH00002199948','IL','1','llewellyn','jessica','','','','34','297863940','65 SOUTHWEST AVE',0,'TALLMADGE','OH','44278','2201','CY','39153','1981-07-25','F','U',':RET:2106-3','N','021','DEN','2166514','99734OH005000301','2014-03-01','2014-01-16 08:46:30','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:35:37'),(705,582,'Y','18','021','EC','A','','','AC','0000933603','0000933603','LA00000098022','IL','1','Nathan','Kathryn','Leigh','','','34','433742127','2019 Royal Street',0,'New Orleans','LA','70116',NULL,'CY','22071','1963-09-09','F','U',':RET:2106-3','N','021','DEN','1025847','18575LA002000201','2014-01-01','2013-12-15 19:29:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:03:00'),(17061,13653,'N','01','021','EC','A',NULL,NULL,'','0000768311','0000179413','','IL','1','Brindis','Maria','Oliva','','','34','620709109','705 mimosa trail',0,'cedar hill','TX','75104',NULL,'CY','48113','1967-06-03','F','',':RET:2106-3','N','021','DEN','1849284','33348TX002000201','2014-02-01','2014-01-07 21:08:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:11'),(1789,1472,'Y','18','021','EC','A','','','AC','0000627876','0000627876','OH00001116941','IL','1','Landfair','James','','','','34','525554364','4173 FOREST RIDGE BLVD',0,'DAYTON','OH','45424','4836','CY','39113','1970-03-21','M','M',':RET:2106-3','N','021','DEN','2280430','99734OH005000301','2014-01-01','2013-12-24 16:43:54','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:56:32'),(6812,5404,'Y','18','021','EC','A','','','AC','0001170797','0001170797','OH00001033066','IL','1','Jennings','Ronald','','','','34','285624477','808 MCKINLEY AVE',0,'AKRON','OH','44306','1906','CY','39153','1955-10-26','M','M',':RET:2106-3','N','021','HLT','295091','52664OH151001306','2014-01-01','2013-11-13 18:33:31','1004.00',NULL,NULL,'1136.44','132.44','R-OH012','OH0','568.22',NULL,0,'2013-12-26 01:30:21'),(3432,2757,'Y','18','021','EC','A','','','AC','0000515257','0000515257','LA00000410484','31','1','Rayford','Gary','','','','34','436864641','P O BOX  5612',0,'Shreveport','LA','71135',NULL,'CY','22017','1956-01-08','M','U',':RET:2106-3','N','021','DEN','2107745','18575LA002000101','2014-01-01','2013-12-22 09:37:48','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 21:18:58'),(6085,4823,'Y','18','021','EC','A','','','AC','0001108066','0001108066','OH00000171255','IL','1','Csepegi','Elizabeth','','','','34','273902780','208 N AVON AVE',0,'WADSWORTH','OH','44281','1203','CY','39103','1983-05-24','F','M',':RET:2106-3','N','021','HLT','1099446','52664OH151001305','2014-01-01','2013-12-01 17:19:15','362.00',NULL,NULL,'523.84','161.84','R-OH012','OH0','253.11',NULL,0,'2013-12-26 00:02:34'),(21708,17335,'Y','18','021','EC','A','','','AC','0000753418','0000753418','OH00002234536','IL','1','Long','Rebecca','','','','34','279682577','4827 ROCKDALE RD',0,'LIBERTY TWP','OH','45011','2330','CY','39017','1973-03-28','F','M',':RET:2106-3','N','021','HLT','3328107','92036OH003001206','2014-03-01','2014-02-05 09:25:04','382.00',NULL,NULL,'636.91','254.91','R-OH004','OH0','286.51',NULL,0,'2014-02-05 21:31:14'),(23346,18605,'Y','18','021','EC','A','','','AC','0000659943','0000659943','OH00001770012','IL','1','OLSON','DEBORAH','KAY','','','34','302581547','2739 3RD ST',0,'CUYAHOGA FALLS','OH','44221',NULL,'CY','39153','1956-12-19','F','M',':RET:2106-3','N','021','HLT','3665512','52664OH151001305','2014-03-01','2014-02-13 09:17:01','375.00',NULL,NULL,'543.47','168.47','R-OH012','OH0','543.47',NULL,0,'2014-02-13 22:00:39'),(27077,21437,'N','19','021','EC','A',NULL,NULL,'','0000671758','0000530757','','IL','1','douglas','donte','','','','34','292924591','1230 BYE ST',0,'AKRON','OH','44320','1902','CY','39153','1990-09-03','M','',':RET:2054-5','N','021','HLT','3721635','52664OH152000901','2014-04-01','2014-03-02 19:29:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2014-03-03 21:30:09'),(28135,22264,'N','01','021','EC','A',NULL,NULL,'','0000035818','0000943480','','IL','1','FREED','LUANN',NULL,NULL,NULL,NULL,NULL,'1817 A HIGBY',0,'STOW','OH','44224',NULL,'CY','39153','1953-08-31','F','',':RET:2106-3','N','021','HLT','3000466','52664OH151001304','2014-04-01','2014-03-06 15:30:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2014-03-06 21:02:26'),(648,534,'N','01','021','EC','A',NULL,NULL,'','0001248317','0000184924','','IL','1','Van Deursen','Margaret','','','','34','074384056','400 chatham dr',0,'kettering','OH','45429',NULL,'CY','39113','1953-06-18','F','',':RET:2106-3','N','021','DEN','1924689','99734OH005000401','2014-01-01','2013-12-16 16:09:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:31'),(2185,1797,'Y','18','021','EC','A','','','AC','0000709330','0000709330','TX00001211589','IL','1','Goetz','Kristi','','','','34','633090822','401 N 5th Street',0,'Ballinger','TX','76821',NULL,'CY','48399','1973-10-16','F','R',':RET:2106-3','N','021','DEN','28010','33348TX002000101','2014-01-01','2013-12-10 17:26:14','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:19:33'),(17218,13779,'Y','18','021','EC','A','','','AC','0000152903','0000152903','MS00002262161','31','1','DILLARD','PAMELA','','','','34','428132575','PO BOX 645',0,'BRANDON','MS','39043',NULL,'CY','28049','1963-07-03','F','U',':RET:2054-5','N','021','DEN','2104341','46300MS002000201','2014-02-01','2014-01-08 15:08:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:22:32'),(16687,13353,'Y','18','021','EC','A','','','AC','0000163878','0000163878','TX00001269772','IL','1','Arnott','Robert','','','','34','610542427','3207 Merrie Lynn Ave.',0,'Austin','TX','78722',NULL,'CY','48453','1987-01-08','M','R',':RET:2106-3','N','021','DEN','1825453','33348TX002000201','2014-02-01','2014-01-06 18:47:37','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-08 18:24:33'),(19932,15896,'Y','18','021','EC','A','','','AC','0000168915','0000168915','OH00001372989','IL','1','DeLaura','Bradford','','','','34','276723136','849 IONA AVE',0,'AKRON','OH','44314','2846','CY','39153','1967-07-12','M','U',':RET:2106-3','N','021','HLT','2182899','52664OH152000901','2014-03-01','2014-01-24 12:40:35','94.00',NULL,NULL,'245.01','151.01','R-OH012','OH0','245.01',NULL,0,'2014-01-24 21:01:09'),(17149,13721,'N','01','021','EC','A',NULL,NULL,'','0001278408','0001883124','','IL','1','jimenez','tania','','','','34','659038234','3810 CANTERBURY LN',0,'METAIRIE','LA','70001','1717','CY','22051','1979-11-08','F','',NULL,'N','021','DEN','2108299','18575LA002000201','2014-02-01','2014-01-07 20:30:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:21:56'),(18334,14640,'Y','18','021','EC','A','','','AC','0000621134','0000621134','OH00002062115','IL','1','Munford-Clark','Cenell','','','','34','275862007','926 WOODHILL DR',0,'GRANDVIEW HEIGHTS','OH','43212','3759','CY','39049','1971-09-10','F','U',':RET:2054-5','N','021','DEN','2362990','99734OH005000401','2014-02-01','2014-01-15 17:10:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:14'),(25963,20590,'Y','18','021','EC','A','','','AC','0000467141','0000467141','OH00002831915','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','DEN','3560975','99734OH005000401','2014-04-01','2014-02-26 12:40:34','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-26 21:01:42'),(24474,19442,'Y','18','021','EC','A','','','AC','0000129303','0000129303','OH00002385494','IL','1','wilson','sharell','','','','34','279863035','2840 floex dr',0,'toledo','OH','43615',NULL,'CY','39095','1985-10-17','F','U',':RET:2054-5','N','021','HLT','3690644','92036OH004002601','2014-04-01','2014-02-18 16:06:35','0.00',NULL,NULL,'170.44','170.44','R-OH001','OH0','170.44',NULL,0,'2014-02-18 22:01:40'),(23798,18936,'N','01','021','EC','A',NULL,NULL,'','0000072929','0000237625','','IL','1','Houck','Demetria','M','','','34','062962100','1260 Elno Ave.',0,'Kent','OH','44240',NULL,'CY','39133','1955-06-21','F','',':RET:2036-2','N','021','HLT','3805743','52664OH151001301','2014-03-01','2014-02-14 14:27:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2014-02-14 21:31:28'),(23276,18556,'Y','18','021','EC','A','','','AC','0001142218','0001142218','OH00002225359','IL','1','PATEL','BIPIN','R','','','34','314112645','9060 COUNTRY CLUB RD',0,'PIQUA','OH','45356','8570','CY','39109','1960-08-16','M','M',NULL,'N','021','HLT','2697198','92036OH004000501','2014-03-01','2014-02-13 11:59:08','702.00',NULL,NULL,'763.01','61.01','R-OH003','OH0','389.92','CIC',0,'2014-02-13 21:30:14'),(20863,16673,'N','19','021','EC','A',NULL,NULL,'','0000728749','0001168032','','IL','1','Vyas','Dominic',NULL,NULL,NULL,NULL,NULL,'5830 TRIPLETT SQ',0,'NEW ALBANY','OH','43054','8080','CY','39049','2004-05-21','M','',':RET:2106-3','N','021','DEN','2759609','99734OH005000301','2014-03-01','2014-01-31 15:19:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:57'),(7141,5665,'Y','18','021','EC','A','','','AC','0000022223','0000022223','TX00001387064','IL','1','Matassa','Susan','','','','34','462908998','354Van Zandt County Rd. 4108',0,'Canton','TX','75103',NULL,'CY','48467','1950-07-23','F','R',':RET:2106-3','N','021','DEN','2388967','33348TX002000101','2014-01-01','2013-12-24 20:15:53','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 01:51:52'),(4332,3441,'Y','18','021','EC','A','','','AC','0000955508','0000955508','OH00000174583','IL','1','RAMEY','DEBRA','','','','34','270709350','201 Superior St Apt 5',0,'ROSSFORD','OH','43460',NULL,'CY','39173','1960-08-07','F','U',NULL,'N','021','HLT','2588287','92036OH003002606','2014-01-01','2013-12-17 10:47:45','319.00',NULL,NULL,'415.41','96.41','R-OH001','OH0','415.41',NULL,0,'2013-12-25 21:53:03'),(19357,15429,'Y','18','021','EC','A','','','AC','0000340324','0000340324','OH00002488579','IL','1','VARGO','DEBORAH','LEE','','','34','287541072','1 S HAMILTON ST',0,'MONROEVILLE','OH','44847',NULL,'CY','39077','1954-07-25','F','U',':RET:2106-3','N','021','DEN','2302589','99734OH005000301','2014-03-01','2014-01-21 16:38:55','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,1,'2014-01-22 03:22:28'),(4738,3754,'Y','18','021','EC','A','','','AC','0000013755','0000013755','OH00001291871','IL','1','Jarvi','Terasa','','','','34','294627433','243 south pine street',0,'lima','OH','45804',NULL,'CY','39003','1958-09-19','F','U',':RET:2106-3','T','021','HLT','349716','92036OH002001501','2014-01-01','2013-12-12 15:23:52','377.00',NULL,NULL,'651.80','274.80','R-OH002','OH0','651.80',NULL,0,'2013-12-25 22:09:21'),(15949,12769,'Y','18','021','EC','A','','','AC','0000633746','0000633746','OH00002091074','IL','1','Citro','Ralph','','','','34','296468841','5980 S MAYFLOWER DR',0,'LORAIN','OH','44053','4120','CY','39093','1949-06-27','M','R',':RET:2106-3','N','021','DEN','1925493','99734OH005000301','2014-02-01','2014-01-02 18:29:51','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:00:03'),(15999,12805,'Y','18','021','EC','A','','','AC','0000559176','0000559176','TX00002078613','IL','1','Hill','Timothy','','','','34','433394768','113 APOLLO DR',0,'LIVINGSTON','TX','77351','5149','CY','48373','1965-09-23','M','U',':RET:2106-3','T','021','DEN','1642677','33348TX002000201','2014-02-01','2014-01-03 14:25:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:26'),(16646,13318,'Y','18','021','EC','A','','','AC','0000820557','0000820557','MS00001253728','IL','1','Nguyen','Rose','M','','','34','586264239','9815 ANA HULU ST',0,'DIAMONDHEAD','MS','39525','4407','CY','28045','1955-05-12','F','U',':RET:2028-9^:RET:2047-9','N','021','DEN','1812754','46300MS002000201','2014-02-01','2014-01-06 18:29:58','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-08 18:24:19'),(26457,20984,'Y','18','021','EC','A','','','AC','0000953294','0000953294','OH00002671687','IL','1','Rice','Debra','','','','34','371720888','7856 St Rt 108  lot 27',0,'Wauseon','OH','43567',NULL,'CY','39051','1956-09-05','F','U',':RET:2106-3','N','021','HLT','2756519','92036OH006002601','2014-03-01','2014-02-27 10:19:03','374.11',NULL,NULL,'376.87','2.76','R-OH001','OH0','376.87','CIC',0,'2014-02-28 07:30:28'),(29039,22985,'Y','18','021','EC','A','','','AC','0000239095','0000239095','OH00003538011','IL','1','MITCHELL','RICHARD','','','','34','290607480','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','1968-05-15','M','M',NULL,'N','021','DEN','3542283','99734OH005000401','2014-04-01','2014-03-10 13:16:43','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:01:40'),(809,669,'Y','18','021','EC','A','','','AC','0000082549','0000082549','OH00000687363','IL','1','Blair','Kim','','','','34','006641474','3808 NEW HUDSON RD',0,'ORWELL','OH','44076','9725','CY','39007','1958-04-02','F','M',':RET:2106-3','T','021','HLT','1716927','52664OH151001305','2014-01-01','2013-12-16 08:38:26','464.00',NULL,NULL,'645.02','181.02','R-OH011','OH0','645.02',NULL,0,'2013-12-25 18:05:46'),(25144,19946,'N','19','021','EC','A',NULL,NULL,'','0000805939','0000019053','','IL','1','brown','kimberly','','','','34','642329556','3210 VILLAGE POND LN',0,'FRESNO','TX','77545','8780','CY','48157','1992-09-21','F','',':RET:2054-5','N','021','DEN','3615831','33348TX002000201','2014-04-01','2014-02-21 12:07:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-21 22:00:12'),(24265,19270,'Y','18','024','14','A','','','TE','0000420054','0000420054','','IL','1','PHILLIPS','SCHERRI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-10','F','',NULL,NULL,NULL,'','2779698','','2014-02-17','2014-02-17 12:13:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-17 19:00:13'),(19676,15680,'Y','18','021','EC','A','','','AC','0001065186','0001065186','TX00002324346','IL','1','Boyd','Logan','','','','34','456950946','3417 Fruitland Farm Court',0,'San Angelo','TX','76903',NULL,'CY','48451','1987-12-29','M','U',':RET:2106-3','N','021','DEN','2139467','33348TX002000201','2014-03-01','2014-01-22 22:00:34','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-23 21:00:35'),(17490,13985,'Y','18','021','EC','A','','','AC','0001236359','0001236359','LA00001693661','IL','1','White','Brenda','','','','34','433062930','1016 NORTH FILMORE STREET',0,'COVINGTON','LA','70433',NULL,'CY','22103','1955-02-01','F','U',':RET:2054-5','N','021','DEN','1855448','18575LA002000201','2014-02-01','2014-01-11 20:43:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 03:01:19'),(2026,1659,'Y','18','021','EC','A','','','AC','0000773948','0000773948','OH00000363900','IL','1','STRAUSS','EDDI','','','','34','051475112','9637 E IDLEWOOD DR',0,'TWINSBURG','OH','44087','1684','CY','39153','1952-08-12','F','U',':RET:2106-3','N','021','HLT','1039706','52664OH152000901','2014-01-01','2013-12-10 12:44:00','458.99',NULL,NULL,'458.99','0.00','R-OH012','OH0','458.99',NULL,0,'2013-12-25 19:15:13'),(8818,6990,'Y','18','021','EC','A','','','AC','0000947398','0000947398','OH00001068955','IL','1','HELBLING','CONNIE','','','','34','294508097','435 FREE SOIL RD',0,'GEORGETOWN','OH','45121',NULL,'CY','39015','1950-12-30','F','M',':RET:2106-3','N','021','HLT','1640733','92036OH004000601','2014-01-01','2013-12-18 12:43:34','0.00',NULL,NULL,'509.54','509.54','R-OH005','OH0','509.54',NULL,0,'2013-12-26 04:00:10'),(6671,5291,'Y','18','021','EC','A','','','AC','0001042253','0001042253','OH00001216015','IL','1','baldosser','todd','','','','34','273642921','2292 E AUDREY DR',0,'NEWARK','OH','43055','9612','CY','39089','1965-04-23','M','U',':RET:2106-3','N','021','DEN','422951','99734OH005000301','2014-01-01','2013-11-15 21:59:39','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:01:07'),(16819,13452,'N','01','021','EC','A',NULL,NULL,'','0000304124','0000679839','','IL','1','Beltran','Jaime','','','','34','627057467','4636 ALBATROSS DR',0,'GRANBURY','TX','76049','1255','CY','48221','1966-08-30','M','',':RET:2106-3','N','021','DEN','1706634','33348TX002000101','2014-02-01','2014-01-10 19:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-13 02:18:21'),(16040,12843,'Y','18','021','EC','A','','','AC','0000968388','0000968388','TX00001892508','IL','1','Cook','Christopher','','','','34','453952113','1109 ELK TRL',0,'CARROLLTON','TX','75007','1115','CY','48121','1982-12-17','M','U',':RET:2106-3','T','021','DEN','1423865','33348TX002000101','2014-02-01','2014-01-02 20:49:22','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-04 02:02:48'),(6245,4948,'Y','18','021','EC','A','','','AC','0000298186','0000298186','OH00000704074','IL','1','Koelsch','Monica','','','','34','283822529','303 Finch St',0,'Sandusky','OH','44870',NULL,'CY','39043','1978-09-22','F','U',':RET:2106-3','N','021','DEN','474056','99734OH005000301','2014-01-01','2013-11-19 16:36:43','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-26 00:31:45'),(15135,12095,'Y','18','021','EC','A','','','AC','0000996536','0000996536','OH00001952119','IL','1','Reeves','Kristiana','','','','34','278903743','6709 HIGHLAND GREENS DR',0,'WEST CHESTER','OH','45069','7659','CY','39017','1987-09-19','F','U',':RET:2106-3','N','021','DEN','1708467','99734OH005000401','2014-02-01','2013-12-29 22:54:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:33'),(5226,4149,'Y','18','021','EC','A','','','AC','0000461927','0000461927','OH00000597858','IL','1','Baron','Olga','','','','34','296081955','343 SYCAMORE WOODS LN',0,'GAHANNA','OH','43230','5601','CY','39049','1974-03-14','F','M',':RET:2106-3','N','021','DEN','1748447','99734OH005000401','2014-01-01','2013-12-19 17:53:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:04:40'),(14808,11827,'Y','18','021','EC','A','','','AC','0002281371','0002281371','LA00001291432','IL','1','Philavong','Dok May','','','','34','557917425','1200 West Main St',0,'New Iberia','LA','70560',NULL,'CY','22045','1956-06-05','F','M',NULL,'N','021','DEN','1914493','18575LA002000201','2014-01-01','2013-12-23 19:53:26','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:13:59'),(26842,21274,'Y','18','021','EC','A','','','AC','0001967169','0001967169','LA00002500176','IL','1','walker','latonya','','','','34','436750404','610 van zelfden st',0,'tallulah','LA','71282',NULL,'CY','22065','1989-08-30','F','U',':RET:2054-5','N','021','DEN','2880691','18575LA002000201','2014-04-01','2014-03-01 08:49:46','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-01 21:00:45'),(28633,22660,'Y','18','021','EC','A','','','AC','0000293702','0000293702','TX00002921866','IL','1','OVIEDO','TOMAS','','','','34','449939941','1746  VZCR 1505',0,'VAN','TX','75790',NULL,'CY','48467','1963-03-07','M','M',NULL,'N','021','DEN','3115031','33348TX002000201','2014-04-01','2014-03-07 19:20:17','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:28'),(28695,22709,'Y','18','021','EC','A','','','AC','0001992238','0001992238','LA00003370373','IL','1','Kirk','Bonnie','','','','34','439316796','701 S 27TH ST',0,'MONROE','LA','71201','8037','CY','22073','1977-09-06','F','U',':RET:2054-5','N','021','DEN','3174951','18575LA002000101','2014-04-01','2014-03-08 13:07:20','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-03-08 21:31:05'),(849,703,'Y','18','021','EC','A','','','AC','0000290784','0000290784','OH00001162345','IL','1','Zacharias','Anna','','','','34','292849717','5380 OVERLOOK RD',0,'MILFORD','OH','45150','9203','CY','39025','1986-08-18','F','U',':RET:2106-3','N','021','HLT','1022269','92036OH001000601','2014-01-01','2013-12-15 23:44:09','0.00',NULL,NULL,'271.36','271.36','R-OH005','OH0','271.36',NULL,0,'2013-12-25 18:06:51'),(14168,11295,'Y','18','021','EC','A','','','AC','0001578963','0001578963','LA00001450995','IL','1','DANGERFIELD','SAMANTHA','','','','34','438157344','13388 OLD BATON ROUGE HWY',0,'HAMMOND','LA','70403','2539','CY','22063','1967-09-09','F','U',NULL,'N','021','DEN','1610766','18575LA002000201','2014-02-01','2013-12-26 17:36:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:03:22'),(25378,20134,'N','01','021','EC','A',NULL,NULL,'','0001097825','0000313301','','IL','1','Barber','Rodney','L','','Sr','34','268821482','326 Brookhaven Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','1969-09-17','M','',':RET:2054-5','N','021','DEN','2931619','99734OH005000301','2014-04-01','2014-02-25 16:20:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:44'),(24428,19404,'Y','18','021','EC','A','','','AC','0000201966','0000201966','OH00001994482','IL','1','Kelly','Susan','','','','34','286484796','8912 Isabelle Lane',0,'Macedonia','OH','44056',NULL,'CY','39153','1949-09-04','F','U',':RET:2106-3','T','021','HLT','3646250','52664OH151001301','2014-04-01','2014-02-18 09:50:57','306.00',NULL,NULL,'769.35','463.35','R-OH012','OH0','769.35',NULL,0,'2014-02-18 22:01:12'),(22968,18313,'Y','18','021','EC','A','','','AC','0000792244','0000792244','OH00001990619','IL','1','Kopac','James','','','','34','294764557','6702 FOREST AVE',0,'SEVEN HILLS','OH','44129','2734','CY','39035','1965-03-25','M','U',':RET:2106-3','T','021','HLT','2796292','52664OH151001306','2014-03-01','2014-02-12 17:22:43','274.00',NULL,NULL,'472.92','198.92','R-OH011','OH0','472.92','CIC',0,'2014-02-12 21:00:14'),(22355,17855,'Y','18','021','EC','A','','','AC','0000948462','0000948462','OH00001752752','IL','1','TUZZEO','CHRIS','','','','34','291606952','115 HIGHLAND MIST CIR',0,'HINCKLEY','OH','44233','9354','CY','39103','1964-10-24','M','M',':RET:2106-3','N','021','DEN','3504412','99734OH005000401','2014-03-01','2014-02-10 10:28:01','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00','CIC',0,'2014-02-10 21:00:06'),(6400,5072,'Y','18','024','14','A','','','TE','0000614068','0000614068','','IL','1','Whitaker','Janet','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-12','F','',NULL,NULL,NULL,'','95616','','2013-12-11','2013-12-11 14:36:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:48:19'),(14893,11895,'Y','18','021','EC','A','','','AC','0001546826','0001546826','LA00001494257','IL','1','bell','reginald','','','','34','434115499','3870 OZARK ST',0,'BATON ROUGE','LA','70805','5943','CY','22033','1964-01-09','M','U',':RET:2054-5','N','021','DEN','2575003','18575LA002000201','2014-02-01','2013-12-29 11:25:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-30 00:00:52'),(8095,6408,'N','19','021','EC','A',NULL,NULL,'','0000230429','0000467086','','IL','1','Miller','Collin','P','','','34','285066645','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','2001-07-31','M','',':RET:2106-3','N','021','HLT','2479133','52664OH151001501','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 03:10:48'),(26928,21341,'Y','18','021','EC','A','','','AC','0000005900','0000005900','OH00003267558','IL','1','SMITH','EUGENE','','','Jr','34','269627342','5510 TILLMAN AVE',0,'CLEVELAND','OH','44102',NULL,'CY','39035','1958-10-13','M','U',':RET:2054-5','N','021','DEN','3444838','99734OH005000401','2014-04-01','2014-03-02 13:56:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 01:00:18'),(27510,21764,'Y','18','021','EC','A','','','AC','0000699332','0000699332','OH00003637452','IL','1','Randolph','Clayton','','','Jr','34','280629828','740 Inwood St.',0,'Maumee','OH','43537',NULL,'CY','39095','1966-02-21','M','U',':RET:2106-3','N','021','HLT','3050361','92036OH004002601','2014-04-01','2014-03-04 16:45:11','0.00',NULL,NULL,'256.36','256.36','R-OH001','OH0','256.36',NULL,0,'2014-03-04 21:02:32'),(996,816,'Y','18','021','EC','A','','','AC','0001100562','0001100562','OH00000764537','IL','1','debord','dawn','','','','34','301605993','724 UNION RD',0,'FRANKLIN','OH','45005','2568','CY','39165','1976-09-07','F','U',':RET:2106-3','N','021','DEN','941022','99734OH005000301','2014-01-01','2013-11-11 15:24:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:10:47'),(23609,18804,'Y','18','021','EC','A','','','AC','0000332425','0000332425','OH00002631599','IL','1','LUCAS','JAMIE','','','','34','275823087','234 E 11TH ST',0,'DELPHOS','OH','45833','1118','CY','39003','1977-01-18','F','U',':RET:2106-3','T','021','HLT','3152745','92036OH003001505','2014-03-01','2014-02-13 16:42:18','180.00',NULL,NULL,'327.21','147.21','R-OH002','OH0','327.21',NULL,0,'2014-02-13 22:03:11'),(7745,6134,'Y','18','021','EC','A','','','AC','0000633732','0000633732','OH00001310103','IL','1','SCHOFFNER','LISA','','','','34','293586564','2345 GRANDVIEW AVE',0,'CLEVELAND','OH','44106','3119','CY','39035','1956-03-07','F','U',':RET:2106-3','N','021','DEN','1914274','99734OH005000401','2014-01-01','2013-12-20 15:55:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:23'),(7413,5866,'Y','18','021','EC','A','','','AC','0000383010','0000383010','LA00000441945','IL','1','GREENBERRY','ANTHONY','','','','34','436941228','334 N LOPEZ ST',0,'NEW ORLEANS','LA','70119','5430','CY','22071','1957-03-01','M','M',':RET:2054-5','N','021','DEN','623025','18575LA002000201','2014-01-01','2013-10-28 17:23:17','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:16:47'),(7194,5701,'Y','18','021','EC','A','','','AC','0000692904','0000692904','OH00000443709','IL','1','JONES','MELINDA','','','','34','346406245','2594 OAK PARK BLVD',0,'CUYAHOGA FALLS','OH','44221',NULL,'CY','39153','1952-07-29','F','U',':RET:2106-3','N','021','DEN','889176','99734OH005000301','2014-01-01','2013-12-14 14:49:46','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:00:29'),(22985,18325,'Y','18','021','EC','A','','','AC','0000235250','0000235250','OH00001670020','IL','1','Sanata','Terri','L','','','34','193447252','886 LYNITA DR NE',0,'BROOKFIELD','OH','44403','9643','CY','39155','1953-12-10','F','U',':RET:2106-3','N','021','DEN','3142123','99734OH005000301','2014-03-01','2014-02-11 23:57:22','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-12 21:30:11'),(21684,17316,'Y','18','021','EC','A','','','AC','0000099034','0000099034','OH00002324611','IL','1','MacCarthy','Thomas','','','','34','272118403','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1962-06-01','M','M',NULL,'N','021','HLT','3404444','92036OH004002601','2014-03-01','2014-02-04 19:52:55','386.00',NULL,NULL,'771.60','385.60','R-OH001','OH0','292.43',NULL,0,'2014-02-05 21:31:04'),(2202,1813,'Y','18','021','EC','A','','','AC','0000378543','0000378543','OH00000073662','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','HLT','523793','92036OH003000505','2014-01-01','2013-12-10 16:25:40','368.00',NULL,NULL,'506.41','138.41','R-OH003','OH0','506.41',NULL,0,'2013-12-25 19:20:03'),(16951,13568,'Y','18','021','EC','A','','','AC','0000810061','0000810061','MS00001475176','IL','1','council','linda','','','','34','426454599','40 tallahoma dr',0,'laurel','MS','39440',NULL,'CY','28067','1971-06-30','F','M',':RET:2106-3','N','021','DEN','1891925','46300MS002000101','2014-02-01','2014-01-08 22:55:37','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,0,'2014-01-13 02:20:00'),(25731,20410,'Y','18','021','EC','A','','','AC','0001810975','0001810975','LA00002745197','IL','1','ferdinand','patrix','','','','34','592234947','600 deerfield road',0,'terrytown','LA','70056',NULL,'CY','22051','1969-03-06','M','U',':RET:2054-5','N','021','DEN','3720228','18575LA002000201','2014-04-01','2014-02-24 14:34:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 09:30:35'),(27153,21498,'Y','18','021','EC','A','','','AC','0000920874','0000920874','OH00003658855','31','1','Channing','Richard','','','','34','234061184','P.O.Box 1953',0,'Buckeye Lake','OH','43008',NULL,'CY','39089','1959-05-11','M','U',':RET:2106-3','N','021','DEN','2673198','99734OH005000401','2014-04-01','2014-03-03 14:37:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:53'),(28013,22167,'Y','18','021','EC','A','','','AC','0000081337','0000081337','OH00003074365','IL','1','MCKENZIE','CHRISTINE','','','','34','274660726','17106 DINGMAN SLAGLE RD',0,'SIDNEY','OH','45365','9130','CY','39149','1972-01-03','F','U',':RET:2106-3','N','021','DEN','4168753','99734OH005000401','2014-04-01','2014-03-06 12:04:06','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-06 21:01:16'),(1489,1242,'Y','18','024','14','A','','','TE','0001046823','0001046823','','IL','1','Weaver','Gary','D','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-01-07','M','',NULL,NULL,NULL,'','72074','','2013-12-24','2013-12-24 11:06:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:59'),(24450,19422,'Y','18','024','14','A','','','TE','0001627542','0001627542','','IL','1','DELANEY','WANDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-01','F','',NULL,NULL,NULL,'','3088613','','2014-02-18','2014-02-18 16:27:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-18 22:01:26'),(24387,19370,'N','19','021','EC','A',NULL,NULL,'','0000479899','0000416009','','IL','1','STERLING','SIENA','','','','34','150716612','1614 RIVERSTONE WAY',0,'MONROE','OH','45050','1750','CY','39017','2012-05-01','F','',NULL,'N','021','DEN','3458464','99734OH005000401','2014-04-01','2014-02-18 11:37:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:47'),(2793,2258,'Y','18','021','EC','A','','','AC','0000614146','0000614146','LA00000228664','IL','1','Fulcher','Jennifer','','','','34','526815448','612 HIGH ST',0,'HOUMA','LA','70360','4759','CY','22109','1963-04-15','F','U',':RET:2106-3','N','021','DEN','847486','18575LA002000101','2014-01-01','2013-12-02 10:06:18','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2013-12-25 19:50:10'),(24154,19192,'Y','18','021','EC','A','','','AC','0000261545','0000261545','OH00001863027','IL','1','Drum','Alan','','','','34','524968747','07847 Southland Rd',0,'New Knoxville','OH','45871',NULL,'CY','39011','1960-07-16','M','M',':RET:2106-3','N','021','HLT','3344765','92036OH005001505','2014-03-01','2014-02-15 11:41:45','859.00',NULL,NULL,'918.85','59.85','R-OH002','OH0','448.97',NULL,0,'2014-02-15 22:01:59'),(24019,19102,'Y','18','021','EC','A','','','AC','0000181055','0000181055','OH00001458195','IL','1','Johnson','Randal','','','','34','281801861','4512 BURGER AVE',0,'CLEVELAND','OH','44109','5322','CY','39035','1981-05-01','M','U',':RET:2106-3','N','021','DEN','2791303','99734OH005000401','2014-03-01','2014-02-15 15:00:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:45'),(23883,19001,'Y','18','021','EC','A','','','AC','0000833460','0000833460','OH00001517227','IL','1','Orue','Emily','','','','34','276744189','6720 GREENFIELD DR',0,'CINCINNATI','OH','45224','1643','CY','39061','1978-09-05','F','M',':RET:2106-3','N','021','HLT','2952696','92036OH002001201','2014-03-01','2014-02-14 13:23:55','285.00',NULL,NULL,'968.46','683.46','R-OH004','OH0','302.93',NULL,0,'2014-02-14 21:32:14'),(14896,11898,'Y','18','021','EC','A','','','AC','0002285004','0002285004','LA00001300440','IL','1','Johnson','Jacqueline','','','','34','437796894','702 odgen street',0,'winnfield','LA','71483',NULL,'CY','22127','1990-09-27','F','U',':RET:2054-5','N','021','DEN','1948262','18575LA002000201','2014-02-01','2013-12-29 15:12:18','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-30 00:00:57'),(15082,12055,'Y','18','021','EC','A','','','AC','0001241722','0001241722','TX00001360691','IL','1','SEBAN','YOLANDA','','','','34','457779914','1445 DAVID AVE',0,'DESOTO','TX','75115','3155','CY','48113','1980-07-10','F','U',NULL,'N','021','DEN','2439748','33348TX002000101','2014-02-01','2013-12-30 11:05:39','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-01 12:04:11'),(15365,12290,'Y','18','021','EC','A','','','AC','0000168902','0000168902','OH00000847414','IL','1','Sejdic','Smail','','','','34','299020404','1654 BREIDING RD',0,'AKRON','OH','44310','2635','CY','39153','1951-05-07','M','M',':RET:2106-3','N','021','DEN','2613791','99734OH005000301','2014-02-01','2014-01-01 14:30:08','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:24:55'),(15573,12462,'N','01','021','EC','A',NULL,NULL,'','0000484804','0000442189','','IL','1','Reed','James','','','','34','277784645','6781 ROBERTS LN',0,'WOOSTER','OH','44691','7769','CY','39169','1970-07-02','M','',':RET:2106-3','T','021','HLT','2324680','52664OH151001305','2014-02-01','2013-12-31 14:23:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.01',NULL,1,'2014-01-02 04:31:57'),(15781,12630,'Y','18','021','EC','A','','','AC','0000792191','0000792191','TX00000744382','IL','1','simmons','latosha','','','','34','465755439','1227 MARFA AVE',0,'DALLAS','TX','75216','5414','CY','48113','1981-07-15','F','U',NULL,'T','021','DEN','1961940','33348TX002000201','2014-02-01','2014-01-02 17:33:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:02:08'),(23352,18609,'N','19','021','EC','A',NULL,NULL,'','0000373671','0000352882','','IL','1','Smith','Jenna','Kyle',NULL,NULL,NULL,NULL,'4604 Garrett Dr',0,'Norton','OH','44203',NULL,'CY','39153','2001-07-30','F','',':RET:2106-3','N','021','HLT','2740488','52664OH151001304','2014-03-01','2014-02-13 13:48:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-13 22:00:42'),(20254,16163,'Y','18','024','14','A','','','TE','0001246915','0001246915','','IL','1','Moore','Jeanie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-21','F','',NULL,NULL,NULL,'','194034','','2014-01-27','2014-01-27 19:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:15'),(23143,18449,'Y','18','021','EC','A','','','AC','0000970500','0000970500','OH00002040492','IL','1','Armsey','Linda','','','','34','284523863','385 South Cleveland Avenue',0,'Mogadore','OH','44260',NULL,'CY','39133','1950-07-03','F','U',':RET:2106-3','N','021','HLT','3631137','52664OH151001301','2014-03-01','2014-02-12 12:13:12','281.00',NULL,NULL,'658.32','377.32','R-OH012','OH0','658.32',NULL,0,'2014-02-12 21:31:37'),(2222,1829,'N','01','021','EC','A',NULL,NULL,'','0000186086','0000308246','','IL','1','Shelton','John','','','','34','284505725','2620 Westmar Ct.',0,'Toledo','OH','43615',NULL,'CY','39095','1950-10-21','M','',':RET:2054-5','N','021','HLT','1226322','92036OH003002605','2014-01-01','2013-12-10 13:44:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','601.12',NULL,0,'2013-12-25 19:20:33'),(9139,7247,'N','01','021','EC','A',NULL,NULL,'','0001138039','0001053043','','IL','1','Deckman','Pamela','','','','34','300482614','13762 HOWELL RD',0,'SAINT MARYS','OH','45885','9753','CY','39011','1950-04-11','F','',':RET:2106-3','N','021','HLT','1987200','92036OH003001501','2014-01-01','2013-12-18 13:48:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','678.46',NULL,0,'2013-12-26 04:08:08'),(19287,15373,'Y','18','021','EC','A','','','AC','0002002653','0002002653','LA00001567835','IL','1','gresham','jacqueline','antointte','','','34','550392904','1153 monet st',0,'baton rouge','LA','70806',NULL,'CY','22033','1970-07-20','F','U',':RET:2054-5','N','021','DEN','2762032','18575LA002000201','2014-03-01','2014-01-20 19:10:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:52'),(16649,13320,'Y','18','021','EC','A','','','AC','0000884430','0000884430','MS00002152409','IL','1','travis','helen','','','','34','436888199','94 LEON WALTERS RD',0,'SEMINARY','MS','39479','4072','CY','28031','1953-05-23','F','M',':RET:2106-3','N','021','DEN','1398218','46300MS002000201','2014-02-01','2014-01-07 12:37:59','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-08 18:24:20'),(3164,2546,'Y','18','021','EC','A','','','AC','0000203039','0000203039','OH00000265604','IL','1','alexakis','kyriakos','','','','34','286861518','8170 FOXDALE CT',0,'WEST CHESTER','OH','45069','5700','CY','39017','1973-03-03','M','U',':RET:2106-3','N','021','DEN','932054','99734OH005000401','2014-01-01','2013-11-18 11:13:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:24'),(7274,5768,'N','01','021','EC','A',NULL,NULL,'','0000440537','0000894840','','IL','1','MATTICK','STEPHEN','','','','34','463983705','721 GOLFCREST DR',0,'WINDCREST','TX','78239','2623','CY','48029','1955-07-12','M','',':RET:2106-3','N','021','DEN','1103883','33348TX002000201','2014-01-01','2013-12-14 14:23:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 02:02:30'),(2501,2037,'Y','18','024','14','A','','','TE','0000161576','0000161576','','IL','1','Pevey','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-23','M','',NULL,NULL,NULL,'','740848','','2013-12-09','2013-12-09 17:45:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:36:02'),(3813,3053,'N','01','021','EC','A',NULL,NULL,'','0000912935','0001183516','','IL','1','Williams','Jason','','','','34','294865519','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-01-06','M','',':RET:2054-5','N','021','DEN','783233','99734OH005000301','2014-01-01','2013-12-13 14:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:45'),(25999,20619,'Y','18','021','EC','A','','','AC','0001591675','0001591675','LA00001755747','IL','1','LEWIS','INEZ','','','','34','433493894','2116 BAUCUM PLACE',0,'HAYNESVILLE','LA','71038',NULL,'CY','22027','1978-10-01','F','U',NULL,'N','021','DEN','3103202','18575LA002000101','2014-04-01','2014-02-26 10:33:58','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-26 21:02:02'),(27403,21693,'Y','18','021','EC','A','','','AC','0000344196','0000344196','OH00003020203','S1','1','Ramos','Andrew','','','','34','680107396','8308 WAINSTEAD DR',0,'PARMA','OH','44129','4847','CY','39035','1998-10-09','F','U',':RET:2106-3','N','021','DEN','3600133','99734OH005000301','2014-04-01','2014-03-04 01:59:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2014-03-04 21:01:32'),(115,101,'Y','18','021','EC','A','','','AC','0000745350','0000745350','TX00001182978','IL','1','KERVIN','PENNY','','','','34','445549990','10865 COLONIAL HEIGHTS LANE',0,'FORT WORTH','TX','76179',NULL,'CY','48439','1953-01-30','F','U',NULL,'N','021','DEN','13983','33348TX002000201','2014-01-01','2013-12-05 15:16:33','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:18:04'),(400,329,'Y','18','021','EC','A','','','AC','0000855603','0000855603','OH00000974648','IL','1','Saenz','Martin','','','','34','457235077','1900 PARKWOOD DR NW',0,'WARREN','OH','44485','2323','CY','39155','1960-10-06','M','U',':RET:2106-3','T','021','DEN','1025515','99734OH005000401','2014-01-01','2013-12-04 05:17:45','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:46:08'),(21682,17315,'Y','18','021','EC','A','','','AC','0001012964','0001012964','OH00001446634','IL','1','Rowe','Sandra','','','','34','224136752','7160 LAZY TRL',0,'HILLSBORO','OH','45133','6440','CY','39071','1964-09-29','F','M',':RET:2106-3','N','021','HLT','2773746','92036OH004000601','2014-03-01','2014-02-05 18:09:34','694.32',NULL,NULL,'699.43','5.11','R-OH005','OH0','294.48',NULL,0,'2014-02-05 21:31:03'),(21558,17222,'Y','18','021','EC','A','','','AC','0001161578','0001161578','OH00001938198','IL','1','STIDHAM','DIANA','','','','34','297507205','17989 COUNTY ROAD 85',0,'BELLE CENTER','OH','43310','9650','CY','39065','1950-03-20','F','U',':RET:2106-3','N','021','DEN','3049647','99734OH005000401','2014-03-01','2014-02-05 16:40:06','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-05 21:30:17'),(7562,5986,'Y','18','021','EC','A','','','AC','0000315288','0000315288','MS00000536608','IL','1','Powers','Brian','','','','34','428437001','1004 Turtle Creek Blvd',0,'Oxford','MS','38655',NULL,'CY','28071','1976-09-21','M','U',':RET:2106-3','N','021','DEN','1234989','46300MS002000101','2014-01-01','2013-12-14 23:50:20','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 02:33:32'),(2797,2261,'N','01','021','EC','A',NULL,NULL,'','0001074115','0000335124','','IL','1','Fisher','Timothy','','','','34','287462571','9014 STATE ROUTE 3 WEST',0,'Clarksville','OH','45113',NULL,'CY','39027','1952-01-17','M','',':RET:2106-3','N','021','HLT','558510','92036OH001000601','2014-01-01','2013-12-02 12:24:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','727.64',NULL,0,'2013-12-25 19:50:18'),(3002,2413,'Y','18','021','EC','A','','','AC','0000888148','0000888148','OH00001038724','IL','1','Thomas','Vanessa','','','','34','294668405','1035 E BOWMAN ST',0,'WOOSTER','OH','44691','3119','CY','39169','1974-10-11','F','R',':RET:2106-3','N','021','DEN','633136','99734OH005000301','2014-01-01','2013-12-06 10:32:38','0.00',NULL,NULL,'21.13','21.13','R-OH014','OH0','0.00',NULL,0,'2013-12-25 20:17:40'),(20447,16331,'Y','18','021','EC','A','','','AC','0001063647','0001063647','MS00001397926','IL','1','CLAUSELL','DIETRICH','','','','34','425572272','10588 SHARP BLVD',0,'GULFPORT','MS','39503','4522','CY','28047','1972-10-22','M','U',':RET:2054-5','N','021','DEN','2621070','46300MS002000101','2014-03-01','2014-01-29 12:25:40','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-29 21:00:43'),(18794,14970,'Y','18','021','EC','A','','','AC','0000298257','0000298257','OH00002476909','IL','1','Trinh','Ana','','','','34','298944966','1250 WINFREE DR',0,'WESTERVILLE','OH','43081','3773','CY','39049','1975-10-09','F','M',':RET:2047-9','N','021','DEN','1461272','99734OH005000401','2014-03-01','2014-01-16 10:20:24','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-01-17 03:35:58'),(18613,14837,'Y','18','021','EC','A','','','AC','0001145996','0001145996','OH00002069491','IL','1','MARKINS','LEONARD','','','','34','287787927','801 N UNION ST',0,'FOSTORIA','OH','44830','2164','CY','39147','1970-07-30','M','M',':RET:2106-3','N','021','HLT','2514759','92036OH004002701','2014-02-01','2014-01-15 12:59:34','158.00',NULL,NULL,'212.76','54.76','R-OH006','OH0','212.76',NULL,0,'2014-01-16 08:47:24'),(4770,3784,'Y','18','021','EC','A','','','AC','0001258631','0001258631','OH00000421833','IL','1','Scott','Michael','','','','34','300885189','3330 RALPH AVE',0,'CLEVELAND','OH','44109','5511','CY','39035','1988-09-08','M','U',':RET:2106-3','N','021','DEN','10220','99734OH005000401','2014-01-01','2013-12-08 13:11:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:15:48'),(14989,11980,'Y','18','021','EC','A','','','AC','0000909870','0000909870','TX00000772344','IL','1','Gomez','Martha','M','','','34','450533543','1700 S Main street',0,'Midland','TX','79701',NULL,'CY','48329','1965-11-16','F','U',NULL,'N','021','DEN','1870719','33348TX002000201','2014-02-01','2013-12-30 16:12:27','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-01 12:01:22'),(5002,3967,'Y','18','021','EC','A','','','AC','0000921890','0000921890','OH00001190357','31','1','Haren','Deborah','','','','34','276660614','P.O. Box 1403',0,'Massillon','OH','44648',NULL,'CY','39151','1959-04-14','F','U',':RET:2106-3','N','021','DEN','842423','99734OH005000301','2014-01-01','2013-12-07 13:00:10','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 22:47:09'),(14941,11940,'Y','18','024','14','A','','','TE','0000418870','0000418870','','IL','1','SNOW','RAYMOND',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-22','M','',NULL,NULL,NULL,'','787040','','2013-12-29','2013-12-29 17:34:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-30 00:02:19'),(14947,11945,'N','01','021','EC','A',NULL,NULL,'','0001249240','0000491689','','IL','1','Abascal','Norma','Y','','','34','561066678','10002 PALE STAR DR',0,'HOUSTON','TX','77064','5486','CY','48201','1952-11-17','F','',':RET:2106-3','N','021','DEN','1988795','33348TX002000201','2014-02-01','2013-12-29 18:40:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:00:04'),(28763,22767,'Y','18','021','EC','A','','','AC','0000608013','0000608013','TX00002851261','IL','1','Castello Beatty','Esperanza','','','','34','541291226','23 BACK BAY CIR',0,'GALVESTON','TX','77551','1212','CY','48167','1958-01-02','F','U',':RET:2106-3','N','021','DEN','4045666','33348TX002000201','2014-04-01','2014-03-09 15:15:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-09 21:00:24'),(21292,17014,'Y','18','021','EC','A','','','AC','0001180852','0001180852','LA00002532736','IL','1','Williams','Cynthia','','','','34','570088167','10953 MAY BELLE CT',0,'BATON ROUGE','LA','70815','5102','CY','22033','1959-06-26','F','M',':RET:2054-5','N','021','DEN','3194839','18575LA002000101','2014-03-01','2014-02-04 13:02:02','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-02-04 21:00:07'),(20172,16098,'Y','18','021','EC','A','','','AC','0000207160','0000207160','OH00002047820','31','1','ALI','CHARISSE','','','','34','274829907','PO BOX 86',0,'GENEVA','OH','44041',NULL,'CY','39007','1968-02-10','F','M',':RET:2054-5','N','021','HLT','1448622','52664OH151001301','2014-03-01','2014-01-27 12:47:53','697.00',NULL,NULL,'1078.01','381.01','R-OH011','OH0','377.28',NULL,0,'2014-01-27 21:01:16'),(1315,1088,'N','19','021','EC','A',NULL,NULL,'','0000186069','0001001121','','IL','1','Purdy','Thomas','','','','34','828272756','119 RAVINEWOOD TER',0,'LOVELAND','OH','45140','7744','CY','39061','2012-06-01','M','',':RET:2106-3','N','021','DEN','335758','99734OH005000401','2014-01-01','2013-11-04 11:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:31:35'),(18363,14657,'N','19','021','EC','A',NULL,NULL,'','0000488009','0000822047','','IL','1','BIESENBENDER','CLAUDIA','RENEE','','','34','300029152','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1998-06-28','F','',':RET:2106-3','N','021','DEN','2772132','99734OH005000301','2014-02-01','2014-01-15 02:13:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:27'),(5189,4116,'Y','18','021','EC','A','','','AC','0000223700','0000223700','OH00000200172','IL','1','Butler','Joan','','','','34','292446714','7741 HARLEY HILLS DR',0,'NORTH ROYALTON','OH','44133','3663','CY','39035','1949-12-07','F','M',':RET:2106-3','N','021','DEN','2204000','99734OH005000401','2014-01-01','2013-12-19 13:34:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:43'),(6982,5540,'N','01','021','EC','A',NULL,NULL,'','0000573061','0000496762','','IL','1','hedges','scott','','','','34','300662415','4413 BENNETT RD',0,'TOLEDO','OH','43612','1909','CY','39095','1958-12-27','M','',':RET:2106-3','T','021','DEN','2214724','99734OH005000401','2014-02-01','2013-12-25 00:04:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:45'),(17867,14273,'Y','18','021','EC','A','','','AC','0001026959','0001026959','OH00001515079','IL','1','Wehby','Linda','','','','34','281525222','1432 Young Road',0,'Amelia','OH','45102',NULL,'CY','39025','1950-03-31','F','M',':RET:2106-3','N','021','DEN','1871048','99734OH005000401','2014-02-01','2014-01-14 12:56:26','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-15 02:06:12'),(15628,12501,'Y','18','021','EC','A','','','AC','0001366366','0001366366','LA00000314170','IL','1','Ferrand','Steven','','','','34','436314790','207 LESNA LN',0,'RUSTON','LA','71270','9031','CY','22061','1963-01-22','M','M',':RET:2054-5','N','021','DEN','2081332','18575LA002000101','2014-02-01','2013-12-31 12:14:06','0.00',NULL,NULL,'75.06','75.06','R-LA007','LA0','25.02',NULL,1,'2014-01-02 04:33:24'),(15231,12173,'N','01','021','EC','A',NULL,NULL,'','0000968222','0000479856','','IL','1','Kuhnell','Sarah','','','','34','274841292','5930 WOODSPOINT DR',0,'MILFORD','OH','45150','2157','CY','39025','1975-08-15','F','',':RET:2106-3','N','021','HLT','1445791','92036OH005000605','2014-02-01','2013-12-29 23:38:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.49',NULL,0,'2014-01-01 12:08:16'),(25276,20055,'Y','18','021','EC','A','','','AC','0001132137','0001132137','TX00003058700','IL','1','Guajardo','Jose','','','','34','632182115','206 DE GAIL ST',0,'GRAND SALINE','TX','75140','1332','CY','48467','1974-12-16','M','M',NULL,'N','021','DEN','3499800','33348TX002000201','2014-04-01','2014-02-25 11:11:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-02-25 21:00:15'),(25473,20210,'Y','18','021','EC','A','','','AC','0000506936','0000506936','TX00002729443','31','1','LANDEROS','ERIKA','','','','34','521873610','P.O. Box 17278',0,'El Paso','TX','79917',NULL,'CY','48141','1976-04-04','F','M',NULL,'N','021','DEN','3018403','33348TX002000201','2014-04-01','2014-02-25 17:36:00','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-25 21:31:39'),(28546,22592,'N','01','021','EC','A',NULL,NULL,'','0001014439','0000510712','','IL','1','Bragg','Timothy','R',NULL,NULL,NULL,NULL,'2260 COLUMBIA RD',0,'VALLEY CITY','OH','44280','9545','CY','39103','1960-10-12','M','',':RET:2106-3','T','021','HLT','3248686','52664OH151001501','2014-04-01','2014-03-07 16:20:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','627.47',NULL,0,'2014-03-07 21:32:17'),(22531,17989,'Y','18','021','EC','A','','','AC','0000659627','0000659627','MS00002162179','IL','1','Brock','Tara','','','','34','425655891','707 PARKER DR',0,'CLINTON','MS','39056','4037','CY','28049','1983-12-08','F','U',':RET:2106-3','N','021','DEN','3783796','46300MS002000201','2014-03-01','2014-02-09 21:54:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 21:31:32'),(13272,10593,'Y','18','021','EC','A','','','AC','0000006179','0000006179','TX00001169879','IL','1','WOODS','KRISTI','SMITH','','','34','458199493','4004 BANDERA DR',0,'GRANBURY','TX','76049',NULL,'CY','48221','1959-09-29','F','M',NULL,'T','021','DEN','2547270','33348TX002000201','2014-01-01','2013-12-23 12:26:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:56'),(9802,7761,'Y','18','021','EC','A','','','AC','0000598711','0000598711','OH00000253894','IL','1','Myers','Christopher','','','','34','278924902','6118 OAKBRIDGE WAY',0,'MILFORD','OH','45150','5619','CY','39025','1988-11-17','M','U',':RET:2106-3','N','021','HLT','204424','92036OH006000601','2014-01-01','2013-10-20 19:18:18','0.00',NULL,NULL,'170.93','170.93','R-OH005','OH0','170.93',NULL,0,'2013-12-26 05:01:15'),(8129,6431,'Y','18','021','EC','A','','','AC','0000156896','0000156896','OH00001073004','IL','1','Jennings','Eileen','','','','34','274569493','30630 Drouillard Road Lot360',0,'Walbridge','OH','43465',NULL,'CY','39173','1953-11-02','F','M',':RET:2106-3','N','021','DEN','1159393','99734OH005000401','2014-01-01','2013-11-22 11:04:45','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 03:15:28'),(20605,16463,'N','01','021','EC','A',NULL,NULL,'','0000327304','0000262758','','IL','1','DELONG','JAMES','','','','34','291644892','22260 SYCAMORE RD',0,'MOUNT VERNON','OH','43050',NULL,'CY','39083','1969-12-22','M','',':RET:2106-3','N','021','DEN','2730305','99734OH005000401','2014-03-01','2014-01-30 14:15:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:15'),(20500,16378,'Y','18','021','EC','A','','','AC','0002154907','0002154907','LA00001492575','IL','1','MEJIA','JOSE','L','','','34','632682730','14300 JOSEPH RD',0,'FOLSOM','LA','70437','5844','CY','22103','1963-06-22','M','U',NULL,'N','021','DEN','3139205','18575LA002000201','2014-03-01','2014-01-29 13:35:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:12'),(4428,3519,'Y','18','021','EC','A','','','AC','0000251603','0000251603','OH00001286703','IL','1','HILL','STANLEY','','','','34','300460375','8103 CONSTITUTION DR',0,'CINCINNATI','OH','45215',NULL,'CY','39061','1952-11-20','M','U',':RET:2054-5','N','021','DEN','897557','99734OH005000401','2014-01-01','2013-12-12 17:17:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:47'),(6731,5339,'Y','18','021','EC','A','','','AC','0001135134','0001135134','OH00000914893','IL','1','Waltz','Cheryl','','','','34','268640805','248 STORER AVE',0,'AKRON','OH','44302','1119','CY','39153','1958-08-25','F','U',':RET:2106-3','N','021','DEN','182914','99734OH005000401','2014-01-01','2013-11-25 09:21:24','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:15:29'),(4862,3853,'Y','18','021','EC','A','','','AC','0000015186','0000015186','TX00000597178','IL','1','ALVAREZ','STEVEN','','','','34','465793184','5939 GLACIER SUN DR',0,'SAN ANTONIO','TX','78244','1255','CY','48029','1986-07-22','M','U',NULL,'N','021','DEN','259991','33348TX002000101','2014-01-01','2013-11-08 15:18:17','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 22:30:42'),(19481,15528,'Y','18','021','EC','A','','','AC','0001119622','0001119622','TX00001816355','IL','1','Harris','Wanda','','','','34','465395581','1907 LAUREL OAKS DR',0,'HOUSTON','TX','77014','3670','CY','48201','1967-06-09','F','U',':RET:2054-5','N','021','DEN','2405866','33348TX002000201','2014-03-01','2014-01-22 17:23:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-23 03:02:03'),(16312,13060,'Y','18','021','EC','A','','','AC','0002205371','0002205371','LA00001495445','IL','1','Semien','Roselind','','','','34','434391505','2045 6TH ST',0,'LAKE CHARLES','LA','70601','4764','CY','22019','1966-02-26','F','M',':RET:2054-5','T','021','DEN','1390753','18575LA002000201','2014-02-01','2014-01-06 16:14:01','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-07 04:01:27'),(27781,21971,'Y','18','021','EC','A','','','AC','0000490539','0000490539','OH00003157500','IL','1','MCCAULEY','WILLIAM','','','Jr','34','286606212','2371 STATE ROUTE 225',0,'DEERFIELD','OH','44411','9733','CY','39133','1969-01-01','M','U',':RET:2106-3','T','021','HLT','3187848','52664OH152000901','2014-04-01','2014-03-05 14:18:51','155.00',NULL,NULL,'271.24','116.24','R-OH012','OH0','271.24',NULL,0,'2014-03-05 21:31:34'),(24785,19659,'N','01','021','EC','A',NULL,NULL,'','0000947441','0000807554','','IL','1','GARZA','RICHARD','','','','34','302782700','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-11-19','M','',NULL,'T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:46:05'),(21090,16853,'Y','18','021','EC','A','','','AC','0000953474','0000953474','MS00002478391','IL','1','Shelton','Krystal','','','','34','410639321','5763 HUNTERS CHASE DR',0,'SOUTHAVEN','MS','38672','6539','CY','28033','1972-04-22','F','U',':RET:2106-3','N','021','DEN','3795609','46300MS002000101','2014-03-01','2014-02-01 22:38:25','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-02 19:00:27'),(13296,10613,'Y','18','021','EC','A','','','AC','0001069106','0001069106','TX00000071977','IL','1','Withrow','Kathryn','','','','34','464236963','4203 COUNTY ROAD 2216',0,'CADDO MILLS','TX','75135','8215','CY','48231','1957-11-07','F','R',':RET:2106-3','N','021','DEN','1986062','33348TX002000201','2014-01-01','2013-12-23 14:09:08','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:37'),(1690,1412,'Y','18','021','EC','A','','','AC','0001448394','0001448394','LA00000345923','IL','1','NAZARETIAN','WANDA','','','','34','425048447','1725 ESPLANADE AVE',0,'NEW ORLEANS','LA','70116','1702','CY','22071','1956-02-24','F','U',':RET:2106-3','N','021','DEN','1366924','18575LA002000101','2014-01-01','2013-12-24 17:55:34','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:25'),(8034,6361,'Y','18','021','EC','A','','','AC','0001186304','0001186304','OH00000225804','IL','1','Altman','Charles','','','','34','291845568','1710 S BLANCHARD ST',0,'FINDLAY','OH','45840','6160','CY','39063','1970-12-16','M','U',':RET:2106-3','N','021','HLT','1461804','92036OH005001505','2014-01-01','2013-12-19 21:17:17','208.00',NULL,NULL,'298.65','90.65','R-OH002','OH0','298.65',NULL,0,'2013-12-26 03:09:14'),(27125,21472,'Y','18','021','EC','A','','','AC','0000679588','0000679588','OH00003117712','IL','1','Saunders','David','','','','34','297540323','2870 S WALNUT HILL DRIVE',0,'ELMORE','OH','43416',NULL,'CY','39123','1954-09-01','M','M',':RET:2106-3','N','021','HLT','3609945','92036OH004002701','2014-04-01','2014-03-03 09:22:11','0.00',NULL,NULL,'408.14','408.14','R-OH006','OH0','408.14',NULL,0,'2014-03-03 21:30:36'),(28432,22499,'Y','18','021','EC','A','','','AC','0000547943','0000547943','OH00003498734','IL','1','Serio','Justin','','','','34','354705340','404 Webb St',0,'Saint Marys','OH','45885',NULL,'CY','39011','1981-10-03','M','M',':RET:2106-3','N','021','HLT','3747252','92036OH003001505','2014-04-01','2014-03-06 18:37:00','564.00',NULL,NULL,'830.18','266.18','R-OH002','OH0','271.90',NULL,0,'2014-03-07 21:31:09'),(351,288,'Y','18','021','EC','A','','','AC','0000560324','0000560324','TX00000524610','IL','1','Upchurch','Jackie','','','','34','451278919','219 W WOODY CREEK CT',0,'SPRINGTOWN','TX','76082','6624','CY','48367','1958-07-23','F','U',':RET:2106-3','N','021','DEN','161179','33348TX002000101','2014-01-01','2013-11-08 20:31:00','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 17:32:16'),(4207,3346,'Y','18','021','EC','A','','','AC','0000573658','0000573658','TX00001244469','IL','1','Jameei','Vahid','','','','34','640295757','6071 VILLAGE BEND DR',0,'DALLAS','TX','75206','3580','CY','48113','1977-09-21','M','M',':RET:2106-3','N','021','DEN','1789126','33348TX002000201','2014-01-01','2013-12-16 21:14:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:50:04'),(22335,17836,'Y','18','021','EC','A','','','AC','0001070365','0001070365','TX00001857899','IL','1','Conley','Ronald','','','','34','509520602','7129 COUNTY ROAD 526',0,'MANSFIELD','TX','76063','7201','CY','48439','1954-11-15','M','U',':RET:2106-3','N','021','DEN','2841254','33348TX002000101','2014-03-01','2014-02-03 18:10:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-10 11:01:04'),(6073,4813,'Y','18','021','EC','A','','','AC','0001169413','0001169413','OH00000420504','IL','1','Currie','Michael','','','','34','292540688','439 W 29TH ST',0,'ASHTABULA','OH','44004','4921','CY','39007','1952-07-10','M','R',':RET:2054-5','N','021','HLT','1078422','52664OH152000901','2014-01-01','2013-11-30 20:22:38','0.00',NULL,NULL,'517.67','517.67','R-OH011','OH0','517.67',NULL,0,'2013-12-26 00:02:15'),(9173,7276,'Y','18','021','EC','A','','','AC','0000854181','0000854181','OH00001292111','IL','1','McGrath','Matthew','','','','34','289864972','5486 S GARRETT DR',0,'MILFORD','OH','45150','2841','CY','39025','1982-08-30','M','M',':RET:2106-3','T','021','HLT','1389997','92036OH005000601','2014-01-01','2013-12-18 11:27:35','0.00',NULL,NULL,'572.26','572.26','R-OH005','OH0','286.13',NULL,0,'2013-12-26 04:08:59'),(21842,17443,'Y','18','021','EC','A','','','AC','0001221973','0001221973','OH00002359821','IL','1','Stuart','Steven','','','','34','276647728','7220 CRABAPPLE CV',0,'WHITEHOUSE','OH','43571','9838','CY','39095','1957-06-19','M','U',NULL,'N','021','HLT','2667053','92036OH005002601','2014-03-01','2014-02-06 11:38:34','108.00',NULL,NULL,'454.92','346.92','R-OH001','OH0','454.92',NULL,0,'2014-02-06 21:01:11'),(6611,5241,'N','01','021','EC','A',NULL,NULL,'','0001182484','0001207131','','IL','1','McGuire','Heidi','D','','','34','367021166','107 Brookside Drive',0,'Anna','OH','45302',NULL,'CY','39149','1987-05-07','F','',':RET:2106-3','N','021','HLT','260347','92036OH003000506','2014-01-01','2013-12-11 15:07:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','254.19',NULL,0,'2013-12-26 00:53:45'),(14595,11648,'Y','18','021','EC','A','','','AC','0001019280','0001019280','OH00001053295','IL','1','Fox','Randi','Gail','','','34','282566117','227 DELORA DR',0,'AKRON','OH','44319','2410','CY','39153','1953-10-10','F','M',':RET:2106-3','N','021','HLT','1850034','52664OH151001304','2014-02-01','2013-12-27 12:08:34','385.00',NULL,NULL,'605.24','220.24','R-OH012','OH0','605.24',NULL,0,'2013-12-28 03:36:14'),(17631,14096,'Y','18','024','14','A','','','TE','0000522785','0000522785','','IL','1','SADEGHBEGI','MEDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-01-12','M','',NULL,NULL,NULL,'','2004727','','2014-01-13','2014-01-13 17:24:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-14 01:32:33'),(21666,17304,'Y','18','021','EC','A','','','AC','0002020256','0002020256','LA00001707111','IL','1','Israel','Melissa','','','','34','434570368','188 WILDWOOD DR',0,'PINEVILLE','LA','71360','4565','CY','22079','1975-06-30','F','M',':RET:2106-3','N','021','DEN','3251886','18575LA002000201','2014-03-01','2014-02-05 14:51:46','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-05 21:30:57'),(26501,21021,'N','19','021','EC','A',NULL,NULL,'','0001064742','0000881651','','IL','1','PODOLL','OWEN','','','','34','206726300','5625 NICHOLSON DR',0,'HUDSON','OH','44236','3700','CY','39153','1991-12-01','M','',NULL,'N','021','HLT','3055284','52664OH151001304','2014-03-01','2014-02-28 16:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01','CIC',0,'2014-02-28 21:00:15'),(26664,21138,'Y','18','021','EC','A','','','AC','0002288784','0002288784','LA00002238633','IL','1','Muhammad','nadiyah','','','','34','434336210','p o box 604',0,'Natalbany','LA','70451',NULL,'CY','22105','1964-05-24','F','U',':RET:2054-5','N','021','DEN','3847563','18575LA002000201','2014-04-01','2014-02-27 20:58:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:13'),(26845,21276,'Y','18','021','EC','A','','','AC','0001859015','0001859015','LA00003464197','IL','1','Byers','Eddie','C','','','34','433965101','823 EDDIE SCOTT AVE',0,'CROWLEY','LA','70526','3331','CY','22001','1956-03-23','M','U',':RET:2054-5','N','021','DEN','2731042','18575LA002000201','2014-04-01','2014-03-01 13:16:53','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-01 21:00:47'),(28083,22225,'N','01','021','EC','A',NULL,NULL,'','0000524344','0001175225','','IL','1','WALLACE','BOBBY','','','','34','467218128','19472 FM 850',0,'ARP','TX','75750',NULL,'CY','48423','1957-01-01','M','',':RET:2054-5','N','021','DEN','3760085','33348TX002000101','2014-04-01','2014-03-06 14:45:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-06 21:01:59'),(29121,23054,'Y','18','021','EC','A','','','AC','0000609604','0000609604','OH00003307464','IL','1','Klotz','Jimmy','Lawrence','','Jr','34','290699384','11426 W TOWNSHIP ROAD 33',0,'FOSTORIA','OH','44830','9588','CY','39147','1968-12-20','M','U',':RET:2106-3','N','021','HLT','3660016','92036OH005002705','2014-04-01','2014-03-10 09:15:37','177.00',NULL,NULL,'281.58','104.58','R-OH006','OH0','281.58',NULL,0,'2014-03-10 21:02:30'),(22362,17858,'Y','18','021','EC','A','','','AC','0001174396','0001174396','OH00002341773','IL','1','Thornton','Christine','','','','34','299825891','8317 WAINSTEAD DR',0,'PARMA','OH','44129','4846','CY','39035','1985-01-27','F','M',':RET:2106-3','N','021','DEN','2973163','99734OH005000301','2014-02-01','2014-02-10 12:13:55','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00','CIC',0,'2014-02-10 21:00:08'),(2408,1966,'N','01','021','EC','A',NULL,NULL,'','0000927284','0001212326','','IL','1','miller','donna','','','','34','298466603','28 beechwood dr',0,'youngstown','OH','44512',NULL,'CY','39099','1952-02-11','F','',':RET:2106-3','N','021','DEN','1024130','99734OH005000401','2014-01-01','2013-12-09 14:34:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:41'),(15967,12779,'Y','18','021','EC','A','','','AC','0000652649','0000652649','TX00001360789','IL','1','Garcia','Jose','F','','','34','346724313','704 E 4TH ST',0,'ODESSA','TX','79761','5210','CY','48135','1952-02-15','M','M',NULL,'N','021','DEN','1855243','33348TX002000201','2014-02-01','2014-01-02 18:35:59','0.00',NULL,NULL,'29.22','29.22','R-TX017','TX0','14.61',NULL,0,'2014-01-04 02:00:29'),(14706,11742,'Y','18','021','EC','A','','','AC','0000377467','0000377467','OH00001315353','IL','1','Syrjanen','William','','','','34','280844485','2063 KNOLLWOOD AVE',0,'POLAND','OH','44514','1519','CY','39099','1978-07-06','M','U',':RET:2106-3','N','021','DEN','2109589','99734OH005000301','2014-02-01','2013-12-28 14:15:26','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,1,'2013-12-29 11:09:13'),(5037,3989,'Y','18','021','EC','A','','','AC','0001190027','0001190027','OH00000568818','IL','1','Sharkey','Daniel','','','','34','293504076','2116 EAGLEBROOKE PKWY',0,'CELINA','OH','45822','8340','CY','39107','1954-12-07','M','R',':RET:2106-3','N','021','HLT','696009','92036OH004001501','2014-01-01','2013-12-07 11:01:45','0.00',NULL,NULL,'891.92','891.92','R-OH002','OH0','460.65',NULL,0,'2013-12-25 22:47:53'),(7529,5959,'Y','18','021','EC','A','','','AC','0000193454','0000193454','TX00001307435','IL','1','Calhoun','Rebeka','Renae','','','34','461833108','162 HCR 3131',0,'HILLSBORO','TX','76645','4035','CY','48217','1977-08-17','F','U',':RET:2054-5','N','021','DEN','149705','33348TX002000201','2014-01-01','2013-12-14 22:31:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:32:37'),(26454,20981,'N','01','021','EC','A',NULL,NULL,'','0000177461','0000633321','','IL','1','Bretheim','Shelly','','','','34','587517497','147 CHINQUIPIN CV',0,'RIDGELAND','MS','39157','1007','CY','28089','1973-08-29','F','',':RET:2106-3','N','021','DEN','3260961','46300MS002000101','2014-03-01','2014-02-27 07:32:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15','CIC',0,'2014-02-28 07:30:27'),(26567,21063,'Y','18','024','14','A','','','TE','0000692965','0000692965','','IL','1','Mueller','Shane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-07','M','',NULL,NULL,NULL,'','3742651','','2014-02-28','2014-02-28 10:57:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 21:30:24'),(27680,21892,'Y','18','021','EC','A','','','AC','0000552165','0000552165','TX00002671912','IL','1','fortuna','jorge','','','','34','644420125','305 HUMPHREY AVE',0,'PALACIOS','TX','77465','4439','CY','48321','1979-05-25','M','M',':RET:2106-3','N','021','DEN','2853165','33348TX002000201','2014-04-01','2014-03-04 20:21:47','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:30:38'),(28884,22860,'Y','18','021','EC','A','','','AC','0000102599','0000102599','TX00003547846','IL','1','Bryce','April','','','','34','385860603','610 LAKESHORE DR',0,'MARBLE FALLS','TX','78654','7272','CY','48053','1974-04-30','F','U',NULL,'N','021','DEN','4245152','33348TX002000201','2014-04-01','2014-03-10 12:41:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:10'),(21594,17247,'N','19','021','EC','A',NULL,NULL,'','0001160446','0001124110','','S1','1','Sheeley','Scott','Anthony','','','34','296064079','504 DAKOTA RD',0,'BELLEFONTAINE','OH','43311','2347','CY','39091','2002-03-24','M','',':RET:2106-3','N','021','DEN','3810658','99734OH005000301','2014-03-01','2014-02-05 10:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:30'),(20622,16479,'Y','18','021','EC','A','','','AC','0001136991','0001136991','TX00001589120','IL','1','jurado','victor','','','','34','450551912','903 w calais pl',0,'laredo','TX','78045',NULL,'CY','48479','1966-08-03','M','M',NULL,'N','021','DEN','3302500','33348TX002000201','2014-03-01','2014-01-29 18:33:49','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2014-01-30 21:00:24'),(7522,5953,'Y','18','021','EC','A','','','AC','0000247877','0000247877','OH00000939055','IL','1','WILLIAMS','KENNETH','','','','34','283544395','6211 GRACELAND AVE',0,'CINCINNATI','OH','45237',NULL,'CY','39061','1956-01-04','M','U',':RET:2054-5','T','021','HLT','566549','92036OH006001201','2014-01-01','2013-12-15 15:29:41','397.00',NULL,NULL,'477.13','80.13','R-OH004','OH0','477.13',NULL,0,'2013-12-26 02:32:25'),(19672,15676,'Y','18','021','EC','A','','','AC','0000564083','0000564083','TX00001948048','IL','1','REYNA','SANDRA','','','','34','638846143','308 N CAGE BLVD',0,'PHARR','TX','78577','3904','CY','48215','1963-06-22','F','U',NULL,'N','021','DEN','1855702','33348TX002000201','2014-03-01','2014-01-22 19:06:43','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-23 21:00:32'),(8101,6410,'N','19','021','EC','A',NULL,NULL,'','0000781890','0000745431','','IL','1','Horrigan','Sean','Michael','','','34','277027823','1273 SHERMAN ST',0,'AKRON','OH','44301','1811','CY','39153','1997-03-24','M','',':RET:2106-3','N','021','HLT','2141014','52664OH151001501','2014-01-01','2013-12-20 17:53:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 03:10:53'),(18985,15125,'N','01','021','EC','A',NULL,NULL,'','0000675473','0001194151','','IL','1','Manley','Marjoriejo','','','','34','276721140','30705 STEWART HOLLOW RD',0,'MIDDLEPORT','OH','45760','9765','CY','39105','1968-11-28','F','',':RET:2106-3','N','021','DEN','2264386','99734OH005000301','2014-03-01','2014-01-17 12:24:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:08'),(3261,2628,'Y','18','021','EC','A','','','AC','0000097920','0000097920','LA00001312803','IL','1','Harris','Derick','','','','34','433776908','3125 BANKS ST',0,'NEW ORLEANS','LA','70119','7208','CY','22071','1987-02-25','M','U',':RET:2106-3','N','021','DEN','243142','18575LA002000201','2014-01-01','2013-11-27 18:32:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:46:53'),(18167,14507,'Y','18','021','EC','A','','','AC','0001016873','0001016873','OH00002210738','IL','1','byers','brent','','','','34','284705876','4192 WHITE OAK RD',0,'BLUE CREEK','OH','45616','9026','CY','39001','1960-11-12','M','M',NULL,'T','021','HLT','2676347','92036OH005000601','2014-02-01','2014-01-14 12:24:18','476.00',NULL,NULL,'887.01','411.01','R-OH005','OH0','503.62',NULL,0,'2014-01-15 02:07:56'),(26052,20661,'N','01','021','EC','A',NULL,NULL,'','0000808714','0000476019','','IL','1','Johnson','Marla','M','','','34','560585807','1023 TOWNSHIP ROAD 1682',0,'ASHLAND','OH','44805','9281','CY','39005','1956-12-17','F','',':RET:2106-3','N','021','HLT','3595104','52664OH151001305','2014-04-01','2014-02-26 17:58:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2014-02-26 21:02:34'),(5411,4294,'N','19','021','EC','A',NULL,NULL,'','0000974082','0001161530','','IL','1','Middleton','Amanda','Jo','','','34','274946938','719 MCCUNE RD',0,'WILMINGTON','OH','45177','8715','CY','39027','1991-06-26','F','',':RET:2106-3','N','021','HLT','1575700','92036OH003000601','2014-01-01','2013-12-19 13:29:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2013-12-25 23:09:09'),(13229,10555,'Y','18','021','EC','A','','','AC','0000304011','0000304011','TX00001098835','IL','1','REED','JAMES','','','','34','463907936','7337 FREDRICKSBURG DR',0,'FOREST HILL','TX','76140','2546','CY','48439','1951-12-18','M','M',':RET:2054-5','N','021','DEN','1762968','33348TX002000201','2014-01-01','2013-12-22 21:30:59','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:55:43'),(13992,11147,'Y','18','024','14','A','','','TE','0000964721','0000964721','','IL','1','WARSAW','STACY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-01-25','F','',NULL,NULL,NULL,'','1452688','','2013-12-23','2013-12-23 05:26:38',NULL,NULL,NULL,NULL,NULL,NULL,'MI0',NULL,'CANCEL',0,'2013-12-26 13:15:50'),(13538,10794,'Y','18','021','EC','A','','','AC','0001960926','0001960926','LA00000981719','31','1','Henry','Russell','','','','34','437239694','P.O. Box 351',0,'Sicily Island','LA','71368',NULL,'CY','22025','1966-10-14','M','U',':RET:2054-5','N','021','DEN','1593225','18575LA002000201','2014-01-01','2013-12-23 13:03:24','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 13:03:41'),(24832,19686,'Y','18','021','EC','A','','','AC','0000709756','0000709756','MS00003010949','IL','1','Thomas','James','Hoyat','','','34','587115418','208 VALLEY RIDGE DR',0,'JACKSON','MS','39206','3157','CY','28049','1961-09-02','M','M',':RET:2054-5','N','021','DEN','2622935','46300MS002000101','2014-04-01','2014-02-18 22:51:01','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:52:23'),(28724,22733,'Y','18','021','EC','A','','','AC','0001751453','0001751453','LA00003581140','IL','1','Kern','Michael','D','','Sr','34','267296135','4108 W PARK AVE',0,'GRAY','LA','70359','3202','CY','22109','1957-02-21','M','M',':RET:2106-3','N','021','DEN','4269266','18575LA002000101','2014-04-01','2014-03-08 18:03:58','0.00',NULL,NULL,'50.04','50.04','R-LA002','LA0','25.02',NULL,0,'2014-03-09 20:59:59'),(3213,2585,'Y','18','021','EC','A','','','AC','0000263911','0000263911','TX00000975741','IL','1','Hargrave','Cathy','Williams','','','34','403883548','5613 WILLOWBROOK DR',0,'ROWLETT','TX','75088','7663','CY','48113','1957-05-03','F','M',':RET:2106-3','N','021','DEN','224878','33348TX002000201','2014-01-01','2013-10-31 18:39:42','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:45:29'),(23020,18355,'Y','18','021','EC','A','','','AC','0000881301','0000881301','TX00002267994','IL','1','Italico','Nicholas','','','','34','085580314','5216 Cameron creek lane',0,'Fort Worth','TX','76132',NULL,'CY','48439','1962-12-12','M','U',':RET:2106-3','N','021','DEN','2642686','33348TX002000201','2014-03-01','2014-02-11 18:36:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-12 21:30:29'),(22975,18319,'Y','18','021','EC','A','','','AC','0000988927','0000988927','OH00002270452','IL','1','Scherr','Adam','','','','34','413491321','3914 LITTLE CREEK DR',0,'AMELIA','OH','45102','1173','CY','39025','1982-09-08','M','R',':RET:2106-3','T','021','DEN','3198987','99734OH005000301','2014-03-01','2014-02-11 18:31:58','0.00',NULL,NULL,'59.76','59.76','R-OH005','OH0','0.00',NULL,0,'2014-02-12 21:30:04'),(13153,10492,'N','01','021','EC','A',NULL,NULL,'','0000205786','0000670259','','IL','1','Teague','Eddie','Lee','','','34','290485921','PO Box 373',0,'Anna','OH','45302',NULL,'CY','39149','1950-12-18','M','',NULL,'N','021','DEN','1668629','99734OH005000401','2014-01-01','2013-12-23 17:05:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:38'),(22625,18067,'Y','18','021','EC','A','','','AC','0000565490','0000565490','TX00002136443','IL','1','TATY','CECILIA','','','','34','628921632','3000 GREENRIDGE DR',0,'HOUSTON','TX','77057',NULL,'CY','48201','1971-10-08','F','U',':RET:2054-5','N','021','DEN','3204068','33348TX002000201','2014-03-01','2014-02-10 21:26:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:13'),(20809,16628,'Y','18','021','EC','A','','','AC','0000374450','0000374450','TX00001536900','IL','1','GUERRERO','RAYMOND','','','III','34','381982278','4825 52ND ST',0,'LUBBOCK','TX','79414','3701','CY','48303','1986-12-16','M','U',NULL,'N','021','DEN','3652668','33348TX002000201','2014-03-01','2014-01-31 16:56:37','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-31 21:00:27'),(16428,13145,'Y','18','021','EC','A','','','AC','0001891947','0001891947','LA00001780400','IL','1','Jackson','Delisa','M','','','34','433153447','118 NORFOLK PL',0,'MONROE','LA','71202','3919','CY','22073','1965-06-24','F','M',NULL,'N','021','DEN','2201374','18575LA002000101','2014-02-01','2014-01-06 18:10:58','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2014-01-07 04:04:43'),(25844,20487,'Y','18','021','EC','A','','','AC','0000439461','0000439461','OH00002877591','IL','1','weaver','wilfred','','','','34','300441047','3760 EASTERN RD',0,'NORTON','OH','44203','8104','CY','39169','1950-07-31','M','U',':RET:2106-3','N','021','HLT','3212237','52664OH152000901','2014-04-01','2014-02-26 07:54:45','366.00',NULL,NULL,'482.18','116.18','R-OH014','OH0','482.18',NULL,0,'2014-02-26 21:00:37'),(27842,22022,'N','01','021','EC','A',NULL,NULL,'','0000499882','0000988825','','IL','1','Avendano','Corina','','','','34','640185114','3004 N ALAMO RD',0,'EDINBURG','TX','78542','2937','CY','48215','1990-07-22','F','',':RET:2106-3','N','021','DEN','2985645','33348TX002000101','2014-04-01','2014-03-04 22:01:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-05 21:32:08'),(23763,18911,'N','19','021','EC','A',NULL,NULL,'','0001146017','0000393723','','IL','1','DiMuzio','Angela','','','','34','286023510','614 COLEBERRY CT',0,'CLEVES','OH','45002','1390','CY','39061','1997-10-02','F','',':RET:2106-3','N','021','DEN','2812096','99734OH005000301','2014-03-01','2014-02-14 14:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:11'),(22125,17659,'N','19','021','EC','A',NULL,NULL,'','0000101467','0001138081','','S1','1','Ratliff','Melissa','','','','34','402637998','2108 INDIAN RIDGE DR',0,'PIQUA','OH','45356','8268','CY','39109','2004-09-30','M','',':RET:2106-3','N','021','HLT','2819217','92036OH004000501','2014-03-01','2014-02-08 17:01:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-02-08 19:00:41'),(17568,14046,'Y','18','021','EC','A','','','AC','0001128016','0001128016','OH00001659278','31','1','JILANI','Jilani','M','','','34','673037396','P.O.Box 247364',0,'Columbus','OH','43224',NULL,'CY','39049','1968-05-03','M','U',':RET:2054-5','N','021','DEN','2440043','99734OH005000401','2014-02-01','2014-01-13 09:54:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:32:00'),(2755,2228,'N','01','021','EC','A',NULL,NULL,'','0000249092','0000779078','','IL','1','LUOMA','RONALD','ALLEN','','','34','276808757','910 E 15TH ST',0,'ASHTABULA','OH','44004','3624','CY','39007','1967-03-28','M','',':RET:2106-3','T','021','HLT','1247802','52664OH151001305','2014-01-01','2013-12-02 11:34:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','433.87',NULL,0,'2013-12-25 19:49:10'),(16499,13200,'Y','18','021','EC','A','','','AC','0000139026','0000139026','OH00001381472','IL','1','SMALL','SCOTT','','','','34','554339761','305 EASTOWN DR',0,'WAPAKONETA','OH','45895','1794','CY','39011','1958-09-09','M','U',':RET:2106-3','N','021','HLT','1373601','92036OH003001504','2014-02-01','2014-01-06 14:17:08','366.00',NULL,NULL,'512.54','146.54','R-OH002','OH0','512.54',NULL,0,'2014-01-07 04:06:46'),(15963,12776,'N','01','021','EC','A',NULL,NULL,'','0000471025','0000011173','','IL','1','Clark','Robert','','','','34','294682747','303 Mt. Tabor Rd',0,'Waverly','OH','45690',NULL,'CY','39131','1962-12-10','M','',':RET:2106-3','N','021','DEN','2276887','99734OH005000301','2014-02-01','2014-01-03 13:40:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:22'),(14929,11929,'Y','18','021','EC','A','','','AC','0000200324','0000200324','TX00001868203','IL','1','Thomas','Robert','','','','34','463933558','19534 AVENTINE PLANTATION DR',0,'KATY','TX','77449','2685','CY','48201','1986-02-02','M','U',':RET:2054-5','N','021','DEN','2223066','33348TX002000101','2014-02-01','2013-12-28 23:43:31','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-30 00:01:56'),(5023,3981,'Y','18','021','EC','A','','','AC','0000197130','0000197130','OH00000297177','IL','1','Griffin','Paula','','','','34','274745472','19 WOODSIDE DR',0,'ARCANUM','OH','45304','1345','CY','39037','1962-04-02','F','U',':RET:2106-3','N','021','HLT','394938','92036OH004000501','2014-01-01','2013-12-07 12:42:12','321.00',NULL,NULL,'356.48','35.48','R-OH003','OH0','356.48',NULL,0,'2013-12-25 22:47:36'),(13331,10644,'Y','18','021','EC','A','','','AC','0000758210','0000758210','TX00000455289','IL','1','Holmes','Cameron','','','','34','319784643','4700 E Riverside Dr',0,'Austin','TX','78741',NULL,'CY','48453','1984-01-11','F','U',':RET:2054-5','N','021','DEN','2289257','33348TX002000201','2014-01-01','2013-12-23 17:45:26','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:58:37'),(267,220,'Y','18','021','EC','A','','','AC','0000073910','0000073910','OH00000459681','IL','1','Cole','Michael','','','','34','286508906','43373 HASTINGS RD',0,'OBERLIN','OH','44074','9504','CY','39093','1951-01-22','M','M',':RET:2106-3','N','021','HLT','567406','92036OH005000801','2014-01-01','2013-12-05 12:24:53','643.00',NULL,NULL,'1343.40','700.40','R-OH011','OH0','671.70',NULL,0,'2013-12-25 17:21:59'),(20070,16009,'Y','18','021','EC','A','','','AC','0000613887','0000613887','TX00001812752','IL','1','Mayers','Stephanie',NULL,NULL,NULL,NULL,NULL,'821 AVENUE C',0,'HUNTSVILLE','TX','77320','5406','CY','48471','1977-03-27','F','M',':RET:2054-5','N','021','DEN','2770877','33348TX002000201','2014-03-01','2014-01-27 14:08:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:16'),(18970,15116,'Y','18','021','EC','A','','','AC','0000924819','0000924819','OH00002218401','IL','1','GAJKOWSKI','TERESA','','','','34','271887689','17263 South Boone Road',0,'Columbia Station','OH','44028',NULL,'CY','39093','1976-11-29','F','M',':RET:2106-3','N','021','DEN','3024697','99734OH005000301','2014-03-01','2014-01-16 21:10:51','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:06:01'),(1542,1285,'Y','18','021','EC','A','','','AC','0000444917','0000444917','OH00000905536','IL','1','DOUGLASS','ANNE','TENISON','','','34','271748471','60 E COTTAGE ST',0,'CHAGRIN FALLS','OH','44022','2729','CY','39035','1962-06-03','F','U',NULL,'N','021','DEN','1721068','99734OH005000401','2014-01-01','2013-12-24 17:45:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:20'),(7253,5753,'Y','18','021','EC','A','','','AC','0000291958','0000291958','OH00000983417','31','1','Mills','Mike','','','','34','271640963','PO Box 277',0,'Owensville','OH','45160',NULL,'CY','39025','1966-01-14','M','M',':RET:2106-3','T','021','HLT','284721','92036OH002000601','2014-01-01','2013-12-13 19:43:33','0.00',NULL,NULL,'445.61','445.61','R-OH005','OH0','445.61',NULL,0,'2013-12-26 02:02:00'),(14436,11513,'Y','18','021','EC','A','','','AC','0001384393','0001384393','LA00000843172','IL','1','Rivers','Reginald','Thomas','','','34','439172394','3456 BROADMOOR BLVD',0,'SHREVEPORT','LA','71105','2026','CY','22017','1963-10-02','M','U',':RET:2054-5','N','021','DEN','1798419','18575LA002000201','2014-02-01','2013-12-27 10:42:52','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-28 03:32:03'),(6263,4965,'Y','18','024','14','A','','','TE','0000162235','0000162235','','IL','1','Cooper','Julian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-01','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:32:18'),(3804,3049,'N','01','021','EC','A',NULL,NULL,'','0000490455','0000672736','','IL','1','Kenyon','Meagan','','','','34','628183624','24 SHADY LANE DR',0,'NORWALK','OH','44857','2372','CY','39077','1987-06-18','F','',':RET:2106-3','N','021','DEN','396507','99734OH005000301','2014-01-01','2013-12-13 13:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:36'),(27023,21403,'N','19','021','EC','A',NULL,NULL,'','0000592211','0001076627','','IL','1','GREEN','KYLER','','','','34','276981572','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1995-01-23','M','',':RET:2106-3','N','021','DEN','3725480','99734OH005000301','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:13'),(27270,21594,'Y','18','021','EC','A','','','AC','0000785121','0000785121','TX00002805364','IL','1','Freeney','Bettie','','','','34','451908220','9049 COUNTY ROAD 3246D',0,'MT ENTERPRISE','TX','75681','4224','CY','48401','1950-08-13','F','M',':RET:2054-5','N','021','DEN','3200690','33348TX002000201','2014-04-01','2014-03-03 18:02:46','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-03-04 21:00:15'),(27569,21804,'N','19','021','EC','A',NULL,NULL,'','0000209610','0000103942','','IL','1','Tupaz','Gabe','Miguel','','','34','282080786','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','2003-05-29','M','',':RET:2036-2^:RET:2106-3','N','021','DEN','3012426','99734OH005000301','2014-04-01','2014-03-04 14:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:20'),(23263,18548,'Y','18','024','14','A','','','TE','0000796947','0000796947','','IL','1','Sand','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-17','M','',NULL,NULL,NULL,'','2298205','','2014-02-28','2014-02-13 07:27:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:11'),(958,787,'N','01','021','EC','A',NULL,NULL,'','0000580117','0000617423','','IL','1','Molina','Carmen','T','','','34','457947030','3694 Hawthorne Trail',0,'Rockwall','TX','75032',NULL,'CY','48397','1949-06-22','F','',':RET:2148-5^:RET:2106-3','N','021','DEN','207073','33348TX002000201','2014-01-01','2013-10-28 19:06:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:09:43'),(22853,18234,'Y','18','021','EC','A','','','AC','0000205827','0000205827','OH00002076845','IL','1','ASKINS','CONSTANCE','B','','','34','291484133','1400 S CLAY ST',0,'DELPHOS','OH','45833',NULL,'CY','39161','1950-01-18','F','U',':RET:2106-3','N','021','HLT','2815559','92036OH005001505','2014-03-01','2014-02-11 16:19:26','568.00',NULL,NULL,'660.24','92.24','R-OH002','OH0','660.24',NULL,0,'2014-02-11 21:02:22'),(22271,17776,'Y','18','021','EC','A','','','AC','0001136964','0001136964','TX00001640286','IL','1','Clary','Billy','J','','','34','454376582','233 COUNTY ROAD 1230',0,'PITTSBURG','TX','75686','4839','CY','48343','1962-01-27','M','M',':RET:2106-3','T','021','DEN','1766260','33348TX002000201','2014-03-01','2014-01-20 11:24:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:14'),(22248,17757,'N','01','021','EC','A',NULL,NULL,'','0000012472','0000411162','','IL','1','Bihn','Timothy','','','','34','271528952','7447 Lunitas Ln',0,'Perrysburg','OH','43551',NULL,'CY','39173','1951-11-27','M','',NULL,'N','021','HLT','3588176','92036OH004002601','2014-03-01','2014-02-09 13:14:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','450.46',NULL,0,'2014-02-09 19:00:41'),(19450,15503,'N','01','021','EC','A',NULL,NULL,'','0000994001','0000529470','','IL','1','Rosario','Norberto','','','','34','118582854','47405 MIDDLE RIDGE RD',0,'AMHERST','OH','44001','3209','CY','39093','1964-01-08','M','',NULL,'N','021','DEN','3150951','99734OH005000301','2014-03-01','2014-01-22 11:23:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:01:52'),(4929,3910,'Y','18','021','EC','A','','','AC','0000042027','0000042027','OH00001221219','IL','1','whitis','terry','','','','34','403705216','300 courtland dr',0,'monroe','OH','45050',NULL,'CY','39017','1950-04-08','M','U',':RET:2106-3','N','021','DEN','706936','99734OH005000401','2014-01-01','2013-12-06 19:29:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:22'),(4542,3599,'Y','18','021','EC','A','','','AC','0000311538','0000311538','TX00001262182','31','1','Fried','Rosa','','','','34','467835413','PO Box 283',0,'Muleshoe','TX','79347',NULL,'CY','48017','1950-12-26','F','U',':RET:2106-3','N','021','DEN','319009','33348TX002000201','2014-01-01','2013-12-12 17:59:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:19'),(18528,14775,'Y','18','021','EC','A','','','AC','0000203105','0000203105','OH00002134637','IL','1','Pavlyak','Paula','','','','34','117467827','8740 Simpson Court',0,'Mason','OH','45040',NULL,'CY','39165','1958-02-12','F','U',':RET:2106-3','N','021','HLT','1458518','92036OH005001206','2014-02-01','2014-01-14 21:21:38','393.00',NULL,NULL,'478.72','85.72','R-OH004','OH0','478.72',NULL,0,'2014-01-16 08:46:42'),(18381,14671,'Y','18','021','EC','A','','','AC','0000929856','0000929856','OH00001567717','IL','1','WALLACE','CHERYL','','','','34','248611980','370 RALPHS WAY',0,'VAN WERT','OH','45891',NULL,'CY','39161','1958-03-25','F','U',':RET:2106-3','N','021','DEN','1676001','99734OH005000301','2014-02-01','2014-01-15 09:41:08','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-16 08:45:35'),(2988,2404,'Y','18','021','EC','A','','','AC','0000246419','0000246419','OH00000630113','IL','1','Rutherford','James','','','','34','300566190','5037 Chantilly Dr',0,'Cincinnati','OH','45238',NULL,'CY','39061','1955-05-29','M','U',':RET:2106-3','N','021','DEN','752334','99734OH005000301','2014-01-01','2013-12-06 14:13:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:17:21'),(21894,17483,'Y','18','021','EC','A','','','AC','0000426477','0000426477','OH00002496787','IL','1','mayall','laura','','','','34','546557071','607 S.Blackhoof St.',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1978-07-09','F','R',':RET:2106-3','N','021','HLT','3510920','92036OH006001501','2014-03-01','2014-02-05 20:23:25','0.00',NULL,NULL,'213.28','213.28','R-OH002','OH0','213.28',NULL,0,'2014-02-06 21:01:41'),(14773,11796,'Y','18','021','EC','A','','','AC','0000969800','0000969800','TX00000177476','IL','1','meili','phillip','','','','34','465518721','1509 pintoresco',0,'el paso','TX','79935',NULL,'CY','48141','1967-12-25','M','U',':RET:2106-3','N','021','DEN','2030438','33348TX002000201','2014-01-01','2013-12-23 20:26:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:13:00'),(14825,11840,'Y','18','021','EC','A','','','AC','0000705143','0000705143','OH00000774757','IL','1','Parent','Alexander','','','','34','268886537','26948 MINGO DR',0,'PERRYSBURG','OH','43551','1073','CY','39173','1987-12-01','M','U',':RET:2106-3','N','021','HLT','1885946','92036OH004002601','2014-01-01','2013-12-23 19:36:16','103.00',NULL,NULL,'160.55','57.55','R-OH001','OH0','160.55',NULL,1,'2013-12-29 11:14:25'),(15059,12037,'Y','18','021','EC','A','','','AC','0001573467','0001573467','LA00001958502','IL','1','POWELL','PAMELA','','','','34','435431775','140 PENNSYLVANIA AVE',0,'SHREVEPORT','LA','71105','3318','CY','22017','1967-10-31','F','U',NULL,'T','021','DEN','2439765','18575LA002000201','2014-02-01','2013-12-30 15:08:26','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-01 12:03:29'),(21449,17142,'N','01','021','EC','A',NULL,NULL,'','0000469573','0000873271','','IL','1','Cross','Howard','M','','','34','273709222','321 SUZANNE DR',0,'KENT','OH','44240','1931','CY','39133','1960-02-19','M','',NULL,'N','021','HLT','2878000','52664OH151001301','2014-03-01','2014-02-03 21:59:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2014-02-04 21:01:27'),(16334,13077,'Y','18','021','EC','A','','','AC','0001943573','0001943573','LA00002092321','IL','1','Vo','Brandon','','','','34','433834393','15762 RIVERDALE AVE E',0,'BATON ROUGE','LA','70816','1574','CY','22033','1974-07-15','M','U',NULL,'N','021','DEN','1559529','18575LA002000201','2014-02-01','2014-01-06 17:59:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:02:04'),(25275,20054,'Y','18','024','14','A','','','TE','0001082303','0001082303','','IL','1','Hernandez','Asmaa','Abdelaziz',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-07-16','F','',NULL,NULL,NULL,'','2875617','','2014-02-24','2014-02-24 23:49:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-02-25 21:00:14'),(26025,20641,'Y','18','021','EC','A','','','AC','0000188167','0000188167','MS00002643824','IL','1','WILLIAMS','ASHLEY','','','','34','587752138','895 N SIWELL RD',0,'JACKSON','MS','39209',NULL,'CY','28049','1993-03-26','F','U',NULL,'N','021','DEN','2963214','46300MS002000101','2014-04-01','2014-02-26 11:37:32','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-26 21:02:18'),(26600,21090,'Y','18','021','EC','A','','','AC','0000751423','0000751423','TX00002817912','IL','1','Taylor','Calvin','','','','34','452799244','8858 VINCENT RD',0,'COLLEGE STATION','TX','77845','9047','CY','48041','1986-06-14','M','M',':RET:2054-5','N','021','DEN','2990657','33348TX002000201','2014-03-01','2014-02-27 19:14:20','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-28 21:30:41'),(3919,3137,'Y','18','021','EC','A','','','AC','0000393649','0000393649','OH00001306232','IL','1','KOEHL','GREGORY','','','','34','300764177','426 EBEN AVE',0,'FINDLAY','OH','45840',NULL,'CY','39063','1970-09-27','M','U',NULL,'N','021','HLT','298238','92036OH005001506','2014-01-01','2013-12-12 19:39:17','265.00',NULL,NULL,'298.65','33.65','R-OH002','OH0','298.65',NULL,0,'2013-12-25 21:37:19'),(22429,17909,'Y','18','021','EC','A','','','AC','0000707325','0000707325','TX00002484717','IL','1','Almaguer','Maria','del socorro','','','34','631128805','1723 Berkley ave.',0,'Dallas','TX','75224',NULL,'CY','48113','1980-06-27','F','M',NULL,'N','021','DEN','3048167','33348TX002000201','2014-03-01','2014-02-09 20:02:49','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:35'),(23595,18796,'Y','18','021','EC','A','','','AC','0000216150','0000216150','OH00002661715','IL','1','blankenship','tiffany','','','','34','287889398','4883 MONTEREY MAPLE GROVE RD',0,'BATAVIA','OH','45103','9418','CY','39025','1987-04-13','F','M',':RET:2106-3','N','021','HLT','3157904','92036OH006000601','2014-03-01','2014-02-13 12:45:52','243.00',NULL,NULL,'345.26','102.26','R-OH005','OH0','174.33',NULL,0,'2014-02-13 22:03:05'),(24776,19652,'N','01','021','EC','A',NULL,NULL,'','0001165319','0000930893','','IL','1','ANAYA','GEORGE','ANTONIO','','','34','279963007','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-21','M','',NULL,'T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:47'),(25368,20128,'Y','18','021','EC','A','','','AC','0000431425','0000431425','OH00003151285','IL','1','SANDERS','JENIFER','','','','34','285847103','132 LEFT FORK RD',0,'BIDWELL','OH','45614','9267','CY','39053','1983-01-21','F','M',':RET:2106-3','N','021','DEN','3142469','99734OH005000301','2014-04-01','2014-02-25 13:48:25','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-02-25 21:30:40'),(26476,21000,'Y','18','024','14','A','','','TE','0000895770','0000895770','','IL','1','McGarvey','Steve',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-06-23','M','',NULL,NULL,NULL,'','3840895','','2014-02-27','2014-02-27 17:23:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:30:39'),(1418,1180,'Y','18','021','EC','A','','','AC','0002019016','0002019016','LA00000343565','IL','1','BURKHALTER','CAMILLE','','','','34','434023292','7419 RUE HENRI',0,'BATON ROUGE','LA','70806','7525','CY','22033','1956-02-21','F','U',':RET:2106-3','N','021','DEN','1789682','18575LA002000201','2014-01-01','2013-12-24 15:04:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:47:09'),(1837,1506,'Y','18','021','EC','A','','','AC','0001255030','0001255030','OH00000782602','IL','1','parr','john','','','','34','296783734','2910 HECKMAN RD',0,'UNIONTOWN','OH','44685','9003','CY','39153','1977-09-28','M','M',':RET:2106-3','N','021','HLT','2372187','52664OH151001306','2014-01-01','2013-12-24 11:32:29','382.00',NULL,NULL,'546.82','164.82','R-OH012','OH0','274.30',NULL,0,'2013-12-25 18:57:34'),(2437,1985,'Y','18','021','EC','A','','','AC','0000077536','0000077536','OH00001250527','IL','1','Hall','Heather','Lee','','','34','297721220','18813 CHILLICOTHE RD',0,'CHAGRIN FALLS','OH','44023','5023','CY','39055','1966-09-27','F','U',':RET:2106-3','T','021','HLT','272062','52664OH151001304','2014-01-01','2013-12-09 14:05:23','122.00',NULL,NULL,'452.09','330.09','R-OH011','OH0','452.09',NULL,0,'2013-12-25 19:34:19'),(15566,12456,'Y','18','021','EC','A','','','AC','0000776439','0000776439','OH00000680309','IL','1','Pilz','Anton','Martin','','','34','273586316','3642 Darrow Rd',0,'Stow','OH','44224',NULL,'CY','39153','1955-05-22','M','U',':RET:2106-3','T','021','HLT','1886243','52664OH151001304','2014-02-01','2013-12-31 12:43:58','384.00',NULL,NULL,'653.46','269.46','R-OH012','OH0','653.46',NULL,1,'2014-01-02 04:31:44'),(20260,16168,'Y','18','021','EC','A','','','AC','0000768911','0000768911','OH00002246835','IL','1','Wood','Tanzie','','','','34','273722686','1434 HARVARD BLVD',0,'DAYTON','OH','45406','5960','CY','39113','1971-12-04','F','U',':RET:2054-5','N','021','DEN','2111747','99734OH005000301','2014-03-01','2014-01-27 22:50:11','0.00',NULL,NULL,'59.76','59.76','R-OH003','OH0','0.00',NULL,0,'2014-01-28 21:00:18'),(20287,16192,'Y','18','021','EC','A','','','AC','0001455037','0001455037','LA00002473649','IL','1','MCKINLEY','TAMMY','','','','34','437373620','126 GONZALES CT',0,'HOUMA','LA','70364','4802','CY','22109','1979-03-05','F','M',':RET:2054-5','N','021','DEN','3116737','18575LA002000201','2014-03-01','2014-01-27 19:16:34','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-28 21:00:33'),(21921,17508,'Y','18','021','EC','A','','','AC','0000645514','0000645514','TX00001352296','IL','1','HURTADO','NOEL','','','','34','562934432','1701 LOMALAND DR',0,'EL PASO','TX','79935',NULL,'CY','48141','1956-10-10','M','M',':RET:2106-3','N','021','DEN','3376455','33348TX002000201','2014-03-01','2014-02-06 19:19:51','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-07 19:00:06'),(22231,17745,'Y','18','021','EC','A','','','AC','0000217483','0000217483','TX00002151666','IL','1','Golden','Maria','','','','34','466497283','4005 CROCKETT ST',0,'AMARILLO','TX','79110','1106','CY','48381','1967-03-28','F','M',NULL,'N','021','DEN','3051073','33348TX002000101','2014-03-01','2014-02-09 12:40:33','0.00',NULL,NULL,'50.04','50.04','R-TX002','TX0','25.02',NULL,0,'2014-02-09 19:00:32'),(24296,19297,'Y','18','021','EC','A','','','AC','0000071650','0000071650','OH00002687017','IL','1','TRAPNELL','TAMARA','','','','34','301549318','945 PRAIRIE RD',0,'WILMINGTON','OH','45177',NULL,'CY','39027','1959-09-10','F','U',':RET:2106-3','N','021','HLT','3275746','92036OH004000601','2014-04-01','2014-02-18 14:26:55','365.84',NULL,NULL,'368.53','2.69','R-OH005','OH0','368.53','CIC',0,'2014-02-18 21:30:16'),(29103,23036,'Y','18','021','EC','A','','','AC','0000295568','0000295568','OH00003811144','IL','1','Coutinho','Gustavo','M','','','34','270988030','1131 Claudia Lane',0,'Findlay','OH','45840',NULL,'CY','39063','1977-04-26','M','R',NULL,'N','021','HLT','3400836','92036OH002001501','2014-04-01','2014-03-09 22:36:07','0.00',NULL,NULL,'312.63','312.63','R-OH002','OH0','312.63',NULL,0,'2014-03-10 21:02:18'),(94,83,'Y','18','021','EC','A','','','AC','0001059693','0001059693','TX00000620980','IL','1','rivas','brijido','','','','34','462318890','2459 STANTON ST',0,'SAN ANGELO','TX','76901','1241','CY','48451','1963-07-25','M','U',NULL,'N','021','DEN','90717','33348TX002000201','2014-01-01','2013-12-04 22:08:07','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 17:17:31'),(216,181,'Y','18','024','14','A','','','TE','0000111724','0000111724','','IL','1','Hanson','Sarah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-07-10','F','',NULL,NULL,NULL,'','676979','','2013-12-05','2013-12-05 06:27:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 17:20:37'),(624,515,'Y','18','021','EC','A','','','AC','0001064700','0001064700','OH00000727914','IL','1','CARLSON','PATRICIA','J','','','34','279721837','2615 CHAMBERLAIN RD',0,'FAIRLAWN','OH','44333','4173','CY','39153','1961-10-15','F','U',NULL,'N','021','DEN','2221339','99734OH005000401','2014-01-01','2013-12-16 12:22:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:00:55'),(7268,5763,'Y','18','021','EC','A','','','AC','0000586945','0000586945','TX00001193032','IL','1','RIVERA','MYRA','ESTHER','','','34','450833350','1402 DIANE DR',0,'KILLEEN','TX','76543','3591','CY','48027','1981-08-22','F','U',NULL,'N','021','DEN','26277','33348TX002000201','2014-01-01','2013-12-14 09:51:47','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 02:02:20'),(6234,4942,'Y','18','021','EC','A','','','AC','0000015186','0000015186','TX00000477404','IL','1','ALVAREZ','STEVEN','','','','34','465793184','5939 GLACIER SUN DR',0,'SAN ANTONIO','TX','78244','1255','CY','48029','1986-07-22','M','U',NULL,'N','021','DEN','199142','33348TX002000101','2014-01-01','2013-11-19 11:51:54','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 00:31:31'),(5891,4671,'Y','18','024','14','A','','','TE','0000105370','0000105370','','IL','1','Williams','Kareema',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-08','F','',NULL,NULL,NULL,'','1915805','','2013-12-23','2013-12-23 22:45:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:49:38'),(4941,3921,'Y','18','021','EC','A','','','AC','0000186080','0000186080','OH00000392917','IL','1','YANOVICH','PAUL','','','','34','278503493','8931 SHEPARD RD',0,'MACEDONIA','OH','44056','1957','CY','39153','1952-08-11','M','U',':RET:2106-3','N','021','DEN','784371','99734OH005000401','2014-01-01','2013-12-07 16:09:58','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:45:40'),(21995,17564,'N','01','021','EC','A',NULL,NULL,'','0002029265','0001242700','','IL','1','ware','william','','','Jr','34','435069753','114 Current Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1958-02-26','M','',NULL,'N','021','DEN','2754783','18575LA002000201','2014-03-01','2014-02-07 10:24:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:44'),(23120,18428,'N','19','021','EC','A',NULL,NULL,'','0000270056','0000486985','','S1','1','CLARKE','DEREK','','','','34','296023884','4205 HEGNER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1998-04-05','M','',':RET:2106-3','N','021','DEN','2856415','99734OH005000401','2014-03-01','2014-02-12 12:21:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:23'),(1140,938,'Y','18','021','EC','A','','','AC','0000166956','0000166956','LA00000362595','IL','1','LaHatte','Jonnie','','','','34','434964487','4620 pike drive',0,'metairie','LA','70003',NULL,'CY','22051','1954-08-28','F','M',':RET:2106-3','N','021','DEN','1009991','18575LA002000201','2014-01-01','2013-12-03 10:00:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:18'),(9431,7483,'Y','18','021','EC','A','','','AC','0000457812','0000457812','OH00001069107','IL','1','Pfeiffer','Sheila','','','','34','288786035','17145 W TOUSSAINT NORTH RD',0,'GRAYTOWN','OH','43432','9760','CY','39123','1966-02-09','F','M',':RET:2106-3','T','021','HLT','1635654','92036OH003002705','2014-01-01','2013-12-20 18:58:52','525.00',NULL,NULL,'684.32','159.32','R-OH006','OH0','366.03',NULL,0,'2013-12-26 04:33:25'),(19347,15423,'Y','18','021','EC','A','','','AC','0000895700','0000895700','OH00002218470','IL','1','Sullivan','Bartholomew','','','','34','269828832','1776 24th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1983-10-07','M','U',':RET:2106-3','N','021','DEN','1865151','99734OH005000301','2014-03-01','2014-01-21 13:34:57','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,1,'2014-01-22 03:22:24'),(2140,1758,'Y','18','021','EC','A','','','AC','0001015882','0001015882','MS00000742288','IL','1','Barnes','Greta','','','','34','428310209','1901 MARTIN BLUFF RD',0,'GAUTIER','MS','39553','4328','CY','28059','1968-10-15','F','U',':RET:2054-5','N','021','DEN','451969','46300MS002000101','2014-01-01','2013-12-09 18:43:22','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 19:18:14'),(7999,6330,'N','19','021','EC','A',NULL,NULL,'','0000768872','0000129256','','IL','1','Chasteen','Maria','','','','34','297081424','7340 PAWNEE RD',0,'SPENCER','OH','44275','9764','CY','39103','1998-06-21','F','',':RET:2028-9','N','021','HLT','2490235','52664OH151001304','2014-01-01','2013-12-20 16:31:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 03:08:20'),(14750,11777,'Y','18','021','EC','A','','','AC','0000837703','0000837703','OH00001296579','IL','1','King','April','','','','34','290744666','119 South Street',0,'Greenfield','OH','45123',NULL,'CY','39071','1978-05-31','F','U',':RET:2106-3','T','021','HLT','1524578','92036OH006000601','2014-02-01','2013-12-28 15:22:12','237.48',NULL,NULL,'239.23','1.75','R-OH005','OH0','239.23',NULL,1,'2013-12-29 11:10:16'),(22569,18024,'Y','18','021','EC','A','','','AC','0000043259','0000043259','OH00002585810','IL','1','Dapane','Sirisumana','','','','34','218619896','7925 CLOVERNOOK AVE',0,'CINCINNATI','OH','45231','3301','CY','39061','1971-04-02','M','U',':RET:2028-9','N','021','DEN','3116993','99734OH005000401','2014-03-01','2014-02-10 15:37:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:55'),(23590,18792,'Y','18','021','EC','A','','','AC','0000029090','0000029090','OH00002409177','IL','1','Thomas','Sarah','','','','34','275821797','264 HILBISH AVE',0,'AKRON','OH','44312','1967','CY','39153','1979-08-21','F','M',':RET:2106-3','T','021','HLT','3613273','52664OH152000901','2014-03-01','2014-02-13 13:36:07','406.00',NULL,NULL,'460.59','54.59','R-OH012','OH0','228.04',NULL,0,'2014-02-13 22:03:01'),(24081,19149,'Y','18','021','EC','A','','','AC','0000432810','0000432810','OH00002948940','IL','1','DRENNEN','DAVID','J','','','34','273766229','4899 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','1973-01-11','M','U',':RET:2106-3','N','021','HLT','3259633','52664OH151001305','2014-03-01','2014-02-15 12:10:38','365.00',NULL,NULL,'573.58','208.58','R-OH012','OH0','290.36',NULL,0,'2014-02-15 22:01:22'),(13868,11064,'Y','18','021','EC','A','','','AC','0000836638','0000836638','OH00000372619','IL','1','ANGERSTIEN','DENISE','','','','34','292601297','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','1977-05-30','F','U',':RET:2106-3','N','021','HLT','1632218','52664OH151001501','2014-01-01','2013-12-23 10:46:17','84.00',NULL,NULL,'328.98','244.98','R-OH012','OH0','328.98',NULL,0,'2013-12-26 13:12:57'),(19705,15703,'Y','18','021','EC','A','','','AC','0000035837','0000035837','TX00002273886','IL','1','CAMPBELL','BERNICE','MARIE','','','34','466175929','102 COUNTY ROAD 3784',0,'QUEEN CITY','TX','75572','5328','CY','48067','1967-09-19','F','U',':RET:2054-5','N','021','DEN','2711339','33348TX002000201','2014-03-01','2014-01-23 15:20:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:50'),(19472,15521,'Y','18','021','EC','A','','','AC','0000396226','0000396226','TX00001460210','31','1','Garcia','Rosa','','','','34','547257809','PO Box 642',0,'Sullivan City','TX','78595',NULL,'CY','48215','1969-10-18','F','M',NULL,'N','021','DEN','2318712','33348TX002000201','2014-03-01','2014-01-21 18:42:39','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-01-23 03:02:00'),(13735,10962,'Y','18','024','14','A','','','TE','0001249587','0001249587','','IL','1','Smith','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-06','F','',NULL,NULL,NULL,'','2144754','','2013-12-23','2013-12-23 18:23:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:31'),(13382,10683,'N','01','021','EC','A',NULL,NULL,'','0000631506','0000271420','','IL','1','Porter','Cindy','Ann','','','34','270667810','668 Wynne Dr.',0,'Akron','OH','44319',NULL,'CY','39153','1968-03-21','F','',':RET:2106-3','N','021','DEN','1487252','99734OH005000301','2014-01-01','2013-12-22 22:57:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:55'),(16057,12858,'Y','18','024','14','A','','','TE','0000484800','0000484800','','IL','1','LENGEL','JOSEPH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-01','M','',NULL,NULL,NULL,'','2148751','','2014-01-03','2014-01-03 09:14:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:03:24'),(14910,11912,'Y','18','021','EC','A','','','AC','0000652135','0000652135','OH00001239708','IL','1','Zbeidy','Jessy','','','','34','276112542','12641Walnut Hill Drive',0,'North Royalton','OH','44133',NULL,'CY','39035','1982-06-06','F','U',':RET:2106-3','N','021','DEN','1968738','99734OH005000401','2014-02-01','2013-12-28 20:20:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-30 00:01:25'),(14403,11486,'Y','18','021','EC','A','','','AC','0000759720','0000759720','OH00001522419','IL','1','Whitehead','Joyce','','','','34','278785539','11228 Notre Dame Avenue',0,'Cleveland','OH','44104',NULL,'CY','39035','1971-10-03','F','M',':RET:2054-5','T','021','DEN','2117293','99734OH005000401','2014-02-01','2013-12-27 17:45:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:31:15'),(3065,2463,'Y','18','021','EC','A','','','AC','0000995093','0000995093','MS00000365096','IL','1','GWYN','KEVIN','ANDREW','','','34','412618465','2116 CUSTER DR',0,'SOUTHAVEN','MS','38671','5024','CY','28033','1982-11-19','M','M',':RET:2106-3','N','021','DEN','609324','46300MS002000101','2014-01-01','2013-12-05 23:35:01','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 20:19:18'),(9436,7485,'N','19','021','EC','A',NULL,NULL,'','0000662687','0000828226','','IL','1','Merusi','William',NULL,NULL,NULL,NULL,NULL,'1859 FAIRFAX AVE',0,'CINCINNATI','OH','45207','1811','CY','39061','2001-04-04','M','',NULL,'N','021','HLT','1998662','92036OH006001201','2014-01-01','2013-12-20 18:59:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-26 04:33:32'),(9701,7684,'Y','18','021','EC','A','','','AC','0000923323','0000923323','OH00000147974','IL','1','SEIBERT','FREDERIC','','','','34','297488752','2139 BROADHURST AVE',0,'CINCINNATI','OH','45240','1413','CY','39061','1950-05-27','M','M',':RET:2106-3','N','021','HLT','1711557','92036OH002001201','2014-01-01','2013-12-21 13:49:12','700.00',NULL,NULL,'1463.62','763.62','R-OH004','OH0','731.81',NULL,0,'2013-12-26 04:39:57'),(27868,22043,'Y','18','021','EC','A','','','AC','0000048256','0000048256','OH00003031369','IL','1','Dierking','Robyn','','','','34','406724434','5730 Windridge View',0,'Cincinnati','OH','45243',NULL,'CY','39061','1958-08-15','F','U',NULL,'N','021','HLT','2978187','92036OH004001201','2014-04-01','2014-03-05 14:43:48','100.00',NULL,NULL,'384.93','284.93','R-OH004','OH0','384.93',NULL,0,'2014-03-05 21:32:23'),(28653,22673,'N','01','021','EC','A',NULL,NULL,'','0000632749','0000002358','','IL','1','Hall','Cody','','','','34','275905186','3894 DAVIDSON RD',0,'HILLSBORO','OH','45133','8797','CY','39071','1988-05-17','M','',':RET:2106-3','N','021','HLT','3711540','92036OH003000605','2014-04-01','2014-03-08 15:16:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','225.08',NULL,0,'2014-03-08 21:30:39'),(48,43,'Y','18','021','EC','A','','','AC','0000099191','0000099191','MS00000386357','IL','1','Vaughn','Norma','','','','34','457235850','11387 GOULD RD',0,'GULFPORT','MS','39503','5626','CY','28047','1958-04-08','F','U',':RET:2106-3','T','021','DEN','260191','46300MS002000101','2014-01-01','2013-12-05 15:25:12','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 17:16:17'),(19815,15798,'N','01','021','EC','A',NULL,NULL,'','0000194999','0000179481','','IL','1','NGUYEN','HAI','','','','34','636047588','4318 GOODNIGHT TRL',0,'SAN ANGELO','TX','76903','8113','CY','48451','1977-11-14','M','',':RET:2047-9','N','021','DEN','3066550','33348TX002000201','2014-03-01','2014-01-23 20:37:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-24 21:00:11'),(19185,15284,'Y','18','021','EC','A','','','AC','0000850663','0000850663','TX00002023784','IL','1','Lee-Johnson','Kim','','','','34','287748068','1625 Maple Drive',0,'Garland','TX','75042',NULL,'CY','48113','1966-12-23','F','R',NULL,'N','021','DEN','2622276','33348TX002000201','2014-03-01','2014-01-20 17:07:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-21 08:46:09'),(227,191,'Y','18','021','EC','A','','','AC','0000102947','0000102947','LA00000486799','31','1','Brown','Quentin','Rod','','Jr','34','434375903','Po Box 15393',0,'Marrero','LA','70175',NULL,'CY','22071','1969-09-22','M','U',':RET:2054-5','N','021','DEN','1168414','18575LA002000201','2014-01-01','2013-12-05 12:43:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:20:57'),(17077,13667,'Y','18','021','EC','A','','','AC','0000374363','0000374363','TX00000764394','IL','1','Cocchiaro','Katherine',NULL,NULL,NULL,NULL,NULL,'3708 CURTIS DR',0,'ROUND ROCK','TX','78681','1643','CY','48491','1980-09-13','F','M',':RET:2034-7','N','021','DEN','1741472','33348TX002000201','2014-02-01','2014-01-08 12:21:52','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:21:20'),(9549,7568,'Y','18','021','EC','A','','','AC','0001069313','0001069313','OH00000339679','IL','1','Scott','Janell','Renee','','','34','283649217','340 E HARDIN ST',0,'FINDLAY','OH','45840','4964','CY','39063','1973-08-31','F','U',':RET:2106-3','N','021','DEN','1962884','99734OH005000301','2014-01-01','2013-12-21 12:43:13','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:36:14'),(4994,3962,'Y','18','021','EC','A','','','AC','0000053035','0000053035','OH00000425305','IL','1','Engebrecht','Johanna','','','','34','296048237','2847 OBSERVATORY AVE',0,'CINCINNATI','OH','45208','2332','CY','39061','2000-04-06','F','R',':RET:1002-5^:RET:2106-3','N','021','DEN','913624','99734OH005000301','2014-01-01','2013-12-06 21:49:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','21.13',NULL,0,'2013-12-25 22:47:00'),(7550,5975,'Y','18','021','EC','A','','','AC','0000273622','0000273622','LA00000095277','IL','1','MOODY','PAMELA','','','','34','433040895','427 Firethorn Dr',0,'Gretna','LA','70056',NULL,'CY','22051','1958-09-16','F','U',':RET:2106-3','N','021','DEN','32514','18575LA002000101','2014-01-01','2013-12-15 10:59:37','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 02:33:12'),(2792,2257,'Y','18','021','EC','A','','','AC','0000272210','0000272210','LA00001293076','IL','1','HENAGAN','GREG','','','','34','439948623','1004 LAKESHORE DR',0,'PINEVILLE','LA','71360','6189','CY','22079','1955-01-13','M','M',NULL,'N','021','DEN','1224840','18575LA002000101','2014-01-01','2013-12-02 12:11:27','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-25 19:50:09'),(15924,12751,'Y','18','021','EC','A','','','AC','0001025154','0001025154','MS00000074608','IL','1','Brown','Kimberley','','','','34','426354641','1814 Avenue J',0,'Jackson','MS','39213',NULL,'CY','28049','1979-08-08','F','U',':RET:2054-5','N','021','DEN','2156732','46300MS002000201','2014-02-01','2014-01-02 13:48:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-03 02:06:44'),(3728,2979,'Y','18','021','EC','A','','','AC','0000334033','0000334033','TX00000893788','IL','1','Dershe','Abraham','','','','34','375294706','12166 Metric Blvd.',0,'Austin','TX','78758',NULL,'CY','48453','1969-11-22','M','U',':RET:2054-5','N','021','DEN','1022218','33348TX002000201','2014-01-01','2013-12-13 17:44:41','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:32:31'),(5900,4674,'N','19','021','EC','A',NULL,NULL,'','0001071787','0000396160','','S1','1','Clark','DeShon','','','','34','280046744','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','1999-05-22','F','',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:45'),(22685,18115,'Y','18','021','EC','A','','','AC','0000338746','0000338746','TX00002007943','IL','1','Dorsey','Carol','','','','34','449290057','222 BAR E RD',0,'LIVINGSTON','TX','77351','9348','CY','48373','1964-04-17','F','M',NULL,'N','021','DEN','2899515','33348TX002000201','2014-03-01','2014-02-11 17:31:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:49'),(25204,19993,'N','01','021','EC','A',NULL,NULL,'','0002198962','0001580019','','IL','1','OAKLEY','KYLE','','','','34','081607349','623 SADIE AVE',0,'METAIRIE','LA','70003','4847','CY','22051','1960-07-24','M','',NULL,'N','021','DEN','2792610','18575LA002000201','2014-04-01','2014-02-21 17:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-21 22:00:47'),(27656,21874,'N','01','021','EC','A',NULL,NULL,'','0000091220','0001029431','','IL','1','Patel','Kanubhai','','','','34','360807584','301 BIHL AVE',0,'NORTHWOOD','OH','43619','1539','CY','39173','1958-10-13','M','',':RET:2029-7','T','021','DEN','3309374','99734OH005000401','2014-04-01','2014-03-05 13:31:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:24'),(28476,22531,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000764949','','IL','1','Shamy','Alexander','','','','34','300115042','13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',NULL,'N','021','DEN','4102709','99734OH005000301','2014-04-01','2014-03-07 09:25:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:33'),(7539,5965,'Y','18','021','EC','A','','','AC','0001161900','0001161900','TX00001267491','IL','1','moniniger','kristi','','','','34','459490952','1152 ELM GROVE CT',0,'WHITNEY','TX','76692','9650','CY','48217','1969-11-23','F','U',':RET:2106-3','N','021','DEN','708247','33348TX002000201','2014-01-01','2013-12-15 13:40:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:32:50'),(17675,14125,'Y','18','021','EC','A','','','AC','0001723197','0001723197','LA00002048938','IL','1','Tran','Hy','','','','34','260398169','2433 River Rd',0,'Berwick','LA','70342',NULL,'CY','22101','1960-12-22','M','M',':RET:2047-9','N','021','DEN','1728218','18575LA002000101','2014-02-01','2014-01-13 13:18:50','0.00',NULL,NULL,'50.04','50.04','R-LA003','LA0','25.02',NULL,0,'2014-01-14 01:32:51'),(17564,14044,'Y','18','021','EC','A','','','AC','0001121405','0001121405','OH00002001319','IL','1','Marshall','Nora','','','','34','269602017','4235 U.S. Route 127 South',0,'Greenville','OH','45331',NULL,'CY','39037','1956-12-02','F','M',':RET:2106-3','N','021','DEN','1938439','99734OH005000401','2014-02-01','2014-01-12 18:31:49','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-14 01:31:58'),(17497,13991,'Y','18','021','EC','A','','','AC','0002003893','0002003893','LA00001793649','IL','1','SPADONI','LYDIA','ANN','','','34','436828811','1711 LAFITTE ST',0,'NEW ORLEANS','LA','70112',NULL,'CY','22071','1950-08-03','F','U',NULL,'N','021','DEN','1632804','18575LA002000201','2014-02-01','2014-01-12 11:18:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 03:01:23'),(2898,2337,'N','01','021','EC','A',NULL,NULL,'','0000949487','0000881598','','IL','1','Overfield','Carrie','','','','34','281662400','1436 RUTH AVE',0,'CUYAHOGA FALLS','OH','44221','2938','CY','39153','1967-07-15','F','',':RET:2106-3','T','021','HLT','56941','52664OH151001501','2014-01-01','2013-12-06 15:24:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','461.38',NULL,0,'2013-12-25 20:15:17'),(3242,2612,'Y','18','024','14','A','','','TE','0000019074','0000019074','','IL','1','davidson','terrence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-07-18','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:46:22'),(5717,4538,'N','01','021','EC','A',NULL,NULL,'','0000192738','0000456525','','IL','1','Snyder','Carrie','Liane','','','34','381844435','1226 N BEVER ST',0,'WOOSTER','OH','44691','2316','CY','39169','1975-10-11','F','',':RET:2106-3','N','021','HLT','1976754','52664OH151001306','2014-01-01','2013-12-24 01:10:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2013-12-25 23:45:18'),(5841,4640,'Y','18','024','14','A','','','TE','0000963307','0000963307','','IL','1','Nordin','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-16','M','',NULL,NULL,NULL,'','2245532','','2013-12-23','2013-12-23 23:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:48:34'),(20372,16273,'Y','18','021','EC','A','','','AC','0002165899','0002165899','LA00002464032','IL','1','LeBlanc','Brett','','','','34','436044985','37121 MURPHY WEBB RD',0,'PRAIRIEVILLE','LA','70769','3394','CY','22005','1965-01-09','M','U',NULL,'T','021','DEN','3124416','18575LA002000101','2014-03-01','2014-01-29 10:56:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-29 21:00:06'),(22337,17838,'Y','18','021','EC','A','','','AC','0000352871','0000352871','OH00002281632','IL','1','leslie','kenneth','','','','34','279608228','2710 EMMICK DR',0,'TOLEDO','OH','43606','2703','CY','39095','1957-07-04','M','M',':RET:2106-3','N','021','HLT','3162122','92036OH004002601','2014-03-01','2014-01-30 16:47:28','0.00',NULL,NULL,'365.79','365.79','R-OH001','OH0','365.79',NULL,0,'2014-02-10 11:01:05'),(22502,17963,'Y','18','024','14','A','','','TE','0000187503','0000187503','','IL','1','ROBBINS','SINDY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-26','F','',NULL,NULL,NULL,'','1540699','','2014-02-10','2014-02-10 15:33:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:13'),(23089,18406,'Y','18','021','EC','A','','','AC','0000733643','0000733643','OH00002149195','IL','1','Skowronski','Richard','','','','34','118505097','549 WARWICK LN',0,'PICKERINGTON','OH','43147','1510','CY','39045','1958-01-23','M','U',NULL,'T','021','DEN','3558080','99734OH005000401','2014-03-01','2014-02-12 11:31:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:06'),(23185,18486,'Y','18','021','EC','A','','','AC','0000879423','0000879423','MS00002392230','IL','1','AUSTIN','CURTIS','','','','34','410318466','6208 CASTLETON DR',0,'OLIVE BRANCH','MS','38654','9353','CY','28033','1976-01-21','M','M',NULL,'N','021','DEN','2830470','46300MS002000101','2014-03-01','2014-02-12 12:59:57','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-12 21:32:00'),(25304,20074,'Y','18','021','EC','A','','','AC','0000717874','0000717874','OH00002833243','IL','1','ANOKYE','EVELYN','','','','34','290131267','1328 CAMP HILL WAY',0,'DAYTON','OH','45449','3136','CY','39113','1986-05-05','F','U',':RET:2054-5','N','021','DEN','3539432','99734OH005000301','2014-03-01','2014-02-25 10:09:47','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00','CIC',0,'2014-02-25 21:00:29'),(26506,21024,'N','19','021','EC','A',NULL,NULL,'','0000496746','0000626792','','S1','1','Grande','Stephen','M','','','34','280111217','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','2005-05-11','F','',':RET:2106-3','N','021','DEN','3104329','99734OH005000401','2014-03-01','2014-02-28 15:49:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 21:00:17'),(28426,22494,'Y','18','021','EC','A','','','AC','0000936118','0000936118','OH00003333282','IL','1','Chaffin','Brandon','','','','34','273965286','19980 COSHOCTON RD',0,'MOUNT VERNON','OH','43050','8273','CY','39083','1992-11-20','M','R',':RET:2106-3','N','021','DEN','3180429','99734OH005000401','2014-04-01','2014-03-07 15:14:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:06'),(28913,22885,'N','19','021','EC','A',NULL,NULL,'','0000643296','0001165404','','S1','1','Kolar','Nikola','Senior','','','34','299041333','6510 Morrow Cozaddale',0,'Morrow','OH','45152',NULL,'CY','39165','2000-06-01','F','',':RET:2106-3','N','021','DEN','3470217','99734OH005000301','2014-04-01','2014-03-10 09:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:28'),(1977,1616,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000800931','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','931032','33348TX002000101','2014-01-01','2013-11-19 23:03:16','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:37'),(17872,14278,'Y','18','021','EC','A','','','AC','0000366302','0000366302','OH00001715316','IL','1','Kushner','David','','','','34','296686757','1851 PATHFINDER CT',0,'XENIA','OH','45385','9596','CY','39057','1959-12-26','M','M',':RET:2106-3','N','021','DEN','2445311','99734OH005000401','2014-02-01','2014-01-14 14:01:06','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:14'),(16567,13253,'Y','18','021','EC','A','','','AC','0001204544','0001204544','OH00001940195','IL','1','Johnson','Ciara','','','','34','298785406','2318 DEERPATH LN',0,'TOLEDO','OH','43614','5012','CY','39095','1982-08-22','F','U',':RET:2054-5','N','021','HLT','2243536','92036OH003002604','2014-02-01','2014-01-04 20:22:21','132.00',NULL,NULL,'494.64','362.64','R-OH001','OH0','236.02',NULL,1,'2014-01-07 10:23:13'),(14626,11673,'N','01','021','EC','A',NULL,NULL,'','0000357204','0000370030','','IL','1','Koester','Kevin','Lee','','','34','272603659','6081 N. Martin Williston Rd',0,'Williston','OH','43468',NULL,'CY','39123','1969-04-21','M','',':RET:2106-3','T','021','HLT','1617692','92036OH001002701','2014-02-01','2013-12-27 11:45:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','377.88',NULL,0,'2013-12-28 03:37:03'),(9178,7280,'Y','18','021','EC','A','','','AC','0000015249','0000015249','OH00000132741','IL','1','Lewis','Dwight','','','','34','272808101','5205 NORFOLK ST',0,'LIMA','OH','45806','9465','CY','39003','1975-07-13','M','M',':RET:2106-3','T','021','HLT','1396257','92036OH005001506','2014-01-01','2013-12-18 09:53:44','660.00',NULL,NULL,'767.40','107.40','R-OH002','OH0','315.38',NULL,0,'2013-12-26 04:09:06'),(3867,3096,'Y','18','021','EC','A','','','AC','0000776465','0000776465','LA00001165879','IL','1','stevens','ralph','','','','34','436808043','187 LLOYD HICKS RD',0,'CALHOUN','LA','71225','9541','CY','22073','1949-09-27','M','M',':RET:2106-3','N','021','DEN','1053947','18575LA002000201','2014-01-01','2013-12-13 09:14:53','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 21:36:06'),(5446,4327,'Y','18','021','EC','A','','','AC','0000382143','0000382143','OH00000187244','IL','1','SPIVAK','ALEXANDER','','','','34','288920012','3824 BARLEYTON CIR',0,'SYLVANIA','OH','43560','3501','CY','39095','1977-08-20','M','M',NULL,'N','021','HLT','2395141','92036OH004002601','2014-01-01','2013-12-18 22:56:15','130.00',NULL,NULL,'419.27','289.27','R-OH001','OH0','192.86',NULL,0,'2013-12-25 23:10:03'),(22775,18183,'Y','18','024','14','A','','','TE','0001196843','0001196843','','IL','1','Diehl','Jamie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-04-15','F','',NULL,NULL,NULL,'','3380289','','2014-02-11','2014-02-11 13:22:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:01:40'),(23641,18825,'Y','18','021','EC','A','','','AC','0000610032','0000610032','TX00002613847','IL','1','johnson','cedrick','','','','34','450372806','1919 n joe ramsey blvd',0,'greenville','TX','75401',NULL,'CY','48231','1976-01-08','M','U',':RET:2054-5','N','021','DEN','2648906','33348TX002000201','2014-03-01','2014-02-13 20:54:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:08'),(23995,19079,'Y','18','021','EC','A','','','AC','0001345325','0001345325','LA00002048317','IL','1','Gorey','Peter','','','','34','436980314','846 CAMP ST',0,'NEW ORLEANS','LA','70130','3704','CY','22071','1955-03-27','M','R',':RET:2106-3','N','021','DEN','2646454','18575LA002000201','2014-03-01','2014-02-15 15:27:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:29'),(24770,19653,'Y','18','021','EC','A','','','AC','0001165319','0001165319','OH00001564682','IL','1','ANAYA','MAURA','KENNEDY','','','34','251843487','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-22','F','M',':RET:2106-3','T','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:44:15'),(25187,19978,'N','01','021','EC','A',NULL,NULL,'','0000805938','0000636198','','IL','1','alimi','shapirai','','','','34','454739619','1113 WATERFORD WAY',0,'ALLEN','TX','75013','5622','CY','48085','1963-01-15','F','',':RET:2028-9','N','021','DEN','3701651','33348TX002000101','2014-04-01','2014-02-20 22:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-21 22:00:37'),(26874,21299,'Y','18','021','EC','A','','','AC','0000950729','0000950729','OH00002869868','IL','1','Blair','Roger','','','','34','275584703','11 N KNIFFIN ST',0,'GREENWICH','OH','44837','1103','CY','39077','1955-09-19','M','M',':RET:2106-3','N','021','HLT','3705854','92036OH004002701','2014-04-01','2014-02-28 21:05:52','147.00',NULL,NULL,'399.50','252.50','R-OH006','OH0','399.50',NULL,0,'2014-03-01 21:01:05'),(578,473,'Y','18','021','EC','A','','','AC','0000528217','0000528217','OH00001106823','IL','1','Kinner','Diane','','','','34','287447683','7634 NEWKIRK DR',0,'FAIRFIELD','OH','45011','8630','CY','39017','1957-12-08','F','U',NULL,'N','021','HLT','765153','92036OH003001201','2014-01-01','2013-12-04 07:52:47','226.00',NULL,NULL,'523.01','297.01','R-OH004','OH0','523.01',NULL,0,'2013-12-25 17:50:46'),(16680,13348,'N','19','021','EC','A',NULL,NULL,'','0000012450','0001138061','','IL','1','KNUTSON','ELIN','','','','34','113494265','6982 FRANCIS DR',0,'LIBERTY TOWNSHIP','OH','45044','9254','CY','39017','2011-06-01','F','',':RET:2106-3','N','021','DEN','1575019','99734OH005000301','2014-02-01','2014-01-07 15:25:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(16545,13235,'N','01','021','EC','A',NULL,NULL,'','0000705160','0000390907','','IL','1','VAZQUEZ','JOSELITO','','','','34','582232879','3123 W 34TH PL',0,'CLEVELAND','OH','44109','1419','CY','39035','1963-04-28','M','',NULL,'N','021','DEN','2013550','99734OH005000401','2014-02-01','2014-01-04 22:26:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-07 10:22:30'),(14624,11672,'N','01','021','EC','A',NULL,NULL,'','0000276281','0000525592','','IL','1','Francis','David','','','','34','298425945','1318 EXCHANGE RD S',0,'NEW LONDON','OH','44851','9351','CY','39077','1951-10-27','M','',':RET:2106-3','N','021','HLT','1935445','92036OH006002701','2014-02-01','2013-12-27 10:50:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','444.29',NULL,0,'2013-12-28 03:37:00'),(14434,11512,'Y','18','021','EC','A','','','AC','0002074891','0002074891','LA00001730982','IL','1','Gregory','Robert','Austin','','','34','236809015','665 WOODHAVEN ST',0,'BATON ROUGE','LA','70815','4661','CY','22033','1950-10-09','M','M',':RET:2106-3','N','021','DEN','2296270','18575LA002000201','2014-02-01','2013-12-27 09:21:04','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-28 03:32:00'),(13726,10953,'Y','18','021','EC','A','','','AC','0000425083','0000425083','OH00000672767','IL','1','Collins','Michael','','','','34','291829754','2827 OSAGE AVE',0,'AKRON','OH','44312','4524','CY','39153','1971-10-27','M','U',':RET:2106-3','N','021','HLT','2337295','52664OH151001305','2014-01-01','2013-12-23 17:52:42','197.00',NULL,NULL,'295.48','98.48','R-OH012','OH0','295.48',NULL,0,'2013-12-26 13:09:19'),(6834,5417,'Y','18','021','EC','A','','','AC','0000577281','0000577281','OH00000257876','IL','1','norris','lois','','','','34','279449859','1307 APPLO WAY',0,'ZANESVILLE','OH','43701','6713','CY','39119','1949-08-17','F','U',':RET:2106-3','N','021','DEN','739184','99734OH005000401','2014-01-01','2013-11-14 09:19:12','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:30:53'),(7928,6269,'Y','18','021','EC','A','','','AC','0001834708','0001834708','LA00000577575','IL','1','NGUYEN','TRAN','','','','34','438519108','1217 WYNDHAM NORTH',0,'GRETNA','LA','70056',NULL,'CY','22051','1983-05-13','F','R',':RET:2047-9','N','021','DEN','1998616','18575LA002000201','2014-01-01','2013-12-20 09:20:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:31'),(2659,2161,'Y','18','021','EC','A','','','AC','0000898422','0000898422','OH00000643463','IL','1','WARRIER','MALAKIZH VARIATH S','','','','34','292137689','6731 STILLHOUSE LANE',0,'DUBLIN','OH','43016',NULL,'CY','39159','1934-02-20','M','M',':RET:2029-7','N','021','DEN','304633','99734OH005000301','2014-01-01','2013-12-02 09:51:40','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:49'),(21522,17195,'Y','18','021','EC','A','','','AC','0000699308','0000699308','OH00001627377','IL','1','Alexander','Thomas','','','','34','277466738','2103 S.R. 132',0,'Goshen','OH','45122',NULL,'CY','39025','1963-11-13','M','M',':RET:2106-3','T','021','HLT','2953966','92036OH006000601','2014-03-01','2014-02-05 15:47:19','175.00',NULL,NULL,'587.50','412.50','R-OH005','OH0','349.66','CIC',0,'2014-02-05 21:00:07'),(21532,17203,'Y','18','021','EC','A','','','AC','0000777703','0000777703','OH00001814261','IL','1','Bass','Steven','','','','34','568511502','4934 LAKOTA WOODS DR',0,'LIBERTY TOWNSHIP','OH','45044','3245','CY','39017','1966-06-04','M','R',':RET:2106-3','N','021','HLT','3179559','92036OH001001201','2014-03-01','2014-02-04 18:44:23','0.00',NULL,NULL,'1095.35','1095.35','R-OH004','OH0','404.73',NULL,0,'2014-02-05 21:30:07'),(23596,18796,'N','01','021','EC','A',NULL,NULL,'','0000216150','0000743128','','IL','1','Blankenship','Trevor','J','','','34','292889413','4883 MONTEREY MAPLE GROVE RD',0,'BATAVIA','OH','45103','9418','CY','39025','1988-03-11','M','',':RET:2106-3','N','021','HLT','3157904','92036OH006000601','2014-03-01','2014-02-13 12:45:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','170.93',NULL,0,'2014-02-13 22:03:05'),(29008,22959,'Y','18','021','EC','A','','','AC','0001131512','0001131512','OH00003376533','IL','1','blake','kathleen','','','','34','095464681','719 township road 101',0,'west salem','OH','44287',NULL,'CY','39005','1955-08-13','F','M',':RET:2106-3','N','021','HLT','4026402','52664OH152000901','2014-04-01','2014-03-10 14:50:38','366.36',NULL,NULL,'416.19','49.83','R-OH012','OH0','416.19',NULL,0,'2014-03-10 21:01:23'),(9663,7655,'N','01','021','EC','A',NULL,NULL,'','0000437968','0000993969','','IL','1','Box','Charlene','','','','34','284509564','1620 BRIM DR',0,'TOLEDO','OH','43612','4007','CY','39095','1953-01-19','F','',NULL,'T','021','HLT','1799166','92036OH004002601','2014-01-01','2013-12-21 17:53:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','489.36',NULL,0,'2013-12-26 04:39:02'),(2142,1760,'Y','18','021','EC','A','','','AC','0001153398','0001153398','MS00000695708','IL','1','Egdorf','Donald','','','','34','436766734','2906 N State Street',0,'jackson','MS','39216',NULL,'CY','28049','1953-05-01','M','U',':RET:2106-3','N','021','DEN','578996','46300MS002000101','2014-01-01','2013-12-10 16:30:26','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 19:18:17'),(17025,13623,'N','19','021','EC','A',NULL,NULL,'','0001217387','0000140303','','IL','1','RUMMER','NICHOLAS','','','','34','292082643','3276 WHIPPLE DR',0,'NORTON','OH','44203','5221','CY','39153','2004-01-18','M','',':RET:2106-3','N','021','HLT','1701414','52664OH152000901','2014-02-01','2014-01-09 15:19:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:20:42'),(16749,13398,'Y','18','021','EC','A','','','AC','0000252213','0000252213','TX00001682596','IL','1','TA-NESERT','NET-HETEP','A A','','','34','448647036','17601 PRINCETON ROAD',0,'DALLAS','TX','75252',NULL,'CY','48085','1957-09-11','F','U',':RET:2054-5','N','021','DEN','2566311','33348TX002000101','2014-02-01','2014-01-07 10:53:49','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-08 18:24:54'),(2783,2249,'N','01','021','EC','A',NULL,NULL,'','0000305806','0000894594','','IL','1','Moores','Charles','R','','','34','284583225','8759 ANGOLA RD',0,'HOLLAND','OH','43528','8816','CY','39095','1955-06-27','M','',':RET:2106-3','N','021','HLT','1006131','92036OH004002601','2014-01-01','2013-12-02 14:38:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','399.50',NULL,0,'2013-12-25 19:49:55'),(16541,13232,'Y','18','021','EC','A','','','AC','0000977642','0000977642','TX00001297931','IL','1','TO','ERIC','','','','34','552674289','25 COUNTY ROAD 2381 S',0,'WINNSBORO','TX','75494','4873','CY','48223','1958-08-25','M','U',NULL,'N','021','DEN','2607319','33348TX002000101','2014-02-01','2014-01-05 15:56:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,1,'2014-01-07 10:22:22'),(16784,13425,'Y','18','021','EC','A','','','AC','0000336439','0000336439','OH00001845147','IL','1','Hill','Donald','','','','34','291600768','606 DURANGO DR',0,'TOLEDO','OH','43609','1706','CY','39095','1977-06-22','M','M',':RET:2106-3','N','021','HLT','1572718','92036OH004002601','2014-02-01','2014-01-07 13:50:55','0.00',NULL,NULL,'192.86','192.86','R-OH001','OH0','192.86',NULL,0,'2014-01-08 18:25:07'),(7799,6177,'Y','18','021','EC','A','','','AC','0000286964','0000286964','TX00001048654','IL','1','Sanchez','Luisa','','','','34','642035995','3809 E. Yandell',0,'EL Paso','TX','79903',NULL,'CY','48141','1986-10-05','F','U',NULL,'N','021','DEN','2093539','33348TX002000201','2014-01-01','2013-12-20 16:17:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 03:03:37'),(4474,3552,'N','19','021','EC','A',NULL,NULL,'','0000129245','0000740251','','IL','1','Dail','Thomas',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1994-06-21','M','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:52');
INSERT INTO `EdiParticipant` VALUES (5062,4011,'Y','18','021','EC','A','','','AC','0000810518','0000810518','TX00001111085','IL','1','Thornton','Charles','','','','34','547081590','453 PASADENA PL',0,'CORPUS CHRISTI','TX','78411','1607','CY','48355','1957-04-05','M','M',NULL,'N','021','DEN','1539512','33348TX002000201','2014-01-01','2013-12-19 07:57:12','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 23:00:27'),(7543,5969,'Y','18','021','EC','A','','','AC','0000518941','0000518941','TX00001092324','31','1','fazalbhoy','zainab','','','','34','633489758','10011 goldenglade drive',0,'houston','TX','77064',NULL,'CY','48201','1982-05-26','F','U',':RET:2029-7^:RET:2028-9','N','021','DEN','784627','33348TX002000201','2014-01-01','2013-12-15 16:36:44','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:32:58'),(24968,19801,'Y','18','021','EC','A','','','AC','0000702500','0000702500','TX00002615065','IL','1','WOODS','TEKINA','MICHELLE','','','34','431257982','818 PEBBLEBROOK DR',0,'ALLEN','TX','75002','2218','CY','48085','1970-01-20','F','U',':RET:2054-5','N','021','DEN','2661128','33348TX002000201','2014-04-01','2014-02-19 19:49:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 22:00:24'),(26355,20907,'Y','18','021','EC','A','','','AC','0000808715','0000808715','OH00002564006','IL','1','Barnes','David','','','','34','273468966','662 MCCORMICK LN',0,'CINCINNATI','OH','45245','2412','CY','39025','1950-10-04','M','U',':RET:2106-3','N','021','HLT','3679997','92036OH005000605','2014-04-01','2014-02-27 16:42:02','449.00',NULL,NULL,'633.70','184.70','R-OH005','OH0','633.70',NULL,0,'2014-02-28 06:31:49'),(28363,22442,'Y','18','024','14','A','','','TE','0000737505','0000737505','','IL','1','NINO','MIGDALIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-09-22','F','',NULL,NULL,NULL,'','3073581','','2014-03-07','2014-03-07 15:40:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-07 21:30:30'),(13117,10461,'Y','18','021','EC','A','','','AC','0000061318','0000061318','OH00000320841','IL','1','Repko','Kathleen','','','','34','278503842','40 PRIVET LN',0,'NORTHFIELD','OH','44067','2883','CY','39153','1952-01-24','F','U',':RET:2106-3','N','021','DEN','1803252','99734OH005000401','2014-01-01','2013-12-23 13:54:30','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:52:38'),(98,87,'Y','18','021','EC','A','','','AC','0000289102','0000289102','TX00000202106','IL','1','Bustos','Sandra','','','','34','640301062','2701 PAREDES LINE RD',0,'BROWNSVILLE','TX','78526','1108','CY','48061','1970-11-15','F','U',':RET:2106-3','N','021','DEN','771621','33348TX002000201','2014-01-01','2013-12-05 10:05:42','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 17:17:38'),(18990,15127,'N','19','021','EC','A',NULL,NULL,'','0000551443','0000920835','','IL','1','Bernstein','Sam','','','','34','301945516','2175 CAMPUS RD',0,'BEACHWOOD','OH','44122','1216','CY','39035','1992-06-08','M','',':RET:2106-3','N','021','HLT','2281072','52664OH151001304','2014-03-01','2014-01-17 11:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2014-01-20 08:06:11'),(18973,15118,'Y','18','021','EC','A','','','AC','0000740304','0000740304','OH00002179699','IL','1','cline','amanda','s','','','34','592367878','917 GARFIELD AVE',0,'MARIETTA','OH','45750','1624','CY','39167','1976-04-26','F','U',NULL,'N','021','DEN','2593214','99734OH005000301','2014-03-01','2014-01-17 00:38:53','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-01-20 08:06:03'),(844,698,'Y','18','021','EC','A','','','AC','0000086344','0000086344','LA00000270140','31','1','DeRamus','Melissa','','','','34','433532511','PO Box 786',0,'Calhoun','LA','71225',NULL,'CY','22073','1969-06-10','F','U',':RET:2106-3','N','021','DEN','352086','18575LA002000101','2014-01-01','2013-12-15 23:02:32','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 18:06:41'),(17756,14187,'N','01','021','EC','A',NULL,NULL,'','0000319049','0000317925','','IL','1','Spann','Christopher','J','','','34','425331041','103 Joe Myers Rd.',0,'Brandon','MS','39047',NULL,'CY','28121','1972-02-27','M','',':RET:2054-5','N','021','DEN','1729595','46300MS002000101','2014-02-01','2014-01-13 14:58:25',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-14 01:33:31'),(9371,7430,'Y','18','021','EC','A','','','AC','0002157175','0002157175','LA00000711233','IL','1','TAYLOR','KENNETH','','','','34','437021483','8038 EDGELAKE CT',0,'NEW ORLEANS','LA','70126',NULL,'CY','22071','1958-09-17','M','U',':RET:2054-5','N','021','DEN','1380566','18575LA002000201','2014-01-01','2013-12-21 12:44:40','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:49'),(5692,4516,'Y','18','021','EC','A','','','AC','0001125403','0001125403','OH00001226463','IL','1','Burns','Kristina','','','','34','271906055','5642 MONICA DR',0,'FAIRFIELD','OH','45014','3958','CY','39017','1987-04-18','F','U',':RET:2106-3','N','021','HLT','246759','92036OH004001201','2014-01-01','2013-11-25 23:13:05','55.00',NULL,NULL,'176.75','121.75','R-OH004','OH0','176.75',NULL,0,'2013-12-25 23:32:38'),(16124,12916,'Y','18','021','EC','A','','','AC','0001495561','0001495561','LA00002267108','IL','1','DUHON','DONALD','','','','34','436709617','1499 BAYONNE ST',0,'JEANERETTE','LA','70544','5503','CY','22045','1949-07-05','M','U',':RET:2054-5','N','021','DEN','1429865','18575LA002000101','2014-02-01','2014-01-03 15:53:39','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-04 02:05:30'),(4866,3857,'Y','18','021','EC','A','','','AC','0000642034','0000642034','OH00000536130','IL','1','Sarra','Jacqueline','','','','34','272603143','4339 N. Elliston Trowbridge Rd.',0,'Graytown','OH','43432',NULL,'CY','39123','1963-01-21','F','U',':RET:2106-3','T','021','HLT','398750','92036OH002002701','2014-01-01','2013-11-08 13:56:29','335.00',NULL,NULL,'462.50','127.50','R-OH006','OH0','462.50',NULL,0,'2013-12-25 22:30:50'),(21369,17079,'Y','18','021','EC','A','','','AC','0001100493','0001100493','TX00001671156','IL','1','Taylor','Tracy','','','','34','461898639','3612 Linda st.',0,'Victoria','TX','77901',NULL,'CY','48469','1973-05-12','F','U',':RET:2054-5','N','021','DEN','2627444','33348TX002000201','2014-03-01','2014-02-04 16:56:26','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-04 21:00:47'),(26278,20844,'N','19','021','EC','A',NULL,NULL,'','0001934491','0002247647','','IL','1','Mitchell','Chantal','','','','34','435776454','313 Belinda',0,'Gramercy','LA','70052',NULL,'CY','22093','1989-08-01','F','',NULL,'N','021','DEN','3837030','18575LA002000101','2014-04-01','2014-02-26 22:23:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 06:31:19'),(26670,21144,'Y','18','021','EC','A','','','AC','0001300858','0001300858','LA00003050095','IL','1','May','Albert','','','','34','462312893','4324 DUKE ST',0,'WESTLAKE','LA','70669','7614','CY','22019','1974-06-01','M','M',NULL,'N','021','DEN','3313829','18575LA002000201','2014-04-01','2014-02-28 10:54:00','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-28 21:31:17'),(193,162,'Y','18','021','EC','A','','','AC','0000194024','0000194024','OH00000794046','IL','1','Beverly','Debra','','','','34','269584063','607 E HIGH ST',0,'HICKSVILLE','OH','43526','1222','CY','39039','1955-06-12','F','M',':RET:2106-3','N','021','HLT','959545','92036OH006002601','2014-01-01','2013-12-05 10:26:29','638.00',NULL,NULL,'856.95','218.95','R-OH001','OH0','394.02',NULL,0,'2013-12-25 17:20:01'),(14580,11635,'Y','18','021','EC','A','','','AC','0002012898','0002012898','LA00000047297','IL','1','BLAKE','MONICA','','','','34','439236431','2715 SHERWOOD ST',0,'BATON ROUGE','LA','70805','4054','CY','22033','1965-01-24','F','U',':RET:2054-5','N','021','DEN','1932638','18575LA002000101','2014-02-01','2013-12-27 15:31:54','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-28 03:35:49'),(14536,11599,'Y','18','024','14','A','','','TE','0001098922','0001098922','','IL','1','Cross','Roosevelt',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-17','M','',NULL,NULL,NULL,'','2290217','','2013-12-27','2013-12-27 11:12:40',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-28 03:34:41'),(14080,11220,'Y','18','024','14','A','','','TE','0000103887','0000103887','','IL','1','louis','sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-15','F','',NULL,NULL,NULL,'','2616117','','2013-12-26','2013-12-26 10:24:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:01:05'),(7024,5577,'Y','18','021','EC','A','','','AC','0001085924','0001085924','TX00000418721','31','1','Hall','Green','','','','34','458920287','P O Box 57',0,'Moscow','TX','75960',NULL,'CY','48373','1950-02-21','M','U',':RET:2054-5','N','021','DEN','2498175','33348TX002000201','2014-01-01','2013-12-24 22:07:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:56'),(5981,4734,'Y','18','021','EC','A','','','AC','0000207127','0000207127','OH00001366445','IL','1','Latta','Douglas','','','','34','564290596','P.O. Box 43',0,'Curtice','OH','43412',NULL,'CY','39123','1957-06-28','M','M',':RET:2106-3','N','021','HLT','2603098','92036OH004002701','2014-01-01','2013-12-23 23:32:23','360.00',NULL,NULL,'365.79','5.79','R-OH006','OH0','365.79',NULL,0,'2013-12-25 23:51:56'),(6090,4827,'Y','18','021','EC','A','','','AC','0001127961','0001127961','OH00000564889','IL','1','Woods','Veronica','','','','34','285548162','4066 IDDINGS CT',0,'DAYTON','OH','45405','1465','CY','39113','1954-04-20','F','U',':RET:2054-5','N','021','HLT','565051','92036OH003000506','2014-01-01','2013-11-30 18:51:08','0.00',NULL,NULL,'646.18','646.18','R-OH003','OH0','646.18',NULL,0,'2013-12-26 00:02:43'),(6749,5355,'Y','18','021','EC','A','','','AC','0000767374','0000767374','OH00001281150','31','1','bullock','leneta','','','','34','269583100','p.o.174',0,'sherwood','OH','43556',NULL,'CY','39039','1954-05-10','F','U',':RET:2106-3','N','021','HLT','1036905','92036OH005002606','2014-01-01','2013-11-25 16:51:02','503.87',NULL,NULL,'507.58','3.71','R-OH001','OH0','507.58',NULL,0,'2013-12-26 01:16:02'),(20660,16510,'N','01','021','EC','A',NULL,NULL,'','0001233186','0001180091','','IL','1','Soto','Irene','','','','34','465215460','1535 HARVEY SMITH RD',0,'COTULLA','TX','78014','5055','CY','48283','1964-07-09','F','',NULL,'N','021','DEN','3434979','33348TX002000201','2014-03-01','2014-01-30 17:21:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:43'),(20913,16717,'Y','18','021','EC','A','','','AC','0000684846','0000684846','OH00002152996','IL','1','Meyer','Kenneth','','','','34','270782740','8800 LIMERIDGE RD',0,'RAVENNA','OH','44266','9179','CY','39133','1979-11-28','M','M',':RET:2106-3','N','021','HLT','2830194','52664OH152000901','2014-03-01','2014-01-31 09:31:58','99.00',NULL,NULL,'399.21','300.21','R-OH012','OH0','198.30',NULL,0,'2014-01-31 21:01:28'),(21717,17342,'Y','18','021','EC','A','','','AC','0000948457','0000948457','OH00002614672','IL','1','Hoang','Jessica','','','','34','623525462','1415 OAK HILL CT',0,'TOLEDO','OH','43614','2544','CY','39095','1983-05-23','F','M',':RET:2047-9','N','021','HLT','3326810','92036OH001002601','2014-03-01','2014-02-05 14:25:06','0.00',NULL,NULL,'266.97','266.97','R-OH001','OH0','266.97',NULL,0,'2014-02-05 21:31:18'),(23227,18517,'Y','18','021','EC','A','','','AC','0000448811','0000448811','OH00002470755','IL','1','kevern','james','','','','34','298527454','3196 W116th St',0,'Cleveland','OH','44111',NULL,'CY','39035','1953-07-31','M','U',':RET:2106-3','T','021','HLT','2967957','92036OH004000801','2014-03-01','2014-02-12 16:28:20','285.00',NULL,NULL,'586.74','301.74','R-OH011','OH0','586.74',NULL,0,'2014-02-12 21:32:22'),(24132,19180,'Y','18','021','EC','A','','','AC','0001623424','0001623424','LA00001984588','IL','1','Hicks','Tania','','','','34','381966746','5435 BEECHWOOD DR',0,'BATON ROUGE','LA','70805','3020','CY','22033','1984-08-09','F','U',':RET:2054-5','N','021','DEN','3450942','18575LA002000101','2014-03-01','2014-02-15 15:16:19','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-15 22:01:48'),(25632,20334,'Y','18','021','EC','A','','','AC','0000564254','0000564254','OH00002415802','IL','1','GILL','JAMES','L','','','34','294489398','8950 CATT RD NE',0,'NEWARK','OH','43055',NULL,'CY','39089','1951-10-16','M','U',':RET:2106-3','N','021','DEN','2881684','99734OH005000301','2014-04-01','2014-02-22 13:45:03','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:23'),(18178,14514,'Y','18','021','EC','A','','','AC','0000216125','0000216125','OH00001475318','IL','1','RAFTERY','SUSAN','','','','34','287527520','157 PERU HOLLOW RD',0,'NORWALK','OH','44857',NULL,'CY','39077','1952-10-09','F','U',':RET:2106-3','N','021','HLT','1532412','92036OH004002701','2014-02-01','2014-01-14 14:51:56','267.00',NULL,NULL,'440.60','173.60','R-OH006','OH0','440.60',NULL,0,'2014-01-15 02:07:59'),(19129,15241,'Y','18','021','EC','A','','','AC','0001152288','0001152288','LA00002369583','IL','1','Hayes','Terry','','','','34','436175979','3711 PAUGER ST',0,'NEW ORLEANS','LA','70122','3610','CY','22071','1959-02-22','M','U',':RET:2054-5','T','021','DEN','2274471','18575LA002000201','2014-03-01','2014-01-19 16:57:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:45:22'),(20599,16459,'Y','18','021','EC','A','','','AC','0000287127','0000287127','OH00001752540','IL','1','ALLISON','JEFFERY','L','','','34','287563627','3521 HARRISON AVE NW',0,'CANTON','OH','44709','2762','CY','39151','1956-08-31','M','M',':RET:2106-3','N','021','DEN','3370150','99734OH005000401','2014-03-01','2014-01-30 12:51:50','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-01-30 21:00:12'),(23198,18497,'Y','18','021','EC','A','','','AC','0001200924','0001200924','OH00002230164','IL','1','Teutsch','Adam','','','','34','506130676','211 W 9TH ST',0,'CINCINNATI','OH','45202','1959','CY','39061','1982-10-18','M','U',':RET:2106-3','T','021','HLT','3640869','92036OH006001201','2014-03-01','2014-02-12 06:33:16','0.00',NULL,NULL,'226.92','226.92','R-OH004','OH0','226.92',NULL,0,'2014-02-12 21:32:07'),(23633,18819,'Y','18','021','EC','A','','','AC','0000904971','0000904971','TX00002315497','IL','1','CERRILLO','MARIA','E','','','34','632469225','808 BRADLEY DR',0,'ATHENS','TX','75751','2949','CY','48213','1975-12-24','F','M',NULL,'N','021','DEN','2865601','33348TX002000201','2014-03-01','2014-02-13 18:24:48','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:04'),(24890,19734,'N','03','021','EC','A',NULL,NULL,'','0001152250','0000043265','','IL','1','Irby','Donald','','','','34','230615043','2237 SARATOGA DR',0,'FINDLAY','OH','45840','7400','CY','39063','1991-06-18','M','',':RET:2106-3','N','021','HLT','3755831','92036OH003001505','2014-04-01','2014-02-19 10:59:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.83','CIC',0,'2014-02-20 05:38:35'),(25380,20136,'Y','18','021','EC','A','','','AC','0000974137','0000974137','OH00003274797','IL','1','Humphries','Roberta','','','','34','288807003','141 CENTRAL AVE',0,'BLANCHESTER','OH','45107','1425','CY','39027','1975-06-09','F','U',NULL,'N','021','DEN','2931624','99734OH005000301','2014-04-01','2014-02-25 17:00:09','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-25 21:30:46'),(26451,20981,'Y','18','021','EC','A','','','AC','0000177461','0000177461','MS00003316291','IL','1','bretheim','david','','','','34','426391320','147 CHINQUIPIN CV',0,'RIDGELAND','MS','39157','1007','CY','28089','1974-02-22','M','M',':RET:2106-3','N','021','DEN','3260961','46300MS002000101','2014-03-01','2014-02-27 07:32:02','36.36',NULL,NULL,'148.50','112.14','R-MS003','MS0','27.15','CIC',0,'2014-02-28 07:30:26'),(9579,7585,'Y','18','021','EC','A','','','AC','0001056691','0001056691','OH00000030337','IL','1','Elassal','Hani','','','','34','070645963','3842 WALLINGFORD RD',0,'SOUTH EUCLID','OH','44121','1952','CY','39035','1956-12-22','M','M',NULL,'N','021','DEN','2231873','99734OH005000301','2014-01-01','2013-12-21 17:16:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:36:50'),(19374,15444,'Y','18','021','EC','A','','','AC','0000118288','0000118288','MS00002308207','31','1','Ware','Christine','','','','34','501829638','P.O. BOX 103',0,'duncan','MS','38740',NULL,'CY','28011','1955-11-27','F','U',NULL,'N','021','DEN','2387084','46300MS002000101','2014-03-01','2014-01-20 19:41:32','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2014-01-22 03:22:38'),(9089,7213,'Y','18','021','EC','A','','','AC','0000970451','0000970451','OH00001012663','IL','1','Johnson','Eric','','','','34','408947414','1200 RIPPLECREEK CT',0,'CENTERVILLE','OH','45458','3282','CY','39113','1953-10-07','M','U',':RET:2054-5','N','021','DEN','2499136','99734OH005000301','2014-01-01','2013-12-18 10:17:32','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:07:01'),(2364,1928,'Y','18','021','EC','A','','','AC','0000684794','0000684794','OH00000043990','IL','1','LEAS','SAUNDRA','','','','34','302523150','311 FROSTVIEW DR',0,'WINTERSVILLE','OH','43953','4245','CY','39081','1950-06-21','F','M',':RET:2106-3','N','021','DEN','185926','99734OH005000401','2014-01-01','2013-12-09 07:49:24','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 19:32:34'),(16583,13264,'N','01','021','EC','A',NULL,NULL,'','0001780576','0001419740','','IL','1','gerstner','michael','','','','34','437299929','29 MILLERS CREEK LN',0,'SLIDELL','LA','70458','5448','CY','22103','1972-11-25','M','',':RET:2106-3','N','021','DEN','2585704','18575LA002000201','2014-02-01','2014-01-07 12:21:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-08 18:23:58'),(15624,12497,'Y','18','024','14','A','','','TE','0000319049','0000319049','','IL','1','Spann','Claire',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-25','F','',NULL,NULL,NULL,'','196181','','2013-12-31','2013-12-31 18:28:38',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2014-01-02 04:33:16'),(2714,2195,'Y','18','024','14','A','','','TE','0000655790','0000655790','','IL','1','Toth','Jeffrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-23','M','',NULL,NULL,NULL,'','428018','','2013-12-02','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:48:01'),(28938,22901,'Y','18','021','EC','A','','','AC','0000827226','0000827226','OH00003746595','IL','1','Nisch','Ronald','','','','34','297444556','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','1959-01-13','M','M',':RET:2106-3','N','021','DEN','4285886','99734OH005000301','2014-04-01','2014-03-10 17:13:23','0.00',NULL,NULL,'59.76','59.76','R-OH006','OH0','0.00',NULL,0,'2014-03-10 21:00:41'),(753,622,'Y','18','021','EC','A','','','AC','0000921331','0000921331','TX00000837118','IL','1','Minard','Jennifer','Kay','','','34','460737848','5829 PARKSIDE CT',0,'GRANBURY','TX','76048','3211','CY','48221','1968-07-25','F','M',':RET:2106-3','T','021','DEN','2424956','33348TX002000201','2014-01-01','2013-12-16 10:13:33','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:20'),(19336,15415,'Y','18','021','EC','A','','','AC','0000730341','0000730341','TX00001501876','IL','1','lowe','donald','','','','34','569497555','505  w avenue j',0,'killeen','TX','76541',NULL,'CY','48027','1977-12-10','M','M',':RET:2106-3','T','021','DEN','2998303','33348TX002000201','2014-03-01','2014-01-21 15:56:50','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,1,'2014-01-22 03:22:18'),(19331,15410,'Y','18','024','14','A','','','TE','0000689569','0000689569','','IL','1','Little','Erik',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-05-09','M','',NULL,NULL,NULL,'','1795929','','2014-01-21','2014-01-21 08:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:16'),(1078,884,'Y','18','021','EC','A','','','AC','0000938501','0000938501','OH00000054677','IL','1','Kusak','Elizabeth','','','','34','287829828','220 Napoleon Road',0,'Bowling Green','OH','43402',NULL,'CY','39173','1982-09-22','F','M',':RET:2106-3','N','021','DEN','819369','99734OH005000401','2014-01-01','2013-12-03 09:23:42','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:16:41'),(19228,15321,'Y','18','021','EC','A','','','AC','0000415986','0000415986','OH00002097019','IL','1','Johnson','Nathaniel','','','','34','271609106','1737 Berkley Avenue',0,'Cincinnati','OH','45237',NULL,'CY','39061','1959-11-30','M','U',':RET:2054-5','N','021','DEN','2091586','99734OH005000301','2014-03-01','2014-01-19 21:38:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-21 08:46:31'),(27247,21574,'Y','18','021','EC','A','','','AC','0001004317','0001004317','TX00002897878','IL','1','Hindman','Brenda','','','','34','587907509','391 MORELAND ST',0,'VIDOR','TX','77662','5556','CY','48361','1952-08-24','F','M',':RET:2106-3','N','021','DEN','3468627','33348TX002000101','2014-04-01','2014-03-03 14:31:04','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2014-03-03 21:31:50'),(27398,21689,'N','19','021','EC','A',NULL,NULL,'','0000214721','0000499358','','IL','1','Rowland','Noah','','','','34','273082029','328 Beech Street',0,'Green Camp','OH','43322',NULL,'CY','39101','2002-11-15','M','',':RET:2106-3','N','021','DEN','2955789','99734OH005000301','2014-04-01','2014-03-03 21:44:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:30'),(27588,21818,'Y','18','021','EC','A','','','AC','0000563198','0000563198','TX00002792955','IL','1','daily','mykelle','','','','34','623649948','3000 Murworth dr.',0,'houston','TX','77025',NULL,'CY','48201','1992-07-16','F','U',':RET:2054-5','N','021','DEN','4031505','33348TX002000201','2014-04-01','2014-03-05 16:08:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-03-05 21:00:15'),(28262,22363,'Y','18','021','EC','A','','','AC','0000599821','0000599821','OH00003779513','31','1','DAVIS','JACQUELINE','','','','34','179441486','PO BOX1604',0,'DAYTON','OH','45401',NULL,'CY','39113','1951-08-11','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3621284','99734OH005000301','2014-04-01','2014-03-07 16:28:06','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00','CIC',0,'2014-03-07 21:00:17'),(28389,22462,'Y','18','021','EC','A','','','AC','0000498238','0000498238','OH00003318713','IL','1','Lantz','Nicole','','','','34','291825219','701 RUDOLPH AVE',0,'CUYAHOGA FALLS','OH','44221','1939','CY','39153','1984-04-13','F','M',NULL,'N','021','HLT','3434437','52664OH152000901','2014-04-01','2014-03-07 17:45:05','497.00',NULL,NULL,'611.87','114.87','R-OH012','OH0','182.78',NULL,0,'2014-03-07 21:30:44'),(13780,10998,'Y','18','021','EC','A','','','AC','0000303970','0000303970','MS00000700384','IL','1','Holmes','Christopher','','','','34','109722273','5042 OAK CREEK DR',0,'Jackson','MS','39212',NULL,'CY','28049','1987-10-02','M','U',':RET:2054-5','N','021','DEN','2569518','46300MS002000201','2014-01-01','2013-12-23 15:58:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:43'),(1939,1579,'Y','18','021','EC','A','','','AC','0000293153','0000293153','OH00000748404','IL','1','Lawson','Jermaine','','','','34','274908710','1370 W 9TH ST',0,'CLEVELAND','OH','44113','1217','CY','39035','1985-02-19','M','U',':RET:2054-5','N','021','DEN','687114','99734OH005000401','2014-01-01','2013-11-19 20:28:05','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:00:36'),(7772,6153,'Y','18','021','EC','A','','','AC','0001199100','0001199100','TX00000365603','IL','1','COLSTONMACK','VENEITRA','','','','34','443725577','12610 JUPITER RD',0,'DALLAS','TX','75238','3900','CY','48113','1972-09-04','F','U',':RET:2054-5','N','021','DEN','2373066','33348TX002000201','2014-01-01','2013-12-19 19:52:31','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 03:02:56'),(16280,13033,'Y','18','021','EC','A','','','AC','0001033672','0001033672','OH00001430987','IL','1','Young','Venita','','','','34','290584295','1144 Carmania Avenue',0,'Cincinnati','OH','45238',NULL,'CY','39061','1958-10-06','F','M',':RET:2054-5','N','021','DEN','2229962','99734OH005000401','2014-02-01','2014-01-06 16:05:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:30'),(6446,5111,'N','01','021','EC','A',NULL,NULL,'','0000293163','0000982684','','IL','1','Farnsworth','Bryan','','','','34','298687470','1465 MICHIGAN AVE',0,'MAUMEE','OH','43537','2610','CY','39095','1974-10-04','M','',NULL,'N','021','HLT','818110','92036OH004002601','2014-01-01','2013-12-10 21:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','197.87',NULL,0,'2013-12-26 00:49:34'),(7753,6141,'Y','18','024','14','A','','','TE','0000846113','0000846113','','IL','1','Paynter','Sylvia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-11','F','',NULL,NULL,NULL,'','1054838','','2013-12-20','2013-12-20 16:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:34'),(5303,4203,'Y','18','021','EC','A','','','AC','0000946096','0000946096','OH00000531404','IL','1','Lemire','Michael','','','','34','286581700','120 OAKLAND AVE',0,'FINDLAY','OH','45840','5317','CY','39063','1959-01-13','M','U',':RET:2106-3','N','021','HLT','2258954','92036OH006001501','2014-01-01','2013-12-18 19:12:55','175.00',NULL,NULL,'372.65','197.65','R-OH002','OH0','372.65',NULL,0,'2013-12-25 23:06:20'),(5929,4694,'Y','18','021','EC','A','','','AC','0000036941','0000036941','TX00000412102','IL','1','Sailors','Russell','','','','34','434639334','51 S Burberry Park Cir',0,'The Woodlands','TX','77382',NULL,'CY','48339','1971-11-03','M','M',':RET:2106-3','N','021','DEN','1534307','33348TX002000101','2014-01-01','2013-12-24 01:27:24','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:50:27'),(23864,18989,'Y','18','021','EC','A','','','AC','0001157609','0001157609','OH00001963312','S3','1','Wells','Gabriel','Alan','','','34','826834263','4351 IMPERIAL DR',0,'TOLEDO','OH','43615','1215','CY','39095','2013-12-18','M','U',':RET:2106-3','N','021','HLT','2804017','92036OH002002601','2014-03-01','2014-02-14 09:26:27','0.00',NULL,NULL,'286.00','286.00','R-OH001','OH0','143.00',NULL,0,'2014-02-14 21:32:06'),(24667,19580,'N','19','021','EC','A',NULL,NULL,'','0000149395','0000771483','','IL','1','Van Dyke','Devin','','','','34','268024595','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1996-08-23','M','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-02-20 04:26:52'),(24828,19682,'Y','18','021','EC','A','','','AC','0000697956','0000697956','OH00002635752','IL','1','wilson','michael','','','','34','243734736','37 CONCORD WOODS DR',0,'MILFORD','OH','45150','1334','CY','39025','1992-04-28','M','M',':RET:2106-3','N','021','HLT','3440784','92036OH002000601','2014-04-01','2014-02-18 22:48:36','0.00',NULL,NULL,'247.90','247.90','R-OH005','OH0','247.90',NULL,0,'2014-02-20 04:51:17'),(14931,11931,'Y','18','021','EC','A','','','AC','0000736028','0000736028','TX00001187201','IL','1','Hall','Mark','','','','34','462154343','418 Dorie Street',0,'San Antonio','TX','78220',NULL,'CY','48029','1962-05-02','M','U',':RET:2054-5','N','021','DEN','2419376','33348TX002000101','2014-02-01','2013-12-29 12:29:58','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-30 00:02:01'),(1873,1529,'Y','18','021','EC','A','','','AC','0000680844','0000680844','OH00000482993','IL','1','Galon','Eric','','','','34','298762948','8684 N BEDFORD RD',0,'MACEDONIA','OH','44056','1943','CY','39153','1976-02-13','M','U',':RET:2106-3','N','021','HLT','1812461','52664OH152000901','2014-01-01','2013-12-24 16:25:46','0.00',NULL,NULL,'202.22','202.22','R-OH012','OH0','202.22',NULL,0,'2013-12-25 18:58:20'),(2053,1682,'Y','18','021','EC','A','','','AC','0001018205','0001018205','OH00000365168','IL','1','Sargent','Kathryn','','','','34','554970331','1128 Convers Ave',0,'Zanesville','OH','43701',NULL,'CY','39119','1985-07-08','F','U',':RET:2106-3','N','021','DEN','810979','99734OH005000301','2014-01-01','2013-12-09 19:06:21','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 19:15:56'),(8932,7081,'Y','18','021','EC','A','','','AC','0000940843','0000940843','OH00000992390','IL','1','Lawson','Joseph','','','','34','299707150','5682 PERKINS RD',0,'BEDFORD HEIGHTS','OH','44146','2501','CY','39035','1964-06-22','M','U',NULL,'N','021','DEN','2602660','99734OH005000401','2014-01-01','2013-12-18 10:13:44','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:03'),(26001,20621,'Y','18','021','EC','A','','','AC','0001514076','0001514076','LA00002829337','IL','1','Lewis','Brandon','','','','34','434630234','5367 WASHINGTON AVE',0,'BATON ROUGE','LA','70806','1644','CY','22033','1986-11-28','M','U',':RET:2054-5','N','021','DEN','3761074','18575LA002000101','2014-04-01','2014-02-26 12:47:59','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-26 21:02:03'),(27284,21604,'N','01','021','EC','A',NULL,NULL,'','0000986216','0000737550','','IL','1','WHITE','JAMES',NULL,NULL,NULL,NULL,NULL,'1602 WILBURN DR',0,'BAYTOWN','TX','77520',NULL,'CY','48201','1956-11-21','M','',':RET:2054-5','N','021','DEN','2662453','33348TX002000201','2014-04-01','2014-03-03 23:14:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-04 21:00:24'),(28085,22227,'Y','18','021','EC','A','','','AC','0001112170','0001112170','TX00003487269','IL','1','ALCALA','KRYSTA','','','','34','630050804','17838 JUNIPER GREEN TRL',0,'HUMBLE','TX','77346','4300','CY','48201','1981-02-04','F','U',NULL,'N','021','DEN','3827225','33348TX002000101','2014-04-01','2014-03-06 15:17:22','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-06 21:02:00'),(8927,7077,'N','01','021','EC','A',NULL,NULL,'','0001233040','0001160401','','IL','1','DEMKOVICH','PATRICK','','','','34','545678806','815 S CHESTERFIELD RD',0,'COLUMBUS','OH','43209','2631','CY','39049','1965-12-14','M','',':RET:2106-3','N','021','DEN','1366440','99734OH005000401','2014-01-01','2013-12-18 09:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:55'),(7030,5583,'Y','18','021','EC','A','','','AC','0000246917','0000246917','TX00000989015','IL','1','Spencer','George','Leonard','','III','34','636074870','2040 PINE KNOT DR',0,'HEARTLAND','TX','75126','8283','CY','48257','1973-04-09','M','M',':RET:2054-5','N','021','DEN','2183527','33348TX002000201','2014-01-01','2013-12-24 23:21:33','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:06'),(4421,3513,'Y','18','021','EC','A','','','AC','0000680814','0000680814','OH00000288583','IL','1','Shafitz','Michael','','','','34','420782243','4021 Eastern Avenue',0,'Cincinnati','OH','45226',NULL,'CY','39061','1952-08-25','M','M',NULL,'N','021','DEN','508619','99734OH005000401','2014-01-01','2013-12-12 16:37:49','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:38'),(4517,3580,'Y','18','021','EC','A','','','AC','0000814229','0000814229','TX00000217413','IL','1','CHAVEZ','MARTIN','','','','34','450454699','5353 RIDGE ST',0,'EL PASO','TX','79932','1551','CY','48141','1963-03-01','M','U',NULL,'T','021','DEN','653066','33348TX002000201','2014-01-01','2013-12-12 11:58:16','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 22:03:44'),(17569,14047,'Y','18','021','EC','A','','','AC','0000089850','0000089850','OH00002326557','IL','1','TURNER','DARLA','','','','34','288421921','1130 LAVINA AVE',0,'BUCYRUS','OH','44820','3036','CY','39033','1953-12-03','F','U',NULL,'N','021','DEN','1495742','99734OH005000401','2014-02-01','2014-01-13 10:11:22','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-01-14 01:32:00'),(4859,3850,'Y','18','021','EC','A','','','AC','0000640751','0000640751','LA00001084697','IL','1','PICKENS','BIRDELL','','','','34','439452342','154 SAYLOCK LN',0,'OPELOUSAS','LA','70570','1791','CY','22097','1980-08-07','F','U',':RET:2054-5','T','021','DEN','305864','18575LA002000201','2014-01-01','2013-11-08 15:52:45','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 22:30:37'),(21784,17396,'Y','18','021','EC','A','','','AC','0001126911','0001126911','OH00002227396','IL','1','Bluemel','Melody','','','','34','374601835','4998 ABBERTON CT',0,'HILLIARD','OH','43026','9518','CY','39049','1954-10-26','F','U',':RET:2106-3','N','021','DEN','3671796','99734OH005000401','2014-03-01','2014-02-06 08:35:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:39'),(23954,19047,'Y','18','021','EC','A','','','AC','0000404396','0000404396','TX00002552001','IL','1','Vinezof','Bruno','Jose','','','34','819408249','1015 MILFORD WAY',0,'AUSTIN','TX','78745','2976','CY','48453','1984-09-15','M','M',NULL,'N','021','DEN','3826691','33348TX002000101','2014-03-01','2014-02-15 10:47:04','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:06'),(25028,19846,'Y','18','021','EC','A','','','AC','0000545301','0000545301','TX00001908322','IL','1','pooler','michael','','','','34','484929789','2904 barton skyway',0,'austin','TX','78746',NULL,'CY','48453','1966-10-04','M','U',':RET:2028-9','N','021','DEN','3234666','33348TX002000101','2014-04-01','2014-02-20 15:05:01','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-20 22:01:01'),(25078,19888,'Y','18','021','EC','A','','','AC','0000927357','0000927357','OH00002841046','IL','1','Wollum','Heather','','','','34','286907771','21 allen st',0,'westunion','OH','45693',NULL,'CY','39001','1989-07-15','F','M',':RET:2106-3','T','021','HLT','3263085','92036OH003000605','2014-04-01','2014-02-20 11:16:41','123.00',NULL,NULL,'257.80','134.80','R-OH005','OH0','257.80',NULL,0,'2014-02-20 22:01:35'),(26040,20652,'Y','18','021','EC','A','','','AC','0000954350','0000954350','OH00002964973','IL','1','Ringler','James','','','','34','280823113','847 hampton ridge dr',0,'akron','OH','44313',NULL,'CY','39153','1983-04-14','M','U',NULL,'N','021','HLT','2942024','52664OH151001304','2014-03-01','2014-02-26 14:24:41','86.00',NULL,NULL,'253.11','167.11','R-OH012','OH0','253.11',NULL,0,'2014-02-26 21:02:26'),(28481,22534,'N','01','021','EC','A',NULL,NULL,'','0000013844','0000574500','','IL','1','Davis','Jennie','Linda','','','34','266257046','7103 EVENTRAIL DR',0,'POWELL','OH','43065','7342','CY','39041','1956-10-06','F','',':RET:2106-3','N','021','DEN','3666152','99734OH005000301','2014-04-01','2014-03-07 11:40:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:35'),(13351,10662,'N','01','021','EC','A',NULL,NULL,'','0000782806','0000937999','','IL','1','Morales','George','','','Jr','34','456632338','1202 Mallette Dr',0,'Victoria','TX','77904',NULL,'CY','48469','1982-06-08','M','',':RET:2106-3','N','021','DEN','1508511','33348TX002000201','2014-01-01','2013-12-23 19:10:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:59:12'),(6160,4884,'Y','18','021','EC','A','','','AC','0000003540','0000003540','OH00000155048','IL','1','Houser','Michael','Dean','','','34','269881438','3668 Kent Road',0,'Stow','OH','44224',NULL,'CY','39153','1987-12-01','M','U',':RET:2106-3','N','021','HLT','284344','52664OH152000901','2014-01-01','2013-11-21 15:29:38','90.00',NULL,NULL,'167.26','77.26','R-OH012','OH0','167.26',NULL,0,'2013-12-26 00:16:45'),(18214,14538,'Y','18','021','EC','A','','','AC','0000918272','0000918272','OH00001475325','IL','1','German','Carrie','','','','34','298846558','21371 JENNINGS DELPHOS RD',0,'DELPHOS','OH','45833','8865','CY','39161','1984-03-24','F','M',':RET:2106-3','N','021','HLT','1639161','92036OH006001501','2014-02-01','2014-01-14 17:10:24','0.00',NULL,NULL,'440.58','440.58','R-OH002','OH0','195.31',NULL,0,'2014-01-15 02:08:11'),(785,647,'Y','18','021','EC','A','','','AC','0000838399','0000838399','TX00001114936','IL','1','Leavell','Scott','M','','','34','372884837','5323 RIDGECREST DR',0,'WICHITA FALLS','TX','76310','3493','CY','48485','1980-11-28','M','U',':RET:2106-3','N','021','DEN','2059078','33348TX002000201','2014-01-01','2013-12-16 15:30:25','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:05:09'),(16982,13591,'N','01','021','EC','A',NULL,NULL,'','0000407385','0000499323','','IL','1','price','madelyn','g','','','34','280500221','10567 RUSSELLVILLE WINCHESTER RD',0,'WINCHESTER','OH','45697','9638','CY','39015','1957-12-08','F','',':RET:2106-3','N','021','HLT','1455930','92036OH005000606','2014-02-01','2014-01-08 20:53:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','500.82',NULL,0,'2014-01-13 02:20:19'),(16462,13171,'N','01','021','EC','A',NULL,NULL,'','0000816438','0000636022','','IL','1','CAMPOLONGO','CHERYL','','','','34','290740761','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1963-11-14','F','',NULL,'N','021','HLT','2257217','92036OH004000601','2014-02-01','2014-01-06 10:24:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.28',NULL,0,'2014-01-07 04:05:43'),(4736,3752,'Y','18','021','EC','A','','','AC','0000866878','0000866878','OH00000447194','IL','1','fasick','christie','','','','34','295687263','9633 COUNTRY CLUB RD',0,'PIQUA','OH','45356','9520','CY','39109','1968-12-13','F','M',':RET:2106-3','N','021','HLT','774646','92036OH004000501','2014-01-01','2013-12-12 14:25:37','0.00',NULL,NULL,'276.01','276.01','R-OH003','OH0','276.01',NULL,0,'2013-12-25 22:09:17'),(2671,2167,'N','01','021','EC','A',NULL,NULL,'','0000868197','0000322107','','IL','1','Brandt','Janice','L','','','34','302447558','8881 WILDWOOD DR',0,'NORTH ROYALTON','OH','44133','1155','CY','39035','1951-04-17','F','',':RET:2106-3','N','021','DEN','433252','99734OH005000301','2014-01-01','2013-12-02 15:08:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:03'),(2648,2152,'Y','18','021','EC','A','','','AC','0000789866','0000789866','TX00000109342','IL','1','Parsons','Patrice','','','','34','449068250','4400 MEMORIAL DR',0,'HOUSTON','TX','77007','7378','CY','48201','1954-05-14','F','M',':RET:2106-3','N','021','DEN','89249','33348TX002000101','2014-01-01','2013-12-02 17:44:49','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-25 19:46:32'),(1963,1602,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','525781','','2013-11-19','2013-11-19 22:59:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:17'),(22009,17570,'N','01','021','EC','A',NULL,NULL,'','0000844737','0000265282','','IL','1','Moroski','Katherine','','','','34','294809624','400 Pike St',0,'Cincinnati','OH','45202',NULL,'CY','39061','1980-07-26','F','',':RET:2106-3','N','021','DEN','2997355','99734OH005000301','2014-03-01','2014-02-07 07:39:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:50'),(24231,19243,'Y','18','021','EC','A','','','AC','0001209635','0001209635','OH00002993017','IL','1','WELLS','KIMM','','','','34','291423987','241 RIVERSIDE DR',0,'TROY','OH','45373',NULL,'CY','39109','1956-02-12','F','M',':RET:2106-3','N','021','DEN','3348737','99734OH005000401','2014-04-01','2014-02-16 14:04:17','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-16 19:00:34'),(24866,19716,'Y','18','024','14','A','','','TE','0000326755','0000326755','','IL','1','White','Areniqua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-20','F','',NULL,NULL,NULL,'','2554261','','2014-03-31','2014-02-19 16:20:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 05:31:51'),(28058,22203,'Y','18','021','EC','A','','','AC','0000082618','0000082618','OH00003653966','IL','1','EHMAN','CORY','N','','','34','279909670','11158 STATE ROUTE 141',0,'PATRIOT','OH','45658','9274','CY','39053','1987-10-03','M','U',':RET:2106-3','N','021','DEN','3167032','99734OH005000301','2014-04-01','2014-03-05 18:58:48','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-03-06 21:01:42'),(28490,22543,'Y','18','021','EC','A','','','AC','0000253113','0000253113','OH00002637261','IL','1','GOUDA','ABDELKARIM','','','','34','714857781','980 KING AVE',0,'COLUMBUS','OH','43212','2638','CY','39049','1990-09-20','M','U',':RET:2106-3','N','021','DEN','3871746','99734OH005000301','2014-04-01','2014-03-07 17:48:58','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:41'),(15205,12152,'Y','18','021','EC','A','','','AC','0000633298','0000633298','MS00000605622','IL','1','Jones','yvonne','L','','','34','318482580','2425 HWY 84',0,'Meadville','MS','39653',NULL,'CY','28037','1954-01-30','F','M',':RET:2054-5','N','021','DEN','1974619','46300MS002000201','2014-02-01','2013-12-30 15:14:38','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2014-01-01 12:07:32'),(1351,1119,'Y','18','021','EC','A','','','AC','0000433096','0000433096','TX00000241055','IL','1','Kramitz','Victor','','','','34','111529505','2202 S SHADOW GROVE LN',0,'RICHMOND','TX','77406','2428','CY','48157','1958-06-21','M','U',':RET:2106-3','N','021','DEN','2524485','33348TX002000101','2014-01-01','2013-12-24 12:47:35','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:45:15'),(9248,7332,'N','01','021','EC','A',NULL,NULL,'','0001157551','0000744420','','IL','1','Roessner','Debra','R',NULL,NULL,NULL,NULL,'PO Box 380  704 Little Turtle Drive',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1958-04-28','F','',':RET:2106-3','N','021','HLT','2146728','92036OH002001501','2014-01-01','2013-12-18 17:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','566.78',NULL,0,'2013-12-26 04:10:44'),(19045,15168,'Y','18','021','EC','A','','','AC','0000456548','0000456548','OH00002242944','IL','1','Roth','Andrew','','','','34','300725591','2910 E LINCOLNSHIRE BLVD',0,'TOLEDO','OH','43606','2817','CY','39095','1962-12-14','M','M',':RET:2106-3','N','021','HLT','1841384','92036OH006002601','2014-03-01','2014-01-17 17:29:27','218.00',NULL,NULL,'288.42','70.42','R-OH001','OH0','288.42',NULL,0,'2014-01-20 08:06:40'),(4728,3747,'Y','18','021','EC','A','','','AC','0000966891','0000966891','OH00000219673','IL','1','Scranton','Paula','','','','34','270562347','5456 HUBER RD',0,'HICKSVILLE','OH','43526','9752','CY','39039','1954-02-28','F','M',NULL,'N','021','HLT','836900','92036OH003002606','2014-01-01','2013-12-12 17:04:16','1010.00',NULL,NULL,'1082.73','72.73','R-OH001','OH0','530.07',NULL,0,'2013-12-25 22:09:06'),(20333,16236,'Y','18','021','EC','A','','','AC','0000908059','0000908059','OH00002056233','IL','1','Rydarowics','Stanley','','','','34','300509677','165 MANCHESTER AVE',0,'YOUNGSTOWN','OH','44509','2306','CY','39099','1951-09-06','M','U',NULL,'N','021','HLT','1934709','52664OH151001501','2014-03-01','2014-01-28 09:35:15','430.00',NULL,NULL,'871.41','441.41','R-OH013','OH0','871.41',NULL,0,'2014-01-28 21:01:03'),(4197,3337,'N','01','021','EC','A',NULL,NULL,'','0000030526','0001234114','','IL','1','Gerber','Robert','','','','34','275768165','969 BROOK RD',0,'WADSWORTH','OH','44281','9057','CY','39103','1970-03-23','M','',':RET:2106-3','N','021','HLT','1768557','52664OH151001304','2014-01-01','2013-12-17 16:30:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2013-12-25 21:49:46'),(3097,2488,'Y','18','021','EC','A','','','AC','0000991511','0000991511','OH00000929348','IL','1','Korn','jeffrey','','','','34','114466728','4463 Broadview road',0,'Cleveland','OH','44109',NULL,'CY','39035','1964-03-28','M','U',':RET:2106-3','N','021','HLT','284497','92036OH004000801','2014-01-01','2013-12-06 07:55:39','0.00',NULL,NULL,'320.72','320.72','R-OH011','OH0','320.72',NULL,0,'2013-12-25 20:20:08'),(14864,11869,'Y','18','021','EC','A','','','AC','0000008809','0000008809','TX00000309089','IL','1','manion','jason','','','','34','453992561','915 MEADOW VIEW DR',0,'RICHARDSON','TX','75080','3009','CY','48113','1972-09-01','M','M',':RET:2106-3','N','021','DEN','1622478','33348TX002000201','2014-02-01','2013-12-28 18:14:35','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-30 00:00:03'),(15627,12500,'Y','18','021','EC','A','','','AC','0001998474','0001998474','LA00001212506','IL','1','siebold','john','','','','34','463987985','3919 ANNUNCIATION ST',0,'NEW ORLEANS','LA','70115','1320','CY','22071','1955-07-28','M','M',':RET:2054-5','N','021','DEN','1373477','18575LA002000101','2014-02-01','2013-12-30 22:35:40','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:33:22'),(18323,14629,'Y','18','021','EC','A','','','AC','0000363795','0000363795','OH00001677755','IL','1','Valentine','Christina','','','','34','290706326','6833 Indian hill rd',0,'Cincinnati','OH','45227',NULL,'CY','39061','1975-08-02','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','1994345','99734OH005000401','2014-02-01','2014-01-15 11:31:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:08'),(16026,12829,'Y','18','021','EC','A','','','AC','0001235063','0001235063','LA00001059649','IL','1','WESLEY','TWANDA','','','','34','437510210','56555 BREAUX ST',0,'WHITE CASTLE','LA','70788','3031','CY','22047','1982-07-14','F','U',NULL,'N','021','DEN','1443573','18575LA002000201','2014-02-01','2014-01-03 10:36:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-04 02:02:18'),(16523,13218,'Y','18','021','EC','A','','','AC','0001138423','0001138423','TX00002163720','31','1','KRAHN','KRISTOPHER','','','','34','453318012','PO BOX 278',0,'VEGA','TX','79092',NULL,'CY','48359','1973-01-23','M','U',':RET:2106-3','T','021','DEN','1785043','33348TX002000201','2014-02-01','2014-01-05 17:28:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-07 10:21:48'),(16750,13399,'Y','18','021','EC','A','','','AC','0001050032','0001050032','TX00001969807','IL','1','ROBINSON','AMBER','','','','34','466878855','2404 W 16TH ST',0,'PLAINVIEW','TX','79072','4889','CY','48189','1987-07-21','F','U',NULL,'N','021','DEN','1735454','33348TX002000101','2014-02-01','2014-01-07 12:02:54','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-08 18:24:54'),(26348,20903,'Y','18','021','EC','A','','','AC','0000500448','0000500448','OH00003081386','IL','1','Hibsman','Sandra','','','','34','191424850','7390 PEARL ROAD',0,'MIDDLEBURG HEIGHTS','OH','44130',NULL,'CY','39035','1951-10-16','F','U',NULL,'N','021','HLT','3627484','92036OH004000801','2014-04-01','2014-02-27 13:28:38','402.00',NULL,NULL,'540.10','138.10','R-OH011','OH0','540.10',NULL,0,'2014-02-28 06:31:46'),(26572,21068,'Y','18','024','14','A','','','TE','0000899617','0000899617','','IL','1','CURTIS','DAEBORAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-11','F','',NULL,NULL,NULL,'','3479566','','2014-02-28','2014-02-28 11:48:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 21:30:26'),(28049,22195,'Y','18','021','EC','A','','','AC','0001194681','0001194681','MS00003289322','IL','1','ortiz','joshua','','','','34','071668416','2835 SMITH ROBINSON ST',0,'JACKSON','MS','39213','6646','CY','28049','1981-10-13','M','M',NULL,'T','021','DEN','2779337','46300MS002000201','2014-04-01','2014-03-05 23:28:25','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:36'),(28800,22796,'N','01','021','EC','A',NULL,NULL,'','0000022858','0000488056','','IL','1','robinson','carol','i','','','34','296502263','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1953-07-11','F','',':RET:2106-3','N','021','DEN','4021324','99734OH005000301','2014-05-01','2014-03-09 10:14:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:47'),(25091,19900,'Y','18','021','EC','A','','','AC','0000471065','0000471065','OH00001776245','IL','1','Vegara','Koviljka','','','','34','731098091','1535 Brittain cir.',0,'Akron','OH','44310',NULL,'CY','39153','1968-09-27','F','M',':RET:2106-3','N','021','DEN','3254818','99734OH005000401','2014-03-01','2014-02-20 20:52:23','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-21 21:30:05'),(13605,10850,'Y','18','021','EC','A','','','AC','0000246446','0000246446','OH00000034059','IL','1','eaton','aimee','','','','34','314789224','210 w.sugar',0,'cridersville','OH','45806',NULL,'CY','39011','1970-04-12','F','U',':RET:2106-3','N','021','HLT','2130769','92036OH003001505','2014-01-01','2013-12-23 18:35:43','238.00',NULL,NULL,'311.88','73.88','R-OH002','OH0','311.88',NULL,0,'2013-12-26 13:05:30'),(23196,18495,'N','19','021','EC','A',NULL,NULL,'','0001077798','0000130737','','IL','1','Lupo','Joseph','Paul','','','34','296964205','579 Parkhill Dr',0,'Fairlawn','OH','44333',NULL,'CY','39153','1993-01-18','M','',':RET:2106-3','N','021','HLT','3301665','52664OH152000901','2014-03-01','2014-02-12 16:23:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2014-02-12 21:32:06'),(23012,18347,'Y','18','021','EC','A','','','AC','0002096993','0002096993','LA00002530090','IL','1','Decker','Monica','','','','34','434881656','1905 DORVILLE ST',0,'MAMOU','LA','70554','4810','CY','22039','1965-09-15','F','U',':RET:2106-3','T','021','DEN','3313427','18575LA002000101','2014-03-01','2014-02-12 15:40:19','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-12 21:30:24'),(13239,10564,'Y','18','021','EC','A','','','AC','0000001114','0000001114','TX00000421279','IL','1','rice','debra',NULL,NULL,NULL,NULL,NULL,'1712 E. Riverside',0,'Austin','TX','78741',NULL,'CY','48453','1952-12-08','F','R',':RET:2106-3','N','021','DEN','1839227','33348TX002000201','2014-01-01','2013-12-23 01:05:13','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:56:01'),(5346,4240,'Y','18','021','EC','A','','','AC','0001071760','0001071760','OH00000146466','IL','1','Thornton','Lisa','','','','34','268840778','614 W Tuscarawas Avenue',0,'Barberton','OH','44203',NULL,'CY','39153','1981-10-01','F','U',':RET:1002-5^:RET:2106-3','N','021','HLT','1794118','52664OH152000901','2014-01-01','2013-12-18 21:09:29','154.00',NULL,NULL,'193.23','39.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 23:07:30'),(5749,4564,'Y','18','021','EC','A','','','AC','0001439408','0001439408','LA00000025584','IL','1','ALEXANDER','GWENDOLYN','','','','34','433862569','6150 Eastover Drive',0,'New Orleans','LA','70128',NULL,'CY','22071','1952-09-24','F','U',':RET:2054-5','N','021','DEN','2118538','18575LA002000201','2014-01-01','2013-12-24 01:38:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:46:09'),(6389,5066,'Y','18','021','EC','A','','','AC','0000242691','0000242691','OH00000489499','IL','1','Robison','Barry','','','','34','285802520','4661 BARRINGTON CLUB DR',0,'COLUMBUS','OH','43220','3586','CY','39049','1974-02-12','M','U',':RET:2106-3','N','021','DEN','456886','99734OH005000301','2014-01-01','2013-12-11 11:39:32','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:48:08'),(18989,15127,'N','19','021','EC','A',NULL,NULL,'','0000551443','0001067012','','S1','1','Bernstein','Jeffrey','','','','34','287989416','2175 CAMPUS RD',0,'BEACHWOOD','OH','44122','1216','CY','39035','1995-08-28','F','',':RET:2106-3','N','021','HLT','2281072','52664OH151001304','2014-03-01','2014-01-17 11:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-01-20 08:06:10'),(18560,14801,'N','01','021','EC','A',NULL,NULL,'','0000880545','0000858513','','IL','1','Workman','Jamie','','','','34','277900868','330 COON HILL RD',0,'WINCHESTER','OH','45697','9746','CY','39001','1988-08-18','F','',':RET:2106-3','N','021','HLT','1584950','92036OH005000605','2014-02-01','2014-01-15 14:49:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','215.53',NULL,0,'2014-01-16 08:46:58'),(17272,13816,'Y','18','021','EC','A','','','AC','0000381160','0000381160','OH00002432191','IL','1','Kilpatrick','Todd','','','','34','272763864','149 PATRICK JOHN DR',0,'WADSWORTH','OH','44281','8789','CY','39103','1964-02-16','M','R',':RET:2106-3','N','021','HLT','1510165','52664OH152000901','2014-02-01','2014-01-09 21:32:52','0.00',NULL,NULL,'585.90','585.90','R-OH012','OH0','278.66',NULL,0,'2014-01-13 02:23:22'),(26625,21110,'Y','18','021','EC','A','','','AC','0000419370','0000419370','TX00002443425','IL','1','JUAREZ','VALERIE','MARIE','','','34','335105094','4850 HEATHER PASS',0,'SAN ANTONIO','TX','78218','2751','CY','48029','1986-09-02','F','U',':RET:2106-3','N','021','DEN','3788887','33348TX002000201','2014-04-01','2014-02-28 12:47:16','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-28 21:30:54'),(27123,21470,'Y','18','021','EC','A','','','AC','0000425143','0000425143','OH00003036513','IL','1','scott','douglas','','','','34','291824130','5111 WEDGEWAY DR',0,'LOVELAND','OH','45140','6569','CY','39025','1985-01-11','M','U',':RET:2106-3','N','021','DEN','3053968','99734OH005000301','2014-04-01','2014-03-03 15:18:27','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-03-03 21:30:35'),(28757,22761,'Y','18','021','EC','A','','','AC','0000405541','0000405541','TX00003296927','IL','1','Skeen','James','','','','34','465795437','1040 Candlelight Ln.',0,'Houston','TX','77018',NULL,'CY','48201','1985-07-22','M','U',':RET:2106-3','N','021','DEN','3725727','33348TX002000201','2014-04-01','2014-03-09 11:53:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-09 21:00:20'),(28759,22763,'Y','18','021','EC','A','','','AC','0000888889','0000888889','TX00003421545','IL','1','rayo','jennifer','a','','','34','454759067','1503B W 9TH ST',0,'CALDWELL','TX','77836','1406','CY','48051','1981-11-04','F','M',':RET:2106-3','N','021','DEN','3941256','33348TX002000201','2014-04-01','2014-03-09 13:27:09','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-03-09 21:00:21'),(21875,17464,'Y','18','021','EC','A','','','AC','0001781683','0001781683','LA00001502170','IL','1','Shettlesworth','Rebecca','','','','34','590161493','946 CAMP RD',0,'WEST MONROE','LA','71292','8111','CY','22073','1968-07-02','F','U',':RET:2106-3','T','021','DEN','2633676','18575LA002000201','2014-03-01','2014-02-05 22:34:40','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-06 21:01:27'),(586,481,'Y','18','021','EC','A','','','AC','0000535725','0000535725','OH00000355610','IL','1','Barnett','Linda','','','','34','281527930','1740 W MARKET ST',0,'TIFFIN','OH','44883','4905','CY','39147','1952-02-27','F','U',':RET:2106-3','N','021','HLT','216147','92036OH003002704','2014-01-01','2013-12-04 11:35:55','444.00',NULL,NULL,'572.23','128.23','R-OH006','OH0','572.23',NULL,0,'2013-12-25 17:51:04'),(13456,10730,'Y','18','021','EC','A','','','AC','0000908029','0000908029','OH00001192289','IL','1','Feerer','Luke','','','','34','299709539','167 WOOLERY LN',0,'DAYTON','OH','45415','1732','CY','39113','1972-10-25','M','U',':RET:2106-3','N','021','DEN','2286882','99734OH005000301','2014-01-01','2013-12-23 14:53:46','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:01:38'),(18549,14793,'Y','18','021','EC','A','','','AC','0000075947','0000075947','MS00002157251','IL','1','GILBERT','WILLIAM','MARTIN','','','34','237792681','503 E TRACY ST',0,'GULFPORT','MS','39503','3794','CY','28047','1965-09-15','M','M',':RET:2106-3','N','021','DEN','1705610','46300MS002000101','2014-02-01','2014-01-15 13:12:06','0.00',NULL,NULL,'54.30','54.30','R-MS005','MS0','27.15',NULL,0,'2014-01-16 08:46:53'),(24463,19435,'Y','18','021','EC','A','','','AC','0000390937','0000390937','OH00002739149','IL','1','Mitchin','Robert','','','','34','288506781','5447 Pepperidge rd',0,'New Franklin','OH','44216',NULL,'CY','39153','1952-01-12','M','M',':RET:2106-3','N','021','HLT','3565549','52664OH151001501','2014-04-01','2014-02-18 12:11:05','631.00',NULL,NULL,'1290.52','659.52','R-OH012','OH0','768.43',NULL,0,'2014-02-18 22:01:34'),(4592,3636,'N','01','021','EC','A',NULL,NULL,'','0000532080','0000444887','','IL','1','Watkins','Betty','','','','34','284521369','3123 BUTTERCUP AVE',0,'AKRON','OH','44319','3103','CY','39153','1951-01-12','F','',':RET:2106-3','N','021','HLT','439008','52664OH151001304','2014-01-01','2013-12-12 11:33:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-25 22:05:29'),(16255,13014,'Y','18','021','EC','A','','','AC','0000205160','0000205160','MS00002126567','31','1','PERRY','TINA','','','','34','425499344','P.O BOX 1154',0,'LUCEDALE','MS','39452',NULL,'CY','28039','1974-04-14','F','M',NULL,'N','021','DEN','2447712','46300MS002000201','2014-02-01','2014-01-04 10:18:33','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2014-01-05 00:02:44'),(13236,10561,'Y','18','021','EC','A','','','AC','0001002916','0001002916','TX00000887201','IL','1','Duncan','Christopher','','','','34','092681822','2704 BARTONS BLUFF LN',0,'AUSTIN','TX','78746','7944','CY','48453','1984-03-07','M','U',':RET:2034-7^:RET:2106-3','N','021','DEN','1944302','33348TX002000201','2014-01-01','2013-12-22 23:00:27','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:55:55'),(15150,12109,'Y','18','021','EC','A','','','AC','0000558154','0000558154','OH00000375394','IL','1','wright','glendon','','','','34','276847485','20868 county road g40',0,'stryker','OH','43557',NULL,'CY','39171','1979-03-28','M','M',':RET:2106-3','N','021','DEN','1458124','99734OH005000401','2014-02-01','2013-12-30 12:33:02','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-01 12:06:02'),(8939,7088,'Y','18','021','EC','A','','','AC','0000521935','0000521935','OH00001045796','IL','1','FUSS','MERLE','','','','34','272602286','3714 W 169TH ST',0,'CLEVELAND','OH','44111','5726','CY','39035','1966-09-21','F','U',NULL,'N','021','DEN','1720567','99734OH005000401','2014-01-01','2013-12-18 10:47:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:16'),(9636,7634,'Y','18','021','EC','A','','','AC','0000330330','0000330330','TX00000367164','IL','1','SMITH','CAROYLN','JEAN','','','34','567847362','3918 INGLEWOOD CIR',0,'MISSOURI CITY','TX','77459','6879','CY','48157','1952-04-19','F','U',':RET:2054-5','N','021','DEN','2164089','33348TX002000101','2014-01-01','2013-12-21 09:06:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 04:38:21'),(2801,2264,'Y','18','021','EC','A','','','AC','0000236231','0000236231','OH00001206065','IL','1','King','Michael','William','','','34','273908818','331 E RUTH ST',0,'SIDNEY','OH','45365','1620','CY','39149','1985-04-17','M','M',':RET:2106-3','N','021','HLT','1159473','92036OH006000501','2014-01-01','2013-12-02 16:49:15','239.00',NULL,NULL,'402.48','163.48','R-OH003','OH0','204.92',NULL,0,'2013-12-25 19:50:25'),(22210,17727,'Y','18','024','14','A','','','TE','0000114162','0000114162','','IL','1','Kearns','Sherry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-07-09','F','',NULL,NULL,NULL,'','676931','','2014-02-24','2014-02-09 16:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-09 19:00:20'),(19355,15428,'Y','18','021','EC','A','','','AC','0000426465','0000426465','OH00002118066','IL','1','IANNI','DAVID','','','','34','286527676','32556 LISA LN',0,'SOLON','OH','44139','5581','CY','39035','1952-08-02','M','M',':RET:2106-3','N','021','DEN','2667751','99734OH005000301','2014-03-01','2014-01-21 15:07:02','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,1,'2014-01-22 03:22:28'),(18986,15126,'Y','18','021','EC','A','','','AC','0000866923','0000866923','OH00002518255','IL','1','Bertison','Xander','','','','34','272925028','9001 Portage Pointe Drive',0,'Streetsboro','OH','44241',NULL,'CY','39133','1989-06-18','M','U',NULL,'N','021','HLT','3005671','52664OH151001305','2014-03-01','2014-01-16 19:45:17','109.00',NULL,NULL,'223.01','114.01','R-OH012','OH0','223.01',NULL,0,'2014-01-20 08:06:09'),(17377,13904,'Y','18','021','EC','A','','','AC','0000616885','0000616885','OH00002255184','IL','1','THIERET','SHARON','M','','','34','286682769','7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','1964-06-26','F','M',':RET:2106-3','N','021','DEN','1926859','99734OH005000401','2014-02-01','2014-01-09 20:13:38','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-01-13 03:00:04'),(26145,20730,'N','01','021','EC','A',NULL,NULL,'','0000666818','0000586743','','IL','1','Mount','Diana','','','','34','284547764','601 S DOUGLAS AVE',0,'SPRINGFIELD','OH','45505','2436','CY','39023','1953-05-29','F','',NULL,'N','021','DEN','3825940','99734OH005000401','2014-04-01','2014-02-27 13:38:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:27'),(28267,22368,'Y','18','021','EC','A','','','AC','0001226599','0001226599','TX00003180496','31','1','Thongsavanh','Thothsakanh','','','','34','586120581','929 Zarsky Drive',0,'Corpus Christi','TX','78412',NULL,'CY','48355','1974-03-02','M','U',':RET:2028-9','N','021','DEN','4167616','33348TX002000201','2014-04-01','2014-03-07 00:24:07','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61','CIC',0,'2014-03-07 21:00:19'),(25760,20432,'Y','18','021','EC','A','','','AC','0000431422','0000431422','OH00002051965','IL','1','Kotomski','Teresa','','','','34','281641725','161 FIFIELD AVE',0,'CONNEAUT','OH','44030','2127','CY','39007','1960-06-10','F','U',':RET:2106-3','N','021','HLT','2857952','52664OH151001306','2014-04-01','2014-02-24 12:10:27','468.00',NULL,NULL,'513.10','45.10','R-OH011','OH0','513.10',NULL,0,'2014-02-26 09:30:51'),(1150,948,'Y','18','021','EC','A','','','AC','0000600839','0000600839','LA00001223957','IL','1','Palomin','Maria','A','','','34','464239373','10856 Abington Avenue',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1961-07-30','F','U',NULL,'N','021','DEN','288426','18575LA002000201','2014-01-01','2013-12-03 15:59:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:36'),(24603,19530,'Y','18','024','14','A','','','TE','0001217400','0001217400','','IL','1','Day','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-09-01','F','',NULL,NULL,NULL,'','2926212','','2014-02-19','2014-02-19 16:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 04:13:06'),(2651,2154,'Y','18','021','EC','A','','','AC','0000913430','0000913430','TX00001251489','IL','1','Place','Mary','','','','34','502769156','3412 BRETT JACKSON DR',0,'CROWLEY','TX','76036','5628','CY','48251','1963-07-18','F','U',':RET:2106-3','N','021','DEN','866790','33348TX002000101','2014-01-01','2013-12-02 15:38:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:46:36'),(20927,16724,'N','19','021','EC','A',NULL,NULL,'','0000125594','0001260045','','IL','1','SCOTT','HEATHER','','','','34','299065800','1516 CHESTNUT BLVD',0,'CUYAHOGA FALLS','OH','44223','2347','CY','39153','2002-05-31','F','',':RET:2106-3','N','021','HLT','2093280','52664OH151001501','2014-03-01','2014-01-31 13:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-01-31 21:01:35'),(19535,15569,'Y','18','021','EC','A','','','AC','0000843367','0000843367','OH00001972488','IL','1','Iberahim','alaa','','','','34','278982915','275 SKYVIEW DR',0,'AKRON','OH','44319','4542','CY','39153','1968-09-12','M','U',NULL,'N','021','DEN','2908553','99734OH005000401','2014-03-01','2014-01-22 15:13:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-23 03:02:22'),(5803,4609,'N','01','021','EC','A',NULL,NULL,'','0000660325','0000663037','','IL','1','Toups','Pamela','Davis','','','34','462635281','8304 Hwy 94',0,'Lufkin','TX','75904','7304','CY','48005','1968-01-09','F','',':RET:2106-3','N','021','DEN','1505964','33348TX002000201','2014-01-01','2013-12-23 21:06:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:47:33'),(15877,12714,'Y','18','021','EC','A','','','AC','0001755268','0001755268','LA00002111033','IL','1','West','Una','','','','34','435236888','429 PARLANGE DR',0,'PEARL RIVER','LA','70452','3911','CY','22103','1960-01-28','F','M',':RET:2054-5','N','021','DEN','2558391','18575LA002000101','2014-02-01','2014-01-02 12:15:33','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-01-03 02:05:18'),(26042,20653,'N','19','021','EC','A',NULL,NULL,'','0000194050','0001224518','','IL','1','TAYLOR','OLIVIA','','','','34','277155468','417 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','2009-03-22','F','',NULL,'N','021','HLT','2864760','52664OH151001304','2014-03-01','2014-02-26 14:38:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-26 21:02:28'),(26977,21371,'Y','18','021','EC','A','','','AC','0001174452','0001174452','OH00002969037','IL','1','Bales','Daniel','','','','34','286565563','1732 PATRICIA DR',0,'LIMA','OH','45801',NULL,'CY','39003','1955-04-15','M','U',':RET:2106-3','T','021','HLT','3544393','92036OH005001505','2014-04-01','2014-03-02 11:04:01','519.00',NULL,NULL,'644.88','125.88','R-OH002','OH0','644.88',NULL,0,'2014-03-03 01:00:37'),(27076,21437,'N','19','021','EC','A',NULL,NULL,'','0000671758','0000432819','','IL','1','douglas','india','','','','34','278982273','1230 BYE ST',0,'AKRON','OH','44320','1902','CY','39153','1995-05-29','F','',':RET:2054-5','N','021','HLT','3721635','52664OH152000901','2014-04-01','2014-03-02 19:29:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-03 21:30:08'),(27407,21694,'N','19','021','EC','A',NULL,NULL,'','0000195195','0000725111','','IL','1','Watkins','Kelsie','Aliyah','','','34','270988715','20700 Wilmore Avenue',0,'Euclid','OH','44123',NULL,'CY','39035','1994-08-06','F','',':RET:2054-5','N','021','DEN','3485352','99734OH005000301','2014-04-01','2014-03-04 10:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:33'),(28094,22236,'Y','18','021','EC','A','','','AC','0000206507','0000206507','MS00003538870','31','1','Smith','Marcus','Aurelius','','','34','426131029','Post Office Box 62',0,'Bolton','MS','39041',NULL,'CY','28049','1976-07-31','M','U',':RET:2054-5','N','021','DEN','4160794','46300MS002000101','2014-04-01','2014-03-06 12:49:43','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-06 21:02:06'),(564,463,'Y','18','021','EC','A','','','AC','0000295454','0000295454','OH00001165622','IL','1','Huynh','An','','','','34','284947095','59 Dunderry ln.',0,'Toledo','OH','43615',NULL,'CY','39095','1989-02-21','M','U',':RET:2047-9^:RET:2106-3','N','021','HLT','697090','92036OH006002601','2014-01-01','2013-12-03 19:28:22','0.00',NULL,NULL,'154.64','154.64','R-OH001','OH0','154.64',NULL,0,'2013-12-25 17:50:25'),(13854,11055,'Y','18','021','EC','A','','','AC','0001212341','0001212341','OH00000191242','IL','1','Barrett','Michael','Ian','','','34','282623118','2407 QUEEN AVE',0,'MIDDLETOWN','OH','45044','4737','CY','39017','1971-10-20','M','M',':RET:2106-3','N','021','HLT','2064259','92036OH006001201','2014-01-01','2013-12-22 20:21:00','409.00',NULL,NULL,'451.16','42.16','R-OH004','OH0','225.58',NULL,0,'2013-12-26 13:12:38'),(25005,19830,'N','01','021','EC','A',NULL,NULL,'','0001173265','0000265295','','IL','1','JONES','VICKI','','','','34','286463238','5321 FAIRHILL DR',0,'RAVENNA','OH','44266','9029','CY','39133','1957-09-23','F','',NULL,'N','021','HLT','3782719','52664OH151001301','2014-04-01','2014-02-20 14:12:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2014-02-20 22:00:48'),(21089,16852,'Y','18','024','14','A','','','TE','0001203258','0001203258','','IL','1','BRISSETT','GWAYNE','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-03-04','M','',NULL,NULL,NULL,'','2717926','','2014-02-01','2014-02-01 21:25:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-02 19:00:26'),(1098,902,'Y','18','021','EC','A','','','AC','0000103861','0000103861','OH00000677008','IL','1','johnson','Arnold','G','','','34','277480498','3708 KIDRON CT',0,'COLUMBUS','OH','43232','4229','CY','39049','1952-10-19','M','U',':RET:2054-5','N','021','DEN','254588','99734OH005000401','2014-01-01','2013-12-03 11:30:59','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:17:12'),(3129,2514,'Y','18','024','14','A','','','TE','0000153327','0000153327','','IL','1','Lambert','Kristopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-07-04','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-13 15:07:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:30:27'),(6102,4838,'Y','18','021','EC','A','','','AC','0000926232','0000926232','OH00000179125','IL','1','BREEST','DAVID','D','','','34','270465688','636 MORRIS DR',0,'VERMILION','OH','44089','2370','CY','39093','1951-06-18','M','M',':RET:2106-3','N','021','DEN','789801','99734OH005000401','2014-01-01','2013-11-21 08:37:22','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:15:15'),(2361,1925,'Y','18','021','EC','A','','','AC','0000988861','0000988861','OH00001054961','IL','1','Ake','Dennis','','','','34','282429427','3829 COTTAGE GROVE RD',0,'AKRON','OH','44319','3713','CY','39153','1950-08-01','M','U',NULL,'N','021','DEN','1233','99734OH005000401','2014-01-01','2013-12-09 07:16:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:32:29'),(25798,20458,'N','01','021','EC','A',NULL,NULL,'','0001244219','0000115549','','IL','1','wolfe','benjamin','m','','','34','295846793','15462 STATE RD',0,'NORTH ROYALTON','OH','44133','5359','CY','39035','1973-03-29','M','',':RET:2106-3','N','021','DEN','3343507','99734OH005000301','2014-04-01','2014-02-26 10:48:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:15'),(26035,20648,'Y','18','021','EC','A','','','AC','0000239081','0000239081','OH00002578025','IL','1','Farag','Denise','','','','34','313867692','2196 Bridle Court',0,'Maineville','OH','45039',NULL,'CY','39165','1966-12-28','F','R',':RET:2106-3','N','021','HLT','3465669','92036OH001001201','2014-04-01','2014-02-26 10:58:11','0.00',NULL,NULL,'404.73','404.73','R-OH004','OH0','404.73',NULL,0,'2014-02-26 21:02:23'),(26794,21236,'Y','18','021','EC','A','','','AC','0000271487','0000271487','OH00002707641','IL','1','WARD','JEFFREY','','','','34','372780981','1212 N. HOLLAND SYLVANIA AVE. APT. 202',0,'TOLEDO','OH','43615',NULL,'CY','39095','1969-02-03','M','U',':RET:2106-3','N','021','HLT','3575634','92036OH003002605','2014-04-01','2014-03-01 16:46:10','200.00',NULL,NULL,'294.05','94.05','R-OH001','OH0','294.05',NULL,0,'2014-03-01 21:00:20'),(23544,18757,'Y','18','021','EC','A','','','AC','0001815614','0001815614','LA00002165621','IL','1','HERNANDEZ','MARTHA','ELIZABETH','','','34','665033951','45 CHATEAU LATOUR DR',0,'KENNER','LA','70065','2020','CY','22051','1943-07-30','F','U',':RET:2106-3','N','021','DEN','3681118','18575LA002000201','2014-03-01','2014-02-13 13:46:46','0.00',NULL,NULL,'16.22','16.22','R-LA001','LA0','16.22',NULL,0,'2014-02-13 22:02:34'),(13195,10528,'Y','18','021','EC','A','','','AC','0000453040','0000453040','TX00000210426','IL','1','Duff','Patricia','','','','34','353469632','12 LAKERIDGE DR',0,'SPRING','TX','77381','4016','CY','48339','1952-04-08','F','U',NULL,'N','021','DEN','2344101','33348TX002000101','2014-01-01','2013-12-23 12:47:14','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:46'),(9774,7741,'Y','18','021','EC','A','','','AC','0000228701','0000228701','LA00000249334','IL','1','Dale','Deborah','','','','34','315869309','3308 Blanchard Dr.',0,'Chalmette','LA','70043',NULL,'CY','22087','1966-01-15','F','U',NULL,'N','021','DEN','326675','18575LA002000201','2014-01-01','2013-10-20 18:38:57','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 05:00:33'),(9718,7697,'Y','18','021','EC','A','','','AC','0000759673','0000759673','OH00000685471','IL','1','McCallum','Steven','d','','','34','294480383','6681 N CHESTNUT ST',0,'RAVENNA','OH','44266','3905','CY','39133','1951-07-08','M','M',':RET:2106-3','N','021','DEN','333038','99734OH005000401','2014-01-01','2013-11-15 12:37:50','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:45:22'),(19994,15949,'N','01','021','EC','A',NULL,NULL,'','0000035782','0000878291','','IL','1','kemper','tara','','','','34','270809710','8109 w mill st',0,'cleves','OH','45002',NULL,'CY','39061','1980-06-24','F','',':RET:2106-3','T','021','HLT','3171094','92036OH004001201','2014-03-01','2014-01-25 12:59:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','237.80',NULL,0,'2014-01-25 19:00:21'),(16912,13533,'Y','18','021','EC','A','','','AC','0000483497','0000483497','OH00002084343','IL','1','LOCHER','CYNTHIA','','','','34','279569248','7071 Victoria DR',0,'Mentor','OH','44060',NULL,'CY','39085','1955-07-26','F','U',':RET:2106-3','N','021','DEN','2300060','99734OH005000401','2014-02-01','2014-01-09 11:48:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:19:39'),(8904,7061,'Y','18','021','EC','A','','','AC','0000396145','0000396145','OH00000868279','IL','1','Phillips','Brenda','','','','34','268620475','426 S HIGH ST',0,'HEBRON','OH','43025','9410','CY','39089','1954-08-26','F','M',':RET:2106-3','N','021','DEN','1982308','99734OH005000401','2014-01-01','2013-12-17 19:59:22','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:21'),(7583,5998,'Y','18','021','EC','A','','','AC','0000429019','0000429019','OH00000964767','S1','1','Minor','Randall',NULL,NULL,NULL,NULL,NULL,'110 RIDGE SIDE CT',0,'MUNROE FALLS','OH','44262','1086','CY','39153','1997-09-15','M','U',':RET:2106-3','N','021','DEN','945540','99734OH005000101','2014-01-01','2013-12-15 15:20:56','0.00',NULL,NULL,'27.59','27.59','R-OH012','OH0','27.59',NULL,0,'2013-12-26 02:33:59'),(4640,3677,'Y','18','021','EC','A','','','AC','0000167448','0000167448','MS00001079558','IL','1','STRICKLAND','JANE','BLANKS','','','34','587704583','11182 HIGHWAY 494',0,'MERIDIAN','MS','39305','9779','CY','28075','1951-12-20','F','M',':RET:2106-3','N','021','DEN','155640','46300MS002000201','2014-01-01','2013-12-12 11:10:05','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 22:06:45'),(26656,21131,'Y','18','021','EC','A','','','AC','0000159468','0000159468','OH00003072045','IL','1','Brannon','Michelle','','','','34','281464292','2208 10TH ST',0,'CUYAHOGA FALLS','OH','44221','3133','CY','39153','1961-02-13','F','U',':RET:2106-3','N','021','HLT','3761152','52664OH151001301','2014-04-01','2014-02-28 14:18:23','204.00',NULL,NULL,'454.94','250.94','R-OH012','OH0','454.94',NULL,0,'2014-02-28 21:31:09'),(339,278,'Y','18','021','EC','A','','','AC','0001076537','0001076537','OH00000306593','IL','1','walker','elizabeth','','','','34','298600156','7982 festive ct',0,'cincinnati','OH','45236',NULL,'CY','39061','1968-07-05','F','M',':RET:2106-3','N','021','DEN','988495','99734OH005000401','2014-01-01','2013-11-08 20:09:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:31:55'),(24671,19581,'N','19','021','EC','A',NULL,NULL,'','0000149395','0000362548','','IL','1','Van Dyke','Fallon','','','','34','269986042','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1994-09-22','F','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-02-20 04:27:10'),(18373,14664,'N','01','021','EC','A',NULL,NULL,'','0000197173','0000384420','','IL','1','Sturgill','Corby',NULL,NULL,NULL,NULL,NULL,'13810 3RD ST',0,'CROOKSVILLE','OH','43731','9603','CY','39115','1986-12-17','M','',NULL,'N','021','DEN','1854339','99734OH005000301','2014-02-01','2014-01-15 12:45:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:31'),(1080,886,'Y','18','024','14','A','','','TE','0001174374','0001174374','','IL','1','LONGBOTTOM','BARBARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-31','F','',NULL,NULL,NULL,'','235632','','2013-12-03','2013-12-03 09:30:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:16:45'),(5067,4016,'Y','18','021','EC','A','','','AC','0001264331','0001264331','TX00000410311','IL','1','Burns','Robert','','','','34','452989010','3906 BOTANY LN',0,'HOUSTON','TX','77047','1634','CY','48201','1958-06-14','M','U',':RET:2054-5','N','021','DEN','2549407','33348TX002000201','2014-01-01','2013-12-19 11:10:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:00:37'),(14571,11626,'Y','18','021','EC','A','','','AC','0000805124','0000805124','OH00000366052','IL','1','Kirby','Lauren','','','','34','274904779','3515 SEAMAN RD',0,'OREGON','OH','43616','2417','CY','39095','1988-09-14','F','U',':RET:2106-3','T','021','HLT','1485287','92036OH005002601','2014-02-01','2013-12-27 09:04:48','0.00',NULL,NULL,'225.15','225.15','R-OH001','OH0','225.15',NULL,0,'2013-12-28 03:35:32'),(14547,11606,'Y','18','021','EC','A','','','AC','0000124464','0000124464','MS00001875940','IL','1','Dymond','Frederick','','','','34','433929432','132 Via Don Ray',0,'Long Beach','MS','39560',NULL,'CY','28047','1954-05-31','M','U',':RET:2106-3','N','021','DEN','1482820','46300MS002000201','2014-02-01','2013-12-27 15:03:10','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-28 03:34:55'),(5341,4236,'Y','18','021','EC','A','','','AC','0000524479','0000524479','OH00000306266','IL','1','Landry','Douglas','I','','','34','278547203','3188 SURREY HILL LN',0,'STOW','OH','44224','4757','CY','39153','1953-07-11','M','M',':RET:2106-3','N','021','DEN','1766512','99734OH005000301','2014-01-01','2013-12-19 15:26:58','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:07:21'),(5112,4051,'Y','18','021','EC','A','','','AC','0000864013','0000864013','TX00001225678','IL','1','Atherton','Elsa','','','','34','457082057','401 ISLAND AVE',0,'PORT ISABEL','TX','78578','2538','CY','48061','1951-09-01','F','M',':RET:2106-3','N','021','DEN','1521506','33348TX002000201','2014-01-01','2013-12-19 18:13:24','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 23:01:43'),(26128,20721,'Y','18','021','EC','A','','','AC','0000489301','0000489301','OH00003287772','IL','1','LING','CHERYL','','','','34','269643643','3756 Towhship Rd 90',0,'Killbuck','OH','44637',NULL,'CY','39075','1957-04-27','F','M',':RET:2106-3','T','021','DEN','2980700','99734OH005000401','2014-03-01','2014-02-27 11:44:00','0.00',NULL,NULL,'15.78','15.78','R-OH014','OH0','0.00',NULL,0,'2014-02-28 06:30:22'),(28038,22187,'N','19','021','EC','A',NULL,NULL,'','0000926336','0000638578','','IL','1','KLUN','VINCENT','','','','34','293966594','860 E 239TH ST',0,'EUCLID','OH','44123',NULL,'CY','39035','1993-10-19','M','',NULL,'N','021','DEN','3540924','99734OH005000401','2014-04-01','2014-03-06 17:35:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:30'),(28609,22643,'Y','18','021','EC','A','','','AC','0001248394','0001248394','OH00002707940','IL','1','EVANS-HENRY','BECKY','','','','34','278524973','1297 W COMET RD',0,'CLINTON','OH','44216','9666','CY','39153','1951-08-30','F','M',NULL,'N','021','DEN','4024884','99734OH005000401','2014-04-01','2014-03-08 15:31:30','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-03-08 21:30:14'),(28923,22890,'N','19','021','EC','A',NULL,NULL,'','0000739088','0001187703','','S3','1','BERNARD','JEFFERY','','','','34','405638654','970 SANDY LN',0,'MEDINA','OH','44256','2026','CY','39103','2005-03-24','M','',NULL,'N','021','DEN','3492816','99734OH005000301','2014-04-01','2014-03-10 10:42:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:32'),(783,645,'N','01','021','EC','A',NULL,NULL,'','0001172467','0001017541','','IL','1','Wood','Kelly','','','','34','467872959','29106 LEGENDS VALLEY LN',0,'SPRING','TX','77386','4132','CY','48339','1971-11-29','F','',NULL,'N','021','DEN','2394984','33348TX002000201','2014-01-01','2013-12-16 15:02:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:05:06'),(22567,18022,'Y','18','021','EC','A','','','AC','0000514490','0000514490','OH00002223987','IL','1','Dudeck','Quentin','','','','34','323802788','210 Galway Lane',0,'Bowling Green','OH','43402',NULL,'CY','39173','1977-02-02','M','U',':RET:2106-3','N','021','DEN','3767535','99734OH005000401','2014-03-01','2014-02-10 14:07:20','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-10 21:31:54'),(18733,14927,'N','01','021','EC','A',NULL,NULL,'','0000253078','0000300434','','IL','1','Winters','Camden','','','','34','299863588','6282 E US HIGHWAY 36',0,'CABLE','OH','43009','9625','CY','39021','1982-12-13','M','',':RET:2106-3','N','021','DEN','2107235','99734OH005000301','2014-03-01','2014-01-16 00:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:37'),(6401,5073,'Y','18','021','EC','A','','','AC','0000614068','0000614068','OH00000075133','IL','1','Whitaker','Janet','Ann','','','34','292427145','3383 HAMMERSMITH LN',0,'CINCINNATI','OH','45248','2874','CY','39061','1951-04-12','F','M',':RET:2106-3','N','021','DEN','275489','99734OH005000301','2014-01-01','2013-12-11 14:36:07','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:48:20'),(2889,2334,'Y','18','021','EC','A','','','AC','0000631482','0000631482','OH00000048967','IL','1','carter','stephen','','','','34','270567095','1 park center drive',0,'wadsworth','OH','44281',NULL,'CY','39103','1956-06-06','M','M',':RET:2106-3','N','021','HLT','55854','52664OH151001501','2014-01-01','2013-12-06 11:47:03','491.00',NULL,NULL,'1173.90','682.90','R-OH012','OH0','651.81',NULL,0,'2013-12-25 20:15:07'),(26317,20879,'Y','18','024','14','A','','','TE','0000132079','0000132079','','IL','1','HUTCHINSON','JOANN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-06','F','',NULL,NULL,NULL,'','1736599','','2014-03-14','2014-02-27 09:54:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 06:31:35'),(27287,21607,'Y','18','021','EC','A','','','AC','0000512963','0000512963','TX00003402239','IL','1','McIntosh','Grace','','','','34','632148879','1401 redford st',0,'houston','TX','77034',NULL,'CY','48201','1989-09-18','F','U',':RET:2054-5','N','021','DEN','2851903','33348TX002000201','2014-04-01','2014-03-04 08:53:28','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:26'),(376,312,'Y','18','021','EC','A','','','AC','0001206885','0001206885','TX00001133145','IL','1','Foster','Debra','Lynn','','','34','461154539','22665 HWY154',0,'New Diana','TX','75640',NULL,'CY','48203','1963-01-06','F','M',':RET:2106-3','N','021','DEN','480084','33348TX002000201','2014-01-01','2013-12-03 21:06:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:45:34'),(1238,1019,'N','19','021','EC','A',NULL,NULL,'','0000805935','0000633208','','IL','1','Lewis','Chamarcus','Dwayne','','','34','439836521','32455 Leona Ave',0,'White Castle','LA','70788',NULL,'CY','22047','1992-05-02','M','',':RET:2054-5','N','021','DEN','532233','18575LA002000101','2014-01-01','2013-12-03 16:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 18:20:53'),(1920,1566,'Y','18','021','EC','A','','','AC','0000859662','0000859662','OH00000234997','IL','1','Woodward','Julie','','','','34','269769512','1811 BROOKWOOD DR',0,'AKRON','OH','44313','5061','CY','39153','1965-07-12','F','U',':RET:2106-3','N','021','DEN','216018','99734OH005000301','2014-01-01','2013-11-20 09:38:10','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:00:09'),(20054,15994,'Y','18','024','14','A','','','TE','0000786069','0000786069','','IL','1','CASTILLO','RICKY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-09-14','M','',NULL,NULL,NULL,'','2578709','','2014-01-27','2014-01-27 09:59:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:07'),(6620,5250,'Y','18','021','EC','A','','','AC','0000300388','0000300388','OH00001077103','IL','1','Johnson','Samantha','','','','34','284864349','345 PORTAGE TRL',0,'CUYAHOGA FALLS','OH','44221','3225','CY','39153','1986-04-01','F','U',':RET:2106-3','N','021','HLT','20373','52664OH152001001','2014-01-01','2013-12-11 12:20:48','0.00',NULL,NULL,'128.49','128.49','R-OH012','OH0','128.49',NULL,0,'2013-12-26 00:54:01'),(19108,15224,'Y','18','021','EC','A','','','AC','0000110544','0000110544','OH00001996425','IL','1','McAulay','Donald','Frederick','','','34','011761728','122 W MAIN ST',0,'LAFAYETTE','OH','45806','2323','CY','39003','1991-12-13','M','U',':RET:2106-3','N','021','HLT','3153420','92036OH003001506','2014-03-01','2014-01-18 11:36:33','183.00',NULL,NULL,'229.83','46.83','R-OH002','OH0','229.83',NULL,0,'2014-01-21 08:44:43'),(4959,3936,'Y','18','021','EC','A','','','AC','0000913403','0000913403','LA00000491583','31','1','Melia','Daniel','','','','34','565814728','319 ELIZA ST',0,'NEW ORLEANS','LA','70114','2333','CY','22071','1984-08-12','M','U',':RET:2106-3','N','021','DEN','758429','18575LA002000201','2014-01-01','2013-12-07 00:39:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:07'),(5826,4626,'N','01','021','EC','A',NULL,NULL,'','0000709415','0000530597','','IL','1','Balahutrak','Lydia','','','','34','269489430','2528 DRYDEN RD',0,'HOUSTON','TX','77030','1004','CY','48201','1951-05-06','F','',':RET:2106-3','N','021','DEN','1456753','33348TX002000201','2014-01-01','2013-12-23 22:55:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:48:08'),(5319,4217,'N','01','021','EC','A',NULL,NULL,'','0000762277','0001163824','','IL','1','Robinson','Donald','F','','','34','559457994','24160 BUCKHURST DR',0,'BEACHWOOD','OH','44122','1676','CY','39035','1962-10-22','M','',':RET:2106-3','T','021','DEN','2325172','99734OH005000301','2014-01-01','2013-12-18 20:18:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:06:45'),(24350,19339,'Y','18','021','EC','A','','','AC','0000511714','0000511714','TX00002575351','31','1','Johnson','Chantelle','','','','34','546636369','519 E. Interstate 30',0,'Rockwall','TX','75087',NULL,'CY','48397','1980-03-15','F','U',':RET:2054-5','T','021','DEN','3108907','33348TX002000201','2014-04-01','2014-02-18 17:28:14','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-18 22:00:26'),(24811,19676,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000105425','','IL','1','Burdick','Isabella','','','','34','294086988','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','2004-01-08','F','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:49:57'),(3179,2556,'N','01','021','EC','A',NULL,NULL,'','0001210883','0000300366','','IL','1','Deadwyler','Emanuel','Jerome','','','34','271722367','4982 East 88th Street',0,'Cleveland','OH','44125',NULL,'CY','39035','1970-10-09','M','',':RET:2054-5','N','021','HLT','292194','92036OH004000801','2014-01-01','2013-11-17 19:46:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.10',NULL,0,'2013-12-25 20:31:48'),(8156,6452,'N','01','021','EC','A',NULL,NULL,'','0000951760','0001225681','','IL','1','HOFFMAN','THOMAS','RAY','','','34','293521392','2438 N HAVEN BLVD',0,'CUYAHOGA FALLS','OH','44223',NULL,'CY','39153','1951-08-29','M','',':RET:2106-3','N','021','HLT','91745','52664OH151001305','2014-01-01','2013-11-22 10:34:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-26 03:16:11'),(8063,6384,'N','01','021','EC','A',NULL,NULL,'','0001149867','0000165067','','IL','1','Wallace','Jacqueline','','','','34','276689384','266 Mt Royal Drive',0,'toledo','OH','43608',NULL,'CY','39095','1964-11-25','F','',':RET:2054-5','N','021','HLT','2016150','92036OH003002605','2014-01-01','2013-12-20 14:41:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','347.41',NULL,0,'2013-12-26 03:10:00'),(4112,3286,'Y','18','021','EC','A','','','AC','0001054198','0001054198','OH00000271417','IL','1','Moss','Nicholas','','','','34','278846634','275 W 9TH ST',0,'MARYSVILLE','OH','43040','1502','CY','39159','1984-11-21','M','M',':RET:2106-3','N','021','DEN','1533830','99734OH005000301','2014-01-01','2013-12-16 20:23:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:01'),(4771,3785,'Y','18','021','EC','A','','','AC','0000026599','0000026599','OH00000668405','IL','1','Mullins','Brenda','','','','34','289505362','6925 MILL POND DR',0,'HAMILTON','OH','45011','2519','CY','39017','1950-09-28','F','M',NULL,'N','021','DEN','991511','99734OH005000401','2014-01-01','2013-12-08 13:33:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:15:49'),(24004,19088,'Y','18','021','EC','A','','','AC','0000194103','0000194103','OH00002025738','IL','1','SANFILLIPO','ROBIN','','','','34','287586641','5461 SIMS RD',0,'GROVEPORT','OH','43125','9755','CY','39049','1956-03-12','F','U',NULL,'N','021','DEN','3503238','99734OH005000401','2014-03-01','2014-02-15 10:37:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:35'),(15987,12796,'Y','18','021','EC','A','','','AC','0000720281','0000720281','TX00001498901','31','1','Rodriguez','Arnesto','','','','34','456968743','PO Box 291841',0,'Kerville','TX','78029',NULL,'CY','48265','1953-10-31','M','U',NULL,'T','021','DEN','2077427','33348TX002000201','2014-02-01','2014-01-03 11:38:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:08'),(16187,12959,'Y','18','021','EC','A','','','AC','0000945526','0000945526','TX00001510115','IL','1','Soza','Joe','','','','34','461612549','711 E. B Street',0,'Monahans','TX','79756',NULL,'CY','48475','1982-12-16','M','M',':RET:2106-3','N','021','DEN','1942440','33348TX002000201','2014-02-01','2014-01-03 21:39:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-05 00:00:43'),(162,136,'Y','18','021','EC','A','','','AC','0000705791','0000705791','TX00000679231','IL','1','Torres','Ernestina','','','','34','457083898','1917 69TH ST',0,'LUBBOCK','TX','79412','4025','CY','48303','1954-11-26','F','U',NULL,'N','021','DEN','527228','33348TX002000101','2014-01-01','2013-12-05 15:02:30','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 17:19:13'),(13214,10545,'Y','18','021','EC','A','','','AC','0000006115','0000006115','TX00001106089','IL','1','HERNANDEZ','OLGA','','','','34','585235937','9100 Bradley Drive',0,'North Richland Hills','TX','76182',NULL,'CY','48439','1963-07-12','F','M',NULL,'N','021','DEN','1547568','33348TX002000201','2014-01-01','2013-12-22 19:47:45','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:55:21'),(13060,10410,'N','19','021','EC','A',NULL,NULL,'','0000184938','0000097574','','S1','1','Filina','Robert','','','','34','274117535','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','2004-11-27','M','',':RET:2106-3','N','021','DEN','1466228','99734OH005000401','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:02'),(544,445,'Y','18','021','EC','A','','','AC','0000207094','0000207094','OH00000251894','IL','1','taylor','teron','','','','34','302887612','2475 PARKVIEW DR',0,'CUYAHOGA FALLS','OH','44223','1153','CY','39153','1988-09-18','M','U',':RET:2054-5','N','021','HLT','72878','52664OH152000901','2014-01-01','2013-12-03 21:14:57','100.00',NULL,NULL,'163.99','63.99','R-OH012','OH0','163.99',NULL,0,'2013-12-25 17:49:49'),(22430,17909,'N','01','021','EC','A',NULL,NULL,'','0000707325','0000725321','','IL','1','almaguer','david','','','Sr','34','638175056','1723 Berkley ave.',0,'Dallas','TX','75224',NULL,'CY','48113','1973-05-03','M','',NULL,'N','021','DEN','3048167','33348TX002000201','2014-03-01','2014-02-09 20:02:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-10 21:30:36'),(1050,861,'Y','18','021','EC','A','','','AC','0000361659','0000361659','TX00000705554','IL','1','Kay','Richard','','','','34','493561657','14722 CELESTIAL PL',0,'DALLAS','TX','75254','7560','CY','48113','1950-04-04','M','M',':RET:2106-3','N','021','DEN','667458','33348TX002000201','2014-01-01','2013-12-03 12:20:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:16:00'),(1785,1469,'Y','18','021','EC','A','','','AC','0000371482','0000371482','OH00001385911','IL','1','Dugan','John','J','','III','34','222541784','1473 VICTORIA AVE',0,'LAKEWOOD','OH','44107','3936','CY','39035','1966-01-18','M','U',NULL,'N','021','DEN','1779059','99734OH005000301','2014-01-01','2013-12-24 16:18:29','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:56:25'),(4805,3808,'Y','18','021','EC','A','','','AC','0000835584','0000835584','LA00000187915','IL','1','ROBINSON','DOROTHY','SHAW','','','34','435903675','205 DELLWOOD DR',0,'MONROE','LA','71202',NULL,'CY','22073','1961-05-11','F','M',':RET:2054-5','N','021','DEN','787016','18575LA002000101','2014-01-01','2013-12-07 19:47:25','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 22:16:37'),(19704,15702,'Y','18','021','EC','A','','','AC','0000043561','0000043561','TX00001623197','IL','1','Jimenez','Leticia','','','','34','454251896','125 Los Angeles Dr.',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1956-01-01','F','U',':RET:2106-3','N','021','DEN','1454942','33348TX002000201','2014-03-01','2014-01-23 15:10:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:49'),(18466,14732,'Y','18','021','EC','A','','','AC','0001756542','0001756542','LA00001966442','IL','1','ALESAWI','ALI','','','','34','109861512','4912 PIKE DR',0,'METAIRIE','LA','70003','2730','CY','22051','1973-01-01','M','U',NULL,'N','021','DEN','1917792','18575LA002000101','2014-02-01','2014-01-15 17:06:55','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-16 08:46:15'),(14290,11399,'N','01','021','EC','A',NULL,NULL,'','0001209593','0000705146','','IL','1','louis','frank','','','','34','163443973','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-05-23','M','',':RET:2106-3','T','021','HLT','2559689','52664OH152000901','2014-02-01','2013-12-26 10:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','509.80',NULL,0,'2013-12-27 02:06:33'),(16997,13605,'Y','18','021','EC','A','','','AC','0000411129','0000411129','OH00002436816','IL','1','James','Brian','','','','34','295766607','943 Wye Drive',0,'Akron','OH','44303',NULL,'CY','39153','1963-10-11','M','M',':RET:2106-3','N','021','DEN','2610068','99734OH005000301','2014-02-01','2014-01-09 08:33:00','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:20:28'),(14567,11622,'Y','18','024','14','A','','','TE','0001140784','0001140784','','IL','1','Soto','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-06-25','M','',NULL,NULL,NULL,'','2577523','','2013-12-27','2013-12-27 00:27:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:35:26'),(14620,11669,'Y','18','021','EC','A','','','AC','0001081805','0001081805','OH00000445644','IL','1','PAYNE','JACCOB','','','','34','273960939','255 W MARKET ST',0,'TIFFIN','OH','44883','2778','CY','39147','1993-02-05','M','U',':RET:2106-3','N','021','HLT','1975626','92036OH003002705','2014-02-01','2013-12-27 10:43:05','30.00',NULL,NULL,'129.31','99.31','R-OH006','OH0','129.31',NULL,0,'2013-12-28 03:36:54'),(16367,13098,'Y','18','021','EC','A','','','AC','0000760440','0000760440','MS00001026671','IL','1','Cowart','Alesia','','','','34','426474297','232 PEAR ORCHARD DR',0,'VICKSBURG','MS','39180','9005','CY','28149','1983-06-19','F','U',':RET:2106-3','T','021','DEN','1816924','46300MS002000201','2014-02-01','2014-01-06 11:40:08','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-07 04:02:55'),(16274,13030,'Y','18','021','EC','A','','','AC','0000551429','0000551429','OH00002152384','IL','1','Collins','Amber','Dawn','','','34','275882839','1121 TRUDY CT',0,'LEBANON','OH','45036','9694','CY','39165','1981-02-14','F','M',NULL,'N','021','DEN','1972264','99734OH005000401','2014-02-01','2014-01-06 13:22:06','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:22'),(29036,22982,'Y','18','024','14','A','','','TE','0001248394','0001248394','','IL','1','EVANS-HENRY','BECKY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-30','F','',NULL,NULL,NULL,'','4024884','','2014-03-10','2014-03-10 12:32:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:38'),(5639,4473,'Y','18','021','EC','A','','','AC','0000424658','0000424658','TX00000749691','IL','1','Love','Mark','','','','34','361668083','7305 San Dario',0,'Laredo','TX','78045',NULL,'CY','48479','1965-09-30','M','U',':RET:2106-3','N','021','DEN','508283','33348TX002000201','2014-01-01','2013-11-26 10:23:21','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 23:31:10'),(13892,11081,'Y','18','021','EC','A','','','AC','0000647075','0000647075','OH00001126500','IL','1','Williams','Janet','','','','34','299504543','416 N BRAYER ST',0,'HOLGATE','OH','43527','9545','CY','39069','1959-01-23','F','U',':RET:2106-3','N','021','HLT','2208419','92036OH005002605','2014-01-01','2013-12-23 18:05:52','348.00',NULL,NULL,'416.32','68.32','R-OH001','OH0','416.32',NULL,0,'2013-12-26 13:13:29'),(19059,15182,'Y','18','021','EC','A','','','AC','0001218232','0001218232','TX00001551821','31','1','Zur','Robert','','','','34','626382865','Pox 323',0,'Marfa','TX','79843',NULL,'CY','48377','1988-07-15','M','U',':RET:2106-3','N','021','DEN','2618264','33348TX002000201','2014-03-01','2014-01-17 18:58:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-21 08:44:14'),(17574,14052,'Y','18','021','EC','A','','','AC','0001051920','0001051920','OH00001722839','IL','1','Moore','Lisa','','','','34','272686718','112 OVERWOOD RD',0,'AKRON','OH','44313',NULL,'CY','39153','1960-03-18','F','M',NULL,'N','021','DEN','1805230','99734OH005000401','2014-02-01','2014-01-13 13:32:55','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-14 01:32:03'),(6357,5039,'Y','18','021','EC','A','','','AC','0000134556','0000134556','OH00000863142','IL','1','Lockett','Richard','','','','34','298620813','3774 ASHTON RD',0,'COLUMBUS','OH','43227','1202','CY','39049','1959-11-15','M','U',':RET:2054-5','N','021','DEN','800940','99734OH005000401','2014-01-01','2013-12-11 16:42:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:47:14'),(8879,7040,'Y','18','021','EC','A','','','AC','0001015355','0001015355','TX00001232339','IL','1','torres','dora','v','','','34','457902798','11378 CANDLE PARK',0,'SAN ANTONIO','TX','78249','4428','CY','48029','1949-10-14','F','U',NULL,'N','021','DEN','2069163','33348TX002000201','2014-01-01','2013-12-18 15:02:28','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 04:01:44'),(14494,11563,'Y','18','021','EC','A','','','AC','0000183346','0000183346','TX00001773737','IL','1','ACEVEDO','ANA','M','','','34','450134365','3742 ROGER JOSEPH DR',0,'EL PASO','TX','79938','9442','CY','48141','1956-06-01','F','M',NULL,'N','021','DEN','1408056','33348TX002000201','2014-02-01','2013-12-27 12:50:24','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-28 03:33:36'),(25458,20198,'Y','18','021','EC','A','','','AC','0001013213','0001013213','TX00001940002','IL','1','KELLY-VUJANOV','COSSETTE','','','','34','147864929','11610 HOPSON MEADOW LN',0,'RICHMOND','TX','77406','3963','CY','48157','1966-03-04','F','U',NULL,'N','021','DEN','3171815','33348TX002000201','2014-04-01','2014-02-25 14:19:24','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:29'),(26166,20748,'Y','18','024','14','A','','','TE','0000264228','0000264228','','IL','1','Fawcett','Randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-25','M','',NULL,NULL,NULL,'','2499400','','2014-03-13','2014-02-26 19:19:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERM',0,'2014-02-28 06:30:34'),(733,608,'Y','18','021','EC','A','','','AC','0000029413','0000029413','TX00000179583','IL','1','Joseph-Vanderpool','Jean','','','','34','081466744','425 MAJESTIC MOUNTAIN DR',0,'EL PASO','TX','79912','6301','CY','48141','1955-05-09','M','M',':RET:2054-5','N','021','DEN','337460','33348TX002000201','2014-01-01','2013-12-15 19:59:38','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:03:52'),(24921,19761,'Y','18','021','EC','A','','','AC','0000947423','0000947423','OH00001738510','IL','1','Wilson','Aimee','susan','','','34','277805920','393 N MAD ANTHONY ST',0,'MILLERSBURG','OH','44654','1116','CY','39075','1972-04-23','F','U',':RET:2106-3','T','021','HLT','3392844','52664OH151001305','2014-03-01','2014-02-20 15:38:46','181.00',NULL,NULL,'333.91','152.91','R-OH014','OH0','333.91','CIC',0,'2014-02-20 21:30:14'),(14050,11194,'Y','18','024','14','A','','','TE','0000190196','0000190196','','IL','1','Cooper','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-22','F','',NULL,NULL,NULL,'','1961601','','2013-12-26','2013-12-26 13:09:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:00:16'),(22949,18297,'Y','18','024','14','A','','','TE','0000327240','0000327240','','IL','1','ROLLER','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-08','F','',NULL,NULL,NULL,'','311108','','2014-02-28','2014-02-11 16:26:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:27'),(9366,7425,'Y','18','021','EC','A','','','AC','0001255719','0001255719','LA00000131567','IL','1','WOODARD','JAMES','','','','34','439886863','4422 BACCICH ST',0,'NEW ORLEANS','LA','70122','6114','CY','22071','1953-05-31','M','U',NULL,'N','021','DEN','2164099','18575LA002000201','2014-01-01','2013-12-21 11:25:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:40'),(19875,15854,'Y','18','021','EC','A','','','AC','0001110390','0001110390','OH00002478251','IL','1','CARR','MARY','','','','34','281528331','11711 MCCUTCHEONVILLE RD',0,'WAYNE','OH','43466','9758','CY','39173','1950-08-16','F','U',':RET:2106-3','N','021','DEN','3387266','99734OH005000401','2014-03-01','2014-01-24 17:37:56','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-24 21:00:43'),(5332,4228,'Y','18','024','14','A','','','TE','0000433867','0000433867','','IL','1','Jereb','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-01','M','',NULL,NULL,NULL,'','1227509','','2013-12-19','2013-12-19 13:22:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:07:07'),(7833,6204,'Y','18','021','EC','A','','','AC','0000203061','0000203061','OH00000542806','IL','1','Hurlow','Melinda','','','','34','269567163','1445 JERSEY RIDGE RD',0,'ZANESVILLE','OH','43701','7333','CY','39119','1953-10-26','F','U',':RET:2106-3','N','021','DEN','1557658','99734OH005000301','2014-01-01','2013-12-19 20:10:51','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 03:04:27'),(19706,15704,'Y','18','024','14','A','','','TE','0000570150','0000570150','','IL','1','delaram','ali',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-05-31','M','',NULL,NULL,NULL,'','2430630','','2014-01-23','2014-01-23 15:22:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:50'),(5812,4618,'Y','18','021','EC','A','','','AC','0000953700','0000953700','TX00000365882','IL','1','Livingston','Travis','','','','34','452378250','159 VZ COUNTY ROAD 3443',0,'WILLS POINT','TX','75169','9272','CY','48467','1962-05-24','M','M',':RET:2106-3','N','021','DEN','1633466','33348TX002000201','2014-01-01','2013-12-23 21:51:41','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:47:49'),(17749,14181,'Y','18','021','EC','A','','','AC','0000759728','0000759728','OH00002486977','IL','1','Mennell','Kenneth','','','','34','273605744','6955 Dorr Street',0,'Toledo','OH','43615',NULL,'CY','39095','1972-06-03','M','U',':RET:2106-3','N','021','HLT','2289823','92036OH004002601','2014-02-01','2014-01-13 13:41:12','0.00',NULL,NULL,'204.15','204.15','R-OH001','OH0','204.15',NULL,0,'2014-01-14 01:33:26'),(18172,14510,'N','01','021','EC','A',NULL,NULL,'','0000221318','0000465945','','IL','1','Taylor','Karen','E','','','34','379644391','7381 N TOWNSHIP ROAD 63',0,'FOSTORIA','OH','44830','9574','CY','39147','1956-01-06','F','',':RET:2106-3','N','021','HLT','2384160','92036OH005002701','2014-02-01','2014-01-14 08:46:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','496.84',NULL,0,'2014-01-15 02:07:58'),(25868,20509,'Y','18','021','EC','A','','','AC','0002060257','0002060257','LA00002608995','IL','1','Morehouse','roberta','','','','34','484720776','1202 2ND ST',0,'ELTON','LA','70532','3235','CY','22053','1964-03-12','F','U',':RET:2106-3','T','021','DEN','3515330','18575LA002000201','2014-04-01','2014-02-26 15:13:08','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-26 21:00:49'),(28362,22441,'Y','18','021','EC','A','','','AC','0000397426','0000397426','TX00003531496','IL','1','Osman','Ahmad','','','','34','875435063','601 CENTER DR',0,'CACTUS','TX','79013','3001','CY','48341','1987-01-01','M','U',NULL,'N','021','DEN','2674843','33348TX002000201','2014-04-01','2014-03-07 15:36:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:29'),(28622,22651,'N','01','021','EC','A',NULL,NULL,'','0000315685','0000606885','','IL','1','AVALOS','BRENDA','','','','34','644946757','9904 BROCKBANK DR.',0,'DALLAS','TX','75220',NULL,'CY','48113','1982-07-20','F','',NULL,'N','021','DEN','4248889','33348TX002000201','2014-04-01','2014-03-07 23:26:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-08 21:30:22'),(25414,20164,'Y','18','021','EC','A','','','AC','0001245648','0001245648','OH00002921457','IL','1','MONTIL','ROSE','','','','34','291545269','1363 HIDEAWAY WOODS DR',0,'WESTERVILLE','OH','43081',NULL,'CY','39049','1953-10-06','F','U',NULL,'T','021','DEN','3439631','99734OH005000401','2014-04-01','2014-02-25 13:42:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-25 21:31:05'),(3248,2618,'Y','18','021','EC','A','','','AC','0000279511','0000279511','OH00000916284','IL','1','Hollingsworth-Christian','Laverne','','','','34','132645646','6204 taywood Rd',0,'englewood','OH','45322',NULL,'CY','39113','1969-12-24','F','R',':RET:2054-5','N','021','DEN','640341','99734OH005000401','2014-01-01','2013-11-27 22:32:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:46:32'),(13425,10710,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000049485','','IL','1','Mecklenborg','Lucy','Jane',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2011-09-01','F','',NULL,'N','021','DEN','2321841','99734OH005000301','2014-01-01','2013-12-23 11:34:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:54'),(25407,20157,'Y','18','021','EC','A','','','AC','0000198616','0000198616','OH00002466950','IL','1','Eichenlaub','Julia','','','','34','275861711','4369 W 28TH ST',0,'CLEVELAND','OH','44109','4102','CY','39035','1987-04-15','F','U',':RET:2106-3','N','021','DEN','3214656','99734OH005000401','2014-04-01','2014-02-24 23:18:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-25 21:31:00'),(24527,19484,'Y','18','021','EC','A','','','AC','0000598466','0000598466','TX00001755612','IL','1','TILLEY','CAROLYN','LOUISE','','','34','462068273','1453 MARYLAND DR',0,'CORPUS KRISTY','TX','78415',NULL,'CY','48355','1955-05-04','F','M',NULL,'N','021','DEN','2681008','33348TX002000201','2014-04-01','2014-02-19 16:31:19','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-02-20 03:59:27'),(23961,19053,'Y','18','021','EC','A','','','AC','0000019033','0000019033','TX00002857522','IL','1','Martin','David','','','','34','452968938','1101 KAREN AVE',0,'AUSTIN','TX','78757','3013','CY','48453','1968-01-17','M','M',NULL,'N','021','DEN','2703305','33348TX002000101','2014-03-01','2014-02-15 13:45:53','0.00',NULL,NULL,'148.50','148.50','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:09'),(16400,13122,'Y','18','021','EC','A','','','AC','0001029167','0001029167','TX00000154923','IL','1','Nalls','Stacie','','','','34','638120811','100 N PASCHALL RD',0,'SUNNYVALE','TX','75182','9685','CY','48113','1975-10-24','F','U',':RET:2106-3','N','021','DEN','2526258','33348TX002000201','2014-02-01','2014-01-06 13:48:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:50'),(5080,4026,'Y','18','024','14','A','','','TE','0000485233','0000485233','','IL','1','Moreno','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-08','M','',NULL,NULL,NULL,'','1564550','','2013-12-19','2013-12-19 14:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:00:56'),(28612,22645,'Y','18','021','EC','A','','','AC','0000995271','0000995271','TX00003214357','IL','1','Morin','Martha','','','','34','462213957','2801 TIERRA DORADA BLVD',0,'MISSION','TX','78572','6755','CY','48215','1958-03-03','F','M',':RET:2106-3','N','021','DEN','4266382','33348TX002000201','2014-04-01','2014-03-07 18:22:16','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-08 21:30:16'),(13828,11038,'Y','18','021','EC','A','','','AC','0000904262','0000904262','OH00000358721','IL','1','Filina','Joanne','','','','34','290603002','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','1973-04-14','F','M',':RET:2106-3','N','021','HLT','2523112','52664OH152000901','2014-01-01','2013-12-23 09:17:46','0.00',NULL,NULL,'637.84','637.84','R-OH012','OH0','208.75',NULL,0,'2013-12-26 13:12:03'),(1329,1100,'Y','18','021','EC','A','','','AC','0000516868','0000516868','OH00000329956','IL','1','Stump','Teresa','','','','34','278728942','848 GORDON SMITH BLVD',0,'HAMILTON','OH','45013','6015','CY','39017','1965-12-31','F','U',':RET:2106-3','T','021','HLT','970380','92036OH004001201','2014-01-01','2013-10-25 13:35:54','161.00',NULL,NULL,'324.56','163.56','R-OH004','OH0','324.56',NULL,0,'2013-12-25 18:32:02'),(17731,14168,'Y','18','024','14','A','','','TE','0000919417','0000919417','','IL','1','sands','ellen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-03-27','F','',NULL,NULL,NULL,'','1979733','','2014-01-13','2014-01-13 09:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-14 01:33:19'),(15575,12463,'N','19','021','EC','A',NULL,NULL,'','0000816437','0000474983','','S1','1','Smith','Charles','Robert','','Jr','34','272048568','303 W WASHINGTON ST',0,'MEDINA','OH','44256','2236','CY','39103','1998-11-20','M','',':RET:2106-3','N','021','HLT','2193769','52664OH151001306','2014-02-01','2013-12-31 15:28:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,1,'2014-01-02 04:32:01'),(6421,5091,'Y','18','021','EC','A','','','AC','0000577169','0000577169','LA00000781918','IL','1','Gravois','Evelie','','','','34','433046457','13756 HIGHWAY 643',0,'VACHERIE','LA','70090','3364','CY','22093','1956-01-31','F','U',':RET:2106-3','N','021','DEN','946638','18575LA002000201','2014-01-01','2013-12-10 19:29:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:48:54'),(3032,2438,'Y','18','021','EC','A','','','AC','0000520929','0000520929','OH00001131778','IL','1','SORG','KENNETH','W','','','34','276543748','130 E. WASHINGTON APT.',0,'BOWLING GREEN','OH','43402',NULL,'CY','39173','1953-05-20','M','M',':RET:2106-3','N','021','HLT','1236034','92036OH004002601','2014-01-01','2013-12-06 09:56:47','0.00',NULL,NULL,'425.53','425.53','R-OH001','OH0','425.53',NULL,0,'2013-12-25 20:18:26'),(2965,2388,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00000500747','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','1148839','33348TX002000201','2014-01-01','2013-12-06 00:26:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:51'),(2929,2360,'Y','18','021','EC','A','','','AC','0000274757','0000274757','OH00000635170','IL','1','Perry','Teresa','','','','34','299781763','15293 CALABOONE RD',0,'DOYLESTOWN','OH','44230','9204','CY','39169','1969-04-03','F','M',':RET:2106-3','N','021','DEN','758404','99734OH005000401','2014-01-01','2013-12-05 20:48:02','0.00',NULL,NULL,'71.95','71.95','R-OH014','OH0','0.00',NULL,0,'2013-12-25 20:15:58'),(14509,11575,'Y','18','021','EC','A','','','AC','0000298713','0000298713','TX00001384550','IL','1','ESPINO OCHOA','GABRIELA','','','','34','701464413','209 3RD ST',0,'BOVINA','TX','79009',NULL,'CY','48369','1941-03-31','F','U',NULL,'N','021','DEN','1975639','33348TX002000201','2014-02-01','2013-12-27 15:42:35','0.00',NULL,NULL,'16.22','16.22','R-TX026','TX0','16.22',NULL,0,'2013-12-28 03:34:00'),(19376,15446,'Y','18','021','EC','A','','','AC','0000545440','0000545440','MS00002249285','IL','1','Beauchamp','Andrew','','','','34','436557090','1624 DEVINE ST',0,'JACKSON','MS','39202','1313','CY','28049','1984-03-05','M','U',':RET:2106-3','T','021','DEN','3013967','46300MS002000101','2014-03-01','2014-01-21 00:41:13','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-22 03:22:39'),(13666,10904,'Y','18','021','EC','A','','','AC','0001335545','0001335545','LA00000828594','IL','1','Gervais','Lloyd','','','Jr','34','437924359','1272 SAINT CHRISTOPHER ST',0,'SLIDELL','LA','70460','2366','CY','22103','1952-04-21','M','U',':RET:2106-3','N','021','DEN','2028248','18575LA002000101','2014-01-01','2013-12-23 14:58:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:47'),(18821,14991,'Y','18','021','EC','A','','','AC','0000264237','0000264237','MS00002591645','IL','1','DAMPEER','FREDRICK','W','','','34','425552125','2741 SHIVERS RD',0,'MENDENHALL','MS','39114','4943','CY','28127','1977-11-25','M','M',':RET:2054-5','N','021','DEN','2733678','46300MS002000201','2014-02-01','2014-01-15 18:47:13','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:06'),(5204,4130,'Y','18','021','EC','A','','','AC','0000498150','0000498150','OH00000860954','IL','1','Vance','Barbara','','','','34','401025431','6515 RAINBOW LN',0,'CINCINNATI','OH','45230','1464','CY','39061','1960-09-16','F','U',NULL,'N','021','DEN','2030150','99734OH005000401','2014-01-01','2013-12-19 14:54:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:07'),(20464,16348,'Y','18','024','14','A','','','TE','0000128130','0000128130','','IL','1','MILLER','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-17','F','',NULL,NULL,NULL,'','3003266','','2014-01-29','2014-01-29 11:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:53'),(21934,17515,'N','19','021','EC','A',NULL,NULL,'','0000560635','0000334283','','IL','1','SOWEMIMO','AARON','','','','34','635305875','5830 COASTAL WAY',0,'HOUSTON','TX','77085','1922','CY','48201','1992-03-30','M','',':RET:2054-5','N','021','DEN','3222083','33348TX002000201','2014-03-01','2014-02-07 10:12:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-07 19:00:12'),(22646,18081,'Y','18','021','EC','A','','','AC','0000573913','0000573913','TX00001579601','IL','1','Bush','Gayle','','','','34','467069582','506 Howard St',0,'Longview','TX','75602',NULL,'CY','48183','1955-11-19','F','U',':RET:2054-5','N','021','DEN','3214332','33348TX002000201','2014-03-01','2014-02-11 10:48:36','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-11 21:00:24'),(24842,19696,'Y','18','021','EC','A','','','AC','0000857169','0000857169','OH00002251057','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','HLT','2640425','52664OH152000901','2014-04-01','2014-02-19 09:35:44','266.00',NULL,NULL,'391.36','125.36','R-OH015','OH0','195.68',NULL,0,'2014-02-20 04:54:01'),(25797,20458,'Y','18','021','EC','A','','','AC','0001244219','0001244219','OH00003153791','IL','1','robinson','chris','','','','34','401273898','15462 STATE RD',0,'NORTH ROYALTON','OH','44133','5359','CY','39035','1974-04-18','M','M',':RET:2106-3','N','021','DEN','3343507','99734OH005000301','2014-04-01','2014-02-26 10:48:08','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:00:14'),(26437,20969,'Y','18','024','14','A','','','TE','0001081765','0001081765','','IL','1','Bencar','Chris',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-11-18','M','',NULL,NULL,NULL,'','927034','','2014-02-28','2014-02-27 13:06:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:18'),(26709,21173,'N','19','021','EC','A',NULL,NULL,'','0001096815','0000588032','','IL','1','MARSH','JEREMY','','','','34','294961816','3638 BLACK JACK TRL',0,'AMELIA','OH','45102','1619','CY','39025','1994-01-14','M','',':RET:2106-3','N','021','HLT','3651849','92036OH003000601','2014-04-01','2014-02-27 21:19:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-28 21:31:37'),(13335,10647,'N','19','021','EC','A',NULL,NULL,'','0001131863','0001056220','','IL','1','WASHINGTON','LATISHA','','','','34','633182447','11455 BISSONNET ST',0,'HOUSTON','TX','77099',NULL,'CY','48201','1990-09-11','F','',':RET:2054-5','N','021','DEN','2361200','33348TX002000201','2014-01-01','2013-12-23 18:03:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:58:44'),(7287,5778,'Y','18','021','EC','A','','','AC','0000998761','0000998761','OH00001303774','IL','1','Rogers','Cynthia','','','','34','278543405','10016 HOMESTEAD RD',0,'WADSWORTH','OH','44281','9033','CY','39103','1960-04-16','F','M',NULL,'N','021','HLT','980982','52664OH151001501','2014-01-01','2013-12-14 10:26:02','370.00',NULL,NULL,'1532.84','1162.84','R-OH012','OH0','545.63',NULL,0,'2013-12-26 02:02:51'),(19691,15691,'N','01','021','EC','A',NULL,NULL,'','0000800833','0000370852','','IL','1','WILLIAMS','CHRIS','','','','34','466379269','1003 RICHMOND DR',0,'MARSHALL','TX','75672','2507','CY','48203','1962-02-20','M','',NULL,'T','021','DEN','2707774','33348TX002000201','2014-03-01','2014-01-23 16:42:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 21:00:42'),(6903,5477,'N','01','021','EC','A',NULL,NULL,'','0001773091','0002189760','','IL','1','sellers','cynthia','','','','34','433741500','8501 BELFAST ST',0,'NEW ORLEANS','LA','70118','3137','CY','22071','1961-07-15','F','',':RET:2106-3','N','021','DEN','1502212','18575LA002000201','2014-01-01','2013-12-24 22:45:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:45:41'),(18215,14538,'N','01','021','EC','A',NULL,NULL,'','0000918272','0000217618','','IL','1','German','Scott','V','','','34','288805284','21371 JENNINGS DELPHOS RD',0,'DELPHOS','OH','45833','8865','CY','39161','1978-07-28','M','',':RET:2106-3','T','021','HLT','1639161','92036OH006001501','2014-02-01','2014-01-14 17:10:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.27',NULL,0,'2014-01-15 02:08:11'),(22188,17708,'Y','18','021','EC','A','','','AC','0001068304','0001068304','OH00001552220','IL','1','Moore','Walter','','','','34','281625775','703 ROBINHOOD DR',0,'AURORA','OH','44202','7821','CY','39133','1957-03-27','M','U',':RET:2106-3','T','021','HLT','3221037','52664OH151001305','2014-03-01','2014-02-09 15:41:03','399.00',NULL,NULL,'598.32','199.32','R-OH012','OH0','598.32','CIC',0,'2014-02-09 19:00:07'),(22566,18021,'N','01','021','EC','A',NULL,NULL,'','0000498215','0000188894','','IL','1','TEMPLE','ASHELEY','','','','34','592428847','1843 SEDRO ST',0,'CUYAHOGA FALLS','OH','44221','5242','CY','39153','1984-12-26','F','',':RET:2106-3','N','021','DEN','3588204','99734OH005000401','2014-03-01','2014-02-10 13:32:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:54'),(22584,18037,'Y','18','021','EC','A','','','AC','0000044310','0000044310','OH00001555205','IL','1','arnett-hall','JoeAnne','','','','34','285663399','2939 ERTER DR',0,'SPRINGFIELD','OH','45503','2102','CY','39023','1959-05-07','F','M',':RET:2106-3','N','021','HLT','3650118','92036OH004000501','2014-03-01','2014-02-10 13:23:59','243.00',NULL,NULL,'408.08','165.08','R-OH003','OH0','408.08',NULL,0,'2014-02-10 21:32:04'),(25902,20538,'Y','18','021','EC','A','','','AC','0000805910','0000805910','TX00002109805','IL','1','SANTOS','CELESTE','','','','34','465690846','2813 E NOPAL DR',0,'EDINBURG','TX','78542','0576','CY','48215','1979-11-27','F','M',':RET:2106-3','N','021','DEN','3443411','33348TX002000201','2014-04-01','2014-02-26 13:45:47','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-26 21:01:09'),(28909,22883,'Y','18','021','EC','A','','','AC','0000407436','0000407436','OH00002654944','IL','1','PLUNKETT','ASHLEY','','','','34','293901794','1 Oakwood Ave.',0,'Dayton','OH','45409',NULL,'CY','39113','1985-12-22','F','U',':RET:2106-3','N','021','DEN','3997644','99734OH005000301','2014-04-01','2014-03-09 22:21:41','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-10 21:00:26'),(4883,3872,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000878751','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','336936','92036OH006002601','2014-01-01','2013-10-10 03:56:00','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-25 22:31:17'),(1946,1586,'Y','18','021','EC','A','','','AC','0000273748','0000273748','OH00000632481','IL','1','LAWRENCE','ROBERT','ALLEN','','','34','278600900','12220 IOWA AVE',0,'CLEVELAND','OH','44108',NULL,'CY','39035','1958-07-09','M','U',':RET:2054-5','N','021','DEN','97976','99734OH005000401','2014-01-01','2013-11-20 12:50:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:00:50'),(3023,2431,'Y','18','021','EC','A','','','AC','0000596249','0000596249','OH00001145454','IL','1','BOSNYAK','TRACI','LEE','','','34','279841899','282 1ST ST',0,'WADSWORTH','OH','44281','2049','CY','39103','1971-07-15','F','U',':RET:2106-3','N','021','HLT','598751','52664OH151001304','2014-01-01','2013-12-06 10:43:13','0.00',NULL,NULL,'295.48','295.48','R-OH012','OH0','295.48',NULL,0,'2013-12-25 20:18:13'),(18002,14385,'Y','18','021','EC','A','','','AC','0000437993','0000437993','OH00002404626','IL','1','Tackett','Sara','','','','34','294906706','720 TALLTREES DR',0,'ASHTABULA','OH','44004','7758','CY','39007','1987-12-18','F','U',':RET:2106-3','N','021','DEN','2606220','99734OH005000301','2014-02-01','2014-01-13 21:36:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:00'),(17742,14174,'N','01','021','EC','A',NULL,NULL,'','0000250269','0001053075','','IL','1','Hindel','Scott','','','','34','276886241','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','1976-12-24','M','',':RET:2106-3','N','021','HLT','2130210','52664OH151001304','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','276.08',NULL,0,'2014-01-14 01:33:23'),(6792,5387,'Y','18','021','EC','A','','','AC','0001192592','0001192592','TX00000155075','IL','1','Clark','Scott','William','','','34','228152467','9415 McNeil Drive',0,'Austin','TX','78750',NULL,'CY','48453','1966-05-27','M','U',':RET:2106-3','N','021','DEN','333097','33348TX002000201','2014-01-01','2013-11-25 16:11:06','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:17:06'),(8837,7005,'Y','18','021','EC','A','','','AC','0000570150','0000570150','TX00001011630','IL','1','delaram','ali','','','','34','645429179','15114 wells port dr',0,'austin','TX','78728',NULL,'CY','48453','1980-05-31','M','M',':RET:2106-3','N','021','DEN','2430630','33348TX002000201','2014-01-01','2013-12-17 21:03:48','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:00:38'),(14975,11970,'Y','18','021','EC','A','','','AC','0000557904','0000557904','TX00001480128','IL','1','Su','Zimin','','','','34','490987692','9618 OAKLAND LAKE WAY',0,'MISSOURI CITY','TX','77459','6451','CY','48157','1961-11-27','M','M',':RET:2034-7','N','021','DEN','1492600','33348TX002000201','2014-02-01','2013-12-30 13:40:06','0.00',NULL,NULL,'63.40','63.40','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:00:57'),(28129,22260,'Y','18','021','EC','A','','','AC','0000298301','0000298301','OH00003167132','IL','1','Karos','Bill','','','','34','276565966','333 S ROSE BLVD',0,'AKRON','OH','44313','7802','CY','39153','1955-08-19','M','M',':RET:2106-3','N','021','HLT','3616200','52664OH151001305','2014-04-01','2014-03-06 11:36:23','866.00',NULL,NULL,'1044.34','178.34','R-OH012','OH0','568.22',NULL,0,'2014-03-06 21:02:24'),(273,225,'Y','18','021','EC','A','','','AC','0000254500','0000254500','OH00000009246','IL','1','Allen','Brandon','','','','34','272920366','2928 BANNING RD',0,'CINCINNATI','OH','45239','5577','CY','39061','1984-09-23','M','U',NULL,'T','021','DEN','1104479','99734OH005000401','2014-01-01','2013-10-11 21:30:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:30:04'),(4117,3290,'N','19','021','EC','A',NULL,NULL,'','0000309426','0000648311','','IL','1','Cipro','Joseph','','','','34','273118119','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2004-12-28','M','',':RET:2106-3','N','021','DEN','1795221','99734OH005000301','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:09'),(530,432,'Y','18','021','EC','A','','','AC','0000780967','0000780967','MS00000921050','31','1','Ali','Akeelah','','','','34','427678672','302 First Hopewell Road',0,'Sumrall','MS','39482',NULL,'CY','28091','1987-01-30','F','U',':RET:2054-5','N','021','DEN','369065','46300MS002000201','2014-01-01','2013-12-04 18:03:06','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 17:49:26'),(18141,14486,'Y','18','021','EC','A','','','AC','0001743833','0001743833','LA00002331857','IL','1','CARROLL','COEL','','','','34','439653691','3201 KALISTE SALOOM RD',0,'LAFAYETTE','LA','70508','7460','CY','22055','1977-12-23','F','U',':RET:2054-5','N','021','DEN','1973795','18575LA002000101','2014-02-01','2014-01-14 14:19:32','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-15 02:07:46'),(2074,1698,'Y','18','024','14','A','','','TE','0000841402','0000841402','','IL','1','Coleman','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-09-29','M','',NULL,NULL,NULL,'','943803','','2013-12-09','2013-12-09 21:44:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:16:27'),(863,714,'Y','18','024','14','A','','','TE','0000201897','0000201897','','IL','1','Berry','Laura','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-09-14','F','',NULL,NULL,NULL,'','226447','','2013-12-16','2013-12-16 08:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:07:14'),(6794,5389,'Y','18','021','EC','A','','','AC','0001204493','0001204493','OH00000593586','31','1','Durliat','Thomas','','','','34','295527727','PO Box 475',0,'Hartville','OH','44632',NULL,'CY','39133','1951-07-30','M','M',':RET:2106-3','N','021','HLT','2360','52664OH151001501','2014-01-01','2013-11-25 15:47:07','903.00',NULL,NULL,'1676.42','773.42','R-OH012','OH0','768.43',NULL,0,'2013-12-26 01:17:10'),(9266,7350,'Y','18','021','EC','A','','','AC','0000495424','0000495424','OH00000999416','IL','1','McKee','Linda','','','','34','279528418','6936 W SMITH RD',0,'MEDINA','OH','44256','7512','CY','39103','1952-02-10','F','U',':RET:2106-3','T','021','HLT','797901','52664OH152000901','2014-01-01','2013-11-30 07:57:22','513.00',NULL,NULL,'527.84','14.84','R-OH012','OH0','527.84',NULL,0,'2013-12-26 04:15:28'),(9605,7607,'N','19','021','EC','A',NULL,NULL,'','0000502980','0000614101','','IL','1','Wilde','Benjamin','','','','34','285926280','10956 AMBLER LN',0,'MANTUA','OH','44255','9224','CY','39133','1989-11-22','M','',':RET:2106-3','N','021','HLT','2012957','52664OH151001306','2014-01-01','2013-12-21 13:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-26 04:37:30'),(13995,11150,'Y','18','024','14','A','','','TE','0000933206','0000933206','','IL','1','Durnell','Zachery',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-05-19','M','',NULL,NULL,NULL,'','2368076','','2013-12-23','2013-12-23 07:30:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:15:55'),(21290,17012,'N','01','021','EC','A',NULL,NULL,'','0002181286','0001256795','','IL','1','HARTFIELD','TASHA','LYNN','','','34','434475282','22317 WALKER SOUTH ROAD',0,'DENHAM SPRINGS','LA','70726',NULL,'CY','22063','1979-11-26','F','',':RET:2106-3','T','021','DEN','3115338','18575LA002000101','2014-03-01','2014-02-03 20:53:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-04 21:00:06'),(23237,18526,'Y','18','021','EC','A','','','AC','0000267571','0000267571','OH00001676910','31','1','harlan','deborah','','','','34','302622375','p.o.box123',0,'put in bay','OH','43456',NULL,'CY','39123','1958-12-15','F','M',':RET:2106-3','T','021','HLT','2993721','92036OH006002701','2014-03-01','2014-02-12 14:31:37','0.00',NULL,NULL,'396.58','396.58','R-OH006','OH0','396.58',NULL,0,'2014-02-12 21:32:29'),(23608,18803,'N','19','021','EC','A',NULL,NULL,'','0000051967','0000087532','','IL','1','Hamp','Kenneth','','','','34','594553576','732 w 1st st',0,'delphos','OH','45833',NULL,'CY','39161','1994-10-05','M','',':RET:2106-3','N','021','HLT','3474683','92036OH003001501','2014-03-01','2014-02-13 15:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-13 22:03:10'),(27368,21671,'N','01','021','EC','A',NULL,NULL,'','0000822115','0000937342','','IL','1','Poteet','Timothy','E','','','34','282508938','4913 BATH RD',0,'DAYTON','OH','45424','1756','CY','39057','1966-02-02','M','',':RET:2106-3','N','021','DEN','2782074','99734OH005000401','2014-04-01','2014-03-04 17:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:14'),(1189,978,'N','19','021','EC','A',NULL,NULL,'','0001200866','0000907989','','IL','1','Morris','Jeremiah','William','','','34','282962901','4881 Westville Lake Rd',0,'Beloit','OH','44609',NULL,'CY','39029','1993-06-29','M','',':RET:2106-3','T','021','DEN','634259','99734OH005000301','2014-01-01','2013-12-03 09:46:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:33'),(5246,4161,'Y','18','021','EC','A','','','AC','0000857090','0000857090','OH00000183637','IL','1','KVETENSKY','NORMAN','D','','','34','297504466','10955 MITCHELL RD',0,'COLUMBIA STATION','OH','44028','9564','CY','39093','1952-07-14','M','M',':RET:2106-3','N','021','HLT','2180575','52664OH151001301','2014-01-01','2013-12-18 23:15:06','690.00',NULL,NULL,'1293.56','603.56','R-OH011','OH0','706.77',NULL,0,'2013-12-25 23:05:01'),(16142,12929,'Y','18','021','EC','A','','','AC','0000814301','0000814301','OH00001414406','IL','1','pierce','thomas','','','','34','293707569','13491 NEW HARMONY SHILOH RD',0,'MOUNT ORAB','OH','45154','9524','CY','39015','1960-10-12','M','M',':RET:2106-3','N','021','HLT','1460927','92036OH003000606','2014-02-01','2014-01-03 14:55:59','358.00',NULL,NULL,'457.33','99.33','R-OH005','OH0','457.33',NULL,0,'2014-01-04 02:06:02'),(3008,2418,'Y','18','021','EC','A','','','AC','0000545210','0000545210','OH00000884136','IL','1','miller','robert','l','','','34','160448709','311 PLEASANT MEADOW BLVD',0,'STOW','OH','44224','4968','CY','39153','1951-07-17','M','U',':RET:2106-3','N','021','HLT','805878','52664OH151001301','2014-01-01','2013-12-05 19:45:01','385.00',NULL,NULL,'640.70','255.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 20:17:50'),(7091,5625,'Y','18','021','EC','A','','','AC','0000799897','0000799897','OH00001444281','31','1','Lopez','Rafael','','','','34','102586232','PO Box 1851',0,'Medina','OH','44258',NULL,'CY','39103','1969-09-27','M','U',':RET:2106-3','N','021','HLT','1766924','52664OH151001305','2014-01-01','2013-12-24 18:51:50','215.00',NULL,NULL,'311.54','96.54','R-OH012','OH0','311.54',NULL,0,'2013-12-26 01:50:32'),(4300,3419,'N','01','021','EC','A',NULL,NULL,'','0000943411','0000324830','','IL','1','Grant','Monica','M','','','34','269761923','7566 n cr 29',0,'Flat rock','OH','44828',NULL,'CY','39147','1971-09-12','F','',NULL,'N','021','HLT','2074677','92036OH004002701','2014-01-01','2013-12-16 21:35:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','207.75',NULL,0,'2013-12-25 21:52:20'),(4714,3737,'N','01','021','EC','A',NULL,NULL,'','0000132047','0000457799','','IL','1','MOLONEY','RICHARD','','','','34','269741144','152 LARKINS STREET',0,'FINDLAY','OH','45840',NULL,'CY','39063','1964-02-23','M','',NULL,'T','021','HLT','618345','92036OH005001505','2014-01-01','2013-12-12 15:49:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','431.79',NULL,0,'2013-12-25 22:08:48'),(5196,4122,'Y','18','021','EC','A','','','AC','0000908015','0000908015','OH00000842699','IL','1','HULS','SUSAN','','','','34','280500576','5663 DOCKSIDE DR',0,'MASON','OH','45040','8205','CY','39165','1950-06-17','F','U',NULL,'N','021','DEN','2582430','99734OH005000401','2014-01-01','2013-12-19 14:10:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:54'),(22993,18331,'Y','18','021','EC','A','','','AC','0000532153','0000532153','OH00002233674','IL','1','Murphy','Lori','','','','34','294681964','2502 STARFORD DR',0,'DUBLIN','OH','43016','9247','CY','39049','1963-10-19','F','U',':RET:2106-3','T','021','DEN','3821763','99734OH005000301','2014-03-01','2014-02-12 08:49:12','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:30:14'),(23484,18706,'Y','18','021','EC','A','','','AC','0001879517','0001879517','LA00001954590','IL','1','Mills','Garrett','','','','34','005762462','2220 MARAIS ST',0,'NEW ORLEANS','LA','70117','8413','CY','22071','1977-10-20','M','U',':RET:2106-3','T','021','DEN','2835416','18575LA002000101','2014-03-01','2014-02-13 12:56:01','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-13 22:01:57'),(23593,18794,'Y','18','021','EC','A','','','AC','0000597350','0000597350','OH00002134295','IL','1','Mannion','Ruth','','','','34','282520518','69 E GARFIELD RD',0,'AURORA','OH','44202','8801','CY','39133','1950-05-06','F','M',':RET:2106-3','N','021','HLT','3848383','52664OH152000901','2014-03-01','2014-02-13 17:10:34','395.00',NULL,NULL,'482.18','87.18','R-OH012','OH0','482.18',NULL,0,'2014-02-13 22:03:03'),(26692,21162,'N','19','021','EC','A',NULL,NULL,'','0001262234','0001456311','','IL','1','Canizales','Hector','','','Jr','34','434851812','1614 JUNIPER DR',0,'SHREVEPORT','LA','71118','2214','CY','22017','1992-04-29','M','',':RET:2106-3','N','021','DEN','3758620','18575LA002000101','2014-04-01','2014-02-28 00:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 21:31:29'),(27875,22050,'Y','18','021','EC','A','','','AC','0001087296','0001087296','MS00003567489','IL','1','Mcghee','Gena','','','','34','427497590','1553 Jackson drive',0,'Nesbit','MS','38651',NULL,'CY','28033','1974-09-06','F','R',':RET:2054-5','N','021','DEN','3117687','46300MS002000101','2014-04-01','2014-03-05 15:35:27','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-03-05 21:32:28'),(28872,22850,'Y','18','021','EC','A','','','AC','0000936835','0000936835','TX00002713988','IL','1','Joslin','Delores','','','','34','467871698','125 S SPRING ST',0,'GRAND SALINE','TX','75140','2331','CY','48467','1981-08-26','F','M',':RET:2106-3','N','021','DEN','4006209','33348TX002000201','2014-04-01','2014-03-09 21:24:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:03'),(29061,23001,'Y','18','021','EC','A','','','AC','0000768935','0000768935','OH00003642825','IL','1','SCHWEIPZER','KIM','','','','34','271705629','1628 NORMAN AVE',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1962-04-21','F','U',NULL,'N','021','DEN','3545784','99734OH005000401','2014-04-01','2014-03-10 17:43:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:52'),(1448,1208,'Y','18','021','EC','A','','','AC','0001011568','0001011568','OH00001191154','IL','1','Schwartz','Richard','','','','34','277726079','1379 N High St',0,'columbus','OH','43201',NULL,'CY','39049','1976-05-06','M','U',':RET:2106-3','N','021','DEN','1979269','99734OH005000401','2014-01-01','2013-12-24 05:03:44','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:02'),(19474,15522,'Y','18','021','EC','A','','','AC','0000151795','0000151795','TX00002023812','IL','1','KAHLE','SAVITRI','R','','','34','643740332','17515 SPRING CYPRESS ROAD',0,'CYPRESS','TX','77429',NULL,'CY','48201','1961-11-23','F','U',':RET:2029-7','N','021','DEN','3163369','33348TX002000201','2014-03-01','2014-01-21 18:52:23','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-23 03:02:01'),(1975,1614,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','149271','','2013-11-19','2013-11-19 23:03:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:35'),(7175,5690,'Y','18','021','EC','A','','','AC','0000057316','0000057316','OH00001240311','IL','1','Walker','Tia','','','','34','276704223','2653 MAYFAIR RD',0,'AKRON','OH','44312','5409','CY','39153','1960-04-20','F','M',':RET:2106-3','N','021','DEN','222945','99734OH005000301','2014-01-01','2013-12-13 20:55:46','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:00:04'),(16292,13043,'Y','18','021','EC','A','','','AC','0000808663','0000808663','OH00001932071','IL','1','SELL','MARK','ALLAN','','','34','283567643','6595 MAPLEWOOD DR',0,'MAYFIELD HEIGHTS','OH','44124',NULL,'CY','39035','1956-09-13','M','U',':RET:2106-3','N','021','DEN','2133793','99734OH005000401','2014-02-01','2014-01-06 17:45:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-07 04:00:53'),(3451,2775,'Y','18','021','EC','A','','','AC','0000501608','0000501608','OH00000195344','IL','1','Hammond','Hope','','','','34','270905218','180 College Park Drive',0,'Elyria','OH','44053',NULL,'CY','39093','1984-04-23','F','U',':RET:2106-3','N','021','DEN','2476725','99734OH005000401','2014-01-01','2013-12-21 22:04:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:19:30'),(14716,11749,'Y','18','021','EC','A','','','AC','0000827170','0000827170','OH00000617305','IL','1','Winn','Diana','P','','','34','268541511','101 E Ticonderoga Dr.',0,'Westerville','OH','43081',NULL,'CY','39049','1953-08-02','F','U',':RET:2106-3','T','021','DEN','2132367','99734OH005000301','2014-02-01','2013-12-28 15:50:31','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:09:26'),(20540,16413,'Y','18','021','EC','A','','','AC','0000957932','0000957932','OH00002089437','IL','1','Kackloudis','Michael','','','','34','278500357','4635 LANDCHESTER RD',0,'CLEVELAND','OH','44109','4532','CY','39035','1950-09-09','M','U',':RET:2106-3','N','021','HLT','2873880','52664OH152000901','2014-03-01','2014-01-29 17:08:38','263.00',NULL,NULL,'543.83','280.83','R-OH011','OH0','543.83',NULL,0,'2014-01-29 21:01:35'),(22449,17923,'N','01','021','EC','A',NULL,NULL,'','0000925348','0000376693','','IL','1','Townsend','Benjamin','Curtis','','Jr','34','156687054','11433 TURNING LEAF TRL',0,'FORT WORTH','TX','76244','4889','CY','48439','1971-04-13','M','',':RET:2106-3','N','021','DEN','2928737','33348TX002000201','2014-03-01','2014-02-10 14:28:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-10 21:30:45'),(24224,19237,'Y','18','021','EC','A','','','AC','0000888787','0000888787','TX00001458205','IL','1','WANG','JACQUELINE','','','','34','645224055','5940 GLENDOWER LN',0,'PLANO','TX','75093','4780','CY','48085','1988-05-20','F','U',NULL,'N','021','DEN','2828445','33348TX002000201','2014-04-01','2014-02-16 10:54:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-16 19:00:30'),(24690,19599,'Y','18','021','EC','A','','','AC','0000024826','0000024826','TX00001552501','IL','1','Gilson','Cimarron','','','','34','452539182','3777 FM 1518',0,'Selma','TX','78154',NULL,'CY','48187','1980-08-28','M','U',':RET:2106-3','N','021','DEN','3194029','33348TX002000101','2014-04-01','2014-02-19 17:35:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-20 04:32:15'),(24922,19762,'Y','18','021','EC','A','','','AC','0001009849','0001009849','MS00003044717','IL','1','hathcox','thomas','f','','Jr','34','434558801','10 THREE OAKS RD',0,'CARRIERE','MS','39426','9114','CY','28109','1967-03-07','M','M',':RET:2106-3','N','021','DEN','2645469','46300MS002000201','2014-04-01','2014-02-20 14:00:51','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85','CIC',0,'2014-02-20 21:30:15'),(26919,21335,'Y','18','021','EC','A','','','AC','0001190120','0001190120','OH00002354202','IL','1','Hamric','Stacey','Marie','','','34','270709081','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1971-08-19','F','M',':RET:2106-3','N','021','DEN','3289675','99734OH005000401','2014-04-01','2014-03-01 21:31:20','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2014-03-03 01:00:15'),(27068,21432,'Y','18','021','EC','A','','','AC','0001690505','0001690505','LA00002785498','IL','1','WEBB','HENRY','','','','34','435825706','3557 ASH ST',0,'ZACHARY','LA','70791','2957','CY','22033','1950-12-26','M','M',':RET:2054-5','N','021','DEN','3290780','18575LA002000201','2014-04-01','2014-03-03 15:32:28','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-03 21:30:04'),(27714,21916,'Y','18','021','EC','A','','','AC','0000053593','0000053593','TX00003156311','IL','1','LAMBERT','CARMELINE','','','','34','459868228','7501 SCOTT AVE',0,'MANVEL','TX','77578','3939','CY','48039','1953-02-10','F','U',':RET:2106-3','N','021','DEN','3160783','33348TX002000201','2014-04-01','2014-03-05 13:13:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-05 21:30:55'),(28473,22530,'N','01','021','EC','A',NULL,NULL,'','0000310865','0001105550','','IL','1','Ross','Janie','D','','','34','306681725','5708 Terrace Park Drive',0,'Kettering','OH','45429',NULL,'CY','39113','1957-01-11','F','',':RET:2106-3','N','021','DEN','3857494','99734OH005000301','2014-04-01','2014-03-07 08:55:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:32'),(29140,23068,'Y','18','021','EC','A','','','AC','0000646075','0000646075','OH00003500032','IL','1','Killion','Joseph',NULL,NULL,NULL,NULL,NULL,'322 SENECA ST',0,'DEFIANCE','OH','43512','2231','CY','39039','1951-06-02','M','M',NULL,'N','021','HLT','4344272','92036OH005002605','2014-04-01','2014-03-10 12:17:51','1023.00',NULL,NULL,'1067.80','44.80','R-OH001','OH0','560.22',NULL,0,'2014-03-10 21:02:42'),(3336,2674,'N','01','021','EC','A',NULL,NULL,'','0000581483','0000783228','','IL','1','SMITH','ANNETTE','A','','','34','284668641','217 IDAHO AVE',0,'LORAIN','OH','44052','2159','CY','39093','1972-11-09','F','',':RET:1002-5','N','021','DEN','1853563','99734OH005000301','2014-01-01','2013-12-22 18:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:22'),(3375,2705,'Y','18','021','EC','A','','','AC','0000371951','0000371951','TX00001285946','IL','1','Woods','Joyce','K','','','34','452983986','153 Southern Ave',0,'Joaquin','TX','75954',NULL,'CY','48419','1954-08-28','F','M',':RET:2106-3','N','021','DEN','2036623','33348TX002000201','2014-01-01','2013-12-22 17:02:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:22'),(3610,2893,'Y','18','021','EC','A','','','AC','0000997747','0000997747','OH00001149844','IL','1','McDermott','Patrice','','','','34','273684743','419 Cabot Drive',0,'Akron','OH','44333',NULL,'CY','39153','1967-10-29','F','M',':RET:2106-3','N','021','HLT','1423401','52664OH152000901','2014-01-01','2013-12-22 18:15:54','285.99',NULL,NULL,'556.17','270.18','R-OH012','OH0','245.01',NULL,0,'2013-12-25 21:23:28'),(13610,10852,'Y','18','024','14','A','','','TE','0001053019','0001053019','','IL','1','Pemberton','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-12','M','',NULL,NULL,NULL,'','1151301','','2013-12-23','2013-12-23 08:48:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:05:36'),(4819,3819,'Y','18','021','EC','A','','','AC','0000251596','0000251596','OH00000938822','IL','1','Mallett','Catherine','','','','34','300529455','429 E Benson St',0,'Cincinnati','OH','45215',NULL,'CY','39061','1952-09-19','F','U',':RET:2106-3','T','021','HLT','1068598','92036OH004001201','2014-01-01','2013-12-08 09:25:52','0.00',NULL,NULL,'557.81','557.81','R-OH004','OH0','557.81',NULL,0,'2013-12-25 22:17:01'),(5455,4334,'Y','18','021','EC','A','','','AC','0000404788','0000404788','OH00000114955','IL','1','Dussel','Linda','','','','34','272560397','1109 OLD FORGE RD',0,'KENT','OH','44240','7403','CY','39133','1955-12-11','F','M',':RET:2106-3','N','021','HLT','1853381','52664OH151001501','2014-01-01','2013-12-19 08:40:42','812.00',NULL,NULL,'1465.23','653.23','R-OH012','OH0','681.50',NULL,0,'2013-12-25 23:10:16'),(9184,7285,'Y','18','021','EC','A','','','AC','0000805092','0000805092','OH00000692599','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','HLT','2468299','92036OH005001506','2014-01-01','2013-12-18 15:28:56','300.00',NULL,NULL,'649.68','349.68','R-OH002','OH0','649.68',NULL,0,'2013-12-26 04:09:15'),(6924,5496,'Y','18','021','EC','A','','','AC','0000637111','0000637111','OH00001153827','31','1','Givens','Garland','','','','34','285803627','P. O. Box 2731',0,'Springfield','OH','45501',NULL,'CY','39023','1983-05-12','M','U',':RET:2054-5','N','021','DEN','2404065','99734OH005000401','2014-01-01','2013-12-24 19:16:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:46:18'),(13238,10563,'Y','18','021','EC','A','','','AC','0001044049','0001044049','TX00000445367','IL','1','Sorrell','Larry','','','','34','459310286','814 N Llano St',0,'Junction','TX','76849',NULL,'CY','48267','1961-09-01','M','U',':RET:2106-3','N','021','DEN','1650836','33348TX002000201','2014-01-01','2013-12-22 23:24:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:55:59'),(9388,7444,'Y','18','021','EC','A','','','AC','0000987139','0000987139','TX00001043425','IL','1','OBREGON','ELVIRA','','','','34','459949990','1019 COMAL ST',0,'CORPUS CHRIST','TX','78407',NULL,'CY','48355','1950-05-10','F','U',NULL,'N','021','DEN','1708007','33348TX002000201','2014-01-01','2013-12-20 19:57:06','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 04:32:16'),(9425,7477,'N','01','021','EC','A',NULL,NULL,'','0000825449','0000576201','','IL','1','PHAM','LE','','','','34','643889367','3271 SHAVER ST.',0,'PASADENA','TX','77504',NULL,'CY','48201','1982-10-01','F','',':RET:2047-9','N','021','DEN','1418673','33348TX002000201','2014-01-01','2013-12-21 16:50:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:33:14'),(20042,15983,'Y','18','021','EC','A','','','AC','0000153399','0000153399','OH00001620589','IL','1','Meier','Johnathon','','','','34','272982795','203 S Main Street',0,'St Marys','OH','45885',NULL,'CY','39011','1994-12-21','M','U',':RET:2106-3','N','021','HLT','3456519','92036OH003001506','2014-03-01','2014-01-26 10:01:34','94.00',NULL,NULL,'145.95','51.95','R-OH002','OH0','145.95',NULL,0,'2014-01-26 19:00:27'),(24113,19168,'N','01','021','EC','A',NULL,NULL,'','0000011585','0001201411','','IL','1','VASQUEZ','MANUEL','','','','34','264061044','609 9TH ST',0,'WOLFFORTH','TX','79382','2900','CY','48303','1951-11-11','M','',NULL,'N','021','DEN','3014517','33348TX002000201','2014-03-01','2014-02-15 12:57:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-15 22:01:37'),(25271,20050,'Y','18','024','14','A','','','TE','0001968357','0001968357','','IL','1','goldberg','annette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-09-30','F','',NULL,NULL,NULL,'','2172131','','2014-03-31','2014-02-25 15:09:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-25 21:00:12'),(2170,1785,'Y','18','021','EC','A','','','AC','0000713611','0000713611','OH00000468969','IL','1','Vanvelzel','Bruce','','','','34','274541084','9866 BALLANTREE CT',0,'PERRYSBURG','OH','43551','3757','CY','39173','1953-01-01','M','R',NULL,'N','021','HLT','878458','92036OH006002601','2014-01-01','2013-12-09 21:50:08','0.00',NULL,NULL,'434.56','434.56','R-OH001','OH0','434.56',NULL,0,'2013-12-25 19:19:08'),(13882,11075,'N','19','021','EC','A',NULL,NULL,'','0001216261','0000219983','','IL','1','RIEHM','ERIC','','','','34','291948092','19601 BATTERSEA BLVD',0,'ROCKY RIVER','OH','44116','1651','CY','39035','1991-11-21','M','',':RET:2106-3','T','021','HLT','1359839','52664OH151001501','2014-01-01','2013-12-23 15:05:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','346.91',NULL,0,'2013-12-26 13:13:19'),(14757,11782,'N','01','021','EC','A',NULL,NULL,'','0000208514','0001038618','','IL','1','knitz','kimberly','l','','','34','279623155','241 N v ine St',0,'Deshler','OH','43516',NULL,'CY','39069','1966-07-02','F','',':RET:2106-3','N','021','HLT','1879432','92036OH004002601','2014-02-01','2013-12-28 17:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.07',NULL,1,'2013-12-29 11:10:29'),(8013,6342,'N','19','021','EC','A',NULL,NULL,'','0000216090','0000305834','','IL','1','biesenbender','claudia','renee','','','34','300029152','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1998-06-28','F','',':RET:2106-3','N','021','HLT','2430784','92036OH001000601','2014-01-01','2013-12-19 20:48:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-26 03:08:42'),(14380,11470,'Y','18','021','EC','A','','','AC','0000901079','0000901079','OH00000368623','IL','1','Ali','Hassan','','','','34','610587379','1256 CANTERHURST ST',0,'BLACKLICK','OH','43004','7134','CY','39049','1976-01-02','M','M',NULL,'N','021','DEN','2312078','99734OH005000401','2014-02-01','2013-12-27 12:16:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:46'),(21904,17492,'Y','18','021','EC','A','','','AC','0000153408','0000153408','OH00002254702','IL','1','CARTER','AMY','','','','34','281848431','2941 KING RD',0,'TOLEDO','OH','43617','1543','CY','39095','1976-02-20','F','M',':RET:2106-3','N','021','HLT','2656120','92036OH006002601','2014-03-01','2014-02-06 16:13:35','0.00',NULL,NULL,'192.70','192.70','R-OH001','OH0','192.70',NULL,0,'2014-02-06 21:01:49'),(21986,17557,'N','01','021','EC','A',NULL,NULL,'','0001344247','0001172247','','IL','1','Lucido','Angela','','','','34','433415607','11132 HIGHWAY 1063',0,'INDEPENDENCE','LA','70443','3052','CY','22105','1964-05-18','F','',':RET:2106-3','N','021','DEN','3690339','18575LA002000201','2014-03-01','2014-02-06 20:46:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:39'),(22509,17969,'Y','18','021','EC','A','','','AC','0000221341','0000221341','OH00002600902','IL','1','Morgan','Carol','E','','','34','291505072','3171 Preserve Ln',0,'Cincinnati','OH','45239',NULL,'CY','39061','1951-04-11','F','U',':RET:2106-3','N','021','HLT','3145452','92036OH005001205','2014-03-01','2014-02-10 09:30:25','434.00',NULL,NULL,'616.74','182.74','R-OH004','OH0','616.74',NULL,0,'2014-02-10 21:31:17'),(22607,18054,'Y','18','021','EC','A','','','AC','0000298274','0000298274','OH00002393182','IL','1','Laporte','Nick','','','','34','283563982','207 South Reynolds Road',0,'Toledo','OH','43615',NULL,'CY','39095','1954-04-01','M','U',NULL,'N','021','HLT','3827873','92036OH004002601','2014-03-01','2014-02-10 16:30:57','392.00',NULL,NULL,'408.14','16.14','R-OH001','OH0','408.14',NULL,0,'2014-02-10 21:32:18'),(25231,20013,'Y','18','021','EC','A','','','AC','0001076620','0001076620','OH00002435636','IL','1','wagoner','william','','','','34','301563285','759 ROBINSON AVE',0,'AKRON','OH','44319','1433','CY','39153','1956-04-13','M','U',NULL,'N','021','HLT','3022109','52664OH151001305','2014-04-01','2014-02-21 15:35:29','429.00',NULL,NULL,'543.47','114.47','R-OH012','OH0','543.47',NULL,0,'2014-02-21 22:01:02'),(28553,22599,'Y','18','021','EC','A','','','AC','0000435371','0000435371','OH00003328041','IL','1','WALTERS','VICTORIA','','','','34','272888755','4821 MEREDITH RD',0,'YELLOW SPRINGS','OH','45387','9734','CY','39057','1974-08-03','F','M',':RET:2106-3','N','021','HLT','3945359','92036OH006000501','2014-04-01','2014-03-07 12:55:54','228.00',NULL,NULL,'710.70','482.70','R-OH003','OH0','237.90',NULL,0,'2014-03-07 21:32:22'),(13021,10379,'Y','18','021','EC','A','','','AC','0000036995','0000036995','OH00000275654','IL','1','Yez','Dorothy','','','','34','198382626','8200 LORAIN ST SE',0,'MASURY','OH','44438','1127','CY','39155','1960-09-16','F','U',':RET:2106-3','N','021','DEN','1721911','99734OH005000401','2014-01-01','2013-12-22 21:22:36','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 12:50:03'),(9479,7516,'N','01','021','EC','A',NULL,NULL,'','0000399882','0000767389','','IL','1','Bitonte','Tracy','Dawn','','','34','298648097','508 Chatham Court',0,'Pinkerington','OH','43147',NULL,'CY','39045','1969-01-01','F','',':RET:2106-3','N','021','DEN','2396650','99734OH005000401','2014-01-01','2013-12-21 11:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:35'),(4016,3207,'N','01','021','EC','A',NULL,NULL,'','0000803719','0000091118','','IL','1','BOCKIE','ROSELYN','','','','34','615436176','2931 HAU DR',0,'COLUMBUS','OH','43219',NULL,'CY','39049','1983-07-03','F','',':RET:2054-5','N','021','DEN','1858314','99734OH005000401','2014-01-01','2013-12-17 06:32:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:33'),(20909,16713,'Y','18','024','14','A','','','TE','0000050685','0000050685','','IL','1','CRONIN','KEVIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-08','M','',NULL,NULL,NULL,'','1575883','','2014-01-31','2014-01-31 17:13:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:26'),(9075,7202,'N','19','021','EC','A',NULL,NULL,'','0001212335','0001237686','','IL','1','Gohs','Joseph','','','','34','299020479','5202 PARLOR CT',0,'MASON','OH','45040','2935','CY','39165','1997-09-12','M','',NULL,'N','021','DEN','2606601','99734OH005000301','2014-01-01','2013-12-17 19:16:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:06:42'),(7263,5759,'Y','18','021','EC','A','','','AC','0000361689','0000361689','TX00001304873','IL','1','Betty','Jeffrey','','','','34','096642787','410 N MADISON ST',0,'SAN ANGELO','TX','76901','1766','CY','48451','1967-02-24','M','M',':RET:2106-3','N','021','DEN','234756','33348TX002000201','2014-01-01','2013-12-13 22:17:14','0.00',NULL,NULL,'29.22','29.22','R-TX018','TX0','14.61',NULL,0,'2013-12-26 02:02:12'),(4035,3222,'Y','18','021','EC','A','','','AC','0001253517','0001253517','OH00000538906','IL','1','Bushman','Melanie','','','','34','301901303','2954 WARDALL AVE',0,'CINCINNATI','OH','45211','4904','CY','39061','1986-12-24','F','U',':RET:2106-3','N','021','DEN','1570528','99734OH005000401','2014-01-01','2013-12-17 10:01:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:59'),(17736,14172,'Y','18','021','EC','A','','','AC','0000584293','0000584293','OH00002027316','IL','1','Evans','Rebecca','','','','34','275489058','1810 WESTPORT CV',0,'STOW','OH','44224','1515','CY','39153','1950-04-02','F','M',':RET:2106-3','N','021','HLT','2238788','52664OH151001301','2014-02-01','2014-01-13 12:15:09','160.00',NULL,NULL,'658.32','498.32','R-OH012','OH0','658.32',NULL,0,'2014-01-14 01:33:21'),(5483,4353,'Y','18','021','EC','A','','','AC','0000307091','0000307091','OH00000912068','IL','1','KEEFER','TAMMY','M','','','34','286603399','7804 HUWER RD',0,'MARIA STEIN','OH','45860','9794','CY','39107','1968-09-01','F','U',':RET:2106-3','N','021','HLT','2078321','92036OH005001506','2014-01-01','2013-12-19 11:54:16','309.00',NULL,NULL,'317.81','8.81','R-OH002','OH0','317.81',NULL,0,'2013-12-25 23:10:53'),(4051,3235,'Y','18','021','EC','A','','','AC','0000980525','0000980525','OH00000156765','IL','1','Brown','Winfield','','','','34','300462244','6533 STOLL LN',0,'CINCINNATI','OH','45236','4034','CY','39061','1951-03-18','M','M',':RET:2054-5','N','021','DEN','1504198','99734OH005000401','2014-01-01','2013-12-17 14:19:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:24'),(5999,4750,'Y','18','021','EC','A','','','AC','0000528123','0000528123','LA00000204893','IL','1','Brown','April','','','','34','438671252','3910 Kirkman Street',0,'Lake Charles','LA','70607',NULL,'CY','22019','1975-04-10','F','R',':RET:2106-3','N','021','DEN','1205563','18575LA002000201','2014-01-01','2013-11-30 21:23:34','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 00:00:18'),(24874,19722,'Y','18','021','EC','A','','','AC','0000475967','0000475967','OH00002571531','IL','1','Hurst','Susan','Kay','','','34','290481629','21395 COUNTY ROAD U',0,'NAPOLEON','OH','43545','9407','CY','39069','1953-07-04','F','M',':RET:2106-3','N','021','DEN','3051339','99734OH005000401','2014-04-01','2014-02-19 11:20:30','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00','CIC',0,'2014-02-20 05:34:05'),(27617,21842,'Y','18','024','14','A','','','TE','0000932448','0000932448','','IL','1','Lee','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-02-11','F','',NULL,NULL,NULL,'','1793327','','2014-01-21','2014-03-05 14:54:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:31'),(27645,21867,'Y','18','021','EC','A','','','AC','0000614175','0000614175','OH00003352169','IL','1','Jackson','Lisa','','','','34','107427033','763 East Reagan Parkway',0,'Medina','OH','44256',NULL,'CY','39103','1966-09-26','F','U',':RET:2106-3','N','021','DEN','3141351','99734OH005000401','2014-04-01','2014-03-05 12:35:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:18'),(28740,22746,'Y','18','021','EC','A','','','AC','0001684543','0001684543','LA00002620450','IL','1','Higgins','Timothy','','','','34','421378182','152 LIVE OAK BLVD',0,'MANDEVILLE','LA','70471','3029','CY','22103','1991-05-10','M','U',':RET:2106-3','N','021','DEN','3528872','18575LA002000201','2014-04-01','2014-03-08 23:09:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-09 21:00:09'),(460,375,'Y','18','021','EC','A','','','AC','0000912927','0000912927','OH00000518742','IL','1','Saenz','Martin','','','','34','457235077','1900 PARKWOOD DR NW',0,'WARREN','OH','44485','2323','CY','39155','1960-10-06','M','U',':RET:2106-3','T','021','HLT','836699','52664OH151001306','2014-01-01','2013-12-04 05:17:45','433.00',NULL,NULL,'593.29','160.29','R-OH013','OH0','593.29',NULL,0,'2013-12-25 17:47:35'),(13487,10754,'N','19','021','EC','A',NULL,NULL,'','0001205814','0000943423','','IL','1','McGuinness','Kylie','M','','','34','278113663','8770 HILLTOP DR',0,'MENTOR','OH','44060','1932','CY','39085','2005-03-30','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','1533151','99734OH005000301','2014-01-01','2013-12-23 18:04:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:22'),(3638,2911,'Y','18','021','EC','A','','','AC','0001194653','0001194653','MS00000756817','IL','1','TAYLOR','MAXINE','','','','34','427049362','369 E ACADEMY ST',0,'CANTON','MS','39046','4601','CY','28089','1953-04-03','F','M',':RET:2054-5','N','021','DEN','391515','46300MS002000201','2014-01-01','2013-12-13 11:22:11','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:17'),(24531,19486,'Y','18','021','EC','A','','','AC','0000011603','0000011603','TX00002883167','IL','1','Rodriguez','Bernarda','','','','34','643821123','2512 S INDIA AVE',0,'LAREDO','TX','78046','6947','CY','48479','1960-08-20','F','M',NULL,'N','021','DEN','2738101','33348TX002000201','2014-04-01','2014-02-19 16:53:58','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2014-02-20 04:00:29'),(14542,11603,'N','01','021','EC','A',NULL,NULL,'','0001213447','0000459797','','IL','1','MYERS','ROBERT','','','','34','428278015','6825 S SIWELL RD',0,'BYRAM','MS','39272','8701','CY','28049','1974-07-24','M','',':RET:2054-5','N','021','DEN','2009582','46300MS002000201','2014-02-01','2013-12-27 13:36:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-28 03:34:48'),(24363,19350,'N','19','021','EC','A',NULL,NULL,'','0002008031','0001814447','','IL','1','MIDENCE','MICHAEL','','','','34','435792982','29 TRAMINER DR',0,'KENNER','LA','70065',NULL,'CY','22051','1990-06-27','M','',NULL,'N','021','DEN','3745364','18575LA002000201','2014-04-01','2014-02-18 11:02:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-18 22:00:33'),(14884,11887,'Y','18','021','EC','A','','','AC','0001274270','0001274270','LA00000172376','IL','1','Guillen','Eddy','Villalta','','','34','587851925','918 BOURBON ST',0,'NEW ORLEANS','LA','70116','3121','CY','22071','1965-11-18','M','U',':RET:2106-3','N','021','DEN','2588975','18575LA002000201','2014-02-01','2013-12-28 18:28:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:38'),(15639,12510,'Y','18','021','EC','A','','','AC','0001160631','0001160631','MS00001396117','IL','1','Bui','Van','','','','34','586145273','7120 GREENBRIAR ST',0,'OCEAN SPRINGS','MS','39564','9311','CY','28059','1960-04-24','F','M',':RET:2047-9','N','021','DEN','2282017','46300MS002000201','2014-02-01','2013-12-30 20:49:37','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,1,'2014-01-02 04:33:46'),(29010,22961,'Y','18','021','EC','A','','','AC','0000848418','0000848418','OH00002813274','IL','1','Rickett','Katherine','','','','34','295785412','132 KEYSTONE RD',0,'VINTON','OH','45686','9073','CY','39053','1971-09-14','F','M',':RET:2106-3','N','021','DEN','4367183','99734OH005000401','2014-04-01','2014-03-09 19:53:57','0.00',NULL,NULL,'50.05','50.05','R-OH010','OH0','0.00',NULL,0,'2014-03-10 21:01:24'),(16426,13143,'Y','18','021','EC','A','','','AC','0000605971','0000605971','OH00001879834','IL','1','GREEN','DEBORAH','','','','34','295506434','797 DECADE LN',0,'LOVELAND','OH','45140','7501','CY','39025','1953-05-03','F','M',':RET:2106-3','N','021','HLT','2051389','92036OH003000605','2014-02-01','2014-01-06 13:47:39','425.00',NULL,NULL,'608.42','183.42','R-OH005','OH0','608.42',NULL,0,'2014-01-07 04:04:38'),(23217,18508,'Y','18','021','EC','A','','','AC','0000880510','0000880510','MS00001776031','IL','1','Diamond','Sheena','','','','34','427473345','708 GEORGE WASHINGTON AVE',0,'CANTON','MS','39046','3402','CY','28089','1983-07-25','F','U',':RET:2054-5','N','021','DEN','2966444','46300MS002000201','2014-03-01','2014-02-12 15:27:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-12 21:32:17'),(20675,16522,'Y','18','024','14','A','','','TE','0000995093','0000995093','','IL','1','GWYN','KEVIN','ANDREW',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-11-19','M','',NULL,NULL,NULL,'','609324','','2014-01-29','2014-01-29 19:42:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-30 21:00:52'),(25395,20146,'N','01','021','EC','A',NULL,NULL,'','0000307147','0000396212','','IL','1','Mohr','Jeffrey','','','','34','296540700','5612 Brentwood Avenue NW',0,'North Canton','OH','44720',NULL,'CY','39151','1967-11-16','M','',NULL,'N','021','HLT','3677245','52664OH151001304','2014-04-01','2014-02-25 12:12:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.51',NULL,0,'2014-02-25 21:30:53'),(1580,1318,'N','01','021','EC','A',NULL,NULL,'','0000001133','0000935286','','IL','1','Leija','Narcizo','Tovar','','','34','630763652','1701 W MESA PARK DR',0,'ROUND ROCK','TX','78664','3157','CY','48491','1970-03-18','M','',':RET:2106-3','N','021','DEN','1633491','33348TX002000201','2014-01-01','2013-12-24 10:32:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:51:25'),(13648,10887,'Y','18','021','EC','A','','','AC','0001250715','0001250715','LA00000338343','IL','1','Tademy','Charnell','','','','34','439797011','4110 BEECH ST',0,'BATON ROUGE','LA','70805','2903','CY','22033','1990-10-05','F','U',':RET:2054-5','N','021','DEN','2390177','18575LA002000101','2014-01-01','2013-12-22 19:15:35','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 13:07:12'),(23623,18812,'Y','18','021','EC','A','','','AC','0000097619','0000097619','OH00002284612','IL','1','Vayda','Michael','Scott','','','34','280742980','42 E LORAIN ST',0,'OBERLIN','OH','44074','1128','CY','39093','1962-10-04','M','M',':RET:2106-3','N','021','HLT','3227163','92036OH005000806','2014-03-01','2014-02-13 16:36:11','620.00',NULL,NULL,'818.31','198.31','R-OH011','OH0','436.05',NULL,0,'2014-02-13 22:03:18'),(13433,10716,'Y','18','021','EC','A','','','AC','0000846132','0000846132','OH00000621721','IL','1','KOHR','DIANA','','','','34','274542984','3005 OGDEN DR',0,'MIDDLETOW','OH','45044',NULL,'CY','39017','1955-04-25','F','M',':RET:2106-3','N','021','DEN','1828615','99734OH005000301','2014-01-01','2013-12-23 12:55:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:05'),(3730,2981,'Y','18','021','EC','A','','','AC','0000907609','0000907609','TX00000244254','IL','1','tyrone','lauren','','','','34','466796585','1105 W 9TH ST',0,'HEARNE','TX','77859','2011','CY','48395','1986-12-10','F','U',':RET:2054-5','N','021','DEN','189977','33348TX002000201','2014-01-01','2013-12-12 18:46:26','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 21:32:34'),(4251,3386,'Y','18','021','EC','A','','','AC','0002174982','0002174982','NC00000305050','IL','1','CONRAD','PATRICIA','','','','34','130620185','114 SYCAMORE SLOPE LANE',0,'MOORESVILLE','NC','78117',NULL,'CY','48255','1964-01-13','F','U',':RET:2106-3','N','021','DEN','2225022','33348TX002000201','2014-01-01','2013-12-17 14:22:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','NC0','14.61',NULL,0,'2013-12-25 21:51:17'),(4369,3471,'Y','18','021','EC','A','','','AC','0000645956','0000645956','OH00000061025','IL','1','Colegrove','Carl','','','','34','282649727','493 CATLIN DR',0,'RICHMOND HEIGHTS','OH','44143','2529','CY','39035','1959-03-04','M','R',':RET:2106-3','N','021','DEN','893850','99734OH005000401','2014-01-01','2013-12-11 21:23:05','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:15'),(4494,3561,'N','01','021','EC','A',NULL,NULL,'','0001235250','0000003510','','IL','1','Flores','Jose','Guadalupe','','Jr','34','459478302','462 Patricia Ave',0,'Mercedes','TX','78570',NULL,'CY','48215','1979-08-12','M','',':RET:2106-3','N','021','DEN','163963','33348TX002000201','2014-01-01','2013-12-11 18:43:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:03:12'),(23337,18601,'Y','18','021','EC','A','','','AC','0001016891','0001016891','OH00002352536','IL','1','mccandless','Lawren','','','','34','167602850','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1962-10-20','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3403625','99734OH005000301','2014-03-01','2014-02-12 18:47:51','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-02-13 22:00:35'),(4731,3749,'Y','18','021','EC','A','','','AC','0001014355','0001014355','OH00001255157','IL','1','KEVER','JANET','S','','','34','311500334','215 E RAYMOND ST',0,'VAN WERT','OH','45891',NULL,'CY','39161','1951-09-15','F','M',':RET:2106-3','N','021','HLT','863153','92036OH003001501','2014-01-01','2013-12-12 15:37:01','523.00',NULL,NULL,'890.15','367.15','R-OH002','OH0','660.32',NULL,0,'2013-12-25 22:09:10'),(22019,17580,'Y','18','024','14','A','','','TE','0001023170','0001023170','','IL','1','Pangelinan','Brenda','Marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-10','F','',NULL,NULL,NULL,'','2346493','','2014-02-21','2014-02-06 21:47:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-07 19:00:57'),(17851,14260,'Y','18','021','EC','A','','','AC','0000809692','0000809692','OH00001994956','IL','1','Otto','Catherine','','','','34','343629800','21 RINGGOLD ST',0,'DAYTON','OH','45403','1814','CY','39113','1975-08-29','F','U',':RET:2106-3','N','021','DEN','1579084','99734OH005000401','2014-02-01','2014-01-14 10:33:37','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:07'),(17268,13813,'Y','18','021','EC','A','','','AC','0000615526','0000615526','OH00001745899','IL','1','Fraser','Melissa','','','','34','232044454','801 Leisure Lane',0,'Medina','OH','44256',NULL,'CY','39103','1973-01-07','F','U',':RET:2106-3','N','021','HLT','2501358','52664OH152000901','2014-02-01','2014-01-09 18:18:29','0.00',NULL,NULL,'212.67','212.67','R-OH012','OH0','212.67',NULL,0,'2014-01-13 02:23:20'),(5442,4323,'Y','18','024','14','A','','','TE','0001633542','0001633542','','IL','1','CHAKRAVARTY','INDRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-18','F','',NULL,NULL,NULL,'','2551857','','2013-12-19','2013-12-19 17:03:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 23:09:57'),(6940,5511,'Y','18','021','EC','A','','','AC','0000378580','0000378580','OH00001192428','S3','1','Enoch','Vanessa','Serenity','','','34','270069384','8172 MISTY SHORE DR',0,'WEST CHESTER','OH','45069','9240','CY','39017','2000-10-13','F','U',':RET:2054-5','N','021','DEN','2060762','99734OH005000401','2014-01-01','2013-12-24 20:25:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-26 01:46:47'),(27208,21542,'N','01','021','EC','A',NULL,NULL,'','0000223750','0001228118','','IL','1','Kuohn','Daniel','E','','','34','279428432','905 EVESHAM AVE',0,'TOLEDO','OH','43607','3748','CY','39095','1958-10-23','M','',NULL,'T','021','HLT','3071260','92036OH004002601','2014-04-01','2014-03-03 11:47:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','402.10',NULL,0,'2014-03-03 21:31:26'),(27689,21898,'Y','18','024','14','A','','','TE','0000792429','0000792429','','IL','1','Harris','Blake',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-30','M','',NULL,NULL,NULL,'','3675181','','2014-03-05','2014-03-05 09:45:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:43'),(28702,22715,'Y','18','021','EC','A','','','AC','0000816491','0000816491','OH00003461588','IL','1','FRAZEE','LYNN','','','','34','272564271','2488 DONNA DR',0,'RICHFEILD','OH','44286',NULL,'CY','39153','1954-06-19','M','U',':RET:2106-3','N','021','HLT','4144277','52664OH151001305','2014-04-01','2014-03-07 19:42:47','466.00',NULL,NULL,'580.49','114.49','R-OH012','OH0','580.49',NULL,0,'2014-03-08 21:31:10'),(857,710,'Y','18','021','EC','A','','','AC','0001094629','0001094629','OH00001145729','IL','1','Carmichael','Debra','','','','34','300424546','7548 FORT AMANDA RD',0,'LIMA','OH','45806','9332','CY','39003','1953-11-12','F','M',':RET:2106-3','N','021','HLT','1411122','92036OH005001501','2014-01-01','2013-12-16 15:00:02','986.00',NULL,NULL,'1324.45','338.45','R-OH002','OH0','597.30',NULL,0,'2013-12-25 18:07:03'),(3861,3091,'Y','18','024','14','A','','','TE','0001048122','0001048122','','IL','1','reeves','laurie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-20','F','',NULL,NULL,NULL,'','1198165','','2013-12-12','2013-12-12 20:27:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:35:56'),(6035,4779,'Y','18','021','EC','A','','','AC','0000059169','0000059169','LA00001057040','IL','1','Smith','Michael','M','','','34','146449682','9318 GREAT SMOKEY AVE',0,'BATON ROUGE','LA','70814','2611','CY','22033','1959-11-04','M','U',':RET:2106-3','N','021','DEN','36687','18575LA002000101','2014-01-01','2013-12-01 13:10:01','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 00:01:15'),(22609,18055,'N','01','021','EC','A',NULL,NULL,'','0000832034','0000909516','','IL','1','Hunter','Leah','P','','','34','288627425','2366 St. Johns Road',0,'Wakeman','OH','44889',NULL,'CY','39077','1957-05-19','F','',':RET:2106-3','N','021','HLT','3808130','92036OH003002705','2014-03-01','2014-02-10 17:44:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.07',NULL,0,'2014-02-10 21:32:19'),(19458,15510,'Y','18','021','EC','A','','','AC','0001213185','0001213185','TX00001918296','IL','1','Ngezelonye','Austen','','','','34','633983070','8418 SAILORS ST',0,'ROWLETT','TX','75089','9135','CY','48113','1953-08-02','M','U',NULL,'N','021','DEN','2713741','33348TX002000201','2014-03-01','2014-01-21 20:54:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 03:01:55'),(7726,6119,'Y','18','021','EC','A','','','AC','0000569305','0000569305','OH00000804144','IL','1','Queen','Debbie','','','','34','281507975','366 E MAIN ST',0,'POMEROY','OH','45769','1023','CY','39105','1950-06-09','F','M',':RET:2106-3','N','021','DEN','1473824','99734OH005000401','2014-01-01','2013-12-20 14:25:11','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 03:01:52'),(19025,15152,'Y','18','021','EC','A','','','AC','0000038177','0000038177','MS00001850299','IL','1','Eddington','Amanda','','','','34','604405824','6430 FORESTGATE RD',0,'HORN LAKE','MS','38637','2120','CY','28033','1990-02-02','F','U',':RET:2106-3','N','021','DEN','1573020','46300MS002000101','2014-03-01','2014-01-17 12:41:03','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-20 08:06:28'),(18504,14759,'Y','18','021','EC','A','','','AC','0000529466','0000529466','OH00001932323','IL','1','Goodell','Bruce','','','','34','274461408','9370 Peck Road',0,'Mantua','OH','44255',NULL,'CY','39133','1952-05-16','M','M',NULL,'N','021','HLT','2619341','52664OH151001305','2014-02-01','2014-01-15 15:40:00','966.00',NULL,NULL,'1253.30','287.30','R-OH012','OH0','626.65',NULL,0,'2014-01-16 08:46:31'),(22287,17792,'Y','18','021','EC','A','','','AC','0000519864','0000519864','OH00001959043','IL','1','Woo','Brandon','Michael','','','34','290602298','10888 PARKER LANE RD',0,'GEORGETOWN','OH','45121','9253','CY','39015','1971-03-17','M','U',':RET:2034-7^:RET:2106-3','N','021','DEN','1363373','99734OH005000401','2014-03-01','2014-01-21 08:03:21','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-10 11:00:26'),(28327,22414,'Y','18','021','EC','A','','','AC','0000872922','0000872922','TX00003398403','IL','1','Denbow','Jayna','E','','','34','631178733','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1979-02-20','F','M',':RET:2106-3','N','021','DEN','3682816','33348TX002000201','2014-04-01','2014-03-07 00:30:47','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:08'),(15017,12003,'N','01','021','EC','A',NULL,NULL,'','0000843344','0000038395','','IL','1','kanuckle','brant','','','','34','276885692','1817 state route 83',0,'millersburg','OH','44654',NULL,'CY','39075','1981-05-04','M','',NULL,'N','021','HLT','1647404','52664OH151001306','2014-02-01','2013-12-30 18:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','263.82',NULL,0,'2014-01-01 12:02:10'),(14490,11560,'Y','18','021','EC','A','','','AC','0000465740','0000465740','TX00000241140','IL','1','Lara','Mary','','','','34','452193837','1004 North Fanin',0,'Cameron','TX','76520',NULL,'CY','48331','1956-08-14','F','U',':RET:2106-3','N','021','DEN','1408051','33348TX002000201','2014-02-01','2013-12-27 11:00:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:30'),(2248,1845,'Y','18','021','EC','A','','','AC','0000481047','0000481047','OH00000510388','31','1','Garner','James','','','','34','287464855','1277 W Main St',0,'Wilmington','OH','45177',NULL,'CY','39027','1951-07-16','M','U',':RET:2106-3','N','021','HLT','685900','92036OH003000601','2014-01-01','2013-12-10 17:49:08','0.00',NULL,NULL,'644.07','644.07','R-OH005','OH0','644.07',NULL,0,'2013-12-25 19:21:11'),(13216,10546,'Y','18','021','EC','A','','','AC','0000553050','0000553050','TX00001148836','IL','1','Legg','Michael','','','','34','591706615','227 RED HAWK RDG',0,'SAN ANTONIO','TX','78258','4866','CY','48029','1955-02-17','M','M',':RET:2106-3','N','021','DEN','1980234','33348TX002000201','2014-01-01','2013-12-22 19:03:02','0.00',NULL,NULL,'82.05','82.05','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:55:23'),(3675,2941,'Y','18','021','EC','A','','','AC','0000902192','0000902192','OH00000507075','IL','1','Hollingsworth','Lauvern','','','','34','132645646','6204 taywood rd',0,'englewood','OH','45322',NULL,'CY','39113','1969-12-24','F','U',':RET:2054-5','N','021','DEN','252184','99734OH005000401','2014-01-01','2013-12-12 22:32:14','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:31:17'),(23383,18633,'Y','18','021','EC','A','','','AC','0001176889','0001176889','OH00002209982','IL','1','Zecher','Matthew','J','','','34','297623925','1717 HOPKINS AVE',0,'CINCINNATI','OH','45212','2809','CY','39061','1973-04-27','M','U',':RET:2106-3','N','021','DEN','3264473','99734OH005000401','2014-03-01','2014-02-13 13:46:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:01:00'),(23879,18999,'Y','18','021','EC','A','','','AC','0000342770','0000342770','OH00002795898','IL','1','Fioritto','Pamela','A','','','34','273645511','1512 SUNVIEW RD',0,'LYNDHURST','OH','44124','2839','CY','39035','1957-10-29','F','U',':RET:2106-3','N','021','HLT','3092314','52664OH151001501','2014-03-01','2014-02-14 16:39:45','244.00',NULL,NULL,'703.78','459.78','R-OH011','OH0','703.78',NULL,0,'2014-02-14 21:32:13'),(27784,21974,'Y','18','021','EC','A','','','AC','0000415747','0000415747','MS00002848555','IL','1','Cole','Bathsheba','','','','34','587411965','5008 HUNTINGTON DR',0,'GAUTIER','MS','39553','4455','CY','28059','1979-07-02','F','U',':RET:2054-5','N','021','DEN','3736337','46300MS002000201','2014-04-01','2014-03-04 19:26:19','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-03-05 21:31:36'),(28441,22504,'Y','18','021','EC','A','','','AC','0002184678','0002184678','LA00002742052','IL','1','Claudet','Georgius','','','','34','435861544','2332 CHAMPAGNE ST',0,'MARRERO','LA','70072','5326','CY','22051','1951-08-09','F','U',':RET:2106-3','N','021','DEN','3770914','18575LA002000201','2014-04-01','2014-03-06 19:21:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:13'),(29142,23069,'Y','18','021','EC','A','','','AC','0001156261','0001156261','OH00003188020','IL','1','Emery','Karen','','','','34','369564919','5626 ELLIOTT DR',0,'SYLVANIA','OH','43560','2063','CY','39095','1951-05-15','F','U',':RET:2106-3','N','021','HLT','4196855','92036OH005002605','2014-04-01','2014-03-10 15:10:32','372.00',NULL,NULL,'560.22','188.22','R-OH001','OH0','560.22',NULL,0,'2014-03-10 21:02:43'),(148,125,'N','19','021','EC','A',NULL,NULL,'','0000204539','0000616841','','IL','1','Beal','Erica','','','','34','287961974','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1993-08-20','F','',':RET:2106-3','N','021','HLT','217583','52664OH152000901','2014-01-01','2013-12-05 12:07:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 17:18:52'),(2395,1955,'Y','18','021','EC','A','','','AC','0000034346','0000034346','OH00000298650','IL','1','Siffel','Gloria','Ann','','','34','402684482','6225 Savannah Ave',0,'Cincinati','OH','45224',NULL,'CY','39061','1949-04-29','F','U',':RET:2054-5','N','021','DEN','1113318','99734OH005000401','2014-01-01','2013-12-09 12:34:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:22'),(19295,15381,'Y','18','021','EC','A','','','AC','0002038960','0002038960','LA00002560506','IL','1','WHITE','MICHAEL','','','','34','437597174','3971 RIVER RD',0,'GILBERT','LA','71336','4711','CY','22041','1972-03-20','M','U',':RET:2106-3','T','021','DEN','2204979','18575LA002000201','2014-03-01','2014-01-21 10:45:19','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,1,'2014-01-22 03:21:57'),(18802,14975,'Y','18','021','EC','A','','','AC','0000165109','0000165109','OH00002396369','IL','1','RAMSER','RICHARD','','','','34','282542563','2101 LESTER RD',0,'VALLEY CITY','OH','44280','9566','CY','39103','1953-06-26','M','U',':RET:2106-3','N','021','DEN','2120448','99734OH005000401','2014-03-01','2014-01-16 13:16:48','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:36:00'),(18704,14912,'N','01','021','EC','A',NULL,NULL,'','0000937295','0000953264','','IL','1','Zinn','Tonya','','','','34','298607397','7828 Pattonsville Rd',0,'Jackson','OH','45640',NULL,'CY','39079','1977-01-22','F','',NULL,'N','021','DEN','2380451','99734OH005000301','2014-02-01','2014-01-15 18:36:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:29'),(2551,2076,'Y','18','021','EC','A','','','AC','0000626713','0000626713','OH00000277724','IL','1','Audino','Patsy','','','','34','173364864','3516 Hopkins Rd',0,'Youngstown','OH','44511',NULL,'CY','39099','1954-08-14','M','M',':RET:2106-3','T','021','HLT','928700','52664OH151001501','2014-01-01','2013-12-09 16:08:00','1012.00',NULL,NULL,'1615.58','603.58','R-OH013','OH0','907.95',NULL,0,'2013-12-25 19:37:17'),(7505,5937,'Y','18','021','EC','A','','','AC','0000413342','0000413342','OH00000852185','IL','1','dunlap','william','','','','34','296408553','965 LAUREL AVE',0,'CINCINNATI','OH','45246','4522','CY','39061','1956-06-26','M','R',':RET:2106-3','N','021','DEN','649049','99734OH005000401','2014-01-01','2013-12-15 17:33:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:56'),(14254,11368,'Y','18','024','14','A','','','TE','0000439571','0000439571','','IL','1','CALLAHAN','MARK','JAMES','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-07-01','M','',NULL,NULL,NULL,'','315357','','2013-12-26','2013-12-26 08:59:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:05:36'),(20495,16374,'Y','18','021','EC','A','','','AC','0001211616','0001211616','LA00002147586','IL','1','Pham','Toan','Thanh','','','34','627809302','1141 Santa Maria',0,'Marrero','LA','70072',NULL,'CY','22051','1969-05-21','M','M',':RET:2047-9','N','021','DEN','3099134','18575LA002000201','2014-03-01','2014-01-29 11:10:13','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:09'),(20815,16634,'Y','18','021','EC','A','','','AC','0001735389','0001735389','LA00001609797','IL','1','Williams','Derrick','','','','34','437318547','1408 LIVE OAK DR',0,'HAMMOND','LA','70403','3822','CY','22105','1970-10-01','M','U',':RET:2054-5','N','021','DEN','3504220','18575LA002000201','2014-03-01','2014-01-30 18:37:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-31 21:00:31'),(21783,17395,'N','01','021','EC','A',NULL,NULL,'','0000847186','0000957934','','IL','1','Loomis','Katrina','Y','','','34','292700706','5626 Summerville Dr',0,'Galloway','OH','43119',NULL,'CY','39049','1968-12-09','F','',':RET:2054-5','N','021','DEN','3376436','99734OH005000401','2014-03-01','2014-02-05 23:29:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:00:39'),(22465,17937,'Y','18','024','14','A','','','TE','0000100964','0000100964','','IL','1','Granoff','Harry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-24','M','',NULL,NULL,NULL,'','2169882','','2014-02-10','2014-02-10 18:19:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:30:54'),(24469,19438,'Y','18','021','EC','A','','','AC','0000653250','0000653250','OH00002087567','IL','1','ST GERMAIN','REBECCA','','','','34','291487182','1822 JERMAIN DR',0,'TOLEDO','OH','43606','4038','CY','39095','1950-05-26','F','M',':RET:2106-3','N','021','HLT','3512669','92036OH004002601','2014-04-01','2014-02-18 12:21:33','615.00',NULL,NULL,'933.21','318.21','R-OH001','OH0','462.84',NULL,0,'2014-02-18 22:01:37'),(25279,20056,'N','01','021','EC','A',NULL,NULL,'','0000543705','0000027243','','IL','1','STACK','MARY','','','','34','635328945','8113 SUN MEADOWS CT',0,'FORT WORTH','TX','76123','1960','CY','48439','1960-08-27','F','',NULL,'N','021','DEN','3643899','33348TX002000201','2014-03-01','2014-02-25 13:32:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85','CIC',0,'2014-02-25 21:00:16'),(27779,21969,'Y','18','021','EC','A','','','AC','0000979353','0000979353','OH00003325553','IL','1','Jackson','Lisa','','','','34','107427033','763 East Reagan Parkway',0,'Medina','OH','44256',NULL,'CY','39103','1966-09-26','F','U',':RET:2106-3','N','021','HLT','3756259','52664OH152000901','2014-04-01','2014-03-05 12:35:44','0.00',NULL,NULL,'255.30','255.30','R-OH012','OH0','255.30',NULL,0,'2014-03-05 21:31:32'),(1363,1129,'Y','18','021','EC','A','','','AC','0001053422','0001053422','TX00001615933','IL','1','bonilla barrera','luis','','','','34','643135944','6628 PARQUE DEL SOL',0,'EL PASO','TX','79911','3050','CY','48141','1981-04-29','M','M',NULL,'N','021','DEN','1609421','33348TX002000101','2014-01-01','2013-12-24 14:39:53','0.00',NULL,NULL,'50.04','50.04','R-TX009','TX0','25.02',NULL,0,'2013-12-25 18:45:33'),(5256,4168,'N','01','021','EC','A',NULL,NULL,'','0001212337','0001171875','','IL','1','Haffner','Pamela','','','','34','294548508','6898 GREENBRIAR DR',0,'PARMA HEIGHTS','OH','44130','4661','CY','39035','1953-10-04','F','',':RET:2106-3','N','021','HLT','2069214','52664OH151001305','2014-01-01','2013-12-19 10:05:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','682.62',NULL,0,'2013-12-25 23:05:14'),(5065,4014,'Y','18','021','EC','A','','','AC','0000576179','0000576179','TX00000514445','31','1','Gonzales','Angelica','','','','34','450939559','6202 Vera Lane',0,'Austin','TX','78741',NULL,'CY','48453','1981-08-20','F','U',':RET:2106-3','N','021','DEN','2206666','33348TX002000201','2014-01-01','2013-12-19 10:41:02','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:00:33'),(19159,15265,'Y','18','021','EC','A','','','AC','0000426463','0000426463','OH00001409746','IL','1','BOLING','RUTH ANN','','','','34','300485249','62 N ERIE BEACH RD',0,'LAKESIDE','OH','43440',NULL,'CY','39123','1950-04-04','F','M',':RET:2106-3','N','021','DEN','2713702','99734OH005000301','2014-03-01','2014-01-19 11:54:03','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2014-01-21 08:45:40'),(2063,1688,'N','01','021','EC','A',NULL,NULL,'','0000054443','0000769968','','IL','1','Jolliff','William','Heath','','Sr','34','287762514','320 Liberty Street',0,'Ada','OH','45810',NULL,'CY','39065','1980-09-19','M','',':RET:2106-3','N','021','DEN','364254','99734OH005000301','2014-01-01','2013-12-10 14:53:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:16:09'),(17705,14148,'Y','18','021','EC','A','','','AC','0001782985','0001782985','LA00001709054','IL','1','McCConnell','Faye','','','','34','435111175','2005 ROGGERSON RD',0,'MONROE','LA','71201','5050','CY','22073','1965-03-10','F','U',NULL,'N','021','DEN','2335626','18575LA002000201','2014-02-01','2014-01-13 14:12:00','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-14 01:33:06'),(13078,10426,'Y','18','021','EC','A','','','AC','0000082525','0000082525','OH00000376397','IL','1','Bolin-Devore','Tenaya','Erica','','','34','302725611','1300 4TH ST',0,'LOGAN','OH','43138','1049','CY','39073','1969-05-13','F','M',NULL,'N','021','DEN','1526877','99734OH005000401','2014-01-01','2013-12-23 10:40:19','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2013-12-26 12:51:30'),(23557,18768,'Y','18','021','EC','A','','','AC','0001236630','0001236630','OH00002477452','IL','1','OVIAHON','NOSA','','','','34','296981617','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1968-01-15','M','M',':RET:2054-5','N','021','HLT','3515021','92036OH005002604','2014-03-01','2014-02-13 12:34:49','492.00',NULL,NULL,'863.97','371.97','R-OH001','OH0','292.49',NULL,0,'2014-02-13 22:02:42'),(25595,20306,'Y','18','024','14','A','','','TE','0000088637','0000088637','','IL','1','Willis','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-12-05','F','',NULL,NULL,NULL,'','3662935','','2014-02-24','2014-02-24 16:27:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-02-26 08:00:46'),(26973,21369,'N','01','021','EC','A',NULL,NULL,'','0001252181','0000829335','','IL','1','Randles','Anne','L','','','34','294445522','552 PICADILLY CIR',0,'AKRON','OH','44319','1377','CY','39153','1956-09-06','F','',':RET:2106-3','N','021','HLT','2639465','52664OH152000901','2014-05-01','2014-03-02 07:47:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.06',NULL,0,'2014-03-03 01:00:35'),(29029,22975,'N','01','021','EC','A',NULL,NULL,'','0000148405','0001187704','','IL','1','Hogan','Kyle','D','','','34','615288549','2549 S HARBOR DR',0,'MAINEVILLE','OH','45039','9318','CY','39165','1986-06-13','M','',':RET:2106-3','N','021','DEN','3894223','99734OH005000401','2014-04-01','2014-03-10 11:10:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:34'),(546,447,'Y','18','021','EC','A','','','AC','0000079880','0000079880','OH00001025433','IL','1','Compton','Gary','','','','34','555984837','633 HILBISH AVE',0,'AKRON','OH','44312','2249','CY','39153','1953-10-09','M','M',NULL,'N','021','HLT','369057','52664OH152000901','2014-01-01','2013-12-04 13:10:01','314.00',NULL,NULL,'443.31','129.31','R-OH012','OH0','443.31',NULL,0,'2013-12-25 17:49:52'),(3103,2493,'Y','18','021','EC','A','','','AC','0000053033','0000053033','OH00000844906','IL','1','Tomanicek','Marcia','','','','34','291587280','5523 MCLAIN DR',0,'SYLVANIA','OH','43560','2513','CY','39095','1956-01-30','F','M',':RET:2106-3','N','021','HLT','784348','92036OH006002601','2014-01-01','2013-12-06 15:42:37','0.00',NULL,NULL,'376.87','376.87','R-OH001','OH0','376.87',NULL,0,'2013-12-25 20:20:20'),(6098,4834,'Y','18','021','EC','A','','','AC','0000495421','0000495421','OH00000247987','IL','1','Dirr','Timothy','','','','34','286621629','3111 Fairfield Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1963-04-24','M','U',NULL,'N','021','DEN','1046060','99734OH005000401','2014-01-01','2013-11-20 22:48:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:15:08'),(14895,11897,'Y','18','021','EC','A','','','AC','0001546826','0001546826','LA00001699869','IL','1','bell','reginald','','','','34','434115499','3870 OZARK ST',0,'BATON ROUGE','LA','70805','5943','CY','22033','1964-01-09','M','U',':RET:2054-5','N','021','DEN','2322122','18575LA002000201','2014-02-01','2013-12-29 12:05:25','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-30 00:00:55'),(15795,12643,'Y','18','021','EC','A','','','AC','0001755270','0001755270','LA00002240011','IL','1','Ryan','Martha','','','','34','224724983','1306 PARK AVE',0,'MONROE','LA','71201','3334','CY','22073','1959-03-25','F','U',':RET:2106-3','N','021','DEN','1620254','18575LA002000201','2014-02-01','2014-01-02 16:52:30','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-03 02:02:39'),(21291,17013,'Y','18','021','EC','A','','','AC','0001429874','0001429874','LA00002174302','IL','1','Vault','Vinetta','','','','34','438883868','506 JASMINE ST',0,'JONESVILLE','LA','71343','2533','CY','22025','1949-07-16','F','M',':RET:2054-5','N','021','DEN','3657823','18575LA002000101','2014-03-01','2014-02-04 11:26:48','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-04 21:00:06'),(25922,20557,'Y','18','021','EC','A','','','AC','0000755580','0000755580','TX00002946497','IL','1','CASTILLO','ELENA','M','','','34','461457532','1519 GRAND MESA DR',0,'ODESSA','TX','79761','6841','CY','48135','1966-09-22','F','U',NULL,'N','021','DEN','3809972','33348TX002000201','2014-03-01','2014-02-26 15:48:41','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-02-26 21:01:21'),(26399,20938,'Y','18','024','14','A','','','TE','0000042085','0000042085','','IL','1','Older','Naz',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-01-26','F','',NULL,NULL,NULL,'','2660420','','2014-02-26','2014-02-26 15:04:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:00:30'),(27355,21663,'Y','18','021','EC','A','','','AC','0000501673','0000501673','OH00002482687','IL','1','goings','tyrone','','','','34','280709201','1220 E 74TH ST',0,'CLEVELAND','OH','44103','1905','CY','39035','1963-03-29','M','U',':RET:2054-5','N','021','DEN','3313012','99734OH005000401','2014-04-01','2014-03-04 14:51:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:08'),(3764,3012,'Y','18','021','EC','A','','','AC','0000846127','0000846127','OH00001079602','IL','1','Liotta','Kathleen','','','','34','273483631','117 BOULDER BLVD',0,'PENINSULA','OH','44264','9597','CY','39153','1949-09-10','F','U',':RET:2106-3','N','021','HLT','426032','52664OH151001306','2014-01-01','2013-12-13 12:23:51','557.00',NULL,NULL,'669.00','112.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 21:33:30'),(20247,16156,'Y','18','021','EC','A','','','AC','0000122941','0000122941','TX00001456660','IL','1','Arellano','Patricia','','','','34','466988770','7951 BOSQUE RD',0,'CANUTILLO','TX','79835','7402','CY','48141','1953-11-11','F','M',':RET:2106-3','N','021','DEN','3300023','33348TX002000101','2014-03-01','2014-01-28 11:10:54','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-01-28 21:00:11'),(20079,16017,'N','01','021','EC','A',NULL,NULL,'','0001059944','0000047298','','IL','1','Nguyen','Destinie','','','','34','457635688','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1970-09-30','F','',':RET:2047-9','N','021','DEN','2886948','33348TX002000201','2014-03-01','2014-01-27 17:29:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-27 21:00:22'),(17176,13743,'Y','18','021','EC','A','','','AC','0000890768','0000890768','OH00001419182','IL','1','COLE','KIMBERLY','DAWN','','','34','271725083','6714 ALBER AVE',0,'PARMA','OH','44129',NULL,'CY','39035','1970-11-06','F','U',':RET:2106-3','N','021','DEN','2347319','99734OH005000301','2014-02-01','2014-01-08 07:29:38','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:22:10'),(3655,2924,'N','01','021','EC','A',NULL,NULL,'','0000460565','0000201906','','IL','1','Bosch','Joseph','','','','34','271829497','451 MONROE ST',0,'CONNEAUT','OH','44030','2548','CY','39007','1981-08-31','M','',':RET:2106-3','N','021','DEN','266666','99734OH005000401','2014-01-01','2013-12-12 19:21:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:43'),(16993,13602,'Y','18','021','EC','A','','','AC','0000496769','0000496769','OH00002016623','IL','1','Gerdon','Sara','','','','34','270802867','3995 N.C.R 21',0,'Republic','OH','44867',NULL,'CY','39147','1981-06-18','F','M',':RET:2106-3','N','021','HLT','2513205','92036OH004002701','2014-02-01','2014-01-09 13:11:42','0.00',NULL,NULL,'185.49','185.49','R-OH006','OH0','185.49',NULL,0,'2014-01-13 02:20:26'),(6983,5541,'Y','18','021','EC','A','','','AC','0000309449','0000309449','OH00000136990','IL','1','smith','tracy','','','','34','284843934','1541 W STEWART ST',0,'DAYTON','OH','45417','3819','CY','39113','1971-09-26','F','U',':RET:2054-5','N','021','DEN','1693400','99734OH005000401','2014-02-01','2013-12-25 00:07:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:47:47'),(15530,12425,'Y','18','021','EC','A','','','AC','0001241370','0001241370','LA00000181495','IL','1','ENGLISH','RICKY','','','','34','435865653','104 UPSILON ST',0,'BELLE CHASSE','LA','70037','1704','CY','22075','1952-09-21','M','U',':RET:2106-3','N','021','DEN','2295227','18575LA002000201','2014-02-01','2013-12-31 12:29:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:30:36'),(9698,7681,'N','01','021','EC','A',NULL,NULL,'','0000711364','0000901065','','IL','1','BELL','LAWRENCE','RAYMOND','','','34','283505095','5718 HILLTOP WAY',0,'MILFORD','OH','45150',NULL,'CY','39025','1950-06-30','M','',':RET:2106-3','T','021','HLT','2189191','92036OH006000601','2014-01-01','2013-12-21 13:59:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','577.94',NULL,0,'2013-12-26 04:39:53'),(21936,17516,'Y','18','021','EC','A','','','AC','0000279109','0000279109','TX00001586865','IL','1','Sires','Ricky','','','','34','460218542','8601 RUNION RD',0,'SAN ANGELO','TX','76905','8827','CY','48451','1959-02-12','M','M',':RET:2106-3','N','021','DEN','2856329','33348TX002000201','2014-03-01','2014-02-07 15:21:52','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-07 19:00:12'),(17734,14170,'Y','18','021','EC','A','','','AC','0000625443','0000625443','OH00001458917','IL','1','carothers','brian','','','','34','290665079','1250 us hwy 42',0,'ashland','OH','44805',NULL,'CY','39005','1971-07-10','M','U',':RET:2106-3','N','021','HLT','2266550','52664OH151001305','2014-02-01','2014-01-13 11:39:04','208.00',NULL,NULL,'295.48','87.48','R-OH012','OH0','295.48',NULL,0,'2014-01-14 01:33:20'),(24571,19511,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000653252','','IL','1','ONWUAGBA','CHIDIEBUBE','','','','34','284112818','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','2000-06-04','M','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:07:27'),(27740,21936,'N','01','021','EC','A',NULL,NULL,'','0000174119','0000419413','','IL','1','De La Garza','Julian','Dee','','','34','451679149','3312 E RICHARDSON RD',0,'EDINBURG','TX','78542','7640','CY','48215','1983-10-14','M','',NULL,'N','021','DEN','3716919','33348TX002000201','2014-04-01','2014-03-05 17:41:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:31:09'),(28281,22379,'Y','18','024','14','A','','','TE','0000019532','0000019532','','IL','1','Skef','Natalia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-03','F','',NULL,NULL,NULL,'','638049','','2014-03-31','2014-03-07 09:57:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-07 21:00:25'),(4579,3626,'Y','18','021','EC','A','','','AC','0000545220','0000545220','OH00000071404','IL','1','Chen','Cindy Xin Fang','','','','34','562879608','581 FOREST CREEK DR',0,'WOOSTER','OH','44691','4920','CY','39169','1958-10-11','F','U',NULL,'N','021','HLT','445786','52664OH151001305','2014-01-01','2013-12-11 19:22:24','395.00',NULL,NULL,'497.31','102.31','R-OH014','OH0','497.31',NULL,0,'2013-12-25 22:05:09'),(20905,16709,'N','01','021','EC','A',NULL,NULL,'','0001043426','0000273828','','IL','1','Franks','Geraldine','','','','34','166447392','7673 CORNELL RD',0,'CINCINNATI','OH','45242','3015','CY','39061','1952-05-17','F','',':RET:2106-3','N','021','DEN','3037922','99734OH005000401','2014-03-01','2014-01-31 16:30:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:01:23'),(20266,16171,'Y','18','024','14','A','','','TE','0000640935','0000640935','','IL','1','SMITH','DIANE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-02-25','F','',NULL,NULL,NULL,'','2466295','','2014-01-28','2014-01-28 11:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:20'),(19412,15476,'Y','18','024','14','A','','','TE','0001083069','0001083069','','IL','1','quaintance','george',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-19','M','',NULL,NULL,NULL,'','1639271','','2014-01-21','2014-01-21 11:30:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:58'),(5644,4477,'Y','18','021','EC','A','','','AC','0001142243','0001142243','TX00001018073','31','1','Coronado','Carmen','','','','34','368588970','P O Box 435',0,'Crystal City','TX','78839',NULL,'CY','48507','1950-03-24','F','U',':RET:2106-3','N','021','DEN','1038070','33348TX002000201','2014-01-01','2013-11-26 11:09:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:31:19'),(8920,7072,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000119052','','IL','1','TURNER','BRANDON','M','','','34','272068549','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2000-11-19','M','',NULL,'N','021','DEN','1914082','99734OH005000401','2014-01-01','2013-12-18 05:39:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:45'),(17832,14245,'Y','18','021','EC','A','','','AC','0000610796','0000610796','MS00002369435','IL','1','HAMILTON','DILLARD','','','','34','587960042','902 SCR 101A',0,'LOUIN','MS','39338','4883','CY','28129','1953-09-05','M','M',':RET:2054-5','N','021','DEN','1680537','46300MS002000201','2014-02-01','2014-01-14 16:06:05','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-15 02:06:00'),(13540,10796,'Y','18','021','EC','A','','','AC','0002112173','0002112173','LA00000481554','IL','1','stevens','susan','pittman','','','34','435137569','7800 youree drive',0,'Shreveport','LA','71105',NULL,'CY','22017','1963-05-05','F','U',':RET:2106-3','N','021','DEN','1566035','18575LA002000201','2014-01-01','2013-12-23 13:11:35','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:03:45'),(13961,11128,'Y','18','021','EC','A','','','AC','0000999849','0000999849','OH00000336144','IL','1','bryant','gary','','','','34','297507444','2350 LOWER BELLBROOK RD',0,'SPRING VALLEY','OH','45370','8774','CY','39057','1966-05-31','M','M',':RET:2106-3','N','021','HLT','1480111','92036OH005000504','2014-01-01','2013-12-23 13:43:31','408.00',NULL,NULL,'796.07','388.07','R-OH003','OH0','371.54',NULL,0,'2013-12-26 13:15:08'),(22568,18023,'Y','18','021','EC','A','','','AC','0000363814','0000363814','OH00001980696','IL','1','Richley','Georgiann','','','','34','275747943','10209 Fidelity Ave',0,'Cleveland','OH','44111',NULL,'CY','39035','1964-01-07','F','U',':RET:2106-3','N','021','DEN','3636179','99734OH005000401','2014-03-01','2014-02-10 14:07:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:55'),(22988,18327,'N','01','021','EC','A',NULL,NULL,'','0000843378','0001155135','','IL','1','Rohr','Nicholas','','','','34','296803324','2108 Ben Fulton Rd',0,'North Lawrence','OH','44666',NULL,'CY','39151','1980-12-27','M','',NULL,'N','021','DEN','3370430','99734OH005000301','2014-03-01','2014-02-12 09:24:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:12'),(23115,18424,'Y','18','024','14','A','','','TE','0000446286','0000446286','','IL','1','THOMPSON','THOMAS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-04-10','M','',NULL,NULL,NULL,'','2156288','','2014-02-28','2014-02-12 17:30:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-12 21:31:21'),(24194,19217,'N','01','021','EC','A',NULL,NULL,'','0000076346','0001204582','','IL','1','Garrison','Gregory','L','','','34','278643337','88 Ralph Morrison Rd',0,'Peebles','OH','45660',NULL,'CY','39001','1959-04-17','M','',':RET:2106-3','N','021','DEN','3579054','99734OH005000301','2014-03-01','2014-02-15 19:30:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:14'),(27796,21986,'Y','18','021','EC','A','','','AC','0001038663','0001038663','OH00002616506','IL','1','BAJOR','GEORGE','','','','34','294665876','4585 MARS RD',0,'UNIONTOWN','OH','44685','6901','CY','39153','1950-05-26','M','M',NULL,'N','021','HLT','3064839','52664OH151001305','2014-04-01','2014-03-04 18:52:03','891.00',NULL,NULL,'1155.63','264.63','R-OH012','OH0','658.32',NULL,0,'2014-03-05 21:31:43'),(28205,22320,'N','19','021','EC','A',NULL,NULL,'','0000848367','0000048650','','S1','1','Moser','Gregory','','','','34','641560270','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1997-05-05','F','',':RET:2106-3','N','021','DEN','3200824','33348TX002000101','2014-04-01','2014-03-06 16:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10','CIC',0,'2014-03-06 21:30:11'),(4470,3552,'Y','18','021','EC','A','','','AC','0000129245','0000129245','OH00000029952','IL','1','Dail','Alan','','','','34','230829756','6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1963-06-29','M','R',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10','0.00',NULL,NULL,'87.78','87.78','R-OH014','OH0','0.00',NULL,0,'2013-12-25 22:02:49'),(6253,4955,'Y','18','021','EC','A','','','AC','0000948686','0000948686','LA00001211304','IL','1','ducote','shannon','','','','34','564758179','30090 Mayer St.',0,'Walker','LA','70785',NULL,'CY','22063','1967-07-01','F','U',NULL,'N','021','DEN','1014924','18575LA002000101','2014-01-01','2013-11-19 17:20:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 00:32:01'),(20329,16232,'Y','18','021','EC','A','','','AC','0000700414','0000700414','OH00001847668','IL','1','breisinger','robert','','','','34','293549658','5178 st rt 634',0,'continental','OH','45831',NULL,'CY','39137','1967-07-17','M','M',':RET:2106-3','T','021','HLT','3182882','92036OH001001501','2014-03-01','2014-01-27 20:44:04','0.00',NULL,NULL,'457.93','457.93','R-OH002','OH0','457.93',NULL,0,'2014-01-28 21:01:00'),(16002,12807,'Y','18','021','EC','A','','','AC','0001053468','0001053468','TX00000778914','IL','1','Williams','Antwanna','','','','34','433656844','1503 WINSTON ST',0,'MARSHALL','TX','75670','5949','CY','48203','1987-05-08','F','U',':RET:2054-5','N','021','DEN','1943659','33348TX002000201','2014-02-01','2014-01-03 15:42:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:31'),(25273,20052,'Y','18','021','EC','A','','','AC','0000917654','0000917654','TX00002292096','IL','1','TAYLOR','LISA','ANN','','','34','452415803','2622 E GRIMES ST',0,'HARLINGEN','TX','78550','4508','CY','48061','1975-10-30','F','M',NULL,'N','021','DEN','2752401','33348TX002000201','2014-04-01','2014-02-24 19:56:46','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61','CIC',0,'2014-02-25 21:00:13'),(25945,20575,'Y','18','021','EC','A','','','AC','0000112984','0000112984','OH00002790423','IL','1','borger','mary','','','','34','275465241','1850 CLARISSA AVE',0,'KETTERING','OH','45429','4254','CY','39113','1952-06-06','F','U',NULL,'N','021','DEN','3492437','99734OH005000401','2014-03-01','2014-02-26 08:51:28','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-26 21:01:33'),(182,151,'Y','18','021','EC','A','','','AC','0001045647','0001045647','OH00000391693','IL','1','Suffolk','Joan','','','','34','282563599','2954 NORTHAMPTON RD',0,'CUYAHOGA FALLS','OH','44223','3031','CY','39153','1953-08-25','F','U',':RET:2106-3','N','021','HLT','596484','52664OH151001305','2014-01-01','2013-12-05 13:04:20','437.00',NULL,NULL,'605.24','168.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 17:19:42'),(19728,15722,'Y','18','021','EC','A','','','AC','0001576164','0001576164','LA00002227141','IL','1','Brown','Charles','Edward','','III','34','566177804','105 west st.marys dr.',0,'covington','LA','70433',NULL,'CY','22103','1971-02-15','M','M',':RET:2054-5','T','021','DEN','3199739','18575LA002000201','2014-03-01','2014-01-23 16:39:06','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:04'),(5423,4305,'Y','18','021','EC','A','','','AC','0000584437','0000584437','MS00000378757','IL','1','Davis','Jacque','','','','34','373080992','5600 KEELE ST',0,'JACKSON','MS','39206',NULL,'CY','28049','1986-05-06','M','U',':RET:2054-5','T','021','DEN','1558791','46300MS002000201','2014-01-01','2013-12-19 10:37:37','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:09:27'),(17393,13917,'Y','18','021','EC','A','','','AC','0000670273','0000670273','OH00002536038','IL','1','Manley','Robert','','','','34','297807811','3925 FOREST AVE',0,'CINCINNATI','OH','45212','3930','CY','39061','1975-07-03','M','R',NULL,'N','021','DEN','1513579','99734OH005000401','2014-02-01','2014-01-10 15:14:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 03:00:12'),(15462,12373,'Y','18','024','14','A','','','TE','0000665593','0000665593','','IL','1','tomblin','jayson',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-22','M','',NULL,NULL,NULL,'','188193','','2013-12-30','2013-12-30 18:45:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:28:43'),(6945,5515,'Y','18','021','EC','A','','','AC','0000260477','0000260477','OH00001502358','IL','1','WILLIAMS','LOIS','','','','34','297565122','2 WINCHESTER AVE',0,'CLEVELAND','OH','44110','1038','CY','39035','1954-11-13','F','U',':RET:2106-3','N','021','DEN','1940692','99734OH005000401','2014-01-01','2013-12-24 20:45:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:53'),(24251,19256,'Y','18','024','14','A','','','TE','0000721345','0000721345','','IL','1','Gustafson','Johnna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-01-29','F','',NULL,NULL,NULL,'','1834041','','2014-03-03','2014-02-16 17:22:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-16 19:00:44'),(203,168,'Y','18','021','EC','A','','','AC','0001171861','0001171861','OH00000662708','IL','1','CLEVENGER','ETTA','','','','34','291508433','14999 ROAD S',0,'COLUMBUS GROVE','OH','45830',NULL,'CY','39137','1950-01-10','F','M',NULL,'N','021','HLT','1131986','92036OH005001501','2014-01-01','2013-12-05 11:36:49','258.00',NULL,NULL,'649.68','391.68','R-OH002','OH0','649.68',NULL,0,'2013-12-25 17:20:14'),(5270,4179,'N','19','021','EC','A',NULL,NULL,'','0000696804','0000475956','','S1','1','Vaccaro','Raphael','M',NULL,NULL,NULL,NULL,'2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','2005-03-26','F','',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:05:33'),(1317,1088,'N','01','021','EC','A',NULL,NULL,'','0000186069','0000109249','','IL','1','Purdy','Stephanie','','','','34','617402541','119 RAVINEWOOD TER',0,'LOVELAND','OH','45140','7744','CY','39061','1989-09-27','F','',':RET:2106-3','N','021','DEN','335758','99734OH005000401','2014-01-01','2013-11-04 11:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:31:36'),(19426,15486,'Y','18','021','EC','A','','','AC','0000092547','0000092547','OH00001538168','IL','1','Roberts','Shirley','','','','34','276542072','928 OHIO PIKE',0,'CINCINNATI','OH','45245','2323','CY','39025','1952-02-14','F','U',':RET:2106-3','N','021','HLT','1790324','92036OH004000601','2014-03-01','2014-01-21 16:59:40','463.00',NULL,NULL,'495.91','32.91','R-OH005','OH0','495.91',NULL,1,'2014-01-22 03:23:05'),(17134,13712,'Y','18','021','EC','A','','','AC','0000998798','0000998798','OH00002174919','IL','1','Ashcraft','Ellen','McClain','','','34','288667053','7960 Rio Grande Dr',0,'Cleves','OH','45002',NULL,'CY','39061','1958-11-06','F','M',':RET:2106-3','T','021','DEN','1936869','99734OH005000401','2014-02-01','2014-01-08 14:42:05','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:21:48'),(16233,12999,'N','01','021','EC','A',NULL,NULL,'','0000384407','0001089566','','IL','1','SMITH','JANE','','','','34','270547033','216 E BURWELL AVE',0,'LOUDONVILLE','OH','44842','9504','CY','39005','1952-09-11','F','',':RET:2106-3','N','021','HLT','2320824','52664OH151001301','2014-02-01','2014-01-04 11:06:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-01-05 00:02:06'),(6574,5212,'Y','18','021','EC','A','','','AC','0000045662','0000045662','LA00000967049','IL','1','Branning','Pamela','','','','34','219583907','1000 BOURBON ST',0,'NEW ORLEANS','LA','70116','2708','CY','22071','1954-03-25','F','U',':RET:2106-3','N','021','DEN','1069925','18575LA002000101','2014-01-01','2013-12-11 12:27:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:52:45'),(8983,7125,'N','01','021','EC','A',NULL,NULL,'','0000437961','0000647063','','IL','1','Gilbert','Jason','Donald','','','34','294803879','4967 SCHROER AVE',0,'CINCINNATI','OH','45238','5727','CY','39061','1982-11-14','M','',':RET:2106-3','N','021','DEN','1827005','99734OH005000401','2014-01-01','2013-12-18 16:05:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:04:24'),(15179,12130,'Y','18','021','EC','A','','','AC','0000116596','0000116596','OH00001279599','IL','1','JOHNSON','DONNY','','','','34','274843975','15324 SHILOH RD',0,'CLEVELAND','OH','44110','1719','CY','39035','1985-08-06','M','U',':RET:2054-5','N','021','DEN','2145032','99734OH005000401','2014-02-01','2013-12-30 17:50:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:06:46'),(15085,12058,'Y','18','021','EC','A','','','AC','0001105062','0001105062','TX00000335130','IL','1','Ortega','Ventura','','','','34','466909217','1502 BEL AIR DR',0,'ABILENE','TX','79603','4204','CY','48441','1951-10-20','M','M',NULL,'N','021','DEN','1499189','33348TX002000101','2014-02-01','2013-12-30 14:32:26','0.00',NULL,NULL,'25.02','25.02','R-TX001','TX0','25.02',NULL,0,'2014-01-01 12:04:18'),(22075,17620,'Y','18','021','EC','A','','','AC','0001268791','0001268791','LA00002135105','IL','1','tubbs','Anthony','','','','34','434557415','2056 E TEXAS ST',0,'BOSSIER CITY','LA','71111','3844','CY','22015','1970-03-16','M','M',':RET:2106-3','N','021','DEN','2621245','18575LA002000201','2014-03-01','2014-02-07 20:27:23','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-02-08 19:00:16'),(24573,19511,'N','01','021','EC','A',NULL,NULL,'','0000256015','0000753434','','IL','1','ONWUAGBA','ALBERTA','','','','34','273116289','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1968-09-23','F','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:07:37'),(26856,21287,'Y','18','021','EC','A','','','AC','0000177685','0000177685','OH00002546974','IL','1','Campton','Duane','','','','34','274721698','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1970-06-08','M','M',NULL,'N','021','HLT','3909716','92036OH003000601','2014-04-01','2014-03-01 11:08:35','545.00',NULL,NULL,'1028.34','483.34','R-OH005','OH0','304.21',NULL,0,'2014-03-01 21:00:54'),(5404,4290,'Y','18','021','EC','A','','','AC','0000411106','0000411106','OH00000376144','IL','1','Robinson','Tom','P','','','34','290423048','416 PERSHING AVE',0,'CINCINNATI','OH','45215','2944','CY','39061','1955-01-10','M','M',':RET:2106-3','N','021','HLT','2494093','92036OH002001201','2014-01-01','2013-12-18 21:44:46','363.00',NULL,NULL,'631.66','268.66','R-OH004','OH0','631.66',NULL,0,'2013-12-25 23:09:01'),(4558,3610,'N','19','021','EC','A',NULL,NULL,'','0000426405','0000257118','','IL','1','Williams','Kingston',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2010-12-09','M','',':RET:2054-5','N','021','HLT','1132180','52664OH152000901','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 22:04:40'),(18916,15072,'N','01','021','EC','A',NULL,NULL,'','0001094663','0001016879','','IL','1','TOPP','KURT','M','','','34','301766699','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1971-02-17','M','',':RET:2106-3','N','021','HLT','2100812','92036OH005001506','2014-02-01','2014-01-15 19:29:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.62',NULL,0,'2014-01-17 03:36:42'),(3799,3045,'Y','18','024','14','A','','','TE','0000280795','0000280795','','IL','1','Caserta','Zachary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-07-01','M','',NULL,NULL,NULL,'','985884','','2013-12-13','2013-12-13 11:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:28'),(17806,14223,'Y','18','021','EC','A','','','AC','0000474580','0000474580','TX00001437591','IL','1','Pruett','Jessica','','','','34','465998950','6992 La Hacienda Dr.',0,'Flint','TX','75762',NULL,'CY','48423','1982-05-31','F','U',':RET:2106-3','N','021','DEN','1944989','33348TX002000101','2014-02-01','2014-01-13 21:15:24','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2014-01-15 02:05:51'),(7036,5588,'Y','18','021','EC','A','','','AC','0000022226','0000022226','TX00000466164','IL','1','Castillo','Javier','Reyes','','','34','461258815','3326 JAMAICA WAY',0,'MESQUITE','TX','75150','1719','CY','48113','1955-01-06','M','M',':RET:2106-3','N','021','DEN','1737715','33348TX002000201','2014-01-01','2013-12-24 23:52:10','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:16'),(17089,13677,'Y','18','021','EC','A','','','AC','0001123525','0001123525','TX00001265710','IL','1','Crenshaw','Shovon','','','','34','571197949','3550 TIMBERGLEN RD',0,'DALLAS','TX','75287','3491','CY','48121','1968-07-12','F','U',':RET:2054-5^:RET:2039-6','N','021','DEN','2066299','33348TX002000201','2014-02-01','2014-01-08 14:50:28','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:26'),(15271,12208,'Y','18','021','EC','A','','','AC','0001256045','0001256045','OH00002158945','IL','1','Steele','Danita','A','','','34','291669744','1089 MEADOWIND CT',0,'CINCINNATI','OH','45231','4607','CY','39061','1970-07-22','F','U',':RET:2054-5','N','021','DEN','1710955','99734OH005000401','2014-02-01','2013-12-31 19:29:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:21:48'),(15147,12106,'Y','18','021','EC','A','','','AC','0000148345','0000148345','OH00001350133','IL','1','HASAN','TAMIKA','','','','34','294603165','1430 W 21ST ST',0,'LORAIN','OH','44052','4417','CY','39093','1977-07-07','F','M',':RET:2054-5','N','021','DEN','1486495','99734OH005000401','2014-02-01','2013-12-30 11:58:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:05:56'),(24198,19221,'Y','18','021','EC','A','','','AC','0000221366','0000221366','OH00002384150','IL','1','Albrinck','Andrew','','','','34','405884877','7545 FERNWOOD DR',0,'CINCINNATI','OH','45237','1700','CY','39061','1969-06-27','M','M',':RET:2106-3','N','021','DEN','2697299','99734OH005000301','2014-03-01','2014-02-15 23:29:13','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-16 19:00:17'),(24427,19403,'N','01','021','EC','A',NULL,NULL,'','0000815378','0000293238','','IL','1','Sebe','Jennifer','','','','34','302641299','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','1969-08-22','F','',':RET:2106-3','N','021','HLT','3372930','52664OH151001301','2014-04-01','2014-02-18 08:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-02-18 22:01:11'),(24727,19632,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000519884','','IL','1','SMITH','NIQUAN','','','','34','291138661','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2008-01-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:00'),(239,200,'Y','18','021','EC','A','','','AC','0000954271','0000954271','OH00000817611','IL','1','Agner','Terry','','','','34','291507833','4020 Portage View Rd',0,'Bloomdale','OH','44817',NULL,'CY','39173','1951-07-14','M','U',':RET:2106-3','N','021','HLT','292375','92036OH004002601','2014-01-01','2013-12-04 22:49:54','241.00',NULL,NULL,'450.46','209.46','R-OH001','OH0','450.46',NULL,0,'2013-12-25 17:21:16'),(18319,14626,'Y','18','024','14','A','','','TE','0000060285','0000060285','','IL','1','McCue','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-23','F','',NULL,NULL,NULL,'','2457716','','2014-01-15','2014-01-15 09:15:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:06'),(323,265,'N','01','021','EC','A',NULL,NULL,'','0000524453','0000271389','','IL','1','Yang','Myunghee','','','','34','280153067','5592 WATERSIDE DR',0,'MASON','OH','45040','4512','CY','39165','1978-12-05','F','',':RET:2040-4','N','021','HLT','299134','92036OH006001201','2014-01-01','2013-11-12 23:34:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','208.03',NULL,0,'2013-12-25 17:31:25'),(4927,3908,'N','01','021','EC','A',NULL,NULL,'','0000388621','0000029016','','IL','1','Kennedy','Kevin','','','','34','273765574','5542 BOSWORTH PL',0,'CINCINNATI','OH','45212','1238','CY','39061','1978-01-08','M','',':RET:2054-5','N','021','DEN','28646','99734OH005000401','2014-01-01','2013-12-06 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:45:18'),(20250,16159,'Y','18','024','14','A','','','TE','0000187474','0000187474','','IL','1','Cunningam','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-07-31','M','',NULL,NULL,NULL,'','3186903','','2014-01-28','2014-01-28 15:13:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:13'),(20297,16202,'Y','18','024','14','A','','','TE','0002138109','0002138109','','IL','1','Shivers','Brenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-01-26','F','',NULL,NULL,NULL,'','2254909','','2014-01-28','2014-01-28 17:51:09',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-28 21:00:40'),(20512,16389,'Y','18','021','EC','A','','','AC','0001955079','0001955079','LA00001982755','IL','1','BERNARD','SHANNON','','','','34','435062113','277 SYCAMORE LN',0,'MONROE','LA','71202','8040','CY','22073','1957-12-19','M','U',NULL,'N','021','DEN','3570493','18575LA002000201','2014-03-01','2014-01-29 17:57:38','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-29 21:01:20'),(21428,17125,'Y','18','021','EC','A','','','AC','0001229334','0001229334','OH00002593367','IL','1','BORMUTH','ERIC','','','','34','271823556','105 N. MAIN STREET',0,'JENERA','OH','45841',NULL,'CY','39063','1977-02-26','M','U',':RET:2106-3','T','021','HLT','3220921','92036OH002001501','2014-03-01','2014-02-03 21:04:14','5.00',NULL,NULL,'361.84','356.84','R-OH002','OH0','361.84',NULL,0,'2014-02-04 21:01:16'),(27650,21871,'N','19','021','EC','A',NULL,NULL,'','0000134634','0000377527','','IL','1','Stinson','David','','','III',NULL,NULL,'2540 OWLCREST DR',0,'CINCINNATI','OH','45231','1152','CY','39061','2012-05-15','M','',':RET:2054-5','N','021','DEN','2946972','99734OH005000401','2014-04-01','2014-03-05 13:17:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:22'),(28617,22648,'Y','18','021','EC','A','','','AC','0000427550','0000427550','TX00002839368','IL','1','McNeill','John','','','','34','056545693','3049 SNOWBERRY',0,'NEW BRAUNFELS','TX','78130','7055','CY','48091','1973-10-08','M','M',':RET:2106-3','N','021','DEN','3447391','33348TX002000201','2014-04-01','2014-03-07 22:53:28','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-03-08 21:30:19'),(1380,1145,'Y','18','021','EC','A','','','AC','0001993680','0001993680','LA00001467550','IL','1','Daume','William','','','','34','411805199','2000 S CARROLLTON AVE',0,'NEW ORLEANS','LA','70118','2949','CY','22071','1950-10-16','M','M',':RET:2106-3','N','021','DEN','1956821','18575LA002000201','2014-01-01','2013-12-24 09:00:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:04'),(3580,2872,'N','19','021','EC','A',NULL,NULL,'','0001225702','0000597298','','S1','1','Lowell','Ginger','','','','34','294041515','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','2000-02-22','F','',':RET:2106-3','N','021','HLT','2295943','92036OH006000601','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-25 21:22:44'),(16433,13149,'Y','18','021','EC','A','','','AC','0000323521','0000323521','OH00001550489','IL','1','Ficarra','Mark','Joseph','','','34','299723928','623 MEREDITH LN',0,'CUYAHOGA FALLS','OH','44223','3300','CY','39153','1963-05-16','M','U',':RET:2106-3','T','021','HLT','1730544','52664OH152000901','2014-02-01','2014-01-06 15:53:16','61.00',NULL,NULL,'335.49','274.49','R-OH012','OH0','335.49',NULL,0,'2014-01-07 04:04:53'),(4024,3213,'Y','18','021','EC','A','','','AC','0000262715','0000262715','OH00000646200','IL','1','Wallace','Christopher','','','','34','234354564','5555 COLUMBIA DR',0,'BEDFORD HEIGHTS','OH','44146','2443','CY','39035','1981-06-07','M','M',':RET:2106-3','N','021','DEN','2025566','99734OH005000401','2014-01-01','2013-12-17 08:54:27','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:45:44'),(20551,16423,'Y','18','021','EC','A','','','AC','0000999880','0000999880','OH00001655894','IL','1','ANDRA','DAVID','','','','34','272520568','100 N GREENLAWN AVE',0,'LIMA','OH','45807','1010','CY','39003','1951-11-03','M','U',':RET:2106-3','T','021','HLT','2984804','92036OH003001505','2014-03-01','2014-01-29 10:53:26','575.00',NULL,NULL,'759.36','184.36','R-OH002','OH0','759.36',NULL,0,'2014-01-29 21:01:42'),(21419,17120,'Y','18','021','EC','A','','','AC','0000828271','0000828271','OH00001889168','S3','1','almaguer','heather','','','','34','272116702','804 N PROSPECT ST',0,'BOWLING GREEN','OH','43402','1821','CY','39173','2004-12-08','F','U',':RET:2106-3','N','021','HLT','3148889','92036OH006002601','2014-03-01','2014-02-04 12:26:46','0.00',NULL,NULL,'98.20','98.20','R-OH001','OH0','98.20',NULL,0,'2014-02-04 21:01:12'),(26369,20917,'Y','18','024','14','A','','','TE','0000319650','0000319650','','IL','1','CLARK','RENEE','KAY',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-03-28','F','',NULL,NULL,NULL,'','412697','','2014-03-31','2014-02-26 11:04:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:11'),(28911,22884,'N','01','021','EC','A',NULL,NULL,'','0000435375','0000528315','','IL','1','Whitmer','Samantha','','','','34','300969253','1327 MAPLE AVE NE',0,'CANTON','OH','44705','1717','CY','39151','1994-06-24','F','',':RET:2106-3','N','021','DEN','3664828','99734OH005000301','2014-04-01','2014-03-09 23:46:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:27'),(201,167,'Y','18','021','EC','A','','','AC','0000643204','0000643204','OH00000367635','IL','1','Hanson','Edgar','','','','34','296523564','65 RUE DR',0,'CRIDERSVILLE','OH','45806','2238','CY','39011','1952-07-18','M','M',NULL,'N','021','HLT','1019866','92036OH005001505','2014-01-01','2013-12-05 09:15:34','1153.00',NULL,NULL,'1250.76','97.76','R-OH002','OH0','618.46',NULL,0,'2013-12-25 17:20:12'),(13124,10466,'Y','18','021','EC','A','','','AC','0001196810','0001196810','OH00001369871','IL','1','Guilfoyle','Julie','','','','34','288847995','404 INGRAM RD',0,'CINCINNATI','OH','45218','1138','CY','39061','1969-06-05','F','U',':RET:2106-3','N','021','DEN','1539787','99734OH005000401','2014-01-01','2013-12-23 14:10:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:49'),(16281,13034,'Y','18','021','EC','A','','','AC','0000490488','0000490488','OH00001769136','IL','1','CLARK','JOYCE','','','','34','294665074','150 S LEONARD AVE',0,'LIMA','OH','45804','2926','CY','39003','1960-03-12','F','M',NULL,'N','021','DEN','1984394','99734OH005000401','2014-02-01','2014-01-06 16:18:41','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2014-01-07 04:00:32'),(2251,1848,'Y','18','021','EC','A','','','AC','0000385874','0000385874','OH00000417888','IL','1','MESONES','CESAR','A','','','34','276023886','8717 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','1961-10-02','M','M',':RET:2106-3','N','021','DEN','688704','99734OH005000301','2014-01-01','2013-12-08 19:49:16','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:07'),(4674,3705,'Y','18','021','EC','A','','','AC','0000578534','0000578534','LA00001303684','IL','1','NASH','DAVID','','','','34','437173130','129 NASH RD',0,'NATCHITOCHES','LA','71457',NULL,'CY','22127','1957-04-17','M','U',':RET:2054-5','N','021','DEN','208905','18575LA002000201','2014-01-01','2013-12-12 14:36:39','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 22:07:41'),(6133,4864,'Y','18','021','EC','A','','','AC','0000313846','0000313846','LA00000833077','IL','1','MacDougall','Glenn','','','','34','008426603','14302 RIVERLAKE DR',0,'COVINGTON','LA','70435','5783','CY','22103','1955-07-23','M','M',':RET:2106-3','N','021','DEN','140323','18575LA002000201','2014-01-01','2013-11-20 21:48:38','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:16:04'),(7301,5787,'Y','18','021','EC','A','','','AC','0000570541','0000570541','OH00001197918','31','1','FOSTER','VERONICA','A','','','34','301545217','PO BOX 11137',0,'YOUNGSTOWN','OH','44511',NULL,'CY','39099','1953-12-31','F','M',':RET:2106-3','N','021','HLT','484456','52664OH151001306','2014-01-01','2013-12-14 12:10:30','576.00',NULL,NULL,'686.36','110.36','R-OH013','OH0','686.36',NULL,0,'2013-12-26 02:03:08'),(20415,16306,'Y','18','021','EC','A','','','AC','0000545271','0000545271','OH00002094304','IL','1','RITTERBACH','JOHN','','','','34','269461288','131 MORRISON ST',0,'FREMONT','OH','43420','4416','CY','39143','1947-10-04','M','M',NULL,'N','021','DEN','2749134','99734OH005000301','2014-03-01','2014-01-28 19:59:56','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-01-29 21:00:27'),(26795,21237,'Y','18','021','EC','A','','','AC','0000862497','0000862497','OH00003289138','IL','1','Gonzalez','Mary','','','','34','294808191','336 N BERLIN AVE',0,'TOLEDO','OH','43605','1508','CY','39095','1970-06-02','F','M',NULL,'N','021','HLT','2734646','92036OH003002605','2014-04-01','2014-03-01 16:53:49','674.00',NULL,NULL,'934.08','260.08','R-OH001','OH0','276.33',NULL,0,'2014-03-01 21:00:21'),(26911,21329,'Y','18','021','EC','A','','','AC','0001620090','0001620090','LA00003378863','IL','1','Ghashghaee','Fayzollah','','','','34','447708877','59655 Highway 1148 Lot 180',0,'Plaquemine','LA','70764',NULL,'CY','22047','1956-09-13','M','M',':RET:2106-3','T','021','DEN','3511496','18575LA002000201','2014-04-01','2014-03-02 16:43:49','0.00',NULL,NULL,'43.83','43.83','R-LA005','LA0','14.61',NULL,0,'2014-03-03 01:00:12'),(28619,22649,'Y','18','021','EC','A','','','AC','0000749387','0000749387','TX00002601663','IL','1','Covington','Alice','Myrie','','','34','465772952','300 BOWIE ST',0,'NOCONA','TX','76255','2242','CY','48337','1982-02-19','F','M',':RET:2106-3','N','021','DEN','3761434','33348TX002000201','2014-04-01','2014-03-07 22:58:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:20'),(7874,6229,'Y','18','021','EC','A','','','AC','0000529416','0000529416','OH00000389674','IL','1','BAILOSKY','KEVIN','','','','34','283862692','2811 Greenville Lane',0,'Fairlawn','OH','44333',NULL,'CY','39153','1983-06-21','M','U',':RET:2106-3','N','021','DEN','1859881','99734OH005000301','2014-01-01','2013-12-20 16:21:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:05:15'),(19838,15821,'Y','18','021','EC','A','','','AC','0002158535','0002158535','LA00001940676','IL','1','GIRTLEY','DONALD','D','','','34','434191827','4888 HOOPER RD',0,'BATON ROUGE','LA','70811',NULL,'CY','22033','1965-03-03','M','U',':RET:2054-5','N','021','DEN','2750326','18575LA002000201','2014-03-01','2014-01-24 15:51:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-24 21:00:23'),(19440,15495,'N','01','021','EC','A',NULL,NULL,'','0000431402','0000908056','','IL','1','Ladd','Klint','','','','34','274881920','3380 WHISPERING TREES DR',0,'AMELIA','OH','45102','2327','CY','39025','1982-03-04','M','',':RET:2106-3','N','021','HLT','1465689','92036OH003000601','2014-03-01','2014-01-21 15:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','259.83',NULL,1,'2014-01-22 03:23:12'),(6880,5457,'Y','18','021','EC','A','','','AC','0001949858','0001949858','LA00000291652','IL','1','ESSED','TOUFIK','','','','34','438913771','1610 CARROLLTON AVE',0,'METAIRIE','LA','70005','5001','CY','22051','1965-12-03','M','M',NULL,'N','021','DEN','2552252','18575LA002000201','2014-01-01','2013-12-24 18:20:13','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:03'),(18415,14691,'Y','18','021','EC','A','','','AC','0002348411','0002348411','LA00001991222','IL','1','CARTER','BRENDA','J','','','34','439259688','13930 WELLS ST',0,'NEW ORLEANS','LA','70128',NULL,'CY','22071','1959-09-19','F','U',NULL,'N','021','DEN','1920316','18575LA002000201','2014-02-01','2014-01-14 21:11:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:49'),(21587,17243,'N','19','021','EC','A',NULL,NULL,'','0000833445','0001008976','','IL','1','kennedy','micheal','','','','34','278989737','61525 vocational rd',0,'cambridge','OH','43725',NULL,'CY','39059','1995-03-28','M','',':RET:2106-3','N','021','DEN','3199975','99734OH005000301','2014-03-01','2014-02-04 19:26:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:28'),(22111,17648,'Y','18','021','EC','A','','','AC','0001256073','0001256073','OH00002355002','IL','1','SEAGIN','DEBRA','A','','','34','282562724','1094 KILLINGER RD',0,'CLINTON','OH','44216','9656','CY','39153','1956-06-14','F','M',':RET:2106-3','N','021','DEN','2866517','99734OH005000301','2014-03-01','2014-02-08 15:44:13','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-08 19:00:34'),(22267,17773,'Y','18','021','EC','A','','','AC','0000548053','0000548053','TX00002371065','IL','1','YAHYA','ALINASR','MOHAMED','','','34','640727003','6606 De Moss Dr',0,'Houston','TX','77074',NULL,'CY','48201','1981-01-01','M','M',':RET:2054-5','N','021','DEN','2889374','33348TX002000201','2014-03-01','2014-01-30 17:55:45','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-10 11:00:12'),(23099,18412,'N','01','021','EC','A',NULL,NULL,'','0000881674','0000293233','','IL','1','THOMPSON','SHARON','A','','','34','285589538','30 TOY FOX LN',0,'BATAVIA','OH','45103','9688','CY','39025','1957-09-05','F','',NULL,'T','021','DEN','3031778','99734OH005000401','2014-03-01','2014-02-12 15:00:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:10'),(26612,21101,'Y','18','021','EC','A','','','AC','0001229765','0001229765','TX00003058816','IL','1','ni','yanqin','','','','34','095900670','807 itasca st',0,'plainview','TX','79072',NULL,'CY','48189','1983-09-17','F','U',':RET:2034-7','N','021','DEN','2859104','33348TX002000201','2014-04-01','2014-02-28 00:12:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:48'),(270,222,'Y','18','024','14','A','','','TE','0000750980','0000750980','','IL','1','MCKINNEY','LARRY','H',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-13','M','',NULL,NULL,NULL,'','138984','','2013-12-05','2013-12-05 12:56:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:22:03'),(19052,15175,'Y','18','021','EC','A','','','AC','0000536947','0000536947','OH00001463680','IL','1','Chowning','Nicholas','','','','34','272928871','5809 KAREN LN',0,'MILFORD','OH','45150','2118','CY','39025','1987-05-10','M','U',':RET:2106-3','N','021','HLT','2921923','92036OH003000605','2014-03-01','2014-01-17 15:13:13','92.00',NULL,NULL,'229.56','137.56','R-OH005','OH0','229.56',NULL,0,'2014-01-20 08:06:45'),(1696,1415,'Y','18','021','EC','A','','','AC','0001239127','0001239127','OH00001367908','IL','1','kolberg','david','','','','34','294680874','3350 MOFFAT RD',0,'TOLEDO','OH','43615','1336','CY','39095','1960-02-09','M','M',':RET:2106-3','N','021','HLT','1480232','92036OH004002601','2014-01-01','2013-12-24 09:49:09','0.00',NULL,NULL,'319.86','319.86','R-OH001','OH0','319.86',NULL,0,'2013-12-25 18:54:33'),(21329,17044,'Y','18','021','EC','A','','','AC','0000550104','0000550104','OH00002422032','IL','1','Musleve','Karen','','','','34','295669583','1245 WILBUR AVE',0,'AKRON','OH','44301','1839','CY','39153','1961-06-07','F','U',':RET:2106-3','T','021','HLT','3261537','52664OH152000901','2014-03-01','2014-02-04 15:46:12','341.00',NULL,NULL,'366.67','25.67','R-OH012','OH0','366.67',NULL,0,'2014-02-04 21:00:27'),(13971,11135,'Y','18','021','EC','A','','','AC','0000569311','0000569311','OH00000217882','IL','1','McIntosh','Randall','Earl','','','34','279703678','4244 Huston Rd.',0,'Hamilton','OH','45013',NULL,'CY','39017','1964-11-29','M','M',':RET:2106-3','N','021','HLT','2505527','92036OH004001201','2014-01-01','2013-12-22 23:52:56','452.00',NULL,NULL,'581.13','129.13','R-OH004','OH0','294.48',NULL,0,'2013-12-26 13:15:24'),(19183,15283,'Y','18','021','EC','A','','','AC','0000007457','0000007457','TX00002022737','IL','1','juarez','norberto','','','','34','452235764','9920 genie',0,'el paso','TX','79924',NULL,'CY','48141','1966-06-07','M','M',':RET:2106-3','N','021','DEN','2198131','33348TX002000201','2014-03-01','2014-01-20 14:15:30','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-21 08:46:09'),(5396,4283,'Y','18','021','EC','A','','','AC','0001270233','0001270233','LA00000850920','IL','1','Warren','Donald','','','','34','435960126','P O Box 37832',0,'Shreveport','LA','71133',NULL,'CY','22017','1956-04-01','M','U',':RET:2054-5','N','021','DEN','1944137','18575LA002000201','2014-01-01','2013-12-19 18:18:04','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 23:08:48'),(2597,2109,'Y','18','021','EC','A','','','AC','0000323470','0000323470','OH00000680471','IL','1','Snide','James','','','','34','286744273','114 Loretta Ave.',0,'Fairborn','OH','45324',NULL,'CY','39057','1962-03-14','M','U',':RET:2106-3','N','021','DEN','427021','99734OH005000401','2014-01-01','2013-12-01 19:57:44','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:45:13'),(2311,1878,'Y','18','021','EC','A','','','AC','0000718664','0000718664','TX00001055974','IL','1','Fan','Hong','','','','34','108339017','302 Bob bullock loop',0,'laredo','TX','78043',NULL,'CY','48479','1987-10-01','F','U',':RET:2034-7','N','021','DEN','710623','33348TX002000201','2014-01-01','2013-12-08 19:09:50','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 19:31:10'),(26677,21150,'Y','18','024','14','A','','','TE','0000067923','0000067923','','IL','1','Thompson','Arthelma',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-03-10','F','',NULL,NULL,NULL,'','950521','','2014-03-15','2014-02-28 12:42:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-28 21:31:21'),(27210,21544,'Y','18','021','EC','A','','','AC','0000109325','0000109325','OH00002789357','IL','1','Ball','Stephanie','','','','34','282867258','724 SOUTH ST',0,'FINDLAY','OH','45840','5930','CY','39063','1987-06-19','F','U',':RET:2106-3','N','021','HLT','3677443','92036OH006001501','2014-04-01','2014-03-03 10:52:44','149.00',NULL,NULL,'178.73','29.73','R-OH002','OH0','178.73',NULL,0,'2014-03-03 21:31:27'),(28419,22487,'Y','18','021','EC','A','','','AC','0000388704','0000388704','OH00002941659','IL','1','Townsend','Orlando','','','','34','296889628','2553 Romig Rd',0,'Akron','OH','44320',NULL,'CY','39153','1988-06-06','M','U',':RET:2054-5','N','021','DEN','3011318','99734OH005000401','2014-04-01','2014-03-07 13:34:25','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-07 21:31:01'),(28523,22573,'Y','18','021','EC','A','','','AC','0001100653','0001100653','OH00003228519','IL','1','Lewis','Kathleen','Ann','','','34','302501326','789 WISBEY RD',0,'BLANCHESTER','OH','45107','9788','CY','39027','1953-05-30','F','M',':RET:2106-3','N','021','HLT','2680004','92036OH003000601','2014-05-01','2014-03-07 03:21:09','0.00',NULL,NULL,'608.42','608.42','R-OH005','OH0','608.42',NULL,0,'2014-03-07 21:32:02'),(933,772,'Y','18','021','EC','A','','','AC','0000848302','0000848302','OH00001003984','IL','1','harr','james','','','','34','233800998','8 FLEETWOOD AVE',0,'JACKSON','OH','45640','1807','CY','39079','1953-01-09','M','M',':RET:2106-3','N','021','DEN','457607','99734OH005000401','2014-01-01','2013-10-29 12:26:01','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2013-12-25 18:09:08'),(1903,1556,'Y','18','021','EC','A','','','AC','0000486952','0000486952','OH00001566131','IL','1','McGill','Sharon','','','','34','273804958','2933 LISA DR',0,'SIDNEY','OH','45365','9507','CY','39149','1967-04-02','F','U',':RET:2106-3','T','021','HLT','2585383','92036OH002000501','2014-01-01','2013-12-24 13:40:30','103.00',NULL,NULL,'473.52','370.52','R-OH003','OH0','473.52',NULL,0,'2013-12-25 18:59:12'),(15394,12314,'Y','18','021','EC','A','','','AC','0000474985','0000474985','OH00001085901','IL','1','Walden','Amanda','','','','34','269942603','19464 RIVERVIEW AVE',0,'ROCKY RIVER','OH','44116','2636','CY','39035','1989-11-29','F','U',':RET:2106-3','N','021','HLT','2585591','92036OH004000801','2014-02-01','2014-01-01 13:33:23','0.00',NULL,NULL,'187.99','187.99','R-OH011','OH0','187.99',NULL,1,'2014-01-02 04:25:50'),(15277,12213,'Y','18','021','EC','A','','','AC','0000420037','0000420037','OH00000403659','IL','1','Barlow','William','James','','','34','281487772','1550 West Galbreith',0,'Cincinnati','OH','45231',NULL,'CY','39061','1952-09-29','M','U',':RET:2054-5','N','021','DEN','2251741','99734OH005000401','2014-02-01','2014-01-01 12:36:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:21:59'),(1241,1021,'Y','18','021','EC','A','','','AC','0000502282','0000502282','LA00000571596','IL','1','Becnel','Ann','','','','34','222404752','6107 West End Blvd',0,'New Orleans','LA','70124',NULL,'CY','22071','1958-01-03','F','R',':RET:2106-3','N','021','DEN','375033','18575LA002000101','2014-01-01','2013-12-03 17:41:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:20:56'),(8168,6463,'Y','18','021','EC','A','','','AC','0000939735','0000939735','OH00000404825','IL','1','McKinley','Rodney','','','','34','291762468','200 WATER WORKS RD',0,'PEEBLES','OH','45660','9799','CY','39001','1976-09-03','M','M',':RET:2106-3','N','021','HLT','398807','92036OH005000605','2014-01-01','2013-11-22 11:37:04','400.00',NULL,NULL,'545.26','145.26','R-OH005','OH0','265.76',NULL,0,'2013-12-26 03:16:33'),(3050,2450,'Y','18','021','EC','A','','','AC','0001006899','0001006899','LA00001075694','IL','1','Simmons','Cleve','','','','34','434920318','6612 SNAPPER CIR',0,'SHREVEPORT','LA','71119','3401','CY','22017','1955-03-08','M','U',':RET:2054-5','N','021','DEN','1103653','18575LA002000201','2014-01-01','2013-12-06 11:11:54','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 20:18:51'),(4094,3271,'Y','18','021','EC','A','','','AC','0001225694','0001225694','OH00000438707','IL','1','toth','christy','','','','34','289928740','4615 N HOLLAND SYLVANIA RD',0,'TOLEDO','OH','43623','2575','CY','39095','1988-05-02','F','U',':RET:2040-4','N','021','HLT','1757524','92036OH004002601','2014-01-01','2013-12-16 18:50:04','0.00',NULL,NULL,'157.42','157.42','R-OH001','OH0','157.42',NULL,0,'2013-12-25 21:47:32'),(5210,4136,'Y','18','021','EC','A','','','AC','0001235165','0001235165','OH00000507358','IL','1','Downs','Julie','','','','34','300787709','2336 Loris Dr',0,'Dayton','OH','45449',NULL,'CY','39113','1965-12-29','F','U',':RET:2106-3','N','021','DEN','2001181','99734OH005000401','2014-01-01','2013-12-19 15:34:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:04:17'),(6284,4983,'Y','18','021','EC','A','','','AC','0000254500','0000254500','OH00000518909','IL','1','Allen','Brandon','','','','34','272920366','2928 BANNING RD',0,'CINCINNATI','OH','45239','5577','CY','39061','1984-09-23','M','U',NULL,'T','021','DEN','110382','99734OH005000401','2014-01-01','2013-12-10 20:21:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:45:26'),(21264,16993,'Y','18','021','EC','A','','','AC','0001256068','0001256068','OH00001383109','31','1','SANDIDGE','JEFF','','','','34','274580044','P.O BOX 1394',0,'ASHTABULA','OH','44005',NULL,'CY','39007','1957-08-01','M','U',':RET:2054-5','N','021','HLT','3098135','52664OH151001501','2014-03-01','2014-02-03 11:41:21','452.00',NULL,NULL,'703.78','251.78','R-OH011','OH0','703.78',NULL,0,'2014-02-03 21:01:26'),(21359,17071,'Y','18','021','EC','A','','','AC','0001166604','0001166604','TX00001970437','IL','1','DOAN','ANH','','','','34','729281435','4725 W WALNUT ST',0,'GARLAND','TX','75042','5159','CY','48113','1989-04-23','F','U',':RET:2047-9','N','021','DEN','3487996','33348TX002000201','2014-03-01','2014-02-04 14:33:09','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-04 21:00:42'),(25489,20220,'N','19','021','EC','A',NULL,NULL,'','0000446825','0000323808','','IL','1','WELLS','TREVOR','','','','34','426753183','10490 ROAD 773',0,'PHILADELPHIA','MS','39350',NULL,'CY','28099','1993-01-15','M','',':RET:2106-3','N','021','DEN','3637743','46300MS002000201','2014-04-01','2014-02-25 12:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-25 21:31:47'),(25906,20541,'Y','18','021','EC','A','','','AC','0001238160','0001238160','TX00002130546','IL','1','Holmes','Carlette','','','','34','438514455','12919 Whittington Dr.',0,'Houston','TX','77077',NULL,'CY','48201','1981-02-23','F','U',':RET:2054-5','N','021','DEN','3351757','33348TX002000201','2014-03-01','2014-02-26 14:18:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 21:01:11'),(27576,21807,'N','19','021','EC','A',NULL,NULL,'','0000440869','0000519891','','IL','1','Anderson','Samantha','Claire','','','34','276949605','703 EUCLID ST',0,'WILLARD','OH','44890','1241','CY','39077','1991-07-29','F','',':RET:2106-3','N','021','HLT','3988828','92036OH005002705','2014-04-01','2014-03-04 12:30:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99','CIC',0,'2014-03-04 21:30:22'),(9021,7157,'Y','18','021','EC','A','','','AC','0000121522','0000121522','OH00001312326','31','1','MYERS','BRENDA','SUE','','','34','297749659','P O Box 406',0,'Kingsville','OH','44048',NULL,'CY','39007','1963-07-30','F','U',':RET:2106-3','T','021','HLT','2046421','52664OH151001305','2014-01-01','2013-12-17 21:24:28','362.00',NULL,NULL,'516.60','154.60','R-OH011','OH0','516.60',NULL,0,'2013-12-26 04:05:19'),(19178,15278,'N','01','021','EC','A',NULL,NULL,'','0000067029','0000837458','','IL','1','Saltzman','Stephen','Junior-Duncan','','','34','641166164','2811 LA FRONTERA BLVD',0,'Austin','TX','78728',NULL,'CY','48453','1985-06-20','M','',':RET:2106-3','N','021','DEN','2730131','33348TX002000201','2014-03-01','2014-01-20 15:54:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-21 08:46:06'),(7835,6206,'Y','18','021','EC','A','','','AC','0000733581','0000733581','OH00000429314','31','1','DZIAK','MICHAEL','','','','34','270689680','P.O BOX 375',0,'CLYDE','OH','43410',NULL,'CY','39143','1960-02-04','M','M',':RET:2106-3','N','021','DEN','1940342','99734OH005000301','2014-01-01','2013-12-19 20:11:34','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2013-12-26 03:04:30'),(5009,3972,'Y','18','021','EC','A','','','AC','0000581452','0000581452','OH00000494429','IL','1','watkins','david','','','','34','301662024','4816 forest glen trail',0,'ravenna','OH','44266',NULL,'CY','39133','1961-06-10','M','R',':RET:2106-3','N','021','DEN','598783','99734OH005000301','2014-01-01','2013-12-07 17:19:36','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:47:18'),(16113,12907,'Y','18','021','EC','A','','','AC','0000880493','0000880493','MS00001571442','31','1','alexander','cheryl','','','','34','425439947','PO BOX 9575',0,'greenwood','MS','38930',NULL,'CY','28083','1968-03-13','F','U',':RET:2106-3','N','021','DEN','2481121','46300MS002000101','2014-02-01','2014-01-03 18:15:25','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-04 02:05:09'),(23061,18385,'Y','18','021','EC','A','','','AC','0001705683','0001705683','LA00002006587','IL','1','Gilmore','Thresea','','','','34','436177357','10442 SLIGO RD',0,'SAINT FRANCISVILLE','LA','70775','5815','CY','22125','1959-02-10','F','M',':RET:2054-5','N','021','DEN','3388819','18575LA002000201','2014-03-01','2014-02-12 13:14:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:51'),(23320,18586,'Y','18','021','EC','A','','','AC','0000205831','0000205831','OH00002249784','IL','1','musselman','stella','madonna','','','34','293601588','6417 CLOUGH PIKE',0,'CINCINNATI','OH','45244','4015','CY','39061','1966-07-15','F','M',':RET:2106-3','T','021','DEN','3435312','99734OH005000301','2014-03-01','2014-02-13 12:56:13','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:24'),(27634,21857,'Y','18','021','EC','A','','','AC','0000433968','0000433968','OH00002992239','IL','1','Vaughn','Mary','','','','34','298744286','135 EVANS AVE',0,'XENIA','OH','45385','3023','CY','39057','1974-09-28','F','U',NULL,'N','021','DEN','3302216','99734OH005000401','2014-04-01','2014-03-05 09:46:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-05 21:30:12'),(2678,2169,'N','01','021','EC','A',NULL,NULL,'','0001167969','0000182254','','IL','1','Kadlub','Joanne',NULL,NULL,NULL,NULL,NULL,'10300 SPRINGBROOK CT',0,'PAINESVILLE','OH','44077','9349','CY','39085','1952-07-08','F','',NULL,'T','021','DEN','755740','99734OH005000301','2014-01-01','2013-12-02 10:36:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:09'),(5260,4172,'Y','18','021','EC','A','','','AC','0001213461','0001213461','OH00001039178','IL','1','Hoyt','Matthew','','','','34','302600136','576 WESTMINSTER CIR',0,'AKRON','OH','44319','5503','CY','39153','1970-04-01','M','M',':RET:2106-3','N','021','HLT','1633132','52664OH151001306','2014-01-01','2013-12-19 11:04:50','435.00',NULL,NULL,'592.98','157.98','R-OH012','OH0','302.62',NULL,0,'2013-12-25 23:05:20'),(16975,13586,'N','01','021','EC','A',NULL,NULL,'','0001077629','0001238426','','IL','1','Stevens','John','Phillip','','','34','428613786','20306 28th street',0,'long beach','MS','39560',NULL,'CY','28047','1986-12-12','M','',':RET:2106-3','N','021','DEN','1755522','46300MS002000201','2014-02-01','2014-01-09 14:53:40',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 02:20:15'),(6455,5117,'Y','18','021','EC','A','','','AC','0001089534','0001089534','OH00001082412','IL','1','Watson','Donald','','','','34','279501163','1041 Cosmos St. NW',0,'Hartville','OH','44632',NULL,'CY','39151','1951-05-14','M','M',':RET:2106-3','T','021','HLT','1250473','52664OH151001501','2014-01-01','2013-12-11 07:48:03','798.00',NULL,NULL,'1484.10','686.10','R-OH015','OH0','883.69',NULL,0,'2013-12-26 00:49:47'),(14174,11300,'N','01','021','EC','A',NULL,NULL,'','0000712282','0000648270','','IL','1','rios','Maria','guadalupe','','','34','180926735','2010 12TH ST',0,'GALENA PARK','TX','77547','2206','CY','48201','1969-02-16','F','',NULL,'N','021','DEN','2405202','33348TX002000201','2014-02-01','2013-12-25 22:17:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-27 02:03:32'),(14322,11422,'Y','18','021','EC','A','','','AC','0001011572','0001011572','OH00000397383','IL','1','Brahler','Ashley','','','','34','296902126','5747 Eastview Street',0,'Louisville','OH','44641',NULL,'CY','39151','1986-12-29','F','U',NULL,'N','021','HLT','1731526','52664OH151001306','2014-02-01','2013-12-26 13:01:44','144.00',NULL,NULL,'233.71','89.71','R-OH015','OH0','233.71',NULL,0,'2013-12-27 02:07:16'),(21175,16923,'Y','18','021','EC','A','','','AC','0000388675','0000388675','OH00002358536','IL','1','Hall','Mildred','','','','34','234827687','3590 CENTER RD',0,'ZANESVILLE','OH','43701','9464','CY','39119','1953-03-23','F','U',':RET:2106-3','N','021','DEN','3824295','99734OH005000401','2014-03-01','2014-02-03 16:19:03','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-03 21:00:40'),(21492,17172,'N','01','021','EC','A',NULL,NULL,'','0000103920','0001261238','','IL','1','Lyons','Sean','M','','','34','282860903','185 Forest Green Dr.',0,'Marblehead','OH','43440',NULL,'CY','39123','1977-09-08','M','',':RET:2106-3','N','021','HLT','3702652','92036OH002002701','2014-03-01','2014-02-04 14:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','276.99',NULL,0,'2014-02-04 21:01:48'),(24870,19719,'N','19','021','EC','A',NULL,NULL,'','0000227044','0001113186','','S1','1','Oliver','William','C','','Jr','34','287110583','23 S WILLIAMS ST',0,'DAYTON','OH','45402','8236','CY','39113','2005-09-27','M','',':RET:2054-5','N','021','DEN','3718664','99734OH005000401','2014-03-01','2014-02-19 09:53:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-20 05:33:10'),(25054,19868,'Y','18','021','EC','A','','','AC','0000493289','0000493289','OH00002595127','IL','1','Ziroulo','Dominique','','','','34','272969652','971 STANWOOD AVE',0,'AKRON','OH','44314','1234','CY','39153','1992-11-22','M','U',':RET:2054-5','N','021','DEN','3429304','99734OH005000401','2014-04-01','2014-02-20 10:01:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-20 22:01:19'),(26304,20868,'Y','18','024','14','A','','','TE','0000824302','0000824302','','IL','1','Birchfield','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-02-28','M','',NULL,NULL,NULL,'','2593289','','2014-02-27','2014-02-27 00:21:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:30'),(27160,21505,'Y','18','021','EC','A','','','AC','0001249497','0001249497','TX00003572504','IL','1','Taylor','Stevie','Joe','','','34','461028487','1717 East Auburn',0,'Lubbock','TX','79403',NULL,'CY','48303','1956-08-15','M','U',':RET:2054-5','T','021','DEN','2643128','33348TX002000201','2014-04-01','2014-03-03 10:26:24','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-03-03 21:30:59'),(3082,2477,'Y','18','021','EC','A','','','AC','0000253021','0000253021','OH00001210138','IL','1','Phipps-Cvengros','Louise','','','','34','302520264','1050 WOODLAND ST NE',0,'WARREN','OH','44483','5115','CY','39155','1952-04-22','F','U',NULL,'T','021','HLT','734805','92036OH004003201','2014-01-01','2013-12-06 14:50:03','403.00',NULL,NULL,'628.96','225.96','R-OH013','OH0','628.96',NULL,0,'2013-12-25 20:19:46'),(20552,16424,'Y','18','021','EC','A','','','AC','0001241898','0001241898','OH00002392924','IL','1','TRENT','MATTHEW','','','','34','242577797','1475 EDGEWOOD DR',0,'LIMA','OH','45805','1041','CY','39003','1987-10-22','M','U',':RET:2106-3','N','021','HLT','1892323','92036OH002001501','2014-03-01','2014-01-29 11:07:00','113.00',NULL,NULL,'260.26','147.26','R-OH002','OH0','260.26',NULL,0,'2014-01-29 21:01:42'),(3085,2479,'Y','18','021','EC','A','','','AC','0000021361','0000021361','OH00001227871','IL','1','Reinhart','Michael','','','','34','300860096','1020 Half Putnam St.',0,'Findlay','OH','45840',NULL,'CY','39063','1982-10-17','M','U',':RET:2106-3','T','021','HLT','575230','92036OH004001501','2014-01-01','2013-12-06 15:25:37','0.00',NULL,NULL,'235.87','235.87','R-OH002','OH0','235.87',NULL,0,'2013-12-25 20:19:49'),(7555,5979,'Y','18','021','EC','A','','','AC','0000759693','0000759693','OH00000362921','IL','1','Willhite','Deborah','','','','34','278681273','3619 PONCIANA AVE',0,'AKRON','OH','44319','2214','CY','39153','1959-10-19','F','M',':RET:2106-3','N','021','HLT','698411','52664OH152000901','2014-01-01','2013-12-15 09:10:48','196.00',NULL,NULL,'348.73','152.73','R-OH012','OH0','348.73',NULL,0,'2013-12-26 02:33:19'),(14022,11171,'Y','18','021','EC','A','','','AC','0000865860','0000865860','OH00001254627','IL','1','HUA','KIM','','','','34','290942732','1208 HOLLY DR',0,'SPRINGFIELD','OH','45504','4141','CY','39023','1958-03-23','M','M',':RET:2047-9','N','021','HLT','2044515','92036OH002000501','2014-01-01','2013-12-23 10:50:50','888.00',NULL,NULL,'1572.96','684.96','R-OH003','OH0','612.16',NULL,0,'2013-12-26 13:16:40'),(22320,17821,'Y','18','021','EC','A','','','AC','0001770502','0001770502','LA00002525711','IL','1','LeBlanc','Sarah','','','','34','437817115','10108 AZROK AVE',0,'BATON ROUGE','LA','70809','3150','CY','22033','1991-04-19','F','U',':RET:2106-3','N','021','DEN','3264183','18575LA002000201','2014-03-01','2014-02-02 10:48:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 11:00:53'),(23696,18870,'N','19','021','EC','A',NULL,NULL,'','0001038651','0000359731','','IL','1','Cunningham','Brendan','','','','34','271139514','212 East N. St.',0,'Medina','OH','44256',NULL,'CY','39103','2006-11-07','M','',':RET:2106-3','N','021','DEN','3362929','99734OH005000401','2014-03-01','2014-02-14 10:59:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:40'),(23725,18890,'Y','18','021','EC','A','','','AC','0000412926','0000412926','TX00002005521','IL','1','Corbett','Thomas','','','','34','460026768','22427 PARK POINT DR',0,'KATY','TX','77450','5806','CY','48201','1959-05-22','M','M',':RET:2106-3','N','021','DEN','2815666','33348TX002000101','2014-03-01','2014-02-14 16:45:05','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-02-14 21:30:54'),(24212,19230,'Y','18','021','EC','A','','','AC','0001880833','0001880833','LA00001704908','IL','1','Heuer','Joan','','','','34','461985041','32122 LA 43 HWY',0,'ALBANY','LA','70711','2212','CY','22063','1955-03-14','F','U',':RET:2106-3','N','021','DEN','3848470','18575LA002000201','2014-04-01','2014-02-16 17:46:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-16 19:00:24'),(24525,19482,'Y','18','021','EC','A','','','AC','0001023473','0001023473','TX00002324969','IL','1','Martinez','Sylvia','','','','34','467232620','1215 E 8TH ST',0,'LITTLEFIELD','TX','79339','4203','CY','48279','1953-02-22','F','M',NULL,'N','021','DEN','3477215','33348TX002000201','2014-04-01','2014-02-19 15:41:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 03:58:47'),(25919,20554,'Y','18','024','14','A','','','TE','0000611073','0000611073','','IL','1','Boyle-Court','Benjamn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-10-25','M','',NULL,NULL,NULL,'','2977051','','2014-03-13','2014-02-26 15:36:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-26 21:01:19'),(699,576,'Y','18','021','EC','A','','','AC','0000172380','0000172380','OH00000487155','IL','1','Krenisky','Jennifer','','','','34','280583138','5997 ROOT RD',0,'CONNEAUT','OH','44030','9749','CY','39007','1955-02-20','F','M',':RET:2106-3','N','021','DEN','1381535','99734OH005000301','2014-01-01','2013-12-16 17:58:30','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:02:51'),(18722,14922,'N','01','021','EC','A',NULL,NULL,'','0000084072','0000414721','','IL','1','Johnson','Kevin','','','','34','269709622','1381 PEBBLE CT',0,'CINCINNATI','OH','45255',NULL,'CY','39061','1964-06-20','M','',NULL,'N','021','DEN','2779642','99734OH005000301','2014-02-01','2014-01-15 23:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:34'),(3206,2580,'Y','18','021','EC','A','','','AC','0000858456','0000858456','OH00001232682','IL','1','Mahone','Terence','','','','34','269528660','1404 E MCMILLAN ST',0,'CINCINNATI','OH','45206','2242','CY','39061','1965-11-24','M','M',':RET:2106-3','N','021','DEN','100398','99734OH005000301','2014-01-01','2013-10-31 23:29:49','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:45:19'),(8845,7011,'Y','18','021','EC','A','','','AC','0000481854','0000481854','TX00000944688','IL','1','Michon','Arthur','','','','34','466832579','1707 AVENUE B',0,'SANTA ANNA','TX','76878','1809','CY','48083','1977-01-13','M','U',':RET:2106-3','T','021','DEN','2081963','33348TX002000201','2014-01-01','2013-12-18 06:15:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:52'),(15736,12587,'N','01','021','EC','A',NULL,NULL,'','0000271433','0001058013','','IL','1','CUPP','DAVID','','','','34','287505887','4317 LINCHMERE DR',0,'DAYTON','OH','45415','1810','CY','39113','1950-06-01','M','',':RET:2106-3','N','021','DEN','1610926','99734OH005000301','2014-02-01','2014-01-02 15:00:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:00:40'),(14190,11315,'Y','18','024','14','A','','','TE','0000252004','0000252004','','IL','1','Killen','Molly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-16','F','',NULL,NULL,NULL,'','667266','','2013-12-26','2013-12-26 12:45:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:03:58'),(20649,16500,'Y','18','021','EC','A','','','AC','0000269151','0000269151','TX00001846673','IL','1','ulanowski','Bradley','','','','34','457474493','7304 BRIARWYCK CT',0,'FT WORTH','TX','76137','1700','CY','48439','1979-02-22','M','M',NULL,'N','021','DEN','2321407','33348TX002000201','2014-03-01','2014-01-30 14:48:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:37'),(25047,19864,'Y','18','021','EC','A','','','AC','0000874755','0000874755','OH00002724569','IL','1','SABIROV','ELDAR','','','','34','271080228','6818 LAKESIDE DR',0,'WEST CHESTER','OH','45069','7675','CY','39017','1982-06-07','M','M',NULL,'T','021','DEN','3463338','99734OH005000401','2014-04-01','2014-02-19 21:46:03','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:14'),(200,166,'Y','18','021','EC','A','','','AC','0001125407','0001125407','OH00000824875','IL','1','King','Diane','','','','34','272542274','1005 Loretta Place',0,'Lima','OH','45805',NULL,'CY','39003','1951-02-06','F','U',':RET:2106-3','N','021','HLT','20221','92036OH005001501','2014-01-01','2013-12-04 20:14:36','395.00',NULL,NULL,'632.30','237.30','R-OH002','OH0','632.30',NULL,0,'2013-12-25 17:20:10'),(5601,4444,'N','01','021','EC','A',NULL,NULL,'','0000574417','0001029330','','IL','1','PHAM','THANG','','','','34','605226821','2755 LOCH RAVEN BLVD',0,'COPLEY','OH','44321','2165','CY','39153','1967-12-07','M','',NULL,'N','021','DEN','589013','99734OH005000401','2014-01-01','2013-11-25 18:38:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:14'),(618,509,'Y','18','021','EC','A','','','AC','0000614091','0000614091','OH00000098042','IL','1','SCHROEDER','SHELLY','','','','34','274681855','2441 MASSILLON ST',0,'FINDLAY','OH','45840','4685','CY','39063','1958-11-03','F','U',':RET:2106-3','N','021','DEN','2055167','99734OH005000401','2014-01-01','2013-12-16 11:18:24','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:00:45'),(4870,3861,'Y','18','024','14','A','','','TE','0000099701','0000099701','','IL','1','Farmer','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-12-03','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 22:30:59'),(19330,15409,'Y','18','024','14','A','','','TE','0000945516','0000945516','','IL','1','Pando','Empress',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-10-03','F','',NULL,NULL,NULL,'','2231229','','2014-01-21','2014-01-21 01:30:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:16'),(4042,3226,'Y','18','021','EC','A','','','AC','0000558135','0000558135','OH00000386733','IL','1','Diamond','Ariel','','','','34','344729683','1022 FAUROT AVE',0,'LIMA','OH','45805','3218','CY','39003','1983-02-19','F','U',':RET:2054-5','N','021','DEN','2281305','99734OH005000401','2014-01-01','2013-12-17 11:21:05','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:46:07'),(27602,21830,'Y','18','021','EC','A','','','AC','0000661411','0000661411','OH00003699231','IL','1','Tuuri','Mary','Ann','','','34','302627420','4414 Lesher Dr.',0,'Kettering','OH','45429',NULL,'CY','39113','1957-02-14','F','U',':RET:2106-3','N','021','HLT','3533474','92036OH004000501','2014-04-01','2014-03-05 08:37:50','409.00',NULL,NULL,'465.80','56.80','R-OH003','OH0','465.80','CIC',0,'2014-03-05 21:00:23'),(858,710,'N','01','021','EC','A',NULL,NULL,'','0001094629','0000079895','','IL','1','Carmichael','James','F','','','34','300481176','7548 FORT AMANDA RD',0,'LIMA','OH','45806','9332','CY','39003','1951-01-13','M','',':RET:2106-3','T','021','HLT','1411122','92036OH005001501','2014-01-01','2013-12-16 15:00:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','727.15',NULL,0,'2013-12-25 18:07:05'),(26099,20699,'Y','18','021','EC','A','','','AC','0001778133','0001778133','LA00002955726','IL','1','Briesacher','Jann','','','','34','355480324','PO Box 517',0,'Baton Rouge','LA','70821',NULL,'CY','22033','1953-06-05','F','U',NULL,'N','021','DEN','3386968','18575LA002000201','2014-03-01','2014-02-27 15:12:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 06:30:12'),(4169,3319,'Y','18','021','EC','A','','','AC','0000874684','0000874684','OH00000619011','IL','1','CONNOLLY','JOHN','','','','34','299542670','2712 120TH ST',0,'TOLEDO','OH','43611',NULL,'CY','39095','1954-10-16','M','U',':RET:2106-3','N','021','DEN','1918181','99734OH005000301','2014-01-01','2013-12-17 16:54:08','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:49:10'),(5959,4720,'Y','18','021','EC','A','','','AC','0000781906','0000781906','OH00000280711','IL','1','Jensen','Donna',NULL,NULL,NULL,NULL,NULL,'2630 BRITAINIA CT',0,'TOLEDO','OH','43617','2326','CY','39095','1960-04-11','F','U',':RET:2106-3','N','021','HLT','1748751','92036OH001002601','2014-01-01','2013-12-23 23:51:30','0.00',NULL,NULL,'479.83','479.83','R-OH001','OH0','479.83',NULL,0,'2013-12-25 23:51:21'),(25778,20443,'Y','18','021','EC','A','','','AC','0002277365','0002277365','LA00002651099','IL','1','LEEFORT','JOHNNETTA','','','','34','425066846','737 WRIGHT AVE',0,'GRETNA','LA','70056','4156','CY','22051','1956-04-07','F','U',':RET:2054-5','N','021','DEN','3244316','18575LA002000101','2014-04-01','2014-02-24 16:05:31','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-26 09:30:59'),(5969,4725,'Y','18','021','EC','A','','','AC','0000386268','0000386268','MS00000200483','31','1','McCraney','Courtney','','','','34','427471740','P.O. Box 4142',0,'Laurel','MS','39443',NULL,'CY','28067','1983-03-07','F','U',NULL,'N','021','DEN','2327023','46300MS002000101','2014-01-01','2013-12-23 22:34:09','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2013-12-25 23:51:33'),(24958,19792,'Y','18','021','EC','A','','','AC','0002180130','0002180130','LA00002525042','IL','1','Trent','Jeannie','','','','34','435908924','411 KING ST',0,'JENNINGS','LA','70546','7426','CY','22053','1953-07-05','F','U',':RET:2054-5','N','021','DEN','3853366','18575LA002000201','2014-04-01','2014-02-20 14:09:20','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-20 22:00:17'),(24208,19226,'Y','18','021','EC','A','','','AC','0002140691','0002140691','LA00002463186','31','1','DUCOTE','ROBBY','','','','34','437550718','PO BOX 806',0,'PORT BARRE','LA','70577',NULL,'CY','22097','1977-07-14','M','U',':RET:2106-3','N','021','DEN','3005154','18575LA002000201','2014-04-01','2014-02-16 00:30:44','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-16 19:00:21'),(24114,19169,'Y','18','021','EC','A','','','AC','0000102508','0000102508','TX00002452020','IL','1','Yanez','Ismael','','','','34','454110561','1221 San Antonio',0,'El Paso','TX','79901',NULL,'CY','48141','1955-12-07','M','U',':RET:2106-3','N','021','DEN','3295408','33348TX002000201','2014-03-01','2014-02-15 13:23:28','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-15 22:01:38'),(15319,12251,'Y','18','021','EC','A','','','AC','0000126816','0000126816','TX00001887030','IL','1','Pedroza','nolberto','','','','34','457634178','607 W 7TH ST',0,'LITTLEFIELD','TX','79339','3229','CY','48279','1968-04-03','M','M',NULL,'N','021','DEN','2484726','33348TX002000201','2014-02-01','2013-12-31 20:04:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:23:28'),(21077,16843,'Y','18','021','EC','A','','','AC','0000494476','0000494476','OH00002251955','IL','1','Friedman','Keith','','','','34','549578769','10009 Zig Zag Road',0,'Cincinnati','OH','45242',NULL,'CY','39061','1978-12-20','M','U',':RET:2106-3','N','021','DEN','2785073','99734OH005000401','2014-03-01','2014-02-02 17:11:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-02 19:00:20'),(461,376,'Y','18','021','EC','A','','','AC','0000814256','0000814256','OH00000288341','IL','1','Myerson','Melissa','','','','34','284880210','3870 Hadcock Road',0,'Brunswick','OH','44212',NULL,'CY','39103','1984-06-18','F','U',':RET:2106-3','T','021','HLT','95803','52664OH151001301','2014-01-01','2013-12-04 15:30:21','0.00',NULL,NULL,'286.98','286.98','R-OH012','OH0','286.98',NULL,0,'2013-12-25 17:47:37'),(25492,20222,'Y','18','021','EC','A','','','AC','0000200462','0000200462','MS00003220238','IL','1','CATCHINGS','PATRICIA','','','','34','587069132','5186 BETHESDA RD',0,'CRYSTAL SPRINGS','MS','39059',NULL,'CY','28029','1959-06-12','F','U',NULL,'N','021','DEN','2670851','46300MS002000201','2014-04-01','2014-02-25 13:42:58','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-25 21:31:48'),(19918,15884,'N','01','021','EC','A',NULL,NULL,'','0000321786','0001080693','','IL','1','Wreyford','Robert','N','','','34','465854691','1204 SAN BERNARD ST',0,'AUSTIN','TX','78702','1129','CY','48453','1975-06-14','M','',':RET:2106-3','N','021','DEN','2680394','33348TX002000101','2014-03-01','2014-01-24 12:19:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-24 21:01:03'),(16915,13536,'Y','18','021','EC','A','','','AC','0000853055','0000853055','OH00001664278','IL','1','Riggs','Leann','','','','34','302565978','3551 STATE ROUTE 152',0,'DILLONVALE','OH','43917','7919','CY','39081','1954-08-11','F','M',':RET:2106-3','N','021','DEN','2528895','99734OH005000401','2014-02-01','2014-01-09 13:52:47','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-13 02:19:40'),(6568,5207,'Y','18','021','EC','A','','','AC','0000498324','0000498324','TX00000322807','IL','1','ramirez','sylvia','','','','34','449316223','7907 Hermosillo Dr.',0,'El Paso','TX','79915',NULL,'CY','48141','1959-10-10','F','M',NULL,'N','021','DEN','988846','33348TX002000201','2014-01-01','2013-12-11 15:16:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 00:52:35'),(4846,3839,'N','01','021','EC','A',NULL,NULL,'','0000690707','0001077700','','IL','1','Sarisky','Jacqueline','','','','34','285520777','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1953-01-05','F','',':RET:1002-5^:RET:2106-3','T','021','DEN','424131','99734OH005000401','2014-01-01','2013-11-08 09:36:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:30:14'),(6492,5143,'Y','18','021','EC','A','','','AC','0000780470','0000780470','OH00000059715','IL','1','Treadway','Karen','A','','','34','279500538','762 SANDY LAKE RD',0,'KENT','OH','44240','6753','CY','39133','1949-04-07','F','U',NULL,'T','021','HLT','827433','52664OH151001306','2014-01-01','2013-12-11 12:57:13','561.00',NULL,NULL,'769.35','208.35','R-OH012','OH0','769.35',NULL,0,'2013-12-26 00:50:36'),(4088,3265,'N','19','021','EC','A',NULL,NULL,'','0000675436','0000564195','','IL','1','Chantalou','Candice','','','','34','220417969','502 S WINTERGARDEN RD',0,'BOWLING GREEN','OH','43402','3540','CY','39173','1994-05-09','F','',NULL,'N','021','HLT','1963754','92036OH005002606','2014-01-01','2013-12-17 10:07:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-25 21:47:21'),(5814,4619,'Y','18','021','EC','A','','','AC','0001062373','0001062373','TX00000972752','IL','1','Eisenman','Bonnie','','','','34','444483462','6905 MEADOW PARK N',0,'NORTH RICHLAND HILLS','TX','76180','6609','CY','48439','1956-11-03','F','M',':RET:2106-3','N','021','DEN','2212073','33348TX002000201','2014-01-01','2013-12-23 21:55:34','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:47:51'),(26441,20973,'Y','18','024','14','A','','','TE','0000438000','0000438000','','IL','1','ADAMS','MITCHELL','CALVIN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-19','M','',NULL,NULL,NULL,'','2907140','','2014-02-26','2014-02-26 18:47:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:30:21'),(27231,21564,'Y','18','021','EC','A','','','AC','0001117315','0001117315','OH00002075905','IL','1','Montague','Delilah','','','','34','295841346','131 Noran Circle',0,'Bedford','OH','44146',NULL,'CY','39035','1985-01-06','F','U',':RET:2054-5','N','021','HLT','3879202','92036OH004000801','2014-04-01','2014-03-02 21:25:53','394.00',NULL,NULL,'449.12','55.12','R-OH011','OH0','210.36',NULL,0,'2014-03-03 21:31:41'),(28715,22725,'Y','18','021','EC','A','','','AC','0000813148','0000813148','OH00003534157','IL','1','williams','carole','','','','34','298506506','2576 SPRAGUE RD',0,'BETHEL','OH','45106','9338','CY','39025','1952-03-08','F','U',':RET:2106-3','T','021','HLT','3791907','92036OH004000601','2014-04-01','2014-03-08 13:21:47','403.00',NULL,NULL,'570.30','167.30','R-OH005','OH0','570.30',NULL,0,'2014-03-08 21:31:17'),(23319,18585,'N','01','021','EC','A',NULL,NULL,'','0001093178','0000181048','','IL','1','Seebaluck','Pingala','','','','34','734917319','612 SNIDER CT',0,'MASON','OH','45040','1384','CY','39165','1964-07-04','F','',':RET:2029-7','N','021','DEN','2997510','99734OH005000301','2014-03-01','2014-02-13 12:55:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:24'),(14329,11429,'Y','18','021','EC','A','','','AC','0000282020','0000282020','OH00000256407','IL','1','Fellabaum','Bruce','','','','34','377662581','1221 HIDDEN RIDGE RD',0,'TOLEDO','OH','43615','6724','CY','39095','1957-02-13','M','U',':RET:2106-3','N','021','HLT','2485791','92036OH003002601','2014-02-01','2013-12-26 16:26:19','0.00',NULL,NULL,'475.07','475.07','R-OH001','OH0','475.07',NULL,0,'2013-12-27 02:07:29'),(14199,11323,'Y','18','021','EC','A','','','AC','0000253290','0000253290','TX00000233547','IL','1','Chen','Marlon','','','','34','451578554','2392 HWY 71 West',0,'Cedar Creek','TX','78751',NULL,'CY','48453','1955-05-26','M','M',':RET:2028-9','N','021','DEN','1552971','33348TX002000201','2014-02-01','2013-12-26 13:20:12','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-27 02:04:11'),(20412,16303,'Y','18','021','EC','A','','','AC','0001056394','0001056394','TX00001899278','IL','1','RODRIGUEZ','DIAMANTINA','','','','34','451339927','1305 MELWOOD AVE',0,'BROWNWOOD','TX','76801','2541','CY','48049','1959-05-17','F','M',NULL,'N','021','DEN','3171168','33348TX002000201','2014-03-01','2014-01-29 17:01:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:25'),(24191,19217,'Y','18','021','EC','A','','','AC','0000076346','0000076346','OH00002680624','IL','1','Garrison','Kimberley','E','','','34','301643829','88 Ralph Morrison Rd',0,'Peebles','OH','45660',NULL,'CY','39001','1965-03-09','F','M',':RET:2106-3','N','021','DEN','3579054','99734OH005000301','2014-03-01','2014-02-15 19:30:22','0.00',NULL,NULL,'87.78','87.78','R-OH005','OH0','0.00',NULL,0,'2014-02-16 19:00:14'),(19999,15952,'N','01','021','EC','A',NULL,NULL,'','0000946141','0000886945','','IL','1','McCown','Brandie','Lee','','','34','286800490','1818 NASON AVE',0,'COLUMBUS','OH','43207','1678','CY','39049','1975-12-23','F','',':RET:2106-3','T','021','DEN','2067773','99734OH005000401','2014-03-01','2014-01-26 11:06:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:04'),(17924,14318,'Y','18','021','EC','A','','','AC','0000078298','0000078298','TX00001720414','IL','1','DANSORD','WENDY','','','','34','458670368','102 SOUTH TYLER AVE',0,'DAWSON','TX','76639',NULL,'CY','48349','1971-12-30','F','U',NULL,'N','021','DEN','2348494','33348TX002000201','2014-02-01','2014-01-14 11:39:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:32'),(9256,7340,'Y','18','021','EC','A','','','AC','0000893743','0000893743','TX00000452034','IL','1','Tovar','Patricia','','','','34','645107125','506 ESPINO DR',0,'LAREDO','TX','78046','8530','CY','48479','1976-05-04','F','M',NULL,'N','021','DEN','34569','33348TX002000201','2014-01-01','2013-11-30 13:43:12','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-26 04:15:08'),(15584,12471,'Y','18','024','14','A','','','TE','0000114189','0000114189','','IL','1','Smith','Todd',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-03-29','M','',NULL,NULL,NULL,'','1632554','','2013-12-30','2013-12-30 19:35:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:16'),(15273,12210,'Y','18','021','EC','A','','','AC','0000637121','0000637121','OH00001832903','IL','1','Fournier','Richard','','','','34','286867034','1961 PARKGATE AVE',0,'AKRON','OH','44320','1107','CY','39153','1981-12-14','M','M',':RET:2106-3','T','021','DEN','1876756','99734OH005000401','2014-02-01','2013-12-31 21:25:56','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,1,'2014-01-02 04:21:53'),(6260,4962,'Y','18','024','14','A','','','TE','0000162235','0000162235','','IL','1','Cooper','Julian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-01','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:32:14'),(24730,19633,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000253096','','IL','1','HENRY','QUAN DEZ','','','','34','270088561','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2002-09-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:07'),(22133,17665,'Y','18','021','EC','A','','','AC','0000986046','0000986046','OH00002244688','IL','1','Miller','Pete','','','','34','277082726','4973 STATE ROUTE 7',0,'ANDOVER','OH','44003','9663','CY','39007','1984-11-25','M','U',':RET:2106-3','T','021','DEN','3451745','99734OH005000401','2014-03-01','2014-02-08 12:04:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-08 19:00:44'),(20827,16646,'Y','18','024','14','A','','','TE','0001658415','0001658415','','IL','1','Ictech','Gaye','carmen',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-04-17','F','',NULL,NULL,NULL,'','2150392','','2014-01-31','2014-01-31 15:14:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-31 21:00:39'),(17668,14119,'Y','18','021','EC','A','','','AC','0001050659','0001050659','OH00002095430','IL','1','Sarafin','Daniel','','','','34','291548979','3241 SUGARTREE RD',0,'BETHEL','OH','45106','9329','CY','39025','1959-03-11','M','M',':RET:2106-3','N','021','DEN','2301264','99734OH005000301','2014-02-01','2014-01-13 16:48:45','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2014-01-14 01:32:48'),(3222,2593,'Y','18','021','EC','A','','','AC','0000602238','0000602238','OH00000215661','IL','1','Lawson','Aaron','','','','34','291867354','104 Plaza ct',0,'Akron','OH','44312',NULL,'CY','39153','1974-10-02','M','U',':RET:2106-3','N','021','HLT','892356','52664OH152000901','2014-01-01','2013-10-31 20:04:31','191.00',NULL,NULL,'206.14','15.14','R-OH012','OH0','206.14',NULL,0,'2013-12-25 20:45:46'),(3903,3123,'Y','18','021','EC','A','','','AC','0000284870','0000284870','MS00000876561','IL','1','Ray','Barbara','','','','34','428196107','1562 Alan Dr',0,'Clarksdale','MS','38614',NULL,'CY','28027','1961-10-17','F','M',':RET:2054-5','N','021','DEN','946774','46300MS002000101','2014-01-01','2013-12-13 18:17:52','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 21:36:53'),(8019,6348,'Y','18','021','EC','A','','','AC','0001239117','0001239117','OH00000121569','IL','1','gampher','charlynn','','','','34','270889397','2180 STEWARD HARBOUGH RD',0,'WILLIAMSBURG','OH','45176','9425','CY','39015','1980-01-01','F','U',NULL,'N','021','HLT','2205251','92036OH006000601','2014-01-01','2013-12-20 15:39:12','100.00',NULL,NULL,'206.68','106.68','R-OH005','OH0','206.68',NULL,0,'2013-12-26 03:08:51'),(26780,21224,'Y','18','021','EC','A','','','AC','0000276701','0000276701','TX00002970137','IL','1','Newey','Carter','Martyn','','','34','646093141','7200 N Main St',0,'McAllen','TX','78504',NULL,'CY','48215','1988-02-22','M','M',':RET:2106-3','N','021','DEN','3704693','33348TX002000201','2014-04-01','2014-03-01 00:49:04','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-01 21:00:13'),(290,239,'Y','18','021','EC','A','','','AC','0000377836','0000377836','TX00000862736','IL','1','Mobley','Stephen','','','','34','636167211','4033 Gilbert Ave.',0,'Dallas','TX','75219',NULL,'CY','48113','1990-04-06','M','U',NULL,'N','021','DEN','582255','33348TX002000101','2014-01-01','2013-10-12 15:51:14','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 17:30:30'),(20272,16177,'Y','18','021','EC','A','','','AC','0001113175','0001113175','OH00001640419','IL','1','Redmond','Marsha','','','','34','233905045','1045 SANDHILL RD',0,'MARIETTA','OH','45750','8780','CY','39167','1954-02-14','F','U',NULL,'N','021','DEN','1363498','99734OH005000401','2014-03-01','2014-01-27 19:41:12','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-01-28 21:00:24'),(5769,4583,'Y','18','021','EC','A','','','AC','0000645975','0000645975','OH00001286096','IL','1','Eck','Kyle','','','','34','399024791','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1986-09-02','M','R',':RET:2106-3','T','021','DEN','1813473','99734OH005000401','2014-01-01','2013-12-23 22:34:27','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:44'),(26275,20842,'Y','18','021','EC','A','','','AC','0001452433','0001452433','LA00003040072','IL','1','Mcknight','Kizzy','','','','34','435350062','30253 Hoppy Lane',0,'Independnece','LA','70443',NULL,'CY','22063','1977-06-09','F','U',':RET:2054-5','N','021','DEN','3627467','18575LA002000101','2014-04-01','2014-02-26 20:09:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-28 06:31:18'),(6536,5182,'Y','18','021','EC','A','','','AC','0000830336','0000830336','TX00000815364','IL','1','Kim','Hwa','','','','34','494725508','1432 MORITZ DR',0,'HOUSTON','TX','77055','3206','CY','48201','1951-09-07','F','U',':RET:2040-4','N','021','DEN','1124057','33348TX002000201','2014-01-01','2013-12-10 22:26:18','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:51:47'),(7103,5634,'Y','18','021','EC','A','','','AC','0000294416','0000294416','OH00000181358','IL','1','Teeter','Susan','','','','34','180560240','9211 Deercross Pkwy 1B',0,'Cincinnati','OH','45236',NULL,'CY','39061','1962-08-02','F','M',':RET:2106-3','N','021','HLT','1945638','92036OH004001201','2014-01-01','2013-12-24 23:05:26','662.00',NULL,NULL,'771.25','109.25','R-OH004','OH0','321.93',NULL,0,'2013-12-26 01:50:49'),(16865,13494,'Y','18','021','EC','A','','','AC','0001019894','0001019894','TX00001846196','IL','1','CONSTANTE','ERNESTINA','','','','34','640035722','3701 CIMARRON BLVD',0,'CORPUS CHRISTI','TX','78414','3687','CY','48355','1979-10-27','F','M',NULL,'N','021','DEN','2399625','33348TX002000201','2014-02-01','2014-01-09 12:04:05','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-13 02:19:12'),(24193,19217,'N','19','021','EC','A',NULL,NULL,'','0000076346','0000321077','','S1','1','Garrison','Gregory','L','','','34','286983749','88 Ralph Morrison Rd',0,'Peebles','OH','45660',NULL,'CY','39001','1995-08-09','F','',':RET:2106-3','N','021','DEN','3579054','99734OH005000301','2014-03-01','2014-02-15 19:30:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-16 19:00:14'),(26936,21347,'N','01','021','EC','A',NULL,NULL,'','0000884280','0000262782','','IL','1','Kettler','Roberta','','','','34','272560932','29674 TOWNSHIP ROAD 30',0,'WARSAW','OH','43844','9754','CY','39031','1953-07-19','F','',':RET:2106-3','N','021','DEN','2873243','99734OH005000301','2014-04-01','2014-03-02 11:04:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:22'),(868,718,'N','01','021','EC','A',NULL,NULL,'','0000705127','0000425067','','IL','1','Vargas Escorcia','Juan',NULL,NULL,NULL,NULL,NULL,'496 N Firestone Blvd',0,'Akron','OH','44301',NULL,'CY','39153','1962-03-08','M','',NULL,'N','021','HLT','2445667','52664OH151001501','2014-01-01','2013-12-16 10:49:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','498.82',NULL,0,'2013-12-25 18:07:23'),(22764,18175,'Y','18','021','EC','A','','','AC','0001092170','0001092170','OH00002106949','IL','1','PALOMBO','CHRISTINE','','','','34','268441512','7935 NORRITON CIR NW',0,'NORTH CANTON','OH','44720','5623','CY','39151','1950-10-13','F','U',NULL,'N','021','DEN','3107634','99734OH005000401','2014-03-01','2014-02-11 11:12:55','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-11 21:01:34'),(21112,16869,'Y','18','024','14','A','','','TE','0002045234','0002045234','','IL','1','Davis','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-20','M','',NULL,NULL,NULL,'','3418607','','2014-02-03','2014-02-03 15:09:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-03 21:00:08'),(14766,11789,'Y','18','021','EC','A','','','AC','0000584392','0000584392','TX00000012850','IL','1','HERNANDEZ','CRISTAL','','','','34','645109170','2841 OLD ANSON RD',0,'ABILENE','TX','79603','1835','CY','48441','1986-08-23','F','U',NULL,'N','021','DEN','2383543','33348TX002000201','2014-01-01','2013-12-23 20:07:36','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,1,'2013-12-29 11:12:48'),(27946,22107,'N','01','021','EC','A',NULL,NULL,'','0000242590','0001053723','','IL','1','SANDERS','MARION','','','Sr','34','178446255','5613 SILTSTONE LOOP',0,'KILLEEN','TX','76542','5763','CY','48027','1954-01-29','M','',':RET:2054-5','N','021','DEN','2906700','33348TX002000201','2014-04-01','2014-03-06 15:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:35'),(16853,13483,'Y','18','021','EC','A','','','AC','0000338891','0000338891','OH00001619108','IL','1','Hoffman','David','','','','34','285821546','320 Leona',0,'Celina','OH','45822',NULL,'CY','39107','1975-09-01','M','U',NULL,'N','021','HLT','1916293','92036OH003001506','2014-02-01','2014-01-11 14:30:32','239.00',NULL,NULL,'286.39','47.39','R-OH002','OH0','286.39',NULL,0,'2014-01-13 02:18:41'),(16953,13569,'Y','18','021','EC','A','','','AC','0001247774','0001247774','MS00001859725','31','1','Hunter','Brenda','','','','34','428064801','P.O.Box 544',0,'Greenville','MS','38701',NULL,'CY','28151','1958-05-28','F','U',':RET:2054-5','N','021','DEN','2352003','46300MS002000101','2014-02-01','2014-01-08 19:31:19','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:20:01'),(22979,18321,'N','01','021','EC','A',NULL,NULL,'','0000172455','0000167811','','IL','1','Winchell','Bonnie','L','','','34','296481178','3537 BULAH RD',0,'JEFFERSON','OH','44047','9446','CY','39007','1953-10-15','F','',':RET:2106-3','N','021','DEN','3256024','99734OH005000301','2014-03-01','2014-02-11 21:14:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:07'),(22893,18250,'N','01','021','EC','A',NULL,NULL,'','0000350609','0000909517','','IL','1','DeKay','James','','','','34','289760434','13555 NEAPOLIS WATERVILLE RD',0,'GRAND RAPIDS','OH','43522','9649','CY','39095','1965-10-30','M','',':RET:2106-3','N','021','HLT','2886147','92036OH003002604','2014-03-01','2014-02-11 13:16:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','332.95',NULL,0,'2014-02-11 21:02:37'),(19313,15395,'N','01','021','EC','A',NULL,NULL,'','0000105057','0000792249','','IL','1','ANGULO','MARIA','DEL CARMEN','','','34','634606979','14121 ENTRADA LOOP',0,'LAREDO','TX','78045',NULL,'CY','48479','1968-12-27','F','',NULL,'N','021','DEN','1557346','33348TX002000201','2014-03-01','2014-01-20 22:40:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-22 03:22:07'),(22246,17756,'N','01','021','EC','A',NULL,NULL,'','0000651587','0001062418','','IL','1','RAMIREZ','CLAUDIA','','','','34','415951676','5933 ALEXANDRIA LN',0,'SOUTHAVEN','MS','38671','1829','CY','28033','1981-01-13','F','',NULL,'N','021','DEN','2819235','46300MS002000101','2014-03-01','2014-02-09 13:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-09 19:00:40'),(21088,16851,'Y','18','021','EC','A','','','AC','0000933239','0000933239','OH00002050413','IL','1','Johns','Kathleen','','','','34','500607845','798 S Johnsville Rd',0,'New Lebanon','OH','45345',NULL,'CY','39113','1951-11-11','F','U',':RET:2106-3','N','021','DEN','3771293','99734OH005000301','2014-03-01','2014-02-02 15:35:36','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-02 19:00:25'),(1493,1246,'Y','18','021','EC','A','','','AC','0000173811','0000173811','OH00000732164','IL','1','Nelms','Darlene','','','','34','298680845','3670 LARKWELL WAY',0,'COLUMBUS','OH','43232','3611','CY','39049','1960-05-23','F','U',NULL,'N','021','DEN','2234549','99734OH005000401','2014-01-01','2013-12-24 11:18:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:05'),(19592,15618,'Y','18','021','EC','A','','','AC','0000060242','0000060242','MS00001705762','IL','1','DOSS','JIMMY','L','','','34','426416711','2619 TOGO ST',0,'VICKSBURG','MS','39180','4244','CY','28149','1979-07-23','M','U',NULL,'N','021','DEN','3202392','46300MS002000201','2014-03-01','2014-01-22 17:47:27','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-23 03:02:44'),(19545,15579,'Y','18','021','EC','A','','','AC','0000412084','0000412084','MS00002315029','31','1','GLADNEY','LINDA','','','','34','426087926','PO BOX',0,'OXFORD','MS','38655',NULL,'CY','28071','1970-01-03','F','U',':RET:2054-5','N','021','DEN','2387110','46300MS002000101','2014-03-01','2014-01-22 09:39:18','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-01-23 03:02:26'),(14651,11694,'Y','18','021','EC','A','','','AC','0000389432','0000389432','TX00000696618','IL','1','Williams','Nixon','','','','34','437713695','6635 S STAPLES ST',0,'CORPUS CHRISTI','TX','78413','5400','CY','48355','1980-09-09','M','U',':RET:2054-5','N','021','DEN','1447949','33348TX002000201','2014-02-01','2013-12-27 19:45:21','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2013-12-29 11:07:44'),(9300,7373,'Y','18','021','EC','A','','','AC','0000144183','0000144183','OH00000045017','IL','1','Bernola','Steven','','','','34','270468608','332 PORTZ AVE',0,'FINDLAY','OH','45840','2430','CY','39063','1964-08-30','M','U',':RET:2106-3','N','021','HLT','1147270','92036OH002001501','2014-01-01','2013-11-30 13:28:21','0.00',NULL,NULL,'433.61','433.61','R-OH002','OH0','433.61',NULL,0,'2013-12-26 04:16:21'),(3244,2614,'Y','18','021','EC','A','','','AC','0000453874','0000453874','OH00000312944','IL','1','Knight','Carolyn','','','','34','273545376','5826 SHADY COVE LN',0,'TROTWOOD','OH','45426','2118','CY','39113','1963-08-10','F','U',':RET:2054-5','N','021','DEN','1104616','99734OH005000401','2014-01-01','2013-11-27 18:24:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:46:26'),(5269,4179,'N','19','021','EC','A',NULL,NULL,'','0000696804','0000743077','','S1','1','Vaccaro','Raphael','M',NULL,NULL,NULL,NULL,'2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','2013-03-14','F','',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:05:32'),(8918,7072,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000691823','','IL','1','TURNER','BRIAN','A','','','34','301087538','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2004-07-24','M','',NULL,'N','021','DEN','1914082','99734OH005000401','2014-01-01','2013-12-18 05:39:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:02:44'),(6252,4954,'Y','18','021','EC','A','','','AC','0000533268','0000533268','OH00000439459','IL','1','EMERUWA','CAROL','','','','34','269544250','3775 BRIDGEVIEW DR',0,'SOUTH EUCLID','OH','44121','1930','CY','39035','1952-10-06','F','U',':RET:2054-5','N','021','HLT','62542','52664OH151001306','2014-01-01','2013-11-19 17:08:51','522.00',NULL,NULL,'706.77','184.77','R-OH011','OH0','706.77',NULL,0,'2013-12-26 00:31:59'),(6022,4766,'Y','18','021','EC','A','','','AC','0000932349','0000932349','TX00000024677','IL','1','Uribe','Christian','','','','34','640202309','125 CORONADO RD',0,'EL PASO','TX','79915','3671','CY','48141','1986-12-22','F','U',':RET:2106-3','N','021','DEN','733191','33348TX002000201','2014-01-01','2013-12-01 13:07:50','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 00:00:53'),(27494,21754,'Y','18','021','EC','A','','','AC','0000234114','0000234114','OH00003723502','IL','1','McCullough','Rick','L','','','34','302587380','125 TAYLOR BLVD',0,'LAGRANGE','OH','44050','9301','CY','39093','1956-03-23','M','U',':RET:2106-3','T','021','HLT','3994110','52664OH151001304','2014-04-01','2014-03-04 13:02:10','340.00',NULL,NULL,'737.00','397.00','R-OH011','OH0','737.00',NULL,0,'2014-03-04 21:02:24'),(1636,1366,'N','01','021','EC','A',NULL,NULL,'','0000291938','0000914829','','IL','1','Horlander','Lisa','','','','34','633269304','2308 SARASOTA DR',0,'TYLER','TX','75701','4943','CY','48423','1983-08-19','F','',':RET:2106-3','N','021','DEN','2298613','33348TX002000201','2014-01-01','2013-12-24 15:10:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:57'),(25941,20571,'Y','18','021','EC','A','','','AC','0001008079','0001008079','TX00002117523','IL','1','ROCHA','KENIA','','','','34','640964355','104 W MONROE ST',0,'BROWNSVILLE','TX','78520','7338','CY','48061','1977-01-18','F','M',NULL,'N','021','DEN','2930415','33348TX002000201','2014-03-01','2014-02-26 17:32:40','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-26 21:01:31'),(13439,10720,'Y','18','021','EC','A','','','AC','0000279552','0000279552','OH00001248664','IL','1','STROUD','DEBORAH','','','','34','092625858','42126 MEADOW LN',0,'LAGRANGE','OH','44050','9677','CY','39093','1977-04-16','F','M',':RET:2106-3','N','021','DEN','2356171','99734OH005000301','2014-01-01','2013-12-23 13:39:07','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:15'),(2419,1973,'Y','18','021','EC','A','','','AC','0000236242','0000236242','OH00000047708','IL','1','Slouffman','James','Walter','','','34','290440485','3327 GLENHURST PL',0,'CINCINNATI','OH','45209','2312','CY','39061','1950-04-01','M','M',':RET:2106-3','N','021','DEN','902636','99734OH005000401','2014-01-01','2013-12-09 16:02:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:54'),(13138,10478,'N','01','021','EC','A',NULL,NULL,'','0000950675','0000997753','','IL','1','Couch','Charles','','','','34','282520696','1621 STAHLHEBER RD',0,'HAMILTON','OH','45013','1919','CY','39017','1951-09-11','M','',NULL,'N','021','DEN','2122248','99734OH005000401','2014-01-01','2013-12-23 15:21:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:13'),(9428,7480,'Y','18','021','EC','A','','','AC','0000144463','0000144463','TX00000279428','IL','1','Rice','Melody','Kay','','','34','455886494','25302 BANCOCK CT',0,'MAGNOLIA','TX','77355','6266','CY','48339','1952-03-11','F','U',':RET:2106-3','N','021','DEN','2315525','33348TX002000201','2014-01-01','2013-12-21 17:21:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:33:18'),(24731,19633,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000924845','','IL','1','PARHAM','QUANTE','','','','34','288982082','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1995-08-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:15'),(9114,7231,'Y','18','021','EC','A','','','AC','0000796947','0000796947','OH00000333399','IL','1','Sand','John','','','','34','302487158','25685 RUSTIC LN',0,'WESTLAKE','OH','44145','5474','CY','39035','1949-02-17','M','M',':RET:2106-3','N','021','DEN','2298205','99734OH005000301','2014-01-01','2013-12-18 16:47:55','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:07:37'),(5903,4676,'Y','18','021','EC','A','','','AC','0000469541','0000469541','OH00000347187','IL','1','Sheeks','Leni','','','','34','251451424','35 North Liberty Street',0,'Amesville','OH','45711',NULL,'CY','39009','1980-09-10','F','U',':RET:2106-3','N','021','DEN','1787156','99734OH005000301','2014-01-01','2013-12-23 23:53:12','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 23:49:48'),(20510,16387,'Y','18','021','EC','A','','','AC','0001302111','0001302111','LA00001998769','31','1','Tedeton','Linda','','','','34','438358372','9100 Hwy 495',0,'Meridian','MS','39305',NULL,'CY','22061','1968-09-18','F','U',':RET:2106-3','T','021','DEN','1462959','18575LA002000201','2014-03-01','2014-01-29 17:06:49','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-29 21:01:18'),(19120,15234,'Y','18','024','14','A','','','TE','0001202213','0001202213','','IL','1','DELVALLE','ANGELA','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-02-18','F','',NULL,NULL,NULL,'','1932829','','2014-01-19','2014-01-19 14:45:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-21 08:45:17'),(16544,13235,'Y','18','021','EC','A','','','AC','0000705160','0000705160','OH00002180510','IL','1','COSS','MILDRED','','','','34','044682806','3123 W 34TH PL',0,'CLEVELAND','OH','44109','1419','CY','39035','1971-10-24','F','M',NULL,'N','021','DEN','2013550','99734OH005000401','2014-02-01','2014-01-04 22:26:00','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,1,'2014-01-07 10:22:29'),(26191,20770,'N','19','021','EC','A',NULL,NULL,'','0001204586','0000115550','','S1','1','HABLI','FIRAS','','','','34','269130210','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','2006-08-28','F','',':RET:2106-3','N','021','DEN','2693744','99734OH005000301','2014-03-01','2014-02-27 12:46:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:44'),(26680,21152,'N','19','021','EC','A',NULL,NULL,'','0002138124','0002066523','','IL','1','Grisby','Jeremiah','','','','34','435851207','11558 WILLOW OAK AVE',0,'BATON ROUGE','LA','70815','2391','CY','22033','1992-09-20','M','',':RET:2054-5','N','021','DEN','3919282','18575LA002000201','2014-04-01','2014-02-28 13:21:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-28 21:31:23'),(26034,20647,'Y','18','021','EC','A','','','AC','0001032457','0001032457','MS00002590065','31','1','AMOS','GLORIA','','','','34','434782503','P.O. BOX 546',0,'DECATUR','MS','39327',NULL,'CY','28101','1950-10-27','F','M',':RET:2054-5','N','021','DEN','3734668','46300MS002000101','2014-04-01','2014-02-26 16:43:29','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-26 21:02:22'),(24332,19323,'N','01','021','EC','A',NULL,NULL,'','0000745682','0000595882','','IL','1','ORTIZ CARRANZA','GLORIA','','','','34','740421437','113 MARIE DR',0,'COMFORT','TX','78013','3366','CY','48265','1962-11-14','F','',':RET:2106-3','N','021','DEN','2982930','33348TX002000201','2014-04-01','2014-02-18 13:37:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-18 22:00:14'),(947,780,'N','01','021','EC','A',NULL,NULL,'','0000321006','0000485831','','IL','1','Bundy','Tina','','','','34','288900550','218 BAKER ST',0,'LODI','OH','44254','1407','CY','39103','1973-05-30','F','',':RET:2106-3','N','021','DEN','133654','99734OH005000301','2014-01-01','2013-10-28 22:38:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:27'),(21006,16785,'Y','18','024','14','A','','','TE','0001587670','0001587670','','IL','1','Kenard','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-02','M','',NULL,NULL,NULL,'','3241658','','2014-02-01','2014-02-01 14:04:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-01 19:00:32'),(5679,4506,'Y','18','021','EC','A','','','AC','0000132039','0000132039','OH00001192706','IL','1','Boldman','Shirley','','','','34','272849312','3889 Bennett Road',0,'Cincinnati','OH','45245',NULL,'CY','39025','1966-01-23','F','U',NULL,'T','021','HLT','218645','92036OH004000601','2014-01-01','2013-11-26 12:13:28','105.00',NULL,NULL,'310.27','205.27','R-OH005','OH0','310.27',NULL,0,'2013-12-25 23:32:16'),(19487,15532,'N','01','021','EC','A',NULL,NULL,'','0001183755','0000450718','','IL','1','VASQUEZ','AURELIO','','','','34','451879051','2409 ALVAREZ ST',0,'LONGVIEW','TX','75604','9302','CY','48183','1959-09-25','M','',NULL,'N','021','DEN','3049375','33348TX002000201','2014-03-01','2014-01-22 12:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 03:02:05'),(17112,13695,'Y','18','021','EC','A','','','AC','0000538283','0000538283','OH00002323964','IL','1','Neiman','Robert','','','','34','279501531','2054 LARCHMONT RD',0,'AKRON','OH','44313','6053','CY','39153','1953-11-04','M','U',NULL,'N','021','DEN','1677372','99734OH005000401','2014-02-01','2014-01-07 19:21:58','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:21:38'),(5133,4068,'Y','18','021','EC','A','','','AC','0001221663','0001221663','TX00000025264','IL','1','Cantu','Jesus','','','','34','462111177','1204 Linnwood St',0,'El Campo','TX','77437',NULL,'CY','48481','1958-03-31','M','M',NULL,'N','021','DEN','2191827','33348TX002000101','2014-01-01','2013-12-19 16:57:53','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:02:17'),(5028,3984,'N','19','021','EC','A',NULL,NULL,'','0000194026','0000596250','','IL','1','Crehan','Grace',NULL,NULL,NULL,NULL,NULL,'7350 S TIMBERLANE DR',0,'CINCINNATI','OH','45243','1844','CY','39061','2001-02-03','F','',':RET:2106-3','N','021','HLT','141721','92036OH004001201','2014-01-01','2013-12-07 11:34:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 22:47:42'),(2402,1962,'Y','18','021','EC','A','','','AC','0000422793','0000422793','OH00000657655','IL','1','Price','Ronald','Eugene','','','34','273580077','5520 Ridgewood Rd. W.',0,'Springfield','OH','45503',NULL,'CY','39023','1954-09-26','M','M',':RET:2106-3','T','021','DEN','112745','99734OH005000401','2014-01-01','2013-12-09 14:02:33','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:33:34'),(17055,13648,'Y','18','021','EC','A','','','AC','0000930924','0000930924','OH00002025997','IL','1','Conley','Linda','','','','34','277543593','5704 Terre Haute Rd',0,'Urbana','OH','43078',NULL,'CY','39021','1951-02-04','F','M',':RET:2106-3','T','021','HLT','2156899','92036OH005000505','2014-02-01','2014-01-09 15:13:51','590.00',NULL,NULL,'785.37','195.37','R-OH003','OH0','785.37',NULL,0,'2014-01-13 02:21:01'),(3005,2415,'Y','18','021','EC','A','','','AC','0001218521','0001218521','OH00000428802','IL','1','MCENTIRE','SHARON','','','','34','272443247','22935 US HIGHWAY 224',0,'FOSTORIA','OH','44830','9624','CY','39063','1951-08-20','F','M',':RET:2106-3','N','021','HLT','338436','92036OH003001505','2014-01-01','2013-12-05 19:22:42','498.00',NULL,NULL,'660.32','162.32','R-OH002','OH0','660.32',NULL,0,'2013-12-25 20:17:45'),(16011,12815,'Y','18','021','EC','A','','','AC','0001435392','0001435392','LA00001437336','IL','1','Tigler','Shelly','','','','34','439905530','1028 Kepler Street',0,'Gretna','LA','70053',NULL,'CY','22051','1956-05-14','F','U',':RET:2054-5','N','021','DEN','1459696','18575LA002000201','2014-02-01','2014-01-02 20:36:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:01:49'),(27527,21778,'Y','18','021','EC','A','','','AC','0000326250','0000326250','OH00003478155','IL','1','Tusing','Monica','','','','34','287528095','268 ELLA ST',0,'TIFFIN','OH','44883','2925','CY','39147','1951-09-30','F','M',':RET:2106-3','N','021','HLT','3636757','92036OH004002701','2014-04-01','2014-03-04 15:44:20','389.00',NULL,NULL,'450.46','61.46','R-OH006','OH0','450.46',NULL,0,'2014-03-04 21:02:45'),(24419,19397,'Y','18','021','EC','A','','','AC','0000874751','0000874751','OH00003023660','IL','1','Jones','Linda','','','','34','276647376','1834 HAYDEN AVE',0,'EAST CLEVELAND','OH','44112','2140','CY','39035','1958-05-01','F','U',':RET:2054-5','N','021','DEN','2902329','99734OH005000301','2014-04-01','2014-02-18 13:19:08','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:01:06'),(24031,19113,'Y','18','021','EC','A','','','AC','0001467814','0001467814','LA00002012768','IL','1','dotson','shane','','','','34','435534755','22825 citation dr',0,'denham springs','LA','43553',NULL,'CY','39051','1975-09-26','F','U',':RET:2054-5','N','021','HLT','3243067','92036OH004002601','2014-03-01','2014-02-14 19:49:01','259.00',NULL,NULL,'294.94','35.94','R-OH001','LA0','195.37',NULL,0,'2014-02-15 22:00:53'),(23686,18862,'Y','18','021','EC','A','','','AC','0000251670','0000251670','OH00001746716','IL','1','COPPINS','COURTNEY','','','','34','269924646','6714 PECK RD',0,'RAVENNA','OH','44266',NULL,'CY','39133','1987-07-13','F','U',':RET:2106-3','N','021','DEN','3044683','99734OH005000401','2014-03-01','2014-02-13 19:16:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:34'),(23648,18831,'Y','18','021','EC','A','','','AC','0000882602','0000882602','TX00002440261','IL','1','Esparza','Julian','','','','34','456838748','108 REDWOOD LN',0,'LEVELLAND','TX','79336','6606','CY','48219','1983-06-29','M','M',':RET:2106-3','N','021','DEN','3540331','33348TX002000201','2014-03-01','2014-02-13 23:23:21','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:12'),(20522,16398,'Y','18','021','EC','A','','','AC','0000081061','0000081061','TX00001435186','IL','1','powell','kanzetta','','','','34','457590064','6050 kenilwood dr.',0,'Houston','TX','77033',NULL,'CY','48201','1970-02-16','F','U',':RET:2054-5','N','021','DEN','3131765','33348TX002000101','2014-03-01','2014-01-29 16:32:06','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-29 21:01:25'),(16743,13393,'N','01','021','EC','A',NULL,NULL,'','0000403673','0000980555','','IL','1','Mcquain','Raymond','H','','','34','268523066','129 W CUYAHOGA FALLS AVE',0,'AKRON','OH','44310','2903','CY','39153','1951-07-06','M','',':RET:2106-3','N','021','HLT','2050004','52664OH151001301','2014-02-01','2014-01-07 13:53:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2014-01-08 18:24:52'),(7266,5761,'Y','18','021','EC','A','','','AC','0000540750','0000540750','TX00000806476','IL','1','ORR','PATRICIA','ANN','','','34','485589670','605 B CHURCH ST',0,'BRENHAM','TX','77833',NULL,'CY','48477','1950-04-29','F','U',':RET:2106-3','N','021','DEN','1070037','33348TX002000201','2014-01-01','2013-12-14 00:22:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:02:16'),(26400,20939,'Y','18','021','EC','A','','','AC','0000042085','0000042085','OH00002400584','IL','1','Older','Naz','','','','34','284888626','1060 E MILLTOWN RD',0,'WOOSTER','OH','44691','1848','CY','39169','1976-01-26','F','U',':RET:2106-3','N','021','HLT','2973579','52664OH151001304','2014-03-01','2014-02-26 15:04:15','259.00',NULL,NULL,'561.09','302.09','R-OH014','OH0','277.87','CIC',0,'2014-02-28 07:00:30'),(27272,21596,'Y','18','021','EC','A','','','AC','0000125701','0000125701','TX00002958038','IL','1','FAIRCHILD','EDWARD','LEE','','','34','435040086','112 BENNETT ST',0,'NORMANGEE','TX','77871','5286','CY','48289','1970-07-27','M','M',':RET:2106-3','N','021','DEN','3284963','33348TX002000201','2014-04-01','2014-03-03 18:12:32','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:16'),(1012,829,'Y','18','021','EC','A','','','AC','0000009810','0000009810','OH00000460520','IL','1','Hufford','Kyle','','','','34','280828653','8527 PRINGLE DR',0,'CINCINNATI','OH','45231','4903','CY','39061','1975-12-24','M','U',NULL,'N','021','DEN','954210','99734OH005000401','2014-01-01','2013-10-16 21:26:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:11:18'),(14317,11419,'Y','18','021','EC','A','','','AC','0000987410','0000987410','OH00001388485','IL','1','Baddar','Milad','','','','34','287903755','3663 WOODSPRING RD',0,'SYLVANIA','OH','43560','3558','CY','39095','1964-12-20','M','M',NULL,'N','021','HLT','1495338','92036OH001002601','2014-02-01','2013-12-26 11:38:44','392.00',NULL,NULL,'951.91','559.91','R-OH001','OH0','401.27',NULL,0,'2013-12-27 02:07:10'),(1976,1615,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','1245360','','2013-11-19','2013-11-19 23:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:36'),(13199,10532,'Y','18','024','14','A','','','TE','0000102261','0000102261','','IL','1','RIVERA','CARLOS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-13','M','',NULL,NULL,NULL,'','1514381','','2013-12-23','2013-12-23 13:31:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:54:54'),(22411,17894,'Y','18','024','14','A','','','TE','0001441723','0001441723','','IL','1','Tardo','Magen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-08-05','F','',NULL,NULL,NULL,'','3440477','','2014-02-10','2014-02-10 10:12:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-10 21:30:25'),(9729,7705,'Y','18','021','EC','A','','','AC','0000207089','0000207089','OH00000511398','IL','1','SPISAK','THOMAS','DUANE','','Jr','34','276523097','608SHEFFIELD ROAD',0,'MIDDLETOWN','OH','45042',NULL,'CY','39017','1952-05-13','M','U',':RET:2106-3','N','021','DEN','753165','99734OH005000301','2014-01-01','2013-11-15 12:11:41','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:45:38'),(21743,17362,'Y','18','021','EC','A','','','AC','0000576436','0000576436','TX00002555138','IL','1','Shashy','Lawrence','','','','34','453904662','720 COLCHESTER DR',0,'EL PASO','TX','79912','7056','CY','48141','1949-11-26','M','U',':RET:2106-3','N','021','DEN','3046772','33348TX002000201','2014-03-01','2014-02-05 18:33:58','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-06 21:00:16'),(9270,7354,'Y','18','021','EC','A','','','AC','0000949476','0000949476','OH00001125564','IL','1','Harris','Schuanch','M','','','34','270669678','20201 HILLCREST DR',0,'EUCLID','OH','44117','2267','CY','39035','1960-10-12','F','M',':RET:2054-5','T','021','DEN','469046','99734OH005000401','2014-01-01','2013-11-30 11:47:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:15:37'),(23501,18719,'N','01','021','EC','A',NULL,NULL,'','0000038585','0000110646','','IL','1','ROGERS','CHELSEA','','','','34','458673041','117 PR 6254',0,'MINEOLA','TX','75773',NULL,'CY','48499','1984-02-10','F','',':RET:2106-3','T','021','DEN','3799697','33348TX002000101','2014-03-01','2014-02-13 08:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-13 22:02:08'),(3308,2660,'N','01','021','EC','A',NULL,NULL,'','0000097572','0000957910','','IL','1','Bueno','Kathryn','','','','34','671684411','1085 TREELINE WAY',0,'DELAWARE','OH','43015','3547','CY','39041','1981-11-06','F','',':RET:2036-2','N','021','DEN','1644492','99734OH005000301','2014-01-01','2013-12-22 13:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:49'),(6819,5407,'Y','18','021','EC','A','','','AC','0001183494','0001183494','OH00000479636','IL','1','Poff','Deborah','','','','34','298661008','1120 GRIGGS RD',0,'JEFFERSON','OH','44047','9754','CY','39007','1959-02-20','F','M',':RET:2106-3','N','021','HLT','662105','52664OH151001305','2014-01-01','2013-11-14 17:29:24','1106.00',NULL,NULL,'1243.76','137.76','R-OH011','OH0','536.99',NULL,0,'2013-12-26 01:30:29'),(25392,20146,'Y','18','021','EC','A','','','AC','0000307147','0000307147','OH00002939848','IL','1','Mohr','Jayma','','','','34','269704840','5612 Brentwood Avenue NW',0,'North Canton','OH','44720',NULL,'CY','39151','1959-12-27','F','M',NULL,'N','021','HLT','3677245','52664OH151001304','2014-04-01','2014-02-25 12:12:05','634.00',NULL,NULL,'1093.85','459.85','R-OH015','OH0','476.12',NULL,0,'2014-02-25 21:30:52'),(22777,18185,'Y','18','021','EC','A','','','AC','0000227087','0000227087','OH00001970586','IL','1','HERITIER','ALEJANDRO','','','','34','081525725','9618 WINTON RD',0,'SPRINGFIELD TOWNSHIP','OH','45231',NULL,'CY','39061','1954-11-09','M','M',NULL,'N','021','DEN','3448058','99734OH005000401','2014-03-01','2014-02-11 14:39:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:41'),(5658,4488,'Y','18','021','EC','A','','','AC','0000841887','0000841887','OH00000821111','IL','1','Hepler','Marilyn','','','','34','279545061','839 OAKRIDGE ST SW',0,'NORTH CANTON','OH','44720','3410','CY','39151','1953-02-18','F','M',NULL,'N','021','HLT','984530','52664OH152000901','2014-01-01','2013-11-26 16:25:48','0.00',NULL,NULL,'443.31','443.31','R-OH015','OH0','443.31',NULL,0,'2013-12-25 23:31:40'),(14959,11956,'Y','18','021','EC','A','','','AC','0000430685','0000430685','TX00000241191','IL','1','OBRIAN','REGINA','','','','34','456903371','3311 MOORE DR',0,'TEXARKANA','TX','75503',NULL,'CY','48037','1951-03-15','F','M',':RET:2106-3','N','021','DEN','1975676','33348TX002000201','2014-02-01','2013-12-30 09:02:40','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-01-01 12:00:27'),(21307,17026,'Y','18','021','EC','A','','','AC','0001229902','0001229902','LA00001483421','IL','1','Bankston','Katina','','','','34','438458371','209 A Senator Circle',0,'Houma','LA','70363',NULL,'CY','22109','1973-08-01','F','U',':RET:2054-5','N','021','DEN','2835196','18575LA002000201','2014-03-01','2014-02-04 10:37:46','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-02-04 21:00:15'),(16796,13435,'Y','18','021','EC','A','','','AC','0000348936','0000348936','TX00002524067','IL','1','Dhungana','Obi','','','','34','616693675','1500 davis lane',0,'brownwood','TX','76801',NULL,'CY','48049','1981-02-02','M','M',':RET:2028-9','N','021','DEN','1793913','33348TX002000201','2014-02-01','2014-01-11 08:34:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:18:09'),(25610,20319,'N','01','021','EC','A',NULL,NULL,'','0000335397','0000964854','','IL','1','GROCE','DARYL','HENRY','','','34','457174849','406 GARDNER ST',0,'BORGER','TX','79007','6030','CY','48233','1955-05-15','M','',':RET:2106-3','N','021','DEN','2681065','33348TX002000201','2014-04-01','2014-02-21 23:46:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 08:30:08'),(27139,21486,'Y','18','021','EC','A','','','AC','0000264260','0000264260','OH00003080469','IL','1','OWUSU','CHRISTIAN','','','','34','476433169','1328 CAMP HILL WAY',0,'DAYTON','OH','45449','3136','CY','39113','1963-04-06','M','M',':RET:2054-5','N','021','DEN','3613733','99734OH005000401','2014-04-01','2014-03-03 12:00:03','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-03-03 21:30:45'),(28435,22499,'N','01','021','EC','A',NULL,NULL,'','0000547943','0000190253','','IL','1','Serio','Kassondra','','','','34','302800547','404 Webb St',0,'Saint Marys','OH','45885',NULL,'CY','39011','1982-09-17','F','',':RET:2106-3','N','021','HLT','3747252','92036OH003001505','2014-04-01','2014-03-06 18:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','266.38',NULL,0,'2014-03-07 21:31:10'),(24549,19500,'N','19','021','EC','A',NULL,NULL,'','0000928544','0000816469','','IL','1','JOHNSON','SHAYNNA','R','','','34','301928949','7122 RIDGE AVE SE',0,'EAST SPARTA','OH','44626','9448','CY','39151','1991-01-27','F','',':RET:2106-3','N','021','HLT','3091078','52664OH151001301','2014-04-01','2014-02-19 08:53:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-02-20 04:04:04'),(23301,18576,'Y','18','021','EC','A','','','AC','0000784405','0000784405','OH00002772817','IL','1','Chernoff','Irving','','','','34','245766030','4178 Berry Ridge Lane',0,'Columbus','OH','43230',NULL,'CY','39049','1949-12-11','M','U',':RET:2106-3','N','021','DEN','2874232','99734OH005000301','2014-03-01','2014-02-13 01:51:39','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:14'),(22841,18224,'N','01','021','EC','A',NULL,NULL,'','0000027927','0001064754','','IL','1','Bazzy','Lubna','','','','34','301808089','10790 BIXEL RD',0,'BLUFFTON','OH','45817','9506','CY','39003','1969-03-08','F','',NULL,'N','021','HLT','3376536','92036OH004001501','2014-03-01','2014-02-10 21:15:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','247.23',NULL,0,'2014-02-11 21:02:13'),(13517,10775,'Y','18','021','EC','A','','','AC','0002007996','0002007996','LA00000694109','IL','1','peloquin','fred','','','','34','439081844','3904 YELLOWROSE DR',0,'SULPHUR','LA','70665','8399','CY','22019','1956-09-23','M','U',':RET:2106-3','N','021','DEN','1541119','18575LA002000201','2014-01-01','2013-12-23 07:43:30','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 13:03:06'),(13490,10754,'N','01','021','EC','A',NULL,NULL,'','0001205814','0001122742','','IL','1','McGuinness','Timothy','L','','','34','296749419','8770 HILLTOP DR',0,'MENTOR','OH','44060','1932','CY','39085','1970-03-23','M','',':RET:2106-3','N','021','DEN','1533151','99734OH005000301','2014-01-01','2013-12-23 18:04:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:23'),(3582,2873,'Y','18','021','EC','A','','','AC','0000284400','0000284400','OH00000513471','IL','1','Stephens','Gary','','','','34','280564096','7678 RICHEY RD',0,'FELICITY','OH','45120','9649','CY','39025','1967-11-05','M','U',':RET:2106-3','T','021','HLT','1594582','92036OH004000601','2014-01-01','2013-12-22 08:57:26','0.00',NULL,NULL,'297.75','297.75','R-OH005','OH0','297.75',NULL,0,'2013-12-25 21:22:46'),(18714,14918,'Y','18','021','EC','A','','','AC','0001166839','0001166839','OH00001735258','IL','1','Hoehn','Debra','','','','34','016481986','310 SMITH ST',0,'FOREST','OH','45843','1052','CY','39065','1968-03-09','F','U',':RET:2106-3','N','021','DEN','3012805','99734OH005000301','2014-02-01','2014-01-15 22:35:59','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-17 03:35:32'),(15849,12689,'N','19','021','EC','A',NULL,NULL,'','0000798423','0000359695','','S1','1','Bacon','Brian','','','','34','288115178','1128 W State St',0,'Lima','OH','45805',NULL,'CY','39003','2005-10-29','F','',':RET:2106-3','N','021','DEN','2535120','99734OH005000401','2014-02-01','2014-01-02 17:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:04:22'),(5848,4644,'Y','18','021','EC','A','','','AC','0000406520','0000406520','TX00000216664','IL','1','Chowdhury','Anna','','','','34','439650449','4603 Colonial Circle',0,'College Station','TX','77845',NULL,'CY','48041','1982-08-24','F','U',':RET:2028-9','N','021','DEN','2169205','33348TX002000201','2014-01-01','2013-12-24 00:19:05','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 23:48:41'),(6316,5009,'N','19','021','EC','A',NULL,NULL,'','0000648299','0000865838','','IL','1','Setser','Riley','Adam','','','34','286065589','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','2001-08-17','M','',':RET:2106-3','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:18'),(15848,12689,'N','19','021','EC','A',NULL,NULL,'','0000798423','0000877128','','S1','1','Bacon','Brian','','','','34','299133837','1128 W State St',0,'Lima','OH','45805',NULL,'CY','39003','2008-06-17','M','',':RET:2106-3','N','021','DEN','2535120','99734OH005000401','2014-02-01','2014-01-02 17:33:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:04:21'),(27038,21414,'Y','18','024','14','A','','','TE','0000550795','0000550795','','IL','1','Valenta','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-19','M','',NULL,NULL,NULL,'','3019390','','2014-03-31','2014-03-03 17:25:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-03 21:00:20'),(28017,22171,'Y','18','021','EC','A','','','AC','0001147407','0001147407','OH00003448991','IL','1','Osborne','Robert','','','','34','276467736','1150 MANOR DR',0,'COLUMBUS','OH','43232','1639','CY','39049','1950-10-23','M','U',NULL,'T','021','DEN','3921757','99734OH005000401','2014-04-01','2014-03-06 13:37:39','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:19'),(28424,22492,'Y','18','021','EC','A','','','AC','0000546529','0000546529','OH00003487316','IL','1','Moritz','Richard','A','','','34','298624458','2501 VESTAL RD',0,'YOUNGSTOWN','OH','44509','1460','CY','39099','1958-05-26','M','M',':RET:2106-3','N','021','DEN','4149905','99734OH005000401','2014-04-01','2014-03-07 14:28:22','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-03-07 21:31:05'),(28438,22501,'Y','18','021','EC','A','','','AC','0001219649','0001219649','OH00003216776','IL','1','FLYNN','DARLENE','K','','','34','286566999','440 TOUVELLE ST',0,'CELINA','OH','45822',NULL,'CY','39107','1964-04-25','F','U',':RET:2106-3','T','021','HLT','2953322','92036OH003001505','2014-04-01','2014-03-07 09:37:45','316.00',NULL,NULL,'450.92','134.92','R-OH002','OH0','450.92',NULL,0,'2014-03-07 21:31:11'),(61,54,'N','01','021','EC','A',NULL,NULL,'','0000038354','0001214766','','IL','1','sullivan','amy','','','','34','286881950','7706 Norwalk Rd',0,'Medina','OH','44256',NULL,'CY','39103','1977-09-27','F','',NULL,'N','021','DEN','669743','99734OH005000301','2014-01-01','2013-12-05 09:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:16:40'),(23478,18701,'Y','18','021','EC','A','','','AC','0000376184','0000376184','OH00002194083','IL','1','Sullivan','Jeremy','','','','34','272768956','4228 CLOUGH LN',0,'CINCINNATI','OH','45245','1711','CY','39025','1977-04-19','M','M',':RET:2106-3','N','021','HLT','3278358','92036OH003000601','2014-03-01','2014-02-13 09:46:28','0.00',NULL,NULL,'574.55','574.55','R-OH005','OH0','275.75',NULL,0,'2014-02-13 22:01:53'),(19971,15930,'Y','18','024','14','A','','','TE','0000951831','0000951831','','IL','1','MALTRY','LINDA','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-05-16','F','',NULL,NULL,NULL,'','2021622','','2014-01-25','2014-01-25 11:17:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-25 19:00:11'),(3786,3033,'Y','18','021','EC','A','','','AC','0000822039','0000822039','OH00000670885','IL','1','Petro','Mary Beth','','','','34','291648080','8330 LORRAINE DR',0,'STRONGSVILLE','OH','44149','1045','CY','39035','1962-01-07','F','U',':RET:2106-3','N','021','DEN','304931','99734OH005000301','2014-01-01','2013-12-13 09:23:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:34:06'),(25438,20184,'Y','18','021','EC','A','','','AC','0000170330','0000170330','TX00002486462','IL','1','Mccain','Teresa','','','','34','452022656','16015 Estella Lane',0,'Houston','TX','77090',NULL,'CY','48201','1954-09-24','F','U',NULL,'N','021','DEN','2902474','33348TX002000201','2014-04-01','2014-02-25 10:00:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:19'),(14846,11854,'N','19','021','EC','A',NULL,NULL,'','0000175102','0000119070','','IL','1','Schneider','Joseph','','','','34','283980727','15175 KRUSE RD',0,'WAPAKONETA','OH','45895','9518','CY','39011','1995-06-11','M','',NULL,'N','021','HLT','1503466','92036OH005001501','2014-01-01','2013-12-23 20:12:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,1,'2013-12-29 11:14:58'),(22422,17903,'Y','18','021','EC','A','','','AC','0001442853','0001442853','LA00001578450','31','1','Reddix','Katondra','','','','34','433636400','P.o box 386',0,'prairieville','LA','70769',NULL,'CY','22005','1986-09-23','F','U',':RET:2054-5','N','021','DEN','3321784','18575LA002000201','2014-03-01','2014-02-10 14:03:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 21:30:31'),(15753,12603,'Y','18','021','EC','A','','','AC','0000276479','0000276479','TX00001350207','IL','1','Vong','Dora','','','','34','460498941','3501 SUMMIT LN',0,'GARLAND','TX','75042','5453','CY','48113','1963-03-13','F','M',NULL,'N','021','DEN','1677271','33348TX002000201','2014-02-01','2014-01-02 16:16:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:01:13'),(16444,13157,'Y','18','021','EC','A','','','AC','0000534891','0000534891','MS00001592212','IL','1','GRAY','TOMMIE','','','','34','587980783','2655 BOYD RD',0,'UTICA','MS','39175','9345','CY','28049','1954-01-29','F','M',':RET:2054-5','N','021','DEN','1571379','46300MS002000101','2014-02-01','2014-01-06 10:18:21','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-07 04:05:11'),(21712,17338,'Y','18','021','EC','A','','','AC','0000476002','0000476002','OH00001350971','31','1','Stevens','Gregory','Alan','','','34','276646527','P.O. Box 6',0,'New Hampshire','OH','45870',NULL,'CY','39011','1960-02-27','M','M',':RET:2106-3','N','021','HLT','3844390','92036OH003001505','2014-03-01','2014-02-05 11:55:56','759.00',NULL,NULL,'959.57','200.57','R-OH002','OH0','490.70',NULL,0,'2014-02-05 21:31:16'),(27423,21702,'Y','18','021','EC','A','','','AC','0002171670','0002171670','LA00002547060','IL','1','Peyton','Alorna','','','','34','434594033','10284 W. Winston Ave',0,'Baton Rouge','LA','70809',NULL,'CY','22033','1985-07-10','F','U',':RET:2054-5','N','021','DEN','3703331','18575LA002000201','2014-04-01','2014-03-03 22:44:34','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-04 21:01:40'),(28258,22360,'Y','18','021','EC','A','','','AC','0000115550','0000115550','OH00002670806','S1','1','Habli','firas','','','','34','269130210','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2006-08-28','F','U',NULL,'N','021','DEN','3568808','99734OH005000301','2014-04-01','2014-03-06 19:19:44','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13','CIC',0,'2014-03-07 21:00:16'),(28474,22531,'Y','18','021','EC','A','','','AC','0000614088','0000614088','OH00003251382','IL','1','Shamy','Rachel','','','','34','268885750','13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','1977-10-04','F','M',NULL,'N','021','DEN','4102709','99734OH005000301','2014-04-01','2014-03-07 09:25:51','0.00',NULL,NULL,'59.76','59.76','R-OH001','OH0','0.00',NULL,0,'2014-03-07 21:31:33'),(29046,22988,'N','01','021','EC','A',NULL,NULL,'','0000041012','0000364956','','IL','1','OKERWALL','MICHAEL','ANGELO','','','34','302668330','463 LIBERTY ST',0,'PAINESVILLE','OH','44077','3647','CY','39085','1961-02-19','M','',NULL,'N','021','DEN','3101292','99734OH005000401','2014-04-01','2014-03-10 13:44:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:43'),(1654,1382,'Y','18','021','EC','A','','','AC','0000051898','0000051898','TX00000863938','IL','1','Monsivais','jesse','','','','34','459693477','6916 ALEXANDRIA CT',0,'FORT WORTH','TX','76133','6301','CY','48439','1984-05-11','M','M',':RET:2106-3','N','021','DEN','1358546','33348TX002000201','2014-01-01','2013-12-24 16:38:52','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:53:26'),(25097,19906,'Y','18','024','14','A','','','TE','0000951854','0000951854','','IL','1','Butler','Allie','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-16','M','',NULL,NULL,NULL,'','2879441','','2014-03-31','2014-02-21 15:09:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:08'),(13568,10821,'Y','18','021','EC','A','','','AC','0001947405','0001947405','LA00000981757','IL','1','Bishop','Shannon','Alexis','','','34','438499569','1108 MERRILL ST',0,'NEW ORLEANS','LA','70114','1650','CY','22071','1969-03-14','F','U',':RET:2054-5','N','021','DEN','2132139','18575LA002000201','2014-01-01','2013-12-23 16:53:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:34'),(22030,17587,'N','19','021','EC','A',NULL,NULL,'','0001066019','0001034707','','IL','1','Simmons','Alexandra','N',NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1994-07-11','F','',NULL,'N','021','HLT','2731792','52664OH151001501','2014-03-01','2014-02-07 10:25:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-02-07 19:01:03'),(9482,7519,'Y','18','021','EC','A','','','AC','0000388638','0000388638','OH00000487415','IL','1','Schurr','Kathleen','','','','34','276900192','143 GRANT AVE',0,'CUYAHOGA FALLS','OH','44221','4713','CY','39153','1988-05-20','F','U',':RET:2106-3','N','021','DEN','2334899','99734OH005000401','2014-01-01','2013-12-21 12:20:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:34:39'),(21372,17082,'Y','18','021','EC','A','','','AC','0000926620','0000926620','TX00001639391','31','1','Ortega','Barbara','','','','34','572964937','1531 Connettere',0,'New Braunfels','TX','78132',NULL,'CY','48209','1953-05-13','F','M',':RET:2106-3','N','021','DEN','2980138','33348TX002000201','2014-03-01','2014-02-04 17:43:50','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-04 21:00:49'),(21319,17036,'Y','18','024','14','A','','','TE','0002045234','0002045234','','IL','1','Davis','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-20','M','',NULL,NULL,NULL,'','3089576','','2014-02-04','2014-02-04 16:50:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-04 21:00:22'),(18543,14788,'Y','18','024','14','A','','','TE','0000256241','0000256241','','IL','1','Romine','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-08-08','M','',NULL,NULL,NULL,'','2716126','','2014-01-15','2014-01-15 14:46:31',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-16 08:46:50'),(17676,14125,'N','01','021','EC','A',NULL,NULL,'','0001723197','0001473913','','IL','1','Lam','Yen','','','','34','664051734','2433 River Rd',0,'Berwick','LA','70342',NULL,'CY','22101','1970-02-09','F','',':RET:2047-9','N','021','DEN','1728218','18575LA002000101','2014-02-01','2014-01-13 13:18:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-14 01:32:52'),(29144,23070,'N','01','021','EC','A',NULL,NULL,'','0000268967','0000840592','','IL','1','Davis','Julie','T','','','34','297862533','6610 TRIESTA CT',0,'CINCINNATI','OH','45230','1434','CY','39061','1985-09-12','F','',':RET:2106-3','N','021','HLT','4255288','92036OH005001205','2014-04-01','2014-03-10 11:25:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.35',NULL,0,'2014-03-10 21:02:45'),(22780,18188,'Y','18','024','14','A','','','TE','0000767431','0000767431','','IL','1','FOSU','KOFI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-03-03','M','',NULL,NULL,NULL,'','3314441','','2014-02-11','2014-02-11 17:11:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-11 21:01:43'),(13328,10641,'Y','18','021','EC','A','','','AC','0000454444','0000454444','TX00000520600','IL','1','SANCHEZ','LUIS','','','','34','465452130','3506 LA CHUPARROSA',0,'MERCEDES','TX','78570','5732','CY','48215','1961-08-25','M','U',':RET:2106-3','N','021','DEN','1563665','33348TX002000201','2014-01-01','2013-12-23 17:24:22','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 12:58:32'),(21778,17392,'Y','18','021','EC','A','','','AC','0000581535','0000581535','OH00001476955','IL','1','Williams','Ashley','','','','34','272824615','2991 DANA DR',0,'COLUMBUS','OH','43209','1137','CY','39049','1983-12-31','F','U',NULL,'N','021','DEN','3595840','99734OH005000401','2014-03-01','2014-02-05 21:35:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:36'),(19329,15408,'Y','18','021','EC','A','','','AC','0001156179','0001156179','TX00001660972','IL','1','LOZOYA','JUANA','','','','34','562797873','121 H EAST AVE',0,'FABENS','TX','79838',NULL,'CY','48141','1962-04-13','F','U',NULL,'N','021','DEN','2812865','33348TX002000201','2014-03-01','2014-01-21 17:35:51','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2014-01-22 03:22:15'),(15638,12509,'Y','18','021','EC','A','','','AC','0001197438','0001197438','LA00001815812','IL','1','Bergez','Tina','M','','','34','437433323','2010 TEAL ST',0,'SLIDELL','LA','70460','3301','CY','22103','1963-11-01','F','U',':RET:2106-3','N','021','DEN','1623616','18575LA002000101','2014-02-01','2013-12-31 17:12:13','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:33:43'),(5302,4202,'Y','18','021','EC','A','','','AC','0000148319','0000148319','OH00000554348','IL','1','GOSHE-COOK','KATHY','ANN','','','34','275648893','1431 WESTSHORE DR',0,'FINDLAY','OH','45840','6674','CY','39063','1959-10-15','F','U',NULL,'N','021','HLT','2251187','92036OH003001504','2014-01-01','2013-12-19 09:34:27','366.00',NULL,NULL,'490.70','124.70','R-OH002','OH0','490.70',NULL,0,'2013-12-25 23:06:18'),(25475,20211,'N','01','021','EC','A',NULL,NULL,'','0000396337','0001161052','','IL','1','Rollfing','Ana','','','','34','636146303','28130 LAURA CT',0,'CONROE','TX','77385','8959','CY','48339','1975-01-13','F','',NULL,'N','021','DEN','3678748','33348TX002000201','2014-04-01','2014-02-25 17:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-25 21:31:40'),(26576,21070,'N','19','021','EC','A',NULL,NULL,'','0001121454','0000606017','','IL','1','Capotosto','Jacob','Thomas','','','34','283980442','2589 W ELM ST',0,'LIMA','OH','45805','2544','CY','39003','1995-06-05','M','',':RET:2106-3','N','021','DEN','3607412','99734OH005000401','2014-04-01','2014-02-28 12:39:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:28'),(26905,21324,'Y','18','021','EC','A','','','AC','0001929136','0001929136','LA00003337345','IL','1','kawafeha','shadi','','','','34','580355534','1436 delplaza apt B',0,'baton rouge','LA','70815',NULL,'CY','22033','1976-01-08','M','M',NULL,'T','021','DEN','2996679','18575LA002000201','2014-04-01','2014-03-01 19:58:42','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-03 01:00:09'),(27228,21561,'Y','18','024','14','A','','','TE','0002183547','0002183547','','IL','1','Van Calsem','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-10-21','F','',NULL,NULL,NULL,'','3489857','','2014-03-03','2014-03-03 16:23:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-03 21:31:40'),(309,252,'N','G8','021','EC','A',NULL,NULL,'','0000124058','0000828077','','IL','1','Marivani','Valeria','','','','34','642221606','5623 STAR VIEW DR',0,'EL PASO','TX','79912','6427','CY','48141','1990-05-14','F','',':RET:2106-3','N','021','DEN','555509','33348TX002000101','2014-01-01','2013-11-12 18:19:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 17:30:57'),(9749,7720,'Y','18','021','EC','A','','','AC','0000465882','0000465882','OH00000639793','IL','1','Reich','Paul','','','','34','283482085','2421 SUCROSE DR',0,'AKRON','OH','44312','5571','CY','39153','1949-11-14','M','M',NULL,'N','021','HLT','762200','52664OH151001501','2014-01-01','2013-11-15 11:15:02','741.00',NULL,NULL,'1604.76','863.76','R-OH012','OH0','802.38',NULL,0,'2013-12-26 04:46:11'),(21930,17514,'Y','18','021','EC','A','','','AC','0001106433','0001106433','TX00002377530','IL','1','fails','travis','','','','34','460571939','8427 hwy 37 south',0,'winnsboro','TX','75494',NULL,'CY','48159','1972-09-03','M','M',':RET:2106-3','N','021','DEN','3357438','33348TX002000201','2014-03-01','2014-02-07 08:57:08','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-07 19:00:11'),(17781,14205,'Y','18','021','EC','A','','','AC','0000424051','0000424051','OH00001775352','IL','1','Haynes','Mary','','','','34','273667382','5970 RICKY DR',0,'FAIRFIELD','OH','45014','4775','CY','39017','1961-09-12','F','M',':RET:2106-3','N','021','HLT','2585844','92036OH005001204','2014-02-01','2014-01-13 12:15:28','186.00',NULL,NULL,'419.03','233.03','R-OH004','OH0','419.03',NULL,0,'2014-01-14 01:33:42'),(9207,7303,'Y','18','024','14','A','','','TE','0000237440','0000237440','','IL','1','MAISURIA','RAKESHKUMAR',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-10-09','M','',NULL,NULL,NULL,'','1988233','','2013-12-18','2013-12-18 12:46:34',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 04:09:49'),(6809,5401,'Y','18','021','EC','A','','','AC','0000914710','0000914710','TX00000147165','IL','1','Gamero','Joe','','','','34','456865286','3913 W BEAUREGARD AVE',0,'SAN ANGELO','TX','76904','8404','CY','48451','1951-02-07','M','U',NULL,'N','021','DEN','823185','33348TX002000201','2014-01-01','2013-11-14 11:24:05','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-26 01:30:15'),(17010,13615,'Y','18','021','EC','A','','','AC','0000145400','0000145400','OH00002489686','IL','1','Hurley','James','','','','34','016424683','2605 WELLINGTON RD',0,'CLEVELAND HEIGHTS','OH','44118','4120','CY','39035','1951-05-25','M','M',':RET:2106-3','N','021','DEN','2106998','99734OH005000301','2014-02-01','2014-01-09 13:42:26','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:20:36'),(16952,13568,'N','01','021','EC','A',NULL,NULL,'','0000810061','0001061039','','IL','1','council','benjamin','','','','34','253219777','40 tallahoma dr',0,'laurel','MS','39440',NULL,'CY','28067','1972-06-27','M','',':RET:2106-3','N','021','DEN','1891925','46300MS002000101','2014-02-01','2014-01-08 22:55:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-13 02:20:01'),(4740,3755,'N','01','021','EC','A',NULL,NULL,'','0000940835','0000739005','','IL','1','Roe','Laurie','Jean','','','34','473743721','6325 Garden Rd.',0,'maumee','OH','43537',NULL,'CY','39095','1959-03-15','F','',':RET:2106-3','N','021','HLT','549376','92036OH002002601','2014-01-01','2013-12-12 15:16:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','480.78',NULL,0,'2013-12-25 22:09:25'),(736,610,'Y','18','024','14','A','','','TE','0000516678','0000516678','','IL','1','Hoffman','Bryan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-02-03','M','',NULL,NULL,NULL,'','1130877','','2013-12-15','2013-12-15 20:49:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:03:56'),(4696,3723,'Y','18','024','14','A','','','TE','0000281986','0000281986','','IL','1','SIMMONS','JERI','JEANNE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-05-25','F','',NULL,NULL,NULL,'','766795','','2013-12-12','2013-12-12 14:25:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:08:18'),(16944,13561,'N','01','021','EC','A',NULL,NULL,'','0001633557','0001875519','','IL','1','russo','connie','','','','34','438889886','3825 HIGHWAY 308',0,'RACELAND','LA','70394','2946','CY','22057','1959-04-15','F','',':RET:2106-3','N','021','DEN','1385078','18575LA002000201','2014-02-01','2014-01-09 13:55:24',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:19:56'),(3548,2847,'N','01','021','EC','A',NULL,NULL,'','0000454421','0000892429','','IL','1','Ramirez','Catalina','','','','34','630265272','3112 E COUNTY ROAD 136',0,'MIDLAND','TX','79706','7130','CY','48329','1991-10-06','F','',NULL,'N','021','DEN','2252551','33348TX002000101','2014-01-01','2013-12-22 18:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 21:21:57'),(3265,2632,'Y','18','021','EC','A','','','AC','0000187529','0000187529','LA00001317069','IL','1','Murtagh','Angela','','','','34','386661609','505 METAIRIE LAWN DR',0,'METAIRIE','LA','70001','2920','CY','22051','1977-04-02','F','R',NULL,'N','021','DEN','84271','18575LA002000101','2014-01-01','2013-11-27 18:13:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:47:02'),(2547,2073,'Y','18','021','EC','A','','','AC','0000321021','0000321021','OH00000488007','IL','1','Reed','Richard','','','','34','299443334','1336 INMAN ST',0,'AKRON','OH','44306','2604','CY','39153','1949-07-28','M','M',':RET:2106-3','T','021','HLT','8726','52664OH151001501','2014-01-01','2013-12-09 13:04:59','396.00',NULL,NULL,'922.73','526.73','R-OH012','OH0','922.73',NULL,0,'2013-12-25 19:37:11'),(2367,1930,'N','01','021','EC','A',NULL,NULL,'','0000678060','0000818539','','IL','1','Otchere','Tonette','','','','34','268664864','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1960-12-17','F','',':RET:2054-5','N','021','DEN','276792','99734OH005000401','2014-01-01','2013-12-09 08:34:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:32:38'),(1371,1136,'Y','18','021','EC','A','','','AC','0000705909','0000705909','TX00001629912','IL','1','Mark','Alice','','','','34','112724642','4715 DUVAL ST',0,'AUSTIN','TX','78751','3128','CY','48453','1987-11-16','F','U',':RET:2106-3','N','021','DEN','2126050','33348TX002000101','2014-01-01','2013-12-24 17:22:32','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:47'),(1954,1593,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','156338','','2013-11-19','2013-11-19 22:57:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:03'),(26999,21384,'Y','18','021','EC','A','','','AC','0000221380','0000221380','OH00003352061','IL','1','MILLER','APRIL','','','','34','521114881','9010 DRUMS BOTTOM RD NE',0,'THORNVILLE','OH','43076','9537','CY','39045','1973-07-19','F','M',':RET:2106-3','N','021','DEN','2961031','99734OH005000401','2014-04-01','2014-03-02 22:54:12','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00','CIC',0,'2014-03-03 21:00:01'),(28404,22474,'Y','18','021','EC','A','','','AC','0000017689','0000017689','OH00002983017','IL','1','Goodfield','Paula','','','','34','286445050','204 Villa East Dr',0,'Fairport Harbor','OH','44077',NULL,'CY','39085','1950-11-01','F','U',NULL,'N','021','DEN','3884355','99734OH005000401','2014-04-01','2014-03-07 10:00:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:30:53'),(24393,19375,'Y','18','021','EC','A','','','AC','0000050735','0000050735','OH00001537339','IL','1','Clein','Thomas','Richard','','','34','273447392','1520 Orange RD',0,'Ashland','OH','44805',NULL,'CY','39005','1951-05-14','M','U',':RET:2106-3','N','021','DEN','2954285','99734OH005000401','2014-04-01','2014-02-18 13:47:39','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:00:50'),(13428,10712,'Y','18','021','EC','A','','','AC','0000184940','0000184940','OH00000420020','IL','1','MARTIN','GAYLE','E','','','34','300625451','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1956-10-16','F','M',':RET:2106-3','N','021','DEN','1987465','99734OH005000301','2014-01-01','2013-12-23 11:43:31','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:00:58'),(21554,17218,'Y','18','021','EC','A','','','AC','0000861011','0000861011','OH00002388845','IL','1','gabriel','randall','','','','34','466934353','13206 DUTCH CREEK RD',0,'ATHENS','OH','45701','7810','CY','39009','1986-09-02','M','M',NULL,'N','021','DEN','3451677','99734OH005000401','2014-03-01','2014-02-05 15:38:08','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-02-05 21:30:15'),(9161,7266,'N','01','021','EC','A',NULL,NULL,'','0000929828','0000029029','','IL','1','Plum','Trevor','','','','34','008680544','6246 BENNEVILLE ST',0,'CINCINNATI','OH','45230','1901','CY','39061','1979-10-09','M','',':RET:2106-3','N','021','HLT','2232955','92036OH005001201','2014-01-01','2013-12-18 06:18:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','260.61',NULL,0,'2013-12-26 04:08:42'),(3678,2943,'N','01','021','EC','A',NULL,NULL,'','0000100044','0000924776','','IL','1','Eckels','Tamara','Elisa','','','34','279647144','7323 GEARIED ST',0,'PICKERINGTON','OH','43147','8123','CY','39045','1958-02-05','F','',':RET:2106-3','N','021','DEN','15423','99734OH005000401','2014-01-01','2013-12-13 08:45:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:31:23'),(20904,16709,'Y','18','021','EC','A','','','AC','0001043426','0001043426','OH00002390870','IL','1','Franks','Bernard','','','','34','283487313','7673 CORNELL RD',0,'CINCINNATI','OH','45242','3015','CY','39061','1949-08-28','M','M',':RET:2106-3','N','021','DEN','3037922','99734OH005000401','2014-03-01','2014-01-31 16:30:42','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:23'),(20387,16287,'Y','18','021','EC','A','','','AC','0000094900','0000094900','TX00002292723','IL','1','Holub','John','','','','34','460296071','1132 FM 1890',0,'Colubus','TX','78934',NULL,'CY','48089','1959-06-25','M','M',NULL,'N','021','DEN','3042843','33348TX002000201','2014-03-01','2014-01-29 11:48:51','0.00',NULL,NULL,'43.83','43.83','R-TX026','TX0','14.61',NULL,0,'2014-01-29 21:00:14'),(25589,20300,'Y','18','021','EC','A','','','AC','0001841406','0001841406','LA00003003514','IL','1','Alcala','Rebecca','','','','34','436732230','415 West Parker Boulevard',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1988-02-05','F','M',':RET:2106-3','N','021','DEN','2821882','18575LA002000201','2014-03-01','2014-02-24 14:02:33','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61','CIC',0,'2014-02-26 08:00:42'),(27692,21900,'N','01','021','EC','A',NULL,NULL,'','0000809678','0000631195','','IL','1','Belacyuec','Jose','','','','34','451798357','2814 LAWTON ST',0,'CORPUS CHRISTI','TX','78405','2953','CY','48355','1964-07-02','M','',NULL,'N','021','DEN','3356914','33348TX002000201','2014-04-01','2014-03-05 09:54:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:44'),(28794,22793,'Y','18','021','EC','A','','','AC','0000615295','0000615295','TX00003117987','IL','1','BELEA','JOHN','','','','34','353900628','2308 HILLGROVE COURT',0,'MANSFIELD','TX','76063',NULL,'CY','48439','1972-10-14','M','M',':RET:2106-3','N','021','DEN','4287129','33348TX002000101','2014-04-01','2014-03-09 15:25:23','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-03-09 21:00:44'),(28875,22852,'Y','18','021','EC','A','','','AC','0000924004','0000924004','TX00003317671','IL','1','Enzer','Jennifer',NULL,NULL,NULL,NULL,NULL,'14802 Enterprise',0,'Farmers Branch','TX','75234',NULL,'CY','48113','1965-04-02','F','U',':RET:2106-3','N','021','DEN','4178910','33348TX002000201','2014-04-01','2014-03-10 10:35:02','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-10 21:00:05'),(21436,17133,'Y','18','021','EC','A','','','AC','0000840427','0000840427','MS00002275323','31','1','BARNETTE','DIANE','','','','34','425026772','PO BOX 80261',0,'STARKSVILLE','MS','39759',NULL,'CY','28105','1955-04-16','F','U',NULL,'N','021','DEN','3439153','46300MS002000101','2014-03-01','2014-02-03 21:23:01','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-04 21:01:21'),(13265,10587,'Y','18','024','14','A','','','TE','0000097422','0000097422','','IL','1','Ashton','Erikalin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-01-15','F','',NULL,NULL,NULL,'','2227677','','2013-12-23','2013-12-23 12:14:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:56:45'),(19883,15860,'Y','18','021','EC','A','','','AC','0000988914','0000988914','OH00002191100','IL','1','Ferguson','Brian','','','','34','287640558','326 GAIL AVE NE',0,'MASSILLON','OH','44646','4058','CY','39151','1968-03-18','M','M',':RET:2106-3','N','021','HLT','2094591','52664OH151001305','2014-03-01','2014-01-24 15:14:05','525.00',NULL,NULL,'737.93','212.93','R-OH015','OH0','322.02',NULL,0,'2014-01-24 21:00:47'),(2197,1808,'Y','18','021','EC','A','','','AC','0000819761','0000819761','OH00000666255','IL','1','Lee','Sheena','','','','34','286829980','725 TAFT ST',0,'SIDNEY','OH','45365','2541','CY','39149','1984-10-21','F','U',NULL,'N','021','HLT','1188046','92036OH003000506','2014-01-01','2013-12-10 11:45:41','178.00',NULL,NULL,'277.77','99.77','R-OH003','OH0','277.77',NULL,0,'2013-12-25 19:19:55'),(2416,1971,'Y','18','024','14','A','','','TE','0000916978','0000916978','','IL','1','Porter','Gregory','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-09','M','',NULL,NULL,NULL,'','711732','','2013-12-09','2013-12-09 15:55:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:33:51'),(16216,12986,'Y','18','021','EC','A','','','AC','0000764981','0000764981','OH00001470084','IL','1','Glassner','April','','','','34','274705035','326 W PEARL ST',0,'WILLARD','OH','44890','1215','CY','39077','1974-04-30','F','U',':RET:2106-3','N','021','HLT','2506970','92036OH004002701','2014-02-01','2014-01-03 19:19:36','192.00',NULL,NULL,'197.87','5.87','R-OH006','OH0','197.87',NULL,0,'2014-01-05 00:01:38'),(8020,6349,'Y','18','021','EC','A','','','AC','0000259220','0000259220','OH00000325759','IL','1','Smith II','Bradley','','','','34','294883874','4620 BETHANY GLEN DR',0,'BATAVIA','OH','45103','1085','CY','39025','1987-09-05','M','U',':RET:2106-3','N','021','HLT','1985886','92036OH006000601','2014-01-01','2013-12-20 17:13:49','129.00',NULL,NULL,'174.33','45.33','R-OH005','OH0','174.33',NULL,0,'2013-12-26 03:08:53'),(26900,21319,'Y','18','021','EC','A','','','AC','0000594593','0000594593','TX00003483048','IL','1','Bobb','Joshua',NULL,NULL,NULL,NULL,NULL,'2535 Marsh Lane',0,'Carrollton','TX','75006',NULL,'CY','48113','1989-01-16','M','U',NULL,'N','021','DEN','3457332','33348TX002000201','2014-04-01','2014-03-01 22:52:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-03 01:00:07'),(27767,21958,'Y','18','021','EC','A','','','AC','0001962394','0001962394','LA00002900235','IL','1','Henley','Larry','','','','34','428317100','4233 Lac Bienville Dr',0,'Harvey','LA','70058',NULL,'CY','22051','1963-03-29','M','U',':RET:2054-5','T','021','DEN','3555221','18575LA002000201','2014-04-01','2014-03-05 13:54:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:24'),(27923,22087,'N','01','021','EC','A',NULL,NULL,'','0000386860','0000005232','','IL','1','ZAMARRIPA','DANIEL','','','','34','449153994','2908 GRINNELL ST',0,'LUBBOCK','TX','79415','1640','CY','48303','1957-11-13','M','',NULL,'N','021','DEN','4063809','33348TX002000201','2014-04-01','2014-03-05 22:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:20'),(27934,22097,'Y','18','021','EC','A','','','AC','0000787458','0000787458','TX00003001576','IL','1','Moore','Myrna','','','','34','453234319','207 S ITASCA ST',0,'PLAINVIEW','TX','79072','6663','CY','48189','1955-01-05','F','M',':RET:2106-3','N','021','DEN','3070067','33348TX002000201','2014-04-01','2014-03-06 12:49:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:27'),(6,5,'Y','18','021','EC','A','','','AC','0001044451','0001044451','OH00001158490','IL','1','Foster','Laura','','','','34','289749672','221 W Pleasant St',0,'Hillsboro','OH','45133',NULL,'CY','39071','1964-01-28','F','U',':RET:2106-3','N','021','DEN','372821','99734OH005000401','2014-01-01','2013-12-04 20:28:32','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 17:15:10'),(13986,11143,'Y','18','021','EC','A','','','AC','0000581489','0000581489','OH00000620571','IL','1','Day','Kenneth','','','','34','300489722','2002 Austin Bluffs',0,'Toledo','OH','43615',NULL,'CY','39095','1951-12-31','M','R',NULL,'N','021','HLT','1632211','92036OH001002601','2014-01-01','2013-12-23 09:58:03','0.00',NULL,NULL,'1370.08','1370.08','R-OH001','OH0','675.75',NULL,0,'2013-12-26 13:15:42'),(476,388,'N','01','021','EC','A',NULL,NULL,'','0000701868','0000496785','','IL','1','Reliford','Danny','Allen','','','34','437497122','214 Nursery Road',0,'Sibley','LA','71073',NULL,'CY','22119','1980-10-15','M','',':RET:2054-5','N','021','DEN','1046184','18575LA002000201','2014-01-01','2013-12-03 20:05:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 17:48:00'),(2014,1653,'Y','18','021','EC','A','','','AC','0000163643','0000163643','OH00000084726','IL','1','Hunsicker','Barbara','','','','34','299525217','1334 HIGHBRIDGE RD',0,'CUYAHOGA FALLS','OH','44223','2327','CY','39153','1952-12-24','F','U',':RET:2106-3','N','021','HLT','1183864','52664OH151001501','2014-01-01','2013-11-20 15:10:05','0.00',NULL,NULL,'1520.01','1520.01','R-OH012','OH0','751.58',NULL,0,'2013-12-25 19:02:36'),(2286,1863,'Y','18','021','EC','A','','','AC','0001118692','0001118692','OH00000717562','IL','1','paul','janet','l','','','34','288521276','1015 HEMPSTEAD DR',0,'CINCINNATI','OH','45231','5809','CY','39061','1952-02-21','F','M',':RET:2106-3','N','021','DEN','676028','99734OH005000301','2014-01-01','2013-12-09 13:45:43','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:39'),(22200,17719,'Y','18','024','14','A','','','TE','0000656969','0000656969','','IL','1','Swank','Jeffery',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-07-19','M','',NULL,NULL,NULL,'','3071768','','2014-02-09','2014-02-09 08:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-09 19:00:14'),(22902,18255,'N','01','021','EC','A',NULL,NULL,'','0000214706','0000703823','','IL','1','regina','Heather','ann','','','34','293863797','332 S WAYNE ST',0,'VAN WERT','OH','45891','2135','CY','39161','1987-10-06','F','',':RET:2106-3','N','021','HLT','3393901','92036OH003001506','2014-03-01','2014-02-11 14:29:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','235.35',NULL,0,'2014-02-11 21:02:42'),(23080,18402,'Y','18','021','EC','A','','','AC','0000457845','0000457845','OH00001878124','IL','1','FREED','LEONARD','','','','34','294469028','2137 GLOUCHESTER DR',0,'CLEVELAND','OH','44124','4032','CY','39035','1959-05-13','M','U',':RET:2106-3','N','021','HLT','2895869','52664OH151001501','2014-03-01','2014-02-12 11:18:40','99.00',NULL,NULL,'644.05','545.05','R-OH011','OH0','644.05',NULL,0,'2014-02-12 21:31:02'),(23218,18509,'Y','18','021','EC','A','','','AC','0000242746','0000242746','MS00002730215','IL','1','Cooper','Linda','','','','34','587116539','1082 COOK CV',0,'EDWARDS','MS','39066','9632','CY','28049','1965-07-31','F','U',NULL,'N','021','DEN','3303851','46300MS002000201','2014-03-01','2014-02-12 17:36:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-12 21:32:18'),(23421,18662,'Y','18','021','EC','A','','','AC','0001245558','0001245558','TX00001657383','IL','1','Hughes','Herbert','','','','34','468665669','410 Mills Street',0,'Fort Worth','TX','76102',NULL,'CY','48439','1959-11-29','M','M',':RET:2106-3','T','021','DEN','2992745','33348TX002000201','2014-03-01','2014-02-12 21:51:20','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:22'),(24683,19592,'Y','18','024','14','A','','','TE','0000277949','0000277949','','IL','1','Rivas','Sergio',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-24','M','',NULL,NULL,NULL,'','3820792','','2014-02-18','2014-02-18 23:03:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-20 04:30:48'),(26415,20949,'Y','18','021','EC','A','','','AC','0000212192','0000212192','TX00002447134','IL','1','Anderson','Shelley','','','','34','467539325','20927 VISTA TRACE DR',0,'HOUSTON','TX','77073','5459','CY','48201','1968-01-13','F','U',NULL,'N','021','DEN','2841754','33348TX002000101','2014-03-01','2014-02-26 18:13:28','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15','CIC',0,'2014-02-28 07:30:03'),(26418,20952,'Y','18','021','EC','A','','','AC','0000858522','0000858522','TX00001984821','IL','1','FISHER-FLORES','NORMA','','','','34','450371998','7409 LAKEHURST RD',0,'el paso','TX','79912',NULL,'CY','48141','1961-01-07','F','M',NULL,'N','021','DEN','3038513','33348TX002000201','2014-04-01','2014-02-26 20:06:21','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61','CIC',0,'2014-02-28 07:30:06'),(27661,21879,'Y','18','021','EC','A','','','AC','0000461997','0000461997','OH00003282630','IL','1','SUPPLENUSBAUM','Donna','','','','34','278522850','6325 MARIANA DR',0,'CLEVELAND','OH','44130','2839','CY','39035','1956-04-12','F','M',NULL,'N','021','DEN','3703413','99734OH005000401','2014-04-01','2014-03-05 15:58:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-05 21:30:27'),(3235,2605,'Y','18','021','EC','A','','','AC','0000136036','0000136036','OH00001167952','IL','1','Bennett','Cathy','','','','34','232941027','2548 BARNETT RIDGE RD',0,'FLEMING','OH','45729','5204','CY','39167','1957-12-01','F','U',NULL,'N','021','DEN','779972','99734OH005000301','2014-01-01','2013-10-06 09:54:01','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 20:46:08'),(20717,16554,'Y','18','024','14','A','','','TE','0001364937','0001364937','','IL','1','bernal','roman',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-11-18','M','',NULL,NULL,NULL,'','2919442','','2014-01-30','2014-01-30 18:13:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-30 21:01:12'),(1763,1456,'Y','18','021','EC','A','','','AC','0001118726','0001118726','OH00001512199','IL','1','McGill','Sharon','','','','34','273804958','2933 LISA DR',0,'SIDNEY','OH','45365','9507','CY','39149','1967-04-02','F','U',':RET:2106-3','T','021','DEN','1729106','99734OH005000301','2014-01-01','2013-12-24 13:40:30','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:55:56'),(20129,16062,'Y','18','024','14','A','','','TE','0000109281','0000109281','','IL','1','FLECK','AMY','ELIZABETH',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-02-03','F','',NULL,NULL,NULL,'','1682289','','2014-01-27','2014-01-27 11:27:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:51'),(19767,15757,'Y','18','021','EC','A','','','AC','0001154771','0001154771','MS00001896789','IL','1','Lewis','Jerry','','','','34','425081308','564 WITSELL RD',0,'JACKSON','MS','39206','3819','CY','28049','1957-03-15','M','M',':RET:2054-5','N','021','DEN','2797249','46300MS002000101','2014-03-01','2014-01-23 14:13:00','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-23 21:01:27'),(19495,15537,'Y','18','021','EC','A','','','AC','0000205813','0000205813','OH00002106550','31','1','Frankel','Erika','','','','34','182568693','8138 Main St',0,'Garrettsville','OH','44231',NULL,'CY','39133','1969-02-10','F','U',':RET:2106-3','N','021','HLT','3273844','52664OH151001304','2014-03-01','2014-01-22 11:48:14','138.00',NULL,NULL,'322.02','184.02','R-OH012','OH0','322.02',NULL,0,'2014-01-23 03:02:08'),(6178,4895,'N','01','021','EC','A',NULL,NULL,'','0000006946','0000008374','','IL','1','Higham','Marilyn','','','','34','299724779','4429 Robinson Rd',0,'Hillsboro','OH','45133',NULL,'CY','39071','1962-11-06','F','',NULL,'T','021','HLT','104048','92036OH003000606','2014-01-01','2013-10-02 07:22:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','480.83',NULL,0,'2013-12-26 00:17:14'),(16361,13093,'Y','18','024','14','A','','','TE','0001066996','0001066996','','IL','1','Roby','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-19','F','',NULL,NULL,NULL,'','1767236','','2014-01-06','2014-01-06 17:56:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:02:45'),(6917,5490,'Y','18','021','EC','A','','','AC','0001016858','0001016858','OH00000236079','IL','1','chavez','bonnie','','','','34','269949846','6411 ridge rd',0,'cleveland','OH','44129',NULL,'CY','39035','1991-03-10','F','U',':RET:2106-3','N','021','DEN','1592106','99734OH005000401','2014-01-01','2013-12-24 18:20:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:05'),(15595,12479,'Y','18','024','14','A','','','TE','0000858456','0000858456','','IL','1','Mahone','Terence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-11-24','M','',NULL,NULL,NULL,'','100398','','2013-12-31','2013-12-31 12:04:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:32:29'),(13933,11113,'Y','18','021','EC','A','','','AC','0001012922','0001012922','OH00000563313','IL','1','Burrington','James','','','','34','381703517','1956 W Alexis',0,'Toledo','OH','43613',NULL,'CY','39095','1957-02-01','M','U',':RET:2106-3','T','021','HLT','2443230','92036OH004002601','2014-01-01','2013-12-23 10:15:34','314.00',NULL,NULL,'420.66','106.66','R-OH001','OH0','420.66',NULL,0,'2013-12-26 13:14:32'),(7430,5880,'Y','18','021','EC','A','','','AC','0000287079','0000287079','OH00000993530','IL','1','Boes','Matthew','','','','34','294904624','53 S HIGHLAND AVE',0,'AKRON','OH','44303','1022','CY','39153','1989-12-02','M','U',':RET:2106-3','N','021','HLT','187541','52664OH151001306','2014-01-01','2013-12-14 18:42:46','140.00',NULL,NULL,'223.01','83.01','R-OH012','OH0','223.01',NULL,0,'2013-12-26 02:30:07'),(13077,10425,'Y','18','021','EC','A','','','AC','0000062532','0000062532','OH00001089258','IL','1','Agosti','Robert','','','','34','182609696','857 INWOOD PL',0,'COLUMBUS','OH','43224','1919','CY','39049','1964-01-01','M','U',':RET:2106-3','T','021','DEN','1569521','99734OH005000401','2014-01-01','2013-12-23 10:35:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:51:28'),(24400,19381,'Y','18','021','EC','A','','','AC','0000966954','0000966954','OH00002259780','IL','1','Lowen','Kathleen','A','','','34','297545896','5296 E MIAMI RIVER RD',0,'CLEVES','OH','45002','9676','CY','39061','1955-09-02','F','M',':RET:2106-3','N','021','DEN','2961817','99734OH005000401','2014-04-01','2014-02-18 14:19:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:54'),(25755,20428,'Y','18','021','EC','A','','','AC','0000381194','0000381194','OH00002538328','IL','1','Wasserman','Kyle','','','','34','600925639','36353 Derby Downs Dr',0,'Solon','OH','44139',NULL,'CY','39035','1987-02-10','M','R',':RET:2106-3','N','021','DEN','3047221','99734OH005000401','2014-04-01','2014-02-24 17:43:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 09:30:47'),(28821,22809,'Y','18','021','EC','A','','','AC','0000927287','0000927287','MS00002870135','IL','1','CATES','COLEY','M','','','34','429595735','106 FOX RUN DR',0,'RIDGELAND','MS','39157','2118','CY','28089','1973-11-25','M','U',NULL,'T','021','DEN','3945414','46300MS002000101','2014-04-01','2014-03-09 10:45:10','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-09 21:01:00'),(29115,23048,'Y','18','024','14','A','','','TE','0001257143','0001257143','','IL','1','KING','MAURINE','CATHERINE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-05','F','',NULL,NULL,NULL,'','3818564','','2014-03-10','2014-03-10 10:28:08',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-10 21:02:27'),(942,779,'Y','18','021','EC','A','','','AC','0000716297','0000716297','OH00000909019','IL','1','Moore','Karen','Theresa','','','34','268468063','918 6TH AVE',0,'MIDDLETOWN','OH','45044','4224','CY','39017','1949-06-04','F','U',':RET:2054-5','N','021','DEN','55601','99734OH005000301','2014-01-01','2013-10-28 20:47:55','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:22'),(20040,15981,'Y','18','021','EC','A','','','AC','0001245627','0001245627','OH00002195042','IL','1','HILL','AMANDA','KRISTINE','','','34','268924074','724 QUILLIAMS RD',0,'CLEVELAND HEIGHTS','OH','44121','1956','CY','39035','1987-12-23','F','U',':RET:2106-3','T','021','HLT','2821205','52664OH151001305','2014-03-01','2014-01-26 08:47:42','117.00',NULL,NULL,'296.19','179.19','R-OH011','OH0','296.19',NULL,0,'2014-01-26 19:00:25'),(4318,3430,'N','01','021','EC','A',NULL,NULL,'','0000665622','0000650765','','IL','1','PANTON','ALTON','R','','','34','594113131','1110 HAYWARD CIR',0,'MILFORD','OH','45150',NULL,'CY','39025','1965-11-10','M','',':RET:2054-5','N','021','HLT','1795236','92036OH004000601','2014-01-01','2013-12-17 08:40:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','282.22',NULL,0,'2013-12-25 21:52:42'),(19669,15674,'Y','18','021','EC','A','','','AC','0002142111','0002142111','LA00002019221','IL','1','MOORE','PATRICIA','','','','34','433043446','1408 West Willow Park Apartments',0,'Lafayette','LA','70506',NULL,'CY','22055','1954-10-08','F','U',':RET:2054-5','N','021','DEN','3344234','18575LA002000101','2014-03-01','2014-01-23 15:10:41','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-23 21:00:30'),(2983,2401,'Y','18','021','EC','A','','','AC','0000664151','0000664151','OH00000500750','IL','1','Krebs','Silvija','','','','34','294524741','3416 HIGLEY RD',0,'ROCKY RIVER','OH','44116','3835','CY','39035','1952-08-01','F','M',':RET:2106-3','N','021','DEN','471488','99734OH005000301','2014-01-01','2013-12-06 08:57:53','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:17:15'),(1749,1448,'N','01','021','EC','A',NULL,NULL,'','0000784364','0000993980','','IL','1','Haikal','Kimberly','','','','34','289445612','13882 LAKE AVE',0,'LAKEWOOD','OH','44107','1425','CY','39035','1963-05-30','F','',NULL,'N','021','DEN','2188206','99734OH005000301','2014-01-01','2013-12-24 12:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:39'),(18777,14957,'Y','18','021','EC','A','','','AC','0000245016','0000245016','OH00002594418','IL','1','Himes','Leslie','','','','34','276647135','5696 MELODY LN',0,'MILFORD','OH','45150','2661','CY','39025','1957-09-27','F','M',':RET:2106-3','N','021','HLT','2073136','92036OH004000601','2014-03-01','2014-01-16 13:23:30','777.00',NULL,NULL,'978.01','201.01','R-OH005','OH0','402.70',NULL,0,'2014-01-17 03:35:51'),(18729,14927,'Y','18','021','EC','A','','','AC','0000253078','0000253078','OH00002269919','IL','1','Winters','Amy','','','','34','282880534','6282 E US HIGHWAY 36',0,'CABLE','OH','43009','9625','CY','39021','1984-02-18','F','M',':RET:2106-3','N','021','DEN','2107235','99734OH005000301','2014-03-01','2014-01-16 00:24:17','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:35:36'),(6778,5376,'Y','18','021','EC','A','','','AC','0000731154','0000731154','OH00000791439','IL','1','Keltz','Jeanne','','','','34','287482424','9162 FRIENDSVILLE RD',0,'SEVILLE','OH','44273','9119','CY','39103','1950-07-15','F','U',':RET:2106-3','N','021','DEN','1046085','99734OH005000301','2014-01-01','2013-11-25 08:56:28','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:16:46'),(7394,5853,'Y','18','021','EC','A','','','AC','0001186272','0001186272','OH00001020497','IL','1','DeCastro','Robert','','','','34','282806020','1586 NORLEDGE RD',0,'AKRON','OH','44305','1343','CY','39153','1982-09-09','M','M',':RET:2106-3','N','021','HLT','767508','52664OH151001305','2014-01-01','2013-11-22 23:55:26','312.00',NULL,NULL,'511.58','199.58','R-OH012','OH0','258.47',NULL,0,'2013-12-26 02:16:15'),(14835,11847,'N','01','021','EC','A',NULL,NULL,'','0000362502','0000459151','','IL','1','Wiechers','Michael','','','','34','293443347','520 S POPLAR ST',0,'BUCYRUS','OH','44820','2658','CY','39033','1951-04-18','M','',':RET:2106-3','N','021','DEN','1552824','99734OH005000301','2014-01-01','2013-12-23 20:18:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:14:40'),(21034,16806,'N','01','021','EC','A',NULL,NULL,'','0001005747','0000716375','','IL','1','POWERS','DON','','','','34','271522289','632 FOLKERTH AVE',0,'SIDNEY','OH','45365','9091','CY','39149','1950-11-27','M','',':RET:2106-3','N','021','HLT','3633231','92036OH006000501','2014-03-01','2014-02-01 11:59:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','556.49',NULL,0,'2014-02-01 19:00:46'),(21849,17447,'Y','18','021','EC','A','','','AC','0001070511','0001070511','OH00001671200','IL','1','Wilkins','Gloria','','','','34','270443027','4342 CENTENNIAL DR',0,'CINCINNATI','OH','45227','2579','CY','39061','1949-10-13','F','U',NULL,'N','021','DEN','3134346','99734OH005000301','2014-03-01','2014-02-06 13:11:49','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:01:14'),(24762,19646,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000330936','','IL','1','Dugan','Veronica','A','','','34','296969404','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1994-02-07','F','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:42:50'),(1171,965,'N','01','021','EC','A',NULL,NULL,'','0000253015','0000911736','','IL','1','KULOW','JANET','RAE','','','34','294544309','449 DOHNER DRIVE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1953-11-23','F','',':RET:2106-3','N','021','HLT','549112','52664OH151001501','2014-01-01','2013-12-02 19:47:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','725.90',NULL,0,'2013-12-25 18:19:09'),(20858,16672,'N','19','021','EC','A',NULL,NULL,'','0001201924','0000720281','','IL','1','Destefano','Gabriella','','','','34','294084310','3688 HEMPHILL RD',0,'NORTON','OH','44203','5020','CY','39153','2004-02-19','F','',NULL,'N','021','DEN','2817982','99734OH005000301','2014-03-01','2014-01-31 15:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:56'),(5703,4526,'Y','18','021','EC','A','','','AC','0000704465','0000704465','MS00000613613','IL','1','PAYNE','WILLIE','','','','34','587011321','180 CR 17257',0,'BAY SPRINGS','MS','39422',NULL,'CY','28061','1950-04-10','M','U',':RET:2054-5','N','021','DEN','314976','46300MS002000101','2014-01-01','2013-11-26 16:00:03','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 23:32:58'),(16553,13242,'Y','18','021','EC','A','','','AC','0001225797','0001225797','LA00001401911','IL','1','GREEN','ELLEN','','','','34','436299746','2744 JACKSON AVE',0,'BATON ROUGE','LA','70802','2847','CY','22033','1962-04-26','F','M',':RET:2054-5','N','021','DEN','2528782','18575LA002000201','2014-02-01','2014-01-05 13:39:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-07 10:22:48'),(16525,13220,'Y','18','021','EC','A','','','AC','0000810649','0000810649','TX00001376427','IL','1','Gilberry','Kelley','','','','34','592180491','212 GILA CLIFF DR',0,'PFLUGERVILLE','TX','78660','5282','CY','48453','1978-11-21','M','R',':RET:2054-5','N','021','DEN','2337692','33348TX002000201','2014-02-01','2014-01-05 12:54:08','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,1,'2014-01-07 10:21:53'),(14984,11975,'Y','18','021','EC','A','','','AC','0000118125','0000118125','TX00001261720','IL','1','Logan','Brittany','','','','34','639322945','2154 COUNTY ROAD 3925',0,'MT PLEASANT','TX','75455','6947','CY','48449','1992-09-17','F','U',':RET:2106-3','N','021','DEN','1496743','33348TX002000201','2014-02-01','2013-12-30 14:58:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:11'),(14743,11772,'Y','18','021','EC','A','','','AC','0002332204','0002332204','LA00000021888','IL','1','Negrotto','Brad','','','','34','438619370','37377 PRAIRIE DR',0,'PRAIRIEVILLE','LA','70769','4444','CY','22005','1979-05-31','M','U',':RET:2106-3','N','021','DEN','1798444','18575LA002000101','2014-02-01','2013-12-28 11:45:30','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2013-12-29 11:10:04'),(14596,11649,'Y','18','021','EC','A','','','AC','0000599762','0000599762','OH00001142809','IL','1','SKOBLAR','ANNE','MARIE','','','34','299581056','588 PALISADES DR',0,'AKRON','OH','44303','1763','CY','39153','1959-08-25','F','U',':RET:2106-3','N','021','HLT','1525629','52664OH151001305','2014-02-01','2013-12-27 14:53:47','328.00',NULL,NULL,'476.12','148.12','R-OH012','OH0','476.12',NULL,0,'2013-12-28 03:36:15'),(14402,11485,'Y','18','024','14','A','','','TE','0000703759','0000703759','','IL','1','Lay','River','Manda',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2008-05-06','F','',NULL,NULL,NULL,'','94437','','2013-12-27','2013-12-27 17:06:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:31:13'),(13901,11087,'Y','18','021','EC','A','','','AC','0000708939','0000708939','OH00000308835','IL','1','Derian','Cynthia','','','','34','284581933','4710 290TH ST',0,'TOLEDO','OH','43611','1960','CY','39095','1956-08-14','F','M',':RET:2106-3','N','021','HLT','2269988','92036OH006002601','2014-01-01','2013-12-23 16:27:26','584.00',NULL,NULL,'779.41','195.41','R-OH001','OH0','376.87',NULL,0,'2013-12-26 13:13:41'),(4467,3549,'Y','18','021','EC','A','','','AC','0000491857','0000491857','OH00001048222','IL','1','heffley','kristin','','','','34','290708000','1048 PARK AVE',0,'RAVENNA','OH','44266','1459','CY','39133','1970-04-02','F','U',':RET:2106-3','N','021','DEN','886571','99734OH005000301','2014-01-01','2013-12-12 14:26:24','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:02:45'),(9289,7367,'Y','18','021','EC','A','','','AC','0000225979','0000225979','OH00001125565','IL','1','Smith','Robert','','','','34','487904255','919 BROOKCREST DR',0,'MASON','OH','45040','3435','CY','39165','1972-12-02','M','M',':RET:2106-3','N','021','DEN','1094066','99734OH005000301','2014-01-01','2013-11-30 14:42:52','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:16:07'),(7438,5886,'N','01','021','EC','A',NULL,NULL,'','0000307086','0000019097','','IL','1','WAGNER','GERALD','','','','34','295725865','373 E ARCHWOOD AVE',0,'AKRON','OH','44301','2138','CY','39153','1964-03-17','M','',':RET:2106-3','N','021','HLT','269477','52664OH151001304','2014-01-01','2013-12-15 11:08:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45',NULL,0,'2013-12-26 02:30:20'),(6787,5383,'Y','18','021','EC','A','','','AC','0000570083','0000570083','TX00001062136','IL','1','Pham','Peter Dzung','','','','34','461477683','527 COLONY LAKE ESTATES DR',0,'STAFFORD','TX','77477','4597','CY','48157','1955-10-29','M','M',':RET:2047-9','N','021','DEN','24560','33348TX002000201','2014-01-01','2013-11-24 20:19:01','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:17:00'),(23695,18870,'Y','18','021','EC','A','','','AC','0001038651','0001038651','OH00001915393','IL','1','Cunningham','Janet','','','','34','299888147','212 East N. St.',0,'Medina','OH','44256',NULL,'CY','39103','1977-03-15','F','U',':RET:2106-3','N','021','DEN','3362929','99734OH005000401','2014-03-01','2014-02-14 10:59:59','0.00',NULL,NULL,'50.05','50.05','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:39'),(24476,19444,'Y','18','021','EC','A','','','AC','0001187688','0001187688','OH00002587386','IL','1','Civitarese','Frank','','','','34','289787703','210 MONROE ST',0,'LOUDONVILLE','OH','44842','1328','CY','39005','1981-11-25','M','M',':RET:2106-3','N','021','HLT','3280684','52664OH152000901','2014-04-01','2014-02-18 13:52:02','0.00',NULL,NULL,'193.23','193.23','R-OH012','OH0','193.23',NULL,0,'2014-02-18 22:01:41'),(25998,20618,'N','01','021','EC','A',NULL,NULL,'','0001944662','0002264061','','IL','1','Crocker','Suzette','','','','34','433135300','356 BLUNT MILL RD',0,'GRAND CANE','LA','71032','5532','CY','22031','1958-11-20','F','',NULL,'N','021','DEN','2646635','18575LA002000101','2014-04-01','2014-02-26 09:42:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-26 21:02:01'),(25873,20514,'Y','18','021','EC','A','','','AC','0001551861','0001551861','LA00003286276','IL','1','MENDEZ DE VILLAGRAN','ALMA','','','','34','663105841','3321 EDENBORN AVENUE 103',0,'METAIRIE','LA','70002',NULL,'CY','22051','1958-09-13','F','U',':RET:2106-3','N','021','DEN','3259888','18575LA002000201','2014-03-01','2014-02-26 17:05:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:52'),(28001,22156,'Y','18','021','EC','A','','','AC','0000335216','0000335216','OH00003450211','IL','1','Carr','Kyla','jenee','','','34','294949905','737 ELAINE RD',0,'WHITEHALL','OH','43213','3020','CY','39049','1983-09-23','F','R',':RET:2054-5','T','021','DEN','3339085','99734OH005000401','2014-04-01','2014-03-05 20:03:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:08'),(3809,3052,'Y','18','021','EC','A','','','AC','0000195116','0000195116','OH00000674748','IL','1','Wilson','Michael','','','','34','280688633','6664 US Hwy 42',0,'Mount Gilead','OH','43338',NULL,'CY','39117','1960-08-26','M','U',':RET:2106-3','N','021','DEN','678341','99734OH005000301','2014-01-01','2013-12-13 13:49:23','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','0.00',NULL,0,'2013-12-25 21:34:42'),(19894,15868,'Y','18','024','14','A','','','TE','0000679557','0000679557','','IL','1','Cook','Julie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-05-06','F','',NULL,NULL,NULL,'','3092957','','2014-01-24','2014-01-24 13:40:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:52'),(4384,3485,'Y','18','021','EC','A','','','AC','0000697886','0000697886','OH00001020811','IL','1','WEAVER','WINIFRED','','','','34','296867867','1168 SIDNEY ST',0,'COLUMBUS','OH','43201',NULL,'CY','39049','1987-10-16','F','U',NULL,'N','021','DEN','67934','99734OH005000401','2014-01-01','2013-12-12 10:29:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:43'),(7559,5983,'Y','18','021','EC','A','','','AC','0000538250','0000538250','OH00000670940','IL','1','Richardson','Cynthia','','','','34','280829594','6235 S FULTON LUCAS RD',0,'SWANTON','OH','43558','8700','CY','39095','1968-07-22','F','U',NULL,'N','021','HLT','1099825','92036OH004002601','2014-01-01','2013-12-15 08:57:25','51.00',NULL,NULL,'226.41','175.41','R-OH001','OH0','226.41',NULL,0,'2013-12-26 02:33:26'),(7755,6143,'Y','18','024','14','A','','','TE','0000236264','0000236264','','IL','1','SMITH','LISA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-07-27','F','',NULL,NULL,NULL,'','2484251','','2013-12-20','2013-12-20 16:47:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:37'),(18360,14656,'N','19','021','EC','A',NULL,NULL,'','0000701719','0000128121','','IL','1','Marmer','Emily','','','','34','284048518','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1999-08-07','F','',':RET:2039-6^:RET:2106-3','N','021','DEN','1466950','99734OH005000301','2014-02-01','2014-01-15 01:42:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:26'),(18155,14499,'Y','18','024','14','A','','','TE','0000976728','0000976728','','IL','1','GREIWERA','Ralph','allen',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-28','M','',NULL,NULL,NULL,'','2100257','','2014-01-14','2014-01-14 11:16:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:07:52'),(17560,14040,'N','01','021','EC','A',NULL,NULL,'','0000511965','0000661368','','IL','1','Brown','Matthew','J','','','34','283782574','4411 ZURMEHLY RD',0,'LIMA','OH','45806','1030','CY','39003','1981-05-01','M','',':RET:2106-3','T','021','HLT','1946058','92036OH001001501','2014-02-01','2014-01-12 14:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','361.17',NULL,0,'2014-01-13 03:02:00'),(23825,18957,'Y','18','021','EC','A','','','AC','0000128681','0000128681','MS00002151811','IL','1','Carter','John','','','','34','587620081','286 KITTRELL RD',0,'BEAUMONT','MS','39423','2422','CY','28111','1955-09-11','M','M',NULL,'N','021','DEN','3793770','46300MS002000101','2014-03-01','2014-02-13 22:24:44','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-14 21:31:43'),(25709,20395,'Y','18','021','EC','A','','','AC','0000537644','0000537644','TX00002586172','IL','1','GILBERT','TIMOTHY','','','','34','454715571','25343 WILLIAMS DR',0,'JUSTIN','TX','76247','7520','CY','48121','1968-12-23','M','M',':RET:2106-3','N','021','DEN','3241204','33348TX002000201','2014-04-01','2014-02-24 15:49:19','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-26 09:30:22'),(26675,21148,'Y','18','021','EC','A','','','AC','0001847213','0001847213','LA00002896312','IL','1','LITT','RHONDA','','','','34','435598777','6155 SANDY CREEK LN',0,'ZACHARY','LA','70791','2759','CY','22033','1970-10-06','F','U',':RET:2054-5','N','021','DEN','3017416','18575LA002000201','2014-04-01','2014-02-28 12:17:33','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:20'),(27096,21452,'Y','18','021','EC','A','','','AC','0000242767','0000242767','OH00002905665','IL','1','White','Tina','','','','34','290661842','1010 CARNEGIE AVE',0,'AKRON','OH','44314','1146','CY','39153','1966-06-11','F','M',':RET:2106-3','N','021','HLT','3110608','52664OH151001304','2014-04-01','2014-03-03 17:53:32','273.01',NULL,NULL,'773.39','500.38','R-OH012','OH0','348.56',NULL,0,'2014-03-03 21:30:20'),(28714,22724,'Y','18','021','EC','A','','','AC','0000723915','0000723915','OH00002668285','IL','1','Deerhake','Katie','','','','34','289828274','1457 IVY DR',0,'ELIDA','OH','45807','9455','CY','39003','1982-12-28','F','U',':RET:2106-3','N','021','HLT','4115605','92036OH004001501','2014-04-01','2014-03-08 13:12:28','203.61',NULL,NULL,'205.11','1.50','R-OH002','OH0','205.11',NULL,0,'2014-03-08 21:31:16'),(865,716,'Y','18','021','EC','A','','','AC','0000218816','0000218816','OH00000529925','IL','1','heaps','amber','','','','34','286947603','333 W MAIN ST',0,'METAMORA','OH','43540','9702','CY','39051','1987-09-13','F','U',':RET:2106-3','N','021','HLT','1885454','92036OH006002601','2014-01-01','2013-12-16 15:31:09','0.00',NULL,NULL,'158.35','158.35','R-OH001','OH0','158.35',NULL,0,'2013-12-25 18:07:17'),(21654,17293,'Y','18','021','EC','A','','','AC','0001875542','0001875542','LA00001468523','IL','1','Hudson','Lazandra','','','','34','426331450','P. O. Box 254',0,'Wilson','LA','70789',NULL,'CY','22037','1977-10-07','F','U',':RET:2054-5','N','021','DEN','3367506','18575LA002000201','2014-03-01','2014-02-05 09:58:45','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:51'),(21012,16789,'N','01','021','EC','A',NULL,NULL,'','0001067016','0000491914','','IL','1','Do','Thuong','','','','34','274119622','7927 Furrow Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1983-12-16','F','',':RET:2047-9','N','021','DEN','3069221','99734OH005000401','2014-03-01','2014-02-01 01:30:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:34'),(20117,16051,'Y','18','021','EC','A','','','AC','0000708972','0000708972','OH00001447877','IL','1','Davis','Bryan','','','','34','289845028','3838 DREXEL DR',0,'TOLEDO','OH','43612','1236','CY','39095','1969-09-14','M','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','2839920','99734OH005000401','2014-03-01','2014-01-26 22:50:41','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-27 21:00:44'),(19386,15454,'Y','18','021','EC','A','','','AC','0000532138','0000532138','OH00002594496','IL','1','GREER','JANE','','','','34','286583187','7689 TOWNSHIP ROAD 237',0,'FINDLAY','OH','45840','8679','CY','39063','1955-12-29','F','M',':RET:2106-3','N','021','DEN','3131577','99734OH005000401','2014-03-01','2014-01-21 09:51:53','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,1,'2014-01-22 03:22:45'),(19118,15232,'Y','18','021','EC','A','','','AC','0000171256','0000171256','OH00001358711','IL','1','Bennett','Valerie','','','','34','276524737','518 HILL AVE',0,'FAIRFIELD','OH','45014','1022','CY','39017','1952-09-25','F','U',':RET:2106-3','N','021','HLT','1449972','92036OH003001201','2014-03-01','2014-01-19 13:18:29','308.00',NULL,NULL,'629.96','321.96','R-OH004','OH0','629.96',NULL,0,'2014-01-21 08:45:15'),(6137,4867,'Y','18','021','EC','A','','','AC','0000313846','0000313846','LA00001221028','IL','1','MacDougall','Glenn','','','','34','008426603','14302 RIVERLAKE DR',0,'COVINGTON','LA','70435','5783','CY','22103','1955-07-23','M','M',':RET:2106-3','N','021','DEN','902408','18575LA002000201','2014-01-01','2013-11-21 17:43:12','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:16:10'),(18186,14519,'N','01','021','EC','A',NULL,NULL,'','0000956670','0000119087','','IL','1','Line','Brenda','','','','34','296702625','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1960-10-15','F','',':RET:2106-3','N','021','HLT','2739789','92036OH004000501','2014-02-01','2014-01-14 11:16:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','389.92',NULL,0,'2014-01-15 02:08:02'),(7595,6009,'Y','18','021','EC','A','','','AC','0001108064','0001108064','OH00000223966','IL','1','Crock','Ann','','','','34','293862374','7845 BRIDGEPOINT DR',0,'CINCINNATI','OH','45248','1920','CY','39061','1978-03-31','F','U',':RET:2106-3','N','021','DEN','9989','99734OH005000401','2014-01-01','2013-11-17 10:00:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:45:13'),(8169,6463,'N','01','021','EC','A',NULL,NULL,'','0000939735','0000055877','','IL','1','McKinley','Amanda','Ellen','','','34','295783358','200 WATER WORKS RD',0,'PEEBLES','OH','45660','9799','CY','39001','1972-08-19','F','',':RET:1002-5^:RET:2106-3','N','021','HLT','398807','92036OH005000605','2014-01-01','2013-11-22 11:37:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','279.50',NULL,0,'2013-12-26 03:16:34'),(28061,22206,'Y','18','021','EC','A','','','AC','0000393737','0000393737','OH00002835978','IL','1','SAN','MYO','','','','34','303310924','305 S LOCUST ST',0,'OXFORD','OH','45056','2170','CY','39017','1977-02-03','M','M',NULL,'N','021','DEN','4086888','99734OH005000301','2014-04-01','2014-03-05 23:21:01','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:44'),(6552,5194,'N','01','021','EC','A',NULL,NULL,'','0001230670','0000450504','','IL','1','Pitts','Tamykah','Lynnette','','','34','306980932','3400 Craig Drive',0,'Mckinney','TX','75070',NULL,'CY','48085','1980-08-07','F','',':RET:2054-5','N','021','DEN','61576','33348TX002000201','2014-01-01','2013-12-11 12:14:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:52:12'),(22162,17687,'N','19','021','EC','A',NULL,NULL,'','0001246982','0001007923','','IL','1','Hartwig','Ayden','J','','','34','276133632','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','2007-02-19','M','',':RET:2106-3','N','021','HLT','3385475','92036OH005001201','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-02-08 19:00:59'),(4349,3452,'Y','18','021','EC','A','','','AC','0001258643','0001258643','OH00000053826','IL','1','Manley','Ronese','','','','34','295628490','952 E VINE ST',0,'LIMA','OH','45804',NULL,'CY','39003','1958-04-03','F','U',':RET:2054-5','N','021','HLT','1888263','92036OH004001501','2014-01-01','2013-12-17 17:50:49','391.76',NULL,NULL,'394.64','2.88','R-OH002','OH0','394.64',NULL,0,'2013-12-25 21:53:25'),(16047,12850,'Y','18','021','EC','A','','','AC','0000035762','0000035762','TX00002115109','IL','1','Machicek','Verlyn','','','','34','463921045','502 HERDER AVE',0,'SCHULENBURG','TX','78956','1606','CY','48149','1951-02-17','F','M',':RET:2106-3','N','021','DEN','1943661','33348TX002000101','2014-02-01','2014-01-03 18:09:51','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-04 02:03:04'),(16050,12853,'Y','18','021','EC','A','','','AC','0000630386','0000630386','OH00000413822','IL','1','Waterman','Jennifer','','','','34','286929900','8261 CHEVIOT RD',0,'CINCINNATI','OH','45247','3801','CY','39061','1985-12-20','F','M',NULL,'N','021','DEN','2159439','99734OH005000401','2014-02-01','2014-01-02 21:36:42','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:11'),(19782,15770,'Y','18','021','EC','A','','','AC','0000493261','0000493261','OH00001539346','IL','1','Mealka','Gregory','','','','34','293645432','3916 South Arlington Rd.',0,'Uniontown','OH','44685',NULL,'CY','39153','1958-10-19','M','U',':RET:2106-3','N','021','HLT','2967529','52664OH151001305','2014-03-01','2014-01-23 11:34:11','323.00',NULL,NULL,'497.31','174.31','R-OH012','OH0','497.31',NULL,0,'2014-01-23 21:01:35'),(17064,13656,'Y','18','021','EC','A','','','AC','0001014083','0001014083','TX00002177188','IL','1','mckenzie','frenchell','','','','34','452816467','6500 St. John dr.',0,'Fort Worth','TX','76132',NULL,'CY','48439','1986-10-29','F','U',':RET:2054-5','N','021','DEN','2510755','33348TX002000201','2014-02-01','2014-01-07 21:36:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:13'),(25268,20047,'Y','18','021','EC','A','','','AC','0001941234','0001941234','LA00002219134','IL','1','Korman','Alexis','','','','34','625245872','200 CARONDELET ST',0,'NEW ORLEANS','LA','70130','2915','CY','22071','1981-11-20','F','U',':RET:2106-3','N','021','DEN','2786861','18575LA002000201','2014-04-01','2014-02-24 19:14:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-25 21:00:10'),(25870,20511,'Y','18','021','EC','A','','','AC','0001636364','0001636364','LA00001976807','IL','1','Salas','Edward','','','','34','631103968','1105 Foster st',0,'shreveport','LA','71101',NULL,'CY','22017','1985-10-03','M','U',':RET:2106-3','N','021','DEN','3029301','18575LA002000201','2014-03-01','2014-02-26 15:52:49','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-26 21:00:50'),(26260,20828,'Y','18','021','EC','A','','','AC','0000943383','0000943383','TX00003298850','IL','1','GOMEZ','MICHELLE','L','','','34','463751090','2508 HIGH RIDGE LN',0,'EDINBURG','TX','78539','6167','CY','48215','1981-10-08','F','U',NULL,'N','021','DEN','3434126','33348TX002000201','2014-04-01','2014-02-27 15:47:09','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-28 06:31:12'),(28107,22248,'Y','18','021','EC','A','','','AC','0001019326','0001019326','OH00003030240','IL','1','Badowski','Kelly','','','','34','280645052','550 RAWLINS AVE',0,'AKRON','OH','44319','4343','CY','39153','1963-07-16','F','M',':RET:2106-3','N','021','HLT','3177573','52664OH152000901','2014-04-01','2014-03-06 15:36:51','400.00',NULL,NULL,'936.10','536.10','R-OH012','OH0','291.73',NULL,0,'2014-03-06 21:02:14'),(28328,22414,'N','01','021','EC','A',NULL,NULL,'','0000872922','0001011829','','IL','1','Denbow','William','Kevin','','','34','460690387','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1968-09-16','M','',':RET:2106-3','N','021','DEN','3682816','33348TX002000201','2014-04-01','2014-03-07 00:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-07 21:30:09'),(29109,23042,'Y','18','021','EC','A','','','AC','0002068774','0002068774','LA00003186533','IL','1','Sorensen','Scott','P','','','34','433350059','606 VOTERS RD',0,'SLIDELL','LA','70461','3555','CY','22103','1963-06-12','M','U',':RET:2106-3','N','021','DEN','3985258','18575LA002000101','2014-04-01','2014-03-10 14:04:41','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-10 21:02:22'),(620,511,'Y','18','024','14','A','','','TE','0000690707','0000690707','','IL','1','Sarisky','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-03','M','',NULL,NULL,NULL,'','449387','','2013-12-16','2013-12-16 11:33:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:00:49'),(20870,16679,'Y','18','021','EC','A','','','AC','0000468843','0000468843','MS00002547540','IL','1','HARPER','ROBIN','','','','34','426433671','1778 MORRISON CEMETERY RD',0,'EDWARDS','MS','39066','9300','CY','28049','1966-01-09','F','U',':RET:2054-5','N','021','DEN','2843653','46300MS002000101','2014-03-01','2014-01-31 12:09:36','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-31 21:01:01'),(845,699,'Y','18','021','EC','A','','','AC','0000500824','0000500824','LA00001262272','IL','1','Rougeau','Linda','','','','34','439980765','4803 MILLWOOD DR',0,'BATON ROUGE','LA','70817','1209','CY','22033','1956-01-03','F','U',':RET:2106-3','N','021','DEN','512326','18575LA002000101','2014-01-01','2013-12-15 23:52:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:06:43'),(19793,15779,'Y','18','024','14','A','','','TE','0000879487','0000879487','','IL','1','Taylor','Nicole',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-01-02','F','',NULL,NULL,NULL,'','2330830','','2014-01-23','2014-01-23 14:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:43'),(19132,15244,'Y','18','021','EC','A','','','AC','0001881841','0001881841','LA00002161768','IL','1','Sherman','Trainett','','','','34','438337445','108 BLACKWELL LN',0,'BELLE ROSE','LA','70341','5847','CY','22007','1977-10-24','F','U',':RET:2054-5','N','021','DEN','3124240','18575LA002000201','2014-03-01','2014-01-19 11:12:09','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-21 08:45:24'),(17532,14017,'N','19','021','EC','A',NULL,NULL,'','0001061041','0000672611','','IL','1','neal','kayla','m','','','34','587714445','526 broad st',0,'jackson','MS','39203',NULL,'CY','28049','1991-09-21','F','',':RET:2054-5','N','021','DEN','2381709','46300MS002000201','2014-02-01','2014-01-12 10:18:20',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 03:01:43'),(3946,3158,'N','01','021','EC','A',NULL,NULL,'','0000577299','0000632673','','IL','1','Richards','walter','','','','34','295722471','1430 CARROL ST',0,'SIDNEY','OH','45365','6201','CY','39149','1961-12-29','M','',NULL,'T','021','HLT','143373','92036OH006000501','2014-01-01','2013-12-13 10:00:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','423.18',NULL,0,'2013-12-25 21:38:02'),(4206,3345,'Y','18','021','EC','A','','','AC','0000820511','0000820511','TX00000942231','IL','1','Denny','Rebeca','Anthon','','','34','464535422','900 KING RD',0,'SAN JUAN','TX','78589','2133','CY','48215','1955-08-30','F','M',':RET:2106-3','N','021','DEN','2317432','33348TX002000201','2014-01-01','2013-12-16 21:07:46','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:50:03'),(15855,12694,'Y','18','021','EC','A','','','AC','0000847160','0000847160','OH00001910739','IL','1','Simmons','Dominique','','','','34','570935367','795 Florida Ave',0,'Akron','OH','44314',NULL,'CY','39153','1986-10-01','F','M',':RET:2054-5','N','021','HLT','2439810','52664OH151001301','2014-02-01','2014-01-02 09:55:35','0.00',NULL,NULL,'233.71','233.71','R-OH012','OH0','233.71',NULL,0,'2014-01-03 02:04:33'),(7530,5960,'Y','18','021','EC','A','','','AC','0000359165','0000359165','TX00000705879','IL','1','Cheplick','Denise','Lynn','','','34','061548944','6 STILL GLEN CT',0,'THE WOODLANDS','TX','77381','2832','CY','48339','1967-12-16','F','R',':RET:2106-3','N','021','DEN','752582','33348TX002000201','2014-01-01','2013-12-14 23:22:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:32:39'),(8998,7140,'Y','18','021','EC','A','','','AC','0000783212','0000783212','OH00000173248','IL','1','mattes','jacob','','','','34','299924952','1684 bailey road',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1990-12-22','M','U',':RET:2106-3','T','021','HLT','1406235','52664OH152000901','2014-01-01','2013-12-17 20:16:08','0.00',NULL,NULL,'187.84','187.84','R-OH012','OH0','187.84',NULL,0,'2013-12-26 04:04:47'),(22836,18221,'Y','18','021','EC','A','','','AC','0000926307','0000926307','OH00001724650','IL','1','Ricciardi','Josephine','','','','34','302642476','1452 Winona Rd.',0,'Stow','OH','44224',NULL,'CY','39153','1958-10-27','F','U',':RET:2106-3','N','021','HLT','3853137','52664OH151001305','2014-03-01','2014-02-11 14:51:39','387.00',NULL,NULL,'497.31','110.31','R-OH012','OH0','497.31',NULL,0,'2014-02-11 21:02:10'),(22983,18323,'N','01','021','EC','A',NULL,NULL,'','0000933248','0000533344','','IL','1','Insko','Derek',NULL,NULL,NULL,NULL,NULL,'24 W 8TH ST',0,'MANCHESTER','OH','45144','1239','CY','39001','1974-11-10','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','3102867','99734OH005000301','2014-03-01','2014-02-11 21:53:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:09'),(25017,19837,'N','19','021','EC','A',NULL,NULL,'','0001199554','0000054514','','IL','1','Bignall','Riley','','','','34','287139663','601 SUNCREST DR',0,'SPRINGFIELD','OH','45503','5308','CY','39023','2007-09-05','F','',NULL,'N','021','DEN','2940508','99734OH005000301','2014-04-01','2014-02-20 14:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:00:55'),(27046,21419,'N','19','021','EC','A',NULL,NULL,'','0000265305','0000298295','','S1','1','Drees','Richard','H','','','34','282049296','5831 MURNEN RD',0,'TOLEDO','OH','43623','1413','CY','39095','1999-07-03','M','',':RET:2106-3','N','021','HLT','3396980','92036OH005002601','2014-04-01','2014-03-03 11:30:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83','CIC',0,'2014-03-03 21:00:23'),(231,195,'Y','18','021','EC','A','','','AC','0000337587','0000337587','OH00000647324','IL','1','reiser','jeanne','','','','34','272509651','415 FLEMRIDGE CT',0,'WYOMING','OH','45231','4015','CY','39061','1956-08-30','F','M',':RET:2106-3','N','021','HLT','481342','92036OH006001201','2014-01-01','2013-12-05 18:00:41','0.00',NULL,NULL,'1127.03','1127.03','R-OH004','OH0','414.90',NULL,0,'2013-12-25 17:21:03'),(4982,3956,'Y','18','021','EC','A','','','AC','0000444415','0000444415','TX00000123363','IL','1','Arreola','Abraham','','','','34','642168754','345 Shadow Mountain Dr',0,'El paso','TX','79912',NULL,'CY','48141','1990-04-14','M','M',':RET:2106-3','N','021','DEN','156548','33348TX002000201','2014-01-01','2013-12-07 14:57:27','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 22:46:45'),(9416,7470,'N','01','021','EC','A',NULL,NULL,'','0000854459','0000364506','','IL','1','Rios','Adriana','','','','34','467893459','110 Highland Circle',0,'Crystal City','TX','78839',NULL,'CY','48507','1978-08-05','F','',NULL,'N','021','DEN','2456943','33348TX002000201','2014-01-01','2013-12-21 13:46:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:33:00'),(4761,3776,'Y','18','021','EC','A','','','AC','0000424003','0000424003','OH00001097106','IL','1','Fatute','Laura','','','','34','286821024','6046 JERRY LEE DR',0,'MILFORD','OH','45150','2252','CY','39025','1984-09-06','F','M',':RET:2106-3','N','021','DEN','586526','99734OH005000401','2014-01-01','2013-12-07 19:07:45','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 22:15:33'),(7335,5809,'Y','18','021','EC','A','','','AC','0001204508','0001204508','OH00000031223','IL','1','Brock','Mark','','','','34','282627471','1058 Nordyke Rd.',0,'Cincinnati','OH','45255',NULL,'CY','39061','1961-04-13','M','U',':RET:2106-3','T','021','HLT','270921','92036OH006001201','2014-01-01','2013-12-14 12:01:14','71.00',NULL,NULL,'382.16','311.16','R-OH004','OH0','382.16',NULL,0,'2013-12-26 02:03:52'),(26466,20993,'Y','18','024','14','A','','','TE','0000289580','0000289580','','IL','1','givens','jack',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-07','M','',NULL,NULL,NULL,'','2627956','','2014-03-31','2014-02-27 14:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:34'),(1338,1107,'Y','18','021','EC','A','','','AC','0000972710','0000972710','OH00000872265','IL','1','Liller','Susan','','','','34','293581691','10923 MUSSELMAN RD',0,'NEW CARLISLE','OH','45344','9256','CY','39023','1962-11-11','F','U',':RET:2106-3','N','021','DEN','1052304','99734OH005000301','2014-01-01','2013-11-06 22:31:03','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:32:18'),(19655,15661,'Y','18','024','14','A','','','TE','0000757147','0000757147','','IL','1','Thomas','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-12-03','F','',NULL,NULL,NULL,'','2251455','','2014-01-23','2014-01-23 12:28:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:00:21'),(2183,1795,'Y','18','021','EC','A','','','AC','0000452967','0000452967','TX00000813856','IL','1','vahalik','gina','','','','34','546811484','112 CIRCLE DR',0,'HALLETTSVILLE','TX','77964','5099','CY','48285','1982-01-03','F','U',':RET:2106-3','N','021','DEN','313867','33348TX002000101','2014-01-01','2013-12-10 15:07:42','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:19:29'),(17219,13780,'Y','18','021','EC','A','','','AC','0000468835','0000468835','MS00001431033','31','1','Lofton','Mary','K','','','34','427112534','PO Box 512',0,'Yutica','MS','39175',NULL,'CY','28049','1958-02-05','F','M',':RET:2054-5','N','021','DEN','2570046','46300MS002000201','2014-02-01','2014-01-08 15:50:22','0.00',NULL,NULL,'47.55','47.55','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:22:33'),(15184,12134,'Y','18','021','EC','A','','','AC','0000168900','0000168900','OH00000449334','IL','1','Bersee','Teri','Ann','','','34','289444172','9220 NOWARD RD',0,'WATERVILLE','OH','43566','9555','CY','39095','1953-05-21','F','M',':RET:2106-3','N','021','HLT','1649963','92036OH004002601','2014-02-01','2013-12-30 08:37:05','632.00',NULL,NULL,'851.06','219.06','R-OH001','OH0','425.53',NULL,0,'2014-01-01 12:06:54'),(3429,2754,'Y','18','024','14','A','','','TE','0000515257','0000515257','','IL','1','Rayford','Gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-08','M','',NULL,NULL,NULL,'','488031','','2013-12-21','2013-12-21 18:54:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:18:53'),(7375,5840,'Y','18','021','EC','A','','','AC','0000501582','0000501582','OH00000810987','IL','1','Bagadion','Patricia','','','','34','294649133','3980 Olde Savannah Dr.',0,'Cincinnati','OH','45247',NULL,'CY','39061','1966-12-24','F','U',':RET:2106-3','N','021','DEN','734621','99734OH005000401','2014-01-01','2013-11-23 15:44:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:15:46'),(8171,6465,'Y','18','021','EC','A','','','AC','0000453869','0000453869','OH00000668190','IL','1','KOCH','ROY','','','','34','285482899','6292 ROCKNOLL LN',0,'CINCINNATI','OH','45247','3471','CY','39061','1949-12-07','M','U',':RET:2106-3','N','021','HLT','464995','92036OH005001204','2014-01-01','2013-11-22 13:39:25','398.00',NULL,NULL,'644.00','246.00','R-OH004','OH0','644.00',NULL,0,'2013-12-26 03:16:37'),(4083,3262,'N','19','021','EC','A',NULL,NULL,'','0000656919','0000806345','','IL','1','CHESMAR','CASEY','MARIE','','','34','296926618','5759 CANTERBURY RD',0,'AKRON','OH','44319','5101','CY','39153','1989-08-05','F','',':RET:2106-3','N','021','HLT','1756079','52664OH152000901','2014-01-01','2013-12-17 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2013-12-25 21:47:13'),(14237,11353,'N','01','021','EC','A',NULL,NULL,'','0001025151','0000150555','','IL','1','Elkhatib','Mufeda','','','','34','426696922','515 Florence Dr.',0,'Madison','MS','39110',NULL,'CY','28089','1953-09-10','F','',NULL,'N','021','DEN','1703709','46300MS002000101','2014-02-01','2013-12-26 13:00:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-27 02:05:09'),(5434,4316,'Y','18','021','EC','A','','','AC','0002108607','0002108607','LA00000573454','IL','1','Snowden','Maria','','','','34','433867201','13 Boeuf Court',0,'Kenner','LA','70065',NULL,'CY','22051','1951-04-28','F','M',':RET:2106-3','N','021','DEN','1705859','18575LA002000101','2014-01-01','2013-12-19 16:07:14','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:44'),(13502,10760,'N','01','021','EC','A',NULL,NULL,'','0000876493','0000145005','','IL','1','BAREHELENY','DOROTHY','','','','34','767366449','4226 W 52ND PLACE',0,'ERADEN','FL','44210',NULL,'CY','39153','1973-09-13','F','',NULL,'N','021','DEN','2480685','99734OH005000301','2014-01-01','2013-12-23 07:13:02',NULL,NULL,NULL,NULL,NULL,NULL,'FL0','0.00',NULL,0,'2013-12-26 13:02:37'),(20608,16466,'Y','18','024','14','A','','','TE','0000998743','0000998743','','IL','1','lantz','allan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-08-25','M','',NULL,NULL,NULL,'','988587','','2014-01-30','2014-01-30 15:14:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:16'),(22063,17613,'Y','18','021','EC','A','','','AC','0001181549','0001181549','TX00001406410','IL','1','WILLIAMS','EDMERYL','','','','34','467941510','520 E 6TH ST',0,'FREEPORT','TX','77541',NULL,'CY','48039','1954-03-23','F','U',NULL,'N','021','DEN','2857606','33348TX002000201','2014-03-01','2014-02-08 13:21:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-08 19:00:11'),(24999,19826,'Y','18','021','EC','A','','','AC','0000549623','0000549623','TX00001943543','IL','1','Talley','Judy','','','','34','453350129','655 Castle Park Dr',0,'CORPUS CHRISTI','TX','78418',NULL,'CY','48355','1961-06-02','F','U',NULL,'N','021','DEN','3529581','33348TX002000201','2014-04-01','2014-02-20 17:08:57','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-20 22:00:45'),(27059,21424,'N','01','021','EC','A',NULL,NULL,'','0000399894','0000862441','','IL','1','GREEN','JAMES','','','','34','285808025','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1974-06-27','M','',':RET:2106-3','T','021','HLT','3076432','92036OH003002704','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.53','CIC',0,'2014-03-03 21:00:27'),(787,649,'Y','18','021','EC','A','','','AC','0001016492','0001016492','TX00000679585','IL','1','Vasquez','Gloria','','','','34','458044463','70 HAYNES LN',0,'BROWNSVILLE','TX','78521','2808','CY','48061','1953-03-16','F','U',':RET:2106-3','N','021','DEN','1728556','33348TX002000201','2014-01-01','2013-12-16 15:40:27','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:05:12'),(3090,2484,'Y','18','021','EC','A','','','AC','0001086756','0001086756','OH00000284690','IL','1','Marshall','Barbara','','','','34','282506868','2760 WENTWORTH AVE',0,'DAYTON','OH','45406','1640','CY','39113','1950-10-26','F','M',':RET:2106-3','N','021','HLT','111718','92036OH004000501','2014-01-01','2013-12-05 22:44:54','1129.31',NULL,NULL,'1137.62','8.32','R-OH003','OH0','564.22',NULL,0,'2013-12-25 20:19:59'),(16330,13075,'Y','18','021','EC','A','','','AC','0001176160','0001176160','LA00001742571','IL','1','Ellison','Mary','','','','34','433943142','1376 NAPOLEON ST',0,'BATON ROUGE','LA','70802','7052','CY','22033','1955-10-08','F','U',NULL,'N','021','DEN','1682688','18575LA002000201','2014-02-01','2014-01-06 17:29:10','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:58'),(13385,10685,'Y','18','021','EC','A','','','AC','0000108148','0000108148','OH00000347056','IL','1','Spehar','Vincent','','','','34','285766564','780 WINSTON CIR',0,'MEDINA','OH','44256','7195','CY','39103','1971-06-29','M','M',':RET:2106-3','N','021','DEN','1660505','99734OH005000301','2014-01-01','2013-12-23 01:17:03','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:00:00'),(3666,2932,'Y','18','021','EC','A','','','AC','0000506946','0000506946','OH00000698584','IL','1','hawthorne','kirk','','','','34','298667376','2826 E 5TH AVE',0,'COLUMBUS','OH','43219','2849','CY','39049','1961-11-08','M','R',':RET:2054-5','N','021','DEN','828629','99734OH005000401','2014-01-01','2013-12-12 20:35:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:31:00'),(4477,3552,'N','01','021','EC','A',NULL,NULL,'','0000129245','0000173797','','IL','1','Smith-Dail','Angela','','','','34','281704789','6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1970-07-17','F','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:53'),(8912,7068,'Y','18','021','EC','A','','','AC','0000597292','0000597292','OH00000328314','IL','1','sherman','patricia','','','','34','280545595','19909 GLADSTONE RD',0,'WARRENSVILLE HEIGHTS','OH','44122','6639','CY','39035','1953-01-11','F','U',':RET:2054-5','T','021','DEN','2125527','99734OH005000401','2014-01-01','2013-12-17 21:16:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:02:35'),(21158,16907,'Y','18','021','EC','A','','','AC','0000771470','0000771470','OH00002184896','IL','1','Brooks','Jeremy','','','','34','273682757','387 Broadway Street',0,'Loveland','OH','45140',NULL,'CY','39025','1967-10-09','M','U',':RET:2106-3','N','021','DEN','3477959','99734OH005000401','2014-03-01','2014-02-03 00:17:30','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-03 21:00:31'),(23442,18675,'Y','18','021','EC','A','','','AC','0000552096','0000552096','TX00002044166','IL','1','Greenfield','Sean','','','','34','275724422','1220 Middle Cove Dr',0,'Plano','TX','75023',NULL,'CY','48085','1971-04-04','M','M',NULL,'N','021','DEN','2625245','33348TX002000201','2014-03-01','2014-02-13 12:15:59','0.00',NULL,NULL,'72.22','72.22','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:34'),(27115,21462,'Y','18','021','EC','A','','','AC','0001190123','0001190123','OH00003152521','IL','1','McClain','Mary','','','','34','291482209','833 3RD ST SE',0,'NEW PHILADELPHIA','OH','44663','2311','CY','39157','1951-12-15','F','M',NULL,'N','021','DEN','3243419','99734OH005000301','2014-04-01','2014-03-03 11:26:25','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-03-03 21:30:29'),(29149,23075,'Y','18','021','EC','A','','','AC','0000911827','0000911827','OH00003338669','IL','1','Ruberg','Jacquelyn','','','','34','288562938','2336 W GALBRAITH RD',0,'CINCINNATI','OH','45239','4343','CY','39061','1952-08-24','F','M',':RET:2106-3','N','021','HLT','3887224','92036OH003001204','2014-04-01','2014-03-10 11:40:41','357.00',NULL,NULL,'629.96','272.96','R-OH004','OH0','629.96',NULL,0,'2014-03-10 21:02:48'),(29175,23091,'N','01','021','EC','A',NULL,NULL,'','0000519899','0001240620','','IL','1','PATTON','MICHAEL','','','','34','302806336','2947 BURNHAM JUMP DR',0,'CUYAHOGA FALLS','OH','44223','1218','CY','39153','1971-03-02','M','',NULL,'N','021','HLT','4011165','52664OH151001501','2014-04-01','2014-03-10 16:55:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','362.95',NULL,0,'2014-03-10 21:03:01'),(40,35,'Y','18','021','EC','A','','','AC','0000261465','0000261465','OH00000999505','IL','1','ZORN','LAURENE','','','','34','286481222','6584 OAKWOOD DR',0,'INDEPENDENCE','OH','44131',NULL,'CY','39035','1953-07-08','F','M',':RET:2106-3','N','021','DEN','882457','99734OH005000401','2014-01-01','2013-12-05 12:58:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:16:01'),(517,422,'Y','18','021','EC','A','','','AC','0001219561','0001219561','OH00000882757','IL','1','Ott','Joe','','','','34','288528628','124 BROOK DR SW',0,'ETNA','OH','43068','3302','CY','39089','1954-07-30','M','U',':RET:2106-3','T','021','DEN','254632','99734OH005000301','2014-01-01','2013-12-04 16:22:57','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:49:06'),(18897,15057,'Y','18','021','EC','A','','','AC','0000258188','0000258188','OH00001916032','IL','1','Howard','Judy','Ann','','','34','301648260','510 S GREEN ST',0,'GEORGETOWN','OH','45121','1542','CY','39015','1959-07-10','F','U',':RET:2106-3','N','021','HLT','2596136','92036OH002000601','2014-03-01','2014-01-16 08:50:41','211.00',NULL,NULL,'529.28','318.28','R-OH005','OH0','529.28',NULL,0,'2014-01-17 03:36:34'),(17940,14334,'Y','18','021','EC','A','','','AC','0001004131','0001004131','TX00001884873','IL','1','Meza','Rosanna','','','','34','098548676','1004 N BISHOP AVE',0,'DALLAS','TX','75208','4111','CY','48113','1973-07-18','F','U',NULL,'N','021','DEN','2864887','33348TX002000201','2014-02-01','2014-01-14 15:16:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:39'),(966,792,'N','G8','021','EC','A',NULL,NULL,'','0000036804','0000280241','','IL','1','viswanath','vinitha',NULL,NULL,NULL,NULL,NULL,'732 lake carolyn parkway',0,'irving','TX','75039',NULL,'CY','48113','1987-05-23','F','',':RET:2029-7','N','021','DEN','425581','33348TX002000201','2014-01-01','2013-10-31 10:07:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:09:54'),(1254,1033,'N','01','021','EC','A',NULL,NULL,'','0000998748','0000652092','','IL','1','Basher','Alessandra','','','','34','752831465','7858 WILD ORCHARD LN',0,'MONTGOMERY','OH','45242','4307','CY','39061','1978-06-22','F','',':RET:2106-3','N','021','HLT','1103563','92036OH002001201','2014-01-01','2013-12-02 23:22:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.93',NULL,0,'2013-12-25 18:21:20'),(7153,5675,'N','01','021','EC','A',NULL,NULL,'','0000721345','0001113147','','IL','1','Gustafson','Eric','R','','','34','372887071','1224 TOWNSHIP ROAD 1453',0,'ASHLAND','OH','44805','9359','CY','39005','1965-11-19','M','',':RET:2106-3','N','021','HLT','1834041','52664OH151001501','2014-01-01','2013-12-24 20:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','437.31',NULL,0,'2013-12-26 01:52:15'),(16412,13134,'Y','18','021','EC','A','','','AC','0000628364','0000628364','TX00001377897','31','1','GONZALEZ','HUGO','','','','34','628104307','P.O BOX 12286',0,'LUBBOCK','TX','79452',NULL,'CY','48303','1963-04-01','M','U',NULL,'N','021','DEN','1782158','33348TX002000201','2014-02-01','2014-01-06 17:22:18','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-07 04:04:14'),(2002,1641,'Y','18','021','EC','A','','','AC','0000823477','0000823477','OH00000882599','IL','1','maassel','mary','','','','34','292420593','436 S KEYSER ST',0,'HOLGATE','OH','43527','9743','CY','39069','1949-12-05','F','U',':RET:2106-3','N','021','HLT','236514','92036OH004002601','2014-01-01','2013-11-20 07:18:57','466.93',NULL,NULL,'470.37','3.44','R-OH001','OH0','470.37',NULL,0,'2013-12-25 19:02:14'),(15162,12117,'Y','18','024','14','A','','','TE','0000558135','0000558135','','IL','1','Diamond','Ariel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-02-19','F','',NULL,NULL,NULL,'','2281305','','2013-12-30','2013-12-30 14:26:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:18'),(14361,11453,'Y','18','024','14','A','','','TE','0000208511','0000208511','','IL','1','Lee','Charranda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-05-09','F','',NULL,NULL,NULL,'','1711863','','2013-12-26','2013-12-26 19:59:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:30:16'),(6662,5285,'Y','18','021','EC','A','','','AC','0000159079','0000159079','TX00000035629','IL','1','Massey','Jennifer','','','','34','457298540','501 KENT DR',0,'PITTSBURG','TX','75686','2136','CY','48063','1969-06-11','F','U',':RET:2106-3','N','021','DEN','846262','33348TX002000201','2014-01-01','2013-11-15 23:30:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:00:54'),(4452,3538,'Y','18','021','EC','A','','','AC','0000195113','0000195113','OH00000091088','IL','1','Spencer','Linda','M','','','34','292509830','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1951-01-29','F','M',':RET:2054-5','N','021','DEN','61616','99734OH005000301','2014-01-01','2013-12-12 10:29:21','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:02:24'),(24023,19105,'N','01','021','EC','A',NULL,NULL,'','0000810832','0000393724','','IL','1','Russell','Lauri','Anne','','','34','278827389','5211 SHEILA DR',0,'TOLEDO','OH','43613','2441','CY','39095','1970-10-08','F','',':RET:2106-3','N','021','DEN','2820520','99734OH005000401','2014-03-01','2014-02-15 16:20:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:00:48'),(26092,20693,'Y','18','021','EC','A','','','AC','0002293482','0002293482','LA00003109966','31','1','Silcio','John','','','','34','436826547','P.O. Box 2043',0,'LaPlace','LA','70069',NULL,'CY','22095','1952-03-18','M','U',':RET:2106-3','T','021','DEN','3115913','18575LA002000201','2014-04-01','2014-02-27 11:51:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:09'),(26707,21172,'N','01','021','EC','A',NULL,NULL,'','0000666820','0000019159','','IL','1','Perry','Julie','Ann','','','34','286668670','55 MONROE ST',0,'MONROEVILLE','OH','44847','9722','CY','39077','1960-12-19','F','',NULL,'N','021','HLT','3486303','92036OH004002701','2014-04-01','2014-02-28 10:10:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.86',NULL,0,'2014-02-28 21:31:36'),(27021,21403,'Y','18','021','EC','A','','','AC','0000592211','0000592211','OH00002315910','IL','1','GREEN','ANGELA','','','','34','278840124','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1974-09-19','F','M',':RET:2106-3','T','021','DEN','3725480','99734OH005000301','2014-04-01','2014-03-03 13:43:55','0.00',NULL,NULL,'87.78','87.78','R-OH006','OH0','0.00','CIC',0,'2014-03-03 21:00:13'),(28587,22623,'N','19','021','EC','A',NULL,NULL,'','0001228127','0000443514','','IL','1','Jarrett','Cooper','A','','','34','403552922','1677 ABBY DR',0,'NEWARK','OH','43055','9416','CY','39089','1999-08-04','M','',':RET:2106-3','N','021','DEN','3070144','99734OH005000401','2014-04-01','2014-03-07 18:00:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-08 21:30:00'),(28657,22677,'Y','18','021','EC','A','','','AC','0001566484','0001566484','LA00003054139','IL','1','robinson','Talasia','edrice','','','34','437733434','2701 Stanberry Dr',0,'Shreveport','LA','71118',NULL,'CY','22017','1989-01-03','F','U',':RET:2054-5','N','021','DEN','3253884','18575LA002000201','2014-04-01','2014-03-08 10:10:22','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-08 21:30:42'),(1772,1460,'N','01','021','EC','A',NULL,NULL,'','0001192675','0000308272','','IL','1','Jellison','Penny','','','','34','284521063','150 Filly Lane',0,'Northfield','OH','44067',NULL,'CY','39153','1968-02-24','F','',':RET:2106-3','N','021','DEN','1856328','99734OH005000301','2014-01-01','2013-12-24 14:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:08'),(19671,15675,'N','01','021','EC','A',NULL,NULL,'','0001018922','0000189947','','IL','1','CUBAS','JUAN','','','','34','631262641','522 HOBBS AVE',0,'ALICE','TX','78332','6364','CY','48249','1958-11-05','M','',NULL,'N','021','DEN','2692942','33348TX002000201','2014-03-01','2014-01-22 18:59:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 21:00:32'),(7318,5800,'Y','18','021','EC','A','','','AC','0000950061','0000950061','TX00000797625','IL','1','McKinney','Tammy','','','','34','449335618','6008 E UNIVERSITY BLVD',0,'DALLAS','TX','75206','4652','CY','48113','1960-10-09','F','U',':RET:2106-3','T','021','DEN','214947','33348TX002000101','2014-01-01','2013-12-14 16:36:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 02:03:32'),(15255,12193,'Y','18','021','EC','A','','','AC','0000076312','0000076312','OH00001588382','IL','1','Mobley','Ryan','','','','34','294882197','162 Loretta Ave',0,'Fairborn','OH','45324',NULL,'CY','39057','1988-03-11','M','U',':RET:2054-5^:RET:2106-3','T','021','HLT','2427863','92036OH004000501','2014-02-01','2013-12-30 11:50:54','38.00',NULL,NULL,'220.69','182.69','R-OH003','OH0','220.69',NULL,0,'2014-01-01 12:09:05'),(2538,2065,'Y','18','021','EC','A','','','AC','0000769965','0000769965','OH00000900724','IL','1','Dugger','Patti','','','','34','281521771','977 KATHRYN DR',0,'WILMINGTON','OH','45177','1403','CY','39027','1952-09-12','F','U',':RET:2106-3','N','021','HLT','659848','92036OH005000606','2014-01-01','2013-12-09 17:10:23','598.83',NULL,NULL,'603.24','4.41','R-OH005','OH0','603.24',NULL,0,'2013-12-25 19:36:57'),(7156,5677,'Y','18','021','EC','A','','','AC','0001133950','0001133950','OH00000374052','IL','1','Hertzfeld','John','','','','34','284701266','1337 SENECA CREEK CT',0,'PERRYSBURG','OH','43551','6023','CY','39173','1976-05-08','M','M',':RET:2106-3','N','021','HLT','2207053','92036OH004002601','2014-01-01','2013-12-24 20:51:56','303.00',NULL,NULL,'381.94','78.94','R-OH001','OH0','194.11',NULL,0,'2013-12-26 01:52:19'),(17000,13607,'Y','18','021','EC','A','','','AC','0000177647','0000177647','OH00001712557','IL','1','Nuss','Patricia','','','','34','271440678','1143 S. Cleve-Mass Rd',0,'Copley','OH','44321',NULL,'CY','39153','1951-02-12','F','M',':RET:2106-3','N','021','DEN','2043809','99734OH005000301','2014-02-01','2014-01-09 16:02:42','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:20:30'),(5845,4642,'N','01','021','EC','A',NULL,NULL,'','0000902144','0000533844','','IL','1','Wang','Ching Lung','','','','34','591189597','306 ROUEN DR',0,'PORT LAVACA','TX','77979','2020','CY','48057','1951-01-02','M','',':RET:2034-7','N','021','DEN','2504354','33348TX002000201','2014-01-01','2013-12-24 00:13:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:48:39'),(24954,19788,'Y','18','021','EC','A','','','AC','0002138117','0002138117','LA00003009948','IL','1','STEVENS','NATHAN','T','','','34','434276242','710 WELSH ST',0,'WELSH','LA','70591','4157','CY','22053','1961-07-26','M','U',':RET:2054-5','N','021','DEN','2753685','18575LA002000201','2014-04-01','2014-02-20 10:02:29','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-20 22:00:13'),(25058,19871,'Y','18','021','EC','A','','','AC','0000948473','0000948473','OH00002493272','IL','1','CORNE','KATHLEEN','','','','34','378544819','300 MARGARET PLACE',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1949-06-08','F','U',':RET:2106-3','N','021','DEN','3504734','99734OH005000401','2014-04-01','2014-02-20 12:06:34','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-20 22:01:21'),(25593,20304,'Y','18','021','EC','A','','','AC','0001697898','0001697898','LA00002323538','IL','1','Faciane','Mary','','','','34','436906536','27191 JACKSON ST',0,'LACOMBE','LA','70445','4635','CY','22103','1950-11-10','F','U',':RET:2054-5','N','021','DEN','3285861','18575LA002000201','2014-04-01','2014-02-24 17:00:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-26 08:00:44'),(26435,20967,'Y','18','021','EC','A','','','AC','0001182479','0001182479','OH00002826855','S3','1','OLINGER','JEFFREY','','','','34','281026082','5245 E KEMPER RD',0,'CINCINNATI','OH','45241','2146','CY','39061','1997-02-09','M','U',':RET:2106-3','N','021','DEN','2989442','99734OH005000401','2014-04-01','2014-02-27 11:33:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78','CIC',0,'2014-02-28 07:30:17'),(2845,2299,'Y','18','021','EC','A','','','AC','0000320296','0000320296','TX00000749600','IL','1','Simmons','Clarence','','','','34','457967122','6301 IH 37',0,'Corpus Christi','TX','78409',NULL,'CY','48355','1956-02-14','M','U',':RET:2054-5','N','021','DEN','771397','33348TX002000201','2014-01-01','2013-11-02 04:08:47','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 20:01:10'),(3691,2954,'Y','18','021','EC','A','','','AC','0001056674','0001056674','OH00001168429','IL','1','GOODMAN','GREGORY','JOSEPH','','','34','279680232','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1965-08-29','M','M',':RET:2106-3','N','021','DEN','885503','99734OH005000401','2014-01-01','2013-12-13 10:43:19','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:31:44'),(20051,15991,'Y','18','021','EC','A','','','AC','0000196441','0000196441','TX00001970249','IL','1','GARCIA','CRUZ','','','','34','585137955','851 BARANDAL DR',0,'EL PASO','TX','79907','2731','CY','48141','1967-10-22','F','M',NULL,'T','021','DEN','2037578','33348TX002000201','2014-03-01','2014-01-26 19:24:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-27 21:00:05'),(18922,15076,'Y','18','021','EC','A','','','AC','0000461953','0000461953','OH00002304926','IL','1','Mayo','Brenda','','','','34','302465896','34200 BROOKMEADE CT',0,'SOLON','OH','44139','3876','CY','39035','1949-12-30','F','U',':RET:2054-5','N','021','DEN','1636578','99734OH005000401','2014-03-01','2014-01-16 18:45:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:05:33'),(16603,13280,'Y','18','024','14','A','','','TE','0001959782','0001959782','','IL','1','Dedon','Stacy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-11-14','F','',NULL,NULL,NULL,'','1802490','','2014-01-07','2014-01-07 13:51:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-08 18:24:05'),(16453,13166,'Y','18','021','EC','A','','','AC','0000630388','0000630388','OH00001505119','IL','1','Williamson','Clara','','','','34','634792843','275 TOLBERT ST',0,'WADSWORTH','OH','44281','1522','CY','39103','2013-10-06','F','R',':RET:2106-3','N','021','HLT','1628898','52664OH152001001','2014-02-01','2014-01-06 08:47:51','0.00',NULL,NULL,'77.86','77.86','R-OH012','OH0','77.86',NULL,0,'2014-01-07 04:05:29'),(3865,3095,'Y','18','021','EC','A','','','AC','0000439570','0000439570','LA00000813948','IL','1','Annan','John','','','','34','402868667','38135 SPRINGWOOD AVE',0,'PRAIRIEVILLE','LA','70769','4286','CY','22005','1949-10-20','M','M',':RET:2054-5','N','021','DEN','703447','18575LA002000201','2014-01-01','2013-12-12 23:34:03','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:36:04'),(4557,3610,'Y','18','021','EC','A','','','AC','0000426405','0000426405','OH00000938960','IL','1','Williams','LaKisha','','','','34','287888848','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-05-18','F','R',':RET:2054-5','N','021','HLT','1132180','52664OH152000901','2014-01-01','2013-12-12 15:40:37','0.00',NULL,NULL,'606.64','606.64','R-OH012','OH0','199.60',NULL,0,'2013-12-25 22:04:40'),(15631,12502,'Y','18','021','EC','A','','','AC','0001737482','0001737482','LA00001550377','IL','1','Richmond','Essie','','','','34','434175264','2025 Titan St.',0,'Harvey','LA','70058',NULL,'CY','22051','1959-07-15','F','U',NULL,'N','021','DEN','2435038','18575LA002000101','2014-02-01','2013-12-31 12:39:41','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:33:27'),(14085,11225,'Y','18','021','EC','A','','','AC','0000008427','0000008427','OH00000213183','IL','1','DELPRINCE','GREGORY','','','','34','290640759','1819 LYNDON AVE',0,'ASHTABULA','OH','44004','2749','CY','39007','1958-05-01','M','U',NULL,'N','021','DEN','1554025','99734OH005000401','2014-02-01','2013-12-26 10:39:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:13'),(9603,7606,'Y','18','024','14','A','','','TE','0000284390','0000284390','','IL','1','Baranowski','Tracey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-08','F','',NULL,NULL,NULL,'','238063','','2013-12-21','2013-12-21 13:02:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:37:28'),(9284,7363,'Y','18','021','EC','A','','','AC','0000703752','0000703752','OH00000212159','IL','1','Wagner','Kevin','','','','34','295607666','1637 COUNTY ROAD 92',0,'ALGER','OH','45812','9650','CY','39065','1962-05-07','M','U',':RET:2106-3','N','021','DEN','303175','99734OH005000301','2014-01-01','2013-11-30 13:37:37','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:15:57'),(6210,4921,'Y','18','021','EC','A','','','AC','0000937860','0000937860','TX00000289540','IL','1','Hudson','David','Allan','','','34','453876264','712 N RITA ST',0,'WACO','TX','76705','1141','CY','48309','1978-05-02','M','U',NULL,'N','021','DEN','227623','33348TX002000101','2014-01-01','2013-10-16 19:09:30','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2013-12-26 00:30:51'),(21224,16960,'Y','18','021','EC','A','','','AC','0000542721','0000542721','OH00001844187','IL','1','DiBacco','Barbara','J','','','34','283749962','27945 PERGL RD',0,'SOLON','OH','44139','2118','CY','39035','1964-02-18','F','M',':RET:2106-3','N','021','HLT','3176760','92036OH004000801','2014-03-01','2014-02-03 09:02:46','227.66',NULL,NULL,'335.75','108.09','R-OH011','OH0','335.75',NULL,0,'2014-02-03 21:01:05'),(25613,20321,'N','01','021','EC','A',NULL,NULL,'','0000834345','0000951608','','IL','1','Rueda','Eduardo',NULL,NULL,NULL,NULL,NULL,'2017 Rosita Valley Road',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1968-12-08','M','',':RET:2106-3','N','021','DEN','2797906','33348TX002000201','2014-04-01','2014-02-22 09:52:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 08:30:10'),(27668,21885,'Y','18','021','EC','A','','','AC','0000667466','0000667466','TX00003247289','31','1','Cowell','Laura','','','','34','585498858','615 APACHE TRL',0,'COMANCHE','TX','76442','2962','CY','48143','1970-03-29','F','U',':RET:2106-3','N','021','DEN','3245835','33348TX002000201','2014-04-01','2014-03-04 18:07:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:30:32'),(392,322,'N','01','021','EC','A',NULL,NULL,'','0000993944','0000619611','','IL','1','Johnston','Trenda','','','','34','271767263','310 FOWLER ST',0,'CORTLAND','OH','44410','1332','CY','39155','1968-04-30','F','',':RET:2106-3','T','021','HLT','663432','92036OH004003201','2014-01-01','2013-12-04 11:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','323.21',NULL,0,'2013-12-25 17:45:55'),(7147,5671,'Y','18','021','EC','A','','','AC','0001203727','0001203727','TX00000089358','IL','1','Koulakiotis','Melpomeni','','','','34','463953304','3022 14TH AVE N',0,'TEXAS CITY','TX','77590','5110','CY','48167','1980-06-06','F','U',NULL,'N','021','DEN','2130902','33348TX002000101','2014-02-01','2013-12-25 00:33:43','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:52:05'),(20209,16125,'Y','18','021','EC','A','','','AC','0000734872','0000734872','MS00001406184','31','1','Murry','Shameka','','','','34','426634187','437 Stump bridge',0,'Canton','MS','39046',NULL,'CY','28089','1987-11-14','F','U',':RET:2054-5','N','021','DEN','2391156','46300MS002000201','2014-03-01','2014-01-27 15:53:25','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-27 21:01:37'),(13452,10727,'Y','18','021','EC','A','','','AC','0000116589','0000116589','OH00000640720','IL','1','Verga','Cosette','','','','34','218491885','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1988-08-11','F','M',':RET:2106-3','N','021','DEN','2417728','99734OH005000301','2014-01-01','2013-12-23 14:32:53','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 13:01:32'),(14160,11288,'Y','18','021','EC','A','','','AC','0001216518','0001216518','LA00001437157','IL','1','Nelson','Michael','','','','34','436414700','6019 LEXINGTON AVE',0,'SHREVEPORT','LA','71106','1927','CY','22017','1973-01-07','M','M',NULL,'N','021','DEN','1710820','18575LA002000201','2014-02-01','2013-12-26 15:29:29','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2013-12-27 02:03:09'),(17400,13924,'Y','18','021','EC','A','','','AC','0000487507','0000487507','MS00002325524','IL','1','Dawson','Shirley','','','','34','425277427','216 CARTER ST',0,'KOSCIUSKO','MS','39090','3512','CY','28007','1962-04-26','F','U',':RET:2054-5','N','021','DEN','1753112','46300MS002000101','2014-02-01','2014-01-09 21:22:11','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 03:00:16'),(15110,12077,'Y','18','024','14','A','','','TE','0000744408','0000744408','','IL','1','Lingafelter','Ruth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-26','F','',NULL,NULL,NULL,'','99493','','2013-12-30','2013-12-30 13:23:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:04:56'),(26211,20788,'Y','18','021','EC','A','','','AC','0000727346','0000727346','OH00002925545','IL','1','Petersen','Julie','Ann','','','34','291648163','6509 VAIR RD',0,'RAVENNA','OH','44266','8402','CY','39133','1958-11-13','F','M',':RET:2106-3','N','021','HLT','3704644','52664OH151001301','2014-04-01','2014-02-27 14:51:32','648.00',NULL,NULL,'1234.12','586.12','R-OH012','OH0','497.31',NULL,0,'2014-02-28 06:30:53'),(554,454,'Y','18','021','EC','A','','','AC','0000927273','0000927273','LA00001229082','IL','1','HARRIS','CHRISHUNDA','LYNETTE','','','34','665053819','325 GEBELIN ST',0,'BATON ROUGE','LA','70802','2728','CY','22033','1987-07-16','F','M',':RET:2054-5','T','021','DEN','416097','18575LA002000101','2014-01-01','2013-12-04 00:09:04','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 17:50:07'),(4827,3824,'N','01','021','EC','A',NULL,NULL,'','0000566589','0000475943','','IL','1','Cooper','Rose','A','','','34','276481664','6620 Bruce Road',0,'Celina','OH','45822',NULL,'CY','39107','1951-08-31','F','',':RET:2106-3','N','021','HLT','1003762','92036OH002001501','2014-01-01','2013-12-08 13:58:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','730.20',NULL,0,'2013-12-25 22:17:14'),(919,762,'Y','18','021','EC','A','','','AC','0000618352','0000618352','OH00000958461','IL','1','yakimoff','Alex','','','','34','285521505','1150 WILSHIRE DR',0,'YOUNGSTOWN','OH','44511','1212','CY','39099','1952-06-04','M','U',':RET:2106-3','N','021','HLT','1684330','92036OH003003206','2014-01-01','2013-12-16 15:52:12','580.00',NULL,NULL,'710.32','130.32','R-OH013','OH0','710.32',NULL,0,'2013-12-25 18:08:45'),(6197,4910,'Y','18','021','EC','A','','','AC','0000451237','0000451237','OH00000327653','IL','1','MILLS','JAMES','','','','34','289840193','6892 LAKESIDE DR',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','1970-07-11','M','U',':RET:2106-3','N','021','HLT','136146','92036OH004001201','2014-01-01','2013-10-23 14:18:53','0.00',NULL,NULL,'234.23','234.23','R-OH004','OH0','234.23',NULL,0,'2013-12-26 00:30:29'),(7845,6213,'Y','18','021','EC','A','','','AC','0000418885','0000418885','OH00001281843','IL','1','Balanson','Rachael','A','','','34','575393517','16509 W PARK RD',0,'CLEVELAND','OH','44111','3966','CY','39035','1972-09-11','F','M',':RET:2106-3','N','021','DEN','1558839','99734OH005000301','2014-01-01','2013-12-20 00:13:29','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:04:42'),(21345,17059,'Y','18','021','EC','A','','','AC','0000934112','0000934112','TX00002394464','IL','1','Lopez','Lorenzo','','','','34','462047389','320 SW 29TH ST',0,'SAN ANTONIO','TX','78237','2113','CY','48029','1951-08-10','M','M',':RET:2106-3','N','021','DEN','3588086','33348TX002000201','2014-03-01','2014-02-03 22:28:01','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-02-04 21:00:35'),(21726,17349,'Y','18','021','EC','A','','','AC','0000809546','0000809546','TX00002397927','IL','1','Nunn','Beverly','','','','34','460027931','1434 COUNTY ROAD 210',0,'WEIMAR','TX','78962','3720','CY','48089','1952-12-26','F','M',':RET:2106-3','N','021','DEN','2751966','33348TX002000201','2014-03-01','2014-02-06 13:35:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:06'),(22497,17960,'Y','18','021','EC','A','','','AC','0000665687','0000665687','OH00002535338','IL','1','NGUYEN','THU HA','THI','','','34','287150644','7230 HOSBROOK RD',0,'CINCINNATI','OH','45243','1710','CY','39061','1973-04-29','F','M',NULL,'N','021','DEN','2684479','99734OH005000301','2014-03-01','2014-02-10 14:31:23','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:11'),(25650,20349,'Y','18','021','EC','A','','','AC','0001117306','0001117306','OH00001891001','IL','1','Houser','Leanna','','','','34','300844149','410 North Scioto Street',0,'Circleville','OH','43113',NULL,'CY','39129','1971-01-20','F','U',':RET:2106-3','N','021','DEN','2677252','99734OH005000401','2014-04-01','2014-02-22 10:32:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:38'),(27273,21596,'N','01','021','EC','A',NULL,NULL,'','0000125701','0001168023','','IL','1','FAIRCHILD','MARICELA','','','','34','850560524','112 BENNETT ST',0,'NORMANGEE','TX','77871','5286','CY','48289','1969-05-25','F','',NULL,'T','021','DEN','3284963','33348TX002000201','2014-04-01','2014-03-03 18:12:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:17'),(27589,21819,'Y','18','021','EC','A','','','AC','0000248349','0000248349','TX00003379012','IL','1','Autrey','Garret','','','','34','466674099','54 PALO ALTO DR',0,'BROWNSVILLE','TX','78521','2607','CY','48061','1983-12-20','M','U',':RET:2106-3','N','021','DEN','3160799','33348TX002000201','2014-04-01','2014-03-05 16:22:49','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61','CIC',0,'2014-03-05 21:00:16'),(1105,909,'Y','18','021','EC','A','','','AC','0001018193','0001018193','OH00001100587','IL','1','Brown-Straits','Donna','','','','34','296487784','9615 TOWNSHIP ROAD 50',0,'DOLA','OH','45835','9751','CY','39065','1950-09-24','F','M',':RET:2106-3','N','021','DEN','609247','99734OH005000401','2014-01-01','2013-12-03 14:51:41','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:17:22'),(20359,16260,'Y','18','024','14','A','','','TE','0000012462','0000012462','','IL','1','Jones','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-11-24','M','',NULL,NULL,NULL,'','2741518','','2014-01-28','2014-01-28 12:56:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:19'),(19845,15828,'Y','18','021','EC','A','','','AC','0001245200','0001245200','LA00002321486','IL','1','Leitch','Gary','','','','34','438570811','726 Cotton Street',0,'Shreveport','LA','71101',NULL,'CY','22017','1975-04-27','M','M',':RET:2106-3','T','021','DEN','3194632','18575LA002000201','2014-03-01','2014-01-24 10:15:00','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-24 21:00:28'),(18804,14977,'Y','18','021','EC','A','','','AC','0000024133','0000024133','OH00002011024','IL','1','Rice','Kathryn','','','','34','287507437','6031 BUGGY WHIP LN',0,'DAYTON','OH','45459','2407','CY','39113','1950-04-12','F','U',NULL,'T','021','DEN','1697853','99734OH005000401','2014-03-01','2014-01-16 14:42:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:36:00'),(5590,4435,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000890724','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','583768','92036OH006002601','2014-01-01','2013-11-05 19:45:06','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-25 23:17:14'),(5177,4108,'Y','18','021','EC','A','','','AC','0000385887','0000385887','OH00000481309','IL','1','Asempa','Mercy','','','','34','639456305','8165 REAL QUIET LN',0,'BLACKLICK','OH','43004','9168','CY','39049','1944-01-26','F','U',NULL,'N','021','DEN','2393727','99734OH005000401','2014-01-01','2013-12-19 12:33:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:03:27'),(13544,10800,'Y','18','021','EC','A','','','AC','0001653647','0001653647','LA00000977737','IL','1','Davis','Tonette','','','','34','439399449','1405 Park Street',0,'Jonesville','LA','71343',NULL,'CY','22025','1980-01-29','F','U',':RET:2054-5','N','021','DEN','1460521','18575LA002000201','2014-01-01','2013-12-23 14:10:18','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 13:03:52'),(4261,3395,'N','01','021','EC','A',NULL,NULL,'','0000968210','0000418858','','IL','1','musil','timothy','i',NULL,NULL,NULL,NULL,'6810 CHIPPEWA RD',0,'MEDINA','OH','44256','8573','CY','39103','1959-09-08','M','',':RET:2106-3','T','021','HLT','1485820','52664OH151001501','2014-01-01','2013-12-17 13:09:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','656.69',NULL,0,'2013-12-25 21:51:31'),(1639,1369,'Y','18','024','14','A','','','TE','0000028235','0000028235','','IL','1','Espinoza','Victoriano',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-23','M','',NULL,NULL,NULL,'','744512','','2013-12-24','2013-12-24 15:22:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:53:02'),(7250,5750,'Y','18','021','EC','A','','','AC','0000019539','0000019539','LA00000355900','IL','1','williams','barbara','','','','34','435827549','6883 SPRING DR',0,'BATON ROUGE','LA','70812','3043','CY','22033','1949-07-22','F','U',NULL,'N','021','DEN','238092','18575LA002000201','2014-01-01','2013-12-14 16:26:11','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:01:54'),(22058,17608,'Y','18','021','EC','A','','','AC','0000505712','0000505712','TX00001833710','IL','1','Gonzales','Ninfa','','','','34','458758345','121 W WADLEY AVE',0,'MIDLAND','TX','79705','5217','CY','48329','1980-02-12','F','U',NULL,'N','021','DEN','2843806','33348TX002000201','2014-03-01','2014-02-08 11:40:10','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-08 19:00:08'),(22333,17834,'Y','18','021','EC','A','','','AC','0000398552','0000398552','TX00001796747','IL','1','sconiers','adrian','','','','34','523330298','8258 MORNING GRV',0,'CONVERSE','TX','78109','3434','CY','48029','1967-01-09','M','U',':RET:2054-5','N','021','DEN','3283008','33348TX002000101','2014-03-01','2014-01-25 07:06:34','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-10 11:01:02'),(23618,18811,'Y','18','021','EC','A','','','AC','0000024155','0000024155','OH00002793417','IL','1','Schmidt','Anne','','','','34','298620193','15 FARMVIEW CT',0,'HARRISON','OH','45030','2013','CY','39061','1972-05-24','F','M',':RET:2106-3','N','021','HLT','3274336','92036OH004001201','2014-03-01','2014-02-13 15:06:17','392.00',NULL,NULL,'778.31','386.31','R-OH004','OH0','224.74',NULL,0,'2014-02-13 22:03:17'),(27642,21864,'Y','18','021','EC','A','','','AC','0000917049','0000917049','OH00003426805','IL','1','HOLTZ','HAROLD','','','','34','286563747','8834 CENTER DR',0,'NORTH ROYALTON','OH','44133','4730','CY','39035','1955-03-25','M','M',NULL,'N','021','DEN','3706004','99734OH005000401','2014-04-01','2014-03-05 12:06:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-05 21:30:17'),(1614,1349,'Y','18','021','EC','A','','','AC','0001006790','0001006790','TX00001518714','IL','1','villalobos','america','','','','34','630763620','10781 VISTA DEL SOL DR',0,'EL PASO','TX','79935','4521','CY','48141','1983-05-09','F','U',NULL,'N','021','DEN','1710732','33348TX002000201','2014-01-01','2013-12-24 13:13:45','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:52:24'),(17770,14197,'N','01','021','EC','A',NULL,NULL,'','0001169023','0000144592','','IL','1','jaffer','nayla','','','','34','638034523','6707 Park Lane',0,'Houston','TX','77023',NULL,'CY','48201','1958-03-13','F','',':RET:2029-7','N','021','DEN','1546815','33348TX002000101','2014-02-01','2014-01-13 13:43:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-14 01:33:38'),(2003,1642,'Y','18','021','EC','A','','','AC','0000805081','0000805081','OH00000285934','IL','1','BARNETT','BONNIE','SUE','','','34','302440484','5 SWEET GUM LN',0,'MILFORD','OH','45150','2540','CY','39025','1949-06-04','F','M',':RET:2106-3','N','021','HLT','943738','92036OH006000601','2014-01-01','2013-11-20 09:28:29','198.00',NULL,NULL,'510.73','312.73','R-OH005','OH0','510.73',NULL,0,'2013-12-25 19:02:15'),(13150,10490,'Y','18','021','EC','A','','','AC','0000474973','0000474973','OH00000622816','IL','1','CLARK','LEEANN','','','','34','273604228','910 HALF S LIME STONE ST',0,'SPRINGFIELD','OH','45505',NULL,'CY','39023','1956-09-05','F','U',NULL,'N','021','DEN','1518483','99734OH005000401','2014-01-01','2013-12-23 17:00:20','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:53:34'),(17466,13967,'Y','18','021','EC','A','','','AC','0001258677','0001258677','OH00001607221','IL','1','EDWARDS','KATHLEEN','','','','34','292507919','2500 LYON BLVD',0,'POLAND','OH','44514','1533','CY','39099','1950-08-16','F','M',':RET:2106-3','N','021','DEN','2131296','99734OH005000301','2014-02-01','2014-01-12 10:32:28','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-13 03:01:05'),(9631,7629,'Y','18','021','EC','A','','','AC','0001208293','0001208293','OH00001253153','IL','1','Skillman','Howard','','','','34','308643546','995 TOWNSHIP ROAD 713',0,'ASHLAND','OH','44805','9791','CY','39005','1957-03-04','M','M',':RET:2106-3','T','021','HLT','2181878','52664OH152000901','2014-01-01','2013-12-21 15:57:05','349.00',NULL,NULL,'438.23','89.23','R-OH012','OH0','438.23',NULL,0,'2013-12-26 04:38:12'),(24076,19146,'N','01','021','EC','A',NULL,NULL,'','0000790924','0000846184','','IL','1','morris','james','','','','34','282640873','104 CENTER ST',0,'SEVILLE','OH','44273','9504','CY','39103','1963-10-15','M','',':RET:2106-3','N','021','HLT','3076050','52664OH151001305','2014-03-01','2014-02-14 19:15:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','398.29',NULL,0,'2014-02-15 22:01:19'),(21847,17445,'N','01','021','EC','A',NULL,NULL,'','0000915679','0000259271','','IL','1','Gaglione','John','','','','34','270602042','334 STANTON HALL CT',0,'KETTERING','OH','45429','1851','CY','39113','1959-12-06','M','',':RET:2106-3','N','021','DEN','3130763','99734OH005000301','2014-03-01','2014-02-06 11:42:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:13'),(16466,13175,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00000094739','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','1896932','52664OH151001306','2014-02-01','2014-01-06 10:57:15','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2014-01-07 04:05:49'),(7665,6071,'Y','18','024','14','A','','','TE','0001735358','0001735358','','IL','1','Patterson','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-16','F','',NULL,NULL,NULL,'','1723847','','2013-12-20','2013-12-20 15:23:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 03:00:24'),(7620,6030,'Y','18','021','EC','A','','','AC','0000373592','0000373592','OH00000352685','IL','1','Crock','Ann','','','','34','293862374','7845 BRIDGEPOINT DR',0,'CINCINNATI','OH','45248','1920','CY','39061','1978-03-31','F','U',':RET:2106-3','N','021','HLT','25841','92036OH004001201','2014-01-01','2013-11-17 10:00:19','78.00',NULL,NULL,'210.92','132.92','R-OH004','OH0','210.92',NULL,0,'2013-12-26 02:45:53'),(16222,12991,'N','01','021','EC','A',NULL,NULL,'','0000396177','0000214662','','IL','1','campbell','matthew','coorick','','','34','291721560','3756 MIDDLEBROOK AVE',0,'CINCINNATI','OH','45208','1119','CY','39061','1976-02-22','M','',NULL,'N','021','DEN','2585646','99734OH005000401','2014-02-01','2014-01-03 22:22:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:01:49'),(15758,12608,'Y','18','021','EC','A','','','AC','0000276479','0000276479','TX00002022288','IL','1','VONG','DORA','','','','34','460498941','3501 SUMMIT LN',0,'GARLAND','TX','75042','5453','CY','48113','1963-03-13','F','M',NULL,'N','021','DEN','1721249','33348TX002000201','2014-02-01','2014-01-01 21:52:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:01:23'),(16059,12860,'Y','18','021','EC','A','','','AC','0000219993','0000219993','OH00001459752','IL','1','Murphy','Paula','A','','','34','298481187','47 NESTICO DR',0,'CUYAHOGA FALLS','OH','44223','2660','CY','39153','1950-06-25','F','U',':RET:2106-3','N','021','DEN','2057151','99734OH005000401','2014-02-01','2014-01-03 09:49:27','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-04 02:03:26'),(1586,1324,'Y','18','021','EC','A','','','AC','0001213071','0001213071','TX00000204424','IL','1','Cowan','Joshua','','','','34','643059703','2405 22ND PL',0,'LUBBOCK','TX','79411','1011','CY','48303','1986-10-31','M','R',':RET:2106-3','N','021','DEN','1961692','33348TX002000201','2014-01-01','2013-12-24 11:12:30','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:51:35'),(14279,11391,'Y','18','024','14','A','','','TE','0000174157','0000174157','','IL','1','ROMINES','MELISSA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-04-28','F','',NULL,NULL,NULL,'','2355292','','2013-12-26','2013-12-26 16:11:01',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-27 02:06:17'),(13311,10628,'Y','18','021','EC','A','','','AC','0000664267','0000664267','TX00000347126','31','1','waldrop','nancy','','','','34','449839604','po box 252',0,'santo','TX','76472',NULL,'CY','48363','1977-07-21','F','U',':RET:2106-3','N','021','DEN','2446167','33348TX002000201','2014-01-01','2013-12-23 16:06:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:06'),(6560,5201,'Y','18','021','EC','A','','','AC','0000006115','0000006115','TX00000447149','IL','1','HERNANDEZ','OLGA','','','','34','585235937','9100 Bradley Drive',0,'North Richland Hills','TX','76182',NULL,'CY','48439','1963-07-12','F','M',NULL,'N','021','DEN','666278','33348TX002000201','2014-01-01','2013-12-11 13:23:46','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:52:24'),(16587,13267,'N','01','021','EC','A',NULL,NULL,'','0001843850','0001490631','','IL','1','Kurts','Christopher','Dylan','','','34','217270064','4735 LOYOLA AVE',0,'NEW ORLEANS','LA','70115','5931','CY','22071','1987-07-21','M','',':RET:2106-3','N','021','DEN','2174909','18575LA002000201','2014-02-01','2014-01-07 16:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-08 18:23:59'),(17259,13809,'Y','18','021','EC','A','','','AC','0000736537','0000736537','OH00001615285','IL','1','SEELEY','DONLAD','','','','34','285468576','26470 WILDCAT HOLLOW RD',0,'ROCKBRIDGE','OH','43149','9770','CY','39073','1952-06-25','M','M',':RET:2106-3','N','021','DEN','2518658','99734OH005000301','2014-02-01','2014-01-10 12:37:25','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2014-01-13 02:23:16'),(17660,14114,'Y','18','021','EC','A','','','AC','0000002313','0000002313','OH00002432255','IL','1','Brazelton','Patricia','','','','34','295689067','13 REDWOOD AVE',0,'DAYTON','OH','45405','5110','CY','39113','1964-08-02','F','M',NULL,'T','021','DEN','2208958','99734OH005000301','2014-02-01','2014-01-13 15:06:37','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-14 01:32:44'),(22934,18283,'Y','18','021','EC','A','','','AC','0001021510','0001021510','OH00001902139','IL','1','Moses','Mark','','','','34','300941107','1897 us rt 40',0,'eldorado','OH','45321',NULL,'CY','39135','1988-08-02','M','U',':RET:2054-5','N','021','HLT','3552448','92036OH004000501','2014-03-01','2014-02-10 19:38:28','141.00',NULL,NULL,'191.91','50.91','R-OH003','OH0','191.91','CIC',0,'2014-02-11 21:30:13'),(24090,19153,'Y','18','021','EC','A','','','AC','0001109274','0001109274','OH00002341970','IL','1','Krause','Patricia','','','','34','300646510','3024 Frost Road',0,'Mantua','OH','44255',NULL,'CY','39133','1969-09-24','F','M',':RET:2106-3','N','021','HLT','3679734','52664OH151001304','2014-03-01','2014-02-15 14:30:46','549.00',NULL,NULL,'906.30','357.30','R-OH012','OH0','311.54',NULL,0,'2014-02-15 22:01:25'),(24344,19333,'Y','18','021','EC','A','','','AC','0000430883','0000430883','TX00001800077','IL','1','Ragan','Pamela','','','','34','450061180','13803 PECAN HOLW',0,'LEANDER','TX','78641','7624','CY','48453','1953-01-04','F','U',':RET:2106-3','N','021','DEN','3459602','33348TX002000201','2014-04-01','2014-02-18 16:21:02','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:22'),(25818,20471,'N','01','021','EC','A',NULL,NULL,'','0000003628','0001247003','','IL','1','MIKLOS','KEVIN','','','','34','291868152','12760 CARTER RD',0,'PAINESVILLE','OH','44077','9790','CY','39085','1971-10-26','M','',NULL,'N','021','DEN','3115883','99734OH005000301','2014-03-01','2014-02-26 14:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:24'),(25930,20563,'Y','18','021','EC','A','','','AC','0000127017','0000127017','TX00002404296','31','1','WHITE','ROLANDA','','','','34','465119994','PO BOX 80',0,'DEKALB','TN','75559',NULL,'CY','48037','1966-09-05','F','M',NULL,'N','021','DEN','3571101','33348TX002000201','2014-03-01','2014-02-26 16:32:14','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2014-02-26 21:01:26'),(29214,23119,'N','01','021','EC','A',NULL,NULL,'','0001223240','0001205881','','IL','1','WASA','DALIA','','','','34','370858416','3540 QUEENSWOOD BLVD',0,'TOLEDO','OH','43606','1136','CY','39095','1977-10-01','F','',NULL,'N','021','HLT','4057721','92036OH003002604','2014-04-01','2014-03-10 14:37:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','250.48','CIC',0,'2014-03-10 21:30:17'),(431,354,'Y','18','021','EC','A','','','AC','0000745405','0000745405','OH00000903193','IL','1','Salyers','Charles','','','','34','294641662','15026 GIBSON RD',0,'ASHVILLE','OH','43103','9663','CY','39129','1958-03-07','M','U',':RET:2106-3','N','021','DEN','658570','99734OH005000401','2014-01-01','2013-12-04 16:34:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:55'),(693,571,'Y','18','021','EC','A','','','AC','0000545227','0000545227','OH00001151766','IL','1','Lawrence','Zachary','','','','34','603103858','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1980-10-09','M','M',':RET:2106-3','N','021','DEN','2570237','99734OH005000301','2014-01-01','2013-12-16 14:59:56','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:02:42'),(14450,11527,'Y','18','021','EC','A','','','AC','0001951052','0001951052','LA00001843427','IL','1','Jacobs','Gerald','Huey','','III','34','438393645','2600 HOUMA BLVD',0,'METAIRIE','LA','70001','6503','CY','22051','1970-06-18','M','U',':RET:2106-3','N','021','DEN','2102722','18575LA002000201','2014-02-01','2013-12-27 13:27:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:28'),(914,759,'Y','18','021','EC','A','','','AC','0000799878','0000799878','OH00000817941','IL','1','Camp','Antonio','','','','34','299749155','4518 WINTON RD',0,'CINCINNATI','OH','45232','1844','CY','39061','1979-09-15','M','U',':RET:2054-5','T','021','HLT','2195737','92036OH003001205','2014-01-01','2013-12-16 14:45:28','109.00',NULL,NULL,'312.97','203.97','R-OH004','OH0','312.97',NULL,0,'2013-12-25 18:08:38'),(1514,1263,'Y','18','021','EC','A','','','AC','0000633739','0000633739','OH00000192870','IL','1','Jones','Donna','','','','34','279644815','1901 RICHLEY DR',0,'DAYTON','OH','45417','4512','CY','39113','1960-02-07','F','U',':RET:2054-5','N','021','DEN','1929331','99734OH005000401','2014-01-01','2013-12-24 14:11:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:49:36'),(14232,11350,'Y','18','021','EC','A','','','AC','0000976728','0000976728','OH00001718745','IL','1','GREIWERA','Ralph','allen','','','34','302527770','4213 clifford rd',0,'cincinnati','OH','45236',NULL,'CY','39061','1951-08-28','M','U',':RET:2106-3','N','021','HLT','2100257','92036OH003001201','2014-02-01','2013-12-26 17:23:36','316.00',NULL,NULL,'644.07','328.07','R-OH004','OH0','644.07',NULL,0,'2013-12-27 02:05:02'),(15264,12202,'Y','18','021','EC','A','','','AC','0000268913','0000268913','OH00001555562','IL','1','Diamond','Ariel','','','','34','344729683','1022 FAUROT AVE',0,'LIMA','OH','45805','3218','CY','39003','1983-02-19','F','U',':RET:2054-5','N','021','HLT','1482882','92036OH006001501','2014-02-01','2013-12-30 14:41:33','131.00',NULL,NULL,'198.11','67.11','R-OH002','OH0','198.11',NULL,0,'2014-01-01 12:09:22'),(9598,7602,'Y','18','021','EC','A','','','AC','0000929834','0000929834','OH00000707344','IL','1','Morris','Gary','','','','34','288508234','3166 BIRD DR',0,'RAVENNA','OH','44266','9532','CY','39133','1950-10-05','M','M',':RET:2106-3','N','021','HLT','1575777','52664OH151001304','2014-01-01','2013-12-21 09:33:06','1037.00',NULL,NULL,'1327.32','290.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 04:37:20'),(9527,7552,'N','01','021','EC','A',NULL,NULL,'','0000667772','0000637097','','IL','1','AGARWAL','SHUBHRA','NEIL','','','34','281046375','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','1976-03-11','F','',':RET:2029-7','N','021','DEN','2028084','99734OH005000301','2014-01-01','2013-12-20 20:28:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:42'),(5141,4075,'Y','18','021','EC','A','','','AC','0000813078','0000813078','OH00000967383','IL','1','parker','glenna','','','','34','275720447','930 E 248TH ST',0,'EUCLID','OH','44123','2408','CY','39035','1976-04-04','F','U',':RET:2054-5','N','021','DEN','1778646','99734OH005000401','2014-01-01','2013-12-18 20:31:28','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:02:32'),(4926,3908,'Y','18','021','EC','A','','','AC','0000388621','0000388621','OH00000700849','IL','1','Kennedy','Melisa','','','','34','272903586','5542 BOSWORTH PL',0,'CINCINNATI','OH','45212','1238','CY','39061','1980-06-24','F','M',':RET:2054-5','N','021','DEN','28646','99734OH005000401','2014-01-01','2013-12-06 18:59:46','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:17'),(4912,3896,'N','01','021','EC','A',NULL,NULL,'','0000302508','0001177339','','IL','1','Farrell','Shelly','','','','34','450536052','7686 COUNTY ROAD 964',0,'NEVADA','TX','75173','6008','CY','48085','1965-11-23','F','',':RET:2106-3','T','021','DEN','742813','33348TX002000201','2014-01-01','2013-10-26 15:53:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:32:07'),(16335,13078,'Y','18','021','EC','A','','','AC','0000891512','0000891512','NJ00002065448','IL','1','morrell','corlinda','l','','','34','137526467','280 goldsmith ave',0,'north','NJ','70112',NULL,'CY','22071','1955-10-21','F','U',':RET:2054-5','N','021','DEN','1995470','18575LA002000201','2014-02-01','2014-01-06 11:10:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','NJ0','14.61',NULL,0,'2014-01-07 04:02:06'),(20433,16320,'Y','18','021','EC','A','','','AC','0000954326','0000954326','OH00002558184','S3','1','Pepmeyer','Kathleen','','','','34','161594211','4805 GLENSHADE AVE',0,'CINCINNATI','OH','45227','2419','CY','39061','2012-11-30','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3284176','99734OH005000301','2014-03-01','2014-01-29 16:08:32','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','21.13',NULL,0,'2014-01-29 21:00:36'),(21444,17140,'Y','18','021','EC','A','','','AC','0001053089','0001053089','OH00002022996','IL','1','Evans','Bevan','','','','34','281587141','1092 WEXFORD CT',0,'AKRON','OH','44312','4635','CY','39153','1962-03-26','F','R',':RET:2106-3','N','021','HLT','3628447','52664OH151001501','2014-03-01','2014-02-04 12:09:51','0.00',NULL,NULL,'766.29','766.29','R-OH012','OH0','498.82',NULL,0,'2014-02-04 21:01:25'),(22526,17984,'Y','18','021','EC','A','','','AC','0000661389','0000661389','OH00001846877','31','1','Marlow','Joy','','','','34','405969247','P.O Box 572',0,'Felicity','OH','45120',NULL,'CY','39015','1965-06-18','F','M',':RET:2106-3','N','021','HLT','2908916','92036OH003000605','2014-03-01','2014-02-10 15:19:59','116.00',NULL,NULL,'366.54','250.54','R-OH005','OH0','366.54',NULL,0,'2014-02-10 21:31:28'),(22594,18047,'Y','18','021','EC','A','','','AC','0000794546','0000794546','OH00002163414','IL','1','Spencer','Eric','','','','34','291663158','2658 Chenango Rd.',0,'Wakeman','OH','44889',NULL,'CY','39077','1967-09-12','M','M',':RET:2106-3','N','021','HLT','3235478','92036OH002002701','2014-03-01','2014-02-10 12:28:51','150.00',NULL,NULL,'568.36','418.36','R-OH006','OH0','337.77',NULL,0,'2014-02-10 21:32:11'),(22981,18322,'N','19','021','EC','A',NULL,NULL,'','0000168928','0000016657','','IL','1','holm','teegan','','','','34','288158116','12055 fifth st',0,'millersport','OH','43046',NULL,'CY','39045','2009-11-20','M','',':RET:2106-3','N','021','DEN','3818040','99734OH005000301','2014-03-01','2014-02-11 21:53:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:08'),(23358,18612,'N','01','021','EC','A',NULL,NULL,'','0001062169','0000258209','','IL','1','gonzales','carlos','','','','34','596280962','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','1978-01-19','M','',NULL,'N','021','HLT','3713513','52664OH151001304','2014-03-01','2014-02-13 14:50:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','274.30',NULL,0,'2014-02-13 22:00:44'),(25611,20320,'Y','18','021','EC','A','','','AC','0000472047','0000472047','TX00003057273','IL','1','LOPEZ','JENNIFER','ARDILA','','','34','435595754','4211 Clay Hill Dr',0,'Houston','TX','77084',NULL,'CY','48201','1976-12-14','F','U',NULL,'N','021','DEN','3027945','33348TX002000201','2014-04-01','2014-02-22 09:46:30','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 08:30:08'),(25973,20598,'Y','18','021','EC','A','','','AC','0000559496','0000559496','OH00002117506','IL','1','Garringer','Shirley','S','','','34','280509930','3489 BOGUS RD SE',0,'WASHINGTON COURT HOUSE','OH','43160','8747','CY','39047','1954-03-23','F','U',':RET:2106-3','N','021','DEN','3515320','99734OH005000401','2014-04-01','2014-02-26 13:34:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:47'),(4250,3385,'Y','18','021','EC','A','','','AC','0000245793','0000245793','TX00000333338','IL','1','Gillis','Laura','','','','34','449968340','5703 ABERDEEN CT',0,'TEMPLE','TX','76502','7942','CY','48027','1950-11-24','F','U',':RET:2106-3','N','021','DEN','2541905','33348TX002000201','2014-01-01','2013-12-17 17:58:00','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 21:51:15'),(13723,10951,'Y','18','024','14','A','','','TE','0000872037','0000872037','','IL','1','Thielenhaus','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-29','M','',NULL,NULL,NULL,'','1772509','','2013-12-23','2013-12-23 17:32:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:15'),(2656,2159,'Y','18','021','EC','A','','','AC','0001171854','0001171854','OH00000620903','IL','1','Strang','Michael','','','','34','528619794','5236 MONTICELLO HALL DR',0,'COLUMBUS','OH','43221','5678','CY','39049','1971-01-22','M','M',':RET:2106-3','N','021','DEN','23389','99734OH005000301','2014-01-01','2013-12-01 20:32:29','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:46'),(2366,1930,'Y','18','021','EC','A','','','AC','0000678060','0000678060','OH00000927029','IL','1','Otchere','Baffour','','','','34','291766180','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1954-02-20','M','M',':RET:2054-5','N','021','DEN','276792','99734OH005000401','2014-01-01','2013-12-09 08:34:35','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:32:38'),(6632,5260,'Y','18','021','EC','A','','','AC','0000547849','0000547849','OH00000590863','IL','1','Yates','Kevin','','','','34','302602283','5264 Wakefield Dr.',0,'Hilliard','OH','43026',NULL,'CY','39049','1958-06-03','M','U',':RET:2106-3','T','021','DEN','856180','99734OH005000401','2014-01-01','2013-11-11 18:07:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:00:03'),(19406,15473,'Y','18','021','EC','A','','','AC','0001031479','0001031479','OH00001634352','IL','1','mays','oletha',NULL,NULL,NULL,NULL,NULL,'1105 katcham',0,'toledo','OH','43608',NULL,'CY','39095','1951-09-13','F','M',NULL,'N','021','HLT','3036273','92036OH004002601','2014-03-01','2014-01-21 17:09:49','422.00',NULL,NULL,'450.46','28.46','R-OH001','OH0','450.46',NULL,1,'2014-01-22 03:22:55'),(28081,22224,'Y','18','021','EC','A','','','AC','0001233321','0001233321','TX00003129625','IL','1','Jackson','Monisha',NULL,NULL,NULL,NULL,NULL,'1133 Esters Road apt 614',0,'Irving','TX','75061',NULL,'CY','48113','1982-05-04','F','U',':RET:2054-5','N','021','DEN','2702398','33348TX002000101','2014-04-01','2014-03-06 13:09:48','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-06 21:01:57'),(4642,3679,'Y','18','021','EC','A','','','AC','0000377173','0000377173','MS00000052235','IL','1','Cook','Felicia','Denise','','','34','428298308','4412 CHARLES ST',0,'MOSS POINT','MS','39563','4606','CY','28059','1970-07-07','F','U',':RET:2054-5','N','021','DEN','516275','46300MS002000201','2014-01-01','2013-12-12 12:17:30','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 22:06:48'),(17201,13765,'Y','18','024','14','A','','','TE','0000814303','0000814303','','IL','1','WILSON','GARY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-28','M','',NULL,NULL,NULL,'','2446623','','2014-01-08','2014-01-08 12:00:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:22:24'),(15713,12569,'N','01','021','EC','A',NULL,NULL,'','0000911776','0001055330','','IL','1','CARTER','THOMAS','','','','34','007467190','510 MAPLE ST',0,'WAPAKONETA','OH','45895','2320','CY','39011','1960-04-20','M','',NULL,'N','021','HLT','2205770','92036OH006001501','2014-02-01','2013-12-31 16:53:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','356.06',NULL,1,'2014-01-02 04:36:07'),(16722,13383,'Y','18','021','EC','A','','','AC','0001075494','0001075494','TX00001405713','IL','1','Kohn','Joseph','','','','34','465780712','4235 SW 15TH AVE',0,'AMARILLO','TX','79106','5707','CY','48375','1950-10-10','M','U',':RET:2106-3','N','021','DEN','2041090','33348TX002000201','2014-02-01','2014-01-07 17:31:38','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-08 18:24:46'),(27374,21676,'Y','18','021','EC','A','','','AC','0000302878','0000302878','MS00002641079','IL','1','tran','maria','','','','34','586448442','7412 OLD FORT BAYOU RD',0,'OCEAN SPRINGS','MS','39564','8195','CY','28059','1971-11-30','F','M',':RET:2047-9','N','021','DEN','3947696','46300MS002000101','2014-04-01','2014-03-04 13:57:10','0.00',NULL,NULL,'155.70','155.70','R-MS005','MS0','27.15',NULL,0,'2014-03-04 21:01:18'),(28366,22445,'Y','18','021','EC','A','','','AC','0000444836','0000444836','TX00003162926','IL','1','Kennedy','Yulanda','','','','34','464155521','1801 CIRCLE DR',0,'MARSHALL','TX','75670','6311','CY','48203','1964-05-08','F','U',NULL,'N','021','DEN','3613943','33348TX002000201','2014-04-01','2014-03-07 16:15:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:32'),(29080,23016,'Y','18','021','EC','A','','','AC','0000798814','0000798814','MS00003149493','IL','1','THURMAN','TAMATHA','','','','34','425217256','119 ARTHUR LN',0,'RIDGELAND','MS','39157','8666','CY','28089','1969-10-30','F','M',':RET:2054-5','N','021','DEN','3282718','46300MS002000101','2014-04-01','2014-03-10 13:18:59','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-10 21:02:02'),(2947,2372,'Y','18','021','EC','A','','','AC','0000574421','0000574421','OH00000681735','IL','1','BEVLY','CHARLOTTE','','','','34','298485031','461 GYPSY LN',0,'YOUNGSTOWN','OH','44504','1344','CY','39099','1950-06-23','F','U',':RET:2054-5','N','021','DEN','430853','99734OH005000401','2014-01-01','2013-12-06 13:15:30','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:16:26'),(20548,16421,'Y','18','021','EC','A','','','AC','0001166846','0001166846','OH00001436678','IL','1','Rodriguez','Jennifer','','','','34','300865596','4494 TYLERSVILLE RD',0,'WEST CHESTER','OH','45011','8635','CY','39017','1973-05-02','F','M',':RET:2106-3','N','021','HLT','3594492','92036OH005001201','2014-03-01','2014-01-29 17:06:00','243.00',NULL,NULL,'596.35','353.35','R-OH004','OH0','274.35',NULL,0,'2014-01-29 21:01:40'),(19101,15218,'Y','18','021','EC','A','','','AC','0001788841','0001788841','LA00001439259','IL','1','MATEO BRITO','NEMESIO','','','','34','016929336','1200 CAMBRIDGE DR',0,'LA PLACE','LA','70068','3665','CY','22089','1962-03-10','M','U',NULL,'N','021','DEN','1885195','18575LA002000201','2014-03-01','2014-01-18 17:29:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:44:38'),(18723,14923,'Y','18','021','EC','A','','','AC','0000409769','0000409769','OH00001945259','IL','1','Smith','Casey','','','','34','286822925','2330 RIVERSIDE DR',0,'CINCINNATI','OH','45202','1812','CY','39061','1972-09-22','M','R',':RET:2106-3','N','021','DEN','1513784','99734OH005000301','2014-02-01','2014-01-15 23:17:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:34'),(7722,6115,'Y','18','021','EC','A','','','AC','0000713630','0000713630','OH00000522861','IL','1','HANKS','JESS','','','','34','281841731','33 CLARK PL',0,'COLUMBUS','OH','43201',NULL,'CY','39049','1969-11-17','M','U',':RET:2106-3','N','021','DEN','1914253','99734OH005000401','2014-01-01','2013-12-20 13:55:08','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:01:45'),(24003,19087,'Y','18','021','EC','A','','','AC','0000970504','0000970504','OH00002713349','IL','1','KAUTZ','SHEILA','','','','34','271768770','1912 EDISON AVE',0,'HAMILTON','OH','45011',NULL,'CY','39017','1963-07-13','F','U',':RET:2106-3','N','021','DEN','3819482','99734OH005000401','2014-03-01','2014-02-15 10:25:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:34'),(4259,3394,'Y','18','024','14','A','','','TE','0000720240','0000720240','','IL','1','TAYLOR','DORIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-04','F','',NULL,NULL,NULL,'','1920672','','2013-12-17','2013-12-17 11:25:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:30'),(25955,20585,'Y','18','021','EC','A','','','AC','0000402509','0000402509','OH00003399576','IL','1','Love','Fha','','','','34','291543834','2813 BANNING RD',0,'CINCINNATI','OH','45239','5505','CY','39061','1955-01-26','F','U',':RET:2054-5','N','021','DEN','3815917','99734OH005000401','2014-04-01','2014-02-26 11:55:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:01:39'),(26307,20871,'Y','18','021','EC','A','','','AC','0000684233','0000684233','TX00002914257','IL','1','GROMER','ANTOINETTE','','','','34','452536292','4405 N NAVARRO ST',0,'VICTORIA','TX','77904','2005','CY','48469','1971-06-22','F','U',':RET:2106-3','N','021','DEN','3571136','33348TX002000101','2014-04-01','2014-02-27 12:19:16','0.00',NULL,NULL,'25.02','25.02','R-TX023','TX0','25.02',NULL,0,'2014-02-28 06:31:31'),(26987,21378,'Y','18','021','EC','A','','','AC','0000805173','0000805173','OH00002767970','IL','1','Ulrich','Martin','','','','34','296564088','1828 W MAIN CROSS ST',0,'FINDLAY','OH','45840','1714','CY','39063','1958-12-09','M','M',NULL,'T','021','HLT','2946834','92036OH006001501','2014-04-01','2014-03-02 14:46:44','711.00',NULL,NULL,'1026.73','315.73','R-OH002','OH0','447.61',NULL,0,'2014-03-03 01:00:40'),(5179,4109,'N','19','021','EC','A',NULL,NULL,'','0000714933','0001006777','','IL','1','Truong','Tiffany','','','','34','275119346','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','2005-02-01','F','',':RET:2047-9','N','021','DEN','2460550','99734OH005000401','2014-01-01','2013-12-19 12:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:03:30'),(14976,11970,'N','19','021','EC','A',NULL,NULL,'','0000557904','0000478317','','IL','1','Su','Becky','','','','34','500048421','9618 OAKLAND LAKE WAY',0,'MISSOURI CITY','TX','77459','6451','CY','48157','1991-04-25','F','',':RET:2034-7','N','021','DEN','1492600','33348TX002000201','2014-02-01','2013-12-30 13:40:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:00:59'),(4153,3310,'Y','18','021','EC','A','','','AC','0001021458','0001021458','OH00000775609','IL','1','Goode','Aaron','','','','34','295602125','5611 North Meadows Blvd',0,'Columbus','OH','43229',NULL,'CY','39049','1977-08-05','M','U',':RET:2106-3','N','021','DEN','2129182','99734OH005000301','2014-01-01','2013-12-17 14:37:57','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:48'),(3142,2526,'Y','18','021','EC','A','','','AC','0000796821','0000796821','TX00001109355','IL','1','ryals','tana','','','','34','218946516','2704 FM 2490',0,'CLIFTON','TX','76634','3315','CY','48035','1966-09-19','F','M',':RET:2106-3','N','021','DEN','247889','33348TX002000201','2014-01-01','2013-11-18 06:34:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:49'),(6595,5229,'Y','18','021','EC','A','','','AC','0000790921','0000790921','MS00001092181','IL','1','BUCKLEY','TRYSYN','','','','34','425697665','116 SUMNER HILL DR',0,'CLINTON','MS','39056','3004','CY','28049','1990-03-06','F','U',':RET:2054-5','N','021','DEN','324347','46300MS002000101','2014-01-01','2013-12-11 08:28:15','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 00:53:23'),(9715,7695,'N','01','021','EC','A',NULL,NULL,'','0001152157','0001128982','','IL','1','Muncy','Patti','','','','34','268541366','2455 E LIVINGSTON AVE',0,'COLUMBUS','OH','43209','2911','CY','39049','1950-08-03','F','',':RET:2106-3','N','021','DEN','1000939','99734OH005000401','2014-01-01','2013-11-15 11:00:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:18'),(17448,13956,'Y','18','021','EC','A','','','AC','0001005730','0001005730','OH00002346516','IL','1','Kennedy','John','','','','34','283808167','215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','1978-04-23','M','M',':RET:2106-3','N','021','HLT','1698891','92036OH002000601','2014-02-01','2014-01-10 14:21:04','310.00',NULL,NULL,'899.17','589.17','R-OH005','OH0','302.93',NULL,0,'2014-01-13 03:00:38'),(21257,16987,'Y','18','021','EC','A','','','AC','0000748222','0000748222','OH00001862678','IL','1','Jacobsen','Neil','','','','34','320781714','1036 Rocky Brook Dr',0,'Akron','OH','44313',NULL,'CY','39153','1987-02-13','M','U',':RET:2106-3','N','021','HLT','3746345','52664OH152001001','2014-03-01','2014-02-03 10:39:26','0.00',NULL,NULL,'128.49','128.49','R-OH012','OH0','128.49',NULL,0,'2014-02-03 21:01:20'),(23990,19075,'Y','18','021','EC','A','','','AC','0001298658','0001298658','LA00002288161','IL','1','Barnhill','Chad','Preston','','','34','439754706','1413 E MISSISSIPPI AVE',0,'RUSTON','LA','71270','4046','CY','22061','1980-11-08','M','U',':RET:2106-3','N','021','DEN','3383009','18575LA002000201','2014-03-01','2014-02-15 14:47:29','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-15 22:00:25'),(24943,19779,'N','19','021','EC','A',NULL,NULL,'','0000992656','0000723682','','IL','1','JOHNSON','BRITTANY','','','','34','425754178','133 ASHTON DR',0,'BRANDON','MS','39047',NULL,'CY','28121','1992-11-15','F','',NULL,'N','021','DEN','3767833','46300MS002000201','2014-04-01','2014-02-19 21:54:42',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 22:00:06'),(25251,20031,'Y','18','021','EC','A','','','AC','0000533812','0000533812','MS00003186023','IL','1','BATTLE','BOBBIE','','','','34','587468213','4 N PECAN DR',0,'INDIANOLA','MS','38751','2022','CY','28133','1953-05-11','F','U',':RET:2054-5','N','021','DEN','3578007','46300MS002000101','2014-04-01','2014-02-21 15:13:13','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-21 22:01:13'),(27478,21744,'Y','18','021','EC','A','','','AC','0000381795','0000381795','TX00003702910','IL','1','williams','sandra','','','','34','457555243','1933 PORTLAND AVE',0,'FORT WORTH','TX','76102','1534','CY','48439','1965-10-22','F','U',':RET:2054-5','N','021','DEN','2621854','33348TX002000101','2014-04-01','2014-03-04 00:46:10','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-04 21:02:15'),(28987,22943,'Y','18','024','14','A','','','TE','0000836604','0000836604','','IL','1','ROBERTS','ELIZABETH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-03-16','F','',NULL,NULL,NULL,'','95642','','2014-03-25','2014-03-10 14:41:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:01:12'),(1396,1159,'Y','18','021','EC','A','','','AC','0001599168','0001599168','LA00000088197','IL','1','rivera','adlina','','','','34','583283516','15218 SWEET PECAN AVE',0,'PRAIRIEVILLE','LA','70769','5039','CY','22005','1949-10-16','F','U',NULL,'N','021','DEN','1697201','18575LA002000201','2014-01-01','2013-12-24 12:00:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:28'),(6570,5209,'Y','18','021','EC','A','','','AC','0000436738','0000436738','TX00000015581','31','1','mathews','jennifer','','','','34','452610951','Po box 854',0,'valley view','TX','76272',NULL,'CY','48097','1971-09-26','F','U',':RET:2106-3','T','021','DEN','951931','33348TX002000201','2014-01-01','2013-12-11 16:13:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:39'),(14036,11181,'Y','18','021','EC','A','','','AC','0000072876','0000072876','OH00000585243','IL','1','Meeker','Jerrilyn','','','','34','288563276','144 STATE ROUTE 124',0,'NEW VIENNA','OH','45159','9552','CY','39027','1954-03-10','F','M',':RET:2106-3','N','021','HLT','2289273','92036OH005000606','2014-01-01','2013-12-23 19:25:15','553.00',NULL,NULL,'558.80','5.80','R-OH005','OH0','558.80',NULL,0,'2013-12-26 13:17:01'),(9141,7249,'Y','18','021','EC','A','','','AC','0000299228','0000299228','OH00000029102','IL','1','Gilbert','Margaret','','','','34','291523181','188 N GRANT ST',0,'MILLERSBURG','OH','44654','1164','CY','39075','1951-01-08','F','M',':RET:2106-3','N','021','HLT','2014959','52664OH151001501','2014-01-01','2013-12-17 20:50:04','538.00',NULL,NULL,'768.43','230.43','R-OH014','OH0','768.43',NULL,0,'2013-12-26 04:08:12'),(7535,5964,'Y','18','021','EC','A','','','AC','0000048245','0000048245','TX00000726382','IL','1','Zander','Lynne','','','','34','389744818','2900 Shalimar Dr.',0,'Plano','TX','75023',NULL,'CY','48085','1960-04-26','F','M',':RET:2106-3','N','021','DEN','942959','33348TX002000201','2014-01-01','2013-12-15 11:38:49','0.00',NULL,NULL,'63.40','63.40','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:32:47'),(15739,12590,'Y','18','021','EC','A','','','AC','0000498446','0000498446','TX00001660518','IL','1','Corral','Maria','Gloria','','','34','327524783','9435 Diana Dr.',0,'El Paso','TX','79924',NULL,'CY','48141','1955-09-20','F','U',':RET:2106-3','N','021','DEN','1834245','33348TX002000201','2014-02-01','2014-01-01 23:19:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-03 02:00:45'),(16974,13586,'Y','18','021','EC','A','','','AC','0001077629','0001077629','MS00001434746','IL','1','Stevens','Julie','','','','34','220270434','20306 28th street',0,'long beach','MS','39560',NULL,'CY','28047','1990-02-22','F','M',':RET:2106-3','N','021','DEN','1755522','46300MS002000201','2014-02-01','2014-01-09 14:53:40','0.00',NULL,NULL,'31.70','31.70','R-MS005','MS0','15.85',NULL,0,'2014-01-13 02:20:14'),(21795,17407,'Y','18','021','EC','A','','','AC','0001156235','0001156235','OH00001777364','IL','1','SHARKEY','DAISY','S','','','34','282526455','367 N LINCOLN AVE',0,'ALLIANCE','OH','44601','1619','CY','39151','1949-12-29','F','M',NULL,'T','021','DEN','3103741','99734OH005000401','2014-03-01','2014-02-06 16:22:57','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-06 21:00:46'),(22324,17825,'Y','18','021','EC','A','','','AC','0001690488','0001690488','LA00002171593','IL','1','SCHULMAN-ZABACK','LISA','','','','34','080508964','12385 PECAN ISLAND RD',0,'JARREAU','LA','70749','3217','CY','22077','1958-04-13','F','M',NULL,'N','021','DEN','3055698','18575LA002000201','2014-03-01','2014-01-29 13:14:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-10 11:00:56'),(22723,18144,'Y','18','021','EC','A','','','AC','0001779253','0001779253','LA00002299213','IL','1','Gordon','Barry','','','','34','436820964','41351 Crown Drive Ext.',0,'Ponchatoula','LA','70454',NULL,'CY','22105','1950-08-29','M','U',':RET:2106-3','N','021','DEN','3682123','18575LA002000201','2014-03-01','2014-02-11 13:00:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-11 21:01:11'),(25428,20176,'Y','18','024','14','A','','','TE','0000039778','0000039778','','IL','1','Moran','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-03-02','F','',NULL,NULL,NULL,'','418234','','2014-03-12','2014-02-25 17:39:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:31:13'),(25627,20332,'N','19','021','EC','A',NULL,NULL,'','0000685891','0000172464','','IL','1','Tucker','Riley','','','','34','295117035','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2006-02-14','M','',':RET:2106-3','N','021','DEN','3742050','99734OH005000301','2014-04-01','2014-02-21 19:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 08:30:21'),(26223,20797,'N','01','021','EC','A',NULL,NULL,'','0000804617','0001170356','','IL','1','hernandez','felipe','','','','34','560436602','4812 CALISTA ST',0,'MERCEDES','TX','78570','8254','CY','48215','1976-09-04','M','',NULL,'N','021','DEN','3052755','33348TX002000201','2014-04-01','2014-02-26 20:08:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 06:30:58'),(4357,3459,'Y','18','021','EC','A','','','AC','0000005813','0000005813','OH00000982440','IL','1','okeeffe','karen','a','','','34','365507485','1011 TAFT ST',0,'PORT CLINTON','OH','43452','2245','CY','39123','1949-06-09','F','M',NULL,'N','021','HLT','1560945','92036OH003002705','2014-01-01','2013-12-17 13:41:19','483.00',NULL,NULL,'610.89','127.89','R-OH006','OH0','610.89',NULL,0,'2013-12-25 21:53:38'),(6287,4986,'Y','18','021','EC','A','','','AC','0001207127','0001207127','OH00001210238','IL','1','Riffle','Pamela','','','','34','302504928','8289 Smoke Rd. SW',0,'Pataskala','OH','43062',NULL,NULL,NULL,'1950-12-23','F','M',':RET:2106-3','N','021','DEN','276851','99734OH005000401','2014-01-01','2013-12-10 22:26:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:45:32'),(13033,10389,'Y','18','021','EC','A','','','AC','0000190194','0000190194','OH00000708646','IL','1','Kirby','Brent','','','','34','033488086','30307 Fern Dr.',0,'Willowick','OH','44095',NULL,'CY','39085','1971-11-22','M','U',NULL,'N','021','DEN','2330733','99734OH005000401','2014-01-01','2013-12-23 00:24:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:50:24'),(6584,5220,'Y','18','021','EC','A','','','AC','0000182270','0000182270','OH00000276346','IL','1','Karadeniz','Courtney','L','','','34','275802257','322 BROOKFOREST DR',0,'CINCINNATI','OH','45238','5610','CY','39061','1982-12-06','F','U',':RET:2106-3','N','021','HLT','11118','92036OH003001205','2014-01-01','2013-12-11 11:36:10','37.00',NULL,NULL,'259.83','222.83','R-OH004','OH0','259.83',NULL,0,'2013-12-26 00:53:03'),(17273,13816,'N','19','021','EC','A',NULL,NULL,'','0000381160','0000117812','','IL','1','Kilpatrick','Cameron','','','','34','797847238','149 PATRICK JOHN DR',0,'WADSWORTH','OH','44281','8789','CY','39103','2012-01-05','M','',':RET:2106-3','N','021','HLT','1510165','52664OH152000901','2014-02-01','2014-01-09 21:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:23:22'),(17606,14073,'Y','18','021','EC','A','','','AC','0000220904','0000220904','TX00001413244','IL','1','Powell','Gwendolyn','','','','34','452213570','410 S COLLINS AVE',0,'TULIA','TX','79088','2828','CY','48437','1963-06-18','F','U',':RET:2054-5','N','021','DEN','2650316','33348TX002000201','2014-02-01','2014-01-12 21:03:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:18'),(20392,16289,'N','01','021','EC','A',NULL,NULL,'','0000896386','0000879114','','IL','1','Pipes','Carlos','','','','34','461907579','2007 VANZANDY COUNTY Road',0,'FRUITVILLE','TX','75127',NULL,'CY','48467','1951-08-08','M','',NULL,'N','021','DEN','3362523','33348TX002000201','2014-03-01','2014-01-29 12:10:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:16'),(20895,16700,'Y','18','021','EC','A','','','AC','0000991575','0000991575','OH00002306199','IL','1','Bressler','Kelly','','','','34','298901420','7004 BRAMBLE AVE',0,'CINCINNATI','OH','45227','3210','CY','39061','1985-08-01','F','U',':RET:2106-3','T','021','DEN','1676326','99734OH005000401','2014-03-01','2014-01-31 11:34:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-31 21:01:17'),(22086,17629,'Y','18','021','EC','A','','','AC','0002319948','0002319948','LA00001568201','IL','1','Parker','Jessica','','','','34','438655144','938 SAINT CHARLES ST',0,'THIBODAUX','LA','70301','4737','CY','22057','1981-06-01','F','U',':RET:2054-5','N','021','DEN','3370346','18575LA002000101','2014-03-01','2014-02-08 16:05:21','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-02-08 19:00:21'),(23971,19058,'Y','18','021','EC','A','','','AC','0000385536','0000385536','TX00002269262','IL','1','Banks','Jessica','','','','34','435739469','200 SAINT MARYS DR',0,'HUTTO','TX','78634','5290','CY','48491','1987-12-29','F','U',':RET:2054-5','N','021','DEN','3397726','33348TX002000101','2014-03-01','2014-02-15 16:15:09','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-15 22:00:14'),(25141,19944,'Y','18','021','EC','A','','','AC','0001065303','0001065303','TX00002507591','IL','1','Chang','Joyce','','','','34','602641189','26518 FOREST PINE LN',0,'KATY','TX','77494','8372','CY','48157','1964-07-15','F','M',NULL,'N','021','DEN','3780415','33348TX002000201','2014-04-01','2014-02-21 11:54:01','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-21 22:00:10'),(28354,22434,'Y','18','021','EC','A','','','AC','0000715005','0000715005','TX00003272915','IL','1','Hoppington','Yorda','Jessica','','','34','508292737','765 Colorado Street',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1975-11-11','F','U',NULL,'N','021','DEN','2870038','33348TX002000201','2014-04-01','2014-03-07 13:34:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:24'),(24801,19669,'Y','18','021','EC','A','','','AC','0001126924','0001126924','OH00002292001','IL','1','Cheema','Sukhdev','','','','34','296153683','7532 mount whitney',0,'Dayton','OH','45424',NULL,'CY','39113','1979-01-04','M','M',':RET:2028-9','N','021','DEN','3430354','99734OH005000401','2014-04-01','2014-02-19 16:54:51','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-20 04:48:20'),(22533,17991,'Y','18','021','EC','A','','','AC','0001108426','0001108426','MS00002130097','IL','1','Luong','Lisa','','','','34','409634863','3167 PINETREE LOOP S',0,'SOUTHAVEN','MS','38672','9520','CY','28033','1974-03-09','F','U',':RET:2047-9','N','021','DEN','2848657','46300MS002000201','2014-03-01','2014-02-10 09:18:03','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2014-02-10 21:31:33'),(2218,1827,'Y','18','021','EC','A','','','AC','0000376133','0000376133','OH00000592380','IL','1','Walters','Anthony','','','','34','295460196','9027 RED HAWK DR',0,'STREETSBORO','OH','44241','4541','CY','39133','1950-03-27','M','M',':RET:2106-3','T','021','HLT','4035','52664OH151001305','2014-01-01','2013-12-10 17:22:09','1063.00',NULL,NULL,'1362.31','299.31','R-OH012','OH0','757.07',NULL,0,'2013-12-25 19:20:27'),(13332,10645,'Y','18','021','EC','A','','','AC','0000773051','0000773051','TX00001000289','31','1','JUAREZ','RODOLFO','F','','','34','467355273','P.O. BOX 3236',0,'LAREDO','TX','78044',NULL,'CY','48479','1970-05-01','M','U',NULL,'N','021','DEN','2002872','33348TX002000201','2014-01-01','2013-12-23 17:54:37','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-26 12:58:39'),(14498,11566,'Y','18','021','EC','A','','','AC','0001230776','0001230776','TX00001858152','IL','1','SOLIZ','NINA','','','','34','639122096','7432 AZALEA ST',0,'HOUSTON','TX','77023','2707','CY','48201','1980-08-09','F','U',NULL,'N','021','DEN','1547865','33348TX002000201','2014-02-01','2013-12-27 14:00:10','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-28 03:33:42'),(7679,6081,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000298206','','IL','1','TURNER','BRYCE','P','','','34','284083584','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2003-07-17','M','',NULL,'N','021','DEN','2276263','99734OH005000401','2014-01-01','2013-12-19 19:29:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:00:47'),(20163,16090,'N','01','021','EC','A',NULL,NULL,'','0000600828','0000796994','','IL','1','KONCAN','LAURA','A','','','34','291629506','5554 MILLWOOD DR',0,'BROADVIEW HEIGHTS','OH','44147','2246','CY','39035','1961-02-08','F','',':RET:2106-3','N','021','DEN','3238156','99734OH005000301','2014-03-01','2014-01-27 15:39:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:01:10'),(7860,6221,'N','19','021','EC','A',NULL,NULL,'','0000951788','0001012915','','IL','1','Scott','Benjamin','B','','','34','023780246','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1994-11-30','M','',':RET:2106-3','T','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:59'),(20024,15970,'Y','18','021','EC','A','','','AC','0001624876','0001624876','LA00001595544','IL','1','Britton','Johnny','','','','34','249062042','3400 CLAIBORNE AVE',0,'METAIRIE','LA','70001','5812','CY','22051','1957-02-20','M','M',':RET:2054-5','N','021','DEN','3305760','18575LA002000201','2014-03-01','2014-01-25 22:20:10','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-26 19:00:16'),(15661,12530,'Y','18','021','EC','A','','','AC','0000404228','0000404228','TX00001823660','IL','1','guzman','mark','','','','34','467734333','15122 COUNTY ROAD 195',0,'TYLER','TX','75703','6742','CY','48423','1982-12-31','M','U',':RET:2106-3','N','021','DEN','1965953','33348TX002000101','2014-02-01','2013-12-31 06:29:29','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,1,'2014-01-02 04:34:27'),(18478,14741,'Y','18','021','EC','A','','','AC','0000602307','0000602307','OH00001980187','IL','1','Gray','Christina','','','','34','590095830','5300 DAILEY RD',0,'AKRON','OH','44319','4906','CY','39153','1972-07-21','F','M',':RET:2106-3','N','021','HLT','2446799','52664OH151001301','2014-02-01','2014-01-14 21:34:51','0.00',NULL,NULL,'290.36','290.36','R-OH012','OH0','290.36',NULL,0,'2014-01-16 08:46:20'),(25286,20063,'Y','18','021','EC','A','','','AC','0000723875','0000723875','OH00002021151','IL','1','Baker','Holly','','','','34','283663804','32 CHURCH STREET',0,'Amelia','OH','45102',NULL,'CY','39025','1972-04-13','F','U',':RET:2106-3','N','021','HLT','3858135','92036OH001000601','2014-04-01','2014-02-24 21:12:26','0.00',NULL,NULL,'337.14','337.14','R-OH005','OH0','337.14','CIC',0,'2014-02-25 21:00:20'),(27015,21398,'Y','18','024','14','A','','','TE','0001459180','0001459180','','IL','1','Lopez','Comcepcion',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-08','M','',NULL,NULL,NULL,'','3683502','','2014-03-03','2014-03-03 10:45:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-03-03 21:00:10'),(29172,23090,'Y','18','024','14','A','','','TE','0000971526','0000971526','','IL','1','Bann','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-08-09','M','',NULL,NULL,NULL,'','4219067','','2014-03-10','2014-03-10 16:13:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:03:00'),(325,267,'Y','18','021','EC','A','','','AC','0000829244','0000829244','OH00000041417','IL','1','jones','athena','','','','34','296668677','3333 steeplechase lane 1b',0,'loveland','OH','45150',NULL,'CY','39025','1974-04-14','F','U',':RET:2106-3','N','021','HLT','519630','92036OH004000601','2014-01-01','2013-11-13 12:31:36','0.00',NULL,NULL,'217.83','217.83','R-OH005','OH0','217.83',NULL,0,'2013-12-25 17:31:28'),(22832,18218,'Y','18','021','EC','A','','','AC','0000884264','0000884264','OH00001890746','IL','1','PARKER','TERRY','L','','','34','267900381','24 SHELDON ST',0,'RITTMAN','OH','44270','1411','CY','39169','1950-11-19','F','U',':RET:2106-3','N','021','HLT','3556805','52664OH151001301','2014-03-01','2014-02-11 11:57:21','387.00',NULL,NULL,'658.32','271.32','R-OH014','OH0','658.32',NULL,0,'2014-02-11 21:02:08'),(1223,1006,'Y','18','021','EC','A','','','AC','0000575887','0000575887','OH00000284612','IL','1','Kim','Suzanne','Lynn','','','34','003502713','89 E STREETSBORO ST',0,'HUDSON','OH','44236','3047','CY','39153','1970-09-14','F','U',':RET:2106-3','N','021','HLT','619214','52664OH151001304','2014-01-01','2013-12-03 14:04:28','89.00',NULL,NULL,'302.62','213.62','R-OH012','OH0','302.62',NULL,0,'2013-12-25 18:20:28'),(13845,11049,'Y','18','021','EC','A','','','AC','0001231773','0001231773','OH00000980399','IL','1','Oakes','Rosilynn','','','','34','273645351','2090 16 th st sw',0,'akron','OH','44314',NULL,'CY','39153','1957-01-04','F','M',':RET:2106-3','T','021','HLT','2306687','52664OH152000901','2014-01-01','2013-12-23 16:11:11','371.00',NULL,NULL,'438.23','67.23','R-OH012','OH0','438.23',NULL,0,'2013-12-26 13:12:25'),(1553,1296,'Y','18','021','EC','A','','','AC','0001062405','0001062405','MS00001576220','IL','1','CUBLEY','SARAH','','','','34','425590116','808 CAMP ST',0,'HATTIESBURG','MS','39401','5031','CY','28035','1981-09-28','F','U',':RET:2106-3','T','021','DEN','1989932','46300MS002000201','2014-01-01','2013-12-24 12:35:58','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 18:50:40'),(7373,5839,'Y','18','021','EC','A','','','AC','0000258116','0000258116','OH00000371697','IL','1','williams','terri','','','','34','300565128','2011 CREST RD',0,'CINCINNATI','OH','45240','2063','CY','39061','1957-05-21','F','M',':RET:2054-5','N','021','DEN','331578','99734OH005000401','2014-01-01','2013-11-23 09:44:25','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:15:43'),(2786,2251,'N','01','021','EC','A',NULL,NULL,'','0000224689','0000907988','','IL','1','Shultz','Eva','','','','34','300706539','20357 u s highway 6',0,'ridgeville corners','OH','43555',NULL,'CY','39069','1961-04-09','F','',':RET:2106-3','T','021','HLT','50841','92036OH004002601','2014-01-01','2013-12-02 13:35:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','351.96',NULL,0,'2013-12-25 19:50:00'),(6348,5030,'Y','18','021','EC','A','','','AC','0001086762','0001086762','OH00000109557','IL','1','Cioffi','Nicholas','','','','34','231433728','5865 BELFAST OWENSVILLE RD',0,'BATAVIA','OH','45103','9632','CY','39025','1982-08-30','M','R',NULL,'N','021','DEN','1215508','99734OH005000401','2014-01-01','2013-12-11 13:09:40','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:46:57'),(20401,16296,'Y','18','021','EC','A','','','AC','0000345349','0000345349','TX00002421916','IL','1','Ferris','Reginald','','','','34','448648282','216 N Sparks St',0,'BELTON','TX','76513',NULL,'CY','48027','1972-06-21','M','M',NULL,'N','021','DEN','2948584','33348TX002000201','2014-03-01','2014-01-29 15:31:51','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-01-29 21:00:20'),(4377,3478,'Y','18','021','EC','A','','','AC','0000494419','0000494419','OH00001181067','IL','1','Atkins','David','','','','34','288541355','1165 GINGHAMSBURG FREDERICK RD',0,'TIPP CITY','OH','45371','8983','CY','39109','1963-05-25','M','U',':RET:2106-3','N','021','DEN','949224','99734OH005000401','2014-01-01','2013-12-12 08:31:53','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:00:29'),(27099,21452,'N','19','021','EC','A',NULL,NULL,'','0000242767','0000425144','','IL','1','White','Richard','','','','34','291964129','1010 CARNEGIE AVE',0,'AKRON','OH','44314','1146','CY','39153','1993-10-18','M','',':RET:2106-3','N','021','HLT','3110608','52664OH151001304','2014-04-01','2014-03-03 17:53:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 21:30:20'),(1521,1268,'N','19','021','EC','A',NULL,NULL,'','0001075301','0001157562','','IL','1','Danner','Jude','Xavier','','','34','302154534','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','2005-09-06','M','',':RET:2106-3','N','021','DEN','2363707','99734OH005000401','2014-01-01','2013-12-24 14:59:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:48'),(24823,19677,'N','01','021','EC','A',NULL,NULL,'','0000757194','0000784410','','IL','1','Nowland','Steven','R','','','34','221332990','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1980-02-12','M','',':RET:2106-3','T','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.98',NULL,0,'2014-02-20 04:50:40'),(4450,3537,'Y','18','021','EC','A','','','AC','0000911738','0000911738','OH00000386543','IL','1','Vranich','Sherry','','','','34','275507492','14335 MILL HOLLOW LN',0,'STRONGSVILLE','OH','44136','5423','CY','39035','1951-02-09','F','M',':RET:2106-3','N','021','DEN','330659','99734OH005000301','2014-01-01','2013-12-12 10:01:10','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:22'),(14072,11214,'Y','18','021','EC','A','','','AC','0001049381','0001049381','OH00001454794','IL','1','Loring','Elizabeth','','','','34','014649758','7285 THOMAS DR',0,'CINCINNATI','OH','45243','2138','CY','39061','1969-06-28','F','U',':RET:2106-3','N','021','DEN','2417898','99734OH005000401','2014-02-01','2013-12-26 09:46:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:53'),(23125,18431,'Y','18','021','EC','A','','','AC','0000398655','0000398655','OH00002105674','IL','1','PONCE','TEOFILO','','','','34','548952361','30 LIBERTY ST',0,'CANAL WINCHESTER','OH','43110','1215','CY','39049','1987-04-02','M','U',':RET:2036-2','N','021','DEN','2658766','99734OH005000401','2014-03-01','2014-02-12 14:02:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:25'),(13053,10406,'N','19','021','EC','A',NULL,NULL,'','0001075301','0001157562','','IL','1','Danner','Jude','Xavier','','','34','302154534','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','2005-09-06','M','',':RET:2106-3','N','021','DEN','2350448','99734OH005000401','2014-01-01','2013-12-23 09:06:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:54'),(4518,3581,'Y','18','021','EC','A','','','AC','0000626066','0000626066','TX00000027811','IL','1','LAROCCA','LISA','','','','34','283803053','6615 ENTLE WIND LANE',0,'DALLAS','TX','75248',NULL,'CY','48113','1968-12-10','F','M',':RET:2106-3','N','021','DEN','1091971','33348TX002000201','2014-01-01','2013-12-12 12:32:39','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:46'),(4775,3789,'Y','18','021','EC','A','','','AC','0001018203','0001018203','OH00000860492','IL','1','anderson','latrice','','','','34','293587708','9208miles pk',0,'cleveland','OH','44105',NULL,'CY','39035','1968-12-01','F','U',':RET:2054-5','N','021','DEN','349579','99734OH005000401','2014-01-01','2013-12-08 17:10:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:15:57'),(5268,4179,'Y','18','021','EC','A','','','AC','0000696804','0000696804','OH00000080522','IL','1','Vaccaro','Fabiola','','','','34','283789251','2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','1971-08-20','F','M',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37','941.00',NULL,NULL,'1100.76','159.76','R-OH012','OH0','295.48',NULL,0,'2013-12-25 23:05:31'),(6605,5238,'Y','18','024','14','A','','','TE','0000378543','0000378543','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','1228685','','2013-12-11','2013-12-11 09:42:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:53:38'),(22240,17752,'Y','18','021','EC','A','','','AC','0000049552','0000049552','OH00002567303','IL','1','CONTI','FRANCO','','','','34','278500559','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1959-12-19','M','M',':RET:2106-3','N','021','DEN','3018000','99734OH005000301','2014-03-01','2014-02-09 13:33:32','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-09 19:00:38'),(15740,12591,'Y','18','021','EC','A','','','AC','0000516799','0000516799','TX00001566359','IL','1','BERNAL','LETICIA','','','','34','449373170','316 E RIO GRANDE AVE',0,'EL PASO','TX','79902','4152','CY','48141','1971-01-27','F','U',NULL,'N','021','DEN','2364974','33348TX002000201','2014-02-01','2014-01-02 10:59:34','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-03 02:00:48'),(24134,19182,'Y','18','021','EC','A','','','AC','0000043263','0000043263','OH00002072799','IL','1','Jones','Penny','','','','34','292608956','3201 MECHANICSBURG RD',0,'SPRINGFIELD','OH','45503','1828','CY','39023','1971-02-22','F','M',':RET:2106-3','N','021','HLT','3439441','92036OH003000501','2014-03-01','2014-02-15 10:01:38','458.00',NULL,NULL,'957.47','499.47','R-OH003','OH0','336.85',NULL,0,'2014-02-15 22:01:49'),(3333,2674,'N','19','021','EC','A',NULL,NULL,'','0000581483','0000045761','','IL','1','SMITH','EIMILO','C','','','34','278112479','217 IDAHO AVE',0,'LORAIN','OH','44052','2159','CY','39093','2005-03-26','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','1853563','99734OH005000301','2014-01-01','2013-12-22 18:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:21'),(14012,11162,'N','01','021','EC','A',NULL,NULL,'','0000433888','0000044272','','IL','1','young','thomas','','','','34','299868673','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1987-07-10','M','',':RET:2106-3','N','021','HLT','2109334','92036OH003000606','2014-01-01','2013-12-23 14:32:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.56',NULL,0,'2013-12-26 13:16:24'),(13896,11084,'Y','18','021','EC','A','','','AC','0000478473','0000478473','OH00000119160','IL','1','wilson','lawrence','','','','34','284666629','5811 county rd 1',0,'swanton','OH','43558',NULL,'CY','39051','1960-08-17','M','M',':RET:2106-3','N','021','HLT','2556771','92036OH006002601','2014-01-01','2013-12-22 20:43:18','0.00',NULL,NULL,'413.67','413.67','R-OH001','OH0','315.47',NULL,0,'2013-12-26 13:13:35'),(3970,3171,'N','01','021','EC','A',NULL,NULL,'','0001055297','0000829260','','IL','1','Dustin','Joyce','A','','','34','271660467','3070 Park Rd',0,'Goshen','OH','45122',NULL,'CY','39025','1959-11-26','F','',NULL,'N','021','HLT','39950','92036OH004000601','2014-01-01','2013-12-13 11:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','368.53',NULL,0,'2013-12-25 21:38:33'),(22081,17624,'Y','18','021','EC','A','','','AC','0001771805','0001771805','LA00001807609','IL','1','BASSAR','DEXTER','','','','34','438291662','3420 CLAIBORNE AVE',0,'METAIRIE','LA','70001','5812','CY','22051','1975-07-22','M','U',':RET:2054-5','T','021','DEN','2676899','18575LA002000201','2014-03-01','2014-02-08 14:07:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-08 19:00:18'),(21437,17134,'Y','18','021','EC','A','','','AC','0000850467','0000850467','MS00001628341','IL','1','Mcgee','George','J','','','34','335847302','185 WILL BROWN RD',0,'CONEHATTA','MS','39057','9518','CY','28101','1977-10-22','M','U',':RET:2054-5','N','021','DEN','3681950','46300MS002000101','2014-03-01','2014-02-04 11:32:23','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-04 21:01:22'),(26913,21329,'N','01','021','EC','A',NULL,NULL,'','0001620090','0002194923','','IL','1','Ghashghaee','Carla','Kelly','','','34','436430555','59655 Highway 1148 Lot 180',0,'Plaquemine','LA','70764',NULL,'CY','22047','1964-07-09','F','',':RET:2106-3','N','021','DEN','3511496','18575LA002000201','2014-04-01','2014-03-02 16:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-03 01:00:12'),(21430,17127,'Y','18','021','EC','A','','','AC','0000223187','0000223187','TX00002444192','IL','1','Rider','Matthew','','','','34','459935882','5521 26th',0,'lubbock','TX','79407',NULL,'CY','48303','1980-05-21','M','U',':RET:2106-3','T','021','DEN','2940087','33348TX002000101','2014-03-01','2014-02-03 21:30:29','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2014-02-04 21:01:18'),(17689,14136,'Y','18','021','EC','A','','','AC','0001888256','0001888256','LA00002502891','IL','1','Jenkins','Eric','','','','34','545613915','1716 Peniston Street',0,'New Orleans','LA','70115',NULL,'CY','22071','1971-01-30','M','R',NULL,'N','021','DEN','1457293','18575LA002000201','2014-02-01','2014-01-13 11:16:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:32:58'),(7256,5754,'N','19','021','EC','A',NULL,NULL,'','0000038362','0001209569','','S1','1','McDowell','Chad','','','','34','491157533','127 Moores Road',0,'Seaman','OH','45679',NULL,'CY','39001','1998-10-22','F','',':RET:2106-3','N','021','HLT','996722','92036OH002000601','2014-01-01','2013-12-13 23:27:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 02:02:03'),(4906,3891,'Y','18','021','EC','A','','','AC','0000367982','0000367982','LA00000455574','IL','1','Robertson','Jarrell','','','','34','436658947','4500 sherwood common blvd',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1985-11-25','M','U',NULL,'T','021','DEN','700657','18575LA002000201','2014-01-01','2013-10-26 17:51:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:31:57'),(14077,11218,'N','19','021','EC','A',NULL,NULL,'','0000166385','0001090926','','IL','1','Preston','Shervon','Lynnise','','','34','299963786','1214 LINDEN AVE',0,'AKRON','OH','44310','1263','CY','39153','1994-03-31','F','',':RET:2054-5','N','021','DEN','2148666','99734OH005000401','2014-02-01','2013-12-26 10:09:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:01'),(3460,2782,'Y','18','021','EC','A','','','AC','0000139006','0000139006','OH00001099919','IL','1','Spieldenner','Steven','J','','','34','279660135','4424 BURNINGTREE DR',0,'TOLEDO','OH','43623','3186','CY','39095','1964-11-03','M','M',':RET:2106-3','N','021','DEN','2500676','99734OH005000401','2014-01-01','2013-12-22 04:18:00','0.00',NULL,NULL,'71.95','71.95','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:19:44'),(5215,4140,'Y','18','021','EC','A','','','AC','0000920790','0000920790','OH00000406731','IL','1','Bartlett','Joyce','','','','34','401806995','4243 Tower Ave.',0,'Cincinnati','OH','45217',NULL,'CY','39061','1950-05-10','F','U',':RET:2106-3','N','021','DEN','1889721','99734OH005000401','2014-01-01','2013-12-19 15:45:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:23'),(28634,22660,'N','01','021','EC','A',NULL,NULL,'','0000293702','0000992746','','IL','1','OVIEDO','EUSEBIA','','','','34','635704883','1746  VZCR 1505',0,'VAN','TX','75790',NULL,'CY','48467','1963-08-14','F','',NULL,'N','021','DEN','3115031','33348TX002000201','2014-04-01','2014-03-07 19:20:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:28'),(1705,1424,'Y','18','021','EC','A','','','AC','0000632693','0000632693','OH00001008526','IL','1','Ingram','Beverly','Lynn','','','34','280560753','2984 WESTBROOK DR',0,'CINCINNATI','OH','45238','2438','CY','39061','1955-03-19','F','M',':RET:2054-5','N','021','HLT','1800883','92036OH006001201','2014-01-01','2013-12-24 10:59:30','0.00',NULL,NULL,'433.78','433.78','R-OH004','OH0','433.78',NULL,0,'2013-12-25 18:54:51'),(14389,11477,'Y','18','021','EC','A','','','AC','0001048005','0001048005','OH00000684133','IL','1','robinson','philip','','','','34','401985040','959 4 MILE RD',0,'CINCINNATI','OH','45230','5221','CY','39061','1960-01-08','M','M',':RET:2106-3','N','021','DEN','2299761','99734OH005000401','2014-02-01','2013-12-27 14:55:24','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:58'),(28798,22795,'N','01','021','EC','A',NULL,NULL,'','0001055377','0000585590','','IL','1','Wright','James','L','','','34','301801273','1845 Beech Rd',0,'Stow','OH','44224',NULL,'CY','39153','1969-04-24','M','',':RET:2106-3','N','021','DEN','4088055','99734OH005000301','2014-04-01','2014-03-09 09:45:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:46'),(6121,4854,'Y','18','021','EC','A','','','AC','0000357654','0000357654','TX00001125510','IL','1','garcia','gloria','','','','34','464591812','403 32nd st',0,'hidalgo','TX','78557',NULL,'CY','48215','1974-03-02','F','U',':RET:2106-3','N','021','DEN','1077099','33348TX002000201','2014-01-01','2013-11-20 21:57:46','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 00:15:44'),(5051,4000,'Y','18','021','EC','A','','','AC','0000200244','0000200244','TX00000448811','IL','1','Sepulveda','Maritza','','','','34','456713231','5000 Gallagher',0,'Laredo','TX','78041',NULL,'CY','48479','1965-05-18','F','U',NULL,'N','021','DEN','1759036','33348TX002000201','2014-01-01','2013-12-18 20:15:20','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 23:00:11'),(5391,4278,'Y','18','021','EC','A','','','AC','0001791235','0001791235','LA00000408203','IL','1','Blanchard','Glenda','','','','34','436904613','108 HALFWAY RD',0,'DONALDSONVILLE','LA','70346','8410','CY','22005','1950-04-25','F','U',':RET:2106-3','N','021','DEN','2291844','18575LA002000201','2014-01-01','2013-12-19 16:46:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:08:40'),(13991,11146,'Y','18','021','EC','A','','','AC','0000483485','0000483485','OH00000762669','IL','1','Gentile','Raymond','','','','34','272604304','3527 Secor',0,'Toledo','OH','43606',NULL,'CY','39095','1956-12-29','M','U',':RET:2106-3','T','021','HLT','2110828','92036OH001002601','2014-01-01','2013-12-23 18:20:01','210.00',NULL,NULL,'659.19','449.19','R-OH001','OH0','659.19',NULL,0,'2013-12-26 13:15:47'),(17320,13853,'Y','18','021','EC','A','','','AC','0000718861','0000718861','TX00002296223','IL','1','King','Nataly','Torres','','','34','628062307','3209 GILBERT ST',0,'AUSTIN','TX','78703','2221','CY','48453','1992-05-01','F','U',NULL,'N','021','DEN','2058594','33348TX002000201','2014-02-01','2014-01-10 17:30:29','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:23:50'),(21948,17528,'Y','18','021','EC','A','','','AC','0000140332','0000140332','OH00002402568','IL','1','PATEL','JYOTIBEN','','','','34','456611391','4135 LINCOLN ST E',0,'CANTON','OH','44730','9479','CY','39151','1971-04-18','F','M',':RET:2029-7','N','021','DEN','3175502','99734OH005000401','2014-03-01','2014-02-06 20:07:26','0.00',NULL,NULL,'71.95','71.95','R-OH015','OH0','0.00',NULL,0,'2014-02-07 19:00:19'),(25224,20007,'N','01','021','EC','A',NULL,NULL,'','0000246501','0001199555','','IL','1','MCMILLION','DENISE','','','','34','291668823','257 HILLSDALE CIR',0,'WADSWORTH','OH','44281','1007','CY','39103','1959-07-14','F','',NULL,'N','021','HLT','2647888','52664OH151001306','2014-04-01','2014-02-21 10:34:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2014-02-21 22:00:58'),(5428,4310,'Y','18','021','EC','A','','','AC','0000722255','0000722255','MS00000422319','IL','1','molden','margaret','','','','34','526216009','10805 CAROLINA CV',0,'VANCLEAVE','MS','39565','9541','CY','28059','1956-01-24','F','U',':RET:2106-3','T','021','DEN','1548894','46300MS002000201','2014-01-01','2013-12-19 17:52:17','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 23:09:34'),(2662,2163,'Y','18','021','EC','A','','','AC','0000366252','0000366252','OH00001319516','IL','1','Braunstein','Pamela','J','','','34','280569077','6542 SIMON DR',0,'CINCINNATI','OH','45233','4562','CY','39061','1954-07-25','F','M',':RET:2106-3','N','021','DEN','523596','99734OH005000301','2014-01-01','2013-12-02 09:59:01','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:46:52'),(3807,3051,'Y','18','021','EC','A','','','AC','0000025274','0000025274','OH00000309547','IL','1','Kirby','Scott','','','','34','269606165','22 Basin St.',0,'Navarre','OH','44662',NULL,'CY','39151','1971-04-08','M','M',':RET:2106-3','N','021','DEN','998037','99734OH005000301','2014-01-01','2013-12-13 13:43:10','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 21:34:40'),(6850,5430,'Y','18','021','EC','A','','','AC','0000200155','0000200155','TX00000786700','IL','1','Mewis','Dawn','','','','34','533545674','20075 STATE HIGHWAY 159 W',0,'NEW ULM','TX','78950','5031','CY','48015','1952-12-05','F','U',NULL,'N','021','DEN','985868','33348TX002000201','2014-01-01','2013-10-05 10:44:35','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:31:21'),(15515,12413,'Y','18','021','EC','A','','','AC','0001173604','0001173604','LA00000724400','IL','1','Wise','Brenda','','','','34','268469156','118 Carolyn Dr.',0,'Lafayette','LA','70508',NULL,'CY','22055','1949-11-22','F','U',':RET:2106-3','N','021','DEN','1644904','18575LA002000201','2014-02-01','2013-12-30 19:04:43','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:30:10'),(21385,17091,'Y','18','024','14','A','','','TE','0000184962','0000184962','','IL','1','ZUCCO','GARY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-10-13','M','',NULL,NULL,NULL,'','1448514','','2014-02-04','2014-02-04 08:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:00:55'),(24037,19115,'N','19','021','EC','A',NULL,NULL,'','0000304757','0000708994','','IL','1','Hineline','Paige','','','','34','648070779','8368 HAMBLETONIAN DR',0,'CINCINNATI','OH','45249','1309','CY','39061','1995-06-15','F','',':RET:2106-3','N','021','DEN','2881544','99734OH005000301','2014-03-01','2014-02-15 08:58:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:00:56'),(25219,20003,'Y','18','021','EC','A','','','AC','0000983170','0000983170','MS00002534434','IL','1','McGee','Clara','','','','34','427412244','712 North Jeferson Street',0,'Jackson','MS','39202',NULL,'CY','28049','1981-11-10','F','U',':RET:2054-5','N','021','DEN','3679822','46300MS002000201','2014-04-01','2014-02-21 10:15:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-21 22:00:55'),(26319,20881,'Y','18','021','EC','A','','','AC','0000910577','0000910577','OH00003041128','IL','1','Horwath','Brent','','','','34','288829038','223 LAFAYETTE AVE',0,'URBANA','OH','43078','1421','CY','39021','1984-11-30','M','M',':RET:2106-3','N','021','HLT','2766489','92036OH005000501','2014-04-01','2014-02-27 17:40:09','115.00',NULL,NULL,'515.10','400.10','R-OH003','OH0','265.99',NULL,0,'2014-02-28 06:31:36'),(630,521,'Y','18','021','EC','A','','','AC','0000307066','0000307066','OH00001267523','IL','1','Wainscott','Peggy','','','','34','296526826','7560 EVANS CT',0,'FAIRFIELD','OH','45011','9308','CY','39017','1952-12-13','F','U',':RET:2106-3','N','021','DEN','2056318','99734OH005000401','2014-01-01','2013-12-16 12:52:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:04'),(5410,4294,'N','19','021','EC','A',NULL,NULL,'','0000974082','0000426416','','IL','1','Middleton','Matthew','Keith','','','34','291960652','719 MCCUNE RD',0,'WILMINGTON','OH','45177','8715','CY','39027','1993-10-28','M','',':RET:2106-3','N','021','HLT','1575700','92036OH003000601','2014-01-01','2013-12-19 13:29:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 23:09:09'),(19446,15500,'Y','18','021','EC','A','','','AC','0000015297','0000015297','OH00001365003','31','1','Moeller','Kevin','','','','34','280887124','464 E PEKIN RD',0,'LEBANON','OH','45036','8191','CY','39165','1984-03-19','M','M',':RET:2106-3','N','021','DEN','3019019','99734OH005000301','2014-03-01','2014-01-22 13:52:42','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:01:51'),(18494,14751,'Y','18','021','EC','A','','','AC','0000589344','0000589344','OH00002080328','IL','1','Marsilio','Victor','','','','34','275609676','5340 MAHONING AVE',0,'AUSTINTOWN','OH','44515','2415','CY','39099','1959-12-13','M','U',':RET:2106-3','N','021','HLT','2159761','52664OH151001305','2014-02-01','2014-01-15 11:47:10','415.00',NULL,NULL,'539.93','124.93','R-OH013','OH0','539.93',NULL,0,'2014-01-16 08:46:27'),(18436,14709,'Y','18','021','EC','A','','','AC','0002365428','0002365428','LA00001964079','IL','1','KAVANAUGH','PATRICK','','','','34','435044561','4764 LAFAYE ST',0,'NEW ORLEANS','LA','70122','6136','CY','22071','1955-08-16','M','U',':RET:2106-3','T','021','DEN','1947267','18575LA002000201','2014-02-01','2014-01-15 15:15:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:46:01'),(18354,14652,'Y','18','021','EC','A','','','AC','0000162292','0000162292','OH00002180786','IL','1','Deyarmin','Susan','','','','34','288720012','708 TOWNSHIP ROAD 150',0,'SULLIVAN','OH','44880','9700','CY','39005','1961-09-28','F','M',':RET:2106-3','T','021','DEN','2144183','99734OH005000301','2014-02-01','2014-01-14 21:54:51','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:23'),(985,806,'N','19','021','EC','A',NULL,NULL,'','0000525539','0000678055','','IL','1','Scalia','Sophie','','','','34','033966657','2931 OAKCREST DR',0,'NORTON','OH','44203','6385','CY','39153','2011-10-15','F','',':RET:2106-3','N','021','HLT','869301','52664OH151001501','2014-01-01','2013-10-31 12:40:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 18:10:26'),(17753,14185,'Y','18','021','EC','A','','','AC','0001212009','0001212009','MS00002137266','IL','1','Goree','Telisha','','','','34','427554468','102 N MILL ST',0,'JACKSON','MS','39201','2012','CY','28049','1975-10-27','F','U',NULL,'N','021','DEN','1395734','46300MS002000101','2014-02-01','2014-01-13 13:14:37','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-14 01:33:29'),(1459,1216,'Y','18','021','EC','A','','','AC','0001108095','0001108095','OH00000282003','IL','1','subuyuj','juan','','','','34','602641668','781bernhar rd',0,'columbus','OH','43213',NULL,'CY','39049','1964-06-24','M','M',NULL,'N','021','DEN','1682325','99734OH005000401','2014-01-01','2013-12-24 08:27:59','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:16'),(14282,11393,'N','01','021','EC','A',NULL,NULL,'','0000895744','0001205912','','IL','1','Claveau','Sebastien','','','','34','753077470','17 Chiniche Lane',0,'Long beach','MS','39560',NULL,'CY','28047','1974-02-14','M','',':RET:2106-3','T','021','DEN','1538545','46300MS002000201','2014-02-01','2013-12-26 17:08:05',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-27 02:06:21'),(3881,3109,'Y','18','021','EC','A','','','AC','0001027411','0001027411','LA00001069827','IL','1','Johnson','Sylvia','S','','','34','434577272','7822 READ BLVD',0,'NEW ORLEANS','LA','70127','1322','CY','22071','1985-01-30','F','U',':RET:2054-5','N','021','DEN','808391','18575LA002000201','2014-01-01','2013-12-13 14:49:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:36:27'),(3421,2747,'Y','18','021','EC','A','','','AC','0002154880','0002154880','LA00000208244','IL','1','Ortiz','Patricia','','','','34','557049685','39580 Highway 75',0,'Plaquemine','LA','70764',NULL,'CY','22047','1956-01-03','F','U',NULL,'T','021','DEN','1392411','18575LA002000201','2014-01-01','2013-12-22 17:56:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:39'),(9082,7206,'Y','18','021','EC','A','','','AC','0000475953','0000475953','OH00001193164','IL','1','Singh','Gretchen','','','','34','281626504','8367 PATRILLA LN',0,'CINCINNATI','OH','45249','1701','CY','39061','1971-07-26','F','U',':RET:2106-3','N','021','DEN','2009031','99734OH005000301','2014-01-01','2013-12-17 23:43:58','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:06:51'),(2330,1896,'Y','18','021','EC','A','','','AC','0000128151','0000128151','TX00000813821','IL','1','Gomez','Senia','','','','34','645106521','2123 N MUSKINGUM AVE',0,'ODESSA','TX','79761','1247','CY','48135','1980-01-13','F','M',NULL,'N','021','DEN','355575','33348TX002000201','2014-01-01','2013-12-09 11:54:13','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2013-12-25 19:31:40'),(2790,2255,'Y','18','021','EC','A','','','AC','0000801219','0000801219','OH00000354208','IL','1','Hemmelgarn','Kathleen','','','','34','290486790','344 BRUNS AVE',0,'CELINA','OH','45822','9799','CY','39107','1950-03-14','F','M',':RET:2106-3','T','021','HLT','75455','92036OH004001501','2014-01-01','2013-12-02 08:41:28','243.00',NULL,NULL,'600.76','357.76','R-OH002','OH0','600.76',NULL,0,'2013-12-25 19:50:05'),(2810,2271,'Y','18','021','EC','A','','','AC','0000327232','0000327232','OH00001095636','IL','1','Combs','Bradley','','','','34','311861626','3647 MOONRIDGE DR',0,'CINCINNATI','OH','45248','4222','CY','39061','1967-02-17','M','U',NULL,'N','021','DEN','1165520','99734OH005000301','2014-01-01','2013-10-15 02:31:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:00:13'),(21565,17227,'N','19','021','EC','A',NULL,NULL,'','0001248370','0000982744','','S1','1','Crabiel','Mark','','','','34','295080795','4980 Maple Heights Drive',0,'Medina','OH','44256',NULL,'CY','39103','2004-03-03','M','',':RET:2106-3','N','021','HLT','3214185','52664OH151001305','2014-03-01','2014-02-04 19:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-05 21:30:19'),(24477,19445,'Y','18','021','EC','A','','','AC','0001165391','0001165391','OH00002716188','IL','1','Mendel','Sydney','','','','34','274587620','2592 QUEENSTON RD',0,'CLEVELAND HEIGHTS','OH','44118','4352','CY','39035','1955-07-15','M','U',':RET:2106-3','N','021','HLT','2718324','52664OH152000901','2014-04-01','2014-02-18 14:05:06','219.00',NULL,NULL,'469.40','250.40','R-OH011','OH0','469.40',NULL,0,'2014-02-18 22:01:42'),(24640,19557,'Y','18','021','EC','A','','','AC','0001862429','0001862429','LA00001648696','IL','1','SIMIEN','LAVONDA','CHARLES','','','34','369789588','217 W VINE ST',0,'OPELOUSAS','LA','70570','5155','CY','22097','1973-05-24','F','U',':RET:2054-5','N','021','DEN','3051340','18575LA002000201','2014-04-01','2014-02-19 11:21:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 04:19:48'),(133,115,'Y','18','021','EC','A','','','AC','0001014349','0001014349','OH00001314358','IL','1','Upton','Bennie','','','','34','409515432','4771 Country Lane.',0,'Warrensville Heights','OH','44128',NULL,'CY','39035','1986-04-05','M','U',':RET:2054-5','N','021','HLT','1086379','52664OH152000901','2014-01-01','2013-12-04 19:14:43','0.00',NULL,NULL,'193.07','193.07','R-OH011','OH0','193.07',NULL,0,'2013-12-25 17:18:31'),(19493,15536,'N','19','021','EC','A',NULL,NULL,'','0000049533','0000664207','','S1','1','Carpenter','Gene','W','','','34','296065940','7430 WHITEWOOD DR',0,'ASHTABULA','OH','44004','9413','CY','39007','2002-03-27','F','',':RET:2106-3','N','021','HLT','2396221','52664OH151001304','2014-03-01','2014-01-22 10:48:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-01-23 03:02:07'),(17925,14319,'Y','18','021','EC','A','','','AC','0001164434','0001164434','TX00002364360','IL','1','Hirth','Edith','','','','34','432904106','1907 WILLIS DR',0,'LONGVIEW','TX','75601','4132','CY','48183','1949-09-25','F','U',':RET:2106-3','N','021','DEN','2201571','33348TX002000201','2014-02-01','2014-01-14 11:39:17','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-15 02:06:32'),(142,121,'Y','18','021','EC','A','','','AC','0000054435','0000054435','OH00000053432','IL','1','Kelly','Kathleen','','','','34','101465469','875 N MEDINA LINE RD',0,'AKRON','OH','44333','1323','CY','39153','1951-10-14','F','M',':RET:2106-3','T','021','HLT','931212','52664OH152000901','2014-01-01','2013-12-05 09:23:01','0.00',NULL,NULL,'539.67','539.67','R-OH012','OH0','539.67',NULL,0,'2013-12-25 17:18:43'),(15927,12753,'Y','18','021','EC','A','','','AC','0000683197','0000683197','MS00001891302','IL','1','Campbell','Justin','','','','34','587617422','828 OLD HIGHWAY 49 S',0,'RICHLAND','MS','39218','9662','CY','28121','1984-01-11','M','U',':RET:2106-3','N','021','DEN','1517498','46300MS002000201','2014-02-01','2014-01-02 17:44:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-03 02:06:48'),(6194,4908,'Y','18','021','EC','A','','','AC','0000960848','0000960848','TX00000676798','IL','1','Corbin','Coree','Lavone','','','34','629248789','2310 Stillmeadow Drive',0,'Missouri City','TX','77489',NULL,'CY','48157','1979-03-26','F','M',':RET:2039-6^:RET:2106-3','N','021','DEN','679303','33348TX002000201','2014-01-01','2013-10-23 15:07:17','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:30:24'),(5779,4591,'Y','18','021','EC','A','','','AC','0001092126','0001092126','OH00001194858','IL','1','AVILES','CARLOS','','','','34','148581453','3032 DAVID CT',0,'COLUMBUS','OH','43224','1893','CY','39049','1971-08-01','M','M',NULL,'N','021','DEN','2234515','99734OH005000401','2014-01-01','2013-12-23 23:11:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:47:00'),(14973,11968,'Y','18','021','EC','A','','','AC','0000050549','0000050549','TX00001898584','IL','1','Lambert','John','','','','34','464966511','3454 WASHINGTON DR',0,'FRISCO','TX','75034','6392','CY','48121','1964-05-14','M','R',':RET:2106-3','N','021','DEN','2142624','33348TX002000201','2014-02-01','2013-12-30 12:58:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:53'),(5114,4052,'N','01','021','EC','A',NULL,NULL,'','0000201725','0000327777','','IL','1','Khan','Zubaida','I','','','34','635665542','22 MOCKINGBIRD LN',0,'DAYTON','TX','77535','9204','CY','48291','1961-03-03','F','',':RET:2029-7','N','021','DEN','2393756','33348TX002000201','2014-01-01','2013-12-19 18:15:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:01:46'),(1318,1089,'Y','18','021','EC','A','','','AC','0000078722','0000078722','OH00000901689','IL','1','Toppel','James','','','','34','281901161','12535 EDGEWATER DR',0,'LAKEWOOD','OH','44107','1636','CY','39035','1973-10-22','M','U',':RET:2106-3','T','021','DEN','424122','99734OH005000401','2014-01-01','2013-11-04 16:09:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:31:37'),(2238,1839,'Y','18','021','EC','A','','','AC','0001187621','0001187621','OH00000310947','IL','1','Coates','Tim','','','','34','293526064','192 PINEWOOD DR',0,'ELYRIA','OH','44035','6032','CY','39093','1952-05-03','M','M',':RET:2106-3','N','021','HLT','640568','92036OH003000805','2014-01-01','2013-12-10 15:25:43','397.00',NULL,NULL,'686.10','289.10','R-OH011','OH0','686.10',NULL,0,'2013-12-25 19:20:56'),(22216,17733,'Y','18','021','EC','A','','','AC','0001436527','0001436527','LA00002310862','IL','1','Evans','Jeffrey','','','','34','438983808','2515 HOLLYGROVE ST',0,'NEW ORLEANS','LA','70118','1626','CY','22071','1955-02-25','M','U',':RET:2054-5','N','021','DEN','2652007','18575LA002000201','2014-03-01','2014-02-09 15:39:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:23'),(22895,18252,'Y','18','021','EC','A','','','AC','0000073974','0000073974','OH00002156674','IL','1','Huff','Alison','','','','34','296764146','15054 MOCK RD',0,'BERLIN CENTER','OH','44401','8731','CY','39099','1976-04-04','F','M',':RET:2106-3','N','021','HLT','3669385','92036OH002003201','2014-03-01','2014-02-11 10:22:47','0.00',NULL,NULL,'1049.38','1049.38','R-OH013','OH0','346.05',NULL,0,'2014-02-11 21:02:38'),(24484,19450,'Y','18','021','EC','A','','','AC','0001138089','0001138089','OH00001978069','IL','1','pittman','brenda','','','','34','295522319','176 BARRY DR',0,'LOVELAND','OH','45140','9467','CY','39025','1953-07-14','F','M',':RET:2106-3','N','021','HLT','3186081','92036OH004000601','2014-04-01','2014-02-18 17:18:57','349.00',NULL,NULL,'468.46','119.46','R-OH005','OH0','468.46',NULL,0,'2014-02-18 22:01:47'),(24664,19579,'Y','18','021','EC','A','','','AC','0000457850','0000457850','OH00002772976','IL','1','Graham','Sharon','','','','34','290522434','2318 Kenwood Blvd',0,'Toledo','OH','43606',NULL,'CY','39095','1952-07-01','F','U',NULL,'N','021','HLT','3280721','92036OH004002601','2014-04-01','2014-02-19 17:40:21','167.00',NULL,NULL,'440.60','273.60','R-OH001','OH0','440.60',NULL,0,'2014-02-20 04:26:07'),(25357,20119,'Y','18','021','EC','A','','','AC','0001243020','0001243020','OH00002986782','IL','1','Purtty','Jamey','','','','34','302827724','540 E 124TH ST',0,'CLEVELAND','OH','44108','1809','CY','39035','1985-06-08','F','U',':RET:2054-5','N','021','DEN','3619620','99734OH005000301','2014-04-01','2014-02-24 18:34:13','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-25 21:30:33'),(26932,21344,'Y','18','024','14','A','','','TE','0001190120','0001190120','','IL','1','Hamric','Stacey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-19','F','',NULL,NULL,NULL,'','3299454','','2014-03-16','2014-03-01 19:21:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 01:00:20'),(1936,1577,'Y','18','021','EC','A','','','AC','0000311498','0000311498','TX00000011891','IL','1','Baker','Fred','','','','34','464596580','PO Box 933',0,'Snyder','TX','79550',NULL,'CY','48415','1978-09-01','M','M',':RET:2106-3','T','021','DEN','1014929','33348TX002000201','2014-01-01','2013-11-20 12:13:32','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:00:32'),(19981,15938,'Y','18','021','EC','A','','','AC','0000387318','0000387318','OH00001462585','31','1','Pasternack','John','','','','34','301568418','Po Box',0,'New Middletown','OH','44442',NULL,'CY','39099','1954-09-15','M','M',NULL,'N','021','DEN','2919451','99734OH005000401','2014-03-01','2014-01-25 17:41:04','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-01-25 19:00:16'),(2061,1687,'N','01','021','EC','A',NULL,NULL,'','0000552609','0000251600','','IL','1','Macaluso','Sandra','','','','34','285485365','2 CURRY LN',0,'MILFORD','OH','45150','1891','CY','39025','1949-07-08','F','',':RET:2106-3','N','021','DEN','732002','99734OH005000301','2014-01-01','2013-12-10 14:33:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:16:06'),(2418,1972,'N','01','021','EC','A',NULL,NULL,'','0000377441','0000916978','','IL','1','Porter','Gregory','L','','','34','300584444','1041 CLOVERLY DR',0,'GAHANNA','OH','43230','6219','CY','39049','1957-07-09','M','',':RET:2054-5','N','021','DEN','869595','99734OH005000401','2014-01-01','2013-12-09 15:55:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:53'),(15012,12000,'Y','18','021','EC','A','','','AC','0000228347','0000228347','OH00001502500','IL','1','Hartney','Mercades','','','','34','298942123','1063 EAGLE DR',0,'AKRON','OH','44312','5859','CY','39153','1992-05-19','F','U',':RET:2106-3','N','021','HLT','2134964','52664OH151001306','2014-02-01','2013-12-30 11:08:03','158.00',NULL,NULL,'223.01','65.01','R-OH012','OH0','223.01',NULL,0,'2014-01-01 12:02:03'),(6897,5472,'N','01','021','EC','A',NULL,NULL,'','0001997204','0002234216','','IL','1','Tibbs','Dewayne','','','','34','434371667','1809 N. Harco Bldg 2',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1978-08-22','M','',':RET:2054-5','N','021','DEN','2594124','18575LA002000201','2014-01-01','2013-12-24 21:42:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:45:32'),(7374,5839,'N','01','021','EC','A',NULL,NULL,'','0000258116','0001229278','','IL','1','williams','antonio','','','','34','300566111','2011 CREST RD',0,'CINCINNATI','OH','45240','2063','CY','39061','1956-07-12','M','',':RET:2054-5','N','021','DEN','331578','99734OH005000401','2014-01-01','2013-11-23 09:44:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:44'),(7976,6314,'Y','18','021','EC','A','','','AC','0000884204','0000884204','OH00000870657','IL','1','Mitchell','Lisa','','','','34','291466820','229 LONGVIEW DR',0,'WADSWORTH','OH','44281','1644','CY','39103','1960-10-12','F','U',':RET:2106-3','N','021','HLT','2587420','52664OH151001304','2014-01-01','2013-12-20 08:05:04','241.00',NULL,NULL,'454.94','213.94','R-OH012','OH0','454.94',NULL,0,'2013-12-26 03:07:50'),(7909,6253,'Y','18','021','EC','A','','','AC','0001304614','0001304614','LA00000463624','IL','1','Ojong','Ernest','','','','34','662221208','567 sharp lane',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1979-07-27','M','U',':RET:2054-5','N','021','DEN','1830971','18575LA002000201','2014-01-01','2013-12-19 21:06:11','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:06:01'),(27866,22042,'Y','18','021','EC','A','','','AC','0000525638','0000525638','OH00002890432','IL','1','WILKINS','DON','M','','','34','295801421','399 SAIRVIEW AVE',0,'HAMILTON','OH','45015',NULL,'CY','39017','1967-03-03','F','M',':RET:2106-3','N','021','HLT','3545586','92036OH004001201','2014-04-01','2014-03-05 12:09:02','316.00',NULL,NULL,'567.55','251.55','R-OH004','OH0','269.80',NULL,0,'2014-03-05 21:32:22'),(916,761,'Y','18','021','EC','A','','','AC','0000915632','0000915632','OH00000425590','IL','1','Fowler','Maureen','E','','','34','114584175','821 PARK AVE',0,'HAMILTON','OH','45013','2973','CY','39017','1961-11-17','F','M',':RET:2106-3','N','021','HLT','1467176','92036OH003001201','2014-01-01','2013-12-16 16:03:12','391.00',NULL,NULL,'980.33','589.33','R-OH004','OH0','437.59',NULL,0,'2013-12-25 18:08:40'),(19778,15767,'Y','18','024','14','A','','','TE','0000961888','0000961888','','IL','1','Danchisen','Jacquelyn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-11-02','F','',NULL,NULL,NULL,'','2895372','','2014-01-23','2014-01-23 17:54:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:32'),(19656,15662,'Y','18','021','EC','A','','','AC','0000757147','0000757147','OH00001831050','IL','1','Thomas','Jessica','','','','34','288905063','2149 TRAILRIDGE DR',0,'CINCINNATI','OH','45215','3948','CY','39061','1984-12-03','F','U',':RET:2106-3','N','021','DEN','3145149','99734OH005000401','2014-03-01','2014-01-23 12:55:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 21:00:21'),(6582,5219,'Y','18','021','EC','A','','','AC','0000064863','0000064863','OH00001208983','IL','1','Abrams','Gregory','','','','34','278687799','3159 Delhi Ave',0,'Cincinnati','OH','45204',NULL,'CY','39061','1975-02-13','M','M',NULL,'N','021','HLT','704593','92036OH003001201','2014-01-01','2013-12-11 08:05:35','115.00',NULL,NULL,'558.68','443.68','R-OH004','OH0','279.34',NULL,0,'2013-12-26 00:53:01'),(2215,1824,'N','01','021','EC','A',NULL,NULL,'','0001029340','0000733565','','IL','1','Schrack','Jeri','','','','34','289801886','1432 CHIPPEWA AVE',0,'AKRON','OH','44305','2706','CY','39153','1970-09-18','F','',NULL,'N','021','HLT','702067','52664OH151001305','2014-01-01','2013-12-10 16:39:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.62',NULL,0,'2013-12-25 19:20:23'),(7876,6231,'Y','18','021','EC','A','','','AC','0000062527','0000062527','OH00001283032','IL','1','schindler','maury','','','','34','167383279','1580 CREEKSIDE RD',0,'AMELIA','OH','45102','1794','CY','39025','1961-01-27','M','M',':RET:2106-3','N','021','DEN','1620752','99734OH005000301','2014-01-01','2013-12-20 17:20:51','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:05:18'),(16942,13560,'Y','18','021','EC','A','','','AC','0001600419','0001600419','LA00001519130','IL','1','amaya calix','reina','','','','34','682098692','804 burlay drive apt b',0,'kenel','LA','70065',NULL,'CY','22051','1964-06-17','F','U',NULL,'N','021','DEN','1809888','18575LA002000201','2014-02-01','2014-01-09 13:31:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:54'),(27120,21467,'Y','18','021','EC','A','','','AC','0000992729','0000992729','OH00002886248','IL','1','Stone','david','','','','34','297827482','518 BLAINE ST',0,'GENEVA','OH','44041','1610','CY','39007','1984-08-13','M','U',':RET:2106-3','N','021','DEN','3013830','99734OH005000301','2014-04-01','2014-03-03 13:11:57','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:33'),(6460,5119,'N','01','021','EC','A',NULL,NULL,'','0000881600','0001162575','','IL','1','TAKACH','BARBARA','','','','34','272542341','680 WHIPPOORWILL LN',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1955-01-27','F','',':RET:2106-3','N','021','HLT','895273','52664OH151001501','2014-01-01','2013-12-11 10:25:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','681.50',NULL,0,'2013-12-26 00:49:53'),(2681,2171,'Y','18','021','EC','A','','','AC','0000287064','0000287064','OH00000079941','IL','1','young','william','','','','34','287480956','5935 S MYERS RD',0,'CLINTON','OH','44216','8703','CY','39153','1950-07-26','M','U',':RET:2106-3','N','021','DEN','1233531','99734OH005000301','2014-01-01','2013-12-02 13:57:02','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:47:12'),(21626,17267,'Y','18','021','EC','A','','','AC','0000042236','0000042236','TX00002302845','IL','1','Sadruddin','Sadiq','','','','34','456735734','1432 SUMMERHILL DR',0,'CARROLLTON','TX','75007','6048','CY','48121','1965-08-14','M','M',NULL,'N','021','DEN','3849168','33348TX002000201','2014-03-01','2014-02-05 09:56:45','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-05 21:30:39'),(2953,2378,'Y','18','021','EC','A','','','AC','0000800597','0000800597','TX00000460792','IL','1','Fletcher','Jamal','','','','34','636224425','908 MOCKINGBIRD LN',0,'Tyler','TX','75701',NULL,'CY','48423','1991-04-15','M','U',':RET:2054-5','N','021','DEN','300662','33348TX002000201','2014-01-01','2013-12-06 11:27:56','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 20:16:35'),(3612,2893,'N','19','021','EC','A',NULL,NULL,'','0000997747','0001204523','','IL','1','McDermott','Collin','','','','34','278080157','419 Cabot Drive',0,'Akron','OH','44333',NULL,'CY','39153','2003-03-12','M','',':RET:2106-3','N','021','HLT','1423401','52664OH152000901','2014-01-01','2013-12-22 18:15:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 21:23:30'),(13193,10526,'Y','18','021','EC','A','','','AC','0000896210','0000896210','TX00000925391','IL','1','Coleman','Carolyn','','','','34','456375225','336 MCBRIDE RD',0,'LANCASTER','TX','75146','5110','CY','48113','1960-12-08','F','R',':RET:2054-5','N','021','DEN','2466060','33348TX002000101','2014-01-01','2013-12-23 11:46:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:42'),(17816,14231,'Y','18','021','EC','A','','','AC','0000643546','0000643546','MS00002499043','31','1','Wallace','Twyonda','','','','34','587294921','P.O Box 71',0,'Clinton','MS','39071',NULL,'CY','28089','1975-02-06','F','U',':RET:2054-5','N','021','DEN','1752019','46300MS002000201','2014-02-01','2014-01-13 19:12:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:54'),(14214,11334,'N','19','021','EC','A',NULL,NULL,'','0000151687','0000374314','','IL','1','Smith','Cameron','James','','','34','639820354','17906 BUTTE CREEK RD',0,'HOUSTON','TX','77090','1816','CY','48201','2002-08-05','M','',':RET:2106-3','N','021','DEN','2425613','33348TX002000201','2014-02-01','2013-12-26 15:49:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2013-12-27 02:04:34'),(23148,18453,'Y','18','021','EC','A','','','AC','0000396203','0000396203','OH00002557511','IL','1','Cantrell','Dean','','','','34','295626568','263 JENNINGS AVE',0,'CUYAHOGA FALLS','OH','44221','2109','CY','39153','1958-03-29','M','U',':RET:2106-3','N','021','HLT','2661958','52664OH151001306','2014-03-01','2014-02-12 14:32:09','431.00',NULL,NULL,'497.31','66.31','R-OH012','OH0','497.31',NULL,0,'2014-02-12 21:31:39'),(23467,18691,'N','01','021','EC','A',NULL,NULL,'','0000160460','0000733986','','IL','1','RUBIO','FRANCISCO','','','','34','457938155','310 E TRIPP RD',0,'SUNNYVALE','TX','75182','9591','CY','48113','1959-11-28','M','',NULL,'N','021','DEN','3007197','33348TX002000201','2014-03-01','2014-02-13 15:03:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:45'),(25077,19887,'Y','18','021','EC','A','','','AC','0000932151','0000932151','OH00002934738','IL','1','PARKER','LINDA','','','','34','275644784','801 EUCLID AVE',0,'AKRON','OH','44307','1537','CY','39153','1952-05-21','F','U',':RET:2054-5','N','021','HLT','3678644','52664OH152000901','2014-04-01','2014-02-20 14:33:47','348.00',NULL,NULL,'458.99','110.99','R-OH012','OH0','458.99',NULL,0,'2014-02-20 22:01:34'),(28320,22407,'Y','18','021','EC','A','','','AC','0000393625','0000393625','TX00003128236','IL','1','barry','susan','','','','34','134444225','1618 California Street',0,'Houston','TX','77006',NULL,'CY','48201','1952-10-21','F','U',':RET:2106-3','N','021','DEN','3505224','33348TX002000201','2014-04-01','2014-03-06 19:31:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:04'),(28614,22646,'N','01','021','EC','A',NULL,NULL,'','0001104214','0001051488','','IL','1','DIAZ','JOSE','A','','','34','457898985','923 W HUBBARD ST',0,'MINERAL WELLS','TX','76067','4856','CY','48363','1957-12-01','M','',':RET:2106-3','N','021','DEN','3646796','33348TX002000201','2014-04-01','2014-03-07 21:43:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:17'),(28709,22719,'Y','18','021','EC','A','','','AC','0000493309','0000493309','OH00002843978','IL','1','Corey','Shellie','','','','34','301823830','26959 OAKMEAD DR',0,'PERRYSBURG','OH','43551','2656','CY','39173','1969-06-26','F','U',NULL,'N','021','HLT','2715896','92036OH003002604','2014-04-01','2014-03-08 16:24:42','73.00',NULL,NULL,'284.48','211.48','R-OH001','OH0','284.48',NULL,0,'2014-03-08 21:31:13'),(1144,942,'Y','18','024','14','A','','','TE','0001048122','0001048122','','IL','1','reeves','laurie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-20','F','',NULL,NULL,NULL,'','1195794','','2013-12-03','2013-12-03 13:36:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:18:26'),(6099,4835,'Y','18','021','EC','A','','','AC','0001021441','0001021441','OH00000830330','IL','1','Arzola','Jason','','','','34','301806537','1283 Hilltop Cr',0,'Troy','OH','45373',NULL,'CY','39109','1983-12-18','M','M',':RET:2106-3','T','021','DEN','880987','99734OH005000401','2014-01-01','2013-11-21 15:48:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:15:09'),(20908,16712,'Y','18','024','14','A','','','TE','0000459153','0000459153','','IL','1','Martin','Brandon','John',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-11','M','',NULL,NULL,NULL,'','1846436','','2014-01-31','2014-01-31 16:56:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:25'),(2429,1978,'N','01','021','EC','A',NULL,NULL,'','0000885570','0000034348','','IL','1','MCCAFFERTY','KIM','','','','34','276705949','4145 PLEASANTVILLE RD NE',0,'PLEASANTVILLE','OH','43148','9787','CY','39045','1960-08-01','M','',':RET:2106-3','N','021','DEN','456848','99734OH005000401','2014-01-01','2013-12-09 17:28:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:34:06'),(18267,14583,'N','19','021','EC','A',NULL,NULL,'','0000102399','0000617625','','IL','1','Smus','Alexis','Z','','','34','630179854','2914 HUNTINGTON WAY',0,'PEARLAND','TX','77584','9423','CY','48039','2008-08-25','F','',':RET:2106-3','N','021','DEN','2263147','33348TX002000201','2014-02-01','2014-01-15 15:58:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-01-16 08:44:40'),(17317,13850,'Y','18','021','EC','A','','','AC','0000055438','0000055438','TX00001781657','IL','1','Nguyen','Nam','','','','34','642083436','6819 QUAIL LK',0,'SAN ANTONIO','TX','78244','2017','CY','48029','1956-10-23','F','U',':RET:2047-9','N','021','DEN','1822026','33348TX002000201','2014-02-01','2014-01-10 15:23:01','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:23:48'),(5414,4296,'Y','18','021','EC','A','','','AC','0000987385','0000987385','OH00000782228','IL','1','Morton','Divante','','','','34','282986831','1016 Cherry Street',0,'Fostoria','OH','44830',NULL,'CY','39147','1995-09-12','M','U',':RET:2054-5^:RET:2106-3','N','021','HLT','2052762','92036OH003002705','2014-01-01','2013-12-18 22:03:19','115.94',NULL,NULL,'129.31','13.37','R-OH006','OH0','129.31',NULL,0,'2013-12-25 23:09:13'),(15280,12216,'Y','18','021','EC','A','','','AC','0000048201','0000048201','OH00001993391','31','1','Hernandez','Nelson','','','','34','584440365','po box 602511',0,'cleveland','OH','44102',NULL,'CY','39035','1953-03-04','M','U',NULL,'N','021','DEN','2222105','99734OH005000401','2014-02-01','2014-01-01 15:32:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:22:04'),(22928,18277,'N','01','021','EC','A',NULL,NULL,'','0000108148','0001244163','','IL','1','SPEHAR','MICHELLE','','','','34','300585741','780 WINSTON CIR',0,'MEDINA','OH','44256','7195','CY','39103','1960-04-16','F','',':RET:2106-3','N','021','DEN','3275543','99734OH005000301','2014-03-01','2014-02-11 05:25:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-11 21:30:08'),(23741,18903,'Y','18','021','EC','A','','','AC','0000301928','0000301928','OH00001650021','IL','1','RANKINS','DELLA','E','','','34','302444962','6369 MEIS AVE',0,'CINCINNATI','OH','45224','1957','CY','39061','1950-02-01','F','U',':RET:2054-5','N','021','DEN','2881499','99734OH005000301','2014-03-01','2014-02-13 23:53:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:31:04'),(27418,21697,'N','01','021','EC','A',NULL,NULL,'','0000585592','0000899624','','IL','1','Manning','Lynn','','','','34','281848968','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','1979-02-02','F','',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:37'),(1240,1020,'Y','18','021','EC','A','','','AC','0000429412','0000429412','LA00001149149','IL','1','hall','valerie','','','','34','438293384','704 Madison Drive',0,'LaPlace','LA','70068',NULL,'CY','22095','1965-10-26','F','U',':RET:2054-5','N','021','DEN','1165705','18575LA002000101','2014-01-01','2013-12-03 17:02:38','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:20:54'),(1670,1395,'Y','18','021','EC','A','','','AC','0000397129','0000397129','TX00000758806','IL','1','Richards','Janice','','','','34','555862050','6329 13TH ST',0,'LUBBOCK','TX','79416','5940','CY','48303','1950-03-21','F','U',NULL,'N','021','DEN','2499591','33348TX002000201','2014-01-01','2013-12-24 18:13:56','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:53:52'),(2507,2042,'Y','18','021','EC','A','','','AC','0000972719','0000972719','OH00000831966','IL','1','keller','jay','','','','34','275440778','735 YORKSHIRE DR',0,'LIMA','OH','45804','3378','CY','39003','1949-11-30','M','R',':RET:2106-3','N','021','HLT','1185448','92036OH003001501','2014-01-01','2013-12-08 23:25:39','0.00',NULL,NULL,'689.49','689.49','R-OH002','OH0','689.49',NULL,0,'2013-12-25 19:36:10'),(19014,15142,'Y','18','021','EC','A','','','AC','0002270836','0002270836','LA00002560469','IL','1','ibanez','jaime','','','','34','662201360','1029 S DARLA AVE',0,'GONZALES','LA','70737','4043','CY','22005','1970-12-19','M','M',NULL,'N','021','DEN','2070285','18575LA002000201','2014-03-01','2014-01-17 15:39:51','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-20 08:06:21'),(3205,2579,'Y','18','021','EC','A','','','AC','0000685806','0000685806','OH00000731107','IL','1','chinni','michael','','','','34','286482509','163 HIGHLAND AVE',0,'AVON LAKE','OH','44012','2031','CY','39093','1953-03-01','M','M',':RET:2106-3','N','021','DEN','731678','99734OH005000301','2014-01-01','2013-11-01 15:59:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:45:18'),(18280,14594,'N','01','021','EC','A',NULL,NULL,'','0000115558','0001061239','','IL','1','LOPEZ','ANA','CECILIA','','','34','766897421','307 N MISSISSIPPI ST',0,'AMARILLO','TX','79106',NULL,'CY','48375','1989-10-24','F','',NULL,'N','021','DEN','1497189','33348TX002000201','2014-02-01','2014-01-15 18:07:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-16 08:44:46'),(3632,2906,'Y','18','021','EC','A','','','AC','0000560530','0000560530','OH00001138540','IL','1','Thompson','Evelyn','','','','34','300503614','131 Kennedy Blvd Box 426',0,'Leesburg','OH','45135',NULL,'CY','39071','1952-06-29','F','M',':RET:2106-3','N','021','HLT','206106','92036OH003000606','2014-01-01','2013-12-13 16:09:58','550.00',NULL,NULL,'629.96','79.96','R-OH005','OH0','629.96',NULL,0,'2013-12-25 21:30:10'),(17760,14190,'N','01','021','EC','A',NULL,NULL,'','0000586710','0000300427','','IL','1','TOLLE','REBECCA','','','','34','295664801','150 FOREST AVE',0,'SEAMAN','OH','45679','9755','CY','39001','1960-11-18','F','',':RET:2106-3','N','021','HLT','2067459','92036OH004000601','2014-02-01','2014-01-13 11:17:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','352.13',NULL,0,'2014-01-14 01:33:33'),(17757,14188,'Y','18','021','EC','A','','','AC','0001124089','0001124089','OH00001632699','IL','1','West','Amanda','','','','34','279882737','4499 MOGUL LN',0,'LIBERTY TWP','OH','45011','7297','CY','39017','1982-12-11','F','U',':RET:2106-3','T','021','HLT','2176359','92036OH003001205','2014-02-01','2014-01-13 11:15:14','55.00',NULL,NULL,'298.80','243.80','R-OH004','OH0','298.80',NULL,0,'2014-01-14 01:33:31'),(7951,6291,'Y','18','021','EC','A','','','AC','0001936871','0001936871','LA00001121576','IL','1','PERRY','IVY','','','','34','547152298','638 WYANDOTTE STREET',0,'SHREVEPORT','LA','71101',NULL,'CY','22017','1966-05-08','F','U',':RET:2054-5','T','021','DEN','1558877','18575LA002000201','2014-01-01','2013-12-20 18:09:54','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:07:09'),(9025,7161,'Y','18','021','EC','A','','','AC','0000533288','0000533288','OH00000896283','IL','1','Davisson','Kathryn','','','','34','279568859','12125 COUNTRY OAKS TRL',0,'CHARDON','OH','44024','9094','CY','39055','1953-05-15','F','M',':RET:2106-3','N','021','HLT','1969342','52664OH151001301','2014-01-01','2013-12-18 09:48:23','597.00',NULL,NULL,'1365.24','768.24','R-OH011','OH0','682.62',NULL,0,'2013-12-26 04:05:26'),(16757,13406,'Y','18','021','EC','A','','','AC','0001055334','0001055334','OH00001212683','IL','1','Wang','Zong Ze','','','','34','276964553','107 WESTWOOD PL',0,'HICKSVILLE','OH','43526','1060','CY','39039','1962-02-13','M','M',':RET:2028-9','N','021','HLT','1820534','92036OH005002606','2014-02-01','2014-01-07 14:30:29','629.00',NULL,NULL,'696.35','67.35','R-OH001','OH0','363.68',NULL,0,'2014-01-08 18:24:57'),(14599,11652,'Y','18','021','EC','A','','','AC','0000581502','0000581502','OH00000456767','IL','1','hammonds','jacquelyn','','','','34','278623434','3660 HOFFMAN NORTON RD',0,'WEST FARMINGTON','OH','44491','8738','CY','39155','1955-07-27','F','U',':RET:2106-3','N','021','DEN','2543899','99734OH005000301','2014-02-01','2013-12-27 10:23:28','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-28 03:36:20'),(14292,11401,'Y','18','021','EC','A','','','AC','0000176400','0000176400','OH00000764104','IL','1','COSTILOW','REBECCA','L','','','34','272648406','1015 WASHINGTON AVE',0,'CUYAHOGA FALLS','OH','44221','2063','CY','39153','1956-09-28','F','M',':RET:2106-3','N','021','HLT','2591642','52664OH152000901','2014-02-01','2013-12-26 12:38:08','352.00',NULL,NULL,'398.06','46.06','R-OH012','OH0','398.06',NULL,0,'2013-12-27 02:06:36'),(6061,4802,'Y','18','021','EC','A','','','AC','0001011529','0001011529','OH00000069781','IL','1','Beeman','Robert','','','','34','278821517','4487 W 191ST ST',0,'CLEVELAND','OH','44135','1719','CY','39035','1980-01-19','M','U',':RET:2106-3','N','021','DEN','819333','99734OH005000401','2014-01-01','2013-12-01 09:43:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:01:56'),(3414,2741,'Y','18','021','EC','A','','','AC','0001326483','0001326483','LA00000116376','IL','1','McGee','Larry','','','','34','434909404','1212 LAKE LOUISE DR',0,'GRETNA','LA','70056','8341','CY','22051','1953-02-25','M','M',':RET:2054-5','N','021','DEN','2141109','18575LA002000201','2014-01-01','2013-12-22 16:12:48','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:28'),(6259,4961,'Y','18','021','EC','A','','','AC','0000162235','0000162235','OH00000921945','IL','1','Cooper','Julian','','','','34','272805902','8217 DAVIS ST',0,'MASURY','OH','44438','1111','CY','39155','1983-03-01','M','U',NULL,'N','021','DEN','1212577','99734OH005000401','2014-01-01','2013-10-06 20:53:40','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:32:13'),(25249,20029,'Y','18','021','EC','A','','','AC','0001012397','0001012397','MS00002824346','IL','1','Armit','Donna','G','','','34','437966986','142 HEARRINGTON',0,'CALHOUN CITY','MS','38916','7721','CY','28013','1970-07-19','F','M',':RET:2106-3','T','021','DEN','3079942','46300MS002000101','2014-04-01','2014-02-21 12:12:06','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-21 22:01:13'),(4346,3450,'N','19','021','EC','A',NULL,NULL,'','0000878253','0000893136','','S1','1','Schnipke','Terry','','','','34','292154586','3723 road 16',0,'continental','OH','45831',NULL,'CY','39137','2010-02-17','M','',':RET:2106-3','N','021','HLT','1431241','92036OH006001501','2014-01-01','2013-12-17 12:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2013-12-25 21:53:21'),(4562,3612,'Y','18','024','14','A','','','TE','0000848316','0000848316','','IL','1','Canterbury','Teresa','Lynn',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-17','F','',NULL,NULL,NULL,'','1250349','','2013-12-12','2013-12-12 17:46:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:04:44'),(6559,5200,'Y','18','021','EC','A','','','AC','0000743877','0000743877','TX00000819134','IL','1','HOLDER','DEANNA','','','','34','461196051','1113 PALO VERDE DR',0,'DENTON','TX','76210','3240','CY','48121','1958-10-11','F','M',NULL,'N','021','DEN','379841','33348TX002000201','2014-01-01','2013-12-11 13:23:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:52:23'),(7486,5922,'Y','18','021','EC','A','','','AC','0000335142','0000335142','OH00000235460','IL','1','hupp','corey','','','','34','296901468','4204 PORTOBELLO DR',0,'COLUMBUS','OH','43230','5417','CY','39049','1987-01-19','M','U',':RET:2106-3','N','021','DEN','125659','99734OH005000401','2014-01-01','2013-12-15 14:07:32','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:29'),(18647,14866,'Y','18','024','14','A','','','TE','0000093582','0000093582','','IL','1','Barker','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-05','M','',NULL,NULL,NULL,'','2073132','','2014-01-16','2014-01-16 01:26:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:09'),(9424,7477,'Y','18','021','EC','A','','','AC','0000825449','0000825449','TX00000728245','31','1','PHAM','Mc','','','','34','479271409','4530 VILLAGE PARK DR.',0,'PASADENA','TX','77504',NULL,'CY','48201','1974-02-07','M','M',':RET:2047-9','N','021','DEN','1418673','33348TX002000201','2014-01-01','2013-12-21 16:50:41','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:33:12'),(15286,12221,'Y','18','021','EC','A','','','AC','0000624024','0000624024','MS00001915592','IL','1','ROBERTSON','JERRY','','','','34','587809230','16277 MISSISSIPPI HWY 17',0,'COILA','MS','38923',NULL,'CY','28015','1955-01-27','M','M',NULL,'N','021','DEN','1843869','46300MS002000101','2014-02-01','2013-12-31 20:33:56','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2014-01-02 04:22:18'),(22036,17590,'Y','18','021','EC','A','','','AC','0001237747','0001237747','OH00001678241','IL','1','Young','Bruce','','','','34','297508395','1018 Richardson Road',0,'Seamon','OH','45679',NULL,'CY','39071','1951-07-14','M','U',':RET:2106-3','N','021','HLT','3238372','92036OH002000601','2014-03-01','2014-02-07 16:12:33','430.00',NULL,NULL,'712.24','282.24','R-OH005','OH0','712.24',NULL,0,'2014-02-07 19:01:05'),(23831,18962,'Y','18','021','EC','A','','','AC','0001077639','0001077639','MS00002401770','IL','1','Pearson','Dania','','','','34','587697429','853 SERVILLE DR',0,'JACKSON','MS','39206','4209','CY','28049','1983-08-12','F','U',':RET:2054-5','N','021','DEN','3161361','46300MS002000101','2014-03-01','2014-02-14 02:15:52','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-14 21:31:46'),(25637,20338,'Y','18','021','EC','A','','','AC','0002128636','0002128636','LA00002082370','31','1','David','Eloise','','','','34','437081429','P.o. Box 781',0,'Carencro','LA','70520',NULL,'CY','22055','1963-01-01','F','U',':RET:2106-3','N','021','DEN','2729400','18575LA002000201','2014-04-01','2014-02-21 22:35:11','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-02-26 08:30:28'),(26529,21037,'Y','18','024','14','A','','','TE','0000381138','0000381138','','IL','1','Jefferson','Harriet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-14','F','',NULL,NULL,NULL,'','2252738','','2014-02-28','2014-02-28 16:04:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:27'),(284,234,'Y','18','021','EC','A','','','AC','0000103850','0000103850','OH00000802014','IL','1','Grove','Peggy','','','','34','292620834','1577 BROWN RD',0,'WILMINGTON','OH','45177','8730','CY','39027','1959-02-21','F','U',NULL,'N','021','DEN','76406','99734OH005000301','2014-01-01','2013-10-12 12:21:04','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 17:30:22'),(18531,14778,'Y','18','021','EC','A','','','AC','0000642095','0000642095','OH00001627967','IL','1','Gravett','Kevin','','','','34','300825443','7100 Hamilton Ave.',0,'Cincinnati','OH','45231',NULL,'CY','39061','1970-09-30','M','U',':RET:2106-3','N','021','HLT','2034899','92036OH005001205','2014-02-01','2014-01-15 13:27:42','170.00',NULL,NULL,'291.30','121.30','R-OH004','OH0','291.30',NULL,0,'2014-01-16 08:46:43'),(5598,4443,'Y','18','021','EC','A','','','AC','0000163099','0000163099','LA00000509110','IL','1','crochet','erlin','','','','34','439942861','15081 chenal road',0,'Jarreau','LA','70749',NULL,NULL,NULL,'1954-02-17','M','M',':RET:2106-3','N','021','DEN','1080882','18575LA002000201','2014-01-01','2013-11-26 12:32:11','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:30:10'),(5380,4267,'Y','18','021','EC','A','','','AC','0002326329','0002326329','LA00000358527','IL','1','BROWN','LA TOYA','','','','34','436391194','1048 CLAIRISE CT',0,'SLIDELL','LA','70461','3567','CY','22103','1975-06-17','F','U',':RET:2054-5','N','021','DEN','1722766','18575LA002000201','2014-01-01','2013-12-19 15:31:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:20'),(360,297,'Y','18','021','EC','A','','','AC','0000912237','0000912237','TX00001170645','IL','1','Hendrix','Lori','','','','34','456117308','198 COUNTY ROAD SE 4115',0,'MOUNT VERNON','TX','75457','6928','CY','48159','1961-08-29','F','M',':RET:2106-3','N','021','DEN','40383','33348TX002000201','2014-01-01','2013-12-03 18:16:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:45:08'),(9600,7603,'Y','18','021','EC','A','','','AC','0000005828','0000005828','OH00000059040','IL','1','Trbovich','Gregory','M','','','34','294480273','1019 35TH ST NW',0,'CANTON','OH','44709','2606','CY','39151','1950-04-26','M','U',':RET:2106-3','N','021','HLT','1799138','52664OH151001304','2014-01-01','2013-12-21 10:16:38','375.00',NULL,NULL,'658.32','283.32','R-OH015','OH0','658.32',NULL,0,'2013-12-26 04:37:23'),(1518,1266,'N','01','021','EC','A',NULL,NULL,'','0000520962','0000529446','','IL','1','DERECSKEY','Brent','','','','34','293903754','8120 CLOVER LN',0,'GARRETTSVILLE','OH','44231','1056','CY','39133','1984-05-09','M','',':RET:2106-3','N','021','DEN','2149566','99734OH005000401','2014-01-01','2013-12-24 14:26:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:43'),(7401,5857,'Y','18','021','EC','A','','','AC','0000680804','0000680804','OH00001130605','IL','1','CLOSSON','MICHAEL','','','','34','293468478','1284 S BREDEICK ST',0,'DELPHOS','OH','45833','2299','CY','39161','1949-12-07','M','M',':RET:2106-3','N','021','HLT','81544','92036OH006001501','2014-01-01','2013-11-23 08:24:32','1017.57',NULL,NULL,'1025.07','7.49','R-OH002','OH0','523.61',NULL,0,'2013-12-26 02:16:26'),(21612,17256,'Y','18','021','EC','A','','','AC','0000298272','0000298272','OH00001539608','IL','1','Rees','Catherine','','','','34','288669510','6870 BRYANT LN',0,'SEVEN HILLS','OH','44131','3602','CY','39035','1973-06-14','F','R',':RET:2106-3','N','021','DEN','3202674','99734OH005000301','2014-03-01','2014-02-05 16:13:54','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:34'),(25997,20618,'Y','18','021','EC','A','','','AC','0001944662','0001944662','LA00002199563','31','1','Crocker','Kenneth','','','','34','439989834','PO Box 57',0,'Grand Cane','LA','71032',NULL,'CY','22031','1957-04-01','M','M',NULL,'N','021','DEN','2646635','18575LA002000101','2014-04-01','2014-02-26 09:42:41','0.00',NULL,NULL,'50.04','50.04','R-LA008','LA0','25.02',NULL,0,'2014-02-26 21:02:01'),(2455,1997,'Y','18','021','EC','A','','','AC','0000807068','0000807068','TX00001028485','IL','1','BLACK','GERALD','','','','34','525231522','1485 LAKEVIEW DR',0,'ST PAUL','TX','75098','4745','CY','48085','1963-06-16','M','M',':RET:2106-3','N','021','DEN','284551','33348TX002000101','2014-01-01','2013-12-09 12:22:25','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:34:45'),(7918,6261,'Y','18','021','EC','A','','','AC','0002269520','0002269520','LA00000672540','IL','1','selva','holly','','','','34','039549381','10404 RICKY BURCH LN',0,'TICKFAW','LA','70466','3406','CY','22105','1975-08-02','F','U',':RET:2028-9^:RET:2106-3','N','021','DEN','1818785','18575LA002000201','2014-01-01','2013-12-19 23:01:31','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:06:15'),(9040,7172,'Y','18','021','EC','A','','','AC','0000987388','0000987388','OH00000238102','IL','1','Vanke','Dennis','','','','34','271542348','404 35TH ST SW',0,'BARBERTON','OH','44203','7713','CY','39153','1953-02-06','M','M',':RET:2106-3','N','021','HLT','2139753','52664OH151001305','2014-01-01','2013-12-18 15:27:30','460.00',NULL,NULL,'605.24','145.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 04:05:47'),(9113,7230,'N','01','021','EC','A',NULL,NULL,'','0000814273','0001151070','','IL','1','Hall','Nicole','','','','34','280662287','26 Virginia Avenue',0,'Centerville','OH','45458',NULL,'CY','39113','1974-07-08','F','',':RET:2106-3','N','021','DEN','1840295','99734OH005000301','2014-01-01','2013-12-18 15:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:35'),(16482,13190,'N','01','021','EC','A',NULL,NULL,'','0001032621','0000246462','','IL','1','laurianti','jean','m','','','34','142662087','8591 SHORTHORN DR',0,'SAGAMORE HILLS','OH','44067','3228','CY','39153','1962-05-27','F','',NULL,'N','021','HLT','2422391','52664OH151001306','2014-02-01','2014-01-06 14:54:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2014-01-07 04:06:18'),(13775,10995,'Y','18','021','EC','A','','','AC','0000333498','0000333498','MS00000412011','IL','1','Braud','Meta','','','','34','537600605','937 SAINT ANN ST',0,'GAUTIER','MS','39553','4040','CY','28059','1956-08-20','F','U',':RET:2039-6^:RET:2106-3','T','021','DEN','1932436','46300MS002000201','2014-01-01','2013-12-23 14:58:56','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 13:10:35'),(14162,11289,'Y','18','021','EC','A','','','AC','0001316597','0001316597','LA00000031900','IL','1','Manning','Latrice','','','','34','434678270','2814 DICK TAYLOR ST',0,'MONROE','LA','71202','3218','CY','22073','1987-09-08','F','U',':RET:2054-5','N','021','DEN','2439682','18575LA002000201','2014-02-01','2013-12-26 15:55:28','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-27 02:03:11'),(23289,18566,'Y','18','021','EC','A','','','AC','0000991588','0000991588','OH00002200518','IL','1','Whitman','Kyle','','','','34','269884274','82 ACTON RD',0,'COLUMBUS','OH','43214','3302','CY','39049','1987-04-21','M','U',':RET:2106-3','N','021','DEN','2920970','99734OH005000301','2014-03-01','2014-02-12 21:29:21','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:06'),(4691,3719,'Y','18','021','EC','A','','','AC','0001020401','0001020401','OH00000656425','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',NULL,'N','021','HLT','597882','92036OH005000506','2014-01-01','2013-12-12 09:01:17','0.00',NULL,NULL,'424.53','424.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 22:08:11'),(4561,3611,'Y','18','021','EC','A','','','AC','0000266518','0000266518','OH00000643756','IL','1','Donaldson','Lori','','','','34','297606345','1709 Root Avenue NE',0,'Canton','OH','44705',NULL,'CY','39151','1961-08-26','F','U',':RET:2106-3','T','021','HLT','469353','52664OH152000901','2014-01-01','2013-12-12 16:52:21','288.00',NULL,NULL,'366.67','78.67','R-OH015','OH0','366.67',NULL,0,'2013-12-25 22:04:42'),(7362,5830,'Y','18','021','EC','A','','','AC','0000263108','0000263108','MS00001214910','IL','1','Knight','Marquis','','','','34','426514406','6300 OLD CANTON RD',0,'JACKSON','MS','39211','2441','CY','28049','1984-12-04','M','U',':RET:2054-5','T','021','DEN','631744','46300MS002000201','2014-01-01','2013-11-22 20:25:47','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 02:15:25'),(20292,16197,'Y','18','021','EC','A','','','AC','0001890806','0001890806','LA00001861377','IL','1','Maurin','Erica','','','','34','439615055','1938 Longwood Court',0,'LaPlace','LA','70068',NULL,'CY','22095','1983-12-01','F','U',':RET:2106-3','N','021','DEN','2681752','18575LA002000201','2014-03-01','2014-01-28 11:51:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-28 21:00:37'),(20049,15990,'Y','18','021','EC','A','','','AC','0001071713','0001071713','TX00001629622','IL','1','Omer','Restem','','','','34','645179203','8330 POTRANCO RD',0,'SAN ANTONIO','TX','78251','2995','CY','48029','1974-03-14','M','M',':RET:2054-5','N','021','DEN','2943792','33348TX002000201','2014-03-01','2014-01-26 18:46:50','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-01-27 21:00:04'),(14215,11334,'N','01','021','EC','A',NULL,NULL,'','0000151687','0000810606','','IL','1','Smith','Charles','Bradley','','','34','460755105','17906 BUTTE CREEK RD',0,'HOUSTON','TX','77090','1816','CY','48201','1971-04-20','M','',':RET:2106-3','N','021','DEN','2425613','33348TX002000201','2014-02-01','2013-12-26 15:49:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-27 02:04:35'),(14775,11798,'Y','18','021','EC','A','','','AC','0000796950','0000796950','TX00000023074','IL','1','Reidy','William','','','','34','123608128','22231 Flanagan cr',0,'Frisco','TX','75034',NULL,'CY','48121','1972-08-26','M','U',':RET:2106-3','N','021','DEN','2433383','33348TX002000201','2014-01-01','2013-12-23 20:29:28','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2013-12-29 11:13:03'),(22475,17946,'N','19','021','EC','A',NULL,NULL,'','0000505768','0000072921','','IL','1','Lindhorst','Paul','James','','','34','330355536','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','2013-04-22','M','',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:01'),(24726,19632,'Y','18','021','EC','A','','','AC','0000720297','0000720297','OH00002854339','IL','1','SUBER','KATRINA','','','','34','298709971','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1976-02-22','F','U',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:38:48'),(26807,21244,'Y','18','021','EC','A','','','AC','0001066042','0001066042','OH00003180270','IL','1','ALLAN','NAZEK','','','','34','068609305','4027 SHELLEY DR',0,'NORTH OLMSTED','OH','44070','1947','CY','39035','1962-02-08','F','M',NULL,'N','021','DEN','3395691','99734OH005000301','2014-04-01','2014-03-01 11:39:16','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:26'),(27659,21877,'Y','18','021','EC','A','','','AC','0000788261','0000788261','OH00002681053','IL','1','stuhldreher','heather','','','','34','292600780','617 EDGEHILL AVE',0,'ASHLAND','OH','44805','4117','CY','39005','1976-09-20','F','U',':RET:2106-3','T','021','DEN','2998058','99734OH005000401','2014-04-01','2014-03-05 14:47:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:26'),(25,20,'Y','18','021','EC','A','','','AC','0000809646','0000809646','OH00000374388','IL','1','Kamu','Richard','k','','','34','024869399','8356 ANTHONY WAYNE AVE',0,'CINCINNATI','OH','45216','1232','CY','39061','1967-11-17','M','M',':RET:2054-5','N','021','DEN','947850','99734OH005000401','2014-01-01','2013-12-05 16:29:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:37'),(6288,4987,'Y','18','021','EC','A','','','AC','0000907999','0000907999','OH00000246915','IL','1','Nott','Diane','','','','34','298768534','418 FRANCES BLVD',0,'ELYRIA','OH','44035','4165','CY','39093','1967-05-02','F','U',NULL,'N','021','DEN','715279','99734OH005000401','2014-01-01','2013-12-10 22:55:46','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:34'),(1942,1582,'Y','18','021','EC','A','','','AC','0000115455','0000115455','OH00001142922','IL','1','Dolejs','Jennifer','','','','34','284809660','8543 RAVENSWOOD LN',0,'MACEDONIA','OH','44056','1743','CY','39153','1983-06-04','F','U',':RET:2106-3','N','021','DEN','752115','99734OH005000401','2014-01-01','2013-11-20 11:42:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:00:42'),(7956,6296,'Y','18','024','14','A','','','TE','0000662673','0000662673','','IL','1','Beck','David','M','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-05','M','',NULL,NULL,NULL,'','1095596','','2013-12-19','2013-12-19 19:29:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:07:19'),(17861,14268,'Y','18','021','EC','A','','','AC','0000869302','0000869302','OH00002126796','IL','1','VANGURI','INDIRA','','','','34','296962335','6073 HEATHER LANE',0,'HUDSON','OH','44236',NULL,'CY','39153','1966-08-30','F','U',NULL,'N','021','DEN','2246185','99734OH005000401','2014-02-01','2014-01-14 11:22:42','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:10'),(16900,13523,'Y','18','021','EC','A','','','AC','0001246955','0001246955','OH00001731286','IL','1','WOLLERMAN','RENEE','','','','34','283887274','2866 FINDLEY AVE',0,'COLUMBUS','OH','43202','2320','CY','39049','1974-09-05','F','U',NULL,'N','021','DEN','2282235','99734OH005000401','2014-02-01','2014-01-09 10:47:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:19:32'),(9806,7765,'Y','18','021','EC','A','','','AC','0000389807','0000389807','OH00000141979','IL','1','Bodenmiller','Dustin','','','','34','278849762','133 E 3RD ST',0,'SPRINGFIELD','OH','45504','1452','CY','39023','1986-01-08','M','U',':RET:2106-3','T','021','HLT','978256','92036OH004000501','2014-01-01','2013-10-21 07:45:57','0.00',NULL,NULL,'230.35','230.35','R-OH003','OH0','230.35',NULL,0,'2013-12-26 05:01:22'),(21826,17428,'Y','18','024','14','A','','','TE','0000825672','0000825672','','IL','1','Blackmon','Jeremy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-10','M','',NULL,NULL,NULL,'','3697795','','2014-02-06','2014-02-06 13:46:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-06 21:01:01'),(22136,17668,'Y','18','021','EC','A','','','AC','0000493274','0000493274','OH00002221415','IL','1','Gilmore','Ann','','','','34','285847186','800 BRICK MILL RUN',0,'WESTLAKE','OH','44145','1606','CY','39035','1982-03-16','F','M',':RET:2106-3','N','021','DEN','3345757','99734OH005000401','2014-03-01','2014-02-08 16:03:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-08 19:00:46'),(23753,18907,'N','01','021','EC','A',NULL,NULL,'','0000221362','0000870673','','IL','1','Dahl','Erik','Albin','','','34','044766209','961 MCCLAIN RD',0,'GRANDVIEW HEIGHTS','OH','43212','3706','CY','39049','1976-01-08','M','',':RET:2106-3','N','021','DEN','2644067','99734OH005000301','2014-03-01','2014-02-14 11:21:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:07'),(28472,22530,'Y','18','021','EC','A','','','AC','0000310865','0000310865','OH00003559058','IL','1','Ross','Kevin','','','','34','164420843','5708 Terrace Park Drive',0,'Kettering','OH','45429',NULL,'CY','39113','1952-07-24','M','M',':RET:2106-3','N','021','DEN','3857494','99734OH005000301','2014-04-01','2014-03-07 08:55:04','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-03-07 21:31:32'),(4663,3697,'Y','18','021','EC','A','','','AC','0000524198','0000524198','LA00001056093','IL','1','toom','taher','','','','34','065726847','14055 tricou blvd',0,'hammond','LA','70403',NULL,'CY','22105','1964-08-25','M','M',NULL,'N','021','DEN','520000','18575LA002000201','2014-01-01','2013-12-12 12:21:23','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:07:26'),(7177,5691,'Y','18','021','EC','A','','','AC','0000166359','0000166359','OH00000154017','IL','1','Barney','Erica','','','','34','285844199','644 E POSSUM RD',0,'SPRINGFIELD','OH','45502','9403','CY','39023','1983-09-25','F','M',':RET:2106-3','N','021','DEN','145759','99734OH005000301','2014-01-01','2013-12-13 21:02:49','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:00:06'),(6911,5485,'Y','18','021','EC','A','','','AC','0001233909','0001233909','LA00000669256','IL','1','Watts','Joyce','','','','34','439843237','25020 PIN OAK AVE',0,'PLAQUEMINE','LA','70764','7522','CY','22047','1954-03-13','F','U',':RET:2054-5','N','021','DEN','2290785','18575LA002000201','2014-02-01','2013-12-25 00:29:28','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:55'),(5902,4675,'N','01','021','EC','A',NULL,NULL,'','0000130699','0001169448','','IL','1','Stanic','Riste','','','','34','286066248','7013 STATE RD',0,'PARMA','OH','44134','4950','CY','39035','1965-01-21','M','',':RET:2106-3','N','021','DEN','1366867','99734OH005000301','2014-01-01','2013-12-23 23:36:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:47'),(20659,16510,'Y','18','021','EC','A','','','AC','0001233186','0001233186','TX00001416136','31','1','Soto','Humberto','','','','34','457570926','P O BOX 751',0,'Cotulla','TX','78014',NULL,'CY','48283','1964-04-07','M','M',NULL,'N','021','DEN','3434979','33348TX002000201','2014-03-01','2014-01-30 17:21:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:43'),(19766,15756,'Y','18','024','14','A','','','TE','0000006450','0000006450','','IL','1','Johnson','Earline',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-05-23','F','',NULL,NULL,NULL,'','1707500','','2014-01-23','2014-01-23 11:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-23 21:01:26'),(19242,15332,'N','01','021','EC','A',NULL,NULL,'','0000301912','0000626760','','IL','1','Foit','Debra','','','','34','273586506','2771 STATE ROUTE 14',0,'ROOTSTOWN','OH','44272','9801','CY','39133','1958-09-07','F','',':RET:2106-3','N','021','HLT','1415868','52664OH151001501','2014-03-01','2014-01-19 21:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','596.45',NULL,0,'2014-01-21 08:46:38'),(19121,15235,'Y','18','021','EC','A','','','AC','0001506566','0001506566','LA00002524306','IL','1','Crow','Janet','','','','34','435152585','70515 Fuchsia St',0,'Abita Springs','LA','70420',NULL,'CY','22103','1957-12-18','F','U',':RET:2106-3','N','021','DEN','1983466','18575LA002000101','2014-03-01','2014-01-19 17:23:05','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-21 08:45:17'),(18904,15063,'Y','18','021','EC','A','','','AC','0001004364','0001004364','OH00001634252','IL','1','Nay','Shayna','','','','34','299888338','729 E MAIN ST',0,'BELLEVUE','OH','44811','1550','CY','39077','1988-03-01','F','M',':RET:2106-3','T','021','HLT','1516552','92036OH004002701','2014-02-01','2014-01-15 19:05:33','0.00',NULL,NULL,'181.04','181.04','R-OH006','OH0','181.04',NULL,0,'2014-01-17 03:36:37'),(27344,21652,'Y','18','021','EC','A','','','AC','0000230505','0000230505','OH00002611852','IL','1','MCARTHUR','STEVE','JOHN','','','34','279546208','1809 ARNOLD AVE NW',0,'CANTON','OH','44709',NULL,'CY','39151','1953-03-14','M','U',':RET:2106-3','N','021','DEN','3346369','99734OH005000401','2014-04-01','2014-03-04 10:27:20','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-04 21:01:00'),(28852,22831,'N','01','021','EC','A',NULL,NULL,'','0000715030','0000328470','','IL','1','Peterson','Stephanie','','','','34','323425823','05009 County Road 33 A',0,'Saint Marys','OH','45885',NULL,'CY','39011','1954-07-14','F','',':RET:2106-3','N','021','HLT','3157209','92036OH005001504','2014-04-01','2014-03-09 15:14:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','572.89',NULL,0,'2014-03-09 21:01:19'),(25360,20122,'Y','18','021','EC','A','','','AC','0000234106','0000234106','OH00002346290','IL','1','Saladino','John','','','','34','299025252','6391 WILLOW BROOKE DR',0,'LIBERTY TWP','OH','45011','0401','CY','39017','1992-08-29','M','U',':RET:2036-2','N','021','DEN','3790021','99734OH005000301','2014-04-01','2014-02-24 21:43:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:35'),(13884,11076,'N','19','021','EC','A',NULL,NULL,'','0000685845','0001004337','','IL','1','Evans','Emilie','Louise','','','34','277065459','18300 PARKLAND DR',0,'SHAKER HEIGHTS','OH','44122','3449','CY','39035','2001-03-02','F','',':RET:2106-3','N','021','HLT','1935254','52664OH151001501','2014-01-01','2013-12-23 17:12:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-26 13:13:21'),(13855,11055,'N','01','021','EC','A',NULL,NULL,'','0001212341','0001001157','','IL','1','Barrett','Shelly','Renee','','','34','302766619','2407 QUEEN AVE',0,'MIDDLETOWN','OH','45044','4737','CY','39017','1971-03-12','F','',':RET:2106-3','N','021','HLT','2064259','92036OH006001201','2014-01-01','2013-12-22 20:21:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','225.58',NULL,0,'2013-12-26 13:12:39'),(13450,10725,'Y','18','021','EC','A','','','AC','0000921906','0000921906','OH00001136439','IL','1','adkins','Brandon','','','','34','296928732','11592 MELROSE CIR NW',0,'UNIONTOWN','OH','44685','8250','CY','39151','1986-02-07','M','U',':RET:2106-3','N','021','DEN','2162995','99734OH005000301','2014-01-01','2013-12-23 14:21:14','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 13:01:27'),(13368,10678,'Y','18','021','EC','A','','','AC','0000665595','0000665595','OH00000552130','IL','1','MEEKER','JASON','','','','34','285866602','60 MAYWOOD ST',0,'LUCASVILLE','OH','45648','8812','CY','39145','1977-10-08','M','U',':RET:2106-3','N','021','DEN','2589880','99734OH005000301','2014-01-01','2013-12-22 21:20:00','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-26 12:59:42'),(3295,2655,'Y','18','021','EC','A','','','AC','0000471013','0000471013','OH00000884758','IL','1','Solmo','Thomas','','','','34','267273676','1065 Reimer Rd.',0,'Wadsworth','OH','44281',NULL,'CY','39103','1956-03-05','M','U',':RET:2106-3','N','021','DEN','1632153','99734OH005000301','2014-01-01','2013-12-22 10:01:23','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:15:35'),(21893,17482,'Y','18','021','EC','A','','','AC','0001037583','0001037583','MS00001526867','IL','1','DAVIS','DENISE','','','','34','427045782','619 Citizen Street',0,'Bay St Louis','MS','39520',NULL,'CY','28045','1955-07-10','F','U',':RET:2054-5','N','021','DEN','3504352','46300MS002000201','2014-03-01','2014-02-06 10:34:46','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-06 21:01:40'),(21653,17292,'Y','18','021','EC','A','','','AC','0001183208','0001183208','LA00002473817','IL','1','Johnson','Joseph','','','','34','438292453','1749 73RD AVE',0,'BATON ROUGE','LA','70807','5813','CY','22033','1973-08-23','M','M',NULL,'N','021','DEN','2900453','18575LA002000201','2014-03-01','2014-02-04 21:18:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:51'),(19196,15293,'N','19','021','EC','A',NULL,NULL,'','0000427340','0000271811','','S1','1','WADE','STACY','','','','34','631526871','2610 CODY CT',0,'MIDLOTHIAN','TX','76065',NULL,'CY','48139','1996-03-09','F','',NULL,'N','021','DEN','2105914','33348TX002000101','2014-03-01','2014-01-20 14:18:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-21 08:46:14'),(5016,3975,'Y','18','021','EC','A','','','AC','0000933185','0000933185','OH00000821258','IL','1','PIOTROWSKI','WILLIAM','','','Jr','34','283643374','4323 PACKARD RD',0,'TOLEDO','OH','43612','1941','CY','39095','1956-12-29','M','U',':RET:2106-3','N','021','HLT','873472','92036OH004002601','2014-01-01','2013-12-07 05:47:54','0.00',NULL,NULL,'382.11','382.11','R-OH001','OH0','382.11',NULL,0,'2013-12-25 22:47:25'),(17674,14124,'Y','18','021','EC','A','','','AC','0001849670','0001849670','LA00001649288','IL','1','vidrine','joanie','','','','34','438256900','5739 Hidden Ridge lane',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1963-12-30','F','U',':RET:1002-5','N','021','DEN','2100678','18575LA002000101','2014-02-01','2014-01-13 12:35:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-14 01:32:51'),(28583,22621,'Y','18','024','14','A','','','TE','0001100653','0001100653','','IL','1','Lewis','Kathleen','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-30','F','',NULL,NULL,NULL,'','4205570','','2014-03-08','2014-03-08 13:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-08 21:00:09'),(24707,19616,'Y','18','021','EC','A','','','AC','0000089877','0000089877','OH00002764978','IL','1','Phillips','Rhonda','','','','34','284689766','2739 TownTerrace',0,'Cincinnati','OH','45251',NULL,'CY','39061','1963-01-29','F','U',':RET:2054-5','N','021','DEN','3187442','99734OH005000401','2014-04-01','2014-02-19 00:11:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:35:18'),(1589,1327,'Y','18','021','EC','A','','','AC','0000097483','0000097483','TX00001517355','IL','1','Goetz','Virginia','martin','','','34','250134717','17024 NE COUNTY ROAD 3140',0,'KERENS','TX','75144','5058','CY','48349','1957-12-10','F','M',':RET:2106-3','T','021','DEN','1828728','33348TX002000201','2014-01-01','2013-12-24 11:32:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:41'),(7542,5968,'Y','18','021','EC','A','','','AC','0000009928','0000009928','TX00001154564','31','1','Flores','Maria','','','','34','637164859','P.O. Box 811',0,'Flatonia','TX','78660',NULL,'CY','48149','1950-12-22','F','M',':RET:2106-3','N','021','DEN','749951','33348TX002000201','2014-01-01','2013-12-15 14:21:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:32:56'),(23634,18819,'N','01','021','EC','A',NULL,NULL,'','0000904971','0000149525','','IL','1','CERRILLO','ADAN','','','','34','643071688','808 BRADLEY DR',0,'ATHENS','TX','75751','2949','CY','48213','1974-05-14','M','',NULL,'N','021','DEN','2865601','33348TX002000201','2014-03-01','2014-02-13 18:24:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-14 21:30:04'),(20395,16291,'N','19','021','EC','A',NULL,NULL,'','0000807338','0000369566','','IL','1','Tran','Kathy','','','','34','636092563','11963 Silver Island Circle',0,'Houston','TX','77067',NULL,'CY','48201','1989-06-30','F','',':RET:2047-9','N','021','DEN','2954975','33348TX002000201','2014-03-01','2014-01-29 12:26:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-29 21:00:17'),(1615,1350,'Y','18','021','EC','A','','','AC','0000844675','0000844675','TX00000758781','IL','1','Light','Daniel','','','','34','462312154','1619 University Ave',0,'Lubbock','TX','79401',NULL,'CY','48303','1969-01-31','M','U',':RET:2106-3','N','021','DEN','1472929','33348TX002000201','2014-01-01','2013-12-24 13:14:48','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:52:26'),(2650,2153,'Y','18','021','EC','A','','','AC','0000766685','0000766685','TX00000019674','IL','1','Davis','Judy','Marie','','','34','572789534','1815 BILLINGS RD',0,'TOLAR','TX','76476','5343','CY','48221','1950-01-01','F','M',NULL,'N','021','DEN','274248','33348TX002000101','2014-01-01','2013-12-02 15:35:50','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:46:35'),(19846,15828,'N','01','021','EC','A',NULL,NULL,'','0001245200','0001368885','','IL','1','Leitch','Stacey','','','','34','439474722','726 Cotton Street',0,'Shreveport','LA','71101',NULL,'CY','22017','1978-04-29','F','',':RET:2106-3','N','021','DEN','3194632','18575LA002000201','2014-03-01','2014-01-24 10:15:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-24 21:00:28'),(16664,13335,'Y','18','021','EC','A','','','AC','0001661906','0001661906','LA00002084273','IL','1','Lain','Cassandra','','','','34','439237772','5103 Blanks Street',0,'Monroe','LA','71203',NULL,'CY','22073','1965-07-31','F','U',':RET:2054-5','N','021','DEN','1947025','18575LA002000101','2014-02-01','2014-01-07 13:16:35','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-08 18:24:26'),(3749,2999,'Y','18','021','EC','A','','','AC','0000760852','0000760852','TX00000500966','31','1','mccaffrey','timothy','','','','34','457979454','328 e 11th st',0,'new york','NY','10003',NULL,'CY','48453','1977-01-05','M','U',NULL,'N','021','DEN','637024','33348TX002000201','2014-01-01','2013-12-13 14:52:54','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:33:07'),(14538,11601,'Y','18','021','EC','A','','','AC','0000178547','0000178547','MS00001567279','IL','1','WILLIAMS','MARY','','','','34','587262705','255 TUCKER RD',0,'HOLLY SPRINGS','MS','38635','8336','CY','28093','1950-01-05','F','U',':RET:2054-5','T','021','DEN','1465063','46300MS002000201','2014-02-01','2013-12-27 12:14:52','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-28 03:34:45'),(16432,13148,'Y','18','021','EC','A','','','AC','0000364901','0000364901','OH00001687237','IL','1','Walters','Paula','','','','34','287782314','120 Church St',0,'Hamler','OH','43524',NULL,'CY','39069','1973-10-20','F','U',':RET:2106-3','N','021','HLT','1966065','92036OH006002601','2014-02-01','2014-01-05 19:11:01','174.00',NULL,NULL,'197.64','23.64','R-OH001','OH0','197.64',NULL,0,'2014-01-07 04:04:50'),(16416,13138,'Y','18','021','EC','A','','','AC','0000168905','0000168905','OH00002376821','IL','1','Butcher','Nancy','','','','34','236847520','6918 WHITE PINE DR',0,'RAVENNA','OH','44266','8983','CY','39133','1954-05-27','F','M',':RET:2106-3','N','021','HLT','2088781','52664OH151001501','2014-02-01','2014-01-06 15:56:52','612.00',NULL,NULL,'1382.13','770.13','R-OH012','OH0','696.21',NULL,0,'2014-01-07 04:04:24'),(25979,20603,'N','01','021','EC','A',NULL,NULL,'','0000823570','0000774030','','IL','1','heald','amanda','','','','34','294902483','20901 CLUTTER RD',0,'UTICA','OH','43080','9609','CY','39083','1989-12-11','F','',NULL,'N','021','DEN','3439684','99734OH005000401','2014-04-01','2014-02-26 16:27:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:51'),(26599,21089,'Y','18','021','EC','A','','','AC','0000479978','0000479978','TX00003037572','IL','1','Jones','Maria','Jesus Victoria','','','34','643526239','1861 LYMAN DUTTON CIR',0,'EL PASO','TX','79936','0908','CY','48141','1954-01-16','F','U',NULL,'N','021','DEN','2985481','33348TX002000201','2014-04-01','2014-02-27 19:06:06','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:30:40'),(26747,21196,'Y','18','021','EC','A','','','AC','0001031508','0001031508','OH00002825869','IL','1','SHOFFSTALL','JERRY','','','','34','300482013','4615 COUNTY RD 33A',0,'SAINT MARYS','OH','45885',NULL,'CY','39011','1951-05-04','M','M',':RET:2106-3','N','021','HLT','3159608','92036OH005001506','2014-04-01','2014-02-28 16:18:40','581.00',NULL,NULL,'632.30','51.30','R-OH002','OH0','632.30',NULL,0,'2014-02-28 21:31:57'),(27161,21506,'Y','18','021','EC','A','','','AC','0000659125','0000659125','TX00002531962','IL','1','Verdell','Charles','','','','34','461815803','138 MERRY WAY',0,'GUN BARREL CITY','TX','75156','5116','CY','48213','1968-12-02','M','U',':RET:2054-5','N','021','DEN','3680070','33348TX002000201','2014-04-01','2014-03-03 10:28:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:30:59'),(28139,22268,'Y','18','021','EC','A','','','AC','0001011621','0001011621','OH00003420037','IL','1','Walker','Jamarr','Equel','','Sr','34','284905805','4703 Vallejo Drive',0,'Toledo','OH','43615',NULL,'CY','39095','1989-06-16','M','U',NULL,'N','021','HLT','2812662','92036OH004002601','2014-04-01','2014-03-06 14:25:32','143.00',NULL,NULL,'156.79','13.79','R-OH001','OH0','156.79',NULL,0,'2014-03-06 21:02:29'),(28561,22604,'Y','18','024','14','A','','','TE','0000872020','0000872020','','IL','1','Meade','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-28','F','',NULL,NULL,NULL,'','688908','','2014-03-31','2014-03-07 13:58:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-07 21:32:26'),(25350,20115,'Y','18','021','EC','A','','','AC','0001499318','0001499318','LA00002479880','IL','1','Delcambre','Philip','','','','34','436194728','300 Dobbertine',0,'Lake Charles','LA','70607',NULL,'CY','22019','1961-02-24','M','U',NULL,'N','021','DEN','3541832','18575LA002000101','2014-04-01','2014-02-25 11:41:03','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-02-25 21:30:31'),(18220,14541,'Y','18','021','EC','A','','','AC','0001177566','0001177566','TX00002026152','IL','1','ORTIZ','MIGUEL','','','','34','466818004','5510 MESQUITE GROVE RD',0,'AUSTIN','TX','78744','4603','CY','48453','1982-05-05','M','U',NULL,'N','021','DEN','1662630','33348TX002000201','2014-02-01','2014-01-14 19:00:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-16 08:44:13'),(410,338,'Y','18','021','EC','A','','','AC','0000479812','0000479812','OH00000964462','IL','1','Geyer','Margaret','','','','34','285529566','1881 RIDGEBURY DR',0,'HILLIARD','OH','43026','8377','CY','39049','1952-05-21','F','U',NULL,'N','021','DEN','699494','99734OH005000401','2014-01-01','2013-12-04 15:10:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:24'),(5314,4214,'Y','18','021','EC','A','','','AC','0000449857','0000449857','OH00000526378','31','1','MYERS','BRENDA','SUE','','','34','297749659','P O Box 406',0,'Kingsville','OH','44048',NULL,'CY','39007','1963-07-30','F','U',':RET:2106-3','T','021','DEN','1387300','99734OH005000301','2014-01-01','2013-12-18 19:42:18','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:06:39'),(4344,3450,'Y','18','021','EC','A','','','AC','0000878253','0000878253','OH00000756943','IL','1','Schnipke','Shanna','','','','34','277842593','3723 road 16',0,'continental','OH','45831',NULL,'CY','39137','1984-08-27','F','M',':RET:2106-3','N','021','HLT','1431241','92036OH006001501','2014-01-01','2013-12-17 12:51:28','424.00',NULL,NULL,'623.47','199.47','R-OH002','OH0','195.31',NULL,0,'2013-12-25 21:53:20'),(28971,22929,'Y','18','021','EC','A','','','AC','0001829972','0001829972','LA00003257781','IL','1','Flemings','Robin','','','','34','439616806','6101 Tullis Dr',0,'New Orleans','LA','70131',NULL,'CY','22071','1986-10-27','F','U',':RET:2054-5','N','021','DEN','3976710','18575LA002000201','2014-04-01','2014-03-10 16:56:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:01:02'),(23390,18639,'Y','18','021','EC','A','','','AC','0001108139','0001108139','OH00002016182','IL','1','Broderick','Neva','','','','34','283429835','2901 STATE ROUTE 743',0,'MOSCOW','OH','45153','7302','CY','39025','1960-10-28','F','U',':RET:2106-3','N','021','DEN','2966493','99734OH005000401','2014-03-01','2014-02-13 14:39:06','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:01:04'),(21229,16965,'Y','18','021','EC','A','','','AC','0000149382','0000149382','OH00002153030','IL','1','Jacobsen','Neil','','','','34','320781714','1036 Rocky Brook Dr',0,'Akron','OH','44313',NULL,'CY','39153','1987-02-13','M','U',':RET:2106-3','N','021','DEN','3499289','99734OH005000301','2014-03-01','2014-02-03 10:39:26','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-03 21:01:08'),(13571,10824,'Y','18','021','EC','A','','','AC','0001152276','0001152276','LA00000477067','IL','1','Diettel','Gregory','','','','34','437232899','3808 PAGE DR',0,'METAIRIE','LA','70003','1416','CY','22051','1965-09-15','M','U',':RET:2106-3','N','021','DEN','2254176','18575LA002000201','2014-01-01','2013-12-23 17:07:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:40'),(18553,14795,'N','01','021','EC','A',NULL,NULL,'','0000331208','0000952270','','IL','1','Tims','Mary','','','','34','587230698','309 pine st',0,'lumberton','MS','39455',NULL,'CY','28073','1967-12-15','F','',':RET:2106-3','N','021','DEN','2770660','46300MS002000101','2014-02-01','2014-01-15 15:57:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-16 08:46:54'),(17597,14066,'Y','18','021','EC','A','','','AC','0001229492','0001229492','MS00001736472','IL','1','Anthony','Christopher','','','','34','425675765','1533 Fairwood Dr',0,'Jackson','MS','39213',NULL,'CY','28049','1986-09-22','M','U',':RET:2054-5','T','021','DEN','1572861','46300MS002000201','2014-02-01','2014-01-13 13:17:56','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-14 01:32:14'),(15483,12387,'Y','18','021','EC','A','','','AC','0000733603','0000733603','OH00001511377','IL','1','Roy','Jeffrey','','','','34','301622696','3350 SUNNYBROOK DR',0,'COLUMBUS','OH','43221','4707','CY','39049','1970-08-03','M','U',':RET:2106-3','N','021','DEN','1446955','99734OH005000401','2014-02-01','2013-12-31 09:21:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:13'),(3837,3069,'N','01','021','EC','A',NULL,NULL,'','0000663153','0000261009','','IL','1','Oliveira','Fredson','','','','34','660077276','1103 CAMBRONNE ST',0,'NEW ORLEANS','LA','70118','2019','CY','22071','1979-03-18','M','',NULL,'N','021','DEN','363138','18575LA002000101','2014-01-01','2013-12-13 17:51:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 21:35:18'),(28600,22634,'Y','18','021','EC','A','','','AC','0000350639','0000350639','OH00002823581','IL','1','Kolesar','Danielle','','','','34','294849212','4101 STONE RIDGE CIR',0,'BEREA','OH','44017','3110','CY','39035','1986-09-04','F','U',':RET:2106-3','N','021','DEN','3897613','99734OH005000401','2014-01-01','2014-03-08 11:25:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-08 21:30:08'),(997,817,'Y','18','024','14','A','','','TE','0001100562','0001100562','','IL','1','debord','dawn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-07','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-11-11 16:38:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:10:49'),(5622,4462,'Y','18','021','EC','A','','','AC','0000013742','0000013742','OH00000081103','IL','1','KANE','JOSEPH','','','','34','271809138','8703 OUTLOOK DR',0,'CLEVELAND','OH','44144','2444','CY','39035','1982-05-26','M','U',':RET:2106-3','T','021','DEN','264904','99734OH005000401','2014-01-01','2013-11-26 17:13:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:49'),(19479,15527,'Y','18','021','EC','A','','','AC','0000953797','0000953797','TX00002578466','IL','1','GUNERATNE','ARUNA','','','','34','612250388','1334 RED STAG PL',0,'ROUND ROCK','TX','78665','1359','CY','48491','1972-10-29','M','M',':RET:2028-9','N','021','DEN','3311003','33348TX002000201','2014-03-01','2014-01-22 17:10:21','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-23 03:02:03'),(4403,3500,'N','01','021','EC','A',NULL,NULL,'','0000447445','0000281988','','IL','1','MEIDT','WILLIAM','J','','','34','295526892','4811 LARKHAVEN DR',0,'TOLEDO','OH','43623','3053','CY','39095','1951-05-28','M','',':RET:2106-3','N','021','DEN','1187087','99734OH005000401','2014-01-01','2013-12-12 14:18:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:13'),(7902,6246,'N','01','021','EC','A',NULL,NULL,'','0000044264','0000398609','','IL','1','Reed','Melinda','','','','34','270646050','140 KESWICK DR',0,'MONROE','OH','45050','1457','CY','39017','1957-05-31','F','',':RET:2106-3','N','021','HLT','1668379','92036OH003001201','2014-01-01','2013-12-19 19:13:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','523.01',NULL,0,'2013-12-26 03:05:50'),(21878,17467,'Y','18','021','EC','A','','','AC','0001162300','0001162300','LA00001395806','IL','1','Myles','Sandra','','','','34','433135226','12851 CANTERBURY DR',0,'BATON ROUGE','LA','70814','7411','CY','22033','1959-04-20','F','U',NULL,'N','021','DEN','3231944','18575LA002000201','2014-03-01','2014-02-06 12:55:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-06 21:01:29'),(22416,17898,'N','01','021','EC','A',NULL,NULL,'','0002188711','0001499310','','IL','1','MONTERROSO','BLANCA','ESTELLA','','','34','434578466','648 MORNINGSIDE DR',0,'TERRYTOWN','LA','70056','2906','CY','22051','1958-07-25','F','',NULL,'N','021','DEN','2713006','18575LA002000201','2014-03-01','2014-02-10 13:26:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-10 21:30:28'),(23573,18781,'Y','18','021','EC','A','','','AC','0000116627','0000116627','OH00001914215','IL','1','Anderson','Bryan','','','','34','288940735','5334 DARLENE DR',0,'TOLEDO','OH','43615','4676','CY','39095','1987-08-17','M','U',NULL,'N','021','HLT','3851959','92036OH003002605','2014-03-01','2014-02-13 13:31:55','123.00',NULL,NULL,'208.52','85.52','R-OH001','OH0','208.52',NULL,0,'2014-02-13 22:02:53'),(24449,19421,'Y','18','021','EC','A','','','AC','0001624891','0001624891','LA00001713448','IL','1','Bruins','Janet','','','','34','436047346','3715 ORANGEFIELD DR',0,'ALEXANDRIA','LA','71302','4620','CY','22079','1955-11-03','F','M',':RET:2054-5','N','021','DEN','2684712','18575LA002000101','2014-04-01','2014-02-18 12:21:02','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-18 22:01:25'),(1891,1547,'Y','18','021','EC','A','','','AC','0001144773','0001144773','OH00000218031','IL','1','walley','katherine','','','','34','290927510','729 FRANCIS RD',0,'FELICITY','OH','45120','9152','CY','39015','1989-02-18','F','M',':RET:2106-3','N','021','HLT','1361199','92036OH004000601','2014-01-01','2013-12-24 12:15:29','348.00',NULL,NULL,'353.50','5.50','R-OH005','OH0','172.61',NULL,0,'2013-12-25 18:58:51'),(19774,15764,'Y','18','024','14','A','','','TE','0000823491','0000823491','','IL','1','Livers','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-08-29','F','',NULL,NULL,NULL,'','1238535','','2014-01-23','2014-01-23 15:56:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:30'),(5864,4654,'Y','18','021','EC','A','','','AC','0001207161','0001207161','OH00001024871','IL','1','Castle','Jason','','','','34','289782420','800 PERSHING AVE SE',0,'NORTH CANTON','OH','44720','3630','CY','39151','1974-06-17','M','U',':RET:2106-3','T','021','HLT','2489247','52664OH152000901','2014-01-01','2013-12-23 21:08:56','19.00',NULL,NULL,'237.06','218.06','R-OH015','OH0','237.06',NULL,0,'2013-12-25 23:49:04'),(5782,4593,'N','01','021','EC','A',NULL,NULL,'','0000645975','0001149870','','IL','1','ECK','JENNIFER','','','','34','295866888','1065 NORTHFIELD PLASE S',0,'REYNOLDSBURG','OH','43068',NULL,'CY','39049','1985-01-18','F','',':RET:2106-3','N','021','DEN','2261464','99734OH005000401','2014-01-01','2013-12-23 23:24:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:47:05'),(2227,1833,'Y','18','021','EC','A','','','AC','0001216239','0001216239','OH00000396568','IL','1','BISHOP','TERRY','','','','34','270546819','8684 S TOWNSHIP RD 191',0,'NEW WASHINGTON','OH','44854',NULL,'CY','39147','1953-06-13','M','M',':RET:2106-3','N','021','HLT','1256957','92036OH003002706','2014-01-01','2013-12-10 16:04:37','487.00',NULL,NULL,'552.66','65.66','R-OH006','OH0','552.66',NULL,0,'2013-12-25 19:20:41'),(2706,2191,'Y','18','021','EC','A','','','AC','0000685279','0000685279','TX00000705537','IL','1','Mireles','Andres','','','','34','635101291','1112 JUSTICE AVE',0,'LUBBOCK','TX','79416','5941','CY','48303','1987-02-05','M','M',':RET:2106-3','N','021','DEN','938393','33348TX002000201','2014-01-01','2013-12-02 16:25:29','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 19:47:51'),(13698,10928,'Y','18','021','EC','A','','','AC','0000706192','0000706192','OH00001160494','IL','1','Rodgers','Linda','','','','34','299524138','955 DONALD AVE',0,'AKRON','OH','44306','3503','CY','39153','1951-07-17','F','M',':RET:2106-3','N','021','HLT','1482558','52664OH151001304','2014-01-01','2013-12-23 11:46:21','418.00',NULL,NULL,'640.70','222.70','R-OH012','OH0','640.70',NULL,0,'2013-12-26 13:08:35'),(9454,7500,'Y','18','021','EC','A','','','AC','0000496746','0000496746','OH00001149770','IL','1','Grande','Kristen','','','','34','280841299','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','1970-02-21','F','M',':RET:2106-3','N','021','DEN','1590351','99734OH005000401','2014-01-01','2013-12-20 22:20:26','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:03'),(7400,5856,'N','01','021','EC','A',NULL,NULL,'','0000538228','0000811981','','IL','1','PRESSLEY','CLAUDIA','','','','34','296665606','702 SEARLES RD',0,'TOLEDO','OH','43607','2847','CY','39095','1959-12-30','F','',':RET:2054-5','N','021','DEN','685662','99734OH005000301','2014-01-01','2013-11-23 16:04:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:16:23'),(5552,4407,'Y','18','021','EC','A','','','AC','0000230491','0000230491','TX00000225146','IL','1','ramos','gabriel','','','','34','460061875','216 E COTTONWOOD ST',0,'AMARILLO','TX','79108','2108','CY','48375','1956-09-23','M','M',':RET:2106-3','N','021','DEN','1204219','33348TX002000201','2014-01-01','2013-11-26 22:17:19','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-25 23:16:11'),(4925,3907,'Y','18','021','EC','A','','','AC','0001228038','0001228038','OH00001063447','IL','1','cistrunk','lillie','ruth','','','34','587405853','1259 HEREFORD RD',0,'CLEVELAND HTS','OH','44118','1343','CY','39035','1950-10-20','F','U',':RET:2054-5','N','021','DEN','771659','99734OH005000401','2014-01-01','2013-12-06 18:16:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:45:15'),(5354,4246,'N','01','021','EC','A',NULL,NULL,'','0000961855','0000153360','','IL','1','Randolph','David','W','','','34','300704346','4056 St Rt 84',0,'Kingsville','OH','44048',NULL,'CY','39007','1966-10-02','M','',':RET:2106-3','T','021','HLT','1673857','52664OH152000901','2014-01-01','2013-12-19 15:25:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','331.13',NULL,0,'2013-12-25 23:07:41'),(23067,18391,'Y','18','021','EC','A','','','AC','0001519197','0001519197','LA00002423350','IL','1','WILLIAMS','ELAINE','','','','34','439238725','5725 SAINT KATHERINE AVE',0,'BATON ROUGE','LA','70805','3775','CY','22033','1963-09-24','F','U',NULL,'N','021','DEN','3017002','18575LA002000201','2014-03-01','2014-02-12 12:14:28','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:54'),(24300,19300,'N','01','021','EC','A',NULL,NULL,'','0001041549','0000595884','','IL','1','FORD','JOEY','','','','34','459557288','974 COUNTY ROAD 4445',0,'SPURGER','TX','77660','9206','CY','48457','1965-07-11','M','',':RET:2106-3','T','021','DEN','3704439','33348TX002000201','2014-04-01','2014-02-18 15:48:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-02-18 21:30:19'),(26530,21038,'Y','18','021','EC','A','','','AC','0001408570','0001408570','LA00002896328','IL','1','mills','jacob','carl','','','34','532118302','1117 ODWYER PL',0,'JEFFERSON','LA','70121','3019','CY','22051','1979-05-02','M','U',':RET:2106-3','N','021','DEN','2643091','18575LA002000101','2014-04-01','2014-02-28 17:42:52','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02','CIC',0,'2014-02-28 21:00:28'),(217,182,'Y','18','021','EC','A','','','AC','0000111724','0000111724','LA00000172832','IL','1','Hanson','Sarah','','','','34','434617857','333 N SAINT PATRICK ST',0,'NEW ORLEANS','LA','70119','4426','CY','22071','1982-07-10','F','U',':RET:2106-3','N','021','DEN','121735','18575LA002000201','2014-01-01','2013-12-05 06:27:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:20:38'),(21161,16910,'Y','18','021','EC','A','','','AC','0000942030','0000942030','OH00001450536','IL','1','NAPIER','ASLEY','','','','34','406354662','1732 SUTTON AVE',0,'CINCINNATI','OH','45230',NULL,'CY','39061','1988-04-03','F','U',NULL,'T','021','DEN','3388560','99734OH005000401','2014-03-01','2014-02-03 09:43:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:33'),(1413,1175,'Y','18','021','EC','A','','','AC','0001497864','0001497864','LA00001180289','IL','1','Williams','Paul','','','','34','439436459','2245 college drive',0,'baton rouge','LA','70808',NULL,'CY','22033','1981-06-21','M','U',':RET:2054-5','N','021','DEN','1415230','18575LA002000201','2014-01-01','2013-12-24 13:56:34','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:59'),(18811,14983,'Y','18','021','EC','A','','','AC','0001049407','0001049407','OH00001520401','IL','1','SWISHER','JANET','R','','','34','283502640','127 FARNSWORTH RD',0,'SAINT MARYS','OH','45885','1027','CY','39107','1950-03-02','F','U',':RET:2106-3','N','021','DEN','1782465','99734OH005000401','2014-03-01','2014-01-16 17:16:19','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-01-17 03:36:03'),(18489,14747,'Y','18','024','14','A','','','TE','0000399906','0000399906','','IL','1','Weisel','Raymond',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-08','M','',NULL,NULL,NULL,'','1538851','','2014-01-15','2014-01-15 14:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:46:25'),(2657,2159,'N','01','021','EC','A',NULL,NULL,'','0001171854','0001083059','','IL','1','Strang','Tonya','','','','34','454559770','5236 MONTICELLO HALL DR',0,'COLUMBUS','OH','43221','5678','CY','39049','1973-01-22','F','',':RET:2106-3','N','021','DEN','23389','99734OH005000301','2014-01-01','2013-12-01 20:32:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:47'),(17498,13992,'Y','18','021','EC','A','','','AC','0001215430','0001215430','LA00002306977','IL','1','pickett','anthony','','','','34','294709898','33718 weiss rd',0,'walker','LA','70785',NULL,'CY','22063','1962-09-18','M','M',':RET:2106-3','N','021','DEN','1702666','18575LA002000201','2014-02-01','2014-01-12 15:30:21','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-13 03:01:24'),(16613,13290,'Y','18','021','EC','A','','','AC','0001015588','0001015588','OH00000890625','IL','1','Caldwell','Kathleen','L','','','34','274765295','7599 CREEKWOOD DR',0,'NORTH ROYALTON','OH','44133','3859','CY','39035','1965-03-10','F','U',':RET:2106-3','N','021','DEN','2208825','99734OH005000401','2014-02-01','2014-01-07 10:32:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:08'),(8970,7116,'Y','18','021','EC','A','','','AC','0000370007','0000370007','OH00000369380','IL','1','Ward','Camilia','','','','34','293905556','2525 BRENDEL DR',0,'COLUMBUS','OH','43235','8004','CY','39049','1985-10-29','F','M',NULL,'N','021','DEN','2186646','99734OH005000401','2014-01-01','2013-12-18 15:16:41','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:04:04'),(21602,17249,'N','01','021','EC','A',NULL,NULL,'','0001076598','0000708975','','IL','1','SAMI','QURATULAIN','','','','34','271066504','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','1971-01-14','F','',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(25317,20084,'Y','18','024','14','A','','','TE','0001206168','0001206168','','IL','1','SENEGAL','LORI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-07-28','F','',NULL,NULL,NULL,'','3521619','','2014-02-24','2014-02-24 21:12:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-25 21:30:06'),(26102,20702,'Y','18','021','EC','A','','','AC','0001466599','0001466599','LA00002695005','IL','1','Bourgeois','Bradley','','','','34','434539631','17 SHADOW LN',0,'DESTREHAN','LA','70047','3624','CY','22089','1982-04-23','M','U',':RET:2106-3','T','021','DEN','3642568','18575LA002000201','2014-04-01','2014-02-27 17:19:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:13'),(27086,21444,'Y','18','021','EC','A','','','AC','0000655879','0000655879','OH00003339714','IL','1','Moody','JoAnn','','','','34','291503304','895 STATE ROUTE 302',0,'ASHLAND','OH','44805','9577','CY','39005','1949-12-07','F','U',NULL,'N','021','HLT','3663388','52664OH151001305','2014-04-01','2014-03-03 11:35:53','599.00',NULL,NULL,'669.00','70.00','R-OH012','OH0','669.00',NULL,0,'2014-03-03 21:30:14'),(1650,1378,'N','01','021','EC','A',NULL,NULL,'','0000260474','0000042073','','IL','1','Rogers','Melody','Patrice','','','34','413394048','19518 COUNTRY BREEZE CT',0,'SPRING','TX','77388','2544','CY','48201','1966-02-27','F','',':RET:2054-5','N','021','DEN','1456827','33348TX002000201','2014-01-01','2013-12-24 16:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:53:19'),(6105,4840,'Y','18','021','EC','A','','','AC','0000818537','0000818537','OH00000777641','IL','1','Saunders','Charles','','','','34','297587170','6772 US HIGHWAY 20',0,'METAMORA','OH','43540','9739','CY','39051','1961-04-10','M','M',NULL,'N','021','DEN','25867','99734OH005000401','2014-01-01','2013-11-21 12:30:01','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:15:19'),(1887,1543,'Y','18','021','EC','A','','','AC','0000467100','0000467100','OH00000433631','IL','1','Tarvin','Randall','','','','34','279548104','14633 SALEM CHURCH RD',0,'MOUNT ORAB','OH','45154','9506','CY','39015','1953-09-20','M','U',':RET:2106-3','N','021','HLT','2292222','92036OH006000601','2014-01-01','2013-12-24 11:47:57','252.00',NULL,NULL,'462.04','210.04','R-OH005','OH0','462.04',NULL,0,'2013-12-25 18:58:43'),(2111,1731,'Y','18','021','EC','A','','','AC','0000794468','0000794468','OH00000194823','IL','1','Kelby','Susan','','','','34','299684258','276 EMMAUS RD',0,'BELPRE','OH','45714','9711','CY','39167','1966-05-04','F','M',':RET:2106-3','N','021','DEN','656286','99734OH005000401','2014-01-01','2013-12-10 10:43:33','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 19:17:26'),(16983,13592,'Y','18','021','EC','A','','','AC','0000727292','0000727292','OH00001473911','IL','1','Coffey','Pauline','','','','34','295522085','4537 Denton Lane',0,'Batavia','OH','45103',NULL,'CY','39025','1952-12-15','F','U',':RET:2106-3','N','021','HLT','1719314','92036OH005000606','2014-02-01','2014-01-09 17:55:34','480.00',NULL,NULL,'603.24','123.24','R-OH005','OH0','603.24',NULL,0,'2014-01-13 02:20:19'),(16127,12918,'N','19','021','EC','A',NULL,NULL,'','0000383372','0000473664','','IL','1','Jackson','Kadyn','LeiAnn','','','34','673872291','10 CHATEAU PL',0,'MILFORD','OH','45150','1259','CY','39025','2011-07-15','F','',':RET:2106-3','N','021','HLT','1849186','92036OH006000601','2014-02-01','2014-01-03 01:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-01-04 02:05:35'),(14510,11576,'Y','18','024','14','A','','','TE','0001184944','0001184944','','IL','1','mcgee','john',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-01','M','',NULL,NULL,NULL,'','199100','','2013-12-27','2013-12-27 15:43:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:34:01'),(13764,10986,'Y','18','021','EC','A','','','AC','0000478171','0000478171','MS00000201841','IL','1','Dodson','Mary','','','','34','304540165','14220 Goodman Rd',0,'Olive Branch','MS','38654',NULL,'CY','28033','1952-03-06','F','U',':RET:2054-5','T','021','DEN','1939187','46300MS002000201','2014-01-01','2013-12-23 10:33:57','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-26 13:10:18'),(3309,2661,'Y','18','021','EC','A','','','AC','0000198559','0000198559','OH00000493499','IL','1','Latscha','Denise','','','','34','272806586','5542 KAREN AVE',0,'CINCINNATI','OH','45248','5207','CY','39061','1980-07-07','F','M',':RET:2106-3','N','021','DEN','2587529','99734OH005000301','2014-01-01','2013-12-22 14:14:23','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:50'),(4095,3272,'Y','18','024','14','A','','','TE','0000699257','0000699257','','IL','1','Foust','Ty','T',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-11-06','M','',NULL,NULL,NULL,'','895411','','2013-12-17','2013-12-17 09:31:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:47:35'),(21570,17230,'Y','18','021','EC','A','','','AC','0001104487','0001104487','OH00001422331','IL','1','MINOR','SANDRA','M','','','34','302668097','110 RIDGE SIDE CT',0,'MUNROE FALLS','OH','44262','1086','CY','39153','1959-11-27','F','M',':RET:2106-3','N','021','HLT','3530493','52664OH151001305','2014-03-01','2014-02-04 22:48:50','808.00',NULL,NULL,'1115.04','307.04','R-OH012','OH0','476.12',NULL,0,'2014-02-05 21:30:21'),(23967,19055,'Y','18','021','EC','A','','','AC','0000799743','0000799743','TX00002870883','IL','1','Stevens','Scott','','','','34','525333218','381 MISSION RIVER OAKS RD',0,'WOODSBORO','TX','78393','3623','CY','48391','1980-05-06','M','R',':RET:2106-3','T','021','DEN','3082240','33348TX002000101','2014-03-01','2014-02-15 14:07:41','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-02-15 22:00:11'),(24447,19419,'Y','18','021','EC','A','','','AC','0001662978','0001662978','LA00002034297','IL','1','WILLIAMS-QUINN','GLORIA','','','','34','436763802','1549 HANGING MOSS LN',0,'GRETNA','LA','70056','7794','CY','22051','1949-09-08','F','U',':RET:2054-5','N','021','DEN','3084554','18575LA002000101','2014-04-01','2014-02-18 10:22:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-18 22:01:23'),(26325,20885,'N','19','021','EC','A',NULL,NULL,'','0000899928','0000101669','','IL','1','REED','BRITTANY','','','','34','425699811','318 JEFFERSON AVE',0,'CLARKSDALE','MS','38614',NULL,'CY','28027','1990-04-23','F','',':RET:2054-5','N','021','DEN','3733596','46300MS002000101','2014-03-01','2014-02-27 11:08:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-28 06:31:38'),(26997,21382,'Y','18','021','EC','A','','','AC','0000338847','0000338847','OH00002786827','IL','1','Grigsby','Scott','','','','34','273787896','278 E TUSCARAWAS AVE',0,'BARBERTON','OH','44203','3241','CY','39153','1981-06-29','M','U',':RET:2106-3','N','021','HLT','3510043','52664OH152000901','2014-04-01','2014-03-02 15:43:27','83.00',NULL,NULL,'193.23','110.23','R-OH012','OH0','193.23','CIC',0,'2014-03-03 01:30:00'),(27538,21784,'N','01','021','EC','A',NULL,NULL,'','0000616885','0000061334','','IL','1','THIERET','JAMES','J','','','34','163448764','7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','1952-11-08','M','',':RET:2106-3','N','021','DEN','3776480','99734OH005000401','2014-04-01','2014-03-03 18:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:06'),(27817,22002,'Y','18','021','EC','A','','','AC','0000878331','0000878331','OH00002847550','IL','1','Clark','Heather',NULL,NULL,NULL,NULL,NULL,'643 BLAIN LN',0,'GREENFIELD','OH','45123','9660','CY','39141','1982-11-19','F','M',':RET:2106-3','N','021','DEN','3888152','99734OH005000301','2014-04-01','2014-03-04 19:19:34','0.00',NULL,NULL,'87.78','87.78','R-OH010','OH0','0.00',NULL,0,'2014-03-05 21:31:54'),(27893,22066,'Y','18','021','EC','A','','','AC','0001256098','0001256098','OH00003437690','31','1','AMBROSE','DANIEL','','','','34','300941969','PO BOX 144',0,'BETTSVILLE','OH','44815',NULL,'CY','39147','1985-05-03','M','U',':RET:2106-3','T','021','HLT','3356937','92036OH003002705','2014-04-01','2014-03-05 13:59:16','98.00',NULL,NULL,'254.56','156.56','R-OH006','OH0','254.56',NULL,0,'2014-03-05 21:32:40'),(28806,22801,'Y','18','021','EC','A','','','AC','0001231833','0001231833','OH00002728359','IL','1','Wright','Kellee','','','','34','288829205','1845 Beech Rd',0,'Stow','OH','44224',NULL,'CY','39153','1971-03-17','F','M',':RET:2106-3','N','021','HLT','4338954','52664OH151001301','2014-04-01','2014-03-09 09:45:47','212.00',NULL,NULL,'614.16','402.16','R-OH012','OH0','302.62',NULL,0,'2014-03-09 21:00:51'),(4288,3411,'N','01','021','EC','A',NULL,NULL,'','0000504460','0000464617','','IL','1','Wood','Krystle','L','','','34','255694322','508 W BREMEN ST',0,'NEW KNOXVILLE','OH','45871','9746','CY','39011','1988-03-18','F','',':RET:2106-3','N','021','HLT','2540742','92036OH005001504','2014-01-01','2013-12-17 13:41:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.97',NULL,0,'2013-12-25 21:52:06'),(14363,11455,'Y','18','021','EC','A','','','AC','0000939787','0000939787','OH00000624048','IL','1','ZIMMERMAN','LORI','','','','34','299746464','6784 OWLWOOD DR',0,'MASON','OH','45040','9576','CY','39165','1962-10-11','F','U',':RET:2106-3','N','021','DEN','2489383','99734OH005000401','2014-02-01','2013-12-26 21:00:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:19'),(9686,7671,'N','01','021','EC','A',NULL,NULL,'','0000437967','0000965765','','IL','1','caldwell','cynthia',NULL,NULL,NULL,NULL,NULL,'7692 BAYSHORE',0,'MASON','OH','45040','8613','CY','39165','1959-07-16','F','',':RET:2054-5','N','021','HLT','1616219','92036OH001001201','2014-01-01','2013-12-21 12:03:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','552.84',NULL,0,'2013-12-26 04:39:34'),(3422,2748,'Y','18','021','EC','A','','','AC','0002154880','0002154880','LA00000867435','IL','1','Ortiz','Patricia','','','','34','557049685','39580 Highway 75',0,'Plaquemine','LA','70764',NULL,'CY','22047','1956-01-03','F','U',NULL,'T','021','DEN','1358323','18575LA002000201','2014-01-01','2013-12-22 18:13:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:41'),(2957,2381,'Y','18','021','EC','A','','','AC','0000293249','0000293249','TX00000309346','IL','1','Pope','Patricia','Gay','','','34','459960076','106 LUANN WAY',0,'MABANK','TX','75156','6871','CY','48213','1952-08-30','F','U',':RET:2106-3','N','021','DEN','67787','33348TX002000201','2014-01-01','2013-12-06 14:06:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:40'),(16879,13505,'Y','18','021','EC','A','','','AC','0000260549','0000260549','TX00001636276','IL','1','Chancellor','Tyler','','','','34','455691134','6710 Burnet Ln.',0,'Austin','TX','78757',NULL,'CY','48453','1983-04-24','M','U',':RET:2106-3','N','021','DEN','1802639','33348TX002000201','2014-02-01','2014-01-08 23:32:54','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:19:20'),(17245,13799,'N','01','021','EC','A',NULL,NULL,'','0000872062','0000806365','','IL','1','KEAN','MATTHEW','','','','34','271505807','72 W. MAIN ST',0,'NORWALK','OH','44857',NULL,'CY','39077','1949-10-14','M','',':RET:2106-3','N','021','HLT','1510141','92036OH005002705','2014-02-01','2014-01-08 15:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','584.98',NULL,0,'2014-01-13 02:22:47'),(20983,16769,'Y','18','021','EC','A','','','AC','0002042469','0002042469','LA00002317980','31','1','THOMAS','LINDA','','','','34','436909856','PO BOX 665',0,'LAKE CHARLES','LA','70602',NULL,'CY','22019','1953-07-29','F','U',':RET:2054-5','N','021','DEN','3225601','18575LA002000201','2014-03-01','2014-02-01 13:32:08','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-01 19:00:21'),(21464,17152,'N','19','021','EC','A',NULL,NULL,'','0001114567','0001183558','','IL','1','BERNATOVICZ','WILL','','','','34','289138226','1000 ROBINWOOD HILLS DR',0,'AKRON','OH','44333','1554','CY','39153','2007-11-21','M','',NULL,'N','021','HLT','3471935','52664OH151001301','2014-03-01','2014-02-04 18:01:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-04 21:01:35'),(23195,18495,'Y','18','021','EC','A','','','AC','0001077798','0001077798','OH00001530627','IL','1','Lupo','Lisa','','','','34','288665366','579 Parkhill Dr',0,'Fairlawn','OH','44333',NULL,'CY','39153','1960-01-01','F','R',':RET:2106-3','N','021','HLT','3301665','52664OH152000901','2014-03-01','2014-02-12 16:23:12','0.00',NULL,NULL,'512.07','512.07','R-OH012','OH0','348.73',NULL,0,'2014-02-12 21:32:05'),(25228,20011,'Y','18','021','EC','A','','','AC','0001032656','0001032656','OH00002541796','IL','1','Gardner','Stephen','','','','34','283465176','1230 STATE ROUTE 96',0,'ASHLAND','OH','44805','1069','CY','39005','1952-02-11','M','M',':RET:2106-3','N','021','HLT','2699516','52664OH151001301','2014-04-01','2014-02-21 14:25:04','950.00',NULL,NULL,'1267.35','317.35','R-OH012','OH0','640.70',NULL,0,'2014-02-21 22:01:01'),(28154,22280,'N','19','021','EC','A',NULL,NULL,'','0000108222','0000650829','','IL','1','Perdew','Axl','','','','34','804538512','703 TAYLOR ST',0,'DELTA','OH','43515','1043','CY','39051','2013-12-29','M','',':RET:2106-3','N','021','HLT','3334936','92036OH005002601','2014-04-01','2014-03-06 15:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-03-06 21:02:39'),(643,531,'N','19','021','EC','A',NULL,NULL,'','0000740260','0000239019','','IL','1','SAWYER','BRANDON','','','','34','300960455','8800 FAIRLANE DR',0,'OLMSTED TWP','OH','44138','2123','CY','39035','1994-04-13','M','',':RET:2106-3','T','021','DEN','2369039','99734OH005000401','2014-01-01','2013-12-16 15:28:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:25'),(15030,12013,'Y','18','021','EC','A','','','AC','0002024360','0002024360','LA00000691897','IL','1','leblanc','paula','r','','','34','433841395','8340 RUBY ST',0,'SORRENTO','LA','70778','3143','CY','22005','1950-05-05','F','U',':RET:2106-3','N','021','DEN','2013406','18575LA002000201','2014-02-01','2013-12-30 08:47:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:02:36'),(4767,3782,'Y','18','021','EC','A','','','AC','0000151947','0000151947','OH00000744666','IL','1','HILL','GRADY','L','','Sr','34','276562367','907 JEFFERSON CHASE WAY',0,'BLACKLICK','OH','43004',NULL,'CY','39049','1959-04-07','M','M',NULL,'N','021','DEN','741985','99734OH005000401','2014-01-01','2013-12-08 11:41:05','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:15:44'),(6213,4924,'Y','18','024','14','A','','','TE','0000937860','0000937860','','IL','1','Hudson','David','Allan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-02','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-16 19:15:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:30:57'),(7471,5912,'Y','18','021','EC','A','','','AC','0000411095','0000411095','OH00001249302','IL','1','Tompkins','Lugene','','','','34','417727029','670 Babbitt Rd',0,'Euclid','OH','44123',NULL,'CY','39035','1951-04-04','M','M',':RET:2054-5','N','021','DEN','721135','99734OH005000401','2014-01-01','2013-12-14 21:38:49','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:31:11'),(16201,12971,'Y','18','024','14','A','','','TE','0000985990','0000985990','','IL','1','Hymel','Ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-12-16','F','',NULL,NULL,NULL,'','2289608','','2014-01-04','2014-01-04 14:59:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-05 00:01:08'),(18325,14631,'Y','18','021','EC','A','','','AC','0000140312','0000140312','OH00002128296','IL','1','Pillsbury','Deanna','','','','34','281861895','7861 TWIN HILLS RD',0,'STREETSBORO','OH','44241','6219','CY','39133','1986-04-07','F','U',':RET:2106-3','N','021','DEN','2041294','99734OH005000401','2014-02-01','2014-01-15 11:57:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:09'),(20829,16648,'Y','18','021','EC','A','','','AC','0001616396','0001616396','LA00001500661','IL','1','Goodman-Daniel','Diane','','','','34','556894266','1937 General Pershing St',0,'New Orleans','LA','70115',NULL,'CY','22071','1971-04-17','F','M',':RET:2106-3','T','021','DEN','2835133','18575LA002000201','2014-03-01','2014-01-31 15:54:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:40'),(4963,3939,'Y','18','021','EC','A','','','AC','0000610244','0000610244','LA00000656309','IL','1','mire','elaine','','','','34','150525127','5221 york st',0,'metairie','LA','70001',NULL,'CY','22051','1956-11-06','F','M',':RET:2106-3','N','021','DEN','765241','18575LA002000201','2014-01-01','2013-12-07 12:43:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:12'),(4025,3213,'N','01','021','EC','A',NULL,NULL,'','0000262715','0000860961','','IL','1','Wallace','Meghan','','','','34','300764437','5555 COLUMBIA DR',0,'BEDFORD HEIGHTS','OH','44146','2443','CY','39035','1981-03-27','F','',NULL,'N','021','DEN','2025566','99734OH005000401','2014-01-01','2013-12-17 08:54:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:46'),(2541,2068,'Y','18','021','EC','A','','','AC','0000013750','0000013750','OH00000192019','IL','1','McCormick','Daniel','','','','34','276486827','8340 W BANCROFT ST',0,'TOLEDO','OH','43617','1902','CY','39095','1950-01-03','M','M',':RET:2106-3','N','021','HLT','1010158','92036OH006002601','2014-01-01','2013-12-09 14:13:47','856.00',NULL,NULL,'913.00','57.00','R-OH001','OH0','456.50',NULL,0,'2013-12-25 19:37:03'),(2646,2150,'Y','18','021','EC','A','','','AC','0000593095','0000593095','TX00000134790','IL','1','Rosales','Amanda','Lee','','','34','454835023','4610 VERSAILLES DR',0,'MIDLAND','TX','79703','6838','CY','48329','1979-07-26','F','U',NULL,'N','021','DEN','1223549','33348TX002000101','2014-01-01','2013-12-02 14:46:49','0.00',NULL,NULL,'25.02','25.02','R-TX016','TX0','25.02',NULL,0,'2013-12-25 19:46:28'),(7331,5808,'N','19','021','EC','A',NULL,NULL,'','0000491858','0000053044','','IL','1','Maus','Madalyn','Rena','','','34','748044506','822 BOLENDER RD',0,'MOSCOW','OH','45153','9650','CY','39025','2011-07-14','F','',':RET:2106-3','N','021','HLT','711943','92036OH003000601','2014-01-01','2013-12-14 14:54:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-26 02:03:49'),(9440,7489,'Y','18','021','EC','A','','','AC','0000291966','0000291966','OH00000209204','IL','1','Jenck','Ashley','','','','34','271866472','3 HIGH ST',0,'NORWALK','OH','44857','2408','CY','39077','1986-12-31','F','U',NULL,'N','021','HLT','2040427','92036OH004002701','2014-01-01','2013-12-20 19:05:43','160.00',NULL,NULL,'164.31','4.31','R-OH006','OH0','164.31',NULL,0,'2013-12-26 04:33:40'),(8106,6412,'Y','18','024','14','A','','','TE','0000108143','0000108143','','IL','1','DOLNEY','JIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-11','F','',NULL,NULL,NULL,'','1948858','','2013-12-20','2013-12-20 16:47:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:58'),(7984,6321,'N','19','021','EC','A',NULL,NULL,'','0000740268','0001096750','','IL','1','Brown','Hylan','','','','34','838329873','202 Hawk Ave',0,'Akron','OH','44312',NULL,'CY','39153','2013-04-07','M','',':RET:2106-3','N','021','HLT','1854694','52664OH151001305','2014-01-01','2013-12-20 14:39:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 03:08:02'),(16877,13503,'N','01','021','EC','A',NULL,NULL,'','0001120731','0000209383','','IL','1','hibbitts','donna','fay','','','34','466210114','909 s. main',0,'eldorado','TX','76936',NULL,'CY','48413','1958-01-20','F','',':RET:2106-3','N','021','DEN','2025167','33348TX002000201','2014-02-01','2014-01-08 19:20:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:19:19'),(19597,15622,'N','01','021','EC','A',NULL,NULL,'','0000050715','0000149375','','IL','1','CONTI','CATHERINE','','','','34','278602593','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1960-03-29','F','',':RET:2106-3','N','021','HLT','3307000','52664OH151001501','2014-03-01','2014-01-22 14:09:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','615.39',NULL,0,'2014-01-23 03:02:47'),(21588,17243,'N','01','021','EC','A',NULL,NULL,'','0000833445','0000586732','','IL','1','kennedy','kimberly','','','','34','277889616','61525 vocational rd',0,'cambridge','OH','43725',NULL,'CY','39059','1974-06-17','F','',':RET:2106-3','N','021','DEN','3199975','99734OH005000301','2014-03-01','2014-02-04 19:26:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:28'),(22719,18142,'Y','18','021','EC','A','','','AC','0001252238','0001252238','LA00002693108','IL','1','FAROOQI','MOHAMMED','','','','34','664071966','6209 BLANKE ST',0,'METAIRIE','LA','70003','2914','CY','22051','1958-07-20','M','M',NULL,'T','021','DEN','3066905','18575LA002000201','2014-03-01','2014-02-11 12:33:20','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:09'),(25772,20440,'Y','18','021','EC','A','','','AC','0001160463','0001160463','OH00002677066','IL','1','Karp','Brian','','','','34','275764159','17306 Fairway Drive',0,'Lagrange','OH','44050',NULL,'CY','39093','1966-01-09','M','M',':RET:2106-3','T','021','DEN','3063575','99734OH005000301','2014-04-01','2014-02-24 16:36:12','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 09:30:57'),(4922,3905,'N','01','021','EC','A',NULL,NULL,'','0000225993','0000566585','','IL','1','Cipro','Dawn','','','','34','288661665','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1967-03-02','F','',':RET:2106-3','N','021','HLT','979775','52664OH151001306','2014-01-01','2013-12-07 11:41:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.51',NULL,0,'2013-12-25 22:45:11'),(14800,11819,'N','01','021','EC','A',NULL,NULL,'','0000589324','0000276273','','IL','1','Homan','Leigh','Ann','','','34','273723851','4460 TOWER RD',0,'DORSET','OH','44032','9628','CY','39007','1968-06-02','F','',':RET:2106-3','N','021','DEN','1951572','99734OH005000401','2014-01-01','2013-12-23 19:40:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:13:44'),(6994,5551,'Y','18','021','EC','A','','','AC','0001153852','0001153852','TX00001389712','IL','1','Vazquez','Marlene','','','','34','640342969','1737 Oates Dr',0,'Mesquite','TX','75150',NULL,'CY','48113','1988-11-24','F','M',NULL,'N','021','DEN','1621101','33348TX002000201','2014-01-01','2013-12-24 18:32:20','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:48:04'),(13683,10918,'Y','18','021','EC','A','','','AC','0000898455','0000898455','OH00000594400','IL','1','Allen','Katherine','','','','34','294687892','4965 SHERMAN WOOD DR',0,'KENT','OH','44240','7048','CY','39133','1959-08-25','F','U',':RET:2106-3','N','021','HLT','1974263','52664OH151001305','2014-01-01','2013-12-23 08:50:15','368.00',NULL,NULL,'476.12','108.12','R-OH012','OH0','476.12',NULL,0,'2013-12-26 13:08:14'),(13597,10845,'N','19','021','EC','A',NULL,NULL,'','0000649371','0000254529','','IL','1','Hodosko','Ashleigh','N','','','34','278924787','4000 Yellowood St.',0,'Lima','OH','45806',NULL,'CY','39003','1988-03-14','F','',':RET:2106-3','N','021','HLT','2395344','92036OH003001505','2014-01-01','2013-12-22 20:41:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','230.76',NULL,0,'2013-12-26 13:05:21'),(21346,17059,'N','01','021','EC','A',NULL,NULL,'','0000934112','0000087556','','IL','1','Lopez','Yolanda','','','','34','451398722','320 SW 29TH ST',0,'SAN ANTONIO','TX','78237','2113','CY','48029','1951-06-23','F','',':RET:2106-3','N','021','DEN','3588086','33348TX002000201','2014-03-01','2014-02-03 22:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-04 21:00:35'),(22709,18134,'N','01','021','EC','A',NULL,NULL,'','0001402631','0001429876','','IL','1','McCann','Suzanne','E','','','34','149506533','270 EDGEWOOD LN',0,'MONTZ','LA','70068','8967','CY','22095','1958-04-05','F','',':RET:2106-3','N','021','DEN','3621841','18575LA002000201','2014-03-01','2014-02-10 20:41:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:03'),(27304,21620,'Y','18','021','EC','A','','','AC','0000428667','0000428667','TX00003504280','31','1','Brooks','Kimberly','','','','34','466932364','PO BOX 631',0,'Tomball','TX','77377',NULL,'CY','48339','1975-09-12','F','M',NULL,'N','021','DEN','3841046','33348TX002000201','2014-04-01','2014-03-04 13:36:51','0.00',NULL,NULL,'112.74','112.74','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:36'),(1070,876,'Y','18','021','EC','A','','','AC','0001221913','0001221913','OH00000824829','IL','1','Bear','August','','','','34','425066182','664 GLASTONBURY CT',0,'WESTERVILLE','OH','43081','3203','CY','39049','1956-07-13','M','U',':RET:2106-3','N','021','DEN','249215','99734OH005000401','2014-01-01','2013-12-03 07:25:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:16:30'),(13206,10538,'Y','18','021','EC','A','','','AC','0000385302','0000385302','TX00000369704','IL','1','Tran','Thach','','','','34','586403034','6922 CANYON CREEK SQ',0,'HOUSTON','TX','77084','6373','CY','48201','1963-07-05','M','M',':RET:2047-9','N','021','DEN','2027272','33348TX002000101','2014-01-01','2013-12-23 18:12:06','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:55:05'),(13154,10493,'Y','18','021','EC','A','','','AC','0000950676','0000950676','OH00000361288','IL','1','Colbert','Teresa','','','','34','274649221','3259 SCOTTWOOD RD',0,'COLUMBUS','OH','43227','3505','CY','39049','1959-12-31','F','M',':RET:2054-5','N','021','DEN','2523184','99734OH005000401','2014-01-01','2013-12-23 17:24:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:53:39'),(9647,7644,'Y','18','021','EC','A','','','AC','0001162591','0001162591','OH00001215631','IL','1','paul','gabriel','','','','34','270929732','308 east 3rd street',0,'greenville','OH','45331',NULL,'CY','39037','1990-02-22','M','U',':RET:2106-3','N','021','HLT','2362053','92036OH004000501','2014-01-01','2013-12-20 22:14:10','140.00',NULL,NULL,'191.13','51.13','R-OH003','OH0','191.13',NULL,0,'2013-12-26 04:38:40'),(8140,6441,'Y','18','021','EC','A','','','AC','0000176358','0000176358','OH00000651221','IL','1','Leis','Thomas','','','','34','285644745','66 CRESTWOOD DR',0,'WILLARD','OH','44890','1607','CY','39077','1968-01-05','M','M',':RET:2106-3','T','021','HLT','1222029','92036OH004002701','2014-01-01','2013-11-21 21:10:17','275.00',NULL,NULL,'766.83','491.83','R-OH006','OH0','260.37',NULL,0,'2013-12-26 03:15:47'),(1857,1521,'Y','18','021','EC','A','','','AC','0000205787','0000205787','OH00000513675','IL','1','Biggs','Julie','','','','34','295847234','148 MORRISON AVE',0,'CUYAHOGA FALLS','OH','44221','2127','CY','39153','1970-08-29','F','M',':RET:2106-3','N','021','HLT','1628559','52664OH152000901','2014-01-01','2013-12-24 10:41:21','0.00',NULL,NULL,'429.09','429.09','R-OH012','OH0','221.65',NULL,0,'2013-12-25 18:58:06'),(2262,1851,'N','01','021','EC','A',NULL,NULL,'','0000909454','0001248305','','IL','1','Andreadis','Maya','','','','34','290743103','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1967-06-22','F','',':RET:2106-3','N','021','DEN','19816','99734OH005000301','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:15'),(3120,2507,'Y','18','021','EC','A','','','AC','0000277246','0000277246','OH00000454222','IL','1','pesek','adam','','','','34','269747521','12379 EATON BLVD',0,'GRAFTON','OH','44044','9552','CY','39093','1970-08-25','M','U',NULL,'T','021','DEN','674490','99734OH005000301','2014-01-01','2013-10-12 19:39:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:30:16'),(5909,4680,'Y','18','021','EC','A','','','AC','0000399892','0000399892','OH00000857281','IL','1','HOLLIFIELD','SHARON','','','','34','300545148','3963 Pleasant Avenue',0,'Hamilton','OH','45015',NULL,'CY','39017','1952-11-11','F','U',':RET:2106-3','N','021','HLT','1495198','92036OH003001205','2014-01-01','2013-12-23 21:15:29','435.00',NULL,NULL,'629.96','194.96','R-OH004','OH0','629.96',NULL,0,'2013-12-25 23:49:57'),(15525,12421,'Y','18','021','EC','A','','','AC','0001853928','0001853928','LA00001564902','IL','1','Stewart','Jerry','','','','34','435639132','PO Box 201',0,'Darrow','LA','70725',NULL,'CY','22005','1973-10-09','M','U',':RET:2054-5','N','021','DEN','2113781','18575LA002000201','2014-02-01','2013-12-31 06:04:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:26'),(17028,13624,'Y','18','021','EC','A','','','AC','0000026638','0000026638','OH00001947733','IL','1','Rohrs','Rodger','','','','34','279529405','1648 TINKERS VIEW DR',0,'TWINSBURG','OH','44087','1130','CY','39153','1951-08-09','M','M',':RET:2106-3','N','021','HLT','2099288','52664OH152000901','2014-02-01','2014-01-09 15:38:09','640.00',NULL,NULL,'912.59','272.59','R-OH012','OH0','469.28',NULL,0,'2014-01-13 02:20:42'),(17315,13848,'Y','18','021','EC','A','','','AC','0000307765','0000307765','TX00001375238','IL','1','Cole','Christi','','','','34','540275629','6541 S 3rd St.',0,'Abilene','TX','79605',NULL,'CY','48441','1972-11-16','F','M',':RET:2106-3','T','021','DEN','2188661','33348TX002000201','2014-02-01','2014-01-10 14:53:05','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-01-13 02:23:47'),(22960,18305,'Y','18','024','14','A','','','TE','0001031762','0001031762','','IL','1','Binz','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-07-16','M','',NULL,NULL,NULL,'','3339529','','2014-02-28','2014-02-11 19:39:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-12 21:00:08'),(23107,18420,'Y','18','021','EC','A','','','AC','0000504509','0000504509','OH00001583509','IL','1','tam','calvin','','','','34','534028218','8111 EAGLE RIDGE DR',0,'WEST CHESTER','OH','45069','1976','CY','39017','1979-03-22','M','M',':RET:2028-9^:RET:2500-7','N','021','DEN','2782996','99734OH005000401','2014-03-01','2014-02-12 17:00:01','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:16'),(23717,18883,'N','01','021','EC','A',NULL,NULL,'','0001257376','0000649409','','IL','1','Troxell','Mary','Ann','','','34','278423891','6001 SPRINGBORO PIKE',0,'DAYTON','OH','45449','3251','CY','39113','1955-08-29','F','',':RET:2106-3','N','021','DEN','3749092','99734OH005000401','2014-03-01','2014-02-14 16:51:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:50'),(28414,22482,'N','01','021','EC','A',NULL,NULL,'','0000178960','0000115560','','IL','1','Turner','David','W','','','34','407829743','4308 32ND AVE',0,'CINCINNATI','OH','45209','1625','CY','39061','1954-11-15','M','',':RET:2106-3','N','021','DEN','3833234','99734OH005000401','2014-04-01','2014-03-07 12:09:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:30:58'),(5399,4286,'Y','18','021','EC','A','','','AC','0001148710','0001148710','OH00001164822','IL','1','MIHM','JAMES','','','','34','300503884','15700 SAINT MARYS RIVER RD',0,'SAINT MARYS','OH','45885','9228','CY','39011','1950-03-28','M','U',':RET:2106-3','T','021','HLT','2258989','92036OH004001501','2014-01-01','2013-12-19 11:32:02','0.00',NULL,NULL,'600.76','600.76','R-OH002','OH0','600.76',NULL,0,'2013-12-25 23:08:54'),(8894,7052,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','2486700','','2013-12-18','2013-12-18 18:06:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:02:06'),(18645,14864,'Y','18','021','EC','A','','','AC','0001019931','0001019931','TX00001598672','IL','1','Mireles','Eloisa','','','','34','454969290','1344 LANTANA LN',0,'BROWNSVILLE','TX','78520','8612','CY','48061','1955-05-08','F','M',NULL,'N','021','DEN','2786142','33348TX002000201','2014-03-01','2014-01-16 01:08:51','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-17 03:35:08'),(21561,17225,'Y','18','021','EC','A','','','AC','0000491916','0000491916','OH00002062480','IL','1','Wu','Gui Zhen','','','','34','106968741','4118 SCHENCK AVE',0,'CINCINNATI','OH','45236','2528','CY','39061','1957-11-14','F','M',':RET:2034-7','N','021','DEN','3239668','99734OH005000401','2014-03-01','2014-02-05 17:18:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:18'),(327,269,'Y','18','021','EC','A','','','AC','0001065941','0001065941','OH00000213268','IL','1','Glass','Richard','','','','34','279548282','256 MUDSWITCH RD',0,'MARTINSVILLE','OH','45146','9611','CY','39027','1953-10-19','M','U',':RET:2106-3','N','021','HLT','404093','92036OH002000601','2014-01-01','2013-11-13 16:01:29','303.00',NULL,NULL,'672.81','369.81','R-OH005','OH0','672.81',NULL,0,'2013-12-25 17:31:33'),(4634,3672,'Y','18','021','EC','A','','','AC','0000784935','0000784935','MS00000032482','IL','1','Ingram','Susan','','','','34','587969646','350 Main st',0,'pope','MS','38658',NULL,'CY','28107','1957-05-25','F','M',':RET:2106-3','N','021','DEN','313948','46300MS002000101','2014-01-01','2013-12-12 15:47:09','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2013-12-25 22:06:37'),(13462,10736,'Y','18','021','EC','A','','','AC','0001224464','0001224464','OH00000355069','IL','1','Sage','Billy','','','III','34','590887438','31968 Ansel Rd',0,'Logan','OH','43138',NULL,'CY','39073','1988-07-10','M','U',':RET:2106-3','N','021','DEN','1719906','99734OH005000301','2014-01-01','2013-12-23 15:18:21','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-26 13:01:46'),(6835,5418,'Y','18','021','EC','A','','','AC','0001092083','0001092083','OH00000547271','IL','1','Merkt','Janet','','','','34','287545380','3887 BRIGADOON DR',0,'CINCINNATI','OH','45255','5402','CY','39025','1952-01-25','F','M',':RET:2106-3','N','021','DEN','766434','99734OH005000401','2014-01-01','2013-11-14 13:16:27','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 01:30:54'),(7878,6232,'Y','18','021','EC','A','','','AC','0000884207','0000884207','OH00000173446','IL','1','BYERS-LOWERY','ERNESTINE','','','','34','335508898','1802 FAIRMOUNT AVE',0,'CINCINNATI','OH','45214','1225','CY','39061','1957-02-08','F','M',':RET:1002-5^:RET:2054-5','N','021','DEN','2328174','99734OH005000301','2014-01-01','2013-12-20 17:26:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:05:21'),(16098,12894,'Y','18','024','14','A','','','TE','0000204571','0000204571','','IL','1','Lee','Tracy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-06-26','F','',NULL,NULL,NULL,'','1553161','','2014-01-03','2014-01-03 10:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:04:41'),(21822,17427,'Y','18','021','EC','A','','','AC','0000825672','0000825672','TX00001720873','IL','1','Blackmon','Jeremy','','','','34','457690331','15994 COUNTY ROAD 3138',0,'LINDALE','TX','75771','7358','CY','48423','1983-08-10','M','M',':RET:2106-3','N','021','DEN','3697795','33348TX002000101','2014-03-01','2014-02-06 09:44:32','0.00',NULL,NULL,'139.14','139.14','R-TX022','TX0','25.02',NULL,0,'2014-02-06 21:01:00'),(24029,19111,'Y','18','021','EC','A','','','AC','0000403706','0000403706','OH00002888710','31','1','Siek','Ashley',NULL,NULL,NULL,NULL,NULL,'PO BOX 4',0,'West Millgrove','OH','43467',NULL,'CY','39173','1988-01-24','F','R',NULL,'T','021','HLT','3317820','92036OH004002601','2014-03-01','2014-02-14 20:20:30','0.00',NULL,NULL,'184.63','184.63','R-OH001','OH0','184.63',NULL,0,'2014-02-15 22:00:52'),(24939,19777,'Y','18','021','EC','A','','','AC','0001210868','0001210868','MS00002434566','IL','1','Richardson','Lawander','L','','','34','428276236','432 HURON ST',0,'JACKSON','MS','39203','1123','CY','28049','1972-08-07','F','U',':RET:2054-5','N','021','DEN','2678433','46300MS002000201','2014-04-01','2014-02-19 18:01:04','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 22:00:03'),(25215,20000,'Y','18','021','EC','A','','','AC','0000221371','0000221371','OH00003188932','IL','1','WARREN','KEVIN','','','','34','280784836','112 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1425','CY','39023','1980-07-05','M','U',NULL,'N','021','DEN','3519343','99734OH005000301','2014-04-01','2014-02-21 16:30:27','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-21 22:00:53'),(333,273,'N','01','021','EC','A',NULL,NULL,'','0000536040','0000537299','','IL','1','barnett','michael','','','','34','407984275','3111 Avenue Q',0,'Galveston','TX','77550',NULL,'CY','48167','1962-07-26','M','',NULL,'T','021','DEN','1036777','33348TX002000201','2014-01-01','2013-10-11 12:17:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 17:31:43'),(597,491,'N','01','021','EC','A',NULL,NULL,'','0001039739','0000157979','','IL','1','Wiley','Sally','Jo','','','34','273642018','3050 GLENFINNAN DR',0,'ALBANY','OH','45710','9462','CY','39009','1957-08-21','F','',':RET:2106-3','N','021','DEN','629721','99734OH005000401','2014-01-01','2013-12-15 20:25:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:00:14'),(5207,4133,'Y','18','021','EC','A','','','AC','0000036982','0000036982','OH00000140369','IL','1','HAGOS','TADESSE','','','','34','224913272','4142 CERTALDO DR',0,'COLUMBUS','OH','43219','8108','CY','39049','1982-04-10','M','U',NULL,'N','021','DEN','1900871','99734OH005000401','2014-01-01','2013-12-19 15:20:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:04:12'),(13752,10976,'N','01','021','EC','A',NULL,NULL,'','0001105531','0000427626','','IL','1','lambert','jessica','lynn','','','34','295720561','605 E. Pearl St.',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1977-03-31','F','',':RET:2106-3','T','021','HLT','1781710','92036OH004001501','2014-01-01','2013-12-23 14:04:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','250.32',NULL,0,'2013-12-26 13:09:57'),(13411,10700,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000049485','','IL','1','Mecklenborg','Lucy','Jane',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2011-09-01','F','',NULL,'N','021','DEN','1618729','99734OH005000301','2014-01-01','2013-12-23 10:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:34'),(3266,2633,'Y','18','021','EC','A','','','AC','0000460643','0000460643','LA00000548814','IL','1','Perkins','Theresa','','','','34','439064514','P.O. Box 41578',0,'Baton Rouge','LA','70835',NULL,'CY','22033','1962-06-24','F','U',':RET:2054-5','N','021','DEN','297925','18575LA002000101','2014-01-01','2013-11-28 09:11:22','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 20:47:04'),(7336,5810,'Y','18','021','EC','A','','','AC','0000015241','0000015241','OH00000045397','31','1','Stritenberger','Elizabeth','','','','34','514546839','PO BOX 62',0,'LEESBURG','OH','45135',NULL,'CY','39071','1949-07-04','F','M',':RET:2106-3','N','021','HLT','952027','92036OH005000605','2014-01-01','2013-12-14 12:48:22','544.00',NULL,NULL,'644.00','100.00','R-OH005','OH0','644.00',NULL,0,'2013-12-26 02:03:54'),(22249,17758,'Y','18','024','14','A','','','TE','0000050715','0000050715','','IL','1','CONTI','FRANCO',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-19','M','',NULL,NULL,NULL,'','3307000','','2014-02-09','2014-02-09 13:33:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-09 19:00:42'),(22759,18171,'Y','18','021','EC','A','','','AC','0000253087','0000253087','OH00002395726','IL','1','Hooks','Linda','','','','34','277467202','1414 WOODVILLE RD',0,'MANSFIELD','OH','44903','9478','CY','39139','1954-11-04','F','M',':RET:2106-3','N','021','DEN','3004952','99734OH005000401','2014-03-01','2014-02-10 21:22:43','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-02-11 21:01:32'),(23944,19038,'Y','18','021','EC','A','','','AC','0000594544','0000594544','TX00002868165','IL','1','turner','chelbie','','','','34','632289868','402 S JACKSON ST',0,'MIDLAND','TX','79701','7611','CY','48329','1991-12-06','F','U',':RET:2054-5','N','021','DEN','2927652','33348TX002000201','2014-03-01','2014-02-15 11:51:47','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61','CIC',0,'2014-02-15 21:00:10'),(24077,19147,'Y','18','021','EC','A','','','AC','0000621147','0000621147','OH00001732099','IL','1','Marquardt','Amber','','','','34','292803985','6048 HOPKINS RD',0,'MENTOR','OH','44060','2208','CY','39085','1983-07-30','F','U',':RET:2106-3','N','021','HLT','2993800','52664OH151001305','2014-03-01','2014-02-14 20:04:15','127.00',NULL,NULL,'285.47','158.47','R-OH011','OH0','285.47',NULL,0,'2014-02-15 22:01:20'),(26618,21105,'Y','18','021','EC','A','','','AC','0000619128','0000619128','TX00002804015','IL','1','Ahmed','Ruqiya','','','','34','614451455','12820 n lamar',0,'Austin','TX','78753',NULL,'CY','48453','1991-05-25','F','U',NULL,'N','021','DEN','2948116','33348TX002000201','2014-04-01','2014-02-28 11:44:10','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-28 21:30:50'),(28888,22864,'Y','18','021','EC','A','','','AC','0000967210','0000967210','TX00003386256','IL','1','MANZA','JUDITH','','','','34','552745406','4513 BULL CREEK RD',0,'AUSTIN','TX','78731','5501','CY','48453','1963-06-27','F','U',NULL,'N','021','DEN','3675386','33348TX002000201','2014-04-01','2014-03-10 14:34:18','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-10 21:00:13'),(2473,2013,'Y','18','021','EC','A','','','AC','0000039177','0000039177','LA00000380884','IL','1','PRESLEY','DAMON','COLBY','','','34','434770756','3201 KNIGHT ST',0,'SHREVEPORT','LA','71105','2706','CY','22017','1986-04-14','M','U',':RET:2054-5','N','021','DEN','229373','18575LA002000201','2014-01-01','2013-12-09 11:46:43','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 19:35:17'),(15840,12684,'Y','18','021','EC','A','','','AC','0000209648','0000209648','OH00001542890','IL','1','hinkle','susan','','','','34','294700974','3995 alexander ln.',0,'batavia','OH','45103',NULL,'CY','39025','1962-11-07','F','M',':RET:2106-3','N','021','DEN','2569897','99734OH005000401','2014-02-01','2014-01-02 15:17:58','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-03 02:04:08'),(15789,12637,'Y','18','021','EC','A','','','AC','0001377681','0001377681','LA00001514791','IL','1','Foley','Lillian','','','','34','437313747','2020 PAILET AVE',0,'HARVEY','LA','70058','3522','CY','22051','1965-02-13','F','U',':RET:2054-5','T','021','DEN','1850172','18575LA002000201','2014-02-01','2014-01-02 12:25:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:25'),(5982,4735,'Y','18','021','EC','A','','','AC','0000740276','0000740276','OH00001039514','IL','1','Stanic','Milojka','','','','34','286067310','7013 STATE RD',0,'PARMA','OH','44134','4950','CY','39035','1968-09-27','F','M',':RET:2106-3','T','021','HLT','1965704','92036OH003000805','2014-01-01','2013-12-23 23:36:54','479.00',NULL,NULL,'804.65','325.65','R-OH011','OH0','405.45',NULL,0,'2013-12-25 23:51:58'),(3479,2792,'N','01','021','EC','A',NULL,NULL,'','0000769988','0000053058','','IL','1','Riesenberg','Ann','','','','34','279660819','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1965-08-05','F','',':RET:2106-3','N','021','DEN','1874880','99734OH005000401','2014-01-01','2013-12-22 11:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:08'),(4743,3758,'Y','18','021','EC','A','','','AC','0000280814','0000280814','OH00000869137','IL','1','Scott','Jacqueline','','','','34','284742922','12854 S. South Street',0,'Greenfield','OH','45123',NULL,'CY','39071','1963-04-16','F','R',':RET:2106-3','N','021','HLT','17859','92036OH004000601','2014-01-01','2013-12-12 16:09:44','0.00',NULL,NULL,'308.28','308.28','R-OH005','OH0','308.28',NULL,0,'2013-12-25 22:09:31'),(7606,6019,'Y','18','021','EC','A','','','AC','0000081256','0000081256','OH00000813581','IL','1','DEITZ','DENNIS','','','','34','297589706','4256 N MONROE CTR',0,'KINGSVILLE','OH','44048','9706','CY','39007','1955-11-02','M','M',':RET:2106-3','T','021','HLT','847402','52664OH151001301','2014-01-01','2013-11-16 20:24:27','844.00',NULL,NULL,'1297.89','453.89','R-OH011','OH0','737.00',NULL,0,'2013-12-26 02:45:31'),(18062,14429,'N','19','021','EC','A',NULL,NULL,'','0000484813','0001173242','','S1','1','Boone','Jesee','Lee','','Jr',NULL,NULL,'14 Oriole Court',0,'Amelia','OH','45102',NULL,'CY','39025','2009-06-13','M','',':RET:2106-3','N','021','HLT','1875690','92036OH003000604','2014-02-01','2014-01-14 16:42:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-15 02:07:21'),(20227,16138,'N','01','021','EC','A',NULL,NULL,'','0001250873','0000295537','','IL','1','Schlueter','Catherine','A',NULL,NULL,NULL,NULL,'10534 JOHN WOODS RD',0,'WINCHESTER','OH','45697','9627','CY','39015','1960-03-28','F','',':RET:2106-3','N','021','HLT','3182869','92036OH005000604','2014-03-01','2014-01-27 15:34:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','437.93',NULL,0,'2014-01-27 21:01:48'),(26144,20730,'Y','18','021','EC','A','','','AC','0000666818','0000666818','OH00003335857','IL','1','Mount','Larry','','','','34','295429959','601 S DOUGLAS AVE',0,'SPRINGFIELD','OH','45505','2436','CY','39023','1951-05-12','M','M',NULL,'N','021','DEN','3825940','99734OH005000401','2014-04-01','2014-02-27 13:38:26','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-28 06:30:27'),(28706,22716,'N','01','021','EC','A',NULL,NULL,'','0000314760','0000326254','','IL','1','Rorrer','David','B','','','34','274802069','175 HERMANN ST',0,'BARBERTON','OH','44203','1422','CY','39153','1969-11-07','M','',':RET:2106-3','N','021','HLT','3646802','52664OH151001301','2014-04-01','2014-03-08 13:02:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-03-08 21:31:11'),(6275,4975,'Y','18','021','EC','A','','','AC','0001080305','0001080305','OH00000591191','IL','1','ALINO','REGINA','','','','34','277135735','5010 LINDEN AVE',0,'DAYTON','OH','45432',NULL,'CY','39113','1989-09-07','F','U',':RET:2036-2','N','021','DEN','35920','99734OH005000401','2014-01-01','2013-12-10 19:05:20','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:45:12'),(14927,11927,'Y','18','021','EC','A','','','AC','0001114544','0001114544','OH00001480095','IL','1','Zbeidy','Jessy','','','','34','276112542','12641Walnut Hill Drive',0,'North Royalton','OH','44133',NULL,'CY','39035','1982-06-06','F','U',':RET:2106-3','N','021','HLT','2142599','92036OH004000801','2014-02-01','2013-12-28 20:20:14','74.00',NULL,NULL,'217.89','143.89','R-OH011','OH0','217.89',NULL,0,'2013-12-30 00:01:52'),(607,500,'Y','18','021','EC','A','','','AC','0001174386','0001174386','OH00001301100','IL','1','BERIHUN','MARITU','','','','34','300906951','7882 MERDON DR',0,'BLACKLICK','OH','43004','9116','CY','39049','1966-02-13','F','M',NULL,'N','021','DEN','2318873','99734OH005000401','2014-01-01','2013-12-16 09:18:48','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:00:28'),(6944,5514,'Y','18','021','EC','A','','','AC','0000075246','0000075246','OH00000181351','IL','1','Wooden','Angelica','','','','34','272840791','23024 High Road',0,'Oakwood Village','OH','44146',NULL,'CY','39035','1985-08-04','F','U',':RET:2054-5','N','021','DEN','1888763','99734OH005000401','2014-01-01','2013-12-24 20:30:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:51'),(5512,4373,'N','01','021','EC','A',NULL,NULL,'','0001207117','0000234016','','IL','1','Stamp','Krysten','Marie','','','34','414219771','11818 Hidden Lake Dr.',0,'Marshallville','OH','44645',NULL,'CY','39169','1965-11-04','F','',':RET:2106-3','N','021','DEN','1073474','99734OH005000301','2014-01-01','2013-11-26 18:22:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:08'),(3831,3067,'N','19','021','EC','A',NULL,NULL,'','0001124051','0000823492','','S1','1','Scholten','Kathleen','','','','34','369212685','2106 PRESSLER RD',0,'AKRON','OH','44312','4328','CY','39153','1997-02-11','M','',':RET:2106-3','N','021','DEN','85836','99734OH005000301','2014-01-01','2013-12-13 16:51:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:35:11'),(18675,14888,'Y','18','021','EC','A','','','AC','0000175098','0000175098','TX00001905415','IL','1','Cook','Maria','','','','34','463354450','205 AVALON DR',0,'ROBSTOWN','TX','78380','2001','CY','48355','1969-01-20','F','U',NULL,'N','021','DEN','2752915','33348TX002000201','2014-02-01','2014-01-15 19:37:48','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-17 03:35:18'),(19586,15613,'Y','18','021','EC','A','','','AC','0001131927','0001131927','MS00001630633','IL','1','DAMPIER','MARY','','','','34','587984103','4625 HERITAGE MNR',0,'JACKSON','MS','39212',NULL,'CY','28049','1955-11-12','F','M',NULL,'N','021','DEN','2375473','46300MS002000201','2014-03-01','2014-01-22 16:22:55','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-23 03:02:42'),(19608,15627,'N','01','021','EC','A',NULL,NULL,'','0001063272','0000280865','','IL','1','Ethridge','Susan','','','','34','300806068','7050 Chillicothe Rd.',0,'Mentor','OH','44060',NULL,'CY','39085','1968-07-22','F','',':RET:2106-3','T','021','HLT','1766296','52664OH152000901','2014-03-01','2014-01-22 10:01:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','305.92',NULL,0,'2014-01-23 03:02:49'),(23919,19022,'N','19','021','EC','A',NULL,NULL,'','0000613049','0000066298','','IL','1','Barr','Parker',NULL,NULL,NULL,NULL,NULL,'7191 TUMBLEBROOK DR',0,'NEW ALBANY','OH','43054','8890','CY','39049','2009-03-23','M','',NULL,'N','021','DEN','3604800','99734OH005000301','2014-03-01','2014-02-14 15:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:05'),(24297,19298,'Y','18','024','14','A','','','TE','0000071650','0000071650','','IL','1','TRAPNELL','TAMARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-10','F','',NULL,NULL,NULL,'','1758196','','2014-03-31','2014-02-18 14:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:17'),(27111,21458,'Y','18','021','EC','A','','','AC','0000015323','0000015323','OH00002169895','IL','1','El-Dabaja','Sarah','Saleh','','','34','282927757','45461 VINEGAR ST',0,'RACINE','OH','45771','9548','CY','39105','1990-06-06','F','U',':RET:2106-3','N','021','DEN','2902631','99734OH005000301','2014-04-01','2014-03-02 18:42:42','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-03-03 21:30:26'),(27721,21922,'N','01','021','EC','A',NULL,NULL,'','0000277951','0001040539','','IL','1','trevino','carlos',NULL,NULL,NULL,NULL,NULL,'13407 SPRUCE HOLLOW CT',0,'HOUSTON','TX','77059','3237','CY','48201','1971-12-30','M','',NULL,'N','021','DEN','3109320','33348TX002000201','2014-04-01','2014-03-05 14:05:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-05 21:30:58'),(27860,22036,'Y','18','024','14','A','','','TE','0001117315','0001117315','','IL','1','Montague','Delilah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-01-06','F','',NULL,NULL,NULL,'','3879202','','2014-03-04','2014-03-04 22:52:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:18'),(27918,22085,'N','19','021','EC','A',NULL,NULL,'','0000248355','0000103951','','IL','1','ALVARADO','ELMER','JOVANY','','','34','658100706','3045 YASMEEN CIR',0,'FLINT','TX','75762','6734','CY','48423','2001-08-25','M','',NULL,'N','021','DEN','3758819','33348TX002000201','2014-04-01','2014-03-05 21:56:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-03-06 21:00:19'),(28122,22256,'Y','18','021','EC','A','','','AC','0000197204','0000197204','OH00003054065','IL','1','Pollauf','Thomas','','','','34','279460769','3950 PEPPERWOOD CT',0,'SYLVANIA','OH','43560','3578','CY','39095','1951-04-14','M','M',NULL,'N','021','HLT','3699648','92036OH003002601','2014-04-01','2014-03-06 12:32:04','602.00',NULL,NULL,'1157.27','555.27','R-OH001','OH0','585.04',NULL,0,'2014-03-06 21:02:21'),(67,60,'Y','18','021','EC','A','','','AC','0000995411','0000995411','OH00001240071','IL','1','STEDRONSKY','JAMES','','','','34','286528533','11911 OLD MILL RD',0,'SPENCER','OH','44275','9585','CY','39103','1952-05-06','M','U',':RET:2106-3','N','021','DEN','1204343','99734OH005000301','2014-01-01','2013-12-05 06:17:07','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:16:48'),(13859,11059,'Y','18','021','EC','A','','','AC','0000229432','0000229432','OH00000220127','IL','1','Piecuch','Brian','','','','34','279725207','2427 BARCLAY MESSERLY RD',0,'SOUTHINGTON','OH','44470','9740','CY','39155','1974-02-28','M','M',':RET:2106-3','N','021','HLT','2060525','52664OH151001501','2014-01-01','2013-12-22 21:02:43','398.00',NULL,NULL,'765.56','367.56','R-OH013','OH0','382.78',NULL,0,'2013-12-26 13:12:47'),(14164,11291,'Y','18','021','EC','A','','','AC','0001154838','0001154838','LA00000380565','IL','1','SMITH','QUENTIN','LEOEIS','','','34','435775837','506 E MAGNOLIA ST',0,'BUNKIE','LA','71322','1116','CY','22009','1987-04-07','M','U',':RET:2054-5','N','021','DEN','1838086','18575LA002000201','2014-02-01','2013-12-26 16:35:02','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-27 02:03:14'),(1822,1496,'N','19','021','EC','A',NULL,NULL,'','0000593684','0000251622','','IL','1','tariq','omaid','','','','34','283068419','1613 RIDGE CROSS RD',0,'PERRYSBURG','OH','43551','9055','CY','39173','1993-05-14','M','',NULL,'N','021','HLT','1708312','92036OH005002605','2014-01-01','2013-12-24 14:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-25 18:57:16'),(4874,3865,'Y','18','024','14','A','','','TE','0000482849','0000482849','','IL','1','Slowik','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-05-20','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:31:06'),(7273,5768,'Y','18','021','EC','A','','','AC','0000440537','0000440537','TX00000797621','IL','1','MATTICK','CAROL','','','','34','585948138','721 GOLFCREST DR',0,'WINDCREST','TX','78239','2623','CY','48029','1957-01-13','F','R',':RET:2106-3','N','021','DEN','1103883','33348TX002000201','2014-01-01','2013-12-14 14:23:15','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-26 02:02:29'),(7170,5685,'Y','18','021','EC','A','','','AC','0000933210','0000933210','OH00001536071','IL','1','Lester','Patricia','','','','34','301504359','1093 Greyton Road',0,'Cleveland Hts','OH','44112',NULL,'CY','39035','1950-11-03','F','M',':RET:2054-5','T','021','HLT','2119880','92036OH004000801','2014-01-01','2013-12-24 22:22:07','178.00',NULL,NULL,'638.19','460.19','R-OH011','OH0','638.19',NULL,0,'2013-12-26 01:52:41'),(4732,3749,'N','19','021','EC','A',NULL,NULL,'','0001014355','0000183474','','IL','1','KEVER','BRITTNEY','','','','34','281961967','215 E RAYMOND ST',0,'VAN WERT','OH','45891',NULL,'CY','39161','1992-05-21','F','',':RET:2106-3','N','021','HLT','863153','92036OH003001501','2014-01-01','2013-12-12 15:37:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','229.83',NULL,0,'2013-12-25 22:09:11'),(16278,13032,'Y','18','021','EC','A','','','AC','0001144784','0001144784','OH00000266951','IL','1','Booker','Theresa','','','','34','297828267','5219Daleside.Ave',0,'Parma','OH','44134',NULL,'CY','39035','1977-02-01','F','M',':RET:2106-3','N','021','DEN','2097864','99734OH005000401','2014-02-01','2014-01-06 13:47:14','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-07 04:00:27'),(16821,13454,'Y','18','021','EC','A','','','AC','0001634954','0001634954','LA00001684942','31','1','douglas','dineshea','','','','34','439855027','13171 PLANK RD',0,'BAKER','LA','70714','4914','CY','22033','1993-01-21','F','U',':RET:2054-5','N','021','DEN','2170956','18575LA002000201','2014-02-01','2014-01-10 18:47:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:18:22'),(17699,14144,'Y','18','021','EC','A','','','AC','0001432539','0001432539','LA00001553078','IL','1','DUNN','MELODIE','A','','','34','439047168','5465 BEECHWOOD DR',0,'BATON ROUGE','LA','70805','3020','CY','22033','1957-02-05','F','M',':RET:2054-5','N','021','DEN','1885002','18575LA002000201','2014-02-01','2014-01-13 13:39:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:03'),(18025,14399,'N','19','021','EC','A',NULL,NULL,'','0000408502','0001208326','','IL','1','Andrews','Lauren','','','','34','291130635','6827 DRY RUN RD',0,'KINGSTON','OH','45644','9711','CY','39141','2007-12-21','F','',':RET:2106-3','N','021','DEN','2850751','99734OH005000301','2014-02-01','2014-01-14 13:19:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:07'),(19804,15789,'Y','18','024','14','A','','','TE','0001162013','0001162013','','IL','1','waller','terry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-05-11','M','',NULL,NULL,NULL,'','1682527','','2014-01-24','2014-01-24 15:32:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:05'),(19983,15939,'Y','18','024','14','A','','','TE','0000955578','0000955578','','IL','1','Jerels','Ashaki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-02-14','F','',NULL,NULL,NULL,'','3216270','','2014-01-25','2014-01-25 12:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-25 19:00:16'),(20947,16739,'Y','18','021','EC','A','','','AC','0000737896','0000737896','OH00001544968','IL','1','MARTIN','DANETTE','','','','34','273843364','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','1983-10-22','F','M',NULL,'N','021','HLT','3625394','92036OH003002705','2014-03-01','2014-01-31 16:57:05','299.00',NULL,NULL,'462.26','163.26','R-OH006','OH0','231.13',NULL,0,'2014-01-31 21:01:46'),(23208,18503,'Y','18','021','EC','A','','','AC','0000345629','0000345629','OH00002693142','IL','1','swearingen','donna','','','','34','294441151','120 DANA AVE',0,'WILMINGTON','OH','45177','1005','CY','39027','1953-12-10','F','M',':RET:2106-3','N','021','HLT','3508246','92036OH004000601','2014-03-01','2014-02-12 13:55:51','382.00',NULL,NULL,'468.46','86.46','R-OH005','OH0','468.46',NULL,0,'2014-02-12 21:32:12'),(24127,19178,'Y','18','021','EC','A','','','AC','0001756563','0001756563','LA00001860554','IL','1','Hammons','Marsha','','','','34','438047952','604 Clayton st',0,'West Monroe','LA','71291',NULL,'CY','22073','1975-07-16','F','U',':RET:2106-3','N','021','DEN','2766219','18575LA002000101','2014-03-01','2014-02-15 13:32:47','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-15 22:01:46'),(24558,19507,'Y','18','021','EC','A','','','AC','0000737910','0000737910','OH00002446935','IL','1','grubb','danny','','','','34','401278536','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1969-06-18','M','M',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:05:55'),(4245,3381,'N','01','021','EC','A',NULL,NULL,'','0000982434','0000411635','','IL','1','CANALES','JOSE','A','','','34','451910051','14166 CLOVER POINT DR',0,'SUGAR LAND','TX','77498','1732','CY','48157','1952-11-30','M','',NULL,'N','021','DEN','1723680','33348TX002000201','2014-01-01','2013-12-17 16:51:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 21:51:08'),(9204,7301,'Y','18','021','EC','A','','','AC','0000717217','0000717217','MS00000292494','IL','1','Day','laquita','','','','34','425693953','322 Maple Street',0,'Jackson','MS','39203',NULL,'CY','28049','1990-02-16','F','U',':RET:2054-5','N','021','DEN','2011719','46300MS002000201','2014-01-01','2013-12-18 11:02:08','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:09:46'),(3297,2657,'Y','18','021','EC','A','','','AC','0000524487','0000524487','OH00000210343','IL','1','Murphy','Cheryl','','','','34','319647554','255 GUILFORD BLVD',0,'MEDINA','OH','44256','2134','CY','39103','1967-11-18','F','M',':RET:2106-3','N','021','DEN','1471448','99734OH005000301','2014-01-01','2013-12-22 12:30:55','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:15:39'),(6514,5164,'Y','18','024','14','A','','','TE','0000224704','0000224704','','IL','1','Hirt','JoAnna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-15','F','',NULL,NULL,NULL,'','385723','','2013-12-10','2013-12-10 19:08:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:51:13'),(13667,10905,'Y','18','021','EC','A','','','AC','0002038940','0002038940','LA00001293910','IL','1','KNOX','DEBRA','','','','34','020402370','5605 VESTA ST',0,'ALEXANDRIA','LA','71303','2252','CY','22079','1959-05-20','F','M',':RET:2106-3','N','021','DEN','2239324','18575LA002000101','2014-01-01','2013-12-23 15:23:49','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-26 13:07:48'),(16321,13067,'Y','18','021','EC','A','','','AC','0001548248','0001548248','LA00001394117','IL','1','nguyen','no','','','','34','439831403','20357 chaumont ave',0,'baton rouge','LA','70817',NULL,'CY','22033','1970-10-02','M','M',':RET:2047-9','N','021','DEN','2561030','18575LA002000201','2014-02-01','2014-01-06 16:56:06','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:42'),(18968,15114,'Y','18','021','EC','A','','','AC','0000964647','0000964647','OH00002518254','IL','1','KOVACH','OLGA','','','','34','270764517','122 CENTER ST',0,'CHARDON','OH','44024','1120','CY','39055','1963-07-07','F','M',':RET:2106-3','N','021','DEN','2562252','99734OH005000301','2014-03-01','2014-01-16 19:06:07','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:06:00'),(19344,15420,'N','01','021','EC','A',NULL,NULL,'','0001104472','0000203114','','IL','1','Bergdorf','Diane','MARIE','','','34','273587069','5868 GROVE RD',0,'CLINTON','OH','44216','9719','CY','39153','1955-10-26','F','',':RET:2106-3','N','021','DEN','3190513','99734OH005000301','2014-03-01','2014-01-20 19:33:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:23'),(21092,16855,'Y','18','021','EC','A','','','AC','0001930308','0001930308','LA00001967958','IL','1','Guggenheim','Tonya','Joanne','','','34','452738652','2826 MISTY LN',0,'BOSSIER CITY','LA','71111','3256','CY','22015','1978-05-19','F','M',':RET:2106-3','N','021','DEN','2673912','18575LA002000101','2014-03-01','2014-02-02 15:59:56','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-02 19:00:28'),(21286,17010,'N','19','021','EC','A',NULL,NULL,'','0001729348','0002215785','','IL','1','Mancilla','Pedro','','','','34','635789717','6512 PARK MANOR DR',0,'METAIRIE','LA','70003','3926','CY','22051','1993-03-30','M','',NULL,'N','021','DEN','3138284','18575LA002000101','2014-03-01','2014-02-03 18:29:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2014-02-04 21:00:05'),(247,206,'Y','18','021','EC','A','','','AC','0000491838','0000491838','OH00001080802','IL','1','Snyder','Tabitha','','','','34','272922088','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1986-06-05','F','M',':RET:2106-3','N','021','HLT','660869','92036OH003002606','2014-01-01','2013-12-05 13:45:22','151.02',NULL,NULL,'444.53','293.53','R-OH001','OH0','213.40',NULL,0,'2013-12-25 17:21:28'),(6191,4905,'Y','18','021','EC','A','','','AC','0000844554','0000844554','TX00000980733','IL','1','Churchill','Dale','','','','34','450987297','5 SPRING VALLEY CT',0,'RICHARDSON','TX','75081','4431','CY','48113','1954-06-12','M','U',':RET:2106-3','N','021','DEN','408049','33348TX002000201','2014-01-01','2013-10-23 02:41:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:30:19'),(18124,14475,'Y','18','021','EC','A','','','AC','0000611972','0000611972','OH00001762830','IL','1','Lord','Patricia','','','','34','264177455','1976 KELSEY DR',0,'CUYAHOGA FALLS','OH','44221','4344','CY','39153','1962-08-30','F','M',':RET:2106-3','N','021','HLT','2656983','52664OH152000901','2014-02-01','2014-01-14 18:04:12','566.00',NULL,NULL,'596.36','30.36','R-OH012','OH0','304.63',NULL,0,'2014-01-15 02:07:41'),(22767,18177,'Y','18','021','EC','A','','','AC','0000877151','0000877151','OH00002353675','IL','1','Earhart','Barbara','','','','34','297664527','22 Ellen Circle',0,'Hamilton','OH','45011',NULL,'CY','39017','1960-03-07','F','M',':RET:2106-3','N','021','DEN','2902111','99734OH005000401','2014-03-01','2014-02-11 11:37:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:36'),(23946,19040,'Y','18','021','EC','A','','','AC','0002280124','0002280124','LA00002422363','IL','1','Turner','Tress','','','','34','439378400','823 NAVARRE AVE',0,'NEW ORLEANS','LA','70124','2707','CY','22071','1965-06-20','F','U',':RET:2106-3','N','021','DEN','3114489','18575LA002000201','2014-03-01','2014-02-15 13:08:12','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-15 21:00:12'),(27117,21464,'Y','18','021','EC','A','','','AC','0000992729','0000992729','OH00003132237','IL','1','Stone','david','','','','34','297827482','518 BLAINE ST',0,'GENEVA','OH','44041','1610','CY','39007','1984-08-13','M','U',':RET:2106-3','N','021','DEN','3192934','99734OH005000301','2014-04-01','2014-03-03 13:04:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:31'),(29065,23004,'N','19','021','EC','A',NULL,NULL,'','0000552689','0000247960','','S1','1','Kerr','Michelle','','','','34','293060024','4134 N LOCKWOOD AVE',0,'TOLEDO','OH','43612','1745','CY','39095','2002-01-03','F','',NULL,'N','021','HLT','3276340','92036OH004002601','2014-04-01','2014-03-10 12:08:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-10 21:01:54'),(135,117,'Y','18','021','EC','A','','','AC','0000103864','0000103864','OH00000161323','IL','1','Wiandt','Wendy','','','','34','286787972','7927 OVERTON RD',0,'BURBANK','OH','44214','9516','CY','39169','1969-12-23','F','M',':RET:2106-3','N','021','HLT','6429','52664OH152000901','2014-01-01','2013-12-04 20:55:35','555.00',NULL,NULL,'663.82','108.82','R-OH014','OH0','228.19',NULL,0,'2013-12-25 17:18:35'),(14814,11833,'Y','18','021','EC','A','','','AC','0001623394','0001623394','LA00000150722','IL','1','Hebert','Jarrod','','','','34','436798534','1002 CYPRESS LN',0,'SAINT MARTINVILLE','LA','70582','6516','CY','22099','1990-08-13','M','U',':RET:2106-3','N','021','DEN','2532517','18575LA002000201','2014-01-01','2013-12-23 20:35:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:14:09'),(165,139,'Y','18','021','EC','A','','','AC','0000555348','0000555348','OH00000402525','IL','1','Brown','Sibble','','','','34','275708541','2963 commdor lane',0,'cicinnatti','OH','45251',NULL,'CY','39061','1961-12-16','F','U',':RET:2054-5','N','021','HLT','428114','92036OH004001201','2014-01-01','2013-12-05 17:19:15','260.00',NULL,NULL,'446.54','186.54','R-OH004','OH0','336.93',NULL,0,'2013-12-25 17:19:18'),(6808,5400,'Y','18','021','EC','A','','','AC','0001230634','0001230634','TX00001194942','IL','1','Steptoe','Andrea','monae','','','34','458450777','12265 fondren rd',0,'houston','TX','77035',NULL,'CY','48201','1975-10-18','F','U',':RET:2054-5','N','021','DEN','142972','33348TX002000201','2014-01-01','2013-11-14 09:27:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:30:13'),(6490,5141,'Y','18','021','EC','A','','','AC','0000509183','0000509183','OH00000863122','IL','1','Ringler','Larry','','','','34','272502735','873 BLANDING AVE',0,'AKRON','OH','44310','4004','CY','39153','1952-06-23','M','U',NULL,'N','021','HLT','361990','52664OH151001305','2014-01-01','2013-12-11 12:17:18','472.00',NULL,NULL,'626.65','154.65','R-OH012','OH0','626.65',NULL,0,'2013-12-26 00:50:33'),(234,195,'N','01','021','EC','A',NULL,NULL,'','0000337587','0000105339','','IL','1','reiser','bruce','','','','34','214607232','415 FLEMRIDGE CT',0,'WYOMING','OH','45231','4015','CY','39061','1955-06-04','M','',':RET:2106-3','N','021','HLT','481342','92036OH006001201','2014-01-01','2013-12-05 18:00:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','433.78',NULL,0,'2013-12-25 17:21:06'),(2857,2308,'N','01','021','EC','A',NULL,NULL,'','0000485693','0000484582','','IL','1','eskridge','joan','','','','34','376620685','4265 WILDERNESS RUN DR',0,'ZACHARY','LA','70791','2863','CY','22033','1955-07-11','F','',':RET:2054-5','N','021','DEN','392477','18575LA002000201','2014-01-01','2013-11-02 11:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:01:32'),(5078,4024,'Y','18','024','14','A','','','TE','0000485233','0000485233','','IL','1','Moreno','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-08','M','',NULL,NULL,NULL,'','754970','','2013-12-19','2013-12-19 13:39:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:00:53'),(16048,12851,'Y','18','021','EC','A','','','AC','0001162039','0001162039','TX00001862018','IL','1','Morris','Barbara','','','','34','459040103','2205 Dartmouth Dr',0,'Arlington','TX','76015',NULL,'CY','48439','1954-02-01','F','M',':RET:2106-3','N','021','DEN','2078964','33348TX002000101','2014-02-01','2014-01-03 17:58:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-04 02:03:06'),(16540,13231,'Y','18','021','EC','A','','','AC','0000499671','0000499671','TX00001586073','IL','1','RAJU','SUGUNA','','','','34','428023314','708 SUMMERFIELD DR',0,'MURPHY','TX','75094','4256','CY','48085','1950-11-12','F','U',':RET:2029-7','N','021','DEN','2467764','33348TX002000101','2014-02-01','2014-01-05 08:53:19','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2014-01-07 10:22:19'),(23265,18550,'Y','18','021','EC','A','','','AC','0000987360','0000987360','OH00002700739','IL','1','Carnes','Michael','','','','34','310548586','461 SANOMA CT',0,'CINCINNATI','OH','45255','5645','CY','39025','1951-01-09','M','M',':RET:2106-3','N','021','DEN','2961704','99734OH005000301','2014-03-01','2014-02-13 14:33:29','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00','CIC',0,'2014-02-13 21:30:11'),(23541,18754,'Y','18','021','EC','A','','','AC','0002367650','0002367650','LA00002381222','IL','1','Glass','Lolita','','','','34','436239940','2727 GADSDEN ST',0,'KENNER','LA','70062','5035','CY','22051','1966-06-04','F','M',':RET:2054-5','N','021','DEN','3331941','18575LA002000201','2014-03-01','2014-02-13 12:50:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:32'),(24843,19695,'N','01','021','EC','A',NULL,NULL,'','0000857169','0000242757','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','HLT','2640425','52664OH152000901','2014-04-01','2014-02-19 09:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.68',NULL,0,'2014-02-20 04:54:05'),(1281,1059,'Y','18','021','EC','A','','','AC','0000884178','0000884178','OH00000180286','IL','1','Loveall','James','Boyd','','','34','300681883','7556 CHATEAU CT',0,'WEST CHESTER','OH','45069','2350','CY','39017','1970-12-27','M','U',NULL,'N','021','DEN','197685','99734OH005000401','2014-01-01','2013-11-29 09:45:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:30:33'),(15451,12364,'Y','18','021','EC','A','','','AC','0000471842','0000471842','TX00001625294','IL','1','Goeser','Wendy','','','','34','105480690','406 W GARNETT ST',0,'GAINESVILLE','TX','76240','5240','CY','48097','1955-09-07','F','M',':RET:2106-3','N','021','DEN','2613773','33348TX002000201','2014-02-01','2013-12-31 15:48:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:28:23'),(15289,12224,'Y','18','021','EC','A','','','AC','0002334851','0002334851','LA00001732558','IL','1','rogers','robinette','','','','34','433556713','1575 lot 1 hwy 55 montgut',0,'montgut','LA','70377',NULL,'CY','22109','1984-03-25','F','U',NULL,'N','021','DEN','1760765','18575LA002000101','2014-02-01','2013-12-31 18:44:03','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,1,'2014-01-02 04:22:24'),(2199,1810,'Y','18','021','EC','A','','','AC','0000819761','0000819761','OH00000516282','IL','1','Lee','Sheena','','','','34','286829980','725 TAFT ST',0,'SIDNEY','OH','45365','2541','CY','39149','1984-10-21','F','U',NULL,'N','021','HLT','987341','92036OH003000506','2014-01-01','2013-12-10 11:54:37','178.00',NULL,NULL,'277.77','99.77','R-OH003','OH0','277.77',NULL,0,'2013-12-25 19:19:58'),(14783,11806,'Y','18','021','EC','A','','','AC','0000109281','0000109281','OH00001030431','IL','1','FLECK','AMY','ELIZABETH','','','34','268644674','378 WEATHERSTONE DR',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1973-02-03','F','M',':RET:2106-3','N','021','DEN','1682289','99734OH005000401','2014-01-01','2013-12-23 20:32:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,1,'2013-12-29 11:13:16'),(19607,15627,'Y','18','021','EC','A','','','AC','0001063272','0001063272','OH00002582311','IL','1','Ethridge','James','','','','34','284603932','7050 Chillicothe Rd.',0,'Mentor','OH','44060',NULL,'CY','39085','1964-12-30','M','R',':RET:2106-3','T','021','HLT','1766296','52664OH152000901','2014-03-01','2014-01-22 10:01:14','0.00',NULL,NULL,'667.35','667.35','R-OH011','OH0','361.43',NULL,0,'2014-01-23 03:02:49'),(20544,16417,'Y','18','021','EC','A','','','AC','0000012462','0000012462','OH00001752522','IL','1','Jones','David','','','','34','281829789','2063 garden lake dr.',0,'toledo','OH','43614',NULL,'CY','39095','1967-11-24','M','M',':RET:2106-3','T','021','HLT','3219637','92036OH006002601','2014-03-01','2014-01-29 17:17:48','32.00',NULL,NULL,'266.76','234.76','R-OH001','OH0','266.76',NULL,0,'2014-01-29 21:01:37'),(24486,19452,'Y','18','021','EC','A','','','AC','0001455054','0001455054','LA00002189017','IL','1','LASSITTER','JAMES','','','','34','263338620','5510 LA 44',0,'CONVENT','LA','70723','2114','CY','22093','1955-10-19','M','M',':RET:2106-3','T','021','DEN','2620043','18575LA002000101','2014-04-01','2014-02-18 19:48:16','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-20 03:42:23'),(24529,19485,'Y','18','021','EC','A','','','AC','0000663254','0000663254','TX00003068967','IL','1','MECINAS MESTAS','RAFAEL','','','','34','620280605','10972 SOMBRA VERDE DR',0,'EL PASO','TX','79935','3709','CY','48141','1963-08-12','M','M',NULL,'N','021','DEN','3300508','33348TX002000201','2014-04-01','2014-02-19 16:31:22','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-20 04:00:01'),(9277,7360,'Y','18','021','EC','A','','','AC','0000836609','0000836609','OH00000269739','IL','1','Comello','Michelle','','','','34','281721408','3273 Coleen Dr',0,'Cincinnati','OH','45251',NULL,'CY','39061','1964-01-06','F','U',':RET:2106-3','T','021','HLT','46043','92036OH005001206','2014-01-01','2013-11-30 11:24:15','294.00',NULL,NULL,'421.17','127.17','R-OH004','OH0','421.17',NULL,0,'2013-12-26 04:15:50'),(19954,15916,'N','01','021','EC','A',NULL,NULL,'','0001505532','0001641075','','IL','1','RAMIREZ','ANA','','','','34','102673330','4318 MACARTHUR BLVD',0,'NEW ORLEANS','LA','70131','6844','CY','22071','1964-09-23','F','',NULL,'N','021','DEN','3158785','18575LA002000201','2014-03-01','2014-01-25 16:41:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-25 19:00:04'),(15322,12254,'Y','18','021','EC','A','','','AC','0001123525','0001123525','TX00001942438','IL','1','Crenshaw','Shovon','','','','34','571197949','3550 TIMBERGLEN RD',0,'DALLAS','TX','75287','3491','CY','48121','1968-07-12','F','U',':RET:2054-5^:RET:2039-6','N','021','DEN','2244613','33348TX002000201','2014-02-01','2013-12-31 21:54:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:23:35'),(15883,12718,'N','01','021','EC','A',NULL,NULL,'','0001203573','0002026464','','IL','1','Gafford','Samantha','','','','34','433711309','9465 MCADOO ST',0,'SHREVEPORT','LA','71118','3807','CY','22017','1973-11-10','F','',NULL,'N','021','DEN','1541519','18575LA002000101','2014-02-01','2014-01-02 11:23:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-03 02:05:28'),(19088,15207,'Y','18','021','EC','A','','','AC','0001234140','0001234140','OH00001796644','IL','1','Burley','Pamela','','','','34','573299785','931 W HIGH ST',0,'MOUNT VERNON','OH','43050','2242','CY','39083','1958-12-03','F','M',':RET:2106-3','T','021','DEN','1585023','99734OH005000301','2014-03-01','2014-01-17 22:51:58','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:44:30'),(18995,15129,'N','01','021','EC','A',NULL,NULL,'','0001064742','0000145405','','IL','1','VILLA','JENNIFER','','','','34','176645707','5625 NICHOLSON DR',0,'HUDSON','OH','44236',NULL,'CY','39153','1968-10-02','F','',NULL,'N','021','HLT','2214063','52664OH151001305','2014-03-01','2014-01-17 16:11:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.02',NULL,0,'2014-01-20 08:06:13'),(21791,17403,'Y','18','021','EC','A','','','AC','0000299285','0000299285','OH00001605189','31','1','fowee','carol','','','','34','295625891','p.o. box 435',0,'lynchburg','OH','45142',NULL,'CY','39071','1957-08-22','F','U',':RET:2106-3','N','021','DEN','3266665','99734OH005000401','2014-03-01','2014-02-06 14:48:36','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-06 21:00:44'),(21922,17508,'N','01','021','EC','A',NULL,NULL,'','0000645514','0000554435','','IL','1','PEREZ','MARIA','SANTA','','','34','623417470','1701 LOMALAND DR',0,'EL PASO','TX','79935',NULL,'CY','48141','1961-03-31','F','',':RET:2106-3','N','021','DEN','3376455','33348TX002000201','2014-03-01','2014-02-06 19:19:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-07 19:00:06'),(23378,18628,'Y','18','021','EC','A','','','AC','0000540337','0000540337','OH00002201584','IL','1','Howlett','Carol','','','','34','288564367','1103 Cutler Lane',0,'Hudson','OH','44236',NULL,'CY','39153','1953-08-26','F','U',':RET:2106-3','N','021','DEN','2854004','99734OH005000401','2014-03-01','2014-02-13 11:37:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-13 22:00:57'),(26644,21127,'Y','18','021','EC','A','','','AC','0000759761','0000759761','OH00002210329','IL','1','Torres','Gustavo','','','','34','297083937','4523 Vista Circle',0,'Kent','OH','44240',NULL,'CY','39133','1968-02-14','M','M',NULL,'N','021','HLT','2980732','52664OH151001304','2014-04-01','2014-02-28 10:31:22','475.00',NULL,NULL,'867.28','392.28','R-OH012','OH0','334.51',NULL,0,'2014-02-28 21:31:05'),(27663,21881,'Y','18','021','EC','A','','','AC','0000736580','0000736580','OH00003129604','IL','1','KENNEDY','JESSICA','','','','34','269924328','669 WOODDUCK CT',0,'COLUMBUS','OH','43215','7032','CY','39049','1984-03-18','F','U',NULL,'N','021','DEN','3566005','99734OH005000401','2014-04-01','2014-03-05 16:21:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-05 21:30:28'),(27708,21911,'N','19','021','EC','A',NULL,NULL,'','0001151267','0000228488','','IL','1','LOPEZ','DAVID','','','','34','617588123','16510 SPERRY GARDENS DR',0,'HOUSTON','TX','77095','5551','CY','48201','1992-07-27','M','',NULL,'N','021','DEN','3295852','33348TX002000201','2014-04-01','2014-03-05 12:29:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-05 21:30:52'),(5958,4719,'Y','18','021','EC','A','','','AC','0000481082','0000481082','OH00001204535','IL','1','wallis','thomas',NULL,NULL,NULL,NULL,NULL,'2630 BRITAINIA CT',0,'TOLEDO','OH','43617','2326','CY','39095','1960-07-11','M','U',':RET:2106-3','N','021','HLT','2366988','92036OH001002601','2014-01-01','2013-12-23 23:27:32','280.00',NULL,NULL,'479.83','199.83','R-OH001','OH0','479.83',NULL,0,'2013-12-25 23:51:19'),(21661,17300,'Y','18','021','EC','A','','','AC','0001631177','0001631177','LA00001392064','IL','1','Lamonte','Deborah','','','','34','427619729','1420 GENERAL PERSHING ST',0,'NEW ORLEANS','LA','70115','3808','CY','22071','1982-04-13','F','U',NULL,'N','021','DEN','3467932','18575LA002000201','2014-03-01','2014-02-05 13:12:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:54'),(709,586,'Y','18','021','EC','A','','','AC','0000994365','0000994365','LA00000679562','IL','1','Lege','Jonathan','','','','34','436615519','806 HOUMA BLVD',0,'METAIRIE','LA','70001','4733','CY','22051','1985-07-18','M','U',':RET:2106-3','N','021','DEN','279623','18575LA002000201','2014-01-01','2013-12-15 23:54:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:03:08'),(20185,16108,'N','19','021','EC','A',NULL,NULL,'','0000533968','0000558020','','IL','1','samaha','laith','','','','34','446252866','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','2009-02-24','M','',':RET:2106-3','N','021','DEN','2702806','33348TX002000101','2014-03-01','2014-01-27 00:47:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-27 21:01:23'),(4292,3414,'Y','18','021','EC','A','','','AC','0000517484','0000517484','MS00000968411','IL','1','WILLIAMS','MILGRED','B','','','34','587366216','2140 WILLIAMS RD',0,'STARKVILLE','MS','39759','8801','CY','28105','1951-10-19','F','U',NULL,'N','021','DEN','2154788','46300MS002000201','2014-01-01','2013-12-17 10:25:56','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 21:52:10'),(3985,3182,'Y','18','021','EC','A','','','AC','0000273767','0000273767','OH00000225493','IL','1','Suttles','Jason','','','','34','282844912','102 BACON ST',0,'CINCINNATI','OH','45215','2903','CY','39061','1970-06-18','M','M',':RET:2106-3','T','021','HLT','46351','92036OH003001205','2014-01-01','2013-12-13 13:10:34','363.00',NULL,NULL,'654.05','291.05','R-OH004','OH0','349.84',NULL,0,'2013-12-25 21:38:56'),(19010,15139,'N','19','021','EC','A',NULL,NULL,'','0001640013','0002106179','','IL','1','Francios','Brittani','','','','34','435739508','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1988-07-28','F','',NULL,'N','021','DEN','1433763','18575LA002000201','2014-03-01','2014-01-17 12:04:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-20 08:06:20'),(3689,2953,'Y','18','021','EC','A','','','AC','0001056674','0001056674','OH00000164044','IL','1','GOODMAN','GREGORY','JOSEPH','','','34','279680232','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1965-08-29','M','M',':RET:2106-3','N','021','DEN','321464','99734OH005000401','2014-01-01','2013-12-13 10:39:46','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:31:41'),(13431,10714,'Y','18','021','EC','A','','','AC','0000977937','0000977937','OH00000387081','IL','1','LEGAN','DENNIS','','','','34','271606356','7702 GHEOTA AVE',0,'GARMA','OH','44129',NULL,'CY','39035','1955-08-05','M','U',':RET:2106-3','N','021','DEN','2005547','99734OH005000301','2014-01-01','2013-12-23 12:21:20','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:02'),(16172,12948,'Y','18','021','EC','A','','','AC','0001196192','0001196192','LA00000748262','IL','1','GRUBBS','SARAH','','','','34','437855578','7414 PRAIRIE DR',0,'GREENWELL SPRINGS','LA','70739','3055','CY','22033','1985-09-29','F','U',':RET:2106-3','T','021','DEN','2469039','18575LA002000201','2014-02-01','2014-01-03 22:56:56','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-05 00:00:15'),(15675,12539,'Y','18','021','EC','A','','','AC','0000043240','0000043240','OH00001493293','IL','1','Milefchik','Jennifer','','','','34','296802411','322 Wilson Ave',0,'Port Clinton','OH','43452',NULL,'CY','39123','1977-10-15','F','M',':RET:2106-3','N','021','HLT','2474421','92036OH004002701','2014-02-01','2013-12-31 16:54:53','259.00',NULL,NULL,'485.29','226.29','R-OH006','OH0','192.86',NULL,1,'2014-01-02 04:34:48'),(14600,11653,'Y','18','024','14','A','','','TE','0000714953','0000714953','','IL','1','Escribano','Giovanny',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-28','M','',NULL,NULL,NULL,'','166636','','2013-12-27','2013-12-27 11:04:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:23'),(22585,18038,'Y','18','021','EC','A','','','AC','0000318451','0000318451','OH00001743297','S3','1','PRATT','STEPHANIE','','','','34','274066987','1419 VIRGINIA AVE',0,'AKRON','OH','44306',NULL,'CY','39153','2000-12-16','M','U',NULL,'N','021','DEN','2637497','99734OH005000101','2014-03-01','2014-02-10 11:42:01','0.00',NULL,NULL,'27.59','27.59','R-OH012','OH0','27.59',NULL,0,'2014-02-10 21:32:05'),(26518,21031,'N','01','021','EC','A',NULL,NULL,'','0000294433','0000295517','','IL','1','Dietrich','Kara','M','','','34','296660761','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1974-11-15','F','',NULL,'N','021','HLT','3280933','92036OH003002706','2014-03-01','2014-02-28 14:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','256.98','CIC',0,'2014-02-28 21:00:23'),(39,34,'Y','18','024','14','A','','','TE','0000398580','0000398580','','IL','1','MCKINNEY','LARRY','H',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-13','M','',NULL,NULL,NULL,'','584999','','2013-12-05','2013-12-05 12:56:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:16:00'),(219,184,'Y','18','021','EC','A','','','AC','0000039177','0000039177','LA00000092295','IL','1','Presley','Damon','','','','34','434770756','3201 Knight St',0,'Shreveport','LA','71105',NULL,'CY','22017','1986-04-14','M','R',NULL,'N','021','DEN','684300','18575LA002000201','2014-01-01','2013-12-05 11:25:10','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 17:20:43'),(21511,17186,'Y','18','021','EC','A','','','AC','0000930942','0000930942','OH00001352240','IL','1','Young','Jami','','','','34','279820266','6031 CARPENTER RD',0,'DEFIANCE','OH','43512','8292','CY','39039','1979-02-07','F','U',':RET:2106-3','N','021','HLT','3582367','92036OH001002601','2014-03-01','2014-02-04 17:52:30','107.00',NULL,NULL,'287.41','180.41','R-OH001','OH0','287.41',NULL,0,'2014-02-04 21:01:58'),(21188,16933,'Y','18','021','EC','A','','','AC','0000647517','0000647517','MS00002420639','31','1','Martin','Virgil','','','','34','524680619','P.O. Box 429',0,'Gloster','MS','39638',NULL,'CY','28005','1949-08-11','M','M',':RET:2054-5','N','021','DEN','3374932','46300MS002000101','2014-03-01','2014-02-03 12:35:16','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-02-03 21:00:47'),(19494,15536,'N','01','021','EC','A',NULL,NULL,'','0000049533','0000330908','','IL','1','Carpenter','Gene','W','','','34','268763163','7430 WHITEWOOD DR',0,'ASHTABULA','OH','44004','9413','CY','39007','1964-01-31','M','',':RET:2106-3','N','021','HLT','2396221','52664OH151001304','2014-03-01','2014-01-22 10:48:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','449.21',NULL,0,'2014-01-23 03:02:07'),(17189,13755,'Y','18','021','EC','A','','','AC','0000799579','0000799579','TX00002282458','IL','1','LOPEZ','LILIAN','','','','34','508134332','3816 YUCCA AVE',0,'MCALLEN','TX','78504','5217','CY','48215','1978-12-06','F','M',':RET:2106-3','N','021','DEN','1426463','33348TX002000101','2014-02-01','2014-01-08 16:31:00','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-01-13 02:22:17'),(16470,13179,'Y','18','021','EC','A','','','AC','0000140297','0000140297','OH00002191899','IL','1','Zenobia','Johnson','','','','34','278687422','697 MORELEY AVENUE',0,'AKRON','OH','44320',NULL,'CY','39153','1961-10-30','F','U',':RET:2054-5','N','021','HLT','2337711','52664OH151001305','2014-02-01','2014-01-06 13:19:50','299.00',NULL,NULL,'435.31','136.31','R-OH012','OH0','435.31',NULL,0,'2014-01-07 04:05:55'),(4407,3503,'Y','18','021','EC','A','','','AC','0000803710','0000803710','OH00000470548','IL','1','DEVORE','DREW','','','','34','272902005','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1985-09-20','M','M',NULL,'N','021','DEN','252161','99734OH005000401','2014-01-01','2013-12-12 14:40:57','0.00',NULL,NULL,'71.95','71.95','R-OH015','OH0','0.00',NULL,0,'2013-12-25 22:01:18'),(15660,12529,'Y','18','021','EC','A','','','AC','0000118131','0000118131','TX00001609096','31','1','TREVINO','YOLANDA','','','','34','455310128','PO BOX 123',0,'WILSON','TX','79381',NULL,'CY','48305','1961-12-08','F','U',NULL,'N','021','DEN','1914745','33348TX002000101','2014-02-01','2013-12-30 22:26:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,1,'2014-01-02 04:34:25'),(13863,11061,'N','19','021','EC','A',NULL,NULL,'','0001127991','0000515832','','IL','1','Davis','Autumn','N','','','34','301984460','2542 RANFIELD RD',0,'MOGADORE','OH','44260','9457','CY','39133','1996-06-24','F','',':RET:2106-3','N','021','HLT','1864308','52664OH151001501','2014-01-01','2013-12-22 23:20:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 13:12:52'),(2529,2060,'N','19','021','EC','A',NULL,NULL,'','0001241834','0001083062','','IL','1','Andreadis','Devi','','','','34','294042314','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','2000-02-18','F','',':RET:2106-3','N','021','HLT','1176892','92036OH001001201','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-25 19:36:46'),(1510,1259,'Y','18','021','EC','A','','','AC','0001059475','0001059475','OH00001574922','IL','1','Weltin','Karin','O','','','34','300544119','7337 FAIRFIELD LAKES DR',0,'POWELL','OH','43065','7880','CY','39041','1953-06-11','F','U',':RET:2106-3','N','021','DEN','1514580','99734OH005000401','2014-01-01','2013-12-24 13:11:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:30'),(22541,17999,'Y','18','021','EC','A','','','AC','0001314138','0001314138','LA00001774701','IL','1','Simmons','Angela','','','','34','436515608','27699 CHURCH OF GOD RD',0,'SPRINGFIELD','LA','70462','9023','CY','22063','1979-02-05','F','U',':RET:2106-3','T','021','DEN','3646030','18575LA002000101','2014-03-01','2014-02-10 10:30:06','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-10 21:31:39'),(23649,18831,'N','01','021','EC','A',NULL,NULL,'','0000882602','0000987414','','IL','1','Esparza','Monica','','','','34','452771163','108 REDWOOD LN',0,'LEVELLAND','TX','79336','6606','CY','48219','1984-04-07','F','',':RET:2106-3','N','021','DEN','3540331','33348TX002000201','2014-03-01','2014-02-13 23:23:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-14 21:30:13'),(26705,21171,'Y','18','021','EC','A','','','AC','0000872106','0000872106','OH00002340784','IL','1','Negrete','Benilde',NULL,NULL,NULL,NULL,NULL,'841 US HIGHWAY 224 W',0,'WILLARD','OH','44890','9319','CY','39077','1954-07-28','F','U',NULL,'N','021','HLT','2995425','92036OH004002701','2014-04-01','2014-02-28 09:31:28','405.16',NULL,NULL,'408.14','2.98','R-OH006','OH0','408.14',NULL,0,'2014-02-28 21:31:35'),(28700,22713,'Y','18','021','EC','A','','','AC','0000448836','0000448836','OH00003492417','IL','1','Chinn','David','Barry','','','34','301584577','70 Highmeadow Lane',0,'Williamsburg','OH','45176',NULL,'CY','39025','1958-09-17','M','U',NULL,'T','021','HLT','3892074','92036OH006000601','2014-04-01','2014-03-07 20:21:55','376.00',NULL,NULL,'436.60','60.60','R-OH005','OH0','436.60',NULL,0,'2014-03-08 21:31:08'),(715,591,'Y','18','021','EC','A','','','AC','0000323481','0000323481','OH00000361910','31','1','Smith','Katherine','','','','34','279744946','PO Box 332',0,'Attica','OH','44807',NULL,'CY','39147','1978-11-17','F','M',':RET:2106-3','T','021','HLT','1565626','92036OH005002706','2014-01-01','2013-12-16 14:44:38','395.00',NULL,NULL,'478.36','83.36','R-OH006','OH0','274.01',NULL,0,'2013-12-25 18:03:18'),(21487,17170,'Y','18','021','EC','A','','','AC','0000408509','0000408509','OH00002047996','IL','1','BEASLEY','SUSAN','','','','34','509568325','3411 PECAN LN',0,'WOOSTER','OH','44691','5903','CY','39169','1950-07-08','F','U',NULL,'N','021','DEN','3800714','99734OH005000301','2014-03-01','2014-02-04 18:13:39','0.00',NULL,NULL,'21.13','21.13','R-OH014','OH0','0.00',NULL,0,'2014-02-04 21:01:46'),(1156,954,'Y','18','021','EC','A','','','AC','0000312360','0000312360','LA00001087153','IL','1','LANDRY','LINDA','BERGERON','','','34','437080125','43245 SYCAMORE BEND AVE',0,'GONZALES','LA','70737','7782','CY','22005','1967-10-17','F','M',':RET:2106-3','N','021','DEN','1217625','18575LA002000201','2014-01-01','2013-12-03 14:16:22','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:46'),(1890,1546,'Y','18','024','14','A','','','TE','0000096388','0000096388','','IL','1','King','Christine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-08','F','',NULL,NULL,NULL,'','1994855','','2013-12-24','2013-12-24 12:01:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:58:49'),(3243,2613,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000260346','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','408035','92036OH006002601','2014-01-01','2013-10-05 22:52:27','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-25 20:46:23'),(19816,15799,'Y','18','021','EC','A','','','AC','0000374425','0000374425','TX00001690259','IL','1','ALLEN','DION','','','','34','459479183','2802 LANDMARK DR',0,'BAYTOWN','TX','77521','9261','CY','48201','1971-11-21','M','U',':RET:2054-5','N','021','DEN','2617080','33348TX002000201','2014-03-01','2014-01-24 12:04:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-24 21:00:12'),(14131,11263,'Y','18','021','EC','A','','','AC','0002149669','0002149669','LA00001429564','IL','1','Lavalais','Shirley','','','','34','436045360','1918 HIGHWAY 451',0,'MOREAUVILLE','LA','71355','3208','CY','22009','1957-07-05','F','U',':RET:2054-5','N','021','DEN','1627355','18575LA002000201','2014-02-01','2013-12-26 09:37:57','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-27 02:02:23'),(17595,14064,'Y','18','021','EC','A','','','AC','0000935158','0000935158','MS00002549797','IL','1','taylor','nikki','','','','34','452753187','4 LEISHA DR',0,'LONG BEACH','MS','39560','4049','CY','28047','1982-10-17','F','M',':RET:2106-3','N','021','DEN','2172243','46300MS002000201','2014-02-01','2014-01-12 20:33:47','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-14 01:32:12'),(25577,20288,'N','01','021','EC','A',NULL,NULL,'','0000123023','0000054518','','IL','1','Hirn','Rebecca','Lynn','','','34','311762329','410 E 3RD ST',0,'DELPHOS','OH','45833','1771','CY','39003','1974-11-24','F','',':RET:2106-3','N','021','HLT','3347484','92036OH001001501','2014-04-01','2014-02-23 15:37:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','335.02',NULL,0,'2014-02-26 08:00:33'),(26084,20686,'Y','18','021','EC','A','','','AC','0002285039','0002285039','LA00002811714','IL','1','White','Crandall','','','','34','433434606','1000 Willow Dr.',0,'Westwego','LA','70094',NULL,'CY','22051','1980-12-09','M','U',':RET:2054-5','N','021','DEN','3424320','18575LA002000201','2014-04-01','2014-02-26 20:59:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:05'),(7272,5767,'Y','18','021','EC','A','','','AC','0000243618','0000243618','TX00000575900','IL','1','Davis','Dotzie','','','','34','551087230','1015 COUNTY ROAD 158',0,'LONG BRANCH','TX','75669','2613','CY','48365','1963-11-22','F','M',':RET:2054-5','N','021','DEN','439089','33348TX002000201','2014-01-01','2013-12-14 12:50:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:02:27'),(13198,10531,'Y','18','021','EC','A','','','AC','0000135125','0000135125','TX00000450496','IL','1','Dunn','Susan','Rebecca','','','34','457046230','7032 SMITHFIELD RD',0,'NORTH RICHLAND HILLS','TX','76182','3427','CY','48439','1954-11-03','F','U',':RET:2106-3','N','021','DEN','2494375','33348TX002000101','2014-01-01','2013-12-23 13:16:30','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:52'),(14662,11704,'Y','18','021','EC','A','','','AC','0000142130','0000142130','TX00000309078','IL','1','McWhorter','Terri','','','','34','453351364','2302 MOCKINGBIRD LN',0,'GARLAND','TX','75042','8305','CY','48113','1962-09-07','F','U',':RET:2106-3','N','021','DEN','2616364','33348TX002000201','2014-02-01','2013-12-27 23:29:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2013-12-29 11:08:01'),(14041,11186,'Y','18','021','EC','A','','','AC','0000258151','0000258151','OH00000012830','IL','1','Miley','Scott','A','','','34','276568927','117 11TH ST',0,'NILES','OH','44446','4317','CY','39155','1957-06-03','M','U',NULL,'T','021','HLT','1639772','92036OH004003201','2014-01-01','2013-12-23 17:42:57','463.00',NULL,NULL,'522.17','59.17','R-OH013','OH0','522.17',NULL,0,'2013-12-26 13:17:12'),(13012,10370,'Y','18','024','14','A','','','TE','0001231748','0001231748','','IL','1','Crutcher','Carrie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-15','F','',NULL,NULL,NULL,'','2515453','','2013-12-22','2013-12-22 19:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:49:48'),(9500,7535,'Y','18','021','EC','A','','','AC','0000714967','0000714967','OH00000966342','IL','1','MAZAR','LAURA','','','','34','217703646','8627 GIBSON RD',0,'CANFIELD','OH','44406','9745','CY','39099','1954-02-08','F','M',':RET:2106-3','N','021','DEN','2334907','99734OH005000401','2014-01-01','2013-12-21 15:13:54','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:35:09'),(24261,19266,'Y','18','021','EC','A','','','AC','0002168370','0002168370','LA00002014042','IL','1','Schittone','Jessica','','','','34','437378364','44207 Gold Place Road',0,'Saint Amant','LA','70774',NULL,'CY','22005','1978-07-17','F','U',':RET:2106-3','N','021','DEN','3360177','18575LA002000101','2014-04-01','2014-02-17 00:28:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-17 19:00:10'),(24600,19527,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000326237','','IL','1','Sexton','Sophia','Elizabeth','','','34','288113995','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2005-10-21','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:12:42'),(25416,20166,'Y','18','021','EC','A','','','AC','0000667831','0000667831','OH00002519071','IL','1','CLARIETTE','FREDDIE','A','','','34','413883525','1028 ROSLYN AVE',0,'AKRON','OH','44320','2708','CY','39153','1951-04-22','F','U',NULL,'N','021','DEN','3350391','99734OH005000401','2014-04-01','2014-02-25 13:54:52','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:31:06'),(6920,5493,'Y','18','021','EC','A','','','AC','0001075307','0001075307','OH00000505008','IL','1','Snyder','Sarah','','','','34','269780574','86990 AMSTERDAM RD',0,'JEWETT','OH','43986','9543','CY','39067','1965-06-01','F','U',':RET:2106-3','N','021','DEN','1967214','99734OH005000401','2014-01-01','2013-12-24 18:51:47','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:46:11'),(18876,15038,'Y','18','024','14','A','','','TE','0001377681','0001377681','','IL','1','Foley','Lillian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-02-13','F','',NULL,NULL,NULL,'','1850172','','2014-01-16','2014-01-16 14:58:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-17 03:36:26'),(6837,5420,'Y','18','021','EC','A','','','AC','0001008910','0001008910','OH00000827585','IL','1','Snavely','Joseph','','','','34','292881403','3747 CREEK RD',0,'CINCINNATI','OH','45241','2707','CY','39061','1972-04-13','M','M',':RET:2106-3','T','021','DEN','38291','99734OH005000401','2014-01-01','2013-11-14 14:21:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:30:57'),(15846,12689,'Y','18','021','EC','A','','','AC','0000798423','0000798423','OH00000830176','IL','1','Bacon','Karen','','','','34','385883155','1128 W State St',0,'Lima','OH','45805',NULL,'CY','39003','1979-03-11','F','M',':RET:2106-3','N','021','DEN','2535120','99734OH005000401','2014-02-01','2014-01-02 17:33:10','0.00',NULL,NULL,'71.95','71.95','R-OH002','OH0','0.00',NULL,0,'2014-01-03 02:04:19'),(2537,2064,'Y','18','021','EC','A','','','AC','0000134546','0000134546','OH00001023031','IL','1','Johnson','Theresa','','','','34','300503292','2277 US 50  box 520',0,'Owensville','OH','45103',NULL,'CY','39025','1950-12-05','F','U',':RET:2106-3','N','021','HLT','465191','92036OH005000606','2014-01-01','2013-12-09 09:05:43','525.00',NULL,NULL,'633.70','108.70','R-OH005','OH0','633.70',NULL,0,'2013-12-25 19:36:55'),(2654,2157,'Y','18','021','EC','A','','','AC','0000163649','0000163649','OH00000600701','IL','1','Savage','Michelle','','','','34','294807054','56 LOWELL RD',0,'COLUMBUS','OH','43209','1534','CY','39049','1967-01-02','F','U',':RET:2106-3','N','021','DEN','811829','99734OH005000301','2014-01-01','2013-12-01 19:20:44','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:42'),(8839,7006,'Y','18','021','EC','A','','','AC','0000944212','0000944212','TX00000147763','IL','1','Robinson','Frank','','','','34','262476844','212 E ELLIOTT ST',0,'BEEVILLE','TX','78102','6735','CY','48025','1960-07-27','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1494795','33348TX002000201','2014-01-01','2013-12-17 21:35:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:42'),(8118,6421,'Y','18','021','EC','A','','','AC','0000109252','0000109252','OH00000232454','IL','1','Akerman','Kaley','Nicole','','','34','681182100','31 Old Main Street West',0,'Miamisburg','OH','45342',NULL,'CY','39113','1999-07-20','F','U',':RET:2106-3','N','021','DEN','573694','99734OH005000401','2014-01-01','2013-11-21 19:41:10','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2013-12-26 03:15:12'),(3056,2455,'Y','18','021','EC','A','','','AC','0000684082','0000684082','LA00000680583','IL','1','Surritte-Armbruster','Michelle','Ann','','','34','149767433','544 HONORE DR',0,'JEFFERSON','LA','70121','1605','CY','22051','1968-04-10','F','M',':RET:2106-3','T','021','DEN','1251537','18575LA002000201','2014-01-01','2013-12-06 17:23:58','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:19:02'),(3828,3066,'Y','18','021','EC','A','','','AC','0001173199','0001173199','OH00001271656','IL','1','MANUEL','RHONDA','RAE','','','34','270542591','7292 FAIR RIDGE RD',0,'HILLSBORO','OH','45133','6677','CY','39071','1951-07-25','F','M',':RET:2106-3','N','021','DEN','572983','99734OH005000301','2014-01-01','2013-12-13 16:12:49','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:35:08'),(23314,18584,'Y','18','021','EC','A','','','AC','0000416004','0000416004','OH00002754780','IL','1','OVIAHON','NOSA','','','','34','296981617','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1968-01-15','M','M',':RET:2054-5','N','021','DEN','3381743','99734OH005000301','2014-03-01','2014-02-13 12:34:49','0.00',NULL,NULL,'87.78','87.78','R-OH001','OH0','0.00',NULL,0,'2014-02-13 22:00:22'),(25328,20095,'Y','18','021','EC','A','','','AC','0001348768','0001348768','LA00002537095','IL','1','Rosenbohm','Mark','','','','34','433230409','9413 CALVARY CT',0,'RIVER RIDGE','LA','70123','2054','CY','22051','1962-03-11','M','U',':RET:2106-3','N','021','DEN','2695048','18575LA002000201','2014-04-01','2014-02-25 12:42:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:15'),(27321,21633,'Y','18','021','EC','A','','','AC','0001120980','0001120980','TX00003727361','31','1','FREEMAN','RICKEY','','','','34','463020229','P O BOX 303',0,'MOSTOW','TX','75960',NULL,'CY','48373','1955-08-07','M','M',NULL,'N','021','DEN','3278839','33348TX002000201','2014-04-01','2014-03-04 16:23:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:46'),(27563,21802,'Y','18','021','EC','A','','','AC','0000346947','0000346947','OH00003669533','IL','1','Landow','Walter','','','','34','294502238','3319 BRAEMAR RD',0,'SHAKER HEIGHTS','OH','44120','3331','CY','39035','1966-10-12','M','M',':RET:2106-3','N','021','DEN','3460948','99734OH005000301','2014-04-01','2014-03-04 12:53:29','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00','CIC',0,'2014-03-04 21:30:18'),(27744,21938,'N','19','021','EC','A',NULL,NULL,'','0000211062','0000529503','','IL','1','Zemenski','Shelby',NULL,NULL,NULL,NULL,NULL,'5115 KELLER RD',0,'WALBRIDGE','OH','43465','9752','CY','39173','1996-08-21','F','',NULL,'N','021','HLT','3092831','92036OH004002601','2014-04-01','2014-03-04 18:08:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-05 21:31:10'),(28830,22816,'N','01','021','EC','A',NULL,NULL,'','0000179976','0000342786','','IL','1','Warnecke','Stacy','','','','34','271705368','19736 ROAD 22S',0,'FORT JENNINGS','OH','45844','9359','CY','39137','1973-07-12','F','',NULL,'N','021','HLT','3227875','92036OH003001504','2014-04-01','2014-03-09 11:21:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.73',NULL,0,'2014-03-09 21:01:06'),(1309,1083,'Y','18','021','EC','A','','','AC','0000206037','0000206037','LA00001132952','IL','1','White','Terry','','','','34','434474717','9532 GREAT SMOKEY AVE',0,'BATON ROUGE','LA','70814','4103','CY','22033','1977-05-06','M','U',':RET:2106-3','N','021','DEN','445430','18575LA002000201','2014-01-01','2013-11-04 17:43:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:31:24'),(4454,3539,'Y','18','021','EC','A','','','AC','0000974069','0000974069','OH00000243088','IL','1','Byers','Chrisann','','','','34','287504151','337 HOOVER RD',0,'VINCENT','OH','45784','5630','CY','39167','1949-12-28','F','M',':RET:2106-3','N','021','DEN','463054','99734OH005000301','2014-01-01','2013-12-12 10:42:08','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 22:02:27'),(21928,17513,'Y','18','021','EC','A','','','AC','0000246042','0000246042','TX00001909417','IL','1','MORENO','MARGARITTA','','','','34','643384472','11362 LONG JOHN DR',0,'EL PASO','TX','79936','3131','CY','48141','1958-11-07','F','M',':RET:2106-3','N','021','DEN','3417658','33348TX002000201','2014-03-01','2014-02-06 22:15:12','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-07 19:00:10'),(2336,1901,'N','19','021','EC','A',NULL,NULL,'','0000608600','0001025579','','IL','1','Rodriguez','Leticia','Guadalupe','','','34','595291568','2107 N CELIA DR',0,'CEDAR PARK','TX','78613','4619','CY','48491','1992-10-27','F','',':RET:2106-3','N','021','DEN','315171','33348TX002000201','2014-01-01','2013-12-09 12:33:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 19:31:48'),(7642,6050,'N','01','021','EC','A',NULL,NULL,'','0000865820','0000151935','','IL','1','HART','DEBORAH','A','','','34','283566487','6281 IROQUOIS TRL',0,'MENTOR','OH','44060','2905','CY','39085','1954-02-08','F','',':RET:2106-3','N','021','DEN','397544','99734OH005000401','2014-01-01','2013-11-10 08:44:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:46:36'),(8997,7139,'Y','18','021','EC','A','','','AC','0000412204','0000412204','OH00000200072','IL','1','kelly','ann','','','','34','108468339','3385 FOREST HILLS DR',0,'MEDINA','OH','44256','8732','CY','39103','1953-04-12','F','R',':RET:2106-3','N','021','HLT','1358034','52664OH152000901','2014-01-01','2013-12-17 18:38:29','0.00',NULL,NULL,'443.31','443.31','R-OH012','OH0','443.31',NULL,0,'2013-12-26 04:04:45'),(15180,12131,'Y','18','021','EC','A','','','AC','0000785801','0000785801','OH00001751822','31','1','Hinds','Joyce','','','','34','298563104','1207 2nd St NW',0,'New Philadelphia','OH','44663',NULL,'CY','39157','1955-12-02','F','M',':RET:2106-3','N','021','DEN','2241936','99734OH005000401','2014-02-01','2013-12-30 17:55:13','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-01-01 12:06:48'),(23481,18703,'Y','18','021','EC','A','','','AC','0001207187','0001207187','LA00002564809','IL','1','Kelly','Laura','','','','34','433675074','7618 VICE PRESIDENT DR',0,'BATON ROUGE','LA','70817','5459','CY','22033','1978-10-11','F','U',':RET:2106-3','T','021','DEN','2818249','18575LA002000101','2014-03-01','2014-02-12 19:46:37','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-13 22:01:55'),(27259,21583,'N','19','021','EC','A',NULL,NULL,'','0000618422','0000630433','','S1','1','Branco','Michael','','','','34','281021164','401 Castalia St.',0,'Bellevue','OH','44811',NULL,'CY','39077','1997-03-12','F','',NULL,'N','021','HLT','3321125','92036OH003002704','2014-04-01','2014-03-03 17:33:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-03 21:31:58'),(27683,21894,'Y','18','021','EC','A','','','AC','0000787432','0000787432','TX00003061545','IL','1','LEYVA','ITZEL','','','','34','633096693','1711 WALNUT LN',0,'MIDLAND','TX','79701','3752','CY','48329','1989-04-14','F','M',NULL,'N','021','DEN','3110691','33348TX002000201','2014-04-01','2014-03-04 23:34:34','0.00',NULL,NULL,'29.22','29.22','R-TX016','TX0','14.61',NULL,0,'2014-03-05 21:30:39'),(28418,22486,'Y','18','021','EC','A','','','AC','0001243031','0001243031','OH00003227284','IL','1','Dirocco','Joseph','','','','34','272647804','1305 33RD ST NE',0,'CANTON','OH','44714','1545','CY','39151','1957-06-25','M','U',':RET:2106-3','N','021','DEN','3629285','99734OH005000401','2014-04-01','2014-03-07 13:23:55','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-07 21:31:00'),(803,664,'Y','18','021','EC','A','','','AC','0000516684','0000516684','TX00001264813','IL','1','Schwenke','Alexandra','','','','34','462691481','19 COURTLANDT PL',0,'HOUSTON','TX','77006','4013','CY','48201','1984-09-16','F','U',':RET:2106-3','N','021','DEN','1418376','33348TX002000201','2014-01-01','2013-12-16 17:31:40','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:05:36'),(16471,13180,'Y','18','024','14','A','','','TE','0000140297','0000140297','','IL','1','Zenobia','Johnson',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-10-30','F','',NULL,NULL,NULL,'','2337711','','2014-01-06','2014-01-06 13:24:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:05:57'),(13486,10754,'Y','18','021','EC','A','','','AC','0001205814','0001205814','OH00000198115','IL','1','McGuinness','Lyndsay','','','','34','294866837','8770 HILLTOP DR',0,'MENTOR','OH','44060','1932','CY','39085','1976-04-12','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1533151','99734OH005000301','2014-01-01','2013-12-23 18:04:30','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:02:21'),(13058,10410,'Y','18','021','EC','A','','','AC','0000184938','0000184938','OH00001288472','IL','1','Filina','Joanne','','','','34','290603002','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','1973-04-14','F','M',':RET:2106-3','N','021','DEN','1466228','99734OH005000401','2014-01-01','2013-12-23 09:17:46','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:51:00'),(9651,7648,'Y','18','021','EC','A','','','AC','0000422809','0000422809','OH00000862169','IL','1','Harsh','rodney','','','','34','279701564','323 LANEY AVE',0,'LIMA','OH','45804','1381','CY','39003','1968-05-06','M','U',':RET:2106-3','T','021','HLT','2573343','92036OH004001501','2014-01-01','2013-12-21 14:47:57','54.00',NULL,NULL,'293.88','239.88','R-OH002','OH0','293.88',NULL,0,'2013-12-26 04:38:47'),(8976,7119,'Y','18','024','14','A','','','TE','0000969424','0000969424','','IL','1','steffan','victoria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-21','F','',NULL,NULL,NULL,'','2042976','','2013-12-18','2013-12-18 15:28:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:04:11'),(26956,21359,'N','19','021','EC','A',NULL,NULL,'','0000245041','0000287160','','S1','1','Hamric','Craig','Allen','','','34','270067040','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','2000-10-02','F','',':RET:2106-3','N','021','HLT','3266135','52664OH151001305','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 01:00:29'),(224,188,'Y','18','021','EC','A','','','AC','0000483137','0000483137','LA00000628963','IL','1','Duffer','Scott','','','','34','093586914','39033 S. Angelle Ct.',0,'Gonzales','LA','70737',NULL,'CY','22005','1973-04-09','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','83083','18575LA002000201','2014-01-01','2013-12-05 14:32:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:51'),(22612,18057,'N','01','021','EC','A',NULL,NULL,'','0000121933','0000742951','','IL','1','HOQUE','MEHERUNNESSA','','','','34','733188500','824 ARAF AVE',0,'RICHARDSON','TX','75081','5189','CY','48113','1987-06-21','F','',':RET:2028-9','N','021','DEN','3189785','33348TX002000201','2014-03-01','2014-02-11 18:21:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:05'),(14346,11443,'N','01','021','EC','A',NULL,NULL,'','0000541650','0000440823','','IL','1','HUBBARD','RICKEY','LYNN','','','34','403065550','7830 TAWAWA MAPLEWOOD RD',0,'SIDNEY','OH','45365','9261','CY','39149','1965-05-11','M','',':RET:2106-3','T','021','HLT','2611148','92036OH003000505','2014-02-01','2013-12-26 16:41:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','466.75',NULL,0,'2013-12-27 02:08:01'),(18250,14569,'Y','18','021','EC','A','','','AC','0000732869','0000732869','TX00002293728','IL','1','Grace','Frank','','','','34','352626942','7404 SHADYWOOD DR',0,'AUSTIN','TX','78745','6486','CY','48453','1969-06-09','M','U',NULL,'N','021','DEN','1615889','33348TX002000201','2014-02-01','2014-01-15 09:30:45','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-16 08:44:30'),(25167,19962,'Y','18','021','EC','A','','','AC','0000595190','0000595190','OH00003081256','IL','1','Cotruta','Gabriel','','','','34','285065390','23839 David dr.',0,'North Olmsted','OH','44070',NULL,'CY','39035','1975-08-19','M','U',':RET:2106-3','T','021','DEN','2726837','99734OH005000401','2014-04-01','2014-02-21 08:24:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:25'),(25344,20109,'Y','18','024','14','A','','','TE','0000350623','0000350623','','IL','1','Purtty','Jamey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-06-08','F','',NULL,NULL,NULL,'','2883016','','2014-02-24','2014-02-24 18:34:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-25 21:30:27'),(28168,22291,'Y','18','021','EC','A','','','AC','0002076110','0002076110','LA00003772148','IL','1','KERCHEVAL','CARLA','A','','','34','445684406','441 WYANDOTTE ST',0,'SHREVEPORT','LA','71101',NULL,'CY','22017','1961-11-15','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3602821','18575LA002000101','2014-04-01','2014-03-06 15:40:22','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-03-06 21:02:47'),(3508,2818,'N','01','021','EC','A',NULL,NULL,'','0000340289','0000336420','','IL','1','Sikora','John','S','','','34','294528599','6079 FLEMINGTON RD',0,'DAYTON','OH','45459','1901','CY','39113','1952-08-18','M','',':RET:2106-3','N','021','DEN','1925020','99734OH005000401','2014-01-01','2013-12-22 18:17:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:54'),(21786,17398,'Y','18','024','14','A','','','TE','0001157596','0001157596','','IL','1','dominic','susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-11-30','F','',NULL,NULL,NULL,'','3241636','','2014-02-06','2014-02-06 10:18:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-06 21:00:41'),(21237,16969,'N','19','021','EC','A',NULL,NULL,'','0001105571','0000488021','','IL','1','AERI','ARJUN','','','','34','289089254','6060 ROUND TOWER LN',0,'DUBLIN','OH','43017','3451','CY','39049','2000-02-23','M','',':RET:2029-7','N','021','DEN','3426351','99734OH005000301','2014-03-01','2014-02-03 13:10:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:01:11'),(18638,14857,'Y','18','021','EC','A','','','AC','0001233139','0001233139','TX00001470410','IL','1','Reta','Jeremy','','','','34','464894353','850 W SAN FRANCISCO AVE',0,'RAYMONDVILLE','TX','78580','1528','CY','48489','1987-01-27','M','U',NULL,'N','021','DEN','2947178','33348TX002000201','2014-02-01','2014-01-15 22:41:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:05'),(5130,4065,'N','01','021','EC','A',NULL,NULL,'','0000543705','0000027243','','IL','1','STACK','MARY','','','','34','635328945','8113 SUN MEADOWS CT',0,'FORT WORTH','TX','76123','1960','CY','48439','1960-08-27','F','',NULL,'N','021','DEN','1841788','33348TX002000101','2014-01-01','2013-12-18 19:52:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:02:12'),(14793,11815,'Y','18','021','EC','A','','','AC','0000132073','0000132073','OH00000052825','IL','1','Payten','Steven','','','','34','302642350','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1964-01-21','M','M',':RET:1002-5^:RET:2054-5','N','021','DEN','2101453','99734OH005000401','2014-01-01','2013-12-23 19:41:32','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:13:33'),(17785,14208,'Y','18','021','EC','A','','','AC','0001060928','0001060928','OH00001398626','IL','1','Redden','Glynnette','','','','34','268845515','11651 Norbourne Drive',0,'Cincincinnati','OH','45240',NULL,'CY','39061','1971-03-12','F','U',':RET:2054-5','T','021','HLT','2140652','92036OH002001201','2014-02-01','2014-01-13 13:47:44','135.00',NULL,NULL,'535.19','400.19','R-OH004','OH0','377.76',NULL,0,'2014-01-14 01:33:44'),(15785,12634,'Y','18','021','EC','A','','','AC','0002300679','0002300679','LA00001905002','IL','1','Van Dyke','Michael','J','','','34','433276968','321 W LEE ST',0,'SULPHUR','LA','70663','5439','CY','22019','1959-10-03','M','U',':RET:2106-3','T','021','DEN','2121518','18575LA002000201','2014-02-01','2014-01-02 02:21:59','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-03 02:02:17'),(26210,20787,'Y','18','021','EC','A','','','AC','0000394988','0000394988','OH00003311575','31','1','Spade','Gail','W','','','34','273506070','PO Box 283',0,'Jeromesville','OH','44840',NULL,'CY','39005','1951-03-23','M','U',':RET:2106-3','T','021','HLT','3060280','52664OH151001304','2014-04-01','2014-02-27 12:31:00','509.00',NULL,NULL,'757.07','248.07','R-OH012','OH0','757.07',NULL,0,'2014-02-28 06:30:53'),(28503,22555,'Y','18','021','EC','A','','','AC','0000695702','0000695702','OH00003136110','IL','1','Blanton','Deborah','','','','34','280583987','940 OAKBROOK DR',0,'ASHLAND','OH','44805','3687','CY','39005','1954-07-04','F','M',':RET:2106-3','N','021','HLT','3853817','52664OH151001305','2014-04-01','2014-03-07 10:40:36','480.00',NULL,NULL,'580.49','100.49','R-OH012','OH0','580.49',NULL,0,'2014-03-07 21:31:50'),(2283,1861,'N','19','021','EC','A',NULL,NULL,'','0001237681','0000204541','','S3','1','Johnson','Michael','I','','','34','260992668','2610 KEMPERWOOD DR',0,'BLACKLICK','OH','43004','8667','CY','39049','1997-03-12','F','',NULL,'N','021','DEN','551987','99734OH005000301','2014-01-01','2013-12-09 12:47:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:35'),(5185,4113,'Y','18','021','EC','A','','','AC','0000831988','0000831988','OH00000747587','IL','1','Gearin','Jason','','','','34','287605278','441 ROSE AVE',0,'SALEM','OH','44460','2251','CY','39029','1976-11-01','M','U',':RET:2106-3','N','021','DEN','2001168','99734OH005000401','2014-01-01','2013-12-19 13:07:06','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:03:36'),(3425,2751,'Y','18','021','EC','A','','','AC','0000114188','0000114188','OH00001142455','IL','1','Upadhyay','Umesh','','','','34','297983540','485 West main street',0,'Canfield','OH','44406',NULL,'CY','39099','1957-05-29','M','M',':RET:2029-7','N','021','HLT','1637208','92036OH005003206','2014-01-01','2013-12-21 18:39:19','913.00',NULL,NULL,'1058.49','145.49','R-OH013','OH0','564.70',NULL,0,'2013-12-25 21:18:46'),(2893,2336,'N','19','021','EC','A',NULL,NULL,'','0001169421','0000593645','','IL','1','Bodzin','Shelby','','','','34','272133048','4421 SILSBY RD',0,'UNIVERSITY HEIGHTS','OH','44118','3938','CY','39035','2006-10-16','F','',':RET:2106-3','N','021','HLT','235718','52664OH151001501','2014-01-01','2013-12-06 14:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-25 20:15:13'),(19886,15862,'Y','18','021','EC','A','','','AC','0000448800','0000448800','OH00001930104','IL','1','Caughey','Shawn','','','','34','277567504','1270 ECHO ST NE',0,'CANTON','OH','44721','1629','CY','39151','1967-06-26','M','M',NULL,'N','021','HLT','3270956','52664OH151001305','2014-03-01','2014-01-23 19:56:16','430.00',NULL,NULL,'646.05','216.05','R-OH015','OH0','334.51',NULL,0,'2014-01-24 21:00:49'),(19213,15308,'Y','18','024','14','A','','','TE','0000116558','0000116558','','IL','1','Covert','Harry','Michael',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-21','M','',NULL,NULL,NULL,'','409256','','2014-01-20','2014-01-20 11:44:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:23'),(19193,15292,'Y','18','021','EC','A','','','AC','0001107788','0001107788','TX00002097030','IL','1','moreno','katanna','lee','','','34','632321715','7306 hanzi dr',0,'san antonio','TX','78223',NULL,'CY','48029','1993-01-31','F','M',':RET:2106-3','N','021','DEN','2788423','33348TX002000101','2014-03-01','2014-01-20 16:40:07','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-21 08:46:13'),(17946,14338,'N','01','021','EC','A',NULL,NULL,'','0000608795','0001087398','','IL','1','Rayas','Victor','G','','','34','467819538','1722 Socorro',0,'San Antonio','TX','78214',NULL,'CY','48029','1962-03-23','M','',':RET:2106-3','N','021','DEN','2008634','33348TX002000201','2014-02-01','2014-01-14 16:01:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:41'),(6363,5045,'Y','18','021','EC','A','','','AC','0000478449','0000478449','OH00000986975','IL','1','Thorton','Amy','','','','34','299722733','2109 UNIONDALE DR',0,'STOW','OH','44224','3443','CY','39153','1974-08-14','F','M',':RET:2106-3','N','021','DEN','485346','99734OH005000301','2014-01-01','2013-12-10 18:46:20','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:25'),(15787,12636,'Y','18','021','EC','A','','','AC','0001897902','0001897902','LA00001900159','IL','1','Folse','Akeen','T','','','34','433274840','817 North 8th Street',0,'Thibodaux','LA','70301',NULL,'CY','22057','1976-03-15','F','M',':RET:2054-5','N','021','DEN','2331196','18575LA002000201','2014-02-01','2014-01-02 12:16:31','0.00',NULL,NULL,'29.22','29.22','R-LA002','LA0','14.61',NULL,0,'2014-01-03 02:02:21'),(15253,12191,'Y','18','021','EC','A','','','AC','0001209597','0001209597','OH00001399361','IL','1','Gallaspie','Doug','','','','34','280701347','2573 SHARON ROSE DR',0,'LIMA','OH','45807','1522','CY','39003','1963-02-16','M','U',':RET:2106-3','T','021','HLT','1809669','92036OH002001501','2014-02-01','2013-12-30 11:18:06','198.00',NULL,NULL,'522.01','324.01','R-OH002','OH0','522.01',NULL,0,'2014-01-01 12:09:01'),(6426,5095,'Y','18','021','EC','A','','','AC','0000698154','0000698154','LA00000463206','IL','1','Green','Carl','','','','34','436715780','619 N. Pleasant Ave',0,'Gonzales','LA','70737',NULL,'CY','22005','1972-12-25','M','U',':RET:2106-3','N','021','DEN','159046','18575LA002000201','2014-01-01','2013-12-11 11:52:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:49:02'),(23430,18665,'N','19','021','EC','A',NULL,NULL,'','0000520158','0000040048','','IL','1','Rudloff','Jessica','','','','34','228931806','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','2002-04-28','F','',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','0.00',NULL,0,'2014-02-13 22:01:26'),(26559,21055,'Y','18','021','EC','A','','','AC','0000116640','0000116640','OH00003374770','IL','1','Conley','Cameron','','','','34','246258437','8595 SUNMONT DR',0,'CINCINNATI','OH','45255','4778','CY','39061','1973-04-30','M','R',':RET:2054-5','N','021','DEN','3880400','99734OH005000301','2014-04-01','2014-02-28 16:05:18','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:18'),(27585,21815,'Y','18','024','14','A','','','TE','0000396088','0000396088','','IL','1','WILSON','DOROTHY','GEORGETTE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-09-12','F','',NULL,NULL,NULL,'','2225544','','2014-03-31','2014-03-05 10:54:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:14'),(28484,22537,'Y','18','024','14','A','','','TE','0000345641','0000345641','','IL','1','colson','laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-04-25','F','',NULL,NULL,NULL,'','3599885','','2014-03-07','2014-03-07 14:17:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:37'),(28981,22938,'Y','18','021','EC','A','','','AC','0000114268','0000114268','OH00003662704','IL','1','HEAVNER','MARIA','','','','34','297821656','3555 RABER TERRACE RD',0,'UNIONTOWN','OH','44685',NULL,'CY','39153','1984-07-27','F','U',NULL,'N','021','HLT','3692679','52664OH151001305','2014-04-01','2014-03-10 09:31:19','83.00',NULL,NULL,'249.55','166.55','R-OH012','OH0','249.55',NULL,0,'2014-03-10 21:01:09'),(6032,4776,'Y','18','021','EC','A','','','AC','0000437980','0000437980','TX00001231786','IL','1','Myers','Richard','','','','34','456216929','3840 CLOVER LN',0,'DALLAS','TX','75220','3702','CY','48113','1957-11-26','M','R',':RET:2106-3','N','021','DEN','1151406','33348TX002000201','2014-01-01','2013-12-01 11:27:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:01:09'),(21147,16898,'Y','18','021','EC','A','','','AC','0001212143','0001212143','TX00002290574','IL','1','valenzuela','jason','','','','34','451632267','1700 charlie smith dr',0,'el paso','TX','79936',NULL,'CY','48141','1979-03-19','M','U',':RET:2106-3','N','021','DEN','3556656','33348TX002000201','2014-03-01','2014-02-03 18:06:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-03 21:00:25'),(6453,5115,'Y','18','021','EC','A','','','AC','0000448750','0000448750','OH00000546261','IL','1','Dardenne','Tracy','','','','34','268806202','2202 PALM RD',0,'MOGADORE','OH','44260','9342','CY','39133','1967-01-24','F','M',':RET:2106-3','N','021','HLT','125484','52664OH151001501','2014-01-01','2013-12-10 21:03:08','229.00',NULL,NULL,'401.20','172.20','R-OH012','OH0','401.20',NULL,0,'2013-12-26 00:49:44'),(20473,16354,'Y','18','021','EC','A','','','AC','0001142203','0001142203','OH00001916252','IL','1','Tolber','Nika','','','','34','270704297','12265 MILNOR RD',0,'PICKERINGTON','OH','43147','8224','CY','39045','1975-02-26','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','3571950','99734OH005000401','2014-03-01','2014-01-29 13:57:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:56'),(6891,5467,'Y','18','021','EC','A','','','AC','0002350966','0002350966','LA00000412178','IL','1','Brown','Sally','','','','34','435840384','10490 SCOUT DR',0,'KEITHVILLE','LA','71047','8893','CY','22017','1951-01-20','F','U',NULL,'N','021','DEN','1683884','18575LA002000201','2014-01-01','2013-12-24 21:25:27','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 01:45:22'),(14990,11981,'Y','18','021','EC','A','','','AC','0000669670','0000669670','TX00000410891','IL','1','Jones','Laura','','','','34','643120862','108 W. McGee',0,'Sherman','TX','75092',NULL,'CY','48181','1985-10-06','F','M',':RET:2106-3','N','021','DEN','2252916','33348TX002000201','2014-02-01','2013-12-30 16:12:41','0.00',NULL,NULL,'31.70','31.70','R-TX020','TX0','15.85',NULL,0,'2014-01-01 12:01:23'),(16766,13412,'Y','18','021','EC','A','','','AC','0000483493','0000483493','OH00002061869','IL','1','Hill','April','Louise','','','34','298828107','606 DURANGO DR',0,'TOLEDO','OH','43609','1706','CY','39095','1981-09-23','F','M',':RET:2106-3','N','021','HLT','1409665','92036OH006002601','2014-02-01','2014-01-07 13:50:55','177.00',NULL,NULL,'182.95','5.95','R-OH001','OH0','182.95',NULL,0,'2014-01-08 18:25:00'),(17442,13953,'N','19','021','EC','A',NULL,NULL,'','0001030389','0000411131','','S1','1','DUFRESNE','DAVID','','','','34','298048649','3522 WALBRIDGE RD',0,'MILLBURY','OH','43447','9741','CY','39173','2000-05-18','M','',':RET:2106-3','N','021','HLT','2394519','92036OH004002601','2014-02-01','2014-01-10 16:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-01-13 03:00:36'),(21667,17304,'N','01','021','EC','A',NULL,NULL,'','0002020256','0001600434','','IL','1','Melder','Kristoffer','','','','34','462770546','188 WILDWOOD DR',0,'PINEVILLE','LA','71360','4565','CY','22079','1978-04-04','M','',':RET:2106-3','N','021','DEN','3251886','18575LA002000201','2014-03-01','2014-02-05 14:51:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:30:57'),(22795,18198,'Y','18','021','EC','A','','','AC','0000347943','0000347943','OH00002072647','IL','1','WILSON','GERALD','','','','34','283782545','4365 W ANDERSON RD',0,'CLEVELAND','OH','44121','3574','CY','39035','1966-07-04','M','M',':RET:2054-5','N','021','DEN','2982740','99734OH005000301','2014-03-01','2014-02-11 13:01:11','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-11 21:01:51'),(24967,19800,'N','01','021','EC','A',NULL,NULL,'','0000125701','0001168023','','IL','1','FAIRCHILD','MARICELA','','','','34','850560524','112 BENNETT ST',0,'NORMANGEE','TX','77871','5286','CY','48289','1969-05-25','F','',NULL,'T','021','DEN','3629919','33348TX002000201','2014-04-01','2014-02-19 19:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 22:00:24'),(25670,20365,'Y','18','021','EC','A','','','AC','0000924846','0000924846','OH00003062452','IL','1','townend','richard','','','','34','275785548','40 CHARMALEE DR',0,'AMELIA','OH','45102','2369','CY','39025','1974-08-30','M','M',':RET:2106-3','N','021','HLT','3383122','92036OH004000601','2014-04-01','2014-02-21 22:15:41','0.00',NULL,NULL,'217.83','217.83','R-OH005','OH0','217.83',NULL,0,'2014-02-26 08:30:51'),(29071,23008,'Y','18','021','EC','A','','','AC','0001020480','0001020480','OH00003627688','IL','1','Russell','Edward','','','','34','299844799','1043 CAMPBELL ST',0,'TOLEDO','OH','43607','4417','CY','39095','1986-07-09','M','U',NULL,'N','021','HLT','2896617','92036OH004002601','2014-04-01','2014-03-10 16:58:30','142.00',NULL,NULL,'164.31','22.31','R-OH001','OH0','164.31',NULL,0,'2014-03-10 21:01:57'),(2253,1848,'N','19','021','EC','A',NULL,NULL,'','0000385874','0000769962','','IL','1','MESONES','LEONARDO','G','','','34','276024460','8717 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','1993-10-28','M','',':RET:2106-3','N','021','DEN','688704','99734OH005000301','2014-01-01','2013-12-08 19:49:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:08'),(3211,2583,'Y','18','021','EC','A','','','AC','0000234150','0000234150','TX00000907980','IL','1','Levy','Carol','','','','34','427926611','618 BENTLEY CT',0,'TYLER','TX','75703','4619','CY','48423','1952-07-16','F','M',NULL,'N','021','DEN','316259','33348TX002000201','2014-01-01','2013-11-01 08:34:05','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 20:45:26'),(2356,1921,'Y','18','021','EC','A','','','AC','0000918721','0000918721','TX00000588408','IL','1','Pickup','Kristi','','','','34','467555522','1080 BERRY RD',0,'LUFKIN','TX','75904','7214','CY','48005','1968-05-09','F','U',':RET:2106-3','N','021','DEN','197903','33348TX002000201','2014-01-01','2013-12-09 18:01:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:32:22'),(9531,7554,'N','01','021','EC','A',NULL,NULL,'','0000550061','0000898450','','IL','1','ROBINETTE','TIMOTHY','F','','','34','280522924','5942 ISCH RD',0,'WALBRIDGE','OH','43465','9555','CY','39173','1952-09-10','M','',':RET:2106-3','N','021','DEN','1877579','99734OH005000301','2014-01-01','2013-12-21 08:23:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:46'),(15006,11995,'Y','18','021','EC','A','','','AC','0001236586','0001236586','OH00001917716','IL','1','MUFFET','JAMES','','','','34','294442465','986 HANCOCK AVE',0,'AKRON','OH','44314','1028','CY','39153','1949-05-01','M','U',':RET:2106-3','N','021','HLT','1876680','52664OH151001305','2014-02-01','2013-12-29 18:53:44','533.00',NULL,NULL,'669.00','136.00','R-OH012','OH0','669.00',NULL,0,'2014-01-01 12:01:53'),(16152,12934,'Y','18','021','EC','A','','','AC','0000819787','0000819787','OH00002179324','IL','1','Garcia','Aaron','','','','34','295862461','412 N Metcalf',0,'Lima','OH','45801',NULL,'CY','39003','1971-07-20','M','U',NULL,'N','021','HLT','1895581','92036OH004001501','2014-02-01','2014-01-03 15:48:34','158.00',NULL,NULL,'234.49','76.49','R-OH002','OH0','234.49',NULL,0,'2014-01-04 02:06:16'),(23397,18645,'Y','18','021','EC','A','','','AC','0000546511','0000546511','OH00002438909','IL','1','Johnson','John','','','','34','297868670','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','1973-07-31','M','M',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25','0.00',NULL,NULL,'71.95','71.95','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:01:09'),(23918,19022,'Y','18','021','EC','A','','','AC','0000613049','0000613049','OH00001844494','IL','1','Barr','Jason','','','','34','290863629','7191 TUMBLEBROOK DR',0,'NEW ALBANY','OH','43054','8890','CY','39049','1977-05-06','M','M',NULL,'N','021','DEN','3604800','99734OH005000301','2014-03-01','2014-02-14 15:48:17','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00','CIC',0,'2014-02-14 22:00:05'),(24360,19349,'Y','18','021','EC','A','','','AC','0001652357','0001652357','LA00002771485','IL','1','BROWN','ALLEN','','','','34','434657146','10797 SHELTON RD.',0,'BASTROP','LA','71220',NULL,'CY','22067','1972-02-05','M','M',NULL,'N','021','DEN','3623162','18575LA002000201','2014-04-01','2014-02-18 10:39:50','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-18 22:00:32'),(238,199,'Y','18','021','EC','A','','','AC','0000369993','0000369993','OH00001130737','IL','1','Cooper','Julettia','','','','34','296588100','1920 OAKGROVE RD',0,'LYNCHBURG','OH','45142','9672','CY','39027','1954-11-13','F','M',':RET:2106-3','T','021','HLT','180866','92036OH003000605','2014-01-01','2013-12-04 21:35:48','469.00',NULL,NULL,'671.09','202.09','R-OH005','OH0','671.09',NULL,0,'2013-12-25 17:21:14'),(20631,16486,'Y','18','021','EC','A','','','AC','0000976592','0000976592','TX00001548723','IL','1','PACATTE','CLAYTON','','','','34','645093987','1407 BERNARD ST',0,'DENTON','TX','76201','7140','CY','48121','1989-01-02','M','U',':RET:2106-3','N','021','DEN','1363548','33348TX002000201','2014-03-01','2014-01-29 22:05:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:29'),(19885,15861,'Y','18','021','EC','A','','','AC','0000917019','0000917019','OH00002092748','IL','1','Wisniewski','Margaret','Rita','','','34','269489277','9219 N BEDFORD RD',0,'MACEDONIA','OH','44056','1209','CY','39153','1949-09-30','F','M',NULL,'T','021','HLT','2667806','52664OH151001306','2014-03-01','2014-01-23 19:27:00','537.00',NULL,NULL,'769.35','232.35','R-OH012','OH0','769.35',NULL,0,'2014-01-24 21:00:48'),(1278,1056,'Y','18','021','EC','A','','','AC','0000560516','0000560516','OH00000379453','IL','1','lemke','craig','','','','34','271864161','2452 FROSTWOOD DR',0,'YOUNGSTOWN','OH','44515','5142','CY','39099','1986-10-24','M','U',':RET:2106-3','N','021','DEN','146677','99734OH005000401','2014-01-01','2013-11-29 16:02:13','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:30:29'),(19180,15280,'Y','18','024','14','A','','','TE','0000521374','0000521374','','IL','1','Katt','Jude',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-12-16','F','',NULL,NULL,NULL,'','550312','','2014-01-20','2014-01-20 00:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:46:07'),(18951,15099,'N','01','021','EC','A',NULL,NULL,'','0000233209','0000859419','','IL','1','Steakley','Zollie','Carl','','','34','463788193','9 LAKEWOOD ST',0,'SWEETWATER','TX','79556','1709','CY','48353','1949-09-09','M','',':RET:2106-3','N','021','DEN','1915189','33348TX002000201','2014-03-01','2014-01-17 14:05:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-20 08:05:49'),(1629,1360,'N','01','021','EC','A',NULL,NULL,'','0000277730','0000438096','','IL','1','MARTINEZ','VIRGINIA',NULL,NULL,NULL,NULL,NULL,'2808 JUNIPER AVE',0,'LUBBOCK','TX','79404','1805','CY','48303','1961-05-07','F','',NULL,'N','021','DEN','2359825','33348TX002000201','2014-01-01','2013-12-24 14:54:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:47'),(13957,11125,'N','01','021','EC','A',NULL,NULL,'','0000112931','0000101434','','IL','1','Neiheisel','Robin','K','','','34','294683777','41 CROSSBOW CT',0,'AMELIA','OH','45102','2112','CY','39025','1975-09-20','F','',':RET:2106-3','N','021','HLT','2027257','92036OH004000601','2014-01-01','2013-12-23 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','215.09',NULL,0,'2013-12-26 13:15:01'),(2968,2391,'Y','18','021','EC','A','','','AC','0000410462','0000410462','TX00000088495','IL','1','ward','mattie','','','','34','449065015','1112 nottingham',0,'angleton','TX','77515',NULL,'CY','48039','1953-10-24','F','M',':RET:2106-3','N','021','DEN','486720','33348TX002000201','2014-01-01','2013-12-06 15:41:47','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:16:55'),(7716,6110,'Y','18','021','EC','A','','','AC','0000162260','0000162260','OH00000736101','IL','1','Roewer','Joel','','','','34','273929166','6851 KENTON AVE',0,'SILVERTON','OH','45236','3814','CY','39061','1987-08-07','M','R',':RET:2106-3','N','021','DEN','2396599','99734OH005000401','2014-01-01','2013-12-20 13:16:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:01:37'),(8087,6403,'Y','18','021','EC','A','','','AC','0000182279','0000182279','OH00000059007','IL','1','Creed','Lori','','','','34','283821058','3497 WHEATCROFT DR',0,'CINCINNATI','OH','45239','6151','CY','39061','1970-12-10','F','U',':RET:2106-3','N','021','HLT','2569301','92036OH005001204','2014-01-01','2013-12-20 15:18:27','131.00',NULL,NULL,'291.30','160.30','R-OH004','OH0','291.30',NULL,0,'2013-12-26 03:10:34'),(24666,19581,'Y','18','021','EC','A','','','AC','0000149395','0000149395','OH00002642209','IL','1','Schulte','Rebecca','','','','34','294722750','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1962-07-10','F','R',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17','0.00',NULL,NULL,'770.28','770.28','R-OH002','OH0','325.53',NULL,0,'2014-02-20 04:26:44'),(26643,21126,'Y','18','021','EC','A','','','AC','0000558203','0000558203','OH00003441755','IL','1','Milano','Debra','','','','34','300569802','2524 DANIEL DR',0,'ASHTABULA','OH','44004','9713','CY','39007','1956-05-18','F','M',':RET:2106-3','N','021','HLT','2966833','52664OH151001305','2014-04-01','2014-02-27 23:21:09','522.00',NULL,NULL,'612.95','90.95','R-OH011','OH0','612.95',NULL,0,'2014-02-28 21:31:04'),(28022,22176,'Y','18','024','14','A','','','TE','0001040909','0001040909','','IL','1','WINANS','AMY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-16','F','',NULL,NULL,NULL,'','3190433','','2014-03-06','2014-03-06 15:18:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:01:22'),(2397,1957,'Y','18','021','EC','A','','','AC','0000293162','0000293162','OH00000596103','IL','1','Treharn','Kenneth','','','','34','288489475','1626 HEWITT GIFFORD RD SW',0,'WARREN','OH','44481','9715','CY','39155','1950-09-08','M','U',':RET:2106-3','N','021','DEN','216248','99734OH005000401','2014-01-01','2013-12-09 13:28:22','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:33:27'),(21364,17075,'Y','18','021','EC','A','','','AC','0000926620','0000926620','TX00001989091','31','1','Ortega','Barbara','','','','34','572964937','1531 Connettere',0,'New Braunfels','TX','78132',NULL,'CY','48209','1953-05-13','F','M',':RET:2106-3','N','021','DEN','3188342','33348TX002000201','2014-03-01','2014-02-04 16:05:27','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-04 21:00:44'),(28146,22274,'Y','18','021','EC','A','','','AC','0000488051','0000488051','OH00003770638','IL','1','Pastrikos','Sotiria','','','','34','297742889','4012 CLOVER RIDGE CT',0,'TOLEDO','OH','43623','1240','CY','39095','1958-10-05','F','M',NULL,'N','021','HLT','3830002','92036OH001002601','2014-04-01','2014-03-06 10:31:30','0.00',NULL,NULL,'524.52','524.52','R-OH001','OH0','524.52',NULL,0,'2014-03-06 21:02:34'),(28928,22895,'Y','18','021','EC','A','','','AC','0000701767','0000701767','OH00003487381','IL','1','Tepperman','Ann','','','','34','269905197','3021 WOODBINE PL',0,'COLUMBUS','OH','43202','1428','CY','39049','1979-04-06','F','M',':RET:2106-3','N','021','DEN','4272007','99734OH005000301','2014-04-01','2014-03-10 13:47:22','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:00:36'),(28946,22907,'Y','18','021','EC','A','','','AC','0002270856','0002270856','LA00003199488','IL','1','Hart','Daniel','','','','34','434553881','4500 BURBANK DR',0,'BATON ROUGE','LA','70820','3220','CY','22033','1984-06-12','M','U',':RET:2054-5','N','021','DEN','4173904','18575LA002000201','2014-04-01','2014-03-09 21:08:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:00:46'),(153,128,'Y','18','021','EC','A','','','AC','0001015289','0001015289','TX00000112288','31','1','Isaac','Grace','','','','34','450392647','P.O.Box 18301',0,'San Antonio','TX','78218',NULL,'CY','48029','1962-05-10','F','M',':RET:2106-3','N','021','DEN','356574','33348TX002000101','2014-01-01','2013-12-05 13:19:49','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2013-12-25 17:18:58'),(20152,16081,'Y','18','021','EC','A','','','AC','0000155813','0000155813','OH00002177615','IL','1','brown','richard','','','','34','280768832','9139 CHERRY BLOSSOM LN',0,'CINCINNATI','OH','45231','3831','CY','39061','1975-02-03','M','U',':RET:2106-3','T','021','DEN','2339482','99734OH005000301','2014-03-01','2014-01-26 21:57:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:01:04'),(1177,969,'Y','18','021','EC','A','','','AC','0001095621','0001095621','OH00000028657','31','1','Boleyn','Radie','','','','34','291484724','644 Cherry Park Oval',0,'Aurora','OH','44202',NULL,'CY','39133','1950-07-03','M','M',':RET:2106-3','N','021','HLT','477609','52664OH151001501','2014-01-01','2013-12-03 16:22:03','396.81',NULL,NULL,'789.56','392.75','R-OH012','OH0','789.56',NULL,0,'2013-12-25 18:19:16'),(13805,11019,'Y','18','021','EC','A','','','AC','0000060260','0000060260','OH00000048353','IL','1','swem','tom','','','','34','298447729','1507 SOUTHWOOD DR',0,'LIMA','OH','45805','3748','CY','39003','1951-03-08','M','M',NULL,'N','021','HLT','1406515','92036OH006001501','2014-01-01','2013-12-22 19:00:49','895.00',NULL,NULL,'1002.92','107.92','R-OH002','OH0','501.46',NULL,0,'2013-12-26 13:11:28'),(22910,18262,'Y','18','021','EC','A','','','AC','0000218876','0000218876','OH00002472897','IL','1','Scales','Diana','','','','34','299481458','3462 BEHYMER RD',0,'CINCINNATI','OH','45245','3102','CY','39025','1950-02-13','F','M',':RET:2106-3','N','021','HLT','3334193','92036OH005000601','2014-03-01','2014-02-11 11:34:23','728.00',NULL,NULL,'1372.75','644.75','R-OH005','OH0','644.00',NULL,0,'2014-02-11 21:02:48'),(77,68,'N','01','021','EC','A',NULL,NULL,'','0000049461','0000403630','','IL','1','Lauer','Larry','','','','34','400804367','564 COMMON WEALTH DR',0,'CINCINNATI','OH','45244','1031','CY','39025','1953-01-13','M','',NULL,'N','021','DEN','241225','99734OH005000301','2014-01-01','2013-12-05 17:35:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:17:05'),(21162,16911,'Y','18','021','EC','A','','','AC','0000027921','0000027921','OH00001850597','S3','1','Goulding','Mark','','','','34','296131612','6781 Maplehurst Road',0,'North Olmstead','OH','44070',NULL,'CY','39035','2008-04-10','F','U',':RET:2106-3','N','021','DEN','2681864','99734OH005000401','2014-03-01','2014-02-03 11:04:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2014-02-03 21:00:33'),(20065,16004,'Y','18','024','14','A','','','TE','0000922524','0000922524','','IL','1','ZAN','QUANG',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-18','M','',NULL,NULL,NULL,'','2412868','','2014-01-27','2014-01-27 13:16:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:14'),(19781,15769,'Y','18','021','EC','A','','','AC','0001252147','0001252147','OH00002100610','31','1','ZODY','WENDY','','','','34','272683499','P.O. Box 401',0,'Loudonville','OH','44842',NULL,'CY','39005','1968-12-03','F','M',':RET:2106-3','T','021','HLT','3167318','52664OH152000901','2014-03-01','2014-01-23 11:10:00','0.00',NULL,NULL,'271.24','271.24','R-OH012','OH0','271.24',NULL,0,'2014-01-23 21:01:34'),(18830,14998,'Y','18','021','EC','A','','','AC','0000658150','0000658150','MS00001901633','IL','1','Griffin','Alex','','','','34','426738125','5000 RIDGEWOOD RD',0,'JACKSON','MS','39211','5464','CY','28049','1992-02-27','M','U',':RET:2054-5','N','021','DEN','2403198','46300MS002000201','2014-02-01','2014-01-15 19:43:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:09'),(17922,14316,'Y','18','021','EC','A','','','AC','0000977683','0000977683','TX00001969976','IL','1','krpoun','robert','','','','34','502902017','14403 TIFFER LN',0,'AUSTIN','TX','78728','6725','CY','48453','1971-09-01','M','U',':RET:2106-3','N','021','DEN','2718998','33348TX002000201','2014-02-01','2014-01-14 11:04:41','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:31'),(6546,5190,'Y','18','021','EC','A','','','AC','0000927628','0000927628','TX00000595135','31','1','SIMPSON','RITA','VICTORIA','','','34','508785225','P.O. BOX 17713',0,'SAN ANTONIO','TX','78217',NULL,'CY','48029','1963-08-22','F','U',':RET:2106-3','N','021','DEN','842529','33348TX002000201','2014-01-01','2013-12-11 11:16:39','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 00:52:03'),(16962,13576,'Y','18','021','EC','A','','','AC','0000947421','0000947421','OH00001559946','IL','1','Williams','Victoria','','','','34','278542971','116 W 12TH ST',0,'ASHLAND','OH','44805','1754','CY','39005','1951-06-28','F','M',NULL,'N','021','HLT','1929742','52664OH151001304','2014-02-01','2014-01-09 16:07:57','408.00',NULL,NULL,'640.70','232.70','R-OH012','OH0','640.70',NULL,0,'2014-01-13 02:20:08'),(16926,13545,'Y','18','024','14','A','','','TE','0002261610','0002261610','','IL','1','Woodard','Joan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-11','F','',NULL,NULL,NULL,'','1601083','','2014-01-09','2014-01-09 10:55:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 02:19:46'),(15728,12580,'Y','18','021','EC','A','','','AC','0000972750','0000972750','OH00000705358','IL','1','rine','deven','','','','34','298920155','536 RICHLAND AVE',0,'ATHENS','OH','45701','3748','CY','39009','1990-12-17','M','M',':RET:2106-3','N','021','DEN','2205819','99734OH005000301','2014-02-01','2014-01-02 18:06:57','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2014-01-03 02:00:24'),(5741,4557,'Y','18','021','EC','A','','','AC','0001816674','0001816674','LA00000395982','IL','1','MATTHEWS','GAIL','','','','34','439119581','1014 BARKLEY DR',0,'BATON ROUGE','LA','70810',NULL,'CY','22033','1959-09-11','F','U',':RET:2054-5','N','021','DEN','1598396','18575LA002000201','2014-01-01','2013-12-23 23:55:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:57'),(4984,3958,'Y','18','021','EC','A','','','AC','0000189744','0000189744','TX00000767478','IL','1','David','Stephen','','','','34','337723217','21702 WINDSOR CASTLE DR',0,'SPRING','TX','77388','3471','CY','48201','1956-05-30','M','U',':RET:2036-2','N','021','DEN','364196','33348TX002000201','2014-01-01','2013-12-07 15:11:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:46:48'),(7084,5620,'Y','18','021','EC','A','','','AC','0000182292','0000182292','OH00001651528','IL','1','IDE','BOUBACAR','','','','34','110906552','1730 TANGLEWOOD DR',0,'AKRON','OH','44313','6359','CY','39153','1973-11-06','M','U',NULL,'N','021','HLT','1484252','52664OH152000901','2014-01-01','2013-12-24 18:41:43','0.00',NULL,NULL,'208.75','208.75','R-OH012','OH0','208.75',NULL,0,'2013-12-26 01:50:22'),(13902,11087,'N','01','021','EC','A',NULL,NULL,'','0000708939','0000903231','','IL','1','Derian','Richard','S','','','34','274569375','4710 290TH ST',0,'TOLEDO','OH','43611','1960','CY','39095','1954-06-10','M','',':RET:2106-3','N','021','HLT','2269988','92036OH006002601','2014-01-01','2013-12-23 16:27:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','402.54',NULL,0,'2013-12-26 13:13:42'),(22606,18053,'N','01','021','EC','A',NULL,NULL,'','0001062162','0000465960','','IL','1','NGUYEN','THU HA','THI','','','34','287150644','7230 HOSBROOK RD',0,'CINCINNATI','OH','45243','1710','CY','39061','1973-04-29','F','',NULL,'N','021','HLT','3682085','92036OH001001201','2014-03-01','2014-02-10 14:31:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','330.93',NULL,0,'2014-02-10 21:32:17'),(24547,19499,'Y','18','021','EC','A','','','AC','0000009892','0000009892','OH00002670364','IL','1','Mahone','Celia','','','','34','278625417','3378 Whitebeech Lane',0,'Youngstown','OH','44511',NULL,'CY','39099','1961-11-03','F','U',':RET:2054-5','T','021','HLT','3026681','52664OH151001305','2014-04-01','2014-02-19 15:59:36','484.00',NULL,NULL,'728.29','244.29','R-OH013','OH0','567.70',NULL,0,'2014-02-20 04:03:47'),(24579,19514,'N','19','021','EC','A',NULL,NULL,'','0000256015','0000317383','','IL','1','ONWUAGBA','CHUKWUEBUKA','','','','34','284110056','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1998-05-26','M','',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:08:22'),(25507,20236,'N','01','021','EC','A',NULL,NULL,'','0000054520','0000801316','','IL','1','Meeks','Christel','','','','34','274609207','4080 HAMBLETON AVE',0,'LOUISVILLE','OH','44641','9428','CY','39151','1972-07-03','F','',':RET:2106-3','N','021','HLT','3169253','52664OH152000901','2014-04-01','2014-02-25 16:30:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','212.67',NULL,0,'2014-02-25 21:31:59'),(25712,20396,'N','19','021','EC','A',NULL,NULL,'','0000106646','0000702516','','IL','1','RODRIGUEZ','LILAH','R','','','34','450752755','413 S ALBERTA ST',0,'PECOS','TX','79772',NULL,'CY','48389','1985-09-28','F','',NULL,'N','021','DEN','3736046','33348TX002000201','2014-04-01','2014-02-24 16:13:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:23'),(25813,20470,'Y','18','021','EC','A','','','AC','0001059527','0001059527','OH00003013452','IL','1','Kubicina','Aaron','','','','34','268921034','3241 CIRCLE DR',0,'CORTLAND','OH','44410','1702','CY','39155','1987-01-30','M','U',':RET:2106-3','N','021','DEN','3259876','99734OH005000301','2014-04-01','2014-02-26 14:15:58','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-26 21:00:23'),(26049,20659,'Y','18','021','EC','A','','','AC','0001260066','0001260066','OH00003278637','IL','1','BELL','JANICE','','','','34','284523493','1822 GRANT AVE',0,'CUYAHOGA FALLS','OH','44223','1819','CY','39153','1951-11-03','F','M',':RET:2106-3','N','021','HLT','3351774','52664OH151001301','2014-04-01','2014-02-26 17:15:25','163.00',NULL,NULL,'640.70','477.70','R-OH012','OH0','640.70',NULL,0,'2014-02-26 21:02:32'),(26265,20832,'Y','18','024','14','A','','','TE','0000923928','0000923928','','IL','1','GARZA','ELOY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-11-24','M','',NULL,NULL,NULL,'','2862412','','2014-02-27','2014-02-27 16:00:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:14'),(26743,21195,'N','19','021','EC','A',NULL,NULL,'','0000992728','0000918309','','IL','1','Supe','Kylie','','','','34','727815163','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2011-07-21','F','',':RET:2106-3','N','021','HLT','3540690','92036OH003001205','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-28 21:31:56'),(26785,21227,'Y','18','021','EC','A','','','AC','0000306734','0000306734','TX00002922973','31','1','DELEON','JOHNNY','','','','34','465868991','PO BOX 430282',0,'LAREDO','TX','78043',NULL,'CY','48479','1951-03-14','M','U',NULL,'N','021','DEN','3694755','33348TX002000201','2014-04-01','2014-03-01 11:48:38','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-03-01 21:00:15'),(6084,4822,'Y','18','021','EC','A','','','AC','0001224434','0001224434','OH00001141758','IL','1','Malicki','Charlene','','','','34','276543692','1614 SLATER ST',0,'TOLEDO','OH','43612','2019','CY','39095','1952-06-27','F','U',NULL,'N','021','HLT','967960','92036OH003002605','2014-01-01','2013-12-01 14:38:45','419.00',NULL,NULL,'572.23','153.23','R-OH001','OH0','572.23',NULL,0,'2013-12-26 00:02:33'),(21213,16952,'Y','18','021','EC','A','','','AC','0001185734','0001185734','LA00002305234','IL','1','DIKE','LAWRENCE','','','','34','663149006','3226 TRUMAN ST',0,'BAKER','LA','70714','3448','CY','22033','1940-04-30','M','M',NULL,'N','021','DEN','2911345','18575LA002000201','2014-03-01','2014-02-03 13:01:30','0.00',NULL,NULL,'32.44','32.44','R-LA005','LA0','16.22',NULL,0,'2014-02-03 21:01:00'),(5648,4480,'N','01','021','EC','A',NULL,NULL,'','0000074873','0000987063','','IL','1','pinon','christina','','','','34','450953591','1001 w 1st',0,'littlefield','TX','79339',NULL,'CY','48279','1976-05-13','F','',NULL,'N','021','DEN','137599','33348TX002000201','2014-01-01','2013-11-26 11:44:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:31:25'),(4214,3352,'N','19','021','EC','A',NULL,NULL,'','0001040265','0000957377','','IL','1','VERETTE','BRIANNA','','','','34','637288126','405 E GRANITE ST',0,'LLANO','TX','78643','3057','CY','48299','1991-12-04','F','',':RET:2106-3','N','021','DEN','2434314','33348TX002000201','2014-01-01','2013-12-17 08:06:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:50:16'),(18559,14801,'Y','18','021','EC','A','','','AC','0000880545','0000880545','OH00001909977','IL','1','Workman','Xavier','','','','34','401413149','330 COON HILL RD',0,'WINCHESTER','OH','45697','9746','CY','39001','1990-11-28','M','M',':RET:2106-3','N','021','HLT','1584950','92036OH005000605','2014-02-01','2014-01-15 14:49:11','303.00',NULL,NULL,'430.20','127.20','R-OH005','OH0','214.67',NULL,0,'2014-01-16 08:46:58'),(18377,14668,'Y','18','021','EC','A','','','AC','0000338890','0000338890','OH00001468143','IL','1','Weisel','Raymond','','','','34','269843030','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1976-09-08','M','M',':RET:2106-3','N','021','DEN','2708876','99734OH005000301','2014-02-01','2014-01-15 14:58:37','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:33'),(7664,6070,'Y','18','021','EC','A','','','AC','0001735358','0001735358','LA00001220500','IL','1','Patterson','Jessica','','','','34','439698997','9283 Samoa Ave',0,'Baton Rouge','LA','70810',NULL,'CY','22033','1987-04-16','F','U',':RET:2106-3','N','021','DEN','1635640','18575LA002000101','2014-01-01','2013-12-20 15:23:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:22'),(15754,12604,'Y','18','021','EC','A','','','AC','0000363157','0000363157','TX00001955193','31','1','GARCIA','MARYANN','','','','34','453254147','P.O. BOX 193',0,'MENARD','TX','76859',NULL,'CY','48327','1960-05-31','F','U',NULL,'N','021','DEN','1452096','33348TX002000201','2014-02-01','2014-01-02 16:52:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:01:16'),(7743,6132,'Y','18','021','EC','A','','','AC','0000762245','0000762245','OH00000568008','IL','1','Scheid','Kris','','','','34','273765626','10131 CROSIER LN',0,'BLUE ASH','OH','45242','5745','CY','39061','1978-12-21','M','U',':RET:2106-3','N','021','DEN','2227934','99734OH005000401','2014-01-01','2013-12-20 15:46:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:02:20'),(14238,11354,'Y','18','021','EC','A','','','AC','0000120613','0000120613','MS00001208420','IL','1','LI','HUI','','','','34','303191363','462 FAIRFIELD DR',0,'MADISON','MS','39110','7543','CY','28089','1964-12-31','M','M',':RET:2034-7','N','021','DEN','2466300','46300MS002000101','2014-02-01','2013-12-26 13:29:15','47.10',NULL,NULL,'74.25','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-27 02:05:10'),(7939,6279,'Y','18','021','EC','A','','','AC','0001721764','0001721764','LA00000225819','IL','1','Whittington','Margaret','','','','34','466714609','2944 GRAND RTE SAINT JOHN ST',0,'NEW ORLEANS','LA','70119','3003','CY','22071','1982-01-15','F','U',NULL,'N','021','DEN','2370631','18575LA002000201','2014-01-01','2013-12-20 14:46:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:50'),(13728,10955,'Y','18','024','14','A','','','TE','0001249587','0001249587','','IL','1','Smith','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-06','F','',NULL,NULL,NULL,'','1889996','','2013-12-23','2013-12-23 18:22:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:22'),(13464,10738,'Y','18','021','EC','A','','','AC','0001122740','0001122740','OH00000222596','IL','1','Sherman','David','I','','','34','044407412','3434 Darby Glen Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1953-12-20','M','U',':RET:2106-3','N','021','DEN','1711710','99734OH005000301','2014-01-01','2013-12-23 15:23:25','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:01:49'),(21915,17502,'Y','18','024','14','A','','','TE','0000499775','0000499775','','IL','1','Harris','Terrisha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-05-01','F','',NULL,NULL,NULL,'','3354776','','2014-02-28','2014-02-05 23:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-06 21:30:05'),(1203,990,'Y','18','021','EC','A','','','AC','0000300376','0000300376','OH00000895838','IL','1','capretta','ben','','','','34','286502727','4559 E BERWALD RD',0,'SOUTH EUCLID','OH','44121','3925','CY','39035','1951-11-19','M','M',':RET:2106-3','N','021','DEN','207252','99734OH005000301','2014-01-01','2013-12-03 08:20:33','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:19:55'),(5500,4366,'N','01','021','EC','A',NULL,NULL,'','0000689686','0000430265','','IL','1','Dunn','Donna','','','','34','289761343','3180 ZENOBIA RD',0,'NORWALK','OH','44857','8818','CY','39077','1980-04-19','F','',NULL,'N','021','HLT','1865416','92036OH005002705','2014-01-01','2013-12-19 15:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.59',NULL,0,'2013-12-25 23:11:18'),(2565,2084,'N','01','021','EC','A',NULL,NULL,'','0000654569','0000893132','','IL','1','Wakerman','Jane','','','','34','298784972','2937 UTOPIA PL',0,'CINCINNATI','OH','45208','2936','CY','39061','1951-07-15','F','',NULL,'N','021','HLT','381944','92036OH006001201','2014-01-01','2013-12-09 11:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','489.12',NULL,0,'2013-12-25 19:37:32'),(8841,7007,'N','01','021','EC','A',NULL,NULL,'','0000966842','0000106371','','IL','1','Doan','Amy','Tran','','','34','636667403','1909 Summit Ridge Drive',0,'Kerrville','TX','78028',NULL,'CY','48265','1979-08-01','F','',':RET:2047-9','N','021','DEN','2083305','33348TX002000201','2014-01-01','2013-12-17 22:02:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:00:45'),(17021,13621,'Y','18','021','EC','A','','','AC','0000948432','0000948432','OH00001752056','IL','1','Johnston','Lynn','','','','34','282722354','221 MELROSE AVE',0,'YOUNGSTOWN','OH','44512','2356','CY','39099','1962-04-30','F','U',':RET:2106-3','N','021','HLT','1374891','52664OH152000901','2014-02-01','2014-01-09 11:35:34','129.00',NULL,NULL,'345.46','216.46','R-OH013','OH0','345.46',NULL,0,'2014-01-13 02:20:40'),(16803,13440,'Y','18','021','EC','A','','','AC','0000803016','0000803016','TX00002452275','IL','1','Longnion','Cristy','','','','34','464993995','1634 county road 234',0,'Jasper','TX','75951',NULL,'CY','48241','1972-01-29','F','M',':RET:2106-3','N','021','DEN','2639592','33348TX002000201','2014-02-01','2014-01-11 11:36:10','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:18:12'),(16740,13392,'Y','18','021','EC','A','','','AC','0000370039','0000370039','OH00001975664','IL','1','SAMBOR','KATHY','','','','34','282626260','112 RIDGEVIEW DR',0,'SEVEN HILLS','OH','44131','5618','CY','39035','1959-05-14','F','M',':RET:2106-3','T','021','HLT','2071371','52664OH151001305','2014-02-01','2014-01-07 11:24:55','730.00',NULL,NULL,'1262.56','532.56','R-OH011','OH0','617.54',NULL,0,'2014-01-08 18:24:51'),(13960,11127,'N','01','021','EC','A',NULL,NULL,'','0000904260','0000993972','','IL','1','Bartee','Robin','Michelle','','','34','282722899','411 E. Pinehurst St.',0,'Sidney','OH','45365',NULL,'CY','39149','1962-01-01','F','',':RET:2106-3','N','021','HLT','1862973','92036OH005000501','2014-01-01','2013-12-22 22:34:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','464.00',NULL,0,'2013-12-26 13:15:07'),(14650,11693,'Y','18','021','EC','A','','','AC','0001233046','0001233046','TX00001894868','IL','1','SERVIN','MARY','J','','','34','458886324','421 COUNTY RD 715',0,'MACOGDOCHES','TX','75964',NULL,'CY','48347','1950-10-19','F','M',':RET:2106-3','N','021','DEN','2558274','33348TX002000201','2014-02-01','2013-12-27 18:48:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:07:43'),(21833,17435,'Y','18','021','EC','A','','','AC','0000050679','0000050679','TX00002363615','IL','1','Bujanda Herrera','Ever','','','','34','523069309','306 Tays',0,'El Paso','TX','79901',NULL,'CY','48141','1955-10-15','M','M',NULL,'T','021','DEN','3652782','33348TX002000101','2014-03-01','2014-02-06 12:32:59','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-06 21:01:05'),(27306,21620,'N','19','021','EC','A',NULL,NULL,'','0000428667','0001016864','','S1','1','Brooks','Quatro','','','','34','640234939','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','2009-12-18','M','',NULL,'N','021','DEN','3841046','33348TX002000201','2014-04-01','2014-03-04 13:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-04 21:00:37'),(27992,22149,'Y','18','021','EC','A','','','AC','0000292032','0000292032','OH00002933981','IL','1','Hunter','Brenda','','','','34','275964155','628 e 185th st',0,'cleveland','OH','44119',NULL,'CY','39035','1993-01-28','F','U',':RET:2054-5','N','021','DEN','3155784','99734OH005000401','2014-04-01','2014-03-05 18:22:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:04'),(28446,22508,'N','01','021','EC','A',NULL,NULL,'','0001318084','0002119908','','IL','1','Bandi','Stephen','','','','34','434781741','5418 S ROCHEBLAVE ST',0,'NEW ORLEANS','LA','70125','4322','CY','22071','1960-01-15','M','',':RET:2106-3','N','021','DEN','3236224','18575LA002000201','2014-04-01','2014-03-06 22:42:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-07 21:31:17'),(103,91,'Y','18','021','EC','A','','','AC','0000196207','0000196207','TX00001308159','IL','1','Lawson','Marianne','','','','34','731124314','1427 W FAIRMONT ST',0,'LONGVIEW','TX','75604','4408','CY','48183','1976-03-27','F','M',':RET:2106-3','N','021','DEN','245834','33348TX002000201','2014-01-01','2013-12-05 16:16:58','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2013-12-25 17:17:46'),(23941,19035,'Y','18','024','14','A','','','TE','0000288334','0000288334','','IL','1','Neal','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-06-27','F','',NULL,NULL,NULL,'','3256038','','2014-02-28','2014-02-15 11:00:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-15 21:00:08'),(20435,16322,'Y','18','021','EC','A','','','AC','0001059504','0001059504','OH00002032455','IL','1','DELLIFANTI','CAROL','JOYCE','','','34','299528640','40449 BUTTERNUT RIDGE RD',0,'ELYRIA','OH','44035','7909','CY','39093','1952-12-22','F','M',NULL,'N','021','DEN','1937320','99734OH005000301','2014-03-01','2014-01-29 16:40:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:37'),(9645,7642,'Y','18','021','EC','A','','','AC','0001226595','0001226595','TX00001271994','IL','1','Reichardt','Valerie','Renee','','','34','437790329','2924 San Antonio St.',0,'San Angelo','TX','76901',NULL,'CY','48451','1988-10-10','F','U',':RET:2106-3','N','021','DEN','1711567','33348TX002000101','2014-01-01','2013-12-21 15:54:06','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2013-12-26 04:38:36'),(9456,7501,'Y','18','021','EC','A','','','AC','0000653196','0000653196','OH00000452722','IL','1','Hood','Joyce','','','','34','294425072','166 STATE ROUTE 151',0,'MINGO JUNCTION','OH','43938','2604','CY','39081','1953-03-20','F','U',NULL,'N','021','DEN','2384766','99734OH005000401','2014-01-01','2013-12-20 22:43:11','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:34:07'),(1037,850,'N','01','021','EC','A',NULL,NULL,'','0000314043','0000173706','','IL','1','Reyes','Bertha','Guadalupe','','','34','467045809','8704 BUENA PARK DR',0,'EL PASO','TX','79907','6206','CY','48141','1954-03-10','F','',':RET:2106-3','N','021','DEN','1092930','33348TX002000201','2014-01-01','2013-12-03 15:14:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:15:40'),(18241,14560,'Y','18','021','EC','A','','','AC','0001084979','0001084979','TX00001980204','IL','1','HINOJOSA DE BOLANOS','MA','','','','34','641040479','825 GOODNIGHT TRL',0,'PHARR','TX','78577','7225','CY','48215','1956-10-26','F','U',NULL,'N','021','DEN','2008680','33348TX002000201','2014-02-01','2014-01-15 12:07:19','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-16 08:44:25'),(3845,3076,'Y','18','021','EC','A','','','AC','0000046988','0000046988','LA00000495891','IL','1','Hayes','Kara','','','','34','435650347','612 SPAIN ST',0,'NEW ORLEANS','LA','70117','7821','CY','22071','1983-07-19','F','M',':RET:2106-3','N','021','DEN','645472','18575LA002000101','2014-01-01','2013-12-13 11:17:20','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:35:29'),(5597,4442,'Y','18','021','EC','A','','','AC','0000116743','0000116743','LA00000541047','IL','1','Smith','Ravone','A','','','34','434752794','2270 PLEASURE ST',0,'NEW ORLEANS','LA','70122','4568','CY','22071','1988-01-05','F','U',':RET:2054-5','N','021','DEN','311112','18575LA002000201','2014-01-01','2013-11-25 21:36:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:30:08'),(5435,4317,'Y','18','021','EC','A','','','AC','0001448385','0001448385','LA00000715408','IL','1','Thompson','Elise','','','','34','439274935','8064 Owen St.',0,'Baton Rouge','LA','70809',NULL,'CY','22033','1976-05-31','F','R',':RET:2106-3','T','021','DEN','1400157','18575LA002000101','2014-01-01','2013-12-19 16:15:15','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:09:46'),(6169,4889,'N','19','021','EC','A',NULL,NULL,'','0000678057','0000151938','','IL','1','Cremonese','Katelyn','Rose','','','34','122845977','2210 MIAMI PL',0,'LIMA','OH','45806','1301','CY','39003','1996-02-02','F','',':RET:2106-3','N','021','HLT','345453','92036OH003001501','2014-01-01','2013-11-21 14:50:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-26 00:17:00'),(4917,3901,'Y','18','021','EC','A','','','AC','0000473620','0000473620','OH00001291709','IL','1','Sloan','Erin','R','','','34','270843418','840 W 10TH ST',0,'ASHLAND','OH','44805','1101','CY','39005','1985-04-08','F','U',':RET:2106-3','N','021','HLT','720908','52664OH151001305','2014-01-01','2013-12-06 18:15:17','160.00',NULL,NULL,'242.41','82.41','R-OH012','OH0','242.41',NULL,0,'2013-12-25 22:45:03'),(26354,20906,'N','19','021','EC','A',NULL,NULL,'','0000636066','0000616933','','IL','1','Borntrager','Eli','T','','','34','220919549','1415 PULLAN AVE',0,'CINCINNATI','OH','45223','1821','CY','39061','2011-08-10','M','',':RET:2106-3','N','021','HLT','3361899','92036OH004001201','2014-03-01','2014-02-27 15:51:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-28 06:31:48'),(25234,20016,'Y','18','021','EC','A','','','AC','0000425132','0000425132','OH00002562616','IL','1','Fath','Joshua','','','','34','279849234','520 Meredith Ln.',0,'Cuyahoga Falls','OH','44223','2575','CY','39153','1980-12-10','M','M',NULL,'N','021','HLT','3048452','52664OH152000901','2014-04-01','2014-02-21 12:39:23','0.00',NULL,NULL,'195.68','195.68','R-OH012','OH0','195.68',NULL,0,'2014-02-21 22:01:04'),(25199,19990,'Y','18','021','EC','A','','','AC','0002194917','0002194917','LA00002558707','IL','1','Marshall','Margo','','','','34','436274927','3034 EDSON BLVD',0,'SHREVEPORT','LA','71107','5715','CY','22017','1964-11-22','F','U',':RET:2054-5','N','021','DEN','3501055','18575LA002000201','2014-04-01','2014-02-21 13:08:09','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-02-21 22:00:45'),(14183,11308,'Y','18','021','EC','A','','','AC','0000243618','0000243618','TX00000264113','IL','1','Davis','Dotzie','','','','34','551087230','1015 COUNTY ROAD 158',0,'LONG BRANCH','TX','75669','2613','CY','48365','1963-11-22','F','M',':RET:2054-5','N','021','DEN','1534408','33348TX002000201','2014-02-01','2013-12-26 10:39:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:45'),(25195,19986,'Y','18','021','EC','A','','','AC','0001576178','0001576178','LA00002639520','IL','1','SHERMAN','CAROLYN','','','','34','435274928','1825 ROSIERE ST',0,'NEW ORLEANS','LA','70119',NULL,'CY','22071','1962-08-04','F','U',NULL,'N','021','DEN','3411780','18575LA002000201','2014-04-01','2014-02-20 23:54:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-21 22:00:42'),(7586,6001,'Y','18','021','EC','A','','','AC','0000368125','0000368125','TX00000273978','IL','1','Blair','Grace','','','','34','463967390','1956 CAROLINA AVE',0,'PORT ARTHUR','TX','77642','0549','CY','48245','1951-03-09','F','U',':RET:2106-3','N','021','DEN','65657','33348TX002000101','2014-01-01','2013-12-15 16:59:04','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2013-12-26 02:34:04'),(23585,18790,'N','19','021','EC','A',NULL,NULL,'','0001064757','0001147380','','IL','1','Fehr','Marilee','','','','34','272965420','2978 STATE ROUTE 133',0,'BETHEL','OH','45106','9304','CY','39025','1992-12-03','F','',NULL,'N','021','HLT','3163908','92036OH004000601','2014-03-01','2014-02-13 17:02:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-02-13 22:02:59'),(23155,18459,'Y','18','021','EC','A','','','AC','0001073194','0001073194','OH00001990616','IL','1','christman','jerry','','','','34','605075032','6619 HIGHLAND AVE',0,'CINCINNATI','OH','45236','3914','CY','39061','1971-10-11','M','R',':RET:2106-3','T','021','HLT','3690493','92036OH004001201','2014-03-01','2014-02-12 16:31:35','0.00',NULL,NULL,'263.02','263.02','R-OH004','OH0','263.02',NULL,0,'2014-02-12 21:31:44'),(21407,17109,'Y','18','024','14','A','','','TE','0000159447','0000159447','','IL','1','Dershimer','Mark',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-03-14','M','',NULL,NULL,NULL,'','2913719','','2014-02-04','2014-02-04 15:02:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:01:06'),(20586,16449,'Y','18','021','EC','A','','','AC','0000895748','0000895748','OH00001994007','IL','1','Parnell','Jonathan','C','','','34','276822422','9160 LEWIS AVE',0,'BLUE ASH','OH','45242','7440','CY','39061','1983-10-02','M','U',':RET:2106-3','T','021','DEN','2784989','99734OH005000401','2014-03-01','2014-01-29 20:35:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:06'),(6690,5302,'N','01','021','EC','A',NULL,NULL,'','0000728670','0000683347','','IL','1','Palmer','Megan','','','','34','286886787','401 SILVERWOOD FARMS DR',0,'LEBANON','OH','45036','8314','CY','39165','1979-04-14','F','',':RET:2106-3','N','021','DEN','125151','99734OH005000401','2014-01-01','2013-11-05 13:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:33'),(3682,2947,'Y','18','021','EC','A','','','AC','0000393650','0000393650','OH00000243127','IL','1','BENSON','SHARON','','','','34','295702473','2929 IRONSTONE DR',0,'COLUMBUS','OH','43231','8811','CY','39049','1964-11-28','F','U',':RET:2054-5','N','021','DEN','456967','99734OH005000401','2014-01-01','2013-12-13 09:35:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:31:29'),(4920,3904,'Y','18','021','EC','A','','','AC','0000552604','0000552604','OH00000486858','IL','1','Balogh','Frederick','','','','34','293522496','2486 8TH ST',0,'CUYAHOGA FALLS','OH','44221','2410','CY','39153','1952-06-08','M','M',':RET:2106-3','N','021','HLT','1058318','52664OH151001301','2014-01-01','2013-12-06 23:59:12','542.00',NULL,NULL,'626.65','84.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 22:45:08'),(17813,14229,'Y','18','021','EC','A','','','AC','0000684082','0000684082','TX00002318909','IL','1','Silva','Jacob','','','','34','639208900','21902 TOWER TER',0,'SAN ANTONIO','TX','78259','2758','CY','48029','1986-03-20','M','R',NULL,'N','021','DEN','1448365','33348TX002000101','2014-02-01','2014-01-14 16:43:08','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2014-01-15 02:05:53'),(18081,14441,'Y','18','021','EC','A','','','AC','0001344237','0001344237','LA00001432359','31','1','Miles','Roy','Ellis','','','34','436029295','P.O Box 625',0,'Kinder','LA','70648',NULL,'CY','22003','1957-07-28','M','M',':RET:2054-5','T','021','DEN','2061284','18575LA002000201','2014-02-01','2014-01-14 11:09:26','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2014-01-15 02:07:27'),(26767,21214,'Y','18','021','EC','A','','','AC','0000639503','0000639503','OH00002732769','IL','1','Platz-Rosenow','Heather','','','','34','274667346','1456 EASTON AVE',0,'MADISON','OH','44057','1114','CY','39085','1971-10-13','F','U',':RET:2106-3','N','021','HLT','3882838','52664OH151001301','2014-03-01','2014-02-28 20:41:48','0.00',NULL,NULL,'333.26','333.26','R-OH011','OH0','333.26','CIC',0,'2014-03-01 19:00:12'),(711,588,'Y','18','021','EC','A','','','AC','0000300394','0000300394','OH00000075273','IL','1','Depinet','Debra','','','','34','292565289','205 OHIO AVE',0,'TIFFIN','OH','44883','1745','CY','39147','1954-05-27','F','U',':RET:2106-3','T','021','HLT','1169946','92036OH005002701','2014-01-01','2013-12-15 18:44:26','295.00',NULL,NULL,'583.72','288.72','R-OH006','OH0','583.72',NULL,0,'2013-12-25 18:03:12'),(14632,11678,'N','01','021','EC','A',NULL,NULL,'','0000722644','0000608459','','IL','1','Anderson','Sunce','Raye','','','34','282643262','5381 E TOWNSHIP ROAD 138',0,'TIFFIN','OH','44883','9688','CY','39147','1957-03-20','F','',':RET:2106-3','N','021','HLT','2144949','92036OH005002705','2014-02-01','2013-12-27 12:39:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.92',NULL,0,'2013-12-28 03:37:12'),(20118,16052,'Y','18','021','EC','A','','','AC','0000532142','0000532142','OH00001559111','IL','1','Hixenbaugh','Allyssa','','','','34','274785092','26 JEFFERSON AVE',0,'ASHVILLE','OH','43103','1208','CY','39129','1979-04-30','F','M',':RET:2106-3','N','021','DEN','3331523','99734OH005000401','2014-03-01','2014-01-26 22:52:25','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-27 21:00:45'),(19686,15688,'Y','18','021','EC','A','','','AC','0000219765','0000219765','TX00002051297','IL','1','Newsome','Rickey','','','','34','427088141','316 Parakeet Dr',0,'Desoto','TX','75115',NULL,'CY','48113','1958-04-14','M','M',NULL,'N','021','DEN','2930896','33348TX002000201','2014-03-01','2014-01-23 13:40:09','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-23 21:00:40'),(18632,14852,'Y','18','021','EC','A','','','AC','0001253148','0001253148','TX00001891698','IL','1','DUNCAN','ROBERT','WAYNE','','','34','575788516','14197 RANIER POINT DR',0,'EL PASO','TX','79938','5204','CY','48141','1966-04-06','M','M',NULL,'N','021','DEN','1712407','33348TX002000201','2014-02-01','2014-01-15 21:34:22','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-17 03:35:02'),(15360,12285,'Y','18','021','EC','A','','','AC','0000926280','0000926280','OH00001828204','IL','1','Rodriguez','Brianna',NULL,NULL,NULL,NULL,NULL,'2557 CHERRY LAKE RD',0,'SYLVANIA','OH','43560','8982','CY','39095','1997-09-21','F','R',':RET:2106-3','N','021','DEN','2458819','99734OH005000301','2014-02-01','2014-01-01 02:09:23','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','21.13',NULL,1,'2014-01-02 04:24:45'),(13889,11078,'Y','18','021','EC','A','','','AC','0001071775','0001071775','OH00000315193','IL','1','BRADMAN','REBECCA','','','','34','286568915','7043 RAMBLEHURST RD',0,'SYLVANIA','OH','43560','3573','CY','39095','1953-09-13','F','U',':RET:2106-3','N','021','HLT','2112195','92036OH005002604','2014-01-01','2013-12-23 09:47:56','342.00',NULL,NULL,'529.21','187.21','R-OH001','OH0','529.21',NULL,0,'2013-12-26 13:13:25'),(5182,4110,'Y','18','024','14','A','','','TE','0000714933','0000714933','','IL','1','Truong','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-06-01','M','',NULL,NULL,NULL,'','227690','','2013-12-19','2013-12-19 12:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:31'),(3780,3028,'Y','18','021','EC','A','','','AC','0001227005','0001227005','OH00001072315','IL','1','Phillips','Deborah','','','','34','299508657','7340 Cayman Way',0,'Maineville','OH','45039',NULL,'CY','39165','1951-07-31','F','U',':RET:2054-5','T','021','DEN','439050','99734OH005000301','2014-01-01','2013-12-12 23:06:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:33:58'),(9035,7169,'N','01','021','EC','A',NULL,NULL,'','0001077720','0000713624','','IL','1','Smith','Stephen','','','','34','299529548','1246 FRANK DR',0,'WOOSTER','OH','44691','4674','CY','39169','1952-04-11','M','',':RET:2106-3','N','021','HLT','1737238','52664OH151001305','2014-01-01','2013-12-18 14:22:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2013-12-26 04:05:41'),(7987,6323,'Y','18','021','EC','A','','','AC','0001162588','0001162588','OH00000880942','IL','1','HENDERSON','JAMES','','','','34','283740410','400 HIGH ST',0,'DOYLESTOWN','OH','44230','1322','CY','39169','1969-08-27','M','M',NULL,'N','021','HLT','1803078','52664OH151001304','2014-01-01','2013-12-20 15:01:20','448.00',NULL,NULL,'789.84','341.84','R-OH014','OH0','311.54',NULL,0,'2013-12-26 03:08:06'),(4295,3417,'Y','18','021','EC','A','','','AC','0000608248','0000608248','MS00001285654','IL','1','ahmed','zaidan','','','','34','496989990','807 poplare ave',0,'new albany','MS','38652',NULL,'CY','28145','1960-01-01','M','M',':RET:2054-5','N','021','DEN','2436740','46300MS002000201','2014-01-01','2013-12-17 13:07:02','0.00',NULL,NULL,'31.70','31.70','R-MS002','MS0','15.85',NULL,0,'2013-12-25 21:52:14'),(5484,4354,'Y','18','021','EC','A','','','AC','0000414690','0000414690','OH00001090224','IL','1','Johnson','Paul','M','','','34','269568096','2410 GATETREE LN',0,'BATAVIA','OH','45103','8951','CY','39025','1953-11-21','M','M',':RET:2106-3','N','021','HLT','1944088','92036OH005000605','2014-01-01','2013-12-19 09:44:45','901.00',NULL,NULL,'1165.20','264.20','R-OH005','OH0','582.60',NULL,0,'2013-12-25 23:10:55'),(4325,3436,'Y','18','021','EC','A','','','AC','0000930896','0000930896','OH00000108295','IL','1','THOMPSON','JOHN','C','','','34','285568838','44852 HOGPATH',0,'GREENVILLE','OH','45331',NULL,'CY','39037','1954-02-11','M','M',':RET:2106-3','T','021','HLT','1455005','92036OH004000501','2014-01-01','2013-12-17 09:31:49','402.00',NULL,NULL,'572.17','170.17','R-OH003','OH0','572.17',NULL,0,'2013-12-25 21:52:52'),(5000,3965,'Y','18','021','EC','A','','','AC','0000558124','0000558124','OH00001133215','IL','1','Geiger','Stephen','R','','','34','288466421','7240 HICKMAN ST',0,'CINCINNATI','OH','45231','5331','CY','39061','1951-02-17','M','M',NULL,'N','021','DEN','953234','99734OH005000301','2014-01-01','2013-12-07 10:48:59','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:47:07'),(5912,4682,'N','01','021','EC','A',NULL,NULL,'','0000955090','0000723898','','IL','1','MARACINE','IOANA','','','','34','640143633','2522 QUAIL GLEN RD',0,'CARROLLTON','TX','75006','2011','CY','48113','1961-06-26','F','',':RET:2106-3','N','021','DEN','1996315','33348TX002000101','2014-01-01','2013-12-23 22:08:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 23:50:03'),(26392,20934,'Y','18','024','14','A','','','TE','0000194050','0000194050','','IL','1','Taylor','Kathleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-24','F','',NULL,NULL,NULL,'','2681139','','2014-02-26','2014-02-26 13:08:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:00:26'),(26429,20962,'Y','18','021','EC','A','','','AC','0000298291','0000298291','OH00002734141','IL','1','SIGMAN','GAYLENE','','','','34','270763238','126 MAPLE ST',0,'LONDON','OH','43140','1416','CY','39097','1972-12-18','F','U',':RET:2106-3','T','021','DEN','3826937','99734OH005000401','2014-04-01','2014-02-26 18:46:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-28 07:30:15'),(26690,21161,'Y','18','021','EC','A','','','AC','0002130752','0002130752','LA00003440424','31','1','Wright','Helaine','','','','34','437276775','P.O. Box 84',0,'Belle Chasse','LA','70037',NULL,'CY','22051','1964-08-18','F','U',NULL,'N','021','DEN','2905275','18575LA002000101','2014-04-01','2014-02-27 23:33:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-28 21:31:28'),(245,205,'N','19','021','EC','A',NULL,NULL,'','0000796930','0000219957','','IL','1','Brunner','Rebecca','','','','34','291981714','7719 Topridge Drive',0,'West Chester','OH','45069',NULL,'CY','39017','1995-10-15','F','',':RET:2106-3','N','021','HLT','273253','92036OH005001201','2014-01-01','2013-12-05 13:41:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 17:21:26'),(13958,11126,'Y','18','021','EC','A','','','AC','0000889610','0000889610','OH00000089199','IL','1','iding','catherine','ann','','','34','275507865','1402 POST WOODS GLN',0,'BATAVIA','OH','45103','3609','CY','39025','1951-02-09','F','U',':RET:2106-3','T','021','HLT','2462216','92036OH004000601','2014-01-01','2013-12-23 17:19:55','345.00',NULL,NULL,'570.30','225.30','R-OH005','OH0','570.30',NULL,0,'2013-12-26 13:15:03'),(528,430,'Y','18','021','EC','A','','','AC','0000005808','0000005808','OH00000786939','IL','1','Burtscher','Michael','','','','34','293524242','3862 FAIRFIELD DR',0,'MOGADORE','OH','44260','1407','CY','39153','1952-03-25','M','U',':RET:2106-3','N','021','HLT','119119','52664OH151001501','2014-01-01','2013-12-04 14:13:39','308.00',NULL,NULL,'751.58','443.58','R-OH012','OH0','751.58',NULL,0,'2013-12-25 17:49:22'),(17578,14054,'N','01','021','EC','A',NULL,NULL,'','0000196157','0000690755','','IL','1','Copley','Mark','','','','34','299560695','7248 CHILDRENS HOME BRADFORD RD',0,'GREENVILLE','OH','45331','9234','CY','39037','1956-11-03','M','',':RET:2106-3','N','021','DEN','2474676','99734OH005000401','2014-02-01','2014-01-13 14:06:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:05'),(9179,7280,'N','01','021','EC','A',NULL,NULL,'','0000015249','0000809665','','IL','1','Lewis','Shawna','E','','','34','296742090','5205 NORFOLK ST',0,'LIMA','OH','45806','9465','CY','39003','1963-10-08','F','',':RET:2106-3','T','021','HLT','1396257','92036OH005001506','2014-01-01','2013-12-18 09:53:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','452.02',NULL,0,'2013-12-26 04:09:07'),(22115,17652,'Y','18','021','EC','A','','','AC','0001172710','0001172710','TX00002113145','IL','1','Jaber','Nancy','','','','34','577705996','701 N Vista Ridge Blvd',0,'Cedar Park','TX','78613',NULL,'CY','48491','1966-01-18','F','U',':RET:2106-3','N','021','DEN','2777538','33348TX002000101','2014-03-01','2014-02-07 21:39:39','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-08 19:00:36'),(25786,20450,'Y','18','021','EC','A','','','AC','0001062179','0001062179','OH00002649701','IL','1','Lehman','Richard','','','','34','296788314','7163 TAYLOR RD',0,'CLINTON','OH','44216','9337','CY','39153','1970-12-16','M','U',':RET:2106-3','N','021','HLT','3422831','52664OH151001501','2014-04-01','2014-02-24 17:42:04','228.00',NULL,NULL,'362.95','134.95','R-OH012','OH0','362.95',NULL,0,'2014-02-26 09:31:06'),(1582,1320,'Y','18','021','EC','A','','','AC','0000708191','0000708191','TX00000953021','IL','1','LOPEZ','EMILIA','','','','34','585311756','10024 MERCEDES ST',0,'EL PASO','TX','79924','3817','CY','48141','1955-09-17','F','U',NULL,'N','021','DEN','2499538','33348TX002000201','2014-01-01','2013-12-24 10:50:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:51:28'),(6510,5160,'Y','18','021','EC','A','','','AC','0000269992','0000269992','OH00000202254','IL','1','Milan','Robert','','','','34','296501378','1273 W MAIN ST',0,'KENT','OH','44240','1971','CY','39133','1954-01-13','M','U',':RET:2106-3','N','021','HLT','139277','52664OH152000901','2014-01-01','2013-12-11 13:24:29','318.00',NULL,NULL,'425.18','107.18','R-OH012','OH0','425.18',NULL,0,'2013-12-26 00:51:06'),(19850,15832,'Y','18','021','EC','A','','','AC','0000595175','0000595175','OH00002157442','IL','1','Albright','Paula','','','','34','293482379','325 MECHANIC ST',0,'CLYDE','OH','43410','1969','CY','39143','1950-07-25','F','U',':RET:2106-3','N','021','DEN','2162457','99734OH005000301','2014-03-01','2014-01-24 11:37:32','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-01-24 21:00:30'),(6078,4817,'N','01','021','EC','A',NULL,NULL,'','0000807468','0001196785','','IL','1','Hassel','Marcia',NULL,NULL,NULL,NULL,NULL,'5130 ROLLMAN ESTATES DR',0,'CINCINNATI','OH','45236','1456','CY','39061','1950-03-11','F','',NULL,'N','021','HLT','1017274','92036OH004001201','2014-01-01','2013-12-01 11:00:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','509.54',NULL,0,'2013-12-26 00:02:23'),(17379,13905,'Y','18','021','EC','A','','','AC','0001156222','0001156222','OH00002469973','IL','1','Myers','Paul','','','','34','270884207','4164 WATKINS RD',0,'NORTON','OH','44203','6156','CY','39153','1979-09-29','M','U',NULL,'T','021','DEN','2477397','99734OH005000401','2014-02-01','2014-01-09 21:37:45','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:00:05'),(14366,11457,'Y','18','021','EC','A','','','AC','0001165347','0001165347','OH00001829167','IL','1','Pennick','Crystal','','','','34','523317645','3643 BASSWOOD AVE NE',0,'WARREN','OH','44483','2307','CY','39155','1980-09-20','F','U',NULL,'N','021','DEN','2051167','99734OH005000401','2014-02-01','2013-12-27 00:17:01','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-28 03:30:24'),(14345,11443,'Y','18','021','EC','A','','','AC','0000541650','0000541650','OH00001459579','IL','1','HUBBARD','MARIE','D','','','34','401137409','7830 TAWAWA MAPLEWOOD RD',0,'SIDNEY','OH','45365','9261','CY','39149','1968-05-01','F','M',':RET:2106-3','T','021','HLT','2611148','92036OH003000505','2014-02-01','2013-12-26 16:41:47','536.00',NULL,NULL,'878.98','342.98','R-OH003','OH0','412.23',NULL,0,'2013-12-27 02:08:00'),(2804,2266,'Y','18','021','EC','A','','','AC','0000230404','0000230404','OH00000024695','IL','1','jones','anthony','','','','34','299763779','1034 king st',0,'toledo','OH','43607',NULL,'CY','39095','1981-01-14','M','U',':RET:2054-5','N','021','HLT','98080','92036OH006002601','2014-01-01','2013-12-02 10:19:07','130.00',NULL,NULL,'182.95','52.95','R-OH001','OH0','182.95',NULL,0,'2013-12-25 19:50:30'),(8141,6441,'N','19','021','EC','A',NULL,NULL,'','0000176358','0000915609','','IL','1','Leis','Justin','','','','34','289048595','66 CRESTWOOD DR',0,'WILLARD','OH','44890','1607','CY','39077','1999-11-23','M','',':RET:2106-3','N','021','HLT','1222029','92036OH004002701','2014-01-01','2013-11-21 21:10:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-26 03:15:48'),(3959,3168,'N','19','021','EC','A',NULL,NULL,'','0000246429','0000192714','','IL','1','Dougherty','Zachary','H','','','34','299026708','1782 Middleton Rd',0,'Hudson','OH','44236',NULL,'CY','39153','1998-06-20','M','',':RET:2106-3','N','021','HLT','919943','52664OH151001501','2014-01-01','2013-12-13 13:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 21:38:23'),(5181,4109,'N','01','021','EC','A',NULL,NULL,'','0000714933','0001032579','','IL','1','Tran','Cindy','','','','34','436916429','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','1974-12-25','F','',':RET:2047-9','N','021','DEN','2460550','99734OH005000401','2014-01-01','2013-12-19 12:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:03:30'),(27179,21519,'Y','18','021','EC','A','','','AC','0000005200','0000005200','TX00002825923','IL','1','Killebrew','Shivon','','','','34','457858599','6933 BORDER BRK',0,'SAN ANTONIO','TX','78238','4031','CY','48029','1986-12-10','F','U',NULL,'N','021','DEN','3072388','33348TX002000201','2014-04-01','2014-03-03 13:26:20','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-03 21:31:09'),(541,442,'Y','18','021','EC','A','','','AC','0000373600','0000373600','OH00000076167','IL','1','Anderson','Robin','L','','','34','296501026','240 NATHAN AVE',0,'CUYAHOGA FALLS','OH','44221','2613','CY','39153','1954-05-22','M','U',':RET:2106-3','T','021','HLT','650255','52664OH152000901','2014-01-01','2013-12-04 18:06:51','0.00',NULL,NULL,'488.95','488.95','R-OH012','OH0','488.95',NULL,0,'2013-12-25 17:49:43'),(2090,1711,'Y','18','021','EC','A','','','AC','0000741409','0000741409','LA00000419400','IL','1','AUGUSTUS','TIYAWNA','','','','34','436615291','14031 NORTHGATE DR',0,'BATON ROUGE','LA','70807','1131','CY','22033','1986-06-29','F','U',':RET:2054-5','N','021','DEN','1030707','18575LA002000201','2014-01-01','2013-12-10 16:42:53','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:51'),(21699,17327,'Y','18','021','EC','A','','','AC','0000927341','0000927341','OH00002134081','IL','1','sharp','gloria','','','','34','294560505','606 SCHOCALOG RD',0,'AKRON','OH','44320','1034','CY','39153','1959-02-07','F','U',':RET:2106-3','N','021','HLT','3152540','52664OH151001501','2014-03-01','2014-02-05 12:50:37','97.00',NULL,NULL,'596.45','499.45','R-OH012','OH0','596.45',NULL,0,'2014-02-05 21:31:10'),(18783,14961,'Y','18','021','EC','A','','','AC','0000884247','0000884247','OH00002143515','IL','1','HENN','MICHELE','','','','34','297726402','6 SPRINGBOK DR',0,'FAIRFIELD','OH','45014','6616','CY','39017','1963-11-05','F','U',NULL,'N','021','DEN','2025402','99734OH005000401','2014-02-01','2014-01-15 21:36:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:53'),(18135,14481,'Y','18','024','14','A','','','TE','0000542703','0000542703','','IL','1','HUGHETT','JEFFREY','RAY',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-04-18','M','',NULL,NULL,NULL,'','1403598','','2014-01-14','2014-01-14 18:12:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:07:44'),(6319,5009,'N','01','021','EC','A',NULL,NULL,'','0000648299','0001261187','','IL','1','Setser','Melissa','Diane','','','34','299761110','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','1968-06-07','F','',':RET:2106-3','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:19'),(16650,13321,'Y','18','021','EC','A','','','AC','0000538698','0000538698','MS00001558637','IL','1','Bailes','Margaret','','','','34','556172081','950 Easterbrook St',0,'Bay St Louis','MS','39520',NULL,'CY','28045','1952-09-26','F','U',':RET:2106-3','N','021','DEN','1360306','46300MS002000201','2014-02-01','2014-01-07 16:58:53','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-08 18:24:20'),(2695,2183,'N','01','021','EC','A',NULL,NULL,'','0000485197','0000399381','','IL','1','Habib','Geetha','','','','34','333681347','1907 MIDNIGHT LN',0,'HOUSTON','TX','77047','2559','CY','48201','1954-03-18','F','',':RET:2029-7','N','021','DEN','203102','33348TX002000201','2014-01-01','2013-12-02 17:24:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 19:47:36'),(4408,3503,'N','19','021','EC','A',NULL,NULL,'','0000803710','0000784339','','IL','1','Devore','Nolan',NULL,NULL,NULL,NULL,NULL,'1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2013-07-26','M','',NULL,'N','021','DEN','252161','99734OH005000401','2014-01-01','2013-12-12 14:40:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:19'),(13984,11142,'Y','18','021','EC','A','','','AC','0000319666','0000319666','OH00000341131','IL','1','Seeman','Walter','','','','34','299502599','205 WOODLAND AVE',0,'SWANTON','OH','43558','1050','CY','39051','1952-02-15','M','M',NULL,'N','021','HLT','1738721','92036OH001002601','2014-01-01','2013-12-23 00:19:06','104.00',NULL,NULL,'1260.25','1156.25','R-OH001','OH0','660.95',NULL,0,'2013-12-26 13:15:40'),(13954,11125,'Y','18','021','EC','A','','','AC','0000112931','0000112931','OH00000037661','IL','1','Foy','Charles','','','','34','273845622','41 CROSSBOW CT',0,'AMELIA','OH','45102','2112','CY','39025','1978-01-12','M','M',':RET:2106-3','N','021','HLT','2027257','92036OH004000601','2014-01-01','2013-12-23 16:24:41','403.00',NULL,NULL,'645.23','242.23','R-OH005','OH0','210.92',NULL,0,'2013-12-26 13:14:59'),(23075,18398,'N','01','021','EC','A',NULL,NULL,'','0001284884','0001913353','','IL','1','Lee','David','','','Sr','34','438865735','335 GIBBS ST',0,'MANSFIELD','LA','71052','2615','CY','22031','1952-11-17','M','',':RET:2054-5','T','021','DEN','2869341','18575LA002000201','2014-03-01','2014-02-12 14:56:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-12 21:30:59'),(25209,19997,'Y','18','021','EC','A','','','AC','0000471066','0000471066','OH00001818390','IL','1','Thrasher','Edward',NULL,NULL,NULL,NULL,NULL,'7609 ROAD 82',0,'PAYNE','OH','45880','9518','CY','39125','1969-03-17','M','M',':RET:2106-3','N','021','DEN','3518034','99734OH005000301','2014-04-01','2014-02-21 12:31:27','0.00',NULL,NULL,'59.76','59.76','R-OH002','OH0','0.00',NULL,0,'2014-02-21 22:00:50'),(25604,20314,'N','19','021','EC','A',NULL,NULL,'','0001164583','0000717563','','IL','1','Varnell','Joshua','Taylor','','','34','632549246','3660 SPRING CANYON TRL',0,'ROUND ROCK','TX','78681','2263','CY','48491','1996-09-08','M','',':RET:2106-3','N','021','DEN','3421348','33348TX002000201','2014-04-01','2014-02-21 18:21:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-26 08:30:04'),(26054,20663,'Y','18','021','EC','A','','','AC','0000429095','0000429095','OH00002075779','IL','1','Berry','LeAnna','','','','34','286847724','3218 SANDY LAKE RD',0,'RAVENNA','OH','44266','9553','CY','39133','1985-01-16','F','M',':RET:2106-3','N','021','HLT','2619066','52664OH151001501','2014-03-01','2014-02-26 13:05:56','0.00',NULL,NULL,'299.29','299.29','R-OH012','OH0','299.29',NULL,0,'2014-02-26 21:02:35'),(26253,20823,'Y','18','021','EC','A','','','AC','0000971052','0000971052','TX00002784151','IL','1','PURSREY','MELISSA','','','','34','456692197','311 MORNING DOVE CT',0,'KYLE','TX','78640','9218','CY','48209','1983-08-03','F','U',NULL,'N','021','DEN','3482434','33348TX002000201','2014-04-01','2014-02-27 14:50:25','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-28 06:31:09'),(27598,21827,'Y','18','024','14','A','','','TE','0000338853','0000338853','','IL','1','McKinney','Debra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-12','F','',NULL,NULL,NULL,'','2442979','','2014-03-31','2014-03-05 15:40:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-05 21:00:21'),(50,45,'Y','18','024','14','A','','','TE','0000099191','0000099191','','IL','1','Vaughn','Norma',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-04-08','F','',NULL,NULL,NULL,'','260191','','2013-12-05','2013-12-05 15:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 17:16:22'),(21151,16901,'Y','18','021','EC','A','','','AC','0001102127','0001102127','OH00001832370','IL','1','Dabrowski','George','','','','34','283908320','8463 SOUTHLANE DR',0,'BROOKLYN','OH','44144','2756','CY','39035','1986-11-20','M','U',':RET:2106-3','N','021','DEN','3267705','99734OH005000401','2014-03-01','2014-02-02 21:14:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:28'),(6756,5361,'Y','18','021','EC','A','','','AC','0000619603','0000619603','OH00000393746','IL','1','frangias','maria','','','','34','271864561','431 MONTABELLA PL NW',0,'CANTON','OH','44709','4872','CY','39151','1967-11-26','F','M',':RET:2106-3','N','021','HLT','217444','52664OH152000901','2014-01-01','2013-11-24 21:01:01','0.00',NULL,NULL,'245.01','245.01','R-OH015','OH0','245.01',NULL,0,'2013-12-26 01:16:13'),(20382,16282,'Y','18','021','EC','A','','','AC','0000700956','0000700956','TX00001995288','IL','1','Sweatt','DAdreinne','','','','34','559879148','8727 Point Park Dr',0,'Houston','TX','77095',NULL,'CY','48201','1985-12-01','F','U',':RET:2054-5','N','021','DEN','2868991','33348TX002000201','2014-03-01','2014-01-28 22:29:41','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-29 21:00:11'),(20221,16133,'N','01','021','EC','A',NULL,NULL,'','0001007916','0000700413','','IL','1','Seip','Pamela','','','','34','284464006','1103 RIDGEPOINT DR',0,'BATAVIA','OH','45103','2680','CY','39025','1951-10-05','F','',':RET:2106-3','N','021','HLT','2930970','92036OH004000601','2014-03-01','2014-01-27 14:05:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','495.91',NULL,0,'2014-01-27 21:01:44'),(6558,5199,'Y','18','021','EC','A','','','AC','0000040945','0000040945','TX00001023090','IL','1','Pierce','Bradley','','','','34','459832618','3824 cedar springs road',0,'Dallas','TX','75219',NULL,'CY','48113','1980-03-26','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','26171','33348TX002000201','2014-01-01','2013-12-11 13:20:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:52:21'),(19107,15223,'Y','18','021','EC','A','','','AC','0001007907','0001007907','OH00002290311','IL','1','Siebold','Thomas','','','','34','389481757','126 MARSHALL ST',0,'YELLOW SPRINGS','OH','45387','1634','CY','39057','1951-02-13','M','U',':RET:2106-3','N','021','HLT','2756961','92036OH004000501','2014-03-01','2014-01-18 11:25:20','381.00',NULL,NULL,'564.22','183.22','R-OH003','OH0','564.22',NULL,0,'2014-01-21 08:44:42'),(17291,13829,'Y','18','021','EC','A','','','AC','0000546561','0000546561','TX00002160364','IL','1','Harvey','Karl','','','','34','438688999','13854 HAWKSNEST BAY DR',0,'CORPUS CHRISTI','TX','78418','6334','CY','48355','1956-04-06','M','M',':RET:2106-3','N','021','DEN','1682772','33348TX002000201','2014-02-01','2014-01-09 21:59:21','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-01-13 02:23:33'),(16870,13498,'Y','18','021','EC','A','','','AC','0000490450','0000490450','TX00002063257','IL','1','Richard','Delton','','','','34','467794716','1383 COUNTY ROAD 1109',0,'MAUD','TX','75567','3418','CY','48037','1972-09-26','M','U',':RET:2106-3','N','021','DEN','1881058','33348TX002000201','2014-02-01','2014-01-09 16:14:00','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-01-13 02:19:15'),(16655,13326,'Y','18','021','EC','A','','','AC','0000957012','0000957012','MS00001751994','IL','1','WALKER','MICHAEL','RAY','','','34','430232464','347 QUEEN THERESA LN',0,'JACKSON','MS','39209',NULL,'CY','28049','1958-12-29','M','U',':RET:2054-5','N','021','DEN','1880971','46300MS002000201','2014-02-01','2014-01-07 11:54:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-08 18:24:22'),(16423,13141,'Y','18','021','EC','A','','','AC','0000830648','0000830648','OH00001633959','IL','1','Sutton','John','','','','34','483082349','4106 Otter Creek Drive',0,'Amelia','OH','45102',NULL,'CY','39025','1969-07-22','M','U',':RET:2106-3','N','021','HLT','2234914','92036OH003000604','2014-02-01','2014-01-06 15:33:04','167.00',NULL,NULL,'313.18','146.18','R-OH005','OH0','313.18',NULL,0,'2014-01-07 04:04:32'),(6297,4994,'N','01','021','EC','A',NULL,NULL,'','0000062515','0001055295','','IL','1','KACHMAR','ROBERTA','','','','34','279488304','15175 HARTFORD TRL',0,'STRONGSVILLE','OH','44136','8221','CY','39035','1950-03-03','F','',NULL,'N','021','DEN','1086525','99734OH005000401','2014-01-01','2013-12-11 08:34:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:45:48'),(2318,1884,'Y','18','021','EC','A','','','AC','0000914738','0000914738','TX00001116086','31','1','Witt','Cody','','','','34','627121206','PO BOX 3081',0,'Big Spring','TX','79721',NULL,'CY','48227','1985-11-12','M','U',':RET:2106-3','N','021','DEN','493429','33348TX002000201','2014-01-01','2013-12-09 07:21:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:21'),(15091,12063,'Y','18','021','EC','A','','','AC','0000490482','0000490482','OH00001848328','IL','1','Lewis','Victoria','','','','34','283866924','1612 MAYWOOD RD',0,'SOUTH EUCLID','OH','44121','4104','CY','39035','1982-09-04','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2019879','99734OH005000301','2014-02-01','2013-12-29 21:13:57','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:04:28'),(14861,11866,'Y','18','021','EC','A','','','AC','0000997755','0000997755','OH00000455306','IL','1','CISCO','JEFF','','','','34','301762593','570 ST.CLAIR AVE',0,'LIMA','OH','45801',NULL,'CY','39003','1965-11-17','M','M',':RET:2106-3','N','021','HLT','2264947','92036OH004001501','2014-01-01','2013-12-23 19:51:34','0.00',NULL,NULL,'289.34','289.34','R-OH002','OH0','289.34',NULL,1,'2013-12-29 11:15:22'),(2913,2347,'N','01','021','EC','A',NULL,NULL,'','0000095211','0000829253','','IL','1','ROBERTS','ROSEMARIA','','','','34','271680435','822 IMANI CIR',0,'TOLEDO','OH','43604','8427','CY','39095','1957-10-02','F','',':RET:2054-5','N','021','DEN','267905','99734OH005000401','2014-01-01','2013-12-06 11:29:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:35'),(4951,3930,'Y','18','021','EC','A','','','AC','0000025403','0000025403','LA00000982082','31','1','Minson','Beau','M','','','34','436857610','PO Box 3451',0,'St Francisville','LA','70775',NULL,'CY','22125','1984-09-26','M','M',NULL,'N','021','DEN','693656','18575LA002000201','2014-01-01','2013-12-06 18:34:26','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:45:57'),(27904,22076,'Y','18','021','EC','A','','','AC','0000393614','0000393614','TX00003541345','IL','1','TOLIVER','HAZEL','','','','34','452802130','10323 CAROLINA OAKS DR',0,'DALLAS','TX','75227','7110','CY','48113','1950-06-30','F','U',NULL,'N','021','DEN','2851986','33348TX002000201','2014-04-01','2014-03-05 18:34:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:11'),(2556,2079,'N','01','021','EC','A',NULL,NULL,'','0000385176','0000396442','','IL','1','Bell','Debora','','','','34','426273253','2025 TULANE RD',0,'NESBIT','MS','38651','9647','CY','28033','1966-05-02','F','',':RET:2054-5','N','021','DEN','959639','46300MS002000201','2014-01-01','2013-12-09 13:54:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 19:37:24'),(2732,2210,'Y','18','021','EC','A','','','AC','0000143051','0000143051','LA00000956829','IL','1','Smith','Trimeca','','','','34','436599587','1959 GARDEN ST',0,'SHREVEPORT','LA','71101','2214','CY','22017','1977-04-10','F','U',':RET:2054-5','N','021','DEN','777573','18575LA002000201','2014-01-01','2013-12-02 12:33:36','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 19:48:30'),(19480,15527,'N','01','021','EC','A',NULL,NULL,'','0000953797','0001041432','','IL','1','GUNERATNE','NILUSHA','DUSHMANTHA','','','34','612252094','1334 RED STAG PL',0,'ROUND ROCK','TX','78665','1359','CY','48491','1977-09-27','F','',':RET:2028-9','N','021','DEN','3311003','33348TX002000201','2014-03-01','2014-01-22 17:10:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 03:02:03'),(18658,14874,'N','01','021','EC','A',NULL,NULL,'','0000231952','0000321916','','IL','1','dominguz  jr','richard','','','','34','450713479','422 MORGAN AVE',0,'TYLER','TX','75702','7655','CY','48423','1976-01-21','M','',NULL,'N','021','DEN','1451266','33348TX002000201','2014-03-01','2014-01-16 14:28:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:12'),(15410,12326,'N','19','021','EC','A',NULL,NULL,'','0000826937','0000958706','','IL','1','nguyen','christina','','','','34','445063208','531 hawthorne dr',0,'murphy','TX','75094',NULL,'CY','48085','1992-06-20','F','',':RET:2047-9','N','021','DEN','1670382','33348TX002000201','2014-02-01','2013-12-30 23:23:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,1,'2014-01-02 04:27:05'),(14755,11781,'Y','18','021','EC','A','','','AC','0000870638','0000870638','OH00000366107','IL','1','Gibson','Lonnie','','','','34','282521132','1412 WACO ST',0,'TROY','OH','45373','3832','CY','39109','1952-03-01','M','R',':RET:2106-3','T','021','HLT','1959543','92036OH004000501','2014-02-01','2013-12-28 17:34:29','0.00',NULL,NULL,'617.67','617.67','R-OH003','OH0','617.67',NULL,1,'2013-12-29 11:10:25'),(13927,11107,'Y','18','021','EC','A','','','AC','0000993976','0000993976','OH00000580386','IL','1','Forgette','Holly','','','','34','278828556','2929 STARR AVE',0,'OREGON','OH','43616','2251','CY','39095','1983-11-14','F','U',':RET:2106-3','N','021','HLT','2235533','92036OH003002606','2014-01-01','2013-12-23 18:37:37','153.00',NULL,NULL,'231.13','78.13','R-OH001','OH0','231.13',NULL,0,'2013-12-26 13:14:20'),(28742,22748,'Y','18','021','EC','A','','','AC','0001986002','0001986002','LA00002725072','IL','1','CARATTINI','JENNIFER','','','','34','596389452','255 CLIFFWOOD DR',0,'HOUMA','LA','70364','1072','CY','22109','1993-03-16','F','U',NULL,'T','021','DEN','4022780','18575LA002000201','2014-04-01','2014-03-09 10:51:35','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-03-09 21:00:10'),(745,616,'N','19','021','EC','A',NULL,NULL,'','0001241620','0001192642','','IL','1','Ibekwe','John','','','Jr','34','638846694','416 PECAN HOLLOW DR',0,'COPPELL','TX','75019','4848','CY','48113','1990-05-26','M','',':RET:2054-5','N','021','DEN','640755','33348TX002000201','2014-01-01','2013-12-16 00:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:04:09'),(22872,18244,'Y','18','021','EC','A','','','AC','0001037585','0001037585','MS00001987077','IL','1','COLEY','MARY','','','','34','587804064','367 ROBIN ST',0,'COLUMBUS','MS','39702','9447','CY','28087','1954-03-28','F','U',':RET:2054-5','N','021','DEN','3507078','46300MS002000101','2014-03-01','2014-02-11 09:08:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-11 21:02:30'),(22619,18062,'Y','18','021','EC','A','','','AC','0001152570','0001152570','TX00002714493','IL','1','Normann','Randy','','','','34','463062202','11772 FM905',0,'Pattonville','TX','75468',NULL,'CY','48277','1955-03-23','M','M',NULL,'N','021','DEN','3416580','33348TX002000201','2014-03-01','2014-02-10 20:07:44','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:09'),(19898,15872,'Y','18','021','EC','A','','','AC','0001451367','0001451367','LA00002099509','IL','1','Neal','Glen','Allen','','','34','587889269','7921 BENSON ST',0,'NEW ORLEANS','LA','70127','1005','CY','22071','1953-12-19','M','U',':RET:2054-5','N','021','DEN','3408909','18575LA002000101','2014-03-01','2014-01-24 14:40:34','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-24 21:00:55'),(6406,5077,'N','01','021','EC','A',NULL,NULL,'','0000735014','0001050622','','IL','1','Rodriguez','Colleen','','','','34','293805187','2557 CHERRY LAKE RD',0,'SYLVANIA','OH','43560','8982','CY','39095','1967-11-05','F','',':RET:2106-3','N','021','DEN','288632','99734OH005000301','2014-01-01','2013-12-11 17:49:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:29'),(4007,3201,'Y','18','024','14','A','','','TE','0001245581','0001245581','','IL','1','Eversole','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-24','F','',NULL,NULL,NULL,'','2075671','','2013-12-16','2013-12-16 21:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:19'),(17079,13668,'N','01','021','EC','A',NULL,NULL,'','0000530655','0000415587','','IL','1','chavez','rosa','maria','','','34','631015618','2425 katy flewellen rd',0,'katy','TX','77494',NULL,'CY','48157','1980-01-29','F','',NULL,'N','021','DEN','2217470','33348TX002000201','2014-02-01','2014-01-08 12:53:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:22'),(3767,3015,'Y','18','021','EC','A','','','AC','0000507963','0000507963','OH00000196247','IL','1','Johnson','Teresa','','','','34','278501356','1541 Oakwood Dr.',0,'Cleveland Heights','OH','44121',NULL,'CY','39035','1950-09-25','F','M',':RET:2106-3','N','021','HLT','753551','52664OH151001305','2014-01-01','2013-12-13 14:09:01','460.00',NULL,NULL,'742.48','282.48','R-OH011','OH0','742.48',NULL,0,'2013-12-25 21:33:35'),(16259,13017,'Y','18','021','EC','A','','','AC','0000926284','0000926284','OH00002251268','IL','1','Gaines','Cynthia','','','','34','278580274','135.5 N MARKET ST',0,'LOUDONVILLE','OH','44842','1216','CY','39005','1962-05-01','F','U',':RET:2106-3','N','021','HLT','2182442','52664OH151001501','2014-02-01','2014-01-04 12:12:48','210.00',NULL,NULL,'498.82','288.82','R-OH012','OH0','498.82',NULL,0,'2014-01-05 00:02:52'),(16250,13012,'Y','18','021','EC','A','','','AC','0000236286','0000236286','OH00001723821','IL','1','Bonenfant','Robert','m','','Sr','34','047561043','25271 SPRAGUE RD',0,'COLUMBIA STATION','OH','44028','9602','CY','39093','1961-01-12','M','R',':RET:2106-3','T','021','DEN','2522495','99734OH005000301','2014-02-01','2014-01-04 15:18:33','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-05 00:02:37'),(15937,12760,'Y','18','021','EC','A','','','AC','0000940863','0000940863','OH00001358303','IL','1','CORDY','CONNIE','','','','34','277483376','36 COLUMBUS ST',0,'WILMINGTON','OH','45177','1802','CY','39027','1953-01-09','F','M',':RET:2106-3','T','021','HLT','2335381','92036OH005000606','2014-02-01','2014-01-02 09:19:26','559.00',NULL,NULL,'693.72','134.72','R-OH005','OH0','693.72',NULL,0,'2014-01-03 02:07:07'),(940,777,'Y','18','021','EC','A','','','AC','0000762245','0000762245','OH00001050735','IL','1','Scheid','Kris','','','','34','273765626','10131 CROSIER LN',0,'BLUE ASH','OH','45242','5745','CY','39061','1978-12-21','M','U',':RET:2106-3','N','021','DEN','1186663','99734OH005000401','2014-01-01','2013-10-31 16:58:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:19'),(9560,7578,'Y','18','024','14','A','','','TE','0000427622','0000427622','','IL','1','Turner','Shirley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-02','F','',NULL,NULL,NULL,'','1716199','','2013-12-21','2013-12-21 15:32:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:36:33'),(1429,1191,'Y','18','021','EC','A','','','AC','0001930300','0001930300','LA00001502330','IL','1','Roberts','Jason','','','','34','453436303','135 Calhoun Loop Rd.',0,'Calhoun','LA','71225',NULL,'CY','22073','1966-11-22','M','M',':RET:2106-3','N','021','DEN','2482363','18575LA002000201','2014-01-01','2013-12-24 17:10:35','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 18:47:30'),(28125,22258,'Y','18','021','EC','A','','','AC','0000854261','0000854261','OH00003514226','IL','1','Johnson','Tasha','','','','34','280904916','2504 state rd',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1989-03-18','F','U',':RET:2054-5^:RET:2106-3','N','021','HLT','3491334','52664OH151001306','2014-04-01','2014-03-06 10:17:23','301.00',NULL,NULL,'365.51','64.51','R-OH012','OH0','223.90',NULL,0,'2014-03-06 21:02:22'),(28307,22398,'Y','18','021','EC','A','','','AC','0000784935','0000784935','MS00002864792','IL','1','Ingram','Susan','','','','34','587969646','734 MEADOWBROOK RD',0,'GRENADA','MS','38901','9788','CY','28043','1957-05-25','F','M',':RET:2106-3','N','021','DEN','4255218','46300MS002000101','2014-04-01','2014-03-07 16:02:50','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15','CIC',0,'2014-03-07 21:00:34'),(28527,22576,'N','01','021','EC','A',NULL,NULL,'','0000919446','0000197205','','IL','1','delung','rebecca','j','','','34','276863939','4086 YOUNGSTOWN KINGSVILLE RD',0,'CORTLAND','OH','44410','9721','CY','39155','1971-04-27','F','',':RET:2106-3','N','021','HLT','3574349','92036OH003003206','2014-04-01','2014-03-07 08:47:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.94',NULL,0,'2014-03-07 21:32:05'),(28721,22730,'Y','18','021','EC','A','','','AC','0000254606','0000254606','OH00003360111','IL','1','Vickrey','Shelia',NULL,NULL,NULL,NULL,NULL,'329 Hayes st',0,'West Milton','OH','45383',NULL,'CY','39109','1970-03-21','F','M',NULL,'N','021','HLT','3860539','92036OH004000501','2014-04-01','2014-03-08 16:52:45','255.00',NULL,NULL,'267.02','12.02','R-OH003','OH0','267.02',NULL,0,'2014-03-08 21:31:21'),(7748,6137,'Y','18','021','EC','A','','','AC','0000435290','0000435290','OH00000478149','IL','1','HENDERSON','MERLE','','','','34','277569525','773 ERIE STREET SOUTH',0,'MASSILLON','OH','44646',NULL,'CY','39151','1956-01-10','M','U',NULL,'T','021','DEN','2465907','99734OH005000401','2014-01-01','2013-12-20 16:20:43','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 03:02:27'),(1708,1427,'Y','18','021','EC','A','','','AC','0000915651','0000915651','OH00001222056','IL','1','Donkor','Daniel','','','','34','072020555','302 Mendingwall Way',0,'Fairfield','OH','45014',NULL,'CY','39017','1987-09-09','M','U',':RET:2054-5','N','021','HLT','2209733','92036OH006001201','2014-01-01','2013-12-24 15:40:47','112.00',NULL,NULL,'174.33','62.33','R-OH004','OH0','174.33',NULL,0,'2013-12-25 18:54:56'),(7423,5874,'Y','18','021','EC','A','','','AC','0000769956','0000769956','OH00000048695','IL','1','Edmondson','Matthew','','','','34','560678425','1823 PENTHLEY AVE',0,'AKRON','OH','44312','1915','CY','39153','1975-11-24','M','U',':RET:2106-3','N','021','DEN','592700','99734OH005000301','2014-01-01','2013-10-26 21:39:31','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:17:05'),(21393,17095,'Y','18','021','EC','A','','','AC','0000421502','0000421502','OH00002193848','IL','1','KING','CHERYL','','','','34','275549271','2450 WILMER ST',0,'ZANESVILLE','OH','43701','1856','CY','39119','1951-04-12','F','M',':RET:2106-3','N','021','DEN','3723629','99734OH005000401','2014-03-01','2014-02-04 10:38:32','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-04 21:00:58'),(3517,2825,'N','01','021','EC','A',NULL,NULL,'','0000163696','0000668954','','IL','1','Nguyen','Mung','T','','','34','586507828','15068 LOVELESS DR',0,'GULFPORT','MS','39503','2455','CY','28047','1954-03-20','F','',':RET:2047-9','N','021','DEN','1880424','46300MS002000201','2014-01-01','2013-12-22 17:43:53',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:21:10'),(3470,2787,'Y','18','021','EC','A','','','AC','0000625423','0000625423','OH00001151038','IL','1','Bebout','Michael','Ray','','','34','269520457','47 W 1ST ST',0,'FRAZEYSBURG','OH','43822','9770','CY','39119','1951-10-08','M','M',':RET:2106-3','N','021','DEN','2532345','99734OH005000401','2014-01-01','2013-12-22 08:56:55','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:19:56'),(18932,15085,'Y','18','021','EC','A','','','AC','0000964648','0000964648','OH00001784413','IL','1','letcher','amika','','','','34','275860387','3032 COLERAIN AVE',0,'CINCINNATI','OH','45225','1849','CY','39061','1987-04-14','F','U',':RET:2054-5','N','021','DEN','1641867','99734OH005000401','2014-03-01','2014-01-17 11:09:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:05:38'),(17876,14279,'N','19','021','EC','A',NULL,NULL,'','0001126890','0000478501','','IL','1','Vollmer','Drake','','','','34','272173603','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','2011-01-10','M','',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(15629,12501,'N','19','021','EC','A',NULL,NULL,'','0001366366','0002022979','','IL','1','Ferrand','Joshua','A','','','34','435796350','207 LESNA LN',0,'RUSTON','LA','71270','9031','CY','22061','1990-07-04','M','',':RET:2054-5','N','021','DEN','2081332','18575LA002000101','2014-02-01','2013-12-31 12:14:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,1,'2014-01-02 04:33:26'),(14616,11666,'Y','18','021','EC','A','','','AC','0000710153','0000710153','OH00001026456','IL','1','lovejoy','mary','','','','34','284744317','218 e. water st',0,'Deshler','OH','43516',NULL,'CY','39069','1965-04-07','F','M',':RET:2106-3','T','021','HLT','1423698','92036OH006002601','2014-02-01','2013-12-27 05:29:16','0.00',NULL,NULL,'290.77','290.77','R-OH001','OH0','290.77',NULL,0,'2013-12-28 03:36:48'),(13914,11098,'Y','18','021','EC','A','','','AC','0000468113','0000468113','OH00001351172','IL','1','HILL','KYLE','FRANKLIN','','','34','278843235','7917 COUNTY ROAD 59',0,'CAREY','OH','43316','9510','CY','39147','1985-11-21','M','U',NULL,'N','021','HLT','2319372','92036OH005002706','2014-01-01','2013-12-23 18:54:49','190.00',NULL,NULL,'211.97','21.97','R-OH006','OH0','211.97',NULL,0,'2013-12-26 13:14:02'),(8898,7056,'Y','18','021','EC','A','','','AC','0001188775','0001188775','OH00000059949','IL','1','HURLEY','JOYCE','ARTHEROUS','','','34','292443860','21 SWANGER AVE',0,'MANSFIELD','OH','44902','7844','CY','39139','1951-01-04','F','M',':RET:2054-5','N','021','DEN','2236492','99734OH005000401','2014-01-01','2013-12-17 18:32:39','0.00',NULL,NULL,'31.57','31.57','R-OH007','OH0','0.00',NULL,0,'2013-12-26 04:02:13'),(2028,1661,'Y','18','021','EC','A','','','AC','0000303339','0000303339','OH00000494483','IL','1','Balasakis','Eleni','','','','34','300724303','1975 ABBEYVILLE RD',0,'VALLEY CITY','OH','44280','9519','CY','39103','1964-02-25','F','U',NULL,'N','021','HLT','570257','52664OH152000901','2014-01-01','2013-12-10 16:14:43','72.00',NULL,NULL,'278.66','206.66','R-OH012','OH0','278.66',NULL,0,'2013-12-25 19:15:16'),(27540,21786,'Y','18','021','EC','A','','','AC','0000669236','0000669236','OH00003458815','IL','1','STITT','TEGAN','','','','34','270781226','407 INDIANA AVE',0,'MCDONALD','OH','44437',NULL,'CY','39155','1978-04-17','F','M',':RET:2106-3','N','021','DEN','3976455','99734OH005000401','2014-04-01','2014-03-04 11:45:15','0.00',NULL,NULL,'50.05','50.05','R-OH013','OH0','0.00','CIC',0,'2014-03-04 21:30:07'),(6828,5411,'Y','18','021','EC','A','','','AC','0000364847','0000364847','OH00000652483','IL','1','Frederick','Diane','','','','34','301726519','900 Roanoke Rd',0,'Cleveland Heights','OH','44121',NULL,'CY','39035','1962-04-09','F','U',NULL,'T','021','DEN','1063316','99734OH005000301','2014-01-01','2013-11-14 16:34:03','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:30:41'),(22873,18245,'Y','18','021','EC','A','','','AC','0000624041','0000624041','MS00002406574','IL','1','Tsai','Min','','','','34','622803805','331 County Road 1498',0,'Tupelo','MS','38804',NULL,'CY','28081','1966-12-10','M','M',':RET:2034-7','N','021','DEN','3245245','46300MS002000101','2014-03-01','2014-02-11 10:06:40','0.00',NULL,NULL,'81.45','81.45','R-MS002','MS0','27.15',NULL,0,'2014-02-11 21:02:31'),(22647,18082,'Y','18','021','EC','A','','','AC','0000731740','0000731740','TX00001926503','IL','1','Friday','Cyril','','','','34','635364505','12800 CENTER LAKE DR',0,'AUSTIN','TX','78753','1082','CY','48453','1988-01-19','M','U',NULL,'N','021','DEN','2714133','33348TX002000201','2014-03-01','2014-02-11 11:00:23','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-11 21:00:25'),(6243,4946,'N','01','021','EC','A',NULL,NULL,'','0000084007','0000166339','','IL','1','Hebenstreit','Barbara','','','','34','291885852','3748 W FORK RD',0,'CINCINNATI','OH','45247','7549','CY','39061','1972-11-21','F','',NULL,'N','021','DEN','1206943','99734OH005000301','2014-01-01','2013-11-19 10:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:31:42'),(19346,15422,'Y','18','024','14','A','','','TE','0000895700','0000895700','','IL','1','Sullivan','Bartholomew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-10-07','M','',NULL,NULL,NULL,'','1923600','','2014-01-21','2014-01-21 13:32:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:24'),(17649,14107,'N','01','021','EC','A',NULL,NULL,'','0001163861','0001219608','','IL','1','Boulton','Georga','Kay','','','34','521882792','7101 WREN AVE NW',0,'NORTH CANTON','OH','44720','7054','CY','39151','1954-07-16','F','',':RET:2106-3','N','021','DEN','1954806','99734OH005000301','2014-02-01','2014-01-13 11:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:40'),(17255,13807,'Y','18','021','EC','A','','','AC','0001049396','0001049396','OH00001834145','IL','1','wilson','jessica','ann','','','34','277788775','769 CONGRESS LAKE RD',0,'MOGADORE','OH','44260','9620','CY','39133','1981-10-11','F','U',':RET:2106-3','N','021','DEN','2392219','99734OH005000301','2014-02-01','2014-01-10 10:05:20','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:23:14'),(3278,2643,'Y','18','021','EC','A','','','AC','0000732586','0000732586','OH00001214652','IL','1','Lee','Vanessa','','','','34','296803393','3338 Alamo Ave',0,'Cincinnati','OH','45209',NULL,'CY','39061','1980-10-01','F','U',':RET:2106-3','N','021','DEN','1543348','99734OH005000301','2014-01-01','2013-12-21 18:28:14','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:11'),(5040,3991,'Y','18','021','EC','A','','','AC','0001087263','0001087263','MS00000779360','IL','1','Riley','Ernest','','','','34','496602022','455 QUEEN JULIANNA LN',0,'JACKSON','MS','39209','2230','CY','28049','1954-03-29','M','M',':RET:2054-5','N','021','DEN','629481','46300MS002000201','2014-01-01','2013-12-07 14:30:59','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 22:47:59'),(14824,11839,'Y','18','021','EC','A','','','AC','0001044063','0001044063','TX00000504887','IL','1','Halcrow','Jason','Christopher','','','34','202663116','8208 STEAMERS LN',0,'FRISCO','TX','75035','7329','CY','48085','1975-05-09','M','U',':RET:2106-3','N','021','DEN','2510342','33348TX002000101','2014-01-01','2013-12-23 19:54:18','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2013-12-29 11:14:22'),(14021,11170,'Y','18','021','EC','A','','','AC','0001144768','0001144768','OH00000580309','S1','1','Sharp','Tamara','L',NULL,NULL,NULL,NULL,'861 Wylie',0,'Toledo','OH','43609',NULL,'CY','39095','1998-09-28','F','U',NULL,'N','021','DEN','2378616','99734OH005000101','2014-01-01','2013-12-23 10:45:52','0.00',NULL,NULL,'27.59','27.59','R-OH001','OH0','27.59',NULL,0,'2013-12-26 13:16:39'),(13308,10625,'Y','18','021','EC','A','','','AC','0000902133','0000902133','TX00000513597','IL','1','GREGORY','DANN','','','','34','449536125','907 NATURE DR',0,'DUNCANVILLE','TX','75116','2527','CY','48113','1971-06-07','F','U',':RET:2106-3','N','021','DEN','2310772','33348TX002000201','2014-01-01','2013-12-23 15:32:28','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:58:00'),(23694,18869,'Y','18','021','EC','A','','','AC','0000112975','0000112975','OH00001757966','IL','1','BURNS','JOANNE','E','','','34','295441710','367 Birchwood Ave',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1954-09-13','F','U',':RET:2106-3','N','021','DEN','2815649','99734OH005000401','2014-03-01','2014-02-14 09:54:34','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:39'),(24940,19778,'Y','18','021','EC','A','','','AC','0001005068','0001005068','MS00002999998','IL','1','Piper','Darlene','','','','34','342686037','850 Lindbergh Dr',0,'Jackson','MS','39209',NULL,'CY','28049','1965-10-19','F','U',':RET:2054-5','N','021','DEN','2714397','46300MS002000201','2014-04-01','2014-02-19 20:15:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 22:00:04'),(3340,2677,'N','01','021','EC','A',NULL,NULL,'','0001011470','0000194843','','IL','1','LEAL','SAUL','C','','','34','267493999','1101 QUARTZ ST',0,'PENITAS','TX','78579',NULL,'CY','48215','1962-03-22','M','',NULL,'N','021','DEN','2565737','33348TX002000201','2014-01-01','2013-12-21 19:01:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:16:28'),(6356,5038,'Y','18','021','EC','A','','','AC','0000690717','0000690717','OH00000897143','IL','1','DREETY','DAVID','B','','','34','275466732','248 NAPOLEON DR',0,'KETTERING','OH','45429','1738','CY','39113','1951-04-07','M','U',':RET:2106-3','N','021','DEN','363053','99734OH005000401','2014-01-01','2013-12-11 15:05:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:47:12'),(16886,13512,'Y','18','021','EC','A','','','AC','0000567646','0000567646','TX00001285025','IL','1','flores','rose','','','','34','460195315','4703 HERRERA ST',0,'ROBSTOWN','TX','78380','4326','CY','48355','1968-05-16','F','M',NULL,'N','021','DEN','2456100','33348TX002000201','2014-02-01','2014-01-09 13:10:26','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-01-13 02:19:24'),(20959,16748,'Y','18','021','EC','A','','','AC','0001023407','0001023407','TX00002579952','IL','1','Duran','Annaeli','','','','34','643328384','12452 TIERRA SERENA DR',0,'EL PASO','TX','79938','4441','CY','48141','1992-10-01','F','U',NULL,'N','021','DEN','2540604','33348TX002000201','2014-03-01','2014-02-01 13:13:52','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-01 19:00:08'),(19093,15212,'Y','18','021','EC','A','','','AC','0001190085','0001190085','OH00001746153','IL','1','Foster','Leslie','','','Jr','34','272701400','6098 Alliance NW',0,'Melbourne','OH','44644',NULL,'CY','39019','1960-07-06','M','U',':RET:2106-3','N','021','DEN','2710059','99734OH005000301','2014-03-01','2014-01-18 10:38:52','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-21 08:44:33'),(24269,19274,'Y','18','021','EC','A','','','AC','0001852483','0001852483','LA00002433042','IL','1','Ayoup','Nasra','I','','','34','659206314','4629 CLEARLAKE DR',0,'METAIRIE','LA','70006','2221','CY','22051','1971-10-07','F','M',':RET:2106-3','N','021','DEN','3370584','18575LA002000201','2014-04-01','2014-02-17 14:43:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-17 19:00:16'),(26659,21134,'Y','18','021','EC','A','','','AC','0001240612','0001240612','OH00002624159','IL','1','Pearcy-Jennings','Autumn','','','','34','275645239','2538-C Royal County Down',0,'Uniontown','OH','44685',NULL,'CY','39153','1972-11-08','F','U',':RET:2106-3','N','021','HLT','3501247','52664OH151001305','2014-04-01','2014-02-28 14:47:16','342.00',NULL,NULL,'513.37','171.37','R-OH012','OH0','290.36',NULL,0,'2014-02-28 21:31:11'),(26725,21184,'N','19','021','EC','A',NULL,NULL,'','0000533968','0000558020','','IL','1','samaha','laith','','','','34','446252866','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','2009-02-24','M','',':RET:2106-3','N','021','DEN','3332360','33348TX002000101','2014-04-01','2014-02-28 09:18:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-02-28 21:31:47'),(19511,15551,'Y','18','021','EC','A','','','AC','0000775899','0000775899','TX00001357446','IL','1','Morrison','Doris','','','','34','440607330','2809 SOMMERSET DR',0,'GRAND PRAIRIE','TX','75052','8313','CY','48439','1957-02-24','F','U',NULL,'N','021','DEN','3186838','33348TX002000101','2014-03-01','2014-01-22 18:19:12','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-23 03:02:14'),(5187,4115,'Y','18','021','EC','A','','','AC','0000908014','0000908014','OH00000894008','IL','1','morris','rosemarie','','','','34','271700665','6652 ECHO VLY',0,'MAUMEE','OH','43537','9669','CY','39095','1960-03-05','F','M',':RET:2106-3','N','021','DEN','2086903','99734OH005000401','2014-01-01','2013-12-19 13:30:37','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:03:40'),(17873,14278,'N','01','021','EC','A',NULL,NULL,'','0000366302','0000674089','','IL','1','Kushner','Sandra','K','','','34','309689035','1851 PATHFINDER CT',0,'XENIA','OH','45385','9596','CY','39057','1960-08-06','F','',':RET:2106-3','N','021','DEN','2445311','99734OH005000401','2014-02-01','2014-01-14 14:01:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:14'),(7671,6076,'Y','18','021','EC','A','','','AC','0001856228','0001856228','LA00000225839','IL','1','Watkins','Marcy','','','','34','436040202','1742 INGLESIDE DR',0,'BATON ROUGE','LA','70808','1271','CY','22033','1968-12-01','F','R',':RET:2106-3','N','021','DEN','1935047','18575LA002000101','2014-01-01','2013-12-20 18:32:47','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:34'),(9182,7283,'Y','18','021','EC','A','','','AC','0000805092','0000805092','OH00001207879','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','HLT','2180540','92036OH005001506','2014-01-01','2013-12-18 15:24:34','200.00',NULL,NULL,'649.68','449.68','R-OH002','OH0','649.68',NULL,0,'2013-12-26 04:09:12'),(14272,11386,'Y','18','021','EC','A','','','AC','0000594166','0000594166','MS00001699807','IL','1','Jackson','Debra','','','','34','415927452','2621 PINTAIL DR',0,'HORN LAKE','MS','38637','1267','CY','28033','1953-06-24','F','M',':RET:2106-3','T','021','DEN','2027423','46300MS002000201','2014-02-01','2013-12-26 12:28:08','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-27 02:06:06'),(13534,10790,'Y','18','021','EC','A','','','AC','0002050219','0002050219','LA00000025482','IL','1','Mcevilla','Basilides','','','','34','563319349','157 MILLIE DR',0,'AVONDALE','LA','70094','2828','CY','22051','1952-06-10','F','U',':RET:2036-2','N','021','DEN','2556815','18575LA002000201','2014-01-01','2013-12-23 12:26:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:33'),(22705,18131,'Y','18','021','EC','A','','','AC','0002236636','0002236636','LA00001392196','IL','1','JORDAN','JARRETT','','','','34','439719645','3044 CLAIRE AVE',0,'GRETNA','LA','70053',NULL,'CY','22051','1973-09-14','M','U',':RET:2106-3','N','021','DEN','3380633','18575LA002000201','2014-03-01','2014-02-11 18:21:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:01'),(26450,20980,'Y','18','024','14','A','','','TE','0000625469','0000625469','','IL','1','Kreakie','Nicholas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-30','M','',NULL,NULL,NULL,'','2897356','','2014-03-31','2014-02-26 19:45:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:25'),(510,416,'Y','18','021','EC','A','','','AC','0001018194','0001018194','OH00000439582','IL','1','Wilson','Susan','Kathleen','','','34','294522825','842 ATWATER AVE',0,'CIRCLEVILLE','OH','43113','1342','CY','39129','1952-08-01','F','U',':RET:2106-3','N','021','DEN','229254','99734OH005000301','2014-01-01','2013-12-03 19:56:04','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:48:54'),(973,797,'Y','18','021','EC','A','','','AC','0000014313','0000014313','LA00001023805','IL','1','Lirette','James','','','Jr','34','435554542','15650 BACCA ST',0,'PONCHATOULA','LA','70454','9436','CY','22105','1978-04-25','M','M',':RET:2106-3','N','021','DEN','819201','18575LA002000201','2014-01-01','2013-10-29 00:42:23','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:10:04'),(984,806,'Y','18','021','EC','A','','','AC','0000525539','0000525539','OH00000848906','IL','1','Scalia','Joshua','','','','34','411336997','2931 OAKCREST DR',0,'NORTON','OH','44203','6385','CY','39153','1980-02-25','M','M',':RET:2106-3','T','021','HLT','869301','52664OH151001501','2014-01-01','2013-10-31 12:40:48','120.00',NULL,NULL,'865.17','745.17','R-OH012','OH0','368.49',NULL,0,'2013-12-25 18:10:24'),(5161,4092,'Y','18','021','EC','A','','','AC','0001192664','0001192664','OH00000183657','IL','1','WEATHERSPOON','CLARISSA','ANN','','','34','279541556','646 ASHLAND AVE',0,'ALLIANCE','OH','44601','1529','CY','39151','1953-06-27','F','M',NULL,'N','021','DEN','1936063','99734OH005000401','2014-01-01','2013-12-19 10:39:08','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 23:03:04'),(5127,4063,'Y','18','021','EC','A','','','AC','0000290466','0000290466','TX00000421048','IL','1','Piper','William','D','','','34','510625605','607 JESSIE ST',0,'AUSTIN','TX','78704','1523','CY','48453','1953-12-19','M','U',NULL,'N','021','DEN','2360874','33348TX002000101','2014-01-01','2013-12-18 19:12:37','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 23:02:07'),(1823,1496,'N','19','021','EC','A',NULL,NULL,'','0000593684','0000559441','','IL','1','tariq','sohaib','','','','34','283067604','1613 RIDGE CROSS RD',0,'PERRYSBURG','OH','43551','9055','CY','39173','1988-02-25','M','',NULL,'N','021','HLT','1708312','92036OH005002605','2014-01-01','2013-12-24 14:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','195.78',NULL,0,'2013-12-25 18:57:17'),(4705,3729,'Y','18','021','EC','A','','','AC','0001245578','0001245578','OH00000464370','IL','1','Kulwicki','John','Scott','','','34','283428806','31 S MCCORD RD',0,'HOLLAND','OH','43528','8168','CY','39095','1959-04-21','M','U',NULL,'T','021','HLT','523870','92036OH004002601','2014-01-01','2013-12-12 13:47:15','229.00',NULL,NULL,'384.97','155.97','R-OH001','OH0','384.97',NULL,0,'2013-12-25 22:08:33'),(2289,1865,'N','01','021','EC','A',NULL,NULL,'','0001007864','0000570536','','IL','1','PETERS','NANCY','BAKER','','','34','294561919','1665 SPILLAN RD',0,'YELLOW SPRINGS','OH','45387',NULL,'CY','39057','1953-02-21','F','',NULL,'N','021','DEN','412499','99734OH005000301','2014-01-01','2013-12-09 14:04:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:43'),(13983,11141,'Y','18','021','EC','A','','','AC','0000309443','0000309443','OH00000116506','IL','1','Cornette','Gary','','','','34','295548962','3488 BRIAN DR',0,'TRENTON','OH','45067','9448','CY','39017','1951-05-01','M','U',':RET:2106-3','N','021','HLT','1606922','92036OH004001201','2014-01-01','2013-12-23 18:31:23','251.00',NULL,NULL,'495.91','244.91','R-OH004','OH0','495.91',NULL,0,'2013-12-26 13:15:38'),(3869,3098,'Y','18','024','14','A','','','TE','0000852787','0000852787','','IL','1','LINDE','BARBARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-04-09','F','',NULL,NULL,NULL,'','1085015','','2013-12-13','2013-12-13 09:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:36:09'),(9311,7383,'Y','18','021','EC','A','','','AC','0001760462','0001760462','LA00000733369','IL','1','Jones','LaDonna','','','','34','433453544','126 PALM DR',0,'DONALDSONVILLE','LA','70346','3950','CY','22005','1981-07-03','F','U',':RET:2054-5','N','021','DEN','1899582','18575LA002000101','2014-01-01','2013-12-21 11:04:09','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 04:30:16'),(3228,2598,'Y','18','021','EC','A','','','AC','0000120032','0000120032','OH00000600563','IL','1','krohn','michael','','','','34','271702849','357 north american blvd',0,'vandalia','OH','45377',NULL,'CY','39113','1964-12-09','M','U',NULL,'N','021','DEN','1093920','99734OH005000401','2014-01-01','2013-10-06 08:57:01','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:45:59'),(22784,18191,'Y','18','021','EC','A','','','AC','0000163722','0000163722','OH00002528634','IL','1','Garcia','Diane','','','','34','277567693','11624 CORUNDITE RD NW',0,'MASSILLON','OH','44647','9432','CY','39151','1953-12-01','F','M',':RET:2106-3','N','021','DEN','3806844','99734OH005000301','2014-03-01','2014-02-11 09:05:48','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2014-02-11 21:01:46'),(24970,19803,'Y','18','021','EC','A','','','AC','0001228237','0001228237','TX00002635779','31','1','PARKER','ALICIA','','','','34','630166048','POX 111',0,'MERTZON','TX','76941',NULL,'CY','48235','1990-03-15','F','U',':RET:2106-3','N','021','DEN','3305145','33348TX002000201','2014-04-01','2014-02-19 20:14:52','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-02-20 22:00:26'),(26076,20678,'Y','18','021','EC','A','','','AC','0000684868','0000684868','OH00003036376','IL','1','URTON','MARIA','','','','34','299604957','501 LANTERN GLOW CT',0,'LEBANON','OH','45036','8029','CY','39165','1972-02-12','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','3685959','92036OH004001202','2014-03-01','2014-02-26 17:38:30','136.68',NULL,NULL,'228.72','92.04','R-OH004','OH0','228.72',NULL,0,'2014-02-26 21:02:47'),(28021,22175,'Y','18','021','EC','A','','','AC','0001062194','0001062194','OH00003544981','IL','1','yuellig','dennis','','','','34','299804736','4365 CLASSIC DR',0,'BLUE ASH','OH','45241','2205','CY','39061','1983-11-04','M','U',':RET:2106-3','N','021','DEN','3474132','99734OH005000401','2014-04-01','2014-03-06 15:08:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:21'),(28,23,'Y','18','021','EC','A','','','AC','0001066953','0001066953','OH00000730286','IL','1','Hattemer','Katherine','','','','34','274921564','2867 Erie Ave.',0,'Cincinnati','OH','45208',NULL,'CY','39061','1987-12-08','F','U',':RET:2106-3','N','021','DEN','514686','99734OH005000401','2014-01-01','2013-12-05 14:03:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:43'),(6462,5121,'Y','18','021','EC','A','','','AC','0000631482','0000631482','OH00000958279','IL','1','CARTER','STEPHEN','L','','','34','270567095','1 PARK CENTER DR',0,'WADSWORTH','OH','44281','9452','CY','39103','1956-06-06','M','M',':RET:2106-3','N','021','HLT','881253','52664OH151001501','2014-01-01','2013-12-11 11:53:45','491.00',NULL,NULL,'1173.90','682.90','R-OH012','OH0','651.81',NULL,0,'2013-12-26 00:49:56'),(609,501,'Y','18','021','EC','A','','','AC','0001147325','0001147325','OH00000974982','IL','1','Damron','Tamaria','','','','34','283744237','4312 FLOWERS RD',0,'MANSFIELD','OH','44903','8618','CY','39139','1966-04-23','F','U',':RET:2106-3','N','021','DEN','1550934','99734OH005000401','2014-01-01','2013-12-16 09:57:00','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 18:00:31'),(1849,1514,'Y','18','021','EC','A','','','AC','0000372609','0000372609','OH00000199424','IL','1','Parker','Pamala','','','','34','288508867','658 YAGER RD',0,'CLINTON','OH','44216','9465','CY','39153','1951-10-31','F','M',':RET:2106-3','N','021','HLT','2378787','52664OH151001305','2014-01-01','2013-12-24 16:57:17','477.00',NULL,NULL,'640.70','163.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 18:57:51'),(19864,15845,'Y','18','021','EC','A','','','AC','0000111921','0000111921','OH00002326797','IL','1','Bodeker','John','E','','','34','301506070','1327 Catherine Dr',0,'Brunswick','OH','44212',NULL,'CY','39103','1952-08-04','M','M',':RET:2106-3','N','021','DEN','1748053','99734OH005000401','2014-03-01','2014-01-24 08:18:19','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-24 21:00:37'),(2326,1892,'Y','18','021','EC','A','','','AC','0000649576','0000649576','TX00001211532','IL','1','pollard','sheryl','','','','34','461882588','337 COLUMBINE ST',0,'MEADOWLAKES','TX','78654','6829','CY','48053','1957-09-18','F','U',':RET:2106-3','N','021','DEN','518447','33348TX002000201','2014-01-01','2013-12-09 10:58:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:32'),(19083,15204,'Y','18','021','EC','A','','','AC','0000701723','0000701723','OH00002353222','IL','1','Patel','Smita','','','','34','334744039','2416 SPRINGMILL RD',0,'FINDLAY','OH','45840','2864','CY','39063','1959-05-05','F','M',':RET:2029-7','N','021','DEN','2793247','99734OH005000401','2014-03-01','2014-01-18 15:03:43','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2014-01-21 08:44:28'),(13530,10786,'Y','18','024','14','A','','','TE','0000700745','0000700745','','IL','1','Alexander','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-02-04','F','',NULL,NULL,NULL,'','1145005','','2013-12-23','2013-12-23 11:25:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:03:27'),(16578,13260,'Y','18','024','14','A','','','TE','0001634948','0001634948','','IL','1','Perritt','Tammy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-02','F','',NULL,NULL,NULL,'','1650076','','2014-01-06','2014-01-06 18:27:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-08 18:23:56'),(16135,12923,'N','01','021','EC','A',NULL,NULL,'','0000921927','0000154666','','IL','1','MILLIK','NORA','A',NULL,NULL,NULL,NULL,'2090 HOWLAND WILSON RD',0,'CORTLAND','OH','44410','9485','CY','39155','1950-09-13','F','',':RET:2106-3','N','021','HLT','1792640','52664OH151001306','2014-02-01','2014-01-03 13:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','746.55',NULL,0,'2014-01-04 02:05:48'),(24179,19208,'N','01','021','EC','A',NULL,NULL,'','0000688335','0001054262','','IL','1','Porter','Beverly','A','','','34','278640952','522 Ledge Rd.',0,'Macedonia','OH','44056',NULL,'CY','39153','1959-01-12','F','',':RET:2106-3','N','021','HLT','3797182','52664OH152000901','2014-03-01','2014-02-15 18:01:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','364.25',NULL,0,'2014-02-16 19:00:06'),(25528,20251,'Y','18','021','EC','A','','','AC','0000895768','0000895768','OH00003240657','IL','1','Krilivsky','Michael','','','','34','047769103','1604 MARLOWE AVE',0,'LAKEWOOD','OH','44107','4323','CY','39035','1979-09-05','M','R',':RET:2106-3','N','021','HLT','3238794','92036OH001000801','2014-04-01','2014-02-25 17:15:56','0.00',NULL,NULL,'342.36','342.36','R-OH011','OH0','342.36',NULL,0,'2014-02-25 21:32:10'),(26045,20655,'Y','18','021','EC','A','','','AC','0000915692','0000915692','OH00002558815','IL','1','Crooks','Traci','','','','34','277785097','5892 New Milford Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1968-01-18','F','U',':RET:2106-3','N','021','HLT','3186267','52664OH151001301','2014-04-01','2014-02-26 15:19:21','38.00',NULL,NULL,'334.51','296.51','R-OH012','OH0','334.51',NULL,0,'2014-02-26 21:02:29'),(26384,20930,'Y','18','024','14','A','','','TE','0000194050','0000194050','','IL','1','Taylor','Kathleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-24','F','',NULL,NULL,NULL,'','1598503','','2014-02-28','2014-02-26 11:42:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:22'),(27082,21441,'Y','18','021','EC','A','','','AC','0001231833','0001231833','OH00002736834','IL','1','Wright','Kellee','','','','34','288829205','1845 BEECH RD',0,'STOW','OH','44224','3912','CY','39153','1971-03-17','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','2885542','52664OH151001304','2014-04-01','2014-03-03 07:27:59','341.00',NULL,NULL,'614.16','273.16','R-OH012','OH0','302.62',NULL,0,'2014-03-03 21:30:11'),(28566,22606,'Y','18','021','EC','A','','','AC','0001024342','0001024342','OH00002875347','IL','1','BRYERS','David','','','','34','287706380','4033 W LIBERTY ST',0,'CINCINNATI','OH','45205','1459','CY','39061','1969-07-25','M','M',NULL,'N','021','HLT','3727125','92036OH004001201','2014-05-01','2014-03-07 14:26:15','0.00',NULL,NULL,'241.14','241.14','R-OH004','OH0','241.14',NULL,0,'2014-03-07 21:32:28'),(28662,22680,'Y','18','024','14','A','','','TE','0001904953','0001904953','','IL','1','Migues','Donna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-05','F','',NULL,NULL,NULL,'','3769650','','2014-03-07','2014-03-07 19:39:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-08 21:30:44'),(6112,4846,'Y','18','021','EC','A','','','AC','0000372568','0000372568','OH00001145270','IL','1','Rawson','Cynthia','Kay','','','34','301563844','2205 21 st Street',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1951-06-20','F','U',':RET:2106-3','N','021','HLT','97980','52664OH151001305','2014-01-01','2013-11-20 20:52:45','510.00',NULL,NULL,'640.70','130.70','R-OH012','OH0','640.70',NULL,0,'2013-12-26 00:15:28'),(21391,17093,'Y','18','021','EC','A','','','AC','0000361048','0000361048','OH00001600361','IL','1','FIELDS','RITA','','','','34','293546947','3497 WOODHILL DR',0,'PORT CLINTON','OH','43452',NULL,'CY','39123','1957-07-30','F','U',':RET:2106-3','N','021','DEN','3198806','99734OH005000401','2014-03-01','2014-02-04 10:07:51','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-04 21:00:56'),(8989,7131,'Y','18','021','EC','A','','','AC','0000484771','0000484771','OH00001024507','IL','1','Lee','Lindsay','','','','34','284849523','5187 Dempster Dr',0,'Columbus','OH','43228',NULL,'CY','39049','1986-03-02','F','U',':RET:2106-3','N','021','DEN','1592927','99734OH005000401','2014-01-01','2013-12-18 17:08:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:04:32'),(9442,7490,'N','01','021','EC','A',NULL,NULL,'','0000600793','0000949506','','IL','1','bryant','charles','timothy','','','34','290685537','7511 E HARBOR RD',0,'MARBLEHEAD','OH','43440','9330','CY','39123','1960-03-23','M','',NULL,'N','021','HLT','1914336','92036OH004002701','2014-01-01','2013-12-21 12:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.86',NULL,0,'2013-12-26 04:33:42'),(15786,12635,'Y','18','021','EC','A','','','AC','0001250725','0001250725','LA00002100058','IL','1','Hamilton','Virgilia','','','','34','436253138','4616 S LIBERTY ST',0,'NEW ORLEANS','LA','70115','5965','CY','22071','1950-03-05','F','U',':RET:2036-2','N','021','DEN','1734189','18575LA002000201','2014-02-01','2014-01-02 10:46:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:19'),(18888,15049,'Y','18','021','EC','A','','','AC','0001174425','0001174425','OH00002053616','IL','1','Boyea','Jan','','','','34','299525024','4342 SUNNYVIEW DR',0,'UNIONTOWN','OH','44685','9548','CY','39153','1950-05-26','F','M',':RET:2106-3','N','021','HLT','1677653','52664OH152000901','2014-03-01','2014-01-16 12:03:25','216.00',NULL,NULL,'482.18','266.18','R-OH012','OH0','482.18',NULL,0,'2014-01-17 03:36:31'),(16826,13459,'Y','18','021','EC','A','','','AC','0001081818','0001081818','OH00001370482','IL','1','McGinnis','Brian','','','','34','282663025','1470 Pike Parkway',0,'Streetsboro','OH','44241',NULL,'CY','39133','1959-11-10','M','M',NULL,'N','021','DEN','2385501','99734OH005000401','2014-02-01','2014-01-10 18:51:42','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:18:26'),(21871,17462,'Y','18','021','EC','A','','','AC','0002388442','0002388442','LA00002184987','IL','1','BERLIN','BARRY','','','','34','161468985','4000 LAKEWAY BLVD',0,'BENTON','LA','71006','9325','CY','22015','1956-10-01','M','M',':RET:2106-3','N','021','DEN','3036569','18575LA002000201','2014-03-01','2014-02-05 22:07:15','0.00',NULL,NULL,'43.83','43.83','R-LA008','LA0','14.61',NULL,0,'2014-02-06 21:01:25'),(26755,21204,'Y','18','021','EC','A','','','AC','0000674883','0000674883','TX00002932575','IL','1','Fuller','Kenneth','','','','34','456471496','308 CR 3062',0,'Newton','TX','75966',NULL,'CY','48351','1972-06-06','M','M',':RET:2106-3','T','021','DEN','3528589','33348TX002000201','2014-04-01','2014-03-01 17:48:21','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-03-01 19:00:05'),(27914,22084,'Y','18','021','EC','A','','','AC','0000604557','0000604557','TX00002928045','IL','1','Guerra','Miguel','Angel','','','34','455595706','2603 HARRIS AVE',0,'PASADENA','TX','77506','3962','CY','48201','1982-01-11','M','M',':RET:2106-3','N','021','DEN','2995656','33348TX002000201','2014-04-01','2014-03-05 21:46:19','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-06 21:00:17'),(8954,7102,'Y','18','024','14','A','','','TE','0001021444','0001021444','','IL','1','Suri','Sameer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-05','M','',NULL,NULL,NULL,'','879567','','2013-12-18','2013-12-18 12:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:03:40'),(20223,16135,'Y','18','021','EC','A','','','AC','0000460608','0000460608','OH00002267656','IL','1','ROBINSON','JUDITH','','','','34','289685630','1742 LOXLEY RD',0,'TOLEDO','OH','43613','4602','CY','39095','1960-12-13','F','U',NULL,'T','021','HLT','2037593','92036OH006002601','2014-03-01','2014-01-27 14:16:45','164.00',NULL,NULL,'362.79','198.79','R-OH001','OH0','362.79',NULL,0,'2014-01-27 21:01:45'),(21992,17563,'Y','18','021','EC','A','','','AC','0001580010','0001580010','LA00002080814','IL','1','BOANCA','DUMIERU','','','','34','446898779','9124 OLD HAMMOND HWY',0,'BATON ROUGE','LA','70809',NULL,'CY','22033','1954-10-04','M','M',NULL,'N','021','DEN','2739000','18575LA002000201','2014-03-01','2014-02-06 23:08:16','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-07 19:00:43'),(22535,17993,'Y','18','021','EC','A','','','AC','0001125977','0001125977','MS00001530552','IL','1','Arana','Cosme','','','','34','069544124','202 EASTHAVEN DR',0,'CLINTON','MS','39056','5322','CY','28049','1955-10-13','M','M',NULL,'N','021','DEN','2682009','46300MS002000201','2014-03-01','2014-02-10 13:33:39','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 21:31:35'),(24288,19289,'Y','18','021','EC','A','','','AC','0000247833','0000247833','MS00002634287','IL','1','Robinson','Charlotte','','','','34','426138886','4901 MCWILLIE CIR',0,'JACKSON','MS','39206','6210','CY','28049','1975-04-24','F','U',':RET:2054-5','N','021','DEN','2628980','46300MS002000101','2014-04-01','2014-02-18 09:39:38','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15','CIC',0,'2014-02-18 21:30:10'),(24973,19806,'Y','18','021','EC','A','','','AC','0000850784','0000850784','TX00002750002','IL','1','Guntle','Dianna','','','','34','456975868','519 Land Grant Dr.',0,'Richmond','TX','77406',NULL,'CY','48157','1978-03-08','F','U',':RET:2106-3','N','021','DEN','3367862','33348TX002000201','2014-04-01','2014-02-20 01:27:16','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:28'),(6612,5242,'Y','18','021','EC','A','','','AC','0001233029','0001233029','OH00000710793','IL','1','Wenning','Teresa','','','','34','272641266','2835 SANDALWOOD LN',0,'LIMA','OH','45806','2025','CY','39003','1957-06-22','F','U',':RET:2106-3','N','021','HLT','245987','92036OH004001501','2014-01-01','2013-12-11 10:00:55','216.00',NULL,NULL,'412.86','196.86','R-OH002','OH0','412.86',NULL,0,'2013-12-26 00:53:46'),(4733,3750,'Y','18','021','EC','A','','','AC','0000669163','0000669163','OH00000568977','IL','1','GEESAMAN','LAWREEN','K','','','34','280522315','516 S PEARS AVE',0,'LIMA','OH','45805','3109','CY','39003','1952-01-02','F','M',':RET:2106-3','N','021','HLT','945452','92036OH003001505','2014-01-01','2013-12-12 16:16:17','541.00',NULL,NULL,'645.86','104.86','R-OH002','OH0','645.86',NULL,0,'2013-12-25 22:09:12'),(20639,16492,'Y','18','021','EC','A','','','AC','0000049516','0000049516','TX00001815240','IL','1','SMITH','ANTHONY','W','','','34','466135346','5532 FERNANDER DRIVE',0,'FORT WORTH','TX','76107',NULL,'CY','48439','1968-04-04','M','M',NULL,'N','021','DEN','1811752','33348TX002000201','2014-03-01','2014-01-30 11:33:44','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:32'),(5315,4215,'Y','18','024','14','A','','','TE','0000449857','0000449857','','IL','1','MYERS','BRENDA','SUE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-30','F','',NULL,NULL,NULL,'','2109055','','2013-12-18','2013-12-18 19:42:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:06:41'),(7600,6014,'Y','18','021','EC','A','','','AC','0000236228','0000236228','OH00000068423','IL','1','Taubert','Tricia','','','','34','295785408','23629 DELMERE DR',0,'NORTH OLMSTED','OH','44070','1671','CY','39035','1980-09-05','F','U',':RET:2106-3','N','021','DEN','415972','99734OH005000401','2014-01-01','2013-11-17 17:32:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:45:22'),(24720,19626,'N','01','021','EC','A',NULL,NULL,'','0000467141','0000298280','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:37:42'),(26964,21363,'Y','18','021','EC','A','','','AC','0000121606','0000121606','OH00002764143','IL','1','ELGHAZAL','SAMI','','','','34','287138927','3435 KEYSER PKWY',0,'CUYAHOGA FALLS','OH','44223','3543','CY','39153','1937-05-15','M','M',':RET:2106-3','N','021','HLT','3754627','52664OH151001305','2014-04-01','2014-03-02 14:38:19','517.00',NULL,NULL,'669.00','152.00','R-OH012','OH0','669.00',NULL,0,'2014-03-03 01:00:31'),(27490,21752,'N','19','021','EC','A',NULL,NULL,'','0000829339','0000392426','','IL','1','ZIMMERMAN','NICHOLAS','','','','34','277026663','105 PINELAND DR',0,'COPLEY','OH','44321','1319','CY','39153','1996-12-10','M','',':RET:2106-3','N','021','HLT','2817281','52664OH151001305','2014-05-01','2014-03-04 11:51:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-04 21:02:22'),(27751,21945,'Y','18','024','14','A','','','TE','0001927663','0001927663','','IL','1','Poole','Antoinette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-11-12','F','',NULL,NULL,NULL,'','1592115','','2014-03-20','2014-03-05 05:09:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-05 21:31:15'),(28047,22193,'Y','18','021','EC','A','','','AC','0001232962','0001232962','MS00003042502','31','1','Jones','Parvie','','','','34','587161689','P.O. Box 1814',0,'Canton','MS','39046',NULL,'CY','28089','1949-10-17','M','M',':RET:2054-5','N','021','DEN','3220578','46300MS002000201','2014-04-01','2014-03-05 19:24:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:35'),(714,590,'Y','18','021','EC','A','','','AC','0000768865','0000768865','OH00000307100','IL','1','Gooding','Kenneth','','','','34','270468185','114 2ND AVE',0,'TIFFIN','OH','44883','1320','CY','39147','1951-02-01','M','U',':RET:2106-3','N','021','HLT','2602549','92036OH005002705','2014-01-01','2013-12-16 11:45:08','491.00',NULL,NULL,'560.22','69.22','R-OH006','OH0','560.22',NULL,0,'2013-12-25 18:03:16'),(1959,1598,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001059825','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','982048','33348TX002000101','2014-01-01','2013-11-19 22:58:25','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:10'),(20471,16352,'Y','18','021','EC','A','','','AC','0000957930','0000957930','OH00002349656','IL','1','Haskins','Anne','Lois','','','34','277726199','550 IMO DR',0,'DAYTON','OH','45405','2940','CY','39113','1966-03-23','F','U',':RET:2054-5','T','021','DEN','2877903','99734OH005000401','2014-03-01','2014-01-29 11:58:52','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-29 21:00:55'),(19754,15746,'Y','18','021','EC','A','','','AC','0001014400','0001014400','OH00001488415','IL','1','BOWSER','REBECCA','','','','34','277923450','337 SYCAMORE CREEK ST',0,'PICKERINGTON','OH','43147','7916','CY','39045','1987-12-02','F','U',':RET:2106-3','N','021','DEN','3156048','99734OH005000301','2014-03-01','2014-01-23 13:59:29','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:01:20'),(2016,1654,'Y','18','021','EC','A','','','AC','0000514407','0000514407','OH00001022774','IL','1','Lowe','Donald','','','','34','268922894','3158 REIMER RD',0,'NORTON','OH','44203','5260','CY','39153','1987-08-07','M','U',':RET:2106-3','N','021','HLT','546556','52664OH152000901','2014-01-01','2013-11-19 23:07:51','132.00',NULL,NULL,'167.26','35.26','R-OH012','OH0','167.26',NULL,0,'2013-12-25 19:02:38'),(3126,2511,'N','01','021','EC','A',NULL,NULL,'','0000153327','0000305801','','IL','1','Lambert','Melissa','','','','34','002661185','5625 Coach Drive East',0,'Kettering','OH','45440',NULL,'CY','39113','1982-12-24','F','',NULL,'N','021','DEN','394657','99734OH005000301','2014-01-01','2013-10-13 14:46:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:30:23'),(9061,7190,'Y','18','021','EC','A','','','AC','0000937944','0000937944','TX00000314873','IL','1','Hunt','Jasmine','','','','34','642264056','5644 SHALLOW RUN',0,'BENBROOK','TX','76109','8714','CY','48439','1991-08-08','F','U',':RET:2054-5','N','021','DEN','1620600','33348TX002000101','2014-01-01','2013-12-18 12:18:12','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 04:06:21'),(14028,11174,'Y','18','021','EC','A','','','AC','0000752082','0000752082','OH00000014125','IL','1','Brooks','Ideaner','','','','34','269487483','4066 bushnell rd',0,'university heights','OH','44118',NULL,'CY','39035','1949-08-29','F','U',NULL,'N','021','HLT','2256806','92036OH004000801','2014-01-01','2013-12-23 14:32:35','538.00',NULL,NULL,'563.97','25.97','R-OH011','OH0','563.97',NULL,0,'2013-12-26 13:16:47'),(22484,17951,'Y','18','021','EC','A','','','AC','0000963275','0000963275','OH00002614763','IL','1','Headrick','Timothy','','','','34','302549126','6513 Shaffer Road NW',0,'Warren','OH','44481',NULL,'CY','39155','1953-06-21','M','M',NULL,'N','021','DEN','3118316','99734OH005000301','2014-03-01','2014-02-10 09:30:05','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-02-10 21:31:04'),(22611,18057,'Y','18','021','EC','A','','','AC','0000121933','0000121933','TX00001918702','IL','1','HOQUE','NURUL','','','','34','628483581','824 ARAF AVE',0,'RICHARDSON','TX','75081','5189','CY','48113','1970-07-16','M','M',':RET:2028-9','N','021','DEN','3189785','33348TX002000201','2014-03-01','2014-02-11 18:21:32','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:05'),(28579,22617,'Y','18','021','EC','A','','','AC','0000140895','0000140895','TX00003464465','IL','1','Fortanelli-Martinez','Ma Angelica','','','','34','459999610','1320 LILLY ST',0,'EL CAMPO','TX','77437','5350','CY','48481','1971-03-19','F','M',NULL,'N','021','DEN','4169932','33348TX002000201','2014-04-01','2014-03-08 14:43:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-08 21:00:06'),(29152,23077,'N','01','021','EC','A',NULL,NULL,'','0001212398','0000073998','','IL','1','Murphy','Jill','','','','34','299523159','104 COVER DR',0,'POLAND','OH','44514','1619','CY','39099','1951-11-16','F','',NULL,'N','021','HLT','3174996','92036OH005003201','2014-04-01','2014-03-10 11:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','695.41',NULL,0,'2014-03-10 21:02:50'),(446,366,'Y','18','024','14','A','','','TE','0000186069','0000186069','','IL','1','Purdy','Mark',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-04-06','M','',NULL,NULL,NULL,'','335758','','2013-12-04','2013-12-04 11:47:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:47:18'),(6913,5486,'N','01','021','EC','A',NULL,NULL,'','0001258165','0002082205','','IL','1','Jones','Terrence','','','','34','435175220','5000 PAUGER ST',0,'NEW ORLEANS','LA','70122','4032','CY','22071','1966-06-18','M','',':RET:2054-5','N','021','DEN','1621127','18575LA002000201','2014-02-01','2013-12-25 00:35:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:45:58'),(6606,5239,'Y','18','021','EC','A','','','AC','0000378543','0000378543','OH00001276436','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','HLT','567533','92036OH003000505','2014-01-01','2013-12-11 09:42:35','368.00',NULL,NULL,'506.41','138.41','R-OH003','OH0','506.41',NULL,0,'2013-12-26 00:53:39'),(3601,2887,'N','01','021','EC','A',NULL,NULL,'','0000570557','0000096395','','IL','1','KIRCHENR','KAY','','','','34','310727817','120 WALL ST',0,'TIFFIN','OH','44883','2146','CY','39147','1957-12-25','F','',':RET:2106-3','T','021','HLT','1660459','92036OH003002705','2014-01-01','2013-12-22 11:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','546.33',NULL,0,'2013-12-25 21:23:15'),(2297,1871,'Y','18','021','EC','A','','','AC','0001151056','0001151056','OH00001187651','IL','1','Coolidge','Valerie','Comas','','','34','234024569','4640 WYANDOTTE DR',0,'COLUMBUS','OH','43230','1258','CY','39049','1960-03-25','F','M',':RET:2106-3','N','021','DEN','856432','99734OH005000301','2014-01-01','2013-12-09 16:23:12','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:54'),(16555,13244,'Y','18','024','14','A','','','TE','0001284858','0001284858','','IL','1','Mitchell','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-10-06','F','',NULL,NULL,NULL,'','1636184','','2014-01-05','2014-01-05 15:11:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2014-01-07 10:22:52'),(8906,7063,'Y','18','021','EC','A','','','AC','0000373616','0000373616','OH00000290188','IL','1','mattes','jacob','','','','34','299924952','1684 bailey road',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1990-12-22','M','U',':RET:2106-3','T','021','DEN','2557669','99734OH005000401','2014-01-01','2013-12-17 20:16:08','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:02:26'),(25685,20378,'Y','18','021','EC','A','','','AC','0001108433','0001108433','MS00002915404','IL','1','Hamilton','Kenta','','','','34','427138572','4635 OLD CANTON RD',0,'JACKSON','MS','39211','5528','CY','28049','1962-03-30','F','M',':RET:2106-3','T','021','DEN','3853435','46300MS002000201','2014-04-01','2014-02-24 14:23:25','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:07'),(26344,20901,'Y','18','021','EC','A','','','AC','0001066040','0001066040','OH00002835728','IL','1','DAVIS','KIMBERLY','','','','34','295725916','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1971-05-27','F','M',':RET:2106-3','N','021','HLT','3569741','92036OH004000601','2014-03-01','2014-02-27 12:17:02','230.00',NULL,NULL,'597.24','367.24','R-OH005','OH0','228.72',NULL,0,'2014-02-28 06:31:45'),(5615,4455,'N','01','021','EC','A',NULL,NULL,'','0000666729','0000627840','','IL','1','Yohe','Grae','','','','34','276807472','3436 ERHART RD',0,'LITCHFIELD','OH','44253','9731','CY','39103','1976-03-23','M','',':RET:2106-3','N','021','DEN','834245','99734OH005000401','2014-01-01','2013-11-26 08:16:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:36'),(21764,17380,'Y','18','021','EC','A','','','AC','0001090764','0001090764','TX00001806173','IL','1','Trinh','June','','','','34','299747276','12303 TERRACE COVE LN',0,'CYPRESS','TX','77433','3372','CY','48201','1976-03-06','F','U',':RET:2047-9','N','021','DEN','3783757','33348TX002000201','2014-03-01','2014-02-06 16:30:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-06 21:00:28'),(1375,1140,'Y','18','021','EC','A','','','AC','0000278943','0000278943','TX00000012953','IL','1','Dang','Huong','','','','34','585254715','1104 APACHE LAKE DR',0,'CARROLLTON','TX','75010','1140','CY','48121','1959-11-07','F','U',':RET:2047-9','N','021','DEN','2353027','33348TX002000101','2014-01-01','2013-12-24 18:00:45','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 18:45:55'),(4448,3535,'Y','18','021','EC','A','','','AC','0001147317','0001147317','OH00000591249','IL','1','SCHLIESMAN','JUDITH','','','','34','271501823','1050 FRANKLIN ST',0,'HAMILTON','OH','45013',NULL,'CY','39017','1950-01-20','F','M',':RET:2106-3','N','021','DEN','143324','99734OH005000301','2014-01-01','2013-12-12 09:54:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:02:20'),(3225,2596,'Y','18','021','EC','A','','','AC','0000521917','0000521917','OH00000873413','IL','1','cole','kayla','','','','34','268944797','11414 pool kuntz rd',0,'sardinia','OH','45171',NULL,'CY','39015','1991-02-17','F','M',':RET:2106-3','N','021','HLT','939568','92036OH006000601','2014-01-01','2013-11-01 16:24:47','338.00',NULL,NULL,'340.48','2.48','R-OH005','OH0','170.24',NULL,0,'2013-12-25 20:45:52'),(7384,5845,'N','01','021','EC','A',NULL,NULL,'','0001233017','0001160378','','IL','1','Cameron','Tonya',NULL,NULL,NULL,NULL,NULL,'735 AMBERLY DR',0,'HAMILTON','OH','45013','3458','CY','39017','1972-09-07','F','',':RET:2106-3','N','021','DEN','914454','99734OH005000401','2014-01-01','2013-11-23 10:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:58'),(7789,6168,'Y','18','021','EC','A','','','AC','0000174943','0000174943','TX00001312490','IL','1','GONSALES','JESSE','','','','34','456330968','402 S AVENUE L',0,'LAMESA','TX','79331','6038','CY','48115','1961-08-30','M','M',NULL,'T','021','DEN','2187897','33348TX002000201','2014-01-01','2013-12-20 14:43:36','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:23'),(18754,14943,'Y','18','024','14','A','','','TE','0000153393','0000153393','','IL','1','Zarnick','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-01','M','',NULL,NULL,NULL,'','2833526','','2014-01-16','2014-01-16 12:04:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:35:45'),(22402,17887,'Y','18','021','EC','A','','','AC','0000602318','0000602318','OH00002294244','IL','1','BIVINS','RANDALL','','','','34','253806150','324 BROAD ST',0,'WADSWORTH','OH','44281','2243','CY','39103','1950-06-15','M','M',':RET:2106-3','N','021','HLT','3143151','52664OH151001301','2014-03-01','2014-02-10 16:07:24','555.00',NULL,NULL,'658.32','103.32','R-OH012','OH0','658.32',NULL,0,'2014-02-10 21:30:20'),(25826,20477,'N','01','021','EC','A',NULL,NULL,'','0000253100','0000888228','','IL','1','JACOBS','DAVID','','','','34','294480154','48866 JOHN TOMCHO RD',0,'CUMBERLAND','OH','43732',NULL,'CY','39121','1951-06-22','M','',':RET:2106-3','N','021','DEN','3155546','99734OH005000301','2014-03-01','2014-02-26 16:42:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:28'),(27206,21541,'Y','18','021','EC','A','','','AC','0000643286','0000643286','OH00003285143','IL','1','Fletcher','Carole','A','','','34','292502290','5123 Ryan Rd.',0,'Toledo','OH','43614',NULL,'CY','39095','1952-10-27','F','U',':RET:2106-3','T','021','HLT','2943344','92036OH004002601','2014-04-01','2014-03-03 10:52:07','393.00',NULL,NULL,'506.69','113.69','R-OH001','OH0','506.69',NULL,0,'2014-03-03 21:31:25'),(29052,22994,'Y','18','021','EC','A','','','AC','0000287170','0000287170','OH00003138761','IL','1','Emery','Karen','','','','34','369564919','5626 ELLIOTT DR',0,'SYLVANIA','OH','43560','2063','CY','39095','1951-05-15','F','U',':RET:2106-3','N','021','DEN','3894245','99734OH005000401','2014-04-01','2014-03-10 15:10:32','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-10 21:01:47'),(7052,5602,'Y','18','021','EC','A','','','AC','0000390899','0000390899','OH00000496552','IL','1','Kunkel','Linda','','','','34','283585505','332 DONHAM AVE',0,'CINCINNATI','OH','45226','2116','CY','39061','1961-05-25','F','U',NULL,'N','021','DEN','1445671','99734OH005000301','2014-01-01','2013-12-24 19:19:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:49:43'),(6976,5535,'N','01','021','EC','A',NULL,NULL,'','0000647078','0000427639','','IL','1','Rosholt','Mark','J',NULL,NULL,NULL,NULL,'4241 Eldridge Ave SW',0,'Massillon','OH','44646',NULL,'CY','39151','1964-07-14','M','',':RET:2106-3','T','021','DEN','1559243','99734OH005000401','2014-01-01','2013-12-24 23:27:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:34'),(21719,17343,'N','01','021','EC','A',NULL,NULL,'','0000580017','0000827200','','IL','1','SMITH','DONNIE','','','','34','401040769','555 BOURBON STREET',0,'BLANCHESTER','OH','45107',NULL,'CY','39027','1968-04-14','M','',NULL,'N','021','HLT','3059758','92036OH003000605','2014-03-01','2014-02-05 14:35:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','323.72',NULL,0,'2014-02-05 21:31:18'),(20523,16399,'Y','18','021','EC','A','','','AC','0000074096','0000074096','TX00002227250','IL','1','Austin','Stephen','','','','34','437926119','4346 FM 1999',0,'Karnack','TX','75661',NULL,'CY','48203','1955-01-06','M','R',':RET:2106-3','T','021','DEN','3131767','33348TX002000101','2014-03-01','2014-01-29 17:46:02','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-29 21:01:26'),(20326,16229,'Y','18','024','14','A','','','TE','0000490393','0000490393','','IL','1','Bybee','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-30','M','',NULL,NULL,NULL,'','1809652','','2014-01-28','2014-01-28 17:09:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:58'),(4879,3868,'N','01','021','EC','A',NULL,NULL,'','0000315229','0000079284','','IL','1','Rasnic','Deanna','Rogers','','','34','437317339','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1971-10-11','F','',NULL,'N','021','DEN','322518','33348TX002000201','2014-01-01','2013-10-10 01:38:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:31:12'),(14822,11838,'N','19','021','EC','A',NULL,NULL,'','0000860687','0000841044','','IL','1','Borromeo','Steony','Tonggao','','','34','631363016','15707 Pinyon Creek Dr',0,'Houston','TX','77095',NULL,'CY','48201','1992-08-27','F','',':RET:2036-2','N','021','DEN','2013174','33348TX002000101','2014-01-01','2013-12-23 20:51:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,1,'2013-12-29 11:14:21'),(4510,3575,'Y','18','021','EC','A','','','AC','0001124561','0001124561','TX00000747254','31','1','Turner','Stella','','','','34','456432147','P O Box 256',0,'Bronte','TX','76933',NULL,'CY','48081','1961-06-03','F','M',NULL,'N','021','DEN','347292','33348TX002000201','2014-01-01','2013-12-12 06:34:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:03:34'),(13409,10700,'Y','18','021','EC','A','','','AC','0000540299','0000540299','OH00000445386','IL','1','Mecklenborg','Evan','','','','34','300980342','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','1980-07-19','M','M',NULL,'N','021','DEN','1618729','99734OH005000301','2014-01-01','2013-12-23 10:06:02','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:32'),(9665,7657,'Y','18','024','14','A','','','TE','0000569486','0000569486','','IL','1','Morgan','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-23','F','',NULL,NULL,NULL,'','1444205','','2013-12-21','2013-12-21 09:24:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 04:39:05'),(685,564,'Y','18','021','EC','A','','','AC','0000990051','0000990051','OH00001121275','IL','1','ferreri','samuel','','','','34','295542687','25 FIELDSTONE',0,'POLAND','OH','44514','4201','CY','39099','1954-11-27','M','M',':RET:2106-3','N','021','DEN','2466880','99734OH005000301','2014-01-01','2013-12-16 12:25:46','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:02:30'),(3522,2829,'Y','18','024','14','A','','','TE','0000245358','0000245358','','IL','1','Goldstein','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-09-18','M','',NULL,NULL,NULL,'','2548389','','2013-12-22','2013-12-22 12:16:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 21:21:17'),(99,88,'Y','18','021','EC','A','','','AC','0000834030','0000834030','TX00000513948','IL','1','SHARARA','MARIA','JOSEFA','','','34','267789826','1315 ARDEN FOREST DR',0,'SPRING','TX','77379','2988','CY','48201','1949-07-29','F','U',NULL,'N','021','DEN','853842','33348TX002000201','2014-01-01','2013-12-05 13:05:36','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:17:40'),(13797,11014,'Y','18','021','EC','A','','','AC','0000874282','0000874282','MS00000338399','IL','1','Taylor','Vernon','Mack','','','34','428080981','1763 SOUTHHAVEN CIR',0,'JACKSON','MS','39204','4300','CY','28049','1957-02-04','M','M',':RET:2054-5','T','021','DEN','2208371','46300MS002000101','2014-01-01','2013-12-23 12:10:43','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:16'),(13192,10525,'Y','18','021','EC','A','','','AC','0000306442','0000306442','TX00000644294','IL','1','valenzuela','Jessica','','','','34','625202977','225 OAK HILL DR',0,'TROPHY CLUB','TX','76262','5454','CY','48121','1985-10-15','F','U',NULL,'N','021','DEN','1627122','33348TX002000101','2014-01-01','2013-12-23 09:46:38','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:40'),(1425,1187,'Y','18','021','EC','A','','','AC','0001415028','0001415028','LA00001398185','IL','1','CAMPBELL','PAUL','','','','34','433175088','1611 GRACELAND AVE',0,'ABBEVILLE','LA','70510','3849','CY','22113','1974-02-02','M','U',':RET:2106-3','T','021','DEN','1882006','18575LA002000201','2014-01-01','2013-12-24 16:10:07','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:47:22'),(16970,13583,'Y','18','021','EC','A','','','AC','0000218843','0000218843','OH00002392528','IL','1','Mahoney','Leslie','','','','34','301660730','27261 NANTUCKET DR',0,'NORTH OLMSTED','OH','44070','4456','CY','39035','1963-08-08','F','U',':RET:2106-3','N','021','HLT','1823189','52664OH151001305','2014-02-01','2014-01-09 17:12:45','380.00',NULL,NULL,'700.73','320.73','R-OH011','OH0','449.21',NULL,0,'2014-01-13 02:20:12'),(22482,17949,'Y','18','021','EC','A','','','AC','0000508035','0000508035','OH00002627036','IL','1','Piper','Juanita','','','','34','288502379','5269 E. Pine Lake Rd',0,'Petersburg','OH','44454',NULL,'CY','39099','1951-06-15','F','U',':RET:2106-3','N','021','DEN','3744099','99734OH005000301','2014-03-01','2014-02-09 22:06:51','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-10 21:31:03'),(23376,18627,'Y','18','021','EC','A','','','AC','0000690783','0000690783','OH00001844438','IL','1','Vansickle','Connie','','','','34','297627936','3000 HOGUE RD',0,'ADAMSVILLE','OH','43802','9023','CY','39119','1958-12-15','F','M',':RET:2106-3','N','021','DEN','2996274','99734OH005000401','2014-03-01','2014-02-13 10:23:24','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-02-13 22:00:57'),(23656,18837,'Y','18','021','EC','A','','','AC','0001016771','0001016771','TX00001553791','31','1','Boyd','Gary','','','','34','454152734','POB 1454',0,'Sweetwater','TX','79556',NULL,'CY','48353','1957-11-08','M','U',':RET:2106-3','N','021','DEN','2679469','33348TX002000201','2014-03-01','2014-02-14 07:28:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:17'),(23665,18843,'Y','18','021','EC','A','','','AC','0000989952','0000989952','TX00001904859','IL','1','Vaid','Usman','','','','34','307707682','20927 SHELBY MEADOW LN',0,'RICHMOND','TX','77407','4024','CY','48157','1950-11-30','M','M',':RET:2028-9','N','021','DEN','3269218','33348TX002000201','2014-03-01','2014-02-14 13:09:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-14 21:30:21'),(24766,19651,'Y','18','021','EC','A','','','AC','0000947441','0000947441','OH00002802438','IL','1','GARZA','EMILY','','','','34','280843026','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-04-26','F','M',':RET:2106-3','T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:43:35'),(27733,21930,'N','01','021','EC','A',NULL,NULL,'','0000913838','0000750396','','IL','1','GARCIA','ELIZABETH','','','','34','461993875','4250 LOMA ROSADA DR',0,'EL PASO','TX','79934','3772','CY','48141','1967-12-21','F','',NULL,'N','021','DEN','2887893','33348TX002000201','2014-04-01','2014-03-05 16:14:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:31:04'),(44,39,'Y','18','021','EC','A','','','AC','0000203048','0000203048','OH00000673263','IL','1','Montgomery','Gwyn','A','','','34','274542411','5478 EHRLING RD',0,'CINCINNATI','OH','45227','1123','CY','39061','1956-04-03','F','U',':RET:2054-5','N','021','DEN','843790','99734OH005000401','2014-01-01','2013-12-05 18:02:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:09'),(1440,1202,'Y','18','021','EC','A','','','AC','0000640929','0000640929','OH00000707566','IL','1','phipps','randall','','','','34','278560239','3775 TATER KNOB RD',0,'PEEBLES','OH','45660','9333','CY','39001','1954-06-30','M','M',':RET:2106-3','N','021','HLT','2046838','92036OH003000605','2014-01-01','2013-12-24 04:26:20','956.00',NULL,NULL,'1062.18','106.18','R-OH005','OH0','583.55',NULL,0,'2013-12-25 18:47:50'),(6934,5505,'Y','18','024','14','A','','','TE','0001168005','0001168005','','IL','1','Ashby','Matthew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-18','M','',NULL,NULL,NULL,'','2506723','','2013-12-24','2013-12-24 20:03:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:46:37'),(3183,2560,'Y','18','021','EC','A','','','AC','0000204763','0000204763','LA00000720846','IL','1','HARLOW','juliette','','','','34','435494042','113 DUNLEITH DR',0,'DESTREHAN','LA','70047','2026','CY','22089','1980-05-16','F','M',NULL,'N','021','DEN','446612','18575LA002000201','2014-01-01','2013-11-18 17:34:15','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:31:54'),(16195,12966,'Y','18','021','EC','A','','','AC','0000812005','0000812005','TX00002317362','IL','1','Othman','Ayad','','','','34','465616359','1434 PLAZA ROJA CT',0,'EL PASO','TX','79912','8449','CY','48141','1961-08-24','M','M',':RET:2106-3','N','021','DEN','2037062','33348TX002000201','2014-02-01','2014-01-04 11:00:06','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-05 00:00:58'),(17145,13719,'N','01','021','EC','A',NULL,NULL,'','0001712549','0001827207','','IL','1','ARMSTRONG','JANET','CHARLET','','','34','437394714','2295 HORTON ST',0,'ZWOLLE','LA','71486','3103','CY','22085','1978-09-01','F','',':RET:2106-3','N','021','DEN','1487741','18575LA002000201','2014-02-01','2014-01-07 20:16:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:21:54'),(19136,15247,'N','01','021','EC','A',NULL,NULL,'','0000016539','0000292045','','IL','1','Phillips','Donna','Lynn','','','34','237216842','1924 RALPH JANES PL',0,'EL PASO','TX','79936','4062','CY','48141','1964-10-07','F','',':RET:2106-3','N','021','DEN','2119258','33348TX002000201','2014-03-01','2014-01-18 19:15:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:45:27'),(22312,17813,'Y','18','021','EC','A','','','AC','0000847848','0000847848','MS00002189718','IL','1','Walker','Melvin','','','','34','414195645','65 KERSHAW ST',0,'GRENADA','MS','38901','2207','CY','28043','1960-07-24','M','U',NULL,'N','021','DEN','3002013','46300MS002000101','2014-03-01','2014-01-22 18:02:48','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-10 11:00:46'),(22417,17899,'Y','18','024','14','A','','','TE','0000434563','0000434563','','IL','1','Thomas','Noel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-10-12','F','',NULL,NULL,NULL,'','848560','','2014-02-25','2014-02-10 13:32:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-10 21:30:28'),(26291,20855,'Y','18','024','14','A','','','TE','0000904448','0000904448','','IL','1','JENKINS','LILLIAN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-28','F','',NULL,NULL,NULL,'','457912','','2014-03-14','2014-02-27 16:33:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-28 06:31:24'),(1201,989,'N','19','021','EC','A',NULL,NULL,'','0000571963','0000773943','','IL','1','Pielech','Aleksa','B','','','34','295964994','435 W 48TH ST',0,'SHADYSIDE','OH','43947','1050','CY','39013','1994-03-20','F','',':RET:2106-3','N','021','DEN','1159487','99734OH005000301','2014-01-01','2013-12-03 03:54:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:53'),(1311,1085,'Y','18','021','EC','A','','','AC','0000231465','0000231465','OH00000865246','IL','1','thornton','felicia','','','','34','285803121','1416 COBURG RD',0,'COLUMBUS','OH','43227','3220','CY','39049','1983-04-03','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','857246','99734OH005000401','2014-01-01','2013-11-03 23:59:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:31:28'),(13621,10860,'Y','18','021','EC','A','','','AC','0000303361','0000303361','OH00000136720','IL','1','rehan','tarick','','','','34','224716378','1722 LUCILLE DR',0,'LIMA','OH','45801','2816','CY','39003','1994-04-11','M','U',':RET:2054-5','N','021','HLT','1625693','92036OH005001506','2014-01-01','2013-12-22 19:40:26','123.00',NULL,NULL,'139.76','16.76','R-OH002','OH0','139.76',NULL,0,'2013-12-26 13:05:51'),(9542,7562,'Y','18','021','EC','A','','','AC','0000899559','0000899559','OH00000773333','IL','1','CAMPBELL','STEFANY','','','','34','269527325','404 DAYTON ST',0,'YELLOW SPRINGS','OH','45387','1706','CY','39057','1950-08-04','F','M',':RET:2106-3','N','021','DEN','1725056','99734OH005000301','2014-01-01','2013-12-21 11:55:57','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:36:02'),(2106,1727,'Y','18','021','EC','A','','','AC','0000338853','0000338853','OH00000634196','IL','1','McKinney','Debra','','','','34','291428895','137 HIRN ST',0,'CHILLICOTHE','OH','45601','2627','CY','39141','1952-03-12','F','U',':RET:2106-3','N','021','DEN','347228','99734OH005000401','2014-01-01','2013-12-10 09:55:27','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-25 19:17:19'),(9206,7302,'N','01','021','EC','A',NULL,NULL,'','0000237440','0000868175','','IL','1','MAISURIA','JAYSHREEBEN','RAKESHKUMAR','','','34','860939399','2206 MAIN ST',0,'COLUMBUS','MS','39701','6046','CY','28087','1974-09-26','F','',':RET:2029-7','N','021','DEN','1988233','46300MS002000201','2014-01-01','2013-12-18 12:27:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 04:09:48'),(4021,3211,'Y','18','021','EC','A','','','AC','0000607139','0000607139','OH00000108292','IL','1','ruggles','randy','','','','34','284568258','3830 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9575','CY','39123','1953-12-01','M','M',':RET:2106-3','N','021','DEN','2168737','99734OH005000401','2014-01-01','2013-12-17 08:39:45','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:45:40'),(6447,5112,'Y','18','021','EC','A','','','AC','0000987374','0000987374','OH00000703220','IL','1','King','Duane','','','','34','280763757','468 E MAIN ST',0,'PORTAGE','OH','43451','9701','CY','39173','1965-08-27','M','M',':RET:2106-3','N','021','HLT','843910','92036OH004002601','2014-01-01','2013-12-10 22:20:22','400.00',NULL,NULL,'792.75','392.75','R-OH001','OH0','256.36',NULL,0,'2013-12-26 00:49:36'),(23063,18387,'Y','18','021','EC','A','','','AC','0001969387','0001969387','LA00002003078','IL','1','Rodriguez','Giorgio','','','','34','438552240','1504 CLEARY AVE',0,'METAIRIE','LA','70001','3731','CY','22051','1968-01-25','M','U',NULL,'N','021','DEN','2621362','18575LA002000201','2014-03-01','2014-02-12 15:59:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:52'),(27030,21408,'Y','18','024','14','A','','','TE','0001065207','0001065207','','IL','1','CISNEROS','ALBA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-21','F','',NULL,NULL,NULL,'','1548568','','2014-03-31','2014-03-03 14:13:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-03 21:00:16'),(6246,4949,'Y','18','021','EC','A','','','AC','0000479613','0000479613','MS00001164226','31','1','CULBERSON','LARRY','','','','34','587069309','PO BOX 247',0,'NOXAPATER','MS','39346',NULL,'CY','28159','1960-09-25','M','U',NULL,'N','021','DEN','287025','46300MS002000101','2014-01-01','2013-11-18 20:38:29','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 00:31:48'),(4215,3353,'Y','18','021','EC','A','','','AC','0000390597','0000390597','TX00000625773','IL','1','HUTCHINSON','CARLIE','ROSE','','','34','633341054','819 KIOWA DR E',0,'LAKE KIOWA','TX','76240','9573','CY','48097','1992-12-21','F','R',':RET:2106-3','N','021','DEN','2559084','33348TX002000201','2014-01-01','2013-12-17 09:06:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:17'),(3107,2496,'Y','18','021','EC','A','','','AC','0000836613','0000836613','OH00001067380','IL','1','Murray','Connie','','','','34','295446041','1285 County Road F',0,'Swanton','OH','43558',NULL,'CY','39051','1960-01-19','F','M',':RET:2106-3','T','021','HLT','757277','92036OH002002601','2014-01-01','2013-12-06 13:27:12','389.00',NULL,NULL,'1056.58','667.58','R-OH001','OH0','528.29',NULL,0,'2013-12-25 20:20:26'),(13219,10546,'N','01','021','EC','A',NULL,NULL,'','0000553050','0000028293','','IL','1','Legg','Maureen','','','','34','592704171','227 RED HAWK RDG',0,'SAN ANTONIO','TX','78258','4866','CY','48029','1960-06-14','F','',':RET:2106-3','N','021','DEN','1980234','33348TX002000201','2014-01-01','2013-12-22 19:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:55:26'),(15439,12353,'Y','18','021','EC','A','','','AC','0001197725','0001197725','TX00000410923','IL','1','Maier','Gary','','','','34','456574484','605 W. Inez',0,'Beeville','TX','78102',NULL,'CY','48025','1967-01-24','M','U',':RET:2106-3','N','021','DEN','1422747','33348TX002000201','2014-02-01','2013-12-31 13:58:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:28:00'),(14484,11555,'Y','18','021','EC','A','','','AC','0000869017','0000869017','TX00001049079','IL','1','fulton','bobby','','','','34','564177311','709 ODANIEL ST',0,'BORGER','TX','79007','2844','CY','48233','1971-12-11','M','U',':RET:2106-3','N','021','DEN','2179641','33348TX002000201','2014-02-01','2013-12-27 08:39:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:20'),(14961,11958,'Y','18','021','EC','A','','','AC','0000956361','0000956361','TX00001540201','31','1','Grant','Anna','','','','34','461080261','P.O. Box 62',0,'Mineola','TX','75773',NULL,'CY','48499','1952-01-09','F','U',':RET:2054-5','N','021','DEN','2209863','33348TX002000201','2014-02-01','2013-12-30 10:40:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:00:31'),(17777,14203,'N','19','021','EC','A',NULL,NULL,'','0000406596','0001261939','','IL','1','CLAY','KEITH','','','Jr','34','632304383','8702 BROOKHOLLOW DR',0,'ROWLETT','TX','75089','8621','CY','48113','1992-03-02','M','',NULL,'N','021','DEN','1581611','33348TX002000101','2014-02-01','2014-01-13 16:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-14 01:33:41'),(21925,17510,'Y','18','021','EC','A','','','AC','0000560633','0000560633','TX00002188743','IL','1','Flores','Catherine','','','','34','629222758','424 SOUDER DR',0,'HURST','TX','76053','6739','CY','48439','1985-07-07','F','U',':RET:2106-3','N','021','DEN','3326864','33348TX002000201','2014-03-01','2014-02-06 20:11:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-07 19:00:07'),(24033,19114,'Y','18','021','EC','A','','','AC','0001162644','0001162644','OH00002917589','IL','1','Kreitman','Leonard','','','','34','278566416','109 ODLIN AVE',0,'DAYTON','OH','45405','2724','CY','39113','1962-04-27','M','U',':RET:2106-3','N','021','DEN','3472227','99734OH005000301','2014-03-01','2014-02-14 22:40:08','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-15 22:00:54'),(24585,19518,'Y','18','021','EC','A','','','AC','0000290852','0000290852','OH00001805183','IL','1','CZEKANSKY','SUSAN','','','','34','282588932','1374 LIPTON AVE SW',0,'CANTON','OH','44720','4147','CY','39151','1970-06-25','F','U',NULL,'N','021','DEN','2951732','99734OH005000301','2014-04-01','2014-02-19 10:44:21','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-20 04:09:15'),(27280,21602,'Y','18','021','EC','A','','','AC','0000493421','0000493421','TX00002759100','IL','1','Cantu','Rodolfo','H','','Jr','34','452397032','802 SUNRISE LN',0,'MISSION','TX','78574','2383','CY','48215','1964-01-05','M','U',':RET:2106-3','N','021','DEN','3233567','33348TX002000201','2014-04-01','2014-03-03 21:47:00','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-04 21:00:21'),(28783,22783,'N','19','021','EC','A',NULL,NULL,'','0000221388','0000921993','','IL','1','Willis','Benjamin','M','','','34','279665039','732 Bellingham Ct',0,'Worthington','OH','43085',NULL,'CY','39049','1991-10-21','M','',':RET:2054-5','N','021','DEN','2822386','99734OH005000401','2014-04-01','2014-03-09 16:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:36'),(1211,995,'N','01','021','EC','A',NULL,NULL,'','0000585505','0000939741','','IL','1','Carpenter','Deborah','','','','34','297565676','10255 THWING RD',0,'CHARDON','OH','44024','9788','CY','39055','1955-08-23','F','',NULL,'N','021','DEN','552941','99734OH005000301','2014-01-01','2013-12-03 16:32:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:20:06'),(15537,12432,'Y','18','021','EC','A','','','AC','0002215760','0002215760','LA00002074541','IL','1','mccoy','robert','','','','34','435150365','309 S SPRUCE ST',0,'VIDALIA','LA','71373','4056','CY','22029','1972-11-23','M','U',NULL,'T','021','DEN','2501128','18575LA002000201','2014-02-01','2013-12-31 14:03:21','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,1,'2014-01-02 04:30:50'),(14764,11787,'Y','18','021','EC','A','','','AC','0001070196','0001070196','TX00001425936','IL','1','Contreras','Alondra','Yasmine','','','34','634383688','1345 RANCHERO CT',0,'SAN ELIZARIO','TX','79849','7535','CY','48141','1992-04-17','F','M',':RET:2106-3','N','021','DEN','2068402','33348TX002000201','2014-01-01','2013-12-23 20:13:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:12:45'),(14449,11526,'Y','18','021','EC','A','','','AC','0001428847','0001428847','LA00001666225','IL','1','LAMBERT','AMELIA','DAWN','','','34','267571872','3616 LAKE VILLA DR',0,'METAIRIE','LA','70002','4330','CY','22051','1956-11-11','F','U',NULL,'T','021','DEN','2378865','18575LA002000201','2014-02-01','2013-12-27 13:20:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:26'),(6029,4773,'Y','18','021','EC','A','','','AC','0000994836','0000994836','TX00000923280','IL','1','Meadows','James','C','','','34','450434550','303 E NANCY ST',0,'WHITE OAK','TX','75693','1121','CY','48183','1963-03-07','M','U',':RET:2106-3','N','021','DEN','642674','33348TX002000201','2014-01-01','2013-11-30 21:31:04','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 00:01:06'),(13670,10907,'N','01','021','EC','A',NULL,NULL,'','0001751407','0001670244','','IL','1','TAYLOR','GERALD','','','','34','415926178','1819 MCKINNEY RD',0,'SLIDELL','LA','70458','8011','CY','22103','1953-01-24','M','',':RET:2054-5','N','021','DEN','1764541','18575LA002000101','2014-01-01','2013-12-23 16:51:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 13:07:53'),(13369,10679,'Y','18','024','14','A','','','TE','0000665595','0000665595','','IL','1','MEEKER','JASON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-10-08','M','',NULL,NULL,NULL,'','111525','','2013-12-22','2013-12-22 21:19:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:59:44'),(19675,15679,'Y','18','021','EC','A','','','AC','0000593354','0000593354','TX00002585450','IL','1','Gonzales','Sandra','Patricia','','','34','629243368','1306 ALCOA AVE',0,'ROCKDALE','TX','76567','2105','CY','48331','1974-09-13','F','M',':RET:2106-3','N','021','DEN','2463008','33348TX002000201','2014-03-01','2014-01-22 21:16:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:34'),(26024,20640,'Y','18','021','EC','A','','','AC','0000597888','0000597888','MS00002719814','IL','1','ROGERS','ANTONIO','','','','34','427553620','3017 SPRINGHILL RD',0,'UNION','MS','39365',NULL,'CY','28101','1972-12-25','M','U',':RET:2054-5','N','021','DEN','3703144','46300MS002000101','2014-03-01','2014-02-26 10:54:07','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-26 21:02:17'),(28956,22917,'Y','18','021','EC','A','','','AC','0001214444','0001214444','LA00002841564','IL','1','Guillory','Annette','F','','','34','459511264','4226 PRAIRIE RONDE HWY',0,'OPELOUSAS','LA','70570','1054','CY','22097','1965-10-01','F','M',NULL,'N','021','DEN','3851520','18575LA002000201','2014-04-01','2014-03-10 11:25:26','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-03-10 21:00:53'),(6018,4763,'Y','18','021','EC','A','','','AC','0000459121','0000459121','OH00001225047','IL','1','Lindelof','Kara','Louisa','','','34','027644543','2404 COUNTRY SQUIRE LN',0,'TOLEDO','OH','43615','2735','CY','39095','1983-06-18','F','U',':RET:2106-3','N','021','DEN','816879','99734OH005000301','2014-01-01','2013-12-01 09:37:38','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:00:46'),(23996,19080,'Y','18','021','EC','A','','','AC','0001991171','0001991171','LA00002121177','IL','1','Fleming','Yana','','','','34','227133099','300 Baronne ST',0,'New Orleans','LA','70112',NULL,'CY','22071','1977-02-10','F','U',NULL,'N','021','DEN','3395380','18575LA002000201','2014-03-01','2014-02-15 15:39:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:30'),(24861,19711,'Y','18','024','14','A','','','TE','0000400559','0000400559','','IL','1','PARKER','RICHARD',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-21','M','',NULL,NULL,NULL,'','1513221','','2014-02-28','2014-02-18 18:36:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 05:30:24'),(25082,19892,'Y','18','021','EC','A','','','AC','0000413409','0000413409','OH00001989480','IL','1','BUMSTED','DANA','','','','34','479921923','9490 WYNNECREST DR',0,'BLUE ASH','OH','45242','6941','CY','39061','1968-06-07','F','U',':RET:2106-3','N','021','HLT','3497301','92036OH006001201','2014-04-01','2014-02-20 13:00:00','33.00',NULL,NULL,'245.84','212.84','R-OH004','OH0','245.84',NULL,0,'2014-02-20 22:01:39'),(26132,20724,'N','19','021','EC','A',NULL,NULL,'','0000911816','0000401294','','IL','1','MOTE','AMBERLIN','','','','34','293022868','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1997-12-10','F','',':RET:2106-3','N','021','DEN','3709810','99734OH005000401','2014-03-01','2014-02-27 12:17:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:23'),(28496,22548,'Y','18','021','EC','A','','','AC','0001215614','0001215614','MS00002753113','IL','1','Mcqueen','Florine','','','','34','427048405','1055 Quinn Street',0,'Jackson','MS','39202',NULL,'CY','28049','1956-03-24','F','U',':RET:2054-5','N','021','DEN','2947087','46300MS002000201','2014-04-01','2014-03-07 16:16:56','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-07 21:31:45'),(5973,4729,'Y','18','021','EC','A','','','AC','0001109228','0001109228','OH00001409029','IL','1','Maxey','Dean','','','','34','276548147','10764 HOEL RD',0,'CAMDEN','OH','45311','8651','CY','39135','1953-08-01','M','M',':RET:2106-3','N','021','HLT','1484156','92036OH001000501','2014-01-01','2013-12-23 22:44:15','322.00',NULL,NULL,'778.17','456.17','R-OH003','OH0','778.17',NULL,0,'2013-12-25 23:51:42'),(1657,1384,'Y','18','021','EC','A','','','AC','0001156066','0001156066','TX00001363188','IL','1','PEREZ','CARMELO','J','','','34','452710576','521 W ELM ST',0,'HILLSBORO','TX','76645','2007','CY','48217','1962-04-22','M','U',NULL,'N','021','DEN','2297461','33348TX002000201','2014-01-01','2013-12-24 17:01:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:31'),(9668,7660,'Y','18','024','14','A','','','TE','0000317317','0000317317','','IL','1','Minge','Donna','Jean',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-04','F','',NULL,NULL,NULL,'','283194','','2013-12-21','2013-12-21 07:29:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:09'),(9107,7229,'N','19','021','EC','A',NULL,NULL,'','0001135152','0000792211','','IL','1','Cremeans','Jamie','','','','34','877673426','46343 Scout Camp Rd',0,'Chester','OH','45720',NULL,'CY','39105','2011-10-21','M','',':RET:2106-3','N','021','DEN','2250070','99734OH005000301','2014-01-01','2013-12-18 15:33:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:32'),(15720,12576,'Y','18','021','EC','A','','','AC','0001128010','0001128010','OH00001748176','IL','1','Jamison','Jessika','','','','34','269025932','160 HICKORY HILLS DR',0,'SPRINGBORO','OH','45066','8625','CY','39165','1975-12-03','F','R',':RET:2106-3','N','021','DEN','1945838','99734OH005000301','2014-02-01','2014-01-02 14:21:21','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:00:12'),(18394,14679,'N','19','021','EC','A',NULL,NULL,'','0000246475','0000783262','','IL','1','Stone','Leah','','','','34','275150878','237 OPAL BLVD',0,'STEUBENVILLE','OH','43952','2330','CY','39081','2009-01-30','F','',':RET:2106-3','N','021','DEN','2849573','99734OH005000301','2014-02-01','2014-01-15 17:09:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:41'),(18499,14755,'Y','18','021','EC','A','','','AC','0000182320','0000182320','OH00001524086','IL','1','SANDERSON','IAN','','','','34','278805813','5759 FRANK RD NW',0,'NORTH CANTON','OH','44720','7541','CY','39151','1981-01-16','M','U',':RET:2106-3','N','021','HLT','1557245','52664OH151001306','2014-02-01','2014-01-15 16:37:55','174.00',NULL,NULL,'267.16','93.16','R-OH015','OH0','267.16',NULL,0,'2014-01-16 08:46:29'),(21392,17094,'Y','18','021','EC','A','','','AC','0001059507','0001059507','OH00002223839','IL','1','Wittenauer','Beth','','','','34','271683322','518 West Liberty St.',0,'Hubbard','OH','44425',NULL,'CY','39155','1961-04-25','F','U',':RET:2106-3','N','021','DEN','3440442','99734OH005000401','2014-03-01','2014-02-04 10:13:59','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-04 21:00:57'),(23256,18541,'Y','18','021','EC','A','','','AC','0000423934','0000423934','TX00002339176','IL','1','MEMON','MEHRIN','','','','34','354903683','13002 HALWIN CIR',0,'DALLAS','TX','75243',NULL,'CY','48113','1980-06-24','F','M',':RET:2028-9','N','021','DEN','3170222','33348TX002000201','2014-03-01','2014-02-13 00:26:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-13 21:30:08'),(23339,18602,'Y','18','021','EC','A','','','AC','0000359724','0000359724','OH00002239666','IL','1','NIXON','SONA','','','','34','203633320','3867 W MARKET ST',0,'FAIRLAWN','OH','44333',NULL,'CY','39153','1982-05-02','F','M',NULL,'N','021','HLT','3508268','52664OH151001304','2014-03-01','2014-02-12 19:04:09','56.00',NULL,NULL,'258.47','202.47','R-OH012','OH0','258.47',NULL,0,'2014-02-13 22:00:36'),(24123,19175,'Y','18','021','EC','A','','','AC','0001676519','0001676519','LA00002031534','IL','1','Hawkins','Brittney','','','','34','434732353','8120 W JUDGE PEREZ DR',0,'CHALMETTE','LA','70043','1693','CY','22087','1988-11-21','F','U',':RET:2054-5','N','021','DEN','2688647','18575LA002000101','2014-03-01','2014-02-14 23:59:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-15 22:01:43'),(26327,20887,'Y','18','021','EC','A','','','AC','0000878054','0000878054','MS00003174471','IL','1','Henry','Frank','','','','34','425755173','104 S MORGAN ST',0,'POPLARVILLE','MS','39470','2512','CY','28109','1992-11-19','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','3867613','46300MS002000101','2014-03-01','2014-02-27 16:19:28','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-28 06:31:38'),(5448,4328,'Y','18','021','EC','A','','','AC','0000203071','0000203071','OH00000038927','IL','1','NEWMAN','ROBERT','E','','III','34','296565466','3404 BRIGHAM ST',0,'TOLEDO','OH','43608','1604','CY','39095','1963-09-23','M','U',':RET:2054-5','T','021','HLT','2263427','92036OH004002601','2014-01-01','2013-12-19 16:12:56','50.00',NULL,NULL,'322.03','272.03','R-OH001','OH0','322.03',NULL,0,'2013-12-25 23:10:06'),(15381,12304,'Y','18','021','EC','A','','','AC','0000983842','0000983842','OH00001647599','IL','1','Chapman','Robert','','','Jr','34','274889193','1088 KIRKWALL DR',0,'COPLEY','OH','44321','1727','CY','39153','1980-01-07','M','M',':RET:2106-3','N','021','HLT','2554510','52664OH151001305','2014-02-01','2014-01-01 10:32:09','277.00',NULL,NULL,'537.89','260.89','R-OH012','OH0','270.73',NULL,1,'2014-01-02 04:25:26'),(14643,11686,'N','01','021','EC','A',NULL,NULL,'','0000848367','0001057284','','IL','1','Moser','Gregory','','','','34','460637362','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1971-06-01','M','',':RET:2106-3','N','021','DEN','2409236','33348TX002000101','2014-02-01','2013-12-27 19:15:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,1,'2013-12-29 11:07:30'),(15733,12585,'Y','18','021','EC','A','','','AC','0000648341','0000648341','OH00002024714','IL','1','HICKS','MADISON','','','','34','270946896','2903 S MAIN ST',0,'AKRON','OH','44319','1848','CY','39153','1991-03-06','F','U',':RET:2106-3','N','021','DEN','2297676','99734OH005000301','2014-02-01','2014-01-02 11:21:08','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-03 02:00:34'),(15793,12641,'Y','18','021','EC','A','','','AC','0001861376','0001861376','LA00000436492','31','1','WILLIS','TAMMY','','','','34','435553140','PO BOX 7279',0,'BELLE CHASSE','LA','70037',NULL,'CY','22075','1982-10-01','F','U',':RET:2106-3','N','021','DEN','2438844','18575LA002000201','2014-02-01','2014-01-02 16:01:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:34'),(16721,13382,'Y','18','021','EC','A','','','AC','0001056308','0001056308','TX00001852222','IL','1','Edwards','Clarince','','','','34','455635326','2927 6TH ST',0,'PORT ARTHUR','TX','77642','4716','CY','48245','1964-04-02','M','U',':RET:2054-5','N','021','DEN','2122700','33348TX002000201','2014-02-01','2014-01-07 17:27:20','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-01-08 18:24:46'),(20996,16777,'Y','18','021','EC','A','','','AC','0000424062','0000424062','OH00002212212','IL','1','Dick','Susan','','','','34','283604889','151 Allen Ave',0,'Powhatan Point','OH','43942',NULL,'CY','39013','1959-10-26','F','U',NULL,'T','021','DEN','3293712','99734OH005000301','2014-03-01','2014-02-01 12:22:50','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-02-01 19:00:27'),(24438,19411,'Y','18','021','EC','A','','','AC','0000310910','0000310910','OH00002782574','IL','1','CORNELIUS','CHRISTOPHER','','','','34','250872538','678 S WALNUT ST',0,'RAVENNA','OH','44266','3153','CY','39133','1991-08-21','M','U',NULL,'T','021','HLT','2753647','52664OH151001305','2014-04-01','2014-02-18 16:17:59','133.00',NULL,NULL,'256.46','123.46','R-OH012','OH0','256.46',NULL,0,'2014-02-18 22:01:17'),(28131,22261,'Y','18','021','EC','A','','','AC','0000163740','0000163740','OH00003242302','IL','1','OROURKE','CAROLYN','','','','34','290869653','3314 BEECHWOOD DR',0,'HUBBARD','OH','44425','1325','CY','39155','1975-12-31','F','U',':RET:2106-3','N','021','HLT','4102661','52664OH151001305','2014-04-01','2014-03-06 12:03:02','169.00',NULL,NULL,'315.11','146.11','R-OH013','OH0','315.11',NULL,0,'2014-03-06 21:02:24'),(100,89,'Y','18','021','EC','A','','','AC','0001159508','0001159508','TX00000420603','IL','1','Teltschik','Randy','L','','','34','454270080','952 MYRTA ST',0,'KERRVILLE','TX','78028','3307','CY','48265','1964-08-31','M','U',':RET:2106-3','N','021','DEN','8988','33348TX002000201','2014-01-01','2013-12-05 13:31:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:17:42'),(15446,12360,'Y','18','021','EC','A','','','AC','0000549440','0000549440','TX00000785536','IL','1','Holley','George','','','','34','498648994','3205 Morning Glory Dr. Apt. A',0,'Temple','TX','76502',NULL,'CY','48027','1953-10-16','M','M',':RET:2054-5','N','021','DEN','2415396','33348TX002000201','2014-02-01','2013-12-31 14:49:47','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,1,'2014-01-02 04:28:13'),(13812,11024,'Y','18','021','EC','A','','','AC','0000200762','0000200762','OH00001024753','IL','1','Sheal','Jennifer','','','','34','287801012','10145 PIPPIN RD',0,'CINCINNATI','OH','45231','2031','CY','39061','1983-03-02','F','U',':RET:2106-3','N','021','HLT','1717345','92036OH005001206','2014-01-01','2013-12-23 06:44:32','188.00',NULL,NULL,'243.66','55.66','R-OH004','OH0','243.66',NULL,0,'2013-12-26 13:11:38'),(13602,10848,'Y','18','021','EC','A','','','AC','0000616868','0000616868','OH00000007890','IL','1','Welch','Thomas','','','','34','297900890','20659 WETZEL RD',0,'FORT JENNINGS','OH','45844','9417','CY','39161','1985-08-10','M','U',':RET:2106-3','T','021','HLT','2255548','92036OH003001505','2014-01-01','2013-12-23 14:28:40','140.00',NULL,NULL,'287.32','147.32','R-OH002','OH0','287.32',NULL,0,'2013-12-26 13:05:27'),(13171,10506,'Y','18','021','EC','A','','','AC','0000655816','0000655816','OH00000620640','IL','1','JUSTICE','JOE','B','','','34','293768007','192 NORTHPARK DR',0,'WADSWORTH','OH','44281','1310','CY','39103','1979-01-23','M','M',NULL,'T','021','DEN','2559530','99734OH005000401','2014-01-01','2013-12-23 18:37:10','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:54:03'),(13102,10446,'Y','18','021','EC','A','','','AC','0001194121','0001194121','OH00000519508','IL','1','Dalton','Lauren','','','','34','302905197','517 HOGE ST',0,'CINCINNATI','OH','45226','1106','CY','39061','1987-11-25','F','U',':RET:2106-3','N','021','DEN','1704887','99734OH005000401','2014-01-01','2013-12-23 13:00:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:11'),(9737,7710,'Y','18','021','EC','A','','','AC','0001150864','0001150864','TX00000552337','IL','1','guajardo','sherry','','','','34','452337714','4834 U S HIGHWAY 59 N',0,'LIVINGSTON','TX','77351','0254','CY','48373','1963-06-23','F','M',':RET:2106-3','N','021','DEN','250273','33348TX002000201','2014-01-01','2013-11-14 22:46:25','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:45:49'),(9535,7558,'Y','18','021','EC','A','','','AC','0000442169','0000442169','OH00000823164','IL','1','Hayes','Cheryl','','','','34','271703116','2857 Lovers Lane',0,'Ravenna','OH','44266',NULL,'CY','39133','1963-12-19','F','M',':RET:2106-3','N','021','DEN','2528190','99734OH005000301','2014-01-01','2013-12-21 10:54:40','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:35:53'),(5265,4176,'Y','18','021','EC','A','','','AC','0000247884','0000247884','OH00000829552','IL','1','COOK','TONYA','L','','','34','281721871','1943 NEWTON ST',0,'ARKON','OH','44305',NULL,'CY','39153','1969-01-30','F','U',':RET:2106-3','N','021','HLT','2264637','52664OH151001305','2014-01-01','2013-12-19 11:24:57','179.00',NULL,NULL,'311.54','132.54','R-OH012','OH0','311.54',NULL,0,'2013-12-25 23:05:27'),(4166,3317,'N','01','021','EC','A',NULL,NULL,'','0000571981','0000250235','','IL','1','Gallagher-Conley','Catherine','','','','34','295561048','9771 RAVENNA AVE',0,'LOUISVILLE','OH','44641','9778','CY','39151','1955-02-23','F','',':RET:2106-3','N','021','DEN','1918172','99734OH005000301','2014-01-01','2013-12-17 16:10:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:49:07'),(15777,12626,'Y','18','021','EC','A','','','AC','0000963388','0000963388','TX00000182899','IL','1','Wilson','Peace','','','','34','463710265','8212 IRON BRIDGE RD',0,'BURTON','TX','77835','2474','CY','48477','1985-01-26','F','U',':RET:2054-5','N','021','DEN','1910579','33348TX002000201','2014-02-01','2014-01-02 15:55:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:02:01'),(17562,14042,'Y','18','024','14','A','','','TE','0001809817','0001809817','','IL','1','Hemani','Hussain',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-06-23','M','',NULL,NULL,NULL,'','2193823','','2014-01-12','2014-01-12 17:33:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 03:02:02'),(20270,16175,'Y','18','021','EC','A','','','AC','0001057988','0001057988','OH00002037408','IL','1','Mudd','Gabriel','Kirk','','','34','258510568','4956 WINDY RIDGE CT',0,'LIBERTY TWP','OH','45011','0414','CY','39017','1984-08-14','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2661664','99734OH005000301','2014-03-01','2014-01-28 17:11:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-28 21:00:22'),(21519,17193,'Y','18','021','EC','A','','','AC','0000784935','0000784935','MS00001601716','IL','1','Ingram','Susan','','','','34','587969646','734 MEADOWBROOK RD',0,'GRENADA','MS','38901','9788','CY','28043','1957-05-25','F','M',':RET:2106-3','N','021','DEN','3202671','46300MS002000101','2014-03-01','2014-02-05 15:31:13','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15','CIC',0,'2014-02-05 21:00:06'),(22087,17630,'Y','18','021','EC','A','','','AC','0001507644','0001507644','LA00002247082','IL','1','CARDENTEY','IVAN','','','','34','770345031','3320 WALL BLVD',0,'GRETNA','LA','70056','8634','CY','22051','1981-02-18','M','U',NULL,'N','021','DEN','3768854','18575LA002000101','2014-03-01','2014-02-08 17:52:31','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-08 19:00:22'),(24105,19163,'Y','18','021','EC','A','','','AC','0000911147','0000911147','TX00001916658','IL','1','Ezell','Sandra','','','','34','461946295','6227 HOTT SPRINGS DR',0,'ARLINGTON','TX','76001','5052','CY','48439','1952-03-11','F','U',':RET:2106-3','N','021','DEN','3233151','33348TX002000201','2014-03-01','2014-02-14 19:02:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:33'),(24355,19344,'Y','18','024','14','A','','','TE','0002140691','0002140691','','IL','1','DUCOTE','ROBBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-14','M','',NULL,NULL,NULL,'','3005154','','2014-02-18','2014-02-18 06:21:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-18 22:00:29'),(28143,22271,'Y','18','021','EC','A','','','AC','0001031516','0001031516','OH00002957183','31','1','JONES','MARILYN','','','','34','296564292','PO BOX 141001',0,'TOLEDO','OH','43614',NULL,'CY','39095','1956-03-31','F','U',':RET:2054-5^:RET:2106-3','N','021','HLT','3906049','92036OH006002601','2014-04-01','2014-03-06 16:50:50','382.00',NULL,NULL,'394.02','12.02','R-OH001','OH0','394.02',NULL,0,'2014-03-06 21:02:32'),(911,756,'Y','18','021','EC','A','','','AC','0000963205','0000963205','OH00000767744','IL','1','Matthews','Janice','','','','34','281568676','228 Austin St',0,'Toledo','OH','43608',NULL,'CY','39095','1954-02-14','F','U',':RET:2106-3','N','021','HLT','2461749','92036OH004002601','2014-01-01','2013-12-16 14:17:12','377.00',NULL,NULL,'408.14','31.14','R-OH001','OH0','408.14',NULL,0,'2013-12-25 18:08:33'),(15027,12010,'Y','18','021','EC','A','','','AC','0002380014','0002380014','LA00001832834','IL','1','forbes','andre','','','Sr','34','303784692','10795 MEAD RD',0,'BATON ROUGE','LA','70816','2190','CY','22033','1962-01-12','M','U',':RET:2054-5','N','021','DEN','1936640','18575LA002000201','2014-02-01','2013-12-30 00:02:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:02:30'),(14473,11547,'N','01','021','EC','A',NULL,NULL,'','0001029136','0000508848','','IL','1','Urquieta','Guadalupe','Lizeth','','','34','637724605','3144 LEOPARD ST',0,'BROWNSVILLE','TX','78521','4541','CY','48061','1981-11-06','F','',NULL,'N','021','DEN','1623484','33348TX002000201','2014-02-01','2013-12-26 19:20:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:33:04'),(19054,15177,'Y','18','021','EC','A','','','AC','0000884248','0000884248','OH00001763974','IL','1','NEWCOMB','TERRY','','','','34','271523134','5915 BENALEX DR',0,'TOLEDO','OH','43612','4407','CY','39095','1951-03-15','M','M',':RET:2106-3','N','021','HLT','1606130','92036OH004002601','2014-03-01','2014-01-17 15:26:25','156.00',NULL,NULL,'450.46','294.46','R-OH001','OH0','450.46',NULL,0,'2014-01-20 08:06:47'),(20903,16708,'Y','18','021','EC','A','','','AC','0000349297','0000349297','OH00001740941','IL','1','Mitchell','Lindsey',NULL,NULL,NULL,NULL,NULL,'1457 KARL DR',0,'COPLEY','OH','44321','1954','CY','39153','1987-10-01','F','U',':RET:2106-3','N','021','DEN','3175373','99734OH005000401','2014-03-01','2014-01-31 15:38:42','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-31 21:01:22'),(21521,17194,'Y','18','024','14','A','','','TE','0000784935','0000784935','','IL','1','Ingram','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-25','F','',NULL,NULL,NULL,'','313948','','2014-02-28','2014-02-05 15:31:12',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-05 21:00:07'),(22006,17569,'N','19','021','EC','A',NULL,NULL,'','0000273834','0000790910','','IL','1','Harbeson','Juliet',NULL,NULL,NULL,NULL,NULL,'3894 WINTER HILL DR',0,'HAMILTON','OH','45011','6421','CY','39017','2010-08-09','F','',NULL,'N','021','DEN','3480609','99734OH005000301','2014-03-01','2014-02-06 23:05:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:49'),(22348,17848,'Y','18','021','EC','A','','','AC','0000818608','0000818608','OH00002301199','IL','1','venegas','eduardo','','','','34','631485190','317 CEDAR ST',0,'PORT CLINTON','OH','43452','1235','CY','39123','1976-12-09','M','M',NULL,'T','021','HLT','2387147','92036OH004002701','2014-03-01','2014-01-24 11:19:31','145.53',NULL,NULL,'223.22','77.69','R-OH006','OH0','223.22',NULL,0,'2014-02-10 11:01:13'),(24314,19309,'Y','18','021','EC','A','','','AC','0000497211','0000497211','TX00001813230','IL','1','Leon','Karina','','','','34','633947066','3650 Sunflower lane',0,'Belton','TX','76513',NULL,'CY','48027','1988-03-29','F','M',':RET:2106-3','N','021','DEN','3519241','33348TX002000201','2014-04-01','2014-02-17 21:35:50','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-18 22:00:04'),(24905,19745,'Y','18','021','EC','A','','','AC','0000047108','0000047108','TX00003003459','31','1','DE SANTIAGO','JOSE','','','','34','635807448','4106 CHAPELLE AVE',0,'PICO RIVERA','CA','90660',NULL,'CY','48141','1943-03-24','M','M',NULL,'N','021','DEN','2640473','33348TX002000201','2014-04-01','2014-02-20 17:47:08','0.00',NULL,NULL,'16.22','16.22','R-TX009','TX0','16.22','CIC',0,'2014-02-20 21:30:04'),(519,424,'Y','18','021','EC','A','','','AC','0000585506','0000585506','OH00000393868','IL','1','May','Joelle','','','','34','290740752','326 N Walnut Street',0,'Van Wert','OH','45891',NULL,'CY','39161','1966-10-15','F','M',':RET:2106-3','N','021','DEN','602152','99734OH005000301','2014-01-01','2013-12-04 16:38:38','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 17:49:09'),(24563,19509,'Y','18','021','EC','A','','','AC','0000737910','0000737910','OH00002446935','IL','1','grubb','danny','','','','34','401278536','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1969-06-18','M','M',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:06:32'),(25662,20359,'Y','18','021','EC','A','','','AC','0000488044','0000488044','OH00001813331','IL','1','Stenger','Brian','','','','34','298806240','11805 SPENCER PARK DR',0,'HIRAM','OH','44234','9707','CY','39133','1980-09-29','M','U',NULL,'N','021','HLT','3676149','52664OH152000901','2014-04-01','2014-02-22 15:53:39','0.00',NULL,NULL,'195.68','195.68','R-OH012','OH0','195.68',NULL,0,'2014-02-26 08:30:45'),(26088,20689,'Y','18','021','EC','A','','','AC','0002084507','0002084507','LA00003277268','31','1','Casler','Kyle','','','','34','457698046','po box 770256',0,'New Orleans','LA','70177',NULL,'CY','22071','1976-12-07','M','U',':RET:2106-3','N','021','DEN','3745581','18575LA002000201','2014-04-01','2014-02-26 23:29:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:07'),(27087,21445,'Y','18','021','EC','A','','','AC','0000436665','0000436665','OH00002680948','IL','1','Cook','Lauri','','','','34','288742501','305 WONDER LAKE DR',0,'AKRON','OH','44319','3853','CY','39153','1962-11-13','F','M',':RET:2106-3','N','021','HLT','2796735','52664OH151001301','2014-04-01','2014-03-03 11:49:21','252.00',NULL,NULL,'638.92','386.92','R-OH012','OH0','415.91',NULL,0,'2014-03-03 21:30:15'),(27722,21923,'Y','18','021','EC','A','','','AC','0000011678','0000011678','TX00003003829','IL','1','Williams','Shaun-Patrice','','','','34','622767485','12513 SANDPIPER',0,'LIVE OAK','TX','78233','2735','CY','48029','1989-07-18','F','U',NULL,'N','021','DEN','3278880','33348TX002000201','2014-04-01','2014-03-05 14:26:05','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-05 21:30:59'),(9410,7466,'Y','18','021','EC','A','','','AC','0000686673','0000686673','TX00000294052','IL','1','Deal','Christopher','','','','34','237698962','2306 BROOKHILL DR',0,'AUSTIN','TX','78745','3553','CY','48453','1985-08-11','M','U',':RET:2106-3','N','021','DEN','1521590','33348TX002000201','2014-01-01','2013-12-21 12:18:09','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:32:51'),(16628,13302,'N','01','021','EC','A',NULL,NULL,'','0001008959','0000691846','','IL','1','Dwertman','Christa','','','','34','291562077','4444 SHIRE MILL RD',0,'HILLIARD','OH','43026','2733','CY','39049','1969-06-01','F','',NULL,'N','021','DEN','2261880','99734OH005000401','2014-02-01','2014-01-07 16:18:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:13'),(23093,18409,'N','01','021','EC','A',NULL,NULL,'','0000449909','0001031494','','IL','1','Podgorski','Joy','','','','34','438352424','4419 W 56TH ST',0,'CLEVELAND','OH','44144','2914','CY','39035','1976-09-15','F','',':RET:2106-3','N','021','DEN','3631141','99734OH005000401','2014-03-01','2014-02-12 13:13:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:08'),(23295,18570,'N','19','021','EC','A',NULL,NULL,'','0000407418','0000404844','','IL','1','Perry-Moore','Arianna','','','','34','361882838','1779 Rockland Avenue',0,'Rocky River','OH','44116',NULL,'CY','39035','1993-10-10','F','',':RET:2106-3','N','021','DEN','3414101','99734OH005000301','2014-03-01','2014-02-12 23:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:10'),(24371,19357,'Y','18','021','EC','A','','','AC','0001697898','0001697898','LA00002024413','IL','1','Faciane','Mary','','','','34','436906536','27191 JACKSON ST',0,'LACOMBE','LA','70445','4635','CY','22103','1950-11-10','F','U',':RET:2054-5','N','021','DEN','3529529','18575LA002000201','2014-04-01','2014-02-18 15:49:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:38'),(26276,20843,'Y','18','021','EC','A','','','AC','0001766783','0001766783','LA00002335739','IL','1','FORD','ABBY','','','','34','433653365','1611 Hicks Frazier Rd',0,'Farmerville','LA','71241',NULL,'CY','22111','1981-09-04','F','U',':RET:2106-3','N','021','DEN','2865907','18575LA002000101','2014-04-01','2014-02-26 20:13:53','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-28 06:31:18'),(28782,22783,'N','19','021','EC','A',NULL,NULL,'','0000221388','0001081879','','IL','1','Willis','Marcus','X','','','34','269985893','732 Bellingham Ct',0,'Worthington','OH','43085',NULL,'CY','39049','1994-05-05','M','',':RET:2054-5','N','021','DEN','2822386','99734OH005000401','2014-04-01','2014-03-09 16:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:36'),(28958,22918,'Y','18','021','EC','A','','','AC','0001214445','0001214445','LA00003078211','IL','1','CLARK','YAZA','','','','34','433273166','8912 APRICOT STREET',0,'NEW ORLEANS','LA','70118',NULL,'CY','22071','1959-12-08','F','U',NULL,'N','021','DEN','2876133','18575LA002000201','2014-04-01','2014-03-10 12:27:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:54'),(5977,4732,'Y','18','021','EC','A','','','AC','0000570561','0000570561','OH00000463900','IL','1','Lowe','Lester','F','','Jr','34','268765189','453 SEAMAN AVE',0,'AKRON','OH','44305','3850','CY','39153','1977-08-15','M','U',':RET:2106-3','N','021','HLT','1788566','52664OH151001501','2014-01-01','2013-12-24 01:12:55','105.00',NULL,NULL,'328.98','223.98','R-OH012','OH0','328.98',NULL,0,'2013-12-25 23:51:50'),(14684,11724,'Y','18','021','EC','A','','','AC','0000484800','0000484800','OH00001819653','IL','1','Lengel','Joseph','','','','34','269486487','16284 Forgehill Dr.',0,'Garrettsville','OH','44231',NULL,'CY','39055','1952-12-01','M','M',':RET:2106-3','N','021','DEN','1521995','99734OH005000401','2014-02-01','2013-12-28 12:14:37','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:08:40'),(1291,1068,'Y','18','021','EC','A','','','AC','0000418863','0000418863','OH00001161943','IL','1','HENRY','LLOYD','','','','34','306506515','84 RAVENNA ST',0,'HUDSON','OH','44236','3064','CY','39153','1949-08-06','M','M',':RET:2106-3','T','021','DEN','1098011','99734OH005000301','2014-01-01','2013-11-29 15:09:44','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:30:53'),(2753,2228,'Y','18','021','EC','A','','','AC','0000249092','0000249092','OH00000928133','IL','1','LUOMA','ERIN','ANNE','','','34','298867052','910 E 15TH ST',0,'ASHTABULA','OH','44004','3624','CY','39007','1973-06-29','F','M',':RET:2106-3','N','021','HLT','1247802','52664OH151001305','2014-01-01','2013-12-02 11:34:55','600.00',NULL,NULL,'1006.83','406.83','R-OH011','OH0','321.44',NULL,0,'2013-12-25 19:49:08'),(13504,10762,'Y','18','021','EC','A','','','AC','0001893010','0001893010','LA00001087909','IL','1','johnson','edna','','','','34','435944424','2557 SENECA ST',0,'BATON ROUGE','LA','70805','8209','CY','22033','1954-12-27','F','M',':RET:2054-5','N','021','DEN','1517063','18575LA002000201','2014-01-01','2013-12-22 19:40:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:02:40'),(2158,1775,'Y','18','021','EC','A','','','AC','0000062731','0000062731','LA00000211318','IL','1','Knichen','Monique','','','','34','438134308','446 Bay Street',0,'Denham Springs','LA','70726',NULL,'CY','22063','1968-04-29','F','U',':RET:2054-5','N','021','DEN','889025','18575LA002000101','2014-01-01','2013-12-10 17:34:15','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 19:18:47'),(7900,6245,'N','01','021','EC','A',NULL,NULL,'','0000162261','0001095643','','IL','1','Luedeke','Jenny','','','','34','298549361','2100 Celina Road Lot 13',0,'Saint Marys','OH','45885',NULL,'CY','39011','1955-10-17','F','',':RET:2106-3','N','021','HLT','1595691','92036OH003001505','2014-01-01','2013-12-20 16:34:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','585.61',NULL,0,'2013-12-26 03:05:47'),(7795,6173,'Y','18','024','14','A','','','TE','0000145649','0000145649','','IL','1','casillas','janet','torres',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-10','F','',NULL,NULL,NULL,'','2134346','','2013-12-20','2013-12-20 15:38:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:31'),(6857,5437,'Y','18','021','EC','A','','','AC','0000058720','0000058720','OH00000822314','IL','1','Morgan','Esther','','','','34','294686296','10214 SIMMS STATION RD',0,'DAYTON','OH','45458','9401','CY','39113','1971-11-01','F','U',NULL,'N','021','DEN','679286','99734OH005000401','2014-01-01','2013-10-04 20:41:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:31:34'),(16181,12955,'Y','18','021','EC','A','','','AC','0000839981','0000839981','TX00002152348','IL','1','HOLT','JUSTIN','','','','34','453859596','5657 AMESBURY DR',0,'DALLAS','TX','75206','3000','CY','48113','1983-02-20','M','U',':RET:2106-3','N','021','DEN','2336509','33348TX002000201','2014-02-01','2014-01-03 18:45:05','0.00',NULL,NULL,'56.37','56.37','R-TX008','TX0','15.85',NULL,0,'2014-01-05 00:00:32'),(18687,14897,'N','01','021','EC','A',NULL,NULL,'','0002015318','0001306119','','IL','1','Clavo','Alonzo','J','','Sr','34','436293805','6300 MORRISON RD',0,'NEW ORLEANS','LA','70126','1511','CY','22071','1974-09-15','M','',':RET:2054-5','N','021','DEN','1437482','18575LA002000101','2014-02-01','2014-01-15 22:05:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-17 03:35:23'),(19433,15492,'Y','18','021','EC','A','','','AC','0000376165','0000376165','OH00001885037','IL','1','rodarmel','megan','','','','34','308066560','2375 DORR ST',0,'TOLEDO','OH','43607','3407','CY','39095','1989-02-11','F','M',NULL,'N','021','HLT','2207733','92036OH003002605','2014-03-01','2014-01-21 12:56:38','188.00',NULL,NULL,'408.08','220.08','R-OH001','OH0','204.45',NULL,1,'2014-01-22 03:23:09'),(19452,15504,'N','01','021','EC','A',NULL,NULL,'','0000234077','0001225737','','IL','1','MICHEL','DALE','W','','','34','284740200','764 FROOME AVE',0,'CINCINNATI','OH','45232','1745','CY','39061','1963-04-08','M','',':RET:2106-3','N','021','DEN','2870281','99734OH005000301','2014-03-01','2014-01-22 17:38:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:01:53'),(20929,16726,'Y','18','021','EC','A','','','AC','0000721120','0000721120','MS00002067349','IL','1','Adams','Vanessa','','','','34','428415949','6300 old Canton road',0,'jackson','MS','39211',NULL,'CY','28049','1968-02-14','F','U',NULL,'N','021','DEN','2785047','46300MS002000201','2014-03-01','2014-01-31 17:09:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-31 21:01:36'),(21691,17320,'Y','18','021','EC','A','','','AC','0002188709','0002188709','LA00001839611','IL','1','Chustz','Jake','','','','34','438531933','4125 LORRAINE ST',0,'BATON ROUGE','LA','70805','2928','CY','22033','1984-05-07','M','U',':RET:2106-3','N','021','DEN','3569176','18575LA002000101','2014-03-01','2014-02-05 13:54:41','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-05 21:31:06'),(24282,19284,'Y','18','024','14','A','','','TE','0000317358','0000317358','','IL','1','Barrington','Dennis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-30','M','',NULL,NULL,NULL,'','2141792','','2014-02-28','2014-02-18 17:04:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:07'),(26411,20946,'Y','18','021','EC','A','','','AC','0000027561','0000027561','TX00002376488','IL','1','Lively','Rachel','','','','34','459919325','2013 SE 12TH ST',0,'MINERAL WELLS','TX','76067','6627','CY','48363','1987-09-14','F','M',':RET:2106-3','N','021','DEN','3100857','33348TX002000201','2014-04-01','2014-02-26 15:36:09','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61','CIC',0,'2014-02-28 07:00:39'),(3715,2972,'Y','18','021','EC','A','','','AC','0001165319','0001165319','OH00001102107','IL','1','Anaya','Maura','','','','34','251843487','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1964-05-22','F','M',':RET:2106-3','T','021','DEN','210262','99734OH005000401','2014-01-01','2013-12-13 14:59:18','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:32:17'),(15973,12783,'N','01','021','EC','A',NULL,NULL,'','0001234240','0000536218','','IL','1','RODRIGUEZ','MARY ANN','','','','34','280660154','413 E JACKSON ST',0,'LEVELLAND','TX','79336','2513','CY','48219','1957-11-14','F','',NULL,'N','021','DEN','2361547','33348TX002000201','2014-02-01','2014-01-02 21:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:00:39'),(15757,12607,'Y','18','024','14','A','','','TE','0000329351','0000329351','','IL','1','Washington','Damion',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-07-07','M','',NULL,NULL,NULL,'','2535100','','2014-01-01','2014-01-01 20:45:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-03 02:01:22'),(14820,11838,'Y','18','021','EC','A','','','AC','0000860687','0000860687','TX00000959984','IL','1','Borromeo','Marjoe','Quijano','','','34','241156204','15707 Pinyon Creek Dr',0,'Houston','TX','77095',NULL,'CY','48201','1967-01-30','M','R',':RET:2036-2','N','021','DEN','2013174','33348TX002000101','2014-01-01','2013-12-23 20:51:58','0.00',NULL,NULL,'128.55','128.55','R-TX010','TX0','27.15',NULL,1,'2013-12-29 11:14:19'),(14038,11183,'Y','18','021','EC','A','','','AC','0000656931','0000656931','OH00000454166','IL','1','Hesser','Carol','','','','34','301685421','5663 Mellie Ave',0,'Milford','OH','45150',NULL,'CY','39025','1960-01-12','F','U',':RET:2106-3','T','021','HLT','1672662','92036OH006000601','2014-01-01','2013-12-23 19:14:18','318.00',NULL,NULL,'399.40','81.40','R-OH005','OH0','399.40',NULL,0,'2013-12-26 13:17:05'),(6324,5014,'Y','18','021','EC','A','','','AC','0000180980','0000180980','OH00000308243','IL','1','firm','edward','','','','34','268500507','492 fairview hts.',0,'toronto','OH','43964',NULL,'CY','39081','1949-02-17','M','M',':RET:2106-3','N','021','DEN','570278','99734OH005000401','2014-01-01','2013-12-11 11:16:45','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 00:46:26'),(13231,10556,'Y','18','024','14','A','','','TE','0001099168','0001099168','','IL','1','Mixon','Thelma','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-23','F','',NULL,NULL,NULL,'','2075972','','2013-12-22','2013-12-22 21:57:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:55:45'),(16318,13065,'Y','18','021','EC','A','','','AC','0001486211','0001486211','LA00001433470','IL','1','JARREAU','CHERYL','','','','34','439089555','12944 PECAN ST',0,'PORT ALLEN','LA','70767','5531','CY','22121','1956-05-04','F','M',':RET:2106-3','N','021','DEN','2316086','18575LA002000201','2014-02-01','2014-01-06 16:45:44','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:37'),(18206,14530,'N','19','021','EC','A',NULL,NULL,'','0000486963','0001205833','','IL','1','Kurtz','Adelynn','','','','34','145570905','9278 LIBERTY RD',0,'TWINSBURG','OH','44087','1834','CY','39153','2011-11-16','F','',NULL,'N','021','HLT','1523644','52664OH152001001','2014-02-01','2014-01-14 14:15:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','77.86',NULL,0,'2014-01-15 02:08:08'),(19035,15160,'Y','18','021','EC','A','','','AC','0000895750','0000895750','MS00001709214','IL','1','MACOY','BECKEY','SWEETLAND','','','34','292824257','631 MARILYN DR',0,'PEARL','MS','39208','2902','CY','28121','1980-08-31','F','M',':RET:2106-3','T','021','DEN','3084998','46300MS002000201','2014-03-01','2014-01-17 14:22:40','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-20 08:06:34'),(20371,16272,'Y','18','021','EC','A','','','AC','0002074907','0002074907','LA00002161939','IL','1','JOHNSON','WANDA','M','','','34','436170775','7510 VANDERKLOOT AVE',0,'NEW ORLEANS','LA','70127','1648','CY','22071','1961-01-23','F','U',NULL,'N','021','DEN','2919515','18575LA002000101','2014-03-01','2014-01-29 09:40:00','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-29 21:00:05'),(20545,16418,'Y','18','024','14','A','','','TE','0000240376','0000240376','','IL','1','Traxler','Mary','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-08','F','',NULL,NULL,NULL,'','2117887','','2014-01-29','2014-01-29 10:02:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:38'),(25362,20124,'Y','18','021','EC','A','','','AC','0000816476','0000816476','OH00003199088','IL','1','Glasser','Dena','','','','34','281805739','1103 N Crater Ave',0,'Dover','OH','44622',NULL,'CY','39157','1968-08-22','F','U',':RET:2106-3','N','021','DEN','3740659','99734OH005000301','2014-04-01','2014-02-25 08:49:12','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2014-02-25 21:30:37'),(25971,20596,'Y','18','021','EC','A','','','AC','0000578830','0000578830','OH00003370004','S3','1','Bregitzer','Kelly','','','','34','291152235','1551 POLK DR',0,'BRUNSWICK','OH','44212','3713','CY','39103','2009-12-29','F','U',':RET:2106-3','N','021','DEN','3607339','99734OH005000401','2014-03-01','2014-02-26 13:32:47','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78',NULL,0,'2014-02-26 21:01:46'),(1265,1043,'N','01','021','EC','A',NULL,NULL,'','0000332893','0000533729','','IL','1','Hernandez','Maria','','','','34','630607950','7277 Hwy 22',0,'Brandon','TX','76628',NULL,'CY','48217','1965-09-25','F','',NULL,'N','021','DEN','795837','33348TX002000201','2014-01-01','2013-11-28 19:20:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:30:05'),(5077,4023,'Y','18','021','EC','A','','','AC','0000485233','0000485233','TX00001225650','IL','1','Moreno','Francisco','','','','34','451982648','222 PIKE RD',0,'SAN ANTONIO','TX','78209','3515','CY','48029','1956-10-08','M','M',':RET:2500-7','N','021','DEN','1564550','33348TX002000201','2014-01-01','2013-12-19 13:39:32','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:00:52'),(14216,11335,'Y','18','021','EC','A','','','AC','0001230770','0001230770','TX00000405878','IL','1','GOIDE','IRENE','','','','34','308295291','111 PALENCIA AVE',0,'LAREDO','TX','78046','8400','CY','48479','1975-10-03','F','U',NULL,'N','021','DEN','1723207','33348TX002000201','2014-02-01','2013-12-26 16:06:03','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-27 02:04:37'),(23521,18737,'N','19','021','EC','A',NULL,NULL,'','0000600844','0000513371','','IL','1','Tocchi','Amanda','Lynn','','','34','296962843','3198 SPRING VALLEY RD',0,'AKRON','OH','44333','1236','CY','39153','1993-09-13','F','',':RET:2106-3','N','021','HLT','3678481','52664OH151001501','2014-03-01','2014-02-13 15:29:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-13 22:02:20'),(23985,19070,'N','01','021','EC','A',NULL,NULL,'','0002224558','0001808513','','IL','1','Orechwa','Theresa','','','','34','433980175','18231 WILDLIFE WAY DR',0,'BATON ROUGE','LA','70817','4359','CY','22033','1950-07-12','F','',':RET:2106-3','N','021','DEN','3018196','18575LA002000201','2014-03-01','2014-02-15 12:37:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-15 22:00:22'),(25811,20468,'Y','18','021','EC','A','','','AC','0000495496','0000495496','OH00002659628','IL','1','rogers','robert','','','','34','295587772','157 odlin',0,'dayton','OH','45405',NULL,'CY','39113','1966-05-16','M','U',':RET:2106-3','N','021','DEN','2939586','99734OH005000301','2014-04-01','2014-02-26 13:36:20','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-26 21:00:21'),(28465,22524,'Y','18','021','EC','A','','','AC','0000512015','0000512015','OH00003566492','IL','1','Mallardi','Chloe','','','','34','283946661','1171 PITKIN AVE',0,'AKRON','OH','44310','1120','CY','39153','1991-08-05','F','U',':RET:2106-3','N','021','DEN','3845226','99734OH005000301','2014-04-01','2014-03-06 20:30:54','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-07 21:31:28'),(4015,3207,'Y','18','021','EC','A','','','AC','0000803719','0000803719','OH00000224496','IL','1','BOCKIE','ABBUL','','','','34','200780598','2931 HAU DR',0,'COLUMBUS','OH','43219',NULL,'CY','39049','1972-09-30','M','M',':RET:2054-5','N','021','DEN','1858314','99734OH005000401','2014-01-01','2013-12-17 06:32:35','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:45:32'),(6684,5301,'Y','18','021','EC','A','','','AC','0000955497','0000955497','OH00000728739','IL','1','Fluharty','Bruce','','','','34','271543180','14022 LEROY AVE',0,'CLEVELAND','OH','44135','1444','CY','39035','1959-08-11','M','M',':RET:2106-3','N','021','DEN','19544','99734OH005000401','2014-01-01','2013-11-05 05:21:11','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:01:29'),(9614,7614,'Y','18','021','EC','A','','','AC','0000976711','0000976711','OH00000783748','IL','1','OBRIEN','THOMAS','M','','','34','280680246','5396 RACE RD',0,'CINCINNATI','OH','45247','7429','CY','39061','1957-09-05','M','U',':RET:2106-3','N','021','HLT','2351359','92036OH005001201','2014-01-01','2013-12-20 19:26:18','157.00',NULL,NULL,'500.82','343.82','R-OH004','OH0','500.82',NULL,0,'2013-12-26 04:37:43'),(22102,17643,'N','01','021','EC','A',NULL,NULL,'','0000758310','0000460613','','IL','1','mccandless','dolores','ruth','','','34','233047125','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1959-11-19','F','',':RET:2106-3','N','021','DEN','2632680','99734OH005000301','2014-03-01','2014-02-08 11:47:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:30'),(22350,17850,'Y','18','021','EC','A','','','AC','0000203118','0000203118','OH00001874510','IL','1','Meyers','Delilah','','','','34','277808240','3319 RATTEREE DR',0,'TOLEDO','OH','43611','1765','CY','39095','1982-08-09','F','M',':RET:2106-3','N','021','HLT','2856359','92036OH006002601','2014-04-01','2014-02-10 07:18:06','89.00',NULL,NULL,'179.23','90.23','R-OH001','OH0','179.23','CIC',0,'2014-02-10 21:00:02'),(3397,2726,'Y','18','021','EC','A','','','AC','0001868251','0001868251','LA00001018782','IL','1','Boll','Andrea','','','','34','546934135','2519 VIENNA ST',0,'NEW ORLEANS','LA','70122','5438','CY','22071','1974-12-15','F','U',NULL,'N','021','DEN','1429353','18575LA002000201','2014-01-01','2013-12-22 09:54:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:01'),(7949,6289,'Y','18','021','EC','A','','','AC','0001960921','0001960921','LA00000870690','IL','1','HAWKINS','PATRICIA','MARIE','','','34','435436891','1072 CARMADELLE ST',0,'MARRERO','LA','70072','2644','CY','22051','1974-08-02','F','M',':RET:2054-5','N','021','DEN','1731147','18575LA002000201','2014-01-01','2013-12-20 17:40:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:07:06'),(3823,3061,'Y','18','021','EC','A','','','AC','0000471000','0000471000','OH00000198712','IL','1','Blemenschutz','Thomas','','','','34','278543816','430 Malacca St',0,'Akron','OH','44305',NULL,'CY','39153','1951-04-13','M','U',':RET:2106-3','N','021','DEN','690016','99734OH005000301','2014-01-01','2013-12-13 14:57:42','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:35:00'),(3934,3149,'Y','18','021','EC','A','','','AC','0001029342','0001029342','OH00000196227','IL','1','Dedo','Robert','Ross','','','34','275500194','1758 Lealand Ave.',0,'Poland','OH','44514',NULL,'CY','39099','1951-02-07','M','M',':RET:2106-3','N','021','HLT','340858','92036OH002003201','2014-01-01','2013-12-12 21:26:37','921.00',NULL,NULL,'1455.22','534.22','R-OH013','OH0','803.09',NULL,0,'2013-12-25 21:37:45'),(4296,3417,'N','01','021','EC','A',NULL,NULL,'','0000608248','0000359146','','IL','1','abdirahman','hayat','','','','34','614159593','807 poplare ave',0,'new albany','MS','38652',NULL,'CY','28145','1961-01-01','F','',':RET:2054-5','N','021','DEN','2436740','46300MS002000201','2014-01-01','2013-12-17 13:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:52:15'),(1692,1413,'N','19','021','EC','A',NULL,NULL,'','0000096402','0001240558','','IL','1','Lin','Candie','','','','34','281112987','26693 Amberwood Dr.',0,'Perrysburg','OH','43551',NULL,'CY','39173','2005-05-01','F','',':RET:2034-7','N','021','HLT','2565943','92036OH004002601','2014-01-01','2013-12-24 07:13:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-25 18:54:29'),(21226,16962,'Y','18','021','EC','A','','','AC','0000643265','0000643265','OH00001655983','IL','1','SMITH','MARK','EDWARD','','','34','277683832','206 Washington St',0,'WILLARD','OH','44890',NULL,'CY','39077','1960-07-18','M','U',NULL,'T','021','HLT','3476777','92036OH004002701','2014-03-01','2014-02-03 09:11:57','268.00',NULL,NULL,'367.84','99.84','R-OH006','OH0','367.84',NULL,0,'2014-02-03 21:01:06'),(21078,16844,'Y','18','021','EC','A','','','AC','0000533989','0000533989','TX00002363519','IL','1','Bruder','Courtney','L','','','34','634098590','9301 Spectrum Drive',0,'Austin','TX','78717',NULL,'CY','48491','1989-04-30','F','M',':RET:2106-3','N','021','DEN','2899297','33348TX002000101','2014-03-01','2014-02-01 20:48:29','0.00',NULL,NULL,'54.30','54.30','R-TX003','TX0','27.15',NULL,0,'2014-02-02 19:00:20'),(2446,1991,'N','19','021','EC','A',NULL,NULL,'','0000188827','0000987371','','IL','1','Truong','Michael','','','','34','276961533','3365 LAKE CREST DR',0,'HAMILTON','OH','45011','8167','CY','39017','1992-11-24','M','',':RET:2047-9','N','021','HLT','1256918','92036OH004001201','2014-01-01','2013-12-08 19:57:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2013-12-25 19:34:33'),(20589,16452,'Y','18','021','EC','A','','','AC','0000566651','0000566651','OH00002291531','IL','1','Ewart','Mark','','','','34','268749246','605 MONTERAY AVE',0,'DAYTON','OH','45419','2748','CY','39113','1969-04-18','M','U',':RET:2106-3','N','021','DEN','3622744','99734OH005000401','2014-03-01','2014-01-30 09:12:06','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-30 21:00:07'),(20373,16274,'Y','18','021','EC','A','','','AC','0001827223','0001827223','LA00002116832','IL','1','Robinson','Elmore','','','','34','587985941','2011 W Alabama Ave',0,'Ruston','LA','71270',NULL,'CY','22061','1955-12-02','M','U',':RET:2054-5','N','021','DEN','3278013','18575LA002000101','2014-03-01','2014-01-29 11:27:26','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-29 21:00:07'),(2971,2393,'Y','18','021','EC','A','','','AC','0001099084','0001099084','TX00000880401','IL','1','AVANT','DEVEN','LEE','','','34','451835200','108 half North 22ND PL',0,'LA MESA','TX','79331','2302','CY','48115','1979-05-02','M','M',':RET:2106-3','T','021','DEN','235715','33348TX002000201','2014-01-01','2013-12-06 13:02:02','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:59'),(14845,11854,'Y','18','021','EC','A','','','AC','0000175102','0000175102','OH00000449107','IL','1','Schneider','Melinda','','','','34','291608811','15175 KRUSE RD',0,'WAPAKONETA','OH','45895','9518','CY','39011','1967-09-12','F','U',NULL,'N','021','HLT','1503466','92036OH005001501','2014-01-01','2013-12-23 20:12:56','184.00',NULL,NULL,'469.88','285.88','R-OH002','OH0','330.12',NULL,1,'2013-12-29 11:14:58'),(8052,6375,'Y','18','021','EC','A','','','AC','0000443451','0000443451','OH00000205513','IL','1','Huber','Karen','','','','34','269645814','160 WESTWOOD AVE',0,'NAPOLEON','OH','43545','9474','CY','39069','1957-04-16','F','U',':RET:2106-3','N','021','HLT','1768718','92036OH004002601','2014-01-01','2013-12-20 15:10:51','363.12',NULL,NULL,'365.79','2.67','R-OH001','OH0','365.79',NULL,0,'2013-12-26 03:09:44'),(13703,10933,'Y','18','021','EC','A','','','AC','0001158916','0001158916','OH00000090522','IL','1','Meszaros','Sharon','','','','34','298644026','5482 LAKEVIEW RD',0,'CORTLAND','OH','44410','9513','CY','39155','1973-03-09','F','U',':RET:2106-3','N','021','HLT','2059485','52664OH151001305','2014-01-01','2013-12-23 13:00:55','190.00',NULL,NULL,'323.20','133.20','R-OH013','OH0','323.20',NULL,0,'2013-12-26 13:08:44'),(13531,10787,'Y','18','021','EC','A','','','AC','0001507614','0001507614','LA00000931145','IL','1','SHAW','HAROLD','E','','Jr','34','436175844','2916 REUNION DR',0,'VIOLET','LA','70092','3420','CY','22087','1958-06-01','M','U',NULL,'N','021','DEN','2400173','18575LA002000201','2014-01-01','2013-12-23 11:29:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:28'),(5818,4620,'N','01','021','EC','A',NULL,NULL,'','0000876732','0000185907','','IL','1','Ghneim','Husn','Abdullah','','','34','442802756','5807 MANCHESTER DR',0,'RICHARDSON','TX','75082','2709','CY','48085','1951-02-12','F','',':RET:2106-3','N','021','DEN','1632313','33348TX002000201','2014-01-01','2013-12-23 21:56:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:47:55'),(20511,16388,'Y','18','021','EC','A','','','AC','0001779243','0001779243','LA00002407481','IL','1','KNIGHTON','SHIRLEY','ANN','','','34','433175212','3409 SEVERN AVE',0,'METAIRIE','LA','70002','6504','CY','22051','1963-08-07','F','U',NULL,'N','021','DEN','2923418','18575LA002000201','2014-03-01','2014-01-29 17:28:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:19'),(1160,957,'Y','18','021','EC','A','','','AC','0000888004','0000888004','LA00001165607','IL','1','Hebert','Vicky','G','','','34','436793672','2651 Cypress Island Hwy',0,'St Martinville','LA','70582',NULL,'CY','22099','1950-03-08','F','M',':RET:2106-3','N','021','DEN','862909','18575LA002000201','2014-01-01','2013-12-03 14:24:57','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:18:52'),(21899,17488,'Y','18','021','EC','A','','','AC','0000532150','0000532150','OH00002076714','IL','1','Hawkins','Cassandra','','','','34','279884592','8089 US ROUTE 33',0,'CELINA','OH','45822','9309','CY','39107','1979-12-13','F','U',':RET:2106-3','T','021','HLT','3461760','92036OH005001506','2014-03-01','2014-02-06 10:18:13','253.00',NULL,NULL,'307.26','54.26','R-OH002','OH0','307.26',NULL,0,'2014-02-06 21:01:45'),(17661,14115,'Y','18','021','EC','A','','','AC','0001128018','0001128018','OH00002363080','IL','1','ali','zeinab','','','','34','218045878','4689 CRYSTAL LAKE DR',0,'HILLIARD','OH','43026','2824','CY','39049','1963-01-03','F','U',':RET:2054-5','N','021','DEN','2598500','99734OH005000301','2014-02-01','2014-01-13 15:18:53','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:32:45'),(16930,13548,'Y','18','021','EC','A','','','AC','0001297381','0001297381','LA00001914552','IL','1','Douglas','Ivy','Labyzon','','','34','436642573','2759 MEXICO ST',0,'NEW ORLEANS','LA','70122','6556','CY','22071','1945-08-02','F','U',':RET:2054-5','T','021','DEN','2207431','18575LA002000201','2014-02-01','2014-01-09 16:42:12','0.00',NULL,NULL,'16.22','16.22','R-LA001','LA0','16.22',NULL,0,'2014-01-13 02:19:48'),(16447,13160,'Y','18','021','EC','A','','','AC','0000713578','0000713578','MS00000590705','IL','1','Lee','Carole','','','','34','587529258','850 North Jefferson Street',0,'Jackson','MS','39202',NULL,'CY','28049','1949-12-23','F','U',':RET:2106-3','T','021','DEN','2039962','46300MS002000101','2014-02-01','2014-01-06 09:06:45','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-07 04:05:17'),(15437,12351,'Y','18','021','EC','A','','','AC','0001030312','0001030312','TX00001737335','IL','1','vega carmona','juan','','','','34','732034565','301 s. maddox',0,'Dumas','TX','79029',NULL,'CY','48341','1984-01-23','M','M',':RET:2106-3','N','021','DEN','1579880','33348TX002000201','2014-02-01','2013-12-31 13:41:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:56'),(14763,11786,'N','19','021','EC','A',NULL,NULL,'','0000925131','0000131183','','IL','1','CHENG','GRACE','OLIVER','','','34','280923000','4225 EARLY MORN DR',0,'PLANO','TX','75093','3814','CY','48085','1990-04-23','F','',':RET:2034-7','N','021','DEN','2188129','33348TX002000201','2014-01-01','2013-12-23 19:38:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,1,'2013-12-29 11:12:44'),(13827,11037,'Y','18','021','EC','A','','','AC','0000938523','0000938523','OH00000802942','IL','1','willoughby','moses','earl','','Jr','34','578849851','3799 E NORMANDY PARK DR',0,'MEDINA','OH','44256','8267','CY','39103','1958-05-13','M','R',':RET:2106-3','T','021','HLT','1555177','52664OH152000901','2014-01-01','2013-12-23 01:41:43','0.00',NULL,NULL,'418.89','418.89','R-OH012','OH0','418.89',NULL,0,'2013-12-26 13:12:01'),(9618,7617,'Y','18','021','EC','A','','','AC','0000108143','0000108143','OH00000437504','IL','1','Dolney','Jin','','','','34','297045947','4700 LOGAN GATE RD',0,'YOUNGSTOWN','OH','44505','1716','CY','39155','1975-11-11','F','M',':RET:2034-7','N','021','HLT','2028081','92036OH005003205','2014-01-01','2013-12-20 19:39:26','153.00',NULL,NULL,'301.61','148.61','R-OH013','OH0','301.61',NULL,0,'2013-12-26 04:37:49'),(9257,7341,'Y','18','021','EC','A','','','AC','0000444415','0000444415','TX00000714735','IL','1','Arreola','Abraham','','','','34','642168754','345 Shadow Mountain Dr',0,'El paso','TX','79912',NULL,'CY','48141','1990-04-14','M','M',':RET:2106-3','N','021','DEN','694720','33348TX002000201','2014-01-01','2013-11-30 16:14:46','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:15:11'),(3234,2604,'Y','18','021','EC','A','','','AC','0000112895','0000112895','OH00001151248','IL','1','Pyle','Hamilton','','','','34','279505949','26025 West Chester Rd.',0,'Tippecanoe','OH','44699',NULL,'CY','39067','1952-09-12','M','U',NULL,'N','021','DEN','440793','99734OH005000301','2014-01-01','2013-10-06 06:16:11','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 20:46:07'),(1803,1481,'Y','18','021','EC','A','','','AC','0000717833','0000717833','OH00001385869','IL','1','Wright','Laurie','','','','34','301763432','1705 BLUE ROCK ST',0,'CINCINNATI','OH','45223',NULL,'CY','39061','1981-02-04','F','U',':RET:2106-3','N','021','HLT','2020836','92036OH004001201','2014-01-01','2013-12-24 11:33:35','0.00',NULL,NULL,'204.20','204.20','R-OH004','OH0','204.20',NULL,0,'2013-12-25 18:56:48'),(1290,1067,'Y','18','021','EC','A','','','AC','0001034633','0001034633','OH00001096960','IL','1','Solari','Janet','','','','34','333527569','110 W LONGVIEW AVE',0,'COLUMBUS','OH','43202','1038','CY','39049','1955-12-20','F','U',':RET:2106-3','N','021','DEN','913482','99734OH005000301','2014-01-01','2013-11-29 13:05:08','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:30:50'),(25355,20118,'N','19','021','EC','A',NULL,NULL,'','0001120004','0000913009','','IL','1','STOGSDILL','KAYLA','NICOLE','','','34','302045761','5757 LAKE EERIE DR.',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','2000-07-12','F','',':RET:2106-3','N','021','DEN','3026771','99734OH005000301','2014-04-01','2014-02-24 18:33:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:33'),(26511,21027,'Y','18','021','EC','A','','','AC','0000418918','0000418918','OH00003330231','S3','1','Meek','Theresa','Wayne','','','34','280068745','2152 LAVENHAM RD',0,'REYNOLDSBURG','OH','43068','3424','CY','39049','2001-05-07','M','U',':RET:2106-3','N','021','DEN','3123947','99734OH005000401','2014-04-01','2014-02-28 17:40:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78','CIC',0,'2014-02-28 21:00:19'),(851,705,'Y','18','021','EC','A','','','AC','0000172387','0000172387','OH00000763514','IL','1','RICH','MARK','','','','34','301561195','2105 wedgewood dr',0,'akron','OH','44312',NULL,'CY','39153','1954-07-22','M','M',':RET:2106-3','N','021','HLT','1574141','52664OH152000901','2014-01-01','2013-12-16 16:11:42','146.00',NULL,NULL,'425.18','279.18','R-OH012','OH0','425.18',NULL,0,'2013-12-25 18:06:54'),(20508,16385,'N','01','021','EC','A',NULL,NULL,'','0001594352','0001436521','','IL','1','LIEU','THANG','','','','34','439410650','1685 NOTTINGHAM DR',0,'MARRERO','LA','70072','4380','CY','22051','1973-03-09','M','',NULL,'N','021','DEN','3144070','18575LA002000201','2014-03-01','2014-01-29 16:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-29 21:01:17'),(19231,15324,'Y','18','024','14','A','','','TE','0000691804','0000691804','','IL','1','Martin','Tenee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-04','F','',NULL,NULL,NULL,'','28474','','2014-01-20','2014-01-20 12:35:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:33'),(18803,14976,'Y','18','021','EC','A','','','AC','0000627907','0000627907','OH00001756343','IL','1','Crow','Deborah','','','','34','288689326','1008 KENILWORTH AVE',0,'CLEVELAND','OH','44113','4458','CY','39035','1964-01-29','F','U',':RET:2106-3','T','021','DEN','2920384','99734OH005000401','2014-03-01','2014-01-16 13:44:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:36:00'),(6486,5137,'Y','18','021','EC','A','','','AC','0000627853','0000627853','OH00000417951','IL','1','Abufhele','Melba','','','','34','590447188','4056 FAIRWAY DR',0,'CANFIELD','OH','44406','9056','CY','39099','1952-08-29','F','U',NULL,'N','021','HLT','389132','52664OH151001305','2014-01-01','2013-12-11 10:27:16','512.00',NULL,NULL,'710.64','198.64','R-OH013','OH0','710.64',NULL,0,'2013-12-26 00:50:27'),(1699,1418,'Y','18','021','EC','A','','','AC','0001190060','0001190060','OH00001210990','IL','1','Corwin','Cynthia','E','','','34','283462200','919 Hickory St',0,'Perrysburg','OH','43551',NULL,'CY','39173','1961-09-26','F','U',':RET:2106-3','N','021','HLT','2001530','92036OH004002601','2014-01-01','2013-12-24 13:36:56','242.00',NULL,NULL,'306.05','64.05','R-OH001','OH0','306.05',NULL,0,'2013-12-25 18:54:39'),(15421,12336,'Y','18','024','14','A','','','TE','0000415450','0000415450','','IL','1','anderson','amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-05','F','',NULL,NULL,NULL,'','2060662','','2013-12-31','2013-12-31 11:30:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:27:28'),(3326,2668,'Y','18','021','EC','A','','','AC','0001139501','0001139501','OH00000079120','IL','1','Wilson','Nancy','','','','34','593165898','200 MILL ST',0,'MORROW','OH','45152','1214','CY','39165','1965-05-19','F','U',':RET:2106-3','N','021','DEN','2407701','99734OH005000301','2014-01-01','2013-12-22 16:36:43','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:16:09'),(3461,2782,'N','19','021','EC','A',NULL,NULL,'','0000139006','0000565542','','IL','1','Spieldenner','Mark','C','','','34','298048618','4424 BURNINGTREE DR',0,'TOLEDO','OH','43623','3186','CY','39095','2000-05-20','M','',':RET:2106-3','N','021','DEN','2500676','99734OH005000401','2014-01-01','2013-12-22 04:18:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:45'),(9800,7760,'Y','18','021','EC','A','','','AC','0000227019','0000227019','OH00000499161','IL','1','weiner','lynn','','','','34','369801357','6745 SWEET BUSH CT',0,'SYLVANIA','OH','43560','3585','CY','39095','1961-03-17','F','U',':RET:2106-3','N','021','HLT','126474','92036OH006002601','2014-01-01','2013-10-20 18:58:14','0.00',NULL,NULL,'456.50','456.50','R-OH001','OH0','301.86',NULL,0,'2013-12-26 05:01:12'),(24728,19633,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000519884','','IL','1','SMITH','NIQUAN','','','','34','291138661','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2008-01-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:00'),(27556,21797,'Y','18','021','EC','A','','','AC','0000273032','0000273032','TX00003122904','31','1','RODRIGUEZ','DELIA','','','','34','309663751','PO BOX 651',0,'BENBOLT','TN','78342',NULL,'CY','48249','1956-08-01','F','M',NULL,'N','021','DEN','3446201','33348TX002000201','2014-04-01','2014-03-04 14:59:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-04 21:30:14'),(27797,21986,'N','01','021','EC','A',NULL,NULL,'','0001038663','0000748249','','IL','1','BAJOR','ELIZABETH','','','','34','564087114','4585 MARS RD',0,'UNIONTOWN','OH','44685','6901','CY','39153','1958-06-06','F','',NULL,'N','021','HLT','3064839','52664OH151001305','2014-04-01','2014-03-04 18:52:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-03-05 21:31:44'),(28778,22780,'Y','18','021','EC','A','','','AC','0001011626','0001011626','OH00003759554','IL','1','Whitehead','Katrina','','','','34','302868664','1480 E 204TH ST',0,'EUCLID','OH','44117','1402','CY','39035','1985-12-06','F','U',':RET:2054-5','N','021','DEN','3555341','99734OH005000401','2014-04-01','2014-03-09 13:37:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-09 21:00:33'),(6972,5533,'Y','18','021','EC','A','','','AC','0000388621','0000388621','OH00000003422','IL','1','Kennedy','Melisa','','','','34','272903586','5542 BOSWORTH PL',0,'CINCINNATI','OH','45212','1238','CY','39061','1980-06-24','F','M',':RET:2054-5','N','021','DEN','1869407','99734OH005000401','2014-01-01','2013-12-24 23:18:38','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:28'),(6028,4772,'Y','18','021','EC','A','','','AC','0000994836','0000994836','TX00000500608','IL','1','Meadows','James','C','','','34','450434550','303 E NANCY ST',0,'WHITE OAK','TX','75693','1121','CY','48183','1963-03-07','M','U',':RET:2106-3','N','021','DEN','35708','33348TX002000201','2014-01-01','2013-11-30 19:35:17','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 00:01:05'),(20294,16199,'Y','18','021','EC','A','','','AC','0002247622','0002247622','LA00001969091','IL','1','Campa','Khaled','Amat','','','34','659164401','201 BRIARHAVEN DR',0,'BATON ROUGE','LA','70810','6451','CY','22033','1991-02-13','M','U',':RET:2106-3','N','021','DEN','3054515','18575LA002000201','2014-03-01','2014-01-28 13:38:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-28 21:00:38'),(5657,4487,'Y','18','024','14','A','','','TE','0000865825','0000865825','','IL','1','Harris','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-20','F','',NULL,NULL,NULL,'','883760','','2013-11-26','2013-11-26 14:23:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:31:39'),(5576,4424,'Y','18','021','EC','A','','','AC','0000863428','0000863428','OH00001078048','IL','1','Kennedy','Daniel','Douglas','','','34','284507667','1633parkridgeln.',0,'toledo','OH','43614',NULL,'CY','39095','1951-05-02','M','M',':RET:2106-3','N','021','DEN','29787','99734OH005000401','2014-01-01','2013-11-06 14:24:39','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:16:49'),(4893,3881,'Y','18','021','EC','A','','','AC','0000144366','0000144366','TX00000782940','IL','1','Nakamura','Terri','','','','34','164463417','13626 OAK MDWS',0,'UNIVERSAL CITY','TX','78148','2724','CY','48029','1956-12-29','F','U',NULL,'N','021','DEN','739117','33348TX002000201','2014-01-01','2013-10-04 16:41:54','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 22:31:35'),(1902,1555,'Y','18','021','EC','A','','','AC','0000988886','0000988886','OH00001598067','IL','1','Rossi','JOHN',NULL,NULL,NULL,NULL,NULL,'5307 TIMBERHOLLOW LN',0,'CINCINNATI','OH','45247','7537','CY','39061','1962-03-26','M','R',':RET:2106-3','T','021','HLT','2000104','92036OH002001201','2014-01-01','2013-12-24 13:11:36','0.00',NULL,NULL,'531.72','531.72','R-OH004','OH0','531.72',NULL,0,'2013-12-25 18:59:09'),(14343,11441,'N','01','021','EC','A',NULL,NULL,'','0000661359','0000420034','','IL','1','France','Kathleen','','','','34','310587035','2921 EVERGREEN RD',0,'TOLEDO','OH','43606','2723','CY','39095','1951-10-29','F','',':RET:2106-3','N','021','HLT','2017754','92036OH005002605','2014-02-01','2013-12-26 15:39:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','560.22',NULL,0,'2013-12-27 02:07:56'),(28989,22945,'Y','18','021','EC','A','','','AC','0000788268','0000788268','OH00003195969','IL','1','Rhodes','Beth','','','','34','290440273','7418 Ayrshire ave',0,'Canton','OH','44721',NULL,'CY','39151','1949-10-28','F','M',':RET:2106-3','N','021','HLT','2978333','52664OH151001305','2014-04-01','2014-03-10 15:09:12','420.00',NULL,NULL,'669.00','249.00','R-OH015','OH0','669.00',NULL,0,'2014-03-10 21:01:13'),(475,388,'Y','18','021','EC','A','','','AC','0000701868','0000701868','LA00000628903','31','1','Reliford','Kiwana','','','','34','433453048','P. O. Box 1258',0,'Minden','LA','71058',NULL,'CY','22119','1981-08-06','F','M',':RET:1002-5^:RET:2054-5','N','021','DEN','1046184','18575LA002000201','2014-01-01','2013-12-03 20:05:12','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2013-12-25 17:47:59'),(21579,17237,'Y','18','021','EC','A','','','AC','0000901104','0000901104','OH00002252025','IL','1','Esterak','Linda','','','','34','270504378','2087 Darnell Drive',0,'Akron','OH','44319',NULL,'CY','39153','1950-08-27','F','M',':RET:2106-3','N','021','HLT','2933243','52664OH151001301','2014-03-01','2014-02-05 14:26:26','331.00',NULL,NULL,'658.32','327.32','R-OH012','OH0','658.32',NULL,0,'2014-02-05 21:30:24'),(6999,5555,'Y','18','021','EC','A','','','AC','0001194171','0001194171','TX00001128071','IL','1','rojas','jose','','','','34','633521559','1510 BIG BEND DR',0,'HOUSTON','TX','77055','4531','CY','48201','1955-11-05','M','U',NULL,'N','021','DEN','1476520','33348TX002000201','2014-01-01','2013-12-24 18:58:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:48:13'),(18259,14577,'N','01','021','EC','A',NULL,NULL,'','0000233201','0001006877','','IL','1','RIVERA','CARLOS','','','','34','628602913','10380 THOR ST',0,'EL PASO','TX','79924',NULL,'CY','48141','1979-08-31','M','',NULL,'N','021','DEN','2765553','33348TX002000201','2014-02-01','2014-01-15 16:28:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-16 08:44:35'),(15216,12162,'Y','18','021','EC','A','','','AC','0000148346','0000148346','OH00000698028','IL','1','Heskett','Adam','','','','34','299881298','3215 COLUMBUS RD',0,'SPRINGFIELD','OH','45503','3213','CY','39023','1983-09-10','M','U',':RET:2106-3','N','021','HLT','1641351','92036OH005000506','2014-02-01','2013-12-30 14:35:06','214.00',NULL,NULL,'269.80','55.80','R-OH003','OH0','269.80',NULL,0,'2014-01-01 12:07:51'),(727,602,'Y','18','021','EC','A','','','AC','0000133877','0000133877','TX00001128663','IL','1','WOODWARD','KELSEY','','','','34','642109361','909 ACORN OAKS DR',0,'AUSTIN','TX','78745',NULL,'CY','48453','1987-10-27','F','U',':RET:2106-3','N','021','DEN','1562010','33348TX002000101','2014-01-01','2013-12-16 15:53:45','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:03:40'),(13981,11139,'N','01','021','EC','A',NULL,NULL,'','0000484788','0001201892','','IL','1','Hawkins','Wallace','','','','34','274481098','3421 Amberway Court',0,'CINCINATTI','OH','45251',NULL,'CY','39061','1950-11-04','M','',NULL,'N','021','HLT','2183325','92036OH004001201','2014-01-01','2013-12-23 13:15:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','509.54',NULL,0,'2013-12-26 13:15:35'),(9779,7745,'Y','18','021','EC','A','','','AC','0000529404','0000529404','OH00000850163','IL','1','Prout','Mark','D','','','34','300723028','1000 W Main St Lot 20',0,'west jefferson','OH','43162',NULL,'CY','39097','1961-12-01','M','U',':RET:2106-3','N','021','DEN','669510','99734OH005000301','2014-01-01','2013-10-20 20:11:41','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 05:00:42'),(3192,2568,'Y','18','021','EC','A','','','AC','0000003728','0000003728','MS00000060607','IL','1','Hubbard','Rodney','','','','34','427637882','5155 Keele Street',0,'Jackson','MS','39206',NULL,'CY','28049','1988-09-13','M','U',NULL,'N','021','DEN','522041','46300MS002000101','2014-01-01','2013-10-03 08:48:13','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 20:32:12'),(1242,1022,'Y','18','021','EC','A','','','AC','0000642041','0000642041','OH00000834313','IL','1','Heskamp','Joshua','','','','34','129728619','419 Kellyann Ct.',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-10-22','M','U',':RET:2106-3','N','021','HLT','23416','52664OH152001001','2014-01-01','2013-12-03 09:09:09','0.00',NULL,NULL,'125.55','125.55','R-OH012','OH0','125.55',NULL,0,'2013-12-25 18:20:58'),(1337,1106,'N','01','021','EC','A',NULL,NULL,'','0000573026','0001068233','','IL','1','peachock','mark','angelo','','','34','276801221','7238 HERRICK PARK DR',0,'HUDSON','OH','44236','2316','CY','39153','1974-02-17','M','',':RET:2106-3','N','021','HLT','682879','52664OH151001304','2014-01-01','2013-11-07 01:59:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.44',NULL,0,'2013-12-25 18:32:17'),(24489,19454,'N','01','021','EC','A',NULL,NULL,'','0000840141','0001029333','','IL','1','Calzada','Edgar','','','','34','467495579','10249 SHARP DR',0,'EL PASO','TX','79924','3516','CY','48141','1980-03-27','M','',NULL,'N','021','DEN','3034654','33348TX002000201','2014-04-01','2014-02-18 18:04:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:43:43'),(24492,19457,'Y','18','021','EC','A','','','AC','0000869231','0000869231','TX00002960071','IL','1','tutton','angela','','','','34','461274089','5025 FM 66',0,'WAXAHACHIE','TX','75167','8924','CY','48139','1967-06-06','F','U',':RET:2106-3','N','021','DEN','3503289','33348TX002000201','2014-04-01','2014-02-18 18:21:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:44:58'),(24902,19742,'Y','18','024','14','A','','','TE','0000415441','0000415441','','IL','1','olvera','maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-15','F','',NULL,NULL,NULL,'','195234','','2014-03-31','2014-02-19 18:54:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-20 21:30:02'),(28994,22949,'N','19','021','EC','A',NULL,NULL,'','0000177685','0001131503','','IL','1','campton','abby','','','','34','287045171','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1999-10-07','F','',NULL,'N','021','HLT','4056302','92036OH003000601','2014-04-01','2014-03-09 18:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-10 21:01:16'),(370,307,'Y','18','021','EC','A','','','AC','0000230506','0000230506','TX00000522248','IL','1','Moyer','Erika','','','','34','641092492','278 COUNTY ROAD 6401',0,'DAYTON','TX','77535','5107','CY','48291','1987-11-11','F','U',NULL,'N','021','DEN','115150','33348TX002000201','2014-01-01','2013-12-04 15:28:23','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:45:25'),(7048,5598,'Y','18','021','EC','A','','','AC','0000334115','0000334115','TX00001385957','IL','1','moore','kashonda','','','','34','460552249','1011 COLE DR',0,'LONGVIEW','TX','75602','1010','CY','48183','1981-11-23','F','U',':RET:2054-5','N','021','DEN','1928058','33348TX002000201','2014-02-01','2013-12-25 18:14:37','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 01:49:36'),(16421,13140,'N','19','021','EC','A',NULL,NULL,'','0000417411','0000661361','','IL','1','Jin','Joseph','Young','','','34','295921908','3789 MAPLE GROVE LN',0,'BEAVERCREEK','OH','45440','3573','CY','39057','1990-10-25','M','',':RET:2040-4','N','021','HLT','2136580','92036OH001000501','2014-02-01','2014-01-06 14:12:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','286.72',NULL,0,'2014-01-07 04:04:30'),(16434,13150,'Y','18','021','EC','A','','','AC','0001126879','0001126879','OH00001562583','IL','1','SMITH','VIRGINIA','','','','34','295524643','842 VINE STREET',0,'ORRVILLE','OH','44667',NULL,'CY','39169','1952-07-22','F','U',NULL,'T','021','HLT','1721343','52664OH152000901','2014-02-01','2014-01-06 15:57:05','518.00',NULL,NULL,'527.84','9.84','R-OH014','OH0','527.84',NULL,0,'2014-01-07 04:04:56'),(20081,16019,'Y','18','021','EC','A','','','AC','0000824316','0000824316','TX00001532984','IL','1','GANDARA','CARLOS','','','','34','641168582','2420 FEDERAL AVENUE',0,'ALPASO','TX','79930',NULL,'CY','48141','1987-02-10','M','U',NULL,'T','021','DEN','3387304','33348TX002000201','2014-03-01','2014-01-27 17:49:26','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-27 21:00:23'),(16517,13213,'Y','18','021','EC','A','','','AC','0001039171','0001039171','TX00001639903','IL','1','PLUMMER','BRITNEY','','','','34','627103036','201 TALL TIMBER LOOP',0,'WHITNEY','TX','76692','7526','CY','48217','1987-06-24','F','U',NULL,'N','021','DEN','2371242','33348TX002000201','2014-02-01','2014-01-05 11:20:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-07 10:21:32'),(17169,13739,'Y','18','021','EC','A','','','AC','0001135182','0001135182','OH00002423699','IL','1','Turbett','Margaret','','','','34','282467873','11850 Edgewater Drive',0,'Lakewood','OH','44107',NULL,'CY','39035','1953-08-17','F','U',':RET:2106-3','N','021','HLT','2090117','92036OH005000806','2014-02-01','2014-01-07 18:44:15','483.00',NULL,NULL,'634.52','151.52','R-OH011','OH0','634.52',NULL,0,'2014-01-13 02:22:07'),(17462,13964,'Y','18','021','EC','A','','','AC','0001223189','0001223189','OH00001767786','IL','1','Glick','Sharon','','','','34','294669337','1505 KAREN AVE',0,'LIMA','OH','45801','2610','CY','39003','1962-12-13','F','U',NULL,'N','021','HLT','2302327','92036OH001001501','2014-02-01','2014-01-10 17:11:02','224.00',NULL,NULL,'495.12','271.12','R-OH002','OH0','495.12',NULL,0,'2014-01-13 03:00:43'),(27193,21531,'Y','18','021','EC','A','','','AC','0000374581','0000374581','TX00002873843','IL','1','PRASEK','LAWRENCE','','','','34','461436133','12211 Dorsett Rd.',0,'Austin','TX','78727',NULL,'CY','48453','1963-08-22','M','U',':RET:2106-3','N','021','DEN','2925395','33348TX002000201','2014-04-01','2014-03-03 16:17:10','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-03 21:31:17'),(28025,22178,'Y','18','021','EC','A','','','AC','0000622557','0000622557','OH00003657722','IL','1','DeMartin','Edward','','','','34','271641065','1493 TOWNSHIP ROAD 219',0,'RICHMOND','OH','43944','7840','CY','39081','1957-06-30','M','U',':RET:2106-3','N','021','DEN','2741049','99734OH005000401','2014-04-01','2014-03-06 15:31:02','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-06 21:01:23'),(28528,22577,'Y','18','024','14','A','','','TE','0001108153','0001108153','','IL','1','Little','Jill',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-11-25','F','',NULL,NULL,NULL,'','3432194','','2014-03-07','2014-03-07 09:20:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:32:05'),(1250,1030,'Y','18','021','EC','A','','','AC','0000151943','0000151943','OH00000396389','IL','1','Wilson','Nancy','','','','34','269546541','6342 STRATFORD DR',0,'PARMA HEIGHTS','OH','44130','3173','CY','39035','1952-02-05','F','M',':RET:2106-3','N','021','HLT','493315','92036OH004000801','2014-01-01','2013-12-03 10:27:00','132.00',NULL,NULL,'528.27','396.27','R-OH011','OH0','528.27',NULL,0,'2013-12-25 18:21:12'),(7873,6228,'Y','18','024','14','A','','','TE','0000529416','0000529416','','IL','1','BAILOSKY','KEVIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-06-21','M','',NULL,NULL,NULL,'','968199','','2013-12-20','2013-12-20 16:21:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:05:14'),(6144,4873,'Y','18','021','EC','A','','','AC','0000589280','0000589280','OH00000856275','IL','1','Neff','Jennifer','','','','34','297600007','488 KELLER RD',0,'CHILLICOTHE','OH','45601','2935','CY','39141','1969-03-16','F','M',':RET:2106-3','N','021','DEN','989941','99734OH005000301','2014-01-01','2013-11-21 08:33:09','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-26 00:16:22'),(3556,2855,'Y','18','021','EC','A','','','AC','0000768875','0000768875','OH00000634764','IL','1','Brown','Daniel','','','Sr','34','285648138','8630 Lawton Dr',0,'Macedonia','OH','44056',NULL,'CY','39153','1959-04-04','M','M',NULL,'T','021','HLT','1480023','52664OH151001305','2014-01-01','2013-12-22 12:34:07','878.00',NULL,NULL,'1284.35','406.35','R-OH012','OH0','547.54',NULL,0,'2013-12-25 21:22:10'),(9315,7386,'Y','18','021','EC','A','','','AC','0001803382','0001803382','LA00000131568','IL','1','Aulds','Tony','','','','34','437671985','705 JOSEPH ST',0,'MONROE','LA','71201','2749','CY','22073','1979-02-15','M','M',':RET:2106-3','N','021','DEN','2508809','18575LA002000101','2014-01-01','2013-12-21 11:53:55','0.00',NULL,NULL,'50.04','50.04','R-LA007','LA0','25.02',NULL,0,'2013-12-26 04:30:21'),(20105,16041,'Y','18','024','14','A','','','TE','0001255719','0001255719','','IL','1','WOODARD','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-31','M','',NULL,NULL,NULL,'','2164099','','2014-01-27','2014-01-27 16:08:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:37'),(19859,15840,'Y','18','021','EC','A','','','AC','0000181032','0000181032','OH00001532939','IL','1','Anderson','Tina','','','','34','290568983','3133 RANDOLPH ST NW',0,'WARREN','OH','44485','2526','CY','39155','1956-10-16','F','U',':RET:2054-5','N','021','DEN','2690524','99734OH005000301','2014-03-01','2014-01-24 10:57:14','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-24 21:00:34'),(17238,13795,'Y','18','021','EC','A','','','AC','0000455325','0000455325','OH00000010688','IL','1','dong','zhihang','','','','34','087809594','8172 CLEARBROOK DR',0,'FINDLAY','OH','45840','7809','CY','39063','1973-11-12','M','M',':RET:2034-7','N','021','HLT','1584757','92036OH004001501','2014-02-01','2014-01-08 13:56:02','212.00',NULL,NULL,'456.58','244.58','R-OH002','OH0','226.17',NULL,0,'2014-01-13 02:22:43'),(18529,14776,'Y','18','024','14','A','','','TE','0001096772','0001096772','','IL','1','Fahnle','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-16','F','',NULL,NULL,NULL,'','1876776','','2014-01-15','2014-01-15 12:50:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:46:43'),(25845,20488,'Y','18','024','14','A','','','TE','0000857169','0000857169','','IL','1','Culpepper','Kathryn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-22','F','',NULL,NULL,NULL,'','2640425','','2014-02-26','2014-02-26 12:40:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:00:37'),(26893,21313,'Y','18','021','EC','A','','','AC','0001191393','0001191393','OH00002878739','IL','1','Morrison','Delta','','','','34','296766333','669 Bailey Rd.',0,'Peebles','OH','45660',NULL,'CY','39001','1975-05-17','F','U',':RET:2106-3','N','021','HLT','3038595','92036OH003000605','2014-04-01','2014-03-02 13:17:08','149.00',NULL,NULL,'279.34','130.34','R-OH005','OH0','279.34',NULL,0,'2014-03-03 01:00:04'),(28883,22859,'Y','18','021','EC','A','','','AC','0000455877','0000455877','TX00003366677','IL','1','TORRES','RAYMOND','','','','34','583891634','3316 E RANCIER AVE',0,'KILLEEN','TX','76543',NULL,'CY','48027','1979-06-24','M','M',NULL,'T','021','DEN','3973413','33348TX002000201','2014-04-01','2014-03-10 12:35:46','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-10 21:00:10'),(1364,1129,'N','01','021','EC','A',NULL,NULL,'','0001053422','0001258021','','IL','1','choe','andreana','','','','34','633302669','6628 PARQUE DEL SOL',0,'EL PASO','TX','79911','3050','CY','48141','1989-03-24','F','',NULL,'N','021','DEN','1609421','33348TX002000101','2014-01-01','2013-12-24 14:39:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 18:45:34'),(23190,18491,'Y','18','021','EC','A','','','AC','0000321071','0000321071','OH00001927793','IL','1','frady','sherry','','','','34','297604610','2743 GRAYBILL RD',0,'UNIONTOWN','OH','44685','8735','CY','39153','1962-10-02','F','M',':RET:2106-3','N','021','HLT','3392649','52664OH152000901','2014-03-01','2014-02-12 13:20:48','0.00',NULL,NULL,'304.63','304.63','R-OH012','OH0','304.63',NULL,0,'2014-02-12 21:32:03'),(22010,17571,'Y','18','021','EC','A','','','AC','0000695674','0000695674','OH00002437479','IL','1','ROCKWELL','BONNIE','','','','34','293542445','322 MORRIS LANE',0,'LUCASVILLE','OH','45648',NULL,'CY','39145','1955-09-11','F','U',':RET:2106-3','N','021','DEN','3456763','99734OH005000301','2014-03-01','2014-02-07 08:23:37','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-07 19:00:50'),(20366,16267,'Y','18','021','EC','A','','','AC','0000733624','0000733624','OH00001598887','IL','1','Siegrist','Alberta','A','','','34','282580055','362 ANTHONY DR',0,'SAINT HENRY','OH','45883','9524','CY','39107','1953-08-13','F','M',':RET:2106-3','N','021','HLT','3019137','92036OH004001501','2014-03-01','2014-01-28 18:17:52','0.00',NULL,NULL,'480.28','480.28','R-OH002','OH0','480.28',NULL,0,'2014-01-28 21:01:24'),(17062,13654,'Y','18','021','EC','A','','','AC','0000023654','0000023654','TX00002385565','IL','1','Sullivan','Patrick','','','','34','616308541','3700 McCann Rd.',0,'Longview','TX','75605',NULL,'CY','48183','1989-04-07','M','U',NULL,'N','021','DEN','2353327','33348TX002000201','2014-02-01','2014-01-07 21:21:42','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-13 02:21:12'),(1784,1468,'N','01','021','EC','A',NULL,NULL,'','0000866902','0000817546','','IL','1','WAHL','NANCY','S','','','34','279529479','15794 MAYFIELD RD',0,'HUNTSBURG','OH','44046','8788','CY','39055','1952-04-24','F','',':RET:2106-3','N','021','DEN','1611901','99734OH005000301','2014-01-01','2013-12-24 15:36:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:24'),(2302,1874,'Y','18','021','EC','A','','','AC','0000347882','0000347882','OH00000355727','IL','1','Kafcsak','Kenneth','','','','34','292526107','10181 DEER RUN',0,'BRECKSVILLE','OH','44141','3637','CY','39035','1953-08-06','M','M',':RET:2106-3','N','021','DEN','633201','99734OH005000301','2014-01-01','2013-12-09 17:08:16','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:31:01'),(9355,7415,'Y','18','021','EC','A','','','AC','0001189323','0001189323','LA00000902508','IL','1','whitaker','kalvin','','','','34','636148620','11493 hwy175',0,'grand cane','LA','71032',NULL,'CY','22031','1986-09-26','M','U',':RET:2054-5','T','021','DEN','1945337','18575LA002000201','2014-01-01','2013-12-21 00:16:50','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 04:31:21'),(14253,11367,'Y','18','021','EC','A','','','AC','0001511387','0001511387','LA00001036872','IL','1','Castle','Nikita','','','','34','438315643','2617 PAYNE ST',0,'HOUMA','LA','70363','5215','CY','22109','1974-12-24','F','U',':RET:2054-5','N','021','DEN','2039707','18575LA002000101','2014-02-01','2013-12-26 06:17:17','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2013-12-27 02:05:34'),(28341,22424,'Y','18','021','EC','A','','','AC','0000142405','0000142405','TX00003612093','IL','1','Edgar','Dana','McKenzie','','','34','454319556','9402 APPIN FALLS DR',0,'SPRING','TX','77379','6552','CY','48201','1959-02-12','F','M',':RET:2106-3','N','021','DEN','2771897','33348TX002000201','2014-04-01','2014-03-07 10:50:44','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:17'),(3252,2622,'Y','18','021','EC','A','','','AC','0000511927','0000511927','OH00001212854','IL','1','Neal','Rosanda','Marija','','','34','272170364','1282 Seneca blvd',0,'Cleveland','OH','44111',NULL,'CY','39035','2010-01-09','F','U',NULL,'N','021','DEN','384238','99734OH005000401','2014-01-01','2013-11-28 17:43:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2013-12-25 20:46:40'),(20219,16132,'Y','18','021','EC','A','','','AC','0000930937','0000930937','OH00001768169','IL','1','Alcorn','Deborah','','','','34','298505642','314 SCHOOL ST',0,'MARTINSVILLE','OH','45146','9671','CY','39027','1952-01-20','F','U',':RET:2106-3','N','021','HLT','1962511','92036OH003000605','2014-03-01','2014-01-27 15:10:45','573.00',NULL,NULL,'644.07','71.07','R-OH005','OH0','644.07',NULL,0,'2014-01-27 21:01:43'),(19301,15386,'Y','18','021','EC','A','','','AC','0001406138','0001406138','LA00001757504','31','1','ENGLISH','MARY','','','','34','439191089','PO BOX 4568',0,'BATON ROUGE','LA','70821',NULL,'CY','22033','1960-06-06','F','M',':RET:2054-5','N','021','DEN','1494443','18575LA002000101','2014-03-01','2014-01-21 11:20:37','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-22 03:22:01'),(7408,5862,'N','01','021','EC','A',NULL,NULL,'','0000804271','0000325202','','IL','1','Cadena','Guadalupe','','','Jr','34','456830134','250 E Mayfield Blvd',0,'San Antonio','TX','78214',NULL,'CY','48029','1987-03-07','M','',':RET:2148-5','N','021','DEN','144126','33348TX002000201','2014-01-01','2013-10-28 15:04:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 02:16:38'),(3310,2661,'N','19','021','EC','A',NULL,NULL,'','0000198559','0001173214','','S1','1','Latscha','Brian','','','','34','277178470','5542 KAREN AVE',0,'CINCINNATI','OH','45248','5207','CY','39061','2011-05-23','M','',':RET:2106-3','N','021','DEN','2587529','99734OH005000301','2014-01-01','2013-12-22 14:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:52'),(17322,13855,'Y','18','021','EC','A','','','AC','0000218462','0000218462','TX00001980086','IL','1','Schuur Sousa','Alexandra','','','','34','027744245','502 Southwest Parkway',0,'College Station','TX','77840',NULL,'CY','48041','1991-04-11','F','U',':RET:2106-3','N','021','DEN','2272997','33348TX002000201','2014-02-01','2014-01-10 17:38:53','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-13 02:23:51'),(4033,3220,'N','01','021','EC','A',NULL,NULL,'','0000678076','0000479829','','IL','1','Wang','Buguo','','','','34','654126780','3763 Catalina Drive',0,'Beavercreek','OH','45431',NULL,'CY','39057','1964-09-13','M','',':RET:2034-7','N','021','DEN','1586327','99734OH005000401','2014-01-01','2013-12-17 10:00:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:56'),(4643,3680,'Y','18','024','14','A','','','TE','0000694370','0000694370','','IL','1','PRESTON','ARMETHIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-15','F','',NULL,NULL,NULL,'','1007367','','2013-12-12','2013-12-12 12:58:05',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 22:06:51'),(2531,2060,'N','01','021','EC','A',NULL,NULL,'','0001241834','0000467069','','IL','1','Andreadis','Maya','','','','34','290743103','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1967-06-22','F','',':RET:2106-3','N','021','HLT','1176892','92036OH001001201','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','388.40',NULL,0,'2013-12-25 19:36:47'),(25098,19907,'Y','18','021','EC','A','','','AC','0000491906','0000491906','TX00003098325','IL','1','ZAVALA','LUZ','STELLA','','','34','455371090','8379 TAMIAMI TRL',0,'FORT WORTH','TX','76137','4934','CY','48439','1960-03-19','F','M',NULL,'N','021','DEN','2882959','33348TX002000101','2014-04-01','2014-02-21 10:51:37','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15','CIC',0,'2014-02-21 21:30:09'),(23976,19062,'Y','18','021','EC','A','','','AC','0001594364','0001594364','LA00002744029','IL','1','Gulbengay','Erin','','','','34','567657774','2523 GOVERNOR NICHOLLS ST',0,'NEW ORLEANS','LA','70119','3448','CY','22071','1981-03-02','F','U',NULL,'N','021','DEN','3460524','18575LA002000201','2014-03-01','2014-02-15 09:28:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:17'),(23836,18965,'N','19','021','EC','A',NULL,NULL,'','0000775131','0000792251','','IL','1','KEHLING','ALEXANDER','JORDAN','','','34','280983462','1167 BISHOP AVE',0,'HAMILTON','OH','45015','2165','CY','39017','1995-01-30','M','',':RET:2106-3','N','021','HLT','3243040','92036OH003001205','2014-03-01','2014-02-13 20:39:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-14 21:31:49'),(17541,14024,'Y','18','024','14','A','','','TE','0000532115','0000532115','','IL','1','Wallbridge','Noel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-06-07','M','',NULL,NULL,NULL,'','1372273','','2014-01-12','2014-01-12 11:11:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:48'),(3851,3081,'Y','18','021','EC','A','','','AC','0000067038','0000067038','LA00000076408','IL','1','Henry','Kerry','','','','34','434578629','133 S Orange Street',0,'Lafayette','LA','70501',NULL,'CY','22055','1982-01-11','M','U',':RET:2106-3','T','021','DEN','159125','18575LA002000101','2014-01-01','2013-12-13 12:53:41','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 21:35:38'),(4237,3374,'Y','18','021','EC','A','','','AC','0000404120','0000404120','TX00000788360','IL','1','GRACE','ROBERT','','','','34','014449514','735 JOEL DR',0,'TYLER','TX','75703','4841','CY','48423','1953-05-05','M','M',':RET:2054-5','N','021','DEN','2248811','33348TX002000201','2014-01-01','2013-12-17 15:04:42','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 21:50:54'),(4437,3527,'Y','18','021','EC','A','','','AC','0001225689','0001225689','OH00001122208','IL','1','Hanzel','Matthew','Alan','','','34','277887924','211 6TH ST',0,'TORONTO','OH','43964','1461','CY','39081','1987-12-12','M','R',':RET:2106-3','N','021','DEN','922577','99734OH005000301','2014-01-01','2013-12-11 18:54:58','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:02:04'),(26931,21343,'Y','18','021','EC','A','','','AC','0000816481','0000816481','OH00002910456','IL','1','SMITH','MARY','','','','34','451928043','3025 LAKE SHORE DR',0,'LIMA','OH','45806',NULL,'CY','39003','1954-09-10','F','U',NULL,'N','021','DEN','2624208','99734OH005000401','2014-04-01','2014-03-02 17:02:42','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-03-03 01:00:20'),(27610,21836,'Y','18','024','14','A','','','TE','0001888275','0001888275','','IL','1','RICHARD','JAUNITA','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-03','F','',NULL,NULL,NULL,'','3430458','','2014-03-05','2014-03-05 17:37:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-03-05 21:00:28'),(583,478,'Y','18','021','EC','A','','','AC','0001117210','0001117210','OH00000199657','IL','1','May','Joelle','','','','34','290740752','326 N Walnut Street',0,'Van Wert','OH','45891',NULL,'CY','39161','1966-10-15','F','M',':RET:2106-3','N','021','HLT','184462','92036OH004001501','2014-01-01','2013-12-04 16:38:38','274.58',NULL,NULL,'276.60','2.02','R-OH002','OH0','276.60',NULL,0,'2013-12-25 17:50:58'),(21300,17020,'Y','18','021','EC','A','','','AC','0001529380','0001529380','LA00002518553','IL','1','Nadjafi Sadati','Leslie','','','','34','439150766','10888 Buddy Ellis Road',0,'Denham Springs','LA','70726',NULL,'CY','22063','1965-12-19','F','M',':RET:2106-3','N','021','DEN','2636155','18575LA002000201','2014-03-01','2014-02-03 19:04:37','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-04 21:00:12'),(19477,15525,'Y','18','021','EC','A','','','AC','0000558004','0000558004','TX00002011106','IL','1','Brooks','Rita','','','','34','432151361','3348 KEITH AVE',0,'KILLEEN','TX','76543','4472','CY','48027','1977-02-09','F','U',':RET:2054-5','N','021','DEN','1591322','33348TX002000201','2014-03-01','2014-01-22 11:51:31','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-23 03:02:02'),(27394,21687,'Y','18','021','EC','A','','','AC','0001074204','0001074204','OH00003075254','IL','1','HARKINS','ALLEN','','','','34','274461751','527 CLARENDON AVE NW',0,'CANTON','OH','44708','4463','CY','39151','1949-11-25','M','M',':RET:2106-3','T','021','DEN','3779316','99734OH005000301','2014-04-01','2014-03-03 18:53:34','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-03-04 21:01:28'),(18460,14726,'N','01','021','EC','A',NULL,NULL,'','0002339696','0002168353','','IL','1','burton','rebecca','','','','34','439410637','18256 manchac acres dr',0,'Prairieville','LA','70769',NULL,'CY','22005','1979-01-14','F','',':RET:2106-3','N','021','DEN','2453725','18575LA002000101','2014-02-01','2014-01-15 14:15:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-16 08:46:12'),(23416,18657,'Y','18','021','EC','A','','','AC','0001062564','0001062564','TX00002290818','IL','1','QUIROZ','DIANA','','','','34','462258961','905 W POWELL ST',0,'BEEVILLE','TX','78102','6614','CY','48025','1957-06-17','F','M',NULL,'N','021','DEN','3651472','33348TX002000201','2014-03-01','2014-02-12 20:34:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:19'),(9189,7287,'N','01','021','EC','A',NULL,NULL,'','0000232645','0001167990','','IL','1','yanglam','kwaiching','','','','34','126808445','108 S WALNUT ST',0,'NEW BREMEN','OH','45869','1239','CY','39011','1965-10-02','F','',':RET:2034-7','N','021','HLT','1864053','92036OH005001505','2014-01-01','2013-12-18 15:39:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','359.84',NULL,0,'2013-12-26 04:09:20'),(16337,13079,'N','01','021','EC','A',NULL,NULL,'','0001147348','0001071791','','IL','1','Moore','John','','','','34','298802864','56594 HOMER WARRICK RD',0,'BARNESVILLE','OH','43713','9673','CY','39013','1968-03-03','M','',NULL,'N','021','DEN','1967494','99734OH005000301','2014-02-01','2014-01-06 12:16:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:10'),(15345,12274,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1843875','','2014-01-01','2014-01-01 12:20:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:24:22'),(27994,22151,'Y','18','024','14','A','','','TE','0000521015','0000521015','','IL','1','DECKER','KEVIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-21','M','',NULL,NULL,NULL,'','3849584','','2014-03-05','2014-03-05 19:06:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:01:05'),(28112,22249,'Y','18','021','EC','A','','','AC','0000270083','0000270083','OH00002632189','IL','1','ZAWISTOWSKI','JOHN','','','','34','277466950','820 W TURKEYFOOT LAKE RD',0,'AKRON','OH','44319','3309','CY','39153','1951-06-24','M','U',':RET:2106-3','T','021','HLT','3375845','52664OH152000901','2014-04-01','2014-03-06 15:47:44','479.00',NULL,NULL,'539.67','60.67','R-OH012','OH0','539.67',NULL,0,'2014-03-06 21:02:15'),(28827,22814,'Y','18','021','EC','A','','','AC','0000582865','0000582865','OH00002879026','IL','1','Price','Benjamin','Stafford','','','34','282827762','5784 LESLIE DR',0,'FAIRFIELD','OH','45014','4713','CY','39017','1975-03-08','M','U',':RET:2106-3','N','021','HLT','4023877','92036OH003001206','2014-04-01','2014-03-09 11:03:32','173.00',NULL,NULL,'282.91','109.91','R-OH004','OH0','282.91',NULL,0,'2014-03-09 21:01:04'),(28998,22950,'Y','18','021','EC','A','','','AC','0000240423','0000240423','OH00002814622','IL','1','mckinney','heather',NULL,NULL,NULL,NULL,NULL,'20 Surrey Court',0,'monroeville','OH','44847',NULL,'CY','39077','1992-07-31','F','M',NULL,'N','021','HLT','3499043','92036OH004002701','2014-04-01','2014-03-09 19:13:16','311.28',NULL,NULL,'313.58','2.30','R-OH006','OH0','156.79',NULL,0,'2014-03-10 21:01:17'),(561,460,'Y','18','021','EC','A','','','AC','0001038568','0001038568','OH00000316912','IL','1','HILLIARD','DIANA','','','','34','279629882','6660 STATE ROUTE 753',0,'HILLSBORO','OH','45133','9324','CY','39071','1962-10-17','F','M',NULL,'N','021','HLT','815893','92036OH002000601','2014-01-01','2013-12-04 15:12:01','43.00',NULL,NULL,'462.36','419.36','R-OH005','OH0','462.36',NULL,0,'2013-12-25 17:50:19'),(13765,10987,'Y','18','021','EC','A','','','AC','0000996395','0000996395','MS00000670292','IL','1','edwards','david','','','','34','436358696','441 Hillandale Dr',0,'Jackson','MS','39212',NULL,'CY','28049','1967-01-25','M','U',':RET:2054-5','N','021','DEN','1852505','46300MS002000201','2014-01-01','2013-12-23 10:41:04','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:20'),(13180,10514,'Y','18','021','EC','A','','','AC','0000867606','0000867606','TX00000037579','IL','1','Day','Matthew','Wayne','','','34','466933983','5707 SHADY HILL LN',0,'ARLINGTON','TX','76016','2122','CY','48439','1978-06-21','M','U',':RET:2106-3','N','021','DEN','1792176','33348TX002000101','2014-01-01','2013-12-22 20:03:29','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:17'),(2396,1956,'Y','18','021','EC','A','','','AC','0000519804','0000519804','OH00001311974','IL','1','Karadeniz','Courtney','L','','','34','275802257','322 BROOKFOREST DR',0,'CINCINNATI','OH','45238','5610','CY','39061','1982-12-06','F','U',':RET:2106-3','N','021','DEN','817043','99734OH005000401','2014-01-01','2013-12-09 12:52:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:25'),(5922,4690,'Y','18','021','EC','A','','','AC','0000889695','0000889695','TX00000050771','IL','1','Doberson','Chad','','','','34','449657937','2655 SKYVIEW RIDGE CT',0,'HOUSTON','TX','77047','6518','CY','48201','1970-12-23','M','M',':RET:2054-5','N','021','DEN','2294967','33348TX002000101','2014-01-01','2013-12-24 00:54:32','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:50:19'),(5783,4594,'Y','18','021','EC','A','','','AC','0000707622','0000707622','OH00000422593','IL','1','Latta','Douglas','','','','34','564290596','P.O. Box 43',0,'Curtice','OH','43412',NULL,'CY','39123','1957-06-28','M','M',':RET:2106-3','N','021','DEN','2009430','99734OH005000401','2014-01-01','2013-12-23 23:32:23','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 23:47:06'),(1971,1610,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','979570','','2013-11-19','2013-11-19 23:00:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:29'),(22539,17997,'Y','18','021','EC','A','','','AC','0001214423','0001214423','LA00001577298','IL','1','Truong','Hue','','','','34','661012368','2479 77TH AVE',0,'BATON ROUGE','LA','70807','5602','CY','22033','1956-07-22','F','U',':RET:2047-9','N','021','DEN','3038095','18575LA002000101','2014-03-01','2014-02-09 23:09:35','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-10 21:31:38'),(22947,18295,'Y','18','021','EC','A','','','AC','0000108294','0000108294','MS00002159881','IL','1','King','Ashley','','','','34','428475701','5 stardust drive',0,'Natchez','MS','39120',NULL,'CY','28001','1983-08-02','F','U',':RET:2054-5','N','021','DEN','3742733','46300MS002000101','2014-03-01','2014-02-11 08:30:06','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15','CIC',0,'2014-02-11 21:30:24'),(26202,20780,'Y','18','021','EC','A','','','AC','0000648380','0000648380','OH00002810250','IL','1','WAGONER','MARIE','','','','34','281585357','1194 N MAIN ST',0,'AKRON','OH','44310','1046','CY','39153','1958-01-08','F','U',NULL,'N','021','HLT','3275945','52664OH151001304','2014-04-01','2014-02-27 09:41:05','324.00',NULL,NULL,'520.28','196.28','R-OH012','OH0','520.28',NULL,0,'2014-02-28 06:30:49'),(29180,23095,'Y','18','021','EC','A','','','AC','0000695706','0000695706','OH00002608023','IL','1','Sabatino','Dominic','','','','34','292441027','56953 W 53RD ST',0,'SHADYSIDE','OH','43947','9719','CY','39013','1956-02-06','M','M',':RET:2106-3','N','021','DEN','4211319','99734OH005000401','2014-04-01','2014-03-09 22:21:27','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00','CIC',0,'2014-03-10 21:29:57'),(5530,4386,'Y','18','021','EC','A','','','AC','0000998743','0000998743','OH00001274835','IL','1','lantz','allan','','','','34','269964380','871 lovers lane st',0,'AKRON','OH','44306',NULL,'CY','39153','1992-08-25','M','U',':RET:2106-3','N','021','DEN','988587','99734OH005000401','2014-01-01','2013-11-27 10:08:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:15:33'),(6416,5086,'Y','18','021','EC','A','','','AC','0001147312','0001147312','OH00000876440','IL','1','Oliver','Bonita','','','','34','172382719','6177 Roundhead Rd',0,'New Vienna','OH','45159',NULL,'CY','39071','1954-01-27','F','M',':RET:2106-3','N','021','HLT','257605','92036OH003000605','2014-01-01','2013-12-11 08:42:37','453.00',NULL,NULL,'583.55','130.55','R-OH005','OH0','583.55',NULL,0,'2013-12-26 00:48:45'),(6712,5322,'Y','18','021','EC','A','','','AC','0000132367','0000132367','TX00001236276','IL','1','wright','joe','','','','34','451900723','1231 huisache',0,'new braunfels','TX','78130',NULL,'CY','48091','1949-10-16','M','U',':RET:2106-3','T','021','DEN','490662','33348TX002000101','2014-01-01','2013-11-05 13:42:12','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 01:02:18'),(17303,13838,'Y','18','021','EC','A','','','AC','0000574921','0000574921','TX00001396390','IL','1','Pitts','Michael','','','','34','466158728','6821 HIGHWAY 6',0,'DE LEON','TX','76444','6933','CY','48093','1966-07-25','M','M',NULL,'N','021','DEN','1939768','33348TX002000201','2014-02-01','2014-01-10 12:05:47','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:40'),(17493,13987,'N','01','021','EC','A',NULL,NULL,'','0001967146','0001962361','','IL','1','ARMSTRONG','DAVID','','','','34','439026026','325 SANDSTONE CIR',0,'ZWOLLE','LA','71486','2764','CY','22085','1958-08-03','M','',':RET:2106-3','N','021','DEN','1791473','18575LA002000201','2014-02-01','2014-01-11 22:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 03:01:21'),(18425,14699,'N','01','021','EC','A',NULL,NULL,'','0001208246','0001914739','','IL','1','Hemingway','Johnathan',NULL,NULL,NULL,NULL,NULL,'5623 Milne Boulevard',0,'New Orleans','LA','70124',NULL,'CY','22071','1985-08-28','M','',NULL,'N','021','DEN','2489815','18575LA002000201','2014-02-01','2014-01-15 00:53:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:45:55'),(21354,17067,'Y','18','021','EC','A','','','AC','0000144679','0000144679','TX00001907894','IL','1','dixon','shawda','','','','34','628302486','9320 MCLEAN ST',0,'BEAUMONT','TX','77707','1131','CY','48245','1992-04-10','F','U',':RET:2054-5','N','021','DEN','2994780','33348TX002000201','2014-03-01','2014-02-04 13:44:06','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-02-04 21:00:39'),(24408,19388,'Y','18','021','EC','A','','','AC','0001063294','0001063294','OH00002384170','IL','1','ROJAS','LUIS','','','','34','598070785','2108 DENNISON AVE',0,'CLEVELAND','OH','44109',NULL,'CY','39035','1986-09-02','M','M',NULL,'N','021','DEN','2818382','99734OH005000401','2014-04-01','2014-02-18 17:57:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:00:59'),(26286,20850,'Y','18','021','EC','A','','','AC','0001176199','0001176199','LA00003351975','31','1','Johnson','Debra','','','','34','434947117','P.O. Box 362',0,'Krotz Springs','LA','70750',NULL,'CY','22097','1960-09-25','F','U',':RET:2106-3','N','021','DEN','3230059','18575LA002000101','2014-04-01','2014-02-27 11:12:01','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-28 06:31:22'),(3977,3177,'N','19','021','EC','A',NULL,NULL,'','0000971452','0000236250','','IL','1','King','Kayleigh','Grace','','','34','369891203','910 CORNELL DR',0,'LIMA','OH','45805','1622','CY','39003','2012-10-26','F','',':RET:2106-3','N','021','HLT','155695','92036OH003001504','2014-01-01','2013-12-13 12:17:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 21:38:45'),(6459,5119,'Y','18','021','EC','A','','','AC','0000881600','0000881600','OH00000165157','IL','1','TAKACH','BRUCE','','','','34','291567856','680 WHIPPOORWILL LN',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1955-02-22','M','M',':RET:2106-3','N','021','HLT','895273','52664OH151001501','2014-01-01','2013-12-11 10:25:38','576.00',NULL,NULL,'1363.00','787.00','R-OH012','OH0','681.50',NULL,0,'2013-12-26 00:49:52'),(7643,6051,'Y','18','021','EC','A','','','AC','0000644634','0000644634','OH00001148992','IL','1','Estridge','Christopher','','','','34','404290349','3081 Neisel Ave',0,'Cincinnati','OH','45248',NULL,'CY','39061','1986-07-24','M','M',':RET:2106-3','N','021','DEN','530872','99734OH005000401','2014-01-01','2013-11-10 11:38:30','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:46:38'),(14243,11358,'Y','18','021','EC','A','','','AC','0000763397','0000763397','TX00000902859','IL','1','Johnson','Rick','','','','34','450897808','3306 MIDLANDS CIR',0,'EDINBURG','TX','78539','7754','CY','48215','1983-07-06','M','U',':RET:2106-3','T','021','DEN','1687164','33348TX002000101','2014-02-01','2013-12-26 01:37:25','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-27 02:05:18'),(14999,11988,'Y','18','021','EC','A','','','AC','0000969849','0000969849','TX00000969098','IL','1','gomez','mario','','','','34','545358515','625 FELIZ PL',0,'EL PASO','TX','79905','5118','CY','48141','1955-01-19','M','M',':RET:2106-3','N','021','DEN','1513330','33348TX002000201','2014-02-01','2013-12-30 17:57:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-01 12:01:39'),(14303,11410,'Y','18','021','EC','A','','','AC','0000637113','0000637113','OH00001707346','IL','1','WALKER','TERRY','','','','34','384561132','19533 WILLIAMS RD',0,'WAPAKONETA','OH','45895','7852','CY','39011','1951-06-23','M','U',':RET:2106-3','T','021','HLT','2611128','92036OH006001501','2014-02-01','2013-12-26 11:26:24','572.45',NULL,NULL,'576.67','4.22','R-OH002','OH0','576.67',NULL,0,'2013-12-27 02:06:53'),(15682,12544,'Y','18','021','EC','A','','','AC','0000011170','0000011170','OH00001535065','IL','1','Leibold','Susan','','','','34','302620454','400 Greenler Rd',0,'Defiance','OH','43512',NULL,'CY','39039','1957-01-22','F','U',':RET:2106-3','N','021','HLT','2243438','92036OH005002601','2014-02-01','2013-12-31 11:57:06','192.00',NULL,NULL,'475.21','283.21','R-OH001','OH0','475.21',NULL,1,'2014-01-02 04:35:00'),(15918,12746,'Y','18','021','EC','A','','','AC','0001066990','0001066990','OH00001788172','IL','1','Sattler','Cindy','','','','34','291585223','15218 MERMILL RD',0,'RUDOLPH','OH','43462','9631','CY','39173','1962-09-18','F','U',':RET:2106-3','N','021','HLT','2160653','92036OH002002601','2014-02-01','2014-01-02 14:50:52','185.00',NULL,NULL,'419.99','234.99','R-OH001','OH0','419.99',NULL,0,'2014-01-03 02:06:33'),(22839,18224,'Y','18','021','EC','A','','','AC','0000027927','0000027927','OH00002603440','IL','1','Reichenbach','Gregory','','','','34','301821213','10790 BIXEL RD',0,'BLUFFTON','OH','45817','9506','CY','39003','1970-04-30','M','M',NULL,'N','021','HLT','3376536','92036OH004001501','2014-03-01','2014-02-10 21:15:35','459.00',NULL,NULL,'599.75','140.75','R-OH002','OH0','240.14',NULL,0,'2014-02-11 21:02:13'),(25432,20179,'N','01','021','EC','A',NULL,NULL,'','0000375619','0000322044','','IL','1','HONG','KYUNG DUK','','','','34','629968724','1009 LIVERMORE ST',0,'PORTLAND','TX','78374','4209','CY','48409','1970-01-10','F','',':RET:2040-4','N','021','DEN','3174494','33348TX002000201','2014-04-01','2014-02-24 20:26:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:15'),(26439,20971,'Y','18','021','EC','A','','','AC','0000050735','0000050735','OH00002708596','IL','1','Cline','Thomas','Richard','','','34','273447392','1520 ORANGE RD',0,'ASHLAND','OH','44805','1573','CY','39005','1951-05-14','M','U',':RET:2106-3','N','021','DEN','2834461','99734OH005000401','2014-04-01','2014-02-27 14:03:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-28 07:30:19'),(4950,3929,'Y','18','024','14','A','','','TE','0000426398','0000426398','','IL','1','Brooker','Lee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-12-03','M','',NULL,NULL,NULL,'','912272','','2013-12-07','2013-12-07 15:49:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:45:55'),(8909,7066,'Y','18','021','EC','A','','','AC','0000687206','0000687206','OH00001085275','IL','1','Friedman','Aaron','','','','34','291604112','3773 Langhorst Ct.',0,'Cincinnati','OH','45243',NULL,'CY','39061','1977-06-30','M','U',':RET:2106-3','N','021','DEN','1503081','99734OH005000401','2014-01-01','2013-12-17 20:38:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:02:31'),(24373,19359,'Y','18','024','14','A','','','TE','0001211629','0001211629','','IL','1','LaFargue','Richard','A','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-07-25','M','',NULL,NULL,NULL,'','3622055','','2014-02-18','2014-02-18 16:23:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-18 22:00:39'),(25502,20232,'Y','18','021','EC','A','','','AC','0000400788','0000400788','TX00002443314','IL','1','HUSCROFT','AMBER','','','','34','466990799','15398 CACTUS BLOSSOM DR',0,'EL PASO','TX','79938','8357','CY','48141','1981-12-28','F','U',':RET:2106-3','N','021','DEN','2664878','33348TX002000101','2014-04-01','2014-02-25 13:55:09','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-25 21:31:55'),(26446,20977,'Y','18','021','EC','A','','','AC','0000971518','0000971518','OH00002810266','S1','1','Habli','firas','','','','34','302088105','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2004-08-11','M','U',NULL,'N','021','DEN','3569754','99734OH005000301','2014-03-01','2014-02-27 14:31:36','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13','CIC',0,'2014-02-28 07:30:23'),(26972,21369,'Y','18','021','EC','A','','','AC','0001252181','0001252181','OH00003073151','IL','1','Randles','Maynard','','','','34','283484777','552 PICADILLY CIR',0,'AKRON','OH','44319','1377','CY','39153','1950-01-20','M','M',':RET:2106-3','N','021','HLT','2639465','52664OH152000901','2014-05-01','2014-03-02 07:47:22','0.00',NULL,NULL,'888.06','888.06','R-OH012','OH0','490.00',NULL,0,'2014-03-03 01:00:35'),(27341,21650,'Y','18','021','EC','A','','','AC','0000787257','0000787257','OH00002586437','IL','1','LEWIS','JEROME','','','','34','300562598','734 CARLSBAD RD',0,'CINCINNATI','OH','45240','3646','CY','39061','1956-01-31','M','M',':RET:2054-5','T','021','DEN','3080223','99734OH005000401','2014-04-01','2014-03-04 10:25:43','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-03-04 21:00:59'),(6921,5494,'Y','18','021','EC','A','','','AC','0000179903','0000179903','OH00001653993','IL','1','SHAMANSKY','KELSEY','','','','34','290806287','9568 CLIFFVIEW ST NW',0,'CLINTON TOWNSHIP','OH','44216',NULL,'CY','39151','1970-07-03','F','M',':RET:2106-3','N','021','DEN','2573614','99734OH005000401','2014-01-01','2013-12-24 18:59:37','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2013-12-26 01:46:13'),(5683,4509,'N','01','021','EC','A',NULL,NULL,'','0001235138','0001225683','','IL','1','Whitaker','Brittney','M','','','34','275949879','628 E LAKE ST',0,'TOLEDO','OH','43608','1326','CY','39095','1991-10-18','F','',':RET:2054-5','N','021','HLT','570024','92036OH006002601','2014-01-01','2013-11-25 22:45:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','154.64',NULL,0,'2013-12-25 23:32:23'),(2424,1975,'Y','18','021','EC','A','','','AC','0000902185','0000902185','OH00000431550','IL','1','HORVATH','ALAN','','','','34','278848072','861 WISTERIA DR',0,'BARBERTON','OH','44203','4467','CY','39153','1968-03-09','M','M',':RET:2106-3','N','021','DEN','196464','99734OH005000401','2014-01-01','2013-12-09 16:18:51','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:33:59'),(8053,6376,'Y','18','021','EC','A','','','AC','0000317334','0000317334','OH00000018825','IL','1','Wilson','Gwendolyn','','','','34','386600148','1020 FERNWOOD AVE',0,'TOLEDO','OH','43607','1901','CY','39095','1953-11-10','F','R',':RET:2054-5','N','021','HLT','2259081','92036OH004002601','2014-01-01','2013-12-20 18:01:58','0.00',NULL,NULL,'425.53','425.53','R-OH001','OH0','425.53',NULL,0,'2013-12-26 03:09:45'),(19693,15693,'Y','18','024','14','A','','','TE','0000515685','0000515685','','IL','1','Grizzle','Dorinda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-22','F','',NULL,NULL,NULL,'','1507940','','2014-01-23','2014-01-23 18:20:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:44'),(14406,11488,'Y','18','021','EC','A','','','AC','0000436608','0000436608','OH00001226138','IL','1','Shatteen','Brittany','','','','34','285768935','1170 Creekledge Ct',0,'Streetsboro','OH','44241',NULL,'CY','39133','1979-12-25','F','M',':RET:2054-5','N','021','DEN','1860319','99734OH005000401','2014-02-01','2013-12-27 17:53:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-28 03:31:20'),(25376,20134,'Y','18','021','EC','A','','','AC','0001097825','0001097825','OH00003310494','IL','1','Barber','Lawanna','','','','34','299806505','326 Brookhaven Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','1971-01-03','F','M',':RET:2054-5','N','021','DEN','2931619','99734OH005000301','2014-04-01','2014-02-25 16:20:10','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:44'),(27674,21889,'Y','18','021','EC','A','','','AC','0000376794','0000376794','TX00002198279','IL','1','BONDONI','JOSE','UBERTO','','','34','027084062','6320 BRISA DEL MAR DR',0,'EL PASO','TX','79912','1839','CY','48141','1973-11-03','M','M',':RET:2106-3','N','021','DEN','3672515','33348TX002000201','2014-04-01','2014-03-04 19:36:21','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:30:35'),(28691,22706,'Y','18','021','EC','A','','','AC','0000203147','0000203147','OH00003690484','IL','1','EVANS-HENRY','BECKY','','','','34','278524973','1297 W COMET RD',0,'CLINTON','OH','44216','9666','CY','39153','1951-08-30','F','M',NULL,'N','021','HLT','3724542','52664OH152000901','2014-04-01','2014-03-08 15:31:30','735.00',NULL,NULL,'912.59','177.59','R-OH012','OH0','469.28',NULL,0,'2014-03-08 21:31:03'),(2799,2262,'N','01','021','EC','A',NULL,NULL,'','0000201897','0000093812','','IL','1','berry','michael','','','','34','275608673','12 n hazelwood',0,'youngstown','OH','44509',NULL,'CY','39099','1958-01-05','M','',':RET:2106-3','N','021','HLT','226447','92036OH002003201','2014-01-01','2013-12-02 12:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','623.35',NULL,0,'2013-12-25 19:50:22'),(17791,14212,'Y','18','021','EC','A','','','AC','0000134595','0000134595','OH00001456338','IL','1','Vodney','Lisa','','','','34','284663313','2368 ANDERSON RD',0,'CUYAHOGA FALLS','OH','44221','3657','CY','39153','1959-03-14','F','M',NULL,'T','021','HLT','2081622','52664OH151001501','2014-02-01','2014-01-13 15:30:39','504.00',NULL,NULL,'1202.32','698.32','R-OH012','OH0','656.69',NULL,0,'2014-01-14 01:33:48'),(17286,13824,'Y','18','021','EC','A','','','AC','0001005618','0001005618','TX00001809533','IL','1','quintanilla','juan','','','','34','454536552','1700 CAVITT AVE',0,'BRYAN','TX','77801','1207','CY','48041','1974-08-18','M','U',NULL,'N','021','DEN','2581670','33348TX002000201','2014-02-01','2014-01-09 18:57:12','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-13 02:23:28'),(16137,12925,'Y','18','021','EC','A','','','AC','0000685860','0000685860','OH00001253679','IL','1','Gallion','Brandon','','','','34','283903544','24 21ST ST NW',0,'BARBERTON','OH','44203','7124','CY','39153','1988-08-24','M','U',':RET:2106-3','N','021','HLT','1945856','52664OH152000901','2014-02-01','2014-01-03 10:38:44','163.99',NULL,NULL,'163.99','0.00','R-OH012','OH0','163.99',NULL,0,'2014-01-04 02:05:52'),(7765,6149,'N','19','021','EC','A',NULL,NULL,'','0000045757','0000868228','','IL','1','Seung','Eunyoung',NULL,NULL,NULL,NULL,NULL,'1914 N NANTUCKET DR',0,'LORAIN','OH','44053','3224','CY','39093','1992-12-05','F','',':RET:2040-4','N','021','DEN','2402355','99734OH005000401','2014-01-01','2013-12-20 18:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:49'),(5013,3972,'N','01','021','EC','A',NULL,NULL,'','0000581452','0000669152','','IL','1','watkins','judith','','','','34','300724415','4816 forest glen trail',0,'ravenna','OH','44266',NULL,'CY','39133','1963-07-24','F','',':RET:2106-3','N','021','DEN','598783','99734OH005000301','2014-01-01','2013-12-07 17:19:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:20'),(24336,19326,'Y','18','021','EC','A','','','AC','0000598459','0000598459','TX00002999954','IL','1','GUZMAN','VERONICA','','','','34','644101279','2101 S LAKELINE BLVD',0,'CEDAR PARK','TX','78613','3939','CY','48491','1984-02-29','F','M',NULL,'N','021','DEN','3546513','33348TX002000201','2014-04-01','2014-02-18 14:07:07','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:16'),(24441,19414,'Y','18','021','EC','A','','','AC','0000433959','0000433959','OH00002125055','31','1','Amburgey','Rita','','','','34','277560832','P.O. Box 17',0,'Willshire','OH','45898',NULL,'CY','39161','1959-11-29','F','U',':RET:2106-3','N','021','HLT','3754324','92036OH006001501','2014-04-01','2014-02-18 11:45:35','290.00',NULL,NULL,'372.65','82.65','R-OH002','OH0','372.65',NULL,0,'2014-02-18 22:01:19'),(26097,20697,'Y','18','021','EC','A','','','AC','0002084508','0002084508','LA00002400619','IL','1','duhe','regina','','','','34','415175216','3423 WENDY ST',0,'PAULINA','LA','70763','2360','CY','22093','1960-04-02','F','U',':RET:2106-3','N','021','DEN','3544316','18575LA002000201','2014-04-01','2014-02-27 14:37:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:11'),(6239,4945,'Y','18','021','EC','A','','','AC','0001221906','0001221906','OH00000654904','IL','1','Miller','Chirstopher','Lee','','','34','288769350','313 FRANKLIN ST',0,'MIDDLETOWN','OH','45042','3245','CY','39017','1980-11-10','M','U',':RET:2106-3','N','021','DEN','736952','99734OH005000301','2014-01-01','2013-11-18 23:37:50','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:31:38'),(21560,17224,'Y','18','021','EC','A','','','AC','0001056741','0001056741','OH00001691638','IL','1','Mei','Jing Fu','','','','34','123906314','4118 SCHENCK AVE',0,'CINCINNATI','OH','45236','2528','CY','39061','1955-12-08','M','M',':RET:2034-7','N','021','DEN','2926239','99734OH005000401','2014-03-01','2014-02-05 17:18:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:18'),(20757,16583,'N','01','021','EC','A',NULL,NULL,'','0000152011','0001114561','','IL','1','Henry','Melissa','','','','34','403172076','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1965-07-06','F','',':RET:2106-3','N','021','HLT','3188235','92036OH005001201','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','350.99',NULL,0,'2014-01-30 21:01:32'),(1450,1210,'Y','18','021','EC','A','','','AC','0001102092','0001102092','OH00001157870','31','1','DeBault','Lance','','','','34','382760715','PO Box 532011',0,'Cincinnati','OH','45253',NULL,'CY','39061','1970-03-28','M','U',':RET:2106-3','N','021','DEN','2444746','99734OH005000401','2014-01-01','2013-12-24 07:16:54','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:48:05'),(18653,14870,'N','01','021','EC','A',NULL,NULL,'','0000083778','0000082320','','IL','1','GOMEZ','JOSE','','','','34','453472377','820 S STAPLES ST',0,'CORPUS CHRISTI','TX','78404','3233','CY','48355','1976-02-25','M','',':RET:2106-3','T','021','DEN','2963719','33348TX002000201','2014-03-01','2014-01-16 11:06:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:11'),(18035,14407,'Y','18','021','EC','A','','','AC','0000808676','0000808676','OH00001740588','IL','1','Caynor','Sheila','','','','34','301463843','4124 HAWAII AVE',0,'NORTON','OH','44203','6171','CY','39153','1950-08-23','F','U',':RET:2106-3','N','021','DEN','2171056','99734OH005000301','2014-02-01','2014-01-14 18:07:54','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:07:10'),(7601,6015,'Y','18','021','EC','A','','','AC','0000166337','0000166337','OH00000257892','IL','1','dodge','tyler','','','','34','299765662','4323 meadowcroft',0,'kettering','OH','45429',NULL,'CY','39113','1980-04-07','M','M',':RET:2106-3','N','021','DEN','60033','99734OH005000401','2014-01-01','2013-11-17 17:43:19','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:45:23'),(16324,13069,'Y','18','021','EC','A','','','AC','0001705655','0001705655','LA00002278757','IL','1','Labat','Skye','','','','34','434814816','1516 MENVILLE ST',0,'HOUMA','LA','70360','6532','CY','22109','1988-03-21','F','U',':RET:2054-5','N','021','DEN','2567394','18575LA002000201','2014-02-01','2014-01-05 21:08:53','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-07 04:01:46'),(7636,6045,'Y','18','021','EC','A','','','AC','0000039768','0000039768','OH00000343787','IL','1','Crain','Darrell','','','','34','285749790','2305 GRAND BLVD',0,'HAMILTON','OH','45011','4519','CY','39017','1979-04-02','M','U',NULL,'N','021','HLT','788225','92036OH004001202','2014-01-01','2013-10-14 10:20:06','0.00',NULL,NULL,'209.55','209.55','R-OH004','OH0','209.55',NULL,0,'2013-12-26 02:46:25'),(8000,6330,'N','19','021','EC','A',NULL,NULL,'','0000768872','0000744425','','IL','1','Chasteen','Lydia','','','','34','289022725','7340 PAWNEE RD',0,'SPENCER','OH','44275','9764','CY','39103','1996-07-31','F','',':RET:2028-9','N','021','HLT','2490235','52664OH151001304','2014-01-01','2013-12-20 16:31:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 03:08:21'),(13512,10770,'Y','18','021','EC','A','','','AC','0000344180','0000344180','LA00000663437','IL','1','Lavis','William','','','','34','437575504','100 S CORTEZ ST',0,'NEW ORLEANS','LA','70119','6119','CY','22071','1970-07-07','M','U',':RET:2106-3','N','021','DEN','1575865','18575LA002000201','2014-01-01','2013-12-22 22:42:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:02:56'),(24596,19527,'Y','18','021','EC','A','','','AC','0000788253','0000788253','OH00002089912','IL','1','Sexton','Ryan','','','','34','286809279','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','1983-06-24','M','M',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:12:05'),(25132,19935,'Y','18','021','EC','A','','','AC','0000645588','0000645588','TX00002455676','IL','1','Crandell','Ramona','','','','34','457276894','12015 LUCKY MEADOW DR',0,'TOMBALL','TX','77375','7570','CY','48201','1959-03-28','F','U',':RET:2106-3','N','021','DEN','3041961','33348TX002000201','2014-04-01','2014-02-20 21:12:17','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-21 22:00:04'),(6635,5263,'Y','18','021','EC','A','','','AC','0000346848','0000346848','OH00000578306','IL','1','Sharpe','Keven','James','','','34','288867509','607 US HIGHWAY 224',0,'SULLIVAN','OH','44880','9718','CY','39005','1972-09-30','M','U',':RET:2106-3','N','021','DEN','111503','99734OH005000401','2014-01-01','2013-11-12 13:30:28','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:00:08'),(5634,4469,'Y','18','024','14','A','','','TE','0000706163','0000706163','','IL','1','Harris','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-20','F','',NULL,NULL,NULL,'','360526','','2013-11-26','2013-11-26 15:56:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:31:02'),(19958,15920,'Y','18','021','EC','A','','','AC','0000693583','0000693583','TX00002243078','IL','1','Eads','Agaytha','','','','34','455868843','420 HCR 2421 W',0,'HILLSBORO','TX','76645','5222','CY','48217','1950-03-19','F','U',':RET:2106-3','N','021','DEN','3034079','33348TX002000201','2014-03-01','2014-01-24 22:50:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-25 19:00:06'),(19144,15252,'Y','18','021','EC','A','','','AC','0001188953','0001188953','TX00002456449','IL','1','Einhaus','Shirl','','','','34','465351950','6361 STATE HIGHWAY 79 N',0,'WICHITA FALLS','TX','76305','2768','CY','48485','1966-09-14','F','U',':RET:2106-3','N','021','DEN','2236272','33348TX002000201','2014-03-01','2014-01-19 17:24:13','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-21 08:45:30'),(19087,15206,'Y','18','021','EC','A','','','AC','0000890778','0000890778','OH00001866502','IL','1','Dale','Kayleigh','R','','','34','412950560','505 N CLINTON ST',0,'DEFIANCE','OH','43512','1606','CY','39039','2003-04-22','F','R',':RET:2106-3','N','021','DEN','3076954','99734OH005000401','2014-03-01','2014-01-18 16:07:10','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','15.78',NULL,0,'2014-01-21 08:44:29'),(19008,15138,'Y','18','024','14','A','','','TE','0001640013','0001640013','','IL','1','Leary','Arnold','F',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-11','M','',NULL,NULL,NULL,'','1639262','','2014-01-17','2014-01-17 12:04:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-20 08:06:19'),(18786,14964,'Y','18','021','EC','A','','','AC','0000359703','0000359703','OH00001811147','IL','1','Huelskamp','Bernard','','','','34','298547968','1877 Kremer Rd.',0,'Maria Stein','OH','45860',NULL,'CY','39107','1958-11-23','M','M',NULL,'N','021','DEN','1766210','99734OH005000401','2014-02-01','2014-01-15 21:55:15','0.00',NULL,NULL,'71.95','71.95','R-OH002','OH0','0.00',NULL,0,'2014-01-17 03:35:54'),(15770,12619,'Y','18','021','EC','A','','','AC','0000297310','0000297310','TX00000979343','IL','1','Robles','Sarai','','','','34','636485122','1001 LARRY RD',0,'CANUTILLO','TX','79835','8418','CY','48141','1991-07-16','F','U',NULL,'N','021','DEN','1988881','33348TX002000201','2014-02-01','2014-01-02 13:34:37','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-03 02:01:47'),(14033,11178,'Y','18','021','EC','A','','','AC','0001160414','0001160414','OH00000750587','IL','1','Boggs','Charlotte','','','','34','278644901','227 GUNTHER ST',0,'BELLEVUE','OH','44811','1515','CY','39077','1960-07-08','F','M',NULL,'N','021','HLT','1492331','92036OH004002701','2014-01-01','2013-12-23 15:41:38','0.00',NULL,NULL,'319.86','319.86','R-OH006','OH0','319.86',NULL,0,'2013-12-26 13:16:55'),(5261,4172,'N','01','021','EC','A',NULL,NULL,'','0001213461','0000119056','','IL','1','Hoyt','Elizabeth','','','','34','269884893','576 WESTMINSTER CIR',0,'AKRON','OH','44319','5503','CY','39153','1972-02-29','F','',':RET:2106-3','N','021','HLT','1633132','52664OH151001306','2014-01-01','2013-12-19 11:04:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.36',NULL,0,'2013-12-25 23:05:21'),(1038,851,'Y','18','021','EC','A','','','AC','0000880994','0000880994','TX00000860359','IL','1','KUBECZKA','PATRICIA','','','','34','466922960','1912 RAMPART ST',0,'LEAGUE CITY','TX','77573','1946','CY','48167','1950-02-27','F','U',NULL,'N','021','DEN','1107345','33348TX002000201','2014-01-01','2013-12-03 15:33:45','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:15:41'),(9332,7396,'Y','18','021','EC','A','','','AC','0000043221','0000043221','OH00000464758','IL','1','Retzlaff','Jonathan','','','','34','327829805','3735 WHITE CHAPEL CT',0,'AMELIA','OH','45102','2902','CY','39025','1983-08-10','M','U',':RET:2106-3','N','021','HLT','2311701','92036OH004000601','2014-01-01','2013-12-21 06:25:18','0.00',NULL,NULL,'195.92','195.92','R-OH005','OH0','195.92',NULL,0,'2013-12-26 04:30:46'),(4638,3675,'Y','18','021','EC','A','','','AC','0000136286','0000136286','MS00000533836','IL','1','SAWYER','CHARLES','','','','34','427112244','165 MAPLE STREET',0,'JACKSON','MS','39203',NULL,'CY','28049','1977-03-10','M','U',':RET:2054-5','N','021','DEN','329363','46300MS002000201','2014-01-01','2013-12-12 09:50:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 22:06:42'),(1040,853,'Y','18','021','EC','A','','','AC','0000357673','0000357673','TX00001213967','IL','1','GAONA','CARLOS','FRANCISCO','','','34','459437071','1710 CHICAGO STREET REAR',0,'LAREDO','TX','78041',NULL,'CY','48479','1968-07-22','M','M',NULL,'N','021','DEN','1209890','33348TX002000201','2014-01-01','2013-12-03 11:38:01','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 18:15:45'),(25953,20583,'Y','18','021','EC','A','','','AC','0000834513','0000834513','OH00003258813','31','1','DENIGRIS','GABRIEL','','','','34','278665748','9255 BROADVIEW RD',0,'BROADVIEW HEIGHTS','OH','44147','2309','CY','39055','1965-12-05','M','U',NULL,'N','021','DEN','2878517','99734OH005000401','2014-05-01','2014-02-26 10:58:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:01:38'),(4052,3236,'Y','18','021','EC','A','','','AC','0001178163','0001178163','OH00001281684','IL','1','Beckloff','David','','','','34','282560404','38911 WATSON AVE',0,'NORTH RIDGEVILLE','OH','44039','2719','CY','39093','1967-08-11','M','U',':RET:2106-3','N','021','DEN','2377042','99734OH005000401','2014-01-01','2013-12-17 15:01:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:25'),(22031,17587,'N','19','021','EC','A',NULL,NULL,'','0001066019','0000857156','','IL','1','Simmons','Victoria','L',NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1992-05-21','F','',NULL,'N','021','HLT','2731792','52664OH151001501','2014-03-01','2014-02-07 10:25:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2014-02-07 19:01:03'),(21399,17101,'Y','18','021','EC','A','','','AC','0000711409','0000711409','OH00001399100','IL','1','kudalor','golda','','','','34','846777850','1971 FOUNTAINVIEW CT',0,'COLUMBUS','OH','43232','2112','CY','39049','1985-12-04','F','U',':RET:2054-5','N','021','DEN','3193647','99734OH005000401','2014-03-01','2014-02-04 12:19:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:01:01'),(21254,16985,'Y','18','021','EC','A','','','AC','0000965807','0000965807','OH00001474437','IL','1','Schuster','Margaret','','','','34','268523561','779 CLYDE ST',0,'AKRON','OH','44310','4007','CY','39153','1951-10-06','F','U',':RET:2106-3','N','021','HLT','3330307','52664OH151001305','2014-03-01','2014-02-03 15:01:34','482.00',NULL,NULL,'640.70','158.70','R-OH012','OH0','640.70',NULL,0,'2014-02-03 21:01:19'),(1683,1405,'Y','18','021','EC','A','','','AC','0002056782','0002056782','LA00000144093','IL','1','WILSON','DEANDRIA','','','','34','433319164','356 FEDERAL DR',0,'AVONDALE','LA','70094','2433','CY','22051','1956-03-01','F','U',':RET:2054-5','N','021','DEN','2514194','18575LA002000101','2014-01-01','2013-12-24 10:40:31','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:13'),(2747,2223,'Y','18','021','EC','A','','','AC','0000815307','0000815307','OH00000164930','IL','1','Greene','David','','','','34','285622142','PO Box 368',0,'Lynchburg','OH','45142',NULL,'CY','39071','1963-02-06','M','M',':RET:2106-3','N','021','HLT','1126687','92036OH002000601','2014-01-01','2013-12-01 20:24:01','358.00',NULL,NULL,'442.75','84.75','R-OH005','OH0','442.75',NULL,0,'2013-12-25 19:48:57'),(25647,20346,'Y','18','024','14','A','','','TE','0000194106','0000194106','','IL','1','tucker','casey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2001-12-03','M','',NULL,NULL,NULL,'','3274450','','2014-02-21','2014-02-21 19:33:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 08:30:36'),(2340,1905,'Y','18','021','EC','A','','','AC','0001261749','0001261749','TX00000826382','IL','1','HERRERA','ROSA','','','','34','546061986','4909 N DOGWOOD ST',0,'PHARR','TX','78577','8334','CY','48215','1948-11-11','F','U',NULL,'N','021','DEN','1229669','33348TX002000201','2014-01-01','2013-12-09 13:15:28','0.00',NULL,NULL,'16.22','16.22','R-TX015','TX0','16.22',NULL,0,'2013-12-25 19:31:56'),(19806,15790,'N','01','021','EC','A',NULL,NULL,'','0000187461','0000884999','','IL','1','ROMERO','BERNABE','','','','34','461214952','306 W STUTON',0,'ROCKSPRINGS','TX','78880',NULL,'CY','48137','1951-03-30','M','',NULL,'N','021','DEN','2987388','33348TX002000201','2014-03-01','2014-01-24 15:34:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-24 21:00:06'),(17226,13785,'Y','18','021','EC','A','','','AC','0001198126','0001198126','OH00002276145','IL','1','Plasterer','Danny','','','','34','271447727','3324 QUEENSWOOD BLVD',0,'TOLEDO','OH','43606','1127','CY','39095','1962-12-08','M','U',':RET:2106-3','N','021','HLT','1900185','92036OH004002601','2014-02-01','2014-01-08 11:02:23','257.00',NULL,NULL,'292.43','35.43','R-OH001','OH0','292.43',NULL,0,'2014-01-13 02:22:37'),(3485,2797,'N','01','021','EC','A',NULL,NULL,'','0001054209','0001142164','','IL','1','Balster','Lori','M','','','34','276700479','459 E RAHN RD',0,'DAYTON','OH','45429','5948','CY','39113','1973-04-07','F','',':RET:2106-3','N','021','DEN','1547522','99734OH005000401','2014-01-01','2013-12-22 11:36:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:17'),(5464,4340,'Y','18','021','EC','A','','','AC','0000755989','0000755989','OH00000017478','IL','1','Ray','Robert','','','','34','295607866','139 CEMETERY ST',0,'YELLOW SPRINGS','OH','45387','1914','CY','39057','1975-11-12','M','U',':RET:2106-3','N','021','HLT','2441720','92036OH006000501','2014-01-01','2013-12-19 14:16:52','175.00',NULL,NULL,'234.90','59.90','R-OH003','OH0','234.90',NULL,0,'2013-12-25 23:10:29'),(9201,7298,'Y','18','021','EC','A','','','AC','0000091127','0000091127','OH00000854359','IL','1','Peterson','Deborah','','','','34','281525189','408 E MAIN ST',0,'MOUNT ORAB','OH','45154','9018','CY','39015','1950-12-17','F','M',':RET:2106-3','N','021','HLT','2280003','92036OH002000601','2014-01-01','2013-12-18 14:05:50','140.00',NULL,NULL,'731.81','591.81','R-OH005','OH0','731.81',NULL,0,'2013-12-26 04:09:40'),(28119,22254,'Y','18','021','EC','A','','','AC','0001109284','0001109284','OH00003648741','IL','1','Rowland','Tyler','J','','','34','286829761','1568 COUNTY ROAD P',0,'MC CLURE','OH','43534','9714','CY','39069','1984-04-14','M','M',':RET:2106-3','N','021','HLT','3666103','92036OH003002601','2014-04-01','2014-03-05 22:31:15','0.00',NULL,NULL,'357.17','357.17','R-OH001','OH0','227.86',NULL,0,'2014-03-06 21:02:19'),(2045,1675,'Y','18','021','EC','A','','','AC','0000082128','0000082128','TX00001294573','IL','1','Wooldridge','Gayle','','','','34','630324893','103 E ALLYN AVE',0,'CORSICANA','TX','75110','1401','CY','48349','1992-06-30','F','R',':RET:2106-3','N','021','DEN','827398','33348TX002000201','2014-01-01','2013-12-10 13:29:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:15:41'),(4667,3700,'Y','18','021','EC','A','','','AC','0000799582','0000799582','LA00000225444','IL','1','Bestman','Ida','','','','34','664093045','2257 BALIS DR',0,'BATON ROUGE','LA','70808','1742','CY','22033','1974-08-27','F','M',':RET:2054-5','N','021','DEN','137914','18575LA002000201','2014-01-01','2013-12-12 13:21:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:07:31'),(21615,17259,'Y','18','021','EC','A','','','AC','0000855980','0000855980','TX00001971638','IL','1','Jimenez','Jose','','','','34','452904114','1803 E. 3 Mile Rd',0,'Mission','TX','78573',NULL,'CY','48215','1952-02-14','M','M',':RET:2106-3','N','021','DEN','3718311','33348TX002000201','2014-03-01','2014-02-04 19:59:04','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-05 21:30:35'),(4048,3232,'Y','18','021','EC','A','','','AC','0000443444','0000443444','OH00000989842','IL','1','JOHNSON','TYLER','','','','34','297806021','5893 DATUNE CT',0,'COLUMBUS','OH','43229','2755','CY','39049','1967-08-13','M','M',':RET:2106-3','N','021','DEN','1814055','99734OH005000401','2014-01-01','2013-12-17 13:00:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:18'),(2691,2181,'Y','18','021','EC','A','','','AC','0001102344','0001102344','TX00000036827','IL','1','NGUYEN','QUANG','','','','34','615841767','9713 LINKS FAIRWAY DR',0,'ROWLETT','TX','75089','9534','CY','48113','1973-03-08','M','M',':RET:2047-9','N','021','DEN','995070','33348TX002000201','2014-01-01','2013-12-02 17:07:02','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:47:31');
INSERT INTO `EdiParticipant` VALUES (20705,16545,'Y','18','021','EC','A','','','AC','0001398762','0001398762','LA00001923816','31','1','Fowler','Vera','','','','34','438729752','P.O. Box 475',0,'Farmerville','LA','71241',NULL,'CY','22111','1950-05-25','F','M',':RET:2106-3','N','021','DEN','3374851','18575LA002000201','2014-03-01','2014-01-30 12:17:16','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-30 21:01:06'),(17911,14306,'Y','18','021','EC','A','','','AC','0001191817','0001191817','TX00001986473','IL','1','Bingham','Tonia','Michelle','','','34','464837846','1904 TOPHILL DR',0,'FLOWER MOUND','TX','75022','4484','CY','48121','1973-07-07','F','U',':RET:2106-3','N','021','DEN','2678704','33348TX002000201','2014-02-01','2014-01-13 20:26:22','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:27'),(16845,13475,'N','01','021','EC','A',NULL,NULL,'','0000678117','0001142188','','IL','1','DeLand','Robert','William','','','34','288583098','876 CORDOVA DR',0,'BARBERTON','OH','44203','8658','CY','39153','1957-04-27','M','',':RET:2106-3','N','021','HLT','2656865','52664OH151001501','2014-02-01','2014-01-11 10:27:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','624.00',NULL,0,'2014-01-13 02:18:35'),(7897,6243,'Y','18','021','EC','A','','','AC','0001121382','0001121382','OH00000085414','IL','1','Barker','Kenneth','','','','34','298547552','517 MARIAN AVE',0,'LIMA','OH','45801','3946','CY','39003','1953-07-30','M','U',':RET:2106-3','N','021','HLT','1376689','92036OH003001505','2014-01-01','2013-12-19 19:10:11','530.00',NULL,NULL,'623.76','93.76','R-OH002','OH0','623.76',NULL,0,'2013-12-26 03:05:43'),(13876,11072,'Y','18','021','EC','A','','','AC','0000689695','0000689695','OH00000010222','IL','1','Goodson','Jennifer','','','','34','233317643','4383 Lexington Ridge Drive',0,'Medina','OH','44256',NULL,'CY','39103','1975-09-23','F','U',':RET:2106-3','N','021','HLT','1917115','52664OH151001501','2014-01-01','2013-12-23 13:45:26','0.00',NULL,NULL,'333.26','333.26','R-OH012','OH0','333.26',NULL,0,'2013-12-26 13:13:11'),(9027,7162,'Y','18','021','EC','A','','','AC','0000044258','0000044258','OH00001132188','IL','1','Jerin','Craig','','','','34','300805578','2540 Royal County Down',0,'Uniontown','OH','44685',NULL,'CY','39153','1968-11-20','M','U',':RET:2106-3','N','021','HLT','2036363','52664OH151001304','2014-01-01','2013-12-18 10:22:22','143.00',NULL,NULL,'322.02','179.02','R-OH012','OH0','322.02',NULL,0,'2013-12-26 04:05:28'),(23507,18725,'Y','18','024','14','A','','','TE','0000444506','0000444506','','IL','1','Roets','Etienne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-11-01','M','',NULL,NULL,NULL,'','1633478','','2014-02-28','2014-02-13 12:58:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-13 22:02:12'),(24657,19574,'Y','18','021','EC','A','','','AC','0000509255','0000509255','OH00002864335','IL','1','johnson','margaretta','','','','34','102609964','817 HOAG ST',0,'TOLEDO','OH','43607','4114','CY','39095','1969-03-14','F','M',NULL,'N','021','HLT','3338672','92036OH004002601','2014-04-01','2014-02-19 15:38:13','219.00',NULL,NULL,'452.82','233.82','R-OH001','OH0','226.41',NULL,0,'2014-02-20 04:24:42'),(25338,20104,'Y','18','021','EC','A','','','AC','0001250755','0001250755','LA00002586215','IL','1','FOWLER','MARVIN','','','','34','436258472','137 HAM RD',0,'ZWOLLE','LA','71486','2744','CY','22085','1961-02-10','M','M',NULL,'N','021','DEN','2989380','18575LA002000201','2014-04-01','2014-02-25 15:15:44','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-02-25 21:30:23'),(27044,21419,'Y','18','021','EC','A','','','AC','0000265305','0000265305','OH00003498555','IL','1','Drees','Teresa','','','','34','294461325','5831 MURNEN RD',0,'TOLEDO','OH','43623','1413','CY','39095','1962-12-01','F','M',':RET:2106-3','N','021','HLT','3396980','92036OH005002601','2014-04-01','2014-03-03 11:30:58','209.00',NULL,NULL,'975.02','766.02','R-OH001','OH0','363.68','CIC',0,'2014-03-03 21:00:23'),(28302,22393,'Y','18','021','EC','A','','','AC','0000906658','0000906658','OH00003435582','31','1','Svetlik','George','','','','34','283480127','Po Box 4675',0,'Akron','OH','44310',NULL,'CY','39153','1949-10-04','M','M',':RET:2106-3','N','021','HLT','2793056','52664OH151001501','2014-04-01','2014-03-07 14:08:29','292.00',NULL,NULL,'802.38','510.38','R-OH012','OH0','802.38','CIC',0,'2014-03-07 21:00:32'),(28540,22588,'Y','18','021','EC','A','','','AC','0000988851','0000988851','TX00002882596','IL','1','Medina','Magdalena','H','','','34','450191451','118 W AVENUE C',0,'SAN ANGELO','TX','76903','6813','CY','48451','1958-09-14','F','U',':RET:2106-3','N','021','DEN','4066210','33348TX002000101','2014-04-01','2014-03-07 15:57:13','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2014-03-07 21:32:13'),(29117,23050,'Y','18','021','EC','A','','','AC','0000672636','0000672636','MS00002819671','IL','1','Jones','Jessica','','','','34','425572240','719 CHERRY ST',0,'JACKSON','MS','39204','2955','CY','28049','1986-07-25','F','M',':RET:2054-5','N','021','DEN','4131725','46300MS002000201','2014-04-01','2014-03-10 12:13:24','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-10 21:02:27'),(829,686,'Y','18','021','EC','A','','','AC','0000644658','0000644658','OH00001314709','IL','1','Fritz','Annette','','','','34','039328263','5738 NOLLEY RD',0,'AKRON','OH','44319','4656','CY','39153','1951-12-21','F','M',':RET:2106-3','N','021','HLT','1800386','52664OH151001301','2014-01-01','2013-12-16 16:10:39','306.00',NULL,NULL,'640.70','334.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 18:06:18'),(21821,17426,'Y','18','021','EC','A','','','AC','0000288329','0000288329','OH00002609925','IL','1','Baughman','Sherri','','','','34','299648149','6909 N. St. Rt. 66 Lot 60',0,'Defiance','OH','43512',NULL,'CY','39039','1960-07-27','F','U',NULL,'N','021','HLT','3253063','92036OH003002605','2014-03-01','2014-02-06 14:00:26','316.00',NULL,NULL,'415.41','99.41','R-OH001','OH0','415.41',NULL,0,'2014-02-06 21:00:59'),(1300,1076,'Y','18','021','EC','A','','','AC','0000589337','0000589337','TX00000179069','IL','1','mohon','jeremy','','','','34','636205690','420 MELODYWOOD CT',0,'FRIENDSWOOD','TX','77546','3476','CY','48167','1986-02-20','M','U',':RET:2106-3','T','021','DEN','842153','33348TX002000201','2014-01-01','2013-11-03 20:25:55','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:31:09'),(21503,17179,'Y','18','021','EC','A','','','AC','0001204573','0001204573','OH00002425380','IL','1','Bissinger','William','','','','34','275424508','3630 HIGHLAND GRN',0,'CINCINNATI','OH','45245','1755','CY','39025','1953-04-17','M','M',':RET:2106-3','N','021','HLT','2857520','92036OH005000605','2014-03-01','2014-02-04 17:16:38','876.00',NULL,NULL,'1083.42','207.42','R-OH005','OH0','582.60',NULL,0,'2014-02-04 21:01:53'),(20701,16541,'Y','18','021','EC','A','','','AC','0001695391','0001695391','LA00002083340','IL','1','HUDSON','ESTRELLITA','','','','34','436232837','312 NOTTINGHAM CIRCLE',0,'LAFAYETTE','LA','70507',NULL,'CY','22055','1962-01-26','F','U',':RET:2054-5','N','021','DEN','3315990','18575LA002000201','2014-03-01','2014-01-30 11:00:28','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-30 21:01:04'),(6900,5475,'Y','18','021','EC','A','','','AC','0002114760','0002114760','LA00000825844','IL','1','Cormier','Karen','','','','34','433333562','400 CLIFTON ST',0,'THIBODAUX','LA','70301','5550','CY','22109','1969-09-28','F','U',':RET:2106-3','T','021','DEN','1392652','18575LA002000201','2014-01-01','2013-12-24 22:33:29','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-26 01:45:36'),(17547,14028,'Y','18','021','EC','A','','','AC','0000560571','0000560571','OH00001436277','IL','1','Edwards','Harold','','','','34','423767842','4113 Crest Dr',0,'Dayton','OH','45416',NULL,'CY','39113','1951-09-05','M','U',':RET:2054-5','T','021','HLT','2058615','92036OH006000501','2014-02-01','2014-01-12 13:00:14','0.00',NULL,NULL,'622.85','622.85','R-OH003','OH0','622.85',NULL,0,'2014-01-13 03:01:51'),(6233,4941,'Y','18','024','14','A','','','TE','0000015186','0000015186','','IL','1','ALVAREZ','STEVEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-07-22','M','',NULL,NULL,NULL,'','259991','','2013-11-19','2013-11-19 11:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:31:30'),(2098,1719,'Y','18','024','14','A','','','TE','0000242689','0000242689','','IL','1','Sullivan','Judith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-06','F','',NULL,NULL,NULL,'','249398','','2013-12-09','2013-12-09 20:12:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:17:05'),(4455,3540,'Y','18','024','14','A','','','TE','0000701655','0000701655','','IL','1','Davidson','Danielle','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-11-05','F','',NULL,NULL,NULL,'','254667','','2013-12-12','2013-12-12 10:56:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:29'),(3437,2762,'Y','18','021','EC','A','','','AC','0002362911','0002362911','LA00000123943','IL','1','HOGAN','KEITH','','','','34','434533500','1209 MONTGOMERY BLVD',0,'SLIDELL','LA','70461','4415','CY','22103','1982-08-01','M','U',':RET:2106-3','N','021','DEN','1616264','18575LA002000101','2014-01-01','2013-12-22 13:14:47','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 21:19:06'),(29197,23106,'N','01','021','EC','A',NULL,NULL,'','0000906663','0000767475','','IL','1','BRADFORD','TINA','','','','34','285787959','3615 BERKELEY RD',0,'CLEVELAND HEIGHTS','OH','44118','1940','CY','39035','1973-03-10','F','',':RET:2054-5','N','021','DEN','3599206','99734OH005000301','2014-04-01','2014-03-10 11:31:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-10 21:30:08'),(29199,23107,'N','01','021','EC','A',NULL,NULL,'','0000271433','0001058013','','IL','1','CUPP','DAVID','','','','34','287505887','4317 LINCHMERE DR',0,'DAYTON','OH','45415','1810','CY','39113','1950-06-01','M','',':RET:2106-3','N','021','DEN','4253876','99734OH005000301','2014-04-01','2014-03-10 13:33:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-10 21:30:09'),(6721,5331,'Y','18','021','EC','A','','','AC','0001182471','0001182471','OH00001090804','IL','1','Kluckman','Alison','Megan','','','34','274886218','6010 CRITTENDEN DR',0,'CINCINNATI','OH','45244','3905','CY','39061','1985-08-09','F','U',':RET:2106-3','N','021','DEN','51071','99734OH005000401','2014-01-01','2013-11-25 15:06:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:12'),(21208,16948,'Y','18','021','EC','A','','','AC','0002071065','0002071065','LA00001796920','IL','1','nguyen','bon','','','','34','464777997','22 CHERRY BLOSSOM LN',0,'MARRERO','LA','70072','2425','CY','22051','1952-01-10','M','M',':RET:2047-9','N','021','DEN','2966219','18575LA002000201','2014-03-01','2014-02-03 11:40:41','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:00:57'),(25000,19827,'Y','18','021','EC','A','','','AC','0000895766','0000895766','OH00002528888','IL','1','Rankine','Scott','','','','34','285622607','1804 MASSILLON RD',0,'AKRON','OH','44312','4209','CY','39153','1958-11-04','M','U',':RET:2106-3','N','021','HLT','3565593','52664OH151001305','2014-04-01','2014-02-19 19:11:21','366.00',NULL,NULL,'497.31','131.31','R-OH012','OH0','497.31',NULL,0,'2014-02-20 22:00:45'),(28917,22887,'Y','18','021','EC','A','','','AC','0001241933','0001241933','OH00003739715','IL','1','Heller','Belinda','','','','34','278766098','212 E WATER ST',0,'OAK HARBOR','OH','43449','1451','CY','39123','1971-02-20','F','M',':RET:2106-3','T','021','DEN','3179097','99734OH005000301','2014-04-01','2014-03-10 09:48:39','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2014-03-10 21:00:29'),(1019,834,'N','01','021','EC','A',NULL,NULL,'','0000865871','0000864521','','IL','1','Williams','Joann','','','','34','428439423','370 williams st.',0,'Canton','MS','39046',NULL,'CY','28089','1974-08-27','F','',':RET:2054-5','N','021','DEN','412329','46300MS002000201','2014-01-01','2013-12-02 23:44:11',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 18:15:11'),(22196,17716,'Y','18','021','EC','A','','','AC','0000214701','0000214701','OH00002146331','IL','1','Knight','Mark','','','','34','463691713','3925 ELM AVE',0,'CINCINNATI','OH','45236','3907','CY','39061','1982-08-03','M','M',':RET:2106-3','T','021','DEN','2932314','99734OH005000401','2014-03-01','2014-02-08 19:23:17','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-09 19:00:12'),(21122,16877,'Y','18','021','EC','A','','','AC','0000154070','0000154070','TX00001837210','IL','1','AGEE','BETTY','','','','34','464110531','4508 HILL ST',0,'GREENVILLE','TX','75401','2022','CY','48231','1958-04-02','F','U',NULL,'N','021','DEN','3190750','33348TX002000201','2014-03-01','2014-02-03 13:07:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-03 21:00:13'),(7500,5932,'Y','18','021','EC','A','','','AC','0000696797','0000696797','OH00001274106','IL','1','Krueger','Timothy','','','','34','282824632','3715 KENMORE AVE',0,'PARMA','OH','44134','2429','CY','39035','1978-06-18','M','U',':RET:2106-3','N','021','DEN','115469','99734OH005000401','2014-01-01','2013-12-15 15:37:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:31:48'),(2557,2080,'Y','18','021','EC','A','','','AC','0001124564','0001124564','MS00000894759','IL','1','Childers','Michael','','','','34','587286511','155 COUNTY ROAD 157',0,'CORINTH','MS','38834','1314','CY','28003','1951-06-07','M','M',':RET:2106-3','N','021','DEN','465205','46300MS002000201','2014-01-01','2013-12-09 14:15:03','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2013-12-25 19:37:25'),(2621,2131,'Y','18','021','EC','A','','','AC','0001021444','0001021444','OH00001240007','IL','1','Suri','Sameer','','','','34','272023346','127 E 9th Street',0,'Cincinnati','OH','45202',NULL,'CY','39061','1974-01-05','M','U',':RET:2029-7','N','021','DEN','879567','99734OH005000401','2014-01-01','2013-12-02 17:52:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:52'),(5330,4227,'Y','18','021','EC','A','','','AC','0000151965','0000151965','OH00001282963','IL','1','LaForce','Mark','','','','34','271524251','7140 White Water Ct.',0,'Dayton','OH','45414',NULL,'CY','39113','1952-03-19','M','M',NULL,'N','021','DEN','1494883','99734OH005000301','2014-01-01','2013-12-19 12:43:19','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:07:05'),(14762,11786,'N','19','021','EC','A',NULL,NULL,'','0000925131','0001036597','','IL','1','CHENG','AUDREY','PATRICIA','','','34','287960772','4225 EARLY MORN DR',0,'PLANO','TX','75093','3814','CY','48085','1993-09-13','F','',':RET:2034-7','N','021','DEN','2188129','33348TX002000201','2014-01-01','2013-12-23 19:38:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,1,'2013-12-29 11:12:43'),(5326,4224,'Y','18','021','EC','A','','','AC','0000817528','0000817528','OH00000996384','IL','1','SPENCE','JEREMY','','','','34','421170204','741 RIDGEWOOD AVE',0,'HAMILTON','OH','45013','3201','CY','39017','1982-02-05','M','M',':RET:2106-3','N','021','DEN','2053923','99734OH005000301','2014-01-01','2013-12-19 11:02:39','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:06:58'),(13044,10398,'Y','18','021','EC','A','','','AC','0001195502','0001195502','OH00000905333','IL','1','MILETI','CYNTHIA','JEAN','','','34','278604882','8200 ACKLEY RD',0,'PARMA','OH','44129','4918','CY','39035','1959-05-16','F','U',':RET:2106-3','N','021','DEN','1814371','99734OH005000401','2014-01-01','2013-12-23 07:01:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:50:41'),(23241,18529,'N','19','021','EC','A',NULL,NULL,'','0000351611','0000649406','','IL','1','Procaccini','Vincenzo','','','','34','744692814','2240 S COUNTY ROAD 43',0,'REPUBLIC','OH','44867','9750','CY','39147','2012-12-29','M','',':RET:2106-3','N','021','HLT','3442061','92036OH005002701','2014-03-01','2014-02-12 16:27:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-02-12 21:32:32'),(23400,18645,'N','19','021','EC','A',NULL,NULL,'','0000546511','0000615557','','S1','1','Johnson','Jenny','','','','34','272118189','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','2002-01-19','F','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:10'),(6522,5171,'Y','18','021','EC','A','','','AC','0000560524','0000560524','OH00001312050','31','1','Eitniear','Judith','','','','34','290506356','2137 POTOMAC DR',0,'TOLEDO','OH','43607','1568','CY','39095','1950-11-17','F','M',NULL,'N','021','HLT','871032','92036OH006002601','2014-01-01','2013-12-11 15:02:13','229.00',NULL,NULL,'456.50','227.50','R-OH001','OH0','456.50',NULL,0,'2013-12-26 00:51:26'),(6158,4882,'Y','18','021','EC','A','','','AC','0000264221','0000264221','MS00000390031','IL','1','laughlin','alicia','','','','34','587430248','17468 Sherelle dr.',0,'saucier','MS','39574',NULL,'CY','28047','1982-06-19','F','U',':RET:2106-3','T','021','DEN','447892','46300MS002000201','2014-01-01','2013-11-21 16:59:57','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 00:16:41'),(17729,14166,'N','01','021','EC','A',NULL,NULL,'','0000129273','0000905614','','IL','1','Babcock','Kimberly','Whittington','','','34','293808655','1391 GOODYEAR BLVD',0,'AKRON','OH','44305','3447','CY','39153','1972-01-14','F','',':RET:2106-3','N','021','HLT','2450661','52664OH151001305','2014-02-01','2014-01-13 09:30:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,0,'2014-01-14 01:33:18'),(17193,13757,'Y','18','021','EC','A','','','AC','0000699286','0000699286','OH00001541783','IL','1','Gullett','Benjamin','','','','34','292802004','6954 BEECHWOOD RD',0,'HILLSBORO','OH','45133','8449','CY','39071','1982-12-19','M','U',':RET:2106-3','N','021','HLT','1838398','92036OH003000605','2014-02-01','2014-01-07 21:03:16','180.00',NULL,NULL,'259.83','79.83','R-OH005','OH0','259.83',NULL,0,'2014-01-13 02:22:19'),(15756,12606,'Y','18','021','EC','A','','','AC','0000329351','0000329351','TX00001858264','31','1','Washington','Damion',NULL,NULL,NULL,NULL,NULL,'P.O.Box 2221',0,'Waco','TX','76703',NULL,'CY','48309','1986-07-07','M','U',NULL,'T','021','DEN','2535100','33348TX002000201','2014-02-01','2014-01-01 20:44:28','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-01-03 02:01:20'),(3800,3046,'Y','18','021','EC','A','','','AC','0000658400','0000658400','OH00000050174','IL','1','Liotta','Kathleen','','','','34','273483631','117 BOULDER BLVD',0,'PENINSULA','OH','44264','9597','CY','39153','1949-09-10','F','U',':RET:2106-3','N','021','DEN','17729','99734OH005000301','2014-01-01','2013-12-13 12:23:51','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:34:29'),(3614,2893,'N','19','021','EC','A',NULL,NULL,'','0000997747','0000137569','','IL','1','McDermott','Blythe','','','','34','268045846','419 Cabot Drive',0,'Akron','OH','44333',NULL,'CY','39153','1998-07-19','F','',':RET:2106-3','N','021','HLT','1423401','52664OH152000901','2014-01-01','2013-12-22 18:15:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:23:30'),(2699,2185,'N','19','021','EC','A',NULL,NULL,'','0000867535','0000730099','','IL','1','ruiz','diego','','','','34','638247197','321 SUNSET DR',0,'MARBLE FALLS','TX','78654','1430','CY','48053','1991-04-10','M','',':RET:2106-3','N','021','DEN','38414','33348TX002000201','2014-01-01','2013-12-02 15:41:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:47:40'),(2567,2085,'N','01','021','EC','A',NULL,NULL,'','0000044246','0000795487','','IL','1','SCHRODDER','ROBIN',NULL,NULL,NULL,NULL,NULL,'4333 ZURMEHLY RD',0,'LIMA','OH','45806','1028','CY','39003','1958-05-03','F','',':RET:2106-3','N','021','HLT','950513','92036OH006001501','2014-01-01','2013-12-09 11:55:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','389.23',NULL,0,'2013-12-25 19:37:34'),(2394,1954,'Y','18','021','EC','A','','','AC','0000372580','0000372580','OH00001293224','IL','1','Mindling','Kimberly','','','','34','563477498','20 WATERTOWN RD',0,'WATERTOWN','OH','45786','5249','CY','39167','1961-06-20','F','M',':RET:2106-3','N','021','DEN','377322','99734OH005000401','2014-01-01','2013-12-09 12:24:35','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 19:33:21'),(2036,1666,'Y','18','021','EC','A','','','AC','0001190116','0001190116','TX00001188963','IL','1','Franklin','Eugene','','','','34','459924794','922 HANNAH FALLS LN',0,'FRESNO','TX','77545','7196','CY','48157','1951-03-26','M','U',':RET:2054-5','N','021','DEN','973557','33348TX002000201','2014-01-01','2013-12-09 21:40:00','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:15:28'),(22914,18265,'Y','18','021','EC','A','','','AC','0000368589','0000368589','OH00002242231','IL','1','Murphy','Ashley','','','','34','273881695','7435 LUNITAS LN',0,'PERRYSBURG','OH','43551','7033','CY','39173','1987-10-31','F','U',NULL,'N','021','HLT','3287984','92036OH006002601','2014-03-01','2014-02-11 15:44:00','39.00',NULL,NULL,'158.35','119.35','R-OH001','OH0','158.35',NULL,0,'2014-02-11 21:02:50'),(23505,18723,'Y','18','021','EC','A','','','AC','0000678748','0000678748','TX00002224094','IL','1','Baldwin','Sandra','','','','34','456906510','874 Pine Ln',0,'Cottonwood Shores','TX','78657',NULL,'CY','48053','1955-07-11','F','U',NULL,'N','021','DEN','2918777','33348TX002000101','2014-03-01','2014-02-13 12:04:08','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-13 22:02:10'),(24245,19251,'Y','18','021','EC','A','','','AC','0000639571','0000639571','OH00002587358','S3','1','Hernan','Stefanie','','','','34','278150927','2176 Gregory Ave',0,'Youngstown','OH','44511',NULL,'CY','39099','2009-04-03','M','U',':RET:2106-3','N','021','DEN','3844713','99734OH005000101','2014-03-01','2014-02-15 23:42:35','0.00',NULL,NULL,'27.59','27.59','R-OH013','OH0','27.59',NULL,0,'2014-02-16 19:00:41'),(24329,19322,'Y','18','021','EC','A','','','AC','0001036844','0001036844','TX00001446946','IL','1','MILLNER','DONNA','JEAN','','','34','465021303','1701B SHADOWVIEW DR',0,'AUSTIN','TX','78758',NULL,'CY','48453','1968-11-13','F','U',NULL,'N','021','DEN','3470784','33348TX002000201','2014-04-01','2014-02-18 13:30:02','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:13'),(25994,20615,'Y','18','024','14','A','','','TE','0000296521','0000296521','','IL','1','Jackson','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-02','M','',NULL,NULL,NULL,'','2914308','','2014-02-26','2014-02-26 16:44:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-26 21:01:59'),(27027,21405,'Y','18','024','14','A','','','TE','0000824454','0000824454','','IL','1','tran','hongnga',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-04-10','F','',NULL,NULL,NULL,'','3502543','','2014-03-31','2014-03-02 22:15:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-03 21:00:14'),(27201,21538,'Y','18','021','EC','A','','','AC','0000379450','0000379450','TX00002754015','IL','1','Eatmon','Javonne','','','','34','642182014','1526 REYNOLDSTON LN',0,'DALLAS','TX','75232','2414','CY','48113','1981-07-02','F','M',':RET:2054-5','N','021','DEN','2979352','33348TX002000201','2014-04-01','2014-03-03 17:31:47','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-03-03 21:31:22'),(28636,22662,'Y','18','021','EC','A','','','AC','0001064119','0001064119','TX00003475628','31','1','FEATHERSTON','NICHOLLE','','','','34','454610117','PO BOX 154',0,'BEN WHEELER','TX','75754',NULL,'CY','48467','1982-10-29','F','U',NULL,'T','021','DEN','3456334','33348TX002000201','2014-04-01','2014-03-08 12:30:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:29'),(2263,1852,'Y','18','021','EC','A','','','AC','0000017600','0000017600','OH00000614858','IL','1','Blank','Thomas','','','','34','163468682','11082 Sage creek drive',0,'Galena','OH','43021',NULL,'CY','39041','1957-03-06','M','M',':RET:2106-3','N','021','DEN','761032','99734OH005000301','2014-01-01','2013-12-09 09:27:04','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:16'),(20912,16716,'Y','18','024','14','A','','','TE','0000349295','0000349295','','IL','1','Boos','Magaret',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-01-18','F','',NULL,NULL,NULL,'','3001075','','2014-01-31','2014-01-31 09:19:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:28'),(6483,5134,'N','01','021','EC','A',NULL,NULL,'','0000144194','0000828205','','IL','1','REED','THERESA','LYNN','','','34','276582168','2221 mifflin ave',0,'ashland','OH','44805',NULL,'CY','39005','1958-01-19','F','',NULL,'N','021','HLT','863096','52664OH151001305','2014-01-01','2013-12-11 09:47:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2013-12-26 00:50:22'),(2314,1881,'Y','18','021','EC','A','','','AC','0000224327','0000224327','TX00001249098','IL','1','Chaplin','Floyd','','','','34','461572784','1113 HIGH ST',0,'BRENHAM','TX','77833','4067','CY','48477','1977-09-24','M','M',':RET:2106-3','N','021','DEN','454558','33348TX002000201','2014-01-01','2013-12-08 21:31:27','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:16'),(2526,2059,'Y','18','021','EC','A','','','AC','0000784333','0000784333','OH00000704319','IL','1','Richmond','Lance','Douglas','','','34','600461243','1796 WESTPORT CV',0,'STOW','OH','44224','1515','CY','39153','1980-11-14','M','U',':RET:2106-3','T','021','HLT','95922','52664OH152000901','2014-01-01','2013-12-09 17:59:10','150.00',NULL,NULL,'225.03','75.03','R-OH012','OH0','225.03',NULL,0,'2013-12-25 19:36:43'),(3723,2975,'Y','18','021','EC','A','','','AC','0000227039','0000227039','OH00000876554','IL','1','GAMBILL','GARY',NULL,NULL,NULL,NULL,NULL,'4737 PALMYRA RD SW',0,'WARREN','OH','44481','9710','CY','39155','1949-09-06','M','R',NULL,'N','021','DEN','94693','99734OH005000401','2014-01-01','2013-12-13 15:43:58','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:32:24'),(7912,6256,'Y','18','021','EC','A','','','AC','0001619034','0001619034','LA00000217732','IL','1','Ocasio','David','','','','34','594667345','4009 POST DR',0,'HARVEY','LA','70058','2225','CY','22051','1975-04-17','M','U',':RET:2106-3','T','021','DEN','1776278','18575LA002000201','2014-01-01','2013-12-19 21:24:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:06'),(9799,7759,'N','01','021','EC','A',NULL,NULL,'','0001083379','0000700690','','IL','1','Martinez','Robert','','','','34','627104550','201 33RD ST',0,'SNYDER','TX','79549','3819','CY','48415','1989-10-27','M','',':RET:2106-3','N','021','DEN','96848','33348TX002000201','2014-01-01','2013-10-21 09:54:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 05:01:11'),(23018,18353,'Y','18','021','EC','A','','','AC','0002315170','0002315170','LA00002203957','IL','1','navarre','melanie','','','','34','439270898','156 GEORGIA LOOP',0,'RAYNE','LA','70578','8814','CY','22001','1962-08-04','F','U',':RET:2106-3','T','021','DEN','3566826','18575LA002000101','2014-03-01','2014-02-12 16:33:53','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-12 21:30:28'),(27818,22002,'N','19','021','EC','A',NULL,NULL,'','0000878331','0001122793','','S1','1','Clark','Josh',NULL,NULL,NULL,NULL,NULL,'643 BLAIN LN',0,'GREENFIELD','OH','45123','9660','CY','39141','2009-07-17','M','',':RET:2106-3','N','021','DEN','3888152','99734OH005000301','2014-04-01','2014-03-04 19:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:31:54'),(27908,22078,'Y','18','021','EC','A','','','AC','0000809687','0000809687','TX00002460905','IL','1','Morris','Asiah','','','','34','644010576','1377 GREENBRIAR LN',0,'LANCASTER','TX','75146','1365','CY','48113','1983-08-10','F','U',':RET:2054-5','N','021','DEN','2779327','33348TX002000201','2014-04-01','2014-03-05 19:24:40','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:13'),(7209,5713,'Y','18','021','EC','A','','','AC','0000961844','0000961844','OH00000150169','IL','1','Bliss','Matthew','','','','34','270843943','5225 FRENCH CREEK RD',0,'SHEFFIELD VILLAGE','OH','44054','2745','CY','39093','1983-12-14','M','U',':RET:2106-3','N','021','DEN','859054','99734OH005000401','2014-01-01','2013-12-13 23:58:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:00:53'),(22375,17868,'Y','18','021','EC','A','','','AC','0001188835','0001188835','OH00002440086','IL','1','SURNBROCK','DAVID','','','','34','289502480','5631 ALOMAR DR',0,'CINCINNATI','OH','45238','5105','CY','39061','1951-08-17','M','R',':RET:2106-3','N','021','HLT','3660611','92036OH004001201','2014-03-01','2014-02-10 10:48:13','0.00',NULL,NULL,'495.91','495.91','R-OH004','OH0','495.91',NULL,0,'2014-02-10 21:30:05'),(22199,17718,'Y','18','021','EC','A','','','AC','0000799931','0000799931','OH00002063871','IL','1','Hunter','Nicole','','','','34','275880625','1987 Haverton Dr',0,'Reynoldsburg','OH','43068',NULL,'CY','39049','1982-04-29','F','U',':RET:2054-5','N','021','DEN','3120937','99734OH005000401','2014-03-01','2014-02-08 22:00:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-09 19:00:14'),(22165,17689,'Y','18','021','EC','A','','','AC','0000393712','0000393712','OH00002495516','IL','1','Griffith','David','','','','34','276540260','5097 Meyers Lane',0,'Cincinnati','OH','45242',NULL,'CY','39061','1962-02-26','M','R',':RET:2106-3','N','021','HLT','3808089','92036OH006001201','2014-03-01','2014-02-08 14:19:06','0.00',NULL,NULL,'332.32','332.32','R-OH004','OH0','332.32',NULL,0,'2014-02-08 19:01:00'),(21951,17528,'N','01','021','EC','A',NULL,NULL,'','0000140332','0001183561','','IL','1','PATEL','JAYPRAKASH','C','','','34','288940385','4135 LINCOLN ST E',0,'CANTON','OH','44730','9479','CY','39151','1964-08-22','M','',':RET:2029-7','N','021','DEN','3175502','99734OH005000401','2014-03-01','2014-02-06 20:07:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:20'),(19975,15933,'Y','18','021','EC','A','','','AC','0001103470','0001103470','OH00001857721','IL','1','Curtiss','Todd','','','','34','286829770','556 Bloomington Dr.',0,'Wooster','OH','44691',NULL,'CY','39169','1984-10-11','M','U',':RET:2106-3','T','021','HLT','2005109','52664OH152000901','2014-03-01','2014-01-25 06:04:06','207.00',NULL,NULL,'210.19','3.19','R-OH014','OH0','210.19',NULL,0,'2014-01-25 19:00:13'),(19358,15430,'Y','18','021','EC','A','','','AC','0000212191','0000212191','OH00001522977','IL','1','Bergdorf','Robert','','','','34','270500812','5868 GROVE RD',0,'CLINTON','OH','44216','9719','CY','39153','1950-03-07','M','M',':RET:2106-3','N','021','HLT','2648361','52664OH151001305','2014-03-01','2014-01-20 19:33:34','1029.00',NULL,NULL,'1226.54','197.54','R-OH012','OH0','658.32',NULL,1,'2014-01-22 03:22:29'),(7183,5695,'N','19','021','EC','A',NULL,NULL,'','0000983815','0001140757','','IL','1','abdallah','lana','','','','34','291154473','897 DEERHURST DR',0,'VANDALIA','OH','45377','9409','CY','39113','2010-01-26','F','',':RET:2028-9','N','021','DEN','1065162','99734OH005000301','2014-01-01','2013-12-14 11:41:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:16'),(4399,3497,'Y','18','021','EC','A','','','AC','0001249566','0001249566','OH00000007343','IL','1','Flynn','Alyson','Forbes','','','34','345482246','122 ROSE LANE ST SW',0,'NORTH CANTON','OH','44720','3569','CY','39151','1969-01-09','F','U',':RET:2106-3','N','021','DEN','562723','99734OH005000401','2014-01-01','2013-12-12 13:45:17','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 22:01:06'),(15943,12763,'N','01','021','EC','A',NULL,NULL,'','0000307108','0000586703','','IL','1','Martin','Dennis','','','','34','271548869','2300 BULLE RD',0,'SIDNEY','OH','45365','9442','CY','39149','1954-04-15','M','',':RET:2106-3','N','021','HLT','2349497','92036OH005000506','2014-02-01','2014-01-02 09:31:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','618.76',NULL,0,'2014-01-03 02:07:14'),(4850,3842,'Y','18','021','EC','A','','','AC','0000529406','0000529406','OH00000408492','IL','1','Howe','Matthew','','','','34','284942335','4293 STATE RD',0,'AKRON','OH','44319','2702','CY','39153','1988-06-12','M','U',':RET:2106-3','T','021','DEN','1149959','99734OH005000401','2014-01-01','2013-11-08 14:11:22','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:30:20'),(26236,20808,'Y','18','021','EC','A','','','AC','0000503670','0000503670','TX00002507718','IL','1','Ashby','Isrella','','','','34','554824934','P.O.Box 583',0,'Huntsville','TX','77342',NULL,'CY','48471','1951-06-26','F','U',':RET:2106-3','N','021','DEN','3117446','33348TX002000201','2014-03-01','2014-02-27 01:35:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:31:03'),(879,727,'Y','18','021','EC','A','','','AC','0001227153','0001227153','MS00001028691','IL','1','Stephens','Marti','','','','34','428393946','3664 WOOLEY TRL NW',0,'BROOKHAVEN','MS','39601','8579','CY','28085','1968-12-19','F','U',':RET:2054-5^:RET:2039-6^:RET:2106-3','N','021','DEN','2157151','46300MS002000201','2014-01-01','2013-12-16 10:15:59','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:07:41'),(6484,5135,'Y','18','021','EC','A','','','AC','0000283235','0000283235','OH00001099417','IL','1','Barriball','Kelly','','','','34','298820731','12954 WINAGLE RD',0,'HIRAM','OH','44234','9617','CY','39055','1985-02-26','F','U',':RET:2106-3','N','021','HLT','452007','52664OH151001306','2014-01-01','2013-12-11 10:08:14','166.00',NULL,NULL,'273.40','107.40','R-OH011','OH0','273.40',NULL,0,'2013-12-26 00:50:23'),(2004,1643,'Y','18','024','14','A','','','TE','0000805081','0000805081','','IL','1','BARNETT','BONNIE','SUE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-04','F','',NULL,NULL,NULL,'','943738','','2013-11-20','2013-11-20 10:03:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:02:17'),(2246,1844,'Y','18','021','EC','A','','','AC','0001044459','0001044459','OH00001168347','IL','1','Massie','Rosemary','','','','34','291744049','2891 LAYER RD SW',0,'WARREN','OH','44481','9161','CY','39155','1964-05-03','F','M',':RET:2106-3','T','021','HLT','77876','92036OH005003206','2014-01-01','2013-12-10 17:04:38','901.00',NULL,NULL,'1230.35','329.35','R-OH013','OH0','474.89',NULL,0,'2013-12-25 19:21:09'),(18607,14833,'N','19','021','EC','A',NULL,NULL,'','0000816438','0000460590','','IL','1','CAMPOLONGO','NICALA','','','','34','290946149','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1992-01-16','F','',NULL,'N','021','HLT','1840005','92036OH004000601','2014-02-01','2014-01-15 16:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-01-16 08:47:21'),(2598,2110,'Y','18','021','EC','A','','','AC','0000960566','0000960566','OH00000989370','IL','1','McCrary','Terrence','','','','34','301624995','4986 WINSLOW DR',0,'WHITEHALL','OH','43213','2433','CY','39049','1964-08-25','M','R',NULL,'N','021','DEN','251873','99734OH005000401','2014-01-01','2013-12-01 20:28:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:45:15'),(3499,2810,'Y','18','021','EC','A','','','AC','0000501610','0000501610','OH00000627357','IL','1','Green','Melanie','','','','34','299869327','1529 BUNKER DR',0,'LIMA','OH','45805','3802','CY','39003','1979-02-20','F','U',':RET:2106-3','N','021','DEN','1988446','99734OH005000401','2014-01-01','2013-12-22 16:05:12','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:20:38'),(18150,14494,'Y','18','021','EC','A','','','AC','0001362500','0001362500','LA00001962641','IL','1','TRUFANT','DARRICK','','','','34','437753842','2533 CYPRESS  LAW',0,'MARRERO','LA','70072',NULL,'CY','22051','1970-12-21','M','U',NULL,'N','021','DEN','2705202','18575LA002000101','2014-02-01','2014-01-14 17:19:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-15 02:07:50'),(16176,12951,'Y','18','021','EC','A','','','AC','0001274273','0001274273','LA00001662097','IL','1','Boggs','James','','','','34','215319156','1905 S Carrollton Ave',0,'New Orleans','LA','70118',NULL,'CY','22071','1987-06-17','M','U',':RET:2106-3','N','021','DEN','2216050','18575LA002000201','2014-02-01','2014-01-04 16:26:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-05 00:00:23'),(23731,18894,'Y','18','024','14','A','','','TE','0000862477','0000862477','','IL','1','Gillespie','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-05-10','F','',NULL,NULL,NULL,'','3175670','','2014-02-13','2014-02-13 18:41:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:30:58'),(26362,20910,'N','01','021','EC','A',NULL,NULL,'','0000229490','0000752128','','IL','1','bowling','lisa','','','','34','269724466','37424 HUNTERS RIDGE RD',0,'SOLON','OH','44139','2535','CY','39035','1972-07-09','F','',NULL,'N','021','DEN','2866980','99734OH005000301','2014-04-01','2014-02-26 10:29:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:00:05'),(26700,21166,'N','01','021','EC','A',NULL,NULL,'','0001100646','0000191422','','IL','1','Grubb','Christina','','','','34','459676654','792 St. Rt. 132',0,'Clarksville','OH','45113',NULL,'CY','39027','1966-05-06','F','',':RET:2106-3','T','021','HLT','3134849','92036OH004000601','2014-04-01','2014-02-27 18:50:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','310.27',NULL,0,'2014-02-28 21:31:33'),(5146,4080,'Y','18','021','EC','A','','','AC','0001055308','0001055308','OH00000308559','IL','1','Rhoades','Sharon','K','','','34','274449739','1463 LANTERN LN',0,'TROY','OH','45373','4767','CY','39109','1949-06-28','F','U',':RET:2106-3','N','021','DEN','1991008','99734OH005000401','2014-01-01','2013-12-19 09:06:12','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:02:41'),(763,630,'Y','18','021','EC','A','','','AC','0000450528','0000450528','TX00000595306','IL','1','Martin','Lisa','M','','','34','261958238','340 COUNTY ROAD 14300',0,'PATTONVILLE','TX','75468','3210','CY','48277','1964-09-15','F','U',':RET:2106-3','N','021','DEN','1479712','33348TX002000201','2014-01-01','2013-12-16 11:31:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:37'),(23857,18982,'Y','18','021','EC','A','','','AC','0001775734','0001775734','LA00002594994','IL','1','Egan','Emily','','','','34','044748322','3529 LOUISIANA AVENUE PKWY',0,'NEW ORLEANS','LA','70125','3734','CY','22071','1981-08-07','F','U',':RET:2106-3','N','021','DEN','3830417','18575LA002000101','2014-03-01','2014-02-14 10:35:39','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:02'),(2946,2371,'Y','18','021','EC','A','','','AC','0000735008','0000735008','OH00000172890','IL','1','Butz','Mary','','','','34','280502324','934 RESERVOIR ST',0,'HAMILTON','OH','45011','1734','CY','39017','1952-03-12','F','U',':RET:2106-3','N','021','DEN','446815','99734OH005000401','2014-01-01','2013-12-06 13:09:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:16:23'),(22712,18136,'N','01','021','EC','A',NULL,NULL,'','0001815612','0002084499','','IL','1','Licona Soto','Luis','Enrique','','','34','662184502','545 LAURICELLA AVE',0,'JEFFERSON','LA','70121','1734','CY','22051','1955-12-09','M','',NULL,'N','021','DEN','3013299','18575LA002000201','2014-03-01','2014-02-10 22:54:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:05'),(2969,2391,'N','01','021','EC','A',NULL,NULL,'','0000410462','0000074891','','IL','1','ward','robert','m','','Sr','34','454967940','1112 nottingham',0,'angleton','TX','77515',NULL,'CY','48039','1951-10-18','M','',':RET:2106-3','N','021','DEN','486720','33348TX002000201','2014-01-01','2013-12-06 15:41:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 20:16:56'),(3026,2434,'Y','18','021','EC','A','','','AC','0000648594','0000648594','MS00000995954','IL','1','THURMAN','SAAMIA','S','','','34','425138399','6352 MANSHIP RD',0,'BRANDON','MS','39047',NULL,'CY','28121','1965-06-21','F','U',':RET:2054-5','N','021','DEN','14555','46300MS002000201','2014-01-01','2013-12-06 17:12:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 20:18:18'),(21298,17019,'Y','18','021','EC','A','','','AC','0002188706','0002188706','LA00001926346','IL','1','Scott','Kimberly','','','','34','437599749','8021 WOLFCREEK PL',0,'DENHAM SPRINGS','LA','70726','1201','CY','22063','1977-07-11','F','M',':RET:2106-3','N','021','DEN','3359840','18575LA002000201','2014-03-01','2014-02-03 18:39:33','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-04 21:00:10'),(20493,16372,'Y','18','021','EC','A','','','AC','0001407485','0001407485','LA00001652391','IL','1','Anderson','Denise','','','','34','434611959','2323 OXFORD PL',0,'GRETNA','LA','70056','8210','CY','22051','1982-08-28','F','U',':RET:2054-5','N','021','DEN','3067991','18575LA002000201','2014-03-01','2014-01-29 09:43:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:08'),(19457,15509,'Y','18','021','EC','A','','','AC','0000837467','0000837467','TX00002481673','IL','1','Williams','Addison','','','','34','632223524','6404 WANKLYN ST',0,'DALLAS','TX','75237','2051','CY','48113','1986-07-17','M','U',':RET:2054-5','N','021','DEN','3078119','33348TX002000201','2014-03-01','2014-01-21 20:06:39','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 03:01:55'),(18157,14500,'N','01','021','EC','A',NULL,NULL,'','0000814306','0000504489','','IL','1','Kunar','Erika','Estella','','','34','269846045','512 ADRIAN ST',0,'DELTA','OH','43515','1063','CY','39051','1983-10-20','F','',':RET:2106-3','N','021','HLT','1605988','92036OH005002606','2014-02-01','2014-01-13 22:19:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','221.32',NULL,0,'2014-01-15 02:07:52'),(3927,3143,'Y','18','021','EC','A','','','AC','0001242955','0001242955','OH00000076419','IL','1','Berryman','Lisa','','','','34','271468887','1048 CORWIN AVE',0,'HAMILTON','OH','45015','1877','CY','39017','1962-07-12','F','U',':RET:2106-3','N','021','HLT','1215608','92036OH005001205','2014-01-01','2013-12-13 15:01:23','249.00',NULL,NULL,'400.37','151.37','R-OH004','OH0','400.37',NULL,0,'2013-12-25 21:37:30'),(3620,2898,'N','19','021','EC','A',NULL,NULL,'','0000142828','0000472257','','IL','1','Houchin','Araceli','','','','34','292131068','611 GEORGIA DR',0,'BETHEL','OH','45106','1035','CY','39025','2007-12-28','F','',NULL,'N','021','HLT','2408887','92036OH001000601','2014-01-01','2013-12-22 16:14:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-25 21:23:41'),(15429,12343,'N','01','021','EC','A',NULL,NULL,'','0000569021','0000443452','','IL','1','Huynh','Lang',NULL,NULL,NULL,NULL,NULL,'5727 PERSIMMON DR',0,'TYLER','TX','75707','2062','CY','48423','1973-04-07','F','',NULL,'N','021','DEN','2498318','33348TX002000201','2014-02-01','2013-12-31 12:06:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:27:41'),(13993,11148,'Y','18','021','EC','A','','','AC','0001252110','0001252110','OH00000765456','IL','1','van der Velde','Cornelis','','','','34','128607648','1332 MAIDEN LN',0,'SPRINGFIELD','OH','45504','2810','CY','39023','1949-12-16','M','M',':RET:2106-3','N','021','HLT','2444614','92036OH006000501','2014-01-01','2013-12-23 09:42:58','373.00',NULL,NULL,'565.54','192.54','R-OH003','OH0','565.54',NULL,0,'2013-12-26 13:15:51'),(3506,2817,'Y','18','021','EC','A','','','AC','0000697905','0000697905','OH00000795776','IL','1','Glass','Cena','','','','34','437171166','438 Baldwin Road',0,'Akron','OH','44312',NULL,'CY','39153','1957-07-12','F','U',':RET:2106-3','N','021','DEN','2321784','99734OH005000401','2014-01-01','2013-12-22 18:02:34','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:20:51'),(13613,10854,'N','19','021','EC','A',NULL,NULL,'','0000035753','0000486947','','IL','1','Mack','Kelly','','','','34','298968682','8062 Hickory Hill Lane',0,'Cincinnati','OH','45241',NULL,'CY','39017','1994-04-29','F','',':RET:2106-3','N','021','HLT','1712998','92036OH002001201','2014-01-01','2013-12-23 11:44:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 13:05:40'),(13191,10524,'Y','18','021','EC','A','','','AC','0000211906','0000211906','TX00000198032','IL','1','Forsman','Anita','','','','34','501542555','10809 Sandpiper Lane',0,'Dallas','TX','75230',NULL,'CY','48113','1950-09-25','F','U',':RET:2106-3','N','021','DEN','1984944','33348TX002000101','2014-01-01','2013-12-23 09:18:29','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:37'),(3209,2582,'Y','18','021','EC','A','','','AC','0000612954','0000612954','OH00000871157','IL','1','Fritsch','Charles','','','','34','274783153','832 SUNCREEK CT',0,'CINCINNATI','OH','45238','4836','CY','39061','1978-03-14','M','M',':RET:2106-3','T','021','DEN','464939','99734OH005000301','2014-01-01','2013-11-01 13:54:29','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:45:24'),(3229,2599,'Y','18','021','EC','A','','','AC','0000149312','0000149312','OH00001181707','IL','1','steffen','kathy','','','','34','122522385','23307 LORAIN RD',0,'NORTH OLMSTED','OH','44070','1634','CY','39035','1958-06-10','F','U',NULL,'N','021','DEN','1188748','99734OH005000401','2014-01-01','2013-10-06 12:13:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:01'),(26372,20920,'Y','18','024','14','A','','','TE','0000188899','0000188899','','IL','1','Hammond','Nana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-06','F','',NULL,NULL,NULL,'','2869410','','2014-03-31','2014-02-26 15:56:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:13'),(28367,22446,'Y','18','021','EC','A','','','AC','0000082541','0000082541','TX00002904378','IL','1','Martin','Kathy','','','','34','466378246','1624 SAINT JOHNS DR',0,'EL PASO','TX','79903','2102','CY','48141','1961-07-03','F','U',':RET:2106-3','N','021','DEN','3168411','33348TX002000201','2014-04-01','2014-03-07 16:23:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-07 21:30:32'),(311,254,'Y','18','021','EC','A','','','AC','0000106310','0000106310','TX00000613552','IL','1','PETTY','ANDREW','lee','','','34','460026293','11211 WATER OAK DR',0,'FLINT','TX','75762','5102','CY','48423','1963-09-16','M','U',':RET:2106-3','N','021','DEN','1199084','33348TX002000101','2014-01-01','2013-11-13 16:27:25','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-25 17:31:01'),(419,344,'Y','18','021','EC','A','','','AC','0000279518','0000279518','OH00000298543','IL','1','Fisher','Paul','','','','34','166486038','1380 OLD 122 RD',0,'LEBANON','OH','45036','9496','CY','39165','1957-10-06','M','M',':RET:2106-3','N','021','DEN','614518','99734OH005000401','2014-01-01','2013-12-03 23:43:03','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:46:35'),(21321,17038,'Y','18','021','EC','A','','','AC','0002045234','0002045234','LA00002564587','IL','1','Davis','James','','','','34','437572488','267 randy road',0,'West monroe','LA','71292',NULL,'CY','22073','1983-02-20','M','M',':RET:2106-3','N','021','DEN','2672512','18575LA002000201','2014-03-01','2014-02-04 17:13:09','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-04 21:00:23'),(7344,5815,'N','19','021','EC','A',NULL,NULL,'','0000109265','0000985988','','IL','1','Forsyth','Maxwell','','','','34','275025970','3672 Sanctuary Dr.',0,'Akron','OH','44333',NULL,'CY','39153','1997-01-30','M','',':RET:2106-3','N','021','HLT','246118','52664OH152000901','2014-01-01','2013-12-14 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 02:04:05'),(20795,16615,'Y','18','021','EC','A','','','AC','0001187813','0001187813','TX00002032489','IL','1','Sanchez','Ernie','','','','34','463950520','4000 TIERRA INEZ PL',0,'EL PASO','TX','79938','5333','CY','48141','1987-08-23','M','U',NULL,'N','021','DEN','3485660','33348TX002000201','2014-03-01','2014-01-31 10:50:38','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:17'),(19365,15436,'Y','18','021','EC','A','','','AC','0000672747','0000672747','OH00001397778','IL','1','Sullivan','Bartholomew','','','','34','269828832','1776 24th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1983-10-07','M','U',':RET:2106-3','N','021','HLT','2666738','52664OH151001305','2014-03-01','2014-01-21 13:34:57','135.00',NULL,NULL,'253.11','118.11','R-OH012','OH0','253.11',NULL,1,'2014-01-22 03:22:33'),(6131,4862,'Y','18','021','EC','A','','','AC','0001217994','0001217994','TX00000930278','IL','1','allison','maria','','','','34','456796098','527 OAK ST',0,'DE KALB','TX','75559','1141','CY','48037','1986-09-10','F','M',':RET:2106-3','T','021','DEN','293665','33348TX002000201','2014-01-01','2013-11-21 17:52:21','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2013-12-26 00:16:00'),(2585,2101,'Y','18','021','EC','A','','','AC','0000535732','0000535732','OH00000813832','IL','1','Spoor','William','','','','34','286466089','10812 LINCOLN HWY',0,'VAN WERT','OH','45891','9377','CY','39161','1954-04-27','M','U',NULL,'T','021','HLT','402980','92036OH004001501','2014-01-01','2013-12-09 17:24:55','525.88',NULL,NULL,'529.75','3.87','R-OH002','OH0','529.75',NULL,0,'2013-12-25 19:38:06'),(4843,3837,'Y','18','021','EC','A','','','AC','0000077521','0000077521','OH00000076995','IL','1','Deppen','Debra','','','','34','268666759','55 TOWNSEND AVE',0,'NORWALK','OH','44857','2219','CY','39077','1959-08-30','F','U',':RET:2106-3','N','021','HLT','878160','92036OH005002705','2014-01-01','2013-11-08 06:36:48','372.00',NULL,NULL,'416.32','44.32','R-OH006','OH0','416.32',NULL,0,'2013-12-25 22:30:10'),(15982,12792,'Y','18','021','EC','A','','','AC','0000134021','0000134021','TX00000384657','IL','1','stevens','angela','','','','34','449298703','77 county road 43 sandy',0,'mount pleasant','TX','75455',NULL,'CY','48449','1967-07-23','F','U',':RET:2106-3','N','021','DEN','1809749','33348TX002000201','2014-02-01','2014-01-03 10:50:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:00:58'),(4187,3331,'Y','18','021','EC','A','','','AC','0000680828','0000680828','OH00001309905','IL','1','Tigelman','Beth','','','','34','284521282','2631 Swinehart Rd',0,'Akron','OH','44312',NULL,'CY','39153','1952-08-27','F','M',':RET:2106-3','N','021','HLT','2300238','52664OH151001305','2014-01-01','2013-12-17 13:45:49','415.00',NULL,NULL,'626.65','211.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 21:49:33'),(15391,12312,'Y','18','021','EC','A','','','AC','0000705157','0000705157','OH00000807287','IL','1','DOOLAN','LUCY','','','','34','182505845','9623 RAVENNA RD',0,'TWINSBURG','OH','44087',NULL,'CY','39153','1958-07-27','F','M',':RET:2106-3','N','021','HLT','2244619','52664OH151001501','2014-02-01','2014-01-01 13:32:26','0.00',NULL,NULL,'596.45','596.45','R-OH012','OH0','596.45',NULL,1,'2014-01-02 04:25:45'),(9446,7493,'Y','18','021','EC','A','','','AC','0001165333','0001165333','OH00000399704','IL','1','Mann','Corey','','','','34','295740136','1128 stone drive',0,'Harrison','OH','45030',NULL,'CY','39061','1963-10-03','M','R',':RET:2106-3','T','021','DEN','1574385','99734OH005000401','2014-01-01','2013-12-20 19:49:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:33:50'),(14788,11811,'Y','18','021','EC','A','','','AC','0000710147','0000710147','OH00000887316','IL','1','Litt','Therese','','','','34','297448073','438 Vernon Road',0,'Mansfield','OH','44905',NULL,'CY','39139','1957-01-23','F','U',':RET:2106-3','N','021','DEN','2399151','99734OH005000401','2014-01-01','2013-12-23 20:52:05','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,1,'2013-12-29 11:13:25'),(13416,10704,'Y','18','021','EC','A','','','AC','0001012923','0001012923','OH00000521731','IL','1','Simon','Shirley','Ann','','','34','287482007','1244 Tampa Ave',0,'Akron','OH','44314',NULL,'CY','39153','1949-12-31','F','U',':RET:2106-3','N','021','DEN','1887124','99734OH005000301','2014-01-01','2013-12-23 10:49:14','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:00:41'),(25561,20277,'Y','18','024','14','A','','','TE','0000730183','0000730183','','IL','1','jones','yolvalda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-04-06','F','',NULL,NULL,NULL,'','1707048','','2014-03-10','2014-02-23 08:52:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-26 08:00:23'),(6109,4843,'Y','18','024','14','A','','','TE','0000761073','0000761073','','IL','1','Stivaletti','Anthony',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-04-20','M','',NULL,NULL,NULL,'','456568','','2013-11-21','2013-11-21 14:28:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:15:23'),(22478,17946,'N','19','021','EC','A',NULL,NULL,'','0000505768','0000307134','','IL','1','lindhorst','james','','','','34','301061137','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','2002-06-26','M','',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:01'),(1483,1237,'Y','18','021','EC','A','','','AC','0001163838','0001163838','OH00000091712','IL','1','Snodgrass','Kathleen','J','','','34','298545163','34754 Lakeshore Blvd',0,'Eastlake','OH','44095',NULL,'CY','39085','1953-11-14','F','U',':RET:2106-3','N','021','DEN','2552199','99734OH005000401','2014-01-01','2013-12-24 10:46:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:48:51'),(2930,2360,'N','19','021','EC','A',NULL,NULL,'','0000274757','0000149320','','IL','1','Perry','Heather','','','','34','275968569','15293 CALABOONE RD',0,'DOYLESTOWN','OH','44230','9204','CY','39169','1993-01-02','F','',':RET:2106-3','N','021','DEN','758404','99734OH005000401','2014-01-01','2013-12-05 20:48:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:59'),(9525,7552,'N','19','021','EC','A',NULL,NULL,'','0000667772','0001100589','','IL','1','AGARWAL','SHIVANI','NEIL','','','34','286062106','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','2001-08-18','F','',':RET:2029-7','N','021','DEN','2028084','99734OH005000301','2014-01-01','2013-12-20 20:28:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:42'),(23552,18763,'Y','18','024','14','A','','','TE','0001073132','0001073132','','IL','1','Hostetler','Lance',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-01-06','M','',NULL,NULL,NULL,'','1958887','','2014-02-28','2014-02-13 08:34:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-13 22:02:39'),(25952,20582,'Y','18','021','EC','A','','','AC','0001210976','0001210976','OH00002194391','IL','1','WENG','QIDIAN','','','','34','074962106','115 ARROW WOOD CT',0,'ETNA','OH','43062','8000','CY','39089','1984-10-26','M','M',NULL,'N','021','DEN','2997798','99734OH005000401','2014-04-01','2014-02-26 10:57:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:37'),(26250,20820,'Y','18','021','EC','A','','','AC','0000872882','0000872882','TX00003440398','31','1','Roblez','Catarina','','','','34','467153223','po box 340',0,'Christine','TX','78012',NULL,'CY','48013','1966-05-06','F','M',NULL,'N','021','DEN','3136304','33348TX002000201','2014-04-01','2014-02-27 13:50:11','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-28 06:31:08'),(3386,2715,'Y','18','021','EC','A','','','AC','0002238058','0002238058','LA00000473350','IL','1','ANDERSEN','MARY','','','','34','433749840','10439 R L BERGERON LN',0,'NEW ROADS','LA','70760','4120','CY','22077','1958-11-14','F','U',':RET:2106-3','N','021','DEN','2486905','18575LA002000201','2014-01-01','2013-12-21 18:39:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:17:40'),(6771,5373,'Y','18','021','EC','A','','','AC','0000689658','0000689658','OH00000903075','IL','1','McMahon','Christopher','','','','34','286784756','147 E MAPLEDALE AVE',0,'AKRON','OH','44301','1731','CY','39153','1982-01-17','M','U',':RET:2106-3','T','021','DEN','241085','99734OH005000301','2014-01-01','2013-11-25 13:56:21','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:16:38'),(22644,18080,'N','19','021','EC','A',NULL,NULL,'','0000121927','0000437044','','IL','1','Hoang','Dat','','','','34','640926490','3355 BEACON VIEW CT',0,'PEARLAND','TX','77584',NULL,'CY','48039','1992-07-28','M','',NULL,'N','021','DEN','3827885','33348TX002000201','2014-03-01','2014-02-11 10:26:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:24'),(3814,3054,'Y','18','024','14','A','','','TE','0000912935','0000912935','','IL','1','Williams','LaKisha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-18','F','',NULL,NULL,NULL,'','922603','','2013-12-13','2013-12-13 14:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:46'),(9564,7580,'N','19','021','EC','A',NULL,NULL,'','0000718911','0001127986','','S1','1','Pushkaran','Suvarnamala','Vivek','','','34','296150220','1395 STABLEVIEW CIR',0,'MAINEVILLE','OH','45039','7916','CY','39165','2010-04-28','M','',':RET:2029-7','N','021','DEN','1600650','99734OH005000301','2014-01-01','2013-12-21 16:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:37'),(21505,17180,'Y','18','021','EC','A','','','AC','0000793501','0000793501','OH00001985764','IL','1','Brown','Laura','','','','34','492921867','7906 POMONA AVE',0,'NORTHFIELD','OH','44067','2041','CY','39153','1986-04-12','F','U',':RET:2106-3','T','021','HLT','2998580','52664OH152001001','2014-03-01','2014-02-04 13:57:48','0.00',NULL,NULL,'147.77','147.77','R-OH012','OH0','147.77',NULL,0,'2014-02-04 21:01:54'),(9731,7706,'Y','18','021','EC','A','','','AC','0001126833','0001126833','OH00000530728','IL','1','Peters','David','','','','34','279787933','166 east main street',0,'orwell','OH','44076',NULL,'CY','39007','1981-11-09','M','U',':RET:2106-3','N','021','DEN','1220883','99734OH005000301','2014-01-01','2013-11-15 14:17:23','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:45:41'),(13561,10815,'Y','18','021','EC','A','','','AC','0001743826','0001743826','LA00000471101','IL','1','Qasem','Nabil','','','','34','455552794','12625 Coursey Blvd',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1961-05-16','M','M',':RET:2106-3','N','021','DEN','2357288','18575LA002000201','2014-01-01','2013-12-23 15:51:42','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:22'),(14030,11176,'Y','18','021','EC','A','','','AC','0000344140','0000344140','OH00000857229','IL','1','MAJOR','CLARA','','','','34','295460581','11318METHYL AVE',0,'CLEVELAND','OH','44120',NULL,'CY','39035','1949-12-12','F','M',':RET:2054-5','N','021','HLT','2093720','92036OH004000801','2014-01-01','2013-12-23 15:29:29','269.00',NULL,NULL,'563.97','294.97','R-OH011','OH0','563.97',NULL,0,'2013-12-26 13:16:51'),(18548,14792,'N','01','021','EC','A',NULL,NULL,'','0001107133','0000921196','','IL','1','TRAN','MICHAEL','','','','34','456971072','58 EASTVIEW CIR',0,'LAUREL','MS','39443','2623','CY','28067','1984-04-24','M','',':RET:2028-9','N','021','DEN','1833212','46300MS002000101','2014-02-01','2014-01-15 09:39:32',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-16 08:46:52'),(4960,3937,'Y','18','021','EC','A','','','AC','0000811959','0000811959','LA00000137553','IL','1','Governale','Michael','','','','34','434842783','30175 HUFF CHAPEL RD',0,'SPRINGFIELD','LA','70462','6927','CY','22063','1950-08-22','M','M',':RET:2106-3','N','021','DEN','1031836','18575LA002000201','2014-01-01','2013-12-07 10:30:18','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:46:09'),(5042,3992,'Y','18','021','EC','A','','','AC','0001203630','0001203630','TX00001025493','IL','1','Reagan','James','','','','34','225887867','118 DOGWOOD LAKES CIR',0,'BULLARD','TX','75757','8805','CY','48073','1956-11-23','M','U',':RET:2106-3','N','021','DEN','518419','33348TX002000101','2014-01-01','2013-12-07 14:31:20','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 22:48:02'),(15683,12545,'Y','18','021','EC','A','','','AC','0000819786','0000819786','OH00000154816','IL','1','Boop','Roy','','','','34','300504991','1105 Crestwood Dr.',0,'Lima','OH','45805',NULL,'CY','39003','1951-08-01','M','U',':RET:2106-3','N','021','HLT','1931687','92036OH003001505','2014-02-01','2013-12-31 11:13:35','591.00',NULL,NULL,'660.32','69.32','R-OH002','OH0','660.32',NULL,1,'2014-01-02 04:35:03'),(9696,7680,'Y','18','021','EC','A','','','AC','0001188783','0001188783','OH00000245993','IL','1','HOLTKAMP','JOHN','','','Sr','34','274540492','766 HALLE DR',0,'FAYETTEVILLE','OH','45118',NULL,'CY','39015','1952-01-04','M','U',NULL,'N','021','HLT','1521597','92036OH006000601','2014-01-01','2013-12-21 13:35:27','443.00',NULL,NULL,'478.41','35.41','R-OH005','OH0','478.41',NULL,0,'2013-12-26 04:39:51'),(25321,20088,'Y','18','021','EC','A','','','AC','0002140691','0002140691','LA00002700977','31','1','DUCOTE','ROBBY','','','','34','437550718','PO BOX 806',0,'PORT BARRE','LA','70577',NULL,'CY','22097','1977-07-14','M','U',':RET:2106-3','N','021','DEN','2980626','18575LA002000201','2014-04-01','2014-02-25 02:46:48','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-25 21:30:09'),(26899,21318,'Y','18','021','EC','A','','','AC','0001119764','0001119764','TX00002467130','IL','1','OPINA','FRANCISCO','LUIS','','','34','144745927','2204 MURPHY DR',0,'BEDFORD','TX','76021','5962','CY','48439','1958-01-26','M','U',NULL,'N','021','DEN','2780664','33348TX002000201','2014-04-01','2014-03-01 22:35:09','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-03 01:00:06'),(27603,21831,'Y','18','024','14','A','','','TE','0001218534','0001218534','','IL','1','JOHNSON','KATHI','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-14','F','',NULL,NULL,NULL,'','1586505','','2014-03-31','2014-03-05 09:24:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-05 21:00:24'),(27830,22011,'Y','18','021','EC','A','','','AC','0000148398','0000148398','OH00002706297','IL','1','Catanzaro','Darlene','','','','34','107705992','6082 SPRING LAKE DR',0,'HAMILTON','OH','45011','8195','CY','39017','1985-11-12','F','M',NULL,'N','021','DEN','4001292','99734OH005000301','2014-04-01','2014-03-05 10:38:23','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:32:00'),(2963,2386,'Y','18','021','EC','A','','','AC','0001166344','0001166344','TX00000726180','IL','1','CASE','PATRICIA','','','','34','463411437','280 BROOKWOOD ST',0,'ORE CITY','TX','75683','7308','CY','48315','1955-03-29','F','M',':RET:2106-3','N','021','DEN','1035620','33348TX002000201','2014-01-01','2013-12-06 18:13:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:49'),(21686,17316,'N','19','021','EC','A',NULL,NULL,'','0000099034','0000049549','','IL','1','MacCarthy','Linda','','','','34','272118405','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1993-09-03','F','',NULL,'N','021','HLT','3404444','92036OH004002601','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-02-05 21:31:04'),(9351,7411,'N','19','021','EC','A',NULL,NULL,'','0001181899','0002029221','','IL','1','Bates','Eric','','','','34','437856486','111 S OAK ST',0,'VIDALIA','LA','71373','4040','CY','22029','1992-12-05','M','',':RET:2054-5','N','021','DEN','1362458','18575LA002000201','2014-01-01','2013-12-20 23:36:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:31:15'),(15172,12124,'Y','18','021','EC','A','','','AC','0001148732','0001148732','OH00001593437','IL','1','GROTENRATH','DONNA','','','','34','396626977','480 bacon ave',0,'AKRON','OH','44320',NULL,'CY','39153','1953-01-17','F','U',':RET:2106-3','N','021','DEN','2105404','99734OH005000401','2014-02-01','2013-12-30 15:39:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-01 12:06:35'),(18933,15086,'Y','18','021','EC','A','','','AC','0000718939','0000718939','OH00001956604','IL','1','Gump','Daniel','','','','34','283862537','285 Columbus Rd',0,'Bedford','OH','44146',NULL,'CY','39035','1987-07-04','M','U',':RET:2106-3','N','021','DEN','2067622','99734OH005000401','2014-03-01','2014-01-17 11:14:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:05:39'),(17776,14203,'Y','18','021','EC','A','','','AC','0000406596','0000406596','TX00002521553','IL','1','CLAY','BRENDA','','','','34','412113771','8702 BROOKHOLLOW DR',0,'ROWLETT','TX','75089','8621','CY','48113','1962-09-05','F','M',NULL,'N','021','DEN','1581611','33348TX002000101','2014-02-01','2014-01-13 16:51:23','0.00',NULL,NULL,'108.60','108.60','R-TX008','TX0','27.15',NULL,0,'2014-01-14 01:33:41'),(15863,12702,'Y','18','021','EC','A','','','AC','0000200446','0000200446','MS00002113686','IL','1','Yeager','Jaimee','','','','34','426712628','711 S MIDDLE ST',0,'RIPLEY','MS','38663','2722','CY','28139','1991-01-08','F','M',':RET:2106-3','N','021','DEN','1987830','46300MS002000101','2014-02-01','2014-01-02 12:36:58','0.00',NULL,NULL,'54.30','54.30','R-MS002','MS0','27.15',NULL,0,'2014-01-03 02:04:51'),(22508,17968,'Y','18','024','14','A','','','TE','0000221341','0000221341','','IL','1','Morgan','Carol','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-11','F','',NULL,NULL,NULL,'','3179365','','2014-02-10','2014-02-10 09:30:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:31:16'),(23784,18927,'Y','18','024','14','A','','','TE','0000349299','0000349299','','IL','1','SCOTT','RAYMONE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-22','M','',NULL,NULL,NULL,'','3667992','','2014-02-13','2014-02-13 19:16:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:31:22'),(26162,20745,'Y','18','021','EC','A','','','AC','0000422866','0000422866','OH00003122738','IL','1','Orelli','Ricardo','','','','34','162449815','153 DEERFIELD LN',0,'AURORA','OH','44202','7521','CY','39133','1952-02-24','M','M',':RET:2106-3','N','021','DEN','2813689','99734OH005000401','2014-04-01','2014-02-27 17:54:31','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:33'),(26282,20847,'Y','18','021','EC','A','','','AC','0001827235','0001827235','LA00002831951','IL','1','Smith','Patrice','','','','34','435706138','556 ALICE ST',0,'BATON ROUGE','LA','70802','7103','CY','22033','1952-12-31','F','U',':RET:2054-5','N','021','DEN','3258758','18575LA002000101','2014-03-01','2014-02-27 10:37:07','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-28 06:31:20'),(3745,2996,'Y','18','021','EC','A','','','AC','0000015239','0000015239','TX00000745899','IL','1','Dillingham','Deborah','','','','34','460909637','808 WINGED FOOT',0,'CORSICANA','TX','75110','1184','CY','48349','1950-06-01','F','M',':RET:2106-3','N','021','DEN','829945','33348TX002000201','2014-01-01','2013-12-13 14:06:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:33:00'),(8024,6352,'Y','18','021','EC','A','','','AC','0000261485','0000261485','OH00000353432','IL','1','myers','billy','','','','34','280500499','3949 N 1ST ST',0,'TRENTON','OH','45067','9701','CY','39017','1950-11-21','M','U',':RET:2106-3','T','021','HLT','2593783','92036OH006001201','2014-01-01','2013-12-20 16:42:46','216.00',NULL,NULL,'577.94','361.94','R-OH004','OH0','577.94',NULL,0,'2013-12-26 03:08:58'),(20792,16613,'Y','18','021','EC','A','','','AC','0000241075','0000241075','TX00002589434','IL','1','Ball','Susan','','','','34','465418561','28411 Sm 506',0,'La seria','TX','78559',NULL,'CY','48061','1961-11-28','F','U',':RET:2106-3','N','021','DEN','3281743','33348TX002000201','2014-03-01','2014-01-31 10:37:06','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-31 21:00:16'),(18341,14645,'N','01','021','EC','A',NULL,NULL,'','0000514473','0000459180','','IL','1','Bourn','Cristal','','','','34','281623279','2429 26TH ST',0,'CUYAHOGA FALLS','OH','44223','1521','CY','39153','1969-09-17','F','',':RET:2106-3','N','021','DEN','2732603','99734OH005000401','2014-02-01','2014-01-15 17:50:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:17'),(14023,11171,'N','19','021','EC','A',NULL,NULL,'','0000865860','0000839053','','IL','1','HUA','HELEN','','','','34','297968359','1208 HOLLY DR',0,'SPRINGFIELD','OH','45504','4141','CY','39023','1994-05-22','F','',':RET:2047-9','N','021','HLT','2044515','92036OH002000501','2014-01-01','2013-12-23 10:50:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','174.32',NULL,0,'2013-12-26 13:16:41'),(17510,13998,'Y','18','021','EC','A','','','AC','0001234135','0001234135','OH00002183172','IL','1','DAVIS','DAVID','','','','34','274649972','1884 KALE ADAMS RD SW',0,'WARREN','OH','44481','9781','CY','39155','1962-08-02','M','M',':RET:2106-3','T','021','DEN','1570118','99734OH005000401','2014-02-01','2014-01-11 21:00:33','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-01-13 03:01:29'),(25004,19830,'Y','18','021','EC','A','','','AC','0001173265','0001173265','OH00001984678','IL','1','JONES','GARY','','','','34','294561430','5321 FAIRHILL DR',0,'RAVENNA','OH','44266','9029','CY','39133','1955-07-18','M','M',NULL,'N','021','HLT','3782719','52664OH151001301','2014-04-01','2014-02-20 14:12:40','616.00',NULL,NULL,'1088.50','472.50','R-OH012','OH0','568.22',NULL,0,'2014-02-20 22:00:48'),(8815,6987,'N','01','021','EC','A',NULL,NULL,'','0000397325','0000341323','','IL','1','Ginn','Roberta','','','','34','285749481','1964 Laurel Moscow Rd',0,'Moscow','OH','45153',NULL,'CY','39025','1963-06-06','F','',':RET:2106-3','N','021','HLT','2487723','92036OH004000601','2014-01-01','2013-12-17 20:26:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.28',NULL,0,'2013-12-26 04:00:06'),(14433,11511,'Y','18','021','EC','A','','','AC','0001390882','0001390882','LA00000534590','IL','1','BERRY','HAROLD','','','','34','437905896','34 IMOGENE ST',0,'WESTWEGO','LA','70094','5817','CY','22051','1954-07-26','M','M',':RET:2054-5','T','021','DEN','2255782','18575LA002000201','2014-02-01','2013-12-27 08:22:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:31:59'),(19611,15630,'Y','18','021','EC','A','','','AC','0000701728','0000701728','OH00001996483','IL','1','Quilty','James','','','','34','277748653','19487 FRAZIER DR',0,'ROCKY RIVER','OH','44116','1759','CY','39035','1965-01-29','M','R',':RET:2106-3','N','021','HLT','1992068','52664OH152000901','2014-03-01','2014-01-22 12:47:26','0.00',NULL,NULL,'314.29','314.29','R-OH011','OH0','314.29',NULL,0,'2014-01-23 03:02:50'),(16340,13080,'N','19','021','EC','A',NULL,NULL,'','0000910539','0000001053','','S1','1','CONRAD','CURT','W','','','34','280083719','4609 CREEKRUN DR',0,'MASON','OH','45040',NULL,'CY','39165','2003-04-25','F','',NULL,'N','021','DEN','2064786','99734OH005000301','2014-02-01','2014-01-06 12:31:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:13'),(22754,18166,'Y','18','021','EC','A','','','AC','0001590301','0001590301','LA00002452988','IL','1','Brown','Marvin','','','','34','433988325','5960 DIXIE LN',0,'ALEXANDRIA','LA','71301','2426','CY','22079','1956-04-22','M','U',':RET:2054-5','N','021','DEN','3193813','18575LA002000101','2014-03-01','2014-02-11 16:23:20','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-11 21:01:28'),(24030,19112,'Y','18','021','EC','A','','','AC','0001230447','0001230447','OH00002405407','31','1','woodruff','larry','','','','34','290522347','po box 295',0,'north balitmore','OH','45872',NULL,'CY','39173','1959-10-03','M','U',NULL,'T','021','HLT','3008432','92036OH004002601','2014-03-01','2014-02-15 16:38:00','166.00',NULL,NULL,'384.97','218.97','R-OH001','OH0','384.97',NULL,0,'2014-02-15 22:00:52'),(25179,19972,'Y','18','021','EC','A','','','AC','0000181057','0000181057','OH00002550763','IL','1','HOBERG','PAULA','M','','','34','281805244','5959 LINNVILLE RD',0,'NEWARK','OH','43056','9267','CY','39089','1970-02-08','F','M',NULL,'N','021','DEN','3224926','99734OH005000401','2014-04-01','2014-02-21 13:05:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-21 22:00:33'),(25220,20004,'Y','18','021','EC','A','','','AC','0000132058','0000132058','MS00003147718','IL','1','flemming','leo','','','','34','587050085','1314 BB KING RD',0,'INDIANOLA','MS','38751','3756','CY','28133','1949-06-07','M','U',':RET:2054-5','N','021','DEN','3415782','46300MS002000201','2014-04-01','2014-02-20 19:20:48','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-21 22:00:56'),(253,210,'Y','18','021','EC','A','','','AC','0000861246','0000861246','LA00000679227','IL','1','SCHEXNAYDER','Maureen','Moise','','','34','142382058','7424 MEADOWVIEW AVE',0,'BATON ROUGE','LA','70810','2023','CY','22033','1955-05-21','F','U',':RET:2106-3','N','021','DEN','1058289','18575LA002000101','2014-01-01','2013-12-05 14:16:33','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 17:21:37'),(21845,17445,'N','19','021','EC','A',NULL,NULL,'','0000915679','0000711411','','S1','1','Gaglione','John','','','','34','277027773','334 STANTON HALL CT',0,'KETTERING','OH','45429','1851','CY','39113','1997-04-28','F','',':RET:2106-3','N','021','DEN','3130763','99734OH005000301','2014-03-01','2014-02-06 11:42:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:13'),(21580,17238,'Y','18','021','EC','A','','','AC','0000684852','0000684852','OH00001930348','IL','1','Broadwater','Jason','','','','34','292927734','1966 KELSEY DR',0,'CUYAHOGA FALLS','OH','44221','4344','CY','39153','1985-08-22','M','U',NULL,'N','021','HLT','3512367','52664OH151001304','2014-03-01','2014-02-05 15:01:02','87.00',NULL,NULL,'242.41','155.41','R-OH012','OH0','242.41',NULL,0,'2014-02-05 21:30:25'),(6336,5022,'N','19','021','EC','A',NULL,NULL,'','0001088245','0000271407','','IL','1','Jordan','Kennedy','','','','34','280114568','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','2005-05-23','F','',NULL,'N','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:41'),(21195,16938,'N','01','021','EC','A',NULL,NULL,'','0000727646','0000737429','','IL','1','STEPHENS','JASON','','','','34','428895227','793 HARRY SONES RD',0,'CARRIERE','MS','39426','8200','CY','28109','1980-09-06','M','',':RET:2106-3','N','021','DEN','3052190','46300MS002000101','2014-03-01','2014-02-03 16:57:01',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-03 21:00:50'),(19587,15613,'N','01','021','EC','A',NULL,NULL,'','0001131927','0001153418','','IL','1','DAMPIER','KEITH','','','','34','587461807','4625 HERITAGE MNR',0,'JACKSON','MS','39212',NULL,'CY','28049','1953-08-14','M','',NULL,'N','021','DEN','2375473','46300MS002000201','2014-03-01','2014-01-22 16:22:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-23 03:02:43'),(17650,14108,'Y','18','021','EC','A','','','AC','0000664202','0000664202','OH00001923417','IL','1','Cogley','Robert','','','','34','480749084','1337 HANSON ST',0,'REYNOLDSBURG','OH','43068','4769','CY','39089','1955-12-14','M','M',':RET:2106-3','N','021','DEN','1491532','99734OH005000301','2014-02-01','2014-01-13 12:00:11','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:32:40'),(2840,2295,'Y','18','021','EC','A','','','AC','0001239085','0001239085','OH00000494244','IL','1','Felger','Zachary','Aaron','','','34','298940704','5266 TIPPECANOE RD',0,'CANFIELD','OH','44406','9500','CY','39099','1992-05-22','M','U',':RET:2106-3','T','021','DEN','813161','99734OH005000401','2014-01-01','2013-11-24 14:41:17','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:01:01'),(427,350,'Y','18','021','EC','A','','','AC','0000321017','0000321017','OH00000739672','IL','1','WEAVER','WINIFRED','','','','34','296867867','1168 SIDNEY ST',0,'COLUMBUS','OH','43201',NULL,'CY','39049','1987-10-16','F','U',NULL,'N','021','DEN','605544','99734OH005000401','2014-01-01','2013-12-04 13:58:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:48'),(13107,10451,'Y','18','021','EC','A','','','AC','0000835458','0000835458','OH00000664650','IL','1','Dutton','Karen','Lynn','','','34','272500526','4860 RIDGESIDE CIR SE',0,'CANTON','OH','44707','1133','CY','39151','1950-07-01','F','U',':RET:2106-3','N','021','DEN','1742044','99734OH005000401','2014-01-01','2013-12-23 13:13:53','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 12:52:20'),(9634,7632,'Y','18','021','EC','A','','','AC','0000611953','0000611953','OH00000630709','IL','1','Richards','Frances','','','','34','296501947','1868 11th st sw',0,'Akron','OH','44314',NULL,'CY','39153','1952-05-16','F','U',':RET:2106-3','T','021','HLT','2157463','52664OH152000901','2014-01-01','2013-12-21 18:18:57','474.00',NULL,NULL,'527.84','53.84','R-OH012','OH0','527.84',NULL,0,'2013-12-26 04:38:17'),(23279,18557,'N','01','021','EC','A',NULL,NULL,'','0001387258','0002026485','','IL','1','Hodgson-Rigsbee','Ryan','','','','34','352728107','3301 BANKS ST',0,'NEW ORLEANS','LA','70119','7109','CY','22071','1981-10-01','M','',':RET:2106-3','N','021','DEN','3217802','18575LA002000201','2014-03-01','2014-02-13 12:03:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-13 21:30:15'),(24735,19635,'Y','18','021','EC','A','','','AC','0000990107','0000990107','OH00003038556','IL','1','Lovingshimer','Melanie','Dawn','','','34','289724784','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-01-08','F','M',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:39:41'),(27525,21776,'Y','18','021','EC','A','','','AC','0000289586','0000289586','OH00003609757','IL','1','eisenhauer','joshua','','','','34','522945502','853 EUCLID AVE',0,'TOLEDO','OH','43605','2324','CY','39095','1975-03-31','M','U',':RET:2106-3','T','021','HLT','3402016','92036OH003002604','2014-04-01','2014-03-04 14:37:06','90.00',NULL,NULL,'295.53','205.53','R-OH001','OH0','295.53',NULL,0,'2014-03-04 21:02:43'),(27648,21870,'Y','18','021','EC','A','','','AC','0000933267','0000933267','OH00003652772','IL','1','Fredericy','Edward','','','','34','299567973','11419 SARCHET LN',0,'DRESDEN','OH','43821','8754','CY','39119','1956-01-18','M','U',':RET:2106-3','N','021','DEN','3225263','99734OH005000401','2014-04-01','2014-03-05 13:07:06','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-05 21:30:20'),(161,135,'Y','18','021','EC','A','','','AC','0000281629','0000281629','TX00001062282','IL','1','JENKINS','BARBRA','','','','34','467373784','3531 FIORELLA WAY',0,'HUMBLE','TX','77338','1295','CY','48201','1964-12-05','F','U',':RET:2054-5','N','021','DEN','617187','33348TX002000101','2014-01-01','2013-12-05 12:42:38','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 17:19:11'),(22361,17857,'Y','18','024','14','A','','','TE','0001174396','0001174396','','IL','1','Thornton','Christine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-01-27','F','',NULL,NULL,NULL,'','2601350','','2014-01-21','2014-02-10 12:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-10 21:00:08'),(22241,17752,'N','01','021','EC','A',NULL,NULL,'','0000049552','0000228377','','IL','1','CONTI','CATHERINE','','','','34','278602593','709 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1813','CY','39035','1960-03-29','F','',':RET:2106-3','N','021','DEN','3018000','99734OH005000301','2014-03-01','2014-02-09 13:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-09 19:00:38'),(21704,17332,'Y','18','021','EC','A','','','AC','0000789574','0000789574','MS00001757757','IL','1','Marshall','Joey','','','','34','428457703','6306 Quail Lake Drv',0,'Jackson','MS','39206',NULL,'CY','28049','1969-08-02','M','U',NULL,'N','021','DEN','3060834','46300MS002000201','2014-03-01','2014-02-05 14:54:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-05 21:31:12'),(20408,16300,'Y','18','021','EC','A','','','AC','0000944425','0000944425','TX00002499424','IL','1','OYERVIDES','SERGIO','','','','34','631440594','9604 BAHAMAS ST',0,'EL PASO','TX','79927','2801','CY','48141','1969-03-31','M','M',':RET:2106-3','N','021','DEN','2786349','33348TX002000201','2014-03-01','2014-01-29 16:36:59','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-29 21:00:23'),(19627,15644,'Y','18','021','EC','A','','','AC','0000271456','0000271456','OH00002375772','IL','1','FLEISHER','TINA','L','','','34','284700996','2408 BILLINGSLEY RD',0,'COLUMBUS','OH','43235','1922','CY','39049','1972-04-21','F','M',':RET:2054-5','N','021','DEN','1786610','99734OH005000401','2014-03-01','2014-01-23 10:13:53','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:07'),(9274,7358,'Y','18','021','EC','A','','','AC','0001119925','0001119925','OH00001019150','IL','1','MUNDY','LORETTA','','','','34','288561250','19379 BENNETT RD',0,'NORTH ROYALTON','OH','44133','5959','CY','39035','1955-01-14','F','M',':RET:2106-3','N','021','DEN','13372','99734OH005000401','2014-01-01','2013-11-30 14:53:34','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:15:45'),(25633,20335,'Y','18','021','EC','A','','','AC','0000680903','0000680903','OH00003054792','31','1','Berry StVictor','Sophia','Loren','','','34','057608837','Pobox 13574',0,'whitehall','OH','43207',NULL,'CY','39049','1973-10-26','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2695004','99734OH005000301','2014-04-01','2014-02-22 14:40:14','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-26 08:30:24'),(25988,20609,'Y','18','021','EC','A','','','AC','0001158293','0001158293','MS00002719812','IL','1','MOORE','MINNIE','','','','34','587540467','795 W COUNTY LINE RD',0,'JACKSON','MS','39213',NULL,'CY','28049','1950-04-30','F','U',NULL,'N','021','DEN','3347536','46300MS002000201','2014-03-01','2014-02-26 09:24:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:54'),(28982,22939,'Y','18','021','EC','A','','','AC','0000615576','0000615576','OH00003504489','IL','1','Robinson','James','','','','34','288583556','7041 olde 8 rd',0,'hudson','OH','44236',NULL,'CY','39153','1955-12-24','M','M',':RET:2106-3','N','021','HLT','4101757','52664OH151001306','2014-05-01','2014-03-10 09:41:14','1000.00',NULL,NULL,'1173.46','173.46','R-OH012','OH0','568.22',NULL,0,'2014-03-10 21:01:10'),(29011,22961,'N','19','021','EC','A',NULL,NULL,'','0000848418','0000069141','','S3','1','rickett','bruce','','','','34','680622793','132 KEYSTONE RD',0,'VINTON','OH','45686','9073','CY','39053','2004-10-05','F','',':RET:2106-3','N','021','DEN','4367183','99734OH005000401','2014-04-01','2014-03-09 19:53:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:24'),(355,292,'Y','18','021','EC','A','','','AC','0000322100','0000322100','OH00000212061','IL','1','Van Slyke','Linda','Lou','','','34','271527444','2137 Dana St',0,'Toledo','OH','43609',NULL,'CY','39095','1951-11-17','F','U',':RET:2106-3','T','021','HLT','45960','92036OH005002605','2014-01-01','2013-11-09 15:04:01','462.00',NULL,NULL,'644.25','182.25','R-OH001','OH0','644.25',NULL,0,'2013-12-25 17:32:24'),(6296,4994,'Y','18','021','EC','A','','','AC','0000062515','0000062515','OH00000974823','IL','1','KACHMAR','RICHARD','J','','','34','299460391','15175 HARTFORD TRL',0,'STRONGSVILLE','OH','44136','8221','CY','39035','1950-08-28','M','M',':RET:2106-3','N','021','DEN','1086525','99734OH005000401','2014-01-01','2013-12-11 08:34:34','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:47'),(5955,4716,'Y','18','021','EC','A','','','AC','0000876063','0000876063','OH00000529033','IL','1','Erard','Mary','JANE','','','34','288604528','1727 WILDWOOD RD',0,'TOLEDO','OH','43614','4028','CY','39095','1964-02-20','F','U',':RET:2106-3','N','021','HLT','1401719','92036OH006002601','2014-01-01','2013-12-23 22:06:29','36.00',NULL,NULL,'263.83','227.83','R-OH001','OH0','263.83',NULL,0,'2013-12-25 23:51:12'),(19580,15607,'N','01','021','EC','A',NULL,NULL,'','0001228484','0001795876','','IL','1','Pham','Hai-Linh','Nguyen','','','34','626416818','12003 DAWN AVE',0,'BATON ROUGE','LA','70815','2614','CY','22033','1984-08-24','F','',NULL,'N','021','DEN','3243578','18575LA002000201','2014-03-01','2014-01-22 12:27:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 03:02:40'),(17521,14008,'Y','18','021','EC','A','','','AC','0001115964','0001115964','OH00002534700','IL','1','Warden','George','w','','','34','273560661','195 W Fountain Ave',0,'Delaware','OH','43015',NULL,'CY','39041','1956-07-16','M','M',':RET:2106-3','N','021','DEN','2686419','99734OH005000401','2014-02-01','2014-01-12 11:09:49','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-13 03:01:36'),(4483,3556,'N','01','021','EC','A',NULL,NULL,'','0000377445','0000278303','','IL','1','foster','stephanie',NULL,NULL,NULL,NULL,NULL,'726 WALLINGER DR',0,'GALLOWAY','OH','43119','8752','CY','39049','1985-01-18','F','',':RET:2054-5^:RET:2106-3','T','021','DEN','775664','99734OH005000301','2014-01-01','2013-12-12 15:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:03:01'),(16686,13352,'Y','18','021','EC','A','','','AC','0000661587','0000661587','TX00001083469','31','1','wheeler','charlie','','','','34','456895235','po box 60',0,'valley view','TX','76272',NULL,'CY','48097','1973-06-16','M','M',':RET:2106-3','T','021','DEN','1449642','33348TX002000201','2014-02-01','2014-01-06 18:43:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:33'),(16354,13089,'N','19','021','EC','A',NULL,NULL,'','0000568041','0000623988','','IL','1','BADER','EMILY','','','','34','291080712','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','2003-12-01','F','',NULL,'N','021','DEN','2467785','99734OH005000301','2014-02-01','2014-01-06 14:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:36'),(4079,3260,'Y','18','021','EC','A','','','AC','0001155094','0001155094','OH00000427655','IL','1','Gingo','Michael',NULL,NULL,NULL,NULL,NULL,'1396 WIMBLEDON CIR',0,'STOW','OH','44224','2448','CY','39153','1959-01-07','M','R',NULL,'N','021','HLT','2262047','52664OH152000901','2014-01-01','2013-12-17 12:30:02','0.00',NULL,NULL,'348.73','348.73','R-OH012','OH0','348.73',NULL,0,'2013-12-25 21:47:08'),(14316,11418,'Y','18','024','14','A','','','TE','0001065962','0001065962','','IL','1','doughman','joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-01-06','M','',NULL,NULL,NULL,'','2010357','','2013-12-26','2013-12-26 11:07:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:07:09'),(2189,1801,'Y','18','021','EC','A','','','AC','0001038568','0001038568','OH00000979754','IL','1','HILLIARD','DIANA','','','','34','279629882','6660 STATE ROUTE 753',0,'HILLSBORO','OH','45133','9324','CY','39071','1962-10-17','F','M',NULL,'N','021','HLT','1168531','92036OH002000601','2014-01-01','2013-12-10 08:36:38','43.00',NULL,NULL,'462.36','419.36','R-OH005','OH0','462.36',NULL,0,'2013-12-25 19:19:41'),(24507,19468,'Y','18','021','EC','A','','','AC','0000780566','0000780566','TX00001739969','IL','1','Stephens','Brittney','nicole','','','34','463810573','557 en 20th',0,'abilene','TX','79601',NULL,'CY','48441','1986-01-14','F','U',':RET:2106-3','N','021','DEN','2857858','33348TX002000201','2014-04-01','2014-02-18 23:19:33','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-02-20 03:51:50'),(25692,20383,'N','01','021','EC','A',NULL,NULL,'','0001260065','0001183576','','IL','1','Geer','Kenneth','','','','34','300660906','6030 FERRY RD',0,'WAKEMAN','OH','44889','9405','CY','39077','1960-09-16','M','',':RET:2106-3','N','021','HLT','2776711','92036OH003002704','2014-04-01','2014-02-23 20:33:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.41',NULL,0,'2014-02-26 09:30:13'),(25936,20567,'Y','18','024','14','A','','','TE','0000784040','0000784040','','IL','1','Sparks','Alice',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-26','F','',NULL,NULL,NULL,'','3760819','','2014-02-26','2014-02-26 16:51:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-26 21:01:29'),(27688,21897,'Y','18','021','EC','A','','','AC','0000792429','0000792429','TX00003591223','IL','1','Harris','Blake','','','','34','450758584','1717 W WEBSTER ST',0,'HOUSTON','TX','77019','5461','CY','48201','1984-08-30','M','U',':RET:2106-3','N','021','DEN','2905444','33348TX002000201','2014-04-01','2014-03-05 09:45:43','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-05 21:30:42'),(27988,22145,'Y','18','021','EC','A','','','AC','0002198972','0002198972','LA00003813724','IL','1','BAKER','ILENE','','','','34','433218123','43 COLONIAL DR',0,'MONROE','LA','71203','2501','CY','22073','1971-08-01','F','U',':RET:2054-5','N','021','DEN','3952639','18575LA002000201','2014-04-01','2014-03-06 17:07:50','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-03-06 21:01:02'),(28132,22262,'Y','18','021','EC','A','','','AC','0000070362','0000070362','OH00003070786','IL','1','Shank','Becky','J','','','34','285641153','1520 Orange Road Lot 91',0,'Ashland','OH','44805',NULL,'CY','39005','1958-07-23','F','M',NULL,'T','021','HLT','3041084','52664OH151001306','2014-04-01','2014-03-06 12:39:23','474.00',NULL,NULL,'571.90','97.90','R-OH012','OH0','571.90',NULL,0,'2014-03-06 21:02:25'),(28294,22387,'Y','18','024','14','A','','','TE','0000198629','0000198629','','IL','1','Day','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-10-29','F','',NULL,NULL,NULL,'','3096511','','2014-03-07','2014-03-07 11:40:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:29'),(28656,22676,'Y','18','021','EC','A','','','AC','0001878362','0001878362','LA00002615598','IL','1','MICKLE','STEVE','','','','34','437339185','4324 JEANNE MARIE PL',0,'NEW ORLEANS','LA','70122','1871','CY','22071','1970-08-28','M','U',NULL,'N','021','DEN','2836068','18575LA002000201','2014-04-01','2014-03-08 09:42:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-08 21:30:41'),(6227,4936,'Y','18','021','EC','A','','','AC','0000300368','0000300368','OH00000184353','IL','1','Kunkel','Ashley','','','','34','284965001','2011 FARMVIEW DR',0,'LANCASTER','OH','43130','8415','CY','39045','1992-02-17','F','U',':RET:2106-3','N','021','DEN','1143609','99734OH005000401','2014-01-01','2013-11-19 12:07:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:31:20'),(22408,17892,'Y','18','021','EC','A','','','AC','0001444331','0001444331','LA00001879168','IL','1','THOMAS','LESLIE','','','','34','438963157','3000 GENTILLY BLVD',0,'NEW ORLEANS','LA','70122',NULL,'CY','22071','1955-02-15','F','U',NULL,'N','021','DEN','3392574','18575LA002000201','2014-03-01','2014-02-10 09:57:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:24'),(22072,17618,'Y','18','021','EC','A','','','AC','0001253225','0001253225','TX00002455341','IL','1','OLVERA','JOSE','PEDRO','','','34','452996933','702 E BURLESON ST',0,'MARSHALL','TX','75670','3510','CY','48203','1951-04-17','M','M',NULL,'N','021','DEN','3031677','33348TX002000201','2014-03-01','2014-02-08 16:37:37','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:15'),(21839,17440,'Y','18','021','EC','A','','','AC','0001160447','0001160447','OH00002636455','IL','1','Quaye','Isaac','','','','34','752134585','935 PYRAMID HILL BLVD',0,'HAMILTON','OH','45013','3780','CY','39017','1984-02-16','M','M',':RET:2054-5','N','021','HLT','3211744','92036OH006001201','2014-03-01','2014-02-06 12:40:50','0.00',NULL,NULL,'193.23','193.23','R-OH004','OH0','193.23',NULL,0,'2014-02-06 21:01:09'),(21705,17333,'Y','18','021','EC','A','','','AC','0000917024','0000917024','OH00001785990','IL','1','abdul hadi','sammy','','','','34','253479817','630 BATTLES RD',0,'GATES MILLS','OH','44040','9768','CY','39035','1984-01-14','M','M',NULL,'N','021','HLT','3058463','92036OH005000806','2014-03-01','2014-02-04 23:04:44','393.00',NULL,NULL,'530.74','137.74','R-OH011','OH0','265.37',NULL,0,'2014-02-05 21:31:12'),(2942,2367,'Y','18','021','EC','A','','','AC','0000694163','0000694163','OH00000994671','IL','1','ATZBACH','DONA','','','','34','280480977','899 W LIMA ST',0,'KENTON','OH','43326','1082','CY','39065','1950-03-13','F','U',':RET:2106-3','N','021','DEN','9650','99734OH005000401','2014-01-01','2013-12-06 12:15:42','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 20:16:16'),(13453,10727,'N','01','021','EC','A',NULL,NULL,'','0000116589','0000951796','','IL','1','young','thomas','','','','34','299868673','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1987-07-10','M','',':RET:2106-3','N','021','DEN','2417728','99734OH005000301','2014-01-01','2013-12-23 14:32:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:33'),(14078,11218,'N','01','021','EC','A',NULL,NULL,'','0000166385','0001099197','','IL','1','Pope','terry','Lewis','','','34','302708911','1214 LINDEN AVE',0,'AKRON','OH','44310','1263','CY','39153','1962-08-21','M','',':RET:2054-5','N','021','DEN','2148666','99734OH005000401','2014-02-01','2013-12-26 10:09:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:02'),(16112,12906,'Y','18','021','EC','A','','','AC','0000989291','0000989291','MS00000904392','IL','1','GONZALEZ','ADDISON','','','','34','425719166','528 WOODSMOKE DR',0,'SOUTHAVEN','MS','38671','5625','CY','28033','1988-11-26','M','R',':RET:2106-3','N','021','DEN','1756851','46300MS002000101','2014-02-01','2014-01-03 15:25:58','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-04 02:05:06'),(23134,18440,'Y','18','021','EC','A','','','AC','0000710181','0000710181','OH00002383991','IL','1','watkins','crystal','','','','34','301702206','1724 bailey road',0,'cuyahogafalls','OH','44221',NULL,'CY','39153','1970-05-29','F','U',':RET:2054-5','N','021','HLT','3705417','52664OH151001305','2014-03-01','2014-02-11 20:34:32','208.00',NULL,NULL,'302.62','94.62','R-OH012','OH0','302.62',NULL,0,'2014-02-12 21:31:32'),(26624,21109,'N','01','021','EC','A',NULL,NULL,'','0000200559','0000967165','','IL','1','Carter','Stanwyn','Jay','','','34','362928753','3615 Rosedale St',0,'Houston','TX','77004',NULL,'CY','48201','1966-07-13','M','',':RET:2054-5','N','021','DEN','3137373','33348TX002000201','2014-04-01','2014-02-28 12:35:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 21:30:53'),(837,692,'Y','18','024','14','A','','','TE','0000846115','0000846115','','IL','1','Reynolds','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-10-06','F','',NULL,NULL,NULL,'','330460','','2013-12-16','2013-12-16 12:02:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:06:31'),(7448,5896,'Y','18','021','EC','A','','','AC','0001057973','0001057973','OH00000173146','IL','1','Johnson','Stacey','','','','34','299903762','4319 POST RAIL LN',0,'FRANKLIN','OH','45005','4950','CY','39165','1987-08-28','F','U',NULL,'N','021','DEN','832236','99734OH005000301','2014-01-01','2013-12-15 11:58:11','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:30:38'),(7288,5778,'N','19','021','EC','A',NULL,NULL,'','0000998761','0000950665','','IL','1','Rogers','Rebecca',NULL,NULL,NULL,NULL,NULL,'10016 HOMESTEAD RD',0,'WADSWORTH','OH','44281','9033','CY','39103','2001-09-14','F','',NULL,'N','021','HLT','980982','52664OH151001501','2014-01-01','2013-12-14 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 02:02:52'),(21818,17423,'Y','18','021','EC','A','','','AC','0001253571','0001253571','OH00002446587','IL','1','POLITSCH','BRENDA','','','','34','323545111','1738 ST ROUTE 303',0,'STREETSBORO','OH','44241',NULL,'CY','39133','1959-04-25','F','U',':RET:2106-3','T','021','HLT','2621223','52664OH151001305','2014-03-01','2014-02-06 16:29:44','345.00',NULL,NULL,'547.54','202.54','R-OH012','OH0','547.54',NULL,0,'2014-02-06 21:00:58'),(2975,2396,'Y','18','021','EC','A','','','AC','0000274965','0000274965','TX00000464182','31','1','Stankorb','Iris','','','','34','463293641','P. O. Box 9262',0,'Longview','TX','75608',NULL,'CY','48183','1951-01-12','F','M',':RET:2034-7','N','021','DEN','617202','33348TX002000201','2014-01-01','2013-12-05 18:32:20','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 20:17:05'),(19563,15595,'Y','18','021','EC','A','','','AC','0001617712','0001617712','LA00002033735','IL','1','white','harold','','','','34','434471177','1301 BAYOU MARIA RD',0,'PINEVILLE','LA','71360','6801','CY','22079','1981-09-14','M','U',':RET:2106-3','T','021','DEN','2321241','18575LA002000201','2014-03-01','2014-01-22 13:07:06','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-23 03:02:34'),(4267,3399,'Y','18','024','14','A','','','TE','0001152170','0001152170','','IL','1','Griffith','Tereasa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-07-18','F','',NULL,NULL,NULL,'','724805','','2013-12-16','2013-12-16 20:37:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:40'),(13881,11075,'N','19','021','EC','A',NULL,NULL,'','0001216261','0000521945','','IL','1','RIEHM','RYAN','','','','34','300960926','19601 BATTERSEA BLVD',0,'ROCKY RIVER','OH','44116','1651','CY','39035','1994-05-13','M','',':RET:2106-3','N','021','HLT','1359839','52664OH151001501','2014-01-01','2013-12-23 15:05:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-26 13:13:18'),(13133,10475,'Y','18','024','14','A','','','TE','0000912952','0000912952','','IL','1','HARDING','AMELIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-10','F','',NULL,NULL,NULL,'','2369470','','2013-12-23','2013-12-23 15:02:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:53:05'),(9372,7430,'N','19','021','EC','A',NULL,NULL,'','0002157175','0002333528','','IL','1','TAYLOR','LELAND','S','','','34','232909658','8038 EDGELAKE CT',0,'NEW ORLEANS','LA','70126',NULL,'CY','22071','1992-10-13','M','',':RET:2054-5','N','021','DEN','1380566','18575LA002000201','2014-01-01','2013-12-21 12:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:31:50'),(9314,7385,'Y','18','021','EC','A','','','AC','0002219361','0002219361','LA00000395763','IL','1','Robinson','Lisa','','','','34','436965655','1527 Soniat St.',0,'New Orleans','LA','70115',NULL,'CY','22071','1958-01-29','F','U',':RET:2106-3','N','021','DEN','2539479','18575LA002000101','2014-01-01','2013-12-21 11:36:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:20'),(4781,3795,'Y','18','021','EC','A','','','AC','0000614056','0000614056','MS00000550279','IL','1','Berry','Adra','','','','34','412395645','8136 LODEN CV',0,'SOUTHAVEN','MS','38671','7354','CY','28033','1980-12-01','F','U',':RET:2054-5','N','021','DEN','429442','46300MS002000101','2014-01-01','2013-12-07 19:57:18','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-25 22:16:07'),(28153,22280,'Y','18','021','EC','A','','','AC','0000108222','0000108222','OH00002828251','IL','1','Perdew','Kurt','','','','34','279862032','703 TAYLOR ST',0,'DELTA','OH','43515','1043','CY','39051','1986-12-29','M','M',':RET:2106-3','N','021','HLT','3334936','92036OH005002601','2014-04-01','2014-03-06 15:18:42','173.00',NULL,NULL,'647.79','474.79','R-OH001','OH0','204.35',NULL,0,'2014-03-06 21:02:38'),(317,260,'Y','18','021','EC','A','','','AC','0001080287','0001080287','OH00000056015','IL','1','Jenkins','William','','','','34','268822272','185 Applegrove St',0,'North Canton','OH','44720',NULL,'CY','39151','1967-10-03','M','U',':RET:2106-3','N','021','HLT','28421','52664OH152000901','2014-01-01','2013-11-13 16:19:43','166.00',NULL,NULL,'245.01','79.01','R-OH015','OH0','245.01',NULL,0,'2013-12-25 17:31:13'),(21281,17007,'N','01','021','EC','A',NULL,NULL,'','0000268933','0000421500','','IL','1','Bostelman','Kitty','','','','34','270560756','14265 HARRISON RD',0,'GRAND RAPIDS','OH','43522','9669','CY','39095','1956-04-14','F','',':RET:2106-3','N','021','HLT','2857489','92036OH003002604','2014-03-01','2014-02-03 18:06:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','496.27',NULL,0,'2014-02-03 21:01:37'),(19015,15142,'N','01','021','EC','A',NULL,NULL,'','0002270836','0002202396','','IL','1','chevarria ibanez','zuleika','','','','34','661221061','1029 S DARLA AVE',0,'GONZALES','LA','70737','4043','CY','22005','1975-11-25','F','',NULL,'N','021','DEN','2070285','18575LA002000201','2014-03-01','2014-01-17 15:39:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-20 08:06:22'),(15796,12644,'Y','18','021','EC','A','','','AC','0001867134','0001867134','LA00001715053','IL','1','Thi','Hien','','','','34','662077254','5202 Raval St.',0,'New Orleans','LA','70129',NULL,'CY','22071','1976-05-17','F','M',NULL,'N','021','DEN','1480515','18575LA002000201','2014-02-01','2014-01-02 18:01:30','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:41'),(14887,11889,'Y','18','021','EC','A','','','AC','0001465295','0001465295','LA00001690770','IL','1','Fleming','Alexander','','','','34','428475532','1243 MARIGNY ST',0,'NEW ORLEANS','LA','70117','8418','CY','22071','1974-01-17','M','U',':RET:2106-3','N','021','DEN','2314472','18575LA002000201','2014-02-01','2013-12-28 19:10:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:40'),(7525,5956,'Y','18','021','EC','A','','','AC','0000740257','0000740257','OH00000093831','IL','1','Chahal','Bhalinder','Singh','','','34','271176838','9977 Darrow park drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1986-04-28','M','M',':RET:2029-7','N','021','HLT','275614','52664OH152001001','2014-01-01','2013-12-15 14:46:48','0.00',NULL,NULL,'128.49','128.49','R-OH012','OH0','128.49',NULL,0,'2013-12-26 02:32:31'),(4184,3328,'N','01','021','EC','A',NULL,NULL,'','0000187457','0001216249','','IL','1','Sheller','Elizabeth','A','','','34','297624926','11951 WHITMAN RD',0,'DOYLESTOWN','OH','44230','9733','CY','39169','1961-08-16','F','',':RET:2106-3','N','021','HLT','2170046','52664OH151001304','2014-01-01','2013-12-17 08:53:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2013-12-25 21:49:28'),(6180,4897,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000310575','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','309822','92036OH006002601','2014-01-01','2013-10-02 17:56:00','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-26 00:17:17'),(2057,1685,'N','01','021','EC','A',NULL,NULL,'','0001122718','0000288280','','IL','1','Pauley','Christine','','','','34','296809911','9139 LAKE VIEW DR',0,'OLMSTED FALLS','OH','44138','3713','CY','39035','1968-01-17','F','',':RET:2106-3','N','021','DEN','878456','99734OH005000301','2014-01-01','2013-12-09 20:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:16:02'),(13095,10440,'Y','18','021','EC','A','','','AC','0000566620','0000566620','OH00000303060','IL','1','Manzi','Alberta','','','','34','297501103','3657 Bendemeer Road',0,'Cleveland Heights','OH','44118',NULL,'CY','39035','1951-05-24','F','U',':RET:2106-3','N','021','DEN','2185844','99734OH005000401','2014-01-01','2013-12-23 11:53:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:59'),(5457,4335,'Y','18','024','14','A','','','TE','0000418858','0000418858','','IL','1','musil','timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-08','M','',NULL,NULL,NULL,'','137521','','2013-12-19','2013-12-19 14:33:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:19'),(1230,1013,'Y','18','021','EC','A','','','AC','0000027866','0000027866','OH00000180326','IL','1','Rains','Thomas','','','','34','270949639','1240 DODD ST',0,'NAPOLEON','OH','43545','1052','CY','39069','1985-10-19','M','U',':RET:2106-3','N','021','HLT','647354','92036OH004002601','2014-01-01','2013-12-03 00:42:55','155.00',NULL,NULL,'170.44','15.44','R-OH001','OH0','170.44',NULL,0,'2013-12-25 18:20:41'),(1511,1260,'Y','18','021','EC','A','','','AC','0000763528','0000763528','OH00000890288','31','1','Betz','Florence','','','','34','273669376','P.o. Box 46',0,'Harrisburg','OH','43126',NULL,'CY','39049','1958-10-05','F','U',':RET:2106-3','N','021','DEN','2537403','99734OH005000401','2014-01-01','2013-12-24 13:13:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:49:31'),(17589,14059,'Y','18','021','EC','A','','','AC','0000895729','0000895729','OH00001397605','IL','1','Howard','Cornell','','','','34','417027527','780 Clinton Springs Ave.',0,'Cincinnati','OH','45229',NULL,'CY','39061','1970-06-28','M','M',':RET:2054-5','N','021','DEN','2570155','99734OH005000401','2014-02-01','2014-01-13 17:06:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:09'),(18049,14420,'Y','18','021','EC','A','','','AC','0001023984','0001023984','MS00002220900','IL','1','Harris','Marqua','','','','34','638861619','1114 COVINGTON PARK DR',0,'JACKSON','MS','39212','5046','CY','28049','1978-09-10','M','U',NULL,'T','021','DEN','2043908','46300MS002000101','2014-02-01','2014-01-14 12:14:34','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-15 02:07:16'),(22182,17703,'Y','18','021','EC','A','','','AC','0000830375','0000830375','TX00002248287','IL','1','VASQUEZ','TOMMIE','','','','34','456782774','6212 21ST ST',0,'LUBBOCK','TX','79407','1412','CY','48303','1949-09-22','F','U',':RET:2106-3','N','021','DEN','3083152','33348TX002000201','2014-03-01','2014-02-08 18:12:27','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61','CIC',0,'2014-02-09 19:00:04'),(23571,18779,'Y','18','021','EC','A','','','AC','0000381187','0000381187','OH00001374547','IL','1','Urbanski','Paul',NULL,NULL,NULL,NULL,NULL,'2344 Aberdeen',0,'Taleto','OH','43614',NULL,'CY','39095','1952-08-02','M','U',NULL,'N','021','HLT','3044660','92036OH003002605','2014-03-01','2014-02-13 11:38:16','430.00',NULL,NULL,'572.23','142.23','R-OH001','OH0','572.23',NULL,0,'2014-02-13 22:02:51'),(6928,5500,'Y','18','021','EC','A','','','AC','0001168005','0001168005','OH00001035684','IL','1','Ashby','Matthew','','','','34','289883711','7507 Miami rd',0,'Mentor','OH','44060',NULL,'CY','39085','1981-06-18','M','U',':RET:2106-3','N','021','DEN','2506723','99734OH005000401','2014-01-01','2013-12-24 19:33:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:26'),(9258,7342,'Y','18','021','EC','A','','','AC','0000429307','0000429307','TX00001050851','IL','1','BRUNO','SUSAN','L','','','34','455929344','140 WAYSIDE DR.',0,'AMARILLO','TX','79106',NULL,'CY','48375','1951-09-05','F','U',':RET:2106-3','N','021','DEN','1158121','33348TX002000201','2014-01-01','2013-11-30 16:43:58','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 04:15:13'),(14127,11260,'Y','18','021','EC','A','','','AC','0001779223','0001779223','LA00000818541','IL','1','Johnson','Derek','','','','34','436410309','13221 SUNSHINE RD',0,'BATON ROUGE','LA','70811','9711','CY','22033','1968-06-16','M','M',':RET:2054-5','N','021','DEN','1577626','18575LA002000201','2014-02-01','2013-12-25 22:18:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:02:17'),(2949,2374,'Y','18','021','EC','A','','','AC','0000111859','0000111859','OH00001180928','IL','1','Boone','Anthony','','','','34','269823308','1273 East 114',0,'Cleveland','OH','44108',NULL,'CY','39035','1983-12-29','M','U',':RET:2054-5','T','021','DEN','977201','99734OH005000401','2014-01-01','2013-12-06 16:18:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:16:28'),(6885,5461,'Y','18','021','EC','A','','','AC','0002051521','0002051521','LA00001211034','IL','1','POPE','EDWARD','R','','','34','477045043','931 WASHINGTON AVE',0,'NEW ORLEANS','LA','70130','5537','CY','22071','1978-04-10','M','U',NULL,'T','021','DEN','1596033','18575LA002000201','2014-01-01','2013-12-24 19:18:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:11'),(16724,13385,'Y','18','021','EC','A','','','AC','0001045702','0001045702','OH00001712476','IL','1','CLARK','LINDSEY','A','','','34','294564003','97 MARVIN AVE',0,'AKRON','OH','44302','1069','CY','39153','1953-03-09','M','U',':RET:2106-3','N','021','HLT','2615082','52664OH151001301','2014-02-01','2014-01-07 10:07:30','233.00',NULL,NULL,'605.24','372.24','R-OH012','OH0','605.24',NULL,0,'2014-01-08 18:24:47'),(19408,15475,'Y','18','021','EC','A','','','AC','0000196164','0000196164','OH00001949094','IL','1','Gruich','Mark','','','','34','279501208','2449 GREENHAVEN DR',0,'AKRON','OH','44333','2753','CY','39153','1963-11-18','M','M',':RET:2106-3','N','021','HLT','3023737','52664OH152000901','2014-03-01','2014-01-21 11:13:54','462.00',NULL,NULL,'803.80','341.80','R-OH012','OH0','291.73',NULL,1,'2014-01-22 03:22:57'),(19935,15899,'Y','18','021','EC','A','','','AC','0000637139','0000637139','OH00001418143','IL','1','Lane','Larnetta','L','','','34','283564699','1606 CONE ST',0,'TOLEDO','OH','43606','4403','CY','39095','1957-09-15','F','U',':RET:2054-5','N','021','HLT','2627251','92036OH004002601','2014-03-01','2014-01-24 13:39:13','271.00',NULL,NULL,'365.79','94.79','R-OH001','OH0','365.79',NULL,0,'2014-01-24 21:01:11'),(20681,16525,'N','19','021','EC','A',NULL,NULL,'','0000167726','0000774471','','IL','1','Hassan','Zahraa','','','','34','639963434','643 LEAFY RDG',0,'SAN ANTONIO','TX','78251','4251','CY','48029','2005-06-04','F','',NULL,'N','021','DEN','3626848','33348TX002000101','2014-03-01','2014-01-29 19:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-01-30 21:00:54'),(26176,20757,'Y','18','021','EC','A','','','AC','0000228387','0000228387','OH00002871120','IL','1','BAILEY','CAROL','JANE','','','34','295548982','43 BEAM CIR',0,'FRANKLIN','OH','45005',NULL,'CY','39165','1957-04-12','F','U',NULL,'N','021','DEN','2636680','99734OH005000301','2014-03-01','2014-02-26 18:37:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:38'),(26226,20800,'Y','18','021','EC','A','','','AC','0000944549','0000944549','TX00003130617','IL','1','Torres','Elizabeth','','','','34','181984934','2089 Foster Lane',0,'Gerrell','TX','76537',NULL,'CY','48491','1986-02-24','F','U',NULL,'N','021','DEN','3350436','33348TX002000201','2014-03-01','2014-02-26 21:16:18','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-28 06:30:59'),(775,640,'N','01','021','EC','A',NULL,NULL,'','0000926384','0000120480','','IL','1','Maestas','Eva','','','','34','093783141','6060 ABILENE TRL',0,'AUSTIN','TX','78749','2823','CY','48453','1963-11-10','F','',':RET:2106-3','N','021','DEN','2294460','33348TX002000201','2014-01-01','2013-12-16 12:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:04:55'),(4968,3944,'Y','18','021','EC','A','','','AC','0000449280','0000449280','TX00001162085','31','1','Jernigan','Janice','','','','34','435430034','null null',0,'PANOLA','TX','75685','0282','CY','48365','1965-01-04','F','U',':RET:2106-3','N','021','DEN','245871','33348TX002000201','2014-01-01','2013-12-06 18:54:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:21'),(16175,12950,'Y','18','021','EC','A','','','AC','0001936891','0001936891','LA00002268247','IL','1','porter','eric','','','','34','435111078','3811 Windsong Drive',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1959-02-03','M','U',':RET:2054-5','N','021','DEN','1638900','18575LA002000201','2014-02-01','2014-01-04 16:13:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-05 00:00:21'),(4848,3840,'N','01','021','EC','A',NULL,NULL,'','0000499277','0000815304','','IL','1','Combs','Dave','','','','34','405028647','222worth st',0,'Cincinnati','OH','45226',NULL,'CY','39061','1964-06-07','M','',':RET:2106-3','N','021','DEN','163603','99734OH005000401','2014-01-01','2013-11-08 10:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:30:17'),(13755,10979,'Y','18','021','EC','A','','','AC','0000392500','0000392500','MS00000821886','IL','1','Patel','Harish',NULL,NULL,NULL,NULL,NULL,'115 SUNNY DR',0,'CANTON','MS','39046','5129','CY','28089','1954-10-20','M','M',NULL,'T','021','DEN','2173042','46300MS002000201','2014-01-01','2013-12-22 22:36:51','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:03'),(13741,10968,'Y','18','021','EC','A','','','AC','0000096400','0000096400','OH00001377494','IL','1','Crabtree','Karen','','','','34','301463542','1974 BAKER AVE',0,'AKRON','OH','44312','2110','CY','39153','1949-06-23','F','M',':RET:2106-3','N','021','HLT','1851113','52664OH151001305','2014-01-01','2013-12-23 19:04:12','454.00',NULL,NULL,'669.00','215.00','R-OH012','OH0','669.00',NULL,0,'2013-12-26 13:09:41'),(13125,10467,'Y','18','021','EC','A','','','AC','0000541640','0000541640','OH00000441744','IL','1','Frank','Jon','','','','34','291825698','4953 marcy rd',0,'west carrollton','OH','45449',NULL,'CY','39113','1969-04-09','M','U',':RET:2106-3','N','021','DEN','1716331','99734OH005000401','2014-01-01','2013-12-23 14:17:26','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:52:51'),(17877,14279,'N','19','021','EC','A',NULL,NULL,'','0001126890','0000016637','','IL','1','Vollmer','Virginia','','','','34','683208080','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','2009-08-12','F','',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(18454,14721,'Y','18','021','EC','A','','','AC','0002176331','0002176331','LA00002082999','IL','1','Gaille','Marlane','','','','34','438748436','2165 W RIDGE DR',0,'MANDEVILLE','LA','70448','1046','CY','22103','1959-09-07','F','U',':RET:2106-3','N','021','DEN','1839969','18575LA002000101','2014-02-01','2014-01-14 21:44:53','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-16 08:46:09'),(19370,15441,'Y','18','024','14','A','','','TE','0001108066','0001108066','','IL','1','Csepegi','Elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-05-24','F','',NULL,NULL,NULL,'','1099446','','2014-01-21','2014-01-21 17:24:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:36'),(19397,15464,'Y','18','024','14','A','','','TE','0001076537','0001076537','','IL','1','walker','elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-07-05','F','',NULL,NULL,NULL,'','988495','','2014-01-21','2014-01-21 14:18:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:51'),(22357,17855,'N','19','021','EC','A',NULL,NULL,'','0000948462','0000680889','','S1','1','TUZZEO','LISA','Ginley','','','34','601776636','115 HIGHLAND MIST CIR',0,'HINCKLEY','OH','44233','9354','CY','39103','1998-03-12','F','',':RET:2106-3','N','021','DEN','3504412','99734OH005000401','2014-03-01','2014-02-10 10:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-10 21:00:06'),(22786,18192,'Y','18','021','EC','A','','','AC','0000848395','0000848395','OH00001523368','IL','1','SAMPLE','ROBIN','','','','34','505027007','1908 FRAIL RD',0,'LIMA','OH','45806','1741','CY','39003','1966-06-24','F','R',':RET:2106-3','N','021','DEN','2859902','99734OH005000301','2014-03-01','2014-02-11 10:38:24','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-11 21:01:47'),(23599,18799,'Y','18','021','EC','A','','','AC','0000821058','0000821058','OH00001545249','IL','1','Copeland','Deborah','','','','34','292543913','414 N LAKE PINE DR',0,'LAKESIDE MARBLEHEAD','OH','43440','1268','CY','39123','1952-04-24','F','U',NULL,'T','021','HLT','2639068','92036OH006002701','2014-03-01','2014-02-13 12:47:25','460.00',NULL,NULL,'499.74','39.74','R-OH006','OH0','499.74',NULL,0,'2014-02-13 22:03:07'),(24274,19277,'Y','18','024','14','A','','','TE','0001045659','0001045659','','IL','1','Taulbee','Katie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-11-26','F','',NULL,NULL,NULL,'','781883','','2014-02-28','2014-02-17 20:56:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:03'),(26221,20796,'Y','18','021','EC','A','','','AC','0000381759','0000381759','TX00002947820','IL','1','HENRY','JOYCENYN','','','','34','638152263','925 NORTHWOOD DRIVE',0,'BAYTOWN','TX','77521',NULL,'CY','48201','1967-07-24','F','U',':RET:2054-5','N','021','DEN','2988135','33348TX002000201','2014-04-01','2014-02-26 19:12:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 06:30:57'),(27235,21566,'Y','18','021','EC','A','','','AC','0001081116','0001081116','MS00002531974','IL','1','newman','cody','','','','34','587619314','7024 hwy 18',0,'utica','MS','39175',NULL,'CY','28029','1982-04-13','M','U',':RET:2106-3','T','021','DEN','3773027','46300MS002000101','2014-04-01','2014-03-03 13:38:31','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-03 21:31:44'),(5766,4580,'N','01','021','EC','A',NULL,NULL,'','0000217595','0001241863','','IL','1','Lyttle','Reva','Sabrina','','','34','285549251','4607 KENTFIELD DR',0,'TROTWOOD','OH','45426','1853','CY','39113','1956-04-15','F','',':RET:2054-5','N','021','DEN','2226872','99734OH005000401','2014-01-01','2013-12-23 22:13:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:46:39'),(8857,7022,'Y','18','021','EC','A','','','AC','0001087223','0001087223','TX00001301230','IL','1','Howlett','Edison','','','','34','463786625','729 Broadway Commons',0,'Garland','TX','75043',NULL,'CY','48113','1949-04-06','M','M',':RET:2054-5','N','021','DEN','1379106','33348TX002000201','2014-01-01','2013-12-18 10:43:08','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:01:11'),(5564,4418,'Y','18','021','EC','A','','','AC','0001050608','0001050608','OH00000236122','IL','1','Coakley','Donald','kenneth','','','34','290865975','1044 MCCOY CT',0,'PATASKALA','OH','43062','7098','CY','39089','1974-07-02','M','M',':RET:2106-3','N','021','DEN','276530','99734OH005000301','2014-01-01','2013-11-05 19:28:47','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:16:34'),(8032,6359,'Y','18','021','EC','A','','','AC','0000505799','0000505799','MS00001267797','IL','1','Portis','Lorraine','','','','34','425231798','P.O. Box 472',0,'Tchula','MS','39169',NULL,'CY','28051','1967-05-28','F','U',':RET:2054-5','N','021','DEN','1920881','46300MS002000101','2014-01-01','2013-12-20 15:11:35','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 03:09:10'),(3661,2928,'N','01','021','EC','A',NULL,NULL,'','0000755982','0000451251','','IL','1','WEBER','LORI','A','','','34','285486135','532 COVEDALE AVE',0,'CINCINNATI','OH','45238',NULL,'CY','39061','1957-09-03','F','',':RET:2106-3','N','021','DEN','1181594','99734OH005000401','2014-01-01','2013-12-12 20:16:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:53'),(7947,6287,'Y','18','021','EC','A','','','AC','0001512611','0001512611','LA00000284062','IL','1','Martin','Vallery','','','','34','439275155','3977 N 38TH ST',0,'BATON ROUGE','LA','70805','5004','CY','22033','1968-02-05','F','U',':RET:2054-5','N','021','DEN','2016173','18575LA002000201','2014-01-01','2013-12-20 17:14:24','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:07:03'),(17214,13775,'Y','18','024','14','A','','','TE','0001148736','0001148736','','IL','1','Lee','Ronald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-12-20','M','',NULL,NULL,NULL,'','1399432','','2014-01-08','2014-01-08 16:54:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:22:30'),(17260,13809,'N','01','021','EC','A',NULL,NULL,'','0000736537','0000089848','','IL','1','SEELEY','CYNTHIA','','','','34','302727273','26470 WILDCAT HOLLOW RD',0,'ROCKBRIDGE','OH','43149','9770','CY','39073','1961-10-02','F','',':RET:2106-3','N','021','DEN','2518658','99734OH005000301','2014-02-01','2014-01-10 12:37:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:16'),(18043,14414,'Y','18','021','EC','A','','','AC','0000417171','0000417171','MS00002344045','IL','1','BURTON','ALFRETTA','','','','34','587415774','5169 PINE AVE',0,'PEARLINGTON','MS','39572','7723','CY','28045','1977-11-08','F','U',NULL,'N','021','DEN','1495777','46300MS002000101','2014-02-01','2014-01-13 19:59:16','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-15 02:07:13'),(21378,17086,'Y','18','021','EC','A','','','AC','0000364923','0000364923','OH00001810053','IL','1','Elliott','Robin','','','','34','298546432','10270 Danvers Drive',0,'Concord','OH','44077',NULL,'CY','39085','1954-02-13','F','M',':RET:2106-3','N','021','DEN','2683285','99734OH005000401','2014-03-01','2014-02-03 21:07:07','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-04 21:00:51'),(24184,19212,'Y','18','021','EC','A','','','AC','0000793512','0000793512','OH00002528826','IL','1','Cole','Michelle','','','','34','268861360','112 CHESTNUT ST',0,'SWANTON','OH','43558','1302','CY','39051','1984-11-25','F','M',':RET:2106-3','N','021','HLT','3692060','92036OH005002605','2014-03-01','2014-02-15 18:18:12','67.00',NULL,NULL,'218.20','151.20','R-OH001','OH0','218.20',NULL,0,'2014-02-16 19:00:09'),(24877,19725,'Y','18','021','EC','A','','','AC','0001240606','0001240606','OH00002478817','IL','1','Lovett','James','','','','34','268586885','9638 HELMSLEY WAY',0,'CINCINNATI','OH','45231','2430','CY','39061','1960-04-07','M','U',':RET:2054-5','N','021','HLT','3294165','92036OH003001205','2014-03-01','2014-02-19 13:10:21','296.00',NULL,NULL,'457.33','161.33','R-OH004','OH0','457.33','CIC',0,'2014-02-20 05:35:00'),(25133,19936,'Y','18','021','EC','A','','','AC','0001050184','0001050184','TX00003085107','IL','1','LARA','SUSIE','','','','34','463023727','1315 ADAMS AVE',0,'ODESSA','TX','79761','2708','CY','48135','1954-10-02','F','M',NULL,'N','021','DEN','3077691','33348TX002000201','2014-04-01','2014-02-20 21:54:18','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-02-21 22:00:04'),(25373,20131,'Y','18','021','EC','A','','','AC','0000117847','0000117847','OH00003286239','IL','1','WHITE','VINCENT','','','Sr','34','283704661','3563 AMBERACRES DR',0,'CINCINNATI','OH','45237','2522','CY','39061','1966-03-31','M','M',':RET:2054-5','N','021','DEN','2659068','99734OH005000301','2014-04-01','2014-02-25 14:51:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:42'),(25852,20494,'Y','18','021','EC','A','','','AC','0001200867','0001200867','LA00003048788','IL','1','hawkins','chad','','','','34','438515342','1536 WAKEFIELD DR',0,'MARRERO','LA','70072','4415','CY','22051','1974-08-24','M','U',':RET:2054-5','N','021','DEN','3343498','18575LA002000201','2014-03-01','2014-02-26 08:34:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:41'),(26064,20669,'N','19','021','EC','A',NULL,NULL,'','0000182350','0000188905','','IL','1','alsept','leah','mckenzie','','','34','269065013','1548 WONDERLICK RD',0,'LIMA','OH','45805','3936','CY','39003','2000-09-13','F','',':RET:2054-5^:RET:2106-3','N','021','HLT','3273127','92036OH002001501','2014-03-01','2014-02-26 12:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2014-02-26 21:02:41'),(27846,22026,'Y','18','021','EC','A','','','AC','0000315634','0000315634','TX00002961650','31','1','PEREZ','MARIBEL','','','','34','453839186','PO BOX',0,'LA BLANCA','TX','78558',NULL,'CY','48215','1966-08-13','F','M',NULL,'N','021','DEN','3498898','33348TX002000101','2014-04-01','2014-03-05 13:28:53','0.00',NULL,NULL,'50.04','50.04','R-TX015','TX0','25.02',NULL,0,'2014-03-05 21:32:10'),(6759,5363,'N','19','021','EC','A',NULL,NULL,'','0001113109','0000987356','','IL','1','Forrer','Hadley','Joy','','','34','890628188','152 WALDORF DR',0,'AKRON','OH','44313','6228','CY','39153','2012-04-19','F','',':RET:2106-3','N','021','HLT','712871','52664OH152000901','2014-01-01','2013-11-25 08:05:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 01:16:18'),(16091,12887,'Y','18','021','EC','A','','','AC','0000966570','0000966570','MS00001362057','IL','1','GOFF','PATRICIA','','','','34','264844057','1215 36TH ST UNIT B',0,'GULFPORT','MS','39501',NULL,'CY','28047','1955-10-23','F','U',':RET:2106-3','N','021','DEN','2237229','46300MS002000201','2014-02-01','2014-01-03 11:17:49','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-04 02:04:25'),(14953,11951,'Y','18','021','EC','A','','','AC','0000821797','0000821797','TX00001918881','IL','1','Tardif','Emma','','','','34','415693624','305 THELMA DR',0,'AUSTIN','TX','78745','5647','CY','48453','1988-02-08','F','U',':RET:2106-3','N','021','DEN','2170667','33348TX002000201','2014-02-01','2013-12-29 23:15:23','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-01 12:00:15'),(15306,12239,'Y','18','021','EC','A','','','AC','0001962357','0001962357','LA00000096082','IL','1','Leonard','Brandon','','','','34','433757637','1457 NATALIE ST',0,'SHREVEPORT','LA','71108','3530','CY','22017','1985-08-15','M','M',':RET:2054-5','N','021','DEN','2289536','18575LA002000201','2014-02-01','2014-01-01 15:31:52','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,1,'2014-01-02 04:23:01'),(6988,5545,'Y','18','021','EC','A','','','AC','0001225718','0001225718','OH00001435863','31','1','Wehlitz','Paul','','','','34','226338509','P.o. Box 8182',0,'West Chester','OH','45069',NULL,'CY','39017','1977-01-14','M','U',':RET:2106-3','N','021','DEN','2436097','99734OH005000401','2014-02-01','2013-12-25 11:29:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:54'),(7730,6122,'Y','18','021','EC','A','','','AC','0000249117','0000249117','OH00000992532','IL','1','Bochnek','Ross','','','','34','128607445','27800 BELCOURT RD',0,'PEPPER PIKE','OH','44124','5612','CY','39035','1977-03-10','M','U',':RET:2106-3','N','021','DEN','2135965','99734OH005000401','2014-01-01','2013-12-20 14:46:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:01:58'),(16390,13115,'Y','18','021','EC','A','','','AC','0001208412','0001208412','TX00001782841','IL','1','BARRERA','MARIA','ROSARIO','','','34','553867089','4818 PRESCOTT ST',0,'CORPUS CRISTI','TX','78416',NULL,'CY','48355','1952-07-03','F','U',NULL,'N','021','DEN','1528377','33348TX002000201','2014-02-01','2014-01-06 10:18:46','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-07 04:03:32'),(18424,14699,'Y','18','021','EC','A','','','AC','0001208246','0001208246','LA00001679043','IL','1','Hemingway','Meghan',NULL,NULL,NULL,NULL,NULL,'5623 Milne Boulevard',0,'New Orleans','LA','70124',NULL,'CY','22071','1984-10-29','F','M',NULL,'N','021','DEN','2489815','18575LA002000201','2014-02-01','2014-01-15 00:53:26','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:54'),(19591,15617,'Y','18','021','EC','A','','','AC','0001051214','0001051214','MS00001752395','IL','1','HARRIS','EARNESTINE','','','','34','587206954','52 CAVERS RD',0,'BUCKATUNNA','MS','39322','9661','CY','28153','1950-07-25','F','U',':RET:2054-5','N','021','DEN','2894254','46300MS002000201','2014-03-01','2014-01-22 11:14:28','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-23 03:02:44'),(21480,17163,'Y','18','021','EC','A','','','AC','0000478517','0000478517','OH00002337708','IL','1','Grindler','Adam','','','','34','255659098','5859 KINGS HWY',0,'PARMA HEIGHTS','OH','44130','1748','CY','39035','1986-06-13','M','U',NULL,'N','021','DEN','2835207','99734OH005000301','2014-03-01','2014-02-04 14:01:41','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-04 21:01:42'),(22467,17939,'Y','18','021','EC','A','','','AC','0000217641','0000217641','OH00002080870','IL','1','owens','paul','','','','34','273645804','8309 STAHLEY DR',0,'CINCINNATI','OH','45239','3918','CY','39061','1957-09-20','M','U',NULL,'N','021','HLT','2623673','92036OH006001201','2014-03-01','2014-02-10 12:32:06','0.00',NULL,NULL,'397.18','397.18','R-OH004','OH0','397.18',NULL,0,'2014-02-10 21:30:55'),(26366,20914,'Y','18','024','14','A','','','TE','0000191379','0000191379','','IL','1','CLARK','BRITTANY','JO',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-03-14','F','',NULL,NULL,NULL,'','2362571','','2014-02-28','2014-02-26 14:47:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:09'),(27440,21717,'Y','18','021','EC','A','','','AC','0002154923','0002154923','LA00002770423','IL','1','Parks','Jodi','Allen','','','34','311682387','18183 MONGA DR',0,'COVINGTON','LA','70433','0328','CY','22103','1970-12-18','F','U',':RET:2106-3','N','021','DEN','3837215','18575LA002000201','2014-04-01','2014-03-04 15:23:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:52'),(28399,22469,'Y','18','021','EC','A','','','AC','0000133378','0000133378','OH00003398398','IL','1','Archie','Karen','','','','34','300580002','4317 GERMANTOWN PIKE',0,'DAYTON','OH','45417','6157','CY','39113','1956-06-03','F','U',':RET:2054-5','N','021','DEN','3041099','99734OH005000401','2014-04-01','2014-03-06 21:03:24','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-07 21:30:49'),(136,117,'N','19','021','EC','A',NULL,NULL,'','0000103864','0000963203','','IL','1','Wiandt','Jake','B','','','34','273023618','7927 OVERTON RD',0,'BURBANK','OH','44214','9516','CY','39169','1996-10-30','M','',':RET:2106-3','N','021','HLT','6429','52664OH152000901','2014-01-01','2013-12-04 20:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 17:18:36'),(15532,12427,'Y','18','021','EC','A','','','AC','0002187198','0002187198','LA00001223687','IL','1','STEWART','MONICA','','','','34','439494946','1271 N FOSTER DR',0,'BATON ROUGE','LA','70806','1814','CY','22033','1970-10-23','F','U',':RET:2054-5','N','021','DEN','2303506','18575LA002000201','2014-02-01','2013-12-31 13:27:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:39'),(6610,5241,'Y','18','021','EC','A','','','AC','0001182484','0001182484','OH00000143383','IL','1','McGuire','Cory','','','','34','463953250','107 Brookside Drive',0,'Anna','OH','45302',NULL,'CY','39149','1987-04-28','M','M',':RET:2106-3','N','021','HLT','260347','92036OH003000506','2014-01-01','2013-12-11 15:07:11','441.00',NULL,NULL,'508.38','67.38','R-OH003','OH0','254.19',NULL,0,'2013-12-26 00:53:43'),(7468,5910,'Y','18','021','EC','A','','','AC','0000792208','0000792208','OH00000407948','IL','1','Roper','Tramango','','','','34','269725504','301 E GLENWOOD AVE',0,'AKRON','OH','44310','3805','CY','39153','1973-05-02','M','U',':RET:2054-5','N','021','DEN','1089456','99734OH005000401','2014-01-01','2013-12-14 19:52:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:31:07'),(4342,3449,'Y','18','021','EC','A','','','AC','0000268872','0000268872','OH00000680889','IL','1','Caprilla','Frank','','','','34','274807371','5350 W BREESE RD',0,'LIMA','OH','45806','9458','CY','39003','1979-07-12','M','M',':RET:2106-3','N','021','HLT','2429394','92036OH006001501','2014-01-01','2013-12-17 11:36:15','293.00',NULL,NULL,'420.98','127.98','R-OH002','OH0','211.89',NULL,0,'2013-12-25 21:53:18'),(6026,4770,'Y','18','021','EC','A','','','AC','0001062244','0001062244','TX00000635059','31','1','Wilson','Leslie','','','','34','463957113','1722 RON CERRUDO ST',0,'EL PASO','TX','79936','4802','CY','48141','1981-09-02','F','U',':RET:2106-3','N','021','DEN','533382','33348TX002000201','2014-01-01','2013-12-01 16:29:46','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 00:01:01'),(3116,2504,'Y','18','021','EC','A','','','AC','0000660186','0000660186','TX00000774976','IL','1','Waldron','Patrick','J','','','34','488664526','1538 DALY DR',0,'CORPUS CHRISTI','TX','78412','4714','CY','48355','1956-11-02','M','U',NULL,'N','021','DEN','621702','33348TX002000201','2014-01-01','2013-10-12 22:51:03','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-25 20:30:10'),(2762,2233,'N','19','021','EC','A',NULL,NULL,'','0000259197','0001039723','','IL','1','Griggs','Kaitlin','Marie','','','34','280134422','1667 JUNIATA RD',0,'AKRON','OH','44305','1444','CY','39153','2007-05-18','F','',':RET:2054-5^:RET:2106-3','N','021','HLT','371453','52664OH151001304','2014-01-01','2013-12-02 17:51:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 19:49:20'),(16075,12873,'N','01','021','EC','A',NULL,NULL,'','0001078905','0000688298','','IL','1','Bender','Lynda','M','','','34','262915976','117 Shay Street',0,'Deleware','OH','43015',NULL,'CY','39041','1963-08-21','F','',NULL,'N','021','DEN','2547671','99734OH005000401','2014-02-01','2014-01-03 12:58:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:03:55'),(17195,13759,'Y','18','021','EC','A','','','AC','0001252213','0001252213','LA00002298457','IL','1','Clark','Anne','','','','34','601649708','2108 TEZCUCO LN',0,'MARRERO','LA','70072','5478','CY','22051','1987-03-17','F','U',':RET:2106-3','N','021','DEN','1543941','18575LA002000101','2014-02-01','2014-01-07 22:47:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-13 02:22:21'),(18859,15021,'Y','18','021','EC','A','','','AC','0001560133','0001560133','LA00001968905','IL','1','Jackson','Cedric','','','','34','437599478','7473 OAKLEAF DR',0,'BATON ROUGE','LA','70812','3728','CY','22033','1985-05-13','M','U',NULL,'N','021','DEN','1803989','18575LA002000201','2014-02-01','2014-01-15 22:48:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:19'),(19436,15494,'Y','18','024','14','A','','','TE','0000740257','0000740257','','IL','1','Chahal','Bhalinder','Singh',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-28','M','',NULL,NULL,NULL,'','275614','','2014-01-21','2014-01-21 15:03:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:23:11'),(22447,17923,'N','19','021','EC','A',NULL,NULL,'','0000925348','0000122990','','S1','1','Townsend','Benjamin','Curtis','','Jr','34','634199961','11433 TURNING LEAF TRL',0,'FORT WORTH','TX','76244','4889','CY','48439','2009-02-08','F','',':RET:2106-3','N','021','DEN','2928737','33348TX002000201','2014-03-01','2014-02-10 14:28:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-10 21:30:45'),(23837,18966,'Y','18','021','EC','A','','','AC','0001020464','0001020464','OH00002321930','IL','1','BRIDGEFORD','MARY','','','','34','273666885','203 CENTERBURY CT',0,'SPRINGDALE','OH','45246','4904','CY','39061','1960-05-18','F','U',':RET:2106-3','N','021','HLT','2731979','92036OH003001205','2014-03-01','2014-02-14 08:41:12','296.00',NULL,NULL,'457.33','161.33','R-OH004','OH0','457.33',NULL,0,'2014-02-14 21:31:49'),(26630,21115,'Y','18','021','EC','A','','','AC','0000729022','0000729022','TX00003183706','IL','1','ezebuike','virginia','','','','34','629190488','3931 TEAL WAY CT',0,'FRESNO','TX','77545','8642','CY','48157','1960-06-24','F','U',':RET:2054-5','N','021','DEN','2801732','33348TX002000201','2014-04-01','2014-02-28 14:38:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 21:30:57'),(289,238,'N','01','021','EC','A',NULL,NULL,'','0000622444','0000207743','','IL','1','Roselle','Jennifer','','','','34','632165915','1026 HARMONY DR',0,'ABILENE','TX','79603','3014','CY','48441','1990-06-13','F','',NULL,'T','021','DEN','217365','33348TX002000101','2014-01-01','2013-10-12 14:50:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 17:30:29'),(371,308,'Y','18','021','EC','A','','','AC','0000150335','0000150335','TX00001261978','IL','1','Bowden','Mark','','','','34','465539830','215 COMMUNITY DR',0,'CARTHAGE','TX','75633','1552','CY','48365','1972-11-01','M','U',':RET:2106-3','N','021','DEN','166354','33348TX002000201','2014-01-01','2013-12-04 15:36:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:45:26'),(853,707,'Y','18','021','EC','A','','','AC','0000314682','0000314682','OH00000086644','IL','1','MIRON','WILLIAM','R','','','34','293689777','518 OHIO ST',0,'LIMA','OH','45804','1148','CY','39003','1964-07-14','M','U',':RET:2106-3','N','021','HLT','609619','92036OH005001505','2014-01-01','2013-12-15 23:51:33','323.00',NULL,NULL,'375.47','52.47','R-OH002','OH0','375.47',NULL,0,'2013-12-25 18:06:57'),(3286,2649,'Y','18','024','14','A','','','TE','0000614088','0000614088','','IL','1','Shamy','Rachel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-10-04','F','',NULL,NULL,NULL,'','1998433','','2013-12-21','2013-12-21 23:32:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:15:23'),(1814,1489,'N','01','021','EC','A',NULL,NULL,'','0001166821','0000507993','','IL','1','Niklas','Natasha','','','','34','276869080','80 E CASE DR',0,'HUDSON','OH','44236','2744','CY','39153','1971-03-24','F','',':RET:2106-3','N','021','HLT','2153126','52664OH151001501','2014-01-01','2013-12-24 14:40:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','354.39',NULL,0,'2013-12-25 18:57:03'),(20879,16687,'Y','18','021','EC','A','','','AC','0000717861','0000717861','OH00001577134','IL','1','WILCOX','JAMES','','','','34','285427015','707.5 MORSE ST',0,'FINDLAY','OH','45840','6049','CY','39063','1960-10-08','M','U',':RET:2106-3','N','021','HLT','3087251','92036OH003001504','2014-03-01','2014-01-30 20:59:28','342.00',NULL,NULL,'468.87','126.87','R-OH002','OH0','468.87',NULL,0,'2014-01-31 21:01:07'),(21155,16904,'Y','18','024','14','A','','','TE','0000494476','0000494476','','IL','1','Friedman','Keith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-12-20','M','',NULL,NULL,NULL,'','2785073','','2014-02-02','2014-02-02 22:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:00:29'),(22080,17623,'N','01','021','EC','A',NULL,NULL,'','0001555380','0001364948','','IL','1','Woldeyohanis','Bekelech','W','','','34','660057259','4225 Hudson St',0,'Metairie','LA','70006',NULL,'CY','22051','1961-04-20','F','',':RET:2054-5','N','021','DEN','2883765','18575LA002000201','2014-03-01','2014-02-08 13:24:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-08 19:00:18'),(24276,19279,'Y','18','024','14','A','','','TE','0000794468','0000794468','','IL','1','Kelby','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-05-04','F','',NULL,NULL,NULL,'','656286','','2014-03-31','2014-02-18 09:27:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-18 21:30:04'),(25062,19875,'Y','18','021','EC','A','','','AC','0000872098','0000872098','OH00002944961','31','1','Haas','Thomas','','','','34','301527393','P.O. Box 563',0,'Ironton','OH','45638',NULL,'CY','39087','1955-09-30','M','U',':RET:2106-3','N','021','DEN','3030587','99734OH005000401','2014-04-01','2014-02-20 14:02:07','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-02-20 22:01:24'),(25517,20243,'Y','18','021','EC','A','','','AC','0000261553','0000261553','OH00002152049','IL','1','Dircksen','Joseph','','','','34','283504338','5260 EDGEWOOD ST',0,'CELINA','OH','45822','8842','CY','39107','1951-04-22','M','M',':RET:2106-3','N','021','HLT','2718481','92036OH004001501','2014-04-01','2014-02-25 13:21:41','447.00',NULL,NULL,'508.42','61.42','R-OH002','OH0','508.42',NULL,0,'2014-02-25 21:32:04'),(25565,20280,'Y','18','021','EC','A','','','AC','0000292022','0000292022','OH00003017486','IL','1','Dingee','Roger','A','','Jr','34','048646324','2498 TOWNSHIP ROAD 687',0,'LOUDONVILLE','OH','44842','9571','CY','39005','1971-01-12','M','U',':RET:2106-3','N','021','HLT','3288263','52664OH151001306','2014-04-01','2014-02-23 11:58:01','126.00',NULL,NULL,'302.62','176.62','R-OH012','OH0','302.62',NULL,0,'2014-02-26 08:00:25'),(27552,21794,'Y','18','021','EC','A','','','AC','0000605503','0000605503','TX00003389789','IL','1','RAMIREZ','NORA','G','','','34','467961152','701 LA PALMA ST',0,'SAN BENITO','TX','78586','4209','CY','48061','1954-08-04','F','M',NULL,'N','021','DEN','2751301','33348TX002000201','2014-04-01','2014-03-04 12:57:09','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61','CIC',0,'2014-03-04 21:30:12'),(28190,22307,'Y','18','021','EC','A','','','AC','0000575588','0000575588','MS00003668574','31','1','Ollie','Folger','','','','34','426027952','PO BOX 333',0,'MOOREHEAD','MS','38761',NULL,'CY','28133','1957-03-03','M','U',':RET:2054-5','N','021','DEN','3428345','46300MS002000201','2014-04-01','2014-03-05 18:19:25','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85','CIC',0,'2014-03-06 21:30:03'),(6573,5211,'N','01','021','EC','A',NULL,NULL,'','0000182539','0000119708','','IL','1','Cope','Claudia','','','','34','131464306','5601 BERKLEY DR',0,'NEW ORLEANS','LA','70131','5402','CY','22071','1959-01-06','F','',':RET:2106-3','N','021','DEN','446929','18575LA002000101','2014-01-01','2013-12-11 10:59:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 00:52:44'),(15810,12656,'Y','18','021','EC','A','','','AC','0001576143','0001576143','LA00000295575','IL','1','Van','Phuong','','','','34','374191965','11331 PARKWOOD CT N',0,'NEW ORLEANS','LA','70128','2913','CY','22071','1976-11-22','F','M',NULL,'N','021','DEN','2453384','18575LA002000201','2014-02-01','2014-01-02 17:33:17','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:03:10'),(15050,12030,'Y','18','021','EC','A','','','AC','0001409920','0001409920','LA00001368107','IL','1','BURNS','PATRICIA','','','','34','437413239','1105 SHERRON AVE',0,'BAKER','LA','70714','3956','CY','22033','1963-11-26','F','M',NULL,'N','021','DEN','1914724','18575LA002000201','2014-02-01','2013-12-30 14:07:46','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:14'),(13047,10401,'Y','18','021','EC','A','','','AC','0001080328','0001080328','OH00000788699','IL','1','reves','riley','m','','','34','279020983','5021 FRANCISCO PL',0,'COLUMBUS','OH','43220','2516','CY','39049','1997-04-29','M','R',':RET:2106-3','N','021','DEN','2337211','99734OH005000401','2014-01-01','2013-12-23 08:35:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-26 12:50:46'),(7797,6175,'Y','18','024','14','A','','','TE','0000286960','0000286960','','IL','1','esquivel','alma',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-01-18','F','',NULL,NULL,NULL,'','2018326','','2013-12-20','2013-12-20 15:53:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:34'),(7407,5862,'Y','18','021','EC','A','','','AC','0000804271','0000804271','TX00000855067','IL','1','Cadena','Suzanne','Elyssia','','','34','626260408','250 E Mayfield Blvd',0,'San Antonio','TX','78214',NULL,'CY','48029','1988-08-17','F','M',':RET:2148-5','N','021','DEN','144126','33348TX002000201','2014-01-01','2013-10-28 15:04:24','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-26 02:16:37'),(6220,4930,'Y','18','021','EC','A','','','AC','0000451236','0000451236','OH00000701717','IL','1','Rodriguez','Crystal','','','','34','455775476','496 pontiac dr',0,'defiance','OH','43512',NULL,'CY','39039','1986-03-14','F','U',NULL,'T','021','HLT','280242','92036OH003002601','2014-01-01','2013-10-16 00:19:14','0.00',NULL,NULL,'245.41','245.41','R-OH001','OH0','245.41',NULL,0,'2013-12-26 00:31:07'),(2754,2228,'N','19','021','EC','A',NULL,NULL,'','0000249092','0000472240','','IL','1','GOOD','EVADNE','MARIE','','','34','293944930','910 E 15TH ST',0,'ASHTABULA','OH','44004','3624','CY','39007','1992-02-11','F','',':RET:2054-5','N','021','HLT','1247802','52664OH151001305','2014-01-01','2013-12-02 11:34:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2013-12-25 19:49:09'),(17276,13817,'N','19','021','EC','A',NULL,NULL,'','0000440830','0001128015','','IL','1','Immarino','Joseph','','','','34','292949850','2641 DOUG AVE',0,'HUDSON','OH','44236','3206','CY','39153','1992-01-21','M','',NULL,'N','021','HLT','1633910','52664OH152000901','2014-02-01','2014-01-10 10:13:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.34',NULL,0,'2014-01-13 02:23:23'),(22994,18332,'Y','18','021','EC','A','','','AC','0000834500','0000834500','OH00001672821','IL','1','Smith','David','Anthony','','','34','293920363','1049 LINDSEY LOOP',0,'LONDON','OH','43140','2166','CY','39097','1987-05-21','M','M',':RET:2106-3','N','021','DEN','3513810','99734OH005000301','2014-03-01','2014-02-12 10:08:43','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:30:15'),(23456,18685,'Y','18','021','EC','A','','','AC','0001049009','0001049009','TX00001904834','IL','1','CARRERAS','TERESA','','','','34','171549222','306 EDGEHILL BLVD',0,'RICHARDSON','TX','75081','2708','CY','48113','1960-11-20','F','U',NULL,'N','021','DEN','2947766','33348TX002000201','2014-03-01','2014-02-13 14:09:07','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:40'),(29101,23034,'Y','18','021','EC','A','','','AC','0001244227','0001244227','OH00003361376','IL','1','Crego','Mathew','','','','34','298564762','2307 STATE ROUTE 28',0,'GOSHEN','OH','45122','9550','CY','39025','1967-07-11','M','U',':RET:2106-3','N','021','HLT','3952755','92036OH004000601','2014-04-01','2014-03-10 12:40:45','117.00',NULL,NULL,'258.91','141.91','R-OH005','OH0','258.91',NULL,0,'2014-03-10 21:02:16'),(1008,826,'Y','18','021','EC','A','','','AC','0000281966','0000281966','OH00000715990','IL','1','Meisner','Ronald','Eugene','','','34','293482552','423 CENTER ST',0,'FINDLAY','OH','45840','5747','CY','39063','1951-01-24','M','M',':RET:2080-0','N','021','HLT','554112','92036OH002001501','2014-01-01','2013-10-19 15:00:18','554.00',NULL,NULL,'1145.76','591.76','R-OH002','OH0','730.20',NULL,0,'2013-12-25 18:11:09'),(6365,5046,'N','01','021','EC','A',NULL,NULL,'','0000799866','0000470995','','IL','1','MOORE','ROBERTA','SUZEANN','','','34','280583263','5991 GRAHAM RD',0,'PIERPONT','OH','44082','9746','CY','39007','1954-03-01','F','',':RET:2106-3','N','021','DEN','300761','99734OH005000301','2014-01-01','2013-12-10 19:08:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:47:28'),(8994,7136,'Y','18','021','EC','A','','','AC','0000030530','0000030530','OH00001176083','IL','1','Pham','Diana','','','','34','278948846','65 N. Glen Oak Dr.',0,'Springboro','OH','45066',NULL,'CY','39165','1989-02-06','F','R',':RET:2047-9','N','021','DEN','2208108','99734OH005000401','2014-01-01','2013-12-18 17:57:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:39'),(4442,3530,'Y','18','021','EC','A','','','AC','0000726111','0000726111','OH00001291833','IL','1','Blake','Jason','','','','34','282825870','5585 Briarcliff Drive',0,'Garfield Heights','OH','44125',NULL,'CY','39035','1970-03-31','M','R',':RET:2106-3','N','021','DEN','463044','99734OH005000301','2014-01-01','2013-12-11 21:07:48','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:09'),(229,193,'Y','18','021','EC','A','','','AC','0000843309','0000843309','OH00000817605','IL','1','english','kevin','','','','34','293623312','6501 germantown rd',0,'middletown','OH','45042',NULL,'CY','39017','1966-08-16','M','U',':RET:2106-3','T','021','HLT','634307','92036OH006001201','2014-01-01','2013-12-04 20:39:13','186.00',NULL,NULL,'306.01','120.01','R-OH004','OH0','306.01',NULL,0,'2013-12-25 17:21:01'),(14300,11408,'Y','18','021','EC','A','','','AC','0000490477','0000490477','OH00000804548','IL','1','Strayer','Brian','','','','34','302728216','933 TAMARACK DR',0,'WILLARD','OH','44890','9443','CY','39077','1971-03-31','M','M',':RET:2106-3','N','021','HLT','1753884','92036OH005002705','2014-02-01','2013-12-26 17:17:41','273.00',NULL,NULL,'504.46','231.46','R-OH006','OH0','258.38',NULL,0,'2013-12-27 02:06:50'),(7159,5678,'N','01','021','EC','A',NULL,NULL,'','0000318414','0000590792','','IL','1','forster','samuel','','','','34','282660830','311 E CORNELIA ST',0,'HICKSVILLE','OH','43526','1213','CY','39039','1961-11-08','M','',':RET:2106-3','N','021','HLT','2182204','92036OH004002601','2014-01-01','2013-12-24 21:08:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','306.05',NULL,0,'2013-12-26 01:52:23'),(2570,2088,'Y','18','021','EC','A','','','AC','0000820979','0000820979','OH00000692270','IL','1','Kucharik','Nancy',NULL,NULL,NULL,NULL,NULL,'2727 SHORELAND AVE',0,'TOLEDO','OH','43611','1177','CY','39095','1953-09-16','F','U',':RET:2106-3','T','021','HLT','585251','92036OH002002601','2014-01-01','2013-12-09 17:03:54','293.00',NULL,NULL,'702.82','409.82','R-OH001','OH0','702.82',NULL,0,'2013-12-25 19:37:39'),(13470,10744,'Y','18','021','EC','A','','','AC','0001102089','0001102089','OH00001006075','IL','1','Farmer','Jacob','','','','34','281928682','822 TEAKWOOD CT',0,'LEBANON','OH','45036','8650','CY','39165','1985-08-27','M','M',':RET:2106-3','N','021','DEN','1583336','99734OH005000301','2014-01-01','2013-12-23 16:11:33','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:02:00'),(3106,2495,'N','01','021','EC','A',NULL,NULL,'','0000088529','0000106689','','IL','1','STEELE','RANEE','','','','34','509865054','192 N RIDGE ST',0,'MONROEVILLE','OH','44847',NULL,'CY','39077','1969-02-20','F','',':RET:2106-3','N','021','HLT','698184','92036OH003002706','2014-01-01','2013-12-06 13:05:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','284.48',NULL,0,'2013-12-25 20:20:24'),(7608,6020,'Y','18','021','EC','A','','','AC','0000491842','0000491842','OH00000918591','IL','1','Harold','Sheri','','','','34','282804532','51 HIGH GROVE BLVD',0,'AKRON','OH','44312','1701','CY','39153','1970-12-19','F','U',NULL,'T','021','HLT','833140','52664OH151001306','2014-01-01','2013-11-17 06:41:58','243.00',NULL,NULL,'348.01','105.01','R-OH012','OH0','348.01',NULL,0,'2013-12-26 02:45:34'),(16342,13081,'Y','18','021','EC','A','','','AC','0000134588','0000134588','OH00001441775','IL','1','Daugherty','Dexter','','','','34','401372022','5653 View Pointe Dr',0,'Cincinnati','OH','45213',NULL,'CY','39061','1988-11-21','M','U',':RET:2054-5','T','021','DEN','1845446','99734OH005000301','2014-02-01','2014-01-06 15:00:02','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:02:15'),(16408,13130,'Y','18','021','EC','A','','','AC','0000655500','0000655500','TX00000574116','IL','1','Ortega','Dora','','','','34','630841393','287 OLD TRAMM RD',0,'LIVINGSTON','TX','77351','7481','CY','48373','1956-04-19','F','M',NULL,'N','021','DEN','2461269','33348TX002000201','2014-02-01','2014-01-06 14:41:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-07 04:04:08'),(16502,13202,'Y','18','021','EC','A','','','AC','0000313256','0000313256','OH00000094748','IL','1','Mertens','Carol','','','','34','283643399','1129 E HIGH ST',0,'LIMA','OH','45804','2823','CY','39003','1958-03-09','F','U',NULL,'N','021','HLT','1647548','92036OH004001501','2014-02-01','2014-01-06 14:46:59','391.76',NULL,NULL,'394.64','2.88','R-OH002','OH0','394.64',NULL,0,'2014-01-07 04:06:53'),(17812,14228,'Y','18','021','EC','A','','','AC','0000024696','0000024696','TX00001471620','IL','1','MAGID','Karen','','','','34','364868495','1632 CHURCHWOOD CV',0,'AUSTIN','TX','78746',NULL,'CY','48453','1979-03-02','F','U',':RET:2106-3','N','021','DEN','2682861','33348TX002000101','2014-02-01','2014-01-14 14:48:58','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-15 02:05:53'),(25076,19886,'Y','18','021','EC','A','','','AC','0001022830','0001022830','OH00002748698','IL','1','JACKSON','REBECCA','','','','34','279505781','838 VERNON ODOM BLVD',0,'AKRON','OH','44307','1431','CY','39153','1954-06-02','F','U',':RET:2054-5','N','021','HLT','2800053','52664OH152000901','2014-04-01','2014-02-20 11:12:09','187.00',NULL,NULL,'425.18','238.18','R-OH012','OH0','425.18',NULL,0,'2014-02-20 22:01:34'),(26243,20814,'Y','18','021','EC','A','','','AC','0000503671','0000503671','TX00002787875','IL','1','RIVERA','ROBERTO','','','','34','782358708','3700 GARTH RD',0,'BAYTOWN','TX','77521',NULL,'CY','48201','1985-12-22','M','M',':RET:2106-3','N','021','DEN','3476350','33348TX002000201','2014-04-01','2014-02-27 12:00:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 06:31:05'),(27985,22142,'Y','18','021','EC','A','','','AC','0001541504','0001541504','LA00002686429','31','1','JONES','DWANDA','','','','34','435170692','PO BOX 424',0,'TRAUT','LA','71371',NULL,'CY','22059','1965-11-28','F','U',NULL,'N','021','DEN','3685022','18575LA002000201','2014-04-01','2014-03-06 16:18:28','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-03-06 21:01:00'),(28661,22679,'N','19','021','EC','A',NULL,NULL,'','0002318782','0001612843','','IL','1','LEJEUNE','CALLI','','','','34','660140733','517 N 1ST ST',0,'VILLE PLATTE','LA','70586','6965','CY','22039','2006-09-15','F','',NULL,'N','021','DEN','4008684','18575LA002000201','2014-04-01','2014-03-07 19:31:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-03-08 21:30:43'),(29090,23025,'Y','18','021','EC','A','','','AC','0000093778','0000093778','TX00003005085','IL','1','Jaimes','Nancy','','','','34','453193560','2434 JESUSITA',0,'SAN ANTONIO','TX','78237','4161','CY','48029','1966-10-13','F','U',':RET:2106-3','N','021','DEN','4360092','33348TX002000101','2014-04-01','2014-03-10 14:22:25','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-03-10 21:02:09'),(1691,1413,'Y','18','021','EC','A','','','AC','0000096402','0000096402','OH00000088176','IL','1','Lin','Canchu','','','','34','442110556','26693 Amberwood Dr.',0,'Perrysburg','OH','43551',NULL,'CY','39173','1963-12-02','M','M',':RET:2034-7','N','021','HLT','2565943','92036OH004002601','2014-01-01','2013-12-24 07:13:24','505.00',NULL,NULL,'679.55','174.55','R-OH001','OH0','280.03',NULL,0,'2013-12-25 18:54:28'),(4240,3377,'Y','18','021','EC','A','','','AC','0001264315','0001264315','TX00001221570','IL','1','Longoria','Ernestina','','','','34','452196919','522 N SAINT MARIE ST',0,'MISSION','TX','78572','5654','CY','48215','1956-02-15','F','M',':RET:2106-3','N','021','DEN','2203860','33348TX002000201','2014-01-01','2013-12-17 15:24:40','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:51:00'),(14688,11727,'Y','18','024','14','A','','','TE','0000808652','0000808652','','IL','1','Rammel','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-11-16','F','',NULL,NULL,NULL,'','2497729','','2013-12-28','2013-12-28 12:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:08:44'),(7006,5560,'N','01','021','EC','A',NULL,NULL,'','0000389421','0000946818','','IL','1','Jarero','Sharon','Ruth','','','34','453711137','2605 Fulton Dr',0,'Corpus Christi','TX','78414',NULL,'CY','48355','1971-11-07','F','',':RET:2106-3','N','021','DEN','1821617','33348TX002000201','2014-01-01','2013-12-24 19:23:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:48:23'),(13784,11001,'Y','18','021','EC','A','','','AC','0000448255','0000448255','MS00000787727','IL','1','Crossey','Lashona','','','','34','427414123','207 e 7th ave',0,'petal','MS','39465',NULL,'CY','28035','1976-03-23','F','U',NULL,'N','021','DEN','2053057','46300MS002000201','2014-01-01','2013-12-23 16:44:55','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 13:10:50'),(20743,16573,'Y','18','021','EC','A','','','AC','0000383394','0000383394','OH00002003957','IL','1','BRODBECK','JANET','','','','34','286602554','730 BARTLEY PL',0,'TOLEDO','OH','43609','3107','CY','39095','1967-05-18','F','M',':RET:2106-3','N','021','HLT','3090597','92036OH006002601','2014-03-01','2014-01-30 09:32:18','132.00',NULL,NULL,'231.96','99.96','R-OH001','OH0','231.96',NULL,0,'2014-01-30 21:01:25'),(21590,17245,'Y','18','021','EC','A','','','AC','0000184967','0000184967','OH00002499549','IL','1','DOUBLIN','LATRICA','ANN','','','34','298787020','6257 TIMBERSIDE DR',0,'TOLEDO','OH','43615','4517','CY','39095','1980-01-19','F','U',':RET:2054-5','N','021','DEN','2652894','99734OH005000301','2014-03-01','2014-02-04 20:11:30','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-05 21:30:28'),(24660,19575,'N','01','021','EC','A',NULL,NULL,'','0000509255','0000637164','','IL','1','jackson','norman','','','','34','285724497','817 HOAG ST',0,'TOLEDO','OH','43607','4114','CY','39095','1968-06-18','M','',NULL,'N','021','HLT','3338672','92036OH004002601','2014-04-01','2014-02-19 15:38:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','226.41',NULL,0,'2014-02-20 04:25:11'),(26197,20775,'N','01','021','EC','A',NULL,NULL,'','0001190120','0001199560','','IL','1','Hamric','Craig','A','','','34','276841750','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1969-10-10','M','',':RET:2106-3','N','021','DEN','3299454','99734OH005000301','2014-03-01','2014-02-27 16:24:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:46'),(26379,20926,'N','01','021','EC','A',NULL,NULL,'','0001747612','0001968347','','IL','1','matusicky','Kris','Patrick','','','34','433750390','11156 OAK RIDGE DR',0,'DENHAM SPRINGS','LA','70726','7108','CY','22063','1980-08-31','M','',':RET:2106-3','N','021','DEN','3635282','18575LA002000201','2014-04-01','2014-02-26 13:32:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-28 07:00:18'),(28897,22872,'Y','18','021','EC','A','','','AC','0000678863','0000678863','TX00002867491','IL','1','gonzalez','sara','','','','34','641308241','2516 CHESTNUT ST',0,'LAREDO','TX','78046','6507','CY','48479','1959-02-25','F','U',NULL,'N','021','DEN','3697556','33348TX002000201','2014-04-01','2014-03-10 16:15:49','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-03-10 21:00:18'),(4735,3751,'N','01','021','EC','A',NULL,NULL,'','0000132047','0000457799','','IL','1','MOLONEY','RICHARD','','','','34','269741144','152 LARKINS STREET',0,'FINDLAY','OH','45840',NULL,'CY','39063','1964-02-23','M','',NULL,'T','021','HLT','468152','92036OH003001505','2014-01-01','2013-12-12 16:54:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','450.92',NULL,0,'2013-12-25 22:09:15'),(3525,2831,'Y','18','021','EC','A','','','AC','0000931196','0000931196','MS00000699043','IL','1','Stevens','Jeff','','','','34','426298179','205 WALNUT ST',0,'RIDGELAND','MS','39157','2831','CY','28089','1962-08-29','M','U',':RET:2106-3','N','021','DEN','1638399','46300MS002000101','2014-01-01','2013-12-22 14:02:49','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 21:21:20'),(7942,6282,'Y','18','021','EC','A','','','AC','0001417273','0001417273','LA00001186724','IL','1','Dion','Sloan','','','','34','660186572','1941 NICHOLAS ST',0,'LAKE CHARLES','LA','70605','4125','CY','22019','1907-08-09','F','U',':RET:2106-3','N','021','DEN','1472617','18575LA002000201','2014-01-01','2013-12-20 15:19:42','0.00',NULL,NULL,'16.22','16.22','R-LA004','LA0','16.22',NULL,0,'2013-12-26 03:06:55'),(6687,5302,'N','19','021','EC','A',NULL,NULL,'','0000728670','0000538226','','IL','1','Palmer','Spike',NULL,NULL,NULL,NULL,NULL,'401 SILVERWOOD FARMS DR',0,'LEBANON','OH','45036','8314','CY','39165','2012-08-28','M','',':RET:2106-3','N','021','DEN','125151','99734OH005000401','2014-01-01','2013-11-05 13:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:32'),(19997,15951,'Y','18','024','14','A','','','TE','0000799917','0000799917','','IL','1','Buccino','Gina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-11-05','F','',NULL,NULL,NULL,'','1732087','','2014-01-26','2014-01-26 11:02:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-26 19:00:03'),(25235,20017,'Y','18','021','EC','A','','','AC','0000290856','0000290856','OH00003165325','IL','1','Bonheimer','Bruce','','','','34','292588806','933 COLINA VISTA ST NW',0,'MASSILLON','OH','44646','3025','CY','39151','1956-11-30','M','U',NULL,'N','021','HLT','3031986','52664OH152000901','2014-04-01','2014-02-21 13:26:33','381.00',NULL,NULL,'398.06','17.06','R-OH015','OH0','398.06',NULL,0,'2014-02-21 22:01:04'),(27312,21625,'Y','18','021','EC','A','','','AC','0000879250','0000879250','TX00003485694','IL','1','Yousif','Wissam','','','','34','766842870','3800 SOLARIUM PL',0,'PLANO','TX','75075','3523','CY','48085','1978-05-15','M','U',NULL,'T','021','DEN','3791742','33348TX002000201','2014-04-01','2014-03-04 14:06:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-04 21:00:40'),(27362,21668,'Y','18','024','14','A','','','TE','0000501608','0000501608','','IL','1','Hammond','Hope',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-23','F','',NULL,NULL,NULL,'','2476725','','2014-03-19','2014-03-04 17:21:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-04 21:01:11'),(5136,4070,'Y','18','021','EC','A','','','AC','0000975079','0000975079','TX00001115129','IL','1','Collins','Marshall','','','','34','458975051','11519 WICKERSHAM LN',0,'HOUSTON','TX','77077','6829','CY','48201','1979-07-13','M','U',':RET:2106-3','T','021','DEN','1542227','33348TX002000101','2014-01-01','2013-12-19 17:48:13','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:02:22'),(16365,13096,'N','01','021','EC','A',NULL,NULL,'','0000467588','0000869519','','IL','1','Barton','Thelma','Lee','','','34','427115160','403 Hayes St.',0,'Carthage','MS','39051',NULL,'CY','28079','1957-07-19','F','',':RET:2054-5','N','021','DEN','1651299','46300MS002000201','2014-02-01','2014-01-06 11:00:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-07 04:02:52'),(1572,1312,'Y','18','021','EC','A','','','AC','0000347463','0000347463','TX00000895539','IL','1','Davis','Annette','M','','','34','466237525','2600 FALLCREEK ST',0,'ARLINGTON','TX','76014','1013','CY','48439','1963-10-30','F','U',':RET:2054-5','N','021','DEN','2614709','33348TX002000201','2014-01-01','2013-12-24 09:49:02','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:51:12'),(13247,10572,'Y','18','021','EC','A','','','AC','0000004882','0000004882','TX00000941581','IL','1','Mayes','Heather','','','','34','457594793','4903 E 27th STreet',0,'Dickinson','TX','77539',NULL,'CY','48167','1970-04-12','F','U',NULL,'N','021','DEN','1854842','33348TX002000201','2014-01-01','2013-12-23 10:57:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:56:17'),(19037,15162,'Y','18','021','EC','A','','','AC','0000585509','0000585509','MS00001884995','IL','1','Brown','Rosemary','','','','34','587346780','1215 DEAN TURNER RD',0,'LEAKESVILLE','MS','39451','5403','CY','28041','1950-11-19','F','M',':RET:2106-3','N','021','DEN','1647865','46300MS002000201','2014-03-01','2014-01-17 12:17:14','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-20 08:06:35'),(19437,15495,'Y','18','021','EC','A','','','AC','0000431402','0000431402','OH00001860036','IL','1','Ladd','Melissa','','','','34','291864569','3380 WHISPERING TREES DR',0,'AMELIA','OH','45102','2327','CY','39025','1980-09-06','F','M',':RET:2106-3','N','021','HLT','1465689','92036OH003000601','2014-03-01','2014-01-21 15:36:47','100.00',NULL,NULL,'813.11','713.11','R-OH005','OH0','268.56',NULL,1,'2014-01-22 03:23:11'),(20068,16007,'Y','18','021','EC','A','','','AC','0000354232','0000354232','TX00001726861','IL','1','COOKS','SHERTORA','','','','34','643128094','5621 AMHERST ST',0,'LUBBOCK','TX','79416','1411','CY','48303','1990-03-20','F','U',':RET:2054-5','N','021','DEN','2730229','33348TX002000201','2014-03-01','2014-01-27 14:07:25','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-27 21:00:15'),(21432,17129,'Y','18','024','14','A','','','TE','0000967072','0000967072','','IL','1','Nolasco','Jose','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-18','M','',NULL,NULL,NULL,'','3532670','','2014-02-04','2014-02-04 00:18:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:01:19'),(21773,17387,'Y','18','021','EC','A','','','AC','0000498209','0000498209','OH00001634649','IL','1','Bryant','Kimberly','','','','34','282520915','4071 COLUMBIA ST',0,'HILLIARD','OH','43026','1439','CY','39049','1967-10-05','F','U',':RET:2106-3','N','021','DEN','2708056','99734OH005000401','2014-03-01','2014-02-06 13:37:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:33'),(25959,20589,'Y','18','021','EC','A','','','AC','0000648379','0000648379','OH00002576745','IL','1','TAYLOR','YVONNE','','','','34','286866910','231 S FINDLAY ST',0,'DAYTON','OH','45403','2658','CY','39113','1976-10-28','F','M',NULL,'N','021','DEN','3479755','99734OH005000401','2014-04-01','2014-02-26 12:30:47','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00',NULL,0,'2014-02-26 21:01:41'),(6051,4793,'Y','18','021','EC','A','','','AC','0000299209','0000299209','OH00000259244','IL','1','MOORE','PAMELA','','','','34','282620597','8329 LEISURE DR',0,'CENTERVILLE','OH','45458','2023','CY','39113','1961-01-18','F','U',':RET:2106-3','N','021','DEN','870796','99734OH005000401','2014-01-01','2013-12-01 16:32:47','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:01:42'),(2925,2357,'Y','18','021','EC','A','','','AC','0001068243','0001068243','OH00000914041','IL','1','Glascock','Thomas','','','','34','400862767','7525 MONTGOMERY RD',0,'CINCINNATI','OH','45236','4101','CY','39061','1966-07-28','M','U',':RET:2106-3','N','021','DEN','550541','99734OH005000401','2014-01-01','2013-12-06 18:08:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:52'),(14476,11550,'Y','18','021','EC','A','','','AC','0000567592','0000567592','TX00000549866','IL','1','Bebout','Martin','','','','34','463238866','1709 E 18th Street',0,'Austin','TX','78702',NULL,'CY','48453','1961-11-17','M','U',':RET:2106-3','N','021','DEN','1741185','33348TX002000201','2014-02-01','2013-12-26 20:23:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-28 03:33:10'),(3367,2698,'Y','18','021','EC','A','','','AC','0000959870','0000959870','TX00000650556','IL','1','malano','tarah','','','','34','336725057','7023 PINE VISTA LN',0,'HOUSTON','TX','77092','1012','CY','48201','1970-11-03','F','U',':RET:2106-3','N','021','DEN','2373164','33348TX002000201','2014-01-01','2013-12-22 14:26:10','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:17:08'),(7648,6055,'Y','18','021','EC','A','','','AC','0000790837','0000790837','OH00000449537','IL','1','Kozopas','Joyce','','','','34','289545001','241 JEANIE WILSON WAY',0,'WILMINGTON','OH','45177','1795','CY','39027','1953-05-05','F','U',NULL,'N','021','DEN','128947','99734OH005000301','2014-01-01','2013-11-10 17:23:33','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:46:46'),(7178,5691,'N','01','021','EC','A',NULL,NULL,'','0000166359','0000467080','','IL','1','Barney','Joseph','Allen','','','34','285602074','644 E POSSUM RD',0,'SPRINGFIELD','OH','45502','9403','CY','39023','1971-01-12','M','',':RET:2106-3','N','021','DEN','145759','99734OH005000301','2014-01-01','2013-12-13 21:02:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:08'),(7055,5605,'Y','18','021','EC','A','','','AC','0001233055','0001233055','OH00000457989','IL','1','Koha','Andrew','','','','34','282607681','2358 RIDGEVIEW DR SW',0,'SHERRODSVILLE','OH','44675','9700','CY','39019','1959-01-09','M','R',':RET:2106-3','N','021','DEN','1529316','99734OH005000301','2014-01-01','2013-12-24 20:41:06','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-26 01:49:49'),(4552,3606,'Y','18','021','EC','A','','','AC','0000841898','0000841898','OH00000668534','IL','1','Clark','Thomas','','','','34','279501621','373 N PORTAGE ST',0,'DOYLESTOWN','OH','44230','1362','CY','39169','1950-12-12','M','U',':RET:2106-3','T','021','HLT','939951','52664OH152000901','2014-01-01','2013-12-12 09:08:29','439.00',NULL,NULL,'554.51','115.51','R-OH014','OH0','554.51',NULL,0,'2013-12-25 22:04:33'),(17842,14253,'Y','18','021','EC','A','','','AC','0000481096','0000481096','OH00001816126','IL','1','AGBO','EVELYN','','','','34','782365805','276 HAMTSHIRE',0,'HAMILTION','OH','45011',NULL,'CY','39017','1954-07-22','F','M',NULL,'N','021','DEN','2707506','99734OH005000401','2014-02-01','2014-01-13 21:44:27','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:04'),(20104,16040,'Y','18','021','EC','A','','','AC','0002106182','0002106182','LA00002161903','IL','1','Martin','Monique','','','','34','438351398','7622 Mercier St',0,'New Orleans','LA','70128',NULL,'CY','22071','1978-07-21','F','U',':RET:2054-5','N','021','DEN','2491357','18575LA002000201','2014-03-01','2014-01-27 14:28:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-27 21:00:37'),(22272,17777,'Y','18','021','EC','A','','','AC','0001040484','0001040484','TX00001965365','IL','1','Santoyo','Ramon','de Jesus','','','34','455933265','3601 GUADALUPE ST',0,'LAREDO','TX','78043','3828','CY','48479','1987-12-09','M','U',':RET:2106-3','N','021','DEN','2910105','33348TX002000201','2014-03-01','2014-01-29 21:12:03','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-10 11:00:15'),(4436,3526,'Y','18','021','EC','A','','','AC','0001031431','0001031431','OH00000583463','IL','1','Moltz','Debora','','','','34','268649217','406 Bellevue Ave',0,'Sandusky','OH','44870',NULL,'CY','39043','1957-04-12','F','U',':RET:2106-3','N','021','DEN','634477','99734OH005000301','2014-01-01','2013-12-11 18:47:46','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 22:02:01'),(3125,2511,'Y','18','021','EC','A','','','AC','0000153327','0000153327','OH00001089513','IL','1','Lambert','Kristopher','','','','34','270807553','5625 Coach Drive East',0,'Kettering','OH','45440',NULL,'CY','39113','1982-07-04','M','U',NULL,'N','021','DEN','394657','99734OH005000301','2014-01-01','2013-10-13 14:46:29','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:30:23'),(1773,1461,'Y','18','021','EC','A','','','AC','0000796967','0000796967','OH00000962726','IL','1','Wilson','Katrina','','','','34','277827402','1024 KUNZ AVE',0,'MIDDLETOWN','OH','45044','5704','CY','39017','1968-06-03','F','M',':RET:2054-5','N','021','DEN','2153123','99734OH005000301','2014-01-01','2013-12-24 14:22:04','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:56:09'),(1621,1354,'N','01','021','EC','A',NULL,NULL,'','0001041352','0001182389','','IL','1','Contreras','Ramon','','','III','34','457732937','150 Wildrose Ave',0,'San Antonio','TX','78209',NULL,'CY','48029','1969-08-08','M','',':RET:2106-3','N','021','DEN','2483563','33348TX002000201','2014-01-01','2013-12-24 13:52:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:35'),(17282,13820,'Y','18','021','EC','A','','','AC','0000807514','0000807514','OH00001567579','IL','1','Smith','Kim','','','','34','032605878','5485 BRIDGEPORT AVE NW',0,'CANAL FULTON','OH','44614','8587','CY','39151','1970-11-25','F','R',':RET:2106-3','N','021','HLT','2250941','52664OH152000901','2014-02-01','2014-01-10 14:39:09','0.00',NULL,NULL,'221.65','221.65','R-OH015','OH0','221.65',NULL,0,'2014-01-13 02:23:25'),(17456,13958,'N','01','021','EC','A',NULL,NULL,'','0001005730','0001007898','','IL','1','Kennedy','Tabitha',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','1984-01-29','F','',':RET:2106-3','N','021','HLT','1835802','92036OH002000601','2014-02-01','2014-01-10 14:33:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.38',NULL,0,'2014-01-13 03:00:40'),(25411,20161,'Y','18','021','EC','A','','','AC','0001049432','0001049432','OH00002683224','IL','1','JONES','CHARLES','J','','Jr','34','278641234','938 MERTON AVE',0,'AKRON','OH','44306',NULL,'CY','39153','1958-10-24','M','U',':RET:2054-5','N','021','DEN','3279833','99734OH005000401','2014-04-01','2014-02-25 10:52:45','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:31:03'),(26033,20646,'N','01','021','EC','A',NULL,NULL,'','0000409537','0000897146','','IL','1','HAMPTON','SHENITHA','','','','34','426415612','5214 MOUNT SINAI RD',0,'LIBERTY','MS','39645',NULL,'CY','28005','1979-02-24','F','',':RET:2054-5','N','021','DEN','3424307','46300MS002000101','2014-04-01','2014-02-26 16:14:01',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-26 21:02:22'),(28241,22346,'Y','18','021','EC','A','','','AC','0000279607','0000279607','OH00003532707','S3','1','Bregitzer','Kelly','','','','34','288137384','1551 POLK DR',0,'BRUNSWICK','OH','44212','3713','CY','39103','2007-10-24','M','U',':RET:2106-3','N','021','DEN','3414807','99734OH005000401','2014-04-01','2014-03-07 10:03:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78','CIC',0,'2014-03-07 21:00:10'),(1001,821,'Y','18','021','EC','A','','','AC','0000319049','0000319049','MS00000333907','IL','1','Spann','Claire','','','','34','267874344','103 JOE MYERS RD',0,'BRANDON','MS','39047','9558','CY','28121','1969-08-25','F','M',':RET:2106-3','N','021','DEN','196181','46300MS002000101','2014-01-01','2013-11-10 20:25:24','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2013-12-25 18:10:57'),(15338,12267,'Y','18','021','EC','A','','','AC','0001174411','0001174411','OH00001081913','IL','1','Keith','Angela','','','','34','290847198','232 BAKER DR',0,'RITTMAN','OH','44270','1302','CY','39169','1970-12-03','F','U',':RET:2106-3','N','021','HLT','1459651','52664OH152000901','2014-02-01','2013-12-31 20:10:53','0.00',NULL,NULL,'221.65','221.65','R-OH014','OH0','221.65',NULL,1,'2014-01-02 04:24:08'),(1737,1442,'Y','18','021','EC','A','','','AC','0001124065','0001124065','OH00000308930','IL','1','turkish','michael','','','','34','298728665','12290 WATERFOWL LN',0,'CHARDON','OH','44024','7024','CY','39055','1970-07-23','M','M',NULL,'N','021','DEN','1845086','99734OH005000301','2014-01-01','2013-12-24 11:01:17','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:28'),(6190,4904,'N','01','021','EC','A',NULL,NULL,'','0000179207','0000558997','','IL','1','kayati','karima','','','','34','496778371','2157 OLD IRONSIDES RD',0,'ABILENE','TX','79601','4765','CY','48441','1983-08-07','F','',NULL,'N','021','DEN','682853','33348TX002000101','2014-01-01','2013-10-23 00:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-26 00:30:17'),(3528,2833,'Y','18','021','EC','A','','','AC','0000550600','0000550600','TX00000577666','IL','1','Bridges','Mirabel','','','','34','645182877','2000 N COUNTY ROAD 1147',0,'MIDLAND','TX','79705','9517','CY','48329','1990-08-16','F','U',':RET:2106-3','N','021','DEN','2476726','33348TX002000101','2014-01-01','2013-12-21 22:09:48','0.00',NULL,NULL,'25.02','25.02','R-TX016','TX0','25.02',NULL,0,'2013-12-25 21:21:25'),(9379,7437,'Y','18','021','EC','A','','','AC','0001310086','0001310086','LA00000064201','IL','1','Hamlin','Lauren','','','','34','436490312','85 Allard Blvd.',0,'New Orleans','LA','70119',NULL,'CY','22071','1965-12-05','F','U',NULL,'T','021','DEN','1847584','18575LA002000201','2014-01-01','2013-12-21 15:55:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:32:02'),(5183,4111,'Y','18','021','EC','A','','','AC','0001240545','0001240545','OH00000623619','IL','1','Fadell','Abraham','','','','34','271525791','3861 WINDWARD DR',0,'SYLVANIA','OH','43560','9111','CY','39095','1951-03-02','M','U',NULL,'N','021','DEN','1891193','99734OH005000401','2014-01-01','2013-12-19 12:41:03','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 23:03:33'),(17546,14027,'N','01','021','EC','A',NULL,NULL,'','0000584291','0001200900','','IL','1','Rebrisorean','Lavinia','Ana','','','34','288085855','2115 REDWOOD PL',0,'CANFIELD','OH','44406','8463','CY','39099','1970-04-02','F','',':RET:2106-3','N','021','HLT','1466827','92036OH005003205','2014-02-01','2014-01-12 12:52:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','328.46',NULL,0,'2014-01-13 03:01:51'),(20695,16535,'Y','18','021','EC','A','','','AC','0000172443','0000172443','OH00002109196','IL','1','Harless','Stephen','','','','34','270865522','1570 BELDEN AVE SE',0,'CANTON','OH','44707','2659','CY','39151','1978-08-29','M','U',NULL,'N','021','DEN','3480435','99734OH005000301','2014-03-01','2014-01-30 11:32:50','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-30 21:01:00'),(23372,18624,'Y','18','021','EC','A','','','AC','0001162642','0001162642','OH00002806070','IL','1','ALBERT','LATOYA','A','','','34','284705889','342 S ASH BURN RD',0,'COLUMBUS','OH','43213',NULL,'CY','39049','1968-08-05','F','U',NULL,'N','021','DEN','3835255','99734OH005000401','2014-03-01','2014-02-12 23:32:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:54'),(23734,18897,'Y','18','021','EC','A','','','AC','0000700431','0000700431','OH00001510985','IL','1','WEATHERS','BETTY','F','','','34','268766115','10283 SPRINGLEN CT',0,'CINCINNATI','OH','45251','1214','CY','39061','1971-12-17','F','U',':RET:2054-5','N','021','DEN','2622816','99734OH005000301','2014-03-01','2014-02-13 20:03:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:59'),(24218,19234,'Y','18','021','EC','A','','','AC','0001246738','0001246738','TX00001782499','IL','1','FLORES','FRANKIE','','','','34','453913735','1020 BRIGHTON PL',0,'ROUND ROCK','TX','78665','4044','CY','48491','1979-09-12','M','M',NULL,'N','021','DEN','2625358','33348TX002000201','2014-04-01','2014-02-16 00:23:01','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-16 19:00:27'),(26521,21032,'N','19','021','EC','A',NULL,NULL,'','0000294433','0000569376','','S1','1','Dietrich','Kara','M','','','34','288021829','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1997-11-02','F','',NULL,'N','021','HLT','2621755','92036OH003002706','2014-03-01','2014-02-28 14:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-28 21:00:24'),(3325,2667,'N','01','021','EC','A',NULL,NULL,'','0000581482','0000432753','','IL','1','Riegler','John','','','','34','286667127','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','1971-11-17','M','',':RET:2106-3','N','021','DEN','2144635','99734OH005000301','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:08'),(6688,5302,'N','19','021','EC','A',NULL,NULL,'','0000728670','0001030331','','IL','1','Palmer','Jaxten',NULL,NULL,NULL,NULL,NULL,'401 SILVERWOOD FARMS DR',0,'LEBANON','OH','45036','8314','CY','39165','2010-06-28','M','',':RET:2106-3','N','021','DEN','125151','99734OH005000401','2014-01-01','2013-11-05 13:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:01:32'),(13174,10508,'Y','18','021','EC','A','','','AC','0000268906','0000268906','OH00000111672','IL','1','roane','amber','','','','34','272881002','337 fieldcrest drive',0,'fairlawn','OH','44333',NULL,'CY','39153','1984-05-29','F','U',':RET:2054-5','N','021','DEN','2499490','99734OH005000401','2014-01-01','2013-12-23 18:57:06','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:54:07'),(13059,10410,'N','19','021','EC','A',NULL,NULL,'','0000184938','0000047083','','S1','1','Filina','Robert','','','','34','285153847','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','2009-09-05','F','',':RET:2106-3','N','021','DEN','1466228','99734OH005000401','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:02'),(9677,7666,'N','01','021','EC','A',NULL,NULL,'','0000957908','0000289525','','IL','1','JULIUS','DIANN','','','','34','283561233','5713 TIBARON LN',0,'TOLEDO','OH','43615',NULL,'CY','39095','1962-07-31','F','',NULL,'T','021','HLT','2118305','92036OH006002601','2014-01-01','2013-12-21 12:08:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','331.68',NULL,0,'2013-12-26 04:39:23'),(7426,5877,'Y','18','021','EC','A','','','AC','0000779070','0000779070','OH00000720786','IL','1','stark','cheryl','','','','34','284709967','1797 LEXINGTON AVE NW',0,'WARREN','OH','44485','1724','CY','39155','1961-07-28','F','U',':RET:2106-3','T','021','HLT','125140','92036OH001003201','2014-01-01','2013-10-28 14:59:37','289.00',NULL,NULL,'655.40','366.40','R-OH013','OH0','655.40',NULL,0,'2013-12-26 02:17:12'),(19031,15156,'Y','18','021','EC','A','','','AC','0000869308','0000869308','OH00001897986','IL','1','Brown','Byron','','','','34','626160481','1025 CORNELL DR',0,'LIMA','OH','45805','1623','CY','39003','1988-01-01','M','U',':RET:2054-5','N','021','HLT','2682982','92036OH003001506','2014-03-01','2014-01-17 11:29:49','185.00',NULL,NULL,'235.35','50.35','R-OH002','OH0','235.35',NULL,0,'2014-01-20 08:06:31'),(22101,17643,'Y','18','021','EC','A','','','AC','0000758310','0000758310','OH00002477318','IL','1','mccandless','Lawren','','','','34','167602850','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1962-10-20','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2632680','99734OH005000301','2014-03-01','2014-02-08 11:47:06','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-02-08 19:00:30'),(23787,18930,'Y','18','021','EC','A','','','AC','0000823559','0000823559','OH00002206412','IL','1','BLACKWOOD','PAMELA','','','','34','277629376','267 SOUTH BLVD',0,'WADSWORTH','OH','44281','1782','CY','39103','1955-03-05','F','M',':RET:2106-3','N','021','HLT','3311553','52664OH151001306','2014-03-01','2014-02-13 22:27:21','776.00',NULL,NULL,'1023.16','247.16','R-OH012','OH0','568.22',NULL,0,'2014-02-14 21:31:23'),(5370,4258,'Y','18','021','EC','A','','','AC','0000349253','0000349253','OH00000910782','IL','1','Madill','Richard','','','','34','298505916','11781 STONE MILL RD',0,'CINCINNATI','OH','45251','4125','CY','39061','1951-02-25','M','M',NULL,'N','021','HLT','1527691','92036OH005001201','2014-01-01','2013-12-19 13:00:34','578.00',NULL,NULL,'1219.98','641.98','R-OH004','OH0','616.74',NULL,0,'2013-12-25 23:08:04'),(6350,5032,'Y','18','021','EC','A','','','AC','0000042032','0000042032','OH00000012200','IL','1','Cioffi','Nicolle','','','','34','284864486','5865 BELFAST OWENSVILLE RD',0,'BATAVIA','OH','45103','9632','CY','39025','1983-09-29','F','R',':RET:2106-3','N','021','DEN','519964','99734OH005000401','2014-01-01','2013-12-11 13:32:58','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:47:01'),(7391,5851,'Y','18','021','EC','A','','','AC','0000636946','0000636946','MS00001170552','IL','1','Mack','Stuart','','','','34','425470309','5764 KIRKLEY DR',0,'JACKSON','MS','39206','2720','CY','28049','1983-04-04','M','U',NULL,'N','021','DEN','1004737','46300MS002000101','2014-01-01','2013-11-23 15:27:03','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 02:16:11'),(16016,12820,'Y','18','021','EC','A','','','AC','0002268054','0002268054','LA00001713653','IL','1','Kambi','Cheye','','','','34','438651682','1223 SEVILLE DR',0,'NEW ORLEANS','LA','70122','1940','CY','22071','1986-09-02','F','U',':RET:2054-5','N','021','DEN','2410449','18575LA002000201','2014-02-01','2014-01-02 22:10:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-04 02:02:00'),(17251,13803,'N','01','021','EC','A',NULL,NULL,'','0000335176','0001133962','','IL','1','janovyak','kayla','','','','34','602018669','1690 AMERICANA CT',0,'COLUMBUS','OH','43229','1430','CY','39049','1987-10-04','F','',':RET:2106-3','N','021','DEN','1758434','99734OH005000301','2014-02-01','2014-01-09 20:36:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:12'),(20645,16497,'Y','18','021','EC','A','','','AC','0001244406','0001244406','TX00002406359','IL','1','douglass','brenda','','','','34','450433506','300 ACR 428',0,'Palestine','TX','75803',NULL,'CY','48001','1961-09-30','F','U',':RET:2106-3','N','021','DEN','3167449','33348TX002000201','2014-03-01','2014-01-30 13:47:27','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:35'),(22735,18152,'N','19','021','EC','A',NULL,NULL,'','0001880829','0001852478','','IL','1','nguyen','peter','','','','34','483237423','29795 hwy 23',0,'port sulpher','LA','70083',NULL,'CY','22075','1995-01-17','M','',':RET:2047-9','N','021','DEN','2828295','18575LA002000201','2014-03-01','2014-02-11 15:53:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-02-11 21:01:17'),(23775,18918,'Y','18','021','EC','A','','','AC','0000132054','0000132054','MS00001932901','IL','1','BARNES','MANDIE','','','','34','587543520','117 LUTHER MCEWEN DR.',0,'MAGNOLIA','MS','39652',NULL,'CY','28113','1953-07-06','F','U',NULL,'N','021','DEN','2930136','46300MS002000201','2014-03-01','2014-02-13 19:40:06','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-14 21:31:15'),(23848,18976,'Y','18','021','EC','A','','','AC','0000655868','0000655868','OH00001926613','IL','1','CHU','TIEN PAO','','','','34','293081828','1908 Woods Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1970-08-18','M','M',NULL,'N','021','HLT','3160262','92036OH005001506','2014-03-01','2014-02-13 22:54:38','485.00',NULL,NULL,'579.92','94.92','R-OH002','OH0','298.65',NULL,0,'2014-02-14 21:31:57'),(25599,20310,'Y','18','024','14','A','','','TE','0001092126','0001092126','','IL','1','AVILES','CARLOS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-01','M','',NULL,NULL,NULL,'','2234515','','2014-03-31','2014-02-23 13:02:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-26 08:00:49'),(1427,1189,'Y','18','021','EC','A','','','AC','0001501884','0001501884','LA00000135736','IL','1','durbin','patrick','','','','34','536665137','po box 474',0,'krotz springs','LA','70750',NULL,'CY','22097','1961-01-29','M','U',':RET:2106-3','N','021','DEN','2442112','18575LA002000201','2014-01-01','2013-12-24 16:54:50','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 18:47:26'),(8029,6356,'Y','18','024','14','A','','','TE','0000515384','0000515384','','IL','1','JOHNSON','WILLIE','j','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1941-04-29','M','',NULL,NULL,NULL,'','2377164','','2013-12-20','2013-12-20 09:55:04',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 03:09:05'),(14415,11497,'Y','18','021','EC','A','','','AC','0000298712','0000298712','TX00001580079','IL','1','Aguirre','Noemi','','','','34','459822553','6423 WILDLIFE WAY',0,'BAYTOWN','TX','77523','7480','CY','48071','1950-11-28','F','U',':RET:2106-3','N','021','DEN','1682456','33348TX002000101','2014-02-01','2013-12-27 06:47:45','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:33'),(14344,11442,'Y','18','021','EC','A','','','AC','0001096765','0001096765','OH00001363259','IL','1','Gould','Mary','','','','34','288501698','618 Whipple Ave.',0,'Campbell','OH','44405',NULL,'CY','39099','1950-07-02','F','U',':RET:2106-3','N','021','HLT','2425612','92036OH003003205','2014-02-01','2013-12-26 15:40:34','575.00',NULL,NULL,'746.18','171.18','R-OH013','OH0','746.18',NULL,0,'2013-12-27 02:07:58'),(15077,12051,'N','01','021','EC','A',NULL,NULL,'','0000670759','0001111908','','IL','1','Graves','Jeremy','L','','','34','462614948','605 AUDREY ST',0,'LONGVIEW','TX','75601','6004','CY','48203','1981-02-07','M','',':RET:2106-3','N','021','DEN','2009622','33348TX002000101','2014-02-01','2013-12-29 19:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-01 12:04:03'),(18326,14632,'Y','18','021','EC','A','','','AC','0000910548','0000910548','OH00001591397','IL','1','VanAlmen','Amy','','','','34','280723049','7471 SOM CENTER RD',0,'SOLON','OH','44139','5623','CY','39035','1976-01-04','F','U',':RET:2106-3','N','021','DEN','2736238','99734OH005000401','2014-02-01','2014-01-15 13:31:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:10'),(19619,15638,'Y','18','021','EC','A','','','AC','0000216131','0000216131','OH00002288951','IL','1','DAY','JOAN','','','','34','289526023','6215 CAVALCADE DR',0,'FAIRFIELD','OH','45011','5106','CY','39017','1951-04-07','F','U',':RET:2106-3','N','021','HLT','2134197','92036OH005001201','2014-03-01','2014-01-22 14:06:14','247.00',NULL,NULL,'616.74','369.74','R-OH004','OH0','616.74',NULL,0,'2014-01-23 03:02:54'),(22322,17823,'Y','18','021','EC','A','','','AC','0002282453','0002282453','LA00002458592','31','1','Bingham','Elester','','','','34','438849806','P.O. Box 337',0,'Wisner','LA','71378',NULL,'CY','22041','1953-09-15','F','U',':RET:2054-5','N','021','DEN','1992074','18575LA002000201','2014-03-01','2014-01-22 16:53:41','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-10 11:00:54'),(25669,20364,'N','01','021','EC','A',NULL,NULL,'','0000840433','0000984248','','IL','1','Tart','Willie','Earl','','','34','427029228','239 Boyd Street',0,'Canton','MS','39046',NULL,'CY','28089','1956-01-17','M','',':RET:2054-5','N','021','DEN','3195282','46300MS002000201','2014-04-01','2014-02-21 21:54:30',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-26 08:30:51'),(27131,21478,'Y','18','021','EC','A','','','AC','0000959154','0000959154','OH00002322294','IL','1','Stewart','Benjamin','','','','34','300925358','1730 Beacon St',0,'Cincinnati','OH','45230',NULL,'CY','39061','1988-09-10','M','U',NULL,'N','021','DEN','3712679','99734OH005000401','2014-04-01','2014-03-02 20:29:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:39'),(6055,4797,'Y','18','021','EC','A','','','AC','0000020144','0000020144','OH00000484467','IL','1','Saygrover','WM','Thomas','','','34','270460084','398 FAIRVIEW ST',0,'MARION','OH','43302','1817','CY','39101','1950-08-03','M','U',':RET:2106-3','N','021','DEN','1053624','99734OH005000401','2014-01-01','2013-12-01 14:34:52','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2013-12-26 00:01:48'),(15803,12650,'Y','18','021','EC','A','','','AC','0001612802','0001612802','LA00001433389','IL','1','Collins','Twander','M','','','34','436171518','100 GATES DR',0,'FRANKLIN','LA','70538','6207','CY','22101','1968-05-10','F','U',':RET:2054-5','N','021','DEN','2445013','18575LA002000201','2014-02-01','2014-01-02 11:47:41','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-03 02:02:57'),(15071,12047,'N','01','021','EC','A',NULL,NULL,'','0000322500','0000274085','','IL','1','Espinoza Ocampo','Diepherith','Moises','','','34','086674241','909 WHITWORTH ST',0,'JACKSON','MS','39202','2744','CY','28049','1987-04-08','M','',NULL,'N','021','DEN','2331134','46300MS002000101','2014-02-01','2013-12-30 18:14:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-01 12:03:54'),(8957,7105,'Y','18','021','EC','A','','','AC','0000634796','0000634796','OH00001019710','IL','1','Armstrong','Alexandra','Morgon','','','34','287906416','966 WOODLYN DR N',0,'CINCINNATI','OH','45230','4422','CY','39061','1987-01-13','F','U',NULL,'N','021','DEN','2517812','99734OH005000401','2014-01-01','2013-12-18 12:38:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:45'),(27884,22058,'Y','18','021','EC','A','','','AC','0000763588','0000763588','OH00002815512','IL','1','FAY','MARK','','','','34','271525165','657 DUSSEL DR',0,'MAUMEE','OH','43537','2411','CY','39095','1957-03-18','M','U',':RET:2106-3','T','021','HLT','4043138','92036OH005002604','2014-04-01','2014-03-05 11:22:22','326.00',NULL,NULL,'546.49','220.49','R-OH001','OH0','546.49',NULL,0,'2014-03-05 21:32:34'),(655,540,'Y','18','021','EC','A','','','AC','0001195491','0001195491','OH00000561760','IL','1','Sheard','James','','','','34','294527137','7740 Scioto Darby Road',0,'Hilliard','OH','43026',NULL,'CY','39049','1951-05-27','M','R',':RET:2106-3','N','021','DEN','51203','99734OH005000301','2014-01-01','2013-12-15 18:12:45','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:01:42'),(18826,14995,'Y','18','021','EC','A','','','AC','0001247777','0001247777','MS00002196103','IL','1','DUKE','TAMMY','','','','34','428217273','273 VIRLILIA RD',0,'CANTON','MS','39046',NULL,'CY','28089','1961-08-23','F','M',':RET:2106-3','N','021','DEN','2633276','46300MS002000201','2014-03-01','2014-01-16 11:40:30','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:08'),(17797,14216,'N','01','021','EC','A',NULL,NULL,'','0000963249','0000880538','','IL','1','Baker','Darrell','R','','','34','274541392','445 KARENLAW LN',0,'CINCINNATI','OH','45231','2727','CY','39061','1952-04-02','M','',':RET:2106-3','N','021','HLT','1682848','92036OH004001201','2014-02-01','2014-01-13 15:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','485.05',NULL,0,'2014-01-14 01:33:51'),(17236,13793,'N','01','021','EC','A',NULL,NULL,'','0000130711','0000987422','','IL','1','Geyer','Paul','J','','Jr','34','284605273','13301 GILMORE AVE',0,'CLEVELAND','OH','44135','2131','CY','39035','1963-01-18','M','',':RET:2106-3','N','021','HLT','1542948','92036OH003000806','2014-02-01','2014-01-08 12:50:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','455.37',NULL,0,'2014-01-13 02:22:42'),(8027,6354,'N','01','021','EC','A',NULL,NULL,'','0000931195','0001114577','','IL','1','Williamson','Betty','','','','34','458984295','2 SOUTHWOOD BLVD',0,'CLINTON','MS','39056','3590','CY','28049','1952-05-15','F','',':RET:2106-3','N','021','DEN','2016122','46300MS002000101','2014-01-01','2013-12-19 21:33:36',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-26 03:09:03'),(21674,17308,'Y','18','024','14','A','','','TE','0001640013','0001640013','','IL','1','Leary','Arnold','F',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-11','M','',NULL,NULL,NULL,'','1433763','','2014-02-05','2014-02-05 16:15:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-05 21:30:59'),(7464,5906,'Y','18','021','EC','A','','','AC','0000516383','0000516383','MS00000234137','IL','1','MARTIN','JOHN','','','','34','409882144','2087 ASHLAND DR',0,'SOUTHHAVEN','MS','38671',NULL,'CY','28033','1949-12-18','M','U',':RET:2106-3','T','021','DEN','925131','46300MS002000201','2014-01-01','2013-12-15 09:30:52','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-26 02:30:59'),(1507,1256,'Y','18','021','EC','A','','','AC','0000893154','0000893154','OH00001525884','IL','1','molden','michael','','','','34','298826122','982 W KEMPER RD',0,'CINCINNATI','OH','45240','2436','CY','39061','1985-04-02','M','U',':RET:2054-5','T','021','DEN','1550244','99734OH005000401','2014-01-01','2013-12-24 12:33:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:23'),(15837,12681,'Y','18','021','EC','A','','','AC','0000876072','0000876072','OH00000844568','IL','1','burns','kenneth','','','','34','273705521','3912 WARWICK AVE',0,'CINCINNATI','OH','45229','1319','CY','39061','1971-04-03','M','U',NULL,'N','021','DEN','2229883','99734OH005000401','2014-02-01','2014-01-02 13:10:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:04:03'),(5150,4083,'Y','18','021','EC','A','','','AC','0000312173','0000312173','OH00000860925','IL','1','HATTON','WILLIAM','','','','34','296489448','1816 FERNWOOD ST',0,'MIDDLETOWN','OH','45044','6432','CY','39017','1949-12-14','M','M',':RET:2106-3','N','021','DEN','1527675','99734OH005000401','2014-01-01','2013-12-19 09:49:22','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:02:47'),(13401,10694,'N','19','021','EC','A',NULL,NULL,'','0001075301','0001157562','','IL','1','Danner','Jude','Xavier','','','34','302154534','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','2005-09-06','M','',':RET:2106-3','N','021','DEN','2539568','99734OH005000301','2014-01-01','2013-12-23 09:16:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:21'),(4311,3427,'Y','18','021','EC','A','','','AC','0000077551','0000077551','OH00000632950','IL','1','Wilson','Jacqueline','Christine','','','34','292903410','2200 Prospect Ave. E.',0,'Cleveland','OH','44115',NULL,'CY','39035','1984-06-27','F','U',':RET:2054-5','N','021','HLT','2215277','52664OH152001001','2014-01-01','2013-12-17 02:00:06','0.00',NULL,NULL,'154.74','154.74','R-OH011','OH0','154.74',NULL,0,'2013-12-25 21:52:34'),(9478,7516,'N','19','021','EC','A',NULL,NULL,'','0000399882','0000561665','','S1','1','Bitonte','Tracy','Dawn','','','34','293043742','508 Chatham Court',0,'Pinkerington','OH','43147',NULL,'CY','39045','2000-01-09','M','',':RET:2106-3','N','021','DEN','2396650','99734OH005000401','2014-01-01','2013-12-21 11:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:35'),(9002,7143,'Y','18','021','EC','A','','','AC','0000953236','0000953236','OH00000293878','IL','1','Smith','Douglas','','','','34','234846351','823 CLOVER AVE',0,'CUYAHOGA FALLS','OH','44221','1947','CY','39153','1951-05-29','M','M',':RET:2106-3','T','021','HLT','2047872','52664OH152000901','2014-01-01','2013-12-18 10:26:01','419.00',NULL,NULL,'539.67','120.67','R-OH012','OH0','539.67',NULL,0,'2013-12-26 04:04:55'),(25374,20132,'Y','18','024','14','A','','','TE','0000397371','0000397371','','IL','1','Marini','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-03','F','',NULL,NULL,NULL,'','1403670','','2014-03-12','2014-02-25 15:44:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:43'),(25468,20205,'N','01','021','EC','A',NULL,NULL,'','0000640161','0000264291','','IL','1','Rios','Gostabo','','','','34','449259797','461 CUT OFF RD',0,'FREDERICKSBURG','TX','78624','7558','CY','48171','1958-08-01','M','',':RET:2106-3','N','021','DEN','3226156','33348TX002000201','2014-04-01','2014-02-25 16:19:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:35'),(25488,20220,'N','19','021','EC','A',NULL,NULL,'','0000446825','0000253972','','IL','1','WELLS','MARLA','','','','34','425871504','10490 ROAD 773',0,'PHILADELPHIA','MS','39350',NULL,'CY','28099','1999-06-17','F','',':RET:2106-3','N','021','DEN','3637743','46300MS002000201','2014-04-01','2014-02-25 12:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2014-02-25 21:31:47'),(26831,21266,'Y','18','021','EC','A','','','AC','0001203273','0001203273','OH00003568450','IL','1','Civitarese','Frank','','','','34','289787703','210 MONROE ST',0,'LOUDONVILLE','OH','44842','1328','CY','39005','1981-11-25','M','M',':RET:2106-3','N','021','DEN','2707432','99734OH005000401','2014-04-01','2014-03-01 14:37:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-01 21:00:40'),(26873,21298,'Y','18','021','EC','A','','','AC','0001233107','0001233107','OH00002418463','IL','1','COXE','BARBARA','','','','34','270500332','259 CRESTMONT CT',0,'COPLEY','OH','44321',NULL,'CY','39153','1950-07-28','F','U',':RET:2106-3','N','021','HLT','3174649','52664OH151001305','2014-04-01','2014-03-01 16:18:47','487.00',NULL,NULL,'658.32','171.32','R-OH012','OH0','658.32',NULL,0,'2014-03-01 21:01:04'),(7996,6328,'Y','18','021','EC','A','','','AC','0000347898','0000347898','OH00000925236','IL','1','Kimbro-Jackson','Florene','','','','34','277465737','917 E 218TH ST',0,'CLEVELAND','OH','44119','2423','CY','39035','1949-11-03','F','U',NULL,'N','021','HLT','2356018','52664OH151001305','2014-01-01','2013-12-20 15:39:44','524.00',NULL,NULL,'754.54','230.54','R-OH011','OH0','754.54',NULL,0,'2013-12-26 03:08:16'),(20186,16108,'N','19','021','EC','A',NULL,NULL,'','0000533968','0000921511','','IL','1','samaha','yasmeen','','','','34','444237216','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','2007-05-31','F','',':RET:2106-3','N','021','DEN','2702806','33348TX002000101','2014-03-01','2014-01-27 00:47:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-27 21:01:24'),(3810,3053,'Y','18','021','EC','A','','','AC','0000912935','0000912935','OH00000434325','IL','1','Williams','LaKisha','','','','34','287888848','2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','1978-05-18','F','R',':RET:2054-5','N','021','DEN','783233','99734OH005000301','2014-01-01','2013-12-13 14:00:53','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:34:44'),(13480,10748,'N','01','021','EC','A',NULL,NULL,'','0000771441','0000053061','','IL','1','Rawal','Meena','','','','34','281809398','4998 SHADY CREST AVE NW',0,'MASSILLON','OH','44646','9554','CY','39151','1977-08-17','F','',':RET:2029-7','N','021','DEN','2193469','99734OH005000301','2014-01-01','2013-12-23 17:17:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:11'),(19644,15656,'Y','18','021','EC','A','','','AC','0001219620','0001219620','OH00001602548','IL','1','MINAMYER','RALPH','LEE','','','34','298461188','35 DEER TRAIL DR',0,'SPRINGBORO','OH','45066',NULL,'CY','39165','1949-11-29','M','M',':RET:2106-3','N','021','DEN','2440304','99734OH005000401','2014-03-01','2014-01-23 09:28:00','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-23 21:00:16'),(14315,11417,'N','01','021','EC','A',NULL,NULL,'','0000780516','0000436607','','IL','1','Perkins','Andrew','','','','34','301820623','41 Walnut Street',0,'New London','OH','44851',NULL,'CY','39077','1985-05-05','M','',NULL,'N','021','HLT','1936578','92036OH003002706','2014-02-01','2013-12-26 18:22:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','221.36',NULL,0,'2013-12-27 02:07:07'),(21136,16889,'Y','18','024','14','A','','','TE','0000861937','0000861937','','IL','1','Marsh','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-20','M','',NULL,NULL,NULL,'','2022939','','2014-02-03','2014-02-03 15:50:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:00:20'),(23712,18880,'Y','18','021','EC','A','','','AC','0000195183','0000195183','OH00002679524','IL','1','Kourian','Phyllis','','','','34','290409839','105 GRANDVIEW AVE',0,'HUBBARD','OH','44425','2052','CY','39155','1951-05-10','F','M',':RET:2106-3','N','021','DEN','2784271','99734OH005000401','2014-03-01','2014-02-14 16:07:18','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-14 21:30:47'),(26942,21350,'N','19','021','EC','A',NULL,NULL,'','0000618418','0001152256','','IL','1','Chmura','Thomas',NULL,NULL,NULL,NULL,NULL,'1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','1999-08-30','M','',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:23'),(27178,21518,'Y','18','021','EC','A','','','AC','0000292207','0000292207','TX00002500238','IL','1','ESCOBEDO','ALEX','','','','34','452907733','308 E 89TH ST',0,'ODESSA','TX','79765','1405','CY','48135','1951-06-08','M','M',NULL,'N','021','DEN','2838453','33348TX002000201','2014-04-01','2014-03-03 13:04:37','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-03-03 21:31:09'),(27507,21763,'Y','18','021','EC','A','','','AC','0000851896','0000851896','OH00003721202','IL','1','Gupta','Sandeep','','','','34','277827610','2450 UNDERHILL RD',0,'OTTAWA HILLS','OH','43615','2332','CY','39095','1983-12-21','M','R',':RET:2029-7','N','021','HLT','3948896','92036OH004002601','2014-04-01','2014-03-04 15:10:58','0.00',NULL,NULL,'438.08','438.08','R-OH001','OH0','177.96',NULL,0,'2014-03-04 21:02:31'),(27695,21903,'Y','18','021','EC','A','','','AC','0000688431','0000688431','TX00003080571','31','1','RODRIGUEZ','MARLINDA','O','','','34','462492184','P O BOX 13179',0,'PORT ISABEL','TX','78578',NULL,'CY','48061','1966-01-26','F','M',':RET:2106-3','N','021','DEN','3408659','33348TX002000201','2014-04-01','2014-03-05 11:41:46','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-05 21:30:46'),(28489,22542,'Y','18','021','EC','A','','','AC','0000034446','0000034446','OH00003779517','IL','1','GREEN','TANGER','','','','34','298602459','845 BLUM ST',0,'TOLEDO','OH','43607','4202','CY','39095','1963-06-16','F','U',':RET:2054-5','N','021','DEN','3937331','99734OH005000301','2014-04-01','2014-03-07 17:23:27','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-07 21:31:40'),(28869,22847,'Y','18','021','EC','A','','','AC','0000284392','0000284392','TX00002871500','31','1','harris','michael','','','','34','461064935','po box 251',0,'waelder','TX','78959',NULL,'CY','48177','1956-01-09','M','U',':RET:2106-3','N','021','DEN','3524902','33348TX002000201','2014-04-01','2014-03-09 20:13:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:01'),(7584,5999,'Y','18','024','14','A','','','TE','0001228033','0001228033','','IL','1','Kishel','Susan','Marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-01','F','',NULL,NULL,NULL,'','380668','','2013-12-15','2013-12-15 16:11:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:34:01'),(21942,17522,'Y','18','021','EC','A','','','AC','0001146181','0001146181','TX00001517015','IL','1','Lewis','Barbara','','','','34','455824559','4475 MADDOX ST',0,'BEAUMONT','TX','77705','4009','CY','48245','1949-03-25','F','U',':RET:2054-5','N','021','DEN','3734231','33348TX002000201','2014-03-01','2014-02-07 16:35:00','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-02-07 19:00:15'),(7553,5978,'Y','18','021','EC','A','','','AC','0000869266','0000869266','OH00001252850','IL','1','Maxwell','Robert','','','','34','297665332','1258 RANDOLPH RD',0,'MOGADORE','OH','44260','9741','CY','39133','1965-09-07','M','M',':RET:2106-3','T','021','HLT','692542','52664OH152000901','2014-01-01','2013-12-14 21:41:41','413.00',NULL,NULL,'574.18','161.18','R-OH012','OH0','307.12',NULL,0,'2013-12-26 02:33:17'),(7172,5687,'Y','18','021','EC','A','','','AC','0001227031','0001227031','OH00000048625','IL','1','Scott','Michelle','','','','34','274746126','1511 ADDINGTON RD',0,'TOLEDO','OH','43607','1706','CY','39095','1962-05-25','F','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','HLT','1933945','92036OH002002601','2014-02-01','2013-12-25 15:10:41','0.00',NULL,NULL,'419.99','419.99','R-OH001','OH0','419.99',NULL,0,'2013-12-26 01:52:44'),(16822,13455,'Y','18','021','EC','A','','','AC','0001551845','0001551845','LA00001846237','IL','1','Street','Tony','','','Jr','34','428615622','405 West 17th avenue',0,'Covington','LA','70433',NULL,'CY','22103','1987-05-28','M','U',':RET:2106-3','N','021','DEN','1453426','18575LA002000201','2014-02-01','2014-01-10 20:57:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:18:23'),(15723,12576,'N','19','021','EC','A',NULL,NULL,'','0001128010','0000101444','','IL','1','Jamison','William','','','','34','301113459','160 HICKORY HILLS DR',0,'SPRINGBORO','OH','45066','8625','CY','39165','2006-07-30','M','',':RET:2106-3','N','021','DEN','1945838','99734OH005000301','2014-02-01','2014-01-02 14:21:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-03 02:00:14'),(3779,3027,'Y','18','021','EC','A','','','AC','0000689675','0000689675','OH00000654177','IL','1','Fahnestock','Christy','','','','34','296765921','315 South Enterprise',0,'Bowling Green','OH','43402',NULL,'CY','39173','1978-12-31','F','U',':RET:2106-3','T','021','DEN','408501','99734OH005000301','2014-01-01','2013-12-12 20:40:19','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 21:33:56'),(6961,5526,'Y','18','021','EC','A','','','AC','0000972745','0000972745','OH00001435845','IL','1','Jackson','Tanisha','','','','34','283840311','7176 LAVENDER LN',0,'LEWIS CENTER','OH','43035','8146','CY','39041','1981-05-30','F','U',':RET:2054-5','N','021','DEN','2601722','99734OH005000401','2014-01-01','2013-12-24 22:20:49','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:15'),(3456,2779,'N','01','021','EC','A',NULL,NULL,'','0001024271','0000713632','','IL','1','Baker','Joseph','Anthony','','','34','268884095','752 WILTSHIRE RD',0,'COLUMBUS','OH','43204','2337','CY','39049','1978-06-13','M','',':RET:2106-3','N','021','DEN','1903279','99734OH005000401','2014-01-01','2013-12-21 23:10:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:19:39'),(24678,19587,'Y','18','021','EC','A','','','AC','0000178090','0000178090','TX00002916522','IL','1','Murphree','Shelly','','','','34','459813320','333 COUNTY ROAD 2592',0,'SHELBYVILLE','TX','75973','2615','CY','48419','1971-12-11','F','U',':RET:2106-3','N','021','DEN','3720135','33348TX002000101','2014-04-01','2014-02-18 21:01:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:29:16'),(26336,20895,'Y','18','024','14','A','','','TE','0000142878','0000142878','','IL','1','Green','Ken',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-07','M','',NULL,NULL,NULL,'','3467019','','2014-02-27','2014-02-27 10:53:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:31:42'),(27319,21631,'Y','18','021','EC','A','','','AC','0001193021','0001193021','TX00002605410','IL','1','Polanco','Juan','M','','','34','460395047','3247 SAL BERROTERAN DR',0,'EL PASO','TX','79936','2605','CY','48141','1961-01-15','M','R',':RET:2106-3','N','021','DEN','3887044','33348TX002000201','2014-04-01','2014-03-04 15:55:16','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-04 21:00:45'),(27485,21750,'Y','18','021','EC','A','','','AC','0000869345','0000869345','OH00003588758','IL','1','MARSHALL','PATRICIA','N','','','34','285586147','728 WOOSTER RD N',0,'BARBERTON','OH','44203',NULL,'CY','39153','1956-11-16','F','U',':RET:2106-3','N','021','HLT','3978599','52664OH151001304','2014-04-01','2014-03-04 09:03:31','313.00',NULL,NULL,'543.47','230.47','R-OH012','OH0','543.47',NULL,0,'2014-03-04 21:02:20'),(13579,10830,'Y','18','021','EC','A','','','AC','0002382401','0002382401','LA00000153367','IL','1','Abrams','Eve','','','','34','212686447','1028 Montegut Street',0,'New Orleans','LA','70117',NULL,'CY','22071','1971-03-27','F','M',':RET:2106-3','N','021','DEN','2341463','18575LA002000201','2014-01-01','2013-12-23 18:15:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:51'),(23334,18598,'Y','18','021','EC','A','','','AC','0001117296','0001117296','OH00001759317','IL','1','Kelly','Jamaal','','','','34','274784022','1881 EDGEWATER DR',0,'CINCINNATI','OH','45240','1515','CY','39061','1981-05-21','M','U',':RET:2054-5','N','021','DEN','2744418','99734OH005000301','2014-03-01','2014-02-13 16:35:06','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:32'),(14890,11892,'Y','18','021','EC','A','','','AC','0001370233','0001370233','LA00000547122','IL','1','tran','chi','','','','34','241874511','941 W MONTEREY CT',0,'GRETNA','LA','70056','4675','CY','22051','1966-05-03','F','U',':RET:2047-9','N','021','DEN','1763286','18575LA002000201','2014-02-01','2013-12-28 21:38:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:45'),(15309,12242,'Y','18','021','EC','A','','','AC','0002090686','0002090686','LA00000431200','IL','1','FAZENDE','Jennifer','','','','34','433774979','813 BREANON ST',0,'METAIRIE','LA','70001','4923','CY','22051','1987-10-12','F','U',':RET:2106-3','T','021','DEN','2251745','18575LA002000201','2014-02-01','2014-01-01 17:36:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:23:08'),(20339,16242,'Y','18','021','EC','A','','','AC','0001799647','0001799647','LA00001862575','IL','1','Fazzio','Patricia','','','','34','434968431','613 LEGENDRE DR',0,'SLIDELL','LA','70460','3427','CY','22103','1955-10-19','F','M',':RET:2106-3','N','021','DEN','2657237','18575LA002000101','2014-03-01','2014-01-28 17:37:58','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-01-28 21:01:07'),(17945,14338,'N','19','021','EC','A',NULL,NULL,'','0000608795','0000518005','','IL','1','Rayas','Victor','James','','','34','449939410','1722 Socorro',0,'San Antonio','TX','78214',NULL,'CY','48029','1987-07-14','M','',':RET:2106-3','N','021','DEN','2008634','33348TX002000201','2014-02-01','2014-01-14 16:01:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:41'),(17090,13678,'Y','18','024','14','A','','','TE','0001123525','0001123525','','IL','1','Crenshaw','Shovon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-07-12','F','',NULL,NULL,NULL,'','2244613','','2014-01-08','2014-01-08 14:50:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:21:27'),(23619,18811,'N','19','021','EC','A',NULL,NULL,'','0000024155','0000929888','','IL','1','Schmidt','John','M','','','34','288080981','15 FARMVIEW CT',0,'HARRISON','OH','45030','2013','CY','39061','2003-08-31','M','',':RET:2106-3','N','021','HLT','3274336','92036OH004001201','2014-03-01','2014-02-13 15:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-13 22:03:17'),(26041,20653,'Y','18','021','EC','A','','','AC','0000194050','0000194050','OH00002516675','IL','1','TAYLOR','KATHLEEN','','','','34','277801472','417 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','1981-07-24','F','M',NULL,'N','021','HLT','2864760','52664OH151001304','2014-03-01','2014-02-26 14:38:28','352.00',NULL,NULL,'658.54','306.54','R-OH012','OH0','263.82',NULL,0,'2014-02-26 21:02:27'),(15233,12175,'Y','18','024','14','A','','','TE','0001046845','0001046845','','IL','1','Smith','Mitchell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-28','M','',NULL,NULL,NULL,'','1406838','','2013-12-30','2013-12-30 01:41:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:08:20'),(16323,13068,'Y','18','024','14','A','','','TE','0001548248','0001548248','','IL','1','nguyen','no',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-10-02','M','',NULL,NULL,NULL,'','2353135','','2014-01-06','2014-01-06 16:56:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-07 04:01:44'),(27530,21780,'Y','18','024','14','A','','','TE','0000536992','0000536992','','IL','1','Peterson','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-06-18','M','',NULL,NULL,NULL,'','3477579','','2014-03-04','2014-03-04 16:39:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:46'),(8944,7092,'Y','18','021','EC','A','','','AC','0001258644','0001258644','OH00000899879','IL','1','Brown','Carol',NULL,NULL,NULL,NULL,NULL,'4221 ARDMORE AVE',0,'CLEVELAND','OH','44109','3913','CY','39035','1953-09-09','F','U',NULL,'N','021','DEN','2342284','99734OH005000401','2014-01-01','2013-12-18 10:56:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:24'),(21901,17489,'N','01','021','EC','A',NULL,NULL,'','0000412247','0000396200','','IL','1','Fox','Charles','L','','','34','425633171','21409 MONTICELLO SPENCERVILL RD',0,'SPENCERVILLE','OH','45887','9022','CY','39161','1976-08-22','M','',':RET:2106-3','N','021','HLT','3013219','92036OH005001506','2014-03-01','2014-02-06 14:35:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.46',NULL,0,'2014-02-06 21:01:47'),(4014,3206,'N','01','021','EC','A',NULL,NULL,'','0000817528','0000418882','','IL','1','SPENCE','ALEESHA','','','','34','363060082','741 RIDGEWOOD AVE',0,'HAMILTON','OH','45013','3201','CY','39017','1980-02-20','F','',':RET:2106-3','N','021','DEN','2371668','99734OH005000401','2014-01-01','2013-12-17 01:42:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:45:30'),(8056,6379,'Y','18','021','EC','A','','','AC','0000964721','0000964721','MI00000399668','IL','1','WARSAW','STACY','','','','34','366547546','UNION N EAST',0,'GRAND RAPIDS','MI','45459',NULL,'CY','39057','1959-01-25','F','U',':RET:2106-3','N','021','HLT','2231794','92036OH006000501','2014-01-01','2013-12-20 13:21:17','271.00',NULL,NULL,'402.48','131.48','R-OH003','MI0','402.48',NULL,0,'2013-12-26 03:09:51'),(21170,16918,'Y','18','024','14','A','','','TE','0001165319','0001165319','','IL','1','Anaya','Maura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-05-22','F','',NULL,NULL,NULL,'','210262','','2014-02-03','2014-02-03 14:22:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:00:38'),(7948,6288,'Y','18','024','14','A','','','TE','0001936871','0001936871','','IL','1','PERRY','IVY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-05-08','F','',NULL,NULL,NULL,'','1634409','','2013-12-20','2013-12-20 17:20:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 03:07:05'),(17639,14100,'Y','18','021','EC','A','','','AC','0000997774','0000997774','OH00001697682','IL','1','Mullin','Jeffrey','','','','34','279702994','450 E CENTER ST',0,'GERMANTOWN','OH','45327','1449','CY','39113','1963-11-05','M','M',':RET:2106-3','N','021','DEN','2452146','99734OH005000301','2014-02-01','2014-01-12 23:49:26','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-14 01:32:36'),(4682,3711,'Y','18','021','EC','A','','','AC','0000423034','0000423034','LA00000654168','IL','1','CANIZALES','REINA','','','','34','127461291','4080 PAIGE JANETTE DRIVE',0,'HARVEY','LA','70058',NULL,'CY','22051','1955-02-26','F','U',NULL,'N','021','DEN','1089369','18575LA002000201','2014-01-01','2013-12-12 17:02:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:07:55'),(13205,10537,'N','01','021','EC','A',NULL,NULL,'','0000946796','0000592109','','IL','1','Kemper','LeAnn','','','','34','488660519','6605 RIVERHILL DR',0,'PLANO','TX','75024','7437','CY','48121','1957-02-16','F','',':RET:2106-3','N','021','DEN','2425449','33348TX002000101','2014-01-01','2013-12-23 17:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 12:55:04'),(15843,12686,'Y','18','021','EC','A','','','AC','0000381149','0000381149','OH00001519997','IL','1','Ramun','David','','','','34','274585969','776 east wood st.',0,'lowellville','OH','44436',NULL,'CY','39099','1956-12-04','M','U',':RET:2106-3','T','021','DEN','1454459','99734OH005000401','2014-02-01','2014-01-02 15:48:36','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-03 02:04:12'),(13237,10562,'Y','18','021','EC','A','','','AC','0000146853','0000146853','TX00000440320','IL','1','washburn','charlet','ann','','','34','455063849','610 GROVE CT',0,'LONGVIEW','TX','75601','5908','CY','48203','1952-10-19','F','M',':RET:2106-3','N','021','DEN','2145882','33348TX002000201','2014-01-01','2013-12-22 23:18:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:55:57'),(25816,20471,'N','19','021','EC','A',NULL,NULL,'','0000003628','0001002221','','IL','1','MIKLOS','KENDALL','','','','34','292082872','12760 CARTER RD',0,'PAINESVILLE','OH','44077','9790','CY','39085','2004-01-22','F','',NULL,'N','021','DEN','3115883','99734OH005000301','2014-03-01','2014-02-26 14:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:24'),(26010,20629,'Y','18','021','EC','A','','','AC','0000026667','0000026667','OH00003390688','IL','1','COWAN','JOSHUA','','','','34','269967480','24 N KNIFFIN ST',0,'GREENWICH','OH','44837','1125','CY','39077','1993-01-25','M','U',NULL,'N','021','HLT','3162712','92036OH005002706','2014-03-01','2014-02-26 15:13:01','134.00',NULL,NULL,'194.99','60.99','R-OH006','OH0','194.99',NULL,0,'2014-02-26 21:02:09'),(1594,1332,'Y','18','021','EC','A','','','AC','0001230762','0001230762','TX00001380041','IL','1','Thompson','William','Blaine','','','34','453753931','20236 FM 1804',0,'LINDALE','TX','75771','4227','CY','48423','1972-08-03','M','M',':RET:2106-3','N','021','DEN','1410642','33348TX002000201','2014-01-01','2013-12-24 12:08:01','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-25 18:51:51'),(9483,7520,'Y','18','021','EC','A','','','AC','0000159412','0000159412','OH00000095597','IL','1','Arthur','Chad','','','','34','298602070','7546 Cutters Edge Court',0,'dublin','OH','43016',NULL,'CY','39049','1977-09-06','M','U',':RET:2106-3','N','021','DEN','1587715','99734OH005000401','2014-01-01','2013-12-21 12:33:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:34:41'),(23770,18915,'N','19','021','EC','A',NULL,NULL,'','0001070521','0000242752','','IL','1','Record','Nathan','Campbell','','','34','295966075','6214 Robison Road',0,'Cincinnati','OH','45213',NULL,'CY','39061','1994-01-07','M','',':RET:2106-3','N','021','DEN','3685676','99734OH005000301','2014-03-01','2014-02-14 17:10:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:13'),(23453,18683,'Y','18','021','EC','A','','','AC','0001113287','0001113287','TX00002042937','IL','1','Armstrong','Micheal','','','','34','464907801','709 STAIN GLASS DR',0,'DESOTO','TX','75115','6057','CY','48113','1954-08-21','M','M',':RET:2054-5','T','021','DEN','3416683','33348TX002000201','2014-03-01','2014-02-13 13:50:01','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:39'),(23273,18553,'Y','18','021','EC','A','','','AC','0000582236','0000582236','MS00002549308','IL','1','Bradberry','Barton',NULL,NULL,NULL,NULL,NULL,'63 BOB CHEEKS RD',0,'ELLISVILLE','MS','39437','8600','CY','28067','1965-04-22','M','U',NULL,'T','021','DEN','3175655','46300MS002000101','2014-03-01','2014-02-13 11:38:19','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15','CIC',0,'2014-02-13 21:30:13'),(22999,18336,'N','17','021','EC','A',NULL,NULL,'','0001078938','0000881673','','IL','1','Campbell','Alyssa','','','','34','042900355','7154 YOUNGSTOWN SALEM RD',0,'CANFIELD','OH','44406','8422','CY','39099','1992-03-12','F','',':RET:2106-3','N','021','DEN','3426568','99734OH005000301','2014-03-01','2014-02-12 12:47:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:18'),(2985,2401,'N','01','021','EC','A',NULL,NULL,'','0000664151','0001015546','','IL','1','Krebs','Valdis','E','','','34','299545709','3416 HIGLEY RD',0,'ROCKY RIVER','OH','44116','3835','CY','39035','1953-12-11','M','',':RET:2106-3','N','021','DEN','471488','99734OH005000301','2014-01-01','2013-12-06 08:57:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:16'),(13564,10817,'Y','18','021','EC','A','','','AC','0001810938','0001810938','LA00000164597','IL','1','Taylor','Cheryl','','','','34','438028042','345 APPLE ST',0,'NORCO','LA','70079','2343','CY','22089','1957-10-02','F','U',':RET:2106-3','N','021','DEN','2339969','18575LA002000201','2014-01-01','2013-12-23 16:21:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:26'),(13695,10926,'Y','18','024','14','A','','','TE','0001258640','0001258640','','IL','1','MARTIN','GAYLE','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-16','F','',NULL,NULL,NULL,'','1411108','','2013-12-23','2013-12-23 11:43:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:08:31'),(19760,15752,'Y','18','021','EC','A','','','AC','0000897014','0000897014','OH00002374801','IL','1','RODGERS','RONALD','','','','34','283565831','16221 PARKGROVE AVE',0,'CLEVELAND','OH','44110','1516','CY','39035','1956-01-06','M','U',':RET:2054-5','T','021','DEN','3143974','99734OH005000301','2014-03-01','2014-01-23 15:42:09','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-23 21:01:23'),(28461,22520,'N','01','021','EC','A',NULL,NULL,'','0001711449','0001957149','','IL','1','Robin','Michael','J','','','34','437259917','4032 DARA BETH RD',0,'YOUNGSVILLE','LA','70592','6237','CY','22113','1963-11-08','M','',':RET:2106-3','N','021','DEN','3438860','18575LA002000201','2014-04-01','2014-03-07 15:37:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-07 21:31:25'),(691,569,'Y','18','021','EC','A','','','AC','0000974069','0000974069','OH00000482437','IL','1','Byers','Chrisann','','','','34','287504151','337 HOOVER RD',0,'VINCENT','OH','45784','5630','CY','39167','1949-12-28','F','M',':RET:2106-3','N','021','DEN','2529334','99734OH005000301','2014-01-01','2013-12-16 14:59:46','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 18:02:38'),(21582,17240,'Y','18','021','EC','A','','','AC','0000894659','0000894659','OH00001570832','IL','1','Miller','Angela','','','','34','277822586','1962 AUTEN DR',0,'AKRON','OH','44320','1139','CY','39153','1974-11-22','F','U',':RET:2106-3','N','021','HLT','3427620','52664OH151001305','2014-03-01','2014-02-05 16:13:50','152.00',NULL,NULL,'281.44','129.44','R-OH012','OH0','281.44',NULL,0,'2014-02-05 21:30:26'),(21227,16963,'Y','18','024','14','A','','','TE','0000506993','0000506993','','IL','1','Stegall','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-13','F','',NULL,NULL,NULL,'','2378030','','2014-02-03','2014-02-03 09:17:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:07'),(7161,5680,'Y','18','021','EC','A','','','AC','0000669188','0000669188','OH00000994189','IL','1','Christoff','Donald','','','','34','301467074','155 EAGLES PT W',0,'LIMA','OH','45805','2849','CY','39003','1949-06-16','M','U',':RET:2106-3','N','021','HLT','1391619','92036OH002001501','2014-01-01','2013-12-24 21:13:17','532.00',NULL,NULL,'762.47','230.47','R-OH002','OH0','762.47',NULL,0,'2013-12-26 01:52:28'),(21048,16817,'Y','18','021','EC','A','','','AC','0000820734','0000820734','TX00002202516','IL','1','Abraham','Achamma','','','','34','354705366','2703 ORCHID DR',0,'RICHARDSON','TX','75082','3469','CY','48085','1950-01-30','F','M',':RET:2029-7','N','021','DEN','2801103','33348TX002000201','2014-03-01','2014-02-01 22:16:21','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-02 19:00:04'),(21000,16779,'Y','18','021','EC','A','','','AC','0000975270','0000975270','OH00001919634','IL','1','tincher','krystal','','','','34','279804799','98 CEDAR CT',0,'LONDON','OH','43140','9487','CY','39097','1982-08-17','F','U',':RET:2106-3','T','021','DEN','3098120','99734OH005000301','2014-03-01','2014-02-01 16:03:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:28'),(20736,16569,'Y','18','021','EC','A','','','AC','0000977970','0000977970','OH00002399994','IL','1','koons','amy',NULL,NULL,NULL,NULL,NULL,'327 MORROW ST',0,'GREENVILLE','OH','45331','1836','CY','39037','1975-08-24','F','M',':RET:2106-3','N','021','HLT','3040152','92036OH005000501','2014-03-01','2014-01-29 20:36:52','447.00',NULL,NULL,'907.60','460.60','R-OH003','OH0','296.20',NULL,0,'2014-01-30 21:01:21'),(1167,963,'Y','18','021','EC','A','','','AC','0000050834','0000050834','LA00000029713','IL','1','Taylor','Rachel','Elaine','','','34','437134619','12223 villa park drive',0,'Geismar','LA','70734',NULL,'CY','22005','1962-04-28','F','M',':RET:2054-5','N','021','DEN','718551','18575LA002000201','2014-01-01','2013-12-03 17:31:36','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:19:04'),(1579,1318,'Y','18','021','EC','A','','','AC','0000001133','0000001133','TX00001435777','IL','1','Leija','Terry','Carmona','','','34','467176752','1701 W MESA PARK DR',0,'ROUND ROCK','TX','78664','3157','CY','48491','1963-05-15','F','M',':RET:2106-3','N','021','DEN','1633491','33348TX002000201','2014-01-01','2013-12-24 10:32:00','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:51:23'),(2481,2020,'Y','18','021','EC','A','','','AC','0001028649','0001028649','LA00000059657','IL','1','bruneau','thomas','','','','34','047767173','3720 DAUTERIVE DR',0,'CHALMETTE','LA','70043','1404','CY','22087','1968-05-08','M','U',':RET:2106-3','N','021','DEN','1246822','18575LA002000201','2014-01-01','2013-12-09 14:13:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:31'),(13936,11116,'Y','18','021','EC','A','','','AC','0000697914','0000697914','OH00000059172','IL','1','Strange','Connie','','','','34','376585342','236 CRIM ST',0,'BOWLING GREEN','OH','43402','3221','CY','39173','1952-05-22','F','M',':RET:2106-3','N','021','HLT','1423488','92036OH004002601','2014-01-01','2013-12-23 14:50:27','305.00',NULL,NULL,'440.60','135.60','R-OH001','OH0','440.60',NULL,0,'2013-12-26 13:14:38'),(26154,20737,'Y','18','024','14','A','','','TE','0000991521','0000991521','','IL','1','Rathfelder','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-11-08','F','',NULL,NULL,NULL,'','1406191','','2014-03-14','2014-02-27 15:18:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 06:30:30'),(757,625,'Y','18','021','EC','A','','','AC','0000714646','0000714646','TX00000856770','IL','1','Kinnibrugh','Karen','','','','34','454154455','435 HILL COUNTY ROAD 4254',0,'ITASCA','TX','76055','5516','CY','48217','1956-04-30','F','U',':RET:2106-3','N','021','DEN','1586279','33348TX002000201','2014-01-01','2013-12-16 11:09:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:27'),(23054,18381,'Y','18','021','EC','A','','','AC','0002082239','0002082239','LA00002588693','IL','1','Hatton','Nicholas','','','','34','305087779','111 SUWANEE RD',0,'LAFAYETTE','LA','70503','6111','CY','22055','1986-02-12','M','U',':RET:2106-3','N','021','DEN','3719941','18575LA002000201','2014-03-01','2014-02-11 20:48:57','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-12 21:30:47'),(22576,18031,'Y','18','021','EC','A','','','AC','0000844739','0000844739','OH00001442563','IL','1','munz','julie','','','','34','276780155','4 CHOCTAW LN',0,'MILFORD','OH','45150','1604','CY','39025','1965-08-21','F','M',':RET:2106-3','N','021','HLT','3810767','92036OH005000604','2014-03-01','2014-02-10 14:06:09','382.00',NULL,NULL,'686.53','304.53','R-OH005','OH0','350.99',NULL,0,'2014-02-10 21:32:00'),(20825,16644,'Y','18','021','EC','A','','','AC','0001658415','0001658415','LA00002472691','IL','1','Ictech','Gaye','carmen','','','34','434578346','3612 MEADOW LAKE DR W',0,'SLIDELL','LA','70461','5559','CY','22103','1973-04-17','F','U',':RET:2106-3','T','021','DEN','2150392','18575LA002000201','2014-03-01','2014-01-31 14:57:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:38'),(3957,3167,'Y','18','021','EC','A','','','AC','0000357174','0000357174','OH00000745886','IL','1','BENSON','CYNTHIA','LOUISE','','','34','301460281','1105 7TH AVE',0,'AKRON','OH','44306','1727','CY','39153','1949-03-13','F','U',':RET:2054-5','N','021','HLT','842615','52664OH151001501','2014-01-01','2013-12-13 10:52:47','507.00',NULL,NULL,'802.40','295.40','R-OH012','OH0','802.38',NULL,0,'2013-12-25 21:38:19'),(20028,15972,'Y','18','021','EC','A','','','AC','0001679957','0001679957','LA00001454327','IL','1','alonzo','angel','','','','34','438250899','1201 west esplanade ave.',0,'kenner','LA','70065',NULL,'CY','22051','1958-02-15','M','M',NULL,'N','021','DEN','2568899','18575LA002000201','2014-03-01','2014-01-26 13:46:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-26 19:00:18'),(6735,5342,'N','01','021','EC','A',NULL,NULL,'','0000849408','0000413324','','IL','1','Truong','Hai','Thanh','','','34','278151679','5708 Brandtmanor Dr',0,'Cincinnati','OH','45248',NULL,'CY','39061','1975-03-31','M','',':RET:2047-9','N','021','DEN','178456','99734OH005000401','2014-01-01','2013-11-25 12:38:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:15:36'),(4723,3743,'N','01','021','EC','A',NULL,NULL,'','0000021366','0000946084','','IL','1','Koosed','Paige','','','','34','296446184','24259 W RIVER RD',0,'PERRYSBURG','OH','43551','9476','CY','39173','1951-06-10','F','',':RET:2106-3','N','021','HLT','299498','92036OH003002601','2014-01-01','2013-12-12 13:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','585.04',NULL,0,'2013-12-25 22:09:00'),(13751,10976,'Y','18','021','EC','A','','','AC','0001105531','0001105531','OH00000275715','IL','1','Lambert','Jerry','','','','34','276842272','605 E. Pearl St.',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1974-04-09','M','M',':RET:2106-3','T','021','HLT','1781710','92036OH004001501','2014-01-01','2013-12-23 14:04:37','297.00',NULL,NULL,'507.15','210.15','R-OH002','OH0','256.83',NULL,0,'2013-12-26 13:09:56'),(18808,14981,'Y','18','021','EC','A','','','AC','0001184909','0001184909','OH00001928705','IL','1','Boring','John','','','','34','288608799','730 W Portage Tr Ext',0,'Akron','OH','44313',NULL,'CY','39153','1961-11-12','M','M',':RET:2106-3','T','021','DEN','1905335','99734OH005000401','2014-03-01','2014-01-16 16:39:09','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:36:02'),(18037,14409,'Y','18','021','EC','A','','','AC','0001240578','0001240578','OH00002426340','IL','1','Cho','Myung','','','','34','223396249','8023 Rainey Rd',0,'Waynesville','OH','45068',NULL,'CY','39165','1951-10-08','F','M',':RET:2040-4','N','021','DEN','2077731','99734OH005000301','2014-02-01','2014-01-14 18:34:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:07:10'),(13970,11134,'N','01','021','EC','A',NULL,NULL,'','0001062113','0000566618','','IL','1','Homer','Jessie','','','','34','291901276','309 RICE ST',0,'ELMORE','OH','43416','9404','CY','39123','1982-03-14','F','',':RET:2106-3','N','021','HLT','2570566','92036OH002002701','2014-01-01','2013-12-22 23:36:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','261.00',NULL,0,'2013-12-26 13:15:22'),(24869,19719,'Y','18','021','EC','A','','','AC','0000227044','0000227044','OH00002006759','IL','1','Oliver','Tenola','C','','','34','296605213','23 S WILLIAMS ST',0,'DAYTON','OH','45402','8236','CY','39113','1975-06-19','F','M',':RET:2054-5','N','021','DEN','3718664','99734OH005000401','2014-03-01','2014-02-19 09:53:50','0.00',NULL,NULL,'71.95','71.95','R-OH003','OH0','0.00','CIC',0,'2014-02-20 05:32:52'),(5792,4600,'Y','18','021','EC','A','','','AC','0000209634','0000209634','OH00000955624','IL','1','Lange','Nancy','','','','34','283486985','2715 Silver Springs Dr',0,'Norton','OH','44203',NULL,'CY','39153','1950-02-02','F','U',':RET:2106-3','N','021','DEN','1464897','99734OH005000401','2014-01-01','2013-12-24 01:19:26','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:47:17'),(23776,18919,'Y','18','021','EC','A','','','AC','0000197712','0000197712','MS00001704838','IL','1','Cleaves','Regina','','','','34','461817740','507 MAIN ST',0,'BAY SAINT LOUIS','MS','39520','2705','CY','28045','1980-11-22','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','2934667','46300MS002000201','2014-03-01','2014-02-13 22:25:09','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-14 21:31:16'),(7541,5967,'Y','18','021','EC','A','','','AC','0000226842','0000226842','TX00000787229','IL','1','Van Overborg','Shelly','L','','','34','449713840','11303 Vance Jackson',0,'San Antonio','TX','78230',NULL,'CY','48029','1978-05-19','F','U',NULL,'N','021','DEN','1075001','33348TX002000201','2014-01-01','2013-12-15 14:14:30','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 02:32:54'),(9115,7231,'N','01','021','EC','A',NULL,NULL,'','0000796947','0000055905','','IL','1','Sand','Cynthia','','','','34','271489368','25685 RUSTIC LN',0,'WESTLAKE','OH','44145','5474','CY','39035','1949-10-11','F','',':RET:2106-3','N','021','DEN','2298205','99734OH005000301','2014-01-01','2013-12-18 16:47:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:38'),(7428,5878,'N','01','021','EC','A',NULL,NULL,'','0001097761','0000652097','','IL','1','Preto','Robert','Edward','','','34','286629150','1206 WEISER AVE',0,'AKRON','OH','44314','1429','CY','39153','1957-08-24','M','',':RET:2106-3','N','021','HLT','1046499','52664OH151001306','2014-01-01','2013-12-14 18:14:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-26 02:30:04'),(729,604,'Y','18','021','EC','A','','','AC','0000494351','0000494351','TX00000966086','IL','1','ANGUS','MICHELLE','','','','34','231903618','408 KIOWA ST',0,'LAKE KIOWA','TX','76240',NULL,'CY','48097','1970-07-11','F','U',':RET:2106-3','N','021','DEN','2448210','33348TX002000101','2014-01-01','2013-12-16 17:13:34','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:03:44'),(22394,17881,'Y','18','021','EC','A','','','AC','0000455343','0000455343','OH00002306374','IL','1','Curtis','Linda','','','','34','302447351','3432 ATTERBURY ST',0,'CUYAHOGA FALLS','OH','44221','1116','CY','39153','1953-03-05','F','U',':RET:2106-3','N','021','HLT','3119427','52664OH151001301','2014-03-01','2014-02-10 13:33:51','349.00',NULL,NULL,'605.24','256.24','R-OH012','OH0','605.24',NULL,0,'2014-02-10 21:30:17'),(21750,17369,'Y','18','021','EC','A','','','AC','0000612461','0000612461','TX00001818021','IL','1','Belcher','John','','','','34','464596587','1659 MCGREGOR AVE',0,'WICHITA FALLS','TX','76301','5720','CY','48485','1980-08-15','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3215425','33348TX002000201','2014-03-01','2014-02-05 19:31:34','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-06 21:00:20'),(8915,7071,'Y','18','021','EC','A','','','AC','0000340275','0000340275','OH00001214424','IL','1','Thompson','Melissa','','','','34','284861505','707 CARTER CT',0,'OXFORD','OH','45056','1098','CY','39017','1974-04-19','F','M',':RET:2106-3','T','021','DEN','1532756','99734OH005000401','2014-01-01','2013-12-18 00:23:47','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:02:40'),(6626,5254,'N','01','021','EC','A',NULL,NULL,'','0001084123','0000575894','','IL','1','Shipley','Hattie','','','','34','283504337','5702 Angola Rd.',0,'Toledo','OH','43615',NULL,'CY','39095','1951-04-13','F','',':RET:2106-3','N','021','HLT','1125484','92036OH005002605','2014-01-01','2013-12-11 16:05:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','560.22',NULL,0,'2013-12-26 00:54:12'),(2596,2108,'Y','18','021','EC','A','','','AC','0000714938','0000714938','OH00000393789','IL','1','FRAUNFELTER','DEBORAH','','','','34','268682769','901 SELBY ST',0,'FINDLAY','OH','45840',NULL,'CY','39063','1959-05-01','F','U',':RET:2106-3','T','021','DEN','623173','99734OH005000401','2014-01-01','2013-12-01 19:51:50','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 19:45:11'),(15094,12064,'N','01','021','EC','A',NULL,NULL,'','0000025302','0000770004','','IL','1','Nguyen','Oanh','T','','','34','273114532','6756 WINDING CV',0,'CENTERVILLE','OH','45459','6913','CY','39113','1973-08-28','F','',':RET:2047-9','N','021','DEN','2260489','99734OH005000301','2014-02-01','2013-12-29 22:07:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:04:31'),(25687,20380,'Y','18','021','EC','A','','','AC','0001167154','0001167154','MS00003308361','IL','1','CARTER','SHEILA','','','','34','587160289','134 PINEHURST DR',0,'BRANDON','MS','39047','8231','CY','28121','1951-08-23','F','U',NULL,'N','021','DEN','2746998','46300MS002000201','2014-04-01','2014-02-24 16:19:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:09'),(26744,21195,'N','19','021','EC','A',NULL,NULL,'','0000992728','0000159470','','IL','1','Supe','Ryan','','','','34','295131704','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2008-03-21','M','',':RET:2106-3','N','021','HLT','3540690','92036OH003001205','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-28 21:31:56'),(198,164,'Y','18','021','EC','A','','','AC','0000656899','0000656899','OH00000476297','IL','1','Prock','Marie','','','','34','301467822','1204 SANDY LAKE RD',0,'RAVENNA','OH','44266','8201','CY','39133','1949-11-08','F','M',NULL,'N','021','HLT','18941','52664OH151001501','2014-01-01','2013-12-05 15:49:09','426.00',NULL,NULL,'802.38','376.38','R-OH012','OH0','802.38',NULL,0,'2013-12-25 17:20:06'),(21228,16964,'Y','18','021','EC','A','','','AC','0000817578','0000817578','OH00002353484','IL','1','Quigg','Qiana','','','','34','297601366','9 KENNYWOOD LN',0,'WEST CARROLLTON','OH','45449','2606','CY','39113','1977-09-14','F','U',':RET:2054-5','T','021','DEN','3509386','99734OH005000301','2014-03-01','2014-02-03 10:17:26','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-03 21:01:07'),(3294,2654,'N','01','021','EC','A',NULL,NULL,'','0000461933','0000983825','','IL','1','Lowell','Ginger','','','','34','595101380','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','1970-10-08','F','',':RET:2106-3','N','021','DEN','1417328','99734OH005000301','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:33'),(20459,16343,'Y','18','021','EC','A','','','AC','0000507008','0000507008','OH00001641813','IL','1','MILTON','KATHLEEN','','','','34','149508876','3310 E OVERLOOK RD',0,'CLEVELAND','OH','44118','2116','CY','39035','1968-11-29','F','U',NULL,'N','021','DEN','3202505','99734OH005000401','2014-03-01','2014-01-29 09:53:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:50'),(19989,15945,'Y','18','021','EC','A','','','AC','0002142112','0002142112','LA00002374821','IL','1','Thomas','Brandon','','','','34','438737018','2617 CERRITAS VIA',0,'HARVEY','LA','70058','2934','CY','22051','1988-11-25','M','U',':RET:2054-5','N','021','DEN','2037557','18575LA002000101','2014-03-01','2014-01-25 02:25:01','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-25 19:00:19'),(4986,3959,'N','19','021','EC','A',NULL,NULL,'','0000136048','0000733560','','IL','1','Marable','Devonte','K','','','34','277969690','352 Enos Loomis st',0,'Pataskala','OH','43062',NULL,'CY','39089','1993-01-26','M','',NULL,'N','021','DEN','667559','99734OH005000301','2014-01-01','2013-12-06 19:55:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:52'),(9419,7473,'Y','18','021','EC','A','','','AC','0000623645','0000623645','TX00000444070','IL','1','Brown','Jessica',NULL,NULL,NULL,NULL,NULL,'360 COUNTY ROAD 430',0,'STEPHENVILLE','TX','76401','7281','CY','48143','1986-07-03','F','M',':RET:2106-3','N','021','DEN','2309508','33348TX002000201','2014-01-01','2013-12-21 14:17:05','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:33:03'),(17556,14037,'Y','18','021','EC','A','','','AC','0000202912','0000202912','TX00002054549','IL','1','carrizales','Dustin','','','','34','634200464','12331 DANNY DR',0,'AUSTIN','TX','78759','3001','CY','48453','1987-03-31','M','U',':RET:2106-3','N','021','DEN','1671986','33348TX002000101','2014-02-01','2014-01-12 14:45:45','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-13 03:01:57'),(13141,10481,'Y','18','021','EC','A','','','AC','0000809675','0000809675','OH00001253318','IL','1','SANBORN','MICHAEL','ALAN','','','34','230847839','464 HENRY ST',0,'PAINESVILLE','OH','44077','4331','CY','39085','1956-01-14','M','M',NULL,'N','021','DEN','1364101','99734OH005000401','2014-01-01','2013-12-23 15:55:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:18'),(17019,13620,'N','19','021','EC','A',NULL,NULL,'','0000071658','0001138062','','S1','1','SABO','MARC','','','','34','285135720','3740 WYNDHAM RIDGE DR',0,'STOW','OH','44224','6152','CY','39153','2007-08-28','F','',':RET:2106-3','N','021','HLT','2109833','52664OH152000901','2014-02-01','2014-01-08 19:30:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:20:40'),(25160,19957,'N','01','021','EC','A',NULL,NULL,'','0001060038','0000926678','','IL','1','VEGA RIOS','CRUZ','','','','34','654264701','127 LA VISTA CIRCLE',0,'ELSA','TX','78543',NULL,'CY','48215','1981-11-08','M','',NULL,'N','021','DEN','2872056','33348TX002000201','2014-04-01','2014-02-21 17:18:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-21 22:00:22'),(25823,20475,'N','01','021','EC','A',NULL,NULL,'','0000960659','0000625480','','IL','1','Harty','Tia','Jean','','','34','287865590','65 SALEM DR',0,'SPRINGBORO','OH','45066','8138','CY','39165','1980-08-29','F','',':RET:2106-3','N','021','DEN','3552879','99734OH005000301','2014-04-01','2014-02-26 16:29:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:27'),(26181,20762,'Y','18','021','EC','A','','','AC','0000351624','0000351624','OH00002887504','IL','1','Adams','April','','','','34','281806726','1730 W ARCADIA AVE',0,'OBETZ','OH','43207','4408','CY','39049','1972-04-15','F','U',':RET:2106-3','N','021','DEN','3078913','99734OH005000301','2014-04-01','2014-02-26 20:17:02','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:40'),(26333,20892,'Y','18','021','EC','A','','','AC','0000256020','0000256020','OH00003209967','IL','1','LARRY','GLORIA','JEAN','','','34','281586857','1231 GREENWOOD AVE',0,'AKRON','OH','44320','3437','CY','39153','1950-10-04','F','M',':RET:2054-5','N','021','HLT','2753861','52664OH151001501','2014-05-01','2014-02-27 15:28:31','327.00',NULL,NULL,'789.56','462.56','R-OH012','OH0','789.56',NULL,0,'2014-02-28 06:31:41'),(26849,21280,'Y','18','021','EC','A','','','AC','0000435961','0000435961','MS00003247162','IL','1','Brennan','Al','','','','34','440660956','323 WILLOW RUN',0,'PEARL','MS','39208','8111','CY','28121','1970-05-25','M','M',NULL,'N','021','DEN','3386050','46300MS002000101','2014-04-01','2014-02-28 19:20:01','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-01 21:00:49'),(8162,6457,'Y','18','021','EC','A','','','AC','0000044228','0000044228','OH00000035658','IL','1','Weaver','Melissa','','','','34','299802009','306 E. Washington Street',0,'Pandora','OH','45877',NULL,'CY','39137','1982-12-24','F','U',':RET:2106-3','N','021','HLT','529774','92036OH003001505','2014-01-01','2013-11-22 09:09:48','196.00',NULL,NULL,'266.38','70.38','R-OH002','OH0','266.38',NULL,0,'2013-12-26 03:16:23'),(1988,1627,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','1244210','','2013-11-19','2013-11-19 23:05:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:53'),(7074,5613,'N','01','021','EC','A',NULL,NULL,'','0000566628','0000974095','','IL','1','Blair','Melissa','Dawn','','','34','291828461','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','1977-05-27','F','',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:07'),(3042,2444,'N','01','021','EC','A',NULL,NULL,'','0000664150','0000896958','','IL','1','Cook','Michael','','','Jr','34','300829276','533 EASTERN AVE',0,'ASHLAND','OH','44805','3324','CY','39005','1983-11-08','M','',':RET:2106-3','N','021','HLT','485239','52664OH152000901','2014-01-01','2013-12-05 22:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','185.39',NULL,0,'2013-12-25 20:18:40'),(20785,16607,'Y','18','021','EC','A','','','AC','0000620515','0000620515','TX00002161989','IL','1','alanis','vanessa','','','','34','450555132','3617 MONTANA AVE',0,'EL PASO','TX','79903','4322','CY','48141','1981-04-12','F','U',NULL,'N','021','DEN','2150378','33348TX002000201','2014-03-01','2014-01-30 21:43:30','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:12'),(3512,2821,'N','01','021','EC','A',NULL,NULL,'','0001098925','0001063626','','IL','1','Sutton','Lisa','Diane','','','34','414456744','350 NICKLAUS CV',0,'HERNANDO','MS','38632','6908','CY','28033','1983-10-07','F','',':RET:2106-3','N','021','DEN','1525295','46300MS002000201','2014-01-01','2013-12-21 19:53:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:21:02'),(19205,15300,'Y','18','021','EC','A','','','AC','0000265263','0000265263','OH00001843955','IL','1','Staruch','Joseph','','','','34','295746073','2777 LANCASHIRE RD',0,'CLEVELAND HEIGHTS','OH','44106','2575','CY','39035','1973-12-31','M','U',':RET:2106-3','T','021','HLT','2957443','52664OH151001304','2014-03-01','2014-01-20 16:34:35','61.00',NULL,NULL,'369.66','308.66','R-OH011','OH0','369.66',NULL,0,'2014-01-21 08:46:18'),(18664,14879,'Y','18','024','14','A','','','TE','0001116709','0001116709','','IL','1','CONSTANCIO','LOUIS','S',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-02-18','M','',NULL,NULL,NULL,'','2192775','','2014-01-16','2014-01-16 16:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:15'),(13972,11135,'N','01','021','EC','A',NULL,NULL,'','0000569311','0000159418','','IL','1','McIntosh','Holly','Elaine','','','34','288701321','4244 Huston Rd.',0,'Hamilton','OH','45013',NULL,'CY','39017','1968-05-20','F','',':RET:2106-3','T','021','HLT','2505527','92036OH004001201','2014-01-01','2013-12-22 23:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','286.65',NULL,0,'2013-12-26 13:15:25'),(17709,14152,'Y','18','021','EC','A','','','AC','0001705667','0001705667','LA00001543137','IL','1','Lafield','Walter','','','','34','438456667','13586 NEIL AVE',0,'BATON ROUGE','LA','70810','5137','CY','22033','1981-04-06','M','U',':RET:2106-3','N','021','DEN','2162158','18575LA002000201','2014-02-01','2014-01-13 15:45:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:09'),(26094,20695,'Y','18','021','EC','A','','','AC','0001330213','0001330213','LA00002880169','IL','1','VOELKER','HEIDI','','','','34','439882537','200 CHAPEL CRK',0,'MANDEVILLE','LA','70471','2590','CY','22103','1966-11-22','F','U',NULL,'N','021','DEN','3158246','18575LA002000201','2014-03-01','2014-02-27 13:14:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:10'),(8871,7034,'Y','18','021','EC','A','','','AC','0000428317','0000428317','TX00000930867','IL','1','Cordova','James','','','','34','463738589','10919 SOMBRA VERDE DR',0,'EL PASO','TX','79935','3708','CY','48141','1960-01-28','M','U',':RET:2106-3','N','021','DEN','2483116','33348TX002000201','2014-01-01','2013-12-18 14:12:53','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:01:34'),(8836,7004,'Y','18','021','EC','A','','','AC','0000145649','0000145649','TX00000474305','IL','1','casillas','janet','torres','','','34','462378262','5312 riviera',0,'wichita falls','TX','76310',NULL,'CY','48485','1964-01-10','F','M',NULL,'N','021','DEN','2134346','33348TX002000201','2014-01-01','2013-12-17 20:53:35','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-26 04:00:37'),(1036,850,'Y','18','021','EC','A','','','AC','0000314043','0000314043','TX00001105407','IL','1','Reyes','Leopoldo','','','','34','453902785','8704 BUENA PARK DR',0,'EL PASO','TX','79907','6206','CY','48141','1949-10-02','M','M',':RET:2106-3','N','021','DEN','1092930','33348TX002000201','2014-01-01','2013-12-03 15:14:58','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:15:38'),(6691,5303,'Y','18','021','EC','A','','','AC','0000179854','0000179854','OH00000925525','IL','1','seguin','anthony','','','','34','300648863','2130 W 80TH ST',0,'CLEVELAND','OH','44102','4159','CY','39035','1963-06-13','M','U',':RET:2106-3','N','021','DEN','943687','99734OH005000401','2014-01-01','2013-11-05 15:03:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:01:34'),(13139,10479,'Y','18','021','EC','A','','','AC','0001198112','0001198112','OH00000801887','IL','1','EVANS','KELLY','','','','34','277788113','363 BRITTAIN RD',0,'AKRON','OH','44305','3453','CY','39153','1970-03-26','F','M',NULL,'N','021','DEN','1430498','99734OH005000401','2014-01-01','2013-12-23 15:23:30','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:53:15'),(16776,13420,'Y','18','021','EC','A','','','AC','0000444927','0000444927','OH00002219449','IL','1','Buchenau','Brandi','','','','34','295861168','3880 MAGNOLIA DR',0,'AMELIA','OH','45102','1057','CY','39025','1981-01-31','F','U',':RET:2106-3','T','021','HLT','1578909','92036OH004000601','2014-02-01','2014-01-06 20:42:11','176.00',NULL,NULL,'237.80','61.80','R-OH005','OH0','237.80',NULL,0,'2014-01-08 18:25:04'),(17463,13965,'Y','18','021','EC','A','','','AC','0001182522','0001182522','OH00002266258','IL','1','Lester','Brian','','','','34','330809552','10348 Road I-10',0,'Ottawa','OH','45875',NULL,'CY','39137','1975-03-14','M','U',':RET:2106-3','N','021','HLT','1762316','92036OH004001501','2014-02-01','2014-01-10 17:25:55','165.00',NULL,NULL,'220.51','55.51','R-OH002','OH0','220.51',NULL,0,'2014-01-13 03:00:44'),(17962,14353,'Y','18','024','14','A','','','TE','0001163196','0001163196','','IL','1','Hooper','Ralph','Edward','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-01-28','M','',NULL,NULL,NULL,'','1528460','','2014-01-14','2014-01-14 18:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:46'),(25320,20087,'Y','18','021','EC','A','','','AC','0002093152','0002093152','LA00002265910','IL','1','SCOTT','KAREN','','','','34','439435656','4114 STATE RD',0,'BATCHELOR','LA','70715','3725','CY','22077','1973-08-26','F','M',':RET:2054-5','N','021','DEN','2837170','18575LA002000201','2014-04-01','2014-02-24 22:17:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:08'),(26534,21041,'Y','18','024','14','A','','','TE','0000793453','0000793453','','IL','1','Smith','Stephen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-01','M','',NULL,NULL,NULL,'','1490619','','2014-03-14','2014-02-27 18:46:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 21:30:04'),(346,283,'Y','18','021','EC','A','','','AC','0000398273','0000398273','TX00000882563','IL','1','Rains Barrera','Shana','','','','34','443941521','3731 Kriss Dr.',0,'Longview','TX','75604',NULL,'CY','48183','1985-02-27','F','M',':RET:2106-3','N','021','DEN','1104526','33348TX002000201','2014-01-01','2013-11-08 18:40:40','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 17:32:06'),(20023,15969,'Y','18','021','EC','A','','','AC','0001281005','0001281005','LA00001419606','IL','1','Sneed','Candise','','','','34','393983834','8956 HILTON DR',0,'SHREVEPORT','LA','71118','2402','CY','22017','1977-01-14','F','U',':RET:2054-5','N','021','DEN','3037785','18575LA002000201','2014-03-01','2014-01-25 21:58:02','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-26 19:00:15'),(18878,15040,'Y','18','021','EC','A','','','AC','0002249029','0002249029','LA00002197198','IL','1','Espree','Floyd','','','','34','439458415','1803 8TH AVE',0,'LAKE CHARLES','LA','70601','6605','CY','22019','1967-07-02','M','U',':RET:2054-5','N','021','DEN','2357982','18575LA002000201','2014-03-01','2014-01-16 15:47:37','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-17 03:36:27'),(423,346,'N','01','021','EC','A',NULL,NULL,'','0000895681','0000848313','','IL','1','Obrien','Gregory','Allen','','','34','275706568','42325 HOOPER RD',0,'SHADE','OH','45776','9549','CY','39105','1962-08-21','M','',':RET:2106-3','N','021','DEN','1143732','99734OH005000401','2014-01-01','2013-12-04 10:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:41'),(5539,4394,'Y','18','021','EC','A','','','AC','0000481036','0000481036','OH00000940752','IL','1','BUTTRAM','MICHAEL','','','','34','269769865','3409 ROBB AVE',0,'CINCINNATI','OH','45211','5332','CY','39061','1978-03-06','M','U',':RET:2106-3','N','021','DEN','368970','99734OH005000401','2014-01-01','2013-11-27 17:43:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:15:45'),(15031,12014,'Y','18','021','EC','A','','','AC','0002189763','0002189763','LA00000547139','IL','1','Jones','Milton','','','','34','437868943','9444 East Claiborne Parkway',0,'West Wego','LA','70094',NULL,'CY','22051','1953-11-01','M','U',NULL,'N','021','DEN','2132388','18575LA002000201','2014-02-01','2013-12-30 10:32:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:37'),(13115,10459,'Y','18','021','EC','A','','','AC','0000208501','0000208501','OH00000882473','IL','1','Peterson','Aaron','','','','34','259630592','8238 EMERALD AVE NE',0,'CANTON','OH','44721','1772','CY','39151','1977-05-08','M','R',':RET:2106-3','N','021','DEN','1525396','99734OH005000401','2014-01-01','2013-12-23 13:38:12','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-26 12:52:35'),(4102,3278,'Y','18','021','EC','A','','','AC','0001001473','0001001473','TX00001236810','IL','1','Decker','Elsa','','','','34','456670358','1702 S. LAMAR',0,'Austin','TX','78704',NULL,'CY','48453','1973-01-11','F','R',':RET:2106-3','N','021','DEN','2463123','33348TX002000101','2014-01-01','2013-12-16 22:50:10','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:47:45'),(28814,22805,'N','19','021','EC','A',NULL,NULL,'','0000559505','0000030612','','IL','1','CALVERT','MARIAH','R','','','34','281045902','5321 DONNER DRIVE',0,'NEW FRANKLIN','OH','44216',NULL,'CY','39153','1999-05-24','F','',':RET:2106-3','N','021','HLT','3871781','52664OH151001304','2014-04-01','2014-03-09 15:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-09 21:00:56'),(9533,7556,'Y','18','021','EC','A','','','AC','0000435292','0000435292','OH00000897616','IL','1','PORTER COZART','DIANE','','','','34','301525996','1723 THOMAS ST',0,'IRONTON','OH','45638','1133','CY','39087','1953-03-13','F','U',':RET:2106-3','N','021','DEN','1521578','99734OH005000301','2014-01-01','2013-12-21 09:44:57','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-26 04:35:50'),(7315,5797,'Y','18','024','14','A','','','TE','0000855715','0000855715','','IL','1','zamora','alicia','melissa',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-29','F','',NULL,NULL,NULL,'','914800','','2013-12-14','2013-12-14 12:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 02:03:26'),(23629,18816,'Y','18','024','14','A','','','TE','0001135198','0001135198','','IL','1','Williams','Ryan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-06','M','',NULL,NULL,NULL,'','1774581','','2014-02-13','2014-02-13 17:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:03:22'),(26715,21177,'Y','18','021','EC','A','','','AC','0000245384','0000245384','MS00003531252','IL','1','buckley','carolyn','','','','34','428510035','3514 FONTAINE AVE',0,'JACKSON','MS','39213','5657','CY','28049','1985-02-13','F','U',':RET:2054-5','N','021','DEN','3341196','46300MS002000201','2014-03-01','2014-02-28 12:19:49','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 21:31:40'),(28266,22367,'Y','18','024','14','A','','','TE','0001226599','0001226599','','IL','1','Thongsavanh','Thothsakanh',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-03-02','M','',NULL,NULL,NULL,'','1729981','','2014-03-31','2014-03-07 00:24:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-07 21:00:19'),(639,528,'N','01','021','EC','A',NULL,NULL,'','0000132052','0000258136','','IL','1','lee','robert','','','','34','300861178','33075 CHESTNUT RIDGE RD',0,'NORTH RIDGEVILLE','OH','44039','3439','CY','39093','1986-09-26','M','',':RET:2106-3','N','021','DEN','1935922','99734OH005000401','2014-01-01','2013-12-16 14:31:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:18'),(7089,5623,'Y','18','021','EC','A','','','AC','0000426435','0000426435','OH00000428215','IL','1','wade','christian','','','','34','284943503','1967 PARKGATE AVE',0,'AKRON','OH','44320','1107','CY','39153','1989-10-05','M','U',':RET:2054-5','N','021','HLT','2239483','52664OH152000901','2014-01-01','2013-12-24 23:45:47','19.00',NULL,NULL,'163.34','144.34','R-OH012','OH0','163.34',NULL,0,'2013-12-26 01:50:29'),(4077,3258,'Y','18','021','EC','A','','','AC','0000546461','0000546461','OH00000576001','IL','1','Foerster','David','J','','','34','071389678','656 HUNTERS TRL',0,'AKRON','OH','44313','8153','CY','39153','1949-06-12','M','U',':RET:2106-3','N','021','HLT','1889580','52664OH152000901','2014-01-01','2013-12-17 10:23:38','463.00',NULL,NULL,'490.00','27.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 21:47:05'),(21236,16969,'N','19','021','EC','A',NULL,NULL,'','0001105571','0000839089','','IL','1','AERI','ARUSHI','','','','34','290085704','6060 ROUND TOWER LN',0,'DUBLIN','OH','43017','3451','CY','39049','2001-11-20','F','',':RET:2029-7','N','021','DEN','3426351','99734OH005000301','2014-03-01','2014-02-03 13:10:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:01:11'),(9188,7287,'N','19','021','EC','A',NULL,NULL,'','0000232645','0000042045','','IL','1','Yang','Andy','','','','34','057822134','108 S WALNUT ST',0,'NEW BREMEN','OH','45869','1239','CY','39011','1990-12-30','M','',':RET:2034-7','N','021','HLT','1864053','92036OH005001505','2014-01-01','2013-12-18 15:39:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.08',NULL,0,'2013-12-26 04:09:20'),(16582,13264,'Y','18','021','EC','A','','','AC','0001780576','0001780576','LA00002047358','IL','1','gerstner','destiny','','','','34','437676669','29 MILLERS CREEK LN',0,'SLIDELL','LA','70458','5448','CY','22103','1979-12-09','F','M',':RET:2106-3','N','021','DEN','2585704','18575LA002000201','2014-02-01','2014-01-07 12:21:46','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:23:57'),(19876,15855,'Y','18','021','EC','A','','','AC','0000943449','0000943449','OH00001820315','IL','1','Frey','Patricia','','','','34','285705762','27054 Oakwood Dr',0,'Olmsted Twp','OH','44138',NULL,'CY','39035','1970-07-11','F','U',':RET:2106-3','N','021','DEN','3282991','99734OH005000401','2014-03-01','2014-01-24 10:04:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-24 21:00:43'),(19823,15806,'Y','18','021','EC','A','','','AC','0001176130','0001176130','TX00001587725','IL','1','Colin','Carmen','M','','','34','452532347','3900 VAN BUREN AVE',0,'EL PASO','TX','79930','5813','CY','48141','1962-07-17','F','M',':RET:2106-3','N','021','DEN','1878584','33348TX002000201','2014-03-01','2014-01-24 13:04:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-24 21:00:15'),(7289,5778,'N','19','021','EC','A',NULL,NULL,'','0000998761','0000666746','','IL','1','Rogers','Ashley',NULL,NULL,NULL,NULL,NULL,'10016 HOMESTEAD RD',0,'WADSWORTH','OH','44281','9033','CY','39103','2000-01-25','F','',NULL,'N','021','HLT','980982','52664OH151001501','2014-01-01','2013-12-14 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 02:02:52'),(689,567,'Y','18','021','EC','A','','','AC','0000463213','0000463213','OH00001031233','IL','1','Camp','Antonio','','','','34','299749155','4518 WINTON RD',0,'CINCINNATI','OH','45232','1844','CY','39061','1979-09-15','M','U',':RET:2054-5','T','021','DEN','2053775','99734OH005000301','2014-01-01','2013-12-16 14:45:28','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:02:35'),(22219,17736,'Y','18','021','EC','A','','','AC','0001392215','0001392215','LA00001957026','IL','1','Creel','Van','','','','34','436901640','186 WHISENANT RD',0,'WINNFIELD','LA','71483','6119','CY','22127','1951-01-11','M','M',':RET:2106-3','N','021','DEN','3695625','18575LA002000201','2014-03-01','2014-02-09 16:40:37','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-09 19:00:25'),(21425,17123,'N','19','021','EC','A',NULL,NULL,'','0000904297','0001067019','','S1','1','Haddad','Saba',NULL,NULL,NULL,NULL,NULL,'5467 surrey ct',0,'West chester','OH','45069',NULL,'CY','39017','2007-08-30','F','',':RET:2106-3','N','021','HLT','3428920','92036OH004001201','2014-03-01','2014-02-03 23:16:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-04 21:01:15'),(6249,4952,'Y','18','021','EC','A','','','AC','0000934948','0000934948','LA00000436733','IL','1','Smith','Brenda','','','','34','434928026','41 E BLUE RIDGE CT',0,'NEW ORLEANS','LA','70128','1138','CY','22071','1954-11-19','F','U',':RET:2054-5','N','021','DEN','418056','18575LA002000201','2014-01-01','2013-11-19 13:43:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:31:53'),(6168,4889,'Y','18','021','EC','A','','','AC','0000678057','0000678057','OH00000804750','IL','1','Cremonese','Joseph','','','','34','115449366','2210 MIAMI PL',0,'LIMA','OH','45806','1301','CY','39003','1953-09-14','M','M',':RET:2106-3','N','021','HLT','345453','92036OH003001501','2014-01-01','2013-11-21 14:50:48','697.00',NULL,NULL,'1180.19','483.19','R-OH002','OH0','623.76',NULL,0,'2013-12-26 00:16:58'),(3039,2443,'Y','18','021','EC','A','','','AC','0000869255','0000869255','OH00000707912','31','1','Jones','Jonathan','','','','34','276867738','740 GARMON AVE',0,'ASHLAND','OH','44805','3725','CY','39005','1981-11-11','M','M',':RET:2106-3','N','021','HLT','266477','52664OH152000901','2014-01-01','2013-12-05 22:50:09','105.00',NULL,NULL,'193.23','88.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 20:18:36'),(4144,3304,'Y','18','021','EC','A','','','AC','0000689679','0000689679','OH00000051389','IL','1','Arisman','Justin','','','','34','565671593','230 W FANCY ST',0,'BLANCHESTER','OH','45107','1461','CY','39027','1981-07-23','M','U',':RET:2106-3','N','021','DEN','2395026','99734OH005000301','2014-01-01','2013-12-17 12:37:07','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:48:37'),(17853,14261,'N','01','021','EC','A',NULL,NULL,'','0001053076','0000949530','','IL','1','Toth Moran','Susanne','','','','34','230137202','3877 W 137TH ST',0,'CLEVELAND','OH','44111','4446','CY','39035','1977-08-23','F','',':RET:2106-3','N','021','DEN','1830477','99734OH005000401','2014-02-01','2014-01-14 10:36:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:07'),(17634,14099,'Y','18','021','EC','A','','','AC','0001258678','0001258678','OH00002244080','IL','1','Kessler','Shmuel','Yaakov','','','34','147700761','4286 UNIVERSITY PKWY',0,'UNIVERSITY HEIGHTS','OH','44118','3943','CY','39035','1980-05-05','M','M',':RET:2106-3','N','021','DEN','1360427','99734OH005000301','2014-02-01','2014-01-12 19:56:44','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-14 01:32:35'),(16726,13386,'N','01','021','EC','A',NULL,NULL,'','0001195517','0001246954','','IL','1','Davis','William','','','','34','564671866','6566 STYME RD',0,'LOWELLVILLE','OH','44436','9541','CY','39099','1980-02-02','M','',':RET:2106-3','N','021','HLT','1807784','52664OH151001306','2014-02-01','2014-01-07 12:44:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','302.97',NULL,0,'2014-01-08 18:24:48'),(4121,3291,'Y','18','021','EC','A','','','AC','0000910508','0000910508','OH00000055057','IL','1','Thomas','Bonnie','','','','34','275749107','3815 MAYFAIR DR',0,'GROVE CITY','OH','43123','9097','CY','39049','1963-12-31','F','U',':RET:2106-3','N','021','DEN','2152605','99734OH005000301','2014-01-01','2013-12-16 21:37:24','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:11'),(3929,3144,'N','01','021','EC','A',NULL,NULL,'','0000218814','0000924775','','IL','1','Hollington','John','W','','','34','285426207','833 BITTERBRUSH LN',0,'FINDLAY','OH','45840','7101','CY','39063','1949-08-07','M','',':RET:2106-3','N','021','HLT','841105','92036OH002001501','2014-01-01','2013-12-12 20:35:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','762.47',NULL,0,'2013-12-25 21:37:34'),(3280,2645,'Y','18','024','14','A','','','TE','0000767369','0000767369','','IL','1','Mantonya','Whitney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-07-16','F','',NULL,NULL,NULL,'','689557','','2013-12-21','2013-12-21 19:02:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:15:15'),(13945,11119,'Y','18','021','EC','A','','','AC','0001257337','0001257337','OH00001282007','IL','1','SAGE','RONALD','','','','34','273522699','985 ROSE BLVD',0,'HIGHLAND HEIGHTS','OH','44143','3229','CY','39035','1951-07-05','M','U',':RET:2106-3','T','021','HLT','2411340','92036OH003000805','2014-01-01','2013-12-23 06:01:08','449.00',NULL,NULL,'806.68','357.68','R-OH011','OH0','806.68',NULL,0,'2013-12-26 13:14:47'),(9157,7264,'Y','18','021','EC','A','','','AC','0000656921','0000656921','OH00000334543','IL','1','HAMILTON','RANDALL','K','','','34','286449451','1416 THOMPSON HEIGHTS AVE',0,'CINCINNATI','OH','45223','1608','CY','39061','1952-03-29','M','U',NULL,'N','021','HLT','2545853','92036OH006001201','2014-01-01','2013-12-18 16:46:53','293.00',NULL,NULL,'478.41','185.41','R-OH004','OH0','478.41',NULL,0,'2013-12-26 04:08:36'),(25130,19934,'Y','18','021','EC','A','','','AC','0000830665','0000830665','TX00002342067','IL','1','Mai','Nhien',NULL,NULL,NULL,NULL,NULL,'3630 Gardenbrook Dr.',0,'Farmers Branch','TX','75234',NULL,'CY','48113','1964-07-03','M','M',NULL,'N','021','DEN','3134713','33348TX002000201','2014-04-01','2014-02-20 21:02:15','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-21 22:00:03'),(592,487,'Y','18','024','14','A','','','TE','0000413342','0000413342','','IL','1','dunlap','william',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-06-26','M','',NULL,NULL,NULL,'','649049','','2013-12-15','2013-12-15 18:20:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:00:05'),(7837,6207,'Y','18','021','EC','A','','','AC','0000431370','0000431370','OH00000591614','IL','1','Jones','Jeffrey','Alan','','','34','286566746','7635 CONDIT RD',0,'CENTERBURG','OH','43011','9507','CY','39041','1954-09-21','M','M',':RET:2106-3','N','021','DEN','2265768','99734OH005000301','2014-01-01','2013-12-19 20:14:08','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:04:32'),(20722,16558,'Y','18','021','EC','A','','','AC','0000436632','0000436632','OH00002533919','IL','1','Brinker','Debra','','','','34','301566341','1272 TOWNSHIP ROAD 653',0,'ASHLAND','OH','44805','9779','CY','39005','1955-01-09','F','M',':RET:2106-3','N','021','HLT','2582147','52664OH151001305','2014-03-01','2014-01-29 20:14:21','473.00',NULL,NULL,'580.49','107.49','R-OH012','OH0','580.49',NULL,0,'2014-01-30 21:01:15'),(20593,16455,'Y','18','021','EC','A','','','AC','0000863501','0000863501','OH00001430353','IL','1','Horton','Bonita','','','','34','297885780','3434 E 103RD ST',0,'CLEVELAND','OH','44104','5625','CY','39035','1988-07-24','F','U',':RET:2054-5','N','021','DEN','3456604','99734OH005000401','2014-03-01','2014-01-30 09:57:23','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-30 21:00:09'),(20168,16094,'Y','18','024','14','A','','','TE','0000105401','0000105401','','IL','1','EHRHARDT','AMANDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-03-27','F','',NULL,NULL,NULL,'','2721714','','2014-01-27','2014-01-27 11:00:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:13'),(19324,15405,'Y','18','021','EC','A','','','AC','0000676350','0000676350','TX00001961651','IL','1','DANG','XUAN','','','','34','434855958','3617 COLONY CREEK DR',0,'NACOGDOCHES','TX','75965','6977','CY','48347','1969-11-20','F','M',':RET:2047-9','N','021','DEN','1791725','33348TX002000201','2014-03-01','2014-01-21 13:17:46','0.00',NULL,NULL,'67.44','67.44','R-TX026','TX0','14.61',NULL,1,'2014-01-22 03:22:13'),(19283,15370,'Y','18','021','EC','A','','','AC','0000240376','0000240376','OH00001945322','IL','1','Traxler','Mary','L','','','34','271602385','188 HUDSON ST',0,'TIFFIN','OH','44883','1420','CY','39147','1956-09-08','F','U',':RET:2106-3','N','021','HLT','2117887','92036OH006002701','2014-03-01','2014-01-20 17:57:59','364.00',NULL,NULL,'376.87','12.87','R-OH006','OH0','376.87',NULL,0,'2014-01-21 08:47:01'),(18364,14658,'Y','18','021','EC','A','','','AC','0000076322','0000076322','OH00001980198','IL','1','Hess','Deborah','','','','34','297523808','18015 Harvest Drive',0,'Chagrin Falls','OH','44023',NULL,'CY','39055','1952-12-04','F','M',':RET:2106-3','N','021','DEN','1512359','99734OH005000301','2014-02-01','2014-01-15 10:01:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:27'),(17586,14057,'N','01','021','EC','A',NULL,NULL,'','0000060285','0000863487','','IL','1','McCue','Scott','','','','34','287487088','1050 N CARPENTER RD',0,'BRUNSWICK','OH','44212','2236','CY','39103','1965-08-10','M','',':RET:2106-3','T','021','DEN','2457716','99734OH005000401','2014-02-01','2014-01-13 15:45:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:07'),(16452,13165,'Y','18','021','EC','A','','','AC','0000968911','0000968911','MS00002180536','IL','1','Hancock','Kyle','','','','34','412334301','3585 STARGATE DR',0,'SOUTHAVEN','MS','38672','6205','CY','28033','1980-05-29','M','M',':RET:2106-3','N','021','DEN','1631221','46300MS002000101','2014-02-01','2014-01-06 17:29:34','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-07 04:05:26'),(15948,12768,'Y','18','021','EC','A','','','AC','0000979311','0000979311','OH00002030534','IL','1','Gorman','Sharon','','','','34','274440367','802 KENNISON AVE',0,'NEW CARLISLE','OH','45344','1319','CY','39023','1952-03-12','F','U',':RET:2106-3','T','021','HLT','2302149','92036OH004000501','2014-02-01','2014-01-02 17:53:47','451.00',NULL,NULL,'617.67','166.67','R-OH003','OH0','617.67',NULL,0,'2014-01-03 02:07:27'),(3531,2834,'N','01','021','EC','A',NULL,NULL,'','0001194131','0001235289','','IL','1','Steormann','Ashley','Cameron','','','34','453538964','1165 Mount Gilead Road',0,'Keller','TX','76262',NULL,'CY','48439','1980-12-04','F','',':RET:2106-3','N','021','DEN','2600144','33348TX002000101','2014-01-01','2013-12-21 22:43:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 21:21:29'),(663,547,'N','01','021','EC','A',NULL,NULL,'','0001133930','0001034649','','IL','1','Fineran','Kayla','','','','34','612301862','2631 MAPLE AVE NE',0,'CANTON','OH','44714','1890','CY','39151','1986-08-26','F','',':RET:2106-3','N','021','DEN','435071','99734OH005000301','2014-01-01','2013-12-15 23:42:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:56'),(2837,2293,'Y','18','021','EC','A','','','AC','0000130657','0000130657','OH00000553725','IL','1','Strahler','Renee','','','','34','285881352','1622 WILDON AVE',0,'AKRON','OH','44306','3334','CY','39153','1981-09-30','F','U',':RET:2106-3','N','021','HLT','550374','52664OH152000901','2014-01-01','2013-11-24 16:23:11','0.00',NULL,NULL,'193.23','193.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 20:00:57'),(2703,2188,'Y','18','021','EC','A','','','AC','0000529196','0000529196','TX00000679136','IL','1','Rawson','Leah','','','','34','449491776','12530 ENFIELD PARK',0,'SAN ANTONIO','TX','78232','4630','CY','48029','1964-11-25','F','U',':RET:2106-3','N','021','DEN','141602','33348TX002000201','2014-01-01','2013-12-02 13:45:29','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 19:47:46'),(6077,4817,'Y','18','021','EC','A','','','AC','0000807468','0000807468','OH00000539603','IL','1','Hassel','Bruce',NULL,NULL,NULL,NULL,NULL,'5130 ROLLMAN ESTATES DR',0,'CINCINNATI','OH','45236','1456','CY','39061','1952-12-30','M','R',NULL,'N','021','HLT','1017274','92036OH004001201','2014-01-01','2013-12-01 11:00:16','0.00',NULL,NULL,'994.59','994.59','R-OH004','OH0','485.05',NULL,0,'2013-12-26 00:02:22'),(7603,6016,'Y','18','021','EC','A','','','AC','0000243702','0000243702','OH00000524635','IL','1','Bowers','Melissa','','','','34','279740725','123 ELY AVE',0,'FINDLAY','OH','45840','4324','CY','39063','1963-12-03','F','U',':RET:2106-3','N','021','DEN','924685','99734OH005000401','2014-01-01','2013-11-17 13:06:55','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 02:45:25'),(1021,836,'Y','18','021','EC','A','','','AC','0000145359','0000145359','OH00000092227','IL','1','McGaffick','Eleanor','','','','34','171381877','485 Stephens Road',0,'Akron','OH','44312',NULL,'CY','39153','1949-03-07','F','U',':RET:2106-3','N','021','HLT','175890','52664OH152000901','2014-01-01','2013-12-02 18:32:25','344.00',NULL,NULL,'490.00','146.00','R-OH012','OH0','490.00',NULL,0,'2013-12-25 18:15:14'),(23380,18630,'Y','18','021','EC','A','','','AC','0000149391','0000149391','OH00001910535','IL','1','Rupley','Julie','','','','34','285849004','4341 CIDER MILL DR',0,'CINCINNATI','OH','45245','1401','CY','39025','1973-02-03','F','M',':RET:2106-3','N','021','DEN','2900687','99734OH005000401','2014-03-01','2014-02-13 13:17:10','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:00:59'),(23917,19021,'N','01','021','EC','A',NULL,NULL,'','0000813132','0001024322','','IL','1','Trimmer','Melissa','','','','34','287745901','2266 TIMBER RIDGE TRL',0,'STREETSBORO','OH','44241','4202','CY','39133','1975-10-24','F','',':RET:2106-3','N','021','DEN','3787451','99734OH005000301','2014-03-01','2014-02-13 23:40:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:04'),(25584,20295,'Y','18','024','14','A','','','TE','0000813091','0000813091','','IL','1','Legan','Thomas','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-19','M','',NULL,NULL,NULL,'','1792400','','2014-03-31','2014-02-24 07:54:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-26 08:00:38'),(26285,20849,'N','01','021','EC','A',NULL,NULL,'','0002047878','0001550712','','IL','1','SHARP','VICKY','','','','34','436498484','16497 WARDLINE RD',0,'COVINGTON','LA','70435',NULL,'CY','22103','1981-07-11','F','',':RET:2106-3','N','021','DEN','3299432','18575LA002000101','2014-04-01','2014-02-27 11:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 06:31:21'),(28687,22703,'Y','18','021','EC','A','','','AC','0000473705','0000473705','OH00003776787','IL','1','Plant','Steven','','','','34','274461999','1595 TREETOP TRL',0,'AKRON','OH','44313','8765','CY','39153','1953-04-25','M','U',':RET:2106-3','N','021','HLT','2849413','52664OH152000901','2014-04-01','2014-03-07 19:43:49','443.31',NULL,NULL,'443.31','0.00','R-OH012','OH0','443.31',NULL,0,'2014-03-08 21:31:01'),(28918,22887,'N','01','021','EC','A',NULL,NULL,'','0001241933','0000115566','','IL','1','heller','john','k','','','34','269768485','212 E WATER ST',0,'OAK HARBOR','OH','43449','1451','CY','39123','1970-10-07','M','',':RET:2106-3','T','021','DEN','3179097','99734OH005000301','2014-04-01','2014-03-10 09:48:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:29'),(2520,2055,'Y','18','021','EC','A','','','AC','0000249097','0000249097','OH00000012130','IL','1','HOPKINS','LINDA','','','','34','284521836','66 N 4TH ST',0,'RITTMAN','OH','44270','1334','CY','39169','1952-03-30','F','M',':RET:2106-3','N','021','HLT','1216725','52664OH152000901','2014-01-01','2013-12-09 13:16:11','932.00',NULL,NULL,'941.17','9.17','R-OH014','OH0','458.99',NULL,0,'2013-12-25 19:36:34'),(6170,4889,'N','01','021','EC','A',NULL,NULL,'','0000678057','0000371459','','IL','1','DeMelio','Susan','','','','34','149583891','2210 MIAMI PL',0,'LIMA','OH','45806','1301','CY','39003','1963-10-29','F','',':RET:2106-3','N','021','HLT','345453','92036OH003001501','2014-01-01','2013-11-21 14:50:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','410.48',NULL,0,'2013-12-26 00:17:00'),(16311,13059,'Y','18','021','EC','A','','','AC','0001577573','0001577573','LA00001920545','IL','1','BAHAM','GARY','','','','34','435866661','1912 AGRICULTURE ST',0,'NEW ORLEANS','LA','70119','1004','CY','22071','1952-04-30','M','U',NULL,'N','021','DEN','2196645','18575LA002000201','2014-02-01','2014-01-06 16:08:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:25'),(17550,14031,'Y','18','024','14','A','','','TE','0000376162','0000376162','','IL','1','STONE','DONALD','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-07-21','M','',NULL,NULL,NULL,'','1524907','','2014-01-12','2014-01-12 13:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:53'),(20943,16736,'Y','18','021','EC','A','','','AC','0000573877','0000573877','TX00002285602','IL','1','Johnson','Gloria','','','','34','435841376','726 S WALKER ST',0,'MESQUITE','TX','75149','4941','CY','48113','1951-07-26','F','M',':RET:2054-5','N','021','DEN','2440468','33348TX002000101','2014-03-01','2014-01-31 16:27:58','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-01-31 21:01:43'),(18913,15071,'N','01','021','EC','A',NULL,NULL,'','0000020201','0000384423','','IL','1','Neace','Steven','','','','34','296802064','9767 COBBLEWOOD CT',0,'CENTERVILLE','OH','45458','6100','CY','39113','1971-11-23','M','',':RET:2106-3','N','021','HLT','2074494','92036OH001000501','2014-02-01','2014-01-15 19:15:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','379.92',NULL,0,'2014-01-17 03:36:41'),(18908,15067,'Y','18','021','EC','A','','','AC','0000526801','0000526801','OH00002102594','IL','1','Wright','Mary','','','','34','423684402','4344 W BANCROFT ST',0,'OTTAWA HILLS','OH','43615','7851','CY','39095','1951-07-27','F','M',NULL,'N','021','HLT','2596156','92036OH004002601','2014-03-01','2014-01-16 17:14:22','0.00',NULL,NULL,'450.46','450.46','R-OH001','OH0','450.46',NULL,0,'2014-01-17 03:36:39'),(6053,4795,'Y','18','021','EC','A','','','AC','0000699230','0000699230','OH00000168627','IL','1','petty','wayne','','','','34','287524568','3464 W 135TH ST',0,'CLEVELAND','OH','44111','2404','CY','39035','1954-09-19','M','M',':RET:2054-5','N','021','DEN','204554','99734OH005000401','2014-01-01','2013-12-01 08:22:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:01:45'),(17288,13826,'Y','18','021','EC','A','','','AC','0000902222','0000902222','TX00002503901','IL','1','Abate','Jesse','','','','34','042906004','1505 W. Grande Blvd',0,'Tyler','TX','75703',NULL,'CY','48423','1981-12-17','M','U',':RET:2106-3','N','021','DEN','1505116','33348TX002000201','2014-02-01','2014-01-09 21:04:41','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-13 02:23:31'),(16611,13288,'Y','18','021','EC','A','','','AC','0000430286','0000430286','OH00001599720','IL','1','LOCHER','JEFFREY','JOHN','','','34','289742704','3899 AUSTINBURG RD',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1965-05-24','M','U',':RET:2106-3','N','021','DEN','1501380','99734OH005000401','2014-02-01','2014-01-06 19:28:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:08'),(8866,7029,'N','01','021','EC','A',NULL,NULL,'','0000035657','0000913501','','IL','1','Liles','Max','','','Sr','34','463270130','205 COUNTY ROAD 2455',0,'MINEOLA','TX','75773','6931','CY','48499','1961-09-09','M','',':RET:2106-3','N','021','DEN','2311519','33348TX002000201','2014-01-01','2013-12-18 12:42:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:25'),(8833,7002,'Y','18','021','EC','A','','','AC','0000606516','0000606516','TX00000897404','IL','1','Ribeiro','Eduardo','','','','34','516372629','1461 FM 934',0,'Blum','TX','76627',NULL,'CY','48217','1965-01-05','M','M',':RET:2106-3','N','021','DEN','2202795','33348TX002000201','2014-01-01','2013-12-17 20:39:27','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:33'),(953,784,'N','19','021','EC','A',NULL,NULL,'','0000115452','0000564171','','IL','1','Rini','Thomas','Robert','','','34','297156220','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','2010-06-10','M','',':RET:2106-3','N','021','DEN','735562','99734OH005000301','2014-01-01','2013-10-31 11:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:36'),(22461,17934,'Y','18','021','EC','A','','','AC','0000469409','0000469409','TX00002696886','IL','1','Wheland','James','Michael','','Jr','34','467633384','1581 COUNTY ROAD 321',0,'LA VERNIA','TX','78121','5634','CY','48493','1968-03-28','M','M',':RET:2106-3','N','021','DEN','3102811','33348TX002000201','2014-03-01','2014-02-10 16:09:10','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-02-10 21:30:53'),(22418,17900,'Y','18','024','14','A','','','TE','0001636345','0001636345','','IL','1','Yambra','Kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-11-29','M','',NULL,NULL,NULL,'','2394797','','2014-02-10','2014-02-10 13:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-10 21:30:29'),(5394,4281,'Y','18','021','EC','A','','','AC','0002356854','0002356854','LA00001183463','IL','1','Ringo','Patricia','','','','34','436784705','308 PLANTATION DR',0,'KENNER','LA','70062','7031','CY','22051','1957-11-19','F','U',':RET:2054-5','N','021','DEN','1734733','18575LA002000201','2014-01-01','2013-12-19 16:54:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:45'),(21023,16799,'Y','18','021','EC','A','','','AC','0000642109','0000642109','OH00002141526','IL','1','Gilkerson','Isaac','','','','34','291625319','71 W HUSTON ST',0,'BARBERTON','OH','44203','2318','CY','39153','1970-05-17','M','U',':RET:2106-3','N','021','DEN','3194797','99734OH005000401','2014-03-01','2014-02-01 16:45:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-01 19:00:40'),(5198,4124,'Y','18','021','EC','A','','','AC','0000732579','0000732579','OH00000117623','IL','1','Itomlenskis','Larissa','','','','34','280909068','5251 MAYVIEW RD',0,'LYNDHURST','OH','44124','1245','CY','39035','1982-09-01','F','U',NULL,'N','021','DEN','1665876','99734OH005000401','2014-01-01','2013-12-19 14:16:27','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:57'),(17480,13975,'N','01','021','EC','A',NULL,NULL,'','0000884961','0000159277','','IL','1','Brecheen','Daveda','Karanas','','','34','437695003','9445 PASTIME CT',0,'FORT WORTH','TX','76244','8680','CY','48439','1979-04-19','F','',':RET:2106-3','N','021','DEN','1969082','33348TX002000201','2014-02-01','2014-01-12 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 03:01:12'),(17133,13711,'Y','18','021','EC','A','','','AC','0001115960','0001115960','OH00002475385','IL','1','gamiere','kevin','l','','','34','297588804','4425 elberta road',0,'perry','OH','44081',NULL,'CY','39085','1956-04-07','M','M',':RET:2106-3','N','021','DEN','2607395','99734OH005000401','2014-02-01','2014-01-08 13:54:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:21:47'),(16817,13451,'Y','18','021','EC','A','','','AC','0000300069','0000300069','TX00002003489','IL','1','corcoran','cynthia','','','','34','225968891','2718 EDLOE ST',0,'HOUSTON','TX','77027','5325','CY','48201','1959-08-28','F','U',':RET:2106-3','N','021','DEN','2145257','33348TX002000101','2014-02-01','2014-01-10 18:40:27','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-13 02:18:20'),(13675,10911,'Y','18','021','EC','A','','','AC','0001024272','0001024272','OH00000295176','IL','1','Lignoski','Nancy','','','','34','208664017','960 HESSEL DR',0,'AKRON','OH','44313','5804','CY','39153','1979-04-07','F','U',':RET:2106-3','N','021','HLT','2376097','52664OH151001301','2014-01-01','2013-12-22 19:56:15','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:08:01'),(26721,21182,'Y','18','021','EC','A','','','AC','0000186910','0000186910','MS00002739412','IL','1','COLEMAN','APRIL','','','','34','426533633','6019 SAMANTHA DR',0,'JACKSON','MS','39209','3590','CY','28049','1985-05-26','F','M',NULL,'N','021','DEN','3720383','46300MS002000101','2014-03-01','2014-02-28 15:58:46','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-02-28 21:31:44'),(26886,21309,'Y','18','021','EC','A','','','AC','0000383421','0000383421','OH00003434356','IL','1','GAY','MELODY','','','','34','272521647','505 MCPHERON AVE',0,'LIMA','OH','45804',NULL,'CY','39003','1956-01-29','F','M',NULL,'N','021','HLT','3394394','92036OH003001506','2014-04-01','2014-03-01 18:25:21','548.00',NULL,NULL,'585.61','37.61','R-OH002','OH0','585.61',NULL,0,'2014-03-03 01:00:01'),(28795,22793,'N','01','021','EC','A',NULL,NULL,'','0000615295','0001082390','','IL','1','BELEA','BILLIE','WESLEY','','','34','467892502','2308 HILLGROVE COURT',0,'MANSFIELD','TX','76063',NULL,'CY','48439','1971-07-03','F','',':RET:2106-3','N','021','DEN','4287129','33348TX002000101','2014-04-01','2014-03-09 15:25:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-03-09 21:00:44'),(1812,1489,'N','19','021','EC','A',NULL,NULL,'','0001166821','0001058001','','IL','1','Niklas','Noah',NULL,NULL,NULL,NULL,NULL,'80 E CASE DR',0,'HUDSON','OH','44236','2744','CY','39153','2008-12-25','M','',':RET:2106-3','N','021','HLT','2153126','52664OH151001501','2014-01-01','2013-12-24 14:40:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-25 18:57:02'),(2892,2336,'Y','18','021','EC','A','','','AC','0001169421','0001169421','OH00000303641','IL','1','Bodzin','Jay','','','','34','294788989','4421 SILSBY RD',0,'UNIVERSITY HEIGHTS','OH','44118','3938','CY','39035','1972-07-19','M','M',':RET:2106-3','N','021','HLT','235718','52664OH151001501','2014-01-01','2013-12-06 14:23:07','81.00',NULL,NULL,'1168.62','1087.62','R-OH011','OH0','392.76',NULL,0,'2013-12-25 20:15:12'),(24379,19365,'Y','18','021','EC','A','','','AC','0000956699','0000956699','OH00001859333','IL','1','Harris','Charece','','','','34','279888742','6331 STRATHAVEN DR',0,'WEST CHESTER','OH','45069','6643','CY','39017','1979-04-07','F','R',':RET:2054-5','N','021','DEN','3784044','99734OH005000401','2014-04-01','2014-02-18 08:53:39','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:43'),(6181,4898,'Y','18','021','EC','A','','','AC','0000372566','0000372566','OH00000448129','IL','1','Lay','Quentin','','','','34','279887550','297 Courtland Drive',0,'Monroe','OH','45050',NULL,'CY','39017','1983-03-11','M','U',':RET:2054-5','N','021','DEN','1181167','99734OH005000401','2014-01-01','2013-10-22 20:01:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:30:03'),(19990,15946,'Y','18','021','EC','A','','','AC','0002323826','0002323826','LA00002572357','IL','1','ROSE','REX','','','','34','266375092','70312 RAVINE ST',0,'ABITA SPRINGS','LA','70420','3134','CY','22103','1962-11-23','M','U',NULL,'N','021','DEN','2962498','18575LA002000101','2014-03-01','2014-01-25 15:05:05','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-25 19:00:19'),(19843,15826,'Y','18','021','EC','A','','','AC','0001747632','0001747632','LA00002456536','IL','1','oneal','timothy','','','','34','436510299','10246 KENLEE DR',0,'BATON ROUGE','LA','70815','4725','CY','22033','1981-03-10','M','U',':RET:2106-3','T','021','DEN','1654623','18575LA002000201','2014-03-01','2014-01-24 13:32:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-24 21:00:27'),(18253,14572,'Y','18','021','EC','A','','','AC','0000673634','0000673634','TX00001604738','IL','1','Offor','Ogechukwu','','','','34','630602300','1358 Blue Diamond Dr',0,'MISSOURI CITY','TX','77489',NULL,'CY','48157','1980-07-25','F','U',':RET:2054-5','N','021','DEN','1647808','33348TX002000201','2014-02-01','2014-01-15 11:30:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-16 08:44:32'),(14745,11774,'Y','18','021','EC','A','','','AC','0000020185','0000020185','OH00001803980','IL','1','Jones','Beverly','','','','34','289488441','8511 PRINGLE DR',0,'CINCINNATI','OH','45231','4903','CY','39061','1950-02-18','F','M',':RET:2054-5','N','021','HLT','1830087','92036OH003001206','2014-02-01','2013-12-27 19:35:35','524.00',NULL,NULL,'661.77','137.77','R-OH004','OH0','661.77',NULL,1,'2013-12-29 11:10:09'),(17131,13709,'Y','18','021','EC','A','','','AC','0001213477','0001213477','OH00000813483','IL','1','STUTZ','CYNTHIA','L','','','34','271722990','12925 LENA AVE',0,'CLEVELAND','OH','44135','3041','CY','39035','1970-10-08','F','U',':RET:2106-3','T','021','DEN','1948477','99734OH005000401','2014-02-01','2014-01-08 12:33:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:21:46'),(27126,21473,'Y','18','024','14','A','','','TE','0000938588','0000938588','','IL','1','howard','tina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-11-27','F','',NULL,NULL,NULL,'','2966815','','2014-03-03','2014-03-03 13:04:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:37'),(27804,21992,'Y','18','021','EC','A','','','AC','0000495502','0000495502','OH00002923107','IL','1','DOBRIJEVIC','DANIJEL','','','','34','288047353','792 HANCOCK CIR',0,'AKRON','OH','44314','1017','CY','39153','1975-10-03','M','M',':RET:2106-3','N','021','HLT','3753464','52664OH151001305','2014-04-01','2014-03-05 12:39:54','562.00',NULL,NULL,'838.96','276.96','R-OH012','OH0','277.87',NULL,0,'2014-03-05 21:31:47'),(28595,22630,'Y','18','021','EC','A','','','AC','0001089622','0001089622','OH00003010426','IL','1','Messer','Fredia','','','','34','235822874','14640 smart cole rd',0,'Ostrander','OH','43061',NULL,'CY','39159','1950-07-08','F','M',':RET:2106-3','N','021','DEN','4176377','99734OH005000401','2014-04-01','2014-03-08 08:54:49','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:30:05'),(3054,2453,'N','01','021','EC','A',NULL,NULL,'','0000753105','0000048421','','IL','1','Pierce','Diane','K','','','34','431119396','30785 PIERCE LN',0,'TICKFAW','LA','70466','4083','CY','22105','1954-12-07','F','',':RET:2106-3','N','021','DEN','705504','18575LA002000201','2014-01-01','2013-12-06 17:12:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:18:58'),(23854,18979,'Y','18','021','EC','A','','','AC','0001005757','0001005757','OH00001771512','IL','1','mclaughlin','sue','','','','34','292686822','4429 camberwell rd',0,'cincinanti','OH','45209',NULL,'CY','39061','1967-01-18','F','U',':RET:2106-3','N','021','HLT','2973306','92036OH004001201','2014-03-01','2014-02-13 23:18:45','84.00',NULL,NULL,'269.80','185.80','R-OH004','OH0','269.80',NULL,0,'2014-02-14 21:32:00'),(23806,18942,'Y','18','024','14','A','','','TE','0000977799','0000977799','','IL','1','GREEN','KYLIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2008-12-24','F','',NULL,NULL,NULL,'','2856467','','2014-02-13','2014-02-13 19:11:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-14 21:31:32'),(9434,7484,'N','01','021','EC','A',NULL,NULL,'','0000342727','0001002164','','IL','1','Lewis','Judy','Ann','','','34','296426731','5630 CODER RD',0,'ATTICA','OH','44807','9600','CY','39077','1949-08-28','F','',':RET:2106-3','N','021','HLT','1503277','92036OH003002705','2014-01-01','2013-12-21 14:01:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','610.89',NULL,0,'2013-12-26 04:33:29'),(9177,7279,'Y','18','021','EC','A','','','AC','0000224713','0000224713','OH00000313529','IL','1','Finley','Brenda','','','','34','281525051','3512 Franklin Road',0,'Felicity','OH','45120',NULL,'CY','39025','1951-12-03','F','M',':RET:2106-3','N','021','HLT','1969372','92036OH005000601','2014-01-01','2013-12-18 16:20:25','516.00',NULL,NULL,'616.74','100.74','R-OH005','OH0','616.74',NULL,0,'2013-12-26 04:09:05'),(21539,17205,'N','19','021','EC','A',NULL,NULL,'','0000073971','0001106815','','IL','1','MacCarthy','Linda','','','','34','272118405','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1993-09-03','F','',NULL,'N','021','DEN','3765230','99734OH005000401','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:09'),(4869,3860,'Y','18','021','EC','A','','','AC','0000099701','0000099701','LA00001168994','IL','1','Farmer','John','','','','34','436737329','1107 TULANE AVE',0,'WEST MONROE','LA','71291','5248','CY','22073','1986-12-03','M','U',NULL,'N','021','DEN','424082','18575LA002000201','2014-01-01','2013-10-10 10:13:23','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:30:57'),(18359,14656,'Y','18','021','EC','A','','','AC','0000701719','0000701719','OH00001550739','IL','1','Marmer','Randy','','','','34','292463379','13 AVON FIELDS PL',0,'CINCINNATI','OH','45229','1512','CY','39061','1956-11-28','M','M',':RET:2106-3','N','021','DEN','1466950','99734OH005000301','2014-02-01','2014-01-15 01:42:53','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:26'),(16058,12859,'Y','18','024','14','A','','','TE','0000153374','0000153374','','IL','1','GAMBEL','KIM','B',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-09-08','F','',NULL,NULL,NULL,'','1502229','','2014-01-03','2014-01-03 09:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:03:25'),(15229,12173,'N','19','021','EC','A',NULL,NULL,'','0000968222','0000493236','','S1','1','Kuhnell','Sarah','','','','34','301085390','5930 WOODSPOINT DR',0,'MILFORD','OH','45150','2157','CY','39025','2004-07-15','M','',':RET:2106-3','N','021','HLT','1445791','92036OH005000605','2014-02-01','2013-12-29 23:38:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-01-01 12:08:15'),(25969,20595,'Y','18','021','EC','A','','','AC','0001146029','0001146029','OH00002214016','IL','1','GRILLI','CYNTHIA','','','','34','298485387','4102 LOCKWOOD BLVD',0,'YOUNGSTOWN','OH','44511',NULL,'CY','39099','1958-06-14','F','M',':RET:2106-3','T','021','DEN','3784217','99734OH005000401','2014-04-01','2014-02-26 13:31:19','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-02-26 21:01:45'),(3016,2425,'Y','18','021','EC','A','','','AC','0001011536','0001011536','OH00000056211','IL','1','Drake','Teri','','','','34','281546541','226 Half E. 10th St.',0,'Ashland','OH','44805',NULL,'CY','39005','1953-05-07','F','U',':RET:2106-3','N','021','HLT','1046243','52664OH151001305','2014-01-01','2013-12-06 09:08:54','538.00',NULL,NULL,'605.24','67.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 20:18:02'),(23646,18829,'Y','18','021','EC','A','','','AC','0000125690','0000125690','TX00001681986','IL','1','Chavez','Carol','P','','','34','462175164','2821 HEDGEROW DR',0,'DALLAS','TX','75235','7535','CY','48113','1958-02-09','F','U',NULL,'N','021','DEN','3658115','33348TX002000201','2014-03-01','2014-02-13 22:43:18','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:11'),(23472,18695,'N','01','021','EC','A',NULL,NULL,'','0001090790','0001086127','','IL','1','Craton','Ethel','Denice','','','34','461988375','1221 FM 318',0,'HALLETTSVILLE','TX','77964','4952','CY','48285','1954-04-20','F','',':RET:2054-5','N','021','DEN','3256092','33348TX002000201','2014-03-01','2014-02-13 16:23:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:49'),(13212,10543,'Y','18','021','EC','A','','','AC','0000590828','0000590828','TX00000959866','IL','1','Deuel','John','','','','34','397963868','1108 N VAN BUREN ST',0,'SAN ANGELO','TX','76901','2108','CY','48451','1986-09-09','M','U',':RET:2106-3','N','021','DEN','1964095','33348TX002000201','2014-01-01','2013-12-22 18:42:15','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-26 12:55:16'),(20313,16216,'Y','18','024','14','A','','','TE','0000266829','0000266829','','IL','1','BALDWIN','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-10-22','M','',NULL,NULL,NULL,'','2936778','','2014-01-28','2014-01-28 12:58:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:50'),(3210,2582,'N','01','021','EC','A',NULL,NULL,'','0000612954','0000659868','','IL','1','Fritsch','Natosha','','','','34','298800636','832 SUNCREEK CT',0,'CINCINNATI','OH','45238','4836','CY','39061','1980-04-18','F','',':RET:2106-3','N','021','DEN','464939','99734OH005000301','2014-01-01','2013-11-01 13:54:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:45:24'),(5846,4643,'Y','18','021','EC','A','','','AC','0000041024','0000041024','TX00001383280','IL','1','Chambless','Mark','','','','34','465252306','1121 OAKWOOD CIR',0,'KELLER','TX','76248','4010','CY','48439','1960-02-09','M','M',NULL,'N','021','DEN','1359914','33348TX002000201','2014-01-01','2013-12-24 00:15:34','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:40'),(25056,19869,'N','01','021','EC','A',NULL,NULL,'','0000541694','0000158041','','IL','1','Kamal','Aachema','','','','34','276083977','5309 EDGER DR',0,'CINCINNATI','OH','45239','7738','CY','39061','1970-04-12','F','',NULL,'N','021','DEN','3811040','99734OH005000401','2014-04-01','2014-02-20 10:07:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:01:20'),(5283,4186,'Y','18','021','EC','A','','','AC','0000150640','0000150640','OH00000640481','IL','1','Powers','Michael','T','','','34','274889007','4209 Story Road',0,'Fairview Park','OH','44126',NULL,'CY','39035','1979-04-29','M','U',':RET:2106-3','T','021','HLT','1991040','52664OH151001306','2014-01-01','2013-12-19 14:50:51','214.00',NULL,NULL,'351.15','137.15','R-OH011','OH0','351.15',NULL,0,'2013-12-25 23:05:49'),(15478,12382,'Y','18','021','EC','A','','','AC','0000412219','0000412219','OH00000184232','IL','1','Misch','Timothy','','','','34','301583162','38 Lucy Run Road',0,'Amelia','OH','45102',NULL,'CY','39025','1958-03-19','M','U',':RET:2106-3','N','021','DEN','2102782','99734OH005000401','2014-02-01','2013-12-30 22:59:52','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,1,'2014-01-02 04:29:03'),(16301,13051,'Y','18','021','EC','A','','','AC','0001503374','0001503374','LA00002113778','IL','1','Palmisano','Dwayne','Michael','','Jr','34','436475286','103 FIELD ST',0,'BELLE CHASSE','LA','70037','1249','CY','22075','1980-07-17','M','M',':RET:2106-3','N','021','DEN','1619247','18575LA002000201','2014-02-01','2014-01-06 18:06:58','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:09'),(25605,20315,'Y','18','024','14','A','','','TE','0000416997','0000416997','','IL','1','atallah','khaled',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-11','M','',NULL,NULL,NULL,'','3105559','','2014-02-21','2014-02-21 21:11:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-26 08:30:04'),(26382,20929,'Y','18','021','EC','A','','','AC','0002266676','0002266676','LA00003044848','IL','1','Jewell','Baylor','Looper','','Sr','34','435907159','13544 MINOU AVE',0,'BATON ROUGE','LA','70809','5425','CY','22033','1955-12-16','M','R',':RET:2106-3','N','021','DEN','2951895','18575LA002000201','2014-04-01','2014-02-26 15:30:40','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61','CIC',0,'2014-02-28 07:00:20'),(396,326,'Y','18','021','EC','A','','','AC','0001158888','0001158888','OH00000287084','IL','1','Denbow','Linda','','','','34','284504888','3910 BURGUNDY BAY BLVD W',0,'MEDINA','OH','44256','8277','CY','39103','1951-06-12','F','M',NULL,'N','021','DEN','492350','99734OH005000401','2014-01-01','2013-12-03 20:02:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:46:02'),(949,782,'Y','18','021','EC','A','','','AC','0000477420','0000477420','OH00000852728','IL','1','Corson','Jonathan','','','','34','288801327','2237 Francis Lane',0,'Cincinnati','OH','45206',NULL,'CY','39061','1983-01-14','M','U',':RET:2106-3','N','021','DEN','44864','99734OH005000301','2014-01-01','2013-10-29 00:31:06','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:31'),(4367,3469,'Y','18','021','EC','A','','','AC','0000510630','0000510630','OH00000254303','IL','1','DAMES','ANTHONY','LEO','','','34','268664354','10010 ADAMS AVE',0,'CLEVELAND','OH','44108',NULL,'CY','39035','1960-12-06','M','U',':RET:2054-5','T','021','DEN','310234','99734OH005000401','2014-01-01','2013-12-11 19:43:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:13'),(8135,6437,'Y','18','021','EC','A','','','AC','0000718880','0000718880','OH00000824759','IL','1','Borkovic','Samantha','','','','34','172702741','4410 LAKE RD',0,'CONNEAUT','OH','44030','1014','CY','39007','1988-04-22','F','U',':RET:2106-3','N','021','DEN','687132','99734OH005000301','2014-01-01','2013-11-22 15:21:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:15:39'),(3493,2805,'Y','18','021','EC','A','','','AC','0000271418','0000271418','OH00001235687','IL','1','Schwartz','Sharon','','','','34','284486443','7790 Sugar Grove Road',0,'Covington','OH','45318',NULL,'CY','39109','1954-01-14','F','M',':RET:2106-3','N','021','DEN','1993536','99734OH005000401','2014-01-01','2013-12-22 14:14:55','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:20:30'),(23059,18384,'N','19','021','EC','A',NULL,NULL,'','0001453637','0001359003','','IL','1','Shugars','Willliam','','','','34','414695422','18410 RIVER BEND RD',0,'MAUREPAS','LA','70449','5273','CY','22063','1991-04-18','M','',NULL,'T','021','DEN','3058622','18575LA002000201','2014-03-01','2014-02-12 11:33:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-12 21:30:50'),(24461,19433,'Y','18','021','EC','A','','','AC','0000971023','0000971023','TX00003003396','IL','1','Vandriver','Jason','','','','34','451916272','22800 BULVERDE RD',0,'SAN ANTONIO','TX','78261','3074','CY','48029','1981-12-04','M','R',':RET:2106-3','N','021','DEN','3041877','33348TX002000101','2014-04-01','2014-02-18 14:33:26','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-18 22:01:33'),(29099,23032,'Y','18','021','EC','A','','','AC','0000546532','0000546532','OH00003661329','IL','1','Crooker','Susan','','','','34','286703278','2818 US Highway 50',0,'Batavia','OH','45103',NULL,'CY','39025','1960-08-24','F','M',':RET:2106-3','N','021','HLT','3345399','92036OH004000601','2014-04-01','2014-03-10 10:13:18','326.00',NULL,NULL,'352.13','26.13','R-OH005','OH0','352.13',NULL,0,'2014-03-10 21:02:15'),(1195,984,'Y','18','021','EC','A','','','AC','0000780475','0000780475','OH00000876259','IL','1','Calio','Joseph','Charles','','III','34','286482741','338 North Cleveland Street',0,'Chagrin Falls','OH','44022',NULL,'CY','39035','1950-03-18','M','U',':RET:2106-3','N','021','DEN','578813','99734OH005000301','2014-01-01','2013-12-03 13:14:57','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:19:43'),(22279,17784,'Y','18','021','EC','A','','','AC','0000972399','0000972399','TX00001594032','IL','1','castro','rosaura','m','','','34','731124861','5107 BLANCO AVE',0,'EL PASO','TX','79905','3982','CY','48141','1952-06-20','F','U',':RET:2106-3','N','021','DEN','3209059','33348TX002000201','2014-03-01','2014-01-23 13:22:27','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-10 11:00:20'),(20334,16237,'Y','18','024','14','A','','','TE','0001129042','0001129042','','IL','1','Hrusovsky','Elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-02-16','F','',NULL,NULL,NULL,'','2065259','','2014-01-28','2014-01-28 12:33:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:01:04'),(19266,15355,'Y','18','021','EC','A','','','AC','0001012953','0001012953','OH00001628050','IL','1','ELMER','STEVEN','','','','34','292602695','1231 N SUPERIOR ST',0,'TOLEDO','OH','43604','1964','CY','39095','1961-08-02','M','M',':RET:2106-3','N','021','HLT','2452369','92036OH006002601','2014-03-01','2014-01-20 12:24:20','0.00',NULL,NULL,'301.86','301.86','R-OH001','OH0','301.86',NULL,0,'2014-01-21 08:46:52'),(1444,1204,'Y','18','021','EC','A','','','AC','0000629249','0000629249','OH00000758798','IL','1','HARPER','MARY','','','','34','301721292','388 W MAIN ST',0,'LEESBURG','OH','45135','9301','CY','39071','1962-09-15','F','U',NULL,'N','021','HLT','1727741','92036OH003000604','2014-01-01','2013-12-24 16:23:23','271.00',NULL,NULL,'418.11','147.11','R-OH005','OH0','418.11',NULL,0,'2013-12-25 18:47:55'),(17034,13629,'Y','18','021','EC','A','','','AC','0002124874','0002124874','LA00002418672','IL','1','Hawkins','Jessica','','','','34','438673343','1726 Albert St.',0,'Alexandria','LA','71301',NULL,'CY','22079','1978-08-11','F','U',':RET:2106-3','T','021','DEN','2486130','18575LA002000101','2014-02-01','2014-01-08 19:37:58','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-01-13 02:20:46'),(3117,2504,'N','01','021','EC','A',NULL,NULL,'','0000660186','0000658726','','IL','1','Waldron','Cindy','K','','','34','494629784','1538 DALY DR',0,'CORPUS CHRISTI','TX','78412','4714','CY','48355','1962-04-25','F','',NULL,'N','021','DEN','621702','33348TX002000201','2014-01-01','2013-10-12 22:51:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:30:11'),(16668,13339,'Y','18','021','EC','A','','','AC','0001249599','0001249599','OH00001493423','IL','1','Bangura','Crystal','','','','34','271785423','2640 Old Forge Road',0,'Columbus','OH','43209',NULL,'CY','39049','1970-07-09','F','M',':RET:2054-5','N','021','DEN','1977115','99734OH005000301','2014-02-01','2014-01-06 23:59:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:27'),(6839,5422,'Y','18','021','EC','A','','','AC','0001038561','0001038561','OH00000351175','IL','1','Cox','Joshua','','','','34','293921612','4890 ADA RD',0,'LIMA','OH','45801','9786','CY','39003','1985-08-17','M','U',':RET:2106-3','N','021','HLT','263730','92036OH006001501','2014-01-01','2013-11-14 05:29:05','0.00',NULL,NULL,'189.73','189.73','R-OH002','OH0','189.73',NULL,0,'2013-12-26 01:31:02'),(6257,4959,'Y','18','021','EC','A','','','AC','0000162235','0000162235','OH00001205909','IL','1','Cooper','Julian','','','','34','272805902','8217 DAVIS ST',0,'MASURY','OH','44438','1111','CY','39155','1983-03-01','M','U',NULL,'N','021','DEN','904938','99734OH005000401','2014-01-01','2013-10-06 20:47:14','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:32:10'),(15018,12004,'Y','18','021','EC','A','','','AC','0000213379','0000213379','OH00000531960','IL','1','McCane','Rachel','LYNN','','','34','272782506','4775 MATTHEW PL',0,'FAIRFIELD','OH','45014','1422','CY','39017','1981-05-14','F','M',':RET:2106-3','N','021','HLT','2233539','92036OH005001206','2014-02-01','2013-12-29 19:01:26','480.00',NULL,NULL,'620.19','140.19','R-OH004','OH0','253.96',NULL,0,'2014-01-01 12:02:13'),(9065,7194,'Y','18','024','14','A','','','TE','0000822879','0000822879','','IL','1','Moye','John','S',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-04-23','M','',NULL,NULL,NULL,'','606625','','2013-12-18','2013-12-18 16:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:06:28'),(14382,11471,'N','01','021','EC','A',NULL,NULL,'','0000683399','0000049497','','IL','1','Anderson','Sunce','Raye','','','34','282643262','5381 E TOWNSHIP ROAD 138',0,'TIFFIN','OH','44883','9688','CY','39147','1957-03-20','F','',':RET:2106-3','N','021','DEN','1908980','99734OH005000401','2014-02-01','2013-12-27 12:39:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:47'),(13935,11115,'Y','18','021','EC','A','','','AC','0000227057','0000227057','OH00000392459','IL','1','Zaborowski','Andrew',NULL,NULL,NULL,NULL,NULL,'6138 Bahiamar Rd',0,'Toledo','OH','43611',NULL,'CY','39095','1983-10-01','M','U',NULL,'N','021','HLT','2279200','92036OH004002601','2014-01-01','2013-12-23 14:12:07','142.00',NULL,NULL,'177.96','35.96','R-OH001','OH0','177.96',NULL,0,'2013-12-26 13:14:36'),(23043,18370,'N','01','021','EC','A',NULL,NULL,'','0000490513','0000249401','','IL','1','Sadler','Angela','Renee','','','34','450830737','1604 GLENWICK DR',0,'PLANO','TX','75075','4201','CY','48085','1975-07-21','F','',':RET:2106-3','N','021','DEN','2710583','33348TX002000201','2014-03-01','2014-02-12 10:17:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-12 21:30:41'),(24602,19529,'Y','18','021','EC','A','','','AC','0000788253','0000788253','OH00002089912','IL','1','Sexton','Ryan','','','','34','286809279','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','1983-06-24','M','M',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:12:52'),(24626,19545,'Y','18','021','EC','A','','','AC','0001888236','0001888236','LA00002558648','IL','1','CAREY','DENISE','RENDELL','','','34','438597142','36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1972-09-30','F','U',':RET:2054-5','N','021','DEN','2875540','18575LA002000201','2014-04-01','2014-02-19 09:07:11','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:17:06'),(25555,20275,'N','19','021','EC','A',NULL,NULL,'','0000638562','0000141558','','IL','1','Greenwood','Lilionna','','','','34','294151105','14533 UPPER CUMBERLAND RD',0,'MOUNT ORAB','OH','45154','9085','CY','39015','2010-03-25','F','',NULL,'N','021','HLT','3140999','92036OH004000601','2014-04-01','2014-02-23 08:34:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-26 08:00:21'),(25568,20283,'Y','18','021','EC','A','','','AC','0001161585','0001161585','OH00002445913','IL','1','ndagire','sarah','','','','34','297968417','2834 E 128TH ST',0,'CLEVELAND','OH','44120','2157','CY','39035','1974-07-11','F','U',NULL,'N','021','HLT','2695016','52664OH152000901','2014-04-01','2014-02-23 16:49:23','0.00',NULL,NULL,'232.49','232.49','R-OH011','OH0','232.49',NULL,0,'2014-02-26 08:00:28'),(25700,20389,'N','19','021','EC','A',NULL,NULL,'','0000409368','0000435994','','IL','1','VENEGAS','DANIEL','','','','34','627542505','2412 DURHAM AVE',0,'BROWNWOOD','TX','76801','4921','CY','48049','1996-07-19','M','',':RET:2106-3','N','021','DEN','2644264','33348TX002000201','2014-04-01','2014-02-24 12:09:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-26 09:30:18'),(26183,20764,'Y','18','021','EC','A','','','AC','0000500447','0000500447','OH00003044872','IL','1','JONATHAN','DAVID','','','','34','292598994','5732 AINSLEY AVE',0,'COLUMBUS','OH','43230','8334','CY','39049','1980-05-15','M','U',NULL,'N','021','DEN','3128771','99734OH005000301','2014-04-01','2014-02-26 22:20:47','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:41'),(26844,21275,'N','01','021','EC','A',NULL,NULL,'','0001809850','0001975776','','IL','1','Sims','Patrice','','','','34','433134373','2625 S BIRCHFIELD DR',0,'HARVEY','LA','70058','2014','CY','22051','1961-08-16','F','',':RET:2054-5','N','021','DEN','3645119','18575LA002000201','2014-04-01','2014-03-01 09:43:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-01 21:00:46'),(27959,22119,'Y','18','021','EC','A','','','AC','0001252249','0001252249','LA00002433493','IL','1','Lane','Heather','','','','34','616384713','808 Congress St',0,'New Orleans','LA','70117',NULL,'CY','22071','1986-11-26','F','U',':RET:2106-3','N','021','DEN','3112159','18575LA002000201','2014-04-01','2014-03-05 18:40:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:43'),(13866,11062,'N','19','021','EC','A',NULL,NULL,'','0000166374','0000477454','','IL','1','Thompson','Kasena','Marie',NULL,NULL,NULL,NULL,'1677 LILLIAN RD',0,'STOW','OH','44224','2536','CY','39153','2001-05-18','F','',':RET:2106-3','N','021','HLT','1593182','52664OH151001501','2014-01-01','2013-12-23 07:53:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 13:12:54'),(22668,18102,'Y','18','021','EC','A','','','AC','0000944473','0000944473','TX00001924084','IL','1','Crane','Larry','','','','34','466984037','16711 Mount Everest',0,'San Antonio','TX','78232',NULL,'CY','48029','1951-08-19','M','M',':RET:2106-3','N','021','DEN','3767581','33348TX002000201','2014-03-01','2014-02-11 15:09:00','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-02-11 21:00:40'),(22591,18044,'Y','18','021','EC','A','','','AC','0000740319','0000740319','OH00001768463','IL','1','sadin','omar','','','','34','281903782','2750 127th st',0,'toledo','OH','43611',NULL,'CY','39095','1982-01-21','M','R',NULL,'T','021','HLT','3740299','92036OH006002601','2014-03-01','2014-02-10 14:45:57','0.00',NULL,NULL,'210.39','210.39','R-OH001','OH0','210.39',NULL,0,'2014-02-10 21:32:09'),(22374,17867,'Y','18','021','EC','A','','','AC','0000489284','0000489284','OH00001669950','IL','1','Hull','Frank','','','','34','606033113','2218 KEMPER LN',0,'CINCINNATI','OH','45206','2719','CY','39061','1987-06-09','M','U',':RET:2106-3','N','021','HLT','3352506','92036OH004001201','2014-03-01','2014-02-09 18:23:51','47.00',NULL,NULL,'176.75','129.75','R-OH004','OH0','176.75',NULL,0,'2014-02-10 21:30:04'),(21547,17212,'Y','18','021','EC','A','','','AC','0000406168','0000406168','OH00001855401','IL','1','mccarty','jessica','','','','34','282888050','304 n. catherine st.',0,'mount vernon','OH','43050',NULL,'CY','39083','1981-05-12','F','M',':RET:2106-3','T','021','DEN','3825371','99734OH005000401','2014-03-01','2014-02-05 11:28:49','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:12'),(15680,12542,'Y','18','024','14','A','','','TE','0000401227','0000401227','','IL','1','Roehm','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-30','M','',NULL,NULL,NULL,'','128049','','2013-12-31','2013-12-31 10:46:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:34:56'),(18580,14815,'N','01','021','EC','A',NULL,NULL,'','0001043414','0001186339','','IL','1','cover','joyce','','','','34','278522031','1128 county road 620',0,'ashland','OH','44805',NULL,'CY','39005','1952-07-20','F','',NULL,'N','021','HLT','2632161','52664OH151001501','2014-02-01','2014-01-15 00:40:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2014-01-16 08:47:08'),(20573,16443,'Y','18','021','EC','A','','','AC','0000683413','0000683413','OH00002527000','IL','1','WILFERT','AMY','','','','34','281525281','6330 CAMBRIDGE AVE',0,'CINCINNATI','OH','45230','1986','CY','39061','1967-05-11','F','U',NULL,'N','021','HLT','2746447','92036OH003001201','2014-03-01','2014-01-29 17:36:19','148.00',NULL,NULL,'620.98','472.98','R-OH004','OH0','336.26',NULL,0,'2014-01-29 21:01:54'),(23579,18786,'Y','18','021','EC','A','','','AC','0000976769','0000976769','OH00002622552','IL','1','TODD','JUDY','','','','34','403748372','1796 ANTIOCH RD',0,'HAMERSVILLE','OH','45130','9534','CY','39025','1949-11-02','F','M',NULL,'N','021','HLT','2645290','92036OH004000601','2014-03-01','2014-02-13 12:34:20','346.00',NULL,NULL,'517.83','171.83','R-OH005','OH0','517.83',NULL,0,'2014-02-13 22:02:56'),(27709,21911,'N','01','021','EC','A',NULL,NULL,'','0001151267','0001073054','','IL','1','LOPEZ','DAVID','','','','34','616205746','16510 SPERRY GARDENS DR',0,'HOUSTON','TX','77095','5551','CY','48201','1966-01-05','M','',NULL,'N','021','DEN','3295852','33348TX002000201','2014-04-01','2014-03-05 12:29:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-05 21:30:52'),(28453,22515,'Y','18','021','EC','A','','','AC','0001361043','0001361043','LA00003391035','IL','1','EL-AMIN','ALMIRE','','','','34','439372759','146 HOOVER DR',0,'SLIDELL','LA','70461','2212','CY','22103','1974-04-26','F','U',NULL,'T','021','DEN','3452520','18575LA002000201','2014-04-01','2014-03-07 12:27:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:21'),(250,208,'Y','18','021','EC','A','','','AC','0000624089','0000624089','LA00000354278','IL','1','Cazes','Wilson','','','','34','439842819','3515 POYDRAS BAYOU DR',0,'PORT ALLEN','LA','70767','5417','CY','22121','1952-05-29','M','M',':RET:2106-3','N','021','DEN','445601','18575LA002000101','2014-01-01','2013-12-05 00:08:18','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-25 17:21:33'),(23040,18368,'Y','18','021','EC','A','','','AC','0000386746','0000386746','TX00001413962','IL','1','Lollar','Evelyn','','','','34','450707292','2400 IRENE DR',0,'AMARILLO','TX','79107','6407','CY','48375','1951-11-09','F','M',':RET:2054-5','N','021','DEN','3456911','33348TX002000201','2014-03-01','2014-02-12 17:36:06','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-12 21:30:39'),(2620,2130,'Y','18','021','EC','A','','','AC','0000868198','0000868198','OH00000700733','IL','1','Roberts','Ronald','','','','34','189549222','852 Kenmore Blvd.',0,'Akron','OH','44314',NULL,'CY','39153','1965-07-29','M','U',':RET:2106-3','T','021','DEN','534561','99734OH005000401','2014-01-01','2013-12-02 17:26:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:45:50'),(6918,5491,'Y','18','021','EC','A','','','AC','0000573059','0000573059','OH00000995567','IL','1','Perazzo','Janna','','','','34','297849235','2344 CANDLEMAKERS LN',0,'MAINEVILLE','OH','45039','8702','CY','39165','1986-08-27','F','U',':RET:2106-3','N','021','DEN','1918679','99734OH005000401','2014-01-01','2013-12-24 18:25:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:07'),(20691,16534,'Y','18','021','EC','A','','','AC','0000854219','0000854219','OH00001852730','IL','1','Henry','Matthew','','','','34','576629098','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1953-07-14','M','M',NULL,'N','021','DEN','2798559','99734OH005000301','2014-03-01','2014-01-30 11:12:51','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:59'),(19115,15230,'N','19','021','EC','A',NULL,NULL,'','0001183547','0000990083','','IL','1','Greer','Naveda','','','','34','873951558','2605 Aberdeen Drive',0,'Findlay','OH','45840',NULL,'CY','39063','2011-12-06','F','',':RET:2106-3','N','021','HLT','1651645','92036OH005001501','2014-03-01','2014-01-18 10:03:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-01-21 08:44:47'),(5696,4520,'Y','18','021','EC','A','','','AC','0000865825','0000865825','OH00000162419','IL','1','Harris','Janet','','','','34','288547119','2371 CALL RD',0,'STOW','OH','44224','1538','CY','39153','1956-09-20','F','M',':RET:2106-3','N','021','HLT','980621','52664OH151001501','2014-01-01','2013-11-26 15:56:22','463.00',NULL,NULL,'651.81','188.81','R-OH012','OH0','651.81',NULL,0,'2013-12-25 23:32:45'),(14037,11182,'Y','18','021','EC','A','','','AC','0001068267','0001068267','OH00000867527','IL','1','GEESLIN','HEATHER','','','','34','296808602','385 GEESLIN RD',0,'SEAMAN','OH','45679',NULL,'CY','39001','1971-03-28','F','M',':RET:2106-3','T','021','HLT','2324378','92036OH006000601','2014-01-01','2013-12-23 15:28:27','157.00',NULL,NULL,'259.42','102.42','R-OH005','OH0','259.42',NULL,0,'2013-12-26 13:17:03'),(25607,20317,'Y','18','021','EC','A','','','AC','0000992667','0000992667','TX00002643748','IL','1','Aziz','Abdul','','','','34','467812372','23827 SHAW PERRY LN',0,'KATY','TX','77493','3563','CY','48201','1958-09-21','M','M',':RET:2028-9','N','021','DEN','2854254','33348TX002000201','2014-04-01','2014-02-21 23:02:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 08:30:05'),(27366,21671,'N','19','021','EC','A',NULL,NULL,'','0000822115','0000866957','','IL','1','Poteet','Justin','M','','','34','275981587','4913 BATH RD',0,'DAYTON','OH','45424','1756','CY','39057','1994-12-08','M','',':RET:2106-3','N','021','DEN','2782074','99734OH005000401','2014-04-01','2014-03-04 17:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:14'),(1334,1104,'Y','18','021','EC','A','','','AC','0000729939','0000729939','OH00000051853','IL','1','Sutton','Sheila','','','','34','277807087','6862 MELROSE LN',0,'MIDDLETOWN','OH','45044','7230','CY','39165','1969-05-03','F','U',NULL,'N','021','HLT','652667','92036OH001001201','2014-01-01','2013-10-25 16:06:38','112.00',NULL,NULL,'361.74','249.74','R-OH004','OH0','361.74',NULL,0,'2013-12-25 18:32:11'),(13156,10495,'Y','18','021','EC','A','','','AC','0001153615','0001153615','OH00000043438','IL','1','Vance','Felicia','Joan','','','34','273820045','4454 BROADBUSH DR',0,'TROTWOOD','OH','45426','1906','CY','39113','1977-07-22','F','U',':RET:2054-5','N','021','DEN','1709605','99734OH005000401','2014-01-01','2013-12-23 17:30:01','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:53:43'),(13802,11016,'N','19','021','EC','A',NULL,NULL,'','0000615442','0000563538','','IL','1','Stewart','Raven','','','','34','605525140','1445 GATES RD',0,'COLUMBIA','MS','39429','5042','CY','28091','1991-02-06','F','',':RET:2054-5','N','021','DEN','2044531','46300MS002000101','2014-01-01','2013-12-23 12:45:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-26 13:11:23'),(14531,11594,'Y','18','021','EC','A','','','AC','0000889313','0000889313','MS00000060555','IL','1','Darin','Rachel','','','','34','385902364','413 MAINSAIL WAY',0,'BRANDON','MS','39047','7037','CY','28121','1981-11-18','F','U',':RET:2106-3','N','021','DEN','1838092','46300MS002000201','2014-02-01','2013-12-26 19:15:24','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:34'),(16898,13522,'N','19','021','EC','A',NULL,NULL,'','0000980556','0001170856','','S1','1','Murphy','Delonte','','','','34','271175664','1077 JUNE DR',0,'XENIA','OH','45385','3725','CY','39057','2011-01-04','F','',':RET:2054-5^:RET:2106-3','N','021','DEN','1449712','99734OH005000401','2014-02-01','2014-01-09 10:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:19:31'),(24160,19197,'Y','18','021','EC','A','','','AC','0000596322','0000596322','OH00002300641','IL','1','Kenner','Jason','','','','34','274822519','3091 Elijah Parkway',0,'Lima','OH','45805',NULL,'CY','39003','1984-03-16','M','U',':RET:2054-5','N','021','HLT','3323049','92036OH003001501','2014-03-01','2014-02-14 20:17:40','33.00',NULL,NULL,'257.18','224.18','R-OH002','OH0','257.18',NULL,0,'2014-02-15 22:02:03'),(24606,19531,'Y','18','021','EC','A','','','AC','0001217400','0001217400','OH00002264402','IL','1','Day','Barbara','','','','34','279425023','11651 Norbourne Drive',0,'Forest Park','OH','45240',NULL,'CY','39061','1952-09-01','F','U',':RET:2106-3','N','021','DEN','3746766','99734OH005000301','2014-04-01','2014-02-19 16:52:05','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:13:24'),(25158,19956,'N','01','021','EC','A',NULL,NULL,'','0000081161','0000973892','','IL','1','marek','joe','','','','34','449084446','16 TROUT ST',0,'PALACIOS','TX','77465','1751','CY','48239','1956-04-20','M','',':RET:2106-3','N','021','DEN','2650205','33348TX002000201','2014-04-01','2014-02-21 16:25:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-21 22:00:20'),(25924,20559,'Y','18','021','EC','A','','','AC','0000327020','0000327020','TX00001976808','IL','1','Grant','Crystal','','','','34','462756659','5518 W. Loop 281',0,'Longview','TX','75602',NULL,'CY','48183','1985-08-08','F','U',':RET:2054-5','N','021','DEN','2854358','33348TX002000201','2014-03-01','2014-02-26 15:58:09','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-26 21:01:22'),(27783,21973,'Y','18','021','EC','A','','','AC','0000575588','0000575588','MS00003115084','IL','1','Ollie','Folser','','','','34','426027952','302 E WASHINGTON ST',0,'MOORHEAD','MS','38761','6615','CY','28133','1957-03-03','M','U',':RET:2054-5','N','021','DEN','3522051','46300MS002000201','2014-04-01','2014-03-04 18:37:48','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-05 21:31:35'),(45,40,'Y','18','021','EC','A','','','AC','0000977149','0000977149','MS00000593687','IL','1','Evers Johnson','Wanda','','','','34','326603008','1341 ROCKDALE DR',0,'JACKSON','MS','39213','4837','CY','28049','1958-11-24','F','U',':RET:2054-5','T','021','DEN','1026677','46300MS002000101','2014-01-01','2013-12-04 18:21:17','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 17:16:11'),(15083,12056,'Y','18','021','EC','A','','','AC','0000115482','0000115482','TX00001751807','IL','1','BERNAL','TERESITA','','','','34','457118552','1810 SHERMAN ST',0,'LAREDO','TX','78040','1022','CY','48479','1969-12-14','F','U',NULL,'N','021','DEN','2166030','33348TX002000101','2014-02-01','2013-12-30 12:45:32','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-01-01 12:04:13'),(14640,11684,'Y','18','021','EC','A','','','AC','0000465746','0000465746','TX00001255924','IL','1','Young','Dontavia','','','','34','452912465','801 Enterprise',0,'Houston','TX','77088',NULL,'CY','48201','1987-06-29','F','U',':RET:2054-5','N','021','DEN','2607155','33348TX002000101','2014-02-01','2013-12-28 10:40:01','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,1,'2013-12-29 11:07:24'),(1175,967,'N','01','021','EC','A',NULL,NULL,'','0000820976','0000882821','','IL','1','Smith','Mary','C','','','34','288544966','1715 Arndale Rd.',0,'Stow','OH','44224',NULL,'CY','39153','1952-10-27','F','',':RET:2106-3','N','021','HLT','244527','52664OH151001501','2014-01-01','2013-12-03 14:12:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2013-12-25 18:19:14'),(14094,11231,'N','01','021','EC','A',NULL,NULL,'','0000751021','0000863474','','IL','1','LEA','ALICE','','','','34','280564305','718 TRENTON AVE',0,'CINCINNATI','OH','45205','2045','CY','39061','1954-04-26','F','',':RET:2106-3','N','021','DEN','2204407','99734OH005000401','2014-02-01','2013-12-26 11:15:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:25'),(13127,10469,'Y','18','021','EC','A','','','AC','0000155774','0000155774','OH00000324505','IL','1','hiser','timothy','','','','34','295845878','222 IDAHO AVE',0,'LORAIN','OH','44052','2160','CY','39093','1976-11-24','M','M',':RET:2106-3','T','021','DEN','2199786','99734OH005000401','2014-01-01','2013-12-23 14:25:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:55'),(9503,7538,'Y','18','021','EC','A','','','AC','0000112924','0000112924','OH00000313711','IL','1','Shimpo','Kimberly','','','','34','444686439','1730 KINGSLEY AVE',0,'AKRON','OH','44313','6109','CY','39153','1974-05-02','F','M',':RET:2106-3','N','021','DEN','1955187','99734OH005000401','2014-01-01','2013-12-21 15:27:12','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:35:14'),(9243,7331,'N','01','021','EC','A',NULL,NULL,'','0000755986','0000813077','','IL','1','Halton','Tracey',NULL,NULL,NULL,NULL,NULL,'491 STONELEDGE DR',0,'RICHMOND HTS','OH','44143','2582','CY','39035','1966-04-29','F','',NULL,'N','021','HLT','1570631','92036OH004000801','2014-01-01','2013-12-18 17:19:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.84',NULL,0,'2013-12-26 04:10:41'),(1684,1406,'Y','18','021','EC','A','','','AC','0001847168','0001847168','LA00000102641','IL','1','Bouie','Shalonda','','','','34','434710132','4740 LAFAYE ST',0,'NEW ORLEANS','LA','70122','6136','CY','22071','1981-09-25','F','U',NULL,'N','021','DEN','1890095','18575LA002000101','2014-01-01','2013-12-24 14:24:35','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:54:15'),(20562,16432,'Y','18','021','EC','A','','','AC','0001099214','0001099214','OH00002362200','IL','1','Gill','Kenna','','','','34','302064970','5009 ROOSEVELT AVE',0,'MIDDLETOWN','OH','45044','6227','CY','39017','2002-08-09','F','U',':RET:2106-3','N','021','HLT','3462844','92036OH006001201','2014-03-01','2014-01-29 13:07:53','73.43',NULL,NULL,'108.11','34.68','R-OH004','OH0','108.11',NULL,0,'2014-01-29 21:01:47'),(21766,17381,'N','01','021','EC','A',NULL,NULL,'','0000978977','0000265519','','IL','1','Morales','Alfredo','','','','34','564917941','692 COUNTY ROAD 3810',0,'TROUP','TX','75789','8522','CY','48073','1986-09-23','M','',NULL,'N','021','DEN','3803032','33348TX002000201','2014-03-01','2014-02-06 16:49:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:29'),(21846,17445,'N','19','021','EC','A',NULL,NULL,'','0000915679','0000684853','','IL','1','Gaglione','Anna','','','','34','271961669','334 STANTON HALL CT',0,'KETTERING','OH','45429','1851','CY','39113','1992-10-26','F','',':RET:2106-3','N','021','DEN','3130763','99734OH005000301','2014-03-01','2014-02-06 11:42:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:13'),(23338,18601,'N','01','021','EC','A',NULL,NULL,'','0001016891','0000403698','','IL','1','mccandless','dolores','ruth','','','34','233047125','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1959-11-19','F','',':RET:2106-3','N','021','DEN','3403625','99734OH005000301','2014-03-01','2014-02-12 18:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:36'),(24456,19428,'Y','18','021','EC','A','','','AC','0000056295','0000056295','MS00002516509','IL','1','FLEMONS','TASHA','','','','34','587315672','225 COUNTY ROAD 271',0,'OXFORD','MS','38655','8759','CY','28071','1974-09-09','F','U',':RET:2054-5','N','021','DEN','3244172','46300MS002000101','2014-04-01','2014-02-18 11:34:42','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-18 22:01:29'),(28179,22299,'N','19','021','EC','A',NULL,NULL,'','0000955603','0000204614','','IL','1','Hennies','Ashley','Nicole','','','34','299983358','3179 Kennedy-Ford Rd.',0,'Bethel','OH','45106',NULL,'CY','39025','1996-05-01','F','',':RET:2106-3','N','021','HLT','3288625','92036OH004000601','2014-04-01','2014-03-06 13:25:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-03-06 21:02:53'),(4881,3870,'Y','18','021','EC','A','','','AC','0000470435','0000470435','TX00000706534','IL','1','HAMM','PURVIS','','','','34','594622361','7802 MERRYWOOD',0,'SAN ANTONIO','TX','78250','3064','CY','48029','1968-02-16','M','U',NULL,'N','021','DEN','947601','33348TX002000201','2014-01-01','2013-10-10 01:54:34','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 22:31:14'),(16351,13087,'Y','18','021','EC','A','','','AC','0001097796','0001097796','OH00002338288','IL','1','KUHEN','THERESA','','','','34','285885811','15142 S STATE AVE',0,'MIDDLEFIELD','OH','44062','9467','CY','39055','1976-02-05','F','U',':RET:2106-3','T','021','DEN','1746430','99734OH005000301','2014-02-01','2014-01-06 09:27:30','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-07 04:02:29'),(15004,11993,'Y','18','021','EC','A','','','AC','0000083698','0000083698','TX00001350149','IL','1','Middleton','Robin','','','','34','627206541','1315 RIVERCHASE DR',0,'COPPELL','TX','75019','6763','CY','48113','1990-10-02','F','U',':RET:2054-5','N','021','DEN','1491234','33348TX002000201','2014-02-01','2013-12-30 18:23:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:01:49'),(14913,11915,'Y','18','021','EC','A','','','AC','0001030380','0001030380','OH00000996900','IL','1','Thompson','Mark','','','','34','290748003','10817 FALLSINGTON CT',0,'BLUE ASH','OH','45242','4233','CY','39061','1977-10-31','M','U',':RET:2106-3','N','021','DEN','2359967','99734OH005000401','2014-02-01','2013-12-28 20:40:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-30 00:01:29'),(1051,862,'Y','18','021','EC','A','','','AC','0000179222','0000179222','TX00000084814','IL','1','ZAMORA','NORALBA','','','','34','452613447','2452 MUNICH ST',0,'BROWNSVILLE','TX','78520','3871','CY','48061','1977-09-02','F','U',':RET:2106-3','N','021','DEN','573792','33348TX002000201','2014-01-01','2013-12-03 12:20:20','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:16:02'),(9218,7313,'Y','18','024','14','A','','','TE','0001021436','0001021436','','IL','1','bailey','jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-09-05','F','',NULL,NULL,NULL,'','941002','','2013-12-18','2013-12-18 11:14:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:10:07'),(4122,3292,'Y','18','024','14','A','','','TE','0001133930','0001133930','','IL','1','Fineran','Andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-11-30','M','',NULL,NULL,NULL,'','435071','','2013-12-16','2013-12-16 22:51:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:48:13'),(4204,3343,'N','01','021','EC','A',NULL,NULL,'','0000360260','0000738440','','IL','1','Lambert','Darrell','','','','34','452214738','P.O. Box 566',0,'Alpine','TX','79831',NULL,'CY','48043','1957-02-26','M','',':RET:2106-3','N','021','DEN','2298101','33348TX002000201','2014-01-01','2013-12-16 20:25:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:49:59'),(3133,2518,'Y','18','021','EC','A','','','AC','0000321005','0000321005','OH00000181567','IL','1','Shupp','Steven','','','','34','294609847','502 W BREMEN ST',0,'NEW KNOXVILLE','OH','45871','9746','CY','39011','1975-01-27','M','U',NULL,'T','021','HLT','842123','92036OH004001501','2014-01-01','2013-10-13 14:26:15','0.00',NULL,NULL,'253.59','253.59','R-OH002','OH0','253.59',NULL,0,'2013-12-25 20:30:35'),(4563,3613,'Y','18','021','EC','A','','','AC','0000278304','0000278304','OH00000131204','IL','1','Piesciuk','Stephen','','','','34','066469661','3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-07-18','M','M',':RET:2106-3','N','021','HLT','605789','52664OH152000901','2014-01-01','2013-12-12 18:11:21','559.00',NULL,NULL,'796.12','237.12','R-OH012','OH0','398.06',NULL,0,'2013-12-25 22:04:45'),(16439,13153,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00002191904','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','2200218','52664OH152000901','2014-02-01','2014-01-06 17:02:50','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,0,'2014-01-07 04:05:02'),(18522,14769,'Y','18','021','EC','A','','','AC','0000786154','0000786154','TX00001534257','IL','1','Zeppa','Aubrey','','','','34','455715736','311 N TENNANT ST',0,'DALLAS','TX','75208','5652','CY','48113','1984-10-20','F','U',':RET:2106-3','N','021','DEN','2971402','33348TX002000101','2014-02-01','2014-01-15 13:16:35','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-16 08:46:38'),(25208,19996,'Y','18','021','EC','A','','','AC','0000048243','0000048243','OH00002615098','IL','1','alexander','glenn','','','','34','295508078','11391 GIRDLED RD',0,'PAINESVILLE','OH','44077','8544','CY','39085','1954-02-12','M','U',':RET:2106-3','N','021','DEN','3760966','99734OH005000301','2014-04-01','2014-02-20 18:43:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:50'),(27691,21900,'Y','18','021','EC','A','','','AC','0000809678','0000809678','TX00002765369','IL','1','BELACYUEC','Esperanza','','','','34','462257367','2814 LAWTON ST',0,'CORPUS CHRISTI','TX','78405','2953','CY','48355','1959-09-28','F','M',NULL,'N','021','DEN','3356914','33348TX002000201','2014-04-01','2014-03-05 09:54:12','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-03-05 21:30:44'),(637,527,'Y','18','021','EC','A','','','AC','0000008404','0000008404','OH00000243222','31','1','Williams','Thomas','','','','34','098443673','6956 E Broad St',0,'Columbus','OH','43213',NULL,'CY','39049','1951-07-16','M','U',':RET:2106-3','N','021','DEN','1989374','99734OH005000401','2014-01-01','2013-12-16 14:00:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:01:15'),(6206,4918,'Y','18','021','EC','A','','','AC','0000481028','0000481028','OH00000932880','IL','1','Moore','Erica','Jane','','','34','283820184','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1984-07-08','F','U',NULL,'N','021','DEN','1245273','99734OH005000401','2014-01-01','2013-10-16 20:05:20','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:30:44'),(6199,4912,'Y','18','024','14','A','','','TE','0000443414','0000443414','','IL','1','Goodhew','Julie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-08-22','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-15 22:57:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:30:34'),(2505,2040,'Y','18','021','EC','A','','','AC','0000913404','0000913404','LA00000553962','IL','1','Kornbacher','Karen','','','','34','435339999','2609 MCHUGH RD',0,'BAKER','LA','70714','2435','CY','22033','1967-08-07','F','M',':RET:2054-5','T','021','DEN','149521','18575LA002000201','2014-01-01','2013-12-09 17:54:06','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:36:06'),(13978,11138,'N','19','021','EC','A',NULL,NULL,'','0000553911','0000120084','','IL','1','Hundley','Rachel',NULL,NULL,NULL,NULL,NULL,'192 COUNTRY VIEW DR',0,'HARRISON','OH','45030',NULL,'CY','39061','1991-11-14','F','',':RET:2106-3','N','021','HLT','2519518','92036OH004001201','2014-01-01','2013-12-23 11:07:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2013-12-26 13:15:32'),(4135,3300,'N','19','021','EC','A',NULL,NULL,'','0000843322','0000975221','','IL','1','Cater','Joyce','','','','34','217235922','9871 N POINTE CIR',0,'BRECKSVILLE','OH','44141','3186','CY','39035','1989-02-11','F','',':RET:2106-3','N','021','DEN','2040203','99734OH005000301','2014-01-01','2013-12-17 10:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:28'),(3862,3092,'Y','18','021','EC','A','','','AC','0000413848','0000413848','LA00000503335','IL','1','Butler','Barbara','','','','34','433942266','2965 Charlotte Drive',0,'Baton Rouge','LA','70814',NULL,'CY','22033','1955-11-19','F','M',':RET:2054-5','N','021','DEN','898796','18575LA002000201','2014-01-01','2013-12-12 20:41:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:35:58'),(23826,18958,'Y','18','021','EC','A','','','AC','0000246689','0000246689','MS00002041651','IL','1','Jones','Richard','','','','34','426396135','4786 OLD 8TH STREET RD N',0,'MERIDIAN','MS','39307','9781','CY','28075','1966-06-19','M','M',NULL,'N','021','DEN','2787857','46300MS002000101','2014-03-01','2014-02-13 22:36:14','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-02-14 21:31:43'),(25018,19837,'N','19','021','EC','A',NULL,NULL,'','0001199554','0001038656','','IL','1','Burnett','Artemis','','','','34','285049883','601 SUNCREST DR',0,'SPRINGFIELD','OH','45503','5308','CY','39023','1999-09-08','F','',NULL,'N','021','DEN','2940508','99734OH005000301','2014-04-01','2014-02-20 14:58:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:00:55'),(4190,3333,'N','01','021','EC','A',NULL,NULL,'','0000310844','0000789656','','IL','1','Exline','Cyleen','Michelle','','','34','298860016','1300 BRIMFIELD DR',0,'KENT','OH','44240','6949','CY','39133','1987-08-10','F','',':RET:2106-3','N','021','HLT','2086773','52664OH151001306','2014-01-01','2013-12-17 14:34:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','228.36',NULL,0,'2013-12-25 21:49:38'),(15117,12083,'Y','18','021','EC','A','','','AC','0001237710','0001237710','OH00001665152','IL','1','Green','Michael','','','','34','227558347','1232 SOUTHLYN DR',0,'DAYTON','OH','45409','1634','CY','39113','1985-08-15','M','U',':RET:2054-5','N','021','DEN','1714454','99734OH005000301','2014-02-01','2013-12-30 15:26:01','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-01 12:05:08'),(15062,12040,'Y','18','021','EC','A','','','AC','0002273722','0002273722','LA00001359616','IL','1','Kirk','Stephen','','','','34','444923951','196 HOUSTON ST',0,'SIMSBORO','LA','71275','3457','CY','22061','1971-06-27','M','R',':RET:2106-3','T','021','DEN','1691363','18575LA002000201','2014-02-01','2013-12-30 15:25:40','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:03:36'),(2299,1872,'Y','18','021','EC','A','','','AC','0000448749','0000448749','OH00000545193','IL','1','Maghiar','Angelica','','','','34','272822331','3120 WESTMORELAND AVE NW',0,'CANTON','OH','44718','3339','CY','39151','1954-11-17','F','U',NULL,'N','021','DEN','1054982','99734OH005000301','2014-01-01','2013-12-09 16:53:23','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 19:30:56'),(2441,1989,'Y','18','021','EC','A','','','AC','0001097761','0001097761','OH00000233943','IL','1','Preto','Vickie','Renee','','','34','291466884','1206 WEISER AVE',0,'AKRON','OH','44314','1429','CY','39153','1959-02-26','F','M',':RET:2106-3','N','021','HLT','550597','52664OH151001306','2014-01-01','2013-12-09 17:00:20','862.00',NULL,NULL,'996.40','134.40','R-OH012','OH0','476.12',NULL,0,'2013-12-25 19:34:26'),(18086,14445,'Y','18','021','EC','A','','','AC','0001603134','0001603134','LA00002014392','31','1','Coker','Edward','','','','34','437089348','PO Box 454',0,'Forest Hill','LA','71430',NULL,'CY','22079','1957-08-20','M','M',':RET:2106-3','N','021','DEN','2437758','18575LA002000201','2014-02-01','2014-01-14 11:38:55','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-15 02:07:28'),(18433,14707,'Y','18','021','EC','A','','','AC','0001846150','0001846150','LA00002026203','IL','1','French','Ruby','','','','34','435062080','533 HICKORY BEND RD',0,'WEST MONROE','LA','71292','0179','CY','22073','1958-03-07','F','M',':RET:2054-5','N','021','DEN','1737037','18575LA002000201','2014-02-01','2014-01-15 16:42:17','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-16 08:45:59'),(22068,17616,'Y','18','021','EC','A','','','AC','0001182551','0001182551','TX00002126063','IL','1','Hazari','Kuntal','','','','34','632138653','2310 WHITE ST',0,'CLIFTON','TX','76634','1135','CY','48035','1987-02-11','M','M',':RET:2029-7','N','021','DEN','2629753','33348TX002000201','2014-03-01','2014-02-08 14:50:40','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:13'),(27006,21390,'Y','18','021','EC','A','','','AC','0000614154','0000614154','OH00003113897','IL','1','Gay','Rodney','','','','34','273589879','2600 Edgebrook Avenue',0,'Akron','OH','44312',NULL,'CY','39153','1957-05-26','M','M',':RET:2106-3','N','021','DEN','3605188','99734OH005000401','2014-04-01','2014-03-03 14:46:51','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00','CIC',0,'2014-03-03 21:00:04'),(28373,22452,'Y','18','021','EC','A','','','AC','0000175171','0000175171','OH00003270223','IL','1','Werring','Timothy','','','','34','293726808','4009 MOORE MARATHON RD',0,'WILLIAMSBURG','OH','45176','8231','CY','39025','1969-08-12','M','M',':RET:2106-3','N','021','HLT','4225138','92036OH005000601','2014-04-01','2014-03-07 10:43:35','223.00',NULL,NULL,'993.30','770.30','R-OH005','OH0','299.90',NULL,0,'2014-03-07 21:30:36'),(1346,1115,'Y','18','021','EC','A','','','AC','0000637346','0000637346','TX00000726946','IL','1','Momoh','Matthew','','','','34','233041486','11246 SIR WINSTON ST',0,'SAN ANTONIO','TX','78216','5450','CY','48029','1952-10-11','M','M',':RET:2054-5','N','021','DEN','1610654','33348TX002000101','2014-01-01','2013-12-24 08:47:00','0.00',NULL,NULL,'50.04','50.04','R-TX019','TX0','25.02',NULL,0,'2013-12-25 18:45:07'),(13850,11053,'N','19','021','EC','A',NULL,NULL,'','0000536920','0000643228','','IL','1','Cavin','Jeremiah','Michael','','','34','663242348','3714 Drexel Dr',0,'Toledo','OH','43612',NULL,'CY','39095','2012-10-19','M','',NULL,'N','021','HLT','1393906','92036OH002002601','2014-01-01','2013-12-23 15:11:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','143.00',NULL,0,'2013-12-26 13:12:35'),(13373,10680,'N','19','021','EC','A',NULL,NULL,'','0000636002','0000858485','','IL','1','Szilagyi','Marye','Phoebe Sullivan','','','34','272986180','18800 State Route 47 East',0,'Sidney','OH','45365',NULL,'CY','39149','1992-06-27','F','',':RET:2106-3','N','021','DEN','2046709','99734OH005000301','2014-01-01','2013-12-22 21:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:47'),(4044,3228,'Y','18','021','EC','A','','','AC','0000084029','0000084029','OH00000692509','IL','1','RAPPACH','LINDA','J','','','34','289523854','1251 E STATE ROUTE 350',0,'WILMINGTON','OH','45177','7145','CY','39027','1952-05-24','F','M',':RET:2106-3','N','021','DEN','2421570','99734OH005000401','2014-01-01','2013-12-17 11:34:22','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:46:11'),(18631,14851,'Y','18','021','EC','A','','','AC','0000815747','0000815747','TX00001360063','IL','1','McAlister','Kelsey','','','','34','644090581','4000 E Renner road',0,'richardson','TX','75082',NULL,'CY','48085','1989-05-03','F','U',':RET:2106-3','N','021','DEN','2814010','33348TX002000201','2014-02-01','2014-01-15 18:23:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:02'),(23192,18493,'Y','18','021','EC','A','','','AC','0000253089','0000253089','OH00001377310','IL','1','Walkerow','Robert','','','','34','283486765','496 Stephens Road',0,'Akron','OH','44312',NULL,'CY','39153','1949-08-03','M','M',':RET:2106-3','N','021','HLT','3316254','52664OH152000901','2014-03-01','2014-02-12 10:50:54','972.18',NULL,NULL,'972.18','0.00','R-OH012','OH0','490.00',NULL,0,'2014-02-12 21:32:04'),(23888,19002,'N','01','021','EC','A',NULL,NULL,'','0000217651','0000124256','','IL','1','Jackson','Sandra','','','','34','290582991','6955 EDENTON PLEASANT PLAIN RD',0,'PLEASANT PLAIN','OH','45162','9633','CY','39025','1959-11-13','F','',':RET:2106-3','N','021','HLT','3664199','92036OH003000605','2014-03-01','2014-02-14 08:08:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.63',NULL,0,'2014-02-14 21:32:16'),(25615,20323,'Y','18','021','EC','A','','','AC','0000329548','0000329548','TX00002182923','IL','1','Rodriguez','Noemi','D','','','34','464926121','4742 Rodgerson Dr',0,'Corpus Christ','TX','78415',NULL,'CY','48355','1951-06-06','F','M',':RET:2106-3','N','021','DEN','3029223','33348TX002000201','2014-04-01','2014-02-22 11:25:45','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2014-02-26 08:30:11'),(27673,21888,'N','01','021','EC','A',NULL,NULL,'','0000127033','0000587318','','IL','1','Aguilar','Manuela','','','','34','461152032','115 COLERIDGE RD',0,'EL PASO','TX','79928','5110','CY','48141','1957-07-26','F','',':RET:2106-3','T','021','DEN','3668495','33348TX002000201','2014-04-01','2014-03-04 19:13:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:35'),(29098,23031,'Y','18','021','EC','A','','','AC','0000522020','0000522020','OH00003050445','IL','1','mclees II','michael','','','','34','283905711','543 PAXTON AVE',0,'LOVELAND','OH','45140','3179','CY','39025','1977-05-29','M','R',':RET:2106-3','N','021','HLT','3996608','92036OH004000601','2014-04-01','2014-03-09 22:32:17','0.00',NULL,NULL,'212.32','212.32','R-OH005','OH0','212.32',NULL,0,'2014-03-10 21:02:14'),(1616,1351,'Y','18','021','EC','A','','','AC','0000306471','0000306471','TX00000851265','IL','1','Cruz','Haydee','','','','34','449198109','1804 TAYLOR LN',0,'PEARLAND','TX','77581','5742','CY','48039','1958-01-31','F','U',NULL,'N','021','DEN','2102611','33348TX002000201','2014-01-01','2013-12-24 13:15:41','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:52:28'),(13580,10831,'Y','18','021','EC','A','','','AC','0002041430','0002041430','LA00000242450','IL','1','Gaines','Glenda','Bureau','','','34','433046553','12043 RODDY RD',0,'GONZALES','LA','70737','1838','CY','22005','1956-08-26','F','U',':RET:2054-5','N','021','DEN','2276539','18575LA002000201','2014-01-01','2013-12-23 18:18:51','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:53'),(5651,4483,'Y','18','021','EC','A','','','AC','0000749993','0000749993','TX00000504027','IL','1','Rivera','Manuel','','','','34','455920676','525 MERRIMAN DR',0,'EL PASO','TX','79912','1278','CY','48141','1951-03-01','M','U',':RET:2106-3','N','021','DEN','43470','33348TX002000201','2014-01-01','2013-11-26 13:11:45','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:31:30'),(5869,4657,'Y','18','021','EC','A','','','AC','0000833418','0000833418','OH00000115278','IL','1','Ferriot','Joseph','','','','34','291885220','886 Eva avenue',0,'Akron','OH','44306',NULL,'CY','39153','1978-11-17','M','M',NULL,'N','021','HLT','2044657','52664OH152000901','2014-01-01','2013-12-24 01:07:03','0.00',NULL,NULL,'199.60','199.60','R-OH012','OH0','199.60',NULL,0,'2013-12-25 23:49:10'),(4039,3224,'N','19','021','EC','A',NULL,NULL,'','0000293172','0001145957','','IL','1','Kington','Michael','','','','34','285942613','714 Matthews Brook LN',0,'Powell','OH','43065',NULL,'CY','39041','1991-09-14','M','',NULL,'N','021','DEN','1548712','99734OH005000401','2014-01-01','2013-12-17 11:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:46:04'),(18413,14690,'Y','18','021','EC','A','','','AC','0001550691','0001550691','LA00001940459','IL','1','Chao','Vincent','','','','34','434690286','1701 N 5TH ST',0,'MONROE','LA','71201','4733','CY','22073','1973-12-13','M','M',NULL,'N','021','DEN','1919199','18575LA002000201','2014-02-01','2014-01-14 20:52:33','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-16 08:45:48'),(22291,17795,'N','19','021','EC','A',NULL,NULL,'','0000298261','0000809707','','S3','1','Schmehl','Bruce','L','','','34','290042559','01909 Feeder Rd',0,'St Marys','OH','45885',NULL,'CY','39011','1999-12-11','M','',':RET:2106-3','N','021','HLT','2960220','92036OH003001501','2014-03-01','2014-01-24 22:11:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-10 11:00:29'),(22292,17795,'N','01','021','EC','A',NULL,NULL,'','0000298261','0000920841','','IL','1','Schmehl','Bruce','','','','34','296684453','01909 Feeder Rd',0,'St Marys','OH','45885',NULL,'CY','39011','1962-11-23','M','',':RET:2106-3','N','021','HLT','2960220','92036OH003001501','2014-03-01','2014-01-24 22:11:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','428.66',NULL,0,'2014-02-10 11:00:30'),(23487,18709,'Y','18','021','EC','A','','','AC','0002184664','0002184664','LA00002312256','IL','1','Alexander','Whitney','','','','34','438670746','1120 East 7th Street',0,'Bogalusa','LA','70427',NULL,'CY','22117','1987-11-06','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3691979','18575LA002000101','2014-03-01','2014-02-13 14:35:53','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-13 22:01:59'),(7531,5961,'Y','18','024','14','A','','','TE','0000398327','0000398327','','IL','1','Wack','Bryan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-01-21','M','',NULL,NULL,NULL,'','818160','','2013-12-15','2013-12-15 10:58:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 02:32:41'),(5895,4674,'Y','18','021','EC','A','','','AC','0001071787','0001071787','OH00000061692','IL','1','Clark','Rolanda','','','','34','288743786','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','1977-10-31','F','M',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:49:42'),(7863,6223,'Y','18','021','EC','A','','','AC','0000141500','0000141500','OH00000183731','IL','1','FRITZ','DAVID','','','','34','297460429','2854 LAUREL WOODS BLVD',0,'STOW','OH','44224','5120','CY','39153','1949-06-23','M','M',':RET:2106-3','N','021','DEN','1801944','99734OH005000301','2014-01-01','2013-12-20 14:41:44','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:05:02'),(17638,14099,'N','01','021','EC','A',NULL,NULL,'','0001258678','0001055339','','IL','1','Kessler','Shayna','Miriam','','','34','277808237','4286 UNIVERSITY PKWY',0,'UNIVERSITY HEIGHTS','OH','44118','3943','CY','39035','1982-05-10','F','',':RET:2106-3','N','021','DEN','1360427','99734OH005000301','2014-02-01','2014-01-12 19:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:35'),(18445,14716,'Y','18','021','EC','A','','','AC','0000618384','0000618384','OH00002553492','IL','1','Link','Andrea','','','','34','277783229','1453 LANGDON DR',0,'SIDNEY','OH','45365','6202','CY','39149','1977-01-28','F','M',':RET:2106-3','N','021','HLT','1806607','92036OH001000501','2014-02-01','2014-01-14 19:22:25','300.00',NULL,NULL,'1074.08','774.08','R-OH003','OH0','354.96',NULL,0,'2014-01-16 08:46:05'),(19833,15816,'Y','18','021','EC','A','','','AC','0001047682','0001047682','TX00001375571','IL','1','Kline','Gayle','D','','','34','454115884','502 EAST ST',0,'GRAHAM','TX','76450','3118','CY','48503','1958-06-30','F','U',NULL,'N','021','DEN','2790805','33348TX002000201','2014-03-01','2014-01-24 14:25:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-24 21:00:20'),(20555,16426,'N','01','021','EC','A',NULL,NULL,'','0000346923','0000205815','','IL','1','Crable','Gary','','','Sr','34','271529867','517 WALSH ST',0,'TOLEDO','OH','43609','1960','CY','39095','1950-06-03','M','',':RET:2106-3','T','021','HLT','2964992','92036OH004002601','2014-03-01','2014-01-29 11:47:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','532.27',NULL,0,'2014-01-29 21:01:44'),(22649,18084,'Y','18','021','EC','A','','','AC','0000044816','0000044816','TX00002605891','IL','1','Hollister','Philip','','','','34','462534545','411 N 3RD ST',0,'WILLS POINT','TX','75169','2107','CY','48467','1966-01-21','M','M',':RET:2106-3','N','021','DEN','3756925','33348TX002000201','2014-03-01','2014-02-11 11:02:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:26'),(23711,18879,'Y','18','021','EC','A','','','AC','0000376185','0000376185','OH00001714625','IL','1','Vidal','Paul','','','','34','282660230','1254 Canyon View Rd',0,'Sagamore Hills','OH','44067',NULL,'CY','39153','1958-08-28','M','R',':RET:2106-3','N','021','DEN','3233143','99734OH005000401','2014-03-01','2014-02-14 15:53:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-14 21:30:47'),(24669,19581,'N','19','021','EC','A',NULL,NULL,'','0000149395','0000771483','','IL','1','Van Dyke','Devin','','','','34','268024595','20880 ROAD 23T',0,'FORT JENNINGS','OH','45844','9366','CY','39137','1996-08-23','M','',':RET:2106-3','N','021','HLT','3212074','92036OH006001501','2014-04-01','2014-02-18 19:56:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2014-02-20 04:27:02'),(24687,19596,'Y','18','021','EC','A','','','AC','0000983854','0000983854','TX00002888782','IL','1','Park','David','','','','34','576433027','2312 TAHOE LN',0,'DENTON','TX','76210','2986','CY','48121','1983-05-26','M','U',':RET:2040-4^:RET:2106-3','N','021','DEN','3053656','33348TX002000101','2014-04-01','2014-02-18 22:51:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-20 04:31:35'),(27780,21970,'Y','18','021','EC','A','','','AC','0000844763','0000844763','OH00002858027','IL','1','Steiner','Kay','','','','34','300449617','382 Grant Street',0,'MOGADORE','OH','44260',NULL,'CY','39133','1952-07-29','F','M',':RET:2106-3','N','021','HLT','3472725','52664OH152000901','2014-04-01','2014-03-05 14:08:36','252.00',NULL,NULL,'458.99','206.99','R-OH012','OH0','458.99',NULL,0,'2014-03-05 21:31:33'),(55,50,'Y','18','021','EC','A','','','AC','0000119031','0000119031','OH00000872450','IL','1','RITTERBACH','MARTHA','','','','34','286746846','131 MOORISON ST',0,'FREMONT','OH','43420',NULL,'CY','39143','1962-08-13','F','M',':RET:2106-3','N','021','DEN','339480','99734OH005000301','2014-01-01','2013-12-04 20:43:57','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 17:16:30'),(7106,5636,'Y','18','021','EC','A','','','AC','0002329539','0002329539','LA00000181342','IL','1','Menyweather','LaShani','','','','34','439713190','343 Woodale Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1988-10-01','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','2313232','18575LA002000101','2014-01-01','2013-12-24 18:54:52','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-26 01:50:53'),(15799,12646,'Y','18','021','EC','A','','','AC','0001469158','0001469158','LA00001671906','IL','1','Shull','Kristine','E','','','34','533984718','1212 DANTE ST',0,'NEW ORLEANS','LA','70118','2030','CY','22071','1982-05-06','F','R',':RET:2106-3','N','021','DEN','1660882','18575LA002000201','2014-02-01','2014-01-02 09:54:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-03 02:02:47'),(14088,11227,'Y','18','021','EC','A','','','AC','0000770001','0000770001','OH00000146961','IL','1','Pankey','Ronald','','','','34','271500539','1915 GRAND BLVD',0,'HAMILTON','OH','45011','4511','CY','39017','1953-12-30','M','M',':RET:2054-5','T','021','DEN','2044759','99734OH005000401','2014-02-01','2013-12-26 10:46:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:01:17'),(6591,5226,'Y','18','021','EC','A','','','AC','0001116521','0001116521','TX00000448494','IL','1','HAMID','karim','Abed','','Sr','34','495803304','4906 LakeLivingston',0,'CorpusChristi','TX','78413',NULL,'CY','48355','1951-11-12','M','M',':RET:2028-9','N','021','DEN','351915','33348TX002000101','2014-01-01','2013-12-11 13:07:11','0.00',NULL,NULL,'50.04','50.04','R-TX007','TX0','25.02',NULL,0,'2013-12-26 00:53:16'),(9305,7378,'Y','18','021','EC','A','','','AC','0001411246','0001411246','LA00000120253','IL','1','HATCHERSON','CHERYL','','','','34','437177013','223 SANDERS ST',0,'FRANKLIN','LA','70538','4216','CY','22101','1958-06-07','F','M',':RET:2054-5','N','021','DEN','2097269','18575LA002000101','2014-01-01','2013-12-20 19:40:51','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-26 04:30:07'),(5810,4616,'Y','18','021','EC','A','','','AC','0001092993','0001092993','TX00001371119','IL','1','Jennings','Marlynda','','','','34','462614294','3110 Ewing Ct',0,'Manvel','TX','77578',NULL,'CY','48039','1967-12-31','F','U',':RET:2054-5','N','021','DEN','1579643','33348TX002000201','2014-01-01','2013-12-23 21:42:08','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:47:45'),(18798,14971,'Y','18','021','EC','A','','','AC','0000695662','0000695662','OH00001454168','IL','1','Sallie','Jessie','','','','34','284640977','10902 GRANDVIEW AVE',0,'CLEVELAND','OH','44104','3529','CY','39035','1965-04-22','M','U',':RET:2054-5','N','021','DEN','1947299','99734OH005000401','2014-03-01','2014-01-16 11:18:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:58'),(24830,19684,'Y','18','021','EC','A','','','AC','0000697956','0000697956','OH00002635752','IL','1','wilson','michael','','','','34','243734736','37 CONCORD WOODS DR',0,'MILFORD','OH','45150','1334','CY','39025','1992-04-28','M','M',':RET:2106-3','N','021','HLT','3440784','92036OH002000601','2014-04-01','2014-02-18 22:48:36','0.00',NULL,NULL,'247.90','247.90','R-OH005','OH0','247.90',NULL,0,'2014-02-20 04:51:54'),(27119,21466,'Y','18','024','14','A','','','TE','0000992729','0000992729','','IL','1','Stone','david',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-13','M','',NULL,NULL,NULL,'','3192934','','2014-03-03','2014-03-03 13:08:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:32'),(27245,21572,'N','01','021','EC','A',NULL,NULL,'','0001100648','0000559499','','IL','1','Malone','Willena','','','','34','278584072','193 ROSS DR',0,'WEST UNION','OH','45693','9628','CY','39001','1955-06-23','M','',NULL,'N','021','HLT','3616065','92036OH004000601','2014-04-01','2014-03-03 15:00:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','439.81',NULL,0,'2014-03-03 21:31:49'),(7220,5722,'N','01','021','EC','A',NULL,NULL,'','0000690707','0001077700','','IL','1','Sarisky','Jacqueline','','','','34','285520777','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1953-01-05','F','',':RET:1002-5^:RET:2106-3','T','021','DEN','1130861','99734OH005000401','2014-01-01','2013-12-14 12:12:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:01:06'),(1394,1158,'Y','18','021','EC','A','','','AC','0001538869','0001538869','LA00001467563','IL','1','BLAKE','VERONICA','','','','34','433114958','1605 N PRIEUR ST',0,'NEW ORLEANS','LA','70116','1311','CY','22071','1957-02-15','F','U',NULL,'N','021','DEN','2056894','18575LA002000201','2014-01-01','2013-12-24 11:55:48','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:26'),(1748,1448,'N','19','021','EC','A',NULL,NULL,'','0000784364','0001100600','','IL','1','Haikal','Laura','','','','34','278947546','13882 LAKE AVE',0,'LAKEWOOD','OH','44107','1425','CY','39035','1991-10-24','F','',NULL,'N','021','DEN','2188206','99734OH005000301','2014-01-01','2013-12-24 12:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:39'),(17833,14246,'Y','18','021','EC','A','','','AC','0000322505','0000322505','MS00001663347','IL','1','Frizell','Alena','','','','34','587575517','119 DOGWOOD TRL',0,'BRANDON','MS','39047','9547','CY','28121','1980-10-07','F','U',':RET:2106-3','N','021','DEN','2644597','46300MS002000201','2014-02-01','2014-01-14 16:08:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:06:00'),(18891,15051,'N','01','021','EC','A',NULL,NULL,'','0000124238','0001104471','','IL','1','Boring','Linda','','','','34','299443716','730 W Portage Tr Ext',0,'Akron','OH','44313',NULL,'CY','39153','1950-06-19','F','',':RET:2106-3','T','021','HLT','2606346','52664OH152000901','2014-03-01','2014-01-16 16:39:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','554.51',NULL,0,'2014-01-17 03:36:32'),(21011,16789,'Y','18','021','EC','A','','','AC','0001067016','0001067016','OH00002512776','IL','1','Le','Tien','','','','34','289924402','7927 Furrow Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1975-11-12','M','M',':RET:2047-9','N','021','DEN','3069221','99734OH005000401','2014-03-01','2014-02-01 01:30:48','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-01 19:00:34'),(21534,17203,'N','19','021','EC','A',NULL,NULL,'','0000777703','0000780546','','IL','1','Bass','Chelsea','','','','34','628640297','4934 LAKOTA WOODS DR',0,'LIBERTY TOWNSHIP','OH','45044','3245','CY','39017','1998-09-13','F','',':RET:2106-3','N','021','HLT','3179559','92036OH001001201','2014-03-01','2014-02-04 18:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2014-02-05 21:30:07'),(26240,20811,'Y','18','021','EC','A','','','AC','0000204378','0000204378','TX00003073074','IL','1','OLIVARES DURAN','ELODIA','','','','34','459047244','2320 SPRINGFIELD AVE',0,'LAREDO','TX','78040','4030','CY','48479','1951-06-29','F','M',':RET:2106-3','N','021','DEN','3352988','33348TX002000201','2014-04-01','2014-02-27 10:52:43','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-28 06:31:04'),(26583,21077,'Y','18','021','EC','A','','','AC','0000917044','0000917044','OH00003207628','IL','1','BLOOMFIELD','JUDY','','','','34','284540688','2896 GENTRY LN',0,'COLUMBUS','OH','43232','5404','CY','39049','1954-10-04','F','U',':RET:2106-3','N','021','DEN','3259936','99734OH005000401','2014-04-01','2014-02-28 15:06:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:31'),(1090,896,'Y','18','021','EC','A','','','AC','0000950650','0000950650','OH00000237610','IL','1','Wenning','Curtis','','','','34','283504820','803 Fox St.',0,'New Bremen','OH','45869',NULL,'CY','39011','1951-05-07','M','U',':RET:2106-3','N','021','DEN','986065','99734OH005000401','2014-01-01','2013-12-03 13:47:06','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:17:01'),(16232,12999,'Y','18','021','EC','A','','','AC','0000384407','0000384407','OH00001827162','IL','1','SMITH','MICHAEL','PAUL','','','34','301447117','216 E BURWELL AVE',0,'LOUDONVILLE','OH','44842','9504','CY','39005','1951-11-08','M','M',':RET:2106-3','N','021','HLT','2320824','52664OH151001301','2014-02-01','2014-01-04 11:06:39','1001.00',NULL,NULL,'1267.35','266.35','R-OH012','OH0','640.70',NULL,0,'2014-01-05 00:02:04'),(2470,2010,'Y','18','021','EC','A','','','AC','0000363891','0000363891','LA00000331616','IL','1','Clary','Robert','','','','34','506645006','1906 BEY ST',0,'BOSSIER CITY','LA','71112','4102','CY','22015','1950-03-25','M','U',':RET:2106-3','N','021','DEN','543563','18575LA002000101','2014-01-01','2013-12-09 18:00:02','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 19:35:11'),(7096,5628,'Y','18','021','EC','A','','','AC','0000933211','0000933211','OH00001066913','IL','1','waheed','karen','','','','34','295625097','1213 5TH AVE',0,'AKRON','OH','44306','1610','CY','39153','1960-06-09','F','R',NULL,'N','021','HLT','1524498','52664OH151001301','2014-01-01','2013-12-24 23:09:09','0.00',NULL,NULL,'454.94','454.94','R-OH012','OH0','454.94',NULL,0,'2013-12-26 01:50:39'),(26766,21213,'Y','18','024','14','A','','','TE','0000639503','0000639503','','IL','1','Platz-Rosenow','Heather',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-13','F','',NULL,NULL,NULL,'','2488832','','2014-02-28','2014-02-28 20:41:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-01 19:00:11'),(26995,21380,'N','01','021','EC','A',NULL,NULL,'','0000779160','0000878325','','IL','1','Nguyen','Thao','Thi Van','','','34','301087756','6938 Hawksbeard dr',0,'Westerville','OH','43082',NULL,'CY','39041','1979-06-06','F','',':RET:2047-9','N','021','DEN','3839908','99734OH005000301','2014-04-01','2014-03-02 11:43:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 01:29:59'),(27762,21953,'Y','18','021','EC','A','','','AC','0001814454','0001814454','LA00003531397','IL','1','Popovich','Delia','Anne','','','34','433198045','4027 Idaho Ave',0,'Kenner','LA','70065',NULL,'CY','22051','1966-09-01','F','R',':RET:2106-3','N','021','DEN','3568746','18575LA002000201','2014-04-01','2014-03-05 11:47:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:20'),(441,362,'N','01','021','EC','A',NULL,NULL,'','0001144745','0000999823','','IL','1','Kundrach','Richard','','','','34','293465822','9381 WILLOW RD',0,'LODI','OH','44254','9629','CY','39103','1950-11-16','M','',':RET:2106-3','N','021','DEN','745758','99734OH005000401','2014-01-01','2013-12-04 11:10:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:10'),(15701,12560,'N','01','021','EC','A',NULL,NULL,'','0000372616','0001182518','','IL','1','BEACH','JOHN','','','','34','296506227','710 E BROADWAY ST',0,'NORTH BALTIMORE','OH','45872','9565','CY','39173','1951-06-04','M','',NULL,'N','021','HLT','2288392','92036OH004002601','2014-02-01','2013-12-31 12:49:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','450.46',NULL,1,'2014-01-02 04:35:43'),(15507,12407,'N','19','021','EC','A',NULL,NULL,'','0000539292','0000986019','','S1','1','cleveland','kyle','','','','34','296026327','383 DAY LIGHT LN',0,'POWELL','OH','43065','8213','CY','39041','1998-04-13','M','',':RET:2106-3','N','021','DEN','1522065','99734OH005000401','2014-02-01','2013-12-31 14:43:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:54'),(970,795,'Y','18','021','EC','A','','','AC','0000214615','0000214615','OH00000347600','IL','1','Wright','John','','','','34','270485030','3820 Townsend Angling Road',0,'Collins','OH','44826',NULL,'CY','39077','1951-01-10','M','U',':RET:2106-3','N','021','HLT','827071','92036OH002002701','2014-01-01','2013-10-28 19:32:04','0.00',NULL,NULL,'1233.13','1233.13','R-OH006','OH0','646.96',NULL,0,'2013-12-25 18:10:00'),(4055,3239,'Y','18','021','EC','A','','','AC','0000140266','0000140266','OH00000962249','IL','1','KUHN','MARTHA','J','','','34','299503016','6034 MCNUTT AVE',0,'ASHTABULA','OH','44004','6326','CY','39007','1951-07-09','F','M',':RET:2106-3','N','021','DEN','1920697','99734OH005000401','2014-01-01','2013-12-17 15:13:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:32'),(9150,7257,'Y','18','021','EC','A','','','AC','0000559430','0000559430','OH00000566552','IL','1','MARX','FARRELL','JEFFREY','','','34','276689285','3419  MARYLAND AVE.',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1961-03-22','M','M',':RET:2106-3','N','021','HLT','2449767','52664OH151001501','2014-01-01','2013-12-18 13:50:45','0.00',NULL,NULL,'588.84','588.84','R-OH011','OH0','588.84',NULL,0,'2013-12-26 04:08:25'),(22015,17576,'Y','18','024','14','A','','','TE','0001218576','0001218576','','IL','1','Luke','Tracy','Susan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-10-20','F','',NULL,NULL,NULL,'','2684418','','2014-02-07','2014-02-07 17:22:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-07 19:00:54'),(22874,18245,'N','19','021','EC','A',NULL,NULL,'','0000624041','0001069244','','IL','1','Tsai','Kang','Lin','','','34','624848017','331 County Road 1498',0,'Tupelo','MS','38804',NULL,'CY','28081','1992-11-08','M','',':RET:2034-7','N','021','DEN','3245245','46300MS002000101','2014-03-01','2014-02-11 10:06:40',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-11 21:02:31'),(23989,19074,'Y','18','021','EC','A','','','AC','0001204995','0001204995','LA00002753659','IL','1','Monk','Janice','','','','34','439868808','12216 CARDIGAN AVE',0,'BATON ROUGE','LA','70814','7501','CY','22033','1951-03-06','F','U',':RET:2054-5','N','021','DEN','3828047','18575LA002000201','2014-03-01','2014-02-15 14:44:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-15 22:00:24'),(24786,19660,'Y','18','021','EC','A','','','AC','0000451328','0000451328','OH00002598971','IL','1','Kopis','Karen','','','','34','291626186','284 ROOSEVELT AVE',0,'ELYRIA','OH','44035','3948','CY','39093','1958-07-07','F','U',':RET:2106-3','N','021','DEN','2960752','99734OH005000401','2014-04-01','2014-02-19 13:32:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:46:12'),(26171,20752,'Y','18','021','EC','A','','','AC','0000989302','0000989302','MS00002465794','IL','1','Richards','Corine','','','','34','428080324','1159 Betighemier Road',0,'Edwards','MS','39066',NULL,'CY','28049','1957-05-06','F','U',':RET:2054-5','N','021','DEN','3662083','46300MS002000201','2014-03-01','2014-02-27 10:21:39','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 06:30:36'),(26796,21237,'N','19','021','EC','A',NULL,NULL,'','0000862497','0000797016','','IL','1','Gonzalez','Dorys','','','','34','274177127','336 N BERLIN AVE',0,'TOLEDO','OH','43605','1508','CY','39095','2011-03-07','F','',NULL,'N','021','HLT','2734646','92036OH003002605','2014-04-01','2014-03-01 16:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-01 21:00:21'),(28123,22256,'N','01','021','EC','A',NULL,NULL,'','0000197204','0000532174','','IL','1','Pollauf','Annette',NULL,NULL,NULL,NULL,NULL,'3950 PEPPERWOOD CT',0,'SYLVANIA','OH','43560','3578','CY','39095','1952-12-03','F','',NULL,'N','021','HLT','3699648','92036OH003002601','2014-04-01','2014-03-06 12:32:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','572.23',NULL,0,'2014-03-06 21:02:21'),(5843,4641,'N','01','021','EC','A',NULL,NULL,'','0000226909','0000563937','','IL','1','Mims','Michael','','','','34','458737217','721 S LAUREL AVE',0,'LULING','TX','78648','3303','CY','48055','1979-06-16','M','',':RET:2106-3','N','021','DEN','2357349','33348TX002000201','2014-01-01','2013-12-24 00:12:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:48:36'),(16035,12838,'Y','18','024','14','A','','','TE','0002385932','0002385932','','IL','1','lewis-green','xaicha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1993-01-30','F','',NULL,NULL,NULL,'','2232343','','2014-01-03','2014-01-03 14:20:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-04 02:02:38'),(7889,6239,'Y','18','024','14','A','','','TE','0000699226','0000699226','','IL','1','vickery','charlotte',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-08-10','F','',NULL,NULL,NULL,'','1031568','','2013-12-19','2013-12-19 21:46:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:05:35'),(19893,15867,'Y','18','021','EC','A','','','AC','0000768910','0000768910','OH00001950151','IL','1','Schreiber','Molly','','','','34','292929903','922 RICE AVE',0,'LIMA','OH','45805','2044','CY','39003','1988-05-01','F','U',':RET:2106-3','T','021','HLT','3287620','92036OH005001506','2014-03-01','2014-01-23 22:27:31','82.00',NULL,NULL,'254.12','172.12','R-OH002','OH0','254.12',NULL,0,'2014-01-24 21:00:52'),(22605,18053,'N','19','021','EC','A',NULL,NULL,'','0001062162','0000708979','','IL','1','VU','ANDREW','','','','34','895363268','7230 HOSBROOK RD',0,'CINCINNATI','OH','45243','1710','CY','39061','2013-08-20','M','',NULL,'N','021','HLT','3682085','92036OH001001201','2014-03-01','2014-02-10 14:31:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2014-02-10 21:32:17'),(25446,20190,'Y','18','021','EC','A','','','AC','0001126176','0001126176','TX00003000097','IL','1','HendonHooks','Jennifer','','','','34','454812307','813 PR 1639',0,'Stephenville','TX','76401',NULL,'CY','48143','1973-04-04','F','M',':RET:2106-3','N','021','DEN','3410745','33348TX002000201','2014-04-01','2014-02-25 12:26:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-25 21:31:23'),(27253,21580,'Y','18','021','EC','A','','','AC','0000178953','0000178953','OH00002666972','IL','1','starr','kenneth','','','','34','204481848','1369 GREENFIELD RD',0,'SABINA','OH','45169',NULL,'CY','39027','1962-05-06','M','M',NULL,'N','021','HLT','3063755','92036OH002000601','2014-04-01','2014-03-03 14:44:18','487.00',NULL,NULL,'867.69','380.69','R-OH005','OH0','462.36',NULL,0,'2014-03-03 21:31:55'),(28024,22177,'N','01','021','EC','A',NULL,NULL,'','0000874765','0000298303','','IL','1','PADILLA','KENYA','','','','34','283135867','4658 OBERLIN AVE',0,'LORAIN','OH','44053',NULL,'CY','39093','1992-03-11','F','',NULL,'N','021','DEN','3051831','99734OH005000401','2014-04-01','2014-03-06 15:20:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:23'),(6011,4758,'N','01','021','EC','A',NULL,NULL,'','0000366252','0000598719','','IL','1','Braunstein','Paul','','','','34','276544420','6542 SIMON DR',0,'CINCINNATI','OH','45233','4562','CY','39061','1952-10-19','M','',':RET:2106-3','N','021','DEN','1195773','99734OH005000301','2014-01-01','2013-12-01 11:13:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:36'),(16651,13322,'Y','18','021','EC','A','','','AC','0000634686','0000634686','MS00002278785','IL','1','TERRELL','MONCORIA','LA SHAY','','','34','426634065','1928 HILL AVE',0,'JACKSON','MS','39204','2344','CY','28049','1988-04-14','F','U',':RET:2054-5','N','021','DEN','2200222','46300MS002000201','2014-02-01','2014-01-06 20:55:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-08 18:24:20'),(15790,12638,'Y','18','021','EC','A','','','AC','0001152281','0001152281','LA00001616165','IL','1','Gambrell','Yanesia','','','','34','435593218','10795 Mead Rd',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1974-09-08','F','U',':RET:2054-5','N','021','DEN','1551756','18575LA002000201','2014-02-01','2014-01-02 12:32:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:27'),(14816,11834,'N','01','021','EC','A',NULL,NULL,'','0000948415','0001104440','','IL','1','Herrin','Rodney','M','','','34','283643027','133 BOURBON ST',0,'BLANCHESTER','OH','45107','1467','CY','39027','1958-04-30','M','',':RET:2106-3','N','021','HLT','2315685','92036OH001000601','2014-01-01','2013-12-23 20:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','577.44',NULL,1,'2013-12-29 11:14:12'),(4253,3388,'Y','18','021','EC','A','','','AC','0000336396','0000336396','OH00000864640','IL','1','Shai','Katelyn',NULL,NULL,NULL,NULL,NULL,'2855 Morewood Rd',0,'Fairlawn','OH','44333',NULL,'CY','39153','1982-02-06','F','U',':RET:2106-3','N','021','HLT','2355819','52664OH151001501','2014-01-01','2013-12-16 19:39:00','0.00',NULL,NULL,'309.99','309.99','R-OH012','OH0','309.99',NULL,0,'2013-12-25 21:51:20'),(9073,7202,'Y','18','021','EC','A','','','AC','0001212335','0001212335','OH00000045529','IL','1','Gohs','Richard','','','','34','286726470','5202 PARLOR CT',0,'MASON','OH','45040','2935','CY','39165','1964-04-14','M','M',NULL,'N','021','DEN','2606601','99734OH005000301','2014-01-01','2013-12-17 19:16:14','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:06:41'),(17886,14285,'Y','18','021','EC','A','','','AC','0001084166','0001084166','OH00001905328','IL','1','DAVIS','EUGENIA','','','','34','288521369','2225 LINDALE NICKLESVILLE ROAD',0,'AMELIA','OH','45102',NULL,'CY','39025','1950-12-13','F','M',':RET:2106-3','N','021','DEN','1665521','99734OH005000401','2014-02-01','2014-01-14 15:20:47','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-15 02:06:18'),(19621,15640,'Y','18','021','EC','A','','','AC','0000246479','0000246479','OH00001670932','IL','1','Maxwell','Wilma','','','','34','286541824','11680 WALNUT AVE NE',0,'ALLIANCE','OH','44601','1307','CY','39151','1956-04-04','F','M',':RET:2106-3','N','021','DEN','2070360','99734OH005000401','2014-03-01','2014-01-22 18:58:37','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-23 21:00:04'),(19795,15781,'Y','18','021','EC','A','','','AC','0000646024','0000646024','OH00002286633','IL','1','Fraley','Roxanne','','','','34','276868963','188 E SANDUSKY ST',0,'MECHANICSBURG','OH','43044','1029','CY','39021','1987-02-19','F','U',NULL,'N','021','HLT','3366233','92036OH003000505','2014-03-01','2014-01-23 15:24:58','183.00',NULL,NULL,'260.15','77.15','R-OH003','OH0','260.15',NULL,0,'2014-01-23 21:01:44'),(20100,16037,'Y','18','024','14','A','','','TE','0001560121','0001560121','','IL','1','Suleiman','Summer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-15','F','',NULL,NULL,NULL,'','1379591','','2014-01-27','2014-01-27 12:57:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:35'),(20958,16747,'Y','18','024','14','A','','','TE','0001093026','0001093026','','IL','1','G RUIZ','CECILIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-03-14','F','',NULL,NULL,NULL,'','2170626','','2014-02-01','2014-02-01 12:59:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-01 19:00:08'),(22012,17573,'Y','18','021','EC','A','','','AC','0001218576','0001218576','OH00001441099','IL','1','Luke','Tracy','Susan','','','34','274600222','75 Clearwater Dr.',0,'Brunswick','OH','44212',NULL,'CY','39103','1966-10-20','F','U',':RET:2106-3','N','021','DEN','2684418','99734OH005000301','2014-03-01','2014-02-07 10:00:07','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-07 19:00:52'),(22054,17604,'N','01','021','EC','A',NULL,NULL,'','0001142561','0000305410','','IL','1','Chavira','Jacqueline','','','','34','635305217','12927 SPARKS DR',0,'EL PASO','TX','79928','5719','CY','48141','1991-03-20','F','',':RET:2106-3','N','021','DEN','3411455','33348TX002000201','2014-03-01','2014-02-07 20:40:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-08 19:00:06'),(27254,21580,'N','01','021','EC','A',NULL,NULL,'','0000178953','0001011617','','IL','1','starr','kimberly','','','','34','276729828','1369 GREENFIELD RD',0,'SABINA','OH','45169',NULL,'CY','39027','1965-11-08','F','',NULL,'N','021','HLT','3063755','92036OH002000601','2014-04-01','2014-03-03 14:44:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','405.33',NULL,0,'2014-03-03 21:31:55'),(28253,22355,'Y','18','021','EC','A','','','AC','0000383369','0000383369','OH00003798323','IL','1','PHILBRICK','CYNTHIA','','','','34','295623227','56 E SMILEY AVE',0,'SHELBY','OH','44875','1048','CY','39139','1958-09-03','F','M',NULL,'N','021','DEN','3788029','99734OH005000401','2014-04-01','2014-03-07 17:33:48','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00','CIC',0,'2014-03-07 21:00:14'),(7513,5944,'Y','18','021','EC','A','','','AC','0000224744','0000224744','LA00000247060','IL','1','BROWN','JONATHAN','','','','34','046768208','3884 GREENWAY PL',0,'SHREVEPORT','LA','71105','2016','CY','22017','1978-04-06','M','U',':RET:2106-3','N','021','DEN','967303','18575LA002000201','2014-01-01','2013-12-15 11:34:39','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 02:32:09'),(13848,11052,'Y','18','021','EC','A','','','AC','0000569309','0000569309','OH00001014383','IL','1','Bortles','Casey','','','','34','321725828','140 S MEILKE RD',0,'HOLLAND','OH','43528','9762','CY','39095','1976-07-08','M','R',':RET:2106-3','T','021','HLT','1753582','92036OH002002601','2014-01-01','2013-12-22 20:12:55','0.00',NULL,NULL,'320.59','320.59','R-OH001','OH0','320.59',NULL,0,'2013-12-26 13:12:31'),(15230,12173,'N','19','021','EC','A',NULL,NULL,'','0000968222','0000449886','','S1','1','Kuhnell','Sarah','','','','34','271082365','5930 WOODSPOINT DR',0,'MILFORD','OH','45150','2157','CY','39025','2002-09-25','F','',':RET:2106-3','N','021','HLT','1445791','92036OH005000605','2014-02-01','2013-12-29 23:38:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-01-01 12:08:16'),(20489,16368,'Y','18','021','EC','A','','','AC','0000794541','0000794541','OH00001726924','IL','1','WESTFALL','BRIAN','J','','','34','286607306','865 E ARCHWOOD AVE',0,'AKRON','OH','44306','2325','CY','39153','1972-04-29','M','U',':RET:2106-3','N','021','HLT','2977295','52664OH151001305','2014-03-01','2014-01-29 17:56:35','178.00',NULL,NULL,'290.36','112.36','R-OH012','OH0','290.36',NULL,0,'2014-01-29 21:01:05'),(20901,16706,'Y','18','021','EC','A','','','AC','0001064747','0001064747','OH00002451662','IL','1','Graham','Kimberly','','','','34','271446501','26500 AMHEARST CIR',0,'BEACHWOOD','OH','44122','8503','CY','39035','1957-06-10','F','U',NULL,'N','021','DEN','2663007','99734OH005000401','2014-03-01','2014-01-31 14:43:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-31 21:01:21'),(24126,19177,'Y','18','021','EC','A','','','AC','0002383580','0002383580','LA00001603089','IL','1','Boughton','Lauren','','','','34','439699144','1021 Quail Creek',0,'Shreveport','LA','71105',NULL,'CY','22017','1985-06-18','F','U',':RET:2106-3','N','021','DEN','2951672','18575LA002000101','2014-03-01','2014-02-15 13:22:55','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-15 22:01:45'),(26322,20883,'Y','18','021','EC','A','','','AC','0000101669','0000101669','MS00002498744','IL','1','REED','BRITTANY','','','','34','425699811','318 JEFFERSON AVE',0,'CLARKSDALE','MS','38614',NULL,'CY','28027','1990-04-23','F','U',':RET:2054-5','N','021','DEN','3122522','46300MS002000101','2014-03-01','2014-02-27 11:03:48','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-28 06:31:37'),(28970,22928,'Y','18','021','EC','A','','','AC','0001538914','0001538914','LA00003715484','31','1','Landrum','Margaret','','','','34','438171794','P.O. Box 1122',0,'Saint Francisville','LA','70775',NULL,'CY','22125','1958-02-14','F','U',':RET:2054-5','N','021','DEN','4447143','18575LA002000201','2014-04-01','2014-03-10 16:46:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:01:02'),(741,614,'Y','18','021','EC','A','','','AC','0001048781','0001048781','TX00000321880','IL','1','Anderson','Kristine','','','','34','458815643','6801 W19th St Sp 383',0,'Lubbock','TX','79407',NULL,'CY','48303','1972-09-12','F','U',':RET:2106-3','N','021','DEN','384628','33348TX002000201','2014-01-01','2013-12-15 23:28:24','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:04:03'),(16438,13152,'Y','18','021','EC','A','','','AC','0000849446','0000849446','OH00001541749','IL','1','Geslak','Janet','','','','34','302645945','635 west main street',0,'malvern','OH','44644',NULL,'CY','39019','1959-09-14','F','M',':RET:2106-3','N','021','HLT','2343093','52664OH152000901','2014-02-01','2014-01-06 14:49:30','220.00',NULL,NULL,'348.73','128.73','R-OH015','OH0','348.73',NULL,0,'2014-01-07 04:05:01'),(3574,2869,'Y','18','021','EC','A','','','AC','0001138044','0001138044','OH00000279449','IL','1','Layton','Denise','','','','34','276644143','226 DELLWOOD DR',0,'FAIRBORN','OH','45324','4225','CY','39057','1963-06-17','F','M',':RET:2106-3','N','021','HLT','2392698','92036OH005000501','2014-01-01','2013-12-22 09:21:54','108.00',NULL,NULL,'424.53','316.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 21:22:37'),(13844,11048,'Y','18','021','EC','A','','','AC','0001100595','0001100595','OH00000200419','IL','1','Estep','Rita','','','','34','268521717','125 MEDINA ST',0,'RITTMAN','OH','44270','1532','CY','39169','1950-08-24','F','M',':RET:2106-3','N','021','HLT','2430996','52664OH152000901','2014-01-01','2013-12-23 15:10:50','482.18',NULL,NULL,'482.18','0.00','R-OH014','OH0','482.18',NULL,0,'2013-12-26 13:12:23'),(8045,6368,'N','01','021','EC','A',NULL,NULL,'','0000082559','0000124200','','IL','1','FRITZ','DIANE','J','','','34','273489272','2854 LAUREL WOODS BLVD',0,'STOW','OH','44224','5120','CY','39153','1949-04-30','F','',':RET:2106-3','N','021','HLT','2035283','52664OH152000901','2014-01-01','2013-12-20 14:41:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.00',NULL,0,'2013-12-26 03:09:30'),(9200,7297,'Y','18','021','EC','A','','','AC','0000097561','0000097561','OH00000363050','IL','1','Centers','Cynthia','','','','34','283701044','3718 Hennings Mill Rd.',0,'Williamsburg','OH','45176',NULL,'CY','39025','1960-03-31','F','M',':RET:2106-3','N','021','HLT','1565727','92036OH002000601','2014-01-01','2013-12-18 10:36:59','0.00',NULL,NULL,'505.73','505.73','R-OH005','OH0','505.73',NULL,0,'2013-12-26 04:09:38'),(19135,15247,'Y','18','021','EC','A','','','AC','0000016539','0000016539','TX00002100533','IL','1','Phillips','James','','','','34','289548418','1924 RALPH JANES PL',0,'EL PASO','TX','79936','4062','CY','48141','1954-02-01','M','M',':RET:2106-3','N','021','DEN','2119258','33348TX002000201','2014-03-01','2014-01-18 19:15:03','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-21 08:45:26'),(19661,15666,'Y','18','021','EC','A','','','AC','0000809704','0000809704','OH00002546107','IL','1','Wu','Haiyan','','','','34','060981380','3100 E 3RD ST',0,'DAYTON','OH','45403','2140','CY','39113','1982-02-09','F','M',NULL,'N','021','DEN','2637158','99734OH005000401','2014-03-01','2014-01-23 15:45:38','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-23 21:00:24'),(21285,17010,'N','19','021','EC','A',NULL,NULL,'','0001729348','0001509038','','IL','1','Macilla','Amanda','','','','34','636782013','6512 PARK MANOR DR',0,'METAIRIE','LA','70003','3926','CY','22051','1994-06-16','F','',NULL,'N','021','DEN','3138284','18575LA002000101','2014-03-01','2014-02-03 18:29:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,0,'2014-02-04 21:00:04'),(23354,18610,'Y','18','024','14','A','','','TE','0000948458','0000948458','','IL','1','ANDERSON','MAURA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-06-18','F','',NULL,NULL,NULL,'','3249318','','2014-02-13','2014-02-13 14:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:00:43'),(27415,21697,'N','19','021','EC','A',NULL,NULL,'','0000585592','0000578842','','IL','1','Manning','Ashley','','','','34','273113571','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','2004-12-08','F','',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:36'),(7548,5973,'Y','18','021','EC','A','','','AC','0000439571','0000439571','LA00000647591','IL','1','CALLAHAN','MARK','JAMES','','Jr','34','439738561','338 BARATARIA AVE',0,'HOUMA','LA','70360','4377','CY','22109','1988-07-01','M','U',':RET:2106-3','N','021','DEN','315357','18575LA002000101','2014-01-01','2013-12-14 21:04:18','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2013-12-26 02:33:07'),(1816,1491,'Y','18','021','EC','A','','','AC','0000956653','0000956653','OH00001235912','IL','1','SCHAUFELE','WILLIAM','CALVIN','','','34','288485613','624 WEBER AVE NE',0,'NORTH CANTON','OH','44720','2146','CY','39151','1965-12-29','M','U',NULL,'T','021','HLT','2350644','52664OH151001501','2014-01-01','2013-12-24 16:12:10','0.00',NULL,NULL,'502.90','502.90','R-OH015','OH0','502.90',NULL,0,'2013-12-25 18:57:06'),(17843,14253,'N','01','021','EC','A',NULL,NULL,'','0000481096','0000357218','','IL','1','ABGO','KENNETH','','','','34','882693465','276 HAMTSHIRE',0,'HAMILTION','OH','45011',NULL,'CY','39017','1960-06-05','M','',NULL,'N','021','DEN','2707506','99734OH005000401','2014-02-01','2014-01-13 21:44:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:04'),(21625,17266,'N','01','021','EC','A',NULL,NULL,'','0000035871','0000677548','','IL','1','Buxton','Mary','','','','34','518828926','681 COUNTY ROAD 407',0,'KIRBYVILLE','TX','75956','2806','CY','48241','1965-10-20','F','',':RET:2106-3','N','021','DEN','3625473','33348TX002000201','2014-03-01','2014-02-05 09:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-05 21:30:39'),(22998,18336,'Y','18','021','EC','A','','','AC','0001078938','0001078938','OH00001969441','IL','1','Watkins','Mark','','','','34','292581113','7154 YOUNGSTOWN SALEM RD',0,'CANFIELD','OH','44406','8422','CY','39099','1970-01-27','M','M',':RET:2106-3','N','021','DEN','3426568','99734OH005000301','2014-03-01','2014-02-12 12:47:35','0.00',NULL,NULL,'87.78','87.78','R-OH013','OH0','0.00',NULL,0,'2014-02-12 21:30:17'),(23221,18511,'Y','18','021','EC','A','','','AC','0000154238','0000154238','MS00001709718','IL','1','Whittington','Cortney','','','','34','428672746','761 rice road',0,'Ridgeland','MS','39157',NULL,'CY','28089','1987-04-15','F','U',':RET:2106-3','N','021','DEN','2660937','46300MS002000201','2014-03-01','2014-02-12 14:21:41','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-12 21:32:19'),(25671,20366,'Y','18','024','14','A','','','TE','0000924846','0000924846','','IL','1','townend','richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-08-30','M','',NULL,NULL,NULL,'','3383122','','2014-02-21','2014-02-21 23:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 08:30:52'),(26442,20974,'Y','18','021','EC','A','','','AC','0000341397','0000341397','OH00002133177','IL','1','Schmidt','Mark','','','','34','079487229','560 EDINBOROUGH DR',0,'BAY VILLAGE','OH','44140','3014','CY','39035','1956-11-15','M','M',':RET:2106-3','N','021','DEN','3847510','99734OH005000301','2014-03-01','2014-02-26 22:07:19','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00','CIC',0,'2014-02-28 07:30:21'),(26720,21181,'Y','18','021','EC','A','','','AC','0000515404','0000515404','MS00003503130','IL','1','Gaskew','Lewis','','','','34','587329598','18165 OLD HIGHWAY 80',0,'EDWARDS','MS','39066','9583','CY','28049','1951-11-08','M','U',':RET:2054-5','N','021','DEN','2980733','46300MS002000101','2014-04-01','2014-02-28 10:58:30','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-28 21:31:44'),(27814,21999,'Y','18','021','EC','A','','','AC','0000725114','0000725114','OH00002704836','IL','1','SCROGGINS','JOHNNY','','','','34','272808342','576 KLING ST',0,'AKRON','OH','44311','1229','CY','39153','1982-08-19','M','U',NULL,'N','021','HLT','3662318','52664OH151001306','2014-04-01','2014-03-05 16:06:49','202.00',NULL,NULL,'258.47','56.47','R-OH012','OH0','258.47',NULL,0,'2014-03-05 21:31:52'),(32,27,'Y','18','021','EC','A','','','AC','0000703759','0000703759','OH00000290796','IL','1','Lay','River','Manda','','','34','297139371','617 Jefferson',0,'Reading','OH','45215',NULL,'CY','39061','2008-05-06','F','R',':RET:2106-3','N','021','DEN','94437','99734OH005000401','2014-01-01','2013-12-05 17:59:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-25 17:15:50'),(16000,12806,'Y','18','021','EC','A','','','AC','0001177520','0001177520','TX00000084598','IL','1','Griffin','Donna','','','','34','452193044','NF38 LAKE CHEROKEE',0,'LONGVIEW','TX','75603','9512','CY','48183','1959-02-22','F','M',NULL,'N','021','DEN','2270367','33348TX002000201','2014-02-01','2014-01-03 15:32:31','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2014-01-04 02:01:28'),(6046,4789,'Y','18','021','EC','A','','','AC','0000678060','0000678060','OH00000730187','IL','1','Otchere','Baffour','','','','34','291766180','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1954-02-20','M','M',':RET:2054-5','N','021','DEN','472829','99734OH005000401','2014-01-01','2013-12-01 13:33:13','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:01:33'),(9168,7271,'Y','18','021','EC','A','','','AC','0000870617','0000870617','OH00001111024','IL','1','Walker','David','','','','34','372681830','19533 Williams road',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1961-11-02','M','U',':RET:2106-3','T','021','HLT','1417099','92036OH004001501','2014-01-01','2013-12-18 11:39:07','392.00',NULL,NULL,'397.25','5.25','R-OH002','OH0','397.25',NULL,0,'2013-12-26 04:08:50'),(923,766,'Y','18','021','EC','A','','','AC','0000802533','0000802533','OH00001228884','IL','1','knight','sarah','','','','34','275924744','1585 lakeview ave',0,'madison','OH','44057',NULL,'CY','39085','1989-10-06','F','U',':RET:2106-3','T','021','DEN','786751','99734OH005000401','2014-01-01','2013-10-28 19:03:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:08:55'),(1026,841,'Y','18','021','EC','A','','','AC','0000420056','0000420056','TX00000797256','IL','1','Welch','Christopher','','','','34','457678486','2324 DOUG FORD DR',0,'EL PASO','TX','79935','2402','CY','48141','1980-10-13','M','U',NULL,'N','021','DEN','45023','33348TX002000201','2014-01-01','2013-12-02 18:47:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:15:24'),(1668,1393,'Y','18','021','EC','A','','','AC','0000813178','0000813178','TX00001294032','31','1','Rangel','Lorinda','','','','34','457419482','PO box 199',0,'goliad','TX','77963',NULL,'CY','48175','1972-10-25','F','U',NULL,'N','021','DEN','2425564','33348TX002000201','2014-01-01','2013-12-24 17:57:50','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-25 18:53:49'),(2704,2189,'Y','18','021','EC','A','','','AC','0000244595','0000244595','TX00000847682','IL','1','Bailey','Tucker','','','','34','627011925','204 LOCKLEAR AVE',0,'LONGVIEW','TX','75605','5416','CY','48183','1983-08-09','M','U',':RET:2106-3','N','021','DEN','498172','33348TX002000201','2014-01-01','2013-12-02 16:09:42','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 19:47:47'),(2579,2096,'Y','18','021','EC','A','','','AC','0000208467','0000208467','OH00000277725','IL','1','koopman','michael','','','','34','279900792','602 VIRGINIA AVE',0,'TROY','OH','45373','2167','CY','39109','1983-05-19','M','R',':RET:2106-3','N','021','HLT','46827','92036OH004000501','2014-01-01','2013-12-09 16:29:04','0.00',NULL,NULL,'216.94','216.94','R-OH003','OH0','216.94',NULL,0,'2013-12-25 19:37:55'),(2582,2099,'Y','18','021','EC','A','','','AC','0000674050','0000674050','OH00001002126','IL','1','MCCOY','CRAIG','','','','34','482920167','1294 MICHAEL LN',0,'MILFORD','OH','45150','2410','CY','39025','1962-03-19','M','U',NULL,'N','021','HLT','119237','92036OH004000601','2014-01-01','2013-12-09 18:01:06','191.00',NULL,NULL,'321.93','130.93','R-OH005','OH0','321.93',NULL,0,'2013-12-25 19:38:01'),(17146,13720,'Y','18','021','EC','A','','','AC','0001185719','0001185719','LA00002028336','IL','1','Schillage','Joseph','Lawrence','','','34','437712432','17366 Grove St.',0,'Walker','LA','70785',NULL,'CY','22063','1970-07-17','M','M',':RET:2106-3','N','021','DEN','1454560','18575LA002000201','2014-02-01','2014-01-07 20:21:44','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:21:54'),(18469,14735,'Y','18','021','EC','A','','','AC','0001960945','0001960945','LA00002351935','IL','1','Peterson','Louis','','','','34','434355660','23523 Hwy 42',0,'Livingston','LA','70754',NULL,'CY','22063','1965-10-18','M','U',':RET:2106-3','N','021','DEN','1566781','18575LA002000101','2014-02-01','2014-01-15 17:43:19','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:16'),(21214,16952,'N','01','021','EC','A',NULL,NULL,'','0001185734','0002066503','','IL','1','DIKE','JOSEPHINE','','','','34','262128882','3226 TRUMAN ST',0,'BAKER','LA','70714','3448','CY','22033','1947-10-18','F','',NULL,'N','021','DEN','2911345','18575LA002000201','2014-03-01','2014-02-03 13:01:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','16.22',NULL,0,'2014-02-03 21:01:00'),(27788,21978,'Y','18','021','EC','A','','','AC','0000656729','0000656729','MS00003107353','IL','1','Sanchez','Manuel','','','','34','425595471','137 OVERVIEW RD',0,'STARKVILLE','MS','39759','6491','CY','28105','1974-07-13','M','U',':RET:2106-3','N','021','DEN','3228976','46300MS002000201','2014-04-01','2014-03-05 13:12:50','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-05 21:31:38'),(6241,4945,'N','03','021','EC','A',NULL,NULL,'','0001221906','0000810749','','IL','1','Miller','Chyla','Jolee','','','34','268118616','313 FRANKLIN ST',0,'MIDDLETOWN','OH','45042','3245','CY','39017','2004-09-04','F','',':RET:2106-3','N','021','DEN','736952','99734OH005000301','2014-01-01','2013-11-18 23:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:31:40'),(17680,14129,'Y','18','021','EC','A','','','AC','0001521983','0001521983','LA00001971175','IL','1','bratcher','richard','','','','34','435907454','425 BELLEVUE DR',0,'LA PLACE','LA','70068','3403','CY','22095','1956-11-30','M','M',NULL,'T','021','DEN','2433904','18575LA002000101','2014-02-01','2014-01-13 15:13:46','0.00',NULL,NULL,'75.06','75.06','R-LA001','LA0','25.02',NULL,0,'2014-01-14 01:32:54'),(18352,14650,'Y','18','021','EC','A','','','AC','0000746912','0000746912','OH00002062081','IL','1','Knautz','Kimberly','','','','34','289806621','14480 BASS LAKE RD',0,'NEWBURY','OH','44065','9641','CY','39055','1966-04-04','F','U',NULL,'T','021','DEN','1470678','99734OH005000301','2014-02-01','2014-01-14 20:11:07','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:21'),(19049,15172,'Y','18','021','EC','A','','','AC','0001889345','0001889345','LA00002499205','IL','1','HUDSON','kATHRYN','','','','34','439733220','9323 Oak Plaza DR',0,'Denham Springs','LA','70726',NULL,'CY','22063','1980-01-22','F','U',':RET:2106-3','N','021','DEN','3066455','18575LA002000101','2014-03-01','2014-01-17 12:48:20','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-20 08:06:43'),(21593,17247,'N','19','021','EC','A',NULL,NULL,'','0001160446','0000200797','','S1','1','Sheeley','Scott','Anthony','','','34','299115118','504 DAKOTA RD',0,'BELLEFONTAINE','OH','43311','2347','CY','39091','2006-06-26','F','',':RET:2106-3','N','021','DEN','3810658','99734OH005000301','2014-03-01','2014-02-05 10:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:30'),(21859,17453,'N','19','021','EC','A',NULL,NULL,'','0000378617','0001223208','','IL','1','SETON','ERNEST','','','III','34','284083070','2411 WIMBLEDON PARK BLVD',0,'TOLEDO','OH','43617','2237','CY','39095','2003-07-18','M','',NULL,'N','021','DEN','3239687','99734OH005000301','2014-03-01','2014-02-06 14:02:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:19'),(22573,18028,'Y','18','021','EC','A','','','AC','0000798455','0000798455','OH00002212410','IL','1','Upadia','Jeffrey','','','','34','268828753','4770 COLONEL PERRY DR',0,'COLUMBUS','OH','43229','6436','CY','39049','1982-08-31','M','U',NULL,'N','021','DEN','3819328','99734OH005000401','2014-03-01','2014-02-10 17:26:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-10 21:31:58'),(23207,18502,'Y','18','024','14','A','','','TE','0000731237','0000731237','','IL','1','Hruska','Andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-02-24','M','',NULL,NULL,NULL,'','2628780','','2014-02-12','2014-02-12 13:33:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:32:11'),(25981,20604,'N','01','021','EC','A',NULL,NULL,'','0000268950','0000934712','','IL','1','Cook','John','P','','','34','285523251','724 KYLE DR',0,'TIPP CITY','OH','45371','1436','CY','39109','1964-08-18','M','',':RET:2106-3','N','021','DEN','3825901','99734OH005000401','2014-03-01','2014-02-26 16:31:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:51'),(26571,21067,'Y','18','021','EC','A','','','AC','0000273850','0000273850','OH00002750190','IL','1','PARKER','GERALD','','','','34','276707082','1034 MOHICAN AVE',0,'COLOMBUS','OH','43224',NULL,'CY','39049','1961-01-10','M','U',':RET:2106-3','N','021','DEN','2681213','99734OH005000401','2014-04-01','2014-02-28 11:31:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:25'),(27439,21716,'Y','18','021','EC','A','','','AC','0001665320','0001665320','LA00003354610','IL','1','Courtney','Ronnie','','','','34','438356900','8174 SUPERIOR DR',0,'DENHAM SPRINGS','LA','70726','6284','CY','22063','1971-01-18','M','R',':RET:2106-3','N','021','DEN','2935173','18575LA002000201','2014-04-01','2014-03-04 15:20:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-04 21:01:52'),(27577,21808,'Y','18','021','EC','A','','','AC','0001566480','0001566480','LA00003262610','31','1','GARSEE','LELA','','','','34','435231634','PO BOX 1766',0,'WEST MONROE','LA','71294',NULL,'CY','22073','1962-09-10','F','M',':RET:2106-3','N','021','DEN','3895140','18575LA002000201','2014-04-01','2014-03-04 13:49:16','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61','CIC',0,'2014-03-04 21:30:23'),(28095,22237,'Y','18','024','14','A','','','TE','0000545440','0000545440','','IL','1','Beauchamp','Andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-05','M','',NULL,NULL,NULL,'','3013967','','2014-03-31','2014-03-06 14:35:11',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERM',0,'2014-03-06 21:02:07'),(1097,901,'Y','18','021','EC','A','','','AC','0000585504','0000585504','OH00000642425','IL','1','Ollison','Rapheal','','','','34','465699923','13009 SOIKA AVE',0,'CLEVELAND','OH','44120','3205','CY','39035','1984-10-10','M','U',':RET:2054-5','N','021','DEN','492324','99734OH005000401','2014-01-01','2013-12-03 08:24:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:10'),(4264,3397,'N','01','021','EC','A',NULL,NULL,'','0001084135','0000285626','','IL','1','Whitman','Sheryl','','','','34','022501815','257 HOLLYWOOD AVE',0,'AKRON','OH','44313','6740','CY','39153','1968-01-05','F','',':RET:2106-3','N','021','HLT','1677983','52664OH151001501','2014-01-01','2013-12-17 15:42:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','386.22',NULL,0,'2013-12-25 21:51:36'),(7296,5782,'Y','18','021','EC','A','','','AC','0000262710','0000262710','OH00000092559','IL','1','MILLIKIN','MATTHEW','','','','34','302865500','3925 NEW HUDSON RD',0,'ORWELL','OH','44076','9769','CY','39007','1975-06-07','M','U',':RET:2106-3','T','021','HLT','1129353','52664OH151001304','2014-01-01','2013-12-13 22:25:40','76.00',NULL,NULL,'360.40','284.40','R-OH011','OH0','360.40',NULL,0,'2013-12-26 02:03:00'),(7005,5560,'Y','18','021','EC','A','','','AC','0000389421','0000389421','TX00000103898','IL','1','Jarero','Mario','','','','34','461832480','2605 Fulton Dr',0,'Corpus Christi','TX','78414',NULL,'CY','48355','1957-11-23','M','M',NULL,'N','021','DEN','1821617','33348TX002000201','2014-01-01','2013-12-24 19:23:16','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-26 01:48:22'),(6768,5370,'Y','18','021','EC','A','','','AC','0000468881','0000468881','LA00000719538','IL','1','Fontenot','Michael','Joseph','','','34','433782941','270 BRUCE CIR',0,'LAKE CHARLES','LA','70611','5639','CY','22019','1962-01-04','M','U',':RET:2054-5','T','021','DEN','965766','18575LA002000201','2014-01-01','2013-11-25 12:01:31','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 01:16:32'),(18437,14710,'Y','18','021','EC','A','','','AC','0002294905','0002294905','LA00001460099','IL','1','Brown','Wayne','','','','34','434157248','1417 NUNEZ ST',0,'NEW ORLEANS','LA','70114','5824','CY','22071','1962-07-14','M','R',':RET:2054-5','T','021','DEN','2578026','18575LA002000201','2014-02-01','2014-01-15 15:26:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:46:01'),(19373,15443,'Y','18','021','EC','A','','','AC','0000341367','0000341367','OH00001551867','IL','1','Holmes','Shelly','','','','34','298543229','1814 CHRISTOPHER DR',0,'AKRON','OH','44312','4257','CY','39153','1950-12-16','F','M',':RET:2106-3','T','021','HLT','3252745','52664OH151001304','2014-03-01','2014-01-21 16:36:56','384.00',NULL,NULL,'757.07','373.07','R-OH012','OH0','757.07',NULL,1,'2014-01-22 03:22:37'),(19974,15932,'Y','18','021','EC','A','','','AC','0000792268','0000792268','TX00001788656','IL','1','Born','Douglas','','','','34','462299906','4181 SILVER DOME RD',0,'DENTON','TX','76208','3224','CY','48121','1964-02-22','M','U',NULL,'N','021','DEN','2275768','33348TX002000101','2014-03-01','2014-01-24 23:06:09','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-25 19:00:12'),(25956,20586,'Y','18','024','14','A','','','TE','0000674114','0000674114','','IL','1','Shredl','Jean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-04-19','F','',NULL,NULL,NULL,'','2774002','','2014-02-26','2014-02-26 12:02:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:01:39'),(154,128,'N','01','021','EC','A',NULL,NULL,'','0001015289','0000266567','','IL','1','Isaac','Jesus','','','','34','451983977','620 IRA LEE RD',0,'SAN ANTONIO','TX','78218','1773','CY','48029','1954-05-29','M','',':RET:2106-3','N','021','DEN','356574','33348TX002000101','2014-01-01','2013-12-05 13:19:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 17:18:59'),(14911,11913,'Y','18','024','14','A','','','TE','0000556704','0000556704','','IL','1','Vroman','Jesse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-02-23','M','',NULL,NULL,NULL,'','1877331','','2013-12-28','2013-12-28 20:21:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-30 00:01:26'),(816,675,'Y','18','021','EC','A','','','AC','0000735019','0000735019','OH00000645075','IL','1','Chapman','Elizabeth','Lee','','','34','296544957','1554 SUNNYACRES RD',0,'COPLEY','OH','44321','2329','CY','39153','1954-05-07','F','U',':RET:2106-3','N','021','HLT','1972672','52664OH151001306','2014-01-01','2013-12-16 11:42:35','483.00',NULL,NULL,'580.49','97.49','R-OH012','OH0','580.49',NULL,0,'2013-12-25 18:05:56'),(2338,1903,'Y','18','021','EC','A','','','AC','0000306369','0000306369','TX00001168301','IL','1','Newell','Seth','','','','34','459597539','2307 MARSHALL DR',0,'BIG SPRING','TX','79720','5218','CY','48227','1980-09-07','M','M',':RET:2106-3','T','021','DEN','453328','33348TX002000201','2014-01-01','2013-12-09 12:39:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:52'),(7225,5727,'Y','18','021','EC','A','','','AC','0000584258','0000584258','OH00000655311','IL','1','Gaugh','Sarah','','','','34','287840931','304 Bailey Rd.',0,'Conneaut','OH','44030',NULL,'CY','39007','1986-05-19','F','U',':RET:2106-3','N','021','DEN','994202','99734OH005000401','2014-01-01','2013-12-14 15:43:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:01:13'),(9401,7457,'Y','18','021','EC','A','','','AC','0000843334','0000843334','TX00001196997','IL','1','MCKENZIE','LORETTA','A','','','34','629345166','1305 CALIFORNIA TRL',0,'GRAND PRAIRIE','TX','75052','2075','CY','48113','1992-12-11','F','U',':RET:2054-5','N','021','DEN','1957989','33348TX002000201','2014-01-01','2013-12-21 00:34:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:32:35'),(17789,14210,'N','01','021','EC','A',NULL,NULL,'','0000498183','0000885611','','IL','1','Fisher','Heidi','','','','34','297649452','4444 STATE ROUTE 763',0,'RIPLEY','OH','45167','8201','CY','39015','1973-02-01','F','',':RET:2106-3','N','021','HLT','2328944','92036OH003000605','2014-02-01','2014-01-13 14:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.89',NULL,0,'2014-01-14 01:33:46'),(19940,15903,'Y','18','021','EC','A','','','AC','0000201952','0000201952','OH00002538889','IL','1','Hall','Lawanda','','','','34','397783471','1189 S Main St',0,'Lima','OH','45804',NULL,'CY','39003','1975-02-12','F','R',':RET:2054-5','T','021','HLT','3350996','92036OH004001501','2014-03-01','2014-01-24 09:52:22','0.00',NULL,NULL,'256.83','256.83','R-OH002','OH0','256.83',NULL,0,'2014-01-24 21:01:14'),(22118,17655,'Y','18','021','EC','A','','','AC','0000963527','0000963527','TX00001706092','IL','1','Marquez','Marynka','','','','34','629123231','4013 ROXBURY DR',0,'EL PASO','TX','79922','1916','CY','48141','1989-11-06','F','U',':RET:2106-3','N','021','DEN','3094453','33348TX002000101','2014-03-01','2014-02-08 15:59:01','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-02-08 19:00:38'),(28028,22181,'Y','18','021','EC','A','','','AC','0000120152','0000120152','OH00003042535','IL','1','STAPLETON','TRAVIS','','','','34','271905844','37438 EUCLID AVE',0,'WILLOUGHBY','OH','44094','5644','CY','39085','1984-03-24','M','U',NULL,'N','021','DEN','3308114','99734OH005000401','2014-04-01','2014-03-06 16:35:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:26'),(6379,5058,'Y','18','021','EC','A','','','AC','0000336406','0000336406','OH00000296061','IL','1','Frank','Lynn','','','','34','272484601','5504 E GALBRAITH RD',0,'CINCINNATI','OH','45236','2858','CY','39061','1949-10-25','F','U',':RET:2106-3','N','021','DEN','1135493','99734OH005000301','2014-01-01','2013-12-11 10:02:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:47:52'),(21388,17092,'N','19','021','EC','A',NULL,NULL,'','0000552661','0000727325','','IL','1','Mason','Carter','','','','34','292139650','3800 MILNER RD',0,'NEWARK','OH','43055','9304','CY','39089','2008-01-23','M','',':RET:2106-3','N','021','DEN','3762814','99734OH005000401','2014-03-01','2014-02-04 09:27:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:56'),(19026,15153,'Y','18','021','EC','A','','','AC','0000251649','0000251649','OH00001668149','IL','1','Miller','Dean','','','','34','301805725','820 E Twp Road 130',0,'Tiffin','OH','44883',NULL,'CY','39147','1968-04-08','M','M',':RET:2106-3','T','021','HLT','1704278','92036OH004002701','2014-03-01','2014-01-17 10:22:59','340.00',NULL,NULL,'464.52','124.52','R-OH006','OH0','260.37',NULL,0,'2014-01-20 08:06:29'),(18686,14897,'Y','18','021','EC','A','','','AC','0002015318','0002015318','LA00001875248','IL','1','Dannel','Amy','','','','34','437410908','6300 MORRISON RD',0,'NEW ORLEANS','LA','70126','1511','CY','22071','1978-06-02','F','M',':RET:2054-5','N','021','DEN','1437482','18575LA002000101','2014-02-01','2014-01-15 22:05:50','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-01-17 03:35:22'),(28140,22269,'Y','18','021','EC','A','','','AC','0000604764','0000604764','OH00002921792','IL','1','Rimawi','Sahar','F','','','34','067887879','13698 OTUSSO DR',0,'PERRYSBURG','OH','43551','1068','CY','39173','1969-12-12','F','U',':RET:2106-3','N','021','HLT','3838557','92036OH006002601','2014-04-01','2014-03-05 22:14:44','0.00',NULL,NULL,'216.04','216.04','R-OH001','OH0','216.04',NULL,0,'2014-03-06 21:02:30'),(28398,22468,'Y','18','021','EC','A','','','AC','0000848416','0000848416','OH00003599034','31','1','Burress','Kathy','','','','34','281541718','PO Box 604',0,'Hillsboro','OH','45133',NULL,'CY','39071','1954-02-16','F','U',':RET:2106-3','N','021','DEN','3180401','99734OH005000401','2014-04-01','2014-03-06 20:58:32','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-07 21:30:48'),(1788,1471,'N','01','021','EC','A',NULL,NULL,'','0000596279','0000072883','','IL','1','TIGRETT','SCOTT','R','','','34','281567119','910 MAURINE DR',0,'COLUMBUS','OH','43228','3118','CY','39049','1965-08-04','M','',':RET:2106-3','N','021','DEN','2152098','99734OH005000301','2014-01-01','2013-12-24 16:20:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:30'),(7825,6198,'Y','18','021','EC','A','','','AC','0000178879','0000178879','OH00000261084','IL','1','diep','tuan','','','','34','084769983','405 reed rd apt 41B',0,'beavercreek','OH','45440',NULL,'CY','39113','1975-06-03','M','M',':RET:2047-9','N','021','DEN','1963916','99734OH005000301','2014-01-01','2013-12-19 18:59:01','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:04:17'),(21709,17335,'N','01','021','EC','A',NULL,NULL,'','0000753418','0001220872','','IL','1','Long','Robert','S','','','34','291728552','4827 ROCKDALE RD',0,'LIBERTY TWP','OH','45011','2330','CY','39017','1966-09-12','M','',':RET:2106-3','N','021','HLT','3328107','92036OH003001206','2014-03-01','2014-02-05 09:25:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','350.40',NULL,0,'2014-02-05 21:31:14'),(3274,2639,'Y','18','021','EC','A','','','AC','0001196806','0001196806','OH00000345663','IL','1','Lee','Vanessa','','','','34','296803393','3338 Alamo Ave',0,'Cincinnati','OH','45209',NULL,'CY','39061','1980-10-01','F','U',':RET:2106-3','N','021','HLT','1435475','92036OH004001201','2014-01-01','2013-12-21 18:28:14','0.00',NULL,NULL,'206.78','206.78','R-OH004','OH0','206.78',NULL,0,'2013-12-25 21:15:03'),(20922,16723,'Y','18','021','EC','A','','','AC','0001144804','0001144804','OH00001494993','IL','1','Brightbill','Linda','','','','34','278580170','2808 NORMA ST',0,'CUYAHOGA FALLS','OH','44223','1733','CY','39153','1955-01-12','F','M',':RET:2106-3','T','021','HLT','3275328','52664OH151001501','2014-03-01','2014-01-31 11:45:39','699.00',NULL,NULL,'1603.02','904.02','R-OH012','OH0','800.64',NULL,0,'2014-01-31 21:01:33'),(20862,16673,'N','19','021','EC','A',NULL,NULL,'','0000728749','0000438004','','IL','1','Vyas','Ariya',NULL,NULL,NULL,NULL,NULL,'5830 TRIPLETT SQ',0,'NEW ALBANY','OH','43054','8080','CY','39049','2011-12-22','F','',':RET:2106-3','N','021','DEN','2759609','99734OH005000301','2014-03-01','2014-01-31 15:19:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:57'),(6959,5525,'N','19','021','EC','A',NULL,NULL,'','0000093853','0001083093','','IL','1','MURPHY','SHERRELL','R','','','34','607384759','4030 BELMORE TRACE',0,'DAYTON','OH','45426',NULL,'CY','39113','1989-12-08','F','',':RET:2054-5','N','021','DEN','1504748','99734OH005000401','2014-01-01','2013-12-24 22:17:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:13'),(3971,3172,'Y','18','021','EC','A','','','AC','0000834436','0000834436','OH00001046829','IL','1','McGarvey','Steve','','','','34','298884011','635 ROMBACH AVE',0,'WILMINGTON','OH','45177','2486','CY','39027','1982-06-23','M','U',':RET:2106-3','T','021','HLT','1240928','92036OH004000601','2014-01-01','2013-12-13 12:24:13','0.00',NULL,NULL,'230.07','230.07','R-OH005','OH0','230.07',NULL,0,'2013-12-25 21:38:34'),(13255,10579,'Y','18','021','EC','A','','','AC','0000539715','0000539715','TX00000287873','IL','1','Mack','Samuel','','','','34','451047317','207 Grayson',0,'Teague','TX','75860',NULL,'CY','48161','1956-05-13','M','M',':RET:2054-5','N','021','DEN','2393930','33348TX002000201','2014-01-01','2013-12-23 11:30:21','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:31'),(24389,19371,'Y','18','021','EC','A','','','AC','0000824638','0000824638','OH00002994205','IL','1','Molloy','Sarah','','','','34','149807703','820 Carrington Place',0,'Loveland','OH','45140',NULL,'CY','39061','1981-10-20','F','U',':RET:2106-3','N','021','DEN','2623883','99734OH005000401','2014-04-01','2014-02-18 11:51:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:47'),(9415,7470,'Y','18','021','EC','A','','','AC','0000854459','0000854459','TX00000923973','IL','1','Rios','Gustavo','','','','34','461630213','110 Highland Circle',0,'Crystal City','TX','78839',NULL,'CY','48507','1973-05-02','M','M',NULL,'N','021','DEN','2456943','33348TX002000201','2014-01-01','2013-12-21 13:46:30','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:32:58'),(1584,1322,'Y','18','021','EC','A','','','AC','0000999033','0000999033','TX00000332355','IL','1','Nelson','Sherry','','','','34','459881870','1507 CYPRESS ST',0,'BRECKENRIDGE','TX','76424','5011','CY','48429','1953-02-26','F','M',':RET:2106-3','N','021','DEN','2055696','33348TX002000201','2014-01-01','2013-12-24 10:53:29','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:32'),(22137,17669,'Y','18','021','EC','A','','','AC','0001136685','0001136685','OH00002193940','IL','1','Harpster','Kaleena','','','','34','299888504','1214 ANDERSON RD',0,'CUYAHOGA FALLS','OH','44221','4304','CY','39153','1988-08-22','F','U',':RET:2106-3','N','021','DEN','3660585','99734OH005000401','2014-03-01','2014-02-08 16:19:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-08 19:00:47'),(20215,16129,'N','01','021','EC','A',NULL,NULL,'','0001218568','0000374732','','IL','1','ABBOTT','JOSEPH','L','','','34','275668091','907 SURREY RIDGE',0,'CINCINNATI','OH','45245',NULL,'CY','39025','1966-02-24','M','',NULL,'N','021','HLT','1810272','92036OH001000601','2014-03-01','2014-01-27 12:39:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','423.37',NULL,0,'2014-01-27 21:01:41'),(1736,1441,'N','01','021','EC','A',NULL,NULL,'','0000813089','0001179629','','IL','1','Pressel','Adam','Steven','','','34','275883464','1480 WAINSCOTT WAY',0,'DAYTON','OH','45414','5915','CY','39113','1978-08-26','M','',':RET:2106-3','T','021','DEN','1480239','99734OH005000301','2014-01-01','2013-12-24 11:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:27'),(4916,3900,'Y','18','021','EC','A','','','AC','0000048151','0000048151','OH00000681495','IL','1','MCDONALD','NITAYA','Y','','','34','301782994','32367 HAMILTON CT',0,'SOLON','OH','44139','6201','CY','39035','1966-11-06','F','U',':RET:2054-5','N','021','HLT','947617','52664OH151001301','2014-01-01','2013-10-26 14:49:09','0.00',NULL,NULL,'393.12','393.12','R-OH011','OH0','393.12',NULL,0,'2013-12-25 22:32:15'),(5566,4418,'N','19','021','EC','A',NULL,NULL,'','0001050608','0000534538','','IL','1','Coakley','Caleb','B',NULL,NULL,NULL,NULL,'1044 MCCOY CT',0,'PATASKALA','OH','43062','7098','CY','39089','2000-01-27','M','',':RET:2106-3','N','021','DEN','276530','99734OH005000301','2014-01-01','2013-11-05 19:28:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:36'),(16165,12942,'Y','18','021','EC','A','','','AC','0002266690','0002266690','LA00002071781','IL','1','Toups','Hunter','A','','','34','433794611','701 W WAYSIDE DR',0,'WESTLAKE','LA','70669','6713','CY','22019','1990-01-24','M','U',':RET:2106-3','N','021','DEN','2004614','18575LA002000201','2014-02-01','2014-01-03 18:31:39','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-05 00:00:03'),(5033,3986,'N','01','021','EC','A',NULL,NULL,'','0001175687','0000122945','','IL','1','Dunn','Milena','','','','34','260022638','107 SANTA MARIA WOODS DR',0,'MOSCOW','OH','45153','9656','CY','39025','1949-10-16','F','',':RET:2106-3','T','021','HLT','63967','92036OH006000601','2014-01-01','2013-12-07 16:37:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','587.34',NULL,0,'2013-12-25 22:47:48'),(13513,10771,'Y','18','021','EC','A','','','AC','0001157720','0001157720','LA00000898967','IL','1','Shumate','Rachel','Anne','','','34','284863258','2132 S SALCEDO ST',0,'NEW ORLEANS','LA','70125','4450','CY','22071','1983-07-27','F','U',':RET:2106-3','N','021','DEN','2263599','18575LA002000201','2014-01-01','2013-12-22 23:19:03','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:02:58'),(13684,10919,'Y','18','021','EC','A','','','AC','0000413362','0000413362','OH00000765454','IL','1','Shaheen','Terrie','Lee','','','34','269605350','6061 LAKEWOOD ST NW',0,'CANTON','OH','44718','1346','CY','39151','1956-07-08','F','U',':RET:2106-3','N','021','HLT','2251373','52664OH151001306','2014-01-01','2013-12-23 09:27:06','446.00',NULL,NULL,'543.47','97.47','R-OH015','OH0','543.47',NULL,0,'2013-12-26 13:08:17'),(26552,21052,'Y','18','021','EC','A','','','AC','0000524545','0000524545','OH00003408500','IL','1','Dunn','Sheirida','','','','34','548531657','1393 E BROAD ST',0,'COLUMBUS','OH','43205','1584','CY','39049','1978-04-01','F','U',NULL,'N','021','DEN','3567240','99734OH005000301','2014-04-01','2014-02-28 14:41:20','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:14'),(26730,21186,'N','19','021','EC','A',NULL,NULL,'','0000328462','0000968263','','IL','1','Hedrick','Kaydin','','','','34','838454091','4825 BURNHAM AVE',0,'TOLEDO','OH','43612','2438','CY','39095','2013-12-13','F','',NULL,'N','021','HLT','3290702','92036OH003002604','2014-01-01','2014-02-28 11:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-28 21:31:49'),(28788,22788,'Y','18','021','EC','A','','','AC','0000111964','0000111964','OH00002881599','IL','1','White','Kathy','','','','34','286583115','932 E SANDUSKY ST',0,'FINDLAY','OH','45840','6442','CY','39063','1955-10-27','F','U',NULL,'N','021','HLT','4270713','92036OH004001501','2014-04-01','2014-03-09 14:04:07','447.60',NULL,NULL,'450.90','3.30','R-OH002','OH0','450.90',NULL,0,'2014-03-09 21:00:40'),(28967,22926,'Y','18','021','EC','A','','','AC','0001517929','0001517929','LA00003816223','IL','1','BENNETT','NATHANIEL','PRESTON','','Sr','34','434537672','6962 BOSTON DR',0,'NEW ORLEANS','LA','70127','2102','CY','22071','1984-01-13','M','U',':RET:2054-5','N','021','DEN','2822418','18575LA002000201','2014-04-01','2014-03-10 15:31:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:01:00'),(1229,1012,'Y','18','021','EC','A','','','AC','0000824556','0000824556','OH00001062228','IL','1','Sutton','Kyndal','','','','34','292828432','608 SACKETT AVE',0,'CUYAHOGA FALLS','OH','44221','4549','CY','39153','1985-01-06','F','U',':RET:2106-3','N','021','HLT','244534','52664OH151001305','2014-01-01','2013-12-03 17:24:20','120.00',NULL,NULL,'242.41','122.41','R-OH012','OH0','242.41',NULL,0,'2013-12-25 18:20:39'),(23324,18589,'Y','18','021','EC','A','','','AC','0001001203','0001001203','OH00002539331','IL','1','WARD','STEPHANIE','R','','','34','277111848','9822 TIMBERS DR',0,'BLUE ASH','OH','45242',NULL,'CY','39061','1952-12-15','F','U',':RET:2054-5','N','021','DEN','3776025','99734OH005000301','2014-03-01','2014-02-13 13:51:16','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:26'),(21996,17565,'Y','18','021','EC','A','','','AC','0001945942','0001945942','LA00001451919','IL','1','Almaguer','Santa','','','','34','660102529','2813 BRITANNICA DR',0,'MARRERO','LA','70072','6031','CY','22051','1963-02-18','F','M',':RET:2106-3','N','021','DEN','2701605','18575LA002000201','2014-03-01','2014-02-07 15:29:37','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-07 19:00:45'),(5595,4440,'Y','18','021','EC','A','','','AC','0000888002','0000888002','LA00000474881','IL','1','Brock','Andrew','','','','34','433455654','916 S UPLAND AVE',0,'METAIRIE','LA','70003','6760','CY','22051','1981-04-15','M','U',':RET:2054-5','N','021','DEN','450256','18575LA002000201','2014-01-01','2013-11-25 18:22:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:30:05'),(5716,4538,'Y','18','021','EC','A','','','AC','0000192738','0000192738','OH00001388372','IL','1','Snyder','Daniel','','','','34','384927907','1226 N BEVER ST',0,'WOOSTER','OH','44691','2316','CY','39169','1968-12-02','M','M',':RET:2106-3','N','021','HLT','1976754','52664OH151001306','2014-01-01','2013-12-24 01:10:51','363.00',NULL,NULL,'599.89','236.89','R-OH014','OH0','322.02',NULL,0,'2013-12-25 23:45:16'),(6724,5334,'Y','18','021','EC','A','','','AC','0001153585','0001153585','OH00000622960','IL','1','daye','gary','','','','34','284668607','5094 ZIMMER DR',0,'COLUMBUS','OH','43232','6048','CY','39049','1960-03-07','M','U',':RET:2106-3','N','021','DEN','839316','99734OH005000401','2014-01-01','2013-11-25 17:56:24','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:15:18'),(13178,10512,'Y','18','021','EC','A','','','AC','0000994931','0000994931','TX00001142490','IL','1','Riggs','Ann','','','','34','512728932','14860 TURNBRIDGE DR',0,'FRISCO','TX','75035','4830','CY','48085','1959-02-22','F','U',':RET:2106-3','N','021','DEN','1411453','33348TX002000101','2014-01-01','2013-12-22 19:05:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:13'),(15615,12490,'Y','18','021','EC','A','','','AC','0000282616','0000282616','MS00000936281','IL','1','Ross','Bobby','','','','34','434822561','103 SUNRISE POINT DR',0,'BRANDON','MS','39047','6523','CY','28121','1951-04-17','M','M',NULL,'N','021','DEN','1832816','46300MS002000101','2014-02-01','2013-12-30 21:26:55','0.00',NULL,NULL,'101.40','101.40','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:32:57'),(28235,22340,'Y','18','021','EC','A','','','AC','0000884230','0000884230','OH00003056347','IL','1','Stupar','Gillian','Rose','','','34','295767460','3615 IRA RD',0,'AKRON','OH','44333','1211','CY','39153','1969-09-16','F','U',':RET:2106-3','N','021','DEN','3673897','99734OH005000401','2014-04-01','2014-03-06 17:56:01','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-03-06 21:30:25'),(28336,22420,'Y','18','021','EC','A','','','AC','0000049649','0000049649','TX00002760351','IL','1','Terry','Damian','','','','34','464233647','9403 BALSAM LN',0,'HOUSTON','TX','77078','3303','CY','48201','1970-01-29','M','U',':RET:2054-5','N','021','DEN','3106942','33348TX002000201','2014-04-01','2014-03-07 09:25:20','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:14'),(28926,22893,'Y','18','021','EC','A','','','AC','0000758334','0000758334','OH00002789652','IL','1','LYDON','VIRGINIA','','','','34','379646825','27695 TRACY ROAD  LOT 316',0,'WALBRIDGE','OH','43465',NULL,'CY','39173','1955-08-27','F','U',NULL,'N','021','DEN','4256521','99734OH005000301','2014-04-01','2014-03-10 13:01:46','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-10 21:00:34'),(2479,2018,'Y','18','021','EC','A','','','AC','0000198831','0000198831','LA00000153850','IL','1','Brown','Keith','','','','34','436154884','4204 LUCERNE ST',0,'METAIRIE','LA','70006','2444','CY','22051','1960-11-17','M','U',':RET:2106-3','N','021','DEN','1025624','18575LA002000201','2014-01-01','2013-12-09 13:33:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:27'),(22663,18097,'Y','18','021','EC','A','','','AC','0000652770','0000652770','TX00002197721','31','1','Stock','Brent','','','','34','640344875','19 FRONT ST',0,'ROCKPORT','TX','78382','7802','CY','48453','1987-11-03','M','R',':RET:2106-3','N','021','DEN','3401413','33348TX002000201','2014-03-01','2014-02-11 13:26:43','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-11 21:00:36'),(7903,6247,'Y','18','021','EC','A','','','AC','0000066237','0000066237','OH00000888488','IL','1','Mato','Debra','','','','34','197420350','1694 FELLSMERE LN',0,'CINCINNATI','OH','45240','1018','CY','39061','1954-03-05','F','M',':RET:2106-3','N','021','HLT','1577221','92036OH003001204','2014-01-01','2013-12-19 20:07:06','273.00',NULL,NULL,'583.55','310.55','R-OH004','OH0','583.55',NULL,0,'2013-12-26 03:05:51'),(5243,4158,'Y','18','021','EC','A','','','AC','0001129005','0001129005','OH00000792021','IL','1','Spence','Janet','','','','34','268820327','104 CLEVELAND AVE',0,'DOYLESTOWN','OH','44230','1203','CY','39169','1979-05-29','F','U',':RET:2106-3','N','021','HLT','1853371','52664OH151001306','2014-01-01','2013-12-18 21:54:01','0.00',NULL,NULL,'270.73','270.73','R-OH014','OH0','270.73',NULL,0,'2013-12-25 23:04:58'),(19688,15689,'Y','18','021','EC','A','','','AC','0000752647','0000752647','TX00002465025','IL','1','Gonzalez','Roel','','','Jr','34','461614462','2625 N HIGHWAY 83',0,'ROMA','TX','78584','5882','CY','48427','1975-12-30','M','U',NULL,'N','021','DEN','3282979','33348TX002000201','2014-03-01','2014-01-23 13:52:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:41'),(4766,3781,'Y','18','021','EC','A','','','AC','0000378555','0000378555','OH00001006510','IL','1','Schultz','Patricia','Ann','','','34','150569452','13813 Cedar Rd',0,'South Euclid','OH','44118',NULL,'CY','39035','1962-11-03','F','U',':RET:2106-3','N','021','DEN','1002647','99734OH005000401','2014-01-01','2013-12-08 10:52:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:15:41'),(3863,3093,'Y','18','021','EC','A','','','AC','0000421726','0000421726','LA00000599948','IL','1','Dunlap','Seth','','','','34','439758120','11 Ranch Oak Drive',0,'West Monroe','LA','71291',NULL,'CY','22073','1985-07-03','F','U',':RET:2106-3','N','021','DEN','28821','18575LA002000201','2014-01-01','2013-12-12 20:56:12','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 21:36:00'),(13862,11061,'Y','18','021','EC','A','','','AC','0001127991','0001127991','OH00000519468','IL','1','Davis','Debra','','','','34','246350353','2542 RANFIELD RD',0,'MOGADORE','OH','44260','9457','CY','39133','1965-05-28','F','M',':RET:2106-3','T','021','HLT','1864308','52664OH151001501','2014-01-01','2013-12-22 23:20:52','140.00',NULL,NULL,'1035.69','895.69','R-OH012','OH0','502.90',NULL,0,'2013-12-26 13:12:51'),(14051,11195,'Y','18','021','EC','A','','','AC','0000683397','0000683397','OH00001313859','IL','1','JONES','VANESSA','','','','34','290705633','313 JEFFERSON AVE',0,'SAINT BERNARD','OH','45217','1710','CY','39061','1971-06-24','F','U',':RET:2054-5','T','021','DEN','2067036','99734OH005000301','2014-02-01','2013-12-26 13:37:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:17'),(14951,11949,'Y','18','024','14','A','','','TE','0000253290','0000253290','','IL','1','Chen','Marlon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-05-26','M','',NULL,NULL,NULL,'','1552971','','2013-12-29','2013-12-29 21:22:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-01 12:00:11'),(24339,19329,'Y','18','021','EC','A','','','AC','0000049584','0000049584','TX00001675687','IL','1','Perez','Angelina','','','','34','451815279','7499 CHEVY CHASE DR',0,'AUSTIN','TX','78752','1547','CY','48453','1987-01-15','F','U',NULL,'N','021','DEN','3789878','33348TX002000201','2014-04-01','2014-02-18 14:36:01','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-18 22:00:18'),(24856,19706,'Y','18','021','EC','A','','','AC','0000927356','0000927356','OH00001632232','IL','1','MATA','JORGE','A','','','34','460976206','4217 SOUTH AVE',0,'CINCINNATI','OH','45236','3705','CY','39061','1963-04-23','M','U',NULL,'N','021','HLT','2641635','92036OH004001201','2014-04-01','2014-02-19 16:35:56','192.00',NULL,NULL,'308.28','116.28','R-OH004','OH0','308.28',NULL,0,'2014-02-20 04:56:08'),(19589,15615,'Y','18','021','EC','A','','','AC','0000824587','0000824587','MS00002285447','IL','1','Betts','Terrisita','','','','34','425139617','1810 COUNTRY CLUB RD',0,'HATTIESBURG','MS','39401','7886','CY','28035','1976-08-09','F','U',':RET:2054-5','N','021','DEN','2803528','46300MS002000201','2014-03-01','2014-01-22 16:36:50','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-23 03:02:43'),(17935,14329,'Y','18','021','EC','A','','','AC','0000102390','0000102390','TX00002336021','IL','1','ashmore','andrew','','','','34','431699233','68 Comal',0,'Austin','TX','78702',NULL,'CY','48453','1982-11-15','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1570184','33348TX002000201','2014-02-01','2014-01-14 14:29:29','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:37'),(18869,15031,'Y','18','021','EC','A','','','AC','0001885756','0001885756','LA00001483080','31','1','Galloway','Timothy','Wayne','','','34','438152545','6300 Pandora Street',0,'New Orleans','LA','70126',NULL,'CY','22071','1960-08-28','M','U',':RET:2054-5','T','021','DEN','2210320','18575LA002000201','2014-03-01','2014-01-16 11:57:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:23'),(23966,19054,'N','01','021','EC','A',NULL,NULL,'','0001232037','0000645562','','IL','1','Ahmed','Samina','Tahir','','','34','384139949','8426 SEA ASH CIR',0,'ROUND ROCK','TX','78681','3410','CY','48491','1952-07-23','F','',NULL,'N','021','DEN','3639652','33348TX002000101','2014-03-01','2014-02-15 13:47:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-15 22:00:11'),(24316,19311,'Y','18','021','EC','A','','','AC','0000816886','0000816886','TX00002709751','IL','1','LUGO','YOLANDA','','','','34','466945691','6707 LAIR RD',0,'AMARILLO','TX','79118','3016','CY','48381','1950-02-04','F','M',NULL,'N','021','DEN','2671817','33348TX002000201','2014-04-01','2014-02-18 09:46:22','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-18 22:00:05'),(6290,4988,'N','01','021','EC','A',NULL,NULL,'','0000735012','0000071611','','IL','1','mujalli','wasfia','','','','34','092729486','3076 WATERFALL WAY',0,'WESTLAKE','OH','44145','6811','CY','39035','1987-07-12','F','',':RET:2106-3','N','021','DEN','903961','99734OH005000401','2014-01-01','2013-12-11 00:03:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:45:37'),(5770,4583,'N','01','021','EC','A',NULL,NULL,'','0000645975','0001149870','','IL','1','Eck','Jennifer','','','','34','295866888','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1985-01-18','F','',':RET:2106-3','N','021','DEN','1813473','99734OH005000401','2014-01-01','2013-12-23 22:34:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:46:46'),(19634,15648,'Y','18','021','EC','A','','','AC','0001053086','0001053086','OH00001510543','IL','1','Thiel','John','Marcus','','','34','273647520','15063 State Route 53',0,'Upper Sandusky','OH','43351',NULL,'CY','39175','1961-12-09','M','U',':RET:2106-3','N','021','DEN','1937216','99734OH005000401','2014-03-01','2014-01-23 13:13:32','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-23 21:00:10'),(5668,4497,'Y','18','021','EC','A','','','AC','0000743047','0000743047','OH00001178258','IL','1','lockett','lynda','l','','','34','288508627','1267 CLIFFSIDE ST',0,'CUYAHOGA FALLS','OH','44221','5103','CY','39153','1951-07-21','F','U',':RET:2054-5','N','021','HLT','417031','52664OH151001304','2014-01-01','2013-11-26 13:55:37','447.00',NULL,NULL,'640.70','193.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 23:31:58'),(15650,12520,'Y','18','021','EC','A','','','AC','0000813772','0000813772','MS00000110498','IL','1','PEMAREST','JUDY','','','','34','438760627','122 OXFORD PL',0,'WAVELAND','MS','39576','6004','CY','28045','1950-07-11','F','U',':RET:2106-3','N','021','DEN','1758241','46300MS002000201','2014-02-01','2013-12-31 14:14:22','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,1,'2014-01-02 04:34:04'),(15602,12483,'Y','18','021','EC','A','','','AC','0000066261','0000066261','OH00000110502','IL','1','Mecklenborg','Jill','','','','34','280702833','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','1975-08-17','F','M',':RET:2106-3','N','021','DEN','1692472','99734OH005000301','2014-02-01','2013-12-31 15:23:07','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:32:39'),(859,711,'Y','18','021','EC','A','','','AC','0001252100','0001252100','OH00000630387','IL','1','NEU','WAYNE','A','','','34','294424546','909 LORETTA PL',0,'LIMA','OH','45805','1639','CY','39003','1951-03-27','M','U',':RET:2106-3','N','021','HLT','2027858','92036OH005001501','2014-01-01','2013-12-16 15:02:32','342.00',NULL,NULL,'632.30','290.30','R-OH002','OH0','632.30',NULL,0,'2013-12-25 18:07:06'),(2363,1927,'Y','18','024','14','A','','','TE','0000029011','0000029011','','IL','1','Yurcik','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-15','M','',NULL,NULL,NULL,'','958395','','2013-12-09','2013-12-09 07:31:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:32:33'),(4768,3782,'N','01','021','EC','A',NULL,NULL,'','0000151947','0000912932','','IL','1','HILL','SAMANTHA','M','','','34','276806191','907 JEFFERSON CHASE WAY',0,'BLACKLICK','OH','43004',NULL,'CY','39049','1968-02-19','F','',NULL,'N','021','DEN','741985','99734OH005000401','2014-01-01','2013-12-08 11:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:15:45'),(24693,19602,'Y','18','021','EC','A','','','AC','0001064763','0001064763','OH00002808958','IL','1','george','joe','','','','34','302529474','4456 matson ave',0,'cinn','OH','45236',NULL,'CY','39061','1952-09-16','M','U',':RET:2106-3','N','021','DEN','3172968','99734OH005000401','2014-04-01','2014-02-18 21:38:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:32:55'),(25153,19953,'Y','18','024','14','A','','','TE','0000823163','0000823163','','IL','1','PAHLAVAN','ABBAS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-01','M','',NULL,NULL,NULL,'','2673931','','2014-02-21','2014-02-21 14:05:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-21 22:00:18'),(28071,22215,'Y','18','021','EC','A','','','AC','0000512013','0000512013','OH00002724982','IL','1','Roach','Beverly','','','','34','280547368','5422 FENLAKE RD',0,'BEDFORD','OH','44146','1643','CY','39035','1955-04-29','F','U',NULL,'N','021','DEN','2674778','99734OH005000301','2014-04-01','2014-03-06 13:52:46','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:50'),(710,587,'Y','18','024','14','A','','','TE','0000994365','0000994365','','IL','1','Lege','Jonathan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-07-18','M','',NULL,NULL,NULL,'','606505','','2013-12-15','2013-12-15 23:54:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:03:10'),(1465,1221,'Y','18','021','EC','A','','','AC','0000013781','0000013781','OH00000804448','IL','1','Carbonell','Raymond','Hector','','','34','269724402','32891 LAKE RD',0,'AVON LAKE','OH','44012','1564','CY','39093','1974-01-21','M','U',':RET:2106-3','N','021','DEN','2542340','99734OH005000401','2014-01-01','2013-12-24 09:00:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:48:25'),(22000,17567,'N','01','021','EC','A',NULL,NULL,'','0001743846','0001326509','','IL','1','CHUNG','ERIC','','','','34','660092328','16 GLACIER ST',0,'KENNER','LA','70065','1007','CY','22051','1961-06-08','M','',':RET:2028-9','N','021','DEN','3180891','18575LA002000201','2014-03-01','2014-02-07 16:25:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:47'),(5202,4128,'Y','18','021','EC','A','','','AC','0000474955','0000474955','OH00000401973','IL','1','Randall','Linda','','','','34','048448215','8872 RIVER CORNERS RD',0,'HOMERVILLE','OH','44235','9719','CY','39103','1950-03-23','F','U',':RET:2054-5','N','021','DEN','2401133','99734OH005000401','2014-01-01','2013-12-19 14:30:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:04:03'),(2303,1874,'N','01','021','EC','A',NULL,NULL,'','0000347882','0000873220','','IL','1','Kafcsak','Catherine','Marie','','','34','292526323','10181 DEER RUN',0,'BRECKSVILLE','OH','44141','3637','CY','39035','1957-06-12','F','',':RET:2106-3','N','021','DEN','633201','99734OH005000301','2014-01-01','2013-12-09 17:08:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:02'),(20948,16739,'N','01','021','EC','A',NULL,NULL,'','0000737896','0000388674','','IL','1','MARTIN','BRANDON','','','','34','298804861','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','1983-03-11','M','',NULL,'N','021','HLT','3625394','92036OH003002705','2014-03-01','2014-01-31 16:57:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.13',NULL,0,'2014-01-31 21:01:46'),(19660,15665,'Y','18','024','14','A','','','TE','0000415946','0000415946','','IL','1','SCHULER','Carol','s',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-27','F','',NULL,NULL,NULL,'','1094262','','2014-01-23','2014-01-23 15:33:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:00:24'),(14428,11506,'Y','18','021','EC','A','','','AC','0001791246','0001791246','LA00000315450','IL','1','Pardee','Debra','','','','34','439332536','5131 HIGHWAY 9',0,'SALINE','LA','71070','2753','CY','22069','1962-12-05','F','U',':RET:2106-3','N','021','DEN','2591660','18575LA002000201','2014-02-01','2013-12-26 18:32:19','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-28 03:31:51'),(17397,13921,'Y','18','021','EC','A','','','AC','0001196829','0001196829','OH00002024905','IL','1','TORREY','TYLER',NULL,NULL,NULL,NULL,NULL,'5727 TULLY HARRISON ROAD',0,'CONVOY','OH','45832',NULL,'CY','39161','1992-07-24','M','U',NULL,'N','021','HLT','2404467','92036OH006001501','2014-02-01','2014-01-09 20:29:09','162.00',NULL,NULL,'174.54','12.54','R-OH002','OH0','174.54',NULL,0,'2014-01-13 03:00:14'),(26222,20797,'Y','18','021','EC','A','','','AC','0000804617','0000804617','TX00002932485','31','1','yedra hernandez','angelica','','','','34','642586837','po box 1321',0,'weslaco','TX','78599',NULL,'CY','48215','1978-11-03','F','M',NULL,'N','021','DEN','3052755','33348TX002000201','2014-04-01','2014-02-26 20:08:49','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-28 06:30:58'),(26351,20905,'Y','18','021','EC','A','','','AC','0000132119','0000132119','OH00002860451','IL','1','Scott','Barbara','','','','34','269666074','26961 SCHADY RD',0,'OLMSTED FALLS','OH','44138','1709','CY','39035','1960-04-06','F','M',':RET:2106-3','T','021','HLT','2773072','92036OH002000801','2014-05-01','2014-02-27 14:27:50','100.00',NULL,NULL,'834.37','734.37','R-OH011','OH0','662.91',NULL,0,'2014-02-28 06:31:47'),(15521,12417,'N','01','021','EC','A',NULL,NULL,'','0002034153','0001793417','','IL','1','Nhan','Hoa','','','','34','641220055','9801 HEARTHSIDE CIR',0,'SHREVEPORT','LA','71118','4830','CY','22017','1967-08-16','F','',NULL,'N','021','DEN','2364926','18575LA002000201','2014-02-01','2013-12-30 19:44:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:30:19'),(22505,17965,'N','01','021','EC','A',NULL,NULL,'','0001198145','0000514491','','IL','1','Morlan','Lana','','','','34','296501320','1261 CARNEGIE AVE',0,'AKRON','OH','44314','1151','CY','39153','1949-04-15','F','',NULL,'T','021','DEN','2971905','99734OH005000301','2014-03-01','2014-02-10 16:44:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:15'),(16838,13469,'Y','18','021','EC','A','','','AC','0000442202','0000442202','OH00002026027','IL','1','Hilinski','Claudia','','','','34','298604320','1064 Clyde Avenue',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1965-01-11','F','U',NULL,'N','021','HLT','1926880','52664OH151001304','2014-02-01','2014-01-11 08:07:41','172.00',NULL,NULL,'380.45','208.45','R-OH012','OH0','380.45',NULL,0,'2014-01-13 02:18:32'),(18589,14821,'Y','18','021','EC','A','','','AC','0000321059','0000321059','OH00002443820','IL','1','Kimbrell','James','','','','34','309985010','1400 HICKORY CT',0,'NEW RICHMOND','OH','45157','8607','CY','39025','1980-04-05','M','R',':RET:2106-3','N','021','HLT','2318575','92036OH002000601','2014-02-01','2014-01-15 11:25:47','0.00',NULL,NULL,'296.98','296.98','R-OH005','OH0','296.98',NULL,0,'2014-01-16 08:47:13'),(25749,20422,'Y','18','021','EC','A','','','AC','0000388690','0000388690','OH00002322115','IL','1','LOJEWSKI','MICHAEL','','','','34','291486302','746 PROUTY AVE',0,'TOLEDO','OH','43609','3332','CY','39095','1949-09-24','M','U',':RET:2106-3','N','021','DEN','3615868','99734OH005000401','2014-04-01','2014-02-24 15:44:44','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-26 09:30:44'),(25895,20532,'Y','18','021','EC','A','','','AC','0000305503','0000305503','TX00003171725','IL','1','Wimberley','Sean','Morgan','','','34','437630807','1481 CHELSEAS CIR',0,'ORANGE','TX','77632','5303','CY','48361','1983-02-15','M','M',NULL,'N','021','DEN','3032092','33348TX002000201','2014-04-01','2014-02-26 12:27:08','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-02-26 21:01:05'),(27898,22071,'Y','18','021','EC','A','','','AC','0000187537','0000187537','OH00002628814','IL','1','Weissenberger','John','J','','','34','300821467','1003 KIPLING DR',0,'TOLEDO','OH','43612','2375','CY','39095','1969-06-10','M','U',':RET:2106-3','T','021','HLT','3495011','92036OH006002601','2014-04-01','2014-03-05 16:07:09','0.00',NULL,NULL,'248.45','248.45','R-OH001','OH0','248.45',NULL,0,'2014-03-05 21:32:44'),(28758,22762,'Y','18','021','EC','A','','','AC','0000050810','0000050810','TX00003641322','IL','1','dixon','emilie','','','','34','612641665','1704 COTTONWOOD ST',0,'BRYAN','TX','77803','3626','CY','48041','1991-12-27','F','U',':RET:2106-3','N','021','DEN','3695058','33348TX002000201','2014-04-01','2014-03-09 12:16:49','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-03-09 21:00:20'),(7962,6302,'Y','18','021','EC','A','','','AC','0000727626','0000727626','MS00001182509','IL','1','Clincy','Andrea','','','','34','426638496','6100 MIDWAY RD',0,'RAYMOND','MS','39154','8357','CY','28049','1972-12-20','F','U',':RET:2054-5','N','021','DEN','1358203','46300MS002000201','2014-01-01','2013-12-20 08:11:11','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:27'),(9126,7237,'N','01','021','EC','A',NULL,NULL,'','0000816399','0000678126','','IL','1','ANDERSON','diania','','','','34','413130355','70 PIN OAK DR',0,'BYHALIA','MS','38611','8295','CY','28093','1956-03-23','F','',':RET:2106-3','N','021','DEN','1557504','46300MS002000101','2014-01-01','2013-12-17 19:26:00',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-26 04:07:51'),(19167,15270,'Y','18','024','14','A','','','TE','0000878857','0000878857','','IL','1','Hertel','Rhonda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-05-18','F','',NULL,NULL,NULL,'','1154145','','2014-01-20','2014-01-20 11:19:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:46:01'),(18721,14922,'N','19','021','EC','A',NULL,NULL,'','0000084072','0000581515','','S1','1','Johnson','Kevin',NULL,NULL,NULL,NULL,NULL,'1381 PEBBLE CT',0,'CINCINNATI','OH','45255',NULL,'CY','39061','2002-12-27','F','',NULL,'N','021','DEN','2779642','99734OH005000301','2014-02-01','2014-01-15 23:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:34'),(7097,5629,'Y','18','021','EC','A','','','AC','0000770000','0000770000','OH00001485042','IL','1','Wright','Matt','','','','34','284842286','98 Cummings',0,'Geneva','OH','44041',NULL,'CY','39007','1970-05-04','M','R',':RET:2106-3','N','021','HLT','2053202','52664OH151001301','2014-01-01','2013-12-24 23:31:56','0.00',NULL,NULL,'341.31','341.31','R-OH011','OH0','341.31',NULL,0,'2013-12-26 01:50:40'),(18406,14685,'N','01','021','EC','A',NULL,NULL,'','0000963257','0000893175','','IL','1','packo','deborrah','k','','','34','290541204','100 S BAYSHORE DR',0,'COLUMBIANA','OH','44408','9312','CY','39099','1953-05-29','F','',':RET:2106-3','N','021','DEN','2956132','99734OH005000301','2014-02-01','2014-01-15 18:02:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:45'),(17068,13659,'Y','18','021','EC','A','','','AC','0001138430','0001138430','TX00001927008','IL','1','Eatmon','Javonne','Deshye','','','34','642182014','1526 Reynoldston',0,'Dallas','TX','75232',NULL,'CY','48113','1981-06-02','F','M',':RET:2054-5','N','021','DEN','1920115','33348TX002000201','2014-02-01','2014-01-07 21:57:57','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:15'),(1892,1547,'N','01','021','EC','A',NULL,NULL,'','0001144773','0000615516','','IL','1','Walley','Adam','','','','34','404292414','729 FRANCIS RD',0,'FELICITY','OH','45120','9152','CY','39015','1986-07-16','M','',':RET:2106-3','N','021','HLT','1361199','92036OH004000601','2014-01-01','2013-12-24 12:15:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','180.89',NULL,0,'2013-12-25 18:58:52'),(5397,4284,'Y','18','021','EC','A','','','AC','0002206826','0002206826','LA00000440148','IL','1','White','Dexter','','','','34','439048644','620 E MISSISSIPPI AVE',0,'RUSTON','LA','71270','4058','CY','22061','1959-05-29','M','U',':RET:2054-5','N','021','DEN','1393675','18575LA002000201','2014-01-01','2013-12-19 18:21:45','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 23:08:50'),(13553,10808,'Y','18','024','14','A','','','TE','0001571159','0001571159','','IL','1','Napoli','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-14','F','',NULL,NULL,NULL,'','2005429','','2013-12-23','2013-12-23 15:10:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:04:09'),(2167,1783,'Y','18','021','EC','A','','','AC','0000743060','0000743060','OH00000700930','IL','1','Shrock','Bradley','','','','34','268509486','342 LONG POINTE DR',0,'AVON LAKE','OH','44012','2424','CY','39093','1958-06-04','M','M',':RET:2106-3','N','021','HLT','425913','52664OH151001501','2014-01-01','2013-12-10 16:43:04','783.00',NULL,NULL,'1376.48','593.48','R-OH011','OH0','672.70',NULL,0,'2013-12-25 19:19:04'),(25571,20286,'Y','18','021','EC','A','','','AC','0001109277','0001109277','OH00002830432','IL','1','Dickerson','James','','','','34','268828662','4837 Overland Parkway',0,'Toledo','OH','43612',NULL,'CY','39095','1984-01-08','M','M',NULL,'N','021','HLT','3786329','92036OH003002606','2014-04-01','2014-02-23 14:00:11','356.00',NULL,NULL,'434.76','78.76','R-OH001','OH0','231.13',NULL,0,'2014-02-26 08:00:30'),(28893,22868,'N','01','021','EC','A',NULL,NULL,'','0000242590','0001053723','','IL','1','SANDERS','MARION','','','Sr','34','178446255','5613 SILTSTONE LOOP',0,'KILLEEN','TX','76542','5763','CY','48027','1954-01-29','M','',':RET:2054-5','N','021','DEN','3471314','33348TX002000201','2014-04-01','2014-03-10 15:18:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-10 21:00:16'),(1888,1544,'Y','18','021','EC','A','','','AC','0000071648','0000071648','OH00000887403','IL','1','Johnson','Brenda','','','','34','289589516','2177 OLD STATE ROUTE 32',0,'BATAVIA','OH','45103','1944','CY','39025','1951-02-12','F','M',':RET:2106-3','T','021','HLT','1667748','92036OH006000601','2014-01-01','2013-12-24 17:18:45','277.00',NULL,NULL,'562.48','285.48','R-OH005','OH0','562.48',NULL,0,'2013-12-25 18:58:45'),(22073,17618,'N','01','021','EC','A',NULL,NULL,'','0001253225','0001229681','','IL','1','OLVERA','MARIA','','','','34','639807211','702 E BURLESON ST',0,'MARSHALL','TX','75670','3510','CY','48203','1955-03-06','F','',NULL,'N','021','DEN','3031677','33348TX002000201','2014-03-01','2014-02-08 16:37:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-08 19:00:15'),(21981,17554,'Y','18','021','EC','A','','','AC','0002328529','0002328529','LA00001679561','IL','1','McCarthy','Wayne','','','','34','436435466','7211 ANNE ST',0,'ARABI','LA','70032','1603','CY','22087','1980-07-09','M','U',':RET:2106-3','N','021','DEN','3795727','18575LA002000101','2014-03-01','2014-02-07 17:07:29','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-07 19:00:37'),(21656,17295,'Y','18','021','EC','A','','','AC','0001571188','0001571188','LA00002191319','IL','1','Loupe','Johanna','','','','34','433559216','3151 W. Hidden Gates Dr.',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1983-05-20','F','M',':RET:2106-3','N','021','DEN','3054670','18575LA002000201','2014-03-01','2014-02-05 11:07:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-05 21:30:52'),(20747,16577,'Y','18','021','EC','A','','','AC','0000459191','0000459191','OH00002278148','IL','1','Reichert','Deborah','','','','34','289565472','335 CHESTERFIELD LN',0,'MAUMEE','OH','43537','3817','CY','39095','1954-01-30','F','U',':RET:2106-3','N','021','HLT','1477346','92036OH006002601','2014-03-01','2014-01-30 16:07:42','365.00',NULL,NULL,'419.70','54.70','R-OH001','OH0','419.70',NULL,0,'2014-01-30 21:01:27'),(2295,1870,'N','19','021','EC','A',NULL,NULL,'','0001139484','0000289499','','IL','1','Thompson','Isabella','','','','34','300157105','2820 GRANDIN HOLLOW LN',0,'CINCINNATI','OH','45208','3315','CY','39061','2010-08-07','F','',':RET:2106-3','N','021','DEN','6540','99734OH005000301','2014-01-01','2013-12-09 16:04:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:53'),(19402,15469,'Y','18','024','14','A','','','TE','0000575899','0000575899','','IL','1','Chahal','Bhalinder','Singh',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-28','M','',NULL,NULL,NULL,'','29264','','2014-01-21','2014-01-21 15:03:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:53'),(18318,14625,'Y','18','021','EC','A','','','AC','0000614128','0000614128','OH00001819098','IL','1','ROBERTSON','DEBORA','','','','34','283589571','94 PARKWOOD AVE',0,'ZANESVILLE','OH','43701','6145','CY','39119','1957-03-14','F','U',':RET:2106-3','N','021','DEN','2816203','99734OH005000401','2014-02-01','2014-01-15 14:47:28','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-16 08:45:06'),(1199,988,'Y','18','021','EC','A','','','AC','0000500368','0000500368','OH00001050893','31','1','Bodi','Amanda','','','','34','300906228','PO Box 313',0,'Castalia','OH','44824',NULL,'CY','39043','1987-11-13','F','M',':RET:2106-3','N','021','DEN','639302','99734OH005000301','2014-01-01','2013-12-03 01:36:21','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 18:19:50'),(24565,19509,'N','19','021','EC','A',NULL,NULL,'','0000737910','0000783293','','IL','1','grubb','nicholas','','','','34','272134541','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','2006-11-13','M','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:06:49'),(24446,19418,'Y','18','021','EC','A','','','AC','0000382211','0000382211','OH00002082275','IL','1','Elliott','Sheila','','','','34','281526449','2279 Berrywood Drive',0,'Cincinnati','OH','45244',NULL,'CY','39061','1952-05-13','F','U',NULL,'N','021','HLT','2871987','92036OH006001201','2014-04-01','2014-02-18 15:54:42','428.00',NULL,NULL,'478.41','50.41','R-OH004','OH0','478.41',NULL,0,'2014-02-18 22:01:23'),(1859,1521,'N','19','021','EC','A',NULL,NULL,'','0000205787','0000964624','','S3','1','Biggs','Robert','Wayne','','','34','290045778','148 MORRISON AVE',0,'CUYAHOGA FALLS','OH','44221','2127','CY','39153','1999-12-07','M','',':RET:2106-3','N','021','HLT','1628559','52664OH152000901','2014-01-01','2013-12-24 10:41:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 18:58:07'),(22774,18182,'Y','18','021','EC','A','','','AC','0000007021','0000007021','OH00002512984','IL','1','LEWIS','LORENE','','','','34','282586296','4404 RANDALL DR',0,'LIBERTY TWP','OH','45011','2392','CY','39017','1956-01-14','F','U',':RET:2106-3','N','021','DEN','3311434','99734OH005000401','2014-03-01','2014-02-11 13:07:03','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:39'),(21695,17323,'Y','18','021','EC','A','','','AC','0000298269','0000298269','OH00002256926','IL','1','Vang','Vaj','','','','34','299966251','237 PARA AVE',0,'AKRON','OH','44305','4141','CY','39153','1951-02-20','M','M',NULL,'N','021','HLT','2891876','52664OH152000901','2014-03-01','2014-02-04 20:30:46','448.00',NULL,NULL,'482.18','34.18','R-OH012','OH0','482.18',NULL,0,'2014-02-05 21:31:08'),(19463,15514,'Y','18','021','EC','A','','','AC','0000153046','0000153046','TX00001710666','IL','1','HUANG','GUO KANG','','','','34','113965634','3801 49TH ST',0,'LUBBOCK','TX','79413','3717','CY','48303','1985-10-10','M','M',':RET:2034-7^:RET:2028-9','N','021','DEN','1928678','33348TX002000201','2014-03-01','2014-01-22 10:22:08','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-01-23 03:01:57'),(18005,14388,'Y','18','021','EC','A','','','AC','0001025514','0001025514','OH00001989998','S3','1','Holt','Haley','Miller','','','34','646028839','5615 WATER MILLS DR',0,'MILFORD','OH','45150','1598','CY','39025','2008-04-05','F','U',':RET:2106-3','N','021','DEN','2024043','99734OH005000301','2014-02-01','2014-01-14 09:12:40','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','21.13',NULL,0,'2014-01-15 02:07:01'),(1985,1624,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000047470','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','604412','33348TX002000101','2014-01-01','2013-11-19 23:04:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:48'),(2843,2298,'Y','18','021','EC','A','','','AC','0000132034','0000132034','OH00000032146','IL','1','WOLFORD','KENNY','','','','34','304663855','9269 WORTH RD',0,'UNION CITY','OH','45390','8609','CY','39037','1956-10-01','M','M',':RET:2106-3','N','021','DEN','961987','99734OH005000401','2014-01-01','2013-11-24 16:44:52','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:01:07'),(6609,5240,'N','01','021','EC','A',NULL,NULL,'','0000380027','0000970440','','IL','1','Clark','Donna','R','','','34','270685552','9217 PITSBURG LAURA RD',0,'ARCANUM','OH','45304','9627','CY','39037','1967-03-09','F','',':RET:2106-3','N','021','HLT','677107','92036OH003000501','2014-01-01','2013-12-11 10:33:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','372.35',NULL,0,'2013-12-26 00:53:42'),(26012,20631,'Y','18','021','EC','A','','','AC','0000016669','0000016669','OH00002117499','IL','1','MILLER','JENNIFER','','','','34','284804462','833 ALLINGHAM ST',0,'VAN WERT','OH','45891','1005','CY','39161','1972-06-04','F','M',':RET:2106-3','N','021','HLT','3762075','92036OH003001506','2014-03-01','2014-02-26 12:33:03','538.99',NULL,NULL,'591.15','52.16','R-OH002','OH0','299.25',NULL,0,'2014-02-26 21:02:11'),(555,455,'Y','18','021','EC','A','','','AC','0000489321','0000489321','LA00000517284','IL','1','Crowder','Justin','','','','34','254615790','2700 Ernest Street',0,'Lake Charles','LA','70601',NULL,'CY','22019','1987-10-08','M','U',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','1082398','18575LA002000101','2014-01-01','2013-12-03 23:49:46','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2013-12-25 17:50:09'),(1236,1019,'Y','18','021','EC','A','','','AC','0000805935','0000805935','LA00000427257','IL','1','Allen','Shalanda','','','','34','439275515','32455 Leona Ave',0,'White Castle','LA','70788',NULL,'CY','22047','1970-12-13','F','M',':RET:2054-5','N','021','DEN','532233','18575LA002000101','2014-01-01','2013-12-03 16:20:22','0.00',NULL,NULL,'119.61','119.61','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:20:51'),(1760,1454,'N','17','021','EC','A',NULL,NULL,'','0001260013','0001104442','','S3','1','Bepler','Jamie','Lyn','','','34','290980077','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','1996-01-14','M','',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:53'),(21520,17193,'N','01','021','EC','A',NULL,NULL,'','0000784935','0000023680','','IL','1','Ingram','Charles','Douglas','','','34','587742411','734 MEADOWBROOK RD',0,'GRENADA','MS','38901','9788','CY','28043','1953-09-19','M','',':RET:2106-3','N','021','DEN','3202671','46300MS002000101','2014-03-01','2014-02-05 15:31:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15','CIC',0,'2014-02-05 21:00:06'),(21060,16827,'Y','18','021','EC','A','','','AC','0002151063','0002151063','LA00001906791','31','1','taylor','lashanti','','','','34','439596985','p o box 1402',0,'slidell','LA','70459',NULL,'CY','22103','1978-09-09','F','U',NULL,'N','021','DEN','3153684','18575LA002000201','2014-03-01','2014-02-02 15:19:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-02 19:00:11'),(20337,16240,'Y','18','024','14','A','','','TE','0001418489','0001418489','','IL','1','Johnson','Ricka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-14','F','',NULL,NULL,NULL,'','2839767','','2014-01-28','2014-01-28 14:59:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-28 21:01:05'),(2992,2407,'N','01','021','EC','A',NULL,NULL,'','0001235146','0000015235','','IL','1','Park','Sung Hwa','','','','34','296080671','8655 GOLD LEAF LN',0,'DUBLIN','OH','43016','8444','CY','39049','1953-07-22','M','',':RET:2040-4','T','021','DEN','908788','99734OH005000301','2014-01-01','2013-12-06 14:57:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:28'),(7896,6242,'N','01','021','EC','A',NULL,NULL,'','0000689688','0000106707','','IL','1','McGuire','Thomas','','','','34','557410361','1004 LONES DR',0,'PERRYSBURG','OH','43551','2332','CY','39173','1960-05-08','M','',':RET:2106-3','N','021','HLT','1836189','92036OH005002601','2014-01-01','2013-12-20 15:11:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','397.79',NULL,0,'2013-12-26 03:05:41'),(5338,4234,'Y','18','021','EC','A','','','AC','0000227044','0000227044','OH00000334604','IL','1','Oliver','Tenola','C','','','34','296605213','23 S WILLIAMS ST',0,'DAYTON','OH','45402','8236','CY','39113','1975-06-19','F','M',NULL,'N','021','DEN','1656286','99734OH005000301','2014-01-01','2013-12-19 15:07:55','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:07:16'),(14758,11783,'Y','18','021','EC','A','','','AC','0000336465','0000336465','TX00000971437','IL','1','Contreras','Jose','osbaldo','','','34','639261757','1345 RANCHERO CT',0,'SAN ELIZARIO','TX','79849','7535','CY','48141','1991-08-06','M','M',':RET:2106-3','N','021','DEN','2101458','33348TX002000201','2014-01-01','2013-12-23 20:13:39','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2013-12-29 11:12:35'),(26938,21349,'Y','18','021','EC','A','','','AC','0000254596','0000254596','OH00003302707','IL','1','Stearns','Kaci','','','','34','021746094','14567 Madison Ave',0,'Lakewood','OH','44107',NULL,'CY','39035','1989-04-25','F','U',NULL,'N','021','DEN','2902625','99734OH005000301','2014-04-01','2014-03-02 14:46:39','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-03 01:00:22'),(8021,6350,'Y','18','021','EC','A','','','AC','0000146874','0000146874','OH00001199409','IL','1','CONLY','SARAH','L','','','34','282503658','6566  RIPPLEWOOD  LANE',0,'CINCINATI','OH','45230',NULL,'CY','39061','1952-10-18','F','M',':RET:2106-3','N','021','HLT','1378176','92036OH006001201','2014-01-01','2013-12-19 21:00:49','0.00',NULL,NULL,'478.41','478.41','R-OH004','OH0','478.41',NULL,0,'2013-12-26 03:08:55'),(3687,2951,'N','01','021','EC','A',NULL,NULL,'','0001219572','0000149329','','IL','1','Robbins','Anne','','','','34','272583067','4777 COTTON RUN RD',0,'HAMILTON','OH','45011','9656','CY','39017','1955-01-22','F','',':RET:2106-3','N','021','DEN','493587','99734OH005000401','2014-01-01','2013-12-13 10:17:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:31:37'),(6277,4977,'Y','18','021','EC','A','','','AC','0000918240','0000918240','OH00001295713','IL','1','Hanna','Christopher','','','','34','284823388','1187 CARNEGIE AVE',0,'AKRON','OH','44314','1149','CY','39153','1974-12-30','M','U',':RET:2106-3','N','021','DEN','1057238','99734OH005000401','2014-01-01','2013-12-10 19:20:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:45:16'),(24651,19568,'Y','18','021','EC','A','','','AC','0000616924','0000616924','OH00001622462','IL','1','friend','shelli','','','','34','294608233','1803 KINGSBURY DR',0,'SAINT MARYS','OH','45885','1345','CY','39011','1961-07-15','F','U',':RET:2106-3','T','021','HLT','3620764','92036OH005001504','2014-04-01','2014-02-18 18:55:24','263.00',NULL,NULL,'494.04','231.04','R-OH002','OH0','494.04',NULL,0,'2014-02-20 04:23:00'),(5989,4741,'Y','18','021','EC','A','','','AC','0000060243','0000060243','OH00001296408','IL','1','SELKA','STEVEN','ALAN','','','34','287528520','11 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1953-08-02','M','U',':RET:2106-3','N','021','HLT','1877823','92036OH006002701','2014-01-01','2013-12-24 01:36:01','405.00',NULL,NULL,'419.70','14.70','R-OH006','OH0','419.70',NULL,0,'2013-12-25 23:52:09'),(23844,18972,'Y','18','021','EC','A','','','AC','0001181069','0001181069','OH00002820512','IL','1','Brown','Todd','','','','34','296904062','30 STOUTENBURG DR',0,'NORWALK','OH','44857','2324','CY','39077','1987-02-03','M','U',':RET:2106-3','T','021','HLT','3268017','92036OH003002705','2014-03-01','2014-02-14 16:59:01','152.00',NULL,NULL,'245.41','93.41','R-OH006','OH0','245.41',NULL,0,'2014-02-14 21:31:54'),(23719,18885,'Y','18','021','EC','A','','','AC','0001245638','0001245638','OH00002002055','IL','1','Anderson','Uriah','','','','34','474023862','330 MORTON AVE',0,'DAYTON','OH','45410','1304','CY','39113','1982-05-12','M','R',':RET:2106-3','N','021','DEN','2862139','99734OH005000401','2014-03-01','2014-02-14 17:41:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:30:51'),(23138,18444,'Y','18','021','EC','A','','','AC','0000705197','0000705197','OH00002205007','IL','1','HARKLEROAD','MARGUERITE','','','','34','291529171','2526 REDGATE LN',0,'YOUNGSTOWN','OH','44511','1926','CY','39099','1952-07-13','F','U',':RET:2106-3','T','021','HLT','3816662','52664OH151001306','2014-03-01','2014-02-12 11:36:10','571.00',NULL,NULL,'817.23','246.23','R-OH013','OH0','817.23',NULL,0,'2014-02-12 21:31:34'),(23062,18386,'Y','18','021','EC','A','','','AC','0002056816','0002056816','LA00001638172','IL','1','JOHNSON','LILYOLANDA','','','','34','439538306','2172 68TH AVE',0,'BATON ROUGE','LA','70807','6301','CY','22033','1977-06-26','F','U',':RET:2054-5','N','021','DEN','3486959','18575LA002000201','2014-03-01','2014-02-12 13:19:30','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:51'),(21908,17496,'Y','18','021','EC','A','','','AC','0000309486','0000309486','OH00001590447','IL','1','Garcia','Alicia','','','','34','581279013','6815 Madison Ave',0,'Cleveland','OH','44102',NULL,'CY','39035','1963-11-17','F','R',NULL,'N','021','HLT','3449319','92036OH005000801','2014-03-01','2014-02-06 14:15:13','0.00',NULL,NULL,'417.55','417.55','R-OH011','OH0','417.55',NULL,0,'2014-02-06 21:01:51'),(16263,13021,'Y','18','021','EC','A','','','AC','0000672776','0000672776','OH00001519033','IL','1','Caddell','Douglas','','','','34','281606908','925 BEISSINGER RD',0,'HAMILTON','OH','45013','9322','CY','39017','1962-03-16','M','U',NULL,'N','021','DEN','1848124','99734OH005000401','2014-02-01','2014-01-06 12:01:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:03'),(21210,16949,'Y','18','021','EC','A','','','AC','0001364942','0001364942','LA00002137728','IL','1','Maine','Lavelle','','','','34','434869548','507 RUSTON ST',0,'FARMERVILLE','LA','71241','3333','CY','22111','1951-06-17','M','U',':RET:2054-5','T','021','DEN','2869083','18575LA002000201','2014-03-01','2014-02-03 11:45:59','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-03 21:00:58'),(19777,15766,'Y','18','021','EC','A','','','AC','0000551447','0000551447','OH00001492460','IL','1','Slack','Michael','','','','34','282840956','20860 DUNBRIDGE RD',0,'BOWLING GREEN','OH','43402','9653','CY','39173','1973-06-22','M','M',':RET:2106-3','N','021','HLT','3265302','92036OH006002601','2014-03-01','2014-01-23 11:42:46','25.00',NULL,NULL,'197.64','172.64','R-OH001','OH0','197.64',NULL,0,'2014-01-23 21:01:32'),(19278,15365,'N','01','021','EC','A',NULL,NULL,'','0001158954','0000460605','','IL','1','Crutcher','Cheri','Dee','','','34','287681424','1816 WHEATFIELD WAY',0,'LOVELAND','OH','45140','8538','CY','39025','1960-10-03','F','',':RET:2106-3','T','021','HLT','1830652','92036OH004000601','2014-03-01','2014-01-20 13:47:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','404.95',NULL,0,'2014-01-21 08:46:58'),(18987,15127,'Y','18','021','EC','A','','','AC','0000551443','0000551443','OH00001847521','IL','1','Bernstein','Shari','','','','34','286506337','2175 CAMPUS RD',0,'BEACHWOOD','OH','44122','1216','CY','39035','1964-08-30','F','M',':RET:2106-3','N','021','HLT','2281072','52664OH151001304','2014-03-01','2014-01-17 11:24:07','750.00',NULL,NULL,'1491.00','741.00','R-OH011','OH0','429.09',NULL,0,'2014-01-20 08:06:10'),(18350,14649,'N','19','021','EC','A',NULL,NULL,'','0000393694','0000938545','','IL','1','miller','anna','isabella','','','34','275135382','31600 north marginal rd',0,'willowick','OH','44095',NULL,'CY','39085','2007-02-06','F','',':RET:2106-3','N','021','DEN','1560829','99734OH005000301','2014-02-01','2014-01-14 19:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:21'),(26192,20771,'Y','18','021','EC','A','','','AC','0000017684','0000017684','OH00003429314','IL','1','MONTER','THEODORE','','','','34','298461100','4145 CHESTER AVE',0,'LOUISVILLE','OH','44641',NULL,'CY','39151','1950-05-31','M','U',':RET:2106-3','N','021','DEN','3786459','99734OH005000301','2014-04-01','2014-02-27 13:00:04','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-28 06:30:45'),(27560,21800,'Y','18','024','14','A','','','TE','0000195113','0000195113','','IL','1','Spencer','Linda','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-29','F','',NULL,NULL,NULL,'','1231216','','2014-03-31','2014-03-04 11:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-04 21:30:16'),(29137,23066,'N','19','021','EC','A',NULL,NULL,'','0000754634','0000341410','','IL','1','Nisch Quan','Kamlin','','','','34','277066509','4243 E THE VALLEY RD',0,'PORT CLINTON','OH','43452','9762','CY','39123','2001-03-06','F','',':RET:2029-7^:RET:2034-7^:RET:2106-3','N','021','HLT','4316538','92036OH003002705','2014-04-01','2014-03-10 17:13:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-10 21:02:40'),(1401,1163,'Y','18','021','EC','A','','','AC','0002224528','0002224528','LA00000807056','IL','1','ROSS','HAROLD','','','','34','310621136','5445 PROVINE PL',0,'ALEXANDRIA','LA','71303',NULL,'CY','22079','1962-07-28','M','R',':RET:2106-3','N','021','DEN','2276626','18575LA002000201','2014-01-01','2013-12-24 12:22:27','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 18:46:36'),(23720,18886,'Y','18','021','EC','A','','','AC','0001003347','0001003347','OH00002532976','IL','1','McHenry','Martin','','','','34','295801951','4651 Liberty Road',0,'South Euclid','OH','44121',NULL,'CY','39035','1974-06-28','M','U',':RET:2106-3','T','021','HLT','3565450','92036OH004000801','2014-03-01','2014-02-13 18:29:06','0.00',NULL,NULL,'272.83','272.83','R-OH011','OH0','272.83',NULL,0,'2014-02-14 21:30:52'),(21785,17397,'Y','18','021','EC','A','','','AC','0001163878','0001163878','OH00001846805','IL','1','EVANS','CHRISTINA','MARIE','','','34','295760515','16 OAK STREET P.O BOX 289',0,'SOUTH CHARLESTONE','OH','45368',NULL,'CY','39023','1968-08-17','F','U',':RET:2106-3','N','021','DEN','3606845','99734OH005000401','2014-03-01','2014-02-06 08:42:00','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-06 21:00:40'),(1407,1169,'Y','18','021','EC','A','','','AC','0001642157','0001642157','LA00000707602','IL','1','Calix','Kisha','S','','','34','434593546','79 Avant Garde Cir',0,'Kenner','LA','70065',NULL,'CY','22051','1971-08-06','F','U',':RET:2106-3','N','021','DEN','1429574','18575LA002000201','2014-01-01','2013-12-24 13:04:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:47'),(8974,7117,'Y','18','024','14','A','','','TE','0000969424','0000969424','','IL','1','steffan','victoria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-21','F','',NULL,NULL,NULL,'','986258','','2013-12-18','2013-12-18 15:24:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:04:08'),(4574,3622,'N','01','021','EC','A',NULL,NULL,'','0000080816','0000910829','','IL','1','Medrano','Catalina','','','','34','462450073','3651 BULL MOOSE CT',0,'EL PASO','TX','79938','2600','CY','48141','1965-04-11','F','',':RET:2106-3','N','021','DEN','1162406','33348TX002000101','2014-01-01','2013-12-12 15:28:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 22:05:03'),(15517,12414,'N','01','021','EC','A',NULL,NULL,'','0002039982','0002080797','','IL','1','jones','jeanette',NULL,NULL,NULL,NULL,NULL,'513 FONTELIEU DR',0,'NEW IBERIA','LA','70560','5031','CY','22045','1954-01-13','F','',NULL,'N','021','DEN','1476658','18575LA002000201','2014-02-01','2013-12-30 19:08:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:30:13'),(15704,12563,'Y','18','021','EC','A','','','AC','0000092530','0000092530','OH00001701226','IL','1','Pies','Julie','L','','','34','297762988','117 S WALNUT ST',0,'YELLOW SPRINGS','OH','45387','1728','CY','39057','1970-04-27','F','U',':RET:2106-3','N','021','HLT','2431299','92036OH006000501','2014-02-01','2013-12-31 13:49:25','148.00',NULL,NULL,'255.81','107.81','R-OH003','OH0','255.81',NULL,1,'2014-01-02 04:35:50'),(17828,14242,'Y','18','021','EC','A','','','AC','0000709749','0000709749','MS00002183238','IL','1','NGUYEN','LOI','','','','34','426697937','15608 BELMONT DR',0,'BILOXI','MS','39532','4053','CY','28059','1950-03-26','M','U',':RET:2047-9','N','021','DEN','2256209','46300MS002000201','2014-02-01','2014-01-14 14:20:17','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-15 02:05:58'),(1520,1268,'Y','18','021','EC','A','','','AC','0001075301','0001075301','OH00000847227','IL','1','Danner','David','','','','34','299649604','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1958-09-02','M','U',':RET:2106-3','N','021','DEN','2363707','99734OH005000401','2014-01-01','2013-12-24 14:59:57','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:46'),(13063,10412,'Y','18','024','14','A','','','TE','0000629231','0000629231','','IL','1','Robson','Elihudi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-06-21','M','',NULL,NULL,NULL,'','1615999','','2013-12-23','2013-12-23 09:31:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:51:06'),(4143,3303,'N','01','021','EC','A',NULL,NULL,'','0000930898','0001186299','','IL','1','NAKKA','JOSEPHINE','','','','34','273089064','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','1977-06-09','F','',':RET:2029-7','N','021','DEN','1476001','99734OH005000301','2014-01-01','2013-12-17 12:33:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:36'),(4182,3327,'Y','18','021','EC','A','','','AC','0000102807','0000102807','OH00001002413','IL','1','KING','DAVID','','','','34','302586256','52744 TRINTER RD',0,'VERMILION','OH','44089','9407','CY','39093','1957-02-03','M','U',NULL,'N','021','HLT','1427844','52664OH151001306','2014-01-01','2013-12-17 05:02:34','400.00',NULL,NULL,'586.79','186.79','R-OH011','OH0','586.79',NULL,0,'2013-12-25 21:49:26'),(14517,11583,'Y','18','021','EC','A','','','AC','0000751195','0000751195','TX00001663987','IL','1','Urquieta','Juan','','','','34','461412115','2480 Lexington Place',0,'Brownsville','TX','78520',NULL,'CY','48061','1950-03-23','M','M',':RET:2106-3','N','021','DEN','1847937','33348TX002000201','2014-02-01','2013-12-27 16:23:59','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2013-12-28 03:34:12'),(18164,14505,'N','01','021','EC','A',NULL,NULL,'','0001065993','0000332400','','IL','1','Tran','Yenna','','','','34','489081841','641 KEN HAWK PL',0,'WILMINGTON','OH','45177','7933','CY','39027','1979-08-27','F','',':RET:2047-9','N','021','HLT','2539005','92036OH005000605','2014-02-01','2014-01-14 00:16:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','260.61',NULL,0,'2014-01-15 02:07:55'),(19799,15785,'Y','18','021','EC','A','','','AC','0000689687','0000689687','TX00002057428','IL','1','Velazquez','Herlinda','','','','34','642236381','8737 US HIGHWAY 69 N',0,'TYLER','TX','75706','6640','CY','48423','1979-03-23','F','M',NULL,'N','021','DEN','2644845','33348TX002000201','2014-03-01','2014-01-23 23:36:02','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-24 21:00:03'),(19642,15654,'N','01','021','EC','A',NULL,NULL,'','0000509235','0000170187','','IL','1','Hildreth','Thomas','','','','34','291621708','674 BRISTOL CHAMPION TOWNLINE RD NE',0,'BRISTOLVILLE','OH','44402',NULL,'CY','39155','1961-11-06','M','',NULL,'T','021','DEN','3081676','99734OH005000401','2014-03-01','2014-01-23 14:22:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:15'),(18246,14565,'Y','18','024','14','A','','','TE','0001058757','0001058757','','IL','1','TATUM','CARLOS','W',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-09-17','M','',NULL,NULL,NULL,'','1523703','','2014-01-15','2014-01-15 14:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-16 08:44:28'),(23513,18730,'Y','18','021','EC','A','','','AC','0001088751','0001088751','MS00002179083','IL','1','ANDREWS','HERBERT','','','','34','587368062','2626 QUEENIE M JOHNSON RD',0,'LEXINTONT','MS','39095',NULL,'CY','28051','1950-10-03','M','U',':RET:2054-5','N','021','DEN','3767641','46300MS002000101','2014-03-01','2014-02-13 12:40:17','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-13 22:02:15'),(24071,19143,'Y','18','021','EC','A','','','AC','0000086472','0000086472','OH00002156859','IL','1','Davis','Mark','','','','34','285840848','3865 SHAWNEE ST NW',0,'UNIONTOWN','OH','44685','9133','CY','39151','1985-02-25','M','U',':RET:2106-3','N','021','HLT','3119599','52664OH151001304','2014-03-01','2014-02-15 09:43:04','31.00',NULL,NULL,'249.55','218.55','R-OH015','OH0','249.55',NULL,0,'2014-02-15 22:01:17'),(25242,20024,'Y','18','021','EC','A','','','AC','0001174433','0001174433','OH00002284773','IL','1','ulrick','peter','','','','34','271765322','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1979-08-19','M','M',':RET:2106-3','N','021','HLT','3464360','92036OH004001501','2014-04-01','2014-02-20 20:15:28','485.00',NULL,NULL,'561.70','76.70','R-OH002','OH0','214.83',NULL,0,'2014-02-21 22:01:09'),(26404,20940,'N','01','021','EC','A',NULL,NULL,'','0001121451','0000102863','','IL','1','Martin','Wesley','','','','34','280884155','1505 W WAYNE ST',0,'LIMA','OH','45805','2271','CY','39003','1981-08-28','M','',':RET:2106-3','T','021','HLT','2936108','92036OH003001505','2014-04-01','2014-02-26 12:22:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','312.68','CIC',0,'2014-02-28 07:00:33'),(28666,22684,'Y','18','021','EC','A','','','AC','0002251367','0002251367','LA00003796936','IL','1','Washington','Loreene','','','','34','562852763','1825 TRAFFIC ST',0,'BOSSIER CITY','LA','71111','4159','CY','22015','1984-06-05','F','M',NULL,'N','021','DEN','3343904','18575LA002000201','2014-04-01','2014-03-08 15:37:16','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-08 21:30:46'),(7812,6189,'Y','18','021','EC','A','','','AC','0000563896','0000563896','TX00000028240','IL','1','Carrillo','Nancy','','','','34','453997743','3108 TIERRA AYALA',0,'EL PASO','TX','79938','4362','CY','48141','1973-04-27','F','U',':RET:2106-3','N','021','DEN','1419821','33348TX002000201','2014-01-01','2013-12-20 17:45:52','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 03:03:59'),(3238,2608,'Y','18','021','EC','A','','','AC','0000252004','0000252004','TX00000502880','IL','1','Killen','Molly','','','','34','450915999','701 Legacy Drive',0,'Plano','TX','75023',NULL,'CY','48085','1983-02-16','F','U',NULL,'N','021','DEN','667266','33348TX002000201','2014-01-01','2013-10-05 19:59:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:46:14'),(8960,7108,'Y','18','021','EC','A','','','AC','0000309430','0000309430','OH00000703525','IL','1','Turner','Preston','','','','34','678207992','5830 PLACE DE LA CONCORDE ST W',0,'COLUMBUS','OH','43229','9126','CY','39049','2010-08-16','M','R',':RET:2054-5','N','021','DEN','2157256','99734OH005000401','2014-01-01','2013-12-18 13:11:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-26 04:03:50'),(20843,16660,'Y','18','021','EC','A','','','AC','0000844734','0000844734','OH00002388741','IL','1','Campbell','Thomas','','','','34','271880387','2255 Par Ln',0,'Willoughby','OH','44094',NULL,'CY','39085','1987-11-08','M','U',NULL,'N','021','DEN','3529109','99734OH005000301','2014-03-01','2014-01-30 19:04:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-31 21:00:48'),(9247,7332,'N','19','021','EC','A',NULL,NULL,'','0001157551','0000424016','','IL','1','Roessner','Shawn','K',NULL,NULL,NULL,NULL,'PO Box 380  704 Little Turtle Drive',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1993-05-27','M','',':RET:2106-3','N','021','HLT','2146728','92036OH002001501','2014-01-01','2013-12-18 17:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2013-12-26 04:10:44'),(19638,15651,'N','01','021','EC','A',NULL,NULL,'','0000077592','0000886941','','IL','1','MCCAFFERTY','LINDA','','','','34','287568559','9198 SLOUGH RD',0,'CANAL WINCHESTER','OH','43110','9230','CY','39045','1954-10-04','F','',':RET:2106-3','N','021','DEN','2534265','99734OH005000401','2014-03-01','2014-01-23 11:24:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:13'),(24384,19368,'Y','18','021','EC','A','','','AC','0000730021','0000730021','OH00002182843','IL','1','rudes','Cynthia','l','','','34','278521207','5671 CHIPPEWA RD',0,'CHIPPEWA LAKE','OH','44215','8882','CY','39103','1953-01-15','F','M',NULL,'N','021','DEN','2808602','99734OH005000401','2014-04-01','2014-02-18 11:20:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:00:46'),(26147,20731,'N','01','021','EC','A',NULL,NULL,'','0001003356','0000182351','','IL','1','HUBER','JEFFERY','','','','34','301567533','75 MAPLE DR',0,'YOUNGSTOWN','OH','44512','1521','CY','39099','1955-01-21','M','',':RET:2106-3','N','021','DEN','3863017','99734OH005000401','2014-04-01','2014-02-27 13:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:27'),(3744,2995,'Y','18','021','EC','A','','','AC','0001150916','0001150916','TX00001295826','IL','1','RAMIREZ','AMELIA','','','','34','429652580','107 AUSTIN ST',0,'SUDAN','TX','79371','2121','CY','48279','1971-08-26','F','U',NULL,'N','021','DEN','579099','33348TX002000201','2014-01-01','2013-12-13 13:47:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:59'),(21344,17058,'Y','18','021','EC','A','','','AC','0000321974','0000321974','TX00002365948','IL','1','Keating','Stacey','','','','34','457197723','332 BAER ST',0,'PAMPA','TX','79065','5716','CY','48179','1966-12-29','F','R',':RET:2106-3','T','021','DEN','3250594','33348TX002000201','2014-03-01','2014-02-03 22:19:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:34'),(20628,16483,'Y','18','021','EC','A','','','AC','0000752672','0000752672','TX00001491119','IL','1','GUTIERREZ','DAVID','','','','34','342728937','901 BEVERLY DR',0,'LAREDO','TX','78045','2003','CY','48479','1982-08-08','M','U',NULL,'N','021','DEN','3130603','33348TX002000201','2014-03-01','2014-01-29 19:56:45','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-30 21:00:27'),(3796,3042,'Y','18','021','EC','A','','','AC','0000355020','0000355020','OH00001196625','IL','1','Kurtzman','Linda','','','','34','185403549','7013 STEWART SHARON RD',0,'HUBBARD','OH','44425','3082','CY','39155','1949-06-12','F','U',NULL,'N','021','DEN','897580','99734OH005000301','2014-01-01','2013-12-13 11:45:26','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:34:22'),(6440,5107,'Y','18','021','EC','A','','','AC','0000143057','0000143057','LA00000597498','31','1','Doubleday','Roland','','','','34','439881857','3501 N Causeway Blvd',0,'Metairie','LA','70002',NULL,'CY','22051','1959-01-19','M','U',NULL,'N','021','DEN','575347','18575LA002000201','2014-01-01','2013-12-11 17:28:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:49:24'),(17766,14194,'Y','18','021','EC','A','','','AC','0000737352','0000737352','TX00002269767','IL','1','Gomez','Diana','M','','','34','457210853','12770 Bandera Rd',0,'Helotes','TX','78023',NULL,'CY','48029','1958-07-19','F','U',':RET:2106-3','N','021','DEN','1995645','33348TX002000101','2014-02-01','2014-01-13 11:42:36','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-14 01:33:35'),(14266,11380,'Y','18','021','EC','A','','','AC','0000993984','0000993984','OH00001729918','IL','1','McFarland','Jan','','','','34','272689628','19 POWHATTON DR',0,'MILFORD','OH','45150','1621','CY','39025','1961-05-29','F','U',':RET:2106-3','N','021','HLT','1951729','92036OH006000601','2014-02-01','2013-12-26 13:35:27','308.00',NULL,NULL,'332.32','24.32','R-OH005','OH0','332.32',NULL,0,'2013-12-27 02:05:57'),(16549,13239,'Y','18','021','EC','A','','','AC','0001284858','0001284858','LA00002369202','IL','1','Mitchell','Patricia',NULL,NULL,NULL,NULL,NULL,'7516 Prairie Drive',0,'Greenwell Springs','LA','70739',NULL,'CY','22033','1973-10-06','F','M',':RET:2106-3','N','021','DEN','1583740','18575LA002000101','2014-02-01','2014-01-05 15:11:51','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-07 10:22:39'),(16599,13277,'Y','18','021','EC','A','','','AC','0002268057','0002268057','LA00001964866','IL','1','WILEY','BETTY','','','','34','434334639','39389 BAYRIDGE DR',0,'PRAIRIEVILLE','LA','70769','4978','CY','22005','1962-07-06','F','M',NULL,'N','021','DEN','2394431','18575LA002000201','2014-02-01','2014-01-07 13:13:18','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:03'),(23812,18947,'Y','18','021','EC','A','','','AC','0000604747','0000604747','OH00002207485','IL','1','Arnold','Vicki','','','','34','296501428','1500 West Market St',0,'Akron','OH','44313',NULL,'CY','39153','1951-12-20','F','U',':RET:2054-5','N','021','HLT','2902233','52664OH152000901','2014-03-01','2014-02-14 08:01:48','415.00',NULL,NULL,'469.28','54.28','R-OH012','OH0','469.28',NULL,0,'2014-02-14 21:31:36'),(23968,19055,'N','01','021','EC','A',NULL,NULL,'','0000799743','0000724115','','IL','1','Stevens','Lisa','','','','34','454754192','381 MISSION RIVER OAKS RD',0,'WOODSBORO','TX','78393','3623','CY','48391','1974-08-13','F','',':RET:2106-3','N','021','DEN','3082240','33348TX002000101','2014-03-01','2014-02-15 14:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-15 22:00:12'),(26299,20863,'Y','18','021','EC','A','','','AC','0000112986','0000112986','OH00003444622','IL','1','Lanum','Richard','','','','34','298701443','3289 Uplands Dr',0,'Springfield','OH','45506',NULL,'CY','39023','1971-11-13','M','U',NULL,'N','021','HLT','3770637','92036OH004000501','2014-04-01','2014-02-26 21:19:07','109.00',NULL,NULL,'253.26','144.26','R-OH003','OH0','253.26',NULL,0,'2014-02-28 06:31:28'),(27180,21520,'Y','18','021','EC','A','','','AC','0000353269','0000353269','TX00003623300','IL','1','wise','colleen','','','','34','346626400','1407 SYCAMORE DR',0,'BURKBURNETT','TX','76354','3140','CY','48485','1959-12-29','F','M',':RET:2106-3','N','021','DEN','3876467','33348TX002000201','2014-04-01','2014-03-03 13:33:11','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-03-03 21:31:10'),(27387,21684,'Y','18','021','EC','A','','','AC','0001187438','0001187438','MS00003561687','IL','1','LOVE','MARY','LEE','','','34','426195337','1520 PITTSBURG ST',0,'JACKSON','MS','39203','2850','CY','28049','1960-10-08','F','U',NULL,'N','021','DEN','4053917','46300MS002000201','2014-04-01','2014-03-04 16:10:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:25'),(27647,21869,'Y','18','021','EC','A','','','AC','0000030606','0000030606','OH00002433476','IL','1','Morin','John','J','','','34','275680060','139 MARILYN DR',0,'MADISON','OH','44057','1641','CY','39085','1963-10-29','M','U',':RET:2106-3','T','021','DEN','3881944','99734OH005000401','2014-04-01','2014-03-05 13:02:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-05 21:30:20'),(1547,1290,'Y','18','021','EC','A','','','AC','0000387731','0000387731','MS00001301686','IL','1','Archer','Vernon','','','','34','427553153','1068 VOORHEES AVE',0,'JACKSON','MS','39209','7021','CY','28049','1972-04-26','M','U',':RET:2054-5','N','021','DEN','1632346','46300MS002000201','2014-01-01','2013-12-24 05:04:45','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:50:29'),(22431,17910,'Y','18','021','EC','A','','','AC','0000925341','0000925341','TX00001579561','IL','1','Barrera','Maria','','','','34','643765073','1303 WAYNE ST',0,'HALTOM CITY','TX','76117','5830','CY','48439','1962-05-25','F','M',NULL,'N','021','DEN','3059837','33348TX002000201','2014-03-01','2014-02-09 22:03:23','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:36'),(22336,17837,'Y','18','021','EC','A','','','AC','0000467123','0000467123','OH00002160740','IL','1','Hale','Susan','','','','34','291486635','2519 GRACEWOOD RD',0,'TOLEDO','OH','43613','3338','CY','39095','1951-09-28','F','U',':RET:2106-3','T','021','HLT','3179358','92036OH004002601','2014-03-01','2014-01-27 08:07:02','506.00',NULL,NULL,'518.03','12.03','R-OH001','OH0','518.03',NULL,0,'2014-02-10 11:01:05'),(21713,17338,'N','01','021','EC','A',NULL,NULL,'','0000476002','0001096791','','IL','1','Stevens','Lisa','J','','','34','299620727','276 State Route 196',0,'New Hampshire','OH','45870',NULL,'CY','39011','1960-10-15','F','',':RET:2106-3','N','021','HLT','3844390','92036OH003001505','2014-03-01','2014-02-05 11:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.87',NULL,0,'2014-02-05 21:31:16'),(20349,16250,'Y','18','021','EC','A','','','AC','0000735060','0000735060','OH00002249413','IL','1','Hartman','August','','','','34','360803832','260 Holly Dr.',0,'Franklin','OH','45005',NULL,'CY','39165','1976-11-16','M','U',':RET:2106-3','T','021','HLT','3303489','92036OH004001201','2014-03-01','2014-01-28 11:27:07','190.00',NULL,NULL,'245.74','55.74','R-OH004','OH0','245.74',NULL,0,'2014-01-28 21:01:13'),(20256,16165,'Y','18','021','EC','A','','','AC','0000141537','0000141537','OH00002237865','IL','1','ANTAUER','GENE','','','','34','291501777','3193 MIDDLEBORO',0,'DUBLIN','OH','43017',NULL,'CY','39049','1951-02-12','M','M',':RET:2106-3','N','021','DEN','2685659','99734OH005000301','2014-03-01','2014-01-27 19:46:16','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-28 21:00:16'),(20211,16126,'N','19','021','EC','A',NULL,NULL,'','0000675479','0000449901','','IL','1','DePaolo','Alexander','N',NULL,NULL,NULL,NULL,'38155 STATE ROUTE 303',0,'GRAFTON','OH','44044','9013','CY','39093','2001-07-02','M','',':RET:1002-5^:RET:2106-3','N','021','HLT','2833724','52664OH151001501','2014-03-01','2014-01-27 12:09:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-01-27 21:01:38'),(5323,4221,'Y','18','024','14','A','','','TE','0000265197','0000265197','','IL','1','Pickrel','Sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-23','F','',NULL,NULL,NULL,'','239845','','2013-12-19','2013-12-19 08:27:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:06:53'),(19746,15738,'Y','18','021','EC','A','','','AC','0000343941','0000343941','TX00002540039','IL','1','nino','maria','','','','34','632180426','6905 N HUBER AVE',0,'ODESSA','TX','79764','2748','CY','48135','1986-07-11','F','U',NULL,'N','021','DEN','1464338','33348TX002000101','2014-03-01','2014-01-23 17:42:22','0.00',NULL,NULL,'25.02','25.02','R-TX017','TX0','25.02',NULL,0,'2014-01-23 21:01:14'),(19200,15296,'Y','18','021','EC','A','','','AC','0000448800','0000448800','OH00002260350','IL','1','Caughey','Shawn','','','','34','277567504','1270 ECHO ST NE',0,'CANTON','OH','44721','1629','CY','39151','1967-06-26','M','M',NULL,'N','021','HLT','2554935','52664OH151001305','2014-03-01','2014-01-19 19:16:52','163.00',NULL,NULL,'334.51','171.51','R-OH015','OH0','334.51',NULL,0,'2014-01-21 08:46:16'),(4324,3435,'Y','18','021','EC','A','','','AC','0000710120','0000710120','OH00000206366','IL','1','Gibbs','Adam','','','','34','293924322','2748 St. Rt. 29 N',0,'Sidney','OH','45365',NULL,'CY','39149','1984-07-28','M','U',':RET:2106-3','N','021','HLT','2062880','92036OH004000501','2014-01-01','2013-12-17 08:49:27','193.00',NULL,NULL,'213.88','20.88','R-OH003','OH0','213.88',NULL,0,'2013-12-25 21:52:50'),(18753,14942,'Y','18','021','EC','A','','','AC','0000541672','0000541672','OH00002022684','IL','1','Galbraith','Keith','James','','','34','279587621','606 PALMWOOD ST',0,'DELTA','OH','43515','1234','CY','39051','1958-01-10','M','U',':RET:2106-3','T','021','HLT','2529120','92036OH005002601','2014-03-01','2014-01-16 05:28:11','127.00',NULL,NULL,'523.16','396.16','R-OH001','OH0','523.16',NULL,0,'2014-01-17 03:35:44'),(9093,7217,'Y','18','021','EC','A','','','AC','0001109209','0001109209','OH00000458680','IL','1','Johnson II','Eric','','','','34','414571156','1200 RIPPLECREEK CT',0,'CENTERVILLE','OH','45458','3282','CY','39113','1982-03-05','M','U',':RET:2054-5','N','021','DEN','1452557','99734OH005000301','2014-01-01','2013-12-18 11:42:38','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:07:09'),(17954,14345,'Y','18','021','EC','A','','','AC','0000363209','0000363209','TX00001554630','IL','1','Perez','Clarissa','','','','34','637163134','230 TERESA',0,'SAN ANTONIO','TX','78214','1037','CY','48029','1985-02-19','F','U',':RET:2106-3','N','021','DEN','2353499','33348TX002000201','2014-02-01','2014-01-14 17:21:17','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:43'),(13299,10616,'Y','18','021','EC','A','','','AC','0000822968','0000822968','TX00000957663','IL','1','Cole','Stacey','','','','34','429630480','9115 LIPTONSHIRE DR',0,'DALLAS','TX','75238','2713','CY','48113','1973-12-18','F','U',':RET:2106-3','N','021','DEN','1456696','33348TX002000201','2014-01-01','2013-12-23 14:42:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:57:43'),(25556,20275,'N','19','021','EC','A',NULL,NULL,'','0000638562','0000563195','','IL','1','Greenwood','Isannah','','','','34','280139414','14533 UPPER CUMBERLAND RD',0,'MOUNT ORAB','OH','45154','9085','CY','39015','2007-05-26','F','',NULL,'N','021','HLT','3140999','92036OH004000601','2014-04-01','2014-02-23 08:34:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-26 08:00:21'),(25777,20442,'Y','18','024','14','A','','','TE','0002243488','0002243488','','IL','1','Davis','Lenard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-18','M','',NULL,NULL,NULL,'','2343627','','2014-02-24','2014-02-24 14:57:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-26 09:30:59'),(7685,6086,'Y','18','021','EC','A','','','AC','0001004325','0001004325','OH00001275497','IL','1','Ayers','Lisa','','','','34','274805391','1118 TWIGG LN',0,'AMELIA','OH','45102','1235','CY','39025','1970-02-05','F','R',':RET:2106-3','N','021','DEN','1676656','99734OH005000401','2014-01-01','2013-12-19 20:48:10','0.00',NULL,NULL,'50.05','50.05','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:00:54'),(7626,6036,'Y','18','021','EC','A','','','AC','0001102055','0001102055','OH00000351187','IL','1','beaverson','shawn','','','','34','300749469','817 VALE CT',0,'BOWLING GREEN','OH','43402','4845','CY','39173','1975-01-29','M','M',':RET:2106-3','N','021','HLT','610623','92036OH004002601','2014-01-01','2013-11-17 13:06:20','329.00',NULL,NULL,'386.96','57.96','R-OH001','OH0','195.37',NULL,0,'2013-12-26 02:46:04'),(22046,17598,'Y','18','021','EC','A','','','AC','0002109711','0002109711','LA00002522094','IL','1','Bankston','Emelie','','','','34','438534501','114 OAK POST RD',0,'LAFAYETTE','LA','70503','6106','CY','22055','1969-02-21','F','M',':RET:2106-3','N','021','DEN','3167599','18575LA002000101','2014-03-01','2014-02-06 23:02:54','0.00',NULL,NULL,'50.04','50.04','R-LA003','LA0','25.02','CIC',0,'2014-02-07 19:30:03'),(22029,17587,'Y','18','021','EC','A','','','AC','0001066019','0001066019','OH00001703251','IL','1','Simmons','Kathrine',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1968-10-03','F','R',NULL,'N','021','HLT','2731792','52664OH151001501','2014-03-01','2014-02-07 10:25:17','0.00',NULL,NULL,'1819.31','1819.31','R-OH011','OH0','435.60',NULL,0,'2014-02-07 19:01:03'),(16747,13396,'Y','18','021','EC','A','','','AC','0000350434','0000350434','TX00002388165','IL','1','khalid','naeema','','','','34','630255709','5025 fm 2351 rd.',0,'friendswood','TX','77546',NULL,'CY','48201','1966-03-04','F','M',':RET:2028-9','N','021','DEN','2335485','33348TX002000101','2014-02-01','2014-01-06 21:33:13','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-08 18:24:53'),(4425,3516,'Y','18','021','EC','A','','','AC','0001194097','0001194097','OH00000322855','IL','1','MONCOL','SALLY','','','','34','285461289','4487 ROADOAN RD',0,'BROOKLYN','OH','44144','2745','CY','39035','1949-06-20','F','U',NULL,'N','021','DEN','819628','99734OH005000401','2014-01-01','2013-12-12 16:53:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:42'),(4469,3551,'Y','18','024','14','A','','','TE','0000500368','0000500368','','IL','1','Bodi','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-13','F','',NULL,NULL,NULL,'','639302','','2013-12-12','2013-12-12 14:52:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:48'),(4921,3905,'Y','18','021','EC','A','','','AC','0000225993','0000225993','OH00000477617','IL','1','Cipro','Romualdo','','','Jr','34','298760256','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1970-06-25','M','M',':RET:2106-3','N','021','HLT','979775','52664OH151001306','2014-01-01','2013-12-07 11:41:17','513.00',NULL,NULL,'637.13','124.13','R-OH012','OH0','302.62',NULL,0,'2013-12-25 22:45:10'),(6204,4917,'Y','18','021','EC','A','','','AC','0000481028','0000481028','OH00001074393','IL','1','Moore','Erica','Jane','','','34','283820184','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1984-07-08','F','U',NULL,'N','021','DEN','440801','99734OH005000401','2014-01-01','2013-10-16 20:06:59','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:30:42'),(18365,14659,'Y','18','024','14','A','','','TE','0000697935','0000697935','','IL','1','salmons','Josh',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-11-16','M','',NULL,NULL,NULL,'','2897804','','2014-01-15','2014-01-15 10:16:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:45:28'),(19181,15281,'Y','18','021','EC','A','','','AC','0001181494','0001181494','TX00001498041','IL','1','Cerros','Manuel','','','','34','458024922','819 Mallett',0,'el paso','TX','79907',NULL,'CY','48141','1951-11-16','M','U',':RET:2106-3','N','021','DEN','1395965','33348TX002000201','2014-03-01','2014-01-20 16:24:12','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-21 08:46:08'),(21058,16825,'Y','18','021','EC','A','','','AC','0001157750','0001157750','LA00001529004','IL','1','washington','reneka','','','','34','436496863','8880 geenwood rd.',0,'greenwood','LA','71033',NULL,'CY','22017','1983-01-11','F','U',':RET:2054-5','N','021','DEN','3084186','18575LA002000201','2014-03-01','2014-02-02 09:05:22','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-02 19:00:10'),(22052,17603,'Y','18','021','EC','A','','','AC','0000507899','0000507899','TX00001490000','IL','1','Houck','Alec','','','','34','638245909','14658 LOURDES DR',0,'HOUSTON','TX','77049','4415','CY','48201','1991-03-14','M','U',':RET:2106-3','N','021','DEN','3402482','33348TX002000201','2014-03-01','2014-02-07 20:09:02','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-08 19:00:05'),(26923,21336,'Y','18','021','EC','A','','','AC','0001187695','0001187695','OH00003159766','IL','1','Randles','Anne','L','','','34','294445522','552 PICADILLY CIR',0,'AKRON','OH','44319','1377','CY','39153','1956-09-06','F','M',':RET:2106-3','N','021','DEN','3617360','99734OH005000401','2014-05-01','2014-03-02 07:47:22','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-03 01:00:16'),(27214,21547,'Y','18','021','EC','A','','','AC','0000508362','0000508362','MS00003499756','IL','1','Young','Marquis','','','','34','604108507','2642 MACLEAN RD',0,'JACKSON','MS','39209','9569','CY','28049','1979-02-02','M','U',':RET:2054-5','N','021','DEN','3079013','46300MS002000201','2014-04-01','2014-03-02 19:30:27','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:30'),(189,158,'Y','18','021','EC','A','','','AC','0000720224','0000720224','OH00000515097','IL','1','GLEGHORN','THOMAS','','','','34','278522343','2689 9TH STREET',0,'CUYAHOGA FALLS','OH','44221',NULL,'CY','39153','1951-12-24','M','U',':RET:2106-3','N','021','HLT','19744','52664OH151001304','2014-01-01','2013-12-05 12:29:38','450.00',NULL,NULL,'640.70','190.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 17:19:54'),(228,192,'Y','18','021','EC','A','','','AC','0000267237','0000267237','LA00000753729','IL','1','GREATREX','VICTOR','','','','34','433868850','1326 WEST ESPLANADE AVE',0,'KENNER','LA','70065',NULL,'CY','22051','1951-06-24','M','U',':RET:2106-3','N','021','DEN','196390','18575LA002000201','2014-01-01','2013-12-05 18:13:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:20:58'),(13798,11014,'N','01','021','EC','A',NULL,NULL,'','0000874282','0001083486','','IL','1','Taylor','Ruthie','Mae','','','34','587865285','1763 SOUTHHAVEN CIR',0,'JACKSON','MS','39204','4300','CY','28049','1953-03-31','F','',':RET:2054-5','N','021','DEN','2208371','46300MS002000101','2014-01-01','2013-12-23 12:10:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-26 13:11:18'),(7887,6238,'Y','18','021','EC','A','','','AC','0000262722','0000262722','OH00000787479','IL','1','KHOURY','JEANINE','','','','34','269464542','3035 VILLA DR',0,'TOLEDO','OH','43614','5265','CY','39095','1953-12-08','F','M',NULL,'N','021','HLT','1489424','92036OH005002601','2014-01-01','2013-12-19 19:28:59','737.00',NULL,NULL,'1077.16','340.16','R-OH001','OH0','529.21',NULL,0,'2013-12-26 03:05:33'),(7827,6199,'Y','18','024','14','A','','','TE','0001032598','0001032598','','IL','1','Crawford','Daniel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-10-06','M','',NULL,NULL,NULL,'','1676498','','2013-12-19','2013-12-19 19:02:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:20'),(7433,5882,'N','01','021','EC','A',NULL,NULL,'','0000356029','0001229296','','IL','1','DEITERS','GREGORY','P','','','34','271446679','683 VALLEY CREST DR',0,'AKRON','OH','44319','4260','CY','39153','1957-10-04','M','',':RET:2106-3','N','021','HLT','732165','52664OH151001305','2014-01-01','2013-12-14 19:15:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-26 02:30:12'),(5129,4065,'Y','18','021','EC','A','','','AC','0000543705','0000543705','TX00000605055','IL','1','STACK','THOMAS','AIDAN','','','34','635328943','8113 SUN MEADOWS CT',0,'FORT WORTH','TX','76123','1960','CY','48439','1959-10-09','M','M',NULL,'N','021','DEN','1841788','33348TX002000101','2014-01-01','2013-12-18 19:52:08','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:02:11'),(7309,5793,'Y','18','024','14','A','','','TE','0001029340','0001029340','','IL','1','Schrack','Curtis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-07','M','',NULL,NULL,NULL,'','702067','','2013-12-14','2013-12-14 17:23:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:03:19'),(21448,17142,'N','19','021','EC','A',NULL,NULL,'','0000469573','0000280871','','IL','1','Bryant','Clark','L','','III','34','279984640','321 SUZANNE DR',0,'KENT','OH','44240','1931','CY','39133','1995-01-28','M','',NULL,'N','021','HLT','2878000','52664OH151001301','2014-03-01','2014-02-03 21:59:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-04 21:01:27'),(545,446,'Y','18','021','EC','A','','','AC','0000491846','0000491846','OH00000649852','IL','1','Harris','Veniece','','','','34','297921643','890 Simon Lane',0,'Kent','OH','44240',NULL,'CY','39133','1991-02-08','F','U',':RET:2054-5','N','021','HLT','424300','52664OH152000901','2014-01-01','2013-12-03 23:26:25','0.00',NULL,NULL,'163.34','163.34','R-OH012','OH0','163.34',NULL,0,'2013-12-25 17:49:51'),(5816,4620,'N','19','021','EC','A',NULL,NULL,'','0000876732','0001152369','','IL','1','Ghneim','Amal','Said','','','34','636287682','5807 MANCHESTER DR',0,'RICHARDSON','TX','75082','2709','CY','48085','1990-05-04','F','',':RET:2106-3','N','021','DEN','1632313','33348TX002000201','2014-01-01','2013-12-23 21:56:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:47:54'),(1625,1357,'N','01','021','EC','A',NULL,NULL,'','0000351733','0000679770','','IL','1','Kankonde','Mutombo','','','','34','579116320','11101 BILL HILL DR',0,'EL PASO','TX','79936','4601','CY','48141','1958-09-05','M','',':RET:2054-5','N','021','DEN','2049654','33348TX002000201','2014-01-01','2013-12-24 14:01:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:52:41'),(5592,4437,'Y','18','021','EC','A','','','AC','0000203034','0000203034','OH00000981820','IL','1','Mueller','Thomas','','','','34','295441873','420 HOME AVE',0,'CINCINNATI','OH','45215','2926','CY','39061','1954-08-12','M','U',NULL,'N','021','HLT','300435','92036OH005001201','2014-01-01','2013-11-06 09:59:14','277.00',NULL,NULL,'558.80','281.80','R-OH004','OH0','558.80',NULL,0,'2013-12-25 23:17:18'),(15245,12185,'Y','18','021','EC','A','','','AC','0000060275','0000060275','OH00001109209','IL','1','Hopkins','Chrishana','Lynn','','','34','294749891','20 GRAY DR',0,'PEEBLES','OH','45660','1011','CY','39001','1978-02-26','F','U',':RET:2106-3','N','021','HLT','1549374','92036OH003000605','2014-02-01','2013-12-30 10:01:32','112.00',NULL,NULL,'273.93','161.93','R-OH005','OH0','273.93',NULL,0,'2014-01-01 12:08:45'),(14709,11744,'Y','18','024','14','A','','','TE','0001050608','0001050608','','IL','1','Coakley','Donald','kenneth',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-07-02','M','',NULL,NULL,NULL,'','276530','','2013-12-28','2013-12-28 16:10:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:09:17'),(4671,3703,'Y','18','021','EC','A','','','AC','0000680186','0000680186','LA00000379739','IL','1','Courville','Sarah','','','','34','439274564','1567 COTEAU RODAIRE HWY',0,'ARNAUDVILLE','LA','70512','3625','CY','22099','1962-04-04','F','U',':RET:2106-3','N','021','DEN','369256','18575LA002000201','2014-01-01','2013-12-12 14:27:04','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 22:07:36'),(18976,15121,'Y','18','021','EC','A','','','AC','0000228366','0000228366','OH00002124376','IL','1','WHITLATCH','CHARLEY','E','','','34','295629045','537 FOWLER ST',0,'NEW LEXINGTON','OH','43764',NULL,'CY','39127','1966-07-23','M','M',':RET:2106-3','N','021','DEN','2237610','99734OH005000301','2014-03-01','2014-01-17 13:47:14','0.00',NULL,NULL,'87.78','87.78','R-OH016','OH0','0.00',NULL,0,'2014-01-20 08:06:05'),(20579,16445,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000232674','','IL','1','Alshinnawi','yousef','S','','','34','286047764','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1999-09-23','M','',':RET:2106-3','N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(20921,16722,'Y','18','021','EC','A','','','AC','0000086449','0000086449','OH00002550238','IL','1','Anderson','Keith','','','','34','272865768','5340 HAMILTON AVE APT 302',0,'CLEVELAND','OH','44114',NULL,'CY','39035','1975-10-16','M','U',':RET:2106-3','N','021','HLT','3266536','52664OH151001501','2014-03-01','2014-01-31 11:08:43','98.00',NULL,NULL,'375.87','277.87','R-OH011','OH0','375.87',NULL,0,'2014-01-31 21:01:32'),(21939,17519,'Y','18','024','14','A','','','TE','0000411585','0000411585','','IL','1','Kerr','Charles',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-21','M','',NULL,NULL,NULL,'','848696','','2014-02-28','2014-02-07 15:54:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-07 19:00:14'),(23259,18544,'Y','18','024','14','A','','','TE','0000542205','0000542205','','IL','1','montanez','stefanie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-11','F','',NULL,NULL,NULL,'','397886','','2014-02-28','2014-02-13 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-13 21:30:09'),(23393,18642,'Y','18','021','EC','A','','','AC','0000934703','0000934703','OH00001743408','IL','1','Hollinger','Tiffany','','','','34','274925417','940 N MANTUA ST',0,'KENT','OH','44240','2324','CY','39133','1989-10-04','F','U',':RET:2106-3','N','021','DEN','3664167','99734OH005000401','2014-03-01','2014-02-13 15:16:39','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-13 22:01:07'),(25676,20369,'N','01','021','EC','A',NULL,NULL,'','0000072934','0000853088','','IL','1','Khoele','Mmabatho','Rejoice','','','34','396170511','900 SELBY ST',0,'FINDLAY','OH','45840','6024','CY','39063','1963-09-26','F','',':RET:2054-5','N','021','HLT','3581637','92036OH004001501','2014-04-01','2014-02-22 12:18:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','316.06',NULL,0,'2014-02-26 08:30:55'),(3854,3084,'Y','18','021','EC','A','','','AC','0000154030','0000154030','LA00000050195','IL','1','PIPPIT','NANCY','','','','34','420764546','247 WOODARD DR',0,'MINDEN','LA','71055','8927','CY','22119','1952-11-23','F','M',':RET:2106-3','T','021','DEN','846687','18575LA002000101','2014-01-01','2013-12-13 16:53:13','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 21:35:43'),(5893,4673,'Y','18','021','EC','A','','','AC','0000146891','0000146891','OH00001134011','IL','1','Tucker','Lance','','','','34','278724008','2517 HUFFMAN RD',0,'CENTERBURG','OH','43011','9470','CY','39083','1976-10-18','M','M',':RET:2106-3','N','021','DEN','1679922','99734OH005000301','2014-01-01','2013-12-23 23:12:25','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:49:40'),(4880,3869,'Y','18','024','14','A','','','TE','0000315229','0000315229','','IL','1','Rasnic','Rhea',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-06-27','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:31:13'),(14231,11349,'Y','18','021','EC','A','','','AC','0000901075','0000901075','OH00000877273','IL','1','Little','Robert','','','','34','268644708','70 Bent Tree Dr',0,'Fairfield','OH','45014',NULL,'CY','39017','1963-09-11','M','U',':RET:2106-3','N','021','HLT','2121319','92036OH003001205','2014-02-01','2013-12-25 20:06:29','263.00',NULL,NULL,'400.38','137.38','R-OH004','OH0','400.38',NULL,0,'2013-12-27 02:05:00'),(14083,11223,'Y','18','021','EC','A','','','AC','0001135174','0001135174','OH00001641057','IL','1','archer','randy','','','','34','302420646','11 mill st.',0,'berlin heights','OH','44814',NULL,'CY','39043','1953-09-04','M','U',':RET:2106-3','N','021','DEN','2558221','99734OH005000401','2014-02-01','2013-12-26 10:32:06','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-27 02:01:09'),(5586,4431,'Y','18','021','EC','A','','','AC','0001007854','0001007854','OH00000324996','IL','1','Louderback','Kevin','','','','34','276887111','3925 St. Rte. 134',0,'Mt Orab','OH','45154',NULL,'CY','39071','1979-09-07','M','U',':RET:2106-3','T','021','HLT','651482','92036OH006000601','2014-01-01','2013-11-05 18:29:39','0.00',NULL,NULL,'237.68','237.68','R-OH005','OH0','237.68',NULL,0,'2013-12-25 23:17:05'),(17761,14191,'Y','18','021','EC','A','','','AC','0000201941','0000201941','OH00001852351','IL','1','Hayes','Verlie','','','','34','298560862','2420 JETT HILL RD',0,'NEW RICHMOND','OH','45157','9593','CY','39025','1958-08-23','F','M',':RET:2106-3','T','021','HLT','2001992','92036OH004000601','2014-02-01','2014-01-13 12:35:12','581.00',NULL,NULL,'938.58','357.58','R-OH005','OH0','442.67',NULL,0,'2014-01-14 01:33:33'),(18063,14429,'N','19','021','EC','A',NULL,NULL,'','0000484813','0000288312','','S1','1','Boone','Jesee','Lee',NULL,NULL,NULL,NULL,'14 Oriole Court',0,'Amelia','OH','45102',NULL,'CY','39025','2007-10-15','F','',':RET:2106-3','N','021','HLT','1875690','92036OH003000604','2014-02-01','2014-01-14 16:42:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-15 02:07:21'),(22651,18086,'Y','18','021','EC','A','','','AC','0001241888','0001241888','TX00001718338','IL','1','GALLAGHER','DALE','','','','34','437829304','4207 MEADOWBANK DR',0,'SEABROOK','TX','77586','4118','CY','48201','1950-12-22','F','U',NULL,'T','021','DEN','2864360','33348TX002000201','2014-03-01','2014-02-11 11:18:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:28'),(22697,18124,'Y','18','021','EC','A','','','AC','0000764956','0000764956','TX00001355066','IL','1','HILL','LUIS','A','','','34','512566242','9001 MARKVILLE DR',0,'DALLAS','TX','75243','9341','CY','48113','1953-07-17','M','M',NULL,'N','021','DEN','3655447','33348TX002000101','2014-03-01','2014-02-11 02:58:36','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-02-11 21:00:56'),(24586,19519,'Y','18','021','EC','A','','','AC','0000278358','0000278358','OH00002499915','IL','1','BOGGAN','LINDA','','','','34','289740464','20551 MILLER AVE',0,'EUCLID','OH','44119','2312','CY','39035','1965-01-26','F','U',':RET:2106-3','N','021','DEN','3495804','99734OH005000301','2014-04-01','2014-02-19 13:13:26','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:09:37'),(24749,19640,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000519884','','IL','1','SMITH','NIQUAN','','','','34','291138661','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2008-01-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:59'),(26090,20691,'Y','18','021','EC','A','','','AC','0002064248','0002064248','LA00002655766','IL','1','Gosha','Angelle','','','','34','437633228','4844 I 49 N SERVICE RD',0,'OPELOUSAS','LA','70570','0737','CY','22097','1971-08-09','F','U',':RET:2054-5','N','021','DEN','3213260','18575LA002000201','2014-03-01','2014-02-27 10:01:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-28 06:30:08'),(26596,21087,'Y','18','021','EC','A','','','AC','0000434449','0000434449','TX00002603905','IL','1','Mele','Vincent','','','','34','153787891','3609 CALDERA BLVD',0,'MIDLAND','TX','79707','2872','CY','48329','1985-10-21','M','M',NULL,'N','021','DEN','2708604','33348TX002000201','2014-03-01','2014-02-27 18:29:06','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-28 21:30:39'),(27279,21601,'N','01','021','EC','A',NULL,NULL,'','0000798469','0000449665','','IL','1','VALDEZ-LOPEZ','CARLOS','','','','34','729287292','1460 PLAZA VERDE DR',0,'EL PASO','TX','79912','8427','CY','48141','1964-08-11','M','',':RET:2106-3','N','021','DEN','3091417','33348TX002000201','2014-04-01','2014-03-03 21:08:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:21'),(8876,7037,'Y','18','021','EC','A','','','AC','0000204043','0000204043','TX00001193200','IL','1','Perez','Salomon','Garrett','','','34','629261549','387 BUNDRICK LN',0,'LONGVIEW','TX','75604','9414','CY','48183','1991-09-11','M','M',NULL,'N','021','DEN','2374407','33348TX002000201','2014-01-01','2013-12-18 14:31:55','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 04:01:41'),(17506,13996,'N','19','021','EC','A',NULL,NULL,'','0000530709','0000345598','','IL','1','Lampert','Joseph','','','','34','283024115','7291 Lauren J Drive',0,'Mentor','OH','44060',NULL,'CY','39085','1997-08-14','M','',':RET:2106-3','N','021','HLT','1596454','52664OH151001501','2014-02-01','2014-01-11 19:22:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-01-13 03:01:28'),(16119,12912,'Y','18','021','EC','A','','','AC','0001604385','0001604385','LA00001631164','31','1','KEASLEY','DARRELL','','','','34','436948657','1938 TENNESSEE ST',0,'NEW ORLEANS','LA','70117',NULL,'CY','22071','1956-07-18','M','M',NULL,'T','021','DEN','2066200','18575LA002000101','2014-02-01','2014-01-03 11:49:15','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-01-04 02:05:21'),(7622,6032,'Y','18','021','EC','A','','','AC','0001027976','0001027976','TX00001094366','IL','1','Branden','Tychesia','','','','34','433319559','2815 Logan Cir',0,'Nacogdoches','TX','75961',NULL,'CY','48347','1976-09-17','F','U',':RET:2054-5','N','021','DEN','120115','33348TX002000201','2014-01-01','2013-11-17 10:24:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:45:56'),(15403,12321,'Y','18','021','EC','A','','','AC','0000083700','0000083700','TX00001371387','IL','1','Scheidt','John','','','','34','395566039','236 RAINBOW DR',0,'LIVINGSTON','TX','77399','2036','CY','48373','1954-01-12','M','M',':RET:2106-3','N','021','DEN','1895478','33348TX002000201','2014-02-01','2013-12-30 20:10:50','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:26:51'),(13763,10985,'N','01','021','EC','A',NULL,NULL,'','0000412070','0000996394','','IL','1','DAQUIN','DEANNA','MARIE','','','34','425234171','236 BASSWOOD DR',0,'PASS CHRISTIAN','MS','39571','2104','CY','28047','1960-09-22','F','',':RET:2106-3','N','021','DEN','1958110','46300MS002000201','2014-01-01','2013-12-23 10:33:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:17'),(5126,4062,'N','01','021','EC','A',NULL,NULL,'','0001116558','0000894840','','IL','1','Mattick','Stephen','Ray','','III','34','463983705','721 GOLFCREST DR',0,'WINDCREST','TX','78239','2623','CY','48029','1955-07-12','M','',':RET:2106-3','N','021','DEN','2131819','33348TX002000101','2014-01-01','2013-12-18 19:05:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 23:02:05'),(6236,4943,'N','01','021','EC','A',NULL,NULL,'','0000315241','0001006675','','IL','1','King','Kimberly','S','','','34','467410054','1490 E FM 852',0,'WINNSBORO','TX','75494','3810','CY','48499','1962-10-21','F','',':RET:2106-3','N','021','DEN','128983','33348TX002000201','2014-01-01','2013-11-19 10:15:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 00:31:35'),(2540,2067,'Y','18','021','EC','A','','','AC','0000768853','0000768853','OH00000692252','IL','1','OBEID','SULTANEH','A','','','34','291702833','3806 WILDPHEASANT LANE',0,'SYLVANIA','OH','43560',NULL,'CY','39095','1952-08-26','F','M',NULL,'N','021','HLT','957307','92036OH006002601','2014-01-01','2013-12-09 11:22:25','340.00',NULL,NULL,'434.56','94.56','R-OH001','OH0','434.56',NULL,0,'2013-12-25 19:37:01'),(7395,5853,'N','01','021','EC','A',NULL,NULL,'','0001186272','0001016818','','IL','1','DeCastro','Danielle','','','','34','293803042','1586 NORLEDGE RD',0,'AKRON','OH','44305','1343','CY','39153','1983-10-01','F','',':RET:2106-3','N','021','HLT','767508','52664OH151001305','2014-01-01','2013-11-22 23:55:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.11',NULL,0,'2013-12-26 02:16:16'),(16303,13052,'Y','18','021','EC','A','','','AC','0001209318','0001209318','LA00001705347','IL','1','ARABIE','SHANE','','','','34','437257397','2015 PINE CREST AVE',0,'COVINGTON','LA','70433','1011','CY','22103','1976-01-27','M','U',NULL,'N','021','DEN','1543884','18575LA002000201','2014-02-01','2014-01-05 18:13:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:12'),(15908,12739,'N','01','021','EC','A',NULL,NULL,'','0000550086','0001240567','','IL','1','Cole','Laura','L','','','34','315600772','1225 STONEY RD',0,'PEEBLES','OH','45660','9271','CY','39001','1953-01-02','F','',':RET:2106-3','N','021','HLT','1599726','92036OH006000601','2014-02-01','2014-01-02 14:38:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.41',NULL,0,'2014-01-03 02:06:18'),(15706,12565,'Y','18','021','EC','A','','','AC','0001194135','0001194135','OH00000848797','31','1','CRAIG','RICHARD','E','','','34','270489479','P.O.BOX 88',0,'NEW MIDDLETOWN','OH','44442',NULL,'CY','39099','1951-08-24','M','U',NULL,'N','021','HLT','2231207','92036OH005003205','2014-02-01','2013-12-31 14:44:02','551.00',NULL,NULL,'695.41','144.41','R-OH013','OH0','695.41',NULL,1,'2014-01-02 04:35:55'),(7166,5684,'N','19','021','EC','A',NULL,NULL,'','0000870633','0000777681','','IL','1','Yang','Brendon','','','','34','060946706','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','2004-03-11','M','',':RET:2034-7','N','021','HLT','1985187','92036OH003002705','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2013-12-26 01:52:38'),(5802,4609,'Y','18','021','EC','A','','','AC','0000660325','0000660325','TX00000240999','31','1','toups','calvin','','','','34','433192763','null null',0,'LUFKIN','TX','75915','0207','CY','48005','1961-12-09','M','M',':RET:2106-3','N','021','DEN','1505964','33348TX002000201','2014-01-01','2013-12-23 21:06:08','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:47:32'),(13719,10948,'Y','18','021','EC','A','','','AC','0001201895','0001201895','OH00001270689','IL','1','James','Traci','','','','34','285581470','6795 Deerfield Dr',0,'Sagamore Hills','OH','44067',NULL,'CY','39153','1971-11-07','F','U',NULL,'N','021','HLT','1489648','52664OH151001305','2014-01-01','2013-12-23 16:59:32','204.00',NULL,NULL,'295.48','91.48','R-OH012','OH0','295.48',NULL,0,'2013-12-26 13:09:10'),(7491,5926,'Y','18','021','EC','A','','','AC','0000575899','0000575899','OH00000744888','IL','1','Chahal','Bhalinder','Singh','','','34','271176838','9977 Darrow park drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1986-04-28','M','M',':RET:2029-7','N','021','DEN','29264','99734OH005000401','2014-01-01','2013-12-15 14:46:48','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:31:37'),(4898,3886,'Y','18','021','EC','A','','','AC','0000743040','0000743040','OH00000259119','IL','1','Stennett','Shannon','','','','34','291722766','17683 brim rd',0,'Bowling Green','OH','43402',NULL,'CY','39173','1973-02-20','M','M',':RET:2106-3','N','021','DEN','947616','99734OH005000401','2014-01-01','2013-10-26 01:07:49','0.00',NULL,NULL,'71.95','71.95','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:31:45'),(17837,14249,'Y','18','021','EC','A','','','AC','0000632707','0000632707','OH00001376641','31','1','Goolsby','Brenda','','','','34','284443878','P O Box 271',0,'Washington C H','OH','43160',NULL,'CY','39047','1949-07-01','F','U',':RET:2106-3','N','021','DEN','2607503','99734OH005000401','2014-02-01','2014-01-13 19:32:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:02'),(18133,14480,'Y','18','021','EC','A','','','AC','0000542703','0000542703','OH00001549608','IL','1','HUGHETT','JEFFREY','RAY','','','34','295802221','4208 BROOKSIDE AVE',0,'CINCINNATI','OH','45223','2102','CY','39061','1982-04-18','M','M',':RET:2106-3','T','021','HLT','1403598','92036OH004001201','2014-02-01','2014-01-14 17:34:32','95.00',NULL,NULL,'434.27','339.27','R-OH004','OH0','230.07',NULL,0,'2014-01-15 02:07:44'),(21902,17490,'Y','18','021','EC','A','','','AC','0000196171','0000196171','OH00002101927','IL','1','MOON','SUSAN','','','','34','298426048','715 CASTLEGATE LANE UNIT 302',0,'CINCINNATI','OH','45231',NULL,'CY','39061','1951-09-14','F','U',':RET:2106-3','N','021','HLT','2617322','92036OH004001201','2014-03-01','2014-02-06 10:31:55','253.00',NULL,NULL,'495.91','242.91','R-OH004','OH0','495.91',NULL,0,'2014-02-06 21:01:47'),(21955,17532,'Y','18','021','EC','A','','','AC','0001131479','0001131479','OH00002416715','IL','1','Wood','Penny','','','','34','280607284','606 W 6th Street',0,'Marysville','OH','43040',NULL,'CY','39159','1958-11-19','F','U',':RET:2106-3','T','021','DEN','3215454','99734OH005000401','2014-03-01','2014-02-07 09:15:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:23'),(23114,18423,'Y','18','021','EC','A','','','AC','0000175145','0000175145','OH00002742564','IL','1','Akunne','Chinonye','','','','34','271945882','634 W Foulke Ave',0,'Findlay','OH','45840',NULL,'CY','39063','1988-04-13','F','U',':RET:2054-5','N','021','DEN','3190979','99734OH005000401','2014-03-01','2014-02-12 17:18:54','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-12 21:31:20'),(25173,19967,'N','01','021','EC','A',NULL,NULL,'','0000768924','0000123021','','IL','1','Dillon','Joseph','','','','34','288504748','16588 COUNTY ROAD 410',0,'COSHOCTON','OH','43812','9594','CY','39031','1950-03-04','M','',NULL,'T','021','DEN','3763271','99734OH005000401','2014-04-01','2014-02-20 18:23:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:29'),(28504,22556,'Y','18','024','14','A','','','TE','0001196877','0001196877','','IL','1','lindsay','carol',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-03-05','F','',NULL,NULL,NULL,'','3653544','','2014-03-07','2014-03-07 10:41:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:50'),(237,198,'Y','18','021','EC','A','','','AC','0000909451','0000909451','OH00000315880','IL','1','Riester','Catherine','','','','34','279429869','160 QUAIL RD',0,'PERRYSBURG','OH','43551','2563','CY','39173','1953-04-26','F','U',':RET:2106-3','N','021','HLT','551901','92036OH002002601','2014-01-01','2013-12-05 15:25:29','336.00',NULL,NULL,'611.15','275.15','R-OH001','OH0','611.15',NULL,0,'2013-12-25 17:21:12'),(16333,13076,'N','01','021','EC','A',NULL,NULL,'','0001380428','0002192167','','IL','1','Jones','Tyrone','','','','34','437040830','41154 Clearwater Avenue',0,'Gonzales','LA','70737',NULL,'CY','22005','1956-12-08','M','',':RET:2054-5','N','021','DEN','1879623','18575LA002000201','2014-02-01','2014-01-06 17:56:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:02:02'),(871,720,'N','01','021','EC','A',NULL,NULL,'','0001184873','0000885574','','IL','1','Whiteleather','Marcia','','','','34','269423016','726 TWIN OAKS RD',0,'DEERFIELD','OH','44411','9717','CY','39133','1952-02-28','F','',':RET:2106-3','N','021','HLT','1649240','52664OH151001501','2014-01-01','2013-12-16 12:51:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','751.58',NULL,0,'2013-12-25 18:07:27'),(3527,2832,'N','01','021','EC','A',NULL,NULL,'','0000582901','0000814294','','IL','1','Duron','Nicholas','','','','34','467871447','6547 AMBER OAK',0,'SAN ANTONIO','TX','78249','1587','CY','48029','1986-09-19','M','',NULL,'N','021','DEN','1564681','33348TX002000101','2014-01-01','2013-12-21 21:21:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 21:21:24'),(15043,12025,'Y','18','021','EC','A','','','AC','0001780571','0001780571','LA00001602006','IL','1','Young','Jennifer','','','','34','436088352','583 I 10 Mobile Village Rd',0,'Lake Charles','LA','70615',NULL,'CY','22019','1972-07-04','F','U',':RET:2106-3','T','021','DEN','1361352','18575LA002000201','2014-02-01','2013-12-30 13:35:11','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-01 12:03:02'),(8884,7043,'Y','18','024','14','A','','','TE','0000230539','0000230539','','IL','1','GONZALES','MELISSA','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-02-18','F','',NULL,NULL,NULL,'','533691','','2013-12-18','2013-12-18 15:49:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:01:51'),(22643,18080,'N','19','021','EC','A',NULL,NULL,'','0000121927','0000029665','','IL','1','Hoang','Buc','','','','34','640929479','3355 BEACON VIEW CT',0,'PEARLAND','TX','77584',NULL,'CY','48039','1993-10-11','M','',NULL,'N','021','DEN','3827885','33348TX002000201','2014-03-01','2014-02-11 10:26:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-11 21:00:24'),(26101,20701,'Y','18','021','EC','A','','','AC','0001843873','0001843873','LA00003379821','IL','1','Jackson','Lonnie','','','','34','587227789','911 22ND ST',0,'GRETNA','LA','70053','6805','CY','22051','1952-06-04','M','U',NULL,'T','021','DEN','3235974','18575LA002000201','2014-04-01','2014-02-27 16:02:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:13'),(27816,22001,'Y','18','024','14','A','','','TE','0001055377','0001055377','','IL','1','Wright','Kellee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-03-17','F','',NULL,NULL,NULL,'','2943336','','2014-03-04','2014-03-04 18:45:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:31:54'),(28730,22738,'Y','18','021','EC','A','','','AC','0002056834','0002056834','LA00002984408','IL','1','McKeever','Breck','','','','34','439275879','3115 TRANSCONTINENTAL DR',0,'METAIRIE','LA','70006','5154','CY','22051','1964-08-03','M','U',':RET:2106-3','T','021','DEN','3319813','18575LA002000101','2014-04-01','2014-03-09 13:38:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-09 21:00:02'),(6733,5341,'Y','18','021','EC','A','','','AC','0000542639','0000542639','OH00001304508','IL','1','Korn','Jeffery','','','','34','114466728','4463 Broadview Road',0,'Cleveland','OH','44109',NULL,'CY','39035','1964-03-28','M','U',NULL,'N','021','DEN','47146','99734OH005000401','2014-01-01','2013-11-25 12:16:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:15:33'),(16653,13324,'Y','18','024','14','A','','','TE','0000746846','0000746846','','IL','1','Aurelia','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-05','M','',NULL,NULL,NULL,'','1925563','','2014-01-07','2014-01-07 11:39:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-08 18:24:21'),(1076,882,'Y','18','024','14','A','','','TE','0001174374','0001174374','','IL','1','LONGBOTTOM','BARBARA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-01-31','F','',NULL,NULL,NULL,'','1099481','','2013-12-03','2013-12-03 09:20:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:16:39'),(15342,12271,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00000125593','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','1843875','52664OH152000901','2014-02-01','2014-01-01 10:48:21','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,1,'2014-01-02 04:24:16'),(15243,12183,'Y','18','021','EC','A','','','AC','0000904271','0000904271','OH00001387171','IL','1','AMOS','JUDY','','','','34','289421775','160 E BRYANT ST',0,'WAYNE','OH','43466','7069','CY','39173','1949-05-04','F','U',NULL,'N','021','HLT','2510551','92036OH006002601','2014-02-01','2013-12-30 09:50:23','458.00',NULL,NULL,'463.92','5.92','R-OH001','OH0','463.92',NULL,0,'2014-01-01 12:08:41'),(13886,11076,'N','19','021','EC','A',NULL,NULL,'','0000685845','0000954302','','IL','1','Evans','Peter','Alexander','','','34','302029118','18300 PARKLAND DR',0,'SHAKER HEIGHTS','OH','44122','3449','CY','39035','1997-03-03','M','',':RET:2106-3','N','021','HLT','1935254','52664OH151001501','2014-01-01','2013-12-23 17:12:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2013-12-26 13:13:21'),(18929,15083,'Y','18','021','EC','A','','','AC','0000274809','0000274809','OH00001600063','IL','1','HUFFMAN','RENE','G','','','34','262611417','7945 N PALMYRA RD',0,'CANFIELD','OH','44406',NULL,'CY','39099','1965-07-10','F','M',NULL,'N','021','DEN','2271896','99734OH005000401','2014-03-01','2014-01-17 10:32:38','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-01-20 08:05:37'),(19744,15736,'Y','18','024','14','A','','','TE','0000417411','0000417411','','IL','1','Jin','Young',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-03-07','M','',NULL,NULL,NULL,'','2136580','','2014-01-22','2014-01-22 21:52:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:13'),(20687,16530,'Y','18','021','EC','A','','','AC','0001169490','0001169490','OH00001572000','IL','1','williams','stephen','','','','34','290705812','PO Box 91229',0,'Columbus','OH','43209',NULL,'CY','39049','1975-09-24','M','U',NULL,'N','021','DEN','3525256','99734OH005000301','2014-03-01','2014-01-29 20:03:15','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:57'),(20849,16664,'Y','18','021','EC','A','','','AC','0000934695','0000934695','OH00001691535','IL','1','Likens','Erica','','','','34','280825913','3465 FARLEY DR',0,'HILLIARD','OH','43026','1742','CY','39049','1983-03-14','F','U',':RET:2106-3','N','021','DEN','2746469','99734OH005000301','2014-03-01','2014-01-30 23:18:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-31 21:00:51'),(23229,18519,'Y','18','021','EC','A','','','AC','0000254573','0000254573','OH00001549007','IL','1','Tolbert','Rebertha','','','','34','416702706','3360 E SCARBOROUGH RD',0,'CLEVELAND HEIGHTS','OH','44118','3411','CY','39035','1950-12-18','F','U',NULL,'N','021','HLT','3785070','92036OH004000801','2014-03-01','2014-02-12 18:00:34','371.00',NULL,NULL,'554.95','183.95','R-OH011','OH0','554.95',NULL,0,'2014-02-12 21:32:24'),(24098,19156,'Y','18','021','EC','A','','','AC','0000787359','0000787359','MS00001976562','IL','1','Kincaid','Sharita','','','','34','428658059','6300 Old Canton Road',0,'Jackson','MS','39211',NULL,'CY','28049','1988-06-22','F','U',NULL,'N','021','DEN','3134590','46300MS002000201','2014-03-01','2014-02-14 23:17:04','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-15 22:01:29'),(24219,19234,'N','01','021','EC','A',NULL,NULL,'','0001246738','0000533029','','IL','1','FLORES','APRIL','','','','34','455754704','1020 BRIGHTON PL',0,'ROUND ROCK','TX','78665','4044','CY','48491','1982-04-10','F','',NULL,'N','021','DEN','2625358','33348TX002000201','2014-04-01','2014-02-16 00:23:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-16 19:00:27'),(27619,21844,'Y','18','024','14','A','','','TE','0000380069','0000380069','','IL','1','Hall','Juliean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-20','F','',NULL,NULL,NULL,'','2239675','','2014-03-31','2014-03-05 17:52:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-05 21:00:33'),(186,155,'Y','18','021','EC','A','','','AC','0000133286','0000133286','OH00000585548','IL','1','FADEL','PATRICIA','','','','34','130422001','7004 DODGE RD',0,'ROME','OH','44085','9561','CY','39007','1950-08-12','F','U',':RET:2106-3','N','021','HLT','463939','52664OH151001306','2014-01-01','2013-12-05 14:59:17','719.00',NULL,NULL,'742.48','23.48','R-OH011','OH0','742.48',NULL,0,'2013-12-25 17:19:49'),(6615,5245,'Y','18','021','EC','A','','','AC','0000805092','0000805092','OH00000938903','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','HLT','608164','92036OH005001506','2014-01-01','2013-12-11 10:44:09','200.00',NULL,NULL,'649.68','449.68','R-OH002','OH0','649.68',NULL,0,'2013-12-26 00:53:51'),(6464,5122,'Y','18','021','EC','A','','','AC','0000168861','0000168861','OH00000517485','IL','1','PROGOFF','JONATHAN','PHILLIP','','','34','074482623','685-5 CHANDLER PATH',0,'AURORA','OH','44202','9175','CY','39133','1954-06-21','M','U',':RET:2106-3','N','021','HLT','596630','52664OH151001501','2014-01-01','2013-12-11 14:02:00','308.00',NULL,NULL,'696.21','388.21','R-OH012','OH0','696.21',NULL,0,'2013-12-26 00:49:58'),(2069,1694,'Y','18','021','EC','A','','','AC','0000132345','0000132345','LA00001231981','IL','1','Gordon','Keith','','','','34','435274210','57841 LUCKEY ST',0,'PLAQUEMINE','LA','70764','4368','CY','22047','1960-08-26','M','U',':RET:2054-5','N','021','DEN','130329','18575LA002000201','2014-01-01','2013-12-09 18:28:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:20'),(15225,12170,'N','01','021','EC','A',NULL,NULL,'','0002052877','0002095798','','IL','1','Hebert','Lachrissia','','','','34','436042490','10051 LEXINGTON DR',0,'DENHAM SPRINGS','LA','70706','8554','CY','22063','1957-10-03','F','',':RET:2106-3','N','021','DEN','1982953','18575LA002000101','2014-02-01','2013-12-30 15:55:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-01 12:08:08'),(14997,11986,'Y','18','021','EC','A','','','AC','0000842383','0000842383','TX00001741304','IL','1','ransom','rickey','','','','34','457022331','847 RIDGEWAY',0,'TOW','TX','78672','4989','CY','48299','1955-03-28','M','M',':RET:2106-3','N','021','DEN','2198880','33348TX002000201','2014-02-01','2013-12-30 17:28:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:35'),(13852,11053,'N','01','021','EC','A',NULL,NULL,'','0000536920','0000889609','','IL','1','Cavin','Kristen','Nicole','','','34','295827123','3714 Drexel Dr',0,'Toledo','OH','43612',NULL,'CY','39095','1983-11-13','F','',':RET:2106-3','N','021','HLT','1393906','92036OH002002601','2014-01-01','2013-12-23 15:11:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.59',NULL,0,'2013-12-26 13:12:36'),(9259,7343,'Y','18','021','EC','A','','','AC','0000820453','0000820453','TX00000032175','IL','1','Ajeakwa','Thomas','','','','34','622517490','3815 51st  Street',0,'Lubbock','TX','79413',NULL,'CY','48303','1961-06-10','M','M',':RET:2054-5','N','021','DEN','476542','33348TX002000201','2014-01-01','2013-11-30 16:53:10','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 04:15:15'),(5098,4041,'Y','18','021','EC','A','','','AC','0001120622','0001120622','TX00000004300','31','1','Robinson','Barton','','','','34','463946706','po box1954',0,'Rockport','TX','78381',NULL,'CY','48007','1951-10-19','M','M',':RET:2106-3','N','021','DEN','2031279','33348TX002000201','2014-01-01','2013-12-19 16:23:02','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-25 23:01:23'),(4279,3409,'Y','18','021','EC','A','','','AC','0001073132','0001073132','OH00000620230','IL','1','Hostetler','Lance','','','','34','315967019','14110 State Route 116',0,'Van Wert','OH','45891',NULL,'CY','39161','1977-01-06','M','M',':RET:2106-3','N','021','HLT','1958887','92036OH005001504','2014-01-01','2013-12-17 11:34:52','553.00',NULL,NULL,'805.31','252.31','R-OH002','OH0','270.71',NULL,0,'2013-12-25 21:51:59'),(18052,14423,'Y','18','021','EC','A','','','AC','0000088686','0000088686','MS00001592438','31','1','Robinson','Carl','','','','34','587050115','PO bow 365',0,'Bayou','MS','38762',NULL,'CY','28011','1950-04-11','M','M',':RET:2054-5','N','021','DEN','2135358','46300MS002000101','2014-02-01','2014-01-14 13:52:36','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-15 02:07:17'),(25893,20530,'Y','18','021','EC','A','','','AC','0000525623','0000525623','TX00002688260','IL','1','Wear','Vernon','','','','34','461374372','4047 TROPICAL DR',0,'SAN ANTONIO','TX','78218','3429','CY','48029','1962-06-06','M','U',':RET:2106-3','T','021','DEN','3801221','33348TX002000201','2014-04-01','2014-02-26 05:34:18','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-26 21:01:04'),(26124,20718,'Y','18','021','EC','A','','','AC','0000226068','0000226068','OH00002181721','IL','1','NORRIS','JACQULIN','','','','34','270506738','1 EVERGREEN DR',0,'NORWALK','OH','44857','2383','CY','39077','1950-01-01','F','U',':RET:2106-3','N','021','DEN','2997838','99734OH005000401','2014-03-01','2014-02-27 09:44:34','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-28 06:30:20'),(429,352,'Y','18','021','EC','A','','','AC','0000186080','0000186080','OH00000604562','IL','1','YANOVICH','PAUL','','','','34','278503493','8931 SHEPARD RD',0,'MACEDONIA','OH','44056','1957','CY','39153','1952-08-11','M','U',':RET:2106-3','N','021','DEN','817973','99734OH005000401','2014-01-01','2013-12-04 16:33:26','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:46:52'),(4813,3815,'Y','18','021','EC','A','','','AC','0000687198','0000687198','OH00000810104','IL','1','CURTIS','JUANITA','','','','34','386703994','3945 BORDEN ST',0,'CINCINNATI','OH','45223','2401','CY','39061','1975-09-24','F','M',':RET:2054-5','N','021','HLT','204695','92036OH006001201','2014-01-01','2013-12-07 20:41:13','0.00',NULL,NULL,'212.14','212.14','R-OH004','OH0','212.14',NULL,0,'2013-12-25 22:16:51'),(4533,3592,'Y','18','021','EC','A','','','AC','0000530520','0000530520','TX00000469075','IL','1','Trevino','William','','','','34','460678224','310 LANARK DR',0,'SAN ANTONIO','TX','78218','1824','CY','48029','1979-11-24','M','U',':RET:2106-3','N','021','DEN','1249403','33348TX002000201','2014-01-01','2013-12-12 16:25:41','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 22:04:06'),(4513,3577,'Y','18','021','EC','A','','','AC','0000398327','0000398327','TX00001117378','IL','1','Wack','Bryan','','','','34','495966139','7740 SUMMERBROOK CIR',0,'FORT WORTH','TX','76137','5464','CY','48439','1976-01-21','M','U',':RET:2106-3','N','021','DEN','818160','33348TX002000201','2014-01-01','2013-12-12 10:27:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:38'),(28556,22599,'N','01','021','EC','A',NULL,NULL,'','0000435371','0000178961','','IL','1','WALTERS','BILLY','R','','Jr','34','277729353','4821 MEREDITH RD',0,'YELLOW SPRINGS','OH','45387','9734','CY','39057','1976-04-30','M','',':RET:2106-3','N','021','HLT','3945359','92036OH006000501','2014-04-01','2014-03-07 12:55:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.38',NULL,0,'2014-03-07 21:32:23'),(769,635,'Y','18','021','EC','A','','','AC','0000990899','0000990899','TX00000303921','IL','1','Quintanilla','Veronica','','','','34','453650981','4112 GOLDENROD AVE',0,'MCALLEN','TX','78501','3440','CY','48215','1971-11-04','F','R',':RET:2106-3','N','021','DEN','2322439','33348TX002000201','2014-01-01','2013-12-16 12:23:40','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:04:46'),(7508,5940,'Y','18','021','EC','A','','','AC','0000409956','0000409956','LA00000670939','IL','1','BUTLER-GASPER','KATRESE','','','','34','438557317','1228 LEE ST',0,'MARRERO','LA','70072','2346','CY','22051','1976-10-14','F','M',':RET:2054-5','N','021','DEN','1113533','18575LA002000201','2014-01-01','2013-12-14 23:05:34','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:32:02'),(14761,11786,'Y','18','021','EC','A','','','AC','0000925131','0000925131','TX00000261365','IL','1','CHENG','LYDIA','','','','34','555938595','4225 EARLY MORN DR',0,'PLANO','TX','75093','3814','CY','48085','1958-12-27','F','U',':RET:2034-7','N','021','DEN','2188129','33348TX002000201','2014-01-01','2013-12-23 19:38:21','0.00',NULL,NULL,'72.22','72.22','R-TX008','TX0','15.85',NULL,1,'2013-12-29 11:12:42'),(7086,5621,'N','19','021','EC','A',NULL,NULL,'','0000183506','0000768884','','IL','1','Devereux','Charity','Starr','','','34','292927259','188 NORTHPARK DR',0,'WADSWORTH','OH','44281','1310','CY','39103','1988-04-22','F','',':RET:2106-3','N','021','HLT','2532631','52664OH152000901','2014-01-01','2013-12-24 21:43:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','163.99',NULL,0,'2013-12-26 01:50:25'),(14518,11583,'N','01','021','EC','A',NULL,NULL,'','0000751195','0000902181','','IL','1','Urquieta','Elida','','','','34','449117393','2480 Lexington Place',0,'Brownsville','TX','78520',NULL,'CY','48061','1953-05-19','F','',':RET:2106-3','N','021','DEN','1847937','33348TX002000201','2014-02-01','2013-12-27 16:23:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:34:13'),(6449,5112,'N','19','021','EC','A',NULL,NULL,'','0000987374','0001194093','','IL','1','King','Jolene','','','','34','296940381','468 E MAIN ST',0,'PORTAGE','OH','43451','9701','CY','39173','1992-03-31','F','',':RET:2106-3','N','021','HLT','843910','92036OH004002601','2014-01-01','2013-12-10 22:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','156.79',NULL,0,'2013-12-26 00:49:37'),(13201,10534,'Y','18','021','EC','A','','','AC','0000363093','0000363093','TX00000181180','IL','1','bednar','savannah','','','','34','520236420','589 VZ COUNTY ROAD 2717',0,'MABANK','TX','75147','5570','CY','48467','1987-12-18','F','M',':RET:2106-3','N','021','DEN','2061954','33348TX002000101','2014-01-01','2013-12-23 15:24:08','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 12:54:57'),(9066,7195,'Y','18','024','14','A','','','TE','0000713579','0000713579','','IL','1','Hooper','Elizabeth','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-26','F','',NULL,NULL,NULL,'','205854','','2013-12-18','2013-12-18 16:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:06:29'),(9053,7182,'Y','18','021','EC','A','','','AC','0000499568','0000499568','TX00001142225','IL','1','Kimbrell','Robert','','','','34','251989200','604 Airport Rd',0,'La Grange','TX','78945',NULL,'CY','48149','1953-05-01','M','U',':RET:2106-3','N','021','DEN','1729713','33348TX002000101','2014-01-01','2013-12-17 19:02:06','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 04:06:05'),(4246,3382,'Y','18','021','EC','A','','','AC','0000481850','0000481850','TX00001031305','IL','1','McGowan','Latasha','','','','34','458775136','13509 S WAYSIDE DR',0,'HOUSTON','TX','77048','5212','CY','48201','1984-08-15','F','U',':RET:2054-5','N','021','DEN','2111858','33348TX002000201','2014-01-01','2013-12-17 16:59:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:51:09'),(4661,3696,'Y','18','021','EC','A','','','AC','0000785022','0000785022','LA00000815415','IL','1','Lowery','Joyce','','','','34','434041834','12043 Shelton Rd',0,'Bastrop','LA','71220',NULL,'CY','22067','1956-03-01','F','M',':RET:2106-3','N','021','DEN','598912','18575LA002000201','2014-01-01','2013-12-12 11:54:22','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:07:23'),(4907,3892,'Y','18','021','EC','A','','','AC','0000602624','0000602624','TX00001094311','IL','1','Whipkey','Randy','Lee','','','34','455394809','107 W 6th St',0,'Camp Wood','TX','78833',NULL,NULL,NULL,'1968-04-10','M','M',NULL,'T','021','DEN','526983','33348TX002000101','2014-01-01','2013-10-25 18:55:49','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 22:31:59'),(17436,13949,'N','01','021','EC','A',NULL,NULL,'','0001207173','0000058769','','IL','1','Babcock','Elizabeth','','','','34','093461422','414 HILLCREST DR',0,'CINCINNATI','OH','45215','2502','CY','39061','1953-09-29','F','',NULL,'N','021','HLT','1457250','92036OH006001201','2014-02-01','2014-01-10 12:20:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','462.04',NULL,0,'2014-01-13 03:00:33'),(20360,16261,'Y','18','021','EC','A','','','AC','0000702804','0000702804','OH00002470389','IL','1','Pasker','Rodney','','','','34','299588336','527 HIGHLAND CREEK CT',0,'HOLLAND','OH','43528','9794','CY','39095','1965-04-14','M','M',':RET:2054-5','N','021','HLT','3388453','92036OH006002601','2014-03-01','2014-01-28 14:12:40','103.00',NULL,NULL,'252.84','149.84','R-OH001','OH0','252.84',NULL,0,'2014-01-28 21:01:19'),(21469,17156,'Y','18','021','EC','A','','','AC','0000158457','0000158457','MS00001884235','IL','1','Butler','Jerry','','','','34','251354880','104 TERA CT',0,'GULFPORT','MS','39503','3262','CY','28047','1973-09-09','M','U',':RET:2054-5','T','021','DEN','2676808','46300MS002000201','2014-03-01','2014-02-04 12:12:35','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-04 21:01:37'),(24886,19732,'Y','18','021','EC','A','','','AC','0001152250','0001152250','OH00001813256','IL','1','Irby','Melissa','','','','34','226660459','2237 SARATOGA DR',0,'FINDLAY','OH','45840','7400','CY','39063','1954-07-12','F','M',':RET:2106-3','N','021','HLT','3229869','92036OH003001505','2014-04-01','2014-02-19 10:31:39','655.00',NULL,NULL,'828.10','173.10','R-OH002','OH0','598.27','CIC',0,'2014-02-20 05:38:01'),(25533,20255,'N','19','021','EC','A',NULL,NULL,'','0001082303','0000120793','','S1','1','Hernandez','ismael','','','III','34','638277318','1007 SHOFNER ST',0,'KILLEEN','TX','76541','7848','CY','48027','2010-09-21','M','',NULL,'N','021','DEN','2875617','33348TX002000201','2014-04-01','2014-02-23 00:49:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-26 08:00:06'),(25742,20417,'Y','18','021','EC','A','','','AC','0001228110','0001228110','OH00001379912','IL','1','WALKER','RUTH','ELLEN','','','34','273466494','203 E HIGH AVE',0,'NEW PHILADELPHIA','OH','44663',NULL,'CY','39157','1952-07-12','F','U',':RET:2106-3','N','021','DEN','3830637','99734OH005000401','2014-04-01','2014-02-24 13:57:02','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-26 09:30:41'),(559,458,'Y','18','021','EC','A','','','AC','0001169415','0001169415','OH00000706754','IL','1','Tuttle','Richard','','','','34','288466333','957 SUMMIT AVE',0,'GLENDALE','OH','45246','4324','CY','39061','1951-02-06','M','U',':RET:2106-3','N','021','HLT','340609','92036OH004001201','2014-01-01','2013-12-04 06:19:09','355.00',NULL,NULL,'495.91','140.91','R-OH004','OH0','495.91',NULL,0,'2013-12-25 17:50:14'),(6079,4818,'Y','18','021','EC','A','','','AC','0000201895','0000201895','OH00000821137','IL','1','Heberlein','Dean','','','','34','298844573','10342 E BAYSHORE RD',0,'MARBLEHEAD','OH','43440','2313','CY','39123','1970-07-25','M','U',':RET:2106-3','N','021','HLT','283043','92036OH003002706','2014-01-01','2013-12-01 11:20:49','221.00',NULL,NULL,'276.33','55.33','R-OH006','OH0','276.33',NULL,0,'2013-12-26 00:02:24'),(1192,981,'Y','18','021','EC','A','','','AC','0001010175','0001010175','OH00000326507','IL','1','Donley','Bertram','','','','34','114446114','2559 Hilton Drive',0,'Kettering','OH','45409',NULL,'CY','39113','1952-04-06','M','U',':RET:2106-3','N','021','DEN','229242','99734OH005000301','2014-01-01','2013-12-03 10:44:19','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:19:37'),(14463,11540,'Y','18','021','EC','A','','','AC','0001046845','0001046845','OH00000237284','IL','1','Smith','Mitchell','','','','34','290822329','8665 twp. Rd. 460',0,'Loudonville','OH','44842',NULL,'CY','39075','1974-09-28','M','U',':RET:2106-3','N','021','HLT','2457331','52664OH151001501','2014-02-01','2013-12-27 13:41:53','141.00',NULL,NULL,'337.54','196.54','R-OH014','OH0','337.54',NULL,0,'2013-12-28 03:32:51'),(5867,4655,'N','01','021','EC','A',NULL,NULL,'','0000858492','0000776431','','IL','1','Warnick','Matt','','','','34','271728980','1520 N HAMETOWN RD',0,'AKRON','OH','44333','1058','CY','39153','1976-09-11','M','',':RET:2106-3','T','021','HLT','2518207','52664OH152000901','2014-01-01','2013-12-23 22:53:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','232.55',NULL,0,'2013-12-25 23:49:07'),(5594,4439,'Y','18','021','EC','A','','','AC','0000063936','0000063936','LA00000403824','IL','1','Woods','Cheylon','','','','34','621463379','550 Lee Drive',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1987-03-20','F','U',':RET:2054-5','N','021','DEN','63781','18575LA002000201','2014-01-01','2013-11-25 18:21:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:30:03'),(3598,2885,'Y','18','024','14','A','','','TE','0000271399','0000271399','','IL','1','Wuest','Frances',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-04','F','',NULL,NULL,NULL,'','910914','','2013-12-22','2013-12-22 11:30:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:23:11'),(4792,3800,'N','19','021','EC','A',NULL,NULL,'','0000229411','0000373602','','IL','1','Lim-Bonner','Ian','','','','34','269966773','900 ELMORE AVE',0,'AKRON','OH','44302','1239','CY','39153','1992-01-20','M','',':RET:2034-7^:RET:2106-3','N','021','HLT','35841','52664OH151001304','2014-01-01','2013-12-08 13:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-25 22:16:19'),(19667,15672,'Y','18','021','EC','A','','','AC','0002031693','0002031693','LA00001724257','IL','1','Schaffer','Charity','','','','34','434733541','828 S. 17th St.',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1984-04-05','F','U',':RET:2054-5^:RET:2028-9','N','021','DEN','2572879','18575LA002000101','2014-03-01','2014-01-23 08:47:45','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-23 21:00:29'),(22194,17714,'Y','18','021','EC','A','','','AC','0001204959','0001204959','TX00002066202','IL','1','Ingram','Alvin','','','','34','134502652','2915 INTREPID ELM ST',0,'HOUSTON','TX','77084','4290','CY','48201','1961-01-24','M','U',':RET:2054-5','N','021','DEN','3639420','33348TX002000201','2014-03-01','2014-02-09 15:37:43','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-09 19:00:11'),(10,8,'N','19','021','EC','A',NULL,NULL,'','0000132043','0001156186','','IL','1','Beal','Molly','','','','34','282986081','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1995-05-18','F','',':RET:2106-3','N','021','DEN','938477','99734OH005000401','2014-01-01','2013-12-04 23:45:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:15:16'),(906,751,'Y','18','021','EC','A','','','AC','0000708920','0000708920','OH00000888290','IL','1','Thompson','Mia','','','','34','286706480','5627 KIRBY AVE',0,'CINCINNATI','OH','45239','7228','CY','39061','1970-12-26','F','U',':RET:2054-5','N','021','HLT','1611321','92036OH004001201','2014-01-01','2013-12-16 16:04:02','65.00',NULL,NULL,'234.23','169.23','R-OH004','OH0','234.23',NULL,0,'2013-12-25 18:08:25'),(14258,11372,'Y','18','021','EC','A','','','AC','0001955054','0001955054','LA00000772225','IL','1','RIvas','James','','','','34','437198568','6350 GENERAL DIAZ ST',0,'NEW ORLEANS','LA','70124','3104','CY','22071','1962-05-20','M','M',':RET:2106-3','N','021','DEN','1364249','18575LA002000101','2014-02-01','2013-12-26 11:41:10','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-27 02:05:43'),(6229,4937,'N','01','021','EC','A',NULL,NULL,'','0000550032','0000873209','','IL','1','Freeland','Kimberly','Sue','','','34','294629867','8970 LANCASTER THORNVILLE RD NE',0,'PLEASANTVILLE','OH','43148','9763','CY','39045','1957-06-25','F','',':RET:2106-3','T','021','DEN','1183858','99734OH005000401','2014-01-01','2013-11-19 15:45:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:31:23'),(13552,10807,'Y','18','021','EC','A','','','AC','0001179678','0001179678','LA00001357954','IL','1','porter','asia','','','','34','435354442','4378 THURGOOD CIR',0,'SHREVEPORT','LA','71109','6827','CY','22017','1978-05-20','F','U',':RET:2054-5','N','021','DEN','1707124','18575LA002000201','2014-01-01','2013-12-23 15:10:52','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:04:07'),(5695,4519,'Y','18','024','14','A','','','TE','0000865825','0000865825','','IL','1','Harris','Janet',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-09-20','F','',NULL,NULL,NULL,'','615861','','2013-11-26','2013-11-26 15:56:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:32:44'),(9356,7416,'Y','18','021','EC','A','','','AC','0002078408','0002078408','LA00000261156','IL','1','Carlton','Barbara','W','','','34','149400876','61 S WREN ST',0,'NEW ORLEANS','LA','70124','4113','CY','22071','1950-09-11','F','U',':RET:2106-3','T','021','DEN','1829711','18575LA002000201','2014-01-01','2013-12-21 00:43:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:23'),(7978,6316,'Y','18','021','EC','A','','','AC','0000427620','0000427620','OH00001239258','IL','1','Heckert','Tara','','','','34','269905160','147 HALE ST',0,'MOGADORE','OH','44260','1112','CY','39153','1985-09-07','F','U',':RET:2106-3','N','021','HLT','2262228','52664OH151001306','2014-01-01','2013-12-20 13:31:53','191.00',NULL,NULL,'242.41','51.41','R-OH012','OH0','242.41',NULL,0,'2013-12-26 03:07:52'),(5647,4480,'Y','18','021','EC','A','','','AC','0000074873','0000074873','TX00001170567','IL','1','pinon','natividad','','','','34','451953077','1001 w 1st',0,'littlefield','TX','79339',NULL,'CY','48279','1972-06-16','M','M',NULL,'N','021','DEN','137599','33348TX002000201','2014-01-01','2013-11-26 11:44:09','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:31:25'),(18937,15090,'Y','18','024','14','A','','','TE','0001184909','0001184909','','IL','1','Boring','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-12','M','',NULL,NULL,NULL,'','1905335','','2014-01-16','2014-01-16 22:09:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:05:42'),(23415,18656,'Y','18','021','EC','A','','','AC','0000219826','0000219826','TX00001588172','IL','1','JANES','NORMA','','','','34','765235242','11607 PELLICANO',0,'EL PASO','TX','79936',NULL,'CY','48141','1971-03-21','F','U',NULL,'N','021','DEN','3569362','33348TX002000201','2014-03-01','2014-02-12 20:23:56','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-13 22:01:18'),(24367,19353,'Y','18','021','EC','A','','','AC','0002250144','0002250144','LA00002878468','IL','1','Sanders','Albert','','','','34','437152721','48318 WHISKEY LN',0,'TICKFAW','LA','70466','2750','CY','22105','1958-08-03','M','U',':RET:2106-3','N','021','DEN','3463294','18575LA002000201','2014-04-01','2014-02-18 13:53:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-18 22:00:35'),(5505,4371,'Y','18','024','14','A','','','TE','0000905572','0000905572','','IL','1','Such','Teri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-03','F','',NULL,NULL,NULL,'','205813','','2013-12-19','2013-12-19 18:31:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:11:27'),(2257,1850,'Y','18','021','EC','A','','','AC','0000744408','0000744408','OH00000090961','IL','1','Lingafelter','Ruth','','','','34','287588571','3331 WINDING CREEK DR',0,'COLUMBUS','OH','43223','3561','CY','39049','1954-05-26','F','U',':RET:2106-3','N','021','DEN','99493','99734OH005000301','2014-01-01','2013-12-09 05:53:08','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:12'),(16614,13291,'Y','18','021','EC','A','','','AC','0000181025','0000181025','OH00001565078','IL','1','FLOYD','KIMBERLY','','','','34','297687670','1231 ROGERS AVE SE',0,'WARREN','OH','44484','4361','CY','39155','1968-09-27','F','M',NULL,'N','021','DEN','1488943','99734OH005000401','2014-02-01','2014-01-07 10:41:53','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2014-01-08 18:24:09'),(16406,13128,'Y','18','024','14','A','','','TE','0000807245','0000807245','','IL','1','HARRIS','JANE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-11','F','',NULL,NULL,NULL,'','2307095','','2014-01-06','2014-01-06 14:07:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-07 04:04:04'),(16185,12958,'Y','18','021','EC','A','','','AC','0000657564','0000657564','TX00001034380','IL','1','Wilkerson','Brenda','G','','','34','460611113','13286 FM 1013 RD',0,'SPURGER','TX','77660','5032','CY','48457','1965-09-14','F','U',':RET:2106-3','N','021','DEN','1839701','33348TX002000201','2014-02-01','2014-01-03 21:18:38','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-05 00:00:40'),(14470,11546,'Y','18','021','EC','A','','','AC','0000478205','0000478205','TX00000553514','IL','1','mancine','steven','','','','34','007469873','4302 SW 51ST AVE',0,'AMARILLO','TX','79109','6162','CY','48381','1950-07-30','M','M',':RET:2106-3','N','021','DEN','2105321','33348TX002000201','2014-02-01','2013-12-26 19:07:35','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-28 03:33:00'),(21412,17114,'Y','18','021','EC','A','','','AC','0001228088','0001228088','OH00002032553','IL','1','scarborough','jon','','','','34','300545501','2649 TOPEKA ST',0,'CINCINNATI','OH','45231','2238','CY','39061','1954-03-28','M','M',NULL,'N','021','DEN','3614195','99734OH005000401','2014-03-01','2014-02-04 16:50:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:09'),(24052,19129,'Y','18','021','EC','A','','','AC','0001248382','0001248382','OH00002258631','IL','1','OSBORNE','IVY','','','','34','299828244','4212 NORTHRIDGE RD',0,'ALEXANDRIA','OH','43001','9769','CY','39089','1970-05-11','F','M',':RET:2106-3','N','021','DEN','2764867','99734OH005000301','2014-03-01','2014-02-15 11:44:25','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:01:05'),(24875,19723,'Y','18','024','14','A','','','TE','0000630413','0000630413','','IL','1','GANTZ','MARGIE','I',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-10-22','F','',NULL,NULL,NULL,'','2928555','','2014-03-31','2014-02-19 09:22:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:34:22'),(6932,5503,'N','01','021','EC','A',NULL,NULL,'','0000301895','0000092527','','IL','1','Wallace','Mark','F','','','34','300621378','890 N HUNTINGTON ST',0,'MEDINA','OH','44256','1523','CY','39103','1958-06-08','M','',':RET:2106-3','N','021','DEN','1462174','99734OH005000401','2014-01-01','2013-12-24 20:03:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:46:33'),(3138,2523,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00000816426','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','716280','33348TX002000201','2014-01-01','2013-11-17 19:21:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:45'),(5083,4028,'N','01','021','EC','A',NULL,NULL,'','0000678495','0000638463','','IL','1','Applewhite','Judy','','','','34','457941130','1113 E RIO GRANDE ST',0,'PEARSALL','TX','78061','4427','CY','48163','1951-02-16','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','2262193','33348TX002000201','2014-01-01','2013-12-19 14:25:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:00:59'),(3156,2538,'N','01','021','EC','A',NULL,NULL,'','0000977902','0001149837','','IL','1','Seay','Tia','','','','34','295928585','1011 Arrowhead Drive',0,'Oxford','OH','45056',NULL,'CY','39017','1984-01-17','F','',':RET:2054-5','N','021','DEN','84217','99734OH005000401','2014-01-01','2013-11-17 20:56:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:31:10'),(5151,4083,'N','01','021','EC','A',NULL,NULL,'','0000312173','0000313232','','IL','1','HATTON','KATHY','','','','34','282508323','1816 FERNWOOD ST',0,'MIDDLETOWN','OH','45044','6432','CY','39017','1951-03-26','F','',':RET:2106-3','N','021','DEN','1527675','99734OH005000401','2014-01-01','2013-12-19 09:49:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:02:48'),(3184,2560,'N','01','021','EC','A',NULL,NULL,'','0000204763','0000343134','','IL','1','HARLOW','CHRISTIAN','A','','','34','275863077','113 DUNLEITH DR',0,'DESTREHAN','LA','70047','2026','CY','22089','1974-11-29','M','',':RET:2106-3','N','021','DEN','446612','18575LA002000201','2014-01-01','2013-11-18 17:34:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 20:31:56'),(19497,15539,'Y','18','021','EC','A','','','AC','0000879514','0000879514','OH00001506972','IL','1','Sanford','Kile','','','','34','299821682','232 WOODROW ST NW',0,'NORTH CANTON','OH','44720','1936','CY','39151','1979-05-08','M','U',':RET:2106-3','N','021','HLT','1377786','52664OH151001305','2014-03-01','2014-01-22 14:52:45','173.00',NULL,NULL,'270.73','97.73','R-OH015','OH0','270.73',NULL,0,'2014-01-23 03:02:08'),(25229,20011,'N','01','021','EC','A',NULL,NULL,'','0001032656','0000413410','','IL','1','Gardner','Cynthia','','','','34','284467876','1230 STATE ROUTE 96',0,'ASHLAND','OH','44805','1069','CY','39005','1953-01-14','F','',':RET:2106-3','N','021','HLT','2699516','52664OH151001301','2014-04-01','2014-02-21 14:25:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-02-21 22:01:01'),(25601,20312,'Y','18','021','EC','A','','','AC','0001793447','0001793447','LA00002699887','IL','1','Taylor','Kema','','','','34','434752610','141 SCOTT LN',0,'HOUMA','LA','70364','3063','CY','22109','1987-09-18','F','U',':RET:2054-5','N','021','DEN','3201717','18575LA002000201','2014-03-01','2014-02-23 15:42:33','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61','CIC',0,'2014-02-26 08:00:51'),(28454,22516,'Y','18','021','EC','A','','','AC','0001974573','0001974573','LA00003199426','IL','1','DE HERNANDEZ','SUYAPA',NULL,NULL,NULL,NULL,NULL,'12743 ROE DR',0,'WALKER','LA','70785','5536','CY','22063','1969-06-08','F','M',':RET:2106-3','N','021','DEN','3562425','18575LA002000201','2014-04-01','2014-03-07 12:49:12','0.00',NULL,NULL,'67.44','67.44','R-LA005','LA0','14.61',NULL,0,'2014-03-07 21:31:22'),(3385,2714,'Y','18','021','EC','A','','','AC','0000245836','0000245836','TX00001069209','31','1','wheaton','harvey','','','','34','548824873','P. O. Box 902',0,'Navasota','TX','77868',NULL,'CY','48185','1949-11-23','M','M',NULL,'N','021','DEN','2107773','33348TX002000201','2014-01-01','2013-12-22 18:22:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:37'),(24095,19154,'N','01','021','EC','A',NULL,NULL,'','0000262774','0001058037','','IL','1','Doerrer','Andrew','Guy','','','34','272643352','600 COUNTRY CLUB LN',0,'ASHLAND','OH','44805','4237','CY','39005','1958-03-30','M','',':RET:2106-3','N','021','HLT','2650091','52664OH151001301','2014-03-01','2014-02-15 16:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-02-15 22:01:27'),(6969,5531,'Y','18','021','EC','A','','','AC','0000073947','0000073947','OH00000785376','IL','1','Teeter','Susan','','','','34','180560240','9211 Deercross Pkwy 1B',0,'Cincinnati','OH','45236',NULL,'CY','39061','1962-08-02','F','M',':RET:2106-3','N','021','DEN','1655274','99734OH005000401','2014-01-01','2013-12-24 23:05:26','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:25'),(14840,11850,'N','01','021','EC','A',NULL,NULL,'','0000614111','0001063243','','IL','1','Golden','Stephen','','','','34','284663233','6028 PINEMOOR  STREET',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1968-05-02','M','',':RET:2106-3','T','021','DEN','1653797','99734OH005000301','2014-01-01','2013-12-23 20:35:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:14:48'),(16888,13513,'Y','18','021','EC','A','','','AC','0000080973','0000080973','TX00002429892','IL','1','Keily','Virginia','Katherine','','','34','454110421','8807 COASTAL DR',0,'AUSTIN','TX','78749','4922','CY','48453','1956-01-29','F','U',NULL,'N','021','DEN','1627706','33348TX002000201','2014-02-01','2014-01-09 13:17:45','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:19:25'),(19904,15874,'Y','18','024','14','A','','','TE','0000680851','0000680851','','IL','1','Oliver','Tracy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-06-28','F','',NULL,NULL,NULL,'','2315929','','2014-01-24','2014-01-24 08:49:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:57'),(18217,14540,'Y','18','021','EC','A','','','AC','0000333889','0000333889','OH00002260221','IL','1','ROSENBROOK','ELIZABETH','','','','34','302620056','4810 PICKLE RD',0,'OREGON','OH','43616','5618','CY','39095','1966-03-22','F','R',':RET:2106-3','N','021','HLT','2271793','92036OH004002601','2014-02-01','2014-01-14 18:00:49','0.00',NULL,NULL,'650.69','650.69','R-OH001','OH0','245.07',NULL,0,'2014-01-15 02:08:12'),(27356,21664,'Y','18','021','EC','A','','','AC','0000911822','0000911822','OH00003580963','IL','1','WOOD','ANDREW','','','','34','269844196','1809 FLESHER AVE',0,'KETTERING','OH','45420','2916','CY','39113','1985-03-05','M','U',':RET:2106-3','N','021','DEN','2963422','99734OH005000401','2014-04-01','2014-03-04 14:56:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-04 21:01:08'),(15,11,'Y','18','021','EC','A','','','AC','0001029333','0001029333','OH00000635146','IL','1','Toney','Donna','','','','34','276549616','41 Towne Commons way',0,'Cincinnati','OH','45215',NULL,'CY','39061','1953-11-13','F','U',':RET:2106-3','N','021','DEN','10940','99734OH005000401','2014-01-01','2013-12-05 09:39:54','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:22'),(2522,2056,'Y','18','021','EC','A','','','AC','0000232632','0000232632','OH00001049586','IL','1','Schilling','Kim','','','','34','279703918','2914 MAYFAIR RD',0,'AKRON','OH','44312','5432','CY','39153','1965-03-23','F','M',':RET:2106-3','N','021','HLT','917086','52664OH152000901','2014-01-01','2013-12-09 13:53:13','222.00',NULL,NULL,'495.25','273.25','R-OH012','OH0','267.06',NULL,0,'2013-12-25 19:36:37'),(7952,6292,'Y','18','021','EC','A','','','AC','0001951048','0001951048','LA00000367148','IL','1','Patin','Jonathan','','','','34','437630602','7231 MOSSPOINT LN',0,'DENHAM SPRINGS','LA','70706','1965','CY','22063','1986-09-08','M','U',':RET:2106-3','N','021','DEN','1573313','18575LA002000201','2014-01-01','2013-12-20 18:11:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:07:11'),(7821,6195,'N','01','021','EC','A',NULL,NULL,'','0000029449','0000829304','','IL','1','Luckey','Suni','Darlene','','','34','464616587','121 N FAULKNER ST',0,'PAMPA','TX','79065','6114','CY','48179','1970-01-05','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','2079738','33348TX002000201','2014-01-01','2013-12-20 18:24:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:04:11'),(4220,3358,'Y','18','021','EC','A','','','AC','0000838399','0000838399','TX00000982420','IL','1','Leavell','Scott','M','','','34','372884837','5323 RIDGECREST DR',0,'WICHITA FALLS','TX','76310','3493','CY','48485','1980-11-28','M','U',':RET:2106-3','N','021','DEN','2097020','33348TX002000201','2014-01-01','2013-12-17 10:39:37','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 21:50:23'),(23493,18714,'Y','18','021','EC','A','','','AC','0000569361','0000569361','OH00001806308','IL','1','Odell','Tonyia','','','','34','401110641','1080 TURNER RD',0,'LYNCHBURG','OH','45142','9640','CY','39027','1971-08-05','F','U',':RET:2106-3','N','021','HLT','3033014','92036OH005000604','2014-03-01','2014-02-12 21:05:45','51.00',NULL,NULL,'284.44','233.44','R-OH005','OH0','284.44',NULL,0,'2014-02-13 22:02:03'),(5139,4073,'Y','18','021','EC','A','','','AC','0000996520','0000996520','OH00001195642','IL','1','Madaras','Daneen','S','','','34','285563958','3301 PRISCILLA AVE',0,'PARMA','OH','44134','4236','CY','39035','1961-06-16','F','U',':RET:2106-3','N','021','DEN','2239046','99734OH005000401','2014-01-01','2013-12-18 19:46:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:02:28'),(20499,16377,'Y','18','021','EC','A','','','AC','0002377660','0002377660','LA00001473118','IL','1','ZABACK','ABRAHAM','J','','','34','114502808','12385 PECAN ISLAND RD',0,'JARREAU','LA','70749','3217','CY','22077','1958-12-02','M','M',NULL,'N','021','DEN','2946099','18575LA002000201','2014-03-01','2014-01-29 13:14:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-29 21:01:12'),(15088,12060,'N','01','021','EC','A',NULL,NULL,'','0001236600','0001154987','','IL','1','Valluzzi','Jerri','Lynn','','','34','460217841','2010 SE 21st Street',0,'Mineral Wells','TX','76067',NULL,'CY','48363','1958-01-10','F','',':RET:2106-3','N','021','DEN','1736632','33348TX002000101','2014-02-01','2013-12-30 18:40:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-01 12:04:23'),(13501,10760,'Y','18','021','EC','A','','','AC','0000876493','0000876493','FL00000868604','IL','1','BAREHERENY','TILBRUN','JR','','','34','770427516','4226 W 52ND PLACE',0,'ERADEN','FL','44210',NULL,'CY','39153','1972-12-28','M','M',NULL,'N','021','DEN','2480685','99734OH005000301','2014-01-01','2013-12-23 07:13:02','0.00',NULL,NULL,'42.26','42.26','R-OH012','FL0','0.00',NULL,0,'2013-12-26 13:02:36'),(4290,3413,'Y','18','021','EC','A','','','AC','0000869506','0000869506','MS00000784795','IL','1','Johnson','Lakeishia','','','','34','426238768','237 Baker Lane',0,'Brandon','MS','39047',NULL,'CY','28121','1974-09-26','F','M',':RET:2054-5','N','021','DEN','1474854','46300MS002000201','2014-01-01','2013-12-16 21:33:28','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:52:09'),(25840,20484,'Y','18','021','EC','A','','','AC','0000521019','0000521019','OH00003335790','IL','1','Adkins','Johnny','','','','34','279541306','540 S WALNUT ST',0,'ORRVILLE','OH','44667','2236','CY','39169','1955-03-15','M','M',':RET:2106-3','T','021','HLT','3812419','52664OH152000901','2014-03-01','2014-02-26 08:32:25','101.00',NULL,NULL,'478.62','377.62','R-OH014','OH0','478.62',NULL,0,'2014-02-26 21:00:34'),(28229,22334,'N','01','021','EC','A',NULL,NULL,'','0001204586','0000236326','','IL','1','Habli','firas','','','','34','290110182','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','1976-01-05','M','',NULL,'N','021','DEN','2969726','99734OH005000301','2014-04-01','2014-03-06 15:47:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-06 21:30:22'),(962,790,'Y','18','021','EC','A','','','AC','0000903472','0000903472','TX00000548721','IL','1','Alexander','Princesa','','','','34','449021116','5418 FLO DR',0,'WICHITA FALLS','TX','76302','5134','CY','48485','1953-12-03','F','U',':RET:2106-3','N','021','DEN','810640','33348TX002000201','2014-01-01','2013-10-29 07:50:37','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:09:48'),(5178,4109,'Y','18','021','EC','A','','','AC','0000714933','0000714933','OH00000273069','IL','1','Truong','Michael','','','','34','298780493','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','1965-06-01','M','M',':RET:2047-9','N','021','DEN','2460550','99734OH005000401','2014-01-01','2013-12-19 12:37:00','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:29'),(21202,16942,'Y','18','021','EC','A','','','AC','0001396000','0001396000','LA00001440996','IL','1','Mims','Darrell','','','','34','438814400','1119 S. Tonti Street',0,'New Orleans','LA','70125',NULL,'CY','22071','1991-06-05','M','U',':RET:2054-5','N','021','DEN','3381495','18575LA002000201','2014-03-01','2014-02-03 05:45:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:00:54'),(4438,3528,'Y','18','024','14','A','','','TE','0001225689','0001225689','','IL','1','Hanzel','Matthew','Alan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-12','M','',NULL,NULL,NULL,'','465277','','2013-12-11','2013-12-11 18:54:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:06'),(16437,13151,'N','01','021','EC','A',NULL,NULL,'','0000137584','0001062130','','IL','1','Kost','Liesa','M','','','34','295664067','2462 STROUP RD',0,'ATWATER','OH','44201','9100','CY','39133','1959-07-16','F','',':RET:2106-3','T','021','HLT','2111229','52664OH152000901','2014-02-01','2014-01-06 14:03:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.04',NULL,0,'2014-01-07 04:05:00'),(20101,16038,'Y','18','021','EC','A','','','AC','0001451369','0001451369','LA00002129829','IL','1','Hartley','Charles','Edward','','','34','437824028','13005 BETHANY STATE LINE RD',0,'BETHANY','LA','71007','9768','CY','22017','1950-12-07','M','M',':RET:2106-3','T','021','DEN','2979951','18575LA002000201','2014-03-01','2014-01-27 13:24:50','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-27 21:00:35'),(19763,15754,'N','19','021','EC','A',NULL,NULL,'','0001090011','0000215323','','IL','1','perkins','nuriel','','','','34','415891673','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','2000-10-17','F','',':RET:2054-5','N','021','DEN','2486451','46300MS002000101','2014-03-01','2014-01-23 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','47.10',NULL,0,'2014-01-23 21:01:25'),(18747,14938,'N','19','021','EC','A',NULL,NULL,'','0000397371','0000997782','','IL','1','Marini','Julie','','','','34','286965045','1999 W RIDGEWOOD DR',0,'PARMA','OH','44134','4822','CY','39035','1993-06-18','F','',':RET:2106-3','N','021','DEN','1403670','99734OH005000301','2014-02-01','2014-01-15 20:39:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:42'),(16844,13475,'Y','18','021','EC','A','','','AC','0000678117','0000678117','OH00002044804','IL','1','DeLand','Patricia','','','','34','281607617','876 CORDOVA DR',0,'BARBERTON','OH','44203','8658','CY','39153','1958-01-15','F','R',':RET:2106-3','N','021','HLT','2656865','52664OH151001501','2014-02-01','2014-01-11 10:27:31','0.00',NULL,NULL,'1248.00','1248.00','R-OH012','OH0','624.00',NULL,0,'2014-01-13 02:18:35'),(24911,19751,'Y','18','021','EC','A','','','AC','0000081330','0000081330','OH00002435609','IL','1','Case','Thomas','Arthur','','','34','283546600','1279 Wildwood Road',0,'Toledo','OH','43614',NULL,'CY','39095','1953-04-03','M','M',':RET:2106-3','T','021','DEN','3709661','99734OH005000401','2014-04-01','2014-02-20 15:51:13','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00','CIC',0,'2014-02-20 21:30:08'),(469,382,'Y','18','021','EC','A','','','AC','0000754540','0000754540','OH00001057131','IL','1','Zink','Gail','Lee','','','34','274540846','1211 Dussel Rd.',0,'Kent','OH','44240',NULL,'CY','39133','1953-01-17','F','M',':RET:2106-3','N','021','HLT','962106','52664OH151001305','2014-01-01','2013-12-04 16:30:04','452.00',NULL,NULL,'605.24','153.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 17:47:48'),(21468,17155,'Y','18','021','EC','A','','','AC','0000498643','0000498643','MS00001970431','IL','1','Thomas','Zariale','','','','34','428650556','5256 ROMANY DR',0,'JACKSON','MS','39211','4837','CY','28049','1989-04-27','F','U',':RET:2054-5','N','021','DEN','2658557','46300MS002000201','2014-03-01','2014-02-04 11:47:33','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-04 21:01:37'),(24417,19395,'Y','18','021','EC','A','','','AC','0000201967','0000201967','OH00002698565','IL','1','Murphy','Amy','','','','34','288566487','7071 Brakeman Rd',0,'Painesville','OH','44077',NULL,'CY','39085','1960-10-28','F','U',':RET:2106-3','N','021','DEN','3323099','99734OH005000301','2014-04-01','2014-02-18 12:28:47','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:01:05'),(22906,18258,'Y','18','021','EC','A','','','AC','0000850541','0000850541','OH00002484767','IL','1','Lewis','Cynthia','','','','34','276488742','2111 GLEN ARBOR DR',0,'TOLEDO','OH','43614','3210','CY','39095','1949-09-17','F','U',':RET:2106-3','T','021','HLT','2908945','92036OH004002601','2014-03-01','2014-02-11 15:03:31','431.00',NULL,NULL,'540.92','109.92','R-OH001','OH0','540.92',NULL,0,'2014-02-11 21:02:45'),(1439,1201,'Y','18','021','EC','A','','','AC','0000361553','0000361553','MS00001291513','IL','1','king','Rosie','','','','34','587821856','111 DELTA BLUES ST',0,'INDIANOLA','MS','38751','3603','CY','28133','1958-08-18','F','U',':RET:2054-5','N','021','DEN','1692293','46300MS002000101','2014-01-01','2013-12-24 16:21:38','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 18:47:48'),(14691,11729,'Y','18','021','EC','A','','','AC','0000986014','0000986014','OH00001847034','IL','1','Gipson','Tracy','','','','34','289604888','229 West 37th Street',0,'Lorain','OH','44052',NULL,'CY','39093','1972-03-23','F','U',':RET:2106-3','N','021','DEN','1604438','99734OH005000401','2014-02-01','2013-12-27 18:54:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:08:48'),(14504,11571,'Y','18','021','EC','A','','','AC','0000449392','0000449392','TX00001239679','IL','1','Montano','Willy','','','','34','449988570','6803 MICHELLE DR',0,'AMARILLO','TX','79109','7419','CY','48381','1952-12-27','M','M',':RET:2106-3','N','021','DEN','2504523','33348TX002000201','2014-02-01','2013-12-27 14:39:42','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-28 03:33:53'),(24674,19583,'Y','18','021','EC','A','','','AC','0001025549','0001025549','OH00002678294','IL','1','Parker','Robert','','','','34','289829447','518 E SANDUSKY ST',0,'FINDLAY','OH','45840','5920','CY','39063','1984-12-11','M','U',':RET:2106-3','T','021','HLT','3033150','92036OH004001501','2014-04-01','2014-02-18 20:44:05','153.00',NULL,NULL,'227.73','74.73','R-OH002','OH0','227.73',NULL,0,'2014-02-20 04:27:48'),(28563,22605,'N','19','021','EC','A',NULL,NULL,'','0000130763','0000722710','','S1','1','Henderson','Michelle','A','','','34','541913438','4132 ROUTT LN',0,'FRANKLIN','OH','45005','4648','CY','39165','2012-09-13','M','',':RET:2106-3','N','021','HLT','3450176','92036OH003001205','2014-04-01','2014-03-07 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-07 21:32:27'),(13,9,'Y','18','021','EC','A','','','AC','0000626708','0000626708','OH00001184128','IL','1','Zaher','Mark','','','','34','288580404','5721 Newton Falls Rd.',0,'Ravenna','OH','44266',NULL,'CY','39133','1956-09-27','M','U',':RET:2106-3','T','021','DEN','263940','99734OH005000401','2014-01-01','2013-12-05 07:22:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:18'),(1157,954,'N','01','021','EC','A',NULL,NULL,'','0000312360','0000004979','','IL','1','LANDRY','MICHAEL','ANTHONY','','','34','381625116','43245 SYCAMORE BEND AVE',0,'GONZALES','LA','70737','7782','CY','22005','1956-05-10','M','',':RET:2106-3','N','021','DEN','1217625','18575LA002000201','2014-01-01','2013-12-03 14:16:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:18:47'),(2274,1857,'N','19','021','EC','A',NULL,NULL,'','0001085590','0001166783','','IL','1','Dunn','Douglas','R',NULL,NULL,NULL,NULL,'515 Martha Drive',0,'Franklin','OH','45005',NULL,'CY','39165','2006-06-21','M','',':RET:2106-3','N','021','DEN','623334','99734OH005000301','2014-01-01','2013-12-09 12:09:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:27'),(9094,7218,'Y','18','021','EC','A','','','AC','0000382140','0000382140','OH00000038826','IL','1','MAIDEN','TAMMIE','','','','34','300662959','117 W SUNRISE AVE',0,'DAYTON','OH','45426','3527','CY','39113','1962-06-05','F','U',':RET:2054-5','N','021','DEN','2191721','99734OH005000301','2014-01-01','2013-12-18 11:51:09','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:07:11'),(23997,19081,'Y','18','024','14','A','','','TE','0000310865','0000310865','','IL','1','Ross','Kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-24','M','',NULL,NULL,NULL,'','1809841','','2014-03-01','2014-02-14 21:17:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-15 22:00:31'),(23768,18914,'Y','18','021','EC','A','','','AC','0000819819','0000819819','OH00002660624','IL','1','OBRYAN','NANCY','','','','34','460928148','980 WILMINGTON AVE',0,'DAYTON','OH','45420','1686','CY','39113','1949-10-29','F','U',NULL,'N','021','DEN','3468213','99734OH005000301','2014-03-01','2014-02-14 16:49:38','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:31:13'),(6093,4830,'Y','18','021','EC','A','','','AC','0000398584','0000398584','OH00000543548','IL','1','FOK','YIU','WAH','','','34','295929561','7538 TOURNAMENT DR',0,'WATERVILLE','OH','43566','9795','CY','39095','1951-12-13','M','M',':RET:2034-7','N','021','HLT','793431','92036OH002002601','2014-01-01','2013-12-01 15:17:35','860.00',NULL,NULL,'1049.14','189.14','R-OH001','OH0','646.96',NULL,0,'2013-12-26 00:02:49'),(17185,13751,'Y','18','021','EC','A','','','AC','0000762347','0000762347','TX00002272302','IL','1','QUACH','KIEU','','','','34','452552610','2605 HOYA DR',0,'MIDLAND','TX','79707','5105','CY','48329','1980-08-15','F','U',':RET:2028-9','N','021','DEN','1905058','33348TX002000101','2014-02-01','2014-01-07 20:30:01','0.00',NULL,NULL,'25.02','25.02','R-TX016','TX0','25.02',NULL,0,'2014-01-13 02:22:15'),(17080,13669,'Y','18','024','14','A','','','TE','0000899831','0000899831','','IL','1','EDWARDS','BILLIE','RAYE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-18','F','',NULL,NULL,NULL,'','1849211','','2014-01-08','2014-01-08 13:03:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:21:22'),(16327,13072,'Y','18','021','EC','A','','','AC','0001528356','0001528356','LA00001528402','IL','1','Hollis','Leatrice','','','','34','433191576','2021 HAMPTON DR',0,'HARVEY','LA','70058','1407','CY','22051','1964-08-24','F','U',':RET:2054-5','T','021','DEN','2431416','18575LA002000201','2014-02-01','2014-01-06 14:22:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:51'),(14878,11881,'Y','18','021','EC','A','','','AC','0000257613','0000257613','TX00001720007','IL','1','Jones','Charles','','','','34','451968174','P.O. Box 193',0,'Joinerville','TX','75658',NULL,'CY','48401','1951-09-01','M','U',':RET:2054-5','T','021','DEN','2596906','33348TX002000201','2014-02-01','2013-12-29 14:26:27','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-30 00:00:25'),(6067,4807,'Y','18','021','EC','A','','','AC','0000128073','0000128073','OH00000898168','31','1','Williamson','George','L','','III','34','204385228','P.O. Box 161',0,'Columbus','OH','43216',NULL,'CY','39049','1949-10-23','M','U',NULL,'N','021','DEN','886286','99734OH005000401','2014-01-01','2013-12-01 12:31:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:02:05'),(4037,3224,'Y','18','021','EC','A','','','AC','0000293172','0000293172','OH00000889795','IL','1','Kington','Robert','','','','34','284543189','714 Matthews Brook LN',0,'Powell','OH','43065',NULL,'CY','39041','1953-12-13','M','M',NULL,'N','021','DEN','1548712','99734OH005000401','2014-01-01','2013-12-17 11:14:27','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:02'),(16527,13222,'Y','18','021','EC','A','','','AC','0001023306','0001023306','TX00001779213','IL','1','Clark','Angela','','','','34','456550495','409 COUNTY ROAD 3074',0,'CENTER','TX','75935','5668','CY','48419','1965-11-22','F','M',':RET:2106-3','T','021','DEN','2533845','33348TX002000201','2014-02-01','2014-01-05 16:35:02','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2014-01-07 10:21:57'),(15049,12029,'Y','18','021','EC','A','','','AC','0002332206','0002332206','LA00000753428','31','1','WILLIAM','ALBERT','','','','34','438985442','P.O. BOX 172',0,'VACHERIE','LA','70090',NULL,'CY','22095','1954-03-27','M','U',NULL,'N','021','DEN','2288355','18575LA002000201','2014-02-01','2013-12-30 13:59:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:03:12'),(14777,11800,'Y','18','024','14','A','','','TE','0000264202','0000264202','','IL','1','Peterson','Aaron',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-08','M','',NULL,NULL,NULL,'','2544931','','2013-12-23','2013-12-23 20:51:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:13:08'),(4216,3354,'Y','18','021','EC','A','','','AC','0000390597','0000390597','TX00001251964','IL','1','HUTCHINSON','CARLIE','ROSE','','','34','633341054','819 KIOWA DR E',0,'LAKE KIOWA','TX','76240','9573','CY','48097','1992-12-21','F','R',':RET:2106-3','N','021','DEN','2493984','33348TX002000201','2014-01-01','2013-12-17 09:22:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:18'),(25785,20449,'Y','18','021','EC','A','','','AC','0000318461','0000318461','OH00002386633','IL','1','Purnell','Christy','','','','34','270764362','2624 MAPLE DR',0,'TWINSBURG','OH','44087','2142','CY','39153','1967-12-05','F','U',NULL,'T','021','HLT','2780484','52664OH151001501','2014-04-01','2014-02-24 16:09:23','54.00',NULL,NULL,'461.38','407.38','R-OH012','OH0','461.38',NULL,0,'2014-02-26 09:31:05'),(26833,21267,'N','01','021','EC','A',NULL,NULL,'','0001168064','0000987459','','IL','1','Raouidah','Hasna','Lahlou','','','34','279048276','5401 FLINTSTONE DR',0,'WESTERVILLE','OH','43081','4884','CY','39049','1974-08-11','F','',':RET:2106-3','N','021','DEN','3290739','99734OH005000401','2014-04-01','2014-03-01 14:51:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-01 21:00:41'),(694,571,'N','01','021','EC','A',NULL,NULL,'','0000545227','0001050628','','IL','1','Lawrence','Amy','Nicole','','','34','555750539','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1982-07-29','F','',':RET:2106-3','N','021','DEN','2570237','99734OH005000301','2014-01-01','2013-12-16 14:59:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:43'),(1411,1173,'Y','18','021','EC','A','','','AC','0002005305','0002005305','LA00000555797','IL','1','williams','kimberly','','','','34','427459587','2245 College Drive',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1981-09-04','F','U',':RET:2054-5','N','021','DEN','2197479','18575LA002000201','2014-01-01','2013-12-24 13:28:31','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:55'),(22108,17645,'N','01','021','EC','A',NULL,NULL,'','0000957938','0000998817','','IL','1','Hartwig','Emily','A','','','34','288901436','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','1985-06-01','F','',':RET:2106-3','N','021','DEN','2941556','99734OH005000301','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-08 19:00:33'),(20831,16650,'Y','18','021','EC','A','','','AC','0001426185','0001426185','LA00002225063','IL','1','Reeves','Jessica','','','','34','439553922','1564 OKALOOSA RD',0,'EROS','LA','71238','8302','CY','22073','1985-01-09','F','M',':RET:2106-3','T','021','DEN','3620338','18575LA002000201','2014-03-01','2014-01-31 17:52:17','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-31 21:00:41'),(20727,16561,'N','01','021','EC','A',NULL,NULL,'','0001208339','0000775120','','IL','1','PITSINGER','MICHAEL','E','','','34','282565478','9681 SILICA SAND RD',0,'GARRETTSVILLE','OH','44231',NULL,'CY','39133','1957-07-07','M','',':RET:2106-3','T','021','HLT','3242693','52664OH151001304','2014-03-01','2014-01-30 12:32:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','598.32',NULL,0,'2014-01-30 21:01:17'),(4979,3953,'N','01','021','EC','A',NULL,NULL,'','0000471677','0000743868','','IL','1','REYNA','PEDRO','','','','34','637842078','118 E MIMS ST',0,'TYLER','TX','75702','2131','CY','48423','1970-06-23','M','',NULL,'N','021','DEN','835568','33348TX002000201','2014-01-01','2013-12-07 16:42:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:46:40'),(15007,11996,'Y','18','024','14','A','','','TE','0000545220','0000545220','','IL','1','Chen','Cindy Xin Fang',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-10-11','F','',NULL,NULL,NULL,'','445786','','2013-12-29','2013-12-29 19:51:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:01:55'),(16213,12983,'Y','18','024','14','A','','','TE','0000880493','0000880493','','IL','1','alexander','cheryl',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-03-13','F','',NULL,NULL,NULL,'','2481121','','2014-01-03','2014-01-03 19:12:41',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-05 00:01:33'),(16419,13140,'Y','18','021','EC','A','','','AC','0000417411','0000417411','OH00002328912','IL','1','Jin','Young','','','','34','281686434','3789 MAPLE GROVE LN',0,'BEAVERCREEK','OH','45440','3573','CY','39057','1961-03-07','M','M',':RET:2040-4','N','021','HLT','2136580','92036OH001000501','2014-02-01','2014-01-06 14:12:15','942.00',NULL,NULL,'1497.29','555.29','R-OH003','OH0','559.69',NULL,0,'2014-01-07 04:04:29'),(24458,19430,'Y','18','021','EC','A','','','AC','0001154050','0001154050','TX00002047072','IL','1','Hurtado','Jose','','','','34','629109487','2633 JILLS DR',0,'BALCH SPRINGS','TX','75180','1425','CY','48113','1989-04-12','M','U',NULL,'N','021','DEN','3482188','33348TX002000101','2014-04-01','2014-02-18 12:06:34','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-18 22:01:31'),(8991,7133,'Y','18','021','EC','A','','','AC','0000808652','0000808652','OH00001092481','IL','1','Rammel','Michelle','','','','34','296668687','116 E RACE ST',0,'MECHANICSBURG','OH','43044','1024','CY','39021','1974-11-16','F','M',':RET:2106-3','N','021','DEN','2497729','99734OH005000401','2014-01-01','2013-12-18 17:20:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:04:34'),(24010,19094,'Y','18','021','EC','A','','','AC','0001174442','0001174442','OH00002430761','IL','1','Landrum','Mary','','','','34','293483462','2407 LITTLE CREEK RD',0,'FRANKFORT','OH','45628','9713','CY','39141','1953-06-13','F','U',':RET:2106-3','N','021','DEN','3295400','99734OH005000401','2014-03-01','2014-02-15 11:56:12','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-02-15 22:00:39'),(23274,18554,'Y','18','024','14','A','','','TE','0000582236','0000582236','','IL','1','Bradberry','Barton',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-22','M','',NULL,NULL,NULL,'','3175655','','2014-02-28','2014-02-13 12:03:08',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-13 21:30:14'),(1771,1460,'N','19','021','EC','A',NULL,NULL,'','0001192675','0000817545','','IL','1','Jellison','Luke','','','','34','302969637','150 Filly Lane',0,'Northfield','OH','44067',NULL,'CY','39153','1994-08-10','M','',':RET:2106-3','N','021','DEN','1856328','99734OH005000301','2014-01-01','2013-12-24 14:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:07'),(20120,16053,'Y','18','021','EC','A','','','AC','0000415992','0000415992','OH00002266636','IL','1','Perdue','Cheryl','Loudella','','','34','553944087','3241 GLENOAK DR',0,'COLUMBUS','OH','43219','3007','CY','39049','1956-04-09','F','U',':RET:2054-5','N','021','DEN','2236387','99734OH005000401','2014-03-01','2014-01-27 06:57:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-27 21:00:46'),(2768,2238,'Y','18','021','EC','A','','','AC','0000655790','0000655790','OH00000900558','IL','1','Toth','Jeffrey','','','','34','269783194','1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1965-04-23','M','M',':RET:2106-3','N','021','HLT','212152','52664OH151001304','2014-01-01','2013-12-02 13:37:35','621.00',NULL,NULL,'1028.29','407.29','R-OH012','OH0','364.62',NULL,0,'2013-12-25 19:49:29'),(6432,5100,'N','01','021','EC','A',NULL,NULL,'','0000168135','0000036711','','IL','1','Nquyen','Binh','D','','Sr','34','611704853','400 E 4TH ST',0,'KAPLAN','LA','70548','4223','CY','22113','1970-12-09','M','',':RET:2047-9','N','021','DEN','351914','18575LA002000201','2014-01-01','2013-12-11 13:05:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:49:11'),(3729,2980,'Y','18','024','14','A','','','TE','0001215443','0001215443','','IL','1','Ray','Mozell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-07-16','F','',NULL,NULL,NULL,'','7671','','2013-12-13','2013-12-13 17:50:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:32:33'),(4391,3491,'Y','18','021','EC','A','','','AC','0001051885','0001051885','OH00001233107','IL','1','Fontana','Dave','','','','34','272664247','2070 JACQUELINE DR',0,'PARMA','OH','44134','6856','CY','39035','1969-09-16','M','M',':RET:2106-3','N','021','DEN','232249','99734OH005000401','2014-01-01','2013-12-12 11:46:46','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:53'),(4087,3265,'Y','18','021','EC','A','','','AC','0000675436','0000675436','OH00000102149','IL','1','Humphrey','Kathryn','','','','34','283725360','502 S WINTERGARDEN RD',0,'BOWLING GREEN','OH','43402','3540','CY','39173','1962-04-28','F','U',':RET:2106-3','N','021','HLT','1963754','92036OH005002606','2014-01-01','2013-12-17 10:07:31','428.00',NULL,NULL,'487.51','59.51','R-OH001','OH0','363.68',NULL,0,'2013-12-25 21:47:20'),(25211,19997,'N','19','021','EC','A',NULL,NULL,'','0000471066','0000903283','','IL','1','Thrasher','Ashley',NULL,NULL,NULL,NULL,NULL,'7609 ROAD 82',0,'PAYNE','OH','45880','9518','CY','39125','2000-11-30','F','',':RET:2106-3','N','021','DEN','3518034','99734OH005000301','2014-04-01','2014-02-21 12:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:51'),(7697,6094,'N','01','021','EC','A',NULL,NULL,'','0000224717','0000541637','','IL','1','RISDEN','RICKY','','','','34','287628873','7855 KESSLER FREDERICK RD',0,'TIPP CITY','OH','45371','9613','CY','39109','1957-02-23','M','',':RET:2106-3','N','021','DEN','1736152','99734OH005000401','2014-01-01','2013-12-20 00:10:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:10'),(22927,18277,'Y','18','021','EC','A','','','AC','0000108148','0000108148','OH00002260769','IL','1','SPEHAR','VINCENT','','','','34','285766564','780 WINSTON CIR',0,'MEDINA','OH','44256','7195','CY','39103','1971-06-29','M','M',':RET:2106-3','N','021','DEN','3275543','99734OH005000301','2014-03-01','2014-02-11 05:25:10','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00','CIC',0,'2014-02-11 21:30:07'),(21022,16798,'N','01','021','EC','A',NULL,NULL,'','0000545275','0000793500','','IL','1','Gott','Liana','','','','34','304949725','11088 PHILLIPS RD',0,'BLUFFTON','OH','45817','9512','CY','39003','1969-09-30','F','',NULL,'N','021','DEN','3506874','99734OH005000401','2014-03-01','2014-02-01 14:57:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:40'),(7068,5612,'Y','18','021','EC','A','','','AC','0000208510','0000208510','OH00000369835','31','1','Seals','Sherri','','','','34','297801288','2741 Baker St',0,'Coolville','OH','45723',NULL,'CY','39009','1979-12-16','F','U',':RET:2106-3','N','021','DEN','1969838','99734OH005000301','2014-01-01','2013-12-24 22:20:56','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-26 01:50:03'),(16795,13434,'N','01','021','EC','A',NULL,NULL,'','0000546566','0000335248','','IL','1','Sterns','Marcus','Duane','','','34','453299468','2525 Whippoorwill Dr',0,'Mesquite','TX','75149',NULL,'CY','48113','1972-01-18','M','',':RET:2054-5','N','021','DEN','2450633','33348TX002000201','2014-02-01','2014-01-10 21:52:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:18:08'),(16778,13421,'N','19','021','EC','A',NULL,NULL,'','0001130241','0000498178','','S1','1','Francis','Neil','R','','','34','292114399','1076 PARKWAY DR',0,'GREENVILLE','OH','45331','2620','CY','39037','2006-01-30','M','',':RET:2106-3','N','021','HLT','1492777','92036OH004000501','2014-02-01','2014-01-07 11:33:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-01-08 18:25:04'),(16143,12930,'Y','18','024','14','A','','','TE','0000627881','0000627881','','IL','1','shearer','randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-30','M','',NULL,NULL,NULL,'','2373628','','2014-01-03','2014-01-03 15:11:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:06:03'),(16106,12900,'Y','18','021','EC','A','','','AC','0001051211','0001051211','MS00002135617','IL','1','AFKHAMI-NOE','ZAHRA','','','','34','266878375','127 BREAKERS LN',0,'RIDGELAND','MS','39157','1105','CY','28089','1950-10-23','F','U',NULL,'N','021','DEN','1525781','46300MS002000101','2014-02-01','2014-01-02 23:06:03','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-04 02:04:55'),(26553,21053,'Y','18','021','EC','A','','','AC','0000590840','0000590840','OH00003054951','IL','1','WILLIAMS','LONDON','','','','34','280764769','404 19TH ST NW',0,'CANTON','OH','44709','3802','CY','39151','1971-01-25','F','U',':RET:2106-3','N','021','DEN','3255007','99734OH005000301','2014-04-01','2014-02-28 14:41:28','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-28 21:30:15'),(602,495,'Y','18','024','14','A','','','TE','0000242689','0000242689','','IL','1','Sullivan','Judith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-06','F','',NULL,NULL,NULL,'','1006508','','2013-12-16','2013-12-16 07:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:00:21'),(23572,18780,'Y','18','024','14','A','','','TE','0000354012','0000354012','','IL','1','STOLL','JOANNE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-09-01','F','',NULL,NULL,NULL,'','3690452','','2014-02-13','2014-02-13 13:16:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:02:52'),(21857,17453,'Y','18','021','EC','A','','','AC','0000378617','0000378617','OH00001895802','IL','1','SETON','ERNEST','','','','34','275042935','2411 WIMBLEDON PARK BLVD',0,'TOLEDO','OH','43617','2237','CY','39095','1979-02-07','M','M',NULL,'N','021','DEN','3239687','99734OH005000301','2014-03-01','2014-02-06 14:02:27','0.00',NULL,NULL,'87.78','87.78','R-OH001','OH0','0.00',NULL,0,'2014-02-06 21:01:18'),(21316,17033,'Y','18','021','EC','A','','','AC','0001831079','0001831079','LA00001408876','IL','1','SHAW','TAKASHIA','','','','34','435590358','2054 TENNESSEE ST',0,'BATON ROUGE','LA','70802','6755','CY','22033','1977-12-03','F','U',':RET:2054-5','N','021','DEN','3344454','18575LA002000201','2014-03-01','2014-02-04 15:25:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-04 21:00:20'),(1181,973,'Y','18','021','EC','A','','','AC','0000396128','0000396128','OH00000784377','IL','1','Barnes','Tamera','','','','34','294723916','1298 ZEBULON AVE',0,'COLUMBUS','OH','43224','2759','CY','39049','1966-10-16','F','M',':RET:2054-5','N','021','DEN','1201581','99734OH005000301','2014-01-01','2013-12-02 21:19:49','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:19:23'),(19097,15215,'Y','18','021','EC','A','','','AC','0001168025','0001168025','OH00002002577','IL','1','BERRY','THOMAS','','','','34','268620255','289 BAYVIEW RD',0,'BAY VILLAGE','OH','44140',NULL,'CY','39035','1954-04-06','M','U',':RET:2106-3','N','021','HLT','1934554','92036OH004000801','2014-03-01','2014-01-18 09:42:19','345.00',NULL,NULL,'489.35','144.35','R-OH011','OH0','489.35',NULL,0,'2014-01-21 08:44:36'),(17774,14201,'Y','18','021','EC','A','','','AC','0000875441','0000875441','TX00002216990','IL','1','AUZENNE','Lois','','','','34','464047941','836 W 5TH ST',0,'PORT ARTHUR','TX','77640','4945','CY','48245','1953-03-23','F','U',NULL,'N','021','DEN','2732493','33348TX002000101','2014-02-01','2014-01-13 14:31:16','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2014-01-14 01:33:40'),(16615,13291,'N','01','021','EC','A',NULL,NULL,'','0000181025','0000188865','','IL','1','FLOYD','PHILLIP','','','','34','294507303','1231 ROGERS AVE SE',0,'WARREN','OH','44484','4361','CY','39155','1949-03-28','M','',NULL,'N','021','DEN','1488943','99734OH005000401','2014-02-01','2014-01-07 10:41:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:09'),(16563,13251,'Y','18','021','EC','A','','','AC','0000031738','0000031738','MS00001378861','IL','1','dressner','joshua','','','','34','434573028','31 virgil mitchell rd',0,'picayune','MS','39466',NULL,'CY','28109','1981-10-31','M','M',':RET:2106-3','N','021','DEN','1561794','46300MS002000101','2014-02-01','2014-01-05 17:31:17','0.00',NULL,NULL,'54.30','54.30','R-MS004','MS0','27.15',NULL,1,'2014-01-07 10:23:08'),(16070,12869,'Y','18','024','14','A','','','TE','0000484800','0000484800','','IL','1','LENGEL','JOSEPH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-01','M','',NULL,NULL,NULL,'','1474405','','2014-01-03','2014-01-03 11:48:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-04 02:03:47'),(5473,4346,'N','19','021','EC','A',NULL,NULL,'','0001046832','0001138040','','IL','1','Arif','Adeel','','','','34','590299154','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','1992-12-11','M','',':RET:2028-9','N','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99',NULL,0,'2013-12-25 23:10:41'),(4820,3820,'Y','18','021','EC','A','','','AC','0001252093','0001252093','OH00000301020','IL','1','HUMM','CAROLYN','SUE','','','34','291467790','1330 VALLEY DR',0,'AKRON','OH','44312',NULL,'CY','39153','1950-07-08','F','M',':RET:2106-3','N','021','HLT','322788','52664OH152000901','2014-01-01','2013-12-08 11:18:01','201.00',NULL,NULL,'482.18','281.18','R-OH012','OH0','482.18',NULL,0,'2013-12-25 22:17:03'),(4210,3349,'Y','18','021','EC','A','','','AC','0000661470','0000661470','TX00001172113','IL','1','CAVAZOS','EDWARDO','','','','34','458531203','700 AVE D',0,'SINTON','TX','78387',NULL,'CY','48409','1966-01-21','M','M',NULL,'N','021','DEN','2465698','33348TX002000201','2014-01-01','2013-12-17 07:41:11','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 21:50:10'),(24919,19759,'Y','18','024','14','A','','','TE','0001220837','0001220837','','IL','1','witt','deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-27','F','',NULL,NULL,NULL,'','2000018','','2014-02-28','2014-02-20 14:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:13'),(25256,20035,'N','01','021','EC','A',NULL,NULL,'','0000891858','0000261550','','IL','1','Botton','Lori','','','','34','280667994','1700 South Duchess Lane Lot 16',0,'Tiffin','OH','44883',NULL,'CY','39147','1958-07-04','F','',':RET:2106-3','T','021','HLT','3242102','92036OH006002701','2014-04-01','2014-02-21 14:43:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','396.58',NULL,0,'2014-02-21 22:01:17'),(452,370,'N','19','021','EC','A',NULL,NULL,'','0000001005','0000762258','','IL','1','smith','jasen','a','','','34','288062190','2110 PLEASANT HILL RD',0,'MARION','OH','43302','9474','CY','39101','2001-09-26','M','',':RET:2106-3','N','021','DEN','630463','99734OH005000401','2014-01-01','2013-12-04 17:54:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:47:24'),(17724,14162,'N','01','021','EC','A',NULL,NULL,'','0001060931','0000843359','','IL','1','Trent','William','Todd','','Jr','34','274441192','3063 HICKORY ST',0,'CLINTON','OH','44216','9115','CY','39153','1959-04-21','M','',':RET:2106-3','T','021','HLT','2729921','52664OH152000901','2014-02-01','2014-01-13 16:29:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.04',NULL,0,'2014-01-14 01:33:15'),(22427,17907,'N','01','021','EC','A',NULL,NULL,'','0001113260','0000682697','','IL','1','IBARRA','JOVITA','','','','34','449858333','1152 County Road 1002',0,'GLEN ROSE','TX','76043',NULL,'CY','48425','1953-05-13','F','',NULL,'N','021','DEN','3762939','33348TX002000201','2014-03-01','2014-02-09 18:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-10 21:30:34'),(8062,6384,'Y','18','021','EC','A','','','AC','0001149867','0001149867','OH00000168308','IL','1','Wallace','Samuel','','','','34','284688707','266 Mt Royal Drive',0,'toledo','OH','43608',NULL,'CY','39095','1967-12-28','M','M',':RET:2054-5','N','021','HLT','2016150','92036OH003002605','2014-01-01','2013-12-20 14:41:12','505.00',NULL,NULL,'652.86','147.86','R-OH001','OH0','305.45',NULL,0,'2013-12-26 03:09:59'),(5239,4155,'N','19','021','EC','A',NULL,NULL,'','0000124195','0000556709','','IL','1','Buehl','Nicole','','','','34','295924738','204 SILVER VALLEY BLVD',0,'MUNROE FALLS','OH','44262','1019','CY','39153','1990-11-14','F','',NULL,'N','021','HLT','1493366','52664OH151001305','2014-01-01','2013-12-18 20:12:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-25 23:04:53'),(2147,1765,'Y','18','021','EC','A','','','AC','0000387245','0000387245','OH00000159027','IL','1','Harvey','Michael','','','','34','297489707','2899 St rt 133',0,'Bethel','OH','45106',NULL,'CY','39025','1949-08-31','M','U',NULL,'N','021','HLT','321375','92036OH004000601','2014-01-01','2013-12-10 17:10:26','368.00',NULL,NULL,'517.83','149.83','R-OH005','OH0','517.83',NULL,0,'2013-12-25 19:18:26'),(943,780,'Y','18','021','EC','A','','','AC','0000321006','0000321006','OH00001191310','IL','1','Bundy','Lance','','','','34','280887658','218 BAKER ST',0,'LODI','OH','44254','1407','CY','39103','1977-08-17','M','U',':RET:2106-3','T','021','DEN','133654','99734OH005000301','2014-01-01','2013-10-28 22:38:24','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:09:25'),(14431,11509,'Y','18','021','EC','A','','','AC','0001785149','0001785149','LA00000569745','IL','1','Hardaway','James','','','','34','327509006','2020 Valley View Circle',0,'Bossier City','LA','71111',NULL,'CY','22015','1955-09-26','M','U',NULL,'N','021','DEN','2355307','18575LA002000201','2014-02-01','2013-12-26 19:35:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-28 03:31:57'),(22308,17809,'Y','18','021','EC','A','','','AC','0000527466','0000527466','MS00001842968','31','1','MOORE','CHARLES','','','','34','587210661','PO BOX 4411',0,'JACKSON','MS','39296',NULL,'CY','28049','1967-08-26','M','U',':RET:2054-5','N','021','DEN','1636705','46300MS002000201','2014-03-01','2014-01-27 07:28:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 11:00:42'),(21451,17143,'N','01','021','EC','A',NULL,NULL,'','0000899601','0000234088','','IL','1','ROSE','JEFFERY','','','','34','543619463','906 MCKINLEY AVE',0,'AKRON','OH','44306','1908','CY','39153','1974-02-21','M','',NULL,'T','021','HLT','3783691','52664OH151001301','2014-03-01','2014-02-04 09:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','327.75',NULL,0,'2014-02-04 21:01:28'),(17129,13707,'N','01','021','EC','A',NULL,NULL,'','0000192753','0000081302','','IL','1','See','John','Gilbert','','','34','284527172','6911 HILLSIDE RD',0,'INDEPENDENCE','OH','44131','5343','CY','39035','1952-01-25','M','',':RET:2106-3','N','021','DEN','2006095','99734OH005000401','2014-02-01','2014-01-08 11:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:45'),(20866,16675,'Y','18','021','EC','A','','','AC','0000103916','0000103916','OH00001508059','IL','1','Curry','Jermaine','','','','34','292848882','530 3 MEADOWS CT',0,'PERRYSBURG','OH','43551','5511','CY','39173','1986-05-23','M','M',':RET:2054-5','N','021','HLT','2790924','92036OH004002601','2014-03-01','2014-01-30 19:18:16','0.00',NULL,NULL,'164.31','164.31','R-OH001','OH0','164.31',NULL,0,'2014-01-31 21:00:58'),(17150,13722,'Y','18','021','EC','A','','','AC','0001600418','0001600418','LA00000582958','IL','1','Boudreau','Danielle','','','','34','032629110','3324 DANNEEL ST',0,'NEW ORLEANS','LA','70115','5213','CY','22071','1977-02-16','F','U',':RET:2106-3','N','021','DEN','1641566','18575LA002000201','2014-02-01','2014-01-07 21:56:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:56'),(19219,15313,'Y','18','021','EC','A','','','AC','0000703759','0000703759','OH00002188376','IL','1','Lay','River','Manda','','','34','297139371','617 Jefferson',0,'Reading','OH','45215',NULL,'CY','39061','2008-05-06','F','R',':RET:2106-3','N','021','DEN','1385358','99734OH005000401','2014-03-01','2014-01-19 20:05:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-01-21 08:46:26'),(18016,14393,'N','01','021','EC','A',NULL,NULL,'','0001184903','0001187659','','IL','1','Manning','Ted','M','','','34','284803916','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','1965-05-26','M','',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(27854,22030,'Y','18','021','EC','A','','','AC','0000062073','0000062073','TX00002814491','IL','1','CONNER','MARILYN','','','','34','453374872','607 DELMAR AVE',0,'AUSTIN','TX','78752','2626','CY','48453','1963-03-20','F','U',':RET:2054-5','N','021','DEN','3842501','33348TX002000101','2014-04-01','2014-03-05 15:43:59','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-05 21:32:14'),(28375,22452,'N','19','021','EC','A',NULL,NULL,'','0000175171','0000553985','','IL','1','Werring','Terra','','','','34','273048827','4009 MOORE MARATHON RD',0,'WILLIAMSBURG','OH','45176','8231','CY','39025','1998-11-21','F','',':RET:2106-3','N','021','HLT','4225138','92036OH005000601','2014-04-01','2014-03-07 10:43:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-03-07 21:30:36'),(28961,22921,'Y','18','021','EC','A','','','AC','0001484796','0001484796','LA00002704986','IL','1','Hebert','Angela','','','','34','435292925','956 PATTON ST',0,'WESTWEGO','LA','70094','3714','CY','22051','1961-07-25','F','M',NULL,'N','021','DEN','3929475','18575LA002000201','2014-04-01','2014-03-10 13:10:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:56'),(1783,1468,'Y','18','021','EC','A','','','AC','0000866902','0000866902','OH00000260220','IL','1','WAHL','RICHARD','','','','34','298541155','15794 MAYFIELD RD',0,'HUNTSBURG','OH','44046','8788','CY','39055','1953-05-12','M','M',':RET:2106-3','N','021','DEN','1611901','99734OH005000301','2014-01-01','2013-12-24 15:36:03','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:56:24'),(25314,20081,'N','01','021','EC','A',NULL,NULL,'','0001220882','0001692559','','IL','1','KING','HAROLD','','','','34','436047424','3126 MONROE ST',0,'ALEXANDRIA','LA','71301','5537','CY','22079','1956-09-13','M','',NULL,'N','021','DEN','2780493','18575LA002000201','2014-04-01','2014-02-24 18:01:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-25 21:30:03'),(13830,11038,'N','19','021','EC','A',NULL,NULL,'','0000904262','0000951793','','S1','1','Filina','Robert','','','','34','274117535','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','2004-11-27','M','',':RET:2106-3','N','021','HLT','2523112','52664OH152000901','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 13:12:05'),(23797,18936,'Y','18','021','EC','A','','','AC','0000072929','0000072929','OH00001844490','IL','1','Houck','William','','','','34','293521644','1260 Elno Ave.',0,'Kent','OH','44240',NULL,'CY','39133','1952-03-16','M','M',':RET:2106-3','N','021','HLT','3805743','52664OH151001301','2014-03-01','2014-02-14 14:27:13','613.00',NULL,NULL,'1194.87','581.87','R-OH012','OH0','626.65',NULL,0,'2014-02-14 21:31:28'),(9621,7619,'Y','18','021','EC','A','','','AC','0000293180','0000293180','OH00000947465','IL','1','Aldrich','Jacquelyn','','','','34','269827215','1051 Ralston Ave',0,'Defiance','OH','43512',NULL,'CY','39039','1979-04-16','F','U',':RET:2106-3','T','021','HLT','2515360','92036OH005002605','2014-01-01','2013-12-20 21:10:25','74.00',NULL,NULL,'272.23','198.23','R-OH001','OH0','272.23',NULL,0,'2013-12-26 04:37:54'),(6074,4814,'Y','18','021','EC','A','','','AC','0000539259','0000539259','OH00001075577','IL','1','Thayer','Wayne','','','','34','268522598','667 SOUTHWOOD DR',0,'UNIONTOWN','OH','44685','9661','CY','39153','1950-01-29','M','U',':RET:2106-3','T','021','HLT','551795','52664OH152000901','2014-01-01','2013-12-01 07:32:27','465.00',NULL,NULL,'554.51','89.51','R-OH012','OH0','554.51',NULL,0,'2013-12-26 00:02:17'),(22154,17684,'Y','18','021','EC','A','','','AC','0000237617','0000237617','OH00002097409','IL','1','Kuhn','John','','','','34','294801756','838 OLD MILL DR',0,'LOVELAND','OH','45140','8077','CY','39025','1970-09-12','M','R',':RET:2106-3','N','021','HLT','3338375','92036OH004000601','2014-03-01','2014-02-08 10:32:30','0.00',NULL,NULL,'761.73','761.73','R-OH005','OH0','234.23',NULL,0,'2014-02-08 19:00:56'),(21595,17247,'N','01','021','EC','A',NULL,NULL,'','0001160446','0000097612','','IL','1','Sheeley','Scott','Anthony','','','34','268789399','504 DAKOTA RD',0,'BELLEFONTAINE','OH','43311','2347','CY','39091','1968-03-27','M','',':RET:2106-3','N','021','DEN','3810658','99734OH005000301','2014-03-01','2014-02-05 10:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:30'),(6730,5338,'N','01','021','EC','A',NULL,NULL,'','0000326152','0001126835','','IL','1','Seitz','Richard','','','','34','148620119','5386 Sultana Dr',0,'Cincinnati','OH','45238',NULL,'CY','39061','1963-04-01','M','',':RET:2106-3','T','021','DEN','843657','99734OH005000401','2014-01-01','2013-11-25 09:04:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:15:27'),(21168,16916,'N','01','021','EC','A',NULL,NULL,'','0000267566','0001147374','','IL','1','MCQUEEN','JAMES','','','','34','276522753','3783 RIVERDOWNS CT',0,'HAMILTON','OH','45011',NULL,'CY','39017','1954-12-09','M','',':RET:2106-3','T','021','DEN','3598241','99734OH005000401','2014-03-01','2014-02-03 12:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-03 21:00:36'),(14396,11480,'N','19','021','EC','A',NULL,NULL,'','0000382170','0001060913','','IL','1','WALDROP','NICHOLAS','','','','34','278988404','3291 BRENTWOOD CT',0,'POWELL','OH','43065','9134','CY','39041','1995-01-31','M','',NULL,'N','021','DEN','2537519','99734OH005000401','2014-02-01','2013-12-27 15:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:31:06'),(18240,14559,'Y','18','021','EC','A','','','AC','0000515685','0000515685','TX00001561467','IL','1','Grizzle','Dorinda','','','','34','449412337','18218 HEATON DR',0,'HOUSTON','TX','77084','2357','CY','48201','1964-08-22','F','U',':RET:2106-3','N','021','DEN','1507940','33348TX002000201','2014-02-01','2014-01-15 10:42:01','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-16 08:44:24'),(8923,7075,'Y','18','021','EC','A','','','AC','0000381127','0000381127','OH00000190946','IL','1','Fisher','Dalaina','','','','34','125704468','1870 Sunset Ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1980-03-09','F','U',':RET:2054-5','N','021','DEN','2032421','99734OH005000401','2014-01-01','2013-12-18 08:49:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:02:50'),(6375,5055,'Y','18','021','EC','A','','','AC','0000095199','0000095199','OH00000254277','IL','1','RUTLEDGE','MARY ANN','','','','34','273546368','4626 GREENWICH VILLAGE AVE',0,'DAYTON','OH','45406','2410','CY','39113','1949-10-23','F','U',':RET:2054-5','N','021','DEN','35709','99734OH005000301','2014-01-01','2013-12-11 09:25:54','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:47:47'),(16173,12949,'Y','18','021','EC','A','','','AC','0001671571','0001671571','LA00002107172','IL','1','Do','Phuong','','','','34','862508283','16352 Old Hammond Hwy.',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1983-05-30','F','M',NULL,'N','021','DEN','1750501','18575LA002000201','2014-02-01','2014-01-04 12:41:54','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-05 00:00:17'),(18556,14798,'Y','18','021','EC','A','','','AC','0000743104','0000743104','OH00002245314','IL','1','Elliott','Lori','','','','34','295687898','2618 WESTMAR CT',0,'TOLEDO','OH','43615','2052','CY','39095','1962-03-12','F','U',NULL,'N','021','HLT','2819811','92036OH005002605','2014-02-01','2014-01-15 11:37:34','226.00',NULL,NULL,'363.68','137.68','R-OH001','OH0','363.68',NULL,0,'2014-01-16 08:46:56'),(18169,14508,'Y','18','021','EC','A','','','AC','0001132778','0001132778','OH00001901555','IL','1','Roy','Debra','','','','34','301584204','12031 N SHORE DR',0,'HILLSBORO','OH','45133','9211','CY','39071','1952-10-07','F','M',':RET:2106-3','N','021','HLT','2386935','92036OH005000604','2014-02-01','2014-01-14 14:49:14','454.00',NULL,NULL,'603.24','149.24','R-OH005','OH0','603.24',NULL,0,'2014-01-15 02:07:56'),(27915,22084,'N','01','021','EC','A',NULL,NULL,'','0000604557','0001010565','','IL','1','Guerra','Viridiana','','','','34','451991787','2603 HARRIS AVE',0,'PASADENA','TX','77506','3962','CY','48201','1983-12-10','F','',':RET:2106-3','N','021','DEN','2995656','33348TX002000201','2014-04-01','2014-03-05 21:46:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-06 21:00:18'),(29182,23096,'Y','18','021','EC','A','','','AC','0000495510','0000495510','OH00003542484','IL','1','GOUBEAUX','MICHALE','A','','','34','289448299','1351 STERLING DR',0,'TROY','OH','45373','8232','CY','39109','1961-08-08','M','U',':RET:2106-3','N','021','DEN','3305690','99734OH005000401','2014-04-01','2014-03-10 11:07:52','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00','CIC',0,'2014-03-10 21:29:58'),(5367,4255,'Y','18','021','EC','A','','','AC','0000321035','0000321035','OH00001097554','IL','1','Schaffner','Nathaniel','','','','34','585515129','5231 CHAPEL LN',0,'MASON','OH','45040','2402','CY','39165','1984-07-15','M','U',NULL,'N','021','HLT','2256511','92036OH005001206','2014-01-01','2013-12-19 09:56:19','159.00',NULL,NULL,'240.21','81.21','R-OH004','OH0','240.21',NULL,0,'2013-12-25 23:07:59'),(6776,5375,'Y','18','021','EC','A','','','AC','0001008913','0001008913','OH00000495524','IL','1','Fox','Brandon','','','','34','287926798','315 BAILEY RD',0,'BEAVER','OH','45613','9763','CY','39131','1986-06-02','M','U',':RET:2106-3','N','021','DEN','1188835','99734OH005000301','2014-01-01','2013-11-24 19:35:28','0.00',NULL,NULL,'59.76','59.76','R-OH010','OH0','0.00',NULL,0,'2013-12-26 01:16:43'),(13348,10660,'Y','18','021','EC','A','','','AC','0000407858','0000407858','TX00000098544','IL','1','Green','Karen','','','','34','433418593','4055 Hogan Drive',0,'Tyler','TX','75709',NULL,'CY','48423','1966-01-20','F','U',':RET:2054-5','N','021','DEN','1757955','33348TX002000201','2014-01-01','2013-12-23 18:58:25','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-26 12:59:08'),(14575,11630,'Y','18','021','EC','A','','','AC','0001264677','0001264677','LA00000023251','IL','1','Jack','Katherine','','','','34','433370138','57845 GOVERNMENT ST',0,'PLAQUEMINE','LA','70764','2349','CY','22047','1978-12-21','F','U',':RET:2054-5','N','021','DEN','1374589','18575LA002000101','2014-02-01','2013-12-26 22:32:07','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-28 03:35:40'),(17116,13698,'N','01','021','EC','A',NULL,NULL,'','0000223715','0000731219','','IL','1','WAINSCOTT','DANIEL','J','','','34','288820910','569 COVEDALE AVE',0,'CINCINNATI','OH','45238','5324','CY','39061','1968-10-18','M','',':RET:2106-3','N','021','DEN','1494126','99734OH005000401','2014-02-01','2014-01-07 22:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:40'),(17952,14343,'Y','18','024','14','A','','','TE','0000861923','0000861923','','IL','1','Simmons','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-10-26','F','',NULL,NULL,NULL,'','1962175','','2014-01-14','2014-01-14 16:57:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:43'),(27618,21843,'Y','18','021','EC','A','','','AC','0000380069','0000380069','OH00003657689','IL','1','Hall','Juliean','','','','34','275031342','7769 STATE ROUTE 29',0,'DE GRAFF','OH','43318','9525','CY','39021','1953-12-20','F','U',':RET:2106-3','N','021','HLT','4112824','92036OH002000501','2014-04-01','2014-03-05 17:52:55','558.00',NULL,NULL,'745.01','187.01','R-OH003','OH0','745.01','CIC',0,'2014-03-05 21:00:32'),(497,406,'Y','18','021','EC','A','','','AC','0000186231','0000186231','LA00000335413','IL','1','Perot','Robby','','','','34','435493695','675 TIMBERS EAST DR',0,'HAUGHTON','LA','71037','9792','CY','22015','1978-12-09','M','U',':RET:2106-3','N','021','DEN','642763','18575LA002000201','2014-01-01','2013-12-04 17:19:33','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 17:48:35'),(23750,18907,'Y','18','021','EC','A','','','AC','0000221362','0000221362','OH00002571413','IL','1','Dahl','Kelly','','','','34','373044961','961 MCCLAIN RD',0,'GRANDVIEW HEIGHTS','OH','43212','3706','CY','39049','1974-06-06','F','R',':RET:2106-3','N','021','DEN','2644067','99734OH005000301','2014-03-01','2014-02-14 11:21:25','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-14 21:31:06'),(23118,18427,'Y','18','021','EC','A','','','AC','0001015623','0001015623','OH00002250871','IL','1','BUTTROM','SHARON','','','','34','274649431','1002 EBONY LN',0,'CINCINNATI','OH','45224','2726','CY','39061','1956-06-27','F','U',NULL,'N','021','DEN','3606987','99734OH005000401','2014-03-01','2014-02-12 10:54:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:23'),(9468,7510,'N','01','021','EC','A',NULL,NULL,'','0000953243','0000536917','','IL','1','Kiser','Randall','','','','34','275661090','14 Carmel Court',0,'Commercial Point','OH','43116',NULL,'CY','39129','1956-10-05','M','',':RET:2106-3','T','021','DEN','1374202','99734OH005000401','2014-01-01','2013-12-21 10:14:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:22'),(1432,1194,'Y','18','021','EC','A','','','AC','0002257548','0002257548','LA00001445757','IL','1','boissineau','derek','','','','34','555952701','109 HILLCREST RD',0,'PINEVILLE','LA','71360','5601','CY','22079','1987-05-02','M','R',':RET:2106-3','T','021','DEN','1969812','18575LA002000201','2014-01-01','2013-12-24 17:35:52','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 18:47:35'),(7662,6068,'Y','18','024','14','A','','','TE','0001735358','0001735358','','IL','1','Patterson','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-04-16','F','',NULL,NULL,NULL,'','2250176','','2013-12-20','2013-12-20 14:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 03:00:19'),(19160,15265,'N','01','021','EC','A',NULL,NULL,'','0000426463','0000514478','','IL','1','BOLING','JAMES','','','','34','272602766','62 N ERIE BEACH RD',0,'LAKESIDE','OH','43440',NULL,'CY','39123','1956-09-11','M','',':RET:2106-3','N','021','DEN','2713702','99734OH005000301','2014-03-01','2014-01-19 11:54:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:45:41'),(25621,20327,'N','01','021','EC','A',NULL,NULL,'','0000229722','0000409361','','IL','1','van','hoa','','','','34','623177985','4400 BOONE RD',0,'HOUSTON','TX','77072','1980','CY','48201','1973-10-17','F','',':RET:2047-9','N','021','DEN','2696286','33348TX002000201','2014-04-01','2014-02-22 14:32:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-26 08:30:17'),(6493,5144,'Y','18','021','EC','A','','','AC','0000971450','0000971450','OH00000690032','IL','1','Goldstein','Lisa','','','','34','313668921','11453 HARBOUR LIGHT DR',0,'NORTH ROYALTON','OH','44133','2601','CY','39035','1964-08-04','F','U',':RET:2106-3','N','021','HLT','130374','52664OH151001305','2014-01-01','2013-12-11 13:29:29','265.00',NULL,NULL,'429.09','164.09','R-OH011','OH0','429.09',NULL,0,'2013-12-26 00:50:38'),(6452,5114,'Y','18','021','EC','A','','','AC','0000136052','0000136052','OH00000953535','IL','1','Thorton','Amy','','','','34','299722733','2109 UNIONDALE DR',0,'STOW','OH','44224','3443','CY','39153','1974-08-14','F','M',':RET:2106-3','N','021','HLT','1255489','52664OH151001501','2014-01-01','2013-12-10 18:46:20','17.00',NULL,NULL,'337.54','320.54','R-OH012','OH0','337.54',NULL,0,'2013-12-26 00:49:42'),(2369,1932,'Y','18','021','EC','A','','','AC','0001230361','0001230361','OH00000359205','IL','1','Raymond','Donna','','','','34','289501127','6356 tylers crossing',0,'west chester','OH','45069',NULL,'CY','39017','1950-08-18','F','M',':RET:2106-3','N','021','DEN','1226279','99734OH005000401','2014-01-01','2013-12-09 09:04:53','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:32:41'),(18066,14430,'N','01','021','EC','A',NULL,NULL,'','0002189772','0001200847','','IL','1','George','Ivory','','','','34','437928889','420 E MAGNOLIA ST',0,'AMITE','LA','70422','3106','CY','22105','1956-03-23','M','',':RET:2054-5','N','021','DEN','2750054','18575LA002000201','2014-02-01','2014-01-13 20:00:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:22'),(2536,2063,'Y','18','024','14','A','','','TE','0000134546','0000134546','','IL','1','Johnson','Theresa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-05','F','',NULL,NULL,NULL,'','669639','','2013-12-09','2013-12-09 09:05:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:36:54'),(16616,13292,'Y','18','021','EC','A','','','AC','0000358345','0000358345','OH00002263371','IL','1','Moorehead','Arin','Jay','','','34','296941616','518 CHERRY HILL DR',0,'MIAMISBURG','OH','45342','3390','CY','39113','1992-05-08','M','U',NULL,'N','021','DEN','1657017','99734OH005000401','2014-02-01','2014-01-07 12:01:05','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:09'),(15479,12383,'Y','18','021','EC','A','','','AC','0000207133','0000207133','OH00000723109','IL','1','Dekker','Constance','','','','34','345626207','1017 MINERVA AVE',0,'COLUMBUS','OH','43229','5031','CY','39049','1963-04-05','F','U',':RET:2106-3','N','021','DEN','2599492','99734OH005000401','2014-02-01','2013-12-30 23:28:34','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:04'),(435,358,'Y','18','021','EC','A','','','AC','0000210977','0000210977','OH00000119666','IL','1','TRZASKOWSKI','RICHARD','R','','','34','297525403','622 TREADWAY BLVD',0,'SHEFFIELD LAKE','OH','44054','1427','CY','39093','1953-06-02','M','U',':RET:2106-3','T','021','DEN','23446','99734OH005000401','2014-01-01','2013-12-04 08:56:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:47:03'),(21965,17540,'N','01','021','EC','A',NULL,NULL,'','0000960642','0000265283','','IL','1','Hanson','Christopher','A','','','34','594382862','14004 FELS BLVD',0,'MARYSVILLE','OH','43040','9781','CY','39159','1984-07-27','M','',':RET:2106-3','T','021','DEN','3004887','99734OH005000401','2014-03-01','2014-02-07 15:49:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:28'),(20053,15993,'Y','18','021','EC','A','','','AC','0000831567','0000831567','TX00001904453','IL','1','Ginyard','Quinet',NULL,NULL,NULL,NULL,NULL,'10626 VILLAGE TRAIL DR',0,'HOUSTON','TX','77065','3824','CY','48201','1974-08-12','F','U',':RET:2054-5','N','021','DEN','3462788','33348TX002000201','2014-03-01','2014-01-27 09:16:56','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-27 21:00:06'),(8842,7008,'Y','18','021','EC','A','','','AC','0000051826','0000051826','TX00000989888','IL','1','Pike','William','','','','34','635107130','5319 TORTUGA TRL',0,'AUSTIN','TX','78731','4545','CY','48453','1986-12-05','M','U',':RET:2106-3','N','021','DEN','1870128','33348TX002000201','2014-01-01','2013-12-17 22:10:45','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:00:46'),(29113,23046,'Y','18','021','EC','A','','','AC','0001581396','0001581396','LA00003559184','IL','1','JOHNSON','EDDIE','','','','34','438985499','2406 SAINT LOUIS ST',0,'NEW ORLEANS','LA','70119','5642','CY','22071','1959-04-17','M','U',NULL,'N','021','DEN','3018875','18575LA002000101','2014-04-01','2014-03-10 16:58:44','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-10 21:02:25'),(306,252,'Y','18','021','EC','A','','','AC','0000124058','0000124058','TX00001201363','IL','1','Marivani','Mike','','','','34','002604233','5623 STAR VIEW DR',0,'EL PASO','TX','79912','6427','CY','48141','1957-02-18','M','M',':RET:2106-3','N','021','DEN','555509','33348TX002000101','2014-01-01','2013-11-12 18:19:33','0.00',NULL,NULL,'100.08','100.08','R-TX009','TX0','25.02',NULL,0,'2013-12-25 17:30:56'),(6875,5452,'Y','18','021','EC','A','','','AC','0000956614','0000956614','OH00000515940','IL','1','Day','Hayley','','','','34','296925184','941 TRACY PL',0,'MASON','OH','45040','1166','CY','39165','1986-05-23','F','U',':RET:2106-3','N','021','DEN','890111','99734OH005000401','2014-01-01','2013-11-03 11:12:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:32:05'),(14880,11883,'Y','18','021','EC','A','','','AC','0000401803','0000401803','TX00000192993','IL','1','Hong','Solinda','','','','34','639107947','741 Locust St.',0,'Abilene','TX','79602',NULL,'CY','48441','1987-06-21','F','U',':RET:2028-9','N','021','DEN','2444910','33348TX002000201','2014-02-01','2013-12-29 15:19:58','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-30 00:00:30'),(13840,11044,'N','01','021','EC','A',NULL,NULL,'','0000124207','0000300407','','IL','1','First','Susan',NULL,NULL,NULL,NULL,NULL,'1453 STONINGTON RD NW',0,'NORTH CANTON','OH','44720','6065','CY','39151','1951-04-09','F','',':RET:2106-3','T','021','HLT','1413981','52664OH152000901','2014-01-01','2013-12-23 13:11:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','539.67',NULL,0,'2013-12-26 13:12:17'),(9734,7708,'Y','18','024','14','A','','','TE','0000949473','0000949473','','IL','1','nagy','michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-10-17','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-01-01','2013-11-14 20:34:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:45:45'),(9110,7230,'Y','18','021','EC','A','','','AC','0000814273','0000814273','OH00000738074','IL','1','Hall','Jason','','','','34','296722467','26 Virginia Avenue',0,'Centerville','OH','45458',NULL,'CY','39113','1973-09-14','M','M',':RET:2106-3','N','021','DEN','1840295','99734OH005000301','2014-01-01','2013-12-18 15:38:49','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:07:34'),(5308,4208,'Y','18','021','EC','A','','','AC','0000433186','0000433186','MS00000217686','IL','1','Shaw','Marilyn','Darlene','','','34','587709932','124 JESSIE JONES DR',0,'MAGEE','MS','39111','5223','CY','28127','1954-01-08','F','M',':RET:2106-3','N','021','DEN','2040326','46300MS002000101','2014-01-01','2013-12-19 10:37:32','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 23:06:30'),(1368,1133,'Y','18','021','EC','A','','','AC','0000042072','0000042072','TX00000025628','IL','1','Labib','Magdy','Mounir','','','34','255697861','2299 LONE STAR DR',0,'SUGAR LAND','TX','77479','1286','CY','48157','1949-03-01','M','M',NULL,'N','021','DEN','1585761','33348TX002000101','2014-01-01','2013-12-24 15:48:02','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:45:41'),(1480,1234,'Y','18','021','EC','A','','','AC','0000993933','0000993933','OH00001165169','IL','1','CLAY','TERRY','','','','34','268581631','2265  Benson Dr.',0,'Dayton','OH','45406',NULL,'CY','39113','1955-07-08','F','U',NULL,'T','021','DEN','2522194','99734OH005000401','2014-01-01','2013-12-24 10:27:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:48:47'),(20496,16374,'N','01','021','EC','A',NULL,NULL,'','0001211616','0002315160','','IL','1','Pham-Le','Cecilia','','','','34','466779125','1141 Santa Maria',0,'Marrero','LA','70072',NULL,'CY','22051','1970-06-25','F','',':RET:2047-9','N','021','DEN','3099134','18575LA002000201','2014-03-01','2014-01-29 11:10:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-29 21:01:10'),(23637,18821,'N','01','021','EC','A',NULL,NULL,'','0000292135','0000853446','','IL','1','BOULIGNY','ANTHONY','','','','34','433593258','6526 LAS BRISAS DR',0,'HOUSTON','TX','77083','1318','CY','48201','1980-02-03','M','',NULL,'N','021','DEN','3780272','33348TX002000201','2014-03-01','2014-02-13 19:25:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-14 21:30:06'),(26359,20909,'N','19','021','EC','A',NULL,NULL,'','0000060320','0000509261','','IL','1','Wilder','Noah','Winton','','','34','287154764','582 MAGNOLIA DR',0,'PAINESVILLE','OH','44077','2624','CY','39085','2009-10-16','M','',':RET:2106-3','N','021','DEN','3087814','99734OH005000301','2014-03-01','2014-02-26 09:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:00:04'),(4192,3335,'Y','18','021','EC','A','','','AC','0000639503','0000639503','OH00001250810','IL','1','Platz-Rosenow','Heather','','','','34','274667346','1456 EASTON AVE',0,'MADISON','OH','44057','1114','CY','39085','1971-10-13','F','U',':RET:2106-3','N','021','HLT','2488832','52664OH151001304','2014-01-01','2013-12-17 16:11:20','35.00',NULL,NULL,'333.26','298.26','R-OH011','OH0','333.26',NULL,0,'2013-12-25 21:49:40'),(8055,6378,'Y','18','021','EC','A','','','AC','0001225700','0001225700','OH00001036503','IL','1','Mote','Kelton','','','','34','311620837','141 s. main box 48',0,'Palestine','OH','45352',NULL,'CY','39037','1955-07-20','M','U',':RET:2106-3','N','021','HLT','1933524','92036OH006000501','2014-01-01','2013-12-20 09:52:53','457.00',NULL,NULL,'480.33','23.33','R-OH003','OH0','480.33',NULL,0,'2013-12-26 03:09:49'),(14749,11776,'Y','18','021','EC','A','','','AC','0000837702','0000837702','OH00001813389','IL','1','Pell','SuzAnne','','','','34','282725765','80 WOODED RIDGE DR',0,'AMELIA','OH','45102','1862','CY','39025','1976-08-09','F','U',':RET:2106-3','T','021','HLT','1694954','92036OH006000601','2014-02-01','2013-12-27 20:36:36','97.00',NULL,NULL,'242.38','145.38','R-OH005','OH0','242.38',NULL,1,'2013-12-29 11:10:14'),(8822,6994,'Y','18','024','14','A','','','TE','0000185760','0000185760','','IL','1','Estrada','Griselda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-03-01','F','',NULL,NULL,NULL,'','81464','','2013-12-17','2013-12-17 18:43:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:00:18'),(9524,7552,'Y','18','021','EC','A','','','AC','0000667772','0000667772','OH00000095577','IL','1','AGARWAL','NEIL','','','','34','123501588','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','1970-01-25','M','M',':RET:2029-7','N','021','DEN','2028084','99734OH005000301','2014-01-01','2013-12-20 20:28:04','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:35:41'),(16989,13598,'Y','18','021','EC','A','','','AC','0000629485','0000629485','TX00001973291','IL','1','Preston','Laurie','','','','34','279529789','9111 Ridge Post',0,'San Antonio','TX','78250',NULL,'CY','48029','1950-11-02','F','M',':RET:2106-3','N','021','DEN','1436091','33348TX002000101','2014-02-01','2014-01-09 11:19:00','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-01-13 02:20:23'),(18032,14404,'Y','18','024','14','A','','','TE','0000878282','0000878282','','IL','1','Kilbane','Beth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-09-25','F','',NULL,NULL,NULL,'','1582790','','2014-01-14','2014-01-14 16:38:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:07:09'),(20158,16087,'Y','18','021','EC','A','','','AC','0001039778','0001039778','OH00001633031','IL','1','ZIEBRO','LYNETTE','','','','34','273449532','9692 SOUTHVIEW CT',0,'STRONGSVILLE','OH','44136','2473','CY','39035','1951-07-18','F','U',':RET:2106-3','N','021','DEN','3180644','99734OH005000301','2014-03-01','2014-01-27 12:47:22','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:01:08'),(20378,16279,'Y','18','021','EC','A','','','AC','0000102447','0000102447','TX00001570690','IL','1','islah ud din','muhammad','','','','34','504476614','12480 abrams road',0,'dallas','TX','75243',NULL,'CY','48113','1981-02-20','M','M',':RET:2028-9','N','021','DEN','2855104','33348TX002000201','2014-03-01','2014-01-28 20:12:59','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:09'),(20937,16733,'Y','18','021','EC','A','','','AC','0000644702','0000644702','OH00002001719','IL','1','Lowe','Gene','','','','34','268525337','1929 BELVOIR DR',0,'TOLEDO','OH','43613','2801','CY','39095','1951-09-27','M','M',NULL,'T','021','HLT','3566563','92036OH003002604','2014-03-01','2014-01-31 13:57:14','344.00',NULL,NULL,'672.80','328.80','R-OH001','OH0','672.80',NULL,0,'2014-01-31 21:01:41'),(22298,17801,'Y','18','021','EC','A','','','AC','0000936086','0000936086','OH00001924660','IL','1','rai','Didar','singh','','','34','104728150','6841 Great Oaks Parkway',0,'Indepedence','OH','44131',NULL,'CY','39035','1954-02-16','M','M',NULL,'N','021','DEN','2849646','99734OH005000301','2014-03-01','2014-01-20 18:59:41','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-10 11:00:34'),(22470,17942,'Y','18','021','EC','A','','','AC','0000269155','0000269155','MS00002681802','IL','1','WADE','LANCE','','','','34','433111252','4446 WINSTON ST',0,'JACKSON','MS','39206',NULL,'CY','28049','1960-08-18','M','U',':RET:2054-5','T','021','DEN','2831775','46300MS002000101','2014-03-01','2014-02-10 11:13:41','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-10 21:30:58'),(25176,19970,'Y','18','021','EC','A','','','AC','0000197191','0000197191','OH00002114903','IL','1','BOHA','GLORIA','','','','34','288541807','867 EATON FORT NESBIT RD',0,'NEW PARIS','OH','45347','9107','CY','39037','1953-10-23','F','M',':RET:2106-3','N','021','DEN','3737267','99734OH005000401','2014-04-01','2014-02-20 19:26:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-21 22:00:31'),(7023,5576,'Y','18','021','EC','A','','','AC','0000276450','0000276450','TX00000278541','IL','1','RAO','SHAUN','','','','34','627164324','3227 McKinney Ave',0,'Dallas','TX','75204',NULL,'CY','48113','1987-10-10','M','U',':RET:2029-7','N','021','DEN','1956909','33348TX002000201','2014-01-01','2013-12-24 21:51:33','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:48:54'),(834,690,'Y','18','021','EC','A','','','AC','0000498145','0000498145','OH00000987163','IL','1','Strobel','Deborah','','','','34','293524542','2208 WOODBROOK TRL',0,'CUYAHOGA FALLS','OH','44223','3603','CY','39153','1951-07-30','F','U',':RET:2106-3','T','021','HLT','1676440','52664OH151001301','2014-01-01','2013-12-16 18:23:15','225.00',NULL,NULL,'736.81','511.81','R-OH012','OH0','736.81',NULL,0,'2013-12-25 18:06:26'),(13835,11040,'Y','18','021','EC','A','','','AC','0001182501','0001182501','OH00001095297','IL','1','Marstiller','Carolyn','','','','34','282628758','5911 Dailey Rd.',0,'New Franklin','OH','44319',NULL,'CY','39153','1959-01-12','F','M',':RET:2106-3','N','021','HLT','1515772','52664OH152000901','2014-01-01','2013-12-23 09:38:22','194.00',NULL,NULL,'348.73','154.73','R-OH012','OH0','348.73',NULL,0,'2013-12-26 13:12:09'),(3396,2725,'Y','18','021','EC','A','','','AC','0002161981','0002161981','LA00000196634','IL','1','Elias-Soto','Domingo','','','','34','584634765','7324 Menlo Dr.',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1976-08-03','M','M',NULL,'N','021','DEN','2343998','18575LA002000201','2014-01-01','2013-12-22 04:09:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:17:59'),(9502,7537,'Y','18','021','EC','A','','','AC','0000934657','0000934657','OH00000728234','IL','1','HARRIS','NOEL','B','','','34','077469817','2811 N PARK BLVD',0,'CLEVELAND HEIGHTS','OH','44118','4030','CY','39035','1969-03-11','F','U',NULL,'N','021','DEN','1439373','99734OH005000401','2014-01-01','2013-12-21 15:18:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:35:12'),(3532,2835,'Y','18','021','EC','A','','','AC','0001240326','0001240326','TX00000900102','IL','1','Thomas','Ashleigh','','','','34','642262430','501B Sgt. Rodney Taylor Ave.',0,'Seadrift','TX','77983',NULL,'CY','48057','1991-09-18','F','U',':RET:2106-3','N','021','DEN','2459573','33348TX002000101','2014-01-01','2013-12-21 23:43:31','0.00',NULL,NULL,'25.02','25.02','R-TX023','TX0','25.02',NULL,0,'2013-12-25 21:21:30'),(5618,4458,'Y','18','021','EC','A','','','AC','0000579954','0000579954','OH00000811004','IL','1','Shah','Ankita','','','','34','851051928','4089 sharon park lane',0,'cincinnati','OH','45241',NULL,'CY','39061','1989-02-12','F','U',':RET:2029-7','N','021','DEN','605454','99734OH005000401','2014-01-01','2013-11-26 14:04:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:42'),(18739,14932,'Y','18','021','EC','A','','','AC','0000110542','0000110542','OH00002316308','S3','1','Okonkwo','Maureen','Ebelechukwu','','','34','273138616','2541 Lorain Court',0,'Columbus','OH','43210',NULL,'CY','39049','2007-01-30','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3011410','99734OH005000301','2014-03-01','2014-01-16 16:53:36','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13',NULL,0,'2014-01-17 03:35:39'),(19078,15199,'Y','18','021','EC','A','','','AC','0001800782','0001800782','LA00002019128','IL','1','Bullard','Ramona','','','','34','434159789','107 DIXIE DR',0,'WEST MONROE','LA','71291','7798','CY','22073','1961-10-28','F','M',':RET:2106-3','N','021','DEN','2823659','18575LA002000101','2014-03-01','2014-01-17 23:19:31','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-21 08:44:24'),(19830,15813,'Y','18','021','EC','A','','','AC','0001261984','0001261984','TX00002350756','IL','1','MARTINEZ','CASIMIRA','','','','34','602207644','3025 FOREST PARK DR',0,'GRANBURY','TX','76048',NULL,'CY','48221','1955-03-04','F','M',NULL,'N','021','DEN','3066567','33348TX002000201','2014-03-01','2014-01-24 17:52:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-24 21:00:19'),(21110,16867,'Y','18','021','EC','A','','','AC','0001154856','0001154856','LA00002612495','IL','1','Gray','LaBreda','','','','34','437518860','110 Bailey Street',0,'Minden','LA','71055',NULL,'CY','22119','1983-10-12','F','U',':RET:2054-5','N','021','DEN','3475771','18575LA002000101','2014-03-01','2014-02-03 13:08:49','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-03 21:00:07'),(23512,18729,'N','01','021','EC','A',NULL,NULL,'','0000955980','0000815069','','IL','1','kennedy','lee','','','','34','425029261','111 EUGENE DR',0,'GULFPORT','MS','39503','3308','CY','28047','1955-01-03','M','',NULL,'N','021','DEN','3777327','46300MS002000101','2014-03-01','2014-02-13 12:31:34',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-13 22:02:14'),(24725,19633,'Y','18','021','EC','A','','','AC','0000720297','0000720297','OH00002854339','IL','1','SUBER','KATRINA','','','','34','298709971','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1976-02-22','F','U',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:38:47'),(25750,20423,'Y','18','021','EC','A','','','AC','0000746945','0000746945','OH00002485100','IL','1','Strayer','John','','','','34','229271496','1316 RUNAWAY BAY DR',0,'COLUMBUS','OH','43204','3872','CY','39049','1982-02-15','M','U',':RET:2106-3','N','021','DEN','3655764','99734OH005000401','2014-04-01','2014-02-24 15:48:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 09:30:45'),(26149,20733,'Y','18','024','14','A','','','TE','0001204586','0001204586','','IL','1','ALSHAHAL','MANAL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-18','F','',NULL,NULL,NULL,'','3501190','','2014-02-27','2014-02-27 14:20:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:28'),(62,55,'Y','18','021','EC','A','','','AC','0000589280','0000589280','OH00000397830','IL','1','Neff','Jennifer','','','','34','297600007','488 KELLER RD',0,'CHILLICOTHE','OH','45601','2935','CY','39141','1969-03-16','F','M',':RET:2106-3','N','021','DEN','909787','99734OH005000301','2014-01-01','2013-12-05 10:04:00','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2013-12-25 17:16:41'),(14460,11537,'Y','18','021','EC','A','','','AC','0001510392','0001510392','LA00000762874','IL','1','Sonnier','Russell','Joseph','','','34','439787495','1213 CARROLL ST',0,'WESTLAKE','LA','70669','4903','CY','22019','1950-03-10','M','U',':RET:2106-3','N','021','DEN','2071157','18575LA002000201','2014-02-01','2013-12-27 16:36:11','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-28 03:32:45'),(5775,4588,'Y','18','021','EC','A','','','AC','0000645975','0000645975','OH00000196811','IL','1','Eck','Kyle','','','','34','399024791','1065 NORTHFIELD PL S',0,'REYNOLDSBURG','OH','43068','1811','CY','39049','1986-09-02','M','R',':RET:2106-3','T','021','DEN','1492383','99734OH005000401','2014-01-01','2013-12-23 22:55:17','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:53'),(5694,4518,'Y','18','021','EC','A','','','AC','0000865825','0000865825','OH00001030823','IL','1','Harris','Janet','','','','34','288547119','2371 CALL RD',0,'STOW','OH','44224','1538','CY','39153','1956-09-20','F','M',':RET:2106-3','N','021','HLT','615861','52664OH151001501','2014-01-01','2013-11-26 14:23:12','463.00',NULL,NULL,'651.81','188.81','R-OH012','OH0','651.81',NULL,0,'2013-12-25 23:32:42'),(17722,14161,'Y','18','021','EC','A','','','AC','0000323521','0000323521','OH00001707744','IL','1','Ficarra','Mark','J','','','34','299723928','623 MEREDITH LN',0,'CUYAHOGA FALLS','OH','44223','3300','CY','39153','1963-05-16','M','U',':RET:2106-3','N','021','HLT','1747779','52664OH152000901','2014-02-01','2014-01-13 15:55:19','23.00',NULL,NULL,'291.73','268.73','R-OH012','OH0','291.73',NULL,0,'2014-01-14 01:33:14'),(17732,14169,'Y','18','021','EC','A','','','AC','0000625442','0000625442','OH00001407287','IL','1','Sweigert','Brian','','','','34','274826171','14285 Kauffman Ave.',0,'Sterling','OH','44276',NULL,'CY','39169','1969-12-08','M','M',NULL,'N','021','HLT','2088921','52664OH151001305','2014-02-01','2014-01-13 10:14:03','418.00',NULL,NULL,'623.08','205.08','R-OH014','OH0','311.54',NULL,0,'2014-01-14 01:33:20'),(17841,14252,'N','01','021','EC','A',NULL,NULL,'','0000636034','0000961883','','IL','1','Gassaway','Wesley','R','','','34','295824289','6821 VILLABROOK DR',0,'COLUMBUS','OH','43235','3932','CY','39049','1969-08-08','M','',':RET:2054-5','N','021','DEN','1902776','99734OH005000401','2014-02-01','2014-01-13 20:20:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:03'),(20506,16384,'Y','18','021','EC','A','','','AC','0001952518','0001952518','LA00001938045','IL','1','Jackson','Jennifer','','','','34','439067887','11445 Bard Ave',0,'Baton rouge','LA','70815',NULL,'CY','22033','1973-12-01','F','U',':RET:2054-5','N','021','DEN','3381412','18575LA002000201','2014-03-01','2014-01-29 16:29:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-29 21:01:16'),(24362,19350,'Y','18','021','EC','A','','','AC','0002008031','0002008031','LA00002510248','IL','1','MIDENCE','MIRIAM','','','','34','434172450','29 TRAMINER DR',0,'KENNER','LA','70065',NULL,'CY','22051','1960-04-04','F','M',NULL,'N','021','DEN','3745364','18575LA002000201','2014-04-01','2014-02-18 11:02:41','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:33'),(28251,22353,'Y','18','021','EC','A','','','AC','0000427688','0000427688','OH00003119165','IL','1','MILLER','CAROL ANN','','','','34','299508149','4028 HARDING AVE',0,'CINCINNATTI','OH','45211',NULL,'CY','39061','1949-10-03','F','U',':RET:2106-3','N','021','DEN','3248676','99734OH005000401','2014-04-01','2014-03-07 13:17:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-03-07 21:00:13'),(6883,5459,'Y','18','021','EC','A','','','AC','0001330172','0001330172','LA00000701694','IL','1','BAZINET','JANICE','MARIE','','','34','438801422','3335 WALNUT DR',0,'OPELOUSAS','LA','70570','6946','CY','22097','1951-02-22','F','U',':RET:2106-3','N','021','DEN','2188263','18575LA002000201','2014-01-01','2013-12-24 18:54:58','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 01:45:07'),(5507,4372,'N','01','021','EC','A',NULL,NULL,'','0001079108','0001010164','','IL','1','Strickland','Earl','','','','34','458925572','481 LCR 794',0,'Groesbeck','TX','76642',NULL,'CY','48293','1950-09-02','M','',':RET:2106-3','N','021','DEN','56181','33348TX002000101','2014-01-01','2013-11-26 18:15:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 23:15:04'),(1400,1162,'Y','18','021','EC','A','','','AC','0001968349','0001968349','LA00000517046','IL','1','KELLY','ROSE','','','','34','437862400','520 NEL CT',0,'GRETNA','LA','70056','2626','CY','22051','1952-04-08','F','M',':RET:2054-5','N','021','DEN','1943385','18575LA002000201','2014-01-01','2013-12-24 12:20:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:34'),(14520,11585,'Y','18','021','EC','A','','','AC','0000977605','0000977605','TX00001879621','IL','1','Hopkins','Felicia','','','','34','467516684','10555 Fondren Rd',0,'Houston','TX','77096',NULL,'CY','48201','1980-07-20','F','U',':RET:2054-5','N','021','DEN','1585868','33348TX002000201','2014-02-01','2013-12-27 16:56:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-28 03:34:16'),(24953,19787,'Y','18','021','EC','A','','','AC','0002097000','0002097000','LA00002579066','IL','1','BOWMAN','GREGORY','A','','','34','569672558','868 ELMDALE ST',0,'SHREVEPORT','LA','71118','3542','CY','22017','1968-07-29','M','U',':RET:2106-3','T','021','DEN','2694960','18575LA002000201','2014-04-01','2014-02-20 06:32:34','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-20 22:00:13'),(27863,22039,'Y','18','021','EC','A','','','AC','0000566676','0000566676','OH00002711605','IL','1','Zaccagnini','Bruce','','','','34','280587712','1890 MATTINGLY RD',0,'HINCKLEY','OH','44233','9240','CY','39103','1960-10-07','M','R',':RET:2106-3','N','021','HLT','3649330','52664OH151001501','2014-04-01','2014-03-05 05:47:53','0.00',NULL,NULL,'545.63','545.63','R-OH012','OH0','545.63',NULL,0,'2014-03-05 21:32:20'),(28152,22279,'Y','18','021','EC','A','','','AC','0000832059','0000832059','OH00002846393','IL','1','MCCRAY GILL','ELIZABETH','','','','34','297447910','1800 GREEN VALLEY DR',0,'TOLEDO','OH','43614','3216','CY','39095','1951-11-16','F','M',':RET:2106-3','N','021','HLT','3218391','92036OH005002606','2014-04-01','2014-03-06 11:37:39','461.00',NULL,NULL,'560.22','99.22','R-OH001','OH0','560.22',NULL,0,'2014-03-06 21:02:37'),(29134,23065,'Y','18','021','EC','A','','','AC','0000536992','0000536992','OH00003843801','IL','1','Peterson','William','','','','34','292707311','6731 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9414','CY','39123','1968-06-18','M','M',':RET:2106-3','N','021','HLT','3515767','92036OH003002705','2014-04-01','2014-03-10 16:08:11','441.00',NULL,NULL,'547.79','106.79','R-OH006','OH0','294.05',NULL,0,'2014-03-10 21:02:39'),(3170,2548,'N','01','021','EC','A',NULL,NULL,'','0000714933','0001032579','','IL','1','Tran','Cindy','','','','34','436916429','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','1974-12-25','F','',':RET:2047-9','N','021','DEN','227690','99734OH005000401','2014-01-01','2013-11-18 13:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:31:30'),(23024,18357,'N','01','021','EC','A',NULL,NULL,'','0000814510','0000598430','','IL','1','Martinez','Apolonia','','','','34','525457386','6450 Midway',0,'Canutillo','TX','79835',NULL,'CY','48141','1963-05-18','F','',':RET:2106-3','N','021','DEN','3084385','33348TX002000201','2014-03-01','2014-02-11 22:05:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-12 21:30:31'),(22969,18314,'Y','18','021','EC','A','','','AC','0000912998','0000912998','OH00002343230','IL','1','HILDRETH','MICHELLE','R','','','34','297749391','146 GOODVIEW AVE',0,'AKRON','OH','44305','3619','CY','39153','1963-04-20','F','U',':RET:2106-3','N','021','HLT','2759848','52664OH151001306','2014-03-01','2014-02-12 12:48:22','306.00',NULL,NULL,'398.29','92.29','R-OH012','OH0','398.29','CIC',0,'2014-02-12 21:00:15'),(4167,3318,'Y','18','021','EC','A','','','AC','0001031437','0001031437','OH00000413118','IL','1','Shaffer','Rick','','','','34','290563409','5585 Steamtown Road',0,'Ashley','OH','43003',NULL,'CY','39041','1956-11-30','M','M',':RET:2106-3','N','021','DEN','2427233','99734OH005000301','2014-01-01','2013-12-17 16:37:33','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:49:08'),(20092,16030,'Y','18','024','14','A','','','TE','0001554335','0001554335','','IL','1','Pearson','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-10','F','',NULL,NULL,NULL,'','2225265','','2014-01-26','2014-01-26 21:26:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:30'),(14399,11482,'Y','18','021','EC','A','','','AC','0000026628','0000026628','OH00001465392','IL','1','Mitchell','Marguerite','','','','34','302441894','2976 CAUDIL EAST RD',0,'BATAVIA','OH','45103','8415','CY','39025','1950-01-24','F','M',':RET:2106-3','N','021','DEN','1736564','99734OH005000401','2014-02-01','2013-12-27 16:02:26','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-28 03:31:08'),(15496,12399,'N','19','021','EC','A',NULL,NULL,'','0000910534','0000784339','','IL','1','DEVORE','NOLAN','FRANCIS','','','34','738870374','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2013-07-26','M','',NULL,'N','021','DEN','2022527','99734OH005000401','2014-02-01','2013-12-31 12:18:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:40'),(20774,16598,'Y','18','021','EC','A','','','AC','0000132642','0000132642','TX00001426900','IL','1','Hawkins','Robin','','','','34','465658246','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1981-03-05','F','R',':RET:2054-5','N','021','DEN','3014159','33348TX002000201','2014-03-01','2014-01-30 18:44:54','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2014-01-31 21:00:05'),(21314,17031,'Y','18','021','EC','A','','','AC','0001857611','0001857611','LA00001661233','IL','1','MITCHELL','FRANK','','','','34','436021439','10584 CLEVELAND AVE',0,'BELCHER','LA','71004','9608','CY','22017','1957-07-09','M','U',':RET:2054-5','N','021','DEN','2680607','18575LA002000201','2014-03-01','2014-02-04 12:58:19','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-04 21:00:18'),(26448,20979,'Y','18','021','EC','A','','','AC','0000625469','0000625469','OH00002811712','IL','1','Kreakie','Nicholas','','','','34','274904112','1882 BROOKWOOD CT',0,'ORRVILLE','OH','44667','2368','CY','39169','1983-08-30','M','M',':RET:2106-3','N','021','HLT','3614778','52664OH152000901','2014-04-01','2014-02-26 19:45:09','0.00',NULL,NULL,'368.17','368.17','R-OH014','OH0','185.39','CIC',0,'2014-02-28 07:30:24'),(84,73,'Y','18','021','EC','A','','','AC','0000344109','0000344109','OH00000089782','IL','1','Blowers','Bethany','','','','34','296843863','4120 Columbia Sq',0,'North Olmsted','OH','44070',NULL,'CY','39035','1986-01-06','F','U',NULL,'N','021','DEN','409459','99734OH005000301','2014-01-01','2013-12-05 12:40:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:17:14'),(2047,1677,'Y','18','021','EC','A','','','AC','0000678453','0000678453','TX00000293559','IL','1','DIAZ','GABRIELA','E','','','34','635277359','13469 ESTANCIAS DEL NORTE',0,'SAN ELIZARIO','TX','79849','7415','CY','48141','1992-04-24','F','M',NULL,'N','021','DEN','9112','33348TX002000201','2014-01-01','2013-12-10 15:24:10','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 19:15:44'),(21030,16803,'Y','18','021','EC','A','','','AC','0000581529','0000581529','OH00001846697','IL','1','Riddle','Dori','','','','34','261570140','1701 ORCHARD DR',0,'AKRON','OH','44333','1852','CY','39153','1970-03-14','F','U',':RET:2106-3','N','021','HLT','2912452','52664OH151001301','2014-03-01','2014-02-01 09:04:26','0.00',NULL,NULL,'302.62','302.62','R-OH012','OH0','302.62',NULL,0,'2014-02-01 19:00:44'),(19738,15730,'Y','18','021','EC','A','','','AC','0002011481','0002011481','LA00001632969','IL','1','WONG','SHU','ZHEN','','','34','436633142','3815 HUDSON ST',0,'METAIRIE','LA','70006','2805','CY','22051','1963-06-03','F','M',':RET:2034-7','N','021','DEN','2077910','18575LA002000201','2014-03-01','2014-01-23 00:28:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:09'),(5966,4723,'Y','18','021','EC','A','','','AC','0000427630','0000427630','OH00000332317','IL','1','lashaway','kathy','','','','34','294742037','15111 MERMILL RD',0,'RUDOLPH','OH','43462','9633','CY','39173','1964-11-12','F','M',':RET:2106-3','N','021','HLT','2437178','92036OH004002601','2014-01-01','2013-12-23 22:16:17','560.00',NULL,NULL,'587.35','27.35','R-OH001','OH0','267.49',NULL,0,'2013-12-25 23:51:28'),(22924,18274,'Y','18','021','EC','A','','','AC','0000693636','0000693636','TX00002279560','IL','1','Moss','Carrie','','','','34','455412208','1401 Hartford Rd',0,'Austin','TX','78703',NULL,'CY','48453','1967-10-07','F','U',':RET:1002-5','N','021','DEN','2766047','33348TX002000201','2014-03-01','2014-02-11 08:18:49','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-02-11 21:30:04'),(23565,18773,'Y','18','021','EC','A','','','AC','0000027933','0000027933','OH00002387694','IL','1','McCarthy','Brian','','','','34','279441480','3460 DRUMMOND RD',0,'TOLEDO','OH','43606','1659','CY','39095','1959-01-20','M','U',':RET:2106-3','N','021','HLT','2982832','92036OH004002601','2014-03-01','2014-02-13 16:16:49','324.00',NULL,NULL,'349.65','25.65','R-OH001','OH0','349.65',NULL,0,'2014-02-13 22:02:47'),(25300,20073,'Y','18','021','EC','A','','','AC','0000270056','0000270056','OH00001879574','IL','1','CLARKE','ELYSE','','','','34','165629583','4205 HEGNER AVE',0,'CINCINNATI','OH','45236','3614','CY','39061','1965-03-15','F','M',':RET:2106-3','N','021','DEN','3253499','99734OH005000401','2014-04-01','2014-02-25 15:37:20','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00','CIC',0,'2014-02-25 21:00:28'),(25678,20371,'Y','18','021','EC','A','','','AC','0000392418','0000392418','OH00002315705','IL','1','groh','lucas','','','','34','270881451','3306 s wapak rd',0,'lima','OH','45806',NULL,'CY','39003','1986-02-19','M','U',':RET:2106-3','N','021','HLT','2768881','92036OH003001506','2014-04-01','2014-02-22 16:03:25','192.00',NULL,NULL,'249.84','57.84','R-OH002','OH0','249.84',NULL,0,'2014-02-26 08:30:56'),(26921,21335,'N','19','021','EC','A',NULL,NULL,'','0001190120','0000689747','','S1','1','Hamric','Craig','Allen','','','34','293023960','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1998-01-30','F','',':RET:2106-3','N','021','DEN','3289675','99734OH005000401','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:15'),(27672,21888,'Y','18','021','EC','A','','','AC','0000127033','0000127033','TX00003289271','IL','1','Aguilar','Daniel','','','','34','461153554','115 COLERIDGE RD',0,'EL PASO','TX','79928','5110','CY','48141','1950-04-22','M','M',':RET:2106-3','T','021','DEN','3668495','33348TX002000201','2014-04-01','2014-03-04 19:13:08','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:30:34'),(28448,22510,'Y','18','021','EC','A','','','AC','0001979281','0001979281','LA00003577408','IL','1','Gilbert','Sean','','','','34','434574249','4429 Iberville St.',0,'New Orleans','LA','70119',NULL,'CY','22071','1982-12-29','M','U',':RET:2106-3','N','021','DEN','3558770','18575LA002000201','2014-04-01','2014-03-07 10:29:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:18'),(13438,10719,'N','01','021','EC','A',NULL,NULL,'','0001033655','0000701695','','IL','1','Woods','Eddie','','','','34','423703250','874 WADE WALK',0,'CINCINNATI','OH','45214','3419','CY','39061','1949-12-26','M','',':RET:2054-5','N','021','DEN','1744458','99734OH005000301','2014-01-01','2013-12-23 13:24:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:13'),(2041,1671,'Y','18','021','EC','A','','','AC','0000246807','0000246807','TX00001159914','IL','1','Rios','Yolanda','','','','34','154653187','9285 RAILROAD DR',0,'EL PASO','TX','79924','7432','CY','48141','1967-03-25','F','U',NULL,'N','021','DEN','230870','33348TX002000201','2014-01-01','2013-12-10 10:49:11','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 19:15:35'),(23130,18436,'Y','18','021','EC','A','','','AC','0000084092','0000084092','OH00002042904','IL','1','christman','jerry','','','','34','605075032','6619 HIGHLAND AVE',0,'CINCINNATI','OH','45236','3914','CY','39061','1971-10-11','M','R',':RET:2106-3','T','021','DEN','3590759','99734OH005000401','2014-03-01','2014-02-12 16:31:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:29'),(3323,2667,'N','19','021','EC','A',NULL,NULL,'','0000581482','0000499307','','S1','1','Riegler','John','','','','34','298112754','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','2006-06-04','M','',':RET:2106-3','N','021','DEN','2144635','99734OH005000301','2014-01-01','2013-12-22 16:21:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:07'),(19915,15883,'N','19','021','EC','A',NULL,NULL,'','0000300124','0000088560','','IL','1','Aziz','Sabika','','','','34','635923208','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1990-08-25','F','',':RET:2029-7','N','021','DEN','2526649','33348TX002000101','2014-03-01','2014-01-24 00:06:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-24 21:01:02'),(19828,15811,'Y','18','021','EC','A','','','AC','0000645481','0000645481','TX00002141375','IL','1','Riley','Frank','','','','34','088584513','505 W JEFFERSON ST',0,'WYLIE','TX','75098','4371','CY','48085','1966-06-26','M','U',':RET:2106-3','N','021','DEN','2318773','33348TX002000201','2014-03-01','2014-01-24 17:30:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-24 21:00:17'),(15586,12473,'Y','18','021','EC','A','','','AC','0000868239','0000868239','OH00000768510','IL','1','Maxfield','Jessie','','','','34','252530751','930 MOHAWK TRL',0,'MILFORD','OH','45150','1761','CY','39025','1970-02-15','F','U',':RET:2106-3','N','021','DEN','2570933','99734OH005000301','2014-02-01','2013-12-30 20:00:06','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,1,'2014-01-02 04:32:19'),(17523,14009,'Y','18','021','EC','A','','','AC','0001065992','0001065992','OH00001780536','IL','1','Byers','Anthony','Glenn','','','34','277580673','859 W NORTH BEND RD',0,'CINCINNATI','OH','45224','1357','CY','39061','1958-04-13','M','U',':RET:2054-5','N','021','DEN','1787676','99734OH005000401','2014-02-01','2014-01-12 11:32:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 03:01:37'),(15921,12749,'Y','18','021','EC','A','','','AC','0000647505','0000647505','MS00001780295','IL','1','Reed','Kim','','','','34','426257901','5081 OLD NATCHEZ RD',0,'HAZLEHURST','MS','39083','9322','CY','28029','1962-11-05','F','U',':RET:2054-5','N','021','DEN','2477208','46300MS002000201','2014-02-01','2014-01-02 09:41:10','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-03 02:06:40'),(25462,20202,'Y','18','021','EC','A','','','AC','0000996557','0000996557','TX00001983383','IL','1','Parrott','William','','','','34','510500611','3016 Highgate Ln',0,'Bedford','TX','76021',NULL,'CY','48439','1951-01-22','M','M',':RET:2106-3','N','021','DEN','3623303','33348TX002000201','2014-04-01','2014-02-25 15:48:15','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-25 21:31:32'),(28603,22637,'Y','18','021','EC','A','','','AC','0000746965','0000746965','OH00002871467','IL','1','MOON','JACQUELINE','L','','','34','301562924','127 STULL AVENUE',0,'AKRON','OH','44312',NULL,'CY','39153','1955-01-15','F','U',':RET:2106-3','N','021','DEN','3646803','99734OH005000401','2014-04-01','2014-03-08 13:25:32','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-08 21:30:10'),(13869,11065,'Y','18','021','EC','A','','','AC','0000598743','0000598743','OH00000140561','IL','1','Bennett','Jan','','','','34','277467831','931 MIDDLEBURY RD',0,'KENT','OH','44240','3458','CY','39133','1963-05-21','F','U',':RET:2106-3','N','021','HLT','1703514','52664OH151001501','2014-01-01','2013-12-23 11:25:13','0.00',NULL,NULL,'477.69','477.69','R-OH012','OH0','477.69',NULL,0,'2013-12-26 13:12:59'),(6788,5383,'N','01','021','EC','A',NULL,NULL,'','0000570083','0001144702','','IL','1','Ngo','Cuc','','','','34','450530892','527 COLONY LAKE ESTATES DR',0,'STAFFORD','TX','77477','4597','CY','48157','1956-04-30','F','',':RET:2047-9','N','021','DEN','24560','33348TX002000201','2014-01-01','2013-11-24 20:19:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:17:00'),(23426,18665,'Y','18','021','EC','A','','','AC','0000520158','0000520158','TX00002054154','IL','1','Greyard','Shahala','','','','34','565437904','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','1973-12-02','F','M',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42','0.00',NULL,NULL,'143.88','143.88','R-TX017','TX0','14.61',NULL,0,'2014-02-13 22:01:25'),(23111,18420,'N','01','021','EC','A',NULL,NULL,'','0000504509','0000703824','','IL','1','wong','christina','','','','34','617462839','8111 EAGLE RIDGE DR',0,'WEST CHESTER','OH','45069','1976','CY','39017','1972-10-27','F','',':RET:2028-9^:RET:2500-7','N','021','DEN','2782996','99734OH005000401','2014-03-01','2014-02-12 17:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:17'),(22670,18103,'Y','18','021','EC','A','','','AC','0000378158','0000378158','TX00002102011','IL','1','Bratchett','Sirley','','','','34','451594374','1002 Spruce St.',0,'San Augustine','TX','75972',NULL,'CY','48405','1966-01-12','F','U',':RET:2054-5','N','021','DEN','3847155','33348TX002000201','2014-03-01','2014-02-11 15:16:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:41'),(2802,2264,'N','01','021','EC','A',NULL,NULL,'','0000236231','0000633711','','IL','1','King','Krista','Nicole','','','34','622349058','331 E RUTH ST',0,'SIDNEY','OH','45365','1620','CY','39149','1986-05-16','F','',':RET:2106-3','N','021','HLT','1159473','92036OH006000501','2014-01-01','2013-12-02 16:49:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','197.56',NULL,0,'2013-12-25 19:50:27'),(19582,15609,'Y','18','021','EC','A','','','AC','0001563825','0001563825','LA00001659527','IL','1','Huton','Leon','','','','34','123682635','3020 DRYADES ST',0,'NEW ORLEANS','LA','70115','5118','CY','22071','1971-06-14','M','U',':RET:2054-5','T','021','DEN','2914604','18575LA002000201','2014-03-01','2014-01-22 12:44:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 03:02:40'),(19403,15470,'Y','18','024','14','A','','','TE','0001182471','0001182471','','IL','1','Kluckman','Alison','Megan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-08-09','F','',NULL,NULL,NULL,'','51071','','2014-01-21','2014-01-21 15:05:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:54'),(4258,3393,'Y','18','021','EC','A','','','AC','0000720240','0000720240','OH00000864662','IL','1','TAYLOR','DORIS','','','','34','281547441','724 BARLOW RD',0,'HUDSON','OH','44236','3703','CY','39153','1951-02-04','F','M',':RET:2106-3','N','021','HLT','2446943','52664OH151001501','2014-01-01','2013-12-17 11:25:18','0.00',NULL,NULL,'768.43','768.43','R-OH012','OH0','768.43',NULL,0,'2013-12-25 21:51:28'),(18626,14848,'N','19','021','EC','A',NULL,NULL,'','0000333893','0000805141','','IL','1','Scott','Hannah','N','','','34','301020260','9380 Hunt Club Trail NE',0,'Warren','OH','44484',NULL,'CY','39155','1998-07-17','F','',':RET:2106-3','N','021','HLT','1745173','92036OH001003201','2014-02-01','2014-01-15 17:34:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','185.41',NULL,0,'2014-01-16 08:47:30'),(17423,13943,'Y','18','021','EC','A','','','AC','0001145991','0001145991','OH00002143332','IL','1','Pitz','Joseph','','','','34','277740839','535 northeast ave',0,'tallmadge','OH','44278',NULL,'CY','39153','1963-01-29','M','M',':RET:2106-3','N','021','HLT','1782251','52664OH151001306','2014-02-01','2014-01-10 09:31:47','813.00',NULL,NULL,'1019.37','206.37','R-OH012','OH0','415.91',NULL,0,'2014-01-13 03:00:28'),(9376,7434,'Y','18','021','EC','A','','','AC','0001662934','0001662934','LA00000883411','IL','1','cothren','Zachary','','','','34','437770665','1534 BURBANK DR',0,'NEW ORLEANS','LA','70122',NULL,'CY','22071','1987-02-25','M','U',NULL,'N','021','DEN','1857471','18575LA002000201','2014-01-01','2013-12-21 14:43:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:57'),(14107,11243,'Y','18','021','EC','A','','','AC','0000472268','0000472268','OH00001255878','IL','1','CAMBRON','JACK','','','','34','297701393','183 MAPLEWOOD AVE',0,'WHITEHALL','OH','43213',NULL,'CY','39049','1971-07-16','M','M',NULL,'N','021','DEN','1478014','99734OH005000401','2014-02-01','2013-12-26 13:55:36','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:45'),(754,622,'N','01','021','EC','A',NULL,NULL,'','0000921331','0000155035','','IL','1','Minard','David','','','','34','570437202','5829 PARKSIDE CT',0,'GRANBURY','TX','76048','3211','CY','48221','1960-10-10','M','',':RET:2106-3','T','021','DEN','2424956','33348TX002000201','2014-01-01','2013-12-16 10:13:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:04:22'),(24100,19158,'Y','18','021','EC','A','','','AC','0001040535','0001040535','TX00002226577','31','1','Simpson','Alesia','','','','34','431736195','PO Box 506',0,'Helena','AR','72342',NULL,'CY','48439','1989-04-02','F','U',NULL,'N','021','DEN','3450923','33348TX002000201','2014-03-01','2014-02-14 23:53:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-15 22:01:30'),(23516,18733,'Y','18','021','EC','A','','','AC','0000874301','0000874301','MS00002222928','IL','1','lawson','mattie','m','','','34','428271958','1400 28TH ST',0,'GULFPORT','MS','39501','6158','CY','28047','1966-03-02','F','U',NULL,'N','021','DEN','3029040','46300MS002000101','2014-03-01','2014-02-13 15:26:48','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-13 22:02:17'),(13800,11016,'Y','18','021','EC','A','','','AC','0000615442','0000615442','MS00001248654','IL','1','Russell','Sharon','','','','34','572430958','1445 GATES RD',0,'COLUMBIA','MS','39429','5042','CY','28091','1961-11-13','F','M',':RET:2054-5','N','021','DEN','2044531','46300MS002000101','2014-01-01','2013-12-23 12:45:45','0.00',NULL,NULL,'81.45','81.45','R-MS006','MS0','27.15',NULL,0,'2013-12-26 13:11:21'),(1598,1336,'Y','18','021','EC','A','','','AC','0001017623','0001017623','TX00001128015','IL','1','Timberlake','Judy','','','','34','462949956','1815 Vincent',0,'Brownwood','TX','76801',NULL,'CY','48049','1951-12-03','F','M',':RET:2106-3','N','021','DEN','1491056','33348TX002000201','2014-01-01','2013-12-24 12:30:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:51:58'),(4429,3520,'Y','18','021','EC','A','','','AC','0000066225','0000066225','OH00000941059','IL','1','BIANTHINI','JAMES','KEVIN','','','34','284646953','4422 CABERNET CT',0,'LIBERTY TWP','OH','45011','5201','CY','39017','1958-01-19','M','M',':RET:2106-3','N','021','DEN','444546','99734OH005000401','2014-01-01','2013-12-12 17:38:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:49'),(28681,22697,'Y','18','021','EC','A','','','AC','0000759774','0000759774','OH00003746521','IL','1','FRAZEE','LYNN','','','','34','272564271','2488 DONNA DR',0,'RICHFEILD','OH','44286',NULL,'CY','39153','1954-06-19','M','U',':RET:2106-3','N','021','DEN','4124561','99734OH005000301','2014-04-01','2014-03-07 19:42:47','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-08 21:30:56'),(9765,7732,'Y','18','021','EC','A','','','AC','0000516867','0000516867','OH00000925503','IL','1','Buczak','John','','','','34','280607623','7010 Carriage Hill Dr',0,'Brecksville','OH','44141',NULL,'CY','39035','1956-07-18','M','U',':RET:2106-3','T','021','DEN','1202759','99734OH005000401','2014-01-01','2013-10-20 19:26:46','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 05:00:17'),(9461,7505,'Y','18','021','EC','A','','','AC','0000851828','0000851828','OH00000698979','IL','1','FARNSWORTH','ELAINA','','','','34','300684522','306 YOUNG ST',0,'MIDDLETOWN','OH','45044','4353','CY','39017','1967-02-03','F','U',':RET:2106-3','N','021','DEN','1440524','99734OH005000401','2014-01-01','2013-12-21 00:12:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:13'),(20588,16451,'Y','18','024','14','A','','','TE','0001059505','0001059505','','IL','1','Phipps','Tad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-01-06','M','',NULL,NULL,NULL,'','2943858','','2014-01-29','2014-01-29 20:49:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:07'),(20217,16131,'Y','18','021','EC','A','','','AC','0001008972','0001008972','OH00002526936','IL','1','Kinhalt','David','','','','34','278586795','800 West fork road',0,'STOUT','OH','45684',NULL,'CY','39001','1956-10-18','M','M',NULL,'N','021','HLT','2389733','92036OH003000605','2014-03-01','2014-01-27 13:55:34','816.00',NULL,NULL,'983.93','167.93','R-OH005','OH0','546.34',NULL,0,'2014-01-27 21:01:42'),(19491,15535,'N','19','021','EC','A',NULL,NULL,'','0000321062','0000451306','','IL','1','CURTIS','BENJAMIN','','','','34','268964543','4672 N COUNTY LINE RD',0,'GENEVA','OH','44041','7613','CY','39007','1992-08-07','M','',NULL,'N','021','HLT','3117932','52664OH151001305','2014-03-01','2014-01-21 19:10:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2014-01-23 03:02:06'),(18886,15047,'Y','18','021','EC','A','','','AC','0000780536','0000780536','OH00002572212','IL','1','hansford','julia','','','','34','278887806','3355 parkcrest lane',0,'cincinnati','OH','45211',NULL,'CY','39061','1987-12-22','F','U',':RET:2106-3','N','021','HLT','3020289','92036OH005001205','2014-02-01','2014-01-15 22:44:47','85.00',NULL,NULL,'219.82','134.82','R-OH004','OH0','219.82',NULL,0,'2014-01-17 03:36:30'),(2237,1838,'Y','18','021','EC','A','','','AC','0001037319','0001037319','OH00000690002','IL','1','Wyatt','Amanda','','','','34','268882289','2635 BALL RD',0,'LOVELAND','OH','45140','1529','CY','39165','1983-05-19','F','U',':RET:2106-3','N','021','HLT','491002','92036OH005001204','2014-01-01','2013-12-10 17:47:53','68.00',NULL,NULL,'243.66','175.66','R-OH004','OH0','243.66',NULL,0,'2013-12-25 19:20:53'),(13878,11074,'Y','18','021','EC','A','','','AC','0000510655','0000510655','OH00000414957','IL','1','SEES','PENNY','','','','34','294726041','11762 BEECHDALE AVE NW',0,'UNIONTOWN','OH','44685',NULL,'CY','39151','1964-08-31','F','M',NULL,'N','021','HLT','2386338','52664OH151001501','2014-01-01','2013-12-23 14:56:59','215.00',NULL,NULL,'842.52','627.52','R-OH015','OH0','456.30',NULL,0,'2013-12-26 13:13:15'),(8862,7026,'Y','18','021','EC','A','','','AC','0000137830','0000137830','TX00000378692','IL','1','Stewart','Belinda','','','','34','463793699','1430 17TH ST NE',0,'PARIS','TX','75460','2822','CY','48277','1985-12-02','F','U',':RET:2054-5','N','021','DEN','2027935','33348TX002000201','2014-01-01','2013-12-18 12:05:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:18'),(4449,3536,'Y','18','024','14','A','','','TE','0000911738','0000911738','','IL','1','Vranich','Sherry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-09','F','',NULL,NULL,NULL,'','741892','','2013-12-12','2013-12-12 10:01:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:02:21'),(26112,20708,'N','01','021','EC','A',NULL,NULL,'','0000950727','0001113192','','IL','1','Tran','lee','','','','34','278928418','4540 HIDDEN RIDGE CT',0,'COLUMBUS','OH','43230','4124','CY','39049','1972-12-12','M','',':RET:2047-9','N','021','DEN','3623342','99734OH005000401','2014-04-01','2014-02-26 19:03:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:16'),(27070,21433,'Y','18','021','EC','A','','','AC','0002200019','0002200019','LA00002762806','IL','1','RICHARD','KOSHA','','','','34','435532402','410 KING ST',0,'JENNINGS','LA','70546','7427','CY','22053','1975-10-26','F','U',':RET:2054-5','N','021','DEN','3629092','18575LA002000201','2014-04-01','2014-03-03 16:04:57','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-03 21:30:05'),(27835,22016,'Y','18','021','EC','A','','','AC','0000367450','0000367450','OH00003320889','IL','1','Roth','Suzanne','Renee','','','34','281504460','209 E WYANDOT AVE',0,'UPPER SANDUSKY','OH','43351','1431','CY','39175','1951-08-12','F','U',':RET:2106-3','N','021','DEN','3884289','99734OH005000301','2014-05-01','2014-03-05 15:13:03','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-03-05 21:32:03'),(28834,22820,'Y','18','021','EC','A','','','AC','0000327336','0000327336','OH00003041481','IL','1','O\'Neal','John','','','','34','380825899','225 Pinecone Drive',0,'Springboro','OH','45066',NULL,'CY','39165','1969-09-03','M','R',NULL,'N','021','HLT','3737757','92036OH006001201','2014-04-01','2014-03-09 12:57:46','0.00',NULL,NULL,'660.74','660.74','R-OH004','OH0','237.84',NULL,0,'2014-03-09 21:01:09'),(257,214,'Y','18','021','EC','A','','','AC','0000084014','0000084014','OH00000593715','IL','1','Grace','Evelyn','Dorothea','','','34','291509009','2622 E BLUELICK RD',0,'LIMA','OH','45801','2240','CY','39003','1951-10-07','F','M',':RET:2106-3','N','021','HLT','304728','92036OH001001501','2014-01-01','2013-12-05 16:52:58','525.00',NULL,NULL,'762.70','237.70','R-OH002','OH0','762.70',NULL,0,'2013-12-25 17:21:45'),(24321,19315,'Y','18','021','EC','A','','','AC','0000984927','0000984927','TX00002997539','IL','1','MAURER','TANYA','D','','','34','485963675','405 CYPRESS CIRCLE',0,'TYLER','TX','75703',NULL,'CY','48423','1974-12-17','F','U',':RET:2106-3','N','021','DEN','3472281','33348TX002000201','2014-04-01','2014-02-18 10:51:43','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-18 22:00:08'),(21854,17451,'Y','18','021','EC','A','','','AC','0000984886','0000984886','OH00001552178','IL','1','RESER','SHANNON','','','','34','301809370','5909 THORNBERRY CT',0,'MASON','OH','45040','7757','CY','39165','1977-05-17','M','M',NULL,'N','021','DEN','3253048','99734OH005000301','2014-03-01','2014-02-05 23:34:09','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:01:17'),(20013,15962,'Y','18','021','EC','A','','','AC','0001118253','0001118253','TX00002069711','IL','1','SAN MIGUEL','ROSA','E','','','34','631929590','7109 WESTOVER DR',0,'EL PASO','TX','79912','7681','CY','48141','1960-12-10','F','U',NULL,'N','021','DEN','2704179','33348TX002000201','2014-03-01','2014-01-25 22:15:06','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-26 19:00:10'),(19012,15140,'Y','18','021','EC','A','','','AC','0002030436','0002030436','LA00001986622','IL','1','Savage','Christopher','','','','34','436833627','P.O.Box 3104',0,'Jena','LA','71342',NULL,'CY','22059','1991-10-18','M','U',':RET:2054-5','N','021','DEN','2731397','18575LA002000201','2014-03-01','2014-01-17 12:56:55','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-20 08:06:20'),(9565,7580,'N','19','021','EC','A',NULL,NULL,'','0000718911','0000227053','','S1','1','Pushkaran','Suvarnamala','Ashish','','','34','269133298','1395 STABLEVIEW CIR',0,'MAINEVILLE','OH','45039','7916','CY','39165','2006-08-07','M','',':RET:2029-7','N','021','DEN','1600650','99734OH005000301','2014-01-01','2013-12-21 16:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:38'),(18204,14529,'Y','18','021','EC','A','','','AC','0000643251','0000643251','OH00002537423','IL','1','Hopkins','Ciara','','','','34','272845389','19042 CENTER ST',0,'WAPAKONETA','OH','45895',NULL,'CY','39011','1985-08-23','F','M',NULL,'N','021','HLT','2126559','92036OH003001505','2014-02-01','2014-01-14 14:14:01','113.00',NULL,NULL,'249.84','136.84','R-OH002','OH0','249.84',NULL,0,'2014-01-15 02:08:07'),(17890,14289,'Y','18','021','EC','A','','','AC','0001191359','0001191359','OH00002103574','IL','1','distelhorst','sunnie',NULL,NULL,NULL,NULL,NULL,'2700 CALUMET ST',0,'COLUMBUS','OH','43202','2315','CY','39049','1978-12-23','F','U',':RET:2106-3','N','021','DEN','2197994','99734OH005000401','2014-02-01','2014-01-14 15:42:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:19'),(23819,18952,'Y','18','021','EC','A','','','AC','0000556760','0000556760','OH00002356295','IL','1','Grant','Juanita','','','','34','249042251','35 AUGUSTA LN',0,'TIFFIN','OH','44883','5505','CY','39147','1950-01-09','F','M',':RET:2054-5','N','021','HLT','3239881','92036OH005002704','2014-03-01','2014-02-14 00:29:38','353.00',NULL,NULL,'584.98','231.98','R-OH006','OH0','584.98',NULL,0,'2014-02-14 21:31:39'),(9441,7490,'Y','18','021','EC','A','','','AC','0000600793','0000600793','OH00000926370','IL','1','bryant','tina','marie','','','34','295728868','7511 E HARBOR RD',0,'MARBLEHEAD','OH','43440','9330','CY','39123','1964-07-08','F','M',NULL,'N','021','HLT','1914336','92036OH004002701','2014-01-01','2013-12-21 12:44:23','455.00',NULL,NULL,'587.35','132.35','R-OH006','OH0','267.49',NULL,0,'2013-12-26 04:33:41'),(23370,18622,'Y','18','021','EC','A','','','AC','0001201935','0001201935','OH00002424522','IL','1','Hulett','Angela','','','','34','085723630','6509 Marsol Rd.',0,'Mayfield Heights','OH','44124',NULL,'CY','39035','1977-06-21','F','U',':RET:2054-5','N','021','DEN','3003662','99734OH005000401','2014-03-01','2014-02-12 21:35:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:53'),(8875,7036,'N','01','021','EC','A',NULL,NULL,'','0000585484','0001039038','','IL','1','AQEEL','SAIMA','','','','34','628749852','9331 ANTWERP CV',0,'HOUSTON','TX','77070','2000','CY','48201','1977-01-20','F','',':RET:2028-9','N','021','DEN','2086841','33348TX002000201','2014-01-01','2013-12-18 14:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:01:40'),(16393,13117,'N','01','021','EC','A',NULL,NULL,'','0000145768','0000015393','','IL','1','Rodriguez','Daniel','','','','34','458152202','5305 N Hwy 281',0,'Edinburg','TX','78539',NULL,'CY','48215','1959-02-09','M','',':RET:2106-3','N','021','DEN','1746433','33348TX002000201','2014-02-01','2014-01-06 10:30:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-07 04:03:37'),(4596,3639,'Y','18','021','EC','A','','','AC','0000388627','0000388627','OH00000802438','IL','1','SIMPSON','DIANNE','LYNN','','','34','268709110','840 W NIMISILA RD',0,'AKRON','OH','44319','4623','CY','39153','1960-02-25','F','U',':RET:2106-3','T','021','HLT','342194','52664OH151001304','2014-01-01','2013-12-12 15:42:18','292.00',NULL,NULL,'523.18','231.18','R-OH012','OH0','523.18',NULL,0,'2013-12-25 22:05:35'),(2874,2322,'N','01','021','EC','A',NULL,NULL,'','0000163688','0000482853','','IL','1','Farias','Katie','Ann','','','34','466896151','226 CAMARGO ST',0,'SAN ANTONIO','TX','78210','1088','CY','48029','1979-11-11','F','',':RET:2106-3','N','021','DEN','762156','33348TX002000201','2014-01-01','2013-10-22 00:17:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:02:01'),(2891,2335,'Y','18','021','EC','A','','','AC','0000966881','0000966881','OH00000745696','IL','1','SHEARER','LISA','MARIE','','','34','274543914','7077 PLEASANT HOME RD',0,'STERLING','OH','44276','9624','CY','39169','1958-09-13','F','M',':RET:2106-3','N','021','HLT','697164','52664OH151001501','2014-01-01','2013-12-06 14:02:40','276.00',NULL,NULL,'596.45','320.45','R-OH014','OH0','596.45',NULL,0,'2013-12-25 20:15:10'),(3545,2847,'Y','18','021','EC','A','','','AC','0000454421','0000454421','TX00000758589','IL','1','Wolfe','Justin','','','','34','631071703','3112 E COUNTY ROAD 136',0,'MIDLAND','TX','79706','7130','CY','48329','1989-05-20','M','M',':RET:2106-3','T','021','DEN','2252551','33348TX002000101','2014-01-01','2013-12-22 18:23:36','0.00',NULL,NULL,'139.14','139.14','R-TX016','TX0','25.02',NULL,0,'2013-12-25 21:21:55'),(3483,2796,'Y','18','021','EC','A','','','AC','0000401234','0000401234','OH00001195842','IL','1','Cicero','Eileen','','','','34','291728416','1860 ROYAL OAK DR',0,'PAINESVILLE','OH','44077','7708','CY','39085','1962-09-14','F','U',':RET:2106-3','N','021','DEN','2015213','99734OH005000401','2014-01-01','2013-12-22 11:23:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:14'),(24819,19678,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000105425','','IL','1','Burdick','Isabella','','','','34','294086988','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','2004-01-08','F','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:30'),(26134,20725,'Y','18','021','EC','A','','','AC','0001204586','0001204586','OH00003384721','IL','1','ALSHAHAL','MANAL','','','','34','271860960','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','1978-05-18','F','M',':RET:2106-3','N','021','DEN','3501190','99734OH005000401','2014-03-01','2014-02-27 12:27:16','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:23'),(26540,21045,'N','01','021','EC','A',NULL,NULL,'','0000886965','0001029429','','IL','1','MCGEE','LUTHER','','','','34','498567613','2057 HERITAGE DR',0,'SANDUSKY','OH','44870','5158','CY','39043','1949-10-02','M','',':RET:2054-5','N','021','DEN','3359380','99734OH005000301','2014-04-01','2014-02-28 11:17:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:08'),(26846,21277,'Y','18','021','EC','A','','','AC','0001941276','0001941276','LA00002864569','IL','1','Robinson','Amber','Danielle','','','34','591258883','6315 greenwell street',0,'baton rouge','LA','70812',NULL,'CY','22033','1992-07-21','F','U',':RET:2054-5','N','021','DEN','3249912','18575LA002000201','2014-04-01','2014-03-01 13:24:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-01 21:00:47'),(27535,21784,'Y','18','021','EC','A','','','AC','0000616885','0000616885','OH00002963847','IL','1','THIERET','SHARON','M','','','34','286682769','7565 CELINA ST NW',0,'MASSILLON','OH','44646','1007','CY','39151','1964-06-26','F','M',':RET:2106-3','N','021','DEN','3776480','99734OH005000401','2014-04-01','2014-03-03 18:01:25','0.00',NULL,NULL,'71.95','71.95','R-OH015','OH0','0.00','CIC',0,'2014-03-04 21:30:05'),(29,24,'Y','18','021','EC','A','','','AC','0000257108','0000257108','OH00000903216','IL','1','McGreevy','Jean','','','','34','291546588','2987 SUNSET DR',0,'COLUMBUS','OH','43202','1974','CY','39049','1954-05-15','F','U',NULL,'N','021','DEN','504755','99734OH005000401','2014-01-01','2013-12-05 14:53:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:15:45'),(7164,5683,'Y','18','021','EC','A','','','AC','0000128106','0000128106','OH00001405420','IL','1','Quincy','James','','','','34','365804561','19425 Van Aken Blv.',0,'Shaker Heights','OH','44122',NULL,'CY','39035','1967-06-12','M','U',':RET:2054-5','N','021','HLT','2574901','92036OH002000801','2014-01-01','2013-12-24 22:03:57','0.00',NULL,NULL,'404.99','404.99','R-OH011','OH0','404.99',NULL,0,'2013-12-26 01:52:34'),(22581,18035,'Y','18','021','EC','A','','','AC','0001084188','0001084188','OH00001842134','IL','1','ALBERS','KENNETH','','','','34','285569858','13080 HARDIN WAPAK RD.',0,'ANNA','OH','45302',NULL,'CY','39149','1954-08-23','M','M',':RET:2106-3','T','021','HLT','3702745','92036OH004000501','2014-03-01','2014-02-10 10:32:13','938.00',NULL,NULL,'1090.90','152.90','R-OH003','OH0','572.17',NULL,0,'2014-02-10 21:32:03'),(20749,16579,'Y','18','021','EC','A','','','AC','0001068297','0001068297','OH00001967905','IL','1','Wright','Jeffrey','','','','34','286687126','130 ESTHER ST',0,'TOLEDO','OH','43605','1435','CY','39095','1961-04-26','M','U',':RET:2106-3','N','021','HLT','1662965','92036OH005002605','2014-03-01','2014-01-30 14:41:01','273.00',NULL,NULL,'380.63','107.63','R-OH001','OH0','380.63',NULL,0,'2014-01-30 21:01:29'),(18139,14484,'N','01','021','EC','A',NULL,NULL,'','0002318750','0001741310','','IL','1','JONES','JOHNNY','','','','34','434174813','1011 LAURIE LN',0,'SAINT MARTINVILLE','LA','70582','6523','CY','22099','1960-12-08','M','',':RET:2054-5','T','021','DEN','1360468','18575LA002000101','2014-02-01','2014-01-13 23:19:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-15 02:07:46'),(8820,6992,'Y','18','021','EC','A','','','AC','0000605946','0000605946','OH00000605020','IL','1','Roysdon','Arron','','','','34','273943517','167 Garden Drive',0,'Loveland','OH','45140',NULL,'CY','39025','1981-11-01','M','M',':RET:2106-3','N','021','HLT','2387335','92036OH004000601','2014-01-01','2013-12-18 13:48:25','137.00',NULL,NULL,'204.20','67.20','R-OH005','OH0','204.20',NULL,0,'2013-12-26 04:00:14'),(16999,13606,'Y','18','021','EC','A','','','AC','0000355061','0000355061','OH00001384833','IL','1','FIGHTER','JACQUELINE','A','','','34','302440035','5638 STERLING LAKES CIR',0,'MASON','OH','45040','7055','CY','39165','1951-03-29','F','U',':RET:2106-3','N','021','DEN','1891943','99734OH005000301','2014-02-01','2014-01-09 14:59:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:20:29'),(16882,13508,'Y','18','021','EC','A','','','AC','0001119580','0001119580','TX00001999794','IL','1','CLAYBURG','SHIRLEY','M','','','34','467614545','120 LYNN DR',0,'LIVINGSTON','TX','77351','3353','CY','48373','1969-07-14','F','U',':RET:2106-3','N','021','DEN','2016848','33348TX002000201','2014-02-01','2014-01-09 11:05:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:22'),(471,384,'Y','18','021','EC','A','','','AC','0000584247','0000584247','OH00000009462','IL','1','Chapman','Paula','Jean','','','34','300628527','1101 County Road 251',0,'Polk','OH','44866',NULL,'CY','39005','1963-10-26','F','U',':RET:2106-3','N','021','HLT','209985','52664OH151001306','2014-01-01','2013-12-04 14:59:07','377.00',NULL,NULL,'398.29','21.29','R-OH012','OH0','398.29',NULL,0,'2013-12-25 17:47:52'),(16308,13057,'Y','18','021','EC','A','','','AC','0002185725','0002185725','LA00001395129','IL','1','Frasier','Raymond','','','','34','433764531','21 BOONE RD',0,'DELHI','LA','71232','6708','CY','22083','1954-10-21','M','M',':RET:2106-3','N','021','DEN','2066244','18575LA002000201','2014-02-01','2014-01-06 10:16:18','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-07 04:01:21'),(6673,5293,'Y','18','021','EC','A','','','AC','0000077523','0000077523','OH00001201377','IL','1','Fulton','Gerald','','','','34','287767052','623 DAYTONIA AVE',0,'FAIRBORN','OH','45324','2330','CY','39057','1965-07-21','M','U',':RET:2106-3','T','021','HLT','408099','92036OH006000501','2014-01-01','2013-11-15 20:24:36','84.00',NULL,NULL,'354.46','270.46','R-OH003','OH0','354.46',NULL,0,'2013-12-26 01:01:10'),(1778,1464,'N','19','021','EC','A',NULL,NULL,'','0000432762','0000406137','','IL','1','miller','kenzington',NULL,NULL,NULL,NULL,NULL,'94 marion ave',0,'mogadore','OH','44260',NULL,'CY','39153','2005-12-27','F','',':RET:2106-3','N','021','DEN','2417846','99734OH005000301','2014-01-01','2013-12-24 15:00:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:16'),(15177,12128,'Y','18','024','14','A','','','TE','0001068243','0001068243','','IL','1','Glascock','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-07-28','M','',NULL,NULL,NULL,'','550541','','2013-12-30','2013-12-30 17:25:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:43'),(5808,4614,'Y','18','024','14','A','','','TE','0000415450','0000415450','','IL','1','anderson','amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-05','F','',NULL,NULL,NULL,'','966030','','2013-12-23','2013-12-23 21:36:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:47:42'),(3098,2489,'Y','18','021','EC','A','','','AC','0000969418','0000969418','OH00000923400','IL','1','Williams','Katherine','','','','34','272705392','1454 Golden Gate Blvd',0,'Mayfield Hts','OH','44124',NULL,'CY','39035','1962-07-10','F','R',':RET:2054-5','T','021','HLT','1076213','92036OH004000801','2014-01-01','2013-12-06 15:11:23','0.00',NULL,NULL,'403.21','403.21','R-OH011','OH0','403.21',NULL,0,'2013-12-25 20:20:10'),(15903,12735,'Y','18','021','EC','A','','','AC','0001096772','0001096772','OH00001819777','IL','1','Fahnle','Barbara','','','','34','402646505','3531 werk Road',0,'Cincinnati','OH','45248',NULL,'CY','39061','1951-05-16','F','M',':RET:2106-3','N','021','HLT','1876776','92036OH005001206','2014-02-01','2014-01-02 13:27:30','461.00',NULL,NULL,'616.74','155.74','R-OH004','OH0','616.74',NULL,0,'2014-01-03 02:06:08'),(5175,4106,'Y','18','021','EC','A','','','AC','0000082557','0000082557','OH00000696100','IL','1','Dachtler','Vicki','','','','34','278723080','516 Lindberg Blvd',0,'Berea','OH','44017',NULL,'CY','39035','1967-08-14','F','U',':RET:2106-3','N','021','DEN','2582420','99734OH005000401','2014-01-01','2013-12-19 11:55:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:25'),(3964,3169,'N','01','021','EC','A',NULL,NULL,'','0000110507','0000137554','','IL','1','Cushwa','Jennifer','','','','34','573931248','2655 N PARK BLVD',0,'CLEVELAND HEIGHTS','OH','44106','3622','CY','39035','1979-07-04','F','',':RET:2106-3','N','021','HLT','1078795','52664OH151001501','2014-01-01','2013-12-13 16:02:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','366.22',NULL,0,'2013-12-25 21:38:27'),(3565,2862,'Y','18','021','EC','A','','','AC','0000244980','0000244980','OH00000220088','IL','1','ELDRIDGE','CHRISTINE','ELAINE','','','34','283463347','4209 CARAVELLE DR',0,'TOLEDO','OH','43623',NULL,'CY','39095','1957-08-13','F','U',':RET:2106-3','N','021','HLT','1418714','92036OH004002601','2014-01-01','2013-12-22 15:00:25','155.00',NULL,NULL,'365.79','210.79','R-OH001','OH0','365.79',NULL,0,'2013-12-25 21:22:24'),(169,142,'Y','18','021','EC','A','','','AC','0000635981','0000635981','OH00000375635','31','1','Anderholm','Constance','','','','34','281582360','PO Box 398',0,'Berlin','OH','44610',NULL,'CY','39075','1955-05-04','F','M',':RET:2106-3','T','021','HLT','469132','52664OH151001305','2014-01-01','2013-12-04 21:19:31','1293.00',NULL,NULL,'1598.57','305.57','R-OH014','OH0','653.46',NULL,0,'2013-12-25 17:19:24'),(13545,10801,'Y','18','021','EC','A','','','AC','0001632269','0001632269','LA00000449072','IL','1','LANDRY','CHASITI','','','','34','141840143','30518 Black Hills Parkway',0,'walker','LA','70785',NULL,'CY','22063','1979-06-04','F','U',':RET:2106-3','N','021','DEN','1847703','18575LA002000201','2014-01-01','2013-12-23 14:24:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:03:54'),(1454,1212,'Y','18','021','EC','A','','','AC','0000459153','0000459153','OH00000136891','IL','1','Martin','Brandon','John','','','34','298804861','15722 E TR 104',0,'attica','OH','44807',NULL,'CY','39147','1983-03-11','M','M',':RET:2106-3','N','021','DEN','1846436','99734OH005000401','2014-01-01','2013-12-24 07:56:31','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 18:48:09'),(21685,17316,'N','19','021','EC','A',NULL,NULL,'','0000099034','0000819809','','IL','1','MacCarthy','Roland','','','','34','272117600','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1997-08-20','M','',NULL,'N','021','HLT','3404444','92036OH004002601','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-02-05 21:31:04'),(21252,16983,'Y','18','021','EC','A','','','AC','0000336457','0000336457','OH00001493963','IL','1','Bonvenuto','Mark','','','','34','195442207','175 WOODBURY GLEN ST',0,'HARTVILLE','OH','44632','8317','CY','39151','1952-03-24','M','M',':RET:2106-3','N','021','HLT','3473254','52664OH151001304','2014-03-01','2014-02-03 13:27:58','341.00',NULL,NULL,'626.65','285.65','R-OH015','OH0','626.65',NULL,0,'2014-02-03 21:01:18'),(8049,6372,'Y','18','024','14','A','','','TE','0001030368','0001030368','','IL','1','PHOENIX','CLETUS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-06-10','M','',NULL,NULL,NULL,'','2468408','','2013-12-20','2013-12-20 13:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:09:38'),(6467,5125,'Y','18','021','EC','A','','','AC','0000452717','0000452717','OH00000706915','IL','1','Slayton','Deborah','','','','34','285642650','10815 OVERTON RD',0,'BURBANK','OH','44214','9765','CY','39169','1955-09-03','F','M',':RET:2106-3','N','021','HLT','236789','52664OH151001304','2014-01-01','2013-12-10 19:54:25','600.00',NULL,NULL,'1136.44','536.44','R-OH014','OH0','568.22',NULL,0,'2013-12-26 00:50:04'),(25779,20444,'Y','18','021','EC','A','','','AC','0000129303','0000129303','OH00002298217','IL','1','WILSON','SHARELL','','','','34','279863035','2840 FLOEX DR',0,'TOLEDO','OH','43615','2446','CY','39095','1985-10-17','F','U',NULL,'N','021','HLT','3200442','92036OH004002601','2014-04-01','2014-02-24 13:26:55','25.00',NULL,NULL,'170.44','145.44','R-OH001','OH0','170.44',NULL,0,'2014-02-26 09:31:00'),(1879,1535,'Y','18','021','EC','A','','','AC','0000093852','0000093852','OH00000239940','IL','1','FINCH','JESSE','','','','34','268660071','256 KEY ST',0,'TOLEDO','OH','43614',NULL,'CY','39095','1963-10-20','M','U',NULL,'N','021','HLT','2066935','92036OH006002601','2014-01-01','2013-12-24 10:58:34','158.00',NULL,NULL,'276.19','118.19','R-OH001','OH0','276.19',NULL,0,'2013-12-25 18:58:29'),(6310,5005,'Y','18','021','EC','A','','','AC','0000258128','0000258128','OH00001181033','IL','1','Markenson','Pamela','','','','34','494586398','1722 TECUMSEH DR',0,'LANCASTER','OH','43130','8154','CY','39045','1950-12-13','F','M',':RET:2106-3','N','021','DEN','590523','99734OH005000401','2014-01-01','2013-12-11 10:32:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:08'),(17809,14226,'Y','18','021','EC','A','','','AC','0000007497','0000007497','TX00001605957','IL','1','Cox','James','Jeffrey','','','34','451490038','1009 EGAN ST',0,'DENTON','TX','76201','2825','CY','48121','1965-08-17','M','M',':RET:2106-3','N','021','DEN','1414601','33348TX002000101','2014-02-01','2014-01-14 12:29:21','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-15 02:05:52'),(17790,14211,'Y','18','021','EC','A','','','AC','0000070321','0000070321','OH00001890098','IL','1','Vilardo','Susan','','','','34','275583575','770 CENTER ST',0,'MILFORD','OH','45150','1302','CY','39025','1955-05-21','F','U',':RET:2106-3','N','021','HLT','1713637','92036OH002000601','2014-02-01','2014-01-13 15:26:46','185.00',NULL,NULL,'631.66','446.66','R-OH005','OH0','631.66',NULL,0,'2014-01-14 01:33:47'),(6097,4833,'Y','18','021','EC','A','','','AC','0000367343','0000367343','OH00000692025','IL','1','WILLIAMS','KAREN','L','','','34','272703891','19504 CHERRYWOOD LN',0,'CLEAVLAND','OH','44128',NULL,'CY','39035','1975-12-06','F','U',NULL,'N','021','DEN','931037','99734OH005000401','2014-01-01','2013-11-20 20:40:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:15:06'),(15441,12355,'Y','18','024','14','A','','','TE','0001140937','0001140937','','IL','1','hollins','rayvon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-09-26','F','',NULL,NULL,NULL,'','377299','','2013-12-31','2013-12-31 14:12:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:28:03'),(1916,1564,'Y','18','021','EC','A','','','AC','0000949475','0000949475','OH00000191764','IL','1','leese','Michael','','','','34','299805799','895 WATERVILLE MONCLOVA RD',0,'WATERVILLE','OH','43566','1163','CY','39095','1983-06-23','M','U',':RET:2106-3','N','021','DEN','70200','99734OH005000301','2014-01-01','2013-11-20 09:12:21','0.00',NULL,NULL,'59.76','59.76','R-OH001','OH0','0.00',NULL,0,'2013-12-25 19:00:05'),(27234,21565,'Y','18','021','EC','A','','','AC','0000289094','0000289094','MS00003190545','31','1','Craft','Maria','','','','34','427713750','P.O. Box',0,'Taylorsville','MS','39168',NULL,'CY','28129','1991-04-21','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','3358018','46300MS002000101','2014-04-01','2014-03-03 04:02:34','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-03 21:31:43'),(28416,22484,'Y','18','021','EC','A','','','AC','0000885665','0000885665','OH00002653528','IL','1','Lachtrupp','Patrick','','','','34','284841090','5492 LAKEFRONT DR',0,'CINCINNATI','OH','45247','6505','CY','39061','1985-04-17','M','U',':RET:2106-3','T','021','DEN','3982848','99734OH005000401','2014-04-01','2014-03-07 12:47:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-07 21:30:59'),(3761,3009,'N','01','021','EC','A',NULL,NULL,'','0000777658','0000004695','','IL','1','schuck','david','lee','','','34','286769782','456 COUNTY ROAD 1775',0,'JEROMESVILLE','OH','44840','9726','CY','39005','1974-01-01','M','',':RET:2106-3','N','021','HLT','973684','52664OH151001306','2014-01-01','2013-12-13 10:20:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','285.00',NULL,0,'2013-12-25 21:33:25'),(13905,11090,'Y','18','021','EC','A','','','AC','0000854192','0000854192','OH00000750523','IL','1','SNIDER','MICHAEL','','','','34','275603151','645 ORCHARD DR',0,'PORT CLINTON','OH','43452','2129','CY','39123','1971-07-27','M','U',':RET:2106-3','N','021','HLT','2162927','92036OH005002701','2014-01-01','2013-12-22 21:58:10','35.00',NULL,NULL,'258.38','223.38','R-OH006','OH0','258.38',NULL,0,'2013-12-26 13:13:48'),(15220,12166,'Y','18','021','EC','A','','','AC','0001844860','0001844860','LA00001592070','IL','1','Brumen','Sonia','','','','34','436715573','3051 ONEAL LN',0,'BATON ROUGE','LA','70816','3145','CY','22033','1987-12-10','F','U',NULL,'N','021','DEN','2239596','18575LA002000101','2014-02-01','2013-12-30 12:41:46','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-01 12:07:59'),(25071,19883,'Y','18','024','14','A','','','TE','0000739053','0000739053','','IL','1','christman','karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-29','F','',NULL,NULL,NULL,'','2726308','','2014-02-20','2014-02-20 09:12:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 22:01:30'),(25405,20155,'Y','18','021','EC','A','','','AC','0000656982','0000656982','OH00002973675','IL','1','DOLAL','ABDIFATAH','M','','','34','474477770','3226 GREENBROOK CT',0,'COLUMBUS','OH','43224','6801','CY','39049','1988-05-01','M','U',':RET:2054-5','N','021','DEN','2940583','99734OH005000401','2014-04-01','2014-02-24 18:48:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-25 21:30:59'),(25752,20425,'Y','18','024','14','A','','','TE','0000718949','0000718949','','IL','1','shaferly','samuel','david',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2003-04-04','M','',NULL,NULL,NULL,'','3552201','','2014-02-24','2014-02-24 16:29:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 09:30:46'),(17044,13638,'Y','18','021','EC','A','','','AC','0000518432','0000518432','OH00002403202','IL','1','Nuss','Patricia','','','','34','271440678','1143 S. Cleve-Mass Rd',0,'Copley','OH','44321',NULL,'CY','39153','1951-02-12','F','M',':RET:2106-3','N','021','HLT','2060030','52664OH151001501','2014-02-01','2014-01-09 16:02:42','889.00',NULL,NULL,'1449.93','560.93','R-OH012','OH0','768.43',NULL,0,'2014-01-13 02:20:53'),(27026,21404,'Y','18','024','14','A','','','TE','0000108148','0000108148','','IL','1','SPEHAR','VINCENT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-06-29','M','',NULL,NULL,NULL,'','3275543','','2014-03-31','2014-03-03 16:25:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:14'),(28688,22704,'Y','18','021','EC','A','','','AC','0000835535','0000835535','OH00002688629','IL','1','LOPEZ','NATHANIEL','','','','34','122682981','232 DUPONT ST',0,'YOUNGSTOWN','OH','44510','1025','CY','39099','1983-09-30','M','M',NULL,'T','021','HLT','4225179','52664OH152000901','2014-04-01','2014-03-08 12:35:48','0.00',NULL,NULL,'241.77','241.77','R-OH013','OH0','241.77',NULL,0,'2014-03-08 21:31:01'),(9710,7691,'Y','18','021','EC','A','','','AC','0000820716','0000820716','LA00000058299','IL','1','Capistrano','Daniela','','','','34','621036777','8021 BENSON ST.',0,'New Orleans','LA','70127',NULL,'CY','22071','1981-09-29','F','U',':RET:1002-5','N','021','DEN','1013861','18575LA002000201','2014-01-01','2013-11-15 11:29:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:45:09'),(25008,19832,'Y','18','024','14','A','','','TE','0001071837','0001071837','','IL','1','ESCRIBANO','GIOVANNY','FRANCISCO',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-28','M','',NULL,NULL,NULL,'','3111785','','2014-02-20','2014-02-20 14:21:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 22:00:50'),(21824,17427,'N','17','021','EC','A',NULL,NULL,'','0000825672','0001230927','','S3','1','Wade','Rebecca','','','','34','628232586','15994 COUNTY ROAD 3138',0,'LINDALE','TX','75771','7358','CY','48423','2009-09-21','F','',':RET:2106-3','N','021','DEN','3697795','33348TX002000101','2014-03-01','2014-02-06 09:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-02-06 21:01:01'),(19514,15554,'Y','18','024','14','A','','','TE','0000063734','0000063734','','IL','1','jodrey','tina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-08-05','F','',NULL,NULL,NULL,'','2759410','','2014-01-21','2014-01-21 20:22:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:16'),(9708,7690,'Y','18','021','EC','A','','','AC','0000804829','0000804829','LA00000750919','IL','1','Quang','Diep','','','','34','487021682','522 SADDLER RD',0,'MARRERO','LA','70072','1631','CY','22051','1956-10-15','M','M',':RET:2047-9','N','021','DEN','1004685','18575LA002000201','2014-01-01','2013-11-14 19:10:43','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:45:06'),(3619,2898,'Y','18','021','EC','A','','','AC','0000142828','0000142828','OH00000367236','IL','1','Mendoza','Carmen','','','','34','235867129','611 GEORGIA DR',0,'BETHEL','OH','45106','1035','CY','39025','1964-01-01','F','M',NULL,'N','021','HLT','2408887','92036OH001000601','2014-01-01','2013-12-22 16:14:48','489.00',NULL,NULL,'1031.63','542.63','R-OH005','OH0','462.46',NULL,0,'2013-12-25 21:23:41'),(17713,14156,'Y','18','021','EC','A','','','AC','0001499299','0001499299','LA00002159211','IL','1','tillman','ellender','k','','','34','436350481','1222 S SKY ST',0,'GONZALES','LA','70737','4061','CY','22005','1977-04-07','F','M',NULL,'N','021','DEN','1698964','18575LA002000201','2014-02-01','2014-01-13 18:02:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:10'),(7714,6108,'Y','18','021','EC','A','','','AC','0000950650','0000950650','OH00000737105','IL','1','Wenning','Curtis','','','','34','283504820','803 Fox St.',0,'New Bremen','OH','45869',NULL,'CY','39011','1951-05-07','M','U',':RET:2106-3','N','021','DEN','1744277','99734OH005000401','2014-01-01','2013-12-20 13:00:30','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 03:01:34'),(5439,4321,'Y','18','021','EC','A','','','AC','0001633542','0001633542','LA00000549426','IL','1','CHAKRAVARTY','INDRA','','','','34','535900359','4413 RICHLAND AVE',0,'METAIRIE','LA','70002',NULL,'CY','22051','1950-09-18','F','M',':RET:2029-7','N','021','DEN','2551857','18575LA002000101','2014-01-01','2013-12-19 16:55:10','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:53'),(27079,21439,'Y','18','021','EC','A','','','AC','0000807563','0000807563','OH00003279992','IL','1','Waldinger','Karen','','','','34','291866156','23 N HAYDEN PKWY',0,'HUDSON','OH','44236','3149','CY','39153','1972-10-24','F','R',':RET:2106-3','T','021','HLT','2723732','52664OH152000901','2014-04-01','2014-03-03 16:38:50','0.00',NULL,NULL,'348.29','348.29','R-OH012','OH0','244.57',NULL,0,'2014-03-03 21:30:10'),(27962,22121,'N','01','021','EC','A',NULL,NULL,'','0001319307','0001340454','','IL','1','Zidan','Moaiad','','','','34','663220940','2826 Misty Ln',0,'Bossier city','LA','71111',NULL,'CY','22015','1991-02-21','M','',NULL,'N','021','DEN','3327671','18575LA002000201','2014-04-01','2014-03-05 20:40:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-06 21:00:45'),(164,138,'Y','18','021','EC','A','','','AC','0000915623','0000915623','OH00000036901','IL','1','MARSHALL','MICHAEL','','','','34','270720948','218 WILLIAMS ST',0,'CINCINNATI','OH','45215','4604','CY','39061','1966-09-21','M','M',':RET:2106-3','N','021','HLT','579884','92036OH004001201','2014-01-01','2013-12-05 14:01:11','0.00',NULL,NULL,'269.80','269.80','R-OH004','OH0','269.80',NULL,0,'2013-12-25 17:19:16'),(7666,6072,'Y','18','021','EC','A','','','AC','0001555351','0001555351','LA00000709888','IL','1','Ells','Jonathan','','','','34','530986224','7934 Willow St',0,'New Orleans','LA','70118',NULL,'CY','22071','1983-01-05','M','U',':RET:2106-3','T','021','DEN','2145767','18575LA002000101','2014-01-01','2013-12-20 15:34:30','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 03:00:25'),(25558,20276,'Y','18','021','EC','A','','','AC','0000929892','0000929892','OH00002460573','IL','1','Dunning','Tim',NULL,NULL,NULL,NULL,NULL,'207 INWOOD RD',0,'WILMINGTON','OH','45177','8355','CY','39027','1951-11-28','M','M',NULL,'T','021','HLT','2937340','92036OH004000601','2014-04-01','2014-02-23 13:40:28','701.00',NULL,NULL,'1067.38','366.38','R-OH005','OH0','570.30',NULL,0,'2014-02-26 08:00:21'),(7556,5980,'Y','18','021','EC','A','','','AC','0000927293','0000927293','OH00001031191','IL','1','Zelesnik','Kenneth','','','','34','284522030','18592 EDWARDS RD',0,'DOYLESTOWN','OH','44230','9568','CY','39169','1951-09-01','M','U',':RET:2106-3','T','021','HLT','1017652','52664OH152000901','2014-01-01','2013-12-15 14:19:36','453.00',NULL,NULL,'539.67','86.67','R-OH014','OH0','539.67',NULL,0,'2013-12-26 02:33:21'),(24570,19512,'Y','18','021','EC','A','','','AC','0001228107','0001228107','OH00001668830','IL','1','Wingo','Cerra','','','','34','283845987','750 MULL AVE',0,'AKRON','OH','44313','7561','CY','39153','1985-11-27','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2914145','99734OH005000301','2014-04-01','2014-02-18 20:59:47','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-20 04:07:24'),(1940,1580,'Y','18','021','EC','A','','','AC','0000444873','0000444873','OH00000932949','IL','1','Fillmore','Mary','Lou','','','34','277684084','2243 SHERER AVE',0,'DAYTON','OH','45414','4635','CY','39113','1974-02-17','F','U',':RET:2106-3','T','021','DEN','583821','99734OH005000401','2014-01-01','2013-11-19 20:36:28','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:00:38'),(23808,18944,'Y','18','021','EC','A','','','AC','0000639566','0000639566','OH00002540504','IL','1','gipe','michael','wray','','','34','300709879','6447 hampsher rd',0,'new franklin','OH','44216',NULL,'CY','39153','1961-10-29','M','M',':RET:2106-3','N','021','HLT','3024252','52664OH152000901','2014-03-01','2014-02-13 19:25:54','448.00',NULL,NULL,'716.90','268.90','R-OH012','OH0','318.84',NULL,0,'2014-02-14 21:31:33'),(7473,5913,'Y','18','021','EC','A','','','AC','0001196796','0001196796','OH00000812543','IL','1','KIMMONS','SHAWNDA','','','','34','287701964','2601 VERA AVE',0,'CINCINNATI','OH','45237','4539','CY','39061','1970-10-17','F','U',NULL,'N','021','DEN','509881','99734OH005000401','2014-01-01','2013-12-14 22:11:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:13'),(2310,1877,'N','01','021','EC','A',NULL,NULL,'','0001005688','0000134554','','IL','1','Cordos','Maria','','','','34','297026833','2299 HOLLYLANE DR',0,'BROADVIEW HTS','OH','44147','1113','CY','39035','1960-03-31','F','',':RET:2106-3','N','021','DEN','230865','99734OH005000301','2014-01-01','2013-12-09 17:58:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:08'),(17701,14145,'N','01','021','EC','A',NULL,NULL,'','0001944635','0001903439','','IL','1','Pfefferman','David','Edward','','','34','404786510','1850 Harbor Dr.',0,'Slidell','LA','70458',NULL,'CY','22103','1952-03-26','M','',':RET:2106-3','N','021','DEN','2607485','18575LA002000201','2014-02-01','2014-01-13 13:42:32',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-14 01:33:04'),(27792,21982,'Y','18','024','14','A','','','TE','0001187438','0001187438','','IL','1','LOVE','MARY','LEE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-10-08','F','',NULL,NULL,NULL,'','4053917','','2014-03-05','2014-03-05 15:05:54',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-05 21:31:41'),(28895,22870,'Y','18','021','EC','A','','','AC','0000488163','0000488163','TX00002658747','IL','1','Gangsei','Deborah',NULL,NULL,NULL,NULL,NULL,'7530 fm 482',0,'New Braunfels','TX','78132',NULL,'CY','48091','1962-01-11','F','U',':RET:2106-3','N','021','DEN','4365045','33348TX002000201','2014-04-01','2014-03-10 15:41:41','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-10 21:00:17'),(3304,2659,'Y','18','021','EC','A','','','AC','0000114189','0000114189','OH00001315019','IL','1','Smith','Todd','','','','34','286866405','556 HOWELLS CT',0,'EASTLAKE','OH','44095','1237','CY','39085','1973-03-29','M','U',':RET:2106-3','N','021','DEN','1495047','99734OH005000301','2014-01-01','2013-12-22 12:45:38','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:15:46'),(7738,6128,'Y','18','021','EC','A','','','AC','0001019260','0001019260','OH00000706161','IL','1','Nichol','Kyle','','','','34','291763723','121 Shiawassee Ave',0,'Fairlawn','OH','44333',NULL,'CY','39153','1967-04-07','M','U',':RET:2106-3','N','021','DEN','1994834','99734OH005000401','2014-01-01','2013-12-20 15:26:23','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:02:11'),(7477,5916,'Y','18','024','14','A','','','TE','0001109203','0001109203','','IL','1','Scheetz','Teresa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-05','F','',NULL,NULL,NULL,'','340923','','2013-12-15','2013-12-15 10:57:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:31:18'),(25248,20028,'Y','18','021','EC','A','','','AC','0000903282','0000903282','OH00003040965','IL','1','BOHA','GLORIA','','','','34','288541807','867 EATON FORT NESBIT RD',0,'NEW PARIS','OH','45347','9107','CY','39037','1953-10-23','F','M',':RET:2106-3','N','021','HLT','2652325','92036OH004000501','2014-04-01','2014-02-20 19:26:39','491.00',NULL,NULL,'518.73','27.73','R-OH003','OH0','518.73',NULL,0,'2014-02-21 22:01:12'),(20099,16036,'Y','18','021','EC','A','','','AC','0002076082','0002076082','LA00002567046','IL','1','Mullins','Meredith','','','','34','632125289','3539 St. Charles Ave.',0,'New Orleans','LA','70115',NULL,'CY','22071','1985-03-12','F','M',':RET:2106-3','N','021','DEN','2689403','18575LA002000201','2014-03-01','2014-01-27 12:26:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-27 21:00:34'),(24641,19558,'Y','18','021','EC','A','','','AC','0002020263','0002020263','LA00002957733','IL','1','JOLIVETTE','JOSEPH','','','','34','434314902','281 TRINITY RD',0,'OPELOUSAS','LA','70570','0609','CY','22097','1961-08-08','M','U',':RET:2054-5','N','021','DEN','3678614','18575LA002000201','2014-04-01','2014-02-19 12:20:29','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-20 04:20:15'),(25236,20018,'Y','18','021','EC','A','','','AC','0000433963','0000433963','OH00002665539','IL','1','Vanetta','Jeanette','','','','34','347489538','230 College Avenue',0,'Ashland','OH','44805',NULL,'CY','39005','1952-08-10','F','U',':RET:2106-3','T','021','HLT','3022112','52664OH152000901','2014-04-01','2014-02-21 16:22:07','441.00',NULL,NULL,'527.84','86.84','R-OH012','OH0','527.84',NULL,0,'2014-02-21 22:01:05'),(25339,20104,'N','01','021','EC','A',NULL,NULL,'','0001250755','0001775741','','IL','1','FOWLER','KANDY','A','','','34','434253708','137 HAM RD',0,'ZWOLLE','LA','71486','2744','CY','22085','1960-03-02','F','',NULL,'N','021','DEN','2989380','18575LA002000201','2014-04-01','2014-02-25 15:15:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-25 21:30:23'),(25521,20247,'Y','18','021','EC','A','','','AC','0000780563','0000780563','OH00002406933','IL','1','urbanski','Paul','','','','34','299588810','2344 ABERDEEN AVE',0,'TOLEDO','OH','43614','2725','CY','39095','1957-08-02','M','U',':RET:2106-3','N','021','HLT','3703135','92036OH003002604','2014-04-01','2014-02-25 17:17:33','261.00',NULL,NULL,'475.07','214.07','R-OH001','OH0','475.07',NULL,0,'2014-02-25 21:32:06'),(28848,22828,'Y','18','021','EC','A','','','AC','0000075301','0000075301','OH00002932879','IL','1','Fortney','Bradly','J','','','34','229397607','219 GARDEN ST',0,'NAPOLEON','OH','43545','1425','CY','39069','1974-06-03','M','U',':RET:2106-3','N','021','HLT','3685108','92036OH005002601','2014-04-01','2014-03-09 14:35:03','0.00',NULL,NULL,'246.08','246.08','R-OH001','OH0','246.08',NULL,0,'2014-03-09 21:01:16'),(8897,7055,'Y','18','021','EC','A','','','AC','0000157703','0000157703','TX00001171141','IL','1','LANGLEY','BEVERLY','','','','34','467451225','103 MAIN ST',0,'GONZALES','TX','78629','6024','CY','48177','1975-09-02','F','U',':RET:2054-5','N','021','DEN','1538036','33348TX002000201','2014-01-01','2013-12-18 18:32:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:02:10'),(2568,2086,'Y','18','021','EC','A','','','AC','0000748165','0000748165','OH00000690978','IL','1','El-Zayaty','Nady','','','','34','089687161','2510 FOXTAIL DR',0,'FINDLAY','OH','45840','7146','CY','39063','1981-09-18','M','U',NULL,'N','021','HLT','521120','92036OH006001501','2014-01-01','2013-12-09 16:54:06','204.97',NULL,NULL,'206.48','1.51','R-OH002','OH0','206.48',NULL,0,'2013-12-25 19:37:36'),(21555,17219,'Y','18','021','EC','A','','','AC','0001001192','0001001192','OH00002316645','IL','1','PAVLINAK','JAY','','','','34','301883725','761 W MAIN ST',0,'MADISON','OH','44057','9720','CY','39085','1987-08-15','M','U',':RET:2106-3','N','021','DEN','3081950','99734OH005000401','2014-03-01','2014-02-05 15:44:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:15'),(20153,16082,'Y','18','021','EC','A','','','AC','0000648354','0000648354','OH00002494036','IL','1','west','robby','','','','34','275863800','5874 DEVON CT',0,'CINCINNATI','OH','45248','4139','CY','39061','1979-11-09','M','U',':RET:2106-3','N','021','DEN','3403255','99734OH005000301','2014-03-01','2014-01-27 00:20:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:01:05'),(5607,4450,'Y','18','021','EC','A','','','AC','0001157529','0001157529','OH00000773875','IL','1','Rosa','Teresa','','','','34','291740937','15741 Holland Rd.',0,'Brookpark','OH','44142',NULL,'CY','39035','1966-05-19','F','U',':RET:2106-3','N','021','DEN','1117293','99734OH005000401','2014-01-01','2013-11-25 20:50:26','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:27'),(19184,15283,'N','01','021','EC','A',NULL,NULL,'','0000007457','0000704899','','IL','1','juarez','rosa','maria','','','34','629142337','9920 genie',0,'el paso','TX','79924',NULL,'CY','48141','1966-12-12','F','',':RET:2106-3','N','021','DEN','2198131','33348TX002000201','2014-03-01','2014-01-20 14:15:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:46:09'),(17673,14123,'Y','18','021','EC','A','','','AC','0001847185','0001847185','LA00001470259','IL','1','Philson','Nathan','','','','34','439534169','10910 GUILDFORD RD',0,'NEW ORLEANS','LA','70127','2335','CY','22071','1975-12-16','M','R',':RET:2054-5','T','021','DEN','2344683','18575LA002000101','2014-02-01','2014-01-13 12:19:14','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-14 01:32:50'),(16581,13263,'Y','18','021','EC','A','','','AC','0001846147','0001846147','LA00002172567','IL','1','Eddleman','Kaytlynn','','','','34','439716013','12490 DEERFIELD DR',0,'WALKER','LA','70785','5747','CY','22063','1987-10-22','F','U',':RET:2106-3','N','021','DEN','1794809','18575LA002000201','2014-02-01','2014-01-06 23:55:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:23:57'),(9186,7287,'Y','18','021','EC','A','','','AC','0000232645','0000232645','OH00000498644','IL','1','Yang','Renku','','','','34','062769590','108 S WALNUT ST',0,'NEW BREMEN','OH','45869','1239','CY','39011','1963-04-19','M','M',':RET:2034-7','N','021','HLT','1864053','92036OH005001505','2014-01-01','2013-12-18 15:39:24','996.00',NULL,NULL,'1112.74','116.74','R-OH002','OH0','393.06',NULL,0,'2013-12-26 04:09:18'),(13920,11101,'N','01','021','EC','A',NULL,NULL,'','0000829276','0000710133','','IL','1','Baker','Ryan','','','','34','279907479','216 S. Damascus St.',0,'Liberty Center','OH','43532',NULL,'CY','39069','1988-09-22','M','',':RET:2106-3','N','021','HLT','2229453','92036OH003002605','2014-01-01','2013-12-22 22:12:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.45',NULL,0,'2013-12-26 13:14:10'),(26708,21173,'Y','18','021','EC','A','','','AC','0001096815','0001096815','OH00002904069','IL','1','MARSH','LISLIE','','','','34','404988546','3638 BLACK JACK TRL',0,'AMELIA','OH','45102','1619','CY','39025','1962-08-02','F','M',':RET:2106-3','N','021','HLT','3651849','92036OH003000601','2014-04-01','2014-02-27 21:19:15','482.00',NULL,NULL,'1060.39','578.39','R-OH005','OH0','418.11',NULL,0,'2014-02-28 21:31:37'),(9149,7256,'Y','18','021','EC','A','','','AC','0000088544','0000088544','OH00000070320','IL','1','Wyant','Mark','','','','34','279502230','8901 ROBINSON RD',0,'CHARDON','OH','44024','9166','CY','39055','1957-11-06','M','U',':RET:2106-3','N','021','HLT','1564480','52664OH151001501','2014-01-01','2013-12-18 13:01:04','322.00',NULL,NULL,'703.78','381.78','R-OH011','OH0','703.78',NULL,0,'2013-12-26 04:08:24'),(21386,17092,'Y','18','021','EC','A','','','AC','0000552661','0000552661','OH00002077864','IL','1','Mason','Eric','','','','34','298748393','3800 MILNER RD',0,'NEWARK','OH','43055','9304','CY','39089','1963-11-15','M','M',':RET:2106-3','N','021','DEN','3762814','99734OH005000401','2014-03-01','2014-02-04 09:27:38','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:00:55'),(20421,16311,'Y','18','021','EC','A','','','AC','0000373656','0000373656','OH00002447758','IL','1','Vance','Brenda',NULL,NULL,NULL,NULL,NULL,'11217 Tecumseh Path',0,'Lakeview','OH','43331',NULL,'CY','39091','1960-01-31','F','M',':RET:2106-3','N','021','DEN','3399830','99734OH005000301','2014-03-01','2014-01-29 10:16:16','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:30'),(20176,16100,'Y','18','024','14','A','','','TE','0000812006','0000812006','','IL','1','Henrick','Joelle','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-03-02','F','',NULL,NULL,NULL,'','1940124','','2014-01-27','2014-01-27 13:37:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:17'),(19903,15873,'N','01','021','EC','A',NULL,NULL,'','0000679562','0000988912','','IL','1','Sherman','Darris','Leroy','','','34','287604993','600 GLENWOOD RD',0,'ROSSFORD','OH','43460','1508','CY','39173','1973-07-11','M','',NULL,'N','021','HLT','2925974','92036OH002002601','2014-03-01','2014-01-23 20:08:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','287.79',NULL,0,'2014-01-24 21:00:56'),(18858,15020,'Y','18','021','EC','A','','','AC','0001164823','0001164823','LA00002108924','IL','1','Hampton','Tristan','','','','34','436691772','2448 PARK LN',0,'GRETNA','LA','70056','3045','CY','22051','1978-08-09','F','U',':RET:2054-5','N','021','DEN','2907012','18575LA002000201','2014-02-01','2014-01-15 22:24:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:19'),(1269,1047,'Y','18','021','EC','A','','','AC','0000576116','0000576116','TX00000962944','IL','1','McCoy','Kevin','','','','34','569710023','3324 Carlton St',0,'Forth Worth','TX','76133',NULL,'CY','48439','1966-04-16','M','U',':RET:2054-5','N','021','DEN','849984','33348TX002000201','2014-01-01','2013-11-29 11:37:18','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:30:12'),(2635,2142,'N','19','021','EC','A',NULL,NULL,'','0000474926','0000473614','','IL','1','Toth','Kayla',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-02-08','F','',':RET:2106-3','N','021','DEN','236591','99734OH005000401','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:13'),(18042,14413,'Y','18','021','EC','A','','','AC','0000772535','0000772535','MS00001800694','31','1','LEE','PHYLLIS','','','','34','587230481','PO BOX 492',0,'PEARLINGTON','MS','39572',NULL,'CY','28045','1959-12-13','F','U',NULL,'N','021','DEN','2343281','46300MS002000101','2014-02-01','2014-01-13 19:42:57','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-15 02:07:13'),(3218,2589,'Y','18','021','EC','A','','','AC','0000874659','0000874659','OH00001067142','IL','1','Hawn','Thomas','','','','34','364609402','1814 E 40TH ST',0,'CLEVELAND','OH','44103','3526','CY','39035','1953-05-15','M','U',NULL,'T','021','HLT','671842','52664OH151001305','2014-01-01','2013-11-01 10:23:04','417.00',NULL,NULL,'785.02','368.02','R-OH011','OH0','785.02',NULL,0,'2013-12-25 20:45:37'),(3391,2720,'Y','18','021','EC','A','','','AC','0001375430','0001375430','LA00000723977','IL','1','Levy','William','','','','34','222423549','108 Merchants Blvd.',0,'Lafayette','LA','70508',NULL,'CY','22055','1971-01-09','M','U',':RET:2106-3','N','021','DEN','2560441','18575LA002000201','2014-01-01','2013-12-21 21:46:55','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 21:17:50'),(4286,3411,'Y','18','021','EC','A','','','AC','0000504460','0000504460','OH00000063947','IL','1','Wood','Blaze','','','','34','291923244','508 W BREMEN ST',0,'NEW KNOXVILLE','OH','45871','9746','CY','39011','1988-10-23','M','M',':RET:2106-3','N','021','HLT','2540742','92036OH005001504','2014-01-01','2013-12-17 13:41:11','338.00',NULL,NULL,'581.70','243.70','R-OH002','OH0','220.97',NULL,0,'2013-12-25 21:52:04'),(5954,4715,'Y','18','021','EC','A','','','AC','0000252484','0000252484','MS00000999269','IL','1','Lewis','Eddie','','','','34','587805736','1035 NEW HOME RD',0,'MCCOMB','MS','39648','7506','CY','28113','1953-01-18','M','U',':RET:2054-5','N','021','DEN','2161613','46300MS002000201','2014-01-01','2013-12-24 02:44:10','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 23:51:10'),(5288,4190,'Y','18','024','14','A','','','TE','0000627853','0000627853','','IL','1','Abufhele','Melba',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-29','F','',NULL,NULL,NULL,'','389132','','2013-12-19','2013-12-19 16:03:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:05:57'),(24094,19154,'Y','18','021','EC','A','','','AC','0000262774','0000262774','OH00002035555','IL','1','Doerrer','Colleen','','','','34','276569781','600 COUNTRY CLUB LN',0,'ASHLAND','OH','44805','4237','CY','39005','1960-01-13','F','R',':RET:2106-3','N','021','HLT','2650091','52664OH151001301','2014-03-01','2014-02-15 16:11:15','0.00',NULL,NULL,'973.43','973.43','R-OH012','OH0','476.12',NULL,0,'2014-02-15 22:01:26'),(25155,19955,'Y','18','021','EC','A','','','AC','0001019041','0001019041','TX00001800168','IL','1','Gordon','James','','','','34','511663265','307 N FOREST BLVD',0,'HOUSTON','TX','77090','4747','CY','48201','1965-03-28','M','M',':RET:2106-3','N','021','DEN','3194078','33348TX002000201','2014-04-01','2014-02-21 16:02:01','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-21 22:00:19'),(25283,20060,'Y','18','021','EC','A','','','AC','0000304173','0000304173','TX00002647196','IL','1','TREVINO','AIDA','','','','34','466172660','311 N MAYBERRY ST',0,'MISSION','TX','78572','5750','CY','48215','1963-03-28','F','M',NULL,'N','021','DEN','3108000','33348TX002000201','2014-04-01','2014-02-25 17:38:03','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61','CIC',0,'2014-02-25 21:00:18'),(28643,22667,'Y','18','021','EC','A','','','AC','0001262175','0001262175','TX00002806793','IL','1','diles','melissa','','','','34','464656325','441 SHADOW WOOD DR',0,'ABILENE','TX','79601','6242','CY','48441','1981-07-25','F','M',':RET:2106-3','N','021','DEN','3042424','33348TX002000201','2014-04-01','2014-03-08 16:43:00','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-03-08 21:30:33'),(1273,1051,'Y','18','021','EC','A','','','AC','0000271035','0000271035','LA00000971779','IL','1','reynaud','melissa','','','','34','439435325','4840 hwy 22',0,'mandeville','LA','70471',NULL,'CY','22103','1968-02-20','F','M',':RET:2106-3','N','021','DEN','417048','18575LA002000101','2014-01-01','2013-11-28 20:10:46','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:30:19'),(1792,1472,'N','19','021','EC','A',NULL,NULL,'','0000627876','0000270021','','IL','1','Landfair','Jeremy','J','','','34','537357260','4173 FOREST RIDGE BLVD',0,'DAYTON','OH','45424','4836','CY','39113','1996-06-08','M','',NULL,'N','021','DEN','2280430','99734OH005000301','2014-01-01','2013-12-24 16:43:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:34'),(20716,16553,'Y','18','024','14','A','','','TE','0001987419','0001987419','','IL','1','BERNAL','TERESA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-10','F','',NULL,NULL,NULL,'','1810245','','2014-01-30','2014-01-30 18:13:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-30 21:01:11'),(23374,18626,'Y','18','021','EC','A','','','AC','0000350616','0000350616','OH00002226507','IL','1','SARRIS','MICHAEL','','','','34','294669624','1617 CRESTWOOD RD',0,'CLEVELAND','OH','44124',NULL,'CY','39035','1961-12-07','M','M',':RET:2106-3','N','021','DEN','3590773','99734OH005000401','2014-03-01','2014-02-13 09:13:35','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:56'),(23045,18372,'Y','18','021','EC','A','','','AC','0000982724','0000982724','TX00002429494','31','1','Martinez','Juan','R','','','34','467026264','2105 East Main St',0,'Uvalde','TX','78801',NULL,'CY','48463','1956-01-04','M','M',NULL,'N','021','DEN','3144362','33348TX002000201','2014-03-01','2014-02-12 10:24:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-12 21:30:42'),(15113,12080,'Y','18','021','EC','A','','','AC','0000683402','0000683402','OH00000269414','IL','1','spicer','kristen','','','','34','289884462','5 AMANDA ST',0,'BARBERTON','OH','44203','6631','CY','39153','1983-01-19','F','U',':RET:2106-3','N','021','DEN','1993941','99734OH005000301','2014-02-01','2013-12-30 14:06:59','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-01 12:05:01'),(3399,2728,'Y','18','021','EC','A','','','AC','0001375430','0001375430','LA00000512173','IL','1','Levy','William','','','','34','222423549','108 Merchants Blvd.',0,'Lafayette','LA','70508',NULL,'CY','22055','1971-01-09','M','U',':RET:2106-3','N','021','DEN','2214425','18575LA002000201','2014-01-01','2013-12-22 10:30:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 21:18:04'),(6506,5156,'Y','18','021','EC','A','','','AC','0000012412','0000012412','OH00001007805','IL','1','Hoover','Crystal','','','','34','437358831','825 HOOVER DR',0,'ASHLAND','OH','44805','4210','CY','39005','1978-10-24','F','U',':RET:2106-3','T','021','HLT','1256963','52664OH152000901','2014-01-01','2013-12-10 20:00:18','0.00',NULL,NULL,'229.54','229.54','R-OH012','OH0','229.54',NULL,0,'2013-12-26 00:50:59'),(5800,4608,'Y','18','021','EC','A','','','AC','0000468103','0000468103','OH00000432333','IL','1','Landfeld','Laura',NULL,NULL,NULL,NULL,NULL,'12802 Morning Glory Trail',0,'Chesterland','OH','44026',NULL,'CY','39055','1960-09-02','F','M',':RET:2106-3','N','021','DEN','2341513','99734OH005000401','2014-01-01','2013-12-24 02:20:33','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:47:29'),(4443,3530,'N','01','021','EC','A',NULL,NULL,'','0000726111','0000963207','','IL','1','Blake','Anne Marie','','','','34','148780304','5585 Briarcliff Drive',0,'Garfield Heights','OH','44125',NULL,'CY','39035','1968-08-27','F','',':RET:2106-3','N','021','DEN','463044','99734OH005000301','2014-01-01','2013-12-11 21:07:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:10'),(3806,3050,'N','01','021','EC','A',NULL,NULL,'','0000209610','0000937254','','IL','1','Tupaz','Dawn','Loiacono','','','34','274869727','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','1975-06-19','F','',':RET:2106-3','N','021','DEN','1028217','99734OH005000301','2014-01-01','2013-12-13 13:25:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:39'),(26314,20877,'Y','18','021','EC','A','','','AC','0000282072','0000282072','OH00003170601','IL','1','York','Elizabeth','','','','34','548824087','2494 HEROLD RD',0,'BATAVIA','OH','45103','2102','CY','39025','1952-01-21','F','M',':RET:2106-3','N','021','HLT','3817057','92036OH006000601','2014-04-01','2014-02-27 16:25:46','514.00',NULL,NULL,'659.36','145.36','R-OH005','OH0','489.12',NULL,0,'2014-02-28 06:31:34'),(26729,21186,'Y','18','021','EC','A','','','AC','0000328462','0000328462','OH00003268824','IL','1','Hedrick','Michelle','','','','34','301763384','4825 BURNHAM AVE',0,'TOLEDO','OH','43612','2438','CY','39095','1981-04-21','F','M',NULL,'N','021','HLT','3290702','92036OH003002604','2014-01-01','2014-02-28 11:09:14','90.00',NULL,NULL,'499.52','409.52','R-OH001','OH0','240.90',NULL,0,'2014-02-28 21:31:48'),(542,443,'Y','18','021','EC','A','','','AC','0000711341','0000711341','OH00000159891','IL','1','Aylward','Timothy','','','','34','275664997','715 West Market St',0,'Akron','OH','44303',NULL,'CY','39153','1957-10-02','M','U',NULL,'N','021','HLT','293776','52664OH152000901','2014-01-01','2013-12-03 19:54:57','337.00',NULL,NULL,'381.07','44.07','R-OH012','OH0','381.07',NULL,0,'2013-12-25 17:49:45'),(673,555,'Y','18','021','EC','A','','','AC','0000329623','0000329623','OH00000471862','IL','1','Primm','Sheri','','','','34','317869245','3261 Killwinning Place',0,'Columbus','OH','43221',NULL,'CY','39049','1970-08-04','F','U',':RET:2106-3','N','021','DEN','2050527','99734OH005000301','2014-01-01','2013-12-16 10:14:06','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:02:11'),(22045,17597,'N','01','021','EC','A',NULL,NULL,'','0001066020','0001121428','','IL','1','Wilson','Roberta','Jo','','','34','290521999','5525 W BANCROFT ST',0,'TOLEDO','OH','43615','2825','CY','39095','1952-09-06','F','',':RET:2106-3','N','021','HLT','3183131','92036OH006002601','2014-03-01','2014-02-07 17:45:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','434.56',NULL,0,'2014-02-07 19:01:11'),(2807,2268,'N','01','021','EC','A',NULL,NULL,'','0000401208','0000257093','','IL','1','Metcalf','Scott','','','','34','278729091','5241 NORFOLK ST',0,'LIMA','OH','45806','9465','CY','39003','1971-09-14','M','',NULL,'N','021','HLT','718342','92036OH005001506','2014-01-01','2013-10-14 21:21:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.62',NULL,0,'2013-12-25 20:00:06'),(3948,3159,'N','01','021','EC','A',NULL,NULL,'','0000151961','0001033642','','IL','1','GOODMAN','TERI','SUE','','','34','287567305','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1959-12-18','F','',':RET:2106-3','N','021','HLT','812138','92036OH006002701','2014-01-01','2013-12-13 10:39:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','330.16',NULL,0,'2013-12-25 21:38:05'),(6352,5034,'Y','18','021','EC','A','','','AC','0000950644','0000950644','OH00000641493','IL','1','JANSON','LINDA','','','','34','276448198','4383 W 180TH ST',0,'CLEVELAND','OH','44135','3820','CY','39035','1950-08-03','F','U',':RET:2106-3','N','021','DEN','1086537','99734OH005000401','2014-01-01','2013-12-11 13:34:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:04'),(5621,4461,'Y','18','021','EC','A','','','AC','0000271393','0000271393','OH00000796097','IL','1','Reiser','Christine','','','','34','282447841','22386 Park Edge Circle',0,'Fairview Park','OH','44126',NULL,'CY','39035','1950-11-23','F','U',':RET:2106-3','N','021','DEN','999908','99734OH005000401','2014-01-01','2013-11-26 14:55:32','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:47'),(19625,15642,'N','01','021','EC','A',NULL,NULL,'','0000556745','0000908058','','IL','1','Zorn','Leisa','ann','','','34','283804744','89 MEADOW DR SW',0,'ETNA','OH','43068','3311','CY','39089','1967-02-18','F','',NULL,'N','021','DEN','2874963','99734OH005000401','2014-03-01','2014-01-22 20:40:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:06'),(20022,15968,'Y','18','024','14','A','','','TE','0002171655','0002171655','','IL','1','Roussel','Lee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-07-26','M','',NULL,NULL,NULL,'','3432328','','2014-01-25','2014-01-25 19:38:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-26 19:00:15'),(22082,17625,'Y','18','021','EC','A','','','AC','0002196402','0002196402','LA00002040391','31','1','dawes','alan','','','','34','435965757','p.o. box 3833',0,'baton rouge','LA','70801',NULL,'CY','22033','1955-10-08','M','U',':RET:2106-3','N','021','DEN','3723729','18575LA002000201','2014-03-01','2014-02-08 17:14:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-08 19:00:19'),(302,249,'N','19','021','EC','A',NULL,NULL,'','0000290755','0000344095','','IL','1','Jolly','Devin','A','','','34','291043457','10632 GILBERT RD',0,'NEWTON FALLS','OH','44444','9269','CY','39133','1999-12-19','M','',NULL,'N','021','HLT','426917','52664OH151001301','2014-01-01','2013-11-13 01:46:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 17:30:50'),(17159,13729,'Y','18','021','EC','A','','','AC','0001262201','0001262201','LA00002082830','IL','1','minton','donna','','','','34','430410949','423 PELICAN AVE',0,'NEW ORLEANS','LA','70114','1017','CY','22071','1965-04-19','F','U',':RET:2106-3','T','021','DEN','2477342','18575LA002000201','2014-02-01','2014-01-08 11:00:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:22:00'),(617,508,'Y','18','021','EC','A','','','AC','0000063700','0000063700','OH00000480160','IL','1','Capuano','Terry','','','','34','047365057','140 GREENTREE RD',0,'MORELAND HILLS','OH','44022','2424','CY','39035','1948-07-21','M','M',':RET:2106-3','N','021','DEN','1949768','99734OH005000401','2014-01-01','2013-12-16 11:02:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:00:44'),(15412,12328,'Y','18','021','EC','A','','','AC','0000503454','0000503454','TX00001364443','IL','1','SATCHELL','VALERIE','','','','34','541706552','149 EASTERN HILLS DRIVE',0,'MABANK','TX','75156',NULL,'CY','48213','1956-10-19','F','U',':RET:2106-3','N','021','DEN','1835543','33348TX002000201','2014-02-01','2013-12-31 00:36:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:09'),(7916,6259,'N','01','021','EC','A',NULL,NULL,'','0000013141','0000852795','','IL','1','cervini','nitza','vanessa','','','34','665184959','1936 HICKORY AVE',0,'HARAHAN','LA','70123','1637','CY','22051','1978-03-21','F','',NULL,'N','021','DEN','2551871','18575LA002000201','2014-01-01','2013-12-19 21:39:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 03:06:12'),(2407,1966,'Y','18','021','EC','A','','','AC','0000927284','0000927284','OH00000952271','IL','1','miller','randy','','','','34','289528760','28 beechwood dr',0,'youngstown','OH','44512',NULL,'CY','39099','1952-07-22','M','M',':RET:2106-3','N','021','DEN','1024130','99734OH005000401','2014-01-01','2013-12-09 14:34:45','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:33:40'),(5413,4295,'Y','18','021','EC','A','','','AC','0000795504','0000795504','OH00000163049','IL','1','Vontz','Shannon','','','','34','281887420','3135 Old St Rt 32',0,'Batavia','OH','45103',NULL,'CY','39025','1979-04-12','F','U',':RET:2106-3','N','021','HLT','1583100','92036OH003000605','2014-01-01','2013-12-19 15:19:10','147.00',NULL,NULL,'272.15','125.15','R-OH005','OH0','272.15',NULL,0,'2013-12-25 23:09:10'),(4503,3570,'Y','18','021','EC','A','','','AC','0000315229','0000315229','TX00000985985','IL','1','Rasnic','Rhea','','','','34','406883570','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1970-06-27','M','M',NULL,'N','021','DEN','256169','33348TX002000201','2014-01-01','2013-12-11 22:52:33','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:26'),(18806,14979,'Y','18','021','EC','A','','','AC','0000530718','0000530718','OH00001396616','IL','1','paytes','jack','','','','34','299482203','400 N 2nd St',0,'Loveland','OH','45140',NULL,'CY','39025','1952-02-11','M','M',':RET:2106-3','N','021','DEN','1989239','99734OH005000401','2014-03-01','2014-01-16 15:53:45','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-17 03:36:01'),(19069,15191,'Y','18','021','EC','A','','','AC','0001201918','0001201918','OH00002039998','IL','1','Gumpf','Cinthia','','','','34','292642502','444 E 2ND ST',0,'PERRYSBURG','OH','43551','2107','CY','39173','1966-06-28','F','M',':RET:2106-3','N','021','HLT','1673385','92036OH004002601','2014-03-01','2014-01-17 22:51:00','0.00',NULL,NULL,'245.07','245.07','R-OH001','OH0','245.07',NULL,0,'2014-01-21 08:44:19'),(20844,16661,'Y','18','021','EC','A','','','AC','0000656962','0000656962','OH00001705916','IL','1','Krafty','Christopher','','','','34','285881577','1375 Cleveland road west',0,'Huron','OH','44839',NULL,'CY','39043','1983-03-09','M','U',':RET:2106-3','N','021','DEN','3476733','99734OH005000301','2014-03-01','2014-01-30 19:09:45','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-01-31 21:00:48'),(22608,18055,'Y','18','021','EC','A','','','AC','0000832034','0000832034','OH00002399219','IL','1','Hunter','Bobby','','','','34','273569152','2366 St. Johns Road',0,'Wakeman','OH','44889',NULL,'CY','39077','1955-12-20','M','M',':RET:2106-3','N','021','HLT','3808130','92036OH003002705','2014-03-01','2014-02-10 17:44:43','893.00',NULL,NULL,'993.92','100.92','R-OH006','OH0','518.85',NULL,0,'2014-02-10 21:32:18'),(27573,21806,'N','19','021','EC','A',NULL,NULL,'','0000639476','0000589212','','IL','1','Jones','Shaklea','R','','','34','427810163','1445 BUCK LN',0,'JACKSON','MS','39209','9437','CY','28049','1996-07-23','F','',':RET:2054-5','N','021','DEN','2953183','46300MS002000201','2014-04-01','2014-03-04 11:39:08',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52','CIC',0,'2014-03-04 21:30:21'),(28669,22687,'Y','18','021','EC','A','','','AC','0001506597','0001506597','LA00003537969','31','1','Young','Tonia','','','','34','436495336','po box 451',0,'Oberlin','LA','70655',NULL,'CY','22003','1978-11-09','F','M',':RET:2106-3','N','021','DEN','3707389','18575LA002000201','2014-04-01','2014-03-08 16:02:00','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-08 21:30:48'),(7002,5558,'Y','18','021','EC','A','','','AC','0001115572','0001115572','TX00000383150','IL','1','GLASS','SARAH','COHEN','','','34','459737236','800 EXPOSITION AVE',0,'DALLAS','TX','75226',NULL,'CY','48113','1985-01-20','F','U',':RET:2106-3','N','021','DEN','2263813','33348TX002000201','2014-01-01','2013-12-24 19:18:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:48:17'),(1499,1252,'Y','18','021','EC','A','','','AC','0000675453','0000675453','OH00001215935','IL','1','Doeding','Tracy','Jean','','','34','277565943','4081 GLEN ESTE WITHAMSVILLE RD',0,'CINCINNATI','OH','45245','2042','CY','39025','1961-02-24','F','M',':RET:2106-3','N','021','DEN','2417825','99734OH005000401','2014-01-01','2013-12-24 12:03:48','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:49:15'),(9498,7533,'Y','18','021','EC','A','','','AC','0000714967','0000714967','OH00001123751','IL','1','MAZAR','LAURA','','','','34','217703646','8627 GIBSON RD',0,'CANFIELD','OH','44406','9745','CY','39099','1954-02-08','F','M',':RET:2106-3','N','021','DEN','2312935','99734OH005000401','2014-01-01','2013-12-21 15:10:55','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:35:06'),(14717,11750,'Y','18','021','EC','A','','','AC','0000947413','0000947413','OH00001219690','IL','1','Jackson','Charles','','','','34','300700371','6213 COLERIDGE AVE',0,'CINCINNATI','OH','45213','1801','CY','39061','1967-02-19','M','U',':RET:2054-5','N','021','DEN','1453140','99734OH005000301','2014-02-01','2013-12-28 17:22:13','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:09:27'),(13576,10827,'N','01','021','EC','A',NULL,NULL,'','0001326483','0001853919','','IL','1','McGee','Shirlene','','','','34','433042498','1212 LAKE LOUISE DR',0,'GRETNA','LA','70056','8341','CY','22051','1957-04-03','F','',':RET:2054-5','N','021','DEN','1674133','18575LA002000201','2014-01-01','2013-12-23 17:37:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:04:47'),(20823,16642,'Y','18','021','EC','A','','','AC','0001555375','0001555375','LA00001463896','IL','1','Roberson','Pam','','','','34','435572690','321 HAILE BAPTIST CHURCH RD',0,'MARION','LA','71260','4403','CY','22111','1971-06-14','F','M',NULL,'N','021','DEN','3735522','18575LA002000201','2014-03-01','2014-01-31 14:21:01','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-31 21:00:36'),(21799,17409,'N','01','021','EC','A',NULL,NULL,'','0000433936','0001074186','','IL','1','Smith','Tamara','Jean','','','34','295729422','2006 KENSINGTON DR',0,'SAINT MARYS','OH','45885','1388','CY','39011','1969-09-05','F','',':RET:2106-3','N','021','HLT','3599490','92036OH004001501','2014-03-01','2014-02-06 06:16:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','247.23',NULL,0,'2014-02-06 21:00:48'),(7981,6319,'Y','18','021','EC','A','','','AC','0000956638','0000956638','OH00001200836','IL','1','dille','ross','','','','34','300685310','6240 Stumph rd.',0,'parma heights','OH','44130',NULL,'CY','39035','1960-05-30','M','U',':RET:2106-3','T','021','HLT','2482010','52664OH151001305','2014-01-01','2013-12-20 14:10:05','288.00',NULL,NULL,'590.06','302.06','R-OH011','OH0','590.06',NULL,0,'2013-12-26 03:07:58'),(17637,14099,'N','19','021','EC','A',NULL,NULL,'','0001258678','0000066267','','IL','1','Kessler','Avigail','','','','34','123942331','4286 UNIVERSITY PKWY',0,'UNIVERSITY HEIGHTS','OH','44118','3943','CY','39035','2005-10-10','F','',':RET:2106-3','N','021','DEN','1360427','99734OH005000301','2014-02-01','2014-01-12 19:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:35'),(17503,13995,'N','01','021','EC','A',NULL,NULL,'','0000644689','0000155797','','IL','1','Krisha','Henry','','','','34','283741839','3207 FITCHVILLE RIVER RD',0,'WAKEMAN','OH','44889','9320','CY','39077','1963-10-03','M','',':RET:2106-3','N','021','HLT','2022799','92036OH003002706','2014-02-01','2014-01-12 16:49:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.68',NULL,0,'2014-01-13 03:01:26'),(17058,13651,'Y','18','021','EC','A','','','AC','0000869076','0000869076','TX00001400718','IL','1','Karvia','Tabatha','','','','34','544374987','3061 S WESTCLIFF RD',0,'ODESSA','TX','79763','8210','CY','48135','1991-10-13','F','U',':RET:2106-3','N','021','DEN','1895673','33348TX002000201','2014-02-01','2014-01-07 18:48:56','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-13 02:21:10'),(1101,905,'Y','18','021','EC','A','','','AC','0000525548','0000525548','OH00000689823','IL','1','PERLMUTER','PATRICIA','','','','34','284503831','23511 CHAGRIN BLVD',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1950-10-10','F','M',':RET:2106-3','N','021','DEN','711633','99734OH005000401','2014-01-01','2013-12-03 14:11:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:16'),(1155,953,'Y','18','021','EC','A','','','AC','0000417919','0000417919','LA00000464126','IL','1','Richters','Markus','','','','34','463839914','238 LEBOEUF ST',0,'NEW ORLEANS','LA','70114','1314','CY','22071','1970-12-03','M','U',':RET:2106-3','N','021','DEN','545636','18575LA002000201','2014-01-01','2013-12-03 14:15:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:44'),(4023,3212,'Y','18','021','EC','A','','','AC','0000970447','0000970447','OH00001232240','IL','1','Blake','Kathryn','','','','34','277688740','8864 United Lane',0,'Athens','OH','45701',NULL,'CY','39009','1960-09-16','F','U',':RET:2079-2^:RET:2106-3','N','021','DEN','1985659','99734OH005000401','2014-01-01','2013-12-17 08:49:05','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:45:42'),(4752,3767,'Y','18','021','EC','A','','','AC','0000106342','0000106342','TX00000219523','IL','1','Young','Debora','','','','34','465040207','601 COUNTY ROAD 2540',0,'MERIDIAN','TX','76665','4739','CY','48035','1954-04-20','F','R',':RET:2106-3','N','021','DEN','741984','33348TX002000201','2014-01-01','2013-12-08 11:05:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:15:14'),(2826,2283,'N','01','021','EC','A',NULL,NULL,'','0000740233','0000277249','','IL','1','Reynolds','Edward','','','','34','191466701','6750 Stillman rd',0,'Anover','OH','44003',NULL,'CY','39007','1956-12-13','M','',':RET:2106-3','N','021','HLT','690882','52664OH151001306','2014-01-01','2013-11-23 18:36:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','612.95',NULL,0,'2013-12-25 20:00:37'),(2472,2012,'Y','18','021','EC','A','','','AC','0000936334','0000936334','LA00000119774','IL','1','Phillips','Dora','','','','34','439849418','200 Crockett Street',0,'Lafayette','LA','70501',NULL,'CY','22055','1950-03-04','F','U',':RET:2054-5','N','021','DEN','281849','18575LA002000201','2014-01-01','2013-12-09 09:24:40','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 19:35:15'),(18306,14615,'Y','18','024','14','A','','','TE','0001231780','0001231780','','IL','1','MELLUSO','REBECCA','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-05-26','F','',NULL,NULL,NULL,'','1579912','','2014-01-15','2014-01-15 10:54:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-16 08:44:59'),(21185,16930,'Y','18','024','14','A','','','TE','0000284891','0000284891','','IL','1','LOFTON','SHENIKA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-12-11','F','',NULL,NULL,NULL,'','1811804','','2014-02-03','2014-02-03 00:14:34',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-03 21:00:45'),(23135,18441,'Y','18','021','EC','A','','','AC','0000912998','0000912998','OH00002075440','IL','1','HILDRETH','MICHELLE','R','','','34','297749391','146 GOODVIEW AVE',0,'AKRON','OH','44305','3619','CY','39153','1963-04-20','F','U',':RET:2106-3','N','021','HLT','2871820','52664OH151001306','2014-03-01','2014-02-12 09:18:58','306.00',NULL,NULL,'398.29','92.29','R-OH012','OH0','398.29',NULL,0,'2014-02-12 21:31:32'),(26290,20854,'Y','18','021','EC','A','','','AC','0001341771','0001341771','LA00002093546','IL','1','Buggs','KATHY','','','','34','439969207','684 HIGHWAY 3061',0,'RUSTON','LA','71270','9088','CY','22061','1955-08-23','F','U',':RET:2054-5','T','021','DEN','3596370','18575LA002000101','2014-03-01','2014-02-27 14:12:09','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-28 06:31:23'),(301,249,'Y','18','021','EC','A','','','AC','0000290755','0000290755','OH00001161864','IL','1','JOLLY','RICHARD','H','','Jr','34','276568203','10632 GILBERT RD',0,'NEWTON FALLS','OH','44444','9269','CY','39133','1964-01-10','M','M',NULL,'N','021','HLT','426917','52664OH151001301','2014-01-01','2013-11-13 01:46:56','172.00',NULL,NULL,'817.54','645.54','R-OH012','OH0','380.45',NULL,0,'2013-12-25 17:30:49'),(16405,13127,'Y','18','021','EC','A','','','AC','0000914866','0000914866','TX00001432152','IL','1','MACEIUNAS','LAURA','','','','34','463419977','2600 CLEAR SPRINGS DR',0,'RICHARDSON','TX','75082',NULL,'CY','48085','1962-09-04','F','M',NULL,'N','021','DEN','1534690','33348TX002000201','2014-02-01','2014-01-06 11:31:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:04:02'),(735,609,'Y','18','021','EC','A','','','AC','0000713606','0000713606','TX00001087502','IL','1','Langford','Trent','','','','34','631090073','3113 CHELSEA PL',0,'MIDLAND','TX','79705','2323','CY','48329','1987-09-02','M','U',':RET:2106-3','N','021','DEN','786021','33348TX002000201','2014-01-01','2013-12-15 20:31:16','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-25 18:03:54'),(14207,11329,'Y','18','021','EC','A','','','AC','0000658860','0000658860','TX00001445806','IL','1','Lozano','Pablo','','','','34','453049165','611 S DALLAS ST',0,'MIDLAND','TX','79701','7423','CY','48329','1954-07-12','M','U',':RET:2106-3','N','021','DEN','2489365','33348TX002000201','2014-02-01','2013-12-26 14:19:35','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-27 02:04:23'),(1467,1222,'N','01','021','EC','A',NULL,NULL,'','0000078771','0000743088','','IL','1','Miller','Michael','','','','34','301521290','4943 Barrie St NW',0,'Canton','OH','44708',NULL,'CY','39151','1952-06-11','M','',':RET:2106-3','N','021','DEN','1657919','99734OH005000401','2014-01-01','2013-12-24 09:05:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:28'),(4512,3576,'N','01','021','EC','A',NULL,NULL,'','0000324016','0001252946','','IL','1','Lovell','Shanda','','','','34','460630644','1100 Starling Ct',0,'Burleson','TX','76028',NULL,'CY','48251','1977-10-15','F','',':RET:2106-3','T','021','DEN','218963','33348TX002000201','2014-01-01','2013-12-12 09:58:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:37'),(1750,1449,'Y','18','021','EC','A','','','AC','0000835460','0000835460','OH00000824575','IL','1','Green','Stephen','Kyle','','','34','086783850','697 SLEEPY HOLLOW DR',0,'UNIONTOWN','OH','44685','9611','CY','39153','1990-11-29','M','U',':RET:2106-3','N','021','DEN','2376281','99734OH005000301','2014-01-01','2013-12-24 12:17:19','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:55:41'),(18463,14729,'Y','18','021','EC','A','','','AC','0001483475','0001483475','LA00001725287','IL','1','Rhea','Owen','','','','34','434352141','9605 JEFFERSON HWY',0,'NEW ORLEANS','LA','70123','2550','CY','22051','1970-07-21','M','U',NULL,'N','021','DEN','1385274','18575LA002000101','2014-02-01','2014-01-15 16:36:19','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-16 08:46:13'),(21731,17353,'Y','18','021','EC','A','','','AC','0000105119','0000105119','TX00002287903','IL','1','jordan','linda','ruth','','','34','449064072','809 CAROLINA ST',0,'GRAHAM','TX','76450','3626','CY','48503','1951-01-24','F','U',NULL,'N','021','DEN','2680675','33348TX002000201','2014-03-01','2014-02-06 15:34:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:09'),(22299,17802,'Y','18','021','EC','A','','','AC','0000308300','0000308300','OH00002533872','IL','1','bailey','lisa','','','','34','768768441','2114 CRAMER AVE',0,'AKRON','OH','44312','1275','CY','39153','1965-02-07','F','U',NULL,'N','021','DEN','3378914','99734OH005000301','2014-03-01','2014-01-27 20:29:07','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-10 11:00:35'),(23789,18931,'Y','18','024','14','A','','','TE','0000716386','0000716386','','IL','1','Kunzin','Carol',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-13','F','',NULL,NULL,NULL,'','3685649','','2014-02-14','2014-02-14 09:42:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:31:24'),(25216,20001,'Y','18','024','14','A','','','TE','0001157590','0001157590','','IL','1','Collett','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-09','M','',NULL,NULL,NULL,'','1801575','','2014-02-21','2014-02-21 17:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-21 22:00:53'),(27511,21765,'Y','18','021','EC','A','','','AC','0000809735','0000809735','OH00003076562','IL','1','Dunlea','Amy','','','','34','295760865','7305 WILLOWOOD DR',0,'WEST CHESTER','OH','45241','3707','CY','39017','1966-01-27','F','U',':RET:2106-3','N','021','HLT','3867739','92036OH002001201','2014-04-01','2014-03-04 10:28:13','0.00',NULL,NULL,'720.19','720.19','R-OH004','OH0','405.33',NULL,0,'2014-03-04 21:02:33'),(28020,22174,'Y','18','021','EC','A','','','AC','0000461997','0000461997','OH00003510461','IL','1','SUPPLENUSBAUM','Donna','','','','34','278522850','6325 MARIANA DR',0,'CLEVELAND','OH','44130','2839','CY','39035','1956-04-12','F','M',NULL,'N','021','DEN','3606512','99734OH005000401','2014-04-01','2014-03-06 14:21:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:20'),(29077,23013,'N','01','021','EC','A',NULL,NULL,'','0000890776','0000313820','','IL','1','LOWMAN','JESSE','','','Jr','34','545332663','385 NAIL RD',0,'SOUTHAVEN','MS','38671',NULL,'CY','28033','1964-01-30','M','',':RET:2106-3','T','021','DEN','4183915','46300MS002000101','2014-04-01','2014-03-09 23:42:31',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-10 21:02:00'),(7457,5900,'Y','18','021','EC','A','','','AC','0000828215','0000828215','OH00000784734','31','1','putman','maryann','j','','','34','270666670','5765 south state rte 48',0,'maineville','OH','45039',NULL,'CY','39017','1958-05-20','F','M',':RET:2054-5','N','021','DEN','1177117','99734OH005000301','2014-01-01','2013-12-15 13:10:48','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:30:47'),(20409,16300,'N','01','021','EC','A',NULL,NULL,'','0000944425','0001102611','','IL','1','Oyervides','Michel','Adriana','','','34','640240593','9604 BAHAMAS ST',0,'EL PASO','TX','79927','2801','CY','48141','1973-05-02','F','',':RET:2106-3','N','021','DEN','2786349','33348TX002000201','2014-03-01','2014-01-29 16:36:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:23'),(20654,16505,'Y','18','024','14','A','','','TE','0001089436','0001089436','','IL','1','Patel','Paresh',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-10-31','M','',NULL,NULL,NULL,'','902806','','2014-01-30','2014-01-30 16:11:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-30 21:00:40'),(9464,7508,'Y','18','021','EC','A','','','AC','0000442168','0000442168','OH00000665781','IL','1','Pruner','Timothy','','','','34','284647185','1091 CRESTVIEW DR',0,'CRESTLINE','OH','44827','9617','CY','39139','1961-12-15','M','M',':RET:2106-3','N','021','DEN','2115751','99734OH005000401','2014-01-01','2013-12-21 09:23:49','0.00',NULL,NULL,'31.57','31.57','R-OH007','OH0','0.00',NULL,0,'2013-12-26 04:34:17'),(23234,18523,'Y','18','021','EC','A','','','AC','0000948467','0000948467','OH00002296959','IL','1','Walters','Nicholas','','','','34','294860337','1491 Main St',0,'Evansport','OH','43519',NULL,'CY','39039','1981-06-17','M','U',NULL,'N','021','HLT','3011888','92036OH003002605','2014-03-01','2014-02-12 12:30:03','163.00',NULL,NULL,'240.90','77.90','R-OH001','OH0','240.90',NULL,0,'2014-02-12 21:32:27'),(23486,18708,'Y','18','021','EC','A','','','AC','0002307251','0002307251','LA00002546609','IL','1','OSBON','MICHAEL','','','','34','434630981','227 CODIFER BLVD',0,'METAIRIE','LA','70005','3722','CY','22051','1973-12-13','M','U',NULL,'T','021','DEN','3183293','18575LA002000101','2014-03-01','2014-02-13 14:17:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-13 22:01:59'),(26008,20627,'Y','18','021','EC','A','','','AC','0000555425','0000555425','OH00002806389','IL','1','RITTENHOUSE','MOLLY','','','','34','294824121','323 N MAIN ST',0,'SAINT MARYS','OH','45885','2153','CY','39011','1978-07-19','F','M',NULL,'N','021','HLT','3352954','92036OH005001506','2014-03-01','2014-02-26 14:52:34','238.00',NULL,NULL,'268.93','30.93','R-OH002','OH0','268.93',NULL,0,'2014-02-26 21:02:08'),(28355,22435,'Y','18','021','EC','A','','','AC','0000210748','0000210748','TX00003601741','IL','1','ESQUIVEL','SHARON','','','','34','159643953','2312 PECAN RIDGE DR',0,'BRYAN','TX','77802','2245','CY','48041','1973-07-07','F','U',':RET:2106-3','N','021','DEN','3571440','33348TX002000201','2014-04-01','2014-03-07 13:34:37','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-03-07 21:30:25'),(629,520,'Y','18','024','14','A','','','TE','0000307066','0000307066','','IL','1','Wainscott','Peggy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-12-13','F','',NULL,NULL,NULL,'','878199','','2013-12-16','2013-12-16 12:52:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:01:03'),(16458,13170,'N','01','021','EC','A',NULL,NULL,'','0000227069','0001083100','','IL','1','Schackmann','Melanie','Veronica','','','34','217905480','326 PALM SPRINGS DR',0,'FAIRFIELD','OH','45014','8638','CY','39017','1976-12-05','F','',':RET:2106-3','N','021','HLT','2087598','92036OH003001205','2014-02-01','2014-01-06 10:06:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.53',NULL,0,'2014-01-07 04:05:39'),(16313,13061,'Y','18','021','EC','A','','','AC','0001444306','0001444306','LA00001860849','IL','1','Fontenot','Channtanza','','','','34','433831659','908 Lamar St',0,'Lafayette','LA','70501',NULL,'CY','22055','1991-09-04','F','U',':RET:2054-5','N','021','DEN','2179838','18575LA002000201','2014-02-01','2014-01-06 16:14:31','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-07 04:01:29'),(1049,860,'N','01','021','EC','A',NULL,NULL,'','0000399383','0000094649','','IL','1','dang','larry','','','','34','547859797','4666 University ave',0,'Wichita falls','TX','76308',NULL,'CY','48485','1960-02-14','M','',':RET:2047-9','N','021','DEN','168363','33348TX002000201','2014-01-01','2013-12-03 12:10:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:15:58'),(5731,4548,'N','01','021','EC','A',NULL,NULL,'','0001190743','0002299648','','IL','1','Taylor','Joseph','','','','34','437801956','11227 Flamingo Drive',0,'Baton Rouge','LA','70814',NULL,'CY','22033','1950-06-18','M','',NULL,'N','021','DEN','2059576','18575LA002000201','2014-01-01','2013-12-23 22:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:45:40'),(4694,3722,'Y','18','021','EC','A','','','AC','0001173194','0001173194','OH00000092486','IL','1','MORGAN','TROY','','','','34','273882525','829 S DETROIT ST',0,'XENIA','OH','45385',NULL,'CY','39057','1975-10-16','M','M',':RET:2106-3','N','021','HLT','651874','92036OH005000505','2014-01-01','2013-12-12 12:47:02','314.00',NULL,NULL,'577.41','263.41','R-OH003','OH0','296.20',NULL,0,'2013-12-25 22:08:16'),(14211,11332,'Y','18','021','EC','A','','','AC','0001199173','0001199173','TX00000369872','IL','1','Gonzalez','Paula','Rubio','','','34','636262834','1124 E HARRIS AVE',0,'SAN ANGELO','TX','76903','5612','CY','48451','1959-04-17','F','U',NULL,'N','021','DEN','1503597','33348TX002000201','2014-02-01','2013-12-26 14:59:51','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-27 02:04:30'),(14185,11310,'Y','18','021','EC','A','','','AC','0000307694','0000307694','TX00000289302','IL','1','morales','andres','','','','34','456352291','3101 durazno',0,'El Paso','TX','79905',NULL,'CY','48141','1965-05-21','M','U',NULL,'N','021','DEN','2205627','33348TX002000201','2014-02-01','2013-12-26 11:23:12','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-27 02:03:49'),(1854,1518,'N','01','021','EC','A',NULL,NULL,'','0000057335','0000765979','','IL','1','Halpin','Tina','M','','','34','300565426','10356 Marvin Road',0,'Harrison','OH','45030',NULL,'CY','39061','1955-11-12','F','',':RET:2106-3','N','021','HLT','2056929','92036OH005001205','2014-01-01','2013-12-24 15:38:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','546.97',NULL,0,'2013-12-25 18:58:00'),(18232,14552,'Y','18','021','EC','A','','','AC','0000612374','0000612374','TX00001955508','IL','1','Rawlins','Heather','','','','34','637308939','107 28TH ST',0,'CANYON','TX','79015','3130','CY','48381','1988-08-04','F','U',':RET:1002-5','T','021','DEN','2882138','33348TX002000201','2014-02-01','2014-01-14 21:59:29','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-16 08:44:19'),(20199,16117,'Y','18','021','EC','A','','','AC','0000406677','0000406677','MS00002163125','IL','1','Van Buren','Arthur','','','','34','587888276','2475 Goodhope Road',0,'Edward','MS','39066',NULL,'CY','28049','1953-12-08','M','U',':RET:2054-5','T','021','DEN','3035131','46300MS002000101','2014-03-01','2014-01-27 11:33:11','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-27 21:01:31'),(23970,19057,'Y','18','021','EC','A','','','AC','0000486979','0000486979','TX00002635698','IL','1','blalock','sasha','','','','34','462852350','6731 DESERT ROSE LN',0,'HOUSTON','TX','77086','2819','CY','48201','1987-03-15','F','U',':RET:2054-5','N','021','DEN','2825721','33348TX002000101','2014-03-01','2014-02-15 15:43:13','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-15 22:00:13'),(28613,22646,'Y','18','021','EC','A','','','AC','0001104214','0001104214','TX00003343608','IL','1','FLORES  TRUJILLO','PAULINA','','','','34','730262240','923 W HUBBARD ST',0,'MINERAL WELLS','TX','76067','4856','CY','48363','1961-07-18','F','M',':RET:2106-3','N','021','DEN','3646796','33348TX002000201','2014-04-01','2014-03-07 21:43:29','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:17'),(866,717,'Y','18','021','EC','A','','','AC','0001256020','0001256020','OH00000007442','IL','1','Harkness','Priscilla','','','','34','295584410','486 STONEWOOD DR',0,'AKRON','OH','44313','6643','CY','39153','1957-01-28','F','U',NULL,'N','021','HLT','2036250','52664OH151001501','2014-01-01','2013-12-16 09:47:36','387.00',NULL,NULL,'624.00','237.00','R-OH012','OH0','624.00',NULL,0,'2013-12-25 18:07:20'),(17125,13705,'Y','18','021','EC','A','','','AC','0000614119','0000614119','OH00000893342','IL','1','Watkins','Therese','','','','34','281821254','113 Lynnfield Circle',0,'Union','OH','45333',NULL,'CY','39149','1970-10-03','F','U',':RET:2106-3','N','021','DEN','2100568','99734OH005000401','2014-02-01','2014-01-08 11:01:32','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:21:44'),(9099,7223,'Y','18','021','EC','A','','','AC','0000246433','0000246433','OH00001148601','IL','1','Ilhardt','Mary','','','','34','302722846','1324 LIBBY LN',0,'NEW RICHMOND','OH','45157','9163','CY','39025','1963-05-16','F','M',':RET:2106-3','T','021','DEN','1490662','99734OH005000301','2014-01-01','2013-12-18 14:36:49','0.00',NULL,NULL,'42.26','42.26','R-OH005','OH0','0.00',NULL,0,'2013-12-26 04:07:20'),(13350,10662,'Y','18','021','EC','A','','','AC','0000782806','0000782806','TX00000548219','31','1','Morales','Stephanie','','','','34','453675518','PO Box 7865',0,'Victoria','TX','77903',NULL,'CY','48469','1978-05-28','F','M',':RET:2106-3','N','021','DEN','1508511','33348TX002000201','2014-01-01','2013-12-23 19:10:35','0.00',NULL,NULL,'29.22','29.22','R-TX023','TX0','14.61',NULL,0,'2013-12-26 12:59:11'),(13994,11149,'Y','18','021','EC','A','','','AC','0000933206','0000933206','OH00001115304','IL','1','Durnell','Zachery','','','','34','274901975','223 N BUCKEYE ST',0,'SAINT MARYS','OH','45885','2009','CY','39011','1982-05-19','M','U',':RET:2106-3','N','021','HLT','2368076','92036OH002001501','2014-01-01','2013-12-23 07:13:15','0.00',NULL,NULL,'294.58','294.58','R-OH002','OH0','294.58',NULL,0,'2013-12-26 13:15:53'),(27902,22074,'N','01','021','EC','A',NULL,NULL,'','0000556708','0000163022','','IL','1','Tran','Dung','','','','34','875687080','3908 NORFOLK CT',0,'ODESSA','TX','79765','8528','CY','48135','1970-07-14','M','',':RET:2047-9','N','021','DEN','3935877','33348TX002000201','2014-04-01','2014-03-05 18:04:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:10'),(37,32,'Y','18','021','EC','A','','','AC','0000745405','0000745405','OH00000921065','IL','1','Salyers','Charles','','','','34','294641662','15026 GIBSON RD',0,'ASHVILLE','OH','43103','9663','CY','39129','1958-03-07','M','U',':RET:2106-3','N','021','DEN','1026691','99734OH005000401','2014-01-01','2013-12-05 12:45:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:15:57'),(14334,11434,'Y','18','021','EC','A','','','AC','0000699280','0000699280','OH00001497457','IL','1','Vanatta','Todd','','','','34','282663682','9250 BARR RD',0,'UNION CITY','OH','45390','9007','CY','39037','1961-03-15','M','M',NULL,'T','021','HLT','2098959','92036OH004000501','2014-02-01','2013-12-26 13:58:29','311.00',NULL,NULL,'429.06','118.06','R-OH003','OH0','429.06',NULL,0,'2013-12-27 02:07:41'),(9421,7474,'Y','18','021','EC','A','','','AC','0000221856','0000221856','TX00000667806','31','1','Olima','Lilian','','','','34','634083962','P.O Box 154443',0,'Lufkin','TX','75915',NULL,'CY','48005','1979-02-03','F','M',':RET:2054-5','N','021','DEN','1718674','33348TX002000201','2014-01-01','2013-12-21 14:46:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:33:06'),(5991,4743,'Y','18','021','EC','A','','','AC','0000929808','0000929808','OH00001002972','IL','1','williams','rita','','','','34','293483926','5935 WARREN SHARON RD',0,'BROOKFIELD','OH','44403','9551','CY','39155','1949-04-18','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','111597','92036OH001003201','2014-01-01','2013-12-01 10:05:27','300.00',NULL,NULL,'875.89','575.89','R-OH013','OH0','875.89',NULL,0,'2013-12-26 00:00:03'),(7057,5606,'Y','18','021','EC','A','','','AC','0000611960','0000611960','OH00000124228','IL','1','Hoyt','Jennifer','','','','34','280569892','5909 LENGWOOD DR',0,'CINCINNATI','OH','45244','3810','CY','39061','1956-04-30','F','M',':RET:2106-3','N','021','DEN','1874025','99734OH005000301','2014-01-01','2013-12-24 20:42:55','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:49:50'),(6866,5445,'Y','18','021','EC','A','','','AC','0000958523','0000958523','TX00000391465','IL','1','Gardner','Gene','','','','34','464667612','1029 COUNTY ROAD 244',0,'WEIMAR','TX','78962','4605','CY','48089','1951-02-06','M','U',NULL,'N','021','DEN','1113034','33348TX002000201','2014-01-01','2013-11-03 10:03:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:31:49'),(6719,5329,'Y','18','021','EC','A','','','AC','0000605913','0000605913','OH00000156258','IL','1','Brown','Dawn','','','','34','298785653','1249 W WILBETH RD',0,'AKRON','OH','44314','1970','CY','39153','1982-08-25','F','M',':RET:2106-3','N','021','DEN','624383','99734OH005000401','2014-01-01','2013-11-25 13:22:40','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:15:08'),(17234,13792,'Y','18','021','EC','A','','','AC','0001044139','0001044139','MS00001834094','IL','1','powell','tyrone','','','','34','425270927','224 SILVER LK',0,'PEARL','MS','39208','5079','CY','28121','1971-07-20','M','U',NULL,'N','021','DEN','1824254','46300MS002000101','2014-02-01','2014-01-08 16:50:45','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-13 02:22:41'),(22149,17679,'N','01','021','EC','A',NULL,NULL,'','0000452790','0000710180','','IL','1','Vittoria','Maridsa','','','','34','048481785','45 VALENTINE FARMS DR',0,'AKRON','OH','44333','2551','CY','39103','1952-12-09','F','',NULL,'N','021','HLT','2712971','52664OH151001305','2014-03-01','2014-02-08 12:06:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-02-08 19:00:53'),(24676,19585,'Y','18','021','EC','A','','','AC','0000088602','0000088602','OH00002745113','IL','1','Harper','Walter','','','','34','296646330','54 Ridge St. - Po Box 11',0,'Belmore','OH','45815',NULL,'CY','39137','1959-09-11','M','U',':RET:2106-3','N','021','HLT','3449639','92036OH004001501','2014-04-01','2014-02-19 10:40:43','375.06',NULL,NULL,'377.82','2.76','R-OH002','OH0','377.82',NULL,0,'2014-02-20 04:28:33'),(25843,20486,'N','01','021','EC','A',NULL,NULL,'','0001153666','0000103938','','IL','1','Baker','Victoria','L','','','34','293501383','405 OAK MANOR AVE NE',0,'MASSILLON','OH','44646','4033','CY','39151','1951-01-18','F','',':RET:2106-3','T','021','HLT','2949207','52664OH152000901','2014-03-01','2014-02-26 07:06:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','554.51',NULL,0,'2014-02-26 21:00:36'),(26093,20694,'Y','18','021','EC','A','','','AC','0001913359','0001913359','LA00002570265','IL','1','RAMIREZ','CANDIDO','EMILIO','','','34','596207323','711 TERREBONNE ST',0,'MORGAN CITY','LA','70380',NULL,'CY','22101','1952-10-12','M','M',NULL,'N','021','DEN','3551765','18575LA002000201','2014-04-01','2014-02-27 12:18:17','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-28 06:30:09'),(5526,4383,'Y','18','021','EC','A','','','AC','0001143286','0001143286','OH00000029649','IL','1','Southard','Shawna','','','','34','294924215','198 westbrook dr',0,'hamilton','OH','45013',NULL,'CY','39017','1988-03-09','F','M',':RET:2106-3','T','021','DEN','224975','99734OH005000401','2014-01-01','2013-11-26 19:38:41','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:15:27'),(14332,11432,'Y','18','021','EC','A','','','AC','0000039819','0000039819','OH00000173841','IL','1','Meyers','Jonathan','','','','34','295886959','665 Main Street',0,'Clay center','OH','43408',NULL,'CY','39123','1987-03-10','M','U',':RET:2106-3','N','021','HLT','1979371','92036OH004002701','2014-02-01','2013-12-26 13:17:11','0.00',NULL,NULL,'160.55','160.55','R-OH006','OH0','160.55',NULL,0,'2013-12-27 02:07:36'),(18089,14448,'Y','18','021','EC','A','','','AC','0002011478','0002011478','LA00001886307','IL','1','Lindsley','Lavonda','S','','','34','414155216','1432 SAINT MAURICE AVE',0,'NEW ORLEANS','LA','70117','1332','CY','22071','1964-11-06','F','M',':RET:2054-5','N','021','DEN','2594591','18575LA002000201','2014-02-01','2014-01-14 12:04:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:29'),(20782,16604,'Y','18','021','EC','A','','','AC','0000016584','0000016584','TX00001751515','31','1','DO','BINH','HUY','','','34','644587603','PO BOX 221631',0,'EL PASO','TX','79913',NULL,'CY','48141','1964-06-20','M','U',NULL,'N','021','DEN','3599387','33348TX002000201','2014-03-01','2014-01-30 21:07:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:10'),(22757,18169,'Y','18','021','EC','A','','','AC','0001453635','0001453635','LA00001623574','IL','1','Turner','John','','','','34','433532183','328 FONTAINE ST',0,'SHREVEPORT','LA','71105','4136','CY','22017','1969-11-17','M','U',':RET:2106-3','N','021','DEN','3718470','18575LA002000101','2014-03-01','2014-02-11 17:55:09','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-11 21:01:30'),(23215,18506,'Y','18','021','EC','A','','','AC','0000022691','0000022691','MS00002208852','IL','1','Friedman','Bert','','','','34','427292536','106 BAINBRIDGE LN',0,'MADISON','MS','39110','8875','CY','28089','1962-10-18','M','U',':RET:2106-3','N','021','DEN','3808208','46300MS002000201','2014-03-01','2014-02-12 13:59:36','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-12 21:32:15'),(25404,20154,'Y','18','024','14','A','','','TE','0000029007','0000029007','','IL','1','Frenton','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-09-08','M','',NULL,NULL,NULL,'','1030460','','2014-03-11','2014-02-24 18:36:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:58'),(29073,23010,'Y','18','021','EC','A','','','AC','0000878338','0000878338','OH00002656164','IL','1','REINHART','HERMAN','','','','34','285441909','369 S MONROE ST',0,'TIFFIN','OH','44883','3005','CY','39147','1955-06-25','M','U',':RET:2106-3','N','021','HLT','4149991','92036OH006002701','2014-04-01','2014-03-10 16:11:20','306.00',NULL,NULL,'394.02','88.02','R-OH006','OH0','394.02',NULL,0,'2014-03-10 21:01:58'),(658,543,'Y','18','021','EC','A','','','AC','0000234036','0000234036','OH00000034643','IL','1','Sanders','Carolyn','','','','34','299585893','241 S COY RD',0,'OREGON','OH','43616','2405','CY','39095','1957-05-07','F','U',':RET:2106-3','N','021','DEN','650563','99734OH005000301','2014-01-01','2013-12-15 19:20:16','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:01:48'),(7520,5951,'Y','18','021','EC','A','','','AC','0000100048','0000100048','OH00001088800','IL','1','Martin','Steven','','','','34','280487228','10475 WINTERGREEN CT',0,'CINCINNATI','OH','45241','3032','CY','39061','1950-02-16','M','M',':RET:2106-3','N','021','HLT','885557','92036OH006001201','2014-01-01','2013-12-14 19:54:52','476.00',NULL,NULL,'502.56','26.56','R-OH004','OH0','502.56',NULL,0,'2013-12-26 02:32:21'),(15344,12273,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00001966040','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','1571307','52664OH152000901','2014-02-01','2014-01-01 12:20:09','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,1,'2014-01-02 04:24:20'),(14561,11617,'Y','18','021','EC','A','','','AC','0001199502','0001199502','OH00001211103','IL','1','CLEMENT','CAROLYN','','','','34','288507802','3065 GREENLEAF RD',0,'AKRON','OH','44312','5027','CY','39153','1950-02-07','F','M',':RET:2106-3','N','021','HLT','2549914','52664OH152000901','2014-02-01','2013-12-27 12:24:33','430.00',NULL,NULL,'482.18','52.18','R-OH012','OH0','482.18',NULL,0,'2013-12-28 03:35:16'),(2073,1697,'Y','18','021','EC','A','','','AC','0000324890','0000324890','LA00000472856','IL','1','Bodie','Scott','','','','34','431473091','100 JEFFERSON HEIGHTS AVE',0,'JEFFERSON','LA','70121','3208','CY','22051','1975-10-22','M','U',':RET:2106-3','N','021','DEN','475332','18575LA002000201','2014-01-01','2013-12-09 21:29:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:16:25'),(6623,5252,'N','01','021','EC','A',NULL,NULL,'','0000612853','0001135865','','IL','1','Elzie','Bettie','Joyce','','','34','587627578','1324 LAMBARD DR',0,'TUPELO','MS','38801','2434','CY','28081','1951-04-26','F','',':RET:2054-5','N','021','DEN','838321','46300MS002000201','2014-01-01','2013-12-11 17:45:27',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 00:54:06'),(2647,2151,'Y','18','021','EC','A','','','AC','0000546368','0000546368','TX00000945690','IL','1','DANIEL','VALERIE','','','','34','244083284','13500 NOEL RD',0,'DALLAS','TX','75240',NULL,'CY','48113','1958-05-16','F','U',':RET:2106-3','N','021','DEN','376020','33348TX002000101','2014-01-01','2013-12-02 17:15:34','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:46:30'),(20891,16696,'Y','18','021','EC','A','','','AC','0000258196','0000258196','OH00002485896','IL','1','ACHESON','JERRY','DALE','','Sr','34','295541276','9685 DOZER RIDGE RD',0,'BLUE ROCK','OH','43720','9756','CY','39119','1955-06-25','M','U',':RET:2106-3','N','021','DEN','3020567','99734OH005000401','2014-03-01','2014-01-31 10:23:35','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-31 21:01:15'),(25064,19877,'Y','18','021','EC','A','','','AC','0000898502','0000898502','OH00002034369','IL','1','Lackey','Rhonda','','','','34','283524319','5330 LACONIA AVE',0,'CINCINNATI','OH','45237','5804','CY','39061','1953-04-24','F','U',':RET:2054-5','N','021','DEN','3622106','99734OH005000401','2014-04-01','2014-02-20 14:16:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 22:01:26'),(26657,21132,'Y','18','021','EC','A','','','AC','0000195191','0000195191','OH00002941418','IL','1','HUYNH','ERIC','','','','34','295960182','414 MATTHEWS ST',0,'AKRON','OH','44306',NULL,'CY','39153','1970-11-15','M','U',':RET:2047-9','N','021','HLT','3217065','52664OH151001306','2014-04-01','2014-02-28 14:38:38','245.00',NULL,NULL,'302.62','57.62','R-OH012','OH0','302.62',NULL,0,'2014-02-28 21:31:09'),(7619,6029,'Y','18','021','EC','A','','','AC','0000735003','0000735003','OH00000386173','31','1','Warren','Daniel','','','','34','589743314','7934 Pepper Pike',0,'West Chester','OH','45069',NULL,'CY','39061','1988-05-28','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','545510','99734OH005000301','2014-01-01','2013-11-17 14:20:11','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:45:51'),(1532,1276,'Y','18','021','EC','A','','','AC','0001124069','0001124069','OH00000540551','IL','1','Brasty','Annmarie','','','','34','281647557','9114 Chatham Road',0,'Medina','OH','44256',NULL,'CY','39103','1959-01-10','F','M',':RET:2106-3','N','021','DEN','1529284','99734OH005000401','2014-01-01','2013-12-24 16:10:53','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:50:03'),(18045,14416,'Y','18','024','14','A','','','TE','0000856514','0000856514','','IL','1','Hydrick','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-07-06','M','',NULL,NULL,NULL,'','1661173','','2014-01-13','2014-01-13 20:42:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-15 02:07:14'),(19085,15205,'Y','18','021','EC','A','','','AC','0000312218','0000312218','OH00001825442','IL','1','HAUPRICHT','BARBARA','','','','34','289649885','4830 ELM PLCE',0,'TOLEDO','OH','43613',NULL,'CY','39095','1962-05-22','F','M',':RET:2106-3','N','021','DEN','2983261','99734OH005000401','2014-03-01','2014-01-18 15:44:23','0.00',NULL,NULL,'50.05','50.05','R-OH001','OH0','0.00',NULL,0,'2014-01-21 08:44:29'),(19567,15599,'Y','18','021','EC','A','','','AC','0001963571','0001963571','LA00002462641','IL','1','parker','monique','','','','34','435433936','10501 curran blvd Apt 12b',0,'New Orleans','LA','70127',NULL,'CY','22071','1980-04-08','F','R',':RET:2054-5','N','021','DEN','1877236','18575LA002000201','2014-03-01','2014-01-22 00:32:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 03:02:35'),(20222,16134,'Y','18','021','EC','A','','','AC','0000539317','0000539317','OH00001535723','IL','1','Reiley','Michael','','','','34','268529665','126 FAIRLAND AVE',0,'WILMINGTON','OH','45177','1419','CY','39027','1951-11-19','M','M',NULL,'N','021','HLT','2327874','92036OH004000601','2014-03-01','2014-01-27 15:33:54','486.00',NULL,NULL,'495.91','9.91','R-OH005','OH0','495.91',NULL,0,'2014-01-27 21:01:45'),(23131,18437,'Y','18','021','EC','A','','','AC','0001155137','0001155137','OH00002778862','IL','1','Nelson','Alyse','','','','34','282482442','3840 W 128TH ST',0,'CLEVELAND','OH','44111','4511','CY','39035','1952-01-21','F','M',':RET:2106-3','T','021','DEN','2679403','99734OH005000401','2014-03-01','2014-02-12 16:37:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:30'),(26227,20801,'Y','18','021','EC','A','','','AC','0000213550','0000213550','TX00002997722','IL','1','Bean','Catherine','','','','34','230021219','6148 PERCH DR',0,'FORT WORTH','TX','76179','7578','CY','48439','1964-01-15','F','U',':RET:2106-3','N','021','DEN','3006575','33348TX002000201','2014-04-01','2014-02-26 21:36:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-28 06:30:59'),(26832,21267,'Y','18','021','EC','A','','','AC','0001168064','0001168064','OH00002779269','IL','1','Raouidah','Abdessadaq','','','','34','090748064','5401 FLINTSTONE DR',0,'WESTERVILLE','OH','43081','4884','CY','39049','1964-07-08','M','M',':RET:2106-3','N','021','DEN','3290739','99734OH005000401','2014-04-01','2014-03-01 14:51:45','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:40'),(14,10,'Y','18','021','EC','A','','','AC','0000250222','0000250222','OH00000787976','IL','1','Creech','Lois','','','','34','288482760','2429 MILLVILLE AVE',0,'HAMILTON','OH','45013','4209','CY','39017','1950-04-23','F','M',NULL,'N','021','DEN','810880','99734OH005000401','2014-01-01','2013-12-05 07:41:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:20'),(13466,10740,'Y','18','021','EC','A','','','AC','0000463230','0000463230','OH00001379957','IL','1','BALL','CHRISTINA','','','','34','279902012','1470 ALPHADA AVE',0,'AKRON','OH','44310','2721','CY','39153','1984-12-04','F','U',':RET:2054-5','N','021','DEN','2472761','99734OH005000301','2014-01-01','2013-12-23 16:03:22','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:01:53'),(13387,10686,'Y','18','021','EC','A','','','AC','0001057988','0001057988','OH00000444153','IL','1','Mudd','Gabriel','Kirk','','','34','258510568','4956 WINDY RIDGE CT',0,'LIBERTY TWP','OH','45011','0414','CY','39017','1984-08-14','M','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2127061','99734OH005000301','2014-01-01','2013-12-23 01:30:54','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:02'),(13213,10544,'Y','18','021','EC','A','','','AC','0000356371','0000356371','TX00001297394','IL','1','pillado','Vicente','','','','34','635242381','3602 burke rd',0,'pasadena','TX','77504',NULL,'CY','48201','1991-04-26','M','M',NULL,'N','021','DEN','2351454','33348TX002000201','2014-01-01','2013-12-22 18:52:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:55:18'),(2380,1942,'Y','18','021','EC','A','','','AC','0000425063','0000425063','OH00000672063','IL','1','THARP','RANDY','','','','34','280428905','12284 MAUGER ROAD NORTH WEST',0,'BALTIMORE','OH','43105',NULL,'CY','39089','1960-12-17','M','M',':RET:2106-3','N','021','DEN','291231','99734OH005000401','2014-01-01','2013-12-09 10:26:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:00'),(18814,14985,'Y','18','021','EC','A','','','AC','0000975255','0000975255','OH00001592533','IL','1','lutsy','Charlotte','','','','34','234865067','348 SAVAGE ST',0,'BEREA','OH','44017','1313','CY','39035','1953-04-25','F','M',':RET:2106-3','N','021','DEN','2440180','99734OH005000401','2014-02-01','2014-01-15 19:46:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:36:04'),(19039,15163,'N','19','021','EC','A',NULL,NULL,'','0000440816','0000821758','','IL','1','agrawal','luv','','','','34','427674966','8 TWELVE OAKS PL',0,'MADISON','MS','39110','7537','CY','28089','1987-06-01','M','',':RET:2029-7','N','021','DEN','1535019','46300MS002000201','2014-03-01','2014-01-17 12:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-20 08:06:36'),(20074,16013,'Y','18','024','14','A','','','TE','0000078298','0000078298','','IL','1','DANSORD','WENDY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-12-30','F','',NULL,NULL,NULL,'','2348494','','2014-01-27','2014-01-27 15:09:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:19'),(24089,19152,'Y','18','021','EC','A','','','AC','0000055974','0000055974','OH00001709849','IL','1','Eaver','Jacquelyn','','','','34','296909188','231 SPRING ST',0,'WOOSTER','OH','44691','2968','CY','39169','1987-06-26','F','U',':RET:2106-3','N','021','HLT','3268053','52664OH151001305','2014-03-01','2014-02-15 14:14:31','100.00',NULL,NULL,'228.36','128.36','R-OH014','OH0','228.36',NULL,0,'2014-02-15 22:01:25'),(26150,20734,'Y','18','021','EC','A','','','AC','0000145439','0000145439','OH00003028814','IL','1','DRAVIS','BERNADETTE','','','','34','297689127','2507 BARLOW ROAD',0,'HUDSON','OH','44236',NULL,'CY','39153','1962-03-12','F','M',NULL,'N','021','DEN','3598843','99734OH005000401','2014-04-01','2014-02-27 14:22:09','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:28'),(2900,2339,'Y','18','021','EC','A','','','AC','0000895683','0000895683','OH00001200332','31','1','Facchiano','Anthony','','','','34','272500388','3505 HEMPHILL RD',0,'NORTON','OH','44203','5071','CY','39153','1950-08-03','M','R',':RET:2106-3','N','021','HLT','1168448','52664OH151001501','2014-01-01','2013-12-06 13:51:59','0.00',NULL,NULL,'1441.37','1441.37','R-OH012','OH0','789.56',NULL,0,'2013-12-25 20:15:21'),(15643,12513,'N','01','021','EC','A',NULL,NULL,'','0000296507','0000505802','','IL','1','Lee','Wesley','L','','','34','587085715','3414 E LISA DR',0,'PEARL','MS','39208','5430','CY','28121','1966-01-13','M','',':RET:2106-3','N','021','DEN','2024988','46300MS002000201','2014-02-01','2013-12-31 09:48:11',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,1,'2014-01-02 04:33:52'),(14964,11960,'N','01','021','EC','A',NULL,NULL,'','0000416770','0001214461','','IL','1','Autrey','Brian','','','','34','453319918','1305 N 3RD ST',0,'PRINCETON','TX','75407','6788','CY','48085','1969-07-07','M','',':RET:2106-3','N','021','DEN','2577603','33348TX002000201','2014-02-01','2013-12-30 10:56:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:00:35'),(14445,11522,'Y','18','021','EC','A','','','AC','0002105147','0002105147','LA00001222126','IL','1','Levy','Anita','','','','34','435410750','601 S. Guegnon Street',0,'Abbeville','LA','70510',NULL,'CY','22113','1968-04-06','F','U',':RET:2054-5','N','021','DEN','1929425','18575LA002000201','2014-02-01','2013-12-27 12:12:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-28 03:32:19'),(24145,19186,'N','19','021','EC','A',NULL,NULL,'','0000444955','0000743133','','IL','1','Bingamon','Tyler','','','','34','296042940','3533 NEALS CIR',0,'BATAVIA','OH','45103','9709','CY','39025','2000-04-01','M','',':RET:2106-3','N','021','HLT','3320747','92036OH004000601','2014-03-01','2014-02-15 11:05:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:54'),(24976,19809,'Y','18','021','EC','A','','','AC','0000244931','0000244931','TX00002237107','IL','1','Williams','Bridgette','','','','34','645074449','345 river fern ave',0,'Garland','TX','75040',NULL,'CY','48113','1989-06-07','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','3414304','33348TX002000201','2014-04-01','2014-02-20 09:08:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 22:00:30'),(27578,21809,'Y','18','021','EC','A','','','AC','0000091217','0000091217','OH00002904240','IL','1','Mattice','Christine','','','','34','281768129','2670 SWEITZER RD',0,'UNIONTOWN','OH','44685','8349','CY','39153','1960-12-03','F','U',':RET:2106-3','N','021','HLT','3646625','52664OH151001306','2014-04-01','2014-03-04 15:25:48','360.00',NULL,NULL,'454.94','94.94','R-OH012','OH0','454.94','CIC',0,'2014-03-04 21:30:24'),(27622,21847,'Y','18','021','EC','A','','','AC','0002094578','0002094578','LA00003765728','IL','1','PIPKINS','JESSICA','','','','34','438757239','1044 HURON RD',0,'ARNAUDVILLE','LA','70512','3721','CY','22099','1987-08-13','F','U',':RET:2054-5','N','021','DEN','3801509','18575LA002000101','2014-04-01','2014-03-05 13:59:13','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-05 21:30:04'),(28780,22782,'Y','18','021','EC','A','','','AC','0000024176','0000024176','OH00003233547','IL','1','VENUTO','ANTHONY','','','','34','283541576','4286 AUGUST PL.',0,'CINCINNATI','OH','45238',NULL,'CY','39061','1954-01-14','M','U',NULL,'N','021','DEN','3599187','99734OH005000401','2014-04-01','2014-03-09 15:04:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-09 21:00:35'),(1164,961,'Y','18','021','EC','A','','','AC','0000602279','0000602279','LA00000743222','IL','1','RAMOS','LANA','DEANN','','','34','437534102','74 H BRYANT RD',0,'DEVILLE','LA','71328','9230','CY','22079','1967-09-21','F','U',':RET:2106-3','N','021','DEN','150727','18575LA002000201','2014-01-01','2013-12-03 16:55:02','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 18:18:59'),(17208,13770,'N','01','021','EC','A',NULL,NULL,'','0001032622','0000291985','','IL','1','Orton','Cindy',NULL,NULL,NULL,NULL,NULL,'1531 First Street',0,'Lakemore','OH','44250',NULL,'CY','39153','1963-01-23','F','',':RET:2106-3','T','021','HLT','1434943','52664OH151001305','2014-02-01','2014-01-08 09:48:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.30',NULL,0,'2014-01-13 02:22:28'),(15408,12325,'Y','18','021','EC','A','','','AC','0000233140','0000233140','TX00001469991','IL','1','Smith','Aaron','','','','34','451857351','7903 South Loop East',0,'Houston','TX','77012',NULL,'CY','48201','1975-08-15','M','U',':RET:2054-5','N','021','DEN','2410384','33348TX002000201','2014-02-01','2013-12-30 23:17:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:27:01'),(13366,10676,'Y','18','021','EC','A','','','AC','0000859690','0000859690','OH00001091647','IL','1','Peters','Laurence','Barton','','','34','395561689','3151 Madeira Lane',0,'Maineville','OH','45039',NULL,'CY','39165','1952-01-16','M','U',':RET:2106-3','N','021','DEN','2224216','99734OH005000301','2014-01-01','2013-12-22 20:08:52','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:59:37'),(4382,3483,'Y','18','021','EC','A','','','AC','0000664160','0000664160','OH00001183138','IL','1','Henderson','Rita','Lynn','','','34','286667901','117 Tammany Court',0,'Mentor','OH','44060',NULL,'CY','39085','1960-07-27','F','U',':RET:2106-3','T','021','DEN','1196043','99734OH005000401','2014-01-01','2013-12-12 09:39:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:39'),(9255,7339,'Y','18','021','EC','A','','','AC','0000061679','0000061679','TX00000539600','IL','1','de santiago','alejandro','','','','34','450838413','610 n lee trevino',0,'el paso','TX','79907',NULL,'CY','48141','1984-04-24','M','U',':RET:2106-3','N','021','DEN','270580','33348TX002000201','2014-01-01','2013-11-30 13:05:06','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:15:06'),(8030,6357,'Y','18','024','14','A','','','TE','0000546901','0000546901','','IL','1','Pittman','Verkista',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-06-19','F','',NULL,NULL,NULL,'','1691977','','2013-12-20','2013-12-20 14:24:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 03:09:07'),(21474,17160,'N','19','021','EC','A',NULL,NULL,'','0000168920','0000243774','','IL','1','ON','HOPE','','','','34','664457809','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','2011-08-01','F','',NULL,'N','021','DEN','3006962','99734OH005000301','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:01:40'),(24226,19239,'Y','18','021','EC','A','','','AC','0001142221','0001142221','OH00002650971','IL','1','Mahaseth','Pramod','','','','34','730264366','2106 FARLEIGH RD',0,'UPPER ARLINGTON','OH','43221','2702','CY','39049','1963-06-27','M','M',':RET:2028-9','N','021','DEN','3082253','99734OH005000401','2014-03-01','2014-02-15 22:51:58','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-16 19:00:31'),(28945,22906,'Y','18','021','EC','A','','','AC','0002269565','0002269565','LA00002740907','IL','1','Reinauer','Michael','','','','34','437233607','407 6th st',0,'Lake Charles','LA','70601',NULL,'CY','22019','1963-11-16','M','U',':RET:2106-3','N','021','DEN','3855088','18575LA002000201','2014-04-01','2014-03-09 20:54:28','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-10 21:00:46'),(716,591,'N','01','021','EC','A',NULL,NULL,'','0000323481','0000200744','','IL','1','Smith','Larry','','','Jr','34','290840332','109 E HIGH ST',0,'ATTICA','OH','44807','9331','CY','39147','1986-05-29','M','',':RET:2106-3','N','021','HLT','1565626','92036OH005002706','2014-01-01','2013-12-16 14:44:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.35',NULL,0,'2013-12-25 18:03:19'),(2831,2287,'Y','18','021','EC','A','','','AC','0001012286','0001012286','LA00000408579','IL','1','broussard','celeste','','','','34','350540219','1230 toledano st.',0,'new orleans','LA','70115',NULL,'CY','22071','1966-07-04','F','U',':RET:2106-3','N','021','DEN','654817','18575LA002000201','2014-01-01','2013-11-24 14:30:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:00:45'),(8979,7122,'Y','18','021','EC','A','','','AC','0000634797','0000634797','OH00000736993','IL','1','Hughes','Kathy','','','','34','276687610','525 Daytona Pkwy',0,'Dayton','OH','45406',NULL,'CY','39113','1960-07-27','F','U',':RET:2054-5','T','021','DEN','1889654','99734OH005000401','2014-01-01','2013-12-18 15:42:12','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:04:16'),(14524,11588,'N','01','021','EC','A',NULL,NULL,'','0000677422','0000485338','','IL','1','Farishta','Nazia','','','','34','333964573','7422 LAKE TRAVIS DR',0,'CORPUS CHRISTI','TX','78413','5812','CY','48355','1980-11-25','F','',':RET:2029-7','N','021','DEN','2156603','33348TX002000201','2014-02-01','2013-12-27 17:12:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:34:22'),(13806,11019,'N','01','021','EC','A',NULL,NULL,'','0000060260','0001033652','','IL','1','swem','carol','','','','34','283504440','1507 SOUTHWOOD DR',0,'LIMA','OH','45805','3748','CY','39003','1951-05-01','F','',NULL,'N','021','HLT','1406515','92036OH006001501','2014-01-01','2013-12-22 19:00:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','501.46',NULL,0,'2013-12-26 13:11:29'),(9358,7418,'Y','18','021','EC','A','','','AC','0002138089','0002138089','LA00000651976','IL','1','Wilson','Peter','','','','34','439333068','3553 MAGNOLIA AVE',0,'ZACHARY','LA','70791','4458','CY','22033','1963-12-29','M','U',':RET:2054-5','T','021','DEN','2045445','18575LA002000201','2014-01-01','2013-12-21 07:12:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:27'),(6104,4839,'Y','18','021','EC','A','','','AC','0000105334','0000105334','OH00001207314','31','1','Harteis','Carole','','','','34','299543505','P.O. Box 856',0,'Holland','OH','43528',NULL,'CY','39095','1954-02-08','F','M',':RET:2106-3','N','021','DEN','1012436','99734OH005000401','2014-01-01','2013-11-21 08:48:01','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:15:17'),(7764,6149,'N','19','021','EC','A',NULL,NULL,'','0000045757','0000532096','','IL','1','Seung','Minoh',NULL,NULL,NULL,NULL,NULL,'1914 N NANTUCKET DR',0,'LORAIN','OH','44053','3224','CY','39093','1994-08-22','M','',':RET:2040-4','T','021','DEN','2402355','99734OH005000401','2014-01-01','2013-12-20 18:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:49'),(17042,13636,'N','01','021','EC','A',NULL,NULL,'','0001074165','0000009861','','IL','1','Mize','Randall','','','','34','272583134','2999 Carmody Blvd.',0,'Middletown','OH','45042',NULL,'CY','39017','1954-11-04','M','',':RET:2106-3','T','021','HLT','1540283','92036OH004001201','2014-02-01','2014-01-08 19:22:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','516.72',NULL,0,'2014-01-13 02:20:52'),(16902,13524,'N','01','021','EC','A',NULL,NULL,'','0001033674','0001182520','','IL','1','Charek','Kylie','','','','34','299904331','3112 HEARTHSTONE RD',0,'PARMA','OH','44134','2638','CY','39035','1985-08-04','F','',':RET:2106-3','N','021','DEN','1513543','99734OH005000401','2014-02-01','2014-01-09 12:32:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:19:33'),(16199,12969,'Y','18','024','14','A','','','TE','0000773078','0000773078','','IL','1','Gutierrez','Gerardo',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-04-06','M','',NULL,NULL,NULL,'','1450745','','2014-01-04','2014-01-04 12:50:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-05 00:01:05'),(20255,16164,'Y','18','021','EC','A','','','AC','0000171264','0000171264','OH00002346886','IL','1','Clement','Michel','','','','34','270643673','10826 GRANTWOOD AVE',0,'CLEVELAND','OH','44108','3625','CY','39035','1959-03-25','M','U',NULL,'N','021','DEN','2884746','99734OH005000301','2014-03-01','2014-01-27 19:34:21','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-28 21:00:16'),(20630,16485,'Y','18','021','EC','A','','','AC','0001027003','0001027003','TX00002072413','IL','1','SMITH','MARIA','HELENA','','','34','634609751','3010 AGGIE ST',0,'PECOS','TX','79772',NULL,'CY','48389','1967-08-10','F','M',NULL,'N','021','DEN','3086203','33348TX002000201','2014-03-01','2014-01-29 22:01:41','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:28'),(21353,17066,'Y','18','021','EC','A','','','AC','0000249429','0000249429','TX00001994104','IL','1','Glodt','Lisa','','','','34','463932218','4405 n nevarro',0,'Victoria','TX','77904',NULL,'CY','48469','1971-12-31','F','U',NULL,'N','021','DEN','3397392','33348TX002000201','2014-03-01','2014-02-04 12:22:27','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-04 21:00:38'),(7576,5995,'Y','18','021','EC','A','','','AC','0000598733','0000598733','OH00000379838','IL','1','kitzmiller','jayne','','','','34','290625333','308 S WAYNE ST',0,'SAINT MARYS','OH','45885','2227','CY','39011','1960-11-29','F','U',':RET:2106-3','N','021','HLT','531351','92036OH002001501','2014-01-01','2013-12-15 10:58:02','362.00',NULL,NULL,'518.49','156.49','R-OH002','OH0','518.49',NULL,0,'2013-12-26 02:33:52'),(2666,2165,'Y','18','021','EC','A','','','AC','0000352801','0000352801','OH00000414106','IL','1','Scharrer','Neal','Mark','','','34','371483586','7159 TRILLIUM DR',0,'LEWIS CENTER','OH','43035','9670','CY','39041','1957-08-13','M','M',':RET:2106-3','N','021','DEN','370130','99734OH005000301','2014-01-01','2013-12-02 17:56:05','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:46:57'),(16995,13604,'Y','18','021','EC','A','','','AC','0000878277','0000878277','OH00001469086','IL','1','Hess','Anita','','','','34','272769248','17 W INTERSTATE ST',0,'BEDFORD','OH','44146','4248','CY','39035','1963-07-23','F','U',':RET:2106-3','N','021','DEN','1874384','99734OH005000301','2014-02-01','2014-01-08 22:59:34','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:20:27'),(16254,13013,'Y','18','021','EC','A','','','AC','0000433904','0000433904','OH00002144563','IL','1','Rossi','Henry','','','','34','186447562','1760 AINSLEY LN',0,'HAMILTON','OH','45013','5135','CY','39017','1953-10-26','M','R',':RET:2106-3','N','021','HLT','2059903','92036OH004001201','2014-02-01','2014-01-04 09:38:51','0.00',NULL,NULL,'468.46','468.46','R-OH004','OH0','468.46',NULL,0,'2014-01-05 00:02:41'),(5395,4282,'Y','18','024','14','A','','','TE','0000702923','0000702923','','IL','1','davis','patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-09-04','F','',NULL,NULL,NULL,'','1220021','','2013-12-19','2013-12-19 17:29:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 23:08:47'),(4764,3779,'Y','18','021','EC','A','','','AC','0000063688','0000063688','OH00000593760','IL','1','Adams','Teresa','','','','34','297746110','601 W MILL ST',0,'NORTH LEWISBURG','OH','43060','9530','CY','39021','1963-08-20','F','M',':RET:2106-3','N','021','DEN','412464','99734OH005000401','2014-01-01','2013-12-07 22:53:40','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:15:39'),(4277,3407,'Y','18','021','EC','A','','','AC','0000234040','0000234040','OH00000023975','IL','1','FIFE','BILL','','','','34','290804787','8601 STATE ROUTE 124',0,'HILLSBORO','OH','45133','7178','CY','39071','1967-09-14','M','U',':RET:2106-3','N','021','HLT','1840233','92036OH001000601','2014-01-01','2013-12-17 14:25:18','124.00',NULL,NULL,'388.40','264.40','R-OH005','OH0','388.40',NULL,0,'2013-12-25 21:51:54'),(4675,3706,'Y','18','021','EC','A','','','AC','0000951120','0000951120','LA00000019903','IL','1','Montealegre','Melissa','','','','34','438278246','921 BELLEVUE PLANTATION RD',0,'LAFAYETTE','LA','70503','6122','CY','22055','1961-10-28','F','U',NULL,'N','021','DEN','776773','18575LA002000201','2014-01-01','2013-12-12 14:41:53','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 22:07:43'),(16756,13405,'Y','18','021','EC','A','','','AC','0000825924','0000825924','OH00000137253','IL','1','Powers','Lauren','','','','34','274503859','2125 BISHOPSGATE DR',0,'TOLEDO','OH','43614','2005','CY','39095','1956-03-25','F','M',':RET:2106-3','T','021','HLT','2207344','92036OH005002601','2014-02-01','2014-01-06 21:24:28','287.00',NULL,NULL,'546.49','259.49','R-OH001','OH0','546.49',NULL,0,'2014-01-08 18:24:57'),(17022,13622,'Y','18','021','EC','A','','','AC','0000114212','0000114212','OH00001608271','IL','1','Middlecoop','Christine','','','','34','270501379','1255 BAILEY RD',0,'CUYAHOGA FALLS','OH','44221','5331','CY','39153','1966-06-02','F','U',':RET:2106-3','T','021','HLT','1492842','52664OH152000901','2014-02-01','2014-01-09 15:05:32','68.00',NULL,NULL,'293.60','225.60','R-OH012','OH0','293.60',NULL,0,'2014-01-13 02:20:41'),(18389,14677,'N','01','021','EC','A',NULL,NULL,'','0001031474','0000086444','','IL','1','KNOTTS','JOHN','L','','','34','233883649','2439 LADD ST',0,'AKRON','OH','44312',NULL,'CY','39153','1953-11-12','M','',':RET:2106-3','N','021','DEN','1458553','99734OH005000301','2014-02-01','2014-01-15 15:38:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:39'),(19004,15134,'N','01','021','EC','A',NULL,NULL,'','0001640013','0001624870','','IL','1','Leary','Terry','Lynn','','','34','434379044','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1971-01-12','F','',':RET:2054-5','N','021','DEN','1639262','18575LA002000201','2014-03-01','2014-01-17 11:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-20 08:06:17'),(19070,15192,'Y','18','021','EC','A','','','AC','0000022820','0000022820','OH00002206901','IL','1','Dale','Kayleigh','R','','','34','412950560','505 N CLINTON ST',0,'DEFIANCE','OH','43512','1606','CY','39039','2003-04-22','F','R',':RET:2106-3','N','021','HLT','2169858','92036OH004002601','2014-03-01','2014-01-18 16:07:10','0.00',NULL,NULL,'99.57','99.57','R-OH001','OH0','99.57',NULL,0,'2014-01-21 08:44:20'),(23556,18767,'Y','18','021','EC','A','','','AC','0000472295','0000472295','OH00002665317','IL','1','MURREY','MARIE','','','','34','281788793','9667 COUNTY ROAD U',0,'LIBERTY CENTER','OH','43532','9744','CY','39069','1966-01-26','F','U',NULL,'N','021','HLT','2872845','92036OH005002605','2014-03-01','2014-02-13 09:42:32','224.00',NULL,NULL,'318.82','94.82','R-OH001','OH0','318.82',NULL,0,'2014-02-13 22:02:42'),(24244,19250,'N','01','021','EC','A',NULL,NULL,'','0000177678','0000565590','','IL','1','Sexton','Barbara','','','','34','283800004','935 Hathaway Dr.',0,'Trenton','OH','45067',NULL,'CY','39017','1972-08-11','F','',NULL,'N','021','HLT','2768781','92036OH004001201','2014-03-01','2014-02-15 22:14:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.74',NULL,0,'2014-02-16 19:00:40'),(25596,20307,'Y','18','024','14','A','','','TE','0000950641','0000950641','','IL','1','Robinson','Iann',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-03-28','M','',NULL,NULL,NULL,'','532094','','2014-03-31','2014-02-24 12:29:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-26 08:00:46'),(25968,20594,'Y','18','021','EC','A','','','AC','0001166861','0001166861','OH00001823527','IL','1','Amos','Tawnya','','','','34','272609343','50885 State Route 7',0,'New Matamoras','OH','45767',NULL,'CY','39167','1960-02-19','F','M',':RET:2106-3','N','021','DEN','2968312','99734OH005000401','2014-03-01','2014-02-26 12:59:10','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-02-26 21:01:45'),(28467,22526,'Y','18','021','EC','A','','','AC','0001048061','0001048061','OH00003660125','IL','1','Reams','Alana','','','','34','298903997','392 GARRISON RD',0,'ASHTABULA','OH','44004','9067','CY','39007','1986-06-17','F','U',':RET:2106-3','N','021','DEN','3321270','99734OH005000301','2014-04-01','2014-03-06 21:20:41','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:31:29'),(500,409,'Y','18','021','EC','A','','','AC','0000571965','0000571965','OH00000183147','IL','1','Keeney','Elizabeth','','','','34','035325466','107 Meadow Lane',0,'GAMBIER','OH','43022',NULL,'CY','39083','1954-01-20','F','U',':RET:2106-3','N','021','DEN','1121097','99734OH005000301','2014-01-01','2013-12-04 06:53:10','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:48:40'),(5659,4489,'Y','18','021','EC','A','','','AC','0000841887','0000841887','OH00000306666','IL','1','Hepler','Marilyn','','','','34','279545061','839 OAKRIDGE ST SW',0,'NORTH CANTON','OH','44720','3410','CY','39151','1953-02-18','F','M',':RET:2106-3','N','021','HLT','39621','52664OH152000901','2014-01-01','2013-11-26 16:56:44','229.00',NULL,NULL,'443.31','214.31','R-OH015','OH0','443.31',NULL,0,'2013-12-25 23:31:42'),(14268,11382,'Y','18','024','14','A','','','TE','0001131417','0001131417','','IL','1','paparodis','theo',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-05','M','',NULL,NULL,NULL,'','113807','','2013-12-26','2013-12-26 14:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:06:00'),(13147,10487,'Y','18','024','14','A','','','TE','0000317325','0000317325','','IL','1','Niedzialkowski','Carole',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-02-27','F','',NULL,NULL,NULL,'','204914','','2013-12-23','2013-12-23 16:29:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:53:30'),(3351,2685,'Y','18','021','EC','A','','','AC','0000356362','0000356362','TX00000475634','IL','1','reyes','socorro','','','','34','456558598','1313 PALM BLVD',0,'LAGUNA VISTA','TX','78578','2781','CY','48061','1958-06-27','F','M',NULL,'N','021','DEN','1632150','33348TX002000201','2014-01-01','2013-12-22 08:08:29','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 21:16:44'),(7353,5823,'Y','18','021','EC','A','','','AC','0000813056','0000813056','TX00000979493','IL','1','Boehme','Christopher','Alan','','','34','463770985','106 KERRI CT',0,'LONGVIEW','TX','75605','2029','CY','48183','1976-02-21','M','U',':RET:2106-3','N','021','DEN','677966','33348TX002000201','2014-01-01','2013-11-22 18:51:55','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-26 02:15:10'),(20578,16445,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000305871','','IL','1','Alshinnawi','Yasmeen','S','','','34','279117062','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','2005-04-26','F','',':RET:2106-3','N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(21775,17389,'Y','18','021','EC','A','','','AC','0000505767','0000505767','OH00001718235','S3','1','Vogel','Jennifer','','','','34','299088630','4090 FIELDSEDGE DR',0,'MASON','OH','45040','8537','CY','39165','2004-06-05','M','U',':RET:2106-3','N','021','DEN','3093301','99734OH005000401','2014-03-01','2014-02-06 15:49:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-06 21:00:34'),(22153,17683,'Y','18','021','EC','A','','','AC','0000902243','0000902243','OH00002375078','IL','1','SEAGIN','DEBRA','A','','','34','282562724','1094 KILLINGER RD',0,'CLINTON','OH','44216','9656','CY','39153','1956-06-14','F','M',':RET:2106-3','N','021','HLT','3274199','52664OH151001305','2014-03-01','2014-02-08 15:44:13','275.00',NULL,NULL,'543.47','268.47','R-OH012','OH0','543.47',NULL,0,'2014-02-08 19:00:55'),(23357,18612,'N','19','021','EC','A',NULL,NULL,'','0001062169','0000552669','','IL','1','gonzales','lutien','','','','34','012259573','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','2013-07-25','M','',NULL,'N','021','HLT','3713513','52664OH151001304','2014-03-01','2014-02-13 14:50:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-13 22:00:44'),(23408,18650,'Y','18','021','EC','A','','','AC','0000414740','0000414740','OH00002679457','IL','1','Hanna','Joseph','','','','34','299902059','4421 DENISE DR',0,'ASHTABULA','OH','44004','4617','CY','39007','1986-02-05','M','U',':RET:2106-3','N','021','DEN','2898393','99734OH005000401','2014-03-01','2014-02-12 18:31:18','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:01:14'),(23972,19059,'Y','18','021','EC','A','','','AC','0001617731','0001617731','LA00001875930','IL','1','MAIDEN','BRENDA','','','','34','436884631','12897 HIGHWAY 789',0,'KEITHVILLE','LA','71047','8716','CY','22017','1952-08-13','F','U',':RET:2054-5','N','021','DEN','2688643','18575LA002000201','2014-03-01','2014-02-14 21:13:13','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-15 22:00:15'),(25361,20123,'Y','18','024','14','A','','','TE','0001128018','0001128018','','IL','1','ali','zeinab',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-01-03','F','',NULL,NULL,NULL,'','2598500','','2014-03-12','2014-02-25 07:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-25 21:30:36'),(25495,20225,'Y','18','021','EC','A','','','AC','0000949570','0000949570','OH00002221821','IL','1','Smith','Joanna','','','','34','298549765','4540 EAST RD',0,'LIMA','OH','45807','1517','CY','39003','1955-01-30','F','U',NULL,'T','021','HLT','3700545','92036OH003001505','2014-04-01','2014-02-25 12:25:18','505.00',NULL,NULL,'688.01','183.01','R-OH002','OH0','688.01',NULL,0,'2014-02-25 21:31:50'),(26107,20706,'Y','18','021','EC','A','','','AC','0000482238','0000482238','OH00001864578','IL','1','nyhart','nathan','','','','34','298969737','1613 APPLE VALLEY DR',0,'HOWARD','OH','43028','9572','CY','39083','1994-04-21','M','U',':RET:2106-3','N','021','DEN','3291755','99734OH005000401','2014-03-01','2014-02-26 18:15:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-02-28 06:30:14'),(28720,22729,'Y','18','021','EC','A','','','AC','0000449938','0000449938','OH00003232135','31','1','Shafer','Sharon','','','','34','288447017','PO Box 223',0,'Urbana','OH','43078',NULL,'CY','39021','1949-06-10','F','U',':RET:2106-3','T','021','HLT','3585632','92036OH004000501','2014-04-01','2014-03-08 16:46:18','552.00',NULL,NULL,'659.41','107.41','R-OH003','OH0','659.41',NULL,0,'2014-03-08 21:31:20'),(6075,4815,'Y','18','021','EC','A','','','AC','0000595100','0000595100','OH00000673158','IL','1','Moy','Kenneth','','','','34','302521858','6300 BEACH SMITH RD',0,'KINSMAN','OH','44428','9750','CY','39155','1952-12-23','M','U',':RET:2106-3','N','021','HLT','117617','92036OH003003206','2014-01-01','2013-11-30 20:37:49','583.00',NULL,NULL,'710.32','127.32','R-OH013','OH0','710.32',NULL,0,'2013-12-26 00:02:18'),(16857,13487,'Y','18','021','EC','A','','','AC','0000048401','0000048401','TX00002398474','IL','1','Ingram','Karla','','','','34','463880028','5519 W CROSS ST',0,'ODESSA','TX','79763','8836','CY','48135','1951-01-13','F','U',':RET:2106-3','N','021','DEN','1675831','33348TX002000201','2014-02-01','2014-01-08 18:46:50','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-13 02:19:07'),(16786,13427,'Y','18','021','EC','A','','','AC','0000914442','0000914442','OH00001771915','IL','1','kovach','heidi','','','','34','288549011','94 wilpark dr',0,'akron','OH','44312',NULL,'CY','39153','1954-07-29','F','U',':RET:2106-3','N','021','HLT','1851552','52664OH151001501','2014-02-01','2014-01-07 15:03:35','303.00',NULL,NULL,'696.21','393.21','R-OH012','OH0','696.21',NULL,0,'2014-01-08 18:25:07'),(1827,1498,'Y','18','021','EC','A','','','AC','0000552632','0000552632','OH00000577935','IL','1','RAND','James','Michael','','','34','285543584','119 BROOKSIDE DR',0,'SWANTON','OH','43558','1007','CY','39051','1954-07-10','M','M',':RET:2106-3','N','021','HLT','2450228','92036OH005002604','2014-01-01','2013-12-24 18:04:07','260.00',NULL,NULL,'507.58','247.58','R-OH001','OH0','507.58',NULL,0,'2013-12-25 18:57:20'),(2121,1741,'Y','18','021','EC','A','','','AC','0000061299','0000061299','OH00000899592','IL','1','Horton','Desarae','Constance','','','34','603709720','1467 DILLEY RD NW',0,'WARREN','OH','44485','2004','CY','39155','1993-12-12','F','U',':RET:2106-3','N','021','DEN','1136512','99734OH005000401','2014-01-01','2013-12-10 13:50:24','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','15.78',NULL,0,'2013-12-25 19:17:43'),(2454,1996,'Y','18','021','EC','A','','','AC','0000401657','0000401657','TX00000502076','IL','1','Cardenas','Jose','','','','34','230439398','6314 ROYAL RDG',0,'SAN ANTONIO','TX','78239','1635','CY','48029','1987-07-05','M','U',NULL,'N','021','DEN','19002','33348TX002000101','2014-01-01','2013-12-08 22:47:27','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 19:34:43'),(14330,11430,'Y','18','021','EC','A','','','AC','0000602280','0000602280','OH00000858633','IL','1','jones','deborah','','','','34','294687306','425 heather lane',0,'medina','OH','44256',NULL,'CY','39103','1961-07-01','F','U',':RET:2106-3','N','021','HLT','2438666','52664OH151001501','2014-02-01','2013-12-26 13:01:18','339.00',NULL,NULL,'522.09','183.09','R-OH012','OH0','522.09',NULL,0,'2013-12-27 02:07:32'),(7883,6236,'Y','18','021','EC','A','','','AC','0000637097','0000637097','OH00001142410','IL','1','AGARWAL','SHUBHRA','NEIL','','','34','281046375','3136 PREAKNESS DR',0,'STOW','OH','44224','6217','CY','39153','1976-03-11','F','M',':RET:2029-7','N','021','DEN','1767706','99734OH005000301','2014-01-01','2013-12-20 18:44:55','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2013-12-26 03:05:28'),(17138,13714,'Y','18','021','EC','A','','','AC','0001066998','0001066998','OH00001817385','IL','1','Hoot','Alyssa','','','','34','268945791','128 S 5TH ST',0,'WATERVILLE','OH','43566','1303','CY','39095','1991-03-09','F','U',':RET:2106-3','N','021','HLT','2009842','92036OH006002601','2014-02-01','2014-01-07 18:22:00','127.00',NULL,NULL,'154.64','27.64','R-OH001','OH0','154.64',NULL,0,'2014-01-13 02:21:50'),(17242,13797,'N','01','021','EC','A',NULL,NULL,'','0000773992','0000850513','','IL','1','Bowling','Robert','Z','','','34','276884615','2274 STATE ROUTE 131',0,'GOSHEN','OH','45122','9430','CY','39025','1982-05-13','M','',':RET:2106-3','N','021','HLT','1542952','92036OH001000601','2014-02-01','2014-01-08 13:49:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','300.12',NULL,0,'2014-01-13 02:22:46'),(20425,16313,'N','01','021','EC','A',NULL,NULL,'','0000035783','0000381178','','IL','1','JONES','DEBORAH','','','','34','235840551','124 TOWNSHIP ROAD 1291',0,'PROCTORVILLE','OH','45669','8711','CY','39087','1952-01-10','F','',NULL,'N','021','DEN','3446411','99734OH005000301','2014-03-01','2014-01-29 11:43:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:32'),(20987,16773,'Y','18','021','EC','A','','','AC','0001203258','0001203258','OH00001775799','IL','1','BRISSETT','GWAYNE','A','','','34','279138468','1118 EGAN COURT',0,'CINCINATI','OH','45229',NULL,'CY','39061','1980-03-04','M','M',':RET:2054-5','N','021','HLT','2717926','92036OH003001201','2014-03-01','2014-02-01 15:53:07','0.00',NULL,NULL,'268.56','268.56','R-OH004','OH0','268.56',NULL,0,'2014-02-01 19:00:23'),(21061,16828,'Y','18','021','EC','A','','','AC','0002042470','0002042470','LA00001598001','IL','1','Northrop','Stephanie','','','','34','461513915','16081 DERBY AVE',0,'BATON ROUGE','LA','70816','3142','CY','22033','1963-01-14','F','M',':RET:2106-3','N','021','DEN','2741617','18575LA002000201','2014-03-01','2014-02-02 15:48:09','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-02 19:00:12'),(21157,16906,'Y','18','021','EC','A','','','AC','0000159447','0000159447','OH00002265443','IL','1','Dershimer','Mark','','','','34','291429072','6565 Highland Greens Drive',0,'West Chester','OH','45069',NULL,'CY','39017','1955-03-14','M','U',':RET:2106-3','N','021','DEN','2913719','99734OH005000401','2014-03-01','2014-02-02 23:06:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:30'),(26104,20703,'N','01','021','EC','A',NULL,NULL,'','0000203139','0001169511','','IL','1','James','Ronald','B','','Sr','34','270504070','608 STONER RD',0,'CLINTON','OH','44216','9605','CY','39153','1951-12-07','M','',':RET:2106-3','N','021','HLT','3131255','52664OH152000901','2014-03-01','2014-02-26 18:10:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','469.28',NULL,0,'2014-02-28 06:30:13'),(1117,920,'Y','18','021','EC','A','','','AC','0000741689','0000741689','OH00000594947','IL','1','NAL','VANNY','J','','','34','279803791','1710 ROSLYN AVE',0,'KETTERING','OH','45429','5034','CY','39113','1982-09-17','M','M',NULL,'T','021','DEN','919696','99734OH005000401','2014-01-01','2013-12-03 17:53:49','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:17:41'),(6556,5197,'Y','18','021','EC','A','','','AC','0000577574','0000577574','TX00000853104','IL','1','Blake','Gary','','','','34','462787546','2207 Jennifer Dr',0,'Killeen','TX','76542',NULL,'CY','48027','1951-05-09','M','U',':RET:2106-3','N','021','DEN','710702','33348TX002000201','2014-01-01','2013-12-11 12:56:44','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 00:52:17'),(2785,2251,'Y','18','021','EC','A','','','AC','0000224689','0000224689','OH00000078423','31','1','Shultz','James','','','','34','275589947','p.o. box 224',0,'ridgeville corners','OH','43555',NULL,'CY','39069','1956-08-11','M','M',':RET:2106-3','T','021','HLT','50841','92036OH004002601','2014-01-01','2013-12-02 13:35:57','785.61',NULL,NULL,'791.39','5.79','R-OH001','OH0','439.43',NULL,0,'2013-12-25 19:49:59'),(2791,2256,'Y','18','021','EC','A','','','AC','0000880576','0000880576','LA00000585467','IL','1','Harolds','Laura','Beth','','','34','442889401','610 RICHLAND AVE',0,'LAFAYETTE','LA','70508','6617','CY','22055','1985-01-31','F','U',NULL,'N','021','DEN','808097','18575LA002000101','2014-01-01','2013-12-02 12:04:52','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 19:50:07'),(14889,11891,'Y','18','021','EC','A','','','AC','0001888243','0001888243','LA00001430814','IL','1','Capers','Jasmine','','','','34','434797751','1601 McKeen Place',0,'Monroe','LA','71201',NULL,'CY','22073','1990-05-21','F','U',':RET:2054-5','N','021','DEN','2039771','18575LA002000201','2014-02-01','2013-12-28 19:57:01','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-30 00:00:43'),(3782,3030,'Y','18','021','EC','A','','','AC','0001218525','0001218525','OH00000545311','IL','1','Socciarelli','Michael','','','','34','286626344','319 W MADISON ST',0,'GIBSONBURG','OH','43431','1321','CY','39143','1957-10-08','M','M',':RET:2106-3','N','021','DEN','468172','99734OH005000301','2014-01-01','2013-12-13 00:00:14','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:34:01'),(8882,7042,'Y','18','021','EC','A','','','AC','0000826830','0000826830','TX00001154734','IL','1','Temple','Sonya','A','','','34','452731963','102 HOLT ST',0,'EUSTACE','TX','75124','9679','CY','48213','1982-12-19','F','M',':RET:2106-3','T','021','DEN','1911413','33348TX002000201','2014-01-01','2013-12-18 15:43:30','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:48'),(17170,13740,'Y','18','021','EC','A','','','AC','0000789678','0000789678','OH00001822357','IL','1','Gussler','Stephanie','Gail','','','34','276761497','339 E MAPLE ST',0,'GRANVILLE','OH','43023','1414','CY','39089','1965-02-03','F','M',':RET:2106-3','N','021','DEN','1377404','99734OH005000301','2014-02-01','2014-01-07 19:47:56','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:22:08'),(21646,17286,'Y','18','021','EC','A','','','AC','0000356066','0000356066','OH00001639396','IL','1','khosa','sukhjinder','','','','34','568775981','4001 SHARON PARK LN',0,'CINCINNATI','OH','45241','4001','CY','39061','1963-03-27','M','M',':RET:2029-7','N','021','HLT','3417618','92036OH006001201','2014-03-01','2014-02-04 19:25:57','433.00',NULL,NULL,'535.07','102.07','R-OH004','OH0','304.05',NULL,0,'2014-02-05 21:30:48'),(24206,19224,'Y','18','021','EC','A','','','AC','0001408600','0001408600','LA00001938504','IL','1','HAGGERTY','DARNELL','','','','34','436115233','200 DAVID ST',0,'NEW ORLEANS','LA','70119','5131','CY','22071','1962-07-13','F','U',':RET:2106-3','N','021','DEN','2642828','18575LA002000201','2014-03-01','2014-02-15 21:54:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-16 19:00:20'),(22303,17805,'N','19','021','EC','A',NULL,NULL,'','0000639555','0000639554','','S3','1','Chamberlain','David',NULL,NULL,NULL,NULL,NULL,'6104 DONNA JAY DR',0,'LOVELAND','OH','45140','8739','CY','39025','2011-08-12','F','',NULL,'N','021','DEN','2982394','99734OH005000301','2014-03-01','2014-01-25 13:36:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 11:00:38'),(9240,7329,'N','19','021','EC','A',NULL,NULL,'','0000685832','0000909467','','IL','1','Okes','Robert','Owen','','','34','298888759','11 phillip court',0,'elyria','OH','44035',NULL,'CY','39093','1988-06-01','M','',':RET:2106-3','N','021','HLT','2256482','92036OH004000801','2014-01-01','2013-12-18 15:51:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','188.75',NULL,0,'2013-12-26 04:10:38'),(20456,16340,'Y','18','021','EC','A','','','AC','0000851867','0000851867','OH00002455164','IL','1','NABIL','HABIBA','','','','34','577412064','5486 MALIBU DR',0,'COLUMBUS','OH','43213','6609','CY','39049','1985-12-18','F','U',':RET:2054-5','N','021','DEN','3121850','99734OH005000401','2014-03-01','2014-01-29 08:01:02','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:48'),(7971,6309,'Y','18','021','EC','A','','','AC','0000383002','0000383002','MS00001206722','IL','1','SCALES','Mary','Ann','','','34','587088046','500 cypress',0,'greenville','MS','38701',NULL,'CY','28151','1958-12-12','F','U',':RET:2054-5','N','021','DEN','1549965','46300MS002000201','2014-01-01','2013-12-20 16:28:03','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 03:07:40'),(1886,1542,'Y','18','021','EC','A','','','AC','0001155105','0001155105','OH00001397069','IL','1','HARRISON','THOMAS','','','','34','294805273','3723 WASHINGTON PARK BLVD',0,'NEWBURGH HEIGHTS','OH','44105','3133','CY','39035','1981-04-06','M','U',':RET:2106-3','N','021','HLT','2096315','92036OH003000805','2014-01-01','2013-12-24 11:32:22','165.00',NULL,NULL,'288.84','123.84','R-OH011','OH0','288.84',NULL,0,'2013-12-25 18:58:41'),(6603,5236,'Y','18','021','EC','A','','','AC','0000378543','0000378543','OH00000554001','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','HLT','1228685','92036OH003000505','2014-01-01','2013-12-11 09:01:25','368.00',NULL,NULL,'506.41','138.41','R-OH003','OH0','506.41',NULL,0,'2013-12-26 00:53:35'),(18181,14516,'Y','18','021','EC','A','','','AC','0000218846','0000218846','OH00001358561','IL','1','moore','toni','','','','34','286466185','2751 LAKEWOOD AVE',0,'LIMA','OH','45805','3009','CY','39003','1950-01-03','F','M',':RET:2106-3','N','021','HLT','2701070','92036OH005001501','2014-02-01','2014-01-14 10:55:17','333.00',NULL,NULL,'660.24','327.24','R-OH002','OH0','660.24',NULL,0,'2014-01-15 02:08:01'),(17416,13938,'N','01','021','EC','A',NULL,NULL,'','0001203227','0000960614','','IL','1','HUNDLEY','SUSAN','JO','','','34','262398804','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-07-07','F','',NULL,'N','021','HLT','1817030','92036OH005001204','2014-02-01','2014-01-10 10:08:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.72',NULL,0,'2014-01-13 03:00:24'),(15211,12157,'Y','18','024','14','A','','','TE','0000432769','0000432769','','IL','1','Quinter','Alicia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-15','F','',NULL,NULL,NULL,'','2295173','','2013-12-29','2013-12-29 22:38:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:07:42'),(15348,12277,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1571307','','2014-01-01','2014-01-01 14:50:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:24:27'),(15886,12720,'Y','18','021','EC','A','','','AC','0002056796','0002056796','LA00002022314','IL','1','HALL','CARLITHA','LAMONICA','','','34','435730661','540 ADELE ST',0,'NEW ORLEANS','LA','70130','4832','CY','22071','1986-04-22','F','U',':RET:2054-5','T','021','DEN','2295291','18575LA002000101','2014-02-01','2014-01-02 17:15:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-03 02:05:33'),(27014,21397,'Y','18','021','EC','A','','','AC','0000203118','0000203118','TX00003505653','IL','1','Alsobrooks','Jennifer','Faye','','','34','463690955','4955 FM 945 RD S',0,'CLEVELAND','TX','77328','7774','CY','48407','1984-07-07','F','U',':RET:2106-3','T','021','DEN','3642661','33348TX002000101','2014-04-01','2014-03-03 11:59:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15','CIC',0,'2014-03-03 21:00:09'),(951,784,'Y','18','021','EC','A','','','AC','0000115452','0000115452','OH00000009262','IL','1','Rini','Jennifer','Ann','','','34','296805161','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','1982-02-18','F','M',':RET:2106-3','N','021','DEN','735562','99734OH005000301','2014-01-01','2013-10-31 11:26:19','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:09:34'),(21914,17501,'Y','18','024','14','A','','','TE','0001488416','0001488416','','IL','1','McCullough','Leland',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-02','M','',NULL,NULL,NULL,'','2530930','','2014-02-28','2014-02-06 18:04:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-06 21:30:04'),(21751,17370,'Y','18','021','EC','A','','','AC','0000563063','0000563063','TX00002104012','IL','1','pradichith','khamtanh','','','','34','464835106','4618 LAWLER RD',0,'GARLAND','TX','75042','4500','CY','48113','1980-04-10','M','M',':RET:2028-9','N','021','DEN','2660797','33348TX002000201','2014-03-01','2014-02-05 21:17:48','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:21'),(21527,17199,'Y','18','021','EC','A','','','AC','0001086099','0001086099','TX00002088404','IL','1','Hutto','Cassandra','','','','34','457599693','895 COUNTY ROAD 3322',0,'JACKSONVILLE','TX','75766','6709','CY','48073','1982-12-27','F','M',NULL,'N','021','DEN','2646148','33348TX002000101','2014-03-01','2014-02-04 21:45:45','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-02-05 21:30:05'),(21280,17007,'Y','18','021','EC','A','','','AC','0000268933','0000268933','OH00002079318','IL','1','Bostelman','Roger','','','','34','291487125','14265 HARRISON RD',0,'GRAND RAPIDS','OH','43522','9669','CY','39095','1952-10-29','M','M',':RET:2106-3','T','021','HLT','2857489','92036OH003002604','2014-03-01','2014-02-03 18:06:40','747.00',NULL,NULL,'1154.33','407.33','R-OH001','OH0','658.06',NULL,0,'2014-02-03 21:01:37'),(13142,10482,'Y','18','021','EC','A','','','AC','0000300410','0000300410','OH00001111358','IL','1','Ibeh','Bernard','','','','34','101862800','3208 Grand Avenue',0,'Middletown','OH','45044',NULL,'CY','39017','1960-08-23','M','U',':RET:2054-5','N','021','DEN','1732619','99734OH005000401','2014-01-01','2013-12-23 15:57:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:53:20'),(9646,7643,'Y','18','021','EC','A','','','AC','0000097448','0000097448','TX00000802877','IL','1','WOLF','MARVEMA','','','','34','513683130','3517 PALM AVE',0,'TEXAS CITY','TX','77590','4310','CY','48167','1965-04-26','F','U',':RET:2054-5','N','021','DEN','2060453','33348TX002000101','2014-01-01','2013-12-21 18:13:20','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 04:38:37'),(19441,15496,'Y','18','021','EC','A','','','AC','0000726156','0000726156','OH00002433961','IL','1','May','Roy','','','','34','281728001','545 Shaffer Street',0,'Van Wert','OH','45891',NULL,'CY','39161','1963-07-02','M','U',':RET:2106-3','N','021','HLT','3130458','92036OH004001501','2014-03-01','2014-01-21 16:17:44','313.75',NULL,NULL,'316.06','2.31','R-OH002','OH0','316.06',NULL,1,'2014-01-22 03:23:12'),(1447,1207,'Y','18','024','14','A','','','TE','0000481028','0000481028','','IL','1','Moore','Erica','Jane',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-08','F','',NULL,NULL,NULL,'','440801','','2013-12-24','2013-12-24 04:31:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:01'),(17106,13690,'Y','18','021','EC','A','','','AC','0000520974','0000520974','OH00002149790','IL','1','bennington','tammy','','','','34','302669060','45 owens road',0,'west union','OH','45693',NULL,'CY','39001','1959-09-05','F','M',':RET:2106-3','N','021','HLT','2304774','92036OH004000601','2014-02-01','2014-01-08 18:14:46','313.00',NULL,NULL,'368.53','55.53','R-OH005','OH0','368.53',NULL,0,'2014-01-13 02:21:34'),(5750,4565,'Y','18','021','EC','A','','','AC','0001943566','0001943566','LA00001498600','IL','1','Sterling','David','','','','34','438594053','3022 N MEADOW LARK DR',0,'LAKE CHARLES','LA','70607','0942','CY','22019','1976-08-14','M','U',':RET:2054-5','N','021','DEN','2472831','18575LA002000201','2014-01-01','2013-12-24 01:47:09','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 23:46:11'),(16269,13026,'Y','18','021','EC','A','','','AC','0000489261','0000489261','OH00002278756','IL','1','boots','brent','','','','34','270864470','6333 TOWNSHIP ROAD 178',0,'WEST LIBERTY','OH','43357','9578','CY','39091','1973-08-30','M','M',':RET:2106-3','N','021','DEN','2172071','99734OH005000401','2014-02-01','2014-01-05 19:20:33','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-07 04:00:14'),(6338,5022,'N','01','021','EC','A',NULL,NULL,'','0001088245','0000672731','','IL','1','Jordan','Matthew','','','','34','028629162','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','1982-06-01','M','',NULL,'N','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:42'),(15642,12513,'Y','18','021','EC','A','','','AC','0000296507','0000296507','MS00002041918','IL','1','Lee','Cynthia','','','','34','587235352','3414 E LISA DR',0,'PEARL','MS','39208','5430','CY','28121','1960-07-01','F','M',':RET:2106-3','T','021','DEN','2024988','46300MS002000201','2014-02-01','2013-12-31 09:48:11','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,1,'2014-01-02 04:33:51'),(14991,11981,'N','01','021','EC','A',NULL,NULL,'','0000669670','0000940362','','IL','1','Jones','Tyrell','','','','34','627145342','108 W. McGee',0,'Sherman','TX','75092',NULL,'CY','48181','1984-09-22','M','',':RET:2106-3','N','021','DEN','2252916','33348TX002000201','2014-02-01','2013-12-30 16:12:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:01:25'),(27073,21436,'Y','18','021','EC','A','','','AC','0000319722','0000319722','OH00002550971','IL','1','Hanna','John','A','','','34','292623903','9281 HUBBARD VALLEY RD',0,'SEVILLE','OH','44273','9350','CY','39103','1957-12-21','M','U',':RET:2106-3','N','021','HLT','2924195','52664OH152000901','2014-04-01','2014-03-02 18:36:06','381.07',NULL,NULL,'381.07','0.00','R-OH012','OH0','381.07',NULL,0,'2014-03-03 21:30:07'),(28922,22890,'N','19','021','EC','A',NULL,NULL,'','0000739088','0000406192','','S3','1','BERNARD','JEFFERY','','','','34','280137164','970 SANDY LN',0,'MEDINA','OH','44256','2026','CY','39103','2007-05-16','M','',NULL,'N','021','DEN','3492816','99734OH005000301','2014-04-01','2014-03-10 10:42:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:31'),(4534,3593,'Y','18','021','EC','A','','','AC','0000533778','0000533778','TX00000175528','IL','1','Pettis','Brenda','','','','34','452470682','1674 FM 975',0,'CALDWELL','TX','77836','8317','CY','48051','1963-04-01','F','M',':RET:2106-3','N','021','DEN','1142910','33348TX002000201','2014-01-01','2013-12-12 16:48:39','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 22:04:08'),(25044,19861,'Y','18','021','EC','A','','','AC','0000298282','0000298282','OH00002481109','IL','1','Stewart','Dylan','','','','34','296965838','453 south powell',0,'columbus','OH','43204',NULL,'CY','39049','1994-03-14','M','R',':RET:2106-3','N','021','DEN','2748353','99734OH005000401','2014-04-01','2014-02-19 19:50:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-02-20 22:01:12'),(5429,4311,'Y','18','024','14','A','','','TE','0000489329','0000489329','','IL','1','Emerson','Lydell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-02-23','M','',NULL,NULL,NULL,'','2452566','','2013-12-18','2013-12-18 22:23:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 23:09:36'),(13359,10669,'N','01','021','EC','A',NULL,NULL,'','0001209584','0000699271','','IL','1','JUNG','KOOKHEE','','','','34','294113037','6231 CROOKED CREEK DR',0,'MASON','OH','45040','2443','CY','39165','1977-04-04','F','',NULL,'N','021','DEN','2322802','99734OH005000301','2014-01-01','2013-12-22 19:48:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:24'),(23716,18883,'Y','18','021','EC','A','','','AC','0001257376','0001257376','OH00001691876','IL','1','Troxell','Austin','','','','34','132440126','6001 SPRINGBORO PIKE',0,'DAYTON','OH','45449','3251','CY','39113','1956-01-06','M','M',':RET:2106-3','N','021','DEN','3749092','99734OH005000401','2014-03-01','2014-02-14 16:51:36','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:30:49'),(21516,17191,'Y','18','021','EC','A','','','AC','0001210808','0001210808','TX00002357533','IL','1','Robinson','Dominique','','','','34','456794604','3200 Ross Ave Unit 24',0,'Dallas','TX','75204',NULL,'CY','48113','1978-02-22','F','U',':RET:2054-5','N','021','DEN','2829283','33348TX002000201','2014-03-01','2014-02-05 12:55:33','0.00',NULL,NULL,'56.37','56.37','R-TX008','TX0','15.85','CIC',0,'2014-02-05 21:00:04'),(21367,17077,'Y','18','021','EC','A','','','AC','0000324261','0000324261','TX00002458859','IL','1','griffith','melissa','','','','34','449844226','510 MAYBROOK DR',0,'BUDA','TX','78610','9420','CY','48209','1955-09-12','F','U',':RET:2106-3','N','021','DEN','3063109','33348TX002000201','2014-03-01','2014-02-04 16:26:48','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-04 21:00:46'),(21333,17048,'Y','18','021','EC','A','','','AC','0000359423','0000359423','TX00001917477','IL','1','Pena','Raquel','','','','34','456968104','1916 MERCER ST',0,'LAREDO','TX','78043','4519','CY','48479','1956-01-03','F','M',NULL,'N','021','DEN','3105100','33348TX002000201','2014-03-01','2014-02-03 19:41:14','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-04 21:00:29'),(18480,14742,'N','19','021','EC','A',NULL,NULL,'','0000793489','0000895732','','IL','1','Ziss','Jordan','Elizabeth','','','34','288061854','4076 KINGSBURY BLVD',0,'COPLEY','OH','44321','2841','CY','39153','2001-09-29','F','',NULL,'N','021','HLT','2557525','52664OH151001301','2014-02-01','2014-01-14 21:44:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-16 08:46:21'),(17435,13949,'Y','18','021','EC','A','','','AC','0001207173','0001207173','OH00002361804','IL','1','Babcock','Raymond','','','','34','011489376','414 HILLCREST DR',0,'CINCINNATI','OH','45215','2502','CY','39061','1955-07-05','M','M',NULL,'N','021','HLT','1457250','92036OH006001201','2014-02-01','2014-01-10 12:20:42','706.00',NULL,NULL,'895.82','189.82','R-OH004','OH0','433.78',NULL,0,'2014-01-13 03:00:33'),(17054,13647,'Y','18','021','EC','A','','','AC','0000100079','0000100079','OH00002047418','IL','1','Fout','Stephen','','','','34','283863666','267 N SOUTH ST',0,'WILMINGTON','OH','45177','1660','CY','39027','1979-01-20','M','U',':RET:2106-3','N','021','HLT','2095575','92036OH001000601','2014-02-01','2014-01-09 11:29:08','98.00',NULL,NULL,'316.41','218.41','R-OH005','OH0','316.41',NULL,0,'2014-01-13 02:21:00'),(6110,4844,'Y','18','021','EC','A','','','AC','0000761073','0000761073','OH00000815067','IL','1','Stivaletti','Anthony','','','','34','006668312','60 E. Spring St.',0,'Columbus','OH','43215',NULL,'CY','39049','1967-04-20','M','U',':RET:2106-3','N','021','DEN','63757','99734OH005000401','2014-01-01','2013-11-21 14:28:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:15:24'),(6306,5002,'N','01','021','EC','A',NULL,NULL,'','0001062093','0000750991','','IL','1','Castle','Shiela','','','','34','293545518','5720 COUNTY ROAD 23',0,'CARDINGTON','OH','43315','9336','CY','39117','1954-07-22','F','',':RET:2106-3','T','021','DEN','931360','99734OH005000401','2014-01-01','2013-12-11 10:17:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:03'),(9119,7235,'Y','18','021','EC','A','','','AC','0000538256','0000538256','OH00001254379','IL','1','BLANDFORD','HELEN','','','','34','297580585','4510 LOGAN AVE NORTHWEST',0,'CANTON','OH','44709',NULL,'CY','39151','1956-01-26','F','U',':RET:2106-3','N','021','DEN','2359401','99734OH005000301','2014-01-01','2013-12-18 18:00:21','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 04:07:44'),(14368,11459,'Y','18','021','EC','A','','','AC','0001068274','0001068274','OH00001485083','IL','1','Eichman','Tina','','','','34','586544173','314 HILLCREST DR',0,'SPRINGBORO','OH','45066','8455','CY','39165','1955-10-04','F','U',':RET:2047-9','N','021','DEN','1414199','99734OH005000401','2014-02-01','2013-12-27 09:45:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:28'),(7751,6139,'Y','18','021','EC','A','','','AC','0000299235','0000299235','OH00001281873','IL','1','ransom','jack','','','','34','279525553','264 n. washington st. p.o. 722',0,'utica','OH','43080',NULL,'CY','39089','1952-06-23','M','M',':RET:2106-3','N','021','DEN','2185684','99734OH005000401','2014-01-01','2013-12-20 16:24:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:02:30'),(26110,20708,'N','19','021','EC','A',NULL,NULL,'','0000950727','0000869340','','S1','1','Tran','lee','','','','34','276118378','4540 HIDDEN RIDGE CT',0,'COLUMBUS','OH','43230','4124','CY','39049','2004-11-20','M','',':RET:2047-9','N','021','DEN','3623342','99734OH005000401','2014-04-01','2014-02-26 19:03:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:16'),(27739,21936,'Y','18','021','EC','A','','','AC','0000174119','0000174119','TX00003186365','IL','1','Ponce','Armandina','','','','34','456990814','3312 E RICHARDSON RD',0,'EDINBURG','TX','78542','7640','CY','48215','1982-10-16','F','M',NULL,'N','021','DEN','3716919','33348TX002000201','2014-04-01','2014-03-05 17:41:51','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-05 21:31:08'),(713,589,'N','01','021','EC','A',NULL,NULL,'','0001233038','0000553898','','IL','1','perkins','walt','d','','','34','288768210','69 W WASHBURN ST',0,'NEW LONDON','OH','44851','1048','CY','39077','1973-03-31','M','',':RET:2106-3','N','021','HLT','2175371','92036OH005002705','2014-01-01','2013-12-16 10:32:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.21',NULL,0,'2013-12-25 18:03:15'),(1662,1388,'Y','18','021','EC','A','','','AC','0001090597','0001090597','TX00000893005','IL','1','Taylor','idena','','','','34','442904458','1521 South Bryant',0,'San Angelo','TX','76903',NULL,'CY','48451','1983-06-26','F','U',':RET:2054-5^:RET:2106-3','T','021','DEN','2155351','33348TX002000201','2014-01-01','2013-12-24 17:16:32','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 18:53:39'),(6425,5094,'Y','18','021','EC','A','','','AC','0000233933','0000233933','LA00000981094','IL','1','Pineda','Victor','','','','34','437951981','2100 MINNESOTA AVE',0,'KENNER','LA','70062','6038','CY','22051','1978-03-10','M','M',':RET:2106-3','N','021','DEN','962275','18575LA002000201','2014-01-01','2013-12-11 09:51:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:49:00'),(4224,3362,'Y','18','021','EC','A','','','AC','0000440553','0000440553','TX00000280259','IL','1','MOSBAUGH','ERIN','','','','34','254575613','3524 marigold',0,'COLLEGE STATION','TX','77845',NULL,'CY','48041','1987-02-23','F','U',':RET:2106-3','N','021','DEN','1467200','33348TX002000201','2014-01-01','2013-12-17 11:00:37','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 21:50:30'),(22023,17583,'N','19','021','EC','A',NULL,NULL,'','0000667817','0000271466','','IL','1','Hubbell','Elisabeth','','','','34','284942843','491 N SPRING ST',0,'WILMINGTON','OH','45177','1630','CY','39027','1991-07-25','F','',':RET:2106-3','N','021','HLT','3098229','92036OH003000606','2014-03-01','2014-02-07 08:06:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2014-02-07 19:00:59'),(20530,16404,'Y','18','021','EC','A','','','AC','0000065807','0000065807','MS00002217360','IL','1','Fisher','Trevor','','','','34','428656745','485 MOCKINGBIRD LN',0,'MADISON','MS','39110','9577','CY','28089','1988-01-10','M','U',':RET:2106-3','N','021','DEN','1885372','46300MS002000201','2014-03-01','2014-01-29 10:17:40','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-29 21:01:30'),(20216,16130,'Y','18','024','14','A','','','TE','0000943411','0000943411','','IL','1','Grant','Jason','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-31','M','',NULL,NULL,NULL,'','2074677','','2014-01-27','2014-01-27 13:17:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:41'),(4660,3695,'Y','18','021','EC','A','','','AC','0000180761','0000180761','LA00000648637','IL','1','JACOB','LEVI','','','','34','439907117','152 DORSEY LN',0,'MARKSVILLE','LA','71351','4974','CY','22009','1951-09-17','M','U',':RET:2054-5','N','021','DEN','806053','18575LA002000201','2014-01-01','2013-12-12 11:02:32','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 22:07:22'),(17870,14276,'Y','18','021','EC','A','','','AC','0001063267','0001063267','OH00002277822','31','1','GEANS','RACHELLE','','','','34','297880154','292 Riddle Rd',0,'CINCINNATI','OH','45215',NULL,'CY','39061','1973-01-05','F','U',NULL,'T','021','DEN','1796355','99734OH005000401','2014-02-01','2014-01-14 13:23:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:13'),(26528,21036,'N','01','021','EC','A',NULL,NULL,'','0000476002','0001096791','','IL','1','Stevens','Lisa','J','','','34','299620727','276 State Route 196',0,'New Hampshire','OH','45870',NULL,'CY','39011','1960-10-15','F','',':RET:2106-3','N','021','HLT','3425745','92036OH003001505','2014-03-01','2014-02-28 14:55:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.87','CIC',0,'2014-02-28 21:00:26'),(27081,21440,'Y','18','021','EC','A','','','AC','0000561735','0000561735','OH00002806555','IL','1','Hang','Ia','','','','34','580189652','1261 ADA ST',0,'AKRON','OH','44306','2664','CY','39153','1950-07-25','F','M',':RET:2028-9','N','021','HLT','3136432','52664OH152000901','2014-04-01','2014-03-03 16:40:32','482.18',NULL,NULL,'482.18','0.00','R-OH012','OH0','482.18',NULL,0,'2014-03-03 21:30:10'),(27977,22134,'Y','18','021','EC','A','','','AC','0001818148','0001818148','LA00003670699','IL','1','HUGHES','THEODORE','TAYLOR','','','34','237711400','6501 MEMPHIS ST',0,'NEW ORLEANS','LA','70124','3235','CY','22071','1991-03-28','M','R',':RET:2106-3','N','021','DEN','4154165','18575LA002000201','2014-04-01','2014-03-06 13:28:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:54'),(29066,23004,'N','19','021','EC','A',NULL,NULL,'','0000552689','0001092189','','S1','1','Kerr','Michelle','','','','34','286023718','4134 N LOCKWOOD AVE',0,'TOLEDO','OH','43612','1745','CY','39095','1997-10-07','F','',NULL,'N','021','HLT','3276340','92036OH004002601','2014-04-01','2014-03-10 12:08:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-10 21:01:55'),(6528,5176,'N','19','021','EC','A',NULL,NULL,'','0000222380','0000680819','','IL','1','Heffner','Harlow',NULL,NULL,NULL,NULL,NULL,'732 ELM AVE',0,'TERRACE PARK','OH','45174','1262','CY','39061','2013-11-27','F','',':RET:2106-3','N','021','HLT','1196017','92036OH002001201','2014-01-01','2013-12-11 15:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2013-12-26 00:51:36'),(20842,16659,'Y','18','024','14','A','','','TE','0000868231','0000868231','','IL','1','Hill','Micheal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-02-03','M','',NULL,NULL,NULL,'','1601811','','2014-01-31','2014-01-31 16:15:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:00:47'),(20748,16578,'Y','18','021','EC','A','','','AC','0000943453','0000943453','OH00002563339','IL','1','Lucke','Juanita','','','','34','377564949','6560 Kingsbridge Dr.',0,'Sylvania','OH','43560',NULL,'CY','39095','1951-04-12','F','U',':RET:2106-3','N','021','HLT','2638746','92036OH005002601','2014-03-01','2014-01-30 09:48:57','326.00',NULL,NULL,'560.22','234.22','R-OH001','OH0','560.22',NULL,0,'2014-01-30 21:01:28'),(20698,16538,'Y','18','024','14','A','','','TE','0001068287','0001068287','','IL','1','Klunk','Janis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-05-20','F','',NULL,NULL,NULL,'','2385548','','2014-01-30','2014-01-30 17:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:02'),(20504,16382,'Y','18','021','EC','A','','','AC','0002014015','0002014015','LA00001454409','IL','1','Arshad','Nadeem','S','','','34','435838164','3604 LAKE ONTARIO DR',0,'HARVEY','LA','70058','5516','CY','22051','1985-05-17','M','M',NULL,'N','021','DEN','2638728','18575LA002000201','2014-03-01','2014-01-29 14:41:26','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:15'),(4321,3432,'Y','18','021','EC','A','','','AC','0000932094','0000932094','OH00000424437','IL','1','Teague','W','','','','34','523725895','669 E MAIN ST',0,'WILLIAMSBURG','OH','45176','1440','CY','39025','1950-10-06','F','M',':RET:2106-3','N','021','HLT','1740612','92036OH004000601','2014-01-01','2013-12-17 16:55:21','104.00',NULL,NULL,'509.54','405.54','R-OH005','OH0','509.54',NULL,0,'2013-12-25 21:52:45'),(16475,13184,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00000055901','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','1494060','52664OH151001306','2014-02-01','2014-01-06 05:19:07','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2014-01-07 04:06:05'),(17127,13706,'N','01','021','EC','A',NULL,NULL,'','0000414710','0000610881','','IL','1','manning','maria','l','','','34','290609219','554 iroquois trail',0,'willoughby','OH','44094',NULL,'CY','39085','1977-05-10','F','',':RET:2106-3','N','021','DEN','1661027','99734OH005000401','2014-02-01','2014-01-08 11:10:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:45'),(25151,19951,'N','01','021','EC','A',NULL,NULL,'','0000863234','0000606813','','IL','1','bechner','Saundra','','','','34','567089659','1631 fm 3251',0,'Hallsville','TX','75650',NULL,'CY','48203','1968-09-16','F','',':RET:2106-3','T','021','DEN','3514031','33348TX002000201','2014-04-01','2014-02-21 13:18:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-21 22:00:16'),(28353,22433,'Y','18','021','EC','A','','','AC','0001196927','0001196927','TX00003661265','IL','1','Bennett','Racquel','','','','34','130666920','3562 MOJAVE DR',0,'DALLAS','TX','75241','6464','CY','48113','1983-03-11','F','U',':RET:2054-5','N','021','DEN','4261162','33348TX002000201','2014-04-01','2014-03-07 13:06:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:24'),(28935,22898,'Y','18','021','EC','A','','','AC','0000823581','0000823581','OH00003284100','IL','1','WILLINGHAM','Jonathan','','','','34','273848166','6929 KENWOOD RD',0,'CINCINNATI','OH','45243','2327','CY','39061','1985-07-26','M','U',':RET:2036-2^:RET:2106-3','N','021','DEN','3237791','99734OH005000301','2014-04-01','2014-03-10 14:47:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:00:39'),(3383,2712,'Y','18','021','EC','A','','','AC','0000917393','0000917393','TX00000325857','IL','1','Goolsby','Kendra','','','','34','633100353','109 PRESTON ST',0,'BRAZORIA','TX','77422','8898','CY','48039','1987-05-28','F','U',':RET:2106-3','N','021','DEN','2471345','33348TX002000201','2014-01-01','2013-12-22 18:18:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:17:34'),(24028,19110,'Y','18','021','EC','A','','','AC','0000897033','0000897033','OH00002947574','IL','1','Harrison','Deborah','','','','34','295528942','3142 S BYRNE RD',0,'TOLEDO','OH','43614','5326','CY','39095','1950-07-21','F','U',':RET:2106-3','N','021','HLT','2810755','92036OH004002601','2014-03-01','2014-02-15 11:29:19','432.00',NULL,NULL,'462.84','30.84','R-OH001','OH0','462.84',NULL,0,'2014-02-15 22:00:51'),(23687,18863,'Y','18','024','14','A','','','TE','0000964659','0000964659','','IL','1','SCOTT','RAYMONE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-22','M','',NULL,NULL,NULL,'','2977624','','2014-02-13','2014-02-13 19:16:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:30:35'),(23488,18710,'Y','18','024','14','A','','','TE','0000956667','0000956667','','IL','1','Frazier','Danny',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-12-08','M','',NULL,NULL,NULL,'','1838418','','2014-02-27','2014-02-12 19:40:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-13 22:02:00'),(18935,15088,'Y','18','021','EC','A','','','AC','0000905618','0000905618','OH00001788540','IL','1','McKenzie','Kyle','','','','34','364668496','58 COLUMBIA AVE',0,'ATHENS','OH','45701','1649','CY','39009','1956-07-07','F','U',':RET:2106-3','T','021','DEN','2601006','99734OH005000401','2014-03-01','2014-01-17 16:15:17','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-01-20 08:05:41'),(16224,12993,'Y','18','021','EC','A','','','AC','0000955558','0000955558','OH00002147030','IL','1','Quinichett','Robert','','','','34','280805338','712 RACINE AVE',0,'COLUMBUS','OH','43204','2962','CY','39049','1983-04-20','M','R',':RET:2054-5','N','021','DEN','2561928','99734OH005000401','2014-02-01','2014-01-04 09:52:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-05 00:01:52'),(14545,11605,'Y','18','021','EC','A','','','AC','0000584442','0000584442','MS00001008659','IL','1','derouen','tammy','','','','34','426575120','410 E GEORGETOWN ST',0,'CRYSTAL SPRINGS','MS','39059','2533','CY','28029','1974-12-20','F','M',':RET:2106-3','N','021','DEN','2322100','46300MS002000201','2014-02-01','2013-12-27 14:40:15','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:51'),(4343,3449,'N','01','021','EC','A',NULL,NULL,'','0000268872','0001019238','','IL','1','Caprilla','Misty','Ann','','','34','279880966','5350 W BREESE RD',0,'LIMA','OH','45806','9458','CY','39003','1980-08-09','F','',':RET:2106-3','N','021','HLT','2429394','92036OH006001501','2014-01-01','2013-12-17 11:36:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','209.09',NULL,0,'2013-12-25 21:53:19'),(6701,5312,'N','01','021','EC','A',NULL,NULL,'','0000220105','0000544492','','IL','1','Hess','Alton','','','','34','556534412','3305 N General Wainwright dr',0,'lake charles','LA','70615',NULL,'CY','22019','1961-10-19','M','',':RET:2054-5','N','021','DEN','929732','18575LA002000201','2014-01-01','2013-11-04 19:18:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:01:55'),(4633,3671,'Y','18','024','14','A','','','TE','0000784935','0000784935','','IL','1','Ingram','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-25','F','',NULL,NULL,NULL,'','6641','','2013-12-12','2013-12-12 15:47:09',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 22:06:35'),(28977,22934,'Y','18','021','EC','A','','','AC','0000067721','0000067721','OH00003679341','IL','1','Smatana','Johnny','','','','34','595461432','9438 BRANDYWINE RD',0,'SAGAMORE HILLS','OH','44067','2487','CY','39153','1985-11-02','M','U',NULL,'N','021','HLT','4007644','52664OH151001305','2014-04-01','2014-03-09 18:42:48','126.00',NULL,NULL,'242.41','116.41','R-OH012','OH0','242.41',NULL,0,'2014-03-10 21:01:06'),(13412,10700,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000181005','','IL','1','Mecklenborg','Jack','Lawrence',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2009-09-26','M','',NULL,'N','021','DEN','1618729','99734OH005000301','2014-01-01','2013-12-23 10:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:34'),(13054,10406,'N','19','021','EC','A',NULL,NULL,'','0001075301','0000308266','','IL','1','Danner','Sarah','Grace','','','34','291020906','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1997-07-29','F','',':RET:2106-3','N','021','DEN','2350448','99734OH005000401','2014-01-01','2013-12-23 09:06:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:55'),(9511,7543,'Y','18','021','EC','A','','','AC','0001095646','0001095646','OH00000081819','IL','1','CALLAND','KENT','','','','34','275683225','3884 MOUNTVIEW RD',0,'COLUMBUS','OH','43220','4804','CY','39049','1960-09-21','M','U',':RET:2106-3','N','021','DEN','2206790','99734OH005000401','2014-01-01','2013-12-21 16:42:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:35:24'),(9501,7536,'Y','18','024','14','A','','','TE','0000714967','0000714967','','IL','1','MAZAR','LAURA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-08','F','',NULL,NULL,NULL,'','2312935','','2013-12-21','2013-12-21 15:13:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:35:11'),(23444,18675,'N','01','021','EC','A',NULL,NULL,'','0000552096','0000645543','','IL','1','Greenfield','Lena','','','','34','415430447','1220 Middle Cove Dr',0,'Plano','TX','75023',NULL,'CY','48085','1980-10-21','F','',NULL,'N','021','DEN','2625245','33348TX002000201','2014-03-01','2014-02-13 12:15:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:34'),(21703,17331,'Y','18','024','14','A','','','TE','0000374650','0000374650','','IL','1','Kimburbrough','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-07-18','F','',NULL,NULL,NULL,'','3132756','','2014-02-05','2014-02-05 13:15:21',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-05 21:31:12'),(7528,5958,'N','01','021','EC','A',NULL,NULL,'','0000516678','0000925072','','IL','1','Hoffman','Jessica','Leann','','','34','642368113','4800 Brookdale Dr.',0,'Wichita Falls','TX','76310',NULL,'CY','48485','1988-01-02','F','',':RET:2106-3','N','021','DEN','1130877','33348TX002000201','2014-01-01','2013-12-14 20:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:32:36'),(20744,16574,'Y','18','021','EC','A','','','AC','0000049541','0000049541','OH00001948185','IL','1','Cluckey','Thomas','Scott','','','34','283726886','4047 STARR AVE',0,'OREGON','OH','43616','2441','CY','39095','1964-04-22','M','R',':RET:2106-3','N','021','HLT','3293648','92036OH006002601','2014-03-01','2014-01-30 09:32:39','0.00',NULL,NULL,'263.83','263.83','R-OH001','OH0','263.83',NULL,0,'2014-01-30 21:01:25'),(5938,4702,'Y','18','021','EC','A','','','AC','0001903431','0001903431','LA00000486356','IL','1','Washington','Billy','','','','34','439679345','1069 Elysian Dr.',0,'baton Rouge','LA','70810',NULL,'CY','22033','1986-10-08','M','U',':RET:2054-5','N','021','DEN','1531794','18575LA002000101','2014-01-01','2013-12-23 23:05:58','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:50:43'),(18320,14627,'Y','18','021','EC','A','','','AC','0000060285','0000060285','OH00001935070','IL','1','MCCUE','MICHELLE','MARIE','','','34','299606635','1050 N CARPENTER RD',0,'BRUNSWICK','OH','44212','2236','CY','39103','1974-09-23','F','M',NULL,'N','021','DEN','2041286','99734OH005000401','2014-02-01','2014-01-15 09:47:00','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:07'),(5837,4636,'Y','18','021','EC','A','','','AC','0000398417','0000398417','TX00000548247','IL','1','AHMED','JAMEEL','','','','34','138962949','503 S AVENUE F',0,'CLIFTON','TX','76634','2201','CY','48035','1960-03-30','M','M',':RET:2029-7','N','021','DEN','1974399','33348TX002000201','2014-01-01','2013-12-23 23:29:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:48:27'),(14615,11665,'Y','18','021','EC','A','','','AC','0001028611','0001028611','MS00001833829','IL','1','BASSETTE','CHRISTIANA','','','','34','425755604','170 OWNES DR',0,'BENTONIA','MS','39040',NULL,'CY','28163','1992-11-27','F','U',':RET:2054-5','N','021','DEN','2001621','46300MS002000101','2014-02-01','2013-12-27 15:04:46','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-28 03:36:46'),(25409,20159,'Y','18','021','EC','A','','','AC','0000181061','0000181061','OH00003076312','IL','1','STRINE','JUDY','','','','34','284529896','1027 SALEM RD',0,'CALEDONIA','OH','43314','9454','CY','39101','1951-06-26','F','M',':RET:2106-3','N','021','DEN','2837171','99734OH005000401','2014-04-01','2014-02-25 00:04:49','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2014-02-25 21:31:02'),(26851,21282,'Y','18','021','EC','A','','','AC','0001102520','0001102520','MS00002509176','IL','1','MARTIN','SHIRLEY','','','','34','428210631','908 BUCK EGGER RD',0,'CALEDONIA','MS','39740','8627','CY','28087','1957-11-08','F','U',NULL,'N','021','DEN','2687534','46300MS002000101','2014-04-01','2014-03-01 12:45:28','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-01 21:00:50'),(537,438,'Y','18','021','EC','A','','','AC','0000664301','0000664301','MS00000272527','IL','1','TAYLOR','JOSEPH','','','','34','587381460','1312 ABBIE DR',0,'BRANDON','MS','39047','9557','CY','28121','1950-04-29','M','M',NULL,'N','021','DEN','699487','46300MS002000101','2014-01-01','2013-12-04 08:12:16','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 17:49:36'),(7628,6037,'Y','18','021','EC','A','','','AC','0000595095','0000595095','OH00000683001','IL','1','Stern','Lawrence','','','','34','346644630','1925 E SPRING VALLEY PAINTERSVILLE RD',0,'XENIA','OH','45385','9743','CY','39057','1962-01-01','M','U',':RET:2106-3','N','021','HLT','147801','92036OH006000501','2014-01-01','2013-11-17 13:49:50','0.00',NULL,NULL,'367.98','367.98','R-OH003','OH0','367.98',NULL,0,'2013-12-26 02:46:07'),(1344,1113,'Y','18','021','EC','A','','','AC','0000914822','0000914822','TX00000436213','IL','1','Cano','Jackie','','','','34','451331765','293b Mooring Circle',0,'Lakeway','TX','78734',NULL,'CY','48453','1975-06-10','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','2281787','33348TX002000101','2014-01-01','2013-12-24 03:00:26','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:03'),(17993,14379,'N','01','021','EC','A',NULL,NULL,'','0000372625','0000947425','','IL','1','ANDREWS','RICHARD','','','','34','284683515','2336 24TH ST',0,'CUYAHOGA FALLS','OH','44223','1510','CY','39153','1962-01-22','M','',':RET:2106-3','N','021','DEN','2380344','99734OH005000301','2014-02-01','2014-01-13 19:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:58'),(6553,5195,'Y','18','021','EC','A','','','AC','0000614880','0000614880','TX00000573069','31','1','THOMPSON','VICTOR','','','','34','255964700','PO BOX 385',0,'SAVOY','TX','75479',NULL,'CY','48147','1954-11-11','M','U',':RET:2054-5','N','021','DEN','476794','33348TX002000201','2014-01-01','2013-12-11 12:44:47','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:13'),(17561,14041,'Y','18','021','EC','A','','','AC','0002348410','0002348410','LA00002144741','IL','1','MCLEOD','TIFFANY','','','','34','437838729','1183 PINE ST',0,'SLIDELL','LA','70460','2448','CY','22103','1992-01-10','F','U',NULL,'N','021','DEN','2607468','18575LA002000101','2014-02-01','2014-01-12 15:56:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-13 03:02:01'),(16764,13410,'Y','18','021','EC','A','','','AC','0000862452','0000862452','OH00001953782','IL','1','Giannini','Mary','','','','34','028465341','1932 COVENTRY DR',0,'BRUNSWICK','OH','44212','4174','CY','39103','1954-04-03','F','M',':RET:2106-3','N','021','HLT','2282192','52664OH152000901','2014-02-01','2014-01-07 15:43:45','281.00',NULL,NULL,'425.18','144.18','R-OH012','OH0','425.18',NULL,0,'2014-01-08 18:24:59'),(5780,4592,'Y','18','021','EC','A','','','AC','0000232656','0000232656','OH00001429452','IL','1','HUGHES','ORLANDO','','','','34','287927663','122 GLENRIDGE PL',0,'CINCINNATI','OH','45217','2125','CY','39061','1990-10-28','M','U',':RET:2054-5','T','021','DEN','1765580','99734OH005000401','2014-01-01','2013-12-23 23:16:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:47:01'),(13998,11152,'Y','18','021','EC','A','','','AC','0000894619','0000894619','OH00000951629','IL','1','williams','richard','','','','34','274567581','1687 REBECCA DR',0,'LIMA','OH','45805','1666','CY','39003','1953-04-11','M','M',':RET:2106-3','N','021','HLT','1767857','92036OH002001501','2014-01-01','2013-12-23 11:07:37','751.00',NULL,NULL,'1208.27','457.27','R-OH002','OH0','689.78',NULL,0,'2013-12-26 13:15:58'),(13904,11089,'Y','18','021','EC','A','','','AC','0000956643','0000956643','OH00000930005','IL','1','Winterfield','Valerie','','','','34','286881630','14941 WOODSIDE DR',0,'GRAYTOWN','OH','43432','7701','CY','39123','1981-08-07','F','U',':RET:2106-3','N','021','HLT','1992487','92036OH005002705','2014-01-01','2013-12-22 21:47:43','142.00',NULL,NULL,'230.68','88.68','R-OH006','OH0','230.68',NULL,0,'2013-12-26 13:13:47'),(2194,1806,'Y','18','021','EC','A','','','AC','0000659881','0000659881','OH00000273785','IL','1','Brown','Bonnie','','','','34','278643030','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1957-04-20','F','M',':RET:2106-3','N','021','HLT','1255472','92036OH005002605','2014-01-01','2013-12-10 09:46:42','724.00',NULL,NULL,'930.13','206.13','R-OH001','OH0','454.92',NULL,0,'2013-12-25 19:19:51'),(4138,3301,'N','01','021','EC','A',NULL,NULL,'','0000926253','0000919377','','IL','1','Smith','Pamela','','','','34','269521219','6370 MAPLETON ST SE',0,'EAST CANTON','OH','44730','9566','CY','39151','1950-01-09','F','',':RET:2106-3','N','021','DEN','2575770','99734OH005000301','2014-01-01','2013-12-17 11:18:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:31'),(3711,2969,'Y','18','021','EC','A','','','AC','0000179875','0000179875','OH00000466788','IL','1','creatura','christopher','','','','34','287668695','8 east lakeview drive',0,'cincinnati','OH','45237',NULL,'CY','39061','1965-09-16','M','U',':RET:2106-3','T','021','DEN','278291','99734OH005000401','2014-01-01','2013-12-13 14:33:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:32:11'),(25142,19945,'Y','18','021','EC','A','','','AC','0000433317','0000433317','TX00003005936','IL','1','Lopez','John','','','','34','456255651','135 Single Oak Crossing',0,'Cedar Creek','TX','78612',NULL,'CY','48021','1961-10-06','M','U',NULL,'N','021','DEN','3325714','33348TX002000201','2014-04-01','2014-02-20 20:11:08','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-21 22:00:11'),(26825,21260,'Y','18','021','EC','A','','','AC','0000532167','0000532167','OH00003052716','IL','1','maritim','Emily','c','','','34','732249845','4187 Appian way W',0,'Gahanna','OH','43230',NULL,'CY','39049','1984-12-26','F','U',':RET:2054-5','N','021','DEN','2877322','99734OH005000401','2014-04-01','2014-03-01 12:38:17','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:36'),(28672,22689,'Y','18','021','EC','A','','','AC','0000909531','0000909531','OH00003442036','IL','1','Collins','Sheryl','','','','34','314763972','518 Perry Street',0,'Hicksville','OH','43526',NULL,'CY','39039','1972-03-16','F','M',':RET:2106-3','N','021','HLT','4222628','92036OH006002601','2014-04-01','2014-03-07 18:35:43','0.00',NULL,NULL,'303.11','303.11','R-OH001','OH0','204.91',NULL,0,'2014-03-08 21:30:50'),(22865,18240,'Y','18','021','EC','A','','','AC','0000211731','0000211731','MS00001695837','IL','1','Sessums','Karole','','','','34','587034906','1211 QUINN ST',0,'JACKSON','MS','39202','2162','CY','28049','1960-02-02','F','U',':RET:2106-3','N','021','DEN','3354907','46300MS002000201','2014-03-01','2014-02-11 12:31:00','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-11 21:02:27'),(22699,18125,'Y','18','021','EC','A','','','AC','0000532001','0000532001','TX00002076825','IL','1','JONES','MARY','','','','34','467333293','19594 FM 205',0,'BLUFF DALE','TX','76433','4542','CY','48143','1960-01-06','F','U',NULL,'N','021','DEN','3148000','33348TX002000101','2014-03-01','2014-02-11 09:27:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-11 21:00:57'),(7451,5899,'Y','18','021','EC','A','','','AC','0000896969','0000896969','OH00000855573','IL','1','KOPPEL','MICHAEL','','','','34','286705187','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','1969-08-19','M','M',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:30:43'),(20861,16673,'Y','18','021','EC','A','','','AC','0000728749','0000728749','OH00001723281','IL','1','Vyas','Darshan','','','','34','566791396','5830 TRIPLETT SQ',0,'NEW ALBANY','OH','43054','8080','CY','39049','1980-12-15','M','M',':RET:2029-7','N','021','DEN','2759609','99734OH005000301','2014-03-01','2014-01-31 15:19:53','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-01-31 21:00:57'),(3776,3024,'Y','18','021','EC','A','','','AC','0000036973','0000036973','OH00001028642','IL','1','JESSEE','VIRGINIA','A','','','34','293504784','1356 WILHELMINIA DR.',0,'VANDALIA','OH','45377',NULL,'CY','39113','1950-09-16','F','M',':RET:2106-3','N','021','DEN','818217','99734OH005000301','2014-01-01','2013-12-13 17:40:20','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:33:51'),(15278,12214,'Y','18','021','EC','A','','','AC','0000806363','0000806363','OH00001253647','S1','1','Johnson','Mark','D','','','34','270025301','17 PRAIRIE PL',0,'GERMANTOWN','OH','45327','1486','CY','39113','1996-09-04','F','U',NULL,'N','021','DEN','2406851','99734OH005000401','2014-02-01','2014-01-01 13:38:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,1,'2014-01-02 04:22:01'),(27112,21459,'Y','18','021','EC','A','','','AC','0000948483','0000948483','OH00003214099','IL','1','Hasenbalg','Jeremy','','','','34','300929460','483 ACREE LN',0,'COLUMBUS','OH','43228','8905','CY','39049','1985-10-06','M','U',':RET:2106-3','N','021','DEN','3391895','99734OH005000301','2014-04-01','2014-03-02 20:45:34','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:27'),(29161,23081,'N','01','021','EC','A',NULL,NULL,'','0000959165','0001214868','','IL','1','MITCHELL','SUZANNE','','','','34','272847290','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','1973-11-16','F','',NULL,'N','021','HLT','4234698','92036OH006000501','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.93',NULL,0,'2014-03-10 21:02:53'),(1308,1082,'N','01','021','EC','A',NULL,NULL,'','0000331677','0000521652','','IL','1','Allen','Nolan','Radley','','','34','621366439','244 Olivier St',0,'New Orleans','LA','70114',NULL,'CY','22071','1988-06-25','M','',':RET:2034-7^:RET:2106-3','N','021','DEN','792175','18575LA002000201','2014-01-01','2013-11-04 09:55:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:31:23'),(26569,21065,'Y','18','021','EC','A','','','AC','0000150702','0000150702','OH00002886171','IL','1','Kraus','Logan','J','','','34','296085674','3706 W Salinas Circle',0,'Dayton','OH','45440',NULL,'CY','39057','2004-04-03','M','R',':RET:2106-3','N','021','DEN','3618541','99734OH005000401','2014-04-01','2014-02-28 11:04:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-02-28 21:30:25'),(25962,20589,'N','01','021','EC','A',NULL,NULL,'','0000648379','0000071692','','IL','1','TAYLOR','DEMETRIUS','','','','34','274727129','231 S FINDLAY ST',0,'DAYTON','OH','45403','2658','CY','39113','1974-09-24','M','',NULL,'N','021','DEN','3479755','99734OH005000401','2014-04-01','2014-02-26 12:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:41'),(5878,4663,'N','19','021','EC','A',NULL,NULL,'','0000055919','0001031449','','IL','1','Sandoval','Carlos',NULL,NULL,NULL,NULL,NULL,'119 COROLINE DR',0,'SAINT CLAIRSVILLE','OH','43950','1003','CY','39013','1995-09-18','M','',NULL,'N','021','DEN','2092318','99734OH005000301','2014-01-01','2013-12-23 21:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:22'),(7314,5796,'Y','18','021','EC','A','','','AC','0000144429','0000144429','TX00000670915','IL','1','Thaw','Khin','','','','34','639805753','2777 Woodland Park Dr',0,'Houston','TX','77082',NULL,'CY','48201','1971-02-15','F','R',':RET:2028-9','N','021','DEN','886645','33348TX002000101','2014-01-01','2013-12-14 02:09:31','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:03:24'),(17295,13831,'N','01','021','EC','A',NULL,NULL,'','0000220894','0001186499','','IL','1','Lai','Cindy','','','','34','303866949','11919 CHADWELL DR',0,'HOUSTON','TX','77031','2701','CY','48201','1953-05-14','F','',':RET:2500-7','N','021','DEN','2608901','33348TX002000201','2014-02-01','2014-01-09 23:28:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:23:35'),(24294,19295,'Y','18','021','EC','A','','','AC','0000664185','0000664185','OH00002221674','IL','1','COHEN','MICHELLE','L','','','34','273761670','3306 VIENNA WOODS DR',0,'CINCINNATI','OH','45211','2902','CY','39061','1979-12-03','F','U',':RET:2054-5','N','021','HLT','3847303','92036OH004001201','2014-04-01','2014-02-18 11:21:53','98.00',NULL,NULL,'209.55','111.55','R-OH004','OH0','209.55','CIC',0,'2014-02-18 21:30:15'),(18953,15101,'Y','18','021','EC','A','','','AC','0000941761','0000941761','TX00002137438','IL','1','Hoang','Lana','','','','34','537888696','13631 SPRING POINT VW',0,'HOUSTON','TX','77083','6541','CY','48201','1973-02-12','F','M',NULL,'N','021','DEN','1665655','33348TX002000201','2014-03-01','2014-01-17 17:49:03','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-20 08:05:50'),(23462,18690,'Y','18','021','EC','A','','','AC','0000996512','0000996512','TX00002474043','IL','1','Findley','Daniel','','','','34','505626351','300 WILLS POINT ST',0,'CANTON','TX','75103','1216','CY','48467','1951-12-27','M','M',':RET:2106-3','N','021','DEN','3063354','33348TX002000201','2014-03-01','2014-02-13 14:59:35','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:43'),(23226,18516,'Y','18','024','14','A','','','TE','0001173261','0001173261','','IL','1','Nelson','Alyse',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-21','F','',NULL,NULL,NULL,'','3831505','','2014-02-12','2014-02-12 15:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:32:22'),(20002,15953,'N','19','021','EC','A',NULL,NULL,'','0000354005','0000045801','','IL','1','Pieffer','Lucy',NULL,NULL,NULL,NULL,NULL,'3881 W 227TH ST',0,'FAIRVIEW PARK','OH','44126','1031','CY','39035','2010-10-20','F','',':RET:2106-3','N','021','DEN','2594871','99734OH005000401','2014-03-01','2014-01-26 11:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:05'),(28167,22290,'Y','18','021','EC','A','','','AC','0001523180','0001523180','LA00003683016','IL','1','Fernandez','Ashley','','','','34','439492339','200 RIVERVIEW COMPLEX',0,'DONALDSONVILLE','LA','70346','2932','CY','22005','1983-02-09','F','U',':RET:2054-5','N','021','DEN','3051814','18575LA002000101','2014-04-01','2014-03-06 12:17:26','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-06 21:02:46'),(28233,22338,'Y','18','021','EC','A','','','AC','0001228125','0001228125','OH00002929119','IL','1','martin','megan','','','','34','481131815','241 loraine ave.',0,'cincinnati','OH','45220',NULL,'CY','39061','1977-01-12','F','U',':RET:2106-3','N','021','DEN','3779462','99734OH005000401','2014-04-01','2014-03-06 17:21:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-03-06 21:30:24'),(1604,1341,'N','01','021','EC','A',NULL,NULL,'','0001026853','0001025670','','IL','1','STEGMAN','LAUREN','','','','34','638146326','6619 PAULA TERRACE',0,'BURLESON','TX','76028',NULL,'CY','48251','1988-06-08','F','',NULL,'N','021','DEN','1803376','33348TX002000201','2014-01-01','2013-12-24 12:44:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:52:07'),(14242,11357,'Y','18','021','EC','A','','','AC','0001010937','0001010937','MS00001567246','IL','1','Jones','Danny','','','','34','428496751','131 Wesleyanna Street',0,'Florence','MS','39073',NULL,'CY','28121','1969-05-16','M','U',':RET:2106-3','N','021','DEN','1616547','46300MS002000101','2014-02-01','2013-12-26 16:18:56','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-27 02:05:16'),(3417,2743,'Y','18','021','EC','A','','','AC','0001702898','0001702898','LA00000715553','IL','1','Harris','Barbara','','','','34','439843321','125 Kiper St',0,'Wisner','LA','71378',NULL,'CY','22041','1950-11-25','F','U',':RET:2106-3','N','021','DEN','2284382','18575LA002000201','2014-01-01','2013-12-22 16:20:34','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 21:18:32'),(21958,17534,'Y','18','021','EC','A','','','AC','0000403697','0000403697','OH00002059998','IL','1','franklin','sierra','','','','34','376154604','1291 DIAGONAL RD',0,'AKRON','OH','44307','1357','CY','39153','1993-02-04','F','U',':RET:2054-5','N','021','DEN','3077320','99734OH005000401','2014-03-01','2014-02-07 09:50:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-07 19:00:24'),(21852,17450,'Y','18','021','EC','A','','','AC','0000880558','0000880558','OH00001961975','IL','1','WIDMANN','JOHN','','','','34','179545159','1690 TOWNSHIP RD',0,'TORONTO','OH','43964',NULL,'CY','39081','1958-04-09','M','M',NULL,'N','021','DEN','3365252','99734OH005000301','2014-03-01','2014-02-05 20:06:44','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-02-06 21:01:16'),(21466,17153,'Y','18','021','EC','A','','','AC','0000723676','0000723676','MS00001821647','IL','1','TERRY','THOMAS','','','','34','427065944','176 TEMPLE ROAD',0,'PETAL','MS','39465',NULL,'CY','28035','1956-12-11','M','U',':RET:2106-3','N','021','DEN','2849923','46300MS002000201','2014-03-01','2014-02-03 22:34:54','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-04 21:01:35'),(21050,16819,'Y','18','021','EC','A','','','AC','0000184863','0000184863','TX00002248136','IL','1','Perez','Maria','Guadalupe',NULL,NULL,NULL,NULL,'1509 COUNTY ROAD 3216',0,'PITTSBURG','TX','75686','7238','CY','48063','1978-06-15','F','M',NULL,'N','021','DEN','3229452','33348TX002000201','2014-03-01','2014-02-02 13:51:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-02 19:00:06'),(18911,15070,'Y','18','021','EC','A','','','AC','0000682176','0000682176','OH00002255417','IL','1','SWISHER','JANET','R','','','34','283502640','127 FARNSWORTH RD',0,'SAINT MARYS','OH','45885','1027','CY','39107','1950-03-02','F','U',':RET:2106-3','N','021','HLT','1651617','92036OH004001501','2014-03-01','2014-01-16 17:16:19','464.00',NULL,NULL,'522.40','58.40','R-OH002','OH0','522.40',NULL,0,'2014-01-17 03:36:40'),(6224,4934,'Y','18','021','EC','A','','','AC','0000478438','0000478438','OH00000391449','IL','1','Moore','Erica','Jane','','','34','283820184','308 West Silver Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1984-07-08','F','U',NULL,'N','021','HLT','1018266','92036OH006001501','2014-01-01','2013-10-16 20:06:54','0.00',NULL,NULL,'435.76','435.76','R-OH002','OH0','195.31',NULL,0,'2013-12-26 00:31:14'),(14891,11893,'Y','18','021','EC','A','','','AC','0001538872','0001538872','LA00001587094','IL','1','SMITH','JAMES','','','','34','437638525','2224 richmond st',0,'baker','LA','70714',NULL,'CY','22033','1985-07-31','M','U',NULL,'N','021','DEN','1574800','18575LA002000201','2014-02-01','2013-12-28 22:25:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-30 00:00:47'),(16654,13325,'Y','18','021','EC','A','','','AC','0000326371','0000326371','MS00001519061','IL','1','HERROD','BOBBY','','','','34','587552679','116 HOMER RD',0,'GRENADA','MS','38901','6846','CY','28043','1983-08-04','M','U',':RET:2054-5','N','021','DEN','2217439','46300MS002000201','2014-02-01','2014-01-07 11:50:30','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-08 18:24:21'),(16574,13257,'Y','18','021','EC','A','','','AC','0000834478','0000834478','OH00001400657','IL','1','Mensah','Linda','','','','34','454752965','372 W Cedar St',0,'Akron','OH','44307',NULL,'CY','39153','1980-07-08','F','M',':RET:2054-5','N','021','HLT','1439955','52664OH151001305','2014-02-01','2014-01-05 00:11:51','356.00',NULL,NULL,'557.52','201.52','R-OH012','OH0','267.16',NULL,1,'2014-01-07 10:23:27'),(28184,22302,'Y','18','021','EC','A','','','AC','0001028119','0001028119','OH00003379043','IL','1','Brouman','Steven','','','','34','299687283','3913 Boston Ave',0,'New Franklin','OH','44319',NULL,'CY','39153','1961-06-21','M','M',':RET:2106-3','N','021','HLT','3141407','52664OH151001501','2014-04-01','2014-03-06 14:24:53','323.00',NULL,NULL,'1020.91','697.91','R-OH012','OH0','522.09',NULL,0,'2014-03-06 21:02:56'),(28997,22949,'N','01','021','EC','A',NULL,NULL,'','0000177685','0000055985','','IL','1','Campton','Mindi','','','','34','301582182','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1971-04-03','F','',NULL,'N','021','HLT','4056302','92036OH003000601','2014-04-01','2014-03-09 18:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.05',NULL,0,'2014-03-10 21:01:16'),(7144,5668,'Y','18','021','EC','A','','','AC','0000857021','0000857021','TX00001610109','IL','1','Scott','Wayne','','','','34','069564728','4614 RAINBOW RUN',0,'SUGAR LAND','TX','77479','2039','CY','48157','1959-05-16','M','U',':RET:2054-5','N','021','DEN','2263825','33348TX002000101','2014-01-01','2013-12-24 23:27:04','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 01:51:59'),(6784,5380,'N','01','021','EC','A',NULL,NULL,'','0001229370','0000229354','','IL','1','Lesay','Isabelle','Odeppe','','','34','438295273','714 BURLESON ST',0,'SAN MARCOS','TX','78666','4335','CY','48209','1955-07-26','F','',':RET:2106-3','N','021','DEN','40727','33348TX002000201','2014-01-01','2013-11-25 17:52:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 01:16:55'),(6745,5351,'Y','18','021','EC','A','','','AC','0000860942','0000860942','OH00000507857','IL','1','GIURBINO','MICHAEL','','','','34','289509713','3590 ADAMS ROAD',0,'KINGSVILLE','OH','44048',NULL,'CY','39007','1950-08-02','M','U',NULL,'T','021','HLT','1107259','52664OH151001306','2014-01-01','2013-11-25 10:27:12','716.00',NULL,NULL,'853.86','137.86','R-OH011','OH0','853.86',NULL,0,'2013-12-26 01:15:53'),(21571,17230,'N','19','021','EC','A',NULL,NULL,'','0001104487','0001182539','','S1','1','MINOR','RANDALL','','','','34','287022182','110 RIDGE SIDE CT',0,'MUNROE FALLS','OH','44262','1086','CY','39153','1997-09-15','M','',':RET:2106-3','N','021','HLT','3530493','52664OH151001305','2014-03-01','2014-02-04 22:48:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-05 21:30:21'),(3349,2683,'Y','18','021','EC','A','','','AC','0001054749','0001054749','TX00000487446','IL','1','lambard','ronald','','','','34','463117627','2011 kenneth ave',0,'austin','TX','78741',NULL,'CY','48453','1958-08-20','M','U',NULL,'T','021','DEN','1656421','33348TX002000201','2014-01-01','2013-12-22 03:13:06','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:16:41'),(20914,16717,'N','01','021','EC','A',NULL,NULL,'','0000684846','0000237610','','IL','1','Meyer','Kristen','Marie','','','34','288860840','8800 LIMERIDGE RD',0,'RAVENNA','OH','44266','9179','CY','39133','1978-01-26','F','',':RET:2106-3','N','021','HLT','2830194','52664OH152000901','2014-03-01','2014-01-31 09:31:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','200.91',NULL,0,'2014-01-31 21:01:29'),(4506,3572,'Y','18','021','EC','A','','','AC','0000950017','0000950017','TX00001259576','IL','1','Tran','Vivian','','','','34','065681006','4536 9TH ST',0,'BACLIFF','TX','77518','2259','CY','48167','1978-10-15','F','M',':RET:2028-9','T','021','DEN','962319','33348TX002000201','2014-01-01','2013-12-11 23:12:21','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:03:30'),(5935,4699,'Y','18','021','EC','A','','','AC','0001459139','0001459139','LA00000010286','IL','1','Greely','Alexis','','','','34','439710186','407 S COX ST',0,'BASTROP','LA','71220','4710','CY','22067','1988-07-04','F','U',':RET:2054-5','N','021','DEN','1485143','18575LA002000101','2014-01-01','2013-12-23 22:15:58','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 23:50:38'),(27003,21387,'Y','18','024','14','A','','','TE','0000569275','0000569275','','IL','1','Brown','Dennis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-03','M','',NULL,NULL,NULL,'','591730','','2014-03-31','2014-03-03 08:58:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:03'),(27307,21620,'N','01','021','EC','A',NULL,NULL,'','0000428667','0000720508','','IL','1','Brooks','Quatro','','','','34','451550392','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','1971-01-29','M','',NULL,'N','021','DEN','3841046','33348TX002000201','2014-04-01','2014-03-04 13:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-04 21:00:37'),(1695,1414,'Y','18','021','EC','A','','','AC','0000478481','0000478481','OH00000198166','IL','1','Gregg','Michelle','','','','34','275865317','127 TORRINGTON DR',0,'TOLEDO','OH','43615','5401','CY','39095','1971-04-06','F','U',':RET:2106-3','N','021','HLT','2446234','92036OH004002601','2014-01-01','2013-12-24 07:24:01','0.00',NULL,NULL,'207.75','207.75','R-OH001','OH0','207.75',NULL,0,'2013-12-25 18:54:31'),(25886,20525,'Y','18','021','EC','A','','','AC','0000984961','0000984961','TX00002730500','IL','1','ROJAS MONTOYA','TOMASITA','','','','34','453474520','1302 LAS VACAS ST',0,'DEL RIO','TX','78840','5279','CY','48465','1966-06-15','F','U',':RET:2106-3','N','021','DEN','2637916','33348TX002000201','2014-04-01','2014-02-26 10:48:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:01'),(25609,20319,'Y','18','021','EC','A','','','AC','0000335397','0000335397','TX00003117495','IL','1','GROCE','JANICE','','','','34','445564667','406 GARDNER ST',0,'BORGER','TX','79007','6030','CY','48233','1954-03-24','F','M',':RET:2106-3','N','021','DEN','2681065','33348TX002000201','2014-04-01','2014-02-21 23:46:57','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 08:30:08'),(1990,1629,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','122997','','2013-11-19','2013-11-19 23:06:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:56'),(21203,16943,'Y','18','021','EC','A','','','AC','0001258182','0001258182','LA00001911438','IL','1','FEARS','COURTNEY','','','','34','608072685','1712 CASTLEWOOD DR',0,'BOSSIER CITY','LA','71111','5137','CY','22015','1980-08-03','M','U',NULL,'T','021','DEN','2657331','18575LA002000201','2014-03-01','2014-02-03 09:48:31','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-03 21:00:54'),(2915,2349,'Y','18','021','EC','A','','','AC','0001093123','0001093123','OH00000879039','IL','1','FORD','PATRICIA','','','','34','278624851','112 VERSAILLES',0,'CINCINNATI','OH','45240',NULL,'CY','39061','1963-07-30','F','U',':RET:2054-5','T','021','DEN','331754','99734OH005000401','2014-01-01','2013-12-06 11:56:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:37'),(20396,16292,'Y','18','021','EC','A','','','AC','0000033427','0000033427','TX00002152959','IL','1','GARCIA','DEMETRIO','','','','34','464917587','1999 FM 975',0,'CALDWELL','TX','77836','6345','CY','48051','1961-04-08','M','M',NULL,'N','021','DEN','2747834','33348TX002000201','2014-03-01','2014-01-29 13:03:43','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-01-29 21:00:17'),(19769,15759,'Y','18','024','14','A','','','TE','0000590249','0000590249','','IL','1','DEVEREUX','TENA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-06-01','F','',NULL,NULL,NULL,'','2902868','','2014-01-23','2014-01-23 12:35:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-23 21:01:28'),(13172,10506,'N','01','021','EC','A',NULL,NULL,'','0000655816','0000874698','','IL','1','JUSTICE','SUMMER','','','','34','297908518','192 NORTHPARK DR',0,'WADSWORTH','OH','44281','1310','CY','39103','1984-06-30','F','',NULL,'T','021','DEN','2559530','99734OH005000401','2014-01-01','2013-12-23 18:37:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:54:05'),(14731,11762,'N','19','021','EC','A',NULL,NULL,'','0001128005','0000177639','','IL','1','Jundi','Isabella','Danielle','','','34','282152924','324 ASHLAND AVE',0,'CUYAHOGA FALLS','OH','44221','2210','CY','39153','2009-07-09','F','',':RET:2106-3','N','021','HLT','2297573','52664OH151001304','2014-02-01','2013-12-28 14:13:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,1,'2013-12-29 11:09:49'),(17191,13756,'N','19','021','EC','A',NULL,NULL,'','0000482203','0000897005','','IL','1','Veit','Chloe','Marie','','','34','274984833','412 West Vine Street',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1994-12-26','F','',':RET:2106-3','N','021','HLT','1960959','92036OH003001505','2014-02-01','2014-01-07 20:37:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-01-13 02:22:19'),(24907,19747,'Y','18','024','14','A','','','TE','0000929819','0000929819','','IL','1','Kaiser','Bettyann','Virginia',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-11-26','F','',NULL,NULL,NULL,'','1060705','','2014-03-31','2014-02-19 19:15:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:05'),(28638,22664,'Y','18','021','EC','A','','','AC','0000261909','0000261909','TX00003310891','IL','1','Martinez','ELIA','','','','34','396906532','363 W LIVE OAK ST',0,'DUBLIN','TX','76446','1853','CY','48143','1983-07-26','F','U',':RET:2106-3','N','021','DEN','3390854','33348TX002000201','2014-04-01','2014-03-08 15:10:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-08 21:30:30'),(29135,23065,'N','01','021','EC','A',NULL,NULL,'','0000536992','0000376201','','IL','1','Peterson','Dawn','','','','34','288609950','6731 W LAKESHORE DR',0,'PORT CLINTON','OH','43452','9414','CY','39123','1975-11-24','F','',':RET:2106-3','N','021','HLT','3515767','92036OH003002705','2014-04-01','2014-03-10 16:08:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.74',NULL,0,'2014-03-10 21:02:39'),(4,3,'Y','18','021','EC','A','','','AC','0000353940','0000353940','OH00000365065','IL','1','Kidwell','Christine','','','','34','309801900','366 HEIDI CT',0,'MAINEVILLE','OH','45039','7317','CY','39165','1971-06-16','F','U',':RET:2106-3','N','021','DEN','759554','99734OH005000401','2014-01-01','2013-12-04 20:17:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:06'),(23377,18627,'N','01','021','EC','A',NULL,NULL,'','0000690783','0000498218','','IL','1','Vansickle','Bruce','','','','34','275683775','3000 HOGUE RD',0,'ADAMSVILLE','OH','43802','9023','CY','39119','1959-03-17','M','',':RET:2106-3','N','021','DEN','2996274','99734OH005000401','2014-03-01','2014-02-13 10:23:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:57'),(23231,18521,'Y','18','021','EC','A','','','AC','0000257166','0000257166','OH00002012653','IL','1','Rybak','Amanda','','','','34','272887189','1813 TALBOT ST',0,'TOLEDO','OH','43613','4615','CY','39095','1980-01-07','F','M',NULL,'N','021','HLT','3588279','92036OH005002605','2014-03-01','2014-02-12 10:49:12','321.00',NULL,NULL,'473.44','152.44','R-OH001','OH0','236.72',NULL,0,'2014-02-12 21:32:26'),(1591,1329,'Y','18','021','EC','A','','','AC','0000206635','0000206635','TX00000530472','IL','1','graves','eric','','','','34','237637214','225 ramsay st',0,'san marcos','TX','78666',NULL,'CY','48209','1986-09-01','M','U',':RET:2054-5','N','021','DEN','1925221','33348TX002000201','2014-01-01','2013-12-24 11:43:38','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:51:45'),(7683,6084,'Y','18','021','EC','A','','','AC','0000051912','0000051912','OH00001296107','IL','1','OSEI','GEORGE','','','','34','247279212','5695 IRONWOOD CT.',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1952-03-23','M','U',':RET:2054-5','N','021','DEN','1606652','99734OH005000401','2014-01-01','2013-12-19 19:35:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:00:51'),(21192,16936,'Y','18','021','EC','A','','','AC','0001047571','0001047571','MS00001795568','IL','1','Aanerud','Dick','','','','34','425493986','616 Hwy 90',0,'Waveland','MS','39576',NULL,'CY','28045','1982-01-14','M','U',':RET:2106-3','N','021','DEN','2998554','46300MS002000101','2014-03-01','2014-02-03 14:50:42','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-03 21:00:48'),(2068,1693,'Y','18','021','EC','A','','','AC','0000272485','0000272485','OH00000775356','IL','1','Wyatt','Amanda','','','','34','268882289','2635 BALL RD',0,'LOVELAND','OH','45140','1529','CY','39165','1983-05-19','F','U',':RET:2106-3','N','021','DEN','269320','99734OH005000301','2014-01-01','2013-12-10 17:47:53','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:16:17'),(13893,11082,'Y','18','021','EC','A','','','AC','0000753386','0000753386','OH00001300206','IL','1','Hanushek','Kurt','','','','34','291566565','2310 FULTON ST',0,'TOLEDO','OH','43620','1216','CY','39095','1956-10-01','M','U',':RET:2106-3','N','021','HLT','2421976','92036OH005002606','2014-01-01','2013-12-23 18:51:44','221.00',NULL,NULL,'475.21','254.21','R-OH001','OH0','475.21',NULL,0,'2013-12-26 13:13:31'),(19292,15378,'Y','18','021','EC','A','','','AC','0001759236','0001759236','LA00002284047','IL','1','Dunn','Melodie','','','','34','439047168','5465 BEECHWOOD DR',0,'BATON ROUGE','LA','70805','3020','CY','22033','1957-02-05','F','U',NULL,'N','021','DEN','1887927','18575LA002000201','2014-03-01','2014-01-21 14:00:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:56'),(18569,14808,'N','01','021','EC','A',NULL,NULL,'','0000246473','0001234137','','IL','1','Purcell','Debora','','','','34','286721755','1297 HOMESITE DR',0,'STOW','OH','44224','1252','CY','39153','1960-08-05','F','',NULL,'N','021','HLT','2884526','52664OH152000901','2014-02-01','2014-01-15 12:41:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','333.21',NULL,0,'2014-01-16 08:47:03'),(18474,14738,'Y','18','021','EC','A','','','AC','0000524512','0000524512','OH00001566704','IL','1','Schaefer','Kenneth','','','','34','270623633','46 SELDEN AVE',0,'AKRON','OH','44301','2849','CY','39153','1955-01-13','M','M',NULL,'N','021','HLT','2496245','52664OH151001304','2014-02-01','2014-01-14 20:39:45','876.00',NULL,NULL,'1160.98','284.98','R-OH012','OH0','580.49',NULL,0,'2014-01-16 08:46:18'),(16461,13171,'N','19','021','EC','A',NULL,NULL,'','0000816438','0000460590','','IL','1','CAMPOLONGO','NICALA','','','','34','290946149','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1992-01-16','F','',NULL,'N','021','HLT','2257217','92036OH004000601','2014-02-01','2014-01-06 10:24:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-01-07 04:05:42'),(17835,14248,'Y','18','021','EC','A','','','AC','0000255979','0000255979','OH00002089088','IL','1','Terrell','John','','','','34','574668561','5551 JOYCE ANN DR',0,'DAYTON','OH','45415','2948','CY','39113','1979-08-22','M','M',NULL,'N','021','DEN','1864945','99734OH005000401','2014-02-01','2014-01-13 18:59:12','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:01'),(25386,20141,'Y','18','024','14','A','','','TE','0001195546','0001195546','','IL','1','Beers','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-01-21','F','',NULL,NULL,NULL,'','3835524','','2014-02-24','2014-02-24 18:49:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-25 21:30:49'),(27901,22074,'Y','18','021','EC','A','','','AC','0000556708','0000556708','TX00003586039','IL','1','Nguyen','Diem','To','','','34','610823077','3908 NORFOLK CT',0,'ODESSA','TX','79765','8528','CY','48135','1972-12-15','F','M',':RET:2047-9','N','021','DEN','3935877','33348TX002000201','2014-04-01','2014-03-05 18:04:27','0.00',NULL,NULL,'29.22','29.22','R-TX017','TX0','14.61',NULL,0,'2014-03-06 21:00:09'),(823,681,'Y','18','021','EC','A','','','AC','0000790849','0000790849','OH00000970956','IL','1','Lawrence','Zachary','','','','34','603103858','902 Continental Dr.',0,'Medina','OH','44256',NULL,'CY','39103','1980-10-09','M','M',':RET:2106-3','N','021','HLT','2279894','52664OH151001301','2014-01-01','2013-12-16 14:59:56','0.00',NULL,NULL,'525.63','525.63','R-OH012','OH0','267.16',NULL,0,'2013-12-25 18:06:08'),(23141,18447,'Y','18','024','14','A','','','TE','0000912998','0000912998','','IL','1','HILDRETH','MICHELLE','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-04-20','F','',NULL,NULL,NULL,'','2871820','','2014-02-12','2014-02-12 12:03:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:36'),(22722,18143,'Y','18','021','EC','A','','','AC','0002255110','0002255110','LA00001451998','IL','1','RAHMAN','SAIZUR','','','','34','149021846','1334 LAKE FRANCES DR',0,'GRETNA','LA','70056','8321','CY','22051','1962-10-23','M','U',':RET:2029-7','N','021','DEN','3704234','18575LA002000201','2014-03-01','2014-02-11 12:43:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:10'),(7985,6321,'N','01','021','EC','A',NULL,NULL,'','0000740268','0000086415','','IL','1','Brown','Jenna','','','','34','285925525','202 Hawk Ave',0,'Akron','OH','44312',NULL,'CY','39153','1989-05-21','F','',':RET:2106-3','N','021','HLT','1854694','52664OH151001305','2014-01-01','2013-12-20 14:39:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-26 03:08:02'),(7605,6018,'Y','18','021','EC','A','','','AC','0000599555','0000599555','LA00000030771','IL','1','Hunt','Susan','Darlene','','','34','433176320','10322 TAMS DR',0,'BATON ROUGE','LA','70815','1535','CY','22033','1957-07-22','F','U',':RET:2106-3','N','021','DEN','1066109','18575LA002000101','2014-01-01','2013-11-16 19:51:42','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 02:45:30'),(19588,15614,'Y','18','024','14','A','','','TE','0000722255','0000722255','','IL','1','molden','margaret',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-24','F','',NULL,NULL,NULL,'','1548894','','2014-01-22','2014-01-22 16:34:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-23 03:02:43'),(7184,5695,'N','19','021','EC','A',NULL,NULL,'','0000983815','0000333837','','IL','1','abdallah','kareem','','','','34','281134066','897 DEERHURST DR',0,'VANDALIA','OH','45377','9409','CY','39113','2007-06-07','F','',':RET:2028-9','N','021','DEN','1065162','99734OH005000301','2014-01-01','2013-12-14 11:41:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:16'),(15287,12222,'Y','18','021','EC','A','','','AC','0000993936','0000993936','MS00001697410','IL','1','Catchings','Cory','','','','34','587617905','4329 BEACON PL',0,'JACKSON','MS','39213','4602','CY','28049','1988-02-11','M','U',NULL,'N','021','DEN','2572365','46300MS002000101','2014-02-01','2014-01-01 09:35:56','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:22:20'),(17811,14227,'N','01','021','EC','A',NULL,NULL,'','0001022073','0001183716','','IL','1','TRINH','TOQUYEN','KIEU','','','34','614134135','12431 HERITAGE GROVE DR',0,'HOUSTON','TX','77066','3343','CY','48201','1971-04-12','F','',NULL,'N','021','DEN','1817146','33348TX002000101','2014-02-01','2014-01-14 14:09:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-15 02:05:52'),(15969,12780,'Y','18','021','EC','A','','','AC','0001035386','0001035386','TX00002181764','IL','1','LIKE','CHARLES','MAURICE','','','34','456786438','1812 APACHE DR',0,'DALHART','TX','79022','5116','CY','48205','1949-12-18','M','U',':RET:2106-3','N','021','DEN','2284865','33348TX002000201','2014-02-01','2014-01-02 18:45:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:00:32'),(17023,13623,'Y','18','021','EC','A','','','AC','0001217387','0001217387','OH00002383295','IL','1','RUMMER','JEFFREY','','','','34','275682719','3276 WHIPPLE DR',0,'NORTON','OH','44203','5221','CY','39153','1963-05-15','M','M',':RET:2106-3','N','021','HLT','1701414','52664OH152000901','2014-02-01','2014-01-09 15:19:47','0.00',NULL,NULL,'803.80','803.80','R-OH012','OH0','291.73',NULL,0,'2014-01-13 02:20:41'),(24048,19126,'Y','18','021','EC','A','','','AC','0000546512','0000546512','OH00002195502','IL','1','Soutendijk','Diana','','','','34','295581081','3299 State Route 82',0,'Mantua','OH','44255',NULL,'CY','39133','1957-10-01','F','U',NULL,'N','021','DEN','3106401','99734OH005000301','2014-03-01','2014-02-15 11:01:50','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-15 22:01:02'),(24189,19216,'Y','18','021','EC','A','','','AC','0000047379','0000047379','TX00001902343','IL','1','TURNER','MICKEY','','','','34','455218028','2750 RED OAK DR',0,'GRAND PRAIRIE','TX','75052','4439','CY','48439','1960-06-06','M','U',NULL,'N','021','DEN','2870835','33348TX002000101','2014-03-01','2014-02-15 23:14:55','0.00',NULL,NULL,'74.25','74.25','R-TX008','TX0','27.15',NULL,0,'2014-02-16 19:00:13'),(28539,22587,'Y','18','021','EC','A','','','AC','0000009082','0000009082','TX00003032662','IL','1','Wheatley','Jon','','','','34','454958189','7319 WINDY PORT LN',0,'RICHMOND','TX','77407','6385','CY','48157','1977-06-28','M','U',':RET:2054-5','N','021','DEN','4233343','33348TX002000101','2014-04-01','2014-03-07 12:30:18','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-07 21:32:13'),(9682,7669,'N','01','021','EC','A',NULL,NULL,'','0000839048','0000009838','','IL','1','Hayden','Larita','','','','34','532963037','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','1983-04-03','F','',':RET:2054-5','N','021','HLT','1434306','92036OH001001201','2014-01-01','2013-12-21 11:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.90',NULL,0,'2013-12-26 04:39:29'),(20575,16443,'N','19','021','EC','A',NULL,NULL,'','0000683413','0001229329','','IL','1','EICHBERG','JOSHUA','','','','34','298061882','6330 CAMBRIDGE AVE',0,'CINCINNATI','OH','45230','1986','CY','39061','2002-04-11','M','',NULL,'N','021','HLT','2746447','92036OH003001201','2014-03-01','2014-01-29 17:36:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-29 21:01:54'),(20383,16283,'Y','18','021','EC','A','','','AC','0000276578','0000276578','TX00001526706','IL','1','Zuspan','Michelle','','','','34','175627050','4100 Terri Linn Dr.',0,'Killeen','TX','76549',NULL,'CY','48027','1977-12-20','F','U',':RET:2106-3','N','021','DEN','2762187','33348TX002000201','2014-03-01','2014-01-28 23:12:16','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-29 21:00:12'),(2145,1763,'Y','18','021','EC','A','','','AC','0000728684','0000728684','OH00001056011','IL','1','biddle','carla','','','','34','282567990','1875 KAREN DR',0,'BATAVIA','OH','45103','2625','CY','39025','1953-06-23','F','M',':RET:2106-3','N','021','HLT','595484','92036OH004000601','2014-01-01','2013-12-09 18:49:31','61.00',NULL,NULL,'468.46','407.46','R-OH005','OH0','468.46',NULL,0,'2013-12-25 19:18:23'),(19325,15405,'N','19','021','EC','A',NULL,NULL,'','0000676350','0000008893','','S1','1','DANG','TAM','','','','34','630524167','3617 COLONY CREEK DR',0,'NACOGDOCHES','TX','75965','6977','CY','48347','1996-02-26','F','',':RET:2047-9','N','021','DEN','1791725','33348TX002000201','2014-03-01','2014-01-21 13:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,1,'2014-01-22 03:22:13'),(2212,1822,'Y','18','021','EC','A','','','AC','0000541621','0000541621','OH00001114730','IL','1','Keeton','Larry','','','','34','268484078','2642 Owaisa Rd',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1950-12-28','M','M',':RET:2106-3','N','021','HLT','642904','52664OH151001304','2014-01-01','2013-12-10 15:54:54','512.36',NULL,NULL,'658.32','145.96','R-OH012','OH0','658.32',NULL,0,'2013-12-25 19:20:20'),(17152,13723,'N','01','021','EC','A',NULL,NULL,'','0002246138','0002208050','','IL','1','LUCIEN','CELIE','','','','34','710754069','733 CARROLLWOOD VILLAGE DR',0,'GRETNA','LA','70056',NULL,'CY','22051','1980-01-19','F','',':RET:2054-5','N','021','DEN','2545384','18575LA002000201','2014-02-01','2014-01-07 22:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:21:57'),(17092,13680,'Y','18','021','EC','A','','','AC','0000407940','0000407940','TX00002233926','IL','1','ARREDONDO CERVANTES','EDUARDO','','','','34','644521314','1403 CAMP CRAFT RD  APT C',0,'AUSTIN','TX','78746',NULL,'CY','48453','1954-10-14','M','M',NULL,'N','021','DEN','1633872','33348TX002000201','2014-02-01','2014-01-08 15:07:40','0.00',NULL,NULL,'47.55','47.55','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:21:28'),(2899,2338,'Y','18','021','EC','A','','','AC','0000230410','0000230410','OH00000354306','IL','1','Thomas','Vanessa','','','','34','294668405','1035 E BOWMAN ST',0,'WOOSTER','OH','44691','3119','CY','39169','1974-10-11','F','R',':RET:2106-3','N','021','HLT','560008','52664OH151001501','2014-01-01','2013-12-06 10:32:38','0.00',NULL,NULL,'337.54','337.54','R-OH014','OH0','337.54',NULL,0,'2013-12-25 20:15:19'),(14565,11620,'Y','18','021','EC','A','','','AC','0000802581','0000802581','OH00000190084','IL','1','Ninness','Catherine','','','','34','382944120','190 Sharon Ave',0,'Ashland','OH','44805',NULL,'CY','39005','1973-03-25','F','R',':RET:2106-3','T','021','HLT','2414208','52664OH152000901','2014-02-01','2013-12-27 16:44:36','0.00',NULL,NULL,'240.06','240.06','R-OH012','OH0','240.06',NULL,0,'2013-12-28 03:35:22'),(25425,20174,'Y','18','021','EC','A','','','AC','0000880577','0000880577','OH00002527644','IL','1','Rock','Jacqueline','','','','34','280847223','2775 MOONLIGHT LN',0,'COLUMBUS','OH','43207','4655','CY','39049','1970-04-06','F','U',NULL,'N','021','DEN','3249751','99734OH005000401','2014-04-01','2014-02-25 17:23:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-25 21:31:11'),(26598,21088,'N','01','021','EC','A',NULL,NULL,'','0000834329','0000159439','','IL','1','PEREZ','ROBERT','','','','34','466657747','155 HILLCREST LN',0,'LIBERTY HILL','TX','78642','4436','CY','48491','1982-10-06','M','',NULL,'N','021','DEN','2929150','33348TX002000201','2014-04-01','2014-02-27 18:47:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 21:30:40'),(107,94,'Y','18','021','EC','A','','','AC','0001121997','0001121997','TX00000007144','IL','1','Killebrew','Eulonda','','','','34','553117635','20819 INDIGO RIVER LN',0,'KATY','TX','77449','7403','CY','48201','1967-02-06','F','U',':RET:2054-5','N','021','DEN','947835','33348TX002000201','2014-01-01','2013-12-05 11:34:03','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:17:52'),(2780,2247,'Y','18','021','EC','A','','','AC','0001010174','0001010174','OH00000852869','IL','1','Brown','Timothy','','','','34','280887292','44 HITCHCOCK LN',0,'AMELIA','OH','45102','1728','CY','39025','1979-12-19','M','U',':RET:2106-3','N','021','HLT','1012505','92036OH004000601','2014-01-01','2013-12-02 14:22:52','0.00',NULL,NULL,'209.55','209.55','R-OH005','OH0','209.55',NULL,0,'2013-12-25 19:49:50'),(9292,7367,'N','19','021','EC','A',NULL,NULL,'','0000225979','0000823478','','IL','1','Smith','Jack','McKinley','','','34','574359651','919 BROOKCREST DR',0,'MASON','OH','45040','3435','CY','39165','2002-08-31','M','',':RET:2106-3','N','021','DEN','1094066','99734OH005000301','2014-01-01','2013-11-30 14:42:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:16:09'),(5386,4273,'Y','18','021','EC','A','','','AC','0001579967','0001579967','LA00000240705','IL','1','Nash','Ashley','','','','34','467733887','1701 Prytania Street',0,'New Orleans','LA','70130',NULL,'CY','22071','1983-08-13','F','U',':RET:2106-3','N','021','DEN','1455177','18575LA002000201','2014-01-01','2013-12-19 16:20:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:30'),(19819,15802,'Y','18','024','14','A','','','TE','0000321786','0000321786','','IL','1','Wreyford','Christina','K',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-07-09','F','',NULL,NULL,NULL,'','1967057','','2014-01-24','2014-01-24 12:15:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:13'),(7911,6255,'Y','18','021','EC','A','','','AC','0002217015','0002217015','LA00001002622','IL','1','Geraghty','James','Donald','','','34','135821257','3415 DAUPHINE ST',0,'NEW ORLEANS','LA','70117','6243','CY','22071','1971-07-08','M','U',':RET:2106-3','N','021','DEN','2194536','18575LA002000201','2014-01-01','2013-12-19 21:24:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:05'),(7152,5675,'Y','18','021','EC','A','','','AC','0000721345','0000721345','OH00000152026','IL','1','Gustafson','Johnna','','','','34','280808568','1224 TOWNSHIP ROAD 1453',0,'ASHLAND','OH','44805','9359','CY','39005','1967-01-29','F','M',':RET:2106-3','N','021','HLT','1834041','52664OH151001501','2014-01-01','2013-12-24 20:23:07','434.00',NULL,NULL,'838.51','404.51','R-OH012','OH0','401.20',NULL,0,'2013-12-26 01:52:14'),(18051,14422,'Y','18','021','EC','A','','','AC','0000236435','0000236435','MS00002172796','IL','1','Signoff','Henry','','','','34','428028610','2322 20TH AVE',0,'GULFPORT','MS','39501','4756','CY','28047','1955-03-12','M','U',NULL,'N','021','DEN','2038815','46300MS002000101','2014-02-01','2014-01-14 12:57:09','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-15 02:07:17'),(13197,10530,'Y','18','021','EC','A','','','AC','0000627231','0000627231','TX00001219419','IL','1','Martin','Rudolph','','','','34','467455659','3316 AVENUE D',0,'BAY CITY','TX','77414','7135','CY','48321','1962-09-10','M','U',':RET:2054-5','N','021','DEN','1946557','33348TX002000101','2014-01-01','2013-12-23 12:50:53','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 12:54:50'),(25715,20398,'Y','18','021','EC','A','','','AC','0001044303','0001044303','TX00002274570','IL','1','Dingman','Karla','','','','34','457152693','8324 N US HIGHWAY 281',0,'STEPHENVILLE','TX','76401','8905','CY','48143','1958-11-26','F','M',':RET:2106-3','N','021','DEN','3058894','33348TX002000201','2014-04-01','2014-02-24 16:37:50','0.00',NULL,NULL,'43.83','43.83','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:25'),(27354,21662,'Y','18','021','EC','A','','','AC','0001183585','0001183585','OH00002981857','IL','1','Bersacola','Derek','E','','','34','277867057','14042 TRENTON TRL',0,'MIDDLEBURG HEIGHTS','OH','44130','6834','CY','39035','1970-12-05','M','U',':RET:2106-3','N','021','DEN','2811152','99734OH005000401','2014-04-01','2014-03-04 14:30:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:07'),(1282,1060,'Y','18','021','EC','A','','','AC','0000558121','0000558121','OH00001264358','IL','1','Holmes','Brittany','','','','34','291905404','1621 LAVAL DR',0,'CINCINNATI','OH','45255','3213','CY','39061','1984-12-03','F','M',':RET:2106-3','N','021','DEN','264914','99734OH005000401','2014-01-01','2013-11-29 13:08:37','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:30:35'),(3793,3039,'Y','18','024','14','A','','','TE','0000142808','0000142808','','IL','1','Norton','Ruth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-30','F','',NULL,NULL,NULL,'','732116','','2013-12-13','2013-12-13 10:51:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:34:18'),(15563,12454,'Y','18','021','EC','A','','','AC','0001012936','0001012936','OH00001602040','IL','1','BOC','GRZEGORZ','','','','34','290048097','9290 SHADY LAKE DR',0,'STREETSBORO','OH','44241',NULL,'CY','39133','1984-02-25','M','M',':RET:2106-3','N','021','HLT','2299848','52664OH151001305','2014-02-01','2013-12-31 12:18:29','377.00',NULL,NULL,'508.02','131.02','R-OH012','OH0','249.55',NULL,1,'2014-01-02 04:31:40'),(14714,11748,'Y','18','021','EC','A','','','AC','0001020425','0001020425','OH00001721168','IL','1','Jeffries','Thomas','H','','IV','34','300785531','22095 Libby Rd',0,'Bedford','OH','44146',NULL,'CY','39035','1966-01-05','M','M',':RET:2054-5','N','021','DEN','2083900','99734OH005000301','2014-02-01','2013-12-27 23:56:08','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:09:22'),(13098,10443,'Y','18','021','EC','A','','','AC','0000710139','0000710139','OH00000401252','31','1','Hillsman','Terrance','','','','34','285762669','4243 Parkway Drive',0,'Dayton','OH','45416',NULL,'CY','39113','1969-05-21','M','U',':RET:2054-5','N','021','DEN','1507217','99734OH005000401','2014-01-01','2013-12-23 12:25:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:52:05'),(20484,16364,'Y','18','021','EC','A','','','AC','0000435329','0000435329','OH00002390821','IL','1','SHOOKS','EVA','S','','','34','276567899','585 SEVILLE RD',0,'WADSWORTH','OH','44281','1030','CY','39103','1953-06-02','F','M',NULL,'N','021','HLT','2813004','52664OH151001305','2014-03-01','2014-01-29 10:48:19','445.00',NULL,NULL,'605.24','160.24','R-OH012','OH0','605.24',NULL,0,'2014-01-29 21:01:03'),(23013,18348,'Y','18','021','EC','A','','','AC','0002229291','0002229291','LA00001875849','IL','1','HYMEL','LEE','','','','34','437024046','6117 FABCO RD',0,'SAINT JAMES','LA','70086','7337','CY','22093','1954-04-03','M','U',NULL,'N','021','DEN','3733245','18575LA002000101','2014-03-01','2014-02-12 17:24:51','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-12 21:30:24'),(27009,21392,'Y','18','024','14','A','','','TE','0000988896','0000988896','','IL','1','Toth','Slavcia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-16','F','',NULL,NULL,NULL,'','2235945','','2014-03-31','2014-03-03 15:26:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:06'),(27051,21421,'N','01','021','EC','A',NULL,NULL,'','0001025151','0000150555','','IL','1','Elkhatib','Mufeda','','','','34','426696922','515 FLORENCE DR',0,'MADISON','MS','39110','7326','CY','28089','1953-09-10','F','',NULL,'N','021','DEN','3255070','46300MS002000101','2014-04-01','2014-03-03 11:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15','CIC',0,'2014-03-03 21:00:25'),(872,721,'Y','18','024','14','A','','','TE','0000694155','0000694155','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','56646','','2013-12-16','2013-12-16 09:53:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:07:28'),(16277,13031,'N','01','021','EC','A',NULL,NULL,'','0000644683','0000960623','','IL','1','HILL','KATHRYN','','','','34','302744704','524 CHERRY HILL LN',0,'LEBANON','OH','45036',NULL,'CY','39165','1978-10-16','F','',':RET:2106-3','N','021','DEN','2601997','99734OH005000401','2014-02-01','2014-01-06 13:46:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:25'),(15779,12628,'Y','18','021','EC','A','','','AC','0000993774','0000993774','TX00001909636','IL','1','Machain','Isabel','','','','34','640285914','208 N URBAHN AVE',0,'LAREDO','TX','78043','4350','CY','48479','1992-01-10','F','U',':RET:2106-3','N','021','DEN','2380118','33348TX002000201','2014-02-01','2014-01-02 17:10:52','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-03 02:02:04'),(1667,1392,'Y','18','021','EC','A','','','AC','0000774317','0000774317','TX00001031800','IL','1','Vamdehvar','Nasim','','','','34','642981733','11149 CLEARSTREAM LN',0,'FRISCO','TX','75035','3792','CY','48085','1972-12-21','F','U',':RET:2028-9','N','021','DEN','2416553','33348TX002000201','2014-01-01','2013-12-24 17:49:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:53:46'),(14063,11206,'Y','18','021','EC','A','','','AC','0000468118','0000468118','OH00000604141','IL','1','MCGEE','BYRDIE','','','','34','281563496','3125 CLERMONT RD',0,'COLUMBUS','OH','43227','1834','CY','39049','1956-06-22','F','M',':RET:2054-5','N','021','DEN','2225601','99734OH005000401','2014-02-01','2013-12-26 07:43:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:38'),(2339,1904,'Y','18','021','EC','A','','','AC','0001112985','0001112985','TX00000506947','IL','1','Lugo','Wendy','J','','','34','798582861','308 BEGONA CT',0,'LAREDO','TX','78046','8445','CY','48479','1981-10-22','F','U',NULL,'N','021','DEN','494763','33348TX002000201','2014-01-01','2013-12-09 13:11:09','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 19:31:54'),(5047,3996,'Y','18','021','EC','A','','','AC','0000581374','0000581374','TX00000953842','IL','1','Reyes','Angela','','','','34','453081392','2759 KOPPLIN RD',0,'BEEVILLE','TX','78102','8188','CY','48025','1968-07-19','F','U',':RET:2106-3','N','021','DEN','2606661','33348TX002000201','2014-01-01','2013-12-18 19:02:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:03'),(3546,2847,'N','19','021','EC','A',NULL,NULL,'','0000454421','0001188802','','IL','1','Wolfe','Zachary','Noah','','','34','173254557','3112 E COUNTY ROAD 136',0,'MIDLAND','TX','79706','7130','CY','48329','2013-11-06','M','',NULL,'N','021','DEN','2252551','33348TX002000101','2014-01-01','2013-12-22 18:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2013-12-25 21:21:56'),(3096,2487,'N','01','021','EC','A',NULL,NULL,'','0000053034','0000707591','','IL','1','STEPHENS','KIMBERLY','LYNN','','','34','293747961','3973 CENTER STREET',0,'NEW HAVEN','OH','44850',NULL,'CY','39077','1963-09-01','F','',':RET:2106-3','N','021','HLT','479101','92036OH005002706','2014-01-01','2013-12-06 16:49:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.25',NULL,0,'2013-12-25 20:20:07'),(21498,17175,'Y','18','021','EC','A','','','AC','0000439443','0000439443','OH00002508494','IL','1','Nguyen','Thao','','','','34','373351966','1201 BERNATH PKWY',0,'TOLEDO','OH','43615','6741','CY','39095','1979-01-17','F','M',':RET:2047-9','N','021','HLT','3626937','92036OH003002605','2014-03-01','2014-02-04 12:28:51','264.00',NULL,NULL,'548.12','284.12','R-OH001','OH0','248.83',NULL,0,'2014-02-04 21:01:50'),(22150,17680,'Y','18','021','EC','A','','','AC','0000137614','0000137614','OH00002636482','IL','1','Del Monte','Aron','','','','34','279944093','5125 KENNEDY RD',0,'LOWELLVILLE','OH','44436','9412','CY','39099','1991-09-24','M','U',':RET:2106-3','N','021','HLT','3013246','52664OH151001306','2014-03-01','2014-02-08 12:14:55','169.00',NULL,NULL,'252.90','83.90','R-OH013','OH0','252.90',NULL,0,'2014-02-08 19:00:53'),(25498,20228,'Y','18','021','EC','A','','','AC','0000456950','0000456950','TX00003295311','31','1','Coleman','Angel','','','','34','456510388','PO Box 2244',0,'Buna','TX','77612',NULL,'CY','48241','1978-12-08','F','U',':RET:2106-3','N','021','DEN','3394234','33348TX002000101','2014-04-01','2014-02-25 09:19:06','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-25 21:31:52'),(25590,20301,'Y','18','024','14','A','','','TE','0001841406','0001841406','','IL','1','Alcala','Rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-02-05','F','',NULL,NULL,NULL,'','2821882','','2014-02-24','2014-02-24 14:34:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-26 08:00:42'),(26877,21301,'Y','18','021','EC','A','','','AC','0000947447','0000947447','OH00002996617','IL','1','Kulow','Terry','','','','34','222485689','3742 MUIR TAP DR',0,'MEDINA','OH','44256','6464','CY','39103','1963-10-11','M','M',':RET:2106-3','N','021','HLT','3221564','52664OH152000901','2014-03-01','2014-02-28 22:48:56','0.00',NULL,NULL,'570.39','570.39','R-OH012','OH0','291.73',NULL,0,'2014-03-01 21:01:07'),(28257,22359,'Y','18','021','EC','A','','','AC','0000971518','0000971518','OH00003651642','S1','1','Habli','firas','','','','34','302088105','2057 DECKER CT',0,'COLUMBUS','OH','43235','2046','CY','39049','2004-08-11','M','U',NULL,'N','021','DEN','4139129','99734OH005000301','2014-04-01','2014-03-06 19:19:44','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','21.13','CIC',0,'2014-03-07 21:00:15'),(28275,22376,'Y','18','021','EC','A','','','AC','0000404857','0000404857','OH00003278929','IL','1','KNAPP','PATRICK','J','','','34','296623370','35 WASHINGTON AVE',0,'NILES','OH','44446','2433','CY','39155','1957-04-13','M','M',':RET:2106-3','N','021','HLT','3785669','92036OH003003201','2014-04-01','2014-03-07 09:27:53','0.00',NULL,NULL,'1061.16','1061.16','R-OH013','OH0','589.72','CIC',0,'2014-03-07 21:00:23'),(6370,5051,'Y','18','021','EC','A','','','AC','0000582788','0000582788','OH00000524949','IL','1','Becker','Lawrence','','','','34','272445571','2900 DENISE DR',0,'COPLEY','OH','44321','2245','CY','39153','1952-01-19','M','M',':RET:2106-3','N','021','DEN','327047','99734OH005000301','2014-01-01','2013-12-11 05:39:27','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:37'),(9592,7596,'Y','18','021','EC','A','','','AC','0000407363','0000407363','OH00000183759','IL','1','DOLAN','DARLENE','','','','34','299443197','87 MINWOOD AVE',0,'TALLMADGE','OH','44278','1429','CY','39153','1953-02-02','F','M',NULL,'N','021','HLT','1793151','52664OH151001305','2014-01-01','2013-12-20 19:13:35','461.00',NULL,NULL,'605.24','144.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 04:37:11'),(14223,11341,'Y','18','021','EC','A','','','AC','0000704875','0000704875','TX00001223567','IL','1','nguyen','kim','','','','34','627262436','2031 SHEPHERDS GLEN LN',0,'ARLINGTON','TX','76010','6792','CY','48439','1952-01-25','F','U',NULL,'N','021','DEN','2141422','33348TX002000201','2014-02-01','2013-12-26 17:02:17','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-27 02:04:47'),(18634,14853,'Y','18','021','EC','A','','','AC','0000772056','0000772056','TX00002387111','IL','1','Street','Jessica','','','','34','467731872','8724 TOWNSHIP CT',0,'FORT WORTH','TX','76179','2906','CY','48439','1985-09-30','F','M',':RET:2106-3','N','021','DEN','2387012','33348TX002000201','2014-02-01','2014-01-15 21:37:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:03'),(20532,16406,'Y','18','021','EC','A','','','AC','0000570666','0000570666','MS00002020584','IL','1','SMITH','RONNICA','DENISE','','','34','587452600','1107 HUNTER ST',0,'JACKSON','MS','39204','3111','CY','28049','1982-12-10','F','U',':RET:2054-5','N','021','DEN','3302497','46300MS002000201','2014-03-01','2014-01-29 16:15:49','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-29 21:01:31'),(20940,16735,'N','19','021','EC','A',NULL,NULL,'','0000780544','0000705188','','S1','1','Patel','Bhavesh','B','','','34','289081275','1839 CLOUGH PIKE',0,'BATAVIA','OH','45103','2621','CY','39025','2003-10-11','F','',':RET:2029-7^:RET:2106-3','N','021','HLT','3477931','92036OH003000604','2014-03-01','2014-01-31 16:20:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-31 21:01:43'),(21575,17233,'Y','18','021','EC','A','','','AC','0000999881','0000999881','OH00001379500','IL','1','Jeffries','Stephone',NULL,NULL,NULL,NULL,NULL,'1000 DELIA AVE',0,'AKRON','OH','44320','2120','CY','39153','1964-07-16','M','U',':RET:2054-5','N','021','HLT','3011734','52664OH151001305','2014-03-01','2014-02-05 12:43:27','281.00',NULL,NULL,'380.45','99.45','R-OH012','OH0','380.45',NULL,0,'2014-02-05 21:30:23'),(22399,17884,'N','01','021','EC','A',NULL,NULL,'','0000035791','0001024255','','IL','1','Kaye','Daniel','W','','Jr','34','294561130','938 CRESTLINE DR',0,'AKRON','OH','44312','3169','CY','39153','1967-12-05','M','',':RET:2106-3','N','021','HLT','3254528','52664OH151001304','2014-03-01','2014-02-10 14:26:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.51',NULL,0,'2014-02-10 21:30:19'),(26477,21001,'Y','18','024','14','A','','','TE','0001148709','0001148709','','IL','1','Bentley','Lowell',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-11-10','M','',NULL,NULL,NULL,'','2792736','','2014-02-27','2014-02-27 18:32:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-02-28 21:00:02'),(1172,966,'Y','18','021','EC','A','','','AC','0000695599','0000695599','OH00000213405','IL','1','Sandstrom','Michelle','','','','34','292846554','630 Chilham Circle',0,'Uniontown','OH','44685',NULL,'CY','39153','1970-08-28','F','R',':RET:2106-3','N','021','HLT','541910','52664OH151001501','2014-01-01','2013-12-03 13:04:48','0.00',NULL,NULL,'532.79','532.79','R-OH012','OH0','362.95',NULL,0,'2013-12-25 18:19:10'),(18419,14694,'Y','18','021','EC','A','','','AC','0001210411','0001210411','LA00001636455','IL','1','giarratano','nicholas','','','','34','436729095','850 florida blvd',0,'new orleans','LA','70124',NULL,'CY','22071','1958-07-26','M','U',':RET:2106-3','N','021','DEN','2386955','18575LA002000201','2014-02-01','2014-01-14 23:48:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:51'),(18148,14492,'Y','18','021','EC','A','','','AC','0001863552','0001863552','LA00001450145','IL','1','Roberts','Huey','','','','34','438239383','2535 N RAMPART ST',0,'NEW ORLEANS','LA','70117','7837','CY','22071','1971-01-02','M','U',NULL,'N','021','DEN','1962225','18575LA002000101','2014-02-01','2014-01-14 16:47:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-15 02:07:49'),(7968,6307,'Y','18','021','EC','A','','','AC','0001221203','0001221203','MS00000279360','IL','1','Akiti','Kingsley','','','','34','428556495','701 PECAN CT',0,'BRANDON','MS','39042','6013','CY','28121','1962-04-15','M','M',':RET:2054-5','N','021','DEN','2175622','46300MS002000201','2014-01-01','2013-12-20 15:24:27','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 03:07:36'),(16758,13406,'N','01','021','EC','A',NULL,NULL,'','0001055334','0000723920','','IL','1','Dong','Ai Zhu','','','','34','090906786','107 WESTWOOD PL',0,'HICKSVILLE','OH','43526','1060','CY','39039','1964-06-07','F','',':RET:2028-9','N','021','HLT','1820534','92036OH005002606','2014-02-01','2014-01-07 14:30:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','332.67',NULL,0,'2014-01-08 18:24:57'),(15240,12181,'Y','18','021','EC','A','','','AC','0000896996','0000896996','OH00001969625','IL','1','REYNOLDS','JENNIFER','','','','34','288721065','1934 OAKLAND PKWY',0,'LIMA','OH','45805','2262','CY','39003','1964-02-26','F','M',':RET:2106-3','T','021','HLT','1463753','92036OH004001501','2014-02-01','2013-12-30 11:49:29','231.00',NULL,NULL,'347.20','116.20','R-OH002','OH0','347.20',NULL,0,'2014-01-01 12:08:34'),(14634,11679,'N','01','021','EC','A',NULL,NULL,'','0001203227','0000960614','','IL','1','HUNDLEY','SUSAN','JO','','','34','262398804','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-07-07','F','',NULL,'N','021','HLT','1741205','92036OH005001204','2014-02-01','2013-12-27 14:07:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.72',NULL,0,'2013-12-28 03:37:15'),(2405,1964,'Y','18','021','EC','A','','','AC','0000746849','0000746849','OH00000359227','IL','1','Kramer','Leonard','','','','34','291445999','5460 CORONADA DR',0,'MENTOR ON THE LAKE','OH','44060','1408','CY','39085','1950-03-05','M','M',':RET:2106-3','N','021','DEN','273341','99734OH005000401','2014-01-01','2013-12-09 14:13:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:33:38'),(4320,3431,'N','01','021','EC','A',NULL,NULL,'','0001151066','0000355027','','IL','1','Dowling','Connie','','','','34','297645661','5873 TRACY RD',0,'SARDINIA','OH','45171','9113','CY','39015','1959-07-08','F','',':RET:2106-3','N','021','HLT','1402552','92036OH004000601','2014-01-01','2013-12-17 10:06:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','368.53',NULL,0,'2013-12-25 21:52:44'),(2462,2003,'Y','18','021','EC','A','','','AC','0000975227','0000975227','LA00000884187','IL','1','Jones','Travis','','','','34','439061923','317 GASTON LN',0,'BOSSIER CITY','LA','71112','4270','CY','22015','1976-12-21','M','M',':RET:2106-3','N','021','DEN','630550','18575LA002000101','2014-01-01','2013-12-09 12:41:02','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 19:34:58'),(2720,2199,'Y','18','021','EC','A','','','AC','0000463249','0000463249','LA00000499305','IL','1','Dobbins','Denise','','','','34','439983564','3045 Potomac Dr.',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1955-05-23','F','U',':RET:2106-3','N','021','DEN','1139187','18575LA002000201','2014-01-01','2013-12-01 19:36:45','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:48:10'),(18558,14800,'Y','18','021','EC','A','','','AC','0001065998','0001065998','OH00002347938','IL','1','Catone','Joshua','','','','34','173700302','7345 PONDLICK RD',0,'SEAMAN','OH','45679','9798','CY','39001','1983-03-13','M','U',':RET:2106-3','T','021','HLT','2196865','92036OH005000606','2014-02-01','2014-01-14 22:58:04','100.00',NULL,NULL,'280.20','180.20','R-OH005','OH0','280.20',NULL,0,'2014-01-16 08:46:57'),(18848,15011,'N','19','021','EC','A',NULL,NULL,'','0001129038','0000694228','','IL','1','DAVIS','DANIEL','','','','34','294963928','417 RED ROCK DRIVE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1994-01-24','M','',':RET:2106-3','N','021','HLT','2529099','52664OH151001301','2014-02-01','2014-01-15 19:05:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-17 03:36:15'),(23627,18815,'Y','18','021','EC','A','','','AC','0000774019','0000774019','OH00002336742','IL','1','Banister','Barbara','','','','34','308841563','716 W MAIN ST',0,'TIPP CITY','OH','45371','1418','CY','39109','1963-07-22','F','M',':RET:2106-3','N','021','HLT','2764803','92036OH004000501','2014-03-01','2014-02-13 17:17:04','662.56',NULL,NULL,'667.44','4.88','R-OH003','OH0','341.36',NULL,0,'2014-02-13 22:03:21'),(23671,18848,'Y','18','021','EC','A','','','AC','0002023006','0002023006','LA00002551944','IL','1','devitt','blaine','','','','34','434962790','3809 east loloya',0,'kenner','LA','70069',NULL,'CY','22095','1969-07-30','M','U',':RET:2106-3','N','021','DEN','3716377','18575LA002000201','2014-03-01','2014-02-13 18:23:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-14 21:30:24'),(24562,19507,'N','01','021','EC','A',NULL,NULL,'','0000737910','0000283315','','IL','1','grubb','michelle','','','','34','301708059','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1973-04-22','F','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:06:22'),(24745,19638,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000330936','','IL','1','Dugan','Veronica','A','','','34','296969404','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1994-02-07','F','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:46'),(28567,22607,'Y','18','021','EC','A','','','AC','0001026995','0001026995','OH00003144485','IL','1','SHINDELDECKER','APRIL','','','','34','275660954','3065 SWANEY RD',0,'HARROD','OH','45850','8420','CY','39003','1973-06-20','F','U',NULL,'N','021','HLT','3838613','92036OH006001501','2014-04-01','2014-03-07 14:52:02','103.00',NULL,NULL,'333.91','230.91','R-OH002','OH0','223.07',NULL,0,'2014-03-07 21:32:29'),(28698,22711,'N','01','021','EC','A',NULL,NULL,'','0001375473','0001473940','','IL','1','STAGGS','OLIVIA','','','','34','664225944','2026 KENTUCKY AVE',0,'KENNER','LA','70062','5943','CY','22051','1982-11-20','F','',NULL,'N','021','DEN','3636907','18575LA002000101','2014-04-01','2014-03-08 14:58:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-03-08 21:31:07'),(6941,5512,'Y','18','021','EC','A','','','AC','0001169453','0001169453','OH00000553465','IL','1','MOHAMED','MOHAMED','','','','34','029768376','6191 BRENTHURST DR',0,'COLUMBUS','OH','43230','6324','CY','39049','1978-01-01','M','M',NULL,'N','021','DEN','1910370','99734OH005000401','2014-01-01','2013-12-24 20:25:34','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:46:48'),(18458,14725,'Y','18','021','EC','A','','','AC','0001339216','0001339216','LA00001834270','IL','1','Green','Ellen','','','','34','436299746','2744 JACKSON AVE',0,'BATON ROUGE','LA','70802','2847','CY','22033','1962-04-26','F','U',NULL,'N','021','DEN','2099472','18575LA002000101','2014-02-01','2014-01-15 12:53:50','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:11'),(18092,14451,'Y','18','021','EC','A','','','AC','0001549598','0001549598','LA00001788418','IL','1','franks','latashia','','','','34','435433116','505 S HOLLY ST',0,'BUNKIE','LA','71322','2112','CY','22009','1980-12-27','F','U',':RET:2054-5','N','021','DEN','2046259','18575LA002000201','2014-02-01','2014-01-14 12:21:15','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-15 02:07:31'),(14992,11982,'Y','18','021','EC','A','','','AC','0000376554','0000376554','TX00002023277','IL','1','Abrego','Raquel','','','','34','451139962','3103 LIGARDE ST',0,'LAREDO','TX','78043','5602','CY','48479','1960-01-17','F','M',NULL,'N','021','DEN','1787398','33348TX002000201','2014-02-01','2013-12-30 16:26:23','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-01 12:01:27'),(27054,21423,'N','01','021','EC','A',NULL,NULL,'','0000908038','0001003320','','IL','1','Smith','Jack','Lee','','','34','284565169','2316 GLADDEN AVE',0,'SPRINGFIELD','OH','45503','3019','CY','39023','1952-11-02','M','',':RET:2106-3','T','021','HLT','3084900','92036OH004000501','2014-04-01','2014-03-03 12:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','617.67','CIC',0,'2014-03-03 21:00:26'),(28749,22754,'N','01','021','EC','A',NULL,NULL,'','0000663338','0000311918','','IL','1','nguyen','tram','thi bich','','','34','046711320','700 CARVER AVE',0,'ODESSA','TX','79761','7115','CY','48135','1985-05-27','F','',':RET:2047-9','N','021','DEN','3952721','33348TX002000201','2014-04-01','2014-03-08 23:31:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-09 21:00:15'),(28841,22823,'Y','18','021','EC','A','','','AC','0000432825','0000432825','OH00003663886','IL','1','Messenger','Debra','Louise','','','34','276566471','2972 PIKES AVE',0,'AKRON','OH','44314','1006','CY','39153','1956-03-25','F','M',':RET:2106-3','N','021','HLT','3616292','52664OH151001501','2014-04-01','2014-03-09 13:10:39','0.00',NULL,NULL,'1483.88','1483.88','R-OH012','OH0','681.50',NULL,0,'2014-03-09 21:01:12'),(29198,23107,'Y','18','021','EC','A','','','AC','0000271433','0000271433','OH00002625570','IL','1','CUPP','SHARON','','','','34','077466994','4317 LINCHMERE DR',0,'DAYTON','OH','45415','1810','CY','39113','1953-10-19','F','M',':RET:2106-3','N','021','DEN','4253876','99734OH005000301','2014-04-01','2014-03-10 13:33:40','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00','CIC',0,'2014-03-10 21:30:09'),(112,98,'Y','18','021','EC','A','','','AC','0000800592','0000800592','TX00000785793','IL','1','BAILEY','WALTER','D','','','34','464886942','301 S LEE ST',0,'VALLEY VIEW','TX','76272','9404','CY','48097','1952-03-31','M','U',':RET:2106-3','N','021','DEN','34160','33348TX002000201','2014-01-01','2013-12-05 14:30:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:17:59'),(7741,6130,'N','01','021','EC','A',NULL,NULL,'','0000051914','0000460573','','IL','1','Huesken','Susan','Lynn','','','34','269569545','6304 Cary Avenue',0,'Cincinnati','OH','45224',NULL,'CY','39061','1953-04-23','F','',':RET:2106-3','N','021','DEN','1745794','99734OH005000401','2014-01-01','2013-12-20 15:42:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:17'),(15294,12228,'Y','18','021','EC','A','','','AC','0001678724','0001678724','LA00001968503','IL','1','WRIGHT','LORIA','S','','','34','433136802','6420 VINEYARD DR',0,'BATON ROUGE','LA','70812','2055','CY','22033','1958-04-06','F','U',':RET:2054-5','N','021','DEN','2590285','18575LA002000101','2014-02-01','2014-01-01 15:53:31','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-02 04:22:34'),(3369,2699,'N','01','021','EC','A',NULL,NULL,'','0000348881','0001005508','','IL','1','Curry','Rhonda','Catherine','','','34','226864052','10445 TRUMAN ST',0,'AMARILLO','TX','79118','5330','CY','48381','1955-01-01','F','',':RET:2106-3','N','021','DEN','1700790','33348TX002000201','2014-01-01','2013-12-22 15:24:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:17:12'),(13134,10476,'Y','18','021','EC','A','','','AC','0001115938','0001115938','OH00000463828','IL','1','Carlton','Ashley','N',NULL,NULL,NULL,NULL,'1232 Shawnee Trail',0,'Streetsboro','OH','44241',NULL,'CY','39133','1982-11-11','F','M',':RET:2106-3','N','021','DEN','2534743','99734OH005000401','2014-01-01','2013-12-23 15:07:34','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:53:06'),(4364,3466,'Y','18','021','EC','A','','','AC','0000551403','0000551403','OH00001299598','IL','1','Ball','Ed','','','','34','274601003','1023 Lindsay Ave',0,'Akron','OH','44306',NULL,'CY','39153','1955-06-09','M','U',':RET:2106-3','N','021','DEN','743185','99734OH005000401','2014-01-01','2013-12-11 19:13:25','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:00:07'),(9735,7709,'Y','18','021','EC','A','','','AC','0000950017','0000950017','TX00000331394','IL','1','Tran','Vivian','','','','34','065681006','4536 9TH ST',0,'BACLIFF','TX','77518','2259','CY','48167','1978-10-15','F','M',':RET:2028-9','T','021','DEN','929760','33348TX002000201','2014-01-01','2013-11-14 20:43:36','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:45:47'),(5476,4347,'Y','18','021','EC','A','','','AC','0000011117','0000011117','OH00000752878','IL','1','baney','david','','','','34','284621335','113 S TAYLOR ST',0,'NORTH BALTIMORE','OH','45872','1422','CY','39173','1958-12-18','M','U',':RET:2106-3','N','021','HLT','1824753','92036OH005002604','2014-01-01','2013-12-19 10:37:47','259.00',NULL,NULL,'434.84','175.84','R-OH001','OH0','434.84',NULL,0,'2013-12-25 23:10:42'),(18262,14579,'Y','18','021','EC','A','','','AC','0000373218','0000373218','TX00001827462','IL','1','Bryndzia','Yurij','','','','34','347823400','13402 TOSCA LN',0,'HOUSTON','TX','77079','7123','CY','48201','1987-12-16','M','U',':RET:2106-3','N','021','DEN','2858182','33348TX002000201','2014-02-01','2014-01-15 16:40:49','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-16 08:44:37'),(20763,16588,'Y','18','021','EC','A','','','AC','0000995469','0000995469','OH00002128617','IL','1','LAMMERS','MICHAEL','','','','34','268602849','17451 FAIRWAY DR',0,'OTTAWA','OH','45875','9462','CY','39137','1958-04-13','M','M',':RET:2106-3','N','021','HLT','3070507','92036OH003001505','2014-03-01','2014-01-30 14:30:06','912.00',NULL,NULL,'1003.24','91.24','R-OH002','OH0','512.54',NULL,0,'2014-01-30 21:01:36'),(21166,16915,'Y','18','024','14','A','','','TE','0000716376','0000716376','','IL','1','Jones','Mary Jane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-24','F','',NULL,NULL,NULL,'','3272576','','2014-02-03','2014-02-03 11:53:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:00:36'),(25702,20390,'Y','18','021','EC','A','','','AC','0000164040','0000164040','TX00002921422','IL','1','Lucero','Iaan','','','','34','449950110','7931 KIELY RD',0,'VINTON','TX','79821','7602','CY','48141','1977-04-29','M','U',':RET:2106-3','N','021','DEN','3320890','33348TX002000201','2014-04-01','2014-02-24 12:49:52','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-26 09:30:19'),(27144,21490,'Y','18','024','14','A','','','TE','0000785861','0000785861','','IL','1','Price','Derris',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-18','M','',NULL,NULL,NULL,'','2816074','','2014-03-03','2014-03-03 13:01:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:48'),(27363,21669,'Y','18','021','EC','A','','','AC','0000257193','0000257193','OH00003072186','IL','1','Springer','Timothy','L','','','34','275588311','1631 CR 68',0,'Toronto','OH','43964',NULL,'CY','39081','1955-05-16','M','U',':RET:2106-3','N','021','DEN','4015929','99734OH005000401','2014-04-01','2014-03-04 17:40:40','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-04 21:01:12'),(5686,4512,'Y','18','021','EC','A','','','AC','0000757101','0000757101','OH00001144199','IL','1','Ridge','Mary','','','','34','281504384','1855 WOODRIDGE CRES',0,'FINDLAY','OH','45840','0119','CY','39063','1952-09-24','F','M',':RET:2106-3','N','021','DEN','279203','99734OH005000301','2014-01-01','2013-11-26 17:34:00','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 23:32:27'),(4017,3208,'Y','18','021','EC','A','','','AC','0000532084','0000532084','OH00001133531','IL','1','Griffith','Tereasa','','','','34','275763673','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1967-07-18','F','M',':RET:2106-3','N','021','DEN','2086744','99734OH005000401','2014-01-01','2013-12-17 08:08:43','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:45:34'),(3909,3127,'Y','18','021','EC','A','','','AC','0000855715','0000855715','TX00000179490','IL','1','zamora','alicia','melissa','','','34','643056357','329 COLEMAN ST',0,'KERRVILLE','TX','78028','3127','CY','48265','1983-09-29','F','U',NULL,'N','021','DEN','914800','33348TX002000101','2014-01-01','2013-12-12 19:16:02','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 21:37:02'),(2345,1910,'Y','18','021','EC','A','','','AC','0001040238','0001040238','TX00000199755','IL','1','BOURQUIN','BARBARA','JANE','','','34','459257742','306 MARY LYNN DRIVE',0,'GLEN ROSE','TX','76043',NULL,'CY','48425','1957-08-13','F','M',NULL,'N','021','DEN','945326','33348TX002000201','2014-01-01','2013-12-09 14:06:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:32:04'),(2643,2147,'Y','18','021','EC','A','','','AC','0000762255','0000762255','OH00000809956','IL','1','Terrell','Bruce','','','','34','192485555','27100 KNICKERBOCKER RD',0,'BAY VILLAGE','OH','44140','2307','CY','39035','1956-12-08','M','U',NULL,'N','021','DEN','891395','99734OH005000401','2014-01-01','2013-12-02 16:53:15','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:46:23'),(3264,2631,'Y','18','021','EC','A','','','AC','0000985969','0000985969','OH00001082153','IL','1','Barnhart','Betty','','','','34','294563914','360 Lincoln Avenue',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1955-08-16','F','U',':RET:2106-3','N','021','HLT','50812','52664OH151001501','2014-01-01','2013-11-28 16:06:53','495.00',NULL,NULL,'681.50','186.50','R-OH012','OH0','681.50',NULL,0,'2013-12-25 20:47:00'),(9253,7337,'Y','18','021','EC','A','','','AC','0000861722','0000861722','TX00001068412','31','1','FitzSimmons','Stanton','','','','34','451336221','P.O. Box 620',0,'San Diego','TX','78384',NULL,'CY','48131','1963-07-24','M','U',':RET:2106-3','N','021','DEN','480013','33348TX002000201','2014-01-01','2013-11-29 18:17:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:15:03'),(24962,19796,'Y','18','021','EC','A','','','AC','0001720429','0001720429','LA00001709960','31','1','Swayzer','Sandra','','','','34','434172353','Po Box 655',0,'Wisner','LA','71378',NULL,'CY','22041','1969-02-19','F','U',':RET:2054-5','N','021','DEN','3087718','18575LA002000201','2014-04-01','2014-02-20 16:45:35','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 22:00:20'),(28010,22165,'Y','18','021','EC','A','','','AC','0001014438','0001014438','OH00003181490','31','1','GEARY','EVAN','','','','34','326823351','1065 READING RD',0,'MASON','OH','45040','1306','CY','39061','1987-02-03','M','M',':RET:2106-3','N','021','DEN','3892001','99734OH005000401','2014-04-01','2014-03-06 11:43:13','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:14'),(28063,22207,'Y','18','021','EC','A','','','AC','0001135239','0001135239','OH00003581035','IL','1','MAY','DELINTHIA','ANNETTE','','','34','269660720','4673 EAST 173RD STREET',0,'CLEVELAND','OH','44128',NULL,'CY','39035','1959-11-27','F','U',':RET:2054-5','N','021','DEN','3293241','99734OH005000301','2014-04-01','2014-03-06 11:13:31','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:45'),(5425,4307,'Y','18','021','EC','A','','','AC','0001098923','0001098923','MS00000693922','IL','1','Piazza','Bernie','Jude','','Jr','34','587037958','304 B RUELLA',0,'Bay St Louis','MS','39520',NULL,'CY','28045','1950-11-07','M','U',':RET:2106-3','N','021','DEN','1676635','46300MS002000201','2014-01-01','2013-12-19 15:45:23','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 23:09:30'),(16828,13460,'Y','18','021','EC','A','','','AC','0000057350','0000057350','OH00001655506','31','1','Everett-Hardy','Lashonda','','','','34','452794011','PO Box 91132',0,'Cleveland','OH','44101',NULL,'CY','39035','1979-08-15','F','M',':RET:2054-5','N','021','DEN','1741548','99734OH005000401','2014-02-01','2014-01-10 19:08:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:18:27'),(2226,1832,'Y','18','021','EC','A','','','AC','0000891784','0000891784','OH00000656369','IL','1','Schank','Judy','','','','34','268506122','19 GOODSELL ST',0,'TIFFIN','OH','44883','3109','CY','39147','1950-09-24','F','M',':RET:2106-3','N','021','HLT','1246854','92036OH003002706','2014-01-01','2013-12-10 14:22:02','564.00',NULL,NULL,'601.12','37.12','R-OH006','OH0','601.12',NULL,0,'2013-12-25 19:20:39'),(16508,13206,'Y','18','021','EC','A','','','AC','0000011174','0000011174','OH00001631197','IL','1','Fitzpatrick','Joshua','','','','34','296828678','1933 w. alexis',0,'Toledo','OH','43613',NULL,'CY','39095','1985-02-01','M','U',':RET:2106-3','N','021','DEN','2265333','99734OH005000301','2014-02-01','2014-01-05 12:14:43','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,1,'2014-01-07 10:21:17'),(4000,3195,'Y','18','021','EC','A','','','AC','0000556704','0000556704','OH00000713765','IL','1','Vroman','Jesse','','','','34','299842610','537 CANVAS BACK CIR',0,'SPRINGDALE','OH','45246','1535','CY','39061','1985-02-23','M','M',':RET:2106-3','N','021','DEN','1877331','99734OH005000401','2014-01-01','2013-12-16 19:04:40','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:10'),(3874,3102,'Y','18','021','EC','A','','','AC','0000068368','0000068368','LA00000940063','IL','1','Wright','Brianna','','','','34','433836232','3021 Rue Parc Fontanie',0,'NEW ORLEANS','LA','70131',NULL,'CY','22071','1991-09-19','F','U',':RET:2054-5','N','021','DEN','400664','18575LA002000201','2014-01-01','2013-12-13 12:07:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:36:15'),(14940,11939,'Y','18','021','EC','A','','','AC','0000267537','0000267537','OH00000234910','IL','1','duran','katina','','','','34','291789753','7346 hill ave',0,'holland','OH','43528',NULL,'CY','39095','1973-02-26','F','U',NULL,'T','021','HLT','1668871','92036OH006002601','2014-02-01','2013-12-29 13:07:12','194.00',NULL,NULL,'227.28','33.28','R-OH001','OH0','227.28',NULL,0,'2013-12-30 00:02:17'),(14920,11921,'Y','18','021','EC','A','','','AC','0001204536','0001204536','OH00001125207','31','1','DODDS','LOREN','','','','34','282647250','P.O. BOX 226',0,'SMITHFIELD','OH','43948',NULL,'CY','39081','1958-08-11','F','M',':RET:2106-3','T','021','DEN','1689856','99734OH005000401','2014-02-01','2013-12-29 13:31:35','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-30 00:01:39'),(14794,11815,'N','19','021','EC','A',NULL,NULL,'','0000132073','0000604714','','IL','1','Payten','Charity','D','','','34','296966835','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1994-02-17','F','',':RET:2054-5','N','021','DEN','2101453','99734OH005000401','2014-01-01','2013-12-23 19:41:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:13:34'),(3848,3078,'Y','18','021','EC','A','','','AC','0000179444','0000179444','LA00000313300','31','1','Christmas','Carlette','','','','34','439454009','P.O. Box 495',0,'Cheneyville','LA','71325',NULL,'CY','22079','1967-10-16','F','M',':RET:2054-5','N','021','DEN','759781','18575LA002000101','2014-01-01','2013-12-13 12:20:16','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-25 21:35:33'),(3378,2707,'Y','18','021','EC','A','','','AC','0001120644','0001120644','TX00000081866','IL','1','Moran','Sean','','','','34','454253737','2010 IRONGATE DR',0,'ARLINGTON','TX','76012','2235','CY','48439','1967-08-18','M','U',':RET:2106-3','N','021','DEN','1552684','33348TX002000201','2014-01-01','2013-12-22 17:14:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:17:25'),(19270,15358,'Y','18','021','EC','A','','','AC','0001012953','0001012953','OH00001371943','IL','1','ELMER','STEVEN','','','','34','292602695','1231 N SUPERIOR ST',0,'TOLEDO','OH','43604','1964','CY','39095','1961-08-02','M','M',':RET:2106-3','N','021','HLT','2931920','92036OH006002601','2014-03-01','2014-01-20 13:46:56','237.00',NULL,NULL,'301.86','64.86','R-OH001','OH0','301.86',NULL,0,'2014-01-21 08:46:53'),(22824,18213,'Y','18','021','EC','A','','','AC','0001182541','0001182541','OH00001526962','IL','1','Plum','Barbara',NULL,NULL,NULL,NULL,NULL,'1269 SPRUCE WOOD WAY',0,'UNIONTOWN','OH','44685','9579','CY','39153','1958-07-25','F','R',NULL,'N','021','HLT','3637434','52664OH151001301','2014-03-01','2014-02-11 09:10:20','0.00',NULL,NULL,'1382.21','1382.21','R-OH012','OH0','497.31',NULL,0,'2014-02-11 21:02:04'),(22959,18304,'Y','18','021','EC','A','','','AC','0001031762','0001031762','TX00002550491','IL','1','Binz','John','','','','34','631322196','1403 E CRESTWOOD DR',0,'VICTORIA','TX','77901','3411','CY','48469','1992-07-16','M','U',':RET:2106-3','N','021','DEN','2649967','33348TX002000201','2014-03-01','2014-02-11 19:39:53','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61','CIC',0,'2014-02-12 21:00:07'),(24802,19670,'Y','18','021','EC','A','','','AC','0000451328','0000451328','OH00002598971','IL','1','Kopis','Karen','','','','34','291626186','284 ROOSEVELT AVE',0,'ELYRIA','OH','44035','3948','CY','39093','1958-07-07','F','U',':RET:2106-3','N','021','DEN','2960752','99734OH005000401','2014-04-01','2014-02-19 13:32:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:48:25'),(64,57,'Y','18','021','EC','A','','','AC','0000155744','0000155744','OH00001242805','IL','1','HOLIDAY','ALEXANDER','','','','34','295945427','13714 ARGUS AVE.',0,'CLEVELAND','OH','44110',NULL,'CY','39035','1992-02-15','M','U',NULL,'N','021','DEN','517281','99734OH005000301','2014-01-01','2013-12-05 10:51:53','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:16:43'),(498,407,'Y','18','021','EC','A','','','AC','0000144185','0000144185','OH00000748526','IL','1','Marshall','Rhea','','','','34','270828332','5782 Andrews Rd',0,'Mentor','OH','44060',NULL,'CY','39085','1982-03-02','F','U',':RET:2106-3','N','021','DEN','788416','99734OH005000301','2014-01-01','2013-12-03 20:08:01','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:48:37'),(676,556,'N','19','021','EC','A',NULL,NULL,'','0000079893','0000927296','','IL','1','Barlage','Megan','M','','','34','285023784','1021 W BRIDLEPATH LN',0,'LOVELAND','OH','45140','8073','CY','39025','1997-09-04','F','',':RET:2106-3','N','021','DEN','2369019','99734OH005000301','2014-01-01','2013-12-16 10:16:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:15'),(9654,7650,'Y','18','021','EC','A','','','AC','0000257126','0000257126','OH00001026099','IL','1','Montgomery','Angela','','','','34','275889430','301 NELSON LN',0,'BEAVERDAM','OH','45808','9719','CY','39003','1975-05-29','F','M',':RET:2106-3','N','021','HLT','2019458','92036OH004001501','2014-01-01','2013-12-21 15:42:00','0.00',NULL,NULL,'439.59','439.59','R-OH002','OH0','220.51',NULL,0,'2013-12-26 04:38:51'),(6951,5520,'N','01','021','EC','A',NULL,NULL,'','0001110363','0001039756','','IL','1','Smith','Debra','K','','','34','299669232','8833 NATIONAL RD',0,'THORNVILLE','OH','43076','8337','CY','39089','1960-07-10','F','',':RET:2106-3','N','021','DEN','2133520','99734OH005000401','2014-01-01','2013-12-24 21:03:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:02'),(4629,3668,'Y','18','021','EC','A','','','AC','0000232001','0000232001','MS00000717654','IL','1','Jones','Thad','','','','34','427230989','614 EASTWYCK DR',0,'RIDGELAND','MS','39157','3621','CY','28089','1960-12-11','M','U',':RET:2106-3','N','021','DEN','55996','46300MS002000101','2014-01-01','2013-12-12 07:25:59','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 22:06:29'),(20979,16765,'Y','18','024','14','A','','','TE','0002268054','0002268054','','IL','1','Kambi','Cheye',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-09-02','F','',NULL,NULL,NULL,'','2410449','','2014-01-31','2014-01-31 22:46:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-01 19:00:19'),(22168,17692,'Y','18','021','EC','A','','','AC','0000891849','0000891849','OH00002471854','IL','1','Colson','Jennifer','','','','34','299866749','432 E Cleveland St',0,'Delphos','OH','45833',NULL,'CY','39003','1981-07-05','F','M',':RET:2106-3','N','021','HLT','3856729','92036OH004001501','2014-03-01','2014-02-08 17:58:03','319.00',NULL,NULL,'430.57','111.57','R-OH002','OH0','209.35',NULL,0,'2014-02-08 19:01:02'),(24418,19396,'Y','18','021','EC','A','','','AC','0000612003','0000612003','OH00002838850','IL','1','HAYES','MARIA','V','','','34','276663666','3920 BEECHWOOD DR',0,'BELLBROOK','OH','45305','1601','CY','39057','1958-12-18','F','R',NULL,'N','021','DEN','2777806','99734OH005000301','2014-04-01','2014-02-18 12:51:53','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-18 22:01:05'),(158,132,'Y','18','021','EC','A','','','AC','0000940214','0000940214','TX00001138263','IL','1','Falaschi','Kinsey','','','','34','644260473','7011 W PARMER LN',0,'AUSTIN','TX','78729','6977','CY','48453','1991-09-30','F','U',':RET:2106-3','N','021','DEN','1131989','33348TX002000101','2014-01-01','2013-12-05 12:28:23','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 17:19:07'),(16183,12956,'Y','18','021','EC','A','','','AC','0000655491','0000655491','TX00000887652','IL','1','BARRAZA','ARACELY','','','','34','661699831','600 BELVIDERE ST',0,'EL PASO','TX','79912',NULL,'CY','48141','1974-10-13','F','U',NULL,'N','021','DEN','2013537','33348TX002000201','2014-02-01','2014-01-03 19:42:28','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-05 00:00:35'),(8006,6336,'Y','18','021','EC','A','','','AC','0000836287','0000836287','TX00000818197','IL','1','Patel','Rajendra','','','','34','634288713','508 S GREER BLVD',0,'PITTSBURG','TX','75686','1744','CY','48063','1954-09-29','M','M',':RET:2029-7','N','021','DEN','1664646','33348TX002000101','2014-01-01','2013-12-20 14:03:46','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 03:08:30'),(16528,13222,'N','01','021','EC','A',NULL,NULL,'','0001023306','0001134270','','IL','1','Clark','Leo','A','','','34','455114184','409 COUNTY ROAD 3074',0,'CENTER','TX','75935','5668','CY','48419','1959-03-18','M','',':RET:2106-3','T','021','DEN','2533845','33348TX002000201','2014-02-01','2014-01-05 16:35:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-07 10:21:58'),(17621,14087,'Y','18','021','EC','A','','','AC','0000606665','0000606665','TX00002534728','IL','1','Garcia','Elloytha','','','','34','463896276','821 w. abram st.',0,'Arlington','TX','76013',NULL,'CY','48439','1987-09-17','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2643325','33348TX002000201','2014-02-01','2014-01-13 13:36:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-14 01:32:27'),(27421,21700,'Y','18','021','EC','A','','','AC','0001781693','0001781693','LA00003503235','IL','1','Parker','Madison','','','','34','425690027','7819 Dominican Street',0,'New Orleans','LA','70118',NULL,'CY','22071','1990-01-21','F','U',':RET:2106-3','N','021','DEN','3921614','18575LA002000201','2014-04-01','2014-03-03 18:37:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:39'),(28213,22324,'N','01','021','EC','A',NULL,NULL,'','0001062169','0000258209','','IL','1','Gonzales','Carlos','','','','34','596280962','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','1978-01-19','M','',NULL,'N','021','HLT','4072223','52664OH151001304','2014-04-01','2014-03-06 12:51:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','274.30','CIC',0,'2014-03-06 21:30:15'),(2504,2039,'N','01','021','EC','A',NULL,NULL,'','0000161576','0000208237','','IL','1','Pevey','Donna','','','','34','433944964','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1953-09-12','F','',':RET:2106-3','N','021','DEN','377343','18575LA002000201','2014-01-01','2013-12-09 17:52:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:36:05'),(3104,2494,'Y','18','021','EC','A','','','AC','0001244139','0001244139','OH00000045146','IL','1','Dawson','Lavonne','','','','34','274682390','245 HALL ST',0,'TIFFIN','OH','44883','1417','CY','39147','1961-07-26','F','U',':RET:2106-3','N','021','HLT','292408','92036OH003002706','2014-01-01','2013-12-06 10:20:08','340.00',NULL,NULL,'397.49','57.49','R-OH006','OH0','397.49',NULL,0,'2013-12-25 20:20:22'),(16171,12947,'Y','18','021','EC','A','','','AC','0002158528','0002158528','LA00001593565','IL','1','Hurst','Meshonda','','','','34','437712956','2734 TIFTON ST',0,'KENNER','LA','70062','5218','CY','22051','1988-05-23','F','U',NULL,'N','021','DEN','2405431','18575LA002000201','2014-02-01','2014-01-03 20:59:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-05 00:00:14'),(23654,18835,'Y','18','021','EC','A','','','AC','0000201994','0000201994','TX00002353792','IL','1','Nguyen','Dung','','','','34','635296884','6314 NOTTOWAY CT',0,'FRISCO','TX','75035','7738','CY','48085','1993-02-04','F','U',':RET:2047-9','N','021','DEN','3551440','33348TX002000201','2014-03-01','2014-02-14 00:55:25','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:16'),(23569,18777,'Y','18','021','EC','A','','','AC','0000290846','0000290846','OH00002213722','IL','1','Delaney','Regina','Frances','','','34','406133915','14 AMELIA OLIVE BRANCH RD',0,'AMELIA','OH','45102','1543','CY','39025','1964-12-09','F','U',':RET:2106-3','N','021','HLT','3048270','92036OH002000601','2014-03-01','2014-02-13 10:46:56','294.00',NULL,NULL,'422.94','128.94','R-OH005','OH0','422.94',NULL,0,'2014-02-13 22:02:50'),(20706,16546,'Y','18','021','EC','A','','','AC','0001323675','0001323675','LA00002206071','IL','1','castleberry','heather','','','','34','446840531','12063 CROSSETT RD',0,'BASTROP','LA','71220','7699','CY','22067','1985-01-04','F','M',':RET:2106-3','N','021','DEN','3080726','18575LA002000201','2014-03-01','2014-01-30 12:26:36','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-01-30 21:01:06'),(22413,17896,'Y','18','021','EC','A','','','AC','0002142121','0002142121','LA00001490038','IL','1','cann','arabella','','','','34','434040535','3806 DEBORAH DR',0,'MONROE','LA','71201','2112','CY','22073','1958-05-01','F','U',':RET:2106-3','N','021','DEN','2752026','18575LA002000201','2014-03-01','2014-02-10 11:08:01','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-10 21:30:26'),(21568,17229,'Y','18','021','EC','A','','','AC','0001111693','0001111693','OH00002146264','IL','1','Weiss','Lyn','','','','34','276569271','2405 Shadow Lane',0,'Stow','OH','44224',NULL,'CY','39153','1954-03-18','F','M',':RET:2106-3','N','021','HLT','3517615','52664OH151001305','2014-03-01','2014-02-04 20:47:53','809.00',NULL,NULL,'1128.03','319.03','R-OH012','OH0','580.49',NULL,0,'2014-02-05 21:30:20'),(27839,22020,'Y','18','021','EC','A','','','AC','0000305556','0000305556','TX00002616504','IL','1','FISH','KERI','','','','34','563797044','1107 SPUR TRL',0,'GRANBURY','TX','76049','5657','CY','48221','1972-02-02','F','U',':RET:2106-3','T','021','DEN','3891954','33348TX002000101','2014-04-01','2014-03-04 18:46:07','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-03-05 21:32:06'),(28463,22522,'Y','18','021','EC','A','','','AC','0000512015','0000512015','OH00003159976','IL','1','Mallardi','Chloe','','','','34','283946661','1171 PITKIN AVE',0,'AKRON','OH','44310','1120','CY','39153','1991-08-05','F','U',':RET:2106-3','N','021','DEN','3652089','99734OH005000301','2014-04-01','2014-03-06 20:27:00','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-07 21:31:27'),(1641,1371,'Y','18','021','EC','A','','','AC','0000629407','0000629407','TX00000430998','31','1','Allam','Dean','','','','34','460217300','P.O Box 2256',0,'Fulton','TX','78358',NULL,'CY','48007','1955-09-08','M','U',':RET:2106-3','N','021','DEN','2240622','33348TX002000201','2014-01-01','2013-12-24 15:29:51','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-25 18:53:04'),(24629,19546,'N','19','021','EC','A',NULL,NULL,'','0001888236','0002395689','','IL','1','CAREY','JARIUS','J','','','34','437859923','36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1992-11-25','M','',':RET:2054-5','N','021','DEN','2875540','18575LA002000201','2014-04-01','2014-02-19 09:07:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-20 04:17:41'),(23575,18782,'N','01','021','EC','A',NULL,NULL,'','0001125480','0001148767','','IL','1','Mohr','Bryan','','','','34','270764701','4760 Co. Rd. 3',0,'Swanton','OH','43558',NULL,'CY','39051','1969-04-30','M','',':RET:2106-3','N','021','HLT','3098417','92036OH003002605','2014-03-01','2014-02-13 14:37:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','284.48',NULL,0,'2014-02-13 22:02:54'),(13160,10498,'Y','18','021','EC','A','','','AC','0000817539','0000817539','OH00000295259','IL','1','iding','catherine','ann','','','34','275507865','1402 POST WOODS GLN',0,'BATAVIA','OH','45103','3609','CY','39025','1951-02-09','F','U',':RET:2106-3','T','021','DEN','2068374','99734OH005000401','2014-01-01','2013-12-23 17:19:55','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 12:53:49'),(6107,4841,'Y','18','021','EC','A','','','AC','0000761073','0000761073','OH00000404817','IL','1','Stivaletti','Anthony','','','','34','006668312','60 E. Spring St.',0,'Columbus','OH','43215',NULL,'CY','39049','1967-04-20','M','U',':RET:2106-3','N','021','DEN','456568','99734OH005000401','2014-01-01','2013-11-21 14:22:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:15:20'),(6923,5495,'Y','18','021','EC','A','','','AC','0001126873','0001126873','OH00000278532','IL','1','Audette','Kristina','','','','34','008700303','209 Ramblewood Court',0,'Fairfield','OH','45014',NULL,'CY','39017','1984-12-12','F','U',':RET:2106-3','T','021','DEN','2515696','99734OH005000401','2014-01-01','2013-12-24 19:03:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:16'),(16959,13573,'N','01','021','EC','A',NULL,NULL,'','0001024293','0000801280','','IL','1','James','Janel','K','','','34','293509819','943 WYE DR',0,'AKRON','OH','44303','1118','CY','39153','1954-04-15','F','',':RET:2106-3','T','021','HLT','2262952','52664OH151001305','2014-02-01','2014-01-09 08:33:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','667.56',NULL,0,'2014-01-13 02:20:05'),(20919,16720,'Y','18','021','EC','A','','','AC','0000710173','0000710173','OH00001863969','IL','1','McCarthy','William',NULL,NULL,NULL,NULL,NULL,'204 E STREETSBORO ST',0,'HUDSON','OH','44236','3473','CY','39153','1949-10-19','M','R',':RET:2106-3','N','021','HLT','3747427','52664OH152000901','2014-03-01','2014-01-31 16:50:39','0.00',NULL,NULL,'490.00','490.00','R-OH012','OH0','490.00',NULL,0,'2014-01-31 21:01:31'),(26252,20822,'Y','18','021','EC','A','','','AC','0000044922','0000044922','TX00003251133','IL','1','ENRIQUE','JAIME','','','','34','449770215','3105 ROCK WALL LN',0,'EL PASO','TX','79936','2021','CY','48141','1947-03-12','M','M',':RET:2106-3','N','021','DEN','2873178','33348TX002000201','2014-04-01','2014-02-27 14:29:35','0.00',NULL,NULL,'16.22','16.22','R-TX009','TX0','16.22',NULL,0,'2014-02-28 06:31:09'),(14218,11337,'Y','18','021','EC','A','','','AC','0001057276','0001057276','TX00000413663','IL','1','Macias','Rosa','','','','34','464216067','1001 WEST ST',0,'GEORGETOWN','TX','78626','5536','CY','48491','1954-03-06','F','M',NULL,'N','021','DEN','2466313','33348TX002000201','2014-02-01','2013-12-26 16:27:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-27 02:04:39'),(24703,19612,'Y','18','021','EC','A','','','AC','0000172464','0000172464','OH00003048651','S1','1','tucker','christopher','','','','34','295117035','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2006-02-14','M','U',':RET:2106-3','N','021','DEN','3785204','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:34:26'),(1986,1625,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','604412','','2013-11-19','2013-11-19 23:05:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:50'),(21338,17053,'Y','18','024','14','A','','','TE','0000778219','0000778219','','IL','1','Jaquez','Jose',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-07-03','M','',NULL,NULL,NULL,'','3712024','','2014-02-03','2014-02-03 20:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:00:32'),(2157,1774,'Y','18','021','EC','A','','','AC','0000165310','0000165310','LA00000787059','IL','1','nielsen','freda','','','','34','439339808','5452 HIGHWAY 17',0,'WINNSBORO','LA','71295','5483','CY','22041','1964-06-02','F','M',':RET:2106-3','N','021','DEN','273378','18575LA002000101','2014-01-01','2013-12-10 16:20:36','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 19:18:45'),(17557,14038,'Y','18','024','14','A','','','TE','0000202912','0000202912','','IL','1','carrizales','Dustin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-31','M','',NULL,NULL,NULL,'','1671986','','2014-01-12','2014-01-12 14:52:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 03:01:58'),(5822,4624,'Y','18','021','EC','A','','','AC','0000842342','0000842342','TX00000599388','IL','1','Lam','Minhoai','','','','34','026603856','4211 MERRIWEATHER ST',0,'SUGAR LAND','TX','77478','5281','CY','48157','1960-09-30','M','M',':RET:2034-7','N','021','DEN','1471610','33348TX002000201','2014-01-01','2013-12-23 22:14:24','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:48:02'),(16329,13074,'Y','18','021','EC','A','','','AC','0001651005','0001651005','LA00001028102','IL','1','Nguyen','Hoa','','','','34','659120544','15762 RIVERDALE AVE E',0,'BATON ROUGE','LA','70816','1574','CY','22033','1960-06-02','F','M',NULL,'N','021','DEN','2282167','18575LA002000201','2014-02-01','2014-01-06 17:18:14','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:56'),(3313,2661,'N','01','021','EC','A',NULL,NULL,'','0000198559','0000877114','','IL','1','Latscha','Brian','','','','34','288701175','5542 KAREN AVE',0,'CINCINNATI','OH','45248','5207','CY','39061','1973-01-30','M','',':RET:2106-3','N','021','DEN','2587529','99734OH005000301','2014-01-01','2013-12-22 14:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:53'),(14781,11804,'Y','18','021','EC','A','','','AC','0000757147','0000757147','OH00001308927','IL','1','Thomas','Jessica','','','','34','288905063','2149 TRAILRIDGE DR',0,'CINCINNATI','OH','45215','3948','CY','39061','1984-12-03','F','U',':RET:2106-3','N','021','DEN','2251455','99734OH005000401','2014-01-01','2013-12-23 19:59:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:13:13'),(28209,22322,'Y','18','021','EC','A','','','AC','0000062924','0000062924','MS00003091804','IL','1','Tims','Denace','','','','34','428235904','1019 COMBS ST',0,'JACKSON','MS','39204','5305','CY','28049','1965-09-26','M','U',':RET:2054-5','N','021','DEN','3962020','46300MS002000101','2014-04-01','2014-03-06 17:06:39','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15','CIC',0,'2014-03-06 21:30:13'),(28554,22599,'N','19','021','EC','A',NULL,NULL,'','0000435371','0000889671','','IL','1','WALTERS','NICHOLAS','E','','','34','276151948','4821 MEREDITH RD',0,'YELLOW SPRINGS','OH','45387','9734','CY','39057','2009-02-23','M','',':RET:2106-3','N','021','HLT','3945359','92036OH006000501','2014-04-01','2014-03-07 12:55:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.71',NULL,0,'2014-03-07 21:32:23'),(249,207,'Y','18','021','EC','A','','','AC','0000018206','0000018206','LA00000752412','IL','1','Smith','Diane','S','','','34','435042585','1813 FLYNN ST',0,'MONROE','LA','71201','7103','CY','22073','1955-06-13','F','U',':RET:2054-5','N','021','DEN','964431','18575LA002000101','2014-01-01','2013-12-05 13:45:29','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 17:21:31'),(1274,1052,'Y','18','021','EC','A','','','AC','0000506123','0000506123','LA00000440931','IL','1','Herr','John','D','','','34','194488664','10950 Jefferson Hwy.',0,'River Ridge','LA','70123',NULL,'CY','22051','1963-08-26','M','U',':RET:2106-3','N','021','DEN','519712','18575LA002000201','2014-01-01','2013-11-28 20:20:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:30:22'),(13609,10851,'N','01','021','EC','A',NULL,NULL,'','0000796957','0000101429','','IL','1','Behrmann','Anthony','','','','34','288684519','9499 HADDINGTON CT',0,'CINCINNATI','OH','45251','2362','CY','39061','1975-03-31','M','',':RET:2106-3','N','021','HLT','1676823','92036OH002001201','2014-01-01','2013-12-22 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','308.91',NULL,0,'2013-12-26 13:05:34'),(6480,5132,'Y','18','024','14','A','','','TE','0000032932','0000032932','','IL','1','Carson','Jessie','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-05','M','',NULL,NULL,NULL,'','1192015','','2013-12-11','2013-12-11 09:47:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:50:18'),(20004,15953,'N','01','021','EC','A',NULL,NULL,'','0000354005','0000762323','','IL','1','Pieffer','Frank','','','','34','285866014','3881 W 227TH ST',0,'FAIRVIEW PARK','OH','44126','1031','CY','39035','1979-10-01','M','',':RET:2106-3','N','021','DEN','2594871','99734OH005000401','2014-03-01','2014-01-26 11:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:05'),(19583,15610,'Y','18','021','EC','A','','','AC','0001306121','0001306121','LA00001739350','IL','1','O\'Neil','John',NULL,NULL,NULL,NULL,NULL,'1311 HARMONY ST',0,'NEW ORLEANS','LA','70115','3424','CY','22071','1950-03-27','M','U',':RET:2106-3','N','021','DEN','2814113','18575LA002000201','2014-03-01','2014-01-22 12:57:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 03:02:41'),(19579,15607,'Y','18','021','EC','A','','','AC','0001228484','0001228484','LA00002447625','IL','1','Truong','Tu','','','','34','439897240','12003 DAWN AVE',0,'BATON ROUGE','LA','70815','2614','CY','22033','1979-06-16','M','M',NULL,'N','021','DEN','3243578','18575LA002000201','2014-03-01','2014-01-22 12:27:27','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-23 03:02:40'),(18646,14865,'Y','18','021','EC','A','','','AC','0000093582','0000093582','TX00002452457','IL','1','Barker','Joshua','','','','34','640058191','4017 PANAMA DR',0,'CORPUS CHRISTI','TX','78411','5020','CY','48355','1981-06-05','M','U',':RET:2106-3','N','021','DEN','2073132','33348TX002000201','2014-03-01','2014-01-16 01:25:09','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-17 03:35:08'),(17380,13906,'Y','18','021','EC','A','','','AC','0000053073','0000053073','OH00002092420','IL','1','KALTENECKER','THERESE','','','','34','289560530','810 KENWICK RD',0,'COLUMBUS','OH','43209','2515','CY','39049','1955-02-17','F','U',':RET:2106-3','N','021','DEN','2592981','99734OH005000401','2014-02-01','2014-01-09 21:47:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 03:00:05'),(15428,12343,'Y','18','021','EC','A','','','AC','0000569021','0000569021','TX00000609718','IL','1','Phan','Taylor','','','','34','561676630','5727 PERSIMMON DR',0,'TYLER','TX','75707','2062','CY','48423','1969-06-05','M','M',NULL,'N','021','DEN','2498318','33348TX002000201','2014-02-01','2013-12-31 12:06:18','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,1,'2014-01-02 04:27:39'),(29163,23083,'Y','18','021','EC','A','','','AC','0000394996','0000394996','OH00003381506','IL','1','GILLESPIE','JERRY','','','','34','275602396','2226 E ERIE AVE',0,'LORAIN','OH','44052','2318','CY','39093','1961-09-01','M','U',':RET:2106-3','N','021','HLT','3840182','92036OH005000804','2014-04-01','2014-03-10 14:04:11','200.00',NULL,NULL,'456.37','256.37','R-OH011','OH0','456.37',NULL,0,'2014-03-10 21:02:55'),(2372,1934,'Y','18','021','EC','A','','','AC','0000231480','0000231480','OH00001168292','IL','1','Conner','Chasity','','','','34','285963927','402 FOUR SEASONS DR',0,'MASON','OH','45040','1967','CY','39165','1993-08-04','F','R',':RET:2106-3','N','021','DEN','141745','99734OH005000401','2014-01-01','2013-12-09 09:31:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-25 19:32:45'),(9758,7728,'Y','18','021','EC','A','','','AC','0000575880','0000575880','OH00000790116','IL','1','Jones','Debra','','','','34','272565634','6610 GROVE LN',0,'PARMA','OH','44134','6960','CY','39035','1953-09-14','F','M',':RET:2106-3','N','021','DEN','481108','99734OH005000401','2014-01-01','2013-10-20 14:26:24','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 05:00:09'),(21342,17057,'Y','18','021','EC','A','','','AC','0000440765','0000440765','TX00001515518','IL','1','Halladay','Brandi','','','','34','645091342','2105 singing Wind Dr',0,'Kerrville','TX','78028',NULL,'CY','48265','1989-10-30','F','M',':RET:2106-3','T','021','DEN','2747941','33348TX002000201','2014-03-01','2014-02-03 21:49:16','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:33'),(9294,7368,'Y','18','021','EC','A','','','AC','0000854162','0000854162','OH00001118490','IL','1','Frazier','Daniel','','','','34','283509982','4524 Weiner Ln',0,'Cincinnati','OH','45244',NULL,'CY','39025','1965-11-25','M','U',':RET:2106-3','N','021','HLT','910873','92036OH006000601','2014-01-01','2013-11-30 12:02:31','0.00',NULL,NULL,'278.36','278.36','R-OH005','OH0','278.36',NULL,0,'2013-12-26 04:16:11'),(9042,7174,'Y','18','024','14','A','','','TE','0000142804','0000142804','','IL','1','Smithnosky','Christine','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-12-14','F','',NULL,NULL,NULL,'','54730','','2013-12-18','2013-12-18 15:27:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:50'),(8085,6401,'Y','18','024','14','A','','','TE','0000312175','0000312175','','IL','1','Smith','Sean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-10-15','M','',NULL,NULL,NULL,'','1471322','','2013-12-20','2013-12-20 15:07:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:30'),(8070,6391,'Y','18','021','EC','A','','','AC','0000752070','0000752070','OH00000228154','31','1','Gorsuch','Barbara','','','','34','271528383','6033 Van Wormer Dr',0,'Toledo','OH','43612',NULL,'CY','39095','1952-09-06','F','U',':RET:2106-3','T','021','HLT','1482401','92036OH006002601','2014-01-01','2013-12-20 16:59:57','340.00',NULL,NULL,'499.74','159.74','R-OH001','OH0','499.74',NULL,0,'2013-12-26 03:10:11'),(19188,15287,'Y','18','021','EC','A','','','AC','0001226755','0001226755','TX00002594484','IL','1','Manfroni','Michael','T','','','34','263754011','7120 San Mateo Blvd',0,'Dallas','TX','75223',NULL,'CY','48113','1971-09-22','M','M',':RET:2106-3','N','021','DEN','2825067','33348TX002000101','2014-03-01','2014-01-20 15:25:18','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-21 08:46:11'),(19062,15184,'Y','18','021','EC','A','','','AC','0000536294','0000536294','TX00001883916','IL','1','Perez Goiere','Abel','','','','34','635312208','111 PALENCIA AVE',0,'LAREDO','TX','78046','8400','CY','48479','1989-09-06','M','U',NULL,'N','021','DEN','3146087','33348TX002000201','2014-03-01','2014-01-18 17:52:27','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-21 08:44:15'),(6871,5449,'Y','18','021','EC','A','','','AC','0000904224','0000904224','OH00000760463','IL','1','del rio','carlos','','','','34','530191743','4695 MARBLEHEAD CT',0,'COLUMBUS','OH','43220','3454','CY','39049','1980-12-16','M','M',':RET:2054-5','N','021','DEN','156280','99734OH005000301','2014-01-01','2013-11-03 13:59:58','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:31:59'),(28732,22740,'Y','18','021','EC','A','','','AC','0001170986','0001170986','LA00003211771','IL','1','Tademy','Rose','','','','34','436042000','4110 BEECH ST',0,'BATON ROUGE','LA','70805','2903','CY','22033','1958-01-30','F','U',NULL,'N','021','DEN','3923167','18575LA002000101','2014-04-01','2014-03-09 14:28:32','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-09 21:00:04'),(29191,23103,'Y','18','021','EC','A','','','AC','0000076359','0000076359','OH00003531557','IL','1','Brooks','Maxine','','','','34','300487753','406 N. Second',0,'North Baltimore','OH','45872',NULL,'CY','39173','1950-03-15','F','M',':RET:2106-3','N','021','HLT','3447435','92036OH006002601','2014-04-01','2014-03-10 10:41:31','232.00',NULL,NULL,'463.92','231.92','R-OH001','OH0','463.92','CIC',0,'2014-03-10 21:30:05'),(13104,10448,'Y','18','021','EC','A','','','AC','0001166815','0001166815','OH00000023010','IL','1','SHANAHAN','TAMARA','','','','34','295649359','2263 NE CATAWBA RD',0,'PORT CLINTON','OH','43452','3529','CY','39123','1961-02-06','F','U',':RET:2106-3','N','021','DEN','1766748','99734OH005000401','2014-01-01','2013-12-23 13:05:07','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 12:52:15'),(19521,15559,'Y','18','021','EC','A','','','AC','0000221340','0000221340','OH00001653369','IL','1','Luca','Cassaundra','','','','34','302902439','14401 Triskett Road',0,'Cleveland','OH','44111',NULL,'CY','39035','1985-11-22','F','M',':RET:2106-3','N','021','DEN','3147586','99734OH005000401','2014-03-01','2014-01-22 09:53:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:02:18'),(19382,15450,'N','01','021','EC','A',NULL,NULL,'','0000067029','0000837458','','IL','1','Saltzman','Stephen','Junior-Duncan','','','34','641166164','2811 LA FRONTERA BLVD',0,'Austin','TX','78728',NULL,'CY','48453','1985-06-20','M','',':RET:2106-3','N','021','DEN','2673673','33348TX002000101','2014-03-01','2014-01-20 22:03:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,1,'2014-01-22 03:22:42'),(2070,1695,'Y','18','024','14','A','','','TE','0000753105','0000753105','','IL','1','Pierce','Joseph','Whittenton',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-29','M','',NULL,NULL,NULL,'','705504','','2013-12-09','2013-12-09 20:02:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:16:22'),(17897,14295,'Y','18','021','EC','A','','','AC','0000603384','0000603384','OH00002330419','IL','1','Griffith','Marsha','','','','34','284689668','4200 BAUMAN HILL RD SE',0,'LANCASTER','OH','43130','7924','CY','39045','1966-06-09','F','R',':RET:2106-3','N','021','DEN','1916395','99734OH005000401','2014-02-01','2014-01-14 17:31:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:22'),(16109,12903,'Y','18','021','EC','A','','','AC','0000030517','0000030517','MS00002096618','IL','1','BATTLES','TIMOTHY','','','','34','411475978','13107 BRAYBOURNE PL S',0,'OLIVE BRANCH','MS','38654','6531','CY','28033','1973-10-12','M','U',NULL,'N','021','DEN','1382373','46300MS002000101','2014-02-01','2014-01-03 11:43:53','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-04 02:05:00'),(15257,12195,'Y','18','021','EC','A','','','AC','0000251629','0000251629','OH00001447285','IL','1','barnette','sarah','','','','34','297509896','381 N ENON RD',0,'YELLOW SPRINGS','OH','45387','9764','CY','39057','1950-03-04','F','R',':RET:2106-3','T','021','HLT','2078835','92036OH004000501','2014-02-01','2013-12-30 14:33:49','0.00',NULL,NULL,'648.86','648.86','R-OH003','OH0','648.86',NULL,0,'2014-01-01 12:09:09'),(6302,4999,'Y','18','024','14','A','','','TE','0001066955','0001066955','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','973603','','2013-12-11','2013-12-11 09:42:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:45:57'),(15204,12151,'N','01','021','EC','A',NULL,NULL,'','0001225869','0000197703','','IL','1','ROBINSON','FRANK','','','','34','257133065','302 MAX COVE',0,'MADISON','MS','39110',NULL,'CY','28089','1963-03-18','M','',':RET:2106-3','N','021','DEN','1735247','46300MS002000201','2014-02-01','2013-12-30 13:16:22',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-01 12:07:30'),(4845,3839,'Y','18','021','EC','A','','','AC','0000690707','0000690707','OH00000706571','IL','1','Sarisky','Michael','','','','34','298441448','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1954-05-03','M','M',':RET:2106-3','N','021','DEN','424131','99734OH005000401','2014-01-01','2013-11-08 09:36:39','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 22:30:13'),(15046,12027,'Y','18','021','EC','A','','','AC','0001988734','0001988734','LA00001577493','IL','1','Turner','Janice','','','','34','436043236','24853 EUBANKS LN',0,'CLINTON','LA','70722','5653','CY','22033','1959-05-07','F','M',':RET:2054-5','N','021','DEN','1649980','18575LA002000201','2014-02-01','2013-12-30 13:42:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:07'),(5677,4504,'Y','18','021','EC','A','','','AC','0000417157','0000417157','MS00000153635','IL','1','HOWARD','EUGENE','EDWARD','','','34','428811584','900 ROSE ST.',0,'GREENWOOD','MS','38930',NULL,'CY','28083','1996-09-06','M','U',':RET:2054-5','N','021','DEN','132647','46300MS001000101','2014-01-01','2013-11-25 21:31:38','0.00',NULL,NULL,'47.10','47.10','R-MS006','MS0','47.10',NULL,0,'2013-12-25 23:32:13'),(25263,20042,'Y','18','021','EC','A','','','AC','0001107788','0001107788','TX00002561254','IL','1','moreno','katanna','lee','','','34','632321715','318 ESCALON AVE',0,'SAN ANTONIO','TX','78221','1719','CY','48029','1993-01-31','F','M',':RET:2106-3','N','021','DEN','2949148','33348TX002000101','2014-04-01','2014-02-22 15:29:30','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02','CIC',0,'2014-02-22 19:00:14'),(27267,21591,'Y','18','021','EC','A','','','AC','0001968384','0001968384','LA00002993445','IL','1','Mitchell','Matthew','','','','34','434655121','208 N LOPEZ ST',0,'NEW ORLEANS','LA','70119','5428','CY','22071','1984-11-28','M','U',':RET:2054-5','N','021','DEN','3508773','18575LA002000101','2014-04-01','2014-03-04 14:28:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-04 21:00:13'),(27378,21676,'N','01','021','EC','A',NULL,NULL,'','0000302878','0000172901','','IL','1','ngo','man','minh','','','34','266932191','7412 OLD FORT BAYOU RD',0,'OCEAN SPRINGS','MS','39564','8195','CY','28059','1962-12-14','M','',':RET:2047-9','N','021','DEN','3947696','46300MS002000101','2014-04-01','2014-03-04 13:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-04 21:01:19'),(27543,21786,'N','19','021','EC','A',NULL,NULL,'','0000669236','0001077817','','S3','1','STITT','PAUL','','','','34','299026732','407 INDIANA AVE',0,'MC DONALD','OH','44437','1923','CY','39155','1998-06-20','F','',':RET:2106-3','N','021','DEN','3976455','99734OH005000401','2014-04-01','2014-03-04 11:45:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:07'),(28423,22491,'Y','18','021','EC','A','','','AC','0000870690','0000870690','OH00002768191','IL','1','Moritz','Pamela','J','','','34','294506969','2501 VESTAL RD',0,'YOUNGSTOWN','OH','44509','1460','CY','39099','1958-01-28','F','M',':RET:2106-3','T','021','DEN','3579615','99734OH005000401','2014-04-01','2014-03-07 14:28:22','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-03-07 21:31:04'),(28908,22882,'Y','18','021','EC','A','','','AC','0000671765','0000671765','OH00002667225','IL','1','ALLISON','JACK','','','','34','302580945','966 KELLY AVE',0,'AKRON','OH','44306','3120','CY','39153','1958-04-22','M','U',':RET:2106-3','T','021','DEN','4026376','99734OH005000301','2014-04-01','2014-03-09 19:44:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:00:25'),(532,434,'Y','18','021','EC','A','','','AC','0000869506','0000869506','MS00000919840','IL','1','Johnson','Lakeishia','','','','34','426238768','237 Baker Lane',0,'Brandon','MS','39047',NULL,'CY','28121','1974-09-26','F','M',':RET:2054-5','N','021','DEN','400413','46300MS002000201','2014-01-01','2013-12-03 23:35:26','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 17:49:29'),(25061,19874,'Y','18','021','EC','A','','','AC','0001103487','0001103487','OH00002615084','IL','1','JOHNSTON','GERALD','','','','34','270521455','15115 MONTROSE AVE',0,'CLEVELAND','OH','44111','1137','CY','39035','1957-09-20','M','U',NULL,'N','021','DEN','2689975','99734OH005000401','2014-04-01','2014-02-20 13:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:01:24'),(2108,1728,'N','01','021','EC','A',NULL,NULL,'','0000283231','0000457793','','IL','1','Harris','Amy','','','','34','278745500','2594 BRUNSWICK LN',0,'HUDSON','OH','44236','1475','CY','39153','1978-10-15','F','',':RET:2106-3','N','021','DEN','846515','99734OH005000401','2014-01-01','2013-12-10 10:21:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:17:21'),(23464,18691,'Y','18','021','EC','A','','','AC','0000160460','0000160460','TX00001950600','IL','1','GONZALAS','PRISCA','','','','34','456938356','310 E TRIPP RD',0,'SUNNYVALE','TX','75182','9591','CY','48113','1965-01-18','F','M',NULL,'N','021','DEN','3007197','33348TX002000201','2014-03-01','2014-02-13 15:03:28','0.00',NULL,NULL,'112.74','112.74','R-TX008','TX0','15.85',NULL,0,'2014-02-13 22:01:44'),(18601,14830,'Y','18','021','EC','A','','','AC','0000535778','0000535778','OH00001399779','IL','1','Swiger','Dedra','','','','34','293787259','9795 N LENA PALESTINE RD',0,'CONOVER','OH','45317','9754','CY','39109','1966-08-19','F','U',NULL,'T','021','HLT','2738582','92036OH003000505','2014-02-01','2014-01-15 12:00:24','414.00',NULL,NULL,'694.43','280.43','R-OH003','OH0','446.20',NULL,0,'2014-01-16 08:47:19'),(5459,4336,'N','01','021','EC','A',NULL,NULL,'','0000159404','0001205810','','IL','1','Sengstock','Cindy','F','','','34','283563743','2704 Arbor Glen Drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1957-01-26','F','',':RET:2106-3','N','021','HLT','2448398','52664OH151001501','2014-01-01','2013-12-19 15:29:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','624.00',NULL,0,'2013-12-25 23:10:21'),(16383,13110,'Y','18','021','EC','A','','','AC','0000676287','0000676287','TX00001707590','IL','1','Guerrero','Rita','','','','34','457533145','2705 LOGAN AVE',0,'LAREDO','TX','78040','5425','CY','48479','1965-05-27','F','U',NULL,'N','021','DEN','1390724','33348TX002000201','2014-02-01','2014-01-05 20:07:13','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-07 04:03:23'),(15887,12721,'Y','18','021','EC','A','','','AC','0000731210','0000731210','OH00001375020','IL','1','folarin','orla','','','','34','065507851','1568 ashley court',0,'fairborn','OH','45324',NULL,'CY','39057','1956-02-02','F','U',':RET:2054-5','N','021','HLT','2567324','92036OH006000501','2014-02-01','2014-01-02 12:18:58','325.00',NULL,NULL,'459.42','134.42','R-OH003','OH0','459.42',NULL,0,'2014-01-03 02:05:36'),(14678,11718,'Y','18','021','EC','A','','','AC','0001238420','0001238420','MS00000825929','IL','1','MIKES','MONIQUE','','','','34','551170541','23 TIMBER RIDGE DR',0,'JACKSON','MS','39212','5163','CY','28049','1967-01-09','F','U',NULL,'T','021','DEN','2177130','46300MS002000201','2014-02-01','2013-12-27 19:13:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2013-12-29 11:08:28'),(13918,11100,'N','01','021','EC','A',NULL,NULL,'','0000273783','0000241520','','IL','1','Masters','Robert','V','','Jr','34','283462539','718 BARTLEY PL',0,'TOLEDO','OH','43609','3107','CY','39095','1949-03-12','M','',':RET:2106-3','N','021','HLT','2150784','92036OH003002605','2014-01-01','2013-12-22 21:59:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','610.89',NULL,0,'2013-12-26 13:14:08'),(7393,5852,'N','01','021','EC','A',NULL,NULL,'','0000172370','0000353933','','IL','1','Smith','John','','','','34','302645918','685 East Main Street',0,'Williamsburg','OH','45176',NULL,'CY','39025','1959-09-14','M','',':RET:2106-3','N','021','HLT','517143','92036OH001000601','2014-01-01','2013-11-23 17:23:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','552.84',NULL,0,'2013-12-26 02:16:13'),(25684,20377,'Y','18','021','EC','A','','','AC','0000699071','0000699071','MS00002936212','IL','1','Piantanida','Robby','','','','34','641285910','133 MILLSAPS AVE',0,'JACKSON','MS','39202','1408','CY','28049','1988-03-12','M','U',':RET:2106-3','N','021','DEN','2845593','46300MS002000201','2014-04-01','2014-02-24 13:40:59','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:06'),(5036,3988,'Y','18','021','EC','A','','','AC','0000317317','0000317317','OH00000719727','31','1','Minge','Donna','Jean','','','34','280540544','p.o box 155',0,'Port William','OH','45164',NULL,'CY','39027','1951-03-04','F','M',':RET:2106-3','N','021','HLT','283194','92036OH002000601','2014-01-01','2013-12-07 11:55:13','414.00',NULL,NULL,'712.24','298.24','R-OH005','OH0','712.24',NULL,0,'2013-12-25 22:47:52'),(23506,18724,'Y','18','021','EC','A','','','AC','0000088637','0000088637','TX00002629300','IL','1','Willis','Kimberly','','','','34','453672909','2503 Panagrad',0,'Houston','TX','77082',NULL,'CY','48201','1980-12-05','F','U',':RET:2054-5','N','021','DEN','3662935','33348TX002000101','2014-03-01','2014-02-13 12:17:17','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-13 22:02:11'),(6232,4940,'Y','18','021','EC','A','','','AC','0001079104','0001079104','TX00001161885','31','1','REED','CAROLYN','','','','34','464049062','P.O. BOX 1011',0,'WHITEHOUSE','TX','75791',NULL,'CY','48423','1956-06-08','F','M',':RET:2106-3','N','021','DEN','719684','33348TX002000101','2014-01-01','2013-11-19 12:15:01','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-26 00:31:28'),(7380,5844,'N','01','021','EC','A',NULL,NULL,'','0000062503','0000669144','','IL','1','CLOSSON','GLORIA','','','','34','283503317','1284 S BREDEICK ST',0,'DELPHOS','OH','45833','2299','CY','39161','1951-04-24','F','',':RET:2106-3','N','021','DEN','144202','99734OH005000401','2014-01-01','2013-11-23 08:24:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:55'),(18732,14927,'N','19','021','EC','A',NULL,NULL,'','0000253078','0000662722','','S1','1','Winters','Camden',NULL,NULL,NULL,NULL,NULL,'6282 E US HIGHWAY 36',0,'CABLE','OH','43009','9625','CY','39021','2003-05-12','F','',':RET:2106-3','N','021','DEN','2107235','99734OH005000301','2014-03-01','2014-01-16 00:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:37'),(8009,6339,'Y','18','021','EC','A','','','AC','0000291875','0000291875','TX00001076277','31','1','DAILEY','JEANNE','','','','34','551962589','P.O. BOX 535',0,'INGRAM','TX','78025',NULL,'CY','48265','1955-03-20','F','U',':RET:2106-3','N','021','DEN','2247691','33348TX002000101','2014-01-01','2013-12-20 16:02:02','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 03:08:35'),(16353,13089,'Y','18','021','EC','A','','','AC','0000568041','0000568041','OH00001272527','IL','1','BADER','NORMA','','','','34','271845164','22685 BARD AVE',0,'FAIRVIEW PARK','OH','44126','2908','CY','39035','1977-07-03','F','U',NULL,'N','021','DEN','2467785','99734OH005000301','2014-02-01','2014-01-06 14:09:48','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-07 04:02:34'),(22365,17860,'Y','18','024','14','A','','','TE','0000713662','0000713662','','IL','1','Newman','Neil',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-01','M','',NULL,NULL,NULL,'','3249125','','2014-02-28','2014-02-10 14:38:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-10 21:00:10'),(22702,18128,'Y','18','021','EC','A','','','AC','0000070841','0000070841','TX00001486149','31','1','Davis','Maria','de Los Angeles','','','34','547612361','PO Box 623',0,'Sebastian','TX','78594',NULL,'CY','48489','1979-09-05','F','U',':RET:2106-3','N','021','DEN','3043136','33348TX002000101','2014-03-01','2014-02-11 15:46:05','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-11 21:00:59'),(28165,22288,'Y','18','021','EC','A','','','AC','0000342784','0000342784','OH00003416440','IL','1','JAMES','MICHAEL','WAYNE','','','34','302644386','221 WASHINGTON AVE',0,'GREENVILLE','OH','45331',NULL,'CY','39037','1964-03-28','M','U',':RET:2106-3','N','021','HLT','3467293','92036OH003000501','2014-04-01','2014-03-06 11:48:31','153.00',NULL,NULL,'443.34','290.34','R-OH003','OH0','443.34',NULL,0,'2014-03-06 21:02:45'),(5282,4185,'Y','18','021','EC','A','','','AC','0000908016','0000908016','OH00000888459','IL','1','Carpenter','Cynthia','Marie','','','34','289869101','4795 VENUS RD',0,'UNIONTOWN','OH','44685','9675','CY','39153','1982-05-03','F','U',':RET:2106-3','N','021','HLT','1836140','52664OH151001305','2014-01-01','2013-12-19 14:44:59','155.00',NULL,NULL,'258.47','103.47','R-OH012','OH0','258.47',NULL,0,'2013-12-25 23:05:47'),(25212,19997,'N','19','021','EC','A',NULL,NULL,'','0000471066','0001073202','','IL','1','Thrasher','Carrie',NULL,NULL,NULL,NULL,NULL,'7609 ROAD 82',0,'PAYNE','OH','45880','9518','CY','39125','1997-09-16','F','',':RET:2106-3','N','021','DEN','3518034','99734OH005000301','2014-04-01','2014-02-21 12:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:51'),(13803,11017,'Y','18','021','EC','A','','','AC','0000158440','0000158440','MS00000572373','IL','1','Skolnik','Randall','','','','34','435023293','14111 LEMOYNE BLVD',0,'BILOXI','MS','39532','9308','CY','28059','1957-10-22','M','U',':RET:2106-3','N','021','DEN','2507919','46300MS002000101','2014-01-01','2013-12-23 18:49:25','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-26 13:11:24'),(6715,5325,'Y','18','021','EC','A','','','AC','0001036099','0001036099','OH00000009277','IL','1','Kowalski','Kelly','','','','34','284883337','3829 WILLYS PKWY',0,'TOLEDO','OH','43612','1214','CY','39095','1978-11-18','F','U',NULL,'N','021','HLT','38273','92036OH001002601','2014-01-01','2013-11-05 16:19:07','1.00',NULL,NULL,'287.41','286.41','R-OH001','OH0','287.41',NULL,0,'2013-12-26 01:02:24'),(15892,12725,'Y','18','021','EC','A','','','AC','0000472274','0000472274','OH00001363424','IL','1','ROZACK','AUDREY','','','','34','302487856','5099 WHITE PINE DR',0,'BRUNSWICK','OH','44212',NULL,'CY','39103','1951-07-21','F','U',':RET:2106-3','T','021','HLT','2125264','52664OH152000901','2014-02-01','2014-01-02 12:32:45','508.00',NULL,NULL,'539.67','31.67','R-OH012','OH0','539.67',NULL,0,'2014-01-03 02:05:47'),(26895,21315,'Y','18','021','EC','A','','','AC','0000138155','0000138155','TX00002657082','IL','1','Olive','Robert','','','','34','467173182','5 WALNUT',0,'ROCKPORT','TX','78382','7901','CY','48007','1956-08-14','M','U',':RET:2106-3','N','021','DEN','3394397','33348TX002000201','2014-04-01','2014-03-01 19:16:24','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-03-03 01:00:05'),(27025,21403,'N','01','021','EC','A',NULL,NULL,'','0000592211','0000950732','','IL','1','GREEN','JAMES','','','','34','285808025','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1974-06-27','M','',':RET:2106-3','T','021','DEN','3725480','99734OH005000301','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:13'),(27285,21605,'Y','18','021','EC','A','','','AC','0001257046','0001257046','TX00003301325','IL','1','Torres','Maryleen','Lisset','','','34','645167398','17411 RUSTIC PINE TRL',0,'HOUSTON','TX','77090','2034','CY','48201','1976-12-27','F','U',':RET:2106-3','N','021','DEN','3700761','33348TX002000201','2014-04-01','2014-03-04 00:02:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:24'),(27628,21853,'Y','18','021','EC','A','','','AC','0000624033','0000624033','OH00003325541','IL','1','PULJIC','PAUL','','','','34','290680808','339 CRESTWOOD AVE',0,'AKRON','OH','44302',NULL,'CY','39153','1964-01-14','M','U',NULL,'N','021','DEN','3147144','99734OH005000401','2014-04-01','2014-03-04 20:33:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:30:09'),(28278,22378,'Y','18','021','EC','A','','','AC','0000500463','0000500463','OH00003784590','IL','1','Cunningham','Anthony','','','','34','294869900','4643 BLUEJAY CT',0,'CINCINNATI','OH','45244','1178','CY','39025','1980-08-13','M','M',':RET:2106-3','N','021','HLT','4242423','92036OH001000601','2014-04-01','2014-03-07 09:32:12','357.00',NULL,NULL,'768.54','411.54','R-OH005','OH0','310.20','CIC',0,'2014-03-07 21:00:24'),(29085,23021,'Y','18','021','EC','A','','','AC','0000313389','0000313389','TX00003252874','IL','1','Case','Michael','Drew','','','34','499647946','318 FARGO ST',0,'HOUSTON','TX','77006','2018','CY','48201','1956-06-23','M','U',':RET:2106-3','N','021','DEN','3296019','33348TX002000101','2014-04-01','2014-03-09 21:26:34','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-10 21:02:06'),(1883,1539,'Y','18','021','EC','A','','','AC','0001058002','0001058002','OH00000055615','IL','1','Stachowiak','Sue','','','','34','288729816','2673 tremainsville road Apartment 202',0,'toledo','OH','43613',NULL,'CY','39095','1961-04-17','F','U',':RET:2106-3','T','021','HLT','2263790','92036OH006002601','2014-01-01','2013-12-24 15:38:23','336.00',NULL,NULL,'347.14','11.14','R-OH001','OH0','347.14',NULL,0,'2013-12-25 18:58:35'),(25337,20103,'Y','18','021','EC','A','','','AC','0002361877','0002361877','LA00003248509','IL','1','ADAMS','SUSIE','','','','34','433062222','2629 PRIVATEER BLVD',0,'BARATARIA','LA','70036','5770','CY','22051','1956-07-12','F','U',':RET:2054-5','T','021','DEN','3860112','18575LA002000201','2014-04-01','2014-02-25 15:13:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:22'),(14109,11244,'Y','18','021','EC','A','','','AC','0000702776','0000702776','OH00001433226','IL','1','Maxwell','Rob','','','','34','272985630','318 WILLIAMS ST',0,'TROY','OH','45373','3766','CY','39109','1994-10-25','M','U',':RET:2106-3','N','021','DEN','2040809','99734OH005000401','2014-02-01','2013-12-26 14:11:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2013-12-27 02:01:47'),(9465,7508,'N','01','021','EC','A',NULL,NULL,'','0000442168','0000417391','','IL','1','Pruner','Brenda','Fay','','','34','289723889','1091 CRESTVIEW DR',0,'CRESTLINE','OH','44827','9617','CY','39139','1961-09-04','F','',':RET:2106-3','N','021','DEN','2115751','99734OH005000401','2014-01-01','2013-12-21 09:23:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:18'),(6136,4866,'Y','18','021','EC','A','','','AC','0000126613','0000126613','LA00001068354','IL','1','barard','sharon','','','','34','434236625','300 la bau box549',0,'Baldwin','LA','70514',NULL,'CY','22101','1959-11-25','F','U',':RET:2054-5','N','021','DEN','22154','18575LA002000201','2014-01-01','2013-11-21 15:09:53','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 00:16:08'),(2198,1809,'Y','18','024','14','A','','','TE','0000819761','0000819761','','IL','1','Lee','Sheena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-10-21','F','',NULL,NULL,NULL,'','1188046','','2013-12-10','2013-12-10 11:54:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:19:57'),(14533,11596,'Y','18','021','EC','A','','','AC','0001072479','0001072479','MS00001180371','IL','1','Edwards','Amanda','','','','34','425631858','355 EASTWOOD AVE',0,'RIDGELAND','MS','39157','3515','CY','28089','1982-07-28','F','M',':RET:2106-3','N','021','DEN','1427233','46300MS002000201','2014-02-01','2013-12-26 23:54:04','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:37'),(14177,11303,'Y','18','021','EC','A','','','AC','0000811972','0000811972','TX00001431909','31','1','Orsini','Joel','','','','34','451653270','28836 OAKS ON THE WATER',0,'MONTGOMERY','TX','77356','3728','CY','48453','1983-06-14','M','R',':RET:2106-3','N','021','DEN','1720096','33348TX002000201','2014-02-01','2013-12-26 09:14:03','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-27 02:03:37'),(9459,7503,'Y','18','024','14','A','','','TE','0001133928','0001133928','','IL','1','Vivens','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-08-13','F','',NULL,NULL,NULL,'','181091','','2013-12-20','2013-12-20 23:28:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:34:11'),(16121,12913,'Y','18','021','EC','A','','','AC','0001500520','0001500520','LA00002242565','IL','1','CHERAMIE','RAY ANN','','','','34','435069176','513 CENTRAL AVE',0,'HOUMA','LA','70364','3015','CY','22109','1960-10-10','F','M',NULL,'N','021','DEN','2240901','18575LA002000101','2014-02-01','2014-01-03 12:04:03','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-04 02:05:24'),(9382,7440,'Y','18','024','14','A','','','TE','0000714613','0000714613','','IL','1','Jones','Mark',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-06-16','M','',NULL,NULL,NULL,'','1102207','','2013-12-20','2013-12-20 18:58:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:08'),(8901,7058,'Y','18','021','EC','A','','','AC','0000435283','0000435283','OH00001235450','IL','1','Waller','Debra','','','','34','278521991','4987 FARNHURST RD',0,'LYNDHURST','OH','44124','2356','CY','39035','1951-02-19','F','U',':RET:2106-3','N','021','DEN','2098354','99734OH005000401','2014-01-01','2013-12-17 19:19:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:02:17'),(4970,3946,'Y','18','021','EC','A','','','AC','0000023484','0000023484','TX00001214073','IL','1','Resendis','Jose','','','','34','637097540','914 Virgil Ave',0,'Lufkin','TX','75901',NULL,'CY','48005','1989-10-08','M','U',NULL,'T','021','DEN','1176865','33348TX002000201','2014-01-01','2013-12-06 19:00:47','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:24'),(25128,19932,'Y','18','024','14','A','','','TE','0000273783','0000273783','','IL','1','Masters','Kathleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-04','F','',NULL,NULL,NULL,'','2150784','','2014-03-31','2014-02-21 13:01:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:24'),(22943,18291,'Y','18','021','EC','A','','','AC','0001148732','0001148732','OH00002249712','IL','1','GROTENRATH','DONNA','','','','34','396626977','480 bacon ave',0,'AKRON','OH','44320',NULL,'CY','39153','1953-01-17','F','U',':RET:2106-3','N','021','DEN','3787343','99734OH005000401','2014-03-01','2014-02-11 12:38:19','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-11 21:30:21'),(28000,22155,'N','01','021','EC','A',NULL,NULL,'','0000054528','0001018304','','IL','1','Earhart','Olivia','','','','34','283881097','4360 KALAMA CT',0,'CINCINNATI','OH','45236','3714','CY','39061','1987-02-19','F','',':RET:2106-3','N','021','DEN','3904985','99734OH005000401','2014-04-01','2014-03-05 19:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:08'),(6737,5344,'Y','18','021','EC','A','','','AC','0000176362','0000176362','OH00001260599','IL','1','GILHOOLY','Thomas','','','','34','237946998','2946 LINDALE AVE',0,'DAYTON','OH','45414','5521','CY','39113','1953-06-08','M','U',':RET:2106-3','N','021','DEN','199169','99734OH005000401','2014-01-01','2013-11-25 14:05:14','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:15:39'),(4853,3844,'N','01','021','EC','A',NULL,NULL,'','0000982667','0000085132','','IL','1','Stout','Debra','','','','34','181560602','515 S FOUNTAIN AVE',0,'SPRINGFIELD','OH','45506','2223','CY','39023','1960-01-25','F','',':RET:2054-5','N','021','DEN','848570','99734OH005000401','2014-01-01','2013-11-08 14:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:30:25'),(24663,19578,'Y','18','021','EC','A','','','AC','0000457850','0000457850','OH00002772976','IL','1','Graham','Sharon','','','','34','290522434','2318 Kenwood Blvd',0,'Toledo','OH','43606',NULL,'CY','39095','1952-07-01','F','U',NULL,'N','021','HLT','3280721','92036OH004002601','2014-04-01','2014-02-19 17:40:21','167.00',NULL,NULL,'440.60','273.60','R-OH001','OH0','440.60',NULL,0,'2014-02-20 04:25:54'),(25107,19915,'Y','18','021','EC','A','','','AC','0000389645','0000389645','TX00002501330','IL','1','SMITH','DONYA','R','','','34','465573699','7618 LEATHER MARKET ST',0,'HOUSTON','TX','77064','8223','CY','48201','1966-12-19','F','U',NULL,'N','021','DEN','3684637','33348TX002000201','2014-04-01','2014-02-21 15:31:05','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85','CIC',0,'2014-02-21 21:30:13'),(24305,19304,'N','01','021','EC','A',NULL,NULL,'','0001200874','0000674055','','IL','1','Bunton','Sabrina','','','','34','298542279','1135 STONER ST',0,'AKRON','OH','44320','3507','CY','39153','1955-05-12','F','',':RET:2054-5','N','021','HLT','3517969','52664OH152000901','2014-04-01','2014-02-18 16:35:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.19','CIC',0,'2014-02-18 21:30:22'),(21429,17126,'Y','18','021','EC','A','','','AC','0000967072','0000967072','TX00001396907','IL','1','Nolasco','Jose','R','','','34','644466297','3440 E Rosemeade Pkwy',0,'Carrollton','TX','75007',NULL,'CY','48121','1987-09-18','M','U',NULL,'N','021','DEN','3532670','33348TX002000101','2014-03-01','2014-02-03 21:05:42','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-04 21:01:17'),(23058,18384,'Y','18','021','EC','A','','','AC','0001453637','0001453637','LA00002525948','IL','1','Shugars','Kim','','','','34','587352508','18410 RIVER BEND RD',0,'MAUREPAS','LA','70449','5273','CY','22063','1965-03-13','F','M',NULL,'T','021','DEN','3058622','18575LA002000201','2014-03-01','2014-02-12 11:33:39','0.00',NULL,NULL,'43.83','43.83','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:50'),(24049,19127,'Y','18','021','EC','A','','','AC','0000509252','0000509252','OH00002510210','IL','1','GILBERT','FLORENCE','M','','','34','302805567','3795 W 140TH ST',0,'CLEVELAND','OH','44111','4902','CY','39035','1983-11-23','F','M',':RET:2054-5','N','021','DEN','3638616','99734OH005000301','2014-03-01','2014-02-15 11:20:58','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:01:03'),(27958,22118,'Y','18','021','EC','A','','','AC','0002060262','0002060262','LA00003512666','IL','1','LAWSON','MARTHA','','','','34','437065045','510 S 14TH ST',0,'PORT ALLEN','LA','70767',NULL,'CY','22121','1957-01-05','F','U',NULL,'N','021','DEN','3960574','18575LA002000201','2014-04-01','2014-03-05 18:26:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:43'),(28114,22251,'Y','18','021','EC','A','','','AC','0000968210','0000968210','OH00003324433','IL','1','MUSIL','MARY',NULL,NULL,NULL,NULL,NULL,'6810 CHIPPEWA ROAD',0,'MEDINA','OH','44256',NULL,'CY','39103','1961-11-28','F','M',':RET:2106-3','T','021','HLT','4105330','52664OH152000901','2014-04-01','2014-03-06 16:54:23','572.00',NULL,NULL,'767.71','195.71','R-OH012','OH0','366.67',NULL,0,'2014-03-06 21:02:17'),(744,616,'N','19','021','EC','A',NULL,NULL,'','0001241620','0000336400','','IL','1','Ibekwe','Theresa','','','','34','639841082','416 PECAN HOLLOW DR',0,'COPPELL','TX','75019','4848','CY','48113','1993-05-04','F','',':RET:2054-5','N','021','DEN','640755','33348TX002000201','2014-01-01','2013-12-16 00:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2013-12-25 18:04:08'),(14584,11639,'Y','18','021','EC','A','','','AC','0002138099','0002138099','LA00001158033','IL','1','Ohmer','Margie','','','','34','439311857','341 OAK ST',0,'DENHAM SPRINGS','LA','70726','2909','CY','22063','1961-09-25','F','U',':RET:2106-3','N','021','DEN','1701127','18575LA002000101','2014-02-01','2013-12-27 18:16:00','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-28 03:35:56'),(24809,19675,'Y','18','021','EC','A','','','AC','0000923361','0000923361','OH00002704436','IL','1','RIBY WILLIAMS','DONALD','','','','34','529211138','7808 MEADOWHAVEN BLVD',0,'COLUMBUS','OH','43235',NULL,'CY','39049','1951-12-24','M','U',NULL,'N','021','DEN','2894866','99734OH005000401','2014-04-01','2014-02-19 17:47:10','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:49:20'),(1606,1343,'Y','18','021','EC','A','','','AC','0001240358','0001240358','TX00000108851','IL','1','Collins','Tony','','','','34','241848749','511 MUSTANG TRL',0,'HARKER HEIGHTS','TX','76548','2339','CY','48027','1950-09-14','M','M',NULL,'N','021','DEN','1409309','33348TX002000201','2014-01-01','2013-12-24 13:01:17','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2013-12-25 18:52:10'),(9719,7698,'Y','18','021','EC','A','','','AC','0000087449','0000087449','OH00000124329','IL','1','Webb','Tasha','','','','34','159643926','83 LELAND AVE',0,'COLUMBUS','OH','43214','1511','CY','39049','1982-12-11','F','U',NULL,'N','021','DEN','1218501','99734OH005000401','2014-01-01','2013-11-15 14:52:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:45:24'),(19585,15612,'Y','18','021','EC','A','','','AC','0000113402','0000113402','MS00002206964','IL','1','Richardson','Brittney','','','','34','587695211','733 GRACE AVE',0,'HATTIESBURG','MS','39401','2927','CY','28035','1986-04-28','F','R',':RET:2054-5','N','021','DEN','3269817','46300MS002000201','2014-03-01','2014-01-22 09:37:28','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-23 03:02:42'),(19304,15388,'N','19','021','EC','A',NULL,NULL,'','0001634957','0001797050','','IL','1','Hemenway','Hayden','','','','34','438958073','59330 SEXTON DR',0,'PLAQUEMINE','LA','70764','6575','CY','22047','1997-07-08','M','',':RET:2106-3','N','021','DEN','2964841','18575LA002000101','2014-03-01','2014-01-21 13:00:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55',NULL,1,'2014-01-22 03:22:02'),(6665,5287,'Y','18','021','EC','A','','','AC','0000866366','0000866366','TX00000524634','IL','1','lau','yat','tung','','','34','463159520','12908 SCOFIELD FARMS DR',0,'AUSTIN','TX','78727','4589','CY','48453','1950-12-24','M','M',':RET:2034-7','N','021','DEN','522120','33348TX002000201','2014-01-01','2013-11-16 14:08:08','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:00:59'),(16134,12923,'N','19','021','EC','A',NULL,NULL,'','0000921927','0001152206','','IL','1','MILLIK','FAITH',NULL,NULL,NULL,NULL,NULL,'2090 HOWLAND WILSON RD',0,'CORTLAND','OH','44410','9485','CY','39155','1988-08-02','F','',':RET:2106-3','N','021','HLT','1792640','52664OH151001306','2014-02-01','2014-01-03 13:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.91',NULL,0,'2014-01-04 02:05:48'),(17160,13730,'Y','18','021','EC','A','','','AC','0001448410','0001448410','LA00001776674','IL','1','Saxton','Janice','','','','34','423907073','10550 Florida Boulevard',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1961-06-07','F','U',':RET:2054-5','N','021','DEN','2579122','18575LA002000201','2014-02-01','2014-01-08 11:28:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:22:01'),(5115,4053,'Y','18','021','EC','A','','','AC','0000775737','0000775737','TX00000610649','IL','1','Brand','William','J','','Jr','34','467883734','1805 COLLINS AVE',0,'WICHITA FALLS','TX','76301','5607','CY','48485','1950-07-03','M','U',NULL,'N','021','DEN','1852317','33348TX002000201','2014-01-01','2013-12-19 18:17:14','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 23:01:47'),(24696,19605,'Y','18','021','EC','A','','','AC','0000152036','0000152036','OH00002879971','S1','1','tucker','christopher','','','','34','291082360','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2003-11-27','M','U',':RET:2106-3','N','021','DEN','3730892','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:33:30'),(22929,18278,'Y','18','024','14','A','','','TE','0000108148','0000108148','','IL','1','Spehar','Vincent',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-06-29','M','',NULL,NULL,NULL,'','1660505','','2014-02-28','2014-02-11 05:25:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-11 21:30:09'),(20642,16494,'N','01','021','EC','A',NULL,NULL,'','0000941790','0000762413','','IL','1','Capiti','Tommy','','','','34','462191064','508 RITCHIE ST',0,'NACOGDOCHES','TX','75964','3508','CY','48347','1959-11-29','M','',NULL,'N','021','DEN','3458008','33348TX002000201','2014-03-01','2014-01-30 11:47:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:33'),(7247,5747,'Y','18','024','14','A','','','TE','0000463248','0000463248','','IL','1','Oettli','Albert','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-05-02','M','',NULL,NULL,NULL,'','984524','','2013-12-14','2013-12-14 15:33:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 02:01:49'),(1415,1177,'Y','18','021','EC','A','','','AC','0001574796','0001574796','LA00000630973','IL','1','Henton','Milton','','','','34','424964903','57 AUDUBON LAKE DR',0,'MANDEVILLE','LA','70471','8216','CY','22103','1966-09-19','M','R',NULL,'N','021','DEN','2096342','18575LA002000201','2014-01-01','2013-12-24 14:21:49','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:04'),(25266,20045,'Y','18','024','14','A','','','TE','0000288334','0000288334','','IL','1','Neal','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-06-27','F','',NULL,NULL,NULL,'','2767316','','2014-03-31','2014-02-22 16:13:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-22 19:00:15'),(6844,5425,'N','01','021','EC','A',NULL,NULL,'','0001179578','0000402421','','IL','1','Cantrell','Cassandra','','','','34','290088278','65 W Main St',0,'Sardinia','OH','45171',NULL,'CY','39071','1985-10-14','F','',':RET:2106-3','N','021','HLT','1117234','92036OH005000601','2014-01-01','2013-11-14 11:46:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.35',NULL,0,'2013-12-26 01:31:11'),(22301,17804,'Y','18','021','EC','A','','','AC','0000039840','0000039840','OH00001413447','IL','1','Ciraci','Matthew','','','','34','294922565','800 everhard rd. sw.',0,'North canton','OH','44709',NULL,'CY','39151','1988-12-23','M','U',':RET:2106-3','N','021','DEN','2790716','99734OH005000301','2014-03-01','2014-01-19 17:03:02','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-10 11:00:37'),(28237,22342,'Y','18','024','14','A','','','TE','0001165333','0001165333','','IL','1','Mann','Corey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-10-03','M','',NULL,NULL,NULL,'','1574385','','2014-03-31','2014-03-06 18:41:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:09'),(13652,10891,'Y','18','021','EC','A','','','AC','0002346003','0002346003','LA00000037589','IL','1','Barlow','Christi',NULL,NULL,NULL,NULL,NULL,'3014 SAINT PETER ST',0,'NEW ORLEANS','LA','70119','4033','CY','22071','1977-04-21','F','U',':RET:2054-5','N','021','DEN','2025904','18575LA002000101','2014-01-01','2013-12-22 21:42:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:20'),(26897,21317,'Y','18','021','EC','A','','','AC','0000819360','0000819360','TX00002582036','IL','1','Nguyen','Long','','','','34','629927040','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1988-05-31','M','M',':RET:2047-9','N','021','DEN','3871506','33348TX002000201','2014-04-01','2014-03-01 20:13:50','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-03 01:00:05'),(16598,13276,'Y','18','021','EC','A','','','AC','0001890796','0001890796','LA00001557107','IL','1','Swallow','David','','','','34','439754069','505 CROSLEY ST',0,'WEST MONROE','LA','71291','4223','CY','22073','1987-10-03','M','U',':RET:2106-3','N','021','DEN','1624955','18575LA002000201','2014-02-01','2014-01-07 11:18:08','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-08 18:24:03'),(24190,19216,'N','19','021','EC','A',NULL,NULL,'','0000047379','0000252387','','IL','1','TURNER','DRANDON','','','','34','629620694','2750 RED OAK DR',0,'GRAND PRAIRIE','TX','75052','4439','CY','48439','1998-04-21','M','',NULL,'N','021','DEN','2870835','33348TX002000101','2014-03-01','2014-02-15 23:14:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-02-16 19:00:13'),(19294,15380,'Y','18','021','EC','A','','','AC','0001767794','0001767794','LA00002183413','31','1','KNIGHT','JENNETTE','','','','34','434155035','P.O.BOX 1534',0,'AMITE','LA','70422',NULL,'CY','22105','1966-03-16','F','U',':RET:2054-5','N','021','DEN','1967890','18575LA002000201','2014-03-01','2014-01-21 17:48:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:57'),(22450,17924,'Y','18','021','EC','A','','','AC','0000859488','0000859488','TX00002027978','IL','1','HANCOCK','MARGARET','','','','34','467822574','4600 COUNTY ROAD 317',0,'MCKINNEY','TX','75069','1124','CY','48085','1950-12-16','F','U',':RET:2106-3','N','021','DEN','2919755','33348TX002000201','2014-03-01','2014-02-10 14:34:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-10 21:30:46'),(4492,3560,'N','01','021','EC','A',NULL,NULL,'','0001091546','0000045633','','IL','1','ALEMAN','JUAN','ALFREDO','','','34','450491508','2411 INGLESIDE DR',0,'SAN ANTONIO','TX','78213','3013','CY','48029','1957-07-19','M','',NULL,'N','021','DEN','591980','33348TX002000201','2014-01-01','2013-12-11 18:37:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:03:10'),(26207,20785,'Y','18','021','EC','A','','','AC','0001022836','0001022836','OH00002771711','IL','1','LING','CHERYL','','','','34','269643643','3756 Towhship Rd 90',0,'Killbuck','OH','44637',NULL,'CY','39075','1957-04-27','F','M',':RET:2106-3','T','021','HLT','3186304','52664OH151001305','2014-03-01','2014-02-27 11:44:00','370.00',NULL,NULL,'598.32','228.32','R-OH014','OH0','598.32',NULL,0,'2014-02-28 06:30:51'),(25574,20288,'Y','18','021','EC','A','','','AC','0000123023','0000123023','OH00002074345','IL','1','Hirn','Daniel','','','','34','302820358','410 E 3RD ST',0,'DELPHOS','OH','45833','1771','CY','39003','1974-09-20','M','M',':RET:2106-3','N','021','HLT','3347484','92036OH001001501','2014-04-01','2014-02-23 15:37:20','489.00',NULL,NULL,'1007.20','518.20','R-OH002','OH0','335.02',NULL,0,'2014-02-26 08:00:33'),(3232,2602,'Y','18','024','14','A','','','TE','0000149312','0000149312','','IL','1','steffen','kathy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-10','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:46:05'),(7563,5987,'Y','18','021','EC','A','','','AC','0001102074','0001102074','OH00001102146','IL','1','Hattar','Raymond',NULL,NULL,NULL,NULL,NULL,'3906 JEFFERSON LN',0,'AMELIA','OH','45102','1180','CY','39025','1979-08-07','M','M',NULL,'T','021','HLT','1174461','92036OH006000601','2014-01-01','2013-12-15 09:24:18','0.00',NULL,NULL,'435.00','435.00','R-OH005','OH0','237.68',NULL,0,'2013-12-26 02:33:34'),(26898,21317,'N','01','021','EC','A',NULL,NULL,'','0000819360','0000044935','','IL','1','Dinh','Ngoc','','','','34','806332289','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1990-10-03','F','',':RET:2047-9','N','021','DEN','3871506','33348TX002000201','2014-04-01','2014-03-01 20:13:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-03 01:00:06'),(23000,18336,'N','01','021','EC','A',NULL,NULL,'','0001078938','0001054257','','IL','1','Watkins','Amy','','','','34','299665397','7154 YOUNGSTOWN SALEM RD',0,'CANFIELD','OH','44406','8422','CY','39099','1967-04-24','F','',':RET:2106-3','N','021','DEN','3426568','99734OH005000301','2014-03-01','2014-02-12 12:47:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:18'),(22618,18061,'N','01','021','EC','A',NULL,NULL,'','0000981193','0000067117','','IL','1','NGUYEN','HOA','T','','','34','729262547','4101 s custer rd',0,'mckinney','TX','75070',NULL,'CY','48085','1962-10-01','F','',':RET:2047-9','N','021','DEN','2664550','33348TX002000201','2014-03-01','2014-02-10 20:00:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:08'),(22445,17922,'Y','18','021','EC','A','','','AC','0000448257','0000448257','TX00002120984','IL','1','Tran','Tiffany','','','','34','068767264','3711 CHADWELL GLEN LN',0,'HOUSTON','TX','77082','5010','CY','48201','1975-02-03','F','U',':RET:2047-9','N','021','DEN','3531838','33348TX002000201','2014-03-01','2014-02-10 13:53:37','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-10 21:30:44'),(26119,20714,'Y','18','021','EC','A','','','AC','0001241920','0001241920','OH00002075812','IL','1','Mattes','Jacob','','','','34','299924952','1684 bailey road',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1990-12-22','M','U',':RET:2106-3','T','021','DEN','2946735','99734OH005000401','2014-04-01','2014-02-26 23:18:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:18'),(27088,21445,'N','19','021','EC','A',NULL,NULL,'','0000436665','0000336485','','IL','1','Cook','Jacob','','','','34','279961524','305 WONDER LAKE DR',0,'AKRON','OH','44319','3853','CY','39153','1993-02-27','M','',':RET:2106-3','N','021','HLT','2796735','52664OH151001301','2014-04-01','2014-03-03 11:49:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-03-03 21:30:15'),(29157,23080,'Y','18','024','14','A','','','TE','0000258112','0000258112','','IL','1','Eaton','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-13','F','',NULL,NULL,NULL,'','2575970','','2014-03-31','2014-03-10 14:54:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:02:52'),(15776,12625,'Y','18','024','14','A','','','TE','0000276479','0000276479','','IL','1','VONG','DORA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-13','F','',NULL,NULL,NULL,'','1721249','','2014-01-02','2014-01-02 15:52:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-03 02:01:59'),(16314,13062,'Y','18','021','EC','A','','','AC','0001644951','0001644951','LA00002031928','IL','1','RICHARDSON','BARBARA','','','','34','022923657','2138 S COMMERCE AVE',0,'GONZALES','LA','70737','5711','CY','22005','1977-01-07','F','U',NULL,'N','021','DEN','2121601','18575LA002000201','2014-02-01','2014-01-06 16:33:04','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-07 04:01:31'),(18223,14544,'Y','18','021','EC','A','','','AC','0000522808','0000522808','TX00002274918','IL','1','LEE','PHILIP','VANCE','','','34','459376751','104 BRIDGEPOINT DR',0,'KINGSLAND','TX','78639','9610','CY','48299','1960-08-07','M','U',':RET:2106-3','T','021','DEN','2738560','33348TX002000201','2014-02-01','2014-01-14 19:36:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:14'),(19174,15275,'Y','18','021','EC','A','','','AC','0000542424','0000542424','TX00001485687','IL','1','BURKE','BOBETTE','','','','34','461192798','2524 RIDGMAR BLVD',0,'FORT WORTH','TX','76116',NULL,'CY','48439','1956-12-01','F','U',':RET:2106-3','N','021','DEN','3129212','33348TX002000201','2014-03-01','2014-01-20 12:37:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-21 08:46:04'),(19507,15548,'Y','18','021','EC','A','','','AC','0000257712','0000257712','TX00001442191','IL','1','DIAZ','SANDRA','ELIZABETH','','','34','628603763','5109 WYNDHAM CT',0,'GARLAND','TX','75043','7678','CY','48113','1974-04-27','F','M',NULL,'N','021','DEN','2681648','33348TX002000101','2014-03-01','2014-01-22 13:17:44','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-01-23 03:02:13'),(20860,16672,'N','19','021','EC','A',NULL,NULL,'','0001201924','0000893185','','IL','1','Destefano','Rachel','','','','34','284982322','3688 HEMPHILL RD',0,'NORTON','OH','44203','5020','CY','39153','1995-06-03','F','',NULL,'N','021','DEN','2817982','99734OH005000301','2014-03-01','2014-01-31 15:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:56'),(21574,17232,'Y','18','021','EC','A','','','AC','0000868269','0000868269','OH00001748925','IL','1','BROWNNEHLEN','DIANE','','','','34','276684578','2046 HAZEL ST NE',0,'HARTVILLE','OH','44632','8706','CY','39151','1959-06-18','F','M',':RET:2106-3','N','021','HLT','3164958','52664OH151001306','2014-03-01','2014-02-05 12:17:08','349.00',NULL,NULL,'476.12','127.12','R-OH015','OH0','476.12',NULL,0,'2014-02-05 21:30:22'),(23255,18540,'Y','18','024','14','A','','','TE','0001245562','0001245562','','IL','1','Lloyd','Anna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-16','F','',NULL,NULL,NULL,'','69003','','2014-02-28','2014-02-12 21:11:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:07'),(23670,18847,'Y','18','021','EC','A','','','AC','0000993936','0000993936','TX00002278520','IL','1','Mendoza','Sarah','','','','34','635090745','1704 Nelms Dr.',0,'Austin','TX','78744',NULL,'CY','48453','1987-07-13','F','U',NULL,'N','021','DEN','3323047','33348TX002000201','2014-03-01','2014-02-14 17:38:25','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-14 21:30:23'),(25364,20126,'Y','18','021','EC','A','','','AC','0000259284','0000259284','OH00002732629','IL','1','ELDRIDGE','NATHANIEL','','','','34','283846675','2810 INLAND DR',0,'MIDDLETOWN','OH','45042','3320','CY','39017','1984-08-16','M','M',NULL,'N','021','DEN','3848628','99734OH005000301','2014-04-01','2014-02-25 09:52:59','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:38'),(522,426,'N','01','021','EC','A',NULL,NULL,'','0001053027','0000637080','','IL','1','Shonebarger','Barbara','','','','34','282523698','1455 HILLBROOK DR NE',0,'LANCASTER','OH','43130','1106','CY','39045','1953-09-25','F','',':RET:2106-3','N','021','DEN','4951','99734OH005000301','2014-01-01','2013-12-04 11:20:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:49:14'),(6185,4901,'Y','18','021','EC','A','','','AC','0000544082','0000544082','OH00000813523','IL','1','McCarver','Floyd','','','','34','295660188','5992 RUIHLEY WAY',0,'WESTERVILLE','OH','43081','8084','CY','39049','1974-10-05','M','U',':RET:2054-5','N','021','DEN','496823','99734OH005000401','2014-01-01','2013-10-23 09:35:10','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:30:09'),(14191,11316,'Y','18','021','EC','A','','','AC','0000069341','0000069341','TX00000031890','IL','1','Edeline-Johnson','Terri','','','','34','200588970','14488 HILL TOP LN',0,'FRANKLIN','TX','77856','6215','CY','48395','1963-08-19','F','M',':RET:2106-3','N','021','DEN','1979369','33348TX002000201','2014-02-01','2013-12-26 12:50:48','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-27 02:03:59'),(1694,1413,'N','01','021','EC','A',NULL,NULL,'','0000096402','0000088562','','IL','1','Liu','Xiaoyan','','','','34','308257145','26693 Amberwood Dr.',0,'Perrysburg','OH','43551',NULL,'CY','39173','1973-09-01','F','',':RET:2034-7','N','021','HLT','2565943','92036OH004002601','2014-01-01','2013-12-24 07:13:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','200.38',NULL,0,'2013-12-25 18:54:30'),(18720,14922,'Y','18','021','EC','A','','','AC','0000084072','0000084072','OH00001370658','IL','1','Marcello-Johnson','Gina','','','','34','289703001','1381 PEBBLE CT',0,'CINCINNATI','OH','45255',NULL,'CY','39061','1970-10-13','F','M',NULL,'N','021','DEN','2779642','99734OH005000301','2014-02-01','2014-01-15 23:07:28','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:34'),(19375,15445,'Y','18','021','EC','A','','','AC','0000125479','0000125479','MS00002012182','IL','1','simpson','lc','','','','34','428083088','5880 midway rd',0,'jackson','MS','39211',NULL,'CY','28049','1963-06-10','M','U',':RET:2054-5','N','021','DEN','2739975','46300MS002000101','2014-03-01','2014-01-20 21:20:37','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-22 03:22:38'),(20762,16587,'N','19','021','EC','A',NULL,NULL,'','0000182328','0000889638','','IL','1','SIMONS','NATASHA','','','','34','272060744','1854 COUNTY ROAD 140',0,'VAN BUREN','OH','45889','9625','CY','39063','2000-08-11','F','',':RET:2106-3','N','021','HLT','2709173','92036OH003001501','2014-03-01','2014-01-30 13:54:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-01-30 21:01:35'),(21341,17056,'Y','18','021','EC','A','','','AC','0000818037','0000818037','TX00002192518','IL','1','Waddell','Vicki','','','','34','454064075','408 Burnell Circle',0,'WOODWAY','TX','76712',NULL,'CY','48309','1954-03-04','F','U',NULL,'N','021','DEN','2753260','33348TX002000201','2014-03-01','2014-02-03 20:56:59','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-02-04 21:00:33'),(27154,21499,'Y','18','021','EC','A','','','AC','0000934717','0000934717','OH00003007625','IL','1','Singh','Gurjant','','','','34','288066555','742 WESTERN ROW RD',0,'MASON','OH','45040','1445','CY','39165','1989-04-18','M','U',':RET:2029-7','N','021','DEN','3063756','99734OH005000401','2014-04-01','2014-03-03 14:51:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:54'),(5767,4581,'Y','18','021','EC','A','','','AC','0000692922','0000692922','OH00000307595','IL','1','Jenkins','Stephanie','','','','34','287808256','1637 FAVERSHAM DR',0,'COLUMBUS','OH','43228','4558','CY','39049','1979-12-04','F','U',':RET:2106-3','N','021','DEN','1678395','99734OH005000401','2014-01-01','2013-12-23 22:18:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:40'),(15906,12738,'Y','18','021','EC','A','','','AC','0000324849','0000324849','OH00001507446','IL','1','spencer','nancy','','','','34','289521143','8500 LIBERTY UNION RD',0,'VAN WERT','OH','45891','9319','CY','39161','1952-06-25','F','U',':RET:2106-3','N','021','HLT','2312201','92036OH005001501','2014-02-01','2014-01-01 21:06:20','365.00',NULL,NULL,'618.46','253.46','R-OH002','OH0','618.46',NULL,0,'2014-01-03 02:06:13'),(1104,908,'Y','18','021','EC','A','','','AC','0001250807','0001250807','OH00000570212','IL','1','RADER','ANNAMARIE','','','','34','293828407','3551 PLEASANT AVE',0,'HAMILTON','OH','45015',NULL,'CY','39017','1984-11-20','F','U',':RET:2106-3','N','021','DEN','2431','99734OH005000401','2014-01-01','2013-12-03 14:21:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:17:20'),(5381,4268,'Y','18','021','EC','A','','','AC','0002219354','0002219354','LA00000549418','IL','1','Lewis','Elease','','','','34','433271629','3220 SYBIL CT',0,'MARRERO','LA','70072','5942','CY','22051','1964-08-29','F','U',':RET:2054-5','N','021','DEN','2301550','18575LA002000201','2014-01-01','2013-12-19 15:39:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:21');
INSERT INTO `EdiParticipant` VALUES (3644,2916,'Y','18','021','EC','A','','','AC','0000385884','0000385884','OH00000787199','IL','1','TAYLOR','EVA','L','','','34','279505166','1111 INDEPENDENCE AVE',0,'AKRON','OH','44310',NULL,'CY','39153','1950-03-17','F','U',':RET:2054-5','N','021','DEN','391538','99734OH005000401','2014-01-01','2013-12-13 17:39:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:30:26'),(26684,21155,'Y','18','021','EC','A','','','AC','0001174959','0001174959','LA00002780379','IL','1','COLEMAN','DENISE','','','','34','436946922','2211 N BROAD ST',0,'NEW ORLEANS','LA','70119','1815','CY','22071','1955-12-02','F','U',':RET:2054-5','N','021','DEN','3413211','18575LA002000201','2014-04-01','2014-02-28 16:22:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:24'),(26915,21331,'Y','18','021','EC','A','','','AC','0000515884','0000515884','OH00003046213','IL','1','Dell','Jeffrey','','','','34','294905340','356 HAMPSHIRE DR',0,'HAMILTON','OH','45011','4840','CY','39017','1987-10-09','M','U',':RET:2054-5^:RET:2034-7','N','021','DEN','3134903','99734OH005000401','2014-04-01','2014-03-01 19:30:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 01:00:13'),(28752,22756,'Y','18','021','EC','A','','','AC','0000397440','0000397440','TX00002998082','IL','1','Saccente','Deborah','','','','34','550190482','4730 N MESA ST',0,'EL PASO','TX','79912','6140','CY','48141','1960-05-14','F','U',':RET:2106-3','T','021','DEN','3333789','33348TX002000201','2014-04-01','2014-03-08 23:52:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-09 21:00:17'),(904,750,'Y','18','021','EC','A','','','AC','0000895695','0000895695','OH00001218968','IL','1','Luu','Nhan','Thanh','','','34','370255656','12085 Brookston Dr',0,'Cincinnati','OH','45240','1350','CY','39061','1970-04-27','F','M',':RET:2047-9','N','021','HLT','2334579','92036OH004001201','2014-01-01','2013-12-16 13:17:58','0.00',NULL,NULL,'504.03','504.03','R-OH004','OH0','234.23',NULL,0,'2013-12-25 18:08:22'),(925,768,'Y','18','021','EC','A','','','AC','0000157957','0000157957','OH00000097521','IL','1','Petruc','Sam','','','','34','288840669','5301 SUNDANCE WAY',0,'BRUNSWICK','OH','44212','6472','CY','39103','1980-02-23','M','U',NULL,'N','021','DEN','979510','99734OH005000401','2014-01-01','2013-10-28 21:54:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:08:58'),(17526,14012,'Y','18','021','EC','A','','','AC','0000272525','0000272525','OH00002245206','IL','1','Simes','Lisa','','','','34','539620645','506 Main Street',0,'Milford','OH','45150',NULL,'CY','39025','1958-07-13','F','U',':RET:2106-3','N','021','DEN','2646956','99734OH005000401','2014-02-01','2014-01-12 14:13:19','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-13 03:01:39'),(15574,12463,'Y','18','021','EC','A','','','AC','0000816437','0000816437','OH00001646330','IL','1','Smith','Pamela','Ann','','','34','274767367','303 W WASHINGTON ST',0,'MEDINA','OH','44256','2236','CY','39103','1970-01-30','F','M',':RET:2106-3','T','021','HLT','2193769','52664OH151001306','2014-02-01','2013-12-31 15:28:12','652.00',NULL,NULL,'884.57','232.57','R-OH012','OH0','358.27',NULL,1,'2014-01-02 04:31:59'),(14787,11810,'Y','18','021','EC','A','','','AC','0000775095','0000775095','OH00001282088','IL','1','Stull','Vaughn','William','','','34','291866822','884 E HIGH AVE',0,'NEW PHILADELPHIA','OH','44663','3050','CY','39157','1986-11-05','M','U',':RET:2106-3','N','021','DEN','2333637','99734OH005000401','2014-01-01','2013-12-23 19:59:28','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,1,'2013-12-29 11:13:23'),(1007,825,'Y','18','021','EC','A','','','AC','0000256400','0000256400','LA00000184270','IL','1','Matson','Betty','','','','34','546813880','7800 Youree Drive',0,'Shreveport','LA','71105',NULL,'CY','22017','1982-02-09','F','U',':RET:2080-0','N','021','DEN','882231','18575LA002000101','2014-01-01','2013-10-19 14:25:47','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-25 18:11:08'),(7551,5976,'Y','18','021','EC','A','','','AC','0000425066','0000425066','OH00001216487','IL','1','Lowell','Staci','','','','34','279906319','37990 TAMARAC BLVD',0,'WILLOUGHBY','OH','44094','3495','CY','39085','1973-10-09','F','R',NULL,'N','021','HLT','783271','52664OH151001501','2014-01-01','2013-12-14 21:15:30','0.00',NULL,NULL,'385.52','385.52','R-OH011','OH0','385.52',NULL,0,'2013-12-26 02:33:14'),(3882,3110,'Y','18','021','EC','A','','','AC','0000493033','0000493033','LA00000856704','IL','1','BUTLER','NOAH','','','','34','437087131','3025 CHIPPEWA STREET',0,'NEW ORLEANS','LA','70115',NULL,'CY','22071','1964-09-13','M','U',':RET:2054-5','T','021','DEN','411159','18575LA002000201','2014-01-01','2013-12-13 16:43:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:36:29'),(21043,16812,'Y','18','021','EC','A','','','AC','0000913717','0000913717','TX00002175471','IL','1','Austin','Bonnie','','','','34','453676584','130 CEDAR',0,'ONALASKA','TX','77360','7028','CY','48373','1978-01-24','F','U',':RET:2106-3','N','021','DEN','3502885','33348TX002000101','2014-03-01','2014-02-01 16:02:34','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-01 19:00:51'),(21312,17029,'N','01','021','EC','A',NULL,NULL,'','0001462820','0001573488','','IL','1','Steib','Bridget','','','','34','437295591','22870 JACOCK RD',0,'SLAUGHTER','LA','70777','9615','CY','22037','1962-12-28','F','',':RET:2054-5','N','021','DEN','3698838','18575LA002000201','2014-03-01','2014-02-04 12:12:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:17'),(22207,17724,'Y','18','021','EC','A','','','AC','0000020217','0000020217','OH00002048086','IL','1','Tuck','Jamie','George','','','34','296825265','418 gunkel ave',0,'dayton','OH','45410',NULL,'CY','39113','1971-11-07','M','U',':RET:2106-3','T','021','DEN','2903315','99734OH005000401','2014-03-01','2014-02-09 15:46:34','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-09 19:00:17'),(22817,18210,'Y','18','021','EC','A','','','AC','0001103479','0001103479','OH00002226423','IL','1','White','Terry','','','','34','295547480','1409 Grimes Circle',0,'Urbana','OH','43078',NULL,'CY','39021','1956-09-21','M','M',':RET:2106-3','N','021','HLT','3303777','92036OH005000504','2014-03-01','2014-02-10 20:37:25','975.00',NULL,NULL,'1324.54','349.54','R-OH003','OH0','579.30',NULL,0,'2014-02-11 21:02:01'),(22978,18321,'Y','18','021','EC','A','','','AC','0000172455','0000172455','OH00002059076','IL','1','Winchell','James','','','','34','293487720','3537 BULAH RD',0,'JEFFERSON','OH','44047','9446','CY','39007','1951-02-21','M','M',':RET:2106-3','N','021','DEN','3256024','99734OH005000301','2014-03-01','2014-02-11 21:14:19','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:30:07'),(23791,18932,'N','19','021','EC','A',NULL,NULL,'','0000062578','0000361063','','IL','1','Cunningham','Brendan','','','','34','271139514','212 East N. St.',0,'Medina','OH','44256',NULL,'CY','39103','2006-11-07','M','',':RET:2106-3','N','021','HLT','3199083','52664OH151001305','2014-03-01','2014-02-14 10:59:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-14 21:31:25'),(24162,19198,'N','19','021','EC','A',NULL,NULL,'','0000397390','0000653245','','IL','1','Dressman','Grace','','','','34','293065477','3900 ONEIDA ST',0,'STOW','OH','44224','4217','CY','39153','2002-01-24','F','',':RET:2106-3','N','021','HLT','3222274','52664OH151001501','2014-03-01','2014-02-14 20:52:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-15 22:02:04'),(28478,22533,'Y','18','021','EC','A','','','AC','0000936116','0000936116','OH00003498751','IL','1','Page','Robert','','','','34','385804971','221 N NORTH ST',0,'WASHINGTON COURT HOUSE','OH','43160','1457','CY','39047','1963-03-04','M','M',NULL,'N','021','DEN','4140250','99734OH005000301','2014-04-01','2014-03-07 11:20:12','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:31:34'),(28820,22808,'Y','18','021','EC','A','','','AC','0000670318','0000670318','OH00003364131','IL','1','Urbanowicz','Randy','','','','34','288786702','10804 S LAKES DR',0,'PERRYSBURG','OH','43551','6387','CY','39173','1970-03-15','M','U',':RET:2106-3','N','021','HLT','4336340','92036OH002002601','2014-04-01','2014-03-09 15:19:09','87.00',NULL,NULL,'314.59','227.59','R-OH001','OH0','314.59',NULL,0,'2014-03-09 21:00:59'),(65,58,'Y','18','021','EC','A','','','AC','0001217350','0001217350','OH00000976983','IL','1','Devlin','Deborah','','','','34','270641541','179 HUNT CLUB DR',0,'COPLEY','OH','44321','2735','CY','39153','1956-06-13','F','R',':RET:2106-3','N','021','DEN','2484','99734OH005000301','2014-01-01','2013-12-05 10:55:53','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:16:45'),(17086,13674,'Y','18','021','EC','A','','','AC','0000345269','0000345269','TX00002154878','IL','1','Davila','Rosario','','','','34','464795152','13210 FRANKIE LN',0,'EL PASO','TX','79938','8471','CY','48141','1950-01-08','F','M',':RET:2106-3','N','021','DEN','1658311','33348TX002000201','2014-02-01','2014-01-08 14:45:17','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:21:25'),(917,761,'N','01','021','EC','A',NULL,NULL,'','0000915632','0001258641','','IL','1','Fowler','Edward','T','','','34','292647630','821 PARK AVE',0,'HAMILTON','OH','45013','2973','CY','39017','1963-08-25','M','',':RET:2106-3','N','021','HLT','1467176','92036OH003001201','2014-01-01','2013-12-16 16:03:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','400.38',NULL,0,'2013-12-25 18:08:42'),(9752,7722,'Y','18','021','EC','A','','','AC','0001066944','0001066944','OH00000105179','IL','1','TIPTON','PATRICIA','','','','34','273441172','2688 MCHENRY ROAD',0,'GOSHEN','OH','45122',NULL,'CY','39025','1950-02-17','F','M',':RET:2106-3','N','021','HLT','755643','92036OH006000601','2014-01-01','2013-11-15 12:19:44','498.89',NULL,NULL,'502.56','3.67','R-OH005','OH0','502.56',NULL,0,'2013-12-26 04:46:15'),(9670,7661,'N','01','021','EC','A',NULL,NULL,'','0000172397','0000551416','','IL','1','Beam','Valerie','L','','','34','284641230','56 PORT WILLIAM RD',0,'PORT WILLIAM','OH','45164','1011','CY','39027','1956-12-19','F','',':RET:2106-3','N','021','HLT','2349016','92036OH002000601','2014-01-01','2013-12-21 12:45:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','604.16',NULL,0,'2013-12-26 04:39:12'),(1820,1495,'Y','18','021','EC','A','','','AC','0001261214','0001261214','OH00000343539','IL','1','Spafford','Mark','L','','','34','296564481','1005 North Grove St',0,'Bowling Green','OH','43402',NULL,'CY','39173','1954-11-06','M','U',':RET:2106-3','T','021','HLT','2263760','92036OH005002606','2014-01-01','2013-12-24 11:43:19','427.00',NULL,NULL,'583.72','156.72','R-OH001','OH0','583.72',NULL,0,'2013-12-25 18:57:14'),(7744,6133,'Y','18','024','14','A','','','TE','0000762245','0000762245','','IL','1','Scheid','Kris',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-12-21','M','',NULL,NULL,NULL,'','1186663','','2013-12-20','2013-12-20 15:46:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:22'),(25430,20178,'Y','18','021','EC','A','','','AC','0000788744','0000788744','TX00002415835','IL','1','Arthur','Ellen','','','','34','161768248','3101 Mustang Dr',0,'Grapevine','TX','76051',NULL,'CY','48439','1958-12-24','F','U',':RET:2054-5','N','021','DEN','3073592','33348TX002000201','2014-04-01','2014-02-24 19:50:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-25 21:31:14'),(26074,20677,'Y','18','021','EC','A','','','AC','0000324885','0000324885','OH00003036377','IL','1','URTON','RODNEY','','','','34','298762699','501 LANTERN GLOW CT',0,'LEBANON','OH','45036','8029','CY','39165','1969-07-04','M','M',':RET:2106-3','N','021','HLT','2766460','92036OH004001201','2014-03-01','2014-02-26 17:38:30','213.32',NULL,NULL,'350.75','137.43','R-OH004','OH0','241.14',NULL,0,'2014-02-26 21:02:46'),(26159,20742,'Y','18','021','EC','A','','','AC','0000278367','0000278367','OH00002744271','IL','1','FLETCHER','JANE','ERIKA','','','34','277701911','5325 SNELL DR',0,'MENTOR','OH','44060',NULL,'CY','39085','1966-04-06','F','U',NULL,'N','021','DEN','3062570','99734OH005000401','2014-03-01','2014-02-27 17:29:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:31'),(26324,20885,'Y','18','021','EC','A','','','AC','0000899928','0000899928','MS00003125384','IL','1','REED-FIGGS','DELILAH','','','','34','428067633','318 JEFFERSON AVE',0,'CLARKSDALE','MS','38614',NULL,'CY','28027','1957-10-25','F','U',':RET:2054-5','N','021','DEN','3733596','46300MS002000101','2014-03-01','2014-02-27 11:08:51','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-02-28 06:31:37'),(27461,21733,'Y','18','021','EC','A','','','AC','0001113196','0001113196','OH00003422684','IL','1','Miller','Thomas',NULL,NULL,NULL,NULL,NULL,'1270 VANE AVE',0,'AKRON','OH','44310','3520','CY','39153','1955-10-03','M','M',':RET:2106-3','N','021','HLT','3817213','52664OH152000901','2014-04-01','2014-03-04 13:00:06','0.00',NULL,NULL,'817.23','817.23','R-OH012','OH0','416.19',NULL,0,'2014-03-04 21:02:05'),(1092,897,'N','01','021','EC','A',NULL,NULL,'','0001062083','0000223679','','IL','1','Wills','Diana','','','','34','274640821','2812 VINCENT DR',0,'SEVEN HILLS','OH','44131','6263','CY','39035','1963-12-01','F','',':RET:2106-3','N','021','DEN','193714','99734OH005000401','2014-01-01','2013-12-03 13:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:17:04'),(14844,11853,'Y','18','021','EC','A','','','AC','0000889611','0000889611','OH00000226074','IL','1','Gordon','Alison','','','','34','365112900','843 WALNUT ST',0,'PERRYSBURG','OH','43551','1657','CY','39173','1989-06-02','F','U',':RET:2106-3','N','021','HLT','2115959','92036OH002002601','2014-01-01','2013-12-23 19:55:45','0.00',NULL,NULL,'225.18','225.18','R-OH001','OH0','225.18',NULL,1,'2013-12-29 11:14:55'),(6523,5172,'Y','18','021','EC','A','','','AC','0000194031','0000194031','OH00001304781','IL','1','Wernert','Keith','','','','34','299886806','2131 CENTRAL GRV',0,'TOLEDO','OH','43614','4317','CY','39095','1985-05-07','M','U',NULL,'N','021','HLT','1146403','92036OH006002601','2014-01-01','2013-12-11 15:23:55','0.00',NULL,NULL,'168.10','168.10','R-OH001','OH0','168.10',NULL,0,'2013-12-26 00:51:28'),(13574,10826,'Y','18','024','14','A','','','TE','0001326483','0001326483','','IL','1','McGee','Larry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-02-25','M','',NULL,NULL,NULL,'','2141109','','2013-12-23','2013-12-23 17:37:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:04:44'),(9506,7538,'N','01','021','EC','A',NULL,NULL,'','0000112924','0000603355','','IL','1','Shimpo','Ryoge','','','','34','299988901','1730 KINGSLEY AVE',0,'AKRON','OH','44313','6109','CY','39153','1972-01-10','M','',':RET:2039-6','N','021','DEN','1955187','99734OH005000401','2014-01-01','2013-12-21 15:27:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:16'),(8130,6432,'Y','18','021','EC','A','','','AC','0000827122','0000827122','OH00000513791','IL','1','Muncy','Kayla','','','','34','281921705','397 OLD RANCH CT',0,'GALLOWAY','OH','43119','9323','CY','39049','1990-05-03','F','U',':RET:2106-3','N','021','DEN','659604','99734OH005000401','2014-01-01','2013-11-22 11:15:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:15:30'),(17344,13875,'Y','18','021','EC','A','','','AC','0000569498','0000569498','MS00002299857','IL','1','riggs','jaymie','','','','34','445723666','1340 TROPICAL CV',0,'GULFPORT','MS','39507','6003','CY','28047','1962-04-15','F','U',':RET:2106-3','N','021','DEN','2467914','46300MS002000201','2014-02-01','2014-01-10 17:59:53','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-13 02:24:05'),(22033,17587,'N','01','021','EC','A',NULL,NULL,'','0001066019','0000264239','','IL','1','Simmons','Clifton','B',NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1962-02-12','M','',NULL,'N','021','HLT','2731792','52664OH151001501','2014-03-01','2014-02-07 10:25:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','588.84',NULL,0,'2014-02-07 19:01:03'),(27727,21927,'Y','18','021','EC','A','','','AC','0000488120','0000488120','TX00003137130','IL','1','Coots','Lisa','','','','34','640103287','2404 SHADOW CRK',0,'LONGVIEW','TX','75605','2563','CY','48183','1987-03-21','F','U',':RET:2106-3','N','021','DEN','2720262','33348TX002000201','2014-04-01','2014-03-05 15:13:31','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-03-05 21:31:02'),(1863,1522,'N','19','021','EC','A',NULL,NULL,'','0001230390','0000919393','','IL','1','Wilke','Sabrina','N','','','34','269040661','9336 BRYANT RD',0,'WINDHAM','OH','44288','9547','CY','39133','1998-09-18','F','',':RET:2106-3','N','021','HLT','2563089','52664OH152000901','2014-01-01','2013-12-24 10:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 18:58:09'),(16711,13374,'Y','18','021','EC','A','','','AC','0000298763','0000298763','TX00002263366','IL','1','Brodwick','Kevin','','','','34','458451627','3112 Windsor Rd',0,'Austin','TX','78703',NULL,'CY','48453','1970-01-20','M','R',':RET:2106-3','N','021','DEN','2452015','33348TX002000201','2014-02-01','2014-01-07 09:22:57','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-08 18:24:42'),(14954,11952,'Y','18','021','EC','A','','','AC','0000327846','0000327846','TX00000063172','IL','1','CLADIO','ADELITH','','','','34','636083016','1000 PASCHAL ST',0,'KERRVILLE','TX','78028','2235','CY','48265','1981-12-15','F','M',NULL,'N','021','DEN','2234746','33348TX002000201','2014-02-01','2013-12-29 23:39:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:00:17'),(3147,2531,'Y','18','021','EC','A','','','AC','0001130646','0001130646','TX00000407499','IL','1','Poe','Roger','','','','34','457844709','506 BLUEBONNET ST',0,'FREDERICKSBURG','TX','78624','5238','CY','48171','1949-05-24','M','M',':RET:2106-3','N','021','DEN','161203','33348TX002000201','2014-01-01','2013-11-18 14:23:48','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:30:57'),(13547,10803,'Y','18','021','EC','A','','','AC','0001941232','0001941232','LA00001352581','IL','1','montgomery','connie','','','','34','416884733','47 GELPI AVE',0,'KENNER','LA','70065','3150','CY','22051','1958-12-29','F','U',':RET:2106-3','N','021','DEN','1678336','18575LA002000201','2014-01-01','2013-12-23 14:49:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:03:58'),(20077,16016,'Y','18','024','14','A','','','TE','0001247760','0001247760','','IL','1','Jolly','Tonya',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-01-22','F','',NULL,NULL,NULL,'','2464342','','2014-01-27','2014-01-27 16:46:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:21'),(20157,16086,'Y','18','021','EC','A','','','AC','0000363806','0000363806','OH00002459972','IL','1','Skidmore','Timothy','Mark','','','34','288522421','3829 ROUND BOTTOM RD',0,'NEWTOWN','OH','45244','2414','CY','39061','1955-03-10','M','U',':RET:2106-3','T','021','DEN','2753109','99734OH005000301','2014-03-01','2014-01-27 12:35:58','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:01:07'),(21806,17414,'Y','18','021','EC','A','','','AC','0001147375','0001147375','OH00002150421','IL','1','Billick','John','','','','34','287481646','236 WASHBURN RD',0,'TALLMADGE','OH','44278','2614','CY','39153','1951-05-08','M','U',':RET:2106-3','N','021','HLT','2971819','52664OH151001301','2014-03-01','2014-02-06 11:01:35','388.00',NULL,NULL,'640.70','252.70','R-OH012','OH0','640.70',NULL,0,'2014-02-06 21:00:51'),(28279,22378,'N','19','021','EC','A',NULL,NULL,'','0000500463','0000683452','','IL','1','Cunningham','Quinn','M','','','34','872883151','4643 BLUEJAY CT',0,'CINCINNATI','OH','45244','1178','CY','39025','2013-04-05','F','',':RET:2106-3','N','021','HLT','4242423','92036OH001000601','2014-04-01','2014-03-07 09:32:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44','CIC',0,'2014-03-07 21:00:24'),(4200,3340,'Y','18','021','EC','A','','','AC','0000311547','0000311547','TX00000373477','IL','1','harrison','victor','','','','34','449088498','16640 hwy 254',0,'mineral wells','TX','76067',NULL,'CY','48363','1956-09-22','M','M',':RET:2106-3','N','021','DEN','2477657','33348TX002000201','2014-01-01','2013-12-16 19:33:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:49:51'),(2609,2120,'Y','18','021','EC','A','','','AC','0001059450','0001059450','OH00000482062','IL','1','Benson','Curits','','','','34','297646065','22350 EUCLID AVE',0,'EUCLID','OH','44117','1667','CY','39035','1963-04-29','M','U',':RET:2054-5','N','021','DEN','456645','99734OH005000401','2014-01-01','2013-12-02 11:01:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:45:32'),(17074,13664,'Y','18','021','EC','A','','','AC','0001237994','0001237994','TX00001571522','IL','1','Lawson','Tori','','','','34','437732574','7112 NANDINA DR',0,'DALLAS','TX','75241','5833','CY','48113','1989-03-06','F','U',':RET:2054-5','N','021','DEN','1914906','33348TX002000201','2014-02-01','2014-01-08 11:24:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:19'),(15844,12687,'Y','18','021','EC','A','','','AC','0000596285','0000596285','OH00002174793','IL','1','Hater','Kelly','','','','34','276908556','11530 RELTAS CT',0,'CINCINNATI','OH','45249','1707','CY','39061','1986-01-27','F','M',':RET:2106-3','N','021','DEN','1750460','99734OH005000401','2014-02-01','2014-01-02 17:12:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:04:14'),(17277,13818,'Y','18','021','EC','A','','','AC','0000012452','0000012452','OH00001580393','IL','1','Carter','Shavitress','','','','34','411579718','691 COPLEY RD',0,'AKRON','OH','44320','2320','CY','39153','1974-12-06','F','U',':RET:2054-5','T','021','HLT','1723570','52664OH152000901','2014-02-01','2014-01-10 13:28:51','186.00',NULL,NULL,'237.06','51.06','R-OH012','OH0','237.06',NULL,0,'2014-01-13 02:23:24'),(17796,14216,'Y','18','021','EC','A','','','AC','0000963249','0000963249','OH00001892744','IL','1','Baker','Pamela','','','','34','298428637','445 KARENLAW LN',0,'CINCINNATI','OH','45231','2727','CY','39061','1952-04-05','F','M',':RET:2106-3','N','021','HLT','1682848','92036OH004001201','2014-02-01','2014-01-13 15:59:40','595.00',NULL,NULL,'970.10','375.10','R-OH004','OH0','485.05',NULL,0,'2014-01-14 01:33:51'),(19103,15220,'Y','18','021','EC','A','','','AC','0001859000','0001859000','LA00001980312','IL','1','Claiborne','Audrey','','','','34','433047606','1042 Louisiana Ave',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1957-05-02','F','U',NULL,'N','021','DEN','1585026','18575LA002000201','2014-03-01','2014-01-18 12:39:20','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:44:39'),(26098,20698,'Y','18','021','EC','A','','','AC','0001517923','0001517923','LA00002670525','IL','1','Pieri','Alessandro','','','','34','436611147','221 PINE ST',0,'NEW ORLEANS','LA','70118','3614','CY','22071','1986-03-05','M','U',NULL,'N','021','DEN','3288389','18575LA002000201','2014-04-01','2014-02-27 15:04:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:11'),(26797,21237,'N','19','021','EC','A',NULL,NULL,'','0000862497','0000861023','','IL','1','Gonzalez','Alicia','','','','34','290045161','336 N BERLIN AVE',0,'TOLEDO','OH','43605','1508','CY','39095','1999-12-04','F','',NULL,'N','021','HLT','2734646','92036OH003002605','2014-04-01','2014-03-01 16:53:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-03-01 21:00:21'),(27505,21761,'Y','18','021','EC','A','','','AC','0001243027','0001243027','OH00003523264','IL','1','Horsey','Cindy','','','','34','276664223','502 tiedeman ave',0,'Defiance','OH','43512',NULL,'CY','39039','1957-12-26','F','U',NULL,'N','021','HLT','3421646','92036OH004002601','2014-04-01','2014-03-04 14:45:13','295.00',NULL,NULL,'365.79','70.79','R-OH001','OH0','365.79',NULL,0,'2014-03-04 21:02:30'),(81,70,'Y','18','021','EC','A','','','AC','0000809647','0000809647','OH00000601968','IL','1','Helinski','Nancy','Ann','','','34','268547623','6037 VAN WORMER DR',0,'TOLEDO','OH','43612','4042','CY','39095','1953-03-22','F','U',NULL,'N','021','DEN','653959','99734OH005000301','2014-01-01','2013-12-05 17:38:42','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 17:17:08'),(7660,6066,'Y','18','021','EC','A','','','AC','0001488416','0001488416','LA00001059046','IL','1','McCullough','Leland','','','','34','466758598','301 LAWRENCE BLVD',0,'PINEVILLE','LA','71360','5031','CY','22079','1986-01-02','M','M',':RET:2106-3','N','021','DEN','2530930','18575LA002000101','2014-01-01','2013-12-20 10:05:01','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2013-12-26 03:00:15'),(5232,4153,'N','19','021','EC','A',NULL,NULL,'','0000446277','0000363766','','IL','1','Kress','Lucas','A','','','34','627970462','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','2011-08-01','M','',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:04:48'),(7488,5924,'Y','18','021','EC','A','','','AC','0000666747','0000666747','OH00000752679','IL','1','Moore','Dallas','','','','34','269528855','301 BEARDSLEY RD',0,'TROTWOOD','OH','45426','2711','CY','39113','1958-09-19','M','M',':RET:2106-3','N','021','DEN','1222426','99734OH005000401','2014-01-01','2013-12-15 14:38:59','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:31:32'),(18918,15074,'Y','18','021','EC','A','','','AC','0001094663','0001094663','OH00001931249','IL','1','TOPP','RACHEL','E','','','34','296722376','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1970-10-09','F','M',':RET:2106-3','N','021','HLT','1606089','92036OH003001506','2014-02-01','2014-01-15 19:34:24','612.00',NULL,NULL,'762.37','150.37','R-OH002','OH0','311.88',NULL,0,'2014-01-17 03:36:42'),(20377,16278,'Y','18','021','EC','A','','','AC','0000644260','0000644260','TX00002335055','IL','1','Dents','Wanda','','','','34','458379331','1008 S 7TH ST',0,'COPPERAS COVE','TX','76522','3515','CY','48099','1964-10-23','F','U',':RET:2054-5','N','021','DEN','3052064','33348TX002000201','2014-03-01','2014-01-28 19:26:55','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-29 21:00:09'),(24546,19497,'N','19','021','EC','A',NULL,NULL,'','0000928544','0000816469','','IL','1','JOHNSON','SHAYNNA','R','','','34','301928949','7122 RIDGE AVE SE',0,'EAST SPARTA','OH','44626','9448','CY','39151','1991-01-27','F','',':RET:2106-3','N','021','HLT','3091078','52664OH151001301','2014-04-01','2014-02-19 08:53:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-02-20 04:03:31'),(24633,19550,'Y','18','021','EC','A','','','AC','0001193474','0001193474','LA00002271908','IL','1','Scott','Jesse','','','','34','437136504','700 K ST',0,'MONROE','LA','71201','4720','CY','22073','1959-07-19','M','U',':RET:2106-3','N','021','DEN','2714365','18575LA002000201','2014-04-01','2014-02-19 09:46:45','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 04:18:24'),(23,18,'Y','18','024','14','A','','','TE','0000690707','0000690707','','IL','1','Sarisky','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-03','M','',NULL,NULL,NULL,'','424131','','2013-12-05','2013-12-05 13:28:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:15:34'),(190,159,'Y','18','021','EC','A','','','AC','0000053031','0000053031','OH00000340451','IL','1','Allen','Deborah','','','','34','289443361','2346 16th St',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1950-11-30','F','U',':RET:2106-3','T','021','HLT','573849','52664OH151001305','2014-01-01','2013-12-05 15:14:53','495.00',NULL,NULL,'757.07','262.07','R-OH012','OH0','757.07',NULL,0,'2013-12-25 17:19:56'),(17307,13841,'Y','18','021','EC','A','','','AC','0000499691','0000499691','TX00001993609','IL','1','Murphy','Ellen','T','','','34','466904200','1023 RIVER PARK',0,'SAN ANTONIO','TX','78216','7832','CY','48029','1955-11-30','F','U',':RET:2106-3','N','021','DEN','1405907','33348TX002000201','2014-02-01','2014-01-10 13:47:09','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:23:41'),(16479,13188,'Y','18','021','EC','A','','','AC','0001097797','0001097797','OH00000588003','IL','1','KLING','NICOLE','','','','34','269869979','2152 SAVOY AVE',0,'AKRON','OH','44305','2133','CY','39153','1987-01-08','F','U',':RET:2106-3','N','021','HLT','1801221','52664OH151001301','2014-02-01','2014-01-06 11:35:20','0.00',NULL,NULL,'233.71','233.71','R-OH012','OH0','233.71',NULL,0,'2014-01-07 04:06:12'),(16344,13083,'Y','18','021','EC','A','','','AC','0000763536','0000763536','OH00001656507','IL','1','Butcher','Nancy','','','','34','236847520','6918 WHITE PINE DR',0,'RAVENNA','OH','44266','8983','CY','39133','1954-05-27','F','M',':RET:2106-3','N','021','DEN','2569985','99734OH005000301','2014-02-01','2014-01-06 15:56:52','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-07 04:02:18'),(6658,5281,'Y','18','021','EC','A','','','AC','0000853013','0000853013','OH00000695406','IL','1','davis','freddie','travis','','','34','268763143','5085 SINGLETON DR',0,'HILLIARD','OH','43026','9137','CY','39049','1964-03-07','M','U',':RET:2106-3','N','021','DEN','813117','99734OH005000401','2014-01-01','2013-11-16 16:58:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:00:47'),(2100,1721,'Y','18','024','14','A','','','TE','0000242689','0000242689','','IL','1','Sullivan','Judith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-06','F','',NULL,NULL,NULL,'','855252','','2013-12-09','2013-12-09 20:26:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:17:08'),(9389,7445,'Y','18','021','EC','A','','','AC','0000249224','0000249224','TX00000230568','IL','1','Vestal','Michael','Seth','','','34','451897484','3408 NASHVILLE AVE',0,'LUBBOCK','TX','79413','2183','CY','48303','1975-11-21','M','U',':RET:2106-3','N','021','DEN','1914303','33348TX002000201','2014-01-01','2013-12-20 20:07:52','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 04:32:18'),(3980,3178,'Y','18','021','EC','A','','','AC','0000929824','0000929824','OH00000260798','IL','1','McKee','Patsy','','','','34','300526016','885 N McClure Rd',0,'Lima','OH','45801',NULL,'CY','39003','1951-03-09','F','M',':RET:2106-3','N','021','HLT','304951','92036OH003001501','2014-01-01','2013-12-13 13:38:00','363.00',NULL,NULL,'660.32','297.32','R-OH002','OH0','660.32',NULL,0,'2013-12-25 21:38:47'),(21076,16842,'Y','18','021','EC','A','','','AC','0000802612','0000802612','OH00002471721','IL','1','SOMERVILLE','KATHLEEN','','','','34','298507817','314 GRANDVIEW AVE',0,'TILTONSVILLE','OH','43963','1089','CY','39081','1951-04-08','F','U',':RET:2106-3','T','021','DEN','3083008','99734OH005000401','2014-03-01','2014-02-02 13:34:21','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-02 19:00:19'),(25773,20440,'N','19','021','EC','A',NULL,NULL,'','0001160463','0000372658','','IL','1','Karp','Garrett','A','','','34','295085904','17306 Fairway Drive',0,'Lagrange','OH','44050',NULL,'CY','39093','2004-03-17','M','',':RET:2106-3','N','021','DEN','3063575','99734OH005000301','2014-04-01','2014-02-24 16:36:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:57'),(28920,22889,'Y','18','021','EC','A','','','AC','0000913020','0000913020','OH00003411482','IL','1','METCALF','JAMES','','','','34','295583427','129 PALMER LN',0,'BRYAN','OH','43506','7800','CY','39171','1956-05-28','M','M',':RET:2106-3','T','021','DEN','2782251','99734OH005000301','2014-04-01','2014-03-10 10:06:16','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-10 21:00:30'),(7093,5626,'N','19','021','EC','A',NULL,NULL,'','0000846147','0000729976','','IL','1','bonifant','isabel','l','','','34','290026197','731 6TH ST SW',0,'MASSILLON','OH','44647','7744','CY','39151','1997-12-23','F','',':RET:2106-3','N','021','HLT','2157728','52664OH151001304','2014-01-01','2013-12-24 19:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 01:50:36'),(5664,4493,'N','01','021','EC','A',NULL,NULL,'','0000399853','0000679501','','IL','1','Burke','Patricia','Diane','','','34','294562633','1242 KOHLER AVE',0,'AKRON','OH','44314','1618','CY','39153','1954-07-30','F','',':RET:2106-3','N','021','HLT','934482','52664OH151001305','2014-01-01','2013-11-26 12:01:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-25 23:31:51'),(24036,19115,'N','19','021','EC','A',NULL,NULL,'','0000304757','0000124258','','IL','1','Hineline','Sydney','','','','34','649126572','8368 HAMBLETONIAN DR',0,'CINCINNATI','OH','45249','1309','CY','39061','1997-09-29','F','',':RET:2106-3','N','021','DEN','2881544','99734OH005000301','2014-03-01','2014-02-15 08:58:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:00:55'),(23777,18920,'Y','18','021','EC','A','','','AC','0000743192','0000743192','MS00002363848','IL','1','Wiggins','Tiffany','','','','34','587492639','13105 Rocky Mountain Rd',0,'Biloxi','MS','39532',NULL,'CY','28047','1984-07-07','F','U',':RET:2054-5','N','021','DEN','3620666','46300MS002000201','2014-03-01','2014-02-14 11:13:26','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-14 21:31:17'),(22821,18211,'Y','18','021','EC','A','','','AC','0000504506','0000504506','OH00002195352','IL','1','Gruccio','Roger','','','','34','293523429','225 CANTON RD',0,'AKRON','OH','44312','1505','CY','39153','1952-05-07','M','M',':RET:2106-3','N','021','HLT','2919762','52664OH151001305','2014-03-01','2014-02-10 21:01:13','1010.00',NULL,NULL,'1231.89','221.89','R-OH012','OH0','626.65',NULL,0,'2014-02-11 21:02:02'),(22105,17645,'Y','18','021','EC','A','','','AC','0000957938','0000957938','OH00001497250','IL','1','Hartwig','Timothy','','','','34','290584923','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','1972-01-13','M','M',':RET:2106-3','T','021','DEN','2941556','99734OH005000301','2014-03-01','2014-02-08 13:53:43','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-08 19:00:32'),(9001,7142,'Y','18','021','EC','A','','','AC','0000571983','0000571983','OH00000164245','IL','1','Wilson','Elizabeth','A','','','34','279867587','8677 SCENICVIEW DR',0,'BROADVIEW HEIGHTS','OH','44147','3450','CY','39035','1987-01-22','F','U',':RET:2106-3','N','021','HLT','1564468','52664OH152000901','2014-01-01','2013-12-18 10:21:58','130.00',NULL,NULL,'188.65','58.65','R-OH011','OH0','188.65',NULL,0,'2013-12-26 04:04:52'),(8122,6424,'Y','18','021','EC','A','','','AC','0000411077','0000411077','OH00000895746','IL','1','cecil','lutushia','lynn','','','34','273521500','1671 county rd 15',0,'rayland','OH','43943',NULL,'CY','39081','1951-09-10','F','M',':RET:2106-3','N','021','DEN','794692','99734OH005000401','2014-01-01','2013-11-22 10:53:58','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 03:15:17'),(17524,14010,'Y','18','021','EC','A','','','AC','0000910545','0000910545','OH00001499091','IL','1','shanahan','sharon','','','','34','282548983','652 CORTLANDT AVE',0,'LIMA','OH','45801','3560','CY','39003','1953-04-29','F','U',':RET:2106-3','T','021','DEN','1735573','99734OH005000401','2014-02-01','2014-01-12 12:14:55','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-01-13 03:01:38'),(17136,13713,'Y','18','021','EC','A','','','AC','0001018246','0001018246','OH00001408325','IL','1','Carr','Diana','','','','34','282660861','1708 white birch ln.',0,'Amelia','OH','45102',NULL,'CY','39025','1959-07-17','F','M',':RET:2106-3','N','021','DEN','2576660','99734OH005000401','2014-02-01','2014-01-08 17:58:07','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-01-13 02:21:49'),(7807,6184,'Y','18','021','EC','A','','','AC','0000888495','0000888495','TX00000846941','IL','1','HERNANDEZ','ELIDA','','','','34','467947712','3014 GUADALUPE ST',0,'SAN ANGELO','TX','76901','2811','CY','48451','1949-09-26','F','U',NULL,'N','021','DEN','2456885','33348TX002000201','2014-01-01','2013-12-20 16:54:10','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-26 03:03:49'),(7673,6077,'N','01','021','EC','A',NULL,NULL,'','0000948406','0001233046','','IL','1','KING','DEBORAH','L','','','34','280661042','254 GREENFIELD ST',0,'TIFFIN','OH','44883','2424','CY','39147','1959-09-17','F','',':RET:2106-3','N','021','HLT','2445884','92036OH005002701','2014-01-01','2013-12-19 18:52:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.32',NULL,0,'2013-12-26 03:00:37'),(3893,3116,'Y','18','024','14','A','','','TE','0000426405','0000426405','','IL','1','Williams','LaKisha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-18','F','',NULL,NULL,NULL,'','1132180','','2013-12-13','2013-12-13 14:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:36:41'),(3731,2982,'Y','18','021','EC','A','','','AC','0000543673','0000543673','TX00000628166','IL','1','Martinez','Christina','','','','34','455130166','4107 Medical Dr',0,'San Antonio','TX','78229',NULL,'CY','48029','1971-08-26','F','U',':RET:2106-3','N','021','DEN','553194','33348TX002000201','2014-01-01','2013-12-12 19:44:47','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 21:32:36'),(5635,4470,'Y','18','021','EC','A','','','AC','0000805580','0000805580','TX00000002390','IL','1','Said','Roya','','','','34','632341406','722 DELEON ST',0,'DENISON','TX','75020','3858','CY','48181','1991-10-05','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','869388','33348TX002000201','2014-01-01','2013-11-25 18:39:18','0.00',NULL,NULL,'15.85','15.85','R-TX020','TX0','15.85',NULL,0,'2013-12-25 23:31:04'),(2510,2045,'Y','18','021','EC','A','','','AC','0001160391','0001160391','OH00000267278','IL','1','KESSLER','WILLIAM','','','','34','287540100','3960 EVERINGIN RD',0,'MONROEVILLE','OH','44847','9438','CY','39077','1953-10-03','M','U',':RET:2106-3','N','021','HLT','301983','92036OH002002701','2014-01-01','2013-12-08 23:53:22','549.00',NULL,NULL,'611.15','62.15','R-OH006','OH0','611.15',NULL,0,'2013-12-25 19:36:16'),(6758,5363,'Y','18','021','EC','A','','','AC','0001113109','0001113109','OH00000061990','IL','1','Forrer','Sarah','Joy','','','34','294785981','152 WALDORF DR',0,'AKRON','OH','44313','6228','CY','39153','1980-08-17','F','U',':RET:2106-3','N','021','HLT','712871','52664OH152000901','2014-01-01','2013-11-25 08:05:04','0.00',NULL,NULL,'505.54','505.54','R-OH012','OH0','195.68',NULL,0,'2013-12-26 01:16:17'),(24278,19281,'Y','18','021','EC','A','','','AC','0000258218','0000258218','OH00002153427','IL','1','Welch','Brandi','','','','34','277786166','5836 ELSIE AVE',0,'CINCINNATI','OH','45224','3206','CY','39061','1980-12-09','F','U',':RET:2054-5','T','021','DEN','3521635','99734OH005000401','2014-03-01','2014-02-18 14:06:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-18 21:30:05'),(26663,21137,'Y','18','021','EC','A','','','AC','0002307241','0002307241','LA00003287789','IL','1','Ballom','Demetrice','','','','34','436518792','1345 INDEPENDENCE ST',0,'NEW ORLEANS','LA','70117','5635','CY','22071','1971-10-14','F','U',':RET:2054-5','N','021','DEN','3056423','18575LA002000201','2014-04-01','2014-02-27 20:10:53','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:13'),(27848,22027,'Y','18','021','EC','A','','','AC','0000968642','0000968642','TX00002798980','IL','1','Waldoch','Michele','','','','34','025507035','1008 TRINITY CUT OFF',0,'HUNTSVILLE','TX','77320','8987','CY','48471','1961-02-09','F','M',NULL,'N','021','DEN','3259003','33348TX002000101','2014-04-01','2014-03-05 14:24:16','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-03-05 21:32:11'),(28242,22347,'Y','18','021','EC','A','','','AC','0000500465','0000500465','OH00003085587','IL','1','kingsland','thomalena','','','','34','272745728','340 KING AVE',0,'SOUTH LEBANON','OH','45065','1404','CY','39165','1975-02-07','F','M',NULL,'T','021','DEN','3101192','99734OH005000401','2014-04-01','2014-03-07 12:32:58','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00','CIC',0,'2014-03-07 21:00:10'),(1191,980,'Y','18','021','EC','A','','','AC','0001231735','0001231735','OH00001289051','IL','1','marshall','myree','','','','34','401022062','po box 23724',0,'chagrin falls','OH','44023',NULL,'CY','39133','1972-09-27','M','U',':RET:2054-5','N','021','DEN','919678','99734OH005000301','2014-01-01','2013-12-03 10:28:00','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:19:35'),(1219,1002,'Y','18','021','EC','A','','','AC','0000610840','0000610840','OH00000289720','IL','1','Conley','Rebecca','','','','34','268521148','111 KENRIDGE RD',0,'FAIRLAWN','OH','44333','3409','CY','39153','1951-01-10','F','U',':RET:2106-3','N','021','HLT','943840','52664OH151001306','2014-01-01','2013-12-03 09:57:44','525.00',NULL,NULL,'640.70','115.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 18:20:21'),(2966,2389,'Y','18','021','EC','A','','','AC','0000161357','0000161357','TX00000038422','31','1','MORENO','MARIA','ELENA','','','34','464392714','6314 SPACE STOP 63A',0,'ZAPATA','TX','78076',NULL,'CY','48505','1959-11-01','F','M',NULL,'N','021','DEN','1093016','33348TX002000201','2014-01-01','2013-12-06 12:00:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:52'),(7259,5755,'Y','18','021','EC','A','','','AC','0000622465','0000622465','OH00001087458','IL','1','BECKER','JACQUELINE','','','','34','295609482','2109 INWOOD RD',0,'WILMINGTON','OH','45177','9036','CY','39027','1965-03-05','F','U',':RET:2106-3','N','021','HLT','18844','92036OH002000601','2014-01-01','2013-12-14 00:41:05','343.00',NULL,NULL,'405.33','62.33','R-OH005','OH0','405.33',NULL,0,'2013-12-26 02:02:05'),(22174,17697,'Y','18','024','14','A','','','TE','0000586666','0000586666','','IL','1','Schimmel','Edward',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-14','M','',NULL,NULL,NULL,'','257452','','2014-02-28','2014-02-08 00:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-08 19:30:06'),(4515,3578,'N','01','021','EC','A',NULL,NULL,'','0000009917','0000660239','','IL','1','peterson','brittany','rhea','','','34','359809122','404 S 29TH AVE',0,'EDINBURG','TX','78542','5012','CY','48215','1988-09-25','F','',':RET:2106-3','N','021','DEN','1158424','33348TX002000201','2014-01-01','2013-12-12 11:18:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:03:42'),(19289,15375,'Y','18','021','EC','A','','','AC','0001666319','0001666319','LA00001850332','IL','1','Rodrigue','Latricia','','','','34','433679549','1517 JEFFERY ST',0,'DONALDSONVILLE','LA','70346','4150','CY','22005','1987-08-11','F','U',':RET:2054-5','N','021','DEN','3010161','18575LA002000201','2014-03-01','2014-01-20 21:09:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:53'),(5687,4513,'Y','18','021','EC','A','','','AC','0000630345','0000630345','OH00000168597','IL','1','Adanich','Dion','','','','34','363112890','27380 COOK RD',0,'OLMSTED FALLS','OH','44138','1097','CY','39035','1979-10-17','M','R',':RET:2106-3','N','021','DEN','1165629','99734OH005000301','2014-01-01','2013-11-26 11:36:25','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:32:29'),(16607,13284,'Y','18','021','EC','A','','','AC','0001364922','0001364922','LA00001441807','IL','1','dedon','heather','','','','34','437631007','19722 Perrilloux Rd',0,'Livingstgon','LA','70754',NULL,'CY','22063','1986-07-31','F','U',':RET:2106-3','N','021','DEN','1873120','18575LA002000201','2014-02-01','2014-01-07 18:05:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:06'),(14236,11353,'N','19','021','EC','A',NULL,NULL,'','0001025151','0000672606','','IL','1','Elkhatib','Alia','','','','34','587717504','515 Florence Dr.',0,'Madison','MS','39110',NULL,'CY','28089','1987-11-02','F','',NULL,'N','021','DEN','1703709','46300MS002000101','2014-02-01','2013-12-26 13:00:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-27 02:05:09'),(15133,12093,'Y','18','021','EC','A','','','AC','0000636019','0000636019','OH00000110441','IL','1','Doughty','John',NULL,NULL,NULL,NULL,NULL,'3916 CATHERINE AVE',0,'CINCINNATI','OH','45212','4028','CY','39061','1966-04-08','M','U',NULL,'N','021','DEN','2416684','99734OH005000401','2014-02-01','2013-12-29 20:43:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:29'),(14829,11843,'Y','18','021','EC','A','','','AC','0000167452','0000167452','MS00000621781','IL','1','Jones','Frances','','','','34','587606603','4449 AZALEA DR',0,'JACKSON','MS','39206','4413','CY','28049','1950-08-03','F','U',NULL,'N','021','DEN','2163042','46300MS002000101','2014-01-01','2013-12-23 19:41:18','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2013-12-29 11:14:31'),(28552,22598,'Y','18','021','EC','A','','','AC','0000159476','0000159476','OH00003731134','IL','1','michalkiewicz','kristin','','','','34','274829456','404 Monroe Street',0,'Delta','OH','43515',NULL,'CY','39051','1980-12-28','F','U',':RET:2106-3','N','021','HLT','3826227','92036OH003002605','2014-04-01','2014-03-07 11:54:57','123.00',NULL,NULL,'243.94','120.94','R-OH001','OH0','243.94',NULL,0,'2014-03-07 21:32:22'),(28588,22623,'N','01','021','EC','A',NULL,NULL,'','0001228127','0000223756','','IL','1','Jarrett','Jason','A','','','34','275723371','1677 ABBY DR',0,'NEWARK','OH','43055','9416','CY','39089','1975-01-21','M','',':RET:2106-3','T','021','DEN','3070144','99734OH005000401','2014-04-01','2014-03-07 18:00:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-08 21:30:00'),(4993,3961,'N','01','021','EC','A',NULL,NULL,'','0000327249','0001104418','','IL','1','Rice','Roger','','','','34','305624279','5137 RIVERVIEW DR',0,'SOUTH LEBANON','OH','45065','8782','CY','39165','1954-07-20','M','',':RET:2106-3','N','021','DEN','272020','99734OH005000301','2014-01-01','2013-12-06 21:42:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:59'),(6569,5208,'Y','18','021','EC','A','','','AC','0000400453','0000400453','TX00001278736','IL','1','White','James',NULL,NULL,NULL,NULL,NULL,'2908 S. Nelson',0,'Amarillo','TX','79103',NULL,'CY','48381','1949-11-29','M','U',':RET:2106-3','N','021','DEN','1090620','33348TX002000201','2014-01-01','2013-12-11 15:28:49','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 00:52:38'),(6100,4836,'Y','18','021','EC','A','','','AC','0000425056','0000425056','OH00000161184','31','1','WOOD','CATHY','','','','34','279568347','PO BOX 275',0,'ASHTABULA','OH','44005',NULL,'CY','39007','1953-12-02','F','U',':RET:2106-3','N','021','DEN','470292','99734OH005000401','2014-01-01','2013-11-21 15:58:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:15:11'),(14042,11187,'Y','18','021','EC','A','','','AC','0000648336','0000648336','OH00000659909','IL','1','Stebnicki','David','','','','34','307803665','1060 MELWOOD DR',0,'COLUMBUS','OH','43228','3557','CY','39049','1970-07-20','M','U',NULL,'N','021','DEN','1478003','99734OH005000301','2014-02-01','2013-12-25 18:33:13','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:03'),(27845,22025,'Y','18','024','14','A','','','TE','0000315634','0000315634','','IL','1','PEREZ','MARIBEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-08-13','F','',NULL,NULL,NULL,'','4096392','','2014-03-05','2014-03-05 13:28:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:32:10'),(9622,7620,'Y','18','021','EC','A','','','AC','0000125552','0000125552','OH00000463694','IL','1','Smith','Daniel','','','','34','290424170','29670 E RIVER RD',0,'PERRYSBURG','OH','43551','3475','CY','39173','1952-10-21','M','U',':RET:2106-3','N','021','HLT','2006739','92036OH005002605','2014-01-01','2013-12-21 14:17:32','430.00',NULL,NULL,'547.95','117.95','R-OH001','OH0','547.95',NULL,0,'2013-12-26 04:37:55'),(2475,2015,'Y','18','021','EC','A','','','AC','0000641959','0000641959','LA00001183043','IL','1','Hafford','Glenda','','','','34','439842893','9437 W DARRYL PKWY',0,'BATON ROUGE','LA','70815','8923','CY','22033','1953-05-27','F','M',':RET:2054-5','N','021','DEN','1210040','18575LA002000201','2014-01-01','2013-12-09 12:45:55','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:21'),(6860,5439,'N','01','021','EC','A',NULL,NULL,'','0000082525','0000084002','','IL','1','Devore','Steven','Douglas','','','34','286588013','1300 4TH ST',0,'LOGAN','OH','43138','1049','CY','39073','1959-10-17','M','',NULL,'N','021','DEN','621696','99734OH005000401','2014-01-01','2013-10-05 12:01:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:31:39'),(2967,2390,'Y','18','021','EC','A','','','AC','0000959806','0000959806','TX00000819024','IL','1','Alvarado','Rosalina','','','','34','460996260','2068 TRAILWOOD DR W',0,'BURLESON','TX','76028','1708','CY','48251','1961-01-28','F','U',NULL,'N','021','DEN','584004','33348TX002000201','2014-01-01','2013-12-06 12:03:39','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:16:54'),(5006,3970,'Y','18','024','14','A','','','TE','0000136036','0000136036','','IL','1','Bennett','Cathy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-01','F','',NULL,NULL,NULL,'','779972','','2013-12-06','2013-12-06 23:40:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:47:15'),(21572,17230,'N','01','021','EC','A',NULL,NULL,'','0001104487','0000221348','','IL','1','MINOR','RANDALL','','','','34','301647556','110 RIDGE SIDE CT',0,'MUNROE FALLS','OH','44262','1086','CY','39153','1958-08-17','M','',':RET:2106-3','N','021','HLT','3530493','52664OH151001305','2014-03-01','2014-02-04 22:48:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-02-05 21:30:21'),(21423,17123,'N','19','021','EC','A',NULL,NULL,'','0000904297','0000008450','','S1','1','Haddad','Saba',NULL,NULL,NULL,NULL,NULL,'5467 surrey ct',0,'West chester','OH','45069',NULL,'CY','39017','2012-02-01','F','',':RET:2106-3','N','021','HLT','3428920','92036OH004001201','2014-03-01','2014-02-03 23:16:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-04 21:01:15'),(19808,15792,'Y','18','024','14','A','','','TE','0000697124','0000697124','','IL','1','Keating','Mike',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-04-14','M','',NULL,NULL,NULL,'','3154724','','2014-01-24','2014-01-24 15:34:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:07'),(15098,12067,'Y','18','021','EC','A','','','AC','0000222409','0000222409','OH00001976889','IL','1','Hackman','Diane','Kay','','','34','279426991','6475 ROYALTON RD SW',0,'LANCASTER','OH','43130','9538','CY','39045','1959-04-29','F','U',':RET:2106-3','N','021','DEN','1460808','99734OH005000301','2014-02-01','2013-12-30 07:40:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:04:37'),(15472,12379,'N','19','021','EC','A',NULL,NULL,'','0000910534','0000784339','','IL','1','DEVORE','NOLAN','FRANCIS','','','34','738870374','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2013-07-26','M','',NULL,'N','021','DEN','1454396','99734OH005000401','2014-02-01','2013-12-30 19:18:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:28:57'),(15387,12308,'N','01','021','EC','A',NULL,NULL,'','0000903245','0001089565','','IL','1','Fox','Jeremy','','','','34','269884086','1344 W MAIN ST',0,'ASHLAND','OH','44805','1479','CY','39005','1976-01-12','M','',':RET:2106-3','T','021','HLT','2530127','52664OH151001306','2014-02-01','2014-01-01 10:47:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','319.55',NULL,1,'2014-01-02 04:25:37'),(24464,19435,'N','01','021','EC','A',NULL,NULL,'','0000390937','0000846186','','IL','1','Mitchin','Margaret','','','','34','297684292','5447 Pepperidge rd',0,'New Franklin','OH','44216',NULL,'CY','39153','1961-07-17','F','',':RET:2106-3','N','021','HLT','3565549','52664OH151001501','2014-04-01','2014-02-18 12:11:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2014-02-18 22:01:35'),(26026,20642,'Y','18','021','EC','A','','','AC','0001083506','0001083506','MS00003290463','IL','1','Mendez','Rosa','','','','34','352544221','123 CAROLYN AVE',0,'JACKSON','MS','39209','3610','CY','28049','1974-11-12','F','M',NULL,'N','021','DEN','2713381','46300MS002000101','2014-04-01','2014-02-26 11:48:51','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-02-26 21:02:18'),(1059,868,'Y','18','021','EC','A','','','AC','0000352919','0000352919','TX00000009438','IL','1','Lopez','Enrique','','','','34','303587240','2116 LIBERTY ST',0,'MISSION','TX','78573','9863','CY','48215','1952-02-09','M','M',':RET:2106-3','N','021','DEN','607981','33348TX002000201','2014-01-01','2013-12-03 17:43:24','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:16:15'),(1272,1050,'Y','18','021','EC','A','','','AC','0000446858','0000446858','TX00000958042','IL','1','Godines','Bonnie','','','','34','466934435','10015 Boston PL',0,'Dallas','TX','75217',NULL,'CY','48113','1980-12-20','F','M',':RET:2106-3','N','021','DEN','22832','33348TX002000201','2014-01-01','2013-11-29 17:16:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:30:17'),(2660,2161,'N','01','021','EC','A',NULL,NULL,'','0000898422','0000944836','','IL','1','WARRIER','MANJAPRA VARIATH P','','','','34','292134674','6731 STILLHOUSE LANE',0,'DUBLIN','OH','43016',NULL,'CY','39159','1938-10-26','F','',':RET:2029-7','N','021','DEN','304633','99734OH005000301','2014-01-01','2013-12-02 09:51:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:50'),(20606,16464,'Y','18','021','EC','A','','','AC','0000592188','0000592188','OH00002031142','IL','1','KEISTER','LISA','','','','34','284745459','4593 RODNEY ROAD',0,'COLUMBUS','OH','43227',NULL,'CY','39049','1962-05-03','F','U',':RET:2106-3','T','021','DEN','1548611','99734OH005000401','2014-03-01','2014-01-30 14:21:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:15'),(13314,10630,'Y','18','024','14','A','','','TE','0000051826','0000051826','','IL','1','Pike','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-12-05','M','',NULL,NULL,NULL,'','1870128','','2013-12-23','2013-12-23 16:18:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:58:10'),(6322,5012,'Y','18','021','EC','A','','','AC','0001102069','0001102069','OH00000770414','IL','1','Myles','Mildred','','','','34','269607016','2672 WENDEE DR',0,'CINCINNATI','OH','45238','2739','CY','39061','1966-01-16','F','U',':RET:2054-5','N','021','DEN','526081','99734OH005000401','2014-01-01','2013-12-11 11:08:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:23'),(17472,13969,'N','19','021','EC','A',NULL,NULL,'','0000268919','0000735047','','IL','1','Saxton','Tyler','','','','34','297025134','4287 mahoning rd',0,'Diamond','OH','44412',NULL,'CY','39133','1998-03-12','M','',':RET:2106-3','N','021','DEN','1625084','99734OH005000301','2014-02-01','2014-01-12 16:27:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:08'),(16984,13593,'Y','18','021','EC','A','','','AC','0000625173','0000625173','TX00001941552','31','1','HITT','GEORGE','PRESTON','','','34','451866496','PO. BOX 1073',0,'VAN','TX','75790',NULL,'CY','48467','1949-05-06','M','U',':RET:2106-3','T','021','DEN','1432113','33348TX002000101','2014-02-01','2014-01-08 20:57:40','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-13 02:20:20'),(14843,11852,'Y','18','021','EC','A','','','AC','0001130229','0001130229','OH00000267974','IL','1','Adams','Stephen','','','','34','301861825','980 N FAIRFIELD RD',0,'BEAVERCREEK','OH','45434','5922','CY','39057','1971-09-01','M','U',':RET:2106-3','N','021','HLT','2437162','92036OH006000501','2014-01-01','2013-12-23 20:11:54','0.00',NULL,NULL,'249.79','249.79','R-OH003','OH0','249.79',NULL,1,'2013-12-29 11:14:53'),(24137,19183,'Y','18','021','EC','A','','','AC','0000653246','0000653246','OH00002655485','IL','1','House','Jason','','','','34','283562684','537 McDougal St',0,'Fostoria','OH','44830',NULL,'CY','39147','1968-02-20','M','U',':RET:2106-3','T','021','HLT','2762644','92036OH003002705','2014-03-01','2014-02-15 10:13:42','215.00',NULL,NULL,'351.26','136.26','R-OH006','OH0','351.26',NULL,0,'2014-02-15 22:01:50'),(16151,12933,'N','01','021','EC','A',NULL,NULL,'','0000868244','0000051927','','IL','1','HARTZEL','GARY','','','','34','287565896','401 MAIN ST',0,'PUT IN BAY','OH','43456',NULL,'CY','39123','1954-01-24','M','',':RET:2106-3','N','021','HLT','1907812','92036OH006002701','2014-02-01','2014-01-03 15:36:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','419.70',NULL,0,'2014-01-04 02:06:14'),(948,781,'Y','18','021','EC','A','','','AC','0000674026','0000674026','OH00000051858','IL','1','Collins','Sarah','','','','34','285904879','1920 COLLINGWOOD BLVD',0,'TOLEDO','OH','43604','5062','CY','39095','1984-08-05','F','U',':RET:2106-3','N','021','DEN','1185183','99734OH005000301','2014-01-01','2013-10-28 23:56:09','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:09:29'),(25152,19952,'Y','18','021','EC','A','','','AC','0000790207','0000790207','TX00002561224','IL','1','fernandez','fernando','','','','34','460155806','421 LAFAYETTE DR',0,'EL PASO','TX','79915','3313','CY','48141','1975-09-19','M','U',NULL,'N','021','DEN','2687355','33348TX002000201','2014-04-01','2014-02-21 13:28:31','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-21 22:00:17'),(25043,19860,'Y','18','021','EC','A','','','AC','0000012484','0000012484','OH00003003447','IL','1','McCarthy','Kim','','','','34','278023754','1901 RIVER RIDGE DR',0,'SPRING VALLEY','OH','45370','9781','CY','39057','1969-01-28','F','U',':RET:2106-3','N','021','HLT','3688143','92036OH006000501','2014-04-01','2014-02-20 12:58:58','161.00',NULL,NULL,'272.22','111.22','R-OH003','OH0','272.22',NULL,0,'2014-02-20 22:01:11'),(1712,1429,'Y','18','021','EC','A','','','AC','0000251623','0000251623','OH00000845753','IL','1','Ayers','Kara','','','','34','295863047','506 W. Elizabeth St.',0,'Coldwater','OH','45828',NULL,'CY','39107','1974-09-12','F','U',':RET:2106-3','N','021','HLT','1514598','92036OH003001505','2014-01-01','2013-12-24 15:12:17','200.00',NULL,NULL,'290.05','90.05','R-OH002','OH0','290.05',NULL,0,'2013-12-25 18:55:01'),(20707,16546,'N','01','021','EC','A',NULL,NULL,'','0001323675','0002038964','','IL','1','castleberry','Dustin','','','','34','434671456','12063 CROSSETT RD',0,'BASTROP','LA','71220','7699','CY','22067','1984-03-31','M','',':RET:2106-3','N','021','DEN','3080726','18575LA002000201','2014-03-01','2014-01-30 12:26:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-30 21:01:07'),(20615,16473,'Y','18','021','EC','A','','','AC','0001209331','0001209331','LA00002546238','IL','1','DUHON','JOHNNY','','','Sr','34','437517911','408 S CENTRAL ST',0,'DELCAMBRE','LA','70528','4302','CY','22113','1973-03-29','M','U',NULL,'T','021','DEN','2927268','18575LA002000101','2014-03-01','2014-01-30 12:15:20','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-01-30 21:00:20'),(20083,16021,'Y','18','021','EC','A','','','AC','0001948821','0001948821','LA00002523065','IL','1','Walker','Jess','','','','34','547635839','3009 TUPELO ST',0,'KENNER','LA','70065','4352','CY','22051','1966-07-08','M','U',':RET:2106-3','N','021','DEN','2774978','18575LA002000101','2014-03-01','2014-01-26 18:20:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-27 21:00:24'),(17449,13956,'N','19','021','EC','A',NULL,NULL,'','0001005730','0000799906','','IL','1','Kennedy','Thomas',NULL,NULL,NULL,NULL,NULL,'215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','2010-03-16','M','',':RET:2106-3','N','021','HLT','1698891','92036OH002000601','2014-02-01','2014-01-10 14:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-01-13 03:00:38'),(16157,12939,'Y','18','021','EC','A','','','AC','0000208479','0000208479','OH00001271745','IL','1','Bloomfield','James','','','','34','272607979','3636 HIAWATHA TRL',0,'LIMA','OH','45806','1547','CY','39003','1958-03-25','M','M',':RET:2106-3','N','021','DEN','1706694','99734OH005000301','2014-01-01','2013-12-16 22:06:29','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,0,'2014-01-04 06:00:06'),(24910,19750,'Y','18','021','EC','A','','','AC','0000544082','0000544082','OH00002647096','IL','1','McCarver','Floyd','','','','34','295660188','5992 RUIHLEY WAY',0,'WESTERVILLE','OH','43081','8084','CY','39049','1974-10-05','M','U',':RET:2054-5','N','021','DEN','3588482','99734OH005000401','2014-04-01','2014-02-20 11:15:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-20 21:30:07'),(4031,3219,'Y','18','021','EC','A','','','AC','0000812008','0000812008','OH00000522634','IL','1','RADER','MARK','','','','34','503683019','8030 PADDINGTON LN',0,'CINCINNATI','OH','45249','1541','CY','39061','1958-10-17','M','U',':RET:2106-3','N','021','DEN','1985663','99734OH005000401','2014-01-01','2013-12-17 09:47:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:54'),(24260,19265,'Y','18','021','EC','A','','','AC','0000440828','0000440828','TX00002172047','IL','1','PORTILLO','OSCAR','','','','34','460957181','400 LINDA LN',0,'WEBSTER','TX','77598','5040','CY','48201','1957-11-11','M','U',NULL,'N','021','DEN','3098485','33348TX002000201','2014-04-01','2014-02-17 17:17:24','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-17 19:00:10'),(26654,21130,'N','19','021','EC','A',NULL,NULL,'','0000976793','0000087538','','IL','1','Barnette','Allison','','','','34','269080761','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','2002-08-23','F','',':RET:2106-3','N','021','HLT','3502526','52664OH151001305','2014-04-01','2014-02-28 13:43:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:08'),(28822,22810,'Y','18','021','EC','A','','','AC','0000099055','0000099055','OH00002925887','31','1','babcock','matthew','','','','34','273583796','12865 five point road',0,'perrysburg','OH','43551',NULL,'CY','39095','1956-06-25','M','U',':RET:2106-3','T','021','HLT','4120895','92036OH004002601','2014-04-01','2014-03-09 10:58:34','350.00',NULL,NULL,'439.43','89.43','R-OH001','OH0','439.43',NULL,0,'2014-03-09 21:01:00'),(3505,2816,'Y','18','024','14','A','','','TE','0000697905','0000697905','','IL','1','Glass','Cena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-12','F','',NULL,NULL,NULL,'','1934936','','2013-12-22','2013-12-22 18:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:20:50'),(18053,14424,'Y','18','021','EC','A','','','AC','0000638321','0000638321','MS00001690046','IL','1','fonville','william','','','','34','587469817','147 DREW RULEVILLE RD',0,'RULEVILLE','MS','38771','9731','CY','28133','1950-12-22','M','M',':RET:2054-5','N','021','DEN','2758135','46300MS002000101','2014-02-01','2014-01-14 16:41:16','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-01-15 02:07:17'),(19575,15603,'Y','18','021','EC','A','','','AC','0002098174','0002098174','LA00002298825','IL','1','Fuselier','Angelica','','','','34','433390159','183 Erine Benoit Road',0,'Lake Charles','LA','70615',NULL,'CY','22019','1970-12-07','F','U',':RET:2106-3','T','021','DEN','1600215','18575LA002000201','2014-03-01','2014-01-22 17:24:02','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-23 03:02:38'),(19659,15664,'Y','18','024','14','A','','','TE','0001223143','0001223143','','IL','1','Kilby','Brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-01-26','M','',NULL,NULL,NULL,'','1180245','','2014-01-23','2014-01-23 15:30:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:00:23'),(482,393,'N','01','021','EC','A',NULL,NULL,'','0000700745','0000954619','','IL','1','alexander','jesse','','','','34','530048602','70202 9th street',0,'covington','LA','70433',NULL,'CY','22103','1971-07-05','M','',':RET:2106-3','N','021','DEN','1145005','18575LA002000201','2014-01-01','2013-12-03 22:29:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 17:48:11'),(846,700,'Y','18','021','EC','A','','','AC','0000490682','0000490682','LA00000618922','IL','1','Ha','Hang','','','','34','586426747','2440 SUNSET DR',0,'HARVEY','LA','70058','2145','CY','22051','1953-12-23','F','M',':RET:2047-9','N','021','DEN','710831','18575LA002000101','2014-01-01','2013-12-16 00:31:13','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:06:45'),(5312,4212,'Y','18','021','EC','A','','','AC','0000449857','0000449857','OH00000094037','31','1','MYERS','BRENDA','SUE','','','34','297749659','P O Box 406',0,'Kingsville','OH','44048',NULL,'CY','39007','1963-07-30','F','U',':RET:2106-3','T','021','DEN','2109055','99734OH005000301','2014-01-01','2013-12-18 19:38:41','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:06:36'),(6343,5026,'Y','18','021','EC','A','','','AC','0000725041','0000725041','OH00000117231','IL','1','BAILEY','JOSEPH','','','','34','580508743','54 GREENFIELD SABINA RD',0,'GREENFIELD','OH','45123','9128','CY','39047','1950-06-07','M','M',NULL,'N','021','DEN','1227611','99734OH005000401','2014-01-01','2013-12-11 12:17:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:49'),(17665,14117,'Y','18','021','EC','A','','','AC','0000542699','0000542699','OH00002393996','IL','1','Connerth','David','','','','34','284662274','3712 SACHEM AVE',0,'CINCINNATI','OH','45226','1754','CY','39061','1961-06-01','M','R',':RET:2106-3','N','021','DEN','2313708','99734OH005000301','2014-02-01','2014-01-13 15:57:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:46'),(2690,2180,'Y','18','021','EC','A','','','AC','0000411585','0000411585','TX00001178294','IL','1','Kerr','Charles','','','','34','456962942','48 MARCY DR',0,'BORGER','TX','79007','8432','CY','48233','1953-05-21','M','M',':RET:2106-3','N','021','DEN','848696','33348TX002000201','2014-01-01','2013-12-02 14:54:32','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:47:29'),(17800,14219,'Y','18','021','EC','A','','','AC','0001036149','0001036149','OH00001609422','IL','1','Schultz','Hillary','','','','34','271820564','3920 Pansy Rd',0,'Clarksville','OH','45113',NULL,'CY','39027','1978-11-17','F','M',':RET:2106-3','T','021','HLT','2630655','92036OH005000606','2014-02-01','2014-01-13 17:01:22','488.00',NULL,NULL,'609.28','121.28','R-OH005','OH0','301.66',NULL,0,'2014-01-14 01:33:53'),(15152,12111,'Y','18','024','14','A','','','TE','0000148345','0000148345','','IL','1','HASAN','TAMIKA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-07','F','',NULL,NULL,NULL,'','1486495','','2013-12-30','2013-12-30 12:45:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:06'),(7771,6152,'Y','18','021','EC','A','','','AC','0000449318','0000449318','TX00000530131','IL','1','Hayes','Howard','','','','34','515943174','406 SHERMAN ST',0,'NOCONA','TX','76255','3415','CY','48337','1970-11-03','M','U',':RET:2106-3','T','021','DEN','2019353','33348TX002000201','2014-01-01','2013-12-19 18:58:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:02:54'),(14047,11191,'Y','18','021','EC','A','','','AC','0000542681','0000542681','OH00000310280','IL','1','HOGAN-FULLER','VALERIE','','','','34','291582094','1341 W NORTH BEND RD',0,'CINCINNATI','OH','45224','2646','CY','39061','1958-07-16','F','U',':RET:2054-5','N','021','DEN','2160452','99734OH005000301','2014-02-01','2013-12-26 11:13:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:11'),(1303,1079,'Y','18','021','EC','A','','','AC','0000480758','0000480758','TX00000073327','IL','1','White','Heleana','','','','34','570416427','616 Josephine',0,'Holland','TX','76534',NULL,'CY','48027','1972-09-29','F','U',':RET:2106-3','T','021','DEN','1119832','33348TX002000201','2014-01-01','2013-11-04 05:50:50','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 18:31:14'),(6630,5258,'Y','18','021','EC','A','','','AC','0000643210','0000643210','OH00001037541','IL','1','GILBERT','ANGELA','','','','34','289047677','4820 296TH STREET',0,'TOLEDO','OH','43611',NULL,'CY','39095','1999-11-24','F','R',':RET:2106-3','N','021','HLT','581255','92036OH001002601','2014-01-01','2013-12-11 16:54:51','74.61',NULL,NULL,'149.37','74.76','R-OH001','OH0','149.37',NULL,0,'2013-12-26 00:54:19'),(27043,21418,'Y','18','024','14','A','','','TE','0002047849','0002047849','','IL','1','BERRY','MONIQUE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-05-06','F','',NULL,NULL,NULL,'','1607300','','2014-03-31','2014-03-03 11:54:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-03 21:00:22'),(9429,7481,'Y','18','021','EC','A','','','AC','0000414099','0000414099','TX00001312556','IL','1','Cummings','Monique','','','','34','434069195','1912 KNOB HILL DR',0,'PLANO','TX','75023','6507','CY','48085','1966-10-12','F','U',NULL,'N','021','DEN','1983820','33348TX002000201','2014-01-01','2013-12-21 17:42:53','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:33:21'),(7882,6235,'N','01','021','EC','A',NULL,NULL,'','0001174396','0000547871','','IL','1','thornton','david','','','','34','271827908','8317 WAINSTEAD DR',0,'PARMA','OH','44129','4846','CY','39035','1967-07-26','M','',':RET:2054-5','N','021','DEN','2601350','99734OH005000301','2014-01-01','2013-12-20 17:55:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:27'),(23159,18462,'N','01','021','EC','A',NULL,NULL,'','0000929304','0001015640','','IL','1','MARTIN','MARCUS','DOUGLAS','','','34','460790828','7246 FOX HALL LN',0,'HUMBLE','TX','77338','1456','CY','48201','1973-02-13','M','',':RET:2054-5','N','021','DEN','3130894','33348TX002000101','2014-03-01','2014-02-12 09:16:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-12 21:31:46'),(4508,3573,'Y','18','024','14','A','','','TE','0000950017','0000950017','','IL','1','Tran','Vivian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-10-15','F','',NULL,NULL,NULL,'','929760','','2013-12-11','2013-12-11 23:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:03:32'),(7058,5606,'N','01','021','EC','A',NULL,NULL,'','0000611960','0000689700','','IL','1','Hoyt','Andrew','Mark','','','34','269688869','5909 LENGWOOD DR',0,'CINCINNATI','OH','45244','3810','CY','39061','1960-05-04','M','',':RET:2106-3','N','021','DEN','1874025','99734OH005000301','2014-01-01','2013-12-24 20:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:49:52'),(20310,16213,'Y','18','021','EC','A','','','AC','0000266829','0000266829','TX00002023945','IL','1','BALDWIN','JAMES','','','','34','557430979','2569 Surrey Hills Estate Road',0,'McKinney','TX','75069',NULL,'CY','48085','1975-10-22','M','U',':RET:2106-3','N','021','DEN','2936778','33348TX002000201','2014-03-01','2014-01-28 12:07:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-28 21:00:48'),(20033,15976,'N','01','021','EC','A',NULL,NULL,'','0000103912','0001077780','','IL','1','Sherman','Peggy','','','','34','292560579','339 WATERLOO ST',0,'MARION','OH','43302','4769','CY','39101','1954-11-09','F','',':RET:2106-3','N','021','DEN','3363721','99734OH005000301','2014-03-01','2014-01-25 21:21:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:21'),(3592,2881,'N','19','021','EC','A',NULL,NULL,'','0001218537','0000571980','','S1','1','davis','teresa','d','','','34','298045358','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','2000-05-17','M','',':RET:2106-3','N','021','HLT','2277857','92036OH003001201','2014-01-01','2013-12-22 10:38:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 21:23:03'),(17165,13735,'Y','18','021','EC','A','','','AC','0001799638','0001799638','LA00001869867','IL','1','Davis','Daranise','','','','34','434792902','2534 Mexico st',0,'New Orleans','LA','70122',NULL,'CY','22071','1990-04-02','F','U',':RET:2054-5','N','021','DEN','1474518','18575LA002000201','2014-02-01','2014-01-08 15:41:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:22:05'),(15154,12113,'Y','18','021','EC','A','','','AC','0001163849','0001163849','OH00000167408','IL','1','KORNEGAY','SHARRON','','','','34','577764413','2605 BERWICK BLVD',0,'COLUMBUS','OH','43209',NULL,'CY','39049','1954-03-09','F','U',NULL,'N','021','DEN','1804904','99734OH005000401','2014-02-01','2013-12-30 12:59:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:06:09'),(28976,22933,'Y','18','021','EC','A','','','AC','0001900778','0001900778','LA00003579756','IL','1','PHILLIPS','EVA','M','','','34','437046152','1627 COX ST',0,'SHREVEPORT','LA','71108',NULL,'CY','22017','1965-06-08','F','U',':RET:2054-5','N','021','DEN','4028833','18575LA002000201','2014-04-01','2014-03-10 17:28:03','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-10 21:01:05'),(14432,11510,'Y','18','021','EC','A','','','AC','0002016437','0002016437','LA00000788948','IL','1','Jackson','Katrina','','','','34','438595690','7473 OAKLEAF DR',0,'BATON ROUGE','LA','70812','3728','CY','22033','1978-10-21','F','U',NULL,'N','021','DEN','2320618','18575LA002000201','2014-02-01','2013-12-26 22:49:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-28 03:31:58'),(23875,18997,'N','19','021','EC','A',NULL,NULL,'','0001066019','0000857156','','IL','1','Simmons','Victoria',NULL,NULL,NULL,NULL,NULL,'2155 FOWL RD',0,'ELYRIA','OH','44035','4474','CY','39093','1992-05-21','F','',NULL,'N','021','HLT','3387705','52664OH151001501','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2014-02-14 21:32:12'),(21793,17405,'Y','18','021','EC','A','','','AC','0001051940','0001051940','OH00001375822','IL','1','WHITT','ANGELA','','','','34','286709710','11 TAYLOR AVE',0,'NORTH BEND','OH','45052',NULL,'CY','39061','1970-04-21','F','U',':RET:2106-3','N','021','DEN','3270153','99734OH005000401','2014-03-01','2014-02-06 14:55:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-06 21:00:45'),(19110,15226,'Y','18','021','EC','A','','','AC','0000418912','0000418912','OH00002027535','IL','1','Oliver','Brandy','C','','','34','285748755','199 Market Street',0,'Cortland','OH','44410',NULL,'CY','39155','1979-01-14','F','U',':RET:2054-5','T','021','HLT','2754371','52664OH151001306','2014-03-01','2014-01-18 15:05:25','219.00',NULL,NULL,'355.39','136.39','R-OH013','OH0','355.39',NULL,0,'2014-01-21 08:44:44'),(17779,14203,'N','01','021','EC','A',NULL,NULL,'','0000406596','0000751261','','IL','1','CLAY','KEITH','','','','34','454415519','8702 BROOKHOLLOW DR',0,'ROWLETT','TX','75089','8621','CY','48113','1964-05-01','M','',NULL,'N','021','DEN','1581611','33348TX002000101','2014-02-01','2014-01-13 16:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-14 01:33:41'),(7661,6067,'Y','18','021','EC','A','','','AC','0001701513','0001701513','LA00000048203','IL','1','Blanton','Joshua','','','','34','315116761','3640 MARIGNY ST',0,'NEW ORLEANS','LA','70122','4537','CY','22071','1986-03-05','M','U',':RET:2106-3','N','021','DEN','2128073','18575LA002000101','2014-01-01','2013-12-20 13:30:18','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 03:00:17'),(7427,5878,'Y','18','021','EC','A','','','AC','0001097761','0001097761','OH00000487096','IL','1','Preto','Vickie','Renee','','','34','291466884','1206 WEISER AVE',0,'AKRON','OH','44314','1429','CY','39153','1959-02-26','F','M',':RET:2106-3','N','021','HLT','1046499','52664OH151001306','2014-01-01','2013-12-14 18:14:03','862.00',NULL,NULL,'996.40','134.40','R-OH012','OH0','476.12',NULL,0,'2013-12-26 02:30:03'),(9127,7238,'Y','18','021','EC','A','','','AC','0000119354','0000119354','MS00000002902','31','1','EVERETT','NELLIE','','','','34','587682028','PO BOX 63',0,'MAGNOLIA','MS','39652',NULL,'CY','28113','1951-03-15','F','U',':RET:2054-5','N','021','DEN','2414706','46300MS002000101','2014-01-01','2013-12-17 20:16:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 04:07:53'),(19684,15687,'Y','18','021','EC','A','','','AC','0001118247','0001118247','TX00002169006','IL','1','SHIELDS','ROBIN','LACHELLE','','','34','447625638','595 JIM CANNON RD',0,'VAN ALSTYNE','TX','75495','2729','CY','48181','1976-09-30','F','M',':RET:2106-3','N','021','DEN','2815178','33348TX002000201','2014-03-01','2014-01-23 13:09:38','0.00',NULL,NULL,'31.70','31.70','R-TX020','TX0','15.85',NULL,0,'2014-01-23 21:00:39'),(7134,5661,'Y','18','021','EC','A','','','AC','0001042884','0001042884','MS00000418725','IL','1','Scurfield','Helani','','','','34','534045044','26441 W MAPLE RD',0,'PASS CHRISTIAN','MS','39571','8620','CY','28047','1982-06-22','F','U',':RET:2106-3','N','021','DEN','2005745','46300MS002000101','2014-01-01','2013-12-24 22:57:59','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-26 01:51:42'),(3488,2800,'Y','18','021','EC','A','','','AC','0000496750','0000496750','OH00001005958','IL','1','Loveridge','Jeremy','','','','34','271946481','3291 CLAY ST',0,'AUSTINBURG','OH','44010','9709','CY','39007','1990-02-22','M','U',NULL,'N','021','DEN','1945389','99734OH005000401','2014-01-01','2013-12-22 12:22:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:21'),(18336,14642,'Y','18','021','EC','A','','','AC','0000394952','0000394952','OH00001769396','IL','1','battisti','gail','','','','34','163445078','1892 CHAPEL HILL DR',0,'YOUNGSTOWN','OH','44511','1277','CY','39099','1952-05-09','F','M',NULL,'N','021','DEN','2791815','99734OH005000401','2014-02-01','2014-01-15 17:32:23','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-16 08:45:15'),(4639,3676,'Y','18','024','14','A','','','TE','0000136286','0000136286','','IL','1','SAWYER','CHARLES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-03-10','M','',NULL,NULL,NULL,'','329363','','2013-12-12','2013-12-12 09:59:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 22:06:44'),(16516,13212,'Y','18','021','EC','A','','','AC','0001059861','0001059861','TX00001458737','IL','1','Zapata','Julie','','','','34','346822387','3801 KENWOOD DR',0,'ODESSA','TX','79762','7017','CY','48135','1988-08-14','F','M',':RET:2106-3','N','021','DEN','1793763','33348TX002000201','2014-02-01','2014-01-04 23:39:11','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,1,'2014-01-07 10:21:30'),(15468,12376,'Y','18','024','14','A','','','TE','0000231466','0000231466','','IL','1','tomblin','jayson',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-22','M','',NULL,NULL,NULL,'','1180034','','2013-12-30','2013-12-30 18:45:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:28:49'),(25125,19929,'N','01','021','EC','A',NULL,NULL,'','0001174433','0000646036','','IL','1','ulrick','beverly','','','','34','278763644','248 N FAIR AVE',0,'OTTAWA','OH','45875','1623','CY','39137','1972-03-12','F','',':RET:2106-3','N','021','HLT','3177188','92036OH004001501','2014-04-01','2014-02-20 20:29:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','234.49','CIC',0,'2014-02-21 21:30:23'),(28590,22625,'Y','18','021','EC','A','','','AC','0000879556','0000879556','OH00002830856','IL','1','Tyrrell','Anthony','','','','34','294965527','1161 KINGSTON RD',0,'UNIONTOWN','OH','44685','9667','CY','39153','1994-01-20','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','4023864','99734OH005000401','2014-04-01','2014-03-07 21:38:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78',NULL,0,'2014-03-08 21:30:01'),(2327,1893,'Y','18','021','EC','A','','','AC','0000608599','0000608599','TX00000340521','IL','1','Edwards','Audrey','','','','34','438020028','503 MAYS ST',0,'JASPER','TX','75951','5114','CY','48241','1954-12-28','F','U',':RET:2054-5','N','021','DEN','357934','33348TX002000201','2014-01-01','2013-12-09 11:25:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:34'),(23653,18834,'Y','18','021','EC','A','','','AC','0000439592','0000439592','TX00002217715','IL','1','ZUNIGA','MIREYA','Y','','','34','631318336','2405 CHURCH ST',0,'GONZALES','TX','78629','2171','CY','48177','1977-05-29','F','M',NULL,'N','021','DEN','2961730','33348TX002000201','2014-03-01','2014-02-14 00:09:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:15'),(23547,18759,'Y','18','021','EC','A','','','AC','0001605756','0001605756','LA00002812576','IL','1','Hall','Bessie','','','','34','435901472','115 DOUGLAS RD',0,'SHREVEPORT','LA','71115','9462','CY','22081','1951-12-12','F','U',':RET:2054-5','N','021','DEN','2815629','18575LA002000201','2014-03-01','2014-02-13 14:23:03','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-13 22:02:36'),(23290,18567,'Y','18','021','EC','A','','','AC','0000603399','0000603399','OH00001524665','IL','1','Donohue','Susan','','','','34','283420191','5505 US ROUTE 40',0,'TIPP CITY','OH','45371','9419','CY','39109','1954-02-15','F','M',NULL,'N','021','DEN','3238505','99734OH005000301','2014-03-01','2014-02-12 21:48:53','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-13 22:00:07'),(6317,5009,'N','19','021','EC','A',NULL,NULL,'','0000648299','0000610846','','IL','1','Setser','Alexandra','Morgan','','','34','284043769','166 FIELDSTONE WAY',0,'LEBANON','OH','45036','7745','CY','39165','1999-07-28','F','',':RET:2106-3','N','021','DEN','1205822','99734OH005000401','2014-01-01','2013-12-11 10:59:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:18'),(6307,5003,'Y','18','021','EC','A','','','AC','0000798399','0000798399','OH00001138422','IL','1','Cordray','Betty','','','','34','276581838','282 CLOUSE LN',0,'GRANVILLE','OH','43023','1492','CY','39089','1955-05-19','F','M',NULL,'N','021','DEN','626842','99734OH005000401','2014-01-01','2013-12-11 10:25:53','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:04'),(5617,4457,'Y','18','021','EC','A','','','AC','0001167966','0001167966','OH00000899356','IL','1','Antonetz','Cheryl','','','','34','278507621','1273 MUIRWOOD DR',0,'ZANESVILLE','OH','43701','6449','CY','39119','1950-10-15','F','M',':RET:2106-3','N','021','DEN','919609','99734OH005000401','2014-01-01','2013-11-26 09:57:36','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:30:40'),(21507,17182,'Y','18','021','EC','A','','','AC','0001043427','0001043427','OH00001608801','IL','1','Rowley','Thomas','','','','34','281423220','7085 Oakridge Road',0,'Hillsboro','OH','45133',NULL,'CY','39071','1951-05-11','M','U',':RET:2106-3','T','021','HLT','3671754','92036OH004000601','2014-03-01','2014-02-04 15:14:39','566.13',NULL,NULL,'570.30','4.17','R-OH005','OH0','570.30',NULL,0,'2014-02-04 21:01:56'),(15497,12399,'N','19','021','EC','A',NULL,NULL,'','0000910534','0000177616','','IL','1','DEVORE','WESLEY','DAVID','','','34','093994907','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2011-10-01','M','',NULL,'N','021','DEN','2022527','99734OH005000401','2014-02-01','2013-12-31 12:18:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:41'),(24608,19529,'N','01','021','EC','A',NULL,NULL,'','0000788253','0000136132','','IL','1','Sexton','Tiffany','Lee','','','34','272880493','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','1984-08-24','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:13:32'),(17898,14296,'Y','18','021','EC','A','','','AC','0000849455','0000849455','OH00001501703','IL','1','Cook','Pamela','','','','34','298625657','1001 LEWIS ST',0,'WASHINGTON COURT HOUSE','OH','43160','9183','CY','39047','1957-11-26','F','M',':RET:2106-3','N','021','DEN','1489168','99734OH005000401','2014-02-01','2014-01-14 18:06:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:22'),(24513,19473,'N','19','021','EC','A',NULL,NULL,'','0000737484','0000699674','','IL','1','Hinojosa','Devin','','','','34','638908424','6200 Crosscreek Ln',0,'Benbrook','TX','76109',NULL,'CY','48439','2004-03-08','M','',NULL,'N','021','DEN','2793876','33348TX002000201','2014-04-01','2014-02-19 10:40:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-20 03:54:20'),(26402,20939,'N','19','021','EC','A',NULL,NULL,'','0000042085','0000349317','','IL','1','Older','Peyton','','','','34','278068065','1060 E MILLTOWN RD',0,'WOOSTER','OH','44691','1848','CY','39169','2001-03-31','F','',':RET:2106-3','N','021','HLT','2973579','52664OH151001304','2014-03-01','2014-02-26 15:04:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:31'),(27574,21806,'N','01','021','EC','A',NULL,NULL,'','0000639476','0000017624','','IL','1','Jones','Marrian','D','','','34','425217342','1445 BUCK LN',0,'JACKSON','MS','39209','9437','CY','28049','1970-04-23','F','',':RET:2054-5','N','021','DEN','2953183','46300MS002000201','2014-04-01','2014-03-04 11:39:08',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85','CIC',0,'2014-03-04 21:30:22'),(29190,23102,'N','01','021','EC','A',NULL,NULL,'','0000815378','0000293238','','IL','1','Sebe','Jennifer','','','','34','302641299','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','1969-08-22','F','',':RET:2106-3','N','021','HLT','3135230','52664OH151001301','2014-04-01','2014-03-10 16:59:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54','CIC',0,'2014-03-10 21:30:04'),(287,237,'Y','18','021','EC','A','','','AC','0000618748','0000618748','TX00000459462','IL','1','Bernard','Terrance','','','','34','439754945','8306 SWAN MEADOW LN',0,'HUMBLE','TX','77338','1732','CY','48201','1986-11-06','M','U',NULL,'N','021','DEN','156254','33348TX002000101','2014-01-01','2013-10-12 14:25:52','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 17:30:26'),(9268,7352,'Y','18','021','EC','A','','','AC','0001111632','0001111632','OH00001207357','IL','1','BRAUER','TIMOTHY','J','','','34','277823551','20109 MAPLE HEIGHTS BLVD',0,'MAPLE HEIGHTS','OH','44137','1818','CY','39035','1971-09-15','M','U',':RET:2106-3','N','021','DEN','72798','99734OH005000401','2014-01-01','2013-11-30 07:59:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:15:33'),(24002,19086,'Y','18','021','EC','A','','','AC','0001168047','0001168047','OH00002644673','S3','1','Stockslager','Brad','','','','34','276062054','48 SHIELD DR',0,'EATON','OH','45320','2753','CY','39135','2001-01-31','F','U',NULL,'N','021','DEN','3717436','99734OH005000401','2014-03-01','2014-02-15 10:24:29','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-02-15 22:00:34'),(4099,3275,'N','01','021','EC','A',NULL,NULL,'','0000316687','0000030812','','IL','1','Tucker','LaDonna','','','','34','452085456','1884 S CONCHO DR',0,'SAN ANGELO','TX','76904','7971','CY','48451','1960-12-29','F','',':RET:2106-3','N','021','DEN','1479746','33348TX002000101','2014-01-01','2013-12-16 20:28:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 21:47:41'),(6149,4876,'Y','18','021','EC','A','','','AC','0000644636','0000644636','OH00000683016','IL','1','Kauffman','Joseph','L','','','34','273442587','9603 HICKORY HILL DR',0,'TWINSBURG','OH','44087','1546','CY','39153','1950-11-02','M','M',NULL,'N','021','HLT','985951','52664OH151001501','2014-01-01','2013-11-21 05:26:21','959.00',NULL,NULL,'1579.12','620.12','R-OH012','OH0','789.56',NULL,0,'2013-12-26 00:16:28'),(4507,3572,'N','01','021','EC','A',NULL,NULL,'','0000950017','0000151554','','IL','1','Tran','Cuong','','','','34','009505639','4536 9TH ST',0,'BACLIFF','TX','77518','2259','CY','48167','1973-11-11','M','',':RET:2028-9','N','021','DEN','962319','33348TX002000201','2014-01-01','2013-12-11 23:12:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:30'),(18268,14583,'N','01','021','EC','A',NULL,NULL,'','0000102399','0001113171','','IL','1','Smus','Piotr','','','','34','380043323','2914 HUNTINGTON WAY',0,'PEARLAND','TX','77584','9423','CY','48039','1974-05-07','M','',NULL,'N','021','DEN','2263147','33348TX002000201','2014-02-01','2014-01-15 15:58:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-16 08:44:40'),(17820,14235,'Y','18','021','EC','A','','','AC','0000863058','0000863058','MS00001665470','IL','1','BRIGHAM','TERRY','','','','34','428291991','1001 ANTIOCH',0,'TUNICA','MS','38676',NULL,'CY','28143','1974-08-18','M','U',':RET:2054-5','T','021','DEN','1944997','46300MS002000201','2014-02-01','2014-01-14 09:56:55','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2014-01-15 02:05:56'),(15040,12022,'Y','18','021','EC','A','','','AC','0001735370','0001735370','LA00000481827','IL','1','Nguyen','Ha','','','','34','433854160','2736 Fairfield Dr',0,'Gretna','LA','70056',NULL,'CY','22051','1964-01-04','F','U',':RET:2047-9','N','021','DEN','2605859','18575LA002000201','2014-02-01','2013-12-30 12:41:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:55'),(26220,20795,'Y','18','021','EC','A','','','AC','0000966016','0000966016','TX00002194415','IL','1','EDWARDS','CARON','','','','34','461477450','1507 W 6TH ST',0,'MOUNT PLEASANT','TX','75455','3008','CY','48449','1961-08-05','F','U',NULL,'N','021','DEN','3838313','33348TX002000201','2014-04-01','2014-02-26 19:04:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:30:57'),(27339,21648,'Y','18','021','EC','A','','','AC','0001016904','0001016904','OH00003051560','IL','1','Arnold','Gregory','','','','34','289540032','4250 E 151ST ST',0,'CLEVELAND','OH','44128','1907','CY','39035','1955-06-02','M','U',':RET:2054-5','N','021','DEN','3353153','99734OH005000401','2014-04-01','2014-03-04 10:13:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:00:57'),(2173,1788,'Y','18','021','EC','A','','','AC','0000393642','0000393642','OH00000948416','IL','1','Loughridge','William','','','','34','299669518','219 S BRANDON AVE',0,'CELINA','OH','45822','2012','CY','39107','1961-09-22','M','M',':RET:2106-3','N','021','HLT','1182800','92036OH003001501','2014-01-01','2013-12-09 20:34:19','484.00',NULL,NULL,'1151.01','667.01','R-OH002','OH0','448.63',NULL,0,'2013-12-25 19:19:14'),(2203,1814,'Y','18','024','14','A','','','TE','0000378543','0000378543','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','269311','','2013-12-10','2013-12-10 16:25:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:20:05'),(23611,18805,'N','01','021','EC','A',NULL,NULL,'','0001033709','0000212212','','IL','1','Shinall','Phyliss','M','','','34','293661251','529 N WAGNER AVE',0,'SIDNEY','OH','45365','1249','CY','39149','1959-06-14','F','',':RET:2106-3','T','021','HLT','2693423','92036OH003000506','2014-03-01','2014-02-13 12:54:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','609.49',NULL,0,'2014-02-13 22:03:12'),(22205,17723,'Y','18','021','EC','A','','','AC','0000870639','0000870639','OH00002049508','IL','1','darby','susan','','','','34','185467040','7 WHITEFRIARS DR',0,'AKRON','OH','44319','3050','CY','39153','1955-01-19','F','M',':RET:2106-3','N','021','DEN','3324252','99734OH005000401','2014-03-01','2014-02-09 14:26:32','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-02-09 19:00:17'),(2282,1861,'N','19','021','EC','A',NULL,NULL,'','0001237681','0000510622','','S3','1','Johnson','Michael','I','','','34','674013659','2610 KEMPERWOOD DR',0,'BLACKLICK','OH','43004','8667','CY','39049','1998-04-12','F','',NULL,'N','021','DEN','551987','99734OH005000301','2014-01-01','2013-12-09 12:47:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:35'),(14859,11864,'Y','18','024','14','A','','','TE','0000323502','0000323502','','IL','1','tarulli','jason',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-30','M','',NULL,NULL,NULL,'','1376969','','2013-12-23','2013-12-23 20:24:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:15:18'),(6783,5380,'Y','18','021','EC','A','','','AC','0001229370','0001229370','TX00000472629','IL','1','Bell','Bryan','Marsh','','','34','453804353','714 BURLESON ST',0,'SAN MARCOS','TX','78666','4335','CY','48209','1951-04-01','M','U',':RET:2106-3','N','021','DEN','40727','33348TX002000201','2014-01-01','2013-11-25 17:52:04','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:16:54'),(6845,5426,'Y','18','021','EC','A','','','AC','0000802538','0000802538','OH00000636103','IL','1','Sanchez','Cynthia','','','','34','296681724','266 E PEARL ST',0,'TOLEDO','OH','43608','1125','CY','39095','1959-08-31','F','U',NULL,'T','021','HLT','151670','92036OH006002601','2014-01-01','2013-11-14 13:44:58','270.00',NULL,NULL,'379.69','109.69','R-OH001','OH0','379.69',NULL,0,'2013-12-26 01:31:12'),(2377,1939,'Y','18','021','EC','A','','','AC','0000864798','0000864798','OH00000767494','IL','1','emlinger','Robert','','','','34','283503349','429 N WAYNE ST',0,'KENTON','OH','43326','1384','CY','39065','1951-02-23','M','U',':RET:2106-3','N','021','DEN','143212','99734OH005000401','2014-01-01','2013-12-09 10:21:45','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 19:32:55'),(8104,6411,'Y','18','021','EC','A','','','AC','0000108143','0000108143','OH00001178924','IL','1','DOLNEY','JIN','','','','34','297045947','4700 LOGAN GATE RD',0,'YOUNGSTOWN','OH','44505','1716','CY','39155','1975-11-11','F','M',':RET:2034-7','N','021','HLT','1948858','92036OH005003205','2014-01-01','2013-12-20 16:11:21','551.00',NULL,NULL,'733.91','182.91','R-OH013','OH0','301.61',NULL,0,'2013-12-26 03:10:55'),(8895,7053,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00000233034','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','2460507','33348TX002000201','2014-01-01','2013-12-18 18:06:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:02:08'),(25728,20407,'N','01','021','EC','A',NULL,NULL,'','0002029265','0001242700','','IL','1','ware','william','','','Jr','34','435069753','114 Current Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1958-02-26','M','',NULL,'N','021','DEN','2780474','18575LA002000201','2014-04-01','2014-02-24 13:20:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-26 09:30:33'),(28296,22388,'N','19','021','EC','A',NULL,NULL,'','0000198629','0000644738','','S1','1','Reddy','James','Martin',NULL,NULL,NULL,NULL,'2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','2009-03-03','M','',':RET:2106-3','N','021','HLT','2876054','92036OH004000601','2014-04-01','2014-03-07 11:40:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61','CIC',0,'2014-03-07 21:00:30'),(1430,1192,'Y','18','024','14','A','','','TE','0001459145','0001459145','','IL','1','Pasquier','Elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-12','F','',NULL,NULL,NULL,'','2256915','','2013-12-24','2013-12-24 17:13:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:47:32'),(3006,2416,'Y','18','021','EC','A','','','AC','0000893129','0000893129','OH00000713414','IL','1','HARROD','TAMMY','','','','34','282548208','6753 AMHERST RD',0,'CRIDERSVILLE','OH','45806','9294','CY','39003','1958-02-01','F','M',':RET:2106-3','N','021','HLT','1169665','92036OH003001501','2014-01-01','2013-12-05 18:50:11','241.00',NULL,NULL,'512.54','271.54','R-OH002','OH0','512.54',NULL,0,'2013-12-25 20:17:47'),(7609,6021,'Y','18','021','EC','A','','','AC','0000138971','0000138971','OH00000109225','IL','1','harvey','robert','L','','','34','045442185','872 S ELM STREET EXT',0,'ORRVILLE','OH','44667','9501','CY','39169','1952-05-01','M','U',':RET:2106-3','T','021','HLT','864213','52664OH152000901','2014-01-01','2013-11-17 07:19:08','0.00',NULL,NULL,'527.84','527.84','R-OH014','OH0','527.84',NULL,0,'2013-12-26 02:45:35'),(14753,11779,'N','01','021','EC','A',NULL,NULL,'','0000402471','0000685854','','IL','1','Creech','Edward','Alan','','','34','281826747','214 KNEDLER RD',0,'CLARKSVILLE','OH','45113','8688','CY','39027','1969-06-27','M','',':RET:2106-3','N','021','HLT','1404626','92036OH001000601','2014-02-01','2013-12-27 22:06:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','361.74',NULL,1,'2013-12-29 11:10:21'),(7455,5899,'N','19','021','EC','A',NULL,NULL,'','0000896969','0000648307','','IL','1','KOPPEL','ALEX','MICHAEL','','','34','288047744','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','1999-11-08','M','',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:30:46'),(27276,21599,'Y','18','021','EC','A','','','AC','0000399766','0000399766','TX00002721183','IL','1','Pasaret','Adrian','','','','34','626200022','189 Commercial PMB',0,'Eagle Pass','TX','78852',NULL,'CY','48323','1967-03-05','M','U',':RET:2106-3','T','021','DEN','3236100','33348TX002000201','2014-04-01','2014-03-03 20:36:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:19'),(29177,23092,'N','01','021','EC','A',NULL,NULL,'','0000393743','0000981689','','IL','1','SNEED','PHARICA','','','Sr','34','300747611','2444 WRIGHT RD',0,'AKRON','OH','44320','2448','CY','39153','1978-04-10','F','',':RET:2054-5','N','021','HLT','4223964','52664OH151001501','2014-04-01','2014-03-10 16:58:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','326.84',NULL,0,'2014-03-10 21:03:02'),(647,534,'Y','18','021','EC','A','','','AC','0001248317','0001248317','OH00001143443','IL','1','Van Deursen','John','','','','34','145449694','400 chatham dr',0,'kettering','OH','45429',NULL,'CY','39113','1952-08-15','M','M',':RET:2106-3','T','021','DEN','1924689','99734OH005000401','2014-01-01','2013-12-16 16:09:41','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:01:30'),(1340,1109,'Y','18','021','EC','A','','','AC','0000196108','0000196108','OH00000896715','IL','1','Johnson','James','','','','34','300744187','656  thurber dr west',0,'columbus','OH','43215',NULL,'CY','39049','1979-09-14','M','U',NULL,'N','021','DEN','189534','99734OH005000401','2014-01-01','2013-10-09 09:49:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:32:24'),(24782,19657,'Y','18','021','EC','A','','','AC','0000639575','0000639575','OH00002581785','IL','1','Parks','Carlye','','','','34','268961058','517 HEATHERBROOKE WAY',0,'WESTERVILLE','OH','43081','5661','CY','39049','1989-10-19','F','U',':RET:2106-3','N','021','DEN','3244212','99734OH005000401','2014-04-01','2014-02-19 13:17:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:45:27'),(24621,19541,'N','01','021','EC','A',NULL,NULL,'','0000863067','0000652868','','IL','1','TUCKER','STEWART','','','','34','428191874','402 PEARL DR',0,'PEARL','MS','39208','4521','CY','28121','1962-04-20','M','',NULL,'N','021','DEN','2727834','46300MS002000201','2014-04-01','2014-02-19 15:23:39',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 04:16:11'),(6948,5518,'Y','18','021','EC','A','','','AC','0000260477','0000260477','OH00000439331','IL','1','WILLIAMS','LOIS','','','','34','297565122','2 WINCHESTER AVE',0,'CLEVELAND','OH','44110','1038','CY','39035','1954-11-13','F','U',':RET:2106-3','N','021','DEN','1855022','99734OH005000401','2014-01-01','2013-12-24 20:58:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:58'),(6083,4821,'Y','18','021','EC','A','','','AC','0000965741','0000965741','OH00000980848','IL','1','Mielziner','Patti','','','','34','283624933','117 S WALNUT ST',0,'YELLOW SPRINGS','OH','45387','1728','CY','39057','1967-04-11','F','U',':RET:2106-3','N','021','HLT','785595','92036OH006000501','2014-01-01','2013-12-01 14:32:27','280.70',NULL,NULL,'282.77','2.07','R-OH003','OH0','282.77',NULL,0,'2013-12-26 00:02:31'),(5748,4563,'Y','18','021','EC','A','','','AC','0001551828','0001551828','LA00000942707','IL','1','Edwards','LaKendrial','','','','34','436594107','2792 KELSEY ST',0,'SHREVEPORT','LA','71107','5943','CY','22017','1985-11-14','F','U',':RET:2054-5','N','021','DEN','2076111','18575LA002000201','2014-01-01','2013-12-24 01:13:47','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 23:46:07'),(15890,12724,'Y','18','021','EC','A','','','AC','0000937283','0000937283','OH00001236169','IL','1','SCOTT','SANDRA','KAY','','','34','234027615','3951 GRANDVIEW COURT',0,'TOLEDO','OH','43614',NULL,'CY','39095','1962-01-26','F','M',':RET:2106-3','N','021','HLT','2271490','92036OH004002601','2014-02-01','2014-01-02 12:22:09','326.00',NULL,NULL,'655.70','329.70','R-OH001','OH0','306.05',NULL,0,'2014-01-03 02:05:43'),(20200,16118,'Y','18','021','EC','A','','','AC','0001018785','0001018785','MS00002128535','IL','1','ARMSTRONG','CALEB','','','','34','428530254','252 ELLIS AVENUE',0,'JACKSON','MS','39204',NULL,'CY','28049','1985-07-27','M','U',NULL,'N','021','DEN','1418332','46300MS002000101','2014-03-01','2014-01-27 13:09:14','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-27 21:01:31'),(16852,13482,'Y','18','021','EC','A','','','AC','0001157581','0001157581','OH00001985255','IL','1','Motz','Karen','','','','34','407114761','6400 gracely dr',0,'cincinnati','OH','45233',NULL,'CY','39061','1961-12-11','F','U',':RET:2106-3','T','021','HLT','2081572','92036OH004001201','2014-02-01','2014-01-11 13:26:51','229.00',NULL,NULL,'387.47','158.47','R-OH004','OH0','387.47',NULL,0,'2014-01-13 02:18:40'),(27526,21777,'Y','18','021','EC','A','','','AC','0000257191','0000257191','OH00003496045','IL','1','Barnhill','Eloise','M','','','34','270581587','6921 HELLER RD',0,'WHITEHOUSE','OH','43571','9787','CY','39095','1953-08-16','F','U',':RET:2106-3','N','021','HLT','3914640','92036OH005002606','2014-04-01','2014-03-04 15:42:28','448.00',NULL,NULL,'529.21','81.21','R-OH001','OH0','529.21',NULL,0,'2014-03-04 21:02:44'),(28215,22326,'Y','18','021','EC','A','','','AC','0000477434','0000477434','OH00003577368','IL','1','Smith','Terence','','','','34','379786658','2484 LITTLE DRY RUN RD',0,'CINCINNATI','OH','45244','3247','CY','39061','1961-06-11','M','M',':RET:2054-5','N','021','HLT','4039106','92036OH005001201','2014-04-01','2014-03-06 13:36:52','392.00',NULL,NULL,'974.38','582.38','R-OH004','OH0','419.03','CIC',0,'2014-03-06 21:30:16'),(13982,11140,'Y','18','021','EC','A','','','AC','0001130226','0001130226','OH00001352580','IL','1','Hyatt','Sarah','','','','34','283904113','1614 COOPER ST',0,'CINCINNATI','OH','45223','2616','CY','39061','1985-03-27','F','U',':RET:2106-3','N','021','HLT','1706080','92036OH004001201','2014-01-01','2013-12-23 14:47:41','0.00',NULL,NULL,'187.64','187.64','R-OH004','OH0','187.64',NULL,0,'2013-12-26 13:15:36'),(2319,1885,'Y','18','024','14','A','','','TE','0000914738','0000914738','','IL','1','Witt','Cody',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-11-12','M','',NULL,NULL,NULL,'','35637','','2013-12-09','2013-12-09 07:21:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:31:23'),(9072,7201,'Y','18','021','EC','A','','','AC','0001032598','0001032598','OH00000248533','IL','1','Crawford','Daniel','','','','34','272442348','5101 Sumter Ave.',0,'cincinnati','OH','45238',NULL,'CY','39061','1951-10-06','M','U',':RET:2106-3','N','021','DEN','1676498','99734OH005000301','2014-01-01','2013-12-17 19:14:54','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:06:38'),(8167,6462,'Y','18','021','EC','A','','','AC','0000024075','0000024075','OH00000219315','IL','1','Gilbert','Michael','','','','34','287542183','4 Old State Road',0,'Milan','OH','44846',NULL,'CY','39077','1951-02-24','M','U',':RET:2106-3','N','021','HLT','739230','92036OH005002704','2014-01-01','2013-11-22 11:27:53','423.00',NULL,NULL,'560.22','137.22','R-OH006','OH0','560.22',NULL,0,'2013-12-26 03:16:32'),(6939,5510,'Y','18','021','EC','A','','','AC','0000361017','0000361017','OH00000819917','IL','1','Enoch-Mtetwa','Nomphumelelo','Mikela','','','34','219418286','8172 MISTY SHORE DR',0,'WEST CHESTER','OH','45069','9240','CY','39017','1994-05-02','F','U',':RET:2054-5','N','021','DEN','1987612','99734OH005000401','2014-01-01','2013-12-24 20:25:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-26 01:46:46'),(6747,5353,'Y','18','021','EC','A','','','AC','0000391828','0000391828','TX00000831765','IL','1','BRIDGES','JULIAN','','','','34','629283247','1717 SHILOH RD',0,'TYLER','TX','75703','2427','CY','48423','1991-10-21','F','U',':RET:2054-5','N','021','DEN','250332','33348TX002000101','2014-01-01','2013-11-25 11:25:21','0.00',NULL,NULL,'25.02','25.02','R-TX022','TX0','25.02',NULL,0,'2013-12-26 01:15:58'),(21679,17312,'Y','18','021','EC','A','','','AC','0001367535','0001367535','LA00001690496','IL','1','battie','alicia','','','','34','433751220','310 NW 2ND ST',0,'RESERVE','LA','70084','6502','CY','22095','1987-10-21','F','U',':RET:2054-5','N','021','DEN','3460279','18575LA002000201','2014-03-01','2014-02-05 17:17:16','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:31:01'),(18855,15017,'Y','18','021','EC','A','','','AC','0001054239','0001054239','OH00001905436','IL','1','Weber','Karen','lee','','','34','299480359','4158 MCLEAN DR',0,'CINCINNATI','OH','45255','3325','CY','39025','1950-06-27','F','M',':RET:2106-3','N','021','HLT','3000814','92036OH006000601','2014-03-01','2014-01-16 13:11:58','362.00',NULL,NULL,'502.56','140.56','R-OH005','OH0','502.56',NULL,0,'2014-01-17 03:36:17'),(18694,14904,'Y','18','021','EC','A','','','AC','0002015318','0002015318','LA00002525429','IL','1','Dannel','Amy','','','','34','437410908','6300 MORRISON RD',0,'NEW ORLEANS','LA','70126','1511','CY','22071','1978-06-02','F','M',':RET:2054-5','N','021','DEN','2065126','18575LA002000101','2014-03-01','2014-01-16 10:38:45','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2014-01-17 03:35:25'),(18174,14511,'N','01','021','EC','A',NULL,NULL,'','0000284429','0001142193','','IL','1','Peiples','Jaime','Lyn','','','34','296729110','24 FAIRWOOD AVE',0,'NORWALK','OH','44857','2381','CY','39077','1976-05-28','F','',':RET:2106-3','N','021','HLT','2036130','92036OH005002705','2014-02-01','2014-01-14 11:30:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','241.40',NULL,0,'2014-01-15 02:07:58'),(15826,12670,'Y','18','021','EC','A','','','AC','0000824592','0000824592','OH00001299226','IL','1','siwierka','michelle','','','','34','294784997','900 GARFORD AVE',0,'ELYRIA','OH','44035','6655','CY','39093','1965-11-04','F','U',':RET:2106-3','T','021','DEN','2067212','99734OH005000401','2014-02-01','2014-01-02 16:27:23','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:03:41'),(25597,20308,'Y','18','024','14','A','','','TE','0000926299','0000926299','','IL','1','Sobieck','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-17','M','',NULL,NULL,NULL,'','2947457','','2014-03-31','2014-02-24 15:07:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-26 08:00:47'),(27504,21760,'Y','18','024','14','A','','','TE','0001243027','0001243027','','IL','1','Horsey','Cindy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-26','F','',NULL,NULL,NULL,'','3897451','','2014-03-04','2014-03-04 14:45:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:29'),(1361,1127,'Y','18','021','EC','A','','','AC','0000390668','0000390668','TX00001029242','IL','1','Morgan','Cathy','Jean','','','34','452065066','2600 COUNTY ROAD 2390',0,'WINNSBORO','TX','75494','4705','CY','48223','1954-12-26','F','U',NULL,'N','021','DEN','1466404','33348TX002000101','2014-01-01','2013-12-24 14:07:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:45:30'),(25035,19852,'Y','18','021','EC','A','','','AC','0002368667','0002368667','LA00002265854','IL','1','Carriveau','Brandon','','','','34','384822485','626 SAINT JAMES ST',0,'NEW ORLEANS','LA','70130','4637','CY','22071','1971-07-31','M','U',':RET:2106-3','T','021','DEN','2753700','18575LA002000101','2014-04-01','2014-02-20 16:32:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-20 22:01:06'),(7855,6220,'Y','18','024','14','A','','','TE','0000017600','0000017600','','IL','1','Blank','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-06','M','',NULL,NULL,NULL,'','761032','','2013-12-20','2013-12-20 10:06:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:55'),(5280,4183,'N','01','021','EC','A',NULL,NULL,'','0001221930','0000513323','','IL','1','KELLER','CONNIE','S','','','34','301560486','6407 CANTERBURY DR',0,'HUDSON','OH','44236','3487','CY','39153','1954-09-04','F','',':RET:2106-3','N','021','HLT','2017288','52664OH151001301','2014-01-01','2013-12-19 14:38:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-25 23:05:44'),(18526,14773,'Y','18','021','EC','A','','','AC','0000338658','0000338658','TX00001551740','IL','1','LAVANE','TIFFANY','M','','','34','451551612','20018 CHIPPLEGATE LN',0,'HUMBLE','TX','77338','1745','CY','48201','1981-08-28','F','U',':RET:2054-5','N','021','DEN','2529084','33348TX002000101','2014-02-01','2014-01-15 15:41:38','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-16 08:46:41'),(6091,4828,'Y','18','021','EC','A','','','AC','0000025266','0000025266','OH00000411182','IL','1','Schalk','Kristina','','','','34','271885409','4149 SAGEWOOD CT',0,'BATAVIA','OH','45103','2649','CY','39025','1975-03-03','F','M',':RET:2106-3','N','021','HLT','1078428','92036OH006000601','2014-01-01','2013-12-01 12:26:17','0.00',NULL,NULL,'212.14','212.14','R-OH005','OH0','212.14',NULL,0,'2013-12-26 00:02:45'),(15000,11989,'Y','18','021','EC','A','','','AC','0000394814','0000394814','TX00000440670','IL','1','GARCIA','RODD','','','','34','452392624','252 TULANE DR',0,'EL PASO','TX','79907','5919','CY','48141','1962-06-29','M','U',NULL,'N','021','DEN','2288369','33348TX002000201','2014-02-01','2013-12-30 17:58:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-01 12:01:41'),(43,38,'Y','18','021','EC','A','','','AC','0001223143','0001223143','OH00001141841','IL','1','Kilby','Brandon','','','','34','275889977','7299 SILVER CREST DR',0,'CINCINNATI','OH','45236','3622','CY','39061','1981-01-26','M','U',':RET:2054-5','N','021','DEN','1180245','99734OH005000401','2014-01-01','2013-12-05 15:53:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:07'),(14427,11505,'Y','18','021','EC','A','','','AC','0000582977','0000582977','TX00000754696','IL','1','delaflor','Rafael','','','','34','385904382','27009 FOUR PINES ST',0,'CLEVELAND','TX','77328','7157','CY','48339','1977-09-03','M','U',':RET:2106-3','N','021','DEN','1777849','33348TX002000101','2014-02-01','2013-12-27 18:28:21','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:49'),(23761,18911,'Y','18','021','EC','A','','','AC','0001146017','0001146017','OH00002660616','IL','1','DiMuzio','Paul','','','','34','298584621','614 COLEBERRY CT',0,'CLEVES','OH','45002','1390','CY','39061','1958-08-24','M','M',':RET:2106-3','N','021','DEN','2812096','99734OH005000301','2014-03-01','2014-02-14 14:55:40','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:31:10'),(21340,17055,'Y','18','024','14','A','','','TE','0000778219','0000778219','','IL','1','Jaquez','Jose',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-07-03','M','',NULL,NULL,NULL,'','3683065','','2014-02-03','2014-02-03 20:42:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:00:32'),(1342,1111,'Y','18','021','EC','A','','','AC','0000435614','0000435614','TX00001053486','IL','1','Shockey','Cory','Nathan','','','34','467651827','6547 AMBER OAK',0,'SAN ANTONIO','TX','78249','1587','CY','48029','1977-07-15','M','U',NULL,'N','021','DEN','8754','33348TX002000101','2014-01-01','2013-10-09 13:03:34','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 18:32:28'),(18915,15072,'N','19','021','EC','A',NULL,NULL,'','0001094663','0000559462','','IL','1','TOPP','TESSA','M','','','34','283960842','5170 LOCK TWO RD',0,'NEW BREMEN','OH','45869','9412','CY','39011','1993-07-17','F','',':RET:2106-3','N','021','HLT','2100812','92036OH005001506','2014-02-01','2014-01-15 19:29:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-01-17 03:36:42'),(17619,14085,'Y','18','021','EC','A','','','AC','0000814403','0000814403','TX00001737584','IL','1','ALLEN','GLANDA','','','','34','456786204','3503 HARRIS DR',0,'AMARILLO','TX','79103',NULL,'CY','48381','1950-08-28','F','U',':RET:2106-3','N','021','DEN','2413080','33348TX002000201','2014-02-01','2014-01-13 12:28:05','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-14 01:32:26'),(1764,1457,'Y','18','021','EC','A','','','AC','0001131448','0001131448','OH00001447124','IL','1','Rickert-Epstein','Anthony','','','','34','288823652','7306 BANNERWOOD DR',0,'WEST CHESTER','OH','45069','1073','CY','39017','1984-09-28','M','M',':RET:2106-3','N','021','DEN','2193584','99734OH005000301','2014-01-01','2013-12-24 13:43:10','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:55:59'),(8048,6371,'Y','18','021','EC','A','','','AC','0001030368','0001030368','OH00000174786','IL','1','PHOENIX','CLETUS','','','','34','302682548','5541 CHRISTOPHER CT',0,'TOLEDO','OH','43614','1211','CY','39095','1973-06-10','M','U',':RET:2054-5','N','021','HLT','2468408','92036OH004002601','2014-01-01','2013-12-20 13:31:05','0.00',NULL,NULL,'200.38','200.38','R-OH001','OH0','200.38',NULL,0,'2013-12-26 03:09:36'),(16015,12819,'Y','18','021','EC','A','','','AC','0001973388','0001973388','LA00001741385','IL','1','Davis','Paula','','','','34','439277759','104 PERKINS ST',0,'FERRIDAY','LA','71334','2223','CY','22029','1963-12-30','F','M',':RET:2054-5','N','021','DEN','1882230','18575LA002000201','2014-02-01','2014-01-02 21:24:12','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-04 02:01:58'),(5475,4346,'N','01','021','EC','A',NULL,NULL,'','0001046832','0001096746','','IL','1','Arif','Fozia','','','','34','590043826','2831 STONEFENCE DR',0,'PERRYSBURG','OH','43551','8978','CY','39173','1965-11-05','F','',':RET:2028-9','N','021','HLT','2098467','92036OH005002601','2014-01-01','2013-12-19 09:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','318.82',NULL,0,'2013-12-25 23:10:41'),(8015,6344,'Y','18','021','EC','A','','','AC','0001018226','0001018226','OH00000769373','IL','1','Baker','Richard','','','','34','294687548','3265 WAHL RD',0,'HAMERSVILLE','OH','45130','8794','CY','39015','1967-07-23','M','R',':RET:1002-5^:RET:2106-3','N','021','HLT','2214322','92036OH006000601','2014-01-01','2013-12-19 20:48:29','0.00',NULL,NULL,'255.36','255.36','R-OH005','OH0','255.36',NULL,0,'2013-12-26 03:08:45'),(6208,4919,'Y','18','021','EC','A','','','AC','0000511344','0000511344','TX00000743006','IL','1','POKORNY','JULIE','','','','34','638101200','2709 Lawrence Rd',0,'arlington','TX','76006',NULL,'CY','48439','1988-01-23','F','U',NULL,'N','021','DEN','201593','33348TX002000101','2014-01-01','2013-10-15 19:43:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 00:30:48'),(6820,5407,'N','01','021','EC','A',NULL,NULL,'','0001183494','0001022741','','IL','1','Poff','Daniel','J','','Sr','34','300521732','1120 GRIGGS RD',0,'JEFFERSON','OH','44047','9754','CY','39007','1952-12-17','M','',':RET:2106-3','N','021','HLT','662105','52664OH151001305','2014-01-01','2013-11-14 17:29:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','706.77',NULL,0,'2013-12-26 01:30:30'),(3713,2971,'Y','18','021','EC','A','','','AC','0001191319','0001191319','OH00000987069','IL','1','Bigham','Bruce','Edward','','','34','289888665','2029 W CASE RD',0,'COLUMBUS','OH','43235','7526','CY','39049','1986-04-11','M','M',NULL,'N','021','DEN','882696','99734OH005000401','2014-01-01','2013-12-13 14:38:05','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:32:15'),(28105,22246,'Y','18','021','EC','A','','','AC','0000656990','0000656990','OH00003054067','IL','1','MONROE','RACHEL','ANN','','','34','278520325','573 FULMER AVE',0,'AKRON','OH','44312','2035','CY','39153','1950-04-25','F','M',NULL,'N','021','HLT','3968066','52664OH152000901','2014-04-01','2014-03-06 13:42:36','388.00',NULL,NULL,'482.18','94.18','R-OH012','OH0','482.18',NULL,0,'2014-03-06 21:02:12'),(1794,1473,'Y','18','021','EC','A','','','AC','0000197147','0000197147','OH00000008055','31','1','Myrick','Teresa','','','','34','285545800','P O BOX 2003',0,'Dayton','OH','45401',NULL,'CY','39113','1953-11-29','F','U',NULL,'N','021','DEN','2337405','99734OH005000301','2014-01-01','2013-12-24 16:53:52','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:56:36'),(3074,2469,'N','01','021','EC','A',NULL,NULL,'','0000637258','0000070244','','IL','1','PRIESTLEY','VERNITA','','','','34','435278996','3170 ANN ST',0,'VACHERIE','LA','70090','7021','CY','22093','1958-10-16','F','',':RET:2054-5','N','021','DEN','350687','18575LA002000101','2014-01-01','2013-12-06 00:02:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 20:19:32'),(14027,11173,'Y','18','021','EC','A','','','AC','0000451273','0000451273','OH00000163325','IL','1','Banks','Anne','','','','34','303044499','806 FOREST AVE',0,'MILFORD','OH','45150','1310','CY','39025','1982-11-10','F','R',':RET:2106-3','N','021','HLT','1530317','92036OH002000601','2014-01-01','2013-12-23 18:28:43','0.00',NULL,NULL,'287.33','287.33','R-OH005','OH0','287.33',NULL,0,'2013-12-26 13:16:45'),(13758,10981,'Y','18','021','EC','A','','','AC','0001149540','0001149540','MS00000606631','31','1','bennett','yolanda','faye','','','34','428834514','1612 Hastings rd',0,'Gautier','MS','39553',NULL,'CY','28059','1977-07-18','F','U',':RET:1002-5','N','021','DEN','1612868','46300MS002000201','2014-01-01','2013-12-23 08:24:37','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 13:10:08'),(21706,17333,'N','01','021','EC','A',NULL,NULL,'','0000917024','0001132797','','IL','1','abdul hadi','danielle','rose','','','34','291807459','630 BATTLES RD',0,'GATES MILLS','OH','44040','9768','CY','39035','1983-08-03','F','',':RET:2106-3','N','021','HLT','3058463','92036OH005000806','2014-03-01','2014-02-04 23:04:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.37',NULL,0,'2014-02-05 21:31:13'),(9233,7325,'Y','18','021','EC','A','','','AC','0000542653','0000542653','OH00000491978','IL','1','Barlow','Jerry','','','','34','301547929','1484 JONQUILMEADOW DR',0,'CINCINNATI','OH','45240','2940','CY','39061','1953-12-09','M','U',':RET:2106-3','N','021','HLT','1727274','92036OH003001204','2014-01-01','2013-12-18 14:43:26','374.00',NULL,NULL,'608.42','234.42','R-OH004','OH0','608.42',NULL,0,'2013-12-26 04:10:30'),(7132,5659,'Y','18','021','EC','A','','','AC','0000370958','0000370958','MS00001026401','IL','1','Nelson','Michelle','','','','34','428214196','1038 AIRPORT FERNWOOD RD',0,'MCCOMB','MS','39648','5951','CY','28113','1974-03-15','F','M',':RET:2054-5','N','021','DEN','1624674','46300MS002000101','2014-01-01','2013-12-24 19:33:04','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 01:51:38'),(20059,15999,'Y','18','021','EC','A','','','AC','0000725275','0000725275','TX00001971443','IL','1','CARR','NATASHA','','','','34','643012886','1500 FAREWELL ST',0,'BRENHAM','TX','77833',NULL,'CY','48477','1984-07-17','F','M',':RET:2054-5','N','021','DEN','2633461','33348TX002000201','2014-03-01','2014-01-27 11:34:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:10'),(19562,15594,'Y','18','021','EC','A','','','AC','0001352531','0001352531','LA00002069646','IL','1','Gough','August','','','','34','438754670','295 Joe White Road',0,'Monroe','LA','71203',NULL,'CY','22073','1987-12-05','M','U',':RET:2106-3','N','021','DEN','2861645','18575LA002000201','2014-03-01','2014-01-22 10:17:44','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-23 03:02:33'),(4654,3690,'Y','18','021','EC','A','','','AC','0000344180','0000344180','LA00000518965','IL','1','Lavis','William','','','','34','437575504','100 S CORTEZ ST',0,'NEW ORLEANS','LA','70119','6119','CY','22071','1970-07-07','M','U',':RET:2106-3','N','021','DEN','510912','18575LA002000201','2014-01-01','2013-12-12 04:03:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:07:11'),(2178,1790,'Y','18','024','14','A','','','TE','0000242690','0000242690','','IL','1','GAERTNER','DEBORAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-27','F','',NULL,NULL,NULL,'','598832','','2013-12-10','2013-12-10 10:09:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:19:19'),(5740,4556,'Y','18','021','EC','A','','','AC','0002002637','0002002637','LA00000045965','IL','1','Fisher','Charles','','','','34','437731291','4620 New Weis Rd',0,'Zachary','LA','70791',NULL,'CY','22033','1973-06-25','M','R',NULL,'N','021','DEN','1813481','18575LA002000201','2014-01-01','2013-12-23 23:41:36','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:55'),(20089,16027,'Y','18','021','EC','A','','','AC','0002243488','0002243488','LA00001620608','IL','1','Davis','Lenard','','','','34','436434667','1418 KING DEAN DR',0,'BATON ROUGE','LA','70810','3217','CY','22033','1964-09-18','M','U',':RET:2054-5','N','021','DEN','2343627','18575LA002000101','2014-03-01','2014-01-27 16:16:56','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-27 21:00:28'),(22733,18151,'Y','18','021','EC','A','','','AC','0002048902','0002048902','LA00002605902','IL','1','Slocum','Tommy','a','','','34','434575266','10626 LANDSBURY AVE',0,'BATON ROUGE','LA','70809','2829','CY','22033','1968-12-05','M','U',':RET:2106-3','N','021','DEN','2993692','18575LA002000201','2014-03-01','2014-02-11 15:49:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-11 21:01:16'),(23153,18457,'Y','18','021','EC','A','','','AC','0000471055','0000471055','OH00002748500','IL','1','Wright','Sally','','','','34','293560676','639 HERITAGE SQ',0,'HARRISON','OH','45030','8207','CY','39061','1954-06-26','F','U',':RET:2106-3','T','021','HLT','3561699','92036OH004001201','2014-03-01','2014-02-12 09:07:49','435.00',NULL,NULL,'516.72','81.72','R-OH004','OH0','516.72',NULL,0,'2014-02-12 21:31:42'),(26539,21045,'Y','18','021','EC','A','','','AC','0000886965','0000886965','OH00003117647','IL','1','MCGEE','DOROTHY','','','','34','493589719','2057 HERITAGE DR',0,'SANDUSKY','OH','44870','5158','CY','39043','1951-01-05','F','M',':RET:2054-5','N','021','DEN','3359380','99734OH005000301','2014-04-01','2014-02-28 11:17:56','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2014-02-28 21:30:07'),(1118,921,'Y','18','021','EC','A','','','AC','0000022668','0000022668','MS00000576970','IL','1','Williams','Sherokie','','','','34','428692662','340 MAIN ST',0,'SLEDGE','MS','38670','9002','CY','28119','1989-12-11','F','U',':RET:2054-5','N','021','DEN','1040917','46300MS002000101','2014-01-01','2013-12-02 19:19:51','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 18:17:44'),(2115,1735,'Y','18','021','EC','A','','','AC','0001253517','0001253517','OH00001196504','IL','1','Bushman','Melanie','','','','34','301901303','2954 WARDALL AVE',0,'CINCINNATI','OH','45211','4904','CY','39061','1986-12-24','F','U',':RET:2106-3','N','021','DEN','696082','99734OH005000401','2014-01-01','2013-12-10 12:58:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:34'),(9601,7604,'Y','18','021','EC','A','','','AC','0000912945','0000912945','OH00000503730','IL','1','KOCH-MANTEGHI','CINDY','','','','34','269507185','223 PINELAND DR',0,'COPLEY','OH','44321',NULL,'CY','39153','1956-11-19','F','U',NULL,'N','021','HLT','1669905','52664OH151001304','2014-01-01','2013-12-21 10:57:31','268.00',NULL,NULL,'543.47','275.47','R-OH012','OH0','543.47',NULL,0,'2013-12-26 04:37:24'),(4779,3793,'Y','18','021','EC','A','','','AC','0000133518','0000133518','MS00000348993','IL','1','Jobe','Shemekisa','','','','34','553719706','162 CROWN RD',0,'CAMDEN','MS','39045','9668','CY','28089','1982-05-17','F','M',':RET:2054-5','N','021','DEN','573917','46300MS002000201','2014-01-01','2013-12-08 10:02:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 22:16:03'),(9034,7169,'Y','18','021','EC','A','','','AC','0001077720','0001077720','OH00000583747','IL','1','Schmidt','Martha','','','','34','280702082','1246 FRANK DR',0,'WOOSTER','OH','44691','4674','CY','39169','1960-07-03','F','M',':RET:2106-3','N','021','HLT','1737238','52664OH151001305','2014-01-01','2013-12-18 14:22:53','916.00',NULL,NULL,'1081.59','165.59','R-OH014','OH0','454.94',NULL,0,'2013-12-26 04:05:40'),(20085,16023,'Y','18','021','EC','A','','','AC','0001154852','0001154852','LA00002056205','IL','1','ROGERS','VICKIE','','','','34','433963172','902 CASS ST',0,'SULPHUR','LA','70663','1056','CY','22019','1955-05-31','F','M',NULL,'N','021','DEN','1494513','18575LA002000101','2014-03-01','2014-01-27 08:59:29','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-01-27 21:00:26'),(24647,19564,'Y','18','021','EC','A','','','AC','0001276993','0001276993','LA00001650140','IL','1','Vancol','Joseph','','','','34','070681655','1284 LAURADALE DR',0,'NEW ORLEANS','LA','70114','2832','CY','22071','1954-06-26','M','U',':RET:2054-5','N','021','DEN','2887473','18575LA002000201','2014-04-01','2014-02-19 14:25:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 04:21:46'),(26368,20916,'Y','18','021','EC','A','','','AC','0000460551','0000460551','OH00002782790','IL','1','Jacob','Elizabeth','','','','34','269563461','13920 EASTWOOD BLVD',0,'CLEVELAND','OH','44125','6051','CY','39035','1954-02-05','F','M',':RET:2106-3','N','021','DEN','2666140','99734OH005000301','2014-04-01','2014-02-26 15:27:13','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00','CIC',0,'2014-02-28 07:00:10'),(385,319,'N','19','021','EC','A',NULL,NULL,'','0000827126','0000124177','','IL','1','McRae','Paul','','','','34','274943751','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1991-08-29','M','',':RET:2054-5','N','021','HLT','25262','92036OH004003201','2014-01-01','2013-12-03 18:22:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.63',NULL,0,'2013-12-25 17:45:50'),(9283,7362,'Y','18','021','EC','A','','','AC','0000397308','0000397308','OH00000899381','IL','1','Bernola','Steven','','','','34','270468608','332 PORTZ AVE',0,'FINDLAY','OH','45840','2430','CY','39063','1964-08-30','M','U',':RET:2106-3','N','021','DEN','797903','99734OH005000301','2014-01-01','2013-11-30 13:28:21','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:15:56'),(17672,14122,'Y','18','021','EC','A','','','AC','0001492074','0001492074','LA00001715251','IL','1','DAVIS','Lenard','','','','34','436434667','1418 KING DEAN DR',0,'BATON ROUGE','LA','70810','3217','CY','22033','1964-09-18','M','U',':RET:2054-5','N','021','DEN','2477450','18575LA002000101','2014-02-01','2014-01-13 11:02:28','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-14 01:32:50'),(7167,5684,'N','19','021','EC','A',NULL,NULL,'','0000870633','0000001045','','IL','1','Yang','Connie','','','','34','288042878','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1999-11-08','F','',':RET:2034-7','N','021','HLT','1985187','92036OH003002705','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2013-12-26 01:52:38'),(16102,12898,'Y','18','021','EC','A','','','AC','0000084053','0000084053','OH00001644907','IL','1','Lee','Christoffer','','','','34','118744374','8241 CELESTIAL CIR',0,'LIBERTY TOWNSHIP','OH','45044','8399','CY','39017','1983-04-02','M','M',':RET:2106-3','N','021','HLT','1358794','92036OH005001206','2014-02-01','2014-01-02 22:43:10','365.00',NULL,NULL,'483.87','118.87','R-OH004','OH0','243.66',NULL,0,'2014-01-04 02:04:49'),(2533,2061,'N','01','021','EC','A',NULL,NULL,'','0000694167','0000566590','','IL','1','Rickey','Frances','','','','34','290486596','224 E LYNDHURST ST',0,'SIDNEY','OH','45365','1756','CY','39149','1951-03-07','F','',':RET:2106-3','T','021','HLT','40506','92036OH005000501','2014-01-01','2013-12-09 08:59:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','785.37',NULL,0,'2013-12-25 19:36:50'),(3134,2519,'Y','18','021','EC','A','','','AC','0000049730','0000049730','MS00000478477','IL','1','Shook','Cody','','','','34','428619964','12 County Road 8525',0,'Booneville','MS','38829',NULL,'CY','28117','1988-01-13','M','U',NULL,'N','021','DEN','446523','46300MS002000101','2014-01-01','2013-10-13 15:29:40','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 20:30:37'),(3812,3053,'N','19','021','EC','A',NULL,NULL,'','0000912935','0000283237','','IL','1','Williams','Kennedy',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2008-10-10','F','',':RET:2054-5','N','021','DEN','783233','99734OH005000301','2014-01-01','2013-12-13 14:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:45'),(5452,4332,'Y','18','021','EC','A','','','AC','0000178878','0000178878','OH00000099758','IL','1','Richardson','Erin','','','','34','298942950','6428 GLADE AVE',0,'CINCINNATI','OH','45230','2836','CY','39061','1979-10-23','F','U',':RET:2106-3','N','021','HLT','1744210','92036OH003001201','2014-01-01','2013-12-19 08:19:25','0.00',NULL,NULL,'272.15','272.15','R-OH004','OH0','272.15',NULL,0,'2013-12-25 23:10:12'),(6789,5384,'Y','18','021','EC','A','','','AC','0000437973','0000437973','TX00000517190','IL','1','Kelm','Carrie','','','','34','629100553','4040 Crow Road',0,'Beaumont','TX','77706',NULL,'CY','48245','1989-05-15','F','U',':RET:2106-3','N','021','DEN','1162084','33348TX002000201','2014-01-01','2013-11-24 22:30:21','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2013-12-26 01:17:02'),(18795,14970,'N','19','021','EC','A',NULL,NULL,'','0000298257','0000465949','','IL','1','Huynh','Don','','','','34','283119559','1250 WINFREE DR',0,'WESTERVILLE','OH','43081','3773','CY','39049','2005-07-28','M','',':RET:2047-9','N','021','DEN','1461272','99734OH005000401','2014-03-01','2014-01-16 10:20:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:58'),(21240,16971,'Y','18','021','EC','A','','','AC','0000472289','0000472289','OH00001768311','IL','1','MAST','JOYCE','VERONICA','','','34','270508114','389 BROAD ST',0,'CONNEAUT','OH','44030','2656','CY','39007','1950-07-29','F','M',':RET:2106-3','N','021','DEN','3423750','99734OH005000301','2014-03-01','2014-02-03 13:53:54','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:01:12'),(22158,17685,'Y','18','021','EC','A','','','AC','0001126915','0001126915','OH00002592067','IL','1','Bentley','Gary','','','','34','278563586','4080 BEECHWOOD DR',0,'BELLBROOK','OH','45305','1644','CY','39057','1954-03-03','M','M',':RET:2106-3','N','021','HLT','3379166','92036OH003000506','2014-03-01','2014-02-08 11:43:32','464.00',NULL,NULL,'646.18','182.18','R-OH003','OH0','646.18',NULL,0,'2014-02-08 19:00:57'),(24258,19263,'Y','18','021','EC','A','','','AC','0000404402','0000404402','TX00002019757','IL','1','Tu','Phung','','','','34','638448891','1827 North Josey Lane',0,'Carrollton','TX','75006',NULL,'CY','48113','1968-06-27','F','U',':RET:2047-9','N','021','DEN','2804081','33348TX002000201','2014-04-01','2014-02-17 13:08:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-17 19:00:08'),(28711,22721,'Y','18','021','EC','A','','','AC','0000358115','0000358115','MS00002710315','IL','1','Speed','Bryan','','','','34','587445299','7260 SYLVAN LN',0,'OLIVE BRANCH','MS','38654','1130','CY','28033','1952-03-02','M','U',':RET:2106-3','N','021','DEN','3319793','46300MS002000201','2014-04-01','2014-03-08 12:06:07','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2014-03-08 21:31:14'),(9367,7426,'Y','18','021','EC','A','','','AC','0001545351','0001545351','LA00000328527','IL','1','woodard','curtis','','','','34','439198742','206 COLE RD',0,'WINNFIELD','LA','71483','6009','CY','22127','1969-06-20','M','M',':RET:2054-5','N','021','DEN','2502997','18575LA002000201','2014-01-01','2013-12-21 12:33:00','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 04:31:42'),(18009,14392,'Y','18','021','EC','A','','','AC','0000773998','0000773998','OH00002573320','IL','1','PRESUTTI','ROSE','','','','34','281561867','8351 LONDON GROVEPORT RD',0,'GROVE CITY','OH','43123','8817','CY','39049','1954-03-24','F','M',':RET:2106-3','N','021','DEN','1851721','99734OH005000301','2014-02-01','2014-01-14 11:12:44','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:07:03'),(17648,14107,'Y','18','021','EC','A','','','AC','0001163861','0001163861','OH00001272688','IL','1','Boulton','Charles','','','','34','484724146','7101 WREN AVE NW',0,'NORTH CANTON','OH','44720','7054','CY','39151','1953-11-28','M','M',':RET:2106-3','N','021','DEN','1954806','99734OH005000301','2014-02-01','2014-01-13 11:25:52','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2014-01-14 01:32:39'),(3423,2749,'Y','18','024','14','A','','','TE','0002154880','0002154880','','IL','1','Ortiz','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-03','F','',NULL,NULL,NULL,'','1392411','','2013-12-22','2013-12-22 18:13:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:18:43'),(16139,12927,'Y','18','021','EC','A','','','AC','0000680855','0000680855','OH00002024742','IL','1','EPPS','GREGORY','P','','','34','272607825','5256 MONTEZUMA ACRES DR',0,'CELINA','OH','45822','9596','CY','39107','1957-03-21','M','U',':RET:2106-3','T','021','HLT','2227219','92036OH005001506','2014-02-01','2014-01-03 11:22:58','512.00',NULL,NULL,'590.47','78.47','R-OH002','OH0','590.47',NULL,0,'2014-01-04 02:05:55'),(15305,12238,'Y','18','021','EC','A','','','AC','0001289860','0001289860','LA00001883474','IL','1','Mossey','David','','','','34','436632253','11064 BLACK OAK DR',0,'BATON ROUGE','LA','70815','1903','CY','22033','1978-11-18','M','U',':RET:2054-5','N','021','DEN','2146329','18575LA002000201','2014-02-01','2014-01-01 14:45:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:22:58'),(8060,6383,'Y','18','021','EC','A','','','AC','0000230428','0000230428','OH00000201678','IL','1','Koenigseker','James','R','','','34','297449159','9411 BRINT RD',0,'SYLVANIA','OH','43560','9616','CY','39095','1951-05-04','M','M',':RET:2106-3','N','021','HLT','2268413','92036OH003002604','2014-01-01','2013-12-20 13:16:38','868.00',NULL,NULL,'1157.27','289.27','R-OH001','OH0','585.04',NULL,0,'2013-12-26 03:09:57'),(7994,6326,'Y','18','021','EC','A','','','AC','0001036127','0001036127','OH00000640536','IL','1','Nichol','Kyle','','','','34','291763723','121 Shiawassee Ave',0,'Fairlawn','OH','44333',NULL,'CY','39153','1967-04-07','M','U',':RET:2106-3','N','021','HLT','1404178','52664OH151001305','2014-01-01','2013-12-20 15:26:23','150.00',NULL,NULL,'334.51','184.51','R-OH012','OH0','334.51',NULL,0,'2013-12-26 03:08:12'),(7659,6065,'Y','18','021','EC','A','','','AC','0001650989','0001650989','LA00000399663','IL','1','Hayes','Theila','','','','34','435196502','6152 JONATHAN ALARIC AVE',0,'GONZALES','LA','70737','8516','CY','22005','1961-10-16','F','M',':RET:2054-5','N','021','DEN','1815214','18575LA002000101','2014-01-01','2013-12-20 09:40:09','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:13'),(4931,3912,'Y','18','021','EC','A','','','AC','0000615484','0000615484','OH00000592295','IL','1','Cahill','Jamie','Richard','','','34','270727955','5520 SUNNYWOODS LN',0,'CINCINNATI','OH','45239','7217','CY','39061','1975-09-14','M','U',':RET:2106-3','N','021','DEN','385645','99734OH005000401','2014-01-01','2013-12-07 10:29:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:26'),(18889,15050,'Y','18','021','EC','A','','','AC','0001068291','0001068291','OH00002488499','IL','1','Untch','Lawrence','','','','34','297466340','1557 S SAWBURG AVE',0,'ALLIANCE','OH','44601','3540','CY','39151','1950-05-30','M','U',':RET:2106-3','N','021','HLT','1851846','52664OH152000901','2014-03-01','2014-01-16 12:42:25','369.00',NULL,NULL,'482.18','113.18','R-OH015','OH0','482.18',NULL,0,'2014-01-17 03:36:31'),(20080,16018,'Y','18','024','14','A','','','TE','0000091169','0000091169','','IL','1','AMAYA','ANA','MARIA',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-02-17','F','',NULL,NULL,NULL,'','1636253','','2014-01-27','2014-01-27 17:32:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-27 21:00:23'),(20669,16517,'Y','18','021','EC','A','','','AC','0001032446','0001032446','MS00002446425','IL','1','INIZARRY GARCIA','JOSE','A','','','34','596124829','4800 LONG AVE',0,'PASCAGOULA','MS','39581',NULL,'CY','28059','1987-04-20','M','U',NULL,'T','021','DEN','3500505','46300MS002000201','2014-03-01','2014-01-30 12:17:39','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-30 21:00:48'),(20740,16570,'Y','18','021','EC','A','','','AC','0000384434','0000384434','OH00001540852','IL','1','Siler','Steven','','','','34','409271564','8401 Jonathan Ln',0,'Maineville','OH','45039',NULL,'CY','39165','1962-08-29','M','M',':RET:2106-3','N','021','HLT','2617190','92036OH003001204','2014-03-01','2014-01-30 01:56:07','137.00',NULL,NULL,'418.11','281.11','R-OH004','OH0','418.11',NULL,0,'2014-01-30 21:01:23'),(21828,17430,'Y','18','021','EC','A','','','AC','0000622750','0000622750','TX00001486029','IL','1','warren','jeremy','','','','34','449516684','8101 Shin Oak',0,'Live Oak','TX','78233',NULL,'CY','48029','1980-06-17','M','M',':RET:2054-5','N','021','DEN','3065545','33348TX002000101','2014-03-01','2014-02-06 15:57:41','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-06 21:01:02'),(21960,17536,'Y','18','021','EC','A','','','AC','0000647102','0000647102','OH00002228893','IL','1','SMITH','WILLIAM','B','','','34','281848906','4965 LANCASTER CIRCLEVILLE RD SW',0,'LANCASTER','OH','43130','8352','CY','39045','1985-04-03','M','U',':RET:2106-3','N','021','DEN','3148951','99734OH005000401','2014-03-01','2014-02-07 09:59:37','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:25'),(22680,18111,'Y','18','021','EC','A','','','AC','0001105216','0001105216','TX00002441535','IL','1','murphy','shantrell','','','','34','451731427','525 CHAMPION PL',0,'TEXARKANA','TX','75501','2671','CY','48037','1984-08-02','F','U',':RET:2054-5','N','021','DEN','2627595','33348TX002000201','2014-03-01','2014-02-11 17:12:11','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-11 21:00:47'),(25045,19862,'Y','18','021','EC','A','','','AC','0000588028','0000588028','OH00003009943','IL','1','Gaul','Cassandra','','','','34','283924593','2033 East 52nd St',0,'Ashtabula','OH','44004',NULL,'CY','39007','1989-09-06','F','U',':RET:2106-3','N','021','DEN','3742988','99734OH005000401','2014-04-01','2014-02-19 19:53:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:01:13'),(27489,21752,'Y','18','021','EC','A','','','AC','0000829339','0000829339','OH00003228377','IL','1','ZIMMERMAN','CAROL','','','','34','272547076','105 PINELAND DR',0,'COPLEY','OH','44321','1319','CY','39153','1958-11-05','F','M',':RET:2106-3','N','021','HLT','2817281','52664OH151001305','2014-05-01','2014-03-04 11:51:38','1050.00',NULL,NULL,'1359.24','309.24','R-OH012','OH0','497.31',NULL,0,'2014-03-04 21:02:22'),(6349,5031,'Y','18','021','EC','A','','','AC','0000669161','0000669161','OH00001203835','IL','1','FRAZIER','KENYETTA','','','','34','283940108','9834 PLEASANT LAKE BLVD',0,'PARMA','OH','44130','7438','CY','39035','1991-06-20','F','U',NULL,'N','021','DEN','554440','99734OH005000401','2014-01-01','2013-12-11 13:13:14','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:46:59'),(18788,14964,'N','01','021','EC','A',NULL,NULL,'','0000359703','0000168912','','IL','1','Huelskamp','Annette','','','','34','273175935','1877 Kremer Rd.',0,'Maria Stein','OH','45860',NULL,'CY','39107','1987-09-13','F','',NULL,'N','021','DEN','1766210','99734OH005000401','2014-02-01','2014-01-15 21:55:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:55'),(16745,13394,'N','01','021','EC','A',NULL,NULL,'','0000986023','0000019120','','IL','1','Bertison','Kristine','Kim','','','34','295645123','5742 BROOKWOOD DR',0,'AKRON','OH','44319','4223','CY','39153','1958-02-02','F','',':RET:2106-3','N','021','HLT','2540045','52664OH151001304','2014-02-01','2014-01-07 17:08:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-01-08 18:24:52'),(16703,13368,'Y','18','021','EC','A','','','AC','0000867696','0000867696','TX00001711459','IL','1','Ruiz','Evangelina','','','','34','571130733','3139 ASCENSION DR',0,'BROWNSVILLE','TX','78526','7413','CY','48061','1971-09-27','F','U',':RET:2106-3','N','021','DEN','2600690','33348TX002000201','2014-02-01','2014-01-07 16:56:07','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-08 18:24:39'),(4524,3585,'Y','18','021','EC','A','','','AC','0000204014','0000204014','TX00001271596','IL','1','Sanchez','Otto','Q','','','34','462849326','212 STEART ST',0,'ROCKPORT','TX','78382','5933','CY','48007','1953-02-21','M','M',NULL,'N','021','DEN','273451','33348TX002000201','2014-01-01','2013-12-12 14:10:27','0.00',NULL,NULL,'29.22','29.22','R-TX007','TX0','14.61',NULL,0,'2013-12-25 22:03:54'),(15383,12305,'Y','18','021','EC','A','','','AC','0000539293','0000539293','OH00000696717','IL','1','Bonner','Holly','','','','34','289842352','517 Mishler rd',0,'Mogadore','OH','44260',NULL,'CY','39133','1985-12-15','F','U',':RET:2106-3','T','021','HLT','1859036','52664OH151001305','2014-02-01','2014-01-01 10:39:30','135.00',NULL,NULL,'278.77','143.77','R-OH012','OH0','278.77',NULL,1,'2014-01-02 04:25:29'),(15092,12063,'N','19','021','EC','A',NULL,NULL,'','0000490482','0000822060','','S3','1','Lewis','Zachary',NULL,NULL,NULL,NULL,NULL,'1612 MAYWOOD RD',0,'SOUTH EUCLID','OH','44121','4104','CY','39035','2013-12-20','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','2019879','99734OH005000301','2014-02-01','2013-12-29 21:13:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:04:29'),(5102,4043,'Y','18','021','EC','A','','','AC','0001047580','0001047580','TX00000094093','IL','1','OWINO','SCHOLASTICA','AUMA','','','34','641805177','955 WOODROW DR',0,'LEWISVILLE','TX','75067','4426','CY','48121','1953-07-10','F','U',':RET:2054-5','N','021','DEN','1814203','33348TX002000201','2014-01-01','2013-12-19 16:50:11','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:01:27'),(4657,3692,'Y','18','021','EC','A','','','AC','0000177727','0000177727','LA00000153940','IL','1','CAWTHORNE','VIVIAN','ANN','','','34','436881258','234 PENN PVT DR',0,'MANSFIELD','LA','71052','1281','CY','22031','1952-12-16','F','M',':RET:2054-5','T','021','DEN','373058','18575LA002000201','2014-01-01','2013-12-12 09:55:41','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 22:07:16'),(6481,5133,'Y','18','021','EC','A','','','AC','0000032932','0000032932','OH00000123439','IL','1','Carson','Jessie','','','Jr','34','300521813','4707 HOPE AVE',0,'ASHTABULA','OH','44004','6507','CY','39007','1951-01-05','M','U',':RET:2054-5','N','021','HLT','1080099','52664OH151001305','2014-01-01','2013-12-11 09:47:04','644.00',NULL,NULL,'722.61','78.61','R-OH011','OH0','722.61',NULL,0,'2013-12-26 00:50:19'),(2186,1798,'Y','18','021','EC','A','','','AC','0001142711','0001142711','MS00000288474','IL','1','jones','ray','','','','34','587111652','1350 COLLIER AVE',0,'JACKSON','MS','39213','4814','CY','28049','1958-01-07','M','R',':RET:2054-5','N','021','DEN','657435','46300MS002000201','2014-01-01','2013-12-09 23:16:17','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 19:19:36'),(2972,2393,'N','01','021','EC','A',NULL,NULL,'','0001099084','0000496941','','IL','1','AVANT','BRENDA','JUNE','','','34','466618098','108 half North 22ND PL',0,'LA MESA','TX','79331','2302','CY','48115','1979-10-01','F','',NULL,'T','021','DEN','235715','33348TX002000201','2014-01-01','2013-12-06 13:02:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:17:00'),(20737,16569,'N','19','021','EC','A',NULL,NULL,'','0000977970','0000542717','','S1','1','koons','chad',NULL,NULL,NULL,NULL,NULL,'327 MORROW ST',0,'GREENVILLE','OH','45331','1836','CY','39037','2001-07-27','M','',':RET:2106-3','N','021','HLT','3040152','92036OH005000501','2014-03-01','2014-01-29 20:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2014-01-30 21:01:22'),(21125,16880,'Y','18','021','EC','A','','','AC','0000201944','0000201944','TX00001811466','IL','1','Baars','Brandt','','','','34','640102405','1201 SOUTHWESTERN DR',0,'EL PASO','TX','79912','1115','CY','48141','1984-02-14','M','U',':RET:2106-3','N','021','DEN','3645895','33348TX002000201','2014-03-01','2014-02-03 14:23:44','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-03 21:00:15'),(22364,17859,'Y','18','021','EC','A','','','AC','0000713662','0000713662','OH00001807640','IL','1','Newman','Neil','','','','34','286562076','890 WOODFIELD LN',0,'BRUNSWICK','OH','44212','4744','CY','39103','1962-05-01','M','U',':RET:2106-3','N','021','DEN','3245216','99734OH005000301','2014-03-01','2014-02-10 14:38:18','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00','CIC',0,'2014-02-10 21:00:09'),(24584,19517,'Y','18','021','EC','A','','','AC','0000873284','0000873284','OH00002522382','IL','1','Kellerman','William','','','','34','285642786','4517 SPIKERUSH LN',0,'WEST CHESTER','OH','45069','5894','CY','39017','1960-01-05','M','U',':RET:2106-3','N','021','DEN','3197752','99734OH005000301','2014-04-01','2014-02-19 11:31:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:09:03'),(25747,20420,'N','01','021','EC','A',NULL,NULL,'','0001016905','0001129062','','IL','1','HERNANDEZ','ROBIN','D','','','34','296823579','1201 PARKSIDE PL',0,'FINDLAY','OH','45840','5537','CY','39063','1968-04-11','F','',':RET:2106-3','N','021','DEN','3701705','99734OH005000401','2014-04-01','2014-02-24 15:06:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:43'),(26082,20684,'Y','18','021','EC','A','','','AC','0001654707','0001654707','LA00002942715','IL','1','Holiday','Kelotta','','','','34','439491579','8414 Jessie ave',0,'BatonRouge','LA','70811',NULL,'CY','22033','1981-07-05','F','M',':RET:2054-5','N','021','DEN','3268278','18575LA002000201','2014-03-01','2014-02-26 19:32:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 06:30:04'),(356,293,'Y','18','021','EC','A','','','AC','0000303962','0000303962','MS00001196234','IL','1','Dobrowski','Joseph','Leroy','','Jr','34','427319549','7300 CAMPGROUND RD',0,'MOSS POINT','MS','39562','6994','CY','28059','1963-05-20','M','U',':RET:2106-3','N','021','DEN','391072','46300MS002000201','2014-01-01','2013-11-09 07:44:15','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 17:32:26'),(509,415,'N','01','021','EC','A',NULL,NULL,'','0000911737','0001117207','','IL','1','Rogolsky','Sueann','','','','34','290523782','2806 WARSAW ST',0,'TOLEDO','OH','43608','2362','CY','39095','1958-10-08','F','',':RET:2106-3','N','021','DEN','1234673','99734OH005000301','2014-01-01','2013-12-03 19:45:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:48:53'),(17520,14007,'Y','18','024','14','A','','','TE','0000721360','0000721360','','IL','1','Mitchell','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-06-25','M','',NULL,NULL,NULL,'','2037254','','2014-01-12','2014-01-12 10:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:01:36'),(17432,13947,'Y','18','021','EC','A','','','AC','0000595161','0000595161','OH00002087841','IL','1','Niser','Jihad','','','','34','275607589','3027 GREEN ACRES DR',0,'YOUNGSTOWN','OH','44505','2004','CY','39155','1954-04-01','M','M',':RET:2106-3','T','021','HLT','2233828','92036OH002003201','2014-02-01','2014-01-10 12:19:43','879.00',NULL,NULL,'1358.11','479.11','R-OH013','OH0','836.77',NULL,0,'2014-01-13 03:00:31'),(17196,13760,'Y','18','021','EC','A','','','AC','0002399250','0002399250','LA00001735012','IL','1','Turner','Santresa','','','','34','435818418','32040 LACROIX RD',0,'WHITE CASTLE','LA','70788','3560','CY','22047','1990-11-24','F','U',':RET:2054-5','N','021','DEN','2530278','18575LA002000101','2014-02-01','2014-01-08 13:49:13','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:22:21'),(9260,7344,'Y','18','021','EC','A','','','AC','0000271036','0000271036','LA00001084785','31','1','Fletchinger','Cathy','','','','34','438945684','P.O Box 24279',0,'New Orleans','LA','70124',NULL,'CY','22071','1953-08-03','F','U',NULL,'N','021','DEN','333121','18575LA002000201','2014-01-01','2013-11-29 18:25:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:15:17'),(16125,12917,'Y','18','021','EC','A','','','AC','0001581363','0001581363','LA00002039594','IL','1','Melancon','Tisheka','','','','34','439738738','307 CLAIBORNE ST',0,'DONALDSONVILLE','LA','70346','3203','CY','22005','1989-06-01','F','U',':RET:2054-5','N','021','DEN','2355510','18575LA002000101','2014-02-01','2014-01-03 16:41:13','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-04 02:05:31'),(7444,5892,'Y','18','021','EC','A','','','AC','0000524468','0000524468','OH00001190583','IL','1','Richardson','Cynthia','','','','34','280829594','6235 S FULTON LUCAS RD',0,'SWANTON','OH','43558','8700','CY','39095','1968-07-22','F','U',NULL,'N','021','DEN','1244641','99734OH005000301','2014-01-01','2013-12-15 08:57:25','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-26 02:30:30'),(2291,1867,'Y','18','021','EC','A','','','AC','0000172380','0000172380','OH00001143171','IL','1','Krenisky','Jennifer','','','','34','280583138','5997 ROOT RD',0,'CONNEAUT','OH','44030','9749','CY','39007','1955-02-20','F','M',':RET:2106-3','N','021','DEN','967082','99734OH005000301','2014-01-01','2013-12-09 14:32:37','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:30:46'),(18484,14743,'N','01','021','EC','A',NULL,NULL,'','0001049403','0000508013','','IL','1','Won','SunHee','','','','34','301766270','49 FORESTWOOD DR',0,'NORTHFIELD','OH','44067','1918','CY','39153','1954-08-24','F','',':RET:2040-4','N','021','HLT','2707566','52664OH151001301','2014-02-01','2014-01-14 22:37:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2014-01-16 08:46:22'),(19316,15398,'Y','18','021','EC','A','','','AC','0000637474','0000637474','TX00001918270','IL','1','carrazco','angel','','','','34','561498100','112 terrace circle',0,'Del Rio','TX','78840',NULL,'CY','48465','1950-11-05','M','M',':RET:2106-3','N','021','DEN','2708970','33348TX002000201','2014-03-01','2014-01-21 06:33:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-22 03:22:09'),(19652,15659,'N','17','021','EC','A',NULL,NULL,'','0000741751','0000493262','','IL','1','Bowman','Spincer','P',NULL,NULL,NULL,NULL,'517 S Marion St',0,'Cardington','OH','43315',NULL,'CY','39117','1999-08-24','M','',':RET:2106-3','N','021','DEN','3267520','99734OH005000401','2014-03-01','2014-01-23 12:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 21:00:20'),(22549,18006,'Y','18','021','EC','A','','','AC','0002121098','0002121098','LA00001715885','IL','1','Guitreau','Danny','','','','34','437118134','18681 Scivicque Lane',0,'Port Vincent','LA','70726',NULL,'CY','22063','1955-11-22','M','M',':RET:2106-3','N','021','DEN','3227027','18575LA002000101','2014-03-01','2014-02-10 17:43:19','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-10 21:31:43'),(23349,18607,'N','01','021','EC','A',NULL,NULL,'','0000084094','0000467134','','IL','1','Mireles','Graciela D','','','','34','288135515','4523 EVANGEL AVE NW',0,'MASSILLON','OH','44647','5997','CY','39151','1979-03-21','F','',':RET:2106-3','N','021','HLT','3453179','52664OH151001306','2014-03-01','2014-02-13 11:39:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','270.73',NULL,0,'2014-02-13 22:00:40'),(24590,19522,'Y','18','021','EC','A','','','AC','0000005889','0000005889','OH00002518947','IL','1','GAUDIO','DONALD','DOMENIC','','Jr','34','298667018','5981 APPLECREST DR',0,'BOARDMAN','OH','44512','3140','CY','39099','1961-12-27','M','U',':RET:2106-3','N','021','DEN','3840693','99734OH005000301','2014-04-01','2014-02-19 13:35:43','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-20 04:10:22'),(24849,19701,'Y','18','021','EC','A','','','AC','0000214713','0000214713','OH00002400423','IL','1','Weber','Alan','','','','34','284445659','9470 BENCHMARK LN',0,'BLUE ASH','OH','45242','6004','CY','39061','1949-11-25','M','R',':RET:2106-3','N','021','HLT','2699454','92036OH005001201','2014-04-01','2014-02-19 14:28:38','0.00',NULL,NULL,'1247.24','1247.24','R-OH004','OH0','644.00',NULL,0,'2014-02-20 04:55:12'),(27048,21420,'Y','18','024','14','A','','','TE','0001025151','0001025151','','IL','1','Elkhatib','Mostafa','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-06-16','M','',NULL,NULL,NULL,'','1703709','','2014-03-31','2014-03-03 11:35:43',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-03-03 21:00:24'),(168,141,'Y','18','021','EC','A','','','AC','0000586665','0000586665','OH00000162504','IL','1','Buchanan','Beverly','','','','34','283483593','4914 Independence Circle',0,'Stow','OH','44224',NULL,'CY','39153','1950-03-15','F','U',':RET:2106-3','N','021','HLT','324200','52664OH151001304','2014-01-01','2013-12-04 20:45:46','454.00',NULL,NULL,'658.32','204.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 17:19:22'),(3018,2427,'Y','18','021','EC','A','','','AC','0000578762','0000578762','OH00001177008','IL','1','Moore','Mary','','','','34','291701619','1767 GARDEN PL',0,'AKRON','OH','44312','5103','CY','39153','1960-09-29','F','M',':RET:2106-3','N','021','HLT','467976','52664OH151001301','2014-01-01','2013-12-06 12:29:28','255.81',NULL,NULL,'819.56','563.76','R-OH012','OH0','454.94',NULL,0,'2013-12-25 20:18:05'),(1746,1448,'N','19','021','EC','A',NULL,NULL,'','0000784364','0000899568','','IL','1','Haikal','Marie','','','','34','280028568','13882 LAKE AVE',0,'LAKEWOOD','OH','44107','1425','CY','39035','1997-07-10','F','',NULL,'N','021','DEN','2188206','99734OH005000301','2014-01-01','2013-12-24 12:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:38'),(14832,11846,'Y','18','021','EC','A','','','AC','0000789665','0000789665','OH00000986597','IL','1','polk','dan','','','','34','388525407','500 GLENWOOD AVE',0,'CINCINNATI','OH','45229','2016','CY','39061','1950-01-09','M','M',':RET:2054-5','N','021','DEN','2279259','99734OH005000301','2014-01-01','2013-12-23 20:17:31','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,1,'2013-12-29 11:14:37'),(15427,12342,'Y','18','021','EC','A','','','AC','0000969853','0000969853','TX00000877401','IL','1','TREJO','OLIVIA',NULL,NULL,NULL,NULL,NULL,'23816 FM 1017',0,'Edinburg','TX','78541',NULL,'CY','48215','1960-05-02','F','U',NULL,'N','021','DEN','1692467','33348TX002000201','2014-02-01','2013-12-31 12:05:24','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,1,'2014-01-02 04:27:38'),(15145,12104,'Y','18','021','EC','A','','','AC','0000650789','0000650789','OH00000548453','IL','1','Zink','Rebecca','','','','34','291560167','1988 TREBEIN RD',0,'XENIA','OH','45385','9515','CY','39057','1959-04-18','F','U',':RET:2106-3','N','021','DEN','1895461','99734OH005000401','2014-02-01','2013-12-30 11:13:28','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-01 12:05:52'),(18230,14550,'Y','18','024','14','A','','','TE','0000679796','0000679796','','IL','1','Stone','Brad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-12-04','M','',NULL,NULL,NULL,'','2013436','','2014-01-14','2014-01-14 21:49:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-16 08:44:18'),(21637,17277,'Y','18','024','14','A','','','TE','0000488991','0000488991','','IL','1','Wittenstrom','Lauri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-17','F','',NULL,NULL,NULL,'','2902901','','2014-02-05','2014-02-05 13:51:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-05 21:30:44'),(22014,17575,'Y','18','021','EC','A','','','AC','0001128047','0001128047','OH00002042766','IL','1','Cipollone','Catherine','','','','34','296706382','669 Ohio Pike',0,'Cincinnati','OH','45245',NULL,'CY','39025','1962-10-30','F','U',':RET:2106-3','N','021','DEN','3782347','99734OH005000301','2014-03-01','2014-02-07 16:48:59','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-07 19:00:53'),(29058,22998,'N','01','021','EC','A',NULL,NULL,'','0000457867','0000695711','','IL','1','WHITT','GARY','L','','','34','296627840','25514 COUNTY ROAD 10',0,'FRESNO','OH','43824','9742','CY','39031','1957-03-17','M','',':RET:2106-3','N','021','DEN','3152087','99734OH005000401','2014-04-01','2014-03-10 16:21:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:50'),(560,459,'Y','18','021','EC','A','','','AC','0000905572','0000905572','OH00000172794','IL','1','Such','Teri','','','','34','276549836','11596 Rich Rd',0,'Loveland','OH','45140',NULL,'CY','39061','1953-05-03','F','U',':RET:2106-3','N','021','HLT','205813','92036OH004001201','2014-01-01','2013-12-03 19:15:08','374.00',NULL,NULL,'468.46','94.46','R-OH004','OH0','468.46',NULL,0,'2013-12-25 17:50:16'),(17612,14079,'Y','18','021','EC','A','','','AC','0000126854','0000126854','TX00002369375','IL','1','MALDONADO','JESSICA','D','','','34','568919739','410 SE 13TH AVE',0,'AMARILLO','TX','79101','4341','CY','48375','1986-10-09','F','U',NULL,'N','021','DEN','1884993','33348TX002000201','2014-02-01','2014-01-13 10:58:12','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-14 01:32:22'),(15002,11991,'Y','18','021','EC','A','','','AC','0000578813','0000578813','TX00000016489','IL','1','Ninci','Debra','','','','34','449378996','16115 COPPER CANYON DR',0,'FRIENDSWOOD','TX','77546','8105','CY','48201','1961-02-16','F','U',':RET:2106-3','N','021','DEN','2417991','33348TX002000201','2014-02-01','2013-12-30 18:14:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:01:44'),(7458,5901,'Y','18','021','EC','A','','','AC','0001039737','0001039737','OH00000852174','IL','1','Skeltis','Naomi','','','','34','364062382','1710 ARDLEIGH RD',0,'COLUMBUS','OH','43221','1402','CY','39049','1981-08-17','F','U',':RET:2106-3','N','021','DEN','787234','99734OH005000301','2014-01-01','2013-12-15 13:28:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:30:50'),(1569,1310,'Y','18','021','EC','A','','','AC','0000593218','0000593218','TX00001253395','IL','1','HATFIELD','CHRIS','A','','','34','466115027','9330 SAN FERNANDO WAY',0,'DALLAS','TX','75218','3657','CY','48113','1957-10-31','M','M',':RET:2106-3','T','021','DEN','1751465','33348TX002000201','2014-01-01','2013-12-24 08:50:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:51:08'),(3910,3128,'Y','18','021','EC','A','','','AC','0001077845','0001077845','TX00000220824','IL','1','HELBERT','JACK','R','','','34','466984089','143 MCGILBERRY RD',0,'ZAVALLA','TX','75980',NULL,'CY','48005','1952-12-20','M','U',':RET:2106-3','N','021','DEN','1219939','33348TX002000101','2014-01-01','2013-12-13 10:05:00','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 21:37:04'),(1983,1622,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','599594','','2013-11-19','2013-11-19 23:04:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:46'),(5205,4131,'Y','18','021','EC','A','','','AC','0001187633','0001187633','OH00000751628','IL','1','Havens','Leann','','','','34','287504457','5792 CHANWICK DR',0,'GALLOWAY','OH','43119','9071','CY','39049','1950-06-26','F','U',':RET:2106-3','N','021','DEN','2440747','99734OH005000401','2014-01-01','2013-12-19 15:02:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:04:08'),(19422,15482,'N','01','021','EC','A',NULL,NULL,'','0000432789','0000781925','','IL','1','Livingston','Erin','','','','34','284884144','4722 BOWSER DR',0,'TOLEDO','OH','43613','3002','CY','39095','1982-01-14','F','',NULL,'N','021','HLT','2315045','92036OH001002601','2014-03-01','2014-01-21 13:43:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','278.26',NULL,1,'2014-01-22 03:23:02'),(20520,16396,'Y','18','021','EC','A','','','AC','0000713843','0000713843','TX00002574897','IL','1','Roberts','Neal','','','','34','641106150','2410 BLUE MIST CT',0,'SUGAR LAND','TX','77498','1961','CY','48157','1987-01-11','M','U',':RET:2106-3','N','021','DEN','1433944','33348TX002000101','2014-03-01','2014-01-29 14:31:26','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-29 21:01:24'),(26268,20835,'Y','18','021','EC','A','','','AC','0000156679','0000156679','TX00003042284','IL','1','Thompson','Rex','','','','34','431299616','3570 OAK HILL DR',0,'FLINT','TX','75762','6927','CY','48423','1969-10-24','M','U',':RET:2106-3','N','021','DEN','2892477','33348TX002000201','2014-04-01','2014-02-27 17:17:28','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-28 06:31:15'),(26752,21201,'Y','18','021','EC','A','','','AC','0000824454','0000824454','TX00003353413','IL','1','tran','hongnga','','','','34','024683507','1902 dartbrook dr.',0,'rowlett','TX','75089',NULL,'CY','48113','1970-04-10','F','M',':RET:2047-9','N','021','DEN','3502543','33348TX002000201','2014-03-01','2014-02-28 23:12:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-03-01 19:00:03'),(27523,21774,'Y','18','021','EC','A','','','AC','0000997807','0000997807','OH00003692556','IL','1','Harrington','Laura','Nelson','','','34','511625671','1641 FAIRWAY CRST',0,'LOVELAND','OH','45140','5815','CY','39025','1958-09-19','F','U',':RET:2106-3','N','021','HLT','3937165','92036OH002000601','2014-04-01','2014-03-04 13:42:51','372.00',NULL,NULL,'552.84','180.84','R-OH005','OH0','552.84',NULL,0,'2014-03-04 21:02:41'),(28807,22801,'N','01','021','EC','A',NULL,NULL,'','0001231833','0000500452','','IL','1','Wright','James','L','','','34','301801273','1845 Beech Rd',0,'Stow','OH','44224',NULL,'CY','39153','1969-04-24','M','',':RET:2106-3','N','021','HLT','4338954','52664OH151001301','2014-04-01','2014-03-09 09:45:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-03-09 21:00:52'),(593,488,'Y','18','021','EC','A','','','AC','0000413342','0000413342','OH00000596315','IL','1','dunlap','william','','','','34','296408553','965 LAUREL AVE',0,'CINCINNATI','OH','45246','4522','CY','39061','1956-06-26','M','R',':RET:2106-3','N','021','DEN','780537','99734OH005000401','2014-01-01','2013-12-15 18:20:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:00:06'),(3820,3059,'Y','18','021','EC','A','','','AC','0000130677','0000130677','OH00000386617','IL','1','Markielowski','Michelle','','','','34','276867049','180 Starr Drive',0,'Nelsonville','OH','45764',NULL,'CY','39009','1986-03-19','F','M',':RET:2106-3','N','021','DEN','37040','99734OH005000301','2014-01-01','2013-12-13 14:47:56','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:34:55'),(18834,15000,'N','01','021','EC','A',NULL,NULL,'','0001100618','0000983861','','IL','1','Subba','Pavi','M','','','34','294133910','1890 PLEASANT VALLEY RD',0,'STREETSBORO','OH','44241','6281','CY','39133','1973-01-01','F','',':RET:2028-9','N','021','HLT','2096944','52664OH151001306','2014-02-01','2014-01-15 21:00:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','290.36',NULL,0,'2014-01-17 03:36:10'),(19492,15536,'Y','18','021','EC','A','','','AC','0000049533','0000049533','OH00001514041','IL','1','Carpenter','Sandra','Kay','','','34','272769452','7430 WHITEWOOD DR',0,'ASHTABULA','OH','44004','9413','CY','39007','1967-08-26','F','M',':RET:2106-3','N','021','HLT','2396221','52664OH151001304','2014-03-01','2014-01-22 10:48:40','657.00',NULL,NULL,'986.20','329.20','R-OH011','OH0','377.28',NULL,0,'2014-01-23 03:02:07'),(21858,17453,'N','19','021','EC','A',NULL,NULL,'','0000378617','0000058793','','IL','1','SETON','EMMETT','','','','34','287137683','2411 WIMBLEDON PARK BLVD',0,'TOLEDO','OH','43617','2237','CY','39095','2007-10-01','M','',NULL,'N','021','DEN','3239687','99734OH005000301','2014-03-01','2014-02-06 14:02:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:19'),(23948,19042,'Y','18','024','14','A','','','TE','0000743104','0000743104','','IL','1','Elliott','Lori',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-03-12','F','',NULL,NULL,NULL,'','2819811','','2014-02-28','2014-02-14 20:47:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-15 21:00:14'),(25399,20150,'Y','18','021','EC','A','','','AC','0000661402','0000661402','OH00002746607','IL','1','ZENDER','JO','','','','34','273702442','1124 UNION ST',0,'ASHLAND','OH','44805','1831','CY','39005','1961-06-30','F','M',NULL,'N','021','HLT','3819706','52664OH151001306','2014-04-01','2014-02-25 15:42:33','825.00',NULL,NULL,'911.43','86.43','R-OH012','OH0','435.31',NULL,0,'2014-02-25 21:30:55'),(27318,21630,'Y','18','021','EC','A','','','AC','0001208667','0001208667','TX00003473052','IL','1','Harris','Haley','','','','34','632101840','410 FM 785',0,'QUEEN CITY','TX','75572','2505','CY','48067','1984-03-30','F','U',':RET:2106-3','N','021','DEN','3328793','33348TX002000201','2014-04-01','2014-03-04 15:28:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:44'),(28088,22230,'Y','18','021','EC','A','','','AC','0000347814','0000347814','TX00003607029','IL','1','SOTO','EVA','','','','34','462495116','209 SAN BERNARDINO DR',0,'ALAMO','TX','78516','9422','CY','48215','1966-05-02','F','U',NULL,'N','021','DEN','3838586','33348TX002000101','2014-04-01','2014-03-06 17:09:52','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-03-06 21:02:02'),(29001,22952,'Y','18','021','EC','A','','','AC','0000957951','0000957951','OH00003150527','IL','1','ALLISON','JACK','','','','34','302580945','966 KELLY AVE',0,'AKRON','OH','44306','3120','CY','39153','1958-04-22','M','U',':RET:2106-3','T','021','HLT','3263628','52664OH152000901','2014-04-01','2014-03-09 19:44:17','372.00',NULL,NULL,'418.89','46.89','R-OH012','OH0','418.89',NULL,0,'2014-03-10 21:01:19'),(881,729,'Y','18','021','EC','A','','','AC','0000820546','0000820546','MS00000936956','IL','1','Byrd','Nohora','','','','34','769545828','349 MEADOWOODS DR',0,'JACKSON','MS','39211','3068','CY','28049','1978-11-13','F','U',NULL,'N','021','DEN','2361792','46300MS002000201','2014-01-01','2013-12-16 15:57:43','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:07:44'),(18012,14393,'N','19','021','EC','A',NULL,NULL,'','0001184903','0000623994','','S1','1','Manning','Ted','M','','','34','272152240','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','2008-11-20','F','',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(16797,13436,'Y','18','021','EC','A','','','AC','0000360431','0000360431','TX00001591245','IL','1','Gnecco','Stephan','A','','','34','125424128','18022 SHADY KNL',0,'SAN ANTONIO','TX','78258','3410','CY','48029','1950-01-27','M','M',':RET:2106-3','N','021','DEN','1926881','33348TX002000201','2014-02-01','2014-01-11 09:40:36','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:18:09'),(13776,10996,'Y','18','021','EC','A','','','AC','0000217987','0000217987','MS00000402198','IL','1','Stockstill','Sheri','','','','34','587533664','128 WILLIAMSBURG RD',0,'PICAYUNE','MS','39466','8415','CY','28109','1971-10-29','F','U',':RET:2106-3','T','021','DEN','1679844','46300MS002000201','2014-01-01','2013-12-23 14:16:33','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 13:10:37'),(1162,959,'Y','18','021','EC','A','','','AC','0000371371','0000371371','LA00000089728','IL','1','ALBERT','KATHERINE','ROSE','','','34','433710028','28670 INTRACOASTAL RD',0,'PLAQUEMINE','LA','70764','5808','CY','22047','1973-12-27','F','U',':RET:2106-3','N','021','DEN','653891','18575LA002000201','2014-01-01','2013-12-03 16:46:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:18:55'),(2241,1842,'Y','18','021','EC','A','','','AC','0000999827','0000999827','OH00000498291','31','1','PERRYMAN','WILLETTA','M','','','34','277588528','po box 5308',0,'toledo','OH','43611',NULL,'CY','39095','1955-11-18','F','M',':RET:2054-5','N','021','HLT','938604','92036OH002002601','2014-01-01','2013-12-10 17:02:44','164.00',NULL,NULL,'573.76','409.76','R-OH001','OH0','573.76',NULL,0,'2013-12-25 19:21:02'),(19956,15918,'Y','18','021','EC','A','','','AC','0001213185','0001213185','TX00002490060','IL','1','Ngezelonye','Austen','','','','34','633983070','8418 SAILORS ST',0,'ROWLETT','TX','75089','9135','CY','48113','1953-08-02','M','U',NULL,'N','021','DEN','3128012','33348TX002000201','2014-03-01','2014-01-24 18:31:32','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-25 19:00:05'),(19962,15924,'Y','18','021','EC','A','','','AC','0000897710','0000897710','TX00001812730','IL','1','Leandro','Beatriz','','','','34','457233630','P.O . Box 416',0,'La Villa','TX','78562',NULL,'CY','48215','1967-08-10','F','M',NULL,'N','021','DEN','2722904','33348TX002000201','2014-03-01','2014-01-25 15:14:59','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-25 19:00:07'),(20016,15963,'N','01','021','EC','A',NULL,NULL,'','0000404313','0001046526','','IL','1','iqbal','javed','','','','34','627641208','14618 timber cliff ln',0,'cypress','TX','77429',NULL,'CY','48201','1972-11-28','M','',':RET:2028-9','N','021','DEN','3071510','33348TX002000201','2014-03-01','2014-01-26 00:48:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-26 19:00:11'),(22920,18270,'Y','18','024','14','A','','','TE','0000196137','0000196137','','IL','1','Vogel','Judy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-03-14','F','',NULL,NULL,NULL,'','1462002','','2014-02-26','2014-02-11 16:12:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-11 21:02:54'),(26502,21021,'N','01','021','EC','A',NULL,NULL,'','0001064742','0000145405','','IL','1','VILLA','JENNIFER','','','','34','176645707','5625 NICHOLSON DR',0,'HUDSON','OH','44236','3700','CY','39153','1968-10-02','F','',NULL,'N','021','HLT','3055284','52664OH151001304','2014-03-01','2014-02-28 16:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.02','CIC',0,'2014-02-28 21:00:15'),(752,621,'Y','18','021','EC','A','','','AC','0000094689','0000094689','TX00000987129','IL','1','Allred','Judy','','','','34','460982467','106 Joan Lane',0,'Longview','TX','75605',NULL,'CY','48183','1951-08-10','F','U',':RET:2106-3','N','021','DEN','1527476','33348TX002000201','2014-01-01','2013-12-16 09:47:39','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:04:18'),(1821,1496,'Y','18','021','EC','A','','','AC','0000593684','0000593684','OH00001555398','IL','1','tariq','mohammad','','','','34','105769780','1613 RIDGE CROSS RD',0,'PERRYSBURG','OH','43551','9055','CY','39173','1958-09-29','M','M',NULL,'N','021','HLT','1708312','92036OH005002605','2014-01-01','2013-12-24 14:19:34','971.00',NULL,NULL,'1339.43','368.43','R-OH001','OH0','434.84',NULL,0,'2013-12-25 18:57:16'),(2042,1672,'Y','18','021','EC','A','','','AC','0000622489','0000622489','TX00000271176','IL','1','YOUNG','SHERRI','','','','34','464294899','2914 EAST ATOLL DR',0,'DALLAS','TX','75216',NULL,'CY','48113','1959-12-24','F','U',':RET:2054-5','N','021','DEN','1022078','33348TX002000201','2014-01-01','2013-12-10 10:51:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:15:37'),(14892,11894,'Y','18','021','EC','A','','','AC','0002043880','0002043880','LA00000277194','IL','1','Tan','Sara','','','','34','438656127','4418 Baudin St',0,'New Orleans','LA','70119',NULL,'CY','22071','1985-04-15','F','U',':RET:2028-9','N','021','DEN','2248109','18575LA002000201','2014-02-01','2013-12-29 09:30:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:49'),(14663,11705,'Y','18','021','EC','A','','','AC','0000958686','0000958686','TX00000750847','IL','1','Garcia','Gudalupe','','','','34','466949778','po box 245',0,'santa maria','TX','78592',NULL,'CY','48061','1952-08-09','M','M',NULL,'N','021','DEN','2234725','33348TX002000201','2014-02-01','2013-12-28 13:55:29','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,1,'2013-12-29 11:08:03'),(9185,7286,'Y','18','024','14','A','','','TE','0000805092','0000805092','','IL','1','steffan','victoria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-21','F','',NULL,NULL,NULL,'','2180540','','2013-12-18','2013-12-18 15:28:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:17'),(2463,2004,'Y','18','021','EC','A','','','AC','0000080176','0000080176','LA00000606040','IL','1','Rodrigue','DJ','John','','','34','433063426','114 MAN O WAR CT',0,'BUSH','LA','70431','4529','CY','22103','1958-07-23','M','U',NULL,'N','021','DEN','489560','18575LA002000101','2014-01-01','2013-12-09 14:39:46','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 19:35:00'),(7895,6242,'N','19','021','EC','A',NULL,NULL,'','0000689688','0000664168','','S1','1','McGuire','Thomas','','','','34','284060930','1004 LONES DR',0,'PERRYSBURG','OH','43551','2332','CY','39173','2001-07-16','M','',':RET:2106-3','N','021','HLT','1836189','92036OH005002601','2014-01-01','2013-12-20 15:11:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2013-12-26 03:05:41'),(5778,4590,'Y','18','021','EC','A','','','AC','0000733591','0000733591','OH00000761514','IL','1','Shupe','Joseph','','','','34','275605526','608 Enright Ave',0,'Cincinnati','OH','45205',NULL,'CY','39061','1967-02-27','M','U',':RET:2106-3','N','021','DEN','1845062','99734OH005000401','2014-01-01','2013-12-23 23:09:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:46:57'),(6331,5020,'Y','18','024','14','A','','','TE','0000519804','0000519804','','IL','1','Karadeniz','Courtney','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-12-06','F','',NULL,NULL,NULL,'','817043','','2013-12-11','2013-12-11 11:36:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:46:36'),(7267,5762,'Y','18','021','EC','A','','','AC','0001089436','0001089436','TX00001052579','IL','1','Patel','Paresh','','','','34','731072354','800 E DICKINSON BLVD',0,'FORT STOCKTON','TX','79735','4318','CY','48371','1986-10-31','M','M',':RET:2029-7','N','021','DEN','902806','33348TX002000201','2014-01-01','2013-12-14 03:33:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:02:18'),(5194,4120,'N','01','021','EC','A',NULL,NULL,'','0000654587','0001179617','','IL','1','Hoang','Hanh','Ngoc','','','34','284117558','1918 CARLTON RD',0,'KENT','OH','44240','4213','CY','39133','1981-10-17','F','',NULL,'N','021','DEN','2481971','99734OH005000401','2014-01-01','2013-12-19 13:42:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:03:51'),(4142,3303,'N','19','021','EC','A',NULL,NULL,'','0000930898','0001003283','','IL','1','NAKKA','DANIEL','RATANKIRITI','','','34','271083719','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','2002-09-22','M','',':RET:2029-7','N','021','DEN','1476001','99734OH005000301','2014-01-01','2013-12-17 12:33:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:36'),(4581,3627,'N','01','021','EC','A',NULL,NULL,'','0000655798','0000502962','','IL','1','FLINNER','BARRY','','','','34','271602077','7553 TOWNSHIP ROAD 105',0,'MILLERSBURG','OH','44654','9511','CY','39075','1956-04-03','M','',':RET:2106-3','T','021','HLT','1130753','52664OH151001305','2014-01-01','2013-12-11 20:52:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','624.99',NULL,0,'2013-12-25 22:05:12'),(18882,15044,'Y','18','021','EC','A','','','AC','0002180108','0002180108','LA00002482984','IL','1','Burford','Carrie','','','','34','416231365','18587 MAGNOLIA EST',0,'PRAIRIEVILLE','LA','70769','3215','CY','22005','1976-09-25','F','U',NULL,'T','021','DEN','1811497','18575LA002000201','2014-02-01','2014-01-15 19:15:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:29'),(21500,17176,'Y','18','021','EC','A','','','AC','0000203118','0000203118','OH00001973914','IL','1','Meyers','Delilah','','','','34','277808240','3319 RATTEREE DR',0,'TOLEDO','OH','43611','1765','CY','39095','1982-08-09','F','M',':RET:2106-3','N','021','HLT','3147842','92036OH003002601','2014-03-01','2014-02-04 14:31:34','0.00',NULL,NULL,'236.02','236.02','R-OH001','OH0','236.02',NULL,0,'2014-02-04 21:01:51'),(23958,19050,'N','01','021','EC','A',NULL,NULL,'','0001027054','0000880226','','IL','1','Williams','Janet','','','','34','466770146','601 E. Columbia St.',0,'Marfa','TX','79843',NULL,'CY','48377','1985-12-29','F','',':RET:2106-3','N','021','DEN','3340872','33348TX002000101','2014-03-01','2014-02-14 20:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-15 22:00:08'),(24239,19248,'N','01','021','EC','A',NULL,NULL,'','0000472297','0001192717','','IL','1','Clutter','Jessica','','','','34','315969199','2357 WALES AVE',0,'LIMA','OH','45805','3449','CY','39003','1987-02-21','F','',':RET:2106-3','N','021','HLT','3712360','92036OH003001506','2014-03-01','2014-02-15 21:33:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','240.86',NULL,0,'2014-02-16 19:00:38'),(26294,20858,'Y','18','021','EC','A','','','AC','0000221374','0000221374','OH00003441743','IL','1','Phillips','Jimmie','','','','34','284783362','15082 Vollmer Road',0,'Ney','OH','43549',NULL,'CY','39039','1978-05-31','F','U',':RET:2106-3','N','021','HLT','3887989','92036OH005002605','2014-04-01','2014-02-27 15:25:47','50.00',NULL,NULL,'238.27','188.27','R-OH001','OH0','238.27',NULL,0,'2014-02-28 06:31:25'),(28138,22267,'Y','18','021','EC','A','','','AC','0000573105','0000573105','OH00003214277','IL','1','Hissong','Kim','','','','34','503943186','121 E CORNELIA ST',0,'HICKSVILLE','OH','43526','1105','CY','39039','1960-06-06','F','M',':RET:2106-3','N','021','HLT','3294574','92036OH004002601','2014-04-01','2014-03-05 21:56:42','30.00',NULL,NULL,'319.86','289.86','R-OH001','OH0','319.86',NULL,0,'2014-03-06 21:02:29'),(28186,22303,'Y','18','021','EC','A','','','AC','0000530762','0000530762','OH00002456062','IL','1','ALLEN','SAMUEL','FREDERICK','','Jr','34','204580549','1421 4TH DR SW',0,'WARREN','OH','44485','5807','CY','39155','1968-10-31','M','U',':RET:2106-3','T','021','HLT','3141408','92036OH005003206','2014-04-01','2014-03-06 14:28:46','300.00',NULL,NULL,'401.96','101.96','R-OH013','OH0','401.96',NULL,0,'2014-03-06 21:02:57'),(28934,22897,'N','01','021','EC','A',NULL,NULL,'','0000843408','0000522023','','IL','1','novel','matthew','joseph','','','34','300704105','29875 SCHWARTZ RD',0,'WESTLAKE','OH','44145','3828','CY','39035','1973-09-11','M','',':RET:2106-3','T','021','DEN','3830152','99734OH005000301','2014-04-01','2014-03-10 14:29:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:38'),(221,186,'Y','18','021','EC','A','','','AC','0000202366','0000202366','LA00000797325','IL','1','prine','janice','','','','34','436355774','10416 Howell ln.',0,'Tickfaw','LA','70466',NULL,'CY','22105','1978-08-31','F','M',':RET:2106-3','T','021','DEN','393862','18575LA002000201','2014-01-01','2013-12-05 11:39:36','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:46'),(761,628,'Y','18','021','EC','A','','','AC','0000361659','0000361659','TX00000778107','IL','1','Kay','Richard','','','','34','493561657','14722 CELESTIAL PL',0,'DALLAS','TX','75254','7560','CY','48113','1950-04-04','M','M',':RET:2106-3','N','021','DEN','1729620','33348TX002000201','2014-01-01','2013-12-16 11:26:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:04:33'),(1417,1179,'Y','18','021','EC','A','','','AC','0001838707','0001838707','LA00001068189','IL','1','Sampson','Hayley','','','','34','523759624','815.5 ROOSEVELT PL',0,'NEW ORLEANS','LA','70119','3823','CY','22071','1987-12-22','F','U',':RET:2106-3','N','021','DEN','2203278','18575LA002000201','2014-01-01','2013-12-24 14:49:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:07'),(17992,14379,'Y','18','021','EC','A','','','AC','0000372625','0000372625','OH00001560045','IL','1','ANDREWS','DEBRA','','','','34','294561632','2336 24TH ST',0,'CUYAHOGA FALLS','OH','44223','1510','CY','39153','1965-11-03','F','M',':RET:2106-3','N','021','DEN','2380344','99734OH005000301','2014-02-01','2014-01-13 19:11:53','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-15 02:06:57'),(2071,1696,'Y','18','021','EC','A','','','AC','0000753105','0000753105','LA00000712105','31','1','Pierce','Joseph','Whittenton','','','34','431922982','P.O. Box 1894',0,'Hammond','LA','70404',NULL,'CY','22105','1949-11-29','M','M',':RET:2106-3','N','021','DEN','914687','18575LA002000201','2014-01-01','2013-12-09 20:02:52','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:23'),(3550,2849,'Y','18','021','EC','A','','','AC','0000792207','0000792207','OH00001082936','IL','1','Cottle','Kristy','','','','34','286760114','434 HILBISH AVE',0,'AKRON','OH','44312','2250','CY','39153','1978-03-09','F','U',':RET:2106-3','N','021','HLT','2174303','52664OH151001306','2014-01-01','2013-12-21 22:24:40','174.00',NULL,NULL,'272.52','98.52','R-OH012','OH0','272.52',NULL,0,'2013-12-25 21:21:59'),(6165,4887,'N','01','021','EC','A',NULL,NULL,'','0000662666','0000295448','','IL','1','McFerran','Gary','D','','','34','502906482','6150 SHADE RD',0,'GREENVILLE','OH','45331','9577','CY','39037','1959-04-05','M','',':RET:2106-3','N','021','HLT','821715','92036OH003000504','2014-01-01','2013-11-21 14:21:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','529.99',NULL,0,'2013-12-26 00:16:54'),(14161,11288,'N','01','021','EC','A',NULL,NULL,'','0001216518','0002171639','','IL','1','Nelson','Christie','','','','34','438213194','6019 LEXINGTON AVE',0,'SHREVEPORT','LA','71106','1927','CY','22017','1966-07-22','F','',NULL,'N','021','DEN','1710820','18575LA002000201','2014-02-01','2013-12-26 15:29:29',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:03:09'),(25975,20600,'Y','18','021','EC','A','','','AC','0000940912','0000940912','OH00002334272','IL','1','Fitzgerald','Andrew','','','','34','224729400','1983 GENESSEE AVE',0,'COLUMBUS','OH','43211','1827','CY','39049','1950-09-25','M','U',':RET:2054-5','N','021','DEN','3849660','99734OH005000401','2014-03-01','2014-02-26 15:03:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:48'),(75,67,'Y','18','021','EC','A','','','AC','0000150617','0000150617','OH00001007662','IL','1','Cleghorn','John','C','','','34','307066883','8456 Fernwell Dr.',0,'Cincinnati','OH','45231',NULL,'CY','39061','1974-02-15','M','M',':RET:2106-3','N','021','DEN','1224935','99734OH005000301','2014-01-01','2013-12-05 17:09:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:17:02'),(202,167,'N','01','021','EC','A',NULL,NULL,'','0000643204','0000814258','','IL','1','HANSON','SUSAN','','','','34','272522334','65 RUE DR',0,'CRIDERSVILLE','OH','45806','2238','CY','39011','1951-01-09','F','',NULL,'N','021','HLT','1019866','92036OH005001505','2014-01-01','2013-12-05 09:15:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','632.30',NULL,0,'2013-12-25 17:20:13'),(9639,7637,'Y','18','021','EC','A','','','AC','0000921356','0000921356','TX00001176230','31','1','Chrisenberry','Steven','','','','34','454139060','null null',0,'HOUSTON','TX','77266','7189','CY','48201','1956-02-02','M','U',':RET:2106-3','N','021','DEN','1629479','33348TX002000101','2014-01-01','2013-12-21 11:55:39','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 04:38:26'),(17128,13707,'Y','18','021','EC','A','','','AC','0000192753','0000192753','OH00002057016','IL','1','See','Anna','Elsie','','','34','289509706','6911 HILLSIDE RD',0,'INDEPENDENCE','OH','44131','5343','CY','39035','1952-08-12','F','M',NULL,'N','021','DEN','2006095','99734OH005000401','2014-02-01','2014-01-08 11:25:52','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:21:45'),(16532,13225,'Y','18','021','EC','A','','','AC','0000631957','0000631957','MS00001477726','IL','1','BRAY','CHARLES','','','','34','448687855','2606 ROXANNE DR',0,'PEARL','MS','39208','6343','CY','28121','1963-01-17','M','M',':RET:1002-5','N','021','DEN','2340359','46300MS002000201','2014-02-01','2014-01-04 21:46:54','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,1,'2014-01-07 10:22:04'),(9304,7377,'Y','18','021','EC','A','','','AC','0001704380','0001704380','LA00000718045','IL','1','Kubik','James','','','','34','138623691','17233 PINE ACRES RD',0,'COVINGTON','LA','70435','8182','CY','22103','1959-07-21','M','U',':RET:2106-3','N','021','DEN','2160113','18575LA002000101','2014-01-01','2013-12-20 19:21:46','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 04:30:05'),(15964,12777,'Y','18','021','EC','A','','','AC','0000572007','0000572007','OH00002195749','31','1','EGGERS','BETH','','','','34','284843438','5366 RESERVE DR',0,'DUBLIN','OH','43017',NULL,'CY','39105','1970-05-20','F','U',':RET:2106-3','N','021','DEN','1807707','99734OH005000301','2014-02-01','2014-01-03 14:33:54','0.00',NULL,NULL,'59.76','59.76','R-OH017','OH0','0.00',NULL,0,'2014-01-04 02:00:24'),(4911,3896,'Y','18','021','EC','A','','','AC','0000302508','0000302508','TX00000016696','IL','1','Farrell','Robby','','','','34','460331546','7686 COUNTY ROAD 964',0,'NEVADA','TX','75173','6008','CY','48085','1961-03-02','M','M',':RET:2106-3','N','021','DEN','742813','33348TX002000201','2014-01-01','2013-10-26 15:53:30','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:32:06'),(4530,3589,'Y','18','024','14','A','','','TE','0000747893','0000747893','','IL','1','Fridy','Roger',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-23','M','',NULL,NULL,NULL,'','1148839','','2013-12-12','2013-12-12 15:54:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:04:02'),(20623,16479,'N','01','021','EC','A',NULL,NULL,'','0001136991','0000668605','','IL','1','cortez','maria','luisa','','','34','642072569','903 w calais pl',0,'laredo','TX','78045',NULL,'CY','48479','1968-01-25','F','',NULL,'N','021','DEN','3302500','33348TX002000201','2014-03-01','2014-01-29 18:33:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:24'),(24738,19636,'N','01','021','EC','A',NULL,NULL,'','0000990107','0000504519','','IL','1','Lovingshimer','Carl','Lee','','Jr','34','299806976','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-06-11','M','',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:09'),(24847,19699,'Y','18','021','EC','A','','','AC','0001073200','0001073200','OH00002888801','IL','1','Spangler','Wanda','','','','34','274568908','237 N HAREFOOTE RD',0,'TOLEDO','OH','43615','4823','CY','39095','1955-11-28','F','M',':RET:2106-3','N','021','HLT','2646501','92036OH006002601','2014-04-01','2014-02-19 13:33:13','295.00',NULL,NULL,'394.02','99.02','R-OH001','OH0','394.02',NULL,0,'2014-02-20 04:54:41'),(25683,20376,'Y','18','021','EC','A','','','AC','0000834214','0000834214','MS00002527597','IL','1','WINSTON','WILHELMINA','','','','34','428081208','2827 NEWPORT ST',0,'JACKSON','MS','39213','5335','CY','28049','1957-09-05','F','U',':RET:2054-5','N','021','DEN','2804204','46300MS002000201','2014-04-01','2014-02-24 12:52:58','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 09:30:06'),(26072,20675,'N','01','021','EC','A',NULL,NULL,'','0000404857','0000268949','','IL','1','KNAPP','SUSAN','','','','34','295726940','35 WASHINGTON AVE',0,'NILES','OH','44446','2433','CY','39155','1962-05-25','F','',':RET:2106-3','N','021','HLT','3631497','92036OH003003205','2014-05-01','2014-02-26 16:12:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','471.44',NULL,0,'2014-02-26 21:02:45'),(26461,20988,'Y','18','021','EC','A','','','AC','0001157723','0001157723','LA00003419735','IL','1','Perry','Raquell','','','','34','435236201','2337 BELLAIRE LN',0,'HARVEY','LA','70058','2206','CY','22051','1965-09-28','F','U',':RET:2054-5','N','021','DEN','3774070','18575LA002000201','2014-04-01','2014-02-27 11:37:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-28 07:30:31'),(242,203,'Y','18','021','EC','A','','','AC','0000344107','0000344107','OH00001310732','IL','1','hallett','clifford','','','','34','299504372','7856 state route 108',0,'wauseon','OH','43567',NULL,'CY','39051','1951-01-12','M','U',':RET:2106-3','T','021','HLT','1008719','92036OH005002601','2014-01-01','2013-12-05 05:51:35','265.00',NULL,NULL,'644.25','379.25','R-OH001','OH0','644.25',NULL,0,'2013-12-25 17:21:20'),(17248,13802,'Y','18','021','EC','A','','','AC','0000705167','0000705167','OH00002337159','IL','1','martinez','whitney','','','','34','274921896','2190 KINSMAN RD NE',0,'NORTH BLOOMFIELD','OH','44450','9729','CY','39155','1987-01-02','F','M',':RET:2106-3','N','021','DEN','1428774','99734OH005000301','2014-02-01','2014-01-09 19:32:36','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-01-13 02:23:10'),(6578,5215,'N','01','021','EC','A',NULL,NULL,'','0001248307','0001033638','','IL','1','Smith','Cassandra','','','','34','524493977','4555 STATE ROUTE 276',0,'BATAVIA','OH','45103','2108','CY','39025','1982-04-30','F','',':RET:2106-3','N','021','HLT','494804','92036OH005000604','2014-01-01','2013-12-10 20:28:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','248.81',NULL,0,'2013-12-26 00:52:53'),(15419,12335,'Y','18','021','EC','A','','','AC','0000852066','0000852066','TX00001990845','IL','1','FICKEL','AUBREY','','','','34','633090835','502 ELM RIDGE RD',0,'FREDERICKSBURG','TX','78624','5891','CY','48171','1980-04-25','F','M',NULL,'N','021','DEN','2284798','33348TX002000201','2014-02-01','2013-12-31 11:25:27','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:27:25'),(15038,12020,'Y','18','024','14','A','','','TE','0000034141','0000034141','','IL','1','English','Jamie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-07-09','F','',NULL,NULL,NULL,'','774237','','2013-12-30','2013-12-30 12:30:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-01 12:02:51'),(14851,11858,'N','01','021','EC','A',NULL,NULL,'','0000737860','0000723904','','IL','1','White','Keith','L','','','34','299522721','724 Pearlman Rd',0,'New Franklin','OH','44319',NULL,'CY','39153','1955-06-29','M','',':RET:2106-3','N','021','HLT','1704943','52664OH151001306','2014-01-01','2013-12-23 20:51:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,1,'2013-12-29 11:15:06'),(3564,2861,'N','01','021','EC','A',NULL,NULL,'','0000825908','0000599751','','IL','1','bastien','sharon','kay','','','34','364765113','k415county rd 5',0,'McClure','OH','43534',NULL,'CY','39069','1959-05-27','F','',':RET:2106-3','N','021','HLT','1515693','92036OH004002601','2014-01-01','2013-12-21 23:04:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.75',NULL,0,'2013-12-25 21:22:23'),(23209,18504,'Y','18','021','EC','A','','','AC','0000196137','0000196137','OH00002475094','31','1','Vogel','Judy','','','','34','275820374','401 Front Street',0,'New Richmond','OH','45157',NULL,'CY','39025','1968-03-14','F','R',':RET:2106-3','T','021','HLT','2825581','92036OH004000601','2014-03-01','2014-02-12 14:33:26','0.00',NULL,NULL,'788.09','788.09','R-OH005','OH0','286.65',NULL,0,'2014-02-12 21:32:13'),(27177,21517,'Y','18','021','EC','A','','','AC','0001231019','0001231019','TX00002717535','IL','1','Smith','Wanda','','','','34','550023957','1302 BRIARWOOD DR',0,'LUFKIN','TX','75901','3332','CY','48005','1957-06-16','F','U',':RET:2054-5','T','021','DEN','2636810','33348TX002000201','2014-04-01','2014-03-03 12:37:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:08'),(1065,872,'Y','18','021','EC','A','','','AC','0000780472','0000780472','OH00000931585','IL','1','Brady','Rodney','','','','34','268823265','7504 Madison Ave',0,'Cleveland','OH','44102',NULL,'CY','39035','1983-08-27','M','U',NULL,'N','021','DEN','795873','99734OH005000401','2014-01-01','2013-12-02 19:23:27','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:23'),(17467,13968,'Y','18','021','EC','A','','','AC','0000920829','0000920829','OH00002570634','IL','1','tomcko','leonard','','','','34','282527717','135 Brandtson Ave.',0,'Elyria','OH','44035',NULL,'CY','39093','1954-12-22','M','M',':RET:2106-3','N','021','DEN','2665109','99734OH005000301','2014-02-01','2014-01-12 14:05:36','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-13 03:01:06'),(2586,2102,'Y','18','021','EC','A','','','AC','0000566591','0000566591','OH00000172952','IL','1','Balmer','Jessica','','','','34','301967308','2041 WARREN RD',0,'LAKEWOOD','OH','44107','5840','CY','39035','1994-06-13','F','U',':RET:2106-3','N','021','HLT','159005','92036OH005000805','2014-01-01','2013-12-09 17:46:44','59.00',NULL,NULL,'148.47','89.47','R-OH011','OH0','148.47',NULL,0,'2013-12-25 19:38:09'),(15307,12240,'Y','18','021','EC','A','','','AC','0001933106','0001933106','LA00001741351','IL','1','VENTERS','DIANNA','','','','34','449471485','2106 GRIFFIN ST',0,'LAKE CHARLES','LA','70601',NULL,'CY','22019','1964-03-31','F','U',':RET:2054-5','N','021','DEN','2405372','18575LA002000201','2014-02-01','2014-01-01 15:59:37','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,1,'2014-01-02 04:23:03'),(14700,11737,'Y','18','021','EC','A','','','AC','0001110365','0001110365','OH00000522004','IL','1','WARNER','DEBORAH','','','','34','268700613','4918 WOOD AVE',0,'PARMA','OH','44134','2356','CY','39035','1969-01-17','F','U',NULL,'N','021','DEN','1755235','99734OH005000401','2014-02-01','2013-12-28 07:58:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2013-12-29 11:09:02'),(3196,2570,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000236090','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','20961','92036OH006002601','2014-01-01','2013-10-02 18:06:45','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-25 20:32:16'),(14095,11232,'Y','18','021','EC','A','','','AC','0000388650','0000388650','OH00000184107','IL','1','whitaker','norman','','','','34','284624348','607 W WILLIAM ST',0,'MAUMEE','OH','43537','2061','CY','39095','1959-03-22','M','M',':RET:2106-3','T','021','DEN','2163191','99734OH005000401','2014-02-01','2013-12-26 11:27:22','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-27 02:01:26'),(13674,10910,'N','01','021','EC','A',NULL,NULL,'','0000541639','0000396154','','IL','1','Bull','Kellie','Ann','','','34','271680072','268 Lakefront Dr',0,'Akron','OH','44319',NULL,'CY','39153','1966-04-11','F','',':RET:2106-3','N','021','HLT','2098673','52664OH151001306','2014-01-01','2013-12-22 19:46:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.56',NULL,0,'2013-12-26 13:08:00'),(6598,5232,'Y','18','021','EC','A','','','AC','0000823113','0000823113','MS00000104353','31','1','Bourland','Brent','','','','34','425982855','P.O Box 982',0,'Natchez','MS','39121',NULL,'CY','28001','1949-11-07','M','U',':RET:2106-3','N','021','DEN','800935','46300MS002000101','2014-01-01','2013-12-11 15:20:49','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 00:53:28'),(4967,3943,'Y','18','021','EC','A','','','AC','0000725054','0000725054','TX00001164414','31','1','Mendiola','Cesar','','','','34','453332399','P.O. Box 249',0,'Carrizo Springs','TX','78334',NULL,'CY','48127','1965-12-03','M','U',':RET:2106-3','N','021','DEN','46775','33348TX002000201','2014-01-01','2013-12-06 18:44:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:46:19'),(8937,7086,'Y','18','021','EC','A','','','AC','0000338853','0000338853','OH00001117596','IL','1','McKinney','Debra','','','','34','291428895','137 HIRN ST',0,'CHILLICOTHE','OH','45601','2627','CY','39141','1952-03-12','F','U',':RET:2106-3','N','021','DEN','2306352','99734OH005000401','2014-01-01','2013-12-18 10:45:16','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2013-12-26 04:03:14'),(5852,4648,'Y','18','021','EC','A','','','AC','0001120665','0001120665','TX00000085732','IL','1','Mageto','lawrence','','','','34','457439417','6103 hudsonwood drive',0,'arlington','TX','76001',NULL,'CY','48439','1959-02-02','M','M',':RET:2054-5','N','021','DEN','1560234','33348TX002000201','2014-01-01','2013-12-24 00:49:35','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:48:50'),(20207,16123,'Y','18','021','EC','A','','','AC','0000693395','0000693395','MS00001473065','IL','1','NELSON','NANCY','','','','34','428116118','2167 BAYWOOD DR',0,'BILOXI','MS','39532','4247','CY','28047','1966-12-21','F','U',NULL,'N','021','DEN','3184084','46300MS002000201','2014-03-01','2014-01-27 11:17:40','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-27 21:01:35'),(20564,16434,'Y','18','021','EC','A','','','AC','0001186347','0001186347','OH00001521967','IL','1','KILONSKY','MARSHA','','','','34','279528293','909 RIVERSIDE DR',0,'MILFORD','OH','45150','1241','CY','39025','1951-08-26','F','U',':RET:2106-3','T','021','HLT','3604418','92036OH005000606','2014-03-01','2014-01-29 12:50:48','493.00',NULL,NULL,'709.26','216.26','R-OH005','OH0','709.26',NULL,0,'2014-01-29 21:01:48'),(23282,18560,'Y','18','024','14','A','','','TE','0001133975','0001133975','','IL','1','Hazelwood','Mark',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-10-04','M','',NULL,NULL,NULL,'','2936998','','2014-02-28','2014-02-13 13:05:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:17'),(25496,20226,'Y','18','021','EC','A','','','AC','0000723875','0000723875','OH00002953120','IL','1','BAKER','HOLLY','','','','34','283663804','32 CHURCH STREET',0,'AMELIA','OH','45102',NULL,'CY','39025','1972-04-13','F','U',':RET:2106-3','N','021','HLT','2789158','92036OH003000605','2014-04-01','2014-02-25 08:28:04','179.00',NULL,NULL,'291.89','112.89','R-OH005','OH0','291.89',NULL,0,'2014-02-25 21:31:51'),(25900,20536,'Y','18','024','14','A','','','TE','0001099291','0001099291','','IL','1','Ondreas','Sandra','Kaye',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-11-07','F','',NULL,NULL,NULL,'','2036165','','2014-03-13','2014-02-26 13:22:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-26 21:01:08'),(26787,21229,'Y','18','021','EC','A','','','AC','0001209856','0001209856','TX00002732783','IL','1','Stephens','Cameron','','','','34','627329987','911 S Bois Darc',0,'Tyler','TX','75701',NULL,'CY','48423','1992-06-23','M','U',':RET:2106-3','T','021','DEN','3243387','33348TX002000201','2014-04-01','2014-03-01 16:41:51','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-03-01 21:00:16'),(8125,6427,'Y','18','021','EC','A','','','AC','0000983805','0000983805','OH00001144168','IL','1','Freid','Robert','David','','','34','567806768','5300 HAMILTON AVE',0,'CINCINNATI','OH','45224','3152','CY','39061','1951-06-11','M','U',':RET:2106-3','N','021','DEN','1215212','99734OH005000401','2014-01-01','2013-11-22 14:32:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:15:23'),(13430,10713,'Y','18','021','EC','A','','','AC','0000866896','0000866896','OH00000704966','IL','1','Hall','Britt','','','','34','292903249','909 Clearfield Ln',0,'Cincinnati','OH','45240',NULL,'CY','39061','1987-12-28','F','U',':RET:2054-5','N','021','DEN','1623239','99734OH005000301','2014-01-01','2013-12-23 12:03:06','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:01:00'),(14819,11837,'Y','18','021','EC','A','','','AC','0001204770','0001204770','TX00000866251','IL','1','HOPPER RIZO','ASHLEY','','','','34','642186609','1260 COUNTY ROAD 3543',0,'ATLANTA','TX','75551','5128','CY','48067','1990-11-26','F','M',':RET:2106-3','N','021','DEN','2327003','33348TX002000101','2014-01-01','2013-12-23 19:43:53','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,1,'2013-12-29 11:14:17'),(19557,15590,'Y','18','021','EC','A','','','AC','0001212961','0001212961','LA00001841820','31','1','Boudreaux','Sandra','','','','34','437022685','P. O. Box 26',0,'Erwinville','LA','70729',NULL,'CY','22077','1955-09-12','F','M',':RET:2106-3','N','021','DEN','2766743','18575LA002000101','2014-03-01','2014-01-22 14:49:45','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-23 03:02:31'),(20345,16246,'Y','18','021','EC','A','','','AC','0001244947','0001244947','MS00001353528','IL','1','STEVENS','CHERYL','','','','34','513565095','1111 HIGHLAND AVE',0,'GULFPORT','MS','39503',NULL,'CY','28047','1951-10-04','F','U',':RET:2106-3','N','021','DEN','3176646','46300MS002000201','2014-03-01','2014-01-28 10:42:14','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-28 21:01:10'),(23601,18800,'N','01','021','EC','A',NULL,NULL,'','0000003621','0000966948','','IL','1','Hemenway','Michael','','','','34','279744708','2610 STATE ROUTE 61',0,'NORWALK','OH','44857','9188','CY','39077','1963-10-31','M','',':RET:2106-3','N','021','HLT','3757008','92036OH006002701','2014-03-01','2014-02-13 15:09:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','276.19',NULL,0,'2014-02-13 22:03:08'),(26118,20713,'Y','18','024','14','A','','','TE','0001241920','0001241920','','IL','1','Mattes','Jacob',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-12-22','M','',NULL,NULL,NULL,'','3569731','','2014-02-26','2014-02-26 23:18:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:18'),(27295,21612,'N','01','021','EC','A',NULL,NULL,'','0001239612','0000922774','','IL','1','Nunn','Dawn','','','','34','514881961','8550 STATE HIGHWAY 34 N',0,'WOLFE CITY','TX','75496','2998','CY','48231','1969-03-20','F','',NULL,'N','021','DEN','3425854','33348TX002000201','2014-04-01','2014-03-04 11:21:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-04 21:00:31'),(1187,977,'N','01','021','EC','A',NULL,NULL,'','0000493191','0000184903','','IL','1','Fleming','Donna','S','','','34','277484723','153 Westwood',0,'Amherst','OH','44001',NULL,'CY','39093','1950-07-25','F','',':RET:2106-3','N','021','DEN','671996','99734OH005000301','2014-01-01','2013-12-03 09:37:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:19:31'),(7955,6295,'Y','18','021','EC','A','','','AC','0002006670','0002006670','LA00000254723','IL','1','COLEMAN','JACKIE','','','','34','436881074','515 EDWARDS ST',0,'BOSSIER CITY','LA','71111','4101','CY','22015','1960-06-24','M','U',':RET:2054-5','N','021','DEN','2015137','18575LA002000201','2014-01-01','2013-12-20 18:42:59','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:07:17'),(1882,1538,'Y','18','021','EC','A','','','AC','0001039755','0001039755','OH00000303212','IL','1','may','jermaine','','','','34','286723406','3359 blackstone dr.',0,'toledo','OH','43608',NULL,'CY','39095','1976-12-13','M','U',':RET:2054-5','N','021','HLT','2036831','92036OH006002601','2014-01-01','2013-12-24 15:26:06','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-25 18:58:33'),(1950,1590,'Y','18','021','EC','A','','','AC','0001104412','0001104412','OH00000304494','IL','1','mcgurer','harvey','d','','','34','286507430','12409 ASHWOOD LN',0,'GARRETTSVILLE','OH','44231','9643','CY','39133','1949-08-10','M','M',':RET:2106-3','N','021','HLT','258765','52664OH151001301','2014-01-01','2013-11-20 11:43:48','471.00',NULL,NULL,'669.00','198.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 19:00:57'),(15213,12159,'Y','18','021','EC','A','','','AC','0000396172','0000396172','OH00001807922','IL','1','allen','lesia','','','','34','278667518','50 MAPLE GROVE RD',0,'CAMDEN','OH','45311','9541','CY','39135','1964-10-08','F','M',':RET:2106-3','N','021','HLT','1597577','92036OH005000504','2014-02-01','2013-12-29 22:55:56','0.00',NULL,NULL,'405.53','405.53','R-OH003','OH0','405.53',NULL,0,'2014-01-01 12:07:46'),(6189,4904,'N','19','021','EC','A',NULL,NULL,'','0000179207','0000665613','','IL','1','Kayati','Amir','','','','34','690446114','2157 OLD IRONSIDES RD',0,'ABILENE','TX','79601','4765','CY','48441','2011-05-09','M','',NULL,'N','021','DEN','682853','33348TX002000101','2014-01-01','2013-10-23 00:51:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2013-12-26 00:30:17'),(13519,10777,'Y','18','024','14','A','','','TE','0000464421','0000464421','','IL','1','durnin','george',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-04','M','',NULL,NULL,NULL,'','796852','','2013-12-23','2013-12-23 07:58:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 13:03:10'),(4844,3838,'Y','18','021','EC','A','','','AC','0001047961','0001047961','OH00000622894','IL','1','Gambill','Carrie','','','','34','302782044','341 n bridge st',0,'gettysburg','OH','45328',NULL,'CY','39037','1974-02-28','F','U',':RET:2106-3','N','021','DEN','42127','99734OH005000401','2014-01-01','2013-11-08 07:10:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:30:12'),(20854,16669,'Y','18','021','EC','A','','','AC','0000647100','0000647100','OH00001502073','31','1','ANDERSON JONES','WILLIETTE','','','','34','303780539','PO BOX 17426',0,'DAYTON','OH','45417',NULL,'CY','39113','1959-10-23','F','U',NULL,'N','021','DEN','3368816','99734OH005000301','2014-03-01','2014-01-31 12:57:33','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-31 21:00:54'),(22252,17760,'Y','18','021','EC','A','','','AC','0000996562','0000996562','OH00002105571','IL','1','Stiltner','Tiffany','','','','34','302861444','1502 Clough St.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1987-11-05','F','U',':RET:2106-3','N','021','HLT','3469409','92036OH005002606','2014-03-01','2014-02-09 15:49:17','143.00',NULL,NULL,'199.67','56.67','R-OH001','OH0','199.67',NULL,0,'2014-02-09 19:00:43'),(23846,18974,'Y','18','021','EC','A','','','AC','0000452794','0000452794','OH00002336762','IL','1','ENGLISH','STEVEN','B','','Sr','34','294723944','5459 GLENRIDGE DR',0,'TOLEDO','OH','43614','1609','CY','39095','1961-04-03','M','M',':RET:2054-5','N','021','HLT','3335718','92036OH004002601','2014-03-01','2014-02-14 09:14:45','94.00',NULL,NULL,'306.05','212.05','R-OH001','OH0','306.05',NULL,0,'2014-02-14 21:31:56'),(27205,21540,'Y','18','021','EC','A','','','AC','0000140844','0000140844','TX00002602555','IL','1','bengfort','Lucille','','','','34','455020227','2011 ASHLAND DR',0,'GAINESVILLE','TX','76240','4512','CY','48097','1953-05-26','F','U',':RET:2106-3','N','021','DEN','3576934','33348TX002000201','2014-04-01','2014-03-03 17:39:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:24'),(514,419,'Y','18','021','EC','A','','','AC','0000474927','0000474927','OH00000850353','IL','1','Kinner','Diane','','','','34','287447683','7634 NEWKIRK DR',0,'FAIRFIELD','OH','45011','8630','CY','39017','1957-12-08','F','U',NULL,'N','021','DEN','1211310','99734OH005000301','2014-01-01','2013-12-04 07:52:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:49:01'),(1710,1428,'N','19','021','EC','A',NULL,NULL,'','0000314703','0000944866','','S1','1','Knippen','Rick','L',NULL,NULL,NULL,NULL,'26414 ROAD R',0,'FORT JENNINGS','OH','45844','8824','CY','39137','2006-11-27','M','',':RET:2106-3','N','021','HLT','1693316','92036OH003001501','2014-01-01','2013-12-24 07:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 18:54:59'),(22329,17830,'Y','18','021','EC','A','','','AC','0001186348','0001186348','OH00002434095','IL','1','greco','samantha','','','','34','290907235','18072 SOUTH DR',0,'STRONGSVILLE','OH','44149','1646','CY','39035','1989-06-14','F','U',':RET:2106-3','T','021','HLT','2405985','92036OH002000801','2014-03-01','2014-01-30 08:23:13','122.00',NULL,NULL,'310.49','188.49','R-OH011','OH0','310.49',NULL,0,'2014-02-10 11:00:59'),(2067,1692,'Y','18','021','EC','A','','','AC','0000874673','0000874673','OH00000936730','IL','1','HOWANIK','MELISSA','','','','34','298884196','10220 INDEPENDENCE DR',0,'NORTH ROYALTON','OH','44133','3408','CY','39035','1976-12-07','F','U',':RET:2106-3','N','021','DEN','1175557','99734OH005000301','2014-01-01','2013-12-10 17:39:59','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:16:15'),(20442,16329,'Y','18','021','EC','A','','','AC','0000268077','0000268077','MS00001921093','IL','1','PAIGE','TAMMIE','T','','','34','427192882','904 WINDING  LAKE COVE',0,'MADISON','MS','39110',NULL,'CY','28089','1969-11-28','F','U',':RET:2054-5','N','021','DEN','1755955','46300MS002000101','2014-03-01','2014-01-29 10:26:02','94.20',NULL,NULL,'121.35','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-29 21:00:41'),(28342,22425,'Y','18','021','EC','A','','','AC','0000651464','0000651464','TX00003355857','IL','1','mangum','elaine','','','','34','397723834','700 barrywood ct',0,'fort worth','TX','76112',NULL,'CY','48439','1960-09-14','F','U',':RET:2054-5','N','021','DEN','3405244','33348TX002000201','2014-04-01','2014-03-07 11:02:22','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:17'),(15337,12266,'Y','18','021','EC','A','','','AC','0000723915','0000723915','OH00000574004','IL','1','Deerhake','Katie','','','','34','289828274','1457 IVY DR',0,'ELIDA','OH','45807','9455','CY','39003','1982-12-28','F','U',':RET:2106-3','N','021','HLT','1405692','92036OH003001505','2014-02-01','2013-12-31 20:00:48','204.00',NULL,NULL,'266.38','62.38','R-OH002','OH0','266.38',NULL,1,'2014-01-02 04:24:05'),(26791,21233,'Y','18','021','EC','A','','','AC','0002073898','0002073898','LA00003514026','IL','1','Sawdon','William','','','','34','369049663','243 W PHELPS AVE',0,'SHREVEPORT','LA','71107','1924','CY','22017','1977-09-11','M','R',':RET:2106-3','N','021','DEN','2860371','18575LA002000101','2014-04-01','2014-03-01 12:14:43','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-03-01 21:00:18'),(9032,7167,'Y','18','021','EC','A','','','AC','0000130657','0000130657','OH00001293581','IL','1','Strahler','Renee','','','','34','285881352','1622 WILDON AVE',0,'AKRON','OH','44306','3334','CY','39153','1981-09-30','F','U',':RET:2106-3','N','021','HLT','1441764','52664OH151001305','2014-01-01','2013-12-18 12:07:18','158.00',NULL,NULL,'263.82','105.82','R-OH012','OH0','263.82',NULL,0,'2013-12-26 04:05:36'),(22684,18114,'Y','18','021','EC','A','','','AC','0001053612','0001053612','TX00001949535','IL','1','Thawaher Halasa','Niazi','','','','34','629270958','10109 WATERSTONE WAY',0,'MCKINNEY','TX','75070','3147','CY','48085','1946-01-01','M','M',':RET:2106-3','N','021','DEN','3600867','33348TX002000201','2014-03-01','2014-02-11 17:19:02','0.00',NULL,NULL,'17.60','17.60','R-TX008','TX0','17.60',NULL,0,'2014-02-11 21:00:49'),(1714,1430,'N','19','021','EC','A',NULL,NULL,'','0000851841','0000487992','','IL','1','Handley','Kirsten','','','','34','271061134','5320 HI LO DR',0,'FRAZEYSBURG','OH','43822','9002','CY','39119','2000-10-21','F','',':RET:2106-3','N','021','DEN','1668699','99734OH005000301','2014-01-01','2013-12-24 08:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:04'),(7888,6238,'N','01','021','EC','A',NULL,NULL,'','0000262722','0001165329','','IL','1','KHOURY','NATE','','','','34','300486845','3035 VILLA DR',0,'TOLEDO','OH','43614','5265','CY','39095','1952-01-22','M','',NULL,'N','021','HLT','1489424','92036OH005002601','2014-01-01','2013-12-19 19:28:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','547.95',NULL,0,'2013-12-26 03:05:34'),(5004,3968,'N','01','021','EC','A',NULL,NULL,'','0001057965','0000295459','','IL','1','Bozic','Sladana','','','','34','776806925','37 MEADOW CREST CIR',0,'HINCKLEY','OH','44233','9249','CY','39103','1982-03-28','F','',':RET:2106-3','N','021','DEN','70407','99734OH005000301','2014-01-01','2013-12-07 13:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:12'),(23804,18941,'Y','18','021','EC','A','','','AC','0000974129','0000974129','OH00002598863','IL','1','ast','lori','','','','34','288583154','1289 BROWNSTONE AVE',0,'AKRON','OH','44310','3977','CY','39153','1958-03-07','F','M',':RET:2106-3','N','021','HLT','2895953','52664OH151001305','2014-03-01','2014-02-14 17:18:02','955.00',NULL,NULL,'1155.63','200.63','R-OH012','OH0','497.31',NULL,0,'2014-02-14 21:31:31'),(6173,4892,'Y','18','021','EC','A','','','AC','0000017661','0000017661','TX00000176470','IL','1','Nickle','Allison','','','','34','466957564','6420 Clairmont Dr.',0,'Austin','TX','78749',NULL,'CY','48453','1985-12-30','F','U',NULL,'N','021','DEN','71542','33348TX002000201','2014-01-01','2013-10-02 10:42:27','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 00:17:06'),(27517,21769,'Y','18','021','EC','A','','','AC','0001209649','0001209649','OH00002610541','IL','1','Mock','Bronson','','','','34','279868049','2237 ROYAL PALM AVE',0,'DEFIANCE','OH','43512','3535','CY','39039','1984-10-18','M','U',NULL,'T','021','HLT','3983791','92036OH006002601','2014-04-01','2014-03-04 12:37:18','0.00',NULL,NULL,'199.00','199.00','R-OH001','OH0','199.00',NULL,0,'2014-03-04 21:02:37'),(6156,4881,'Y','18','021','EC','A','','','AC','0000397833','0000397833','MS00001159649','IL','1','butorsky','sam','l','','','34','179602197','330 WILD CEDAR PL',0,'BRANDON','MS','39042','2620','CY','28121','1952-06-22','M','M',':RET:2106-3','N','021','DEN','659599','46300MS002000201','2014-01-01','2013-11-21 15:22:14','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 00:16:39'),(9326,7393,'Y','18','021','EC','A','','','AC','0002016428','0002016428','LA00000446533','IL','1','Guercio','Matthew','','','','34','547718785','13368 COUNTRY MANOR AVE',0,'BATON ROUGE','LA','70816','4944','CY','22033','1982-02-03','M','U',':RET:2106-3','N','021','DEN','1643455','18575LA002000101','2014-01-01','2013-12-21 16:38:20','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 04:30:38'),(18257,14576,'Y','18','021','EC','A','','','AC','0000375494','0000375494','TX00001925962','IL','1','Vara','Abram','','','','34','453922947','5739 WHITE FEATHER ST',0,'SAN ANTONIO','TX','78242','2625','CY','48029','1954-01-17','M','U',NULL,'N','021','DEN','2273143','33348TX002000201','2014-02-01','2014-01-15 16:20:07','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-16 08:44:34'),(3258,2625,'Y','18','021','EC','A','','','AC','0000626703','0000626703','OH00000967944','IL','1','McLure','Noelle','','','','34','152681756','32325 Franklin Dr',0,'Solon','OH','44136',NULL,'CY','39035','1971-10-29','F','U',NULL,'N','021','DEN','1177782','99734OH005000301','2014-01-01','2013-11-28 17:49:04','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:45'),(2951,2376,'Y','18','021','EC','A','','','AC','0000184906','0000184906','OH00000529604','IL','1','Bady','Alan','','','','34','301448116','861 GATES MILLS BLVD',0,'MEDINA','OH','44256','2651','CY','39103','1951-06-21','M','U',':RET:2106-3','N','021','DEN','874622','99734OH005000401','2014-01-01','2013-12-05 18:50:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:16:32'),(28890,22866,'Y','18','021','EC','A','','','AC','0001021295','0001021295','TX00003514348','IL','1','Grundy','Fannie','','','','34','455237642','117 Collins Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1961-09-09','F','U',':RET:2054-5','N','021','DEN','3618850','33348TX002000201','2014-04-01','2014-03-10 14:46:59','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-03-10 21:00:14'),(6346,5028,'N','01','021','EC','A',NULL,NULL,'','0000058734','0000801230','','IL','1','Landrum','Michael','Dean','','','34','294521344','712 OVERLOOK HEIGHTS LN',0,'CHILLICOTHE','OH','45601','8452','CY','39141','1952-06-16','M','',':RET:2106-3','T','021','DEN','829840','99734OH005000401','2014-01-01','2013-12-11 12:43:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:53'),(6041,4784,'Y','18','024','14','A','','','TE','0001239086','0001239086','','IL','1','DENSON','KIRBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-25','M','',NULL,NULL,NULL,'','767557','','2013-12-01','2013-12-01 13:12:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:01:25'),(13598,10845,'N','01','021','EC','A',NULL,NULL,'','0000649371','0001181020','','IL','1','Hodosko','Laurie','J','','','34','296648667','4000 Yellowood St.',0,'Lima','OH','45806',NULL,'CY','39003','1964-08-07','F','',':RET:2106-3','N','021','HLT','2395344','92036OH003001505','2014-01-01','2013-12-22 20:41:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','392.11',NULL,0,'2013-12-26 13:05:21'),(4605,3646,'N','01','021','EC','A',NULL,NULL,'','0000783200','0000073912','','IL','1','Drake','John','','','','34','379648656','6800 KRISTI LYNNE LN',0,'TOLEDO','OH','43617','1279','CY','39095','1956-02-25','M','',':RET:2106-3','N','021','HLT','644090','92036OH005002601','2014-01-01','2013-12-11 21:23:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.21',NULL,0,'2013-12-25 22:05:48'),(19831,15814,'Y','18','021','EC','A','','','AC','0000967041','0000967041','TX00001466034','IL','1','Chaffin','Crystal','','','','34','459291450','5930 Arapaho Rd',0,'DALLAS','TX','75248',NULL,'CY','48113','1962-10-01','F','U',NULL,'N','021','DEN','3386195','33348TX002000201','2014-03-01','2014-01-24 10:35:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-24 21:00:19'),(20237,16147,'Y','18','021','EC','A','','','AC','0000918826','0000918826','MS00002481784','IL','1','ARCHIE','LATOYA','','','','34','426534568','203 MARY MYLES DR',0,'BRANDON','MS','39042','9341','CY','28121','1985-05-08','F','U',NULL,'N','021','DEN','3121838','46300MS002000101','2014-03-01','2014-01-28 12:56:57','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-28 21:00:05'),(14326,11426,'Y','18','021','EC','A','','','AC','0000539288','0000539288','OH00001762355','IL','1','HYTHON','DAUREATHA','','','','34','287668867','101 PIERCE AVE',0,'CUYAHOGA FALLS','OH','44221','2138','CY','39153','1970-06-28','F','U',':RET:2106-3','N','021','HLT','2520841','52664OH151001301','2014-02-01','2013-12-26 16:58:21','0.00',NULL,NULL,'302.62','302.62','R-OH012','OH0','302.62',NULL,0,'2013-12-27 02:07:24'),(3843,3074,'N','01','021','EC','A',NULL,NULL,'','0000347749','0000173114','','IL','1','GEORGIEV','JADWIGA','','','','34','249750953','16622 AUTUMN RIDGE AVE',0,'BATON ROUGE','LA','70810',NULL,'CY','22033','1953-03-07','F','',NULL,'N','021','DEN','1175652','18575LA002000101','2014-01-01','2013-12-12 21:53:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 21:35:26'),(22582,18035,'N','01','021','EC','A',NULL,NULL,'','0001084188','0000186150','','IL','1','ALBERS','VICTORIA','ANN','','','34','299569870','13080 HARDIN WAPAK RD.',0,'ANNA','OH','45302',NULL,'CY','39149','1954-02-14','F','',':RET:2106-3','N','021','HLT','3702745','92036OH004000501','2014-03-01','2014-02-10 10:32:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','518.73',NULL,0,'2014-02-10 21:32:03'),(20976,16762,'Y','18','021','EC','A','','','AC','0000446819','0000446819','MS00002105422','31','1','Friday','Omari','','','','34','425570376','P.O. Box 11391',0,'Jackson','MS','39283',NULL,'CY','28049','1986-12-01','M','U',':RET:2054-5','T','021','DEN','2275894','46300MS002000101','2014-03-01','2014-02-01 14:50:46','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-01 19:00:17'),(20595,16456,'N','01','021','EC','A',NULL,NULL,'','0001257359','0000364918','','IL','1','Fragapane','Samuel','P','','','34','278507101','30632 ROYAL WOODS PL',0,'WESTLAKE','OH','44145','3772','CY','39035','1951-04-21','M','',':RET:2106-3','N','021','DEN','3410167','99734OH005000401','2014-03-01','2014-01-30 10:11:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:10'),(18218,14540,'N','19','021','EC','A',NULL,NULL,'','0000333889','0000733613','','IL','1','ROSENBROOK','RYAN','M','','','34','271060751','4810 PICKLE RD',0,'OREGON','OH','43616','5618','CY','39095','2000-11-18','M','',':RET:2106-3','N','021','HLT','2271793','92036OH004002601','2014-02-01','2014-01-14 18:00:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-01-15 02:08:12'),(2161,1778,'Y','18','021','EC','A','','','AC','0000783203','0000783203','OH00000753816','IL','1','harmony','debra','','','','34','293787328','3323 BAYBERRY CV',0,'WOOSTER','OH','44691','5906','CY','39169','1973-02-22','F','U',':RET:2106-3','N','021','HLT','658689','52664OH151001501','2014-01-01','2013-12-09 19:34:57','0.00',NULL,NULL,'341.82','341.82','R-OH014','OH0','341.82',NULL,0,'2013-12-25 19:18:53'),(13320,10635,'Y','18','021','EC','A','','','AC','0000461825','0000461825','TX00000250372','IL','1','zarghouni','alireza','','','','34','730180489','3520 SAN PATRICIO DR',0,'PLANO','TX','75025','4426','CY','48085','1975-05-04','M','U',':RET:2106-3','N','021','DEN','1666134','33348TX002000201','2014-01-01','2013-12-23 16:37:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:58:20'),(28305,22396,'Y','18','021','EC','A','','','AC','0001341772','0001341772','LA00003419033','S3','1','Bradford','anna','Julianna','','','34','660039109','134 FOUNTAIN DR',0,'SLIDELL','LA','70458','1559','CY','22103','2000-10-20','F','U',':RET:2106-3','N','021','DEN','3314110','18575LA002000101','2014-04-01','2014-03-07 15:05:12','0.00',NULL,NULL,'44.55','44.55','R-LA001','LA0','44.55','CIC',0,'2014-03-07 21:00:34'),(29116,23049,'Y','18','021','EC','A','','','AC','0001257143','0001257143','MS00003652932','IL','1','KING','MAURINE','CATHERINE','','','34','426025106','128 BERMUDA CIR',0,'PEARL','MS','39208','5435','CY','28121','1957-08-05','F','M',':RET:2106-3','N','021','DEN','3244766','46300MS002000201','2014-04-01','2014-03-10 10:28:09','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-10 21:02:27'),(19323,15404,'Y','18','024','14','A','','','TE','0000102413','0000102413','','IL','1','Roa Pineda','Monica','Rocio',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-08-25','F','',NULL,NULL,NULL,'','2292884','','2014-01-21','2014-01-21 13:16:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:13'),(27108,21457,'N','19','021','EC','A',NULL,NULL,'','0000044327','0000938590','','S1','1','Mendoza','Cristina','','','','34','325081909','207 Rosemarie Dr',0,'Lebanon','OH','45036',NULL,'CY','39165','2008-05-27','F','',NULL,'N','021','DEN','3005502','99734OH005000301','2014-04-01','2014-03-03 10:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:25'),(21957,17533,'N','01','021','EC','A',NULL,NULL,'','0001181059','0000807532','','IL','1','WILSON','CONNIE','','','','34','278563715','5010 KEY WEST DR',0,'DAYTON','OH','45424','5925','CY','39113','1955-07-13','F','',':RET:2106-3','N','021','DEN','3556736','99734OH005000401','2014-03-01','2014-02-07 09:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:24'),(23269,18552,'N','19','021','EC','A',NULL,NULL,'','0000848565','0000555442','','IL','1','Nwanne','Michael','','','','34','629281359','8318 Lighthouse Drive',0,'Rowlett','TX','75089',NULL,'CY','48113','1991-09-07','M','',NULL,'N','021','DEN','3156478','33348TX002000101','2014-03-01','2014-02-13 09:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-13 21:30:13'),(22578,18032,'Y','18','021','EC','A','','','AC','0000100105','0000100105','OH00001448159','IL','1','Wilson','David','','','','34','290846014','1020 GRASSER ST',0,'OREGON','OH','43616','3135','CY','39095','1981-11-10','M','R',':RET:2106-3','N','021','HLT','2900556','92036OH002002601','2014-03-01','2014-02-10 09:46:38','0.00',NULL,NULL,'266.40','266.40','R-OH001','OH0','266.40',NULL,0,'2014-02-10 21:32:01'),(16154,12936,'Y','18','021','EC','A','','','AC','0000936070','0000936070','OH00001602109','IL','1','Hoskins','Tony','','','','34','283669347','1201 E SANDUSKY ST',0,'FINDLAY','OH','45840','5437','CY','39063','1963-02-17','M','U',NULL,'N','021','HLT','1754067','92036OH006001501','2014-02-01','2014-01-03 17:10:28','309.44',NULL,NULL,'311.72','2.28','R-OH002','OH0','311.72',NULL,0,'2014-01-04 02:06:21'),(5964,4721,'N','01','021','EC','A',NULL,NULL,'','0000599756','0000665647','','IL','1','Painter','Robert','V','','','34','290784862','4333 Aaron Ct',0,'Cincinnati','OH','45241',NULL,'CY','39017','1970-09-12','M','',':RET:2106-3','N','021','HLT','1566099','92036OH005001201','2014-01-01','2013-12-23 22:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.30',NULL,0,'2013-12-25 23:51:25'),(18518,14766,'Y','18','021','EC','A','','','AC','0000934059','0000934059','TX00002578287','IL','1','Sterling','Daniel','Demond','','','34','636091374','5930 Arapaho Rd',0,'Dallas','TX','75248',NULL,'CY','48113','1989-07-24','M','U',':RET:2054-5','N','021','DEN','2339257','33348TX002000101','2014-02-01','2014-01-14 21:45:36','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-16 08:46:36'),(15708,12567,'Y','18','021','EC','A','','','AC','0000433900','0000433900','OH00000120712','IL','1','NING','KAM','','','','34','318829712','110 CREEKSIDE DR',0,'MAPLE HEIGHTS','OH','44137','4780','CY','39035','1963-03-14','M','M',NULL,'T','021','HLT','1792571','92036OH003000805','2014-02-01','2013-12-31 14:44:04','733.00',NULL,NULL,'1181.66','448.66','R-OH011','OH0','501.46',NULL,1,'2014-01-02 04:36:00'),(4974,3949,'N','01','021','EC','A',NULL,NULL,'','0000674883','0000879894','','IL','1','Fuller','Michelle','Renee','','','34','454633797','308 CR 3062',0,'Newton','TX','75966',NULL,'CY','48351','1971-07-23','F','',':RET:2106-3','T','021','DEN','417184','33348TX002000201','2014-01-01','2013-12-06 19:43:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 22:46:32'),(2778,2245,'Y','18','021','EC','A','','','AC','0000840406','0000840406','MS00000079949','IL','1','SHULTS','DEBRA','','','','34','431213957','23206 HIGH 310 EAST',0,'COMO','MS','38619',NULL,'CY','28107','1958-03-25','F','M',NULL,'N','021','DEN','453169','46300MS002000101','2014-01-01','2013-12-02 17:26:57','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 19:49:45'),(2217,1826,'Y','18','021','EC','A','','','AC','0001062091','0001062091','OH00000528369','IL','1','Starcher','Benjamin','','','','34','287749582','4470 BEACHVIEW DR',0,'RAVENNA','OH','44266','9330','CY','39133','1973-12-06','M','U',':RET:2106-3','T','021','HLT','1148923','52664OH151001305','2014-01-01','2013-12-10 16:59:54','194.00',NULL,NULL,'327.75','133.75','R-OH012','OH0','327.75',NULL,0,'2013-12-25 19:20:26'),(146,125,'Y','18','021','EC','A','','','AC','0000204539','0000204539','OH00001109519','IL','1','Beal','Bart','','','','34','274607659','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1960-04-08','M','M',':RET:2106-3','N','021','HLT','217583','52664OH152000901','2014-01-01','2013-12-05 12:07:54','434.00',NULL,NULL,'845.28','411.28','R-OH012','OH0','333.21',NULL,0,'2013-12-25 17:18:51'),(15694,12555,'Y','18','021','EC','A','','','AC','0000499317','0000499317','OH00001239776','IL','1','Nichpor','Robin','','','','34','300485308','214 MARY AVE',0,'NORTHWOOD','OH','43619','1518','CY','39173','1949-09-29','F','U',':RET:2106-3','N','021','HLT','1398073','92036OH002002601','2014-02-01','2013-12-31 15:35:21','480.00',NULL,NULL,'675.55','195.55','R-OH001','OH0','675.55',NULL,1,'2014-01-02 04:35:28'),(3694,2956,'Y','18','021','EC','A','','','AC','0000656910','0000656910','OH00000652892','IL','1','Maye','Vanetta','','','','34','365784609','2850 HARRISON AVE',0,'CINCINNATI','OH','45211','7168','CY','39061','1965-10-28','F','U',NULL,'N','021','DEN','217811','99734OH005000401','2014-01-01','2013-12-13 10:45:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:48'),(13046,10400,'Y','18','021','EC','A','','','AC','0000050685','0000050685','OH00001151112','IL','1','CRONIN','KEVIN','','','','34','364560965','8250 GLENHAVEN CT',0,'WEST CHESTER','OH','45241','1433','CY','39017','1951-01-08','M','M',NULL,'N','021','DEN','1575883','99734OH005000401','2014-01-01','2013-12-23 08:22:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:44'),(3401,2729,'N','19','021','EC','A',NULL,NULL,'','0002397094','0001194892','','IL','1','Davis','Ebony','Deshontalashataria','','','34','439839429','9411 Pitchpine Dr.',0,'Shreveport','LA','71118',NULL,'CY','22017','1992-01-31','F','',':RET:2054-5','N','021','DEN','1733742','18575LA002000201','2014-01-01','2013-12-22 10:47:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 21:18:07'),(14108,11243,'N','01','021','EC','A',NULL,NULL,'','0000472268','0001048003','','IL','1','CAMBRON','RONDA','','','','34','289723878','183 MAPLEWOOD AVE',0,'WHITEHALL','OH','43213',NULL,'CY','39049','1970-07-12','F','',NULL,'N','021','DEN','1478014','99734OH005000401','2014-02-01','2013-12-26 13:55:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:46'),(1904,1557,'Y','18','021','EC','A','','','AC','0000784365','0000784365','OH00000851272','IL','1','SEELING','CORY','','','','34','281847114','312 E NORTH ST',0,'BEAVERDAM','OH','45808','9736','CY','39003','1978-08-18','M','M',NULL,'N','021','HLT','2071054','92036OH004001501','2014-01-01','2013-12-24 13:44:13','379.00',NULL,NULL,'428.24','49.24','R-OH002','OH0','216.24',NULL,0,'2013-12-25 18:59:14'),(13242,10567,'Y','18','021','EC','A','','','AC','0001164306','0001164306','TX00000946453','IL','1','HICKS','LISA','','','','34','456478377','349 CROWELL LN',0,'ROYSE CITY','TX','75189','9652','CY','48085','1966-10-20','F','M',NULL,'N','021','DEN','2523108','33348TX002000201','2014-01-01','2013-12-23 08:45:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:56:07'),(9447,7494,'Y','18','021','EC','A','','','AC','0000696807','0000696807','OH00001103522','IL','1','Shaw','Dana','','','','34','276947524','6871 Cooper rd',0,'Westerville','OH','43081',NULL,'CY','39049','1991-06-27','F','U',':RET:2106-3','N','021','DEN','1926196','99734OH005000401','2014-01-01','2013-12-20 19:50:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:33:51'),(24007,19091,'Y','18','021','EC','A','','','AC','0000674114','0000674114','OH00002222998','IL','1','Shredl','Jean','','','','34','289541274','95 S. Sunbury Rd',0,'Westerville','OH','43081',NULL,'CY','39049','1953-04-19','F','M',':RET:2106-3','N','021','DEN','2774002','99734OH005000401','2014-03-01','2014-02-15 11:13:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-15 22:00:37'),(1590,1328,'Y','18','021','EC','A','','','AC','0000894919','0000894919','TX00000205810','31','1','Willetts','Jacob','','','','34','644249927','11907 Palmdate St',0,'Houston','TX','77034',NULL,'CY','48201','1987-03-23','M','U',':RET:2106-3','N','021','DEN','1514575','33348TX002000201','2014-01-01','2013-12-24 11:34:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:51:42'),(22116,17653,'Y','18','024','14','A','','','TE','0000530739','0000530739','','IL','1','McDonald','Saige',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-06','F','',NULL,NULL,NULL,'','2745271','','2014-02-07','2014-02-07 22:37:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-08 19:00:37'),(2923,2355,'Y','18','021','EC','A','','','AC','0001057964','0001057964','OH00000034379','IL','1','staton','winston','','','','34','296545640','515 W Grand',0,'Dayton','OH','45405',NULL,'CY','39113','1955-03-04','M','U',NULL,'T','021','DEN','1050219','99734OH005000401','2014-01-01','2013-12-06 17:26:50','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:15:48'),(26606,21095,'Y','18','021','EC','A','','','AC','0001258273','0001258273','TX00003007529','IL','1','Padgett','Clyde','','','','34','498529505','257 CANYON CREEK RD',0,'LUFKIN','TX','75904','0387','CY','48005','1951-03-23','M','R',':RET:2106-3','T','021','DEN','3253582','33348TX002000201','2014-03-01','2014-02-27 22:44:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:30:44'),(15214,12160,'Y','18','024','14','A','','','TE','0001020401','0001020401','','IL','1','resor','scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-09','M','',NULL,NULL,NULL,'','1806812','','2013-12-30','2013-12-30 09:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:07:48'),(13307,10624,'Y','18','021','EC','A','','','AC','0000795795','0000795795','TX00000501495','IL','1','Peterson','Jnae','','','','34','461756424','1005 COVERT ST',0,'PALESTINE','TX','75801','8109','CY','48001','1985-11-15','F','U',NULL,'N','021','DEN','2243121','33348TX002000201','2014-01-01','2013-12-23 15:29:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:58'),(21138,16890,'N','01','021','EC','A',NULL,NULL,'','0000364697','0001071749','','IL','1','Wann','Sheila','G','','','34','449231958','3824 Stony Creek Lane',0,'College Station','TX','77845',NULL,'CY','48041','1956-10-22','F','',':RET:2106-3','T','021','DEN','3714737','33348TX002000201','2014-03-01','2014-02-03 16:27:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-03 21:00:21'),(27654,21873,'Y','18','021','EC','A','','','AC','0001012992','0001012992','OH00003618015','IL','1','Hetrick','Gerald','','','','34','291641138','19395 Knowlton Pkwy',0,'Strongsville','OH','44149',NULL,'CY','39035','1957-11-27','M','U',':RET:2106-3','N','021','DEN','3372248','99734OH005000401','2014-04-01','2014-03-05 13:27:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-05 21:30:23'),(5216,4141,'Y','18','021','EC','A','','','AC','0001183522','0001183522','OH00000210225','IL','1','Currence','James','R','','','34','296443390','1183 STATE ROUTE 88',0,'BRISTOLVILLE','OH','44402','9714','CY','39155','1954-09-16','M','M',NULL,'N','021','DEN','2216722','99734OH005000401','2014-01-01','2013-12-19 15:56:39','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:04:25'),(26861,21288,'Y','18','021','EC','A','','','AC','0001238174','0001238174','TX00003456305','31','1','WARREN','SHERRY','','','','34','455845971','POBOX 65253',0,'LUBBOCK','TX','79464',NULL,'CY','48303','1963-09-03','F','U',':RET:2106-3','N','021','DEN','3657259','33348TX002000101','2014-04-01','2014-02-28 19:58:33','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2014-03-01 21:00:56'),(5839,4638,'Y','18','021','EC','A','','','AC','0001057257','0001057257','TX00001231207','IL','1','Cantu','Maria','','','','34','464066446','1510 BALL ST',0,'HARLINGEN','TX','78550','4421','CY','48061','1955-09-12','F','M',NULL,'N','021','DEN','2341505','33348TX002000201','2014-01-01','2013-12-23 23:38:56','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 23:48:30'),(25899,20535,'Y','18','021','EC','A','','','AC','0000858518','0000858518','TX00002718549','IL','1','Ward','Kimberly','','','','34','465192364','4724 RIC DR',0,'MIDLAND','TX','79703','5316','CY','48329','1957-01-29','F','U',':RET:2106-3','N','021','DEN','2886495','33348TX002000201','2014-04-01','2014-02-26 13:16:16','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-26 21:01:07'),(25888,20526,'N','01','021','EC','A',NULL,NULL,'','0001009246','0001060050','','IL','1','Ayala','Eloisa','','','','34','637126755','20834 Lavanderwood Dr',0,'KATY','TX','77449',NULL,'CY','48201','1962-12-01','F','',NULL,'N','021','DEN','2937404','33348TX002000201','2014-04-01','2014-02-26 10:52:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-26 21:01:02'),(20868,16677,'Y','18','021','EC','A','','','AC','0000745721','0000745721','MS00001899309','IL','1','Smith','Timothy','','','','34','344620281','2449 HIGHWAY 16 E',0,'CANTON','MS','39046','8928','CY','28089','1970-07-31','M','U',NULL,'N','021','DEN','3687657','46300MS002000101','2014-03-01','2014-01-30 20:07:32','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-31 21:01:00'),(15246,12186,'Y','18','021','EC','A','','','AC','0001204537','0001204537','OH00001948522','IL','1','Norton','Jessica','','','','34','294882467','3262 Glendora Ave Apt 6',0,'Cincinnati','OH','45220',NULL,'CY','39061','1987-10-26','F','U',NULL,'N','021','HLT','1423764','92036OH003001205','2014-02-01','2013-12-30 10:23:11','127.00',NULL,NULL,'229.56','102.56','R-OH004','OH0','229.56',NULL,0,'2014-01-01 12:08:48'),(15647,12517,'Y','18','021','EC','A','','','AC','0001014723','0001014723','MS00001425005','IL','1','mclaughlin','doristean','','','','34','587600465','4242 DONOVAN ST',0,'MOSS POINT','MS','39563','5641','CY','28059','1951-09-01','F','U',NULL,'N','021','DEN','2244598','46300MS002000201','2014-02-01','2013-12-31 12:53:26','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,1,'2014-01-02 04:33:58'),(4999,3964,'N','01','021','EC','A',NULL,NULL,'','0001234104','0000514417','','IL','1','Kontos','Mary','Madonna','','','34','285560172','1811 KATHRYN DR',0,'WESTLAKE','OH','44145','3557','CY','39035','1954-01-29','F','',':RET:2106-3','N','021','DEN','490921','99734OH005000301','2014-01-01','2013-12-07 10:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:05'),(27369,21672,'Y','18','021','EC','A','','','AC','0000246699','0000246699','MS00003041241','IL','1','Baggett','Amy','','','','34','426695258','1137 DRUID HILL DR',0,'JACKSON','MS','39206','6120','CY','28049','1990-05-11','F','U',':RET:2106-3','N','021','DEN','3310779','46300MS002000101','2014-04-01','2014-03-03 18:07:37','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-04 21:01:15'),(3121,2508,'Y','18','021','EC','A','','','AC','0000296747','0000296747','OH00000763015','IL','1','Freeman','Duncan','','','','34','277138467','6574 LAKESIDE DR',0,'WEST CHESTER','OH','45069','7628','CY','39017','1980-07-19','M','U',NULL,'N','021','DEN','1132768','99734OH005000301','2014-01-01','2013-10-13 10:48:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:30:18'),(2999,2411,'Y','18','021','EC','A','','','AC','0000741691','0000741691','OH00000964504','IL','1','Welborn','Otto','S','','','34','297544183','1523 CORVALLIS AVE',0,'CINCINNATI','OH','45237','3107','CY','39061','1954-12-04','M','U',':RET:2054-5','N','021','DEN','476672','99734OH005000301','2014-01-01','2013-12-06 12:06:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:17:36'),(23542,18755,'Y','18','021','EC','A','','','AC','0001519200','0001519200','LA00002714567','IL','1','JOHNSON','LUCAS','PAUL','','','34','435512832','1106 RAILROAD AVE',0,'MAMOU','LA','70554','2724','CY','22039','1982-06-29','M','U',':RET:2106-3','T','021','DEN','3001414','18575LA002000201','2014-03-01','2014-02-13 13:06:32','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-13 22:02:33'),(23253,18538,'Y','18','021','EC','A','','','AC','0000622531','0000622531','OH00001694444','IL','1','Jordan','Timothy','','','','34','275808524','10271 kenwood',0,'Cincinnati','OH','45242',NULL,'CY','39061','1966-04-25','M','U',':RET:2106-3','N','021','DEN','2713110','99734OH005000401','2014-03-01','2014-02-13 13:16:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-13 21:30:06'),(18515,14763,'Y','18','021','EC','A','','','AC','0000270036','0000270036','OH00002288780','IL','1','reidling','susan','','','','34','270481173','27525 Buckland Holden Rd',0,'Waynesfield','OH','45896',NULL,'CY','39011','1961-08-16','F','M',':RET:2106-3','N','021','HLT','2366285','92036OH004001501','2014-02-01','2014-01-15 13:59:14','178.00',NULL,NULL,'345.43','167.43','R-OH002','OH0','345.43',NULL,0,'2014-01-16 08:46:34'),(18537,14782,'Y','18','021','EC','A','','','AC','0000338895','0000338895','OH00002462505','IL','1','Doyle','William','','','','34','271561370','829 Neeb Rd.',0,'Cincinnati','OH','45233','4670','CY','39061','1970-03-18','M','U',NULL,'N','021','HLT','1978494','92036OH004001201','2014-02-01','2014-01-14 21:46:25','180.00',NULL,NULL,'234.23','54.23','R-OH004','OH0','234.23',NULL,0,'2014-01-16 08:46:46'),(27414,21697,'N','19','021','EC','A',NULL,NULL,'','0000585592','0000862501','','IL','1','Manning','Brianna','','','','34','302114419','9096 BLUEJAY LN',0,'MENTOR','OH','44060','1853','CY','39085','2006-07-20','F','',':RET:2106-3','N','021','DEN','3909818','99734OH005000301','2014-04-01','2014-03-04 14:56:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:36'),(27899,22072,'Y','18','021','EC','A','','','AC','0000624052','0000624052','MS00003535086','S3','1','SANTOS','GRISCELIA','','','','34','626359978','9894 RIGGAN DRIVE',0,'OLIVE BRANCH','MS','38654',NULL,'CY','28033','2002-11-14','F','U',NULL,'N','021','DEN','3675253','46300MS001000101','2014-04-01','2014-03-05 16:24:38','47.10',NULL,NULL,'47.10','0.00','R-MS001','MS0','47.10',NULL,0,'2014-03-05 21:32:45'),(28616,22647,'N','01','021','EC','A',NULL,NULL,'','0000616477','0000413040','','IL','1','Faizunnessa','FNU','','','','34','630217040','6704 shadow glen dr',0,'frisco','TX','75035',NULL,'CY','48085','1954-06-20','F','',':RET:2029-7','N','021','DEN','3122842','33348TX002000201','2014-04-01','2014-03-07 21:46:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-08 21:30:18'),(8961,7109,'Y','18','024','14','A','','','TE','0000819745','0000819745','','IL','1','Collins','Cyanthia','S',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-02-25','F','',NULL,NULL,NULL,'','618035','','2013-12-18','2013-12-18 13:13:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:03:51'),(26641,21124,'Y','18','021','EC','A','','','AC','0001044315','0001044315','TX00002541965','IL','1','Perez','Mariana','','','','34','451870607','PO BOX 2127',0,'Trinity','TX','75862',NULL,'CY','48455','1957-10-24','F','M',':RET:2106-3','T','021','DEN','2663659','33348TX002000201','2014-04-01','2014-02-28 17:37:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 21:31:03'),(25288,20064,'N','01','021','EC','A',NULL,NULL,'','0001235237','0000656983','','IL','1','WOLF','NANCY','','','','34','282645146','773 COUNTY ROAD 2920',0,'PERRYSVILLE','OH','44864','9752','CY','39005','1964-08-27','F','',NULL,'N','021','HLT','3772849','52664OH151001305','2014-03-01','2014-02-24 21:21:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45','CIC',0,'2014-02-25 21:00:22'),(19553,15586,'Y','18','021','EC','A','','','AC','0002321204','0002321204','LA00001516685','IL','1','FONTENOT','JUANITA','A','','','34','438060370','3622 GREINWICH BLVD',0,'LAKE CHARLES','LA','70607','2106','CY','22019','1957-07-22','F','U',NULL,'N','021','DEN','2590790','18575LA002000101','2014-03-01','2014-01-21 20:42:12','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-01-23 03:02:30'),(28437,22500,'N','01','021','EC','A',NULL,NULL,'','0000278373','0000162328','','IL','1','IMES','JOHN','','','','34','293540023','1010 N MCCLURE RD',0,'LIMA','OH','45801','8702','CY','39003','1954-07-25','M','',':RET:2106-3','N','021','HLT','3244672','92036OH003001505','2014-04-01','2014-03-06 19:45:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','598.27',NULL,0,'2014-03-07 21:31:11'),(14397,11480,'N','01','021','EC','A',NULL,NULL,'','0000382170','0000636016','','IL','1','WALDROP','RITA','','','','34','287585923','3291 BRENTWOOD CT',0,'POWELL','OH','43065','9134','CY','39041','1967-09-18','F','',NULL,'N','021','DEN','2537519','99734OH005000401','2014-02-01','2013-12-27 15:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:31:06'),(25875,20516,'Y','18','021','EC','A','','','AC','0001438001','0001438001','LA00002500095','IL','1','Bui','Anh-Dao','T','','','34','437953023','2700 Sprig Dr',0,'Marrero','LA','70072',NULL,'CY','22051','1978-11-08','F','M',':RET:2047-9','N','021','DEN','3862988','18575LA002000201','2014-04-01','2014-02-26 17:32:38','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:54'),(2928,2359,'Y','18','021','EC','A','','','AC','0000581451','0000581451','OH00000448361','IL','1','Gannon','Alyssa','','','','34','285926087','9000 LAUREL LN',0,'NORTH ROYALTON','OH','44133','1344','CY','39035','1990-02-24','F','U',':RET:2106-3','N','021','DEN','594292','99734OH005000401','2014-01-01','2013-12-05 20:47:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:15:56'),(22396,17883,'Y','18','021','EC','A','','','AC','0000894661','0000894661','OH00002576356','IL','1','Dehmel','Nina','','','','34','268600188','256 E 11TH ST',0,'ASHLAND','OH','44805','1814','CY','39005','1957-09-19','F','U',NULL,'T','021','HLT','2726537','52664OH151001304','2014-03-01','2014-02-10 13:50:14','398.00',NULL,NULL,'598.32','200.32','R-OH012','OH0','598.32',NULL,0,'2014-02-10 21:30:18'),(2876,2324,'Y','18','021','EC','A','','','AC','0000321667','0000321667','TX00001179179','IL','1','Portillo','Lou','','','','34','454962018','15907 WOLF CREEK ST',0,'SAN ANTONIO','TX','78232','2746','CY','48029','1953-11-20','M','U',':RET:2148-5^:RET:2106-3','N','021','DEN','659521','33348TX002000201','2014-01-01','2013-10-22 15:23:35','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 20:02:04'),(20121,16054,'Y','18','024','14','A','','','TE','0000796970','0000796970','','IL','1','Love','Nathaniel','','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-10-17','M','',NULL,NULL,NULL,'','1926552','','2014-01-27','2014-01-27 08:54:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:46'),(18401,14682,'Y','18','021','EC','A','','','AC','0000511974','0000511974','OH00001602411','IL','1','Commarata','Anthony','','','','34','290489457','1833 FAIRLAWN KNOLLS DR',0,'AKRON','OH','44313','5435','CY','39153','1966-02-03','M','U',':RET:2106-3','N','021','DEN','2734935','99734OH005000301','2014-02-01','2014-01-15 17:20:27','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:43'),(7122,5651,'Y','18','021','EC','A','','','AC','0000824578','0000824578','MS00000848639','IL','1','Bernard','Earnest','','','','34','426416742','2231 SLOANE ST',0,'JACKSON','MS','39204','4556','CY','28049','1965-08-31','M','U',':RET:2054-5','N','021','DEN','2243274','46300MS002000201','2014-01-01','2013-12-24 19:35:11','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 01:51:21'),(28738,22744,'Y','18','021','EC','A','','','AC','0001387274','0001387274','LA00002665983','31','1','JACKSON','DUVURI','','','','34','448623722','PO BOX 851049',0,'NEW ORLEANS','LA','70185',NULL,'CY','22071','1976-07-06','M','U',NULL,'N','021','DEN','2802011','18575LA002000201','2014-04-01','2014-03-08 18:17:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-09 21:00:07'),(342,280,'Y','18','021','EC','A','','','AC','0001108063','0001108063','OH00000756369','IL','1','roberts','stefan','s','','','34','595063363','1083 Spring Lake ave.',0,'washington CH','OH','43160',NULL,'CY','39047','1987-01-08','F','M',':RET:2106-3','N','021','DEN','614350','99734OH005000401','2014-01-01','2013-11-08 22:28:18','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:31:59'),(24694,19603,'Y','18','021','EC','A','','','AC','0000991176','0000991176','TX00002083800','IL','1','snider','susan','','','','34','459926046','110w 1st st',0,'shiner','TX','77984',NULL,'CY','48285','1950-06-01','F','U',':RET:2106-3','N','021','DEN','3007336','33348TX002000101','2014-04-01','2014-02-19 14:24:51','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:32:59'),(22896,18252,'N','19','021','EC','A',NULL,NULL,'','0000073974','0000016655','','S1','1','Huff','Kevin','Isaac','','','34','378315525','15054 MOCK RD',0,'BERLIN CENTER','OH','44401','8731','CY','39099','2005-04-26','F','',':RET:2106-3','N','021','HLT','3669385','92036OH002003201','2014-03-01','2014-02-11 10:22:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','177.51',NULL,0,'2014-02-11 21:02:39'),(23180,18481,'Y','18','021','EC','A','','','AC','0000837927','0000837927','MS00001477109','IL','1','Murray','Kelsey','','','','34','587691086','116 SHARON HILLS DR',0,'JACKSON','MS','39212','3413','CY','28049','1990-09-27','F','U',':RET:2054-5','N','021','DEN','2840242','46300MS002000101','2014-03-01','2014-02-11 21:34:30','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-12 21:31:57'),(11,8,'N','19','021','EC','A',NULL,NULL,'','0000132043','0000956623','','IL','1','Beal','Erica','','','','34','287961974','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1993-08-20','F','',':RET:2106-3','N','021','DEN','938477','99734OH005000401','2014-01-01','2013-12-04 23:45:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:15:17'),(9217,7312,'Y','18','021','EC','A','','','AC','0001021436','0001021436','OH00000093982','IL','1','bailey','jennifer','','','','34','274785028','5553 lewis ave',0,'toledo','OH','43612',NULL,'CY','39095','1977-09-05','F','U',':RET:2106-3','N','021','HLT','1847370','92036OH004002601','2014-01-01','2013-12-18 11:14:20','0.00',NULL,NULL,'192.86','192.86','R-OH001','OH0','192.86',NULL,0,'2013-12-26 04:10:05'),(7125,5654,'Y','18','021','EC','A','','','AC','0000463703','0000463703','MS00001056846','IL','1','El-sadek','Lamees','','','','34','587656571','15134 I-55',0,'Terry','MS','39170',NULL,'CY','28049','1989-07-20','F','U',NULL,'N','021','DEN','1982826','46300MS002000201','2014-02-01','2013-12-25 00:31:47','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 01:51:27'),(1754,1452,'Y','18','021','EC','A','','','AC','0000819781','0000819781','OH00000524529','IL','1','SIGNER','JULIE','','','','34','291648501','27020 CEDAR RD',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1962-11-07','F','U',NULL,'N','021','DEN','2112363','99734OH005000301','2014-01-01','2013-12-24 12:43:52','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:55:47'),(15169,12122,'Y','18','021','EC','A','','','AC','0000998790','0000998790','OH00001646291','IL','1','Diekmeyer','Kimberley','','','','34','275923641','3894 IRWIN SIMPSON RD',0,'MASON','OH','45040','9475','CY','39165','1978-12-12','F','U',':RET:2106-3','N','021','DEN','1912009','99734OH005000401','2014-02-01','2013-12-30 15:23:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:06:30'),(932,771,'Y','18','021','EC','A','','','AC','0000717793','0000717793','OH00000586600','IL','1','smith','Everett','','','','34','274809923','1125 Govenors Dr.',0,'Fairfield','OH','45014',NULL,'CY','39017','1982-09-25','M','U',':RET:2054-5','N','021','DEN','825854','99734OH005000401','2014-01-01','2013-10-29 07:34:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:09:06'),(22894,18251,'Y','18','021','EC','A','','','AC','0000354012','0000354012','OH00002648219','IL','1','STOLL','JOANNE','','','','34','276546792','2950 KENDALE DRIVE',0,'TOLEDO','OH','43606',NULL,'CY','39095','1951-09-01','F','U',NULL,'N','021','HLT','3690452','92036OH003002605','2014-03-01','2014-02-11 15:35:50','418.00',NULL,NULL,'585.04','167.04','R-OH001','OH0','585.04',NULL,0,'2014-02-11 21:02:38'),(2932,2361,'Y','18','021','EC','A','','','AC','0000298196','0000298196','OH00000260583','IL','1','Ash','Kimberly','','','','34','285669346','6591 Brigham Square',0,'Dayton','OH','45459',NULL,'CY','39113','1960-09-28','F','M',':RET:2106-3','N','021','DEN','299331','99734OH005000401','2014-01-01','2013-12-05 20:52:36','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:16:01'),(17447,13955,'Y','18','024','14','A','','','TE','0000705157','0000705157','','IL','1','DOOLAN','LUCY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-27','F','',NULL,NULL,NULL,'','2244619','','2014-01-10','2014-01-10 13:26:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:37'),(3283,2647,'Y','18','021','EC','A','','','AC','0000071639','0000071639','OH00001093932','IL','1','Green','Gerald','','','','34','301623073','4531 NATURAL TRL',0,'NEW ALBANY','OH','43054','8859','CY','39049','1970-02-15','M','M',':RET:2106-3','N','021','DEN','1390224','99734OH005000301','2014-01-01','2013-12-21 21:51:17','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:15:19'),(15356,12283,'N','19','021','EC','A',NULL,NULL,'','0000377471','0000089835','','IL','1','Toalston','Richard','J','','','34','282114570','5069 Apollo Rd NE',0,'Salineville','OH','43945',NULL,'CY','39019','2005-06-24','M','',':RET:2106-3','N','021','DEN','1934105','99734OH005000301','2014-02-01','2013-12-31 23:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:24:41'),(6670,5290,'Y','18','021','EC','A','','','AC','0001147299','0001147299','OH00000639799','IL','1','Gattozzi','Kathleen','','','','34','297563072','17100 DORCHESTER DR',0,'CLEVELAND','OH','44119','1354','CY','39035','1956-08-17','F','U',':RET:2106-3','N','021','DEN','817823','99734OH005000301','2014-01-01','2013-11-15 21:11:16','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:01:05'),(27271,21595,'Y','18','024','14','A','','','TE','0000125701','0000125701','','IL','1','FAIRCHILD','EDWARD','LEE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-27','M','',NULL,NULL,NULL,'','3629919','','2014-03-03','2014-03-03 18:12:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-04 21:00:16'),(1505,1254,'Y','18','021','EC','A','','','AC','0000895713','0000895713','OH00000970257','IL','1','Amann','Meredith','','','','34','269886326','2088 RAEBURN DR',0,'CINCINNATI','OH','45223','1265','CY','39061','1982-05-11','F','U',':RET:2106-3','N','021','DEN','1622316','99734OH005000401','2014-01-01','2013-12-24 12:26:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:20'),(13837,11042,'Y','18','021','EC','A','','','AC','0000859692','0000859692','OH00001108928','IL','1','BONARRIGO','JACQUELINE','','','','34','273501817','186 TIMBER TRL',0,'MEDINA','OH','44256','3303','CY','39103','1949-07-04','F','M',':RET:2106-3','N','021','HLT','1604154','52664OH152000901','2014-01-01','2013-12-23 11:06:42','318.00',NULL,NULL,'490.00','172.00','R-OH012','OH0','490.00',NULL,0,'2013-12-26 13:12:13'),(13353,10664,'Y','18','024','14','A','','','TE','0000909825','0000909825','','IL','1','Pruitt','Elbert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-12-30','M','',NULL,NULL,NULL,'','1848858','','2013-12-23','2013-12-23 19:21:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:59:15'),(20657,16508,'Y','18','021','EC','A','','','AC','0001005686','0001005686','TX00001390531','IL','1','ritchie','jack','','','','34','632289579','04 COMMERCE ST',0,'REFUGIO','TX','78377',NULL,'CY','48391','1987-11-07','M','U',':RET:2106-3','N','021','DEN','3264145','33348TX002000201','2014-03-01','2014-01-30 16:43:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:42'),(20426,16314,'Y','18','021','EC','A','','','AC','0000128130','0000128130','OH00001360301','IL','1','MILLER','LINDA','','','','34','297563914','4645 CANTERBURY RD',0,'NORTH OLMSTED','OH','44070',NULL,'CY','39035','1958-12-17','F','U',NULL,'N','021','DEN','3136701','99734OH005000301','2014-03-01','2014-01-29 11:44:27','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:33'),(20128,16061,'Y','18','021','EC','A','','','AC','0000503009','0000503009','OH00002204643','IL','1','LEWIS','NANNETTE','M','','','34','290567038','886 FRANKLIN RD',0,'WAYNESVILLE','OH','45068','8129','CY','39165','1958-02-27','F','U',NULL,'N','021','DEN','2094625','99734OH005000401','2014-03-01','2014-01-27 11:21:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:00:50'),(19308,15391,'Y','18','021','EC','A','','','AC','0000271817','0000271817','TX00001815055','IL','1','Augustin','Joseph','','','','34','668188447','200 N Mesa Hills Dr',0,'El Paso','TX','79912',NULL,'CY','48141','1990-10-15','M','U',':RET:2054-5','N','021','DEN','2666727','33348TX002000201','2014-03-01','2014-01-20 18:42:15','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2014-01-22 03:22:04'),(23158,18462,'Y','18','021','EC','A','','','AC','0000929304','0000929304','TX00001599174','IL','1','COHEN','FRANCINE','JULIA','','','34','564080754','7246 FOX HALL LN',0,'HUMBLE','TX','77338','1456','CY','48201','1965-10-25','F','M',':RET:2054-5','N','021','DEN','3130894','33348TX002000101','2014-03-01','2014-02-12 09:16:44','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-02-12 21:31:45'),(19280,15367,'Y','18','021','EC','A','','','AC','0000679539','0000679539','OH00002388512','IL','1','Davis','Sharon','','','','34','272529424','2500 TROY RD',0,'SPRINGFIELD','OH','45504','4236','CY','39023','1951-07-09','F','M',':RET:2106-3','T','021','HLT','2094508','92036OH004000501','2014-03-01','2014-01-20 16:16:36','394.00',NULL,NULL,'631.50','237.50','R-OH003','OH0','631.50',NULL,0,'2014-01-21 08:46:59'),(8929,7079,'Y','18','021','EC','A','','','AC','0000520946','0000520946','OH00000909620','IL','1','serpette','richard','','','','34','318421509','368 Juhl rd',0,'circleville','OH','43113',NULL,'CY','39129','1950-08-30','M','M',':RET:2106-3','N','021','DEN','2215331','99734OH005000401','2014-01-01','2013-12-18 09:50:02','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:59'),(1841,1508,'Y','18','024','14','A','','','TE','0000872037','0000872037','','IL','1','Thielenhaus','Douglas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-06-29','M','',NULL,NULL,NULL,'','2009388','','2013-12-24','2013-12-24 11:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:57:38'),(14713,11747,'Y','18','021','EC','A','','','AC','0000785796','0000785796','OH00001074112','IL','1','Imam','halla','H','','','34','287964717','480 REED RD',0,'SPRINGBORO','OH','45066','9433','CY','39165','1993-04-26','F','R',':RET:2106-3','N','021','DEN','2132356','99734OH005000301','2014-02-01','2013-12-27 20:39:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','21.13',NULL,1,'2013-12-29 11:09:21'),(3960,3168,'N','19','021','EC','A',NULL,NULL,'','0000246429','0000060236','','IL','1','Dougherty','Kyle','B','','','34','292940533','1782 Middleton Rd',0,'Hudson','OH','44236',NULL,'CY','39153','1992-03-17','M','',':RET:2106-3','N','021','HLT','919943','52664OH151001501','2014-01-01','2013-12-13 13:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2013-12-25 21:38:23'),(5276,4181,'N','01','021','EC','A',NULL,NULL,'','0000812016','0000701679','','IL','1','BORES','ANDREW','JOSEPH','','','34','297629838','10134 WILLIAM HENRY DR',0,'STREETSBORO','OH','44241','5091','CY','39133','1958-01-29','M','',NULL,'N','021','HLT','2120874','52664OH151001301','2014-01-01','2013-12-19 14:06:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2013-12-25 23:05:39'),(28980,22937,'Y','18','021','EC','A','','','AC','0001083148','0001083148','OH00002847720','IL','1','Dipolito','Dianna','L','','','34','299525722','276 MALACCA ST',0,'AKRON','OH','44305','3662','CY','39153','1953-02-12','F','U',':RET:2106-3','N','021','HLT','3591466','52664OH151001301','2014-04-01','2014-03-10 09:20:05','294.00',NULL,NULL,'626.65','332.65','R-OH012','OH0','626.65',NULL,0,'2014-03-10 21:01:08'),(4593,3637,'Y','18','021','EC','A','','','AC','0001173195','0001173195','OH00000391888','IL','1','MITCHELL','BRENDA','','','','34','268686102','906 RIVERSIDE DRIVE',0,'ELYRIA','OH','44035',NULL,'CY','39093','1959-04-08','F','U',NULL,'N','021','HLT','1038373','52664OH151001306','2014-01-01','2013-12-12 12:50:52','360.00',NULL,NULL,'536.99','176.99','R-OH011','OH0','536.99',NULL,0,'2013-12-25 22:05:31'),(5532,4388,'Y','18','021','EC','A','','','AC','0000038347','0000038347','OH00000864206','IL','1','Gray','Rayshod','','','','34','298902359','3915 PRESCOTT AVE',0,'DAYTON','OH','45406','3433','CY','39113','1987-08-29','M','U',':RET:2054-5','N','021','DEN','527092','99734OH005000401','2014-01-01','2013-11-27 11:35:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:15:36'),(6215,4925,'N','01','021','EC','A',NULL,NULL,'','0000893725','0000298552','','IL','1','Arreaga','Breny','Judith','','','34','640806563','5515 gatewood st',0,'Houston','TX','77053',NULL,'CY','48201','1975-08-05','F','',NULL,'N','021','DEN','613231','33348TX002000201','2014-01-01','2013-10-15 22:12:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:30:59'),(23520,18737,'Y','18','021','EC','A','','','AC','0000600844','0000600844','OH00002635633','IL','1','Tocchi','Michelle','','','','34','278501429','3198 SPRING VALLEY RD',0,'AKRON','OH','44333','1236','CY','39153','1964-02-21','F','U',':RET:2106-3','N','021','HLT','3678481','52664OH151001501','2014-03-01','2014-02-13 15:29:10','210.00',NULL,NULL,'647.53','437.53','R-OH012','OH0','477.69',NULL,0,'2014-02-13 22:02:20'),(6286,4985,'Y','18','021','EC','A','','','AC','0000739002','0000739002','OH00001093381','IL','1','White','Josette','','','','34','302700005','25061 Arbutus Road',0,'Oakwood Village','OH','44146',NULL,'CY','39035','1968-09-24','F','M',':RET:2054-5','N','021','DEN','389123','99734OH005000401','2014-01-01','2013-12-10 21:06:18','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:30'),(20238,16148,'Y','18','021','EC','A','','','AC','0000206489','0000206489','MS00001385243','IL','1','PERKINS','ROY','','','','34','433256220','1948 PERKINS RD',0,'CENTREVILLE','MS','39631','4371','CY','28005','1961-03-14','M','M',':RET:2106-3','N','021','DEN','3444074','46300MS002000101','2014-03-01','2014-01-28 13:21:34','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-01-28 21:00:06'),(8888,7047,'Y','18','021','EC','A','','','AC','0000686689','0000686689','TX00000422236','IL','1','VARGAS','MICHELLE','','','','34','628122290','210 COUNTY ROAD 418C',0,'COMANCHE','TX','76442','5608','CY','48093','1990-01-23','F','M',NULL,'N','021','DEN','2495261','33348TX002000201','2014-01-01','2013-12-18 17:08:36','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:56'),(19616,15635,'Y','18','021','EC','A','','','AC','0000824615','0000824615','OH00001783249','IL','1','Bradford','Joseph','','','','34','287529981','602 WYANDOTTE AVE',0,'FOSTORIA','OH','44830','3150','CY','39147','1954-10-30','M','U',':RET:2106-3','N','021','HLT','1855697','92036OH004002701','2014-03-01','2014-01-22 16:46:53','396.00',NULL,NULL,'408.14','12.14','R-OH006','OH0','408.14',NULL,0,'2014-01-23 03:02:53'),(25423,20172,'Y','18','021','EC','A','','','AC','0000309505','0000309505','OH00001786497','IL','1','AGEE','GREGORY','L','','','34','282586043','4109 CENTRAL AVE',0,'MIDDLETOWN','OH','45044','5010','CY','39017','1956-10-19','M','M',':RET:2106-3','T','021','DEN','3289535','99734OH005000401','2014-04-01','2014-02-25 15:55:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:31:10'),(4855,3846,'Y','18','021','EC','A','','','AC','0001100562','0001100562','OH00000771087','IL','1','debord','dawn','','','','34','301605993','724 UNION RD',0,'FRANKLIN','OH','45005','2568','CY','39165','1976-09-07','F','U',':RET:2106-3','N','021','DEN','1180042','99734OH005000401','2014-01-01','2013-11-08 17:58:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:30:29'),(24912,19752,'Y','18','024','14','A','','','TE','0000909487','0000909487','','IL','1','Fowlkes','William',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-10-07','M','',NULL,NULL,NULL,'','2541451','','2014-03-31','2014-02-20 17:01:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 21:30:08'),(23861,18986,'Y','18','021','EC','A','','','AC','0001935595','0001935595','LA00002752528','IL','1','CARNEY','CAROLINE','','','','34','415457464','3920 PERRIER ST',0,'NEW ORLEANS','LA','70115','3740','CY','22071','1983-11-13','F','U',':RET:2106-3','N','021','DEN','3564179','18575LA002000101','2014-03-01','2014-02-14 13:09:28','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-14 21:32:04'),(21725,17348,'Y','18','021','EC','A','','','AC','0000404351','0000404351','TX00001742073','31','1','GROUNDS','BROOKE','','','','34','631321251','po box 8571',0,'horseshoe bay','TX','78657',NULL,'CY','48053','1992-07-21','F','R',':RET:2106-3','N','021','DEN','3804448','33348TX002000201','2014-03-01','2014-02-06 11:30:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:06'),(6358,5040,'Y','18','021','EC','A','','','AC','0000525554','0000525554','OH00000219623','IL','1','Williams','Teresa','','','','34','300821956','311 ARLINGTON RD',0,'BROOKVILLE','OH','45309','1322','CY','39113','1971-06-27','F','U',NULL,'N','021','DEN','1103785','99734OH005000401','2014-01-01','2013-12-11 17:10:22','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:47:16'),(14732,11762,'N','19','021','EC','A',NULL,NULL,'','0001128005','0000799899','','IL','1','Jundi','Emma','Dorothea','','','34','292113245','324 ASHLAND AVE',0,'CUYAHOGA FALLS','OH','44221','2210','CY','39153','2006-01-26','F','',':RET:2106-3','N','021','HLT','2297573','52664OH151001304','2014-02-01','2013-12-28 14:13:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,1,'2013-12-29 11:09:49'),(20281,16186,'Y','18','021','EC','A','','','AC','0000812055','0000812055','OH00001354766','IL','1','JAMES','ELENORA','','','','34','405966443','2839 ROBERT AVE',0,'CINCINNATI','OH','45211','8032','CY','39061','1961-07-24','F','U',NULL,'N','021','DEN','2709128','99734OH005000401','2014-03-01','2014-01-28 15:32:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-28 21:00:29'),(15151,12110,'Y','18','021','EC','A','','','AC','0000203095','0000203095','OH00001509996','IL','1','Ament','Anna','','','','34','270520690','1851 KING JAMES PKWY',0,'WESTLAKE','OH','44145','3427','CY','39035','1950-11-29','F','U',':RET:2106-3','N','021','DEN','2386593','99734OH005000401','2014-02-01','2013-12-30 12:43:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:06:04'),(17964,14355,'Y','18','021','EC','A','','','AC','0000074038','0000074038','TX00002351880','IL','1','Tran','Lien','','','','34','730268617','1720 Wells Branch Pkwy',0,'Austin','TX','78728',NULL,'CY','48453','1974-02-10','F','M',':RET:2047-9','N','021','DEN','2026611','33348TX002000201','2014-02-01','2014-01-14 18:39:50','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:47'),(25381,20137,'Y','18','021','EC','A','','','AC','0000297633','0000297633','MS00002119882','IL','1','MCGEE','ESSIE','L','','','34','587923870','1101 WESTSIDE DR',0,'BELZONI','MS','39038','3061','CY','28053','1959-12-19','F','U',':RET:2054-5','N','021','DEN','3464418','46300MS002000101','2014-04-01','2014-02-24 18:16:58','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-25 21:30:46'),(348,285,'Y','18','021','EC','A','','','AC','0000982668','0000982668','OH00001102759','IL','1','Roberts','Nanette','','','','34','550330973','124 HIGHLAND DR',0,'HIRAM','OH','44234','9655','CY','39055','1959-02-19','F','U',':RET:2106-3','N','021','DEN','1008531','99734OH005000301','2014-01-01','2013-11-08 22:08:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:32:10'),(633,523,'N','01','021','EC','A',NULL,NULL,'','0000367365','0001026922','','IL','1','Le','Tam','V','','','34','379137939','12085 Brookston Dr',0,'Cincinnati','OH','45240','1350','CY','39061','1966-03-04','M','',':RET:2047-9','N','021','DEN','1367458','99734OH005000401','2014-01-01','2013-12-16 13:17:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:01:09'),(13457,10731,'Y','18','024','14','A','','','TE','0000116589','0000116589','','IL','1','Verga','Cosette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-08-11','F','',NULL,NULL,NULL,'','2417728','','2013-12-23','2013-12-23 14:57:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:01:40'),(23291,18568,'Y','18','021','EC','A','','','AC','0001221980','0001221980','OH00001735802','IL','1','Montgomery','Sandra','','','','34','275482354','1752 E. Frankfort Street',0,'Columbus','OH','43206',NULL,'CY','39049','1951-02-18','F','U',':RET:2054-5','N','021','DEN','3212935','99734OH005000301','2014-03-01','2014-02-12 22:29:20','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:07'),(21064,16831,'Y','18','021','EC','A','','','AC','0000859729','0000859729','OH00002320622','IL','1','czlapinski','rosemary','','','','34','279444343','747 Kipling Dr',0,'toledo','OH','43612',NULL,'CY','39095','1954-07-16','F','M',':RET:2106-3','T','021','HLT','2668978','92036OH005002605','2014-03-01','2014-02-02 15:27:32','886.00',NULL,NULL,'1213.87','327.87','R-OH001','OH0','583.72',NULL,0,'2014-02-02 19:00:14'),(5233,4153,'N','19','021','EC','A',NULL,NULL,'','0000446277','0001229301','','IL','1','Kress','Dylan','R','','','34','269110703','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','2004-08-28','M','',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:04:48'),(20556,16427,'Y','18','024','14','A','','','TE','0001065985','0001065985','','IL','1','CORNE','KATHLEEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-06-08','F','',NULL,NULL,NULL,'','2297770','','2014-01-29','2014-01-29 16:19:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:44'),(16304,13053,'Y','18','021','EC','A','','','AC','0001918713','0001918713','LA00000010622','IL','1','MILLER','JIMMIE','','','','34','436063313','3901 TULANE AVE',0,'NEW ORLEANS','LA','70119',NULL,'CY','22071','1962-02-28','M','U',':RET:2054-5','N','021','DEN','1794781','18575LA002000201','2014-02-01','2014-01-05 19:41:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:13'),(20352,16253,'Y','18','021','EC','A','','','AC','0000721370','0000721370','OH00001447912','IL','1','Vinson','Jeri','','','','34','272583297','21018 U.S. Route 68',0,'Fayetteville','OH','45118',NULL,'CY','39015','1956-01-15','F','U',':RET:2106-3','N','021','HLT','2664295','92036OH004000601','2014-03-01','2014-01-28 11:38:44','404.00',NULL,NULL,'439.81','35.81','R-OH005','OH0','439.81',NULL,0,'2014-01-28 21:01:15'),(19908,15878,'Y','18','024','14','A','','','TE','0000968210','0000968210','','IL','1','musil','mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-28','F','',NULL,NULL,NULL,'','1485820','','2014-01-24','2014-01-24 13:06:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:59'),(19822,15805,'Y','18','021','EC','A','','','AC','0000175120','0000175120','TX00002553728','IL','1','Magallanes','Ramon','','','','34','464199571','509 N FAULKNER ST',0,'PAMPA','TX','79065','6122','CY','48179','1956-11-05','M','M',':RET:2106-3','T','021','DEN','3346792','33348TX002000201','2014-03-01','2014-01-23 21:38:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-24 21:00:14'),(18514,14762,'N','01','021','EC','A',NULL,NULL,'','0000932125','0001093159','','IL','1','Mohr','J','Gregory','','','34','160701528','192 Garmatter St',0,'Bluffton','OH','45817',NULL,'CY','39003','1973-10-28','M','',':RET:2106-3','N','021','HLT','2043952','92036OH004001501','2014-02-01','2014-01-15 10:52:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','226.17',NULL,0,'2014-01-16 08:46:34'),(24,19,'Y','18','021','EC','A','','','AC','0001213444','0001213444','OH00000670671','IL','1','Wagner','Jeanne','','','','34','281585659','5326 DONNER DR',0,'CLINTON','OH','44216','9711','CY','39153','1955-03-22','F','U',':RET:2106-3','N','021','DEN','824812','99734OH005000401','2014-01-01','2013-12-05 16:13:36','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:15:35'),(13469,10743,'Y','18','021','EC','A','','','AC','0000203083','0000203083','OH00000490118','IL','1','EDWARDS','VIVIAN','','','','34','276600237','4517 CIRCLE HILL CT',0,'DAYTON','OH','45424','4479','CY','39113','1958-10-21','F','M',':RET:2054-5','N','021','DEN','1971847','99734OH005000301','2014-01-01','2013-12-23 16:09:37','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:01:58'),(20790,16611,'Y','18','024','14','A','','','TE','0000168969','0000168969','','IL','1','Trauthwein','Carol',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-22','F','',NULL,NULL,NULL,'','3266534','','2014-01-31','2014-01-31 09:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-31 21:00:15'),(2578,2095,'Y','18','024','14','A','','','TE','0000045728','0000045728','','IL','1','Weihrauch','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-16','F','',NULL,NULL,NULL,'','1218721','','2013-12-09','2013-12-09 16:25:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:37:54'),(24589,19521,'Y','18','021','EC','A','','','AC','0000278358','0000278358','OH00002499915','IL','1','BOGGAN','LINDA','','','','34','289740464','20551 MILLER AVE',0,'EUCLID','OH','44119','2312','CY','39035','1965-01-26','F','U',':RET:2106-3','N','021','DEN','3495804','99734OH005000301','2014-04-01','2014-02-19 13:13:26','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:10:15'),(5757,4572,'Y','18','021','EC','A','','','AC','0000574452','0000574452','OH00001438480','IL','1','Oberacker','Kassady','','','','34','293828080','2311 19TH ST',0,'CUYAHOGA FALLS','OH','44223','1538','CY','39153','1983-06-18','F','U',':RET:2106-3','N','021','DEN','1817866','99734OH005000401','2014-01-01','2013-12-23 21:29:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:46:24'),(28678,22694,'Y','18','021','EC','A','','','AC','0000266583','0000266583','OH00002864807','IL','1','Busler','Robert','','','','34','275708630','911 Clark St',0,'Toledo','OH','43605',NULL,'CY','39095','1965-12-14','M','M',NULL,'T','021','HLT','4045649','92036OH004002601','2014-04-01','2014-03-08 14:47:43','168.00',NULL,NULL,'294.81','126.81','R-OH001','OH0','294.81',NULL,0,'2014-03-08 21:30:54'),(5804,4610,'Y','18','021','EC','A','','','AC','0001085910','0001085910','TX00000674067','IL','1','Johnson','Francis','','','','34','466694112','2156 CR 215',0,'Weimar','TX','78962',NULL,'CY','48089','1982-12-15','M','U',':RET:2106-3','N','021','DEN','2286930','33348TX002000201','2014-01-01','2013-12-23 21:14:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:47:34'),(25519,20245,'Y','18','021','EC','A','','','AC','0000682197','0000682197','OH00003364740','IL','1','ADKINS','JAMES','RUSSELL','','','34','272932131','445 S 1ST ST',0,'HAMLER','OH','43524','9763','CY','39069','1988-07-21','M','U',NULL,'N','021','HLT','3171820','92036OH003002605','2014-04-01','2014-02-25 15:16:03','109.00',NULL,NULL,'204.45','95.45','R-OH001','OH0','204.45',NULL,0,'2014-02-25 21:32:05'),(702,579,'Y','18','021','EC','A','','','AC','0000702923','0000702923','LA00000796526','IL','1','davis','patricia','','','','34','434907822','1316 FARRAGUT ST',0,'NEW ORLEANS','LA','70114','2816','CY','22071','1951-09-04','F','M',NULL,'N','021','DEN','1220021','18575LA002000201','2014-01-01','2013-12-15 18:59:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:02:56'),(1482,1236,'Y','18','021','EC','A','','','AC','0000430277','0000430277','OH00000960037','IL','1','Owens','Eric','','','','34','276808843','365 E MITHOFF ST',0,'COLUMBUS','OH','43206','3508','CY','39049','1967-07-02','M','U',':RET:2106-3','N','021','DEN','2093807','99734OH005000401','2014-01-01','2013-12-24 10:32:07','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:48:49'),(19306,15389,'Y','18','021','EC','A','','','AC','0001807215','0001807215','LA00001802203','IL','1','Grace','Ruby','','','','34','438137380','405 Gulpha Drive',0,'West Monroe','LA','71291',NULL,'CY','22073','1957-07-29','F','U',':RET:2054-5','N','021','DEN','1432435','18575LA002000101','2014-03-01','2014-01-21 13:11:06','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,1,'2014-01-22 03:22:03'),(22645,18080,'N','01','021','EC','A',NULL,NULL,'','0000121927','0000008951','','IL','1','Nguyen','Dung','','','','34','638925792','3355 BEACON VIEW CT',0,'PEARLAND','TX','77584',NULL,'CY','48039','1956-01-01','M','',NULL,'N','021','DEN','3827885','33348TX002000201','2014-03-01','2014-02-11 10:26:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:24'),(22420,17901,'N','01','021','EC','A',NULL,NULL,'','0001636345','0001746236','','IL','1','Yambra','Alicia','','','','34','436757298','6611 Center St.',0,'New Orleans','LA','70124',NULL,'CY','22071','1985-06-12','F','',':RET:2106-3','N','021','DEN','3015494','18575LA002000201','2014-03-01','2014-02-10 13:53:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-10 21:30:30'),(22103,17644,'Y','18','021','EC','A','','','AC','0001016891','0001016891','OH00001626164','IL','1','mccandless','Lawren','','','','34','167602850','524 meakin street',0,'east liverpool','OH','43920',NULL,'CY','39029','1962-10-20','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3271258','99734OH005000301','2014-03-01','2014-02-08 11:47:08','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-02-08 19:00:31'),(21610,17254,'Y','18','021','EC','A','','','AC','0000102852','0000102852','OH00002208692','IL','1','McCue','Mike','','','','34','300588072','17285 IYAMI CT',0,'STRONGSVILLE','OH','44136','4322','CY','39035','1969-03-30','M','U',':RET:2106-3','T','021','DEN','3572094','99734OH005000301','2014-03-01','2014-02-05 15:20:08','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:33'),(20888,16693,'Y','18','021','EC','A','','','AC','0000493269','0000493269','OH00001569506','IL','1','ratchford','windom','','','','34','282900618','20181 GREEN OAK DR',0,'EUCLID','OH','44117','2223','CY','39035','1980-11-25','M','U',':RET:2054-5','N','021','DEN','3321567','99734OH005000401','2014-03-01','2014-01-30 22:23:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-31 21:01:12'),(21274,17002,'N','01','021','EC','A',NULL,NULL,'','0000881661','0000242742','','IL','1','Loving','Nancy','','','','34','296547985','838 ARMSTRONG RD',0,'WOOSTER','OH','44691','9629','CY','39169','1955-06-19','F','',':RET:2106-3','N','021','HLT','2821390','52664OH152000901','2014-03-01','2014-02-03 18:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.19',NULL,0,'2014-02-03 21:01:32'),(26397,20937,'Y','18','021','EC','A','','','AC','0001167985','0001167985','OH00003337238','IL','1','Mollohan','Nicole','','','','34','293748506','3955 PEARL RD',0,'MEDINA','OH','44256','9036','CY','39103','1969-12-08','F','U',':RET:2106-3','N','021','HLT','3432996','52664OH151001305','2014-03-01','2014-02-26 14:11:32','150.00',NULL,NULL,'453.15','303.15','R-OH012','OH0','311.54','CIC',0,'2014-02-28 07:00:28'),(27607,21833,'N','19','021','EC','A',NULL,NULL,'','0001099244','0000292031','','IL','1','Sarli-Freeman','Elise','','','','34','298067574','23896 Parkwood Drive',0,'Columbia Station','OH','44028',NULL,'CY','39093','2002-04-18','F','',NULL,'N','021','DEN','3390721','99734OH005000301','2014-04-01','2014-03-05 12:10:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-05 21:00:26'),(29096,23029,'N','01','021','EC','A',NULL,NULL,'','0001176329','0000167895','','IL','1','GREGG','JAMES','','','','34','278444207','508 N CHURCH ST',0,'MCKINNEY','TX','75069','2735','CY','48085','1956-10-22','M','',NULL,'N','021','DEN','3020233','33348TX002000101','2014-04-01','2014-03-10 17:40:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-03-10 21:02:13'),(13112,10456,'Y','18','021','EC','A','','','AC','0000626734','0000626734','OH00000826994','31','1','Jacobs','Jonathan','','','','34','291868263','205 ELM ST',0,'QUINCY','MA','02169','5538','CY','39035','1987-04-08','M','U',':RET:2106-3','N','021','DEN','2168121','99734OH005000401','2014-01-01','2013-12-23 13:30:09','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:30'),(13100,10445,'Y','18','021','EC','A','','','AC','0000103887','0000103887','OH00000127751','IL','1','louis','sharon','','','','34','179441346','2169 state route 179',0,'jeromesville','OH','44840',NULL,'CY','39005','1953-08-15','F','M',':RET:2106-3','T','021','DEN','2616117','99734OH005000401','2014-01-01','2013-12-23 13:00:11','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:52:09'),(16973,13585,'Y','18','021','EC','A','','','AC','0000364201','0000364201','MS00001473894','IL','1','Guthrie','Tonia','L','','','34','587492989','5201 HIGHWAY 80 E',0,'PEARL','MS','39208','9302','CY','28121','1969-01-30','F','U',':RET:2106-3','N','021','DEN','2253135','46300MS002000201','2014-02-01','2014-01-09 10:08:38','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:20:14'),(9475,7515,'Y','18','021','EC','A','','','AC','0000066241','0000066241','OH00000493448','IL','1','barakakos','reana','','','','34','142863238','686 Main Street',0,'vermilion','OH','44089',NULL,'CY','39043','1982-09-20','F','U',':RET:2106-3','T','021','DEN','1643436','99734OH005000401','2014-01-01','2013-12-21 11:31:00','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-26 04:34:31'),(9275,7358,'N','01','021','EC','A',NULL,NULL,'','0001119925','0000035714','','IL','1','MUNDY','JAMES','','','','34','296583421','19379 BENNETT RD',0,'NORTH ROYALTON','OH','44133','5959','CY','39035','1956-01-29','M','',':RET:2106-3','N','021','DEN','13372','99734OH005000401','2014-01-01','2013-11-30 14:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:15:46'),(24604,19529,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000216158','','IL','1','Sexton','Cora','Lee','','','34','871338512','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2013-09-12','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:13:16'),(4265,3398,'Y','18','021','EC','A','','','AC','0001152170','0001152170','OH00000190887','IL','1','Griffith','Tereasa','','','','34','275763673','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1967-07-18','F','M',':RET:2106-3','N','021','HLT','2499077','92036OH003001501','2014-01-01','2013-12-16 20:37:46','431.00',NULL,NULL,'793.38','362.38','R-OH002','OH0','344.75',NULL,0,'2013-12-25 21:51:37'),(6192,4906,'Y','18','021','EC','A','','','AC','0000844554','0000844554','TX00000401296','IL','1','Churchill','Dale','','','','34','450987297','5 SPRING VALLEY CT',0,'RICHARDSON','TX','75081','4431','CY','48113','1954-06-12','M','U',':RET:2106-3','N','021','DEN','239835','33348TX002000201','2014-01-01','2013-10-23 02:41:27','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:30:21'),(7460,5903,'Y','18','021','EC','A','','','AC','0000870606','0000870606','OH00000834658','IL','1','Rodriguez','Susan','','','','34','270588746','3993 CLAGUE RD',0,'NORTH OLMSTED','OH','44070','2306','CY','39035','1954-12-25','F','M',NULL,'N','021','DEN','428398','99734OH005000301','2014-01-01','2013-12-15 16:02:28','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:30:53'),(26498,21021,'Y','18','021','EC','A','','','AC','0001064742','0001064742','OH00003243597','IL','1','PODOLL','BRETT','','','','34','188608465','5625 NICHOLSON DR',0,'HUDSON','OH','44236','3700','CY','39153','1964-09-25','M','M',NULL,'N','021','HLT','3055284','52664OH151001304','2014-03-01','2014-02-28 16:28:18','675.00',NULL,NULL,'1208.70','533.70','R-OH012','OH0','380.45','CIC',0,'2014-02-28 21:00:14'),(26635,21119,'Y','18','021','EC','A','','','AC','0001083795','0001083795','TX00003415219','IL','1','ANDERSON','ALMA','','','','34','451732117','3922 TRUMAN AVE',0,'EL PASO','TX','79930','6424','CY','48141','1972-09-26','F','U',':RET:2054-5','N','021','DEN','2881850','33348TX002000201','2014-04-01','2014-02-28 16:54:57','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:30:59'),(26903,21322,'Y','18','021','EC','A','','','AC','0000670989','0000670989','TX00002693590','IL','1','LEE','CAROLING','C','','','34','250156276','2314 DEVONSHIRE DR',0,'AUSTIN','TX','78723','2028','CY','48453','1972-09-17','F','U',':RET:2034-7','N','021','DEN','3918204','33348TX002000201','2014-04-01','2014-03-02 17:05:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-03 01:00:08'),(28374,22452,'N','19','021','EC','A',NULL,NULL,'','0000175171','0000313310','','IL','1','Werring','Rebecca','','','','34','302046014','4009 MOORE MARATHON RD',0,'WILLIAMSBURG','OH','45176','8231','CY','39025','2000-08-14','F','',':RET:2106-3','N','021','HLT','4225138','92036OH005000601','2014-04-01','2014-03-07 10:43:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-03-07 21:30:36'),(1295,1071,'Y','18','021','EC','A','','','AC','0000621390','0000621390','TX00000382154','IL','1','Navarro','Cesar','','','','34','458477811','7315 AUTUMN FLOWER',0,'CONVERSE','TX','78109','4614','CY','48029','1975-07-27','M','U',':RET:2106-3','N','021','DEN','271863','33348TX002000101','2014-01-01','2013-11-29 13:36:27','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 18:30:59'),(13692,10925,'Y','18','021','EC','A','','','AC','0000623975','0000623975','OH00001046104','IL','1','Bragg','Orval','A','','','34','291529308','885 Walls Lake Dr',0,'Vignna','OH','44473',NULL,'CY','39155','1954-08-09','M','M',':RET:2106-3','N','021','HLT','2329725','52664OH151001305','2014-01-01','2013-12-23 11:09:36','1177.00',NULL,NULL,'1501.19','324.19','R-OH013','OH0','658.29',NULL,0,'2013-12-26 13:08:29'),(13164,10500,'N','01','021','EC','A',NULL,NULL,'','0001168001','0000678096','','IL','1','Markowitz','Hallie','D','','','34','276605510','3446 OLD GREEN RD',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1957-01-27','F','',':RET:2106-3','N','021','DEN','1955347','99734OH005000401','2014-01-01','2013-12-23 18:12:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:55'),(9330,7395,'N','19','021','EC','A',NULL,NULL,'','0000683381','0000712513','','S1','1','Arkus','Alan','J','','','34','316276694','3746 White Chapel Ct.',0,'Amelia','OH','45102',NULL,'CY','39025','2004-07-10','F','',':RET:2106-3','N','021','HLT','1814248','92036OH004000601','2014-01-01','2013-12-20 18:52:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 04:30:43'),(16562,13250,'N','01','021','EC','A',NULL,NULL,'','0000001052','0001240569','','IL','1','UHRICK','ALLEN','ARTHUR','','','34','273508462','214 GLENN ST',0,'MENDON','OH','45862','9586','CY','39107','1951-03-11','M','',':RET:2106-3','T','021','HLT','1648865','92036OH001001501','2014-02-01','2014-01-05 15:39:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','877.11',NULL,1,'2014-01-07 10:23:05'),(1588,1326,'Y','18','021','EC','A','','','AC','0000853204','0000853204','TX00001554053','IL','1','MYATT','SUSAN','','','','34','461084862','2633 112TH ST',0,'LUBBOCK','TX','79423','6727','CY','48303','1953-08-12','F','R',':RET:2106-3','N','021','DEN','1940636','33348TX002000201','2014-01-01','2013-12-24 11:30:32','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:51:39'),(15970,12781,'Y','18','021','EC','A','','','AC','0000519059','0000519059','TX00001059641','IL','1','franco','lorenzo','','','','34','465434119','2718 SAN DIEGO AVE',0,'EL PASO','TX','79930','2923','CY','48141','1962-01-26','M','U',NULL,'N','021','DEN','1906375','33348TX002000201','2014-02-01','2014-01-02 19:33:53','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-04 02:00:34'),(6364,5046,'Y','18','021','EC','A','','','AC','0000799866','0000799866','OH00000583428','IL','1','MOORE','FRED','CLINTON','','','34','302507948','5991 GRAHAM RD',0,'PIERPONT','OH','44082','9746','CY','39007','1950-11-28','M','M',':RET:2106-3','N','021','DEN','300761','99734OH005000301','2014-01-01','2013-12-10 19:08:51','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:27'),(3347,2682,'Y','18','021','EC','A','','','AC','0001175974','0001175974','TX00000146636','IL','1','Altabaa','Mohamad','','','','34','271065340','1001 PONTIAC AVE',0,'LUBBOCK','TX','79416','3812','CY','48303','1973-05-26','M','M',':RET:2106-3','N','021','DEN','2534624','33348TX002000201','2014-01-01','2013-12-22 00:55:43','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2013-12-25 21:16:39'),(2168,1783,'N','01','021','EC','A',NULL,NULL,'','0000743060','0000972720','','IL','1','Shrock','Terrie','Tenk','','','34','291642642','342 LONG POINTE DR',0,'AVON LAKE','OH','44012','2424','CY','39093','1957-11-07','F','',':RET:2106-3','N','021','HLT','425913','52664OH151001501','2014-01-01','2013-12-10 16:43:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','703.78',NULL,0,'2013-12-25 19:19:05'),(21836,17438,'Y','18','021','EC','A','','','AC','0001156225','0001156225','TX00001992842','31','1','Cobos','Satiago','','','','34','450270185','PO Box 141',0,'GOLDSMITH','TX','79741',NULL,'CY','48135','1964-06-26','M','U',NULL,'N','021','DEN','2628733','33348TX002000101','2014-03-01','2014-02-06 16:52:28','0.00',NULL,NULL,'25.02','25.02','R-TX017','TX0','25.02',NULL,0,'2014-02-06 21:01:07'),(14441,11518,'Y','18','021','EC','A','','','AC','0002188688','0002188688','LA00000428270','IL','1','Wheeler','Pamela','','','','34','437864175','6220 KINGSTON CT',0,'NEW ORLEANS','LA','70131','5561','CY','22071','1951-12-15','F','U',':RET:2054-5','N','021','DEN','1434682','18575LA002000201','2014-02-01','2013-12-27 11:44:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:11'),(21121,16876,'Y','18','021','EC','A','','','AC','0000307850','0000307850','TX00001404954','IL','1','Lee','James','','','','34','458960270','1043 NW 36TH ST',0,'SAN ANTONIO','TX','78228','5939','CY','48029','1951-08-25','M','U',':RET:2106-3','N','021','DEN','3704038','33348TX002000201','2014-03-01','2014-02-03 12:21:38','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-03 21:00:13'),(20009,15958,'Y','18','021','EC','A','','','AC','0001025529','0001025529','OH00001673687','IL','1','Hake','Sharon','','','','34','287509845','4141 Crawfordsville Campbellstown Rd',0,'Eaton','OH','45320',NULL,'CY','39135','1953-03-05','F','U',':RET:2106-3','N','021','DEN','1810257','99734OH005000401','2014-03-01','2014-01-26 16:25:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-26 19:00:08'),(14188,11313,'Y','18','021','EC','A','','','AC','0000908795','0000908795','TX00000684098','IL','1','Forester','Angla','','','','34','443867895','2350 fm 1860',0,'benwheeler','TX','75754',NULL,'CY','48467','1981-08-15','F','U',':RET:2106-3','N','021','DEN','1776688','33348TX002000201','2014-02-01','2013-12-26 12:12:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:56'),(19417,15480,'Y','18','021','EC','A','','','AC','0000928531','0000928531','OH00002129733','31','1','EVANS','WINNIE','','','','34','344460800','P.O. BOX 411',0,'SOUTH CHARLESTON','OH','43568',NULL,'CY','39023','1952-05-26','F','M',NULL,'N','021','HLT','2108631','92036OH004000501','2014-03-01','2014-01-21 13:20:24','260.00',NULL,NULL,'537.11','277.11','R-OH003','OH0','537.11',NULL,1,'2014-01-22 03:23:01'),(23796,18935,'N','01','021','EC','A',NULL,NULL,'','0000983887','0001151118','','IL','1','Metz','Mark','A','','','34','296702086','3891 VALLEY DR',0,'NORTON','OH','44203','5544','CY','39153','1970-01-30','M','',':RET:1002-5','N','021','HLT','3013434','52664OH151001304','2014-03-01','2014-02-14 12:17:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-02-14 21:31:27'),(13008,10367,'Y','18','021','EC','A','','','AC','0001231748','0001231748','OH00001005979','IL','1','Crutcher','Carrie','','','','34','291783160','6266 CORBLY RD',0,'CINCINNATI','OH','45230','1543','CY','39061','1981-12-15','F','U',':RET:2106-3','N','021','DEN','1421230','99734OH005000401','2014-01-01','2013-12-22 19:38:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:49:43'),(2349,1914,'Y','18','021','EC','A','','','AC','0000307581','0000307581','TX00000352936','IL','1','stewart','gwendolyn','','','','34','449137480','205 BONITA ST',0,'LUFKIN','TX','75904','1211','CY','48005','1957-11-17','F','U',':RET:2054-5','T','021','DEN','543555','33348TX002000201','2014-01-01','2013-12-09 16:32:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:32:10'),(15731,12583,'Y','18','021','EC','A','','','AC','0000637122','0000637122','OH00001451141','IL','1','Sommer','Michele','Irene','','','34','275524795','7222 Creekview Drive',0,'Cincinnati','OH','45247',NULL,'CY','39061','1952-03-23','F','U',':RET:2106-3','N','021','DEN','1597677','99734OH005000301','2014-02-01','2014-01-02 09:43:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:00:31'),(15481,12385,'Y','18','024','14','A','','','TE','0000384399','0000384399','','IL','1','Saviano','Joeseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-20','M','',NULL,NULL,NULL,'','2545075','','2013-12-31','2013-12-31 05:13:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:09'),(3524,2830,'N','01','021','EC','A',NULL,NULL,'','0001014719','0001134479','','IL','1','Dearman','Peggy','','','','34','427060368','4114 SHELTON ST',0,'PEARL','MS','39208','4137','CY','28121','1957-07-29','F','',':RET:2106-3','N','021','DEN','2002748','46300MS002000101','2014-01-01','2013-12-22 13:05:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 21:21:19'),(3643,2915,'Y','18','021','EC','A','','','AC','0000003562','0000003562','OH00000007391','IL','1','mangold','kenton','','','','34','299742869','9065 PRINCESS RD',0,'LAKEVIEW','OH','43331','9737','CY','39091','1964-12-25','M','U',NULL,'N','021','DEN','198081','99734OH005000401','2014-01-01','2013-12-13 17:24:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:30:25'),(26213,20789,'Y','18','021','EC','A','','','AC','0000093901','0000093901','OH00003436414','IL','1','Willson','Laura','','','','34','270501918','2419 VALLEY RD',0,'CUYAHOGA FALLS','OH','44223','1633','CY','39153','1949-08-05','F','U',':RET:2106-3','N','021','HLT','2945716','52664OH151001305','2014-05-01','2014-02-27 15:06:18','516.00',NULL,NULL,'669.00','153.00','R-OH012','OH0','669.00',NULL,0,'2014-02-28 06:30:54'),(27604,21832,'Y','18','021','EC','A','','','AC','0001218534','0001218534','OH00002942905','IL','1','JOHNSON','KATHI','R','','','34','278605483','530 NORTHFIELD RD',0,'BEDFORD','OH','44146','2304','CY','39035','1958-07-14','F','U',':RET:2054-5','N','021','DEN','3867784','99734OH005000301','2014-04-01','2014-03-05 09:24:53','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00','CIC',0,'2014-03-05 21:00:25'),(27474,21742,'Y','18','021','EC','A','','','AC','0000237646','0000237646','OH00003309647','IL','1','Choe','Myong','','','','34','298829629','8586 W STATE ROUTE 163',0,'OAK HARBOR','OH','43449','8815','CY','39123','1960-09-09','M','M',':RET:2040-4','T','021','HLT','3693657','92036OH003002705','2014-04-01','2014-03-03 21:46:35','744.00',NULL,NULL,'989.93','245.93','R-OH006','OH0','477.73',NULL,0,'2014-03-04 21:02:13'),(25139,19942,'Y','18','021','EC','A','','','AC','0000006426','0000006426','TX00003026340','IL','1','Griffin','Lizzie','','','','34','456179053','2500 North Eastman Road',0,'Longview','TX','75605',NULL,'CY','48183','1954-05-24','F','U',':RET:2054-5','N','021','DEN','3809847','33348TX002000201','2014-04-01','2014-02-21 10:46:03','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-21 22:00:09'),(18177,14513,'Y','18','021','EC','A','','','AC','0000221319','0000221319','OH00002461114','IL','1','Trimble','Thelma','B','','','34','273505604','6981 E US HIGHWAY 224',0,'BLOOMVILLE','OH','44818','9422','CY','39147','1953-03-03','F','M',':RET:2106-3','N','021','HLT','1920265','92036OH004002701','2014-02-01','2014-01-14 10:12:24','329.00',NULL,NULL,'425.53','96.53','R-OH006','OH0','425.53',NULL,0,'2014-01-15 02:07:59'),(19546,15579,'N','19','021','EC','A',NULL,NULL,'','0000412084','0000303984','','IL','1','HOUSTON','ROBERT','L','','','34','427731868','21 COUNTY ROAD 2067',0,'OXFORD','MS','38655','5878','CY','28071','1992-02-19','M','',':RET:2054-5','N','021','DEN','2387110','46300MS002000101','2014-03-01','2014-01-22 09:39:18',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-23 03:02:27'),(14657,11699,'Y','18','024','14','A','','','TE','0000167518','0000167518','','IL','1','GREEN','STACY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-31','F','',NULL,NULL,NULL,'','2592067','','2013-12-27','2013-12-27 21:04:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:07:53'),(27571,21805,'Y','18','021','EC','A','','','AC','0000948484','0000948484','OH00002960438','IL','1','Winkelman','Michael','','','','34','570929206','543 Conneaut Ave.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1969-01-16','M','U',':RET:2106-3','N','021','HLT','4007426','92036OH006002601','2014-04-01','2014-03-04 11:18:31','200.00',NULL,NULL,'223.31','23.31','R-OH001','OH0','223.31','CIC',0,'2014-03-04 21:30:20'),(26473,20998,'N','19','021','EC','A',NULL,NULL,'','0001934491','0002247647','','IL','1','Mitchell','Chantal','','','','34','435776454','313 Belinda',0,'Gramercy','LA','70052',NULL,'CY','22093','1989-08-01','F','',NULL,'N','021','DEN','2724786','18575LA002000101','2014-04-01','2014-02-27 15:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02','CIC',0,'2014-02-28 07:30:38'),(22161,17687,'N','19','021','EC','A',NULL,NULL,'','0001246982','0000837735','','IL','1','Hartwig','Isabella','A','','','34','276152344','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','2009-02-20','F','',':RET:2106-3','N','021','HLT','3385475','92036OH005001201','2014-03-01','2014-02-08 13:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-02-08 19:00:58'),(20989,16774,'N','19','021','EC','A',NULL,NULL,'','0000609559','0000305871','','IL','1','Al-Shinnawi','Yasmeen','S','','','34','279117062','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','2005-04-26','F','',':RET:2106-3','N','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:24'),(627,518,'Y','18','021','EC','A','','','AC','0000371472','0000371472','OH00000009793','IL','1','Sekerak','Peter','M','','Sr','34','270589153','4424 KENMORE AVE',0,'PARMA','OH','44134','2444','CY','39035','1956-06-07','M','M',':RET:2106-3','N','021','DEN','2056317','99734OH005000401','2014-01-01','2013-12-16 12:40:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:01:01'),(9174,7276,'N','01','021','EC','A',NULL,NULL,'','0000854181','0000672745','','IL','1','McGrath','Shannon','','','','34','622035066','5486 S GARRETT DR',0,'MILFORD','OH','45150','2841','CY','39025','1982-08-06','F','',':RET:2106-3','T','021','HLT','1389997','92036OH005000601','2014-01-01','2013-12-18 11:27:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','286.13',NULL,0,'2013-12-26 04:09:01'),(1044,856,'N','01','021','EC','A',NULL,NULL,'','0000479622','0000423652','','IL','1','PETERS','LOUANNA','','','','34','456784499','734 LAKE DAM ROAD',0,'BLACKWELL','TX','79506',NULL,'CY','48081','1949-04-18','F','',':RET:2106-3','N','021','DEN','123100','33348TX002000201','2014-01-01','2013-12-03 14:25:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:15:51'),(9216,7311,'Y','18','021','EC','A','','','AC','0000718904','0000718904','OH00000944714','IL','1','Henderer','Jessica','','','','34','279927665','7510 ROSEWOOD DR',0,'BLANCHESTER','OH','45107','1520','CY','39027','1990-04-02','F','U',':RET:2106-3','N','021','HLT','2153728','92036OH001000601','2014-01-01','2013-12-18 13:14:27','136.00',NULL,NULL,'258.94','122.94','R-OH005','OH0','258.94',NULL,0,'2013-12-26 04:10:03'),(26746,21195,'N','01','021','EC','A',NULL,NULL,'','0000992728','0000003631','','IL','1','Supe','Lauren','','','','34','298909651','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','1985-05-03','F','',':RET:2106-3','N','021','HLT','3540690','92036OH003001205','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','243.69',NULL,0,'2014-02-28 21:31:56'),(26438,20970,'Y','18','024','14','A','','','TE','0000050735','0000050735','','IL','1','Clein','Thomas','Richard',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-14','M','',NULL,NULL,NULL,'','2954285','','2014-02-27','2014-02-27 14:03:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 07:30:19'),(25074,19884,'N','01','021','EC','A',NULL,NULL,'','0000290854','0000421517','','IL','1','MCDUNNELL','ERIC','H','','Sr','34','350708067','204 W SUGAR ST',0,'CRIDERSVILLE','OH','45806','2346','CY','39011','1967-03-29','M','',NULL,'N','021','HLT','3320838','92036OH005001506','2014-04-01','2014-02-20 10:59:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','344.00',NULL,0,'2014-02-20 22:01:32'),(3653,2923,'N','01','021','EC','A',NULL,NULL,'','0001106771','0000217564','','IL','1','SPRADLING','PATRICIA','ANN','','','34','292466789','4116 WILLIAMSON DR',0,'DAYTON','OH','45416','2146','CY','39113','1951-12-16','F','',':RET:2106-3','N','021','DEN','116837','99734OH005000401','2014-01-01','2013-12-12 18:55:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:41'),(17679,14128,'Y','18','021','EC','A','','','AC','0002265225','0002265225','LA00001940397','IL','1','Toney','Gloria','','','','34','436171120','1838 Spyker Drive',0,'Monroe','LA','71202',NULL,'CY','22073','1956-09-23','F','U',':RET:2054-5','N','021','DEN','2218614','18575LA002000101','2014-02-01','2014-01-13 15:05:00','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-14 01:32:53'),(24684,19593,'Y','18','021','EC','A','','','AC','0001039350','0001039350','TX00002373939','IL','1','Musharbash','Basel','Jalal','','','34','641988141','2470 RIDGEVIEW RD',0,'PARIS','TX','75460','3204','CY','48277','1992-07-08','M','U',':RET:2028-9','N','021','DEN','3200339','33348TX002000101','2014-04-01','2014-02-19 00:10:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:31:01'),(23975,19061,'Y','18','024','14','A','','','TE','0001594364','0001594364','','IL','1','Gulbengay','Erin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-02','F','',NULL,NULL,NULL,'','3213000','','2014-02-15','2014-02-15 09:28:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-15 22:00:17'),(23278,18557,'Y','18','021','EC','A','','','AC','0001387258','0001387258','LA00001919899','IL','1','Torres','Cleona','','','','34','433772626','3301 BANKS ST',0,'NEW ORLEANS','LA','70119','7109','CY','22071','1984-05-15','F','M',':RET:2106-3','N','021','DEN','3217802','18575LA002000201','2014-03-01','2014-02-13 12:03:43','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61','CIC',0,'2014-02-13 21:30:15'),(22213,17730,'Y','18','021','EC','A','','','AC','0002124894','0002124894','LA00001591895','IL','1','BURGESS','RENATE','','','','34','082604492','3741 RED CYPRESS DR',0,'NEW ORLEANS','LA','70131','8317','CY','22071','1962-11-17','F','U',':RET:2054-5','N','021','DEN','3620490','18575LA002000201','2014-03-01','2014-02-08 21:33:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-09 19:00:21'),(19065,15187,'Y','18','024','14','A','','','TE','0000023490','0000023490','','IL','1','sandoval ore','maria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-06-30','F','',NULL,NULL,NULL,'','457913','','2014-01-18','2014-01-18 14:18:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:44:17'),(21160,16909,'Y','18','021','EC','A','','','AC','0001068299','0001068299','OH00002125954','IL','1','HARDIN','DEANNA','','','','34','302863159','763 WESTMONT DRIVE',0,'CINCINNATI','OH','45205',NULL,'CY','39061','1987-11-19','F','U',':RET:2054-5','T','021','DEN','2987556','99734OH005000401','2014-03-01','2014-02-03 09:23:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:32'),(16666,13337,'Y','18','021','EC','A','','','AC','0001066996','0001066996','OH00001835452','IL','1','ROBY','MARY','V','','','34','549313960','214 EAST OHIO ST',0,'KENTON','OH','43326',NULL,'CY','39065','1959-09-19','F','M',NULL,'N','021','DEN','1590958','99734OH005000301','2014-02-01','2014-01-06 18:35:39','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-08 18:24:26'),(26555,21054,'N','19','021','EC','A',NULL,NULL,'','0001030419','0001059530','','IL','1','Supe','Kylie','','','','34','727815163','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2011-07-21','F','',':RET:2106-3','N','021','DEN','2969530','99734OH005000301','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:17'),(1129,929,'Y','18','021','EC','A','','','AC','0000036827','0000036827','TX00001042721','IL','1','Cardoma','Yanet','','','','34','639266782','902 PALOMA DR',0,'SAN JUAN','TX','78589','3841','CY','48215','1988-03-04','F','M',NULL,'N','021','DEN','996422','33348TX002000101','2014-01-01','2013-12-02 23:16:34','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-25 18:18:00'),(21589,17244,'Y','18','021','EC','A','','','AC','0000711410','0000711410','OH00001708256','IL','1','Jaye','Leisa','','','','34','296864807','1293 AUBURN AVE',0,'BARBERTON','OH','44203','7439','CY','39153','1973-01-08','F','U',':RET:2106-3','N','021','DEN','2828151','99734OH005000301','2014-03-01','2014-02-04 20:09:48','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-05 21:30:28'),(22008,17570,'Y','18','021','EC','A','','','AC','0000844737','0000844737','OH00002508571','IL','1','Moroski','Michael','','','','34','260311393','400 Pike St',0,'Cincinnati','OH','45202',NULL,'CY','39061','1978-06-10','M','R',':RET:2106-3','T','021','DEN','2997355','99734OH005000301','2014-03-01','2014-02-07 07:39:04','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-07 19:00:49'),(16816,13450,'N','01','021','EC','A',NULL,NULL,'','0001086035','0000265624','','IL','1','PERRY','MARGARET','','','','34','587229382','1896 N FRONTAGE RD',0,'CLINTON','MS','39056','6233','CY','28049','1955-08-20','F','',NULL,'N','021','DEN','1738110','46300MS002000201','2014-02-01','2014-01-11 11:56:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 02:18:19'),(27158,21503,'Y','18','021','EC','A','','','AC','0001179680','0001179680','OH00003623326','IL','1','Cooper','Betty','Fay','','','34','403804852','7251 BETHLEHEM RD',0,'WINCHESTER','OH','45697','9416','CY','39001','1952-12-14','F','U',':RET:2106-3','N','021','DEN','3966900','99734OH005000401','2014-04-01','2014-03-03 16:50:52','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-03 21:30:57'),(16084,12881,'Y','18','021','EC','A','','','AC','0000465934','0000465934','OH00000830202','IL','1','Forcier','Jennifer','','','','34','295821325','3962 CANTERBURY DR',0,'BRUNSWICK','OH','44212','2606','CY','39103','1985-01-27','F','R',':RET:2106-3','N','021','DEN','1521126','99734OH005000401','2014-02-01','2014-01-03 16:29:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-04 02:04:13'),(16004,12809,'Y','18','024','14','A','','','TE','0000431816','0000431816','','IL','1','Molina','Diana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-07-25','F','',NULL,NULL,NULL,'','1865916','','2014-01-03','2014-01-03 16:06:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-04 02:01:36'),(1769,1460,'Y','18','021','EC','A','','','AC','0001192675','0001192675','OH00000749440','IL','1','Jellison','David','','','','34','280828416','150 Filly Lane',0,'Northfield','OH','44067',NULL,'CY','39153','1969-05-07','M','M',':RET:2106-3','N','021','DEN','1856328','99734OH005000301','2014-01-01','2013-12-24 14:21:41','0.00',NULL,NULL,'87.78','87.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:56:05'),(1069,875,'Y','18','021','EC','A','','','AC','0000063680','0000063680','OH00000027530','31','1','Hilf','Jane','','','','34','270520174','2289 COLUMBUS RD',0,'CLEVELAND','OH','44113','4230','CY','39035','1950-03-23','F','U',':RET:2106-3','N','021','DEN','1094102','99734OH005000401','2014-01-01','2013-12-03 07:01:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:28'),(15420,12335,'N','01','021','EC','A',NULL,NULL,'','0000852066','0000860735','','IL','1','LOTT','MICHAEL','','','','34','462818617','502 ELM RIDGE RD',0,'FREDERICKSBURG','TX','78624','5891','CY','48171','1972-05-05','M','',NULL,'N','021','DEN','2284798','33348TX002000201','2014-02-01','2013-12-31 11:25:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-02 04:27:26'),(17283,13821,'Y','18','021','EC','A','','','AC','0000442044','0000442044','TX00002485458','IL','1','Malesky','Anna','','','','34','290823621','208 MEADOWCREEK DR',0,'DESOTO','TX','75115','5730','CY','48113','1984-07-26','F','U',':RET:2106-3','N','021','DEN','2301189','33348TX002000201','2014-02-01','2014-01-09 18:18:34','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:23:26'),(27872,22047,'Y','18','021','EC','A','','','AC','0000503011','0000503011','MS00003387109','IL','1','SEALE','DIANNA','','','','34','359467831','653 HURRICANE CIR',0,'PASS CHRISTIAN','MS','39571','4045','CY','28047','1951-11-26','F','U',':RET:2106-3','N','021','DEN','2882005','46300MS002000101','2014-04-01','2014-03-05 11:20:56','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-03-05 21:32:26'),(15182,12132,'Y','18','024','14','A','','','TE','0000784343','0000784343','','IL','1','Blair','Rhonda','Allen',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-02-12','F','',NULL,NULL,NULL,'','569012','','2013-12-30','2013-12-30 18:02:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:06:51'),(23523,18739,'Y','18','021','EC','A','','','AC','0001553066','0001553066','LA00002466685','IL','1','Coulter','Justin','','','','34','274928148','1002 Third street',0,'New Orleans','LA','70130',NULL,'CY','22071','1990-03-07','M','R',':RET:2054-5^:RET:2106-3','N','021','DEN','3001399','18575LA002000201','2014-03-01','2014-02-13 03:38:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-13 22:02:21'),(7524,5955,'Y','18','021','EC','A','','','AC','0000063696','0000063696','OH00000561753','IL','1','Jarvis','Colin','','','','34','298842118','3925 Turnbridge Ct',0,'Brunswick','OH','44212',NULL,'CY','39103','1984-05-22','M','U',NULL,'T','021','HLT','1028255','52664OH152001001','2014-01-01','2013-12-14 20:18:44','0.00',NULL,NULL,'157.78','157.78','R-OH012','OH0','157.78',NULL,0,'2013-12-26 02:32:30'),(19872,15851,'Y','18','021','EC','A','','','AC','0000524521','0000524521','OH00001642966','IL','1','Ledford','Samantha','','','','34','272987714','5200 BARKWILL AVE',0,'CLEVELAND','OH','44127','1523','CY','39035','1993-12-21','F','U',':RET:2106-3','N','021','DEN','2750321','99734OH005000401','2014-03-01','2014-01-24 13:17:50','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','15.78',NULL,0,'2014-01-24 21:00:41'),(17581,14056,'N','19','021','EC','A',NULL,NULL,'','0000050708','0001235201','','S1','1','Hindel','Scott','','','','34','876228983','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','2011-12-16','M','',':RET:2106-3','N','021','DEN','1970276','99734OH005000401','2014-02-01','2014-01-13 15:04:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:06'),(22392,17880,'Y','18','021','EC','A','','','AC','0001181063','0001181063','OH00001552248','IL','1','TEMPLE','ALLAN','','','','34','285882299','1843 SEDRO ST',0,'CUYAHOGA FALLS','OH','44221','5242','CY','39153','1980-03-27','M','M',':RET:2106-3','N','021','HLT','3661657','52664OH151001305','2014-03-01','2014-02-10 13:32:25','234.00',NULL,NULL,'516.71','282.71','R-OH012','OH0','267.16',NULL,0,'2014-02-10 21:30:16'),(28648,22669,'N','19','021','EC','A',NULL,NULL,'','0000218017','0000491473','','IL','1','Church','Gregory','','','','34','427632487','953 ARBOR VISTA BLVD',0,'JACKSON','MS','39209','7133','CY','28049','1988-05-23','M','',':RET:2054-5','N','021','DEN','3530033','46300MS002000101','2014-04-01','2014-03-07 22:16:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-03-08 21:30:36'),(13415,10703,'Y','18','021','EC','A','','','AC','0000888171','0000888171','OH00000269092','IL','1','ANGERSTIEN','DENISE','','','','34','292601297','3219 TURTLE BAY CIR',0,'UNIONTOWN','OH','44685','7567','CY','39153','1977-05-30','F','U',':RET:2106-3','N','021','DEN','1533078','99734OH005000301','2014-01-01','2013-12-23 10:46:17','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 13:00:39'),(25129,19933,'Y','18','021','EC','A','','','AC','0000273783','0000273783','OH00002912799','IL','1','Masters','Kathleen','','','','34','274568745','718 BARTLEY PL',0,'TOLEDO','OH','43609','3107','CY','39095','1954-08-04','F','R',':RET:2106-3','N','021','HLT','2777904','92036OH003002601','2014-04-01','2014-02-21 13:01:11','0.00',NULL,NULL,'530.07','530.07','R-OH001','OH0','530.07','CIC',0,'2014-02-21 21:30:25'),(24263,19268,'Y','18','024','14','A','','','TE','0001027054','0001027054','','IL','1','Campos','Johnny',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-09-03','M','',NULL,NULL,NULL,'','3340872','','2014-02-17','2014-02-17 12:35:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-17 19:00:12'),(23769,18915,'Y','18','021','EC','A','','','AC','0001070521','0001070521','OH00002526050','IL','1','Record','Nancy','Corwin','','','34','285561628','6214 Robison Road',0,'Cincinnati','OH','45213',NULL,'CY','39061','1955-06-03','F','M',':RET:2106-3','N','021','DEN','3685676','99734OH005000301','2014-03-01','2014-02-14 17:10:19','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:31:13'),(3038,2442,'N','01','021','EC','A',NULL,NULL,'','0000249094','0000201903','','IL','1','Kelps','Susan','','','','34','295501796','3108 RATHBURN DR',0,'MEDINA','OH','44256','6451','CY','39103','1953-07-05','F','',':RET:2106-3','N','021','HLT','699546','52664OH152000901','2014-01-01','2013-12-06 18:09:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','443.31',NULL,0,'2013-12-25 20:18:35'),(19564,15596,'Y','18','021','EC','A','','','AC','0001716324','0001716324','LA00002392801','IL','1','WHITE','JALONNICA','CHUNTIERS','','','34','434594941','3033 PARKRIDGE STEET',0,'SHREEPORT','LA','71108',NULL,'CY','22017','1985-09-15','F','M',':RET:2054-5','N','021','DEN','2110174','18575LA002000201','2014-03-01','2014-01-22 13:28:40','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-23 03:02:34'),(18159,14502,'Y','18','021','EC','A','','','AC','0000130714','0000130714','OH00001365954','IL','1','Stapleton','Valerie','','','','34','288807874','214 W BENNETT ST',0,'WOODSTOCK','OH','43084','9712','CY','39021','1969-01-14','F','U',':RET:2106-3','N','021','HLT','2618094','92036OH003000504','2014-02-01','2014-01-13 22:31:42','197.00',NULL,NULL,'358.46','161.46','R-OH003','OH0','358.46',NULL,0,'2014-01-15 02:07:53'),(9085,7209,'Y','18','024','14','A','','','TE','0001167969','0001167969','','IL','1','Kadlub','Leonard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-25','M','',NULL,NULL,NULL,'','755740','','2013-12-18','2013-12-18 09:34:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:06:56'),(16554,13243,'Y','18','021','EC','A','','','AC','0001304627','0001304627','LA00001508748','IL','1','Hollier-Perkins','Lauren','','','','34','437908099','112 PRAIRIE VIEW DR',0,'LAFAYETTE','LA','70507','2112','CY','22055','1967-07-17','F','M',':RET:2106-3','N','021','DEN','1358823','18575LA002000201','2014-02-01','2014-01-05 15:04:41','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-07 10:22:50'),(28985,22941,'Y','18','021','EC','A','','','AC','0000639593','0000639593','OH00003012855','IL','1','ONDRAYKA','PATRICK','','','','34','268523316','1280 S AZALEA BLVD',0,'BARBERTON','OH','44203','8610','CY','39153','1953-12-14','M','U',':RET:2106-3','N','021','HLT','3610239','52664OH151001304','2014-04-01','2014-03-10 13:41:42','367.00',NULL,NULL,'605.24','238.24','R-OH012','OH0','605.24',NULL,0,'2014-03-10 21:01:11'),(28637,22663,'Y','18','021','EC','A','','','AC','0000887787','0000887787','TX00003392123','IL','1','Vasquez','Maria','Gloria','','','34','465190469','2800 Capri St.',0,'Brownsville','TX','78520',NULL,'CY','48061','1953-07-09','F','M',NULL,'N','021','DEN','3353338','33348TX002000201','2014-04-01','2014-03-08 13:36:51','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-03-08 21:30:30'),(13702,10932,'Y','18','021','EC','A','','','AC','0000166376','0000166376','OH00000202835','IL','1','Miller-Jackson','Classie','','','','34','288822945','5064 Catherine Street',0,'Maple Heights','OH','44137',NULL,'CY','39035','1969-11-24','F','M',':RET:2054-5','N','021','HLT','2216948','52664OH151001301','2014-01-01','2013-12-23 12:41:30','0.00',NULL,NULL,'351.37','351.37','R-OH011','OH0','351.37',NULL,0,'2013-12-26 13:08:42'),(6388,5065,'N','01','021','EC','A',NULL,NULL,'','0001192648','0000654572','','IL','1','Timmons','Deborah','Jane','','','34','107446959','3983 FELICE CT',0,'BEAVERCREEK','OH','45432','2073','CY','39057','1951-07-02','F','',':RET:2106-3','N','021','DEN','679660','99734OH005000301','2014-01-01','2013-12-11 11:30:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:06'),(20865,16674,'Y','18','024','14','A','','','TE','0001128010','0001128010','','IL','1','Jamison','Jessika',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-12-03','F','',NULL,NULL,NULL,'','1945838','','2014-01-31','2014-01-31 16:11:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:00:58'),(20897,16702,'Y','18','021','EC','A','','','AC','0001076595','0001076595','OH00001780959','IL','1','Morrison','Darren','','','','34','297922609','2055 NAPOLEON RD',0,'BOWLING GREEN','OH','43402','9186','CY','39173','1988-01-23','M','U',':RET:2106-3','N','021','DEN','3050876','99734OH005000401','2014-03-01','2014-01-31 12:28:27','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-31 21:01:18'),(22791,18196,'Y','18','021','EC','A','','','AC','0000247938','0000247938','OH00001569749','IL','1','Arthur','Jeffery','','','','34','293606129','118 CASTLE DR',0,'KETTERING','OH','45429','1722','CY','39113','1966-08-20','M','R',':RET:2106-3','N','021','DEN','2815543','99734OH005000301','2014-03-01','2014-02-11 12:10:29','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-02-11 21:01:49'),(23086,18405,'N','19','021','EC','A',NULL,NULL,'','0000632726','0000274834','','IL','1','Stahl','Case','','','','34','717687300','3151 Hwy 123',0,'Blanchester','OH','45107',NULL,'CY','39015','2013-08-31','M','',NULL,'N','021','DEN','2821595','99734OH005000401','2014-03-01','2014-02-12 11:27:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:05'),(24353,19342,'Y','18','021','EC','A','','','AC','0000446327','0000446327','OH00002464504','IL','1','Welch','Jeff','','','','34','282883030','3611 PARFORE CT',0,'CINCINNATI','OH','45245','3035','CY','39025','1987-07-11','M','U',':RET:2106-3','N','021','HLT','2686135','92036OH006000601','2014-04-01','2014-02-17 19:47:18','124.00',NULL,NULL,'174.33','50.33','R-OH005','OH0','174.33',NULL,0,'2014-02-18 22:00:28'),(1256,1035,'Y','18','024','14','A','','','TE','0000987353','0000987353','','IL','1','HIRSCHFELD','SHEILA','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-17','F','',NULL,NULL,NULL,'','42165','','2013-12-03','2013-12-03 11:49:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:21:23'),(9655,7650,'N','01','021','EC','A',NULL,NULL,'','0000257126','0000404793','','IL','1','Montgomery','Charles','E','','','34','274880146','301 NELSON LN',0,'BEAVERDAM','OH','45808','9719','CY','39003','1976-09-12','M','',':RET:2106-3','N','021','HLT','2019458','92036OH004001501','2014-01-01','2013-12-21 15:42:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','219.08',NULL,0,'2013-12-26 04:38:52'),(7324,5803,'Y','18','021','EC','A','','','AC','0000091481','0000091481','MS00000513143','IL','1','mcnair','richard','','','','34','425350639','111 torino drive',0,'indianola','MS','38751',NULL,'CY','28133','1976-01-01','M','U',':RET:2054-5','N','021','DEN','1257105','46300MS002000201','2014-01-01','2013-12-14 13:30:40','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 02:03:39'),(3102,2492,'Y','18','021','EC','A','','','AC','0000741692','0000741692','OH00001086213','IL','1','EVANS','EDITH','','','','34','276647813','850 W ELM ST',0,'LIMA','OH','45805','3213','CY','39003','1959-04-29','F','M',':RET:2054-5','N','021','HLT','265070','92036OH006001501','2014-01-01','2013-12-06 15:32:20','309.00',NULL,NULL,'372.65','63.65','R-OH002','OH0','372.65',NULL,0,'2013-12-25 20:20:18'),(6276,4976,'Y','18','021','EC','A','','','AC','0000907997','0000907997','OH00000019838','IL','1','Bryant','Randall','','','','34','273664824','1081 HAYWARD CIR',0,'MILFORD','OH','45150','8029','CY','39025','1964-01-11','M','U',':RET:2106-3','N','021','DEN','428239','99734OH005000401','2014-01-01','2013-12-10 19:11:03','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:45:14'),(6295,4993,'Y','18','024','14','A','','','TE','0000029011','0000029011','','IL','1','Yurcik','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-15','M','',NULL,NULL,NULL,'','720935','','2013-12-11','2013-12-11 08:31:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:45:46'),(3721,2973,'N','01','021','EC','A',NULL,NULL,'','0000341319','0001157542','','IL','1','grim','jon','e','','Sr','34','284580734','57211 spencer rd',0,'cumberland','OH','43732',NULL,'CY','39059','1955-10-04','M','',':RET:2106-3','N','021','DEN','844018','99734OH005000401','2014-01-01','2013-12-13 15:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:22'),(6761,5364,'Y','18','021','EC','A','','','AC','0001003268','0001003268','OH00001298034','IL','1','starner','jessica','','','','34','293841342','1863 13TH ST',0,'CUYAHOGA FALLS','OH','44223','2410','CY','39153','1985-11-17','F','U',':RET:2106-3','T','021','HLT','1246588','52664OH152000901','2014-01-01','2013-11-25 12:08:45','97.00',NULL,NULL,'204.18','107.18','R-OH012','OH0','204.18',NULL,0,'2013-12-26 01:16:20'),(4865,3856,'Y','18','021','EC','A','','','AC','0000589278','0000589278','OH00001160603','IL','1','Hill','Willis','','','','34','289561682','16067 LONDON RD',0,'ORIENT','OH','43146','9516','CY','39129','1956-12-20','M','U',':RET:2106-3','T','021','DEN','89116','99734OH005000301','2014-01-01','2013-11-08 10:33:09','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:30:47'),(6531,5178,'Y','18','021','EC','A','','','AC','0000543656','0000543656','TX00000557656','IL','1','Witt','Racheal','','','','34','465814668','4360 fm 933',0,'whitney','TX','76692',NULL,'CY','48217','1987-02-28','F','U',':RET:2106-3','N','021','DEN','476767','33348TX002000201','2014-01-01','2013-12-10 20:34:45','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:51:39'),(18426,14700,'Y','18','021','EC','A','','','AC','0001612813','0001612813','LA00002447462','IL','1','bell','allison','','','','34','433498238','180 hamlin st',0,'zwolle','LA','71486',NULL,'CY','22085','1976-06-23','F','U',':RET:2106-3','N','021','DEN','1869924','18575LA002000201','2014-02-01','2014-01-15 01:07:54','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-16 08:45:55'),(27799,21988,'Y','18','021','EC','A','','','AC','0000063764','0000063764','OH00002935144','IL','1','Osborne','Kevin','','','','34','281704322','646 North Medina Line road',0,'Medina','OH','44256',NULL,'CY','39103','1972-11-24','M','R',':RET:2106-3','N','021','HLT','3539721','52664OH151001301','2014-04-01','2014-03-04 21:46:22','0.00',NULL,NULL,'290.36','290.36','R-OH012','OH0','290.36',NULL,0,'2014-03-05 21:31:45'),(28217,22326,'N','01','021','EC','A',NULL,NULL,'','0000477434','0000954278','','IL','1','Smith','Chandra','','','','34','382747762','2484 LITTLE DRY RUN RD',0,'CINCINNATI','OH','45244','3247','CY','39061','1962-03-17','F','',':RET:2054-5','N','021','HLT','4039106','92036OH005001201','2014-04-01','2014-03-06 13:36:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','419.03','CIC',0,'2014-03-06 21:30:16'),(8092,6407,'Y','18','021','EC','A','','','AC','0000901061','0000901061','OH00000217763','IL','1','Mulberry','Lily','','','','34','401218623','1410 Main St.',0,'Cincinnati','OH','45202',NULL,'CY','39061','1982-12-14','F','M',':RET:2106-3','N','021','HLT','2084531','92036OH002001201','2014-01-01','2013-12-20 15:38:57','0.00',NULL,NULL,'287.33','287.33','R-OH004','OH0','287.33',NULL,0,'2013-12-26 03:10:43'),(18370,14662,'Y','18','021','EC','A','','','AC','0001113164','0001113164','OH00002537468','IL','1','Wiley','Angela','','','','34','277763788','17 Falcon Ct',0,'Hebron','OH','43025',NULL,'CY','39089','1963-12-15','F','M',':RET:2106-3','T','021','DEN','1798831','99734OH005000301','2014-02-01','2014-01-15 12:23:33','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:29'),(2234,1837,'N','19','021','EC','A',NULL,NULL,'','0000009819','0000358303','','IL','1','Clark','Avenell','','','','34','109026958','324 Wentworth Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','2011-09-09','F','',NULL,'N','021','HLT','584104','92036OH005001201','2014-01-01','2013-12-10 16:24:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 19:20:52'),(16922,13542,'Y','18','021','EC','A','','','AC','0001371324','0001371324','LA00002452213','IL','1','Herbert','Gregory','','','Jr','34','437952872','747 LASALLE DR',0,'LA Place','LA','70068',NULL,'CY','22095','1988-10-28','M','U',':RET:2106-3','T','021','DEN','1588360','18575LA002000201','2014-02-01','2014-01-08 18:36:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:44'),(16698,13363,'Y','18','021','EC','A','','','AC','0000420231','0000420231','TX00001645008','31','1','DE LEON','SARAH','','','','34','634296040','P.O BOX 151',0,'WESLACO','TX','78599',NULL,'CY','48215','1987-11-08','F','M',NULL,'N','021','DEN','1612254','33348TX002000201','2014-02-01','2014-01-07 14:38:20','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-08 18:24:37'),(4340,3447,'N','01','021','EC','A',NULL,NULL,'','0000048176','0000327266','','IL','1','Sexton','Thomas','Lee','','','34','300502973','4900 CALEB HILL RD',0,'HILLSBORO','OH','45133','8725','CY','39071','1951-08-26','M','',':RET:2106-3','T','021','HLT','2042893','92036OH003000605','2014-01-01','2013-12-17 12:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','740.68',NULL,0,'2013-12-25 21:53:15'),(7431,5881,'Y','18','024','14','A','','','TE','0000356029','0000356029','','IL','1','Deiters','Helen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-18','F','',NULL,NULL,NULL,'','806151','','2013-12-14','2013-12-14 19:15:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:30:10'),(15692,12554,'Y','18','021','EC','A','','','AC','0000156943','0000156943','OH00001053394','IL','1','Rogacki','Dora','','','','34','285725798','1914 AYERS RD',0,'MILLBURY','OH','43447','9604','CY','39173','1960-12-28','F','M',':RET:2106-3','N','021','HLT','2156682','92036OH002002601','2014-02-01','2013-12-31 12:16:00','509.00',NULL,NULL,'1162.20','653.20','R-OH001','OH0','459.38',NULL,1,'2014-01-02 04:35:24'),(5456,4334,'N','01','021','EC','A',NULL,NULL,'','0000404788','0000841911','','IL','1','Dussel','Michael','','','Sr','34','271540860','1109 OLD FORGE RD',0,'KENT','OH','44240','7403','CY','39133','1955-07-10','M','',':RET:2106-3','T','021','HLT','1853381','52664OH151001501','2014-01-01','2013-12-19 08:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','783.73',NULL,0,'2013-12-25 23:10:18'),(23140,18446,'Y','18','021','EC','A','','','AC','0001048030','0001048030','OH00001433016','IL','1','Alberico','Connie','','','','34','233800348','11435 FOREST MEADOWS CIR NW',0,'UNIONTOWN','OH','44685','6317','CY','39151','1949-08-26','F','U',':RET:2106-3','N','021','HLT','3254585','52664OH151001306','2014-03-01','2014-02-12 10:23:57','523.00',NULL,NULL,'669.00','146.00','R-OH015','OH0','669.00',NULL,0,'2014-02-12 21:31:36'),(26235,20807,'N','01','021','EC','A',NULL,NULL,'','0001148709','0000088694','','IL','1','Bentley','Sara','Elizabeth','','','34','529876883','1400 Eldorado Pkwy',0,'McKinney','TX','75069',NULL,'CY','48085','1983-03-07','F','',':RET:2106-3','N','021','DEN','2792736','33348TX002000201','2014-03-01','2014-02-27 01:04:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 06:31:02'),(27939,22101,'N','01','021','EC','A',NULL,NULL,'','0001033018','0000882713','','IL','1','Colligan','Jimmy','','','','34','464889533','6060 Comstock Road',0,'Beaumont','TX','77708',NULL,'CY','48245','1951-09-17','M','',NULL,'N','021','DEN','3791839','33348TX002000201','2014-04-01','2014-03-06 13:41:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:30'),(9219,7314,'Y','18','021','EC','A','','','AC','0000243720','0000243720','OH00000007565','IL','1','Maier','Alec','','','','34','296940724','3402 state route 109',0,'delta','OH','43515',NULL,'CY','39051','1992-04-28','M','R',':RET:2106-3','N','021','HLT','1778616','92036OH004002601','2014-01-01','2013-12-18 14:18:19','0.00',NULL,NULL,'156.79','156.79','R-OH001','OH0','156.79',NULL,0,'2013-12-26 04:10:08'),(18221,14542,'Y','18','021','EC','A','','','AC','0000698406','0000698406','TX00001893805','IL','1','Laurel','Judy','','','','34','462770955','7614 Laguna Del Mar Ct',0,'Laredo','TX','78041',NULL,'CY','48479','1969-03-09','F','U',NULL,'N','021','DEN','2210233','33348TX002000201','2014-02-01','2014-01-14 19:16:56','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-16 08:44:13'),(17955,14346,'Y','18','021','EC','A','','','AC','0001134320','0001134320','TX00002446134','IL','1','Frame','Gary','','','','34','312561249','7609 DAVY DR',0,'VOLENTE','TX','78641','9156','CY','48453','1950-08-25','M','U',':RET:2106-3','N','021','DEN','1382619','33348TX002000201','2014-02-01','2014-01-14 17:21:24','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:44'),(16013,12817,'Y','18','021','EC','A','','','AC','0001284858','0001284858','LA00001781489','IL','1','Mitchell','Patricia',NULL,NULL,NULL,NULL,NULL,'7516 Prairie Drive',0,'Greenwell Springs','LA','70739',NULL,'CY','22033','1973-10-06','F','M',':RET:2106-3','N','021','DEN','1636184','18575LA002000201','2014-02-01','2014-01-02 20:53:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-04 02:01:53'),(15944,12764,'Y','18','021','EC','A','','','AC','0000206634','0000206634','IN00001914393','IL','1','THARP','DEBRA','','','','34','305625983','1001 ANGELA DR',0,'LAKEVILLE','IN','45336',NULL,'CY','39149','1956-10-17','F','M',':RET:2106-3','T','021','HLT','1680233','92036OH005000506','2014-02-01','2014-01-02 17:11:35','543.00',NULL,NULL,'666.19','123.19','R-OH003','IN0','666.19',NULL,0,'2014-01-03 02:07:15'),(2829,2286,'Y','18','021','EC','A','','','AC','0000464421','0000464421','LA00001310611','IL','1','durnin','george','','','','34','439689024','61326 n military rd',0,'slidell','LA','70461',NULL,'CY','22103','1949-11-04','M','M',':RET:2106-3','N','021','DEN','796852','18575LA002000201','2014-01-01','2013-11-24 10:58:58','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:00:43'),(322,265,'Y','18','021','EC','A','','','AC','0000524453','0000524453','OH00000454267','IL','1','Kim','Kwang','','','','34','406533053','5592 WATERSIDE DR',0,'MASON','OH','45040','4512','CY','39165','1975-07-02','M','M',':RET:2040-4','N','021','HLT','299134','92036OH006001201','2014-01-01','2013-11-12 23:34:45','150.00',NULL,NULL,'420.17','270.17','R-OH004','OH0','212.14',NULL,0,'2013-12-25 17:31:23'),(5693,4517,'Y','18','021','EC','A','','','AC','0001256005','0001256005','OH00000059452','IL','1','HULBERT','DEVON','LEITH','','','34','288542578','86 MENLO PARK DR',0,'AKRON','OH','44313','6755','CY','39153','1953-10-24','F','U',':RET:2106-3','N','021','HLT','84253','52664OH151001501','2014-01-01','2013-11-26 00:28:59','0.00',NULL,NULL,'725.90','725.90','R-OH012','OH0','725.90',NULL,0,'2013-12-25 23:32:41'),(4620,3659,'Y','18','021','EC','A','','','AC','0001021388','0001021388','LA00000541355','IL','1','Malbrough','Brandon','','','','34','433474304','8900 Rosenthal Road',0,'Saint Francisville','LA','70775',NULL,'CY','22125','1980-04-08','M','U',NULL,'T','021','DEN','1233783','18575LA002000101','2014-01-01','2013-12-11 21:14:02','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 22:06:12'),(19732,15725,'Y','18','021','EC','A','','','AC','0001325099','0001325099','LA00002240476','IL','1','taylor','laonette','','','','34','434656797','113 Jason drive',0,'monroe','LA','71202',NULL,'CY','22073','1987-05-09','F','U',NULL,'N','021','DEN','3202398','18575LA002000201','2014-03-01','2014-01-23 08:35:54','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-23 21:01:06'),(23518,18735,'Y','18','021','EC','A','','','AC','0000393718','0000393718','OH00001565887','IL','1','Teague','Amanda','','','','34','270847212','418 E Chestnut St.',0,'Orrville','OH','44667',NULL,'CY','39169','1985-05-26','F','M',':RET:2106-3','N','021','HLT','2711804','52664OH151001501','2014-03-01','2014-02-12 23:27:36','0.00',NULL,NULL,'290.74','290.74','R-OH014','OH0','290.74',NULL,0,'2014-02-13 22:02:19'),(24841,19695,'Y','18','021','EC','A','','','AC','0000857169','0000857169','OH00002251057','IL','1','Culpepper','Kathryn','','','','34','338766667','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-10-22','F','M',':RET:2106-3','N','021','HLT','2640425','52664OH152000901','2014-04-01','2014-02-19 09:35:44','266.00',NULL,NULL,'391.36','125.36','R-OH015','OH0','195.68',NULL,0,'2014-02-20 04:53:52'),(27548,21790,'Y','18','021','EC','A','','','AC','0000618425','0000618425','OH00003715259','IL','1','Russ','Kimberly','','','','34','284845422','561 W HIGHLAND RD',0,'SAGAMORE HILLS','OH','44067','2538','CY','39153','1985-04-04','F','U',':RET:2106-3','N','021','DEN','3786621','99734OH005000401','2014-04-01','2014-03-04 13:58:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-03-04 21:30:09'),(28534,22583,'Y','18','021','EC','A','','','AC','0000404868','0000404868','OH00002715150','31','1','BROWN','CONNIE','','','','34','284563565','45 VINCENT STREET',0,'DAYTON','OH','45405',NULL,'CY','39113','1955-11-30','F','U',NULL,'N','021','HLT','4112888','92036OH005000504','2014-04-01','2014-03-07 10:50:04','354.00',NULL,NULL,'605.66','251.66','R-OH003','OH0','605.66',NULL,0,'2014-03-07 21:32:10'),(9406,7462,'Y','18','021','EC','A','','','AC','0000572522','0000572522','TX00001252218','IL','1','handal','brian','','','','34','333728386','917 Main St',0,'Houston','TX','77002',NULL,'CY','48201','1967-08-23','M','U',NULL,'N','021','DEN','2119579','33348TX002000201','2014-01-01','2013-12-21 10:59:44','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:32:44'),(7759,6146,'Y','18','021','EC','A','','','AC','0001221933','0001221933','OH00000966308','IL','1','WHITE','BENJAMIN','','','','34','291845122','8675 PIPEWELL LN',0,'CINCINNATI','OH','45243','1126','CY','39061','1985-07-24','M','U',':RET:2106-3','N','021','DEN','1858541','99734OH005000401','2014-01-01','2013-12-20 17:26:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:02:42'),(1292,1068,'N','01','021','EC','A',NULL,NULL,'','0000418863','0001083056','','IL','1','HENRY','ANITA','','','','34','307662018','84 RAVENNA ST',0,'HUDSON','OH','44236','3064','CY','39153','1956-04-21','F','',':RET:2106-3','T','021','DEN','1098011','99734OH005000301','2014-01-01','2013-11-29 15:09:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:30:54'),(7000,5556,'Y','18','021','EC','A','','','AC','0000876747','0000876747','TX00000355199','IL','1','CHUKWU','VERONICA','','','','34','463458065','1111 ABRAMS RD',0,'RICHARDSON','TX','75081','5593','CY','48113','1963-05-16','F','U',':RET:2054-5','N','021','DEN','2177049','33348TX002000201','2014-01-01','2013-12-24 18:59:34','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:48:15'),(17696,14141,'Y','18','021','EC','A','','','AC','0001641067','0001641067','LA00001519197','IL','1','Watson','Kerry','','','','34','434900569','309 DeArmas',0,'New Orleans','LA','70114',NULL,'CY','22071','1957-01-25','M','R',':RET:2054-5','N','021','DEN','1502625','18575LA002000201','2014-02-01','2014-01-13 12:35:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:01'),(1774,1462,'Y','18','021','EC','A','','','AC','0001045690','0001045690','OH00001400369','IL','1','Jackson','Michael','','','','34','283740589','142 Middle Ave',0,'Elyria','OH','44035',NULL,'CY','39093','1979-02-21','M','U',':RET:2054-5','N','021','DEN','2616248','99734OH005000301','2014-01-01','2013-12-24 14:30:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:56:12'),(2038,1668,'Y','18','021','EC','A','','','AC','0000282700','0000282700','TX00001173154','IL','1','STOKES','TEAUNNA','J','','','34','338829609','3218 PAGE RD',0,'LONGVIEW','TX','75605','6200','CY','48203','1988-11-27','F','U',':RET:2054-5','N','021','DEN','339606','33348TX002000201','2014-01-01','2013-12-09 21:47:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:15:30'),(6114,4848,'Y','18','021','EC','A','','','AC','0000419988','0000419988','OH00000205907','IL','1','Fraser','Debra','','','','34','264399892','1350 GHENT HILLS RD',0,'AKRON','OH','44333','2146','CY','39153','1965-09-13','F','U',':RET:2106-3','N','021','HLT','891317','52664OH151001301','2014-01-01','2013-11-21 09:43:52','0.00',NULL,NULL,'364.62','364.62','R-OH012','OH0','364.62',NULL,0,'2013-12-26 00:15:33'),(20777,16600,'Y','18','021','EC','A','','','AC','0001200351','0001200351','TX00001479368','IL','1','Aguilar','Cynthia','','','','34','450619230','5649 WALDORF DR',0,'EL PASO','TX','79924','3435','CY','48141','1973-05-01','F','M',':RET:2106-3','N','021','DEN','3404349','33348TX002000201','2014-03-01','2014-01-30 18:57:46','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-31 21:00:07'),(24971,19804,'Y','18','021','EC','A','','','AC','0001056475','0001056475','TX00002599893','IL','1','schulze','kim','','','','34','460572919','211 oscar st',0,'El campo','TX','77437',NULL,'CY','48481','1978-11-19','F','U',':RET:2106-3','N','021','DEN','3533070','33348TX002000201','2014-04-01','2014-02-19 20:52:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 22:00:26'),(4189,3333,'Y','18','021','EC','A','','','AC','0000310844','0000310844','OH00000663095','IL','1','Vaidhyanath','Sainath','','','','34','301068063','1300 BRIMFIELD DR',0,'KENT','OH','44240','6949','CY','39133','1979-09-12','M','M',':RET:2029-7','N','021','HLT','2086773','52664OH151001306','2014-01-01','2013-12-17 14:34:09','393.00',NULL,NULL,'499.09','106.09','R-OH012','OH0','270.73',NULL,0,'2013-12-25 21:49:36'),(4541,3598,'Y','18','021','EC','A','','','AC','0000990882','0000990882','TX00001072302','IL','1','RULLAN','MARIO','','','','34','466491510','3902 AIDIN ST',0,'LAREDO','TX','78045','3403','CY','48479','1964-04-01','M','U',':RET:2106-3','N','021','DEN','1035800','33348TX002000201','2014-01-01','2013-12-12 17:28:43','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 22:04:17'),(4003,3197,'Y','18','021','EC','A','','','AC','0000714957','0000714957','OH00000762236','IL','1','Ginn','Barbara','','','','34','338487968','981 GLASGOW DR',0,'CINCINNATI','OH','45240','2349','CY','39061','1951-09-19','F','U',':RET:2106-3','N','021','DEN','2252250','99734OH005000401','2014-01-01','2013-12-16 20:19:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:14'),(2409,1967,'Y','18','021','EC','A','','','AC','0000667753','0000667753','OH00000246864','IL','1','Elkins','Paula','','','','34','272642676','2843 double eagle dr.',0,'beavercreek','OH','45431',NULL,'CY','39057','1958-05-23','F','M',':RET:2106-3','N','021','DEN','1243416','99734OH005000401','2014-01-01','2013-12-09 15:06:22','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:33:42'),(19640,15653,'Y','18','021','EC','A','','','AC','0000700412','0000700412','OH00001565470','IL','1','Sneed','Clifton','','','','34','423295149','2065 W. Clifton Ave.',0,'Cincinnati','OH','45219',NULL,'CY','39061','1987-08-27','M','U',NULL,'N','021','DEN','2994555','99734OH005000401','2014-03-01','2014-01-23 11:48:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 21:00:14'),(20745,16575,'Y','18','021','EC','A','','','AC','0001175741','0001175741','OH00002419142','IL','1','Laub','Samantha','','','','34','291946045','3231 SPRINGTIME DR',0,'OREGON','OH','43616','2323','CY','39095','1987-09-14','F','U',':RET:2106-3','T','021','HLT','3004712','92036OH006002601','2014-03-01','2014-01-30 10:34:04','50.00',NULL,NULL,'182.10','132.10','R-OH001','OH0','182.10',NULL,0,'2014-01-30 21:01:26'),(20884,16689,'N','01','021','EC','A',NULL,NULL,'','0000468146','0001045727','','IL','1','Shaw','Cynthia','R','','','34','275823358','525 S WEST ST',0,'HILLSBORO','OH','45133','1343','CY','39071','1975-10-01','F','',':RET:2106-3','N','021','HLT','3234142','92036OH006000601','2014-03-01','2014-01-30 21:04:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','212.14',NULL,0,'2014-01-31 21:01:10'),(21905,17493,'Y','18','021','EC','A','','','AC','0001128212','0001128212','MS00002450310','IL','1','SAUNDERS-AUSTIN','ROLINE','','','','34','345629942','6208 CASTLETON DR',0,'OLIVE BRANCH','MS','38654','9353','CY','28033','1973-07-08','F','M',':RET:2054-5','N','021','DEN','3092056','46300MS002000101','2014-03-01','2014-02-06 12:56:33','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-06 21:01:50'),(23817,18951,'Y','18','021','EC','A','','','AC','0000885590','0000885590','OH00002621151','IL','1','Dible','Robert','V','','','34','302602693','7315 N Twp Rd 63',0,'Fostoria','OH','44830','9574','CY','39147','1964-12-17','M','M',':RET:2106-3','T','021','HLT','3716386','92036OH005002705','2014-03-01','2014-02-13 20:19:31','495.00',NULL,NULL,'675.06','180.06','R-OH006','OH0','382.57',NULL,0,'2014-02-14 21:31:38'),(24388,19370,'N','19','021','EC','A',NULL,NULL,'','0000479899','0001089608','','IL','1','STERLING','KARISS','','','','34','642172814','1614 RIVERSTONE WAY',0,'MONROE','OH','45050','1750','CY','39017','2008-11-11','F','',NULL,'N','021','DEN','3458464','99734OH005000401','2014-04-01','2014-02-18 11:37:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:00:47'),(25835,20481,'Y','18','021','EC','A','','','AC','0000165141','0000165141','OH00002662031','IL','1','Hook','Jamie','','','','34','296869572','939 HENRY ST',0,'MARION','OH','43302','7136','CY','39101','1979-11-19','F','M',':RET:2106-3','T','021','DEN','3352970','99734OH005000301','2014-04-01','2014-02-26 17:47:05','0.00',NULL,NULL,'42.26','42.26','R-OH008','OH0','0.00',NULL,0,'2014-02-26 21:00:32'),(27012,21395,'Y','18','021','EC','A','','','AC','0000658451','0000658451','OH00003001429','IL','1','LAMBERT','KATHLEEN','','','','34','293484973','1470 FLEETWOOD AVE',0,'FINDLAY','OH','45840','0127','CY','39063','1952-12-18','F','U',':RET:2106-3','N','021','HLT','2712216','92036OH005001504','2014-04-01','2014-03-03 10:05:59','463.00',NULL,NULL,'618.46','155.46','R-OH002','OH0','618.46','CIC',0,'2014-03-03 21:00:08'),(29026,22975,'Y','18','021','EC','A','','','AC','0000148405','0000148405','OH00002617718','IL','1','Hogan','Savannah','','','','34','273926111','2549 S HARBOR DR',0,'MAINEVILLE','OH','45039','9318','CY','39165','1986-02-24','F','M',':RET:2106-3','N','021','DEN','3894223','99734OH005000401','2014-04-01','2014-03-10 11:10:47','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:33'),(1786,1470,'Y','18','021','EC','A','','','AC','0000305844','0000305844','OH00001088121','IL','1','FULLER','KAYLA','','','','34','288582284','5194 MAPLEWOOD CT W',0,'COLUMBUS','OH','43229','4633','CY','39049','1961-10-20','F','U',NULL,'N','021','DEN','1670218','99734OH005000301','2014-01-01','2013-12-24 16:19:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:56:27'),(5213,4139,'Y','18','021','EC','A','','','AC','0000486941','0000486941','OH00001127655','IL','1','McNulty','George','','','','34','194423961','1231 COOK AVE',0,'LAKEWOOD','OH','44107','2503','CY','39035','1959-06-12','M','M',':RET:2106-3','N','021','DEN','1547384','99734OH005000401','2014-01-01','2013-12-19 15:43:09','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:04:21'),(15538,12433,'Y','18','021','EC','A','','','AC','0001519181','0001519181','LA00000070956','IL','1','Mayon','Jennifer','','','','34','434474673','1021 Don Ave.',0,'Denham Springs','LA','70726',NULL,'CY','22063','1963-09-25','F','M',':RET:2106-3','N','021','DEN','2045919','18575LA002000201','2014-02-01','2013-12-31 14:07:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:52'),(13969,11134,'Y','18','021','EC','A','','','AC','0001062113','0001062113','OH00000687762','IL','1','Homer','Brian','','','','34','277885161','309 RICE ST',0,'ELMORE','OH','43416','9404','CY','39123','1982-04-24','M','M',':RET:2106-3','N','021','HLT','2570566','92036OH002002701','2014-01-01','2013-12-22 23:36:25','334.00',NULL,NULL,'522.00','188.00','R-OH006','OH0','261.00',NULL,0,'2013-12-26 13:15:21'),(15048,12028,'N','01','021','EC','A',NULL,NULL,'','0001457740','0002330863','','IL','1','GALLOWAY','JERALYNN','A','','','34','210503613','9426 CRANDON DR',0,'BATON ROUGE','LA','70810','8803','CY','22033','1956-09-09','F','',NULL,'N','021','DEN','2035769','18575LA002000201','2014-02-01','2013-12-30 13:45:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:03:11'),(19630,15646,'Y','18','021','EC','A','','','AC','0001210955','0001210955','OH00001766635','IL','1','HART','AMY','','','','34','460315403','104 CHARTERHOUSE CT',0,'POWELL','OH','43065','9119','CY','39041','1968-07-08','F','U',':RET:2106-3','N','021','DEN','2685574','99734OH005000401','2014-03-01','2014-01-23 10:36:32','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:09'),(20175,16099,'Y','18','021','EC','A','','','AC','0000115520','0000115520','OH00002161897','IL','1','HALLER','NORMA','','','','34','299584057','1865 ADELAIDE BLVD',0,'AKRON','OH','44305','4353','CY','39153','1960-07-20','F','U',':RET:2106-3','N','021','HLT','2649629','52664OH151001305','2014-03-01','2014-01-27 13:24:44','348.00',NULL,NULL,'454.94','106.94','R-OH012','OH0','454.94',NULL,0,'2014-01-27 21:01:17'),(26492,21015,'Y','18','024','14','A','','','TE','0002140691','0002140691','','IL','1','DUCOTE','ROBBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-14','M','',NULL,NULL,NULL,'','2980626','','2014-02-28','2014-02-28 17:14:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-28 21:00:11'),(27719,21921,'Y','18','024','14','A','','','TE','0000621721','0000621721','','IL','1','Cohen','Laura',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-08-26','F','',NULL,NULL,NULL,'','3679751','','2014-03-05','2014-03-05 13:55:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:57'),(9463,7507,'Y','18','021','EC','A','','','AC','0000195130','0000195130','OH00001301416','IL','1','kochersperger','matt','','','','34','285785071','3695 VILLAGE DR',0,'FRANKLIN','OH','45005','5683','CY','39165','1973-05-07','M','R',':RET:2106-3','N','021','DEN','1675216','99734OH005000401','2014-01-01','2013-12-21 08:07:32','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:16'),(1358,1124,'Y','18','021','EC','A','','','AC','0000170071','0000170071','TX00001495138','IL','1','Johnson','Brandi','','','','34','451998855','115 WARD RD',0,'BAYTOWN','TX','77520','4850','CY','48201','1987-09-20','F','U',':RET:2054-5','N','021','DEN','2168227','33348TX002000101','2014-01-01','2013-12-24 13:48:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:45:25'),(7494,5928,'N','01','021','EC','A',NULL,NULL,'','0001235157','0000283242','','IL','1','Bailey','Kristi','','','','34','281901888','2360 Glenmawr Ave',0,'Columbus','OH','43202',NULL,'CY','39049','1983-10-08','F','',':RET:2106-3','T','021','DEN','1255667','99734OH005000401','2014-01-01','2013-12-15 15:03:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:41'),(22017,17578,'Y','18','021','EC','A','','','AC','0001178334','0001178334','MS00002160990','IL','1','BLOODSAW','BILLY','','','','34','587967682','411 ROSEMONT ST',0,'DUCK HILL','MS','38925','9411','CY','28097','1955-09-12','M','M',NULL,'N','021','DEN','3207912','46300MS002000101','2014-03-01','2014-02-06 21:35:53','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-07 19:00:56'),(22901,18255,'Y','18','021','EC','A','','','AC','0000214706','0000214706','OH00002727602','IL','1','Regina','Gregory','','','','34','369927075','332 S WAYNE ST',0,'VAN WERT','OH','45891','2135','CY','39161','1982-12-20','M','M',':RET:2106-3','N','021','HLT','3393901','92036OH003001506','2014-03-01','2014-02-11 14:29:10','423.00',NULL,NULL,'501.73','78.73','R-OH002','OH0','266.38',NULL,0,'2014-02-11 21:02:42'),(26169,20750,'Y','18','021','EC','A','','','AC','0000890771','0000890771','MS00002662038','IL','1','Erby','Angela','','','','34','427171770','801 17TH ST N',0,'COLUMBUS','MS','39701','3774','CY','28087','1959-09-20','F','U',':RET:2054-5','N','021','DEN','3586326','46300MS002000201','2014-04-01','2014-02-26 22:16:34','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-28 06:30:35'),(27337,21646,'Y','18','021','EC','A','','','AC','0000129309','0000129309','OH00003606899','IL','1','Wolf','Adam','','','','34','298845678','1815 Wegman Ave',0,'Cincinnati','OH','45205',NULL,'CY','39061','1986-06-27','M','U',':RET:2106-3','N','021','DEN','3897430','99734OH005000401','2014-04-01','2014-03-04 09:32:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-04 21:00:56'),(28466,22525,'Y','18','024','14','A','','','TE','0000440878','0000440878','','IL','1','Alsept','Adam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-04-08','M','',NULL,NULL,NULL,'','4002738','','2014-03-06','2014-03-06 20:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:29'),(839,694,'Y','18','021','EC','A','','','AC','0000422785','0000422785','OH00000132620','IL','1','Pozo','Angelica','','','','34','103464017','1193 HOLMDEN AVE',0,'CLEVELAND','OH','44109','1877','CY','39035','1954-02-17','F','U',':RET:2054-5','N','021','HLT','78057','92036OH005000806','2014-01-01','2013-12-15 21:08:41','400.00',NULL,NULL,'608.59','208.59','R-OH011','OH0','608.59',NULL,0,'2013-12-25 18:06:33'),(18372,14664,'Y','18','021','EC','A','','','AC','0000197173','0000197173','OH00001878701','IL','1','Sturgill','Jessica','','','','34','630105144','13810 3RD ST',0,'CROOKSVILLE','OH','43731','9603','CY','39115','1989-06-27','F','M',NULL,'N','021','DEN','1854339','99734OH005000301','2014-02-01','2014-01-15 12:45:12','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-16 08:45:31'),(8083,6399,'Y','18','021','EC','A','','','AC','0000550059','0000550059','OH00001126259','IL','1','Nichting','Marlene','','','','34','288483238','1279 HEATON ST',0,'HAMILTON','OH','45011','1873','CY','39017','1951-02-08','F','U',':RET:2106-3','T','021','HLT','1400206','92036OH004001201','2014-01-01','2013-12-20 15:36:06','238.00',NULL,NULL,'570.30','332.30','R-OH004','OH0','570.30',NULL,0,'2013-12-26 03:10:27'),(15839,12683,'Y','18','021','EC','A','','','AC','0000739033','0000739033','OH00001570063','IL','1','STOESSNER','SANDRA','','','','34','289509038','145 ENGLEWOOD DR.',0,'AVON LAKE','OH','44012',NULL,'CY','39093','1950-07-30','F','U',NULL,'N','021','DEN','2048602','99734OH005000401','2014-02-01','2014-01-02 13:53:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:04:06'),(14993,11983,'Y','18','021','EC','A','','','AC','0000180388','0000180388','TX00000917405','31','1','Spruiell','Kirk','','','','34','450989499','PO Box 66',0,'Palestine','TX','75802',NULL,'CY','48001','1954-09-01','M','M',':RET:1002-5^:RET:2106-3','T','021','DEN','1399284','33348TX002000201','2014-02-01','2013-12-30 16:30:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:01:29'),(14410,11492,'Y','18','021','EC','A','','','AC','0000728778','0000728778','TX00000778724','IL','1','Loli','Darren','','','','34','591584172','2620 CAPITOL ST',0,'HOUSTON','TX','77003','3206','CY','48201','1982-11-03','M','R',':RET:2106-3','N','021','DEN','2358844','33348TX002000101','2014-02-01','2013-12-26 19:54:02','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:25'),(5057,4006,'Y','18','021','EC','A','','','AC','0000557817','0000557817','TX00000217670','IL','1','Herbly','Nada','','','','34','436759462','3001 Cedar St.',0,'Austin','TX','78705',NULL,'CY','48453','1986-05-09','F','U',NULL,'T','021','DEN','1992255','33348TX002000201','2014-01-01','2013-12-18 22:26:48','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:00:19'),(4424,3515,'Y','18','021','EC','A','','','AC','0000869261','0000869261','OH00000263405','IL','1','DILLINGHAM','JERRY','LEE','','','34','289489115','826 ROUTE 131 LOT 10',0,'MILFORD','OH','45150',NULL,'CY','39025','1949-10-30','M','M',':RET:2106-3','N','021','DEN','855355','99734OH005000401','2014-01-01','2013-12-12 16:49:00','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 22:01:40'),(5674,4501,'Y','18','021','EC','A','','','AC','0000117761','0000117761','OH00000743138','IL','1','Alicea','David','','','','34','581049759','3523 West 44Th St',0,'cleveland','OH','44109',NULL,'CY','39035','1955-10-19','M','U',NULL,'N','021','HLT','36659','92036OH006000801','2014-01-01','2013-11-25 20:36:31','0.00',NULL,NULL,'472.43','472.43','R-OH011','OH0','472.43',NULL,0,'2013-12-25 23:32:07'),(23822,18954,'Y','18','021','EC','A','','','AC','0001221982','0001221982','OH00002666516','IL','1','TIMSON','KAREN','','','','34','271649665','9922 TIMBERS DR',0,'BLUE ASH','OH','45242','5547','CY','39061','1957-08-02','F','U',NULL,'N','021','HLT','3424018','92036OH001001201','2014-03-01','2014-02-13 19:30:24','170.00',NULL,NULL,'604.10','434.10','R-OH004','OH0','604.10',NULL,0,'2014-02-14 21:31:41'),(25383,20138,'N','01','021','EC','A',NULL,NULL,'','0000107087','0000103128','','IL','1','Morgan','Sarah','Jane','','','34','529633244','1011 DANIEL ST',0,'WAVELAND','MS','39576','3407','CY','28045','1980-04-24','F','',':RET:2106-3','N','021','DEN','3852214','46300MS002000101','2014-04-01','2014-02-25 11:12:38',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-25 21:30:47'),(7579,5996,'N','19','021','EC','A',NULL,NULL,'','0000440802','0000884194','','IL','1','Kienzle','Stefan','M','','','34','365157368','2238 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','1102','CY','39095','1992-05-09','M','',':RET:2106-3','N','021','HLT','394135','92036OH001002601','2014-01-01','2013-12-15 12:30:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','235.20',NULL,0,'2013-12-26 02:33:54'),(17690,14137,'Y','18','021','EC','A','','','AC','0001571179','0001571179','LA00002363056','IL','1','DUHORN','FLORENCE','M','','','34','434887751','631 NEW ORLEANS AVE',0,'LAKE ARTHUR','LA','70549','3126','CY','22053','1956-12-07','F','M',':RET:2054-5','N','021','DEN','2661340','18575LA002000201','2014-02-01','2014-01-13 11:22:59','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-14 01:32:58'),(15106,12074,'Y','18','024','14','A','','','TE','0000321045','0000321045','','IL','1','Pullalarevu','Sasidhar',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-10-11','M','',NULL,NULL,NULL,'','1698426','','2013-12-30','2013-12-30 10:42:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:04:50'),(1583,1321,'Y','18','021','EC','A','','','AC','0001251679','0001251679','TX00000331022','IL','1','houser','vera','','','','34','258497778','701 DANIELS ST',0,'GLADEWATER','TX','75647','2263','CY','48183','1977-07-28','F','M',':RET:2106-3','N','021','DEN','1362692','33348TX002000201','2014-01-01','2013-12-24 10:51:40','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:51:30'),(2641,2145,'Y','18','021','EC','A','','','AC','0001106762','0001106762','OH00001187476','IL','1','goyetche','mark','','','','34','289749283','2199 LEE RD',0,'CLEVELAND HEIGHTS','OH','44118','2907','CY','39035','1963-11-21','M','U',':RET:2106-3','T','021','DEN','377166','99734OH005000401','2014-01-01','2013-12-02 16:28:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:46:20'),(4111,3285,'N','01','021','EC','A',NULL,NULL,'','0000515823','0000830617','','IL','1','Henderson','Melissa','','','','34','282883760','4753 HIGH HILL RD',0,'CAMBRIDGE','OH','43725','9792','CY','39059','1982-04-18','F','',':RET:2106-3','N','021','DEN','1994619','99734OH005000301','2014-01-01','2013-12-16 19:23:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:00'),(21251,16982,'Y','18','021','EC','A','','','AC','0000904296','0000904296','OH00002324570','IL','1','Mittelman','Scott','','','','34','296541342','3018 STATE ROUTE 43',0,'MOGADORE','OH','44260','9715','CY','39133','1955-02-12','M','M',':RET:2106-3','N','021','HLT','3462939','52664OH151001305','2014-03-01','2014-02-03 12:37:12','355.00',NULL,NULL,'580.49','225.49','R-OH012','OH0','580.49',NULL,0,'2014-02-03 21:01:17'),(22051,17602,'Y','18','021','EC','A','','','AC','0000411874','0000411874','TX00002216336','IL','1','MARTIN DEL CAMPO','MARIA','CRISTINA','','','34','640409096','12108 FRANCIS SCOBEE DR',0,'EL PASO','TX','79936','4473','CY','48141','1954-07-01','F','M',':RET:2106-3','N','021','DEN','3168844','33348TX002000201','2014-03-01','2014-02-07 19:31:47','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-08 19:00:05'),(25679,20372,'Y','18','021','EC','A','','','AC','0000055978','0000055978','OH00002584042','IL','1','CLAYVAUGH','CONNIE','','','','34','268583492','106 W HARRISON ST',0,'WAPAKONETS','OH','45895',NULL,'CY','39011','1956-09-07','F','U',':RET:2106-3','N','021','HLT','3516732','92036OH005001506','2014-04-01','2014-02-22 16:32:55','512.00',NULL,NULL,'536.36','24.36','R-OH002','OH0','536.36',NULL,0,'2014-02-26 08:30:57'),(28837,22820,'N','19','021','EC','A',NULL,NULL,'','0000327336','0000319725','','IL','1','O\'NEAL','john','','','','34','767678251','225 Pinecone Drive',0,'Springboro','OH','45066',NULL,'CY','39165','2013-04-22','M','',NULL,'N','021','HLT','3737757','92036OH006001201','2014-04-01','2014-03-09 12:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-03-09 21:01:10'),(256,213,'Y','18','021','EC','A','','','AC','0000089746','0000089746','LA00000264510','IL','1','Hyde','Yvette','Rachelle','','','34','434494285','9089 KINGCREST PKWY',0,'BATON ROUGE','LA','70810','4046','CY','22033','1968-08-18','F','M',':RET:2054-5','N','021','DEN','973454','18575LA002000101','2014-01-01','2013-12-05 15:53:24','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 17:21:43'),(18758,14946,'Y','18','021','EC','A','','','AC','0000515696','0000515696','TX00001637619','31','1','WATERS','ELIZABETH','','','','34','465434613','PO Box 73572',0,'Houston','TX','77273',NULL,'CY','48201','1978-08-14','F','U',':RET:2106-3','N','021','DEN','1364796','33348TX002000101','2014-02-01','2014-01-15 18:57:38','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:46'),(18422,14697,'Y','18','021','EC','A','','','AC','0001268779','0001268779','LA00001696647','IL','1','Davis','Wandrica','','','','34','438671602','4711 LAFAYE ST',0,'NEW ORLEANS','LA','70122','6135','CY','22071','1987-08-28','F','U',':RET:2054-5','N','021','DEN','2883303','18575LA002000201','2014-02-01','2014-01-15 00:25:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:53'),(18136,14482,'Y','18','021','EC','A','','','AC','0001264690','0001264690','LA00002384624','IL','1','Phillips','Todd','','','','34','439457949','141 Eureka Dr',0,'Gray','LA','70359',NULL,'CY','22109','1968-04-22','M','U',':RET:2106-3','N','021','DEN','1766103','18575LA002000101','2014-02-01','2014-01-13 20:28:08','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-01-15 02:07:45'),(22997,18335,'Y','18','021','EC','A','','','AC','0001049423','0001049423','OH00002405255','IL','1','Opatka','Michelle','','','','34','286782724','491 Broadway Avenue',0,'Bedford','OH','44146',NULL,'CY','39035','1982-01-30','F','M',':RET:2106-3','T','021','DEN','3576420','99734OH005000301','2014-03-01','2014-02-12 12:28:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:30:17'),(2048,1677,'N','01','021','EC','A',NULL,NULL,'','0000678453','0000835118','','IL','1','FIGUEROA','DANIEL','','','','34','635234790','13469 ESTANCIAS DEL NORTE',0,'SAN ELIZARIO','TX','79849','7415','CY','48141','1990-07-12','M','',NULL,'N','021','DEN','9112','33348TX002000201','2014-01-01','2013-12-10 15:24:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:15:46'),(16191,12962,'N','01','021','EC','A',NULL,NULL,'','0000381545','0000057962','','IL','1','NGUYEN','DUNG','CHI','','','34','644182958','449 SAND VERBENA ST',0,'EL PASO','TX','79928','5570','CY','48141','1962-11-29','M','',':RET:2047-9','T','021','DEN','2292513','33348TX002000201','2014-02-01','2014-01-04 00:16:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-05 00:00:49'),(5074,4021,'N','19','021','EC','A',NULL,NULL,'','0000780305','0001140975','','IL','1','majidi','shaghayegh','sheila','','','34','637805108','13115 Marble Falls Cove',0,'Austin','TX','78729',NULL,'CY','48453','1992-03-10','F','',':RET:2106-3','N','021','DEN','2324111','33348TX002000201','2014-01-01','2013-12-19 13:03:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:00:49'),(22525,17983,'N','01','021','EC','A',NULL,NULL,'','0000433943','0000849470','','IL','1','Waits','David','','','','34','285424185','2040 N HOLLOWTOWN RD',0,'LYNCHBURG','OH','45142','9697','CY','39071','1951-03-31','M','',NULL,'N','021','HLT','3670845','92036OH003000604','2014-03-01','2014-02-10 12:46:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','644.07',NULL,0,'2014-02-10 21:31:28'),(22120,17657,'Y','18','021','EC','A','','','AC','0000265284','0000265284','OH00002044008','IL','1','Clos','Jerry','','','','34','284705240','5864 Morris Rd.',0,'Springfield','OH','45502',NULL,'CY','39023','1972-03-20','M','M',':RET:2106-3','N','021','HLT','3228264','92036OH004000501','2014-03-01','2014-02-08 11:17:44','133.00',NULL,NULL,'482.42','349.42','R-OH003','OH0','248.86',NULL,0,'2014-02-08 19:00:39'),(22038,17592,'Y','18','024','14','A','','','TE','0000700415','0000700415','','IL','1','Conway','Connie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-03-02','F','',NULL,NULL,NULL,'','3249083','','2014-02-07','2014-02-07 16:55:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-07 19:01:07'),(19792,15778,'Y','18','021','EC','A','','','AC','0001125465','0001125465','OH00001784524','IL','1','Loder','Gregory','','','','34','298621525','15290 STATE RD',0,'NORTH ROYALTON','OH','44133','5347','CY','39035','1958-08-30','M','U',':RET:2106-3','N','021','HLT','3141721','52664OH151001501','2014-03-01','2014-01-23 15:17:31','117.00',NULL,NULL,'672.70','555.70','R-OH011','OH0','672.70',NULL,0,'2014-01-23 21:01:41'),(19516,15556,'Y','18','021','EC','A','','','AC','0000387311','0000387311','OH00001443532','IL','1','Griffin','Darrin','','','','34','119721406','29107 NORMAN AVE',0,'WICKLIFFE','OH','44092','2356','CY','39085','1973-12-17','M','U',':RET:2106-3','N','021','DEN','2223649','99734OH005000401','2014-03-01','2014-01-21 20:45:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:02:17'),(13451,10726,'Y','18','021','EC','A','','','AC','0000217592','0000217592','OH00001120465','IL','1','Ford','Theresa','Ann','','','34','316860847','1717 NATURE DR',0,'GROVE CITY','OH','43123','8146','CY','39049','1964-09-13','F','M',':RET:2106-3','N','021','DEN','1714171','99734OH005000301','2014-01-01','2013-12-23 14:27:09','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:01:30'),(3911,3129,'Y','18','021','EC','A','','','AC','0000088343','0000088343','TX00000118713','IL','1','cardenas','blanca','','','','34','455811024','4415 NAVAJO ST',0,'PASADENA','TX','77504','3421','CY','48201','1980-12-11','F','M',NULL,'N','021','DEN','1024265','33348TX002000101','2014-01-01','2013-12-13 11:27:14','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 21:37:06'),(13230,10555,'N','01','021','EC','A',NULL,NULL,'','0000304011','0000805674','','IL','1','REED','DEBORAH','J','','','34','449022471','7337 FREDRICKSBURG DR',0,'FOREST HILL','TX','76140','2546','CY','48439','1954-09-20','F','',':RET:2054-5','N','021','DEN','1762968','33348TX002000201','2014-01-01','2013-12-22 21:30:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:55:44'),(6793,5388,'Y','18','021','EC','A','','','AC','0000325218','0000325218','TX00000458122','IL','1','Ramirez','Maria','G','','','34','457156577','1908 SE 9TH ST',0,'MINERAL WELLS','TX','76067','6668','CY','48363','1963-10-08','F','M',NULL,'N','021','DEN','254526','33348TX002000201','2014-01-01','2013-11-25 16:17:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:17:08'),(1319,1090,'Y','18','021','EC','A','','','AC','0000232001','0000232001','MS00000761737','IL','1','jones','thadius','','','','34','427230989','614 EASTWYCK DR',0,'RIDGELAND','MS','39157','3621','CY','28089','1960-12-11','M','U',':RET:2106-3','N','021','DEN','900954','46300MS002000201','2014-01-01','2013-11-04 10:12:18','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:31:39'),(3898,3120,'Y','18','021','EC','A','','','AC','0000184919','0000184919','OH00001169438','IL','1','Barta','Lindsey','','','','34','272928772','2621 3rd street',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1987-10-10','F','U',':RET:2106-3','N','021','HLT','208949','52664OH152000901','2014-01-01','2013-12-13 15:11:14','0.00',NULL,NULL,'167.26','167.26','R-OH012','OH0','167.26',NULL,0,'2013-12-25 21:36:47'),(27952,22112,'Y','18','021','EC','A','','','AC','0000410860','0000410860','TX00003491132','IL','1','HAVINGS','LEROYCE','','','','34','219620151','1210 BARROWGATE DR',0,'SUGAR LAND','TX','77498','2729','CY','48157','1953-11-19','F','U',':RET:2106-3','N','021','DEN','2868664','33348TX002000201','2014-04-01','2014-03-06 17:02:48','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-06 21:00:38'),(13362,10672,'Y','18','021','EC','A','','','AC','0000310851','0000310851','OH00001101350','IL','1','Williams','Brice','','','','34','294845180','3309 BEECHWOOD AVE',0,'CLEVELAND HEIGHTS','OH','44118','1844','CY','39035','1985-12-16','M','U',':RET:2054-5','N','021','DEN','2261328','99734OH005000301','2014-01-01','2013-12-22 19:47:32','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:59:29'),(1935,1576,'Y','18','021','EC','A','','','AC','0000505407','0000505407','TX00000873468','IL','1','Moser','Wendy','','','','34','452815950','6449 COUNTY ROAD 258',0,'DUBLIN','TX','76446','6123','CY','48143','1977-12-27','F','U',':RET:2106-3','N','021','DEN','112524','33348TX002000201','2014-01-01','2013-11-20 10:34:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:00:31'),(1831,1501,'N','01','021','EC','A',NULL,NULL,'','0000232657','0000933208','','IL','1','Skinner','Holly','Lyn','','','34','282907578','4492 RIDGEDALE DR',0,'AKRON','OH','44319','4537','CY','39153','1987-12-09','F','',':RET:2106-3','N','021','HLT','1823807','52664OH151001305','2014-01-01','2013-12-24 10:04:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','228.36',NULL,0,'2013-12-25 18:57:25'),(17164,13734,'Y','18','021','EC','A','','','AC','0001413921','0001413921','LA00002002299','IL','1','Perez','Tara','','','','34','436437039','3433 TAMBOUR DR',0,'MARRERO','LA','70072','5335','CY','22051','1966-04-10','F','U',':RET:2106-3','N','021','DEN','1685243','18575LA002000201','2014-02-01','2014-01-08 15:00:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:22:04'),(2688,2178,'Y','18','021','EC','A','','','AC','0000554127','0000554127','TX00000884053','IL','1','Day','Angie','','','','34','442841779','232 e valley rd.',0,'harker heights','TX','76548',NULL,'CY','48027','1973-01-16','F','U',':RET:2106-3','T','021','DEN','878281','33348TX002000201','2014-01-01','2013-12-02 07:46:55','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 19:47:26'),(23035,18364,'Y','18','021','EC','A','','','AC','0000886552','0000886552','TX00001453235','IL','1','Greenwood','Alicia','','','','34','462235863','400 Old Grande Blvd.',0,'Tyler','TX','75703',NULL,'CY','48423','1972-06-04','F','U',':RET:2106-3','N','021','DEN','2757476','33348TX002000201','2014-03-01','2014-02-12 13:08:11','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-12 21:30:36'),(28331,22416,'N','19','021','EC','A',NULL,NULL,'','0000872922','0000597336','','S1','1','Denbow','William','Kevin','','','34','644191340','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','2009-04-14','M','',':RET:2106-3','N','021','DEN','3020130','33348TX002000201','2014-04-01','2014-03-07 00:39:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-07 21:30:10'),(1610,1345,'Y','18','021','EC','A','','','AC','0000326755','0000326755','TX00000869779','IL','1','White','Areniqua','','','','34','464777281','1369 N Hampton Apt48',0,'Desoto','TX','75115',NULL,'CY','48113','1986-06-20','F','M',':RET:2054-5','N','021','DEN','2554261','33348TX002000201','2014-01-01','2013-12-24 13:07:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:52:16'),(5134,4068,'N','01','021','EC','A',NULL,NULL,'','0001221663','0000034320','','IL','1','Cantu','Soila','','','','34','463829505','1204 Linnwood St',0,'El Campo','TX','77437',NULL,'CY','48481','1949-10-23','F','',NULL,'N','021','DEN','2191827','33348TX002000101','2014-01-01','2013-12-19 16:57:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 23:02:18'),(21100,16863,'Y','18','021','EC','A','','','AC','0000874735','0000874735','OH00001629744','IL','1','Pylypuik','Patrick','','','','34','271966171','9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','1970-10-16','M','R',':RET:2106-3','N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55','0.00',NULL,NULL,'719.22','719.22','R-OH001','OH0','212.76',NULL,0,'2014-02-03 21:00:03'),(20648,16499,'N','01','021','EC','A',NULL,NULL,'','0000157902','0000673682','','IL','1','DAVIS','PATRICIA','','','','34','465025305','8304 MAGNETIC ST',0,'EL PASO','TX','79904',NULL,'CY','48141','1958-08-28','F','',NULL,'N','021','DEN','3179459','33348TX002000201','2014-03-01','2014-01-30 14:25:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:37'),(18263,14580,'Y','18','021','EC','A','','','AC','0001146107','0001146107','TX00002007398','IL','1','orona','adan','','','','34','627320393','1081 north  us hwy 377',0,'junction','TX','76849',NULL,'CY','48267','1992-07-31','M','U',NULL,'N','021','DEN','1402381','33348TX002000201','2014-02-01','2014-01-15 16:47:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:37'),(5744,4560,'Y','18','021','EC','A','','','AC','0000917721','0000917721','LA00000420139','IL','1','Smith','Ava','','','','34','435905027','402 DAPHNE DR',0,'GONZALES','LA','70737','3353','CY','22005','1953-01-01','F','M',':RET:2054-5','N','021','DEN','2392890','18575LA002000201','2014-01-01','2013-12-24 00:38:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:46:02'),(17982,14369,'Y','18','021','EC','A','','','AC','0000001059','0000001059','OH00002242831','IL','1','KIGHTLINGER','PATRICIA','','','','34','302485047','5704 HERMAN AVE',0,'CLEVELAND','OH','44102',NULL,'CY','39035','1950-08-31','F','U',NULL,'N','021','HLT','2565164','52664OH151001305','2014-02-01','2014-01-14 15:56:58','467.00',NULL,NULL,'742.48','275.48','R-OH011','OH0','742.48',NULL,0,'2014-01-15 02:06:53'),(17764,14193,'Y','18','021','EC','A','','','AC','0000500409','0000500409','OH00002245231','IL','1','Thompson','Deborah','','','','34','190568285','105 STONE TRACE DR',0,'MOUNT ORAB','OH','45154','8568','CY','39015','1962-09-02','F','M',':RET:2106-3','N','021','HLT','2189903','92036OH004000601','2014-02-01','2014-01-13 13:53:17','196.00',NULL,NULL,'431.54','235.54','R-OH005','OH0','321.93',NULL,0,'2014-01-14 01:33:35'),(483,394,'Y','18','021','EC','A','','','AC','0000810537','0000810537','LA00001045356','IL','1','Gomes','Elizabeth','','','','34','436735152','1402 N. Causeway Boulevard',0,'Mandeville','LA','70471',NULL,'CY','22103','1975-11-10','F','U',':RET:2106-3','N','021','DEN','870845','18575LA002000201','2014-01-01','2013-12-04 12:00:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:12'),(23908,19018,'N','19','021','EC','A',NULL,NULL,'','0000874746','0000488035','','S1','1','Vanculin','Lyle','','','','34','301131651','189 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1424','CY','39023','2008-07-19','F','',':RET:2106-3','N','021','HLT','3411645','92036OH002000501','2014-03-01','2014-02-14 16:44:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','174.32',NULL,0,'2014-02-14 21:32:28'),(18216,14539,'Y','18','021','EC','A','','','AC','0000082583','0000082583','OH00002210759','IL','1','Jones','Billy','','','','34','274808606','11388 leviden rd',0,'CINCINNATI','OH','45241',NULL,'CY','39061','1982-10-09','M','U',NULL,'N','021','HLT','2407160','92036OH006001201','2014-02-01','2014-01-14 17:22:33','0.00',NULL,NULL,'197.32','197.32','R-OH004','OH0','197.32',NULL,0,'2014-01-15 02:08:12'),(16733,13390,'N','19','021','EC','A',NULL,NULL,'','0000142840','0001136661','','S1','1','Marty','Michael','','','','34','282064636','2156 Steiner rd',0,'Creston','OH','44217',NULL,'CY','39169','2001-06-08','F','',':RET:2106-3','N','021','HLT','2533888','52664OH151001301','2014-02-01','2014-01-07 16:56:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:50'),(15158,12115,'N','19','021','EC','A',NULL,NULL,'','0000116595','0001182517','','IL','1','Ustaszewski','Jordan','A','','','34','278021232','3201 Arctic Avenue',0,'Lewis Center','OH','43035',NULL,'CY','39041','1997-04-29','M','',NULL,'N','021','DEN','2566146','99734OH005000401','2014-02-01','2013-12-30 13:49:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:14'),(3529,2834,'Y','18','021','EC','A','','','AC','0001194131','0001194131','TX00000679853','IL','1','Steormann','Steven','','','','34','112823626','1165 Mount Gilead Road',0,'Keller','TX','76262',NULL,'CY','48439','1980-03-16','M','R',':RET:2106-3','N','021','DEN','2600144','33348TX002000101','2014-01-01','2013-12-21 22:43:58','0.00',NULL,NULL,'101.40','101.40','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:21:27'),(8102,6410,'N','19','021','EC','A',NULL,NULL,'','0000781890','0000145373','','IL','1','Horrigan','Hannah','Christine','','','34','290983334','1273 SHERMAN ST',0,'AKRON','OH','44301','1811','CY','39153','1995-09-23','F','',':RET:2106-3','N','021','HLT','2141014','52664OH151001501','2014-01-01','2013-12-20 17:53:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 03:10:53'),(13459,10733,'Y','18','024','14','A','','','TE','0000908029','0000908029','','IL','1','Feerer','Luke',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-10-25','M','',NULL,NULL,NULL,'','2341418','','2013-12-23','2013-12-23 14:53:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:01:42'),(527,429,'N','01','021','EC','A',NULL,NULL,'','0000891775','0000002266','','IL','1','McLean','David','Allen','','','34','273689439','5616 BRAVE CHIEF LN',0,'RAVENNA','OH','44266','9106','CY','39133','1963-05-05','M','',':RET:2106-3','T','021','HLT','203135','52664OH151001501','2014-01-01','2013-12-04 11:39:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','549.35',NULL,0,'2013-12-25 17:49:21'),(25762,20434,'Y','18','021','EC','A','','','AC','0000665697','0000665697','OH00003077722','IL','1','WURGLER','CLELIA','','','','34','274885997','45 HIGH ST',0,'SEVILLE','OH','44273','9307','CY','39103','1976-09-23','F','U',':RET:2106-3','N','021','HLT','3420225','52664OH151001305','2014-04-01','2014-02-24 14:05:33','179.00',NULL,NULL,'276.08','97.08','R-OH012','OH0','276.08',NULL,0,'2014-02-26 09:30:52'),(5153,4085,'Y','18','021','EC','A','','','AC','0000912943','0000912943','OH00000888435','IL','1','SPENCE','MINDI','','','','34','295547066','3224 SUMMERTIME CT',0,'COLUMBUS','OH','43221','4637','CY','39049','1968-10-10','F','U',':RET:2106-3','N','021','DEN','2024444','99734OH005000401','2014-01-01','2013-12-19 10:01:22','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:02:51'),(954,784,'N','01','021','EC','A',NULL,NULL,'','0000115452','0000091098','','IL','1','Rini','Joseph','Benjamin','','Sr','34','302802854','30401 Clarmont',0,'Willowick','OH','44095',NULL,'CY','39085','1981-01-20','M','',':RET:2106-3','T','021','DEN','735562','99734OH005000301','2014-01-01','2013-10-31 11:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:36'),(25324,20091,'Y','18','021','EC','A','','','AC','0002322426','0002322426','LA00002829306','IL','1','Maynard','Mallory','','','','34','438754642','267 Lovers Lane',0,'Baton Rouge','LA','70806',NULL,'CY','22033','1986-10-31','F','U',':RET:2106-3','N','021','DEN','3371958','18575LA002000201','2014-04-01','2014-02-25 10:47:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:12'),(19091,15210,'Y','18','021','EC','A','','','AC','0001048017','0001048017','OH00002094130','IL','1','Murach','Thomas','','','','34','292446842','3820 W 138TH ST',0,'CLEVELAND','OH','44111','4451','CY','39035','1951-05-07','M','U',NULL,'N','021','DEN','2343464','99734OH005000301','2014-03-01','2014-01-18 15:20:49','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:44:32'),(20962,16751,'Y','18','021','EC','A','','','AC','0000827055','0000827055','TX00002588483','IL','1','Paz','Rodolfo','','','','34','462111581','207 W FARM ST',0,'ALICE','TX','78332','5690','CY','48249','1957-11-20','M','U',':RET:2106-3','T','021','DEN','2653857','33348TX002000201','2014-03-01','2014-02-01 15:08:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-01 19:00:10'),(19483,15530,'Y','18','021','EC','A','','','AC','0000282933','0000282933','TX00001876561','IL','1','Jose','Gloria','A','','','34','449885159','11231 PEARSALL RD',0,'ATASCOSA','TX','78002','5048','CY','48029','1950-08-10','F','M',NULL,'N','021','DEN','2047555','33348TX002000201','2014-03-01','2014-01-22 12:44:49','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-23 03:02:04'),(28008,22163,'Y','18','021','EC','A','','','AC','0000917050','0000917050','OH00003698155','IL','1','LISEMBEE','WANDA','LOUISE','','','34','296667794','2815 QUEENS CITY',0,'Cincinnati','OH','45238',NULL,'CY','39061','1962-12-05','F','U',':RET:2054-5','N','021','DEN','3233678','99734OH005000401','2014-04-01','2014-03-06 10:53:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:13'),(13266,10588,'Y','18','021','EC','A','','','AC','0000865430','0000865430','TX00000252705','IL','1','Aycock','Mike','','','','34','460900907','1818 MESA OAKS CIR',0,'HARKER HEIGHTS','TX','76548','8765','CY','48027','1952-09-24','M','M',':RET:2106-3','N','021','DEN','2151941','33348TX002000201','2014-01-01','2013-12-23 12:16:22','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2013-12-26 12:56:46'),(24733,19632,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000924845','','IL','1','PARHAM','QUANTE','','','','34','288982082','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1995-08-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:15'),(23890,19004,'Y','18','021','EC','A','','','AC','0001203271','0001203271','OH00001355194','IL','1','NEFF','MICHAEL','','','','34','304725423','158 LINDEN AVE',0,'WILMINGTON','OH','45177','1917','CY','39027','1960-10-06','M','M',':RET:2106-3','T','021','HLT','2857784','92036OH003000605','2014-03-01','2014-02-14 17:27:54','992.00',NULL,NULL,'1198.46','206.46','R-OH005','OH0','525.93',NULL,0,'2014-02-14 21:32:17'),(7632,6041,'Y','18','021','EC','A','','','AC','0000076079','0000076079','TX00000305518','IL','1','Beruete','Casey','','','','34','230595100','7101 Virginia pkwy',0,'Mckinney','TX','75071',NULL,'CY','48085','1980-09-11','F','U',NULL,'N','021','DEN','538238','33348TX002000101','2014-01-01','2013-10-14 10:11:54','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 02:46:17'),(2280,1860,'Y','18','021','EC','A','','','AC','0001115909','0001115909','OH00000635251','IL','1','DAVIS','DEBORAH','','','','34','276484079','11307 poplar street',0,'lakeview','OH','43331',NULL,'CY','39091','1949-11-06','F','U',NULL,'N','021','DEN','33513','99734OH005000301','2014-01-01','2013-12-09 12:29:57','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:33'),(23463,18690,'N','01','021','EC','A',NULL,NULL,'','0000996512','0000085331','','IL','1','Findley','Lisa','D','','','34','459232261','300 WILLS POINT ST',0,'CANTON','TX','75103','1216','CY','48467','1958-12-04','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','3063354','33348TX002000201','2014-03-01','2014-02-13 14:59:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:44'),(17292,13829,'N','01','021','EC','A',NULL,NULL,'','0000546561','0000155185','','IL','1','Harvey','Sandra','B','','','34','047527935','13854 HAWKSNEST BAY DR',0,'CORPUS CHRISTI','TX','78418','6334','CY','48355','1955-05-29','F','',':RET:2106-3','N','021','DEN','1682772','33348TX002000201','2014-02-01','2014-01-09 21:59:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:23:33'),(18820,14990,'Y','18','021','EC','A','','','AC','0000479630','0000479630','MS00001371860','IL','1','Tatum','James','','','','34','587532816','5000 RIDGEWOOD RD',0,'JACKSON','MS','39211','5464','CY','28049','1986-03-08','M','U',':RET:2054-5','N','021','DEN','2787235','46300MS002000201','2014-02-01','2014-01-15 18:44:50','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:06'),(17810,14227,'Y','18','021','EC','A','','','AC','0001022073','0001022073','TX00002318899','IL','1','Vu','Due','','','','34','613562780','12431 HERITAGE GROVE DR',0,'HOUSTON','TX','77066','3343','CY','48201','1961-12-24','M','M',NULL,'N','021','DEN','1817146','33348TX002000101','2014-02-01','2014-01-14 14:09:25','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-01-15 02:05:52'),(26259,20827,'Y','18','021','EC','A','','','AC','0000934177','0000934177','TX00003411167','IL','1','Ronquillo','Maria','','','','34','585192786','1314 Banker Rd',0,'Canutillo','TX','79835',NULL,'CY','48141','1952-08-11','F','M',NULL,'N','021','DEN','3348984','33348TX002000201','2014-04-01','2014-02-27 15:42:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-28 06:31:12'),(26485,21009,'Y','18','021','EC','A','','','AC','0000163099','0000163099','LA00003310572','IL','1','crochet','erlin','','','','34','439942861','15081 chenal road',0,'Jarreau','LA','70749',NULL,'CY','22077','1954-02-17','M','M',':RET:2106-3','N','021','DEN','2678654','18575LA002000201','2014-04-01','2014-02-27 20:42:55','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61','CIC',0,'2014-02-28 21:00:07'),(27226,21559,'Y','18','021','EC','A','','','AC','0002183547','0002183547','LA00002933874','IL','1','Van Calsem','Crystal','','','','34','435539978','106 Kappa St',0,'Belle Chasse','LA','70037',NULL,'CY','22075','1981-10-21','F','U',':RET:2106-3','N','021','DEN','3489857','18575LA002000101','2014-04-01','2014-03-03 16:11:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-03 21:31:38'),(27286,21606,'Y','18','021','EC','A','','','AC','0000792429','0000792429','TX00003613003','IL','1','Harris','Blake','','','','34','450758584','1717 W WEBSTER ST',0,'HOUSTON','TX','77019','5461','CY','48201','1984-08-30','M','U',':RET:2106-3','N','021','DEN','3675181','33348TX002000201','2014-04-01','2014-03-04 04:00:10','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:25'),(2232,1836,'N','01','021','EC','A',NULL,NULL,'','0000477434','0000954278','','IL','1','Smith','Chandra','K','','','34','382747762','2484 LITTLE DRY RUN RD',0,'CINCINNATI','OH','45244','3247','CY','39061','1962-03-17','F','',':RET:2054-5','N','021','HLT','116742','92036OH005001205','2014-01-01','2013-12-10 14:34:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','400.37',NULL,0,'2013-12-25 19:20:49'),(25225,20008,'Y','18','021','EC','A','','','AC','0000848407','0000848407','OH00002329950','IL','1','Bostic','Bonnie','','','','34','301507379','581 31st St. S.W.',0,'Barberton','OH','44203',NULL,'CY','39153','1950-10-29','F','U',':RET:2106-3','T','021','HLT','3805901','52664OH151001305','2014-04-01','2014-02-21 11:26:43','518.00',NULL,NULL,'757.07','239.07','R-OH012','OH0','757.07',NULL,0,'2014-02-21 22:00:59'),(2293,1869,'Y','18','021','EC','A','','','AC','0000397316','0000397316','OH00000775322','IL','1','McGovern','Kevin','','','','34','287588603','994 HARRISON AVE',0,'COLUMBUS','OH','43201','3325','CY','39049','1963-12-30','M','M',':RET:2106-3','N','021','DEN','1029325','99734OH005000301','2014-01-01','2013-12-09 16:02:49','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:50'),(9733,7707,'N','01','021','EC','A',NULL,NULL,'','0000949473','0000130653','','IL','1','Nagy','Angela','','','','34','281803991','1720 lexington ave',0,'springfield','OH','45505',NULL,'CY','39023','1967-08-26','F','',':RET:2106-3','T','021','HLT','193577','92036OH004000501','2014-01-01','2013-11-14 20:34:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','329.70',NULL,0,'2013-12-26 04:45:44'),(23011,18346,'Y','18','021','EC','A','','','AC','0001765753','0001765753','LA00002522188','31','1','CHAFFIN','JAMES','MARSH','','','34','264694729','PO BOX 28',0,'GRAND CANE','LA','71032',NULL,'CY','22031','1962-05-22','M','U',':RET:2106-3','N','021','DEN','3121023','18575LA002000101','2014-03-01','2014-02-12 11:56:31','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-12 21:30:23'),(9251,7335,'Y','18','021','EC','A','','','AC','0000735021','0000735021','OH00000066494','IL','1','Rammel','Michelle','','','','34','296668687','116 E RACE ST',0,'MECHANICSBURG','OH','43044','1024','CY','39021','1974-11-16','F','M',':RET:2106-3','N','021','HLT','2274670','92036OH005000506','2014-01-01','2013-12-18 17:20:42','255.00',NULL,NULL,'299.98','44.98','R-OH003','OH0','299.98',NULL,0,'2013-12-26 04:10:49'),(22677,18109,'Y','18','021','EC','A','','','AC','0000502263','0000502263','TX00002640495','IL','1','Richter','Kimberly','','','','34','466067178','3602 FM 528 RD',0,'ALVIN','TX','77511','7520','CY','48039','1955-07-09','F','U',':RET:2106-3','T','021','DEN','3484795','33348TX002000201','2014-03-01','2014-02-11 16:20:09','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:45'),(22261,17768,'Y','18','021','EC','A','','','AC','0000297413','0000297413','TX00001790148','IL','1','Beaird','Jeffery','','','','34','451042956','1269 County Road 175',0,'Colorado City','TX','79512',NULL,'CY','48335','1958-06-24','M','M',':RET:2106-3','N','021','DEN','3210242','33348TX002000201','2014-03-01','2014-01-31 18:35:17','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:08'),(20688,16531,'Y','18','024','14','A','','','TE','0000768911','0000768911','','IL','1','Wood','Tanzie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-12-04','F','',NULL,NULL,NULL,'','2111747','','2014-01-29','2014-01-29 20:32:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:58'),(19171,15273,'N','01','021','EC','A',NULL,NULL,'','0000439486','0001181493','','IL','1','Guasa','Bb Girl Jo Ann','Orillan',NULL,NULL,NULL,NULL,'1109 N MAIN ST',0,'MCALLEN','TX','78501','4330','CY','48215','1969-06-01','F','',':RET:2036-2','N','021','DEN','1477154','33348TX002000201','2014-03-01','2014-01-20 11:58:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:46:03'),(17882,14281,'Y','18','021','EC','A','','','AC','0000919419','0000919419','OH00001982455','IL','1','WAKEFIELD','MICHELLE','RENEE','','','34','302846397','1187 CANDLEWOOD DR',0,'WHEELERSBURG','OH','45694',NULL,'CY','39145','1971-01-26','F','U',':RET:2106-3','N','021','DEN','2839670','99734OH005000401','2014-02-01','2014-01-14 14:32:18','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-01-15 02:06:16'),(7246,5746,'Y','18','021','EC','A','','','AC','0000668988','0000668988','LA00001068804','IL','1','COSPOLOICH','SANDY','LOU','','','34','438133356','62065 HIGHWAY 11',0,'SLIDELL','LA','70458','5426','CY','22103','1958-08-09','F','U',':RET:2106-3','N','021','DEN','904121','18575LA002000201','2014-01-01','2013-12-14 14:56:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:01:47'),(2668,2166,'Y','18','021','EC','A','','','AC','0000433862','0000433862','OH00000019667','31','1','Berry','Laura','M','','','34','302708225','P.O. Box 2485',0,'youngstown','OH','44509',NULL,'CY','39099','1965-09-14','F','M',':RET:2106-3','N','021','DEN','636690','99734OH005000301','2014-01-01','2013-12-02 12:51:40','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:46:59'),(15936,12759,'Y','18','021','EC','A','','','AC','0000479861','0000479861','OH00001910736','IL','1','Waters','Lindsey','','','','34','281786492','221 E JONES ST',0,'FOSTORIA','OH','44830','3017','CY','39147','1981-03-26','F','U',':RET:2106-3','N','021','HLT','1574889','92036OH003002706','2014-02-01','2014-01-02 06:14:21','186.00',NULL,NULL,'240.90','54.90','R-OH006','OH0','240.90',NULL,0,'2014-01-03 02:07:04'),(14899,11901,'Y','18','021','EC','A','','','AC','0000282024','0000282024','OH00000387349','IL','1','Barnett','Patricia','Lee','','','34','235940378','3289 COTTAGE GROVE RD',0,'AKRON','OH','44319','3163','CY','39153','1966-06-07','F','U',':RET:2106-3','T','021','HLT','1586976','52664OH152000901','2014-02-01','2013-12-28 18:20:27','255.00',NULL,NULL,'293.60','38.60','R-OH012','OH0','293.60',NULL,0,'2013-12-30 00:01:04'),(5874,4661,'Y','18','021','EC','A','','','AC','0000071647','0000071647','OH00001429457','IL','1','Conley','Charlotte','','','','34','292583990','1265 DRISCOLL AVE',0,'SPRINGFIELD','OH','45506','2918','CY','39023','1956-08-05','F','M',NULL,'N','021','HLT','2027308','92036OH005000506','2014-01-01','2013-12-23 23:59:14','470.00',NULL,NULL,'579.30','109.30','R-OH003','OH0','579.30',NULL,0,'2013-12-25 23:49:17'),(4644,3681,'Y','18','021','EC','A','','','AC','0000694370','0000694370','MS00000485751','IL','1','PRESTON','ARMETHIA','','','','34','587802196','12391 HOLLIMAN CIR',0,'GULFPORT','MS','39503','5573','CY','28047','1949-07-15','F','M',':RET:2054-5','N','021','DEN','1080149','46300MS002000201','2014-01-01','2013-12-12 12:58:05','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 22:06:52'),(5122,4059,'Y','18','021','EC','A','','','AC','0001088391','0001088391','TX00000009955','IL','1','Lucero','Robert','','','','34','458778015','245 PECOS ST',0,'EL PASO','TX','79905','4803','CY','48141','1971-01-17','M','U',':RET:2106-3','N','021','DEN','1618467','33348TX002000201','2014-01-01','2013-12-18 18:39:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:01:58'),(26592,21084,'N','19','021','EC','A',NULL,NULL,'','0000717875','0000713684','','S1','1','CAVILEER','JOHN','','','','34','332630096','40 WALDORF DR',0,'AKRON','OH','44313','6226','CY','39153','2012-05-02','M','',':RET:2106-3','N','021','HLT','3847575','52664OH152000901','2014-01-01','2014-02-28 12:21:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-02-28 21:30:36'),(27402,21692,'Y','18','021','EC','A','','','AC','0000969505','0000969505','OH00003691530','S1','1','Ramos','Andrew','','','','34','854013742','8308 WAINSTEAD DR',0,'PARMA','OH','44129','4847','CY','39035','2011-08-11','F','U',':RET:2106-3','N','021','DEN','3719013','99734OH005000301','2014-04-01','2014-03-04 01:59:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','21.13',NULL,0,'2014-03-04 21:01:31'),(1738,1442,'N','01','021','EC','A',NULL,NULL,'','0001124065','0000277275','','IL','1','turkish','therese','','','','34','286688354','12290 WATERFOWL LN',0,'CHARDON','OH','44024','7024','CY','39055','1971-12-15','F','',NULL,'N','021','DEN','1845086','99734OH005000301','2014-01-01','2013-12-24 11:01:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:29'),(9453,7499,'N','01','021','EC','A',NULL,NULL,'','0001042287','0000489243','','IL','1','Bruns','Katrina','','','','34','076663529','4673 ANTHONY WAYNE AVE',0,'FAIRFIELD','OH','45014','1701','CY','39017','1982-01-30','F','',':RET:2106-3','N','021','DEN','1809235','99734OH005000401','2014-01-01','2013-12-20 21:49:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:01'),(6515,5165,'Y','18','021','EC','A','','','AC','0000224704','0000224704','OH00000547568','IL','1','Hirt','JoAnna','','','','34','268646109','3118 cardinal dr',0,'Harrod','OH','45850',NULL,'CY','39003','1957-07-15','F','M',':RET:2106-3','N','021','HLT','359250','92036OH003001505','2014-01-01','2013-12-10 19:08:37','414.00',NULL,NULL,'536.20','122.20','R-OH002','OH0','536.20',NULL,0,'2013-12-26 00:51:15'),(18692,14902,'Y','18','021','EC','A','','','AC','0001462813','0001462813','LA00001774243','IL','1','HAGEN','ALLISON','','','','34','485047840','338 AUDUBON ST',0,'NEW ORLEANS','LA','70118','4941','CY','22071','1981-04-29','F','U',NULL,'N','021','DEN','2353584','18575LA002000101','2014-03-01','2014-01-16 00:31:28','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-17 03:35:25'),(14868,11872,'Y','18','021','EC','A','','','AC','0000057929','0000057929','TX00001611682','IL','1','Brown','Sharon','','','','34','464291725','1309 N Englewood Ave',0,'Tyler','TX','75702',NULL,'CY','48423','1962-05-01','F','U',':RET:2054-5','N','021','DEN','1613148','33348TX002000201','2014-02-01','2013-12-28 21:07:51','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-30 00:00:09'),(15685,12547,'Y','18','021','EC','A','','','AC','0000456532','0000456532','OH00000578088','IL','1','Hemmer','April','','','','34','448840807','6781 WESSELMAN RD',0,'CLEVES','OH','45002','9613','CY','39061','1984-01-06','F','U',NULL,'N','021','HLT','2262744','92036OH006001202','2014-02-01','2013-12-31 11:31:27','140.00',NULL,NULL,'193.23','53.23','R-OH004','OH0','193.23',NULL,1,'2014-01-02 04:35:09'),(28332,22416,'N','01','021','EC','A',NULL,NULL,'','0000872922','0001011829','','IL','1','Denbow','William','Kevin','','','34','460690387','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1968-09-16','M','',':RET:2106-3','N','021','DEN','3020130','33348TX002000201','2014-04-01','2014-03-07 00:39:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-07 21:30:11'),(29114,23047,'Y','18','021','EC','A','','','AC','0000243909','0000243909','MS00003538000','IL','1','Thompson','Brian','A','','','34','427492299','238 ROWLAND AVE',0,'JACKSON','MS','39209','2422','CY','28049','1982-09-14','M','U',':RET:2054-5','T','021','DEN','4038080','46300MS002000201','2014-04-01','2014-03-10 09:00:29','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-10 21:02:26'),(896,743,'Y','18','024','14','A','','','TE','0001063197','0001063197','','IL','1','Martin','Mary','Kathern',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-18','F','',NULL,NULL,NULL,'','34015','','2013-12-16','2013-12-16 12:43:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:08:08'),(20857,16672,'Y','18','021','EC','A','','','AC','0001201924','0001201924','OH00001659709','IL','1','Destefano','Christine','','','','34','274745050','3688 HEMPHILL RD',0,'NORTON','OH','44203','5020','CY','39153','1963-01-09','F','M',NULL,'N','021','DEN','2817982','99734OH005000301','2014-03-01','2014-01-31 15:07:28','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2014-01-31 21:00:56'),(14534,11597,'Y','18','024','14','A','','','TE','0001072479','0001072479','','IL','1','Edwards','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-07-28','F','',NULL,NULL,NULL,'','1427233','','2013-12-26','2013-12-26 23:57:03',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-28 03:34:38'),(19967,15928,'Y','18','021','EC','A','','','AC','0000520989','0000520989','OH00002392856','IL','1','PODLICH','LINDA','MARIE','','','34','274708782','360 HENRY ST',0,'AMHERST','OH','44001','2427','CY','39093','1961-03-26','F','M',':RET:2106-3','N','021','DEN','2865151','99734OH005000301','2014-03-01','2014-01-25 13:22:17','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-25 19:00:10'),(17324,13857,'Y','18','021','EC','A','','','AC','0000961074','0000961074','TX00001559976','IL','1','Dang','Hoang Yen','Thi','','','34','667244590','5012 BAYBERRY DR',0,'WICHITA FALLS','TX','76310','3488','CY','48485','1970-09-14','F','U',':RET:2047-9','N','021','DEN','1745021','33348TX002000201','2014-02-01','2014-01-10 18:08:25','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-13 02:23:52'),(14426,11504,'N','01','021','EC','A',NULL,NULL,'','0000386576','0000199054','','IL','1','BALDWIN','DONNIE','RAY','','Sr','34','452259452','1518 HOWARD ST',0,'CORPUS CHRISTI','TX','78401','2631','CY','48355','1964-08-22','M','',':RET:2054-5','N','021','DEN','1866945','33348TX002000101','2014-02-01','2013-12-27 17:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-28 03:31:47'),(15767,12617,'Y','18','021','EC','A','','','AC','0001135551','0001135551','TX00001746979','IL','1','andrews','jennifer','','','','34','449571573','4900 VALLEY OAK DR',0,'AUSTIN','TX','78731','5436','CY','48453','1966-04-01','F','R',':RET:2106-3','N','021','DEN','1869602','33348TX002000201','2014-02-01','2014-01-02 13:24:20','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-03 02:01:42'),(24345,19334,'Y','18','021','EC','A','','','AC','0000713928','0000713928','TX00002946299','IL','1','REYNA','HOPE','','','','34','462472265','1104 NARANJO ST',0,'SINTON','TX','78387','3922','CY','48409','1977-11-24','F','U',':RET:2106-3','N','021','DEN','2906223','33348TX002000201','2014-04-01','2014-02-18 16:22:12','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-18 22:00:23'),(22877,18246,'N','19','021','EC','A',NULL,NULL,'','0000050726','0000358371','','IL','1','Paris','Abigail','','','','34','282029821','5450 PARKS AVE',0,'LOUISVILLE','OH','44641','9522','CY','39151','1997-07-23','F','',NULL,'N','021','HLT','3696746','52664OH151001501','2014-03-01','2014-02-11 09:18:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-11 21:02:32'),(15079,12052,'N','01','021','EC','A',NULL,NULL,'','0000872641','0000765829','','IL','1','Burns','Ronnie','','','','34','455021587','476 Rains County Rd 1430',0,'Point','TX','75472',NULL,'CY','48379','1957-03-15','M','',':RET:2106-3','N','021','DEN','2081272','33348TX002000101','2014-02-01','2013-12-29 20:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-01 12:04:06'),(1166,962,'N','01','021','EC','A',NULL,NULL,'','0000140842','0000253950','','IL','1','Saucier','Wilton','','','','34','439885379','11710 SIMMS RD',0,'DENHAM SPRINGS','LA','70706','0399','CY','22063','1952-10-11','M','',':RET:2106-3','N','021','DEN','115126','18575LA002000201','2014-01-01','2013-12-03 17:18:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:19:02'),(13665,10903,'Y','18','021','EC','A','','','AC','0001719002','0001719002','LA00001228598','IL','1','Elzy','Glenn','','','','34','433774584','3301 w esplanade ave n',0,'Metairie','LA','70002',NULL,'CY','22051','1987-01-21','M','U',':RET:2054-5','N','021','DEN','1513024','18575LA002000101','2014-01-01','2013-12-23 14:13:24','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:45'),(4823,3822,'N','01','021','EC','A',NULL,NULL,'','0000521926','0000924766','','IL','1','Robenalt','Paulette','','','','34','295441085','163 Wentz St',0,'Tiffin','OH','44883',NULL,'CY','39147','1954-11-12','F','',':RET:2106-3','N','021','HLT','787023','92036OH002002701','2014-01-01','2013-12-08 11:37:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.17',NULL,0,'2013-12-25 22:17:09'),(4336,3444,'N','01','021','EC','A',NULL,NULL,'','0000461917','0000726115','','IL','1','BENSMAN','KAREN','','','','34','272521632','908 METBLISS AVE',0,'DELPHOS','OH','45833',NULL,'CY','39161','1952-03-03','F','',NULL,'N','021','HLT','1624117','92036OH002001501','2014-01-01','2013-12-17 10:52:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','714.21',NULL,0,'2013-12-25 21:53:09'),(2381,1943,'Y','18','021','EC','A','','','AC','0000551401','0000551401','OH00000382308','IL','1','Smith','Samuel','','','','34','309886858','8090 OLD KELLOGG RD',0,'CINCINNATI','OH','45255','4646','CY','39061','1982-03-30','M','U',':RET:2106-3','N','021','DEN','488053','99734OH005000401','2014-01-01','2013-12-09 10:36:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:02'),(29067,23004,'N','01','021','EC','A',NULL,NULL,'','0000552689','0000467153','','IL','1','Kerr','Michelle','','','','34','290746354','4134 N LOCKWOOD AVE',0,'TOLEDO','OH','43612','1745','CY','39095','1966-12-16','F','',NULL,'N','021','HLT','3276340','92036OH004002601','2014-04-01','2014-03-10 12:08:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.07',NULL,0,'2014-03-10 21:01:55'),(922,765,'Y','18','021','EC','A','','','AC','0000141468','0000141468','OH00001093039','IL','1','Hayes','James','','','','34','278885760','1094 BERKSHIRE DR',0,'MACEDONIA','OH','44056','1637','CY','39153','1987-11-15','M','U',':RET:2106-3','N','021','DEN','925855','99734OH005000401','2014-01-01','2013-10-28 18:10:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:08:53'),(14257,11371,'Y','18','021','EC','A','','','AC','0002061641','0002061641','LA00000046082','IL','1','Martin','Elizabeth','','','','34','438818572','2716 ERIN DR',0,'MARRERO','LA','70072','6522','CY','22051','1991-06-06','F','U',':RET:2106-3','N','021','DEN','2036873','18575LA002000101','2014-02-01','2013-12-26 11:13:59','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-27 02:05:41'),(24772,19652,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000141486','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','283049387','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1999-07-16','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:25'),(24553,19501,'N','19','021','EC','A',NULL,NULL,'','0000009892','0000438022','','IL','1','Mahone','William','Benjamin','','','34','259873348','3378 Whitebeech Lane',0,'Youngstown','OH','44511',NULL,'CY','39099','1993-09-02','M','',':RET:2054-5','N','021','HLT','3026681','52664OH151001305','2014-04-01','2014-02-19 15:59:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','160.59',NULL,0,'2014-02-20 04:04:45'),(24338,19328,'Y','18','021','EC','A','','','AC','0000204347','0000204347','TX00002567562','31','1','WEBB','WILLIAM','R','','','34','300503622','PO BOX 431',0,'GRAFORD','TX','76449',NULL,'CY','48363','1953-07-10','M','U',NULL,'N','021','DEN','3279686','33348TX002000201','2014-04-01','2014-02-18 14:27:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:18'),(23168,18470,'N','01','021','EC','A',NULL,NULL,'','0000567775','0000265541','','IL','1','KISHKIN','GABRIELA','RUMENOVA','','','34','641197301','12970 AMBROSE DR',0,'FRISCO','TX','75035',NULL,'CY','48085','1971-08-04','F','',':RET:2106-3','N','021','DEN','2852629','33348TX002000101','2014-03-01','2014-02-12 16:18:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-12 21:31:51'),(6707,5317,'Y','18','021','EC','A','','','AC','0001011519','0001011519','OH00000881533','IL','1','Seward','Anastasia','','','','34','381150682','5928 SPRING HOLLOW DR',0,'TOLEDO','OH','43615','7903','CY','39095','1993-06-13','F','U',':RET:2106-3','N','021','HLT','107572','92036OH006002601','2014-01-01','2013-11-04 20:17:54','95.00',NULL,NULL,'98.20','3.20','R-OH001','OH0','98.20',NULL,0,'2013-12-26 01:02:06'),(1704,1423,'Y','18','021','EC','A','','','AC','0000756007','0000756007','OH00000041255','IL','1','Cassiere','Marc','','','','34','270549078','6825 BRIDGETOWN RD',0,'CINCINNATI','OH','45248','2819','CY','39061','1961-02-06','M','R',':RET:2106-3','N','021','HLT','1679944','92036OH006001201','2014-01-01','2013-12-24 08:50:52','0.00',NULL,NULL,'332.32','332.32','R-OH004','OH0','332.32',NULL,0,'2013-12-25 18:54:49'),(24689,19598,'Y','18','021','EC','A','','','AC','0000024826','0000024826','TX00001552501','IL','1','Gilson','Cimarron','','','','34','452539182','3777 FM 1518',0,'Selma','TX','78154',NULL,'CY','48187','1980-08-28','M','U',':RET:2106-3','N','021','DEN','3194029','33348TX002000101','2014-04-01','2014-02-19 17:35:53','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-20 04:32:01'),(21424,17123,'N','19','021','EC','A',NULL,NULL,'','0000904297','0001161577','','S1','1','Haddad','Saba',NULL,NULL,NULL,NULL,NULL,'5467 surrey ct',0,'West chester','OH','45069',NULL,'CY','39017','2009-11-02','M','',':RET:2106-3','N','021','HLT','3428920','92036OH004001201','2014-03-01','2014-02-03 23:16:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-04 21:01:15'),(4795,3802,'Y','18','021','EC','A','','','AC','0000034344','0000034344','OH00000081299','IL','1','Pendleton','D','Renee','','','34','292704101','23310 E BAINTREE RD',0,'BEACHWOOD','OH','44122','1246','CY','39035','1960-06-11','F','M',':RET:2106-3','N','021','HLT','730796','52664OH151001301','2014-01-01','2013-12-08 15:08:35','0.00',NULL,NULL,'1225.64','1225.64','R-OH011','OH0','513.10',NULL,0,'2013-12-25 22:16:23'),(19216,15310,'N','01','021','EC','A',NULL,NULL,'','0000872080','0000472284','','IL','1','DURO','MARY BETH','EOR','','','34','613916191','5440 TRETORN DR',0,'HILLIARD','OH','43026','8828','CY','39049','1963-11-11','F','',NULL,'N','021','DEN','2108606','99734OH005000401','2014-03-01','2014-01-20 12:19:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:46:24'),(16286,13037,'N','01','021','EC','A',NULL,NULL,'','0001010222','0000427648','','IL','1','Duff','James','Raymond','','','34','406028076','105 West 4th st.',0,'Cincinnati','OH','45202',NULL,'CY','39061','1972-03-09','M','',':RET:2106-3','N','021','DEN','2354535','99734OH005000401','2014-02-01','2014-01-06 11:39:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:41'),(15103,12071,'N','01','021','EC','A',NULL,NULL,'','0001081806','0000906612','','IL','1','Lawson','James',NULL,NULL,NULL,NULL,NULL,'24383 Smith Avenue',0,'Westlake','OH','44145',NULL,'CY','39035','1951-01-21','M','',NULL,'N','021','DEN','1737808','99734OH005000301','2014-02-01','2013-12-30 09:25:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:04:44'),(25726,20406,'Y','18','024','14','A','','','TE','0002029265','0002029265','','IL','1','Busby','Cyndi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-07-06','F','',NULL,NULL,NULL,'','2754783','','2014-02-24','2014-02-24 13:15:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-26 09:30:32'),(778,642,'N','01','021','EC','A',NULL,NULL,'','0000440546','0000825418','','IL','1','Alvarado','Elvira','','','','34','455928872','301 DOUGLAS ST',0,'HEREFORD','TX','79045','2702','CY','48117','1951-05-31','F','',NULL,'N','021','DEN','1704482','33348TX002000201','2014-01-01','2013-12-16 13:51:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:04:59'),(24482,19449,'Y','18','021','EC','A','','','AC','0000823565','0000823565','OH00002985246','IL','1','farwell','randy','','','','34','373642861','4577 st rt 276',0,'batavia','OH','45103',NULL,'CY','39025','1954-12-23','M','M',':RET:2106-3','N','021','HLT','3191098','92036OH003000605','2014-04-01','2014-02-18 16:09:56','884.00',NULL,NULL,'1213.51','329.51','R-OH005','OH0','583.55',NULL,0,'2014-02-18 22:01:46'),(22681,18112,'Y','18','021','EC','A','','','AC','0000326967','0000326967','TX00001937119','IL','1','Plate','Derek','','','','34','453894576','5720 Marquita Ave Apt 1',0,'Dallas','TX','75206',NULL,'CY','48113','1983-07-13','M','U',':RET:2106-3','N','021','DEN','3526657','33348TX002000201','2014-03-01','2014-02-11 17:12:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:48'),(13709,10938,'Y','18','021','EC','A','','','AC','0000551419','0000551419','OH00000690598','IL','1','Weihe','Faith','','','','34','302921684','1855 ISSAQUAH ST',0,'CUYAHOGA FALLS','OH','44221','4424','CY','39153','1987-10-12','F','U',':RET:2106-3','N','021','HLT','2297298','52664OH151001306','2014-01-01','2013-12-23 13:42:24','183.00',NULL,NULL,'228.36','45.36','R-OH012','OH0','228.36',NULL,0,'2013-12-26 13:08:53'),(17685,14132,'Y','18','021','EC','A','','','AC','0001356194','0001356194','LA00001931138','IL','1','Olson','Elizabeth','','','','34','435715949','7945 SEVILLE CT',0,'BATON ROUGE','LA','70820','6520','CY','22033','1986-10-15','F','U',':RET:2106-3','N','021','DEN','2775763','18575LA002000101','2014-02-01','2014-01-13 17:25:07','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-14 01:32:56'),(16872,13499,'N','01','021','EC','A',NULL,NULL,'','0001088508','0000562953','','IL','1','mcfatridge','david','wayne','','','34','465450041','1101 N 2ND ST',0,'CRANFILLS GAP','TX','76637','4068','CY','48035','1963-05-02','M','',':RET:2106-3','T','021','DEN','2404457','33348TX002000201','2014-02-01','2014-01-09 16:39:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:19:16'),(16717,13379,'Y','18','021','EC','A','','','AC','0001135571','0001135571','TX00002054444','IL','1','COOLEY','BALINDA','','','','34','445508103','6821 BUCHANAN',0,'TEXARKANA','TX','75501',NULL,'CY','48037','1950-05-07','F','U',NULL,'N','021','DEN','1549582','33348TX002000201','2014-02-01','2014-01-07 15:34:46','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-01-08 18:24:45'),(15284,12220,'Y','18','021','EC','A','','','AC','0000319049','0000319049','MS00001576423','IL','1','Spann','Claire','','','','34','267874344','103 Joe Myers Rd.',0,'Brandon','MS','39047',NULL,'CY','28121','1969-08-25','F','M',':RET:2106-3','N','021','DEN','1782037','46300MS002000101','2014-02-01','2013-12-31 19:06:54','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:22:15'),(13588,10838,'Y','18','021','EC','A','','','AC','0002255077','0002255077','LA00000353644','IL','1','LUNKINS','RENE','','','','34','439276421','5601 BURGUNDY ST',0,'New Orleans','LA','70117',NULL,'CY','22071','1959-08-27','F','U',':RET:2054-5','N','021','DEN','1622247','18575LA002000201','2014-01-01','2013-12-23 18:57:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:05:05'),(26478,21002,'Y','18','024','14','A','','','TE','0000692080','0000692080','','IL','1','Duncan','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-23','M','',NULL,NULL,NULL,'','538567','','2014-03-31','2014-02-28 08:55:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-28 21:00:02'),(26804,21241,'Y','18','021','EC','A','','','AC','0000749594','0000749594','OH00002930010','IL','1','TAMBI','MEITA','','','','34','243112931','3604 ROSSLARE HARBOUR DR',0,'PICKERINGTON','OH','43147','7783','CY','39045','1950-12-24','F','U',':RET:2054-5','N','021','DEN','3699447','99734OH005000301','2014-03-01','2014-02-28 20:25:17','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:24'),(5377,4264,'Y','18','021','EC','A','','','AC','0002135631','0002135631','LA00000301523','IL','1','METTS','RAMONA','','','','34','436863904','3550 CEDAR CREEK DR',0,'SHREVEPORT','LA','71118','2319','CY','22017','1949-10-27','F','U',NULL,'N','021','DEN','2139817','18575LA002000201','2014-01-01','2013-12-19 14:37:46','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 23:08:15'),(9569,7581,'N','19','021','EC','A',NULL,NULL,'','0001245588','0000821000','','IL','1','STUNTEBECK','ICE','SANGPHOM','','','34','654919964','11588 KEMPER WOODS DR',0,'CINCINNATI','OH','45249','1752','CY','39061','1998-04-10','M','',':RET:2028-9','N','021','DEN','1827183','99734OH005000301','2014-01-01','2013-12-21 16:14:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:41'),(604,497,'Y','18','021','EC','A','','','AC','0000741699','0000741699','OH00000437219','IL','1','FALL','Mimi','','','','34','293080665','2889 Spinnaker Loop',0,'Reynoldsburg','OH','43068',NULL,'CY','39049','1971-01-01','F','M',NULL,'N','021','DEN','2186492','99734OH005000401','2014-01-01','2013-12-16 08:48:36','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:00:24'),(22964,18309,'Y','18','021','EC','A','','','AC','0000545210','0000545210','OH00001405171','IL','1','miller','robert','l','','','34','160448709','311 PLEASANT MEADOW BLVD',0,'STOW','OH','44224','4968','CY','39153','1951-07-17','M','U',':RET:2106-3','N','021','HLT','3110144','52664OH151001304','2014-03-01','2014-02-12 11:51:48','442.00',NULL,NULL,'640.70','198.70','R-OH012','OH0','640.70','CIC',0,'2014-02-12 21:00:12'),(22127,17659,'N','01','021','EC','A',NULL,NULL,'','0000101467','0000048229','','IL','1','Ratliff','Melissa','','','','34','400214495','2108 INDIAN RIDGE DR',0,'PIQUA','OH','45356','8268','CY','39109','1977-02-17','F','',':RET:2106-3','N','021','HLT','2819217','92036OH004000501','2014-03-01','2014-02-08 17:01:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','236.62',NULL,0,'2014-02-08 19:00:41'),(16468,13177,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00001407131','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','2201355','52664OH151001306','2014-02-01','2014-01-06 10:59:30','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2014-01-07 04:05:52'),(9485,7522,'Y','18','021','EC','A','','','AC','0000814280','0000814280','OH00001079967','IL','1','Howard','Benjamin','','','','34','295927686','1424 LAKEWOOD AVE',0,'LAKEWOOD','OH','44107','4925','CY','39035','1985-12-25','M','M',':RET:2106-3','N','021','DEN','1477671','99734OH005000401','2014-01-01','2013-12-21 12:56:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:34:45'),(8956,7104,'Y','18','021','EC','A','','','AC','0000857087','0000857087','OH00000701231','IL','1','Rich','Terrence','','','','34','276664600','4217 Roosevelt Boulevard',0,'Middletown','OH','45044',NULL,'CY','39017','1962-10-02','M','U',':RET:2106-3','T','021','DEN','2102123','99734OH005000401','2014-01-01','2013-12-18 12:23:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:43'),(7120,5649,'Y','18','021','EC','A','','','AC','0000191371','0000191371','OH00000265382','IL','1','Spurlock','Jonda','','','','34','281782393','422 N LINCOLN ST',0,'WILMINGTON','OH','45177','1716','CY','39027','1965-12-15','F','U',':RET:2106-3','T','021','HLT','1438408','92036OH001000601','2014-02-01','2013-12-25 12:57:16','0.00',NULL,NULL,'486.88','486.88','R-OH005','OH0','486.88',NULL,0,'2013-12-26 01:51:17'),(27092,21448,'Y','18','024','14','A','','','TE','0000816484','0000816484','','IL','1','Stone','david',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-08-13','M','',NULL,NULL,NULL,'','3249956','','2014-03-03','2014-03-03 13:08:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-03 21:30:17'),(14467,11544,'Y','18','021','EC','A','','','AC','0000376541','0000376541','TX00001763442','IL','1','rodriguez','amado','gomez','','','34','466399023','1424 OLIVE ST',0,'GAINESVILLE','TX','76240','3561','CY','48097','1952-02-06','M','M',':RET:2106-3','N','021','DEN','1444607','33348TX002000201','2014-02-01','2013-12-26 18:55:39','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:32:58'),(24287,19288,'Y','18','024','14','A','','','TE','0000247833','0000247833','','IL','1','Robinson','Charlotte',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-04-24','F','',NULL,NULL,NULL,'','2095034','','2014-03-31','2014-02-18 09:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-18 21:30:10'),(21052,16820,'N','19','021','EC','A',NULL,NULL,'','0000222429','0000250276','','S1','1','Hilton','George','Renee','','','34','515150422','10 krebs Drive',0,'Sabina','OH','45169',NULL,'CY','39027','1998-07-23','F','',':RET:2106-3','N','021','HLT','3641948','92036OH006000601','2014-03-01','2014-02-01 18:58:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-02-02 19:00:06'),(19229,15322,'Y','18','021','EC','A','','','AC','0000374730','0000374730','OH00002101614','IL','1','haddad','ashraf','','','','34','606901230','2837 WESTOWNE CT',0,'TOLEDO','OH','43615','1919','CY','39095','1976-05-03','M','M',':RET:2028-9','T','021','DEN','1467060','99734OH005000301','2014-03-01','2014-01-20 01:55:47','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-21 08:46:32'),(2435,1983,'Y','18','021','EC','A','','','AC','0000430253','0000430253','OH00000597416','IL','1','Halton','Carolyn','','','','34','652834880','9 DOUGLAS LN',0,'MEDINA','OH','44256','1308','CY','39103','1975-12-21','F','M',':RET:2036-2','N','021','HLT','551980','52664OH151001306','2014-01-01','2013-12-09 11:56:41','208.00',NULL,NULL,'277.87','69.87','R-OH012','OH0','277.87',NULL,0,'2013-12-25 19:34:16'),(13590,10840,'Y','18','021','EC','A','','','AC','0002189757','0002189757','LA00001351174','IL','1','Butters','Gary','','','','34','587336029','512 N DILTON ST',0,'METAIRIE','LA','70003','6008','CY','22051','1963-02-28','M','U',NULL,'T','021','DEN','1455453','18575LA002000201','2014-01-01','2013-12-23 19:00:04','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:05:09'),(9312,7384,'Y','18','021','EC','A','','','AC','0001536827','0001536827','LA00000301607','IL','1','Espinosa','Marina','','','','34','663206881','2005 KLEINERT AVE',0,'BATON ROUGE','LA','70806','6711','CY','22033','1928-06-15','F','M',':RET:2106-3','N','021','DEN','1673960','18575LA002000101','2014-01-01','2013-12-21 11:17:56','0.00',NULL,NULL,'62.00','62.00','R-LA005','LA0','31.00',NULL,0,'2013-12-26 04:30:17'),(3880,3108,'Y','18','021','EC','A','','','AC','0000820722','0000820722','LA00000075215','IL','1','Gibbons','Patricia','Venezia','','','34','439826346','3910 Connecticut Avenue',0,'Kenner','LA','70065',NULL,'CY','22051','1950-11-29','F','U',':RET:2106-3','N','021','DEN','42581','18575LA002000201','2014-01-01','2013-12-13 13:55:25','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:36:25'),(5351,4244,'Y','18','021','EC','A','','','AC','0000192725','0000192725','OH00000903715','IL','1','Rivers','Rausheen','','','','34','300765379','844 STADELMAN AVE',0,'AKRON','OH','44320','2275','CY','39153','1981-02-25','M','U',':RET:2054-5','T','021','HLT','1848562','52664OH152000901','2014-01-01','2013-12-19 14:38:19','135.00',NULL,NULL,'222.22','87.22','R-OH012','OH0','222.22',NULL,0,'2013-12-25 23:07:37'),(1479,1233,'Y','18','021','EC','A','','','AC','0000141513','0000141513','OH00001130466','IL','1','BLOCKER','STEVEN','','','','34','177581319','1009 W EXCHANGE ST',0,'AKRON','OH','44302',NULL,'CY','39153','1977-06-06','M','U',':RET:2054-5','N','021','DEN','2415170','99734OH005000401','2014-01-01','2013-12-24 10:27:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:48:46'),(3659,2927,'Y','18','021','EC','A','','','AC','0000661327','0000661327','OH00000908385','IL','1','Brandstetter','Gary','','','','34','298862359','18800 HOMEWAY RD',0,'CLEVELAND','OH','44135','4028','CY','39035','1987-04-27','M','U',':RET:2106-3','N','021','DEN','516308','99734OH005000401','2014-01-01','2013-12-12 20:05:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:30:50'),(18487,14745,'Y','18','021','EC','A','','','AC','0000166398','0000166398','OH00002330471','IL','1','Daywalt','William','','','','34','288566960','5818 S WRIGHT ST',0,'KINGSVILLE','OH','44048','5805','CY','39007','1955-11-21','M','U',':RET:2106-3','N','021','HLT','2889058','52664OH151001305','2014-02-01','2014-01-15 14:03:04','549.00',NULL,NULL,'640.87','91.87','R-OH011','OH0','640.87',NULL,0,'2014-01-16 08:46:23'),(26824,21259,'Y','18','021','EC','A','','','AC','0000604760','0000604760','OH00003494458','IL','1','maritim','lynn','','','','34','699389751','4187 APPIAN WAY W',0,'GAHANNA','OH','43230','1411','CY','39049','1987-11-26','F','U',':RET:2054-5','N','021','DEN','3199466','99734OH005000401','2014-04-01','2014-03-01 12:34:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:36'),(28815,22805,'N','19','021','EC','A',NULL,NULL,'','0000559505','0000739087','','IL','1','CALVERT','HALEY','A','','','34','273988456','5321 DONNER DRIVE',0,'NEW FRANKLIN','OH','44216',NULL,'CY','39153','1994-10-05','F','',':RET:2106-3','N','021','HLT','3871781','52664OH151001304','2014-04-01','2014-03-09 15:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-09 21:00:56'),(28988,22944,'Y','18','021','EC','A','','','AC','0000541712','0000541712','OH00002919584','IL','1','ROZZI','PETER','J','','III','34','271880077','17666 REDWOOD RD',0,'LAKE MILTON','OH','44429','9732','CY','39099','1987-10-21','M','U',NULL,'N','021','HLT','3962141','52664OH151001306','2014-04-01','2014-03-10 14:42:59','207.00',NULL,NULL,'258.96','51.96','R-OH013','OH0','258.96',NULL,0,'2014-03-10 21:01:12'),(29000,22951,'Y','18','021','EC','A','','','AC','0000995502','0000995502','OH00002810673','IL','1','Steinmetz','Stephen','','','','34','279648220','1621 W TOWNSHIP ROAD 198',0,'TIFFIN','OH','44883','8846','CY','39147','1961-01-29','M','U',':RET:2106-3','N','021','HLT','4023928','92036OH004002701','2014-04-01','2014-03-10 15:01:08','198.00',NULL,NULL,'319.86','121.86','R-OH006','OH0','319.86',NULL,0,'2014-03-10 21:01:18'),(357,294,'Y','18','021','EC','A','','','AC','0000110495','0000110495','OH00000428741','IL','1','hopwood','william','','','','34','287425325','210 N MAIN ST',0,'DAYTON','OH','45402','1252','CY','39113','1957-06-05','M','U',':RET:2106-3','N','021','HLT','594232','92036OH006000501','2014-01-01','2013-12-03 18:15:06','0.00',NULL,NULL,'439.80','439.80','R-OH003','OH0','439.80',NULL,0,'2013-12-25 17:45:03'),(14514,11580,'Y','18','021','EC','A','','','AC','0000230645','0000230645','TX00001008662','IL','1','Ramirez De Finley','Dora','A','','','34','446084369','602 W PICKENS AVE',0,'HARLINGEN','TX','78550','4246','CY','48061','1971-11-05','F','M',':RET:2106-3','N','021','DEN','2212249','33348TX002000201','2014-02-01','2013-12-27 16:14:30','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-28 03:34:08'),(14429,11507,'Y','18','021','EC','A','','','AC','0001922552','0001922552','LA00000093246','31','1','Silas','Jessie','','','','34','587191725','p o box 442',0,'Edgard','LA','70049',NULL,'CY','22095','1962-03-09','M','U',':RET:2054-5','N','021','DEN','1423693','18575LA002000201','2014-02-01','2013-12-26 19:11:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:31:53'),(18727,14926,'Y','18','021','EC','A','','','AC','0000060293','0000060293','OH00002236352','IL','1','Moseley','Claire','','','','34','410655890','5178 CONCORD CROSSING DR',0,'MASON','OH','45040','3608','CY','39165','1987-04-30','F','U',':RET:2106-3','T','021','DEN','2689230','99734OH005000301','2014-02-01','2014-01-15 23:46:43','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:36'),(13779,10997,'N','01','021','EC','A',NULL,NULL,'','0001076610','0000014961','','IL','1','Scallions','Diane',NULL,NULL,NULL,NULL,NULL,'1332 SUDDUTH RD',0,'STEENS','MS','39766','9665','CY','28087','1974-09-22','F','',':RET:2106-3','N','021','DEN','1614235','46300MS002000201','2014-01-01','2013-12-23 15:28:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:41'),(16652,13323,'Y','18','021','EC','A','','','AC','0000746846','0000746846','MS00002255098','IL','1','Aurelia','Thomas','','','','34','165440298','499 Springridge Road',0,'Clinton','MS','39056',NULL,'CY','28049','1953-05-05','M','U',':RET:2106-3','T','021','DEN','1925563','46300MS002000201','2014-02-01','2014-01-07 11:08:09','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-08 18:24:21'),(2841,2296,'Y','18','021','EC','A','','','AC','0001119922','0001119922','OH00000709211','IL','1','conn','joseph','','','','34','273765901','5507 KAREN AVE',0,'CINCINNATI','OH','45248','5200','CY','39061','1964-01-16','M','U',':RET:2106-3','T','021','DEN','664588','99734OH005000401','2014-01-01','2013-11-24 15:46:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:01:03'),(6833,5416,'Y','18','021','EC','A','','','AC','0000383328','0000383328','OH00000295758','IL','1','Gound','Jessica','','','','34','438512625','5710 Meister Road',0,'Mentor','OH','44060',NULL,'CY','39085','1981-02-02','F','U',':RET:2106-3','N','021','DEN','983447','99734OH005000401','2014-01-01','2013-11-14 09:09:44','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:30:51'),(27956,22116,'Y','18','021','EC','A','','','AC','0001461633','0001461633','LA00002826051','IL','1','JAMES','SHARON','','','','34','439511137','732 south lewis',0,'new iberia','LA','70560',NULL,'CY','22045','1981-12-25','F','U',':RET:2054-5','N','021','DEN','3498915','18575LA002000201','2014-04-01','2014-03-05 18:10:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-03-06 21:00:41'),(14165,11292,'Y','18','021','EC','A','','','AC','0001814415','0001814415','LA00000822138','IL','1','ACHORD','SHARRON','','','','34','225826125','2846 COOPER RD',0,'BOGALUSA','LA','70427','7644','CY','22117','1953-12-05','F','M',':RET:2106-3','N','021','DEN','2475573','18575LA002000201','2014-02-01','2013-12-26 16:48:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:03:16'),(13825,11035,'Y','18','021','EC','A','','','AC','0001255026','0001255026','OH00000523001','IL','1','Fox','Candace','','','','34','298822025','8329 AVERY RD',0,'BROADVIEW HTS','OH','44147','1651','CY','39035','1985-03-13','F','U',':RET:2106-3','N','021','HLT','2330736','52664OH152000901','2014-01-01','2013-12-23 01:34:47','180.00',NULL,NULL,'200.25','20.25','R-OH011','OH0','200.25',NULL,0,'2013-12-26 13:11:59'),(5924,4691,'Y','18','021','EC','A','','','AC','0001235321','0001235321','TX00000441827','31','1','Hunsaker','Heather',NULL,NULL,NULL,NULL,NULL,'P.O. Box 80911',0,'Austin','TX','78708',NULL,'CY','48491','1983-11-19','F','U',':RET:2106-3','N','021','DEN','2268684','33348TX002000101','2014-01-01','2013-12-24 01:05:41','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 23:50:21'),(8166,6461,'Y','18','021','EC','A','','','AC','0001047966','0001047966','OH00000791431','IL','1','Lawrence','Brandie','','','','34','271806443','226 GARFIELD AVE',0,'FINDLAY','OH','45840','4630','CY','39063','1981-06-29','F','U',':RET:2106-3','T','021','HLT','598555','92036OH005001506','2014-01-01','2013-11-22 11:24:02','200.00',NULL,NULL,'299.42','99.42','R-OH002','OH0','299.42',NULL,0,'2013-12-26 03:16:30'),(7591,6006,'Y','18','021','EC','A','','','AC','0000847122','0000847122','OH00001246269','IL','1','Emig','David','','','','34','287861450','5746 LAWRENCE RD',0,'CINCINNATI','OH','45248','4120','CY','39061','1972-09-21','M','U',':RET:2106-3','T','021','DEN','854961','99734OH005000401','2014-01-01','2013-11-17 07:28:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:45:09'),(8093,6408,'Y','18','021','EC','A','','','AC','0000230429','0000230429','OH00000288944','IL','1','Miller','Timothy','','','','34','300807095','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1965-12-24','M','M',':RET:2106-3','N','021','HLT','2479133','52664OH151001501','2014-01-01','2013-12-20 15:42:29','213.00',NULL,NULL,'1320.48','1107.48','R-OH012','OH0','437.31',NULL,0,'2013-12-26 03:10:46'),(8028,6355,'Y','18','021','EC','A','','','AC','0000546901','0000546901','MS00000138040','IL','1','Pittman','Verkista','','','','34','428530129','2633 KAY WHITE CIR',0,'GREENWOOD','MS','38930','7204','CY','28083','1983-06-19','F','U',':RET:2054-5','N','021','DEN','1691977','46300MS002000101','2014-01-01','2013-12-19 21:43:46','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 03:09:04'),(3995,3190,'Y','18','021','EC','A','','','AC','0001100581','0001100581','OH00000641585','IL','1','Dunham','Scott','','','','34','294525297','409 Probasco St Apt 4',0,'Cincinnati','OH','45220',NULL,'CY','39061','1953-06-28','M','U',':RET:2106-3','N','021','HLT','403132','92036OH002001201','2014-01-01','2013-12-13 15:59:00','366.00',NULL,NULL,'672.81','306.81','R-OH004','OH0','672.81',NULL,0,'2013-12-25 21:39:14'),(3737,2988,'Y','18','021','EC','A','','','AC','0000396025','0000396025','TX00000023834','IL','1','Wilson','Bobbie',NULL,NULL,NULL,NULL,NULL,'2005 NW 20th',0,'Amarillo','TX','79107',NULL,'CY','48375','1949-03-27','F','M',':RET:2054-5','N','021','DEN','769326','33348TX002000201','2014-01-01','2013-12-13 11:30:47','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-25 21:32:46'),(20151,16080,'Y','18','021','EC','A','','','AC','0000317366','0000317366','OH00001704400','IL','1','Doyle','Brian','','','','34','275884283','20 HERON DR',0,'AMELIA','OH','45102','1776','CY','39025','1987-08-28','M','U',':RET:2106-3','T','021','DEN','3325141','99734OH005000301','2014-03-01','2014-01-26 20:45:20','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-01-27 21:01:04'),(21146,16897,'Y','18','021','EC','A','','','AC','0000904931','0000904931','TX00001775821','IL','1','Tobar','Ester','','','','34','454087790','1100 RUNNELS ST',0,'BIG SPRING','TX','79720','4337','CY','48227','1952-01-27','F','U',NULL,'N','021','DEN','3729153','33348TX002000201','2014-03-01','2014-02-03 17:58:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:25'),(21543,17208,'Y','18','021','EC','A','','','AC','0000964659','0000964659','OH00001916385','IL','1','SCOTT','RAYMONE','','','','34','285787390','1020 JEFFERSON AVE',0,'AKRON','OH','44302',NULL,'CY','39153','1976-09-22','M','U',':RET:2054-5','N','021','DEN','3397413','99734OH005000401','2014-03-01','2014-02-05 09:19:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-05 21:30:10'),(21714,17339,'Y','18','021','EC','A','','','AC','0000137611','0000137611','OH00001865503','IL','1','WILSON','CHARLES','','','','34','562398205','2221 IVY LN',0,'FINDLAY','OH','45840','7507','CY','39063','1964-11-11','M','U',':RET:2106-3','N','021','HLT','3141956','92036OH005001506','2014-03-01','2014-02-05 12:06:57','339.00',NULL,NULL,'375.47','36.47','R-OH002','OH0','375.47',NULL,0,'2014-02-05 21:31:16'),(27336,21645,'N','01','021','EC','A',NULL,NULL,'','0001235244','0000392425','','IL','1','WHITESIDE','AMBER','','','','34','274945972','290 ALTAMONT RD',0,'VERMILION','OH','44089','2208','CY','39093','1988-08-13','F','',NULL,'N','021','DEN','3581909','99734OH005000401','2014-04-01','2014-03-04 08:22:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:00:55'),(28434,22499,'N','19','021','EC','A',NULL,NULL,'','0000547943','0000949587','','IL','1','Serio','Alainah','','','','34','284117474','404 Webb St',0,'Saint Marys','OH','45885',NULL,'CY','39011','2005-08-15','F','',':RET:2106-3','N','021','HLT','3747252','92036OH003001505','2014-04-01','2014-03-06 18:37:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-03-07 21:31:10'),(28531,22580,'Y','18','021','EC','A','','','AC','0001394769','0001394769','LA00003351244','31','1','Haskins','Justin','','','','34','435857237','37426 Larry Bennett rd',0,'Pearl River','LA','70452',NULL,'CY','22103','1991-08-29','M','U',':RET:2106-3','T','021','DEN','3302331','18575LA002000101','2014-04-01','2014-03-07 12:56:27','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-07 21:32:07'),(28996,22949,'N','19','021','EC','A',NULL,NULL,'','0000177685','0000396216','','IL','1','campton','Andrew','','','','34','289987066','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1995-09-26','M','',NULL,'N','021','HLT','4056302','92036OH003000601','2014-04-01','2014-03-09 18:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-10 21:01:16'),(8042,6367,'Y','18','021','EC','A','','','AC','0000067665','0000067665','OH00000482672','IL','1','Minnich Young','Shannon','','','','34','284741839','6552 Wise Ave NW',0,'North Canton','OH','44720',NULL,'CY','39151','1974-03-07','F','M',':RET:2106-3','N','021','HLT','1650675','52664OH152000901','2014-01-01','2013-12-20 14:29:18','21.00',NULL,NULL,'409.66','388.66','R-OH015','OH0','206.14',NULL,0,'2013-12-26 03:09:26'),(18683,14894,'Y','18','021','EC','A','','','AC','0000678645','0000678645','TX00001947926','IL','1','Zander','James','F','','','34','455909808','1402 BULLARD ST',0,'CISCO','TX','76437','3218','CY','48429','1953-12-10','M','U',':RET:2106-3','N','021','DEN','2402083','33348TX002000201','2014-02-01','2014-01-15 20:27:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:21'),(18112,14466,'N','01','021','EC','A',NULL,NULL,'','0001416166','0002390644','','IL','1','flores','paula','','','','34','731169675','10860 LETON DR',0,'BATON ROUGE','LA','70816','4126','CY','22033','1955-06-19','F','',NULL,'N','021','DEN','1942708','18575LA002000201','2014-02-01','2014-01-14 18:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:37'),(16818,13452,'Y','18','021','EC','A','','','AC','0000304124','0000304124','TX00001953866','IL','1','Beltran','Dawn','','','','34','453259364','4636 ALBATROSS DR',0,'GRANBURY','TX','76049','1255','CY','48221','1971-12-27','F','M',':RET:2106-3','N','021','DEN','1706634','33348TX002000101','2014-02-01','2014-01-10 19:43:12','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-01-13 02:18:20'),(16708,13371,'N','01','021','EC','A',NULL,NULL,'','0000369491','0000621556','','IL','1','Brassfield','Troy','L','','','34','440845571','810 Denver Ave',0,'Dalhart','TX','79022',NULL,'CY','48111','1979-06-13','M','',':RET:2106-3','N','021','DEN','2542684','33348TX002000201','2014-02-01','2014-01-06 22:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-08 18:24:41'),(13818,11030,'Y','18','021','EC','A','','','AC','0000920810','0000920810','OH00000072008','IL','1','Eckroad','Scott','','','','34','298828128','5608 SNOW RD',0,'PARMA','OH','44129','3316','CY','39035','1983-03-24','M','M',':RET:2106-3','N','021','HLT','2045629','92036OH005000801','2014-01-01','2013-12-23 18:15:03','0.00',NULL,NULL,'265.37','265.37','R-OH011','OH0','265.37',NULL,0,'2013-12-26 13:11:48'),(14341,11440,'N','01','021','EC','A',NULL,NULL,'','0000751023','0000593689','','IL','1','Moore','Randy','','','Jr','34','275865580','408 N WALNUT ST',0,'VAN WERT','OH','45891','1229','CY','39161','1973-09-12','M','',':RET:2106-3','T','021','HLT','2500992','92036OH003001504','2014-02-01','2013-12-26 16:59:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','337.79',NULL,0,'2013-12-27 02:07:53'),(13870,11066,'Y','18','021','EC','A','','','AC','0000393665','0000393665','OH00001297457','IL','1','Watkins','Angela','','','','34','595262800','5067 S HAMETOWN RD',0,'NORTON','OH','44203','5918','CY','39153','1968-12-25','F','M',':RET:2106-3','N','021','HLT','2184641','52664OH151001501','2014-01-01','2013-12-23 13:00:37','200.00',NULL,NULL,'386.22','186.22','R-OH012','OH0','386.22',NULL,0,'2013-12-26 13:13:02'),(20184,16108,'Y','18','021','EC','A','','','AC','0000533968','0000533968','TX00001655850','IL','1','samaha','muhammad','','','','34','443763155','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','1961-05-20','M','M',':RET:2106-3','N','021','DEN','2702806','33348TX002000101','2014-03-01','2014-01-27 00:47:11','0.00',NULL,NULL,'148.50','148.50','R-TX008','TX0','27.15',NULL,0,'2014-01-27 21:01:23'),(20967,16754,'N','01','021','EC','A',NULL,NULL,'','0001251842','0000827053','','IL','1','NORIEGA GONZALEZ','JOHANA','ELIZABETH','','','34','627084225','2205 CUELLAR CT',0,'LAREDO','TX','78040','1010','CY','48479','1980-02-19','F','',NULL,'N','021','DEN','3345620','33348TX002000201','2014-03-01','2014-02-01 12:16:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-01 19:00:12'),(26363,20911,'Y','18','024','14','A','','','TE','0000022832','0000022832','','IL','1','barnett','wendy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-08-31','F','',NULL,NULL,NULL,'','2681973','','2014-03-31','2014-02-26 13:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:06'),(27220,21553,'Y','18','021','EC','A','','','AC','0000479643','0000479643','MS00003330280','IL','1','Martin','Michael','K','','','34','587537361','812 STONEWALL ST',0,'JACKSON','MS','39213','7066','CY','28049','1970-01-02','M','U',':RET:2054-5','N','021','DEN','3777750','46300MS002000201','2014-04-01','2014-03-03 13:27:38','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:34'),(972,796,'Y','18','021','EC','A','','','AC','0000390845','0000390845','LA00000067270','IL','1','Watts','Carla','','','','34','438395559','17555 Breman Drive',0,'Baton Rouge','LA','70817',NULL,'CY','22033','1965-04-25','F','U',NULL,'N','021','DEN','1200316','18575LA002000201','2014-01-01','2013-10-28 20:24:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:10:02'),(1648,1377,'Y','18','021','EC','A','','','AC','0000167583','0000167583','TX00000141953','IL','1','HOLGUIN','JOSE','','','','34','452967858','303 E 3RD ST',0,'PECOS','TX','79772','3237','CY','48389','1950-03-04','M','U',':RET:2106-3','N','021','DEN','1799405','33348TX002000201','2014-01-01','2013-12-24 15:54:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:17'),(2884,2331,'Y','18','021','EC','A','','','AC','0000187428','0000187428','OH00000341320','IL','1','Vaughn','Ieasha','','','','34','281787908','1800 FOREST OAK LN',0,'COLUMBUS','OH','43229','8811','CY','39049','1980-12-08','F','U',NULL,'N','021','DEN','504514','99734OH005000301','2014-01-01','2013-10-08 12:05:28','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:02:19'),(8069,6390,'Y','18','021','EC','A','','','AC','0000708927','0000708927','OH00001262527','IL','1','wheeler','garrett','','','','34','281788466','8743 W BANCROFT ST',0,'TOLEDO','OH','43617','1909','CY','39095','1981-09-27','M','U',':RET:2106-3','N','021','HLT','2214342','92036OH006002601','2014-01-01','2013-12-20 14:44:37','0.00',NULL,NULL,'182.95','182.95','R-OH001','OH0','182.95',NULL,0,'2013-12-26 03:10:09'),(4158,3313,'N','19','021','EC','A',NULL,NULL,'','0000930898','0000108138','','IL','1','NAKKA','JOSHUA','','','','34','294116658','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','2006-02-22','M','',':RET:2029-7','N','021','DEN','1675008','99734OH005000301','2014-01-01','2013-12-17 15:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:56'),(22309,17810,'Y','18','021','EC','A','','','AC','0000633304','0000633304','MS00001909150','IL','1','Rias','Damein','','','','34','425350478','1140 W NORTHSIDE DR',0,'CLINTON','MS','39056','3042','CY','28049','1971-06-18','M','U',':RET:2054-5','T','021','DEN','3211472','46300MS002000201','2014-03-01','2014-01-24 11:31:38','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 11:00:43'),(23632,18818,'Y','18','021','EC','A','','','AC','0000197865','0000197865','TX00001784999','IL','1','Coulter','Vanessia','','','','34','450298265','685 NW 5th Avenue',0,'Paris','TX','75460',NULL,'CY','48277','1960-11-05','F','U',NULL,'N','021','DEN','2841483','33348TX002000201','2014-03-01','2014-02-13 18:19:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:03'),(27777,21967,'Y','18','021','EC','A','','','AC','0001022850','0001022850','OH00002930163','IL','1','Sponza','Peggy','','','','34','294504521','1622 STINE RD',0,'PENINSULA','OH','44264','9504','CY','39153','1952-03-11','F','U',':RET:2106-3','T','021','HLT','3807449','52664OH152000901','2014-04-01','2014-03-05 10:33:30','389.00',NULL,NULL,'539.67','150.67','R-OH012','OH0','539.67',NULL,0,'2014-03-05 21:31:31'),(27896,22069,'Y','18','021','EC','A','','','AC','0000469601','0000469601','OH00003338509','IL','1','Bryant','Patricia','','','','34','285502681','2756 ISLAND CREEK RD',0,'WEST UNION','OH','45693','9504','CY','39001','1951-07-30','F','U',NULL,'N','021','HLT','3793114','92036OH003000605','2014-04-01','2014-03-05 14:56:57','535.00',NULL,NULL,'644.07','109.07','R-OH005','OH0','644.07',NULL,0,'2014-03-05 21:32:42'),(28126,22258,'N','19','021','EC','A',NULL,NULL,'','0000854261','0000318472','','IL','1','Hicks','Kimani','M','','','34','298155875','2504 state rd',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','2010-07-04','F','',':RET:2054-5^:RET:2106-3','N','021','HLT','3491334','52664OH151001306','2014-04-01','2014-03-06 10:17:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-06 21:02:22'),(474,387,'Y','18','021','EC','A','','','AC','0000191713','0000191713','LA00001294409','IL','1','PERCY','SUSAN','','','','34','583861231','15247 POINT CHENIER AVENUE',0,'BATON ROUGE','LA','70817',NULL,'CY','22033','1953-10-24','F','U',':RET:2106-3','N','021','DEN','1003670','18575LA002000201','2014-01-01','2013-12-03 20:01:04','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:47:57'),(1279,1057,'Y','18','021','EC','A','','','AC','0001042258','0001042258','OH00000122183','IL','1','Schornik','Amanda','','','','34','288802060','16534 N Red Rock Dr',0,'Strongsville','OH','44136',NULL,'CY','39035','1980-04-05','F','U',':RET:2106-3','N','021','DEN','639255','99734OH005000401','2014-01-01','2013-11-28 21:23:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:30:30'),(17263,13811,'Y','18','021','EC','A','','','AC','0000532122','0000532122','OH00001522732','IL','1','POPOLIZIO','LEAH','','','','34','073764455','8988 W 130TH ST',0,'STRONGSVILLE','OH','44136',NULL,'CY','39035','1981-07-11','F','R',':RET:2106-3','N','021','DEN','1395674','99734OH005000301','2014-02-01','2014-01-10 09:15:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:23:17'),(16012,12816,'Y','18','024','14','A','','','TE','0001284858','0001284858','','IL','1','Mitchell','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-10-06','F','',NULL,NULL,NULL,'','1373505','','2014-01-02','2014-01-02 20:53:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-04 02:01:52'),(14696,11733,'N','01','021','EC','A',NULL,NULL,'','0001105545','0000731205','','IL','1','Gooch','Sacha','','','','34','290885103','5221 LEONA DR',0,'CINCINNATI','OH','45238','3727','CY','39061','1984-06-11','F','',NULL,'N','021','DEN','1709837','99734OH005000401','2014-02-01','2013-12-27 22:33:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:08:56'),(9796,7757,'Y','18','021','EC','A','','','AC','0000563799','0000563799','TX00001245067','IL','1','ALDANA','ORLANDO','','','','34','609689457','12489 MARTIN BAUMAN DR',0,'EL PASO','TX','79928','1740','CY','48141','1972-11-05','M','U',NULL,'N','021','DEN','807935','33348TX002000201','2014-01-01','2013-10-20 19:23:05','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 05:01:07'),(4932,3913,'Y','18','021','EC','A','','','AC','0000849415','0000849415','OH00000584528','IL','1','burns','nancy','lynn','','','34','287680368','1050 N MAIN ST',0,'FRANKLIN','OH','45005','1653','CY','39165','1964-04-30','F','M',':RET:2106-3','N','021','DEN','1221106','99734OH005000401','2014-01-01','2013-12-07 12:13:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:45:28'),(4107,3282,'Y','18','021','EC','A','','','AC','0000436764','0000436764','TX00000952547','IL','1','Toliver','Harlan','Keith','','','34','460233074','5333 Richmond Ave.',0,'Houston','TX','77056',NULL,'CY','48201','1963-11-01','M','U',':RET:2054-5','N','021','DEN','1800433','33348TX002000101','2014-01-01','2013-12-17 15:19:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 21:47:54'),(20190,16111,'Y','18','021','EC','A','','','AC','0001036762','0001036762','TX00001967829','IL','1','gibson','jackie','','','','34','461216634','1124 TIMBERLINE ST',0,'WACO','TX','76705','2218','CY','48309','1958-11-07','F','U',':RET:2054-5','N','021','DEN','2282601','33348TX002000101','2014-03-01','2014-01-27 14:40:36','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2014-01-27 21:01:26'),(21411,17113,'Y','18','021','EC','A','','','AC','0000243775','0000243775','OH00001496078','IL','1','Mirtallo','Taylor','','','','34','286909721','972 CHAMBERS CIR',0,'COLUMBUS','OH','43212','1301','CY','39049','1984-08-27','M','U',NULL,'N','021','DEN','3508055','99734OH005000401','2014-03-01','2014-02-04 15:50:01','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:01:08'),(24472,19440,'Y','18','021','EC','A','','','AC','0000882895','0000882895','OH00001782517','IL','1','Coger','Terry','','','','34','297446259','10018 DOWLING RD',0,'BOWLING GREEN','OH','43402','9684','CY','39173','1951-03-01','M','M',':RET:2106-3','N','021','HLT','2959571','92036OH004002601','2014-04-01','2014-02-18 13:44:57','0.00',NULL,NULL,'462.84','462.84','R-OH001','OH0','462.84',NULL,0,'2014-02-18 22:01:39'),(25175,19969,'Y','18','024','14','A','','','TE','0000573025','0000573025','','IL','1','Metcalf','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-20','M','',NULL,NULL,NULL,'','227645','','2014-03-07','2014-02-20 19:19:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-21 22:00:30'),(26652,21130,'Y','18','021','EC','A','','','AC','0000976793','0000976793','OH00002369142','IL','1','Christy','Angela','','','','34','284826023','8161 Cooley Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1982-12-10','F','U',':RET:2106-3','N','021','HLT','3502526','52664OH151001305','2014-04-01','2014-02-28 13:43:52','399.00',NULL,NULL,'683.30','284.30','R-OH012','OH0','258.47',NULL,0,'2014-02-28 21:31:08'),(87,76,'Y','18','021','EC','A','','','AC','0000694664','0000694664','TX00000618617','IL','1','King','Dianne','','','','34','227744597','1650 PRICKLY PEAR DR',0,'NEW BRAUNFELS','TX','78130','3248','CY','48091','1949-12-27','F','U',':RET:2106-3','N','021','DEN','372818','33348TX002000201','2014-01-01','2013-12-04 18:32:18','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 17:17:20'),(4856,3847,'Y','18','021','EC','A','','','AC','0000491840','0000491840','OH00000933963','IL','1','Samons','Beverly','','','','34','299641467','437 S. Woodlawn Ave',0,'Lima','OH','45805',NULL,'CY','39003','1959-09-22','F','U',':RET:2106-3','N','021','HLT','16030','92036OH003001504','2014-01-01','2013-11-08 07:13:05','362.00',NULL,NULL,'490.70','128.70','R-OH002','OH0','490.70',NULL,0,'2013-12-25 22:30:31'),(2007,1646,'Y','18','021','EC','A','','','AC','0001200859','0001200859','OH00000250688','IL','1','MYERS','THOMAS','R','','','34','282581139','3920 W BREESE RD',0,'LIMA','OH','45806','1204','CY','39003','1956-09-25','M','U',':RET:2106-3','T','021','HLT','781527','92036OH003001505','2014-01-01','2013-11-20 13:20:32','438.00',NULL,NULL,'644.14','206.14','R-OH002','OH0','644.14',NULL,0,'2013-12-25 19:02:23'),(29167,23087,'Y','18','021','EC','A','','','AC','0000061386','0000061386','OH00002708988','IL','1','Bates','roger','','','','34','299501252','505 MERRIMAK DR',0,'BEREA','OH','44017','2242','CY','39035','1951-05-01','M','M',':RET:2106-3','N','021','HLT','3522270','92036OH003000801','2014-04-01','2014-03-10 14:28:56','0.00',NULL,NULL,'701.46','701.46','R-OH011','OH0','701.46',NULL,0,'2014-03-10 21:02:57'),(786,648,'Y','18','024','14','A','','','TE','0000838399','0000838399','','IL','1','Leavell','Scott','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-11-28','M','',NULL,NULL,NULL,'','486821','','2013-12-16','2013-12-16 15:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:05:11'),(16727,13387,'Y','18','021','EC','A','','','AC','0001069335','0001069335','OH00001413116','IL','1','McBryer','Rhonda','','','','34','298543688','1676 AMBRE DR',0,'AKRON','OH','44312','4357','CY','39153','1953-09-05','F','M',':RET:2106-3','N','021','HLT','2112692','52664OH151001306','2014-02-01','2014-01-07 14:02:27','489.00',NULL,NULL,'605.24','116.24','R-OH012','OH0','605.24',NULL,0,'2014-01-08 18:24:48'),(15244,12184,'Y','18','024','14','A','','','TE','0000672757','0000672757','','IL','1','Hull','valerie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-11-03','F','',NULL,NULL,NULL,'','2277910','','2013-12-30','2013-12-30 16:48:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:08:43'),(9689,7674,'Y','18','021','EC','A','','','AC','0000694188','0000694188','OH00001011864','IL','1','Scott','Janell','Renee','','','34','283649217','340 E HARDIN ST',0,'FINDLAY','OH','45840','4964','CY','39063','1973-08-31','F','U',':RET:2106-3','N','021','HLT','1734806','92036OH005001505','2014-01-01','2013-12-21 12:43:13','193.00',NULL,NULL,'281.27','88.27','R-OH002','OH0','281.27',NULL,0,'2013-12-26 04:39:39'),(9319,7388,'N','01','021','EC','A',NULL,NULL,'','0001183184','0001935560','','IL','1','Cooper','James','Henry','','Sr','34','434948913','214 CHARLOTTE ST',0,'MONROE','LA','71202','3906','CY','22073','1955-12-15','M','',':RET:2054-5','N','021','DEN','1788364','18575LA002000101','2014-01-01','2013-12-21 13:31:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 04:30:28'),(20668,16516,'Y','18','021','EC','A','','','AC','0001181861','0001181861','MS00001970316','IL','1','GREENFIELD','SEVILLE','','','','34','427311465','1071 MACLEAN DR',0,'JACKSON','MS','39209','9716','CY','28049','1992-03-08','M','U',NULL,'N','021','DEN','2810390','46300MS002000201','2014-03-01','2014-01-30 10:32:33','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-30 21:00:48'),(26574,21070,'Y','18','021','EC','A','','','AC','0001121454','0001121454','OH00003297858','IL','1','Capotosto','Elizabeth','','','','34','293681683','2589 W ELM ST',0,'LIMA','OH','45805','2544','CY','39003','1958-06-08','F','U',':RET:2106-3','N','021','DEN','3607412','99734OH005000401','2014-04-01','2014-02-28 12:39:43','0.00',NULL,NULL,'50.05','50.05','R-OH002','OH0','0.00',NULL,0,'2014-02-28 21:30:27'),(26865,21292,'Y','18','021','EC','A','','','AC','0000458406','0000458406','TX00003166952','IL','1','Chavarria','Deborah','','','','34','451557870','400 FAIRFIELD DR',0,'KYLE','TX','78640','4616','CY','48209','1974-01-14','F','R',':RET:2106-3','N','021','DEN','3451216','33348TX002000101','2014-04-01','2014-03-01 12:11:30','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-01 21:00:59'),(27069,21432,'N','01','021','EC','A',NULL,NULL,'','0001690505','0002148443','','IL','1','WEBB','ARLEAN','','','','34','434433336','3557 ASH ST',0,'ZACHARY','LA','70791','2957','CY','22033','1957-03-25','F','',':RET:2054-5','N','021','DEN','3290780','18575LA002000201','2014-04-01','2014-03-03 15:32:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-03 21:30:04'),(3968,3170,'N','01','021','EC','A',NULL,NULL,'','0000951775','0001086766','','IL','1','Cickovskis','Carmen','Anita','','','34','285583364','3440 W SPRAGUE RD',0,'PARMA','OH','44134','6378','CY','39035','1954-03-29','F','',':RET:2106-3','T','021','HLT','584244','52664OH151001501','2014-01-01','2013-12-13 16:16:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','903.01',NULL,0,'2013-12-25 21:38:30'),(4323,3434,'Y','18','024','14','A','','','TE','0001242961','0001242961','','IL','1','Whitehead','Helen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-30','F','',NULL,NULL,NULL,'','1880102','','2013-12-17','2013-12-17 10:55:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:52:49'),(17535,14019,'N','01','021','EC','A',NULL,NULL,'','0000844722','0001105556','','IL','1','Champlin','Jeanie','L','','','34','274541740','7394 dawson Road',0,'Cincinnati','OH','45243',NULL,'CY','39061','1953-01-27','F','',':RET:2106-3','N','021','HLT','1458436','92036OH005001205','2014-02-01','2014-01-12 10:44:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2014-01-13 03:01:45'),(16218,12988,'Y','18','021','EC','A','','','AC','0000575937','0000575937','OH00000964218','IL','1','Randolph','Susan','C','','','34','291505103','537 CONSTITUTION SQ',0,'CINCINNATI','OH','45255','3304','CY','39025','1952-07-14','F','U',':RET:2106-3','N','021','DEN','1609688','99734OH005000401','2014-02-01','2014-01-03 20:18:06','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-05 00:01:43'),(9643,7640,'Y','18','021','EC','A','','','AC','0000941634','0000941634','TX00001210716','IL','1','Polk','Deanie','','','','34','459966538','6004 S FM 5',0,'ALEDO','TX','76008','4114','CY','48367','1953-06-29','F','U',':RET:2106-3','N','021','DEN','2600117','33348TX002000101','2014-01-01','2013-12-21 14:07:59','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 04:38:32'),(18861,15023,'Y','18','021','EC','A','','','AC','0001903442','0001903442','LA00002076365','IL','1','Gibbs','sharanda','','','','34','435699260','9889 hooper road',0,'baton rouge','LA','70818',NULL,'CY','22033','1987-12-24','F','U',':RET:2054-5','N','021','DEN','1845759','18575LA002000201','2014-03-01','2014-01-16 00:01:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:20'),(21659,17298,'Y','18','021','EC','A','','','AC','0001442850','0001442850','LA00002284371','IL','1','Odom','Timothy','','','','34','437430313','978 Hwy 583',0,'Rayville','LA','71269',NULL,'CY','22083','1979-11-09','M','U',NULL,'N','021','DEN','3537500','18575LA002000201','2014-03-01','2014-02-05 12:04:00','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-05 21:30:54'),(21950,17528,'N','19','021','EC','A',NULL,NULL,'','0000140332','0000491917','','IL','1','PATEL','KISHAN','J','','','34','276988255','4135 LINCOLN ST E',0,'CANTON','OH','44730','9479','CY','39151','1994-12-17','M','',':RET:2029-7','N','021','DEN','3175502','99734OH005000401','2014-03-01','2014-02-06 20:07:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:20'),(22351,17851,'Y','18','021','EC','A','','','AC','0000024361','0000024361','LA00002675441','IL','1','jones','gerald','','','','34','433353817','1040 st charles ave',0,'new orleans','LA','70130',NULL,'CY','22071','1972-07-21','M','U',':RET:2054-5','N','021','DEN','3333031','18575LA002000201','2014-03-01','2014-02-10 08:53:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-10 21:00:03'),(28555,22599,'N','19','021','EC','A',NULL,NULL,'','0000435371','0000256027','','IL','1','WALTERS','LEIS','G','','','34','292084399','4821 MEREDITH RD',0,'YELLOW SPRINGS','OH','45387','9734','CY','39057','2004-01-15','M','',':RET:2106-3','N','021','HLT','3945359','92036OH006000501','2014-04-01','2014-03-07 12:55:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.71',NULL,0,'2014-03-07 21:32:23'),(28995,22949,'N','19','021','EC','A',NULL,NULL,'','0000177685','0001044539','','IL','1','campton','allyson','','','','34','288021037','635 PENCE RD',0,'seaman','OH','45679',NULL,'CY','39001','1997-11-03','F','',NULL,'N','021','HLT','4056302','92036OH003000601','2014-04-01','2014-03-09 18:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-10 21:01:16'),(665,549,'Y','18','021','EC','A','','','AC','0000433862','0000433862','OH00000684683','31','1','Berry','Laura','M','','','34','302708225','P.O. Box 2485',0,'youngstown','OH','44509',NULL,'CY','39099','1965-09-14','F','M',':RET:2106-3','N','021','DEN','1703099','99734OH005000301','2014-01-01','2013-12-16 08:45:35','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:01:59'),(9131,7242,'Y','18','024','14','A','','','TE','0000375246','0000375246','','IL','1','Bourgeois','Adam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-05-07','M','',NULL,NULL,NULL,'','1141639','','2013-12-18','2013-12-18 12:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 04:07:59'),(1469,1224,'Y','18','021','EC','A','','','AC','0000240353','0000240353','OH00000518173','IL','1','LANE','MICHAEL','','','','34','294507618','3512 WABASH AVE',0,'CINCINNATI','OH','45207',NULL,'CY','39061','1951-06-12','M','U',':RET:2054-5','T','021','DEN','2411506','99734OH005000401','2014-01-01','2013-12-24 09:12:17','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:48:32'),(13841,11045,'Y','18','021','EC','A','','','AC','0000490468','0000490468','OH00000150657','IL','1','Rafferty','James','','','','34','279504293','12036 BASSWOOD AVE NW',0,'UNIONTOWN','OH','44685','9100','CY','39151','1950-08-09','M','R',':RET:2106-3','N','021','HLT','1733839','52664OH152000901','2014-01-01','2013-12-23 13:25:11','0.00',NULL,NULL,'482.18','482.18','R-OH015','OH0','482.18',NULL,0,'2013-12-26 13:12:18'),(4345,3450,'N','19','021','EC','A',NULL,NULL,'','0000878253','0001032596','','S1','1','Schnipke','Terry','','','','34','011793670','3723 road 16',0,'continental','OH','45831',NULL,'CY','39137','2012-09-28','F','',':RET:2106-3','N','021','HLT','1431241','92036OH006001501','2014-01-01','2013-12-17 12:51:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','110.84',NULL,0,'2013-12-25 21:53:21'),(9343,7406,'Y','18','021','EC','A','','','AC','0002326334','0002326334','LA00000952754','IL','1','Abbas','Syed','','','','34','433550983','4148 Montrachet Drive',0,'Kenner','LA','70065',NULL,'CY','22051','1952-07-16','M','M',':RET:2029-7','N','021','DEN','2290437','18575LA002000201','2014-01-01','2013-12-20 21:40:22','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:04'),(2373,1935,'Y','18','021','EC','A','','','AC','0001092102','0001092102','OH00000955937','IL','1','LIPIEC','LARAINE','','','','34','269504177','1621 PENCE PLACE',0,'DAYTON','OH','45432',NULL,'CY','39113','1950-07-19','F','U',':RET:2106-3','N','021','DEN','1140446','99734OH005000401','2014-01-01','2013-12-09 09:33:17','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:32:47'),(3037,2442,'Y','18','021','EC','A','','','AC','0000249094','0000249094','OH00000133476','IL','1','Kelps','Ronald','','','','34','279467552','3108 RATHBURN DR',0,'MEDINA','OH','44256','6451','CY','39103','1949-08-09','M','M',':RET:2106-3','N','021','HLT','699546','52664OH152000901','2014-01-01','2013-12-06 18:09:50','821.00',NULL,NULL,'933.31','112.31','R-OH012','OH0','490.00',NULL,0,'2013-12-25 20:18:34'),(19139,15250,'Y','18','021','EC','A','','','AC','0000660461','0000660461','TX00002496440','IL','1','Fahmy','Manal','','','','34','645462393','2802 CLIFFBROOK DR',0,'CARROLLTON','TX','75007','5709','CY','48121','1961-09-04','F','M',NULL,'N','021','DEN','1640525','33348TX002000201','2014-03-01','2014-01-18 23:55:01','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-21 08:45:28'),(19350,15424,'N','19','021','EC','A',NULL,NULL,'','0000387310','0000720276','','S1','1','McCoy','Andrew','Michael','','','34','295063256','10210 WINSTEAD LN',0,'CINCINNATI','OH','45231','2720','CY','39061','2002-02-09','M','',NULL,'N','021','DEN','3202365','99734OH005000301','2014-03-01','2014-01-21 14:02:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:25'),(24317,19312,'Y','18','021','EC','A','','','AC','0000249489','0000249489','TX00001954702','IL','1','Trevino','Juan','','','','34','351428955','8101 W BUSINESS 83',0,'HARLINGEN','TX','78552','3724','CY','48061','1950-06-03','M','U',':RET:2106-3','N','021','DEN','2938272','33348TX002000201','2014-04-01','2014-02-18 10:27:12','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-18 22:00:06'),(1251,1031,'Y','18','021','EC','A','','','AC','0001031426','0001031426','OH00001115961','IL','1','Poley','Randall','','','','34','290463906','2011 W 25TH ST',0,'LORAIN','OH','44052','4101','CY','39093','1949-08-17','M','M',':RET:2106-3','N','021','HLT','913535','92036OH004000801','2014-01-01','2013-12-03 11:37:58','0.00',NULL,NULL,'563.97','563.97','R-OH011','OH0','563.97',NULL,0,'2013-12-25 18:21:14'),(17257,13808,'N','19','021','EC','A',NULL,NULL,'','0000515851','0000643245','','IL','1','SCHEIENNER','HAROLD','','','III','34','293947075','30387 HILLIARD BLVD',0,'WESTLAKE','OH','44145','3715','CY','39035','1992-01-21','M','',NULL,'N','021','DEN','2460263','99734OH005000301','2014-02-01','2014-01-10 11:19:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:15'),(16859,13489,'Y','18','021','EC','A','','','AC','0000049429','0000049429','TX00002313668','IL','1','OLVERA','JONATHAN','','','','34','386836479','1537 RANDYWOLFF',0,'EL PASO','TX','79935',NULL,'CY','48141','1987-01-21','M','M',NULL,'N','021','DEN','2087687','33348TX002000201','2014-02-01','2014-01-08 22:03:55','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:19:09'),(4297,3418,'Y','18','021','EC','A','','','AC','0001247762','0001247762','MS00001044501','31','1','Flechas','Eduardo','','','','34','425137600','318 South StatevStreet',0,'Jackson','MS','39201',NULL,'CY','28121','1964-09-30','M','M',NULL,'N','021','DEN','1683359','46300MS002000201','2014-01-01','2013-12-17 17:01:13','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:52:16'),(1359,1125,'Y','18','021','EC','A','','','AC','0000752522','0000752522','TX00000724224','IL','1','Hutt','Patricia','','','','34','580199255','3701 EAGLE FLEDGE TER',0,'PFLUGERVILLE','TX','78660','3621','CY','48453','1969-09-25','F','U',NULL,'N','021','DEN','2235604','33348TX002000101','2014-01-01','2013-12-24 13:52:38','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:27'),(15814,12659,'Y','18','021','EC','A','','','AC','0002222126','0002222126','LA00000905788','IL','1','YOUNG','DON','WAYNE','','','34','437086160','17815 LA ARK RD',0,'JONES','LA','71250','9425','CY','22067','1960-10-30','M','U',':RET:2106-3','N','021','DEN','2195076','18575LA002000201','2014-02-01','2014-01-02 17:41:41','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-03 02:03:18'),(2561,2082,'N','01','021','EC','A',NULL,NULL,'','0000055886','0000798394','','IL','1','Bush','Michael','','','','34','291620636','25 SCHONHARDT ST',0,'TIFFIN','OH','44883','2867','CY','39147','1957-05-01','M','',':RET:2106-3','N','021','HLT','338498','92036OH003002706','2014-01-01','2013-12-09 11:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.07',NULL,0,'2013-12-25 19:37:29'),(2056,1685,'Y','18','021','EC','A','','','AC','0001122718','0001122718','OH00000575714','IL','1','Pauley','Brian','','','','34','297786625','9139 LAKE VIEW DR',0,'OLMSTED FALLS','OH','44138','3713','CY','39035','1967-09-25','M','M',':RET:2106-3','N','021','DEN','878456','99734OH005000301','2014-01-01','2013-12-09 20:33:35','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:16:00'),(9759,7728,'N','01','021','EC','A',NULL,NULL,'','0000575880','0000577280','','IL','1','Jones','Kenneth','Lewis','','','34','284483905','6610 GROVE LN',0,'PARMA','OH','44134','6960','CY','39035','1949-10-16','M','',':RET:2106-3','N','021','DEN','481108','99734OH005000401','2014-01-01','2013-10-20 14:26:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:10'),(18539,14784,'Y','18','021','EC','A','','','AC','0000461098','0000461098','MS00002219710','IL','1','Wilson','Jimmy','Lee','','Jr','34','426670839','5060 BELWOOD CT',0,'MOSS POINT','MS','39563','6214','CY','28059','1987-11-26','M','U',':RET:2054-5','N','021','DEN','2784682','46300MS002000101','2014-02-01','2014-01-15 00:09:17','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-16 08:46:47'),(18575,14813,'N','19','021','EC','A',NULL,NULL,'','0000618388','0001083111','','IL','1','Youssefi','Ramin','','','','34','280042169','1216 MAGDALYN DR',0,'AKRON','OH','44320','1426','CY','39153','1998-03-02','M','',':RET:2106-3','N','021','HLT','2686554','52664OH152000901','2014-02-01','2014-01-15 15:43:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-16 08:47:06'),(23355,18611,'Y','18','021','EC','A','','','AC','0000203129','0000203129','OH00002791295','IL','1','Taylor','Jennifer','','','','34','301806612','3608 E STATE ST',0,'BARBERTON','OH','44203','4546','CY','39153','1982-07-12','F','U',':RET:2106-3','N','021','HLT','3476030','52664OH151001305','2014-03-01','2014-02-13 14:11:16','164.00',NULL,NULL,'258.47','94.47','R-OH012','OH0','258.47',NULL,0,'2014-02-13 22:00:43'),(7029,5582,'Y','18','021','EC','A','','','AC','0001262871','0001262871','TX00000543182','31','1','Walker','Alexander','','','','34','645123616','1509 CAMP CRAFT RD',0,'WEST LAKE HILLS','TX','78746','6960','CY','48453','1987-06-15','M','U',':RET:2106-3','N','021','DEN','1561505','33348TX002000201','2014-01-01','2013-12-24 23:21:14','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:49:04'),(17269,13814,'Y','18','021','EC','A','','','AC','0000069093','0000069093','OH00002380429','IL','1','KERNS','LINDA','','','','34','280468696','240 MOORE RD',0,'AKRON','OH','44319','3734','CY','39153','1949-05-30','F','M',':RET:2106-3','T','021','HLT','1399508','52664OH152000901','2014-02-01','2014-01-09 18:52:10','216.00',NULL,NULL,'563.50','347.50','R-OH012','OH0','563.50',NULL,0,'2014-01-13 02:23:20'),(6475,5129,'N','19','021','EC','A',NULL,NULL,'','0000217560','0000148304','','IL','1','Cord','Bethany','','','','34','399294924','741 ABINGTON RD',0,'AKRON','OH','44312','2440','CY','39153','2008-05-22','F','',':RET:2106-3','N','021','HLT','596609','52664OH151001306','2014-01-01','2013-12-10 23:35:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 00:50:12'),(6354,5036,'Y','18','021','EC','A','','','AC','0000625404','0000625404','OH00000687232','IL','1','Browning','Karen','','','','34','287548468','3374 Cole Rd',0,'Amelia','OH','45102',NULL,'CY','39025','1955-10-05','F','M',':RET:2106-3','N','021','DEN','568877','99734OH005000401','2014-01-01','2013-12-11 14:43:28','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 00:47:09'),(14922,11923,'Y','18','021','EC','A','','','AC','0001611547','0001611547','LA00000160973','IL','1','Petties','Alice','','','','34','439023185','12105 Shannon Avenue',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1954-01-15','F','M',':RET:2054-5','N','021','DEN','1940786','18575LA002000101','2014-02-01','2013-12-28 18:58:56','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-30 00:01:43'),(18345,14648,'Y','18','021','EC','A','','','AC','0000234068','0000234068','OH00002114022','IL','1','Damon','David','','','','34','234721817','8068 Quail Meadow Lane',0,'West Chester','OH','45069',NULL,'CY','39017','1950-10-18','M','R',':RET:2106-3','N','021','DEN','1469552','99734OH005000301','2014-02-01','2014-01-14 19:15:21','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:20'),(18570,14809,'Y','18','021','EC','A','','','AC','0000230462','0000230462','OH00002042312','IL','1','zodnik','laura','','','','34','272648267','1254 HERBERICH AVE',0,'AKRON','OH','44301','2227','CY','39153','1956-07-19','F','M',':RET:2106-3','N','021','HLT','2731322','52664OH152000901','2014-02-01','2014-01-15 14:21:18','374.00',NULL,NULL,'398.06','24.06','R-OH012','OH0','398.06',NULL,0,'2014-01-16 08:47:03'),(18600,14829,'Y','18','021','EC','A','','','AC','0000967742','0000967742','MS00002391670','IL','1','RILEY','ANGELA','','','','34','428437222','4527 WHITEHAVEN DR',0,'JACKSON','MS','39204','4151','CY','28049','1965-09-11','F','U',NULL,'N','021','DEN','1408522','46300MS002000201','2014-02-01','2014-01-15 16:52:30','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-16 08:47:18'),(18838,15004,'Y','18','021','EC','A','','','AC','0000430298','0000430298','OH00001462423','IL','1','Steiner','Kay','','','','34','300449617','382 GRANT AVE',0,'MOGADORE','OH','44260','1526','CY','39133','1952-07-29','F','M',NULL,'N','021','HLT','1976208','52664OH151001305','2014-03-01','2014-01-16 12:00:09','485.00',NULL,NULL,'626.65','141.65','R-OH012','OH0','626.65',NULL,0,'2014-01-17 03:36:12'),(19486,15532,'Y','18','021','EC','A','','','AC','0001183755','0001183755','TX00002063543','IL','1','VASQUEZ','MARIA','D','','','34','455834600','2409 ALVAREZ ST',0,'LONGVIEW','TX','75604','9302','CY','48183','1952-11-27','F','M',NULL,'N','021','DEN','3049375','33348TX002000201','2014-03-01','2014-01-22 12:54:56','0.00',NULL,NULL,'29.22','29.22','R-TX013','TX0','14.61',NULL,0,'2014-01-23 03:02:05'),(21380,17087,'Y','18','021','EC','A','','','AC','0000795558','0000795558','OH00002046723','IL','1','Johnson','David','','','','34','372821274','2716 Woodburn Ave',0,'Cincinnati','OH','45206',NULL,'CY','39061','1976-10-17','M','U',':RET:2106-3','T','021','DEN','3737913','99734OH005000401','2014-03-01','2014-02-03 21:22:36','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:00:52'),(21805,17413,'Y','18','021','EC','A','','','AC','0000340331','0000340331','OH00002026637','IL','1','Sowry','Ty','','','','34','283844908','5288 Dibble Rd',0,'Kingsville','OH','44048',NULL,'CY','39007','1978-03-18','M','R',':RET:2106-3','N','021','HLT','3466517','52664OH151001301','2014-03-01','2014-02-06 06:31:41','0.00',NULL,NULL,'307.36','307.36','R-OH011','OH0','307.36',NULL,0,'2014-02-06 21:00:51'),(5879,4663,'N','19','021','EC','A',NULL,NULL,'','0000055919','0000523420','','IL','1','Sandoval','Dana',NULL,NULL,NULL,NULL,NULL,'119 COROLINE DR',0,'SAINT CLAIRSVILLE','OH','43950','1003','CY','39013','1993-11-25','F','',':RET:2106-3','N','021','DEN','2092318','99734OH005000301','2014-01-01','2013-12-23 21:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:22'),(5527,4383,'N','01','021','EC','A',NULL,NULL,'','0001143286','0001176822','','IL','1','Smith','Derek','','','','34','292888856','198 westbrook dr',0,'hamilton','OH','45013',NULL,'CY','39017','1988-03-06','M','',':RET:2106-3','T','021','DEN','224975','99734OH005000401','2014-01-01','2013-11-26 19:38:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:29'),(13786,11003,'Y','18','021','EC','A','','','AC','0000200442','0000200442','MS00000498959','IL','1','COLLINS','CARRIE','M','','','34','587505955','1910 WIGHTMAN ST',0,'JACKSON','MS','39202','1425','CY','28049','1950-02-26','F','U',NULL,'N','021','DEN','1474045','46300MS002000201','2014-01-01','2013-12-23 17:55:30','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:54'),(1797,1476,'Y','18','021','EC','A','','','AC','0000425087','0000425087','OH00001219567','IL','1','Merry','Remington','J','','','34','301821663','7710 Glenbrier Place',0,'Dayton','OH','45459',NULL,'CY','39113','1985-01-18','M','U',':RET:2106-3','N','021','DEN','2588856','99734OH005000301','2014-01-01','2013-12-24 17:16:39','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:56:40'),(269,221,'Y','18','021','EC','A','','','AC','0000750980','0000750980','OH00000421767','IL','1','MCKINNEY','LARRY','H','','','34','299482279','2687 ROUTE 50',0,'BATAVIA','OH','45103',NULL,'CY','39025','1950-09-13','M','U',NULL,'N','021','HLT','8639','92036OH006000601','2014-01-01','2013-12-05 12:56:30','330.00',NULL,NULL,'502.56','172.56','R-OH005','OH0','502.56',NULL,0,'2013-12-25 17:22:01'),(28964,22924,'Y','18','021','EC','A','','','AC','0001499326','0001499326','LA00003247485','IL','1','Jefferson','Craig','J','','','34','434316833','1331 S 17TH ST',0,'BATON ROUGE','LA','70802','5073','CY','22033','1964-01-23','M','U',':RET:2054-5','N','021','DEN','4230446','18575LA002000201','2014-04-01','2014-03-10 14:21:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-10 21:00:58'),(4298,3418,'N','01','021','EC','A',NULL,NULL,'','0001247762','0000941914','','IL','1','Flechas','Caroline','Ashlee','','','34','233021974','502 SIOUX CV',0,'FLOWOOD','MS','39232','8673','CY','28121','1973-11-08','F','',':RET:2106-3','N','021','DEN','1683359','46300MS002000201','2014-01-01','2013-12-17 17:01:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:52:17'),(22257,17764,'Y','18','021','EC','A','','','AC','0000571579','0000571579','TX00001867837','IL','1','Whitfield','Tina','','','','34','464238423','1815 OLD BRANDON RD',0,'HILLSBORO','TX','76645','2700','CY','48217','1953-04-14','F','U',NULL,'N','021','DEN','3118184','33348TX002000201','2014-03-01','2014-02-03 18:06:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:04'),(4026,3214,'Y','18','024','14','A','','','TE','0000607139','0000607139','','IL','1','ruggles','randy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-01','M','',NULL,NULL,NULL,'','2168737','','2013-12-17','2013-12-17 09:06:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:45:47'),(3416,2742,'Y','18','021','EC','A','','','AC','0002328500','0002328500','LA00000051694','IL','1','Bryan','Amy','','','','34','434837555','7127 PARKSIDE CT',0,'NEW ORLEANS','LA','70127','1915','CY','22071','1976-05-28','F','U',':RET:2054-5','N','021','DEN','2099915','18575LA002000201','2014-01-01','2013-12-22 16:19:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:30'),(15802,12649,'Y','18','021','EC','A','','','AC','0001795862','0001795862','LA00001663092','IL','1','Washington','Darlyn','','','','34','434311358','311 WHITE ST',0,'HAMMOND','LA','70403','4861','CY','22105','1968-12-20','F','U',':RET:2054-5','N','021','DEN','1379819','18575LA002000201','2014-02-01','2014-01-02 11:29:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:55'),(4486,3557,'N','19','021','EC','A',NULL,NULL,'','0000912935','0000283237','','IL','1','Williams','Kennedy',NULL,NULL,NULL,NULL,NULL,'2180 ANTHONY DR',0,'FAIRLAWN','OH','44333','2902','CY','39153','2008-10-10','F','',':RET:2054-5','N','021','DEN','922603','99734OH005000301','2014-01-01','2013-12-12 15:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:03:03'),(2863,2313,'Y','18','021','EC','A','','','AC','0000711337','0000711337','OH00000554723','IL','1','vaught','lawrence','d','','','34','235843693','1650 STATE ROUTE 307',0,'AUSTINBURG','OH','44010','9796','CY','39007','1953-01-07','M','M',':RET:2106-3','N','021','DEN','179397','99734OH005000401','2014-01-01','2013-11-02 09:26:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:01:41'),(4230,3368,'Y','18','021','EC','A','','','AC','0001161912','0001161912','TX00000810408','IL','1','FLOWERS','DEBERA','','','','34','466432363','108 JOE BURL LN',0,'LONGVIEW','TX','75603','9121','CY','48183','1963-07-08','F','M',':RET:2054-5','N','021','DEN','1562053','33348TX002000201','2014-01-01','2013-12-17 13:00:47','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 21:50:41'),(25935,20566,'Y','18','021','EC','A','','','AC','0001039380','0001039380','TX00003191865','IL','1','ZENBEJAS','TITO','CESAR','','','34','603038396','2335 FERN BEND LN',0,'KATY','TX','77494','5807','CY','48157','1968-10-26','M','U',NULL,'N','021','DEN','2756500','33348TX002000201','2014-03-01','2014-02-26 16:45:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-26 21:01:28'),(8112,6417,'Y','18','021','EC','A','','','AC','0000517632','0000517632','LA00001071986','IL','1','HOLLOWAY','NANCY','','','','34','438190633','11091 E VIEUX DR',0,'BATON ROUGE','LA','70815',NULL,'CY','22033','1961-03-24','F','U',':RET:2106-3','T','021','DEN','437346','18575LA002000201','2014-01-01','2013-11-22 18:05:19','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:15:02'),(9125,7237,'Y','18','021','EC','A','','','AC','0000816399','0000816399','MS00000621405','IL','1','ANDERSON','NATHAN','','','','34','408042525','70 PIN OAK DR',0,'BYHALIA','MS','38611','8295','CY','28093','1958-08-23','M','M',':RET:2106-3','N','021','DEN','1557504','46300MS002000101','2014-01-01','2013-12-17 19:26:00','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2013-12-26 04:07:50'),(19758,15750,'Y','18','024','14','A','','','TE','0000809647','0000809647','','IL','1','Helinski','Nancy','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-03-22','F','',NULL,NULL,NULL,'','653959','','2014-01-23','2014-01-23 09:43:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 21:01:22'),(9298,7371,'Y','18','021','EC','A','','','AC','0000655787','0000655787','OH00001161951','IL','1','Tucker','Steven','','','','34','295689351','11820 Edgewater Drive',0,'Lakewood','OH','44107',NULL,'CY','39035','1971-10-27','M','U',':RET:2106-3','N','021','HLT','36681','52664OH151001304','2014-01-01','2013-11-30 14:05:09','258.00',NULL,NULL,'333.26','75.26','R-OH011','OH0','333.26',NULL,0,'2013-12-26 04:16:18'),(28858,22837,'Y','18','021','EC','A','','','AC','0000953307','0000953307','OH00003035382','IL','1','Gillespie','Karen','','','','34','272843517','4533 E MIAMI RIVER RD',0,'CLEVES','OH','45002','9540','CY','39061','1970-05-10','F','M',NULL,'N','021','HLT','3518522','92036OH003001205','2014-04-01','2014-03-09 12:31:39','373.00',NULL,NULL,'785.04','412.04','R-OH004','OH0','304.21','CIC',0,'2014-03-09 21:30:01'),(9344,7406,'N','01','021','EC','A',NULL,NULL,'','0002326334','0001377671','','IL','1','Abbas','Farhat','F','','','34','438778749','4148 Montrachet Drive',0,'Kenner','LA','70065',NULL,'CY','22051','1962-05-27','F','',':RET:2029-7','N','021','DEN','2290437','18575LA002000201','2014-01-01','2013-12-20 21:40:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:31:04'),(22604,18053,'Y','18','021','EC','A','','','AC','0001062162','0001062162','OH00001950502','IL','1','VU','THANH','','','','34','291828843','7230 HOSBROOK RD',0,'CINCINNATI','OH','45243','1710','CY','39061','1966-03-06','M','M',NULL,'N','021','HLT','3682085','92036OH001001201','2014-03-01','2014-02-10 14:31:23','174.00',NULL,NULL,'900.10','726.10','R-OH004','OH0','404.73',NULL,0,'2014-02-10 21:32:17'),(7775,6156,'Y','18','021','EC','A','','','AC','0000637287','0000637287','TX00000008837','IL','1','Hamilton','Ruth','','','','34','463138608','8797 Hammerly Blvd',0,'Houston','TX','77880',NULL,'CY','48477','1958-04-01','F','U',':RET:2106-3','N','021','DEN','1628238','33348TX002000201','2014-01-01','2013-12-19 20:25:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:03'),(9058,7187,'Y','18','021','EC','A','','','AC','0000746655','0000746655','TX00001254331','IL','1','evans','roger','','','','34','553904345','4367 SEABROOK DR',0,'SAN ANTONIO','TX','78219','4108','CY','48029','1950-12-17','M','U',NULL,'N','021','DEN','2430652','33348TX002000101','2014-01-01','2013-12-18 10:31:36','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 04:06:16'),(856,709,'N','01','021','EC','A',NULL,NULL,'','0000156918','0000597288','','IL','1','Schumann','Tiffany','','','','34','277889614','14504 State Route 67',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1982-06-22','F','',':RET:2106-3','N','021','HLT','1750982','92036OH005001505','2014-01-01','2013-12-16 12:23:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.08',NULL,0,'2013-12-25 18:07:02'),(24960,19794,'Y','18','021','EC','A','','','AC','0001397433','0001397433','LA00002252386','IL','1','Carney','Farrow','','','','34','438270348','4012 Glen Oaks Drive',0,'Baton Rouge','LA','70811',NULL,'CY','22033','1963-12-14','M','U',':RET:2054-5','N','021','DEN','3495827','18575LA002000201','2014-04-01','2014-02-20 15:59:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 22:00:18'),(24264,19269,'Y','18','021','EC','A','','','AC','0001003152','0001003152','TX00002072828','IL','1','nelson','charles','','','','34','463455742','18060 KELLY CIR',0,'DALLAS','TX','75287','5659','CY','48121','1978-11-10','M','U',':RET:2054-5','N','021','DEN','3077619','33348TX002000101','2014-04-01','2014-02-17 15:23:15','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-17 19:00:12'),(16565,13252,'Y','18','021','EC','A','','','AC','0000427647','0000427647','OH00001951006','IL','1','terrill','alan','','','','34','530683311','421 E DOROTHY LN',0,'KETTERING','OH','45419','1802','CY','39113','1956-11-12','M','M',':RET:2106-3','N','021','HLT','1850226','92036OH006000501','2014-02-01','2014-01-04 20:12:21','740.00',NULL,NULL,'813.88','73.88','R-OH003','OH0','459.42',NULL,1,'2014-01-07 10:23:10'),(21864,17457,'Y','18','021','EC','A','','','AC','0000335190','0000335190','OH00001950416','IL','1','Hull','James','','','','34','302528861','6834 Linton Road',0,'Goshen','OH','45122',NULL,'CY','39025','1952-12-26','M','U',':RET:2106-3','N','021','HLT','3083099','92036OH005000601','2014-03-01','2014-02-06 13:32:33','339.00',NULL,NULL,'603.24','264.24','R-OH005','OH0','603.24',NULL,0,'2014-02-06 21:01:21'),(14682,11722,'Y','18','021','EC','A','','','AC','0001184892','0001184892','OH00001767470','IL','1','SCOTT','DEBRA','','','','34','296545026','2821 COMANCHE DR',0,'DAYTON','OH','45420','3830','CY','39113','1957-07-27','F','U',':RET:2106-3','T','021','DEN','1846605','99734OH005000401','2014-02-01','2013-12-28 12:07:58','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,1,'2013-12-29 11:08:35'),(13305,10622,'Y','18','021','EC','A','','','AC','0000089762','0000089762','TX00000496425','IL','1','van Riper','Carena','','','','34','573936123','1500 Olympia Way',0,'College Station','TX','77840',NULL,'CY','48041','1983-02-27','F','U',':RET:2106-3','N','021','DEN','2102501','33348TX002000201','2014-01-01','2013-12-23 15:22:51','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-26 12:57:54'),(7933,6274,'Y','18','021','EC','A','','','AC','0002066487','0002066487','LA00000015960','IL','1','Williams','Trudy','','','','34','433804674','202 Pine St.',0,'Vidalia','LA','71373',NULL,'CY','22029','1951-02-18','F','M',':RET:2054-5','N','021','DEN','1468705','18575LA002000201','2014-01-01','2013-12-20 10:00:33','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 03:06:41'),(3348,2682,'N','01','021','EC','A',NULL,NULL,'','0001175974','0000931176','','IL','1','Kifou','Rouaa','','','','34','296081693','1001 PONTIAC AVE',0,'LUBBOCK','TX','79416','3812','CY','48303','1974-08-01','F','',':RET:2106-3','N','021','DEN','2534624','33348TX002000201','2014-01-01','2013-12-22 00:55:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:16:40'),(16809,13444,'Y','18','021','EC','A','','','AC','0000751258','0000751258','TX00002007252','IL','1','Carter','Lane','','','','34','590232805','9500 COUNTY ROAD 1201',0,'MALAKOFF','TX','75148','7736','CY','48001','1992-04-07','M','U',':RET:2106-3','N','021','DEN','2494946','33348TX002000201','2014-02-01','2014-01-11 15:16:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:18:15'),(28723,22732,'Y','18','021','EC','A','','','AC','0000012496','0000012496','OH00002662393','IL','1','Hooven','Pari','','','','34','300605152','89 NEW ST',0,'GREENWICH','OH','44837','1001','CY','39077','1963-11-18','F','U',':RET:2106-3','N','021','HLT','3101244','92036OH003002706','2014-04-01','2014-03-08 16:21:18','310.00',NULL,NULL,'363.68','53.68','R-OH006','OH0','363.68',NULL,0,'2014-03-08 21:31:22'),(27516,21768,'Y','18','021','EC','A','','','AC','0001217419','0001217419','OH00002891625','IL','1','Cox','Rico','J','','','34','288704543','1616 LOCKHURST LN',0,'CINCINNATI','OH','45214','2518','CY','39061','1975-11-14','M','U',':RET:2054-5','N','021','HLT','3404116','92036OH005001205','2014-04-01','2014-03-04 12:12:12','115.00',NULL,NULL,'267.49','152.49','R-OH004','OH0','267.49',NULL,0,'2014-03-04 21:02:36'),(24740,19638,'Y','18','021','EC','A','','','AC','0000027939','0000027939','OH00002503722','IL','1','Dugan','Vincent','A','','Jr','34','196428448','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1955-06-13','M','M',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:40:30'),(473,386,'Y','18','021','EC','A','','','AC','0000195104','0000195104','OH00000322621','IL','1','Henes','Elijah','E','','','34','867558910','5348 Monroe St.',0,'Toledo','OH','43623',NULL,'CY','39095','2013-08-18','M','U',':RET:2106-3','N','021','HLT','1162170','92036OH001002601','2014-01-01','2013-12-03 21:04:03','0.00',NULL,NULL,'149.37','149.37','R-OH001','OH0','149.37',NULL,0,'2013-12-25 17:47:56'),(13783,11000,'Y','18','021','EC','A','','','AC','0000101644','0000101644','MS00000609444','IL','1','spillman','kathleen','','','','34','556576916','501 CEASAR RD',0,'PICAYUNE','MS','39466','8815','CY','28109','1962-08-31','F','U',':RET:2106-3','N','021','DEN','1707138','46300MS002000201','2014-01-01','2013-12-23 16:41:24','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 13:10:48'),(26665,21139,'Y','18','021','EC','A','','','AC','0001920029','0001920029','LA00003337295','IL','1','SHAW','ROBERT','LEWIS','','Jr','34','423843109','3725 BRANDYWINE DR',0,'METAIRIE','LA','70002','7001','CY','22051','1968-09-03','M','U',NULL,'T','021','DEN','2732285','18575LA002000201','2014-03-01','2014-02-27 21:02:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:14'),(4505,3571,'Y','18','024','14','A','','','TE','0000315229','0000315229','','IL','1','Rasnic','Rhea',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-06-27','M','',NULL,NULL,NULL,'','322518','','2013-12-11','2013-12-11 22:52:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:03:28'),(20038,15980,'Y','18','021','EC','A','','','AC','0001074165','0001074165','OH00001931425','IL','1','Mize','Cindy','','','','34','378641339','2999 CARMODY BLVD',0,'MIDDLETOWN','OH','45042','1757','CY','39017','1960-03-01','F','M',':RET:2106-3','T','021','HLT','1580459','92036OH004001201','2014-03-01','2014-01-25 22:49:38','606.00',NULL,NULL,'940.53','334.53','R-OH004','OH0','423.81',NULL,0,'2014-01-26 19:00:24'),(20841,16658,'Y','18','021','EC','A','','','AC','0000959137','0000959137','OH00001980526','IL','1','Hayes','Kathy','J','','','34','414178456','3303 HAMILTON RD',0,'MEDINA','OH','44256','7633','CY','39103','1958-07-23','F','M',':RET:2106-3','T','021','HLT','3643343','52664OH151001304','2014-03-01','2014-01-31 15:48:23','196.00',NULL,NULL,'571.90','375.90','R-OH012','OH0','571.90',NULL,0,'2014-01-31 21:00:46'),(20441,16328,'Y','18','024','14','A','','','TE','0000569504','0000569504','','IL','1','Moran','Steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-03-18','M','',NULL,NULL,NULL,'','3235163','','2014-01-28','2014-01-28 23:15:14',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-29 21:00:41'),(516,421,'Y','18','021','EC','A','','','AC','0000244952','0000244952','OH00000787957','IL','1','Compton','Gary','','','','34','555984837','633 HILBISH AVE',0,'AKRON','OH','44312','2249','CY','39153','1953-10-09','M','M',NULL,'N','021','DEN','168383','99734OH005000301','2014-01-01','2013-12-04 13:10:01','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:49:04'),(16840,13471,'Y','18','021','EC','A','','','AC','0000381162','0000381162','OH00002443704','IL','1','JOHNSON','JOETTA','','','','34','278547065','3004 BRONCO DR',0,'CLINTON','OH','44216','9736','CY','39153','1955-06-01','F','U',NULL,'N','021','HLT','2340519','52664OH151001304','2014-02-01','2014-01-11 10:09:39','384.00',NULL,NULL,'568.22','184.22','R-OH012','OH0','568.22',NULL,0,'2014-01-13 02:18:33'),(26083,20685,'Y','18','024','14','A','','','TE','0001654707','0001654707','','IL','1','Holiday','Kelotta',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-05','F','',NULL,NULL,NULL,'','3268278','','2014-02-26','2014-02-26 19:42:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-28 06:30:05'),(2564,2084,'Y','18','021','EC','A','','','AC','0000654569','0000654569','OH00001072183','IL','1','Carr','James','','','','34','276540635','2937 UTOPIA PL',0,'CINCINNATI','OH','45208','2936','CY','39061','1952-10-07','M','M',NULL,'N','021','HLT','381944','92036OH006001201','2014-01-01','2013-12-09 11:50:45','648.00',NULL,NULL,'967.53','319.53','R-OH004','OH0','478.41',NULL,0,'2013-12-25 19:37:32'),(19225,15318,'Y','18','021','EC','A','','','AC','0000088583','0000088583','OH00002105200','31','1','Henry','Crystal','','','','34','302824044','PO BOX 1254',0,'Bowling Green','OH','43402',NULL,'CY','39173','1985-05-14','F','U',':RET:2106-3','N','021','HLT','2699921','92036OH004002601','2014-03-01','2014-01-19 21:13:38','0.00',NULL,NULL,'170.44','170.44','R-OH001','OH0','170.44',NULL,0,'2014-01-21 08:46:28'),(22932,18281,'Y','18','021','EC','A','','','AC','0000200762','0000200762','OH00001640757','31','1','Sheal','Jennifer','','','','34','287801012','P.O. box .31463',0,'CINCINNATI','OH','45231',NULL,'CY','39061','1983-03-02','F','U',':RET:2106-3','N','021','HLT','3594739','92036OH005001206','2014-03-01','2014-02-11 18:20:10','188.00',NULL,NULL,'243.66','55.66','R-OH004','OH0','243.66','CIC',0,'2014-02-11 21:30:11'),(29107,23040,'Y','18','021','EC','A','','','AC','0001947453','0001947453','LA00003284074','IL','1','SIMMONS','DEBRA','','','','34','433984588','13000 CURRAN RD',0,'NEW ORLEANS','LA','70128',NULL,'CY','22071','1955-09-01','F','U',NULL,'N','021','DEN','4292207','18575LA002000101','2014-04-01','2014-03-09 23:16:15','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-10 21:02:21'),(16005,12810,'Y','18','021','EC','A','','','AC','0001094116','0001094116','TX00002216768','IL','1','ZAMORA','ANGELA','','','','34','678831554','910 9H ST',0,'PALACIOS','TX','77465',NULL,'CY','48321','1989-01-29','F','M',NULL,'N','021','DEN','1672990','33348TX002000201','2014-02-01','2014-01-03 16:26:04','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:37'),(28885,22861,'Y','18','021','EC','A','','','AC','0001014321','0001014321','TX00002796542','IL','1','Martinez','Carlota','','','','34','466839582','5711 PRENTISS DR',0,'SAN ANTONIO','TX','78240','3443','CY','48029','1960-03-23','F','U',NULL,'N','021','DEN','4206818','33348TX002000201','2014-04-01','2014-03-10 13:17:16','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-10 21:00:11'),(5705,4528,'Y','18','021','EC','A','','','AC','0000675417','0000675417','OH00000904533','IL','1','Ridge','Mary','','','','34','281504384','1855 WOODRIDGE CRES',0,'FINDLAY','OH','45840','0119','CY','39063','1952-09-24','F','M',':RET:2106-3','N','021','HLT','781568','92036OH004001501','2014-01-01','2013-11-26 17:34:00','468.00',NULL,NULL,'497.29','29.29','R-OH002','OH0','497.29',NULL,0,'2013-12-25 23:33:02'),(3629,2903,'Y','18','021','EC','A','','','AC','0000493200','0000493200','OH00000364047','IL','1','Flaherty','Gregory','','','','34','280486783','6211 Watchcreek Way Unit 103',0,'Milford','OH','45150',NULL,'CY','39025','1951-07-20','M','U',NULL,'N','021','HLT','525207','92036OH003000605','2014-01-01','2013-12-13 17:58:55','441.00',NULL,NULL,'644.07','203.07','R-OH005','OH0','644.07',NULL,0,'2013-12-25 21:30:04'),(25292,20066,'Y','18','021','EC','A','','','AC','0000401290','0000401290','OH00003311483','IL','1','GERDEMAN','CHERYL','','','','34','287684750','17560 ROAD 20P',0,'FORT JENNINGS','OH','45844','9162','CY','39137','1960-09-15','F','M',NULL,'N','021','HLT','2619030','92036OH004001501','2014-03-01','2014-02-25 08:33:37','355.00',NULL,NULL,'361.01','6.01','R-OH002','OH0','361.01','CIC',0,'2014-02-25 21:00:23'),(25085,19894,'Y','18','021','EC','A','','','AC','0000166423','0000166423','OH00002216649','IL','1','Garcia Diaz','Carlos','R','','','34','262857992','6915 MADISON AVE',0,'CLEVELAND','OH','44102','4039','CY','39035','1965-11-07','M','M',NULL,'N','021','HLT','3794958','92036OH003000801','2014-04-01','2014-02-20 17:14:54','0.00',NULL,NULL,'399.20','399.20','R-OH011','OH0','399.20',NULL,0,'2014-02-20 22:01:41'),(2304,1875,'Y','18','021','EC','A','','','AC','0000705120','0000705120','OH00001052425','IL','1','Isenbarger','John','','','','34','269821132','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1976-09-14','M','M',':RET:2106-3','T','021','DEN','709237','99734OH005000301','2014-01-01','2013-12-09 17:49:29','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:31:03'),(7383,5845,'N','19','021','EC','A',NULL,NULL,'','0001233017','0000590750','','IL','1','Cameron','Lillian',NULL,NULL,NULL,NULL,NULL,'735 AMBERLY DR',0,'HAMILTON','OH','45013','3458','CY','39017','2000-11-17','F','',':RET:2106-3','N','021','DEN','914454','99734OH005000401','2014-01-01','2013-11-23 10:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:58'),(5192,4119,'Y','18','024','14','A','','','TE','0001096743','0001096743','','IL','1','Ceena','Sharon','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-04','F','',NULL,NULL,NULL,'','2131772','','2013-12-19','2013-12-19 13:41:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:49'),(26341,20898,'Y','18','021','EC','A','','','AC','0000572116','0000572116','MS00001864600','IL','1','CHAMBERS ROBERSON','MARKELIA','','','','34','587811067','4306 BRIGGS ST',0,'MOSS POINT','MS','39563',NULL,'CY','28059','1996-12-04','F','U',NULL,'N','021','DEN','2635275','46300MS001000101','2014-03-01','2014-02-27 11:27:50','0.00',NULL,NULL,'47.10','47.10','R-MS005','MS0','47.10',NULL,0,'2014-02-28 06:31:44'),(15621,12494,'Y','18','021','EC','A','','','AC','0000952264','0000952264','MS00001526076','IL','1','GIBBS','ANJOHNETTE','W','','','34','343527955','1781 CAMELLIA DR',0,'GREENVILLE','MS','38701','7521','CY','28151','1955-11-17','F','U',':RET:2054-5','N','021','DEN','1409505','46300MS002000101','2014-02-01','2013-12-31 14:20:15','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,1,'2014-01-02 04:33:09'),(23921,19022,'N','01','021','EC','A',NULL,NULL,'','0000613049','0000526834','','IL','1','Heck','Gina','','','','34','298849942','7191 TUMBLEBROOK DR',0,'NEW ALBANY','OH','43054','8890','CY','39049','1981-02-09','F','',NULL,'N','021','DEN','3604800','99734OH005000301','2014-03-01','2014-02-14 15:48:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:05'),(20981,16767,'Y','18','024','14','A','','','TE','0001903442','0001903442','','IL','1','Gibbs','sharanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-24','F','',NULL,NULL,NULL,'','1845759','','2014-02-01','2014-02-01 00:08:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-01 19:00:20'),(9584,7589,'Y','18','021','EC','A','','','AC','0001244927','0001244927','MS00001014295','IL','1','GILBERT','SHANNON','JO','','','34','426670985','209 WILSON BATES RD',0,'MORTON','MS','39117','9501','CY','28121','1984-10-11','M','U',NULL,'T','021','DEN','1675204','46300MS002000201','2014-01-01','2013-12-20 19:13:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:36:59'),(3832,3067,'N','19','021','EC','A',NULL,NULL,'','0001124051','0000830610','','S1','1','Scholten','Kathleen','','','','34','386174267','2106 PRESSLER RD',0,'AKRON','OH','44312','4328','CY','39153','1995-03-02','F','',':RET:2106-3','N','021','DEN','85836','99734OH005000301','2014-01-01','2013-12-13 16:51:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:35:11'),(938,776,'Y','18','021','EC','A','','','AC','0000866852','0000866852','OH00000629867','IL','1','means','william','','','Jr','34','407179416','687 WOODTHRUSH DR',0,'CINCINNATI','OH','45244','1150','CY','39025','1969-04-07','M','M',':RET:2106-3','T','021','DEN','442950','99734OH005000401','2014-01-01','2013-10-31 14:19:05','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:09:15'),(13857,11057,'Y','18','021','EC','A','','','AC','0000574450','0000574450','OH00000256232','IL','1','McClain','Lucas','','','','34','271861748','19 KELLY CT',0,'HAMILTON','OH','45013','6024','CY','39017','1982-05-19','M','U',NULL,'N','021','HLT','2138695','92036OH006001201','2014-01-01','2013-12-23 18:57:48','0.00',NULL,NULL,'197.32','197.32','R-OH004','OH0','197.32',NULL,0,'2013-12-26 13:12:42'),(7843,6211,'Y','18','024','14','A','','','TE','0000284391','0000284391','','IL','1','Liptok','Ruth','Z',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-07','F','',NULL,NULL,NULL,'','214927','','2013-12-19','2013-12-19 23:10:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:04:40'),(18594,14824,'N','01','021','EC','A',NULL,NULL,'','0000878283','0000711401','','IL','1','OKUMU','STEPHANIE','','','','34','299884748','707 6TH ST',0,'BOWLING GREEN','OH','43402','4152','CY','39173','1988-06-07','F','',NULL,'N','021','HLT','2492550','92036OH004002601','2014-02-01','2014-01-15 10:35:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.42',NULL,0,'2014-01-16 08:47:15'),(16712,13375,'Y','18','021','EC','A','','','AC','0000778114','0000778114','TX00002185450','IL','1','Mojica','Jessica','','','','34','456812925','5118 42ND ST',0,'LUBBOCK','TX','79414','3023','CY','48303','1981-07-31','F','U',':RET:2106-3','T','021','DEN','1813864','33348TX002000201','2014-02-01','2014-01-07 11:11:22','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-08 18:24:43'),(15013,12001,'Y','18','021','EC','A','','','AC','0000837706','0000837706','OH00001536192','IL','1','Souza','Kathleen','M','','','34','272663785','2021 DARROW LAKE DR',0,'STOW','OH','44224','6079','CY','39153','1971-02-10','F','U',NULL,'N','021','HLT','2408044','52664OH151001306','2014-02-01','2013-12-30 13:26:40','222.00',NULL,NULL,'295.48','73.48','R-OH012','OH0','295.48',NULL,0,'2014-01-01 12:02:05'),(3418,2744,'Y','18','021','EC','A','','','AC','0001493242','0001493242','LA00000874289','IL','1','PITTMAN','BARBARA','','','','34','437067547','3819 KAHNS RD',0,'PORT ALLEN','LA','70767','4010','CY','22121','1959-06-13','F','M',':RET:2054-5','N','021','DEN','1681142','18575LA002000201','2014-01-01','2013-12-22 17:33:48','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:34'),(6997,5553,'Y','18','021','EC','A','','','AC','0000720244','0000720244','TX00001447156','IL','1','Ledbetter','Deborah','','','','34','450909499','759 ECKEL ST',0,'LA GRANGE','TX','78945','1707','CY','48149','1949-08-03','F','U',':RET:2106-3','N','021','DEN','2214697','33348TX002000201','2014-01-01','2013-12-24 18:45:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:09'),(4953,3931,'Y','18','024','14','A','','','TE','0000025403','0000025403','','IL','1','Minson','Beau','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-09-26','M','',NULL,NULL,NULL,'','434517','','2013-12-06','2013-12-06 18:34:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 22:45:59'),(1720,1434,'Y','18','021','EC','A','','','AC','0001026941','0001026941','OH00000972792','IL','1','Myers','Alison','','','','34','269115674','21151 TR 372',0,'Walhonding','OH','43843',NULL,'CY','39031','2004-09-10','F','R',':RET:2106-3','N','021','DEN','2442058','99734OH005000301','2014-01-01','2013-12-24 10:06:16','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','21.13',NULL,0,'2013-12-25 18:55:11'),(28260,22362,'Y','18','021','EC','A','','','AC','0000951788','0000951788','OH00003136107','IL','1','Scott','Amy','','','','34','280586611','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1971-09-06','F','M',':RET:2106-3','N','021','DEN','3607652','99734OH005000301','2014-04-01','2014-03-07 09:02:32','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00','CIC',0,'2014-03-07 21:00:16'),(28526,22576,'Y','18','021','EC','A','','','AC','0000919446','0000919446','OH00003261676','IL','1','delung','eric','','','','34','297805017','4086 YOUNGSTOWN KINGSVILLE RD',0,'CORTLAND','OH','44410','9721','CY','39155','1973-09-20','M','M',':RET:2106-3','N','021','HLT','3574349','92036OH003003206','2014-04-01','2014-03-07 08:47:33','539.00',NULL,NULL,'657.99','118.99','R-OH013','OH0','323.05',NULL,0,'2014-03-07 21:32:04'),(957,787,'Y','18','021','EC','A','','','AC','0000580117','0000580117','TX00000985589','IL','1','Molina','Richard','','','','34','573883870','3694 Hawthorne Trail',0,'Rockwall','TX','75032',NULL,'CY','48397','1952-01-29','M','M',':RET:2148-5^:RET:2106-3','N','021','DEN','207073','33348TX002000201','2014-01-01','2013-10-28 19:06:34','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:09:42'),(13699,10929,'Y','18','021','EC','A','','','AC','0000154649','0000154649','OH00000301743','IL','1','Whitis','Kimberly','','','','34','293667882','2511 Ardwell Ave.',0,'Akron','OH','44312',NULL,'CY','39153','1959-09-14','F','U',':RET:2106-3','N','021','HLT','1962986','52664OH151001305','2014-01-01','2013-12-23 11:47:01','333.00',NULL,NULL,'476.12','143.12','R-OH012','OH0','476.12',NULL,0,'2013-12-26 13:08:36'),(23490,18712,'Y','18','021','EC','A','','','AC','0000220020','0000220020','OH00002793392','IL','1','Dodds','Erin','','','','34','268889762','909 PRIMROSE DR',0,'WAPAKONETA','OH','45895','1050','CY','39011','1981-04-12','F','M',':RET:2106-3','N','021','HLT','3412805','92036OH006001501','2014-03-01','2014-02-12 20:29:59','365.00',NULL,NULL,'426.75','61.75','R-OH002','OH0','206.48',NULL,0,'2014-02-13 22:02:01'),(8951,7099,'Y','18','024','14','A','','','TE','0000666738','0000666738','','IL','1','LINER','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-25','F','',NULL,NULL,NULL,'','116698','','2013-12-18','2013-12-18 11:58:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:03:35'),(20521,16397,'Y','18','021','EC','A','','','AC','0000241066','0000241066','TX00001556294','IL','1','VERA','ALMA','','','','34','750110176','173 COUNTY RD 6102',0,'NACOGDOCHES','TX','75964',NULL,'CY','48347','1990-01-15','F','M',':RET:2106-3','N','021','DEN','2696858','33348TX002000101','2014-03-01','2014-01-29 15:11:45','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-29 21:01:25'),(18640,14859,'Y','18','021','EC','A','','','AC','0000269124','0000269124','TX00002515833','IL','1','Oudomvialy','Lamphan','','','','34','643130424','4681 SILVER LAKE DR',0,'DALLAS','TX','75211','7847','CY','48113','1980-12-01','M','U',':RET:2028-9','N','021','DEN','3018910','33348TX002000201','2014-02-01','2014-01-15 23:12:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-17 03:35:06'),(8869,7032,'Y','18','021','EC','A','','','AC','0000222962','0000222962','TX00000535306','IL','1','Arian','Gretchen','','','','34','402800032','2001 Holcombe Blvd',0,'Houston','TX','77030',NULL,'CY','48201','1958-01-21','F','M',':RET:2106-3','N','021','DEN','2592161','33348TX002000201','2014-01-01','2013-12-18 13:22:04','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:01:30'),(16055,12857,'Y','18','021','EC','A','','','AC','0000484800','0000484800','OH00002155766','IL','1','LENGEL','JOSEPH','','','','34','269486487','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-12-01','M','M',':RET:2106-3','N','021','DEN','1474405','99734OH005000401','2014-02-01','2014-01-03 09:14:51','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:03:21'),(25872,20513,'Y','18','021','EC','A','','','AC','0002235431','0002235431','LA00002224402','IL','1','King','Bruce','','','','34','437819606','106 Jennifer Lane',0,'Monroe','LA','71203',NULL,'CY','22073','1987-07-23','M','U',':RET:2054-5','N','021','DEN','2740781','18575LA002000201','2014-04-01','2014-02-26 16:47:14','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-26 21:00:51'),(28207,22320,'N','01','021','EC','A',NULL,NULL,'','0000848367','0001057284','','IL','1','Moser','Gregory','','','','34','460637362','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1971-06-01','M','',':RET:2106-3','N','021','DEN','3200824','33348TX002000101','2014-04-01','2014-03-06 16:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-03-06 21:30:11'),(28248,22350,'Y','18','024','14','A','','','TE','0000615565','0000615565','','IL','1','SMITH','JANET','JW',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-04-06','F','',NULL,NULL,NULL,'','2644327','','2014-03-07','2014-03-07 13:03:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:12'),(4822,3822,'Y','18','021','EC','A','','','AC','0000521926','0000521926','OH00000009536','IL','1','Robenalt','Joseph','','','','34','268505221','163 Wentz St',0,'Tiffin','OH','44883',NULL,'CY','39147','1952-05-21','M','M',':RET:2106-3','N','021','HLT','787023','92036OH002002701','2014-01-01','2013-12-08 11:37:52','1062.00',NULL,NULL,'1218.96','156.96','R-OH006','OH0','632.79',NULL,0,'2013-12-25 22:17:08'),(7435,5884,'Y','18','021','EC','A','','','AC','0001109202','0001109202','OH00000106731','IL','1','Lynn','Tracey','','','','34','268702005','1619 Bronson Rd',0,'Akron','OH','44305',NULL,'CY','39153','1959-12-12','F','U',':RET:2106-3','N','021','HLT','1014351','52664OH151001301','2014-01-01','2013-12-15 09:54:15','72.00',NULL,NULL,'476.12','404.12','R-OH012','OH0','476.12',NULL,0,'2013-12-26 02:30:15'),(25658,20356,'Y','18','021','EC','A','','','AC','0000983895','0000983895','OH00002461957','IL','1','Hornacek','Cherie','','','','34','296503147','3691 E STATE ST',0,'BARBERTON','OH','44203','4547','CY','39153','1951-01-09','F','U',':RET:2106-3','N','021','HLT','2900868','52664OH152000901','2014-04-01','2014-02-21 19:38:15','357.00',NULL,NULL,'482.18','125.18','R-OH012','OH0','482.18',NULL,0,'2014-02-26 08:30:43'),(14977,11970,'N','19','021','EC','A',NULL,NULL,'','0000557904','0000193556','','IL','1','Su','Tom','','','','34','487027055','9618 OAKLAND LAKE WAY',0,'MISSOURI CITY','TX','77459','6451','CY','48157','1989-05-29','M','',':RET:2034-7','N','021','DEN','1492600','33348TX002000201','2014-02-01','2013-12-30 13:40:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-01 12:00:59'),(25443,20187,'N','01','021','EC','A',NULL,NULL,'','0000521748','0000406766','','IL','1','SALGADO','GILARDO','','','','34','460979427','541 CIRUELA DR',0,'BROWNSVILLE','TX','78521',NULL,'CY','48061','1972-03-09','M','',NULL,'N','021','DEN','2903743','33348TX002000201','2014-04-01','2014-02-25 11:46:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-25 21:31:21'),(24096,19155,'Y','18','021','EC','A','','','AC','0001168048','0001168048','OH00001481252','IL','1','delgado','cesar','','','','34','591530599','5174 LUCYDALE AVE',0,'NORTH OLMSTED','OH','44070','4307','CY','39035','1982-01-29','M','M',NULL,'N','021','HLT','2745584','52664OH151001305','2014-03-01','2014-02-15 17:16:55','281.00',NULL,NULL,'561.14','280.14','R-OH011','OH0','297.55',NULL,0,'2014-02-15 22:01:28'),(18275,14590,'Y','18','021','EC','A','','','AC','0000852119','0000852119','TX00002394114','IL','1','Chance','Laura','','','','34','430799238','7109 hwy 43 north',0,'marshall','TX','75672',NULL,'CY','48203','1988-12-17','F','M',':RET:2106-3','N','021','DEN','2233974','33348TX002000201','2014-02-01','2014-01-15 17:47:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:43'),(21931,17514,'N','01','021','EC','A',NULL,NULL,'','0001106433','0000075180','','IL','1','fails','shiela','','','','34','452657724','8427 hwy 37 south',0,'winnsboro','TX','75494',NULL,'CY','48159','1978-12-15','F','',':RET:2106-3','N','021','DEN','3357438','33348TX002000201','2014-03-01','2014-02-07 08:57:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-07 19:00:11'),(14246,11361,'Y','18','024','14','A','','','TE','0000307604','0000307604','','IL','1','pozos','ashley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-02-25','F','',NULL,NULL,NULL,'','1667170','','2013-12-26','2013-12-26 11:58:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:05:23'),(4282,3409,'N','01','021','EC','A',NULL,NULL,'','0001073132','0000678077','','IL','1','Hostetler','Sarah','Elizabeth','','','34','370923261','14110 State Route 116',0,'Van Wert','OH','45891',NULL,'CY','39161','1982-08-22','F','',':RET:2106-3','N','021','HLT','1958887','92036OH005001504','2014-01-01','2013-12-17 11:34:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.08',NULL,0,'2013-12-25 21:52:01'),(5082,4028,'Y','18','021','EC','A','','','AC','0000678495','0000678495','TX00000340943','IL','1','Wall','James','','','','34','461023750','1113 E RIO GRANDE ST',0,'PEARSALL','TX','78061','4427','CY','48163','1960-06-25','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2262193','33348TX002000201','2014-01-01','2013-12-19 14:25:01','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:58'),(24521,19479,'Y','18','021','EC','A','','','AC','0000516986','0000516986','TX00002405459','IL','1','MARIA','ROSA','M','','','34','456994480','8635 PUERTO ESCONDIDO',0,'LAREDO','TX','78045','6206','CY','48479','1959-03-01','F','U',NULL,'N','021','DEN','3018268','33348TX002000201','2014-04-01','2014-02-19 14:31:20','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-20 03:57:21'),(24445,19417,'Y','18','021','EC','A','','','AC','0000984902','0000984902','OH00002759823','IL','1','Eichert','Jean','Karen','','','34','181388911','7104 BLUECREST DR',0,'CINCINNATI','OH','45230','2203','CY','39061','1951-10-04','F','U',':RET:2106-3','N','021','HLT','2660032','92036OH006001201','2014-04-01','2014-02-18 10:12:38','382.00',NULL,NULL,'489.12','107.12','R-OH004','OH0','489.12',NULL,0,'2014-02-18 22:01:22'),(8861,7025,'Y','18','021','EC','A','','','AC','0000285467','0000285467','TX00000773145','IL','1','JACKSON','CARLA','','','','34','466571032','1780 FM 489',0,'OAKWOOD','TX','75855','8413','CY','48161','1963-12-03','F','U',':RET:2054-5','N','021','DEN','1942956','33348TX002000201','2014-01-01','2013-12-18 11:34:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:17'),(7924,6266,'Y','18','021','EC','A','','','AC','0001524559','0001524559','LA00000182316','31','1','Johnson','Donald','','','','34','435557662','P.O. Box 548',0,'DeRidder','LA','70634',NULL,'CY','22011','1969-04-05','M','M',':RET:2106-3','N','021','DEN','1852338','18575LA002000201','2014-01-01','2013-12-20 08:57:39','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2013-12-26 03:06:25'),(7085,5621,'Y','18','021','EC','A','','','AC','0000183506','0000183506','OH00001556827','IL','1','devereux','kenneth','','','','34','302582133','188 NORTHPARK DR',0,'WADSWORTH','OH','44281','1310','CY','39103','1958-09-01','M','M',':RET:2106-3','T','021','HLT','2532631','52664OH152000901','2014-01-01','2013-12-24 21:43:23','890.00',NULL,NULL,'963.95','73.95','R-OH012','OH0','418.89',NULL,0,'2013-12-26 01:50:24'),(18239,14558,'N','01','021','EC','A',NULL,NULL,'','0001251775','0001103959','','IL','1','LIU','DE WANG','','','','34','108823574','2904 86 THE ST',0,'LUBBOCK','TX','79423',NULL,'CY','48303','1974-01-30','M','',':RET:2029-7','N','021','DEN','2721536','33348TX002000201','2014-02-01','2014-01-15 10:41:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-16 08:44:24'),(16141,12928,'N','01','021','EC','A',NULL,NULL,'','0001110371','0000290806','','IL','1','El farissi','Fahd','','','','34','277134651','24 METLIN AVE',0,'AKRON','OH','44302','1023','CY','39153','1980-07-12','M','',':RET:2106-3','N','021','HLT','1457089','52664OH151001501','2014-02-01','2014-01-03 12:43:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','320.42',NULL,0,'2014-01-04 02:06:00'),(6521,5170,'Y','18','021','EC','A','','','AC','0000947381','0000947381','OH00000894792','IL','1','Jennison','James','','','','34','295821539','3520 Fleitz',0,'Oregon','OH','43616',NULL,'CY','39095','1973-07-11','M','U',':RET:2106-3','N','021','HLT','709278','92036OH006002601','2014-01-01','2013-12-10 19:22:04','108.00',NULL,NULL,'197.64','89.64','R-OH001','OH0','197.64',NULL,0,'2013-12-26 00:51:24'),(1862,1522,'N','19','021','EC','A',NULL,NULL,'','0001230390','0000112937','','IL','1','Wilke','Kyle','E','','','34','289046907','9336 BRYANT RD',0,'WINDHAM','OH','44288','9547','CY','39133','1999-11-11','M','',':RET:2106-3','N','021','HLT','2563089','52664OH152000901','2014-01-01','2013-12-24 10:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 18:58:09'),(23628,18815,'N','01','021','EC','A',NULL,NULL,'','0000774019','0000863513','','IL','1','Banister','Alfred','','','','34','306760159','716 W MAIN ST',0,'TIPP CITY','OH','45371','1418','CY','39109','1964-04-10','M','',':RET:2106-3','N','021','HLT','2764803','92036OH004000501','2014-03-01','2014-02-13 17:17:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','326.08',NULL,0,'2014-02-13 22:03:21'),(14867,11871,'Y','18','021','EC','A','','','AC','0000036972','0000036972','TX00000259044','IL','1','candelaria','francisco','','','','34','464951873','790 GREEVES ST',0,'BEAUMONT','TX','77707','1331','CY','48245','1982-10-26','M','U',NULL,'N','021','DEN','1648707','33348TX002000201','2014-02-01','2013-12-28 21:07:28','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2013-12-30 00:00:07'),(20127,16060,'Y','18','021','EC','A','','','AC','0000751045','0000751045','OH00001664638','IL','1','LUDWIG','MICHAEL','S','','','34','277564927','5837 EMERSON AVE NW',0,'WARREN','OH','44483','1121','CY','39155','1959-05-24','M','U',':RET:2106-3','N','021','DEN','2326367','99734OH005000401','2014-03-01','2014-01-27 10:57:06','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-27 21:00:49'),(4457,3542,'Y','18','021','EC','A','','','AC','0000866876','0000866876','OH00000526113','IL','1','Calhoun','Catherine','','','','34','297787770','31 FREDERICK ST',0,'PAINESVILLE','OH','44077','3611','CY','39085','1982-04-22','F','U',':RET:2106-3','T','021','DEN','270851','99734OH005000301','2014-01-01','2013-12-12 11:08:04','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:02:32'),(17885,14284,'Y','18','024','14','A','','','TE','0001053076','0001053076','','IL','1','Moran','Matthew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-04-08','M','',NULL,NULL,NULL,'','1830477','','2014-01-14','2014-01-14 15:00:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:06:17'),(26201,20779,'Y','18','021','EC','A','','','AC','0000465975','0000465975','OH00002219192','IL','1','Baker','Sherry','','','','34','280968635','4713 CRANBERRY AVE NW',0,'CANTON','OH','44709','1314','CY','39151','1993-03-15','F','U',':RET:2106-3','N','021','HLT','3842259','52664OH151001304','2014-04-01','2014-02-26 21:46:17','53.00',NULL,NULL,'223.01','170.01','R-OH015','OH0','223.01',NULL,0,'2014-02-28 06:30:48'),(265,219,'Y','18','021','EC','A','','','AC','0000268872','0000268872','OH00000693401','IL','1','Caprilla','Frank','','','','34','274807371','5350 W BREESE RD',0,'LIMA','OH','45806','9458','CY','39003','1979-07-12','M','M',':RET:2106-3','N','021','HLT','463944','92036OH006001501','2014-01-01','2013-12-05 17:22:21','293.00',NULL,NULL,'420.98','127.98','R-OH002','OH0','211.89',NULL,0,'2013-12-25 17:21:56'),(25207,19995,'Y','18','021','EC','A','','','AC','0001255081','0001255081','OH00002371563','IL','1','WALKER','CYNTHIA','','','','34','273484202','20629 PATTERSON PARKWAY',0,'HIGHLAND HILL','OH','44122',NULL,'CY','39035','1950-03-07','F','U',':RET:2054-5','N','021','DEN','2995237','99734OH005000301','2014-04-01','2014-02-21 10:09:17','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:49'),(25135,19938,'Y','18','021','EC','A','','','AC','0000416997','0000416997','TX00002410693','IL','1','atallah','khaled','','','','34','645509985','644 gibson st',0,'cedar hill','TX','75104',NULL,'CY','48113','1974-01-11','M','U',':RET:2028-9','T','021','DEN','3105559','33348TX002000201','2014-04-01','2014-02-20 23:40:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-21 22:00:06'),(22190,17710,'Y','18','021','EC','A','','','AC','0000440970','0000440970','LA00001746572','IL','1','ramsey','marvin','','','Jr','34','438829757','1107 Auburn Ave.',0,'Monroe','LA','71201',NULL,'CY','22073','1951-05-02','M','M',':RET:2106-3','N','021','DEN','2808363','18575LA002000101','2014-03-01','2014-02-09 16:54:59','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02','CIC',0,'2014-02-09 19:00:08'),(1632,1363,'Y','18','024','14','A','','','TE','0000026101','0000026101','','IL','1','CAMACHO','LESLIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-08-08','F','',NULL,NULL,NULL,'','2261515','','2013-12-24','2013-12-24 15:05:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:52:51'),(2398,1958,'Y','18','021','EC','A','','','AC','0000217557','0000217557','OH00001049585','IL','1','Searfos','Terri','','','','34','450089103','758 silverleaf oak ct',0,'westerville','OH','43081',NULL,'CY','39049','1960-12-19','F','M',':RET:2106-3','N','021','DEN','50175','99734OH005000401','2014-01-01','2013-12-09 13:44:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:28'),(19694,15694,'Y','18','021','EC','A','','','AC','0000925282','0000925282','TX00001982633','IL','1','NGUYEN','TRUNG','VAN','','','34','462719714','5104 FORT BUCKNER DR',0,'MCKINNEY','TX','75070','1000','CY','48085','1953-12-24','M','M',':RET:2047-9','N','021','DEN','3083989','33348TX002000201','2014-03-01','2014-01-22 23:07:26','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-23 21:00:44'),(2809,2270,'Y','18','021','EC','A','','','AC','0000835060','0000835060','TX00000227374','IL','1','Cleckley','James','','','','34','454636932','5900 COUNTY ROAD 3911',0,'ATHENS','TX','75752','4197','CY','48213','1982-05-07','M','U',NULL,'N','021','DEN','58830','33348TX002000101','2014-01-01','2013-10-14 23:26:10','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:00:11'),(21365,17075,'N','19','021','EC','A',NULL,NULL,'','0000926620','0000850709','','IL','1','Ortega','Amanda','Rose','','','34','613360465','1037 TWIN ESTATES DR',0,'KYLE','TX','78640',NULL,'CY','48209','1988-05-23','F','',':RET:2106-3','N','021','DEN','3188342','33348TX002000201','2014-03-01','2014-02-04 16:05:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-04 21:00:45'),(3403,2731,'Y','18','021','EC','A','','','AC','0002189753','0002189753','LA00000840129','IL','1','Scott','Amy','','','','34','437298433','487 MARIONNEAUX ST',0,'BRUSLY','LA','70719','2523','CY','22121','1976-05-21','F','U',':RET:2106-3','N','021','DEN','1624417','18575LA002000201','2014-01-01','2013-12-22 14:11:56','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:10'),(27643,21865,'Y','18','021','EC','A','','','AC','0000421530','0000421530','OH00002744465','S1','1','Bernal','Ricardo','','','Sr','34','530990479','1113 COTTAGE PL NW',0,'CANTON','OH','44703','3022','CY','39151','1996-12-21','F','U',':RET:2106-3','N','021','DEN','4070870','99734OH005000401','2014-04-01','2014-03-05 12:14:28','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','15.78',NULL,0,'2014-03-05 21:30:17'),(15659,12528,'Y','18','021','EC','A','','','AC','0000643237','0000643237','OH00002043150','IL','1','Laudick','Marcia','','','','34','090429124','1637 BENHAM DR',0,'LIMA','OH','45805','1310','CY','39003','1951-04-10','F','M',NULL,'T','021','HLT','1722307','92036OH005001501','2014-02-01','2013-12-31 16:16:39','198.00',NULL,NULL,'727.15','529.15','R-OH002','OH0','727.15',NULL,1,'2014-01-02 04:34:22'),(7757,6145,'Y','18','021','EC','A','','','AC','0000654589','0000654589','OH00000273141','IL','1','ABDILLE','SALAH','','','','34','668098638','3746 TANAGER DR',0,'COLUMBUS','OH','43230','1181','CY','39049','1983-09-01','M','M',':RET:2054-5','N','021','DEN','2426230','99734OH005000401','2014-01-01','2013-12-20 17:20:10','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:02:39'),(25347,20112,'Y','18','021','EC','A','','','AC','0001511418','0001511418','LA00002926606','IL','1','Little','Quentin','','','','34','433495474','333 BRIARHAVEN DR',0,'BATON ROUGE','LA','70810','6452','CY','22033','1982-09-30','M','U',':RET:2106-3','T','021','DEN','3657115','18575LA002000101','2014-04-01','2014-02-24 22:09:19','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-25 21:30:29'),(21988,17559,'Y','18','021','EC','A','','','AC','0001235084','0001235084','LA00001876878','IL','1','Harris','Maurice','','','','34','259679605','1535 FRANCE ST',0,'NEW ORLEANS','LA','70117','4834','CY','22071','1981-06-15','M','U',':RET:2054-5','N','021','DEN','2842707','18575LA002000201','2014-03-01','2014-02-06 21:05:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-07 19:00:40'),(17984,14371,'Y','18','021','EC','A','','','AC','0001181041','0001181041','OH00001577874','IL','1','Reyes','Lupe','','','','34','274546455','20545 CENTER RIDGE RD',0,'ROCKY RIVER','OH','44116','3430','CY','39035','1954-12-05','M','U',':RET:2106-3','N','021','HLT','1520184','52664OH151001301','2014-02-01','2014-01-14 16:39:29','189.00',NULL,NULL,'654.70','465.70','R-OH011','OH0','654.70',NULL,0,'2014-01-15 02:06:54'),(27298,21615,'Y','18','024','14','A','','','TE','0001011470','0001011470','','IL','1','LEAL','NORMA','I',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-02-15','F','',NULL,NULL,NULL,'','2565737','','2014-03-19','2014-03-04 12:59:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-04 21:00:33'),(27852,22029,'N','19','021','EC','A',NULL,NULL,'','0000509118','0001033006','','S1','1','FLORES','JUAN','JAVIER','','','34','639881567','2511 E 28TH ST',0,'MISSION','TX','78574','1979','CY','48215','2003-10-10','F','',NULL,'N','021','DEN','3326083','33348TX002000101','2014-04-01','2014-03-05 14:36:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-03-05 21:32:13'),(28323,22410,'Y','18','021','EC','A','','','AC','0001055092','0001055092','TX00003769586','IL','1','MARTINEZ','MATILDE','','','','34','633447502','1419 ROY ST',0,'GAINESVILLE','TX','76240','4349','CY','48097','1987-09-17','F','U',NULL,'N','021','DEN','4209960','33348TX002000201','2014-04-01','2014-03-06 20:57:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:06'),(5735,4552,'Y','18','021','EC','A','','','AC','0001444296','0001444296','LA00000537176','IL','1','Wiegand','Charles','','','','34','625201707','120 North Rendon St.',0,'New Orleans','LA','70119',NULL,'CY','22071','1979-11-19','M','U',':RET:2036-2^:RET:2106-3','N','021','DEN','1724112','18575LA002000201','2014-01-01','2013-12-23 23:01:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:46'),(5691,4515,'N','01','021','EC','A',NULL,NULL,'','0000451241','0000626700','','IL','1','Brausch','Terry','','','','34','274446401','6696 COACHLIGHT WAY',0,'WEST CHESTER','OH','45069','2047','CY','39017','1952-06-26','M','',':RET:2106-3','N','021','DEN','318691','99734OH005000301','2014-01-01','2013-11-26 15:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:32:36'),(24341,19331,'Y','18','021','EC','A','','','AC','0000573948','0000573948','TX00002995252','31','1','LUCERO','MARIA','','','','34','525611613','PO BOX 649',0,'DENVER CITY','TX','79323',NULL,'CY','48501','1955-08-09','F','M',':RET:2106-3','N','021','DEN','3752999','33348TX002000201','2014-04-01','2014-02-18 15:59:35','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:20'),(4840,3834,'Y','18','021','EC','A','','','AC','0000048153','0000048153','OH00000599499','IL','1','Sotherden','Molly','','','','34','120625841','2667 STEWART DR',0,'RITTMAN','OH','44270','9618','CY','39169','1977-09-11','F','U',NULL,'N','021','HLT','1108648','52664OH152000901','2014-01-01','2013-11-07 19:23:14','0.00',NULL,NULL,'200.91','200.91','R-OH014','OH0','200.91',NULL,0,'2013-12-25 22:30:06'),(20634,16489,'Y','18','021','EC','A','','','AC','0000991099','0000991099','TX00002429204','IL','1','Bertrand','Callen','R','','','34','434662169','19831 LIONS GATE CT',0,'HUMBLE','TX','77338','1924','CY','48201','1946-05-27','M','M',':RET:2106-3','N','021','DEN','3507959','33348TX002000201','2014-03-01','2014-01-30 10:35:59','0.00',NULL,NULL,'35.20','35.20','R-TX010','TX0','17.60',NULL,0,'2014-01-30 21:00:30'),(18131,14478,'N','19','021','EC','A',NULL,NULL,'','0000073961','0000564224','','IL','1','Ker','Nicole','Andrea','','','34','282940291','423 SANDRA DR',0,'OXFORD','OH','45056','2542','CY','39017','1991-10-20','F','',':RET:2106-3','N','021','HLT','2576820','92036OH004001201','2014-02-01','2014-01-14 14:56:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-01-15 02:07:43'),(5915,4685,'Y','18','021','EC','A','','','AC','0000088413','0000088413','TX00001169968','IL','1','EAKENS','RICHARD','','','','34','585548328','1119 COLUMBIA ST',0,'HOUSTON','TX','77008',NULL,'CY','48201','1951-02-05','M','R',':RET:2106-3','T','021','DEN','2446218','33348TX002000101','2014-01-01','2013-12-23 23:19:36','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 23:50:08'),(7908,6252,'Y','18','021','EC','A','','','AC','0001534005','0001534005','LA00000519318','IL','1','Schmitt','Celeste','','','','34','436374449','6945 VICKSBURG ST',0,'NEW ORLEANS','LA','70124','3443','CY','22071','1964-02-09','F','U',':RET:2106-3','N','021','DEN','1759116','18575LA002000201','2014-01-01','2013-12-19 20:39:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:00'),(19095,15214,'Y','18','021','EC','A','','','AC','0000373656','0000373656','OH00002003742','IL','1','Vance','Brenda',NULL,NULL,NULL,NULL,NULL,'11217 Tecumseh Path',0,'Lakeview','OH','43331',NULL,'CY','39091','1960-01-31','F','M',':RET:2106-3','N','021','DEN','1481954','99734OH005000301','2014-03-01','2014-01-18 14:07:10','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:44:35'),(21368,17078,'Y','18','021','EC','A','','','AC','0000930373','0000930373','TX00001856733','IL','1','SHIMONEK','MEGAN','','','','34','228496347','404 S FRYERS CREEK CIR',0,'TEMPLE','TX','76504','7579','CY','48027','1988-02-02','F','U',NULL,'T','021','DEN','2846410','33348TX002000201','2014-03-01','2014-02-04 16:37:35','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-04 21:00:47'),(28741,22747,'Y','18','021','EC','A','','','AC','0001699385','0001699385','LA00003000516','IL','1','Lamonte','Shaun','','','','34','434738333','1612 ABADIE AVE',0,'METAIRIE','LA','70003','4604','CY','22051','1985-02-03','M','U',':RET:2106-3','N','021','DEN','3944393','18575LA002000201','2014-04-01','2014-03-09 09:49:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-09 21:00:09'),(3945,3158,'N','19','021','EC','A',NULL,NULL,'','0000577299','0000327258','','IL','1','Liu','Yang Ao','','','','34','302062790','1430 CARROL ST',0,'SIDNEY','OH','45365','6201','CY','39149','1990-11-05','M','',NULL,'N','021','HLT','143373','92036OH006000501','2014-01-01','2013-12-13 10:00:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','188.51',NULL,0,'2013-12-25 21:38:02'),(23999,19083,'Y','18','021','EC','A','','','AC','0000544165','0000544165','OH00002006694','IL','1','Tayeh','Joe','','','','34','294927655','8624 WHIPPOORWILL LN',0,'PARMA','OH','44130','7675','CY','39035','1990-10-16','M','U',':RET:2106-3','N','021','DEN','3053581','99734OH005000401','2014-03-01','2014-02-14 23:44:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-15 22:00:32'),(6909,5483,'Y','18','021','EC','A','','','AC','0001710248','0001710248','LA00001654014','31','1','martin','dewan','','','','34','437040446','P. O. Box 216',0,'belle rose','LA','70341',NULL,'CY','22007','1957-08-11','F','U',':RET:2054-5','N','021','DEN','2323037','18575LA002000201','2014-02-01','2013-12-25 00:13:53','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-26 01:45:52'),(20528,16403,'Y','18','021','EC','A','','','AC','0000474644','0000474644','MS00001389254','IL','1','JACKSON-WILLIAMS','ELIZA','','','','34','587255803','816 GEORGE ST',0,'MOUND BAYOU','MS','38762','9609','CY','28011','1963-03-01','F','M',':RET:2054-5','N','021','DEN','3172477','46300MS002000201','2014-03-01','2014-01-28 23:00:56','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2014-01-29 21:01:29'),(28163,22286,'Y','18','021','EC','A','','','AC','0000130758','0000130758','OH00003673210','IL','1','Fedor','Judith','','','','34','291488512','6843 MCCOPPIN MILL RD',0,'HILLSBORO','OH','45133','8194','CY','39071','1949-10-05','F','U',NULL,'N','021','HLT','3790332','92036OH005000606','2014-04-01','2014-03-06 11:40:51','618.00',NULL,NULL,'644.00','26.00','R-OH005','OH0','644.00',NULL,0,'2014-03-06 21:02:43'),(4837,3831,'Y','18','021','EC','A','','','AC','0000048153','0000048153','OH00000670483','IL','1','Sotherden','Molly','','','','34','120625841','2667 STEWART DR',0,'RITTMAN','OH','44270','9618','CY','39169','1977-09-11','F','U',NULL,'N','021','HLT','45952','52664OH152000901','2014-01-01','2013-11-07 19:13:50','0.00',NULL,NULL,'200.91','200.91','R-OH014','OH0','200.91',NULL,0,'2013-12-25 22:30:03'),(25876,20516,'N','01','021','EC','A',NULL,NULL,'','0001438001','0002093155','','IL','1','Nguyen','Kiet','Van','','','34','011664306','2700 Sprig Dr',0,'Marrero','LA','70072',NULL,'CY','22051','1974-01-02','M','',':RET:2047-9','N','021','DEN','3862988','18575LA002000201','2014-04-01','2014-02-26 17:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-26 21:00:54'),(17404,13928,'Y','18','024','14','A','','','TE','0000855650','0000855650','','IL','1','Cross','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-14','F','',NULL,NULL,NULL,'','2030861','','2014-01-09','2014-01-09 21:59:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:18'),(3950,3160,'N','01','021','EC','A',NULL,NULL,'','0000151961','0001033642','','IL','1','GOODMAN','TERI','SUE','','','34','287567305','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1959-12-18','F','',':RET:2106-3','N','021','HLT','48028','92036OH006002701','2014-01-01','2013-12-13 10:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','330.16',NULL,0,'2013-12-25 21:38:08'),(28708,22718,'Y','18','021','EC','A','','','AC','0000516975','0000516975','OH00003661285','IL','1','EVEARITT','JAMES','','','','34','290667742','5516 308TH ST',0,'TOLEDO','OH','43611',NULL,'CY','39095','1963-12-04','M','U',NULL,'N','021','HLT','3554263','92036OH003002601','2014-04-01','2014-03-07 19:56:50','0.00',NULL,NULL,'363.68','363.68','R-OH001','OH0','363.68',NULL,0,'2014-03-08 21:31:12'),(5238,4155,'Y','18','021','EC','A','','','AC','0000124195','0000124195','OH00000335872','IL','1','Buehl','Arnold','','','','34','300446419','204 SILVER VALLEY BLVD',0,'MUNROE FALLS','OH','44262','1019','CY','39153','1958-04-23','M','M',NULL,'N','021','HLT','1493366','52664OH151001305','2014-01-01','2013-12-18 20:12:50','854.00',NULL,NULL,'1100.77','246.77','R-OH012','OH0','497.31',NULL,0,'2013-12-25 23:04:52'),(395,325,'Y','18','021','EC','A','','','AC','0000511931','0000511931','OH00000562559','IL','1','Evans','Brandon','','','','34','284922051','8914 WINSTON RD',0,'PICKERINGTON','OH','43147','9737','CY','39045','1989-10-03','M','U',':RET:2106-3','N','021','DEN','986078','99734OH005000401','2014-01-01','2013-12-03 20:00:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:46:00'),(1095,899,'Y','18','021','EC','A','','','AC','0000317310','0000317310','OH00000739641','IL','1','Adams','Coletta','','','','34','269504066','28648 Holly Dr.',0,'North Olmsted','OH','44070',NULL,'CY','39035','1952-06-10','F','U',NULL,'N','021','DEN','25964','99734OH005000401','2014-01-01','2013-12-03 15:39:46','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:06'),(20031,15975,'Y','18','021','EC','A','','','AC','0001691472','0001691472','LA00001737917','IL','1','Crescioni','Heidi','','','','34','438553458','178 NORMANDY AVE',0,'HARAHAN','LA','70123','4319','CY','22051','1980-10-24','F','U',':RET:2106-3','N','021','DEN','3190603','18575LA002000201','2014-03-01','2014-01-26 17:14:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-26 19:00:20'),(4417,3509,'Y','18','021','EC','A','','','AC','0000383340','0000383340','OH00000958336','IL','1','Groflo','Vicky','','','','34','282460626','33721 HENWELL RD',0,'COLUMBIA STATION','OH','44028','9149','CY','39093','1950-08-11','F','U',':RET:2106-3','N','021','DEN','942874','99734OH005000401','2014-01-01','2013-12-12 15:52:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:31'),(15635,12506,'Y','18','021','EC','A','','','AC','0002077147','0002077147','LA00002043148','IL','1','Johnson','Sandra','','','','34','436215393','8059 DIXIE BLANCHARD RD',0,'SHREVEPORT','LA','71107','9130','CY','22017','1957-12-18','F','M',':RET:2106-3','N','021','DEN','2336430','18575LA002000101','2014-02-01','2013-12-31 15:43:22','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-02 04:33:36'),(24504,19466,'Y','18','021','EC','A','','','AC','0000323097','0000323097','TX00002030405','IL','1','Acosta','Manuel','','','','34','632018047','1845 Westcrest Dr.',0,'Houston','TX','77055',NULL,'CY','48201','1970-07-04','M','M',':RET:2106-3','N','021','DEN','2960745','33348TX002000201','2014-04-01','2014-02-18 23:05:27','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 03:50:13'),(15444,12358,'Y','18','024','14','A','','','TE','0000710817','0000710817','','IL','1','Bean','Patricia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-04-12','F','',NULL,NULL,NULL,'','2495904','','2013-12-31','2013-12-31 14:47:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-02 04:28:09'),(22468,17940,'Y','18','021','EC','A','','','AC','0000411008','0000411008','MS00002605844','31','1','ROBINSON','TODD','D','','','34','587479892','7786 HILL LN',0,'SUMMIT','MS','39666',NULL,'CY','28049','1983-05-22','M','U',NULL,'N','021','DEN','3746473','46300MS002000101','2014-03-01','2014-02-09 18:54:22','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-10 21:30:56'),(21727,17350,'Y','18','021','EC','A','','','AC','0000307865','0000307865','TX00002407651','IL','1','Phan','Thanh','','','','34','586524263','2230 Templeton DR',0,'Arlington','TX','76006',NULL,'CY','48439','1950-03-02','M','M',':RET:2047-9','N','021','DEN','3493068','33348TX002000201','2014-03-01','2014-02-06 13:55:00','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:07'),(20015,15963,'Y','18','021','EC','A','','','AC','0000404313','0000404313','TX00001607555','IL','1','chaudhry','uzma','','','','34','045045647','14618 timber cliff ln',0,'cypress','TX','77429',NULL,'CY','48201','1975-03-16','F','M',':RET:2028-9','N','021','DEN','3071510','33348TX002000201','2014-03-01','2014-01-26 00:48:10','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-26 19:00:11'),(19060,15183,'Y','18','021','EC','A','','','AC','0000564069','0000564069','TX00002421725','IL','1','BAZAN GARZA','LAURENCIO','','','','34','637549600','4625 GLOBE WILLOW DR',0,'EL PASO','TX','79922','2221','CY','48141','1949-07-27','M','M',':RET:2106-3','N','021','DEN','2759370','33348TX002000201','2014-03-01','2014-01-18 13:26:55','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-21 08:44:15'),(5548,4403,'Y','18','021','EC','A','','','AC','0000672725','0000672725','OH00000183057','IL','1','GIBSON','ROBERT','','','','34','291486885','2360 BODETTE AVE',0,'TOLEDO','OH','43613','2168','CY','39095','1949-08-05','M','U',':RET:2106-3','N','021','HLT','1240584','92036OH004002601','2014-01-01','2013-11-26 19:42:35','448.00',NULL,NULL,'470.37','22.37','R-OH001','OH0','470.37',NULL,0,'2013-12-25 23:16:03'),(5494,4361,'Y','18','021','EC','A','','','AC','0000205780','0000205780','OH00000193879','IL','1','BABOCK','AMY','','','','34','293442963','3747 GARRISON RD',0,'TOLEDO','OH','43613','4723','CY','39095','1964-04-02','F','U',':RET:2106-3','N','021','HLT','2068128','92036OH003002604','2014-01-01','2013-12-19 16:58:27','157.00',NULL,NULL,'347.41','190.41','R-OH001','OH0','347.41',NULL,0,'2013-12-25 23:11:06'),(5058,4007,'Y','18','024','14','A','','','TE','0000557817','0000557817','','IL','1','Herbly','Nada',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-05-09','F','',NULL,NULL,NULL,'','1992255','','2013-12-18','2013-12-18 22:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:00:21'),(9098,7222,'Y','18','021','EC','A','','','AC','0001024258','0001024258','OH00001072560','31','1','DIETER','REBECCA','','','','34','288744737','PO BOX 18122',0,'CLEVLAND HEIGHTS','OH','44118',NULL,'CY','39035','1962-02-10','F','U',':RET:2106-3','N','021','DEN','2370528','99734OH005000301','2014-01-01','2013-12-18 14:24:00','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:07:17'),(14562,11618,'Y','18','024','14','A','','','TE','0000578790','0000578790','','IL','1','Barnett','Oretha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-20','F','',NULL,NULL,NULL,'','2138772','','2013-12-27','2013-12-27 12:28:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:35:18'),(2027,1660,'Y','18','021','EC','A','','','AC','0000467071','0000467071','OH00000302462','IL','1','PieroneK','Stephanie','','','','34','298820394','400 West Aurora Rd',0,'Northfield','OH','44067',NULL,'CY','39153','1975-12-30','F','U',NULL,'T','021','HLT','477759','52664OH152000901','2014-01-01','2013-12-10 14:25:49','174.00',NULL,NULL,'234.05','60.05','R-OH012','OH0','234.05',NULL,0,'2013-12-25 19:15:15'),(5450,4330,'Y','18','021','EC','A','','','AC','0000305830','0000305830','OH00001255446','IL','1','Martin','James','','','','34','289889108','3318 HEARTHSTONE RD',0,'PARMA','OH','44134','2642','CY','39035','1986-04-24','M','U',':RET:2106-3','N','021','HLT','1853376','92036OH003000805','2014-01-01','2013-12-19 07:24:58','110.00',NULL,NULL,'255.87','145.87','R-OH011','OH0','255.87',NULL,0,'2013-12-25 23:10:09'),(26066,20670,'N','01','021','EC','A',NULL,NULL,'','0000087536','0000294466','','IL','1','RUSSO','CATRINA','','','','34','302153268','3308 GLENEAGLE DR',0,'FINDLAY','OH','45840','2917','CY','39063','1988-07-01','F','',NULL,'N','021','HLT','3788828','92036OH002001501','2014-04-01','2014-02-26 17:02:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.19',NULL,0,'2014-02-26 21:02:41'),(2375,1937,'Y','18','021','EC','A','','','AC','0000827134','0000827134','OH00000959277','IL','1','Churchill','Gary','','','','34','298466825','3287 PHEASANT RUN RD',0,'CORTLAND','OH','44410','9139','CY','39155','1951-03-04','M','M',':RET:2106-3','N','021','DEN','289986','99734OH005000401','2014-01-01','2013-12-09 10:03:37','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:32:51'),(3965,3170,'Y','18','021','EC','A','','','AC','0000951775','0000951775','OH00000487068','IL','1','Cickovskis','Agnar','Visvalbs','','','34','106463312','3440 W SPRAGUE RD',0,'PARMA','OH','44134','6378','CY','39035','1952-07-16','M','M',':RET:2106-3','N','021','HLT','584244','52664OH151001501','2014-01-01','2013-12-13 16:16:21','830.00',NULL,NULL,'2354.00','1524.00','R-OH011','OH0','847.67',NULL,0,'2013-12-25 21:38:28'),(4148,3306,'Y','18','024','14','A','','','TE','0000614088','0000614088','','IL','1','Shamy','Rachel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-10-04','F','',NULL,NULL,NULL,'','1081283','','2013-12-17','2013-12-17 12:46:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:48:41'),(16182,12955,'N','19','021','EC','A',NULL,NULL,'','0000839981','0000945525','','IL','1','HOLT','NOAH','','','','34','003026969','5657 AMESBURY DR',0,'DALLAS','TX','75206','3000','CY','48113','2005-07-31','M','',':RET:2106-3','N','021','DEN','2336509','33348TX002000201','2014-02-01','2014-01-03 18:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-01-05 00:00:34'),(14744,11773,'Y','18','021','EC','A','','','AC','0001148731','0001148731','OH00000249156','IL','1','Wallis','Sharon','','','','34','288660310','1916 W MIDLOTHIAN BLVD',0,'YOUNGSTOWN','OH','44511','3540','CY','39099','1959-04-15','F','U',NULL,'N','021','HLT','1709847','92036OH005003206','2014-02-01','2013-12-28 16:35:52','411.00',NULL,NULL,'516.78','105.78','R-OH013','OH0','516.78',NULL,1,'2013-12-29 11:10:07'),(14862,11867,'Y','18','021','EC','A','','','AC','0000195135','0000195135','OH00001030426','IL','1','Ruffing','Eugenea','M','','','34','272760136','6553 Seel Rd.',0,'Bellevue','OH','44811',NULL,'CY','39077','1979-02-19','F','M',':RET:2106-3','N','021','HLT','2115962','92036OH005002706','2014-01-01','2013-12-23 20:16:47','185.00',NULL,NULL,'236.72','51.72','R-OH006','OH0','236.72',NULL,1,'2013-12-29 11:15:24'),(19677,15681,'Y','18','021','EC','A','','','AC','0000434461','0000434461','TX00002298832','IL','1','BARRIOS','LINDA','','','','34','463968260','2504 NORTH AVE',0,'PASADENA','TX','77506',NULL,'CY','48201','1954-02-20','F','U',NULL,'N','021','DEN','3250385','33348TX002000201','2014-03-01','2014-01-22 22:03:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-23 21:00:35'),(19696,15695,'Y','18','021','EC','A','','','AC','0001196737','0001196737','TX00001670942','IL','1','Seymore','Andrew','','','','34','458888852','104 HUGHES ST',0,'HEARNE','TX','77859','2039','CY','48395','1952-09-11','M','M',':RET:2054-5','N','021','DEN','1855708','33348TX002000201','2014-03-01','2014-01-23 11:58:58','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-01-23 21:00:45'),(20597,16457,'N','19','021','EC','A',NULL,NULL,'','0000930940','0000627915','','IL','1','Rosier','Janelle','','','','34','294065480','59221 LOCKWOOD RUN RD',0,'SHADYSIDE','OH','43947','9716','CY','39013','2002-01-24','F','',':RET:2106-3','N','021','DEN','3317452','99734OH005000401','2014-03-01','2014-01-30 10:17:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:11'),(21932,17515,'Y','18','021','EC','A','','','AC','0000560635','0000560635','TX00001475831','IL','1','SOWEMIMO','RAYMOND','','','','34','467438562','5830 COASTAL WAY',0,'HOUSTON','TX','77085','1922','CY','48201','1954-08-13','M','M',':RET:2054-5','N','021','DEN','3222083','33348TX002000201','2014-03-01','2014-02-07 10:12:47','0.00',NULL,NULL,'88.07','88.07','R-TX010','TX0','15.85',NULL,0,'2014-02-07 19:00:11'),(23899,19011,'Y','18','021','EC','A','','','AC','0001148768','0001148768','OH00002660609','IL','1','Thompson','Brenda','','','','34','295369055','4622 EASTMAN AVE',0,'DAYTON','OH','45432','1430','CY','39113','1942-08-11','F','U',':RET:2106-3','N','021','HLT','3095938','92036OH004000501','2014-03-01','2014-02-14 10:52:06','0.00',NULL,NULL,'573.40','573.40','R-OH003','OH0','573.40',NULL,0,'2014-02-14 21:32:23'),(25651,20350,'Y','18','024','14','A','','','TE','0000178944','0000178944','','IL','1','Schneider','Rachael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-01-14','F','',NULL,NULL,NULL,'','3610846','','2014-02-22','2014-02-22 11:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 08:30:39'),(26688,21159,'Y','18','021','EC','A','','','AC','0002181306','0002181306','LA00002483908','IL','1','ashley','wanda','','','','34','464491155','117 sylvia st',0,'lafayette','LA','70506',NULL,'CY','22055','1964-12-17','F','M',':RET:2106-3','N','021','DEN','3035962','18575LA002000101','2014-04-01','2014-02-27 20:40:19','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-28 21:31:27'),(27815,22000,'Y','18','021','EC','A','','','AC','0000187538','0000187538','OH00003522075','IL','1','SULLIVAN','JANICE','','','','34','283483590','110 OAKDALE AVE',0,'AKRON','OH','44302','1542','CY','39153','1958-03-18','F','U',':RET:2106-3','N','021','HLT','3733824','52664OH151001306','2014-04-01','2014-03-05 16:19:17','419.00',NULL,NULL,'520.28','101.28','R-OH012','OH0','520.28',NULL,0,'2014-03-05 21:31:53'),(28200,22316,'Y','18','021','EC','A','','','AC','0000137792','0000137792','TX00002692446','IL','1','BALINO','LETICIA','C','','','34','457414410','260 SAN MARCOS',0,'EAGLE PASS','TX','78852',NULL,'CY','48323','1951-02-21','F','U',':RET:2106-3','N','021','DEN','3297370','33348TX002000201','2014-04-01','2014-03-06 16:36:38','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-06 21:30:08'),(28499,22551,'Y','18','021','EC','A','','','AC','0001100651','0001100651','OH00002756801','IL','1','Mallardi','Chloe','','','','34','283946661','1171 PITKIN AVE',0,'AKRON','OH','44310','1120','CY','39153','1991-08-05','F','U',':RET:2106-3','N','021','HLT','3831002','52664OH151001306','2014-04-01','2014-03-06 20:26:55','154.00',NULL,NULL,'223.01','69.01','R-OH012','OH0','223.01',NULL,0,'2014-03-07 21:31:47'),(282,232,'N','01','021','EC','A',NULL,NULL,'','0000260440','0000075204','','IL','1','Codispoti','Beverly','','','','34','269523676','7199 BLOUGH AVE SW',0,'NAVARRE','OH','44662','9295','CY','39151','1951-04-21','F','',NULL,'N','021','HLT','1009814','52664OH151001305','2014-01-01','2013-10-12 08:53:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-25 17:30:18'),(5361,4251,'Y','18','021','EC','A','','','AC','0001044474','0001044474','OH00000635620','IL','1','Vonderheide','Kathryn','','','','34','275561606','1911 Kenton St.',0,'Springfield','OH','44505',NULL,'CY','39099','1955-07-19','F','U',':RET:2106-3','N','021','HLT','2250100','92036OH001003201','2014-01-01','2013-12-18 19:43:28','460.00',NULL,NULL,'743.92','283.92','R-OH013','OH0','743.92',NULL,0,'2013-12-25 23:07:51'),(4896,3884,'Y','18','021','EC','A','','','AC','0000016576','0000016576','OH00000593476','IL','1','JONES','ALBERTA','','','','34','280683950','1150 PITKIN AVE',0,'AKRON','OH','44310','1121','CY','39153','1971-01-14','F','U',NULL,'N','021','HLT','785445','52664OH151001501','2014-01-01','2013-10-04 14:04:17','223.00',NULL,NULL,'354.39','131.39','R-OH012','OH0','354.39',NULL,0,'2013-12-25 22:31:40'),(4857,3848,'Y','18','021','EC','A','','','AC','0001038560','0001038560','OH00000775022','IL','1','Thatcher','Sierra','','','','34','595786121','2848 MARTIN HILL RD',0,'ABERDEEN','OH','45101','9722','CY','39015','1988-12-01','F','U',NULL,'N','021','HLT','897183','92036OH003000606','2014-01-01','2013-11-08 08:36:10','147.00',NULL,NULL,'225.08','78.08','R-OH005','OH0','225.08',NULL,0,'2013-12-25 22:30:33'),(4572,3621,'Y','18','024','14','A','','','TE','0001184956','0001184956','','IL','1','PATTERSON','HOLLY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-09','F','',NULL,NULL,NULL,'','1115997','','2013-12-12','2013-12-12 14:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:05:01'),(5254,4168,'Y','18','021','EC','A','','','AC','0001212337','0001212337','OH00000078937','IL','1','Haffner','Joseph','','','','34','289507788','6898 GREENBRIAR DR',0,'PARMA HEIGHTS','OH','44130','4661','CY','39035','1950-03-13','M','M',':RET:2106-3','N','021','HLT','2069214','52664OH151001305','2014-01-01','2013-12-19 10:05:39','1183.00',NULL,NULL,'1676.62','493.62','R-OH011','OH0','742.48',NULL,0,'2013-12-25 23:05:13'),(27309,21622,'Y','18','021','EC','A','','','AC','0000952760','0000952760','TX00003680218','IL','1','COOK','KAREEM','','','','34','466875679','4901 KINSEY DR',0,'TYLER','TX','75703','3052','CY','48423','1981-01-22','M','U',NULL,'N','021','DEN','2924282','33348TX002000201','2014-04-01','2014-03-04 13:47:52','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-03-04 21:00:38'),(6258,4960,'Y','18','024','14','A','','','TE','0000162235','0000162235','','IL','1','Cooper','Julian',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-01','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:32:12'),(15068,12045,'Y','18','021','EC','A','','','AC','0001449874','0001449874','LA00000238685','IL','1','Milaton','Joyce','','','','34','433862758','62197 N 15TH ST',0,'SLIDELL','LA','70460','4438','CY','22103','1952-11-22','F','M',':RET:2054-5','N','021','DEN','1670368','18575LA002000201','2014-02-01','2013-12-30 18:08:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:03:48'),(14462,11539,'Y','18','021','EC','A','','','AC','0000513338','0000513338','OH00001286247','IL','1','EAKIN','BARBARA','','','','34','292527843','3968 MARSH CREEK LN',0,'ROOTSTOWN','OH','44272','9280','CY','39133','1952-08-15','F','U',NULL,'N','021','HLT','1753889','52664OH151001501','2014-02-01','2013-12-26 18:48:44','508.00',NULL,NULL,'751.58','243.58','R-OH012','OH0','751.58',NULL,0,'2013-12-28 03:32:49'),(20735,16568,'Y','18','021','EC','A','','','AC','0000806383','0000806383','OH00001572010','IL','1','artman','terry','','','','34','281444043','2325 DELAWARE AVE SW',0,'CANTON','OH','44706','2128','CY','39151','1949-06-03','M','U',':RET:2106-3','N','021','HLT','3473193','52664OH152000901','2014-03-01','2014-01-30 14:08:30','469.00',NULL,NULL,'490.00','21.00','R-OH015','OH0','490.00',NULL,0,'2014-01-30 21:01:20'),(23504,18722,'Y','18','021','EC','A','','','AC','0000510464','0000510464','TX00002200540','31','1','vest','david','','','','34','458827932','po box 924',0,'brownsboro','TX','75756',NULL,'CY','48213','1952-01-26','M','U',':RET:2106-3','N','021','DEN','2771288','33348TX002000101','2014-03-01','2014-02-13 11:59:36','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-13 22:02:09'),(24448,19420,'Y','18','021','EC','A','','','AC','0002159680','0002159680','LA00002554287','IL','1','JOHNSON','RONISHA','','','','34','523657329','1101 REIGER ROAD',0,'BATON ROUGE','LA','70809',NULL,'CY','22033','1988-06-18','F','U',':RET:2054-5','N','021','DEN','2650105','18575LA002000101','2014-04-01','2014-02-18 10:31:00','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-18 22:01:24'),(24900,19741,'N','19','021','EC','A',NULL,NULL,'','0000737896','0000997798','','IL','1','MARTIN','NEVELLE','','','','34','268177159','15722 E TOWNSHIP ROAD 104',0,'ATTICA','OH','44807','9476','CY','39147','2010-10-21','F','',NULL,'N','021','HLT','3420153','92036OH003002705','2014-01-01','2014-02-19 17:18:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31','CIC',0,'2014-02-20 05:41:15'),(26306,20870,'Y','18','021','EC','A','','','AC','0000162973','0000162973','TX00002510470','IL','1','Rivera','Luis','','','','34','466936509','4009 VALENTINE ST',0,'FORT WORTH','TX','76107','6408','CY','48439','1983-04-30','M','U',':RET:2106-3','N','021','DEN','3647888','33348TX002000101','2014-04-01','2014-02-27 11:25:35','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-28 06:31:31'),(26631,21116,'Y','18','024','14','A','','','TE','0000613887','0000613887','','IL','1','Mayers','Stephanie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-03-27','F','',NULL,NULL,NULL,'','2770877','','2014-02-28','2014-02-28 15:53:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:57'),(27570,21804,'N','01','021','EC','A',NULL,NULL,'','0000209610','0000937254','','IL','1','Tupaz','Dawn','Loiacono','','','34','274869727','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','1975-06-19','F','',':RET:2106-3','N','021','DEN','3012426','99734OH005000301','2014-04-01','2014-03-04 14:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:20'),(183,152,'Y','18','021','EC','A','','','AC','0000975205','0000975205','OH00000774010','IL','1','Freed','Lydia','','','','34','301563885','1269 GRANT ST',0,'AKRON','OH','44301','1849','CY','39153','1957-04-09','F','M',':RET:2106-3','N','021','HLT','5402','52664OH151001306','2014-01-01','2013-12-05 13:57:01','382.00',NULL,NULL,'520.28','138.28','R-OH012','OH0','520.28',NULL,0,'2013-12-25 17:19:44'),(7830,6202,'Y','18','021','EC','A','','','AC','0000733581','0000733581','OH00001040755','31','1','DZIAK','MICHAEL','','','','34','270689680','P.O BOX 375',0,'CLYDE','OH','43410',NULL,'CY','39143','1960-02-04','M','M',':RET:2106-3','N','021','DEN','2025757','99734OH005000301','2014-01-01','2013-12-19 20:05:24','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2013-12-26 03:04:24'),(7283,5776,'Y','18','021','EC','A','','','AC','0000296769','0000296769','OH00000803860','IL','1','Walker','Tia','','','','34','276704223','2653 MAYFAIR RD',0,'AKRON','OH','44312','5409','CY','39153','1960-04-20','F','M',':RET:2106-3','N','021','HLT','1062341','52664OH151001501','2014-01-01','2013-12-13 20:55:46','230.00',NULL,NULL,'1026.39','796.39','R-OH012','OH0','545.63',NULL,0,'2013-12-26 02:02:45'),(14676,11716,'Y','18','021','EC','A','','','AC','0000213099','0000213099','MS00000019251','IL','1','Creswell','Priestly','','','','34','428613415','32 GARDEN CIR',0,'JACKSON','MS','39209','3417','CY','28049','1979-10-17','F','U',':RET:2054-5','N','021','DEN','1615469','46300MS002000201','2014-02-01','2013-12-28 14:36:06','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2013-12-29 11:08:24'),(7136,5663,'Y','18','021','EC','A','','','AC','0001228020','0001228020','TX00000649404','IL','1','Schulte','Robert','','','','34','508642766','318 W CORPORATE DR',0,'LEWISVILLE','TX','75067','6514','CY','48121','1957-12-02','M','U',':RET:2106-3','N','021','DEN','1713201','33348TX002000101','2014-01-01','2013-12-24 19:42:25','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 01:51:46'),(5451,4331,'Y','18','024','14','A','','','TE','0000305830','0000305830','','IL','1','Martin','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-24','M','',NULL,NULL,NULL,'','1853376','','2013-12-19','2013-12-19 17:49:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:11'),(2759,2231,'N','01','021','EC','A',NULL,NULL,'','0000526743','0001115904','','IL','1','royster','denise','','','','34','274708757','232 COUNTY ROAD 681',0,'SULLIVAN','OH','44880','9717','CY','39005','1959-10-30','F','',':RET:2106-3','N','021','HLT','914520','52664OH151001305','2014-01-01','2013-12-02 17:12:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2013-12-25 19:49:16'),(3105,2495,'Y','18','021','EC','A','','','AC','0000088529','0000088529','OH00000298602','31','1','STEELE','DENNIS','','','','34','546130483','P O BOX 492',0,'MONROEVILLE','OH','44847',NULL,'CY','39077','1965-10-18','M','M',':RET:2106-3','T','021','HLT','698184','92036OH003002706','2014-01-01','2013-12-06 13:05:33','564.00',NULL,NULL,'667.37','103.37','R-OH006','OH0','382.89',NULL,0,'2013-12-25 20:20:23'),(21406,17108,'Y','18','021','EC','A','','','AC','0000559476','0000559476','OH00002131467','IL','1','Fink','Joseph','','','','34','291823909','5307 BRIDGE AVE',0,'CLEVELAND','OH','44102','3347','CY','39035','1979-11-03','M','U',':RET:2106-3','N','021','DEN','2745284','99734OH005000401','2014-03-01','2014-02-04 14:48:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-04 21:01:05'),(23286,18564,'Y','18','021','EC','A','','','AC','0000951847','0000951847','OH00002501118','IL','1','NIXON','SONA','','','','34','203633320','3867 W MARKET ST',0,'FAIRLAWN','OH','44333',NULL,'CY','39153','1982-05-02','F','M',NULL,'N','021','DEN','3670943','99734OH005000301','2014-03-01','2014-02-12 19:04:09','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-13 22:00:03'),(24588,19519,'N','19','021','EC','A',NULL,NULL,'','0000278358','0000988936','','IL','1','BOGGAN','ALYA','','','','34','291025826','20551 MILLER AVE',0,'EUCLID','OH','44119','2312','CY','39035','1997-12-27','F','',NULL,'N','021','DEN','3495804','99734OH005000301','2014-04-01','2014-02-19 13:13:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:10:02'),(28182,22300,'Y','18','021','EC','A','','','AC','0001038666','0001038666','OH00003178241','IL','1','rios','elisa','','','','34','268549105','17936 W MOLINE MARTIN RD',0,'GRAYTOWN','OH','43432','9700','CY','39123','1953-08-01','F','M',NULL,'N','021','HLT','3072535','92036OH003002705','2014-04-01','2014-03-06 13:50:39','464.00',NULL,NULL,'552.66','88.66','R-OH006','OH0','552.66',NULL,0,'2014-03-06 21:02:54'),(5908,4679,'N','01','021','EC','A',NULL,NULL,'','0000321045','0001045687','','IL','1','Bathuru','Pavani','','','','34','065066036','10820 Kingslake Dr',0,'Cincinnati','OH','45242',NULL,'CY','39061','1982-05-21','F','',':RET:2029-7','N','021','DEN','1698426','99734OH005000301','2014-01-01','2013-12-24 00:42:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:56'),(2176,1788,'N','01','021','EC','A',NULL,NULL,'','0000393642','0001050620','','IL','1','Loughridge','Lisa','M','','','34','302680864','219 S BRANDON AVE',0,'CELINA','OH','45822','2012','CY','39107','1963-10-15','F','',':RET:2106-3','N','021','HLT','1182800','92036OH003001501','2014-01-01','2013-12-09 20:34:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','410.48',NULL,0,'2013-12-25 19:19:15'),(3071,2467,'N','01','021','EC','A',NULL,NULL,'','0000015736','0000016769','','IL','1','Polsky','David','','','','34','128608731','2344 LAUREL ST',0,'NEW ORLEANS','LA','70130','5508','CY','22071','1978-01-04','M','',':RET:2106-3','N','021','DEN','1029260','18575LA002000101','2014-01-01','2013-12-06 17:16:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 20:19:28'),(16736,13391,'N','19','021','EC','A',NULL,NULL,'','0000674079','0000740293','','S1','1','Ferrari','Anthony','L','','','34','285069401','1705 ARNDALE RD',0,'STOW','OH','44224','1850','CY','39153','2001-08-07','M','',':RET:2106-3','N','021','HLT','1624945','52664OH151001305','2014-02-01','2014-01-06 20:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-08 18:24:50'),(5873,4660,'N','01','021','EC','A',NULL,NULL,'','0000100065','0000912955','','IL','1','Newberry','Kathy',NULL,NULL,NULL,NULL,NULL,'690 greenville- nashville rd.',0,'greenville','OH','45331',NULL,'CY','39037','1957-08-01','F','',':RET:2106-3','N','021','HLT','2059567','92036OH005000504','2014-01-01','2013-12-23 21:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','554.56',NULL,0,'2013-12-25 23:49:16'),(5152,4084,'Y','18','021','EC','A','','','AC','0000351563','0000351563','OH00000135319','IL','1','Thomas','Ronald','','','','34','270504177','4666 Rockcut rd',0,'Norton','OH','44203',NULL,'CY','39153','1952-02-15','M','M',':RET:2106-3','N','021','DEN','1878863','99734OH005000401','2014-01-01','2013-12-19 09:58:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:02:49'),(5162,4093,'Y','18','024','14','A','','','TE','0000912943','0000912943','','IL','1','SPENCE','MINDI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-10-10','F','',NULL,NULL,NULL,'','2421685','','2013-12-19','2013-12-19 10:44:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:03:05'),(21540,17205,'N','01','021','EC','A',NULL,NULL,'','0000073971','0000314737','','IL','1','MacCarthy','Eunice','','','','34','077949273','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1963-08-28','F','',NULL,'N','021','DEN','3765230','99734OH005000401','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:09'),(22818,18210,'N','19','021','EC','A',NULL,NULL,'','0001103479','0000313292','','IL','1','White','Taylor','','','','34','294020066','1409 Grimes Circle',0,'Urbana','OH','43078',NULL,'CY','39021','1998-02-18','F','',':RET:2106-3','N','021','HLT','3303777','92036OH005000504','2014-03-01','2014-02-10 20:37:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2014-02-11 21:02:01'),(24544,19497,'Y','18','021','EC','A','','','AC','0000928544','0000928544','OH00002207602','IL','1','JOHNSON','DAVID','','','','34','282623831','7122 RIDGE AVE SE',0,'EAST SPARTA','OH','44626','9448','CY','39151','1959-05-07','M','U',':RET:2106-3','T','021','HLT','3091078','52664OH151001301','2014-04-01','2014-02-19 08:53:15','297.00',NULL,NULL,'770.55','473.55','R-OH015','OH0','547.54',NULL,0,'2014-02-20 04:03:16'),(24935,19773,'Y','18','021','EC','A','','','AC','0000114836','0000114836','MS00001922899','IL','1','TAYLOR','GLENDA','','','','34','587542507','354 HICKORY HILL CIR',0,'FLORENCE','MS','39073','8561','CY','28121','1950-08-29','F','M',':RET:2106-3','N','021','DEN','3260804','46300MS002000101','2014-04-01','2014-02-20 16:48:49','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15','CIC',0,'2014-02-20 21:30:22'),(25089,19898,'Y','18','024','14','A','','','TE','0000471065','0000471065','','IL','1','Vegara','Koviljka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-09-27','F','',NULL,NULL,NULL,'','3254818','','2014-02-28','2014-02-20 23:07:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:04'),(27034,21410,'N','01','021','EC','A',NULL,NULL,'','0000024875','0000003865','','IL','1','Francher','Autumn','','','','34','466933600','15174 FM 95 S',0,'MOUNT ENTERPRISE','TX','75681','3167','CY','48401','1987-10-24','F','',':RET:2106-3','N','021','DEN','3433154','33348TX002000201','2014-04-01','2014-03-03 14:43:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-03 21:00:17'),(1176,968,'Y','18','021','EC','A','','','AC','0000785751','0000785751','OH00000457094','IL','1','Boleyn','Dawn','','','','34','276446642','644 Cherry Park Oval',0,'Aurora','OH','44202',NULL,'CY','39133','1951-11-17','F','M',':RET:2106-3','N','021','HLT','816922','52664OH151001501','2014-01-01','2013-12-03 16:22:03','386.19',NULL,NULL,'768.43','382.24','R-OH012','OH0','768.43',NULL,0,'2013-12-25 18:19:15'),(26115,20711,'Y','18','021','EC','A','','','AC','0000847186','0000847186','OH00003262443','IL','1','Loomis','William','','','','34','224118600','5626 Summerville Dr',0,'Galloway','OH','43119',NULL,'CY','39049','1966-07-03','M','M',':RET:2106-3','N','021','DEN','3374296','99734OH005000401','2014-03-01','2014-02-26 20:04:55','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:17'),(26881,21304,'Y','18','021','EC','A','','','AC','0000382218','0000382218','OH00002078511','IL','1','Card','Barbara','Louise','','','34','298481930','3525 TUSCARAWAS ST W',0,'CANTON','OH','44708','5640','CY','39151','1949-06-17','F','U',':RET:2054-5','N','021','HLT','2712188','52664OH152000901','2014-04-01','2014-03-01 15:06:10','483.00',NULL,NULL,'490.00','7.00','R-OH015','OH0','490.00',NULL,0,'2014-03-01 21:01:09'),(26988,21378,'N','01','021','EC','A',NULL,NULL,'','0000805173','0001036187','','IL','1','Ulrich','Debra',NULL,NULL,NULL,NULL,NULL,'1828 W MAIN CROSS ST',0,'FINDLAY','OH','45840','1714','CY','39063','1958-01-21','F','',NULL,'T','021','HLT','2946834','92036OH006001501','2014-04-01','2014-03-02 14:46:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.28',NULL,0,'2014-03-03 01:00:41'),(13103,10447,'Y','18','021','EC','A','','','AC','0000155774','0000155774','OH00000356354','IL','1','hiser','timothy','','','','34','295845878','222 IDAHO AVE',0,'LORAIN','OH','44052','2160','CY','39093','1976-11-24','M','M',':RET:2106-3','T','021','DEN','1849804','99734OH005000401','2014-01-01','2013-12-23 13:04:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:13'),(16730,13390,'Y','18','021','EC','A','','','AC','0000142840','0000142840','OH00001988462','IL','1','Marty','Dana','','','','34','293725043','2156 Steiner rd',0,'Creston','OH','44217',NULL,'CY','39169','1976-10-28','F','M',':RET:2106-3','N','021','HLT','2533888','52664OH151001301','2014-02-01','2014-01-07 16:56:31','416.00',NULL,NULL,'982.35','566.35','R-OH014','OH0','276.08',NULL,0,'2014-01-08 18:24:49'),(16067,12867,'N','01','021','EC','A',NULL,NULL,'','0001139517','0000889625','','IL','1','PERIN','SAMUEL','D','','','34','272865900','246 MONTERAY VALLEY DR',0,'PEEBLES','OH','45660','9323','CY','39001','1976-09-30','M','',':RET:2106-3','N','021','DEN','1688697','99734OH005000401','2014-02-01','2014-01-03 10:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:03:42'),(611,503,'Y','18','021','EC','A','','','AC','0000530677','0000530677','OH00000203881','IL','1','BUCHER','LINDA','','','','34','302464616','1256 TIMBERCREEK DR',0,'HAMILTON','OH','45013','9318','CY','39017','1949-11-25','F','M',NULL,'N','021','DEN','2385873','99734OH005000401','2014-01-01','2013-12-16 10:05:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:00:34'),(1516,1265,'Y','18','021','EC','A','','','AC','0000447466','0000447466','OH00001511168','IL','1','MCCLURG','JEFF','','','','34','293627873','1233 HIGH ST',0,'FAIRPORT HARBOR','OH','44077','5560','CY','39085','1962-09-13','M','U',NULL,'N','021','DEN','2451734','99734OH005000401','2014-01-01','2013-12-24 14:22:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:49:40'),(14594,11647,'N','01','021','EC','A',NULL,NULL,'','0001219600','0000389847','','IL','1','Hedrick','Rebecca','S','','','34','277646320','555 FRANKLIN AVE',0,'BARBERTON','OH','44203','2922','CY','39153','1958-08-24','F','',':RET:2106-3','N','021','HLT','1988757','52664OH151001301','2014-02-01','2013-12-27 11:50:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2013-12-28 03:36:12'),(21790,17402,'Y','18','021','EC','A','','','AC','0000287133','0000287133','OH00002449065','IL','1','Cole','Tamika','Nicole','','','34','302926508','11918 HAMLEN AVE',0,'CLEVELAND','OH','44120','1126','CY','39035','1991-04-01','F','U',':RET:2054-5','N','021','DEN','3636119','99734OH005000401','2014-03-01','2014-02-06 14:15:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:00:43'),(23411,18653,'Y','18','021','EC','A','','','AC','0000318424','0000318424','TX00002423379','IL','1','WOODARD','KEWAN','','','','34','462438133','113 MISSIONARY CIRCLE',0,'HEARNE','TX','77859',NULL,'CY','48395','1978-04-30','M','U',NULL,'N','021','DEN','3552527','33348TX002000201','2014-03-01','2014-02-12 19:46:18','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-02-13 22:01:16'),(23726,18890,'N','01','021','EC','A',NULL,NULL,'','0000412926','0000488051','','IL','1','Corbett','Deborah','','','','34','441787209','22427 PARK POINT DR',0,'KATY','TX','77450','5806','CY','48201','1964-04-11','F','',':RET:2106-3','T','021','DEN','2815666','33348TX002000101','2014-03-01','2014-02-14 16:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-14 21:30:55'),(26095,20696,'Y','18','021','EC','A','','','AC','0002006714','0002006714','LA00003508992','IL','1','ALLEN','MARK','','','','34','524531633','442 MEHLE ST',0,'ARABI','LA','70032','1058','CY','22087','1963-03-23','M','M',NULL,'N','021','DEN','3046223','18575LA002000201','2014-03-01','2014-02-27 13:40:19','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-28 06:30:10'),(26164,20746,'Y','18','021','EC','A','','','AC','0000455363','0000455363','OH00002293417','IL','1','fugate','mandy','','','','34','290744698','897 BERWIN ST',0,'AKRON','OH','44310','2145','CY','39153','1979-03-02','F','U',':RET:2106-3','T','021','DEN','3136325','99734OH005000401','2014-03-01','2014-02-27 17:57:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:33'),(26862,21289,'Y','18','021','EC','A','','','AC','0000958916','0000958916','TX00003476625','IL','1','Merino','Evelyn','','','','34','639800215','526 N DRENNAN ST',0,'HOUSTON','TX','77003','1317','CY','48201','1990-09-17','F','U',NULL,'N','021','DEN','2854432','33348TX002000101','2014-04-01','2014-02-28 20:01:20','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-01 21:00:57'),(27165,21509,'Y','18','021','EC','A','','','AC','0001043033','0001043033','TX00002376628','IL','1','Canales','Ernest','','','','34','462434478','4331 BRICK HOUSE',0,'SAN ANTONIO','TX','78222','2705','CY','48029','1978-06-03','M','M',':RET:2106-3','N','021','DEN','2981799','33348TX002000201','2014-04-01','2014-03-03 10:34:53','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-03-03 21:31:01'),(28196,22312,'Y','18','024','14','A','','','TE','0001023386','0001023386','','IL','1','Layne','Luther',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-26','M','',NULL,NULL,NULL,'','3392286','','2014-03-31','2014-03-06 10:39:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-06 21:30:06'),(13323,10637,'N','01','021','EC','A',NULL,NULL,'','0000022199','0000909820','','IL','1','PATEL','ALPABEN','JAYESH','','','34','644217857','14405 RIO BONITO ROAD',0,'HOUSTON','TX','77083',NULL,'CY','48201','1967-05-09','F','',':RET:2029-7','N','021','DEN','1655120','33348TX002000201','2014-01-01','2013-12-23 16:58:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:58:25'),(9476,7516,'Y','18','021','EC','A','','','AC','0000399882','0000399882','OH00001103536','IL','1','Bitonte','Richard','','','','34','289564580','508 Chatham Court',0,'Pinkerington','OH','43147',NULL,'CY','39045','1970-06-30','M','M',':RET:2106-3','N','021','DEN','2396650','99734OH005000401','2014-01-01','2013-12-21 11:31:43','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:34:33'),(1200,989,'Y','18','021','EC','A','','','AC','0000571963','0000571963','OH00000572844','IL','1','Pielech','Dwayne','','','','34','291689121','435 W 48TH ST',0,'SHADYSIDE','OH','43947','1050','CY','39013','1962-04-19','M','M',':RET:2106-3','N','021','DEN','1159487','99734OH005000301','2014-01-01','2013-12-03 03:54:57','0.00',NULL,NULL,'59.76','59.76','R-OH016','OH0','0.00',NULL,0,'2013-12-25 18:19:52'),(15938,12761,'Y','18','021','EC','A','','','AC','0001016864','0001016864','OH00001959983','IL','1','Fishback','Thomas','','','','34','281686662','1 ALLISON CT',0,'WILLIAMSBURG','OH','45176','9298','CY','39025','1960-09-14','M','M',':RET:2106-3','T','021','HLT','1995400','92036OH005000606','2014-02-01','2014-01-02 13:38:41','798.00',NULL,NULL,'1084.52','286.52','R-OH005','OH0','503.62',NULL,0,'2014-01-03 02:07:08'),(2037,1667,'Y','18','024','14','A','','','TE','0001190116','0001190116','','IL','1','Franklin','Eugene',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-26','M','',NULL,NULL,NULL,'','791064','','2013-12-09','2013-12-09 21:40:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:15:29'),(2122,1742,'Y','18','021','EC','A','','','AC','0000535733','0000535733','OH00000393992','IL','1','Couch','Nora','','','','34','292507858','1153 Wimbeldon Blvd',0,'Columbus','OH','43228',NULL,'CY','39049','1951-01-17','F','U',':RET:2106-3','T','021','DEN','151975','99734OH005000401','2014-01-01','2013-12-10 13:55:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:17:44'),(13811,11023,'Y','18','021','EC','A','','','AC','0000367377','0000367377','OH00000655730','IL','1','Olman','John','','','','34','272447519','1307 Dillon Ave',0,'Cincinnati','OH','45208',NULL,'CY','39061','1954-08-20','M','U',NULL,'N','021','HLT','1803208','92036OH005001205','2014-01-01','2013-12-23 01:43:47','396.00',NULL,NULL,'558.80','162.80','R-OH004','OH0','558.80',NULL,0,'2013-12-26 13:11:36'),(13405,10697,'Y','18','021','EC','A','','','AC','0001216259','0001216259','OH00000005685','IL','1','scott','jerry','','','','34','277667293','6858 eldorado dr',0,'liberty township','OH','45044',NULL,'CY','39017','1968-09-12','M','M',':RET:2106-3','N','021','DEN','2048172','99734OH005000301','2014-01-01','2013-12-23 09:41:25','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:26'),(7809,6186,'Y','18','021','EC','A','','','AC','0000859269','0000859269','TX00000228159','31','1','Martinez','Teresa','','','','34','463922933','PO BOX 523',0,'MARKHAM','TX','77456',NULL,'CY','48321','1950-05-09','F','U',NULL,'N','021','DEN','1812144','33348TX002000201','2014-01-01','2013-12-20 17:40:47','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:53'),(5035,3987,'N','01','021','EC','A',NULL,NULL,'','0000031911','0000223686','','IL','1','Vaughn','Danny','','','','34','269601561','1213 Mitchell Rd.',0,'Wilmington','OH','45177',NULL,'CY','39027','1957-02-16','M','',':RET:2106-3','N','021','HLT','1203080','92036OH002000601','2014-01-01','2013-12-07 08:53:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','578.36',NULL,0,'2013-12-25 22:47:51'),(19396,15463,'Y','18','021','EC','A','','','AC','0000001066','0000001066','OH00001514025','IL','1','Cegelski','Mary','','','','34','299469711','14111 SAINT JAMES AVE',0,'CLEVELAND','OH','44135','1465','CY','39035','1952-01-22','F','M',':RET:2106-3','N','021','DEN','1989294','99734OH005000401','2014-03-01','2014-01-21 14:03:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,1,'2014-01-22 03:22:50'),(19813,15797,'Y','18','021','EC','A','','','AC','0000786197','0000786197','TX00002488625','IL','1','Williams','Samantha','','','','34','467618493','309 CHARLOTTE DR',0,'PORT LAVACA','TX','77979','3616','CY','48057','1980-06-26','F','U',NULL,'N','021','DEN','3061782','33348TX002000201','2014-03-01','2014-01-23 20:16:33','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-24 21:00:10'),(20812,16631,'Y','18','021','EC','A','','','AC','0000526943','0000526943','TX00001356249','IL','1','HIRSCHFELD','KATY','','','','34','156889065','2223 WATERLOO CITY LANE',0,'AUTSIN','TX','78741',NULL,'CY','48453','1987-11-10','F','U',':RET:2106-3','N','021','DEN','2706720','33348TX002000201','2014-03-01','2014-01-31 17:52:06','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-31 21:00:29'),(24139,19184,'N','19','021','EC','A',NULL,NULL,'','0000702823','0000992716','','IL','1','Raper','Zakary','K','','','34','295040302','4439 Happiness Lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','2000-03-20','M','',':RET:2106-3','N','021','HLT','3217890','92036OH004000601','2014-03-01','2014-02-15 10:42:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:52'),(26444,20975,'Y','18','024','14','A','','','TE','0000575896','0000575896','','IL','1','Warren','Edward','Gerard',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-12-27','M','',NULL,NULL,NULL,'','986308','','2014-03-31','2014-02-27 09:08:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:30:22'),(26805,21242,'Y','18','021','EC','A','','','AC','0000888230','0000888230','OH00002745348','IL','1','Ibrahim','Mohamed','','','','34','230791909','3700 HAMMERWOOD CT',0,'COLUMBUS','OH','43219','3124','CY','39049','1985-01-01','M','U',':RET:2054-5','N','021','DEN','3194267','99734OH005000301','2014-04-01','2014-02-28 21:02:25','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-03-01 21:00:25'),(28674,22690,'Y','18','021','EC','A','','','AC','0001210985','0001210985','OH00003730012','IL','1','hiris','victor','','','','34','271703672','154 HILLSDALE AVE',0,'ROSSFORD','OH','43460','1253','CY','39173','1960-05-20','M','U',':RET:2106-3','N','021','HLT','3352113','92036OH006002601','2014-04-01','2014-03-08 00:01:29','266.00',NULL,NULL,'315.47','49.47','R-OH001','OH0','315.47',NULL,0,'2014-03-08 21:30:51'),(1414,1176,'Y','18','021','EC','A','','','AC','0001550677','0001550677','LA00001415210','IL','1','Williams','Dylan','','','','34','230195707','910 philip st.',0,'new orleans','LA','70130',NULL,'CY','22071','1976-11-09','M','U',':RET:2106-3','T','021','DEN','2201075','18575LA002000201','2014-01-01','2013-12-24 14:09:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:02'),(1431,1193,'Y','18','021','EC','A','','','AC','0001427515','0001427515','LA00001029261','IL','1','Nellon','Lillian','','','','34','439087265','1457 CAROLYN SUE DR',0,'BATON ROUGE','LA','70815','4908','CY','22033','1960-06-22','F','U',':RET:2054-5','N','021','DEN','1662068','18575LA002000201','2014-01-01','2013-12-24 17:29:17','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:47:33'),(18417,14693,'Y','18','021','EC','A','','','AC','0001242688','0001242688','LA00001962657','IL','1','Thomas','Kim','','','','34','434354605','4653 STEPHEN GIRARD AVE',0,'NEW ORLEANS','LA','70126','4767','CY','22071','1963-04-05','F','M',':RET:2054-5','N','021','DEN','1596556','18575LA002000201','2014-02-01','2014-01-14 23:26:11','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:50'),(2432,1980,'N','01','021','EC','A',NULL,NULL,'','0000656902','0000697878','','IL','1','Dicintio','Cynthia','J','','','34','299526041','1570 CONGRESS LAKE RD',0,'MOGADORE','OH','44260','1925','CY','39133','1950-02-05','F','',':RET:2106-3','N','021','HLT','642860','52664OH151001301','2014-01-01','2013-12-08 20:52:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,0,'2013-12-25 19:34:12'),(2515,2050,'Y','18','021','EC','A','','','AC','0000722248','0000722248','MS00001208929','IL','1','Colvin','Angelea','','','','34','427116265','226 JOHN WILLIS RD',0,'WIGGINS','MS','39577','9350','CY','28131','1958-02-17','F','U',':RET:2106-3','N','021','DEN','747194','46300MS002000101','2014-01-01','2013-12-09 13:26:01','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2013-12-25 19:36:25'),(3273,2638,'N','01','021','EC','A',NULL,NULL,'','0000982674','0000834437','','IL','1','snyder','diana','','','','34','287563962','712 JACKSON AVE',0,'DEFIANCE','OH','43512','2717','CY','39039','1953-02-01','F','',':RET:2106-3','N','021','HLT','318703','92036OH005002606','2014-01-01','2013-11-28 08:22:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','529.21',NULL,0,'2013-12-25 20:47:15'),(14972,11967,'Y','18','021','EC','A','','','AC','0001152406','0001152406','TX00000230996','IL','1','Monkres','Debra','','','','34','453413831','1023 COUNTY ROAD 13800',0,'PARIS','TX','75462','2464','CY','48277','1961-11-27','F','M',':RET:2106-3','N','021','DEN','2228403','33348TX002000201','2014-02-01','2013-12-30 12:44:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-01 12:00:51'),(14807,11826,'Y','18','021','EC','A','','','AC','0002116183','0002116183','LA00000395956','IL','1','STEVENSON','SHARONNE','L','','','34','438817297','8945 SHARON HILLS ST',0,'BATON ROUGE','LA','70811','2356','CY','22033','1976-07-21','F','U',':RET:2054-5','N','021','DEN','1484129','18575LA002000101','2014-01-01','2013-12-23 19:41:25','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2013-12-29 11:13:56'),(3538,2840,'Y','18','021','EC','A','','','AC','0000024564','0000024564','TX00001046017','IL','1','Mcnicol','Judy','','','','34','385543949','4413 Bellaire Dr s',0,'Ft Worth','TX','76109',NULL,'CY','48439','1950-02-13','F','M',':RET:2106-3','N','021','DEN','1443085','33348TX002000101','2014-01-01','2013-12-22 11:35:41','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:21:41'),(6627,5255,'Y','18','021','EC','A','','','AC','0000781876','0000781876','OH00000563929','IL','1','Donahue','Angela','','','','34','301862394','1143 Bonniebrook Dr',0,'Miamisburg','OH','45342',NULL,'CY','39113','1980-04-25','F','U',':RET:2106-3','N','021','HLT','993092','92036OH005000505','2014-01-01','2013-12-11 15:57:03','46.00',NULL,NULL,'284.76','238.76','R-OH003','OH0','284.76',NULL,0,'2013-12-26 00:54:14'),(3859,3089,'Y','18','021','EC','A','','','AC','0000480891','0000480891','LA00000650103','IL','1','Taylor','Termerrial','T','','','34','435556197','182 KEMP ST',0,'CAMPTI','LA','71411','4005','CY','22069','1976-07-11','F','M',':RET:2054-5','N','021','DEN','988900','18575LA002000201','2014-01-01','2013-12-12 19:49:44','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 21:35:52'),(7781,6161,'Y','18','024','14','A','','','TE','0000718664','0000718664','','IL','1','Fan','Hong',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-01','F','',NULL,NULL,NULL,'','710623','','2013-12-20','2013-12-20 00:24:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:03:11'),(8100,6410,'Y','18','021','EC','A','','','AC','0000781890','0000781890','OH00000832448','IL','1','Horrigan','Patrick','','','','34','288580937','1273 SHERMAN ST',0,'AKRON','OH','44301','1811','CY','39153','1966-08-10','M','M',':RET:2106-3','T','021','HLT','2141014','52664OH151001501','2014-01-01','2013-12-20 17:53:55','200.00',NULL,NULL,'1194.09','994.09','R-OH012','OH0','480.76',NULL,0,'2013-12-26 03:10:52'),(22996,18334,'Y','18','024','14','A','','','TE','0000421506','0000421506','','IL','1','HILDRETH','MICHELLE','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-04-20','F','',NULL,NULL,NULL,'','3436698','','2014-02-12','2014-02-12 12:27:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:30:16'),(23525,18741,'Y','18','021','EC','A','','','AC','0001647551','0001647551','LA00001691825','IL','1','VASALLE','LISA','','','','34','334544084','2611 BERTRAND AVE',0,'LAKE CHARLES','LA','70611','3617','CY','22019','1962-01-18','F','M',':RET:2106-3','N','021','DEN','2916341','18575LA002000201','2014-03-01','2014-02-13 08:27:41','0.00',NULL,NULL,'43.83','43.83','R-LA004','LA0','14.61',NULL,0,'2014-02-13 22:02:23'),(23778,18921,'Y','18','021','EC','A','','','AC','0000611860','0000611860','MS00002644630','IL','1','POUNDERS','CAROLYN','','','','34','587862127','627 COUNTY ROAD 864',0,'GOLDEN','MS','38847','9721','CY','28141','1951-11-23','F','M',NULL,'N','021','DEN','2907582','46300MS002000201','2014-03-01','2014-02-14 08:18:43','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-14 21:31:18'),(23862,18987,'Y','18','024','14','A','','','TE','0001912126','0001912126','','IL','1','Toman','Joseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-12-17','M','',NULL,NULL,NULL,'','3710862','','2014-02-14','2014-02-14 13:27:21',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-14 21:32:05'),(26117,20712,'Y','18','021','EC','A','','','AC','0001241920','0001241920','OH00002382892','IL','1','Mattes','Jacob','','','','34','299924952','1684 bailey road',0,'cuyahoga falls','OH','44221',NULL,'CY','39153','1990-12-22','M','U',':RET:2106-3','T','021','DEN','3569731','99734OH005000401','2014-04-01','2014-02-26 23:02:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-28 06:30:18'),(26508,21024,'N','01','021','EC','A',NULL,NULL,'','0000496746','0000498151','','IL','1','Grande','Stephen','M','','','34','277806190','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','1968-12-05','M','',':RET:2106-3','N','021','DEN','3104329','99734OH005000401','2014-03-01','2014-02-28 15:49:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 21:00:18'),(26545,21048,'Y','18','024','14','A','','','TE','0000030519','0000030519','','IL','1','Donahue','Angela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-04-25','F','',NULL,NULL,NULL,'','159056','','2014-03-15','2014-02-28 13:38:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-28 21:30:10'),(27465,21736,'Y','18','024','14','A','','','TE','0000491858','0000491858','','IL','1','Maus','Richard','Aaron',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-15','M','',NULL,NULL,NULL,'','711943','','2014-03-31','2014-03-03 20:49:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-04 21:02:08'),(2266,1852,'N','01','021','EC','A',NULL,NULL,'','0000017600','0001158892','','IL','1','Blank','Sheila','Mary','','','34','161585148','11082 Sage creek drive',0,'Galena','OH','43021',NULL,'CY','39041','1960-10-21','F','',':RET:2106-3','N','021','DEN','761032','99734OH005000301','2014-01-01','2013-12-09 09:27:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:17'),(18844,15009,'N','01','021','EC','A',NULL,NULL,'','0001160433','0000421489','','IL','1','KOHUT','DAVID','M','','','34','295723935','78 W HINES HILL RD',0,'HUDSON','OH','44236','1031','CY','39153','1962-02-24','M','',':RET:2106-3','N','021','HLT','2756934','52664OH151001301','2014-03-01','2014-01-16 16:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2014-01-17 03:36:14'),(15853,12692,'Y','18','021','EC','A','','','AC','0001260025','0001260025','OH00002088824','IL','1','Himmelright','Robert','','','','34','302404144','619 HAMPTON RIDGE DR',0,'AKRON','OH','44313','5078','CY','39153','1950-12-03','M','U',':RET:2106-3','N','021','HLT','1871965','52664OH151001305','2014-02-01','2014-01-02 14:54:35','489.00',NULL,NULL,'658.32','169.32','R-OH012','OH0','658.32',NULL,0,'2014-01-03 02:04:29'),(15564,12454,'N','01','021','EC','A',NULL,NULL,'','0001012936','0001064724','','IL','1','BOC','KATARZYNA','','','','34','288158746','9290 SHADY LAKE DR',0,'STREETSBORO','OH','44241',NULL,'CY','39133','1982-04-04','F','',':RET:2106-3','N','021','HLT','2299848','52664OH151001305','2014-02-01','2013-12-31 12:18:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','258.47',NULL,1,'2014-01-02 04:31:41'),(15502,12403,'Y','18','024','14','A','','','TE','0000714967','0000714967','','IL','1','MAZAR','LAURA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-08','F','',NULL,NULL,NULL,'','2334907','','2013-12-31','2013-12-31 13:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:29:46'),(4585,3630,'N','01','021','EC','A',NULL,NULL,'','0000112913','0000901050','','IL','1','RUBINO','CHARLES','','','','34','290468277','1493 APOLLO DR',0,'STOW','OH','44224',NULL,'CY','39153','1949-06-02','M','',NULL,'N','021','HLT','1190687','52664OH151001301','2014-01-01','2013-12-12 07:39:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','669.00',NULL,0,'2013-12-25 22:05:19'),(21882,17471,'Y','18','021','EC','A','','','AC','0001351099','0001351099','LA00002644416','IL','1','AUBERT','CHARLES','','','','34','436865103','601 LAURICELLA AVE',0,'JEFFERSON','LA','70121','1711','CY','22051','1953-04-30','M','U',NULL,'N','021','DEN','3057010','18575LA002000101','2014-03-01','2014-02-06 13:49:03','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-06 21:01:31'),(22119,17656,'Y','18','021','EC','A','','','AC','0000438009','0000438009','OH00002269036','IL','1','Smith','Debra','','','','34','290564714','26 LARCHMONT AVE',0,'SPRINGFIELD','OH','45503','5418','CY','39023','1953-04-24','F','U',':RET:2106-3','T','021','HLT','3188418','92036OH004000501','2014-03-01','2014-02-07 19:38:53','480.00',NULL,NULL,'596.54','116.54','R-OH003','OH0','596.54',NULL,0,'2014-02-08 19:00:39'),(23084,18404,'N','01','021','EC','A',NULL,NULL,'','0000465961','0000494485','','IL','1','Redmond','Amber','L','','','34','232376494','182 W MAIN ST',0,'WALDO','OH','43356','9106','CY','39101','1989-10-12','F','',NULL,'N','021','DEN','3642155','99734OH005000401','2014-03-01','2014-02-11 20:43:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:04'),(23199,18498,'Y','18','021','EC','A','','','AC','0000295545','0000295545','OH00002118531','IL','1','Minnich','Jennifer','','','','34','277847370','411 FOUR SEASONS DR',0,'MASON','OH','45040','2831','CY','39165','1985-10-09','F','M',NULL,'N','021','HLT','3229708','92036OH006001201','2014-03-01','2014-02-12 16:49:56','318.00',NULL,NULL,'375.56','57.56','R-OH004','OH0','185.06',NULL,0,'2014-02-12 21:32:08'),(23722,18888,'Y','18','021','EC','A','','','AC','0000764985','0000764985','TX00002309814','IL','1','Turner','Sharon','','','','34','435574760','3923 CAMELIA GLEN LN',0,'FRESNO','TX','77545','8763','CY','48157','1967-12-13','F','U',':RET:2054-5','N','021','DEN','2764822','33348TX002000101','2014-03-01','2014-02-13 22:20:11','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-14 21:30:53'),(25851,20493,'Y','18','024','14','A','','','TE','0000050742','0000050742','','IL','1','Koning','Kiana',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-09-05','F','',NULL,NULL,NULL,'','3627460','','2014-02-26','2014-02-26 17:42:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 21:00:40'),(28086,22228,'Y','18','021','EC','A','','','AC','0000708479','0000708479','TX00002963998','IL','1','ROGERS','STEVEN','','','','34','511649725','4049 HERSCHEL AVE',0,'DALLAS','TX','75219','2939','CY','48113','1958-01-27','M','U',NULL,'N','021','DEN','3066266','33348TX002000101','2014-04-01','2014-03-06 15:34:29','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-06 21:02:00'),(28344,22427,'Y','18','021','EC','A','','','AC','0000812287','0000812287','TX00003085582','IL','1','hollebeke','audrey','','','','34','627050893','5953 SIXTA DR',0,'EL PASO','TX','79932','2314','CY','48141','1981-05-27','F','U',':RET:2106-3','T','021','DEN','3981579','33348TX002000201','2014-04-01','2014-03-07 11:34:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-07 21:30:19'),(28705,22716,'N','19','021','EC','A',NULL,NULL,'','0000314760','0000245046','','IL','1','Rorrer','Allyson','N','','','34','287963111','175 HERMANN ST',0,'BARBERTON','OH','44203','1422','CY','39153','1993-08-04','F','',':RET:2106-3','N','021','HLT','3646802','52664OH151001301','2014-04-01','2014-03-08 13:02:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-08 21:31:11'),(5105,4045,'Y','18','021','EC','A','','','AC','0000332974','0000332974','TX00000678633','IL','1','Melton','Robert','','','','34','639053584','1514 BROADMOOR DR',0,'AUSTIN','TX','78723','3126','CY','48453','1980-02-12','M','U',':RET:2106-3','N','021','DEN','2246576','33348TX002000201','2014-01-01','2013-12-19 17:12:54','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 23:01:31'),(18809,14981,'N','01','021','EC','A',NULL,NULL,'','0001184909','0000015294','','IL','1','Boring','Linda','','','','34','299443716','730 W Portage Tr Ext',0,'Akron','OH','44313',NULL,'CY','39153','1950-06-19','F','',':RET:2106-3','T','021','DEN','1905335','99734OH005000401','2014-03-01','2014-01-16 16:39:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:36:02'),(18390,14678,'Y','18','021','EC','A','','','AC','0001210947','0001210947','OH00001500338','IL','1','ANDERSON','JACQUELINE','','','','34','269904692','33141 Fairport Drive',0,'Avon Lake','OH','44012',NULL,'CY','39093','1981-02-23','F','U',':RET:2106-3','N','021','DEN','1989188','99734OH005000301','2014-02-01','2014-01-15 15:57:09','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:39'),(16420,13140,'N','19','021','EC','A',NULL,NULL,'','0000417411','0000532117','','IL','1','Jin','David','Young','','','34','277965277','3789 MAPLE GROVE LN',0,'BEAVERCREEK','OH','45440','3573','CY','39057','1993-05-22','M','',':RET:2040-4','N','021','HLT','2136580','92036OH001000501','2014-02-01','2014-01-06 14:12:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.08',NULL,0,'2014-01-07 04:04:30'),(17819,14234,'Y','18','024','14','A','','','TE','0000681876','0000681876','','IL','1','Arrington','Valerie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-03-21','F','',NULL,NULL,NULL,'','1938213','','2014-01-14','2014-01-14 09:38:50',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-15 02:05:55'),(17101,13686,'N','01','021','EC','A',NULL,NULL,'','0001199228','0000550711','','IL','1','Pearson','Jimmy','','','','34','452823973','919 TUBBS ST',0,'TYLER','TX','75701','1258','CY','48423','1949-07-21','M','',':RET:2054-5','N','021','DEN','2211393','33348TX002000201','2014-02-01','2014-01-08 16:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:21:32'),(23984,19070,'Y','18','021','EC','A','','','AC','0002224558','0002224558','LA00002941117','IL','1','Orechwa','David','','','','34','433040706','18231 WILDLIFE WAY DR',0,'BATON ROUGE','LA','70817','4359','CY','22033','1957-09-26','M','M',':RET:2106-3','N','021','DEN','3018196','18575LA002000201','2014-03-01','2014-02-15 12:37:29','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-15 22:00:22'),(24259,19264,'Y','18','021','EC','A','','','AC','0000783033','0000783033','TX00002756239','IL','1','NAVARRO','ELVIRA','','','','34','733052539','1553 PLAZA VERDE DR',0,'EL PASO','TX','79912',NULL,'CY','48141','1958-10-14','F','U',NULL,'N','021','DEN','3855869','33348TX002000201','2014-04-01','2014-02-17 16:24:41','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-17 19:00:09'),(25237,20019,'Y','18','021','EC','A','','','AC','0000213423','0000213423','OH00002367555','IL','1','Wilke','David','','','','34','271544624','4876 ALGONQUIN TRL',0,'STOW','OH','44224','1204','CY','39153','1952-09-23','M','U',':RET:2106-3','N','021','HLT','2753721','52664OH152000901','2014-04-01','2014-02-21 17:13:48','426.00',NULL,NULL,'458.99','32.99','R-OH012','OH0','458.99',NULL,0,'2014-02-21 22:01:05'),(26660,21134,'N','19','021','EC','A',NULL,NULL,'','0001240612','0001110420','','IL','1','Pearcy','Devin','James','','','34','301941304','2538-C Royal County Down',0,'Uniontown','OH','44685',NULL,'CY','39153','1992-07-10','M','',':RET:2106-3','N','021','HLT','3501247','52664OH151001305','2014-04-01','2014-02-28 14:47:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-02-28 21:31:11'),(27170,21512,'Y','18','024','14','A','','','TE','0000819360','0000819360','','IL','1','Nguyen','Long',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-31','M','',NULL,NULL,NULL,'','3151799','','2014-03-03','2014-03-03 11:23:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-03 21:31:04'),(28039,22187,'N','01','021','EC','A',NULL,NULL,'','0000926336','0000877172','','IL','1','KLUN','BRIAN','','','','34','296584861','860 E 239TH ST',0,'EUCLID','OH','44123',NULL,'CY','39035','1960-09-23','M','',NULL,'T','021','DEN','3540924','99734OH005000401','2014-04-01','2014-03-06 17:35:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:30'),(9617,7616,'Y','18','021','EC','A','','','AC','0000020167','0000020167','OH00000206593','IL','1','Stewart','Ethan','','','','34','269084507','1300 Southern Hills Blvd',0,'Hamilton','OH','45013',NULL,'CY','39017','2002-08-19','M','R',':RET:2106-3','N','021','HLT','1397601','92036OH005001204','2014-01-01','2013-12-20 20:03:12','61.44',NULL,NULL,'136.32','74.88','R-OH004','OH0','136.32',NULL,0,'2013-12-26 04:37:47'),(7989,6324,'Y','18','021','EC','A','','','AC','0000854187','0000854187','OH00000005538','IL','1','Golub','Deborah','','','','34','276825352','12785 HAMETOWN RD',0,'DOYLESTOWN','OH','44230','9780','CY','39169','1970-01-15','F','U',':RET:2106-3','N','021','HLT','2575966','52664OH151001304','2014-01-01','2013-12-20 15:01:42','87.00',NULL,NULL,'302.62','215.62','R-OH014','OH0','302.62',NULL,0,'2013-12-26 03:08:08'),(17433,13947,'N','01','021','EC','A',NULL,NULL,'','0000595161','0000615528','','IL','1','niser','sakeneh','','','','34','290769816','3027 GREEN ACRES DR',0,'YOUNGSTOWN','OH','44505','2004','CY','39155','1963-01-13','F','',':RET:2106-3','N','021','HLT','2233828','92036OH002003201','2014-02-01','2014-01-10 12:19:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','521.34',NULL,0,'2014-01-13 03:00:32'),(17346,13877,'Y','18','021','EC','A','','','AC','0000370042','0000370042','OH00001403103','IL','1','Pizzuti','Cheryl','','','','34','274529210','1457 INGLEWOOD AVE',0,'FINDLAY','OH','45840','0133','CY','39063','1952-03-05','F','U',NULL,'N','021','HLT','2179963','92036OH003001504','2014-02-01','2014-01-10 12:59:03','468.00',NULL,NULL,'645.86','177.86','R-OH002','OH0','645.86',NULL,0,'2014-01-13 02:24:06'),(2922,2354,'N','01','021','EC','A',NULL,NULL,'','0000757107','0000625401','','IL','1','kinloch','barbara','althea','','','34','271648550','4878 state route 7',0,'Burghill','OH','44404',NULL,'CY','39155','1965-12-17','F','',NULL,'N','021','DEN','439837','99734OH005000401','2014-01-01','2013-12-06 17:25:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:47'),(16753,13402,'Y','18','021','EC','A','','','AC','0000694829','0000694829','TX00001929656','IL','1','Muro','Aurora','','','','34','635109884','293 CREEKWOOD DR',0,'SUNNYVALE','TX','75182','2622','CY','48113','1989-07-28','F','U',':RET:2106-3','N','021','DEN','2204643','33348TX002000101','2014-02-01','2014-01-06 20:03:35','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-08 18:24:55'),(16229,12996,'N','01','021','EC','A',NULL,NULL,'','0000031952','0000172419','','IL','1','Gross','Pamela','','','','34','296642947','34 KENMORE AVE',0,'BARBERTON','OH','44203','1236','CY','39153','1971-06-04','F','',':RET:2106-3','N','021','HLT','2323260','52664OH151001305','2014-02-01','2014-01-03 20:34:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,0,'2014-01-05 00:02:00'),(15649,12519,'Y','18','021','EC','A','','','AC','0000727631','0000727631','MS00001020361','IL','1','KYLE','BRENDA','DENISE','','','34','428043608','2528 IDAHO ST',0,'JACKSON','MS','39213','5430','CY','28049','1957-01-13','F','U',':RET:2054-5','N','021','DEN','2058376','46300MS002000201','2014-02-01','2013-12-31 14:10:33','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,1,'2014-01-02 04:34:03'),(15556,12449,'Y','18','021','EC','A','','','AC','0000706202','0000706202','OH00001818704','IL','1','MOSES','STEVEN','','','','34','553830580','176 E COMET RD',0,'CLINTON','OH','44216','9424','CY','39153','1982-05-29','M','M',NULL,'N','021','HLT','2460019','52664OH151001306','2014-02-01','2013-12-30 18:46:21','371.00',NULL,NULL,'482.37','111.37','R-OH012','OH0','258.47',NULL,1,'2014-01-02 04:31:28'),(14227,11345,'Y','18','021','EC','A','','','AC','0000075007','0000075007','TX00001684589','IL','1','Franks','Samuel','Brian','','','34','452191240','22296 COUNTY ROAD 26',0,'OVERTON','TX','75684','8054','CY','48423','1957-04-10','M','U',':RET:2106-3','N','021','DEN','2123904','33348TX002000201','2014-02-01','2013-12-26 18:13:18','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-27 02:04:51'),(3875,3103,'Y','18','024','14','A','','','TE','0000068368','0000068368','','IL','1','Wright','Brianna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-09-19','F','',NULL,NULL,NULL,'','400664','','2013-12-13','2013-12-13 12:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:36:17'),(4132,3299,'Y','18','021','EC','A','','','AC','0001228049','0001228049','OH00000410192','IL','1','DIAMOND','MICHAEL','P','','','34','286781615','2321 INDIAN MOUND AVE',0,'CINCINNATI','OH','45212','1710','CY','39061','1980-02-17','M','U',NULL,'T','021','DEN','2602603','99734OH005000301','2014-01-01','2013-12-17 09:02:48','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:48:25'),(20718,16555,'Y','18','021','EC','A','','','AC','0000868268','0000868268','OH00001971512','IL','1','Hamm','Shawna','','','','34','594481720','55 WHITETHORNE DR',0,'WILMINGTON','OH','45177','7586','CY','39027','1987-04-29','F','U',':RET:2106-3','N','021','HLT','3555496','92036OH006000601','2014-03-01','2014-01-29 19:58:26','117.00',NULL,NULL,'174.33','57.33','R-OH005','OH0','174.33',NULL,0,'2014-01-30 21:01:12'),(20833,16652,'Y','18','021','EC','A','','','AC','0000073968','0000073968','OH00001354828','IL','1','BEATY','EUGENE','','','','34','284523771','2074 COPLEY RD',0,'AKRON','OH','44320','1520','CY','39153','1951-11-17','M','U',':RET:2106-3','N','021','HLT','3522704','52664OH151001305','2014-03-01','2014-01-30 18:43:18','507.00',NULL,NULL,'640.70','133.70','R-OH012','OH0','640.70',NULL,0,'2014-01-31 21:00:42'),(24405,19386,'Y','18','021','EC','A','','','AC','0000950722','0000950722','OH00003012268','IL','1','Miller','Kelley','','','','34','280887013','11700 ALPINE HWY',0,'FRAZEYSBURG','OH','43822',NULL,'CY','39119','1980-01-11','F','M',NULL,'N','021','DEN','3296924','99734OH005000401','2014-04-01','2014-02-18 16:41:43','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-02-18 22:00:57'),(24619,19540,'Y','18','021','EC','A','','','AC','0000017613','0000017613','MS00002757418','IL','1','Scott','Linda','','','','34','587114454','623 WOODBURY RD',0,'JACKSON','MS','39206','4915','CY','28049','1959-11-08','F','U',':RET:2054-5','N','021','DEN','2617641','46300MS002000201','2014-04-01','2014-02-19 11:50:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:15:40'),(26138,20726,'Y','18','021','EC','A','','','AC','0000153425','0000153425','OH00002764050','IL','1','FOUT','CAROL','','','','34','269589262','501 E BROAD ST',0,'COLUMBUS','OH','43215','3822','CY','39049','1955-04-24','F','M',NULL,'N','021','DEN','3744521','99734OH005000401','2014-04-01','2014-02-27 12:31:09','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:24'),(26564,21060,'Y','18','021','EC','A','','','AC','0000058813','0000058813','OH00002138378','IL','1','parker','ollie','','','','34','294500784','13705 COATH AVE',0,'CLEVELAND','OH','44120','4633','CY','39035','1952-04-22','M','M',':RET:2054-5','T','021','DEN','3493578','99734OH005000401','2014-03-01','2014-02-28 09:23:22','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-28 21:30:22'),(26637,21121,'Y','18','021','EC','A','','','AC','0000106669','0000106669','TX00002798803','IL','1','TRAN','KHAC','','','','34','386359014','6743 CATARINA CIR',0,'HOUSTON','TX','77084','1281','CY','48201','1986-05-07','F','U',NULL,'N','021','DEN','3408509','33348TX002000201','2014-04-01','2014-02-28 17:27:36','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 21:31:00'),(26889,21310,'N','17','021','EC','A',NULL,NULL,'','0000493301','0000837756','','S3','1','Gaskill','Stephanie','','','','34','281023560','506 Collins Ave',0,'Van Wert','OH','45891',NULL,'CY','39161','1997-03-15','M','',':RET:2106-3','N','021','HLT','3516931','92036OH003001505','2014-04-01','2014-03-02 15:31:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-03-03 01:00:02'),(28417,22485,'Y','18','021','EC','A','','','AC','0000847213','0000847213','OH00003638715','IL','1','ARNETT','JOANNE','','','','34','548334476','707 8 ROUTE 28 123',0,'MILFORD','OH','45150',NULL,'CY','39025','1958-08-20','F','M',NULL,'N','021','DEN','3963451','99734OH005000401','2014-04-01','2014-03-07 12:56:18','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-03-07 21:31:00'),(6638,5266,'Y','18','021','EC','A','','','AC','0001111628','0001111628','OH00000967852','IL','1','Barone','Deborah','','','','34','282643719','2759 9th Street',0,'Cuyahoga Falls','OH','44221',NULL,'CY','39153','1957-07-07','F','U',':RET:2106-3','N','021','HLT','543247','52664OH151001306','2014-01-01','2013-11-11 19:13:09','452.00',NULL,NULL,'520.28','68.28','R-OH012','OH0','520.28',NULL,0,'2013-12-26 01:00:14'),(4195,3337,'N','19','021','EC','A',NULL,NULL,'','0000030526','0000745425','','S1','1','Gerber','Robert','','','','34','288134221','969 BROOK RD',0,'WADSWORTH','OH','44281','9057','CY','39103','2007-10-25','F','',':RET:2106-3','N','021','HLT','1768557','52664OH151001304','2014-01-01','2013-12-17 16:30:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 21:49:45'),(17627,14093,'Y','18','021','EC','A','','','AC','0000953797','0000953797','TX00002399617','IL','1','GUNERATNE','ARUNA','','','','34','612250388','1334 RED STAG PL',0,'ROUND ROCK','TX','78665','1359','CY','48491','1972-10-29','M','M',':RET:2028-9','N','021','DEN','1928466','33348TX002000201','2014-02-01','2014-01-13 16:05:28','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:31'),(6380,5059,'Y','18','021','EC','A','','','AC','0000510627','0000510627','OH00000472898','IL','1','Roth','Rachelle','','','','34','181427305','34371 SUMMERSET DR',0,'SOLON','OH','44139','5636','CY','39035','1953-12-30','F','M',':RET:2106-3','N','021','DEN','214798','99734OH005000301','2014-01-01','2013-12-11 10:13:18','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:47:54'),(22071,17617,'N','01','021','EC','A',NULL,NULL,'','0000556579','0001018977','','IL','1','james','andersoon','','','III','34','437239165','1603 nandina drive',0,'arlington','TX','76014',NULL,'CY','48439','1967-05-30','M','',':RET:2054-5','N','021','DEN','3530581','33348TX002000201','2014-03-01','2014-02-08 15:24:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-08 19:00:14'),(23528,18742,'Y','18','024','14','A','','','TE','0001220858','0001220858','','IL','1','Ivey','Adria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-11-22','F','',NULL,NULL,NULL,'','2838649','','2014-02-13','2014-02-13 10:24:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-13 22:02:24'),(26926,21339,'Y','18','021','EC','A','','','AC','0001038661','0001038661','OH00002807914','IL','1','Dinnell','Linda','','','','34','376565380','396 PATASKALA RIDGE DR SW',0,'PATASKALA','OH','43062','7434','CY','39089','1951-09-25','F','M',':RET:2106-3','N','021','DEN','3585363','99734OH005000401','2014-04-01','2014-03-02 13:29:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 01:00:17'),(810,670,'Y','18','021','EC','A','','','AC','0001109205','0001109205','OH00001094880','IL','1','BEDNAR','CYNTHIA','','','','34','297424826','1838 PINE CV',0,'WOOSTER','OH','44691','2583','CY','39169','1952-11-11','F','M',':RET:2106-3','N','021','HLT','2187638','52664OH151001305','2014-01-01','2013-12-16 10:14:19','458.00',NULL,NULL,'626.65','168.65','R-OH014','OH0','626.65',NULL,0,'2013-12-25 18:05:47'),(1970,1609,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001056978','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','301754','33348TX002000101','2014-01-01','2013-11-19 23:00:50','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:27'),(16357,13090,'N','01','021','EC','A',NULL,NULL,'','0000768896','0000214664','','IL','1','WILLIAMS','COLLEEN','N','','','34','269843864','5344 WILDCAT PIKE',0,'MARION','OH','43302','9432','CY','39101','1985-07-30','F','',':RET:2106-3','N','021','DEN','2511931','99734OH005000301','2014-02-01','2014-01-06 14:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:38'),(14079,11219,'Y','18','021','EC','A','','','AC','0000291977','0000291977','OH00000091805','IL','1','Fette','Wanda','','','','34','274481121','114 St. Andrews Blvd',0,'Belpre','OH','45714',NULL,'CY','39167','1951-05-18','F','U',NULL,'N','021','DEN','1917298','99734OH005000401','2014-02-01','2013-12-26 10:18:35','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-27 02:01:03'),(22134,17666,'Y','18','021','EC','A','','','AC','0000656969','0000656969','OH00001716889','IL','1','Swank','Jeffery','','','','34','288766718','3465 SOUTH ARLINGTON ROAD',0,'AKRON','OH','44312',NULL,'CY','39153','1965-07-19','M','U',':RET:2106-3','T','021','DEN','3071768','99734OH005000401','2014-03-01','2014-02-08 12:14:51','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-08 19:00:45'),(22957,18303,'Y','18','021','EC','A','','','AC','0002332236','0002332236','LA00002484783','IL','1','Horton','Marialaina','','','','34','437150864','7739 ALABAMA ST',0,'NEW ORLEANS','LA','70126','1309','CY','22071','1959-01-08','F','M',':RET:2054-5','N','021','DEN','3317724','18575LA002000201','2014-03-01','2014-02-12 10:41:56','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61','CIC',0,'2014-02-12 21:00:06'),(23213,18505,'Y','18','021','EC','A','','','AC','0000927348','0000927348','OH00002480941','IL','1','Duggins','Angela','K','','','34','288807142','1429 WAYNE RD',0,'WILMINGTON','OH','45177','1140','CY','39027','1969-04-28','F','M',':RET:2106-3','N','021','HLT','3545034','92036OH004000601','2014-03-01','2014-02-12 14:55:31','379.00',NULL,NULL,'413.75','34.75','R-OH005','OH0','241.14',NULL,0,'2014-02-12 21:32:14'),(25459,20199,'Y','18','024','14','A','','','TE','0001114346','0001114346','','IL','1','REYES','BONNIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-10-01','F','',NULL,NULL,NULL,'','3630042','','2014-02-25','2014-02-25 14:22:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-25 21:31:30'),(27007,21390,'N','01','021','EC','A',NULL,NULL,'','0000614154','0000821060','','IL','1','Gay','Vicki','Michelle','','','34','291666265','2600 EDGEBROOK AVE',0,'AKRON','OH','44312','1569','CY','39153','1958-02-16','F','',':RET:2106-3','N','021','DEN','3605188','99734OH005000401','2014-04-01','2014-03-03 14:46:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:05'),(28144,22272,'Y','18','024','14','A','','','TE','0000404857','0000404857','','IL','1','KNAPP','PATRICK','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-13','M','',NULL,NULL,NULL,'','3631497','','2014-03-06','2014-03-06 09:10:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-06 21:02:33'),(6347,5029,'Y','18','021','EC','A','','','AC','0001007865','0001007865','OH00000935400','IL','1','Rubin','Nicolle','','','','34','273888127','4047 ELLISON RD',0,'SOUTH EUCLID','OH','44121','2730','CY','39035','1987-07-28','F','U',':RET:2106-3','N','021','DEN','889056','99734OH005000401','2014-01-01','2013-12-11 13:01:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:46:55'),(6211,4922,'Y','18','021','EC','A','','','AC','0000937860','0000937860','TX00000036666','IL','1','Hudson','David','Allan','','','34','453876264','712 N RITA ST',0,'WACO','TX','76705','1141','CY','48309','1978-05-02','M','U',NULL,'N','021','DEN','894908','33348TX002000101','2014-01-01','2013-10-16 19:13:41','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2013-12-26 00:30:53'),(3191,2567,'Y','18','021','EC','A','','','AC','0000047023','0000047023','TX00000107699','IL','1','pellegrini','sloane','','','','34','329725537','8104 EXMOOR DR',0,'AUSTIN','TX','78757','7723','CY','48453','1982-11-22','F','U',NULL,'N','021','DEN','432035','33348TX002000201','2014-01-01','2013-10-03 06:51:37','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 20:32:10'),(15825,12669,'Y','18','021','EC','A','','','AC','0000891821','0000891821','OH00000714582','IL','1','Sopp','Susan','','','','34','188449913','3126 LINVIEW AVE',0,'CINCINNATI','OH','45208','2917','CY','39061','1953-02-28','F','U',':RET:2106-3','N','021','DEN','1555569','99734OH005000401','2014-02-01','2014-01-02 16:15:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:03:40'),(14133,11265,'Y','18','021','EC','A','','','AC','0002048869','0002048869','LA00001153857','31','1','Randle','Eugene','','','','34','435518628','P.O. Box 950',0,'Baldwin','LA','70514',NULL,'CY','22101','1974-02-18','M','U',':RET:2054-5','T','021','DEN','2014330','18575LA002000201','2014-02-01','2013-12-26 11:15:24','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-27 02:02:26'),(13897,11084,'N','19','021','EC','A',NULL,NULL,'','0000478473','0000378571','','IL','1','Wilson','Zachary','Lee','','Sr','34','279029681','5811 county rd 1',0,'swanton','OH','43558',NULL,'CY','39051','1997-06-07','M','',':RET:2106-3','N','021','HLT','2556771','92036OH006002601','2014-01-01','2013-12-22 20:43:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2013-12-26 13:13:37'),(13076,10424,'Y','18','021','EC','A','','','AC','0000814285','0000814285','OH00000999142','IL','1','Pierce','Judy','','','','34','268480964','6348 Larcomb Drive',0,'Dayton','OH','45424',NULL,'CY','39113','1949-05-22','F','U',':RET:1002-5','N','021','DEN','2582644','99734OH005000401','2014-01-01','2013-12-23 10:33:52','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:51:26'),(13068,10416,'Y','18','021','EC','A','','','AC','0000323496','0000323496','OH00000987529','IL','1','hall','ronald','','','','34','294702380','15 jackson st',0,'lebanon','OH','45036',NULL,'CY','39165','1972-02-05','M','U',':RET:2106-3','T','021','DEN','1931354','99734OH005000401','2014-01-01','2013-12-23 09:50:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:51:14'),(3908,3126,'Y','18','024','14','A','','','TE','0000376116','0000376116','','IL','1','Moore','Karla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-08-23','F','',NULL,NULL,NULL,'','1144772','','2013-12-12','2013-12-12 18:58:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:37:01'),(20402,16296,'N','01','021','EC','A',NULL,NULL,'','0000345349','0000958804','','IL','1','Finley','Tammy','','','','34','451250568','216 N Sparks St',0,'BELTON','TX','76513',NULL,'CY','48027','1957-12-11','F','',NULL,'N','021','DEN','2948584','33348TX002000201','2014-03-01','2014-01-29 15:31:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-29 21:00:20'),(24820,19677,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000149396','','IL','1','Burdick','Tanner','','','','34','302982628','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1996-06-20','M','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:33'),(25616,20323,'N','01','021','EC','A',NULL,NULL,'','0000329548','0000200527','','IL','1','Rodriguez','Pedro','R','','','34','467829328','4742 Rodgerson Dr',0,'Corpus Christ','TX','78415',NULL,'CY','48355','1951-11-20','M','',':RET:2106-3','N','021','DEN','3029223','33348TX002000201','2014-04-01','2014-02-22 11:25:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 08:30:12'),(26122,20716,'N','01','021','EC','A',NULL,NULL,'','0001178233','0000197194','','IL','1','hummel','douglas','','','','34','288440991','8611 EMERSON RD',0,'APPLE CREEK','OH','44606','9778','CY','39169','1957-07-29','M','',NULL,'N','021','DEN','3072260','99734OH005000401','2014-04-01','2014-02-27 00:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:19'),(29129,23061,'Y','18','021','EC','A','','','AC','0000598820','0000598820','OH00003460360','IL','1','Estep','Jacqueline','','','','34','293764111','5985 TWITCHELL RD',0,'SPRINGFIELD','OH','45502','9273','CY','39023','1965-01-17','F','U',':RET:2106-3','N','021','HLT','3929464','92036OH004000501','2014-04-01','2014-03-10 10:51:34','381.00',NULL,NULL,'447.46','66.46','R-OH003','OH0','326.08',NULL,0,'2014-03-10 21:02:36'),(6720,5330,'Y','18','021','EC','A','','','AC','0000675416','0000675416','OH00000823563','IL','1','Johnston','Lynn','','','','34','363086962','517 HULBERT ST',0,'DAYTON','OH','45410','2222','CY','39113','1987-03-31','F','U',':RET:2106-3','T','021','DEN','796858','99734OH005000401','2014-01-01','2013-11-25 13:40:28','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:15:11'),(1304,1080,'Y','18','021','EC','A','','','AC','0000493005','0000493005','TX00000294320','IL','1','McGee','Crystal','Rae','','','34','122720656','1112 GLENN ST',0,'DAINGERFIELD','TX','75638','1808','CY','48343','1983-03-26','F','M',':RET:2054-5','N','021','DEN','507160','33348TX002000201','2014-01-01','2013-11-04 11:36:26','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:31:16'),(13286,10604,'Y','18','021','EC','A','','','AC','0000120533','0000120533','TX00000781391','IL','1','Castillo','Maria','','','','34','453892414','1108 Echo Lane',0,'Austin','TX','78745',NULL,'CY','48453','1977-01-13','F','U',NULL,'N','021','DEN','2608331','33348TX002000201','2014-01-01','2013-12-23 13:11:33','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:57:20'),(9556,7574,'Y','18','021','EC','A','','','AC','0001192669','0001192669','OH00000901242','IL','1','Vaiksnoras','Eric','','','','34','272740344','36027 FREED CT',0,'EASTLAKE','OH','44095','2325','CY','39085','1973-11-03','M','U',':RET:2106-3','N','021','DEN','1976544','99734OH005000301','2014-01-01','2013-12-21 14:32:49','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:36:25'),(4440,3529,'N','19','021','EC','A',NULL,NULL,'','0000399863','0000153343','','IL','1','Buczkowski','Natalia','','','','34','284944240','22627 MEADOWHILL LN',0,'ROCKY RIVER','OH','44116','2035','CY','39035','1991-11-22','F','',NULL,'N','021','DEN','624644','99734OH005000301','2014-01-01','2013-12-11 18:57:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:07'),(19701,15699,'Y','18','021','EC','A','','','AC','0000273032','0000273032','TX00001781970','31','1','RODRIGUEZ','DELIA','','','','34','309663751','PO BOX 651',0,'BENBOLT','TN','78342',NULL,'CY','48249','1956-08-10','F','M',NULL,'N','021','DEN','2302617','33348TX002000201','2014-03-01','2014-01-23 12:41:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:47'),(22807,18203,'Y','18','021','EC','A','','','AC','0001024319','0001024319','OH00001975005','IL','1','BARRETT','HOWARD','DAVID','','','34','296464990','18706 ESSEX RD',0,'LOGAN','OH','43138',NULL,'CY','39073','1950-05-01','M','M',':RET:2106-3','N','021','DEN','3773641','99734OH005000301','2014-03-01','2014-02-11 14:46:20','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2014-02-11 21:01:55'),(24025,19107,'Y','18','021','EC','A','','','AC','0000055973','0000055973','OH00001352520','IL','1','Al Baff','Fadi','','','','34','297150377','3050 WESTBROOK DR',0,'TOLEDO','OH','43613','3749','CY','39095','1970-07-06','M','U',':RET:2106-3','N','021','HLT','2813412','92036OH004002601','2014-03-01','2014-02-14 22:11:37','211.20',NULL,NULL,'212.76','1.56','R-OH001','OH0','212.76',NULL,0,'2014-02-15 22:00:49'),(24462,19434,'Y','18','021','EC','A','','','AC','0000217516','0000217516','TX00002968754','IL','1','Candela','Anna','','','','34','523826988','1401 N MAGDALEN ST',0,'SAN ANGELO','TX','76903','3971','CY','48451','1954-02-10','F','U',':RET:2106-3','N','021','DEN','3716487','33348TX002000101','2014-04-01','2014-02-18 16:00:48','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2014-02-18 22:01:34'),(26331,20890,'Y','18','021','EC','A','','','AC','0000632739','0000632739','OH00002083963','IL','1','Auer','Alyssa','','','','34','305042368','2084 HIDDEN LAKE DR',0,'STOW','OH','44224','5328','CY','39153','1987-03-19','F','R',':RET:2106-3','N','021','HLT','3502470','52664OH152001001','2014-03-01','2014-02-27 10:13:07','0.00',NULL,NULL,'125.55','125.55','R-OH012','OH0','125.55',NULL,0,'2014-02-28 06:31:40'),(28707,22717,'Y','18','024','14','A','','','TE','0000314760','0000314760','','IL','1','Rorrer','Kelly','Jo',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-01-28','F','',NULL,NULL,NULL,'','3646802','','2014-03-08','2014-03-08 13:10:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-08 21:31:11'),(298,247,'Y','18','021','EC','A','','','AC','0000236226','0000236226','OH00000993030','31','1','Veyon','Aaron','','','','34','232272322','P.O. Box 336',0,'Fredericktown','OH','43019',NULL,'CY','39083','1968-01-07','M','M',':RET:2106-3','N','021','DEN','111511','99734OH005000401','2014-01-01','2013-11-13 17:34:27','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:30:45'),(1016,832,'N','01','021','EC','A',NULL,NULL,'','0000646187','0000014956','','IL','1','Sullivan','Susan','Breanne','','','34','587495628','1401 WALNUT ST',0,'WAYNESBORO','MS','39367','2233','CY','28153','1979-12-28','F','',':RET:2106-3','N','021','DEN','607964','46300MS002000201','2014-01-01','2013-12-03 00:02:52',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 18:15:07'),(17403,13927,'Y','18','021','EC','A','','','AC','0000112197','0000112197','MS00001723962','IL','1','Cadle','Kathryn','Ann','','','34','296468956','5570 CHOCTAW DR',0,'HORN LAKE','MS','38637','9635','CY','28033','1952-10-05','F','U',':RET:2106-3','N','021','DEN','2531713','46300MS002000101','2014-02-01','2014-01-10 17:14:32','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-13 03:00:18'),(17142,13718,'Y','18','021','EC','A','','','AC','0001278407','0001278407','LA00002106176','IL','1','munson','michelle','','','','34','439193088','1825 SQUIRE CT',0,'MARRERO','LA','70072','6723','CY','22051','1971-05-19','F','U',':RET:2054-5','N','021','DEN','2139093','18575LA002000201','2014-02-01','2014-01-07 19:24:20','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:53'),(9023,7159,'Y','18','021','EC','A','','','AC','0000364870','0000364870','OH00000186139','IL','1','Kinzel','Melodie','Rose','','','34','274544101','5771 FAIRLAND RD',0,'CLINTON','OH','44216','9794','CY','39153','1953-08-09','F','U',':RET:2106-3','N','021','HLT','2436773','52664OH151001306','2014-01-01','2013-12-17 21:59:11','496.00',NULL,NULL,'605.24','109.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 04:05:22'),(15930,12754,'N','01','021','EC','A',NULL,NULL,'','0000798422','0000917002','','IL','1','HE','MING','','','','34','280902250','710 TRACK LANE',0,'CINCINNATI','OH','45245',NULL,'CY','39025','1964-05-03','M','',':RET:2034-7','N','021','HLT','2485977','92036OH004000601','2014-02-01','2014-01-02 16:46:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','294.48',NULL,0,'2014-01-03 02:06:52'),(7910,6254,'Y','18','021','EC','A','','','AC','0002127587','0002127587','LA00001287047','IL','1','fortuna','nicholas','','','','34','382904202','6050 CHEF MENTEUR HWY',0,'NEW ORLEANS','LA','70126','5142','CY','22071','1981-04-27','M','U',':RET:2106-3','T','021','DEN','1945284','18575LA002000201','2014-01-01','2013-12-19 21:22:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:03'),(15533,12428,'Y','18','021','EC','A','','','AC','0002061644','0002061644','LA00001498826','IL','1','Carleton','Mary','','','','34','435825349','6125 CHANDLER DR',0,'BATON ROUGE','LA','70808','5019','CY','22033','1958-07-08','F','R',':RET:2106-3','N','021','DEN','1884719','18575LA002000201','2014-02-01','2013-12-31 13:29:27','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-02 04:30:42'),(7552,5977,'Y','18','021','EC','A','','','AC','0000884196','0000884196','OH00000992278','IL','1','Kline','Karen','','','','34','299427816','1320 Dunkeith Dr. N. W.',0,'Canton','OH','44708',NULL,'CY','39151','1958-02-11','F','U',':RET:2106-3','N','021','HLT','1165037','52664OH151001501','2014-01-01','2013-12-15 12:58:37','0.00',NULL,NULL,'596.45','596.45','R-OH015','OH0','596.45',NULL,0,'2013-12-26 02:33:15'),(20048,15989,'Y','18','021','EC','A','','','AC','0001209704','0001209704','TX00001775677','IL','1','Gatian','Barbara','','','','34','302746742','9711 RAVENSWORTH DR',0,'HOUSTON','TX','77031','3121','CY','48201','1963-02-24','F','U',':RET:2106-3','N','021','DEN','3004609','33348TX002000201','2014-03-01','2014-01-26 18:14:20','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-27 21:00:03'),(26802,21239,'Y','18','021','EC','A','','','AC','0000522011','0000522011','OH00003475376','IL','1','MCCANTS','ROSCOE','','','','34','299485547','876 CLEVELAND AVE',0,'CINCINNATI','OH','45229','2738','CY','39061','1951-01-10','M','M',':RET:2054-5','N','021','DEN','3881781','99734OH005000301','2014-03-01','2014-02-28 19:37:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:23'),(27955,22115,'Y','18','021','EC','A','','','AC','0000761226','0000761226','TX00003652842','IL','1','TRAN','TUYEN',NULL,NULL,NULL,NULL,NULL,'2618 DANBERRY LN',0,'GRAND PRAIRIE','TX','75052','3807','CY','48439','1982-01-23','F','U',NULL,'N','021','DEN','3016212','33348TX002000201','2014-04-01','2014-03-06 17:55:28','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:40'),(8819,6991,'Y','18','021','EC','A','','','AC','0000653188','0000653188','OH00001225581','IL','1','Bush','Brittany','','','','34','275881223','2593 LAUREL LINDALE RD',0,'NEW RICHMOND','OH','45157','9517','CY','39025','1984-07-11','F','U',NULL,'N','021','HLT','1691891','92036OH004000601','2014-01-01','2013-12-18 13:31:37','136.00',NULL,NULL,'193.15','57.15','R-OH005','OH0','193.15',NULL,0,'2013-12-26 04:00:12'),(15812,12657,'Y','18','021','EC','A','','','AC','0001888248','0001888248','LA00001867135','IL','1','LINER','JEFFREY','HANKS','','','34','438198505','446 MOON LAKE RD',0,'MONROE','LA','71203','8735','CY','22073','1959-12-14','M','U',NULL,'N','021','DEN','1988889','18575LA002000201','2014-02-01','2014-01-02 17:37:32','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-03 02:03:13'),(7117,5647,'Y','18','021','EC','A','','','AC','0000397341','0000397341','OH00000023194','IL','1','Tilton','Lisa','','','','34','289800303','6405 Panhandle Road',0,'Hillsboro','OH','45133',NULL,'CY','39071','1967-12-29','F','M',':RET:2106-3','N','021','HLT','2045752','92036OH001000601','2014-01-01','2013-12-24 20:39:28','29.00',NULL,NULL,'388.40','359.40','R-OH005','OH0','388.40',NULL,0,'2013-12-26 01:51:13'),(6791,5386,'Y','18','021','EC','A','','','AC','0000838372','0000838372','TX00000096250','IL','1','RUHMANN','JOY','','','','34','453155847','704 E LAMAR ST',0,'PALESTINE','TX','75801','3710','CY','48001','1955-06-07','F','M',':RET:2106-3','N','021','DEN','295158','33348TX002000201','2014-01-01','2013-11-25 16:05:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:17:04'),(19891,15865,'Y','18','021','EC','A','','','AC','0000718945','0000718945','OH00002349584','IL','1','Sites','Susan','A','','','34','300685295','321 north muleerry',0,'spencerville','OH','45887',NULL,'CY','39003','1959-06-04','F','M',':RET:2106-3','N','021','HLT','2173948','92036OH005001505','2014-03-01','2014-01-24 15:20:14','395.00',NULL,NULL,'469.88','74.88','R-OH002','OH0','469.88',NULL,0,'2014-01-24 21:00:51'),(26218,20793,'Y','18','021','EC','A','','','AC','0000926326','0000926326','OH00002440579','IL','1','fugate','mandy','','','','34','290744698','897 BERWIN ST',0,'AKRON','OH','44310','2145','CY','39153','1979-03-02','F','U',':RET:2106-3','T','021','HLT','3851154','52664OH151001306','2014-03-01','2014-02-27 17:57:00','206.00',NULL,NULL,'311.34','105.34','R-OH012','OH0','311.34',NULL,0,'2014-02-28 06:30:56'),(1047,859,'Y','18','021','EC','A','','','AC','0001124536','0001124536','TX00000561406','IL','1','Snowden','Paulette','','','','34','211407979','7503 WOODSMAN TRL',0,'HOUSTON','TX','77040','1710','CY','48201','1950-02-13','F','U',NULL,'N','021','DEN','56248','33348TX002000201','2014-01-01','2013-12-03 16:58:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:15:56'),(9674,7665,'Y','18','024','14','A','','','TE','0000658416','0000658416','','IL','1','Stout','Linda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-08','F','',NULL,NULL,NULL,'','2080829','','2013-12-21','2013-12-21 08:59:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:39:20'),(7348,5818,'Y','18','021','EC','A','','','AC','0001086767','0001086767','OH00000687340','IL','1','Siebert','Todd','','','','34','522118806','9660 SEAMAN RD',0,'CURTICE','OH','43412','9710','CY','39095','1965-06-23','M','R',NULL,'N','021','HLT','1149074','92036OH004002601','2014-01-01','2013-12-14 16:57:30','0.00',NULL,NULL,'256.36','256.36','R-OH001','OH0','256.36',NULL,0,'2013-12-26 02:04:10'),(17768,14196,'Y','18','021','EC','A','','','AC','0001056330','0001056330','TX00001555885','IL','1','NGUYEN','THUY','t','','','34','604539728','4706 N MIDKISS RD',0,'MIDLAND','TX','79705',NULL,'CY','48329','1983-01-05','F','U',':RET:2047-9','N','021','DEN','2114060','33348TX002000101','2014-02-01','2014-01-13 12:08:48','0.00',NULL,NULL,'25.02','25.02','R-TX016','TX0','25.02',NULL,0,'2014-01-14 01:33:36'),(16130,12920,'Y','18','021','EC','A','','','AC','0000827174','0000827174','OH00001541689','IL','1','Murphy','Paula','A','','','34','298481187','47 NESTICO DR',0,'CUYAHOGA FALLS','OH','44223','2660','CY','39153','1950-06-25','F','U',':RET:2106-3','N','021','HLT','1422801','52664OH151001301','2014-02-01','2014-01-03 09:49:27','313.00',NULL,NULL,'658.32','345.32','R-OH012','OH0','658.32',NULL,0,'2014-01-04 02:05:39'),(13389,10688,'Y','18','021','EC','A','','','AC','0000640922','0000640922','OH00000463771','IL','1','Sheal','Jennifer','','','','34','287801012','10145 PIPPIN RD',0,'CINCINNATI','OH','45231','2031','CY','39061','1983-03-02','F','U',':RET:2106-3','N','021','DEN','1418752','99734OH005000301','2014-01-01','2013-12-23 06:44:32','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:00:06'),(14058,11201,'Y','18','021','EC','A','','','AC','0000370028','0000370028','OH00001758169','IL','1','Farris','Sarah','','','','34','283828648','12 OSAGE CT',0,'TIPP CITY','OH','45371','1517','CY','39109','1984-04-26','F','M',':RET:2106-3','N','021','DEN','1581176','99734OH005000401','2014-02-01','2013-12-25 19:03:06','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-27 02:00:29'),(4056,3240,'Y','18','021','EC','A','','','AC','0000205772','0000205772','OH00000282663','IL','1','MCKINNON','BOBBY','D','','','34','290569754','1600 BLAIR AVE NW',0,'WARREN','OH','44483','3308','CY','39155','1954-05-20','M','M',NULL,'N','021','DEN','2120738','99734OH005000401','2014-01-01','2013-12-17 15:14:21','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 21:46:33'),(4090,3267,'Y','18','021','EC','A','','','AC','0001136642','0001136642','OH00000516584','IL','1','LADD','DEBORAH','A','','','34','289568228','5242 303RD ST',0,'TOLEDO','OH','43611',NULL,'CY','39095','1954-07-20','F','M',':RET:2106-3','N','021','HLT','1560964','92036OH005002606','2014-01-01','2013-12-17 18:22:31','409.00',NULL,NULL,'507.58','98.58','R-OH001','OH0','507.58',NULL,0,'2013-12-25 21:47:24'),(13184,10518,'Y','18','021','EC','A','','','AC','0000370688','0000370688','TX00000246072','IL','1','Lalime','Melody','','','','34','441624028','13410 E CYPRESS FOREST DR',0,'HOUSTON','TX','77070','4009','CY','48201','1957-06-02','F','M',':RET:2106-3','N','021','DEN','2280246','33348TX002000101','2014-01-01','2013-12-22 22:54:49','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:25'),(1471,1226,'Y','18','024','14','A','','','TE','0001045680','0001045680','','IL','1','Jacobson','Cynthia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-02-20','F','',NULL,NULL,NULL,'','1375586','','2013-12-24','2013-12-24 09:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:35'),(6964,5529,'Y','18','021','EC','A','','','AC','0001096764','0001096764','OH00001614906','IL','1','SYNDER','JONATHAN','','','','34','279627299','976 W WEBB RD',0,'MERIAL RIDGE','OH','44440',NULL,'CY','39155','1967-09-27','M','M',NULL,'N','021','DEN','1819156','99734OH005000401','2014-01-01','2013-12-24 22:46:13','0.00',NULL,NULL,'71.95','71.95','R-OH013','OH0','0.00',NULL,0,'2013-12-26 01:47:20'),(23563,18771,'Y','18','021','EC','A','','','AC','0001100635','0001100635','OH00002457996','IL','1','HARTINGER','DOUGLAS','R','','','34','296562395','5300 POLING RD',0,'LIMA','OH','45807','9456','CY','39003','1955-04-04','M','U',NULL,'T','021','HLT','3399025','92036OH002001501','2014-03-01','2014-02-13 09:54:42','182.00',NULL,NULL,'744.73','562.73','R-OH002','OH0','744.73',NULL,0,'2014-02-13 22:02:45'),(21331,17046,'Y','18','021','EC','A','','','AC','0000660512','0000660512','TX00001933953','IL','1','finfrock','abram','','','','34','432697120','800 PLUM ST',0,'GRAHAM','TX','76450','3517','CY','48503','1982-12-13','M','U',NULL,'T','021','DEN','3172599','33348TX002000201','2014-03-01','2014-02-03 18:46:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-04 21:00:28'),(20591,16453,'N','01','021','EC','A',NULL,NULL,'','0001067016','0000491914','','IL','1','Do','Thuong','','','','34','274119622','7927 Furrow Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1983-12-16','F','',':RET:2047-9','N','021','DEN','3406537','99734OH005000401','2014-03-01','2014-01-30 09:15:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:08'),(2958,2382,'Y','18','021','EC','A','','','AC','0000775675','0000775675','TX00000211239','IL','1','Briganti','Denise','','','','34','150482482','12489 TIERRA LAUREL DR',0,'EL PASO','TX','79938','4503','CY','48141','1953-05-26','F','M',':RET:2106-3','N','021','DEN','901165','33348TX002000201','2014-01-01','2013-12-06 17:04:31','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 20:16:41'),(4957,3935,'Y','18','021','EC','A','','','AC','0000998137','0000998137','LA00000165070','IL','1','Bui','Lo','','','','34','659140620','1041 MICHAEL ST',0,'MARRERO','LA','70072','2636','CY','22051','1956-07-24','F','M',':RET:2047-9','N','021','DEN','1205719','18575LA002000201','2014-01-01','2013-12-06 21:56:27','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:05'),(4573,3622,'Y','18','021','EC','A','','','AC','0000080816','0000080816','TX00000713602','IL','1','Medrano','Alfredo','','','Sr','34','334646019','3651 BULL MOOSE CT',0,'EL PASO','TX','79938','2600','CY','48141','1965-03-14','M','M',':RET:2106-3','N','021','DEN','1162406','33348TX002000101','2014-01-01','2013-12-12 15:28:07','0.00',NULL,NULL,'50.04','50.04','R-TX009','TX0','25.02',NULL,0,'2013-12-25 22:05:02'),(13549,10805,'Y','18','021','EC','A','','','AC','0002239328','0002239328','LA00001251223','IL','1','Greer','Cynthia','','','','34','435064717','3436 Dryades St.',0,'New Orleans','LA','70115',NULL,'CY','22071','1959-11-30','F','M',':RET:2106-3','N','021','DEN','1649695','18575LA002000201','2014-01-01','2013-12-23 14:53:49','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:01'),(13330,10643,'Y','18','021','EC','A','','','AC','0000917419','0000917419','TX00000100083','IL','1','Lunsford','Cynthia','','','','34','462232917','775 COUNTY ROAD 404',0,'TAYLOR','TX','76574','5221','CY','48491','1958-02-10','F','M',NULL,'T','021','DEN','2336125','33348TX002000201','2014-01-01','2013-12-23 17:28:22','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:58:35'),(15207,12153,'Y','18','021','EC','A','','','AC','0001107127','0001107127','MS00000145690','IL','1','Travis','Richie','','','','34','428338500','219 White Sand Rd',0,'Poplarville','MS','39470',NULL,'CY','28109','1964-02-07','M','U',':RET:2054-5','N','021','DEN','1826371','46300MS002000201','2014-02-01','2013-12-30 16:18:05','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-01 12:07:35'),(3203,2577,'Y','18','021','EC','A','','','AC','0000896948','0000896948','OH00000979394','IL','1','Fortlage','Andrew','','','','34','301889920','1082 Fairview Ave.',0,'Bowling Green','OH','43402',NULL,'CY','39173','1987-05-17','M','U',NULL,'N','021','DEN','1056883','99734OH005000301','2014-01-01','2013-11-01 08:18:58','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 20:45:14'),(26214,20790,'Y','18','021','EC','A','','','AC','0000060323','0000060323','OH00003230841','IL','1','tribble','renee',NULL,NULL,NULL,NULL,NULL,'800 Bartlett',0,'Aurora','OH','44202',NULL,'CY','39133','1957-05-05','F','M',':RET:2106-3','N','021','HLT','3118742','52664OH151001304','2014-03-01','2014-02-27 15:29:07','265.00',NULL,NULL,'520.28','255.28','R-OH012','OH0','520.28',NULL,0,'2014-02-28 06:30:54'),(26507,21024,'N','19','021','EC','A',NULL,NULL,'','0000496746','0000247951','','S1','1','Grande','Stephen','M','','','34','282088670','7716 BRIDGEWATER LN',0,'HAMILTON','OH','45011','6467','CY','39017','2003-06-18','F','',':RET:2106-3','N','021','DEN','3104329','99734OH005000401','2014-03-01','2014-02-28 15:49:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 21:00:18'),(28087,22229,'Y','18','021','EC','A','','','AC','0000448366','0000448366','TX00002595568','IL','1','LERNER','ELLEN','','','','34','090466524','11109 MONICA CT',0,'FORT WORTH','TX','76244','7434','CY','48439','1952-08-30','F','M',NULL,'N','021','DEN','3458963','33348TX002000101','2014-04-01','2014-03-06 16:08:52','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-06 21:02:01'),(28193,22309,'N','01','021','EC','A',NULL,NULL,'','0001059944','0000047298','','IL','1','Nguyen','Destinie','','','','34','457635688','112 SAINT JOSEPH ST',0,'PALACIOS','TX','77465','2502','CY','48321','1970-09-30','F','',':RET:2047-9','N','021','DEN','3719113','33348TX002000201','2014-04-01','2014-03-05 19:08:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-06 21:30:05'),(2508,2043,'Y','18','021','EC','A','','','AC','0000011135','0000011135','OH00000369047','IL','1','MONEY','AMBER','','','','34','282940947','929 LORETTA PL',0,'LIMA','OH','45805','1639','CY','39003','1988-08-09','F','U',':RET:2106-3','N','021','HLT','717604','92036OH003001506','2014-01-01','2013-12-09 16:04:35','197.00',NULL,NULL,'230.76','33.76','R-OH002','OH0','230.76',NULL,0,'2013-12-25 19:36:12'),(3808,3051,'N','01','021','EC','A',NULL,NULL,'','0000025274','0000916983','','IL','1','Kirby','Kristin','Elaine','','','34','268907541','22 Basin St.',0,'Navarre','OH','44662',NULL,'CY','39151','1977-04-19','F','',':RET:2106-3','N','021','DEN','998037','99734OH005000301','2014-01-01','2013-12-13 13:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:41'),(5433,4315,'Y','18','021','EC','A','','','AC','0001949848','0001949848','LA00000720205','IL','1','hernandez','deanna','','','','34','436332261','45225 MAYERS ESTATES RD',0,'PRAIRIEVILLE','LA','70769','6739','CY','22005','1971-02-26','F','U',NULL,'N','021','DEN','1992308','18575LA002000101','2014-01-01','2013-12-19 15:44:23','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:09:43'),(22128,17660,'Y','18','021','EC','A','','','AC','0000544159','0000544159','OH00001573607','IL','1','TAYLOR','KELSEY','M','','','34','290923741','5096 ORANGELAWN DR',0,'CINCINNATI','OH','45238','5722','CY','39061','1987-12-11','F','U',':RET:2106-3','N','021','DEN','2842730','99734OH005000401','2014-03-01','2014-02-07 21:19:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-08 19:00:42'),(21810,17417,'N','01','021','EC','A',NULL,NULL,'','0000277306','0000255999','','IL','1','Leask','Marty','','','','34','271602594','538 S.R. 14',0,'Deerfield','OH','44411',NULL,'CY','39133','1955-10-29','F','',':RET:2106-3','N','021','HLT','3172649','52664OH151001305','2014-03-01','2014-02-06 08:37:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2014-02-06 21:00:54'),(20201,16119,'Y','18','024','14','A','','','TE','0000560561','0000560561','','IL','1','Koch','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-08-07','F','',NULL,NULL,NULL,'','1475492','','2014-01-27','2014-01-27 10:19:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:32'),(17123,13703,'Y','18','021','EC','A','','','AC','0000541660','0000541660','OH00002465886','IL','1','Washington','Deborah','','','','34','283669251','2624 Gingerwren Rd',0,'Pepper Pike','OH','44124',NULL,'CY','39035','1960-01-15','F','U',':RET:2054-5','N','021','DEN','1856682','99734OH005000401','2014-02-01','2014-01-08 10:37:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:21:42'),(13650,10889,'Y','18','021','EC','A','','','AC','0002326336','0002326336','LA00000007819','IL','1','Sobelman','Randi','','','','34','048462555','800 LIVE OAK ST',0,'METAIRIE','LA','70005','1216','CY','22051','1955-05-09','F','U',':RET:2106-3','N','021','DEN','2467247','18575LA002000101','2014-01-01','2013-12-22 21:13:32','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:16'),(19874,15853,'Y','18','021','EC','A','','','AC','0000486972','0000486972','OH00002471577','IL','1','Ramirez','Angie','','','','34','299841800','2763 bell rd',0,'hamilton','OH','45013',NULL,'CY','39017','1986-12-09','F','U',':RET:2106-3','N','021','DEN','2047606','99734OH005000401','2014-03-01','2014-01-24 17:27:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-24 21:00:42'),(25992,20613,'Y','18','021','EC','A','','','AC','0000201683','0000201683','MS00002901354','IL','1','Douglas','Marilyn','','','','34','425215727','103 Ridgecrest Drive',0,'Ridgeland','MS','39157',NULL,'CY','28089','1960-08-10','F','U',':RET:2054-5','N','021','DEN','2783309','46300MS002000201','2014-03-01','2014-02-26 14:35:43','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:57'),(24185,19213,'Y','18','021','EC','A','','','AC','0000841969','0000841969','OH00002195521','IL','1','Farr','Bonnie','','','','34','363623844','507 bourbon st',0,'blanchester','OH','45107',NULL,'CY','39027','1962-08-31','F','M',':RET:2106-3','T','021','HLT','3446831','92036OH005000606','2014-03-01','2014-02-15 18:25:19','792.00',NULL,NULL,'964.05','172.05','R-OH005','OH0','460.43',NULL,0,'2014-02-16 19:00:10'),(22144,17675,'Y','18','021','EC','A','','','AC','0001025540','0001025540','OH00002675418','IL','1','Knerem','Keith','Allen','','Sr','34','269503628','8249 Newton Falls Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1950-07-10','M','M',':RET:2106-3','T','021','HLT','3724896','52664OH152000901','2014-03-01','2014-02-08 17:16:52','554.51',NULL,NULL,'554.51','0.00','R-OH012','OH0','554.51',NULL,0,'2014-02-08 19:00:50'),(26925,21338,'Y','18','021','EC','A','','','AC','0000816480','0000816480','OH00003598827','IL','1','Kersh','Ernest','Michael','','','34','427925581','4901 Far Hills Avenue',0,'Kettering','OH','45429',NULL,'CY','39113','1952-09-23','M','U',':RET:2106-3','N','021','DEN','2804404','99734OH005000401','2014-04-01','2014-03-02 12:04:05','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-03 01:00:17'),(27794,21984,'Y','18','021','EC','A','','','AC','0001152145','0001152145','MS00003057623','IL','1','FLOWERS','LISA','','','','34','570596949','352 S SWEET HOME CHURCH ROAD',0,'PEARL','MS','39208',NULL,'CY','28121','1966-03-28','F','U',':RET:2054-5','N','021','DEN','3168326','46300MS002000201','2014-04-01','2014-03-05 16:14:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-05 21:31:42'),(15241,12182,'Y','18','021','EC','A','','','AC','0000491838','0000491838','OH00001893428','IL','1','Snyder','Tabitha','','','','34','272922088','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1986-06-05','F','M',':RET:2106-3','N','021','HLT','2371100','92036OH003002605','2014-02-01','2013-12-30 09:18:18','175.00',NULL,NULL,'444.53','269.53','R-OH001','OH0','213.40',NULL,0,'2014-01-01 12:08:37'),(855,709,'Y','18','021','EC','A','','','AC','0000156918','0000156918','OH00000484889','IL','1','Schumann','Jared','','','','34','290789203','14504 State Route 67',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1982-03-09','M','M',':RET:2106-3','N','021','HLT','1750982','92036OH005001505','2014-01-01','2013-12-16 12:23:52','344.00',NULL,NULL,'510.16','166.16','R-OH002','OH0','255.08',NULL,0,'2013-12-25 18:07:01'),(1474,1229,'Y','18','021','EC','A','','','AC','0000926274','0000926274','OH00000599418','IL','1','Schroer','Robert','','','','34','291484393','1580 SIEGRIST JUTTE RD',0,'FORT RECOVERY','OH','45846','9514','CY','39107','1952-05-10','M','M',':RET:2106-3','N','021','DEN','2000078','99734OH005000401','2014-01-01','2013-12-24 09:53:23','0.00',NULL,NULL,'31.57','31.57','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:48:39'),(18644,14863,'Y','18','021','EC','A','','','AC','0000583055','0000583055','TX00002276387','IL','1','Palacios','Kasandra','','','','34','449477403','811 E MAGNOLIA AVE',0,'SAN ANTONIO','TX','78212','3114','CY','48029','1966-09-09','F','U',NULL,'N','021','DEN','2852105','33348TX002000201','2014-03-01','2014-01-16 00:32:59','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-17 03:35:07'),(14357,11451,'Y','18','021','EC','A','','','AC','0000801269','0000801269','OH00001035741','IL','1','Czaplicki','Daniel','','','','34','415434641','61 HENDERSON ST',0,'SOUTH BLOOMFIELD','OH','43103','8500','CY','39129','1984-02-21','M','M',':RET:2106-3','N','021','DEN','1857810','99734OH005000401','2014-02-01','2013-12-26 19:14:23','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:11'),(16284,13036,'Y','18','021','EC','A','','','AC','0000963243','0000963243','OH00001610341','IL','1','Webster','Joan','','','','34','299509003','919 SUNRISE DR',0,'LOVELAND','OH','45140','2562','CY','39061','1950-02-12','F','U',':RET:2106-3','N','021','DEN','1599796','99734OH005000401','2014-02-01','2014-01-06 11:05:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:37'),(4670,3702,'Y','18','021','EC','A','','','AC','0000714553','0000714553','LA00001158698','IL','1','Murdoch','Dave','','','','34','438880021','2313 Bon Vie Drive',0,'Sulphur','LA','70665',NULL,'CY','22019','1952-11-19','M','U',':RET:2106-3','T','021','DEN','928798','18575LA002000201','2014-01-01','2013-12-12 13:57:03','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 22:07:35'),(13617,10857,'N','01','021','EC','A',NULL,NULL,'','0000130697','0000478478','','IL','1','Couch','Charles','','','','34','282520696','1621 STAHLHEBER RD',0,'HAMILTON','OH','45013','1919','CY','39017','1951-09-11','M','',NULL,'N','021','HLT','2205443','92036OH002001201','2014-01-01','2013-12-23 15:21:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','712.24',NULL,0,'2013-12-26 13:05:45'),(26486,21009,'N','01','021','EC','A',NULL,NULL,'','0000163099','0000003315','','IL','1','crochet','cheryl','','','','34','434153128','15081 chenal road',0,'Jarreau','LA','70749',NULL,'CY','22077','1957-08-04','F','',':RET:2106-3','N','021','DEN','2678654','18575LA002000201','2014-04-01','2014-02-27 20:42:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-28 21:00:07'),(27749,21943,'Y','18','021','EC','A','','','AC','0001581391','0001581391','LA00003669569','31','1','Garrene','Debra','','','','34','437252491','P O Box 86738',0,'Baton Rouge','LA','70879',NULL,'CY','22033','1961-10-24','F','U',':RET:2106-3','N','021','DEN','3388196','18575LA002000201','2014-04-01','2014-03-04 19:54:43','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:14'),(4623,3662,'Y','18','021','EC','A','','','AC','0000051332','0000051332','LA00000511732','IL','1','GILMORE','CHRISTY','','','','34','439610310','8576 SLIGO RD',0,'SAINT FRANCISVILLE','LA','70775','5806','CY','22125','1986-06-28','F','U',':RET:2054-5','N','021','DEN','1117611','18575LA002000101','2014-01-01','2013-12-12 12:31:57','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 22:06:17'),(16709,13372,'Y','18','021','EC','A','','','AC','0000213354','0000213354','TX00002048779','IL','1','MORALES','CINTHYA','','','','34','631583819','13015 PRAIRIE FALCON',0,'SAN ANTONIO','TX','78233','4667','CY','48029','1982-01-08','F','U',NULL,'N','021','DEN','1906460','33348TX002000201','2014-02-01','2014-01-06 22:36:00','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-08 18:24:42'),(21259,16989,'Y','18','021','EC','A','','','AC','0001130258','0001130258','OH00001950345','IL','1','Davis','Jeffrey','','','','34','295740724','4308 Jacksonburg Road',0,'Hamilton','OH','45011',NULL,'CY','39017','1978-05-09','M','M',':RET:2106-3','N','021','HLT','2879020','92036OH003001204','2014-03-01','2014-02-03 16:01:59','197.00',NULL,NULL,'593.09','396.09','R-OH004','OH0','273.93',NULL,0,'2014-02-03 21:01:22'),(20253,16162,'Y','18','021','EC','A','','','AC','0000060300','0000060300','OH00001930166','IL','1','Covill','Scott','','','','34','273769170','545 W Friendship St',0,'Medina','OH','44256',NULL,'CY','39103','1963-08-05','M','U',':RET:2106-3','N','021','DEN','3123212','99734OH005000301','2014-03-01','2014-01-27 18:47:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-28 21:00:15'),(19176,15277,'Y','18','024','14','A','','','TE','0000542424','0000542424','','IL','1','Burke','Bobette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-01','F','',NULL,NULL,NULL,'','2096909','','2014-01-20','2014-01-20 12:55:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-21 08:46:05'),(17115,13698,'Y','18','021','EC','A','','','AC','0000223715','0000223715','OH00001651847','IL','1','WAINSCOTT','LORI','LEE','','','34','272662425','569 COVEDALE AVE',0,'CINCINNATI','OH','45238','5324','CY','39061','1962-09-16','F','M',':RET:2106-3','N','021','DEN','1494126','99734OH005000401','2014-02-01','2014-01-07 22:08:23','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:21:40'),(14469,11545,'Y','18','024','14','A','','','TE','0000478205','0000478205','','IL','1','mancine','steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-07-30','M','',NULL,NULL,NULL,'','1103756','','2013-12-26','2013-12-26 19:03:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-28 03:32:59'),(26361,20910,'Y','18','021','EC','A','','','AC','0000229490','0000229490','OH00002520229','IL','1','bowling','brad','','','','34','283607444','37424 HUNTERS RIDGE RD',0,'SOLON','OH','44139','2535','CY','39035','1970-12-22','M','M',NULL,'N','021','DEN','2866980','99734OH005000301','2014-04-01','2014-02-26 10:29:10','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00','CIC',0,'2014-02-28 07:00:05'),(16645,13317,'Y','18','021','EC','A','','','AC','0001151094','0001151094','OH00002371901','IL','1','SLATER','LISA','','','','34','300444502','57 VIRGINA AVE.',0,'GERMANTOWN','OH','45327',NULL,'CY','39113','1956-11-04','F','M',':RET:2106-3','T','021','DEN','1654218','99734OH005000401','2014-02-01','2014-01-07 17:52:46','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:18'),(15593,12477,'N','01','021','EC','A',NULL,NULL,'','0001063253','0000726140','','IL','1','mcguire','david','','','','34','294529317','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1955-05-11','M','',NULL,'N','021','DEN','2167311','99734OH005000301','2014-02-01','2013-12-31 10:46:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:27'),(6821,5408,'Y','18','021','EC','A','','','AC','0000384092','0000384092','MS00000948136','IL','1','johnson','brianna','','','','34','409674283','4375 highway 51 n.',0,'horn lake','MS','38637',NULL,'CY','28033','1990-08-22','F','U',':RET:2054-5','N','021','DEN','657131','46300MS002000101','2014-01-01','2013-11-13 21:17:21','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2013-12-26 01:30:32'),(27735,21932,'Y','18','021','EC','A','','','AC','0000288327','0000288327','TX00002923126','IL','1','Hanna','Victoria','','','','34','624165137','4943 GUADALUPE DR',0,'EL PASO','TX','79904','2009','CY','48141','1985-04-16','F','U',NULL,'N','021','DEN','4135367','33348TX002000201','2014-04-01','2014-03-05 16:19:35','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:31:06'),(2143,1761,'Y','18','021','EC','A','','','AC','0000823113','0000823113','MS00000873748','31','1','Bourland','Brent','','','','34','425982855','P.O Box 982',0,'Natchez','MS','39121',NULL,'CY','28001','1949-11-07','M','U',':RET:2106-3','N','021','DEN','1217814','46300MS002000101','2014-01-01','2013-12-10 17:20:29','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 19:18:19'),(7762,6148,'N','01','021','EC','A',NULL,NULL,'','0001219585','0001037350','','IL','1','Blevins','Melba','','','','34','424644907','6521 Elwynne Dr',0,'Cincinnati','OH','45236',NULL,'CY','39061','1950-03-22','F','',':RET:2054-5','T','021','DEN','2022030','99734OH005000401','2014-01-01','2013-12-20 18:41:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:47'),(23795,18935,'Y','18','021','EC','A','','','AC','0000983887','0000983887','OH00002422318','IL','1','Metz','Natasia','','','','34','292802810','3891 VALLEY DR',0,'NORTON','OH','44203','5544','CY','39153','1974-09-26','F','M',':RET:2106-3','N','021','HLT','3013434','52664OH151001304','2014-03-01','2014-02-14 12:17:59','116.00',NULL,NULL,'592.98','476.98','R-OH012','OH0','281.44',NULL,0,'2014-02-14 21:31:27'),(13455,10729,'Y','18','021','EC','A','','','AC','0000146884','0000146884','OH00000685162','IL','1','Feerer','Hannah','V','','','34','287135342','1121 Pursell Ave',0,'Dayton','OH','45420',NULL,'CY','39113','2007-10-03','F','U',':RET:2106-3','N','021','DEN','1402928','99734OH005000301','2014-01-01','2013-12-23 14:53:46','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','21.13',NULL,0,'2013-12-26 13:01:37'),(2576,2093,'Y','18','021','EC','A','','','AC','0001184864','0001184864','OH00000560120','31','1','Maiorana','Gina','','','','34','124541792','P.O. Box 72',0,'Newtonsville','OH','45158',NULL,'CY','39025','1960-06-28','F','U',':RET:2106-3','N','021','HLT','980842','92036OH002000601','2014-01-01','2013-12-09 16:03:32','264.00',NULL,NULL,'505.73','241.73','R-OH005','OH0','505.73',NULL,0,'2013-12-25 19:37:49'),(24124,19176,'Y','18','021','EC','A','','','AC','0002315173','0002315173','LA00002869534','IL','1','Moton','Melvin','','','','34','435845668','5433 RIVERBEND BLVD',0,'BATON ROUGE','LA','70820','4314','CY','22033','1951-01-08','M','M',':RET:2054-5','N','021','DEN','2863476','18575LA002000101','2014-03-01','2014-02-14 20:55:47','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-02-15 22:01:44'),(8068,6389,'Y','18','021','EC','A','','','AC','0000067661','0000067661','OH00001154841','IL','1','Stangelo','Megan','','','','34','291808836','340 West Wooster',0,'Bowling Green','OH','43402',NULL,'CY','39173','1983-07-29','F','U',':RET:2106-3','N','021','HLT','2046587','92036OH006002601','2014-01-01','2013-12-20 14:25:35','0.00',NULL,NULL,'175.52','175.52','R-OH001','OH0','175.52',NULL,0,'2013-12-26 03:10:07'),(4540,3597,'Y','18','021','EC','A','','','AC','0000028235','0000028235','TX00001138494','IL','1','Espinoza','Victoriano','','','','34','450948034','2206 ARBOR ST',0,'HOUSTON','TX','77004','6027','CY','48201','1951-03-23','M','U',NULL,'N','021','DEN','744512','33348TX002000201','2014-01-01','2013-12-12 17:17:03','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 22:04:15'),(5643,4476,'N','01','021','EC','A',NULL,NULL,'','0001107547','0000594226','','IL','1','Novak','Dawn','Marie','','','34','059585343','22959 CREEKSIDE WILLOW DR',0,'TOMBALL','TX','77375','7196','CY','48201','1960-01-04','F','',':RET:2106-3','N','021','DEN','1071075','33348TX002000201','2014-01-01','2013-11-26 14:47:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 23:31:18'),(13202,10535,'Y','18','021','EC','A','','','AC','0000976419','0000976419','TX00000639419','IL','1','Dang','Mikal','','','','34','466630547','3501 N JUPITER RD',0,'RICHARDSON','TX','75082','2218','CY','48085','1983-03-06','M','U',':RET:2047-9','N','021','DEN','1656544','33348TX002000101','2014-01-01','2013-12-23 15:34:09','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 12:54:59'),(22746,18160,'Y','18','021','EC','A','','','AC','0000942040','0000942040','OH00001359137','IL','1','stout','douglas','','','','34','310649074','808 clover circle',0,'oxford','OH','45056',NULL,'CY','39017','1954-10-02','M','U',':RET:2106-3','T','021','HLT','3792456','92036OH006001201','2014-03-01','2014-02-10 19:10:14','177.00',NULL,NULL,'509.63','332.63','R-OH004','OH0','509.63',NULL,0,'2014-02-11 21:01:23'),(24587,19520,'Y','18','021','EC','A','','','AC','0000873284','0000873284','OH00002522382','IL','1','Kellerman','William','','','','34','285642786','4517 SPIKERUSH LN',0,'WEST CHESTER','OH','45069','5894','CY','39017','1960-01-05','M','U',':RET:2106-3','N','021','DEN','3197752','99734OH005000301','2014-04-01','2014-02-19 11:31:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:09:47'),(2625,2135,'Y','18','021','EC','A','','','AC','0000353936','0000353936','OH00001149114','IL','1','Belden','Sam','','','','34','300745773','1224 N MANTUA ST',0,'KENT','OH','44240','2330','CY','39133','1970-01-16','M','U',':RET:2106-3','N','021','DEN','596401','99734OH005000401','2014-01-01','2013-12-02 12:28:10','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:45:58'),(22789,18195,'Y','18','021','EC','A','','','AC','0001095701','0001095701','OH00001767037','IL','1','SELF','STEPHEN','A','','','34','293486538','816 WILLARD ST',0,'WASHINGTON COURT HOUSE','OH','43160','2157','CY','39047','1950-01-21','M','M',':RET:2106-3','N','021','DEN','3144332','99734OH005000301','2014-03-01','2014-02-11 12:03:30','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-02-11 21:01:49'),(7422,5873,'Y','18','021','EC','A','','','AC','0000767369','0000767369','OH00000355420','IL','1','Mantonya','Whitney','','','','34','296767864','782 TWIN ACORN CT',0,'BLACKLICK','OH','43004','8818','CY','39049','1968-07-16','F','U',':RET:2106-3','N','021','DEN','689557','99734OH005000301','2014-01-01','2013-10-26 20:48:27','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:17:03'),(539,440,'Y','18','021','EC','A','','','AC','0000338847','0000338847','OH00000898225','IL','1','Grigsby','Scott',NULL,NULL,NULL,NULL,NULL,'278 E TUSCARAWAS AVE',0,'BARBERTON','OH','44203','3241','CY','39153','1981-06-29','M','U',':RET:2106-3','N','021','HLT','47228','52664OH152000901','2014-01-01','2013-12-03 22:51:36','151.00',NULL,NULL,'193.23','42.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 17:49:39'),(21107,16864,'Y','18','021','EC','A','','','AC','0000424064','0000424064','OH00002036470','IL','1','Lange','Dennis','','','','34','275485444','2116 Scottwood Ave',0,'Toledo','OH','43620',NULL,'CY','39095','1952-08-09','M','U',NULL,'N','021','HLT','3634760','92036OH004002601','2014-03-01','2014-02-03 18:04:03','306.00',NULL,NULL,'440.60','134.60','R-OH001','OH0','440.60',NULL,0,'2014-02-03 21:00:05'),(19404,15471,'Y','18','021','EC','A','','','AC','0000670285','0000670285','OH00002455025','IL','1','GREER','JANE','','','','34','286583187','7689 TOWNSHIP ROAD 237',0,'FINDLAY','OH','45840','8679','CY','39063','1955-12-29','F','M',':RET:2106-3','N','021','HLT','2794661','92036OH005001501','2014-03-01','2014-01-21 09:51:53','167.00',NULL,NULL,'560.76','393.76','R-OH002','OH0','560.76',NULL,1,'2014-01-22 03:22:54'),(13591,10841,'Y','18','021','EC','A','','','AC','0002323807','0002323807','LA00000538292','31','1','LANDRY','LOELLA','','','','34','436278283','po box 10584',0,'HAMMOND','LA','70404',NULL,'CY','22105','1958-06-23','F','U',NULL,'N','021','DEN','2058099','18575LA002000201','2014-01-01','2013-12-23 19:15:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:05:11'),(1083,889,'Y','18','021','EC','A','','','AC','0000029011','0000029011','OH00001289053','IL','1','Yurcik','John','','','','34','278501615','13324 Tomson Drive',0,'Strongsville','OH','44149',NULL,'CY','39035','1952-05-15','M','U',':RET:2106-3','N','021','DEN','958395','99734OH005000401','2014-01-01','2013-12-03 10:47:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:49'),(3198,2572,'Y','18','021','EC','A','','','AC','0000544084','0000544084','OH00000408477','IL','1','Menge','Emma','','','','34','295082972','269 W 8TH ST',0,'MARYSVILLE','OH','43040','1537','CY','39159','2004-03-11','F','U',':RET:2106-3','N','021','DEN','380551','99734OH005000401','2014-01-01','2013-11-01 15:39:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-25 20:45:05'),(6637,5265,'Y','18','021','EC','A','','','AC','0001053019','0001053019','OH00000284461','IL','1','Pemberton','James','','','','34','283826220','3334 Gerold Dr',0,'Cincinnati','OH','45238',NULL,'CY','39061','1984-03-12','M','U',':RET:2106-3','N','021','HLT','1151301','92036OH002001201','2014-01-01','2013-11-11 19:03:11','0.00',NULL,NULL,'277.40','277.40','R-OH004','OH0','277.40',NULL,0,'2013-12-26 01:00:12'),(5493,4360,'N','01','021','EC','A',NULL,NULL,'','0000659881','0001236552','','IL','1','Brown','Roy','A','','','34','290524445','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1956-06-29','M','',':RET:2106-3','N','021','HLT','2099730','92036OH003002605','2014-01-01','2013-12-19 14:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','496.27',NULL,0,'2013-12-25 23:11:05'),(211,176,'Y','18','021','EC','A','','','AC','0000739026','0000739026','LA00000552497','IL','1','Walker','Michael','','','','34','006725968','611 RUE SAINT MARTIN',0,'HAMMOND','LA','70403','5327','CY','22105','1965-01-03','M','U',':RET:2106-3','N','021','DEN','37067','18575LA002000201','2014-01-01','2013-12-05 09:34:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:20:28'),(16132,12922,'Y','18','021','EC','A','','','AC','0000538282','0000538282','OH00001788192','IL','1','DAVIS','KRISTINE','A','','','34','297809827','125 BROOKRUN DR',0,'COPLEY','OH','44321',NULL,'CY','39153','1968-11-01','F','U',NULL,'N','021','HLT','1672977','52664OH151001305','2014-02-01','2014-01-03 12:47:59','207.00',NULL,NULL,'322.02','115.02','R-OH012','OH0','322.02',NULL,0,'2014-01-04 02:05:44'),(24790,19664,'Y','18','021','EC','A','','','AC','0000042107','0000042107','OH00002280950','IL','1','Baker','Jason','','','','34','283765267','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247','7023','CY','39061','1979-06-19','M','U',':RET:2106-3','N','021','DEN','2934802','99734OH005000401','2014-04-01','2014-02-19 15:26:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:46:43'),(7010,5564,'Y','18','021','EC','A','','','AC','0000028334','0000028334','TX00001235935','IL','1','Bruce','Matthew','','','','34','439592277','3220 Duval Rd',0,'Austin','TX','78759',NULL,'CY','48453','1979-01-23','M','U',':RET:2106-3','N','021','DEN','1705044','33348TX002000201','2014-01-01','2013-12-24 19:42:21','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:48:30'),(17330,13862,'N','01','021','EC','A',NULL,NULL,'','0001452405','0001511396','','IL','1','Bedortha','Scott','Alan','','','34','542845892','116 ELMIRA AVE',0,'NEW ORLEANS','LA','70114',NULL,'CY','22071','1962-09-18','M','',':RET:2106-3','N','021','DEN','2602108','18575LA002000201','2014-02-01','2014-01-10 12:14:44',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:23:56'),(19862,15843,'Y','18','021','EC','A','','','AC','0000326218','0000326218','OH00002572339','IL','1','Bistrek','Sharon','','','','34','300684695','4394 marival way',0,'Mason','OH','45040',NULL,'CY','39165','1965-01-04','F','U',':RET:2106-3','N','021','DEN','3015172','99734OH005000401','2014-03-01','2014-01-24 11:59:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-24 21:00:36'),(7109,5639,'Y','18','021','EC','A','','','AC','0001738651','0001738651','LA00000748024','IL','1','Sorenson','Amanda','','','','34','247917398','8026 Jefferson Hwy',0,'Baton rouge','LA','70809',NULL,'CY','22033','1991-08-01','F','R',':RET:2106-3','N','021','DEN','2497054','18575LA002000101','2014-01-01','2013-12-24 20:50:35','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 01:50:58'),(1268,1046,'Y','18','021','EC','A','','','AC','0000312991','0000312991','TX00000911487','IL','1','gibson','tracy','','','','34','458257396','2650 thousand oaks',0,'san antonio','TX','78232',NULL,'CY','48029','1972-03-20','F','U',':RET:2054-5','N','021','DEN','35463','33348TX002000201','2014-01-01','2013-11-29 16:56:59','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 18:30:10'),(26160,20743,'Y','18','021','EC','A','','','AC','0000061372','0000061372','OH00002706097','IL','1','Flannigan','veronica','','','','34','275926906','1366 w.80 street',0,'cleveland','OH','44102',NULL,'CY','39035','1990-04-28','F','U',':RET:2054-5','N','021','DEN','3221511','99734OH005000401','2014-04-01','2014-02-27 17:39:47','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:32'),(2941,2366,'Y','18','021','EC','A','','','AC','0001125409','0001125409','OH00000302373','IL','1','Stacy','Richard','','','','34','301489114','1030 Beryl Trail',0,'Centerville','OH','45459',NULL,'CY','39113','1950-05-08','M','U',':RET:2106-3','N','021','DEN','705493','99734OH005000401','2014-01-01','2013-12-06 12:00:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:16:14'),(1780,1465,'Y','18','021','EC','A','','','AC','0000638513','0000638513','OH00000957799','31','1','Beckford','Mary','Margaret','','','34','283548053','PO Box 614',0,'Put in Bay','OH','43456',NULL,'CY','39123','1955-05-07','F','U',':RET:2106-3','N','021','DEN','2614751','99734OH005000301','2014-01-01','2013-12-24 15:02:56','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 18:56:17'),(17827,14241,'Y','18','021','EC','A','','','AC','0000845241','0000845241','MS00001543183','IL','1','Nguyen','Dung','D','','','34','587712349','15608 BELMONT DR',0,'BILOXI','MS','39532','4053','CY','28059','1955-05-06','M','U',':RET:2028-9','N','021','DEN','2141877','46300MS002000201','2014-02-01','2014-01-14 13:56:16','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-15 02:05:58'),(17486,13981,'Y','18','021','EC','A','','','AC','0000467910','0000467910','TX00001999867','IL','1','Norman','Carlene','','','','34','450969537','824 DEL LENORA DR',0,'DUNCANVILLE','TX','75116','2646','CY','48113','1952-02-05','F','U',NULL,'N','021','DEN','2697569','33348TX002000201','2014-02-01','2014-01-12 17:24:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 03:01:16'),(762,629,'Y','18','021','EC','A','','','AC','0000632311','0000632311','TX00000621309','IL','1','Scroggins','Patricia','','','','34','431964416','419 Clear Creek Lane',0,'Coppell','TX','75019',NULL,'CY','48113','1959-03-14','F','M',':RET:2106-3','N','021','DEN','1469624','33348TX002000201','2014-01-01','2013-12-16 11:30:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:04:35'),(17048,13641,'Y','18','021','EC','A','','','AC','0001062132','0001062132','OH00001543046','IL','1','Engles','Marie','','','','34','287545992','55 WILKERSON CT',0,'SPRINGBORO','OH','45066','8647','CY','39165','1956-01-28','F','M',NULL,'N','021','HLT','1935704','92036OH003001201','2014-02-01','2014-01-09 16:10:48','193.00',NULL,NULL,'571.20','378.20','R-OH004','OH0','571.20',NULL,0,'2014-01-13 02:20:55'),(18623,14847,'Y','18','021','EC','A','','','AC','0000696835','0000696835','OH00001368464','IL','1','Couture','Justin','','','','34','280909794','609 S WESTWOOD AVE',0,'TOLEDO','OH','43609','1525','CY','39095','1983-03-21','M','M',':RET:2106-3','N','021','HLT','1705572','92036OH001002601','2014-02-01','2014-01-14 18:58:30','259.00',NULL,NULL,'522.65','263.65','R-OH001','OH0','266.97',NULL,0,'2014-01-16 08:47:29'),(28334,22418,'Y','18','021','EC','A','','','AC','0000167873','0000167873','TX00002898042','IL','1','Konze','Jennifer','','','','34','557519761','1201 COUNTY ROAD 216',0,'SWEETWATER','TX','79556','8025','CY','48353','1965-02-27','F','R',':RET:2106-3','N','021','DEN','3583235','33348TX002000201','2014-04-01','2014-03-07 08:17:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:12'),(15869,12707,'Y','18','021','EC','A','','','AC','0001164449','0001164449','MS00001764744','IL','1','WILSON','PAMELA','','','','34','426277486','262 MONROE RD',0,'COLLINS','MS','39428','7244','CY','28031','1968-09-10','F','M',NULL,'T','021','DEN','2084019','46300MS002000101','2014-02-01','2014-01-02 14:36:13','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-03 02:05:02'),(7740,6130,'Y','18','021','EC','A','','','AC','0000051914','0000051914','OH00000217764','IL','1','Huesken','Tim','John','','','34','199387589','6304 Cary Avenue',0,'Cincinnati','OH','45224',NULL,'CY','39061','1951-10-01','M','M',':RET:2106-3','N','021','DEN','1745794','99734OH005000401','2014-01-01','2013-12-20 15:42:41','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:02:16'),(22552,18009,'Y','18','021','EC','A','','','AC','0000103926','0000103926','OH00001924033','IL','1','McGowan','Megan','','','','34','250738489','13855 Superior Road',0,'East Cleveland','OH','44118',NULL,'CY','39035','1983-01-02','F','U',NULL,'T','021','DEN','3132011','99734OH005000401','2014-03-01','2014-02-10 00:36:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:46'),(17156,13727,'Y','18','021','EC','A','','','AC','0002152366','0002152366','LA00002464638','IL','1','LANDRY','ARLEEN','','','','34','433354145','1901 HENRY CLAY ST',0,'MANDEVILLE','LA','70448',NULL,'CY','22103','1974-10-25','F','U',':RET:2106-3','N','021','DEN','2345842','18575LA002000201','2014-02-01','2014-01-08 10:00:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:59'),(21148,16899,'Y','18','021','EC','A','','','AC','0000964774','0000964774','TX00001526813','IL','1','Chaparala','Shilpa','','','','34','459392994','2215 Cedar Springs Road',0,'Dallas','TX','75201',NULL,'CY','48113','1972-08-11','F','M',':RET:2029-7','N','021','DEN','2867796','33348TX002000201','2014-03-01','2014-02-03 18:21:36','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-03 21:00:26'),(15603,12483,'N','19','021','EC','A',NULL,NULL,'','0000066261','0000556731','','IL','1','Mecklenborg','Rosie','','','','34','897411108','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2013-11-02','F','',':RET:2106-3','N','021','DEN','1692472','99734OH005000301','2014-02-01','2013-12-31 15:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:40'),(25620,20327,'Y','18','021','EC','A','','','AC','0000229722','0000229722','TX00002753777','IL','1','Tran','Tin','','','','34','623172354','4400 BOONE RD',0,'HOUSTON','TX','77072','1980','CY','48201','1970-12-12','M','M',':RET:2047-9','T','021','DEN','2696286','33348TX002000201','2014-04-01','2014-02-22 14:32:24','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-26 08:30:16'),(5154,4086,'Y','18','021','EC','A','','','AC','0000593666','0000593666','OH00001256857','IL','1','ALLEN','TERRY','','','','34','212727935','787 HALESWORTH DR',0,'CINCINNATI','OH','45240','1801','CY','39061','1954-01-26','M','U',':RET:2106-3','N','021','DEN','1900847','99734OH005000401','2014-01-01','2013-12-19 10:13:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:02:53'),(23851,18978,'Y','18','021','EC','A','','','AC','0000137621','0000137621','OH00002763740','IL','1','POTTKOTTER','CHRISTINA','','','','34','272608899','282 SIEGRIST JUTTE RD',0,'FORT RECOVERY','OH','45846','9573','CY','39107','1964-03-30','F','M',NULL,'N','021','HLT','3021951','92036OH005001501','2014-03-01','2014-02-14 16:35:14','525.00',NULL,NULL,'964.20','439.20','R-OH002','OH0','375.47',NULL,0,'2014-02-14 21:31:58'),(21159,16908,'Y','18','021','EC','A','','','AC','0000949548','0000949548','OH00002162045','IL','1','SMITH','MARK','EDWARD','','','34','277683832','206 Washington St',0,'WILLARD','OH','44890',NULL,'CY','39077','1960-07-18','M','U',NULL,'T','021','DEN','3080782','99734OH005000401','2014-03-01','2014-02-03 09:11:57','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-03 21:00:31'),(9026,7161,'N','01','021','EC','A',NULL,NULL,'','0000533288','0000483477','','IL','1','Davisson','James','','','','34','292540446','12125 COUNTRY OAKS TRL',0,'CHARDON','OH','44024','9094','CY','39055','1953-07-11','M','',':RET:2106-3','N','021','HLT','1969342','52664OH151001301','2014-01-01','2013-12-18 09:48:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','682.62',NULL,0,'2013-12-26 04:05:27'),(987,807,'Y','18','021','EC','A','','','AC','0000254503','0000254503','OH00000727376','IL','1','Egli','Paul','','','','34','482929244','1001 WINDS DR',0,'PERRYSBURG','OH','43551','6928','CY','39173','1970-12-04','M','U',':RET:2106-3','N','021','HLT','25791','92036OH003002601','2014-01-01','2013-10-31 14:30:22','0.00',NULL,NULL,'276.33','276.33','R-OH001','OH0','276.33',NULL,0,'2013-12-25 18:10:28'),(6047,4789,'N','01','021','EC','A',NULL,NULL,'','0000678060','0000818539','','IL','1','Otchere','Tonette','','','','34','268664864','5601 Opengate Ct',0,'Cincinnati','OH','45247',NULL,'CY','39061','1960-12-17','F','',':RET:2054-5','N','021','DEN','472829','99734OH005000401','2014-01-01','2013-12-01 13:33:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:01:34'),(15867,12705,'Y','18','021','EC','A','','','AC','0001126995','0001126995','MS00002140877','31','1','williams','tiaonia','','','','34','236354766','po box 1125',0,'booneville','MS','38829',NULL,'CY','28117','1989-05-31','F','U',':RET:2054-5','N','021','DEN','1484470','46300MS002000101','2014-02-01','2014-01-02 14:17:44','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-03 02:04:59'),(21476,17160,'N','01','021','EC','A',NULL,NULL,'','0000168920','0000699305','','IL','1','LUONG','CHANH','HUY','','','34','573879778','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1973-08-20','M','',NULL,'N','021','DEN','3006962','99734OH005000301','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:01:40'),(20601,16460,'Y','18','021','EC','A','','','AC','0000477489','0000477489','OH00001808606','IL','1','Fox','Sherri','','','','34','287707038','1021 CORONADO AVE',0,'CINCINNATI','OH','45238','4412','CY','39061','1964-08-19','F','U',NULL,'N','021','DEN','3407824','99734OH005000401','2014-03-01','2014-01-30 13:17:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-30 21:00:13'),(14704,11740,'N','01','021','EC','A',NULL,NULL,'','0000773986','0000552639','','IL','1','Lowry','Suzanne','','','','34','292504946','2339 ROYCE RD',0,'TOLEDO','OH','43615','2621','CY','39095','1950-01-21','F','',':RET:2106-3','N','021','DEN','1897894','99734OH005000301','2014-02-01','2013-12-28 12:11:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:09:09'),(4147,3305,'N','19','021','EC','A',NULL,NULL,'','0000614088','0000752055','','IL','1','Shamy','Austin','J',NULL,NULL,NULL,NULL,'13853 ANGOLA RD',0,'SWANTON','OH','43558','9699','CY','39095','2006-06-26','M','',':RET:2106-3','N','021','DEN','1998433','99734OH005000301','2014-01-01','2013-12-17 12:46:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:40'),(27148,21493,'N','01','021','EC','A',NULL,NULL,'','0000062589','0001187698','','IL','1','BROWN','JAMES','','','','34','496949929','3833 STERLING DR',0,'FRANKLIN','OH','45005','5027','CY','39165','1978-07-08','M','',':RET:2106-3','N','021','DEN','3379760','99734OH005000401','2014-04-01','2014-03-03 13:22:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 21:30:51'),(20750,16580,'Y','18','021','EC','A','','','AC','0000690772','0000690772','OH00002321584','IL','1','Peters','Cody','','','','34','280927517','19080 W PORTAGE RIVER SOUTH RD',0,'ELMORE','OH','43416','9523','CY','39123','1988-07-08','M','U',':RET:2106-3','N','021','HLT','3264133','92036OH004002701','2014-03-01','2014-01-30 10:21:43','0.00',NULL,NULL,'157.42','157.42','R-OH006','OH0','157.42',NULL,0,'2014-01-30 21:01:29'),(19288,15374,'Y','18','021','EC','A','','','AC','0001960948','0001960948','LA00001454226','IL','1','WILLIAMS','COREY','T','','','34','439060833','2647 FRANKFORT ST',0,'NEW ORLEANS','LA','70122','6548','CY','22071','1974-01-16','M','U',':RET:2054-5','N','021','DEN','2184158','18575LA002000201','2014-03-01','2014-01-20 20:00:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-22 03:21:53'),(8153,6450,'Y','18','021','EC','A','','','AC','0000335034','0000335034','TX00000974519','IL','1','Ulibarri','Crystal','','','','34','585493094','7119 ORIZABA AVE',0,'EL PASO','TX','79912','2204','CY','48141','1973-11-09','F','U',':RET:2106-3','N','021','DEN','648620','33348TX002000201','2014-01-01','2013-11-22 13:01:42','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 03:16:05'),(19713,15708,'Y','18','024','14','A','','','TE','0000458250','0000458250','','IL','1','Prado','Sonya',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-08-27','F','',NULL,NULL,NULL,'','2006378','','2014-01-23','2014-01-23 15:55:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 21:00:53'),(25539,20260,'Y','18','021','EC','A','','','AC','0000522004','0000522004','OH00002217897','IL','1','SIMPSON','BRENDA','','','','34','299665528','5623 CHEVIOT RD',0,'CINCINNATI','OH','45247','7033','CY','39061','1960-11-19','F','U',NULL,'N','021','DEN','2969359','99734OH005000301','2014-04-01','2014-02-23 11:31:47','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:00:10'),(23702,18873,'Y','18','021','EC','A','','','AC','0001089595','0001089595','OH00002581686','IL','1','BRIDGEFORD','MARY','','','','34','273666885','203 CENTERBURY CT',0,'SPRINGDALE','OH','45246','4904','CY','39061','1960-05-18','F','U',':RET:2106-3','N','021','DEN','3106363','99734OH005000401','2014-03-01','2014-02-14 08:41:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:42'),(23122,18428,'N','01','021','EC','A',NULL,NULL,'','0000270056','0000745483','','IL','1','CLARKE','DEREK','','','','34','219644876','4205 HEGNER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1965-02-10','M','',':RET:2106-3','N','021','DEN','2856415','99734OH005000401','2014-03-01','2014-02-12 12:21:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:24'),(19762,15754,'Y','18','021','EC','A','','','AC','0001090011','0001090011','MS00001551910','IL','1','perkins','willie','','','','34','408157183','6394 SANDBOURNE W',0,'OLIVE BRANCH','MS','38654','6562','CY','28033','1970-09-15','F','R',':RET:2054-5','N','021','DEN','2486451','46300MS002000101','2014-03-01','2014-01-23 16:01:25','0.00',NULL,NULL,'101.40','101.40','R-MS001','MS0','27.15',NULL,0,'2014-01-23 21:01:24'),(6858,5438,'Y','18','021','EC','A','','','AC','0000076269','0000076269','OH00000649640','IL','1','kimble','lori','','','','34','294640378','10170 STONE QUARRY RD NW',0,'SOMERSET','OH','43783','9610','CY','39127','1958-01-19','F','U',NULL,'T','021','DEN','421475','99734OH005000401','2014-01-01','2013-10-05 09:30:13','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:31:36'),(26308,20872,'Y','18','021','EC','A','','','AC','0000649961','0000649961','TX00003376155','IL','1','Saenz','Rosa','','','','34','458211195','399 Co.Rd.229',0,'Concepcion','TX','78349',NULL,'CY','48131','1961-03-08','F','U',':RET:2106-3','N','021','DEN','3069820','33348TX002000101','2014-04-01','2014-02-27 12:33:08','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-28 06:31:32'),(24620,19541,'Y','18','021','EC','A','','','AC','0000863067','0000863067','MS00002342035','IL','1','TUCKER','TYSHA','','','','34','428494080','402 PEARL DR',0,'PEARL','MS','39208','4521','CY','28121','1968-12-04','F','M',NULL,'N','021','DEN','2727834','46300MS002000201','2014-04-01','2014-02-19 15:23:39','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:15:52'),(17549,14030,'Y','18','021','EC','A','','','AC','0000376162','0000376162','OH00001859800','IL','1','STONE','DONALD','M','','','34','280683701','6488 BLUE CREEK RD',0,'STOUT','OH','45684','9633','CY','39001','1974-07-21','M','U',':RET:2106-3','N','021','HLT','1817069','92036OH003000606','2014-02-01','2014-01-12 13:40:20','224.00',NULL,NULL,'282.91','58.91','R-OH005','OH0','282.91',NULL,0,'2014-01-13 03:01:53'),(6305,5002,'Y','18','021','EC','A','','','AC','0001062093','0001062093','OH00001011362','IL','1','Castle','Burgess','','','','34','279522954','5720 COUNTY ROAD 23',0,'CARDINGTON','OH','43315','9336','CY','39117','1954-11-05','M','M',':RET:2106-3','N','021','DEN','931360','99734OH005000401','2014-01-01','2013-12-11 10:17:36','0.00',NULL,NULL,'31.57','31.57','R-OH008','OH0','0.00',NULL,0,'2013-12-26 00:46:01'),(15325,12257,'Y','18','021','EC','A','','','AC','0000018862','0000018862','TX00001856000','IL','1','Llewellyn','Carla','','','','34','456596248','13009 EMMA LEE AVE',0,'AUSTIN','TX','78727','7026','CY','48453','1980-01-07','F','U',':RET:2106-3','N','021','DEN','1369561','33348TX002000201','2014-02-01','2014-01-01 09:44:20','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,1,'2014-01-02 04:23:43'),(7927,6268,'Y','18','021','EC','A','','','AC','0002084464','0002084464','LA00000146542','IL','1','GURIEVSKY','MARK','','','','34','436788278','4625 N LAUREL CREEK CT',0,'BATON ROUGE','LA','70817','1219','CY','22033','1956-04-03','M','U',':RET:2106-3','N','021','DEN','1994816','18575LA002000201','2014-01-01','2013-12-20 09:19:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:06:29'),(14457,11534,'Y','18','021','EC','A','','','AC','0001310097','0001310097','LA00001605553','IL','1','Bolden','Mark','','','','34','438730700','3234 MALLARD LN',0,'GRETNA','LA','70056','8624','CY','22051','1986-10-31','M','U',':RET:2054-5','N','021','DEN','1622453','18575LA002000201','2014-02-01','2013-12-27 14:59:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:40'),(16874,13501,'Y','18','021','EC','A','','','AC','0001016633','0001016633','TX00001565158','IL','1','peralez','susan','','','','34','451277649','203 EDEN DR',0,'LONGVIEW','TX','75605','3308','CY','48183','1959-09-10','F','U',':RET:2106-3','N','021','DEN','2079086','33348TX002000201','2014-02-01','2014-01-09 18:12:13','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-13 02:19:17'),(24582,19516,'Y','18','021','EC','A','','','AC','0000178939','0000178939','OH00001618582','IL','1','Saladino','Liberato','','','','34','299025254','6391 WILLOW BROOKE DR',0,'LIBERTY TWP','OH','45011','0401','CY','39017','1952-10-28','M','M',':RET:2036-2','N','021','DEN','3061186','99734OH005000301','2014-04-01','2014-02-18 23:42:27','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:08:45'),(2532,2061,'Y','18','021','EC','A','','','AC','0000694167','0000694167','OH00000662774','IL','1','Rickey','James','','','','34','269500172','224 E LYNDHURST ST',0,'SIDNEY','OH','45365','1756','CY','39149','1952-01-04','M','M',':RET:2106-3','T','021','HLT','40506','92036OH005000501','2014-01-01','2013-12-09 08:59:22','0.00',NULL,NULL,'1553.54','1553.54','R-OH003','OH0','768.17',NULL,0,'2013-12-25 19:36:48'),(6200,4913,'Y','18','021','EC','A','','','AC','0000443414','0000443414','OH00001032000','IL','1','Goodhew','Julie','','','','34','276745674','477 S MAIN ST',0,'MONROE','OH','45050','1452','CY','39017','1961-08-22','F','U',NULL,'N','021','DEN','168205','99734OH005000401','2014-01-01','2013-10-15 22:57:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:30:35'),(838,693,'Y','18','024','14','A','','','TE','0000422785','0000422785','','IL','1','Pozo','Angelica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-17','F','',NULL,NULL,NULL,'','1175274','','2013-12-15','2013-12-15 21:08:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:06:32'),(13849,11053,'Y','18','021','EC','A','','','AC','0000536920','0000536920','OH00000365842','IL','1','Cavin','Michael','','','','34','302762990','3714 Drexel Dr',0,'Toledo','OH','43612',NULL,'CY','39095','1981-03-24','M','M',NULL,'N','021','HLT','1393906','92036OH002002601','2014-01-01','2013-12-23 15:11:50','312.00',NULL,NULL,'807.99','495.99','R-OH001','OH0','266.40',NULL,0,'2013-12-26 13:12:33'),(5241,4156,'Y','18','021','EC','A','','','AC','0000144206','0000144206','OH00001303991','IL','1','Adams','Sarah','','','','34','296440348','2613 DOUG AVE',0,'HUDSON','OH','44236','3206','CY','39153','1953-10-12','F','R',':RET:2106-3','N','021','HLT','1878834','52664OH151001301','2014-01-01','2013-12-18 20:32:24','0.00',NULL,NULL,'605.24','605.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 23:04:55'),(22881,18247,'N','19','021','EC','A',NULL,NULL,'','0001004383','0000057373','','IL','1','Dao','Nghia','','','','34','297066686','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','2002-04-17','M','',NULL,'N','021','HLT','3544978','52664OH151001501','2014-03-01','2014-02-11 11:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-02-11 21:02:34'),(21798,17409,'N','19','021','EC','A',NULL,NULL,'','0000433936','0000728752','','IL','1','Smith','Presley','Alana','','','34','277061622','2006 KENSINGTON DR',0,'SAINT MARYS','OH','45885','1388','CY','39011','2001-02-24','F','',':RET:2106-3','N','021','HLT','3599490','92036OH004001501','2014-03-01','2014-02-06 06:16:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-02-06 21:00:48'),(18197,14527,'Y','18','021','EC','A','','','AC','0000451295','0000451295','OH00002269807','IL','1','Montoney','Marcus','','','','34','314708026','901 SYCAMORE BLVD',0,'CINCINNATI','OH','45245','1321','CY','39025','1969-01-24','M','R',':RET:2106-3','N','021','HLT','1414599','92036OH006000601','2014-02-01','2014-01-14 12:07:02','0.00',NULL,NULL,'462.06','462.06','R-OH005','OH0','245.84',NULL,0,'2014-01-15 02:08:05'),(1003,822,'Y','18','021','EC','A','','','AC','0000323777','0000323777','MS00000329986','IL','1','Morey','Jacquelin','','','','34','252864383','534 Live Oak Drive',0,'Madison','MS','39110',NULL,'CY','28089','1951-03-10','F','U',':RET:2106-3','N','021','DEN','597481','46300MS002000101','2014-01-01','2013-11-11 00:45:52','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 18:11:00'),(6672,5292,'Y','18','021','EC','A','','','AC','0000710101','0000710101','OH00000411102','IL','1','Napier','Marco','','','','34','290704939','2686 Hillvista LN 6',0,'Cincinnati','OH','45239',NULL,'CY','39061','1974-12-29','M','U',':RET:2054-5','N','021','DEN','1123751','99734OH005000301','2014-01-01','2013-11-16 09:07:35','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:01:08'),(6015,4761,'Y','18','021','EC','A','','','AC','0000261460','0000261460','OH00000448256','IL','1','Perkoski','Robert','','','','34','278547960','22735 CREEK BEND CT',0,'STRONGSVILLE','OH','44149','2013','CY','39035','1956-12-28','M','M',':RET:2106-3','N','021','DEN','730649','99734OH005000301','2014-01-01','2013-12-01 14:55:48','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:00:41'),(20799,16619,'Y','18','021','EC','A','','','AC','0000852164','0000852164','TX00002187485','IL','1','RODRIGUEZ','RAUL','','','','34','458298749','1215 S.Almond',0,'Alice','TX','78332',NULL,'CY','48249','1959-09-16','M','U',':RET:2106-3','N','021','DEN','3178030','33348TX002000201','2014-03-01','2014-01-31 12:34:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-31 21:00:20'),(22265,17771,'Y','18','021','EC','A','','','AC','0000368377','0000368377','TX00001866634','IL','1','Garcia','Jennifer','Amanda','','','34','633079289','104 LITTLE JOHN CT',0,'EL PASO','TX','79924','5412','CY','48141','1980-08-28','F','U',NULL,'N','021','DEN','1662869','33348TX002000201','2014-03-01','2014-01-27 00:00:22','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-10 11:00:10'),(22233,17746,'Y','18','021','EC','A','','','AC','0000838676','0000838676','TX00002580119','IL','1','Boone','Ashley','','','','34','465791270','4402 THREE RIVERS DR',0,'SUGAR LAND','TX','77478','5329','CY','48157','1985-10-07','F','U',':RET:2106-3','N','021','DEN','2694671','33348TX002000101','2014-03-01','2014-02-09 13:58:47','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-09 19:00:33'),(5952,4713,'Y','18','021','EC','A','','','AC','0000677085','0000677085','MS00000879892','IL','1','Morris','Rosalyn','','','','34','426517739','875 William Blvd.',0,'Ridgeland','MS','39157',NULL,'CY','28089','1984-05-22','F','U',':RET:2054-5','N','021','DEN','1802190','46300MS002000201','2014-01-01','2013-12-23 21:51:41','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:51:06'),(28639,22665,'Y','18','021','EC','A','','','AC','0001219488','0001219488','TX00003518056','IL','1','GARCIA','MARIA','ELENA','','','34','629640945','240 SANTOS GOMEZ DR',0,'SAN BENITO','TX','78586','8048','CY','48061','1964-04-23','F','M',NULL,'N','021','DEN','3873156','33348TX002000201','2014-04-01','2014-03-08 15:21:59','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-03-08 21:30:31'),(28067,22211,'Y','18','021','EC','A','','','AC','0000551483','0000551483','OH00003298083','IL','1','Domer','Mary','C','','','34','297443464','1060 Shadybrook Drive',0,'Akron','OH','44312',NULL,'CY','39153','1951-06-16','F','U',NULL,'T','021','DEN','3892003','99734OH005000301','2014-04-01','2014-03-06 12:14:21','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-06 21:01:48'),(26814,21249,'Y','18','021','EC','A','','','AC','0001173275','0001173275','OH00002299656','IL','1','POLING','THOMAS','','','','34','288541626','732 S OHIO AVE',0,'SIDNEY','OH','45365','3214','CY','39149','1953-03-14','M','U',':RET:2106-3','N','021','DEN','3068746','99734OH005000401','2014-03-01','2014-02-28 18:52:22','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-01 21:00:30'),(4464,3546,'N','01','021','EC','A',NULL,NULL,'','0001201870','0000535739','','IL','1','Koosed','Paige','','','','34','296446184','24259 W RIVER RD',0,'PERRYSBURG','OH','43551','9476','CY','39173','1951-06-10','F','',':RET:2106-3','N','021','DEN','528827','99734OH005000301','2014-01-01','2013-12-12 13:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:41'),(19508,15548,'N','01','021','EC','A',NULL,NULL,'','0000257712','0000423869','','IL','1','CRUZ','LUIS','ALBERTO','','','34','899350987','5109 WYNDHAM CT',0,'GARLAND','TX','75043','7678','CY','48113','1973-04-08','M','',NULL,'N','021','DEN','2681648','33348TX002000101','2014-03-01','2014-01-22 13:17:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-23 03:02:13'),(25269,20048,'Y','18','024','14','A','','','TE','0001941234','0001941234','','IL','1','Korman','Alexis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-11-20','F','',NULL,NULL,NULL,'','1410599','','2014-03-31','2014-02-24 19:14:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-25 21:00:11'),(24437,19410,'Y','18','021','EC','A','','','AC','0001160461','0001160461','OH00002098809','IL','1','KURR','BRIAN','EDWARD','','','34','247754618','2935 SAYBROOKE BLVD',0,'STOW','OH','44224','2827','CY','39153','1988-02-29','M','U',':RET:2106-3','N','021','HLT','3539291','52664OH151001306','2014-04-01','2014-02-18 15:49:10','182.00',NULL,NULL,'228.36','46.36','R-OH012','OH0','228.36',NULL,0,'2014-02-18 22:01:16'),(51,46,'Y','18','021','EC','A','','','AC','0000671679','0000671679','OH00000581781','IL','1','Love','Charlotte','Denise','','','34','283669208','7146 BROOKE BLVD',0,'REYNOLDSBURG','OH','43068',NULL,'CY','39049','1959-01-17','F','U',':RET:1002-5','N','021','DEN','1018475','99734OH005000301','2014-01-01','2013-12-04 18:23:02','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:16:23'),(16702,13367,'Y','18','021','EC','A','','','AC','0000710841','0000710841','TX00002383244','IL','1','TASBY','JAMAAL','','','','34','449513875','5707 GASTON AVE',0,'DALLAS','TX','75214','6439','CY','48113','1980-06-17','M','U',':RET:2054-5','N','021','DEN','1451011','33348TX002000201','2014-02-01','2014-01-07 16:53:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-08 18:24:39'),(724,599,'Y','18','021','EC','A','','','AC','0000577595','0000577595','TX00000653006','IL','1','Anderson','Candace','','','','34','458633094','1005 LEONA ST',0,'MARSHALL','TX','75670','6137','CY','48203','1972-12-20','F','U',':RET:2054-5','N','021','DEN','2599830','33348TX002000101','2014-01-01','2013-12-16 12:59:00','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:03:34'),(22650,18085,'Y','18','021','EC','A','','','AC','0001030453','0001030453','TX00002510049','IL','1','Nowland','Anne','','','','34','456451780','133 HUGHS ST',0,'BOERNE','TX','78006','2949','CY','48259','1962-08-06','F','U',':RET:2106-3','N','021','DEN','2748112','33348TX002000201','2014-03-01','2014-02-11 11:12:36','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-11 21:00:27'),(20181,16105,'Y','18','021','EC','A','','','AC','0001010243','0001010243','OH00001603963','IL','1','DEMROVSKY','MARY','','','','34','276648162','360 THORN WAY',0,'DOYLESTOWN','OH','44230','1708','CY','39169','1954-04-05','F','U',':RET:2106-3','N','021','HLT','1957689','52664OH151001305','2014-03-01','2014-01-27 16:03:42','472.00',NULL,NULL,'580.49','108.49','R-OH014','OH0','580.49',NULL,0,'2014-01-27 21:01:20'),(7803,6180,'N','01','021','EC','A',NULL,NULL,'','0000892412','0000077184','','IL','1','mccreight','john','michael','','','34','467494494','10602 YORK AVE',0,'LUBBOCK','TX','79424','7413','CY','48303','1965-02-17','M','',':RET:2106-3','N','021','DEN','1679665','33348TX002000201','2014-01-01','2013-12-20 16:27:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:03:44'),(2256,1849,'Y','18','021','EC','A','','','AC','0001199470','0001199470','OH00000168790','IL','1','Sanders','Kimberly','','','','34','294561026','24832 ROCKLEDGE LN',0,'RICHMOND HEIGHTS','OH','44143','1741','CY','39035','1960-05-02','F','U',NULL,'N','021','DEN','278101','99734OH005000301','2014-01-01','2013-12-09 00:02:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:30:10'),(4312,3428,'Y','18','021','EC','A','','','AC','0001026926','0001026926','OH00000065011','IL','1','RINELLA','MICHAEL','ANTHONY','','','34','270965790','9902 S DELMONTE BLVD',0,'STREETSBORO','OH','44241','4816','CY','39133','1992-11-12','M','U',':RET:2106-3','T','021','HLT','1774825','52664OH152001001','2014-01-01','2013-12-17 14:31:58','0.00',NULL,NULL,'141.00','141.00','R-OH012','OH0','141.00',NULL,0,'2013-12-25 21:52:35'),(9395,7451,'Y','18','021','EC','A','','','AC','0001100269','0001100269','TX00000493437','IL','1','Marmokjo','Maria','E','','','34','458089258','808 W CHAPARRAL ST',0,'SAN JUAN','TX','78589','2210','CY','48215','1957-10-09','F','U',NULL,'N','021','DEN','1775050','33348TX002000201','2014-01-01','2013-12-20 22:27:15','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 04:32:26'),(14123,11256,'Y','18','021','EC','A','','','AC','0000015272','0000015272','OH00001313873','IL','1','HYTHON','DAUREATHA','','','','34','287668867','101 PIERCE AVE',0,'CUYAHOGA FALLS','OH','44221','2138','CY','39153','1970-06-28','F','U',':RET:2106-3','N','021','DEN','2043480','99734OH005000401','2014-02-01','2013-12-26 16:58:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:02:09'),(17212,13773,'N','01','021','EC','A',NULL,NULL,'','0000443471','0000153386','','IL','1','GRAVES','JACK','E','','Jr','34','279507331','1206 HARPSTER AVE',0,'AKRON','OH','44314','2246','CY','39153','1951-03-09','M','',NULL,'N','021','HLT','2062442','52664OH151001304','2014-02-01','2014-01-08 14:52:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2014-01-13 02:22:29'),(6019,4764,'Y','18','021','EC','A','','','AC','0000333821','0000333821','OH00001213931','IL','1','Kelly','Christine','','','','34','144526056','7405 AMBER LN',0,'BRECKSVILLE','OH','44141','1903','CY','39035','1967-06-19','F','R',':RET:2106-3','N','021','DEN','331619','99734OH005000301','2014-01-01','2013-12-01 12:12:45','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:00:48'),(5785,4596,'Y','18','021','EC','A','','','AC','0001173225','0001173225','OH00000649314','IL','1','Addison','Starlette','','','','34','288863232','2506 MAPLEHURST DR',0,'STOW','OH','44224','2757','CY','39153','1987-09-02','F','U',':RET:2054-5','N','021','DEN','2303235','99734OH005000401','2014-01-01','2013-12-23 23:47:35','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:47:09'),(14076,11218,'Y','18','021','EC','A','','','AC','0000166385','0000166385','OH00000697927','IL','1','Pope','Dionne','','','','34','268764214','1214 LINDEN AVE',0,'AKRON','OH','44310','1263','CY','39153','1970-12-02','F','M',':RET:2054-5','N','021','DEN','2148666','99734OH005000401','2014-02-01','2013-12-26 10:09:15','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2013-12-27 02:01:00'),(18399,14680,'N','01','021','EC','A',NULL,NULL,'','0000505755','0000507000','','IL','1','Smith','Danny','E','','','34','293606380','11817 Crofton Road',0,'Garfield Heights','OH','44125',NULL,'CY','39035','1973-11-29','M','',':RET:2106-3','N','021','DEN','2210292','99734OH005000301','2014-02-01','2014-01-15 17:10:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:42'),(20460,16344,'Y','18','021','EC','A','','','AC','0001236613','0001236613','OH00001834552','IL','1','FUQUA','NIKOLE','MARIE','','','34','298906623','11178 VALLEY VIEW RD',0,'SAGAMORE HILLS','OH','44067','1849','CY','39153','1984-04-03','F','U',':RET:2054-5','N','021','DEN','1458826','99734OH005000401','2014-03-01','2014-01-29 10:01:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-29 21:00:51'),(15181,12131,'N','01','021','EC','A',NULL,NULL,'','0000785801','0000846152','','IL','1','Hinds','Jeffrey','L','','','34','293420667','1573 SKINNER LN SE',0,'NEW PHILADELPHIA','OH','44663','3274','CY','39157','1957-05-05','M','',':RET:2106-3','N','021','DEN','2241936','99734OH005000401','2014-02-01','2013-12-30 17:55:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:06:49'),(20486,16366,'Y','18','021','EC','A','','','AC','0000692954','0000692954','OH00002383727','IL','1','BANIC','ANTHONY','','','','34','276762540','17713 EDWARDS RD',0,'DOYLESTOWN','OH','44230','9302','CY','39169','1978-08-21','M','U',':RET:2106-3','N','021','HLT','2932100','52664OH151001305','2014-03-01','2014-01-29 15:52:06','200.00',NULL,NULL,'414.13','214.13','R-OH014','OH0','272.52',NULL,0,'2014-01-29 21:01:04'),(19594,15620,'Y','18','021','EC','A','','','AC','0000327295','0000327295','OH00002431372','IL','1','Washington','Alonzo','','','','34','287682085','1745 W 25TH ST',0,'CLEVELAND','OH','44113','3157','CY','39035','1965-09-04','M','U',':RET:2054-5','N','021','HLT','3154738','52664OH151001501','2014-03-01','2014-01-21 22:24:02','176.00',NULL,NULL,'493.22','317.22','R-OH011','OH0','493.22',NULL,0,'2014-01-23 03:02:45'),(3299,2657,'N','19','021','EC','A',NULL,NULL,'','0000524487','0001068262','','S1','1','Murphy','Patrick','Charles',NULL,NULL,NULL,NULL,'255 GUILFORD BLVD',0,'MEDINA','OH','44256','2134','CY','39103','1998-08-19','M','',':RET:2106-3','N','021','DEN','1471448','99734OH005000301','2014-01-01','2013-12-22 12:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:40'),(2371,1933,'Y','18','021','EC','A','','','AC','0000218804','0000218804','OH00001130824','IL','1','Robinson','Darryl','','','','34','299502403','5064 JOHN THOMAS RD',0,'RAVENNA','OH','44266','9275','CY','39133','1951-04-02','M','U',':RET:2106-3','N','021','DEN','1042293','99734OH005000401','2014-01-01','2013-12-09 09:09:41','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:32:43'),(3004,2414,'N','01','021','EC','A',NULL,NULL,'','0000789642','0000906588','','IL','1','Deger','Jacqueline','Margaret','','','34','287581081','1436 WATERS EDGE DR',0,'AKRON','OH','44313','8635','CY','39153','1955-11-02','F','',':RET:2106-3','N','021','DEN','2626','99734OH005000301','2014-01-01','2013-12-06 13:42:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:44'),(5690,4515,'Y','18','021','EC','A','','','AC','0000451241','0000451241','OH00000248020','IL','1','Brausch','Mary','','','','34','271560122','6696 COACHLIGHT WAY',0,'WEST CHESTER','OH','45069','2047','CY','39017','1954-02-14','F','M',':RET:2106-3','N','021','DEN','318691','99734OH005000301','2014-01-01','2013-11-26 15:32:14','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:32:35'),(4475,3552,'N','17','021','EC','A',NULL,NULL,'','0000129245','0001250817','','IL','1','Smith','Courtney',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1993-07-24','F','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:52'),(20980,16766,'Y','18','021','EC','A','','','AC','0001922564','0001922564','LA00001429246','IL','1','NATHAN','GEORGE','','','','34','434594277','4069 N DELLS ST',0,'HARVEY','LA','70058','2105','CY','22051','1963-11-08','M','M',':RET:2054-5','N','021','DEN','2686888','18575LA002000201','2014-03-01','2014-01-31 23:30:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-01 19:00:20'),(22753,18165,'Y','18','021','EC','A','','','AC','0001523163','0001523163','LA00001547748','IL','1','Wang','Amy','','','','34','435573751','4904 SENAC DR',0,'METAIRIE','LA','70003','2742','CY','22051','1956-04-11','F','M',':RET:2028-9','N','021','DEN','3575183','18575LA002000101','2014-03-01','2014-02-11 15:24:01','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-11 21:01:27'),(24359,19348,'Y','18','024','14','A','','','TE','0001194926','0001194926','','IL','1','LEE','SETHDRIC',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-01-02','F','',NULL,NULL,NULL,'','3537821','','2014-02-18','2014-02-18 10:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-18 22:00:32'),(125,108,'N','01','021','EC','A',NULL,NULL,'','0000556685','0000421440','','IL','1','Lauer','Larry','','','','34','400804367','564 COMMON WEALTH DR',0,'CINCINNATI','OH','45244','1031','CY','39025','1953-01-13','M','',NULL,'N','021','HLT','683093','92036OH002000601','2014-01-01','2013-12-05 17:35:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','672.81',NULL,0,'2013-12-25 17:18:17'),(18881,15043,'Y','18','021','EC','A','','','AC','0001912112','0001912112','LA00001604804','31','1','Strong','Ethel','','','','34','436024611','PO box 724',0,'St Joseph','LA','71366',NULL,'CY','22107','1957-02-27','F','U',NULL,'T','021','DEN','2987266','18575LA002000201','2014-03-01','2014-01-16 17:48:41','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-17 03:36:28'),(1053,864,'Y','18','021','EC','A','','','AC','0000247917','0000247917','TX00000400438','IL','1','Watson','William','','','','34','213548401','6135 LA COSA DR',0,'DALLAS','TX','75248','4924','CY','48113','1951-06-24','M','M',':RET:2106-3','N','021','DEN','365095','33348TX002000201','2014-01-01','2013-12-03 12:46:01','0.00',NULL,NULL,'47.55','47.55','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:16:06'),(8959,7107,'Y','18','021','EC','A','','','AC','0000489240','0000489240','OH00001109974','IL','1','Wallen','Mark','','','','34','297548777','4396 ROCKLAND DR',0,'CLEVELAND','OH','44144','2834','CY','39035','1954-05-08','M','U',NULL,'N','021','DEN','2509976','99734OH005000401','2014-01-01','2013-12-18 12:44:46','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:03:49'),(15132,12092,'Y','18','024','14','A','','','TE','0000612975','0000612975','','IL','1','Chen','Cindy Xin Fang',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-10-11','F','',NULL,NULL,NULL,'','913769','','2013-12-29','2013-12-29 19:51:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:05:28'),(3130,2515,'Y','18','021','EC','A','','','AC','0000280794','0000280794','OH00001072915','IL','1','Maurer','Elizabeth','','','','34','291885461','6265 Amberley Ct',0,'Liberty Twp','OH','45044',NULL,'CY','39017','1983-08-06','F','U',NULL,'N','021','DEN','518139','99734OH005000401','2014-01-01','2013-10-12 22:17:48','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:30:29'),(6516,5166,'Y','18','021','EC','A','','','AC','0001191309','0001191309','OH00000516303','IL','1','Rexford','Leah','','','','34','302783444','1636 LAKEWOOD AVE',0,'LIMA','OH','45805','3350','CY','39003','1977-03-05','F','M',':RET:2106-3','N','021','HLT','19881','92036OH003001505','2014-01-01','2013-12-11 10:13:07','444.00',NULL,NULL,'614.59','170.59','R-OH002','OH0','282.70',NULL,0,'2013-12-26 00:51:16'),(4412,3505,'Y','18','021','EC','A','','','AC','0001152173','0001152173','OH00001148347','IL','1','THOMAS','FREDDY','JAMES III','','','34','291806032','942 HOLLYTREE DR',0,'CINCINNATI','OH','45231','4748','CY','39061','1969-02-01','M','U',':RET:2054-5','T','021','DEN','771827','99734OH005000401','2014-01-01','2013-12-12 14:48:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:23'),(23843,18971,'Y','18','021','EC','A','','','AC','0000833459','0000833459','OH00002598847','IL','1','boseman','amy',NULL,NULL,NULL,NULL,NULL,'412 West Township Road 118',0,'Tiffin','OH','44883',NULL,'CY','39147','1969-09-24','F','U',NULL,'T','021','HLT','2731980','92036OH003002706','2014-03-01','2014-02-14 09:03:10','257.00',NULL,NULL,'327.15','70.15','R-OH006','OH0','327.15',NULL,0,'2014-02-14 21:31:53'),(25748,20421,'Y','18','021','EC','A','','','AC','0000398669','0000398669','OH00002123870','IL','1','BERAUN','CASH','','','','34','520980798','163 E ARCADIA AVE',0,'COLUMBUS','OH','43202','2637','CY','39049','1979-06-27','M','U',NULL,'N','021','DEN','2921210','99734OH005000401','2014-04-01','2014-02-24 15:27:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 09:30:43'),(27612,21838,'Y','18','021','EC','A','','','AC','0000008568','0000008568','LA00003161406','IL','1','rives','Laureen','','','','34','436319367','12538 N OAK HILLS PKWY',0,'BATON ROUGE','LA','70810','3239','CY','22033','1964-04-08','F','M',':RET:2106-3','N','021','DEN','3113654','18575LA002000201','2014-04-01','2014-03-05 17:39:29','0.00',NULL,NULL,'52.83','52.83','R-LA005','LA0','14.61','CIC',0,'2014-03-05 21:00:29'),(28765,22769,'Y','18','021','EC','A','','','AC','0000909109','0000909109','TX00003691733','IL','1','Moore','Allan','Ray','','','34','457829859','21700 Timber Creek Dr',0,'Chandler','TX','75758',NULL,'CY','48213','1955-02-18','M','R',':RET:2106-3','N','021','DEN','3552146','33348TX002000201','2014-04-01','2014-03-09 15:22:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-09 21:00:25'),(13188,10521,'Y','18','021','EC','A','','','AC','0000680976','0000680976','TX00000465925','IL','1','elder','rick','','','','34','466857110','627 DOGWOOD ST',0,'LAKE JACKSON','TX','77566','4339','CY','48039','1973-12-24','M','M',':RET:2106-3','N','021','DEN','2420482','33348TX002000101','2014-01-01','2013-12-23 00:56:40','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:32'),(9637,7635,'Y','18','021','EC','A','','','AC','0000161409','0000161409','TX00000358617','IL','1','Willman','Charles','','','','34','326484567','NE 44 Lake Cherokee',0,'Longview','TX','75603',NULL,'CY','48183','1957-03-02','M','M',':RET:2106-3','N','021','DEN','1989660','33348TX002000101','2014-01-01','2013-12-21 09:44:57','0.00',NULL,NULL,'25.02','25.02','R-TX013','TX0','25.02',NULL,0,'2013-12-26 04:38:22'),(3329,2671,'Y','18','021','EC','A','','','AC','0001016846','0001016846','OH00000630768','IL','1','Bartley','Elizabeth','','','','34','285765863','2316 KEMPER LN',0,'CINCINNATI','OH','45206','2611','CY','39061','1964-09-17','F','U',':RET:2106-3','N','021','DEN','2525767','99734OH005000301','2014-01-01','2013-12-22 17:25:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:16:14'),(17659,14113,'N','01','021','EC','A',NULL,NULL,'','0000163704','0000720265','','IL','1','Fisher','Heidi','','','','34','297649452','4444 STATE ROUTE 763',0,'RIPLEY','OH','45167','8201','CY','39015','1973-02-01','F','',':RET:2106-3','N','021','DEN','2645671','99734OH005000301','2014-02-01','2014-01-13 14:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:44'),(17615,14081,'N','01','021','EC','A',NULL,NULL,'','0001019904','0000265435','','IL','1','Spotswood','Robert','Scott','','','34','214729368','9497 PAGEWOOD LN',0,'HOUSTON','TX','77063','5355','CY','48201','1968-12-24','M','',':RET:2106-3','N','021','DEN','1912276','33348TX002000201','2014-02-01','2014-01-13 11:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-14 01:32:24'),(17337,13868,'Y','18','021','EC','A','','','AC','0002236616','0002236616','LA00001384860','IL','1','briggs','melvin','','','','34','435130458','126 Huntlee Dr.',0,'New olreans','LA','70131',NULL,'CY','22071','1959-02-01','M','U',':RET:2054-5','N','021','DEN','2555976','18575LA002000201','2014-02-01','2014-01-10 15:03:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:24:00'),(16522,13217,'N','01','021','EC','A',NULL,NULL,'','0001087350','0000443473','','IL','1','Tracy','Holly','Cherie','','','34','644164665','5006 35TH ST',0,'LUBBOCK','TX','79414','2505','CY','48303','1984-12-12','F','',':RET:2106-3','N','021','DEN','2312270','33348TX002000201','2014-02-01','2014-01-05 15:46:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-07 10:21:46'),(16030,12833,'Y','18','021','EC','A','','','AC','0001809818','0001809818','LA00000418955','IL','1','Ingram','Stewart','','','','34','436736323','4305 HIGHWAY 133',0,'RAYVILLE','LA','71269','7547','CY','22083','1981-01-23','M','U',':RET:2106-3','N','021','DEN','1979558','18575LA002000201','2014-02-01','2014-01-03 12:06:19','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-04 02:02:27'),(7217,5720,'N','01','021','EC','A',NULL,NULL,'','0000690707','0001077700','','IL','1','Sarisky','Jacqueline','','','','34','285520777','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1953-01-05','F','',':RET:1002-5^:RET:2106-3','T','021','DEN','5673','99734OH005000401','2014-01-01','2013-12-14 12:07:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:01:03'),(6151,4877,'Y','18','021','EC','A','','','AC','0000608572','0000608572','TX00000087226','IL','1','kuliska','william','marcus','','','34','423273165','821 AURORA ST',0,'HOUSTON','TX','77009','1053','CY','48201','1971-03-11','M','M',NULL,'N','021','DEN','1117264','33348TX002000101','2014-01-01','2013-11-21 11:08:39','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-26 00:16:31'),(14247,11362,'Y','18','024','14','A','','','TE','0000982526','0000982526','','IL','1','Triska','Richard','L','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-14','M','',NULL,NULL,NULL,'','2265092','','2013-12-26','2013-12-26 12:25:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:05:25'),(5728,4547,'Y','18','021','EC','A','','','AC','0002270825','0002270825','LA00001229925','IL','1','pham','james','','','','34','435856522','12849 MURLIN AVE',0,'BATON ROUGE','LA','70817','1249','CY','22033','1973-06-23','M','M',':RET:2047-9','N','021','DEN','2586397','18575LA002000201','2014-01-01','2013-12-23 22:44:37','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:36'),(4287,3411,'N','19','021','EC','A',NULL,NULL,'','0000504460','0000929827','','S1','1','Wood','Krystle','L','','','34','856312601','508 W BREMEN ST',0,'NEW KNOXVILLE','OH','45871','9746','CY','39011','2013-09-22','M','',':RET:2106-3','N','021','HLT','2540742','92036OH005001504','2014-01-01','2013-12-17 13:41:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-25 21:52:06'),(25486,20219,'Y','18','021','EC','A','','','AC','0000555841','0000555841','MS00002549562','IL','1','Johnson','joscelyn','','','','34','251897167','156 PARK CIR',0,'JACKSON','MS','39212','3833','CY','28049','1992-08-31','F','U',':RET:2054-5','N','021','DEN','3137262','46300MS002000201','2014-04-01','2014-02-24 20:20:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-25 21:31:45'),(13584,10834,'Y','18','021','EC','A','','','AC','0002201191','0002201191','LA00000283057','IL','1','Lemus','Osmin','','','','34','437891204','212 GEORGETOWN DR',0,'KENNER','LA','70065','4050','CY','22051','1949-12-28','M','M',NULL,'N','021','DEN','2138689','18575LA002000201','2014-01-01','2013-12-23 18:22:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:58'),(1079,885,'Y','18','021','EC','A','','','AC','0001174374','0001174374','OH00000965713','IL','1','LONGBOTTOM','BARBARA','','','','34','272524510','118 E WOODLAND AVE',0,'COLUMBIANA','OH','44408','1519','CY','39029','1953-01-31','F','M',':RET:2106-3','N','021','DEN','143086','99734OH005000401','2014-01-01','2013-12-03 09:30:26','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:16:43'),(14340,11440,'Y','18','021','EC','A','','','AC','0000751023','0000751023','OH00000611058','IL','1','Moore','Abbey','','','','34','302843813','408 N WALNUT ST',0,'VAN WERT','OH','45891','1229','CY','39161','1980-11-09','F','M',':RET:2106-3','N','021','HLT','2500992','92036OH003001504','2014-02-01','2013-12-26 16:59:09','397.00',NULL,NULL,'613.12','216.12','R-OH002','OH0','275.33',NULL,0,'2013-12-27 02:07:52'),(8827,6999,'Y','18','021','EC','A','','','AC','0000047108','0000047108','TX00001117582','31','1','DE SANTIAGO','JOSE','','','','34','635807448','4106 CHAPELLE AVE',0,'PICO RIVERA','CA','90660',NULL,'CY','48141','1973-03-24','M','M',NULL,'N','021','DEN','2591080','33348TX002000201','2014-01-01','2013-12-17 20:06:19','0.00',NULL,NULL,'30.83','30.83','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:00:26'),(3060,2458,'Y','18','021','EC','A','','','AC','0000706956','0000706956','LA00000505507','IL','1','Chifici','Sarah','Magdaline','','','34','433635094','4417 Lefkoe St.',0,'Metairie','LA','70006',NULL,'CY','22051','1986-06-27','F','R',':RET:2106-3','N','021','DEN','278062','18575LA002000201','2014-01-01','2013-12-06 15:20:56','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:19:08'),(20972,16758,'Y','18','021','EC','A','','','AC','0000087547','0000087547','TX00001634556','IL','1','frausto','alexis','','','','34','625624287','6306 QUAKER AVE',0,'LUBBOCK','TX','79413','5140','CY','48303','1990-08-30','F','U',':RET:1002-5','N','021','DEN','3153677','33348TX002000201','2014-03-01','2014-02-01 16:40:16','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-01 19:00:15'),(21047,16816,'Y','18','021','EC','A','','','AC','0001218274','0001218274','TX00002311995','IL','1','ledesma','dolores','','','','34','455821656','7939 MERAZ AVE',0,'EL PASO','TX','79907','1254','CY','48141','1950-08-13','F','U',NULL,'N','021','DEN','2786412','33348TX002000201','2014-03-01','2014-02-01 21:03:22','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-02 19:00:04'),(22844,18227,'Y','18','021','EC','A','','','AC','0000703822','0000703822','OH00002420806','IL','1','Dahlin','Amanda','','','','34','095707783','1732 Juniper Dr',0,'Bowling Green','OH','43402',NULL,'CY','39173','1983-11-22','F','M',NULL,'N','021','HLT','3239761','92036OH005002606','2014-03-01','2014-02-10 21:20:08','137.00',NULL,NULL,'221.32','84.32','R-OH001','OH0','221.32',NULL,0,'2014-02-11 21:02:16'),(23450,18680,'Y','18','021','EC','A','','','AC','0000277933','0000277933','TX00002398111','IL','1','Lara','Elizabeth','','','','34','607345576','150 GREYFRIAR DR',0,'HOUSTON','TX','77037','2908','CY','48201','1988-10-08','F','M',NULL,'N','021','DEN','3215634','33348TX002000201','2014-03-01','2014-02-13 13:11:41','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-13 22:01:37'),(23635,18820,'Y','18','021','EC','A','','','AC','0001016770','0001016770','TX00002820490','IL','1','James','Kathie','Sue','','','34','458986745','222 COUNTY ROAD 4220',0,'JACKSONVILLE','TX','75766','7394','CY','48073','1956-02-03','F','U',NULL,'N','021','DEN','3372854','33348TX002000201','2014-03-01','2014-02-13 19:06:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:05'),(25424,20173,'Y','18','021','EC','A','','','AC','0000380114','0000380114','OH00002908141','IL','1','DELLINGER','ARIEL','','','','34','629343958','5343 BIG CREEK PKWY',0,'PARMA','OH','44129','1044','CY','39035','1992-11-19','F','U',NULL,'N','021','DEN','2981626','99734OH005000401','2014-04-01','2014-02-25 17:01:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-25 21:31:10'),(26953,21357,'Y','18','021','EC','A','','','AC','0000498232','0000498232','OH00003440468','IL','1','Schweitzer','Teresa','','','','34','272606391','P. O. Box 245',0,'Defiance','OH','43512',NULL,'CY','39039','1963-12-21','F','U',':RET:2106-3','N','021','HLT','3406120','92036OH006002601','2014-04-01','2014-03-02 08:22:30','0.00',NULL,NULL,'276.19','276.19','R-OH001','OH0','276.19',NULL,0,'2014-03-03 01:00:27'),(28676,22692,'Y','18','021','EC','A','','','AC','0000701765','0000701765','OH00003636271','IL','1','CAVEY','LORI','','','','34','570198023','5516  308th STREET',0,'TOLEDO','OH','43611',NULL,'CY','39095','1967-05-12','F','U',NULL,'T','021','HLT','4067461','92036OH004002601','2014-04-01','2014-03-07 19:31:35','169.00',NULL,NULL,'270.46','101.46','R-OH001','OH0','270.46',NULL,0,'2014-03-08 21:30:52'),(13794,11011,'Y','18','021','EC','A','','','AC','0000151661','0000151661','MS00001247125','IL','1','JAMES','ROSEMARIE','DAHL','','','34','425236022','301 COUNTY ROAD 106',0,'SCHLATER','MS','38952',NULL,'CY','28083','1971-11-16','F','M',':RET:2054-5','N','021','DEN','2284426','46300MS002000101','2014-01-01','2013-12-23 10:18:31','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 13:11:11'),(19803,15788,'Y','18','024','14','A','','','TE','0000325496','0000325496','','IL','1','BORJAS','STEPHANIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-06-10','F','',NULL,NULL,NULL,'','3311036','','2014-01-24','2014-01-24 15:29:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-24 21:00:05'),(2500,2036,'N','01','021','EC','A',NULL,NULL,'','0000161576','0000208237','','IL','1','Pevey','Donna','','','','34','433944964','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1953-09-12','F','',':RET:2106-3','N','021','DEN','987327','18575LA002000201','2014-01-01','2013-12-09 17:45:08',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:36:01'),(9657,7651,'N','19','021','EC','A',NULL,NULL,'','0000790870','0000160788','','IL','1','Logan','Terri','Alison','','','34','276989838','6699 SOUTHERN VISTA DR',0,'ENON','OH','45323','1640','CY','39023','1994-11-06','F','',':RET:2106-3','N','021','HLT','1476234','92036OH005000501','2014-01-01','2013-12-20 23:29:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2013-12-26 04:38:55'),(18961,15107,'Y','18','021','EC','A','','','AC','0000424878','0000424878','TX00002377137','IL','1','GODINEZ','JOHN','R','','','34','469690735','1440 ALTA MESA BLVD',0,'BROWNSVILLE','TX','78526','1211','CY','48061','1979-05-30','M','U',NULL,'N','021','DEN','1522486','33348TX002000201','2014-03-01','2014-01-17 09:41:46','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-20 08:05:55'),(18342,14646,'Y','18','021','EC','A','','','AC','0000064914','0000064914','OH00002520592','IL','1','BROWNING','KENNETH','R','','','34','287865441','21 STATE ROUTE 56 SW',0,'LONDON','OH','43140',NULL,'CY','39097','1987-08-02','M','M',NULL,'N','021','DEN','2042543','99734OH005000401','2014-02-01','2014-01-15 18:13:34','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:18'),(15916,12744,'Y','18','021','EC','A','','','AC','0000843438','0000843438','TX00001715029','IL','1','Morales','Edit','','','','34','637468517','215 La Mancha Dr',0,'Brownsville','TX','78521',NULL,'CY','48061','1951-08-29','F','U',NULL,'N','021','DEN','2467688','33348TX002000101','2014-02-01','2014-01-01 21:37:05','0.00',NULL,NULL,'25.02','25.02','R-TX005','TX0','25.02',NULL,0,'2014-01-03 02:06:29'),(9071,7200,'Y','18','024','14','A','','','TE','0000746852','0000746852','','IL','1','Schmitz','Judith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-26','F','',NULL,NULL,NULL,'','1098244','','2013-12-18','2013-12-18 14:39:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:06:37'),(7105,5635,'Y','18','021','EC','A','','','AC','0000928507','0000928507','OH00001559590','IL','1','Reid','Caron','','','','34','293887595','4722ward st.',0,'Cincinnati','OH','45227',NULL,'CY','39061','1979-08-14','F','U',':RET:2054-5^:RET:2106-3','T','021','HLT','1989983','92036OH004001201','2014-01-01','2013-12-24 23:28:22','0.00',NULL,NULL,'240.98','240.98','R-OH004','OH0','240.98',NULL,0,'2013-12-26 01:50:51'),(22828,18214,'Y','18','021','EC','A','','','AC','0000232682','0000232682','OH00001915278','IL','1','Costello','Kathy','','','','34','299484363','1500 E. Milltown Rd.',0,'Wooster','OH','44691',NULL,'CY','39169','1949-09-28','F','U',':RET:2106-3','N','021','HLT','3696748','52664OH151001304','2014-03-01','2014-02-11 10:00:05','474.00',NULL,NULL,'669.00','195.00','R-OH014','OH0','669.00',NULL,0,'2014-02-11 21:02:05'),(2467,2007,'Y','18','021','EC','A','','','AC','0000025924','0000025924','LA00000827874','IL','1','Medaries','Linda','','','','34','436885263','1259 Leckie Road',0,'Eros','LA','71238',NULL,'CY','22073','1951-01-04','F','U',':RET:2106-3','N','021','DEN','602269','18575LA002000101','2014-01-01','2013-12-09 15:46:07','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 19:35:06'),(18395,14680,'Y','18','021','EC','A','','','AC','0000505755','0000505755','OH00002518212','IL','1','Smith','Shannon','','','','34','404359813','11817 Crofton Road',0,'Garfield Heights','OH','44125',NULL,'CY','39035','1974-07-04','F','M',':RET:2106-3','N','021','DEN','2210292','99734OH005000301','2014-02-01','2014-01-15 17:10:28','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:41'),(16358,13091,'Y','18','021','EC','A','','','AC','0001071792','0001071792','OH00001851126','IL','1','Payton','Joanie','Marie','','','34','276829737','1765 WINCHESTER RD',0,'XENIA','OH','45385','7632','CY','39057','1981-05-11','F','M',':RET:2106-3','N','021','DEN','2423445','99734OH005000301','2014-02-01','2014-01-06 14:27:03','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-07 04:02:40'),(3857,3087,'Y','18','021','EC','A','','','AC','0000062732','0000062732','LA00000318193','IL','1','Foster','Rose','','','','34','436357271','3639 PLANTATION RIDGE DR',0,'ADDIS','LA','70710','2178','CY','22121','1966-08-31','F','U',':RET:2054-5','N','021','DEN','1045023','18575LA002000201','2014-01-01','2013-12-12 19:07:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:35:49'),(22532,17990,'Y','18','021','EC','A','','','AC','0000044513','0000044513','MS00001990525','IL','1','Burnham','Eric','','','','34','427533900','113 Southdale Drive',0,'Starkville','MS','39759',NULL,'CY','28105','1985-04-13','M','U',':RET:2106-3','T','021','DEN','3572176','46300MS002000201','2014-03-01','2014-02-09 23:03:43','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-10 21:31:32'),(23840,18968,'N','01','021','EC','A',NULL,NULL,'','0001231817','0000103931','','IL','1','Bailey','Jennifer','','','','34','300909026','3639 EL REGO DR',0,'AMELIA','OH','45102','1624','CY','39025','1989-03-28','F','',':RET:2106-3','N','021','HLT','3499568','92036OH005000601','2014-03-01','2014-02-13 21:28:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','214.67',NULL,0,'2014-02-14 21:31:51'),(27149,21494,'Y','18','021','EC','A','','','AC','0000471079','0000471079','OH00002616422','IL','1','Hockett','Patricia','','','','34','300587774','12701 SHAKER BLVD',0,'CLEVELAND','OH','44120','2094','CY','39035','1958-03-10','F','U',':RET:2054-5','N','021','DEN','3323437','99734OH005000401','2014-04-01','2014-03-03 13:50:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-03 21:30:51'),(28269,22370,'Y','18','021','EC','A','','','AC','0001154107','0001154107','TX00003308758','IL','1','GARNER','JANET','','','','34','451060458','505 SUTTON DR',0,'COMANCHE','TX','76442','1681','CY','48093','1958-07-16','F','U',NULL,'N','021','DEN','3539829','33348TX002000201','2014-04-01','2014-03-07 11:27:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-07 21:00:20'),(28819,22807,'Y','18','021','EC','A','','','AC','0000876126','0000876126','OH00003739691','IL','1','CONNORS','ANDREW','','','','34','281902811','7340 LUNITAS LN',0,'PERRYSBURG','OH','43551','4606','CY','39173','1988-10-07','M','U',':RET:2106-3','N','021','HLT','4336333','92036OH002002601','2014-04-01','2014-03-09 10:16:24','61.00',NULL,NULL,'226.09','165.09','R-OH001','OH0','226.09',NULL,0,'2014-03-09 21:00:58'),(29087,23022,'N','01','021','EC','A',NULL,NULL,'','0000888891','0000124489','','IL','1','Maculo','Alina','','','','34','462574263','615 SHADBERRY DR',0,'MAGNOLIA','TX','77354','1642','CY','48339','1953-10-11','F','',':RET:2106-3','N','021','DEN','4352191','33348TX002000101','2014-04-01','2014-03-09 21:29:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-03-10 21:02:08'),(13084,10431,'Y','18','021','EC','A','','','AC','0000578780','0000578780','OH00001298850','IL','1','Thatcher','John','','','','34','291421337','377 FLORENCE AVE',0,'BELLAIRE','OH','43906','1891','CY','39013','1951-05-22','M','U',':RET:2106-3','T','021','DEN','2597877','99734OH005000401','2014-01-01','2013-12-23 11:11:45','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 12:51:40'),(13020,10378,'Y','18','021','EC','A','','','AC','0000154646','0000154646','OH00000042338','IL','1','Gallo','Raymond','','','','34','274742055','746 LONGACRE DR',0,'AKRON','OH','44319','1523','CY','39153','1963-03-05','M','U',':RET:2106-3','T','021','DEN','2395346','99734OH005000401','2014-01-01','2013-12-22 21:02:26','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:50:02'),(18162,14504,'Y','18','024','14','A','','','TE','0000333886','0000333886','','IL','1','Young','Steve',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-05-22','M','',NULL,NULL,NULL,'','1819573','','2014-01-14','2014-01-14 12:13:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:07:54'),(9183,7284,'Y','18','024','14','A','','','TE','0000805092','0000805092','','IL','1','steffan','victoria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-21','F','',NULL,NULL,NULL,'','608164','','2013-12-18','2013-12-18 15:24:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:14'),(6801,5395,'Y','18','021','EC','A','','','AC','0000045723','0000045723','OH00001187418','IL','1','Crick','Joe','','','','34','290723700','313 S MIAMI AVE',0,'BRADFORD','OH','45308','1217','CY','39037','1962-10-15','M','M',':RET:2106-3','T','021','HLT','840784','92036OH003000505','2014-01-01','2013-11-25 10:09:14','732.00',NULL,NULL,'999.18','267.18','R-OH003','OH0','532.43',NULL,0,'2013-12-26 01:17:24'),(5227,4150,'Y','18','021','EC','A','','','AC','0000012419','0000012419','OH00000114998','IL','1','CHELLATH','SEEMA','','','','34','616737041','5758 HAWTHORNE RESERVES DR',0,'LIBERTY TOWNSHIP','OH','45044','8888','CY','39017','1974-04-24','F','M',NULL,'N','021','DEN','1969442','99734OH005000401','2014-01-01','2013-12-19 18:28:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:04:41'),(14176,11302,'Y','18','021','EC','A','','','AC','0000440622','0000440622','TX00001516010','IL','1','Chapa','Monica','Marie','','','34','453999138','4629 BARRERA DR',0,'CORPUS CHRISTI','TX','78416','2441','CY','48355','1984-08-30','F','U',':RET:2106-3','N','021','DEN','2591634','33348TX002000201','2014-02-01','2013-12-26 01:34:39','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-27 02:03:35'),(3233,2603,'Y','18','021','EC','A','','','AC','0000149312','0000149312','OH00000767162','IL','1','steffen','kathy','','','','34','122522385','23307 LORAIN RD',0,'NORTH OLMSTED','OH','44070','1634','CY','39035','1958-06-10','F','U',NULL,'N','021','DEN','1196782','99734OH005000401','2014-01-01','2013-10-06 12:16:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:06'),(3842,3074,'Y','18','021','EC','A','','','AC','0000347749','0000347749','LA00000207767','IL','1','GEORGIEV','ALEXANDER','','','','34','249750630','16622 AUTUMN RIDGE AVE',0,'BATON ROUGE','LA','70810',NULL,'CY','22033','1953-05-29','M','M',NULL,'N','021','DEN','1175652','18575LA002000101','2014-01-01','2013-12-12 21:53:04','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-25 21:35:25'),(20582,16445,'N','01','021','EC','A',NULL,NULL,'','0000609559','0001108123','','IL','1','alshinnawi','Angela','A','','','34','547759396','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1969-09-24','F','',NULL,'N','021','DEN','3569056','99734OH005000401','2014-03-01','2014-01-29 18:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:04'),(20618,16476,'Y','18','021','EC','A','','','AC','0001662948','0001662948','LA00001602687','IL','1','COLBERT','TINICA','L','','','34','435415148','3323 DARIEN ST',0,'SHREVEPORT','LA','71109','2610','CY','22017','1980-07-10','F','U',NULL,'N','021','DEN','3001074','18575LA002000101','2014-03-01','2014-01-30 14:56:55','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-30 21:00:22'),(20917,16719,'N','19','021','EC','A',NULL,NULL,'','0000793499','0000995470','','S1','1','Small','Robert','','','','34','297980490','3401 CURTIS ST',0,'MOGADORE','OH','44260','1009','CY','39153','1996-03-07','M','',':RET:2106-3','N','021','HLT','3571998','52664OH152000901','2014-03-01','2014-01-31 15:26:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-31 21:01:31'),(25822,20475,'Y','18','021','EC','A','','','AC','0000960659','0000960659','OH00002193067','IL','1','Harty','Michael','','','','34','291866895','65 SALEM DR',0,'SPRINGBORO','OH','45066','8138','CY','39165','1979-02-05','M','M',':RET:2106-3','N','021','DEN','3552879','99734OH005000301','2014-04-01','2014-02-26 16:29:30','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:26'),(26591,21084,'N','19','021','EC','A',NULL,NULL,'','0000717875','0000025358','','S1','1','CAVILEER','JOHN','','','','34','639795510','40 WALDORF DR',0,'AKRON','OH','44313','6226','CY','39153','2013-11-05','F','',':RET:2106-3','N','021','HLT','3847575','52664OH152000901','2014-01-01','2014-02-28 12:21:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-02-28 21:30:36'),(235,196,'Y','18','021','EC','A','','','AC','0000582785','0000582785','OH00000904643','IL','1','Meehan','Michael','P','','','34','272442526','1818 MULBERRY ST',0,'TOLEDO','OH','43608','2509','CY','39095','1954-03-17','M','U',':RET:2106-3','N','021','HLT','484189','92036OH002002601','2014-01-01','2013-12-04 20:42:36','200.00',NULL,NULL,'586.17','386.17','R-OH001','OH0','586.17',NULL,0,'2013-12-25 17:21:08'),(13563,10816,'Y','18','021','EC','A','','','AC','0001707030','0001707030','LA00001209578','IL','1','Williams','Glenn','','','','34','436823108','8823 HIGHWAY 43',0,'AMITE','LA','70422','8307','CY','22091','1952-01-08','M','U',':RET:2054-5','N','021','DEN','1364107','18575LA002000201','2014-01-01','2013-12-23 16:11:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:24'),(16205,12975,'Y','18','021','EC','A','','','AC','0000985990','0000985990','TX00002339509','IL','1','Hymel','Ashley','','','','34','589463892','8700 Brodie Lane',0,'Austin','TX','78745',NULL,'CY','48453','1986-12-16','F','U',':RET:2106-3','N','021','DEN','2289608','33348TX002000201','2014-02-01','2014-01-04 13:24:57','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-05 00:01:16'),(1517,1266,'Y','18','021','EC','A','','','AC','0000520962','0000520962','OH00000661199','IL','1','Derecskey','Kerri','','','','34','268865407','8120 CLOVER LN',0,'GARRETTSVILLE','OH','44231','1056','CY','39133','1986-05-09','F','M',':RET:2106-3','N','021','DEN','2149566','99734OH005000401','2014-01-01','2013-12-24 14:26:30','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:49:42'),(2085,1707,'Y','18','021','EC','A','','','AC','0000013141','0000013141','LA00001079496','IL','1','cervini','brett','','','','34','439087082','1936 HICKORY AVE',0,'HARAHAN','LA','70123','1637','CY','22051','1958-03-12','M','M',':RET:2106-3','N','021','DEN','1185494','18575LA002000201','2014-01-01','2013-12-10 13:43:28','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:16:43'),(14405,11487,'N','01','021','EC','A',NULL,NULL,'','0000915654','0000739028','','IL','1','Keene','Bill','J','','','34','406681663','944 Main Ave SW',0,'Warren','OH','44483',NULL,'CY','39155','1953-03-31','M','',':RET:2106-3','N','021','DEN','1742289','99734OH005000401','2014-02-01','2013-12-27 17:46:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:31:18'),(14018,11167,'Y','18','021','EC','A','','','AC','0000177632','0000177632','OH00000141817','IL','1','yelton','dorothy','','','','34','289485596','10723 Liming Lake Rd.',0,'Hamersville','OH','45130',NULL,'CY','39015','1950-02-07','F','U',':RET:2106-3','N','021','HLT','1884404','92036OH003000605','2014-01-01','2013-12-23 15:55:11','499.00',NULL,NULL,'661.77','162.77','R-OH005','OH0','661.77',NULL,0,'2013-12-26 13:16:32'),(4398,3496,'Y','18','021','EC','A','','','AC','0000155749','0000155749','OH00000398007','IL','1','Vest','Dawn','','','','34','314664057','4061 Vinedale Ave',0,'Cincinnati','OH','45205',NULL,'CY','39061','1966-08-17','F','U',':RET:2106-3','N','021','DEN','416305','99734OH005000401','2014-01-01','2013-12-12 13:37:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:03'),(2352,1917,'Y','18','021','EC','A','','','AC','0000737166','0000737166','TX00000346432','IL','1','Hilburn','Teresa','','','','34','450331888','11323 COUNTY ROAD 3251 E',0,'TIMPSON','TX','75975','2128','CY','48401','1975-01-11','F','U',':RET:2106-3','N','021','DEN','1240791','33348TX002000201','2014-01-01','2013-12-09 16:37:07','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 19:32:16'),(23666,18844,'Y','18','021','EC','A','','','AC','0000373319','0000373319','TX00002276991','IL','1','Lopez','Abel','Nathaniel','','Sr','34','450734912','9329 JUANCHIDO LN',0,'YSLETA DEL SUR PUEBLO','TX','79907','6831','CY','48141','1985-02-23','M','M',':RET:1002-5','N','021','DEN','3532953','33348TX002000201','2014-03-01','2014-02-14 13:14:51','0.00',NULL,NULL,'52.83','52.83','R-TX009','TX0','14.61',NULL,0,'2014-02-14 21:30:22'),(24473,19441,'Y','18','021','EC','A','','','AC','0000361071','0000361071','OH00002074222','IL','1','Jackson','Pamela','','','','34','278729770','3311 Jeanette Ave',0,'Toledo','OH','43608',NULL,'CY','39095','1968-02-05','F','U',NULL,'N','021','HLT','3220127','92036OH004002601','2014-04-01','2014-02-18 14:44:39','183.00',NULL,NULL,'235.18','52.18','R-OH001','OH0','235.18',NULL,0,'2014-02-18 22:01:39'),(29105,23038,'Y','18','021','EC','A','','','AC','0000978001','0000978001','OH00003515554','IL','1','CRAMER','ELAINE','','','','34','286566960','08442 CO RD 33A',0,'WAPAKONETA','OH','45895',NULL,'CY','39011','1959-02-23','F','M',':RET:2106-3','N','021','HLT','4194103','92036OH003001506','2014-04-01','2014-03-09 22:40:53','437.00',NULL,NULL,'512.54','75.54','R-OH002','OH0','512.54',NULL,0,'2014-03-10 21:02:20'),(382,317,'Y','18','021','EC','A','','','AC','0000713577','0000713577','TX00001148118','IL','1','Riggins','Virginia','','','','34','439725887','3007 Sunset Park Drive',0,'Katy','TX','77449',NULL,'CY','48201','1950-03-28','F','M',':RET:2054-5','N','021','DEN','1165730','33348TX002000201','2014-01-01','2013-12-04 11:46:29','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:45:45'),(18290,14602,'Y','18','021','EC','A','','','AC','0000160808','0000160808','OH00002457392','IL','1','zittle','susan','','','','34','286600604','1669 BERNA RD',0,'AKRON','OH','44312','5433','CY','39153','1975-05-08','F','M',NULL,'N','021','DEN','1397252','99734OH005000401','2014-02-01','2014-01-14 21:28:18','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:44:52'),(465,380,'Y','18','021','EC','A','','','AC','0000321016','0000321016','OH00000673224','IL','1','Bertok','Lisa','','','','34','297688327','1506 OAK TREE DR',0,'BRUNSWICK','OH','44212','3573','CY','39103','1958-12-13','F','U',':RET:2106-3','N','021','HLT','74193','52664OH151001306','2014-01-01','2013-12-04 10:21:46','422.00',NULL,NULL,'497.31','75.31','R-OH012','OH0','497.31',NULL,0,'2013-12-25 17:47:44'),(1622,1355,'Y','18','021','EC','A','','','AC','0001170087','0001170087','TX00001240938','31','1','Butcher','Christopher','Matthew','','','34','458312466','PO BOX 921',0,'WHARTON','TX','77488',NULL,'CY','48481','1975-03-18','M','U',':RET:2106-3','N','021','DEN','2573583','33348TX002000201','2014-01-01','2013-12-24 13:53:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:52:36'),(9499,7534,'Y','18','021','EC','A','','','AC','0000456517','0000456517','OH00000049576','IL','1','LARKIN','DARRINA','KATHERYN','','','34','298583260','3491 CRESTNOLL LANE',0,'CINCINNATI','OH','45211',NULL,'CY','39061','1965-09-21','F','M',':RET:2106-3','N','021','DEN','1988410','99734OH005000401','2014-01-01','2013-12-21 15:13:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:35:08'),(16593,13272,'N','01','021','EC','A',NULL,NULL,'','0001264685','0001695378','','IL','1','DUDLEY','MAUREEN','','','','34','471788160','1630 PARKER ST',0,'FRANKLINTON','LA','70438','1318','CY','22117','1958-02-13','F','',':RET:2054-5','T','021','DEN','1426448','18575LA002000201','2014-02-01','2014-01-07 16:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-08 18:24:01'),(4140,3303,'Y','18','021','EC','A','','','AC','0000930898','0000930898','OH00000503468','IL','1','NAKKA','COTTON','','','','34','366237733','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','1976-04-24','M','R',':RET:2029-7','N','021','DEN','1476001','99734OH005000301','2014-01-01','2013-12-17 12:33:58','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:34'),(16043,12846,'Y','18','021','EC','A','','','AC','0000864125','0000864125','TX00000428415','IL','1','molina','patricia','','','','34','464430929','rt3 box 20m hwy 359',0,'laredo','TX','78043',NULL,'CY','48479','1954-03-17','F','U',':RET:2106-3','N','021','DEN','2116267','33348TX002000101','2014-02-01','2014-01-02 23:35:34','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-01-04 02:02:55'),(9080,7205,'Y','18','021','EC','A','','','AC','0001105518','0001105518','OH00000320508','IL','1','McIlvain','Brianna','','','','34','290821605','2134 miller',0,'Alliance','OH','44601',NULL,'CY','39151','1984-11-16','F','M',':RET:2106-3','N','021','DEN','1798952','99734OH005000301','2014-01-01','2013-12-17 22:42:14','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-26 04:06:49'),(14230,11348,'Y','18','021','EC','A','','','AC','0000438108','0000438108','TX00001351339','IL','1','pritchett','kyle','','','','34','631101733','11224 TENAHA AVE',0,'EL PASO','TX','79936','1203','CY','48141','1987-08-17','M','U',':RET:2106-3','N','021','DEN','2464929','33348TX002000201','2014-02-01','2013-12-26 18:26:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-27 02:04:58'),(13894,11083,'Y','18','021','EC','A','','','AC','0001179626','0001179626','OH00000958918','IL','1','Dagg','Stephen','W','','','34','271505339','29545 E. Broadway Street',0,'Walbridge','OH','43465',NULL,'CY','39173','1951-09-27','M','M',':RET:2106-3','T','021','HLT','2147085','92036OH005002604','2014-01-01','2013-12-23 19:06:07','704.00',NULL,NULL,'1042.04','338.04','R-OH001','OH0','644.25',NULL,0,'2013-12-26 13:13:32'),(24412,19391,'N','01','021','EC','A',NULL,NULL,'','0000267577','0000721388','','IL','1','SNYDER','PAUL','','','','34','292441874','27 COMO ST',0,'STRUTHERS','OH','44471','1602','CY','39099','1949-08-11','M','',NULL,'N','021','DEN','2914120','99734OH005000301','2014-04-01','2014-02-18 10:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-18 22:01:02'),(25090,19899,'Y','18','021','EC','A','','','AC','0000471065','0000471065','OH00002655605','IL','1','Vegara','Koviljka','','','','34','731098091','1535 Brittain cir.',0,'Akron','OH','44310',NULL,'CY','39153','1968-09-27','F','M',':RET:2106-3','N','021','DEN','3354189','99734OH005000401','2014-03-01','2014-02-20 20:36:27','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-21 21:30:05'),(28845,22825,'N','01','021','EC','A',NULL,NULL,'','0000072943','0000274854','','IL','1','Morris','Alex','','','','34','289827593','1884 MALASIA RD',0,'AKRON','OH','44305','3672','CY','39153','1981-05-27','M','',':RET:2106-3','N','021','HLT','3281234','52664OH152000901','2014-04-01','2014-03-09 13:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','193.23',NULL,0,'2014-03-09 21:01:14'),(3049,2449,'Y','18','021','EC','A','','','AC','0000993071','0000993071','LA00000281140','IL','1','Pharr-Horne','Ava','','','','34','435451742','5416 DEBORE DR',0,'NEW ORLEANS','LA','70126','2428','CY','22071','1966-02-05','F','M',':RET:2054-5','N','021','DEN','546760','18575LA002000201','2014-01-01','2013-12-06 08:31:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:18:50'),(18308,14617,'Y','18','021','EC','A','','','AC','0000134598','0000134598','OH00001800776','IL','1','Ryan','Rhonda','','','','34','281681758','3958 N BEND RD',0,'CINCINNATI','OH','45211','3521','CY','39061','1962-10-31','F','M',':RET:2106-3','N','021','DEN','2090322','99734OH005000401','2014-02-01','2014-01-15 12:16:40','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:01'),(2673,2168,'N','19','021','EC','A',NULL,NULL,'','0000280804','0001157532','','IL','1','sickles','kayden','','','','34','807367452','1700 WOODWARD AVE',0,'SPRINGFIELD','OH','45506','3147','CY','39023','2012-08-21','M','',':RET:2106-3','N','021','DEN','697055','99734OH005000301','2014-01-01','2013-12-02 15:33:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:05'),(14468,11544,'N','01','021','EC','A',NULL,NULL,'','0000376541','0000183342','','IL','1','rodriguez','marilyn','','','','34','449175914','1424 OLIVE ST',0,'GAINESVILLE','TX','76240','3561','CY','48097','1953-08-01','F','',':RET:2106-3','N','021','DEN','1444607','33348TX002000201','2014-02-01','2013-12-26 18:55:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-28 03:32:58'),(15459,12371,'Y','18','021','EC','A','','','AC','0000433134','0000433134','TX00001746953','IL','1','MONTERROZA','AMADEO','','','','34','555996494','15902 N BEND CT',0,'HOUSTON','TX','77073','5450','CY','48201','1958-10-10','M','M',':RET:2106-3','N','021','DEN','2023730','33348TX002000201','2014-02-01','2013-12-31 18:07:12','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:28:37'),(14318,11419,'N','19','021','EC','A',NULL,NULL,'','0000987410','0000561679','','IL','1','Baddar','Youseff','','','','34','270986796','3663 WOODSPRING RD',0,'SYLVANIA','OH','43560','3558','CY','39095','1994-11-08','M','',NULL,'N','021','HLT','1495338','92036OH001002601','2014-02-01','2013-12-26 11:38:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','149.37',NULL,0,'2013-12-27 02:07:11'),(13277,10596,'Y','18','021','EC','A','','','AC','0000877727','0000877727','TX00000814486','IL','1','Mosi','Prima','','','','34','573850068','7202 South Brook',0,'Austin','TX','78736',NULL,'CY','48453','1965-06-24','F','U',':RET:2106-3','N','021','DEN','2226792','33348TX002000201','2014-01-01','2013-12-23 12:39:22','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:57:04'),(7836,6206,'N','01','021','EC','A',NULL,NULL,'','0000733581','0000156929','','IL','1','DZIAK','CONNIE','','','','34','283669859','2899 C.R. 195',0,'CLYDE','OH','43410',NULL,'CY','39143','1962-02-17','F','',':RET:2106-3','N','021','DEN','1940342','99734OH005000301','2014-01-01','2013-12-19 20:11:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:31'),(22167,17691,'Y','18','021','EC','A','','','AC','0001097814','0001097814','OH00002207324','IL','1','Kittle','Heidi','','','','34','272608475','737 GORDON GRV',0,'SAINT MARYS','OH','45885','1767','CY','39011','1971-05-02','F','U',':RET:2106-3','N','021','HLT','3464043','92036OH004001501','2014-03-01','2014-02-08 16:06:15','0.00',NULL,NULL,'234.49','234.49','R-OH002','OH0','234.49',NULL,0,'2014-02-08 19:01:02'),(23780,18923,'Y','18','021','EC','A','','','AC','0000743192','0000743192','MS00002112039','IL','1','Wiggins','Tiffany','','','','34','587492639','13105 Rocky Mountain Rd',0,'Biloxi','MS','39532',NULL,'CY','28047','1984-07-07','F','U',':RET:2054-5','N','021','DEN','3122229','46300MS002000201','2014-03-01','2014-02-14 12:50:51','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-14 21:31:19'),(25815,20471,'N','19','021','EC','A',NULL,NULL,'','0000003628','0001062182','','IL','1','MIKLOS','KATRINA','','','','34','288117398','12760 CARTER RD',0,'PAINESVILLE','OH','44077','9790','CY','39085','2005-10-31','F','',NULL,'N','021','DEN','3115883','99734OH005000301','2014-03-01','2014-02-26 14:59:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:24'),(26601,21090,'N','01','021','EC','A',NULL,NULL,'','0000751423','0000884021','','IL','1','lewis','erica','','','','34','628092557','8858 VINCENT RD',0,'COLLEGE STATION','TX','77845','9047','CY','48041','1989-07-09','F','',':RET:2054-5','N','021','DEN','2990657','33348TX002000201','2014-03-01','2014-02-27 19:14:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-28 21:30:41'),(27396,21689,'Y','18','021','EC','A','','','AC','0000214721','0000214721','OH00003124105','IL','1','Rowland','Rebecca','','','','34','377826912','328 Beech Street',0,'Green Camp','OH','43322',NULL,'CY','39101','1976-07-12','F','U',':RET:2106-3','N','021','DEN','2955789','99734OH005000301','2014-04-01','2014-03-03 21:44:46','0.00',NULL,NULL,'59.76','59.76','R-OH008','OH0','0.00',NULL,0,'2014-03-04 21:01:29'),(791,653,'Y','18','021','EC','A','','','AC','0000903472','0000903472','TX00000893862','IL','1','Alexander','Princesa','','','','34','449021116','5418 FLO DR',0,'WICHITA FALLS','TX','76302','5134','CY','48485','1953-12-03','F','U',':RET:2106-3','N','021','DEN','1815003','33348TX002000201','2014-01-01','2013-12-16 16:29:31','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:05:18'),(19168,15271,'Y','18','021','EC','A','','','AC','0000949077','0000949077','TX00001408588','IL','1','Clary','Candy','Beth','','','34','465711561','233 COUNTY ROAD 1230',0,'PITTSBURG','TX','75686','4839','CY','48343','1967-12-29','F','M',':RET:2106-3','T','021','DEN','1885209','33348TX002000201','2014-03-01','2014-01-20 11:24:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-21 08:46:02'),(13399,10693,'Y','18','021','EC','A','','','AC','0001078890','0001078890','OH00000030404','IL','1','Todd','Benjamin','','','','34','281583577','7100 COOK RD',0,'POWELL','OH','43065','8599','CY','39041','1955-04-25','M','U',':RET:2106-3','N','021','DEN','1378354','99734OH005000301','2014-01-01','2013-12-23 08:48:56','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:00:17'),(13289,10607,'Y','18','024','14','A','','','TE','0001190116','0001190116','','IL','1','Franklin','Eugene',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-26','M','',NULL,NULL,NULL,'','973557','','2013-12-23','2013-12-23 13:30:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 12:57:26'),(17626,14092,'Y','18','021','EC','A','','','AC','0000367115','0000367115','TX00001525251','IL','1','Alvarez','Miguel','','','','34','466940629','6715 Windrift Way',0,'Austin','TX','78745',NULL,'CY','48453','1964-04-18','M','U',':RET:2106-3','N','021','DEN','2663942','33348TX002000201','2014-02-01','2014-01-13 15:24:16','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:30'),(17531,14017,'Y','18','021','EC','A','','','AC','0001061041','0001061041','MS00001469164','IL','1','neal','lisa','g','','','34','426252907','526 broad st',0,'jackson','MS','39203',NULL,'CY','28049','1961-10-04','F','U',':RET:2054-5','N','021','DEN','2381709','46300MS002000201','2014-02-01','2014-01-12 10:18:20','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-13 03:01:43'),(17285,13823,'Y','18','021','EC','A','','','AC','0000615046','0000615046','TX00001458862','IL','1','Birchfield','Michael','','','','34','453356782','702 S MAIN ST',0,'COTULLA','TX','78014','2472','CY','48283','1969-02-28','M','U',NULL,'T','021','DEN','2077597','33348TX002000201','2014-02-01','2014-01-09 18:49:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:27'),(13108,10452,'Y','18','021','EC','A','','','AC','0000112929','0000112929','OH00000216588','IL','1','Cottrill','Cole','','','','34','272925790','3347 QUEEN CITY AVE',0,'CINCINNATI','OH','45238','2207','CY','39061','1986-04-03','M','U',':RET:2106-3','T','021','DEN','2569495','99734OH005000401','2014-01-01','2013-12-23 13:19:17','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:22'),(16253,13012,'N','19','021','EC','A',NULL,NULL,'','0000236286','0000850510','','IL','1','bonenfant','robert','m','','Jr','34','297943292','25271 SPRAGUE RD',0,'COLUMBIA STATION','OH','44028','9602','CY','39093','1992-03-06','M','',':RET:2106-3','N','021','DEN','2522495','99734OH005000301','2014-02-01','2014-01-04 15:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:39'),(21456,17147,'Y','18','021','EC','A','','','AC','0000659932','0000659932','OH00001799721','IL','1','Lyttle','Rebecca','','','','34','291441711','10825 RESERVOIR DR',0,'MANTUA','OH','44255','8400','CY','39133','1954-05-14','F','U',NULL,'N','021','HLT','1800297','52664OH151001301','2014-03-01','2014-02-04 13:58:57','184.00',NULL,NULL,'580.49','396.49','R-OH012','OH0','580.49',NULL,0,'2014-02-04 21:01:31'),(22638,18077,'Y','18','021','EC','A','','','AC','0000307865','0000307865','TX00001530573','IL','1','Phan','Thanh','','','','34','586524263','2230 Templeton DR',0,'Arlington','TX','76006',NULL,'CY','48439','1950-03-02','M','M',':RET:2047-9','N','021','DEN','3472072','33348TX002000201','2014-03-01','2014-02-11 09:58:21','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:21'),(22689,18117,'N','19','021','EC','A',NULL,NULL,'','0000126951','0000904958','','IL','1','Hicks','Sarae','Ashlyn','','','34','633648203','9356 MECHLER LN',0,'LA COSTE','TX','78039','9417','CY','48029','1998-11-08','F','',NULL,'N','021','DEN','2654099','33348TX002000101','2014-03-01','2014-02-11 18:17:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-02-11 21:00:51'),(23959,19051,'Y','18','021','EC','A','','','AC','0000015563','0000015563','TX00002178079','IL','1','Rousey','Robert','','','','34','438871357','2506 COLEY DR',0,'KILLEEN','TX','76543','7505','CY','48027','1992-08-29','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3241986','33348TX002000101','2014-03-01','2014-02-15 13:02:47','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2014-02-15 22:00:08'),(25734,20413,'Y','18','021','EC','A','','','AC','0001888275','0001888275','LA00003071919','31','1','RICHARD','JAUNITA','D','','','34','433780949','PO BOX 116',0,'MERMANTAU','LA','70556',NULL,'CY','22001','1949-08-03','F','U',':RET:2106-3','N','021','DEN','3430458','18575LA002000201','2014-04-01','2014-02-24 17:29:32','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 09:30:37'),(26735,21189,'Y','18','021','EC','A','','','AC','0000392424','0000392424','OH00001983493','IL','1','Ross','Charles','F','','Jr','34','289522034','109 EWING DR',0,'FAIRFIELD','OH','45014','7492','CY','39017','1952-10-23','M','U',NULL,'N','021','HLT','3251200','92036OH004001201','2014-04-01','2014-02-28 13:33:39','315.00',NULL,NULL,'485.05','170.05','R-OH004','OH0','485.05',NULL,0,'2014-02-28 21:31:51'),(8031,6358,'Y','18','021','EC','A','','','AC','0000546901','0000546901','MS00000001790','IL','1','Pittman','Verkista','','','','34','428530129','2633 KAY WHITE CIR',0,'GREENWOOD','MS','38930','7204','CY','28083','1983-06-19','F','U',':RET:2054-5','N','021','DEN','1972934','46300MS002000101','2014-01-01','2013-12-20 14:50:20','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 03:09:08'),(19490,15535,'Y','18','021','EC','A','','','AC','0000321062','0000321062','OH00002218483','IL','1','CURTIS','LYNN','','','','34','264374368','4672 N COUNTY LINE RD',0,'GENEVA','OH','44041','7613','CY','39007','1958-06-26','F','M',NULL,'N','021','HLT','3117932','52664OH151001305','2014-03-01','2014-01-21 19:10:42','675.00',NULL,NULL,'812.41','137.41','R-OH011','OH0','560.89',NULL,0,'2014-01-23 03:02:06'),(18942,15092,'Y','18','024','14','A','','','TE','0000705160','0000705160','','IL','1','COSS','MILDRED',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-10-24','F','',NULL,NULL,NULL,'','2013550','','2014-01-17','2014-01-17 12:50:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:05:44'),(1466,1222,'Y','18','021','EC','A','','','AC','0000078771','0000078771','OH00000886227','IL','1','Miller','Juanita','','','','34','279545653','4943 Barrie St NW',0,'Canton','OH','44708',NULL,'CY','39151','1953-09-24','F','M',':RET:2106-3','N','021','DEN','1657919','99734OH005000401','2014-01-01','2013-12-24 09:05:06','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2013-12-25 18:48:27'),(16931,13549,'Y','18','021','EC','A','','','AC','0001601657','0001601657','LA00002232930','IL','1','Knight','Dorothy','','','','34','433867513','3401 Garden Oaks Dr',0,'New Orleans','LA','70114',NULL,'CY','22071','1949-09-04','F','U',NULL,'T','021','DEN','1553320','18575LA002000201','2014-02-01','2014-01-09 16:57:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:49'),(13939,11117,'N','01','021','EC','A',NULL,NULL,'','0001008945','0000579986','','IL','1','Sheamer','Kelly','J','','','34','281820525','14015 SHERMAN WHITE RD',0,'SWANTON','OH','43558','9112','CY','39095','1968-03-07','F','',':RET:2106-3','T','021','HLT','1879201','92036OH004002601','2014-01-01','2013-12-23 17:27:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','260.37',NULL,0,'2013-12-26 13:14:42'),(5807,4613,'Y','18','021','EC','A','','','AC','0000692177','0000692177','TX00000034079','IL','1','Wille','Robin','Juliana','','','34','468787585','2901 Haine Dr',0,'Harlingen','TX','78550',NULL,'CY','48061','1962-02-22','F','R',':RET:2106-3','N','021','DEN','2442032','33348TX002000201','2014-01-01','2013-12-23 21:28:44','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 23:47:40'),(4222,3360,'Y','18','021','EC','A','','','AC','0001247760','0001247760','TX00000266173','IL','1','Jolly','Tonya','','','','34','458800414','1249 PRUITT RD',0,'SPRING','TX','77380','3028','CY','48339','1960-01-22','F','U',':RET:2106-3','T','021','DEN','2464342','33348TX002000201','2014-01-01','2013-12-17 10:44:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:50:27'),(24754,19643,'Y','18','021','EC','A','','','AC','0000990107','0000990107','OH00003038556','IL','1','Lovingshimer','Melanie','Dawn','','','34','289724784','1920 WILLIAMS RD',0,'COLUMBUS','OH','43207','5113','CY','39049','1977-01-08','F','M',':RET:2106-3','N','021','DEN','2626891','99734OH005000401','2014-04-01','2014-02-19 10:28:18','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:41:40'),(908,753,'Y','18','024','14','A','','','TE','0000402430','0000402430','','IL','1','Ledsome','Melissa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1993-01-29','F','',NULL,NULL,NULL,'','757222','','2013-12-16','2013-12-16 13:27:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:08:28'),(9397,7453,'Y','18','021','EC','A','','','AC','0000140542','0000140542','TX00001108822','IL','1','Ramirez','Hector','','','','34','642263869','1132 COUNTY ROAD 220',0,'FLORENCE','TX','76527','4334','CY','48491','1987-05-31','M','M',NULL,'N','021','DEN','2125706','33348TX002000201','2014-01-01','2013-12-20 23:48:06','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:32:29'),(3805,3050,'Y','18','021','EC','A','','','AC','0000209610','0000209610','OH00000651602','IL','1','Tupaz','Benjamin','','','','34','269703499','950 PEBBLE BEACH CV',0,'PAINESVILLE','OH','44077','4666','CY','39085','1970-07-07','M','M',':RET:2036-2','N','021','DEN','1028217','99734OH005000301','2014-01-01','2013-12-13 13:25:53','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:34:37'),(16158,12939,'N','01','021','EC','A',NULL,NULL,'','0000208479','0000427617','','IL','1','Bloomfield','Teresa','','','','34','275689618','3636 HIAWATHA TRL',0,'LIMA','OH','45806','1547','CY','39003','1959-06-18','F','',':RET:2106-3','N','021','DEN','1706694','99734OH005000301','2014-01-01','2013-12-16 22:06:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 06:00:07'),(15725,12577,'Y','18','021','EC','A','','','AC','0000257137','0000257137','OH00001666361','IL','1','Nugent','James','','','','34','302466948','1101 E 174TH ST',0,'CLEVELAND','OH','44119','3107','CY','39035','1951-04-06','M','U',':RET:2106-3','N','021','DEN','1818172','99734OH005000301','2014-02-01','2014-01-02 16:23:02','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:00:17'),(14656,11698,'Y','18','021','EC','A','','','AC','0000389432','0000389432','TX00001618760','IL','1','Williams','Nixon','','','','34','437713695','6635 S STAPLES ST',0,'CORPUS CHRISTI','TX','78413','5407','CY','48355','1980-09-09','M','U',NULL,'N','021','DEN','2241873','33348TX002000201','2014-02-01','2013-12-27 20:49:49','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2013-12-29 11:07:52'),(14089,11228,'Y','18','024','14','A','','','TE','0000166385','0000166385','','IL','1','Pope','Dionne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-02','F','',NULL,NULL,NULL,'','2148666','','2013-12-26','2013-12-26 10:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:01:18'),(20732,16565,'Y','18','021','EC','A','','','AC','0000582837','0000582837','OH00002513757','IL','1','SCHEDLER','LAURA','','','','34','287447717','29002 FOXBORO ST',0,'WILLOWICK','OH','44095','4556','CY','39085','1955-10-06','F','U',':RET:2106-3','N','021','HLT','3518808','52664OH152000901','2014-03-01','2014-01-30 10:39:34','469.40',NULL,NULL,'469.40','0.00','R-OH011','OH0','469.40',NULL,0,'2014-01-30 21:01:19'),(22098,17640,'Y','18','021','EC','A','','','AC','0000944907','0000944907','OH00001620833','IL','1','BOYD','BRANDON','','','','34','279809818','785 GREENVIEW DR',0,'TIPP CITY','OH','45371',NULL,'CY','39109','1983-05-03','M','M',':RET:2054-5','T','021','DEN','3605725','99734OH005000301','2014-03-01','2014-02-07 21:01:11','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-08 19:00:28'),(26742,21195,'Y','18','021','EC','A','','','AC','0000992728','0000992728','OH00003504170','IL','1','Supe','Kyle','','','','34','396882505','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','1982-04-12','M','M',':RET:2106-3','N','021','HLT','3540690','92036OH003001205','2014-03-01','2014-02-28 15:58:36','508.00',NULL,NULL,'930.60','422.60','R-OH004','OH0','259.83',NULL,0,'2014-02-28 21:31:56'),(27459,21732,'Y','18','021','EC','A','','','AC','0001234176','0001234176','OH00002529265','IL','1','FRANKLIN','MARSHALL','','','','34','301562968','4434 MINOR RD',0,'COPLEY','OH','44321','2430','CY','39153','1958-04-04','M','M',':RET:2106-3','N','021','HLT','2868556','52664OH152000901','2014-04-01','2014-03-04 12:23:53','0.00',NULL,NULL,'683.09','683.09','R-OH012','OH0','364.25',NULL,0,'2014-03-04 21:02:04'),(27597,21826,'Y','18','021','EC','A','','','AC','0000414759','0000414759','OH00002871356','IL','1','Yancey','Lauren','','','','34','273524407','240 OAKMONT ST',0,'CINCINNATI','OH','45216','1421','CY','39061','1955-10-08','F','U',':RET:2054-5','N','021','DEN','3479993','99734OH005000401','2014-04-01','2014-03-05 12:12:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-03-05 21:00:20'),(3699,2961,'Y','18','021','EC','A','','','AC','0001020404','0001020404','OH00000102027','IL','1','Schneider','Joseph','','','','34','289866239','8940 REVERE RUN',0,'WEST CHESTER','OH','45069','3625','CY','39017','1976-09-03','M','U',':RET:2106-3','T','021','DEN','189996','99734OH005000401','2014-01-01','2013-12-13 12:07:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:56'),(3388,2717,'Y','18','021','EC','A','','','AC','0002037768','0002037768','LA00000607920','IL','1','Lee','Angela','','','','34','434295841','2512 LULA AVE',0,'BATON ROUGE','LA','70802','2357','CY','22033','1972-05-27','F','U',NULL,'N','021','DEN','1958027','18575LA002000201','2014-01-01','2013-12-21 19:21:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:17:44'),(17067,13658,'Y','18','024','14','A','','','TE','0001138430','0001138430','','IL','1','Eatmon','Javonne','Deshye',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-06-02','F','',NULL,NULL,NULL,'','1545352','','2014-01-07','2014-01-07 21:57:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:21:15'),(3257,2624,'Y','18','021','EC','A','','','AC','0000604683','0000604683','OH00000129629','IL','1','Creamer','Colleen','','','','34','292901607','7878 GILSTON CT',0,'COLUMBUS','OH','43235','4543','CY','39049','1987-05-27','F','U',':RET:2106-3','N','021','DEN','562406','99734OH005000301','2014-01-01','2013-11-28 17:34:36','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:46:44'),(25547,20268,'Y','18','021','EC','A','','','AC','0000477507','0000477507','OH00003028702','IL','1','Lewis','Thelma','','','','34','435989408','3433 Pleasant View Avenue',0,'Cincinnati','OH','45207',NULL,'CY','39061','1957-07-19','F','U',':RET:2054-5','N','021','DEN','3318007','99734OH005000401','2014-04-01','2014-02-23 14:20:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 08:00:15'),(27136,21483,'Y','18','021','EC','A','','','AC','0001054277','0001054277','OH00002957013','IL','1','Doty','Sherri','','','','34','547678084','141 GOETHE ST',0,'CINCINNATI','OH','45202','8953','CY','39061','1965-07-03','F','U',':RET:2106-3','T','021','DEN','3488649','99734OH005000401','2014-04-01','2014-03-03 11:29:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:43'),(27892,22065,'Y','18','024','14','A','','','TE','0001217419','0001217419','','IL','1','Cox','Rico','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-14','M','',NULL,NULL,NULL,'','3404116','','2014-03-05','2014-03-05 13:07:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:40'),(1486,1239,'N','01','021','EC','A',NULL,NULL,'','0000792220','0000815338','','IL','1','Helmick','Georgiana','','','','34','273520476','1076 HYDE SHAFFER RD',0,'BRISTOLVILLE','OH','44402','9718','CY','39155','1954-03-24','F','',':RET:2106-3','N','021','DEN','1984042','99734OH005000401','2014-01-01','2013-12-24 10:56:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:48:55'),(2261,1851,'N','19','021','EC','A',NULL,NULL,'','0000909454','0001237680','','IL','1','Andreadis','Saijal','','','','34','285028231','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1997-09-21','F','',':RET:2106-3','N','021','DEN','19816','99734OH005000301','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:14'),(18717,14920,'Y','18','021','EC','A','','','AC','0000095259','0000095259','OH00001971296','IL','1','SARICH','JON','','','','34','271900740','2154 MAPLEWOOD RD',0,'STOW','OH','44224','2645','CY','39153','1982-02-17','M','U',':RET:2106-3','T','021','DEN','1548358','99734OH005000301','2014-02-01','2014-01-15 22:57:21','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-17 03:35:33'),(17977,14365,'Y','18','021','EC','A','','','AC','0000642091','0000642091','OH00002574576','IL','1','IRWIN','GREG','','','','34','295642943','2040 BROADWAY AVE NE',0,'EAST CANTON','OH','44730','1716','CY','39151','1957-09-30','M','M',':RET:2106-3','N','021','HLT','2746117','52664OH151001301','2014-02-01','2014-01-14 12:29:46','582.00',NULL,NULL,'1063.75','481.75','R-OH015','OH0','520.28',NULL,0,'2014-01-15 02:06:52'),(22159,17686,'Y','18','021','EC','A','','','AC','0000100103','0000100103','OH00002212360','IL','1','Schroeder','Donald','','','','34','280525773','6219 N TEXAS ST',0,'WHITEHOUSE','OH','43571','9519','CY','39095','1952-07-03','M','M',NULL,'N','021','HLT','2913832','92036OH004002601','2014-03-01','2014-02-08 12:37:28','169.00',NULL,NULL,'440.60','271.60','R-OH001','OH0','440.60',NULL,0,'2014-02-08 19:00:58'),(21326,17041,'Y','18','021','EC','A','','','AC','0002095821','0002095821','LA00002114477','IL','1','CANNATELLA','MICHELLE','','','','34','434650948','2002 MCDONALD ST',0,'MANDEVILLE','LA','70448','6524','CY','22103','1985-06-27','F','U',NULL,'N','021','DEN','3690281','18575LA002000201','2014-03-01','2014-02-04 18:11:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:25'),(18715,14919,'Y','18','021','EC','A','','','AC','0000785825','0000785825','OH00001967633','IL','1','Liccardi','Paul','','','Sr','34','286786193','326 ROSEGARDEN DR NE',0,'WARREN','OH','44484','1827','CY','39155','1966-07-20','M','M',':RET:2106-3','N','021','DEN','3054281','99734OH005000301','2014-02-01','2014-01-15 22:45:13','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-01-17 03:35:32'),(1258,1037,'Y','18','021','EC','A','','','AC','0000271399','0000271399','OH00001290539','IL','1','Wuest','Frances','','','','34','283563683','1606 CEDAR BROWN RD',0,'CURTICE','OH','43412','9703','CY','39095','1954-06-04','F','R',':RET:2106-3','N','021','HLT','910914','92036OH006002601','2014-01-01','2013-12-03 11:56:53','0.00',NULL,NULL,'402.54','402.54','R-OH001','OH0','402.54',NULL,0,'2013-12-25 18:21:26'),(1531,1275,'Y','18','021','EC','A','','','AC','0000879493','0000879493','OH00000551123','IL','1','HILL','KIM','','','','34','285625285','1036 DUXBERRY AVE',0,'COLUMBUS','OH','43211','2137','CY','39049','1958-06-30','F','U',':RET:2054-5','N','021','DEN','1716452','99734OH005000401','2014-01-01','2013-12-24 16:02:32','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:50:01'),(7651,6058,'Y','18','021','EC','A','','','AC','0000045585','0000045585','TX00000657374','IL','1','Willis','Michel','','','','34','453960959','1023 OWENWOOD DR',0,'IRVING','TX','75061','5534','CY','48113','1952-08-27','F','U',':RET:2106-3','N','021','DEN','56665','33348TX002000201','2014-01-01','2013-11-10 14:47:45','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 02:46:52'),(5170,4101,'Y','18','021','EC','A','','','AC','0000179875','0000179875','OH00001073605','IL','1','Creatura','Christopher','','','','34','287668695','8 E LakeView Dr.',0,'Cincinatti','OH','45237',NULL,'CY','39061','1965-09-16','M','U',NULL,'T','021','DEN','2134435','99734OH005000401','2014-01-01','2013-12-19 11:18:49','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:17'),(24196,19219,'Y','18','021','EC','A','','','AC','0000463284','0000463284','OH00001927950','IL','1','Schroeder','Lauren','','','','34','268863425','3431 PAXTON AVE',0,'CINCINNATI','OH','45208','2347','CY','39061','1985-01-20','F','U',':RET:2106-3','N','021','DEN','2698399','99734OH005000301','2014-03-01','2014-02-15 20:49:31','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-16 19:00:16'),(23225,18515,'Y','18','021','EC','A','','','AC','0001173261','0001173261','OH00002621087','IL','1','Nelson','Alyse','','','','34','282482442','3840 W 128TH ST',0,'CLEVELAND','OH','44111','4511','CY','39035','1952-01-21','F','M',':RET:2106-3','T','021','HLT','3831505','92036OH004000801','2014-03-01','2014-02-12 15:23:36','387.00',NULL,NULL,'621.12','234.12','R-OH011','OH0','621.12',NULL,0,'2014-02-12 21:32:21'),(20765,16589,'Y','18','024','14','A','','','TE','0000432769','0000432769','','IL','1','Quinter','Alicia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-15','F','',NULL,NULL,NULL,'','2405293','','2014-01-30','2014-01-30 18:06:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:36'),(411,339,'Y','18','021','EC','A','','','AC','0000160754','0000160754','OH00000274976','IL','1','Wilson','Melody','Gayle','','','34','290462183','747 EVERGREEN PL',0,'LOVELAND','OH','45140','9193','CY','39025','1954-02-18','F','U',':RET:2106-3','N','021','DEN','193746','99734OH005000401','2014-01-01','2013-12-04 15:15:43','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 17:46:25'),(7629,6038,'Y','18','021','EC','A','','','AC','0001207109','0001207109','OH00000168560','IL','1','Schroer','Timothy','','','','34','293824845','209 an a half E Mechanic St',0,'Wapakoneta','OH','45895',NULL,'CY','39011','1977-06-08','M','U',':RET:2106-3','N','021','HLT','1166849','92036OH005001501','2014-01-01','2013-11-17 15:44:36','0.00',NULL,NULL,'270.71','270.71','R-OH002','OH0','270.71',NULL,0,'2013-12-26 02:46:10'),(8109,6414,'N','01','021','EC','A',NULL,NULL,'','0001157555','0000112922','','IL','1','RICE','DANIEL','SCOTT','','Jr','34','283584617','14808 DAY RD',0,'MOUNT ORAB','OH','45154','8332','CY','39015','1971-02-04','M','',':RET:2106-3','N','021','HLT','2300444','92036OH003000605','2014-01-01','2013-12-20 17:16:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','297.05',NULL,0,'2013-12-26 03:11:03'),(14409,11491,'Y','18','021','EC','A','','','AC','0000867606','0000867606','TX00001343380','IL','1','Day','Matthew','Wayne','','','34','466933983','5707 SHADY HILL LN',0,'ARLINGTON','TX','76016','2122','CY','48439','1978-06-21','M','U',':RET:2106-3','N','021','DEN','1981811','33348TX002000101','2014-02-01','2013-12-26 18:40:14','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-28 03:31:23'),(20212,16127,'Y','18','021','EC','A','','','AC','0000114235','0000114235','OH00002307345','IL','1','Ervine','Minnie','','','','34','224881193','712 CLIFFSIDE DR',0,'AKRON','OH','44313','5610','CY','39153','1966-12-06','F','M',':RET:2054-5','N','021','HLT','3484460','52664OH151001501','2014-03-01','2014-01-27 12:15:31','0.00',NULL,NULL,'418.05','418.05','R-OH012','OH0','418.05',NULL,0,'2014-01-27 21:01:38'),(5896,4674,'N','19','021','EC','A',NULL,NULL,'','0001071787','0000795520','','S1','1','Clark','DeShon','','','','34','117213051','8025 VEGAS CIR',0,'WEST CHESTER','OH','45069','9291','CY','39017','2013-05-01','M','',':RET:2054-5','N','021','DEN','1411608','99734OH005000301','2014-01-01','2013-12-23 23:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:44'),(17045,13638,'N','01','021','EC','A',NULL,NULL,'','0000518432','0000872065','','IL','1','Nuss','Thomas','','','','34','294564294','1143 S. Cleve-Mass Rd',0,'Copley','OH','44321',NULL,'CY','39153','1955-02-23','M','',':RET:2106-3','N','021','HLT','2060030','52664OH151001501','2014-02-01','2014-01-09 16:02:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','681.50',NULL,0,'2014-01-13 02:20:53'),(16548,13238,'Y','18','021','EC','A','','','AC','0001207173','0001207173','LA00002053260','IL','1','Sturgis','Shelia','','','','34','428195724','13B Airlie St.',0,'Harvey','LA','70058',NULL,'CY','22051','1963-11-02','F','U',':RET:2054-5','N','021','DEN','1533569','18575LA002000101','2014-02-01','2014-01-05 13:19:55','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-07 10:22:37'),(7930,6271,'Y','18','021','EC','A','','','AC','0001857586','0001857586','LA00000681077','IL','1','DOMINGUE','GLENDA','','','','34','439786879','124 HARRISON DR',0,'LAFAYETTE','LA','70507','5524','CY','22055','1951-08-02','F','M',':RET:2106-3','N','021','DEN','2588502','18575LA002000201','2014-01-01','2013-12-20 09:21:09','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 03:06:35'),(13551,10806,'Y','18','021','EC','A','','','AC','0001571159','0001571159','LA00000214218','IL','1','Napoli','Karen','','','','34','434021453','59010 Postell Avenue',0,'Plaquemine','LA','70764',NULL,'CY','22047','1954-08-14','F','U',':RET:2106-3','N','021','DEN','2252628','18575LA002000201','2014-01-01','2013-12-23 15:10:55','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 13:04:05'),(28391,22462,'N','19','021','EC','A',NULL,NULL,'','0000498238','0000222461','','S1','1','Lantz','Michael','','','','34','300154765','701 RUDOLPH AVE',0,'CUYAHOGA FALLS','OH','44221','1939','CY','39153','2010-08-14','M','',NULL,'N','021','HLT','3434437','52664OH152000901','2014-04-01','2014-03-07 17:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-07 21:30:45'),(6196,4909,'Y','18','021','EC','A','','','AC','0000047026','0000047026','TX00000830245','IL','1','Stanley','Melissa','','','','34','454735559','1801 Edgewood',0,'Bridgeport','TX','76426',NULL,'CY','48497','1980-05-31','F','U',':RET:2106-3','N','021','DEN','700651','33348TX002000201','2014-01-01','2013-10-23 15:27:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:30:27'),(25928,20561,'N','01','021','EC','A',NULL,NULL,'','0000318486','0000621744','','IL','1','TREVIZO','DORA','','','','34','520983085','4522 W LOOP 281',0,'LONGVIEW','TX','75604','5873','CY','48183','1964-12-31','F','',NULL,'N','021','DEN','3796193','33348TX002000201','2014-03-01','2014-02-26 16:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:24'),(5347,4241,'Y','18','021','EC','A','','','AC','0000577312','0000577312','OH00000294995','IL','1','Dent','Paul','','','','34','236844091','1282 Eastern Ave',0,'Wooster','OH','44691',NULL,'CY','39169','1951-12-20','M','M',':RET:2106-3','T','021','HLT','1637064','52664OH152000901','2014-01-01','2013-12-19 10:29:07','324.00',NULL,NULL,'539.67','215.67','R-OH014','OH0','539.67',NULL,0,'2013-12-25 23:07:32'),(4987,3959,'N','19','021','EC','A',NULL,NULL,'','0000136048','0000754542','','IL','1','Taylor','LeTrel','J','','','34','287968699','352 Enos Loomis st',0,'Pataskala','OH','43062',NULL,'CY','39089','1993-08-20','M','',NULL,'N','021','DEN','667559','99734OH005000301','2014-01-01','2013-12-06 19:55:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:52'),(20236,16146,'Y','18','024','14','A','','','TE','0000746848','0000746848','','IL','1','Driskell','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-12-21','F','',NULL,NULL,NULL,'','1576641','','2014-01-28','2014-01-28 04:43:58',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-28 21:00:05'),(9103,7226,'Y','18','021','EC','A','','','AC','0000430263','0000430263','OH00001138729','IL','1','Lewis','Robin','','','','34','270505551','3225 LAUREL RD',0,'BRUNSWICK','OH','44212',NULL,'CY','39103','1957-10-01','F','R',':RET:2106-3','N','021','DEN','2569184','99734OH005000301','2014-01-01','2013-12-18 15:21:41','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:07:27'),(9074,7202,'N','19','021','EC','A',NULL,NULL,'','0001212335','0001239110','','IL','1','Gohs','Thomas','','','','34','277119598','5202 PARLOR CT',0,'MASON','OH','45040','2935','CY','39165','2005-03-15','M','',NULL,'N','021','DEN','2606601','99734OH005000301','2014-01-01','2013-12-17 19:16:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:06:42'),(2209,1819,'N','01','021','EC','A',NULL,NULL,'','0000940831','0000775076','','IL','1','Wallace','Dora','','','','34','268521663','4936 SHERMAN WOOD DR',0,'KENT','OH','44240','7049','CY','39133','1951-01-04','F','',':RET:2106-3','N','021','HLT','222793','52664OH151001304','2014-01-01','2013-12-10 14:13:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','640.70',NULL,0,'2013-12-25 19:20:15'),(27542,21786,'N','19','021','EC','A',NULL,NULL,'','0000669236','0001010268','','S3','1','STITT','PAUL','','','','34','301067282','407 INDIANA AVE',0,'MC DONALD','OH','44437','1923','CY','39155','2002-07-07','F','',':RET:2106-3','N','021','DEN','3976455','99734OH005000401','2014-04-01','2014-03-04 11:45:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:07'),(14182,11307,'Y','18','024','14','A','','','TE','0000243618','0000243618','','IL','1','Davis','Dotzie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-11-22','F','',NULL,NULL,NULL,'','439089','','2013-12-26','2013-12-26 10:37:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-27 02:03:44'),(13923,11103,'Y','18','024','14','A','','','TE','0000254503','0000254503','','IL','1','Egli','Paul',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-04','M','',NULL,NULL,NULL,'','25791','','2013-12-23','2013-12-23 13:20:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:14:13'),(1949,1589,'Y','18','021','EC','A','','','AC','0000300369','0000300369','OH00000748402','IL','1','Campbell','Emily','','','','34','288881383','89 N HAWKINS AVE',0,'AKRON','OH','44313','6423','CY','39153','1987-12-03','F','U',':RET:2106-3','N','021','HLT','770405','52664OH151001306','2014-01-01','2013-11-19 20:03:08','183.00',NULL,NULL,'228.36','45.36','R-OH012','OH0','228.36',NULL,0,'2013-12-25 19:00:55'),(17788,14210,'Y','18','021','EC','A','','','AC','0000498183','0000498183','OH00002331817','IL','1','Fisher','William','','','','34','297721016','4444 STATE ROUTE 763',0,'RIPLEY','OH','45167','8201','CY','39015','1975-02-20','M','M',':RET:2106-3','T','021','HLT','2328944','92036OH003000605','2014-02-01','2014-01-13 14:47:36','266.00',NULL,NULL,'613.14','347.14','R-OH005','OH0','321.25',NULL,0,'2014-01-14 01:33:46'),(17829,14243,'Y','18','021','EC','A','','','AC','0001046505','0001046505','MS00001854919','IL','1','hardy','shana','','','','34','587637682','142 COLLINWOOD LN',0,'BRANDON','MS','39042','9147','CY','28121','1981-12-21','F','M',':RET:2106-3','N','021','DEN','2572682','46300MS002000201','2014-02-01','2014-01-14 14:20:59','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-15 02:05:59'),(28326,22413,'Y','18','024','14','A','','','TE','0000872922','0000872922','','IL','1','Denbow','Jayna','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-20','F','',NULL,NULL,NULL,'','3860455','','2014-03-07','2014-03-07 00:24:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-07 21:30:08'),(8858,7022,'N','01','021','EC','A',NULL,NULL,'','0001087223','0000861767','','IL','1','Howlett','Helen','L','','','34','587786439','729 Broadway Commons',0,'Garland','TX','75043',NULL,'CY','48113','1951-04-14','F','',':RET:2054-5','N','021','DEN','1379106','33348TX002000201','2014-01-01','2013-12-18 10:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 04:01:12'),(26581,21075,'Y','18','021','EC','A','','','AC','0000142883','0000142883','OH00002408214','IL','1','BELOW','MARY','','','','34','290520015','1120 LEE AVE',0,'PORT CLINTON','OH','43452',NULL,'CY','39123','1950-07-25','F','M',':RET:2106-3','N','021','DEN','2722557','99734OH005000401','2014-04-01','2014-02-28 14:07:11','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-28 21:30:30'),(440,362,'Y','18','021','EC','A','','','AC','0001144745','0001144745','OH00001197637','IL','1','Kundrach','Marghrettia','','','','34','232805237','9381 WILLOW RD',0,'LODI','OH','44254','9629','CY','39103','1949-03-24','F','M',':RET:2106-3','N','021','DEN','745758','99734OH005000401','2014-01-01','2013-12-04 11:10:19','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:47:09'),(24799,19666,'N','01','021','EC','A',NULL,NULL,'','0000984904','0000843385','','IL','1','MCGOWAN','HOWARD','GERALD','','','34','302765445','1009 3RD ST',0,'MARIETTA','OH','45750','1836','CY','39167','1980-12-23','M','',NULL,'T','021','DEN','3100708','99734OH005000401','2014-04-01','2014-02-19 16:30:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:47:47'),(24099,19157,'Y','18','021','EC','A','','','AC','0000672411','0000672411','TX00002495726','IL','1','Beall','Sandra','','','','34','452735641','200 Bostic Drive',0,'Longview','TX','75602',NULL,'CY','48183','1969-10-16','F','U',':RET:2054-5','N','021','DEN','2914064','33348TX002000201','2014-03-01','2014-02-14 23:17:36','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-15 22:01:29'),(4666,3699,'Y','18','021','EC','A','','','AC','0000599566','0000599566','LA00000213640','IL','1','Johnson','Della','','','','34','436885585','830 Guyton Road',0,'West Monroe','LA','71292',NULL,'CY','22073','1952-06-17','F','M',':RET:2106-3','N','021','DEN','330676','18575LA002000201','2014-01-01','2013-12-12 12:58:20','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:07:29'),(21506,17181,'Y','18','021','EC','A','','','AC','0000363813','0000363813','OH00001954348','IL','1','Crill','Douglas','L','','','34','302429569','516 LimeCity Road',0,'Rossford','OH','43460',NULL,'CY','39173','1949-10-09','M','U',':RET:2106-3','N','021','HLT','2091841','92036OH004002601','2014-03-01','2014-02-04 14:13:02','380.00',NULL,NULL,'470.37','90.37','R-OH001','OH0','470.37',NULL,0,'2014-02-04 21:01:55'),(18128,14478,'Y','18','021','EC','A','','','AC','0000073961','0000073961','OH00002285259','IL','1','Ker','Tanya','','','','34','287740884','423 SANDRA DR',0,'OXFORD','OH','45056','2542','CY','39017','1963-01-14','F','U',':RET:2106-3','N','021','HLT','2576820','92036OH004001201','2014-02-01','2014-01-14 14:56:50','0.00',NULL,NULL,'776.76','776.76','R-OH004','OH0','321.93',NULL,0,'2014-01-15 02:07:42'),(27885,22059,'Y','18','021','EC','A','','','AC','0001051965','0001051965','OH00002728229','IL','1','Smith','Charles','A','','','34','291683214','2372 LAWRENCE AVE',0,'TOLEDO','OH','43620','1045','CY','39095','1961-02-14','M','U',':RET:2054-5','T','021','HLT','3414731','92036OH005002601','2014-04-01','2014-03-05 14:15:18','123.00',NULL,NULL,'457.46','334.46','R-OH001','OH0','457.46',NULL,0,'2014-03-05 21:32:35'),(13421,10708,'Y','18','021','EC','A','','','AC','0000141509','0000141509','OH00000592971','IL','1','Dale','Brenda','','','','34','300704406','9959 INDUSTRIAL PKWY',0,'PLAIN CITY','OH','43064','8731','CY','39159','1960-10-30','F','U',NULL,'N','021','DEN','1727562','99734OH005000301','2014-01-01','2013-12-23 11:19:29','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:00:49'),(13342,10654,'Y','18','021','EC','A','','','AC','0000968339','0000968339','TX00000954161','IL','1','Wynns','Linda','','','','34','446521441','5301 Alpha Rd.',0,'Dallas','TX','75240',NULL,'CY','48113','1950-02-03','F','U',':RET:2106-3','N','021','DEN','2150886','33348TX002000201','2014-01-01','2013-12-23 18:25:45','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 12:58:57'),(26449,20979,'N','01','021','EC','A',NULL,NULL,'','0000625469','0000664228','','IL','1','Kreakie','Catherine','Renee','','','34','279843734','1882 BROOKWOOD CT',0,'ORRVILLE','OH','44667','2368','CY','39169','1985-01-22','F','',':RET:2106-3','N','021','HLT','3614778','52664OH152000901','2014-04-01','2014-02-26 19:45:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.78','CIC',0,'2014-02-28 07:30:25'),(25029,19847,'Y','18','021','EC','A','','','AC','0000949177','0000949177','TX00002199471','IL','1','buster','ardella','','','','34','452886806','16026 BEECHNUT ST',0,'HOUSTON','TX','77083','5316','CY','48157','1950-01-24','F','U',':RET:2054-5','N','021','DEN','2910615','33348TX002000101','2014-04-01','2014-02-20 17:19:11','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-20 22:01:02'),(7680,6081,'N','19','021','EC','A',NULL,NULL,'','0000767386','0000119052','','IL','1','TURNER','BRANDON','M','','','34','272068549','4362 CHERRYHURST DR',0,'STOW','OH','44224','2747','CY','39153','2000-11-19','M','',NULL,'N','021','DEN','2276263','99734OH005000401','2014-01-01','2013-12-19 19:29:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:00:47'),(18027,14400,'Y','18','021','EC','A','','','AC','0001237727','0001237727','OH00002565458','IL','1','Heiser','Michael','','','','34','289428349','5615 DRAKE RD',0,'PIQUA','OH','45356','8307','CY','39109','1950-10-01','M','M',':RET:2106-3','N','021','DEN','2393483','99734OH005000301','2014-02-01','2014-01-14 14:03:49','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:07:07'),(7087,5621,'N','01','021','EC','A',NULL,NULL,'','0000183506','0000618372','','IL','1','Devereux','Thericia','Irene','','','34','299647162','188 NORTHPARK DR',0,'WADSWORTH','OH','44281','1310','CY','39103','1957-08-30','F','',':RET:2106-3','N','021','HLT','2532631','52664OH152000901','2014-01-01','2013-12-24 21:43:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','381.07',NULL,0,'2013-12-26 01:50:26'),(26674,21147,'N','01','021','EC','A',NULL,NULL,'','0002282464','0002065307','','IL','1','REESE','CHARLES','','','','34','439570323','2034 SHERWOOD MEADOW DR',0,'BATON ROUGE','LA','70816','8549','CY','22033','1985-03-25','M','',':RET:2054-5','T','021','DEN','3102214','18575LA002000201','2014-04-01','2014-02-28 11:55:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-28 21:31:20'),(25259,20038,'Y','18','021','EC','A','','','AC','0001162653','0001162653','OH00003138242','IL','1','Funtulis','Kelli','','','','34','292929578','1263 GUARNIERI DR NE',0,'WARREN','OH','44483','4248','CY','39155','1984-10-19','F','U',':RET:2106-3','N','021','DEN','2882978','99734OH005000401','2014-04-01','2014-02-22 10:10:22','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00','CIC',0,'2014-02-22 19:00:12'),(7429,5879,'Y','18','024','14','A','','','TE','0001097761','0001097761','','IL','1','Preto','Vickie','Renee',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-26','F','',NULL,NULL,NULL,'','550597','','2013-12-14','2013-12-14 18:14:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:30:06'),(24315,19310,'Y','18','021','EC','A','','','AC','0000525592','0000525592','TX00002563745','IL','1','Thomas','Alica','','','','34','452954900','1350 Yorkshire St',0,'Fort Worth','TX','76134',NULL,'CY','48439','1981-08-05','F','U',':RET:2054-5','N','021','DEN','3263025','33348TX002000201','2014-04-01','2014-02-18 09:32:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-18 22:00:04'),(20376,16277,'Y','18','021','EC','A','','','AC','0000977738','0000977738','TX00002265356','IL','1','earle','quynton','','','','34','461514583','3119 LINCOLN AVE',0,'FORT WORTH','TX','76106','5615','CY','48439','1979-03-30','M','U',':RET:2054-5','N','021','DEN','2521586','33348TX002000201','2014-03-01','2014-01-28 18:34:23','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:08'),(14002,11155,'Y','18','021','EC','A','','','AC','0000974089','0000974089','OH00000456492','IL','1','ruhlman','geri','','','','34','262279466','800 DANAN CIR',0,'DAYTON','OH','45429','1301','CY','39113','1956-01-17','F','M',':RET:2106-3','N','021','HLT','1718760','92036OH004000501','2014-01-01','2013-12-23 08:33:56','0.00',NULL,NULL,'465.80','465.80','R-OH003','OH0','465.80',NULL,0,'2013-12-26 13:16:05'),(19951,15914,'Y','18','021','EC','A','','','AC','0002022997','0002022997','LA00001378344','IL','1','Coons','Lindsey','','','','34','044901147','7634 ZIMPEL ST',0,'NEW ORLEANS','LA','70118','5024','CY','22071','1991-08-31','F','U',':RET:2106-3','N','021','DEN','1437644','18575LA002000201','2014-03-01','2014-01-24 23:02:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-25 19:00:03'),(22043,17596,'Y','18','021','EC','A','','','AC','0000640964','0000640964','OH00001560593','IL','1','De Jesus','Elsa',NULL,NULL,NULL,NULL,NULL,'5140 douglas rd',0,'toledo','OH','43613',NULL,'CY','39095','1961-06-07','F','U',NULL,'N','021','HLT','2700332','92036OH005002606','2014-03-01','2014-02-07 17:33:35','309.00',NULL,NULL,'380.63','71.63','R-OH001','OH0','380.63',NULL,0,'2014-02-07 19:01:10'),(22577,18031,'N','01','021','EC','A',NULL,NULL,'','0000844739','0000683427','','IL','1','munz','paul','','','','34','302687133','4 CHOCTAW LN',0,'MILFORD','OH','45150','1604','CY','39025','1966-03-23','M','',':RET:2106-3','N','021','HLT','3810767','92036OH005000604','2014-03-01','2014-02-10 14:06:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','335.54',NULL,0,'2014-02-10 21:32:00'),(23418,18659,'Y','18','021','EC','A','','','AC','0000347691','0000347691','TX00001968233','IL','1','Jaimes','Efrain','','','','34','629701456','1954 Hwy 7 E',0,'CENTER','TX','75935',NULL,'CY','48419','1986-11-13','M','U',NULL,'N','021','DEN','3674721','33348TX002000201','2014-03-01','2014-02-12 21:12:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:20'),(25500,20230,'Y','18','021','EC','A','','','AC','0000151915','0000151915','TX00003287709','IL','1','KEARNEY','ALECERA','','','','34','449497787','1509 CRESTMONT ST',0,'WHARTON','TX','77488','3430','CY','48481','1979-01-03','F','U',NULL,'N','021','DEN','2806469','33348TX002000101','2014-04-01','2014-02-25 12:46:04','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-25 21:31:54'),(28062,22206,'N','01','021','EC','A',NULL,NULL,'','0000393737','0000901132','','IL','1','LWIN','EI','','','','34','097555851','305 S LOCUST ST',0,'OXFORD','OH','45056','2170','CY','39017','1978-06-04','F','',NULL,'N','021','DEN','4086888','99734OH005000301','2014-04-01','2014-03-05 23:21:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:44'),(1014,831,'Y','18','021','EC','A','','','AC','0000694370','0000694370','MS00000010926','IL','1','PRESTON','ARMETHIA','','','','34','587802196','12391 HOLLIMAN CIR',0,'GULFPORT','MS','39503','5573','CY','28047','1949-07-15','F','M',':RET:2054-5','N','021','DEN','1007367','46300MS002000201','2014-01-01','2013-12-02 20:46:12','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-25 18:15:04'),(17148,13721,'Y','18','021','EC','A','','','AC','0001278408','0001278408','LA00001297985','IL','1','castro','christian','','','','34','434953468','3810 CANTERBURY LN',0,'METAIRIE','LA','70001','1717','CY','22051','1979-08-19','M','M',NULL,'N','021','DEN','2108299','18575LA002000201','2014-02-01','2014-01-07 20:30:08','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:55'),(8010,6340,'Y','18','024','14','A','','','TE','0000033183','0000033183','','IL','1','Roubique','Ronald','W',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-01-26','M','',NULL,NULL,NULL,'','188377','','2013-12-20','2013-12-20 16:32:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 03:08:37'),(7682,6083,'Y','18','021','EC','A','','','AC','0000047081','0000047081','OH00000919266','IL','1','Kaye','Megan','Tatiana','','','34','276044654','19201 CHEROKEE AVE',0,'CLEVELAND','OH','44119','2132','CY','39035','1987-09-23','F','M',':RET:2106-3','N','021','DEN','2074869','99734OH005000401','2014-01-01','2013-12-19 19:34:01','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:00:49'),(13361,10671,'Y','18','021','EC','A','','','AC','0001207154','0001207154','OH00000696295','IL','1','Lignoski','Nancy','','','','34','208664017','960 HESSEL DR',0,'AKRON','OH','44313','5804','CY','39153','1979-04-07','F','U',':RET:2106-3','N','021','DEN','2366848','99734OH005000301','2014-01-01','2013-12-22 19:56:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:59:27'),(6293,4991,'Y','18','021','EC','A','','','AC','0000894605','0000894605','OH00000557662','IL','1','Grenier','James','','','','34','296526607','7944 SOLITUDE DR',0,'WESTERVILLE','OH','43081','5808','CY','39049','1959-11-07','M','U',':RET:2106-3','N','021','DEN','693748','99734OH005000401','2014-01-01','2013-12-11 07:55:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:45:43'),(6716,5326,'Y','18','021','EC','A','','','AC','0000940823','0000940823','OH00001310615','IL','1','Ferrell','Barbara','','','','34','294728924','2249 E MARKET ST',0,'AKRON','OH','44312','1244','CY','39153','1964-09-01','F','U',':RET:2106-3','N','021','DEN','436026','99734OH005000401','2014-01-01','2013-11-25 11:16:42','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:15:03'),(21220,16957,'Y','18','021','EC','A','','','AC','0001506573','0001506573','LA00001466228','IL','1','MARKEY','JEFFREY','','','','34','156740080','4601 SEMINARY  PLACE',0,'NEW ORLEANS','LA','70126',NULL,'CY','22071','1982-09-10','M','M',NULL,'N','021','DEN','3100318','18575LA002000201','2014-03-01','2014-02-03 16:00:06','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:01:03'),(24561,19507,'N','19','021','EC','A',NULL,NULL,'','0000737910','0000699324','','IL','1','grubb','brandon','','','','34','289028975','13694 donald drive',0,'brook park','OH','44142',NULL,'CY','39035','1997-12-01','M','',':RET:2106-3','N','021','DEN','3335829','99734OH005000301','2014-04-01','2014-02-18 20:59:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:06:16'),(25719,20400,'Y','18','021','EC','A','','','AC','0000712523','0000712523','TX00002977577','IL','1','David','Allen','','','','34','459671628','33567 FM 521',0,'BAY CITY','TX','77414','3367','CY','48321','1983-12-24','M','U',':RET:2054-5','N','021','DEN','3007438','33348TX002000201','2014-04-01','2014-02-24 17:09:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:27'),(27458,21731,'Y','18','024','14','A','','','TE','0000701759','0000701759','','IL','1','Quidgeon','Brittany',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-03-29','F','',NULL,NULL,NULL,'','3055381','','2014-03-04','2014-03-04 12:07:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:04'),(27581,21812,'Y','18','024','14','A','','','TE','0000348881','0000348881','','IL','1','Curry','Matthew','William',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-12-03','M','',NULL,NULL,NULL,'','1700790','','2014-03-31','2014-03-05 10:34:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:11'),(28776,22778,'N','01','021','EC','A',NULL,NULL,'','0001241932','0000789723','','IL','1','STAIRS','COURTNEY','NICHOLE','','','34','287829404','14 W PARK DR',0,'SHELBY','OH','44875','1427','CY','39139','1984-07-10','F','',':RET:2106-3','N','021','DEN','3350780','99734OH005000401','2014-04-01','2014-03-09 13:18:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-09 21:00:32'),(28962,22922,'Y','18','021','EC','A','','','AC','0001812280','0001812280','LA00003492474','IL','1','HOLMES','ANDRE','','','','34','438028590','7825 DOLLY ST',0,'WESTWEGO','LA','70094','4050','CY','22051','1961-12-07','F','M',NULL,'N','021','DEN','3336403','18575LA002000201','2014-04-01','2014-03-10 13:36:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-10 21:00:57'),(2214,1824,'Y','18','021','EC','A','','','AC','0001029340','0001029340','OH00001236588','IL','1','Schrack','Curtis','','','','34','297781975','1432 CHIPPEWA AVE',0,'AKRON','OH','44305','2706','CY','39153','1966-06-07','M','M',NULL,'N','021','HLT','702067','52664OH151001305','2014-01-01','2013-12-10 16:39:32','447.00',NULL,NULL,'651.18','204.18','R-OH012','OH0','348.56',NULL,0,'2013-12-25 19:20:22'),(16820,13453,'Y','18','021','EC','A','','','AC','0000301231','0000301231','TX00001407265','31','1','ROSAS','VANESSA','','','','34','639329045','4636 ALBATROSS DRIVE',0,'GRANDBURY','TX','76049',NULL,'CY','48221','1992-09-06','F','M',':RET:2106-3','N','021','DEN','2274244','33348TX002000101','2014-02-01','2014-01-11 12:53:25','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-13 02:18:21'),(15579,12466,'Y','18','021','EC','A','','','AC','0001217384','0001217384','OH00001107896','IL','1','TAYLOR','DIAMOND','','','','34','280020834','1876 WYMORE AVE',0,'CLEVELAND','OH','44112','3914','CY','39035','1997-05-27','F','R',':RET:2054-5','N','021','HLT','2532790','52664OH151001301','2014-02-01','2013-12-31 17:46:27','0.00',NULL,NULL,'159.71','159.71','R-OH011','OH0','159.71',NULL,1,'2014-01-02 04:32:08'),(6874,5451,'Y','18','021','EC','A','','','AC','0000818534','0000818534','OH00000417624','IL','1','barbee','laquivia','','','','34','397065918','7815 CLOVERNOOK AVE',0,'CINCINNATI','OH','45231','3509','CY','39061','1990-08-31','F','U',':RET:2054-5','N','021','DEN','74004','99734OH005000401','2014-01-01','2013-11-02 19:35:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:32:04'),(2370,1932,'N','01','021','EC','A',NULL,NULL,'','0001230361','0000911744','','IL','1','raymond','alan','b','','','34','299508846','6356 tylers crossing',0,'west chester','OH','45069',NULL,'CY','39017','1951-08-25','M','',NULL,'N','021','DEN','1226279','99734OH005000401','2014-01-01','2013-12-09 09:04:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:32:42'),(9198,7295,'Y','18','021','EC','A','','','AC','0001224453','0001224453','OH00000304024','IL','1','Knitz','Patricia','','','','34','281813390','7045 N TALL OAKS DR',0,'CURTICE','OH','43412','9646','CY','39123','1969-09-22','F','U',':RET:2106-3','T','021','HLT','2587286','92036OH002002701','2014-01-01','2013-12-18 10:17:56','161.00',NULL,NULL,'361.78','200.78','R-OH006','OH0','361.78',NULL,0,'2013-12-26 04:09:33'),(6202,4915,'Y','18','021','EC','A','','','AC','0000463196','0000463196','OH00000487696','IL','1','LINDSAY','KELTON','','','','34','300766023','20 NORTH LN',0,'LEBANON','OH','45036','1861','CY','39165','1980-08-08','M','U',NULL,'T','021','DEN','913317','99734OH005000401','2014-01-01','2013-10-16 10:09:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:30:38'),(6188,4904,'Y','18','021','EC','A','','','AC','0000179207','0000179207','TX00000576821','IL','1','kayati','ray','','','','34','462655797','2157 OLD IRONSIDES RD',0,'ABILENE','TX','79601','4765','CY','48441','1954-02-06','M','M',NULL,'N','021','DEN','682853','33348TX002000101','2014-01-01','2013-10-23 00:51:23','0.00',NULL,NULL,'94.59','94.59','R-TX001','TX0','25.02',NULL,0,'2013-12-26 00:30:16'),(23309,18581,'N','19','021','EC','A',NULL,NULL,'','0000689734','0000021428','','IL','1','Walden','Sophie','','','','34','273116466','405 BANK AVE',0,'CINCINNATI','OH','45217','1214','CY','39061','2000-09-12','F','',':RET:2034-7','N','021','DEN','2721161','99734OH005000301','2014-03-01','2014-02-13 11:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:20'),(23545,18758,'Y','18','021','EC','A','','','AC','0002116202','0002116202','LA00002207463','IL','1','allatto','russell','','','','34','437172424','50211 WHISKEY LN',0,'TICKFAW','LA','70466','2517','CY','22105','1960-05-16','M','M',':RET:2106-3','N','021','DEN','3593609','18575LA002000201','2014-03-01','2014-02-13 13:46:49','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-13 22:02:35'),(24918,19758,'Y','18','021','EC','A','','','AC','0001220837','0001220837','OH00003033367','IL','1','witt','deborah','','','','34','286629709','2062 ROLLING MEADOWS LN',0,'AKRON','OH','44312','4961','CY','39153','1956-12-27','F','M',':RET:2106-3','N','021','HLT','3813609','52664OH151001305','2014-03-01','2014-02-20 14:51:24','372.00',NULL,NULL,'543.47','171.47','R-OH012','OH0','543.47','CIC',0,'2014-02-20 21:30:12'),(27464,21735,'Y','18','021','EC','A','','','AC','0000731254','0000731254','OH00003169474','IL','1','orton','le',NULL,NULL,NULL,NULL,NULL,'2730 STIEGLER RD',0,'VALLEY CITY','OH','44280','9585','CY','39103','1952-01-18','F','M',':RET:2047-9','N','021','HLT','3744709','52664OH152000901','2014-04-01','2014-03-04 17:04:27','431.00',NULL,NULL,'469.28','38.28','R-OH012','OH0','469.28',NULL,0,'2014-03-04 21:02:07'),(27558,21799,'Y','18','021','EC','A','','','AC','0000982460','0000982460','TX00003515380','IL','1','CONNER','KATHY','','','','34','217880029','508 S DALLAS AVE',0,'LANCASTER','TX','75146','1507','CY','48113','1976-03-13','F','U',NULL,'N','021','DEN','3012437','33348TX002000201','2014-04-01','2014-03-04 16:07:03','0.00',NULL,NULL,'56.37','56.37','R-TX008','TX0','15.85','CIC',0,'2014-03-04 21:30:15'),(9585,7590,'Y','18','024','14','A','','','TE','0001146858','0001146858','','IL','1','Hughie','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-08-04','F','',NULL,NULL,NULL,'','1601541','','2013-12-20','2013-12-20 20:00:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 04:37:01'),(18535,14780,'Y','18','021','EC','A','','','AC','0001038633','0001038633','OH00001779486','IL','1','Taraschke','Megan','Marie','','','34','272966643','1811 middlesbrough court',0,'Maumee','OH','43537',NULL,'CY','39095','1992-11-19','F','U',':RET:2106-3','N','021','HLT','2081730','92036OH006002601','2014-02-01','2014-01-15 14:34:05','106.00',NULL,NULL,'154.64','48.64','R-OH001','OH0','154.64',NULL,0,'2014-01-16 08:46:45'),(18184,14518,'Y','18','024','14','A','','','TE','0000877132','0000877132','','IL','1','Nye','Larry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-12-19','M','',NULL,NULL,NULL,'','1541695','','2014-01-14','2014-01-14 11:53:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:08:02'),(5948,4711,'N','01','021','EC','A',NULL,NULL,'','0000584274','0000447465','','IL','1','Warren','Susan','Joey','','','34','405212624','651 FAWCETT RD',0,'PEEBLES','OH','45660','9741','CY','39001','1978-12-17','F','',':RET:2106-3','N','021','HLT','1750130','92036OH003000606','2014-01-01','2013-12-23 21:47:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','273.93',NULL,0,'2013-12-25 23:51:02'),(4415,3507,'N','01','021','EC','A',NULL,NULL,'','0000881602','0000985984','','IL','1','NASH','DOUGLAS','A','','','34','275520843','5237 WILLNET DR',0,'CINCINNATI','OH','45238','4361','CY','39061','1954-02-02','M','',':RET:2106-3','T','021','DEN','338626','99734OH005000401','2014-01-01','2013-12-12 15:11:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:28'),(14488,11558,'N','01','021','EC','A',NULL,NULL,'','0001107691','0000006231','','IL','1','cheatham','keith','','','','34','461020597','355 E Vista Ridge Mall Dr',0,'lewisville','TX','75067',NULL,'CY','48121','1958-01-14','M','',':RET:2054-5','N','021','DEN','2053253','33348TX002000201','2014-02-01','2013-12-27 10:14:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-28 03:33:27'),(22160,17687,'Y','18','021','EC','A','','','AC','0001246982','0001246982','OH00001445263','IL','1','Hartwig','Timothy','','','','34','290584923','6657 Honeysuckle Ln',0,'Maineville','OH','45039',NULL,'CY','39165','1972-01-13','M','M',':RET:2106-3','T','021','HLT','3385475','92036OH005001201','2014-03-01','2014-02-08 13:53:43','0.00',NULL,NULL,'833.10','833.10','R-OH004','OH0','327.11',NULL,0,'2014-02-08 19:00:58'),(24481,19448,'Y','18','021','EC','A','','','AC','0000239077','0000239077','OH00002430802','IL','1','Toft','Carol','','','','34','269568060','326 MIAMI VALLEY DR',0,'LOVELAND','OH','45140','7532','CY','39025','1953-09-06','F','R',':RET:2106-3','N','021','HLT','3343347','92036OH002000601','2014-04-01','2014-02-18 14:45:11','0.00',NULL,NULL,'672.81','672.81','R-OH005','OH0','672.81',NULL,0,'2014-02-18 22:01:45'),(28813,22805,'Y','18','021','EC','A','','','AC','0000559505','0000559505','OH00003808172','IL','1','CALVERT','LAURA','','','','34','274644490','5321 DONNER DRIVE',0,'NEW FRANKLIN','OH','44216',NULL,'CY','39153','1957-07-26','F','U',':RET:2106-3','N','021','HLT','3871781','52664OH151001304','2014-04-01','2014-03-09 15:15:31','609.00',NULL,NULL,'1026.51','417.51','R-OH012','OH0','520.28',NULL,0,'2014-03-09 21:00:55'),(9020,7156,'Y','18','021','EC','A','','','AC','0000191351','0000191351','OH00000418201','IL','1','Berbig','Donna','','','','34','283527184','6844 OAKFIELD NORTH RD NW',0,'BRISTOLVILLE','OH','44402','8716','CY','39155','1953-07-16','F','M',':RET:2106-3','N','021','HLT','2459332','52664OH151001304','2014-01-01','2013-12-17 20:43:31','200.00',NULL,NULL,'686.36','486.36','R-OH013','OH0','686.36',NULL,0,'2013-12-26 04:05:18'),(1052,863,'Y','18','021','EC','A','','','AC','0000847073','0000847073','TX00000574349','IL','1','Jaksik','Michael','','','','34','451942925','427 Marshall',0,'Fredericksburg','TX','78624',NULL,'CY','48171','1949-12-12','M','U',':RET:2106-3','N','021','DEN','1171774','33348TX002000201','2014-01-01','2013-12-03 12:23:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:16:04'),(6405,5077,'Y','18','021','EC','A','','','AC','0000735014','0000735014','OH00000958302','IL','1','Rodriguez','Jeffery','','','','34','272603687','2557 CHERRY LAKE RD',0,'SYLVANIA','OH','43560','8982','CY','39095','1969-11-20','M','M',NULL,'N','021','DEN','288632','99734OH005000301','2014-01-01','2013-12-11 17:49:10','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:48:28'),(14683,11723,'Y','18','021','EC','A','','','AC','0000789671','0000789671','OH00000905648','IL','1','Varner','Jessque','','','','34','264830506','521 Sawyer Blvd',0,'Columbus','OH','43203',NULL,'CY','39049','1973-12-22','F','M',':RET:2106-3','T','021','DEN','2182286','99734OH005000401','2014-02-01','2013-12-28 12:09:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:08:37'),(5756,4571,'Y','18','021','EC','A','','','AC','0000006987','0000006987','OH00000391008','IL','1','Buzzetta','carlo','','','','34','289825635','450 VALLEY DR',0,'MEDINA','OH','44256','2924','CY','39103','1983-07-31','M','U',':RET:2106-3','N','021','DEN','2537340','99734OH005000401','2014-01-01','2013-12-23 21:28:09','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:46:22'),(3741,2992,'Y','18','021','EC','A','','','AC','0000614893','0000614893','TX00001099526','IL','1','Grambling','William','d','','','34','463883768','405 JOHNSON ST',0,'BIG SPRING','TX','79720','2641','CY','48227','1950-04-15','M','U',':RET:2106-3','N','021','DEN','708200','33348TX002000201','2014-01-01','2013-12-13 13:17:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:53'),(4782,3796,'Y','18','021','EC','A','','','AC','0000539926','0000539926','MS00000694521','IL','1','Lumpkin','Milton','','','','34','358682348','956 MOUNT ELAM CHURCH RD',0,'PEARL','MS','39208','9679','CY','28121','1980-07-26','M','U',':RET:2054-5','N','021','DEN','842430','46300MS002000101','2014-01-01','2013-12-07 21:32:10','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 22:16:09'),(18992,15128,'Y','18','021','EC','A','','','AC','0000848379','0000848379','OH00002534884','IL','1','Machnikowski','Lindsay','','','','34','297887057','3566 ELM RD',0,'STOW','OH','44224','3910','CY','39153','1986-09-17','F','U',':RET:2106-3','N','021','HLT','2677667','52664OH151001305','2014-03-01','2014-01-17 11:52:20','148.00',NULL,NULL,'233.71','85.71','R-OH012','OH0','233.71',NULL,0,'2014-01-20 08:06:11'),(19930,15894,'Y','18','024','14','A','','','TE','0000631949','0000631949','','IL','1','Rainwater','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-04-12','F','',NULL,NULL,NULL,'','883814','','2014-01-24','2014-01-24 03:21:42',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-24 21:01:08'),(21718,17343,'Y','18','021','EC','A','','','AC','0000580017','0000580017','OH00001606407','IL','1','SMITH','ANGIE','','','','34','293823712','555 BOURBON STREET',0,'BLANCHESTER','OH','45107',NULL,'CY','39027','1969-04-03','F','M',NULL,'N','021','HLT','3059758','92036OH003000605','2014-03-01','2014-02-05 14:35:37','500.00',NULL,NULL,'636.90','136.90','R-OH005','OH0','313.18',NULL,0,'2014-02-05 21:31:18'),(22941,18289,'N','01','021','EC','A',NULL,NULL,'','0000259277','0000200804','','IL','1','whitaker','vicki','e','','','34','275644809','607 W WILLIAM ST',0,'MAUMEE','OH','43537','2061','CY','39095','1959-05-23','F','',':RET:2106-3','T','021','HLT','3115491','92036OH004002601','2014-03-01','2014-02-10 22:31:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','384.97','CIC',0,'2014-02-11 21:30:19'),(27411,21696,'N','17','021','EC','A',NULL,NULL,'','0001124133','0000020239','','S3','1','Gandy','Stephanie','Marie','','','34','285085280','3090 Livingston Rd',0,'Cleveland','OH','44120',NULL,'CY','39035','2003-08-12','M','',':RET:2054-5^:RET:2106-3','N','021','DEN','2943428','99734OH005000301','2014-04-01','2014-03-04 14:21:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:35'),(13052,10406,'Y','18','021','EC','A','','','AC','0001075301','0001075301','OH00001107556','IL','1','Danner','David','','','','34','299649604','3320 EUCLID HEIGHTS BLVD',0,'CLEVELAND HTS','OH','44118','1822','CY','39035','1958-09-02','M','U',':RET:2106-3','N','021','DEN','2350448','99734OH005000401','2014-01-01','2013-12-23 09:06:33','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:50:53'),(17974,14362,'Y','18','021','EC','A','','','AC','0000672780','0000672780','OH00001441959','IL','1','Nemeth','Barbara','','','','34','277766615','3062 ALEXA CT',0,'TWINSBURG','OH','44087','4207','CY','39153','1966-10-05','F','U',':RET:2106-3','N','021','HLT','2798188','52664OH151001305','2014-02-01','2014-01-14 11:50:20','240.00',NULL,NULL,'348.56','108.56','R-OH012','OH0','348.56',NULL,0,'2014-01-15 02:06:50'),(4597,3640,'Y','18','021','EC','A','','','AC','0000844689','0000844689','OH00001100863','IL','1','HALES','KIMBERLY','S','','','34','281746874','664 COUNTY ROAD 40',0,'SULLIVAN','OH','44880',NULL,'CY','39005','1963-05-12','F','U',':RET:2106-3','N','021','HLT','110460','52664OH151001306','2014-01-01','2013-12-12 15:50:01','377.00',NULL,NULL,'398.29','21.29','R-OH012','OH0','398.29',NULL,0,'2013-12-25 22:05:37'),(17635,14099,'N','19','021','EC','A',NULL,NULL,'','0001258678','0000592177','','IL','1','Kessler','Maya','Menucha','','','34','381411523','4286 UNIVERSITY PKWY',0,'UNIVERSITY HEIGHTS','OH','44118','3943','CY','39035','2012-02-16','F','',':RET:2106-3','N','021','DEN','1360427','99734OH005000301','2014-02-01','2014-01-12 19:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:35'),(27060,21425,'Y','18','021','EC','A','','','AC','0001207198','0001207198','LA00003579474','IL','1','highstreet','sara','','','','34','435814746','1817 BURDETTE ST',0,'NEW ORLEANS','LA','70118','4106','CY','22071','1985-12-29','F','M',':RET:2106-3','N','021','DEN','3212380','18575LA002000201','2014-04-01','2014-03-03 06:25:14','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-03 21:29:59'),(1220,1003,'Y','18','021','EC','A','','','AC','0000149316','0000149316','OH00001001982','IL','1','CALKINS','MAXINE','','','','34','298785097','4709 W 158TH ST',0,'CLEVELAND','OH','44135','2607','CY','39035','1979-05-24','F','U',':RET:2106-3','N','021','HLT','815872','52664OH151001305','2014-01-01','2013-12-03 18:10:48','162.00',NULL,NULL,'305.34','143.34','R-OH011','OH0','305.34',NULL,0,'2013-12-25 18:20:23'),(24222,19236,'Y','18','021','EC','A','','','AC','0000984923','0000984923','TX00002186404','IL','1','Bauer','Nicholas','','','','34','492824467','112 WILLIAMSON DR',0,'BRYAN','TX','77801','1925','CY','48041','1979-04-18','M','M',':RET:2054-5^:RET:2106-3','N','021','DEN','3259669','33348TX002000201','2014-04-01','2014-02-16 10:46:49','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-16 19:00:29'),(22037,17591,'Y','18','021','EC','A','','','AC','0001059513','0001059513','OH00002232546','IL','1','Danzig','Diane','','','','34','295567652','16925 Sharp Rd.',0,'Sidney','OH','45365',NULL,'CY','39149','1953-10-27','F','U',':RET:2106-3','N','021','HLT','2675527','92036OH003000504','2014-03-01','2014-02-07 16:26:54','451.00',NULL,NULL,'673.71','222.71','R-OH003','OH0','673.71',NULL,0,'2014-02-07 19:01:06'),(1602,1340,'Y','18','021','EC','A','','','AC','0000526806','0000526806','TX00000791274','IL','1','sandoval','brenda','v','','','34','518805382','2113 E 26TH ST',0,'WESLACO','TX','78596','8585','CY','48215','1972-08-19','F','U',NULL,'N','021','DEN','2546289','33348TX002000201','2014-01-01','2013-12-24 12:41:07','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:52:04'),(18501,14756,'N','01','021','EC','A',NULL,NULL,'','0000570582','0000524514','','IL','1','Grimm','Tammy','','','','34','272762011','191 GRANDVIEW AVE',0,'WADSWORTH','OH','44281','1156','CY','39103','1965-04-18','F','',':RET:2106-3','N','021','HLT','1938581','52664OH151001306','2014-02-01','2014-01-15 16:49:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','364.62',NULL,0,'2014-01-16 08:46:29'),(8964,7111,'Y','18','021','EC','A','','','AC','0000109267','0000109267','OH00000697443','IL','1','Chau','Lynn','','','','34','364963807','5571 sterling lake cir apt 103',0,'mason','OH','45040',NULL,'CY','39165','1974-11-12','F','U',':RET:2047-9','N','021','DEN','1744164','99734OH005000401','2014-01-01','2013-12-18 13:55:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:55'),(18192,14523,'N','01','021','EC','A',NULL,NULL,'','0000729995','0000519856','','IL','1','Zarasua','Genesis','Sandy','','','34','640384012','171 EATON RIDGE DR',0,'SAGAMORE HILLS','OH','44067','1573','CY','39153','1993-08-30','F','',NULL,'N','021','HLT','2722660','52664OH151001501','2014-02-01','2014-01-14 13:18:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-01-15 02:08:04'),(26464,20991,'Y','18','021','EC','A','','','AC','0000345647','0000345647','OH00003286304','IL','1','PALUMBO','JENNIFER','','','','34','299926243','2532 4TH ST',0,'CUYAHOGA FALLS','OH','44221','2633','CY','39153','1988-02-02','F','U',NULL,'T','021','HLT','3409648','52664OH151001305','2014-03-01','2014-02-27 12:38:19','133.00',NULL,NULL,'262.61','129.61','R-OH012','OH0','262.61','CIC',0,'2014-02-28 07:30:33'),(25784,20448,'Y','18','021','EC','A','','','AC','0000002341','0000002341','OH00002682134','IL','1','KERBY','LORI','','','','34','291743986','446 ORENA AVE',0,'LIMA','OH','45804','1448','CY','39003','1961-08-25','F','U',':RET:2106-3','T','021','HLT','2684833','92036OH005001505','2014-04-01','2014-02-24 15:39:59','303.00',NULL,NULL,'494.04','191.04','R-OH002','OH0','494.04',NULL,0,'2014-02-26 09:31:04'),(18819,14989,'Y','18','021','EC','A','','','AC','0000928527','0000928527','OH00001652132','IL','1','Kallman','Thomas','','','','34','286462758','8315 kenwood road',0,'Cincinnati','OH','45236',NULL,'CY','39061','1958-10-04','M','U',NULL,'T','021','DEN','2126647','99734OH005000401','2014-02-01','2014-01-15 20:53:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:36:05'),(4615,3655,'Y','18','021','EC','A','','','AC','0000291956','0000291956','OH00000737850','IL','1','Frank','Joseph','','','','34','271544160','1143 NORTON AVE',0,'NORTON','OH','44203','6526','CY','39153','1952-09-29','M','M',NULL,'N','021','HLT','1153190','52664OH151001501','2014-01-01','2013-12-12 16:31:37','820.00',NULL,NULL,'1433.08','613.08','R-OH012','OH0','751.58',NULL,0,'2013-12-25 22:06:06'),(19735,15728,'Y','18','021','EC','A','','','AC','0002065288','0002065288','LA00002140140','IL','1','Smith','Rudy','','','','34','434185898','3109 CHICAGO ST',0,'ALEXANDRIA','LA','71302','4700','CY','22079','1958-04-11','M','U',':RET:2054-5','N','021','DEN','2873759','18575LA002000201','2014-03-01','2014-01-23 14:43:03','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-23 21:01:08'),(16901,13524,'Y','18','021','EC','A','','','AC','0001033674','0001033674','OH00001756109','IL','1','Charek','Matthew','','','','34','268884468','3112 HEARTHSTONE RD',0,'PARMA','OH','44134','2638','CY','39035','1980-09-26','M','M',':RET:2106-3','N','021','DEN','1513543','99734OH005000401','2014-02-01','2014-01-09 12:32:16','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:19:33'),(17540,14023,'Y','18','021','EC','A','','','AC','0000222415','0000222415','OH00002266288','IL','1','Baldwin','Tiffany','','','','34','295885603','303 n prospect st',0,'Ravenna','OH','44266',NULL,'CY','39133','1988-06-09','F','U',':RET:2106-3','N','021','HLT','2689085','52664OH151001305','2014-02-01','2014-01-12 17:51:20','137.00',NULL,NULL,'223.90','86.90','R-OH012','OH0','223.90',NULL,0,'2014-01-13 03:01:47'),(14264,11378,'Y','18','021','EC','A','','','AC','0000670263','0000670263','OH00001648864','IL','1','Williams','Paulette','','','','34','272506572','450 Glensprings Dr. Apt B',0,'Cincinati','OH','45246',NULL,'CY','39061','1950-09-10','F','U',NULL,'N','021','HLT','1656731','92036OH004001201','2014-02-01','2013-12-26 13:11:59','225.00',NULL,NULL,'509.54','284.54','R-OH004','OH0','509.54',NULL,0,'2013-12-27 02:05:54'),(27937,22100,'Y','18','021','EC','A','','','AC','0001154107','0001154107','TX00003542367','IL','1','JARNER','JANET','','','','34','451060458','505 SUTTON DR',0,'COMANCHE','TX','76442','1681','CY','48093','1958-07-16','F','U',NULL,'N','021','DEN','3412166','33348TX002000201','2014-04-01','2014-03-06 13:27:30','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:29'),(28173,22296,'Y','18','021','EC','A','','','AC','0000344197','0000344197','OH00003619439','IL','1','AVNER','RHEN','','','','34','299640712','3951 WILTSHIRE RD',0,'CHAGRIN FALLS','OH','44022','1152','CY','39035','1957-12-10','M','U',':RET:2106-3','N','021','HLT','3539781','92036OH005000805','2014-04-01','2014-03-06 12:12:23','371.00',NULL,NULL,'545.44','174.44','R-OH011','OH0','545.44',NULL,0,'2014-03-06 21:02:50'),(28370,22449,'Y','18','021','EC','A','','','AC','0000994037','0000994037','TX00003464450','IL','1','Escobar','Ramon','','','','34','462863003','2501 HIGHWAY 590',0,'COMANCHE','TX','76442','7008','CY','48093','1950-10-18','M','M',NULL,'N','021','DEN','3777943','33348TX002000201','2014-04-01','2014-03-07 17:58:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:34'),(4046,3230,'Y','18','021','EC','A','','','AC','0000991521','0000991521','OH00000556510','IL','1','Rathfelder','Michelle','','','','34','296665170','1922 N RIVER RD',0,'FREMONT','OH','43420','8701','CY','39143','1974-11-08','F','U',':RET:2106-3','N','021','DEN','1406191','99734OH005000401','2014-01-01','2013-12-17 12:27:59','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:46:15'),(16065,12866,'Y','18','021','EC','A','','','AC','0000490486','0000490486','OH00002125310','IL','1','Thorton','Gerald','','','','34','285543298','2247 HEPBURN AVE',0,'DAYTON','OH','45406','1848','CY','39113','1955-04-23','M','U',NULL,'T','021','DEN','2344460','99734OH005000401','2014-02-01','2014-01-03 10:49:54','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:03:39'),(23640,18824,'Y','18','021','EC','A','','','AC','0000710987','0000710987','TX00002555319','IL','1','Almonrode','Patricia','','','','34','003482870','1393 Arvel Circle',0,'AZLE','TX','76020',NULL,'CY','48367','1958-09-30','F','U',NULL,'N','021','DEN','3662975','33348TX002000201','2014-03-01','2014-02-13 20:29:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:08'),(22319,17820,'Y','18','021','EC','A','','','AC','0001840095','0001840095','LA00002394241','IL','1','Stevens','LeeAnna','','','','34','451026975','1413 Alvin Street',0,'Lake Charles','LA','70601',NULL,'CY','22019','1969-05-23','F','M',':RET:2106-3','N','021','DEN','3282983','18575LA002000201','2014-03-01','2014-01-23 15:02:36','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-10 11:00:52'),(21642,17282,'Y','18','021','EC','A','','','AC','0000271857','0000271857','TX00001992813','IL','1','Burts','Stevquesha','','','','34','392114063','1210 INDUSTRIAL BLVD',0,'KILLEEN','TX','76549','1219','CY','48027','1992-11-12','F','U',':RET:2054-5','N','021','DEN','2753309','33348TX002000201','2014-03-01','2014-02-05 16:22:16','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-05 21:30:45'),(13833,11039,'N','19','021','EC','A',NULL,NULL,'','0001031448','0000787190','','IL','1','Sisouphanh','Isabella','','','','34','280040530','3140 GRENFALL RD',0,'NORTON','OH','44203','5677','CY','39153','1999-05-06','F','',':RET:2028-9','N','021','HLT','1914416','52664OH152000901','2014-01-01','2013-12-23 09:36:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 13:12:08'),(2721,2200,'Y','18','021','EC','A','','','AC','0000874605','0000874605','LA00000147264','IL','1','James','Rica','','','','34','438633882','2857 N DORGENOIS ST',0,'NEW ORLEANS','LA','70117','7409','CY','22071','1977-12-01','F','U',':RET:2054-5','N','021','DEN','1095484','18575LA002000201','2014-01-01','2013-12-01 21:26:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:12'),(14729,11761,'Y','18','024','14','A','','','TE','0000735021','0000735021','','IL','1','Rammel','Michelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-11-16','F','',NULL,NULL,NULL,'','2274670','','2013-12-28','2013-12-28 12:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:09:46'),(27315,21627,'N','01','021','EC','A',NULL,NULL,'','0000474772','0000716322','','IL','1','BADILLO','JUANITA','','','','34','461298510','808 N LOUISIANA',0,'SANTA ROSA','TX','78593',NULL,'CY','48061','1961-11-09','F','',':RET:2106-3','N','021','DEN','3879283','33348TX002000201','2014-04-01','2014-03-04 14:44:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:42'),(2130,1748,'Y','18','021','EC','A','','','AC','0000514421','0000514421','OH00001119812','IL','1','Seifert','Brian','J','','','34','323589326','6923 MAID MARIAN DR',0,'CINCINNATI','OH','45230','2222','CY','39061','1958-01-29','M','U',':RET:2106-3','N','021','DEN','148092','99734OH005000401','2014-01-01','2013-12-10 16:07:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:55'),(21222,16958,'Y','18','021','EC','A','','','AC','0002253951','0002253951','LA00001734330','IL','1','Bryant','Angie','','','','34','435355626','4806 Shed Road',0,'Bossier City','LA','71111',NULL,'CY','22015','1974-03-27','F','U',':RET:2054-5','N','021','DEN','3543695','18575LA002000201','2014-03-01','2014-02-03 17:19:10','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-03 21:01:04'),(23675,18851,'Y','18','021','EC','A','','','AC','0002266723','0002266723','LA00001571071','IL','1','Mitchell','Robert','','','','34','327623312','1352 SAINT ANTHONY ST',0,'NEW ORLEANS','LA','70116','1565','CY','22071','1960-07-11','M','U',':RET:2054-5','T','021','DEN','2856498','18575LA002000201','2014-03-01','2014-02-13 22:28:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-14 21:30:26'),(24623,19542,'N','01','021','EC','A',NULL,NULL,'','0000863067','0000652868','','IL','1','TUCKER','STEWART','','','','34','428191874','402 PEARL DR',0,'PEARL','MS','39208','4521','CY','28121','1962-04-20','M','',NULL,'N','021','DEN','2727834','46300MS002000201','2014-04-01','2014-02-19 15:23:39',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-20 04:16:27'),(3618,2897,'Y','18','021','EC','A','','','AC','0000889603','0000889603','OH00000256082','IL','1','AHRMAN','ROBIN','J','','','34','285662448','182 HIGH ST',0,'PEEBLES','OH','45660','1256','CY','39001','1958-10-19','F','U',':RET:2106-3','T','021','HLT','1884300','92036OH003000605','2014-01-01','2013-12-22 16:07:40','406.00',NULL,NULL,'574.91','168.91','R-OH005','OH0','574.91',NULL,0,'2013-12-25 21:23:38'),(27706,21910,'Y','18','024','14','A','','','TE','0001155919','0001155919','','IL','1','crosby','betty',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-12','F','',NULL,NULL,NULL,'','662131','','2014-03-20','2014-03-05 12:29:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-05 21:30:51'),(27484,21749,'Y','18','021','EC','A','','','AC','0000350629','0000350629','OH00003141799','IL','1','Hughes','Ian','Michael','','','34','281860615','6097 AGERTER RD',0,'LIMA','OH','45806','9368','CY','39003','1984-01-01','M','U',':RET:2106-3','N','021','HLT','3852434','92036OH006001501','2014-04-01','2014-03-04 07:56:43','0.00',NULL,NULL,'198.11','198.11','R-OH002','OH0','198.11',NULL,0,'2014-03-04 21:02:19'),(25846,20489,'Y','18','021','EC','A','','','AC','0000597359','0000597359','OH00003057364','IL','1','Gearhart','Linda','M','','','34','288509577','1657 Traref Rd',0,'Mogadore','OH','44260',NULL,'CY','39133','1950-10-31','F','M',':RET:2106-3','N','021','HLT','3214703','52664OH152000901','2014-04-01','2014-02-26 14:24:52','356.00',NULL,NULL,'482.18','126.18','R-OH012','OH0','482.18',NULL,0,'2014-02-26 21:00:38'),(3317,2663,'Y','18','021','EC','A','','','AC','0000689692','0000689692','OH00001251114','IL','1','Burnette','Brian','','','','34','292868790','1157 THORNY RIDGE TRL',0,'LEBANON','OH','45036','7713','CY','39165','1982-10-06','M','M',':RET:2106-3','N','021','DEN','1478794','99734OH005000301','2014-01-01','2013-12-22 14:38:34','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:57'),(17301,13836,'Y','18','024','14','A','','','TE','0000485377','0000485377','','IL','1','Kim','Yeon','Won',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-03-22','F','',NULL,NULL,NULL,'','2383964','','2014-01-10','2014-01-10 12:06:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:23:38'),(54,49,'Y','18','021','EC','A','','','AC','0000819755','0000819755','OH00000936576','IL','1','MOSS','SARA','','','','34','453290401','8664 SIMPSON CT',0,'MASON','OH','45040','9599','CY','39165','1974-07-19','F','U',':RET:2106-3','N','021','DEN','1223621','99734OH005000301','2014-01-01','2013-12-04 20:27:38','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:28'),(16459,13171,'Y','18','021','EC','A','','','AC','0000816438','0000816438','OH00001647686','IL','1','CAMPOLONGO','DANTE','','','','34','282644839','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','1957-08-27','M','M',NULL,'T','021','HLT','2257217','92036OH004000601','2014-02-01','2014-01-06 10:24:29','549.00',NULL,NULL,'1053.60','504.60','R-OH005','OH0','463.10',NULL,0,'2014-01-07 04:05:41'),(18880,15042,'Y','18','021','EC','A','','','AC','0001651009','0001651009','LA00001549714','IL','1','Eastin','Michael','','','','34','435314617','635 BRASSEAUX RD',0,'CARENCRO','LA','70520','5218','CY','22055','1960-01-25','M','U',NULL,'N','021','DEN','2671160','18575LA002000201','2014-03-01','2014-01-16 17:19:50','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-17 03:36:28'),(15364,12289,'Y','18','021','EC','A','','','AC','0000637122','0000637122','OH00001897570','IL','1','Sommer','Michele','Irene','','','34','275524795','7222 Creekview Drive',0,'Cincinnati','OH','45247',NULL,'CY','39061','1952-03-23','F','U',':RET:2106-3','N','021','DEN','1699748','99734OH005000301','2014-02-01','2014-01-01 12:45:19','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:24:52'),(4176,3325,'Y','18','021','EC','A','','','AC','0000021373','0000021373','OH00000231711','IL','1','Cipro','Dawn','','','','34','288661665','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','1967-03-02','F','M',':RET:2106-3','N','021','HLT','2222362','52664OH151001304','2014-01-01','2013-12-16 20:52:52','570.00',NULL,NULL,'1061.96','491.96','R-OH012','OH0','334.51',NULL,0,'2013-12-25 21:49:21'),(7299,5785,'Y','18','021','EC','A','','','AC','0000251605','0000251605','OH00000293719','IL','1','Sells','Aaron','','','','34','268521963','3613 SAMUEL RD',0,'AKRON','OH','44312','3733','CY','39153','1950-09-09','M','U',':RET:2106-3','N','021','HLT','37338','52664OH151001301','2014-01-01','2013-12-14 09:41:43','359.00',NULL,NULL,'658.32','299.32','R-OH012','OH0','658.32',NULL,0,'2013-12-26 02:03:06'),(6545,5189,'Y','18','021','EC','A','','','AC','0001175922','0001175922','TX00000226639','IL','1','longoria','celicia','','','','34','464731722','5406 S CESAR CHAVEZ RD',0,'EDINBURG','TX','78542','6974','CY','48215','1975-09-26','F','M',':RET:2106-3','T','021','DEN','648872','33348TX002000201','2014-01-01','2013-12-11 11:04:09','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 00:52:01'),(28577,22615,'Y','18','024','14','A','','','TE','0000926782','0000926782','','IL','1','RASMUSSEN','MARTIN','ROBERT',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-01-21','M','',NULL,NULL,NULL,'','4205558','','2014-03-08','2014-03-08 14:16:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-08 21:00:05'),(4529,3588,'Y','18','021','EC','A','','','AC','0000788423','0000788423','TX00000880574','IL','1','Bailey','Cody','','','','34','461879298','418 COUNTY ROAD 4748',0,'TIMPSON','TX','75975','2620','CY','48419','1987-02-24','M','U',':RET:2106-3','T','021','DEN','1213022','33348TX002000201','2014-01-01','2013-12-12 15:48:26','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:04:00'),(26536,21043,'Y','18','021','EC','A','','','AC','0000990113','0000990113','OH00003448758','IL','1','Tyree','Elana','','','','34','297740580','347 Texas Rd',0,'Gallipolis','OH','45631',NULL,'CY','39053','1964-07-27','F','M',':RET:2106-3','T','021','DEN','2794115','99734OH005000301','2014-03-01','2014-02-27 19:52:45','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-02-28 21:30:05'),(6895,5471,'Y','18','021','EC','A','','','AC','0002338306','0002338306','LA00000611023','IL','1','Cooper','Chaz','','','','34','436859237','7922 BAYOU FOUNTAIN AVE',0,'BATON ROUGE','LA','70820','7697','CY','22033','1986-05-23','M','U',':RET:2054-5','N','021','DEN','2213498','18575LA002000201','2014-01-01','2013-12-24 21:37:46','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:29'),(20469,16350,'Y','18','021','EC','A','','','AC','0000598785','0000598785','OH00001933847','IL','1','JOHNSON','ERIC','','','','34','283808585','550 MILLARD AVENUE',0,'CONNEAUT','OH','44030',NULL,'CY','39007','1966-12-08','M','U',NULL,'N','021','DEN','3335350','99734OH005000401','2014-03-01','2014-01-29 11:52:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:54'),(14485,11556,'Y','18','021','EC','A','','','AC','0000416761','0000416761','TX00001008643','IL','1','Pape','June','','','','34','451190463','131 COVE RD',0,'MATHIS','TX','78368','4131','CY','48297','1957-01-26','F','U',NULL,'N','021','DEN','2296269','33348TX002000201','2014-02-01','2013-12-27 08:39:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:22'),(1410,1172,'Y','18','021','EC','A','','','AC','0001617692','0001617692','LA00000443026','IL','1','Murphy','Sean','','','','34','436596443','3865 MARTINIQUE AVE',0,'KENNER','LA','70065','3507','CY','22051','1985-09-10','M','U',':RET:2106-3','T','021','DEN','2187093','18575LA002000201','2014-01-01','2013-12-24 13:26:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:53'),(13906,11091,'Y','18','021','EC','A','','','AC','0001031447','0001031447','OH00000663436','IL','1','Collins','Lori','','','','34','268764117','12 S High St.',0,'Bloomville','OH','44818',NULL,'CY','39147','1972-10-16','F','M',':RET:2106-3','N','021','HLT','2132049','92036OH005002706','2014-01-01','2013-12-22 22:36:59','143.59',NULL,NULL,'253.89','110.30','R-OH006','OH0','253.89',NULL,0,'2013-12-26 13:13:50'),(5877,4663,'Y','18','021','EC','A','','','AC','0000055919','0000055919','OH00001435740','IL','1','Sandoval','Claudia',NULL,NULL,NULL,NULL,NULL,'119 COROLINE DR',0,'SAINT CLAIRSVILLE','OH','43950','1003','CY','39013','1960-10-03','F','M',':RET:2106-3','T','021','DEN','2092318','99734OH005000301','2014-01-01','2013-12-23 21:40:42','0.00',NULL,NULL,'59.76','59.76','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:49:21'),(9804,7763,'Y','18','021','EC','A','','','AC','0000093803','0000093803','OH00001167970','IL','1','bair','laura','','','','34','295680336','45 ROBIN HOOD DR',0,'GREENVILLE','OH','45331','9773','CY','39037','1970-10-30','F','U',':RET:2106-3','N','021','HLT','1139015','92036OH005000505','2014-01-01','2013-10-20 20:37:56','203.00',NULL,NULL,'322.56','119.56','R-OH003','OH0','322.56',NULL,0,'2013-12-26 05:01:18'),(14271,11385,'Y','18','021','EC','A','','','AC','0001178322','0001178322','MS00000413649','IL','1','MOATON','DARRELL','','','','34','426437900','1112 ELLIS AVE',0,'JACKSON','MS','39209','7324','CY','28049','1968-09-17','M','U',':RET:2054-5','T','021','DEN','1364253','46300MS002000201','2014-02-01','2013-12-26 12:17:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:04'),(19318,15399,'N','01','021','EC','A',NULL,NULL,'','0000257704','0000697122','','IL','1','Ding','Luxia','','','','34','631885833','1215 LINCOLN ST',0,'LAREDO','TX','78040','5709','CY','48479','1976-06-03','F','',':RET:2034-7','N','021','DEN','2381931','33348TX002000201','2014-03-01','2014-01-21 09:39:47',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-22 03:22:10'),(16948,13565,'Y','18','021','EC','A','','','AC','0000913275','0000913275','MS00001806958','IL','1','Johnson','Tamika','','','','34','428591190','3895 SNAKE CREEK RD',0,'RAYMOND','MS','39154','8023','CY','28049','1975-09-05','F','U',':RET:2054-5','N','021','DEN','1744973','46300MS002000101','2014-02-01','2014-01-08 20:48:40','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-13 02:19:58'),(26123,20717,'Y','18','021','EC','A','','','AC','0000307150','0000307150','OH00003228207','IL','1','reynolds','karen','','','','34','280486222','865 NORTHERN PKWY',0,'CINCINNATI','OH','45224','1758','CY','39061','1953-08-13','F','M',NULL,'N','021','DEN','3792877','99734OH005000401','2014-03-01','2014-02-27 09:36:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:20'),(25113,19921,'Y','18','021','EC','A','','','AC','0000260611','0000260611','MS00002283539','IL','1','HARPER','CURMERA','','','','34','426591761','1725 DORCHESTER DR',0,'SOUTHAVEN','MS','38671','5707','CY','28033','1987-09-10','F','U',':RET:2054-5','N','021','DEN','3609740','46300MS002000201','2014-04-01','2014-02-21 14:31:02','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85','CIC',0,'2014-02-21 21:30:17'),(21174,16922,'Y','18','024','14','A','','','TE','0000049527','0000049527','','IL','1','Asher','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-12-02','M','',NULL,NULL,NULL,'','2694235','','2014-02-03','2014-02-03 16:07:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:00:40'),(28479,22533,'N','01','021','EC','A',NULL,NULL,'','0000936116','0000723968','','IL','1','Page','Linda','','','','34','219907258','221 N NORTH ST',0,'WASHINGTON COURT HOUSE','OH','43160','1457','CY','39047','1963-04-03','F','',NULL,'N','021','DEN','4140250','99734OH005000301','2014-04-01','2014-03-07 11:20:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:35'),(2848,2301,'N','01','021','EC','A',NULL,NULL,'','0000306335','0000771827','','IL','1','Zulfiquar','Chan','I','','','34','462535999','5810 WHITE CLOVER DR',0,'RICHMOND','TX','77469','6270','CY','48157','1955-02-13','M','',':RET:2029-7','N','021','DEN','839220','33348TX002000101','2014-01-01','2013-11-02 08:26:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 20:01:15'),(27292,21610,'N','01','021','EC','A',NULL,NULL,'','0000182164','0000040139','','IL','1','Durham','Dustin','','','','34','457897686','1723 E BROADWAY ST',0,'BROWNFIELD','TX','79316','4801','CY','48445','1981-01-26','M','',':RET:2106-3','N','021','DEN','3133507','33348TX002000201','2014-04-01','2014-03-04 10:26:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:29'),(16638,13311,'Y','18','021','EC','A','','','AC','0001071793','0001071793','OH00001523830','IL','1','Vosburg','Erika','','','','34','276706091','4812 KAIN AVE',0,'ASHTABULA','OH','44004','6552','CY','39007','1957-04-05','F','M',':RET:2040-4','N','021','DEN','1878171','99734OH005000401','2014-02-01','2014-01-07 11:42:45','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-08 18:24:16'),(15370,12293,'Y','18','021','EC','A','','','AC','0000001051','0000001051','OH00001846007','IL','1','Metzger','Ray','','','','34','272580741','2433 Vanburen Ave',0,'Springfield','OH','45505',NULL,'CY','39023','1955-04-14','M','U',':RET:2106-3','N','021','HLT','2173415','92036OH004000501','2014-02-01','2013-12-31 20:56:46','440.00',NULL,NULL,'487.00','47.00','R-OH003','OH0','487.00',NULL,1,'2014-01-02 04:25:03'),(19530,15565,'Y','18','021','EC','A','','','AC','0000873260','0000873260','OH00001612293','S3','1','Phan','Dien','','','','34','111862331','9199 MistyDawn DR',0,'Columbus','OH','43240',NULL,'CY','39041','1996-10-26','M','U',':RET:2047-9','N','021','DEN','2876448','99734OH005000401','2014-03-01','2014-01-22 17:27:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-01-23 03:02:20'),(23073,18397,'Y','18','021','EC','A','','','AC','0001405004','0001405004','LA00001990611','IL','1','Murphy','James','','','','34','276769361','6419 HIGHWAY 953',0,'JACKSON','LA','70748','3623','CY','22037','1965-08-31','M','U',':RET:2106-3','N','021','DEN','3847196','18575LA002000201','2014-03-01','2014-02-12 14:51:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-12 21:30:58'),(23243,18530,'Y','18','021','EC','A','','','AC','0000312234','0000312234','OH00001894455','IL','1','McMullen','Annette','','','','34','271647773','1436 ELM GROVE AVE',0,'AKRON','OH','44312','4614','CY','39153','1962-01-16','F','U',':RET:2106-3','N','021','HLT','2999857','52664OH152000901','2014-03-01','2014-02-12 19:12:15','212.00',NULL,NULL,'318.84','106.84','R-OH012','OH0','318.84','CIC',0,'2014-02-13 21:30:03'),(24174,19205,'Y','18','021','EC','A','','','AC','0000749587','0000749587','OH00002946256','IL','1','Grenier','Michael','','','','34','393685816','1012 S Byrne Rd',0,'Toledo','OH','43609',NULL,'CY','39095','1970-04-22','M','U',NULL,'N','021','HLT','3637567','92036OH003002605','2014-03-01','2014-02-15 17:17:03','145.00',NULL,NULL,'276.33','131.33','R-OH001','OH0','276.33',NULL,0,'2014-02-15 22:02:11'),(25120,19927,'Y','18','021','EC','A','','','AC','0001136698','0001136698','OH00002623993','IL','1','Spofford','Bobbi','','','','34','369665885','1652 SHERIDAN DR',0,'LANCASTER','OH','43130','1366','CY','39045','1966-12-24','F','U',':RET:2106-3','T','021','DEN','3468365','99734OH005000301','2014-03-01','2014-02-21 12:51:33','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00','CIC',0,'2014-02-21 21:30:21'),(25600,20311,'Y','18','021','EC','A','','','AC','0001092126','0001092126','OH00002319763','IL','1','AVILES','CARLOS','','','','34','148581453','3032 DAVID CT',0,'COLUMBUS','OH','43224','1893','CY','39049','1971-08-01','M','M',NULL,'N','021','DEN','3847410','99734OH005000401','2014-04-01','2014-02-23 13:02:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-26 08:00:50'),(27216,21549,'Y','18','021','EC','A','','','AC','0000795129','0000795129','MS00003557423','IL','1','young','marquis','','','','34','604108507','2265 clinton tinnin rd',0,'clinton','MS','39056',NULL,'CY','28049','1979-02-02','M','U',':RET:2054-5','N','021','DEN','3303218','46300MS002000201','2014-04-01','2014-03-02 20:32:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:31'),(28401,22471,'Y','18','021','EC','A','','','AC','0000130762','0000130762','OH00003769592','IL','1','Quinn','Raymond','','','','34','255556619','6802 Clearhurst Dr',0,'Columbus','OH','43229',NULL,'CY','39049','1980-10-14','M','U',':RET:2054-5','N','021','DEN','3711492','99734OH005000401','2014-04-01','2014-03-07 05:02:33','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:30:50'),(9504,7538,'N','19','021','EC','A',NULL,NULL,'','0000112924','0000964615','','S1','1','Shimpo','Ryoge','','','','34','269173204','1730 KINGSLEY AVE',0,'AKRON','OH','44313','6109','CY','39153','2010-11-10','M','',':RET:2039-6^:RET:2106-3','N','021','DEN','1955187','99734OH005000401','2014-01-01','2013-12-21 15:27:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:15'),(18572,14811,'Y','18','021','EC','A','','','AC','0000568049','0000568049','OH00001719264','IL','1','Kitto','Andrew','Comstock','','','34','293805324','1756 West market st.',0,'Akron','OH','44313',NULL,'CY','39153','1981-11-19','M','U',':RET:2106-3','T','021','HLT','1820778','52664OH152000901','2014-02-01','2014-01-15 16:51:39','190.00',NULL,NULL,'222.22','32.22','R-OH012','OH0','222.22',NULL,0,'2014-01-16 08:47:04'),(777,642,'Y','18','021','EC','A','','','AC','0000440546','0000440546','TX00000081539','IL','1','Alvarado','David','','','','34','463801396','301 DOUGLAS ST',0,'HEREFORD','TX','79045','2702','CY','48117','1951-03-10','M','M',NULL,'N','021','DEN','1704482','33348TX002000201','2014-01-01','2013-12-16 13:51:55','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:04:58'),(7228,5730,'Y','18','021','EC','A','','','AC','0000314681','0000314681','OH00000691153','IL','1','Woofter','Melanie','','','','34','290822519','316 GREENBRIAR DR',0,'CORTLAND','OH','44410','1615','CY','39155','1970-06-27','F','M',':RET:2106-3','N','021','DEN','1250614','99734OH005000401','2014-01-01','2013-12-14 16:02:59','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:01:17'),(5468,4344,'Y','18','021','EC','A','','','AC','0000047080','0000047080','OH00000427752','IL','1','COOK','RORY','','','','34','283549271','709 BALFE ST',0,'TOLEDO','OH','43609','3339','CY','39095','1956-02-15','M','M',NULL,'T','021','HLT','1633121','92036OH006002601','2014-01-01','2013-12-19 09:18:11','91.00',NULL,NULL,'433.40','342.40','R-OH001','OH0','433.40',NULL,0,'2013-12-25 23:10:35'),(19753,15745,'Y','18','021','EC','A','','','AC','0000948446','0000948446','OH00002566975','IL','1','Clark','Nicole','','','','34','445544623','2307 WATERWORKS DR',0,'TOLEDO','OH','43609','3159','CY','39095','1951-07-19','F','U',':RET:2106-3','N','021','HLT','2728752','92036OH001002601','2014-03-01','2014-01-23 13:44:46','269.00',NULL,NULL,'675.75','406.75','R-OH001','OH0','675.75',NULL,0,'2014-01-23 21:01:19'),(22327,17828,'Y','18','021','EC','A','','','AC','0000667811','0000667811','OH00001654801','IL','1','demint','shirley','','','','34','272662740','112 HOPE LN',0,'WEST UNION','OH','45693','9242','CY','39001','1963-10-09','F','M',':RET:2106-3','N','021','HLT','2445583','92036OH004000601','2014-03-01','2014-01-26 17:08:59','0.00',NULL,NULL,'308.28','308.28','R-OH005','OH0','308.28',NULL,0,'2014-02-10 11:00:58'),(23980,19066,'Y','18','021','EC','A','','','AC','0002143161','0002143161','LA00002831668','IL','1','Laufenberg','Dawn','','','','34','396888578','334 N BERNADOTTE ST',0,'NEW ORLEANS','LA','70119','4310','CY','22071','1971-05-14','F','U',':RET:2106-3','N','021','DEN','3746655','18575LA002000201','2014-03-01','2014-02-14 18:24:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:20'),(24746,19639,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000330936','','IL','1','Dugan','Veronica','A','','','34','296969404','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1994-02-07','F','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:46'),(25230,20012,'Y','18','021','EC','A','','','AC','0000723951','0000723951','OH00002850773','IL','1','VODRAZKA','TODD','','','','34','269563711','10780 PARTRIDGE TRL',0,'BRECKSVILLE','OH','44141','1419','CY','39035','1970-01-18','M','U',NULL,'N','021','HLT','3233285','52664OH151001304','2014-04-01','2014-02-21 15:12:49','115.00',NULL,NULL,'351.37','236.37','R-OH011','OH0','351.37',NULL,0,'2014-02-21 22:01:02'),(28392,22462,'N','01','021','EC','A',NULL,NULL,'','0000498238','0001155163','','IL','1','Lantz','Michael','','','','34','302840325','701 RUDOLPH AVE',0,'CUYAHOGA FALLS','OH','44221','1939','CY','39153','1970-10-08','M','',NULL,'N','021','HLT','3434437','52664OH152000901','2014-04-01','2014-03-07 17:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','221.65',NULL,0,'2014-03-07 21:30:45'),(13343,10655,'Y','18','021','EC','A','','','AC','0000909825','0000909825','TX00001167832','IL','1','Pruitt','Elbert','','','','34','456510382','11381 COUNTY ROAD 2249',0,'TYLER','TX','75707','5309','CY','48423','1968-12-30','M','U',NULL,'N','021','DEN','1848858','33348TX002000201','2014-01-01','2013-12-23 18:29:36','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-26 12:58:59'),(4360,3462,'Y','18','021','EC','A','','','AC','0001162582','0001162582','OH00000382612','IL','1','Mix','Theodore','','','','34','283545741','431Southdale',0,'Toledo','OH','43612',NULL,'CY','39095','1967-02-18','M','U',':RET:2106-3','N','021','HLT','2406107','92036OH001002601','2014-01-01','2013-12-17 17:04:58','169.00',NULL,NULL,'352.81','183.81','R-OH001','OH0','352.81',NULL,0,'2013-12-25 21:53:43'),(19033,15158,'Y','18','021','EC','A','','','AC','0000322170','0000322170','OH00001375447','IL','1','Perry','Paul','','','','34','302481241','19955 Rockside',0,'Bedford','OH','44146',NULL,'CY','39035','1950-08-24','M','U',NULL,'N','021','HLT','2947211','92036OH004000801','2014-03-01','2014-01-16 20:02:47','500.00',NULL,NULL,'554.95','54.95','R-OH011','OH0','554.95',NULL,0,'2014-01-20 08:06:32'),(7043,5593,'Y','18','021','EC','A','','','AC','0000190939','0000190939','TX00001199799','IL','1','Muhammad','Damon','','','','34','565435003','10833 N CENTRAL EXPY',0,'DALLAS','TX','75231','1008','CY','48113','1976-05-10','M','U',':RET:2054-5','N','021','DEN','1930525','33348TX002000201','2014-02-01','2013-12-25 00:51:03','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:28'),(14658,11700,'Y','18','021','EC','A','','','AC','0000167518','0000167518','TX00000130688','IL','1','GREEN','STACY','','','','34','525290227','4514 HAVERHILL LN',0,'CORPUS CHRISTI','TX','78411','4936','CY','48355','1963-12-31','F','U',':RET:2106-3','N','021','DEN','1565035','33348TX002000201','2014-02-01','2013-12-27 21:05:26','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2013-12-29 11:07:55'),(15242,12182,'N','01','021','EC','A',NULL,NULL,'','0000491838','0000439392','','IL','1','Snyder','Keith','','','','34','280848791','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1983-09-02','M','',':RET:2106-3','N','021','HLT','2371100','92036OH003002605','2014-02-01','2013-12-30 09:18:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.13',NULL,0,'2014-01-01 12:08:38'),(22897,18252,'N','19','021','EC','A',NULL,NULL,'','0000073974','0000575962','','S1','1','Huff','Kevin','Isaac','','','34','386270201','15054 MOCK RD',0,'BERLIN CENTER','OH','44401','8731','CY','39099','2002-07-31','F','',':RET:2106-3','N','021','HLT','3669385','92036OH002003201','2014-03-01','2014-02-11 10:22:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','177.51',NULL,0,'2014-02-11 21:02:39'),(24840,19694,'Y','18','021','EC','A','','','AC','0000608277','0000608277','MS00002800018','IL','1','Smith','Janice','Marie','','','34','426337150','1212 COVINGTON PARK DR',0,'JACKSON','MS','39212','5044','CY','28049','1964-03-28','F','U',':RET:2054-5','N','021','DEN','3511232','46300MS002000101','2014-04-01','2014-02-19 17:15:39','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:53:35'),(25334,20101,'Y','18','021','EC','A','','','AC','0001527203','0001527203','LA00002963645','IL','1','Weber','Alfred','','','','34','436965384','190 Belle Terre P.O. BOX 2053',0,'LAPLACE','LA','70069',NULL,'CY','22095','1956-04-28','M','U',':RET:2054-5','N','021','DEN','2980642','18575LA002000201','2014-04-01','2014-02-25 14:35:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:20'),(25720,20401,'Y','18','021','EC','A','','','AC','0000422925','0000422925','TX00002872521','IL','1','Fuller','Roosevelt','','','','34','434822155','612 LAUREL RD',0,'ATHENS','TX','75751','3302','CY','48213','1950-08-07','M','M',':RET:2054-5','N','021','DEN','3665760','33348TX002000201','2014-04-01','2014-02-24 17:30:33','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:27'),(27033,21410,'N','19','021','EC','A',NULL,NULL,'','0000024875','0000096369','','S1','1','Francher','Autumn','','','','34','634491877','15174 FM 95 S',0,'MOUNT ENTERPRISE','TX','75681','3167','CY','48401','2011-10-17','M','',':RET:2106-3','N','021','DEN','3433154','33348TX002000201','2014-04-01','2014-03-03 14:43:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22','CIC',0,'2014-03-03 21:00:17'),(27299,21616,'Y','18','021','EC','A','','','AC','0000898862','0000898862','TX00002972685','IL','1','Floyd','Paige','','','','34','474889144','511 N. Fannin St.',0,'Groesbeck','TX','76642',NULL,'CY','48293','1976-04-06','F','U',':RET:2106-3','N','021','DEN','3117630','33348TX002000201','2014-04-01','2014-03-04 13:25:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:33'),(27367,21671,'N','19','021','EC','A',NULL,NULL,'','0000822115','0000759768','','IL','1','Poteet','Chase','E','','','34','280946777','4913 BATH RD',0,'DAYTON','OH','45424','1756','CY','39057','1991-08-16','M','',':RET:2106-3','N','021','DEN','2782074','99734OH005000401','2014-04-01','2014-03-04 17:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:14'),(29022,22971,'Y','18','021','EC','A','','','AC','0000752146','0000752146','OH00003426970','IL','1','Atkinson','Terry','','','','34','300808130','2531 East 37th st.',0,'Lorain','OH','44055',NULL,'CY','39093','1983-11-18','M','U',':RET:2054-5','N','021','DEN','2925641','99734OH005000401','2014-04-01','2014-03-10 10:27:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:31'),(835,691,'Y','18','021','EC','A','','','AC','0000752056','0000752056','OH00000762197','IL','1','Kuhn','James','','','','34','272507848','3801 SANDTRAP CIR',0,'MASON','OH','45040','2170','CY','39165','1959-05-24','M','M',':RET:2106-3','N','021','HLT','350957','92036OH005001204','2014-01-01','2013-12-15 19:43:37','450.00',NULL,NULL,'877.35','427.35','R-OH004','OH0','458.32',NULL,0,'2013-12-25 18:06:28'),(18984,15125,'Y','18','021','EC','A','','','AC','0000675473','0000675473','OH00001474154','IL','1','Manley','Roger','','','','34','272763358','30705 STEWART HOLLOW RD',0,'MIDDLEPORT','OH','45760','9765','CY','39105','1967-02-10','M','M',':RET:2106-3','N','021','DEN','2264386','99734OH005000301','2014-03-01','2014-01-17 12:24:21','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2014-01-20 08:06:08'),(18839,15005,'Y','18','021','EC','A','','','AC','0000042085','0000042085','OH00002273765','IL','1','Older','Naz','','','','34','284888626','1060 E MILLTOWN RD',0,'WOOSTER','OH','44691','1848','CY','39169','1976-01-26','F','U',':RET:2106-3','N','021','HLT','2660420','52664OH151001306','2014-03-01','2014-01-16 12:11:32','208.00',NULL,NULL,'277.87','69.87','R-OH014','OH0','277.87',NULL,0,'2014-01-17 03:36:12'),(4612,3652,'Y','18','021','EC','A','','','AC','0001252092','0001252092','OH00000941031','IL','1','gabriel','lisa','','','','34','017462145','2810 cedar hill road',0,'cuyahoga falls','OH','44223',NULL,'CY','39153','1954-01-17','F','U',':RET:2106-3','N','021','HLT','740929','52664OH151001501','2014-01-01','2013-12-12 11:32:52','0.00',NULL,NULL,'696.21','696.21','R-OH012','OH0','696.21',NULL,0,'2013-12-25 22:06:00'),(3953,3163,'Y','18','021','EC','A','','','AC','0000019094','0000019094','OH00000006246','IL','1','Tuel','Daniel','','','','34','270525614','328 Circle Drive',0,'Ripley','OH','45167',NULL,'CY','39015','1951-07-16','M','U',':RET:2106-3','N','021','HLT','838373','92036OH005000604','2014-01-01','2013-12-13 10:44:40','422.00',NULL,NULL,'616.74','194.74','R-OH005','OH0','616.74',NULL,0,'2013-12-25 21:38:12'),(2803,2265,'Y','18','021','EC','A','','','AC','0001031424','0001031424','OH00000270991','31','1','Caudill','Robert','','','','34','297883226','606 CUMBERLAND DR',0,'CELINA','OH','45822','1336','CY','39107','1988-06-24','M','U',':RET:2106-3','T','021','HLT','905092','92036OH003001504','2014-01-01','2013-12-02 10:06:13','98.00',NULL,NULL,'265.38','167.38','R-OH002','OH0','265.38',NULL,0,'2013-12-25 19:50:28'),(17093,13680,'N','19','021','EC','A',NULL,NULL,'','0000407940','0001002995','','IL','1','ARREDONDO','ANA PAULA','','','','34','628827119','1403 CAMP CRAFT RD  APT C',0,'AUSTIN','TX','78746',NULL,'CY','48453','1992-12-01','F','',NULL,'N','021','DEN','1633872','33348TX002000201','2014-02-01','2014-01-08 15:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:28'),(15528,12423,'Y','18','021','EC','A','','','AC','0001554346','0001554346','LA00001261744','31','1','bourque','carolyn','','','','34','435908462','po box 1792',0,'Opelousas','LA','70571',NULL,'CY','22097','1951-09-07','F','U',':RET:2106-3','N','021','DEN','1465146','18575LA002000201','2014-02-01','2013-12-31 10:24:28','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:30:31'),(3639,2911,'N','01','021','EC','A',NULL,NULL,'','0001194653','0000875487','','IL','1','TAYLOR','JERRY','E','','','34','587487178','369 E ACADEMY ST',0,'CANTON','MS','39046','4601','CY','28089','1950-10-10','M','',':RET:2054-5','N','021','DEN','391515','46300MS002000201','2014-01-01','2013-12-13 11:22:11',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:30:18'),(21217,16955,'Y','18','021','EC','A','','','AC','0001253641','0001253641','LA00001726994','IL','1','AYALA','JULIO','B','','','34','624843310','632 WILLOWBROOK DR',0,'GRETNA','LA','70056',NULL,'CY','22051','1984-06-04','M','M',NULL,'T','021','DEN','2759652','18575LA002000201','2014-03-01','2014-02-03 15:31:48','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-03 21:01:02'),(22700,18126,'Y','18','021','EC','A','','','AC','0001154020','0001154020','TX00002119555','IL','1','Shelton','Katie','','','','34','461971054','17200 Westgrove Dr',0,'Addison','TX','75001',NULL,'CY','48113','1988-01-27','F','M',':RET:2106-3','N','021','DEN','2993686','33348TX002000101','2014-03-01','2014-02-11 13:44:10','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-11 21:00:58'),(23039,18367,'N','01','021','EC','A',NULL,NULL,'','0000925282','0000330497','','IL','1','NGUYEN','DONNA','THY','','','34','462717935','5104 FORT BUCKNER DR',0,'MCKINNEY','TX','75070','1000','CY','48085','1953-11-04','F','',':RET:2047-9','N','021','DEN','3851927','33348TX002000201','2014-03-01','2014-02-12 17:19:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-12 21:30:38'),(23532,18745,'N','01','021','EC','A',NULL,NULL,'','0001834744','0002035577','','IL','1','Spears','Susan','','','','34','437218073','1512 London at',0,'Olla','LA','71465',NULL,'CY','22059','1968-12-27','F','',':RET:2106-3','N','021','DEN','2625243','18575LA002000201','2014-03-01','2014-02-13 11:30:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-13 22:02:26'),(27305,21620,'N','19','021','EC','A',NULL,NULL,'','0000428667','0000784132','','S1','1','Brooks','Quatro','','','','34','586932408','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','2011-07-12','M','',NULL,'N','021','DEN','3841046','33348TX002000201','2014-04-01','2014-03-04 13:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-04 21:00:36'),(524,427,'N','01','021','EC','A',NULL,NULL,'','0001011530','0000914401','','IL','1','CRAWFORD','JAMES','','','','34','288700007','2471 GATE ST',0,'CINCINNATI','OH','45211','7308','CY','39061','1975-10-06','M','',':RET:2054-5','N','021','DEN','1071161','99734OH005000301','2014-01-01','2013-12-04 14:14:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:49:17'),(19343,15420,'Y','18','021','EC','A','','','AC','0001104472','0001104472','OH00001587644','IL','1','Bergdorf','Robert','','','','34','270500812','5868 GROVE RD',0,'CLINTON','OH','44216','9719','CY','39153','1950-03-07','M','M',':RET:2106-3','N','021','DEN','3190513','99734OH005000301','2014-03-01','2014-01-20 19:33:34','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,1,'2014-01-22 03:22:22'),(9517,7548,'Y','18','024','14','A','','','TE','0000637097','0000637097','','IL','1','AGARWAL','SHUBHRA','NEIL',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-03-11','F','',NULL,NULL,NULL,'','1767706','','2013-12-20','2013-12-20 19:09:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:35:34'),(9427,7479,'Y','18','021','EC','A','','','AC','0000048288','0000048288','TX00001151018','IL','1','Thomas','Justin','','','','34','466653157','910 E 6TH ST',0,'BIG LAKE','TX','76932','4714','CY','48383','1982-11-16','M','U',':RET:2106-3','N','021','DEN','2166898','33348TX002000201','2014-01-01','2013-12-21 17:15:02','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:33:17'),(16530,13224,'Y','18','021','EC','A','','','AC','0000007457','0000007457','TX00001441749','IL','1','juarez','norberto','','','','34','452235764','9920 GENIE DR',0,'EL PASO','TX','79924','5016','CY','48141','1966-06-07','M','M',':RET:2106-3','T','021','DEN','1912130','33348TX002000201','2014-02-01','2014-01-05 16:43:33','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,1,'2014-01-07 10:22:01'),(3759,3008,'Y','18','021','EC','A','','','AC','0000792204','0000792204','OH00000677291','IL','1','FREIMAN','TRACEY','JO','','','34','272669090','1040 BEVAN ST',0,'BARBERTON','OH','44203','4509','CY','39153','1959-03-27','F','U',':RET:2106-3','N','021','HLT','655185','52664OH151001306','2014-01-01','2013-12-13 09:15:51','379.00',NULL,NULL,'476.12','97.12','R-OH012','OH0','476.12',NULL,0,'2013-12-25 21:33:22'),(7578,5996,'N','19','021','EC','A',NULL,NULL,'','0000440802','0000976697','','IL','1','Kienzle','Tess','M','','','34','379192603','2238 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','1102','CY','39095','1996-03-16','F','',':RET:2106-3','N','021','HLT','394135','92036OH001002601','2014-01-01','2013-12-15 12:30:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','149.37',NULL,0,'2013-12-26 02:33:54'),(17967,14357,'Y','18','021','EC','A','','','AC','0000906618','0000906618','OH00001550664','IL','1','Becker','Bryan','','','','34','207505402','181 30TH ST NW',0,'BARBERTON','OH','44203','6748','CY','39153','1963-07-29','M','U',':RET:2106-3','N','021','HLT','2376809','52664OH151001306','2014-02-01','2014-01-13 19:18:38','206.00',NULL,NULL,'398.29','192.29','R-OH012','OH0','398.29',NULL,0,'2014-01-15 02:06:48'),(16131,12921,'Y','18','021','EC','A','','','AC','0001066994','0001066994','OH00002218028','IL','1','Sheer','Robert','','','','34','289543272','10376 Brosius',0,'Garrettsville','OH','44231',NULL,'CY','39133','1953-06-22','M','M',':RET:2106-3','T','021','HLT','2442365','52664OH151001306','2014-02-01','2014-01-03 12:36:49','506.00',NULL,NULL,'696.03','190.03','R-OH012','OH0','696.03',NULL,0,'2014-01-04 02:05:41'),(4070,3252,'Y','18','021','EC','A','','','AC','0000069065','0000069065','OH00000202475','IL','1','McCormick','Keegan','','','','34','270942225','296 BRIGHTON RD',0,'COLUMBUS','OH','43202','1024','CY','39049','1991-02-26','M','U',':RET:2106-3','N','021','DEN','2300256','99734OH005000401','2014-01-01','2013-12-17 17:34:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:46:54'),(13157,10496,'Y','18','021','EC','A','','','AC','0000481078','0000481078','OH00000538277','IL','1','Culliton','Patrick','','','','34','283886351','6763 STAFFORD DR',0,'MAYFIELD HEIGHTS','OH','44124','3612','CY','39035','1978-05-04','M','M',':RET:2106-3','T','021','DEN','2392829','99734OH005000401','2014-01-01','2013-12-23 17:29:59','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:45'),(6450,5112,'N','01','021','EC','A',NULL,NULL,'','0000987374','0000444883','','IL','1','King','Lisa','','','','34','292547884','468 E MAIN ST',0,'PORTAGE','OH','43451','9701','CY','39173','1963-04-12','F','',':RET:2106-3','N','021','HLT','843910','92036OH004002601','2014-01-01','2013-12-10 22:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','280.03',NULL,0,'2013-12-26 00:49:38'),(22001,17568,'Y','18','021','EC','A','','','AC','0000658460','0000658460','OH00002500989','IL','1','Mennetti','Janna',NULL,NULL,NULL,NULL,NULL,'612 DOUGLAS DR',0,'WAUSEON','OH','43567','1613','CY','39051','1968-05-26','F','M',':RET:2106-3','N','021','DEN','3010499','99734OH005000301','2014-03-01','2014-02-06 19:01:02','0.00',NULL,NULL,'87.78','87.78','R-OH001','OH0','0.00',NULL,0,'2014-02-07 19:00:48'),(24112,19168,'Y','18','021','EC','A','','','AC','0000011585','0000011585','TX00002541674','31','1','VASQUEZ','LETICA','','','','34','464088318','PO Box 322',0,'WOLFFORTH','TX','79382',NULL,'CY','48303','1954-11-19','F','M',':RET:2106-3','N','021','DEN','3014517','33348TX002000201','2014-03-01','2014-02-15 12:57:45','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-02-15 22:01:37'),(646,533,'Y','18','021','EC','A','','','AC','0000455297','0000455297','OH00000803931','IL','1','Wheeler','Crystal','Kay','','','34','288641891','607 First Street',0,'Piqua','OH','45356',NULL,'CY','39109','1957-06-06','F','U',NULL,'N','021','DEN','2470962','99734OH005000401','2014-01-01','2013-12-16 15:55:40','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:01:29'),(18189,14521,'Y','18','021','EC','A','','','AC','0000930929','0000930929','OH00001700271','IL','1','fisher','mendelynn','','','','34','301521156','1530 koa dr',0,'springfield','OH','45504',NULL,'CY','39023','1951-05-26','F','U',':RET:2106-3','T','021','HLT','2232608','92036OH004000501','2014-02-01','2014-01-14 17:28:20','503.00',NULL,NULL,'631.50','128.50','R-OH003','OH0','631.50',NULL,0,'2014-01-15 02:08:03'),(17936,14330,'Y','18','024','14','A','','','TE','0000102390','0000102390','','IL','1','ashmore','andrew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-11-15','M','',NULL,NULL,NULL,'','2563645','','2014-01-14','2014-01-14 14:29:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-15 02:06:37'),(9234,7326,'Y','18','024','14','A','','','TE','0000542653','0000542653','','IL','1','Barlow','Jerry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-12-09','M','',NULL,NULL,NULL,'','8782','','2013-12-18','2013-12-18 14:43:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:10:32'),(16677,13347,'Y','18','021','EC','A','','','AC','0000266539','0000266539','OH00002011870','IL','1','kovach','heidi','','','','34','288549011','94 wilpark dr',0,'akron','OH','44312',NULL,'CY','39153','1954-07-29','F','U',':RET:2106-3','N','021','DEN','1646478','99734OH005000301','2014-02-01','2014-01-07 15:03:35','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-08 18:24:30'),(1299,1075,'Y','18','021','EC','A','','','AC','0001228033','0001228033','OH00000298474','IL','1','Kishel','Susan','Marie','','','34','298486796','585 Poland Ave',0,'Struthers','OH','44471',NULL,'CY','39099','1950-02-01','F','U',':RET:2106-3','N','021','HLT','380668','92036OH002003201','2014-01-01','2013-11-29 15:49:15','538.00',NULL,NULL,'825.16','287.16','R-OH013','OH0','825.16',NULL,0,'2013-12-25 18:31:06'),(5921,4689,'Y','18','021','EC','A','','','AC','0000086354','0000086354','TX00000539365','IL','1','Vicuna','Javier','','','','34','456931120','4735 CASA ESPANA ST',0,'SAN ANTONIO','TX','78233','6409','CY','48029','1972-10-12','M','U',NULL,'N','021','DEN','2401423','33348TX002000101','2014-01-01','2013-12-24 00:51:13','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 23:50:17'),(6209,4920,'Y','18','021','EC','A','','','AC','0000937860','0000937860','TX00000826095','IL','1','Hudson','David','Allan','','','34','453876264','712 N RITA ST',0,'WACO','TX','76705','1141','CY','48309','1978-05-02','M','U',NULL,'N','021','DEN','144117','33348TX002000101','2014-01-01','2013-10-16 19:15:45','0.00',NULL,NULL,'25.02','25.02','R-TX024','TX0','25.02',NULL,0,'2013-12-26 00:30:50'),(8955,7103,'Y','18','021','EC','A','','','AC','0001099175','0001099175','OH00001103365','IL','1','Chaney','Todd','','','','34','297509416','2388 SWANSEA RD',0,'COLUMBUS','OH','43221','1824','CY','39049','1962-09-09','M','U',':RET:2106-3','N','021','DEN','2296987','99734OH005000401','2014-01-01','2013-12-18 12:23:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:03:41'),(2066,1691,'Y','18','021','EC','A','','','AC','0000824561','0000824561','OH00001094685','IL','1','Patrick','Carla','','','','34','277666448','5 E Lake View Dr.',0,'Cincinnati','OH','45237',NULL,'CY','39061','1959-09-13','F','U',':RET:2054-5','N','021','DEN','26517','99734OH005000301','2014-01-01','2013-12-10 16:46:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:16:14'),(2612,2123,'Y','18','021','EC','A','','','AC','0000834438','0000834438','OH00000783085','IL','1','Haydn','James','','','','34','300565579','5609 Happy Hollow Road',0,'Milford','OH','45150',NULL,'CY','39025','1956-03-01','M','U',':RET:2106-3','N','021','DEN','1080919','99734OH005000401','2014-01-01','2013-12-02 11:33:14','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 19:45:38'),(4151,3308,'Y','18','021','EC','A','','','AC','0001069309','0001069309','OH00000401842','IL','1','Taylor','Jennifer',NULL,NULL,NULL,NULL,NULL,'111 Terrace View South',0,'Howard','OH','43928',NULL,'CY','39013','1957-10-09','F','U',':RET:2106-3','N','021','DEN','1611367','99734OH005000301','2014-01-01','2013-12-17 13:28:54','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:48:45'),(2731,2209,'Y','18','021','EC','A','','','AC','0000031308','0000031308','LA00000229941','IL','1','Fazande','Latanja','T','','','34','433596218','963 Ave. B',0,'Westwego','LA','70094',NULL,'CY','22051','1984-10-21','F','M',':RET:2054-5','N','021','DEN','639296','18575LA002000201','2014-01-01','2013-12-02 18:07:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:29'),(3009,2419,'Y','18','021','EC','A','','','AC','0000008388','0000008388','OH00000137539','IL','1','GRUBB','PAMELA','SUE','','','34','293521124','1020 ARCHMERE DR',0,'AKRON','OH','44319','2004','CY','39153','1952-02-05','F','U',':RET:2106-3','N','021','HLT','1007466','52664OH151001305','2014-01-01','2013-12-06 14:01:43','497.00',NULL,NULL,'626.65','129.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 20:17:52'),(2811,2272,'Y','18','021','EC','A','','','AC','0000327232','0000327232','OH00000946687','IL','1','Combs','Bradley','','','','34','311861626','3647 MOONRIDGE DR',0,'CINCINNATI','OH','45248','4222','CY','39061','1967-02-17','M','U',NULL,'N','021','DEN','900928','99734OH005000301','2014-01-01','2013-10-15 02:32:09','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:00:14'),(27426,21705,'Y','18','021','EC','A','','','AC','0001863576','0001863576','LA00003084115','IL','1','McCowan','Ernest','','','Jr','34','431436654','3312 TERRACE DRIVE',0,'SHREBEPORT','LA','71107',NULL,'CY','22017','1971-08-17','M','M',':RET:2054-5','N','021','DEN','3501354','18575LA002000201','2014-04-01','2014-03-04 10:43:10','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-04 21:01:42'),(1557,1299,'Y','18','021','EC','A','','','AC','0001036189','0001036189','MS00001604203','IL','1','Lollar','Linda','','','','34','587644268','102 W MAIN ST',0,'CLINTON','MS','39056','4278','CY','28049','1951-12-17','F','U',':RET:2106-3','N','021','DEN','2454368','46300MS002000201','2014-01-01','2013-12-24 14:11:25','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:50:46'),(3165,2547,'Y','18','021','EC','A','','','AC','0000034332','0000034332','OH00000432638','IL','1','McHale-Taylor','Debby','','','','34','288425241','4661 NATHANIEL GLEN DR',0,'CINCINNATI','OH','45248','1540','CY','39061','1950-12-12','F','M',':RET:2106-3','N','021','DEN','852219','99734OH005000401','2014-01-01','2013-11-18 13:02:33','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:26'),(7746,6135,'Y','18','024','14','A','','','TE','0000120032','0000120032','','IL','1','krohn','michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-12-09','M','',NULL,NULL,NULL,'','1093920','','2013-12-20','2013-12-20 16:03:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:02:25'),(4745,3760,'Y','18','021','EC','A','','','AC','0000526757','0000526757','OH00001248127','IL','1','shope','karen','','','','34','283540308','4709 EMBRETT CT',0,'CINCINNATI','OH','45238','4004','CY','39061','1953-02-28','F','M',':RET:2106-3','T','021','HLT','1082647','92036OH003001205','2014-01-01','2013-12-12 18:25:23','368.00',NULL,NULL,'699.68','331.68','R-OH004','OH0','699.68',NULL,0,'2013-12-25 22:09:35'),(15990,12798,'Y','18','021','EC','A','','','AC','0000585592','0000585592','TX00001477697','IL','1','Grace','Robert','','','','34','014449514','735 JOEL DR',0,'TYLER','TX','75703','4841','CY','48423','1953-05-05','M','M',':RET:2054-5','N','021','DEN','2383910','33348TX002000201','2014-02-01','2014-01-03 11:50:06','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-04 02:01:13'),(16336,13079,'Y','18','021','EC','A','','','AC','0001147348','0001147348','OH00001599704','IL','1','Moore','Renee','','','','34','295580816','56594 HOMER WARRICK RD',0,'BARNESVILLE','OH','43713','9673','CY','39013','1966-03-04','F','M',NULL,'N','021','DEN','1967494','99734OH005000301','2014-02-01','2014-01-06 12:16:46','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-07 04:02:08'),(21301,17020,'N','01','021','EC','A',NULL,NULL,'','0001529380','0001477776','','IL','1','Nadjafi Sadati','Seyed','Ali','','','34','659223220','10888 Buddy Ellis Road',0,'Denham Springs','LA','70726',NULL,'CY','22063','1962-11-22','M','',NULL,'N','021','DEN','2636155','18575LA002000201','2014-03-01','2014-02-03 19:04:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-04 21:00:12'),(22499,17961,'Y','18','021','EC','A','','','AC','0000283306','0000283306','OH00002289337','IL','1','Hardy','Scott','','','','34','378942026','229 Carlwood Dr',0,'MIAMISBURG','OH','45342',NULL,'CY','39113','1968-05-03','M','U',NULL,'T','021','DEN','3132958','99734OH005000301','2014-03-01','2014-02-10 14:49:10','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-10 21:31:12'),(23321,18586,'N','01','021','EC','A',NULL,NULL,'','0000205831','0000279597','','IL','1','musselman','charles','randolph','','','34','300802554','6417 CLOUGH PIKE',0,'CINCINNATI','OH','45244','4015','CY','39061','1969-03-06','M','',':RET:2106-3','T','021','DEN','3435312','99734OH005000301','2014-03-01','2014-02-13 12:56:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:24'),(23344,18604,'N','19','021','EC','A',NULL,NULL,'','0000110556','0000765002','','IL','1','Bencina','Chad','Alan','','','34','296983973','38278 Roselawn Street',0,'Willoughby','OH','44094',NULL,'CY','39085','1996-02-20','M','',NULL,'N','021','HLT','3683295','52664OH151001305','2014-03-01','2014-02-12 21:48:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-02-13 22:00:38'),(23479,18701,'N','01','021','EC','A',NULL,NULL,'','0000376184','0001119992','','IL','1','Sullivan','Molly','K','','','34','274802158','4228 CLOUGH LN',0,'CINCINNATI','OH','45245','1711','CY','39025','1982-11-26','F','',':RET:2106-3','T','021','HLT','3278358','92036OH003000601','2014-03-01','2014-02-13 09:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','298.80',NULL,0,'2014-02-13 22:01:53'),(25112,19920,'Y','18','024','14','A','','','TE','0000260611','0000260611','','IL','1','HARPER','CURMERA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-10','F','',NULL,NULL,NULL,'','2576481','','2014-03-31','2014-02-21 14:31:01',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-21 21:30:16'),(27347,21655,'Y','18','021','EC','A','','','AC','0000803790','0000803790','OH00002804125','IL','1','DeBusk','Margaret','','','','34','276600382','10973 PANSING RD',0,'ENGLEWOOD','OH','45322','9749','CY','39113','1955-06-26','F','M',':RET:2106-3','T','021','DEN','3184977','99734OH005000401','2014-04-01','2014-03-04 12:07:39','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-04 21:01:02'),(28337,22421,'Y','18','021','EC','A','','','AC','0000101165','0000101165','TX00003792709','IL','1','White','Michael','','','','34','457985776','8902 Hwy 158',0,'Norton','TX','76865',NULL,'CY','48399','1954-01-28','M','M',':RET:2106-3','N','021','DEN','3130371','33348TX002000201','2014-04-01','2014-03-07 09:48:51','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-07 21:30:14'),(278,229,'N','01','021','EC','A',NULL,NULL,'','0000607558','0000606446','','IL','1','Reyna','Luis','','','','34','639011687','2239 WALNUT FAIR LN',0,'SPRING','TX','77373','2312','CY','48201','1962-05-05','M','',NULL,'N','021','DEN','760727','33348TX002000201','2014-01-01','2013-10-12 13:34:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 17:30:13'),(17271,13815,'N','01','021','EC','A',NULL,NULL,'','0001230407','0000629261','','IL','1','Humberson','Harold','','','Jr','34','285786779','3628 MARCELLA AVE',0,'STOW','OH','44224','4119','CY','39153','1968-01-01','M','',':RET:2106-3','N','021','HLT','2580605','52664OH152000901','2014-02-01','2014-01-09 18:53:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.01',NULL,0,'2014-01-13 02:23:21'),(16957,13572,'N','01','021','EC','A',NULL,NULL,'','0000627891','0000140301','','IL','1','JENKINS','SAMARA','','','','34','527872510','706 MAIN ST',0,'CONNEAUT','OH','44030','2252','CY','39007','1973-04-25','F','',NULL,'N','021','HLT','2367401','52664OH151001306','2014-02-01','2014-01-08 18:50:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','321.44',NULL,0,'2014-01-13 02:20:04'),(16186,12958,'N','19','021','EC','A',NULL,NULL,'','0000657564','0001224247','','IL','1','Johnson','Candace','L','','','34','629149340','13286 FM 1013 RD',0,'SPURGER','TX','77660','5032','CY','48457','1989-09-05','F','',':RET:2106-3','N','021','DEN','1839701','33348TX002000201','2014-02-01','2014-01-03 21:18:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-05 00:00:41'),(15977,12787,'Y','18','021','EC','A','','','AC','0001118161','0001118161','TX00001724980','IL','1','Gashaw','Meron','','','','34','259959211','9186 forest lane',0,'dallas','TX','75243',NULL,'CY','48113','1983-12-15','F','U',':RET:2054-5','N','021','DEN','1730488','33348TX002000201','2014-02-01','2014-01-03 04:39:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-04 02:00:48'),(14213,11334,'Y','18','021','EC','A','','','AC','0000151687','0000151687','TX00000326157','IL','1','O\'neal','Cammi','Shea','','','34','461970766','17906 BUTTE CREEK RD',0,'HOUSTON','TX','77090','1816','CY','48201','1972-10-01','F','R',':RET:2106-3','N','021','DEN','2425613','33348TX002000201','2014-02-01','2013-12-26 15:49:33','0.00',NULL,NULL,'72.22','72.22','R-TX010','TX0','15.85',NULL,0,'2013-12-27 02:04:33'),(4924,3906,'N','01','021','EC','A',NULL,NULL,'','0001217354','0000203050','','IL','1','Whitman','Laura','E','','','34','275608590','10568 CHARNEY AVE NW',0,'UNIONTOWN','OH','44685','9404','CY','39151','1957-10-10','F','',':RET:2106-3','N','021','HLT','573912','52664OH151001305','2014-01-01','2013-12-07 14:12:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-25 22:45:13'),(20640,16493,'Y','18','021','EC','A','','','AC','0000978937','0000978937','TX00002038961','IL','1','Bonner','Linda','','','','34','366601345','3713 COCKRILL DR',0,'MCKINNEY','TX','75070','2417','CY','48085','1956-05-24','F','U',':RET:2106-3','N','021','DEN','2919548','33348TX002000201','2014-03-01','2014-01-30 11:45:29','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-30 21:00:33'),(21929,17513,'N','01','021','EC','A',NULL,NULL,'','0000246042','0000243895','','IL','1','MORENO','MOISES','','','','34','600490980','11362 LONG JOHN DR',0,'EL PASO','TX','79936','3131','CY','48141','1952-09-04','M','',':RET:2106-3','N','021','DEN','3417658','33348TX002000201','2014-03-01','2014-02-06 22:15:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-07 19:00:10'),(25972,20597,'Y','18','021','EC','A','','','AC','0000279607','0000279607','OH00002565124','S3','1','Bregitzer','Kelly','','','','34','288137384','1551 POLK DR',0,'BRUNSWICK','OH','44212','3713','CY','39103','2007-10-24','M','U',':RET:2106-3','N','021','DEN','3057490','99734OH005000401','2014-03-01','2014-02-26 13:32:47','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78',NULL,0,'2014-02-26 21:01:47'),(26312,20876,'Y','18','021','EC','A','','','AC','0000066313','0000066313','OH00002732707','IL','1','LITTLETON','DENNIS','','','','34','406924431','3107 STATE ROUTE 41',0,'MANCHESTER','OH','45144','8194','CY','39001','1960-12-15','M','M',NULL,'N','021','HLT','2925273','92036OH006000601','2014-04-01','2014-02-27 09:49:23','540.00',NULL,NULL,'593.14','53.14','R-OH005','OH0','347.30',NULL,0,'2014-02-28 06:31:34'),(1347,1115,'N','01','021','EC','A',NULL,NULL,'','0000637346','0000287009','','IL','1','Momoh','Nathalie',NULL,NULL,NULL,NULL,NULL,'11246 SIR WINSTON ST',0,'SAN ANTONIO','TX','78216','5450','CY','48029','1980-06-26','F','',':RET:2054-5','N','021','DEN','1610654','33348TX002000101','2014-01-01','2013-12-24 08:47:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 18:45:08'),(5724,4544,'Y','18','021','EC','A','','','AC','0002126111','0002126111','LA00000041236','IL','1','BUECHE','GENE','','','','34','435928262','305 CINDY LN',0,'GRAY','LA','70359','4819','CY','22057','1956-12-23','M','M',':RET:2106-3','N','021','DEN','2415137','18575LA002000201','2014-01-01','2013-12-23 22:32:44','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-25 23:45:29'),(15606,12483,'N','01','021','EC','A',NULL,NULL,'','0000066261','0000540299','','IL','1','Mecklenborg','Evan','','','','34','300980342','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','1980-07-19','M','',':RET:2106-3','N','021','DEN','1692472','99734OH005000301','2014-02-01','2013-12-31 15:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:41'),(24810,19676,'Y','18','021','EC','A','','','AC','0000757194','0000757194','OH00003028633','IL','1','Nowland','Deanna','','','','34','301605166','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1972-01-31','F','M',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05','372.00',NULL,NULL,'798.53','426.53','R-OH005','OH0','228.72',NULL,0,'2014-02-20 04:49:37'),(25497,20227,'Y','18','021','EC','A','','','AC','0000270068','0000270068','OH00002815204','IL','1','TEMPLE','ROBIN','','','','34','286622012','20260 ROEHRIG RD',0,'DEFIANCE','OH','43512','9753','CY','39039','1957-02-21','F','U',':RET:2106-3','N','021','HLT','3633754','92036OH005002605','2014-04-01','2014-02-25 08:33:53','421.00',NULL,NULL,'475.21','54.21','R-OH001','OH0','475.21',NULL,0,'2014-02-25 21:31:52'),(25764,20435,'N','01','021','EC','A',NULL,NULL,'','0001070528','0001048044','','IL','1','EHRMAN','DAVID','','','','34','279504646','6267 BRANCH RD',0,'MEDINA','OH','44256','8942','CY','39103','1959-01-19','M','',NULL,'N','021','HLT','3518090','52664OH151001305','2014-04-01','2014-02-24 17:44:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-02-26 09:30:53'),(27091,21447,'Y','18','021','EC','A','','','AC','0000816484','0000816484','OH00003352077','IL','1','Stone','david','','','','34','297827482','518 BLAINE ST',0,'GENEVA','OH','44041','1610','CY','39007','1984-08-13','M','U',':RET:2106-3','N','021','HLT','3249956','52664OH151001305','2014-04-01','2014-03-03 13:04:10','212.00',NULL,NULL,'281.45','69.45','R-OH011','OH0','281.45',NULL,0,'2014-03-03 21:30:17'),(28825,22813,'Y','18','021','EC','A','','','AC','0001196878','0001196878','OH00003125752','IL','1','burley','kevin','','','','34','295529575','1368 matzinger rd.',0,'toledo','OH','43612',NULL,'CY','39095','1954-04-13','M','M',':RET:2106-3','N','021','HLT','3239184','92036OH004002601','2014-04-01','2014-03-09 15:51:46','602.00',NULL,NULL,'773.93','171.93','R-OH001','OH0','408.14',NULL,0,'2014-03-09 21:01:03'),(23202,18499,'N','19','021','EC','A',NULL,NULL,'','0000401284','0000868277','','S1','1','Budzinski','Aaron','','','','34','679157343','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','2012-06-10','F','',':RET:2106-3','N','021','HLT','3157858','92036OH006002601','2014-03-01','2014-02-12 11:08:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2014-02-12 21:32:09'),(114,100,'Y','18','021','EC','A','','','AC','0000210341','0000210341','TX00000018295','IL','1','jimenez','ernesto','','','','34','456892496','8121 WONDERLAND LN',0,'EL PASO','TX','79907','2319','CY','48141','1977-07-27','M','U',NULL,'N','021','DEN','1033175','33348TX002000201','2014-01-01','2013-12-05 12:49:08','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 17:18:03'),(352,289,'Y','18','021','EC','A','','','AC','0000312355','0000312355','LA00000627743','IL','1','Gray','Christopher','','','','34','438613884','2515 Finch Street',0,'Baton Rouge','LA','70807',NULL,'CY','22033','1969-12-31','M','U',':RET:2054-5','N','021','DEN','112495','18575LA002000201','2014-01-01','2013-11-09 13:27:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:32:18'),(17194,13758,'Y','18','021','EC','A','','','AC','0001919998','0001919998','LA00002373060','IL','1','coleman','hope','','','','34','409598580','11888 Longridge Ave',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1985-12-27','F','U',':RET:2054-5','N','021','DEN','1751869','18575LA002000101','2014-02-01','2014-01-07 21:49:44','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:22:20'),(16768,13414,'Y','18','021','EC','A','','','AC','0001244178','0001244178','OH00001930957','IL','1','gerhart','andrea','','','','34','281843572','629 SKYLES RD',0,'UNION','OH','45322','3229','CY','39113','1976-09-23','F','M',':RET:2106-3','N','021','HLT','2154479','92036OH006000501','2014-02-01','2014-01-07 12:15:56','100.00',NULL,NULL,'353.09','253.09','R-OH003','OH0','233.38',NULL,0,'2014-01-08 18:25:01'),(1761,1454,'N','01','021','EC','A',NULL,NULL,'','0001260013','0000812028','','IL','1','Bepler','Jamie','Lyn','','','34','296760387','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','1978-04-29','F','',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:53'),(1860,1522,'Y','18','021','EC','A','','','AC','0001230390','0001230390','OH00000776090','IL','1','Wilke','Brian','','','','34','302727936','9336 BRYANT RD',0,'WINDHAM','OH','44288','9547','CY','39133','1974-01-28','M','M',':RET:2106-3','N','021','HLT','2563089','52664OH152000901','2014-01-01','2013-12-24 10:59:06','306.00',NULL,NULL,'720.82','414.82','R-OH012','OH0','206.14',NULL,0,'2013-12-25 18:58:08'),(24011,19095,'Y','18','021','EC','A','','','AC','0000403705','0000403705','OH00002017524','IL','1','COMER','ELIZABETH','','','','34','275728501','219 W PROSPECT ST',0,'GIRARD','OH','44420','1719','CY','39155','1962-08-22','F','U',':RET:2054-5','N','021','DEN','3760850','99734OH005000401','2014-03-01','2014-02-14 19:20:22','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-15 22:00:40'),(25181,19973,'N','01','021','EC','A',NULL,NULL,'','0001201943','0000809726','','IL','1','Newburn','Fred','','','','34','268500237','3686 COUNTY ROAD 39',0,'BLOOMINGDALE','OH','43910','7937','CY','39081','1950-09-23','M','',':RET:2106-3','T','021','DEN','3606094','99734OH005000401','2014-04-01','2014-02-21 13:25:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:34'),(26525,21035,'Y','18','024','14','A','','','TE','0000476002','0000476002','','IL','1','Stevens','Gregory','Alan',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-02-27','M','',NULL,NULL,NULL,'','3844390','','2014-02-28','2014-02-28 14:55:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 21:00:26'),(28751,22755,'N','01','021','EC','A',NULL,NULL,'','0000825803','0000284384','','IL','1','GURROLA','NELLIE','','','','34','466377060','5300 STANDARD AVE',0,'SAN JUAN','TX','78589','4984','CY','48215','1976-06-06','F','',NULL,'N','021','DEN','3941251','33348TX002000201','2014-04-01','2014-03-08 23:38:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-09 21:00:16'),(28954,22915,'Y','18','024','14','A','','','TE','0001784088','0001784088','','IL','1','phillips','stephen','michael',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-08-17','M','',NULL,NULL,NULL,'','3663641','','2014-03-10','2014-03-10 11:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-10 21:00:52'),(13495,10755,'N','01','021','EC','A',NULL,NULL,'','0000645986','0000966909','','IL','1','Giovannazzo','Emily','J','','','34','039563320','26311 LAKE RD',0,'BAY VILLAGE','OH','44140','2570','CY','39035','1977-03-08','F','',':RET:2106-3','N','021','DEN','2373290','99734OH005000301','2014-01-01','2013-12-23 18:14:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:27'),(9620,7618,'N','01','021','EC','A',NULL,NULL,'','0000318404','0000910516','','IL','1','Kesson','Jennifer','Marie','','','34','296844563','2944 W CENTRAL AVE',0,'TOLEDO','OH','43606','3022','CY','39095','1986-06-05','F','',NULL,'N','021','HLT','1487161','92036OH005002605','2014-01-01','2013-12-20 19:57:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.35',NULL,0,'2013-12-26 04:37:53'),(18142,14487,'Y','18','021','EC','A','','','AC','0001833697','0001833697','LA00002549866','31','1','RUTHERFORD','CONNIE','','','','34','437924271','P.O. BOX 668',0,'LAPLACE','LA','70069',NULL,'CY','22095','1952-11-26','F','U',NULL,'N','021','DEN','2104509','18575LA002000101','2014-02-01','2014-01-14 14:32:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-15 02:07:47'),(5362,4252,'Y','18','021','EC','A','','','AC','0001259994','0001259994','OH00000313550','IL','1','Young','James','','','','34','289505676','4355 BEAL RD',0,'FRANKLIN','OH','45005','4515','CY','39165','1951-08-30','M','M',':RET:2106-3','N','021','HLT','2573194','92036OH005001201','2014-01-01','2013-12-18 19:52:44','606.00',NULL,NULL,'1219.98','613.98','R-OH004','OH0','616.74',NULL,0,'2013-12-25 23:07:53'),(14525,11589,'Y','18','021','EC','A','','','AC','0000741335','0000741335','TX00001506318','IL','1','ortiz','moises','','','','34','618501296','200 lincoln',0,'College Station','TX','77840',NULL,'CY','48041','1991-10-27','M','U',':RET:2106-3','N','021','DEN','2470221','33348TX002000201','2014-02-01','2013-12-27 17:27:38','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-28 03:34:24'),(21940,17520,'Y','18','021','EC','A','','','AC','0001099357','0001099357','TX00002648122','IL','1','Lopez','Mary','Helen','','','34','463353361','174 Willee Drive',0,'San Antonio','TX','78228',NULL,'CY','48029','1961-08-18','F','U',NULL,'N','021','DEN','3848206','33348TX002000201','2014-03-01','2014-02-07 16:13:15','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-07 19:00:14'),(22358,17855,'N','19','021','EC','A',NULL,NULL,'','0000948462','0000486980','','IL','1','TUZZEO','JULIAN','G','','','34','276983732','115 HIGHLAND MIST CIR',0,'HINCKLEY','OH','44233','9354','CY','39103','1994-11-20','M','',':RET:2106-3','N','021','DEN','3504412','99734OH005000401','2014-03-01','2014-02-10 10:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-10 21:00:06'),(25836,20481,'N','01','021','EC','A',NULL,NULL,'','0000165141','0000123026','','IL','1','Hook','Jeremy','','','','34','281763901','939 HENRY ST',0,'MARION','OH','43302','7136','CY','39101','1980-06-20','M','',':RET:2106-3','N','021','DEN','3352970','99734OH005000301','2014-04-01','2014-02-26 17:47:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:32'),(26906,21324,'N','01','021','EC','A',NULL,NULL,'','0001929136','0001482118','','IL','1','radaideh','tuleen','F','','','34','717341793','1436 delplaza apt B',0,'baton rouge','LA','70815',NULL,'CY','22033','1983-07-31','F','',NULL,'N','021','DEN','2996679','18575LA002000201','2014-04-01','2014-03-01 19:58:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-03 01:00:10'),(28525,22575,'Y','18','021','EC','A','','','AC','0000260532','0000260532','OH00003420068','IL','1','GILLIG','ROBERTA','LEE','','','34','281504894','316 OHIO AVE',0,'TIFFIN','OH','44883',NULL,'CY','39147','1951-06-02','F','U',NULL,'N','021','HLT','2760525','92036OH003002704','2014-04-01','2014-03-07 07:31:42','459.00',NULL,NULL,'585.04','126.04','R-OH006','OH0','585.04',NULL,0,'2014-03-07 21:32:03'),(260,215,'N','01','021','EC','A',NULL,NULL,'','0000197129','0001119931','','IL','1','Mason','Chad','','','','34','300668348','1947 providence ave',0,'Springfield','OH','45503',NULL,'CY','39023','1971-02-08','M','',':RET:2106-3','N','021','HLT','14504','92036OH004000501','2014-01-01','2013-12-05 08:24:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.26',NULL,0,'2013-12-25 17:21:49'),(18724,14924,'Y','18','021','EC','A','','','AC','0000965799','0000965799','OH00001407443','IL','1','McDannell','Ryan','Lee','','','34','295861148','333 Rear Springs',0,'Upper Sandusky','OH','43351',NULL,'CY','39175','1987-09-10','M','U',':RET:2106-3','N','021','DEN','2811509','99734OH005000301','2014-02-01','2014-01-15 23:28:22','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-01-17 03:35:35'),(17598,14067,'Y','18','021','EC','A','','','AC','0001197046','0001197046','MS00002276271','IL','1','Lathon','Bruce','','','','34','332508827','131 THAMES CIR',0,'FLORENCE','MS','39073','8495','CY','28121','1955-10-07','M','U',':RET:2054-5','N','021','DEN','1459940','46300MS002000201','2014-02-01','2014-01-13 16:48:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-14 01:32:14'),(14506,11572,'Y','18','021','EC','A','','','AC','0001011540','0001011540','TX00001188530','IL','1','Leth','Corrine','','','','34','528317737','15180 FM 2484',0,'SALADO','TX','76571','5341','CY','48027','1978-01-11','F','U',':RET:2106-3','N','021','DEN','1831418','33348TX002000201','2014-02-01','2013-12-27 15:07:03','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-28 03:33:55'),(16892,13517,'Y','18','021','EC','A','','','AC','0000209389','0000209389','TX00001400768','IL','1','Fleming','Teri','','','','34','453020346','291 SAILFISH DR',0,'MABANK','TX','75156','1927','CY','48213','1960-06-22','F','U',':RET:2106-3','N','021','DEN','1715855','33348TX002000201','2014-02-01','2014-01-09 17:22:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:27'),(2682,2172,'Y','18','021','EC','A','','','AC','0000044236','0000044236','OH00001133116','IL','1','Horan','Thomas','','','','34','102445121','9110 CATTAIL LN',0,'WEST CHESTER','OH','45069','2983','CY','39017','1959-10-31','M','U',':RET:2106-3','N','021','DEN','1086','99734OH005000301','2014-01-01','2013-12-02 16:23:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:47:14'),(13985,11142,'N','01','021','EC','A',NULL,NULL,'','0000319666','0000708935','','IL','1','Seeman','Margie','','','','34','268580795','205 WOODLAND AVE',0,'SWANTON','OH','43558','1050','CY','39051','1955-06-29','F','',NULL,'N','021','HLT','1738721','92036OH001002601','2014-01-01','2013-12-23 00:19:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','599.30',NULL,0,'2013-12-26 13:15:41'),(3440,2765,'Y','18','021','EC','A','','','AC','0000605951','0000605951','OH00000751739','IL','1','tran','trang','','','','34','301089052','3315 BARBARA LEE LN',0,'DAYTON','OH','45424','6203','CY','39113','1966-03-01','M','U',':RET:2047-9','N','021','DEN','1749934','99734OH005000401','2014-01-01','2013-12-21 18:48:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:19:12'),(20398,16293,'Y','18','021','EC','A','','','AC','0000756932','0000756932','TX00002120733','IL','1','DELARION','PATRICIA','','','','34','228749116','4039 TRAVIS ST',0,'DALLAS','TX','75204','7514','CY','48113','1950-08-27','F','U',NULL,'N','021','DEN','2860720','33348TX002000201','2014-03-01','2014-01-29 14:22:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:18'),(20890,16695,'Y','18','021','EC','A','','','AC','0000053091','0000053091','OH00001510682','IL','1','Yaegel','Joseph','Patrick','','','34','407196485','4283 BANTAM LN',0,'CINCINNATI','OH','45245','1406','CY','39025','1979-08-05','M','M',':RET:2106-3','N','021','DEN','3559209','99734OH005000401','2014-03-01','2014-01-31 10:22:56','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-31 21:01:14'),(21139,16891,'Y','18','021','EC','A','','','AC','0000584548','0000584548','TX00002132623','IL','1','NGUYEN','HEIDI','','','','34','586383419','19134 WALBROOK MEADOWS LN',0,'CYPRESS','TX','77433','2762','CY','48201','1949-11-01','F','U',NULL,'N','021','DEN','3021685','33348TX002000201','2014-03-01','2014-02-03 16:38:26','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-03 21:00:21'),(23884,19001,'N','19','021','EC','A',NULL,NULL,'','0000833460','0001059516','','IL','1','Orue','Ethan','','','','34','286085109','6720 GREENFIELD DR',0,'CINCINNATI','OH','45224','1643','CY','39061','2003-08-19','M','',':RET:2106-3','N','021','HLT','2952696','92036OH002001201','2014-03-01','2014-02-14 13:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','157.43',NULL,0,'2014-02-14 21:32:15'),(28571,22610,'Y','18','024','14','A','','','TE','0000232163','0000232163','','IL','1','YEUNG','MINOON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-12','F','',NULL,NULL,NULL,'','3976602','','2014-03-07','2014-03-07 18:29:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-08 21:00:02'),(1161,958,'Y','18','021','EC','A','','','AC','0000197392','0000197392','LA00000466479','IL','1','Capes','Milam','N','','','34','441909711','1868 Forsythe Ave',0,'Monroe','LA','71201',NULL,'CY','22073','1986-08-06','M','R',':RET:2106-3','N','021','DEN','977139','18575LA002000201','2014-01-01','2013-12-03 16:38:08','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 18:18:53'),(13820,11031,'N','19','021','EC','A',NULL,NULL,'','0001143316','0000242708','','IL','1','Kuntz','Eliana','','','','34','274175903','2684 WADSWORTH RD',0,'NORTON','OH','44203','5368','CY','39153','2011-03-15','F','',':RET:2106-3','N','021','HLT','2184575','52664OH152000901','2014-01-01','2013-12-22 20:11:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 13:11:52'),(2976,2397,'Y','18','021','EC','A','','','AC','0001227912','0001227912','TX00000670676','IL','1','Patterson','William','','','','34','453256407','223 TURQUOISE TRADE DR',0,'LA MARQUE','TX','77568','6635','CY','48167','1959-08-29','M','U',':RET:2106-3','N','021','DEN','328030','33348TX002000201','2014-01-01','2013-12-05 18:44:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:17:07'),(4613,3653,'Y','18','021','EC','A','','','AC','0000759690','0000759690','OH00000929522','IL','1','Collins','Karin','','','','34','297828643','3760 Fairway Park Dr',0,'Copley','OH','44321',NULL,'CY','39153','1968-04-17','F','U',':RET:2106-3','N','021','HLT','103388','52664OH151001501','2014-01-01','2013-12-12 12:39:09','0.00',NULL,NULL,'386.22','386.22','R-OH012','OH0','386.22',NULL,0,'2013-12-25 22:06:03'),(13365,10675,'Y','18','021','EC','A','','','AC','0001025498','0001025498','OH00001205687','IL','1','Carter','Takeesha','','','','34','198544888','3776 MARTHA JANE PL',0,'CANAL WINCHESTER','OH','43110','8112','CY','39049','1975-01-13','F','U',':RET:2054-5','N','021','DEN','1616286','99734OH005000301','2014-01-01','2013-12-22 20:06:01','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:59:35'),(21328,17043,'Y','18','021','EC','A','','','AC','0001005719','0001005719','OH00001903143','IL','1','Watts','Glenda','','','','34','290588321','12513 CRENNELL AVE',0,'CLEVELAND','OH','44105','4521','CY','39035','1955-09-21','F','U',':RET:2054-5','N','021','HLT','3542562','52664OH152000901','2014-03-01','2014-02-04 12:19:17','283.00',NULL,NULL,'469.40','186.40','R-OH011','OH0','469.40',NULL,0,'2014-02-04 21:00:26'),(22148,17679,'Y','18','021','EC','A','','','AC','0000452790','0000452790','OH00002101959','IL','1','Vittoria','Biagio','','','','34','048521633','45 VALENTINE FARMS DR',0,'AKRON','OH','44333','2551','CY','39103','1955-05-29','M','M',':RET:2106-3','N','021','HLT','2712971','52664OH151001305','2014-03-01','2014-02-08 12:06:37','968.00',NULL,NULL,'1194.87','226.87','R-OH012','OH0','568.22',NULL,0,'2014-02-08 19:00:52'),(25520,20246,'Y','18','021','EC','A','','','AC','0001032657','0001032657','OH00002883278','IL','1','Newton','Margaret','','','','34','271525872','1120 southern ln',0,'toledo','OH','43615',NULL,'CY','39095','1950-08-12','F','U',NULL,'N','021','HLT','2883052','92036OH003002605','2014-04-01','2014-02-25 17:03:09','433.00',NULL,NULL,'601.12','168.12','R-OH001','OH0','601.12',NULL,0,'2014-02-25 21:32:06'),(9467,7510,'Y','18','021','EC','A','','','AC','0000953243','0000953243','OH00000181008','31','1','Kiser','Terry',NULL,NULL,NULL,NULL,NULL,'PO Box 353',0,'Commercial Point','OH','43116',NULL,'CY','39129','1960-06-14','F','M',':RET:2106-3','T','021','DEN','1374202','99734OH005000401','2014-01-01','2013-12-21 10:14:43','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:34:21'),(7504,5936,'Y','18','021','EC','A','','','AC','0000696797','0000696797','OH00000713704','IL','1','Krueger','Timothy','','','','34','282824632','3715 KENMORE AVE',0,'PARMA','OH','44134','2429','CY','39035','1978-06-18','M','U',':RET:2106-3','N','021','DEN','808444','99734OH005000401','2014-01-01','2013-12-15 16:59:52','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:31:55'),(4074,3255,'N','01','021','EC','A',NULL,NULL,'','0000629231','0000921903','','IL','1','Paulo','Salome','Daniel','','','34','288136241','3450 Partridge place',0,'Columbus','OH','43231',NULL,'CY','39049','1976-02-05','F','',':RET:2054-5','N','021','DEN','1615999','99734OH005000401','2014-01-01','2013-12-17 18:22:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:47:00'),(4183,3328,'Y','18','021','EC','A','','','AC','0000187457','0000187457','OH00001263575','IL','1','Sheller','Jerry','','','','34','296504325','11951 WHITMAN RD',0,'DOYLESTOWN','OH','44230','9733','CY','39169','1957-05-17','M','M',':RET:2106-3','N','021','HLT','2170046','52664OH151001304','2014-01-01','2013-12-17 08:53:20','673.00',NULL,NULL,'955.59','282.59','R-OH014','OH0','520.28',NULL,0,'2013-12-25 21:49:28'),(16748,13397,'Y','18','021','EC','A','','','AC','0000456754','0000456754','TX00002380358','IL','1','Bell','Anna','','','','34','458250495','2592 County Road 421',0,'El Campo','TX','77437',NULL,'CY','48481','1960-07-23','F','M',':RET:2106-3','N','021','DEN','1402105','33348TX002000101','2014-02-01','2014-01-07 08:24:38','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-08 18:24:53'),(22654,18089,'Y','18','021','EC','A','','','AC','0000697213','0000697213','TX00002375140','IL','1','Barnes','Erica','','','','34','462839095','23804 FM 15',0,'Troup','TX','75789',NULL,'CY','48423','1973-08-07','F','R',':RET:2106-3','N','021','DEN','2841408','33348TX002000201','2014-03-01','2014-02-11 12:02:36','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-11 21:00:30'),(25758,20431,'Y','18','021','EC','A','','','AC','0000988938','0000988938','OH00002443263','IL','1','Lehman','William','J','','','34','294440814','5677 SALEM RD',0,'CINCINNATI','OH','45230','2721','CY','39061','1958-11-06','M','R',':RET:2106-3','N','021','HLT','3526941','92036OH002001201','2014-04-01','2014-02-24 07:14:29','0.00',NULL,NULL,'1082.12','1082.12','R-OH004','OH0','552.84',NULL,0,'2014-02-26 09:30:50'),(266,219,'N','01','021','EC','A',NULL,NULL,'','0000268872','0001019238','','IL','1','Caprilla','Misty','Ann','','','34','279880966','5350 W BREESE RD',0,'LIMA','OH','45806','9458','CY','39003','1980-08-09','F','',':RET:2106-3','N','021','HLT','463944','92036OH006001501','2014-01-01','2013-12-05 17:22:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','209.09',NULL,0,'2013-12-25 17:21:57'),(20111,16046,'Y','18','021','EC','A','','','AC','0000067697','0000067697','OH00001658265','IL','1','Bartley','Tonya','','','','34','272825121','1056 Mindy Lane',0,'Wooster','OH','44691',NULL,'CY','39169','1968-05-20','F','U',':RET:2106-3','T','021','HLT','3332789','52664OH152000901','2014-03-01','2014-01-27 16:07:04','271.24',NULL,NULL,'271.24','0.00','R-OH014','OH0','271.24',NULL,0,'2014-01-27 21:00:40'),(19206,15301,'Y','18','021','EC','A','','','AC','0000836658','0000836658','OH00002047684','IL','1','shanes','lisa','','','','34','272546285','5042 EVERTON AVE',0,'SOLON','OH','44139','1281','CY','39035','1958-09-13','F','M',':RET:2106-3','N','021','DEN','2895384','99734OH005000401','2014-03-01','2014-01-19 19:33:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:19'),(2388,1949,'Y','18','024','14','A','','','TE','0000231480','0000231480','','IL','1','Conner','Chasity',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1993-08-04','F','',NULL,NULL,NULL,'','141745','','2013-12-09','2013-12-09 11:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:33:12'),(3754,3004,'Y','18','021','EC','A','','','AC','0001178162','0001178162','OH00000119934','IL','1','TAYLOR','EVA','L','','','34','279505166','1111 INDEPENDENCE AVE',0,'AKRON','OH','44310',NULL,'CY','39153','1950-03-17','F','U',':RET:2054-5','N','021','HLT','17897','52664OH151001305','2014-01-01','2013-12-13 17:39:57','534.00',NULL,NULL,'658.32','124.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 21:33:15'),(9462,7506,'Y','18','021','EC','A','','','AC','0001178172','0001178172','OH00000434679','IL','1','Walker','Richard','','','','34','300565134','2064 QUAIL CT',0,'CINCINNATI','OH','45240','2749','CY','39061','1957-03-07','M','M',':RET:2054-5^:RET:2106-3','T','021','DEN','2287925','99734OH005000401','2014-01-01','2013-12-21 00:21:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:15'),(5342,4236,'N','01','021','EC','A',NULL,NULL,'','0000524479','0001249579','','IL','1','Landry','Christine','Mary','','','34','279502516','3188 SURREY HILL LN',0,'STOW','OH','44224','4757','CY','39153','1950-02-23','F','',':RET:2106-3','N','021','DEN','1766512','99734OH005000301','2014-01-01','2013-12-19 15:26:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:07:23'),(13678,10913,'N','01','021','EC','A',NULL,NULL,'','0000872037','0000733588','','IL','1','Thielenhaus','Brenda','Jean','','','34','275805507','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1969-07-15','F','',':RET:2106-3','N','021','HLT','2392738','52664OH151001305','2014-01-01','2013-12-22 19:09:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2013-12-26 13:08:05'),(18429,14703,'Y','18','021','EC','A','','','AC','0001214411','0001214411','LA00001615447','IL','1','Dethloff','Deanna','','','','34','587576303','54027B WHITPALM DR',0,'INDEPENDENCE','LA','70443','3123','CY','22105','1987-07-16','F','U',':RET:2106-3','N','021','DEN','2821004','18575LA002000201','2014-02-01','2014-01-15 14:07:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-16 08:45:57'),(19296,15382,'Y','18','021','EC','A','','','AC','0001162295','0001162295','LA00001851511','IL','1','PAVON','REINA','','','','34','630682010','38064 DUPLESSIS RD',0,'PRAIRIEVILLE','LA','70769',NULL,'CY','22005','1975-10-09','F','U',NULL,'N','021','DEN','3127938','18575LA002000201','2014-03-01','2014-01-21 15:56:01','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:58'),(23551,18762,'Y','18','021','EC','A','','','AC','0002165910','0002165910','LA00002212514','IL','1','WEYAND','MARLENE','','','','34','449861657','704 BLARNEY ST',0,'BOYCE','LA','71409','9850','CY','22079','1949-06-02','F','U',NULL,'N','021','DEN','3124774','18575LA002000201','2014-03-01','2014-02-13 15:51:28','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-13 22:02:38'),(24808,19674,'Y','18','021','EC','A','','','AC','0000042107','0000042107','OH00002280950','IL','1','Baker','Jason','','','','34','283765267','5664 CHEVIOT RD',0,'CINCINNATI','OH','45247','7023','CY','39061','1979-06-19','M','U',':RET:2106-3','N','021','DEN','2934802','99734OH005000401','2014-04-01','2014-02-19 15:26:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:49:15'),(26537,21043,'N','01','021','EC','A',NULL,NULL,'','0000990113','0000805171','','IL','1','Tyree','Lee','E','','','34','232048143','347 Texas Rd',0,'Gallipolis','OH','45631',NULL,'CY','39053','1963-05-01','M','',':RET:2106-3','N','021','DEN','2794115','99734OH005000301','2014-03-01','2014-02-27 19:52:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:05'),(3296,2656,'Y','18','021','EC','A','','','AC','0000279546','0000279546','OH00000289028','IL','1','Worley','Beverly',NULL,NULL,NULL,NULL,NULL,'2189 N STATE ROUTE 123',0,'LEBANON','OH','45036','9781','CY','39165','1964-08-08','F','M',':RET:2106-3','N','021','DEN','1792131','99734OH005000301','2014-01-01','2013-12-22 11:07:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:15:37'),(18943,15093,'Y','18','021','EC','A','','','AC','0000835320','0000835320','TX00002188335','IL','1','Erwin','Geraldine','','','','34','459082112','PO BOX 711',0,'Judson','TX','75660',NULL,'CY','48183','1953-10-19','F','M',':RET:2106-3','N','021','DEN','2489911','33348TX002000201','2014-03-01','2014-01-16 18:51:24','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-20 08:05:44'),(18047,14418,'Y','18','021','EC','A','','','AC','0000459806','0000459806','MS00001480482','IL','1','Howe','Carla','','','','34','410021388','7048 Foxhall Drive',0,'Horn Lake','MS','38637',NULL,'CY','28033','1961-03-09','F','U',':RET:2106-3','T','021','DEN','1775800','46300MS002000101','2014-02-01','2014-01-14 00:17:51','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-15 02:07:15'),(9349,7410,'Y','18','021','EC','A','','','AC','0002337209','0002337209','LA00000929936','IL','1','Robinson','Patricia','','','','34','434049180','224 Ocean Drive',0,'Baton Rouge','LA','70806',NULL,'CY','22033','1957-10-16','F','U',':RET:2054-5','N','021','DEN','2155048','18575LA002000201','2014-01-01','2013-12-20 23:19:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:11'),(15509,12407,'N','01','021','EC','A',NULL,NULL,'','0000539292','0000725066','','IL','1','cleveland','kyle','','','','34','379647178','383 DAY LIGHT LN',0,'POWELL','OH','43065','8213','CY','39041','1957-11-19','M','',':RET:2106-3','N','021','DEN','1522065','99734OH005000401','2014-02-01','2013-12-31 14:43:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:55'),(7221,5723,'Y','18','024','14','A','','','TE','0000690707','0000690707','','IL','1','Sarisky','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-03','M','',NULL,NULL,NULL,'','5673','','2013-12-14','2013-12-14 12:12:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:01:08'),(16899,13522,'N','01','021','EC','A',NULL,NULL,'','0000980556','0001056710','','IL','1','Murphy','Delonte','','','','34','578046608','1077 JUNE DR',0,'XENIA','OH','45385','3725','CY','39057','1981-02-03','M','',':RET:2054-5','T','021','DEN','1449712','99734OH005000401','2014-02-01','2014-01-09 10:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:19:31'),(16497,13198,'Y','18','021','EC','A','','','AC','0000731216','0000731216','OH00002266103','IL','1','BARNHART','JANICE','LYNN','','','34','269526310','10104 US ROUTE 127',0,'WEST MANCHESTER','OH','45382','9711','CY','39135','1950-05-24','F','U',NULL,'N','021','HLT','1731762','92036OH004000501','2014-02-01','2014-01-06 09:56:27','531.00',NULL,NULL,'564.22','33.22','R-OH003','OH0','564.22',NULL,0,'2014-01-07 04:06:41'),(16114,12908,'Y','18','021','EC','A','','','AC','0000797775','0000797775','MS00001260556','IL','1','Seals','Mona','','','','34','587394451','698 Progress Road',0,'Poplarville','MS','39470',NULL,'CY','28109','1966-11-27','F','U',':RET:2106-3','N','021','DEN','1783489','46300MS002000101','2014-02-01','2014-01-03 17:06:10','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-04 02:05:11'),(14416,11498,'Y','18','021','EC','A','','','AC','0000689561','0000689561','TX00000413679','IL','1','Mirelez','David','','','','34','450158425','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1963-05-22','M','M',NULL,'N','021','DEN','1586934','33348TX002000101','2014-02-01','2013-12-27 10:15:30','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:35'),(21409,17111,'Y','18','021','EC','A','','','AC','0001236606','0001236606','OH00001751599','IL','1','Vignos','Douglas','','','','34','294627675','303 WESTLAND AVE NW',0,'MASSILLON','OH','44646','3375','CY','39151','1957-04-22','M','U',':RET:2106-3','T','021','DEN','3295102','99734OH005000401','2014-03-01','2014-02-04 15:28:53','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-04 21:01:07'),(22077,17621,'Y','18','024','14','A','','','TE','0002074915','0002074915','','IL','1','Stevenson','Bernita',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-24','F','',NULL,NULL,NULL,'','3292472','','2014-02-07','2014-02-07 21:35:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-08 19:00:16'),(24086,19151,'N','19','021','EC','A',NULL,NULL,'','0000289573','0000834504','','IL','1','ZILER','KAITLIN','LEIGH','','','34','284157601','4870 INDUSTRY RD',0,'RAVENNA','OH','44266','9398','CY','39133','2009-08-26','F','',':RET:2106-3','N','021','HLT','2907628','52664OH151001305','2014-03-01','2014-02-15 14:09:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:24'),(24742,19638,'N','19','021','EC','A',NULL,NULL,'','0000027939','0001135222','','IL','1','Dugan','Matthew','J','','','34','284988688','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1995-05-29','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:38'),(842,696,'N','01','021','EC','A',NULL,NULL,'','0000240330','0000221273','','IL','1','Brandt','Randy','','','','34','172466365','315 GALEWOOD DR',0,'NEW CARLISLE','OH','45344','1310','CY','39023','1956-09-08','M','',':RET:2106-3','T','021','HLT','2252235','92036OH006000501','2014-01-01','2013-12-16 14:35:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','528.33',NULL,0,'2013-12-25 18:06:38'),(1830,1501,'Y','18','021','EC','A','','','AC','0000232657','0000232657','OH00001192366','IL','1','Lycan','Timothy','','','','34','306989908','4492 RIDGEDALE DR',0,'AKRON','OH','44319','4537','CY','39153','1987-04-07','M','M',':RET:2106-3','N','021','HLT','1823807','52664OH151001305','2014-01-01','2013-12-24 10:04:23','270.00',NULL,NULL,'456.72','186.72','R-OH012','OH0','228.36',NULL,0,'2013-12-25 18:57:25'),(3127,2512,'Y','18','024','14','A','','','TE','0000153327','0000153327','','IL','1','Lambert','Kristopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-07-04','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-13 14:46:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 20:30:24'),(14260,11374,'Y','18','021','EC','A','','','AC','0002088438','0002088438','LA00001537538','IL','1','Carter','Lois','','','','34','435880300','316 GWEN DR',0,'SLIDELL','LA','70458','8339','CY','22103','1952-01-02','F','U',':RET:2054-5','N','021','DEN','2458662','18575LA002000101','2014-02-01','2013-12-26 12:20:14','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-27 02:05:47'),(13624,10863,'Y','18','021','EC','A','','','AC','0001207158','0001207158','OH00000260050','IL','1','McElderry','David','L','','','34','276484834','412 LINCOLN AVE',0,'LIMA','OH','45805','3352','CY','39003','1953-08-22','M','M',':RET:2106-3','N','021','HLT','2138613','92036OH005001505','2014-01-01','2013-12-23 10:19:36','535.00',NULL,NULL,'597.30','62.30','R-OH002','OH0','597.30',NULL,0,'2013-12-26 13:05:56'),(13604,10849,'N','01','021','EC','A',NULL,NULL,'','0001084148','0001187641','','IL','1','Smith','Sarah','','','','34','270868629','10530 SPENCERVILLE RD',0,'SPENCERVILLE','OH','45887','9710','CY','39003','1979-07-19','F','',NULL,'N','021','HLT','1455439','92036OH003001501','2014-01-01','2013-12-23 17:20:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','279.02',NULL,0,'2013-12-26 13:05:29'),(9117,7233,'Y','18','021','EC','A','','','AC','0000886887','0000886887','OH00000338101','IL','1','ELLIS','AMOS','','','','34','270901132','2076 WENDYS DRIVE',0,'COLOMBUS','OH','43220',NULL,'CY','39049','1988-10-31','M','U',':RET:2054-5','T','021','DEN','2151650','99734OH005000301','2014-01-01','2013-12-18 17:31:25','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:07:40'),(8878,7039,'Y','18','024','14','A','','','TE','0000272784','0000272784','','IL','1','ACOSTA MORALES','GENOVEVA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-01-28','F','',NULL,NULL,NULL,'','843652','','2013-12-18','2013-12-18 14:42:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:01:43'),(9392,7448,'Y','18','024','14','A','','','TE','0000040945','0000040945','','IL','1','Pierce','Bradley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-03-26','M','',NULL,NULL,NULL,'','26171','','2013-12-20','2013-12-20 20:46:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:32:23'),(5671,4499,'Y','18','024','14','A','','','TE','0001207116','0001207116','','IL','1','wilson','vicki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-26','F','',NULL,NULL,NULL,'','843665','','2013-11-26','2013-11-26 15:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:32:03'),(9296,7370,'Y','18','021','EC','A','','','AC','0000772610','0000772610','OH00000826225','IL','1','MCKINNEY','TAMARA','','','','34','285667400','12514 SPRINGWATER AVE NW',0,'UNIONTOWN','OH','44685','8292','CY','39151','1958-07-28','F','M',':RET:2106-3','N','021','HLT','685693','52664OH151001305','2014-01-01','2013-11-30 12:26:05','842.00',NULL,NULL,'1077.80','235.80','R-OH015','OH0','497.31',NULL,0,'2013-12-26 04:16:15'),(21193,16937,'Y','18','021','EC','A','','','AC','0001084928','0001084928','MS00001417265','31','1','Washington','marilyn','ann','','','34','425154025','p.o. box 74',0,'webb','MS','38966',NULL,'CY','28135','1958-09-24','F','M',':RET:2054-5','N','021','DEN','3352374','46300MS002000101','2014-03-01','2014-02-03 15:01:21','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-03 21:00:49'),(22347,17847,'Y','18','021','EC','A','','','AC','0000245018','0000245018','OH00002109084','IL','1','PURDIE JUNIOR','NATHANIEL','','','','34','284522026','553 VILLA AVE',0,'AKRON','OH','44310','3943','CY','39153','1953-10-03','M','U',NULL,'T','021','HLT','2778282','52664OH152000901','2014-03-01','2014-01-24 09:42:39','344.00',NULL,NULL,'509.80','165.80','R-OH012','OH0','509.80',NULL,0,'2014-02-10 11:01:12'),(23128,18434,'Y','18','021','EC','A','','','AC','0000064928','0000064928','OH00002280755','IL','1','Vibbert','Susan','','','','34','276607475','6001 MARINE PKWY',0,'MENTOR ON THE LAKE','OH','44060','2877','CY','39085','1956-09-07','F','U',':RET:2106-3','T','021','DEN','3844569','99734OH005000401','2014-03-01','2014-02-12 16:16:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:28'),(23170,18472,'Y','18','021','EC','A','','','AC','0000732968','0000732968','TX00001794314','31','1','Conde','Jessenia','','','','34','463852822','14466 West Bus 83',0,'Harlingen','TX','78552',NULL,'CY','48061','1980-04-25','F','U',':RET:2106-3','N','021','DEN','2664616','33348TX002000101','2014-03-01','2014-02-12 18:01:35','0.00',NULL,NULL,'25.02','25.02','R-TX005','TX0','25.02',NULL,0,'2014-02-12 21:31:52'),(27135,21482,'Y','18','021','EC','A','','','AC','0000976797','0000976797','OH00003191994','IL','1','finnell','patrick','','','','34','293640929','204 PLUM ST',0,'DANVILLE','OH','43014','9608','CY','39083','1960-12-28','M','U',':RET:2106-3','N','021','DEN','3398103','99734OH005000401','2014-04-01','2014-03-03 08:50:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:43'),(27770,21960,'Y','18','021','EC','A','','','AC','0001555400','0001555400','LA00002683532','IL','1','Scorsone','Lauren','','','','34','438175361','125 MADEWOOD DR',0,'MANDEVILLE','LA','70471','8230','CY','22103','1963-07-05','F','U',':RET:2106-3','N','021','DEN','3104519','18575LA002000201','2014-04-01','2014-03-05 15:52:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:26'),(13542,10798,'Y','18','021','EC','A','','','AC','0001476617','0001476617','LA00000342285','IL','1','Mamon','Monica','','','','34','433451991','1237 Farmerville Highway',0,'Ruston','LA','71270',NULL,'CY','22061','1981-07-17','F','U',NULL,'N','021','DEN','1889950','18575LA002000201','2014-01-01','2013-12-23 14:02:37','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:03:49'),(17278,13819,'Y','18','021','EC','A','','','AC','0000885609','0000885609','OH00001625536','IL','1','Schreiner','Rita','','','','34','291705939','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1961-07-06','F','M',':RET:2106-3','T','021','HLT','2246097','52664OH152000901','2014-02-01','2014-01-10 14:37:22','509.00',NULL,NULL,'1017.42','508.42','R-OH012','OH0','366.67',NULL,0,'2014-01-13 02:23:25'),(9649,7646,'Y','18','024','14','A','','','TE','0001258643','0001258643','','IL','1','Manley','Ronese',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-04-03','F','',NULL,NULL,NULL,'','1888263','','2013-12-20','2013-12-20 22:28:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:38:44'),(16903,13525,'Y','18','021','EC','A','','','AC','0001144789','0001144789','OH00002434685','IL','1','Huber','Donna','','','','34','302523457','1936 STATE ROUTE 646',0,'RICHMOND','OH','43944','7962','CY','39081','1951-03-09','F','U',':RET:2106-3','N','021','DEN','1630128','99734OH005000401','2014-02-01','2014-01-09 14:22:21','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-01-13 02:19:33'),(3657,2926,'Y','18','021','EC','A','','','AC','0001187625','0001187625','OH00001153136','IL','1','Bailey','Paul','','','','34','296668342','405 N. Wright St.',0,'Blanchester','OH','45107',NULL,'CY','39027','1960-09-16','M','M',':RET:2106-3','T','021','DEN','128024','99734OH005000401','2014-01-01','2013-12-12 19:45:20','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:30:47'),(6030,4774,'Y','18','024','14','A','','','TE','0000994836','0000994836','','IL','1','Meadows','James','C',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-07','M','',NULL,NULL,NULL,'','35708','','2013-11-30','2013-11-30 21:31:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:01:07'),(5625,4464,'Y','18','024','14','A','','','TE','0000616836','0000616836','','IL','1','Whisner','philip',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-02-29','M','',NULL,NULL,NULL,'','32617','','2013-11-26','2013-11-26 17:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:30:53'),(6221,4931,'Y','18','021','EC','A','','','AC','0000373589','0000373589','OH00000269597','IL','1','glaesner','janet','','','','34','265840767','1225 FAWN CT',0,'LOVELAND','OH','45140','9735','CY','39025','1961-07-19','F','U',NULL,'N','021','HLT','1211114','92036OH006000601','2014-01-01','2013-10-16 10:11:17','0.00',NULL,NULL,'332.32','332.32','R-OH005','OH0','332.32',NULL,0,'2013-12-26 00:31:09'),(6962,5527,'Y','18','021','EC','A','','','AC','0000312192','0000312192','OH00000431023','IL','1','Lester','Patricia','','','','34','301504359','1093 Greyton Road',0,'Cleveland Hts','OH','44112',NULL,'CY','39035','1950-11-03','F','M',':RET:2054-5','T','021','DEN','2590108','99734OH005000401','2014-01-01','2013-12-24 22:22:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:17'),(6978,5537,'Y','18','021','EC','A','','','AC','0000616874','0000616874','OH00000385980','IL','1','mccarthy','dan','','','','34','290600527','3386 PALMHILL LN',0,'CINCINNATI','OH','45239','7162','CY','39061','1965-05-13','M','M',':RET:2106-3','T','021','DEN','2365774','99734OH005000401','2014-01-01','2013-12-24 23:38:45','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:47:37'),(7492,5927,'Y','18','021','EC','A','','','AC','0000247876','0000247876','OH00001018469','IL','1','Witt','Naomi','M','','','34','549795693','5990 SPRINGFIELD XENIA RD',0,'SPRINGFIELD','OH','45502','7906','CY','39023','1983-07-31','F','U',':RET:2106-3','N','021','DEN','374347','99734OH005000401','2014-01-01','2013-12-15 14:50:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:31:38'),(9293,7367,'N','01','021','EC','A',NULL,NULL,'','0000225979','0001244130','','IL','1','Smith','Emily','Jane','','','34','378865287','919 BROOKCREST DR',0,'MASON','OH','45040','3435','CY','39165','1972-08-04','F','',':RET:2106-3','N','021','DEN','1094066','99734OH005000301','2014-01-01','2013-11-30 14:42:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:16:09'),(8874,7036,'Y','18','021','EC','A','','','AC','0000585484','0000585484','TX00000569227','IL','1','AQEEL','AMIR','','','','34','311064169','9331 ANTWERP CV',0,'HOUSTON','TX','77070','2000','CY','48201','1968-11-07','M','M',':RET:2028-9','N','021','DEN','2086841','33348TX002000201','2014-01-01','2013-12-18 14:23:36','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:01:39'),(19341,15418,'Y','18','021','EC','A','','','AC','0000692322','0000692322','TX00002341385','IL','1','MENDEZ','MELISSA','','','','34','461857447','1001 83RD ST',0,'LUBBOCK','TX','79423','3523','CY','48303','1986-12-16','F','U',NULL,'N','021','DEN','2786212','33348TX002000201','2014-03-01','2014-01-21 16:27:10','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,1,'2014-01-22 03:22:21'),(20817,16636,'Y','18','021','EC','A','','','AC','0001780589','0001780589','LA00002200221','IL','1','Johnson','Brent','','','','34','476882579','3408 N Rampart St.',0,'New Orleans','LA','70117',NULL,'CY','22071','1976-01-22','M','U',':RET:2106-3','N','021','DEN','3710540','18575LA002000201','2014-03-01','2014-01-31 08:26:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-31 21:00:32'),(22034,17588,'Y','18','021','EC','A','','','AC','0000828273','0000828273','OH00002440037','IL','1','Hall','Thomas','Joseph','','','34','277786397','9673 PLACID DR',0,'WEST CHESTER','OH','45241','1215','CY','39017','1966-04-09','M','U',':RET:2106-3','N','021','HLT','3673145','92036OH006001201','2014-03-01','2014-02-07 14:35:59','125.00',NULL,NULL,'266.10','141.10','R-OH004','OH0','266.10',NULL,0,'2014-02-07 19:01:04'),(22710,18135,'Y','18','021','EC','A','','','AC','0001841406','0001841406','LA00002264143','IL','1','Alcala','Rebecca','','','','34','436732230','415 West Parker Boulevard',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1988-02-05','F','M',':RET:2106-3','N','021','DEN','2731862','18575LA002000201','2014-03-01','2014-02-10 22:38:34','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-11 21:01:04'),(23433,18667,'Y','18','021','EC','A','','','AC','0001194338','0001194338','TX00001441256','IL','1','Alexander','Lauren','','','','34','643280398','19307 HIGHWAY 87',0,'LUBBOCK','TX','79423','5413','CY','48303','1991-06-07','F','U',':RET:2106-3','T','021','DEN','3121060','33348TX002000201','2014-03-01','2014-02-13 10:23:28','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-13 22:01:27'),(27301,21618,'Y','18','021','EC','A','','','AC','0000882687','0000882687','TX00003240895','IL','1','Lopez','Leroy','','','','34','450233062','1320 EL CAMINO DR',0,'WESLACO','TX','78596','7381','CY','48215','1962-03-07','M','M',NULL,'N','021','DEN','2944685','33348TX002000201','2014-04-01','2014-03-04 13:35:14','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-04 21:00:35'),(13687,10921,'Y','18','021','EC','A','','','AC','0001019271','0001019271','OH00000761407','IL','1','Prinz','Jeffrey','','','','34','294561202','63 STARBOARD CIR',0,'AKRON','OH','44319','3686','CY','39153','1953-04-23','M','U',':RET:2106-3','N','021','HLT','1781673','52664OH151001305','2014-01-01','2013-12-23 09:52:55','464.00',NULL,NULL,'605.24','141.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 13:08:21'),(19032,15157,'Y','18','021','EC','A','','','AC','0000265261','0000265261','OH00001581660','IL','1','ARMSTRONG','JACQUELINE','','','','34','278504493','289 BAYVIEW RD',0,'BAY VILLAGE','OH','44140','1231','CY','39035','1951-06-28','F','U',':RET:2106-3','N','021','HLT','2839779','92036OH004000801','2014-03-01','2014-01-17 11:42:04','427.00',NULL,NULL,'540.10','113.10','R-OH011','OH0','540.10',NULL,0,'2014-01-20 08:06:31'),(17318,13851,'Y','18','021','EC','A','','','AC','0000577727','0000577727','TX00002371992','IL','1','Vargas','Pablo','','','','34','462960307','1104 DUKE CT',0,'EL PASO','TX','79903','3331','CY','48141','1951-04-12','M','M',NULL,'N','021','DEN','1369759','33348TX002000201','2014-02-01','2014-01-10 16:02:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:23:49'),(17072,13662,'Y','18','021','EC','A','','','AC','0000132558','0000132558','TX00002246386','IL','1','Rucker','Ernest','Eugene','','','34','464251081','2804 FRANCIS ST',0,'VICTORIA','TX','77901','9498','CY','48469','1962-03-31','M','U',':RET:2054-5','T','021','DEN','2027706','33348TX002000201','2014-02-01','2014-01-08 10:34:14','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-13 02:21:17'),(4695,3722,'N','01','021','EC','A',NULL,NULL,'','0001173194','0000876038','','IL','1','Morgan','Cilicia','P','','','34','403374997','829 S DETROIT ST',0,'XENIA','OH','45385',NULL,'CY','39057','1981-01-07','F','',':RET:2029-7','N','021','HLT','651874','92036OH005000505','2014-01-01','2013-12-12 12:47:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.21',NULL,0,'2013-12-25 22:08:17'),(8889,7047,'N','01','021','EC','A',NULL,NULL,'','0000686689','0000268927','','IL','1','GUERRERO','RAMIRO','','','','34','607461302','210 COUNTY ROAD 418C',0,'COMANCHE','TX','76442','5608','CY','48093','1986-01-14','M','',NULL,'N','021','DEN','2495261','33348TX002000201','2014-01-01','2013-12-18 17:08:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:57'),(13032,10388,'Y','18','021','EC','A','','','AC','0000192732','0000192732','OH00000849864','IL','1','Hritz','Matthew','','','','34','288608946','3887 West 136 th. Street',0,'Cleveland','OH','44111',NULL,'CY','39035','1962-11-30','M','U',':RET:2106-3','N','021','DEN','1585573','99734OH005000401','2014-01-01','2013-12-22 23:11:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:50:22'),(16560,13249,'Y','18','021','EC','A','','','AC','0001436510','0001436510','LA00001743698','IL','1','benjamin','brittany',NULL,NULL,NULL,NULL,NULL,'540 dugas st',0,'st martinville','LA','70582',NULL,'CY','22099','1989-09-09','F','U',':RET:2054-5','T','021','DEN','1551810','18575LA002000201','2014-02-01','2014-01-05 12:38:46','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-07 10:23:01'),(263,217,'N','01','021','EC','A',NULL,NULL,'','0000874670','0001186282','','IL','1','sabel','deborah','ann','','','34','292582364','280 paris dr',0,'austintown','OH','44515',NULL,'CY','39099','1959-12-29','F','',':RET:2106-3','T','021','HLT','799322','92036OH004003201','2014-01-01','2013-12-05 14:12:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','477.87',NULL,0,'2013-12-25 17:21:53'),(813,673,'Y','18','021','EC','A','','','AC','0001258640','0001258640','OH00000291068','IL','1','MARTIN','GAYLE','E','','','34','300625451','6446 HAWTHORNE DR',0,'ANDOVER','OH','44003','9792','CY','39007','1956-10-16','F','M',':RET:2106-3','N','021','HLT','1411108','52664OH151001305','2014-01-01','2013-12-16 10:26:42','897.00',NULL,NULL,'1065.04','168.04','R-OH011','OH0','612.95',NULL,0,'2013-12-25 18:05:52'),(3622,2899,'Y','18','021','EC','A','','','AC','0001064709','0001064709','OH00001043500','IL','1','Riegler','Ann','','','','34','298885594','4450 Kenneth Trail',0,'Stow','OH','44224',NULL,'CY','39153','1973-03-29','F','M',':RET:2106-3','N','021','HLT','1527827','52664OH151001501','2014-01-01','2013-12-22 16:21:48','451.00',NULL,NULL,'1035.89','584.89','R-OH012','OH0','341.82',NULL,0,'2013-12-25 21:23:43'),(20169,16095,'Y','18','021','EC','A','','','AC','0000633758','0000633758','OH00002262602','IL','1','Mack','Joan','','','','34','281689137','2976 MCCORMICK RD',0,'SILVER LAKE','OH','44224','3816','CY','39153','1963-08-10','F','U',':RET:2106-3','N','021','HLT','2463076','52664OH151001305','2014-03-01','2014-01-26 22:47:38','285.00',NULL,NULL,'398.29','113.29','R-OH012','OH0','398.29',NULL,0,'2014-01-27 21:01:14'),(3001,2412,'N','01','021','EC','A',NULL,NULL,'','0000880486','0001244140','','IL','1','wahl','karen','a','','','34','293565614','10993 OLMAR DR',0,'CHARDON','OH','44024','9706','CY','39055','1955-01-31','F','',':RET:2106-3','N','021','DEN','815942','99734OH005000301','2014-01-01','2013-12-06 12:55:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:39'),(1476,1230,'Y','18','024','14','A','','','TE','0001030376','0001030376','','IL','1','Nicholas','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-07-13','M','',NULL,NULL,NULL,'','1622297','','2013-12-24','2013-12-24 09:54:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:48:41'),(2105,1726,'Y','18','021','EC','A','','','AC','0001196790','0001196790','OH00000017073','IL','1','LACOMME','WILLIO','','','','34','770038507','5395 BETTMAN DR',0,'CINCINNATI','OH','45232','1209','CY','39061','1981-01-22','M','U',':RET:2054-5','N','021','DEN','239012','99734OH005000401','2014-01-01','2013-12-10 09:12:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:17:17'),(28680,22696,'Y','18','021','EC','A','','','AC','0000695628','0000695628','OH00003070860','IL','1','Peters','Lisa','Michelle','','','34','519966065','3041 YORKSHIRE RD',0,'CLEVELAND HEIGHTS','OH','44118','2427','CY','39035','1979-08-10','F','U',':RET:2106-3','N','021','DEN','4050389','99734OH005000301','2014-04-01','2014-03-08 06:47:28','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-08 21:30:55'),(9010,7149,'Y','18','021','EC','A','','','AC','0000115482','0000115482','OH00001024500','IL','1','Zaferopolos','April','','','','34','163686035','7486 STONE RD',0,'MEDINA','OH','44256','8931','CY','39103','1975-03-13','F','R',':RET:2106-3','T','021','HLT','2521767','52664OH152000901','2014-01-01','2013-12-18 15:50:31','0.00',NULL,NULL,'234.05','234.05','R-OH012','OH0','234.05',NULL,0,'2013-12-26 04:05:04'),(9742,7714,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00000869921','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','1077066','33348TX002000201','2014-01-01','2013-11-15 09:46:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:45:57'),(27215,21548,'Y','18','021','EC','A','','','AC','0000532597','0000532597','MS00003363839','IL','1','steel','Virginia','','','','34','425133053','400 s fulton st',0,'isola','MS','38754',NULL,'CY','28053','1965-05-16','F','U',':RET:2054-5','N','021','DEN','3160667','46300MS002000201','2014-04-01','2014-03-02 20:12:36','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-03 21:31:31'),(4059,3242,'Y','18','021','EC','A','','','AC','0001090903','0001090903','OH00000691261','IL','1','Flesher','Amy','','','','34','271788792','5566 Oakvista Drive',0,'Cincinnati','OH','45227',NULL,'CY','39061','1966-02-15','F','R',':RET:2106-3','N','021','DEN','2202772','99734OH005000401','2014-01-01','2013-12-17 15:42:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:37'),(22990,18328,'N','01','021','EC','A',NULL,NULL,'','0000227088','0000015309','','IL','1','Budzinski','Aaron','','','','34','280763956','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1978-08-03','M','',':RET:2106-3','N','021','DEN','2698252','99734OH005000301','2014-03-01','2014-02-12 11:08:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:30:13'),(21467,17154,'Y','18','021','EC','A','','','AC','0000418253','0000418253','MS00001721944','IL','1','Hungerford','Edward','','','','34','433864029','26299 Broadridge Dr',0,'Picayune','MS','39466',NULL,'CY','28109','1953-04-20','M','U',':RET:2106-3','N','021','DEN','3374954','46300MS002000201','2014-03-01','2014-02-04 11:23:22','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-02-04 21:01:36'),(19570,15601,'Y','18','024','14','A','','','TE','0001973388','0001973388','','IL','1','Davis','Paula',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-12-30','F','',NULL,NULL,NULL,'','1882230','','2014-01-22','2014-01-22 14:21:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-23 03:02:36'),(3114,2502,'Y','18','021','EC','A','','','AC','0000730076','0000730076','TX00000507757','IL','1','Lamb','Shannon','','','','34','452516656','510 Sunset',0,'Blossom','TX','75416',NULL,'CY','48277','1977-11-21','M','U',NULL,'T','021','DEN','405508','33348TX002000101','2014-01-01','2013-10-13 15:34:37','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:30:06'),(6529,5176,'N','01','021','EC','A',NULL,NULL,'','0000222380','0001184866','','IL','1','Heffner','Jennifer','','','','34','295787752','732 ELM AVE',0,'TERRACE PARK','OH','45174','1262','CY','39061','1981-02-06','F','',':RET:2106-3','N','021','HLT','1196017','92036OH002001201','2014-01-01','2013-12-11 15:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.28',NULL,0,'2013-12-26 00:51:36'),(5371,4258,'N','01','021','EC','A',NULL,NULL,'','0000349253','0000749515','','IL','1','Madill','Bonnie','A','','','34','281525704','11781 STONE MILL RD',0,'CINCINNATI','OH','45251','4125','CY','39061','1952-04-14','F','',NULL,'N','021','HLT','1527691','92036OH005001201','2014-01-01','2013-12-19 13:00:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','603.24',NULL,0,'2013-12-25 23:08:05'),(27743,21938,'N','19','021','EC','A',NULL,NULL,'','0000211062','0000177689','','IL','1','Zemenski','Hannah',NULL,NULL,NULL,NULL,NULL,'5115 KELLER RD',0,'WALBRIDGE','OH','43465','9752','CY','39173','1999-02-24','F','',NULL,'N','021','HLT','3092831','92036OH004002601','2014-04-01','2014-03-04 18:08:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-03-05 21:31:10'),(27541,21786,'N','19','021','EC','A',NULL,NULL,'','0000669236','0000242768','','S3','1','STITT','PAUL','','','','34','294110579','407 INDIANA AVE',0,'MC DONALD','OH','44437','1923','CY','39155','2006-02-01','F','',':RET:2106-3','N','021','DEN','3976455','99734OH005000401','2014-04-01','2014-03-04 11:45:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:07'),(26403,20940,'Y','18','021','EC','A','','','AC','0001121451','0001121451','OH00002510424','IL','1','Martin','Amber','','','','34','278823843','1505 W WAYNE ST',0,'LIMA','OH','45805','2271','CY','39003','1984-06-11','F','M',':RET:2106-3','N','021','HLT','2936108','92036OH003001505','2014-04-01','2014-02-26 12:22:31','401.00',NULL,NULL,'569.86','168.86','R-OH002','OH0','257.18','CIC',0,'2014-02-28 07:00:32'),(24724,19631,'Y','18','021','EC','A','','','AC','0001152249','0001152249','OH00002270652','IL','1','kunsman','tabitha','','','','34','301747143','1100 WHITTLESAY LN',0,'ROCKY RIVER','OH','44116','2162','CY','39035','1979-09-15','F','U',':RET:2106-3','N','021','DEN','3136101','99734OH005000401','2014-04-01','2014-02-19 08:31:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:38:23'),(16538,13229,'Y','18','021','EC','A','','','AC','0000516924','0000516924','OH00001906094','IL','1','D\'Aurelio','Barbara','','','','34','278521066','203 S BALCH ST',0,'AKRON','OH','44302','1646','CY','39153','1952-01-26','F','M',':RET:2106-3','N','021','HLT','2463923','52664OH152000901','2014-02-01','2014-01-05 14:01:30','408.00',NULL,NULL,'469.28','61.28','R-OH012','OH0','469.28',NULL,1,'2014-01-07 10:22:15'),(20132,16065,'Y','18','021','EC','A','','','AC','0001195530','0001195530','OH00002474726','IL','1','PALL','ELIZABETH','','','','34','049564548','7351 DUNMORE CT',0,'WEST CHESTER','OH','45069','4947','CY','39017','1970-12-26','F','U',NULL,'N','021','DEN','3157521','99734OH005000401','2014-03-01','2014-01-27 12:53:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:00:52'),(17823,14238,'Y','18','021','EC','A','','','AC','0000611846','0000611846','MS00001591325','31','1','WILLIAMS','RANDALL','','','','34','587347829','PO BOX 1512',0,'CATTISBURG','MS','39403',NULL,'CY','28035','1950-07-15','M','U',':RET:2054-5','N','021','DEN','1995677','46300MS002000201','2014-02-01','2014-01-14 11:08:30','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2014-01-15 02:05:57'),(14521,11586,'Y','18','021','EC','A','','','AC','0000668484','0000668484','TX00000769831','31','1','DICK','DIANE','','','','34','524684483','PO BOX 688',0,'KEMPNER','TX','76539',NULL,'CY','48281','1949-06-18','F','U',':RET:2106-3','N','021','DEN','2404142','33348TX002000201','2014-02-01','2013-12-27 16:57:21','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-28 03:34:18'),(3821,3059,'N','01','021','EC','A',NULL,NULL,'','0000130677','0000496735','','IL','1','Reno','John','C','','','34','301781544','180 Starr Drive',0,'Nelsonville','OH','45764',NULL,'CY','39009','1978-07-06','M','',':RET:2106-3','N','021','DEN','37040','99734OH005000301','2014-01-01','2013-12-13 14:47:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:56'),(28699,22712,'Y','18','024','14','A','','','TE','0000521917','0000521917','','IL','1','cole','kayla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-02-17','F','',NULL,NULL,NULL,'','939568','','2014-03-31','2014-03-07 22:37:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-08 21:31:08'),(29009,22960,'Y','18','021','EC','A','','','AC','0000936119','0000936119','OH00003045340','IL','1','Howell','Victoria','','','','34','262458499','12031 Mumford Road',0,'Garrettsville','OH','44231',NULL,'CY','39133','1959-12-30','F','M',NULL,'N','021','HLT','3648288','52664OH152000901','2014-04-01','2014-03-10 17:31:55','156.00',NULL,NULL,'348.73','192.73','R-OH012','OH0','348.73',NULL,0,'2014-03-10 21:01:23'),(1170,965,'Y','18','021','EC','A','','','AC','0000253015','0000253015','OH00000745617','IL','1','KULOW','FRANK','','','','34','279500237','449 DOHNER DRIVE',0,'WADSWORTH','OH','44281',NULL,'CY','39103','1949-07-13','M','M',':RET:2106-3','N','021','HLT','549112','52664OH151001501','2014-01-01','2013-12-02 19:47:17','1105.00',NULL,NULL,'1528.28','423.28','R-OH012','OH0','802.38',NULL,0,'2013-12-25 18:19:08'),(9111,7230,'N','19','021','EC','A',NULL,NULL,'','0000814273','0000452732','','IL','1','Hall','Cory','','','','34','296085663','26 Virginia Avenue',0,'Centerville','OH','45458',NULL,'CY','39113','2004-04-02','M','',':RET:2106-3','N','021','DEN','1840295','99734OH005000301','2014-01-01','2013-12-18 15:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:35'),(28007,22162,'Y','18','021','EC','A','','','AC','0000895779','0000895779','OH00002633542','IL','1','Rampello','Oliver','','','','34','273907054','2119 Bentwood Circle',0,'Columbus','OH','43235',NULL,'CY','39049','1982-04-14','M','U',':RET:2106-3','N','021','DEN','4043188','99734OH005000401','2014-04-01','2014-03-06 10:36:39','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-06 21:01:12'),(17912,14307,'Y','18','021','EC','A','','','AC','0001262936','0001262936','TX00002384631','IL','1','Desilet','Aimee','','','','34','594289651','5101 N. A Street',0,'Midland','TX','79705',NULL,'CY','48329','1983-05-14','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','1502652','33348TX002000201','2014-02-01','2014-01-13 21:51:16','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-15 02:06:27'),(13118,10462,'Y','18','021','EC','A','','','AC','0000146883','0000146883','OH00001087977','IL','1','NARTKER','DONNA','JEAN','','','34','274520884','641  N WEST ST',0,'HILLSBORO','OH','45133',NULL,'CY','39071','1951-03-31','F','U',':RET:2106-3','N','021','DEN','1546221','99734OH005000401','2014-01-01','2013-12-23 13:59:26','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 12:52:40'),(22492,17956,'Y','18','021','EC','A','','','AC','0000700425','0000700425','OH00002269073','IL','1','Shaw','Margaret','','','','34','176429931','5421 BEECHWOOD RD',0,'RAVENNA','OH','44266','9172','CY','39133','1950-05-01','F','U',':RET:2106-3','T','021','DEN','3684332','99734OH005000301','2014-03-01','2014-02-10 13:36:22','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-10 21:31:08'),(5053,4002,'Y','18','021','EC','A','','','AC','0000316702','0000316702','TX00000539002','IL','1','jackson','peggy','','','','34','444781011','701 E 3RD ST',0,'BURKBURNETT','TX','76354','1708','CY','48485','1967-03-27','F','U',':RET:2106-3','N','021','DEN','1422112','33348TX002000201','2014-01-01','2013-12-18 20:52:41','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 23:00:14'),(29162,23082,'Y','18','021','EC','A','','','AC','0000490543','0000490543','OH00003181645','IL','1','Young','Tracy','R','','','34','289722651','501 GRUEN DR',0,'SPRINGFIELD','OH','45505','2734','CY','39023','1971-06-17','F','U',':RET:2106-3','N','021','HLT','3287424','92036OH006000501','2014-04-01','2014-03-10 17:44:53','165.00',NULL,NULL,'249.79','84.79','R-OH003','OH0','249.79',NULL,0,'2014-03-10 21:02:54'),(1307,1082,'Y','18','021','EC','A','','','AC','0000331677','0000331677','LA00001097921','IL','1','Allen','Ashley','Berry','','','34','438712044','244 Olivier St',0,'New Orleans','LA','70114',NULL,'CY','22071','1988-06-22','F','M',':RET:2106-3','N','021','DEN','792175','18575LA002000201','2014-01-01','2013-11-04 09:55:01','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:31:22'),(17335,13866,'Y','18','021','EC','A','','','AC','0002077153','0002077153','LA00001372680','IL','1','MILLIET','ELAINE','','','','34','662145636','607 N TURNBULL DR',0,'METAIRIE','LA','70001','4949','CY','22051','1980-10-25','F','U',NULL,'N','021','DEN','1538920','18575LA002000201','2014-02-01','2014-01-10 13:19:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:23:59'),(26761,21209,'Y','18','024','14','A','','','TE','0000106694','0000106694','','IL','1','Sutton','Mark','Kerry',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-27','M','',NULL,NULL,NULL,'','1080143','','2014-02-28','2014-02-28 18:22:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-01 19:00:08'),(3585,2875,'Y','18','021','EC','A','','','AC','0000550067','0000550067','OH00000609343','IL','1','Wall','Marilyn','Margaret','','','34','283544243','816 VAN NES DR',0,'CINCINNATI','OH','45246','4307','CY','39061','1953-04-02','F','R',NULL,'N','021','HLT','1558946','92036OH006001201','2014-01-01','2013-12-22 09:11:09','0.00',NULL,NULL,'462.04','462.04','R-OH004','OH0','462.04',NULL,0,'2013-12-25 21:22:50'),(14129,11261,'N','01','021','EC','A',NULL,NULL,'','0001231367','0001220845','','IL','1','Morris','Freida','T','','','34','434984665','6975 HIGHWAY 67',0,'SLAUGHTER','LA','70777','4038','CY','22037','1955-12-09','F','',':RET:2054-5','N','021','DEN','2159238','18575LA002000201','2014-02-01','2013-12-25 22:59:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-27 02:02:21'),(6625,5254,'Y','18','021','EC','A','','','AC','0001084123','0001084123','OH00001235215','IL','1','Shipley','Steven','','','','34','292548912','5702 Angola Rd.',0,'Toledo','OH','43615',NULL,'CY','39095','1953-04-20','M','M',':RET:2106-3','N','021','HLT','1125484','92036OH005002605','2014-01-01','2013-12-11 16:05:25','895.00',NULL,NULL,'1089.43','194.43','R-OH001','OH0','529.21',NULL,0,'2013-12-26 00:54:10'),(8995,7137,'Y','18','021','EC','A','','','AC','0000998771','0000998771','OH00000519232','IL','1','BROCKMAN','BETTY','','','','34','278662080','7051 WINROAD WAY',0,'CINCINNATI','OH','45241','4545','CY','39061','1961-09-26','F','U',':RET:2106-3','N','021','DEN','1476101','99734OH005000401','2014-01-01','2013-12-18 17:57:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:41'),(9588,7592,'Y','18','021','EC','A','','','AC','0000546902','0000546902','MS00000941475','IL','1','Richardson','Mary','','','','34','409880899','199 MCKINSEY LN',0,'RED BANKS','MS','38661','9504','CY','28093','1950-07-18','F','M',':RET:2106-3','N','021','DEN','2181853','46300MS002000201','2014-01-01','2013-12-21 10:39:38','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2013-12-26 04:37:04'),(4504,3570,'N','01','021','EC','A',NULL,NULL,'','0000315229','0000079284','','IL','1','Rasnic','Deanna','Rogers','','','34','437317339','1414 TULANE CT',0,'ALLEN','TX','75013','2826','CY','48085','1971-10-11','F','',NULL,'N','021','DEN','256169','33348TX002000201','2014-01-01','2013-12-11 22:52:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:27'),(1659,1386,'Y','18','021','EC','A','','','AC','0000963307','0000963307','TX00000453039','IL','1','Nordin','Richard','','','','34','320525063','5303 KITE TAIL DR',0,'AUSTIN','TX','78730','1423','CY','48453','1957-04-16','M','M',':RET:2106-3','N','021','DEN','2584054','33348TX002000201','2014-01-01','2013-12-24 17:09:00','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:53:35'),(19111,15227,'Y','18','021','EC','A','','','AC','0000420054','0000420054','OH00002546022','IL','1','PHILLIPS','SCHERRI','','','','34','275721399','575 HEBRON ST',0,'MILLERSBURG','OH','44654','1218','CY','39075','1975-10-10','F','U',':RET:2106-3','T','021','HLT','2779698','52664OH151001304','2014-03-01','2014-01-18 15:25:39','122.00',NULL,NULL,'319.55','197.55','R-OH014','OH0','319.55',NULL,0,'2014-01-21 08:44:44'),(21366,17076,'Y','18','021','EC','A','','','AC','0000626299','0000626299','TX00002518580','IL','1','manigo','Marcus','','','','34','553716451','10911woodmeadow parkway',0,'dallas','TX','75228',NULL,'CY','48113','1982-02-09','M','U',':RET:2054-5','T','021','DEN','2672510','33348TX002000201','2014-03-01','2014-02-04 16:14:22','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-04 21:00:45'),(20288,16193,'Y','18','021','EC','A','','','AC','0001211614','0001211614','LA00002272754','IL','1','FULLER','KEISHA','','','','34','438513409','3131 FREDERICK ST',0,'SHREVEPORT','LA','71109','3515','CY','22017','1981-01-08','F','U',':RET:2054-5','N','021','DEN','2710217','18575LA002000201','2014-03-01','2014-01-27 19:24:12','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-28 21:00:34'),(20179,16103,'Y','18','021','EC','A','','','AC','0000840558','0000840558','OH00001760290','IL','1','HUBER','JENNA','','','','34','290849169','48263 TINA LN',0,'AMHERST','OH','44001','9667','CY','39093','1986-06-05','F','U',':RET:2106-3','T','021','HLT','1909671','52664OH151001305','2014-03-01','2014-01-27 15:04:14','112.00',NULL,NULL,'303.13','191.13','R-OH011','OH0','303.13',NULL,0,'2014-01-27 21:01:19'),(20045,15986,'Y','18','021','EC','A','','','AC','0000735058','0000735058','OH00001746253','IL','1','dale','thomas','','','','34','295806321','296.5 COLE AVE',0,'AKRON','OH','44301','1830','CY','39153','1977-09-19','M','M',':RET:2106-3','N','021','HLT','2859567','52664OH152000901','2014-03-01','2014-01-26 15:19:56','0.00',NULL,NULL,'200.91','200.91','R-OH012','OH0','200.91',NULL,0,'2014-01-26 19:00:30'),(7700,6097,'Y','18','021','EC','A','','','AC','0000425074','0000425074','OH00000891501','IL','1','Handy','Elmer','George','','','34','287708181','11085 STEPHENS RD',0,'NORTH BEND','OH','45052','9405','CY','39061','1960-03-22','M','U',':RET:2106-3','T','021','DEN','2580970','99734OH005000401','2014-01-01','2013-12-20 09:07:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:01:15'),(16010,12814,'Y','18','021','EC','A','','','AC','0001709240','0001709240','LA00000615951','IL','1','middleton','regina','','','','34','438435298','616 hwy 2',0,'sterlington','LA','71280',NULL,'CY','22111','1967-04-09','F','U',':RET:2106-3','N','021','DEN','1443565','18575LA002000201','2014-02-01','2014-01-02 18:41:53','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-04 02:01:47'),(28629,22656,'N','01','021','EC','A',NULL,NULL,'','0000736304','0001151299','','IL','1','CANALES','DORA','GRACIELA','','','34','454373503','3209 CALLE TERESA',0,'EAGLE PASS','TX','78852','5670','CY','48323','1959-10-12','F','',NULL,'N','021','DEN','4293616','33348TX002000201','2014-04-01','2014-03-08 11:07:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-08 21:30:25'),(20677,16524,'Y','18','021','EC','A','','','AC','0000301370','0000301370','MS00001669758','IL','1','Morris','Kirby','Alan','','','34','587841943','3659 ALBERMARLE RD',0,'JACKSON','MS','39213','5552','CY','28049','1954-11-29','M','U',':RET:2054-5','T','021','DEN','3525268','46300MS002000101','2014-03-01','2014-01-30 13:35:54','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-30 21:00:53'),(6705,5316,'Y','18','021','EC','A','','','AC','0001011518','0001011518','OH00000191718','IL','1','Rigdon','Danny','','','Sr','34','289700846','1112 millston road box 286',0,'Aberdeen','OH','45101',NULL,'CY','39015','1970-01-17','M','M',':RET:2106-3','T','021','HLT','630282','92036OH006000601','2014-01-01','2013-11-04 19:57:49','524.00',NULL,NULL,'571.68','47.68','R-OH005','OH0','265.67',NULL,0,'2013-12-26 01:02:02'),(22637,18076,'Y','18','021','EC','A','','','AC','0000897767','0000897767','TX00002377605','IL','1','Lawrence','Carolyn','','','','34','451133398','6502 BROOKHAVEN TRL',0,'FORT WORTH','TX','76133','5823','CY','48439','1969-12-23','F','U',':RET:2054-5','N','021','DEN','3851866','33348TX002000201','2014-03-01','2014-02-11 09:57:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:21'),(26769,21216,'Y','18','021','EC','A','','','AC','0001339237','0001339237','LA00002877706','IL','1','Mennen','Ruthann','','','','34','478887305','2416 4th Street',0,'Harvey','LA','70058',NULL,'CY','22051','1967-11-06','F','U',':RET:2106-3','N','021','DEN','3345104','18575LA002000101','2014-04-01','2014-03-01 15:07:08','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02','CIC',0,'2014-03-01 19:00:13'),(25913,20548,'Y','18','021','EC','A','','','AC','0000672450','0000672450','TX00002760019','IL','1','SMITH','MARGARET','','','','34','480766048','600 STATE HWY 495',0,'ALAMO','TX','78516',NULL,'CY','48215','1956-02-02','F','M',NULL,'N','021','DEN','3745560','33348TX002000201','2014-04-01','2014-02-26 14:51:48','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-26 21:01:15'),(24421,19399,'Y','18','021','EC','A','','','AC','0000540340','0000540340','OH00002398249','IL','1','CORNELIUS','CHRISTOPHER','','','','34','250872538','678 S WALNUT ST',0,'RAVENNA','OH','44266','3153','CY','39133','1991-08-21','M','U',NULL,'T','021','DEN','3588441','99734OH005000301','2014-04-01','2014-02-18 16:17:59','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:01:07'),(17419,13940,'Y','18','021','EC','A','','','AC','0000654616','0000654616','OH00001900357','IL','1','Rodgers','Nancy','','','','34','290505537','12231 US HIGHWAY 50',0,'HILLSBORO','OH','45133','9727','CY','39071','1950-09-22','F','U',':RET:2106-3','N','021','HLT','2541636','92036OH005000606','2014-02-01','2014-01-10 10:53:00','629.07',NULL,NULL,'633.70','4.63','R-OH005','OH0','633.70',NULL,0,'2014-01-13 03:00:26'),(8105,6411,'N','01','021','EC','A',NULL,NULL,'','0000108143','0000586681','','IL','1','WALLEY','ROBERT','M','','','34','296689228','4700 LOGAN GATE RD',0,'YOUNGSTOWN','OH','44505','1716','CY','39155','1963-11-29','M','',':RET:2106-3','N','021','HLT','1948858','92036OH005003205','2014-01-01','2013-12-20 16:11:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','432.30',NULL,0,'2013-12-26 03:10:56'),(2996,2409,'N','19','021','EC','A',NULL,NULL,'','0000705120','0001163808','','IL','1','Isenbarger','Jacob','','','','34','294022081','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1998-02-22','M','',':RET:2106-3','N','021','DEN','728312','99734OH005000301','2014-01-01','2013-12-05 20:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:33'),(19395,15462,'Y','18','021','EC','A','','','AC','0000675475','0000675475','OH00001427839','IL','1','BROYLES','ROBERT','','','','34','299709789','17 POND ST SW',0,'MASSILLON','OH','44647','6405','CY','39151','1961-12-20','M','M',NULL,'T','021','DEN','2812845','99734OH005000401','2014-03-01','2014-01-21 11:56:29','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,1,'2014-01-22 03:22:50'),(14960,11957,'Y','18','021','EC','A','','','AC','0000618884','0000618884','TX00001412925','IL','1','PETERSON','DONNA','','','','34','552989323','3754 WINFIELD AVE',0,'FORT WORTH','TX','76109','3722','CY','48439','1955-02-07','F','U',':RET:2106-3','T','021','DEN','1433293','33348TX002000201','2014-02-01','2013-12-30 09:26:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:29'),(21477,17161,'Y','18','021','EC','A','','','AC','0001106814','0001106814','OH00001429304','IL','1','CRESSIE','YOKO','','','','34','478152700','2211 SANDSTON RD',0,'COLUMBUS','OH','43220','5406','CY','39049','1952-03-05','F','U',':RET:2039-6','N','021','DEN','3517600','99734OH005000301','2014-03-01','2014-02-04 12:09:18','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:01:41'),(21620,17262,'N','01','021','EC','A',NULL,NULL,'','0001072923','0000343978','','IL','1','Loehman','Noelisa','','','','34','453135237','208 BLUEBONNET DR',0,'WINTERS','TX','79567','3040','CY','48399','1955-05-04','F','',':RET:2106-3','N','021','DEN','2767004','33348TX002000201','2014-03-01','2014-02-04 21:09:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-05 21:30:37'),(21856,17452,'Y','18','024','14','A','','','TE','0000128130','0000128130','','IL','1','MILLER','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-12-17','F','',NULL,NULL,NULL,'','3136701','','2014-02-06','2014-02-06 12:14:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-06 21:01:18'),(23201,18499,'Y','18','021','EC','A','','','AC','0000401284','0000401284','OH00001605328','IL','1','Budzinski','Tiffany','','','','34','291900309','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1980-10-22','F','M',':RET:2047-9','N','021','HLT','3157858','92036OH006002601','2014-03-01','2014-02-12 11:08:07','491.00',NULL,NULL,'570.61','79.61','R-OH001','OH0','185.25',NULL,0,'2014-02-12 21:32:09'),(26353,20906,'Y','18','021','EC','A','','','AC','0000636066','0000636066','OH00002527714','IL','1','Borntrager','Douglas','','','','34','290825152','1415 PULLAN AVE',0,'CINCINNATI','OH','45223','1821','CY','39061','1977-10-10','M','M',':RET:2106-3','T','021','HLT','3361899','92036OH004001201','2014-03-01','2014-02-27 15:51:34','0.00',NULL,NULL,'353.78','353.78','R-OH004','OH0','244.17',NULL,0,'2014-02-28 06:31:48'),(26494,21017,'Y','18','024','14','A','','','TE','0002293461','0002293461','','IL','1','Nguyen','Nhai',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-18','F','',NULL,NULL,NULL,'','3205352','','2014-03-31','2014-02-28 17:48:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 21:00:12'),(28766,22770,'Y','18','021','EC','A','','','AC','0000130038','0000130038','TX00003319724','IL','1','Perez Guerra','Jose','','','','34','768961021','200 S OLIVE ST',0,'KERMIT','TX','79745','3908','CY','48495','1975-04-22','M','R',':RET:2106-3','N','021','DEN','3739947','33348TX002000201','2014-04-01','2014-03-09 16:54:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-09 21:00:25'),(28767,22771,'Y','18','021','EC','A','','','AC','0001110430','0001110430','OH00003398461','IL','1','Jackson','Ashton','','','III','34','301920980','2739 BRENTNELL AVE',0,'COLUMBUS','OH','43211','1711','CY','39049','1989-11-14','M','U',':RET:2054-5^:RET:2036-2^:RET:2028-9','N','021','DEN','3057882','99734OH005000401','2014-04-01','2014-03-08 20:21:18','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-09 21:00:26'),(2017,1655,'Y','18','021','EC','A','','','AC','0001224443','0001224443','OH00000948413','IL','1','jesenovic','michael','','','','34','288544886','345 SPRINGBROOK DR',0,'MEDINA','OH','44256','3666','CY','39103','1965-03-16','M','U',NULL,'T','021','HLT','318896','52664OH152000901','2014-01-01','2013-12-09 18:18:28','131.00',NULL,NULL,'307.12','176.12','R-OH012','OH0','307.12',NULL,0,'2013-12-25 19:15:03'),(2150,1768,'Y','18','024','14','A','','','TE','0000524453','0000524453','','IL','1','Kim','Kwang',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-07-02','M','',NULL,NULL,NULL,'','299134','','2013-12-10','2013-12-10 17:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:18:33'),(5656,4486,'Y','18','021','EC','A','','','AC','0000165039','0000165039','OH00000907035','IL','1','Baldwin','Michael','S','','','34','302883796','993 WOODWARD RD',0,'AKRON','OH','44312','5248','CY','39153','1988-11-22','M','U',':RET:2106-3','T','021','HLT','1193168','52664OH152000901','2014-01-01','2013-11-25 18:57:50','0.00',NULL,NULL,'188.59','188.59','R-OH012','OH0','188.59',NULL,0,'2013-12-25 23:31:38'),(19253,15343,'Y','18','021','EC','A','','','AC','0001456288','0001456288','LA00001596486','IL','1','Novoa','Jorge','','','','34','660168892','37346 ALICE BRAUD LN',0,'PRAIRIEVILLE','LA','70769','3546','CY','22005','1985-11-28','M','M',NULL,'N','021','DEN','2712614','18575LA002000201','2014-03-01','2014-01-20 11:48:24','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:46:45'),(5384,4271,'Y','18','021','EC','A','','','AC','0002165873','0002165873','LA00000655551','IL','1','Verges','Jerome','','','','34','433726730','522 AVENUE J',0,'MARRERO','LA','70072','1723','CY','22051','1949-08-04','M','U',':RET:2106-3','N','021','DEN','2538146','18575LA002000201','2014-01-01','2013-12-19 16:00:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:08:26'),(4383,3484,'Y','18','021','EC','A','','','AC','0000394913','0000394913','OH00000353025','IL','1','Grier','Makayla','','','','34','298960189','2826 E 5TH AVE',0,'COLUMBUS','OH','43219','2849','CY','39049','1994-07-14','F','R',':RET:2054-5','N','021','DEN','19131','99734OH005000401','2014-01-01','2013-12-12 09:47:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2013-12-25 22:00:40'),(15163,12118,'Y','18','021','EC','A','','','AC','0000484800','0000484800','OH00000974265','IL','1','LENGEL','JOSEPH','','','','34','269486487','16284 FORGEHILL DR',0,'GARRETTSVILLE','OH','44231','9522','CY','39055','1952-12-01','M','M',':RET:2106-3','N','021','DEN','2148751','99734OH005000401','2014-02-01','2013-12-30 14:28:58','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:06:19'),(22749,18162,'Y','18','021','EC','A','','','AC','0001423587','0001423587','LA00002312149','IL','1','Beary','Michele','','','','34','433371232','730 Goode Street',0,'Thibodaux','LA','70301',NULL,'CY','22057','1963-02-06','F','U',':RET:2106-3','N','021','DEN','3014349','18575LA002000101','2014-03-01','2014-02-10 19:18:01','0.00',NULL,NULL,'69.57','69.57','R-LA002','LA0','25.02',NULL,0,'2014-02-11 21:01:25'),(23705,18875,'N','19','021','EC','A',NULL,NULL,'','0000231548','0000142872','','IL','1','KIM','TOMMY','','','','34','275064088','5656 E FOUNTAIN CIR',0,'MASON','OH','45040','7310','CY','39165','2001-01-18','M','',':RET:2040-4','N','021','DEN','2796352','99734OH005000401','2014-03-01','2014-02-14 12:16:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:44'),(27419,21698,'Y','18','021','EC','A','','','AC','0000614172','0000614172','OH00003310727','IL','1','Badertscher','Amanda','','','','34','284805311','302 SOUTH AVE',0,'PANDORA','OH','45877','9421','CY','39137','1983-06-16','F','U',':RET:2106-3','N','021','DEN','2817303','99734OH005000301','2014-04-01','2014-03-04 15:14:41','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-03-04 21:01:37'),(27481,21746,'Y','18','021','EC','A','','','AC','0001232116','0001232116','TX00003156275','31','1','Martin','Lynn','Serrano','','','34','538085679','P.O.Box1385',0,'Ingleside','TX','78362',NULL,'CY','48409','1975-03-02','F','M',':RET:2500-7','N','021','DEN','3389345','33348TX002000101','2014-04-01','2014-03-04 13:41:40','0.00',NULL,NULL,'25.02','25.02','R-TX007','TX0','25.02',NULL,0,'2014-03-04 21:02:17'),(28560,22603,'Y','18','021','EC','A','','','AC','0001042360','0001042360','OH00003747708','IL','1','Cramer','Paula','','','','34','296742621','329 LYNN ST',0,'SAINT MARYS','OH','45885','1642','CY','39011','1969-09-30','F','U',NULL,'T','021','HLT','4114175','92036OH005001505','2014-04-01','2014-03-07 13:34:11','213.00',NULL,NULL,'353.58','140.58','R-OH002','OH0','353.58',NULL,0,'2014-03-07 21:32:25'),(14007,11159,'Y','18','021','EC','A','','','AC','0000956644','0000956644','OH00000739408','IL','1','Hill','David','Grant','','','34','277845861','18 Brompton Lane',0,'Cincinnati','OH','45218',NULL,'CY','39061','1974-07-15','M','U',':RET:2106-3','N','021','HLT','1932379','92036OH001001201','2014-01-01','2013-12-23 09:40:38','0.00',NULL,NULL,'326.78','326.78','R-OH004','OH0','326.78',NULL,0,'2013-12-26 13:16:16'),(19425,15485,'Y','18','021','EC','A','','','AC','0000713658','0000713658','OH00002333481','IL','1','Justice','HEATHER','','','','34','274769645','653 Arlington Dr.',0,'Cincinnati','OH','45244',NULL,'CY','39025','1979-07-17','F','U',NULL,'N','021','HLT','2565342','92036OH004000601','2014-03-01','2014-01-21 17:12:55','198.00',NULL,NULL,'209.55','11.55','R-OH005','OH0','209.55',NULL,1,'2014-01-22 03:23:04'),(18073,14435,'Y','18','021','EC','A','','','AC','0001215431','0001215431','LA00002519277','IL','1','MOORE','MICHAEL','D','','','34','436192633','142 BIRCHWOOD DR',0,'MONROE','LA','71203','2204','CY','22073','1964-08-15','M','U',':RET:2054-5','N','021','DEN','2208973','18575LA002000201','2014-02-01','2014-01-14 09:13:17','0.00',NULL,NULL,'43.83','43.83','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:24'),(3089,2483,'Y','18','021','EC','A','','','AC','0000239010','0000239010','OH00001165689','IL','1','Jones','Kimberly','','','','34','301489370','2105 Fauver Ave',0,'Dayton','OH','45420',NULL,'CY','39113','1964-06-30','F','U',':RET:2106-3','T','021','HLT','751033','92036OH005000505','2014-01-01','2013-12-06 16:34:31','226.00',NULL,NULL,'466.36','240.36','R-OH003','OH0','466.36',NULL,0,'2013-12-25 20:19:57'),(16045,12848,'Y','18','021','EC','A','','','AC','0000512735','0000512735','TX00002190641','IL','1','ESCOBEDO','DELIA','','','','34','461371784','2704 PORTER AVE',0,'EL PASO','TX','79930','3626','CY','48141','1962-01-19','F','M',NULL,'N','021','DEN','2436306','33348TX002000101','2014-02-01','2014-01-03 14:04:04','0.00',NULL,NULL,'25.02','25.02','R-TX009','TX0','25.02',NULL,0,'2014-01-04 02:02:59'),(15039,12021,'Y','18','021','EC','A','','','AC','0000034141','0000034141','LA00000887536','IL','1','English','Jamie','','','','34','433377134','135 DV BYRD LN',0,'WEST MONROE','LA','71292','0470','CY','22073','1965-07-09','F','U',':RET:2106-3','N','021','DEN','1572497','18575LA002000201','2014-02-01','2013-12-30 12:33:54','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:02:53'),(15367,12291,'Y','18','021','EC','A','','','AC','0000936069','0000936069','OH00000173984','IL','1','DANIELS','DORA','','','','34','290503606','9914 WESTCHESTER AVE',0,'CLEVELAND','OH','44108','3454','CY','39035','1953-01-18','F','U',NULL,'N','021','DEN','1888924','99734OH005000301','2014-02-01','2014-01-01 14:54:05','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,1,'2014-01-02 04:24:57'),(22293,17796,'Y','18','021','EC','A','','','AC','0000662724','0000662724','OH00002259196','IL','1','Wolford','Lucinda','K','','','34','487969681','6364 SAVANNAH AVE',0,'CINCINNATI','OH','45224','1918','CY','39061','1973-04-10','F','U',':RET:2106-3','N','021','DEN','2951108','99734OH005000301','2014-03-01','2014-01-21 16:50:17','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-10 11:00:30'),(22474,17946,'Y','18','021','EC','A','','','AC','0000505768','0000505768','OH00001359104','IL','1','lindhorst','paul','','','','34','302806472','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','1975-06-25','M','M',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-02-10 21:31:00'),(26699,21166,'Y','18','021','EC','A','','','AC','0001100646','0001100646','OH00002710016','IL','1','Grubb','Doug','','','','34','401883635','792 St. Rt. 132',0,'Clarksville','OH','45113',NULL,'CY','39027','1965-08-24','M','M',':RET:2106-3','T','021','HLT','3134849','92036OH004000601','2014-04-01','2014-02-27 18:50:31','582.00',NULL,NULL,'634.83','52.83','R-OH005','OH0','324.56',NULL,0,'2014-02-28 21:31:32'),(28041,22188,'N','01','021','EC','A',NULL,NULL,'','0000366840','0000417192','','IL','1','Stepteau','Lesley','T','','','34','428674671','157B N WIND RIDGE LN',0,'PURVIS','MS','39475','5839','CY','28073','1985-01-27','F','',':RET:2054-5','N','021','DEN','4119365','46300MS002000201','2014-04-01','2014-03-05 18:16:29',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-03-06 21:01:31'),(28356,22436,'Y','18','021','EC','A','','','AC','0000468134','0000468134','TX00002896565','IL','1','ADGER','LAWANA','','','','34','493724390','1613 WYLIE CREEK DR',0,'DESOTO','TX','75115','1708','CY','48113','1959-08-25','F','M',NULL,'T','021','DEN','4251450','33348TX002000201','2014-04-01','2014-03-07 13:41:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:26'),(28641,22666,'Y','18','021','EC','A','','','AC','0001030596','0001030596','TX00003324502','IL','1','Patterson','Chad','','','','34','465878073','1718 HARVEST BEND LN',0,'CEDAR PARK','TX','78613','4152','CY','48491','1973-02-20','M','M',':RET:2106-3','N','021','DEN','3606611','33348TX002000201','2014-04-01','2014-03-08 15:35:46','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-03-08 21:30:32'),(353,290,'Y','18','021','EC','A','','','AC','0000088521','0000088521','OH00000096177','IL','1','sayre','theresa','','','','34','299581211','107 W Crosier',0,'akron','OH','44311',NULL,'CY','39153','1955-08-11','F','M',NULL,'T','021','HLT','865288','52664OH152000901','2014-01-01','2013-11-09 00:19:53','440.00',NULL,NULL,'478.62','38.62','R-OH012','OH0','478.62',NULL,0,'2013-12-25 17:32:20'),(20811,16630,'Y','18','024','14','A','','','TE','0000908718','0000908718','','IL','1','Stevenson','Barbara','Rena',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-12-22','F','',NULL,NULL,NULL,'','2312810','','2014-01-31','2014-01-31 17:36:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-31 21:00:28'),(20432,16319,'Y','18','021','EC','A','','','AC','0000076331','0000076331','OH00002508383','IL','1','albers','edward','anthony','','III','34','288886068','3386 OLD SALEM RD',0,'DAYTON','OH','45415','1231','CY','39113','1977-02-22','M','R',NULL,'T','021','DEN','2519074','99734OH005000301','2014-03-01','2014-01-29 14:43:14','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-29 21:00:35'),(19604,15625,'N','01','021','EC','A',NULL,NULL,'','0000727314','0000994000','','IL','1','SPORLEDER','KELLY','ANGELA','','','34','278742376','6020 MAIN ST',0,'SYLVANIA','OH','43560','1265','CY','39095','1962-06-10','F','',':RET:2106-3','T','021','HLT','2809126','92036OH005002604','2014-03-01','2014-01-22 10:49:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','418.23',NULL,0,'2014-01-23 03:02:48'),(2921,2354,'Y','18','021','EC','A','','','AC','0000757107','0000757107','OH00000473933','IL','1','Kinloch','John','','','','34','300508942','4878 state route 7',0,'Burghill','OH','44404',NULL,'CY','39155','1949-10-25','M','M',NULL,'N','021','DEN','439837','99734OH005000401','2014-01-01','2013-12-06 17:25:07','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 20:15:47'),(18738,14931,'Y','18','021','EC','A','','','AC','0000229458','0000229458','OH00002254294','IL','1','Duckro','Brian','Gregory','','','34','279840872','639 Oak st.',0,'Dayton','OH','45410',NULL,'CY','39113','1984-09-20','M','U',':RET:2106-3','T','021','DEN','1674853','99734OH005000301','2014-03-01','2014-01-16 16:06:18','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:35:39'),(14447,11524,'Y','18','021','EC','A','','','AC','0001440556','0001440556','LA00000708969','IL','1','GABRIEL','GAIL','MARIE','','','34','438028636','538 S CORTEZ ST',0,'NEW ORLEANS','LA','70119','6905','CY','22071','1960-10-12','F','U',':RET:2054-5','T','021','DEN','1815687','18575LA002000201','2014-02-01','2013-12-27 12:30:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:23'),(18309,14617,'N','01','021','EC','A',NULL,NULL,'','0000134598','0000607184','','IL','1','Ryan','Robert','L','','','34','283586897','3958 N BEND RD',0,'CINCINNATI','OH','45211','3521','CY','39061','1956-03-17','M','',':RET:2106-3','T','021','DEN','2090322','99734OH005000401','2014-02-01','2014-01-15 12:16:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:01'),(17976,14364,'Y','18','021','EC','A','','','AC','0000307117','0000307117','OH00002311624','IL','1','Vallen','Erica','','','','34','287907348','1102 MADRID DR',0,'AKRON','OH','44313','5240','CY','39153','1988-12-01','F','U',':RET:2106-3','N','021','HLT','1540404','52664OH151001305','2014-02-01','2014-01-14 12:21:31','127.00',NULL,NULL,'223.90','96.90','R-OH012','OH0','223.90',NULL,0,'2014-01-15 02:06:51'),(14393,11480,'Y','18','021','EC','A','','','AC','0000382170','0000382170','OH00001536144','IL','1','WALDROP','LONNIE','','','','34','515828753','3291 BRENTWOOD CT',0,'POWELL','OH','43065','9134','CY','39041','1966-12-24','M','M',NULL,'N','021','DEN','2537519','99734OH005000401','2014-02-01','2013-12-27 15:53:17','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:31:04'),(17684,14131,'Y','18','024','14','A','','','TE','0001847185','0001847185','','IL','1','Philson','Nathan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-12-16','M','',NULL,NULL,NULL,'','2344683','','2014-01-13','2014-01-13 16:33:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-14 01:32:55'),(17580,14056,'Y','18','021','EC','A','','','AC','0000050708','0000050708','OH00002549817','IL','1','Hindel','Sarah','','','','34','299601175','4295 Marks Ave',0,'Rootstown','OH','44272',NULL,'CY','39133','1977-07-15','F','M',':RET:2106-3','N','021','DEN','1970276','99734OH005000401','2014-02-01','2014-01-13 15:04:29','0.00',NULL,NULL,'71.95','71.95','R-OH012','OH0','0.00',NULL,0,'2014-01-14 01:32:06'),(15972,12783,'Y','18','021','EC','A','','','AC','0001234240','0001234240','TX00002102225','IL','1','RODRIGUEZ','RAMON','','','','34','459252697','413 E JACKSON ST',0,'LEVELLAND','TX','79336','2513','CY','48219','1960-08-04','M','M',NULL,'N','021','DEN','2361547','33348TX002000201','2014-02-01','2014-01-02 21:04:53','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:00:38'),(22171,17694,'Y','18','021','EC','A','','','AC','0000545205','0000545205','OH00002260710','IL','1','CARNAHAN','PAMELA','','','','34','295521099','1830 JONES FLORER RD',0,'BETHEL','OH','45106','8525','CY','39025','1949-11-04','F','M',NULL,'N','021','HLT','3116945','92036OH004000601','2014-03-01','2014-02-07 18:33:38','245.00',NULL,NULL,'517.83','272.83','R-OH005','OH0','517.83','CIC',0,'2014-02-08 19:30:04'),(22521,17980,'Y','18','021','EC','A','','','AC','0000556755','0000556755','OH00002344634','IL','1','Millman','Douglas','','','','34','289486132','337 Lucy Run Road',0,'Amelia','OH','45102',NULL,'CY','39025','1955-08-20','M','U',NULL,'N','021','HLT','3547426','92036OH004000601','2014-03-01','2014-02-10 14:01:54','178.00',NULL,NULL,'439.81','261.81','R-OH005','OH0','439.81',NULL,0,'2014-02-10 21:31:25'),(26061,20668,'Y','18','021','EC','A','','','AC','0000858537','0000858537','OH00003417260','IL','1','Hall','Tiny','','','','34','298560527','1114 Elizabeth St',0,'Ripley','OH','45167',NULL,'CY','39015','1955-05-02','F','U',NULL,'N','021','HLT','2666135','92036OH004000601','2014-04-01','2014-02-26 14:00:15','366.00',NULL,NULL,'439.81','73.81','R-OH005','OH0','439.81',NULL,0,'2014-02-26 21:02:39'),(26737,21190,'N','01','021','EC','A',NULL,NULL,'','0000366339','0000968264','','IL','1','Cappel','Stephanie','A','','','34','272667662','4127 W FORK RD',0,'CINCINNATI','OH','45247','7556','CY','39061','1959-05-07','F','',':RET:2106-3','N','021','HLT','3871477','92036OH004001201','2014-04-01','2014-02-28 14:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','368.53',NULL,0,'2014-02-28 21:31:52'),(13354,10665,'Y','18','021','EC','A','','','AC','0000703569','0000703569','TX00001023754','IL','1','Fisher','Melissa','','','','34','451257339','7700 Ingram Rd',0,'San Antonio','TX','78251',NULL,'CY','48029','1967-05-24','F','U',':RET:2106-3','N','021','DEN','2222852','33348TX002000201','2014-01-01','2013-12-23 19:26:54','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-26 12:59:16'),(20878,16686,'Y','18','021','EC','A','','','AC','0002039999','0002039999','LA00001835987','IL','1','LAURENT','JONAS','G','','','34','433514184','5708 PAULINE DR',0,'NEW ORLEANS','LA','70126','2452','CY','22071','1981-11-30','M','U',':RET:2054-5','N','021','DEN','2877948','18575LA002000101','2014-03-01','2014-01-31 17:25:40','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-31 21:01:06'),(20400,16295,'Y','18','021','EC','A','','','AC','0000226049','0000226049','TX00001383038','IL','1','Lopez','Sylvia','','','','34','460316441','13323 RYAN LANDING DR',0,'HOUSTON','TX','77065','3160','CY','48201','1962-07-20','F','U',NULL,'N','021','DEN','2859660','33348TX002000201','2014-03-01','2014-01-29 14:46:01','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-29 21:00:19'),(19710,15706,'Y','18','021','EC','A','','','AC','0000490505','0000490505','TX00001406126','IL','1','WHITE','LARRY','','','','34','458917604','776 ANGELS HILL RD',0,'SPRING BRANCH','TX','78070','6702','CY','48091','1979-09-21','M','U',':RET:2106-3','N','021','DEN','2563877','33348TX002000201','2014-03-01','2014-01-23 15:54:54','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-23 21:00:52'),(6958,5525,'N','19','021','EC','A',NULL,NULL,'','0000093853','0001208304','','IL','1','MURPHY','AMBER','S','','','34','270984136','4030 BELMORE TRACE',0,'DAYTON','OH','45426',NULL,'CY','39113','1994-09-15','F','',':RET:2054-5','N','021','DEN','1504748','99734OH005000401','2014-01-01','2013-12-24 22:17:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:13'),(19637,15651,'Y','18','021','EC','A','','','AC','0000077592','0000077592','OH00002411436','IL','1','MCCAFFERTY','MARK','','','','34','270541694','9198 SLOUGH RD',0,'CANAL WINCHESTER','OH','43110','9230','CY','39045','1954-10-06','M','M',':RET:2106-3','N','021','DEN','2534265','99734OH005000401','2014-03-01','2014-01-23 11:24:08','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:13'),(20778,16600,'N','01','021','EC','A',NULL,NULL,'','0001200351','0000766942','','IL','1','AGUILAR','RICARDO','B','','','34','641033292','5649 WALDORF DR',0,'EL PASO','TX','79924','3435','CY','48141','1973-10-15','M','',':RET:2106-3','N','021','DEN','3404349','33348TX002000201','2014-03-01','2014-01-30 18:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-31 21:00:07'),(21187,16932,'Y','18','024','14','A','','','TE','0001102489','0001102489','','IL','1','MALLARD','NICHOLAS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-05-26','M','',NULL,NULL,NULL,'','2598786','','2014-02-03','2014-02-03 12:22:22',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-03 21:00:46'),(21671,17307,'Y','18','021','EC','A','','','AC','0001640013','0001640013','LA00002192560','IL','1','Leary','Arnold','F','','','34','437868233','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1953-07-11','M','M',':RET:2054-5','N','021','DEN','2853811','18575LA002000201','2014-03-01','2014-02-05 16:15:19','0.00',NULL,NULL,'43.83','43.83','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:59'),(24187,19214,'Y','18','021','EC','A','','','AC','0000277949','0000277949','TX00002592311','IL','1','Rivas','Sergio','','','','34','637037504','2310 LOVING AVE',0,'FORT WORTH','TX','76164','7814','CY','48439','1988-09-24','M','U',NULL,'N','021','DEN','3820792','33348TX002000101','2014-03-01','2014-02-15 19:22:43','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-16 19:00:11'),(25879,20519,'Y','18','021','EC','A','','','AC','0002274870','0002274870','LA00002294635','IL','1','Walker','Tiffany','','','','34','433391143','160 Maurice Street',0,'Leesville','LA','71446',NULL,'CY','22115','1977-02-19','F','U',':RET:2054-5','N','021','DEN','3153038','18575LA002000201','2014-04-01','2014-02-26 17:46:53','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-26 21:00:56'),(8934,7083,'Y','18','021','EC','A','','','AC','0000064875','0000064875','OH00000186150','IL','1','Blessing','Arlene','','','','34','288684491','2915 NORTH RD NE',0,'WARREN','OH','44483','3044','CY','39155','1960-04-12','F','U',':RET:2106-3','N','021','DEN','1413661','99734OH005000401','2014-01-01','2013-12-18 10:26:58','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:03:07'),(6360,5042,'Y','18','021','EC','A','','','AC','0001257317','0001257317','OH00000495828','IL','1','saxton','ronald','','','','34','269749402','721 THAYER ST',0,'AKRON','OH','44310','3003','CY','39153','1968-01-28','M','U',':RET:2054-5','N','021','DEN','308917','99734OH005000401','2014-01-01','2013-12-11 17:31:01','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:47:19'),(18831,14999,'Y','18','021','EC','A','','','AC','0000019133','0000019133','OH00001798035','IL','1','WAGNER','TIM','J','','','34','301747287','27629 ELLIOTT RD',0,'DEFIANCE','OH','43512','9012','CY','39039','1975-12-02','M','M',NULL,'N','021','HLT','2948334','92036OH001002601','2014-02-01','2014-01-15 18:54:37','378.00',NULL,NULL,'584.27','206.27','R-OH001','OH0','293.09',NULL,0,'2014-01-17 03:36:09'),(15095,12065,'Y','18','021','EC','A','','','AC','0000700385','0000700385','OH00001468861','IL','1','Lanser','Jennifer','','','','34','295861211','2643 Bonnie Drive',0,'Cincinnati','OH','45230',NULL,'CY','39061','1973-09-29','F','U',':RET:2106-3','N','021','DEN','1421582','99734OH005000301','2014-02-01','2013-12-29 23:06:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:04:32'),(16896,13521,'Y','18','021','EC','A','','','AC','0000221310','0000221310','OH00001397500','IL','1','Jennings','Philitca','','','','34','272805388','1335 Trade Winds Dr',0,'Columbus','OH','45204',NULL,'CY','39061','1982-04-11','F','U',':RET:2054-5','N','021','DEN','2034711','99734OH005000401','2014-02-01','2014-01-08 20:35:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:19:30'),(21137,16890,'Y','18','021','EC','A','','','AC','0000364697','0000364697','TX00002156490','IL','1','Wann','Arthur','W','','','34','452251744','3824 Stony Creek Lane',0,'College Station','TX','77845',NULL,'CY','48041','1960-08-28','M','M',':RET:2106-3','N','021','DEN','3714737','33348TX002000201','2014-03-01','2014-02-03 16:27:46','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-03 21:00:20'),(21884,17473,'Y','18','021','EC','A','','','AC','0001176182','0001176182','LA00001484510','IL','1','BORDELON','SANDRA','','','','34','437232669','11165 TUTTLE RD',0,'HAMMOND','LA','70403','3019','CY','22105','1960-12-10','F','U',NULL,'N','021','DEN','3844411','18575LA002000101','2014-03-01','2014-02-05 20:42:26','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-06 21:01:32'),(22621,18063,'Y','18','021','EC','A','','','AC','0000644310','0000644310','TX00002336615','IL','1','bills','elan','','','','34','220170289','hc 70 box 400',0,'lajitas','TX','79852',NULL,'CY','48043','1986-01-21','M','R',NULL,'N','021','DEN','3161245','33348TX002000201','2014-03-01','2014-02-10 20:19:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:10'),(23471,18695,'Y','18','021','EC','A','','','AC','0001090790','0001090790','TX00001621008','IL','1','Craton','Elliott','','','','34','463929725','1221 FM 318',0,'HALLETTSVILLE','TX','77964','4952','CY','48285','1951-02-18','M','M',':RET:2054-5','N','021','DEN','3256092','33348TX002000201','2014-03-01','2014-02-13 16:23:06','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:49'),(25116,19924,'Y','18','024','14','A','','','TE','0001025531','0001025531','','IL','1','Lantz','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-03-30','M','',NULL,NULL,NULL,'','3393690','','2014-03-31','2014-02-20 20:09:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:19'),(25213,19998,'Y','18','021','EC','A','','','AC','0000849484','0000849484','OH00002642286','IL','1','Modica','Donald','','','','34','274804725','1511 RIDGEWICK DR',0,'WICKLIFFE','OH','44092','1626','CY','39085','1971-08-31','M','U',':RET:2106-3','N','021','DEN','3432889','99734OH005000301','2014-04-01','2014-02-21 13:23:45','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:51'),(26406,20942,'Y','18','021','EC','A','','','AC','0000413399','0000413399','OH00002926654','IL','1','Barnett','Wendy','','','','34','290742136','7824 PEACHMONT AVE NW',0,'NORTH CANTON','OH','44720','5799','CY','39151','1963-08-31','F','U',':RET:2106-3','N','021','HLT','3057492','52664OH152000901','2014-04-01','2014-02-26 13:55:36','161.00',NULL,NULL,'291.73','130.73','R-OH015','OH0','291.73','CIC',0,'2014-02-28 07:00:35'),(27297,21614,'Y','18','021','EC','A','','','AC','0000748300','0000748300','TX00003119011','31','1','LYNCH','MEGAN','','','','34','632229733','PO BOX 92',0,'ROUND TOP','TX','78954',NULL,'CY','48477','1987-11-25','F','U',NULL,'N','021','DEN','3874179','33348TX002000201','2014-04-01','2014-03-04 12:27:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:32'),(28682,22698,'Y','18','021','EC','A','','','AC','0001209655','0001209655','OH00003395665','IL','1','Ray','Marsha','','','','34','297467437','290 ATHENS DR',0,'YOUNGSTOWN','OH','44515','4159','CY','39099','1952-01-23','M','M',':RET:2106-3','N','021','DEN','3076659','99734OH005000301','2014-04-01','2014-03-08 13:36:48','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-03-08 21:30:57'),(13810,11022,'N','01','021','EC','A',NULL,NULL,'','0000923328','0000279549','','IL','1','Bartholomew','Emily','Kristen Doll','','','34','272824428','3556 Madison Park Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1984-01-10','F','',NULL,'T','021','HLT','1849749','92036OH005001205','2014-01-01','2013-12-22 22:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','276.24',NULL,0,'2013-12-26 13:11:35'),(1024,839,'Y','18','021','EC','A','','','AC','0000818540','0000818540','OH00000431413','IL','1','LEADING','RUBYLEEN','','','','34','296922434','734 ROBINS GATE',0,'AKRON','OH','44319','5419','CY','39153','1959-09-05','F','M',':RET:2036-2','N','021','HLT','13907','52664OH152000901','2014-01-01','2013-12-03 12:43:23','129.00',NULL,NULL,'348.73','219.73','R-OH012','OH0','348.73',NULL,0,'2013-12-25 18:15:19'),(13760,10983,'Y','18','021','EC','A','','','AC','0001150871','0001150871','MS00001183635','IL','1','BERRY','EDDIE','','','','34','425235496','3959 OAKLAWN DR',0,'JACKSON','MS','39206','4750','CY','28049','1962-03-16','M','M',':RET:2054-5','T','021','DEN','2602979','46300MS002000201','2014-01-01','2013-12-23 09:44:03','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:12'),(1852,1517,'Y','18','021','EC','A','','','AC','0000872049','0000872049','OH00001366489','IL','1','chappell','sherrie','','','','34','290586342','1209 THOMAS CT',0,'CINCINNATI','OH','45215','1835','CY','39061','1957-07-28','F','U',':RET:2054-5','N','021','HLT','2472873','92036OH005001205','2014-01-01','2013-12-24 13:34:12','240.00',NULL,NULL,'500.82','260.82','R-OH004','OH0','500.82',NULL,0,'2013-12-25 18:57:57'),(13734,10961,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00001157825','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','1769990','52664OH151001305','2014-01-01','2013-12-23 18:23:09','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:30'),(6888,5464,'Y','18','021','EC','A','','','AC','0002151042','0002151042','LA00000975607','IL','1','CALAIS','BELINDA','G','','','34','434960362','3212 IDAHO AVE',0,'KENNER','LA','70065','4525','CY','22051','1954-12-14','F','U',':RET:2054-5','N','021','DEN','1776658','18575LA002000201','2014-01-01','2013-12-24 20:29:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:18'),(8097,6408,'N','01','021','EC','A',NULL,NULL,'','0000230429','0000741707','','IL','1','Miller','Rebecca','L','','','34','270809109','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1969-06-25','F','',':RET:2106-3','N','021','HLT','2479133','52664OH151001501','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.65',NULL,0,'2013-12-26 03:10:48'),(21609,17253,'N','01','021','EC','A',NULL,NULL,'','0001162635','0001121422','','IL','1','David','Kathryn','','','','34','400740403','962 GALLATIN CT',0,'CINCINNATI','OH','45240','2406','CY','39061','1951-08-18','F','',':RET:2054-5','N','021','DEN','2649820','99734OH005000301','2014-03-01','2014-02-05 13:27:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:33'),(24398,19379,'Y','18','021','EC','A','','','AC','0000040996','0000040996','OH00003009895','IL','1','Nowak','Troy','','','','34','365925018','2017 Arthur Avenue',0,'Lakewood','OH','44107',NULL,'CY','39035','1983-01-23','M','U',':RET:2106-3','N','021','DEN','3524340','99734OH005000401','2014-04-01','2014-02-18 14:18:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:00:53'),(24609,19532,'Y','18','024','14','A','','','TE','0001217400','0001217400','','IL','1','Day','Barbara',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-09-01','F','',NULL,NULL,NULL,'','2926212','','2014-02-19','2014-02-19 16:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-20 04:13:54'),(413,340,'N','19','021','EC','A',NULL,NULL,'','0000847129','0000811990','','IL','1','New','Everett','','','','34','447594390','5838 EDGEHILL DR',0,'PARMA HEIGHTS','OH','44130','2023','CY','39035','2013-06-18','M','',':RET:2106-3','N','021','DEN','1007424','99734OH005000401','2014-01-01','2013-12-04 15:26:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:28'),(1678,1400,'Y','18','021','EC','A','','','AC','0002206835','0002206835','LA00000593087','IL','1','Johnson','Marilyn','','','','34','439942292','3403 CANONICUS ST',0,'BATON ROUGE','LA','70805','6425','CY','22033','1955-02-14','F','U',':RET:2054-5','N','021','DEN','1433109','18575LA002000101','2014-01-01','2013-12-24 08:54:40','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:54:04'),(3628,2902,'Y','18','021','EC','A','','','AC','0000820986','0000820986','OH00001240300','IL','1','Carter','Robert','','','','34','299720634','8808 st rt 134',0,'Lynchburg','OH','45142',NULL,'CY','39071','1964-08-12','M','U',':RET:2106-3','T','021','HLT','564053','92036OH003000605','2014-01-01','2013-12-13 17:08:09','305.00',NULL,NULL,'439.83','134.83','R-OH005','OH0','439.83',NULL,0,'2013-12-25 21:30:03'),(16166,12943,'Y','18','021','EC','A','','','AC','0002383560','0002383560','LA00000074652','IL','1','Everitt','Shannon','','','','34','515669773','1927wyndemere dr',0,'Slidell','LA','70461',NULL,'CY','22103','1968-06-05','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','1605763','18575LA002000201','2014-02-01','2014-01-03 18:32:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-05 00:00:05'),(5589,4434,'Y','18','021','EC','A','','','AC','0000411225','0000411225','LA00001191326','IL','1','Tharpe','Lindsey','','','','34','436639588','321 Duclos Street',0,'Lafayette','LA','70506',NULL,'CY','22055','1984-12-06','F','U',':RET:2106-3','N','021','DEN','170602','18575LA002000101','2014-01-01','2013-11-05 23:42:44','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 23:17:12'),(19888,15863,'Y','18','021','EC','A','','','AC','0000151976','0000151976','OH00002052649','IL','1','Chan','Hing','','','','34','067705112','453 SEAMAN AVE',0,'AKRON','OH','44305','3850','CY','39153','1979-07-26','M','U',':RET:2034-7','N','021','HLT','3393558','52664OH151001304','2014-03-01','2014-01-23 20:56:12','102.00',NULL,NULL,'270.73','168.73','R-OH012','OH0','270.73',NULL,0,'2014-01-24 21:00:49'),(20845,16662,'Y','18','021','EC','A','','','AC','0000024143','0000024143','OH00002499451','IL','1','Toth-Ganim','Maureen','','','','34','285564554','852 EDGAR LN',0,'BRUNSWICK','OH','44212','5634','CY','39103','1970-08-28','F','U',':RET:2106-3','N','021','DEN','3614093','99734OH005000301','2014-03-01','2014-01-30 20:04:37','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2014-01-31 21:00:49'),(22695,18122,'Y','18','021','EC','A','','','AC','0000224631','0000224631','TX00002695587','IL','1','bell','tawana','','','','34','452250119','501 FLOWERING PLUM LN',0,'FORT WORTH','TX','76140','6558','CY','48439','1973-12-12','F','M',':RET:2054-5','N','021','DEN','3493158','33348TX002000101','2014-03-01','2014-02-10 22:53:54','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-11 21:00:55'),(23070,18394,'Y','18','021','EC','A','','','AC','0002082241','0002082241','LA00002501101','IL','1','Tyler','Marcie','','','','34','435616592','1613 HIGHWAY 153',0,'ASHLAND','LA','71002','2659','CY','22069','1973-10-03','F','M',NULL,'N','021','DEN','3459423','18575LA002000201','2014-03-01','2014-02-12 12:57:03','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-12 21:30:56'),(28497,22549,'Y','18','024','14','A','','','TE','0001215614','0001215614','','IL','1','Mcqueen','Florine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-03-24','F','',NULL,NULL,NULL,'','2947087','','2014-03-07','2014-03-07 16:34:37',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-03-07 21:31:45'),(26,21,'Y','18','021','EC','A','','','AC','0001060880','0001060880','OH00001078266','IL','1','Sauer','Mark','','','','34','293744511','1935 EMERSON AVE',0,'DAYTON','OH','45406','4808','CY','39113','1961-11-13','M','U',':RET:2106-3','N','021','DEN','331719','99734OH005000401','2014-01-01','2013-12-05 11:33:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 17:15:39'),(1091,897,'Y','18','021','EC','A','','','AC','0001062083','0001062083','OH00000159877','IL','1','Wills','Jeffrey','','','','34','271686549','2812 VINCENT DR',0,'SEVEN HILLS','OH','44131','6263','CY','39035','1961-11-22','M','M',':RET:2106-3','N','021','DEN','193714','99734OH005000401','2014-01-01','2013-12-03 13:53:10','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:17:02'),(16500,13201,'Y','18','021','EC','A','','','AC','0000315950','0000315950','OH00002266120','IL','1','Schmidt','Michael','','','','34','293505311','5725 RESIK DR',0,'HUBER HEIGHTS','OH','45424','4319','CY','39113','1950-11-19','M','M',':RET:2106-3','N','021','HLT','1641515','92036OH005000506','2014-02-01','2014-01-06 14:27:16','1292.00',NULL,NULL,'1403.40','111.40','R-OH003','OH0','701.70',NULL,0,'2014-01-07 04:06:49'),(3373,2703,'Y','18','024','14','A','','','TE','0000604202','0000604202','','IL','1','Reeise','Kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-30','M','',NULL,NULL,NULL,'','1413912','','2013-12-22','2013-12-22 16:51:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:17:19'),(4712,3736,'Y','18','021','EC','A','','','AC','0001195490','0001195490','OH00000833409','IL','1','Rode','Helen','','','','34','285481814','17319 MIDDLE POINT RD',0,'VAN WERT','OH','45891','9779','CY','39161','1950-11-10','F','U',':RET:2106-3','N','021','HLT','189954','92036OH005001506','2014-01-01','2013-12-12 14:20:42','550.00',NULL,NULL,'649.68','99.68','R-OH002','OH0','649.68',NULL,0,'2013-12-25 22:08:45'),(2560,2082,'Y','18','021','EC','A','','','AC','0000055886','0000055886','OH00000263269','IL','1','Bush','Barbara','','','','34','206365316','25 SCHONHARDT ST',0,'TIFFIN','OH','44883','2867','CY','39147','1960-02-20','F','M',':RET:2106-3','N','021','HLT','338498','92036OH003002706','2014-01-01','2013-12-09 11:40:42','809.00',NULL,NULL,'890.48','81.48','R-OH006','OH0','415.41',NULL,0,'2013-12-25 19:37:28'),(2555,2079,'Y','18','021','EC','A','','','AC','0000385176','0000385176','MS00000752495','IL','1','Bell','Mack','','','','34','425315624','2025 TULANE RD',0,'NESBIT','MS','38651','9647','CY','28033','1963-05-26','M','M',':RET:2054-5','N','021','DEN','959639','46300MS002000201','2014-01-01','2013-12-09 13:54:12','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85',NULL,0,'2013-12-25 19:37:23'),(7446,5894,'Y','18','021','EC','A','','','AC','0001033643','0001033643','OH00000453699','IL','1','Hardy','Amy','','','','34','276701812','6109 PINE MEADOWS DR',0,'LOVELAND','OH','45140','6538','CY','39025','1973-07-26','F','M',':RET:2106-3','N','021','DEN','272273','99734OH005000301','2014-01-01','2013-12-15 11:23:36','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:30:34'),(1297,1073,'Y','18','021','EC','A','','','AC','0000566388','0000566388','TX00000332801','IL','1','Vanwie','Joseph','','','','34','398084151','1814 CANYON CREEK DR',0,'TEMPLE','TX','76502','3211','CY','48027','1991-12-29','M','U',':RET:2106-3','N','021','DEN','870784','33348TX002000101','2014-01-01','2013-11-29 15:58:47','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-25 18:31:02'),(20766,16590,'Y','18','024','14','A','','','TE','0000241511','0000241511','','IL','1','STRIKE','NICHOLAS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-10-09','M','',NULL,NULL,NULL,'','1418462','','2014-01-30','2014-01-30 14:10:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:37'),(21887,17476,'Y','18','021','EC','A','','','AC','0001235225','0001235225','OH00002423198','IL','1','Cramer','Zachary','','','','34','302885815','6285 KENWOOD HILLS DR',0,'CINCINNATI','OH','45227','1319','CY','39061','1987-09-17','M','R',':RET:2106-3','N','021','HLT','3790990','92036OH002001201','2014-03-01','2014-02-05 19:25:14','0.00',NULL,NULL,'253.85','253.85','R-OH004','OH0','253.85',NULL,0,'2014-02-06 21:01:35'),(23005,18340,'Y','18','024','14','A','','','TE','0001016891','0001016891','','IL','1','mccandless','Lawren',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-10-20','M','',NULL,NULL,NULL,'','2632680','','2014-02-12','2014-02-12 18:15:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:30:20'),(262,217,'Y','18','021','EC','A','','','AC','0000874670','0000874670','OH00001200310','IL','1','sabel','robert','','','','34','275608273','280 paris dr',0,'austintown','OH','44515',NULL,'CY','39099','1957-09-11','M','M',':RET:2106-3','N','021','HLT','799322','92036OH004003201','2014-01-01','2013-12-05 14:12:20','694.00',NULL,NULL,'931.93','237.93','R-OH013','OH0','454.06',NULL,0,'2013-12-25 17:21:52'),(580,475,'Y','18','021','EC','A','','','AC','0000230406','0000230406','OH00000847706','IL','1','Frazier','Wesley','','','','34','278880085','2325Wimbledon Pk.',0,'Toledo','OH','43617',NULL,'CY','39095','1978-08-31','M','U',':RET:2106-3','N','021','HLT','1235983','92036OH002002601','2014-01-01','2013-12-04 13:12:15','25.00',NULL,NULL,'275.16','250.16','R-OH001','OH0','275.16',NULL,0,'2013-12-25 17:50:51'),(747,617,'Y','18','021','EC','A','','','AC','0000282726','0000282726','TX00000897284','31','1','Kantor','Tammy','','','','34','456955534','700 FRANKLIN BLVD',0,'AUSTIN','TX','78751','1835','CY','48453','1979-02-26','F','U',':RET:2106-3','N','021','DEN','80662','33348TX002000201','2014-01-01','2013-12-16 00:48:40','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:10'),(33,28,'Y','18','021','EC','A','','','AC','0000745405','0000745405','OH00000827778','IL','1','Salyers','Charles','','','','34','294641662','15026 GIBSON RD',0,'ASHVILLE','OH','43103','9663','CY','39129','1958-03-07','M','U',':RET:2106-3','N','021','DEN','1118626','99734OH005000401','2014-01-01','2013-12-05 12:35:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:15:51'),(8096,6408,'N','19','021','EC','A',NULL,NULL,'','0000230429','0000619632','','IL','1','Miller','Megan','M','','','34','289027437','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','1997-09-13','F','',':RET:2106-3','N','021','HLT','2479133','52664OH151001501','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2013-12-26 03:10:48'),(6930,5502,'Y','18','021','EC','A','','','AC','0000948420','0000948420','OH00000043564','IL','1','Colagross','Lisa','','','','34','287668964','14181 PAINESVILLE WARREN RD',0,'PAINESVILLE','OH','44077','9771','CY','39085','1970-05-19','F','M',':RET:2106-3','T','021','DEN','2340091','99734OH005000401','2014-01-01','2013-12-24 20:00:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:46:29'),(19199,15295,'Y','18','021','EC','A','','','AC','0000761050','0000761050','TX00001456535','IL','1','Mackey-Amador','Janet','','','','34','449453832','16 East Wandering Oak Drive',0,'The Woodlands','TX','77381',NULL,'CY','48339','1962-10-28','F','R',':RET:2106-3','N','021','DEN','2070309','33348TX002000101','2014-03-01','2014-01-20 17:10:09','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-21 08:46:15'),(3476,2791,'Y','18','021','EC','A','','','AC','0000710128','0000710128','OH00001206802','IL','1','Larsen','Kathy','','','','34','286744207','54 West Park St',0,'Westerville','OH','43081',NULL,'CY','39049','1964-04-03','F','U',NULL,'N','021','DEN','1767779','99734OH005000401','2014-01-01','2013-12-22 10:56:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:20:05'),(3124,2510,'N','01','021','EC','A',NULL,NULL,'','0000116560','0000319627','','IL','1','Gronbeck','Mary','Krebs','','','34','279784268','1751 OLDE HALEY DR',0,'CENTERVILLE','OH','45458','6053','CY','39113','1980-03-15','F','',NULL,'N','021','DEN','654717','99734OH005000301','2014-01-01','2013-10-13 14:06:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:30:22'),(22898,18252,'N','01','021','EC','A',NULL,NULL,'','0000073974','0000337640','','IL','1','Huff','Kevin','Isaac','','','34','559516497','15054 MOCK RD',0,'BERLIN CENTER','OH','44401','8731','CY','39099','1975-04-23','M','',':RET:2106-3','N','021','HLT','3669385','92036OH002003201','2014-03-01','2014-02-11 10:22:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','348.31',NULL,0,'2014-02-11 21:02:39'),(25123,19928,'Y','18','024','14','A','','','TE','0001174433','0001174433','','IL','1','ulrick','peter',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-19','M','',NULL,NULL,NULL,'','3464360','','2014-03-31','2014-02-20 20:29:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-21 21:30:22'),(26238,20809,'N','01','021','EC','A',NULL,NULL,'','0000287264','0000961236','','IL','1','Tukdi','Rahila','Ali','','','34','642808870','17310 ABACO HARBOUR LN',0,'ROUND ROCK','TX','78664','7242','CY','48453','1965-05-11','F','',':RET:2028-9','N','021','DEN','3401825','33348TX002000201','2014-04-01','2014-02-27 09:16:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-28 06:31:03'),(3645,2917,'Y','18','021','EC','A','','','AC','0000863447','0000863447','OH00000585808','IL','1','Anderson','Robin','L','','','34','296501026','240 NATHAN AVE',0,'CUYAHOGA FALLS','OH','44221','2613','CY','39153','1954-05-22','M','U',':RET:2106-3','T','021','DEN','945500','99734OH005000401','2014-01-01','2013-12-13 18:05:21','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:30:28'),(18093,14452,'Y','18','021','EC','A','','','AC','0001512632','0001512632','LA00002521583','IL','1','Jeanfreau','Ashley','','','','34','435838339','208 MAIN ST',0,'BELLE CHASSE','LA','70037','2724','CY','22075','1983-12-07','F','U',':RET:2106-3','T','021','DEN','1437368','18575LA002000201','2014-02-01','2014-01-14 12:48:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-15 02:07:31'),(17465,13966,'N','01','021','EC','A',NULL,NULL,'','0000631527','0001121404','','IL','1','Roberts','David','','','','34','401721011','504 Robinson Ave',0,'Kenton','OH','43326',NULL,'CY','39065','1952-11-02','M','',':RET:2106-3','N','021','DEN','1435030','99734OH005000301','2014-02-01','2014-01-11 18:38:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:05'),(17014,13616,'Y','18','021','EC','A','','','AC','0000532122','0000532122','OH00001836684','IL','1','POPOLIZIO','LEAH','','','','34','073764455','8988 W 130TH ST',0,'STRONGSVILLE','OH','44136',NULL,'CY','39035','1981-07-11','F','R',':RET:2106-3','N','021','DEN','2512015','99734OH005000301','2014-02-01','2014-01-09 15:26:48','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:20:37'),(7950,6290,'Y','18','021','EC','A','','','AC','0002100945','0002100945','LA00000611903','IL','1','Goodly','Kenneth','','','','34','436371536','306 George Green',0,'Fenton','LA','70640',NULL,'CY','22053','1963-10-21','M','U',':RET:2054-5','N','021','DEN','1948868','18575LA002000201','2014-01-01','2013-12-20 17:53:30','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 03:07:08'),(15549,12442,'Y','18','021','EC','A','','','AC','0002024364','0002024364','LA00001132855','IL','1','COOPER','AKIRA','KHALIA','','','34','439794373','103 POWELL ST',0,'DELHI','LA','71232','2125','CY','22083','1990-10-11','F','U',':RET:2054-5','N','021','DEN','1655412','18575LA002000201','2014-02-01','2013-12-31 16:08:33','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:31:13'),(4793,3800,'N','01','021','EC','A',NULL,NULL,'','0000229411','0000683355','','IL','1','Lim','Marie','','','','34','281587456','900 ELMORE AVE',0,'AKRON','OH','44302','1239','CY','39153','1954-06-23','F','',':RET:2034-7','N','021','HLT','35841','52664OH151001304','2014-01-01','2013-12-08 13:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-25 22:16:20'),(5092,4036,'Y','18','021','EC','A','','','AC','0000245809','0000245809','TX00001276828','IL','1','Guevara','Alejo','','','Jr','34','462087378','3900 Eisenhauer',0,'San Antonio','TX','78218',NULL,'CY','48029','1957-06-20','M','M',NULL,'N','021','DEN','2360926','33348TX002000201','2014-01-01','2013-12-19 15:29:51','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 23:01:14'),(21526,17198,'Y','18','024','14','A','','','TE','0000473263','0000473263','','IL','1','Chambers','Joe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-21','M','',NULL,NULL,NULL,'','2702919','','2014-02-04','2014-02-04 19:31:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-05 21:30:05'),(21698,17326,'Y','18','021','EC','A','','','AC','0000460609','0000460609','OH00001880480','IL','1','Chung','Terrence','','','','34','470194959','2304 PARKER RD',0,'AKRON','OH','44313','4306','CY','39153','1967-11-29','M','R',':RET:2054-5','N','021','HLT','3231904','52664OH151001501','2014-03-01','2014-02-04 21:51:49','0.00',NULL,NULL,'401.20','401.20','R-OH012','OH0','401.20',NULL,0,'2014-02-05 21:31:09'),(13379,10682,'N','19','021','EC','A',NULL,NULL,'','0000110519','0000459144','','S1','1','jakupca','jason','','','','34','292135693','9418 DOROTHY AVE',0,'GARFIELD HEIGHTS','OH','44125','1417','CY','39035','2008-01-25','F','',NULL,'N','021','DEN','2538334','99734OH005000301','2014-01-01','2013-12-22 22:57:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:52'),(20491,16370,'Y','18','021','EC','A','','','AC','0001920011','0001920011','LA00002316473','IL','1','BURISE','LILLIAN','L','','','34','439081036','407 E COLORADO ST',0,'HAMMOND','LA','70401','2614','CY','22105','1957-01-31','F','U',':RET:2054-5','N','021','DEN','3007980','18575LA002000201','2014-03-01','2014-01-28 22:23:03','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-29 21:01:07'),(20003,15953,'N','19','021','EC','A',NULL,NULL,'','0000354005','0000654624','','IL','1','Pieffer','Frankie',NULL,NULL,NULL,NULL,NULL,'3881 W 227TH ST',0,'FAIRVIEW PARK','OH','44126','1031','CY','39035','2009-02-18','M','',':RET:2106-3','N','021','DEN','2594871','99734OH005000401','2014-03-01','2014-01-26 11:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-26 19:00:05'),(18665,14880,'Y','18','021','EC','A','','','AC','0000791243','0000791243','TX00001376792','IL','1','Vasquez','Kimberly','','','','34','600800442','6127 VERDE VALLEY DR',0,'HUMBLE','TX','77396','1351','CY','48201','1988-06-10','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','2209118','33348TX002000201','2014-03-01','2014-01-16 16:24:12','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-17 03:35:15'),(3408,2736,'Y','18','021','EC','A','','','AC','0001351076','0001351076','LA00001012899','IL','1','Brown','Kecia','','','','34','436435845','2617 COLORADO DR',0,'MARRERO','LA','70072','6128','CY','22051','1965-02-15','F','U',NULL,'N','021','DEN','1678252','18575LA002000201','2014-01-01','2013-12-22 15:14:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:18:18'),(17645,14104,'N','01','021','EC','A',NULL,NULL,'','0000394947','0000890771','','IL','1','Chiuchiarelli','Julie','A','','','34','277604065','14825 LANCELOT LN W',0,'NORTH ROYALTON','OH','44133','4309','CY','39035','1963-12-28','F','',':RET:2106-3','N','021','DEN','2565101','99734OH005000301','2014-02-01','2014-01-13 09:55:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:38'),(16617,13293,'Y','18','021','EC','A','','','AC','0001026952','0001026952','OH00002039660','IL','1','gerhart','andrea','','','','34','281843572','629 SKYLES RD',0,'UNION','OH','45322','3229','CY','39113','1976-09-23','F','M',':RET:2106-3','N','021','DEN','1473269','99734OH005000401','2014-02-01','2014-01-07 12:15:56','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-08 18:24:10'),(15985,12795,'Y','18','021','EC','A','','','AC','0000945523','0000945523','TX00001437349','IL','1','armour','tricia','leann','','','34','450819541','324 QUAIL CROSSING DR',0,'SANGER','TX','76266','6611','CY','48121','1978-12-19','F','M',':RET:2106-3','N','021','DEN','2597027','33348TX002000201','2014-02-01','2014-01-03 11:28:22','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-04 02:01:05'),(15198,12146,'Y','18','021','EC','A','','','AC','0001032436','0001032436','MS00000905687','31','1','Nolan','Stephen','Lee','','','34','426080661','Po Box 283',0,'North Carrolton','MS','38947',NULL,'CY','28015','1959-09-19','M','U',':RET:2106-3','T','021','DEN','2566132','46300MS002000201','2014-02-01','2013-12-30 10:14:09','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-01 12:07:19'),(3834,3067,'N','01','021','EC','A',NULL,NULL,'','0001124051','0000661330','','IL','1','Scholten','Kathleen','','','','34','384766603','2106 PRESSLER RD',0,'AKRON','OH','44312','4328','CY','39153','1962-11-22','F','',':RET:2106-3','N','021','DEN','85836','99734OH005000301','2014-01-01','2013-12-13 16:51:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:35:12'),(6807,5399,'Y','18','021','EC','A','','','AC','0000938934','0000938934','TX00000792495','IL','1','yaws','suzanne','','','','34','442706186','4703 OLSEN BLVD',0,'AMARILLO','TX','79106','4733','CY','48375','1969-08-14','F','U',':RET:1002-5^:RET:2106-3','N','021','DEN','277863','33348TX002000201','2014-01-01','2013-11-13 18:28:55','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 01:30:11'),(25716,20398,'N','19','021','EC','A',NULL,NULL,'','0001044303','0000369662','','IL','1','Dingman','Kara','','','','34','632344044','8324 N US HIGHWAY 281',0,'STEPHENVILLE','TX','76401','8905','CY','48143','1992-12-17','F','',':RET:2106-3','N','021','DEN','3058894','33348TX002000201','2014-04-01','2014-02-24 16:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:25'),(25883,20523,'Y','18','021','EC','A','','','AC','0000611231','0000611231','TX00002993205','IL','1','WINBOURN','ROSE','M','','','34','447562739','3502 OLD IOWA PARK RD',0,'WICHITA FALLS','TX','76306','3721','CY','48485','1951-11-11','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','3654673','33348TX002000201','2014-03-01','2014-02-26 10:40:36','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-26 21:00:59'),(26073,20676,'Y','18','021','EC','A','','','AC','0000274844','0000274844','OH00003120240','IL','1','WAGNER','KEITH','','','','34','295526609','2115 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','2605','CY','39095','1956-07-22','M','U',NULL,'N','021','HLT','3650563','92036OH004002601','2014-03-01','2014-02-26 16:31:02','379.32',NULL,NULL,'382.11','2.79','R-OH001','OH0','382.11',NULL,0,'2014-02-26 21:02:45'),(28871,22849,'Y','18','021','EC','A','','','AC','0001060132','0001060132','TX00002775842','IL','1','Rodriguez','Monique','','','','34','462556793','5706 ORLANDO LN',0,'EL PASO','TX','79924','7421','CY','48141','1981-11-04','F','U',':RET:2106-3','N','021','DEN','3884425','33348TX002000201','2014-04-01','2014-03-09 21:01:11','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-10 21:00:02'),(6975,5535,'Y','18','021','EC','A','','','AC','0000647078','0000647078','OH00000044834','IL','1','Rosholt','Robin',NULL,NULL,NULL,NULL,NULL,'4241 Eldridge Ave SW',0,'Massillon','OH','44646',NULL,'CY','39151','1960-11-15','F','M',':RET:2106-3','N','021','DEN','1559243','99734OH005000401','2014-01-01','2013-12-24 23:27:53','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2013-12-26 01:47:33'),(5572,4420,'Y','18','021','EC','A','','','AC','0000711338','0000711338','OH00001086991','IL','1','Dixon','Grant','Turner','','Jr','34','288722156','2101 wyoming Street',0,'Dayton','OH','45410',NULL,'CY','39113','1962-05-02','M','U',':RET:2106-3','T','021','DEN','196169','99734OH005000301','2014-01-01','2013-11-06 16:37:05','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:16:41'),(19636,15650,'Y','18','021','EC','A','','','AC','0000943448','0000943448','OH00002359519','IL','1','Collins','Wanetta','','','','34','297486769','1505 E 24TH AVE',0,'COLUMBUS','OH','43211','2543','CY','39049','1951-05-28','F','U',NULL,'N','021','DEN','2925958','99734OH005000401','2014-03-01','2014-01-23 08:22:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:12'),(3305,2660,'Y','18','021','EC','A','','','AC','0000097572','0000097572','OH00000765388','IL','1','Manansala','Christian','','','','34','667222742','1085 TREELINE WAY',0,'DELAWARE','OH','43015','3547','CY','39041','1980-08-08','M','R',':RET:2036-2','N','021','DEN','1644492','99734OH005000301','2014-01-01','2013-12-22 13:36:50','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:15:47'),(15195,12143,'Y','18','021','EC','A','','','AC','0000726277','0000726277','MS00000353867','IL','1','Shird','Lorna','','','','34','587944532','722 CAMPBELL ST',0,'JACKSON','MS','39203','1327','CY','28049','1954-07-30','F','U',':RET:2054-5','N','021','DEN','2382714','46300MS002000201','2014-02-01','2013-12-30 09:34:46','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-01 12:07:14'),(15456,12368,'Y','18','021','EC','A','','','AC','0001219210','0001219210','TX00002089949','IL','1','Thorne','Gillian','','','','34','455632378','4837 CEDAR SPRINGS RD',0,'DALLAS','TX','75219','1204','CY','48113','1981-06-14','F','U',':RET:2106-3','N','021','DEN','2229853','33348TX002000201','2014-02-01','2013-12-31 17:16:39','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:28:31'),(17700,14145,'Y','18','021','EC','A','','','AC','0001944635','0001944635','LA00002173814','IL','1','Pfefferman','Sherrie','','','','34','269569773','1850 Harbor Dr.',0,'Slidell','LA','70458',NULL,'CY','22103','1954-01-24','F','M',':RET:2106-3','N','021','DEN','2607485','18575LA002000201','2014-02-01','2014-01-13 13:42:32','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:04'),(17069,13659,'N','01','021','EC','A',NULL,NULL,'','0001138430','0000364607','','IL','1','Eatmon','Curtis','','','III','34','450670935','1526 Reynoldston',0,'Dallas','TX','75232',NULL,'CY','48113','1980-01-02','M','',':RET:2054-5','N','021','DEN','1920115','33348TX002000201','2014-02-01','2014-01-07 21:57:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-13 02:21:16'),(21635,17275,'Y','18','021','EC','A','','','AC','0000980039','0000980039','TX00002253436','31','1','Milligan','Charles','','','','34','458392874','PO BOX 1238',0,'Port Aransas','TX','78373',NULL,'CY','48355','1967-12-17','M','R',':RET:1002-5^:RET:2106-3','N','021','DEN','3243863','33348TX002000201','2014-03-01','2014-02-05 12:57:21','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-05 21:30:43'),(22404,17888,'N','01','021','EC','A',NULL,NULL,'','0001021509','0000616913','','IL','1','Morlan','Lana','','','','34','296501320','1261 CARNEGIE AVE',0,'AKRON','OH','44314','1151','CY','39153','1949-04-15','F','',NULL,'T','021','HLT','3410397','52664OH151001306','2014-03-01','2014-02-10 16:44:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','769.35',NULL,0,'2014-02-10 21:30:21'),(25309,20077,'Y','18','024','14','A','','','TE','0000511990','0000511990','','IL','1','Macias','Gregory',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-05-16','M','',NULL,NULL,NULL,'','3205590','','2014-03-31','2014-02-25 10:54:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:31'),(2035,1665,'N','01','021','EC','A',NULL,NULL,'','0000695802','0000717188','','IL','1','Plummer','Jo','B','','','34','567250458','P.O. Box 1873',0,'Andrews','TX','79714',NULL,'CY','48003','1960-07-16','F','',':RET:2106-3','N','021','DEN','840994','33348TX002000201','2014-01-01','2013-12-09 20:35:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:15:26'),(19444,15499,'Y','18','021','EC','A','','','AC','0000802607','0000802607','OH00002509644','IL','1','Brock','Michele','','','','34','272707240','464 E PEKIN RD',0,'LEBANON','OH','45036','8191','CY','39165','1975-12-14','F','M',':RET:2106-3','N','021','DEN','1458692','99734OH005000301','2014-03-01','2014-01-22 13:52:42','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:01:50'),(14371,11462,'Y','18','021','EC','A','','','AC','0000435308','0000435308','OH00001440150','IL','1','delvalle','martha','','','','34','345662277','2711 Homewood Dr',0,'lorain','OH','44055',NULL,'CY','39093','1974-09-21','F','U',NULL,'N','021','DEN','1514674','99734OH005000401','2014-02-01','2013-12-27 10:49:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:30:31'),(2636,2142,'N','19','021','EC','A',NULL,NULL,'','0000474926','0000112904','','IL','1','Toth','Caroline',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-05-01','F','',':RET:2106-3','N','021','DEN','236591','99734OH005000401','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:14'),(7787,6167,'Y','18','021','EC','A','','','AC','0000493093','0000493093','TX00000240746','31','1','Valles','Juan','David','','','34','459063233','PO Box 334',0,'Sanderson','TX','79848',NULL,'CY','48443','1956-06-24','M','M',':RET:2106-3','N','021','DEN','2592275','33348TX002000201','2014-01-01','2013-12-20 14:26:59','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:21'),(2937,2363,'N','01','021','EC','A',NULL,NULL,'','0000906587','0000864796','','IL','1','Marshall','Bennie','','','','34','430901280','2760 WENTWORTH AVE',0,'DAYTON','OH','45406','1640','CY','39113','1949-07-26','M','',':RET:2054-5','N','021','DEN','967024','99734OH005000401','2014-01-01','2013-12-05 22:44:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:16:07'),(8829,7000,'Y','18','021','EC','A','','','AC','0000534992','0000534992','TX00000365472','IL','1','Garza','Yolanda','','','','34','457439070','184 SHORELINE DR',0,'BROWNSVILLE','TX','78521','4333','CY','48061','1962-09-06','F','M',':RET:2106-3','N','021','DEN','2086795','33348TX002000201','2014-01-01','2013-12-17 20:08:44','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2013-12-26 04:00:28'),(22763,18174,'Y','18','021','EC','A','','','AC','0000075276','0000075276','OH00001959424','IL','1','taylor','kimberly','a','','','34','276524541','4740 HOLIDAY DR',0,'FAIRFIELD','OH','45014','1876','CY','39017','1957-04-12','F','U',':RET:2106-3','T','021','DEN','3429063','99734OH005000401','2014-03-01','2014-02-11 11:03:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:34'),(23232,18521,'N','01','021','EC','A',NULL,NULL,'','0000257166','0000872094','','IL','1','Rybak','Charles','','','','34','287788414','1813 TALBOT ST',0,'TOLEDO','OH','43613','4615','CY','39095','1979-09-11','M','',NULL,'N','021','HLT','3588279','92036OH005002605','2014-03-01','2014-02-12 10:49:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','236.72',NULL,0,'2014-02-12 21:32:26'),(27277,21600,'Y','18','021','EC','A','','','AC','0000196591','0000196591','TX00003692529','IL','1','Tavitas','Ruben','','','','34','454316648','8602 Cinnamon Creek Dr',0,'San Antonio','TX','78240',NULL,'CY','48029','1960-07-31','M','M',':RET:2106-3','N','021','DEN','3829896','33348TX002000201','2014-04-01','2014-03-03 20:54:36','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-03-04 21:00:20'),(28128,22259,'N','01','021','EC','A',NULL,NULL,'','0000432824','0000627935','','IL','1','Crane','Laura','','','','34','285506578','286 BRENTWOOD DR',0,'HUDSON','OH','44236','1656','CY','39153','1953-01-23','F','',':RET:2106-3','N','021','HLT','3481340','52664OH151001305','2014-04-01','2014-03-06 10:59:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-03-06 21:02:23'),(29112,23045,'Y','18','024','14','A','','','TE','0001616395','0001616395','','IL','1','Jones','Valerie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-03-23','F','',NULL,NULL,NULL,'','1937029','','2014-03-31','2014-03-10 15:24:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-10 21:02:25'),(13344,10656,'Y','18','021','EC','A','','','AC','0000051878','0000051878','TX00001023750','IL','1','Borik','Dvir','','','','34','630056064','1902 AUGUSTA DR',0,'HOUSTON','TX','77057','3120','CY','48201','1974-08-05','M','U',':RET:2106-3','N','021','DEN','2614663','33348TX002000201','2014-01-01','2013-12-23 18:40:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:59:01'),(17492,13987,'Y','18','021','EC','A','','','AC','0001967146','0001967146','LA00002095389','31','1','ARMSTRONG','VIVIAN','','','','34','439025175','PO BOX 114',0,'ZWOLLE','LA','71486',NULL,'CY','22085','1955-07-12','F','M',':RET:1002-5','N','021','DEN','1791473','18575LA002000201','2014-02-01','2014-01-11 22:01:26','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-13 03:01:20'),(18285,14598,'Y','18','021','EC','A','','','AC','0001252140','0001252140','OH00002138788','IL','1','Early','Teresa','','','','34','292845010','6782 RICHARD AVE',0,'CINCINNATI','OH','45224','1148','CY','39061','1986-07-22','F','U',':RET:2054-5','N','021','DEN','2479989','99734OH005000401','2014-02-01','2014-01-14 20:01:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:44:49'),(1561,1303,'Y','18','021','EC','A','','','AC','0000891955','0000891955','MS00001092902','IL','1','Kincaid','Erich','','','','34','526774668','12176 Morton Marathon Road',0,'Forest','MS','39074',NULL,'CY','28123','1971-08-09','M','U',':RET:2054-5','T','021','DEN','1897772','46300MS002000201','2014-01-01','2013-12-24 17:24:02','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-25 18:50:54'),(1836,1505,'Y','18','021','EC','A','','','AC','0001075306','0001075306','OH00000010324','IL','1','carper','james','','','','34','292800083','2245 CRAMER AVE',0,'AKRON','OH','44312','1207','CY','39153','1967-11-27','M','U',':RET:2106-3','N','021','HLT','2516823','52664OH151001301','2014-01-01','2013-12-24 11:20:09','0.00',NULL,NULL,'334.51','334.51','R-OH012','OH0','334.51',NULL,0,'2013-12-25 18:57:32'),(15687,12549,'Y','18','021','EC','A','','','AC','0000545259','0000545259','OH00001682471','IL','1','Moellinger','Timothy','','','','34','300680151','6724 Kentford Ct',0,'Cincinnati','OH','45233',NULL,'CY','39061','1968-04-10','M','U',NULL,'N','021','HLT','1968819','92036OH006001201','2014-02-01','2013-12-31 17:51:38','163.00',NULL,NULL,'245.84','82.84','R-OH004','OH0','245.84',NULL,1,'2014-01-02 04:35:13'),(15681,12543,'Y','18','021','EC','A','','','AC','0001033662','0001033662','OH00001361987','IL','1','Evans','Robin','','','','34','276546062','2809 Devils Hole Road',0,'Pemberville','OH','43450',NULL,'CY','39173','1953-08-11','M','U',':RET:2106-3','N','021','HLT','1949330','92036OH005002604','2014-02-01','2013-12-31 10:52:25','372.00',NULL,NULL,'529.21','157.21','R-OH001','OH0','529.21',NULL,1,'2014-01-02 04:34:58'),(1961,1600,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000358978','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','525781','33348TX002000101','2014-01-01','2013-11-19 22:58:52','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:13'),(13250,10574,'Y','18','021','EC','A','','','AC','0001167789','0001167789','TX00000632212','IL','1','Lewis','Beverly','','','','34','451960933','3975 MCCALL CREEK RD',0,'BLANCO','TX','78606','5115','CY','48031','1954-11-10','F','M',':RET:2106-3','N','021','DEN','1745957','33348TX002000201','2014-01-01','2013-12-23 11:10:39','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:21'),(7961,6301,'Y','18','024','14','A','','','TE','0001219757','0001219757','','IL','1','Irvin','Jametria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-07-02','F','',NULL,NULL,NULL,'','1907202','','2013-12-19','2013-12-19 20:48:00',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 03:07:26'),(18931,15084,'Y','18','021','EC','A','','','AC','0000087511','0000087511','OH00001978823','IL','1','LIPP','CECILIA','','','','34','269505572','722 FAIR ST',0,'BEREA','OH','44017','2703','CY','39035','1949-10-03','F','U',':RET:2106-3','N','021','DEN','2331616','99734OH005000401','2014-03-01','2014-01-17 11:02:02','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-20 08:05:38'),(14994,11984,'Y','18','021','EC','A','','','AC','0000581497','0000581497','TX00001825968','IL','1','MELESIO','RAQUEL','','','','34','593098006','1201 BROADMOOR DR',0,'AUSTIN','TX','78723','3173','CY','48453','1981-01-30','F','U',':RET:2106-3','N','021','DEN','1846672','33348TX002000201','2014-02-01','2013-12-30 16:30:53','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-01 12:01:31'),(14175,11301,'Y','18','021','EC','A','','','AC','0000866501','0000866501','TX00001495198','IL','1','Mauldin','Joe','','','','34','467253000','PO box 541',0,'Stinnett','TX','79083',NULL,'CY','48233','1958-09-21','M','M',':RET:2106-3','T','021','DEN','1822845','33348TX002000201','2014-02-01','2013-12-25 23:01:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:03:33'),(4699,3725,'N','19','021','EC','A',NULL,NULL,'','0001162578','0000880496','','IL','1','Hill','James','','','','34','298960631','12648 OLD TROY PIKE',0,'SAINT PARIS','OH','43072','9626','CY','39021','1994-05-13','M','',NULL,'N','021','HLT','236864','92036OH005000505','2014-01-01','2013-12-12 18:14:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2013-12-25 22:08:22'),(2772,2239,'Y','18','021','EC','A','','','AC','0000916971','0000916971','OH00000419224','IL','1','Hicks','Madison','','','','34','270946896','2903 S MAIN ST',0,'AKRON','OH','44319','1848','CY','39153','1991-03-06','F','U',':RET:2106-3','N','021','HLT','1076095','52664OH151001305','2014-01-01','2013-12-02 16:02:15','0.00',NULL,NULL,'223.01','223.01','R-OH012','OH0','223.01',NULL,0,'2013-12-25 19:49:33'),(3635,2909,'Y','18','024','14','A','','','TE','0000133518','0000133518','','IL','1','Jobe','Shemekisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-05-17','F','',NULL,NULL,NULL,'','573917','','2013-12-13','2013-12-13 10:19:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-25 21:30:15'),(3363,2695,'Y','18','021','EC','A','','','AC','0000346353','0000346353','TX00000423672','IL','1','Wallschlaeger','Shannon','','','','34','453893706','6805 WOOD HOLLOW DR',0,'AUSTIN','TX','78731','3254','CY','48453','1983-11-06','F','U',':RET:2106-3','N','021','DEN','1610466','33348TX002000201','2014-01-01','2013-12-22 13:42:09','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:17:02'),(3140,2525,'Y','18','021','EC','A','','','AC','0000798058','0000798058','TX00000761766','IL','1','Evans','Wyendell','','','','34','459980026','107 LAURELFIELD DR',0,'FRIENDSWOOD','TX','77546','4066','CY','48167','1957-11-01','M','M',NULL,'N','021','DEN','489296','33348TX002000201','2014-01-01','2013-11-17 20:26:10','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:30:47'),(20671,16519,'Y','18','021','EC','A','','','AC','0000511779','0000511779','MS00002483235','IL','1','Jackson','Morris','Terrell','','','34','587534563','1401 Highway 16 West',0,'Canton','MS','39046',NULL,'CY','28089','1985-09-10','M','U',':RET:2054-5','T','021','DEN','3684115','46300MS002000201','2014-03-01','2014-01-30 13:29:32','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-30 21:00:49'),(22524,17983,'Y','18','021','EC','A','','','AC','0000433943','0000433943','OH00002618239','IL','1','Waits','Karen','','','','34','276525389','2040 N HOLLOWTOWN RD',0,'LYNCHBURG','OH','45142','9697','CY','39071','1951-07-31','F','M',NULL,'N','021','HLT','3670845','92036OH003000604','2014-03-01','2014-02-10 12:46:11','1079.00',NULL,NULL,'1288.14','209.14','R-OH005','OH0','644.07',NULL,0,'2014-02-10 21:31:27'),(25891,20528,'N','01','021','EC','A',NULL,NULL,'','0000437109','0000796086','','IL','1','ROSZEL','MARY','','','','34','440626341','321 GRANITE BLVD',0,'MARBLE FALLS','TX','78654','9202','CY','48053','1957-12-15','F','',':RET:2106-3','N','021','DEN','3764399','33348TX002000201','2014-04-01','2014-02-26 11:00:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:03'),(27147,21493,'Y','18','021','EC','A','','','AC','0000062589','0000062589','OH00002621539','IL','1','BROWN','SARAH','','','','34','275880124','3833 STERLING DR',0,'FRANKLIN','OH','45005','5027','CY','39165','1981-04-04','F','M',':RET:2106-3','N','021','DEN','3379760','99734OH005000401','2014-04-01','2014-03-03 13:22:57','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:50'),(28072,22216,'Y','18','021','EC','A','','','AC','0000649427','0000649427','OH00002766860','IL','1','BARTON','MARILYN','','','','34','289505672','2380 MADISON RD.',0,'CINCINNATI','OH','45208',NULL,'CY','39061','1951-01-17','F','U',NULL,'N','021','DEN','3970741','99734OH005000301','2014-04-01','2014-03-06 14:03:02','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:51'),(9369,7428,'Y','18','021','EC','A','','','AC','0001563796','0001563796','LA00000010090','IL','1','Smith','Ashley','','','','34','412611740','285 RIDGEWOOD CIR',0,'MANDEVILLE','LA','70471','2725','CY','22103','1987-12-23','F','U',NULL,'N','021','DEN','2351385','18575LA002000201','2014-01-01','2013-12-21 12:40:20','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:31:46'),(15626,12499,'Y','18','021','EC','A','','','AC','0002030421','0002030421','LA00001477591','IL','1','robinson','naicole','','','','34','438696496','3034 OHIO ST',0,'KENNER','LA','70065','4435','CY','22051','1976-03-04','F','U',':RET:2054-5','N','021','DEN','1815773','18575LA002000101','2014-02-01','2013-12-30 20:53:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2014-01-02 04:33:20'),(16066,12867,'Y','18','021','EC','A','','','AC','0001139517','0001139517','OH00000091997','IL','1','PERIN','REBECCA','F','','','34','432693679','246 MONTERAY VALLEY DR',0,'PEEBLES','OH','45660','9323','CY','39001','1982-05-05','F','M',':RET:2106-3','N','021','DEN','1688697','99734OH005000401','2014-02-01','2014-01-03 10:52:52','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-01-04 02:03:41'),(23094,18410,'Y','18','021','EC','A','','','AC','0001255075','0001255075','OH00001958176','IL','1','anderson','michael','','','','34','285669542','2140 WINCHESTER PL',0,'FAIRFIELD','OH','45014','3819','CY','39017','1967-08-08','M','U',NULL,'N','021','DEN','2915074','99734OH005000401','2014-03-01','2014-02-12 13:29:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:08'),(25393,20146,'N','19','021','EC','A',NULL,NULL,'','0000307147','0000604755','','IL','1','Mohr','Brock','','','','34','274150771','5612 Brentwood Avenue NW',0,'North Canton','OH','44720',NULL,'CY','39151','2008-02-01','M','',NULL,'N','021','HLT','3677245','52664OH151001304','2014-04-01','2014-02-25 12:12:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-25 21:30:52'),(25681,20374,'Y','18','021','EC','A','','','AC','0000203136','0000203136','OH00002892544','IL','1','Arthur','Mary','','','','34','290487266','442 Miami St.',0,'Piqua','OH','45356',NULL,'CY','39109','1950-11-16','F','U',NULL,'N','021','HLT','2655468','92036OH004000501','2014-04-01','2014-02-23 18:52:25','560.10',NULL,NULL,'564.22','4.12','R-OH003','OH0','564.22',NULL,0,'2014-02-26 09:30:04'),(27987,22144,'Y','18','021','EC','A','','','AC','0001268810','0001268810','LA00003552887','IL','1','Breaux','Chris','','','','34','436533119','5831 S.40 CT',0,'IOWA','LA','70647',NULL,'CY','22019','1981-10-16','M','M',':RET:2106-3','N','021','DEN','3833214','18575LA002000201','2014-04-01','2014-03-06 17:07:43','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-06 21:01:01'),(7012,5566,'Y','18','021','EC','A','','','AC','0001197688','0001197688','TX00000097254','IL','1','Dural','Myra','','','','34','457197487','4180 Chaison Avenue',0,'Beaumont','TX','77705',NULL,'CY','48245','1970-12-31','F','M',':RET:2054-5','N','021','DEN','1703678','33348TX002000201','2014-01-01','2013-12-24 19:58:46','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2013-12-26 01:48:34'),(6757,5362,'Y','18','021','EC','A','','','AC','0001184856','0001184856','OH00000288233','IL','1','HILL','BRENDA','JOYCE','','','34','270500532','4797 MASSILLON RD.',0,'NORTH CANTON','OH','44720',NULL,'CY','39153','1950-01-11','F','M',':RET:2106-3','N','021','HLT','1087621','52664OH152000901','2014-01-01','2013-11-25 06:56:22','482.18',NULL,NULL,'482.18','0.00','R-OH012','OH0','482.18',NULL,0,'2013-12-26 01:16:16'),(4729,3747,'N','01','021','EC','A',NULL,NULL,'','0000966891','0001096737','','IL','1','Scranton','Richard','','','','34','281540319','5456 HUBER RD',0,'HICKSVILLE','OH','43526','9752','CY','39039','1953-07-22','M','',NULL,'N','021','HLT','836900','92036OH003002606','2014-01-01','2013-12-12 17:04:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','552.66',NULL,0,'2013-12-25 22:09:07'),(20208,16124,'Y','18','024','14','A','','','TE','0000496246','0000496246','','IL','1','durr','christine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-21','F','',NULL,NULL,NULL,'','262576','','2014-01-27','2014-01-27 15:32:54',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-27 21:01:36'),(22479,17946,'N','01','021','EC','A',NULL,NULL,'','0000505768','0000516949','','IL','1','lindhorst','jamie','','','','34','294700741','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','1976-09-10','F','',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:01'),(486,396,'Y','18','021','EC','A','','','AC','0001048122','0001048122','LA00001319562','IL','1','reeves','laurie','','','','34','220869031','363 WHIPPOORWILL RD',0,'DERIDDER','LA','70634','7123','CY','22011','1965-03-20','F','M',':RET:2106-3','N','021','DEN','1198165','18575LA002000201','2014-01-01','2013-12-03 21:07:32','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 17:48:17'),(18643,14862,'Y','18','021','EC','A','','','AC','0000458250','0000458250','TX00001975948','IL','1','Prado','Sonya','','','','34','464833933','3018 S 1ST ST',0,'AUSTIN','TX','78704','6307','CY','48453','1982-08-27','F','U',NULL,'N','021','DEN','2006378','33348TX002000201','2014-03-01','2014-01-16 00:32:59','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-17 03:35:07'),(18235,14555,'Y','18','021','EC','A','','','AC','0000548008','0000548008','TX00001357272','31','1','Criswell','Jimmy','','','','34','627073440','823 Royale',0,'Lufkin','TX','75901',NULL,'CY','48005','1989-04-20','M','U',':RET:2054-5','T','021','DEN','1810017','33348TX002000201','2014-02-01','2014-01-14 23:30:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:21'),(873,722,'Y','18','021','EC','A','','','AC','0000694155','0000694155','OH00001241695','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',':RET:2106-3','N','021','HLT','2192994','92036OH005000506','2014-01-01','2013-12-16 09:53:00','397.00',NULL,NULL,'424.53','27.53','R-OH003','OH0','424.53',NULL,0,'2013-12-25 18:07:29'),(18008,14391,'Y','18','021','EC','A','','','AC','0000733612','0000733612','OH00001698904','IL','1','Tenkotte','Denise','','','','34','285608213','632 CHATEAU DR',0,'CINCINNATI','OH','45244','1317','CY','39025','1963-12-19','F','U',':RET:2106-3','N','021','DEN','1926954','99734OH005000301','2014-02-01','2014-01-14 11:00:45','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-01-15 02:07:02'),(14274,11388,'Y','18','021','EC','A','','','AC','0000174157','0000174157','MS00000091819','IL','1','ROMINES','MELISSA','','','','34','587596265','267 WOODGATE LN',0,'BRANDON','MS','39042','2040','CY','28121','1983-04-28','F','M',':RET:2106-3','N','021','DEN','2355292','46300MS002000201','2014-02-01','2013-12-26 15:28:30','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:10'),(8941,7090,'Y','18','021','EC','A','','','AC','0000479830','0000479830','OH00000773142','IL','1','Breitburg','Ellen','','','','34','275523600','7813 GREENLAND PL',0,'CINCINNATI','OH','45237','1005','CY','39061','1950-12-22','F','U',':RET:2106-3','N','021','DEN','1672281','99734OH005000401','2014-01-01','2013-12-18 10:52:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:20'),(4511,3576,'Y','18','021','EC','A','','','AC','0000324016','0000324016','TX00001260872','IL','1','Lovell','Jeremy','','','','34','454495540','1100 Starling Ct',0,'Burleson','TX','76028',NULL,'CY','48251','1971-03-09','M','M',':RET:2106-3','T','021','DEN','218963','33348TX002000201','2014-01-01','2013-12-12 09:58:11','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:36'),(4619,3658,'Y','18','021','EC','A','','','AC','0000528129','0000528129','LA00000583468','IL','1','Peterson','Ricky','','','','34','433310410','1417 NUNEZ ST',0,'NEW ORLEANS','LA','70114','5824','CY','22071','1976-02-21','M','U',':RET:2054-5','N','021','DEN','728472','18575LA002000101','2014-01-01','2013-12-11 20:15:52','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 22:06:11'),(5209,4135,'Y','18','024','14','A','','','TE','0001125409','0001125409','','IL','1','Stacy','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-05-08','M','',NULL,NULL,NULL,'','705493','','2013-12-19','2013-12-19 15:33:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:04:16'),(20986,16772,'Y','18','021','EC','A','','','AC','0000630413','0000630413','OH00001450513','IL','1','GANTZ','MARGIE','I','','','34','283505398','1604 SYCAMORE ST',0,'CINCINNATI','OH','45202','6523','CY','39061','1950-10-22','F','U',':RET:2106-3','N','021','HLT','2928555','92036OH003001205','2014-03-01','2014-01-31 21:32:24','480.00',NULL,NULL,'661.77','181.77','R-OH004','OH0','661.77',NULL,0,'2014-02-01 19:00:23');
INSERT INTO `EdiParticipant` VALUES (22493,17957,'Y','18','021','EC','A','','','AC','0000929879','0000929879','OH00001689376','IL','1','Besso','Sheri','','','','34','286726041','3356 DARTMOUTH DR',0,'CINCINNATI','OH','45211','6604','CY','39061','1977-02-22','F','U',NULL,'N','021','DEN','3024113','99734OH005000301','2014-03-01','2014-02-10 13:59:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:09'),(24216,19233,'Y','18','021','EC','A','','','AC','0001246737','0001246737','TX00002932256','IL','1','Bhatpuria','Meena','','','','34','631541471','5905 AVERY ISLAND AVE',0,'AUSTIN','TX','78727','6924','CY','48453','1958-12-30','F','M',':RET:2029-7','N','021','DEN','2744502','33348TX002000201','2014-03-01','2014-02-15 20:45:18','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-16 19:00:26'),(26022,20638,'Y','18','021','EC','A','','','AC','0000418089','0000418089','TX00002186587','IL','1','RHODES','JERRY','D','','','34','463450885','540 COUNTY ROAD 42000',0,'PARIS','TX','75460','0813','CY','48277','1964-06-09','M','M',':RET:2106-3','N','021','DEN','3149436','33348TX002000101','2014-04-01','2014-02-26 13:31:18','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-26 21:02:16'),(26966,21364,'N','01','021','EC','A',NULL,NULL,'','0000261557','0000447539','','IL','1','RILEY','LAURIE','','','','34','301562786','2513 VICTORIA PKWY',0,'HUDSON','OH','44236','3122','CY','39153','1955-03-09','F','',':RET:2106-3','N','021','HLT','3677421','52664OH151001305','2014-04-01','2014-03-02 15:45:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2014-03-03 01:00:32'),(13753,10977,'Y','18','021','EC','A','','','AC','0000639452','0000639452','MS00000833900','IL','1','Kelly','Angela','','','','34','426490645','100 Trelles Cove',0,'Byram','MS','39272',NULL,'CY','28049','1983-12-16','F','U',':RET:2054-5','N','021','DEN','2064256','46300MS002000201','2014-01-01','2013-12-22 19:55:42','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:09:59'),(13533,10789,'Y','18','021','EC','A','','','AC','0001660856','0001660856','LA00000401249','IL','1','PERRY','KENYARDA','','','','34','436258935','112 VIDA ST',0,'MANSFIELD','LA','71052','3308','CY','22031','1975-11-14','F','U',':RET:2054-5','N','021','DEN','2165693','18575LA002000201','2014-01-01','2013-12-23 12:11:32','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:03:31'),(16227,12995,'N','19','021','EC','A',NULL,NULL,'','0000864838','0001235193','','IL','1','JONES','TYLER','','','','34','287960552','372 NUTT RD',0,'DAYTON','OH','45458','9690','CY','39113','1993-09-14','M','',NULL,'N','021','DEN','2385356','99734OH005000401','2014-02-01','2014-01-04 16:10:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:01:57'),(14370,11461,'Y','18','021','EC','A','','','AC','0000888180','0000888180','OH00001047560','IL','1','Sweazy','Julia','','','','34','270542075','6515 ALSPACH RD NW',0,'LANCASTER','OH','43130','8246','CY','39045','1954-04-10','F','M',':RET:2106-3','N','021','DEN','2220705','99734OH005000401','2014-02-01','2013-12-27 10:15:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:30:30'),(19518,15558,'Y','18','021','EC','A','','','AC','0001037384','0001037384','OH00001978891','IL','1','Scott','Eric','','','','34','283806382','142 BRIARCLIFF AVE',0,'ALLIANCE','OH','44601','2112','CY','39151','1982-06-15','M','U',':RET:2106-3','N','021','DEN','2804688','99734OH005000401','2014-03-01','2014-01-22 09:11:53','0.00',NULL,NULL,'50.05','50.05','R-OH015','OH0','0.00',NULL,0,'2014-01-23 03:02:17'),(18661,14877,'Y','18','021','EC','A','','','AC','0001097877','0001097877','TX00001542048','IL','1','TRAN','LINH','','','','34','631955094','2702 PARK RIDGE DR',0,'MARBLE FALLS','TX','78654','4030','CY','48053','1982-06-10','F','M',':RET:2047-9','N','021','DEN','1673360','33348TX002000201','2014-03-01','2014-01-16 14:55:26','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:14'),(6498,5148,'Y','18','021','EC','A','','','AC','0000830606','0000830606','OH00000859347','IL','1','PRESTAS','TERRY','L','','','34','268606757','6020 WHISPERING MDWS',0,'CANFIELD','OH','44406','9694','CY','39099','1957-10-22','F','M',':RET:2106-3','N','021','HLT','1110496','52664OH151001304','2014-01-01','2013-12-11 15:17:03','351.00',NULL,NULL,'590.00','239.00','R-OH013','OH0','590.00',NULL,0,'2013-12-26 00:50:45'),(17143,13718,'N','19','021','EC','A',NULL,NULL,'','0001278407','0002182357','','IL','1','fairley','kristin','n','','','34','439839992','1825 SQUIRE CT',0,'MARRERO','LA','70072','6723','CY','22051','1992-04-03','F','',':RET:2054-5','N','021','DEN','2139093','18575LA002000201','2014-02-01','2014-01-07 19:24:20',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-13 02:21:53'),(21005,16784,'Y','18','021','EC','A','','','AC','0001587670','0001587670','LA00002058880','IL','1','Kenard','Robert','','','','34','336466444','4535 LONGFELLOW DR',0,'NEW ORLEANS','LA','70127','4105','CY','22071','1950-07-02','M','U',NULL,'N','021','DEN','3241658','18575LA002000101','2014-03-01','2014-02-01 14:00:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-01 19:00:31'),(26428,20961,'Y','18','021','EC','A','','','AC','0000219886','0000219886','TX00002728017','31','1','WILSON','RICHARD','','','','34','451047173','PO Box 233',0,'Rio Vista','TX','76093',NULL,'CY','48217','1955-03-11','M','U',':RET:2106-3','T','021','DEN','3669823','33348TX002000201','2014-03-01','2014-02-27 16:16:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-28 07:30:14'),(26812,21247,'Y','18','021','EC','A','','','AC','0000327329','0000327329','OH00002624183','IL','1','flanagan','patricia','','','','34','558330427','14131 s river rd',0,'grand rapids','OH','43522',NULL,'CY','39095','1965-02-14','F','U',':RET:2106-3','N','021','HLT','3237461','92036OH006002601','2014-04-01','2014-03-01 00:42:44','180.00',NULL,NULL,'263.83','83.83','R-OH001','OH0','263.83',NULL,0,'2014-03-01 21:00:29'),(26885,21308,'Y','18','021','EC','A','','','AC','0000578835','0000578835','OH00002439285','IL','1','Loizou','Patricia','','','','34','290523318','1830 CHRISTIAN AVE',0,'TOLEDO','OH','43613','2904','CY','39095','1953-04-03','F','M',':RET:2106-3','N','021','HLT','3514238','92036OH004002601','2014-04-01','2014-03-01 16:34:45','259.00',NULL,NULL,'425.53','166.53','R-OH001','OH0','425.53',NULL,0,'2014-03-01 21:01:12'),(28070,22214,'Y','18','021','EC','A','','','AC','0000832060','0000832060','OH00002878930','IL','1','Robison','Sloane','','','','34','291940103','5626 St Rt 88',0,'Kinsman','OH','44428',NULL,'CY','39155','1992-02-14','F','U',':RET:2106-3','T','021','DEN','3908575','99734OH005000301','2014-04-01','2014-03-06 13:22:00','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-03-06 21:01:49'),(95,84,'Y','18','021','EC','A','','','AC','0001159506','0001159506','TX00000605951','IL','1','McEowen','Janet','','','','34','461923260','6336 ANNAPOLIS LN',0,'DALLAS','TX','75214','2105','CY','48113','1949-09-28','F','M',':RET:2106-3','N','021','DEN','337148','33348TX002000201','2014-01-01','2013-12-05 07:38:14','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 17:17:33'),(8926,7077,'Y','18','021','EC','A','','','AC','0001233040','0001233040','OH00000055121','IL','1','VINCENT','KATHLEEN','MARIE','','','34','278785838','815 S CHESTERFIELD RD',0,'COLUMBUS','OH','43209','2631','CY','39049','1965-12-01','F','M',':RET:2106-3','N','021','DEN','1366440','99734OH005000401','2014-01-01','2013-12-18 09:22:25','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:55'),(18491,14748,'N','01','021','EC','A',NULL,NULL,'','0000399906','0000599770','','IL','1','Weisel','Tamara','Jean','','','34','276684698','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1975-05-28','F','',':RET:2106-3','N','021','HLT','2092959','52664OH151001306','2014-02-01','2014-01-15 14:58:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2014-01-16 08:46:25'),(17852,14261,'Y','18','021','EC','A','','','AC','0001053076','0001053076','OH00001905313','IL','1','Moran','Matthew','','','','34','268844447','3877 W 137TH ST',0,'CLEVELAND','OH','44111','4446','CY','39035','1974-04-08','M','R',':RET:2106-3','N','021','DEN','1830477','99734OH005000401','2014-02-01','2014-01-14 10:36:45','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:07'),(19858,15839,'Y','18','024','14','A','','','TE','0000481029','0000481029','','IL','1','Haas','Susan','J',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-11-05','F','',NULL,NULL,NULL,'','42112','','2014-01-24','2014-01-24 17:27:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:00:34'),(1017,833,'Y','18','021','EC','A','','','AC','0000894539','0000894539','MS00000898214','IL','1','Clay','David','','','','34','587673037','30 N HILL PKWY',0,'JACKSON','MS','39206','5595','CY','28049','1989-12-01','M','U',':RET:2054-5','N','021','DEN','17613','46300MS002000201','2014-01-01','2013-12-03 13:43:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:15:09'),(15910,12741,'Y','18','021','EC','A','','','AC','0000177902','0000177902','TX00001480211','IL','1','Alvarado','Anna','','','','34','459231175','2718 WILSON ST',0,'AUSTIN','TX','78704','5441','CY','48453','1958-08-24','F','U',NULL,'N','021','DEN','2164599','33348TX002000101','2014-02-01','2014-01-02 14:48:11','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-03 02:06:21'),(15798,12645,'Y','18','021','EC','A','','','AC','0001198458','0001198458','LA00000830147','IL','1','wilson','theronyln','','','','34','436853826','2420 commerical',0,'port allen','LA','70767',NULL,'CY','22121','1992-09-11','F','U',':RET:2054-5','N','021','DEN','2364971','18575LA002000201','2014-02-01','2014-01-02 00:34:17','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:02:45'),(5784,4595,'Y','18','024','14','A','','','TE','0000645975','0000645975','','IL','1','Eck','Kyle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-09-02','M','',NULL,NULL,NULL,'','1492383','','2013-12-23','2013-12-23 23:45:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:47:08'),(6608,5240,'N','19','021','EC','A',NULL,NULL,'','0000380027','0000943404','','IL','1','Clark','Katlin','J',NULL,NULL,NULL,NULL,'9217 PITSBURG LAURA RD',0,'ARCANUM','OH','45304','9627','CY','39037','1992-03-25','M','',':RET:2106-3','N','021','HLT','677107','92036OH003000501','2014-01-01','2013-12-11 10:33:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','248.23',NULL,0,'2013-12-26 00:53:42'),(13386,10685,'N','01','021','EC','A',NULL,NULL,'','0000108148','0001244163','','IL','1','Spehar','Michelle','','','','34','300585741','780 WINSTON CIR',0,'MEDINA','OH','44256','7195','CY','39103','1960-04-16','F','',':RET:2106-3','N','021','DEN','1660505','99734OH005000301','2014-01-01','2013-12-23 01:17:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:01'),(1908,1560,'Y','18','021','EC','A','','','AC','0000639533','0000639533','OH00001646151','31','1','Bassett','Michael','','','','34','280768416','62 Grande Lake Drive',0,'Port Clinton','OH','43452',NULL,'CY','39123','1979-12-25','M','U',NULL,'N','021','HLT','2127226','92036OH003002701','2014-01-01','2013-12-24 16:10:38','0.00',NULL,NULL,'247.21','247.21','R-OH006','OH0','247.21',NULL,0,'2013-12-25 18:59:20'),(1944,1584,'Y','18','021','EC','A','','','AC','0000767371','0000767371','OH00000360312','IL','1','Dougherty','Patrick','','','','34','287561203','21 E.Court St.',0,'Cincinnati','OH','45202',NULL,'CY','39061','1956-04-23','M','U',':RET:2106-3','N','021','DEN','985947','99734OH005000401','2014-01-01','2013-11-20 02:29:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:00:46'),(9606,7607,'N','01','021','EC','A',NULL,NULL,'','0000502980','0000338875','','IL','1','Wilde','Therese','','','','34','275567107','10956 AMBLER LN',0,'MANTUA','OH','44255','9224','CY','39133','1954-02-28','F','',':RET:2106-3','N','021','HLT','2012957','52664OH151001306','2014-01-01','2013-12-21 13:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-26 04:37:31'),(22277,17782,'Y','18','021','EC','A','','','AC','0000275200','0000275200','TX00002512520','IL','1','Fuller','Jordan','','','','34','463911419','1502 AZALEA DR',0,'LUFKIN','TX','75904','5334','CY','48005','1987-07-10','F','M',':RET:2106-3','N','021','DEN','2089136','33348TX002000201','2014-03-01','2014-01-20 17:34:33','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:18'),(22880,18247,'Y','18','021','EC','A','','','AC','0001004383','0001004383','OH00002542955','IL','1','Nguyen','Dung','','','','34','556897866','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1968-10-04','F','U',NULL,'N','021','HLT','3544978','52664OH151001501','2014-03-01','2014-02-11 11:31:17','607.00',NULL,NULL,'1261.91','654.91','R-OH012','OH0','386.22',NULL,0,'2014-02-11 21:02:33'),(26696,21164,'Y','18','021','EC','A','','','AC','0001666341','0001666341','LA00003138396','IL','1','Moffett','Cheree','','','','34','443882352','5970 HIGHWAY 6',0,'NATCHITOCHES','LA','71457','7104','CY','22069','1976-06-29','F','M',':RET:1002-5^:RET:2054-5','N','021','DEN','3210854','18575LA002000101','2014-04-01','2014-02-28 14:21:00','0.00',NULL,NULL,'50.04','50.04','R-LA008','LA0','25.02',NULL,0,'2014-02-28 21:31:31'),(28245,22349,'Y','18','021','EC','A','','','AC','0000947441','0000947441','OH00002914555','IL','1','GARZA','EMILY','','','','34','280843026','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-04-26','F','M',':RET:2106-3','T','021','DEN','3294622','99734OH005000401','2014-04-01','2014-03-07 12:47:08','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00','CIC',0,'2014-03-07 21:00:11'),(1412,1174,'Y','18','021','EC','A','','','AC','0001415026','0001415026','LA00000481672','IL','1','mayfield','william','','','','34','439513011','8717 SAINT VINCENT AVE',0,'SHREVEPORT','LA','71106','5556','CY','22017','1968-11-22','M','U',':RET:2054-5','N','021','DEN','2607043','18575LA002000201','2014-01-01','2013-12-24 13:39:43','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 18:46:58'),(20951,16742,'Y','18','021','EC','A','','','AC','0001142532','0001142532','TX00002236636','IL','1','OWENS','DANGEL','','','','34','467850163','30950 LAZY RIDGE ROAD',0,'WALLER','TX','77484',NULL,'CY','48473','1973-09-04','F','U',':RET:2106-3','T','021','DEN','3106026','33348TX002000201','2014-03-01','2014-01-31 19:03:39','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-01 19:00:04'),(4307,3424,'N','19','021','EC','A',NULL,NULL,'','0000093834','0000571980','','IL','1','davis','jonathan','c','','','34','298045358','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','2000-05-17','M','',':RET:2106-3','N','021','HLT','2284060','92036OH004001201','2014-01-01','2013-12-17 05:52:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 21:52:30'),(20385,16285,'Y','18','021','EC','A','','','AC','0000935441','0000935441','TX00002417705','IL','1','THORNTON','RONALD','','','','34','455739803','3828 W 7TH ST',0,'FORTH WORTH','TX','76107',NULL,'CY','48439','1984-06-09','M','U',':RET:2106-3','N','021','DEN','3470310','33348TX002000201','2014-03-01','2014-01-29 00:09:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:13'),(6770,5372,'Y','18','021','EC','A','','','AC','0000425330','0000425330','LA00000608589','IL','1','ELZY','CAROLYN','A','','','34','437967601','4848 WINDSOR VILLAGE DRIVE',0,'BATON ROUGE','LA','70817',NULL,'CY','22033','1955-06-28','F','U',NULL,'N','021','DEN','1082304','18575LA002000201','2014-01-01','2013-11-25 16:57:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:16:36'),(21082,16847,'Y','18','021','EC','A','','','AC','0000394963','0000394963','OH00001442388','IL','1','Klaas','Daniel','','','','34','170581136','301 E Columbus St',0,'West Liberty','OH','43357',NULL,'CY','39091','1959-03-25','M','M',':RET:2106-3','N','021','DEN','3403388','99734OH005000301','2014-03-01','2014-02-02 00:09:35','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-02-02 19:00:22'),(21586,17243,'Y','18','021','EC','A','','','AC','0000833445','0000833445','OH00001530433','IL','1','kennedy','robert','','','','34','281800588','61525 vocational rd',0,'cambridge','OH','43725',NULL,'CY','39059','1973-08-16','M','M',':RET:2106-3','N','021','DEN','3199975','99734OH005000301','2014-03-01','2014-02-04 19:26:30','0.00',NULL,NULL,'87.78','87.78','R-OH016','OH0','0.00',NULL,0,'2014-02-05 21:30:27'),(5795,4603,'Y','18','024','14','A','','','TE','0000209634','0000209634','','IL','1','Lange','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-02','F','',NULL,NULL,NULL,'','1464897','','2013-12-24','2013-12-24 01:42:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:47:22'),(1577,1316,'Y','18','021','EC','A','','','AC','0001075430','0001075430','TX00000818456','IL','1','Brown','Cornelius','','','','34','645053771','1919 34TH ST',0,'LUBBOCK','TX','79411','1859','CY','48303','1989-02-17','M','U',':RET:2054-5','N','021','DEN','2263749','33348TX002000201','2014-01-01','2013-12-24 10:28:33','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:51:20'),(1732,1440,'N','19','021','EC','A',NULL,NULL,'','0000809681','0000246449','','IL','1','Funkhouser','Nicholas','','','','34','272069911','401 Bell Ave',0,'Sandusky','OH','44870',NULL,'CY','39043','2000-11-22','M','',':RET:2106-3','N','021','DEN','2527329','99734OH005000301','2014-01-01','2013-12-24 10:59:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:24'),(20519,16395,'Y','18','024','14','A','','','TE','0000540730','0000540730','','IL','1','Steinbach','Vicki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-12-14','F','',NULL,NULL,NULL,'','1032087','','2014-01-29','2014-01-29 13:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-29 21:01:24'),(2270,1854,'Y','18','021','EC','A','','','AC','0000244957','0000244957','OH00000784530','IL','1','Cramer','Kevin','Robert','','','34','288740448','13262 Co Rd 43',0,'Antwerp','OH','45813',NULL,'CY','39125','1965-04-01','M','U',':RET:2106-3','T','021','DEN','636839','99734OH005000301','2014-01-01','2013-12-09 10:03:13','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 19:30:21'),(4730,3748,'Y','18','021','EC','A','','','AC','0000234028','0000234028','OH00001130940','IL','1','Warner','Tammie','','','','34','270702525','152 and Half Larkins St.',0,'Findlay','OH','45840',NULL,'CY','39063','1961-06-19','F','M',':RET:2106-3','T','021','HLT','1140567','92036OH003001501','2014-01-01','2013-12-12 14:00:56','143.00',NULL,NULL,'515.93','372.93','R-OH002','OH0','515.93',NULL,0,'2013-12-25 22:09:08'),(16122,12914,'Y','18','021','EC','A','','','AC','0001571176','0001571176','LA00001749682','IL','1','Davis','Tracie','L','','','34','438599139','2610 Gravier St',0,'New Orleans','LA','70119',NULL,'CY','22071','1985-04-04','F','U',NULL,'N','021','DEN','2405419','18575LA002000101','2014-02-01','2014-01-03 14:18:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-04 02:05:26'),(2740,2218,'Y','18','021','EC','A','','','AC','0000058726','0000058726','OH00001007576','IL','1','Nofsinger','James','','','','34','283484544','7066 CLEVELAND MASSILLON RD',0,'CLINTON','OH','44216','9700','CY','39153','1950-11-25','M','U',':RET:2106-3','N','021','HLT','4894','52664OH152000901','2014-01-01','2013-12-01 20:48:14','309.00',NULL,NULL,'482.18','173.18','R-OH012','OH0','482.18',NULL,0,'2013-12-25 19:48:46'),(2775,2242,'Y','18','021','EC','A','','','AC','0000220345','0000220345','MS00001084805','IL','1','Northrop','Donna','','','','34','437901591','709 PINEVIEW DR',0,'HATTIESBURG','MS','39401','7439','CY','28035','1953-02-16','F','M',':RET:2106-3','N','021','DEN','93312','46300MS002000201','2014-01-01','2013-12-02 13:09:56','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 19:49:39'),(14770,11793,'Y','18','024','14','A','','','TE','0000909825','0000909825','','IL','1','Pruitt','Elbert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1968-12-30','M','',NULL,NULL,NULL,'','1446693','','2013-12-23','2013-12-23 19:37:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2013-12-29 11:12:55'),(21640,17280,'Y','18','021','EC','A','','','AC','0000607862','0000607862','TX00001910355','IL','1','Roth','Sharlo','','','','34','545877808','1203 East Hwy 31',0,'Longview','TX','75604',NULL,'CY','48183','1985-06-14','F','U',':RET:2106-3','N','021','DEN','3291229','33348TX002000201','2014-03-01','2014-02-05 14:51:22','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-02-05 21:30:45'),(23305,18579,'N','01','021','EC','A',NULL,NULL,'','0000011201','0000904306','','IL','1','Gordon','Christina','M','','','34','278769971','4249 N GILWOOD DR',0,'STOW','OH','44224','2717','CY','39153','1980-04-15','F','',':RET:2106-3','N','021','DEN','3138552','99734OH005000301','2014-03-01','2014-02-13 10:11:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:17'),(24617,19538,'Y','18','021','EC','A','','','AC','0001239785','0001239785','MS00002725558','31','1','BROWN','WALTER','','','','34','587562965','P. O. BX 94',0,'CHARLESTON','MS','38921',NULL,'CY','28135','1953-01-06','M','U',':RET:2054-5','N','021','DEN','3138700','46300MS002000201','2014-04-01','2014-02-19 11:48:08','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-20 04:15:18'),(898,745,'Y','18','021','EC','A','','','AC','0000679517','0000679517','OH00000037220','IL','1','Herring','Cynthia','','','','34','401867665','12612 Christiansburg Jackson Road',0,'Saint Paris','OH','43072',NULL,'CY','39021','1957-10-06','F','M',':RET:2106-3','N','021','HLT','1701626','92036OH003000501','2014-01-01','2013-12-16 12:52:23','511.00',NULL,NULL,'579.13','68.13','R-OH003','OH0','579.13',NULL,0,'2013-12-25 18:08:11'),(20946,16738,'Y','18','024','14','A','','','TE','0000155783','0000155783','','IL','1','Kopp','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-05','F','',NULL,NULL,NULL,'','2260352','','2014-01-31','2014-01-31 16:36:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:01:45'),(20466,16349,'N','19','021','EC','A',NULL,NULL,'','0000558181','0000586727','','S3','1','Berlean','Kellie','','','','34','278178120','7405 REFUGEE RD',0,'PICKERINGTON','OH','43147','9101','CY','39045','2011-06-16','F','',':RET:2106-3','N','021','DEN','3169905','99734OH005000401','2014-03-01','2014-01-29 11:46:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:53'),(7410,5864,'Y','18','021','EC','A','','','AC','0000234149','0000234149','TX00000614543','IL','1','SMITH','TERRI','','','','34','457431305','1401 AVENUE J',0,'LUBBOCK','TX','79401','4023','CY','48303','1965-01-28','F','U',':RET:2106-3','T','021','DEN','6236','33348TX002000201','2014-01-01','2013-10-28 17:08:45','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 02:16:42'),(18775,14956,'N','19','021','EC','A',NULL,NULL,'','0000794535','0000521970','','IL','1','swope','alexzander','','','','34','285085627','13391 WARDLOW RD',0,'SARDINIA','OH','45171','9706','CY','39015','2003-08-17','M','',':RET:2106-3','N','021','HLT','2984581','92036OH004000601','2014-02-01','2014-01-15 18:35:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-17 03:35:51'),(14055,11198,'N','01','021','EC','A',NULL,NULL,'','0001086792','0000051921','','IL','1','DEMITRY','JOHN','','','','34','339960332','1019 SCOTT ST',0,'MAUMEE','OH','43537','3141','CY','39095','1977-06-01','M','',NULL,'T','021','DEN','2181066','99734OH005000301','2014-02-01','2013-12-26 15:53:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:00:24'),(22121,17657,'N','01','021','EC','A',NULL,NULL,'','0000265284','0001139539','','IL','1','Clos','Jennifer','M','','','34','293740296','5864 Morris Rd.',0,'Springfield','OH','45502',NULL,'CY','39023','1979-03-01','F','',':RET:2106-3','N','021','HLT','3228264','92036OH004000501','2014-03-01','2014-02-08 11:17:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.56',NULL,0,'2014-02-08 19:00:40'),(22945,18293,'Y','18','021','EC','A','','','AC','0000012419','0000012419','OH00002466634','IL','1','CHELLATH','SEEMA','','','','34','616737041','5758 HAWTHORNE RESERVES DR',0,'LIBERTY TOWNSHIP','OH','45044','8888','CY','39017','1974-04-24','F','M',NULL,'N','021','DEN','3647500','99734OH005000401','2014-03-01','2014-02-11 15:21:41','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-11 21:30:22'),(23251,18536,'Y','18','021','EC','A','','','AC','0000574421','0000574421','OH00002398097','IL','1','BEVLY','CHARLOTTE','','','','34','298485031','461 GYPSY LN',0,'YOUNGSTOWN','OH','44504','1344','CY','39099','1950-06-23','F','U',':RET:2054-5','N','021','DEN','3477045','99734OH005000401','2014-03-01','2014-02-13 10:41:36','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00','CIC',0,'2014-02-13 21:30:05'),(14069,11211,'Y','18','021','EC','A','','','AC','0000136084','0000136084','OH00000335019','IL','1','Marshall','Willie','M','','','34','273481484','3419 Monticello Blvd',0,'Cleveland Height','OH','44121',NULL,'CY','39035','1949-07-15','F','M',':RET:2054-5','N','021','DEN','2110971','99734OH005000401','2014-02-01','2013-12-26 09:33:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:00:47'),(18443,14714,'N','01','021','EC','A',NULL,NULL,'','0001670263','0001835980','','IL','1','Phan','Kim','','','','34','733140773','2608 HIGHLAND RD',0,'BATON ROUGE','LA','70802','7338','CY','22033','1985-06-27','F','',NULL,'N','021','DEN','2144223','18575LA002000201','2014-02-01','2014-01-15 17:25:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:46:04'),(2477,2017,'Y','18','021','EC','A','','','AC','0000049603','0000049603','LA00000046440','IL','1','PIXLEY DOMINIC','NANCY','','','','34','433533643','2314 MADRID ST',0,'NEW ORLEANS','LA','70122','5514','CY','22071','1969-10-23','F','M',':RET:2054-5','N','021','DEN','376169','18575LA002000201','2014-01-01','2013-12-09 13:26:18','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:24'),(2569,2087,'Y','18','021','EC','A','','','AC','0000086397','0000086397','OH00000970752','IL','1','Koller','Teri','','','','34','299589332','5731 BLESSING DR',0,'TOLEDO','OH','43612','3911','CY','39095','1958-03-13','F','U',':RET:2106-3','N','021','HLT','1139373','92036OH002002601','2014-01-01','2013-12-09 14:04:38','277.00',NULL,NULL,'502.17','225.17','R-OH001','OH0','502.17',NULL,0,'2013-12-25 19:37:37'),(7440,5888,'Y','18','021','EC','A','','','AC','0000479824','0000479824','OH00000156676','IL','1','Dudek','Raymond','A','','','34','288581737','1096 CROWN AVE',0,'RAVENNA','OH','44266','2614','CY','39133','1954-08-12','M','U',':RET:2106-3','N','021','HLT','658882','52664OH151001305','2014-01-01','2013-12-15 17:06:17','448.00',NULL,NULL,'580.49','132.49','R-OH012','OH0','580.49',NULL,0,'2013-12-26 02:30:23'),(21350,17063,'Y','18','021','EC','A','','','AC','0000056901','0000056901','TX00001522077','IL','1','MCKINNEY','THOMAS','LEE','','','34','459952869','1204  S MERRILL STREET',0,'NEW BOSTON','TX','75507',NULL,'CY','48037','1973-10-01','M','U',NULL,'T','021','DEN','2658552','33348TX002000201','2014-03-01','2014-02-04 09:46:07','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-04 21:00:37'),(21898,17487,'Y','18','021','EC','A','','','AC','0001045733','0001045733','OH00002537886','31','1','Cacioppo','Sherrie',NULL,NULL,NULL,NULL,NULL,'13660 Inverness Ave.',0,'Uniontown','OH','44685',NULL,'CY','39153','1954-08-05','F','U',':RET:2106-3','T','021','HLT','3445558','52664OH151001501','2014-03-01','2014-02-06 14:00:20','490.00',NULL,NULL,'800.64','310.64','R-OH012','OH0','800.64',NULL,0,'2014-02-06 21:01:45'),(22886,18249,'Y','18','021','EC','A','','','AC','0000401282','0000401282','OH00002540398','IL','1','Bray','Patti','','','','34','385668854','2275 ORCHARD HILLS BLVD',0,'TOLEDO','OH','43615','2638','CY','39095','1974-08-28','F','M',':RET:2106-3','N','021','HLT','3603202','92036OH003002604','2014-03-01','2014-02-11 10:03:16','574.00',NULL,NULL,'1008.59','434.59','R-OH001','OH0','256.98',NULL,0,'2014-02-11 21:02:35'),(26036,20649,'Y','18','021','EC','A','','','AC','0001207207','0001207207','OH00001646142','IL','1','Zornes','Sharon','','','','34','288543094','1211 WOODS DR',0,'TALLMADGE','OH','44278','3357','CY','39153','1953-10-04','F','M',':RET:2106-3','N','021','HLT','3552850','52664OH151001304','2014-04-01','2014-02-26 11:03:45','373.00',NULL,NULL,'605.24','232.24','R-OH012','OH0','605.24',NULL,0,'2014-02-26 21:02:24'),(26135,20725,'N','19','021','EC','A',NULL,NULL,'','0001204586','0000115550','','S1','1','HABLI','FIRAS','','','','34','269130210','2057 DECKER CT',0,'COLUMBUS','OH','43235',NULL,'CY','39049','2006-08-28','F','',':RET:2106-3','N','021','DEN','3501190','99734OH005000401','2014-03-01','2014-02-27 12:27:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:24'),(26217,20792,'N','01','021','EC','A',NULL,NULL,'','0000043275','0000359744','','IL','1','ULM','DARRELL','','','','34','275766148','533 ROCKWELL ST',0,'KENT','OH','44240','2245','CY','39133','1967-08-07','M','',NULL,'N','021','HLT','3728246','52664OH151001305','2014-04-01','2014-02-27 17:20:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','334.51',NULL,0,'2014-02-28 06:30:55'),(26465,20992,'Y','18','021','EC','A','','','AC','0000289580','0000289580','OH00003389624','IL','1','givens','jack','','','','34','278543243','25 frederick ave',0,'akron','OH','44310',NULL,'CY','39153','1952-04-07','M','U',':RET:2106-3','N','021','HLT','3752101','52664OH151001304','2014-04-01','2014-02-27 14:33:33','420.00',NULL,NULL,'626.65','206.65','R-OH012','OH0','626.65','CIC',0,'2014-02-28 07:30:33'),(26682,21153,'Y','18','021','EC','A','','','AC','0001310130','0001310130','LA00002971345','IL','1','Ly','Hang','Minh','','','34','661055039','12492 LORNA AVE',0,'BATON ROUGE','LA','70815','2686','CY','22033','1964-01-17','F','U',':RET:2047-9','N','021','DEN','3575607','18575LA002000201','2014-04-01','2014-02-28 13:48:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 21:31:23'),(28505,22557,'Y','18','021','EC','A','','','AC','0001196877','0001196877','OH00003765800','IL','1','Lindsay','Carol','','','','34','297428298','2280 COVINGTON RD',0,'AKRON','OH','44313','4302','CY','39153','1950-03-05','F','M',NULL,'N','021','HLT','3400764','52664OH151001305','2014-04-01','2014-03-07 10:56:56','459.00',NULL,NULL,'669.00','210.00','R-OH012','OH0','669.00',NULL,0,'2014-03-07 21:31:51'),(14349,11444,'N','19','021','EC','A',NULL,NULL,'','0000514453','0000530695','','IL','1','Chen','Devin',NULL,NULL,NULL,NULL,NULL,'1079 STREAM RIDGE LN',0,'CINCINNATI','OH','45255','4323','CY','39061','1995-10-22','M','',':RET:2034-7','N','021','HLT','1945675','92036OH006001201','2014-02-01','2013-12-26 17:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-27 02:08:04'),(17640,14100,'N','01','021','EC','A',NULL,NULL,'','0000997774','0000650797','','IL','1','Mullin','Jennifer','','','','34','293582315','450 E CENTER ST',0,'GERMANTOWN','OH','45327','1449','CY','39113','1956-02-14','F','',':RET:2106-3','N','021','DEN','2452146','99734OH005000301','2014-02-01','2014-01-12 23:49:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:36'),(1526,1271,'N','01','021','EC','A',NULL,NULL,'','0000569316','0000148340','','IL','1','Sun','Sherry','Xiaoli','','','34','273941108','6310 COPPERLEAF LN',0,'CINCINNATI','OH','45230','1497','CY','39061','1955-01-08','F','',':RET:2034-7','N','021','DEN','2100165','99734OH005000401','2014-01-01','2013-12-24 15:21:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:53'),(3215,2586,'Y','18','021','EC','A','','','AC','0000242669','0000242669','OH00000431259','IL','1','Ody','Anne','','','','34','374507345','3282 VAN BUREN DR',0,'BRUNSWICK','OH','44212','3771','CY','39103','1949-05-24','F','M',':RET:2106-3','N','021','HLT','207078','52664OH151001301','2014-01-01','2013-11-01 14:00:59','429.00',NULL,NULL,'669.00','240.00','R-OH012','OH0','669.00',NULL,0,'2013-12-25 20:45:32'),(13656,10895,'Y','18','021','EC','A','','','AC','0001803386','0001803386','LA00000297860','IL','1','abdalla','abdalla','','','','34','439972054','3030 congress blvd',0,'baton rouge','LA','70808',NULL,'CY','22033','1960-07-16','M','U',NULL,'N','021','DEN','2306623','18575LA002000101','2014-01-01','2013-12-23 00:37:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 13:07:28'),(4036,3223,'Y','18','021','EC','A','','','AC','0000168871','0000168871','OH00000383871','31','1','Pennock','Debra','','','','34','292569907','P.O. Box 489',0,'Beverly','OH','45715',NULL,'CY','39167','1955-02-24','F','U',':RET:2106-3','T','021','DEN','1759983','99734OH005000401','2014-01-01','2013-12-17 11:11:18','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:46:01'),(21339,17054,'Y','18','021','EC','A','','','AC','0000778219','0000778219','TX00001790192','IL','1','Jaquez','Jose','','','','34','629907200','1572 W BOURNE',0,'CLINT','TX','79836','5204','CY','48141','1972-07-03','M','U',NULL,'N','021','DEN','3683065','33348TX002000201','2014-03-01','2014-02-03 20:38:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-04 21:00:32'),(23732,18895,'Y','18','021','EC','A','','','AC','0000357237','0000357237','OH00001413995','IL','1','Rodriguez','Susan','','','','34','270588746','3993 CLAGUE RD',0,'NORTH OLMSTED','OH','44070','2306','CY','39035','1954-12-25','F','M',':RET:2106-3','N','021','DEN','2750807','99734OH005000301','2014-03-01','2014-02-13 18:48:40','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:30:58'),(24845,19697,'Y','18','021','EC','A','','','AC','0001117302','0001117302','OH00002473130','IL','1','KOMYATI','ANTOINETTE','M','','','34','287642324','1939 GLENWOOD DR',0,'TWINSBURG','OH','44087','1256','CY','39153','1956-11-16','F','M',':RET:2106-3','T','021','HLT','3022046','52664OH152000901','2014-04-01','2014-02-19 11:36:03','165.00',NULL,NULL,'457.77','292.77','R-OH012','OH0','457.77',NULL,0,'2014-02-20 04:54:16'),(24934,19772,'Y','18','021','EC','A','','','AC','0000795015','0000795015','TX00001903534','IL','1','Estes','Linda','','','','34','338461157','250 BRETTONWOOD DR',0,'SAN ANTONIO','TX','78218','4255','CY','48029','1951-07-02','F','U',':RET:2106-3','N','021','DEN','3100735','33348TX002000101','2014-04-01','2014-02-20 16:47:02','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02','CIC',0,'2014-02-20 21:30:21'),(26416,20950,'Y','18','024','14','A','','','TE','0000834324','0000834324','','IL','1','Robertson','Demetra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-01-17','F','',NULL,NULL,NULL,'','3532013','','2014-03-31','2014-02-26 18:34:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-28 07:30:04'),(1275,1053,'Y','18','021','EC','A','','','AC','0000247857','0000247857','OH00000321498','IL','1','Brintnell','John','Richard','','Sr','34','373940097','860 TRADEWIND DR',0,'WESTERVILLE','OH','43081','3507','CY','39049','1968-09-21','M','U',NULL,'T','021','DEN','775354','99734OH005000401','2014-01-01','2013-11-28 20:25:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:30:23'),(19155,15261,'Y','18','021','EC','A','','','AC','0000020203','0000020203','OH00002236398','IL','1','maslanka','benjamin','','','','34','285963551','1333 cove ave',0,'lakewood','OH','44107',NULL,'CY','39035','1993-07-09','M','U',':RET:2106-3','T','021','HLT','2448101','52664OH152000901','2014-03-01','2014-01-19 14:27:25','57.00',NULL,NULL,'116.98','59.98','R-OH011','OH0','116.98',NULL,0,'2014-01-21 08:45:37'),(19019,15146,'Y','18','024','14','A','','','TE','0000124238','0000124238','','IL','1','Boring','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-11-12','M','',NULL,NULL,NULL,'','2606346','','2014-01-16','2014-01-16 22:09:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:06:24'),(18431,14705,'Y','18','021','EC','A','','','AC','0001591660','0001591660','LA00001730447','IL','1','Payton','Bruce','','','','34','439212781','127 CLARENCE AVE',0,'NEW LLANO','LA','71461','9783','CY','22115','1959-04-27','M','U',':RET:2054-5','N','021','DEN','2840900','18575LA002000201','2014-02-01','2014-01-15 14:50:03','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-16 08:45:58'),(18353,14651,'Y','18','021','EC','A','','','AC','0000412229','0000412229','OH00001419369','IL','1','Osborn','Korey','','','','34','302887235','107 LINDSEY LN',0,'BRYAN','OH','43506','9145','CY','39171','1988-05-23','F','U',':RET:2106-3','N','021','DEN','1452397','99734OH005000301','2014-02-01','2014-01-14 20:30:36','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-16 08:45:22'),(16875,13502,'Y','18','024','14','A','','','TE','0000048401','0000048401','','IL','1','Ingram','Karla',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-13','F','',NULL,NULL,NULL,'','1675831','','2014-01-08','2014-01-08 19:10:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:19:18'),(3555,2854,'Y','18','021','EC','A','','','AC','0000793465','0000793465','OH00000742879','IL','1','Davis','John','','','','34','300661214','850 S MAIN ST',0,'AKRON','OH','44311','2043','CY','39153','1958-07-29','M','U',':RET:2106-3','N','021','HLT','1645915','52664OH151001305','2014-01-01','2013-12-22 11:01:34','336.00',NULL,NULL,'497.31','161.31','R-OH012','OH0','497.31',NULL,0,'2013-12-25 21:22:09'),(4038,3224,'N','19','021','EC','A',NULL,NULL,'','0000293172','0000373614','','IL','1','Kington','Kelly','','','','34','288980080','714 Matthews Brook LN',0,'Powell','OH','43065',NULL,'CY','39041','1995-06-13','F','',NULL,'N','021','DEN','1548712','99734OH005000401','2014-01-01','2013-12-17 11:14:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:46:03'),(21765,17381,'Y','18','021','EC','A','','','AC','0000978977','0000978977','TX00001917540','IL','1','Flor','Nadia','','','','34','548550232','692 COUNTY ROAD 3810',0,'TROUP','TX','75789','8522','CY','48073','1978-11-13','F','M',NULL,'N','021','DEN','3803032','33348TX002000201','2014-03-01','2014-02-06 16:49:20','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:29'),(22318,17819,'Y','18','021','EC','A','','','AC','0002343315','0002343315','LA00002281608','IL','1','Giangrosso','Angelina','','','','34','434452171','550 LENWOOD DR',0,'SLIDELL','LA','70458','1222','CY','22103','1979-07-19','F','U',':RET:2106-3','N','021','DEN','3004709','18575LA002000201','2014-03-01','2014-01-29 22:34:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 11:00:51'),(23630,18817,'Y','18','021','EC','A','','','AC','0000725342','0000725342','TX00002159991','IL','1','Bhakta','Dharmesh','','','','34','783825814','110 S MAIN',0,'DILLEY','TX','78017','3834','CY','48163','1971-08-03','M','M',NULL,'N','021','DEN','2713126','33348TX002000201','2014-03-01','2014-02-13 18:16:16','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-14 21:30:03'),(24046,19124,'Y','18','021','EC','A','','','AC','0000546512','0000546512','OH00002437712','IL','1','Soutendijk','Diana','','','','34','295581081','3299 State Route 82',0,'Mantua','OH','44255',NULL,'CY','39133','1957-10-01','F','U',NULL,'N','021','DEN','3623126','99734OH005000301','2014-03-01','2014-02-15 10:51:19','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-15 22:01:01'),(24977,19810,'Y','18','021','EC','A','','','AC','0001067962','0001067962','TX00002231722','IL','1','Ali','Mir','Alam','','','34','641980517','23003 WALDERFORD DR',0,'KATY','TX','77450','1487','CY','48201','1953-03-19','M','M',':RET:2028-9','T','021','DEN','3664330','33348TX002000201','2014-04-01','2014-02-20 10:26:01','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:31'),(27564,21802,'N','19','021','EC','A',NULL,NULL,'','0000346947','0000282074','','IL','1','Landow','Elena','','','','34','673164621','3319 BRAEMAR RD',0,'SHAKER HEIGHTS','OH','44120','3331','CY','39035','2002-08-04','F','',':RET:2106-3','N','021','DEN','3460948','99734OH005000301','2014-04-01','2014-03-04 12:53:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:18'),(27838,22019,'Y','18','021','EC','A','','','AC','0000367450','0000367450','OH00003388394','IL','1','Roth','Suzanne','Renee','','','34','281504460','209 E WYANDOT AVE',0,'UPPER SANDUSKY','OH','43351','1431','CY','39175','1951-08-12','F','U',':RET:2106-3','N','021','DEN','3783103','99734OH005000301','2014-05-01','2014-03-05 15:43:13','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-03-05 21:32:05'),(2610,2121,'Y','18','021','EC','A','','','AC','0000944837','0000944837','OH00001095773','IL','1','Neumann','Jeanne','L','','','34','298460520','4506 9TH ST NW',0,'CANTON','OH','44708','3512','CY','39151','1949-06-12','F','M',':RET:2106-3','N','021','DEN','816888','99734OH005000401','2014-01-01','2013-12-02 11:09:22','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2013-12-25 19:45:34'),(18654,14871,'Y','18','021','EC','A','','','AC','0001178658','0001178658','TX00002198723','IL','1','Schmid','Nancy','','','','34','456988004','810 COUNTY ROAD 4516',0,'CASTROVILLE','TX','78009','5505','CY','48325','1950-11-13','F','M',':RET:2106-3','N','021','DEN','3025986','33348TX002000201','2014-03-01','2014-01-16 13:10:54','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-17 03:35:11'),(2917,2351,'Y','18','021','EC','A','','','AC','0001182479','0001182479','OH00000435446','IL','1','Olinger','Andrew','','','','34','281026082','5245 E Kemper Rd.',0,'Cincinnati','OH','45241',NULL,'CY','39061','1997-02-09','M','U',':RET:2106-3','N','021','DEN','342028','99734OH005000401','2014-01-01','2013-12-06 14:35:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-25 20:15:41'),(3537,2839,'Y','18','021','EC','A','','','AC','0000720201','0000720201','TX00000586190','IL','1','Miller','Amber','','','','34','454959367','2507 GIVENS AVE',0,'AUSTIN','TX','78722','2106','CY','48453','1981-03-17','F','U',':RET:2106-3','N','021','DEN','1832407','33348TX002000101','2014-01-01','2013-12-22 09:51:13','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:21:38'),(15285,12220,'N','01','021','EC','A',NULL,NULL,'','0000319049','0000317925','','IL','1','Spann','Christopher','','','','34','425331041','103 Joe Myers Rd.',0,'Brandon','MS','39047',NULL,'CY','28121','1972-02-27','M','',':RET:2054-5','N','021','DEN','1782037','46300MS002000101','2014-02-01','2013-12-31 19:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,1,'2014-01-02 04:22:17'),(15334,12265,'Y','18','021','EC','A','','','AC','0000710157','0000710157','OH00000505188','IL','1','Johnson','Martin','','','','34','513646078','9344 ROCKY WATER CT',0,'SYLVANIA','OH','43560','9225','CY','39095','1956-11-28','M','R',':RET:2106-3','N','021','HLT','2148800','92036OH005002601','2014-02-01','2014-01-01 15:35:23','0.00',NULL,NULL,'917.86','917.86','R-OH001','OH0','475.21',NULL,1,'2014-01-02 04:24:01'),(21692,17321,'Y','18','021','EC','A','','','AC','0001429874','0001429874','LA00001852860','IL','1','Vault','Vinetta','','','','34','438883868','506 Jasmine Street',0,'Jonesville','LA','71343',NULL,'CY','22025','1949-07-16','F','M',NULL,'N','021','DEN','3485774','18575LA002000101','2014-03-01','2014-02-05 18:09:00','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-02-05 21:31:06'),(22256,17763,'Y','18','021','EC','A','','','AC','0000473303','0000473303','MS00001808792','IL','1','McGowan','Chuncey','','','','34','427518363','616 Oak Park Circle',0,'Pearl','MS','39208',NULL,'CY','28121','1984-09-24','F','M',':RET:2054-5','N','021','DEN','3532787','46300MS002000201','2014-03-01','2014-02-09 17:47:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-09 19:00:45'),(22363,17858,'N','01','021','EC','A',NULL,NULL,'','0001174396','0000547871','','IL','1','thornton','david','','','','34','271827908','8317 WAINSTEAD DR',0,'PARMA','OH','44129','4846','CY','39035','1967-07-26','M','',':RET:2054-5','N','021','DEN','2973163','99734OH005000301','2014-02-01','2014-02-10 12:13:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-10 21:00:09'),(314,257,'Y','18','021','EC','A','','','AC','0000766205','0000766205','LA00000357845','IL','1','Sheats','Mark','','','','34','227399489','8162 RAINBOW DR',0,'BATON ROUGE','LA','70809','2107','CY','22033','1979-06-27','M','U',':RET:2106-3','N','021','DEN','971899','18575LA002000201','2014-01-01','2013-11-13 16:47:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:31:07'),(18971,15116,'N','01','021','EC','A',NULL,NULL,'','0000924819','0001246966','','IL','1','GAJKOWSKI','MARK','','','','34','285562356','17263 South Boone Road',0,'Columbia Station','OH','44028',NULL,'CY','39093','1970-02-15','M','',':RET:2106-3','N','021','DEN','3024697','99734OH005000301','2014-03-01','2014-01-16 21:10:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:02'),(18737,14930,'N','01','021','EC','A',NULL,NULL,'','0001103467','0000084073','','IL','1','KOHUT','DAVID','M','','','34','295723935','78 W HINES HILL RD',0,'HUDSON','OH','44236','1031','CY','39153','1962-02-24','M','',':RET:2106-3','N','021','DEN','2893002','99734OH005000301','2014-03-01','2014-01-16 16:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:38'),(18238,14558,'Y','18','021','EC','A','','','AC','0001251775','0001251775','TX00001588819','IL','1','ZHU','QIONGBIN','','','','34','071940120','2904 86 THE ST',0,'LUBBOCK','TX','79423',NULL,'CY','48303','1979-10-29','F','M',':RET:2029-7','N','021','DEN','2721536','33348TX002000201','2014-02-01','2014-01-15 10:41:46','0.00',NULL,NULL,'29.22','29.22','R-TX014','TX0','14.61',NULL,0,'2014-01-16 08:44:23'),(4338,3446,'Y','18','021','EC','A','','','AC','0000676694','0000676694','OH00000944648','IL','1','Arisman','Justin','','','','34','565671593','230 W FANCY ST',0,'BLANCHESTER','OH','45107','1461','CY','39027','1981-07-23','M','U',':RET:2106-3','N','021','HLT','2063940','92036OH003000605','2014-01-01','2013-12-17 12:37:07','168.00',NULL,NULL,'265.21','97.21','R-OH005','OH0','265.21',NULL,0,'2013-12-25 21:53:12'),(9508,7540,'Y','18','021','EC','A','','','AC','0000461932','0000461932','OH00001010801','IL','1','Bracone','Gary','','','','34','273563546','120 PAULMAN CIR',0,'MINGO JUNCTION','OH','43938','1349','CY','39081','1953-10-18','M','U',':RET:2106-3','N','021','DEN','2569368','99734OH005000401','2014-01-01','2013-12-21 16:09:31','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 04:35:20'),(28420,22488,'Y','18','021','EC','A','','','AC','0000976805','0000976805','OH00003601743','IL','1','Gantt','Thelma','M','','','34','269723127','3855 E 147TH ST',0,'CLEVELAND','OH','44128','1026','CY','39035','1971-05-15','F','U',':RET:2054-5','N','021','DEN','2873466','99734OH005000401','2014-04-01','2014-03-07 13:58:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-07 21:31:02'),(14437,11514,'Y','18','024','14','A','','','TE','0001868251','0001868251','','IL','1','Boll','Andrea',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-12-15','F','',NULL,NULL,NULL,'','1429353','','2013-12-27','2013-12-27 11:01:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-28 03:32:05'),(20734,16567,'Y','18','021','EC','A','','','AC','0000961894','0000961894','OH00002195121','IL','1','Rock','Elizabeth','','','','34','276588911','68 W MARION ST',0,'DOYLESTOWN','OH','44230','1240','CY','39169','1971-02-26','F','M',':RET:2106-3','N','021','HLT','3013082','52664OH152000901','2014-03-01','2014-01-30 13:08:33','221.65',NULL,NULL,'221.65','0.00','R-OH014','OH0','221.65',NULL,0,'2014-01-30 21:01:20'),(20324,16227,'Y','18','021','EC','A','','','AC','0000837493','0000837493','TX00002236558','IL','1','lollar','lena','','','','34','461456460','1030 OLD OMEN RD',0,'TYLER','TX','75701','3723','CY','48423','1978-09-24','F','U',':RET:2054-5','N','021','DEN','3091866','33348TX002000201','2014-03-01','2014-01-28 15:37:47','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-01-28 21:00:57'),(13372,10680,'N','19','021','EC','A',NULL,NULL,'','0000636002','0000810785','','IL','1','Sullivan','James','Stephen Szilagyi','','','34','281988209','18800 State Route 47 East',0,'Sidney','OH','45365',NULL,'CY','39149','1995-02-03','M','',':RET:2106-3','N','021','DEN','2046709','99734OH005000301','2014-01-01','2013-12-22 21:24:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:46'),(18479,14742,'Y','18','021','EC','A','','','AC','0000793489','0000793489','OH00001587501','IL','1','Ziss','William','','','','34','268785737','4076 KINGSBURY BLVD',0,'COPLEY','OH','44321','2841','CY','39153','1967-08-18','M','R',NULL,'N','021','HLT','2557525','52664OH151001301','2014-02-01','2014-01-14 21:44:58','0.00',NULL,NULL,'966.29','966.29','R-OH012','OH0','334.51',NULL,0,'2014-01-16 08:46:20'),(18356,14654,'Y','18','021','EC','A','','','AC','0000911787','0000911787','OH00001391618','IL','1','Lowe','Robert','','','','34','300884122','111 TWIN LAKES DR',0,'FAIRFIELD','OH','45014','5254','CY','39017','1988-08-16','M','U',':RET:2106-3','N','021','DEN','1631421','99734OH005000301','2014-02-01','2014-01-14 22:13:57','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:45:24'),(6342,5025,'N','01','021','EC','A',NULL,NULL,'','0000964594','0000451248','','IL','1','Stec','Deborah','Ann','','','34','277526515','25785 Folley Road',0,'Columbia Station','OH','44028',NULL,'CY','39093','1951-12-27','F','',':RET:2106-3','N','021','DEN','298166','99734OH005000401','2014-01-01','2013-12-11 12:13:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:48'),(16117,12910,'N','01','021','EC','A',NULL,NULL,'','0001809817','0001858990','','IL','1','Hemani','Shehnaz','','','','34','628389731','7009 LEGACY LOOP',0,'PINEVILLE','LA','71360','4680','CY','22079','1965-04-30','F','',':RET:2029-7','N','021','DEN','2193823','18575LA002000101','2014-02-01','2014-01-03 00:10:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-04 02:05:18'),(16739,13391,'N','01','021','EC','A',NULL,NULL,'','0000674079','0000368561','','IL','1','Ferrari','Anthony','L','','','34','281728170','1705 ARNDALE RD',0,'STOW','OH','44224','1850','CY','39153','1971-08-23','M','',':RET:2106-3','N','021','HLT','1624945','52664OH151001305','2014-02-01','2014-01-06 20:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,0,'2014-01-08 18:24:51'),(16345,13083,'N','01','021','EC','A',NULL,NULL,'','0000763536','0000089841','','IL','1','Butcher','David','Lynn','','','34','234047842','6918 WHITE PINE DR',0,'RAVENNA','OH','44266','8983','CY','39133','1958-10-31','M','',':RET:2106-3','T','021','DEN','2569985','99734OH005000301','2014-02-01','2014-01-06 15:56:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:20'),(21246,16977,'Y','18','024','14','A','','','TE','0000155813','0000155813','','IL','1','brown','richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-02-03','M','',NULL,NULL,NULL,'','2339482','','2014-02-03','2014-02-03 15:43:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:15'),(22443,17920,'Y','18','021','EC','A','','','AC','0000925345','0000925345','TX00002247129','IL','1','Tu','Khon','Binh','','','34','586123364','1 ASHLEY CT',0,'WICHITA FALLS','TX','76310','2266','CY','48485','1950-08-09','M','M',':RET:2047-9','N','021','DEN','2917491','33348TX002000201','2014-03-01','2014-02-10 13:17:29','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-10 21:30:43'),(22628,18070,'Y','18','021','EC','A','','','AC','0000304222','0000304222','TX00002357636','IL','1','FIGUEROA','JACQUELINE','','','','34','031621328','11049 GATEWAY BLVD W',0,'EL PASO','TX','79935',NULL,'CY','48141','1982-08-03','F','U',NULL,'N','021','DEN','3089742','33348TX002000201','2014-03-01','2014-02-10 23:08:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-11 21:00:15'),(22755,18167,'Y','18','021','EC','A','','','AC','0001256801','0001256801','LA00001774758','IL','1','CASEY','MEGAN','','','','34','433776598','4920 BIENVILLE AVE',0,'NEW ORLEANS','LA','70119',NULL,'CY','22071','1984-02-15','F','U',':RET:2106-3','N','021','DEN','2736789','18575LA002000101','2014-03-01','2014-02-11 16:32:15','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-11 21:01:28'),(24836,19690,'Y','18','021','EC','A','','','AC','0000835501','0000835501','MS00001805196','IL','1','JONES','JACQUELINE','','','','34','426139033','416 WOODSTONE RD',0,'CLINTON','MS','39056',NULL,'CY','28049','1963-11-25','F','M',NULL,'N','021','DEN','3608257','46300MS002000101','2014-04-01','2014-02-19 15:48:42','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-20 04:53:03'),(1382,1147,'Y','18','021','EC','A','','','AC','0001507618','0001507618','LA00000946608','IL','1','SHAFFETT','DEBORAH','ANN','','','34','439941151','1353 JIM TAYLOR DR APT 108',0,'BATON ROUGE','LA','70820',NULL,'CY','22033','1955-02-03','F','U',':RET:2106-3','N','021','DEN','1733946','18575LA002000201','2014-01-01','2013-12-24 10:00:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 18:46:07'),(20021,15967,'Y','18','024','14','A','','','TE','0001591649','0001591649','','IL','1','GARDNER','GINA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-10','F','',NULL,NULL,NULL,'','1987616','','2014-01-25','2014-01-25 19:37:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-26 19:00:15'),(19277,15365,'Y','18','021','EC','A','','','AC','0001158954','0001158954','OH00001394494','IL','1','Crutcher','Rob','Jay','','','34','276687988','1816 WHEATFIELD WAY',0,'LOVELAND','OH','45140','8538','CY','39025','1959-05-06','M','M',':RET:2106-3','N','021','HLT','1830652','92036OH004000601','2014-03-01','2014-01-20 13:47:41','386.00',NULL,NULL,'773.48','387.48','R-OH005','OH0','368.53',NULL,0,'2014-01-21 08:46:58'),(1665,1390,'N','01','021','EC','A',NULL,NULL,'','0000563953','0001209563','','IL','1','Hollis','Renee','','','','34','460086612','3400 Doe Run',0,'Austin','TX','78748',NULL,'CY','48453','1957-04-21','F','',':RET:2106-3','N','021','DEN','1543620','33348TX002000201','2014-01-01','2013-12-24 17:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:53:44'),(18467,14733,'Y','18','021','EC','A','','','AC','0002030434','0002030434','LA00001465849','IL','1','Johnson','Money','','','','34','439068562','400 VOTERS RD',0,'SLIDELL','LA','70461','3538','CY','22103','1964-08-06','M','U',NULL,'N','021','DEN','2839728','18575LA002000101','2014-02-01','2014-01-15 17:17:44','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-16 08:46:16'),(14679,11719,'Y','18','021','EC','A','','','AC','0000423318','0000423318','MS00001372359','IL','1','brumfield','cyris','','','','34','428638827','22 campbell scenic drive',0,'hattiesburg','MS','39401',NULL,'CY','28035','1988-06-15','M','U',':RET:2054-5','N','021','DEN','2542481','46300MS002000201','2014-02-01','2013-12-27 19:19:05','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,1,'2013-12-29 11:08:30'),(2592,2106,'N','19','021','EC','A',NULL,NULL,'','0000474926','0000473614','','IL','1','Toth','Kayla',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-02-08','F','',':RET:2106-3','N','021','DEN','223776','99734OH005000401','2014-01-01','2013-12-01 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:45:06'),(16249,13011,'Y','18','021','EC','A','','','AC','0000384409','0000384409','OH00002100129','IL','1','Rodriguez','Quentin','','','','34','294864036','1001 N MAIN AVE',0,'SIDNEY','OH','45365','1727','CY','39149','1987-03-18','M','U',':RET:2106-3','N','021','DEN','1955725','99734OH005000301','2014-02-01','2014-01-04 14:13:41','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-05 00:02:35'),(5374,4261,'Y','18','021','EC','A','','','AC','0001964599','0001964599','LA00000442660','IL','1','hilliard','eddie','','','','34','433250112','16439 long lake dr',0,'praireville','LA','70769',NULL,'CY','22005','1960-03-15','M','U',':RET:2054-5','N','021','DEN','1991031','18575LA002000201','2014-01-01','2013-12-19 13:05:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:08:09'),(9231,7324,'Y','18','021','EC','A','','','AC','0001090907','0001090907','OH00000991150','31','1','Denehy','Francis','','','','34','285540033','1057 W LOCUST STREET',0,'Wilmington','OH','45177',NULL,'CY','39027','1954-02-17','M','M',':RET:2106-3','N','021','HLT','1981319','92036OH003000604','2014-01-01','2013-12-18 18:07:44','904.00',NULL,NULL,'1154.75','250.75','R-OH005','OH0','583.55',NULL,0,'2013-12-26 04:10:28'),(3239,2609,'Y','18','021','EC','A','','','AC','0000006069','0000006069','TX00000977984','IL','1','Morris','Willie','','','','34','461316856','3807 crandon',0,'Houston','TX','77026',NULL,'CY','48201','1962-07-26','M','U',NULL,'N','021','DEN','847342','33348TX002000201','2014-01-01','2013-10-06 12:09:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:46:16'),(2781,2248,'Y','18','021','EC','A','','','AC','0000911735','0000911735','OH00000994582','IL','1','Levo','Karen','','','','34','283524864','5513 PENWAY CT',0,'CINCINNATI','OH','45239','7215','CY','39061','1951-12-10','F','M',NULL,'N','021','HLT','381785','92036OH001001201','2014-01-01','2013-12-02 14:31:29','0.00',NULL,NULL,'743.93','743.93','R-OH004','OH0','743.93',NULL,0,'2013-12-25 19:49:52'),(22762,18173,'Y','18','021','EC','A','','','AC','0000929880','0000929880','OH00001856872','IL','1','PRUITT','KATHLEEN','','','','34','422808188','2610 Park Ave',0,'Cincinnati','OH','45206',NULL,'CY','39061','1959-08-17','F','U',':RET:2054-5','N','021','DEN','3159128','99734OH005000401','2014-03-01','2014-02-11 08:41:11','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-11 21:01:33'),(24798,19668,'Y','18','021','EC','A','','','AC','0000984904','0000984904','OH00003029793','IL','1','MCGOWAN','APRIL','','','','34','289905832','1009 3RD ST',0,'MARIETTA','OH','45750','1836','CY','39167','1989-09-15','F','M',NULL,'N','021','DEN','3100708','99734OH005000401','2014-04-01','2014-02-19 16:30:01','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,0,'2014-02-20 04:47:47'),(25296,20069,'Y','18','024','14','A','','','TE','0000411157','0000411157','','IL','1','PAPKAR','PADMAJA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-02-04','F','',NULL,NULL,NULL,'','2914860','','2014-03-31','2014-02-25 11:13:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:26'),(25743,20418,'Y','18','021','EC','A','','','AC','0001024330','0001024330','OH00003216379','IL','1','Hughes','Robert','','','','34','274747071','151 IVANHOE AVE',0,'CINCINNATI','OH','45233','1206','CY','39061','1964-01-06','M','M',':RET:2106-3','N','021','DEN','2686273','99734OH005000401','2014-04-01','2014-02-24 14:32:19','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-26 09:30:41'),(25825,20477,'Y','18','021','EC','A','','','AC','0000253100','0000253100','OH00002595271','IL','1','JACOBS','ANN','','','','34','269522652','48866 JOHN TOMCHO RD',0,'CUMBERLAND','OH','43732',NULL,'CY','39121','1950-03-12','F','M',':RET:2106-3','N','021','DEN','3155546','99734OH005000301','2014-03-01','2014-02-26 16:42:14','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-02-26 21:00:28'),(27593,21822,'Y','18','021','EC','A','','','AC','0000584334','0000584334','OH00003022938','IL','1','Bowles','Maria','Y','','','34','368789418','7050 BARIBILL PL',0,'CINCINNATI','OH','45230','4022','CY','39061','1962-09-27','F','U',NULL,'N','021','DEN','3227712','99734OH005000401','2014-04-01','2014-03-05 07:56:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-03-05 21:00:18'),(28027,22180,'Y','18','021','EC','A','','','AC','0001200947','0001200947','OH00003198047','IL','1','ZAWISTOWSKI','JOHN','','','','34','277466950','820 W TURKEYFOOT LAKE RD',0,'AKRON','OH','44319','3309','CY','39153','1951-06-24','M','U',':RET:2106-3','T','021','DEN','4100532','99734OH005000401','2014-04-01','2014-03-06 15:47:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-06 21:01:25'),(28786,22786,'Y','18','021','EC','A','','','AC','0000539364','0000539364','OH00003607114','IL','1','Sparks','Antwan','','','','34','299843934','5115 EBERSOLE AVE',0,'CINCINNATI','OH','45227','1610','CY','39061','1986-12-06','M','R',':RET:2054-5','N','021','DEN','3452570','99734OH005000401','2014-04-01','2014-03-09 17:21:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-09 21:00:38'),(15045,12026,'N','01','021','EC','A',NULL,NULL,'','0001767784','0001610449','','IL','1','MARTINEZ','WALDINA','E','','','34','436816166','3237 DARTMOUTH ST',0,'KENNER','LA','70065','4001','CY','22051','1961-06-16','F','',NULL,'N','021','DEN','2200028','18575LA002000201','2014-02-01','2013-12-30 13:37:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:03:05'),(20867,16676,'Y','18','021','EC','A','','','AC','0001080368','0001080368','OH00001657084','IL','1','Augustine','Deborah','','','','34','296566821','145 BIRCHCREST DR',0,'PERRYSBURG','OH','43551','1802','CY','39173','1960-09-21','F','U',':RET:2106-3','N','021','HLT','3077177','92036OH004002601','2014-03-01','2014-01-31 12:38:09','230.00',NULL,NULL,'319.86','89.86','R-OH001','OH0','319.86',NULL,0,'2014-01-31 21:00:59'),(16440,13154,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1389263','','2014-01-06','2014-01-06 17:02:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:05:05'),(22437,17915,'Y','18','021','EC','A','','','AC','0000434518','0000434518','TX00001750524','IL','1','SMITH','MARY','','','','34','631085794','45 PRIVATE RD',0,'TEXARKANA','TX','75501',NULL,'CY','48037','1979-04-01','F','U',NULL,'N','021','DEN','3368987','33348TX002000201','2014-03-01','2014-02-10 11:05:57','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-10 21:30:39'),(23409,18651,'Y','18','021','EC','A','','','AC','0001080375','0001080375','OH00001776040','IL','1','Jaworski','Shawn','','','','34','293889543','2605 Detroit Avenue',0,'Cleveland','OH','44113',NULL,'CY','39035','1988-01-30','M','U',':RET:2106-3','N','021','DEN','3244047','99734OH005000401','2014-03-01','2014-02-12 18:38:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:01:14'),(25874,20515,'Y','18','021','EC','A','','','AC','0001904947','0001904947','LA00002078408','IL','1','Favorite','Florience','','','','34','435987657','4644 EASTERN ST',0,'NEW ORLEANS','LA','70122','6124','CY','22071','1955-01-21','M','M',':RET:2054-5','N','021','DEN','3840865','18575LA002000201','2014-04-01','2014-02-26 17:12:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:53'),(27701,21906,'N','19','021','EC','A',NULL,NULL,'','0000428667','0001016864','','S1','1','Brooks','Quatro','','','','34','640234939','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','2009-12-18','M','',NULL,'N','021','DEN','2896425','33348TX002000201','2014-04-01','2014-03-05 11:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-05 21:30:49'),(660,545,'Y','18','021','EC','A','','','AC','0000780487','0000780487','OH00001342708','IL','1','frey','leonard','','','','34','300584445','2441 ravenwood ave',0,'dayton','OH','45406',NULL,'CY','39113','1960-03-27','M','M',':RET:2106-3','T','021','DEN','808447','99734OH005000301','2014-01-01','2013-12-15 20:17:45','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:01:51'),(18541,14786,'Y','18','021','EC','A','','','AC','0000746848','0000746848','MS00001729246','IL','1','Driskell','Sandra','','','','34','427457051','456 COUNTY ROAD 702',0,'CORINTH','MS','38834','8742','CY','28003','1976-12-21','F','U',':RET:2106-3','N','021','DEN','1576641','46300MS002000101','2014-02-01','2014-01-15 00:50:11','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-16 08:46:49'),(4981,3955,'Y','18','021','EC','A','','','AC','0000560354','0000560354','TX00001102997','IL','1','westmoreland','vivian','','','','34','545904518','944 VICKI LN',0,'FORT WORTH','TX','76104','7201','CY','48439','1952-04-24','F','U',':RET:2054-5','N','021','DEN','58064','33348TX002000201','2014-01-01','2013-12-07 14:41:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:46:43'),(15282,12218,'Y','18','021','EC','A','','','AC','0001052507','0001052507','MS00002049720','IL','1','Ford','Veronica','','','','34','428272628','1704 62ND AVE',0,'GULFPORT','MS','39501','4018','CY','28047','1963-07-01','F','U',':RET:2054-5','N','021','DEN','1824068','46300MS002000101','2014-02-01','2013-12-31 18:35:34','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,1,'2014-01-02 04:22:10'),(843,697,'Y','18','021','EC','A','','','AC','0000258133','0000258133','OH00000433085','IL','1','Whittenbarger','Matthew','','','','34','301663352','909 WOODLAND AVE',0,'VAN WERT','OH','45891','1430','CY','39161','1974-05-01','M','U',':RET:2106-3','T','021','HLT','987534','92036OH004001501','2014-01-01','2013-12-15 22:06:50','254.95',NULL,NULL,'256.83','1.88','R-OH002','OH0','256.83',NULL,0,'2013-12-25 18:06:39'),(3591,2881,'Y','18','021','EC','A','','','AC','0001218537','0001218537','OH00001171332','IL','1','davis','orville','','','','34','406119320','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1965-12-09','M','M',':RET:2106-3','N','021','HLT','2277857','92036OH003001201','2014-01-01','2013-12-22 10:38:46','240.00',NULL,NULL,'927.01','687.01','R-OH004','OH0','366.54',NULL,0,'2013-12-25 21:23:03'),(9626,7624,'Y','18','024','14','A','','','TE','0000869255','0000869255','','IL','1','Jones','Jonathan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-11-11','M','',NULL,NULL,NULL,'','266477','','2013-12-20','2013-12-20 21:21:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:38:04'),(21465,17152,'N','01','021','EC','A',NULL,NULL,'','0001114567','0001201927','','IL','1','BERNATOVICZ','EMILY','','','','34','278822328','1000 ROBINWOOD HILLS DR',0,'AKRON','OH','44333','1554','CY','39153','1975-03-13','F','',NULL,'N','021','HLT','3471935','52664OH151001301','2014-03-01','2014-02-04 18:01:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.87',NULL,0,'2014-02-04 21:01:35'),(23109,18420,'N','19','021','EC','A',NULL,NULL,'','0000504509','0000807538','','S1','1','wong','christina','','','','34','613450472','8111 EAGLE RIDGE DR',0,'WEST CHESTER','OH','45069','1976','CY','39017','2004-05-14','F','',':RET:2028-9^:RET:2500-7','N','021','DEN','2782996','99734OH005000401','2014-03-01','2014-02-12 17:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:17'),(23177,18478,'N','01','021','EC','A',NULL,NULL,'','0000267570','0000632727','','IL','1','SPENCER','RANDY','','','','34','280823687','6501 FOUST RD',0,'COLUMBUS GROVE','OH','45830','9497','CY','39003','1981-06-18','M','',NULL,'N','021','HLT','3184442','92036OH004001501','2014-03-01','2014-02-12 14:11:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','209.35',NULL,0,'2014-02-12 21:31:56'),(23283,18561,'Y','18','021','EC','A','','','AC','0001133975','0001133975','OH00001704809','IL','1','Hazelwood','Mark','','','','34','279840264','1201 st.rt. 1312',0,'milford','OH','45150',NULL,'CY','39025','1969-10-04','M','U',NULL,'T','021','HLT','3583617','92036OH006000601','2014-03-01','2014-02-13 13:05:51','135.00',NULL,NULL,'273.51','138.51','R-OH005','OH0','273.51','CIC',0,'2014-02-13 21:30:17'),(26120,20715,'Y','18','021','EC','A','','','AC','0000680907','0000680907','OH00002716384','IL','1','CIANELLI','STEPHEN','D','','','34','293662470','291 WEST WILLIAMS ST',0,'DELAWARE','OH','43015',NULL,'CY','39041','1966-05-17','M','U',NULL,'N','021','DEN','2911901','99734OH005000401','2014-04-01','2014-02-26 23:43:21','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:19'),(28066,22210,'Y','18','021','EC','A','','','AC','0001142239','0001142239','OH00002687491','IL','1','Tchorz','Norman','','','','34','274921559','33 HEREFORD ST',0,'CINCINNATI','OH','45216','1107','CY','39061','1987-05-28','M','M',':RET:2106-3','N','021','DEN','3327684','99734OH005000301','2014-04-01','2014-03-06 12:11:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-06 21:01:47'),(7233,5734,'Y','18','021','EC','A','','','AC','0000944850','0000944850','OH00000239369','IL','1','Harder','Kathy','','','','34','268525228','1148 ANDERSON AVE',0,'MAUMEE','OH','43537','3023','CY','39095','1949-12-06','F','U',':RET:2106-3','N','021','DEN','15813','99734OH005000401','2014-01-01','2013-12-14 17:21:43','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 02:01:26'),(4742,3757,'Y','18','021','EC','A','','','AC','0001166791','0001166791','OH00001108425','IL','1','Cornett','Adam','','','','34','284966093','409 JACKSON ST',0,'WAPAKONETA','OH','45895','1417','CY','39011','1993-08-11','M','U',':RET:2106-3','N','021','HLT','105599','92036OH004001501','2014-01-01','2013-12-12 16:09:33','0.00',NULL,NULL,'112.38','112.38','R-OH002','OH0','112.38',NULL,0,'2013-12-25 22:09:29'),(5762,4577,'Y','18','021','EC','A','','','AC','0000330880','0000330880','OH00000027015','IL','1','eldridge','channin','','','','34','276863813','209 E CIRCLE DR',0,'MASON','OH','45040','1526','CY','39165','1971-04-11','F','M',':RET:2106-3','N','021','DEN','1902219','99734OH005000401','2014-01-01','2013-12-23 22:09:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:46:33'),(4005,3199,'Y','18','021','EC','A','','','AC','0001245581','0001245581','OH00000111195','IL','1','Eversole','Deborah','','','','34','287549922','6211  Watchcreek Way Apt. 103',0,'Milford','OH','45150',NULL,'CY','39025','1952-06-24','F','U',':RET:2106-3','N','021','DEN','2075671','99734OH005000401','2014-01-01','2013-12-16 20:56:12','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:45:17'),(22540,17998,'Y','18','021','EC','A','','','AC','0001757836','0001757836','LA00002326206','IL','1','Jennings','Laura','','','','34','435572112','123 vista dr',0,'Belle chasse','LA','70037',NULL,'CY','22075','1984-03-05','F','U',':RET:2106-3','N','021','DEN','3299014','18575LA002000101','2014-03-01','2014-02-10 09:50:09','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-10 21:31:38'),(24116,19170,'N','01','021','EC','A',NULL,NULL,'','0000186138','0000879177','','IL','1','Garza','Sandra','','','','34','462613293','220 S 83RD ST',0,'EDINBURG','TX','78542','2168','CY','48215','1965-06-23','F','',':RET:2106-3','N','021','DEN','2759974','33348TX002000201','2014-03-01','2014-02-15 13:29:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-15 22:01:39'),(25472,20209,'Y','18','021','EC','A','','','AC','0000077477','0000077477','TX00002628527','IL','1','Grant','Jazmin','','','','34','591883757','11212 Westpark Dr',0,'Houston','TX','77042',NULL,'CY','48201','1989-09-17','F','U',':RET:2054-5','N','021','DEN','3568472','33348TX002000201','2014-04-01','2014-02-25 17:12:57','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-25 21:31:38'),(1005,824,'Y','18','021','EC','A','','','AC','0001019686','0001019686','TX00000489138','IL','1','reed','tonjia','','','','34','459137144','2584 COUNTY ROAD 2995',0,'HUGHES SPRINGS','TX','75656','6196','CY','48067','1961-05-11','F','M',':RET:2080-0','N','021','DEN','671828','33348TX002000201','2014-01-01','2013-10-19 17:28:35','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:11:05'),(19258,15347,'Y','18','024','14','A','','','TE','0001912112','0001912112','','IL','1','Strong','Ethel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-02-27','F','',NULL,NULL,NULL,'','2987266','','2014-01-20','2014-01-20 13:37:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-21 08:46:47'),(18061,14429,'Y','18','021','EC','A','','','AC','0000484813','0000484813','OH00001364819','IL','1','Boone','Stacey','','','','34','299909555','14 Oriole Court',0,'Amelia','OH','45102',NULL,'CY','39025','1983-08-18','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','1875690','92036OH003000604','2014-02-01','2014-01-14 16:42:58','430.00',NULL,NULL,'848.01','418.01','R-OH005','OH0','254.45',NULL,0,'2014-01-15 02:07:21'),(2896,2337,'Y','18','021','EC','A','','','AC','0000949487','0000949487','OH00000341596','IL','1','Overfield','Jon','','','','34','301720107','1436 RUTH AVE',0,'CUYAHOGA FALLS','OH','44221','2938','CY','39153','1970-02-02','M','R',':RET:2106-3','N','021','HLT','56941','52664OH151001501','2014-01-01','2013-12-06 15:24:59','0.00',NULL,NULL,'1091.80','1091.80','R-OH012','OH0','362.95',NULL,0,'2013-12-25 20:15:15'),(7347,5817,'Y','18','021','EC','A','','','AC','0000055895','0000055895','OH00000574684','IL','1','kassan','john','','','','34','279481991','6179 PORTER DR',0,'FARMDALE','OH','44417','9715','CY','39155','1950-06-21','M','U',':RET:2106-3','N','021','HLT','408564','92036OH002003201','2014-01-01','2013-12-14 16:49:58','359.00',NULL,NULL,'825.16','466.16','R-OH013','OH0','825.16',NULL,0,'2013-12-26 02:04:07'),(4247,3383,'Y','18','021','EC','A','','','AC','0000992345','0000992345','TX00000136428','IL','1','Williams','Digole','','','','34','436843655','10305 PYRITE DR',0,'FORT WORTH','TX','76131','4292','CY','48439','1950-10-20','M','U',':RET:2054-5','N','021','DEN','1696714','33348TX002000201','2014-01-01','2013-12-17 17:07:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:51:11'),(14728,11760,'Y','18','021','EC','A','','','AC','0001441697','0001441697','LA00000291770','IL','1','Young','Heather','','','','34','436535534','30137 Barnett rd',0,'Denham springs','LA','70726',NULL,'CY','22063','1975-03-31','F','U',':RET:2106-3','N','021','DEN','2437366','18575LA002000201','2014-02-01','2013-12-28 13:57:42','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2013-12-29 11:09:44'),(4409,3503,'N','19','021','EC','A',NULL,NULL,'','0000803710','0000177616','','IL','1','Devore','Wesley',NULL,NULL,NULL,NULL,NULL,'1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','2011-10-01','M','',NULL,'N','021','DEN','252161','99734OH005000401','2014-01-01','2013-12-12 14:40:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:01:20'),(20832,16651,'Y','18','024','14','A','','','TE','0001345305','0001345305','','IL','1','KEMP','DAWANDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-02','F','',NULL,NULL,NULL,'','2581483','','2014-01-31','2014-01-31 17:55:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-31 21:00:41'),(21275,17003,'Y','18','024','14','A','','','TE','0000280860','0000280860','','IL','1','Donato','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-29','F','',NULL,NULL,NULL,'','2892978','','2014-02-03','2014-02-03 14:48:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:33'),(22922,18272,'Y','18','021','EC','A','','','AC','0000150508','0000150508','TX00002254824','IL','1','Coleman','Regina','','','','34','522510972','111 FM 1996',0,'OGLESBY','TX','76561','2014','CY','48099','1986-10-14','F','M',NULL,'N','021','DEN','3805637','33348TX002000201','2014-03-01','2014-02-11 18:13:45','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61','CIC',0,'2014-02-11 21:30:03'),(24478,19446,'Y','18','021','EC','A','','','AC','0000196184','0000196184','OH00002248551','IL','1','Fickert','Dawne','','','','34','279506289','12094 LISA ST NW',0,'HARTVILLE','OH','44632','9670','CY','39151','1950-01-23','F','M',':RET:2106-3','N','021','HLT','3006367','52664OH152000901','2014-04-01','2014-02-18 14:32:41','373.00',NULL,NULL,'490.00','117.00','R-OH015','OH0','490.00',NULL,0,'2014-02-18 22:01:43'),(24541,19493,'N','01','021','EC','A',NULL,NULL,'','0000840141','0001029333','','IL','1','Calzada','Edgar','','','','34','467495579','10249 SHARP DR',0,'EL PASO','TX','79924','3516','CY','48141','1980-03-27','M','',NULL,'N','021','DEN','3034654','33348TX002000201','2014-04-01','2014-02-18 18:04:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 04:02:20'),(27675,21889,'N','01','021','EC','A',NULL,NULL,'','0000376794','0000925448','','IL','1','GUZMAN NIEBLA','VANESSA','','','','34','464936836','6320 BRISA DEL MAR DR',0,'EL PASO','TX','79912','1839','CY','48141','1976-04-19','F','',':RET:2106-3','N','021','DEN','3672515','33348TX002000201','2014-04-01','2014-03-04 19:36:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:35'),(13966,11131,'N','01','021','EC','A',NULL,NULL,'','0000516910','0000706191','','IL','1','DeGrange','Allen','Gene','','','34','618301062','8618 BRADFORD BLOOMER RD',0,'BRADFORD','OH','45308','9755','CY','39109','1989-02-12','M','',':RET:2106-3','N','021','HLT','2178043','92036OH003000501','2014-01-01','2013-12-22 22:54:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','248.23',NULL,0,'2013-12-26 13:15:16'),(18670,14884,'Y','18','021','EC','A','','','AC','0000911033','0000911033','TX00002380665','IL','1','Garcia Rodriguez','Josue','','','','34','640841672','6521 CARLTON SPEED RANCH RD',0,'WALLER','TX','77484','6615','CY','48185','1977-01-17','M','M',NULL,'N','021','DEN','2628326','33348TX002000201','2014-03-01','2014-01-16 18:21:06','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:17'),(6882,5458,'Y','18','021','EC','A','','','AC','0002198932','0002198932','LA00000403452','IL','1','Reed','Teven','','','','34','436811050','8223 ACORN DR',0,'ALEXANDRIA','LA','71302','9385','CY','22079','1991-03-19','M','U',':RET:2054-5','N','021','DEN','1501096','18575LA002000201','2014-01-01','2013-12-24 18:46:03','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 01:45:05'),(17896,14294,'Y','18','021','EC','A','','','AC','0000636036','0000636036','OH00001941699','IL','1','Graham','Zachary','William','','','34','255672224','450 E. Norwich Ave',0,'Columbus','OH','43201',NULL,'CY','39049','1988-06-30','M','U',':RET:2054-5','N','021','DEN','1855536','99734OH005000401','2014-02-01','2014-01-14 17:12:40','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:21'),(6017,4762,'Y','18','021','EC','A','','','AC','0000547852','0000547852','OH00000482053','IL','1','kelly','thomas','','','','34','299581238','182 n. compass dr.',0,'vermilion','OH','44089',NULL,'CY','39043','1958-05-15','M','U',':RET:2106-3','N','021','DEN','141588','99734OH005000301','2014-01-01','2013-12-01 17:54:21','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-26 00:00:44'),(21723,17347,'Y','18','021','EC','A','','','AC','0000060567','0000060567','TX00002624683','IL','1','Pope','Carleen','','','','34','433454267','2724 Hwy 37 N',0,'Mt Vernon','TX','75457',NULL,'CY','48159','1968-03-07','F','M',':RET:2054-5','N','021','DEN','3839278','33348TX002000201','2014-03-01','2014-02-06 11:30:33','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:04'),(25063,19876,'Y','18','021','EC','A','','','AC','0000451330','0000451330','OH00002136686','IL','1','DAJA','KEITH','','','','34','299463237','965 OAKWOOD AVE',0,'COLUMBUS','OH','43206','1548','CY','39049','1952-01-07','M','U',NULL,'N','021','DEN','2838188','99734OH005000401','2014-04-01','2014-02-20 14:10:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 22:01:25'),(25200,19990,'N','19','021','EC','A',NULL,NULL,'','0002194917','0001849692','','IL','1','Jeter','Chadwin','R','','','34','435797977','3034 EDSON BLVD',0,'SHREVEPORT','LA','71107','5715','CY','22017','1988-03-26','M','',':RET:2054-5','N','021','DEN','3501055','18575LA002000201','2014-04-01','2014-02-21 13:08:09',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-21 22:00:45'),(25885,20524,'N','01','021','EC','A',NULL,NULL,'','0000105192','0000142369','','IL','1','STANLEY','BARBARA','D','','','34','454359657','1007 W 12TH ST',0,'CISCO','TX','76437','3708','CY','48133','1961-12-31','F','',':RET:2106-3','N','021','DEN','2840567','33348TX002000201','2014-04-01','2014-02-26 10:43:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:00'),(28014,22168,'Y','18','021','EC','A','','','AC','0000027956','0000027956','OH00003519382','IL','1','Brouillard','Sarah','Renee','','','34','114702905','4154 Amston Drive',0,'Dayton','OH','45424',NULL,'CY','39113','1986-05-14','F','U',':RET:2106-3','T','021','DEN','3286201','99734OH005000401','2014-04-01','2014-03-06 12:11:00','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-03-06 21:01:17'),(28835,22820,'N','01','021','EC','A',NULL,NULL,'','0000327336','0000396227','','IL','1','o\'neal','jessica','','','','34','279869252','225 Pinecone Drive',0,'Springboro','OH','45066',NULL,'CY','39165','1979-12-30','F','',NULL,'N','021','HLT','3737757','92036OH006001201','2014-04-01','2014-03-09 12:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','206.68',NULL,0,'2014-03-09 21:01:10'),(1301,1077,'Y','18','021','EC','A','','','AC','0000641189','0000641189','TX00001114377','IL','1','Browne','Gregory','','','','34','593685552','1616 W DALLAS ST',0,'HOUSTON','TX','77019','4548','CY','48201','1988-01-12','M','U',':RET:2106-3','N','021','DEN','1216424','33348TX002000201','2014-01-01','2013-11-03 22:00:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:31:10'),(3428,2753,'Y','18','021','EC','A','','','AC','0001787675','0001787675','LA00000043295','IL','1','Johnson','Rebecca','','','','34','463937247','609 TULANE AVE',0,'LAFAYETTE','LA','70503','2140','CY','22055','1986-04-11','F','U',':RET:2106-3','N','021','DEN','2034059','18575LA002000101','2014-01-01','2013-12-21 18:46:23','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 21:18:50'),(16100,12896,'Y','18','021','EC','A','','','AC','0001228069','0001228069','OH00001529744','31','1','Adams','Donna','','','','34','192549485','P.O. Box 104',0,'Tiffin','OH','44883',NULL,'CY','39147','1971-01-16','F','U',':RET:2106-3','N','021','HLT','1930716','92036OH003002705','2014-02-01','2014-01-02 21:46:30','203.00',NULL,NULL,'276.33','73.33','R-OH006','OH0','276.33',NULL,0,'2014-01-04 02:04:44'),(15366,12290,'N','01','021','EC','A',NULL,NULL,'','0000168902','0000376158','','IL','1','Sejdic','Stojka','','','','34','299022100','1654 BREIDING RD',0,'AKRON','OH','44310','2635','CY','39153','1961-03-13','F','',NULL,'N','021','DEN','2613791','99734OH005000301','2014-02-01','2014-01-01 14:30:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:24:56'),(5978,4733,'Y','18','021','EC','A','','','AC','0000768881','0000768881','OH00000571069','IL','1','Chambers','Larry','','','','34','300422183','5040 LEBANON RD',0,'SOUTH LEBANON','OH','45065','1418','CY','39165','1950-08-23','M','M',':RET:2106-3','N','021','HLT','2185931','92036OH004001201','2014-01-01','2013-12-23 23:09:38','581.00',NULL,NULL,'1092.97','511.97','R-OH004','OH0','509.54',NULL,0,'2013-12-25 23:51:53'),(20093,16031,'Y','18','021','EC','A','','','AC','0001554335','0001554335','LA00001459264','IL','1','Pearson','Sandra','','','','34','436783523','2215 GENERAL CLEBURNE AVE',0,'BATON ROUGE','LA','70810','6867','CY','22033','1950-01-10','F','U',':RET:2054-5','N','021','DEN','3475631','18575LA002000201','2014-03-01','2014-01-26 21:43:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-27 21:00:31'),(21613,17257,'Y','18','021','EC','A','','','AC','0001029276','0001029276','TX00002588539','IL','1','sanchez','eva','','','','34','582839757','4039 BURKBURNETT RD',0,'WICHITA FALLS','TX','76306',NULL,'CY','48485','1969-12-30','F','U',NULL,'N','021','DEN','3268947','33348TX002000201','2014-03-01','2014-02-04 19:21:34','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-05 21:30:35'),(21883,17472,'Y','18','024','14','A','','','TE','0001351099','0001351099','','IL','1','AUBERT','CHARLES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-04-30','M','',NULL,NULL,NULL,'','3462989','','2014-02-06','2014-02-06 13:49:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-06 21:01:32'),(23697,18871,'Y','18','021','EC','A','','','AC','0000295548','0000295548','OH00002230251','IL','1','Wentzel','Joseph','','','','34','273844817','3371 Tudor Lane',0,'Hilliard','OH','43026',NULL,'CY','39049','1970-02-09','M','U',':RET:2106-3','N','021','DEN','2625286','99734OH005000401','2014-03-01','2014-02-14 11:08:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-14 21:30:40'),(27207,21542,'Y','18','021','EC','A','','','AC','0000223750','0000223750','OH00003441825','IL','1','Kuohn','Ruth','','','','34','289565645','905 EVESHAM AVE',0,'TOLEDO','OH','43607','3748','CY','39095','1956-02-11','F','M',NULL,'N','021','HLT','3071260','92036OH004002601','2014-04-01','2014-03-03 11:47:23','731.00',NULL,NULL,'801.60','70.60','R-OH001','OH0','399.50',NULL,0,'2014-03-03 21:31:26'),(28529,22578,'Y','18','021','EC','A','','','AC','0001832527','0001832527','LA00003417631','IL','1','Green','Audrey','','','','34','340625160','809 B Third Street',0,'Lake Providence','LA','71254',NULL,'CY','22035','1964-12-04','F','U',':RET:2054-5','N','021','DEN','3774360','18575LA002000101','2014-04-01','2014-03-07 09:34:57','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-03-07 21:32:06'),(14203,11326,'Y','18','021','EC','A','','','AC','0000524067','0000524067','TX00000590477','IL','1','ODAY','JUDITH','A','','','34','071548054','12100 SAGE HEN CT',0,'AUSTIN','TX','78727','6734','CY','48453','1962-06-14','F','U',':RET:2106-3','N','021','DEN','1491142','33348TX002000201','2014-02-01','2013-12-26 13:39:38','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-27 02:04:17'),(19665,15670,'Y','18','021','EC','A','','','AC','0001977773','0001977773','LA00001927369','IL','1','Coleman','Dwayne','','','','34','436811769','1629 N GALVEZ ST',0,'NEW ORLEANS','LA','70119','2640','CY','22071','1991-02-23','M','U',':RET:2054-5','N','021','DEN','2050408','18575LA002000101','2014-03-01','2014-01-22 18:46:22','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-23 21:00:27'),(13315,10631,'Y','18','021','EC','A','','','AC','0001240342','0001240342','TX00000569555','IL','1','Brown','Katheryne','','','','34','455895781','1402 W BLUFF ST',0,'GRANBURY','TX','76048','1835','CY','48221','1984-10-16','F','M',':RET:2106-3','N','021','DEN','1905995','33348TX002000201','2014-01-01','2013-12-23 16:20:35','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:11'),(13152,10492,'Y','18','021','EC','A','','','AC','0000205786','0000205786','OH00000311640','IL','1','Teague','Barbara','','','','34','293724660','PO Box 373',0,'Anna','OH','45302',NULL,'CY','39149','1962-09-24','F','M',NULL,'N','021','DEN','1668629','99734OH005000401','2014-01-01','2013-12-23 17:05:00','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:53:38'),(16564,13251,'N','01','021','EC','A',NULL,NULL,'','0000031738','0000289080','','IL','1','dressner','jennifer','','','','34','227558711','31 virgil mitchell rd',0,'picayune','MS','39466',NULL,'CY','28109','1987-07-26','F','',':RET:2106-3','N','021','DEN','1561794','46300MS002000101','2014-02-01','2014-01-05 17:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,1,'2014-01-07 10:23:09'),(6907,5481,'Y','18','021','EC','A','','','AC','0001229883','0001229883','LA00001034157','IL','1','Harris','Brenda','','','','34','439885259','1341 S DILTON ST',0,'METAIRIE','LA','70003','6203','CY','22051','1955-03-01','F','U',':RET:2054-5','N','021','DEN','2168268','18575LA002000201','2014-01-01','2013-12-24 23:53:44','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:48'),(2350,1915,'Y','18','021','EC','A','','','AC','0000253181','0000253181','TX00001075761','IL','1','De La Vega','Axel','','','','34','637101976','3232 SPRING CREST CT',0,'HURST','TX','76053','7547','CY','48439','1986-10-31','M','U',':RET:2106-3','N','021','DEN','1022065','33348TX002000201','2014-01-01','2013-12-09 16:34:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:32:11'),(2517,2052,'Y','18','021','EC','A','','','AC','0000736030','0000736030','MS00000136116','IL','1','POLK','CHERRI','NAN','','','34','415985691','301 MAGOLINA DRIVE',0,'NEW ALBANY','MS','38652',NULL,'CY','28145','1955-12-01','F','U',':RET:2106-3','T','021','DEN','1135459','46300MS002000101','2014-01-01','2013-12-09 16:47:02','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,0,'2013-12-25 19:36:28'),(8843,7009,'Y','18','021','EC','A','','','AC','0000032002','0000032002','TX00000615233','IL','1','AHMED','AYAAN','','','','34','108747473','9050 MARKVILLE DR',0,'DALLAS','TX','75243',NULL,'CY','48113','1968-06-18','F','U',NULL,'N','021','DEN','1699067','33348TX002000201','2014-01-01','2013-12-17 22:57:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:00:48'),(21549,17213,'Y','18','021','EC','A','','','AC','0000289565','0000289565','OH00001844252','IL','1','Harmon','Michael','','','','34','379524888','2927 KINGSTON AVE',0,'DAYTON','OH','45420','2627','CY','39113','1954-11-18','M','M',':RET:2106-3','N','021','DEN','2757309','99734OH005000401','2014-03-01','2014-02-05 12:31:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-05 21:30:13'),(23341,18604,'Y','18','021','EC','A','','','AC','0000110556','0000110556','OH00001814449','IL','1','Bencina','Richard','','','','34','301440077','38278 Roselawn Street',0,'Willoughby','OH','44094',NULL,'CY','39085','1961-08-18','M','M',NULL,'N','021','HLT','3683295','52664OH151001305','2014-03-01','2014-02-12 21:48:13','827.00',NULL,NULL,'1363.22','536.22','R-OH011','OH0','490.97',NULL,0,'2014-02-13 22:00:38'),(25189,19980,'Y','18','021','EC','A','','','AC','0000971023','0000971023','TX00001853236','IL','1','Vandriver','Jason','','','','34','451916272','22800 BULVERDE RD',0,'SAN ANTONIO','TX','78261','3074','CY','48029','1981-12-04','M','R',':RET:2106-3','N','021','DEN','3463370','33348TX002000101','2014-04-01','2014-02-21 11:46:31','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2014-02-21 22:00:38'),(698,575,'Y','18','021','EC','A','','','AC','0000818559','0000818559','OH00000083822','IL','1','Jones','Jason','Lee','','','34','284744340','2600 State Route 136',0,'Hillsboro','OH','45133',NULL,'CY','39071','1977-11-08','M','U',':RET:2106-3','T','021','DEN','1515383','99734OH005000301','2014-01-01','2013-12-16 17:37:59','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:02:49'),(20674,16521,'N','01','021','EC','A',NULL,NULL,'','0001207349','0000257724','','IL','1','kersh','james','ray','','','34','425230352','32512 dog wood trail',0,'jackson','MS','39212',NULL,'CY','28049','1959-12-19','M','',':RET:2054-5','N','021','DEN','2991301','46300MS002000101','2014-03-01','2014-01-29 19:06:56',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-30 21:00:51'),(19238,15329,'Y','18','021','EC','A','','','AC','0001184911','0001184911','OH00001769481','31','1','Bragg','Frances','','','','34','271520666','P.O. Box 411',0,'St Paris','OH','43072',NULL,'CY','39021','1951-12-30','F','U',':RET:2106-3','N','021','DEN','1679113','99734OH005000301','2014-03-01','2014-01-20 10:37:40','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-01-21 08:46:36'),(1845,1511,'Y','18','021','EC','A','','','AC','0001239129','0001239129','OH00000990357','IL','1','Walk','Susan','','','','34','273522911','36600 S. Lakeshore Rd.',0,'Eastlake','OH','44095',NULL,'CY','39085','1951-11-23','F','U',':RET:2106-3','N','021','HLT','2232090','52664OH151001306','2014-01-01','2013-12-24 13:24:29','537.00',NULL,NULL,'722.61','185.61','R-OH011','OH0','722.61',NULL,0,'2013-12-25 18:57:44'),(18835,15001,'Y','18','021','EC','A','','','AC','0000830666','0000830666','OH00001751249','IL','1','spellacy','john','','','','34','283829855','1530 metzger rd.',0,'valley city','OH','44280',NULL,'CY','39103','1966-09-12','M','U',':RET:2106-3','T','021','HLT','2979763','52664OH151001305','2014-02-01','2014-01-15 21:19:18','234.00',NULL,NULL,'400.84','166.84','R-OH012','OH0','400.84',NULL,0,'2014-01-17 03:36:11'),(6604,5237,'Y','18','024','14','A','','','TE','0000378543','0000378543','','IL','1','Browder','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-20','F','',NULL,NULL,NULL,'','523793','','2013-12-11','2013-12-11 09:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:53:37'),(17765,14193,'N','19','021','EC','A',NULL,NULL,'','0000500409','0000700401','','IL','1','Thompson','Emily','J','','','34','191806598','105 STONE TRACE DR',0,'MOUNT ORAB','OH','45154','8568','CY','39015','2002-06-13','F','',':RET:2106-3','N','021','HLT','2189903','92036OH004000601','2014-02-01','2014-01-13 13:53:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-14 01:33:35'),(14857,11862,'Y','18','021','EC','A','','','AC','0000323502','0000323502','OH00000315287','31','1','tarulli','jason','','','','34','283687776','PO BOX 4655',0,'Akron','OH','44310',NULL,'CY','39153','1974-01-30','M','R',':RET:2106-3','N','021','HLT','1376969','52664OH152000901','2014-01-01','2013-12-23 20:06:33','0.00',NULL,NULL,'206.14','206.14','R-OH012','OH0','206.14',NULL,1,'2013-12-29 11:15:14'),(7251,5751,'Y','18','021','EC','A','','','AC','0000044406','0000044406','LA00000552783','IL','1','ALLEN','LISA','','','','34','438418691','4020 DELAWARE STREET',0,'BATON ROUGE','LA','70805',NULL,'CY','22033','1965-05-10','F','U',':RET:2054-5','N','021','DEN','41108','18575LA002000201','2014-01-01','2013-12-14 16:36:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:01:55'),(7758,6145,'N','01','021','EC','A',NULL,NULL,'','0000654589','0000328407','','IL','1','ARABETO','ANWARO','','','','34','406597575','3746 TANAGER DR',0,'COLUMBUS','OH','43230','1181','CY','39049','1983-10-17','F','',':RET:2054-5','N','021','DEN','2426230','99734OH005000401','2014-01-01','2013-12-20 17:20:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:41'),(24774,19653,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000141486','','S1','1','ANAYA','GEORGE','ANTONIO','','','34','283049387','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1999-07-16','M','',':RET:2106-3','N','021','DEN','2983888','99734OH005000401','2014-04-01','2014-02-19 12:55:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:44:40'),(25013,19835,'N','01','021','EC','A',NULL,NULL,'','0000116634','0000199720','','IL','1','Trotter','William','','','','34','423983643','901 GUSTAVUS LN',0,'COLUMBUS','OH','43205','1212','CY','39049','1962-01-30','M','',':RET:2106-3','N','021','DEN','2958112','99734OH005000301','2014-04-01','2014-02-19 19:25:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:00:53'),(25188,19979,'Y','18','024','14','A','','','TE','0000971023','0000971023','','IL','1','Vandriver','Jason',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-04','M','',NULL,NULL,NULL,'','3041877','','2014-02-21','2014-02-21 11:46:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-21 22:00:38'),(28850,22830,'Y','18','021','EC','A','','','AC','0000119131','0000119131','OH00003035388','IL','1','GUISINGER','ERIN','','','','34','275886818','30630 DROUILLARD RD',0,'WALBRIDGE','OH','43465',NULL,'CY','39173','1978-06-17','F','M',NULL,'N','021','HLT','4012512','92036OH003002606','2014-04-01','2014-03-09 17:00:32','162.00',NULL,NULL,'248.83','86.83','R-OH001','OH0','248.83',NULL,0,'2014-03-09 21:01:18'),(6327,5017,'Y','18','021','EC','A','','','AC','0000971449','0000971449','OH00000407789','IL','1','WOLFORD','RONDA','','','','34','286584659','711 SWANS ROAD NE',0,'NEWARK','OH','43055',NULL,'CY','39089','1955-10-19','F','M',':RET:2106-3','N','021','DEN','491025','99734OH005000401','2014-01-01','2013-12-11 11:24:20','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:46:31'),(20885,16690,'Y','18','021','EC','A','','','AC','0000378613','0000378613','OH00001539493','IL','1','Taylor','Linda','','','','34','282743545','3075 PARK RD',0,'GOSHEN','OH','45122','8901','CY','39025','1957-10-21','F','M',NULL,'N','021','HLT','3678163','92036OH006000601','2014-03-01','2014-01-31 11:39:18','348.00',NULL,NULL,'397.18','49.18','R-OH005','OH0','397.18',NULL,0,'2014-01-31 21:01:10'),(20144,16074,'N','01','021','EC','A',NULL,NULL,'','0000767431','0000725085','','IL','1','Fosu','Janet','','','','34','052845982','2953 MORALITY DR',0,'COLUMBUS','OH','43231','8830','CY','39049','1969-09-25','F','',':RET:2054-5','N','021','DEN','3314441','99734OH005000401','2014-03-01','2014-01-27 16:11:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:01:00'),(18418,14693,'N','01','021','EC','A',NULL,NULL,'','0001242688','0002117303','','IL','1','Thomas','Alexander','','','','34','435337823','4653 STEPHEN GIRARD AVE',0,'NEW ORLEANS','LA','70126','4767','CY','22071','1962-12-16','M','',':RET:2054-5','N','021','DEN','1596556','18575LA002000201','2014-02-01','2014-01-14 23:26:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:45:51'),(6094,4830,'N','01','021','EC','A',NULL,NULL,'','0000398584','0000552599','','IL','1','FOK','SHING','','','','34','274944102','7538 TOURNAMENT DR',0,'WATERVILLE','OH','43566','9795','CY','39095','1963-04-13','F','',':RET:2034-7','N','021','HLT','793431','92036OH002002601','2014-01-01','2013-12-01 15:17:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','402.18',NULL,0,'2013-12-26 00:02:50'),(6642,5270,'Y','18','021','EC','A','','','AC','0000210315','0000210315','TX00000539498','IL','1','Morrow','Jason','Alan','','','34','466833201','2509 JUGLAN DR',0,'VICTORIA','TX','77901','4320','CY','48469','1987-05-24','M','U',':RET:2106-3','T','021','DEN','1219535','33348TX002000201','2014-01-01','2013-11-12 04:15:56','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-26 01:00:20'),(15247,12187,'Y','18','021','EC','A','','','AC','0000045778','0000045778','OH00000569816','IL','1','wormell','scott','','','','34','298689860','3630 GLENCAIRN RD',0,'SHAKER HEIGHTS','OH','44122','5031','CY','39035','1969-08-03','M','U',':RET:1002-5^:RET:2106-3','T','021','HLT','2467602','92036OH001000801','2014-02-01','2013-12-30 10:29:36','0.00',NULL,NULL,'453.07','453.07','R-OH011','OH0','453.07',NULL,0,'2014-01-01 12:08:51'),(7794,6172,'Y','18','021','EC','A','','','AC','0001140986','0001140986','TX00000088994','IL','1','skinner','jeanette','','','','34','463559670','2461 VanZandt cr 1519',0,'grand saline','TX','75140',NULL,'CY','48467','1967-08-28','F','U',':RET:2106-3','N','021','DEN','1691999','33348TX002000201','2014-01-01','2013-12-20 15:33:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:29'),(9043,7175,'Y','18','021','EC','A','','','AC','0000690732','0000690732','OH00000926190','IL','1','Flower','Michelle','','','','34','268822818','226 SELDEN AVE',0,'AKRON','OH','44301','2949','CY','39153','1978-09-29','F','U',':RET:2106-3','N','021','HLT','1909902','52664OH151001305','2014-01-01','2013-12-18 15:39:43','149.00',NULL,NULL,'272.52','123.52','R-OH012','OH0','272.52',NULL,0,'2013-12-26 04:05:52'),(9220,7315,'Y','18','021','EC','A','','','AC','0000699262','0000699262','OH00000839882','IL','1','Borsa','Pamela','','','','34','172461826','7269 Drake Stateline Rd',0,'Burghill','OH','44404',NULL,'CY','39155','1953-03-24','F','U',':RET:2106-3','N','021','HLT','2234103','92036OH005003201','2014-01-01','2013-12-18 11:19:11','323.00',NULL,NULL,'656.92','333.92','R-OH013','OH0','656.92',NULL,0,'2013-12-26 04:10:10'),(23801,18939,'Y','18','021','EC','A','','','AC','0001192716','0001192716','OH00002837777','IL','1','Craddock','Gary','','','','34','295444280','6979 EGYPT RD',0,'MEDINA','OH','44256','8595','CY','39103','1961-06-19','M','M',':RET:2106-3','N','021','HLT','3356420','52664OH151001304','2014-03-01','2014-02-14 15:54:46','595.00',NULL,NULL,'890.25','295.25','R-OH012','OH0','435.31',NULL,0,'2014-02-14 21:31:30'),(25536,20257,'Y','18','021','EC','A','','','AC','0000493381','0000493381','TX00002283555','IL','1','Casburn','Mark','','','','34','453987071','560 SCENIC LOOP',0,'HAWKINS','TX','75765','2505','CY','48499','1953-07-09','M','M',':RET:2106-3','T','021','DEN','2880521','33348TX002000201','2014-04-01','2014-02-23 12:51:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 08:00:07'),(29089,23024,'Y','18','021','EC','A','','','AC','0000943448','0000943448','TX00002853578','IL','1','Jimenez','Iris','Idalia','','','34','451691147','404 N. East Lane',0,'Uvalde','TX','78801',NULL,'CY','48463','1984-07-07','F','U',NULL,'N','021','DEN','2978320','33348TX002000101','2014-04-01','2014-03-10 12:05:19','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-03-10 21:02:08'),(29130,23061,'N','19','021','EC','A',NULL,NULL,'','0000598820','0000812092','','IL','1','Estep','Chloe','','','','34','285989284','5985 TWITCHELL RD',0,'SPRINGFIELD','OH','45502','9273','CY','39023','1995-08-19','F','',':RET:2106-3','N','021','HLT','3929464','92036OH004000501','2014-04-01','2014-03-10 10:51:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','121.38',NULL,0,'2014-03-10 21:02:36'),(5666,4495,'Y','18','021','EC','A','','','AC','0001088238','0001088238','OH00000229898','IL','1','BELVIN','Vanessa','ANN','','','34','282564114','1515 AVERY ST',0,'CUYAHOGA FALLS','OH','44221','4934','CY','39153','1953-12-01','F','M',':RET:2106-3','N','021','HLT','1053591','52664OH151001301','2014-01-01','2013-11-26 16:05:58','272.00',NULL,NULL,'605.24','333.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 23:31:54'),(19899,15873,'Y','18','021','EC','A','','','AC','0000679562','0000679562','OH00001799515','IL','1','Sherman','Shannon','','','','34','284889987','600 GLENWOOD RD',0,'ROSSFORD','OH','43460','1508','CY','39173','1976-11-17','F','M',NULL,'N','021','HLT','2925974','92036OH002002601','2014-03-01','2014-01-23 20:08:15','315.00',NULL,NULL,'995.57','680.57','R-OH001','OH0','278.78',NULL,0,'2014-01-24 21:00:55'),(3137,2522,'Y','18','021','EC','A','','','AC','0000554116','0000554116','TX00000459526','IL','1','Bernache','Oscar','','','','34','525812290','2911 MONTROSE ST',0,'SAN ANTONIO','TX','78223','2739','CY','48029','1979-02-07','M','M',':RET:2106-3','N','021','DEN','511840','33348TX002000101','2014-01-01','2013-11-18 15:21:12','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 20:30:43'),(16153,12935,'Y','18','021','EC','A','','','AC','0000171245','0000171245','OH00001722649','IL','1','Malshe','Amol','','','','34','256899022','4053 Magnolia Way',0,'Beavercreek','OH','45431',NULL,'CY','39057','1977-10-31','M','R',NULL,'N','021','HLT','1924232','92036OH004000501','2014-02-01','2014-01-03 16:23:32','0.00',NULL,NULL,'235.10','235.10','R-OH003','OH0','235.10',NULL,0,'2014-01-04 02:06:18'),(14204,11327,'Y','18','021','EC','A','','','AC','0000847198','0000847198','TX00000415173','31','1','CULVER','DANNY','','','','34','458841688','PO BOX 849',0,'VAN','TX','75790',NULL,'CY','48467','1949-11-12','M','U',NULL,'N','021','DEN','1582316','33348TX002000201','2014-02-01','2013-12-26 13:43:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:04:19'),(13815,11027,'Y','18','021','EC','A','','','AC','0000155776','0000155776','OH00000941621','IL','1','Lewis','Heather','','','','34','407392844','24 EVERGREEN CIR',0,'CINCINNATI','OH','45215','1369','CY','39061','1963-12-25','F','R',NULL,'N','021','HLT','1970733','92036OH005001201','2014-01-01','2013-12-23 15:05:30','0.00',NULL,NULL,'383.39','383.39','R-OH004','OH0','383.39',NULL,0,'2013-12-26 13:11:42'),(7439,5887,'Y','18','021','EC','A','','','AC','0000342718','0000342718','OH00000956171','IL','1','NETTING','THOMAS','','','','34','294580246','1029 JEFFERSON AVE',0,'AKRON','OH','44302',NULL,'CY','39153','1955-12-05','M','U',':RET:2106-3','N','021','HLT','221541','52664OH151001304','2014-01-01','2013-12-15 15:33:42','384.00',NULL,NULL,'568.22','184.22','R-OH012','OH0','568.22',NULL,0,'2013-12-26 02:30:21'),(24817,19677,'N','19','021','EC','A',NULL,NULL,'','0000757194','0000105425','','IL','1','Burdick','Isabella','','','','34','294086988','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','2004-01-08','F','',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-20 04:50:18'),(28264,22365,'Y','18','024','14','A','','','TE','0000938123','0000938123','','IL','1','Nevling','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-08-10','M','',NULL,NULL,NULL,'','1770785','','2014-03-31','2014-03-06 22:56:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-07 21:00:18'),(28903,22877,'Y','18','021','EC','A','','','AC','0001044359','0001044359','TX00003832762','IL','1','Morales','Virginia','','','','34','452336091','1604 Bill Ogden',0,'El Paso','TX','79936',NULL,'CY','48141','1962-06-03','F','U',':RET:2106-3','N','021','DEN','3771044','33348TX002000201','2014-04-01','2014-03-10 17:05:58','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-10 21:00:22'),(29004,22955,'Y','18','021','EC','A','','','AC','0000728782','0000728782','OH00003351316','IL','1','Dawson','Don','','','','34','299960894','137 W MYRTLE AVE',0,'YOUNGSTOWN','OH','44507','1013','CY','39099','1994-05-06','F','U',NULL,'N','021','HLT','3805394','52664OH152000901','2014-04-01','2014-03-10 00:33:50','61.00',NULL,NULL,'117.62','56.62','R-OH013','OH0','117.62',NULL,0,'2014-03-10 21:01:20'),(6443,5109,'Y','18','021','EC','A','','','AC','0000957887','0000957887','OH00000317068','IL','1','Raitz','Robin','','','','34','302741334','3138 VAN FLEET PKWY',0,'TOLEDO','OH','43615','1435','CY','39095','1963-11-23','F','M',':RET:1002-5^:RET:2106-3','N','021','HLT','322855','92036OH004002601','2014-01-01','2013-12-10 18:44:04','75.00',NULL,NULL,'280.03','205.03','R-OH001','OH0','280.03',NULL,0,'2013-12-26 00:49:30'),(21636,17276,'Y','18','021','EC','A','','','AC','0000793570','0000793570','TX00002167778','IL','1','Fraga','Maria','','','','34','640806501','1412 N NAVIDAD ST',0,'SAN ANTONIO','TX','78207','1261','CY','48029','1958-11-04','F','M',NULL,'N','021','DEN','2832869','33348TX002000201','2014-03-01','2014-02-05 12:59:41','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-05 21:30:43'),(3131,2516,'Y','18','021','EC','A','','','AC','0000288265','0000288265','OH00000544883','IL','1','Bradshaw','Monte','','','','34','277782194','89 PARMELEE DR',0,'HUDSON','OH','44236','3425','CY','39153','1968-03-27','M','U',NULL,'N','021','DEN','522048','99734OH005000401','2014-01-01','2013-10-13 08:33:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:30:31'),(21018,16795,'Y','18','021','EC','A','','','AC','0000664211','0000664211','OH00001601639','IL','1','Bien','Douglas','','','','34','289763142','6210 NUEVELLE LN',0,'CINCINNATI','OH','45243','2355','CY','39061','1978-11-27','M','R',':RET:2106-3','N','021','DEN','2821349','99734OH005000401','2014-03-01','2014-02-01 10:47:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-01 19:00:38'),(19471,15520,'Y','18','021','EC','A','','','AC','0000039962','0000039962','TX00002215990','IL','1','Serrano','Isabel','','','','34','548638452','3213 SW 9th Ave',0,'Amarillo','TX','79106',NULL,'CY','48375','1980-08-30','F','U',':RET:2106-3','N','021','DEN','3284051','33348TX002000201','2014-03-01','2014-01-22 16:44:35','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-23 03:01:59'),(3646,2918,'Y','18','021','EC','A','','','AC','0001018212','0001018212','OH00000990920','IL','1','Morehead','Laura','','','','34','273905176','758.5 Park St',0,'Columbus','OH','43215',NULL,'CY','39049','1983-05-06','F','U',':RET:2106-3','T','021','DEN','574114','99734OH005000401','2014-01-01','2013-12-13 18:07:09','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:30:30'),(3829,3066,'N','01','021','EC','A',NULL,NULL,'','0001173199','0000566601','','IL','1','MANUEL','DAVID','L','','','34','375603103','7292 FAIR RIDGE RD',0,'HILLSBORO','OH','45133','6677','CY','39071','1953-06-25','M','',':RET:2106-3','N','021','DEN','572983','99734OH005000301','2014-01-01','2013-12-13 16:12:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:35:08'),(4538,3596,'Y','18','021','EC','A','','','AC','0000621434','0000621434','TX00000996129','IL','1','Contreras','Eleno','','','','34','452934252','422 E RIX ST',0,'TYLER','TX','75701','1928','CY','48423','1961-05-29','M','U',NULL,'N','021','DEN','452077','33348TX002000201','2014-01-01','2013-12-12 17:15:16','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 22:04:13'),(6927,5499,'Y','18','021','EC','A','','','AC','0001110362','0001110362','OH00000681425','IL','1','Halbert','James','','','','34','289501244','1724 GOODMAN AVE',0,'CINCINNATI','OH','45239','4845','CY','39061','1952-09-08','M','U',':RET:2054-5','N','021','DEN','1518630','99734OH005000401','2014-01-01','2013-12-24 19:29:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:24'),(22507,17967,'Y','18','021','EC','A','','','AC','0000957939','0000957939','OH00002174415','IL','1','Stahl','Nicole','','','','34','302900694','2085 W Clifton Ave',0,'Cincinnati','OH','45219',NULL,'CY','39061','1987-05-04','F','U',':RET:2106-3','N','021','HLT','3322892','92036OH005001205','2014-03-01','2014-02-09 19:00:25','110.00',NULL,NULL,'219.82','109.82','R-OH004','OH0','219.82',NULL,0,'2014-02-10 21:31:15'),(23792,18933,'Y','18','021','EC','A','','','AC','0000153413','0000153413','OH00002258590','IL','1','McAdoo','Allen','','','','34','271589568','324 Huntsford Drive',0,'Macedonia','OH','44056',NULL,'CY','39153','1957-06-05','M','U',NULL,'N','021','HLT','2869404','52664OH151001304','2014-03-01','2014-02-14 10:18:59','391.00',NULL,NULL,'661.89','270.89','R-OH012','OH0','520.28',NULL,0,'2014-02-14 21:31:25'),(25741,20416,'Y','18','021','EC','A','','','AC','0001016904','0001016904','OH00002523725','IL','1','Arnold','Gregory','','','','34','289540032','4250 E 151ST ST',0,'CLEVELAND','OH','44128','1907','CY','39035','1955-06-02','M','U',':RET:2054-5','N','021','DEN','3506062','99734OH005000401','2014-04-01','2014-02-24 13:03:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 09:30:40'),(27183,21522,'N','01','021','EC','A',NULL,NULL,'','0000139641','0000743046','','IL','1','Espinosa','Tania','','','','34','384872867','648 North Flores St',0,'Robstown','TX','78380',NULL,'CY','48355','1971-04-02','F','',NULL,'N','021','DEN','3388126','33348TX002000201','2014-04-01','2014-03-03 14:05:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:11'),(27851,22029,'Y','18','021','EC','A','','','AC','0000509118','0000509118','TX00002683529','IL','1','FLORES','ANA','MARIA','','','34','458393993','2511 E 28TH ST',0,'MISSION','TX','78574','1979','CY','48215','1969-10-12','F','M',NULL,'N','021','DEN','3326083','33348TX002000101','2014-04-01','2014-03-05 14:36:02','0.00',NULL,NULL,'94.59','94.59','R-TX015','TX0','25.02',NULL,0,'2014-03-05 21:32:13'),(28408,22478,'Y','18','021','EC','A','','','AC','0000726189','0000726189','OH00002781858','IL','1','PINO','REGINA','ANNE','','','34','301406771','627 broadway blvd',0,'steubenville','OH','43952',NULL,'CY','39081','1951-01-13','F','M',NULL,'N','021','DEN','3173446','99734OH005000401','2014-04-01','2014-03-07 11:09:18','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-03-07 21:30:55'),(218,183,'Y','18','021','EC','A','','','AC','0000468883','0000468883','LA00000751113','IL','1','Ballen','Samuel','David','','','34','140783890','200 CARONDELET ST',0,'NEW ORLEANS','LA','70130','2910','CY','22071','1985-02-10','M','U',':RET:2106-3','N','021','DEN','775472','18575LA002000201','2014-01-01','2013-12-05 11:03:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:20:41'),(3553,2852,'Y','18','021','EC','A','','','AC','0001248327','0001248327','OH00000890089','IL','1','EVERETT','KATHRYN','','','','34','273585211','3327 ANN AVE',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1956-08-05','F','U',':RET:2106-3','T','021','HLT','2148317','52664OH151001305','2014-01-01','2013-12-22 09:36:18','541.00',NULL,NULL,'704.90','163.90','R-OH011','OH0','704.90',NULL,0,'2013-12-25 21:22:05'),(3489,2801,'Y','18','021','EC','A','','','AC','0000886899','0000886899','OH00000606584','31','1','Makowski','Stephan','Richard','','Jr','34','284865055','po box 742',0,'Parkman','OH','44080',NULL,'CY','39055','1987-05-14','M','U',':RET:2106-3','N','021','DEN','2174328','99734OH005000401','2014-01-01','2013-12-22 13:06:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:23'),(6393,5068,'Y','18','021','EC','A','','','AC','0000355013','0000355013','OH00001233064','IL','1','Bressman','David','Allan','','','34','040449354','8633 BROADACRE DR',0,'POWELL','OH','43065','9010','CY','39049','1965-09-30','M','M',':RET:2106-3','N','021','DEN','622071','99734OH005000301','2014-01-01','2013-12-11 11:46:04','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:48:12'),(22057,17607,'Y','18','021','EC','A','','','AC','0000390834','0000390834','TX00001534751','IL','1','BOCCUTO','PHILLIP','','','','34','575860804','667 WHITE CLIFFS DR',0,'EL PASO','TX','79912','2300','CY','48141','1958-11-12','M','U',':RET:2106-3','N','021','DEN','2974101','33348TX002000201','2014-03-01','2014-02-07 23:11:21','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-08 19:00:08'),(25663,20360,'Y','18','021','EC','A','','','AC','0001298660','0001298660','LA00002820664','IL','1','ZULETA','MAURICIO','','','','34','629601182','3102 GRASSY LAKE DR',0,'BATON ROUGE','LA','70816','3770','CY','22033','1956-11-04','M','M',NULL,'N','021','DEN','3355227','18575LA002000101','2014-04-01','2014-02-21 19:55:58','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-02-26 08:30:46'),(27768,21959,'Y','18','021','EC','A','','','AC','0002389526','0002389526','LA00003220524','IL','1','SHELBY','SYLVIA','','','','34','436860815','8059 DIXIE BLANCHARD RD.',0,'TREEPORT','LA','71107',NULL,'CY','22017','1962-08-09','F','U',NULL,'N','021','DEN','2922995','18575LA002000201','2014-04-01','2014-03-05 15:43:50','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-03-05 21:31:25'),(28124,22257,'Y','18','021','EC','A','','','AC','0000957949','0000957949','OH00002633536','IL','1','Grove','Berniel','','','','34','565688115','2235 FAIRWAY BLVD',0,'HUDSON','OH','44236','1355','CY','39153','1950-06-05','F','M',':RET:2106-3','N','021','HLT','3727056','52664OH151001304','2014-04-01','2014-03-05 20:34:36','388.00',NULL,NULL,'658.32','270.32','R-OH012','OH0','658.32',NULL,0,'2014-03-06 21:02:21'),(4885,3874,'Y','18','021','EC','A','','','AC','0000040908','0000040908','OH00000745428','IL','1','Cook','Teresa','A','','','34','296545176','1866 SURREY TRL',0,'BELLBROOK','OH','45305','2714','CY','39057','1953-04-07','F','U',NULL,'T','021','DEN','774201','99734OH005000401','2014-01-01','2013-10-04 13:26:05','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 22:31:21'),(20428,16315,'N','01','021','EC','A',NULL,NULL,'','0001046867','0000411150','','IL','1','Touassi','Sanaa','','','','34','283063382','5738 VILLAS CREEK DR',0,'MASON','OH','45040','2456','CY','39165','1978-07-08','F','',':RET:2106-3','N','021','DEN','2223794','99734OH005000301','2014-03-01','2014-01-29 12:21:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:34'),(2956,2380,'Y','18','021','EC','A','','','AC','0000166367','0000166367','TX00000090914','IL','1','NELSON','SHANDRA','','','','34','459063687','3050 NORTHSHORE DRIVE',0,'MAY','TX','76857',NULL,'CY','48049','1951-03-19','F','M',':RET:2106-3','N','021','DEN','465149','33348TX002000201','2014-01-01','2013-12-06 11:40:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 20:16:38'),(19466,15516,'Y','18','021','EC','A','','','AC','0000807316','0000807316','TX00001358760','IL','1','Ray','Carolyn','','','','34','451130428','5180 County Road 4833',0,'Larue','TX','75770',NULL,'CY','48213','1957-06-18','F','M',NULL,'N','021','DEN','1461376','33348TX002000201','2014-03-01','2014-01-22 10:56:36','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-23 03:01:58'),(3637,2910,'N','01','021','EC','A',NULL,NULL,'','0001218349','0000123016','','IL','1','McNeil','Willie','','','','34','428043836','4960 Gaylyn Drive',0,'Jackson','MS','39209',NULL,'CY','28049','1964-05-23','M','',':RET:2054-5','N','021','DEN','732120','46300MS002000201','2014-01-01','2013-12-13 10:56:15',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 21:30:16'),(18980,15121,'N','01','021','EC','A',NULL,NULL,'','0000228366','0000711404','','IL','1','WHITLATCH','LORI','A','','','34','290748332','537 FOWLER ST',0,'NEW LEXINGTON','OH','43764',NULL,'CY','39127','1973-04-10','F','',':RET:2106-3','N','021','DEN','2237610','99734OH005000301','2014-03-01','2014-01-17 13:47:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:06'),(17858,14266,'Y','18','024','14','A','','','TE','0000172417','0000172417','','IL','1','Line','Steven',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-06-13','M','',NULL,NULL,NULL,'','1394281','','2014-01-14','2014-01-14 11:16:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:06:09'),(4339,3447,'Y','18','021','EC','A','','','AC','0000048176','0000048176','OH00000234230','IL','1','Sexton','JoAnn','','','','34','290482495','4900 CALEB HILL RD',0,'HILLSBORO','OH','45133','8725','CY','39071','1950-07-22','F','M',':RET:2106-3','N','021','HLT','2042893','92036OH003000605','2014-01-01','2013-12-17 12:51:29','1181.00',NULL,NULL,'1402.45','221.45','R-OH005','OH0','661.77',NULL,0,'2013-12-25 21:53:14'),(6842,5425,'Y','18','021','EC','A','','','AC','0001179578','0001179578','OH00000728760','IL','1','Cantrell','Tyler','Earl','','','34','286821936','65 W Main St',0,'Sardinia','OH','45171',NULL,'CY','39071','1983-09-28','M','M',':RET:2106-3','N','021','HLT','1117234','92036OH005000601','2014-01-01','2013-11-14 11:46:43','296.00',NULL,NULL,'613.33','317.33','R-OH005','OH0','243.66',NULL,0,'2013-12-26 01:31:09'),(13189,10522,'Y','18','021','EC','A','','','AC','0000038344','0000038344','TX00000179996','IL','1','Graschel','Philip',NULL,NULL,NULL,NULL,NULL,'7431 AVENUE M',0,'SANTA FE','TX','77510','7512','CY','48167','1983-01-18','M','U',NULL,'N','021','DEN','2292040','33348TX002000101','2014-01-01','2013-12-23 01:01:32','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:34'),(13347,10659,'Y','18','021','EC','A','','','AC','0000449353','0000449353','TX00000751875','IL','1','MCBRIDE','DIEDRICH','','','','34','452379218','1009 COUNTY RD',0,'PITTSBURGH','TX','75686',NULL,'CY','48063','1961-12-07','M','U',':RET:2054-5','N','021','DEN','1706105','33348TX002000201','2014-01-01','2013-12-23 18:57:36','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:59:06'),(22211,17728,'Y','18','021','EC','A','','','AC','0001235226','0001235226','OH00002477333','IL','1','HAILE','TEWOLDE','','','','34','301904325','6869 TUMBLEWEED LN',0,'CANAL WINCHESTER','OH','43110','7807','CY','39049','1956-11-29','M','U',NULL,'N','021','DEN','3655403','99734OH005000401','2014-03-01','2014-02-09 17:45:02','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-09 19:00:20'),(22977,18320,'Y','18','021','EC','A','','','AC','0000961904','0000961904','OH00002571328','IL','1','Justice','Alice','M','','','34','282560426','39020 CENTER RIDGE RD',0,'NORTH RIDGEVILLE','OH','44039','2742','CY','39093','1963-12-23','F','U',':RET:2106-3','N','021','DEN','3143196','99734OH005000301','2014-03-01','2014-02-11 19:31:10','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:30:06'),(23662,18840,'N','01','021','EC','A',NULL,NULL,'','0000226116','0000186128','','IL','1','Chui','Heather','','','','34','507219846','789 EIFFEL DR',0,'PLANO','TX','75023','7062','CY','48085','1987-12-29','F','',':RET:2106-3','N','021','DEN','2804020','33348TX002000201','2014-03-01','2014-02-14 12:46:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-14 21:30:20'),(27203,21539,'Y','18','021','EC','A','','','AC','0000076492','0000076492','TX00002863258','IL','1','Palm','Mark','','','','34','190586154','415 N AVENUE G',0,'SHINER','TX','77984','5703','CY','48285','1965-09-21','M','M',':RET:2106-3','N','021','DEN','3680098','33348TX002000201','2014-04-01','2014-03-03 17:33:47','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:23'),(27723,21924,'Y','18','024','14','A','','','TE','0000277951','0000277951','','IL','1','Trevino','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-03-02','F','',NULL,NULL,NULL,'','2692261','','2014-03-05','2014-03-05 14:36:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:59'),(28273,22374,'Y','18','024','14','A','','','TE','0000458256','0000458256','','IL','1','CASTILLO','DEADIRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-13','F','',NULL,NULL,NULL,'','2210345','','2014-03-31','2014-03-07 14:55:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-07 21:00:22'),(3100,2491,'Y','18','021','EC','A','','','AC','0000084016','0000084016','OH00000043961','IL','1','FLAUGHER','CAROL','','','','34','407926291','807 JACK ROUSH WAY',0,'MANCHESTER','OH','45144','1405','CY','39001','1960-10-24','F','M',NULL,'N','021','HLT','1011368','92036OH005000605','2014-01-01','2013-12-06 15:14:37','869.00',NULL,NULL,'898.36','29.36','R-OH005','OH0','437.93',NULL,0,'2013-12-25 20:20:15'),(20073,16012,'Y','18','021','EC','A','','','AC','0001017779','0001017779','TX00002223701','IL','1','Alvarado','Mario','','','','34','641483152','2800 S COUNTY ROAD 1213',0,'MIDLAND','TX','79706','3423','CY','48329','1969-02-07','M','M',':RET:2106-3','N','021','DEN','3489018','33348TX002000201','2014-03-01','2014-01-27 15:08:14','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-01-27 21:00:19'),(18866,15028,'Y','18','021','EC','A','','','AC','0002003897','0002003897','LA00001995068','IL','1','Roche','Carrie','','','','34','434636929','12021 LAKE SHERWOOD AVE S',0,'BATON ROUGE','LA','70816','4447','CY','22033','1983-06-17','F','U',':RET:2106-3','N','021','DEN','2598660','18575LA002000201','2014-03-01','2014-01-16 10:21:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-17 03:36:22'),(18347,14648,'N','19','021','EC','A',NULL,NULL,'','0000234068','0000262749','','IL','1','Damon','Christopher','','','','34','286944370','8068 Quail Meadow Lane',0,'West Chester','OH','45069',NULL,'CY','39017','1989-11-06','M','',':RET:2106-3','T','021','DEN','1469552','99734OH005000301','2014-02-01','2014-01-14 19:15:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:20'),(17855,14263,'Y','18','021','EC','A','','','AC','0000144243','0000144243','OH00002514481','IL','1','Duckworth','Lee','','','','34','272506117','7224 CREEKVIEW DR',0,'CINCINNATI','OH','45247','2594','CY','39061','1950-06-07','M','M',':RET:2106-3','N','021','DEN','2498666','99734OH005000401','2014-02-01','2014-01-14 10:55:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:06:08'),(5868,4656,'Y','18','021','EC','A','','','AC','0000776433','0000776433','OH00000811920','IL','1','mcgreevy','kevin','','','','34','294863575','3148 SHARON COPLEY RD',0,'MEDINA','OH','44256','9725','CY','39103','1981-04-22','M','U',':RET:2106-3','N','021','HLT','2206975','52664OH152000901','2014-01-01','2013-12-24 00:17:41','103.00',NULL,NULL,'193.23','90.23','R-OH012','OH0','193.23',NULL,0,'2013-12-25 23:49:08'),(7332,5808,'N','19','021','EC','A',NULL,NULL,'','0000491858','0000047074','','IL','1','Maus','Nickolas','Aaron','','','34','284153323','822 BOLENDER RD',0,'MOSCOW','OH','45153','9650','CY','39025','2009-08-07','M','',':RET:2106-3','N','021','HLT','711943','92036OH003000601','2014-01-01','2013-12-14 14:54:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-26 02:03:50'),(7869,6226,'N','19','021','EC','A',NULL,NULL,'','0000328405','0000366275','','IL','1','Miller','Collin','P','','','34','285066645','6987 BEERY RD',0,'RAVENNA','OH','44266','9120','CY','39133','2001-07-31','M','',':RET:2106-3','N','021','DEN','2279031','99734OH005000301','2014-01-01','2013-12-20 15:42:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:10'),(22280,17785,'Y','18','021','EC','A','','','AC','0000868266','0000868266','OH00001584437','IL','1','RICHARDSON','BARBARA','','','','34','298562677','5626 GARDENHILL LN',0,'CINCINNATI','OH','45232','1206','CY','39061','1956-06-05','F','U',':RET:2054-5','N','021','DEN','3555488','99734OH005000401','2014-03-01','2014-01-29 15:52:22','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-10 11:00:21'),(26828,21263,'Y','18','024','14','A','','','TE','0001203273','0001203273','','IL','1','Civitarese','Frank',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-11-25','M','',NULL,NULL,NULL,'','3601019','','2014-03-01','2014-03-01 14:37:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-01 21:00:38'),(28515,22565,'N','01','021','EC','A',NULL,NULL,'','0000500463','0000226072','','IL','1','Cunningham','Karin','M','','','34','296905607','4643 BLUEJAY CT',0,'CINCINNATI','OH','45244','1178','CY','39025','1984-03-22','F','',':RET:2106-3','N','021','HLT','3116203','92036OH001000601','2014-04-01','2014-03-06 20:49:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.90',NULL,0,'2014-03-07 21:31:56'),(965,792,'Y','18','021','EC','A','','','AC','0000036804','0000036804','TX00000721800','IL','1','thiagarajan','shrivatssa','','','','34','635966741','732 lake carolyn parkway',0,'irving','TX','75039',NULL,'CY','48113','1980-07-04','M','M',':RET:2029-7','N','021','DEN','425581','33348TX002000201','2014-01-01','2013-10-31 10:07:42','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:09:53'),(5438,4320,'Y','18','021','EC','A','','','AC','0001999940','0001999940','LA00000914503','IL','1','Naquin','Gordon','','','','34','433742595','2108 TEZCUCO LN',0,'MARRERO','LA','70072','5478','CY','22051','1955-06-13','M','U',NULL,'N','021','DEN','1724957','18575LA002000101','2014-01-01','2013-12-19 16:55:10','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:52'),(19114,15230,'Y','18','021','EC','A','','','AC','0001183547','0001183547','OH00002282756','IL','1','Greer','Dustin','','','','34','295844441','2605 Aberdeen Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1985-11-27','M','M',':RET:2106-3','N','021','HLT','1651645','92036OH005001501','2014-03-01','2014-01-18 10:03:56','259.00',NULL,NULL,'599.08','340.08','R-OH002','OH0','239.24',NULL,0,'2014-01-21 08:44:47'),(16907,13528,'Y','18','021','EC','A','','','AC','0000380075','0000380075','OH00002248982','IL','1','Kramer','Nicholas','','','','34','294865729','11813 Stone Mill Rd',0,'Cincinnati','OH','45251',NULL,'CY','39061','1984-09-17','M','M',':RET:2106-3','N','021','DEN','2192580','99734OH005000401','2014-02-01','2014-01-09 16:37:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:19:36'),(15498,12399,'N','01','021','EC','A',NULL,NULL,'','0000910534','0000385881','','IL','1','DEVORE','ABBY','M','','','34','269882832','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1987-06-19','F','',NULL,'N','021','DEN','2022527','99734OH005000401','2014-02-01','2013-12-31 12:18:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:41'),(13031,10387,'Y','18','021','EC','A','','','AC','0000494438','0000494438','OH00000645473','IL','1','EMBRY-HUGHES','VASHAWNA','','','','34','290643490','1242 WAYCROSS RD',0,'CINCINNATI','OH','45240','2900','CY','39061','1971-07-24','F','U',NULL,'N','021','DEN','1846286','99734OH005000401','2014-01-01','2013-12-22 23:10:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:21'),(968,793,'N','01','021','EC','A',NULL,NULL,'','0000427107','0000937861','','IL','1','Ray','Helen','','','','34','452906042','1225 BUTTERCUP',0,'NEW BRAUNFELS','TX','78130','3559','CY','48091','1950-09-12','F','',':RET:2106-3','N','021','DEN','676763','33348TX002000201','2014-01-01','2013-10-31 14:55:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:09:56'),(4491,3560,'Y','18','021','EC','A','','','AC','0001091546','0001091546','TX00000038557','IL','1','ALEMAN','MARIA','GUADALUPE','','','34','635680788','2411 INGLESIDE DR',0,'SAN ANTONIO','TX','78213','3013','CY','48029','1957-03-25','F','M',NULL,'N','021','DEN','591980','33348TX002000201','2014-01-01','2013-12-11 18:37:01','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-25 22:03:09'),(4179,3325,'N','19','021','EC','A',NULL,NULL,'','0000021373','0000332363','','IL','1','Cipro','Romualdo','','','III','34','272069939','1170 BRIDGEPORT DR',0,'MEDINA','OH','44256','3804','CY','39103','2000-11-26','M','',':RET:2106-3','N','021','HLT','2222362','52664OH151001304','2014-01-01','2013-12-16 20:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 21:49:23'),(3757,3006,'Y','18','021','EC','A','','','AC','0000176377','0000176377','OH00000557745','IL','1','WELLS','KOREN','','','','34','008389695','1220 CHASE RD SE',0,'CARROLLTON','OH','44615','9691','CY','39019','1950-11-19','F','M',':RET:2106-3','N','021','HLT','373104','52664OH151001304','2014-01-01','2013-12-13 08:49:13','393.00',NULL,NULL,'658.32','265.32','R-OH015','OH0','658.32',NULL,0,'2013-12-25 21:33:19'),(2854,2307,'Y','18','021','EC','A','','','AC','0000468879','0000468879','LA00000110654','IL','1','Ducote','Jeralyn','','','','34','439132631','16929 HIGHLAND CLUB AVE',0,'BATON ROUGE','LA','70817','7036','CY','22033','1956-01-16','F','M',':RET:2106-3','N','021','DEN','384139','18575LA002000201','2014-01-01','2013-11-01 21:13:39','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:01:28'),(24340,19330,'Y','18','021','EC','A','','','AC','0000853461','0000853461','TX00002799983','IL','1','CARRILLO','CYTHIA','P','','','34','636421896','1750 N LEE TREVINO DR',0,'EL PASO','TX','79936','4524','CY','48141','1990-01-31','F','U',':RET:2106-3','N','021','DEN','2675790','33348TX002000201','2014-04-01','2014-02-18 15:21:46','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-18 22:00:19'),(26951,21355,'Y','18','021','EC','A','','','AC','0000612012','0000612012','OH00002624210','IL','1','REEVES','MOLLY','','','','34','270567763','1314 STATE RT 224',0,'GREENWICH','OH','44837',NULL,'CY','39077','1953-11-30','F','U',':RET:2106-3','N','021','HLT','3332405','92036OH003002705','2014-04-01','2014-03-02 16:40:47','482.00',NULL,NULL,'552.66','70.66','R-OH006','OH0','552.66',NULL,0,'2014-03-03 01:00:26'),(27333,21643,'Y','18','021','EC','A','','','AC','0000950733','0000950733','OH00002523959','IL','1','Santana','Shelley','','','','34','285642913','7516 Lawn',0,'Cleveland','OH','44102',NULL,'CY','39035','1956-12-12','F','M',':RET:2106-3','T','021','DEN','3409794','99734OH005000401','2014-04-01','2014-03-03 21:30:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:00:53'),(6986,5543,'Y','18','021','EC','A','','','AC','0000234053','0000234053','OH00000191502','IL','1','Reichlderfer','Edward','','','','34','288907115','210 S. Wayne Ave.',0,'Columbus','OH','43204',NULL,'CY','39049','1989-02-14','M','U',':RET:2106-3','T','021','DEN','2098930','99734OH005000401','2014-02-01','2013-12-25 00:43:49','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:51'),(19796,15782,'Y','18','021','EC','A','','','AC','0001148328','0001148328','MS00002260428','IL','1','BURT','JAMES','','','','34','425312695','517 L F PACKER DR',0,'RULEVILLE','MS','38771','3605','CY','28133','1963-11-28','M','U',':RET:2054-5','N','021','DEN','2814148','46300MS002000201','2014-03-01','2014-01-23 17:47:47','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-23 21:01:45'),(9008,7147,'Y','18','024','14','A','','','TE','0000737843','0000737843','','IL','1','Hanna','Amy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-11-01','F','',NULL,NULL,NULL,'','1097028','','2013-12-18','2013-12-18 13:18:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:01'),(18291,14603,'Y','18','021','EC','A','','','AC','0000806371','0000806371','OH00002293722','IL','1','Stein','Sylvia','','','','34','298748008','2824 RESEARCH BLVD',0,'KETTERING','OH','45420','3632','CY','39113','1967-12-01','F','M',':RET:2106-3','N','021','DEN','2632152','99734OH005000401','2014-02-01','2014-01-14 21:30:06','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-16 08:44:52'),(14733,11762,'N','19','021','EC','A',NULL,NULL,'','0001128005','0000868237','','IL','1','Jundi','Alissa','Rahab','','','34','290085187','324 ASHLAND AVE',0,'CUYAHOGA FALLS','OH','44221','2210','CY','39153','2003-11-14','F','',':RET:2106-3','N','021','HLT','2297573','52664OH151001304','2014-02-01','2013-12-28 14:13:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,1,'2013-12-29 11:09:49'),(15351,12280,'Y','18','021','EC','A','','','AC','0000615519','0000615519','OH00002063034','IL','1','Stubbs','Kathy','','','','34','301480759','35939 COUNTY ROAD 402',0,'WARSAW','OH','43844','9500','CY','39031','1950-02-03','F','M',':RET:2106-3','N','021','DEN','2124019','99734OH005000301','2014-02-01','2013-12-31 21:54:17','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,1,'2014-01-02 04:24:33'),(22883,18247,'N','19','021','EC','A',NULL,NULL,'','0001004383','0000366325','','IL','1','Dao','Tung','','','','34','618427525','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1991-01-22','M','',NULL,'N','021','HLT','3544978','52664OH151001501','2014-03-01','2014-02-11 11:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','267.47',NULL,0,'2014-02-11 21:02:34'),(27053,21423,'Y','18','021','EC','A','','','AC','0000908038','0000908038','OH00003053915','IL','1','Smith','Miriam','','','','34','282583910','2316 GLADDEN AVE',0,'SPRINGFIELD','OH','45503','3019','CY','39023','1956-04-10','F','M',':RET:2106-3','N','021','HLT','3084900','92036OH004000501','2014-04-01','2014-03-03 12:07:41','956.00',NULL,NULL,'1083.47','127.47','R-OH003','OH0','465.80','CIC',0,'2014-03-03 21:00:26'),(27172,21513,'N','01','021','EC','A',NULL,NULL,'','0000819360','0000044935','','IL','1','Dinh','Ngoc','','','','34','806332289','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1990-10-03','F','',':RET:2047-9','N','021','DEN','3255069','33348TX002000201','2014-04-01','2014-03-03 11:32:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-03 21:31:05'),(73,66,'Y','18','021','EC','A','','','AC','0000934632','0000934632','OH00000053456','IL','1','daugherty','dorothy','m','','','34','291502826','30 FRAZIER RD',0,'ONTARIO','OH','44906','1312','CY','39139','1951-12-13','F','M',':RET:2106-3','N','021','DEN','380785','99734OH005000301','2014-01-01','2013-12-05 17:02:48','0.00',NULL,NULL,'42.26','42.26','R-OH007','OH0','0.00',NULL,0,'2013-12-25 17:17:00'),(18993,15129,'Y','18','021','EC','A','','','AC','0001064742','0001064742','OH00002344205','IL','1','PODOLL','BRETT','','','','34','188608465','5625 NICHOLSON DR',0,'HUDSON','OH','44236',NULL,'CY','39153','1964-09-25','M','M',NULL,'N','021','HLT','2214063','52664OH151001305','2014-03-01','2014-01-17 16:11:02','565.00',NULL,NULL,'925.48','360.48','R-OH012','OH0','380.45',NULL,0,'2014-01-20 08:06:12'),(8017,6346,'Y','18','021','EC','A','','','AC','0000755991','0000755991','OH00000292606','IL','1','Rockey','David','','','','34','274442247','12199 PURDY RD',0,'SARDINIA','OH','45171','8706','CY','39015','1951-07-21','M','U',':RET:2106-3','T','021','HLT','1595663','92036OH006000601','2014-01-01','2013-12-20 08:47:53','402.00',NULL,NULL,'562.48','160.48','R-OH005','OH0','562.48',NULL,0,'2013-12-26 03:08:49'),(16498,13199,'Y','18','021','EC','A','','','AC','0000605970','0000605970','OH00002317382','IL','1','Givens','Cheryl','Annette','','','34','269661277','2203 SUPERIOR AVE',0,'SPRINGFIELD','OH','45505','4743','CY','39023','1959-09-12','F','U',':RET:2054-5','T','021','HLT','1697540','92036OH006000501','2014-02-01','2014-01-06 11:44:38','346.00',NULL,NULL,'462.86','116.86','R-OH003','OH0','462.86',NULL,0,'2014-01-07 04:06:44'),(16449,13162,'Y','18','021','EC','A','','','AC','0001184535','0001184535','MS00000593398','31','1','Wince','Victorlynn','','','','34','587542063','PO Box 4353',0,'Cleveland','MS','38732',NULL,'CY','28011','1951-03-21','F','M',NULL,'N','021','DEN','2354542','46300MS002000101','2014-02-01','2014-01-06 14:17:40','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-07 04:05:20'),(15442,12356,'Y','18','021','EC','A','','','AC','0001262893','0001262893','TX00001827085','IL','1','Kothman','Kimberly','','','','34','447683085','1420 VALWOOD PKWY',0,'CARROLLTON','TX','75006','6892','CY','48113','1969-09-30','F','U',':RET:2106-3','N','021','DEN','1668938','33348TX002000201','2014-02-01','2013-12-31 14:18:13','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:28:04'),(976,799,'Y','18','021','EC','A','','','AC','0000067633','0000067633','OH00000476073','IL','1','frantz','christopher','','','','34','277665752','21564 COUNTY ROAD 7',0,'ALVADA','OH','44802','9620','CY','39063','1971-06-19','M','U',':RET:2106-3','N','021','HLT','924638','92036OH004001501','2014-01-01','2013-10-28 20:28:42','0.00',NULL,NULL,'234.49','234.49','R-OH002','OH0','234.49',NULL,0,'2013-12-25 18:10:09'),(2427,1977,'Y','18','021','EC','A','','','AC','0000746850','0000746850','OH00000550315','IL','1','Jorgensen','Cindy','Marie','','','34','290564366','10934 STATE ROUTE 68 NORTH',0,'BELLE CENTER','OH','43310',NULL,'CY','39091','1952-07-30','F','M',':RET:2106-3','N','021','DEN','308852','99734OH005000401','2014-01-01','2013-12-09 16:58:59','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:34:04'),(5606,4449,'Y','18','021','EC','A','','','AC','0000168846','0000168846','OH00001194993','IL','1','Macke','Alexander','','','','34','275942178','305 Peyton Dr.',0,'Trenton','OH','45067',NULL,'CY','39017','1991-06-04','M','U',':RET:2106-3','N','021','DEN','1175279','99734OH005000401','2014-01-01','2013-11-25 20:44:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:25'),(3169,2548,'N','19','021','EC','A',NULL,NULL,'','0000714933','0000132032','','IL','1','Truong','Brandon','','','','34','282066527','6705 Jennifer Lynn Dr.',0,'Cincinnati','OH','45248',NULL,'CY','39061','2001-05-28','M','',':RET:2047-9','N','021','DEN','227690','99734OH005000401','2014-01-01','2013-11-18 13:20:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:31:30'),(7602,6015,'N','01','021','EC','A',NULL,NULL,'','0000166337','0000411076','','IL','1','dodge','andrea','','','','34','601100139','4323 meadowcroft',0,'kettering','OH','45429',NULL,'CY','39113','1978-12-22','F','',':RET:2106-3','N','021','DEN','60033','99734OH005000401','2014-01-01','2013-11-17 17:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:45:24'),(4125,3294,'Y','18','021','EC','A','','','AC','0000295470','0000295470','OH00000340783','S3','1','Eash','Christopher','','','','34','290084967','110 Carter Circle',0,'Boardman','OH','44512',NULL,'CY','39099','2003-11-12','F','U',':RET:2106-3','N','021','DEN','1954901','99734OH005000301','2014-01-01','2013-12-16 22:54:15','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','21.13',NULL,0,'2013-12-25 21:48:16'),(28199,22315,'Y','18','024','14','A','','','TE','0000137792','0000137792','','IL','1','BALINO','LETICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-21','F','',NULL,NULL,NULL,'','85668','','2014-03-31','2014-03-06 16:36:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-06 21:30:08'),(696,573,'Y','18','021','EC','A','','','AC','0001210906','0001210906','OH00000889758','IL','1','Hunt','Geralyn',NULL,NULL,NULL,NULL,NULL,'807 McClelland Road',0,'Milford','OH','45150',NULL,'CY','39025','1955-02-26','F','U',':RET:2106-3','N','021','DEN','1654673','99734OH005000301','2014-01-01','2013-12-16 15:26:54','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:02:46'),(941,778,'Y','18','021','EC','A','','','AC','0000795475','0000795475','OH00000032058','IL','1','Tecle','Simon','','','','34','331748499','6433 SKIMMER LN',0,'COLUMBUS','OH','43230','6478','CY','39049','1984-07-13','M','U',':RET:2054-5','N','021','DEN','735558','99734OH005000301','2014-01-01','2013-10-28 18:41:18','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:09:21'),(14314,11417,'Y','18','021','EC','A','','','AC','0000780516','0000780516','OH00001672989','IL','1','Youngless','Lisa','','','','34','268822815','41 Walnut Street',0,'New London','OH','44851',NULL,'CY','39077','1983-12-20','F','M',NULL,'N','021','HLT','1936578','92036OH003002706','2014-02-01','2013-12-26 18:22:35','399.00',NULL,NULL,'452.49','53.49','R-OH006','OH0','231.13',NULL,0,'2013-12-27 02:07:06'),(16495,13197,'Y','18','021','EC','A','','','AC','0000532118','0000532118','OH00002264826','IL','1','piwinski','kimberly','','','','34','319688937','8223 MANORFORD DR',0,'PARMA','OH','44129','5306','CY','39035','1965-06-12','F','M',':RET:2106-3','N','021','HLT','2034650','92036OH002000801','2014-02-01','2014-01-06 16:52:28','717.00',NULL,NULL,'1071.35','354.35','R-OH011','OH0','441.45',NULL,0,'2014-01-07 04:06:37'),(7007,5561,'Y','18','021','EC','A','','','AC','0000381489','0000381489','TX00000332407','31','1','YOUNG','MICHELLE','','','','34','434190998','P O Box 57',0,'Carthage','TX','75633',NULL,'CY','48365','1968-10-07','F','M',NULL,'N','021','DEN','1488626','33348TX002000201','2014-01-01','2013-12-24 19:23:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:24'),(15562,12453,'Y','18','021','EC','A','','','AC','0000449889','0000449889','OH00002033185','31','1','Miller','Cathy','Joan','','','34','268520178','PO Box 15',0,'Deerfield','OH','44411',NULL,'CY','39133','1953-08-20','F','M',':RET:2106-3','N','021','HLT','2447606','52664OH151001301','2014-02-01','2013-12-31 11:20:54','198.00',NULL,NULL,'605.24','407.24','R-OH012','OH0','605.24',NULL,1,'2014-01-02 04:31:37'),(1703,1422,'Y','18','021','EC','A','','','AC','0000390896','0000390896','OH00000381612','IL','1','Massey','travor','','','','34','281803623','2684 queen city ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1977-01-16','M','U',':RET:2054-5','N','021','HLT','1687063','92036OH006001201','2014-01-01','2013-12-24 07:53:58','136.00',NULL,NULL,'209.41','73.41','R-OH004','OH0','209.41',NULL,0,'2013-12-25 18:54:47'),(13693,10925,'N','19','021','EC','A',NULL,NULL,'','0000623975','0001012924','','IL','1','Brag','Scott','A','','','34','279941548','885 Walls Lake Dr',0,'Vignna','OH','44473',NULL,'CY','39155','1989-07-24','M','',NULL,'N','021','HLT','2329725','52664OH151001305','2014-01-01','2013-12-23 11:09:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','252.90',NULL,0,'2013-12-26 13:08:30'),(13392,10691,'Y','18','021','EC','A','','','AC','0001057989','0001057989','OH00001131485','IL','1','Thomas','Esther','','','','34','283864459','5798 UNIVERSITY HEIGHTS DR',0,'ATHENS','OH','45701','9339','CY','39009','1974-04-23','F','M',':RET:2106-3','N','021','DEN','2503092','99734OH005000301','2014-01-01','2013-12-23 08:28:13','0.00',NULL,NULL,'87.78','87.78','R-OH017','OH0','0.00',NULL,0,'2013-12-26 13:00:11'),(3932,3147,'Y','18','021','EC','A','','','AC','0000710115','0000710115','OH00000311064','IL','1','Leach','Brenda',NULL,NULL,NULL,NULL,NULL,'316 W MANHATTAN BLVD',0,'TOLEDO','OH','43608','1024','CY','39095','1967-05-26','F','U',':RET:2106-3','N','021','HLT','134105','92036OH004002601','2014-01-01','2013-12-13 13:39:42','0.00',NULL,NULL,'235.18','235.18','R-OH001','OH0','235.18',NULL,0,'2013-12-25 21:37:40'),(3563,2861,'Y','18','021','EC','A','','','AC','0000825908','0000825908','OH00000915679','IL','1','bastien','marty','','','','34','379681049','k415county rd 5',0,'McClure','OH','43534',NULL,'CY','39069','1959-01-08','M','M',':RET:2106-3','N','021','HLT','1515693','92036OH004002601','2014-01-01','2013-12-21 23:04:26','664.61',NULL,NULL,'669.50','4.89','R-OH001','OH0','334.75',NULL,0,'2013-12-25 21:22:22'),(3420,2746,'Y','18','021','EC','A','','','AC','0001529350','0001529350','LA00000284152','IL','1','Akinniyi','Angela','','','','34','438450642','2716 CAVALIER DR',0,'BATON ROUGE','LA','70816','2121','CY','22033','1974-09-04','F','U',':RET:2054-5','N','021','DEN','1816388','18575LA002000201','2014-01-01','2013-12-22 17:48:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:37'),(6138,4867,'N','01','021','EC','A',NULL,NULL,'','0000313846','0000981853','','IL','1','MacDougall','Pamela','','','','34','008449403','14302 RIVERLAKE DR',0,'COVINGTON','LA','70435','5783','CY','22103','1956-07-22','F','',':RET:2106-3','N','021','DEN','902408','18575LA002000201','2014-01-01','2013-11-21 17:43:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:16:11'),(21167,16916,'Y','18','021','EC','A','','','AC','0000267566','0000267566','OH00002330814','IL','1','MCQUEEN','CATHERINE','','','','34','297561607','3783 RIVERDOWNS CT',0,'HAMILTON','OH','45011',NULL,'CY','39017','1955-03-17','F','M',':RET:2106-3','N','021','DEN','3598241','99734OH005000401','2014-03-01','2014-02-03 12:23:17','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:00:36'),(22616,18061,'Y','18','021','EC','A','','','AC','0000981193','0000981193','TX00002176760','IL','1','CHAU','TAN','','','','34','729263193','4101 s custer rd',0,'mckinney','TX','75070',NULL,'CY','48085','1957-02-01','M','M',':RET:2047-9','N','021','DEN','2664550','33348TX002000201','2014-03-01','2014-02-10 20:00:13','0.00',NULL,NULL,'47.55','47.55','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:08'),(27806,21992,'N','19','021','EC','A',NULL,NULL,'','0000495502','0000613062','','IL','1','DOBRIJEVIC','ANNA MARIA','','','','34','268087099','792 HANCOCK CIR',0,'AKRON','OH','44314','1017','CY','39153','2002-08-17','F','',':RET:2106-3','N','021','HLT','3753464','52664OH151001305','2014-04-01','2014-03-05 12:39:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-05 21:31:48'),(29127,23059,'Y','18','021','EC','A','','','AC','0000703850','0000703850','OH00003498861','IL','1','zachman','james','','','','34','276489983','5533 CRESTHAVEN LN',0,'TOLEDO','OH','43614','1236','CY','39095','1949-09-24','M','U',NULL,'N','021','HLT','4009960','92036OH006002601','2014-04-01','2014-03-10 15:41:25','246.00',NULL,NULL,'463.92','217.92','R-OH001','OH0','463.92',NULL,0,'2014-03-10 21:02:34'),(14499,11567,'Y','18','021','EC','A','','','AC','0001159641','0001159641','TX00001354037','IL','1','Chan','Jane','','','','34','456734535','21610 AMESBURY MEADOW LN',0,'SPRING','TX','77379','1960','CY','48201','1978-10-01','F','U',':RET:2034-7','N','021','DEN','1567666','33348TX002000201','2014-02-01','2013-12-27 14:02:36','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-28 03:33:43'),(14319,11419,'N','01','021','EC','A',NULL,NULL,'','0000987410','0001075309','','IL','1','Baddar','Florence','','','','34','302727688','3663 WOODSPRING RD',0,'SYLVANIA','OH','43560','3558','CY','39095','1964-12-03','F','',NULL,'N','021','HLT','1495338','92036OH001002601','2014-02-01','2013-12-26 11:38:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','401.27',NULL,0,'2013-12-27 02:07:11'),(14039,11184,'Y','18','021','EC','A','','','AC','0000111894','0000111894','OH00000075752','IL','1','landock','matt','','','','34','298724458','18765 GAUCHE RD',0,'FAYETTEVILLE','OH','45118','9647','CY','39015','1977-12-08','M','U',':RET:2106-3','T','021','HLT','1435639','92036OH006000601','2014-01-01','2013-12-23 19:16:35','103.00',NULL,NULL,'240.82','137.82','R-OH005','OH0','240.82',NULL,0,'2013-12-26 13:17:07'),(18846,15010,'N','01','021','EC','A',NULL,NULL,'','0000351597','0000690760','','IL','1','KISSELL','KARA','','','','34','659727879','41 SUNNYCLIFF DRIVE',0,'EUCLID','OH','44123',NULL,'CY','39035','1982-06-08','F','',':RET:2106-3','N','021','HLT','1925839','52664OH151001305','2014-02-01','2014-01-15 19:01:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.51',NULL,0,'2014-01-17 03:36:14'),(6427,5096,'Y','18','021','EC','A','','','AC','0000415196','0000415196','LA00000899620','IL','1','Johnson','Doris','','','','34','436089704','951 S 12TH ST',0,'BATON ROUGE','LA','70802','4813','CY','22033','1955-08-13','F','U',':RET:2054-5','N','021','DEN','927264','18575LA002000201','2014-01-01','2013-12-11 11:58:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:49:04'),(18234,14554,'Y','18','021','EC','A','','','AC','0000213389','0000213389','TX00001721562','IL','1','NOEL','PAULA','','','','34','466762347','103 E LINCOLN AVE',0,'ELECTRA','TX','76360','1603','CY','48485','1952-06-22','F','U',NULL,'N','021','DEN','2919212','33348TX002000201','2014-02-01','2014-01-14 23:08:06','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-16 08:44:21'),(5689,4514,'Y','18','021','EC','A','','','AC','0001217346','0001217346','OH00001236357','IL','1','MUSTAIN','DENISE','','','','34','276541608','3934 OAKPARK PL',0,'CINCINNATI','OH','45209','2120','CY','39061','1952-09-27','F','U',':RET:2106-3','N','021','DEN','868125','99734OH005000301','2014-01-01','2013-11-26 11:40:24','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:32:32'),(20938,16734,'Y','18','021','EC','A','','','AC','0000111926','0000111926','OH00001949302','IL','1','Riggins','Shauna','','','','34','290749109','315 S BURNETT RD',0,'SPRINGFIELD','OH','45505','2650','CY','39023','1979-01-21','F','U',':RET:2054-5','T','021','HLT','2984854','92036OH005000506','2014-03-01','2014-01-31 14:43:00','195.00',NULL,NULL,'334.03','139.03','R-OH003','OH0','334.03',NULL,0,'2014-01-31 21:01:41'),(24266,19271,'Y','18','021','EC','A','','','AC','0000642127','0000642127','OH00002766377','31','1','WILKINSON','TERRANCE','','','','34','282700893','P.O. BOX 93472',0,'CLEVELAND','OH','44101',NULL,'CY','39035','1969-05-13','M','U',NULL,'N','021','HLT','3497242','52664OH151001305','2014-04-01','2014-02-17 14:34:19','197.00',NULL,NULL,'351.37','154.37','R-OH011','OH0','351.37',NULL,0,'2014-02-17 19:00:14'),(26959,21360,'Y','18','021','EC','A','','','AC','0000975295','0000975295','OH00002354206','IL','1','Chilberti','Leslee','A','','','34','077784099','778 CHESTNUT BLVD',0,'WILLOUGHBY','OH','44094','7257','CY','39085','1979-06-11','F','U',':RET:2106-3','N','021','HLT','3302091','52664OH151001305','2014-04-01','2014-03-02 12:09:12','152.00',NULL,NULL,'305.34','153.34','R-OH011','OH0','305.34',NULL,0,'2014-03-03 01:00:29'),(27718,21920,'Y','18','021','EC','A','','','AC','0000621721','0000621721','TX00003082930','IL','1','Cohen','Laura','','','','34','453216156','5582 BUCKLEY DR',0,'EL PASO','TX','79912','6417','CY','48141','1959-08-26','F','M',NULL,'N','021','DEN','4091428','33348TX002000201','2014-04-01','2014-03-05 13:55:45','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:30:57'),(13950,11123,'N','19','021','EC','A',NULL,NULL,'','0000196137','0000122976','','IL','1','Gelter','Trevor','J','','','34','296040792','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','2000-03-17','M','',':RET:2106-3','N','021','HLT','1462002','92036OH004000601','2014-01-01','2013-12-23 12:07:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 13:14:55'),(19469,15518,'Y','18','021','EC','A','','','AC','0001225590','0001225590','TX00001530190','IL','1','Dominguez','Dora','','','','34','462472411','412 30TH ST',0,'SNYDER','TX','79549','3724','CY','48415','1964-04-03','F','U',NULL,'N','021','DEN','2131600','33348TX002000201','2014-03-01','2014-01-22 16:22:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 03:01:58'),(1163,960,'Y','18','021','EC','A','','','AC','0000171971','0000171971','LA00000276152','IL','1','Harney','marie','','','','34','434158730','2505 Livaccari Dr.',0,'Violet','LA','70092',NULL,'CY','22087','1966-10-14','F','M',':RET:2106-3','N','021','DEN','1221011','18575LA002000201','2014-01-01','2013-12-03 16:47:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:18:57'),(9052,7181,'Y','18','021','EC','A','','','AC','0000096383','0000096383','OH00001210575','IL','1','Scott','Brianne','','','','34','211703657','705 BLOOMSBURY DR',0,'UNIONTOWN','OH','44685','6932','CY','39153','1989-12-21','F','U',NULL,'N','021','HLT','1573180','52664OH151001306','2014-01-01','2013-12-18 18:20:06','149.00',NULL,NULL,'223.01','74.01','R-OH012','OH0','223.01',NULL,0,'2013-12-26 04:06:03'),(17113,13696,'Y','18','021','EC','A','','','AC','0001136662','0001136662','OH00002142122','IL','1','Renn','Christopher','','','','34','299843810','800 maple street',0,'stryker','OH','43557',NULL,'CY','39171','1986-09-07','M','U',':RET:2106-3','N','021','DEN','2528848','99734OH005000401','2014-02-01','2014-01-07 20:07:50','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-13 02:21:39'),(16889,13514,'Y','18','021','EC','A','','','AC','0000863072','0000863072','TX00002286308','IL','1','LOPEZ','ROSANA','','','','34','643126173','12400 NANCY LEE AVE',0,'EL PASO','TX','79928','1716','CY','48141','1987-08-20','F','U',NULL,'N','021','DEN','2613987','33348TX002000201','2014-02-01','2014-01-09 15:31:54','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:19:26'),(20468,16349,'N','19','021','EC','A',NULL,NULL,'','0000558181','0000937306','','S3','1','Berlean','Kellie','','','','34','282112233','7405 REFUGEE RD',0,'PICKERINGTON','OH','43147','9101','CY','39045','2005-06-21','F','',':RET:2106-3','N','021','DEN','3169905','99734OH005000401','2014-03-01','2014-01-29 11:46:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-29 21:00:54'),(21363,17074,'N','01','021','EC','A',NULL,NULL,'','0000592299','0000105109','','IL','1','Carpenter','Lisette','','','','34','289846137','122 COUNTRY EST',0,'EUSTACE','TX','75124','9600','CY','48213','1986-06-13','F','',NULL,'N','021','DEN','3106089','33348TX002000201','2014-03-01','2014-02-04 15:57:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-04 21:00:44'),(26884,21307,'Y','18','021','EC','A','','','AC','0000199728','0000199728','OH00003507994','IL','1','Thieken','Andrew','','','','34','273929089','181 EDMONTON PL',0,'HAMILTON','OH','45013','3722','CY','39017','1983-07-13','M','U',':RET:2106-3','N','021','HLT','2945775','92036OH006001201','2014-04-01','2014-03-01 16:10:54','17.00',NULL,NULL,'193.23','176.23','R-OH004','OH0','193.23',NULL,0,'2014-03-01 21:01:11'),(27782,21972,'Y','18','021','EC','A','','','AC','0000160842','0000160842','OH00002918078','IL','1','ARMBRUSTER','MARY','','','','34','274666214','3183 SANITARIUM RD',0,'AKRON','OH','44312','4643','CY','39153','1958-05-14','F','M',':RET:2106-3','N','021','HLT','3489956','52664OH152000901','2014-04-01','2014-03-05 16:11:45','180.00',NULL,NULL,'364.25','184.25','R-OH012','OH0','364.25',NULL,0,'2014-03-05 21:31:34'),(57,52,'Y','18','021','EC','A','','','AC','0000078732','0000078732','OH00000363771','IL','1','Mahone','Elizabeth','','','','34','372989990','3919 BEECH ST',0,'CINCINNATI','OH','45227','3101','CY','39061','1979-07-11','F','M',':RET:2106-3','N','021','DEN','1250336','99734OH005000301','2014-01-01','2013-12-04 22:47:18','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:16:34'),(5550,4405,'Y','18','021','EC','A','','','AC','0000998921','0000998921','TX00000288250','IL','1','Ellsworth','Tavaushjane','','','','34','630325995','150 LIMEWOOD LN',0,'TEMPLE','TX','76501','9501','CY','48027','1992-07-26','F','U',':RET:2054-5','N','021','DEN','438683','33348TX002000201','2014-01-01','2013-11-26 20:36:19','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 23:16:07'),(21093,16856,'Y','18','021','EC','A','','','AC','0000455339','0000455339','OH00002217436','IL','1','Nishimoto','Kenji','','','','34','631123474','3021 PECAN AVE',0,'LIMA','OH','45806','1106','CY','39003','1987-10-29','M','R',NULL,'N','021','HLT','2970265','92036OH006001501','2014-03-01','2014-02-02 09:15:33','0.00',NULL,NULL,'178.73','178.73','R-OH002','OH0','178.73',NULL,0,'2014-02-02 19:00:29'),(5490,4358,'Y','18','021','EC','A','','','AC','0001224434','0001224434','OH00001092527','IL','1','Malicki','Charlene','','','','34','276543692','1614 SLATER ST',0,'TOLEDO','OH','43612','2019','CY','39095','1952-06-27','F','U',NULL,'N','021','HLT','2184389','92036OH003002605','2014-01-01','2013-12-19 13:26:12','419.00',NULL,NULL,'572.23','153.23','R-OH001','OH0','572.23',NULL,0,'2013-12-25 23:11:02'),(3045,2446,'Y','18','021','EC','A','','','AC','0000957335','0000957335','TX00000687076','IL','1','White','Timothy','J','','','34','458083400','707 N 20TH ST',0,'LAMESA','TX','79331','2523','CY','48115','1955-09-22','M','M',':RET:2106-3','N','021','DEN','973467','33348TX002000101','2014-01-01','2013-12-05 21:45:07','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:18:44'),(16571,13255,'Y','18','021','EC','A','','','AC','0000453935','0000453935','OH00001632534','IL','1','Fitzpatrick','Joshua','','','','34','296828678','1933 w. alexis',0,'Toledo','OH','43613',NULL,'CY','39095','1985-02-01','M','U',':RET:2106-3','N','021','HLT','2191171','92036OH006002601','2014-02-01','2014-01-05 12:14:43','31.00',NULL,NULL,'173.04','142.04','R-OH001','OH0','173.04',NULL,1,'2014-01-07 10:23:20'),(22868,18243,'Y','18','021','EC','A','','','AC','0000432803','0000432803','OH00001559412','IL','1','son','my','','','','34','579219174','610 chestnut ln',0,'boardman','OH','44512',NULL,'CY','39099','1970-12-31','M','M',':RET:2047-9','N','021','HLT','3682106','92036OH005003204','2014-03-01','2014-02-10 22:50:28','464.00',NULL,NULL,'956.61','492.61','R-OH013','OH0','328.46',NULL,0,'2014-02-11 21:02:29'),(23336,18600,'Y','18','021','EC','A','','','AC','0000813130','0000813130','OH00002611409','IL','1','Shepherd','Angel','','','','34','277789124','111 RIDGE RD',0,'LEBANON','OH','45036','1666','CY','39165','1973-01-21','F','U',':RET:2106-3','N','021','DEN','2753530','99734OH005000301','2014-03-01','2014-02-13 17:40:23','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:34'),(23438,18671,'Y','18','021','EC','A','','','AC','0000816866','0000816866','TX00002203979','IL','1','kim','victor','','','','34','622525410','100 stonecreek dr',0,'marshall','TX','75672',NULL,'CY','48203','1968-06-07','M','U',':RET:2040-4','T','021','DEN','2972012','33348TX002000201','2014-03-01','2014-02-13 11:38:47','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:31'),(23708,18876,'Y','18','021','EC','A','','','AC','0001100637','0001100637','OH00002781284','IL','1','Dillingham','Lucas','','','','34','380086485','3323 MORRISON AVE',0,'CINCINNATI','OH','45220','1445','CY','39061','1987-10-07','M','R',':RET:2106-3','N','021','DEN','3123627','99734OH005000401','2014-03-01','2014-02-14 13:09:17','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:45'),(23786,18929,'Y','18','021','EC','A','','','AC','0000071688','0000071688','OH00002165642','IL','1','graske','leslie','','','','34','360565754','956 MAYFAIR RD',0,'AKRON','OH','44303','1318','CY','39153','1957-02-01','F','U',':RET:2106-3','N','021','HLT','3502164','52664OH151001301','2014-03-01','2014-02-13 19:34:23','208.00',NULL,NULL,'543.47','335.47','R-OH012','OH0','543.47',NULL,0,'2014-02-14 21:31:22'),(25827,20478,'Y','18','021','EC','A','','','AC','0000444962','0000444962','OH00003048821','IL','1','Weilnau','Elizabeth','','','','34','400044535','1076 REVERES RUN',0,'LEBANON','OH','45036','8974','CY','39165','1975-09-16','F','M',':RET:2106-3','T','021','DEN','2946724','99734OH005000301','2014-04-01','2014-02-26 16:54:19','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:00:29'),(25917,20552,'Y','18','021','EC','A','','','AC','0000151921','0000151921','TX00002252497','IL','1','EVANS','TRACY','','','','34','456492871','958 EAST BROADWAY AVE',0,'FORT WORTH','TX','76104',NULL,'CY','48439','1979-10-18','F','U',':RET:2054-5','N','021','DEN','3624570','33348TX002000201','2014-03-01','2014-02-26 15:11:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:18'),(27869,22044,'Y','18','021','EC','A','','','AC','0001182554','0001182554','OH00002761603','IL','1','MEEKER','JACKIE','','','','34','272521965','304 WALNUT ST',0,'HARROD','OH','45850',NULL,'CY','39003','1951-07-21','F','M',':RET:2106-3','T','021','HLT','3381271','92036OH004001501','2014-04-01','2014-03-05 10:05:07','358.00',NULL,NULL,'584.69','226.69','R-OH002','OH0','584.69',NULL,0,'2014-03-05 21:32:24'),(29200,23108,'Y','18','024','14','A','','','TE','0000271433','0000271433','','IL','1','CUPP','SHARON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-10-19','F','',NULL,NULL,NULL,'','1610926','','2014-03-31','2014-03-10 13:33:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-10 21:30:09'),(1619,1353,'Y','18','021','EC','A','','','AC','0001041351','0001041351','TX00000831395','IL','1','Urive','Tony','','','','34','449559226','2015 2nd St',0,'Lubbock','TX','79415',NULL,'CY','48303','1966-09-01','M','M',NULL,'N','021','DEN','2123810','33348TX002000201','2014-01-01','2013-12-24 13:37:39','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 18:52:32'),(22716,18139,'N','01','021','EC','A',NULL,NULL,'','0001167342','0001422373','','IL','1','tran','dung','','','','34','613584103','544 ATWOOD DR',0,'CROWLEY','LA','70526','0968','CY','22001','1971-07-17','F','',':RET:2028-9','N','021','DEN','3078508','18575LA002000201','2014-03-01','2014-02-11 09:36:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:08'),(25800,20460,'Y','18','021','EC','A','','','AC','0000224772','0000224772','OH00003121391','IL','1','Peterson','Michael','','','','34','300744750','5566 GLEN MEADOW DR',0,'DAYTON','OH','45417','5459','CY','39113','1963-12-23','M','U',NULL,'N','021','DEN','3609807','99734OH005000301','2014-03-01','2014-02-26 11:32:32','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-02-26 21:00:16'),(27651,21871,'N','19','021','EC','A',NULL,NULL,'','0000134634','0000942060','','IL','1','Stinson','Donivan','','','','34','276138742','2540 OWLCREST DR',0,'CINCINNATI','OH','45231','1152','CY','39061','2007-02-28','M','',':RET:2054-5^:RET:2106-3','N','021','DEN','2946972','99734OH005000401','2014-04-01','2014-03-05 13:17:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:22'),(29034,22980,'Y','18','021','EC','A','','','AC','0000930983','0000930983','OH00002708981','IL','1','Crowell','Tammulia','','','','34','286701586','1126 Senate Drive',0,'Fairfield','OH','45014',NULL,'CY','39017','1964-09-26','F','U',':RET:2054-5','T','021','DEN','3147320','99734OH005000401','2014-04-01','2014-03-10 12:21:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:37'),(5393,4280,'Y','18','021','EC','A','','','AC','0002307223','0002307223','LA00000824236','IL','1','Moore','Charles','Edward','','Jr','34','437477307','1904 Hartsfield Ave',0,'Pineville','LA','71360',NULL,'CY','22079','1967-10-06','M','U',':RET:2106-3','N','021','DEN','1532857','18575LA002000201','2014-01-01','2013-12-19 16:49:19','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 23:08:43'),(21245,16976,'Y','18','021','EC','A','','','AC','0000155813','0000155813','OH00001585731','IL','1','brown','richard','','','','34','280768832','9139 CHERRY BLOSSOM LN',0,'CINCINNATI','OH','45231','3831','CY','39061','1975-02-03','M','U',':RET:2106-3','T','021','DEN','3238277','99734OH005000301','2014-03-01','2014-02-03 15:43:46','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:01:14'),(6281,4980,'N','01','021','EC','A',NULL,NULL,'','0000927284','0001212326','','IL','1','miller','donna','','','','34','298466603','28 beechwood dr',0,'youngstown','OH','44512',NULL,'CY','39099','1952-02-11','F','',':RET:2106-3','N','021','DEN','558732','99734OH005000401','2014-01-01','2013-12-10 20:10:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:45:22'),(6502,5152,'Y','18','021','EC','A','','','AC','0000743062','0000743062','OH00000063743','IL','1','Taliano','Daniel','E','','','34','285488615','5475 BARKWOOD DR',0,'SHEFFIELD VILLAGE','OH','44054','2413','CY','39093','1957-10-18','M','M',':RET:2106-3','N','021','HLT','257630','52664OH151001304','2014-01-01','2013-12-11 17:02:16','256.00',NULL,NULL,'586.79','330.79','R-OH011','OH0','586.79',NULL,0,'2013-12-26 00:50:52'),(19076,15197,'N','01','021','EC','A',NULL,NULL,'','0002020248','0002239346','','IL','1','Jenkins','Lawrence','','','','34','436153578','1707 MEDRA DR',0,'MONROE','LA','71202',NULL,'CY','22073','1963-11-30','M','',':RET:2054-5','N','021','DEN','2418491','18575LA002000101','2014-03-01','2014-01-17 22:06:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-21 08:44:23'),(18590,14822,'Y','18','021','EC','A','','','AC','0000827182','0000827182','OH00001394370','IL','1','Rotondo','Anthony','','','','34','291421331','131 SANDY BEACH WAY',0,'CELINA','OH','45822','2723','CY','39107','1954-07-25','M','M',':RET:2106-3','N','021','HLT','2665209','92036OH006001501','2014-02-01','2014-01-15 10:34:44','784.00',NULL,NULL,'976.83','192.83','R-OH002','OH0','454.34',NULL,0,'2014-01-16 08:47:13'),(18209,14533,'Y','18','021','EC','A','','','AC','0000128119','0000128119','OH00002482913','IL','1','Kuwatch','Kimberly','','','','34','285643867','7145 GOSHEN RD',0,'GOSHEN','OH','45122','9744','CY','39025','1958-09-30','F','R',':RET:2106-3','N','021','HLT','2550350','92036OH004000601','2014-02-01','2014-01-14 15:15:12','0.00',NULL,NULL,'384.93','384.93','R-OH005','OH0','384.93',NULL,0,'2014-01-15 02:08:09'),(16001,12806,'N','01','021','EC','A',NULL,NULL,'','0001177520','0000783873','','IL','1','Griffin','Paul','','','','34','459946530','NF38 LAKE CHEROKEE',0,'LONGVIEW','TX','75603','9512','CY','48183','1959-06-14','M','',NULL,'N','021','DEN','2270367','33348TX002000201','2014-02-01','2014-01-03 15:32:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:01:30'),(15899,12731,'Y','18','021','EC','A','','','AC','0000328426','0000328426','OH00000391304','IL','1','Noble','Denise','','','','34','272607964','237 N HICKORY ST',0,'OTTAWA','OH','45875','1934','CY','39137','1955-07-06','F','U',':RET:2106-3','N','021','HLT','2240873','92036OH003001504','2014-02-01','2014-01-02 14:59:13','396.00',NULL,NULL,'585.61','189.61','R-OH002','OH0','585.61',NULL,0,'2014-01-03 02:06:00'),(15143,12102,'N','01','021','EC','A',NULL,NULL,'','0000403667','0000984856','','IL','1','Davidson','Dwayne','','','','34','277666754','7967 WESSELMAN RD',0,'COLERAIN TOWNSHIP','OH','45002',NULL,'CY','39061','1963-09-15','M','',NULL,'N','021','DEN','2509192','99734OH005000401','2014-02-01','2013-12-30 09:23:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:48'),(21966,17541,'Y','18','021','EC','A','','','AC','0000044308','0000044308','OH00002167820','IL','1','Gates','Steve','','','','34','294542469','368 DEWFALL DR',0,'SUNBURY','OH','43074','8532','CY','39041','1954-01-29','M','M',':RET:2106-3','N','021','DEN','2786505','99734OH005000401','2014-03-01','2014-02-07 16:21:16','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:28'),(23316,18584,'N','19','021','EC','A',NULL,NULL,'','0000416004','0001053098','','IL','1','OVIAHON','ARIANA','','','','34','299988779','6044 FREJON LN',0,'SYLVANIA','OH','43560','2228','CY','39095','1996-07-12','F','',':RET:2054-5','N','021','DEN','3381743','99734OH005000301','2014-03-01','2014-02-13 12:34:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:23'),(23351,18609,'Y','18','021','EC','A','','','AC','0000373671','0000373671','OH00001972945','31','1','Smith','Scott',NULL,NULL,NULL,NULL,NULL,'1215 Kenmore Blvd',0,'Akron','OH','44314',NULL,'CY','39153','1961-06-15','M','M',':RET:2106-3','N','021','HLT','2740488','52664OH151001304','2014-03-01','2014-02-13 13:48:28','562.00',NULL,NULL,'941.54','379.54','R-OH012','OH0','435.31',NULL,0,'2014-02-13 22:00:42'),(24854,19704,'Y','18','021','EC','A','','','AC','0000566664','0000566664','OH00001776211','IL','1','Stevens','Camaree','','','','34','269761538','2728 E HIGH ST',0,'SPRINGFIELD','OH','45505','1415','CY','39023','1977-11-11','F','U',':RET:2106-3','N','021','HLT','2933610','92036OH003000505','2014-04-01','2014-02-19 15:22:35','182.00',NULL,NULL,'305.34','123.34','R-OH003','OH0','305.34',NULL,0,'2014-02-20 04:55:50'),(5732,4549,'Y','18','021','EC','A','','','AC','0002317457','0002317457','LA00001057978','IL','1','Smith','Kristen','C','','','34','437850593','10259 UMBEHAGEN LN',0,'BATON ROUGE','LA','70817','7326','CY','22033','1992-09-26','F','U',':RET:2054-5','N','021','DEN','2058118','18575LA002000201','2014-01-01','2013-12-23 22:53:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:42'),(4414,3507,'Y','18','021','EC','A','','','AC','0000881602','0000881602','OH00000599922','IL','1','NASH','VICKIE','','','','34','288521916','5237 WILLNET DR',0,'CINCINNATI','OH','45238','4361','CY','39061','1951-08-13','F','M',':RET:2106-3','T','021','DEN','338626','99734OH005000401','2014-01-01','2013-12-12 15:11:49','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:27'),(888,735,'Y','18','021','EC','A','','','AC','0000984832','0000984832','OH00000152852','IL','1','Maloney','Carol','','','','34','283523960','4525 EASTWOOD DR',0,'BATAVIA','OH','45103',NULL,'CY','39025','1952-04-29','F','U',':RET:2106-3','T','021','HLT','1401215','92036OH006000601','2014-01-01','2013-12-16 12:16:34','393.00',NULL,NULL,'550.17','157.17','R-OH005','OH0','550.17',NULL,0,'2013-12-25 18:07:55'),(6746,5352,'Y','18','021','EC','A','','','AC','0000327240','0000327240','OH00000580555','IL','1','ROLLER','PATRICIA','','','','34','147448027','27192 CLIFFSIDE CIR',0,'OLMSTED TWP','OH','44138',NULL,'CY','39035','1951-01-08','F','U',':RET:2106-3','N','021','HLT','311108','52664OH151001306','2014-01-01','2013-11-25 12:49:18','538.00',NULL,NULL,'722.61','184.61','R-OH011','OH0','722.61',NULL,0,'2013-12-26 01:15:55'),(6937,5508,'Y','18','021','EC','A','','','AC','0000449881','0000449881','OH00000130584','IL','1','penrod','carol','','','','34','302584996','1312 RIVERSIDE DR',0,'AKRON','OH','44310','1214','CY','39153','1972-06-30','F','U',':RET:2106-3','T','021','DEN','1942191','99734OH005000401','2014-01-01','2013-12-24 20:19:45','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:46:42'),(9087,7211,'Y','18','024','14','A','','','TE','0000712484','0000712484','','IL','1','BAISDEN','ROBIN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-21','M','',NULL,NULL,NULL,'','494544','','2013-12-18','2013-12-18 10:07:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:06:59'),(17558,14039,'Y','18','021','EC','A','','','AC','0000106504','0000106504','TX00001513797','IL','1','Rangel','Jesseca','','','','34','459594141','1801 S LINDEN ST',0,'PHARR','TX','78577','7176','CY','48215','1980-10-22','F','U',':RET:2106-3','N','021','DEN','2295525','33348TX002000101','2014-02-01','2014-01-12 17:46:34','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-01-13 03:01:59'),(16923,13543,'Y','18','021','EC','A','','','AC','0002256543','0002256543','LA00002173724','IL','1','Nguyen','Long','','','','34','437416837','1071 ROBERT BLVD',0,'SLIDELL','LA','70458','2048','CY','22103','1976-07-11','M','M',NULL,'N','021','DEN','2441487','18575LA002000201','2014-02-01','2014-01-08 18:40:31','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:45'),(16577,13259,'Y','18','021','EC','A','','','AC','0001168012','0001168012','OH00001960031','IL','1','Gerken','Jessica','','','','34','272964751','315 N KEYSER ST',0,'HOLGATE','OH','43527','9579','CY','39069','1992-12-06','F','U',':RET:2106-3','N','021','HLT','2085129','92036OH004002601','2014-02-01','2014-01-05 14:57:23','117.00',NULL,NULL,'156.79','39.79','R-OH001','OH0','156.79',NULL,1,'2014-01-07 10:23:33'),(14210,11331,'N','01','021','EC','A',NULL,NULL,'','0000400559','0000782840','','IL','1','PARKER','THANYNAN','P','','','34','695941447','6102 MILWEE ST',0,'HOUSTON','TX','77092',NULL,'CY','48201','1975-02-03','F','',NULL,'N','021','DEN','1513221','33348TX002000201','2014-02-01','2013-12-26 14:57:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-27 02:04:29'),(23510,18728,'Y','18','021','EC','A','','','AC','0001257135','0001257135','MS00002185174','IL','1','CONNER','EMORY','','','','34','423236439','1207 FAIRVIEW DR',0,'WAYNESBORO','MS','39367','2111','CY','28153','1982-05-06','M','U',':RET:2106-3','N','021','DEN','3803192','46300MS002000101','2014-03-01','2014-02-12 23:05:30','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-13 22:02:13'),(25858,20500,'Y','18','024','14','A','','','TE','0000139601','0000139601','','IL','1','Robinson','Alaysha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-08-31','F','',NULL,NULL,NULL,'','1090517','','2014-03-13','2014-02-26 10:22:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-26 21:00:44'),(26585,21079,'Y','18','021','EC','A','','','AC','0000427691','0000427691','OH00003520488','IL','1','McGraner','Gina','','','','34','271884541','7393 CIMMARON STA',0,'COLUMBUS','OH','43235','4259','CY','39049','1975-02-06','F','U',':RET:2106-3','N','021','DEN','3350490','99734OH005000401','2014-04-01','2014-02-28 16:04:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:32'),(27704,21908,'Y','18','021','EC','A','','','AC','0000957771','0000957771','TX00003759418','IL','1','Houghton','Ronald','','','','34','466067867','1819 S 5TH',0,'MERKEL','TX','79536','4525','CY','48441','1964-12-27','M','R',NULL,'T','021','DEN','3849888','33348TX002000201','2014-04-01','2014-03-05 12:03:51','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-03-05 21:30:50'),(1031,845,'Y','18','021','EC','A','','','AC','0000089642','0000089642','TX00000579560','IL','1','saldana','celia','','','','34','458136129','416 S. Georgia St.',0,'Mercedes','TX','78570',NULL,'CY','48215','1972-03-02','F','M',NULL,'N','021','DEN','941137','33348TX002000201','2014-01-01','2013-12-03 10:35:03','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 18:15:30'),(2763,2234,'Y','18','021','EC','A','','','AC','0000848309','0000848309','OH00000321518','IL','1','Apple','Stephen','','','','34','302460702','5911 CLEVELAND RD',0,'WOOSTER','OH','44691','1141','CY','39169','1951-04-10','M','U',':RET:2106-3','N','021','HLT','458786','52664OH151001304','2014-01-01','2013-12-02 08:55:24','425.00',NULL,NULL,'640.70','215.70','R-OH014','OH0','640.70',NULL,0,'2013-12-25 19:49:21'),(6488,5139,'Y','18','021','EC','A','','','AC','0001147314','0001147314','OH00000175466','IL','1','McCarty','Dana','Sue','','','34','294560332','3656 LOUISE ST',0,'MOGADORE','OH','44260','1118','CY','39153','1953-10-19','F','U',':RET:2106-3','T','021','HLT','748329','52664OH151001305','2014-01-01','2013-12-11 11:32:44','474.00',NULL,NULL,'696.03','222.03','R-OH012','OH0','696.03',NULL,0,'2013-12-26 00:50:29'),(13079,10426,'N','01','021','EC','A',NULL,NULL,'','0000082525','0000084002','','IL','1','Devore','Steven','Douglas','','','34','286588013','1300 4TH ST',0,'LOGAN','OH','43138','1049','CY','39073','1959-10-17','M','',NULL,'N','021','DEN','1526877','99734OH005000401','2014-01-01','2013-12-23 10:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:31'),(13251,10575,'Y','18','021','EC','A','','','AC','0001262849','0001262849','TX00000317693','IL','1','Simmons','Dean','','','','34','552517893','2166 baja circle',0,'Los Fresnos','TX','78566',NULL,'CY','48061','1965-10-28','M','M',':RET:2106-3','N','021','DEN','1562413','33348TX002000201','2014-01-01','2013-12-23 11:15:14','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 12:56:23'),(17063,13655,'Y','18','021','EC','A','','','AC','0000206707','0000206707','TX00001986304','31','1','Michlin','Laurence','','','','34','466537072','PO BOX 1076',0,'Prosper','TX','75078',NULL,'CY','48121','1966-07-20','M','U',':RET:2106-3','N','021','DEN','1866116','33348TX002000201','2014-02-01','2014-01-07 21:32:48','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:13'),(26106,20705,'Y','18','024','14','A','','','TE','0000846187','0000846187','','IL','1','Mattes','Jacob',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-12-22','M','',NULL,NULL,NULL,'','2780572','','2014-02-26','2014-02-26 23:18:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-28 06:30:14'),(28905,22879,'Y','18','021','EC','A','','','AC','0000368570','0000368570','TX00003388582','IL','1','MCANALLY','CONOR','','','','34','632601244','1505 MAIN ST',0,'BASTROP','TX','78602','2923','CY','48021','1952-03-24','M','M',NULL,'N','021','DEN','3741164','33348TX002000201','2014-04-01','2014-03-10 17:30:19','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-10 21:00:23'),(23091,18408,'Y','18','021','EC','A','','','AC','0000187513','0000187513','OH00002067603','IL','1','King','Raymonda','','','','34','271584819','503 WALNUT ST',0,'ELYRIA','OH','44035','3363','CY','39093','1955-08-27','F','U',':RET:2106-3','T','021','DEN','3547491','99734OH005000401','2014-03-01','2014-02-12 11:40:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:07'),(23144,18450,'Y','18','024','14','A','','','TE','0000912998','0000912998','','IL','1','HILDRETH','MICHELLE','R',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-04-20','F','',NULL,NULL,NULL,'','3656823','','2014-02-12','2014-02-12 12:27:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:31:38'),(24498,19462,'Y','18','021','EC','A','','','AC','0000053520','0000053520','TX00002905319','IL','1','Hurst','Frederick','','','','34','456230180','4201 CARMEL AVE',0,'FORT WORTH','TX','76119','3847','CY','48439','1970-12-21','M','U',':RET:2054-5','N','021','DEN','3859002','33348TX002000201','2014-04-01','2014-02-18 20:10:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:47:46'),(25377,20134,'N','19','021','EC','A',NULL,NULL,'','0001097825','0000965826','','IL','1','Barber','Crystal','A','','','34','300948338','326 Brookhaven Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','1992-08-19','F','',':RET:2054-5','N','021','DEN','2931619','99734OH005000301','2014-04-01','2014-02-25 16:20:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:44'),(25630,20332,'N','01','021','EC','A',NULL,NULL,'','0000685891','0000418940','','IL','1','tucker','Erinn','','','','34','295829815','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','1974-09-27','F','',':RET:2106-3','N','021','DEN','3742050','99734OH005000301','2014-04-01','2014-02-21 19:35:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 08:30:22'),(25857,20499,'Y','18','021','EC','A','','','AC','0001936915','0001936915','LA00002625142','IL','1','Dien','Phung','','','','34','244732883','67 TERRA AVE',0,'ALEXANDRIA','LA','71303','2259','CY','22079','1961-07-15','F','U',':RET:2047-9','N','021','DEN','3386913','18575LA002000201','2014-03-01','2014-02-26 10:20:49','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-26 21:00:43'),(27055,21424,'Y','18','021','EC','A','','','AC','0000399894','0000399894','OH00003359880','IL','1','GREEN','ANGELA','','','','34','278840124','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1974-09-19','F','M',':RET:2106-3','T','021','HLT','3076432','92036OH003002704','2014-04-01','2014-03-03 13:43:55','657.00',NULL,NULL,'1053.31','396.31','R-OH006','OH0','295.53','CIC',0,'2014-03-03 21:00:27'),(28755,22759,'Y','18','021','EC','A','','','AC','0000408207','0000408207','TX00003608428','IL','1','Le','Thu','A','','','34','636045349','8140 La Frontera Trial',0,'Arlington','TX','76002',NULL,'CY','48439','1959-10-20','F','M',':RET:2047-9','N','021','DEN','3849086','33348TX002000201','2014-04-01','2014-03-09 10:57:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-09 21:00:18'),(29141,23068,'N','01','021','EC','A',NULL,NULL,'','0000646075','0000776498','','IL','1','Killion','Patricia',NULL,NULL,NULL,NULL,NULL,'322 SENECA ST',0,'DEFIANCE','OH','43512','2231','CY','39039','1955-01-10','F','',NULL,'N','021','HLT','4344272','92036OH005002605','2014-04-01','2014-03-10 12:17:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','507.58',NULL,0,'2014-03-10 21:02:43'),(1558,1300,'Y','18','021','EC','A','','','AC','0000002405','0000002405','MS00000892991','IL','1','Hamlett','MarLisa','','','','34','490949505','2119 woodland way',0,'Jackson','MS','39209',NULL,'CY','28049','1987-05-12','F','U',':RET:2054-5','N','021','DEN','2451740','46300MS002000201','2014-01-01','2013-12-24 15:31:31','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:50:48'),(5149,4082,'Y','18','021','EC','A','','','AC','0001057980','0001057980','OH00001288243','IL','1','Gamble','WILLIAM','','','','34','288523662','1816 MILDEN RD',0,'COLUMBUS','OH','43221','1936','CY','39049','1952-04-26','M','M',':RET:1002-5^:RET:2054-5^:RET:2106-3','N','021','DEN','2284195','99734OH005000401','2014-01-01','2013-12-19 09:25:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:02:45'),(19919,15885,'Y','18','021','EC','A','','','AC','0000707455','0000707455','MS00002370935','IL','1','THOMPSON','WILLIE','E','','','34','427112784','110 WINNSBORO CT',0,'JACKSON','MS','39206','2520','CY','28049','1957-03-14','M','U',NULL,'N','021','DEN','2920526','46300MS002000101','2014-03-01','2014-01-24 12:06:12','0.00',NULL,NULL,'81.45','81.45','R-MS003','MS0','27.15',NULL,0,'2014-01-24 21:01:04'),(18703,14912,'Y','18','021','EC','A','','','AC','0000937295','0000937295','OH00002563073','IL','1','Zinn','Gory','','','','34','289781468','7828 Pattonsville Rd',0,'Jackson','OH','45640',NULL,'CY','39079','1965-05-23','M','M',':RET:2106-3','N','021','DEN','2380451','99734OH005000301','2014-02-01','2014-01-15 18:36:39','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2014-01-17 03:35:29'),(2382,1944,'Y','18','021','EC','A','','','AC','0000271405','0000271405','OH00000707971','IL','1','PIERRE','BERSONN','','','','34','733018710','4207 SUNDANCE DR',0,'COLUMBUS','OH','43224','1852','CY','39049','1969-05-22','M','M',':RET:2054-5','N','021','DEN','1134243','99734OH005000401','2014-01-01','2013-12-09 10:40:18','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:03'),(4787,3797,'N','01','021','EC','A',NULL,NULL,'','0000505713','0000983810','','IL','1','Ruedlinger','Janet','','','','34','281622675','125 GARFIELD ST',0,'WADSWORTH','OH','44281','1431','CY','39103','1969-07-02','F','',':RET:2106-3','N','021','HLT','1233676','52664OH151001305','2014-01-01','2013-12-07 19:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2013-12-25 22:16:13'),(15254,12192,'Y','18','021','EC','A','','','AC','0000457819','0000457819','OH00001309133','IL','1','Parks','Kim','','','','34','288561997','1411 S UNION ST',0,'LIMA','OH','45804','2155','CY','39003','1956-04-29','F','U',':RET:2054-5','T','021','HLT','1926608','92036OH002001501','2014-02-01','2013-12-30 13:22:15','424.00',NULL,NULL,'712.31','288.31','R-OH002','OH0','712.31',NULL,0,'2014-01-01 12:09:03'),(14348,11444,'N','19','021','EC','A',NULL,NULL,'','0000514453','0000234054','','IL','1','Chen','Ryan',NULL,NULL,NULL,NULL,NULL,'1079 STREAM RIDGE LN',0,'CINCINNATI','OH','45255','4323','CY','39061','2001-05-23','M','',':RET:2034-7','N','021','HLT','1945675','92036OH006001201','2014-02-01','2013-12-26 17:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-27 02:08:04'),(13716,10945,'Y','18','021','EC','A','','','AC','0000430272','0000430272','OH00000867528','IL','1','Campbell','Robert','','','','34','285802225','368 CRAGGY CREEK DR',0,'CHIPPEWA LAKE','OH','44215','9714','CY','39103','1967-07-23','M','U',':RET:2106-3','N','021','HLT','2600258','52664OH151001305','2014-01-01','2013-12-23 15:36:30','100.00',NULL,NULL,'334.51','234.51','R-OH012','OH0','334.51',NULL,0,'2013-12-26 13:09:04'),(13536,10792,'Y','18','021','EC','A','','','AC','0001951050','0001951050','LA00000507578','IL','1','NICHOLS','SHERRY','MORAN','','','34','431276266','6503 RODEO DRIVE',0,'BASTROP','LA','71220',NULL,'CY','22067','1959-04-04','F','R',':RET:2106-3','N','021','DEN','2311864','18575LA002000201','2014-01-01','2013-12-23 12:48:55','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 13:03:37'),(7647,6054,'Y','18','021','EC','A','','','AC','0001126832','0001126832','OH00001172858','IL','1','Converse','Paul','','','','34','365048633','227 E STATE ST',0,'ATHENS','OH','45701','1752','CY','39009','1987-11-22','M','U',NULL,'N','021','DEN','741716','99734OH005000301','2014-01-01','2013-11-10 16:00:26','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-26 02:46:44'),(6012,4759,'Y','18','021','EC','A','','','AC','0000672727','0000672727','OH00001264368','IL','1','Morris','Beth','','','','34','270528156','363 QUEENS DR N',0,'NEWARK','OH','43055','2241','CY','39089','1950-06-23','F','M',':RET:2106-3','N','021','DEN','1144937','99734OH005000301','2014-01-01','2013-12-01 14:19:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:00:37'),(22783,18190,'Y','18','021','EC','A','','','AC','0000810825','0000810825','OH00002440126','IL','1','Dahlin','Amanda','','','','34','095707783','1732 Juniper Dr',0,'Bowling Green','OH','43402',NULL,'CY','39173','1983-11-22','F','M',NULL,'N','021','DEN','3741728','99734OH005000301','2014-03-01','2014-02-10 21:20:08','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-11 21:01:45'),(23901,19013,'Y','18','021','EC','A','','','AC','0000158038','0000158038','OH00001501007','IL','1','roof','susan','','','','34','295669448','8416 STATE ROUTE 4',0,'MECHANICSBURG','OH','43044','9741','CY','39021','1964-07-31','F','U',NULL,'N','021','HLT','2725588','92036OH004000501','2014-03-01','2014-02-14 17:08:17','513.43',NULL,NULL,'517.21','3.78','R-OH003','OH0','326.08',NULL,0,'2014-02-14 21:32:24'),(24490,19455,'Y','18','021','EC','A','','','AC','0001245588','0001245588','TX00002961182','IL','1','PEREZ','YOLANDA','','','','34','454027708','1705 AVE ELLE',0,'BAY CITY','TX','77414',NULL,'CY','48321','1954-03-10','F','U',NULL,'N','021','DEN','3585101','33348TX002000201','2014-04-01','2014-02-18 18:06:15','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-20 03:44:10'),(26345,20901,'N','19','021','EC','A',NULL,NULL,'','0001066040','0000809731','','IL','1','MOTE','AMBERLIN','','','','34','293022868','1425 TEN MILE RD',0,'NEW RICHMOND','OH','45157','9113','CY','39025','1997-12-10','F','',':RET:2106-3','N','021','HLT','3569741','92036OH004000601','2014-03-01','2014-02-27 12:17:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-28 06:31:45'),(26687,21158,'Y','18','021','EC','A','','','AC','0001589120','0001589120','LA00003302642','IL','1','Thomas','William','','','','34','439961674','141 EUREKA DR',0,'GRAY','LA','70359','3256','CY','22109','1956-01-07','M','U',':RET:2106-3','N','021','DEN','3023318','18575LA002000101','2014-03-01','2014-02-27 19:17:23','0.00',NULL,NULL,'25.02','25.02','R-LA002','LA0','25.02',NULL,0,'2014-02-28 21:31:26'),(1234,1017,'Y','18','021','EC','A','','','AC','0000819664','0000819664','LA00000032226','IL','1','Mukerji','Shampa','','','','34','428676825','1831 MULLEN DR',0,'BATON ROUGE','LA','70810','3358','CY','22033','1959-11-05','F','M',':RET:2029-7','N','021','DEN','701931','18575LA002000101','2014-01-01','2013-12-03 15:36:25','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:20:48'),(20751,16581,'Y','18','021','EC','A','','','AC','0000667813','0000667813','OH00001678081','IL','1','Sund','Kelli','','','','34','279845255','2840 Kendale Dr',0,'Toledo','OH','43606',NULL,'CY','39095','1985-12-30','F','R',':RET:2106-3','N','021','HLT','2947425','92036OH002002601','2014-03-01','2014-01-30 11:03:12','0.00',NULL,NULL,'244.79','244.79','R-OH001','OH0','244.79',NULL,0,'2014-01-30 21:01:30'),(18833,15000,'Y','18','021','EC','A','','','AC','0001100618','0001100618','OH00001565347','IL','1','Subba','Naresh','','','','34','300068034','1890 PLEASANT VALLEY RD',0,'STREETSBORO','OH','44241','6281','CY','39133','1968-02-07','M','M',':RET:2028-9','N','021','HLT','2096944','52664OH151001306','2014-02-01','2014-01-15 21:00:51','444.00',NULL,NULL,'612.38','168.38','R-OH012','OH0','322.02',NULL,0,'2014-01-17 03:36:10'),(1597,1335,'Y','18','021','EC','A','','','AC','0000302656','0000302656','TX00000784033','IL','1','mcgee','mary','','','','34','506689025','564 GRACE LN',0,'COPPELL','TX','75019','4822','CY','48113','1951-01-14','F','U',NULL,'N','021','DEN','1751484','33348TX002000201','2014-01-01','2013-12-24 12:20:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:51:56'),(16925,13544,'Y','18','021','EC','A','','','AC','0002389493','0002389493','LA00001985192','IL','1','Dejoie','shondrica','','','','34','435417868','4711 LAFAYE ST',0,'NEW ORLEANS','LA','70122','6135','CY','22071','1980-03-31','F','U',':RET:2054-5','N','021','DEN','1735506','18575LA002000201','2014-02-01','2014-01-08 20:48:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:19:45'),(14754,11780,'Y','18','021','EC','A','','','AC','0000627881','0000627881','OH00001393926','IL','1','shearer','randall','','','','34','272763670','2405 NORTHWEST BLVD NW',0,'WARREN','OH','44485','2310','CY','39155','1965-05-30','M','U',':RET:2106-3','N','021','HLT','2166000','92036OH006003201','2014-02-01','2013-12-28 17:27:51','272.00',NULL,NULL,'313.86','41.86','R-OH013','OH0','313.86',NULL,1,'2013-12-29 11:10:23'),(14025,11171,'N','01','021','EC','A',NULL,NULL,'','0000865860','0000324839','','IL','1','HUA','TULE','','','','34','283904424','1208 HOLLY DR',0,'SPRINGFIELD','OH','45504','4141','CY','39023','1958-12-14','F','',':RET:2047-9','N','021','HLT','2044515','92036OH002000501','2014-01-01','2013-12-23 10:50:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','612.16',NULL,0,'2013-12-26 13:16:42'),(7371,5837,'N','01','021','EC','A',NULL,NULL,'','0000258116','0001229278','','IL','1','williams','antonio','','','','34','300566111','2011 CREST RD',0,'CINCINNATI','OH','45240','2063','CY','39061','1956-07-12','M','',':RET:2054-5','N','021','DEN','1185264','99734OH005000401','2014-01-01','2013-11-23 09:43:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:40'),(2458,1999,'Y','18','021','EC','A','','','AC','0000397007','0000397007','TX00000989552','IL','1','SMITH','JEFFREY','','','','34','449717620','7812 KIRKLAND CT',0,'DALLAS','TX','75237','3619','CY','48113','1971-07-29','M','M',':RET:2054-5','N','021','DEN','105474','33348TX002000101','2014-01-01','2013-12-09 13:16:33','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:34:50'),(21114,16870,'N','01','021','EC','A',NULL,NULL,'','0000497145','0001240520','','IL','1','Gage','Stacy','Leann','','','34','465874205','32946 CR 2142',0,'Kemp','TX','75143',NULL,'CY','48213','1979-11-20','F','',':RET:2106-3','N','021','DEN','2825314','33348TX002000201','2014-03-01','2014-02-02 18:47:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-03 21:00:09'),(22980,18322,'Y','18','021','EC','A','','','AC','0000168928','0000168928','OH00001829157','IL','1','holm','devin','','','','34','301909758','12055 fifth st',0,'millersport','OH','43046',NULL,'CY','39045','1987-05-15','M','U',':RET:2106-3','N','021','DEN','3818040','99734OH005000301','2014-03-01','2014-02-11 21:53:02','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:30:08'),(26613,21102,'Y','18','024','14','A','','','TE','0000719027','0000719027','','IL','1','Haley','Sharon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-08','F','',NULL,NULL,NULL,'','3253464','','2014-02-28','2014-02-28 10:50:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 21:30:48'),(28912,22885,'Y','18','021','EC','A','','','AC','0000643296','0000643296','OH00002808240','IL','1','Kolar','Cynthia','','','','34','277605398','6510 Morrow Cozaddale',0,'Morrow','OH','45152',NULL,'CY','39165','1962-07-23','F','M',':RET:2106-3','T','021','DEN','3470217','99734OH005000301','2014-04-01','2014-03-10 09:20:56','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:00:27'),(3128,2513,'Y','18','021','EC','A','','','AC','0000119012','0000119012','OH00000936324','IL','1','Lehmkuhl','Daniel','','','','34','295523031','11639 Eddington Avenue',0,'Pickerington','OH','43147',NULL,'CY','39045','1952-11-29','M','U',NULL,'N','021','DEN','477420','99734OH005000301','2014-01-01','2013-10-13 14:48:55','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:30:25'),(4242,3379,'Y','18','021','EC','A','','','AC','0000606514','0000606514','TX00000068965','IL','1','Reveles Contreras','Martha','','','','34','568712486','12053 van Dyck',0,'el Paso','TX','79936',NULL,'CY','48141','1956-01-02','F','U',NULL,'N','021','DEN','1628073','33348TX002000201','2014-01-01','2013-12-17 16:35:08','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 21:51:04'),(7341,5814,'N','01','021','EC','A',NULL,NULL,'','0001200874','0000674055','','IL','1','Bunton','Sabrina','','','','34','298542279','1135 STONER ST',0,'AKRON','OH','44320','3507','CY','39153','1955-05-12','F','',':RET:2054-5','N','021','HLT','1213088','52664OH152000901','2014-01-01','2013-12-14 16:12:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','416.19',NULL,0,'2013-12-26 02:04:02'),(18688,14898,'Y','18','021','EC','A','','','AC','0002116194','0002116194','LA00001780701','IL','1','Buttram','Barry','','','','34','252451896','303 LINTWIN CIR',0,'BENTON','LA','71006','9346','CY','22015','1978-09-08','M','U',NULL,'N','021','DEN','2861548','18575LA002000101','2014-02-01','2014-01-15 23:13:03','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-17 03:35:23'),(18423,14698,'Y','18','021','EC','A','','','AC','0001320373','0001320373','LA00001804411','IL','1','Mark','Reginald','','','','34','436293090','2312 SAINT BERNARD AVE',0,'NEW ORLEANS','LA','70119','1502','CY','22071','1966-02-19','M','U',':RET:2054-5','N','021','DEN','2236163','18575LA002000201','2014-02-01','2014-01-15 00:48:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:54'),(18351,14649,'N','19','021','EC','A',NULL,NULL,'','0000393694','0000702789','','IL','1','miller','dylan','shawn','','','34','283087525','31600 north marginal rd',0,'willowick','OH','44095',NULL,'CY','39085','2003-07-01','M','',':RET:2106-3','N','021','DEN','1560829','99734OH005000301','2014-02-01','2014-01-14 19:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:21'),(15871,12709,'Y','18','021','EC','A','','','AC','0000626764','0000626764','MS00001257460','IL','1','Cain','Anthony','','','','34','428295352','4399 SCR 99',0,'Bay Springs','MS','39422',NULL,'CY','28129','1967-01-19','M','M',':RET:2106-3','N','021','DEN','1742446','46300MS002000101','2014-02-01','2014-01-02 16:39:07','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-01-03 02:05:06'),(25546,20267,'Y','18','021','EC','A','','','AC','0000380110','0000380110','OH00001908360','IL','1','Hester','Ryan','S','','','34','290988308','3550 FREEMAN AVE',0,'HAMILTON','OH','45015','1755','CY','39017','1995-11-29','M','U',':RET:2106-3','N','021','DEN','3798590','99734OH005000401','2014-04-01','2014-02-23 13:36:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-26 08:00:15'),(28393,22463,'Y','18','021','EC','A','','','AC','0001088330','0001088330','OH00003006362','IL','1','Allen','Chloe','M','','','34','246973344','No street address Available',0,'Columbus','OH','43219',NULL,'CY','39049','2001-11-08','F','R',NULL,'N','021','DEN','3284019','99734OH005000401','2014-04-01','2014-03-06 18:29:43','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-03-07 21:30:46'),(29059,22999,'Y','18','021','EC','A','','','AC','0001178248','0001178248','OH00002959494','IL','1','watson','george','','','','34','413824690','1164 W LAKESIDE DR SW',0,'SHERRODSVILLE','OH','44675','9732','CY','39019','1951-03-30','M','U',':RET:2106-3','N','021','DEN','3973440','99734OH005000401','2014-04-01','2014-03-10 16:34:41','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-03-10 21:01:50'),(5297,4198,'Y','18','021','EC','A','','','AC','0001178166','0001178166','OH00001174608','IL','1','Ruschau','Nicholas','','','','34','283861818','310 Parkview',0,'Cridersville','OH','45806',NULL,'CY','39011','1986-07-14','M','U',':RET:2106-3','N','021','HLT','1899449','92036OH003001506','2014-01-01','2013-12-18 20:26:53','194.00',NULL,NULL,'240.86','46.86','R-OH002','OH0','240.86',NULL,0,'2013-12-25 23:06:12'),(3962,3169,'Y','18','021','EC','A','','','AC','0000110507','0000110507','OH00001162298','IL','1','Cushwa','Charles','','','','34','300523617','2655 N PARK BLVD',0,'CLEVELAND HEIGHTS','OH','44106','3622','CY','39035','1968-02-22','M','R',':RET:2106-3','N','021','HLT','1078795','52664OH151001501','2014-01-01','2013-12-13 16:02:40','0.00',NULL,NULL,'993.37','993.37','R-OH011','OH0','435.60',NULL,0,'2013-12-25 21:38:25'),(18001,14384,'Y','18','021','EC','A','','','AC','0001043409','0001043409','OH00002077454','IL','1','Nelson','Shamecka','','','','34','404085979','112 GLADYS CT',0,'OBERLIN','OH','44074','1716','CY','39093','1977-07-16','F','U',':RET:2054-5','N','021','DEN','2672047','99734OH005000301','2014-02-01','2014-01-13 21:34:40','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:59'),(7574,5993,'Y','18','021','EC','A','','','AC','0000429018','0000429018','OH00000815505','IL','1','Gingerich','Jacob','','','','34','308681346','322 N ASH ST',0,'CELINA','OH','45822','1739','CY','39107','1957-09-05','M','U',':RET:2106-3','N','021','HLT','239167','92036OH005001505','2014-01-01','2013-12-15 10:44:44','432.00',NULL,NULL,'513.45','81.45','R-OH002','OH0','513.45',NULL,0,'2013-12-26 02:33:48'),(14693,11731,'Y','18','021','EC','A','','','AC','0000383369','0000383369','OH00001715996','IL','1','PHILBRICK','cythnia','','','','34','295623227','56 E SMILEY AVE',0,'SHELBY','OH','44875','1048','CY','39139','1958-09-03','F','M',NULL,'N','021','DEN','2552362','99734OH005000401','2014-02-01','2013-12-27 19:25:37','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,1,'2013-12-29 11:08:51'),(14666,11707,'N','01','021','EC','A',NULL,NULL,'','0000142133','0000738518','','IL','1','BURGESS','JAMES','','','','34','467062653','160 VANVANDT CR 2724',0,'MABANK','TX','75147',NULL,'CY','48467','1963-11-26','M','',NULL,'N','021','DEN','1921323','33348TX002000201','2014-02-01','2013-12-28 15:39:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2013-12-29 11:08:07'),(7496,5929,'N','01','021','EC','A',NULL,NULL,'','0000796942','0000382134','','IL','1','SAXOUR','JOHN','','','','34','280481204','65 MCCLAIN AVE',0,'NEW HOLLAND','OH','43145','9602','CY','39047','1950-09-28','M','',':RET:2106-3','N','021','DEN','1172143','99734OH005000401','2014-01-01','2013-12-15 15:06:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:43'),(16662,13333,'Y','18','021','EC','A','','','AC','0001719010','0001719010','LA00001146617','IL','1','Brass','Aldeaner','','','','34','571111370','108 WARDEN ST',0,'DELHI','LA','71232','2443','CY','22083','1957-12-29','F','U',NULL,'N','021','DEN','2091272','18575LA002000101','2014-02-01','2014-01-07 12:50:41','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-08 18:24:25'),(23329,18594,'Y','18','021','EC','A','','','AC','0000222438','0000222438','OH00002128939','IL','1','frederick','sherry','l','','','34','302680150','3035 PRINCETON ST',0,'madison','OH','44057',NULL,'CY','39085','1962-08-15','F','U',NULL,'N','021','DEN','2805177','99734OH005000301','2014-03-01','2014-02-13 15:08:36','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:29'),(24210,19228,'Y','18','021','EC','A','','','AC','0001870566','0001870566','LA00002180361','IL','1','Diaz','Jose','','','','34','609318056','2568 ROOSEVELT BLVD',0,'KENNER','LA','70062','5650','CY','22051','1967-11-08','M','M',NULL,'N','021','DEN','3062325','18575LA002000201','2014-04-01','2014-02-16 17:00:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-16 19:00:23'),(24524,19481,'N','01','021','EC','A',NULL,NULL,'','0000234502','0000148358','','IL','1','MENDEZ','MA ADELA','','','','34','640408931','8529 OLD HEARNE RD',0,'HEARNE','TX','77859','3977','CY','48395','1957-09-08','F','',':RET:2106-3','N','021','DEN','3439517','33348TX002000201','2014-04-01','2014-02-19 15:00:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:58:33'),(1624,1357,'Y','18','021','EC','A','','','AC','0000351733','0000351733','TX00000949200','IL','1','Kankonde','Peggy','','','','34','800227595','11101 BILL HILL DR',0,'EL PASO','TX','79936','4601','CY','48141','1961-11-12','F','M',':RET:2106-3','N','021','DEN','2049654','33348TX002000201','2014-01-01','2013-12-24 14:01:38','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2013-12-25 18:52:39'),(21584,17241,'N','01','021','EC','A',NULL,NULL,'','0000615549','0000884260','','IL','1','Barchalk','Helene','M','','','34','271547018','801 Franklin Avenue',0,'Kent','OH','44240',NULL,'CY','39133','1954-10-04','F','',':RET:2106-3','T','021','HLT','3742625','52664OH151001306','2014-03-01','2014-02-05 16:48:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','667.56',NULL,0,'2014-02-05 21:30:27'),(19146,15254,'Y','18','021','EC','A','','','AC','0000488991','0000488991','TX00002161769','IL','1','Wittenstrom','Lauri','','','','34','340523931','611 E. 45th st.',0,'Austin','TX','78751',NULL,'CY','48453','1964-03-17','F','U',':RET:2106-3','N','021','DEN','2902901','33348TX002000201','2014-03-01','2014-01-19 11:14:42','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-21 08:45:32'),(5591,4436,'Y','18','021','EC','A','','','AC','0000665593','0000665593','OH00000460542','IL','1','tomblin','jayson','','','','34','289745041','136 hagenbuch st',0,'urbana','OH','43078',NULL,'CY','39021','1972-09-22','M','U',':RET:2106-3','N','021','HLT','188193','92036OH004000501','2014-01-01','2013-11-06 07:47:16','247.04',NULL,NULL,'248.86','1.82','R-OH003','OH0','248.86',NULL,0,'2013-12-25 23:17:16'),(17830,14243,'N','01','021','EC','A',NULL,NULL,'','0001046505','0001070304','','IL','1','hardy','roger','b','','','34','587637682','142 COLLINWOOD LN',0,'BRANDON','MS','39042','9147','CY','28121','1981-08-02','M','',':RET:2106-3','N','021','DEN','2572682','46300MS002000201','2014-02-01','2014-01-14 14:20:59',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-15 02:05:59'),(3160,2542,'Y','18','021','EC','A','','','AC','0001162557','0001162557','OH00000279730','IL','1','Robare','Ann','','','','34','297521966','9978Magnolia',0,'Olmsted Falls','OH','44138',NULL,'CY','39035','1952-10-12','F','U',':RET:2106-3','N','021','DEN','114994','99734OH005000401','2014-01-01','2013-11-18 08:42:04','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:31:17'),(3579,2872,'N','19','021','EC','A',NULL,NULL,'','0001225702','0001088265','','S1','1','Lowell','Ginger','','','','34','296086140','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','2004-04-02','F','',':RET:2106-3','N','021','HLT','2295943','92036OH006000601','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2013-12-25 21:22:43'),(6694,5306,'Y','18','021','EC','A','','','AC','0000605422','0000605422','TX00000099016','IL','1','Wigington','Pamela','','','','34','644307562','119 S 5th',0,'Jacksboro','TX','76458',NULL,'CY','48237','1992-02-12','F','U',':RET:2106-3','N','021','DEN','130021','33348TX002000201','2014-01-01','2013-11-05 13:30:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:01:40'),(23330,18595,'Y','18','021','EC','A','','','AC','0000787240','0000787240','OH00001533350','IL','1','ROTHENBUSH','MARY','','','','34','300883233','3502 WILMINGTON RD',0,'LEBANON','OH','45036','8916','CY','39165','1973-05-01','F','U',':RET:2106-3','N','021','DEN','3126213','99734OH005000301','2014-03-01','2014-02-13 15:10:26','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:30'),(24248,19254,'Y','18','021','EC','A','','','AC','0000402502','0000402502','OH00002930834','31','1','Schulze','Michael','','','','34','288421141','PO BOX 295',0,'BATAVIA','OH','45103',NULL,'CY','39025','1958-12-16','M','M',':RET:2106-3','N','021','HLT','2783106','92036OH002000601','2014-04-01','2014-02-16 09:40:31','526.00',NULL,NULL,'1131.20','605.20','R-OH005','OH0','552.84',NULL,0,'2014-02-16 19:00:42'),(24715,19624,'Y','18','021','EC','A','','','AC','0001152249','0001152249','OH00002270652','IL','1','kunsman','tabitha','','','','34','301747143','1100 WHITTLESAY LN',0,'ROCKY RIVER','OH','44116','2162','CY','39035','1979-09-15','F','U',':RET:2106-3','N','021','DEN','3136101','99734OH005000401','2014-04-01','2014-02-19 08:31:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:36:47'),(24927,19767,'Y','18','021','EC','A','','','AC','0000911810','0000911810','OH00003072914','IL','1','Chura','Jolanta','','','','34','497110870','572 CRESTVIEW AVE',0,'AKRON','OH','44320','1915','CY','39153','1972-01-19','F','U',NULL,'N','021','HLT','3540472','52664OH151001501','2014-04-01','2014-02-20 15:14:07','13.00',NULL,NULL,'354.39','341.39','R-OH012','OH0','354.39','CIC',0,'2014-02-20 21:30:17'),(24964,19798,'Y','18','021','EC','A','','','AC','0002185758','0002185758','LA00002668895','IL','1','Richard','Valerie','','','','34','438372214','212 Jewel St.',0,'New Orleans','LA','70124',NULL,'CY','22071','1979-03-18','F','U',':RET:2106-3','N','021','DEN','3854583','18575LA002000201','2014-04-01','2014-02-20 17:52:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:21'),(6166,4888,'Y','18','021','EC','A','','','AC','0000470981','0000470981','OH00000668174','IL','1','GOSHORN','MARGRET','','','','34','270525922','1219 TRADITIONS TURN',0,'BATAVIA','OH','45103',NULL,'CY','39025','1951-05-13','F','M',':RET:2106-3','N','021','HLT','1022839','92036OH002000601','2014-01-01','2013-11-21 14:41:17','963.00',NULL,NULL,'1424.48','461.48','R-OH005','OH0','712.24',NULL,0,'2013-12-26 00:16:56'),(5255,4168,'N','19','021','EC','A',NULL,NULL,'','0001212337','0001147330','','IL','1','Haffner','Alexandra','','','','34','268966666','6898 GREENBRIAR DR',0,'PARMA HEIGHTS','OH','44130','4661','CY','39035','1992-07-21','F','',':RET:2106-3','N','021','HLT','2069214','52664OH151001305','2014-01-01','2013-12-19 10:05:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2013-12-25 23:05:14'),(20173,16098,'N','19','021','EC','A',NULL,NULL,'','0000207160','0000478509','','IL','1','BAKER','DEQUAN','','','','34','295942167','269 SOUTH EAGLE STREET',0,'GENEVA','OH','44041',NULL,'CY','39007','1992-08-14','M','',':RET:2054-5','N','021','HLT','1448622','52664OH151001301','2014-03-01','2014-01-27 12:47:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2014-01-27 21:01:16'),(19345,15421,'Y','18','021','EC','A','','','AC','0000163712','0000163712','OH00002008749','IL','1','Zohnd','Whitney','','','','34','280906393','6039 SAINT JACOBS LOGTOWN RD',0,'LISBON','OH','44432','8408','CY','39029','1985-01-01','F','U',NULL,'T','021','DEN','1666915','99734OH005000301','2014-03-01','2014-01-21 09:52:33','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,1,'2014-01-22 03:22:23'),(4594,3638,'Y','18','021','EC','A','','','AC','0000652104','0000652104','OH00001119895','IL','1','Babyak','Nancy','','','','34','269509787','130 ADAMS AVE',0,'CUYAHOGA FALLS','OH','44221','1704','CY','39153','1966-09-27','F','M',':RET:2106-3','N','021','HLT','726058','52664OH151001306','2014-01-01','2013-12-12 14:22:28','583.00',NULL,NULL,'670.58','87.58','R-OH012','OH0','348.56',NULL,0,'2013-12-25 22:05:32'),(7943,6283,'Y','18','021','EC','A','','','AC','0001274264','0001274264','LA00000498764','IL','1','LANDERS','NANCY','','','','34','433925393','1645 OLD MANDEVILLE LN',0,'MANDEVILLE','LA','70448','2235','CY','22103','1955-04-30','F','U',':RET:2106-3','N','021','DEN','2507681','18575LA002000201','2014-01-01','2013-12-20 15:25:39','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:56'),(9146,7253,'Y','18','024','14','A','','','TE','0000853011','0000853011','','IL','1','Douglas','Susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-07-27','F','',NULL,NULL,NULL,'','955656','','2013-12-18','2013-12-18 11:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:08:18'),(16008,12812,'Y','18','021','EC','A','','','AC','0000017850','0000017850','TX00001423782','IL','1','Willett','Pauline','','','','34','258723968','1512 TWILIGHT DR',0,'FLOWER MOUND','TX','75028','4296','CY','48121','1953-02-11','F','M',':RET:2106-3','N','021','DEN','1438623','33348TX002000201','2014-02-01','2014-01-03 17:48:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-04 02:01:43'),(15540,12435,'Y','18','021','EC','A','','','AC','0002159651','0002159651','LA00001872165','IL','1','LOTT','GERALD','','','','34','433538181','1106 CARROLL ST',0,'TALLULAH','LA','71282',NULL,'CY','22065','1983-04-18','M','M',':RET:2106-3','T','021','DEN','1592306','18575LA002000201','2014-02-01','2013-12-31 14:41:45','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:30:57'),(9176,7278,'Y','18','021','EC','A','','','AC','0000726120','0000726120','OH00001186613','IL','1','KINTZ','JOHN','','','','34','275466084','5017 OLD A AND P RD',0,'RIPLEY','OH','45167','9794','CY','39015','1957-01-02','M','U',':RET:2106-3','T','021','HLT','2214215','92036OH005000604','2014-01-01','2013-12-18 15:01:30','266.00',NULL,NULL,'575.94','309.94','R-OH005','OH0','575.94',NULL,0,'2013-12-26 04:09:03'),(14738,11767,'Y','18','024','14','A','','','TE','0000383016','0000383016','','IL','1','Rick','Melanie','H',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-08-12','F','',NULL,NULL,NULL,'','2337092','','2013-12-28','2013-12-28 16:21:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2013-12-29 11:09:57'),(13718,10947,'Y','18','021','EC','A','','','AC','0000803730','0000803730','OH00000675284','IL','1','STOUFFER','JASON','','','','34','262975210','2147 WOODLAND STREET NE',0,'WARREN','OH','44483',NULL,'CY','39155','1977-10-23','M','U',':RET:2106-3','N','021','HLT','2568045','52664OH151001306','2014-01-01','2013-12-23 16:19:51','121.00',NULL,NULL,'311.06','190.06','R-OH013','OH0','311.06',NULL,0,'2013-12-26 13:09:08'),(23348,18607,'Y','18','021','EC','A','','','AC','0000084094','0000084094','OH00001543864','IL','1','Mireles Ruiz','Jesus','','','','34','288132698','4523 EVANGEL AVE NW',0,'MASSILLON','OH','44647','5997','CY','39151','1978-12-15','M','M',':RET:2106-3','N','021','HLT','3453179','52664OH151001306','2014-03-01','2014-02-13 11:39:33','414.00',NULL,NULL,'543.25','129.25','R-OH015','OH0','272.52',NULL,0,'2014-02-13 22:00:40'),(25293,20067,'Y','18','021','EC','A','','','AC','0000208554','0000208554','OH00002334219','IL','1','Barclay','Deborah','','','','34','284549203','3905 RIDGE RD',0,'SPRINGFIELD','OH','45502','9328','CY','39023','1952-10-06','F','U',':RET:2106-3','N','021','DEN','3676190','99734OH005000401','2014-04-01','2014-02-25 08:39:08','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00','CIC',0,'2014-02-25 21:00:24'),(25860,20502,'Y','18','024','14','A','','','TE','0001453637','0001453637','','IL','1','Shugars','Kim',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-13','F','',NULL,NULL,NULL,'','3058622','','2014-02-26','2014-02-26 11:09:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-26 21:00:45'),(26297,20861,'Y','18','021','EC','A','','','AC','0000228389','0000228389','OH00002639651','IL','1','Slovak','Nancy','','','','34','268527267','3326 RAINBOW CT',0,'OREGON','OH','43616','2396','CY','39095','1952-06-09','F','U',':RET:2106-3','N','021','HLT','2681178','92036OH004002601','2014-04-01','2014-02-27 10:38:27','437.38',NULL,NULL,'440.60','3.22','R-OH001','OH0','440.60',NULL,0,'2014-02-28 06:31:27'),(27058,21424,'N','19','021','EC','A',NULL,NULL,'','0000399894','0000340297','','IL','1','JOHNSON','TYLER','','','','34','269963818','406 WASHINGTON',0,'REPUBLIC','OH','44867',NULL,'CY','39147','1992-10-09','M','',':RET:2106-3','N','021','HLT','3076432','92036OH003002704','2014-04-01','2014-03-03 13:43:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63','CIC',0,'2014-03-03 21:00:27'),(3148,2531,'N','01','021','EC','A',NULL,NULL,'','0001130646','0000036812','','IL','1','Poe','Marian','','','','34','461191783','506 BLUEBONNET ST',0,'FREDERICKSBURG','TX','78624','5238','CY','48171','1957-04-15','F','',':RET:2106-3','N','021','DEN','161203','33348TX002000201','2014-01-01','2013-11-18 14:23:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 20:30:57'),(21127,16882,'Y','18','021','EC','A','','','AC','0001106414','0001106414','TX00001780999','IL','1','HARMON','SHARON','','','','34','248292529','232 COUNTY ROAD 4369',0,'WOODVILLE','TX','75979','8091','CY','48457','1958-12-23','F','M',NULL,'N','021','DEN','2660726','33348TX002000201','2014-03-01','2014-02-03 14:31:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:16'),(9790,7752,'Y','18','021','EC','A','','','AC','0000473605','0000473605','OH00000311745','IL','1','Steller','Ryan','','','','34','279829810','19342 SPINNAKER CIR',0,'STRONGSVILLE','OH','44136','7109','CY','39035','1984-06-08','M','U',':RET:2106-3','T','021','HLT','321053','52664OH151001301','2014-01-01','2013-10-20 20:16:42','0.00',NULL,NULL,'323.67','323.67','R-OH011','OH0','323.67',NULL,0,'2013-12-26 05:00:56'),(19624,15642,'Y','18','021','EC','A','','','AC','0000556745','0000556745','OH00001719412','IL','1','zorn','dave','','','','34','300625644','89 MEADOW DR SW',0,'ETNA','OH','43068','3311','CY','39089','1970-02-21','M','M',NULL,'N','021','DEN','2874963','99734OH005000401','2014-03-01','2014-01-22 20:40:22','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:05'),(13249,10573,'N','01','021','EC','A',NULL,NULL,'','0001215498','0001096663','','IL','1','Guerrero','Fernando','','','','34','269943114','3402 Alice Lane',0,'Edinburg','TX','78541',NULL,'CY','48215','1976-01-19','M','',NULL,'N','021','DEN','2508919','33348TX002000201','2014-01-01','2013-12-23 11:04:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:56:20'),(19175,15276,'Y','18','021','EC','A','','','AC','0001096790','0001096790','TX00002394174','IL','1','VASQUEZ','LAURA','','','','34','627148972','13907 FAWNBRAKE DR',0,'SUGAR LAND','TX','77498','2373','CY','48157','1988-02-26','F','M',':RET:2106-3','N','021','DEN','2680321','33348TX002000201','2014-03-01','2014-01-20 12:49:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-21 08:46:04'),(18534,14779,'N','01','021','EC','A',NULL,NULL,'','0000432782','0000304733','','IL','1','Haley','Loriann',NULL,NULL,NULL,NULL,NULL,'28220 SIMMONS RD',0,'PERRYSBURG','OH','43551','4132','CY','39173','1970-03-07','F','',':RET:2106-3','N','021','HLT','2802236','92036OH006002601','2014-02-01','2014-01-14 21:27:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','209.85',NULL,0,'2014-01-16 08:46:45'),(13264,10586,'Y','18','021','EC','A','','','AC','0000097422','0000097422','TX00000348563','IL','1','Ashton','Erikalin','','','','34','223132719','4424 Gaines Ranch Loop',0,'Austin','TX','78735',NULL,'CY','48453','1972-01-15','F','R',':RET:2106-3','N','021','DEN','2362210','33348TX002000201','2014-01-01','2013-12-23 12:14:05','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:56:44'),(16760,13408,'Y','18','021','EC','A','','','AC','0000408497','0000408497','OH00002198421','IL','1','Corfman','Dale','','','','34','349466300','3074 ECHO HILLS RD',0,'AKRON','OH','44333','2132','CY','39153','1955-02-09','M','M',':RET:2106-3','N','021','HLT','2097885','52664OH152000901','2014-02-01','2014-01-07 10:42:55','622.00',NULL,NULL,'749.40','127.40','R-OH012','OH0','416.19',NULL,0,'2014-01-08 18:24:58'),(23978,19064,'Y','18','021','EC','A','','','AC','0001594364','0001594364','LA00001988252','IL','1','Gulbengay','Erin','','','','34','567657774','2523 GOVERNOR NICHOLLS ST',0,'NEW ORLEANS','LA','70119','3448','CY','22071','1981-03-02','F','U',NULL,'N','021','DEN','3213000','18575LA002000201','2014-03-01','2014-02-14 18:13:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-15 22:00:18'),(27381,21678,'Y','18','021','EC','A','','','AC','0000985551','0000985551','MS00003523220','IL','1','Miller','Frank','','','','34','352468009','523 ORIOLE DR',0,'JACKSON','MS','39204','4843','CY','28049','1954-06-20','M','M',':RET:2054-5','N','021','DEN','2890205','46300MS002000201','2014-04-01','2014-03-03 18:07:54','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:21'),(2984,2401,'N','19','021','EC','A',NULL,NULL,'','0000664151','0001139480','','IL','1','Krebs','Martins','A','','','34','626606860','3416 HIGLEY RD',0,'ROCKY RIVER','OH','44116','3835','CY','39035','1992-05-09','M','',':RET:2106-3','N','021','DEN','471488','99734OH005000301','2014-01-01','2013-12-06 08:57:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:17:16'),(21879,17468,'Y','18','024','14','A','','','TE','0001162300','0001162300','','IL','1','Myles','Sandra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-04-20','F','',NULL,NULL,NULL,'','3231944','','2014-02-06','2014-02-06 12:57:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-06 21:01:30'),(21552,17216,'Y','18','021','EC','A','','','AC','0000733633','0000733633','OH00002588566','IL','1','SMITH','VANESSA','','','','34','278600753','3766 LONGWOOD AVE',0,'CLEVELAND','OH','44115','3342','CY','39035','1957-12-29','F','U',NULL,'N','021','DEN','3773497','99734OH005000401','2014-03-01','2014-02-05 14:17:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-05 21:30:14'),(20692,16534,'N','19','021','EC','A',NULL,NULL,'','0000854219','0001086806','','IL','1','Henry','Grace',NULL,NULL,NULL,NULL,NULL,'2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','2000-10-14','F','',':RET:2106-3','N','021','DEN','2798559','99734OH005000301','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:59'),(20662,16511,'N','01','021','EC','A',NULL,NULL,'','0000132642','0000872763','','IL','1','Hawkins','Richard','A','','','34','465591352','2520Bender Rd',0,'Texarkana','TX','75501',NULL,'CY','48037','1979-01-05','M','',':RET:2054-5','N','021','DEN','3106001','33348TX002000201','2014-03-01','2014-01-30 17:28:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-30 21:00:44'),(20275,16180,'Y','18','021','EC','A','','','AC','0000542715','0000542715','OH00002455145','IL','1','Dean','Edith','','','','34','289663131','16977 E TOWNSHIP ROAD 88',0,'ATTICA','OH','44807','9494','CY','39147','1968-04-13','F','M',NULL,'N','021','DEN','2736491','99734OH005000401','2014-03-01','2014-01-28 11:32:37','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-28 21:00:26'),(19936,15900,'Y','18','024','14','A','','','TE','0001008933','0001008933','','IL','1','King','Mikki',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-10-04','F','',NULL,NULL,NULL,'','1004012','','2014-01-23','2014-01-23 21:39:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:01:12'),(19663,15668,'Y','18','021','EC','A','','','AC','0001223143','0001223143','OH00002240488','IL','1','Kilby','Brandon','','','','34','275889977','7299 SILVER CREST DR',0,'CINCINNATI','OH','45236','3622','CY','39061','1981-01-26','M','U',':RET:2054-5','N','021','DEN','2449531','99734OH005000401','2014-03-01','2014-01-23 15:48:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 21:00:25'),(19334,15413,'Y','18','021','EC','A','','','AC','0001072881','0001072881','TX00002550028','IL','1','talkington','Martha','','','','34','452923868','252 MULBERRY LN',0,'ROCKWALL','TX','75032','5692','CY','48397','1950-06-25','F','M',':RET:2106-3','N','021','DEN','1472347','33348TX002000201','2014-03-01','2014-01-21 15:37:38','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-22 03:22:17'),(18917,15073,'Y','18','024','14','A','','','TE','0001094663','0001094663','','IL','1','TOPP','RACHEL','E',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-10-09','F','',NULL,NULL,NULL,'','2100812','','2014-01-15','2014-01-15 19:30:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:42'),(8936,7085,'Y','18','021','EC','A','','','AC','0000024098','0000024098','OH00000182186','31','1','Richardson','Theresa','','','','34','274728319','P. O. Box 26157',0,'Trotwood','OH','45426',NULL,'CY','39113','1966-11-20','F','R',NULL,'N','021','DEN','2559164','99734OH005000401','2014-01-01','2013-12-18 10:40:31','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:03:12'),(14543,11604,'Y','18','021','EC','A','','','AC','0000319055','0000319055','MS00000030689','IL','1','McNEAL','JOHN','','','','34','587096526','151 MCCARTY RD',0,'JACKSON','MS','39212','9674','CY','28049','1953-01-12','M','M',':RET:2054-5','N','021','DEN','2029579','46300MS002000201','2014-02-01','2013-12-27 14:19:43','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:49'),(3253,2623,'Y','18','021','EC','A','','','AC','0000148293','0000148293','OH00000464070','IL','1','Scott','Christopher','','','','34','279661736','24 2ND AVE',0,'BEREA','OH','44017','1244','CY','39035','1961-12-11','M','M',':RET:2054-5','N','021','DEN','197683','99734OH005000301','2014-01-01','2013-11-27 20:49:59','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:41'),(19698,15696,'Y','18','021','EC','A','','','AC','0001007953','0001007953','TX00001862479','IL','1','HERNANDEZ','RICHARD','FRANCO','','Jr','34','643708821','1713 1ST ST',0,'BROWNWOOD','TX','76801','4207','CY','48049','1960-12-07','M','U',NULL,'N','021','DEN','2173933','33348TX002000201','2014-03-01','2014-01-23 14:27:10','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:46'),(4799,3803,'Y','18','021','EC','A','','','AC','0000139601','0000139601','LA00000253154','IL','1','Robinson','Alaysha','','','','34','438652986','4204 GWENDOLYN DR',0,'BAKER','LA','70714','2628','CY','22033','1987-08-31','F','U',NULL,'N','021','DEN','1090517','18575LA002000201','2014-01-01','2013-12-07 19:43:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:16:27'),(14312,11415,'N','01','021','EC','A',NULL,NULL,'','0000399894','0000862441','','IL','1','Green','James','','','','34','285808025','PO Box 332',0,'Republic','OH','44867',NULL,'CY','39147','1974-06-27','M','',NULL,'T','021','HLT','1656723','92036OH003002706','2014-02-01','2013-12-26 11:05:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.53',NULL,0,'2013-12-27 02:07:03'),(7200,5705,'Y','18','021','EC','A','','','AC','0000196030','0000196030','LA00001241650','IL','1','burke','catherine','anne','','','34','437453822','2802 DESOTO ST',0,'NEW ORLEANS','LA','70119','3331','CY','22071','1981-11-22','F','U',':RET:2106-3','N','021','DEN','35835','18575LA002000101','2014-01-01','2013-12-13 18:29:30','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 02:00:37'),(6024,4768,'Y','18','021','EC','A','','','AC','0000020698','0000020698','TX00000607217','IL','1','LUKICO','MARKO','','','','34','627508705','504 LOOKOUT TREE LN',0,'ROUND ROCK','TX','78664','7745','CY','48491','1985-08-02','M','U',NULL,'N','021','DEN','75445','33348TX002000201','2014-01-01','2013-12-01 16:21:49','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 00:00:57'),(7033,5585,'Y','18','021','EC','A','','','AC','0000043439','0000043439','TX00001580028','IL','1','Cannon','Stephanie','','','','34','449474895','1851 SHADY GLEN LN',0,'DALLAS','TX','75232','2349','CY','48113','1965-04-15','F','U',':RET:2054-5','N','021','DEN','1746149','33348TX002000201','2014-01-01','2013-12-24 23:39:12','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:10'),(6946,5516,'Y','18','021','EC','A','','','AC','0000288300','0000288300','OH00001350012','IL','1','Gustin','Teresa','','','','34','292586861','5 S CORWIN ST',0,'LEBANON','OH','45036','2003','CY','39165','1958-07-24','F','U',':RET:2106-3','N','021','DEN','2122408','99734OH005000401','2014-01-01','2013-12-24 20:52:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:46:54'),(2034,1665,'Y','18','021','EC','A','','','AC','0000695802','0000695802','TX00000090995','IL','1','Plummer','Mark','','','','34','585664886','P.O. Box 1873',0,'Andrews','TX','79714',NULL,'CY','48003','1957-07-23','M','M',':RET:2106-3','N','021','DEN','840994','33348TX002000201','2014-01-01','2013-12-09 20:35:00','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:15:25'),(2308,1876,'Y','18','024','14','A','','','TE','0000705120','0000705120','','IL','1','Isenbarger','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-09-14','M','',NULL,NULL,NULL,'','728312','','2013-12-09','2013-12-09 17:49:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:31:06'),(19889,15864,'Y','18','021','EC','A','','','AC','0000771465','0000771465','OH00002254437','IL','1','Casserman','Gregory','','','','34','273588978','4470 CYNTHIA DR',0,'NORTH CANTON','OH','44720','1206','CY','39153','1958-03-21','M','M',':RET:2106-3','N','021','HLT','2812919','52664OH151001301','2014-03-01','2014-01-24 13:48:06','578.00',NULL,NULL,'1017.59','439.59','R-OH012','OH0','497.31',NULL,0,'2014-01-24 21:00:50'),(18864,15026,'Y','18','021','EC','A','','','AC','0001516492','0001516492','LA00002551352','IL','1','nunez','kevin','c','','','34','434813913','105 FIRETHORN DR',0,'GRETNA','LA','70056','7849','CY','22051','1988-03-23','M','U',':RET:2106-3','N','021','DEN','1526149','18575LA002000201','2014-03-01','2014-01-16 01:23:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:21'),(18854,15016,'Y','18','021','EC','A','','','AC','0001252143','0001252143','OH00002155136','IL','1','Baker','Brittany','','','','34','280944579','4466 SPRUCE CREEK DR',0,'BATAVIA','OH','45103','1558','CY','39025','1991-08-27','F','U',':RET:2106-3','N','021','HLT','2343407','92036OH006000601','2014-02-01','2014-01-15 22:07:44','0.00',NULL,NULL,'170.24','170.24','R-OH005','OH0','170.24',NULL,0,'2014-01-17 03:36:17'),(18532,14779,'Y','18','021','EC','A','','','AC','0000432782','0000432782','OH00001929905','IL','1','Haley','Craig',NULL,NULL,NULL,NULL,NULL,'28220 SIMMONS RD',0,'PERRYSBURG','OH','43551','4132','CY','39173','1960-11-24','M','M',':RET:2106-3','N','021','HLT','2802236','92036OH006002601','2014-02-01','2014-01-14 21:27:58','297.00',NULL,NULL,'623.52','326.52','R-OH001','OH0','315.47',NULL,0,'2014-01-16 08:46:44'),(2092,1713,'Y','18','021','EC','A','','','AC','0000622890','0000622890','LA00001280044','IL','1','Flaherty','Joelle','','','','34','304641969','120 HEMBLING DR',0,'PINEVILLE','LA','71360','5648','CY','22079','1966-11-16','F','M',':RET:2106-3','N','021','DEN','907612','18575LA002000201','2014-01-01','2013-12-10 17:22:54','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 19:16:55'),(17105,13689,'Y','18','021','EC','A','','','AC','0000657586','0000657586','TX00001630280','IL','1','Carrillo','Stephanie','','','','34','628034645','936 MEADOWDALE CIR',0,'GARLAND','TX','75043','2727','CY','48113','1986-02-15','F','M',':RET:2106-3','N','021','DEN','1818302','33348TX002000201','2014-02-01','2014-01-08 17:46:54','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:21:33'),(17017,13619,'Y','18','021','EC','A','','','AC','0000538285','0000538285','OH00002035925','IL','1','Allen','Kelsey','','','','34','278945925','159 W Overdale Dr',0,'Tallmadge','OH','44278',NULL,'CY','39153','1988-01-03','F','R',':RET:2106-3','N','021','HLT','2493839','52664OH152000901','2014-02-01','2014-01-09 12:42:33','0.00',NULL,NULL,'167.26','167.26','R-OH012','OH0','167.26',NULL,0,'2014-01-13 02:20:39'),(9163,7268,'Y','18','021','EC','A','','','AC','0000063703','0000063703','OH00000604994','IL','1','tai','dale','chiyoung','','','34','289788764','5300 W US HIGHWAY 36',0,'URBANA','OH','43078','9644','CY','39021','1954-12-22','M','M',':RET:2034-7','N','021','HLT','1757583','92036OH003000505','2014-01-01','2013-12-18 10:19:43','867.00',NULL,NULL,'1069.68','202.68','R-OH003','OH0','646.18',NULL,0,'2013-12-26 04:08:45'),(13241,10566,'Y','18','021','EC','A','','','AC','0000694754','0000694754','TX00001142512','IL','1','Hannan','John','K','','','34','463980820','2414 WORDSWORTH ST',0,'HOUSTON','TX','77030','1834','CY','48201','1951-08-24','M','R',':RET:2106-3','N','021','DEN','1899662','33348TX002000201','2014-01-01','2013-12-23 05:08:48','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:56:04'),(14746,11775,'Y','18','021','EC','A','','','AC','0001016863','0001016863','OH00000384518','IL','1','branson','misty','','','','34','270705754','105 HILL TOP LN',0,'MOSCOW','OH','45153','8904','CY','39025','1975-11-06','F','R',':RET:2106-3','N','021','HLT','2083898','92036OH006000601','2014-02-01','2013-12-27 20:06:56','0.00',NULL,NULL,'624.30','624.30','R-OH005','OH0','212.14',NULL,1,'2013-12-29 11:10:12'),(20711,16549,'Y','18','021','EC','A','','','AC','0001271514','0001271514','LA00002349682','IL','1','Garcia','stephanie','','','','34','599326136','1526 London Cross Rd',0,'Harvey','LA','70058',NULL,'CY','22051','1992-01-16','F','U',NULL,'N','021','DEN','2172656','18575LA002000201','2014-03-01','2014-01-30 13:35:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-30 21:01:08'),(24158,19195,'Y','18','021','EC','A','','','AC','0000134623','0000134623','OH00002343310','IL','1','Cook','Jeremy','','','','34','301843494','324 SHELBY ST',0,'NAPOLEON','OH','43545','1643','CY','39069','1985-01-05','M','R',':RET:2106-3','N','021','HLT','3832685','92036OH001002601','2014-03-01','2014-02-14 20:17:19','0.00',NULL,NULL,'263.19','263.19','R-OH001','OH0','263.19',NULL,0,'2014-02-15 22:02:01'),(25394,20146,'N','19','021','EC','A',NULL,NULL,'','0000307147','0000205840','','IL','1','Mohr','Makaila','','','','34','300116593','5612 Brentwood Avenue NW',0,'North Canton','OH','44720',NULL,'CY','39151','2005-09-15','F','',NULL,'N','021','HLT','3677245','52664OH151001304','2014-04-01','2014-02-25 12:12:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-25 21:30:53'),(25794,20456,'Y','18','021','EC','A','','','AC','0000356080','0000356080','OH00002293345','IL','1','Ferguson','Teresa','','','','34','286662595','7913 NATIONAL RD SW',0,'ETNA','OH','43062','8614','CY','39089','1959-12-30','F','M',NULL,'N','021','DEN','2687428','99734OH005000301','2014-04-01','2014-02-26 10:07:32','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:00:13'),(28512,22563,'Y','18','021','EC','A','','','AC','0000873300','0000873300','OH00003080667','IL','1','Huston','Linda','','','','34','288509174','1915 State Route 59 1',0,'Kent','OH','44240',NULL,'CY','39133','1950-11-06','F','M',':RET:2106-3','N','021','HLT','4156898','52664OH151001306','2014-04-01','2014-03-07 15:28:40','568.00',NULL,NULL,'658.32','90.32','R-OH012','OH0','658.32',NULL,0,'2014-03-07 21:31:55'),(29204,23111,'N','19','021','EC','A',NULL,NULL,'','0000313820','0000120634','','IL','1','LOWMAN','ELIZABETH','S','','','34','411678925','385 NAIL RD',0,'SOUTHAVEN','MS','38671',NULL,'CY','28033','1988-03-28','F','',NULL,'N','021','DEN','4392418','46300MS002000201','2014-04-01','2014-03-10 15:50:54',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85','CIC',0,'2014-03-10 21:30:11'),(340,279,'Y','18','021','EC','A','','','AC','0000243701','0000243701','OH00001230220','IL','1','Lagreca','Dave','j','','','34','281627745','4030 carrie ave.',0,'cincinnati','OH','45211',NULL,'CY','39061','1958-08-20','M','M',':RET:2106-3','T','021','DEN','178379','99734OH005000401','2014-01-01','2013-11-08 20:09:58','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:31:57'),(19976,15934,'Y','18','021','EC','A','','','AC','0000613030','0000613030','OH00001530239','IL','1','Shooks','Eva','','','','34','276567899','585 Seville rd',0,'Wadsworth','OH','44281',NULL,'CY','39103','1953-06-02','F','M',':RET:2106-3','N','021','DEN','3230524','99734OH005000401','2014-03-01','2014-01-25 10:21:32','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-25 19:00:14'),(5685,4511,'Y','18','021','EC','A','','','AC','0000277250','0000277250','OH00000479708','IL','1','Johnson','Brandon','','','','34','569574361','2057 WOODTRAIL DR',0,'FAIRFIELD','OH','45014','4873','CY','39017','1979-09-25','M','U',':RET:2106-3','N','021','DEN','543332','99734OH005000301','2014-01-01','2013-11-25 22:47:13','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:32:25'),(16880,13506,'Y','18','021','EC','A','','','AC','0000963412','0000963412','TX00001626773','IL','1','Miller','Serena','','','','34','464672743','1819 Decatur Street',0,'Houston','TX','77007',NULL,'CY','48201','1968-05-04','F','R',':RET:2106-3','N','021','DEN','1642777','33348TX002000201','2014-02-01','2014-01-09 06:54:23','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:19:21'),(16299,13049,'N','01','021','EC','A',NULL,NULL,'','0002051525','0001697872','','IL','1','HUDSON','VESTER','L','','','34','394582501','2924 DOVE AVENUE',0,'MARRERO','LA','70072',NULL,'CY','22051','1954-06-16','M','',NULL,'N','021','DEN','2551505','18575LA002000201','2014-02-01','2014-01-06 15:43:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:01:06'),(2114,1734,'Y','18','021','EC','A','','','AC','0001191308','0001191308','OH00000233959','IL','1','Barth','Charles','','','','34','275568621','3078 CREEKSIDE DR',0,'WESTLAKE','OH','44145','4647','CY','39035','1970-06-24','M','U',':RET:2106-3','N','021','DEN','110364','99734OH005000401','2014-01-01','2013-12-10 11:25:24','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:17:32'),(3817,3057,'Y','18','021','EC','A','','','AC','0000130677','0000130677','OH00000672229','IL','1','Markielowski','Michelle','','','','34','276867049','180 Starr Drive',0,'Nelsonville','OH','45764',NULL,'CY','39009','1986-03-19','F','M',':RET:2106-3','N','021','DEN','958682','99734OH005000301','2014-01-01','2013-12-13 14:37:58','0.00',NULL,NULL,'42.26','42.26','R-OH017','OH0','0.00',NULL,0,'2013-12-25 21:34:51'),(2414,1969,'N','01','021','EC','A',NULL,NULL,'','0001022758','0001093126','','IL','1','lomack','florence','','','','34','294609342','3428 ferncroft dr',0,'cincinnati','OH','45211',NULL,'CY','39061','1965-06-01','F','',':RET:2054-5','N','021','DEN','713099','99734OH005000401','2014-01-01','2013-12-09 15:40:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:33:48'),(15081,12054,'Y','18','024','14','A','','','TE','0000359268','0000359268','','IL','1','Jones','Rashad',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-17','M','',NULL,NULL,NULL,'','1799489','','2013-12-30','2013-12-30 09:17:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-01 12:04:10'),(15019,12004,'N','01','021','EC','A',NULL,NULL,'','0000213379','0001241873','','IL','1','McCane','Thomas','EDWARD','','','34','296709592','4775 MATTHEW PL',0,'FAIRFIELD','OH','45014','1422','CY','39017','1964-05-30','M','',':RET:2106-3','N','021','HLT','2233539','92036OH005001206','2014-02-01','2013-12-29 19:01:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','366.23',NULL,0,'2014-01-01 12:02:15'),(14719,11752,'Y','18','024','14','A','','','TE','0000271414','0000271414','','IL','1','Rammel','Jared',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-01-14','M','',NULL,NULL,NULL,'','2259954','','2013-12-28','2013-12-28 12:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:09:31'),(20925,16724,'N','19','021','EC','A',NULL,NULL,'','0000125594','0001258691','','IL','1','SCOTT','CHRISTINA','','','','34','276150192','1516 CHESTNUT BLVD',0,'CUYAHOGA FALLS','OH','44223','2347','CY','39153','2009-02-18','F','',':RET:2106-3','N','021','HLT','2093280','52664OH151001501','2014-03-01','2014-01-31 13:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-01-31 21:01:34'),(23197,18496,'Y','18','021','EC','A','','','AC','0000404843','0000404843','OH00001491423','IL','1','mutti','angela','','','','34','286641739','805 applegrove st nw',0,'north canton','OH','44720',NULL,'CY','39151','1963-05-17','F','U',':RET:2106-3','N','021','HLT','3679622','52664OH152000901','2014-03-01','2014-02-12 18:00:59','0.00',NULL,NULL,'291.73','291.73','R-OH015','OH0','291.73',NULL,0,'2014-02-12 21:32:06'),(23272,18552,'N','01','021','EC','A',NULL,NULL,'','0000848565','0000818072','','IL','1','Nwanne','Mercy','','','','34','635248966','8318 Lighthouse Drive',0,'Rowlett','TX','75089',NULL,'CY','48113','1968-07-27','F','',NULL,'N','021','DEN','3156478','33348TX002000101','2014-03-01','2014-02-13 09:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-13 21:30:13'),(24280,19283,'Y','18','021','EC','A','','','AC','0000614154','0000614154','OH00002261012','IL','1','Gay','Rodney','','','','34','273589879','2600 Edgebrook Avenue',0,'Akron','OH','44312',NULL,'CY','39153','1957-05-26','M','M',':RET:2106-3','N','021','DEN','3234618','99734OH005000401','2014-03-01','2014-02-18 17:04:01','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00','CIC',0,'2014-02-18 21:30:06'),(26788,21230,'Y','18','024','14','A','','','TE','0000312991','0000312991','','IL','1','gibson','tracy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-03-20','F','',NULL,NULL,NULL,'','35463','','2014-03-16','2014-03-01 17:20:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-01 21:00:17'),(28145,22273,'Y','18','021','EC','A','','','AC','0000926334','0000926334','OH00003601683','IL','1','MASTIN','KATHY','','','','34','270548165','11758 LASSITER DR',0,'CINCINNATI','OH','45240','2004','CY','39061','1951-07-30','F','M',NULL,'N','021','HLT','4119375','92036OH003001204','2014-04-01','2014-03-06 09:53:37','354.00',NULL,NULL,'644.07','290.07','R-OH004','OH0','644.07',NULL,0,'2014-03-06 21:02:33'),(5987,4739,'Y','18','021','EC','A','','','AC','0000784363','0000784363','OH00001320444','IL','1','Jones','Joni','','','','34','278505170','5790 great northern blvd',0,'north olmsted','OH','44070',NULL,'CY','39035','1958-01-05','F','U',':RET:2106-3','T','021','HLT','1632341','92036OH004000801','2014-01-01','2013-12-24 01:17:51','0.00',NULL,NULL,'482.11','482.11','R-OH011','OH0','482.11',NULL,0,'2013-12-25 23:52:06'),(7003,5559,'Y','18','021','EC','A','','','AC','0001065061','0001065061','TX00000439321','IL','1','Vaughn','Marie','A','','','34','556577979','392 PRIVATE ROAD 7533',0,'HAWKINS','TX','75765','4815','CY','48499','1978-03-13','F','M',':RET:2106-3','N','021','DEN','1600904','33348TX002000201','2014-01-01','2013-12-24 19:19:48','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:20'),(20291,16196,'Y','18','021','EC','A','','','AC','0001241388','0001241388','LA00001454370','IL','1','FILOMENO','CLAUDETTE','','','','34','580121122','1557 LONDON CROSS RD',0,'HARVEY','LA','70058',NULL,'CY','22051','1953-11-22','F','U',NULL,'N','021','DEN','2744060','18575LA002000201','2014-03-01','2014-01-28 10:59:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-28 21:00:36'),(7856,6221,'Y','18','021','EC','A','','','AC','0000951788','0000951788','OH00000358568','IL','1','Scott','Amy','','','','34','280586611','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','1971-09-06','F','M',':RET:2106-3','N','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:04:56'),(17496,13990,'Y','18','024','14','A','','','TE','0001294865','0001294865','','IL','1','Bernard','Adam',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-06-01','M','',NULL,NULL,NULL,'','2247355','','2014-01-12','2014-01-12 09:25:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 03:01:23'),(16716,13378,'N','01','021','EC','A',NULL,NULL,'','0001153898','0000239675','','IL','1','Arcudi','Priscilla','','','','34','643142165','40 HANK BENGE RD',0,'DODGE','TX','77334','0416','CY','48471','1990-02-12','F','',':RET:2106-3','N','021','DEN','1921532','33348TX002000201','2014-02-01','2014-01-07 14:59:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-08 18:24:44'),(21033,16806,'Y','18','021','EC','A','','','AC','0001005747','0001005747','OH00001698136','IL','1','GILLUM','DEBORAH','','','','34','295589674','632 FOLKERTH AVE',0,'SIDNEY','OH','45365','9091','CY','39149','1955-10-10','F','M',':RET:2106-3','N','021','HLT','3633231','92036OH006000501','2014-03-01','2014-02-01 11:59:30','1029.24',NULL,NULL,'1036.82','7.58','R-OH003','OH0','480.33',NULL,0,'2014-02-01 19:00:46'),(23709,18877,'Y','18','021','EC','A','','','AC','0000711418','0000711418','OH00002476203','IL','1','FAISON','NATALIE','','','','34','272885357','4770 LAGARE LANE',0,'COLOMBUS','OH','43230',NULL,'CY','39049','1987-12-06','F','U',NULL,'N','021','DEN','2968022','99734OH005000401','2014-03-01','2014-02-14 13:28:30','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-14 21:30:45'),(23800,18938,'Y','18','021','EC','A','','','AC','0000051969','0000051969','OH00002465499','IL','1','Safran','Inna','','','','34','297089966','10489 KERWICK CT',0,'REMINDERVILLE','OH','44202','8160','CY','39153','1980-03-14','F','M',':RET:2106-3','N','021','HLT','3445765','52664OH151001304','2014-03-01','2014-02-14 13:19:53','168.48',NULL,NULL,'267.16','98.68','R-OH012','OH0','267.16',NULL,0,'2014-02-14 21:31:29'),(25770,20438,'Y','18','021','EC','A','','','AC','0001037408','0001037408','OH00003027674','IL','1','thorne','torie','','','','34','370924385','5002 MARYHILL RD',0,'SYLVANIA','OH','43560','2624','CY','39095','1978-11-21','F','U',':RET:2106-3','N','021','DEN','3289492','99734OH005000301','2014-04-01','2014-02-24 13:24:06','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-26 09:30:55'),(315,258,'Y','18','021','EC','A','','','AC','0000768902','0000768902','LA00000298383','IL','1','Marshall','Kimberly','','','','34','437693918','37464 RHONDA RD',0,'PEARL RIVER','LA','70452','5238','CY','22103','1987-06-10','F','U',NULL,'N','021','DEN','367429','18575LA002000201','2014-01-01','2013-11-13 17:25:52','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:31:09'),(19548,15581,'Y','18','021','EC','A','','','AC','0000507003','0000507003','OH00001980356','IL','1','JAGODZINSKI','JAY','','','','34','284666383','4102 LYMAN AVE',0,'TOLEDO','OH','43612','1550','CY','39095','1960-08-30','M','M',':RET:2106-3','N','021','HLT','3015124','92036OH006002601','2014-03-01','2014-01-21 20:37:29','5.00',NULL,NULL,'315.47','310.47','R-OH001','OH0','315.47',NULL,0,'2014-01-23 03:02:27'),(3,2,'Y','18','021','EC','A','','','AC','0000716306','0000716306','OH00001119672','IL','1','Fletcher','Gary','','','','34','283522272','5523 LESTER RD',0,'CINCINNATI','OH','45213','2527','CY','39061','1953-07-05','M','U',':RET:2054-5','N','021','DEN','943890','99734OH005000401','2014-01-01','2013-12-04 19:33:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:05'),(5623,4463,'Y','18','021','EC','A','','','AC','0001049338','0001049338','OH00000605833','IL','1','Burrows','Kevin','','','','34','291705088','3454 OAKLAWN ST',0,'COLUMBUS','OH','43224','3454','CY','39049','1974-12-27','M','M',':RET:2054-5','N','021','DEN','1110220','99734OH005000401','2014-01-01','2013-11-26 17:18:48','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:30:50'),(19980,15937,'Y','18','021','EC','A','','','AC','0000128130','0000128130','OH00001780847','IL','1','MILLER','LINDA','','','','34','297563914','4645 CANTERBURY RD',0,'NORTH OLMSTED','OH','44070',NULL,'CY','39035','1958-12-17','F','U',NULL,'N','021','DEN','3003266','99734OH005000401','2014-03-01','2014-01-25 17:27:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-25 19:00:15'),(16343,13082,'Y','18','021','EC','A','','','AC','0001066996','0001066996','OH00001481820','IL','1','Roby','Mary','','','','34','549313960','214 E. Ohio St',0,'Kenton','OH','43326',NULL,'CY','39065','1959-09-19','F','M',':RET:2106-3','N','021','DEN','1767236','99734OH005000301','2014-02-01','2014-01-06 15:35:31','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-07 04:02:16'),(15919,12747,'Y','18','021','EC','A','','','AC','0000064899','0000064899','OH00001208592','IL','1','nowakowski','alan','','','','34','285722142','745 WASHINGTON ST',0,'TOLEDO','OH','43604','5909','CY','39095','1966-11-13','M','U',NULL,'N','021','HLT','1598701','92036OH006002601','2014-02-01','2014-01-02 16:16:32','154.00',NULL,NULL,'241.71','87.71','R-OH001','OH0','241.71',NULL,0,'2014-01-03 02:06:35'),(4656,3691,'N','01','021','EC','A',NULL,NULL,'','0001004143','0000690070','','IL','1','Caraway','Deborah','B','','','34','439922858','24 Belle Grove Drive',0,'Destrehan','LA','70047',NULL,'CY','22089','1956-09-01','F','',':RET:2106-3','N','021','DEN','345801','18575LA002000201','2014-01-01','2013-12-12 09:12:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:15'),(4137,3301,'Y','18','021','EC','A','','','AC','0000926253','0000926253','OH00001033610','IL','1','Rooley','Clinton','','','','34','517561813','6370 MAPLETON ST SE',0,'EAST CANTON','OH','44730','9566','CY','39151','1951-03-22','M','M',':RET:2106-3','N','021','DEN','2575770','99734OH005000301','2014-01-01','2013-12-17 11:18:57','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 21:48:29'),(7069,5613,'Y','18','021','EC','A','','','AC','0000566628','0000566628','OH00001584825','IL','1','Blair','Jeffrey','','','','34','302709082','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','1976-09-21','M','M',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:50:05'),(25572,20286,'N','01','021','EC','A',NULL,NULL,'','0001109277','0000194109','','IL','1','Dickerson','Jennifer','','','','34','600086623','4837 Overland Parkway',0,'Toledo','OH','43612',NULL,'CY','39095','1991-06-22','F','',NULL,'N','021','HLT','3786329','92036OH003002606','2014-04-01','2014-02-23 14:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.63',NULL,0,'2014-02-26 08:00:31'),(27100,21453,'Y','18','021','EC','A','','','AC','0001055377','0001055377','OH00003385974','IL','1','Wright','Kellee','','','','34','288829205','1845 BEECH RD',0,'STOW','OH','44224','3912','CY','39153','1971-03-17','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','2943336','99734OH005000301','2014-04-01','2014-03-03 07:27:59','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-03-03 21:30:21'),(27730,21929,'Y','18','021','EC','A','','','AC','0000713990','0000713990','TX00003156323','IL','1','TORRES','ALICIA','','','','34','464900955','1113 S 1ST ST',0,'HARLINGEN','TX','78550','7051','CY','48061','1950-01-09','F','U',NULL,'N','021','DEN','4088989','33348TX002000201','2014-04-01','2014-03-05 16:09:15','0.00',NULL,NULL,'29.22','29.22','R-TX005','TX0','14.61',NULL,0,'2014-03-05 21:31:03'),(2109,1729,'Y','18','021','EC','A','','','AC','0000783206','0000783206','OH00001255061','IL','1','Petrosky','Shannon','','','','34','285745525','46 Helena Dr.',0,'Struthers','OH','44471',NULL,'CY','39099','1978-11-20','F','U',':RET:2106-3','N','021','DEN','183169','99734OH005000401','2014-01-01','2013-12-10 10:25:34','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:17:22'),(21470,17157,'Y','18','021','EC','A','','','AC','0000219126','0000219126','MS00002156510','IL','1','anderson','erica','','','','34','425615360','5973 Baxter Dr',0,'Jackson','MS','39211',NULL,'CY','28049','1980-07-03','F','U',':RET:2054-5','N','021','DEN','3426369','46300MS002000201','2014-03-01','2014-02-04 12:21:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-04 21:01:38'),(21197,16939,'N','01','021','EC','A',NULL,NULL,'','0000375748','0000984244','','IL','1','Goodine','Elizabeth','Grace','','','34','453458336','101 BELLE CT',0,'MADISON','MS','39110','6928','CY','28089','1962-09-14','F','',':RET:2106-3','N','021','DEN','3800683','46300MS002000101','2014-03-01','2014-02-03 16:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-02-03 21:00:51'),(20136,16069,'Y','18','021','EC','A','','','AC','0000153400','0000153400','OH00002236529','IL','1','Seip','Nelson','','','','34','270440249','1103 RIDGEPOINT DR',0,'BATAVIA','OH','45103','2680','CY','39025','1951-08-17','M','M',':RET:2106-3','N','021','DEN','3116731','99734OH005000401','2014-03-01','2014-01-27 14:05:08','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-01-27 21:00:55'),(6150,4876,'N','01','021','EC','A',NULL,NULL,'','0000644636','0000873211','','IL','1','Kauffman','Lynn','C','','','34','173441593','9603 HICKORY HILL DR',0,'TWINSBURG','OH','44087','1546','CY','39153','1950-05-04','F','',NULL,'N','021','HLT','985951','52664OH151001501','2014-01-01','2013-11-21 05:26:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','789.56',NULL,0,'2013-12-26 00:16:29'),(16619,13295,'Y','18','021','EC','A','','','AC','0000295510','0000295510','OH00000137261','S3','1','gerhart','chris','','','','34','279154436','629 SKYLES RD',0,'UNION','OH','45322','3229','CY','39113','2009-05-06','F','U',':RET:2106-3','N','021','DEN','1492784','99734OH005000401','2014-02-01','2014-01-07 12:15:56','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2014-01-08 18:24:11'),(16170,12946,'Y','18','021','EC','A','','','AC','0002047849','0002047849','LA00001505105','IL','1','BERRY','MONIQUE','','','','34','437652460','34 IMOGENE ST',0,'WESTWEGO','LA','70094',NULL,'CY','22051','1986-05-06','F','U',':RET:2054-5','N','021','DEN','1607300','18575LA002000201','2014-02-01','2014-01-03 20:42:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-05 00:00:12'),(2368,1931,'Y','18','024','14','A','','','TE','0000678060','0000678060','','IL','1','Otchere','Baffour',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-20','M','',NULL,NULL,NULL,'','34684','','2013-12-09','2013-12-09 08:34:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:32:40'),(4096,3273,'Y','18','021','EC','A','','','AC','0000177623','0000177623','OH00000379925','IL','1','Chalwick','Kellyjean','','','','34','269663508','2823 KENWOOD BLVD',0,'TOLEDO','OH','43606','3224','CY','39095','1957-10-09','F','M',':RET:2106-3','N','021','HLT','2119327','92036OH004002601','2014-01-01','2013-12-17 13:06:37','0.00',NULL,NULL,'365.79','365.79','R-OH001','OH0','365.79',NULL,0,'2013-12-25 21:47:36'),(9581,7587,'Y','18','021','EC','A','','','AC','0000089814','0000089814','OH00001231015','IL','1','tadros','sacha','','','','34','328863788','6535 DOROTHYS CRK',0,'CANAL WINCHESTER','OH','43110','8097','CY','39049','1983-09-19','F','M',':RET:2106-3','N','021','DEN','1835142','99734OH005000301','2014-01-01','2013-12-21 17:53:02','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:36:54'),(25526,20250,'N','19','021','EC','A',NULL,NULL,'','0001220886','0000606013','','IL','1','PLATTENBURG','GUSTAV','','','','34','278966361','54 FLEMING RD',0,'CINCINNATI','OH','45215','2644','CY','39061','1993-04-02','M','',NULL,'N','021','HLT','3737360','92036OH004001201','2014-04-01','2014-02-25 16:24:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-25 21:32:09'),(28787,22787,'Y','18','021','EC','A','','','AC','0000088617','0000088617','OH00003616843','IL','1','Slay','Jackie','','','','34','272680965','519 south collins ave.',0,'Lima','OH','45804',NULL,'CY','39003','1970-04-25','F','M',':RET:2106-3','N','021','HLT','4089114','92036OH004001501','2014-04-01','2014-03-08 21:02:40','95.00',NULL,NULL,'240.14','145.14','R-OH002','OH0','240.14',NULL,0,'2014-03-09 21:00:39'),(28984,22940,'Y','18','024','14','A','','','TE','0000615576','0000615576','','IL','1','Robinson','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-12-24','M','',NULL,NULL,NULL,'','3047642','','2014-03-10','2014-03-10 09:41:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:10'),(2821,2280,'Y','18','021','EC','A','','','AC','0000916966','0000916966','OH00000576908','IL','1','Heil','David','','','','34','278548743','6718 FRANKLIN BLVD',0,'CLEVELAND','OH','44102','2915','CY','39035','1954-02-02','M','M',':RET:2106-3','N','021','DEN','704342','99734OH005000301','2014-01-01','2013-11-23 18:30:47','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:00:30'),(20880,16688,'Y','18','021','EC','A','','','AC','0000793498','0000793498','OH00002279333','31','1','HIGH','JEFFREY','L','','','34','299640548','P.O. BOX 121',0,'MENDEN','OH','45862',NULL,'CY','39107','1961-02-03','M','U',':RET:2106-3','N','021','HLT','2660684','92036OH003001505','2014-03-01','2014-01-31 08:51:44','358.00',NULL,NULL,'468.87','110.87','R-OH002','OH0','468.87',NULL,0,'2014-01-31 21:01:08'),(5511,4373,'N','19','021','EC','A',NULL,NULL,'','0001207117','0001086752','','IL','1','Stamp','Eric','Bruce','','','34','301982855','11818 Hidden Lake Dr.',0,'Marshallville','OH','44645',NULL,'CY','39169','1996-06-03','M','',':RET:2106-3','N','021','DEN','1073474','99734OH005000301','2014-01-01','2013-11-26 18:22:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:07'),(19905,15875,'Y','18','021','EC','A','','','AC','0001129042','0001129042','OH00002333525','IL','1','Hrusovsky','Elizabeth','','','','34','298904405','33850 GILBERT CT',0,'NORTH RIDGEVILLE','OH','44039','4387','CY','39093','1986-02-16','F','R',':RET:2106-3','N','021','HLT','2065259','52664OH151001501','2014-03-01','2014-01-23 20:13:07','0.00',NULL,NULL,'327.91','327.91','R-OH011','OH0','327.91',NULL,0,'2014-01-24 21:00:57'),(5106,4046,'Y','18','021','EC','A','','','AC','0000451615','0000451615','TX00000189615','31','1','FOO','Stephen','','','','34','467136556','P.O. Box 2662',0,'Addison','TX','75001',NULL,'CY','48113','1953-08-30','M','U',':RET:2034-7','N','021','DEN','2126902','33348TX002000201','2014-01-01','2013-12-19 17:25:55','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:01:33'),(19053,15176,'Y','18','021','EC','A','','','AC','0001040878','0001040878','OH00002559420','IL','1','LOVE','ROBERT','','','','34','278906806','1330 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5297','CY','39153','1977-11-03','M','U',NULL,'N','021','HLT','2469416','52664OH151001501','2014-03-01','2014-01-17 15:26:08','0.00',NULL,NULL,'328.98','328.98','R-OH012','OH0','328.98',NULL,0,'2014-01-20 08:06:46'),(3626,2900,'Y','18','021','EC','A','','','AC','0000119061','0000119061','OH00000336071','IL','1','kinman','troy','','','','34','310761469','220 SARA ST',0,'URBANA','OH','43078','1549','CY','39021','1974-06-15','M','U',':RET:2106-3','N','021','HLT','1684666','92036OH004000501','2014-01-01','2013-12-22 17:31:36','204.00',NULL,NULL,'241.21','37.21','R-OH003','OH0','241.21',NULL,0,'2013-12-25 21:23:46'),(4244,3381,'Y','18','021','EC','A','','','AC','0000982434','0000982434','TX00001274199','IL','1','CANALES','MARIA','M','','','34','464977255','14166 CLOVER POINT DR',0,'SUGAR LAND','TX','77498','1732','CY','48157','1960-09-05','F','M',NULL,'N','021','DEN','1723680','33348TX002000201','2014-01-01','2013-12-17 16:51:32','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:51:07'),(6542,5186,'N','01','021','EC','A',NULL,NULL,'','0000225807','0001226541','','IL','1','Palmer','Karen','','','','34','075603100','9641 BARKSDALE DR',0,'FORT WORTH','TX','76244','6047','CY','48439','1964-11-20','F','',':RET:2106-3','N','021','DEN','325582','33348TX002000201','2014-01-01','2013-12-11 10:38:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:51:56'),(9687,7672,'Y','18','021','EC','A','','','AC','0000889602','0000889602','OH00000614383','IL','1','Mackenbach','August','','','','34','279422759','204 WILLIAMS ST',0,'SAINT MARYS','OH','45885','1559','CY','39011','1951-04-24','M','U',':RET:2106-3','N','021','HLT','1628310','92036OH005001504','2014-01-01','2013-12-21 11:32:39','526.00',NULL,NULL,'632.30','106.30','R-OH002','OH0','632.30',NULL,0,'2013-12-26 04:39:36'),(22678,18110,'Y','18','021','EC','A','','','AC','0000097671','0000097671','TX00001672802','IL','1','AGUILAR','JULIO','','','','34','253690973','2007 OLMITOS AVE',0,'SAN JUAN','TX','78589','9793','CY','48215','1962-07-10','M','M',':RET:2106-3','N','021','DEN','3824477','33348TX002000201','2014-03-01','2014-02-11 16:43:34','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-11 21:00:46'),(27041,21416,'N','19','021','EC','A',NULL,NULL,'','0002253953','0001341772','','IL','1','Bradford','Hannah','Julianna','','','34','660039109','134 FOUNTAIN DR',0,'SLIDELL','LA','70458','1559','CY','22103','2000-10-20','F','',':RET:2106-3','N','021','DEN','3705898','18575LA002000201','2014-04-01','2014-03-03 11:17:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22','CIC',0,'2014-03-03 21:00:21'),(27097,21452,'N','19','021','EC','A',NULL,NULL,'','0000242767','0000546524','','IL','1','White','Truitt','Thomas','','','34','295089190','1010 CARNEGIE AVE',0,'AKRON','OH','44314','1146','CY','39153','2001-11-15','M','',':RET:2106-3','N','021','HLT','3110608','52664OH151001304','2014-04-01','2014-03-03 17:53:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 21:30:20'),(27502,21758,'N','01','021','EC','A',NULL,NULL,'','0000367445','0000515886','','IL','1','Wills','Brion','William','','','34','279961930','205 W WILLIAM ST',0,'MAUMEE','OH','43537','2179','CY','39095','1978-04-19','M','',':RET:2106-3','T','021','HLT','3506335','92036OH004002601','2014-04-01','2014-03-04 12:47:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.33',NULL,0,'2014-03-04 21:02:28'),(2774,2241,'Y','18','021','EC','A','','','AC','0000261885','0000261885','MS00001008839','IL','1','smith','kerry','','','','34','587925467','27 vinson dr.',0,'ellisville','MS','39437',NULL,'CY','28067','1954-07-01','M','M',':RET:2106-3','N','021','DEN','1134092','46300MS002000201','2014-01-01','2013-12-02 11:38:45','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 19:49:37'),(7749,6138,'Y','18','021','EC','A','','','AC','0000809669','0000809669','OH00000109999','31','1','KREGLOW','GLEN','','','','34','269646697','PO BOX 281',0,'DE GRAFF','OH','43318',NULL,'CY','39091','1959-10-09','M','M',':RET:2106-3','N','021','DEN','1872479','99734OH005000401','2014-01-01','2013-12-20 16:21:04','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:02:29'),(21693,17322,'Y','18','021','EC','A','','','AC','0000336459','0000336459','OH00001629815','IL','1','leveton','david','s','','','34','290446296','3355 ELMONT RD',0,'TOLEDO','OH','43615','1421','CY','39095','1952-06-03','M','M',':RET:2106-3','N','021','HLT','3206720','92036OH002002601','2014-03-01','2014-02-04 20:27:40','795.00',NULL,NULL,'1218.96','423.96','R-OH001','OH0','632.79',NULL,0,'2014-02-05 21:31:07'),(13337,10649,'Y','18','021','EC','A','','','AC','0000861829','0000861829','TX00000554661','IL','1','FLOREZ','SANTA','HUERGA','','','34','445523317','211 N 8TH ST',0,'MEMPHIS','TX','79245','2815','CY','48191','1952-02-29','F','U',':RET:2106-3','N','021','DEN','2384948','33348TX002000201','2014-01-01','2013-12-23 18:08:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:47'),(19126,15239,'Y','18','021','EC','A','','','AC','0000535785','0000535785','OH00002253098','IL','1','HASSAN','AHMED','','','','34','600796927','2388 VINING DR',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1964-12-15','M','M',':RET:2054-5','N','021','DEN','2746277','99734OH005000401','2014-03-01','2014-01-19 08:45:44','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:45:20'),(24768,19651,'N','01','021','EC','A',NULL,NULL,'','0000947441','0000807554','','IL','1','GARZA','RICHARD','','','','34','302782700','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-11-19','M','',NULL,'T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:43:53'),(27357,21665,'Y','18','024','14','A','','','TE','0000062589','0000062589','','IL','1','BROWN','SARAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-04-04','F','',NULL,NULL,NULL,'','3379760','','2014-03-04','2014-03-04 15:04:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:01:09'),(27446,21721,'Y','18','021','EC','A','','','AC','0000237645','0000237645','OH00003587466','IL','1','Droppleman','William','Michael','','','34','288580429','2940 Kensington Drive',0,'Norton','OH','44203',NULL,'CY','39153','1962-05-27','M','R',':RET:2106-3','N','021','HLT','2763047','52664OH151001501','2014-04-01','2014-03-03 20:25:03','0.00',NULL,NULL,'498.82','498.82','R-OH012','OH0','498.82',NULL,0,'2014-03-04 21:01:56'),(28733,22741,'Y','18','021','EC','A','','','AC','0001993728','0001993728','LA00003415521','IL','1','Raby','Debra','','','','34','435332689','6153 SAINT GABRIEL CT',0,'BATON ROUGE','LA','70811','4118','CY','22033','1964-09-01','F','U',':RET:2054-5','N','021','DEN','3413504','18575LA002000101','2014-04-01','2014-03-09 15:07:11','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-09 21:00:04'),(5011,3972,'N','19','021','EC','A',NULL,NULL,'','0000581452','0001158891','','IL','1','watkins','benjamin','','','','34','299964195','4816 forest glen trail',0,'ravenna','OH','44266',NULL,'CY','39133','1994-04-26','M','',':RET:2106-3','N','021','DEN','598783','99734OH005000301','2014-01-01','2013-12-07 17:19:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:20'),(20490,16369,'Y','18','021','EC','A','','','AC','0001208252','0001208252','LA00002167622','IL','1','ORTOLANO','STACI','','','','34','435652084','318 WESTMINSTER DR',0,'SLIDELL','LA','70460','8408','CY','22103','1980-08-07','F','U',':RET:2106-3','N','021','DEN','2291571','18575LA002000201','2014-03-01','2014-01-28 20:18:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-29 21:01:06'),(20235,16145,'Y','18','024','14','A','','','TE','0000384092','0000384092','','IL','1','johnson','brianna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-08-22','F','',NULL,NULL,NULL,'','657131','','2014-01-28','2014-01-28 02:51:09',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-28 21:00:05'),(19221,15315,'Y','18','021','EC','A','','','AC','0001031477','0001031477','OH00002134764','IL','1','GREEN','KEITH','','','','34','285682232','596 GREENWOOD AVE',0,'AKRON','OH','44320','1865','CY','39153','1964-01-03','M','M',NULL,'N','021','DEN','1940029','99734OH005000401','2014-03-01','2014-01-20 10:17:53','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-21 08:46:27'),(4337,3445,'Y','18','021','EC','A','','','AC','0000431363','0000431363','OH00000211571','IL','1','RAPPACH','LINDA','J','','','34','289523854','1251 E STATE ROUTE 350',0,'WILMINGTON','OH','45177','7145','CY','39027','1952-05-24','F','M',':RET:2106-3','N','021','HLT','2067961','92036OH003000605','2014-01-01','2013-12-17 11:34:22','486.00',NULL,NULL,'629.96','143.96','R-OH005','OH0','629.96',NULL,0,'2013-12-25 21:53:10'),(3263,2630,'Y','18','021','EC','A','','','AC','0000354993','0000354993','OH00000826215','IL','1','Bidinger','James','','','','34','281704488','1786 TREETOP TRL',0,'AKRON','OH','44313','8682','CY','39153','1969-10-13','M','U',':RET:2106-3','N','021','HLT','1014979','52664OH152000901','2014-01-01','2013-11-28 15:48:41','134.00',NULL,NULL,'228.19','94.19','R-OH012','OH0','228.19',NULL,0,'2013-12-25 20:46:58'),(23730,18893,'Y','18','021','EC','A','','','AC','0000266565','0000266565','OH00002208921','IL','1','WEILNAU','TAMMY','LYN','','','34','280726910','10693 HENRY LUCAS COUNTY RD',0,'GRAND RAPIDS','OH','43522',NULL,'CY','39069','1969-03-16','F','U',':RET:2106-3','N','021','HLT','3214458','92036OH003002604','2014-03-01','2014-02-13 20:17:14','141.00',NULL,NULL,'284.48','143.48','R-OH001','OH0','284.48',NULL,0,'2014-02-14 21:30:57'),(25763,20435,'Y','18','021','EC','A','','','AC','0001070528','0001070528','OH00003317248','IL','1','EHRMAN','REBECCA','','','','34','291440403','6267 BRANCH RD',0,'MEDINA','OH','44256','8942','CY','39103','1960-02-20','F','M',NULL,'N','021','HLT','3518090','52664OH151001305','2014-04-01','2014-02-24 17:44:29','752.00',NULL,NULL,'973.43','221.43','R-OH012','OH0','476.12',NULL,0,'2014-02-26 09:30:53'),(21538,17205,'N','19','021','EC','A',NULL,NULL,'','0000073971','0000692962','','IL','1','MacCarthy','Roland','','','','34','272117600','524 W. South Boundary Street',0,'Perrysburg','OH','43551',NULL,'CY','39173','1997-08-20','M','',NULL,'N','021','DEN','3765230','99734OH005000401','2014-03-01','2014-02-04 19:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:09'),(24168,19200,'N','01','021','EC','A',NULL,NULL,'','0000283311','0000160828','','IL','1','Hillis','Teresa','','','','34','291745894','13645 COUNTY ROAD M',0,'NAPOLEON','OH','43545','9571','CY','39069','1975-08-27','F','',NULL,'N','021','HLT','2752215','92036OH005002605','2014-03-01','2014-02-15 12:01:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','242.98',NULL,0,'2014-02-15 22:02:07'),(27174,21514,'N','01','021','EC','A',NULL,NULL,'','0000042349','0000242552','','IL','1','Nguyen','Thuy','Kim','','','34','640706128','4133 NE STALLINGS DR',0,'NACOGDOCHES','TX','75965','1630','CY','48347','1976-03-07','F','',NULL,'N','021','DEN','3644067','33348TX002000201','2014-04-01','2014-03-03 11:36:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-03 21:31:06'),(802,663,'Y','18','021','EC','A','','','AC','0000015253','0000015253','TX00001123451','IL','1','BASSINGER','SARAH','KATHRYN','','','34','455858781','3825 PEAKWOOD DR',0,'LA PORTE','TX','77571',NULL,'CY','48201','1984-10-19','F','U',':RET:2106-3','N','021','DEN','1620489','33348TX002000201','2014-01-01','2013-12-16 17:29:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:05:35'),(4817,3818,'Y','18','021','EC','A','','','AC','0001131417','0001131417','OH00001306074','IL','1','paparodis','theo','','','','34','268507901','250bGateway Drive',0,'milford','OH','45150',NULL,'CY','39025','1956-05-05','M','M',':RET:2106-3','T','021','HLT','113807','92036OH006000601','2014-01-01','2013-12-08 06:22:35','0.00',NULL,NULL,'585.24','585.24','R-OH005','OH0','477.13',NULL,0,'2013-12-25 22:16:58'),(19879,15857,'Y','18','021','EC','A','','','AC','0000183542','0000183542','OH00001553354','IL','1','kimbler','william','','','','34','285924763','4932 LYLE RD',0,'COLUMBUS','OH','43229','5308','CY','39049','1987-01-30','M','U',':RET:2106-3','N','021','DEN','3331504','99734OH005000401','2014-03-01','2014-01-24 14:25:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-24 21:00:45'),(19670,15675,'Y','18','021','EC','A','','','AC','0001018922','0001018922','TX00001584318','31','1','JASSO LOZOYA','CRISTINA','','','','34','525080289','PO BOX 1392',0,'ALICE','TX','78332',NULL,'CY','48249','1965-10-25','F','M',NULL,'N','021','DEN','2692942','33348TX002000201','2014-03-01','2014-01-22 18:59:30','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:31'),(18272,14587,'Y','18','021','EC','A','','','AC','0000972370','0000972370','TX00001826371','IL','1','Fuentes','Guillermo','','','','34','628167445','11561 MEADOWBROOK DR',0,'EL PASO','TX','79936','5636','CY','48141','1954-03-21','M','M',NULL,'N','021','DEN','2245003','33348TX002000201','2014-02-01','2014-01-15 17:30:03','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-16 08:44:42'),(17088,13676,'Y','18','024','14','A','','','TE','0001090661','0001090661','','IL','1','MARTINEZ','VERONICA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-08-13','F','',NULL,NULL,NULL,'','2521141','','2014-01-08','2014-01-08 14:48:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:21:26'),(2607,2118,'Y','18','021','EC','A','','','AC','0000976676','0000976676','OH00000126914','IL','1','BULLOCK','VICTOR','L','','','34','298564282','4424 FIELDS ERTEL RD',0,'CINCINNATI','OH','45241','1268','CY','39017','1961-09-26','M','U',NULL,'N','021','DEN','1040900','99734OH005000401','2014-01-01','2013-12-02 09:19:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:29'),(14806,11825,'Y','18','021','EC','A','','','AC','0001707032','0001707032','LA00001289929','IL','1','Peterson','George','','','IV','34','437479707','231 Ridgewood Drive',0,'Metairie','LA','70005',NULL,'CY','22051','1971-05-09','M','R',':RET:2106-3','N','021','DEN','2394019','18575LA002000101','2014-01-01','2013-12-23 20:01:08','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,1,'2013-12-29 11:13:54'),(6451,5113,'Y','18','021','EC','A','','','AC','0000963205','0000963205','OH00000022395','IL','1','Matthews','Janice','','','','34','281568676','228 Austin St',0,'Toledo','OH','43608',NULL,'CY','39095','1954-02-14','F','U',':RET:2106-3','N','021','HLT','1238520','92036OH004002601','2014-01-01','2013-12-11 08:52:07','377.00',NULL,NULL,'408.14','31.14','R-OH001','OH0','408.14',NULL,0,'2013-12-26 00:49:39'),(7237,5738,'Y','18','021','EC','A','','','AC','0000622892','0000622892','LA00000185992','IL','1','Justice','Michael','','','','34','349646457','208 BAYOU DR',0,'ALEXANDRIA','LA','71301','5507','CY','22079','1976-11-21','M','U',':RET:2054-5','T','021','DEN','403145','18575LA002000201','2014-01-01','2013-12-13 20:35:19','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-26 02:01:35'),(9671,7662,'Y','18','021','EC','A','','','AC','0000652117','0000652117','OH00000569414','IL','1','smith','jeanne','','','','34','262276087','1016 XENIA AVE',0,'WILMINGTON','OH','45177','1349','CY','39027','1956-06-11','F','M',':RET:2106-3','N','021','HLT','1803138','92036OH002000601','2014-01-01','2013-12-21 16:38:39','403.00',NULL,NULL,'604.16','201.16','R-OH005','OH0','604.16',NULL,0,'2013-12-26 04:39:14'),(21838,17439,'N','01','021','EC','A',NULL,NULL,'','0000361052','0000125599','','IL','1','Reed','Barry','','','','34','403748808','6161 BERKINSHAW DR',0,'CINCINNATI','OH','45230','3675','CY','39061','1951-05-31','M','',':RET:2106-3','N','021','HLT','3055847','92036OH006001201','2014-03-01','2014-02-06 11:07:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','489.12',NULL,0,'2014-02-06 21:01:08'),(22067,17615,'Y','18','021','EC','A','','','AC','0000318395','0000318395','TX00001629893','31','1','Colbert','Excelcer','','','','34','455530864','130 W Woodin',0,'Dallas','TX','75224',NULL,'CY','48113','1979-11-12','M','U',':RET:2054-5','N','021','DEN','3721090','33348TX002000201','2014-03-01','2014-02-08 14:47:59','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-08 19:00:12'),(22323,17824,'Y','18','021','EC','A','','','AC','0002247628','0002247628','LA00001350902','IL','1','Perez','Sergio','A','','','34','439653733','3027 GOLDEN DR',0,'SLIDELL','LA','70460','3905','CY','22103','1984-02-04','M','M',':RET:2106-3','N','021','DEN','3073081','18575LA002000201','2014-03-01','2014-02-02 15:45:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 11:00:55'),(23607,18803,'N','19','021','EC','A',NULL,NULL,'','0000051967','0000186155','','IL','1','Hamp','Nicole','','','','34','593835512','732 w 1st st',0,'delphos','OH','45833',NULL,'CY','39161','1999-04-19','F','',':RET:2106-3','N','021','HLT','3474683','92036OH003001501','2014-03-01','2014-02-13 15:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2014-02-13 22:03:10'),(23833,18964,'Y','18','021','EC','A','','','AC','0000743192','0000743192','MS00002502566','IL','1','Wiggins','Tiffany','','','','34','587492639','13105 Rocky Mountain Rd',0,'Biloxi','MS','39532',NULL,'CY','28047','1984-07-07','F','U',':RET:2054-5','N','021','DEN','2697237','46300MS002000101','2014-03-01','2014-02-14 13:18:49','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-02-14 21:31:47'),(25040,19857,'Y','18','021','EC','A','','','AC','0001048041','0001048041','OH00002933611','IL','1','Zink','Eileen','','','','34','272520462','3868 Yale Avenue',0,'Lima','OH','45804',NULL,'CY','39003','1951-10-30','F','U',':RET:2106-3','N','021','HLT','3365628','92036OH003001504','2014-04-01','2014-02-20 15:34:51','535.00',NULL,NULL,'660.32','125.32','R-OH002','OH0','660.32',NULL,0,'2014-02-20 22:01:09'),(4433,3523,'Y','18','021','EC','A','','','AC','0001205802','0001205802','OH00000587033','IL','1','Odonnell','Matthew','','','','34','300801388','6475 SANDFIELD DR',0,'BROOKPARK','OH','44142','3753','CY','39035','1972-10-22','M','U',':RET:2106-3','N','021','DEN','188592','99734OH005000401','2014-01-01','2013-12-12 18:27:37','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:01:54'),(6960,5525,'N','01','021','EC','A',NULL,NULL,'','0000093853','0000575930','','IL','1','MURPHY','CLARICE','S','','','34','558513029','4030 BELMORE TRACE',0,'DAYTON','OH','45426',NULL,'CY','39113','1964-07-13','F','',':RET:2054-5','N','021','DEN','1504748','99734OH005000401','2014-01-01','2013-12-24 22:17:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:13'),(19717,15712,'Y','18','021','EC','A','','','AC','0001216282','0001216282','OH00002268710','IL','1','FORFMAN','KAY','','','','34','385629293','28345 SIMMONS RD',0,'PERRYSBURG','OH','43551','4157','CY','39173','1957-07-27','F','U',NULL,'N','021','HLT','3159784','92036OH004002601','2014-03-01','2014-01-22 19:49:25','143.00',NULL,NULL,'365.79','222.79','R-OH001','OH0','365.79',NULL,0,'2014-01-23 21:00:56'),(8058,6381,'Y','18','021','EC','A','','','AC','0000964721','0000964721','MI00000234420','IL','1','WARSAW','STACY','','','','34','366547546','UNION N EAST',0,'GRAND RAPIDS','MI','45459',NULL,'CY','39057','1959-01-25','F','U',':RET:2106-3','N','021','HLT','1452688','92036OH006000501','2014-01-01','2013-12-20 13:24:34','271.00',NULL,NULL,'402.48','131.48','R-OH003','MI0','402.48',NULL,0,'2013-12-26 03:09:54'),(15108,12076,'Y','18','021','EC','A','','','AC','0001049386','0001049386','OH00000063180','IL','1','DIPUCCIO','WILLIAM','','','','34','295441062','58 E HOWE RD',0,'TALLMADGE','OH','44278','1055','CY','39153','1958-12-26','M','M',NULL,'N','021','DEN','2121427','99734OH005000301','2014-02-01','2013-12-30 13:01:07','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-01 12:04:54'),(15302,12235,'Y','18','021','EC','A','','','AC','0001276960','0001276960','LA00001466627','IL','1','PRATT','LAURIE','','','','34','439118089','16135 CODY LN',0,'COVINGTON','LA','70435','7933','CY','22103','1957-03-11','F','U',':RET:2106-3','N','021','DEN','1417746','18575LA002000201','2014-02-01','2013-12-31 23:15:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:22:52'),(15542,12436,'Y','18','021','EC','A','','','AC','0001716311','0001716311','LA00001832891','IL','1','SANDERS','HENRY','Letroy','','','34','438671804','2715 JONES MABRY RD',0,'SHREVEPORT','LA','71107','8000','CY','22017','1981-01-21','M','U',':RET:2054-5','N','021','DEN','2605906','18575LA002000201','2014-02-01','2013-12-31 14:42:50','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,1,'2014-01-02 04:30:59'),(25951,20581,'Y','18','021','EC','A','','','AC','0000687266','0000687266','OH00002708544','IL','1','Tope','Teresa','','','','34','292764020','5593 CEDAR SPGS',0,'COLUMBUS','OH','43228','7209','CY','39049','1980-12-14','F','U',':RET:2106-3','N','021','DEN','2977916','99734OH005000401','2014-03-01','2014-02-26 10:27:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:36'),(27791,21981,'Y','18','021','EC','A','','','AC','0001187438','0001187438','MS00003196963','IL','1','LOVE','MARY','LEE','','','34','426195337','1520 PITTSBURG ST',0,'JACKSON','MS','39203','2850','CY','28049','1960-10-08','F','U',NULL,'N','021','DEN','3769564','46300MS002000201','2014-04-01','2014-03-05 15:05:55','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-05 21:31:40'),(56,51,'Y','18','021','EC','A','','','AC','0000212143','0000212143','OH00000201125','IL','1','Jackson','cynthia','','','','34','290466298','7729 MYRNA AVE',0,'HUDSON','OH','44236','1333','CY','39153','1950-01-11','F','M',':RET:2054-5','N','021','DEN','260173','99734OH005000301','2014-01-01','2013-12-04 22:01:34','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:16:32'),(1222,1005,'Y','18','021','EC','A','','','AC','0000743051','0000743051','OH00000155124','IL','1','Kundtz','Gwendolyn','','','','34','276800942','1434 Rio',0,'lakewood','OH','44107',NULL,'CY','39035','1982-06-26','F','U',':RET:2106-3','N','021','HLT','40367','52664OH151001305','2014-01-01','2013-12-03 11:13:13','166.00',NULL,NULL,'291.51','125.51','R-OH011','OH0','291.51',NULL,0,'2013-12-25 18:20:26'),(7858,6221,'N','19','021','EC','A',NULL,NULL,'','0000951788','0000011154','','S1','1','Scott','Evan','L','','','34','295082247','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','2004-02-19','M','',':RET:2106-3','N','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:58'),(18440,14712,'N','01','021','EC','A',NULL,NULL,'','0001227293','0002164556','','IL','1','Nguyen','Ha','Thi','','','34','731247281','2275 N VEGA DR',0,'BATON ROUGE','LA','70815','8860','CY','22033','1974-10-20','F','',NULL,'N','021','DEN','1732058','18575LA002000201','2014-02-01','2014-01-15 17:00:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-16 08:46:03'),(8907,7064,'Y','18','021','EC','A','','','AC','0001032599','0001032599','OH00000692544','IL','1','Haring','Alma','','','','34','292881316','5471 LINCOLN BLVD',0,'HUDSON','OH','44236','2639','CY','39153','1973-04-19','F','M',':RET:2106-3','N','021','DEN','1990919','99734OH005000401','2014-01-01','2013-12-17 20:17:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:02:28'),(14392,11479,'Y','18','021','EC','A','','','AC','0001012934','0001012934','OH00000758895','IL','1','Boakai','anthony','','','','34','493272938','4129 SKYVIEW DR',0,'COLUMBUS','OH','43224','6833','CY','39049','1970-04-13','M','U',':RET:2054-5','N','021','DEN','1567670','99734OH005000401','2014-02-01','2013-12-27 15:06:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-28 03:31:02'),(15623,12496,'Y','18','021','EC','A','','','AC','0000114836','0000114836','MS00001625297','IL','1','TAYLOR','GLENDA','','','','34','587542507','354 HICKORY HILL CIR',0,'FLORENCE','MS','39073','8561','CY','28121','1950-08-29','F','M',':RET:2106-3','N','021','DEN','1460871','46300MS002000101','2014-02-01','2013-12-31 17:09:22','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,1,'2014-01-02 04:33:14'),(17266,13812,'N','19','021','EC','A',NULL,NULL,'','0000669198','0000342750','','IL','1','Karasek','Leah','','','','34','278984549','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1995-03-07','F','',':RET:2106-3','N','021','DEN','1797637','99734OH005000301','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:23:19'),(22714,18138,'Y','18','021','EC','A','','','AC','0001460362','0001460362','LA00002163441','IL','1','LeMense','Julia','','','','34','385642737','713 TOURO ST',0,'NEW ORLEANS','LA','70116','1633','CY','22071','1971-03-07','F','U',':RET:2106-3','N','021','DEN','3386527','18575LA002000201','2014-03-01','2014-02-11 06:47:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:06'),(27296,21613,'Y','18','021','EC','A','','','AC','0001120973','0001120973','TX00003583510','IL','1','FERGUSON','CHUJUNNA','Y','','','34','450275277','408 BETTY DR',0,'LONGVIEW','TX','75602','5358','CY','48183','1957-08-02','F','U',':RET:2054-5','N','021','DEN','2630362','33348TX002000201','2014-04-01','2014-03-04 11:22:03','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-03-04 21:00:31'),(631,522,'Y','18','021','EC','A','','','AC','0001037336','0001037336','OH00001290940','IL','1','WILLIAMS','DEBORAH','JOE','','','34','287464305','69 OGLESBEE RD',0,'WILMINGTON','OH','45177',NULL,'CY','39027','1952-12-02','F','M',':RET:2106-3','N','021','DEN','2579616','99734OH005000401','2014-01-01','2013-12-16 13:00:10','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:01:06'),(20448,16332,'Y','18','024','14','A','','','TE','0000475703','0000475703','','IL','1','Bradley','Willie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-07','M','',NULL,NULL,NULL,'','3136544','','2014-01-29','2014-01-29 14:59:16',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-29 21:00:43'),(18842,15008,'Y','18','024','14','A','','','TE','0000655842','0000655842','','IL','1','hasrouni','george',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-12-05','M','',NULL,NULL,NULL,'','2639649','','2014-01-16','2014-01-16 14:33:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:13'),(2087,1708,'Y','18','021','EC','A','','','AC','0000053284','0000053284','LA00001250556','IL','1','thomas','travis','','','','34','437497329','6053 ingram drive',0,'baton rouge','LA','70812',NULL,'CY','22033','1978-12-27','M','U',':RET:2054-5','N','021','DEN','188496','18575LA002000201','2014-01-01','2013-12-10 15:03:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:46'),(16885,13511,'Y','18','021','EC','A','','','AC','0000522785','0000522785','TX00002404523','IL','1','SADEGHBEGI','MEDI','','','','34','463777205','11152 WESTHEIMER RD',0,'HOUSTON','TX','77042','3208','CY','48201','1963-01-12','M','U',':RET:2106-3','N','021','DEN','2004727','33348TX002000201','2014-02-01','2014-01-09 11:46:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:19:24'),(16472,13181,'Y','18','021','EC','A','','','AC','0001151092','0001151092','OH00002241393','IL','1','Rosenberg','Mary','','','','34','276446352','5844 MARTIN DR',0,'HUDSON','OH','44236','2039','CY','39153','1950-06-17','F','M',':RET:2106-3','N','021','HLT','1783525','52664OH151001304','2014-02-01','2014-01-06 13:47:27','404.00',NULL,NULL,'658.32','254.32','R-OH012','OH0','658.32',NULL,0,'2014-01-07 04:05:58'),(14527,11591,'Y','18','021','EC','A','','','AC','0000314173','0000314173','TX00001657575','IL','1','Ramirez','Raphael','','','','34','455536463','4925 LANSDOWN DR',0,'CORPUS CHRISTI','TX','78411','3927','CY','48355','1977-04-05','M','M',':RET:2106-3','N','021','DEN','1985262','33348TX002000201','2014-02-01','2013-12-27 17:45:26','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-28 03:34:28'),(15952,12771,'Y','18','021','EC','A','','','AC','0000740289','0000740289','OH00001974158','IL','1','Lee','Christoffer','','','','34','118744374','8241 CELESTIAL CIR',0,'LIBERTY TOWNSHIP','OH','45044','8399','CY','39017','1983-04-02','M','M',':RET:2106-3','N','021','DEN','2336484','99734OH005000301','2014-02-01','2014-01-02 22:43:10','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:00:08'),(14900,11902,'Y','18','021','EC','A','','','AC','0000025300','0000025300','OH00000101407','IL','1','Rosenberg','Elizabeth','','','','34','269888859','725 Upper Merriman Drive',0,'Akron','OH','44303',NULL,'CY','39153','1987-05-02','F','U',':RET:2106-3','N','021','HLT','1685004','52664OH152000901','2014-02-01','2013-12-28 18:45:25','69.00',NULL,NULL,'167.26','98.26','R-OH012','OH0','167.26',NULL,0,'2013-12-30 00:01:05'),(22459,17932,'Y','18','021','EC','A','','','AC','0000494596','0000494596','TX00001676845','IL','1','VO','HUNG','','','','34','731260217','9122 FERNDALE VIEW DR',0,'HOUSTON','TX','77064','3487','CY','48201','1978-10-08','M','U',':RET:2047-9','T','021','DEN','3271302','33348TX002000201','2014-03-01','2014-02-10 15:28:06','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-10 21:30:51'),(24755,19644,'Y','18','021','EC','A','','','AC','0000387336','0000387336','OH00002849396','IL','1','Troendly','Benjamin','','','','34','282888063','835 KENILWORTH AVE',0,'COSHOCTON','OH','43812','2367','CY','39031','1977-08-02','M','U',':RET:2106-3','N','021','DEN','3815789','99734OH005000401','2014-04-01','2014-02-19 11:52:35','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-20 04:42:02'),(28744,22750,'Y','18','021','EC','A','','','AC','0002227852','0002227852','LA00003256443','IL','1','hampton','carolyn','m','','','34','437296363','8100 pines rd',0,'shreveport','LA','71129',NULL,'CY','22017','1975-12-10','F','U',':RET:2054-5','N','021','DEN','3849089','18575LA002000201','2014-04-01','2014-03-09 15:13:53','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-09 21:00:11'),(1428,1190,'Y','18','021','EC','A','','','AC','0001756531','0001756531','LA00000120550','IL','1','lunn','cheryl','','','','34','245270502','3360 Reine Ave',0,'Slidell','LA','70458',NULL,'CY','22103','1963-05-25','F','U',':RET:2106-3','N','021','DEN','2409132','18575LA002000201','2014-01-01','2013-12-24 16:58:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:28'),(20822,16641,'Y','18','021','EC','A','','','AC','0000578531','0000578531','LA00001834605','IL','1','Breaux','Gina','','','','34','433338821','1131 CURRIE DR',0,'SULPHUR','LA','70665','7927','CY','22019','1961-10-28','F','U',':RET:2106-3','N','021','DEN','3125916','18575LA002000201','2014-03-01','2014-01-31 13:27:08','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-31 21:00:36'),(3982,3179,'N','01','021','EC','A',NULL,NULL,'','0000643212','0000261474','','IL','1','ludwig','debra','','','','34','275721015','1206 S BLANCHARD ST',0,'FINDLAY','OH','45840','6121','CY','39063','1965-12-22','F','',':RET:2106-3','T','021','HLT','691255','92036OH003001506','2014-01-01','2013-12-13 14:15:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','432.15',NULL,0,'2013-12-25 21:38:50'),(17475,13971,'Y','18','021','EC','A','','','AC','0000949026','0000949026','TX00001511654','IL','1','mcelvany','Erica','','','','34','642057552','2500 n. Eastman rd.',0,'longview','TX','75605',NULL,'CY','48183','1987-11-25','F','R',NULL,'N','021','DEN','2541662','33348TX002000201','2014-02-01','2014-01-11 20:19:55','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-13 03:01:09'),(14647,11690,'Y','18','021','EC','A','','','AC','0000248053','0000248053','TX00000540690','IL','1','Whitty','Michael','','','','34','485151954','405 SPRUCE ST',0,'TEXARKANA','TX','75501','5530','CY','48037','1986-05-29','M','U',':RET:2106-3','T','021','DEN','1446883','33348TX002000201','2014-02-01','2013-12-28 12:19:29','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,1,'2013-12-29 11:07:37'),(15996,12802,'N','01','021','EC','A',NULL,NULL,'','0001184944','0000444398','','IL','1','McGee','Alicia','','','','34','637641479','555 COUNTY ROAD 4315',0,'Omaha','TX','75571',NULL,'CY','48449','1979-06-23','F','',NULL,'N','021','DEN','2133736','33348TX002000201','2014-02-01','2014-01-03 13:53:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:01:22'),(22756,18168,'Y','18','021','EC','A','','','AC','0002187218','0002187218','LA00001911621','IL','1','Johnson','Tiffany','','','','34','439799079','1922 SPAIN ST',0,'NEW ORLEANS','LA','70117','8122','CY','22071','1990-11-28','F','U',':RET:2054-5','N','021','DEN','2830455','18575LA002000101','2014-03-01','2014-02-11 17:02:38','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-11 21:01:29'),(23788,18930,'N','01','021','EC','A',NULL,NULL,'','0000823559','0001181065','','IL','1','BLACKWOOD','GREGORY','','','','34','270704932','267 SOUTH BLVD',0,'WADSWORTH','OH','44281','1782','CY','39103','1960-10-20','M','',':RET:2106-3','N','021','HLT','3311553','52664OH151001306','2014-03-01','2014-02-13 22:27:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.94',NULL,0,'2014-02-14 21:31:24'),(24699,19608,'Y','18','021','EC','A','','','AC','0000194106','0000194106','OH00003008678','S1','1','tucker','christopher','','','','34','291068322','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2001-12-03','M','U',':RET:2106-3','N','021','DEN','3274450','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:33:50'),(25557,20275,'N','01','021','EC','A',NULL,NULL,'','0000638562','0001256088','','IL','1','Abney','James','','','','34','290822492','14533 UPPER CUMBERLAND RD',0,'MOUNT ORAB','OH','45154','9085','CY','39015','1981-07-20','M','',NULL,'N','021','HLT','3140999','92036OH004000601','2014-04-01','2014-02-23 08:34:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','204.20',NULL,0,'2014-02-26 08:00:21'),(27759,21951,'Y','18','024','14','A','','','TE','0001284884','0001284884','','IL','1','LEE','Frances',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-02-15','F','',NULL,NULL,NULL,'','2869341','','2014-03-20','2014-03-05 11:19:16',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-05 21:31:19'),(7713,6107,'Y','18','021','EC','A','','','AC','0000995428','0000995428','OH00001137433','IL','1','MOROSKY','HARRISE','','','','34','289523895','7642 JOHN WHITE ROAD',0,'HUBBARD','OH','44425',NULL,'CY','39155','1952-08-20','F','M',':RET:2106-3','N','021','DEN','2347654','99734OH005000401','2014-01-01','2013-12-20 10:09:19','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 03:01:33'),(16160,12940,'N','19','021','EC','A',NULL,NULL,'','0000801241','0000317329','','IL','1','Muktar','Malia','','','','34','829843937','1100 RING NECK DR',0,'BLACKLICK','OH','43004','7035','CY','39049','2013-09-26','F','',':RET:2054-5','N','021','DEN','1671017','99734OH005000401','2014-01-01','2013-12-16 22:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 06:00:11'),(17575,14052,'N','01','021','EC','A',NULL,NULL,'','0001051920','0000175121','','IL','1','Moore','Matthew','R','','','34','291568874','112 OVERWOOD RD',0,'AKRON','OH','44313',NULL,'CY','39153','1957-02-02','M','',NULL,'N','021','DEN','1805230','99734OH005000401','2014-02-01','2014-01-13 13:32:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:03'),(20342,16243,'N','01','021','EC','A',NULL,NULL,'','0001125469','0000148370','','IL','1','Wcislo','Donald','','','','34','281649169','4790 BEACH RD',0,'MEDINA','OH','44256','8462','CY','39103','1959-01-16','M','',':RET:2106-3','N','021','HLT','3371345','52664OH151001305','2014-03-01','2014-01-28 10:18:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2014-01-28 21:01:08'),(22624,18066,'Y','18','021','EC','A','','','AC','0001124842','0001124842','TX00002503486','IL','1','Romo','Misty','','','','34','454659470','1409 DEWITT ST',0,'CORPUS CHRISTI','TX','78418','4309','CY','48355','1973-11-08','F','M',':RET:2106-3','N','021','DEN','3116998','33348TX002000201','2014-03-01','2014-02-10 20:46:53','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-02-11 21:00:12'),(25765,20436,'Y','18','024','14','A','','','TE','0001048017','0001048017','','IL','1','Murach','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-07','M','',NULL,NULL,NULL,'','2343464','','2014-02-24','2014-02-24 12:41:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-26 09:30:54'),(26716,21178,'Y','18','021','EC','A','','','AC','0001029888','0001029888','MS00003099749','IL','1','BRACEY','KIMBERLY','','','','34','427676056','2130 MARGARET W ALEXANDER DR',0,'JACKSON','MS','39213','6407','CY','28049','1985-02-26','F','U',NULL,'N','021','DEN','2765163','46300MS002000201','2014-04-01','2014-02-28 15:19:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 21:31:41'),(27185,21524,'Y','18','021','EC','A','','','AC','0000329584','0000329584','TX00003045026','IL','1','Nieto','Robert','','','','34','454830415','8515 brodie ln',0,'austin','TX','78745',NULL,'CY','48453','1979-07-17','M','U',':RET:2106-3','N','021','DEN','3859327','33348TX002000201','2014-04-01','2014-03-03 14:44:52','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-03 21:31:12'),(27519,21771,'Y','18','024','14','A','','','TE','0000699332','0000699332','','IL','1','Randolph','Clayton','','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-02-21','M','',NULL,NULL,NULL,'','3392001','','2014-03-04','2014-03-04 16:45:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-04 21:02:39'),(27766,21957,'Y','18','021','EC','A','','','AC','0002373866','0002373866','LA00003465767','IL','1','DEL CASTILLO LOPEZ','MARIO','ESTUARDO','','','34','663128331','3512 N ARNOULT RD',0,'METAIRIE','LA','70002','3348','CY','22051','1978-05-01','M','U',':RET:2106-3','N','021','DEN','4052636','18575LA002000201','2014-04-01','2014-03-05 13:51:17','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:23'),(28771,22775,'Y','18','021','EC','A','','','AC','0000364954','0000364954','OH00002794032','IL','1','FREDERICK','ALBERT','S','','Jr','34','297440458','400 HURON ST',0,'HURON','OH','44839','1752','CY','39043','1951-12-14','M','U',':RET:2106-3','N','021','DEN','3760175','99734OH005000401','2014-04-01','2014-03-09 11:29:48','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-03-09 21:00:29'),(567,465,'Y','18','021','EC','A','','','AC','0000111857','0000111857','OH00000915004','IL','1','Wolf','Craig','','','','34','280823852','5606 Fenwick Dr.',0,'Toledo','OH','43623',NULL,'CY','39095','1976-06-16','M','U',':RET:2106-3','T','021','HLT','791060','92036OH006002601','2014-01-01','2013-12-04 14:31:23','152.00',NULL,NULL,'220.16','68.16','R-OH001','OH0','220.16',NULL,0,'2013-12-25 17:50:29'),(867,718,'Y','18','021','EC','A','','','AC','0000705127','0000705127','OH00000917949','IL','1','Vargas','Tammy','','','','34','126543973','496 N Firestone Blvd',0,'Akron','OH','44301',NULL,'CY','39153','1965-10-25','F','M',':RET:2106-3','N','021','HLT','2445667','52664OH151001501','2014-01-01','2013-12-16 10:49:53','648.00',NULL,NULL,'936.13','288.13','R-OH012','OH0','437.31',NULL,0,'2013-12-25 18:07:21'),(1889,1545,'Y','18','021','EC','A','','','AC','0000860980','0000860980','OH00000890282','IL','1','Morse','James','','','','34','371964342','1140 E. Riverview Avenue',0,'Napoleon','OH','43545',NULL,'CY','39069','1968-12-24','M','U',':RET:2106-3','N','021','HLT','1653855','92036OH002002601','2014-01-01','2013-12-24 12:00:22','157.00',NULL,NULL,'325.18','168.18','R-OH001','OH0','325.18',NULL,0,'2013-12-25 18:58:47'),(5289,4191,'Y','18','021','EC','A','','','AC','0000902199','0000902199','OH00000696124','IL','1','Meers','Rebecca','','','','34','289667098','7150 DOYLESTOWN RD',0,'STERLING','OH','44276','9712','CY','39169','1959-08-15','F','M',':RET:2106-3','N','021','HLT','1436469','52664OH151001306','2014-01-01','2013-12-19 16:14:19','376.00',NULL,NULL,'476.12','100.12','R-OH014','OH0','476.12',NULL,0,'2013-12-25 23:05:58'),(3928,3144,'Y','18','021','EC','A','','','AC','0000218814','0000218814','OH00000781994','IL','1','Hollington','Susan','','','','34','376566823','833 BITTERBRUSH LN',0,'FINDLAY','OH','45840','7101','CY','39063','1950-06-27','F','M',':RET:2106-3','N','021','HLT','841105','92036OH002001501','2014-01-01','2013-12-12 20:35:09','898.00',NULL,NULL,'1512.74','614.74','R-OH002','OH0','750.27',NULL,0,'2013-12-25 21:37:33'),(9407,7463,'Y','18','021','EC','A','','','AC','0000140542','0000140542','TX00000751717','IL','1','Ramirez','Hector','','','','34','642263869','1132 COUNTY ROAD 220',0,'FLORENCE','TX','76527','4334','CY','48491','1987-05-31','M','M',NULL,'N','021','DEN','1455253','33348TX002000201','2014-01-01','2013-12-21 11:03:24','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 04:32:46'),(3047,2447,'Y','18','021','EC','A','','','AC','0000765676','0000765676','TX00001174195','IL','1','STEGER','KENNETH','WADE','','','34','585882324','301 HORSE SHOE BEND TRAIL',0,'MERTZON','TX','76941',NULL,'CY','48235','1963-09-21','M','U',':RET:2106-3','N','021','DEN','831998','33348TX002000101','2014-01-01','2013-12-06 14:02:31','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2013-12-25 20:18:47'),(22372,17866,'N','19','021','EC','A',NULL,NULL,'','0000300124','0000088560','','IL','1','Aziz','Sabika','','','','34','635923208','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1990-08-25','F','',':RET:2029-7','N','021','DEN','3129623','33348TX002000101','2014-03-01','2014-02-10 15:13:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15','CIC',0,'2014-02-10 21:00:14'),(23281,18559,'Y','18','021','EC','A','','','AC','0002134557','0002134557','LA00002221563','IL','1','nicholas','erica','','','','34','437113894','825 E HARDING ST',0,'DESTREHAN','LA','70047','4222','CY','22089','1962-05-14','F','U',':RET:2054-5','N','021','DEN','3708018','18575LA002000201','2014-03-01','2014-02-13 13:19:13','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-13 21:30:16'),(26706,21172,'Y','18','021','EC','A','','','AC','0000666820','0000666820','OH00003300123','31','1','Perry','Steven','','','','34','281623156','PO Box 523',0,'Monroeville','OH','44847',NULL,'CY','39077','1959-02-22','M','M',NULL,'N','021','HLT','3486303','92036OH004002701','2014-04-01','2014-02-28 10:10:30','594.00',NULL,NULL,'669.51','75.51','R-OH006','OH0','349.65',NULL,0,'2014-02-28 21:31:36'),(28627,22655,'Y','18','021','EC','A','','','AC','0000564254','0000564254','TX00003098801','IL','1','Lerma','Jaime','','','','34','467960079','115 W BROADWAY ST',0,'BROWNSVILLE','TX','78520','4306','CY','48061','1953-07-20','M','U',':RET:2106-3','N','021','DEN','4147253','33348TX002000201','2014-04-01','2014-03-08 11:05:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,NULL,0,'2014-03-08 21:30:24'),(2638,2143,'Y','18','021','EC','A','','','AC','0000173784','0000173784','OH00000779232','IL','1','Palange','Beth','','','','34','277809593','7642 WILLOW WOODS DR',0,'NORTH OLMSTED','OH','44070','6332','CY','39035','1979-03-15','F','U',':RET:2106-3','N','021','DEN','1243233','99734OH005000401','2014-01-01','2013-12-02 13:44:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:46:16'),(21218,16956,'Y','18','021','EC','A','','','AC','0002045234','0002045234','LA00001602767','IL','1','Davis','James','','','','34','437572488','267 randy road',0,'West monroe','LA','71292',NULL,'CY','22073','1983-02-20','M','M',':RET:2106-3','N','021','DEN','3089576','18575LA002000201','2014-03-01','2014-02-03 15:38:38','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-03 21:01:02'),(21009,16787,'N','01','021','EC','A',NULL,NULL,'','0001131475','0000307128','','IL','1','Rudduck','Amanda','N','','','34','310138180','488 KATHRYN DR',0,'WILMINGTON','OH','45177','1712','CY','39027','1985-01-18','F','',':RET:2106-3','N','021','DEN','2840026','99734OH005000401','2014-03-01','2014-01-31 22:19:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:33'),(18746,14938,'Y','18','021','EC','A','','','AC','0000397371','0000397371','OH00001542024','IL','1','Marini','Lisa','','','','34','273607141','1999 W RIDGEWOOD DR',0,'PARMA','OH','44134','4822','CY','39035','1966-06-03','F','U',':RET:2106-3','N','021','DEN','1403670','99734OH005000301','2014-02-01','2014-01-15 20:39:39','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-01-17 03:35:42'),(17804,14221,'N','01','021','EC','A',NULL,NULL,'','0001130247','0000961882','','IL','1','Burt','Juliann','','','','34','356460199','1450 High St.',0,'Norwalk','OH','44857',NULL,'CY','39077','1953-12-30','F','',':RET:2106-3','N','021','HLT','2077676','92036OH002002701','2014-02-01','2014-01-13 18:11:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','611.15',NULL,0,'2014-01-14 01:33:55'),(5820,4622,'Y','18','021','EC','A','','','AC','0001144815','0001144815','TX00000869725','IL','1','Johnson','Rodney','J','','','34','455903879','1319 STATE HIGHWAY 7',0,'EDDY','TX','76524','2582','CY','48145','1955-02-12','M','M',':RET:2106-3','N','021','DEN','1530347','33348TX002000201','2014-01-01','2013-12-23 22:11:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:47:58'),(16424,13142,'Y','18','021','EC','A','','','AC','0000991553','0000991553','OH00001212652','IL','1','Hendee','Robert','','','','34','288482611','739 N. South Street',0,'Wilmington','OH','45177',NULL,'CY','39027','1950-10-27','M','M',':RET:2106-3','N','021','HLT','1513464','92036OH003000606','2014-02-01','2014-01-06 13:19:44','1260.00',NULL,NULL,'1334.30','74.30','R-OH005','OH0','661.77',NULL,0,'2014-01-07 04:04:35'),(9003,7144,'Y','18','024','14','A','','','TE','0000682128','0000682128','','IL','1','Marsh','Paula',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-03-27','F','',NULL,NULL,NULL,'','878508','','2013-12-18','2013-12-18 10:51:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:04:56'),(14507,11573,'Y','18','021','EC','A','','','AC','0001093026','0001093026','TX00000521996','IL','1','G RUIZ','CECILIA','','','','34','629381321','2906 AVENUE L',0,'SNYDER','TX','79549','4231','CY','48415','1969-03-14','F','M',':RET:2106-3','N','021','DEN','2170626','33348TX002000201','2014-02-01','2013-12-27 15:15:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:56'),(9690,7675,'Y','18','021','EC','A','','','AC','0000422809','0000422809','OH00000081802','IL','1','Harsh','rodney','','','','34','279701564','323 LANEY AVE',0,'LIMA','OH','45804','1381','CY','39003','1968-05-06','M','U',':RET:2106-3','T','021','HLT','1721839','92036OH005001501','2014-01-01','2013-12-21 12:45:27','54.00',NULL,NULL,'365.48','311.48','R-OH002','OH0','365.48',NULL,0,'2013-12-26 04:39:41'),(9532,7555,'Y','18','021','EC','A','','','AC','0000024105','0000024105','OH00001117810','IL','1','Iammarino','Sarah','','','','34','281743349','2295 Delaware Dr.',0,'Cleveland Heights','OH','44106',NULL,'CY','39035','1961-10-30','F','U',':RET:2106-3','N','021','DEN','2161381','99734OH005000301','2014-01-01','2013-12-21 09:20:34','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:35:48'),(25481,20217,'Y','18','021','EC','A','','','AC','0000824647','0000824647','OH00002932417','31','1','Brandenburg','David','W',NULL,NULL,NULL,NULL,'Po Box 71',0,'Lynchburg','OH','45142',NULL,'CY','39071','1957-03-07','M','U',':RET:2106-3','N','021','HLT','3090091','92036OH005000605','2014-04-01','2014-02-24 19:52:59','478.00',NULL,NULL,'523.16','45.16','R-OH005','OH0','523.16',NULL,0,'2014-02-25 21:31:43'),(28380,22455,'Y','18','021','EC','A','','','AC','0000447548','0000447548','OH00003425687','IL','1','Shilinski','David','','','','34','278545049','2570 Shoreline Dr',0,'Akron','OH','44314',NULL,'CY','39153','1952-11-14','M','U',':RET:2106-3','N','021','HLT','3332625','52664OH152000901','2014-04-01','2014-03-07 09:50:56','458.99',NULL,NULL,'458.99','0.00','R-OH012','OH0','458.99',NULL,0,'2014-03-07 21:30:38'),(1139,937,'Y','18','021','EC','A','','','AC','0000588228','0000588228','LA00000088390','IL','1','Dupont','Sheila','','','','34','439495717','1163 BEL OIL RD',0,'ELTON','LA','70532','5412','CY','22003','1981-01-04','F','U',':RET:2106-3','N','021','DEN','915769','18575LA002000201','2014-01-01','2013-12-03 09:10:28','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-25 18:18:16'),(20375,16276,'Y','18','024','14','A','','','TE','0001252213','0001252213','','IL','1','Clark','Anne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-17','F','',NULL,NULL,NULL,'','1543941','','2014-01-29','2014-01-29 16:48:56',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-29 21:00:08'),(2856,2308,'Y','18','021','EC','A','','','AC','0000485693','0000485693','LA00000382064','IL','1','eskridge','michael','','','','34','515581681','4265 WILDERNESS RUN DR',0,'ZACHARY','LA','70791','2863','CY','22033','1954-03-22','M','M',':RET:2054-5','T','021','DEN','392477','18575LA002000201','2014-01-01','2013-11-02 11:01:45','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:01:30'),(19028,15154,'Y','18','021','EC','A','','','AC','0001105565','0001105565','OH00002009679','IL','1','Guilfoyle','Julian','','','','34','279889189','310 WILLOWOOD DR',0,'SPRINGBORO','OH','45066','8176','CY','39165','1984-09-24','M','U',':RET:2106-3','N','021','HLT','2802336','92036OH004001201','2014-03-01','2014-01-17 10:35:24','0.00',NULL,NULL,'193.15','193.15','R-OH004','OH0','193.15',NULL,0,'2014-01-20 08:06:29'),(17607,14074,'Y','18','021','EC','A','','','AC','0000233177','0000233177','TX00001549542','31','1','Toombs','John','','','','34','450254388','Po box 174',0,'Lonestar','TX','75668',NULL,'CY','48343','1972-08-26','M','U',':RET:2106-3','N','021','DEN','1385140','33348TX002000201','2014-02-01','2014-01-12 21:49:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-14 01:32:19'),(3041,2444,'N','19','021','EC','A',NULL,NULL,'','0000664150','0000818544','','IL','1','Cook','Eloise','','','','34','642419734','533 EASTERN AVE',0,'ASHLAND','OH','44805','3324','CY','39005','2013-06-18','F','',':RET:2106-3','N','021','HLT','485239','52664OH152000901','2014-01-01','2013-12-05 22:52:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 20:18:39'),(13975,11136,'N','19','021','EC','A',NULL,NULL,'','0000880512','0000843330','','IL','1','HUX','VANESSA','','','','34','207664810','732 BECKLEY FARM WAY',0,'SPRINGBORO','OH','45066','9485','CY','39165','1986-10-16','F','',':RET:2054-5','N','021','HLT','2395361','92036OH004001201','2014-01-01','2013-12-22 23:54:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','180.89',NULL,0,'2013-12-26 13:15:28'),(4888,3876,'Y','18','021','EC','A','','','AC','0000137763','0000137763','TX00000790102','IL','1','Johnson','Ronald','','','','34','453113971','9514 WATER EDGE POINT LN',0,'HUMBLE','TX','77396','1906','CY','48201','1966-02-05','M','U',NULL,'N','021','DEN','40603','33348TX002000101','2014-01-01','2013-10-04 15:17:52','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:31:26'),(7766,6149,'N','01','021','EC','A',NULL,NULL,'','0000045757','0001240549','','IL','1','Lee','Soon','Yeol',NULL,NULL,NULL,NULL,'1914 N NANTUCKET DR',0,'LORAIN','OH','44053','3224','CY','39093','1970-09-20','F','',':RET:2040-4','N','021','DEN','2402355','99734OH005000401','2014-01-01','2013-12-20 18:41:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:49'),(7519,5950,'Y','18','021','EC','A','','','AC','0000337072','0000337072','LA00000753999','IL','1','Henderson','Joshua','','','','34','400332535','142 MILLAUDON ST',0,'NEW ORLEANS','LA','70118','3630','CY','22071','1974-06-22','M','R',':RET:2106-3','N','021','DEN','107002','18575LA002000201','2014-01-01','2013-12-15 17:13:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:32:19'),(3583,2874,'Y','18','021','EC','A','','','AC','0001175706','0001175706','OH00000351975','IL','1','Taylor','John','','','','34','289526262','1369 Irvin Rd.',0,'Blanchester','OH','45107',NULL,'CY','39027','1952-07-04','M','M',':RET:2106-3','N','021','HLT','1409126','92036OH004000601','2014-01-01','2013-12-22 11:20:19','796.00',NULL,NULL,'934.37','138.37','R-OH005','OH0','485.05',NULL,0,'2013-12-25 21:22:47'),(22864,18239,'Y','18','021','EC','A','','','AC','0000326379','0000326379','MS00001454655','IL','1','harris','robert','r','','','34','426217909','1831 T.J. Roberts Dr.',0,'jackson','MS','39213',NULL,'CY','28049','1974-09-18','M','U',':RET:2054-5','N','021','DEN','3289208','46300MS002000201','2014-03-01','2014-02-11 12:17:15','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-11 21:02:26'),(23235,18524,'Y','18','021','EC','A','','','AC','0000194096','0000194096','OH00001352432','IL','1','Wong','Mei','','','','34','369902218','314 BROOKFOREST DR',0,'CINCINNATI','OH','45238','5610','CY','39061','1963-08-12','F','U',NULL,'N','021','HLT','2893549','92036OH005001205','2014-03-01','2014-02-12 14:23:39','248.00',NULL,NULL,'383.39','135.39','R-OH004','OH0','383.39',NULL,0,'2014-02-12 21:32:28'),(26287,20851,'Y','18','021','EC','A','','','AC','0001294895','0001294895','LA00003282415','31','1','LABEAUD','AMELIA','','','','34','435733993','6911 VIRGILIAN ST',0,'NEW ORLEANS','LA','70126','2630','CY','22071','1980-10-27','F','U',NULL,'N','021','DEN','3017374','18575LA002000101','2014-03-01','2014-02-27 11:51:40','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-28 06:31:22'),(5240,4155,'N','01','021','EC','A',NULL,NULL,'','0000124195','0000017615','','IL','1','Buehl','Kristine','','','','34','276769016','204 SILVER VALLEY BLVD',0,'MUNROE FALLS','OH','44262','1019','CY','39153','1964-03-24','F','',NULL,'N','021','HLT','1493366','52664OH151001305','2014-01-01','2013-12-18 20:12:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','380.45',NULL,0,'2013-12-25 23:04:53'),(1539,1282,'Y','18','021','EC','A','','','AC','0000813091','0000813091','OH00000547011','IL','1','Legan','Thomas','R',NULL,NULL,NULL,NULL,'6512 LOCKHAVEN DR',0,'BROOK PARK','OH','44142','3730','CY','39035','1951-10-19','M','U',NULL,'N','021','DEN','1792400','99734OH005000401','2014-01-01','2013-12-24 17:11:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:14'),(16572,13256,'Y','18','021','EC','A','','','AC','0000481091','0000481091','OH00000025918','IL','1','ALEXANDER','GREGORY','EUGIN','','','34','276666688','9998 BROWNS RUN RD',0,'GERMANTOWN','OH','45327','9737','CY','39113','1961-01-19','M','M',':RET:2106-3','N','021','HLT','1860504','92036OH003000505','2014-02-01','2014-01-04 22:24:23','648.00',NULL,NULL,'990.96','342.96','R-OH003','OH0','506.41',NULL,1,'2014-01-07 10:23:23'),(15047,12028,'Y','18','021','EC','A','','','AC','0001457740','0001457740','LA00001180449','IL','1','GALLOWAY','LARRY','D','','','34','435809540','9426 CRANDON DR',0,'BATON ROUGE','LA','70810','8803','CY','22033','1952-11-17','M','M',NULL,'N','021','DEN','2035769','18575LA002000201','2014-02-01','2013-12-30 13:45:37','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:09'),(13493,10755,'N','19','021','EC','A',NULL,NULL,'','0000645986','0000637108','','S1','1','Giovannazzo','Emily','J','','','34','010904987','26311 LAKE RD',0,'BAY VILLAGE','OH','44140','2570','CY','39035','2006-01-06','M','',NULL,'N','021','DEN','2373290','99734OH005000301','2014-01-01','2013-12-23 18:14:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:26'),(8170,6464,'Y','18','021','EC','A','','','AC','0000340252','0000340252','OH00001209978','IL','1','Malloy','Nicholas','','','','34','299902808','7569 Chateau Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1987-01-05','M','M',':RET:2106-3','N','021','HLT','693471','92036OH006001201','2014-01-01','2013-11-22 13:03:28','0.00',NULL,NULL,'174.33','174.33','R-OH004','OH0','174.33',NULL,0,'2013-12-26 03:16:36'),(4889,3877,'Y','18','024','14','A','','','TE','0000137763','0000137763','','IL','1','Johnson','Ronald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-02-05','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 22:31:27'),(4305,3423,'Y','18','021','EC','A','','','AC','0000383342','0000383342','OH00000480198','IL','1','FENNMORE','CHARLENE','D','','','34','312602119','6673 FERNSHIRE CT',0,'MASON','OH','45040','1192','CY','39165','1952-02-28','F','R',':RET:2106-3','N','021','HLT','1475981','92036OH004001201','2014-01-01','2013-12-16 23:28:05','0.00',NULL,NULL,'485.05','485.05','R-OH004','OH0','485.05',NULL,0,'2013-12-25 21:52:26'),(21734,17356,'Y','18','021','EC','A','','','AC','0000311547','0000311547','TX00001699439','IL','1','HARRISON','VICTOR','','','','34','449088498','16640 HIGHWAY 254',0,'MINERAL WELLS','TX','76067','3272','CY','48363','1956-09-22','M','M',':RET:2106-3','N','021','DEN','2841319','33348TX002000201','2014-03-01','2014-02-06 15:49:49','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-06 21:00:11'),(22476,17946,'N','19','021','EC','A',NULL,NULL,'','0000505768','0000999883','','IL','1','Lindhorst','Summer','','','','34','302155385','1213 DARTMOOR AVE',0,'PARMA','OH','44134','3217','CY','39035','2010-09-28','F','',':RET:2106-3','N','021','DEN','2777564','99734OH005000301','2014-03-01','2014-02-09 18:59:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:01'),(22558,18015,'Y','18','021','EC','A','','','AC','0000473686','0000473686','OH00001488754','IL','1','Boggs','Anna','E','','','34','294989934','450 KING ARTHUR DR',0,'ZANESVILLE','OH','43701','8639','CY','39119','1996-01-26','F','U',':RET:2106-3','N','021','DEN','3376508','99734OH005000401','2014-03-01','2014-02-10 11:45:11','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','15.78',NULL,0,'2014-02-10 21:31:49'),(23673,18850,'Y','18','021','EC','A','','','AC','0001672936','0001672936','LA00002112011','IL','1','Ennis','Ronald','','','','34','463674823','2201 nolan trace',0,'Leesville','LA','71446',NULL,'CY','22115','1977-02-14','M','M',':RET:2106-3','N','021','DEN','2904908','18575LA002000201','2014-03-01','2014-02-13 19:25:30','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-14 21:30:26'),(26044,20654,'Y','18','021','EC','A','','','AC','0000289580','0000289580','OH00002338225','IL','1','givens','jack','','','','34','278543243','25 frederick ave',0,'akron','OH','44310',NULL,'CY','39153','1952-04-07','M','U',':RET:2106-3','N','021','HLT','2627956','52664OH151001304','2014-03-01','2014-02-26 15:11:11','429.00',NULL,NULL,'626.65','197.65','R-OH012','OH0','626.65',NULL,0,'2014-02-26 21:02:28'),(27029,21407,'Y','18','024','14','A','','','TE','0000680042','0000680042','','IL','1','Nguyen','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-03-28','F','',NULL,NULL,NULL,'','3234874','','2014-03-03','2014-03-03 13:15:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-03 21:00:15'),(7445,5893,'Y','18','021','EC','A','','','AC','0001198096','0001198096','OH00000765013','IL','1','Lagace','Danneile','','','','34','115421174','9726 KINGSTON TRL',0,'OLMSTED TWP','OH','44138','4297','CY','39035','1955-12-28','F','M',':RET:2106-3','N','021','DEN','1213102','99734OH005000301','2014-01-01','2013-12-15 11:10:00','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:30:32'),(7857,6221,'N','19','021','EC','A',NULL,NULL,'','0000951788','0001145967','','S1','1','Scott','Evan','L','','','34','273135057','625 W SOUTH COLLEGE ST',0,'YELLOW SPRINGS','OH','45387','1426','CY','39057','2006-07-17','M','',':RET:2106-3','N','021','DEN','1673900','99734OH005000301','2014-01-01','2013-12-20 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:58'),(21644,17284,'Y','18','021','EC','A','','','AC','0001245535','0001245535','TX00001965526','31','1','zamora','teresa','','','','34','450924301','p.o. box 583',0,'hale center','TX','79041',NULL,'CY','48189','1953-03-24','F','M',':RET:2106-3','N','021','DEN','3132882','33348TX002000201','2014-03-01','2014-02-05 18:21:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:47'),(23182,18483,'Y','18','021','EC','A','','','AC','0000776522','0000776522','MS00002155717','IL','1','gilmore','d-andra','','','','34','587638433','5127 PENNSWOOD PL',0,'JACKSON','MS','39206','3121','CY','28049','1983-12-04','F','U',NULL,'N','021','DEN','3739240','46300MS002000101','2014-03-01','2014-02-12 13:18:28','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-12 21:31:58'),(24855,19705,'Y','18','021','EC','A','','','AC','0000927356','0000927356','OH00001632232','IL','1','MATA','JORGE','A','','','34','460976206','4217 SOUTH AVE',0,'CINCINNATI','OH','45236','3705','CY','39061','1963-04-23','M','U',NULL,'N','021','HLT','2641635','92036OH004001201','2014-04-01','2014-02-19 16:35:56','192.00',NULL,NULL,'308.28','116.28','R-OH004','OH0','308.28',NULL,0,'2014-02-20 04:56:01'),(173,143,'Y','18','021','EC','A','','','AC','0000880484','0000880484','OH00000006024','IL','1','GOTTWALT','TERANCE','','','','34','288544058','1556 UNION ST',0,'BARBERTON','OH','44203','7629','CY','39153','1951-09-19','M','U',':RET:2106-3','T','021','HLT','1228537','52664OH151001305','2014-01-01','2013-12-05 09:00:56','466.00',NULL,NULL,'736.81','270.81','R-OH012','OH0','736.81',NULL,0,'2013-12-25 17:19:28'),(19863,15844,'Y','18','021','EC','A','','','AC','0000170188','0000170188','OH00001913812','IL','1','MCKINNEY','THOMAS','','','','34','273644758','1680 KARON DR',0,'COLUMBUS','OH','43219','1251','CY','39049','1970-07-17','M','U',NULL,'N','021','DEN','2911164','99734OH005000401','2014-03-01','2014-01-23 18:42:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-24 21:00:37'),(1002,821,'N','01','021','EC','A',NULL,NULL,'','0000319049','0000317925','','IL','1','Spann','Christopher','J','','','34','425331041','103 JOE MYERS RD',0,'BRANDON','MS','39047','9558','CY','28121','1972-02-27','M','',':RET:2054-5','N','021','DEN','196181','46300MS002000101','2014-01-01','2013-11-10 20:25:24',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-25 18:10:59'),(17244,13799,'Y','18','021','EC','A','','','AC','0000872062','0000872062','OH00001364660','IL','1','KEAN','BOBBIE','G','','','34','270522832','72 W. MAIN ST',0,'NORWALK','OH','44857',NULL,'CY','39077','1953-09-05','F','M',':RET:2106-3','T','021','HLT','1510141','92036OH005002705','2014-02-01','2014-01-08 15:43:49','1002.00',NULL,NULL,'1193.57','191.57','R-OH006','OH0','608.59',NULL,0,'2014-01-13 02:22:47'),(14924,11925,'Y','18','024','14','A','','','TE','0001677505','0001677505','','IL','1','Duplantis','Rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-12-13','F','',NULL,NULL,NULL,'','1435663','','2013-12-29','2013-12-29 08:42:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-30 00:01:47'),(15599,12482,'N','19','021','EC','A',NULL,NULL,'','0000283270','0001158933','','IL','1','Rengel','Kailee','Elizabeth','','','34','288048270','3603 TURFSIDE CIR',0,'HURON','OH','44839','2193','CY','39043','1999-10-29','F','',':RET:2106-3','N','021','DEN','2124004','99734OH005000301','2014-02-01','2013-12-31 14:43:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:37'),(16435,13151,'Y','18','021','EC','A','','','AC','0000137584','0000137584','OH00001475089','IL','1','Kost','Timothy','','','','34','295680922','2462 STROUP RD',0,'ATWATER','OH','44201','9100','CY','39133','1958-02-24','M','R',':RET:2106-3','N','021','HLT','2111229','52664OH152000901','2014-02-01','2014-01-06 14:03:05','0.00',NULL,NULL,'928.63','928.63','R-OH012','OH0','364.25',NULL,0,'2014-01-07 04:04:58'),(21759,17375,'Y','18','021','EC','A','','','AC','0000810761','0000810761','TX00001907943','IL','1','FIERROS-LOPEZ','ADRIAN','','','','34','565279314','407 RICHEY ST',0,'PASADENA','TX','77506','1900','CY','48201','1951-03-05','M','U',NULL,'N','021','DEN','2971821','33348TX002000201','2014-03-01','2014-02-06 12:18:25','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-06 21:00:25'),(22005,17569,'Y','18','021','EC','A','','','AC','0000273834','0000273834','OH00002106865','IL','1','Harbeson','Craig','','','','34','285887942','3894 WINTER HILL DR',0,'HAMILTON','OH','45011','6421','CY','39017','1982-10-14','M','M',NULL,'N','021','DEN','3480609','99734OH005000301','2014-03-01','2014-02-06 23:05:50','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-07 19:00:49'),(22517,17976,'Y','18','024','14','A','','','TE','0000622751','0000622751','','IL','1','Longoria','Crystal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-04-20','F','',NULL,NULL,NULL,'','2821450','','2014-02-10','2014-02-10 16:06:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-10 21:31:22'),(23772,18915,'N','01','021','EC','A',NULL,NULL,'','0001070521','0000357240','','IL','1','Record','Richard','L','','','34','295521550','6214 Robison Road',0,'Cincinnati','OH','45213',NULL,'CY','39061','1952-01-10','M','',':RET:2106-3','N','021','DEN','3685676','99734OH005000301','2014-03-01','2014-02-14 17:10:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:14'),(24070,19142,'Y','18','021','EC','A','','','AC','0001093183','0001093183','OH00001859297','IL','1','Rehs','Gregory','','','','34','280644058','846 BEACHLER RD',0,'TALLMADGE','OH','44278','3112','CY','39153','1958-09-10','M','U',NULL,'N','021','HLT','2718269','52664OH151001301','2014-03-01','2014-02-15 08:48:13','242.00',NULL,NULL,'497.31','255.31','R-OH012','OH0','497.31',NULL,0,'2014-02-15 22:01:16'),(27331,21641,'Y','18','021','EC','A','','','AC','0000888234','0000888234','OH00003551289','IL','1','fishman','michael','','','','34','287889425','98 E TOMPKINS ST',0,'COLUMBUS','OH','43202','2931','CY','39049','1983-03-27','M','U',':RET:2106-3','N','021','DEN','3306630','99734OH005000401','2014-04-01','2014-03-03 19:11:56','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-04 21:00:52'),(28818,22806,'N','01','021','EC','A',NULL,NULL,'','0001048064','0000983911','','IL','1','ARKENBURG','RICHARD','','','','34','283624414','393 TAMMERY DR',0,'TALLMADGE','OH','44278','3034','CY','39153','1960-05-21','M','',':RET:2106-3','N','021','HLT','3794426','52664OH151001305','2014-04-01','2014-03-09 16:42:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','454.94',NULL,0,'2014-03-09 21:00:57'),(432,355,'Y','18','021','EC','A','','','AC','0000296758','0000296758','OH00001011227','IL','1','Monroe','Barbara','','','','34','295505878','2673 Warrensville Center Road',0,'Shaker Heights','OH','44122',NULL,'CY','39035','1953-12-15','F','U',':RET:2106-3','N','021','DEN','563759','99734OH005000401','2014-01-01','2013-12-04 16:37:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:57'),(20721,16557,'N','01','021','EC','A',NULL,NULL,'','0000547919','0001184918','','IL','1','Baker','Travis','R','','','34','458259044','2374 PARKER RIDGE RD',0,'PEEBLES','OH','45660','9104','CY','39001','1969-08-18','M','',':RET:2106-3','T','021','HLT','2821306','92036OH006000601','2014-03-01','2014-01-30 14:17:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','273.51',NULL,0,'2014-01-30 21:01:14'),(20480,16361,'Y','18','021','EC','A','','','AC','0000461959','0000461959','OH00001764161','IL','1','Klippel','David','','','','34','272564470','17 GRANGER RD',0,'MEDINA','OH','44256','8410','CY','39103','1955-07-06','M','M',':RET:2106-3','N','021','HLT','3476682','52664OH151001304','2014-03-01','2014-01-28 20:02:47','699.00',NULL,NULL,'1065.53','366.53','R-OH012','OH0','568.22',NULL,0,'2014-01-29 21:01:00'),(20167,16093,'Y','18','021','EC','A','','','AC','0000105401','0000105401','OH00001538240','IL','1','EHRHARDT','AMANDA','','','','34','284920559','1835 STRATHMOOR AVE',0,'TOLEDO','OH','43614','3922','CY','39095','1990-03-27','F','M',NULL,'N','021','HLT','2352409','92036OH004002601','2014-03-01','2014-01-27 11:00:58','0.00',NULL,NULL,'156.79','156.79','R-OH001','OH0','156.79',NULL,0,'2014-01-27 21:01:12'),(19827,15810,'Y','18','021','EC','A','','','AC','0000453182','0000453182','TX00001474268','IL','1','Bolton','Melanie','','','','34','639039639','3253 Hillcrest Drive',0,'San Antonio','TX','78201',NULL,'CY','48029','1982-08-09','F','U',NULL,'N','021','DEN','3250417','33348TX002000201','2014-03-01','2014-01-24 13:34:32','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-24 21:00:17'),(5513,4374,'Y','18','021','EC','A','','','AC','0000712484','0000712484','OH00000250730','IL','1','BAISDEN','ROBIN','','','','34','297665151','972 CARRYBACK DR SW',0,'PATASKALA','OH','43062','9543','CY','39089','1960-12-21','M','M',':RET:2106-3','N','021','DEN','494544','99734OH005000301','2014-01-01','2013-11-27 12:28:14','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:09'),(2249,1846,'Y','18','021','EC','A','','','AC','0000779085','0000779085','OH00000623168','IL','1','Smith','Tiffany','','','','34','274848951','701 MULBERRY ST',0,'CINCINNATI','OH','45215','2822','CY','39061','1978-08-19','F','U',':RET:2054-5','N','021','DEN','362958','99734OH005000301','2014-01-01','2013-12-08 18:09:59','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:30:03'),(5290,4192,'Y','18','021','EC','A','','','AC','0000728699','0000728699','OH00000183695','IL','1','Paulin','Margaret','','','','34','272561940','2460 CONGO ST',0,'AKRON','OH','44305','3913','CY','39153','1967-09-09','F','U',NULL,'N','021','HLT','2505343','52664OH151001305','2014-01-01','2013-12-19 16:47:38','238.00',NULL,NULL,'334.51','96.51','R-OH012','OH0','334.51',NULL,0,'2013-12-25 23:06:01'),(17928,14322,'Y','18','021','EC','A','','','AC','0001202805','0001202805','TX00001700248','IL','1','Medina','Olga','','','','34','461865446','3012 SILVER LAKE PL',0,'EL PASO','TX','79936','2412','CY','48141','1949-07-02','F','U',':RET:2106-3','N','021','DEN','2485031','33348TX002000201','2014-02-01','2014-01-14 12:22:02','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-15 02:06:34'),(17866,14272,'Y','18','021','EC','A','','','AC','0001227047','0001227047','OH00001729203','IL','1','Juric','Lynne','','','','34','286527978','12520 EDGEWATER DR',0,'LAKEWOOD','OH','44107','1653','CY','39035','1951-12-02','F','U',':RET:2106-3','N','021','DEN','2464141','99734OH005000401','2014-02-01','2014-01-14 12:30:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:12'),(16920,13540,'Y','18','021','EC','A','','','AC','0000380075','0000380075','OH00001520170','IL','1','Kramer','Nicholas','','','','34','294865729','11813 Stone Mill Rd',0,'Cincinnati','OH','45251',NULL,'CY','39061','1984-09-17','M','M',':RET:2106-3','N','021','DEN','2397380','99734OH005000401','2014-02-01','2014-01-09 15:54:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:19:43'),(16800,13438,'Y','18','021','EC','A','','','AC','0001247905','0001247905','TX00002286353','IL','1','Covin','LaCresha','','','','34','452958391','10010 Forest Ln',0,'Dallas','TX','75243',NULL,'CY','48113','1979-07-30','F','U',':RET:2106-3','N','021','DEN','1595300','33348TX002000201','2014-02-01','2014-01-11 11:21:40','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:18:10'),(2933,2361,'N','01','021','EC','A',NULL,NULL,'','0000298196','0001033627','','IL','1','Ash','Darrell','Wayne','','','34','284564766','6591 Brigham Square',0,'Dayton','OH','45459',NULL,'CY','39113','1953-08-18','M','',':RET:2106-3','N','021','DEN','299331','99734OH005000401','2014-01-01','2013-12-05 20:52:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:16:03'),(16200,12970,'Y','18','021','EC','A','','','AC','0000985990','0000985990','TX00001799048','IL','1','Hymel','Ashley','','','','34','589463892','8700 Brodie Lane',0,'Austin','TX','78745',NULL,'CY','48453','1986-12-16','F','U',':RET:2106-3','N','021','DEN','2239732','33348TX002000201','2014-02-01','2014-01-04 14:59:28','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-05 00:01:06'),(15281,12217,'Y','18','021','EC','A','','','AC','0000510662','0000510662','OH00001511413','IL','1','smith','kathy','','','','34','273648430','233 E 6TH AVE',0,'LANCASTER','OH','43130','2618','CY','39045','1957-11-07','F','U',':RET:2106-3','T','021','DEN','1613221','99734OH005000401','2014-02-01','2014-01-01 16:57:50','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:22:07'),(13449,10724,'Y','18','021','EC','A','','','AC','0000280834','0000280834','OH00001021402','IL','1','provenzale','thomas','','','','34','279621516','1580mapledale rd',0,'wickcliff','OH','44092',NULL,'CY','39085','1956-06-17','M','U',':RET:2106-3','N','021','DEN','1803258','99734OH005000301','2014-01-01','2013-12-23 14:09:33','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 13:01:26'),(3075,2470,'Y','18','021','EC','A','','','AC','0000900721','0000900721','LA00000824911','31','1','HARRIS','MYA','','','','34','365782520','PO BOX 139A',0,'ANGIE','LA','70426',NULL,'CY','22117','1966-04-01','F','U',NULL,'N','021','DEN','998987','18575LA002000101','2014-01-01','2013-12-06 12:32:06','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 20:19:33'),(7329,5807,'N','01','021','EC','A',NULL,NULL,'','0000347885','0000129247','','IL','1','Cross','William','','','','34','274541583','688 REDWOOD CT',0,'CINCINNATI','OH','45244','1118','CY','39025','1953-05-29','M','',NULL,'N','021','HLT','842657','92036OH003000601','2014-01-01','2013-12-14 12:43:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','608.42',NULL,0,'2013-12-26 02:03:47'),(23947,19041,'Y','18','021','EC','A','','','AC','0000743104','0000743104','OH00001470997','IL','1','Elliott','Lori','','','','34','295687898','2618 WESTMAR CT',0,'TOLEDO','OH','43615','2052','CY','39095','1962-03-12','F','U',':RET:2106-3','N','021','HLT','3636343','92036OH005002605','2014-03-01','2014-02-14 20:47:06','282.00',NULL,NULL,'363.68','81.68','R-OH001','OH0','363.68','CIC',0,'2014-02-15 21:00:13'),(27067,21431,'Y','18','021','EC','A','','','AC','0002364119','0002364119','LA00003443324','IL','1','Gilbert','Steven','D','','','34','434357480','1945 Walnut Street',0,'Shreveport','LA','71103',NULL,'CY','22017','1978-05-05','M','U',':RET:2054-5','N','021','DEN','3630214','18575LA002000201','2014-04-01','2014-03-03 13:53:51','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-03 21:30:03'),(29189,23102,'N','19','021','EC','A',NULL,NULL,'','0000815378','0000823564','','S1','1','Sebe','Jennifer','','','','34','299067202','5464 TAYLOR RD',0,'NORTON','OH','44203','7842','CY','39169','2002-06-03','F','',':RET:2106-3','N','021','HLT','3135230','52664OH151001301','2014-04-01','2014-03-10 16:59:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-03-10 21:30:04'),(4351,3454,'Y','18','021','EC','A','','','AC','0001003284','0001003284','OH00001252925','IL','1','Mohon','Timothy','','','','34','412232677','443 NORTH ST',0,'GREENFIELD','OH','45123','1337','CY','39071','1962-12-01','M','M',NULL,'N','021','HLT','2051646','92036OH002000601','2014-01-01','2013-12-17 13:03:08','0.00',NULL,NULL,'924.72','924.72','R-OH005','OH0','462.36',NULL,0,'2013-12-25 21:53:28'),(26940,21350,'N','19','021','EC','A',NULL,NULL,'','0000618418','0000914487','','IL','1','Chmura','Isaac',NULL,NULL,NULL,NULL,NULL,'1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','2009-10-07','M','',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:23'),(241,202,'Y','18','021','EC','A','','','AC','0000837660','0000837660','OH00000498171','IL','1','Helinski','Nancy','Ann','','','34','268547623','6037 VAN WORMER DR',0,'TOLEDO','OH','43612','4042','CY','39095','1953-03-22','F','U',NULL,'N','021','HLT','355509','92036OH004002601','2014-01-01','2013-12-05 17:38:42','422.42',NULL,NULL,'425.53','3.11','R-OH001','OH0','425.53',NULL,0,'2013-12-25 17:21:18'),(21567,17228,'Y','18','021','EC','A','','','AC','0000918290','0000918290','OH00002560775','IL','1','Jaye','Leisa','','','','34','296864807','1293 AUBURN AVE',0,'BARBERTON','OH','44203','7439','CY','39153','1973-01-08','F','U',':RET:2106-3','N','021','HLT','2621180','52664OH151001305','2014-03-01','2014-02-04 20:09:48','182.00',NULL,NULL,'290.36','108.36','R-OH012','OH0','290.36',NULL,0,'2014-02-05 21:30:20'),(760,627,'N','01','021','EC','A',NULL,NULL,'','0000788442','0000446901','','IL','1','Bell Titsworth','Katherine','Elaine','','','34','628168561','510 BEDFORD DR',0,'RICHARDSON','TX','75080','3317','CY','48113','1985-08-06','F','',':RET:2106-3','N','021','DEN','2238895','33348TX002000201','2014-01-01','2013-12-16 11:11:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:04:32'),(4947,3926,'Y','18','021','EC','A','','','AC','0000491851','0000491851','OH00000499438','IL','1','Rudolph','Alexander','','','','34','302884410','18116 NOTTINGHAM RD',0,'CLEVELAND','OH','44119','2948','CY','39035','1988-10-13','M','R',':RET:2054-5','N','021','DEN','1107447','99734OH005000401','2014-01-01','2013-12-07 15:03:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:45:50'),(4269,3400,'N','01','021','EC','A',NULL,NULL,'','0001152170','0000879460','','IL','1','Griffith','Jeffery','','','','34','277562485','8041 FORT AMANDA RD',0,'CRIDERSVILLE','OH','45806','9337','CY','39003','1961-11-28','M','',':RET:2106-3','N','021','HLT','1863949','92036OH003001501','2014-01-01','2013-12-17 08:08:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','448.63',NULL,0,'2013-12-25 21:51:43'),(6827,5410,'N','01','021','EC','A',NULL,NULL,'','0001169407','0001171850','','IL','1','Smas','James','','','','34','467497301','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','1978-07-03','M','',NULL,'N','021','DEN','1156560','99734OH005000301','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:30:40'),(8846,7012,'Y','18','021','EC','A','','','AC','0000747893','0000747893','TX00001096268','31','1','Fridy','Roger','','','','34','348389767','PO Box 671',0,'Hawkins','TX','75765',NULL,'CY','48499','1949-07-23','M','M',NULL,'N','021','DEN','2486700','33348TX002000201','2014-01-01','2013-12-18 07:18:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:54'),(23022,18357,'Y','18','021','EC','A','','','AC','0000814510','0000814510','TX00002273076','IL','1','Martinez','Cresencio','','','','34','585653537','6450 Midway',0,'Canutillo','TX','79835',NULL,'CY','48141','1962-02-07','M','M',':RET:2106-3','N','021','DEN','3084385','33348TX002000201','2014-03-01','2014-02-11 22:05:16','0.00',NULL,NULL,'67.44','67.44','R-TX009','TX0','14.61',NULL,0,'2014-02-12 21:30:31'),(23747,18906,'N','19','021','EC','A',NULL,NULL,'','0000137619','0001102137','','IL','1','midamba','Sophia','','','','34','275065083','3909 PINE CREST DRIVE',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','2000-11-16','F','',':RET:2054-5','N','021','DEN','2972052','99734OH005000301','2014-03-01','2014-02-14 05:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:06'),(24242,19250,'N','19','021','EC','A',NULL,NULL,'','0000177678','0000011206','','S1','1','Sexton','Barbara','','','Jr','34','279135279','935 Hathaway Dr.',0,'Trenton','OH','45067',NULL,'CY','39017','2007-04-25','M','',NULL,'N','021','HLT','2768781','92036OH004001201','2014-03-01','2014-02-15 22:14:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-16 19:00:40'),(25371,20129,'N','01','021','EC','A',NULL,NULL,'','0000224770','0001043437','','IL','1','Wallace','Kathleen','','','','34','200580664','7760 CARTER RD',0,'SAGAMORE HILLS','OH','44067','1617','CY','39153','1962-05-16','F','',':RET:2106-3','N','021','DEN','3213207','99734OH005000301','2014-04-01','2014-02-25 14:34:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:41'),(26419,20952,'N','01','021','EC','A',NULL,NULL,'','0000858522','0000648524','','IL','1','FLORES','RAYMUNDO','J','','','34','449089986','7409 LAKEHURST RD',0,'el paso','TX','79912',NULL,'CY','48141','1956-09-11','M','',NULL,'N','021','DEN','3038513','33348TX002000201','2014-04-01','2014-02-26 20:06:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-02-28 07:30:06'),(780,643,'N','01','021','EC','A',NULL,NULL,'','0000586952','0000250606','','IL','1','BUENO','EDUARDO','','','','34','457378600','716 SANTA BARBARA DR',0,'EL PASO','TX','79915','2118','CY','48141','1966-11-28','M','',':RET:2106-3','T','021','DEN','1835942','33348TX002000201','2014-01-01','2013-12-16 14:10:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 18:05:02'),(20882,16689,'N','19','021','EC','A',NULL,NULL,'','0000468146','0000983870','','IL','1','Shaw','Lillian','Olivia','','','34','280138947','525 S WEST ST',0,'HILLSBORO','OH','45133','1343','CY','39071','2007-05-29','F','',':RET:2106-3','N','021','HLT','3234142','92036OH006000601','2014-03-01','2014-01-30 21:04:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-01-31 21:01:09'),(7411,5865,'Y','18','021','EC','A','','','AC','0000970681','0000970681','TX00001035768','IL','1','Tarver','Jeremy','','','','34','458334449','7631 PRESIDIO SANDS',0,'BOERNE','TX','78015','6541','CY','48029','1973-07-19','M','U',':RET:2106-3','N','021','DEN','1004649','33348TX002000201','2014-01-01','2013-10-28 17:27:35','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-26 02:16:44'),(18378,14668,'N','01','021','EC','A',NULL,NULL,'','0000338890','0000106732','','IL','1','Weisel','Tamara','Jean','','','34','276684698','2774 LAKEVIEW DR',0,'UNIONTOWN','OH','44685','6009','CY','39153','1975-05-28','F','',':RET:2106-3','N','021','DEN','2708876','99734OH005000301','2014-02-01','2014-01-15 14:58:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:33'),(7592,6007,'Y','18','021','EC','A','','','AC','0000221249','0000221249','OH00000153597','IL','1','Riley','Charles','','','','34','275448513','5062 WETMORE RD',0,'CONNEAUT','OH','44030','9644','CY','39007','1955-04-04','M','M',NULL,'N','021','DEN','200360','99734OH005000401','2014-01-01','2013-11-17 09:21:39','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:45:10'),(17538,14021,'Y','18','021','EC','A','','','AC','0000408499','0000408499','OH00001812382','IL','1','KNABE','SUSAN','','','','34','284522839','381 MORGAN ST',0,'BARBERTON','OH','44203',NULL,'CY','39153','1949-06-13','F','M',':RET:2106-3','N','021','HLT','2687864','52664OH151001301','2014-02-01','2014-01-12 13:08:30','189.00',NULL,NULL,'669.00','480.00','R-OH012','OH0','669.00',NULL,0,'2014-01-13 03:01:46'),(17424,13943,'N','19','021','EC','A',NULL,NULL,'','0001145991','0000433909','','IL','1','pitz','megan','n','','','34','296942692','535 northeast ave',0,'tallmadge','OH','44278',NULL,'CY','39153','1992-04-22','F','',':RET:2106-3','N','021','HLT','1782251','52664OH151001306','2014-02-01','2014-01-10 09:31:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-01-13 03:00:28'),(7798,6176,'Y','18','021','EC','A','','','AC','0000247980','0000247980','TX00000164399','IL','1','Gonzalez','Jose','','','','34','451210510','812 SE AVENUE C',0,'HAMLIN','TX','79520','5629','CY','48253','1968-03-08','M','U',':RET:2106-3','N','021','DEN','2319169','33348TX002000201','2014-01-01','2013-12-20 16:11:10','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2013-12-26 03:03:35'),(16914,13535,'Y','18','024','14','A','','','TE','0001015590','0001015590','','IL','1','Jones','Wendy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-03-16','F','',NULL,NULL,NULL,'','1557045','','2014-01-09','2014-01-09 13:06:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:19:40'),(24897,19740,'Y','18','024','14','A','','','TE','0000737896','0000737896','','IL','1','MARTIN','DANETTE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-10-22','F','',NULL,NULL,NULL,'','3625394','','2013-12-31','2014-02-19 17:18:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-20 05:40:40'),(27225,21558,'Y','18','021','EC','A','','','AC','0001412733','0001412733','LA00003643714','IL','1','Oliver','Charles','','','','34','433118172','4044 MARIBEL DR',0,'BATON ROUGE','LA','70812','4413','CY','22033','1960-11-24','M','U',':RET:2054-5','N','021','DEN','3687266','18575LA002000101','2014-04-01','2014-03-03 11:56:01','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-03 21:31:37'),(2169,1784,'Y','18','021','EC','A','','','AC','0000489223','0000489223','OH00000630174','IL','1','Crego','Nancy','','','','34','283562806','3403 CHELTENHAM RD',0,'TOLEDO','OH','43606','1823','CY','39095','1953-07-28','F','U',':RET:2106-3','N','021','HLT','640549','92036OH006002601','2014-01-01','2013-12-09 19:54:18','389.00',NULL,NULL,'419.70','30.70','R-OH001','OH0','419.70',NULL,0,'2013-12-25 19:19:06'),(2758,2231,'Y','18','021','EC','A','','','AC','0000526743','0000526743','OH00000709276','IL','1','royster','tony','','','','34','289627789','232 COUNTY ROAD 681',0,'SULLIVAN','OH','44880','9717','CY','39005','1956-11-17','M','M',':RET:2106-3','N','021','HLT','914520','52664OH151001305','2014-01-01','2013-12-02 17:12:07','902.00',NULL,NULL,'1019.59','117.59','R-OH012','OH0','543.47',NULL,0,'2013-12-25 19:49:15'),(13729,10956,'Y','18','021','EC','A','','','AC','0001249587','0001249587','OH00001157824','IL','1','Smith','Shannon','','','','34','297766454','475 WARWICK ST',0,'AKRON','OH','44305','3164','CY','39153','1979-02-06','F','U',':RET:2106-3','N','021','HLT','1683758','52664OH151001305','2014-01-01','2013-12-23 18:22:04','88.00',NULL,NULL,'270.73','182.73','R-OH012','OH0','270.73',NULL,0,'2013-12-26 13:09:23'),(16123,12915,'Y','18','021','EC','A','','','AC','0001181906','0001181906','LA00000532083','IL','1','Brooks','Michelle','','','','34','439512324','11145 CYPRESS GLEN AVE',0,'BATON ROUGE','LA','70807','2332','CY','22033','1981-06-21','F','U',':RET:2054-5','N','021','DEN','2168482','18575LA002000101','2014-02-01','2014-01-03 15:27:16','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-04 02:05:29'),(15263,12201,'Y','18','021','EC','A','','','AC','0001070485','0001070485','OH00001604361','31','1','Malsbury','Christopher','','','','34','410435608','null null',0,'WHITEHOUSE','OH','43571','0742','CY','39095','1982-09-08','M','U',':RET:2106-3','N','021','HLT','1443487','92036OH005002605','2014-02-01','2013-12-30 14:34:46','153.00',NULL,NULL,'226.00','73.00','R-OH001','OH0','226.00',NULL,0,'2014-01-01 12:09:20'),(15136,12096,'Y','18','021','EC','A','','','AC','0000569323','0000569323','OH00000118104','IL','1','Pettyjohn','Michael','David','','','34','281888375','506 WELLAND DR',0,'CINCINNATI','OH','45238','5322','CY','39061','1980-07-13','M','M',':RET:2106-3','N','021','DEN','2463766','99734OH005000401','2014-02-01','2013-12-29 23:24:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:36'),(14365,11456,'N','01','021','EC','A',NULL,NULL,'','0000749531','0000204568','','IL','1','Edwards','Michael','M','','','34','292622409','2213 SANFORD ST',0,'SANDUSKY','OH','44870','1973','CY','39043','1957-10-08','M','',':RET:2106-3','N','021','DEN','1660751','99734OH005000401','2014-02-01','2013-12-26 21:37:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:30:22'),(22356,17855,'N','19','021','EC','A',NULL,NULL,'','0000948462','0000529479','','S1','1','TUZZEO','LISA','Ginley','','','34','606435456','115 HIGHLAND MIST CIR',0,'HINCKLEY','OH','44233','9354','CY','39103','2003-12-05','M','',':RET:2106-3','N','021','DEN','3504412','99734OH005000401','2014-03-01','2014-02-10 10:28:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-10 21:00:06'),(24993,19822,'Y','18','021','EC','A','','','AC','0001016808','0001016808','TX00003102129','IL','1','FISSEHA','AMANUEL','','','','34','636687895','9704 FOREST LN',0,'DALLAS','TX','75243','5720','CY','48113','1979-05-20','M','U',':RET:2054-5','N','021','DEN','3771731','33348TX002000201','2014-04-01','2014-02-20 15:03:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 22:00:40'),(25157,19956,'Y','18','021','EC','A','','','AC','0000081161','0000081161','TX00002670402','IL','1','MAREK','BARBARA','','','','34','452027734','16 TROUT ST',0,'PALACIOS','TX','77465','1751','CY','48239','1957-10-31','F','M',':RET:2106-3','N','021','DEN','2650205','33348TX002000201','2014-04-01','2014-02-21 16:25:59','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:20'),(27049,21421,'Y','18','021','EC','A','','','AC','0001025151','0001025151','MS00002765261','IL','1','Elkhatib','Mostafa','M','','','34','578801403','515 FLORENCE DR',0,'MADISON','MS','39110','7326','CY','28089','1951-06-16','M','M',NULL,'N','021','DEN','3255070','46300MS002000101','2014-04-01','2014-03-03 11:35:44','0.00',NULL,NULL,'81.45','81.45','R-MS003','MS0','27.15','CIC',0,'2014-03-03 21:00:24'),(27456,21729,'Y','18','021','EC','A','','','AC','0000701759','0000701759','OH00003664814','IL','1','Quidgeon','Brittany','','','','34','250776774','1027 W WILBETH RD',0,'AKRON','OH','44314','1761','CY','39153','1989-03-29','F','M',':RET:2106-3','N','021','HLT','3055381','52664OH152000901','2014-04-01','2014-03-04 11:00:17','0.00',NULL,NULL,'163.99','163.99','R-OH012','OH0','163.99',NULL,0,'2014-03-04 21:02:03'),(28155,22280,'N','19','021','EC','A',NULL,NULL,'','0000108222','0000603418','','IL','1','Perdew','Aubree','','','','34','283153775','703 TAYLOR ST',0,'DELTA','OH','43515','1043','CY','39051','2009-07-20','F','',':RET:2106-3','N','021','HLT','3334936','92036OH005002601','2014-04-01','2014-03-06 15:18:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','123.83',NULL,0,'2014-03-06 21:02:39'),(28403,22473,'Y','18','021','EC','A','','','AC','0001049443','0001049443','OH00003377638','IL','1','SHERIDAN','HELENA','','','','34','277506883','3410 FISHER RD',0,'COLUMBUS','OH','43204','1413','CY','39049','1951-02-05','F','U',NULL,'T','021','DEN','2673346','99734OH005000401','2014-04-01','2014-03-07 09:29:41','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:30:52'),(28929,22895,'N','19','021','EC','A',NULL,NULL,'','0000701767','0001195566','','S1','1','Tepperman','Jonathan','','','','34','828429859','3021 WOODBINE PL',0,'COLUMBUS','OH','43202','1428','CY','39049','2012-06-07','F','',':RET:2106-3','N','021','DEN','4272007','99734OH005000301','2014-04-01','2014-03-10 13:47:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:00:36'),(4164,3316,'Y','18','021','EC','A','','','AC','0001176839','0001176839','OH00001199256','IL','1','Burkhart','Jason','','','','34','286765040','1127 FULLER ST',0,'CINCINNATI','OH','45202','1714','CY','39061','1977-06-03','M','R',':RET:2106-3','N','021','DEN','1500596','99734OH005000301','2014-01-01','2013-12-17 16:09:08','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:49:03'),(20029,15973,'Y','18','021','EC','A','','','AC','0001648908','0001648908','LA00002506960','IL','1','BRIDGES','QUINTIN','','','','34','438259465','2121 N MIRO STREET',0,'NEW ORLEANS','LA','70119',NULL,'CY','22071','1963-04-14','M','U',':RET:2054-5','T','021','DEN','2058948','18575LA002000201','2014-03-01','2014-01-26 13:49:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-26 19:00:18'),(18068,14432,'Y','18','021','EC','A','','','AC','0001390894','0001390894','LA00001796494','IL','1','Marbury','Johnny','','','','34','439232312','17269 Milton Dr',0,'French Settlement','LA','70733',NULL,'CY','22063','1963-11-25','M','M',':RET:2106-3','N','021','DEN','1915052','18575LA002000201','2014-02-01','2014-01-14 01:04:27','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-15 02:07:23'),(2814,2275,'Y','18','021','EC','A','','','AC','0000421463','0000421463','TX00000675817','IL','1','Vargas','Pamela','','','','34','641321574','6011 Carnation Terr',0,'Austin','TX','78741',NULL,'CY','48453','1992-09-21','F','U',':RET:2106-3','N','021','DEN','208575','33348TX002000201','2014-01-01','2013-11-24 11:50:31','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 20:00:20'),(17306,13840,'Y','18','024','14','A','','','TE','0000621577','0000621577','','IL','1','guthrie','gail',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-05-09','F','',NULL,NULL,NULL,'','2386840','','2014-01-10','2014-01-10 13:18:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:23:41'),(9786,7749,'N','19','021','EC','A',NULL,NULL,'','0000631477','0000630337','','IL','1','Thompson','Braiden','','','','34','287118023','1274 SERENITY LN',0,'COLUMBUS','OH','43085','4796','CY','39049','2005-10-03','M','',':RET:2106-3','N','021','DEN','582269','99734OH005000301','2014-01-01','2013-10-21 12:15:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 05:00:51'),(22381,17873,'N','19','021','EC','A',NULL,NULL,'','0001156236','0000488030','','IL','1','Cassiday','Brendan','','','','34','287136428','2955 PREAKNESS DR',0,'STOW','OH','44224','6235','CY','39153','2007-10-09','M','',':RET:2106-3','N','021','HLT','2648777','52664OH151001306','2014-03-01','2014-02-10 10:54:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-10 21:30:09'),(25051,19865,'N','01','021','EC','A',NULL,NULL,'','0000542737','0001094695','','IL','1','Williams','Christy','A','','','34','290682785','4892 Hunt Rd',0,'Blue Ash','OH','45242',NULL,'CY','39061','1972-01-26','F','',':RET:2106-3','N','021','DEN','3426767','99734OH005000401','2014-04-01','2014-02-19 22:05:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 22:01:16'),(27592,21821,'Y','18','024','14','A','','','TE','0000693636','0000693636','','IL','1','Moss','Carrie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-10-07','F','',NULL,NULL,NULL,'','2766047','','2014-03-31','2014-03-05 16:38:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-05 21:00:18'),(531,433,'Y','18','021','EC','A','','','AC','0000240163','0000240163','MS00000340407','IL','1','Boone','Mary','Melissa','','','34','426372507','236 CHARLENE DR',0,'BYRAM','MS','39272','6418','CY','28049','1964-05-03','F','M',':RET:2106-3','T','021','DEN','1237109','46300MS002000201','2014-01-01','2013-12-03 23:14:19','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 17:49:28'),(22083,17626,'Y','18','021','EC','A','','','AC','0001436526','0001436526','LA00001607824','IL','1','MYLES','BRANDON','W','','','34','438612810','4202 BOOKER T ST',0,'SHREVEPORT','LA','71109','8104','CY','22017','1986-01-06','M','U',':RET:2054-5','N','021','DEN','3680977','18575LA002000201','2014-03-01','2014-02-08 17:19:46','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-08 19:00:19'),(1215,998,'Y','18','021','EC','A','','','AC','0000124175','0000124175','OH00001207385','31','1','Hornstein','Dianna','','','','34','274568039','7073 Curtice Street',0,'Curtice','OH','43412',NULL,'CY','39123','1960-07-22','F','M',':RET:2106-3','N','021','HLT','920979','92036OH001002701','2014-01-01','2013-12-02 22:51:37','205.00',NULL,NULL,'479.83','274.83','R-OH006','OH0','479.83',NULL,0,'2013-12-25 18:20:13'),(19912,15881,'Y','18','024','14','A','','','TE','0001061041','0001061041','','IL','1','neal','lisa','g',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-10-04','F','',NULL,NULL,NULL,'','2381709','','2014-01-23','2014-01-23 20:20:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-24 21:01:00'),(4679,3709,'Y','18','021','EC','A','','','AC','0000985508','0000985508','LA00001100864','IL','1','PAIGE','KEITH','','','','34','439312705','9359 COLLINSTON RD',0,'BASTROP','LA','71220','8717','CY','22067','1977-08-28','M','U',':RET:2054-5','N','021','DEN','16414','18575LA002000201','2014-01-01','2013-12-12 16:02:07','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 22:07:50'),(16671,13341,'N','01','021','EC','A',NULL,NULL,'','0000650793','0000632705','','IL','1','Meek','Jennifer','Lee','','','34','300864253','1227 CLOVERVIEW ST',0,'BLACKLICK','OH','43004','6052','CY','39049','1978-05-24','F','',':RET:2106-3','N','021','DEN','1534724','99734OH005000301','2014-02-01','2014-01-07 14:16:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:28'),(15570,12460,'Y','18','021','EC','A','','','AC','0000768892','0000768892','OH00002066672','IL','1','Ventura','Daniel','James','','','34','270946468','4079   Greenridge Dr.',0,'Uniontown','OH','44685',NULL,'CY','39153','1991-03-27','M','U',':RET:2106-3','N','021','HLT','2145058','52664OH151001301','2014-02-01','2013-12-31 13:04:36','24.39',NULL,NULL,'223.01','198.62','R-OH012','OH0','223.01',NULL,1,'2014-01-02 04:31:52'),(14768,11791,'Y','18','021','EC','A','','','AC','0000697001','0000697001','TX00001273660','IL','1','Dorsey','Derik','','','','34','458991122','5925 BICENTENNIAL LN',0,'BEAUMONT','TX','77706','2504','CY','48245','1983-04-11','M','U',':RET:2054-5','N','021','DEN','1922611','33348TX002000201','2014-01-01','2013-12-23 19:31:17','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,1,'2013-12-29 11:12:51'),(14049,11193,'Y','18','021','EC','A','','','AC','0000640935','0000640935','OH00000206963','IL','1','SMITH','DIANE','','','','34','383560974','543 CARVER BLVD',0,'TOLEDO','OH','43607','2219','CY','39095','1952-02-25','F','U',':RET:2054-5','N','021','DEN','2466295','99734OH005000301','2014-02-01','2013-12-26 11:33:38','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-27 02:00:14'),(28381,22456,'Y','18','021','EC','A','','','AC','0000518471','0000518471','OH00003720086','IL','1','Walker','Theresa','','','','34','275765315','440 Glenn St',0,'Barberton','OH','44203',NULL,'CY','39153','1965-01-05','F','U',':RET:2106-3','T','021','HLT','4231857','52664OH152000901','2014-04-01','2014-03-07 11:15:05','261.00',NULL,NULL,'320.46','59.46','R-OH012','OH0','320.46',NULL,0,'2014-03-07 21:30:39'),(463,378,'Y','18','021','EC','A','','','AC','0000485837','0000485837','OH00000222944','IL','1','ewing','gary','','','','34','276566356','1497 MEADOWBROOK BLVD',0,'STOW','OH','44224','1325','CY','39153','1954-12-30','M','U',':RET:2106-3','N','021','HLT','8601','52664OH151001305','2014-01-01','2013-12-03 19:03:56','462.00',NULL,NULL,'580.49','118.49','R-OH012','OH0','580.49',NULL,0,'2013-12-25 17:47:40'),(1646,1376,'Y','18','021','EC','A','','','AC','0000493005','0000493005','TX00001280839','IL','1','McGee','Crystal','Rae','','','34','122720656','1112 GLENN ST',0,'DAINGERFIELD','TX','75638','1808','CY','48343','1983-03-26','F','M',':RET:2054-5','N','021','DEN','1901249','33348TX002000201','2014-01-01','2013-12-24 15:51:37','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:53:13'),(16287,13038,'Y','18','021','EC','A','','','AC','0000328427','0000328427','OH00002228187','IL','1','Bentley','Christy','','','','34','285823066','541 THOMA PL',0,'VANDALIA','OH','45377','1458','CY','39113','1976-02-27','F','U',':RET:2106-3','N','021','DEN','1602305','99734OH005000401','2014-02-01','2014-01-06 14:37:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-07 04:00:43'),(2491,2029,'N','01','021','EC','A',NULL,NULL,'','0000750578','0000798281','','IL','1','GRANGER','FLEMING','','','','34','435987754','8304 RENO ST',0,'METAIRIE','LA','70003',NULL,'CY','22051','1955-09-26','M','',':RET:2054-5','N','021','DEN','554391','18575LA002000201','2014-01-01','2013-12-09 16:32:51',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:35:48'),(15488,12392,'Y','18','021','EC','A','','','AC','0000882860','0000882860','OH00001126777','IL','1','VANCE','NANCY','','','','34','224844172','1645 LOUISVILLE RD',0,'SEAMAN','OH','45679',NULL,'CY','39001','1967-02-28','F','M',':RET:2106-3','N','021','DEN','1918834','99734OH005000401','2014-02-01','2013-12-31 10:34:23','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,1,'2014-01-02 04:29:24'),(13910,11095,'Y','18','021','EC','A','','','AC','0000885590','0000885590','OH00000950408','IL','1','Dible','Robert','V','','','34','302602693','7315 N Twp Rd 63',0,'Fostoria','OH','44830',NULL,'CY','39147','1964-12-17','M','M',':RET:2106-3','T','021','HLT','1716328','92036OH005002705','2014-01-01','2013-12-23 13:52:43','508.00',NULL,NULL,'675.06','167.06','R-OH006','OH0','382.57',NULL,0,'2013-12-26 13:13:55'),(2680,2170,'N','01','021','EC','A',NULL,NULL,'','0001256007','0000108110','','IL','1','GRAY','LEIGH','','','','34','279607365','667 CHERRY HILL DR',0,'PICKERINGTON','OH','43147','8768','CY','39045','1963-10-16','F','',NULL,'N','021','DEN','862877','99734OH005000301','2014-01-01','2013-12-02 13:08:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:47:11'),(13158,10496,'N','01','021','EC','A',NULL,NULL,'','0000481078','0000115495','','IL','1','Wilson','Nicole','','','','34','288826414','6763 STAFFORD DR',0,'MAYFIELD HEIGHTS','OH','44124','3612','CY','39035','1979-04-19','F','',':RET:2106-3','N','021','DEN','2392829','99734OH005000401','2014-01-01','2013-12-23 17:29:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:53:46'),(23364,18617,'Y','18','021','EC','A','','','AC','0000716386','0000716386','OH00002446783','IL','1','Kunzin','Carol','','','','34','296685236','1726 PRESTON AVE',0,'AKRON','OH','44305','3520','CY','39153','1959-12-13','F','M',':RET:2106-3','N','021','HLT','3685649','52664OH151001305','2014-03-01','2014-02-13 16:39:34','757.00',NULL,NULL,'973.43','216.43','R-OH012','OH0','476.12',NULL,0,'2014-02-13 22:00:48'),(24613,19535,'Y','18','021','EC','A','','','AC','0001193435','0001193435','MS00002775262','IL','1','COURSE','JUSTIN','','','','34','425634941','1926 SOUTHWOOD PL',0,'JACKSON','MS','39213','7932','CY','28049','1985-07-02','M','U',NULL,'T','021','DEN','2739305','46300MS002000201','2014-04-01','2014-02-18 20:02:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 04:14:27'),(24846,19698,'Y','18','021','EC','A','','','AC','0001117302','0001117302','OH00002473130','IL','1','KOMYATI','ANTOINETTE','M','','','34','287642324','1939 GLENWOOD DR',0,'TWINSBURG','OH','44087','1256','CY','39153','1956-11-16','F','M',':RET:2106-3','T','021','HLT','3022046','52664OH152000901','2014-04-01','2014-02-19 11:36:03','165.00',NULL,NULL,'457.77','292.77','R-OH012','OH0','457.77',NULL,0,'2014-02-20 04:54:24'),(25149,19950,'Y','18','021','EC','A','','','AC','0000425013','0000425013','TX00003216337','IL','1','Longbotham','Miles','','','','34','643050444','25 BRAEWOOD PL',0,'DALLAS','TX','75248','7901','CY','48113','1988-02-27','M','U',NULL,'N','021','DEN','3067163','33348TX002000201','2014-04-01','2014-02-21 13:01:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-21 22:00:16'),(27973,22131,'Y','18','021','EC','A','','','AC','0001218882','0001218882','LA00002799015','IL','1','CANNON','Francine','','','','34','221465294','14475 SUMMERSET DR',0,'GONZALES','LA','70737','7087','CY','22005','1959-02-17','F','U',':RET:2054-5','N','021','DEN','3267374','18575LA002000201','2014-04-01','2014-03-06 13:12:19','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:52'),(28118,22253,'Y','18','021','EC','A','','','AC','0001016916','0001016916','OH00002559099','IL','1','Smith','Noreen','','','','34','300506554','V765 COUNTY ROAD 5B',0,'LIBERTY CENTER','OH','43532','9732','CY','39069','1951-01-16','F','M',NULL,'N','021','HLT','4102647','92036OH003002604','2014-04-01','2014-03-05 20:31:51','411.00',NULL,NULL,'601.12','190.12','R-OH001','OH0','601.12',NULL,0,'2014-03-06 21:02:18'),(28564,22605,'N','19','021','EC','A',NULL,NULL,'','0000130763','0000515893','','S1','1','Henderson','Michelle','A','','','34','269176724','4132 ROUTT LN',0,'FRANKLIN','OH','45005','4648','CY','39165','2010-11-18','F','',':RET:2106-3','N','021','HLT','3450176','92036OH003001205','2014-04-01','2014-03-07 14:00:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-03-07 21:32:27'),(28608,22642,'Y','18','021','EC','A','','','AC','0000447551','0000447551','OH00003366639','IL','1','Hafler','Scot','','','','34','278807493','830 BRUCK ST',0,'COLUMBUS','OH','43206','2204','CY','39049','1968-12-31','M','U',':RET:2106-3','N','021','DEN','2953379','99734OH005000401','2014-04-01','2014-03-08 15:29:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-08 21:30:14'),(21,17,'Y','18','021','EC','A','','','AC','0000690707','0000690707','OH00001307163','IL','1','Sarisky','Michael','','','','34','298441448','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1954-05-03','M','M',':RET:2106-3','N','021','DEN','1239419','99734OH005000401','2014-01-01','2013-12-05 13:28:55','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:15:32'),(19164,15267,'N','01','021','EC','A',NULL,NULL,'','0001194152','0001187669','','IL','1','BOLING','JAMES','','','','34','272602766','62 N ERIE BEACH RD',0,'LAKESIDE','OH','43440',NULL,'CY','39123','1956-09-11','M','',':RET:2106-3','N','021','HLT','3045391','92036OH004002701','2014-03-01','2014-01-19 11:54:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.11',NULL,0,'2014-01-21 08:45:43'),(1644,1374,'Y','18','021','EC','A','','','AC','0000193532','0000193532','TX00001265348','IL','1','Harris','Gloria','','','','34','459884879','5580 PHELPS RD',0,'BEAUMONT','TX','77705','6923','CY','48245','1950-12-21','F','U',':RET:2054-5','N','021','DEN','2081123','33348TX002000201','2014-01-01','2013-12-24 15:49:02','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2013-12-25 18:53:10'),(18014,14393,'N','19','021','EC','A',NULL,NULL,'','0001184903','0001040872','','S1','1','Manning','Ted','M','','','34','288110860','662 STATE ROUTE 257 S',0,'OSTRANDER','OH','43061','9613','CY','39041','2005-10-14','F','',NULL,'N','021','DEN','2742395','99734OH005000301','2014-02-01','2014-01-14 11:33:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(6339,5023,'Y','18','021','EC','A','','','AC','0001204504','0001204504','OH00000112437','IL','1','Ludington','Larry','','','','34','282504886','345 Black Gold Dr',0,'Harrison','OH','45030',NULL,'CY','39061','1952-09-12','M','U',':RET:2106-3','T','021','DEN','1106215','99734OH005000401','2014-01-01','2013-12-11 11:52:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:43'),(13325,10639,'Y','18','021','EC','A','','','AC','0000321786','0000321786','TX00001057929','IL','1','Wreyford','Christina','K','','','34','639785749','1204 SAN BERNARD ST',0,'AUSTIN','TX','78702','1129','CY','48453','1978-07-09','F','M',':RET:2106-3','N','021','DEN','1967057','33348TX002000201','2014-01-01','2013-12-23 17:07:12','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:58:27'),(9754,7724,'Y','18','021','EC','A','','','AC','0001177349','0001177349','TX00000513760','IL','1','smith','rosa','','','','34','466908159','1926 A AND M AVE',0,'SAN ANGELO','TX','76904','5043','CY','48451','1950-08-17','F','U',':RET:2106-3','N','021','DEN','643744','33348TX002000101','2014-01-01','2013-11-15 12:50:08','0.00',NULL,NULL,'25.02','25.02','R-TX018','TX0','25.02',NULL,0,'2013-12-26 04:46:19'),(9706,7688,'Y','18','021','EC','A','','','AC','0001144734','0001144734','OH00000005853','IL','1','Brown','Jered','','','','34','310029387','60 NANTUCKET DR',0,'HUDSON','OH','44236','3334','CY','39153','1987-03-26','M','U',':RET:2106-3','N','021','HLT','202975','52664OH151001301','2014-01-01','2013-11-14 19:09:50','0.00',NULL,NULL,'228.36','228.36','R-OH012','OH0','228.36',NULL,0,'2013-12-26 04:45:02'),(4616,3655,'N','01','021','EC','A',NULL,NULL,'','0000291956','0001145951','','IL','1','Frank','Marcia','','','','34','301561708','1143 NORTON AVE',0,'NORTON','OH','44203','6526','CY','39153','1955-02-26','F','',NULL,'N','021','HLT','1153190','52664OH151001501','2014-01-01','2013-12-12 16:31:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','681.50',NULL,0,'2013-12-25 22:06:06'),(2868,2318,'Y','18','021','EC','A','','','AC','0000440970','0000440970','LA00000586607','IL','1','ramsey','marvin','','','Jr','34','438829757','1107 Auburn Ave.',0,'Monroe','LA','71201',NULL,'CY','22073','1951-05-02','M','M',':RET:2106-3','N','021','DEN','364923','18575LA002000101','2014-01-01','2013-11-02 16:58:24','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 20:01:50'),(25255,20035,'Y','18','021','EC','A','','','AC','0000891858','0000891858','OH00002653111','IL','1','Botton','Victor','','','','34','283665488','1700 South Duchess Lane Lot 16',0,'Tiffin','OH','44883',NULL,'CY','39147','1959-05-11','M','M',':RET:2106-3','T','021','HLT','3242102','92036OH006002701','2014-04-01','2014-02-21 14:43:11','770.60',NULL,NULL,'776.27','5.67','R-OH006','OH0','379.69',NULL,0,'2014-02-21 22:01:16'),(27260,21584,'Y','18','021','EC','A','','','AC','0000228394','0000228394','OH00003147972','IL','1','SISSEL','MARGARET','','','','34','282762276','3199 REISINGER RD',0,'BETHEL','OH','45106','9357','CY','39025','1980-05-26','F','U',':RET:2106-3','N','021','HLT','3048700','92036OH005000606','2014-04-01','2014-03-03 17:38:09','175.00',NULL,NULL,'257.16','82.16','R-OH005','OH0','257.16',NULL,0,'2014-03-03 21:31:59'),(2723,2202,'Y','18','021','EC','A','','','AC','0000616468','0000616468','LA00000181726','IL','1','DAVENPORT','CHERRY','ANN','','','34','437745189','1808 FELICITY ST',0,'NEW ORLEANS','LA','70113','1321','CY','22071','1954-11-27','F','U',':RET:2054-5','N','021','DEN','475143','18575LA002000201','2014-01-01','2013-12-02 11:38:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:15'),(20994,16775,'Y','18','021','EC','A','','','AC','0000452782','0000452782','OH00001508087','IL','1','ATKINSON','PAMELA','','','','34','278589759','913 WASHINGTON AVE',0,'WASHINGTON COURT HOUSE','OH','43160','2055','CY','39047','1951-03-01','F','U',':RET:2106-3','N','021','DEN','3312207','99734OH005000301','2014-03-01','2014-01-31 23:12:16','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:25'),(3944,3158,'Y','18','021','EC','A','','','AC','0000577299','0000577299','OH00001306242','IL','1','Richards','Ji','','','','34','625045997','1430 CARROL ST',0,'SIDNEY','OH','45365','6201','CY','39149','1963-08-02','F','M',NULL,'N','021','HLT','143373','92036OH006000501','2014-01-01','2013-12-13 10:00:51','885.00',NULL,NULL,'948.37','63.37','R-OH003','OH0','336.68',NULL,0,'2013-12-25 21:38:00'),(18477,14740,'Y','18','021','EC','A','','','AC','0000187493','0000187493','OH00001914680','IL','1','zittle','susan','','','','34','286600604','1669 BERNA RD',0,'AKRON','OH','44312','5433','CY','39153','1975-05-08','F','M',NULL,'N','021','HLT','1462670','52664OH151001306','2014-02-01','2014-01-14 21:28:18','209.00',NULL,NULL,'277.87','68.87','R-OH012','OH0','277.87',NULL,0,'2014-01-16 08:46:19'),(17667,14118,'N','01','021','EC','A',NULL,NULL,'','0000616888','0001102109','','IL','1','ROBINSON','PAMELA','','','','34','521047951','7726 DELVIEW DR',0,'WEST CHESTER','OH','45069','3324','CY','39017','1959-02-04','F','',':RET:2054-5','N','021','DEN','1386705','99734OH005000301','2014-02-01','2014-01-13 16:27:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:47'),(16093,12889,'Y','18','021','EC','A','','','AC','0000700519','0000700519','MS00002181783','IL','1','Toussaint','Harry','','','','34','436846707','4019 Coleen Street',0,'Moss Point','MS','39563',NULL,'CY','28059','1950-11-21','M','M',':RET:2054-5','N','021','DEN','1658228','46300MS002000201','2014-02-01','2014-01-03 16:19:39','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-04 02:04:30'),(15128,12091,'Y','18','021','EC','A','','','AC','0001063253','0001063253','OH00001156719','IL','1','McGuire','Crystal','','','','34','402338190','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1974-02-21','F','M',NULL,'N','021','DEN','1658127','99734OH005000301','2014-02-01','2013-12-30 17:49:13','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2014-01-01 12:05:25'),(23098,18412,'Y','18','021','EC','A','','','AC','0000881674','0000881674','OH00001792869','IL','1','THOMPSON','RICHARD','S','','','34','402883831','30 TOY FOX LN',0,'BATAVIA','OH','45103','9688','CY','39025','1955-10-04','M','M',NULL,'N','021','DEN','3031778','99734OH005000401','2014-03-01','2014-02-12 15:00:23','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-02-12 21:31:10'),(24630,19547,'Y','18','021','EC','A','','','AC','0002213411','0002213411','LA00002140721','IL','1','Elie','Shilonda','','','','34','437370520','412 13TH ST',0,'ALEXANDRIA','LA','71301','7013','CY','22079','1977-10-08','F','U',':RET:2054-5','N','021','DEN','2870873','18575LA002000201','2014-04-01','2014-02-19 09:38:59','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-20 04:17:42'),(26481,21005,'Y','18','024','14','A','','','TE','0000047108','0000047108','','IL','1','DE SANTIAGO','JOSE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1943-03-24','M','',NULL,NULL,NULL,'','2640473','','2014-02-28','2014-02-28 16:44:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-02-28 21:00:04'),(27705,21909,'Y','18','024','14','A','','','TE','0000772056','0000772056','','IL','1','Street','Jessica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-30','F','',NULL,NULL,NULL,'','2387012','','2014-03-20','2014-03-05 12:15:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-03-05 21:30:50'),(28551,22597,'Y','18','021','EC','A','','','AC','0000512017','0000512017','OH00003129690','IL','1','Ramey','Sherrie','','','','34','277705553','10487 COUNTY ROAD 4',0,'SWANTON','OH','43558','9219','CY','39051','1964-02-08','F','U',':RET:2106-3','N','021','HLT','3992789','92036OH005002605','2014-04-01','2014-03-07 15:49:51','255.00',NULL,NULL,'348.25','93.25','R-OH001','OH0','348.25',NULL,0,'2014-03-07 21:32:21'),(4622,3661,'Y','18','021','EC','A','','','AC','0000512637','0000512637','LA00000933265','IL','1','Ware','Betty','','','','34','425452019','145 S CHERRYWOOD LN',0,'PEARL RIVER','LA','70452','3457','CY','22103','1972-12-17','F','U',':RET:2106-3','N','021','DEN','941369','18575LA002000101','2014-01-01','2013-12-12 11:20:04','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 22:06:15'),(7490,5925,'N','01','021','EC','A',NULL,NULL,'','0000784343','0000750999','','IL','1','Blair','Paul','Joseph','','Jr','34','290526915','17543 COUNTY ROAD 297',0,'COSHOCTON','OH','43812','9525','CY','39031','1950-09-06','M','',':RET:2106-3','N','021','DEN','569012','99734OH005000401','2014-01-01','2013-12-15 14:45:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:35'),(5237,4154,'N','01','021','EC','A',NULL,NULL,'','0000758253','0000762276','','IL','1','JONES','BURTON','','','','34','302584847','6020 KNAPP RD',0,'RAVENNA','OH','44266','8808','CY','39133','1958-01-02','M','',NULL,'N','021','HLT','2571753','52664OH151001305','2014-01-01','2013-12-18 19:58:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.31',NULL,0,'2013-12-25 23:04:51'),(17747,14179,'Y','18','024','14','A','','','TE','0001182516','0001182516','','IL','1','Jordan','Ericka',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-05-20','F','',NULL,NULL,NULL,'','1532003','','2014-01-13','2014-01-13 09:13:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-14 01:33:26'),(5339,4234,'N','01','021','EC','A',NULL,NULL,'','0000227044','0001196803','','IL','1','Oliver','William','C','','Jr','34','278724447','23 S WILLIAMS ST',0,'DAYTON','OH','45402','8236','CY','39113','1967-02-27','M','',NULL,'N','021','DEN','1656286','99734OH005000301','2014-01-01','2013-12-19 15:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:07:18'),(16107,12901,'Y','18','021','EC','A','','','AC','0000240172','0000240172','MS00002133335','IL','1','Green','Stephanie','','','','34','425417368','479-2 PATTERSON RD',0,'SUMRALL','MS','39482','3655','CY','28073','1973-07-05','F','U',':RET:2106-3','T','021','DEN','2535133','46300MS002000101','2014-02-01','2014-01-03 10:30:46','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-01-04 02:04:57'),(9223,7318,'Y','18','021','EC','A','','','AC','0000773964','0000773964','OH00000761142','IL','1','SMITH','SHARON','','','','34','302567156','4796 STATE route 601',0,'NORWALK','OH','44857',NULL,'CY','39077','1952-12-13','F','U',':RET:2106-3','N','021','HLT','1977452','92036OH003002701','2014-01-01','2013-12-18 12:57:34','317.00',NULL,NULL,'572.23','255.23','R-OH006','OH0','572.23',NULL,0,'2013-12-26 04:10:15'),(15362,12287,'Y','18','021','EC','A','','','AC','0000614117','0000614117','OH00001949639','IL','1','Dixon','Taurean','David','','','34','300883072','245 SMITH ST',0,'DAYTON','OH','45417','4038','CY','39113','1983-11-18','M','U',':RET:2054-5','N','021','DEN','2442316','99734OH005000301','2014-02-01','2014-01-01 10:08:58','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,1,'2014-01-02 04:24:48'),(15266,12204,'Y','18','024','14','A','','','TE','0000885596','0000885596','','IL','1','DETZEL','ELIZABETH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-12','F','',NULL,NULL,NULL,'','2310979','','2013-12-30','2013-12-30 15:34:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:09:28'),(15142,12102,'Y','18','021','EC','A','','','AC','0000403667','0000403667','OH00000904282','IL','1','Davidson','Rikki','','','','34','406215985','7967 WESSELMAN RD',0,'COLERAIN TOWNSHIP','OH','45002',NULL,'CY','39061','1980-01-07','F','M',NULL,'N','021','DEN','2509192','99734OH005000401','2014-02-01','2013-12-30 09:23:59','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:47'),(14842,11851,'N','01','021','EC','A',NULL,NULL,'','0000519836','0000260473','','IL','1','McMaster','Donald','','','','34','295569808','303E Wapakoneta St',0,'Waynesfield','OH','45896',NULL,'CY','39011','1955-04-30','M','',':RET:2106-3','N','021','HLT','2082375','92036OH003001505','2014-01-01','2013-12-23 20:52:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','585.61',NULL,1,'2013-12-29 11:14:51'),(9267,7351,'Y','18','021','EC','A','','','AC','0000038350','0000038350','OH00000046252','IL','1','Zanin','Christopher','','','','34','392722570','3203 N DOVER RD',0,'SILVER LAKE','OH','44224','2421','CY','39153','1958-11-22','M','R',':RET:2106-3','N','021','HLT','1054782','52664OH152000901','2014-01-01','2013-11-30 17:52:13','0.00',NULL,NULL,'364.25','364.25','R-OH012','OH0','364.25',NULL,0,'2013-12-26 04:15:31'),(14159,11287,'Y','18','021','EC','A','','','AC','0001152278','0001152278','LA00000924300','IL','1','Fredericks','Gene','','','','34','152443702','1302 N GAYOSO ST',0,'NEW ORLEANS','LA','70119','3122','CY','22071','1950-12-27','M','U',':RET:2106-3','N','021','DEN','1364270','18575LA002000201','2014-02-01','2013-12-26 14:50:51','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:07'),(23613,18807,'Y','18','021','EC','A','','','AC','0000977799','0000977799','TX00001582201','IL','1','GREEN','KYLIE','','','','34','628199001','3909 E 30TH',0,'ODESSA','TX','79762',NULL,'CY','48135','2008-12-24','F','R',':RET:2106-3','N','021','DEN','2856467','33348TX001000201','2014-03-01','2014-02-13 14:19:20','0.00',NULL,NULL,'38.22','38.22','R-TX017','TX0','38.22',NULL,0,'2014-02-13 22:03:13'),(16448,13161,'Y','18','024','14','A','','','TE','0000188159','0000188159','','IL','1','Erby','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-09-28','F','',NULL,NULL,NULL,'','1396905','','2014-01-06','2014-01-06 09:55:36',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-07 04:05:19'),(5914,4684,'Y','18','021','EC','A','','','AC','0000738487','0000738487','TX00001251291','IL','1','Smylie','Susan','','','','34','457198664','562 CHERRY RDG',0,'FLORESVILLE','TX','78114','4210','CY','48493','1959-06-24','F','U',':RET:2106-3','N','021','DEN','1894198','33348TX002000101','2014-01-01','2013-12-23 23:12:57','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-25 23:50:06'),(6796,5390,'Y','18','021','EC','A','','','AC','0000928472','0000928472','OH00000839325','IL','1','Barker','Mary','','','','34','295527213','2522 SANDY LN',0,'COPLEY','OH','44321','2539','CY','39153','1952-05-12','F','M',':RET:2106-3','N','021','HLT','528492','52664OH151001501','2014-01-01','2013-11-24 19:20:13','280.00',NULL,NULL,'751.58','471.58','R-OH012','OH0','751.58',NULL,0,'2013-12-26 01:17:13'),(7618,6028,'Y','18','021','EC','A','','','AC','0000266503','0000266503','OH00001095686','IL','1','Ganica','Juana','','','','34','290987358','6928 EDITH ST',0,'CINCINNATI','OH','45244','3102','CY','39061','1952-08-31','F','U',NULL,'T','021','DEN','416985','99734OH005000301','2014-01-01','2013-11-17 11:38:21','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:45:49'),(23813,18948,'Y','18','021','EC','A','','','AC','0000407422','0000407422','OH00002444456','IL','1','Lawrentz','Cathe','','','','34','301462993','1939 JOHNS RD',0,'CLINTON','OH','44216','9715','CY','39153','1950-03-10','F','M',':RET:2106-3','T','021','HLT','2798886','52664OH152000901','2014-03-01','2014-02-14 10:45:20','403.00',NULL,NULL,'554.51','151.51','R-OH012','OH0','554.51',NULL,0,'2014-02-14 21:31:36'),(23907,19018,'Y','18','021','EC','A','','','AC','0000874746','0000874746','OH00001896041','IL','1','Vanculin','Tessa','','','','34','296825442','189 WILLIS AVE',0,'SPRINGFIELD','OH','45505','1424','CY','39023','1973-07-29','F','M',':RET:2106-3','N','021','HLT','3411645','92036OH002000501','2014-03-01','2014-02-14 16:44:48','0.00',NULL,NULL,'1257.29','1257.29','R-OH003','OH0','350.83',NULL,0,'2014-02-14 21:32:28'),(24568,19511,'Y','18','021','EC','A','','','AC','0000256015','0000256015','OH00002425739','IL','1','ONWUAGBA','AUSTIN','','','','34','272176442','2703 SAVILLE ROW',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1967-01-02','M','M',':RET:2054-5','N','021','DEN','3263057','99734OH005000301','2014-04-01','2014-02-18 22:04:53','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:07:07'),(26904,21323,'Y','18','021','EC','A','','','AC','0001558832','0001558832','LA00002824546','IL','1','provosty','ledoux','','','','34','436025423','6357 BELLAIRE DR',0,'NEW ORLEANS','LA','70124','1348','CY','22071','1955-09-29','M','U',':RET:2106-3','N','021','DEN','2907967','18575LA002000201','2014-04-01','2014-03-01 19:02:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-03 01:00:09'),(737,611,'Y','18','021','EC','A','','','AC','0000516678','0000516678','TX00000302651','IL','1','Hoffman','Bryan','','','','34','513927737','4800 Brookdale Dr.',0,'Wichita Falls','TX','76310',NULL,'CY','48485','1987-02-03','M','M',':RET:2106-3','N','021','DEN','830002','33348TX002000201','2014-01-01','2013-12-15 20:49:06','0.00',NULL,NULL,'31.70','31.70','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:03:57'),(5974,4730,'Y','18','021','EC','A','','','AC','0000759716','0000759716','OH00000805748','IL','1','Weaver','Brenda','','','','34','294866016','4238 N GENSEN LOOP',0,'CINCINNATI','OH','45245','7028','CY','39025','1971-12-16','F','U',':RET:2106-3','N','021','HLT','1566105','92036OH004000601','2014-01-01','2013-12-23 22:52:53','0.00',NULL,NULL,'228.72','228.72','R-OH005','OH0','228.72',NULL,0,'2013-12-25 23:51:44'),(17491,13986,'Y','18','024','14','A','','','TE','0001452405','0001452405','','IL','1','Brown','Jessabella',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-12-25','F','',NULL,NULL,NULL,'','2602108','','2014-01-11','2014-01-11 21:59:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-13 03:01:20'),(14915,11916,'N','01','021','EC','A',NULL,NULL,'','0001162602','0001006830','','IL','1','lambert','guenada','','','','34','287843582','200 Bent Tree Dr.',0,'fairfield','OH','45014',NULL,'CY','39017','1970-07-17','F','',':RET:2054-5','N','021','DEN','2466359','99734OH005000401','2014-02-01','2013-12-28 21:40:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-30 00:01:31'),(3888,3114,'Y','18','021','EC','A','','','AC','0000429017','0000429017','OH00000923583','IL','1','Zelasko','Donald','','','','34','293568040','2392 Medina Line Rd.',0,'Richfield','OH','44286',NULL,'CY','39153','1956-12-20','M','U',':RET:2106-3','N','021','HLT','628361','52664OH152000901','2014-01-01','2013-12-13 11:28:42','398.06',NULL,NULL,'398.06','0.00','R-OH012','OH0','398.06',NULL,0,'2013-12-25 21:36:36'),(3271,2637,'Y','18','021','EC','A','','','AC','0000090168','0000090168','MS00000386228','IL','1','Ackerman','M','','','','34','436675749','108 Charles Mitchell Rd',0,'Poplarville','MS','39470',NULL,'CY','28109','1954-12-15','F','M',':RET:2106-3','N','021','DEN','690909','46300MS002000201','2014-01-01','2013-11-28 14:05:34','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 20:47:12'),(2058,1686,'Y','18','021','EC','A','','','AC','0000777652','0000777652','OH00001087324','IL','1','SENDER','MARYANN','','','','34','286546782','5874 HICKORY TRL',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1956-08-06','F','M',':RET:2106-3','N','021','DEN','486797','99734OH005000301','2014-01-01','2013-12-10 12:57:58','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:16:03'),(2994,2409,'Y','18','021','EC','A','','','AC','0000705120','0000705120','OH00000921081','IL','1','Isenbarger','John','','','','34','269821132','7640 STONESBORO DR',0,'HUBER HEIGHTS','OH','45424','2262','CY','39113','1976-09-14','M','M',':RET:2106-3','T','021','DEN','728312','99734OH005000301','2014-01-01','2013-12-05 20:01:45','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:17:31'),(22376,17869,'Y','18','024','14','A','','','TE','0000155783','0000155783','','IL','1','Kopp','Nancy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-05','F','',NULL,NULL,NULL,'','3679403','','2014-02-10','2014-02-10 16:44:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-10 21:30:06'),(25976,20601,'Y','18','021','EC','A','','','AC','0000792259','0000792259','OH00002525168','31','1','SALINAS','LOUIS','','','','34','291526270','P.O. BOX 604',0,'HOLGATE','OH','43527',NULL,'CY','39069','1955-12-13','M','U',NULL,'N','021','DEN','3150533','99734OH005000401','2014-03-01','2014-02-26 15:06:10','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-26 21:01:49'),(26279,20844,'N','01','021','EC','A',NULL,NULL,'','0001934491','0002072562','','IL','1','Mitchell','Beatrice','','','','34','438238178','313 Belinda',0,'Gramercy','LA','70052',NULL,'CY','22093','1959-01-20','F','',NULL,'N','021','DEN','3837030','18575LA002000101','2014-04-01','2014-02-26 22:23:13',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-28 06:31:19'),(28658,22678,'Y','18','021','EC','A','','','AC','0001904953','0001904953','LA00003101105','IL','1','Migues','Donna','','','','34','437171121','28421 GRAND TURK DR',0,'DENHAM SPRINGS','LA','70726','7875','CY','22063','1958-07-05','F','M',':RET:2106-3','N','021','DEN','3769650','18575LA002000201','2014-04-01','2014-03-07 19:07:04','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-08 21:30:42'),(2499,2036,'Y','18','021','EC','A','','','AC','0000161576','0000161576','LA00000067613','IL','1','Pevey','Richard','','','','34','435845309','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1951-10-23','M','M',':RET:2106-3','N','021','DEN','987327','18575LA002000201','2014-01-01','2013-12-09 17:45:08','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:36:00'),(21221,16957,'N','01','021','EC','A',NULL,NULL,'','0001506573','0001177295','','IL','1','MARKEY','GRACE','','','','34','144907408','4601 SEMINARY  PLACE',0,'NEW ORLEANS','LA','70126',NULL,'CY','22071','1980-02-25','F','',NULL,'N','021','DEN','3100318','18575LA002000201','2014-03-01','2014-02-03 16:00:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-03 21:01:03'),(3012,2422,'Y','18','021','EC','A','','','AC','0000223685','0000223685','OH00000618660','IL','1','Novak','Linda','','','','34','521661272','4437 Wayne Rd',0,'Mantua','OH','44255',NULL,'CY','39133','1950-09-21','F','M',':RET:2106-3','N','021','HLT','132822','52664OH151001305','2014-01-01','2013-12-06 18:06:52','496.00',NULL,NULL,'658.32','162.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 20:17:57'),(7840,6209,'Y','18','021','EC','A','','','AC','0000406122','0000406122','OH00000956426','IL','1','Hawkins','Jeffrey','','','','34','298441578','1 TANGLEWOOD LN',0,'CINCINNATI','OH','45224','2823','CY','39061','1957-01-14','M','M',NULL,'N','021','DEN','2588493','99734OH005000301','2014-01-01','2013-12-19 22:50:19','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:04:35'),(8067,6388,'Y','18','024','14','A','','','TE','0000053033','0000053033','','IL','1','Tomanicek','Marcia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-30','F','',NULL,NULL,NULL,'','784348','','2013-12-20','2013-12-20 13:07:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:10:06'),(16282,13034,'N','01','021','EC','A',NULL,NULL,'','0000490488','0000211025','','IL','1','CLARK','VERNON','','','','34','290660234','150 S LEONARD AVE',0,'LIMA','OH','45804','2926','CY','39003','1956-10-26','M','',NULL,'N','021','DEN','1984394','99734OH005000401','2014-02-01','2014-01-06 16:18:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:00:33'),(22857,18236,'Y','18','021','EC','A','','','AC','0000708982','0000708982','OH00001691760','IL','1','Swisher','Michelle','','','','34','282661844','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1964-08-12','F','M',':RET:2106-3','N','021','HLT','3585946','92036OH003002705','2014-03-01','2014-02-11 13:07:40','955.00',NULL,NULL,'1102.08','147.08','R-OH006','OH0','347.41',NULL,0,'2014-02-11 21:02:23'),(23849,18976,'N','01','021','EC','A',NULL,NULL,'','0000655868','0000336471','','IL','1','TSAI','YIN','','','','34','276962773','1908 Woods Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1973-10-13','F','',NULL,'N','021','HLT','3160262','92036OH005001506','2014-03-01','2014-02-13 22:54:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','281.27',NULL,0,'2014-02-14 21:31:57'),(27700,21906,'N','19','021','EC','A',NULL,NULL,'','0000428667','0000784132','','S1','1','Brooks','Quatro','','','','34','586932408','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','2011-07-12','M','',NULL,'N','021','DEN','2896425','33348TX002000201','2014-04-01','2014-03-05 11:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-03-05 21:30:48'),(2149,1767,'Y','18','021','EC','A','','','AC','0000285615','0000285615','OH00000217318','IL','1','LACOMME','WILLIO','','','','34','770038507','5395 BETTMAN DR',0,'CINCINNATI','OH','45232','1209','CY','39061','1981-01-22','M','U',':RET:2054-5','N','021','HLT','593015','92036OH006001201','2014-01-01','2013-12-10 09:12:31','65.00',NULL,NULL,'201.40','136.40','R-OH004','OH0','201.40',NULL,0,'2013-12-25 19:18:31'),(7282,5775,'Y','18','021','EC','A','','','AC','0000872020','0000872020','OH00000519040','IL','1','Meade','Linda','','','','34','283543382','6360 HILLSIDE AVE',0,'CINCINNATI','OH','45233','1330','CY','39061','1953-05-28','F','U',':RET:2106-3','T','021','HLT','688908','92036OH005001204','2014-01-01','2013-12-13 19:52:20','346.00',NULL,NULL,'670.00','324.00','R-OH004','OH0','670.00',NULL,0,'2013-12-26 02:02:43'),(17056,13649,'Y','18','021','EC','A','','','AC','0000752591','0000752591','TX00001708943','IL','1','Freman','Will','Christopher','','','34','572784297','2803 Fredericksburg Road',0,'San Antonio','TX','78201','4725','CY','48029','1954-06-20','M','M',':RET:2054-5','N','021','DEN','1478306','33348TX002000201','2014-02-01','2014-01-08 18:14:44','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:21:09'),(17751,14183,'Y','18','021','EC','A','','','AC','0000689332','0000689332','MS00001482920','IL','1','ricks','edward','','','','34','425176545','3122 SHIRLEY DR',0,'JACKSON','MS','39212','4132','CY','28049','1962-04-30','M','U',':RET:2054-5','T','021','DEN','2556016','46300MS002000101','2014-02-01','2014-01-13 11:13:10','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-14 01:33:28'),(22315,17816,'Y','18','021','EC','A','','','AC','0002290231','0002290231','LA00001907761','31','1','Lacen','Johnnie','','','','34','433470705','48B Brandon Hall Drive',0,'Destrehan','LA','70047',NULL,'CY','22071','1977-11-18','M','U',':RET:2054-5','N','021','DEN','3056844','18575LA002000101','2014-03-01','2014-01-29 17:41:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-10 11:00:49'),(23979,19065,'Y','18','021','EC','A','','','AC','0002171665','0002171665','LA00002587323','IL','1','Bernard','Tina','','','','34','436724149','2636 77th Ave',0,'Baton Rouge','LA','70807',NULL,'CY','22033','1962-10-13','F','U',':RET:2054-5','N','021','DEN','3695804','18575LA002000201','2014-03-01','2014-02-14 18:19:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-15 22:00:19'),(24552,19502,'Y','18','021','EC','A','','','AC','0001252177','0001252177','OH00002461913','IL','1','BARNETTE','JUDITH','','','','34','448522568','6553 CLEVELAND RD',0,'RAVENNA','OH','44266','1861','CY','39133','1951-07-06','F','U',':RET:2106-3','N','021','HLT','2815777','52664OH151001305','2014-04-01','2014-02-19 16:00:54','462.00',NULL,NULL,'640.70','178.70','R-OH012','OH0','640.70',NULL,0,'2014-02-20 04:04:27'),(25585,20296,'Y','18','021','EC','A','','','AC','0000813091','0000813091','OH00001888205','IL','1','Legan','Thomas','R','','','34','274488743','6512 LOCKHAVEN DR',0,'BROOK PARK','OH','44142','3730','CY','39035','1951-10-19','M','U',NULL,'N','021','DEN','3732086','99734OH005000401','2014-04-01','2014-02-24 07:54:44','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-02-26 08:00:39'),(25837,20482,'Y','18','021','EC','A','','','AC','0000637168','0000637168','OH00002736674','IL','1','SHERWOOD','JOAN','','','','34','300506442','20145 TAYLOR ST',0,'WESTON','OH','43569','9714','CY','39173','1954-11-24','F','M',':RET:2106-3','N','021','HLT','2700748','92036OH003002601','2014-03-01','2014-02-26 08:17:45','575.00',NULL,NULL,'1131.19','556.19','R-OH001','OH0','530.07',NULL,0,'2014-02-26 21:00:32'),(28411,22480,'Y','18','024','14','A','','','TE','0000120152','0000120152','','IL','1','STAPLETON','TRAVIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-24','M','',NULL,NULL,NULL,'','3308114','','2014-03-07','2014-03-07 11:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:30:57'),(29111,23044,'Y','18','021','EC','A','','','AC','0001219884','0001219884','LA00002728397','IL','1','Hoang','Vu','','','','34','525417893','1254 Melanie St',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1959-08-15','F','M',':RET:2047-9','N','021','DEN','3185204','18575LA002000101','2014-04-01','2014-03-10 15:16:52','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-10 21:02:24'),(642,531,'Y','18','021','EC','A','','','AC','0000740260','0000740260','OH00000070231','IL','1','SAWYER','MICHELLE','','','','34','281704261','8800 FAIRLANE DR',0,'OLMSTED TWP','OH','44138','2123','CY','39035','1966-06-01','F','M',':RET:2106-3','T','021','DEN','2369039','99734OH005000401','2014-01-01','2013-12-16 15:28:54','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:01:23'),(6782,5379,'N','01','021','EC','A',NULL,NULL,'','0001095229','0001237829','','IL','1','GONZALEZ','ANA','','','','34','457631676','1901 CARLA ST',0,'ZAPATA','TX','78076','3237','CY','48505','1969-10-21','F','',NULL,'N','021','DEN','441966','33348TX002000201','2014-01-01','2013-11-25 17:31:41',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:16:53'),(17308,13842,'Y','18','021','EC','A','','','AC','0000877833','0000877833','TX00002042156','IL','1','Beard','John','','','','34','630053700','13566 Ducat Ct',0,'Corpus Christi','TX','78418',NULL,'CY','48355','1989-01-28','M','U',':RET:2106-3','N','021','DEN','1647667','33348TX002000201','2014-02-01','2014-01-10 14:03:31','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-13 02:23:42'),(17179,13746,'Y','18','024','14','A','','','TE','0001151084','0001151084','','IL','1','GREEN','PAMELA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-07','F','',NULL,NULL,NULL,'','2386547','','2014-01-08','2014-01-08 10:19:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:22:12'),(1267,1045,'Y','18','021','EC','A','','','AC','0001192595','0001192595','TX00000851747','31','1','Fancher','Ruby','','','','34','461949153','PO BOX 9623',0,'Longview','TX','75608',NULL,'CY','48183','1951-06-26','F','U',':RET:2106-3','N','021','DEN','362795','33348TX002000201','2014-01-01','2013-11-29 12:20:55','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:30:09'),(16866,13495,'Y','18','021','EC','A','','','AC','0001070280','0001070280','TX00001771972','IL','1','Stratton','Noah','','','','34','467352972','1250 Divide Pass',0,'Blanco','TX','78606',NULL,'CY','48031','1971-12-31','M','U',':RET:2106-3','T','021','DEN','1388107','33348TX002000201','2014-02-01','2014-01-09 12:12:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:19:13'),(9593,7597,'Y','18','021','EC','A','','','AC','0000368542','0000368542','OH00000178703','IL','1','Rockwell','Christine','','','','34','287869405','843 STONEWATER DR',0,'KENT','OH','44240','2052','CY','39133','1987-07-09','F','U',':RET:2106-3','N','021','HLT','1746996','52664OH151001305','2014-01-01','2013-12-20 20:26:55','147.00',NULL,NULL,'228.36','81.36','R-OH012','OH0','228.36',NULL,0,'2013-12-26 04:37:13'),(3706,2966,'Y','18','024','14','A','','','TE','0001095634','0001095634','','IL','1','Piesciuk','Stephen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-18','M','',NULL,NULL,NULL,'','601255','','2013-12-13','2013-12-13 14:24:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:32:06'),(2851,2304,'Y','18','021','EC','A','','','AC','0000276240','0000276240','OH00000474792','IL','1','Barnes','Barbara','','','','34','286507492','1 E. Main St.',0,'Ashland','OH','44805',NULL,'CY','39005','1951-09-07','F','U',':RET:2106-3','N','021','DEN','919524','99734OH005000301','2014-01-01','2013-11-02 16:23:25','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:01:21'),(1525,1271,'Y','18','021','EC','A','','','AC','0000569316','0000569316','OH00000075847','IL','1','xin','alfred','','','','34','278949157','6310 COPPERLEAF LN',0,'CINCINNATI','OH','45230','1497','CY','39061','1954-07-15','M','M',':RET:2034-7','N','021','DEN','2100165','99734OH005000401','2014-01-01','2013-12-24 15:21:23','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:49:52'),(27716,21918,'Y','18','024','14','A','','','TE','0000879243','0000879243','','IL','1','PEREZ','SERGIO',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-01-16','M','',NULL,NULL,NULL,'','2955847','','2014-03-05','2014-03-05 13:28:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:55'),(27731,21929,'N','19','021','EC','A',NULL,NULL,'','0000713990','0000282034','','IL','1','TORRES','JAQUELINE','','','','34','641209556','1113 S 1ST ST',0,'HARLINGEN','TX','78550','7051','CY','48061','1991-02-08','F','',NULL,'N','021','DEN','4088989','33348TX002000201','2014-04-01','2014-03-05 16:09:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:31:04'),(407,335,'Y','18','021','EC','A','','','AC','0001040825','0001040825','OH00001241372','IL','1','Piper','Pamela','','','','34','281543683','19 West Walnut St - -P O Box 273',0,'Marengo','OH','43334',NULL,'CY','39117','1955-07-29','F','U',':RET:2106-3','N','021','DEN','1102225','99734OH005000401','2014-01-01','2013-12-04 12:33:56','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2013-12-25 17:46:18'),(7076,5615,'Y','18','021','EC','A','','','AC','0000194049','0000194049','OH00000596947','IL','1','Nguyen','Sabrina','','','','34','273941972','6720 Kelseys Oak Court',0,'Cincinnati','OH','45248',NULL,'CY','39061','1974-02-13','F','U',':RET:2047-9','N','021','DEN','2585430','99734OH005000301','2014-01-01','2013-12-24 23:14:13','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:50:10'),(878,726,'Y','18','021','EC','A','','','AC','0000590769','0000590769','OH00000652993','IL','1','Hall','Michael','','','','34','286800763','32 S. Plaza Ave.',0,'Dayton','OH','45417',NULL,'CY','39113','1982-12-03','M','U',':RET:2054-5','T','021','HLT','2010232','92036OH004000501','2014-01-01','2013-12-16 10:14:46','195.00',NULL,NULL,'254.76','59.76','R-OH003','OH0','254.76',NULL,0,'2013-12-25 18:07:38'),(3372,2702,'Y','18','021','EC','A','','','AC','0001201183','0001201183','TX00000121666','IL','1','Green-Parks','Holly','Nicole','','','34','464856498','6116 GASTON AVE',0,'DALLAS','TX','75214','4326','CY','48113','1979-04-11','F','R',':RET:2106-3','T','021','DEN','1409136','33348TX002000201','2014-01-01','2013-12-22 15:38:08','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:17:17'),(4578,3625,'Y','18','021','EC','A','','','AC','0000944186','0000944186','TX00000429002','IL','1','Ganze','Hazel','','','','34','454980877','4122 MCDERMED DR',0,'HOUSTON','TX','77025','5448','CY','48201','1958-10-20','F','U',':RET:2106-3','N','021','DEN','630667','33348TX002000101','2014-01-01','2013-12-12 17:40:28','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 22:05:07'),(20574,16443,'N','19','021','EC','A',NULL,NULL,'','0000683413','0001260044','','IL','1','EICHBERG','LUCAS','','','','34','271113045','6330 CAMBRIDGE AVE',0,'CINCINNATI','OH','45230','1986','CY','39061','2004-10-22','M','',NULL,'N','021','HLT','2746447','92036OH003001201','2014-03-01','2014-01-29 17:36:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-29 21:01:54'),(18748,14938,'N','19','021','EC','A',NULL,NULL,'','0000397371','0000326211','','IL','1','Marini','Jason','','','','34','280940817','1999 W RIDGEWOOD DR',0,'PARMA','OH','44134','4822','CY','39035','1991-06-17','M','',':RET:2106-3','N','021','DEN','1403670','99734OH005000301','2014-02-01','2014-01-15 20:39:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:42'),(14748,11775,'N','01','021','EC','A',NULL,NULL,'','0001016863','0000629255','','IL','1','Branson','Robert','','','','34','285709680','105 HILL TOP LN',0,'MOSCOW','OH','45153','8904','CY','39025','1963-10-12','M','',':RET:2106-3','N','021','HLT','2083898','92036OH006000601','2014-02-01','2013-12-27 20:06:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','304.05',NULL,1,'2013-12-29 11:10:13'),(15851,12690,'Y','18','021','EC','A','','','AC','0000183524','0000183524','OH00002146994','IL','1','moncgomery','kia','','','','34','286728176','148 SANTA CLARA AVE',0,'DAYTON','OH','45405','3634','CY','39113','1972-04-14','F','U',':RET:2054-5','N','021','DEN','2541489','99734OH005000401','2014-02-01','2014-01-02 17:56:16','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:04:24'),(23587,18791,'N','19','021','EC','A',NULL,NULL,'','0000389882','0000486988','','S1','1','Schanz','Cynthia','','','','34','291067138','798 N SUMMIT ST',0,'BARBERTON','OH','44203','1523','CY','39153','2001-11-15','F','',':RET:2106-3','N','021','HLT','3127425','52664OH152000901','2014-03-01','2014-02-13 11:50:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-02-13 22:03:00'),(24454,19426,'Y','18','021','EC','A','','','AC','0000553169','0000553169','MS00001674183','IL','1','TILLIS','SIDNEY','M','','','34','427762519','143 RAULSTON DR',0,'BYRAM','MS','39272','9244','CY','28049','1943-07-13','M','U',':RET:2054-5','N','021','DEN','3460586','46300MS002000201','2014-04-01','2014-02-18 15:44:38','0.00',NULL,NULL,'17.60','17.60','R-MS003','MS0','17.60',NULL,0,'2014-02-18 22:01:28'),(27020,21402,'N','01','021','EC','A',NULL,NULL,'','0000897042','0000272556','','IL','1','Eyer-Kerr','Jennifer','','','','34','294709896','209 S. Ayres st.',0,'Nevada','OH','44849',NULL,'CY','39175','1976-01-04','F','',':RET:2106-3','N','021','DEN','3550480','99734OH005000301','2014-04-01','2014-03-03 13:26:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 21:00:12'),(28836,22820,'N','19','021','EC','A',NULL,NULL,'','0000327336','0000227121','','IL','1','o\'neal','cassi','','','','34','747689456','225 Pinecone Drive',0,'Springboro','OH','45066',NULL,'CY','39165','2012-03-27','F','',NULL,'N','021','HLT','3737757','92036OH006001201','2014-04-01','2014-03-09 12:57:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-03-09 21:01:10'),(6294,4992,'Y','18','021','EC','A','','','AC','0000029011','0000029011','OH00000108102','IL','1','Yurcik','John','','','','34','278501615','13324 Tomson Drive',0,'Strongsville','OH','44149',NULL,'CY','39035','1952-05-15','M','U',':RET:2106-3','N','021','DEN','370320','99734OH005000401','2014-01-01','2013-12-11 08:31:23','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:45:44'),(1244,1024,'Y','18','021','EC','A','','','AC','0000542641','0000542641','OH00000084813','IL','1','Oatman','Kari','','','','34','286902554','15724 WYATT RD',0,'EAST CLEVELAND','OH','44112','4042','CY','39035','1985-01-21','F','M',':RET:2054-5','T','021','HLT','77710','52664OH152001001','2014-01-01','2013-12-03 11:09:35','0.00',NULL,NULL,'172.86','172.86','R-OH011','OH0','172.86',NULL,0,'2013-12-25 18:21:01'),(18427,14701,'Y','18','021','EC','A','','','AC','0002310025','0002310025','LA00002453475','IL','1','Ponville','Travis','','','','34','439717788','111 KIRK ST',0,'PIERRE PART','LA','70339','4642','CY','22007','1977-12-10','M','R',':RET:2106-3','N','021','DEN','2814991','18575LA002000201','2014-02-01','2014-01-15 10:25:49','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-01-16 08:45:56'),(3727,2978,'Y','18','021','EC','A','','','AC','0001089435','0001089435','TX00000359406','IL','1','BURCHETT','KUK HWA','','','','34','527872916','2425 MCKINLEY AVE',0,'EL PASO','TX','79930','2243','CY','48141','1951-07-04','F','U',':RET:2040-4','N','021','DEN','1255623','33348TX002000201','2014-01-01','2013-12-13 17:33:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 21:32:29'),(14128,11261,'Y','18','021','EC','A','','','AC','0001231367','0001231367','LA00000957861','IL','1','Morris','Ernest','G','','','34','439942279','6975 HIGHWAY 67',0,'SLAUGHTER','LA','70777','4038','CY','22037','1955-01-09','M','M',':RET:2054-5','N','021','DEN','2159238','18575LA002000201','2014-02-01','2013-12-25 22:59:40','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-27 02:02:19'),(13252,10576,'Y','18','021','EC','A','','','AC','0000033253','0000033253','TX00000900180','IL','1','Quiroga','Virginia','','','','34','292545436','24196 FM 2556',0,'Santa Rosa','TX','78593',NULL,'CY','48061','1953-03-20','F','U',NULL,'N','021','DEN','1891400','33348TX002000201','2014-01-01','2013-12-23 11:17:37','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 12:56:25'),(7180,5693,'Y','18','021','EC','A','','','AC','0000077545','0000077545','OH00001023208','IL','1','WILLIAMS','KRISTIN','','','','34','390409412','616 E 1ST ST',0,'MINERVA','OH','44657','2006','CY','39151','1953-05-04','F','U',NULL,'N','021','DEN','1257098','99734OH005000301','2014-01-01','2013-12-14 09:23:13','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-26 02:00:11'),(7750,6138,'N','01','021','EC','A',NULL,NULL,'','0000809669','0000996523','','IL','1','KREGLOW','JENNIFER','','','','34','295680987','218 KOKE',0,'DE GRAFF','OH','43318',NULL,'CY','39091','1959-10-31','F','',':RET:2106-3','N','021','DEN','1872479','99734OH005000401','2014-01-01','2013-12-20 16:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:02:29'),(21831,17433,'Y','18','021','EC','A','','','AC','0001135677','0001135677','TX00002451754','IL','1','AGUILAR','YOLANDA','','','','34','456518369','2419 FINLEY RD',0,'IRVING','TX','75062','3347','CY','48113','1956-09-19','F','U',':RET:2106-3','N','021','DEN','3211738','33348TX002000101','2014-03-01','2014-02-05 22:53:19','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-06 21:01:05'),(23466,18691,'N','19','021','EC','A',NULL,NULL,'','0000160460','0000808496','','S1','1','RUBIO','FRANCISCO','','','','34','635505140','310 E TRIPP RD',0,'SUNNYVALE','TX','75182','9591','CY','48113','1995-11-18','F','',NULL,'N','021','DEN','3007197','33348TX002000201','2014-03-01','2014-02-13 15:03:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52',NULL,0,'2014-02-13 22:01:45'),(25767,20437,'N','19','021','EC','A',NULL,NULL,'','0001168054','0000108193','','IL','1','MASON','COOPER','','','','34','291153348','3800 Milner rd',0,'Newark','OH','43055',NULL,'CY','39089','2010-01-18','M','',NULL,'N','021','DEN','3409536','99734OH005000301','2014-04-01','2014-02-24 13:04:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:55'),(26347,20902,'Y','18','021','EC','A','','','AC','0000895770','0000895770','OH00003315271','IL','1','McGarvey','Steve','','','','34','298884011','635 Rombach',0,'Wilmington','OH','45177',NULL,'CY','39027','1982-06-23','M','M',':RET:2106-3','T','021','HLT','3840895','92036OH004000601','2014-04-01','2014-02-27 17:11:24','0.00',NULL,NULL,'230.07','230.07','R-OH005','OH0','230.07',NULL,0,'2014-02-28 06:31:45'),(852,706,'Y','18','021','EC','A','','','AC','0000943410','0000943410','OH00001151775','IL','1','BREWER','KATHY','L','','','34','295666221','1909 E TURKEY FOOT LAKE RD',0,'AKRON','OH','44312',NULL,'CY','39153','1960-04-06','F','U',':RET:2106-3','N','021','HLT','1639308','52664OH152000901','2014-01-01','2013-12-16 16:44:41','333.21',NULL,NULL,'333.21','0.00','R-OH012','OH0','333.21',NULL,0,'2013-12-25 18:06:55'),(20956,16746,'Y','18','021','EC','A','','','AC','0000563052','0000563052','TX00002143806','IL','1','Whitley','Barbara','','','','34','467066376','2846 FM 2410 SPUR',0,'Belton','TX','76513',NULL,'CY','48027','1955-10-04','F','M',':RET:2106-3','N','021','DEN','3671695','33348TX002000201','2014-03-01','2014-02-01 11:52:34','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-02-01 19:00:07'),(20596,16457,'Y','18','021','EC','A','','','AC','0000930940','0000930940','OH00001546430','IL','1','Rosier','Jennie','','','','34','301508007','59221 LOCKWOOD RUN RD',0,'SHADYSIDE','OH','43947','9716','CY','39013','1950-08-11','F','M',':RET:2106-3','N','021','DEN','3317452','99734OH005000401','2014-03-01','2014-01-30 10:17:15','0.00',NULL,NULL,'50.05','50.05','R-OH016','OH0','0.00',NULL,0,'2014-01-30 21:00:11'),(18312,14620,'Y','18','021','EC','A','','','AC','0000358355','0000358355','OH00002025052','IL','1','queen','christopher','','','','34','268802185','7911 WHITTINGTON DR',0,'CLEVELAND','OH','44129','4414','CY','39035','1978-12-30','M','U',':RET:2106-3','N','021','DEN','1419494','99734OH005000401','2014-02-01','2014-01-15 12:49:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:02'),(15717,12573,'Y','18','021','EC','A','','','AC','0000253057','0000253057','OH00000010558','IL','1','Kilgallon','Brian','','','','34','055540185','1362 ETHEL AVE',0,'LAKEWOOD','OH','44107','2322','CY','39035','1959-11-18','M','U',':RET:2106-3','N','021','DEN','2608707','99734OH005000301','2014-02-01','2014-01-01 23:08:03','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-03 02:00:04'),(23515,18732,'Y','18','021','EC','A','','','AC','0001082493','0001082493','MS00001770023','IL','1','Smith','LaTonya','','','','34','427617786','130 KING ST',0,'GRENADA','MS','38901','1500','CY','28043','1982-07-28','F','U',':RET:2054-5','N','021','DEN','3162423','46300MS002000101','2014-03-01','2014-02-13 14:38:09','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-13 22:02:16'),(23546,18758,'N','01','021','EC','A',NULL,NULL,'','0002116202','0002133338','','IL','1','Allatto','Ramona','','','','34','438434695','50211 WHISKEY LN',0,'TICKFAW','LA','70466','2517','CY','22105','1962-12-31','F','',':RET:2106-3','N','021','DEN','3593609','18575LA002000201','2014-03-01','2014-02-13 13:46:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-13 22:02:35'),(24097,19155,'N','01','021','EC','A',NULL,NULL,'','0001168048','0000409787','','IL','1','delgado-criado','alejandra','','','','34','297154199','5174 LUCYDALE AVE',0,'NORTH OLMSTED','OH','44070','4307','CY','39035','1987-01-31','F','',':RET:2106-3','N','021','HLT','2745584','52664OH151001305','2014-03-01','2014-02-15 17:16:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','263.59',NULL,0,'2014-02-15 22:01:28'),(28324,22411,'Y','18','021','EC','A','','','AC','0000853577','0000853577','TX00003214324','IL','1','Harvey','Shameeka','Griffin','','','34','458797058','2927 COCONA LN',0,'HOUSTON','TX','77073','2915','CY','48201','1978-05-19','F','U',':RET:2054-5','N','021','DEN','4022725','33348TX002000201','2014-04-01','2014-03-06 23:09:08','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-07 21:30:07'),(3334,2674,'N','19','021','EC','A',NULL,NULL,'','0000581483','0000341338','','IL','1','SMITH','PRESENTINA','B','','','34','300041997','217 IDAHO AVE',0,'LORAIN','OH','44052','2159','CY','39093','2000-06-30','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','1853563','99734OH005000301','2014-01-01','2013-12-22 18:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:21'),(5163,4094,'Y','18','021','EC','A','','','AC','0000912943','0000912943','OH00000322066','IL','1','SPENCE','MINDI','','','','34','295547066','3224 SUMMERTIME CT',0,'COLUMBUS','OH','43221','4637','CY','39049','1968-10-10','F','U',':RET:2106-3','N','021','DEN','1656260','99734OH005000401','2014-01-01','2013-12-19 10:44:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:03:06'),(7298,5784,'Y','18','021','EC','A','','','AC','0000547864','0000547864','OH00000273945','IL','1','Goldblatt','Jay','','','','34','272589119','28700 JACKSON RD',0,'CHAGRIN FALLS','OH','44022','1524','CY','39035','1958-04-17','M','U',':RET:2106-3','N','021','HLT','1002854','52664OH151001301','2014-01-01','2013-12-14 09:41:06','125.00',NULL,NULL,'560.89','435.89','R-OH011','OH0','560.89',NULL,0,'2013-12-26 02:03:04'),(8119,6422,'Y','18','021','EC','A','','','AC','0000222372','0000222372','OH00000978069','IL','1','Guinn','Phyllis','','','','34','298561445','2920 MCCAFFERTY RD',0,'FAYETTEVILLE','OH','45118','9668','CY','39015','1956-02-13','F','M',':RET:2106-3','N','021','DEN','1236993','99734OH005000401','2014-01-01','2013-11-21 22:05:52','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:15:13'),(9378,7436,'Y','18','021','EC','A','','','AC','0000702923','0000702923','LA00000094195','IL','1','davis','patricia','','','','34','434907822','1316 FARRAGUT ST',0,'NEW ORLEANS','LA','70114','2816','CY','22071','1951-09-04','F','M',NULL,'N','021','DEN','2582554','18575LA002000201','2014-01-01','2013-12-21 15:36:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:32:01'),(9015,7153,'N','01','021','EC','A',NULL,NULL,'','0000296774','0000213361','','IL','1','Garling','Sherry','Lynn','','','34','166463206','1729 st rt 511',0,'Ashland','OH','44805',NULL,'CY','39005','1955-04-12','F','',':RET:2106-3','N','021','HLT','1636978','52664OH151001301','2014-01-01','2013-12-17 18:45:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','568.22',NULL,0,'2013-12-26 04:05:12'),(24944,19780,'Y','18','021','EC','A','','','AC','0000328768','0000328768','MS00001980972','IL','1','Anderson','RC','','','Jr','34','427048956','237 NORWOOD RD',0,'FLORENCE','MS','39073','9029','CY','28121','1957-10-20','M','U',':RET:2054-5','N','021','DEN','3184647','46300MS002000201','2014-04-01','2014-02-20 15:00:39','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-20 22:00:06'),(26440,20972,'Y','18','021','EC','A','','','AC','0000249111','0000249111','OH00002652249','IL','1','Rickett','Annette','','','','34','288523228','811 LESCAR LN',0,'GALLOWAY','OH','43119','8543','CY','39049','1957-12-28','F','U',':RET:2106-3','T','021','DEN','3607383','99734OH005000401','2014-04-01','2014-02-27 14:51:24','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-28 07:30:20'),(26779,21223,'Y','18','021','EC','A','','','AC','0000680042','0000680042','TX00003211506','IL','1','Nguyen','Kimberly','','','','34','522356809','1009 DUSTY KAY ST',0,'BONHAM','TX','75418','5524','CY','48147','1977-03-28','F','U',':RET:2047-9','N','021','DEN','3234874','33348TX002000201','2014-04-01','2014-02-28 23:57:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-01 21:00:12'),(27982,22139,'Y','18','024','14','A','','','TE','0002222174','0002222174','','IL','1','Hutto','Heather',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-04-17','F','',NULL,NULL,NULL,'','3977614','','2014-03-06','2014-03-06 16:06:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-03-06 21:00:58'),(28322,22409,'Y','18','021','EC','A','','','AC','0000180640','0000180640','TX00003564060','IL','1','Hernandez','Ivonne','Guadalupe','','','34','637103132','11989 BANNER CREST DR',0,'EL PASO','TX','79936','0948','CY','48141','1982-01-07','F','M',NULL,'N','021','DEN','3165770','33348TX002000201','2014-04-01','2014-03-06 19:58:32','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-07 21:30:05'),(28826,22813,'N','01','021','EC','A',NULL,NULL,'','0001196878','0000181075','','IL','1','Burley','Margie',NULL,NULL,NULL,NULL,NULL,'1368 matzinger rd.',0,'toledo','OH','43612',NULL,'CY','39095','1957-07-20','F','',':RET:2106-3','N','021','HLT','3239184','92036OH004002601','2014-04-01','2014-03-09 15:51:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','365.79',NULL,0,'2014-03-09 21:01:03'),(1805,1483,'Y','18','021','EC','A','','','AC','0000629248','0000629248','OH00001258752','IL','1','Rehbaum','Douglas','','','','34','274482053','9719 PIPPIN RD',0,'CINCINNATI','OH','45231','2225','CY','39061','1955-10-06','M','R',':RET:2106-3','N','021','HLT','2007029','92036OH004001201','2014-01-01','2013-12-24 16:14:51','0.00',NULL,NULL,'439.81','439.81','R-OH004','OH0','439.81',NULL,0,'2013-12-25 18:56:52'),(6328,5017,'N','01','021','EC','A',NULL,NULL,'','0000971449','0001094618','','IL','1','WOLFORD','THOMAS','','','','34','281529392','711 SWANS ROAD NE',0,'NEWARK','OH','43055',NULL,'CY','39089','1955-12-29','M','',':RET:2106-3','N','021','DEN','491025','99734OH005000401','2014-01-01','2013-12-11 11:24:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:32'),(18900,15059,'N','01','021','EC','A',NULL,NULL,'','0000680875','0000873258','','IL','1','Leu','Brenda','','','','34','295648045','2510 Consaul Street',0,'Toledo','OH','43605',NULL,'CY','39095','1959-09-20','F','',NULL,'N','021','HLT','1617051','92036OH006002601','2014-03-01','2014-01-16 11:27:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','330.16',NULL,0,'2014-01-17 03:36:36'),(18114,14467,'N','01','021','EC','A',NULL,NULL,'','0000991559','0001190076','','IL','1','Scroggins','Charlyn','','','','34','301429318','5666 RICHMAN RD',0,'SPENCER','OH','44275','9788','CY','39103','1950-03-06','F','',':RET:2106-3','T','021','HLT','2460330','52664OH152000901','2014-02-01','2014-01-13 20:17:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','554.51',NULL,0,'2014-01-15 02:07:38'),(17995,14380,'N','19','021','EC','A',NULL,NULL,'','0000667803','0001261226','','IL','1','Maier','Jay','','','','34','279029457','830 WOODBINE AVE',0,'CINCINNATI','OH','45246','4521','CY','39061','1997-06-12','M','',':RET:2106-3','N','021','DEN','1517733','99734OH005000301','2014-02-01','2014-01-13 20:30:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:58'),(15493,12397,'Y','18','021','EC','A','','','AC','0001014385','0001014385','OH00001833907','IL','1','Fiamengo','Paul','','','','34','040540163','10600 N Cassel Rd',0,'Vandalia','OH','45377',NULL,'CY','39113','1956-08-15','M','M',NULL,'N','021','DEN','2015630','99734OH005000401','2014-02-01','2013-12-31 12:08:10','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,1,'2014-01-02 04:29:34'),(15449,12362,'Y','18','021','EC','A','','','AC','0000961026','0000961026','TX00001887019','31','1','patterson','crystal','','','','34','451510941','Po Box 434',0,'Bryson','TX','76427',NULL,'CY','48237','1977-06-05','F','U',':RET:2106-3','T','021','DEN','1399320','33348TX002000201','2014-02-01','2013-12-31 15:09:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2014-01-02 04:28:18'),(15192,12140,'Y','18','021','EC','A','','','AC','0000495470','0000495470','OH00001880745','IL','1','Robertson','James','','','','34','310929710','4261 Americana Dr.',0,'Cuyahoga Falls','OH','44224',NULL,'CY','39153','1984-04-30','M','M',':RET:2106-3','N','021','HLT','2233553','52664OH152000901','2014-02-01','2013-12-30 11:55:31','0.00',NULL,NULL,'182.78','182.78','R-OH012','OH0','182.78',NULL,0,'2014-01-01 12:07:08'),(2737,2215,'Y','18','021','EC','A','','','AC','0000820973','0000820973','OH00000114417','IL','1','FRAUNFELTER','DEBORAH','','','','34','268682769','901 SELBY ST',0,'FINDLAY','OH','45840',NULL,'CY','39063','1959-05-01','F','U',':RET:2106-3','T','021','HLT','590290','92036OH005001506','2014-01-01','2013-12-01 19:51:50','503.00',NULL,NULL,'540.37','37.37','R-OH002','OH0','540.37',NULL,0,'2013-12-25 19:48:40'),(21954,17531,'Y','18','021','EC','A','','','AC','0001056744','0001056744','OH00001645692','IL','1','COOK','SHENIKA','','','','34','297820144','135 CHESTNUT LN',0,'CLEVELAND','OH','44143',NULL,'CY','39035','1985-02-25','F','U',':RET:2054-5','N','021','DEN','3361405','99734OH005000401','2014-03-01','2014-02-07 09:08:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-07 19:00:22'),(28670,22688,'Y','18','021','EC','A','','','AC','0001897943','0001897943','LA00003299165','IL','1','Huxen','Sarah','','','','34','439759357','10345 SPRINGPARK AVE',0,'BATON ROUGE','LA','70810','0769','CY','22033','1983-02-03','F','M',':RET:2106-3','N','021','DEN','3153402','18575LA002000201','2014-04-01','2014-03-08 16:36:05','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-03-08 21:30:49'),(2050,1679,'Y','18','021','EC','A','','','AC','0000782711','0000782711','TX00000007277','IL','1','Serrano','Mary','Helen','','','34','465986896','4221 MERIDA AVE',0,'FORT WORTH','TX','76115','1005','CY','48439','1951-07-22','F','M',':RET:2106-3','N','021','DEN','552026','33348TX002000201','2014-01-01','2013-12-10 17:47:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:15:49'),(21395,17097,'Y','18','021','EC','A','','','AC','0000021421','0000021421','OH00002567210','IL','1','LONG','DORIS','','','','34','283707604','1236 FERNWOOD AVE',0,'TOLEDO','OH','43607',NULL,'CY','39095','1961-03-01','F','U',':RET:2054-5','N','021','DEN','3246413','99734OH005000401','2014-03-01','2014-02-04 11:29:23','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-04 21:00:59'),(2236,1837,'N','01','021','EC','A',NULL,NULL,'','0000009819','0000430257','','IL','1','Clark','Rebecca','','','','34','297888958','324 Wentworth Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','1981-11-23','F','',NULL,'N','021','HLT','584104','92036OH005001201','2014-01-01','2013-12-10 16:24:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.96',NULL,0,'2013-12-25 19:20:52'),(4626,3665,'Y','18','021','EC','A','','','AC','0001001588','0001001588','LA00000735728','IL','1','Taylor','Cathy','G','','','34','436823554','2240 MENDEZ ST',0,'NEW ORLEANS','LA','70122','5255','CY','22071','1951-12-03','F','U',':RET:2054-5','N','021','DEN','1073810','18575LA002000101','2014-01-01','2013-12-12 17:22:59','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 22:06:22'),(3335,2674,'N','19','021','EC','A',NULL,NULL,'','0000581483','0001241856','','IL','1','SMITH','MATTHEW','A','','Jr','34','293021673','217 IDAHO AVE',0,'LORAIN','OH','44052','2159','CY','39093','1998-01-19','M','',':RET:1002-5^:RET:2106-3','N','021','DEN','1853563','99734OH005000301','2014-01-01','2013-12-22 18:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:16:22'),(3701,2962,'N','19','021','EC','A',NULL,NULL,'','0000240325','0000974071','','IL','1','Williams','Alison','','','','34','271986745','134 VERMONT AVE',0,'CINCINNATI','OH','45215','2046','CY','39061','1994-06-25','F','',':RET:2106-3','N','021','DEN','608255','99734OH005000401','2014-01-01','2013-12-13 13:19:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:31:59'),(23412,18654,'Y','18','021','EC','A','','','AC','0000549595','0000549595','TX00001746666','IL','1','RIVERA','RICARDO','','','','34','604265172','8126 TINA DR',0,'TYLER','TX','75703','4809','CY','48423','1963-07-26','M','M',NULL,'N','021','DEN','3610613','33348TX002000201','2014-03-01','2014-02-12 19:59:40','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2014-02-13 22:01:17'),(23621,18811,'N','19','021','EC','A',NULL,NULL,'','0000024155','0000234095','','IL','1','Neeley','Hannah','M','','','34','298981964','15 FARMVIEW CT',0,'HARRISON','OH','45030','2013','CY','39061','1995-09-10','F','',':RET:2106-3','N','021','HLT','3274336','92036OH004001201','2014-03-01','2014-02-13 15:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-13 22:03:17'),(23639,18823,'Y','18','021','EC','A','','','AC','0000620569','0000620569','TX00002245964','IL','1','Moreno','Veronica','','','','34','629367764','123 Alta Vista',0,'Bastrop','TX','78602',NULL,'CY','48021','1975-04-06','F','M',':RET:2106-3','N','021','DEN','2933466','33348TX002000201','2014-03-01','2014-02-13 20:24:56','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-14 21:30:07'),(24016,19100,'Y','18','021','EC','A','','','AC','0000179950','0000179950','OH00002275607','IL','1','Craver','Anthony','','','','34','424940213','2683 COBBLE CIR',0,'MORAINE','OH','45439','5167','CY','39113','1973-02-03','M','U',':RET:2054-5','N','021','DEN','2870818','99734OH005000401','2014-03-01','2014-02-15 13:29:02','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-15 22:00:44'),(26762,21210,'Y','18','024','14','A','','','TE','0001121453','0001121453','','IL','1','POKORNY','SYNTHIA','ELLEN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-08-04','F','',NULL,NULL,NULL,'','2898781','','2014-02-28','2014-02-28 19:30:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-01 19:00:09'),(4100,3276,'Y','18','021','EC','A','','','AC','0000721324','0000721324','TX00000864643','IL','1','Branson','Elizabeth','Ann','','','34','522760567','145 Yaupon Dr.',0,'Kerrville','TX','78028',NULL,'CY','48265','1949-11-04','F','M',':RET:2106-3','N','021','DEN','2286457','33348TX002000101','2014-01-01','2013-12-16 20:31:46','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 21:47:42'),(2275,1857,'N','19','021','EC','A',NULL,NULL,'','0001085590','0000035728','','IL','1','Dunn','Allen','R','','Jr',NULL,NULL,'515 Martha Drive',0,'Franklin','OH','45005',NULL,'CY','39165','2003-11-16','M','',':RET:2106-3','N','021','DEN','623334','99734OH005000301','2014-01-01','2013-12-09 12:09:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:27'),(14040,11185,'Y','18','021','EC','A','','','AC','0001236577','0001236577','OH00000804356','IL','1','Openshaw','Garrett','','','','34','622127191','52 UNION ST',0,'OBERLIN','OH','44074','1021','CY','39093','1988-02-22','M','U',':RET:2106-3','N','021','HLT','2260223','52664OH152001001','2014-01-01','2013-12-23 15:50:15','0.00',NULL,NULL,'138.84','138.84','R-OH011','OH0','138.84',NULL,0,'2013-12-26 13:17:09'),(18391,14679,'Y','18','021','EC','A','','','AC','0000246475','0000246475','OH00002155114','IL','1','Ghrist','Michelle','','','','34','284862213','237 OPAL BLVD',0,'STEUBENVILLE','OH','43952','2330','CY','39081','1978-03-22','F','U',':RET:2106-3','N','021','DEN','2849573','99734OH005000301','2014-02-01','2014-01-15 17:09:02','0.00',NULL,NULL,'59.76','59.76','R-OH016','OH0','0.00',NULL,0,'2014-01-16 08:45:40'),(19887,15862,'N','01','021','EC','A',NULL,NULL,'','0000448800','0000999875','','IL','1','Caughey','Illakate','','','','34','293802371','1270 ECHO ST NE',0,'CANTON','OH','44721','1629','CY','39151','1969-10-16','F','',NULL,'N','021','HLT','3270956','52664OH151001305','2014-03-01','2014-01-23 19:56:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2014-01-24 21:00:49'),(23308,18581,'N','19','021','EC','A',NULL,NULL,'','0000689734','0000299296','','IL','1','Walden','Charlotte','','','','34','296130929','405 BANK AVE',0,'CINCINNATI','OH','45217','1214','CY','39061','2002-12-01','F','',':RET:2034-7','N','021','DEN','2721161','99734OH005000301','2014-03-01','2014-02-13 11:28:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:00:19'),(25406,20156,'Y','18','021','EC','A','','','AC','0000733653','0000733653','OH00002078347','IL','1','Thompson','Desirae','','','','34','281842009','1810 CHAPEL HILL DR',0,'YOUNGSTOWN','OH','44511','1223','CY','39099','1979-05-10','F','M',':RET:2054-5','N','021','DEN','2768909','99734OH005000401','2014-04-01','2014-02-24 23:08:45','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-02-25 21:30:59'),(28992,22948,'Y','18','024','14','A','','','TE','0000177685','0000177685','','IL','1','Campton','Duane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-06-08','M','',NULL,NULL,NULL,'','3909716','','2014-03-08','2014-03-09 18:58:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:01:15'),(1055,864,'N','01','021','EC','A',NULL,NULL,'','0000247917','0001093961','','IL','1','Watson','Patsy','S','','','34','457824523','6135 LA COSA DR',0,'DALLAS','TX','75248','4924','CY','48113','1950-05-04','F','',':RET:2106-3','N','021','DEN','365095','33348TX002000201','2014-01-01','2013-12-03 12:46:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:16:08'),(5611,4454,'Y','18','021','EC','A','','','AC','0000546438','0000546438','OH00001035869','IL','1','Stadtler','Derik','','','','34','276886831','2824 West Edgerton',0,'Broadview Heights','OH','44147',NULL,'CY','39035','1982-01-14','M','U',':RET:2106-3','N','021','DEN','10821','99734OH005000401','2014-01-01','2013-11-25 23:15:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:34'),(21308,17027,'Y','18','021','EC','A','','','AC','0001510415','0001510415','LA00002484597','IL','1','Baker','Oscille','','','','34','435514742','7741 BURKE RD',0,'NEW ORLEANS','LA','70127','1109','CY','22071','1980-07-25','F','U',':RET:2054-5','N','021','DEN','3079542','18575LA002000201','2014-03-01','2014-02-04 11:07:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-04 21:00:16'),(21067,16833,'Y','18','021','EC','A','','','AC','0000969472','0000969472','OH00002156460','IL','1','Atzenhoefer','Kristen','','','','34','289927183','5998 ALMINA DR',0,'GALLOWAY','OH','43119','9299','CY','39049','1990-01-04','F','U',':RET:2106-3','N','021','DEN','3221961','99734OH005000401','2014-03-01','2014-02-01 19:30:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-02 19:00:15'),(4435,3525,'Y','18','021','EC','A','','','AC','0001225689','0001225689','OH00000272739','IL','1','Hanzel','Matthew','Alan','','','34','277887924','211 6TH ST',0,'TORONTO','OH','43964','1461','CY','39081','1987-12-12','M','R',':RET:2106-3','N','021','DEN','465277','99734OH005000301','2014-01-01','2013-12-11 18:40:36','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-25 22:01:59'),(20164,16091,'Y','18','021','EC','A','','','AC','0000393706','0000393706','OH00002003890','IL','1','matar','anwar','','','','34','300980657','1218 BUCKINGHAM GATE BLVD',0,'CUYAHOGA FALLS','OH','44221','5327','CY','39153','1979-03-14','M','M',NULL,'N','021','DEN','3243691','99734OH005000301','2014-03-01','2014-01-27 16:07:36','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-27 21:01:11'),(19540,15574,'Y','18','024','14','A','','','TE','0000494433','0000494433','','IL','1','Crabtree','Donald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-10-24','M','',NULL,NULL,NULL,'','1939081','','2014-01-22','2014-01-22 13:12:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:24'),(3063,2461,'Y','18','021','EC','A','','','AC','0000171575','0000171575','LA00000345072','31','1','Jordan','Debra','','','','34','435359554','PO Box 899',0,'Plaquemine','LA','70765',NULL,'CY','22047','1962-12-03','F','U',':RET:2054-5','N','021','DEN','506236','18575LA002000201','2014-01-01','2013-12-06 13:13:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:19:13'),(18416,14692,'Y','18','021','EC','A','','','AC','0001462810','0001462810','LA00001440638','IL','1','Leopaul','Kendall','','','','34','439250222','701 W Gloria Switch Rd',0,'Lafayette','LA','70507',NULL,'CY','22055','1975-01-02','M','U',':RET:2054-5','N','021','DEN','1647792','18575LA002000201','2014-02-01','2014-01-14 21:49:02','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-16 08:45:50'),(16550,13240,'Y','18','021','EC','A','','','AC','0001202213','0001202213','LA00002312445','IL','1','DELVALLE','ANGELA','M','','','34','437452243','9012 blom blvd',0,'shreveport','LA','71118',NULL,'CY','22017','1966-02-18','F','U',':RET:1002-5','T','021','DEN','1932829','18575LA002000101','2014-02-01','2014-01-04 20:43:44','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,1,'2014-01-07 10:22:42'),(13922,11102,'N','01','021','EC','A',NULL,NULL,'','0001239125','0001121390','','IL','1','Gilbert','Jullianne','','','','34','299542140','2845 ELSIE AVE',0,'TOLEDO','OH','43613','3337','CY','39095','1951-07-05','F','',':RET:2106-3','N','021','HLT','2326936','92036OH003002605','2014-01-01','2013-12-23 11:19:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','585.04',NULL,0,'2013-12-26 13:14:12'),(9728,7704,'N','01','021','EC','A',NULL,NULL,'','0000855599','0000882813','','IL','1','Stephens','Jeanie','','','','34','263311009','10810 WESTLEY CHAPEL RD',0,'CROTON','OH','43013','9724','CY','39089','1957-09-08','F','',NULL,'N','021','DEN','105179','99734OH005000301','2014-01-01','2013-11-15 06:45:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:37'),(8902,7059,'Y','18','021','EC','A','','','AC','0000396145','0000396145','OH00000296335','IL','1','Phillips','Brenda','','','','34','268620475','426 S HIGH ST',0,'HEBRON','OH','43025','9410','CY','39089','1954-08-26','F','M',':RET:2106-3','N','021','DEN','1631920','99734OH005000401','2014-01-01','2013-12-17 19:50:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:18'),(2083,1705,'Y','18','024','14','A','','','TE','0000125376','0000125376','','IL','1','Canterbury','Elizabeth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-09-19','F','',NULL,NULL,NULL,'','601159','','2013-12-10','2013-12-10 11:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 19:16:40'),(23264,18549,'Y','18','021','EC','A','','','AC','0000055905','0000055905','OH00002247226','IL','1','Sand','Cynthia','','','','34','271489368','25685 RUSTIC LN',0,'WESTLAKE','OH','44145','5474','CY','39035','1949-10-11','F','M',':RET:2106-3','N','021','DEN','2705820','99734OH005000301','2014-03-01','2014-02-13 07:27:07','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00','CIC',0,'2014-02-13 21:30:11'),(26019,20635,'Y','18','024','14','A','','','TE','0000231927','0000231927','','IL','1','davenport','rebecca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-28','F','',NULL,NULL,NULL,'','2446753','','2014-03-13','2014-02-26 13:03:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-26 21:02:14'),(26377,20925,'Y','18','024','14','A','','','TE','0001606820','0001606820','','IL','1','McMorris','Bradley',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-11-02','M','',NULL,NULL,NULL,'','1897506','','2014-03-31','2014-02-26 11:38:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:00:17'),(27093,21449,'Y','18','021','EC','A','','','AC','0000720248','0000720248','OH00002618864','IL','1','Litvin','Lorraine','','','','34','279786913','121 SHIAWASSEE AVE',0,'FAIRLAWN','OH','44333','3733','CY','39153','1965-11-30','F','U',NULL,'N','021','HLT','3507613','52664OH151001304','2014-04-01','2014-03-03 14:46:19','108.00',NULL,NULL,'364.62','256.62','R-OH012','OH0','364.62',NULL,0,'2014-03-03 21:30:18'),(17250,13803,'Y','18','021','EC','A','','','AC','0000335176','0000335176','OH00001621548','IL','1','janovyak','jeffrey','','','','34','286945543','1690 AMERICANA CT',0,'COLUMBUS','OH','43229','1430','CY','39049','1988-05-11','M','M',':RET:2106-3','N','021','DEN','1758434','99734OH005000301','2014-02-01','2014-01-09 20:36:26','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:23:11'),(18097,14456,'Y','18','021','EC','A','','','AC','0002158532','0002158532','LA00002439570','IL','1','Black','Annie','','','','34','439130536','807 DeLouche St.',0,'Monroe','LA','71202',NULL,'CY','22073','1957-08-09','F','U',':RET:2106-3','N','021','DEN','2752839','18575LA002000201','2014-02-01','2014-01-14 14:58:47','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-15 02:07:33'),(20658,16509,'Y','18','021','EC','A','','','AC','0000244858','0000244858','TX00001387931','IL','1','BULTER','MARIA','','','','34','372609998','315 S 35TH ST',0,'TEMPLE','TX','76504','4022','CY','48027','1957-08-18','F','M',NULL,'N','021','DEN','2701445','33348TX002000201','2014-03-01','2014-01-30 17:04:29','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-30 21:00:42'),(19617,15636,'Y','18','024','14','A','','','TE','0000818542','0000818542','','IL','1','Muntz','Diane',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-03-17','F','',NULL,NULL,NULL,'','498216','','2014-01-22','2014-01-22 11:21:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:53'),(19515,15555,'Y','18','021','EC','A','','','AC','0000063734','0000063734','OH00002325819','IL','1','jodrey','tina','','','','34','281808150','6634 CHESTNUT ST',0,'CINCINNATI','OH','45227','3605','CY','39061','1968-08-05','F','R',':RET:2106-3','N','021','DEN','1851920','99734OH005000401','2014-03-01','2014-01-21 20:22:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-23 03:02:16'),(24528,19484,'N','01','021','EC','A',NULL,NULL,'','0000598466','0001107895','','IL','1','TILLEY','ROGER','','','','34','449068393','1453 MARYLAND DR',0,'CORPUS KRISTY','TX','78415',NULL,'CY','48355','1954-05-19','M','',NULL,'N','021','DEN','2681008','33348TX002000201','2014-04-01','2014-02-19 16:31:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:59:38'),(26777,21221,'N','01','021','EC','A',NULL,NULL,'','0000395046','0000693703','','IL','1','Elwood','Jake','Kyle','','','34','466517702','702 E HUBBARD ST',0,'LINDALE','TX','75771','3323','CY','48423','1980-12-24','M','',':RET:2106-3','N','021','DEN','2646766','33348TX002000201','2014-03-01','2014-02-28 21:04:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-01 21:00:11'),(27694,21902,'Y','18','021','EC','A','','','AC','0000644401','0000644401','TX00003603138','IL','1','Pacheto','Julio','','','','34','455533772','910 NUECES ST',0,'ROBSTOWN','TX','78380','2147','CY','48355','1966-08-05','M','U',NULL,'N','021','DEN','3634033','33348TX002000201','2014-04-01','2014-03-05 11:35:27','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-03-05 21:30:45'),(28726,22734,'Y','18','021','EC','A','','','AC','0001988771','0001988771','LA00003484688','IL','1','Petry','Angela','','','','34','435610289','5306 ROLAND FARM RD',0,'ERATH','LA','70533','5546','CY','22113','1969-05-03','F','U',':RET:2106-3','N','021','DEN','4180349','18575LA002000101','2014-04-01','2014-03-08 18:38:55','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-09 21:00:00'),(29212,23119,'Y','18','021','EC','A','','','AC','0001223240','0001223240','OH00002734540','IL','1','AYAD','HESHAM','','','','34','282842038','3540 QUEENSWOOD BLVD',0,'TOLEDO','OH','43606','1136','CY','39095','1962-01-01','M','M',NULL,'T','021','HLT','4057721','92036OH003002604','2014-04-01','2014-03-10 14:37:55','414.00',NULL,NULL,'836.90','422.90','R-OH001','OH0','457.11','CIC',0,'2014-03-10 21:30:16'),(893,740,'Y','18','021','EC','A','','','AC','0000745424','0000745424','OH00000574721','IL','1','Horner','Jon','','','','34','270542506','250 MUNTZ ST',0,'HILLSBORO','OH','45133','1513','CY','39071','1950-10-19','M','M',':RET:2106-3','N','021','HLT','2190355','92036OH005000601','2014-01-01','2013-12-16 12:42:33','626.00',NULL,NULL,'633.70','7.70','R-OH005','OH0','633.70',NULL,0,'2013-12-25 18:08:03'),(20095,16032,'N','01','021','EC','A',NULL,NULL,'','0002050238','0001600428','','IL','1','Madere','Ashley','Elizabeth','','','34','439793039','6788 HIGHWAY 996',0,'BELLE ROSE','LA','70341','5351','CY','22007','1990-06-23','F','',':RET:2106-3','N','021','DEN','1664313','18575LA002000201','2014-03-01','2014-01-27 00:49:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-27 21:00:32'),(3017,2426,'Y','18','021','EC','A','','','AC','0000199625','0000199625','OH00000860448','IL','1','Moore','Joan','','','','34','280988392','131 Manning Road',0,'Mogadore','OH','44260',NULL,'CY','39153','1995-01-24','F','U',':RET:2106-3','N','021','HLT','612198','52664OH151001301','2014-01-01','2013-12-06 12:29:28','44.20',NULL,NULL,'141.61','97.41','R-OH012','OH0','141.61',NULL,0,'2013-12-25 20:18:04'),(21909,17497,'Y','18','021','EC','A','','','AC','0000247933','0000247933','OH00002231387','IL','1','Trubee','Ronald','','','','34','293528699','586 EAGLE CREEK RD',0,'WEST UNION','OH','45693','9696','CY','39001','1951-11-14','M','M',':RET:2106-3','N','021','HLT','3512397','92036OH001000601','2014-03-01','2014-02-06 14:36:23','257.00',NULL,NULL,'743.93','486.93','R-OH005','OH0','743.93',NULL,0,'2014-02-06 21:01:52'),(21797,17409,'Y','18','021','EC','A','','','AC','0000433936','0000433936','OH00001531859','IL','1','Smith','Mark','','','','34','270721592','2006 KENSINGTON DR',0,'SAINT MARYS','OH','45885','1388','CY','39011','1965-08-17','M','M',':RET:2106-3','N','021','HLT','3599490','92036OH004001501','2014-03-01','2014-02-06 06:16:15','314.00',NULL,NULL,'648.95','334.95','R-OH002','OH0','289.34',NULL,0,'2014-02-06 21:00:48'),(3174,2552,'Y','18','021','EC','A','','','AC','0000647043','0000647043','OH00000631352','IL','1','Broadwater','Carol','','','','34','272686844','1229 Brown Street',0,'Akron','OH','44301',NULL,'CY','39153','1959-10-17','F','M',':RET:2106-3','T','021','HLT','447869','52664OH151001301','2014-01-01','2013-11-18 17:26:49','316.00',NULL,NULL,'547.54','231.54','R-OH012','OH0','547.54',NULL,0,'2013-12-25 20:31:37'),(4127,3295,'N','01','021','EC','A',NULL,NULL,'','0000739010','0000680825','','IL','1','Harmon','Reginald','H','','','34','285546712','1439 ROSEDALE DR',0,'DAYTON','OH','45406','4743','CY','39113','1952-02-27','M','',':RET:2054-5','N','021','DEN','2080595','99734OH005000301','2014-01-01','2013-12-16 23:58:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:18'),(5188,4115,'N','01','021','EC','A',NULL,NULL,'','0000908014','0001190041','','IL','1','morris','gregory','steven','','','34','271529934','6652 ECHO VLY',0,'MAUMEE','OH','43537','9669','CY','39095','1952-08-03','M','',':RET:2106-3','N','021','DEN','2086903','99734OH005000401','2014-01-01','2013-12-19 13:30:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:03:42'),(7566,5989,'Y','18','021','EC','A','','','AC','0000926251','0000926251','OH00000596304','IL','1','rist','john','','','','34','279527432','606 adams street box 97',0,'Middle Point','OH','45863',NULL,'CY','39161','1966-09-14','M','R',':RET:2106-3','N','021','HLT','579131','92036OH004001501','2014-01-01','2013-12-15 09:59:50','0.00',NULL,NULL,'276.60','276.60','R-OH002','OH0','276.60',NULL,0,'2013-12-26 02:33:37'),(7763,6149,'Y','18','021','EC','A','','','AC','0000045757','0000045757','OH00001241975','IL','1','Lee','Bomsik',NULL,NULL,NULL,NULL,NULL,'1914 N NANTUCKET DR',0,'LORAIN','OH','44053','3224','CY','39093','1963-09-16','M','M',':RET:2040-4','T','021','DEN','2402355','99734OH005000401','2014-01-01','2013-12-20 18:41:57','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:48'),(9563,7580,'N','19','021','EC','A',NULL,NULL,'','0000718911','0001249580','','S1','1','Pushkaran','Suvarnamala','Hope','','','34','370697293','1395 STABLEVIEW CIR',0,'MAINEVILLE','OH','45039','7916','CY','39165','2013-09-06','F','',':RET:2029-7','N','021','DEN','1600650','99734OH005000301','2014-01-01','2013-12-21 16:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:37'),(24027,19109,'Y','18','024','14','A','','','TE','0000055973','0000055973','','IL','1','Al Baff','Fadi',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-06','M','',NULL,NULL,NULL,'','2813412','','2014-02-15','2014-02-15 09:26:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-15 22:00:50'),(24522,19480,'Y','18','021','EC','A','','','AC','0001040549','0001040549','TX00002352710','IL','1','Jakubowski','Brenda','','','','34','430211733','40 Green Oak Circle',0,'Nash','TX','75569',NULL,'CY','48037','1962-05-06','F','U',':RET:2054-5','N','021','DEN','2674350','33348TX002000201','2014-04-01','2014-02-19 14:59:36','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-20 03:57:51'),(23616,18809,'Y','18','021','EC','A','','','AC','0001131489','0001131489','OH00001470952','IL','1','JARZYNSKI','DIANA','L','','','34','282627012','223 LONGDALE AVE.',0,'TOLEDO','OH','43605',NULL,'CY','39095','1957-02-25','F','U',':RET:2106-3','N','021','HLT','2967991','92036OH002002601','2014-03-01','2014-02-13 15:05:38','237.00',NULL,NULL,'548.79','311.79','R-OH001','OH0','548.79',NULL,0,'2014-02-13 22:03:15'),(26274,20841,'Y','18','021','EC','A','','','AC','0001903464','0001903464','LA00003222916','IL','1','Crocker','Stacie','Suzette','','','34','438678935','158 BLUNT MILL RD',0,'GRAND CANE','LA','71032','5500','CY','22031','1984-02-07','F','M',':RET:2106-3','N','021','DEN','2883092','18575LA002000101','2014-03-01','2014-02-26 19:26:14','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-28 06:31:17'),(26522,21032,'N','01','021','EC','A',NULL,NULL,'','0000294433','0000295517','','IL','1','Dietrich','Kara','M','','','34','296660761','320 W 5TH ST',0,'PORT CLINTON','OH','43452','1826','CY','39123','1974-11-15','F','',NULL,'N','021','HLT','2621755','92036OH003002706','2014-03-01','2014-02-28 14:37:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','256.98','CIC',0,'2014-02-28 21:00:24'),(26639,21123,'Y','18','021','EC','A','','','AC','0001102742','0001102742','TX00002675945','IL','1','TERRAZAS','JAVIER','','','','34','451654226','339 JUDGEBEAN CIRCLE',0,'CLINT','TX','79836',NULL,'CY','48141','1983-07-03','M','M',':RET:2106-3','N','021','DEN','3756073','33348TX002000201','2014-04-01','2014-02-28 17:36:50','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-02-28 21:31:02'),(6686,5302,'Y','18','021','EC','A','','','AC','0000728670','0000728670','OH00000328736','IL','1','Palmer','Boyd','','','','34','213211293','401 SILVERWOOD FARMS DR',0,'LEBANON','OH','45036','8314','CY','39165','1982-03-03','M','M',':RET:2106-3','N','021','DEN','125151','99734OH005000401','2014-01-01','2013-11-05 13:27:58','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:01:31'),(5960,4721,'Y','18','021','EC','A','','','AC','0000599756','0000599756','OH00001262786','IL','1','Painter','Amy','','','','34','274828099','4333 Aaron Ct',0,'Cincinnati','OH','45241',NULL,'CY','39017','1967-10-03','F','M',':RET:2106-3','N','021','HLT','1566099','92036OH005001201','2014-01-01','2013-12-23 22:11:15','45.00',NULL,NULL,'1022.26','977.26','R-OH004','OH0','322.00',NULL,0,'2013-12-25 23:51:23'),(20609,16467,'Y','18','024','14','A','','','TE','0000001066','0000001066','','IL','1','Cegelski','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-22','F','',NULL,NULL,NULL,'','1989294','','2014-01-30','2014-01-30 16:10:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:16'),(20411,16302,'Y','18','021','EC','A','','','AC','0000394909','0000394909','TX00001364044','IL','1','Smith','Evelyn','','','','34','480156292','418 W. Congress St.',0,'Denton','TX','76201',NULL,'CY','48121','1988-05-17','F','U',':RET:2106-3','N','021','DEN','3036435','33348TX002000201','2014-03-01','2014-01-29 16:45:41','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-29 21:00:25'),(19991,15947,'Y','18','021','EC','A','','','AC','0000287123','0000287123','OH00001950177','S1','1','Fowler','John','Reginald','','','34','290045438','8490 EAGLE PASS DR',0,'HUBER HEIGHTS','OH','45424','1312','CY','39113','1999-12-12','M','U',':RET:2106-3','N','021','DEN','3128021','99734OH005000101','2014-03-01','2014-01-25 14:13:13','0.00',NULL,NULL,'27.59','27.59','R-OH003','OH0','27.59',NULL,0,'2014-01-25 19:00:20'),(6557,5198,'Y','18','021','EC','A','','','AC','0000204004','0000204004','TX00001296871','IL','1','DYER','JAMIE','LYNNE','','','34','453578667','503 MEADOW DR',0,'ROCKDALE','TX','76567','2511','CY','48331','1982-04-23','F','U',':RET:2106-3','N','021','DEN','781863','33348TX002000201','2014-01-01','2013-12-11 13:13:06','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:19'),(18428,14702,'Y','18','021','EC','A','','','AC','0001616396','0001616396','LA00002178495','IL','1','Goodman-Daniel','Diane','','','','34','556894266','1937 General Pershing St',0,'New Orleans','LA','70115',NULL,'CY','22071','1971-04-17','F','M',':RET:2106-3','T','021','DEN','2154723','18575LA002000201','2014-02-01','2014-01-15 12:42:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-16 08:45:56'),(13215,10545,'N','01','021','EC','A',NULL,NULL,'','0000006115','0000226828','','IL','1','HERNANDEZ','ALFRED','','','','34','462499702','9100 Bradley Drive',0,'North Richland Hills','TX','76182',NULL,'CY','48439','1964-07-31','M','',NULL,'N','021','DEN','1547568','33348TX002000201','2014-01-01','2013-12-22 19:47:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:55:22'),(26662,21136,'Y','18','024','14','A','','','TE','0001320369','0001320369','','IL','1','JONES','ERICA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-09-29','F','',NULL,NULL,NULL,'','1459963','','2014-03-14','2014-02-27 18:45:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-28 21:31:12'),(1366,1131,'Y','18','021','EC','A','','','AC','0000697018','0000697018','TX00001013109','IL','1','Land','Lesley','','','','34','461351799','11519 DELL HOLLOW DR',0,'HOUSTON','TX','77066','5106','CY','48201','1975-07-14','F','R',':RET:2106-3','N','021','DEN','2102625','33348TX002000101','2014-01-01','2013-12-24 15:35:25','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-25 18:45:37'),(23017,18352,'Y','18','021','EC','A','','','AC','0002076091','0002076091','LA00001983082','IL','1','Mix','Cynthia','','','','34','434214267','301 GLENDA ST',0,'RAYVILLE','LA','71269','3417','CY','22083','1964-07-24','F','U',':RET:2106-3','N','021','DEN','3367672','18575LA002000101','2014-03-01','2014-02-12 16:11:18','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-02-12 21:30:27'),(1838,1506,'N','01','021','EC','A',NULL,NULL,'','0001255030','0000228339','','IL','1','Parr','Kristen','N','','','34','300767471','2910 HECKMAN RD',0,'UNIONTOWN','OH','44685','9003','CY','39153','1978-03-14','F','',':RET:2106-3','N','021','HLT','2372187','52664OH151001306','2014-01-01','2013-12-24 11:32:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.52',NULL,0,'2013-12-25 18:57:35'),(1998,1637,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001155554','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','838014','33348TX002000101','2014-01-01','2013-11-19 23:08:18','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:02:07'),(21735,17356,'N','01','021','EC','A',NULL,NULL,'','0000311547','0000784007','','IL','1','HARRISON','GINA','','','','34','639962852','16640 HIGHWAY 254',0,'MINERAL WELLS','TX','76067','3272','CY','48363','1973-11-13','F','',':RET:2036-2','N','021','DEN','2841319','33348TX002000201','2014-03-01','2014-02-06 15:49:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-06 21:00:12'),(21278,17005,'Y','18','021','EC','A','','','AC','0000108192','0000108192','OH00002344509','IL','1','HEDGES','CONNIE','','','','34','273509683','3407 SHEARIN AVE',0,'LIMA','OH','45801',NULL,'CY','39003','1950-12-18','F','U',':RET:2106-3','N','021','HLT','2889445','92036OH005001506','2014-03-01','2014-02-03 16:59:21','616.00',NULL,NULL,'649.68','33.68','R-OH002','OH0','649.68',NULL,0,'2014-02-03 21:01:35'),(17522,14008,'N','01','021','EC','A',NULL,NULL,'','0001115964','0000245007','','IL','1','Warden','Dierdre','J','','','34','300440696','195 W Fountain Ave',0,'Delaware','OH','43015',NULL,'CY','39041','1955-11-02','F','',':RET:2106-3','N','021','DEN','2686419','99734OH005000401','2014-02-01','2014-01-12 11:09:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:37'),(16659,13330,'Y','18','021','EC','A','','','AC','0001260698','0001260698','LA00001978526','IL','1','Brass','Adenier','','','','34','613568494','108 WARDEN ST',0,'DELHI','LA','71232','2443','CY','22083','1992-05-17','F','U',':RET:2054-5','N','021','DEN','1719244','18575LA002000101','2014-02-01','2014-01-07 12:10:34','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-08 18:24:23'),(2052,1681,'Y','18','021','EC','A','','','AC','0000267504','0000267504','OH00001207540','IL','1','PERSON','KIMBERLY','','','','34','293782071','3390 WINTER LANE PARK',0,'COLUMBUS','OH','43232','7517','CY','39049','1965-10-18','F','U',NULL,'N','021','DEN','420462','99734OH005000301','2014-01-01','2013-12-09 18:27:11','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:15:54'),(14724,11756,'Y','18','021','EC','A','','','AC','0002343300','0002343300','LA00000108998','IL','1','Boal','Kelly','','','','34','472988484','18446 LAKE MYRTLE DR',0,'BATON ROUGE','LA','70817','9521','CY','22033','1975-06-01','F','R',':RET:2106-3','N','021','DEN','2386563','18575LA002000201','2014-02-01','2013-12-28 14:49:45','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,1,'2013-12-29 11:09:38'),(14692,11730,'Y','18','021','EC','A','','','AC','0001005723','0001005723','OH00001564836','IL','1','Mitchell','Denise','Marie','','','34','210448658','511 WELLMAN AVE',0,'GIRARD','OH','44420','2335','CY','39155','1954-10-10','F','U',':RET:2106-3','N','021','DEN','2276751','99734OH005000401','2014-02-01','2013-12-27 19:18:19','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,1,'2013-12-29 11:08:50'),(9650,7647,'Y','18','021','EC','A','','','AC','0001258643','0001258643','OH00000745196','IL','1','Manley','Ronese','','','','34','295628490','952 E VINE ST',0,'LIMA','OH','45804',NULL,'CY','39003','1958-04-03','F','U',':RET:2054-5','N','021','HLT','1768748','92036OH004001501','2014-01-01','2013-12-20 22:28:27','391.76',NULL,NULL,'394.64','2.88','R-OH002','OH0','394.64',NULL,0,'2013-12-26 04:38:45'),(2959,2383,'Y','18','021','EC','A','','','AC','0000027196','0000027196','TX00001016953','IL','1','Escobedo','Linda','Valdez','','','34','457987330','219 E Ave 1',0,'San Angelo','TX','76903',NULL,'CY','48451','1951-02-12','F','M',NULL,'N','021','DEN','643962','33348TX002000201','2014-01-01','2013-12-06 17:14:00','0.00',NULL,NULL,'29.22','29.22','R-TX018','TX0','14.61',NULL,0,'2013-12-25 20:16:42'),(24691,19600,'Y','18','024','14','A','','','TE','0000277949','0000277949','','IL','1','Rivas','Sergio',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-09-24','M','',NULL,NULL,NULL,'','3820792','','2014-02-18','2014-02-18 23:03:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-20 04:32:18'),(25182,19974,'Y','18','021','EC','A','','','AC','0000879542','0000879542','OH00001491651','IL','1','Curtis','Carmen','','','','34','275703062','4741 HOMEWOOD DR',0,'MENTOR','OH','44060','1029','CY','39085','1969-01-18','F','U',':RET:2079-2','N','021','DEN','3317979','99734OH005000401','2014-04-01','2014-02-21 14:26:31','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-21 22:00:34'),(25631,20333,'Y','18','021','EC','A','','','AC','0000385951','0000385951','OH00002386612','IL','1','THOMPSON','JEREMY','','','','34','298865478','6161 BRAMBLEWOOD PLACE',0,'MENTOR','OH','44060',NULL,'CY','39085','1980-05-18','M','U',':RET:2106-3','N','021','DEN','3170452','99734OH005000301','2014-04-01','2014-02-22 12:58:36','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-26 08:30:22'),(28460,22520,'Y','18','021','EC','A','','','AC','0001711449','0001711449','LA00003498768','IL','1','Robin','Tammy','D','','','34','438293434','4032 DARA BETH RD',0,'YOUNGSVILLE','LA','70592','6237','CY','22113','1964-11-23','F','M',':RET:2106-3','N','021','DEN','3438860','18575LA002000201','2014-04-01','2014-03-07 15:37:43','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2014-03-07 21:31:25'),(7839,6208,'N','01','021','EC','A',NULL,NULL,'','0000993963','0000374702','','IL','1','Tincher','Melissa','','','','34','300720833','6987 LESLEY LN',0,'MIDDLETOWN','OH','45042','3123','CY','39017','1962-03-02','F','',':RET:2106-3','T','021','DEN','2416177','99734OH005000301','2014-01-01','2013-12-19 21:54:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:34'),(22330,17831,'Y','18','021','EC','A','','','AC','0000968467','0000968467','TX00001927371','IL','1','GONZALEZ','SANDRA','Z','','','34','454067400','425 CAYMAN CT',0,'LAREDO','TX','78045','8004','CY','48479','1954-06-13','F','M',':RET:2106-3','N','021','DEN','3279085','33348TX002000101','2014-03-01','2014-01-22 22:06:20','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,0,'2014-02-10 11:01:00'),(22243,17754,'Y','18','021','EC','A','','','AC','0001260052','0001260052','OH00002531432','IL','1','WHEELER','PEGGY','','','','34','279962696','190 WHEELER RD',0,'PIKETON','OH','45661','9552','CY','39131','1986-02-23','F','U',':RET:2106-3','N','021','DEN','2864316','99734OH005000301','2014-03-01','2014-02-09 15:45:19','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-09 19:00:39'),(3815,3055,'Y','18','021','EC','A','','','AC','0001157541','0001157541','OH00000994855','IL','1','Gebremariam','Amanuel','','','','34','620196786','4269 State Route 44',0,'Rootstown','OH','44272',NULL,'CY','39133','1981-02-06','M','U',':RET:2054-5','N','021','DEN','196618','99734OH005000301','2014-01-01','2013-12-13 14:12:51','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:34:47'),(21808,17416,'Y','18','021','EC','A','','','AC','0000133352','0000133352','OH00002580054','IL','1','Croskey','Carrie','','','','34','288769878','123 N LYMAN ST',0,'WADSWORTH','OH','44281','1811','CY','39103','1965-10-10','F','U',':RET:2106-3','N','021','HLT','2888354','52664OH151001306','2014-03-01','2014-02-05 18:32:10','291.00',NULL,NULL,'364.62','73.62','R-OH012','OH0','364.62',NULL,0,'2014-02-06 21:00:53'),(20872,16680,'N','01','021','EC','A',NULL,NULL,'','0001153423','0000668966','','IL','1','potts','michael','','','','34','427214525','241 BROWN RD E',0,'CANTON','MS','39046','8705','CY','28089','1962-03-13','M','',':RET:2054-5','N','021','DEN','3352333','46300MS002000101','2014-03-01','2014-01-31 15:46:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-31 21:01:02'),(6773,5374,'N','19','021','EC','A',NULL,NULL,'','0000566575','0001008914','','IL','1','BACOVIN','MCKENZIE','L','','','34','278989990','10433 WALKINGFERN DR',0,'HARRISON','OH','45030','1654','CY','39061','1995-02-01','F','',':RET:2106-3','N','021','DEN','624387','99734OH005000301','2014-01-01','2013-11-25 15:36:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:16:41'),(6409,5080,'Y','18','021','EC','A','','','AC','0000012411','0000012411','OH00000902045','IL','1','Wheeler','Eric','','','','34','269929295','2567 Shiloh Park',0,'Westlake','OH','44145',NULL,'CY','39035','1978-01-14','M','M',':RET:2106-3','N','021','HLT','955981','92036OH005000806','2014-01-01','2013-12-10 18:29:33','352.00',NULL,NULL,'571.38','219.38','R-OH011','OH0','285.69',NULL,0,'2013-12-26 00:48:34'),(4054,3238,'Y','18','021','EC','A','','','AC','0000828220','0000828220','OH00000483768','IL','1','Ey','Laura','','','','34','299861123','6716 Whitehall Ave.',0,'Cincinnati','OH','45230',NULL,'CY','39061','1981-01-02','F','U',':RET:2106-3','N','021','DEN','2241297','99734OH005000401','2014-01-01','2013-12-17 15:12:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:30'),(17213,13774,'Y','18','021','EC','A','','','AC','0000631525','0000631525','OH00002297183','IL','1','GALAT','SHERI','LEE','','','34','273587998','528 ALLEN DR',0,'WADSWORTH','OH','44281','2123','CY','39103','1957-09-29','F','U',NULL,'N','021','HLT','2100577','52664OH151001305','2014-02-01','2014-01-08 15:31:11','363.00',NULL,NULL,'520.28','157.28','R-OH012','OH0','520.28',NULL,0,'2014-01-13 02:22:30'),(8968,7114,'Y','18','021','EC','A','','','AC','0000679522','0000679522','OH00000077642','IL','1','Hanahan','Robert','M','','','34','279544039','540 W REGENCY CIR',0,'CANFIELD','OH','44406','9630','CY','39099','1954-11-10','M','U',':RET:2106-3','T','021','DEN','2402225','99734OH005000401','2014-01-01','2013-12-18 14:40:44','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 04:04:01'),(15875,12712,'Y','18','021','EC','A','','','AC','0000873264','0000873264','MS00001472500','IL','1','DELEON','SOLEIL','','','','34','596263771','6130 KINROSS ST',0,'MOSS POINT','MS','39563','5624','CY','28059','1989-10-07','F','U',NULL,'N','021','DEN','2331202','46300MS002000101','2014-02-01','2014-01-02 13:37:08','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-03 02:05:13'),(15301,12234,'N','01','021','EC','A',NULL,NULL,'','0002134549','0002225554','','IL','1','Scott','Juanita','','','','34','435111529','184 DUNBAR ST',0,'GRAMBLING','LA','71245','2206','CY','22061','1963-10-18','F','',':RET:2054-5','N','021','DEN','2539922','18575LA002000201','2014-02-01','2013-12-31 20:03:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:22:49'),(28537,22586,'Y','18','021','EC','A','','','AC','0001213360','0001213360','TX00002548460','IL','1','FUENTES','ROBERT','','','Sr','34','462969846','227 STAR ST',0,'HEREFORD','TX','79045',NULL,'CY','48117','1955-01-09','M','M',NULL,'T','021','DEN','3549231','33348TX002000101','2014-04-01','2014-03-07 11:21:01','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2014-03-07 21:32:12'),(2323,1889,'Y','18','021','EC','A','','','AC','0000914738','0000914738','TX00000787014','31','1','Witt','Cody','','','','34','627121206','PO BOX 3081',0,'Big Spring','TX','79721',NULL,'CY','48227','1985-11-12','M','U',':RET:2106-3','N','021','DEN','656255','33348TX002000201','2014-01-01','2013-12-09 08:00:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:27'),(3633,2907,'Y','18','021','EC','A','','','AC','0000365556','0000365556','MS00000123548','IL','1','MYERS','ED','','','','34','538527764','303 DIXIE AVE',0,'HATTIESBURG','MS','39401','4827','CY','28035','1949-10-04','M','U',NULL,'N','021','DEN','106953','46300MS002000201','2014-01-01','2013-12-13 17:20:05','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 21:30:11'),(21075,16841,'Y','18','021','EC','A','','','AC','0000418918','0000418918','OH00002083400','S3','1','Meek','Theresa','Wayne','','','34','280068745','2152 LAVENHAM RD',0,'REYNOLDSBURG','OH','43068','3424','CY','39049','2001-05-07','M','U',':RET:2106-3','N','021','DEN','2786417','99734OH005000401','2014-03-01','2014-02-02 12:44:38','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','15.78',NULL,0,'2014-02-02 19:00:19'),(4316,3430,'Y','18','021','EC','A','','','AC','0000665622','0000665622','OH00001011590','IL','1','PANTON','LUCILLE','','','','34','730104027','1110 HAYWARD CIR',0,'MILFORD','OH','45150',NULL,'CY','39025','1968-07-23','F','M',':RET:2054-5','N','021','HLT','1795236','92036OH004000601','2014-01-01','2013-12-17 08:40:28','509.00',NULL,NULL,'641.09','132.09','R-OH005','OH0','249.26',NULL,0,'2013-12-25 21:52:40'),(6088,4825,'Y','18','021','EC','A','','','AC','0000870593','0000870593','OH00000336466','IL','1','Hilliard','Stephone','','','','34','279605450','1098 MOUNT VERNON AVE',0,'AKRON','OH','44310','1102','CY','39153','1964-11-30','M','U',':RET:2054-5','T','021','HLT','1083745','52664OH151001306','2014-01-01','2013-12-01 12:53:51','324.00',NULL,NULL,'437.52','113.52','R-OH012','OH0','437.52',NULL,0,'2013-12-26 00:02:39'),(9086,7210,'Y','18','021','EC','A','','','AC','0000759701','0000759701','OH00000704646','IL','1','Payne','Justin','','','','34','290785901','203.5 N Main St',0,'Bowling Green','OH','43402',NULL,'CY','39173','1981-05-03','M','U',':RET:2106-3','T','021','DEN','1535388','99734OH005000301','2014-01-01','2013-12-18 10:03:49','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-26 04:06:57'),(18759,14947,'Y','18','021','EC','A','','','AC','0000042185','0000042185','TX00001813898','IL','1','Morris','Rebecca','','','','34','452279330','12723 MANORWOOD LN',0,'CYPRESS','TX','77429','3648','CY','48201','1960-02-10','F','M',NULL,'N','021','DEN','1389650','33348TX002000101','2014-02-01','2014-01-15 21:07:42','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-17 03:35:46'),(22266,17772,'Y','18','021','EC','A','','','AC','0000434449','0000434449','TX00002043595','IL','1','Mele','Vincent','Andre','','','34','153787891','3609 CALDERA BLVD',0,'MIDLAND','TX','79707','2872','CY','48329','1985-10-21','M','M',':RET:2106-3','N','021','DEN','2742546','33348TX002000201','2014-03-01','2014-01-18 18:53:25','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2014-02-10 11:00:11'),(15156,12115,'Y','18','021','EC','A','','','AC','0000116595','0000116595','OH00000996923','IL','1','Ustaszewski','John','','','','34','298623224','3201 Arctic Avenue',0,'Lewis Center','OH','43035',NULL,'CY','39041','1966-02-15','M','R',NULL,'N','021','DEN','2566146','99734OH005000401','2014-02-01','2013-12-30 13:49:23','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,0,'2014-01-01 12:06:12'),(14830,11844,'Y','18','024','14','A','','','TE','0000740930','0000740930','','IL','1','Spencer','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-03-18','F','',NULL,NULL,NULL,'','1140518','','2013-12-23','2013-12-23 20:11:03',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2013-12-29 11:14:33'),(23220,18510,'N','01','021','EC','A',NULL,NULL,'','0000600452','0001146870','','IL','1','Starnes','William','M','','','34','413863051','5625 MAXWELL DR',0,'OLIVE BRANCH','MS','38654','9611','CY','28033','1954-08-13','M','',':RET:2106-3','N','021','DEN','2736810','46300MS002000201','2014-03-01','2014-02-12 12:35:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-12 21:32:19'),(3725,2977,'Y','18','021','EC','A','','','AC','0000195117','0000195117','OH00000372129','IL','1','Vorhees','Mark','','','','34','301448153','9700 PUDDENBAG RD',0,'GERMANTOWN','OH','45327','8832','CY','39113','1951-04-12','M','M',':RET:2106-3','N','021','DEN','802318','99734OH005000401','2014-01-01','2013-12-13 16:28:50','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:32:27'),(13106,10450,'Y','18','021','EC','A','','','AC','0000484787','0000484787','OH00000334809','IL','1','Hamrick','Robert','','','','34','278766564','3450 CLIFTON AVE',0,'CINCINNATI','OH','45220','1707','CY','39061','1964-01-05','M','U',NULL,'N','021','DEN','1805936','99734OH005000401','2014-01-01','2013-12-23 13:09:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:19'),(14248,11363,'Y','18','021','EC','A','','','AC','0000982526','0000982526','TX00001444331','IL','1','Triska','Richard','L','','Jr','34','462985016','815A Brazos Street',0,'Austin','TX','78701',NULL,'CY','48453','1951-02-14','M','R',':RET:2106-3','N','021','DEN','1884583','33348TX002000101','2014-02-01','2013-12-26 12:25:49','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-27 02:05:26'),(24039,19117,'Y','18','021','EC','A','','','AC','0000546512','0000546512','OH00002411979','IL','1','Soutendijk','Diana','','','','34','295581081','3299 State Route 82',0,'Mantua','OH','44255',NULL,'CY','39133','1957-10-01','F','U',NULL,'N','021','DEN','2755005','99734OH005000301','2014-03-01','2014-02-15 10:03:03','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-15 22:00:57'),(25553,20274,'Y','18','024','14','A','','','TE','0001662948','0001662948','','IL','1','COLBERT','TINICA','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-07-10','F','',NULL,NULL,NULL,'','3001074','','2014-02-23','2014-02-23 01:50:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-26 08:00:20'),(25804,20464,'Y','18','021','EC','A','','','AC','0000825956','0000825956','OH00002432115','IL','1','Fluegel','David','','','','34','041709195','524 CHAPEL RD',0,'AMELIA','OH','45102','9738','CY','39025','1963-08-30','M','M',':RET:2106-3','N','021','DEN','2843167','99734OH005000301','2014-04-01','2014-02-26 13:01:34','0.00',NULL,NULL,'87.78','87.78','R-OH005','OH0','0.00',NULL,0,'2014-02-26 21:00:18'),(26952,21356,'Y','18','021','EC','A','','','AC','0001010262','0001010262','OH00003133283','IL','1','DOWNEY','DEBORAH','','','','34','284507677','6206 VALLEY STREAM RD',0,'TOLEDO','OH','43615','2635','CY','39095','1953-12-16','F','U',NULL,'N','021','HLT','3700691','92036OH006002601','2014-04-01','2014-03-01 21:04:21','246.00',NULL,NULL,'419.70','173.70','R-OH001','OH0','419.70',NULL,0,'2014-03-03 01:00:27'),(27653,21872,'Y','18','021','EC','A','','','AC','0001171945','0001171945','OH00002764284','IL','1','Blanchard','Tate','','','','34','281901800','901 West Bennett Street',0,'Bridgeport','OH','43912',NULL,'CY','39013','1989-02-03','M','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3624813','99734OH005000401','2014-04-01','2014-03-05 13:21:24','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-05 21:30:22'),(5543,4398,'Y','18','021','EC','A','','','AC','0000198526','0000198526','OH00001161933','IL','1','Hale','Jennifer','','','','34','336628541','1642 MAPLE VIEW CT',0,'STREETSBORO','OH','44241','6344','CY','39133','1968-02-07','F','U',':RET:2106-3','N','021','HLT','670777','52664OH151001305','2014-01-01','2013-11-26 19:38:33','188.00',NULL,NULL,'322.02','134.02','R-OH012','OH0','322.02',NULL,0,'2013-12-25 23:15:52'),(22021,17582,'Y','18','021','EC','A','','','AC','0000660533','0000660533','TX00001524535','31','1','Campbell','Vicky','','','','34','466274533','PO Box 218',0,'Montague','TX','76251',NULL,'CY','48337','1970-01-21','F','U',':RET:2106-3','N','021','DEN','3397477','33348TX002000101','2014-03-01','2014-02-07 17:27:40','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-07 19:00:58'),(7698,6095,'Y','18','021','EC','A','','','AC','0000915637','0000915637','OH00000339622','IL','1','hyndman','mildred','','','','34','281523635','8113 state route 646',0,'bloomingdale','OH','43910',NULL,'CY','39081','1949-09-14','F','M',':RET:2106-3','N','021','DEN','2089433','99734OH005000401','2014-01-01','2013-12-20 08:49:10','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-26 03:01:11'),(13463,10737,'Y','18','021','EC','A','','','AC','0000951796','0000951796','OH00000954136','IL','1','young','thomas','','','','34','299868673','706 LESLIE DR',0,'WILMINGTON','OH','45177','7842','CY','39027','1987-07-10','M','M',':RET:2106-3','N','021','DEN','2549690','99734OH005000301','2014-01-01','2013-12-23 15:20:42','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 13:01:48'),(13929,11109,'Y','18','021','EC','A','','','AC','0000683384','0000683384','OH00000016123','IL','1','ELLIS','HEATHER','','','','34','275602683','6177 LOOKOVER CT',0,'TOLEDO','OH','43612',NULL,'CY','39095','1971-08-02','F','U',':RET:2106-3','N','021','HLT','2038135','92036OH004002601','2014-01-01','2013-12-22 23:53:34','104.00',NULL,NULL,'207.75','103.75','R-OH001','OH0','207.75',NULL,0,'2013-12-26 13:14:24'),(274,226,'Y','18','021','EC','A','','','AC','0000573584','0000573584','TX00000536092','IL','1','Mcdaniel','Leslie','','','','34','457955870','6408 CERRO CV',0,'AUSTIN','TX','78731','2610','CY','48453','1974-01-06','M','U',NULL,'N','021','DEN','518136','33348TX002000201','2014-01-01','2013-10-11 23:48:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 17:30:06'),(21853,17450,'N','01','021','EC','A',NULL,NULL,'','0000880558','0000001076','','IL','1','WIDMANN','DARLENE','','','','34','277586002','1690 TOWNSHIP RD',0,'TORONTO','OH','43964',NULL,'CY','39081','1954-11-09','F','',NULL,'N','021','DEN','3365252','99734OH005000301','2014-03-01','2014-02-05 20:06:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-06 21:01:16'),(21216,16954,'Y','18','021','EC','A','','','AC','0001993707','0001993707','LA00002017198','31','1','Tolliver','Sirmedra','','','','34','433356116','PO Box 147',0,'Sicily Island','LA','71368',NULL,'CY','22025','1978-04-20','F','M',':RET:2054-5','N','021','DEN','3239611','18575LA002000201','2014-03-01','2014-02-03 15:16:19','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-03 21:01:01'),(18969,15115,'Y','18','021','EC','A','','','AC','0000984871','0000984871','OH00001549719','IL','1','johnson','barbara','','','','34','297720569','580 JAMES AVE',0,'AKRON','OH','44312','3770','CY','39153','1960-11-04','F','M',':RET:2106-3','N','021','DEN','2597386','99734OH005000301','2014-03-01','2014-01-16 19:57:04','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-20 08:06:01'),(7932,6273,'Y','18','021','EC','A','','','AC','0001660851','0001660851','LA00000031521','IL','1','George','Michelle','','','','34','435291285','1480 St. Denis St.',0,'New Orleans','LA','70122',NULL,'CY','22071','1975-01-29','F','U',NULL,'N','021','DEN','1407636','18575LA002000201','2014-01-01','2013-12-20 09:44:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:39'),(15958,12774,'N','19','021','EC','A',NULL,NULL,'','0000608468','0000486956','','IL','1','HERNANDEZ','JACQUELINE','','','','34','281136880','9693 ADAIR CT',0,'CINCINNATI','OH','45251','2109','CY','39061','2007-06-11','F','',':RET:2106-3','N','021','DEN','2183743','99734OH005000301','2014-02-01','2014-01-03 13:23:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:17'),(23347,18606,'Y','18','021','EC','A','','','AC','0001220875','0001220875','OH00002567432','IL','1','Litten','Paulla','','','','34','273542498','415 N WATER ST',0,'LOUDONVILLE','OH','44842','1234','CY','39005','1955-03-03','F','U',NULL,'N','021','HLT','3556881','52664OH151001306','2014-03-01','2014-02-13 10:42:57','527.00',NULL,NULL,'568.22','41.22','R-OH012','OH0','568.22',NULL,0,'2014-02-13 22:00:40'),(26820,21255,'Y','18','021','EC','A','','','AC','0000341400','0000341400','OH00002957977','IL','1','CHAMBERS','BERNADNE','','','','34','299628641','7918 FAIRHOPE CT',0,'CINCINNATI','OH','45224','1315','CY','39061','1960-06-11','F','U',':RET:2054-5','N','021','DEN','3600048','99734OH005000401','2014-04-01','2014-03-01 11:14:43','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-01 21:00:34'),(27322,21634,'Y','18','021','EC','A','','','AC','0000804655','0000804655','TX00003595331','IL','1','Lewis','Evelyn','Olivia','','','34','451210869','875 Washington Blvd.',0,'Beaumont','TX','77705',NULL,'CY','48245','1964-08-01','F','M',':RET:2054-5','N','021','DEN','3075059','33348TX002000201','2014-04-01','2014-03-04 16:24:36','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-03-04 21:00:47'),(6798,5392,'Y','18','021','EC','A','','','AC','0001063197','0001063197','OH00001218535','IL','1','Martin','Mary','Kathern','','','34','271528454','4345 Darr Hopfinger Road',0,'Port Clinton','OH','43452',NULL,'CY','39123','1952-01-18','F','M',':RET:2106-3','N','021','HLT','34015','92036OH003002701','2014-01-01','2013-11-24 20:38:30','424.00',NULL,NULL,'572.23','148.23','R-OH006','OH0','572.23',NULL,0,'2013-12-26 01:17:17'),(3596,2883,'N','01','021','EC','A',NULL,NULL,'','0000124201','0000303356','','IL','1','HALL','MARY-ANNE','R','','','34','406155095','8421 COX RD',0,'WEST CHESTER','OH','45069','3339','CY','39017','1971-07-05','F','',':RET:2106-3','N','021','HLT','1679769','92036OH001001201','2014-01-01','2013-12-22 15:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','343.10',NULL,0,'2013-12-25 21:23:07'),(4380,3481,'Y','18','021','EC','A','','','AC','0000559423','0000559423','OH00000293616','IL','1','Brown','Tara','','','','34','274862699','11118 Clifton Blvd.',0,'Cleveland','OH','44102',NULL,'CY','39035','1976-02-13','F','U',':RET:2106-3','N','021','DEN','356739','99734OH005000401','2014-01-01','2013-12-12 09:11:42','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:00:35'),(20301,16206,'Y','18','024','14','A','','','TE','0000006179','0000006179','','IL','1','WOODS','KRISTI','SMITH',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-09-29','F','',NULL,NULL,NULL,'','2547270','','2014-01-27','2014-01-27 19:48:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:43'),(7450,5898,'Y','18','021','EC','A','','','AC','0000332362','0000332362','OH00000302634','IL','1','GREENWALD','JOHN','','','','34','275503097','17043 WHITNEY RD',0,'STRONGSVILLE','OH','44136','2416','CY','39035','1951-08-15','M','U',':RET:2106-3','N','021','DEN','131713','99734OH005000301','2014-01-01','2013-12-15 12:18:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:30:41'),(18298,14609,'Y','18','021','EC','A','','','AC','0000830659','0000830659','OH00001647948','IL','1','Klein','Cynthia','','','','34','287528841','403 NORTHWEST ST',0,'BELLEVUE','OH','44811','1024','CY','39143','1952-06-16','F','M',NULL,'N','021','DEN','1555873','99734OH005000401','2014-02-01','2014-01-15 10:01:45','0.00',NULL,NULL,'31.57','31.57','R-OH006','OH0','0.00',NULL,0,'2014-01-16 08:44:55'),(17579,14055,'Y','18','021','EC','A','','','AC','0000387298','0000387298','OH00002537371','IL','1','thind','narain','singh','','','34','059764062','8282 ROLLINGWOOD WAY',0,'WEST CHESTER','OH','45069','1822','CY','39017','1965-01-05','M','M',':RET:2029-7','N','021','DEN','2611524','99734OH005000401','2014-02-01','2014-01-13 14:21:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:05'),(8949,7097,'Y','18','021','EC','A','','','AC','0001194104','0001194104','OH00001056326','IL','1','Dabbs','Harland','','','','34','276680422','2839 Morningridge Drive',0,'Cincinnati','OH','45211',NULL,'CY','39061','1961-07-10','M','U',':RET:2054-5','N','021','DEN','1418465','99734OH005000401','2014-01-01','2013-12-18 11:41:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:03:31'),(13398,10692,'N','01','021','EC','A',NULL,NULL,'','0001214791','0000919387','','IL','1','Conter','Tina','','','','34','289645608','2058 CASA LOMA DR',0,'FAIRFIELD','OH','45014','4850','CY','39017','1963-08-26','F','',':RET:2106-3','N','021','DEN','1805895','99734OH005000301','2014-01-01','2013-12-23 08:30:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:16'),(16346,13084,'Y','18','021','EC','A','','','AC','0001066996','0001066996','OH00001722692','IL','1','Roby','Mary','','','','34','549313960','214 E. Ohio St',0,'Kenton','OH','43326',NULL,'CY','39065','1959-09-19','F','M',':RET:2106-3','N','021','DEN','2606032','99734OH005000301','2014-02-01','2014-01-06 18:03:56','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-01-07 04:02:21'),(23124,18430,'Y','18','021','EC','A','','','AC','0000319710','0000319710','OH00001532001','IL','1','CHAFFIN','ANGELA','','','','34','274649117','4252 SWEET CLOVER CT',0,'COLUMBUS','OH','43228','8448','CY','39049','1956-10-20','F','U',':RET:2106-3','N','021','DEN','3215583','99734OH005000401','2014-03-01','2014-02-12 12:44:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:25'),(27616,21841,'Y','18','021','EC','A','','','AC','0000837423','0000837423','TX00003752388','IL','1','PORTILLO','OLGA','MARINA','','','34','461955407','400 LINDA LN',0,'WEBSTER','TX','77598','5040','CY','48201','1959-02-01','F','U',NULL,'N','021','DEN','3236158','33348TX002000101','2014-04-01','2014-03-05 12:43:47','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15','CIC',0,'2014-03-05 21:00:31'),(2686,2176,'Y','18','021','EC','A','','','AC','0000510151','0000510151','TX00000550124','IL','1','Hall','Brian','','','','34','458952383','681 N. Bradford St.',0,'Gilmer','TX','75644',NULL,'CY','48459','1978-12-10','M','U',':RET:2054-5','N','021','DEN','1180161','33348TX002000201','2014-01-01','2013-12-01 19:15:56','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 19:47:22'),(7412,5865,'N','01','021','EC','A',NULL,NULL,'','0000970681','0000357649','','IL','1','Tarver','Carrie','Lynn',NULL,NULL,NULL,NULL,'7631 PRESIDIO SANDS',0,'BOERNE','TX','78015','6541','CY','48029','1979-08-15','F','',':RET:2106-3','N','021','DEN','1004649','33348TX002000201','2014-01-01','2013-10-28 17:27:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 02:16:45'),(20327,16230,'Y','18','024','14','A','','','TE','0000877801','0000877801','','IL','1','taylor','loveda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-08-16','F','',NULL,NULL,NULL,'','2262806','','2014-01-28','2014-01-28 17:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-28 21:00:59'),(18816,14987,'Y','18','021','EC','A','','','AC','0001212363','0001212363','OH00001713987','IL','1','Shteiwi','nazih','','','','34','286907535','5758 AUBERGER DR',0,'FAIRFIELD','OH','45014','3806','CY','39017','1954-09-01','M','M',':RET:2028-9','N','021','DEN','2204901','99734OH005000401','2014-02-01','2014-01-15 20:10:51','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:36:04'),(18637,14856,'Y','18','021','EC','A','','','AC','0000773160','0000773160','TX00001817640','IL','1','Terry Williams','Kenisha','','','','34','567897340','1645 74TH ST',0,'LUBBOCK','TX','79423','6241','CY','48303','1986-06-12','F','U',':RET:2054-5','N','021','DEN','2308957','33348TX002000201','2014-02-01','2014-01-15 22:25:57','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-17 03:35:04'),(17697,14142,'Y','18','021','EC','A','','','AC','0002019027','0002019027','LA00001665438','IL','1','DIXON','STELLA','','','','34','436190405','44156 HOOD RD',0,'HAMMOND','LA','70403','9453','CY','22105','1958-04-24','F','M',NULL,'N','021','DEN','1652944','18575LA002000201','2014-02-01','2014-01-13 13:30:53','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-14 01:33:02'),(6214,4925,'Y','18','021','EC','A','','','AC','0000893725','0000893725','TX00001047785','IL','1','Arreaga','Jose','Daniel','','','34','644487316','5515 gatewood st',0,'Houston','TX','77053',NULL,'CY','48201','1970-07-07','M','U',NULL,'N','021','DEN','613231','33348TX002000201','2014-01-01','2013-10-15 22:12:14','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:30:58'),(22097,17639,'Y','18','024','14','A','','','TE','0000121585','0000121585','','IL','1','HOLMANN','ELIZABETH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-10-08','F','',NULL,NULL,NULL,'','2810538','','2014-02-07','2014-02-07 19:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-08 19:00:28'),(3581,2872,'N','01','021','EC','A',NULL,NULL,'','0001225702','0000362498','','IL','1','Lowell','Ginger','','','','34','595101380','630 South West St.',0,'Hillsboro','OH','45133',NULL,'CY','39071','1970-10-08','F','',':RET:2106-3','N','021','HLT','2295943','92036OH006000601','2014-01-01','2013-12-22 08:50:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.02',NULL,0,'2013-12-25 21:22:44'),(9633,7631,'Y','18','024','14','A','','','TE','0000242703','0000242703','','IL','1','Kostoff','Thomas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-02-06','M','',NULL,NULL,NULL,'','2041647','','2013-12-21','2013-12-21 16:06:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:38:16'),(14288,11398,'Y','18','021','EC','A','','','AC','0000121544','0000121544','OH00000762829','IL','1','Koenitzer','Scott','R','','','34','279529504','504 E SOUTH ST',0,'AKRON','OH','44311','1848','CY','39153','1960-11-05','M','U',':RET:2106-3','N','021','HLT','1361267','52664OH152000901','2014-02-01','2013-12-26 10:18:43','333.21',NULL,NULL,'333.21','0.00','R-OH012','OH0','333.21',NULL,0,'2013-12-27 02:06:30'),(13748,10974,'Y','18','021','EC','A','','','AC','0000145384','0000145384','OH00001009642','IL','1','bentley','sandra','','','','34','240826832','2560 SHERWOOD DR',0,'LIMA','OH','45805','1426','CY','39003','1950-01-27','F','U',':RET:2054-5','N','021','HLT','1711686','92036OH004001501','2014-01-01','2013-12-23 11:17:22','467.00',NULL,NULL,'522.40','55.40','R-OH002','OH0','522.40',NULL,0,'2013-12-26 13:09:53'),(13269,10590,'Y','18','021','EC','A','','','AC','0000326733','0000326733','TX00000788723','IL','1','Long','Robert','Alan','','','34','461530839','6009 HARVARD ST',0,'AMARILLO','TX','79109','6707','CY','48381','1967-08-14','M','U',':RET:2106-3','N','021','DEN','2543647','33348TX002000201','2014-01-01','2013-12-23 12:19:45','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 12:56:50'),(23302,18577,'Y','18','021','EC','A','','','AC','0000278357','0000278357','OH00002539313','IL','1','WEBER','CYNTHIA','','','','34','283505366','4619 RUMPKE RD',0,'CINCINNATI','OH','45245','1131','CY','39025','1957-04-25','F','U',NULL,'N','021','DEN','2652121','99734OH005000301','2014-03-01','2014-02-13 07:28:09','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:00:15'),(24236,19247,'Y','18','021','EC','A','','','AC','0000705202','0000705202','OH00001912918','IL','1','Privett','Joni',NULL,NULL,NULL,NULL,NULL,'4579 georgeann lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','1959-02-23','F','M',NULL,'N','021','HLT','3717465','92036OH003000605','2014-04-01','2014-02-16 15:26:29','714.00',NULL,NULL,'999.84','285.84','R-OH005','OH0','499.92',NULL,0,'2014-02-16 19:00:37'),(25032,19850,'Y','18','021','EC','A','','','AC','0001792367','0001792367','LA00001718606','31','1','Ellzey','Jennifer','','','','34','437355870','p.o. box 261',0,'Livingston','LA','70754',NULL,'CY','22063','1977-08-21','F','M',':RET:2106-3','N','021','DEN','2861195','18575LA002000101','2014-04-01','2014-02-20 12:19:02','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-02-20 22:01:04'),(26597,21088,'Y','18','021','EC','A','','','AC','0000834329','0000834329','TX00003279899','IL','1','PEREZ','CLAUDIA','','','','34','635071419','155 HILLCREST LN',0,'LIBERTY HILL','TX','78642','4436','CY','48491','1986-05-16','F','M',NULL,'N','021','DEN','2929150','33348TX002000201','2014-04-01','2014-02-27 18:47:33','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-28 21:30:39'),(27926,22090,'Y','18','021','EC','A','','','AC','0000612584','0000612584','TX00003635118','IL','1','Strauder','Dana','Akeela','','','34','425456993','9000 Vantage Point Dr.',0,'Dallas','TX','75243',NULL,'CY','48113','1982-08-15','F','U',NULL,'N','021','DEN','3486506','33348TX002000201','2014-04-01','2014-03-06 00:48:01','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:22'),(28109,22248,'N','19','021','EC','A',NULL,NULL,'','0001019326','0000830698','','IL','1','Ulman','Trevor',NULL,NULL,NULL,NULL,NULL,'550 RAWLINS AVE',0,'AKRON','OH','44319','4343','CY','39153','1998-04-14','M','',':RET:2106-3','N','021','HLT','3177573','52664OH152000901','2014-04-01','2014-03-06 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-06 21:02:14'),(28169,22292,'Y','18','021','EC','A','','','AC','0001914754','0001914754','LA00002716684','IL','1','Montet','Mona','','','','34','433176456','1066 SAM CHAMPAGNE RD',0,'BREAUX BRIDGE','LA','70517','7137','CY','22099','1971-10-25','F','U',NULL,'T','021','DEN','4000201','18575LA002000101','2014-04-01','2014-03-06 16:59:57','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-06 21:02:47'),(29169,23088,'N','19','021','EC','A',NULL,NULL,'','0000201983','0000685900','','IL','1','Badowski','Mackenzie','Anne','','','34','801140595','303 S MAIN ST',0,'SPENCER','OH','44275','9747','CY','39103','2013-06-20','F','',':RET:2106-3','N','021','HLT','4310531','52664OH151001501','2014-05-01','2014-03-10 15:11:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-03-10 21:02:59'),(137,117,'N','19','021','EC','A',NULL,NULL,'','0000103864','0000505710','','IL','1','Wiandt','Jessica','A','','','34','297966159','7927 OVERTON RD',0,'BURBANK','OH','44214','9516','CY','39169','1994-03-02','F','',':RET:2106-3','N','021','HLT','6429','52664OH152000901','2014-01-01','2013-12-04 20:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 17:18:36'),(24327,19320,'Y','18','021','EC','A','','','AC','0000841279','0000841279','TX00002295944','IL','1','Powell','Elizabeth','','','','34','640185135','1211 BLUEBONNET DR',0,'MARBLE FALLS','TX','78654','4541','CY','48053','1990-08-10','F','M',NULL,'N','021','DEN','3150354','33348TX002000201','2014-04-01','2014-02-18 13:05:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:11'),(24765,19650,'Y','18','021','EC','A','','','AC','0000947441','0000947441','OH00002802438','IL','1','GARZA','EMILY','','','','34','280843026','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-04-26','F','M',':RET:2106-3','T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:43:28'),(26016,20632,'N','01','021','EC','A',NULL,NULL,'','0000707391','0000896499','','IL','1','OSUCH','DEBORAH','','','','34','550988311','319 W OLMOS DR',0,'SAN ANTONIO','TX','78212',NULL,'CY','48029','1956-11-09','F','',':RET:2106-3','N','021','DEN','3713786','33348TX002000101','2014-04-01','2014-02-26 10:46:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-26 21:02:12'),(28093,22235,'Y','18','021','EC','A','','','AC','0000608277','0000608277','MS00002629881','IL','1','Smith','Janice','Marie','','','34','426337150','1212 COVINGTON PARK DR',0,'JACKSON','MS','39212','5044','CY','28049','1964-03-28','F','U',':RET:2054-5','N','021','DEN','3970722','46300MS002000101','2014-04-01','2014-03-06 11:08:51','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-03-06 21:02:06'),(28900,22875,'Y','18','021','EC','A','','','AC','0000749402','0000749402','TX00003728942','31','1','VILLASENOR','ANA','P','','','34','449512982','PO BOX 2475',0,'EDINBURG','TX','78540',NULL,'CY','48215','1962-02-17','F','M',NULL,'N','021','DEN','3656256','33348TX002000201','2014-04-01','2014-03-10 16:37:12','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-10 21:00:20'),(1102,906,'Y','18','021','EC','A','','','AC','0000342698','0000342698','OH00000495604','IL','1','Thompson','Kimberly','','','','34','269547828','111 SHAFFER BLVD',0,'BRYAN','OH','43506','9184','CY','39171','1952-11-10','F','M',':RET:2106-3','N','021','DEN','767590','99734OH005000401','2014-01-01','2013-12-03 14:14:23','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:17:18'),(23214,18505,'N','19','021','EC','A',NULL,NULL,'','0000927348','0000683429','','IL','1','Duggins','Jeremy','Vince','','','34','276925088','1429 WAYNE RD',0,'WILMINGTON','OH','45177','1140','CY','39027','1990-05-19','M','',':RET:2106-3','N','021','HLT','3545034','92036OH004000601','2014-03-01','2014-02-12 14:55:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-02-12 21:32:15'),(4826,3824,'Y','18','021','EC','A','','','AC','0000566589','0000566589','OH00000924678','IL','1','Cooper','Robert','','','','34','287461542','6620 Bruce Road',0,'Celina','OH','45822',NULL,'CY','39107','1951-02-16','M','M',':RET:2106-3','N','021','HLT','1003762','92036OH002001501','2014-01-01','2013-12-08 13:58:57','1025.00',NULL,NULL,'1460.40','435.40','R-OH002','OH0','730.20',NULL,0,'2013-12-25 22:17:13'),(22186,17706,'N','19','021','EC','A',NULL,NULL,'','0000852787','0000851665','','IL','1','LINDE','WILLIAM','CONNOR','','','34','433754183','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1988-10-03','M','',':RET:2106-3','N','021','DEN','3361436','18575LA002000201','2014-03-01','2014-02-09 13:03:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-09 19:00:06'),(9038,7171,'N','19','021','EC','A',NULL,NULL,'','0000707603','0000004705','','IL','1','Heinz','Allison','','','','34','274961922','8483 TIFFIN CT',0,'MENTOR','OH','44060','2200','CY','39085','1993-01-07','F','',':RET:2106-3','N','021','HLT','1358081','52664OH151001306','2014-01-01','2013-12-18 15:08:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2013-12-26 04:05:45'),(18446,14716,'N','19','021','EC','A',NULL,NULL,'','0000618384','0000921935','','S1','1','Link','Edward','Glen','','III','34','281152348','1453 LANGDON DR',0,'SIDNEY','OH','45365','6202','CY','39149','2009-06-11','F','',':RET:2106-3','N','021','HLT','1806607','92036OH001000501','2014-02-01','2014-01-14 19:22:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','182.08',NULL,0,'2014-01-16 08:46:06'),(19393,15461,'Y','18','021','EC','A','','','AC','0000728745','0000728745','OH00002459871','IL','1','Kunkler','Richard','A','','','34','293784953','435 Shell Park road',0,'marysville','OH','43040',NULL,'CY','39159','1967-01-02','M','M',':RET:2106-3','N','021','DEN','3205122','99734OH005000401','2014-03-01','2014-01-21 11:44:23','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,1,'2014-01-22 03:22:49'),(24284,19285,'N','01','021','EC','A',NULL,NULL,'','0002311279','0002212049','','IL','1','Peaden','Gloria','C','','','34','435980320','3348 KNIGHTSBRIDGE PL',0,'HARVEY','LA','70058','7414','CY','22051','1956-11-27','F','',':RET:2054-5','N','021','DEN','3401596','18575LA002000201','2014-03-01','2014-02-17 22:55:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-18 21:30:08'),(1734,1441,'N','19','021','EC','A',NULL,NULL,'','0000813089','0000880516','','IL','1','Pressel','Jude','Nathaniel','','','34','275152583','1480 WAINSCOTT WAY',0,'DAYTON','OH','45414','5915','CY','39113','2009-02-03','M','',':RET:2106-3','N','021','DEN','1480239','99734OH005000301','2014-01-01','2013-12-24 11:00:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:26'),(22601,18051,'Y','18','021','EC','A','','','AC','0000039853','0000039853','OH00001922606','IL','1','Frail','Jamie','','','','34','293885648','10423 BAILEY RD',0,'WATERVILLE','OH','43566','9716','CY','39095','1981-11-13','F','M',':RET:2106-3','N','021','HLT','3051099','92036OH005002606','2014-03-01','2014-02-10 14:03:38','300.00',NULL,NULL,'470.53','170.53','R-OH001','OH0','230.68',NULL,0,'2014-02-10 21:32:15'),(9006,7146,'Y','18','021','EC','A','','','AC','0000449855','0000449855','OH00001297149','IL','1','YOUNGBLOOD','ROBERT','','','','34','293501386','4242 S HAMETOWN RD',0,'NORTON','OH','44203','5446','CY','39153','1953-07-14','M','M',':RET:2106-3','N','021','HLT','1429101','52664OH152000901','2014-01-01','2013-12-18 11:49:31','673.00',NULL,NULL,'868.49','195.49','R-OH012','OH0','443.31',NULL,0,'2013-12-26 04:05:00'),(9316,7386,'N','01','021','EC','A',NULL,NULL,'','0001803382','0001258154','','IL','1','Aulds','April','Joy','','','34','439438026','705 JOSEPH ST',0,'MONROE','LA','71201','2749','CY','22073','1978-04-13','F','',':RET:2106-3','N','021','DEN','2508809','18575LA002000101','2014-01-01','2013-12-21 11:53:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 04:30:22'),(14711,11746,'Y','18','021','EC','A','','','AC','0001151084','0001151084','OH00001262962','IL','1','GREEN','PAMELA','','','','34','275784407','4285 BOWMAN MEADOW DR',0,'CANAL WINCHESTER','OH','43110','7843','CY','39049','1969-08-07','F','U',':RET:2054-5','N','021','DEN','2386547','99734OH005000301','2014-02-01','2013-12-27 19:31:08','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,1,'2013-12-29 11:09:20'),(18946,15095,'N','01','021','EC','A',NULL,NULL,'','0000758335','0000753967','','IL','1','Jefferson','Rosetta','','','','34','432029568','507 MARTINDALE DR',0,'LANCASTER','TX','75146','3140','CY','48113','1950-05-30','F','',':RET:2054-5','N','021','DEN','2418478','33348TX002000201','2014-03-01','2014-01-17 10:34:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-20 08:05:46'),(15991,12799,'Y','18','021','EC','A','','','AC','0000194931','0000194931','TX00001902499','IL','1','Escareno','Michael','','','','34','461671889','2003 E PARKVIEW RD',0,'FORT STOCKTON','TX','79735','8900','CY','48371','1982-05-14','M','U',NULL,'T','021','DEN','2257163','33348TX002000201','2014-02-01','2014-01-03 12:12:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-04 02:01:15'),(18153,14497,'Y','18','021','EC','A','','','AC','0000085189','0000085189','OH00001940443','IL','1','Good','Craig','','','','34','271661745','217 S GREENLAWN AVE',0,'ELIDA','OH','45807','1339','CY','39003','1958-04-12','M','U',':RET:2106-3','N','021','HLT','2373919','92036OH004001501','2014-02-01','2014-01-14 16:48:01','300.00',NULL,NULL,'394.64','94.64','R-OH002','OH0','394.64',NULL,0,'2014-01-15 02:07:51'),(24149,19187,'N','01','021','EC','A',NULL,NULL,'','0000493282','0000081325','','IL','1','Coffey','Karen','','','','34','287606420','3124 LINDALE MOUNT HOLLY RD',0,'AMELIA','OH','45102','9703','CY','39025','1960-09-03','F','',':RET:2106-3','N','021','HLT','3285701','92036OH004000601','2014-03-01','2014-02-15 12:50:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','352.13',NULL,0,'2014-02-15 22:01:55'),(29060,23000,'Y','18','021','EC','A','','','AC','0000050751','0000050751','OH00003655255','IL','1','KOOSH','AIMEE','LYNN','','','34','280884988','3994 ROYAL RIVERPOOL DR',0,'UNIONTOWN','OH','44685',NULL,'CY','39153','1973-06-11','F','U',':RET:2106-3','N','021','DEN','4196871','99734OH005000401','2014-04-01','2014-03-10 17:19:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-10 21:01:51'),(288,238,'Y','18','021','EC','A','','','AC','0000622444','0000622444','TX00000396213','IL','1','Roselle','Daniel','','','','34','634014436','1026 HARMONY DR',0,'ABILENE','TX','79603','3014','CY','48441','1988-07-09','M','U',NULL,'T','021','DEN','217365','33348TX002000101','2014-01-01','2013-10-12 14:50:39','0.00',NULL,NULL,'50.04','50.04','R-TX001','TX0','25.02',NULL,0,'2013-12-25 17:30:28'),(7696,6094,'Y','18','021','EC','A','','','AC','0000224717','0000224717','OH00000625957','IL','1','RISDEN','ANITA','','','','34','293584848','7855 KESSLER FREDERICK RD',0,'TIPP CITY','OH','45371','9613','CY','39109','1960-02-21','F','M',':RET:2106-3','N','021','DEN','1736152','99734OH005000401','2014-01-01','2013-12-20 00:10:41','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:01:09'),(1978,1617,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000719499','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','209848','33348TX002000101','2014-01-01','2013-11-19 23:03:37','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:39'),(4196,3337,'N','19','021','EC','A',NULL,NULL,'','0000030526','0000689681','','S1','1','Gerber','Robert','','','','34','271062977','969 BROOK RD',0,'WADSWORTH','OH','44281','9057','CY','39103','2000-10-24','M','',':RET:2106-3','N','021','HLT','1768557','52664OH151001304','2014-01-01','2013-12-17 16:30:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 21:49:46'),(13720,10949,'Y','18','021','EC','A','','','AC','0000872037','0000872037','OH00001054468','IL','1','Thielenhaus','Douglas','','','','34','501744196','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1966-06-29','M','M',':RET:2106-3','N','021','HLT','1772509','52664OH151001305','2014-01-01','2013-12-23 17:29:33','313.00',NULL,NULL,'660.10','347.10','R-OH012','OH0','348.56',NULL,0,'2013-12-26 13:09:12'),(14934,11934,'Y','18','021','EC','A','','','AC','0000569321','0000569321','OH00001197388','IL','1','jacobs','gary','','','','34','288509386','330 WELLESLEY WAY',0,'DAYTON','OH','45459','2931','CY','39113','1951-02-05','M','M',':RET:2106-3','N','021','HLT','2192278','92036OH006000501','2014-02-01','2013-12-29 08:18:12','940.00',NULL,NULL,'1032.33','92.33','R-OH003','OH0','541.61',NULL,0,'2013-12-30 00:02:07'),(24499,19463,'Y','18','021','EC','A','','','AC','0001057502','0001057502','TX00002605041','IL','1','HOYT','BRITTANY','','','','34','461999686','3022 N JOSEY LN',0,'CARROLLTON','TX','75007','5302','CY','48121','1983-06-16','F','U',':RET:2106-3','N','021','DEN','3671100','33348TX002000201','2014-04-01','2014-02-18 21:13:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-20 03:48:17'),(26764,21211,'N','19','021','EC','A',NULL,NULL,'','0001121453','0000881693','','IL','1','POKORNY','KIMBERLY','ANN','','','34','275969842','11430 WOODIEBROOK RD',0,'CHARDON','OH','44024','8496','CY','39055','1992-09-03','F','',NULL,'N','021','DEN','2809951','99734OH005000301','2014-03-01','2014-02-28 19:30:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-01 19:00:10'),(7304,5789,'Y','18','021','EC','A','','','AC','0000356029','0000356029','OH00000220863','31','1','Deiters','Helen','','','','34','233906470','683 VALLEY CREST DR',0,'AKRON','OH','44319','4260','CY','39153','1954-05-18','F','M',':RET:2106-3','T','021','HLT','806151','52664OH151001305','2014-01-01','2013-12-14 15:14:42','895.00',NULL,NULL,'1187.84','292.84','R-OH012','OH0','667.56',NULL,0,'2013-12-26 02:03:13'),(22369,17864,'Y','18','024','14','A','','','TE','0002134557','0002134557','','IL','1','nicholas','erica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-05-14','F','',NULL,NULL,NULL,'','3292539','','2014-02-28','2014-02-10 15:16:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-10 21:00:12'),(22260,17767,'Y','18','021','EC','A','','','AC','0000955237','0000955237','TX00002364599','IL','1','Torres','Lisa','','','','34','627301095','1430 KENDALIA AVE',0,'SAN ANTONIO','TX','78224','1108','CY','48029','1992-01-29','F','U',':RET:2106-3','N','021','DEN','2339444','33348TX002000201','2014-03-01','2014-01-23 20:29:23','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-10 11:00:07'),(22204,17722,'Y','18','021','EC','A','','','AC','0000988923','0000988923','OH00002104066','IL','1','Lindberg','Yvonne','','','','34','283605237','108 LAKEVIEW LN',0,'CHAGRIN FALLS','OH','44022','4230','CY','39055','1957-06-25','F','U',':RET:2106-3','N','021','DEN','3696711','99734OH005000401','2014-03-01','2014-02-09 13:52:41','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-09 19:00:16'),(18249,14568,'Y','18','021','EC','A','','','AC','0000556501','0000556501','TX00001421931','IL','1','Huq','Akm','','','','34','204844329','3713 BELLA VISTA DR',0,'PLANO','TX','75074','3591','CY','48085','1966-08-08','M','M',':RET:2029-7','N','021','DEN','2154731','33348TX002000201','2014-02-01','2014-01-15 14:53:06','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-16 08:44:29'),(16827,13459,'N','01','021','EC','A',NULL,NULL,'','0001081818','0000823533','','IL','1','McGinnis','Diane','','','','34','282641778','1470 Pike Parkway',0,'Streetsboro','OH','44241',NULL,'CY','39133','1957-12-12','F','',NULL,'N','021','DEN','2385501','99734OH005000401','2014-02-01','2014-01-10 18:51:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:18:26'),(16283,13035,'Y','18','021','EC','A','','','AC','0001142181','0001142181','OH00001933327','IL','1','BARNHART','JANICE','LYNN','','','34','269526310','10104 US ROUTE 127',0,'WEST MANCHESTER','OH','45382','9711','CY','39135','1950-05-24','F','U',NULL,'N','021','DEN','2235904','99734OH005000401','2014-02-01','2014-01-06 09:56:27','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-07 04:00:35'),(16188,12960,'Y','18','021','EC','A','','','AC','0000064373','0000064373','TX00001876120','IL','1','Garcia','Alma','','','','34','463316361','11434 BUFFALO HORN',0,'SAN ANTONIO','TX','78245','2507','CY','48029','1965-11-26','F','U',NULL,'N','021','DEN','1640146','33348TX002000201','2014-02-01','2014-01-03 23:00:04','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-05 00:00:44'),(841,696,'Y','18','021','EC','A','','','AC','0000240330','0000240330','OH00001182281','IL','1','Brandt','Florence','','','','34','279507595','315 GALEWOOD DR',0,'NEW CARLISLE','OH','45344','1310','CY','39023','1951-05-28','F','M',':RET:2106-3','N','021','HLT','2252235','92036OH006000501','2014-01-01','2013-12-16 14:35:07','922.00',NULL,NULL,'1069.94','147.94','R-OH003','OH0','541.61',NULL,0,'2013-12-25 18:06:37'),(14589,11644,'Y','18','021','EC','A','','','AC','0001188804','0001188804','OH00000101381','IL','1','Pescatrice','Darcy','','','','34','274549266','1632 SCARBOROUGH DR',0,'BRUNSWICK','OH','44212','3656','CY','39103','1953-04-26','F','R',':RET:2106-3','T','021','HLT','2234694','52664OH151001301','2014-02-01','2013-12-27 09:56:46','0.00',NULL,NULL,'696.03','696.03','R-OH012','OH0','696.03',NULL,0,'2013-12-28 03:36:05'),(14104,11240,'Y','18','021','EC','A','','','AC','0000901077','0000901077','OH00000708943','IL','1','Burkard','Valerie','A','','','34','277581258','23200 State Route 37',0,'Marysville','OH','43040',NULL,'CY','39159','1952-07-10','F','U',':RET:2106-3','N','021','DEN','1621150','99734OH005000401','2014-02-01','2013-12-26 13:33:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:01:40'),(9169,7272,'Y','18','021','EC','A','','','AC','0001115927','0001115927','OH00000112693','IL','1','HOOVER','GLORIA','M','','','34','295601706','2401/2 E CROKER ST',0,'SOSPRORIA','OH','44830',NULL,'CY','39147','1964-11-08','F','U',NULL,'N','021','HLT','1413652','92036OH006002701','2014-01-01','2013-12-18 08:48:13','0.00',NULL,NULL,'263.83','263.83','R-OH006','OH0','263.83',NULL,0,'2013-12-26 04:08:53'),(3897,3119,'Y','18','021','EC','A','','','AC','0000459134','0000459134','OH00000766282','IL','1','MYERS','LATONYA','D','','','34','295687092','919 SAINT AMBROSE DR',0,'AKRON','OH','44307','2236','CY','39153','1971-08-04','F','U',':RET:2054-5','N','021','HLT','253416','52664OH152000901','2014-01-01','2013-12-13 14:52:32','216.43',NULL,NULL,'216.43','0.00','R-OH012','OH0','216.43',NULL,0,'2013-12-25 21:36:45'),(24493,19458,'Y','18','021','EC','A','','','AC','0000659077','0000659077','TX00003029764','IL','1','Beck','Alexandria','','','','34','523899310','3311 TOUCHSTONE ST',0,'AUSTIN','TX','78723','6015','CY','48453','1984-11-07','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','2694926','33348TX002000201','2014-04-01','2014-02-18 18:41:07','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-20 03:45:36'),(26156,20739,'Y','18','021','EC','A','','','AC','0000792261','0000792261','OH00002596736','IL','1','Chen','Hui','','','','34','220716071','113 S OHIO AVE',0,'SIDNEY','OH','45365','2716','CY','39149','1971-08-30','M','U',':RET:2034-7','N','021','DEN','2827227','99734OH005000401','2014-04-01','2014-02-27 16:43:47','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-28 06:30:30'),(26632,21117,'Y','18','021','EC','A','','','AC','0000877013','0000877013','TX00003487066','IL','1','Brady','Amy','','','','34','459974698','24531 FOXBERRY GLEN LN',0,'KATY','TX','77494','3187','CY','48157','1977-07-03','F','U',':RET:2106-3','T','021','DEN','3649195','33348TX002000201','2014-05-01','2014-02-28 16:13:08','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-28 21:30:58'),(7339,5813,'Y','18','021','EC','A','','','AC','0001050626','0001050626','OH00000955047','IL','1','Collinge','David','','','','34','288706833','690 SHERWOOD DR',0,'WOOSTER','OH','44691','2012','CY','39169','1960-12-02','M','R',':RET:2106-3','N','021','HLT','827556','52664OH152000901','2014-01-01','2013-12-14 16:05:28','0.00',NULL,NULL,'333.21','333.21','R-OH014','OH0','333.21',NULL,0,'2013-12-26 02:03:58'),(6540,5185,'Y','18','021','EC','A','','','AC','0000838399','0000838399','TX00000289917','IL','1','Leavell','Scott','M','','','34','372884837','5323 RIDGECREST DR',0,'WICHITA FALLS','TX','76310','3493','CY','48485','1980-11-28','M','U',':RET:2106-3','N','021','DEN','486821','33348TX002000201','2014-01-01','2013-12-10 23:16:44','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-26 00:51:53'),(4252,3387,'Y','18','024','14','A','','','TE','0000336396','0000336396','','IL','1','Shai','Katelyn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-06','F','',NULL,NULL,NULL,'','550375','','2013-12-16','2013-12-16 19:39:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:19'),(3382,2711,'Y','18','021','EC','A','','','AC','0001113043','0001113043','TX00001279227','IL','1','Drews','Ada','','','','34','643445225','942 ROCK SPRINGS DR',0,'RICHMOND','TX','77469','6180','CY','48157','1963-07-23','F','R',NULL,'N','021','DEN','2524262','33348TX002000201','2014-01-01','2013-12-22 18:09:19','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 21:17:33'),(1707,1426,'Y','18','024','14','A','','','TE','0000477459','0000477459','','IL','1','Gerrard','Chris',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-03-20','M','',NULL,NULL,NULL,'','2016453','','2013-12-24','2013-12-24 14:29:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:54:55'),(15832,12676,'Y','18','021','EC','A','','','AC','0000701708','0000701708','OH00000529319','IL','1','Brown','Deborah','','','','34','281544576','10 FEARN AVE',0,'MOUNT VERNON','OH','43050','1112','CY','39083','1952-11-09','F','U',':RET:2106-3','N','021','DEN','1665231','99734OH005000401','2014-02-01','2014-01-02 11:13:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-03 02:03:53'),(13339,10651,'Y','18','021','EC','A','','','AC','0001239256','0001239256','TX00001034017','IL','1','Keezer','Elaine','D','','','34','463130887','163 S PENDELL RD',0,'EL PASO','TX','79905','4830','CY','48141','1958-02-18','F','U',NULL,'N','021','DEN','2310786','33348TX002000201','2014-01-01','2013-12-23 18:13:17','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 12:58:50'),(7041,5592,'Y','18','021','EC','A','','','AC','0000380459','0000380459','TX00001597124','IL','1','Floyd','Julie','','','','34','535027157','1805 COZUMEL DR',0,'MANSFIELD','TX','76063','5916','CY','48439','1977-12-03','F','M',':RET:2106-3','T','021','DEN','2197527','33348TX002000201','2014-02-01','2013-12-25 00:51:04','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:25'),(981,803,'Y','18','021','EC','A','','','AC','0000048151','0000048151','OH00000223913','IL','1','MCDONALD','NITAYA','Y','','','34','301782994','32367 HAMILTON CT',0,'SOLON','OH','44139','6201','CY','39035','1966-11-06','F','U',':RET:2054-5','N','021','HLT','1136192','52664OH151001301','2014-01-01','2013-10-28 23:35:45','0.00',NULL,NULL,'393.12','393.12','R-OH011','OH0','393.12',NULL,0,'2013-12-25 18:10:17'),(20066,16005,'Y','18','021','EC','A','','','AC','0000693588','0000693588','TX00001896844','IL','1','Nicely','Erin','','','','34','630162201','19530 Buckland Park Drive',0,'Katy','TX','77449',NULL,'CY','48201','1990-02-01','F','M',':RET:2106-3','N','021','DEN','2879899','33348TX002000201','2014-03-01','2014-01-27 13:22:13','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-27 21:00:14'),(1367,1132,'Y','18','021','EC','A','','','AC','0000204104','0000204104','TX00001035661','IL','1','Baker','Barbara','Ann','','','34','458298193','205 LOON BAY DR',0,'GUN BARREL CITY','TX','75156','3547','CY','48213','1961-10-11','F','M',':RET:2106-3','N','021','DEN','2167159','33348TX002000101','2014-01-01','2013-12-24 15:39:42','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 18:45:39'),(18841,15007,'Y','18','021','EC','A','','','AC','0000024132','0000024132','OH00002221006','IL','1','EVANS','MICHELLE','','','','34','298603245','137 W 2ND ST',0,'NILES','OH','44446','1413','CY','39155','1973-02-28','F','U',':RET:2106-3','N','021','HLT','1747926','52664OH151001306','2014-03-01','2014-01-16 14:23:42','265.00',NULL,NULL,'329.27','64.27','R-OH013','OH0','329.27',NULL,0,'2014-01-17 03:36:13'),(17445,13954,'Y','18','021','EC','A','','','AC','0000336444','0000336444','OH00001640046','IL','1','Terrell','Theresa','','','','34','270607817','2033 UPTON AVE',0,'TOLEDO','OH','43607','1644','CY','39095','1958-07-20','F','U',':RET:2054-5','N','021','HLT','1856745','92036OH004002601','2014-02-01','2014-01-10 16:51:51','315.00',NULL,NULL,'449.22','134.22','R-OH001','OH0','349.65',NULL,0,'2014-01-13 03:00:37'),(5089,4033,'Y','18','021','EC','A','','','AC','0000240871','0000240871','TX00000788501','IL','1','Law','Jennifer','','','','34','627108608','5427 DUMFRIES DR',0,'HOUSTON','TX','77096','4019','CY','48201','1984-11-19','F','U',':RET:2034-7^:RET:2106-3','T','021','DEN','2261177','33348TX002000201','2014-01-01','2013-12-19 14:37:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:01:09'),(7846,6213,'N','19','021','EC','A',NULL,NULL,'','0000418885','0000611949','','IL','1','Balanson','Zev','B','','','34','288134899','16509 W PARK RD',0,'CLEVELAND','OH','44111','3966','CY','39035','2007-10-25','M','',':RET:2106-3','N','021','DEN','1558839','99734OH005000301','2014-01-01','2013-12-20 00:13:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:42'),(23871,18995,'Y','18','024','14','A','','','TE','0000730018','0000730018','','IL','1','SPOERR','ALBERT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-01-08','M','',NULL,NULL,NULL,'','3324397','','2014-02-14','2014-02-14 11:22:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:32:10'),(25464,20203,'Y','18','024','14','A','','','TE','0000835363','0000835363','','IL','1','Martin','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-01-14','M','',NULL,NULL,NULL,'','3045693','','2014-02-25','2014-02-25 15:52:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-25 21:31:33'),(27370,21673,'Y','18','021','EC','A','','','AC','0000135032','0000135032','MS00002615394','IL','1','LEWIS','LEE','','','','34','427210163','501 COLLEGE ST',0,'KOSCIUSKO','MS','39090','4157','CY','28007','1959-12-29','M','M',NULL,'N','021','DEN','3382195','46300MS002000101','2014-04-01','2014-03-03 18:55:02','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-03-04 21:01:16'),(636,526,'Y','18','021','EC','A','','','AC','0000827134','0000827134','OH00000942201','IL','1','Churchill','Gary','','','','34','298466825','3287 PHEASANT RUN RD',0,'CORTLAND','OH','44410','9139','CY','39155','1951-03-04','M','M',':RET:2106-3','N','021','DEN','1613801','99734OH005000401','2014-01-01','2013-12-16 13:19:58','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:01:13'),(7358,5827,'Y','18','021','EC','A','','','AC','0000166344','0000166344','TX00000051930','IL','1','Murphy','Valerie','','','','34','463618228','313 N. Ave. I',0,'Shiner','TX','77984',NULL,'CY','48285','1981-06-07','F','U',':RET:2054-5','N','021','DEN','410771','33348TX002000201','2014-01-01','2013-11-23 14:39:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 02:15:19'),(21866,17459,'Y','18','021','EC','A','','','AC','0002310036','0002310036','LA00002626981','IL','1','MARRERO TORRES','BENJAMIN','','','','34','583341185','103 MARY ST',0,'GRAY','LA','70359','4901','CY','22109','1951-09-02','M','M',NULL,'N','021','DEN','2926261','18575LA002000201','2014-03-01','2014-02-06 13:47:43','0.00',NULL,NULL,'29.22','29.22','R-LA002','LA0','14.61',NULL,0,'2014-02-06 21:01:23'),(21263,16992,'Y','18','021','EC','A','','','AC','0001102489','0001102489','MS00002581399','IL','1','MALLARD','NICHOLAS','','','','34','428497429','607 WHITE ST',0,'MCCOMB','MS','39648','3050','CY','28113','1984-05-26','M','M',NULL,'N','021','DEN','3145316','46300MS002000201','2014-03-01','2014-02-03 12:12:56','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-03 21:01:24'),(6853,5433,'Y','18','021','EC','A','','','AC','0000070277','0000070277','OH00000741964','IL','1','McGurk','Lisa','','','','34','331748977','40 TURNBERRY CT',0,'SPRINGBORO','OH','45066','9284','CY','39165','1968-02-23','F','U',NULL,'N','021','DEN','377001','99734OH005000301','2014-01-01','2013-10-05 00:13:51','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:31:26'),(16706,13370,'N','01','021','EC','A',NULL,NULL,'','0001204834','0001101438','','IL','1','WILLIAMS','JEREMY','','','','34','455695953','844 N AVENUE I',0,'ODESSA','TX','79763',NULL,'CY','48135','1983-02-25','M','',':RET:2106-3','N','021','DEN','1499361','33348TX002000201','2014-02-01','2014-01-06 20:39:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-08 18:24:41'),(16101,12897,'Y','18','021','EC','A','','','AC','0001069332','0001069332','OH00001809353','IL','1','Campbell','Yvonne','','','','34','403883142','325 KNOLLRIDGE CT',0,'FAIRFIELD','OH','45014','6585','CY','39017','1958-05-02','F','M',':RET:2106-3','N','021','HLT','2266339','92036OH005001206','2014-02-01','2014-01-02 21:57:29','376.00',NULL,NULL,'478.72','102.72','R-OH004','OH0','478.72',NULL,0,'2014-01-04 02:04:47'),(1087,893,'Y','18','021','EC','A','','','AC','0000342698','0000342698','OH00000669515','IL','1','Thompson','Kimberly','','','','34','269547828','111 SHAFFER BLVD',0,'BRYAN','OH','43506','9184','CY','39171','1952-11-10','F','M',':RET:2106-3','N','021','DEN','264973','99734OH005000401','2014-01-01','2013-12-03 13:26:57','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:16:57'),(3413,2740,'Y','18','021','EC','A','','','AC','0001606820','0001606820','LA00000848388','IL','1','McMorris','Bradley','','','','34','434479446','19924 Hwy 42',0,'Livingston','LA','70754',NULL,'CY','22063','1978-11-02','M','U',':RET:2106-3','N','021','DEN','1897506','18575LA002000201','2014-01-01','2013-12-22 15:56:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:26'),(3961,3168,'N','01','021','EC','A',NULL,NULL,'','0000246429','0000608429','','IL','1','Sokol','Joseph','E','','','34','280580952','1782 Middleton Rd',0,'Hudson','OH','44236',NULL,'CY','39153','1958-01-04','M','',':RET:2106-3','N','021','HLT','919943','52664OH151001501','2014-01-01','2013-12-13 13:18:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','596.45',NULL,0,'2013-12-25 21:38:24'),(5343,4237,'Y','18','021','EC','A','','','AC','0000713628','0000713628','OH00001104951','IL','1','Paulin','Margaret','','','','34','272561940','2460 CONGO ST',0,'AKRON','OH','44305','3913','CY','39153','1967-09-09','F','U',NULL,'N','021','DEN','2475155','99734OH005000301','2014-01-01','2013-12-19 16:47:38','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:07:24'),(5357,4248,'N','01','021','EC','A',NULL,NULL,'','0000088547','0000658410','','IL','1','Frogge','Dessie','Eveline','','','34','298544225','618 Melrose St',0,'Akron','OH','44305',NULL,'CY','39153','1953-12-26','F','',':RET:2106-3','T','021','HLT','2290363','52664OH152000901','2014-01-01','2013-12-19 16:25:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','509.80',NULL,0,'2013-12-25 23:07:45'),(5725,4545,'Y','18','021','EC','A','','','AC','0002266676','0002266676','LA00001021475','IL','1','Jewell','Baylor','Looper','','Sr','34','435907159','13544 MINOU AVE',0,'BATON ROUGE','LA','70809','5425','CY','22033','1955-12-16','M','R',':RET:2106-3','N','021','DEN','2422009','18575LA002000201','2014-01-01','2013-12-23 22:36:52','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:31'),(23929,19028,'Y','18','021','EC','A','','','AC','0000918299','0000918299','OH00002535515','IL','1','ROBINSON','SARAH','','','','34','287907848','2345 BEECHMONT AVE',0,'CINCINNATI','OH','45230',NULL,'CY','39061','1989-07-31','F','U',':RET:2054-5','T','021','DEN','3334339','99734OH005000401','2014-03-01','2014-02-15 00:12:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00','CIC',0,'2014-02-15 21:00:02'),(25246,20026,'Y','18','021','EC','A','','','AC','0000975290','0000975290','OH00002853076','IL','1','Swander','Tony','Allan','','','34','296561121','6969 SHELLEY RD',0,'ROCKFORD','OH','45882','9534','CY','39107','1959-08-09','M','M',NULL,'T','021','HLT','3698175','92036OH004001501','2014-04-01','2014-02-21 14:40:35','294.00',NULL,NULL,'434.50','140.50','R-OH002','OH0','434.50',NULL,0,'2014-02-21 22:01:10'),(25964,20590,'N','01','021','EC','A',NULL,NULL,'','0000467141','0000298280','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','DEN','3560975','99734OH005000401','2014-04-01','2014-02-26 12:40:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:42'),(26503,21022,'Y','18','024','14','A','','','TE','0000622531','0000622531','','IL','1','Jordan','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-25','M','',NULL,NULL,NULL,'','2713110','','2014-03-31','2014-02-28 10:43:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 21:00:16'),(28557,22600,'Y','18','021','EC','A','','','AC','0001069383','0001069383','OH00002695292','IL','1','Sherman','Mary','','','','34','272443546','112 W CULBERTSON ST',0,'FOSTORIA','OH','44830','2004','CY','39147','1951-03-23','F','M',NULL,'N','021','HLT','3956391','92036OH004002701','2014-04-01','2014-03-07 12:58:18','432.00',NULL,NULL,'462.84','30.84','R-OH006','OH0','462.84',NULL,0,'2014-03-07 21:32:23'),(29132,23063,'Y','18','021','EC','A','','','AC','0000839115','0000839115','OH00003160081','IL','1','Estep','Chloe','','','','34','285989284','5985 TWITCHELL RD',0,'SPRINGFIELD','OH','45502','9273','CY','39023','1995-08-19','F','U',':RET:2106-3','N','021','DEN','3939872','99734OH005000201','2014-04-01','2014-03-10 10:51:34','0.00',NULL,NULL,'24.48','24.48','R-OH003','OH0','24.48',NULL,0,'2014-03-10 21:02:38'),(5559,4413,'Y','18','021','EC','A','','','AC','0000872011','0000872011','OH00000198374','IL','1','Creighton','Ronald','','','','34','271682904','13279 NEW HOPE WHITE OAK STATION RD',0,'SARDINIA','OH','45171','8336','CY','39015','1960-02-09','M','M',NULL,'N','021','HLT','862843','92036OH006000601','2014-01-01','2013-11-27 13:02:53','0.00',NULL,NULL,'347.30','347.30','R-OH005','OH0','347.30',NULL,0,'2013-12-25 23:16:23'),(21869,17461,'Y','18','021','EC','A','','','AC','0001356215','0001356215','LA00001777342','IL','1','watson','zenda','','','','34','439199006','2360 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4454','CY','22071','1973-06-06','F','M',':RET:2054-5','N','021','DEN','3604579','18575LA002000201','2014-03-01','2014-02-05 20:08:23','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-06 21:01:24'),(5365,4254,'Y','18','021','EC','A','','','AC','0001259994','0001259994','OH00000742697','IL','1','Young','James','','','','34','289505676','4355 BEAL RD',0,'FRANKLIN','OH','45005','4515','CY','39165','1951-08-30','M','M',':RET:2106-3','N','021','HLT','1365203','92036OH005001201','2014-01-01','2013-12-18 21:08:22','606.00',NULL,NULL,'1219.98','613.98','R-OH004','OH0','616.74',NULL,0,'2013-12-25 23:07:56'),(4131,3298,'N','01','021','EC','A',NULL,NULL,'','0000882836','0000678075','','IL','1','GAMBLE','KAREN','ELIZABETH','','','34','289586199','3145 WILLIAMSBURG ST NW',0,'WARREN','OH','44485','2256','CY','39155','1955-10-27','F','',NULL,'N','021','DEN','2065380','99734OH005000301','2014-01-01','2013-12-17 08:51:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:23'),(19784,15772,'Y','18','021','EC','A','','','AC','0000891838','0000891838','OH00002247967','IL','1','LaPlant','James','','','','34','290866124','2242 15TH ST',0,'CUYAHOGA FALLS','OH','44223','2459','CY','39153','1984-01-17','M','M',':RET:2106-3','N','021','HLT','2629450','52664OH151001306','2014-03-01','2014-01-23 00:42:19','414.00',NULL,NULL,'502.66','88.66','R-OH012','OH0','253.11',NULL,0,'2014-01-23 21:01:36'),(7880,6234,'Y','18','021','EC','A','','','AC','0000653195','0000653195','OH00001005890','IL','1','COSME','ADA','','','','34','280741139','3608 WOODBRIDGE AVE',0,'CLEVELAND','OH','44109','2156','CY','39035','1971-05-24','F','U',NULL,'N','021','DEN','2387476','99734OH005000301','2014-01-01','2013-12-20 17:39:52','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:05:24'),(19368,15439,'Y','18','021','EC','A','','','AC','0000004749','0000004749','OH00001882472','IL','1','STONE','DIANA','','','','34','283480161','1607 CLOVERFIELD',0,'COPLEY','OH','44321',NULL,'CY','39153','1949-10-24','F','M',NULL,'N','021','HLT','2827867','52664OH151001306','2014-03-01','2014-01-21 17:01:18','535.00',NULL,NULL,'669.00','134.00','R-OH012','OH0','669.00',NULL,1,'2014-01-22 03:22:35'),(19152,15259,'Y','18','021','EC','A','','','AC','0000825935','0000825935','OH00001769468','IL','1','Fordham','James','','','','34','278804313','3327 ARLINGTON AVE',0,'TOLEDO','OH','43614','2475','CY','39095','1972-03-27','M','U',NULL,'N','021','HLT','2760812','92036OH004002601','2014-03-01','2014-01-18 20:23:46','158.00',NULL,NULL,'303.72','145.72','R-OH001','OH0','204.15',NULL,0,'2014-01-21 08:45:36'),(13829,11038,'N','19','021','EC','A',NULL,NULL,'','0000904262','0000326186','','S1','1','Filina','Robert','','','','34','285153847','793 WEBER AVE',0,'AKRON','OH','44303','1529','CY','39153','2009-09-05','F','',':RET:2106-3','N','021','HLT','2523112','52664OH152000901','2014-01-01','2013-12-23 09:17:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 13:12:05'),(14369,11460,'Y','18','024','14','A','','','TE','0000279511','0000279511','','IL','1','Hollingsworth-Christian','Laverne',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-12-24','F','',NULL,NULL,NULL,'','640341','','2013-12-27','2013-12-27 10:12:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:30:29'),(17921,14315,'N','01','021','EC','A',NULL,NULL,'','0001233121','0001173703','','IL','1','Camarillo','Lucio','','','Jr','34','455819111','14310 COTTINGHAM DR',0,'AUSTIN','TX','78725','4782','CY','48453','1979-07-11','M','',':RET:2106-3','N','021','DEN','1941168','33348TX002000201','2014-02-01','2014-01-14 10:58:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-15 02:06:31'),(17913,14308,'Y','18','021','EC','A','','','AC','0000347559','0000347559','TX00001454064','IL','1','Devlin','Amanda','','','','34','585790536','5618 DARTMOUTH ST',0,'LUBBOCK','TX','79416','1335','CY','48303','1987-12-02','F','U',':RET:2106-3','T','021','DEN','2032104','33348TX002000201','2014-02-01','2014-01-13 22:09:21','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-15 02:06:28'),(17773,14200,'Y','18','021','EC','A','','','AC','0000005000','0000005000','TX00002357037','IL','1','martin','shannon','','','','34','467738808','3710 magnolia',0,'beaumont','TX','77703',NULL,'CY','48245','1982-10-05','F','U',':RET:2054-5','N','021','DEN','1376206','33348TX002000101','2014-02-01','2014-01-13 14:27:41','0.00',NULL,NULL,'25.02','25.02','R-TX004','TX0','25.02',NULL,0,'2014-01-14 01:33:39'),(15960,12775,'Y','18','021','EC','A','','','AC','0000103899','0000103899','OH00001593551','IL','1','Renzenbrink','Shaun','','','','34','290828773','1727 RIVERWOOD TRL',0,'KINGS MILLS','OH','45034','9772','CY','39165','1969-02-24','M','M',NULL,'N','021','DEN','1474421','99734OH005000301','2014-02-01','2014-01-03 13:39:13','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:00:18'),(16217,12987,'Y','18','021','EC','A','','','AC','0000701710','0000701710','OH00002276076','IL','1','Scott','Sondra','','','','34','270548054','1819 LAKENOLL DR',0,'MOUNT HEALTHY','OH','45231','5144','CY','39061','1952-09-20','F','U',':RET:2054-5','N','021','DEN','2159476','99734OH005000401','2014-02-01','2014-01-03 20:09:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-05 00:01:41'),(23755,18909,'Y','18','021','EC','A','','','AC','0000661393','0000661393','OH00001543889','IL','1','Falck','Amber','','','','34','267670098','461 North Street',0,'Batavia','OH','45103',NULL,'CY','39025','1968-03-09','F','M',':RET:2106-3','N','021','DEN','2834135','99734OH005000301','2014-03-01','2014-02-14 08:35:54','0.00',NULL,NULL,'87.78','87.78','R-OH005','OH0','0.00',NULL,0,'2014-02-14 21:31:08'),(24165,19199,'Y','18','021','EC','A','','','AC','0000784408','0000784408','OH00002448212','IL','1','Stolarski','Holly','','','','34','299622875','7923 KENILWORTH AVE',0,'PARMA','OH','44129','1829','CY','39035','1972-12-09','F','U',':RET:2106-3','N','021','HLT','3850903','92036OH005000806','2014-03-01','2014-02-15 12:01:25','312.00',NULL,NULL,'452.88','140.88','R-OH011','OH0','304.41',NULL,0,'2014-02-15 22:02:06'),(25511,20239,'Y','18','021','EC','A','','','AC','0000906649','0000906649','OH00003127893','IL','1','Anders','Michael','','','','34','278663174','2547 CONCORD RD',0,'HILLSBORO','OH','45133','6656','CY','39071','1958-12-23','M','M',':RET:2106-3','N','021','HLT','3299380','92036OH004000601','2014-04-01','2014-02-25 14:04:43','627.00',NULL,NULL,'805.59','178.59','R-OH005','OH0','384.93',NULL,0,'2014-02-25 21:32:01'),(7404,5859,'Y','18','021','EC','A','','','AC','0000919358','0000919358','OH00001168078','IL','1','Mackay','Andrew','','','','34','276849514','4349 TOMAHAWK LANE',0,'VERMILION','OH','44089',NULL,'CY','39093','1985-10-06','M','U',':RET:2106-3','N','021','HLT','1004738','92036OH004000801','2014-01-01','2013-11-23 16:52:17','148.00',NULL,NULL,'204.35','56.35','R-OH011','OH0','204.35',NULL,0,'2013-12-26 02:16:30'),(22062,17612,'Y','18','021','EC','A','','','AC','0000615159','0000615159','TX00002613671','IL','1','Blunt','Debbie','','','','34','456459854','10511 Stormy Sky Dr',0,'Houston','TX','77064',NULL,'CY','48201','1961-09-08','F','U',':RET:2106-3','N','021','DEN','3451747','33348TX002000201','2014-03-01','2014-02-08 13:06:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-08 19:00:10'),(21518,17192,'Y','18','024','14','A','','','TE','0001210808','0001210808','','IL','1','Robinson','Dominique',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-02-22','F','',NULL,NULL,NULL,'','2127564','','2014-02-28','2014-02-05 12:55:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-05 21:00:05'),(7368,5835,'N','01','021','EC','A',NULL,NULL,'','0000019532','0000693415','','IL','1','Promoslovsky','Fernando','M','','','34','663055885','2404 JENA ST',0,'NEW ORLEANS','LA','70115','5908','CY','22071','1975-06-03','M','',':RET:2106-3','N','021','DEN','638049','18575LA002000201','2014-01-01','2013-11-23 17:09:30',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 02:15:34'),(20641,16494,'Y','18','021','EC','A','','','AC','0000941790','0000941790','TX00001587833','IL','1','Capiti','Terry','','','','34','463254351','508 RITCHIE ST',0,'NACOGDOCHES','TX','75964','3508','CY','48347','1964-05-06','M','M',NULL,'N','021','DEN','3458008','33348TX002000201','2014-03-01','2014-01-30 11:47:51','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:33'),(20277,16182,'Y','18','021','EC','A','','','AC','0000228370','0000228370','OH00002586926','IL','1','Lappin','Mary','','','','34','284647989','756 N FIRESTONE BLVD',0,'AKRON','OH','44306','2714','CY','39153','1959-07-15','F','U',':RET:2106-3','N','021','DEN','2819020','99734OH005000401','2014-03-01','2014-01-28 11:56:30','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-28 21:00:27'),(6829,5412,'Y','18','021','EC','A','','','AC','0001003263','0001003263','OH00000707739','IL','1','Hightower','Curtis','','','','34','601521843','3675 MAPLECRAFT DR',0,'DRESDEN','OH','43821','9792','CY','39119','1984-03-30','M','U',':RET:2106-3','N','021','DEN','172979','99734OH005000301','2014-01-01','2013-11-14 17:51:30','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:30:43'),(25706,20392,'N','01','021','EC','A',NULL,NULL,'','0001085115','0000809612','','IL','1','Carroll','Barte','','','','34','413452744','4400 paluxy drive',0,'Tyler','TX','75703',NULL,'CY','48423','1970-11-14','M','',':RET:2106-3','T','021','DEN','2702048','33348TX002000201','2014-04-01','2014-02-24 14:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:20'),(27961,22121,'Y','18','021','EC','A','','','AC','0001319307','0001319307','LA00003697155','IL','1','Zidan','Elizabeth','','','','34','448924616','2826 Misty Ln',0,'Bossier city','LA','71111',NULL,'CY','22015','1979-05-28','F','M',NULL,'N','021','DEN','3327671','18575LA002000201','2014-04-01','2014-03-05 20:40:53','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-03-06 21:00:45'),(1731,1440,'N','19','021','EC','A',NULL,NULL,'','0000809681','0000153371','','IL','1','Funkhouser','Brendan','','','','34','294069578','401 Bell Ave',0,'Sandusky','OH','44870',NULL,'CY','39043','2002-02-13','M','',':RET:2106-3','N','021','DEN','2527329','99734OH005000301','2014-01-01','2013-12-24 10:59:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:23'),(22554,18011,'Y','18','021','EC','A','','','AC','0001014412','0001014412','OH00002287952','IL','1','Goedel','Jacqueline','','','','34','275547774','6484 RENNER RD SW',0,'FRESNO','OH','43824','9316','CY','39157','1953-01-22','F','M',NULL,'N','021','DEN','3648713','99734OH005000401','2014-03-01','2014-02-10 09:27:47','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-02-10 21:31:47'),(19972,15931,'Y','18','021','EC','A','','','AC','0000305868','0000305868','OH00001603939','IL','1','Glambin','Betty','','','','34','279688161','119 LOCUST ST',0,'LUCKEY','OH','43443','9741','CY','39173','1970-07-18','F','M',':RET:2106-3','T','021','DEN','3398650','99734OH005000301','2014-03-01','2014-01-25 15:24:01','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00',NULL,0,'2014-01-25 19:00:11'),(3773,3021,'Y','18','021','EC','A','','','AC','0000455296','0000455296','OH00001214274','IL','1','Severance','Ralph','','','','34','268521370','373 MORGAN ST',0,'BARBERTON','OH','44203','1733','CY','39153','1951-10-05','M','U',':RET:2106-3','N','021','HLT','229529','52664OH151001305','2014-01-01','2013-12-13 16:12:37','476.00',NULL,NULL,'640.70','164.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 21:33:46'),(3797,3043,'Y','18','021','EC','A','','','AC','0000868216','0000868216','OH00001278810','IL','1','Milano','John','Mark','','','34','293769242','4225 HAMILTON AVE',0,'CINCINNATI','OH','45223','2033','CY','39061','1970-11-12','M','U',':RET:2106-3','N','021','DEN','976117','99734OH005000301','2014-01-01','2013-12-13 11:51:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:34:24'),(7972,6310,'Y','18','021','EC','A','','','AC','0001010199','0001010199','OH00000581172','IL','1','Gehring','Jennifer','Lynn','','','34','206660233','361 ABBYSHIRE RD',0,'AKRON','OH','44319','3803','CY','39153','1971-10-24','F','U',':RET:2106-3','N','021','HLT','1782918','52664OH151001305','2014-01-01','2013-12-19 19:39:45','142.00',NULL,NULL,'295.48','153.48','R-OH012','OH0','295.48',NULL,0,'2013-12-26 03:07:43'),(13376,10681,'N','01','021','EC','A',NULL,NULL,'','0000514445','0000792216','','IL','1','Bartholomew','Emily','Kristen Doll','','','34','272824428','3556 Madison Park Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1984-01-10','F','',NULL,'T','021','DEN','2341357','99734OH005000301','2014-01-01','2013-12-22 22:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:59:50'),(25581,20292,'Y','18','024','14','A','','','TE','0000129880','0000129880','','IL','1','DAVIS','VERA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-10-13','F','',NULL,NULL,NULL,'','3406542','','2014-03-31','2014-02-24 15:47:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-26 08:00:37'),(27384,21681,'Y','18','021','EC','A','','','AC','0000099216','0000099216','MS00002924458','IL','1','CHAMBERS','ASHLEY','','','','34','427616319','1504 ROBINSON RD',0,'CANTON','MS','39046','9138','CY','28089','1980-03-05','F','U',':RET:2054-5','N','021','DEN','3882954','46300MS002000201','2014-04-01','2014-03-04 11:30:05','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-04 21:01:23'),(27938,22101,'Y','18','021','EC','A','','','AC','0001033018','0001033018','TX00003082974','IL','1','Colligan','Sherrie','','','','34','460985625','6060 Comstock Road',0,'Beaumont','TX','77708',NULL,'CY','48245','1953-08-20','F','M',NULL,'N','021','DEN','3791839','33348TX002000201','2014-04-01','2014-03-06 13:41:53','0.00',NULL,NULL,'29.22','29.22','R-TX004','TX0','14.61',NULL,0,'2014-03-06 21:00:30'),(2117,1737,'Y','18','021','EC','A','','','AC','0000746850','0000746850','OH00000190677','IL','1','Jorgensen','Cindy','Marie','','','34','290564366','10934 STATE ROUTE 68 NORTH',0,'BELLE CENTER','OH','43310',NULL,'CY','39091','1952-07-30','F','M',':RET:2106-3','N','021','DEN','829802','99734OH005000401','2014-01-01','2013-12-10 13:00:35','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:17:37'),(5759,4574,'Y','18','021','EC','A','','','AC','0000101436','0000101436','OH00000492368','IL','1','Winters','Carol','','','','34','277506074','167 EASTWOOD AVE',0,'WESTERVILLE','OH','43081','1615','CY','39049','1950-01-11','F','U',':RET:2106-3','N','021','DEN','2110845','99734OH005000401','2014-01-01','2013-12-23 21:46:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:46:27'),(20961,16750,'Y','18','021','EC','A','','','AC','0001093026','0001093026','TX00002174241','IL','1','RUIZ','CECILIA','G','','','34','629381321','2906 AVENUE L',0,'SNYDER','TX','79549','4231','CY','48415','1969-03-14','F','M',NULL,'N','021','DEN','3459192','33348TX002000201','2014-03-01','2014-02-01 15:04:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-01 19:00:09'),(19964,15926,'Y','18','021','EC','A','','','AC','0000435329','0000435329','OH00002472573','IL','1','Shooks','Eva','','','','34','276567899','585 Seville rd',0,'Wadsworth','OH','44281',NULL,'CY','39103','1953-06-02','F','M',':RET:2106-3','N','021','HLT','2843531','52664OH151001305','2014-03-01','2014-01-25 10:21:35','453.00',NULL,NULL,'605.24','152.24','R-OH012','OH0','605.24',NULL,0,'2014-01-25 19:00:08'),(19255,15344,'Y','18','021','EC','A','','','AC','0002149684','0002149684','LA00002447587','IL','1','APOLLONIO','james','','','','34','297609446','31050 LA HIGHWAY 16',0,'DENHAM SPRINGS','LA','70726',NULL,'CY','22063','1961-02-09','M','M',':RET:2106-3','N','021','DEN','2829985','18575LA002000201','2014-03-01','2014-01-20 11:53:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:46:46'),(18785,14963,'Y','18','021','EC','A','','','AC','0000049527','0000049527','OH00002224774','IL','1','Asher','Joshua','','','','34','292806079','607 S. Linden Ave.',0,'Miamisburg','OH','45342',NULL,'CY','39113','1982-12-02','M','U',':RET:2106-3','T','021','DEN','2694235','99734OH005000401','2014-02-01','2014-01-15 21:51:03','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-17 03:35:54'),(16179,12954,'Y','18','021','EC','A','','','AC','0000380494','0000380494','TX00000019396','IL','1','Chamness','Timothy','','','','34','322465788','7519 TIMBER RIDGE TRL',0,'SUGAR LAND','TX','77479','6121','CY','48157','1952-12-22','M','M',NULL,'T','021','DEN','1567836','33348TX002000201','2014-02-01','2014-01-03 18:43:09','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-05 00:00:28'),(15928,12754,'Y','18','021','EC','A','','','AC','0000798422','0000798422','OH00000110546','IL','1','HE','LIFEM','','','','34','282947122','710 TRACK LANE',0,'CINCINNATI','OH','45245',NULL,'CY','39025','1966-10-17','F','M',':RET:2034-7','N','021','HLT','2485977','92036OH004000601','2014-02-01','2014-01-02 16:46:37','469.00',NULL,NULL,'673.89','204.89','R-OH005','OH0','269.80',NULL,0,'2014-01-03 02:06:51'),(4317,3430,'N','19','021','EC','A',NULL,NULL,'','0000665622','0000676693','','IL','1','PANTON','SHANIQUE','','','','34','771629956','1110 HAYWARD CIR',0,'MILFORD','OH','45150',NULL,'CY','39025','1993-03-27','F','',':RET:2054-5','N','021','HLT','1795236','92036OH004000601','2014-01-01','2013-12-17 08:40:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-25 21:52:41'),(13599,10846,'Y','18','021','EC','A','','','AC','0000299244','0000299244','OH00000490051','IL','1','Stetler','Rita','','','','34','304626038','15819 State Rt. 49',0,'Willshire','OH','45898',NULL,'CY','39161','1953-02-01','F','M',':RET:2106-3','N','021','HLT','2130675','92036OH003001505','2014-01-01','2013-12-23 07:11:45','458.00',NULL,NULL,'623.76','165.76','R-OH002','OH0','623.76',NULL,0,'2013-12-26 13:05:22'),(5400,4287,'Y','18','021','EC','A','','','AC','0000520952','0000520952','OH00000346864','IL','1','Johnston','Carole','','','','34','300480310','522 S SHANNON ST',0,'VAN WERT','OH','45891','1955','CY','39161','1953-08-12','F','U',NULL,'T','021','HLT','1774968','92036OH004001501','2014-01-01','2013-12-19 16:11:00','548.28',NULL,NULL,'552.32','4.04','R-OH002','OH0','552.32',NULL,0,'2013-12-25 23:08:55'),(9773,7740,'Y','18','021','EC','A','','','AC','0000116741','0000116741','LA00000760437','IL','1','Archie','Latasha','','','','34','433812138','916 hunt Rd',0,'Dubach','LA','71235',NULL,'CY','22061','1982-09-23','F','U',NULL,'N','021','DEN','369969','18575LA002000201','2014-01-01','2013-10-20 18:13:46','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-26 05:00:32'),(9013,7152,'Y','18','021','EC','A','','','AC','0000117784','0000117784','OH00001039141','IL','1','KALTENBACH','KAREN','','','','34','273661164','2986 TELBER CT',0,'STOW','OH','44224','2156','CY','39153','1958-04-16','F','M',':RET:2106-3','N','021','HLT','2003928','52664OH152000901','2014-01-01','2013-12-18 16:50:34','264.00',NULL,NULL,'364.25','100.25','R-OH012','OH0','364.25',NULL,0,'2013-12-26 04:05:08'),(25636,20337,'N','01','021','EC','A',NULL,NULL,'','0001935607','0001941269','','IL','1','LEWIS','JONNIQUE','','','','34','433750054','6820 NORWOOD CT',0,'NEW ORLEANS','LA','70126','3248','CY','22071','1988-09-02','F','',':RET:2054-5','N','021','DEN','2893818','18575LA002000201','2014-04-01','2014-02-21 18:21:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-26 08:30:27'),(27953,22113,'Y','18','021','EC','A','','','AC','0000716346','0000716346','TX00003592574','IL','1','Hicks','Torrevio','','','','34','260371953','9659 FOREST LN',0,'DALLAS','TX','75243','8656','CY','48113','1981-05-12','M','U',NULL,'N','021','DEN','2793024','33348TX002000201','2014-04-01','2014-03-06 17:40:14','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:39'),(2211,1821,'Y','18','021','EC','A','','','AC','0000692892','0000692892','OH00001015916','IL','1','Keeton','Debra','','','','34','299500550','2642 OWAISA RD',0,'CUYAHOGA FALLS','OH','44221','2924','CY','39153','1951-12-12','F','M',':RET:2106-3','N','021','HLT','596585','52664OH151001304','2014-01-01','2013-12-10 15:54:54','498.64',NULL,NULL,'640.70','142.06','R-OH012','OH0','640.70',NULL,0,'2013-12-25 19:20:17'),(6649,5275,'N','19','021','EC','A',NULL,NULL,'','0000736481','0001144733','','IL','1','Waugh','Madison','','','','34','732528866','6853 CLUBSIDE DR',0,'LOVELAND','OH','45140','6040','CY','39025','2013-05-01','F','',NULL,'N','021','HLT','830523','92036OH004000601','2014-01-01','2013-11-12 12:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2013-12-26 01:00:32'),(5729,4547,'N','01','021','EC','A',NULL,NULL,'','0002270825','0002045210','','IL','1','pham','uyen','t','','','34','437898481','12849 MURLIN AVE',0,'BATON ROUGE','LA','70817','1249','CY','22033','1978-12-07','F','',':RET:2047-9','N','021','DEN','2586397','18575LA002000201','2014-01-01','2013-12-23 22:44:37',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:45:38'),(4105,3280,'Y','18','021','EC','A','','','AC','0000547843','0000547843','TX00001136040','IL','1','diggins','lupita','','','','34','456278578','3421 Michelle Ridge Dr',0,'Fort Worth','TX','76123',NULL,'CY','48439','1974-05-10','F','U',':RET:2054-5','N','021','DEN','2099570','33348TX002000101','2014-01-01','2013-12-17 07:48:44','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:47:49'),(20166,16092,'Y','18','021','EC','A','','','AC','0000388669','0000388669','OH00002246809','IL','1','Frederick','Dana','','','','34','280868315','3217 Glanzman Rd.',0,'Toledo','OH','43614',NULL,'CY','39095','1984-04-11','F','U',':RET:2106-3','T','021','HLT','3406469','92036OH004002601','2014-03-01','2014-01-26 22:24:09','150.00',NULL,NULL,'201.76','51.76','R-OH001','OH0','201.76',NULL,0,'2014-01-27 21:01:12'),(5420,4302,'Y','18','021','EC','A','','','AC','0000945971','0000945971','MS00000438841','IL','1','McCray','Jawon','','','','34','426530660','2009 GENERAL PERSHING ST',0,'LAUREL','MS','39440','4814','CY','28067','1985-05-18','M','U',':RET:2054-5','N','021','DEN','2093450','46300MS002000201','2014-01-01','2013-12-19 01:16:32','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 23:09:23'),(19215,15310,'Y','18','021','EC','A','','','AC','0000872080','0000872080','OH00002320393','IL','1','DURO','PABLITO','','','','34','847665296','5440 TRETORN DR',0,'HILLIARD','OH','43026','8828','CY','39049','1963-08-05','M','M',NULL,'N','021','DEN','2108606','99734OH005000401','2014-03-01','2014-01-20 12:19:37','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:46:24'),(19151,15258,'Y','18','021','EC','A','','','AC','0000936084','0000936084','OH00001437774','IL','1','Ward','Charles','','','','34','280602365','320 S Pine St',0,'St Marys','OH','45885',NULL,'CY','39011','1960-04-29','M','M',':RET:2106-3','T','021','HLT','1694027','92036OH004001501','2014-03-01','2014-01-18 20:15:12','373.00',NULL,NULL,'415.16','42.16','R-OH002','OH0','415.16',NULL,0,'2014-01-21 08:45:35'),(18800,14973,'Y','18','021','EC','A','','','AC','0000283287','0000283287','OH00002474542','IL','1','Burton','Maria','','','','34','284867046','1114 GROESBECK RD',0,'CINCINNATI','OH','45224','3276','CY','39061','1987-07-24','F','U',':RET:2054-5','N','021','DEN','2847137','99734OH005000401','2014-03-01','2014-01-16 11:49:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:59'),(5214,4139,'N','01','021','EC','A',NULL,NULL,'','0000486941','0000525569','','IL','1','McNulty','Dione','B','','','34','268866462','1231 COOK AVE',0,'LAKEWOOD','OH','44107','2503','CY','39035','1952-07-18','F','',':RET:2106-3','N','021','DEN','1547384','99734OH005000401','2014-01-01','2013-12-19 15:43:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:04:22'),(14611,11662,'Y','18','021','EC','A','','','AC','0000986013','0000986013','OH00000804578','IL','1','Hier','Catherine','','','','34','294543078','3158 W 162ND ST',0,'CLEVELAND','OH','44111','1008','CY','39035','1953-11-14','F','U',NULL,'N','021','DEN','1839533','99734OH005000301','2014-02-01','2013-12-27 15:46:43','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-28 03:36:40'),(16937,13555,'Y','18','021','EC','A','','','AC','0001781664','0001781664','LA00001708949','IL','1','Moore','Jessie','','','','34','434110798','12702 ICELAND AVE',0,'BATON ROUGE','LA','70814','7637','CY','22033','1963-07-06','F','U',':RET:2054-5','N','021','DEN','2092764','18575LA002000201','2014-02-01','2014-01-08 21:36:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:19:51'),(23318,18585,'Y','18','021','EC','A','','','AC','0001093178','0001093178','OH00001582193','IL','1','Seebaluck','Manilall','','','','34','785398729','612 SNIDER CT',0,'MASON','OH','45040','1384','CY','39165','1963-03-19','M','M',':RET:2029-7','N','021','DEN','2997510','99734OH005000301','2014-03-01','2014-02-13 12:55:22','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:00:23'),(24736,19634,'N','01','021','EC','A',NULL,NULL,'','0000467141','0000298280','','IL','1','Culpepper','Thurman','L','','Jr','34','330785423','924 E PORTER ST',0,'MALVERN','OH','44644','9460','CY','39019','1980-08-21','M','',':RET:2106-3','N','021','DEN','3067108','99734OH005000401','2014-04-01','2014-02-19 09:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:46'),(25326,20093,'Y','18','021','EC','A','','','AC','0001517922','0001517922','LA00002856658','IL','1','DOVE','KATHY','','','','34','437928612','14354 HIGHWAY 120',0,'MARTHAVILLE','LA','71450','5219','CY','22085','1954-04-25','F','M',NULL,'N','021','DEN','2886467','18575LA002000201','2014-04-01','2014-02-25 12:20:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-25 21:30:13'),(25478,20214,'Y','18','021','EC','A','','','AC','0000992722','0000992722','OH00003308371','IL','1','sorter','dawn','','','','34','295742328','527 SUNSET BLVD',0,'TOLEDO','OH','43612','2462','CY','39095','1968-02-12','F','M',':RET:2106-3','N','021','HLT','3657109','92036OH004002601','2014-04-01','2014-02-24 18:46:05','0.00',NULL,NULL,'235.18','235.18','R-OH001','OH0','235.18',NULL,0,'2014-02-25 21:31:41'),(26523,21033,'Y','18','024','14','A','','','TE','0000294433','0000294433','','IL','1','Dietrich','Keith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-07-03','M','',NULL,NULL,NULL,'','3280933','','2014-02-28','2014-02-28 14:37:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 21:00:24'),(27098,21452,'N','19','021','EC','A',NULL,NULL,'','0000242767','0001097830','','IL','1','White','Nicholas','','','','34','286987873','1010 CARNEGIE AVE',0,'AKRON','OH','44314','1146','CY','39153','1995-11-06','M','',':RET:2106-3','N','021','HLT','3110608','52664OH151001304','2014-04-01','2014-03-03 17:53:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 21:30:20'),(27605,21833,'Y','18','021','EC','A','','','AC','0001099244','0001099244','OH00003380023','IL','1','Sarli','Samantha','','','','34','271847454','23896 Parkwood Drive',0,'Columbia Station','OH','44028',NULL,'CY','39093','1967-06-18','F','U',NULL,'N','021','DEN','3390721','99734OH005000301','2014-04-01','2014-03-05 12:10:14','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00','CIC',0,'2014-03-05 21:00:25'),(29088,23023,'Y','18','021','EC','A','','','AC','0001053740','0001053740','TX00003551523','IL','1','neeley','rhonda','','','','34','484807767','11004 LAKESIDE DR',0,'JONESTOWN','TX','78645','3317','CY','48453','1957-09-07','F','U',':RET:2106-3','N','021','DEN','3538418','33348TX002000101','2014-04-01','2014-03-10 09:51:23','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-03-10 21:02:08'),(746,616,'N','01','021','EC','A',NULL,NULL,'','0001241620','0000218335','','IL','1','Ibekwe','Christiana','','','','34','639845251','416 PECAN HOLLOW DR',0,'COPPELL','TX','75019','4848','CY','48113','1960-12-25','F','',':RET:2054-5','N','021','DEN','640755','33348TX002000201','2014-01-01','2013-12-16 00:44:23',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:04:09'),(840,695,'Y','18','021','EC','A','','','AC','0000114172','0000114172','OH00000023905','IL','1','Wright','John','Allen','','','34','289646342','1322 Huffman Ave.',0,'Dayton','OH','45403',NULL,'CY','39113','1957-10-08','M','U',':RET:2106-3','N','021','HLT','473210','92036OH006000501','2014-01-01','2013-12-15 21:55:01','351.00',NULL,NULL,'439.80','88.80','R-OH003','OH0','439.80',NULL,0,'2013-12-25 18:06:35'),(22653,18088,'Y','18','021','EC','A','','','AC','0000951563','0000951563','TX00002308643','IL','1','LEAVITT','KATJA','','','','34','639728529','3406 GUS DR',0,'KILLEEN','TX','76549','3112','CY','48027','1977-04-30','F','U',NULL,'N','021','DEN','2687107','33348TX002000201','2014-03-01','2014-02-11 11:45:47','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-11 21:00:29'),(6479,5131,'Y','18','021','EC','A','','','AC','0000032932','0000032932','OH00001101988','IL','1','Carson','Jessie','','','Jr','34','300521813','4707 HOPE AVE',0,'ASHTABULA','OH','44004','6507','CY','39007','1951-01-05','M','U',':RET:2054-5','N','021','HLT','1192015','52664OH151001305','2014-01-01','2013-12-11 08:41:15','644.00',NULL,NULL,'722.61','78.61','R-OH011','OH0','722.61',NULL,0,'2013-12-26 00:50:16'),(3220,2591,'Y','18','021','EC','A','','','AC','0000997609','0000997609','TX00001010998','IL','1','Groves','Russell','','','','34','459954508','1008 HERMITAGE DR',0,'AUSTIN','TX','78753','5864','CY','48453','1983-12-12','M','U',':RET:2106-3','N','021','DEN','1180013','33348TX002000101','2014-01-01','2013-10-31 18:26:47','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 20:45:42'),(6119,4853,'Y','18','021','EC','A','','','AC','0000315241','0000315241','TX00001213868','31','1','King','Michael','','','','34','467294996','PO Box 1326',0,'Winnsboro','TX','75494',NULL,'CY','48499','1960-05-10','M','M',':RET:2106-3','N','021','DEN','97979','33348TX002000201','2014-01-01','2013-11-20 20:52:01','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:15:41'),(5937,4701,'Y','18','021','EC','A','','','AC','0001790135','0001790135','LA00000221413','IL','1','Turner','Gloria','','','','34','438828218','3603 Curry Street',0,'Monroe','LA','71203',NULL,'CY','22073','1950-04-20','F','U',':RET:2054-5','N','021','DEN','2524438','18575LA002000101','2014-01-01','2013-12-23 22:47:54','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-25 23:50:42'),(16804,13440,'N','01','021','EC','A',NULL,NULL,'','0000803016','0000679840','','IL','1','Adams','Lee','','','','34','467458030','1634 county road 234',0,'Jasper','TX','75951',NULL,'CY','48241','1964-03-19','M','',':RET:2106-3','N','021','DEN','2639592','33348TX002000201','2014-02-01','2014-01-11 11:36:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:18:12'),(19207,15302,'Y','18','021','EC','A','','','AC','0000155811','0000155811','OH00002449983','IL','1','Gussey','John','','','','34','280902022','890 W TUSCARAWAS AVE',0,'BARBERTON','OH','44203','7135','CY','39153','1989-02-05','M','U',':RET:2106-3','N','021','DEN','1669398','99734OH005000401','2014-03-01','2014-01-19 19:56:12','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-21 08:46:19'),(17859,14267,'Y','18','021','EC','A','','','AC','0000172417','0000172417','OH00002063355','IL','1','Line','Steven','','','','34','286665623','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1959-06-13','M','M',':RET:2106-3','T','021','DEN','1441285','99734OH005000401','2014-02-01','2014-01-14 11:16:40','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:10'),(16300,13050,'Y','18','021','EC','A','','','AC','0001929116','0001929116','LA00001888537','IL','1','ASHLEY','RUBY','','','','34','438842149','3523 MILTON ST',0,'SHREVEPORT','LA','71109','3325','CY','22017','1949-06-10','F','M',':RET:2054-5','N','021','DEN','2120145','18575LA002000201','2014-02-01','2014-01-06 15:47:48','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-07 04:01:07'),(16038,12841,'Y','18','021','EC','A','','','AC','0000322933','0000322933','TX00001502597','IL','1','Campbell','Tiffany','','','','34','462912724','302 Hawthorne',0,'Abilene','TX','79605',NULL,'CY','48441','1976-05-04','F','U',':RET:2106-3','N','021','DEN','1419187','33348TX002000101','2014-02-01','2014-01-02 18:59:46','0.00',NULL,NULL,'25.02','25.02','R-TX001','TX0','25.02',NULL,0,'2014-01-04 02:02:44'),(6925,5497,'Y','18','024','14','A','','','TE','0000637111','0000637111','','IL','1','Givens','Garland',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-05-12','M','',NULL,NULL,NULL,'','1960578','','2013-12-24','2013-12-24 19:16:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 01:46:20'),(13654,10893,'Y','18','021','EC','A','','','AC','0001869476','0001869476','LA00000545781','IL','1','Riggleman','Christopher','','','','34','569872894','3011 LAFITTE ST',0,'NEW ORLEANS','LA','70119','4005','CY','22071','1985-11-15','M','U',':RET:2106-3','N','021','DEN','1685815','18575LA002000101','2014-01-01','2013-12-22 23:37:36','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:24'),(13293,10610,'N','01','021','EC','A',NULL,NULL,'','0001240339','0001145991','','IL','1','castillo','elsa','','','','34','863959046','206 South Caddo Street',0,'Cleburne','TX','76031',NULL,'CY','48251','1962-05-26','F','',NULL,'N','021','DEN','1788491','33348TX002000201','2014-01-01','2013-12-23 13:42:46',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 12:57:31'),(9238,7329,'N','19','021','EC','A',NULL,NULL,'','0000685832','0000976703','','IL','1','Okes','Andrew','James','','','34','269988160','11 phillip court',0,'elyria','OH','44035',NULL,'CY','39093','1994-07-14','M','',':RET:2106-3','N','021','HLT','2256482','92036OH004000801','2014-01-01','2013-12-18 15:51:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','119.38',NULL,0,'2013-12-26 04:10:37'),(9202,7299,'Y','18','021','EC','A','','','AC','0001205809','0001205809','OH00001047004','IL','1','Rhoades','Sharon','K','','','34','274449739','1463 LANTERN LN',0,'TROY','OH','45373','4767','CY','39109','1949-06-28','F','U',':RET:2106-3','N','021','HLT','1894843','92036OH004000501','2014-01-01','2013-12-18 10:44:16','0.00',NULL,NULL,'573.40','573.40','R-OH003','OH0','573.40',NULL,0,'2013-12-26 04:09:42'),(8973,7116,'N','01','021','EC','A',NULL,NULL,'','0000370007','0000520950','','IL','1','Ward','Benjamin','','','','34','403273291','2525 BRENDEL DR',0,'COLUMBUS','OH','43235','8004','CY','39049','1984-10-28','M','',NULL,'T','021','DEN','2186646','99734OH005000401','2014-01-01','2013-12-18 15:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:04:07'),(8004,6334,'Y','18','021','EC','A','','','AC','0001025621','0001025621','TX00000921605','IL','1','Garza','Carolina','','','','34','459898805','2125 W IRIS AVE',0,'MCALLEN','TX','78501','6033','CY','48215','1987-03-31','F','U',NULL,'N','021','DEN','2440785','33348TX002000101','2014-01-01','2013-12-19 22:33:34','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-26 03:08:27'),(22798,18199,'N','19','021','EC','A',NULL,NULL,'','0000229477','0000885640','','IL','1','Swisher','Elizabeth','','','','34','300949725','1358 N NISSEN RD',0,'MARTIN','OH','43445','9714','CY','39123','1992-08-03','F','',':RET:2106-3','N','021','DEN','3292565','99734OH005000301','2014-03-01','2014-02-11 13:07:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:52'),(22816,18209,'Y','18','021','EC','A','','','AC','0001212374','0001212374','OH00002154410','IL','1','Richmond','Diane','','','','34','270501096','3911 Lake Vista Rd',0,'Akron','OH','44319',NULL,'CY','39153','1958-04-20','F','U',':RET:2106-3','N','021','DEN','3770235','99734OH005000301','2014-03-01','2014-02-11 17:43:15','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-11 21:02:00'),(23676,18852,'Y','18','021','EC','A','','','AC','0001510419','0001510419','LA00001868131','IL','1','Romero','Richelle','','','','34','439922614','3700 Wanda Lynn Drive',0,'Metairie','LA','70002',NULL,'CY','22051','1969-11-26','F','U',':RET:2106-3','N','021','DEN','3161360','18575LA002000201','2014-03-01','2014-02-14 00:01:22','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-14 21:30:27'),(24867,19717,'Y','18','021','EC','A','','','AC','0000326755','0000326755','TX00002672974','IL','1','White','Areniqua','','','','34','464777281','1369 N Hampton Apt48',0,'Desoto','TX','75115',NULL,'CY','48113','1986-06-20','F','M',':RET:2054-5','N','021','DEN','3272990','33348TX002000201','2014-04-01','2014-02-19 16:20:08','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85','CIC',0,'2014-02-20 05:32:05'),(25991,20612,'Y','18','021','EC','A','','','AC','0000296521','0000296521','MS00002437917','IL','1','Jackson','Anthony','','','','34','426379017','107 Suzanne Cove',0,'Clinton','MS','39056',NULL,'CY','28049','1974-02-02','M','U',':RET:2054-5','N','021','DEN','2914308','46300MS002000201','2014-04-01','2014-02-26 14:11:01','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:56'),(27448,21722,'N','19','021','EC','A',NULL,NULL,'','0000133372','0001093195','','IL','1','Andrews','Charity','Elizabeth','','','34','297965547','350 ROBERT DR',0,'KENT','OH','44240','2156','CY','39133','1994-03-07','F','',':RET:2106-3','N','021','HLT','3852436','52664OH151001501','2014-04-01','2014-03-04 09:00:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','169.84',NULL,0,'2014-03-04 21:01:57'),(28762,22766,'Y','18','024','14','A','','','TE','0000368559','0000368559','','IL','1','Godbolt','Johnduras',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-13','M','',NULL,NULL,NULL,'','3895328','','2014-03-08','2014-03-09 14:32:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-09 21:00:23'),(3136,2521,'Y','18','021','EC','A','','','AC','0001064922','0001064922','TX00001208702','31','1','CAVAZOS','MARTIN','','','','34','457881743','PO BOX 209',0,'TIVOLI','TX','77990',NULL,'CY','48391','1949-05-14','M','M',NULL,'N','021','DEN','685632','33348TX002000101','2014-01-01','2013-11-18 12:47:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:30:41'),(21741,17360,'Y','18','021','EC','A','','','AC','0000845892','0000845892','TX00001401361','IL','1','Smiles','Alonna','','','','34','454210308','406 Angelina Drive',0,'Arlington','TX','76018',NULL,'CY','48439','1964-05-31','F','U',NULL,'N','021','DEN','2738992','33348TX002000201','2014-03-01','2014-02-06 17:55:49','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-06 21:00:15'),(21434,17131,'Y','18','024','14','A','','','TE','0000913717','0000913717','','IL','1','Austin','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-01-24','F','',NULL,NULL,NULL,'','3570541','','2014-02-04','2014-02-04 16:23:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:01:20'),(7946,6286,'Y','18','021','EC','A','','','AC','0002156014','0002156014','LA00000684964','IL','1','clark','toni','','','','34','439350077','28821 HIGHWAY 23',0,'PORT SULPHUR','LA','70083','2927','CY','22075','1966-11-10','F','U',':RET:2106-3','N','021','DEN','2250205','18575LA002000201','2014-01-01','2013-12-20 15:37:31','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:07:02'),(13503,10761,'Y','18','021','EC','A','','','AC','0001393300','0001393300','LA00000530282','IL','1','Frazier','Katrina','','','','34','437390325','1716 Malcolm st',0,'Shreveport','LA','71108',NULL,'CY','22017','1978-05-30','F','M',':RET:2054-5','N','021','DEN','2229436','18575LA002000201','2014-01-01','2013-12-22 18:54:04','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:02:38'),(15535,12430,'Y','18','021','EC','A','','','AC','0001780573','0001780573','LA00001617495','IL','1','Horton','Katherine','','','','34','422212948','1208 E BAYOU PKWY',0,'LAFAYETTE','LA','70508','5504','CY','22055','1985-06-27','F','U',':RET:2106-3','N','021','DEN','2542554','18575LA002000201','2014-02-01','2013-12-31 13:44:01','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:30:46'),(17217,13778,'Y','18','021','EC','A','','','AC','0000396455','0000396455','MS00001829455','IL','1','Jackson','Linda','','','','34','547862508','1638 Holly Bush Rd',0,'Pelahatchie','MS','39145',NULL,'CY','28121','1952-03-18','F','U',NULL,'N','021','DEN','2471926','46300MS002000201','2014-02-01','2014-01-08 13:39:35','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-13 02:22:32'),(23287,18565,'Y','18','021','EC','A','','','AC','0000367425','0000367425','OH00002557531','IL','1','Brown','Adrian','','','','34','286809122','121 South Main Street',0,'New Lexington','OH','43764',NULL,'CY','39127','1976-06-17','M','M',NULL,'N','021','DEN','3584977','99734OH005000301','2014-03-01','2014-02-12 19:24:50','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-02-13 22:00:04'),(23492,18713,'Y','18','024','14','A','','','TE','0000035793','0000035793','','IL','1','Ramos','Jaime','Elizabeth',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-11-24','F','',NULL,NULL,NULL,'','2862040','','2014-02-12','2014-02-12 20:32:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:02:03'),(25695,20386,'Y','18','021','EC','A','','','AC','0000159466','0000159466','TX00002868314','IL','1','rivera','guillermo','','','','34','454435293','845 E. Taylor',0,'Brownsville','TX','78520',NULL,'CY','48061','1975-10-18','M','M',NULL,'N','021','DEN','2797924','33348TX002000201','2014-04-01','2014-02-24 00:46:30','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-02-26 09:30:15'),(26256,20825,'Y','18','021','EC','A','','','AC','0000923928','0000923928','TX00002673193','IL','1','GARZA','ELOY','','','','34','307580682','2918 E RICHARDSON RD',0,'EDINBURG','TX','78542','0464','CY','48215','1956-11-24','M','M',NULL,'N','021','DEN','2862412','33348TX002000201','2014-04-01','2014-02-27 15:20:28','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-28 06:31:10'),(308,252,'N','G8','021','EC','A',NULL,NULL,'','0000124058','0000813048','','IL','1','marivani','Paloma','','','','34','642221597','5623 STAR VIEW DR',0,'EL PASO','TX','79912','6427','CY','48141','1990-05-14','F','',':RET:2106-3','N','021','DEN','555509','33348TX002000101','2014-01-01','2013-11-12 18:19:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 17:30:57'),(4854,3845,'Y','18','021','EC','A','','','AC','0000166336','0000166336','OH00000809823','IL','1','Marcosson','Alan','','','','34','293488857','9300 MEMPHIS VILLAS BLVD',0,'BROOKLYN','OH','44144','2435','CY','39035','1950-07-31','M','U',':RET:2106-3','N','021','DEN','1213951','99734OH005000401','2014-01-01','2013-11-08 17:55:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:30:27'),(20527,16402,'N','01','021','EC','A',NULL,NULL,'','0000429075','0000984878','','IL','1','Budzinski','Aaron','','','','34','280763956','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','1978-08-03','M','',NULL,'N','021','HLT','2833778','92036OH005002605','2014-03-01','2014-01-29 15:39:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','238.27',NULL,0,'2014-01-29 21:01:28'),(7343,5815,'N','19','021','EC','A',NULL,NULL,'','0000109265','0001019248','','IL','1','Forsyth','Tia','','','','34','291046704','3672 Sanctuary Dr.',0,'Akron','OH','44333',NULL,'CY','39153','1999-10-29','F','',':RET:2106-3','N','021','HLT','246118','52664OH152000901','2014-01-01','2013-12-14 16:24:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-26 02:04:04'),(19695,15694,'N','01','021','EC','A',NULL,NULL,'','0000925282','0000330497','','IL','1','NGUYEN','DONNA','THY','','','34','462717935','5104 FORT BUCKNER DR',0,'MCKINNEY','TX','75070','1000','CY','48085','1953-11-04','F','',':RET:2047-9','N','021','DEN','3083989','33348TX002000201','2014-03-01','2014-01-22 23:07:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-23 21:00:44'),(19214,15309,'Y','18','024','14','A','','','TE','0000481036','0000481036','','IL','1','BUTTRAM','MICHAEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-06','M','',NULL,NULL,NULL,'','368970','','2014-01-20','2014-01-20 12:16:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:23'),(14249,11364,'Y','18','021','EC','A','','','AC','0000689556','0000689556','TX00001144024','IL','1','Gutierrez','Candelario','','','','34','460922469','2512 quince lane',0,'Mcallen','TX','78501',NULL,'CY','48215','1953-02-02','M','M',NULL,'N','021','DEN','2409183','33348TX002000101','2014-02-01','2013-12-26 13:04:10','0.00',NULL,NULL,'50.04','50.04','R-TX015','TX0','25.02',NULL,0,'2013-12-27 02:05:27'),(18459,14726,'Y','18','021','EC','A','','','AC','0002339696','0002339696','LA00002004866','IL','1','burton','anthony','','','','34','436631620','18256 manchac acres dr',0,'prairieville','LA','70769',NULL,'CY','22005','1977-04-15','M','M',':RET:2106-3','N','021','DEN','2453725','18575LA002000101','2014-02-01','2014-01-15 14:15:15','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:11'),(25359,20121,'Y','18','021','EC','A','','','AC','0000327324','0000327324','OH00003256024','IL','1','reid','lettie','','','','34','271580344','276 W NORTH BEND RD',0,'CINCINNATI','OH','45216','1728','CY','39061','1957-10-18','F','U',NULL,'N','021','DEN','3156750','99734OH005000301','2014-04-01','2014-02-24 21:42:32','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:35'),(318,261,'Y','18','021','EC','A','','','AC','0000193139','0000193139','LA00000618417','IL','1','Nevitt','Jackson','','','','34','433577490','321 DUCLOS ST',0,'LAFAYETTE','LA','70506','2525','CY','22055','1984-12-02','M','U',':RET:2106-3','N','021','DEN','663272','18575LA002000101','2014-01-01','2013-11-12 21:07:57','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-25 17:31:16'),(21675,17309,'Y','18','021','EC','A','','','AC','0001725426','0001725426','LA00002367171','IL','1','NGUYEN','JIMMY','','','','34','435512126','729 WILLOWBROOK DR',0,'GRETNA','LA','70056','7927','CY','22051','1954-09-16','M','M',NULL,'N','021','DEN','3407952','18575LA002000201','2014-03-01','2014-02-05 16:29:20','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:31:00'),(6359,5041,'Y','18','021','EC','A','','','AC','0000385879','0000385879','OH00000560185','IL','1','Langenbrunner','Joyce','A','','','34','281423784','110 FERN VALLEY WAY',0,'SOUTH LEBANON','OH','45065','1192','CY','39165','1952-07-29','F','U',':RET:2106-3','N','021','DEN','897513','99734OH005000401','2014-01-01','2013-12-11 17:30:30','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:47:17'),(18629,14849,'Y','18','021','EC','A','','','AC','0000781922','0000781922','OH00002255378','IL','1','Weirich','Margaret','','','','34','284508552','6536 WOODHALL DR',0,'SYLVANIA','OH','43560','3458','CY','39095','1951-03-03','F','U',':RET:2106-3','N','021','HLT','2489858','92036OH003002604','2014-02-01','2014-01-15 17:38:35','357.00',NULL,NULL,'585.04','228.04','R-OH001','OH0','585.04',NULL,0,'2014-01-16 08:47:31'),(18512,14762,'N','19','021','EC','A',NULL,NULL,'','0000932125','0000388665','','S1','1','Mohr','J','Gregory','','','34','292155798','192 Garmatter St',0,'Bluffton','OH','45817',NULL,'CY','39003','2010-02-17','F','',':RET:2106-3','N','021','HLT','2043952','92036OH004001501','2014-02-01','2014-01-15 10:52:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-01-16 08:46:34'),(18125,14475,'N','01','021','EC','A',NULL,NULL,'','0000611972','0000170181','','IL','1','Lord','David','','','','34','568559168','1976 KELSEY DR',0,'CUYAHOGA FALLS','OH','44221','4344','CY','39153','1963-05-17','M','',':RET:2106-3','N','021','HLT','2656983','52664OH152000901','2014-02-01','2014-01-14 18:04:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','291.73',NULL,0,'2014-01-15 02:07:41'),(18123,14474,'Y','18','021','EC','A','','','AC','0000970474','0000970474','OH00002524168','IL','1','Smith','Cynthia','','','','34','286505686','9788 BAINBRIDGE RD',0,'CHAGRIN FALLS','OH','44023','5440','CY','39055','1950-07-04','F','M',':RET:2106-3','N','021','HLT','2393501','52664OH152000901','2014-02-01','2014-01-14 17:06:28','391.00',NULL,NULL,'543.83','152.83','R-OH011','OH0','543.83',NULL,0,'2014-01-15 02:07:41'),(13877,11073,'Y','18','021','EC','A','','','AC','0000133314','0000133314','OH00000633379','IL','1','Mahota-Blessing','Kimberly','','','','34','021469762','176 26TH ST NW',0,'BARBERTON','OH','44203','6916','CY','39153','1955-09-01','F','U',':RET:2106-3','N','021','HLT','1429470','52664OH151001501','2014-01-01','2013-12-23 14:29:56','458.00',NULL,NULL,'681.50','223.50','R-OH012','OH0','681.50',NULL,0,'2013-12-26 13:13:13'),(17289,13827,'Y','18','021','EC','A','','','AC','0000612374','0000612374','TX00001736406','IL','1','Rawlins','Heather','','','','34','637308939','107 28TH ST',0,'CANYON','TX','79015','3130','CY','48381','1988-08-04','F','U',':RET:1002-5^:RET:2106-3','T','021','DEN','1729531','33348TX002000201','2014-02-01','2014-01-09 21:42:06','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-13 02:23:31'),(14578,11633,'Y','18','021','EC','A','','','AC','0002317462','0002317462','LA00001165309','IL','1','Starnes','Paula','','','','34','438230187','13466 BLOUIN RD',0,'BATON ROUGE','LA','70819','2409','CY','22033','1975-03-03','F','U',':RET:2106-3','T','021','DEN','1450741','18575LA002000101','2014-02-01','2013-12-27 12:13:28','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-28 03:35:46'),(22869,18243,'N','17','021','EC','A',NULL,NULL,'','0000432803','0000984891','','S3','1','vo','trang thao','thi','','','34','289024719','610 chestnut ln',0,'boardman','OH','44512',NULL,'CY','39099','1997-11-19','F','',':RET:2047-9','N','021','HLT','3682106','92036OH005003204','2014-03-01','2014-02-10 22:50:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','153.71',NULL,0,'2014-02-11 21:02:30'),(27809,21994,'Y','18','021','EC','A','','','AC','0000443513','0000443513','OH00003446323','IL','1','McConnell','Margaret','','','','34','207668856','524 Sandpiper Lane',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-03-25','F','U',':RET:2106-3','N','021','HLT','2625809','52664OH151001305','2014-04-01','2014-03-05 13:01:20','114.00',NULL,NULL,'233.71','119.71','R-OH012','OH0','233.71',NULL,0,'2014-03-05 21:31:49'),(740,613,'Y','18','021','EC','A','','','AC','0000540755','0000540755','TX00000690158','IL','1','Tovar','Patricia','','','','34','453677505','1817 E. Oltorf St',0,'Austin','TX','78741',NULL,'CY','48453','1979-01-31','F','U',':RET:2106-3','N','021','DEN','710829','33348TX002000201','2014-01-01','2013-12-15 22:07:47','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:01'),(21820,17425,'Y','18','024','14','A','','','TE','0000203118','0000203118','','IL','1','Meyers','Delilah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-08-09','F','',NULL,NULL,NULL,'','3147842','','2014-02-06','2014-02-06 09:43:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-06 21:00:59'),(5876,4662,'N','01','021','EC','A',NULL,NULL,'','0000794497','0001114536','','IL','1','Trimble Shell','Karen','','','','34','280566593','2842 CYPRESS WAY',0,'CINCINNATI','OH','45212','2446','CY','39061','1956-10-21','F','',':RET:2106-3','N','021','DEN','2068413','99734OH005000301','2014-01-01','2013-12-23 21:11:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:19'),(21305,17024,'Y','18','024','14','A','','','TE','0001987425','0001987425','','IL','1','pouncey','whitney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-02-24','F','',NULL,NULL,NULL,'','2813121','','2014-02-03','2014-02-03 22:23:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-04 21:00:14'),(9357,7417,'Y','18','021','EC','A','','','AC','0001905987','0001905987','LA00001252216','IL','1','Gascot-Barroso','Liza','','','','34','581612076','7324 Menlo Dr.',0,'Baton Rouge','LA','70808',NULL,'CY','22033','1975-07-31','F','M',NULL,'N','021','DEN','1712873','18575LA002000201','2014-01-01','2013-12-21 07:05:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:31:25'),(18815,14986,'Y','18','024','14','A','','','TE','0001108099','0001108099','','IL','1','Decker','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-05','F','',NULL,NULL,NULL,'','1755345','','2014-01-15','2014-01-15 19:53:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-17 03:36:04'),(13232,10557,'Y','18','021','EC','A','','','AC','0000345189','0000345189','TX00000473416','IL','1','Noyola','Jaime','','','','34','459851177','2105 CAMPFIELD PKWY',0,'AUSTIN','TX','78745','6350','CY','48453','1975-03-04','M','U',NULL,'N','021','DEN','2520575','33348TX002000201','2014-01-01','2013-12-22 22:23:18','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 12:55:46'),(24175,19206,'Y','18','024','14','A','','','TE','0000582236','0000582236','','IL','1','Bradberry','Barton',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-04-22','M','',NULL,NULL,NULL,'','3460460','','2014-02-28','2014-02-15 23:25:23',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'TERMCIC',0,'2014-02-16 19:00:03'),(24335,19325,'N','01','021','EC','A',NULL,NULL,'','0000491887','0001088671','','IL','1','Ransleben','Gordon','','','','34','465968209','592 CHERRY HOLLOW DR',0,'FREDERICKSBURG','TX','78624','6704','CY','48171','1955-12-20','M','',':RET:2106-3','N','021','DEN','3285737','33348TX002000201','2014-04-01','2014-02-18 14:02:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-18 22:00:15'),(25412,20162,'Y','18','021','EC','A','','','AC','0001090962','0001090962','OH00002493357','IL','1','SQUICCIARINI','DONNA','LYNN','','','34','292604143','6601 BEECHMONT AVE',0,'CINCINNATI','OH','45230','5900','CY','39061','1964-02-17','F','U',':RET:2106-3','N','021','DEN','3369346','99734OH005000401','2014-04-01','2014-02-25 12:11:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:31:04'),(1186,977,'Y','18','021','EC','A','','','AC','0000493191','0000493191','OH00000787930','IL','1','Fleming','William','','','','34','404721636','153 Westwood',0,'Amherst','OH','44001',NULL,'CY','39093','1949-09-22','M','M',':RET:2106-3','N','021','DEN','671996','99734OH005000301','2014-01-01','2013-12-03 09:37:57','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:19:30'),(23100,18413,'Y','18','021','EC','A','','','AC','0001155137','0001155137','OH00001703395','IL','1','Nelson','Alyse','','','','34','282482442','3840 W 128TH ST',0,'CLEVELAND','OH','44111','4511','CY','39035','1952-01-21','F','M',':RET:2106-3','T','021','DEN','2749483','99734OH005000401','2014-03-01','2014-02-12 15:23:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-12 21:31:11'),(1348,1116,'Y','18','021','EC','A','','','AC','0001026851','0001026851','TX00000326050','IL','1','Rivas','Paul','','','','34','449317328','917 E 36TH ST',0,'LUBBOCK','TX','79404','2511','CY','48303','1974-04-19','M','U',NULL,'N','021','DEN','1459421','33348TX002000101','2014-01-01','2013-12-24 11:06:04','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 18:45:09'),(1853,1518,'Y','18','021','EC','A','','','AC','0000057335','0000057335','OH00001373363','IL','1','Halpin','Dennis','','','','34','295444911','10356 Marvin Road',0,'Harrison','OH','45030',NULL,'CY','39061','1952-06-01','M','M',':RET:2106-3','N','021','HLT','2056929','92036OH005001205','2014-01-01','2013-12-24 15:38:51','850.00',NULL,NULL,'1150.21','300.21','R-OH004','OH0','603.24',NULL,0,'2013-12-25 18:57:59'),(2639,2144,'Y','18','021','EC','A','','','AC','0000993939','0000993939','OH00000071166','IL','1','Fulkner','Connie','Mae','','','34','272689408','484 DREXEL AVE',0,'LEBANON','OH','45036','1616','CY','39165','1959-12-04','F','M',':RET:2106-3','N','021','DEN','39663','99734OH005000401','2014-01-01','2013-12-02 16:14:18','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:46:18'),(7169,5684,'N','01','021','EC','A',NULL,NULL,'','0000870633','0000291976','','IL','1','Chen','Yan Rong','','','','34','120748481','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1974-10-28','F','',':RET:2034-7','N','021','HLT','1985187','92036OH003002705','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','256.98',NULL,0,'2013-12-26 01:52:39'),(22564,18020,'Y','18','021','EC','A','','','AC','0000021421','0000021421','OH00002377579','IL','1','Long','Doris','Jean','','','34','283707604','1236 FERNWOOD AVE',0,'TOLEDO','OH','43607','1848','CY','39095','1961-03-01','F','U',':RET:2054-5','N','021','DEN','2866548','99734OH005000401','2014-03-01','2014-02-10 13:01:53','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-02-10 21:31:53'),(3651,2922,'Y','18','021','EC','A','','','AC','0000437952','0000437952','OH00000718798','IL','1','Wilken','Susan','','','','34','294827784','7401 HICKMAN ST',0,'CINCINNATI','OH','45231','4431','CY','39061','1969-10-19','F','U',':RET:2106-3','N','021','DEN','1236206','99734OH005000401','2014-01-01','2013-12-12 18:54:24','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:30:38'),(3656,2925,'Y','18','021','EC','A','','','AC','0000285619','0000285619','OH00000190746','IL','1','SANDLIN','ANGELA','','','','34','282626901','9515 GREENSVILLE FALLS ROAD',0,'COVINGTON','OH','45318',NULL,'CY','39109','1971-05-26','F','U',':RET:2106-3','N','021','DEN','210235','99734OH005000401','2014-01-01','2013-12-12 19:26:57','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 21:30:45'),(9539,7559,'N','01','021','EC','A',NULL,NULL,'','0000546469','0000785785','','IL','1','Hayden','Larita','','','','34','532963037','1736 Llanfair Ave.',0,'Cincinnati','OH','45224',NULL,'CY','39061','1983-04-03','F','',':RET:2054-5','N','021','DEN','2490277','99734OH005000301','2014-01-01','2013-12-21 11:01:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:35:58'),(21394,17096,'Y','18','021','EC','A','','','AC','0001106813','0001106813','OH00001951714','IL','1','Ofori','Albert','','','','34','276178944','374 Hampshire Dr.',0,'Hamilton','OH','45011',NULL,'CY','39017','1984-08-14','M','U',':RET:2054-5','N','021','DEN','3467898','99734OH005000401','2014-03-01','2014-02-04 11:01:33','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:00:58'),(20177,16101,'Y','18','024','14','A','','','TE','0000249092','0000249092','','IL','1','LUOMA','ERIN','ANNE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-06-29','F','',NULL,NULL,NULL,'','1247802','','2014-01-27','2014-01-27 14:54:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:18'),(19371,15442,'Y','18','021','EC','A','','','AC','0000881652','0000881652','OH00001444921','IL','1','Eaken','Danny','','','','34','299527044','9481 WILLOW RD',0,'LODI','OH','44254','9630','CY','39103','1956-01-10','M','M',':RET:2106-3','T','021','HLT','3079286','52664OH151001304','2014-03-01','2014-01-21 10:47:47','910.00',NULL,NULL,'1410.53','500.53','R-OH012','OH0','653.46',NULL,1,'2014-01-22 03:22:36'),(17628,14093,'N','01','021','EC','A',NULL,NULL,'','0000953797','0001041432','','IL','1','GUNERATNE','NILUSHA','DUSHMANTHA','','','34','612252094','1334 RED STAG PL',0,'ROUND ROCK','TX','78665','1359','CY','48491','1977-09-27','F','',':RET:2028-9','N','021','DEN','1928466','33348TX002000201','2014-02-01','2014-01-13 16:05:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-14 01:32:31'),(24704,19613,'Y','18','021','EC','A','','','AC','0000584317','0000584317','OH00002870921','IL','1','promen','stephen','','','','34','268569160','5415 dunmere ln',0,'dublin','OH','43017',NULL,'CY','39049','1954-09-14','M','U',':RET:2106-3','T','021','DEN','3151518','99734OH005000401','2014-04-01','2014-02-19 00:03:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:34:32'),(24744,19640,'Y','18','021','EC','A','','','AC','0000720297','0000720297','OH00002854339','IL','1','SUBER','KATRINA','','','','34','298709971','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','1976-02-22','F','U',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:40:44'),(25070,19882,'Y','18','021','EC','A','','','AC','0000528299','0000528299','OH00001379856','IL','1','keltner','annette','','','','34','298663984','1410 ROSE HILL RD',0,'HAMERSVILLE','OH','45130','8716','CY','39015','1959-10-20','F','U',':RET:2106-3','N','021','HLT','2758995','92036OH004000601','2014-04-01','2014-02-19 23:50:19','349.00',NULL,NULL,'368.53','19.53','R-OH005','OH0','368.53',NULL,0,'2014-02-20 22:01:29'),(28779,22781,'Y','18','021','EC','A','','','AC','0001188854','0001188854','OH00003108951','IL','1','Ayete','Samuel','','','','34','660351067','5109 PLEASANT AVE',0,'FAIRFIELD','OH','45014','2671','CY','39017','1968-01-21','M','U',':RET:2054-5','N','021','DEN','3959685','99734OH005000401','2014-04-01','2014-03-09 14:34:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-09 21:00:34'),(28892,22868,'Y','18','021','EC','A','','','AC','0000242590','0000242590','TX00003507258','IL','1','SANDERS','YVONE','','','','34','165440964','5613 SILTSTONE LOOP',0,'KILLEEN','TX','76542','5763','CY','48027','1952-09-21','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','3471314','33348TX002000201','2014-04-01','2014-03-10 15:18:05','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-03-10 21:00:15'),(29106,23039,'Y','18','021','EC','A','','','AC','0000876128','0000876128','OH00003614546','IL','1','WERLING','LYNN','E','','','34','294449939','11977 GLYNWOOD RD',0,'WAPAKONETA','OH','45895','9439','CY','39011','1955-08-22','M','M',':RET:2106-3','N','021','HLT','3544677','92036OH003001501','2014-05-01','2014-03-10 11:44:46','275.00',NULL,NULL,'585.61','310.61','R-OH002','OH0','585.61',NULL,0,'2014-03-10 21:02:20'),(2926,2358,'Y','18','021','EC','A','','','AC','0000642051','0000642051','OH00000847769','IL','1','johnson','Richard','','','','34','270548587','620 BAURICHTER ST',0,'CINCINNATI','OH','45204','1142','CY','39061','1954-07-22','M','M',':RET:2106-3','N','021','DEN','240090','99734OH005000401','2014-01-01','2013-12-06 18:12:08','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:15:54'),(22855,18235,'N','19','021','EC','A',NULL,NULL,'','0001208353','0000279592','','IL','1','Keiffer','Brayden','James','','','34','279111924','1418 S TOWNSHIP ROAD 37',0,'FOSTORIA','OH','44830','9622','CY','39147','2005-04-19','M','',':RET:2106-3','N','021','HLT','2797614','92036OH003002704','2014-03-01','2014-02-10 22:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-11 21:02:23'),(21813,17419,'N','19','021','EC','A',NULL,NULL,'','0000616909','0000605998','','IL','1','Chryst','George','Thomas',NULL,NULL,NULL,NULL,'15909 Clifton  Blvd',0,'Lakewood','OH','44107',NULL,'CY','39035','2005-02-18','M','',NULL,'N','021','HLT','3214225','52664OH151001304','2014-03-01','2014-02-06 12:48:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-02-06 21:00:55'),(21270,16999,'Y','18','021','EC','A','','','AC','0001050122','0001050122','TX00002500911','IL','1','Bennings','Ella','','','','34','456865763','809 E 78TH ST',0,'LUBBOCK','TX','79404','6611','CY','48303','1951-11-22','F','M',':RET:2054-5','N','021','DEN','2275925','33348TX002000101','2014-03-01','2014-02-03 18:04:08','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2014-02-03 21:01:30'),(3576,2871,'Y','18','021','EC','A','','','AC','0000777665','0000777665','OH00000719198','IL','1','joseph','gerald','','','','34','291484004','7367 CLUM RD',0,'HARROD','OH','45850','9413','CY','39003','1950-09-17','M','M',':RET:2106-3','T','021','HLT','1404270','92036OH004001501','2014-01-01','2013-12-22 08:49:37','1111.12',NULL,NULL,'1119.30','8.18','R-OH002','OH0','600.76',NULL,0,'2013-12-25 21:22:40'),(13875,11071,'Y','18','024','14','A','','','TE','0000264202','0000264202','','IL','1','Peterson','Aaron',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-05-08','M','',NULL,NULL,NULL,'','1945486','','2013-12-23','2013-12-23 13:38:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:13:10'),(15889,12723,'Y','18','021','EC','A','','','AC','0000857111','0000857111','OH00001554331','IL','1','Mann','John','Robert','','','34','270527425','6514 Meis Ave',0,'Cincinnati','OH','45224',NULL,'CY','39061','1951-11-01','M','U',':RET:2106-3','N','021','HLT','1955669','92036OH004001201','2014-02-01','2014-01-02 14:52:57','220.00',NULL,NULL,'495.91','275.91','R-OH004','OH0','495.91',NULL,0,'2014-01-03 02:05:41'),(17920,14315,'Y','18','021','EC','A','','','AC','0001233121','0001233121','TX00002529430','IL','1','Zacarias-Camarillo','Crystal','','','','34','465594625','14310 COTTINGHAM DR',0,'AUSTIN','TX','78725','4782','CY','48453','1983-02-06','F','R',':RET:2106-3','N','021','DEN','1941168','33348TX002000201','2014-02-01','2014-01-14 10:58:33','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-01-15 02:06:31'),(17415,13938,'Y','18','021','EC','A','','','AC','0001203227','0001203227','OH00001785459','IL','1','HUNDLEY','ROBERT','','','','34','263533272','154 BRUSHWOOD DR',0,'LOVELAND','OH','45140','2612','CY','39061','1958-09-28','M','M',NULL,'N','021','HLT','1817030','92036OH005001204','2014-02-01','2014-01-10 10:08:14','622.00',NULL,NULL,'957.44','335.44','R-OH004','OH0','478.72',NULL,0,'2014-01-13 03:00:24'),(24963,19797,'Y','18','021','EC','A','','','AC','0001942258','0001942258','LA00003083846','IL','1','TULL','STEPHANIE','','','','34','433414895','59655 HIGHWAY 1148',0,'PLAQUEMINE','LA','70764','5333','CY','22047','1967-06-29','F','U',':RET:2106-3','N','021','DEN','3514019','18575LA002000201','2014-04-01','2014-02-20 17:33:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 22:00:20'),(108,95,'Y','18','024','14','A','','','TE','0000383812','0000383812','','IL','1','Elms','Deborah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-09-08','F','',NULL,NULL,NULL,'','849947','','2013-12-05','2013-12-05 11:46:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 17:17:54'),(6979,5538,'Y','18','021','EC','A','','','AC','0000915653','0000915653','OH00001490286','IL','1','Thompson','Joseph','','','','34','297643202','2642 Birchtree Way',0,'Columbus','OH','43232',NULL,'CY','39049','1969-04-30','M','U',':RET:2106-3','N','021','DEN','2601729','99734OH005000401','2014-01-01','2013-12-24 23:54:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:47:39'),(2457,1998,'Y','18','021','EC','A','','','AC','0000368096','0000368096','TX00000378367','IL','1','MUNOZ','ALICIA','','','','34','464940998','727 WEST AVENUE I',0,'KINGSVILLE','TX','78363',NULL,'CY','48273','1961-01-24','F','U',NULL,'N','021','DEN','973529','33348TX002000101','2014-01-01','2013-12-09 12:23:16','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:34:49'),(6378,5057,'N','01','021','EC','A',NULL,NULL,'','0000335133','0000809656','','IL','1','REED','THERESA','LYNN','','','34','276582168','2221 mifflin ave',0,'ashland','OH','44805',NULL,'CY','39005','1958-01-19','F','',NULL,'N','021','DEN','546873','99734OH005000301','2014-01-01','2013-12-11 09:47:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:47:51'),(13310,10627,'Y','18','021','EC','A','','','AC','0000884851','0000884851','TX00000291509','IL','1','GARCIA','DEBRA','','','','34','465456800','4409 VALDEZ DR',0,'CORPUS CHRISTI','TX','78416','2222','CY','48355','1978-11-03','F','U',NULL,'N','021','DEN','1847720','33348TX002000201','2014-01-01','2013-12-23 15:52:04','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 12:58:04'),(14883,11886,'Y','18','021','EC','A','','','AC','0001308765','0001308765','LA00000085924','31','1','Quintana','Blair','','','','34','435536054','102 BREWSTER RD',0,'MADISONVILLE','LA','70447','9578','CY','22071','1982-06-21','M','U',':RET:2106-3','N','021','DEN','1924105','18575LA002000201','2014-02-01','2013-12-28 18:18:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-30 00:00:35'),(16665,13336,'Y','18','021','EC','A','','','AC','0001858995','0001858995','LA00001703977','IL','1','Costa','Gerri','','','','34','437215978','14086 Airline Hwy',0,'Gonzales','LA','70737',NULL,'CY','22005','1966-02-12','M','R',':RET:2106-3','N','021','DEN','2261886','18575LA002000101','2014-02-01','2014-01-07 17:30:53','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-08 18:24:26'),(18926,15080,'Y','18','021','EC','A','','','AC','0000371501','0000371501','OH00002164071','IL','1','McKenzie','Julie','','','','34','404024470','3639 BOUDINOT AVE',0,'CINCINNATI','OH','45211','4907','CY','39061','1965-03-08','F','U',':RET:2106-3','N','021','DEN','2871303','99734OH005000401','2014-03-01','2014-01-16 23:32:52','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:05:35'),(18074,14435,'N','19','021','EC','A',NULL,NULL,'','0001215431','0002099461','','IL','1','HALE','KERNIESHA','','','','34','434816999','142 BIRCHWOOD DR',0,'MONROE','LA','71203','2204','CY','22073','1990-12-12','F','',':RET:2054-5','N','021','DEN','2208973','18575LA002000201','2014-02-01','2014-01-14 09:13:17',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:25'),(18288,14600,'N','01','021','EC','A',NULL,NULL,'','0001165357','0000584297','','IL','1','Robinson','Nancy','','','','34','299701121','283 Washington Ave.',0,'Elyria','OH','44035',NULL,'CY','39093','1964-11-15','F','',':RET:2500-7','T','021','DEN','2575415','99734OH005000401','2014-02-01','2014-01-14 20:18:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:44:51'),(18143,14488,'Y','18','021','EC','A','','','AC','0001964616','0001964616','LA00001469238','IL','1','ANDERSON','JAMES','','','','34','435174760','3137 WISE ST',0,'ALEXANDRIA','LA','71301',NULL,'CY','22079','1957-06-30','M','U',NULL,'N','021','DEN','1915077','18575LA002000101','2014-02-01','2014-01-14 14:59:20','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,0,'2014-01-15 02:07:47'),(26871,21297,'Y','18','021','EC','A','','','AC','0000921982','0000921982','OH00003352031','IL','1','loveland','brian','','','','34','274663231','3047 LOVERS LN',0,'RAVENNA','OH','44266','8929','CY','39133','1960-05-13','M','M',':RET:2106-3','N','021','HLT','3446111','52664OH151001301','2014-04-01','2014-03-01 13:22:48','284.00',NULL,NULL,'853.23','569.23','R-OH012','OH0','454.94',NULL,0,'2014-03-01 21:01:03'),(798,659,'Y','18','021','EC','A','','','AC','0000520234','0000520234','TX00000411598','IL','1','Mason','Kathleen','','','','34','449043962','4401 Idledell Dr',0,'Benbrook','TX','76116',NULL,'CY','48439','1952-02-03','F','M',':RET:2106-3','N','021','DEN','2020344','33348TX002000201','2014-01-01','2013-12-16 16:54:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:05:29'),(2616,2127,'Y','18','021','EC','A','','','AC','0000384367','0000384367','OH00000118419','IL','1','BALL','PATRICIA','','','','34','301626291','5600 BEATTY RD',0,'GROVE CITY','OH','43123','8945','CY','39049','1956-11-14','F','M',':RET:2106-3','N','021','DEN','50013','99734OH005000401','2014-01-01','2013-12-02 14:56:04','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:45:44'),(4683,3712,'Y','18','021','EC','A','','','AC','0000694703','0000694703','LA00000734240','IL','1','Stroud','Alexandra','','','','34','365949478','219 HARDING ST',0,'JEFFERSON','LA','70121','3917','CY','22051','1967-12-19','F','R',':RET:2106-3','N','021','DEN','942882','18575LA002000201','2014-01-01','2013-12-12 17:38:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:07:57'),(20214,16129,'Y','18','021','EC','A','','','AC','0001218568','0001218568','OH00001538243','IL','1','ABBOTT','MARGARET','MURDOCK','','','34','298580905','907 SURREY RIDGE',0,'CINCINNATI','OH','45245',NULL,'CY','39025','1965-08-18','F','M',NULL,'N','021','HLT','1810272','92036OH001000601','2014-03-01','2014-01-27 12:39:51','0.00',NULL,NULL,'846.74','846.74','R-OH005','OH0','423.37',NULL,0,'2014-01-27 21:01:40'),(3853,3083,'Y','18','021','EC','A','','','AC','0000653234','0000653234','LA00001046840','IL','1','MILLER','MARY','B','','','34','459901963','598 S POST OAK RD',0,'SULPHUR','LA','70663','3678','CY','22019','1951-03-25','F','U',':RET:2106-3','T','021','DEN','1043929','18575LA002000101','2014-01-01','2013-12-13 15:05:40','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2013-12-25 21:35:42'),(3150,2533,'Y','18','021','EC','A','','','AC','0000520161','0000520161','TX00000652502','IL','1','norman','Vanessa','','','','34','466331800','2608 Calumet',0,'Houston','TX','77004',NULL,'CY','48201','1970-06-25','F','U',':RET:2054-5','N','021','DEN','162320','33348TX002000201','2014-01-01','2013-11-18 13:04:45','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 20:31:00'),(9466,7509,'Y','18','021','EC','A','','','AC','0001104433','0001104433','OH00000895291','IL','1','Ernst','Jerilyn','','','','34','292425846','203 W BABBITT ST',0,'DAYTON','OH','45405','4806','CY','39113','1956-09-23','F','U',':RET:2106-3','N','021','DEN','1881729','99734OH005000401','2014-01-01','2013-12-21 09:54:57','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:34:19'),(14969,11964,'Y','18','021','EC','A','','','AC','0000481951','0000481951','TX00000400169','IL','1','Simpson','Sara','B','','','34','515045156','7004 Newport Dr',0,'Amarillo','TX','79124',NULL,NULL,NULL,'1987-08-08','F','U',':RET:2106-3','N','021','DEN','1986366','33348TX002000201','2014-02-01','2013-12-30 11:48:20','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-01 12:00:44'),(15384,12306,'Y','18','021','EC','A','','','AC','0000539293','0000539293','OH00001673128','IL','1','Bonner','Holly','','','','34','289842352','517 Mishler rd',0,'Mogadore','OH','44260',NULL,'CY','39133','1985-12-15','F','U',':RET:2106-3','T','021','HLT','1501292','52664OH151001305','2014-02-01','2014-01-01 10:44:22','135.00',NULL,NULL,'278.77','143.77','R-OH012','OH0','278.77',NULL,1,'2014-01-02 04:25:31'),(16382,13109,'Y','18','021','EC','A','','','AC','0000485377','0000485377','TX00001958662','IL','1','Kim','Yeon','Won','','','34','460698739','3951 CLUBWAY LN',0,'DALLAS','TX','75244','5416','CY','48113','1957-03-22','F','M',':RET:2040-4','N','021','DEN','2383964','33348TX002000201','2014-02-01','2014-01-06 15:58:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-07 04:03:21'),(18198,14527,'N','19','021','EC','A',NULL,NULL,'','0000451295','0000559459','','IL','1','Montoney','Marc','Jacob','','','34','276134851','901 SYCAMORE BLVD',0,'CINCINNATI','OH','45245','1321','CY','39025','2007-02-15','M','',':RET:2106-3','N','021','HLT','1414599','92036OH006000601','2014-02-01','2014-01-14 12:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','108.11',NULL,0,'2014-01-15 02:08:06'),(6823,5409,'N','01','021','EC','A',NULL,NULL,'','0000949473','0000130653','','IL','1','Nagy','Angela','','','','34','281803991','1720 lexington ave',0,'springfield','OH','45505',NULL,'CY','39023','1967-08-26','F','',':RET:2106-3','T','021','HLT','244391','92036OH004000501','2014-01-01','2013-11-13 21:34:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','329.70',NULL,0,'2013-12-26 01:30:36'),(15024,12008,'Y','18','021','EC','A','','','AC','0001574799','0001574799','LA00000754727','IL','1','williams','lannie','','','','34','439080921','1506 Opelousas St.',0,'Lake Charles','LA','70601',NULL,'CY','22019','1959-08-28','F','U',':RET:2054-5','T','021','DEN','2374928','18575LA002000201','2014-02-01','2013-12-29 22:14:08','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-01-01 12:02:24'),(1718,1432,'Y','18','024','14','A','','','TE','0000623941','0000623941','','IL','1','Smith','Floyd',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-05-15','M','',NULL,NULL,NULL,'','243041','','2013-12-24','2013-12-24 09:47:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:55:08'),(5654,4485,'Y','18','021','EC','A','','','AC','0000485191','0000485191','TX00000333987','IL','1','Wear','Fern','','','','34','566062069','9101 TEAL FLIGHT WAY',0,'TYLER','TX','75703','5303','CY','48423','1957-07-08','F','M',NULL,'N','021','DEN','598587','33348TX002000201','2014-01-01','2013-11-26 15:52:14','0.00',NULL,NULL,'29.22','29.22','R-TX022','TX0','14.61',NULL,0,'2013-12-25 23:31:35'),(9672,7663,'Y','18','021','EC','A','','','AC','0000927301','0000927301','OH00001164955','IL','1','Baker','Jean','','','','34','272686206','212 W BALDWIN ST',0,'BLANCHESTER','OH','45107','1104','CY','39027','1961-07-21','F','R',':RET:2106-3','N','021','HLT','1952686','92036OH002000601','2014-01-01','2013-12-21 17:47:09','0.00',NULL,NULL,'483.91','483.91','R-OH005','OH0','483.91',NULL,0,'2013-12-26 04:39:15'),(9104,7227,'Y','18','021','EC','A','','','AC','0000322132','0000322132','OH00000862021','IL','1','Jordan','Thomas','','','','34','281489820','2955 Westridge Ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1950-07-30','M','U',':RET:2054-5','N','021','DEN','2496592','99734OH005000301','2014-01-01','2013-12-18 15:31:22','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:07:29'),(24111,19167,'Y','18','021','EC','A','','','AC','0000960119','0000960119','TX00001752960','IL','1','Lewis','Eva','','','','34','465048178','2614 DOW DR',0,'BIG SPRING','TX','79720','6224','CY','48227','1953-11-24','F','U',':RET:2106-3','N','021','DEN','3088750','33348TX002000201','2014-03-01','2014-02-15 12:44:05','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-15 22:01:36'),(25457,20197,'Y','18','021','EC','A','','','AC','0000957698','0000957698','TX00003253650','IL','1','jackson','shannon','','','','34','633200169','420 N GRAY ST',0,'KILLEEN','TX','76541','5247','CY','48027','1990-07-13','F','R',':RET:2054-5','N','021','DEN','3413095','33348TX002000201','2014-04-01','2014-02-25 14:19:07','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-25 21:31:29'),(6722,5332,'Y','18','021','EC','A','','','AC','0000087454','0000087454','OH00001264342','IL','1','Salyer','Katelynn','','','','34','540351263','131 W NIXON ST',0,'CINCINNATI','OH','45220','2218','CY','39061','1990-08-21','F','U',':RET:2106-3','T','021','DEN','970473','99734OH005000401','2014-01-01','2013-11-25 15:37:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:14'),(21045,16814,'Y','18','024','14','A','','','TE','0000913717','0000913717','','IL','1','Austin','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-01-24','F','',NULL,NULL,NULL,'','3502885','','2014-02-01','2014-02-01 16:38:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-01 19:00:52'),(18887,15048,'Y','18','021','EC','A','','','AC','0000834486','0000834486','OH00002203426','IL','1','Licursi','Vincent','','','','34','289484129','1764 Maple Hill Dr',0,'Hinckley','OH','44233',NULL,'CY','39103','1951-08-01','M','U',':RET:2106-3','N','021','HLT','2671137','52664OH152000901','2014-02-01','2014-01-15 23:11:51','461.00',NULL,NULL,'469.28','8.28','R-OH012','OH0','469.28',NULL,0,'2014-01-17 03:36:30'),(6622,5252,'Y','18','021','EC','A','','','AC','0000612853','0000612853','MS00000033465','IL','1','Elzie','Nollen','','','','34','587464905','1324 LAMBARD DR',0,'TUPELO','MS','38801','2434','CY','28081','1952-02-06','M','M',':RET:2054-5','N','021','DEN','838321','46300MS002000201','2014-01-01','2013-12-11 17:45:27','0.00',NULL,NULL,'31.70','31.70','R-MS002','MS0','15.85',NULL,0,'2013-12-26 00:54:05'),(18017,14394,'Y','18','021','EC','A','','','AC','0001085636','0001085636','OH00001974452','31','1','Hayles','Gary','','','','34','290782203','null null',0,'CINCINNATI','OH','45215','0611','CY','39165','1967-08-26','M','M',':RET:2054-5','N','021','DEN','1609921','99734OH005000301','2014-02-01','2014-01-14 12:29:27','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-15 02:07:04'),(15981,12791,'Y','18','021','EC','A','','','AC','0000632433','0000632433','TX00001692383','IL','1','Bourque','Veronica','','','','34','437657425','800 country place dr',0,'houston','TX','77079',NULL,'CY','48201','1986-07-18','F','U',':RET:2054-5','N','021','DEN','2324746','33348TX002000201','2014-02-01','2014-01-03 10:36:31','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-04 02:00:56'),(6588,5223,'Y','18','021','EC','A','','','AC','0000746852','0000746852','OH00000624458','31','1','Schmitz','Judith','','','','34','282524477','P O Box 514',0,'Wauseon','OH','43567',NULL,'CY','39051','1952-03-26','F','U',':RET:2106-3','N','021','HLT','1098244','92036OH002002601','2014-01-01','2013-12-10 22:12:50','0.00',NULL,NULL,'632.79','632.79','R-OH001','OH0','632.79',NULL,0,'2013-12-26 00:53:10'),(5986,4738,'Y','18','021','EC','A','','','AC','0000475973','0000475973','OH00000610944','IL','1','BLAKE','ELIZABETH','','','','34','300748936','30 ELMER ST',0,'TIFFIN','OH','44883','2003','CY','39147','1964-02-18','F','U',NULL,'T','021','HLT','2137353','92036OH005002706','2014-01-01','2013-12-24 00:51:07','325.00',NULL,NULL,'382.57','57.57','R-OH006','OH0','382.57',NULL,0,'2013-12-25 23:52:04'),(3542,2844,'Y','18','021','EC','A','','','AC','0000039787','0000039787','TX00000254808','IL','1','Powell','Neysa','','','','34','585420371','1801 CROCKETT CIR',0,'IRVING','TX','75038','6202','CY','48113','1949-12-26','F','R',':RET:2106-3','T','021','DEN','2294793','33348TX002000101','2014-01-01','2013-12-22 16:17:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:21:49'),(14487,11558,'Y','18','021','EC','A','','','AC','0001107691','0001107691','TX00001369120','IL','1','Cheatham','Dorothy','','','','34','510400415','355 E Vista Ridge Mall Dr',0,'lewisville','TX','75067',NULL,'CY','48121','1957-05-03','F','M',':RET:2054-5','N','021','DEN','2053253','33348TX002000201','2014-02-01','2013-12-27 10:14:25','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-28 03:33:25'),(4627,3666,'Y','18','021','EC','A','','','AC','0001047554','0001047554','MS00000032445','IL','1','Johnson','Kenyatta','','','','34','426491626','639 ROBINHOOD RD',0,'JACKSON','MS','39206','4913','CY','28049','1980-05-06','M','U',':RET:2054-5^:RET:2106-3','T','021','DEN','349675','46300MS002000101','2014-01-01','2013-12-11 20:56:26','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 22:06:24'),(13505,10763,'Y','18','021','EC','A','','','AC','0001325079','0001325079','LA00000959872','31','1','Davis','Kathleen','','','','34','463067821','PO Box 15227',0,'New Orlean','LA','70175','5227','CY','22071','1968-12-09','F','U',':RET:2106-3','N','021','DEN','2566910','18575LA002000201','2014-01-01','2013-12-22 19:48:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:02:42'),(8114,6419,'Y','18','021','EC','A','','','AC','0000569429','0000569429','LA00000624179','31','1','McKay','Marcie','K','','','34','435612988','po box 68',0,'pollock','LA','71467',NULL,'CY','22043','1975-08-25','F','M',':RET:2106-3','T','021','DEN','833172','18575LA002000201','2014-01-01','2013-11-22 15:16:22','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-26 03:15:06'),(22845,18228,'Y','18','021','EC','A','','','AC','0000324875','0000324875','OH00001932814','IL','1','Dickey','Patti','','','','34','272604169','1914 Starr Avenue',0,'Toledo','OH','43605',NULL,'CY','39095','1960-04-25','F','M',':RET:2106-3','N','021','HLT','3514943','92036OH005002605','2014-03-01','2014-02-10 23:17:33','200.00',NULL,NULL,'397.79','197.79','R-OH001','OH0','397.79',NULL,0,'2014-02-11 21:02:17'),(23174,18476,'Y','18','021','EC','A','','','AC','0000309493','0000309493','OH00002575182','IL','1','Cook','Krystle','','','','34','645245060','1273 Crystal Glen Court',0,'Findlay','OH','45840',NULL,'CY','39063','1985-05-29','F','U',':RET:2054-5','N','021','HLT','2792329','92036OH004001501','2014-03-01','2014-02-11 20:59:50','0.00',NULL,NULL,'192.37','192.37','R-OH002','OH0','192.37',NULL,0,'2014-02-12 21:31:54'),(24459,19431,'Y','18','021','EC','A','','','AC','0000447174','0000447174','TX00001793020','IL','1','Cable','Caron','','','','34','461780621','2708 STONEPOINTE',0,'MCKINNEY','TX','75070','4024','CY','48085','1957-06-29','F','R',':RET:2106-3','N','021','DEN','3017155','33348TX002000101','2014-04-01','2014-02-18 12:43:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-18 22:01:32'),(26941,21350,'N','19','021','EC','A',NULL,NULL,'','0000618418','0000951865','','IL','1','Chmura','Natalie',NULL,NULL,NULL,NULL,NULL,'1996 HILLSIDE RD',0,'SEVEN HILLS','OH','44131','4417','CY','39035','2002-08-31','F','',NULL,'N','021','DEN','3929180','99734OH005000301','2014-04-01','2014-03-02 15:37:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-03 01:00:23'),(621,512,'Y','18','021','EC','A','','','AC','0000101416','0000101416','OH00001039013','IL','1','MAKRIDES','IRENE','','','','34','292622632','6939 ALTER RD',0,'HUBER HEIGHTS','OH','45424','3136','CY','39113','1957-03-23','F','M',NULL,'N','021','DEN','1816046','99734OH005000401','2014-01-01','2013-12-16 11:42:21','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:00:50'),(4700,3725,'N','01','021','EC','A',NULL,NULL,'','0001162578','0000682132','','IL','1','Hill','Russell','Lynn','','','34','276604163','12648 OLD TROY PIKE',0,'SAINT PARIS','OH','43072','9626','CY','39021','1968-09-09','F','',NULL,'N','021','HLT','236864','92036OH005000505','2014-01-01','2013-12-12 18:14:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','343.26',NULL,0,'2013-12-25 22:08:22'),(20103,16039,'Y','18','021','EC','A','','','AC','0001262214','0001262214','LA00002195056','IL','1','RUFFIN','NICHOLE','','','','34','433616307','124 bottle brush ln',0,'CARENCRO','LA','70520',NULL,'CY','22055','1971-07-11','F','U',NULL,'N','021','DEN','3213990','18575LA002000201','2014-03-01','2014-01-27 14:09:20','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-27 21:00:36'),(19342,15419,'Y','18','021','EC','A','','','AC','0000290827','0000290827','OH00001476641','IL','1','Brandon','Matthew','','','','34','281902351','90 E COMET RD',0,'CLINTON','OH','44216','9424','CY','39153','1984-02-10','M','U',':RET:2106-3','N','021','DEN','1552244','99734OH005000301','2014-03-01','2014-01-20 18:54:19','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,1,'2014-01-22 03:22:22'),(13506,10764,'Y','18','021','EC','A','','','AC','0002390631','0002390631','LA00000192657','IL','1','Rosborough','Mae','','','','34','439960318','1006 PINE TREE DR',0,'SHREVEPORT','LA','71106','3914','CY','22017','1954-07-05','F','U',':RET:2054-5','N','021','DEN','1541091','18575LA002000201','2014-01-01','2013-12-22 20:00:14','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 13:02:44'),(19050,15173,'Y','18','021','EC','A','','','AC','0001604401','0001604401','LA00002100518','IL','1','BARACCO','LEAH','','','','34','434533819','3205 CYPRESS ST',0,'METAIRIE','LA','70001','5221','CY','22051','1969-04-30','F','U',NULL,'T','021','DEN','2246321','18575LA002000101','2014-03-01','2014-01-17 12:55:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-20 08:06:43'),(17708,14151,'Y','18','021','EC','A','','','AC','0002294905','0002294905','LA00001962578','IL','1','Brown','Wayne','','','','34','434157248','1417 NUNEZ ST',0,'NEW ORLEANS','LA','70114','5824','CY','22071','1962-07-14','M','R',':RET:2054-5','T','021','DEN','2368728','18575LA002000201','2014-02-01','2014-01-13 15:01:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:08'),(16260,13018,'Y','18','021','EC','A','','','AC','0000387292','0000387292','OH00001409360','IL','1','FUSSELMAN','CYNTHIA','','','','34','293683736','9823 LIMERIDGE RD',0,'MANTUA','OH','44255','9743','CY','39133','1959-10-31','F','M',':RET:2106-3','N','021','HLT','1409608','52664OH152000901','2014-02-01','2014-01-04 14:56:17','52.00',NULL,NULL,'348.73','296.73','R-OH012','OH0','348.73',NULL,0,'2014-01-05 00:02:54'),(24230,19242,'Y','18','024','14','A','','','TE','0000614154','0000614154','','IL','1','Gay','Rodney',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-05-26','M','',NULL,NULL,NULL,'','3478244','','2014-02-16','2014-02-16 10:26:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-16 19:00:33'),(27238,21569,'Y','18','021','EC','A','','','AC','0000301380','0000301380','MS00003355678','IL','1','Blair','Anderson','','','','34','400134096','102 NORTHAMPTON RD',0,'NATCHEZ','MS','39120','5241','CY','28001','1967-01-04','M','M',':RET:2106-3','N','021','DEN','3069944','46300MS002000101','2014-04-01','2014-03-03 15:31:36','0.00',NULL,NULL,'101.40','101.40','R-MS006','MS0','27.15',NULL,0,'2014-03-03 21:31:46'),(28211,22324,'Y','18','021','EC','A','','','AC','0001062169','0001062169','OH00002886392','IL','1','Koontz','Wendi','','','','34','291668215','812 S WATER ST',0,'KENT','OH','44240','3569','CY','39133','1974-02-05','F','M',NULL,'N','021','HLT','4072223','52664OH151001304','2014-04-01','2014-03-06 12:51:32','383.00',NULL,NULL,'700.91','317.91','R-OH012','OH0','285.00','CIC',0,'2014-03-06 21:30:14'),(80,69,'N','19','021','EC','A',NULL,NULL,'','0000866868','0001002142','','IL','1','Tatic','Boris','','','','34','285986766','3942 WELCKER DR NE',0,'WARREN','OH','44483','4541','CY','39155','1992-10-24','M','',':RET:2106-3','N','021','DEN','320054','99734OH005000301','2014-01-01','2013-12-05 17:36:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:17:07'),(22657,18092,'Y','18','021','EC','A','','','AC','0001067929','0001067929','TX00001357811','IL','1','Herrera','Manuela','','','','34','456041268','824 YATES PL',0,'EL PASO','TX','79928','7659','CY','48141','1953-07-12','F','M',':RET:2106-3','N','021','DEN','3376553','33348TX002000201','2014-03-01','2014-02-11 12:40:28','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-11 21:00:32'),(6072,4812,'Y','18','024','14','A','','','TE','0000933180','0000933180','','IL','1','JONES','TERRY','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-10-28','M','',NULL,NULL,NULL,'','744229','','2013-11-30','2013-11-30 19:58:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:02:13'),(19794,15780,'Y','18','021','EC','A','','','AC','0001192701','0001192701','OH00001791473','IL','1','Harrah','Linda','','','','34','295546326','822 Mavor St',0,'Springfield','OH','45505',NULL,'CY','39023','1953-12-21','F','U',':RET:2106-3','N','021','HLT','2684130','92036OH003000501','2014-03-01','2014-01-23 17:43:29','343.00',NULL,NULL,'673.71','330.71','R-OH003','OH0','673.71',NULL,0,'2014-01-23 21:01:43'),(18865,15027,'Y','18','021','EC','A','','','AC','0001725399','0001725399','LA00002244243','IL','1','sidora','amanda','','','','34','437771602','105 FIRETHORN DR',0,'GRETNA','LA','70056','7849','CY','22051','1989-10-25','F','U',':RET:2106-3','N','021','DEN','1523749','18575LA002000201','2014-03-01','2014-01-16 01:23:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:22'),(18797,14970,'N','01','021','EC','A',NULL,NULL,'','0000298257','0000066277','','IL','1','Huynh','Vu','','','','34','281029775','1250 WINFREE DR',0,'WESTERVILLE','OH','43081','3773','CY','39049','1978-01-21','M','',':RET:2047-9','T','021','DEN','1461272','99734OH005000401','2014-03-01','2014-01-16 10:20:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:58'),(1540,1283,'Y','18','021','EC','A','','','AC','0001121394','0001121394','OH00001081725','IL','1','Haas','Martin','','','','34','298749432','3708 Harrison Avenue',0,'Cincinnati','OH','45211',NULL,'CY','39061','1979-08-17','M','U',':RET:2106-3','N','021','DEN','1822802','99734OH005000401','2014-01-01','2013-12-24 17:30:35','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:50:16'),(5715,4537,'Y','18','021','EC','A','','','AC','0001131446','0001131446','OH00001006135','IL','1','Potkalitsky','Thomas','','','','34','298482745','754 Skyland Drive',0,'Macedonia','OH','44056',NULL,'CY','39153','1950-06-14','M','U',':RET:2106-3','N','021','HLT','2160340','52664OH151001304','2014-01-01','2013-12-24 00:07:41','472.00',NULL,NULL,'658.32','186.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 23:45:15'),(15783,12632,'Y','18','021','EC','A','','','AC','0000396138','0000396138','TX00001818784','IL','1','Costilow','Luke','','','','34','640107037','2001 19th St',0,'Huntsville','TX','77340',NULL,'CY','48471','1985-08-20','M','U',':RET:2106-3','N','021','DEN','1408198','33348TX002000201','2014-02-01','2014-01-02 17:50:35','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-03 02:02:12'),(15290,12225,'Y','18','021','EC','A','','','AC','0002232949','0002232949','LA00001866065','IL','1','PIKES','SHEILA','RENA','','','34','436139721','5964 HIGHWAY 6',0,'NATCHITOCHES','LA','71457','7104','CY','22069','1961-10-28','F','M',':RET:2054-5','N','021','DEN','1556845','18575LA002000101','2014-02-01','2013-12-31 20:14:48','0.00',NULL,NULL,'50.04','50.04','R-LA008','LA0','25.02',NULL,1,'2014-01-02 04:22:26'),(13809,11022,'Y','18','021','EC','A','','','AC','0000923328','0000923328','OH00000877033','IL','1','Bartholomew','Patrick','','','','34','227491613','3556 Madison Park Ave.',0,'Cincinnati','OH','45209',NULL,'CY','39061','1982-07-23','M','M',NULL,'T','021','HLT','1849749','92036OH005001205','2014-01-01','2013-12-22 22:27:22','331.00',NULL,NULL,'562.37','231.37','R-OH004','OH0','286.13',NULL,0,'2013-12-26 13:11:34'),(9632,7630,'Y','18','021','EC','A','','','AC','0000148326','0000148326','OH00000978843','IL','1','Buller','Suely','','','','34','505113140','1329 Apache Trail',0,'Stow','OH','44224',NULL,'CY','39153','1954-02-25','F','M',':RET:2106-3','N','021','HLT','2078434','52664OH152000901','2014-01-01','2013-12-21 16:03:13','304.00',NULL,NULL,'425.18','121.18','R-OH012','OH0','425.18',NULL,0,'2013-12-26 04:38:14'),(9175,7277,'Y','18','021','EC','A','','','AC','0000813075','0000813075','OH00000511975','IL','1','Smart','Van','Alan','','','34','293542796','4151 STATE ROUTE 247',0,'HILLSBORO','OH','45133','9598','CY','39071','1957-12-14','M','M',':RET:2106-3','T','021','HLT','1611435','92036OH005000601','2014-01-01','2013-12-18 13:41:59','227.00',NULL,NULL,'575.94','348.94','R-OH005','OH0','575.94',NULL,0,'2013-12-26 04:09:02'),(26879,21302,'Y','18','021','EC','A','','','AC','0001252180','0001252180','OH00003475381','IL','1','Hercik','Gregory','','','','34','278605783','10275 SANDALWOOD LN',0,'TWINSBURG','OH','44087','1368','CY','39153','1958-07-21','M','R',':RET:2106-3','N','021','HLT','3709875','52664OH152000901','2014-04-01','2014-03-01 09:44:22','0.00',NULL,NULL,'364.25','364.25','R-OH012','OH0','364.25',NULL,0,'2014-03-01 21:01:07'),(3658,2926,'N','01','021','EC','A',NULL,NULL,'','0001187625','0000105350','','IL','1','Bailey','Jennifer','Lynn','','','34','284623656','405 N. Wright St.',0,'Blanchester','OH','45107',NULL,'CY','39027','1965-05-03','F','',':RET:2106-3','T','021','DEN','128024','99734OH005000401','2014-01-01','2013-12-12 19:45:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:30:48'),(9197,7294,'Y','18','024','14','A','','','TE','0000218816','0000218816','','IL','1','heaps','amber',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-09-13','F','',NULL,NULL,NULL,'','1885454','','2013-12-18','2013-12-18 15:56:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:09:32'),(13179,10513,'Y','18','021','EC','A','','','AC','0000298655','0000298655','TX00000389796','IL','1','Beauchamp','Virginia','','','','34','453434128','14500 Cutten Rd.',0,'Houston','TX','77069',NULL,'CY','48201','1962-07-24','F','U',':RET:2106-3','N','021','DEN','1546163','33348TX002000101','2014-01-01','2013-12-22 19:57:50','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:15'),(21559,17223,'Y','18','021','EC','A','','','AC','0000572032','0000572032','OH00001510795','IL','1','Moreland','Kristen','','','','34','268905189','4967 MCNULTY ST',0,'GROVE CITY','OH','43123','8309','CY','39049','1983-09-06','F','U',':RET:2106-3','N','021','DEN','2870543','99734OH005000401','2014-03-01','2014-02-05 16:54:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-05 21:30:17'),(16773,13418,'Y','18','021','EC','A','','','AC','0000694382','0000694382','MS00001417719','IL','1','Bichon','Rebecca','','','','34','140668654','3445 Clepsyda Dr',0,'Hernando','MS','38632',NULL,'CY','28033','1977-01-05','F','M',':RET:2106-3','N','021','DEN','2079024','46300MS002000101','2014-02-01','2014-01-07 11:11:19','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2014-01-08 18:25:02'),(16376,13104,'Y','18','021','EC','A','','','AC','0000089841','0000089841','TX00001644968','IL','1','ORTEGA','ANDREA','','','','34','458754093','2078 EL PARAISO DR',0,'BROWNSILLE','TX','78520',NULL,'CY','48061','1971-03-04','F','U',NULL,'N','021','DEN','2135115','33348TX002000201','2014-02-01','2014-01-06 12:38:57','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-07 04:03:10'),(14401,11484,'Y','18','024','14','A','','','TE','0000093819','0000093819','','IL','1','YEFREMOV','ANDREY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-01-25','M','',NULL,NULL,NULL,'','1197078','','2013-12-27','2013-12-27 16:53:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:31:12'),(7959,6299,'Y','18','021','EC','A','','','AC','0000521431','0000521431','MS00000423525','IL','1','Simmons','Jerry','','','','34','587680870','1014 MORRIS DAVIS RD',0,'MCCOMB','MS','39648','2554','CY','28113','1953-12-02','M','U',':RET:2054-5','N','021','DEN','1846130','46300MS002000201','2014-01-01','2013-12-19 20:41:46','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 03:07:23'),(9553,7571,'Y','18','024','14','A','','','TE','0001057973','0001057973','','IL','1','Johnson','Stacey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-08-28','F','',NULL,NULL,NULL,'','832236','','2013-12-21','2013-12-21 14:04:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:36:20'),(24390,19372,'Y','18','021','EC','A','','','AC','0000851889','0000851889','OH00002663037','IL','1','DEBORAH','LITTLE','','','','34','296541274','1341 WHITTIER ST NE',0,'CANTON','OH','44721',NULL,'CY','39151','1953-09-21','F','U',':RET:2106-3','N','021','DEN','3674858','99734OH005000401','2014-04-01','2014-02-18 11:55:47','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-02-18 22:00:48'),(27559,21799,'N','19','021','EC','A',NULL,NULL,'','0000982460','0001199106','','IL','1','VETTA','KAITLIN','','','','34','610985161','508 S DALLAS AVE',0,'LANCASTER','TX','75146','1507','CY','48113','1997-05-30','F','',NULL,'N','021','DEN','3012437','33348TX002000201','2014-04-01','2014-03-04 16:07:03',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52','CIC',0,'2014-03-04 21:30:16'),(7599,6013,'Y','18','021','EC','A','','','AC','0000070282','0000070282','OH00000833062','IL','1','stephens','travis','','','','34','308157207','2557 BRAMBLE RD SW',0,'CARROLLTON','OH','44615','9257','CY','39019','1994-03-23','M','U',':RET:2106-3','N','021','DEN','300473','99734OH005000401','2014-01-01','2013-11-17 17:08:40','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','15.78',NULL,0,'2013-12-26 02:45:20'),(19476,15524,'Y','18','021','EC','A','','','AC','0001017766','0001017766','TX00002099465','IL','1','Nguyen','Suong','','','','34','638023100','4012 Willowleaf Court',0,'Dallas','TX','75212',NULL,'CY','48113','1971-11-08','F','U',':RET:2047-9','N','021','DEN','1938712','33348TX002000201','2014-03-01','2014-01-22 11:47:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-23 03:02:01'),(3466,2784,'Y','18','021','EC','A','','','AC','0000346893','0000346893','OH00000243554','IL','1','KAY','BONNIE','B','','','34','273469394','21075 FARNSLEIGH RD',0,'SHAKER HEIGHTS','OH','44122','3845','CY','39035','1951-11-14','F','M',':RET:2106-3','N','021','DEN','1610449','99734OH005000401','2014-01-01','2013-12-22 07:29:54','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:19:49'),(17084,13672,'Y','18','021','EC','A','','','AC','0000875427','0000875427','TX00000321305','IL','1','JAVIER','TERESA','','','','34','733182080','12414 JAGUAR DR',0,'STAFFORD','TX','77477',NULL,'CY','48201','1975-09-13','F','U',':RET:2036-2','N','021','DEN','1444891','33348TX002000201','2014-02-01','2014-01-08 14:23:34','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:21:24'),(16905,13527,'Y','18','021','EC','A','','','AC','0001145990','0001145990','OH00002463617','IL','1','Tweneboah','wilson','O','','','34','590115190','7574 BARON CT',0,'WEST CHESTER','OH','45069','2306','CY','39017','1954-10-10','M','M',':RET:2054-5','N','021','DEN','1963586','99734OH005000401','2014-02-01','2014-01-09 16:34:29','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:19:35'),(16847,13477,'Y','18','021','EC','A','','','AC','0000541664','0000541664','OH00001704080','IL','1','STEWART','PHILLIP','A','','','34','285542383','218 CURTIS DR',0,'WILMINGTON','OH','45177','1539','CY','39027','1953-06-21','M','U',':RET:2106-3','N','021','HLT','2289780','92036OH003000606','2014-02-01','2014-01-11 10:57:05','552.00',NULL,NULL,'608.42','56.42','R-OH005','OH0','608.42',NULL,0,'2014-01-13 02:18:37'),(9097,7221,'Y','18','021','EC','A','','','AC','0000313230','0000313230','OH00000109864','IL','1','Sengewald','Judith','','','','34','302529078','116 BURLEY CIR',0,'CINCINNATI','OH','45218','1335','CY','39061','1951-09-16','F','U',':RET:2106-3','N','021','DEN','2120799','99734OH005000301','2014-01-01','2013-12-18 14:10:19','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:07:15'),(25038,19855,'Y','18','021','EC','A','','','AC','0000661397','0000661397','OH00002520099','31','1','Anderson','Susan','','','','34','304984550','po box 75',0,'Convoy','OH','45832',NULL,'CY','39161','1977-04-25','F','U',NULL,'N','021','HLT','2651186','92036OH003001505','2014-04-01','2014-02-19 19:41:07','96.00',NULL,NULL,'282.70','186.70','R-OH002','OH0','282.70',NULL,0,'2014-02-20 22:01:08'),(25790,20454,'Y','18','021','EC','A','','','AC','0000044325','0000044325','OH00002066583','IL','1','NYE','JULIA','','','','34','269683816','135 S COUNTY ROAD 17',0,'TIFFIN','OH','44883','8407','CY','39147','1959-08-19','F','U',':RET:2106-3','N','021','DEN','2861308','99734OH005000301','2014-03-01','2014-02-26 08:16:55','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-26 21:00:11'),(28250,22352,'Y','18','024','14','A','','','TE','0000427688','0000427688','','IL','1','MILLER','CAROL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-08-03','F','',NULL,NULL,NULL,'','3245600','','2014-03-31','2014-03-07 13:17:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:13'),(90,79,'Y','18','024','14','A','','','TE','0000196192','0000196192','','IL','1','Taylor','Mandy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-01','F','',NULL,NULL,NULL,'','916908','','2013-12-04','2013-12-04 19:25:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 17:17:25'),(21053,16820,'N','01','021','EC','A',NULL,NULL,'','0000222429','0000888212','','IL','1','Hilton','George','','','','34','509683255','10 krebs Drive',0,'Sabina','OH','45169',NULL,'CY','39027','1966-06-20','M','',':RET:2106-3','N','021','HLT','3641948','92036OH006000601','2014-03-01','2014-02-01 18:58:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','266.10',NULL,0,'2014-02-02 19:00:07'),(18510,14761,'N','19','021','EC','A',NULL,NULL,'','0000720266','0001152214','','IL','1','Schwieterman','Ella','','','','34','276154676','03347 Shanverton Dr.',0,'New Bremen','OH','45869',NULL,'CY','39011','2009-03-01','F','',NULL,'N','021','HLT','1730753','92036OH004001501','2014-02-01','2014-01-14 20:22:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','112.38',NULL,0,'2014-01-16 08:46:33'),(18294,14605,'Y','18','021','EC','A','','','AC','0001174421','0001174421','OH00002165007','IL','1','Doyle','William','','','','34','271561370','829 Neeb Rd.',0,'Cincinnati','OH','45233','4670','CY','39061','1970-03-18','M','U',NULL,'N','021','DEN','2896649','99734OH005000401','2014-02-01','2014-01-14 21:46:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-16 08:44:53'),(17968,14358,'Y','18','021','EC','A','','','AC','0000655842','0000655842','OH00001871273','IL','1','hasrouni','george','','','','34','296668306','5151 DENTON CIR',0,'BRUNSWICK','OH','44212','6455','CY','39103','1971-12-05','M','M',':RET:2106-3','N','021','HLT','2639649','52664OH151001306','2014-02-01','2014-01-13 20:03:35','450.00',NULL,NULL,'573.35','123.35','R-OH012','OH0','295.48',NULL,0,'2014-01-15 02:06:48'),(17507,13996,'N','19','021','EC','A',NULL,NULL,'','0000530709','0001118739','','IL','1','Lampert','Anthony','','','III','34','296984304','7291 Lauren J Drive',0,'Mentor','OH','44060',NULL,'CY','39085','1996-02-25','M','',':RET:2106-3','N','021','HLT','1596454','52664OH151001501','2014-02-01','2014-01-11 19:22:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-01-13 03:01:28'),(683,562,'Y','18','021','EC','A','','','AC','0000590764','0000590764','OH00000270148','IL','1','resor','scott','','','','34','296722152','213 SWEITZER ST',0,'GREENVILLE','OH','45331','1345','CY','39037','1963-07-09','M','U',NULL,'N','021','DEN','1610099','99734OH005000301','2014-01-01','2013-12-16 11:19:14','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:02:26'),(13294,10611,'Y','18','021','EC','A','','','AC','0000389399','0000389399','TX00000781400','IL','1','Daniels','Billy','','','','34','451957325','549 3RD ST SW',0,'PARIS','TX','75460',NULL,'CY','48277','1987-12-11','M','U',':RET:2054-5','N','021','DEN','1524333','33348TX002000201','2014-01-01','2013-12-23 13:53:36','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:57:33'),(6674,5294,'Y','18','021','EC','A','','','AC','0000852787','0000852787','LA00000835567','IL','1','LINDE','BARBARA','','','','34','439920749','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1952-04-09','F','M',':RET:2106-3','N','021','DEN','1085015','18575LA002000201','2014-01-01','2013-11-16 10:40:25','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:01:12'),(2401,1961,'Y','18','021','EC','A','','','AC','0001008925','0001008925','OH00000379622','IL','1','brown','Anthony','','','','34','278700701','3450 STATEWOOD DR',0,'CINCINNATI','OH','45251','2381','CY','39061','1960-11-15','M','U',NULL,'N','021','DEN','412498','99734OH005000401','2014-01-01','2013-12-09 13:52:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:33:33'),(3011,2421,'Y','18','021','EC','A','','','AC','0000096359','0000096359','OH00000361614','IL','1','BONKO','MARY','J','','','34','293523683','324 WESTBERRY CIRCLE',0,'TALLMADGE','OH','44278',NULL,'CY','39153','1952-08-27','F','U',':RET:2106-3','N','021','HLT','176004','52664OH151001306','2014-01-01','2013-12-06 17:22:44','524.00',NULL,NULL,'626.65','102.65','R-OH012','OH0','626.65',NULL,0,'2013-12-25 20:17:56'),(6132,4863,'Y','18','021','EC','A','','','AC','0001236455','0001236455','TX00000284502','IL','1','Webber','Patricia','s','','','34','463947430','14203 BARRONE DR',0,'CYPRESS','TX','77429','2547','CY','48201','1952-03-31','F','U',':RET:2106-3','N','021','DEN','281636','33348TX002000201','2014-01-01','2013-11-21 14:42:55','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:16:01'),(3381,2710,'Y','18','021','EC','A','','','AC','0000245836','0000245836','TX00000955466','31','1','wheaton','harvey','','','','34','548824873','P. O. Box 902',0,'Navasota','TX','77868',NULL,'CY','48185','1949-11-23','M','M',NULL,'N','021','DEN','1467525','33348TX002000201','2014-01-01','2013-12-22 17:31:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:17:31'),(848,702,'Y','18','021','EC','A','','','AC','0000489329','0000489329','LA00000318286','IL','1','Emerson','Lydell','','','','34','439351796','6564 CAMBRIDGE ST',0,'BATON ROUGE','LA','70807','6476','CY','22033','1976-02-23','M','U',':RET:2054-5','N','021','DEN','2452566','18575LA002000101','2014-01-01','2013-12-16 09:37:20','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:06:48'),(4411,3504,'Y','18','021','EC','A','','','AC','0000165056','0000165056','OH00001281488','IL','1','Jennings','James','','','','34','274482726','310 Bryant Ave',0,'Cincinnati','OH','45220',NULL,'CY','39061','1952-04-27','M','U',':RET:2106-3','N','021','DEN','503479','99734OH005000401','2014-01-01','2013-12-12 14:43:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:01:21'),(4997,3964,'Y','18','021','EC','A','','','AC','0001234104','0001234104','OH00000480868','IL','1','Kontos','Harry','','','','34','269545905','1811 KATHRYN DR',0,'WESTLAKE','OH','44145','3557','CY','39035','1951-11-17','M','M',':RET:2106-3','N','021','DEN','490921','99734OH005000301','2014-01-01','2013-12-07 10:35:22','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:47:04'),(24234,19246,'Y','18','021','EC','A','','','AC','0001034715','0001034715','OH00001618547','IL','1','LITTLE','DAVID',NULL,NULL,NULL,NULL,NULL,'2815 KING LN',0,'HILLSBORO','OH','45133','8891','CY','39071','1966-12-05','M','M',':RET:2106-3','N','021','HLT','2927675','92036OH003000604','2014-03-01','2014-02-15 21:12:54','512.00',NULL,NULL,'750.78','238.78','R-OH005','OH0','350.40',NULL,0,'2014-02-16 19:00:36'),(24342,19331,'N','01','021','EC','A',NULL,NULL,'','0000573948','0001234426','','IL','1','MARES','MANUEL','','','','34','623189320','1396 STATE HIGHWAY 83 W',0,'DENVER CITY','TX','79323','5704','CY','48501','1959-08-10','M','',':RET:2106-3','N','021','DEN','3752999','33348TX002000201','2014-04-01','2014-02-18 15:59:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-18 22:00:20'),(24814,19678,'Y','18','021','EC','A','','','AC','0000757194','0000757194','OH00003028633','IL','1','Nowland','Deanna','','','','34','301605166','7015 GREENSTONE TRCE',0,'LOVELAND','OH','45140','6016','CY','39025','1972-01-31','F','M',':RET:2106-3','N','021','HLT','3513972','92036OH004000601','2014-04-01','2014-02-18 22:45:05','372.00',NULL,NULL,'798.53','426.53','R-OH005','OH0','228.72',NULL,0,'2014-02-20 04:50:06'),(25165,19961,'Y','18','021','EC','A','','','AC','0000627925','0000627925','OH00002370280','IL','1','SIANG','WEN','','','','34','403374540','1811 HAWK AVE',0,'PIQUA','OH','45356',NULL,'CY','39109','1965-05-24','M','M',NULL,'N','021','DEN','3524406','99734OH005000401','2014-04-01','2014-02-20 23:24:57','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-21 22:00:24'),(25787,20451,'Y','18','021','EC','A','','','AC','0001148774','0001148774','OH00003231735','IL','1','montgomery','james','','','','34','456950375','4127 BELLEVUE RD',0,'TOLEDO','OH','43613','3934','CY','39095','1981-12-15','M','U',':RET:2106-3','N','021','HLT','3835521','92036OH005002605','2014-04-01','2014-02-24 16:14:38','152.00',NULL,NULL,'230.68','78.68','R-OH001','OH0','230.68',NULL,0,'2014-02-26 09:31:07'),(26081,20683,'Y','18','021','EC','A','','','AC','0001497897','0001497897','LA00002214037','IL','1','AREVALO HERNANDES','JUAN','','','','34','065830699','12485 CATE AVENUE',0,'BATON ROUGE','LA','70815',NULL,'CY','22033','1976-03-21','M','U',NULL,'N','021','DEN','3042087','18575LA002000201','2014-03-01','2014-02-26 18:36:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-28 06:30:04'),(1232,1015,'Y','18','021','EC','A','','','AC','0001188765','0001188765','OH00000608660','IL','1','mcgurk','margaret','','','','34','327428496','471 PURCELL AVE',0,'CINCINNATI','OH','45205','2296','CY','39061','1950-10-14','F','U',':RET:2106-3','N','021','HLT','1008658','92036OH003001205','2014-01-01','2013-12-03 02:29:10','470.00',NULL,NULL,'661.77','191.77','R-OH004','OH0','661.77',NULL,0,'2013-12-25 18:20:45'),(23382,18632,'Y','18','024','14','A','','','TE','0000961898','0000961898','','IL','1','Wertz','Donald','G','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-07-07','M','',NULL,NULL,NULL,'','3620359','','2014-02-13','2014-02-13 13:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-13 22:01:00'),(23203,18499,'N','19','021','EC','A',NULL,NULL,'','0000401284','0001106827','','S1','1','Budzinski','Aaron','','','','34','614859284','3181 ASTOR AVE',0,'TOLEDO','OH','43614','5224','CY','39095','2011-01-05','F','',':RET:2106-3','N','021','HLT','3157858','92036OH006002601','2014-03-01','2014-02-12 11:08:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2014-02-12 21:32:09'),(6267,4969,'Y','18','021','EC','A','','','AC','0000176356','0000176356','OH00000565857','IL','1','Rocca','Frank','C','','','34','283441555','3871 Kyle Road',0,'Dorset','OH','44032',NULL,'CY','39007','1950-07-29','M','U',NULL,'N','021','DEN','214429','99734OH005000301','2014-01-01','2013-10-07 11:22:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 00:32:25'),(4361,3463,'Y','18','021','EC','A','','','AC','0000144203','0000144203','OH00000331871','IL','1','Barber','Carolyn','','','','34','305560917','817 STORY DR',0,'FAIRFIELD','OH','45014','3635','CY','39017','1950-01-05','F','U',':RET:2106-3','N','021','HLT','1701693','92036OH006001201','2014-01-01','2013-12-17 17:11:10','271.00',NULL,NULL,'502.56','231.56','R-OH004','OH0','502.56',NULL,0,'2013-12-25 21:53:46'),(13913,11097,'Y','18','021','EC','A','','','AC','0001203221','0001203221','OH00000307552','IL','1','COLEMAN','KATHY','','','','34','268505739','100 VINE ST',0,'TIFFIN','OH','44883','1302','CY','39147','1950-08-21','F','U',':RET:2106-3','N','021','HLT','1988550','92036OH005002705','2014-01-01','2013-12-23 17:06:01','518.00',NULL,NULL,'575.62','57.62','R-OH006','OH0','575.62',NULL,0,'2013-12-26 13:14:00'),(14046,11190,'N','01','021','EC','A',NULL,NULL,'','0001102097','0000154658','','IL','1','Le','Nhung','','','','34','519915892','4620 EDGEWATER DR',0,'STOW','OH','44224','5467','CY','39153','1988-04-30','F','',':RET:2047-9','N','021','DEN','2558216','99734OH005000301','2014-02-01','2013-12-26 08:47:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:00:10'),(14229,11347,'Y','18','021','EC','A','','','AC','0000737288','0000737288','TX00001477509','IL','1','Rockett','Cathyrine','','','','34','639107464','7516 BOGART DR',0,'NORTH RICHLAND HILLS','TX','76180','6224','CY','48439','1987-03-07','F','U',':RET:2106-3','N','021','DEN','1499114','33348TX002000201','2014-02-01','2013-12-26 18:18:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-27 02:04:55'),(17636,14099,'N','19','021','EC','A',NULL,NULL,'','0001258678','0000667799','','IL','1','Kessler','DaniElla','Michal','','','34','272155279','4286 UNIVERSITY PKWY',0,'UNIVERSITY HEIGHTS','OH','44118','3943','CY','39035','2008-11-26','F','',':RET:2106-3','N','021','DEN','1360427','99734OH005000301','2014-02-01','2014-01-12 19:56:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:35'),(35,30,'Y','18','021','EC','A','','','AC','0000422789','0000422789','OH00001012253','IL','1','ARCHINAL','BEN','B','','','34','275865475','5726 HERITAGE AVE',0,'MADISON','OH','44057','1774','CY','39085','1979-08-20','M','U',':RET:2106-3','N','021','DEN','232070','99734OH005000401','2014-01-01','2013-12-05 12:35:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:15:54'),(23392,18641,'Y','18','021','EC','A','','','AC','0000580025','0000580025','OH00002391162','IL','1','Bihr','Kristen','','','','34','288900721','5615 LAKE MANOR DR',0,'FAIRFIELD','OH','45014','4411','CY','39017','1985-03-01','F','U',':RET:2106-3','N','021','DEN','2964287','99734OH005000401','2014-03-01','2014-02-13 14:55:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-13 22:01:06'),(695,572,'Y','18','021','EC','A','','','AC','0000540286','0000540286','OH00001308463','IL','1','Grano','Tyler','','','','34','274905295','218 EDGEWOOD DR',0,'BEREA','OH','44017','1443','CY','39035','1987-11-15','M','U',':RET:2106-3','N','021','DEN','1482179','99734OH005000301','2014-01-01','2013-12-16 15:08:52','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:02:44'),(19946,15909,'Y','18','024','14','A','','','TE','0000340252','0000340252','','IL','1','Malloy','Nicholas',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-01-05','M','',NULL,NULL,NULL,'','693471','','2014-01-24','2014-01-24 14:24:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:01:18'),(19186,15285,'Y','18','021','EC','A','','','AC','0001250581','0001250581','TX00002570847','IL','1','conklin','bethany','','','','34','103740899','13316 BOSSWOOD DR',0,'AUSTIN','TX','78727','3301','CY','48453','1987-07-28','F','U',':RET:2106-3','T','021','DEN','2450828','33348TX002000101','2014-03-01','2014-01-19 19:08:36','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-01-21 08:46:10'),(18279,14594,'Y','18','021','EC','A','','','AC','0000115558','0000115558','TX00001719274','IL','1','LOPEZ','RUBEN','','','','34','628091011','307 N MISSISSIPPI ST',0,'AMARILLO','TX','79106',NULL,'CY','48375','1989-04-19','M','M',NULL,'N','021','DEN','1497189','33348TX002000201','2014-02-01','2014-01-15 18:07:19','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2014-01-16 08:44:46'),(17570,14048,'Y','18','021','EC','A','','','AC','0000996541','0000996541','OH00002559233','IL','1','collie','ray','','','','34','287844118','126 BARNUM ST',0,'LIBERTY TWP','OH','45011','2534','CY','39017','1984-11-19','M','U',':RET:2106-3','N','021','DEN','2400835','99734OH005000401','2014-02-01','2014-01-13 12:17:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-14 01:32:01'),(6667,5288,'Y','18','021','EC','A','','','AC','0000361646','0000361646','TX00000402353','IL','1','duffy','patrick','','','','34','462840232','3114 HUMBLE AVE',0,'MIDLAND','TX','79705','8208','CY','48329','1951-07-07','M','U',':RET:2106-3','N','021','DEN','386672','33348TX002000201','2014-01-01','2013-11-16 14:51:25','0.00',NULL,NULL,'29.22','29.22','R-TX016','TX0','14.61',NULL,0,'2013-12-26 01:01:01'),(16693,13359,'Y','18','021','EC','A','','','AC','0000660401','0000660401','TX00001838965','IL','1','Porras','Mary','','','','34','450130265','1201 N VIRGINIA ST',0,'EL PASO','TX','79902','4443','CY','48141','1956-09-25','F','U',':RET:2106-3','N','021','DEN','1597768','33348TX002000201','2014-02-01','2014-01-07 14:02:15','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-08 18:24:36'),(443,364,'Y','18','021','EC','A','','','AC','0000523379','0000523379','OH00000005999','IL','1','Hopkins','Ruby','','','','34','301621730','3380 GREYWOOD DR',0,'COLUMBUS','OH','43219','5037','CY','39049','1959-02-13','F','U',':RET:2054-5','N','021','DEN','111673','99734OH005000401','2014-01-01','2013-12-04 11:19:52','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 17:47:13'),(5480,4351,'Y','18','021','EC','A','','','AC','0000859684','0000859684','OH00000838614','IL','1','Beaupry','Teresa','','','','34','268548256','11562 LAKEWAY DR',0,'CURTICE','OH','43412','9411','CY','39095','1953-07-29','F','U',':RET:2106-3','N','021','HLT','2386120','92036OH005002605','2014-01-01','2013-12-19 17:09:47','407.00',NULL,NULL,'529.21','122.21','R-OH001','OH0','529.21',NULL,0,'2013-12-25 23:10:49'),(3311,2661,'N','19','021','EC','A',NULL,NULL,'','0000198559','0000587971','','S1','1','Latscha','Brian','','','','34','277178469','5542 KAREN AVE',0,'CINCINNATI','OH','45248','5207','CY','39061','2011-05-23','F','',':RET:2106-3','N','021','DEN','2587529','99734OH005000301','2014-01-01','2013-12-22 14:14:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:52'),(20993,16774,'N','01','021','EC','A',NULL,NULL,'','0000609559','0001108123','','IL','1','Al-Shannawi','Angela','A','','','34','547759396','1527 ADELAIDE CT',0,'WESTLAKE','OH','44145','2466','CY','39035','1969-09-24','F','',NULL,'N','021','DEN','3671690','99734OH005000301','2014-03-01','2014-01-31 21:03:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:25'),(20840,16657,'Y','18','021','EC','A','','','AC','0000812059','0000812059','OH00001470685','IL','1','eichenberg','john','','','','34','190463868','9471 LEDGE ACRES DR',0,'MACEDONIA','OH','44056','1031','CY','39153','1958-11-07','M','U',NULL,'N','021','HLT','3701144','52664OH151001301','2014-03-01','2014-01-31 13:31:32','0.00',NULL,NULL,'497.31','497.31','R-OH012','OH0','497.31',NULL,0,'2014-01-31 21:00:45'),(5287,4189,'Y','18','021','EC','A','','','AC','0000941981','0000941981','OH00000629492','IL','1','Williams','Robert','Thomas','','Jr','34','185548626','554 West Avenue',0,'Tallmadge','OH','44278',NULL,'CY','39153','1966-01-13','M','U',NULL,'N','021','HLT','1878897','52664OH151001304','2014-01-01','2013-12-19 15:39:01','149.00',NULL,NULL,'348.56','199.56','R-OH012','OH0','348.56',NULL,0,'2013-12-25 23:05:56'),(4810,3812,'N','01','021','EC','A',NULL,NULL,'','0000274761','0000723873','','IL','1','White-Lowther','Roxanne','','','','34','284527152','570 MURRAY HILL DR',0,'YOUNGSTOWN','OH','44505','1564','CY','39155','1952-07-10','F','',':RET:2106-3','N','021','DEN','77811','99734OH005000301','2014-01-01','2013-12-08 11:29:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:16:46'),(4315,3429,'N','01','021','EC','A',NULL,NULL,'','0000093834','0000803718','','IL','1','davis','orville','j','','','34','406119320','2702 TYLERSVILLE RD',0,'VILLAGE OF INDIAN SPRINGS','OH','45015','3301','CY','39017','1965-12-09','M','',':RET:2106-3','N','021','HLT','1806855','92036OH003001201','2014-01-01','2013-12-17 07:29:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','366.54',NULL,0,'2013-12-25 21:52:38'),(7572,5992,'N','19','021','EC','A',NULL,NULL,'','0000996517','0000464615','','S1','1','Lee','Marc','','','','34','288136853','459 S WASHINGTON ST',0,'TIFFIN','OH','44883','3313','CY','39147','2007-10-30','M','',NULL,'N','021','HLT','140720','92036OH001002701','2014-01-01','2013-12-15 10:22:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','149.37',NULL,0,'2013-12-26 02:33:45'),(17399,13923,'Y','18','021','EC','A','','','AC','0000362516','0000362516','OH00001634080','IL','1','Dailey','Kecia','','','','34','312947222','1546 CRANBERRY LN',0,'FINDLAY','OH','45840','0906','CY','39063','1982-06-17','F','M',':RET:2106-3','N','021','HLT','1989058','92036OH006001501','2014-02-01','2014-01-10 13:15:32','138.00',NULL,NULL,'202.30','64.30','R-OH002','OH0','202.30',NULL,0,'2014-01-13 03:00:15'),(13013,10371,'Y','18','021','EC','A','','','AC','0001158913','0001158913','OH00000967589','IL','1','Smith','Tyrone','','','','34','298701446','1339 Johnny Lytle Ave.',0,'Springfield','OH','45506',NULL,'CY','39023','1976-07-20','M','U',':RET:2054-5','T','021','DEN','1397676','99734OH005000401','2014-01-01','2013-12-22 19:09:26','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:49:50'),(8893,7051,'Y','18','021','EC','A','','','AC','0000506630','0000506630','TX00000026617','IL','1','hanna','alan','','','','34','427062732','4000 PARKSIDE CENTER BLVD',0,'FARMERS BRANCH','TX','75244','4357','CY','48113','1962-02-07','M','U',':RET:2106-3','N','021','DEN','2278935','33348TX002000201','2014-01-01','2013-12-18 17:34:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:02:04'),(26823,21258,'Y','18','021','EC','A','','','AC','0000992729','0000992729','OH00002746730','IL','1','Stone','david','','','','34','297827482','518 BLAINE ST',0,'GENEVA','OH','44041','1610','CY','39007','1984-08-13','M','U',':RET:2106-3','N','021','DEN','3890595','99734OH005000401','2014-04-01','2014-03-01 12:28:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-01 21:00:36'),(6469,5126,'Y','18','021','EC','A','','','AC','0000119038','0000119038','OH00000703215','IL','1','Belair','Denise','','','','34','283749290','10383 GOLDEN RIDGE DR',0,'WADSWORTH','OH','44281','8648','CY','39103','1963-03-31','F','M',':RET:2106-3','N','021','HLT','469279','52664OH151001305','2014-01-01','2013-12-10 19:54:46','688.00',NULL,NULL,'941.76','253.76','R-OH012','OH0','398.29',NULL,0,'2013-12-26 00:50:06'),(4043,3227,'Y','18','021','EC','A','','','AC','0001119947','0001119947','OH00000830885','IL','1','Bougie','Kristine','','','','34','288520364','615 Stanley Street',0,'Middletown','OH','45044',NULL,'CY','39017','1950-09-27','F','U',':RET:2106-3','N','021','DEN','2566595','99734OH005000401','2014-01-01','2013-12-17 11:28:23','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:46:09'),(18642,14861,'Y','18','024','14','A','','','TE','0000525434','0000525434','','IL','1','Penrod','David',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-03-19','M','',NULL,NULL,NULL,'','1887562','','2014-01-15','2014-01-15 23:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-17 03:35:06'),(18400,14681,'Y','18','021','EC','A','','','AC','0000884245','0000884245','OH00002224755','IL','1','Golupski','Linda','','','','34','274566756','314 MEADOW LN',0,'WALBRIDGE','OH','43465','1206','CY','39173','1956-06-30','F','U',':RET:2106-3','N','021','DEN','2649446','99734OH005000301','2014-02-01','2014-01-15 17:19:40','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-01-16 08:45:42'),(18140,14485,'Y','18','021','EC','A','','','AC','0001568881','0001568881','LA00001737628','IL','1','Crockett','Jerry','Anthony','','','34','278522154','3129 PHOENIX ST',0,'KENNER','LA','70065','5123','CY','22051','1954-11-20','M','U',':RET:2054-5','N','021','DEN','1383948','18575LA002000101','2014-02-01','2014-01-14 11:06:59','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-15 02:07:46'),(22004,17568,'N','01','021','EC','A',NULL,NULL,'','0000658460','0000105412','','IL','1','Mennetti','Matthew',NULL,NULL,NULL,NULL,NULL,'612 DOUGLAS DR',0,'WAUSEON','OH','43567','1613','CY','39051','1969-10-17','M','',':RET:2106-3','N','021','DEN','3010499','99734OH005000301','2014-03-01','2014-02-06 19:01:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:48'),(5235,4153,'N','01','021','EC','A',NULL,NULL,'','0000446277','0000937261','','IL','1','Kress','Jennifer','L','','','34','299769627','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','1977-11-12','F','',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','274.30',NULL,0,'2013-12-25 23:04:49'),(8928,7078,'Y','18','021','EC','A','','','AC','0001106777','0001106777','OH00000477997','IL','1','Sonek','Emma','Claire','','','34','289889474','106 NANTUCKET LNDG',0,'WASHINGTON TOWNSHIP','OH','45458','4207','CY','39113','1982-08-31','F','U',NULL,'N','021','DEN','2369118','99734OH005000401','2014-01-01','2013-12-18 09:30:11','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:02:56'),(9062,7191,'Y','18','024','14','A','','','TE','0000013897','0000013897','','IL','1','Hunter','Robbie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-05-10','M','',NULL,NULL,NULL,'','1235778','','2013-12-18','2013-12-18 12:26:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:06:23'),(14075,11217,'Y','18','021','EC','A','','','AC','0000153374','0000153374','OH00000129294','IL','1','GAMBEL','KIM','B','','','34','291607011','1770 REPUBLIC AVE',0,'COLUMBUS','OH','43211','1853','CY','39049','1967-09-08','F','U',':RET:2054-5','T','021','DEN','1502229','99734OH005000401','2014-02-01','2013-12-26 10:01:28','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:59'),(6902,5477,'Y','18','021','EC','A','','','AC','0001773091','0001773091','LA00000481707','IL','1','sellers','hicks','','','','34','433418050','8501 BELFAST ST',0,'NEW ORLEANS','LA','70118','3137','CY','22071','1963-09-03','M','M',':RET:2106-3','N','021','DEN','1502212','18575LA002000201','2014-01-01','2013-12-24 22:45:07','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:39'),(20379,16279,'N','01','021','EC','A',NULL,NULL,'','0000102447','0000848505','','IL','1','sarwar','maryam','','','','34','444155769','12480 abrams road',0,'dallas','TX','75243',NULL,'CY','48113','1985-04-19','F','',':RET:2028-9','N','021','DEN','2855104','33348TX002000201','2014-03-01','2014-01-28 20:12:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-29 21:00:10'),(6621,5251,'Y','18','021','EC','A','','','AC','0000287668','0000287668','MS00000951045','IL','1','BARNES','ROSE','MARIE','','','34','426115155','201 KATIE AVE',0,'HATTIESBURG','MS','39401','4362','CY','28035','1961-10-14','F','U',':RET:2054-5','N','021','DEN','1135505','46300MS002000201','2014-01-01','2013-12-11 13:10:41','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 00:54:03'),(6271,4972,'N','01','021','EC','A',NULL,NULL,'','0000054445','0001231749','','IL','1','Wheeler','Erin','','','','34','285806187','2567 Shiloh Park',0,'Westlake','OH','44145',NULL,'CY','39035','1978-09-25','F','',':RET:2106-3','N','021','DEN','623390','99734OH005000401','2014-01-01','2013-12-10 18:29:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:45:07'),(17576,14053,'Y','18','021','EC','A','','','AC','0000564222','0000564222','OH00001636377','IL','1','MISEVSKI','KRIS','','','','34','286764179','417 Eastmoor Blvd.',0,'Columbus','OH','43209',NULL,'CY','39049','1970-09-09','M','R',':RET:2106-3','N','021','DEN','1366100','99734OH005000401','2014-02-01','2014-01-13 13:49:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-14 01:32:04'),(16604,13281,'Y','18','021','EC','A','','','AC','0001959782','0001959782','LA00001994793','IL','1','Dedon','Stacy','','','','34','437457897','1335 BELLE TERRE DR',0,'SAINT GABRIEL','LA','70776','5221','CY','22047','1977-11-14','F','R',':RET:2106-3','N','021','DEN','1370946','18575LA002000201','2014-02-01','2014-01-07 13:56:12','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:05'),(4664,3697,'N','01','021','EC','A',NULL,NULL,'','0000524198','0000236283','','IL','1','toom','mirvat','','','','34','593519188','14055 tricou blvd',0,'hammond','LA','70403',NULL,'CY','22105','1976-09-10','F','',NULL,'N','021','DEN','520000','18575LA002000201','2014-01-01','2013-12-12 12:21:23',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:27'),(15913,12743,'N','19','021','EC','A',NULL,NULL,'','0000797000','0000517963','','S1','1','geloach','ruth','','','','34','637981702','286 fm1696 rd west',0,'huntsville','TX','77320',NULL,'CY','48471','2005-10-09','F','',':RET:2106-3','N','021','DEN','2537657','33348TX002000101','2014-02-01','2014-01-02 18:19:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-01-03 02:06:27'),(14451,11528,'Y','18','021','EC','A','','','AC','0002048871','0002048871','LA00001166683','IL','1','BUSSEY','LORNA','','','','34','436193095','337 RUTH ST',0,'HOUMA','LA','70364','3365','CY','22109','1961-11-18','F','M',NULL,'N','021','DEN','2234706','18575LA002000201','2014-02-01','2013-12-27 13:54:38','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2013-12-28 03:32:29'),(4420,3512,'Y','18','021','EC','A','','','AC','0000682131','0000682131','OH00000573126','IL','1','Hodges','Deborah','Regina','','','34','235846640','4939 DOWNING DR',0,'COLUMBUS','OH','43232','4600','CY','39049','1952-06-06','F','M',':RET:2106-3','N','021','DEN','54238','99734OH005000401','2014-01-01','2013-12-12 16:23:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:37'),(7906,6250,'Y','18','021','EC','A','','','AC','0001953595','0001953595','LA00000952692','IL','1','Jackson','Al','','','','34','267775451','48 TUSCANY DR',0,'LA PLACE','LA','70068','8411','CY','22095','1962-06-22','M','R',':RET:2054-5','N','021','DEN','1412672','18575LA002000201','2014-01-01','2013-12-19 20:08:37','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:05:56'),(7526,5957,'Y','18','021','EC','A','','','AC','0000107680','0000107680','TX00000457429','IL','1','Long','Dalton','','','','34','442621613','7278 WILEY RD',0,'HOUSTON','TX','77016','3433','CY','48201','1963-07-12','M','U',':RET:2054-5','T','021','DEN','9281','33348TX002000201','2014-01-01','2013-12-14 20:44:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:32:34'),(3254,2623,'N','19','021','EC','A',NULL,NULL,'','0000148293','0000162243','','IL','1','Scott','Christopher','Sterling','','Jr','34','295981832','24 2ND AVE',0,'BEREA','OH','44017','1244','CY','39035','1996-01-02','M','',':RET:2054-5','N','021','DEN','197683','99734OH005000301','2014-01-01','2013-11-27 20:49:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:46:42'),(22490,17954,'N','01','021','EC','A',NULL,NULL,'','0000976762','0001171925','','IL','1','McOwen','Rose','','','','34','294700183','112 E MAIN ST',0,'BEAVERDAM','OH','45808','9723','CY','39003','1961-10-21','F','',NULL,'N','021','DEN','3647458','99734OH005000301','2014-03-01','2014-02-10 12:25:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:07'),(24648,19565,'Y','18','021','EC','A','','','AC','0001702936','0001702936','LA00001963435','IL','1','Carney','MARCENETTE','','','','34','436457746','2741 N DAY DR',0,'BAKER','LA','70714','3213','CY','22033','1968-08-17','F','U',':RET:2054-5','N','021','DEN','3592362','18575LA002000201','2014-04-01','2014-02-19 15:30:50','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:21:49'),(27028,21406,'Y','18','021','EC','A','','','AC','0000680042','0000680042','TX00002627562','IL','1','Nguyen','Kimberly','','','','34','522356809','1009 DUSTY KAY ST',0,'BONHAM','TX','75418','5524','CY','48147','1977-03-28','F','U',':RET:2047-9','N','021','DEN','3721649','33348TX002000201','2014-04-01','2014-03-03 13:15:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-03 21:00:15'),(27128,21475,'Y','18','024','14','A','','','TE','0001156235','0001156235','','IL','1','SHARKEY','DAISY','S',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-12-29','F','',NULL,NULL,NULL,'','3103741','','2014-03-18','2014-03-03 10:16:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-03 21:30:38'),(28382,22457,'Y','18','021','EC','A','','','AC','0000512016','0000512016','OH00003559076','IL','1','Keough','Cynthia','','','','34','210546434','9015 TORY DR',0,'STREETSBORO','OH','44241','5793','CY','39133','1965-10-29','F','U',':RET:2106-3','T','021','HLT','3187931','52664OH152000901','2014-04-01','2014-03-07 12:29:24','122.00',NULL,NULL,'307.12','185.12','R-OH012','OH0','307.12',NULL,0,'2014-03-07 21:30:40'),(5939,4703,'Y','18','021','EC','A','','','AC','0001724222','0001724222','LA00000440460','IL','1','Latino','brandi','','','','34','433638914','1601 E BAYOU RD',0,'DONALDSONVILLE','LA','70346','4314','CY','22005','1986-11-23','F','U',':RET:2106-3','N','021','DEN','2218079','18575LA002000101','2014-01-01','2013-12-23 23:22:55','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:50:45'),(3952,3162,'Y','18','024','14','A','','','TE','0000019094','0000019094','','IL','1','Tuel','Daniel',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-16','M','',NULL,NULL,NULL,'','518508','','2013-12-13','2013-12-13 10:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:38:11'),(3925,3141,'N','01','021','EC','A',NULL,NULL,'','0000058738','0001119944','','IL','1','MANUEL','DAVID','L','','','34','375603103','7292 FAIR RIDGE RD',0,'HILLSBORO','OH','45133','6677','CY','39071','1953-06-25','M','',':RET:2106-3','N','021','HLT','442343','92036OH001000601','2014-01-01','2013-12-13 16:12:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','702.75',NULL,0,'2013-12-25 21:37:27'),(13567,10820,'Y','18','021','EC','A','','','AC','0002249012','0002249012','LA00000931191','IL','1','vallejos','julio','','','','34','434431494','3410 Severn Ave',0,'Metairie','LA','70002',NULL,'CY','22051','1965-10-29','M','U',NULL,'N','021','DEN','1747183','18575LA002000201','2014-01-01','2013-12-23 16:47:35','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:32'),(17428,13945,'N','19','021','EC','A',NULL,NULL,'','0000817556','0000727293','','IL','1','Digonno','Johna','C','','','34','293967837','2531 REGINA PL',0,'HAMILTON','OH','45013','4812','CY','39017','1994-02-03','F','',':RET:2106-3','N','021','HLT','2087727','92036OH003001205','2014-02-01','2014-01-10 12:11:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-01-13 03:00:30'),(16231,12998,'Y','18','021','EC','A','','','AC','0000678102','0000678102','OH00001373654','IL','1','FERRELL','SHAUN','','','','34','272768407','1425 HUNTERS LAKE DR E',0,'CUYAHOGA FALLS','OH','44221','5305','CY','39153','1979-05-18','M','U',':RET:2106-3','N','021','HLT','2159480','52664OH151001306','2014-02-01','2014-01-04 08:58:53','223.00',NULL,NULL,'270.73','47.73','R-OH012','OH0','270.73',NULL,0,'2014-01-05 00:02:03'),(14952,11950,'Y','18','021','EC','A','','','AC','0000758245','0000758245','TX00001074144','IL','1','iturralde','mario','','','','34','461593211','2255 CENTRAL BLVD',0,'BROWNSVILLE','TX','78520','8711','CY','48061','1975-08-06','M','U',NULL,'N','021','DEN','1571238','33348TX002000201','2014-02-01','2013-12-29 21:52:33','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-01 12:00:12'),(22486,17952,'Y','18','021','EC','A','','','AC','0000711414','0000711414','OH00002213602','IL','1','Graf','Charles','','','III','34','293880683','262 SKAGGS RD',0,'LONDONDERRY','OH','45647','9733','CY','39141','1976-08-14','M','U',':RET:2106-3','N','021','DEN','3254510','99734OH005000301','2014-03-01','2014-02-10 10:15:12','0.00',NULL,NULL,'21.13','21.13','R-OH010','OH0','0.00',NULL,0,'2014-02-10 21:31:05'),(22598,18049,'N','01','021','EC','A',NULL,NULL,'','0000262764','0000077603','','IL','1','Parker-Price','Jayme','L','','','34','451433240','5967 BLACK OAK DR',0,'TOLEDO','OH','43615','1811','CY','39095','1977-05-09','F','',':RET:2054-5','N','021','HLT','3159099','92036OH003002605','2014-03-01','2014-02-10 14:11:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','250.48',NULL,0,'2014-02-10 21:32:13'),(23175,18477,'Y','18','021','EC','A','','','AC','0000643272','0000643272','OH00002318226','IL','1','emmons','pamela','','','','34','280484914','233 Lester ave',0,'finely','OH','45840',NULL,'CY','39063','1950-03-21','F','M',NULL,'T','021','HLT','3486965','92036OH004001501','2014-03-01','2014-02-12 15:12:01','563.00',NULL,NULL,'600.76','37.76','R-OH002','OH0','600.76',NULL,0,'2014-02-12 21:31:55'),(27670,21886,'N','01','021','EC','A',NULL,NULL,'','0000655742','0000297564','','IL','1','garza','hildegardo','','','III','34','450656737','2314 GUAVA DR',0,'WESLACO','TX','78596','1790','CY','48215','1972-04-08','M','',NULL,'N','021','DEN','3000388','33348TX002000201','2014-04-01','2014-03-04 18:28:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:33'),(28372,22451,'Y','18','021','EC','A','','','AC','0001158999','0001158999','OH00003432386','IL','1','Clock','Doris','','','','34','280742970','7067 Cozaddale Rd',0,'Goshen','OH','45122',NULL,'CY','39025','1962-11-16','F','R',':RET:2106-3','N','021','HLT','2785963','92036OH005000601','2014-04-01','2014-03-06 19:04:01','0.00',NULL,NULL,'400.37','400.37','R-OH005','OH0','400.37',NULL,0,'2014-03-07 21:30:35'),(7305,5789,'N','01','021','EC','A',NULL,NULL,'','0000356029','0001229296','','IL','1','DEITERS','GREGORY','P','','','34','271446679','683 VALLEY CREST DR',0,'AKRON','OH','44319','4260','CY','39153','1957-10-04','M','',':RET:2106-3','N','021','HLT','806151','52664OH151001305','2014-01-01','2013-12-14 15:14:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','520.28',NULL,0,'2013-12-26 02:03:14'),(21253,16984,'Y','18','021','EC','A','','','AC','0001241903','0001241903','OH00001535866','IL','1','Bell','John','A','','','34','283663965','441 E CASTON RD',0,'AKRON','OH','44319','5061','CY','39153','1963-06-07','M','M',':RET:2106-3','N','021','HLT','3439142','52664OH151001301','2014-03-01','2014-02-03 13:57:18','329.00',NULL,NULL,'398.29','69.29','R-OH012','OH0','398.29',NULL,0,'2014-02-03 21:01:19'),(25022,19841,'Y','18','021','EC','A','','','AC','0000845949','0000845949','TX00001650153','S3','1','Ali','Navroz',NULL,NULL,NULL,NULL,NULL,'3517 Dry Brook',0,'Pflugerville','TX','78660',NULL,'CY','48453','2007-03-10','M','U',NULL,'N','021','DEN','3165330','33348TX002000101','2014-04-01','2014-02-19 20:52:28','46.09',NULL,NULL,'47.10','1.01','R-TX003','TX0','47.10',NULL,0,'2014-02-20 22:00:57'),(7171,5686,'Y','18','021','EC','A','','','AC','0000255964','0000255964','OH00001399257','31','1','Funk','Christine','Ingrid','','','34','298660592','P.O. Box 30187',0,'Middleburg Heights','OH','44130',NULL,'CY','39035','1967-06-08','F','U',':RET:2106-3','N','021','HLT','1392658','92036OH005000805','2014-02-01','2013-12-25 00:00:34','217.00',NULL,NULL,'350.69','133.69','R-OH011','OH0','350.69',NULL,0,'2013-12-26 01:52:42'),(793,654,'N','01','021','EC','A',NULL,NULL,'','0001229370','0000229354','','IL','1','Lesay','Isabelle','Odeppe','','','34','438295273','714 BURLESON ST',0,'SAN MARCOS','TX','78666','4335','CY','48209','1955-07-26','F','',':RET:2106-3','N','021','DEN','2394994','33348TX002000201','2014-01-01','2013-12-16 16:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:05:22'),(3176,2554,'Y','18','021','EC','A','','','AC','0000472220','0000472220','MS00000842055','IL','1','Favaloro','John','','','','34','439394897','25744 PINECREST DR',0,'PICAYUNE','MS','39466','9377','CY','28109','1964-11-03','M','U',':RET:2106-3','N','021','DEN','520860','46300MS002000101','2014-01-01','2013-11-18 14:41:03','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2013-12-25 20:31:42'),(20514,16391,'Y','18','021','EC','A','','','AC','0000836662','0000836662','OH00001426851','IL','1','Haskins','Anne','Lois','','','34','277726199','550 IMO DR',0,'DAYTON','OH','45405','2940','CY','39113','1966-03-23','F','U',':RET:2054-5','T','021','HLT','3470318','92036OH006000501','2014-03-01','2014-01-29 11:58:52','259.00',NULL,NULL,'338.85','79.85','R-OH003','OH0','338.85',NULL,0,'2014-01-29 21:01:21'),(17139,13715,'Y','18','021','EC','A','','','AC','0000095252','0000095252','OH00002481355','IL','1','OSBORN','DANIEL','','','','34','270560706','557 BECKLEE DR',0,'NAPOLEON','OH','43545','9130','CY','39069','1969-01-14','M','U',':RET:2106-3','N','021','HLT','1455907','92036OH006002601','2014-02-01','2014-01-08 09:05:09','109.00',NULL,NULL,'223.31','114.31','R-OH001','OH0','223.31',NULL,0,'2014-01-13 02:21:51'),(16020,12824,'Y','18','024','14','A','','','TE','0001962357','0001962357','','IL','1','Leonard','Brandon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-08-15','M','',NULL,NULL,NULL,'','2289536','','2014-01-03','2014-01-03 06:58:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-04 02:02:09'),(13769,10991,'Y','18','024','14','A','','','TE','0000439559','0000439559','','IL','1','Harris','Leon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-21','M','',NULL,NULL,NULL,'','2612041','','2013-12-23','2013-12-23 12:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2013-12-26 13:10:28'),(13770,10992,'Y','18','021','EC','A','','','AC','0000439559','0000439559','MS00001068058','31','1','Harris','Leon','','','','34','587500950','P O Box 54',0,'Maben','MS','39750',NULL,'CY','28105','1952-05-21','M','M',':RET:2054-5','N','021','DEN','2358607','46300MS002000201','2014-01-01','2013-12-23 12:29:14','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:29'),(28878,22854,'N','19','021','EC','A',NULL,NULL,'','0000888892','0000081258','','IL','1','CANTU','JUSTIN','REECE','','','34','641184933','506 MARINA DR',0,'PORT ISABEL','TX','78578',NULL,'CY','48061','1990-10-04','M','',NULL,'N','021','DEN','4235995','33348TX002000201','2014-04-01','2014-03-10 11:27:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-10 21:00:07'),(9363,7422,'N','01','021','EC','A',NULL,NULL,'','0001941230','0001393298','','IL','1','Rongey','Yvonne','','','','34','008515368','70 BELLGROVE DR',0,'DESTREHAN','LA','70047','2524','CY','22089','1988-07-04','F','',':RET:2106-3','N','021','DEN','1567266','18575LA002000201','2014-01-01','2013-12-21 11:06:14',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 04:31:36'),(20317,16220,'Y','18','021','EC','A','','','AC','0001048965','0001048965','TX00001500586','IL','1','Means','Emma','','','','34','464928822','15530 FALL BRIAR DR',0,'MISSOURI CITY','TX','77489','2821','CY','48157','1949-11-17','F','U',':RET:2054-5','N','021','DEN','1837307','33348TX002000201','2014-03-01','2014-01-28 13:52:02','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-28 21:00:53'),(19690,15691,'Y','18','021','EC','A','','','AC','0000800833','0000800833','TX00001433877','IL','1','BAKER','TANYA','','','','34','467983819','1003 RICHMOND DR',0,'MARSHALL','TX','75672','2507','CY','48203','1968-09-12','F','M',NULL,'N','021','DEN','2707774','33348TX002000201','2014-03-01','2014-01-23 16:42:58','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-23 21:00:42'),(18824,14993,'Y','18','021','EC','A','','','AC','0000012690','0000012690','MS00001456466','31','1','Wilson','Brenda','','','','34','426153689','P.O. Box 945',0,'Raymond','MS','39154',NULL,'CY','28049','1959-10-05','F','U',':RET:2054-5','N','021','DEN','2032209','46300MS002000201','2014-02-01','2014-01-15 22:20:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:07'),(2748,2224,'Y','18','024','14','A','','','TE','0000662666','0000662666','','IL','1','McFerran','Angela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-10-09','F','',NULL,NULL,NULL,'','821715','','2013-12-01','2013-12-01 20:27:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:48:59'),(7498,5930,'N','01','021','EC','A',NULL,NULL,'','0000690707','0001077700','','IL','1','Sarisky','Jacqueline','','','','34','285520777','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1953-01-05','F','',':RET:1002-5^:RET:2106-3','T','021','DEN','449387','99734OH005000401','2014-01-01','2013-12-15 15:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:46'),(14872,11876,'Y','18','021','EC','A','','','AC','0000589490','0000589490','TX00001609046','IL','1','slater','michelle','','','','34','450971643','1601 WHITE DOVE LN',0,'DENTON','TX','76210','7143','CY','48121','1979-07-18','F','U',':RET:2106-3','N','021','DEN','1473067','33348TX002000201','2014-02-01','2013-12-29 12:10:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-30 00:00:15'),(5247,4161,'N','01','021','EC','A',NULL,NULL,'','0000857090','0001033647','','IL','1','KVETENSKY','CAROLINE','A','','','34','280583342','10955 MITCHELL RD',0,'COLUMBIA STATION','OH','44028','9564','CY','39093','1957-04-01','F','',':RET:2106-3','N','021','HLT','2180575','52664OH151001301','2014-01-01','2013-12-18 23:15:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.79',NULL,0,'2013-12-25 23:05:02'),(14351,11445,'Y','18','021','EC','A','','','AC','0000156939','0000156939','OH00000650850','IL','1','DWELLY','TODD','ROBERT','','','34','300440180','1406 ROSE HILL RD',0,'HAMERSVILLE','OH','45130','8716','CY','39015','1956-03-15','M','U',':RET:2106-3','N','021','HLT','2265109','92036OH005000606','2014-02-01','2013-12-26 18:16:42','418.00',NULL,NULL,'523.16','105.16','R-OH005','OH0','523.16',NULL,0,'2013-12-27 02:08:06'),(3760,3009,'Y','18','021','EC','A','','','AC','0000777658','0000777658','OH00001038916','IL','1','schuck','serena','may','','','34','298842729','456 COUNTY ROAD 1775',0,'JEROMESVILLE','OH','44840','9726','CY','39005','1977-05-31','F','M',':RET:2106-3','N','021','HLT','973684','52664OH151001306','2014-01-01','2013-12-13 10:20:39','469.00',NULL,NULL,'559.30','90.30','R-OH012','OH0','274.30',NULL,0,'2013-12-25 21:33:24'),(13087,10434,'Y','18','021','EC','A','','','AC','0001045680','0001045680','OH00000200375','IL','1','Jacobson','Cynthia','','','','34','262390196','3671 Medina Line Road',0,'Richfield','OH','44286',NULL,'CY','39153','1958-02-20','F','R',':RET:2106-3','N','021','DEN','1375586','99734OH005000401','2014-01-01','2013-12-23 11:24:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 12:51:45'),(4060,3243,'Y','18','021','EC','A','','','AC','0000507969','0000507969','OH00000854298','IL','1','Hatcher','Ronald','','','','34','264909079','490 UPLAND RD',0,'BAY VILLAGE','OH','44140','2849','CY','39035','1950-06-03','M','U',':RET:2106-3','N','021','DEN','1415984','99734OH005000401','2014-01-01','2013-12-17 15:43:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:46:39'),(24548,19500,'Y','18','021','EC','A','','','AC','0000928544','0000928544','OH00002207602','IL','1','JOHNSON','DAVID','','','','34','282623831','7122 RIDGE AVE SE',0,'EAST SPARTA','OH','44626','9448','CY','39151','1959-05-07','M','U',':RET:2106-3','T','021','HLT','3091078','52664OH151001301','2014-04-01','2014-02-19 08:53:15','297.00',NULL,NULL,'770.55','473.55','R-OH015','OH0','547.54',NULL,0,'2014-02-20 04:03:49'),(25641,20341,'Y','18','024','14','A','','','TE','0002046403','0002046403','','IL','1','Porche','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-02-25','M','',NULL,NULL,NULL,'','1990422','','2014-03-31','2014-02-22 15:20:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-26 08:30:31'),(25722,20402,'Y','18','021','EC','A','','','AC','0001052527','0001052527','MS00002963604','IL','1','HARRISON','MELVIN','','','','34','587681230','30 ROOSEVELT MAGEE ROAD',0,'TYLER TOWN','MS','39667',NULL,'CY','28147','1964-06-16','M','M',':RET:2054-5','N','021','DEN','3410711','46300MS002000101','2014-04-01','2014-02-23 21:26:05','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-26 09:30:28'),(27641,21863,'Y','18','021','EC','A','','','AC','0000544173','0000544173','OH00003721235','IL','1','White','Maurice','','','III','34','271842838','6744 Netherland Court',0,'Liberty Township','OH','45044',NULL,'CY','39017','1981-12-27','M','U',':RET:2106-3','N','021','DEN','3909846','99734OH005000401','2014-04-01','2014-03-05 11:50:57','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:30:16'),(28683,22699,'Y','18','021','EC','A','','','AC','0001204026','0001204026','TX00003420111','IL','1','Phonethephaseone','Chithpaseuth','','','','34','461775216','3831 FM 1004',0,'CALL','TX','75933','4018','CY','48351','1974-10-05','F','U',':RET:2028-9','N','021','DEN','3164564','33348TX002000101','2014-04-01','2014-03-07 21:36:15','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-03-08 21:30:58'),(29079,23015,'Y','18','021','EC','A','','','AC','0000566108','0000566108','MS00002959471','IL','1','Roberson','Summer','Devail','','','34','426359449','3820 SOUTHBROOK DR',0,'HORN LAKE','MS','38637','2515','CY','28033','1979-09-21','F','U',':RET:2054-5','N','021','DEN','3646848','46300MS002000101','2014-04-01','2014-03-10 12:59:47','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-03-10 21:02:02'),(78,69,'Y','18','021','EC','A','','','AC','0000866868','0000866868','OH00000890962','IL','1','Tatic','Mirko','','','','34','285986765','3942 WELCKER DR NE',0,'WARREN','OH','44483','4541','CY','39155','1953-12-12','M','M',':RET:2106-3','T','021','DEN','320054','99734OH005000301','2014-01-01','2013-12-05 17:36:54','0.00',NULL,NULL,'59.76','59.76','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:17:07'),(22793,18196,'N','01','021','EC','A',NULL,NULL,'','0000247938','0000551458','','IL','1','Arthur','Ann','Marie','','','34','274680648','118 CASTLE DR',0,'KETTERING','OH','45429','1722','CY','39113','1967-10-14','F','',':RET:2106-3','N','021','DEN','2815543','99734OH005000301','2014-03-01','2014-02-11 12:10:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-11 21:01:50'),(1818,1493,'Y','18','024','14','A','','','TE','0001152192','0001152192','','IL','1','may','william',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-03','M','',NULL,NULL,NULL,'','1825113','','2013-12-24','2013-12-24 08:57:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:57:10'),(23925,19025,'N','01','021','EC','A',NULL,NULL,'','0000614154','0000821060','','IL','1','Gay','Vicki','Michelle','','','34','291666265','2600 EDGEBROOK AVE',0,'AKRON','OH','44312','1569','CY','39153','1958-02-16','F','',':RET:2106-3','N','021','DEN','3478244','99734OH005000401','2014-03-01','2014-02-14 17:06:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:08'),(7485,5921,'N','17','021','EC','A',NULL,NULL,'','0000071620','0000064870','','IL','1','Afzal','Muhammad','','','','34','280153061','6346 RUGOSA AVE',0,'REYNOLDSBURG','OH','43068','1062','CY','39049','1990-01-20','M','',':RET:2029-7','N','021','DEN','692546','99734OH005000401','2014-01-01','2013-12-15 13:53:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:28'),(23304,18579,'Y','18','021','EC','A','','','AC','0000011201','0000011201','OH00002285885','IL','1','Gordon','Dwayne','','','','34','301829603','4249 N GILWOOD DR',0,'STOW','OH','44224','2717','CY','39153','1974-01-26','M','M',':RET:2106-3','N','021','DEN','3138552','99734OH005000301','2014-03-01','2014-02-13 10:11:27','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-02-13 22:00:17'),(13743,10970,'Y','18','021','EC','A','','','AC','0000700375','0000700375','OH00000095670','IL','1','Crutcher','Carrie','','','','34','291783160','6266 CORBLY RD',0,'CINCINNATI','OH','45230','1543','CY','39061','1981-12-15','F','U',':RET:2106-3','N','021','HLT','2133263','92036OH003001205','2014-01-01','2013-12-22 19:38:16','150.00',NULL,NULL,'265.21','115.21','R-OH004','OH0','265.21',NULL,0,'2013-12-26 13:09:45'),(14152,11281,'Y','18','024','14','A','','','TE','0000143051','0000143051','','IL','1','Smith','Trimeca',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-04-10','F','',NULL,NULL,NULL,'','777573','','2013-12-26','2013-12-26 13:36:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:56'),(15210,12156,'Y','18','021','EC','A','','','AC','0000432769','0000432769','OH00000428315','IL','1','Quinter','Alicia','','','','34','274789959','440 Touvelle St',0,'Celina','OH','45822',NULL,'CY','39107','1980-09-15','F','U',':RET:2106-3','N','021','HLT','2295173','92036OH003001506','2014-02-01','2013-12-29 22:15:32','243.00',NULL,NULL,'275.33','32.33','R-OH002','OH0','275.33',NULL,0,'2014-01-01 12:07:41'),(25721,20401,'N','01','021','EC','A',NULL,NULL,'','0000422925','0000149564','','IL','1','Fuller','Karen','','','','34','461908043','612 LAUREL RD',0,'ATHENS','TX','75751','3302','CY','48213','1951-08-22','F','',':RET:2054-5','N','021','DEN','3665760','33348TX002000201','2014-04-01','2014-02-24 17:30:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:28'),(27919,22085,'N','01','021','EC','A',NULL,NULL,'','0000248355','0001057578','','IL','1','ALVARADO','SILVIA','','','','34','247916542','3045 YASMEEN CIR',0,'FLINT','TX','75762','6734','CY','48423','1969-11-23','F','',NULL,'N','021','DEN','3758819','33348TX002000201','2014-04-01','2014-03-05 21:56:51',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:19'),(2235,1837,'N','19','021','EC','A',NULL,NULL,'','0000009819','0000032931','','IL','1','Clark','Maxwell','','','','34','273156459','324 Wentworth Ave',0,'Cincinnati','OH','45215',NULL,'CY','39061','2008-12-28','M','',NULL,'N','021','HLT','584104','92036OH005001201','2014-01-01','2013-12-10 16:24:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 19:20:52'),(23902,19013,'N','19','021','EC','A',NULL,NULL,'','0000158038','0000007028','','IL','1','roof','brook','','','','34','275928274','8416 STATE ROUTE 4',0,'MECHANICSBURG','OH','43044','9741','CY','39021','1989-12-03','F','',NULL,'N','021','HLT','2725588','92036OH004000501','2014-03-01','2014-02-14 17:08:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.13',NULL,0,'2014-02-14 21:32:24'),(6505,5155,'Y','18','021','EC','A','','','AC','0000101406','0000101406','OH00000044050','IL','1','Nist','Renee','','','','34','268522134','3477 East Prescott Circle',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1952-03-20','F','U',':RET:2106-3','N','021','HLT','1008861','52664OH152000901','2014-01-01','2013-12-10 19:35:22','0.00',NULL,NULL,'458.99','458.99','R-OH012','OH0','458.99',NULL,0,'2013-12-26 00:50:58'),(21919,17506,'Y','18','021','EC','A','','','AC','0000097654','0000097654','TX00002264071','IL','1','BYRD','WILHELMINA','','','','34','265966641','505 POST OAK ST',0,'INGRAM','TX','78025','3550','CY','48265','1951-09-08','F','U',NULL,'N','021','DEN','3793556','33348TX002000201','2014-03-01','2014-02-06 18:42:17','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-07 19:00:05'),(21016,16793,'Y','18','021','EC','A','','','AC','0000647102','0000647102','OH00001755171','IL','1','SMITH','WILLIAM','B','','','34','281848906','4965 LANCASTER CIRCLEVILLE RD SW',0,'LANCASTER','OH','43130','8352','CY','39045','1985-04-03','M','U',':RET:2106-3','N','021','DEN','2942629','99734OH005000401','2014-03-01','2014-02-01 15:26:10','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-01 19:00:36'),(20869,16678,'Y','18','021','EC','A','','','AC','0000777566','0000777566','MS00002358486','IL','1','MIDDLETON','CHRISTI','','','','34','428452618','107 SHARPE RD',0,'MADISON','MS','39110','8547','CY','28089','1982-12-27','F','U',NULL,'N','021','DEN','3075709','46300MS002000101','2014-03-01','2014-01-31 11:40:50','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-31 21:01:01'),(19854,15836,'Y','18','021','EC','A','','','AC','0000783268','0000783268','OH00002546115','IL','1','haywood','Angela','christine','','','34','263993180','6551 RAINBOW LN',0,'CINCINNATI','OH','45230','1464','CY','39061','1966-02-25','F','U',':RET:2106-3','N','021','DEN','2021651','99734OH005000301','2014-03-01','2014-01-24 02:34:37','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-24 21:00:32'),(19455,15507,'Y','18','024','14','A','','','TE','0001130905','0001130905','','IL','1','GOTTLIEB','LEWIS',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-12-14','M','',NULL,NULL,NULL,'','1972644','','2014-01-21','2014-01-21 19:06:07',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-23 03:01:54'),(7704,6099,'N','01','021','EC','A',NULL,NULL,'','0000231498','0000285635','','IL','1','Cantrell','Christopher','Ryan','','','34','291659226','112EAST E 10TH ST',0,'MARYSVILLE','OH','43040','3700','CY','39159','1985-04-14','M','',':RET:2106-3','N','021','DEN','2425218','99734OH005000401','2014-01-01','2013-12-20 09:10:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:20'),(17718,14160,'Y','18','021','EC','A','','','AC','0000783254','0000783254','OH00002054584','IL','1','Brown','Jason','','','','34','274602109','541 CLARK DR',0,'TALLMADGE','OH','44278','1549','CY','39153','1965-05-29','M','M',':RET:2106-3','N','021','HLT','2720438','52664OH152000901','2014-02-01','2014-01-13 15:10:50','442.00',NULL,NULL,'687.17','245.17','R-OH012','OH0','267.06',NULL,0,'2014-01-14 01:33:13'),(14197,11322,'Y','18','021','EC','A','','','AC','0000443422','0000443422','TX00000722975','IL','1','LE','KHIEM','','','','34','325901826','5001 N STATE LINE AVE',0,'TEXARKANA','TX','75503',NULL,'CY','48037','1970-12-20','M','M',':RET:2047-9','N','021','DEN','1692354','33348TX002000201','2014-02-01','2013-12-26 13:08:16','0.00',NULL,NULL,'29.22','29.22','R-TX021','TX0','14.61',NULL,0,'2013-12-27 02:04:10'),(24741,19639,'Y','18','021','EC','A','','','AC','0000027939','0000027939','OH00002503722','IL','1','Dugan','Vincent','A','','Jr','34','196428448','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1955-06-13','M','M',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-20 04:40:30'),(25353,20118,'Y','18','021','EC','A','','','AC','0001120004','0001120004','OH00002850819','IL','1','STOGSDILL','DAVID','','','','34','283728277','5757 LAKE EERIE DR.',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','1965-10-07','M','M',':RET:2106-3','T','021','DEN','3026771','99734OH005000301','2014-04-01','2014-02-24 18:33:27','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:30:32'),(26667,21141,'Y','18','024','14','A','','','TE','0002280124','0002280124','','IL','1','Turner','Tress',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-06-20','F','',NULL,NULL,NULL,'','3114489','','2014-02-27','2014-02-27 21:57:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-28 21:31:15'),(27750,21944,'Y','18','021','EC','A','','','AC','0001704417','0001704417','LA00003753520','IL','1','Sartin','Rhonda','K','','','34','439946907','620 CLEVELAND ST',0,'LAKE CHARLES','LA','70601','5365','CY','22019','1956-07-07','F','M',':RET:2106-3','N','021','DEN','3131478','18575LA002000201','2014-04-01','2014-03-05 01:08:47','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-03-05 21:31:15'),(27808,21993,'Y','18','021','EC','A','','','AC','0001088329','0001088329','OH00003273995','IL','1','ALLISON','CHERYL','ANN','','','34','279500182','6871 FIRESTONE AVE NE',0,'CANTON','OH','44721','2518','CY','39151','1949-12-21','F','M',':RET:2106-3','N','021','HLT','3605292','52664OH151001304','2014-04-01','2014-03-05 12:45:50','343.00',NULL,NULL,'669.00','326.00','R-OH015','OH0','669.00',NULL,0,'2014-03-05 21:31:48'),(707,584,'Y','18','021','EC','A','','','AC','0000863663','0000863663','LA00001164647','IL','1','Green','Julie','','','','34','540043162','6235 WALDO DR',0,'NEW ORLEANS','LA','70122','3507','CY','22071','1970-02-10','F','U',':RET:2106-3','N','021','DEN','1153287','18575LA002000201','2014-01-01','2013-12-15 21:46:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:03:04'),(7577,5996,'Y','18','021','EC','A','','','AC','0000440802','0000440802','OH00000857959','IL','1','Kienzle','Debra','','','','34','372729702','2238 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','1102','CY','39095','1958-10-15','F','M',':RET:2106-3','N','021','HLT','394135','92036OH001002601','2014-01-01','2013-12-15 12:30:03','560.00',NULL,NULL,'1693.02','1133.02','R-OH001','OH0','524.52',NULL,0,'2013-12-26 02:33:53'),(21360,17072,'Y','18','021','EC','A','','','AC','0000026263','0000026263','TX00002539105','IL','1','Payton','Tyraniqua','','','','34','434773885','195 E. Round Grove Rd',0,'Lewisville','TX','75067',NULL,'CY','48121','1989-12-14','F','U',':RET:2054-5','N','021','DEN','3183036','33348TX002000201','2014-03-01','2014-02-04 14:35:56','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-04 21:00:43'),(16247,13010,'N','19','021','EC','A',NULL,NULL,'','0000705159','0000259243','','IL','1','Chow','Andrew','Sebastian','','','34','270135750','34078 MONICA DR',0,'NORTH RIDGEVILLE','OH','44039','2130','CY','39093','2006-10-21','M','',':RET:2034-7^:RET:2106-3','N','021','DEN','2297738','99734OH005000301','2014-02-01','2014-01-04 11:35:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-05 00:02:33'),(16552,13241,'N','01','021','EC','A',NULL,NULL,'','0000908038','0001003320','','IL','1','Smith','Jack','Lee','','','34','284565169','11469 W US Hwy 36',0,'Saint Paris','OH','43072',NULL,'CY','39021','1952-11-02','M','',':RET:2106-3','T','021','HLT','1708595','92036OH004000501','2014-02-01','2014-01-05 13:26:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','617.67',NULL,1,'2014-01-07 10:22:46'),(18565,14805,'N','01','021','EC','A',NULL,NULL,'','0000917014','0000965798','','IL','1','Fetters','Wendy','Nicole','','','34','288806759','4000 HARRIET RD',0,'HILLSBORO','OH','45133','7867','CY','39071','1978-10-20','F','',':RET:2106-3','N','021','HLT','1976172','92036OH005000606','2014-02-01','2014-01-15 18:01:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','262.31',NULL,0,'2014-01-16 08:47:01'),(19942,15905,'Y','18','021','EC','A','','','AC','0001099210','0001099210','OH00002396505','IL','1','CLEGG','DONNA','','','','34','192483331','1842 CHERYL PL',0,'SIDNEY','OH','45365','2418','CY','39149','1956-11-20','F','M',':RET:2106-3','T','021','HLT','3294926','92036OH002000501','2014-03-01','2014-01-24 17:19:56','273.00',NULL,NULL,'769.34','496.34','R-OH003','OH0','769.34',NULL,0,'2014-01-24 21:01:15'),(24326,19319,'Y','18','021','EC','A','','','AC','0000748223','0000748223','TX00002144163','IL','1','POWELL','AARON','BLAINE','','','34','446861961','1211 BLUEBONNET DR',0,'MARBLE FALLS','TX','78654','4541','CY','48053','1985-12-17','M','M',NULL,'N','021','DEN','2926544','33348TX002000201','2014-04-01','2014-02-18 13:05:11','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:11'),(24903,19743,'Y','18','021','EC','A','','','AC','0000415441','0000415441','TX00001970800','IL','1','olvera','maria','','','','34','290508889','1005 S DAKOTA ST',0,'HARLINGEN','TX','78552','7626','CY','48061','1954-06-15','F','M',NULL,'N','021','DEN','3213112','33348TX002000201','2014-04-01','2014-02-19 18:54:35','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61','CIC',0,'2014-02-20 21:30:03'),(26658,21133,'Y','18','021','EC','A','','','AC','0000224775','0000224775','OH00003428029','IL','1','WILLIAMS','LONDON','','','','34','280764769','404 19TH ST NW',0,'CANTON','OH','44709','3802','CY','39151','1971-01-25','F','U',':RET:2106-3','N','021','HLT','3178764','52664OH151001305','2014-04-01','2014-02-28 14:41:28','122.00',NULL,NULL,'302.62','180.62','R-OH015','OH0','302.62',NULL,0,'2014-02-28 21:31:10'),(27325,21636,'Y','18','021','EC','A','','','AC','0000968631','0000968631','TX00003537804','31','1','Fojtik','Frank','','','','34','450117834','P.O.  Box 1436',0,'Brookshire','TX','77423',NULL,'CY','48473','1955-10-16','M','U',':RET:2106-3','N','021','DEN','3691028','33348TX002000201','2014-04-01','2014-03-04 16:34:44','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:48'),(27819,22002,'N','19','021','EC','A',NULL,NULL,'','0000878331','0000045837','','S1','1','Clark','Josh',NULL,NULL,NULL,NULL,NULL,'643 BLAIN LN',0,'GREENFIELD','OH','45123','9660','CY','39141','2003-07-23','F','',':RET:2106-3','N','021','DEN','3888152','99734OH005000301','2014-04-01','2014-03-04 19:19:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:31:55'),(1084,890,'Y','18','021','EC','A','','','AC','0000342698','0000342698','OH00000993178','IL','1','Thompson','Kimberly','','','','34','269547828','111 SHAFFER BLVD',0,'BRYAN','OH','43506','9184','CY','39171','1952-11-10','F','M',':RET:2106-3','N','021','DEN','480068','99734OH005000401','2014-01-01','2013-12-03 13:12:47','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 18:16:51'),(1496,1249,'Y','18','021','EC','A','','','AC','0001030376','0001030376','OH00000236031','IL','1','Nicholas','John','','','','34','277685018','252 Ohio Ave',0,'McDonald','OH','44437',NULL,'CY','39155','1959-07-13','M','U',NULL,'N','021','DEN','2219517','99734OH005000401','2014-01-01','2013-12-24 11:28:55','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:49:10'),(21178,16925,'Y','18','021','EC','A','','','AC','0000216138','0000216138','OH00001596746','IL','1','HEDGES','CONNIE','','','','34','273509683','3407 SHEARIN AVE',0,'LIMA','OH','45801',NULL,'CY','39003','1950-12-18','F','U',':RET:2106-3','N','021','DEN','2924711','99734OH005000401','2014-03-01','2014-02-03 16:59:21','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-03 21:00:41'),(2509,2044,'Y','18','021','EC','A','','','AC','0000780482','0000780482','OH00001082343','IL','1','Busack','Sarah','','','','34','278943666','109 Michael St. P.O. Box 388',0,'Bettsville','OH','44815',NULL,'CY','39147','1991-08-23','F','U',':RET:2106-3','N','021','HLT','201915','92036OH004002701','2014-01-01','2013-12-08 23:42:15','100.00',NULL,NULL,'156.79','56.79','R-OH006','OH0','156.79',NULL,0,'2013-12-25 19:36:14'),(19362,15433,'Y','18','024','14','A','','','TE','0000448800','0000448800','','IL','1','Caughey','Shawn',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-06-26','M','',NULL,NULL,NULL,'','2554935','','2014-01-21','2014-01-21 06:51:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:31'),(18662,14877,'N','01','021','EC','A',NULL,NULL,'','0001097877','0000136632','','IL','1','TRAN','HOANG','','','','34','640561597','2702 PARK RIDGE DR',0,'MARBLE FALLS','TX','78654','4030','CY','48053','1976-05-09','M','',':RET:2047-9','T','021','DEN','1673360','33348TX002000201','2014-03-01','2014-01-16 14:55:26',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-17 03:35:14'),(7065,5611,'N','19','021','EC','A',NULL,NULL,'','0000816435','0000652132','','IL','1','Yang','Connie','','','','34','288042878','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1999-11-08','F','',':RET:2034-7','N','021','DEN','2566021','99734OH005000301','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:01'),(9422,7475,'Y','18','021','EC','A','','','AC','0001094038','0001094038','TX00000846985','IL','1','Drapala','Christopher','','','','34','525634125','1350 BANDERA HWY',0,'KERRVILLE','TX','78028','8040','CY','48265','1972-10-18','M','U',':RET:2106-3','N','021','DEN','2002716','33348TX002000201','2014-01-01','2013-12-21 15:41:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:33:08'),(14148,11277,'Y','18','024','14','A','','','TE','0001617692','0001617692','','IL','1','Murphy','Sean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-10','M','',NULL,NULL,NULL,'','2187093','','2013-12-26','2013-12-26 12:53:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-27 02:02:49'),(16849,13479,'Y','18','021','EC','A','','','AC','0000806367','0000806367','OH00002366551','IL','1','Rinehart','Sandra','','','','34','283621533','251 CHESTNUT ST',0,'WADSWORTH','OH','44281','1717','CY','39103','1956-04-21','F','M',':RET:2106-3','T','021','HLT','2507129','52664OH152000901','2014-02-01','2014-01-11 12:11:10','208.00',NULL,NULL,'457.77','249.77','R-OH012','OH0','457.77',NULL,0,'2014-01-13 02:18:39'),(16580,13262,'Y','18','021','EC','A','','','AC','0001198464','0001198464','LA00002268280','IL','1','Eljaan','Mohammed','Fq','','','34','662071330','1506 Delplaza dr',0,'baton rouge','LA','70815',NULL,'CY','22033','1992-09-17','M','U',':RET:2106-3','N','021','DEN','1846828','18575LA002000201','2014-02-01','2014-01-06 19:34:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:23:57'),(23242,18529,'N','01','021','EC','A',NULL,NULL,'','0000351611','0000077609','','IL','1','Procaccini','Tiffany','','','','34','299801271','2240 S COUNTY ROAD 43',0,'REPUBLIC','OH','44867','9750','CY','39147','1979-10-22','F','',':RET:2106-3','N','021','HLT','3442061','92036OH005002701','2014-03-01','2014-02-12 16:27:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','236.72',NULL,0,'2014-02-12 21:32:32'),(28208,22321,'Y','18','021','EC','A','','','AC','0001083509','0001083509','MS00002658605','IL','1','MANNING','NORSHA','','','','34','426370272','258 BONNER STREET',0,'HOLLY SPRINGS','MS','38635',NULL,'CY','28093','1976-01-10','F','M',NULL,'N','021','DEN','3154559','46300MS002000101','2014-04-01','2014-03-06 12:37:29','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15','CIC',0,'2014-03-06 21:30:12'),(131,114,'Y','18','021','EC','A','','','AC','0000502954','0000502954','OH00000434065','IL','1','lindenau','raymond','','','','34','274547708','434 ROCKY HOLLOW DR',0,'MEDINA','OH','44256','7356','CY','39103','1954-02-04','M','M',NULL,'N','021','HLT','56886','52664OH152000901','2014-01-01','2013-12-04 19:07:53','595.00',NULL,NULL,'773.91','178.91','R-OH012','OH0','425.18',NULL,0,'2013-12-25 17:18:29'),(22434,17913,'Y','18','021','EC','A','','','AC','0000832969','0000832969','TX00001645740','IL','1','Reyes','Raul','','','','34','464419317','412 BRISTOL',0,'SAN ANTONIO','TX','78214','2128','CY','48029','1966-12-22','M','M',NULL,'N','021','DEN','3564023','33348TX002000201','2014-03-01','2014-02-10 08:56:45','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-02-10 21:30:38'),(22276,17781,'Y','18','021','EC','A','','','AC','0000162846','0000162846','TX00001919449','IL','1','Garcia','adan','','','','34','451438283','6213 TWILIGHT LN',0,'EL PASO','TX','79912','3825','CY','48141','1978-04-07','M','U',':RET:2106-3','N','021','DEN','2375477','33348TX002000201','2014-03-01','2014-01-22 20:19:12','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-10 11:00:17'),(22114,17651,'Y','18','021','EC','A','','','AC','0000880183','0000880183','TX00002269040','IL','1','Massa','Neomarie','','','','34','582971684','11911 Northwest Freeway',0,'Houston','TX','77092',NULL,'CY','48201','1984-04-11','F','U',NULL,'N','021','DEN','3232962','33348TX002000101','2014-03-01','2014-02-07 20:55:35','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-08 19:00:36'),(19007,15137,'Y','18','021','EC','A','','','AC','0001370246','0001370246','LA00001682911','IL','1','simon','charlavell','','','','34','434239668','1618 Pitre St',0,'Ville Platte','LA','70586',NULL,'CY','22039','1974-06-15','F','U',':RET:2054-5','T','021','DEN','2834887','18575LA002000201','2014-03-01','2014-01-17 01:04:01','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-20 08:06:18'),(18938,15091,'Y','18','021','EC','A','','','AC','0001060937','0001060937','OH00002037233','IL','1','post','gary','','','','34','404767264','4823 PARKSIDE DR',0,'SOUTH LEBANON','OH','45065','1383','CY','39165','1953-04-17','M','M',NULL,'N','021','DEN','2692844','99734OH005000401','2014-03-01','2014-01-17 12:19:01','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:05:42'),(16503,13203,'Y','18','021','EC','A','','','AC','0000891823','0000891823','OH00002262106','IL','1','mandato','michael','','','','34','295824315','2697 US HIGHWAY 224 E',0,'GREENWICH','OH','44837','9553','CY','39077','1974-04-08','M','M',':RET:2106-3','T','021','HLT','2181317','92036OH002002701','2014-02-01','2014-01-06 14:49:07','0.00',NULL,NULL,'637.04','637.04','R-OH006','OH0','326.81',NULL,0,'2014-01-07 04:06:55'),(8887,7046,'Y','18','021','EC','A','','','AC','0000200241','0000200241','TX00000447444','IL','1','Jordan','Ronald','','','','34','489528761','6134 LOS FELINOS CIR',0,'EL PASO','TX','79912','1930','CY','48141','1955-11-11','M','U',':RET:2106-3','N','021','DEN','2189058','33348TX002000201','2014-01-01','2013-12-18 16:40:13','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:01:55'),(936,774,'Y','18','021','EC','A','','','AC','0000858455','0000858455','OH00000791362','IL','1','Eicher','Jon','','','','34','283860450','7533 Sharrington Drive',0,'Columbus','OH','43235',NULL,'CY','39049','1980-11-24','M','U',':RET:2106-3','N','021','DEN','243049','99734OH005000401','2014-01-01','2013-10-31 11:37:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:09:11'),(9727,7704,'Y','18','021','EC','A','','','AC','0000855599','0000855599','OH00000358962','IL','1','Stephens','Jerry','','','','34','464084495','10810 WESTLEY CHAPEL RD',0,'CROTON','OH','43013','9724','CY','39089','1954-11-04','M','M',NULL,'N','021','DEN','105179','99734OH005000301','2014-01-01','2013-11-15 06:45:16','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:45:36'),(3158,2540,'Y','18','021','EC','A','','','AC','0000850465','0000850465','OH00000793885','IL','1','Brackmann','Mary','','','','34','278843982','926 Harris Ave',0,'Cincinnati','OH','45205',NULL,'CY','39061','1983-06-03','F','U',':RET:2106-3','N','021','DEN','1148649','99734OH005000401','2014-01-01','2013-11-18 00:20:46','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:13'),(1765,1457,'N','01','021','EC','A',NULL,NULL,'','0001131448','0000431378','','IL','1','Napier','Christina','Amanda','','','34','280807440','7306 BANNERWOOD DR',0,'WEST CHESTER','OH','45069','1073','CY','39017','1983-04-17','F','',':RET:2106-3','N','021','DEN','2193584','99734OH005000301','2014-01-01','2013-12-24 13:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:00'),(6043,4786,'Y','18','024','14','A','','','TE','0001239086','0001239086','','IL','1','DENSON','KIRBY',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-25','M','',NULL,NULL,NULL,'','392597','','2013-12-01','2013-12-01 11:54:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:01:27'),(5097,4040,'Y','18','024','14','A','','','TE','0000361689','0000361689','','IL','1','Betty','Jeffrey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-02-24','M','',NULL,NULL,NULL,'','234756','','2013-12-19','2013-12-19 16:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 23:01:22'),(1599,1337,'Y','18','021','EC','A','','','AC','0001033922','0001033922','TX00000711479','IL','1','ARICEAGA','LUSSY','','','','34','627260919','1925 VICTORIA DR',0,'BROWNSVILLE','TX','78521','7741','CY','48061','1991-09-13','F','U',NULL,'N','021','DEN','1436816','33348TX002000201','2014-01-01','2013-12-24 12:32:06','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:52:00'),(6033,4777,'Y','18','021','EC','A','','','AC','0000848222','0000848222','TX00000187760','IL','1','Davis','William','','','','34','463755573','904 N 20TH ST',0,'CORSICANA','TX','75110','3727','CY','48349','1979-12-14','M','U',':RET:2106-3','N','021','DEN','18526','33348TX002000201','2014-01-01','2013-12-01 11:35:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:01:11'),(27524,21775,'Y','18','021','EC','A','','','AC','0000561737','0000561737','OH00003557525','IL','1','Chapin','Theresa','','','','34','279665544','3529 KINGSTON LN',0,'YOUNGSTOWN','OH','44511','1159','CY','39099','1958-02-21','F','M',':RET:2106-3','T','021','HLT','3332507','92036OH005003201','2014-04-01','2014-03-04 14:35:53','208.00',NULL,NULL,'649.40','441.40','R-OH013','OH0','649.40',NULL,0,'2014-03-04 21:02:42'),(2287,1864,'Y','18','021','EC','A','','','AC','0000785765','0000785765','OH00000369040','IL','1','Davis','Roberta','','','','34','268508183','15853 JOHNSON RD',0,'LISBON','OH','44432','8627','CY','39029','1949-06-11','F','U',NULL,'N','021','DEN','1204424','99734OH005000301','2014-01-01','2013-12-09 14:03:55','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:30:41'),(13839,11044,'Y','18','021','EC','A','','','AC','0000124207','0000124207','OH00000703831','IL','1','First','Jeffrey',NULL,NULL,NULL,NULL,NULL,'1453 STONINGTON RD NW',0,'NORTH CANTON','OH','44720','6065','CY','39151','1950-07-04','M','R',':RET:2106-3','N','021','HLT','1413981','52664OH152000901','2014-01-01','2013-12-23 13:11:29','0.00',NULL,NULL,'1021.85','1021.85','R-OH015','OH0','482.18',NULL,0,'2013-12-26 13:12:17'),(14263,11377,'Y','18','021','EC','A','','','AC','0000728715','0000728715','OH00001524840','IL','1','Kirkland','Toni','','','','34','293666648','905 S 9TH ST',0,'HAMILTON','OH','45011','3801','CY','39017','1967-08-01','F','U',':RET:2054-5','T','021','HLT','1692344','92036OH004001201','2014-02-01','2013-12-26 07:54:14','51.00',NULL,NULL,'297.75','246.75','R-OH004','OH0','297.75',NULL,0,'2013-12-27 02:05:52'),(20807,16626,'Y','18','021','EC','A','','','AC','0000986088','0000986088','TX00001833558','IL','1','Sherman','Ariel','','','','34','454494992','10755 Meadowchase Lane',0,'Houston','TX','77042',NULL,'CY','48201','1979-08-15','M','U',':RET:2054-5','N','021','DEN','3141885','33348TX002000201','2014-03-01','2014-01-31 16:17:58','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-31 21:00:25'),(15061,12039,'Y','18','021','EC','A','','','AC','0001673954','0001673954','LA00001853432','31','1','Williams','Sandra','','','','34','438270603','PO box 436',0,'Grand Coteau','LA','70541',NULL,'CY','22097','1966-01-22','F','M',':RET:2054-5','N','021','DEN','1840871','18575LA002000201','2014-02-01','2013-12-30 15:14:07','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-01 12:03:34'),(15674,12538,'Y','18','021','EC','A','','','AC','0000516919','0000516919','OH00001711295','IL','1','Gentry','Lana','','','','34','236842798','3490 STATE ROUTE 99',0,'MONROEVILLE','OH','44847','9723','CY','39077','1950-10-30','F','M',':RET:2106-3','N','021','HLT','2069830','92036OH004002701','2014-02-01','2013-12-31 10:04:10','353.00',NULL,NULL,'462.84','109.84','R-OH006','OH0','462.84',NULL,1,'2014-01-02 04:34:47'),(19048,15171,'Y','18','021','EC','A','','','AC','0002025396','0002025396','LA00001693852','IL','1','Rawls','Riciarda','','','','34','249672496','3622 Johnson St.',0,'Metairie','LA','70001',NULL,'CY','22051','1971-12-22','F','U',':RET:2054-5','N','021','DEN','1626500','18575LA002000101','2014-03-01','2014-01-16 20:01:21','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-20 08:06:42'),(23700,18872,'N','19','021','EC','A',NULL,NULL,'','0000616874','0000705200','','IL','1','MCCARTHY','NOAH','','','','34','289021075','3386 PALMHILL LN',0,'CINCINNATI','OH','45239','7162','CY','39061','1997-10-23','M','',NULL,'N','021','DEN','3576493','99734OH005000401','2014-03-01','2014-02-14 11:43:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:42'),(23728,18891,'N','01','021','EC','A',NULL,NULL,'','0000153141','0000019026','','IL','1','Bhatia','Anupam','','','','34','592447785','16226 BREAKWATER PATH DR',0,'HOUSTON','TX','77044','1112','CY','48201','1958-12-07','M','',':RET:2028-9','N','021','DEN','3570852','33348TX002000101','2014-03-01','2014-02-14 16:49:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-14 21:30:56'),(24131,19179,'N','01','021','EC','A',NULL,NULL,'','0002157211','0002376407','','IL','1','Strohmeyer','Yvette','Roszkowski','','','34','435021969','110 EVANGELINE LN',0,'DESTREHAN','LA','70047','3045','CY','22089','1968-12-30','F','',':RET:2106-3','N','021','DEN','2932534','18575LA002000101','2014-03-01','2014-02-15 14:42:54',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-15 22:01:47'),(24950,19785,'Y','18','021','EC','A','','','AC','0001802285','0001802285','LA00001976654','IL','1','GONZALEZ','ELSA','','','','34','662229226','4212 CHATEAU BLVD',0,'KENNER','LA','70065','1986','CY','22051','1979-05-25','F','M',NULL,'N','021','DEN','3820865','18575LA002000201','2014-04-01','2014-02-19 23:43:40','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-20 22:00:11'),(2492,2030,'Y','18','021','EC','A','','','AC','0001028649','0001028649','LA00000683260','IL','1','bruneau','thomas','','','','34','047767173','3720 DAUTERIVE DR',0,'CHALMETTE','LA','70043','1404','CY','22087','1968-05-08','M','U',':RET:2106-3','N','021','DEN','1238470','18575LA002000201','2014-01-01','2013-12-09 16:33:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:35:49'),(14639,11683,'Y','18','021','EC','A','','','AC','0000782853','0000782853','TX00001697284','IL','1','Mwaniki','Michelle','','','','34','531558003','4300 horizon north parkway',0,'Dallas','TX','75287',NULL,'CY','48113','1987-10-15','F','U',':RET:2054-5','N','021','DEN','1405608','33348TX002000101','2014-02-01','2013-12-28 08:28:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2013-12-29 11:07:23'),(21029,16802,'N','01','021','EC','A',NULL,NULL,'','0000878298','0000354008','','IL','1','CHAPPELL-DICK','WENDY','','','','34','294727822','207 N. LAWN AVE',0,'BLUFFTON','OH','45817',NULL,'CY','39003','1969-10-26','F','',':RET:2106-3','N','021','HLT','3031528','92036OH006001501','2014-03-01','2014-01-31 23:04:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','243.84',NULL,0,'2014-02-01 19:00:43'),(23508,18726,'Y','18','021','EC','A','','','AC','0000412921','0000412921','TX00001864255','IL','1','KASHANI','MINA','','','','34','495603617','200 BARSANA AVE',0,'AUSTIN','TX','78737','9081','CY','48209','1951-02-05','F','U',NULL,'N','021','DEN','2935857','33348TX002000101','2014-03-01','2014-02-13 16:05:38','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-13 22:02:12'),(19003,15134,'N','19','021','EC','A',NULL,NULL,'','0001640013','0002106179','','IL','1','Francios','Brittani','','','','34','435739508','217 W GATEHOUSE DR',0,'METAIRIE','LA','70001','2070','CY','22051','1988-07-28','F','',NULL,'N','021','DEN','1639262','18575LA002000201','2014-03-01','2014-01-17 11:55:35',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-20 08:06:17'),(17545,14027,'N','19','021','EC','A',NULL,NULL,'','0000584291','0001006843','','IL','1','Rebrisorean','Bianca','Lavinia','','','34','288085856','2115 REDWOOD PL',0,'CANFIELD','OH','44406','8463','CY','39099','1992-03-08','F','',':RET:2106-3','N','021','HLT','1466827','92036OH005003205','2014-02-01','2014-01-12 12:52:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','242.05',NULL,0,'2014-01-13 03:01:51'),(16629,13303,'Y','18','021','EC','A','','','AC','0000801278','0000801278','OH00000494033','IL','1','Buchenau','Brandi','','','','34','295861168','3880 MAGNOLIA DR',0,'AMELIA','OH','45102','1057','CY','39025','1981-01-31','F','U',':RET:2106-3','T','021','DEN','1555650','99734OH005000401','2014-02-01','2014-01-06 20:42:11','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-08 18:24:14'),(16178,12953,'Y','18','021','EC','A','','','AC','0002215765','0002215765','LA00001800498','IL','1','Lee','John','','','','34','439275278','13344 N LARUSSA LN',0,'INDEPENDENCE','LA','70443','4230','CY','22105','1974-11-23','M','U',NULL,'N','021','DEN','1684106','18575LA002000201','2014-02-01','2014-01-04 17:00:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-05 00:00:27'),(5271,4179,'N','19','021','EC','A',NULL,NULL,'','0000696804','0000814276','','S1','1','Vaccaro','Raphael','M',NULL,NULL,NULL,NULL,'2389 LANCASTER RD',0,'AKRON','OH','44313','4569','CY','39153','2002-06-15','F','',':RET:2106-3','N','021','HLT','2522921','52664OH151001306','2014-01-01','2013-12-19 12:40:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 23:05:33'),(15625,12498,'Y','18','021','EC','A','','','AC','0001636336','0001636336','LA00001751827','IL','1','Gaspard','Elizabeth','','','','34','439359511','43498 WILLIE YOUNGBLOOD RD',0,'FRANKLINTON','LA','70438','5281','CY','22117','1963-11-16','F','M',':RET:2106-3','T','021','DEN','1627487','18575LA002000101','2014-02-01','2013-12-30 20:22:35','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-02 04:33:18'),(14170,11297,'Y','18','021','EC','A','','','AC','0001705649','0001705649','LA00000495340','IL','1','Dison','Darin','','','','34','435672838','3001 Lakewood Dr',0,'Violet','LA','70092',NULL,'CY','22087','1978-03-27','M','M',':RET:2054-5','N','021','DEN','1578683','18575LA002000201','2014-02-01','2013-12-26 17:48:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:25'),(22595,18047,'N','01','021','EC','A',NULL,NULL,'','0000794546','0000983882','','IL','1','Spencer','Cherry','Dignos','','','34','292154392','2658 Chenango Rd.',0,'Wakeman','OH','44889',NULL,'CY','39077','1987-10-24','F','',':RET:2036-2','N','021','HLT','3235478','92036OH002002701','2014-03-01','2014-02-10 12:28:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','230.59',NULL,0,'2014-02-10 21:32:12'),(23799,18937,'Y','18','021','EC','A','','','AC','0000662740','0000662740','OH00002703112','IL','1','Safran','Neil','','','','34','292425150','10489 Kerwick Court',0,'Reminderville','OH','44202',NULL,'CY','39153','1961-06-05','M','M',':RET:2106-3','N','021','HLT','2977643','52664OH151001304','2014-03-01','2014-02-14 13:19:53','274.52',NULL,NULL,'435.31','160.79','R-OH012','OH0','435.31',NULL,0,'2014-02-14 21:31:28'),(26006,20625,'Y','18','021','EC','A','','','AC','0002202417','0002202417','LA00002762651','31','1','Wilson','Beulah','','','','34','438909505','PO Box 513',0,'Mansfield','LA','71052',NULL,'CY','22031','1950-11-14','F','U',':RET:2054-5','T','021','DEN','3781794','18575LA002000101','2014-04-01','2014-02-26 17:10:44','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-02-26 21:02:06'),(449,369,'Y','18','021','EC','A','','','AC','0000844684','0000844684','OH00000435402','IL','1','Kowalczyk','Szymon','','','','34','302926505','2437 EATON RD',0,'UNIVERSITY HEIGHTS','OH','44118','4336','CY','39035','1980-05-22','M','U',':RET:2106-3','N','021','DEN','106698','99734OH005000401','2014-01-01','2013-12-04 17:50:34','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:47:22'),(7349,5819,'Y','18','021','EC','A','','','AC','0000614070','0000614070','OH00000436757','IL','1','Edwards','Gavin','','','','34','331724879','5824 ROAN RD',0,'SYLVANIA','OH','43560','1523','CY','39095','1982-12-02','M','U',':RET:2106-3','T','021','HLT','31013','92036OH005002606','2014-01-01','2013-11-22 18:24:06','192.00',NULL,NULL,'259.90','67.90','R-OH001','OH0','259.90',NULL,0,'2013-12-26 02:15:03'),(3298,2657,'N','19','021','EC','A',NULL,NULL,'','0000524487','0000055915','','S1','1','Murphy','Patrick','Charles',NULL,NULL,NULL,NULL,'255 GUILFORD BLVD',0,'MEDINA','OH','44256','2134','CY','39103','2003-03-27','M','',':RET:2106-3','N','021','DEN','1471448','99734OH005000301','2014-01-01','2013-12-22 12:30:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:40'),(15959,12774,'N','19','021','EC','A',NULL,NULL,'','0000608468','0000682160','','IL','1','HERNANDEZ','ALEJANDRO','','','','34','268112269','9693 ADAIR CT',0,'CINCINNATI','OH','45251','2109','CY','39061','2004-08-05','M','',':RET:2106-3','N','021','DEN','2183743','99734OH005000301','2014-02-01','2014-01-03 13:23:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:17'),(25336,20102,'N','01','021','EC','A',NULL,NULL,'','0001473935','0001620086','','IL','1','Jackson','Robert','','','','34','435552777','2040 Expressway Dr. Apt.105',0,'Pineville','LA','71360',NULL,'CY','22079','1977-10-08','M','',':RET:2054-5','N','021','DEN','2845622','18575LA002000201','2014-04-01','2014-02-25 14:54:12',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-25 21:30:22'),(27960,22120,'Y','18','021','EC','A','','','AC','0001297409','0001297409','LA00003205003','IL','1','Lam','Thao','Thi','','','34','610236708','416 windward dr',0,'houma','LA','70360',NULL,'CY','22109','1967-03-10','F','M',':RET:2047-9','N','021','DEN','3122759','18575LA002000201','2014-04-01','2014-03-05 20:19:31','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-03-06 21:00:44'),(991,811,'Y','18','021','EC','A','','','AC','0001100562','0001100562','OH00000536135','IL','1','debord','dawn','','','','34','301605993','724 UNION RD',0,'FRANKLIN','OH','45005','2568','CY','39165','1976-09-07','F','U',':RET:2106-3','N','021','DEN','551695','99734OH005000401','2014-01-01','2013-11-11 11:21:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:10:37'),(20513,16390,'Y','18','021','EC','A','','','AC','0000255990','0000255990','OH00001379392','IL','1','Monnin','Daniel','','','','34','278683593','528 SHROYER RD',0,'DAYTON','OH','45419','4049','CY','39113','1958-08-20','M','U',':RET:2106-3','N','021','HLT','3205257','92036OH006000501','2014-03-01','2014-01-28 21:12:30','0.00',NULL,NULL,'420.39','420.39','R-OH003','OH0','420.39',NULL,0,'2014-01-29 21:01:20'),(20437,16324,'Y','18','024','14','A','','','TE','0000683397','0000683397','','IL','1','JONES','VANESSA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-06-24','F','',NULL,NULL,NULL,'','2067036','','2014-01-29','2014-01-29 17:18:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:38'),(19615,15634,'Y','18','021','EC','A','','','AC','0000795553','0000795553','OH00001750166','IL','1','jordan','dwayne','a','','','34','278904910','9915 north blvd',0,'cleveland','OH','44108',NULL,'CY','39035','1989-01-28','M','R',':RET:2054-5','N','021','HLT','3164691','52664OH152001001','2014-03-01','2014-01-21 18:30:58','0.00',NULL,NULL,'138.84','138.84','R-OH011','OH0','138.84',NULL,0,'2014-01-23 03:02:52'),(18196,14526,'Y','18','024','14','A','','','TE','0000930926','0000930926','','IL','1','bardes','eric',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-07-01','M','',NULL,NULL,NULL,'','1625072','','2014-01-14','2014-01-14 17:15:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-15 02:08:05'),(6050,4792,'Y','18','021','EC','A','','','AC','0001151047','0001151047','OH00000438278','IL','1','vardhan','aniket','','','','34','112887092','1636 RICHMOND AVE',0,'COLUMBUS','OH','43203','1728','CY','39049','1974-09-25','M','U',':RET:2029-7','N','021','DEN','159839','99734OH005000401','2014-01-01','2013-12-01 16:25:05','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 00:01:39'),(4829,3826,'Y','18','021','EC','A','','','AC','0001255006','0001255006','OH00000045187','IL','1','Trokan','Peter','','','','34','393948788','5375 SULTANA DR',0,'CINCINNATI','OH','45238','5225','CY','39061','1984-05-08','M','U',':RET:2106-3','T','021','HLT','967065','92036OH005001205','2014-01-01','2013-12-08 15:04:23','122.00',NULL,NULL,'276.24','154.24','R-OH004','OH0','276.24',NULL,0,'2013-12-25 22:17:18'),(23745,18906,'Y','18','021','EC','A','','','AC','0000137619','0000137619','OH00002445687','IL','1','MIDAMBA','FATUMA','','','','34','291967056','3909 PINE CREST DRIVE',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','1963-12-12','F','U',':RET:2054-5','N','021','DEN','2972052','99734OH005000301','2014-03-01','2014-02-14 05:10:01','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-14 21:31:05'),(24479,19447,'Y','18','021','EC','A','','','AC','0000968256','0000968256','OH00002939686','IL','1','Woods','Caleb','','','','34','315881716','1723 MEADOWHILL CT',0,'TOLEDO','OH','43614','1837','CY','39095','1981-05-02','M','M',':RET:2106-3','N','021','HLT','3043314','92036OH001002601','2014-04-01','2014-02-18 14:03:12','62.00',NULL,NULL,'545.23','483.23','R-OH001','OH0','278.26',NULL,0,'2014-02-18 22:01:44'),(25990,20611,'Y','18','021','EC','A','','','AC','0001210869','0001210869','MS00002887483','IL','1','Tullos','Angela','D','','','34','428494747','421 THOMASVILLE RD',0,'FLORENCE','MS','39073','9696','CY','28121','1975-12-29','F','M',':RET:2106-3','N','021','DEN','3155533','46300MS002000201','2014-04-01','2014-02-26 13:35:37','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-26 21:01:56'),(27434,21712,'Y','18','021','EC','A','','','AC','0001183223','0001183223','LA00003146801','IL','1','CASILDO','JOSUE','','','','34','664125239','1501 NEWTON ST',0,'GRANDA','LA','70053',NULL,'CY','22051','1985-03-21','M','M',NULL,'N','021','DEN','3791736','18575LA002000201','2014-04-01','2014-03-04 13:27:35','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-04 21:01:48'),(28756,22760,'Y','18','021','EC','A','','','AC','0001013279','0001013279','TX00003566560','IL','1','Clifton','Lauren','','','','34','465395878','6627 OAKLAND HILLS DR',0,'HOUSTON','TX','77069','1721','CY','48201','1977-01-07','F','U',':RET:2106-3','N','021','DEN','3814135','33348TX002000201','2014-04-01','2014-03-09 11:08:29','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-09 21:00:19'),(687,565,'Y','18','021','EC','A','','','AC','0000008403','0000008403','OH00000030061','IL','1','Butcher','Emily','','','','34','277885292','9796 WHEATFIELD LN',0,'CONCORD TOWNSHIP','OH','44060','6643','CY','39085','1987-07-28','F','U',':RET:2106-3','N','021','DEN','1385661','99734OH005000301','2014-01-01','2013-12-16 12:47:42','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:02:32'),(2602,2114,'Y','18','021','EC','A','','','AC','0000448737','0000448737','OH00000220503','IL','1','McConnaughy','Lydia','','','','34','289159660','1123 Howard Street',0,'Bridgeport','OH','43912',NULL,'CY','39013','2009-12-08','F','U',':RET:2106-3','N','021','DEN','424247','99734OH005000401','2014-01-01','2013-12-01 21:32:00','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','15.78',NULL,0,'2013-12-25 19:45:23'),(18962,15108,'Y','18','021','EC','A','','','AC','0000388056','0000388056','TX00002039987','IL','1','Pham','Niem','','','','34','640263597','3904 SAN RAMON DR',0,'ARLINGTON','TX','76013','5719','CY','48439','1953-04-11','M','U',':RET:2047-9','N','021','DEN','1890668','33348TX002000201','2014-03-01','2014-01-17 12:29:19','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-20 08:05:55'),(6579,5216,'Y','18','021','EC','A','','','AC','0000955516','0000955516','OH00000374505','IL','1','HEPPARD','SANDRA','R','','','34','288728829','778 ROLLINGWOODS DR',0,'WEST UNION','OH','45693','9217','CY','39001','1962-12-03','F','U',NULL,'N','021','HLT','195277','92036OH005000605','2014-01-01','2013-12-11 08:50:51','345.00',NULL,NULL,'400.37','55.37','R-OH005','OH0','400.37',NULL,0,'2013-12-26 00:52:54'),(5979,4733,'N','19','021','EC','A',NULL,NULL,'','0000768881','0000865862','','IL','1','Chambers','Timothy','Joseph','','','34','280942963','5040 LEBANON RD',0,'SOUTH LEBANON','OH','45065','1418','CY','39165','1991-09-09','M','',':RET:2106-3','T','021','HLT','2185931','92036OH004001201','2014-01-01','2013-12-23 23:09:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','198.50',NULL,0,'2013-12-25 23:51:54'),(17468,13968,'N','01','021','EC','A',NULL,NULL,'','0000920829','0000032972','','IL','1','Tomcko','Ginny','Sue','','','34','275602364','135 Brandtson Ave.',0,'Elyria','OH','44035',NULL,'CY','39093','1957-06-19','F','',':RET:2106-3','N','021','DEN','2665109','99734OH005000301','2014-02-01','2014-01-12 14:05:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 03:01:07'),(16230,12997,'Y','18','024','14','A','','','TE','0000678102','0000678102','','IL','1','FERRELL','SHAUN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-05-18','M','',NULL,NULL,NULL,'','2337543','','2014-01-04','2014-01-04 08:35:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-05 00:02:01'),(13871,11067,'Y','18','021','EC','A','','','AC','0001144770','0001144770','OH00000564465','IL','1','Steinwand','Kathy','','','','34','277645382','1288 NESTOR AVE',0,'AKRON','OH','44314','1451','CY','39153','1956-09-07','F','M',':RET:2106-3','N','021','HLT','1745973','52664OH151001501','2014-01-01','2013-12-23 13:23:12','283.00',NULL,NULL,'651.81','368.81','R-OH012','OH0','651.81',NULL,0,'2013-12-26 13:13:03'),(13611,10853,'Y','18','021','EC','A','','','AC','0000645982','0000645982','OH00000376407','IL','1','Newland','Michael','','','','34','282585790','1 MARLOU DR',0,'HAMILTON','OH','45013','6036','CY','39017','1963-08-28','M','U',':RET:2106-3','N','021','HLT','1652294','92036OH002001201','2014-01-01','2013-12-23 11:05:50','189.00',NULL,NULL,'442.75','253.75','R-OH004','OH0','442.75',NULL,0,'2013-12-26 13:05:37'),(3679,2944,'Y','18','021','EC','A','','','AC','0000767382','0000767382','OH00000808905','IL','1','KIRK','GEORGE','RICHARD','','','34','285484735','1011 LEDRO ST',0,'SPRINGDALE','OH','45246','1804','CY','39061','1949-05-10','M','U',':RET:2106-3','N','021','DEN','494898','99734OH005000401','2014-01-01','2013-12-13 09:13:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:31:24'),(3714,2971,'N','01','021','EC','A',NULL,NULL,'','0001191319','0000985987','','IL','1','Bigham','Jessica','','','','34','222704212','2029 W CASE RD',0,'COLUMBUS','OH','43235','7526','CY','39049','1986-04-02','F','',NULL,'N','021','DEN','882696','99734OH005000401','2014-01-01','2013-12-13 14:38:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:16'),(4739,3755,'Y','18','021','EC','A','','','AC','0000940835','0000940835','OH00000435596','IL','1','Roe','Randy','','','','34','389781887','6325 Garden Rd.',0,'maumee','OH','43537',NULL,'CY','39095','1961-05-16','M','M',':RET:2106-3','T','021','HLT','549376','92036OH002002601','2014-01-01','2013-12-12 15:16:36','641.00',NULL,NULL,'986.27','345.27','R-OH001','OH0','505.49',NULL,0,'2013-12-25 22:09:24'),(4722,3743,'Y','18','021','EC','A','','','AC','0000021366','0000021366','OH00000953603','IL','1','Koosed','Lawrence','','','','34','273460024','24259 W RIVER RD',0,'PERRYSBURG','OH','43551','9476','CY','39173','1951-11-24','M','M',':RET:2106-3','N','021','HLT','299498','92036OH003002601','2014-01-01','2013-12-12 13:53:17','657.00',NULL,NULL,'1170.08','513.08','R-OH001','OH0','585.04',NULL,0,'2013-12-25 22:08:58'),(24354,19343,'Y','18','021','EC','A','','','AC','0001853959','0001853959','LA00002358904','31','1','NED','DONALD',NULL,NULL,NULL,NULL,NULL,'P.O BOX 383',0,'LAWTELL','LA','70550',NULL,'CY','22097','1979-04-03','M','U',':RET:2054-5','T','021','DEN','2940431','18575LA002000201','2014-04-01','2014-02-17 20:05:05','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-18 22:00:29'),(27910,22080,'Y','18','021','EC','A','','','AC','0000797183','0000797183','TX00003308696','IL','1','CASTILLO','EDUARDO','','','','34','463888200','1413  EAST  SAN CARLOS  ST.',0,'LAREDO','TX','78041',NULL,'CY','48479','1952-10-13','M','U',':RET:2106-3','N','021','DEN','3382300','33348TX002000201','2014-04-01','2014-03-05 19:47:26','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-03-06 21:00:14'),(27990,22147,'Y','18','021','EC','A','','','AC','0000426503','0000426503','OH00002839286','IL','1','DANG','CUONG','MANH','','','34','018706831','4573 EASTLANE DR',0,'BROOKLYN','OH','44144','2738','CY','39035','1973-12-10','M','M',':RET:2028-9','T','021','DEN','3942140','99734OH005000401','2014-04-01','2014-03-05 18:14:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:03'),(28195,22311,'Y','18','021','EC','A','','','AC','0000046038','0000046038','TX00003673200','IL','1','HERNANDEZ','MELISSA','','','','34','466068478','865 KIRKWOOD ST',0,'ABILENE','TX','79603','4957','CY','48441','1955-11-25','F','U',NULL,'N','021','DEN','3560085','33348TX002000201','2014-04-01','2014-03-05 22:43:42','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61','CIC',0,'2014-03-06 21:30:06'),(28231,22336,'Y','18','021','EC','A','','','AC','0000684875','0000684875','OH00003108861','IL','1','Smith','Kenneth','','','','34','292501799','3418 PLUMEY RD',0,'NORTHWOOD','OH','43619','1832','CY','39173','1951-03-20','M','U',':RET:2106-3','N','021','HLT','3814046','92036OH006002601','2014-04-01','2014-03-06 15:41:17','358.00',NULL,NULL,'456.50','98.50','R-OH001','OH0','456.50','CIC',0,'2014-03-06 21:30:23'),(3739,2990,'Y','18','021','EC','A','','','AC','0000286938','0000286938','TX00000886736','IL','1','Jones','Nikole','','','','34','601246748','13547 FM 2501',0,'Apple Springs','TX','75926',NULL,'CY','48455','1985-12-24','F','U',':RET:2054-5','N','021','DEN','1190753','33348TX002000201','2014-01-01','2013-12-13 12:35:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:32:49'),(13092,10438,'Y','18','021','EC','A','','','AC','0001068264','0001068264','OH00000654679','IL','1','Gettelfinger','Denise','','','','34','405901029','5259 LONDONDERRY DR',0,'SHARONVILLE','OH','45241','6010','CY','39061','1960-10-10','F','U',':RET:2106-3','N','021','DEN','1715277','99734OH005000401','2014-01-01','2013-12-23 11:39:50','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:51:54'),(14255,11369,'Y','18','021','EC','A','','','AC','0001462801','0001462801','LA00001501283','IL','1','Paggett','Brenda','','','','34','433027514','1882 Shady Grove Rd.',0,'Saline','LA','71070',NULL,'CY','22013','1955-08-21','F','U',':RET:2054-5','N','021','DEN','2136372','18575LA002000101','2014-02-01','2013-12-26 10:36:44','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-27 02:05:37'),(21523,17195,'N','01','021','EC','A',NULL,NULL,'','0000699308','0000295540','','IL','1','Alexander','Patricia','','','','34','268606519','2103 S.R. 132',0,'Goshen','OH','45122',NULL,'CY','39025','1969-11-16','F','',':RET:2106-3','N','021','HLT','2953966','92036OH006000601','2014-03-01','2014-02-05 15:47:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','237.84','CIC',0,'2014-02-05 21:00:08'),(16425,13142,'N','01','021','EC','A',NULL,NULL,'','0000991553','0000366290','','IL','1','Hendee','Anna','L','','','34','295465129','739 N. South Street',0,'Wilmington','OH','45177',NULL,'CY','39027','1949-02-02','F','',':RET:2106-3','N','021','HLT','1513464','92036OH003000606','2014-02-01','2014-01-06 13:19:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','672.53',NULL,0,'2014-01-07 04:04:36'),(21083,16847,'N','01','021','EC','A',NULL,NULL,'','0000394963','0000387321','','IL','1','Klaas','Cheryl','Ann','','','34','300480285','301 E Columbus St',0,'West Liberty','OH','43357',NULL,'CY','39091','1954-09-07','F','',':RET:2106-3','N','021','DEN','3403388','99734OH005000301','2014-03-01','2014-02-02 00:09:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-02 19:00:23'),(16586,13267,'Y','18','021','EC','A','','','AC','0001843850','0001843850','LA00001961316','IL','1','Meekins','Savanna','','','','34','177721028','4735 LOYOLA AVE',0,'NEW ORLEANS','LA','70115','5931','CY','22071','1986-04-15','F','M',':RET:2106-3','N','021','DEN','2174909','18575LA002000201','2014-02-01','2014-01-07 16:05:28','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:23:59'),(16967,13581,'Y','18','021','EC','A','','','AC','0000349279','0000349279','OH00001450017','IL','1','Herbert','carla','J','','','34','278522526','1266 CANYON ST NE',0,'UNIONTOWN','OH','44685','8510','CY','39151','1961-11-14','F','U',':RET:2106-3','N','021','HLT','1572772','52664OH151001305','2014-02-01','2014-01-09 15:43:01','261.00',NULL,NULL,'435.31','174.31','R-OH015','OH0','435.31',NULL,0,'2014-01-13 02:20:11'),(19131,15243,'Y','18','021','EC','A','','','AC','0001804538','0001804538','LA00002355810','IL','1','DANIELS','James','','','','34','436832865','705 S BAY ST',0,'AMITE','LA','70422','3507','CY','22105','1991-12-03','M','U',':RET:2054-5','N','021','DEN','1755795','18575LA002000201','2014-03-01','2014-01-19 14:07:02','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-21 08:45:23'),(15658,12527,'N','01','021','EC','A',NULL,NULL,'','0001217382','0001046846','','IL','1','Wright','Stephanie','','','','34','293900895','501 W Main St',0,'Cairo','OH','45820',NULL,'CY','39003','1985-10-24','F','',':RET:2106-3','N','021','HLT','2473082','92036OH005001506','2014-02-01','2013-12-31 15:49:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','239.24',NULL,1,'2014-01-02 04:34:21'),(13088,10435,'Y','18','021','EC','A','','','AC','0000556719','0000556719','OH00000546858','IL','1','Leighton','Richard','','','','34','279429339','8246 WOOSTER PIKE',0,'CINCINNATI','OH','45227','4010','CY','39061','1955-04-23','M','M',':RET:2106-3','N','021','DEN','1498868','99734OH005000401','2014-01-01','2013-12-23 11:24:57','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:51:48'),(3240,2610,'Y','18','021','EC','A','','','AC','0000291791','0000291791','TX00000144365','IL','1','STEERS','TERRI','ANN','','','34','455111784','281 FM 2570',0,'FAIRFIELD','TX','75840',NULL,'CY','48161','1954-09-17','F','U',NULL,'N','021','DEN','757020','33348TX002000101','2014-01-01','2013-10-06 10:49:13','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 20:46:18'),(1897,1552,'Y','18','021','EC','A','','','AC','0001152195','0001152195','OH00001156539','31','1','Murray','Heather','','','','34','282788441','PO Box 5',0,'Willard','OH','44890',NULL,'CY','39077','1976-02-19','F','M',':RET:2106-3','N','021','HLT','2177030','92036OH004002701','2014-01-01','2013-12-24 16:08:26','329.00',NULL,NULL,'385.70','56.70','R-OH006','OH0','194.11',NULL,0,'2013-12-25 18:59:02'),(2936,2363,'Y','18','021','EC','A','','','AC','0000906587','0000906587','OH00001197688','IL','1','Marshall','Barbara','','','','34','282506868','2760 WENTWORTH AVE',0,'DAYTON','OH','45406','1640','CY','39113','1950-10-26','F','M',':RET:2106-3','N','021','DEN','967024','99734OH005000401','2014-01-01','2013-12-05 22:44:54','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 20:16:06'),(5971,4727,'Y','18','021','EC','A','','','AC','0001021232','0001021232','MS00001161654','IL','1','Atkinson','Betty','','','','34','427211490','204 E WHEELER ST',0,'OKOLONA','MS','38860','1205','CY','28017','1962-03-09','F','U',':RET:2054-5','N','021','DEN','2244325','46300MS002000101','2014-01-01','2013-12-23 23:41:31','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 23:51:37'),(24868,19718,'Y','18','021','EC','A','','','AC','0000834505','0000834505','OH00002964806','IL','1','THOMPSON','MICHAEL','','','','34','301563679','3252 VINTON PARK PL',0,'HILLIARD','OH','43026','7183','CY','39049','1954-11-14','M','M',NULL,'N','021','DEN','2975534','99734OH005000401','2014-03-01','2014-02-19 08:42:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00','CIC',0,'2014-02-20 05:32:37'),(28849,22829,'Y','18','021','EC','A','','','AC','0000666829','0000666829','OH00003371385','IL','1','gray','carnell','','','Jr','34','290864009','1428 FREEMAN ST',0,'TOLEDO','OH','43606','4535','CY','39095','1970-12-13','M','U',':RET:2054-5','T','021','HLT','4199311','92036OH003002601','2014-04-01','2014-03-09 15:04:10','24.00',NULL,NULL,'317.78','293.78','R-OH001','OH0','317.78',NULL,0,'2014-03-09 21:01:17'),(118,102,'N','19','021','EC','A',NULL,NULL,'','0000745350','0001182291','','IL','1','KERVIN','DIAMOND','','','','34','260776073','10865 COLONIAL HEIGHTS LANE',0,'FORT WORTH','TX','76179',NULL,'CY','48439','1990-12-23','F','',NULL,'N','021','DEN','117708','33348TX002000201','2014-01-01','2013-12-05 15:21:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 17:18:07'),(3357,2690,'N','01','021','EC','A',NULL,NULL,'','0000997711','0000436799','','IL','1','Harless','Amy','','','','34','464754506','623 MITCHELL ST',0,'WINNSBORO','TX','75494','2081','CY','48159','1984-02-13','F','',':RET:2106-3','T','021','DEN','1649594','33348TX002000201','2014-01-01','2013-12-22 12:10:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 21:16:53'),(22481,17948,'Y','18','021','EC','A','','','AC','0000948460','0000948460','OH00002652777','31','1','Taylor','Michael','','','','34','298767171','2830 NORWOOD AVE',0,'NORWOOD','OH','45212','2416','CY','39061','1977-10-17','M','U',':RET:2106-3','N','021','DEN','3219871','99734OH005000301','2014-03-01','2014-02-09 20:42:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:02'),(21403,17105,'Y','18','021','EC','A','','','AC','0000298268','0000298268','OH00001834683','IL','1','Weaver','Michelle','','','','34','279821884','1330 Hanover Rd.',0,'Delaware','OH','43015',NULL,'CY','39041','1984-04-12','F','U',NULL,'N','021','DEN','2734026','99734OH005000401','2014-03-01','2014-02-04 13:44:49','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-04 21:01:03'),(20632,16487,'Y','18','021','EC','A','','','AC','0000956495','0000956495','TX00001353587','IL','1','Jackson','Candice','','','','34','456990499','4695 TAFT ST',0,'BEAUMONT','TX','77706','7454','CY','48245','1984-02-04','F','U',':RET:2054-5','N','021','DEN','3294996','33348TX002000201','2014-03-01','2014-01-29 23:43:21','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-01-30 21:00:29'),(20423,16312,'Y','18','021','EC','A','','','AC','0001099213','0001099213','OH00001675247','IL','1','Yoder','Larry','','','','34','276509196','83 BUD DR',0,'MIDDLEFIELD','OH','44062','8902','CY','39055','1951-01-25','M','U',':RET:2106-3','N','021','DEN','2935488','99734OH005000301','2014-03-01','2014-01-29 10:48:26','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-29 21:00:31'),(19364,15435,'Y','18','024','14','A','','','TE','0000672747','0000672747','','IL','1','Sullivan','Bartholomew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-10-07','M','',NULL,NULL,NULL,'','1581847','','2014-01-21','2014-01-21 13:32:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:32'),(18779,14957,'N','01','021','EC','A',NULL,NULL,'','0000245016','0000771459','','IL','1','Himes','Carthell','','','','34','298560604','5696 MELODY LN',0,'MILFORD','OH','45150','2661','CY','39025','1957-03-03','M','',':RET:2106-3','N','021','HLT','2073136','92036OH004000601','2014-03-01','2014-01-16 13:23:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','402.70',NULL,0,'2014-01-17 03:35:52'),(13297,10614,'Y','18','021','EC','A','','','AC','0000817860','0000817860','TX00001209564','IL','1','Polo','Maria','','','','34','461952063','1900 Bay Area Blvd',0,'Houston','TX','77058',NULL,'CY','48201','1964-09-08','F','U',':RET:2500-7','N','021','DEN','2065788','33348TX002000201','2014-01-01','2013-12-23 14:22:26','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:57:39'),(14710,11745,'Y','18','021','EC','A','','','AC','0000966915','0000966915','OH00001612656','IL','1','Leever','Jennifer','','','','34','243573675','54 HUMMINGBIRD WAY',0,'AMELIA','OH','45102','1697','CY','39025','1979-10-25','F','U',':RET:2106-3','T','021','DEN','2333845','99734OH005000301','2014-02-01','2013-12-27 18:55:30','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,1,'2013-12-29 11:09:18'),(15743,12594,'Y','18','021','EC','A','','','AC','0000528288','0000528288','TX00001724954','IL','1','LEWELLEN','TONI','','','','34','432519065','869 LLANO DR',0,'ALLEN','TX','75013','4936','CY','48085','1977-04-06','F','U',':RET:2054-5','N','021','DEN','2186215','33348TX002000201','2014-02-01','2014-01-02 12:32:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-03 02:00:54'),(24638,19555,'Y','18','021','EC','A','','','AC','0001828593','0001828593','LA00002210119','IL','1','WALKER','DONNA','','','','34','435256618','45263 SAINT PAUL LOOP',0,'HAMMOND','LA','70401','5008','CY','22105','1967-03-27','F','U',':RET:2054-5','N','021','DEN','2790072','18575LA002000201','2014-04-01','2014-02-19 10:43:47','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:19:24'),(25788,20452,'Y','18','024','14','A','','','TE','0000723915','0000723915','','IL','1','Deerhake','Katie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-12-28','F','',NULL,NULL,NULL,'','1405692','','2014-03-11','2014-02-24 17:13:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 09:31:08'),(26289,20853,'Y','18','021','EC','A','','','AC','0001930338','0001930338','LA00002330096','IL','1','LEE','JESSIE','','','','34','435987556','4928 LITTLE JOHN',0,'NEW ORLEANS','LA','70128',NULL,'CY','22071','1958-11-16','F','U',':RET:2054-5','N','021','DEN','3647900','18575LA002000101','2014-04-01','2014-02-27 14:09:05','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-28 06:31:23'),(26302,20866,'Y','18','021','EC','A','','','AC','0000558202','0000558202','OH00003379825','IL','1','Yost','Juanita','','','','34','296505287','3915  North St. Rt. 2',0,'Oak Harbor','OH','43449',NULL,'CY','39123','1950-09-19','F','U',':RET:2106-3','T','021','HLT','2879592','92036OH005002706','2014-04-01','2014-02-27 17:15:46','577.00',NULL,NULL,'661.96','84.96','R-OH006','OH0','661.96',NULL,0,'2014-02-28 06:31:29'),(28183,22301,'Y','18','021','EC','A','','','AC','0000336490','0000336490','OH00003520686','IL','1','Garcia','Brandy','','','','34','482045527','3979 Wilma Ct',0,'Cincinnati','OH','45245',NULL,'CY','39025','1974-08-22','F','U',':RET:2106-3','T','021','HLT','3524801','92036OH003000604','2014-04-01','2014-03-06 14:06:00','85.00',NULL,NULL,'325.35','240.35','R-OH005','OH0','325.35',NULL,0,'2014-03-06 21:02:55'),(28464,22523,'Y','18','024','14','A','','','TE','0000512015','0000512015','','IL','1','Mallardi','Chloe',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-08-05','F','',NULL,NULL,NULL,'','3652089','','2014-03-06','2014-03-06 20:30:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:28'),(28746,22752,'Y','18','021','EC','A','','','AC','0000096426','0000096426','TX00003229740','IL','1','Murphy','rotisha','','','','34','451717988','1010 N 5TH ST',0,'BEAUMONT','TX','77701','1018','CY','48245','1984-12-30','F','U',':RET:2054-5','N','021','DEN','3708711','33348TX002000201','2014-04-01','2014-03-08 19:43:37','0.00',NULL,NULL,'14.61','14.61','R-TX004','TX0','14.61',NULL,0,'2014-03-09 21:00:13'),(2079,1702,'N','01','021','EC','A',NULL,NULL,'','0000460645','0000220111','','IL','1','Borel','Lundi','','','','34','433717616','1017 HEBERT LN',0,'SAINT MARTINVILLE','LA','70582','6108','CY','22099','1982-02-19','F','',':RET:2106-3','N','021','DEN','942780','18575LA002000201','2014-01-01','2013-12-09 23:33:03',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:16:34'),(7300,5786,'Y','18','021','EC','A','','','AC','0000538248','0000538248','OH00001183215','IL','1','WHITE','ROBERT','','','','34','278546332','71 EAST ROSEWOOD AVENUE',0,'AKRON','OH','44301',NULL,'CY','39153','1960-05-19','M','U',':RET:2106-3','N','021','HLT','959818','52664OH151001304','2014-01-01','2013-12-14 10:28:26','212.00',NULL,NULL,'454.94','242.94','R-OH012','OH0','454.94',NULL,0,'2013-12-26 02:03:07'),(20934,16731,'Y','18','021','EC','A','','','AC','0001006856','0001006856','OH00002383766','IL','1','Morris','Lisa','','','','34','302800971','15675 KRUSE RD',0,'WAPAKONETA','OH','45895','9579','CY','39011','1968-09-07','F','M',NULL,'N','021','HLT','3352328','92036OH002001501','2014-03-01','2014-01-31 13:50:45','492.00',NULL,NULL,'885.51','393.51','R-OH002','OH0','367.02',NULL,0,'2014-01-31 21:01:39'),(20139,16071,'Y','18','024','14','A','','','TE','0000862458','0000862458','','IL','1','Cooper','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-12-05','M','',NULL,NULL,NULL,'','2795777','','2014-01-27','2014-01-27 15:24:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:57'),(19910,15879,'N','01','021','EC','A',NULL,NULL,'','0000847175','0000273820','','IL','1','sturm','kathy','l','','','34','298622638','551 mohawk ave.',0,'akron','OH','44305',NULL,'CY','39153','1960-12-14','F','',':RET:2106-3','N','021','HLT','1403862','52664OH151001501','2014-03-01','2014-01-24 17:12:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','545.63',NULL,0,'2014-01-24 21:00:59'),(19201,15297,'Y','18','021','EC','A','','','AC','0001138069','0001138069','OH00001496883','IL','1','Reskof','Wendy','Elayna','','','34','205524648','2298 State Route 511',0,'Perrysville','OH','44864',NULL,'CY','39005','1959-05-18','F','M',':RET:2106-3','N','021','HLT','2083126','52664OH151001305','2014-03-01','2014-01-19 21:41:10','234.00',NULL,NULL,'476.12','242.12','R-OH012','OH0','476.12',NULL,0,'2014-01-21 08:46:16'),(17903,14300,'Y','18','021','EC','A','','','AC','0000375476','0000375476','TX00002051051','IL','1','Wherry','Stephen','','','','34','465067068','6736 FM 933',0,'BLUM','TX','76627','3108','CY','48217','1956-05-25','M','M',':RET:2106-3','N','021','DEN','2231523','33348TX002000201','2014-02-01','2014-01-13 18:54:21','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:24'),(17225,13784,'Y','18','021','EC','A','','','AC','0000964631','0000964631','OH00002073304','IL','1','Watkins','Therese','','','','34','281821254','113 Lynnfield Circle',0,'Union','OH','45333',NULL,'CY','39149','1970-10-03','F','U',':RET:2106-3','N','021','HLT','1400909','92036OH004000501','2014-02-01','2014-01-08 11:01:32','21.00',NULL,NULL,'259.37','238.37','R-OH003','OH0','259.37',NULL,0,'2014-01-13 02:22:36'),(5663,4493,'Y','18','021','EC','A','','','AC','0000399853','0000399853','OH00000316819','IL','1','Burke','Gregory','Lee','','','34','299525000','1242 KOHLER AVE',0,'AKRON','OH','44314','1618','CY','39153','1952-08-30','M','M',':RET:2106-3','N','021','HLT','934482','52664OH151001305','2014-01-01','2013-11-26 12:01:19','958.00',NULL,NULL,'1207.14','249.14','R-OH012','OH0','626.65',NULL,0,'2013-12-25 23:31:50'),(17057,13650,'Y','18','021','EC','A','','','AC','0000891072','0000891072','TX00001846182','IL','1','Ellams','Denise','','','','34','112425698','2803 Fredericksburg Road',0,'San Antonio','TX','78291',NULL,'CY','48029','1950-03-01','F','M',':RET:2054-5','N','021','DEN','2176267','33348TX002000201','2014-02-01','2014-01-08 18:14:44','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-13 02:21:09'),(16456,13169,'Y','18','024','14','A','','','TE','0000001052','0000001052','','IL','1','UHRICK','CRISTINA','MARIE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-07','F','',NULL,NULL,NULL,'','1648865','','2014-01-06','2014-01-06 10:06:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:05:36'),(16072,12871,'Y','18','021','EC','A','','','AC','0000590802','0000590802','OH00001445977','IL','1','HALL','ROBERT','L','','','34','282569538','3741 N STATE ROUTE 42',0,'WAYNESVILLE','OH','45068','9539','CY','39165','1957-07-18','M','M',NULL,'N','021','DEN','1692536','99734OH005000401','2014-02-01','2014-01-03 12:31:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:50'),(14555,11613,'Y','18','021','EC','A','','','AC','0000961874','0000961874','OH00000996860','IL','1','Partin','Martha','Irene','','','34','278543587','799 FAIRWOOD RD',0,'AKRON','OH','44319','4760','CY','39153','1953-09-15','F','M',':RET:2106-3','N','021','HLT','1960712','52664OH152000901','2014-02-01','2013-12-27 11:25:44','600.00',NULL,NULL,'933.31','333.31','R-OH012','OH0','443.31',NULL,0,'2013-12-28 03:35:09'),(14486,11557,'Y','18','021','EC','A','','','AC','0000011400','0000011400','TX00000604176','IL','1','HOLLY','JOSHUA','','','','34','632072533','407 W GIBSON ST',0,'JASPER','TX','75951','4963','CY','48241','1988-08-27','M','U',NULL,'N','021','DEN','2005795','33348TX002000201','2014-02-01','2013-12-27 09:10:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:33:23'),(13787,11004,'Y','18','021','EC','A','','','AC','0000544132','0000544132','MS00000372683','IL','1','taylor','perry','','','','34','509660116','15462 davis circle',0,'gulfport','MS','39503',NULL,'CY','28047','1957-09-06','M','U',':RET:2054-5','T','021','DEN','1440686','46300MS002000201','2014-01-01','2013-12-23 18:08:53','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 13:10:55'),(13196,10529,'Y','18','021','EC','A','','','AC','0000918807','0000918807','TX00000975428','IL','1','Martin','Gary','','','','34','433765875','P.O. Box 6807',0,'Houston','TX','77265',NULL,'CY','48201','1951-01-14','M','U',':RET:2106-3','N','021','DEN','2355087','33348TX002000101','2014-01-01','2013-12-23 12:47:59','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 12:54:49'),(5382,4269,'Y','18','021','EC','A','','','AC','0001955043','0001955043','LA00000401980','IL','1','RAY','JANIS','','','','34','452066225','1012 MALCOLM ST',0,'FRANKLIN','LA','70538',NULL,'CY','22101','1955-05-26','F','U',':RET:2106-3','N','021','DEN','2197115','18575LA002000201','2014-01-01','2013-12-19 15:50:05','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 23:08:23'),(3660,2928,'Y','18','021','EC','A','','','AC','0000755982','0000755982','OH00000500943','IL','1','WEBER','ANTHONY','','','','34','296443177','532 COVEDALE AVE',0,'CINCINNATI','OH','45238',NULL,'CY','39061','1956-08-04','M','M',':RET:2106-3','N','021','DEN','1181594','99734OH005000401','2014-01-01','2013-12-12 20:16:15','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:30:52'),(5251,4165,'Y','18','024','14','A','','','TE','0000780470','0000780470','','IL','1','Treadway','Karen','A',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-04-07','F','',NULL,NULL,NULL,'','827433','','2013-12-19','2013-12-19 09:55:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:05:08'),(25485,20218,'N','01','021','EC','A',NULL,NULL,'','0000289578','0000323562','','IL','1','Werring','Anne','M','','','34','300783377','2896 STATE ROUTE 286',0,'WILLIAMSBURG','OH','45176','6527','CY','39015','1966-11-04','F','',':RET:2106-3','N','021','HLT','3367977','92036OH005000601','2014-04-01','2014-02-25 10:39:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','335.54',NULL,0,'2014-02-25 21:31:45'),(27133,21480,'Y','18','021','EC','A','','','AC','0000190249','0000190249','OH00002045924','IL','1','Bailey','Mark','','','','34','297762160','5292 SERENADE DR',0,'CINCINNATI','OH','45238','4823','CY','39061','1965-04-17','M','R',':RET:2106-3','N','021','DEN','3699485','99734OH005000401','2014-04-01','2014-03-02 23:04:16','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:41'),(29033,22979,'Y','18','021','EC','A','','','AC','0000523474','0000523474','OH00003806768','IL','1','JENNINGS','DEBRA','','','','34','291546519','111 LINABARY AVE',0,'WESTERVILLE','OH','43081',NULL,'CY','39049','1954-01-10','F','U',':RET:2106-3','N','021','DEN','3983980','99734OH005000401','2014-04-01','2014-03-10 12:06:12','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:01:36'),(7988,6323,'N','01','021','EC','A',NULL,NULL,'','0001162588','0000667771','','IL','1','HENDERSON','MARY','','','','34','297727183','400 HIGH ST',0,'DOYLESTOWN','OH','44230','1322','CY','39169','1962-01-28','F','',NULL,'T','021','HLT','1803078','52664OH151001304','2014-01-01','2013-12-20 15:01:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','478.30',NULL,0,'2013-12-26 03:08:06'),(7483,5921,'Y','18','021','EC','A','','','AC','0000071620','0000071620','OH00001029917','IL','1','Sadiq','Jehangir','','','','34','301946106','6346 RUGOSA AVE',0,'REYNOLDSBURG','OH','43068','1062','CY','39049','1965-09-15','M','M',':RET:2029-7','N','021','DEN','692546','99734OH005000401','2014-01-01','2013-12-15 13:53:16','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2013-12-26 02:31:26'),(22354,17854,'Y','18','021','EC','A','','','AC','0002134557','0002134557','LA00002525887','IL','1','nicholas','erica','','','','34','437113894','825 E HARDING ST',0,'DESTREHAN','LA','70047','4222','CY','22089','1962-05-14','F','U',':RET:2054-5','N','021','DEN','2711719','18575LA002000201','2014-03-01','2014-02-10 15:16:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-10 21:00:05'),(22040,17594,'Y','18','021','EC','A','','','AC','0000429493','0000429493','MS00002286945','IL','1','Stallion','Mona','','','','34','587130783','500 AIRPORT RD',0,'BELZONI','MS','39038','3887','CY','28053','1969-07-31','F','M',NULL,'N','021','DEN','3353840','46300MS002000201','2014-03-01','2014-02-07 17:13:28','0.00',NULL,NULL,'31.70','31.70','R-MS006','MS0','15.85',NULL,0,'2014-02-07 19:01:08'),(2301,1873,'N','01','021','EC','A',NULL,NULL,'','0000109262','0000326162','','IL','1','Skelley','Elizabeth','','','','34','291687689','5415 SPIETH RD',0,'MEDINA','OH','44256','9443','CY','39103','1961-04-07','F','',NULL,'T','021','DEN','1083972','99734OH005000301','2014-01-01','2013-12-09 16:58:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:31:00'),(17004,13610,'Y','18','021','EC','A','','','AC','0001105554','0001105554','OH00001651880','31','1','Walker','Donna','M','','','34','268801718','PO Box 225',0,'Delaware','OH','43015',NULL,'CY','39041','1980-02-10','F','U',':RET:2106-3','N','021','DEN','2409529','99734OH005000301','2014-02-01','2014-01-09 11:13:53','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-13 02:20:32'),(20308,16211,'Y','18','021','EC','A','','','AC','0000717453','0000717453','TX00001822791','31','1','wyatt','jennifer','','','','34','455810194','7501 Seville Dr.',0,'Amarillo','TX','79121',NULL,'CY','48381','1985-10-31','F','U',':RET:2106-3','T','021','DEN','2162517','33348TX002000201','2014-03-01','2014-01-28 11:11:46','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-01-28 21:00:47'),(20082,16020,'Y','18','021','EC','A','','','AC','0000001291','0000001291','TX00001950213','IL','1','Mitchell','Ashley','','','','34','450838737','1813 North Banks St',0,'Pampa','TX','79065',NULL,'CY','48179','1987-04-10','F','U',NULL,'N','021','DEN','1755927','33348TX002000201','2014-03-01','2014-01-27 18:16:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-27 21:00:24'),(21415,17116,'N','19','021','EC','A',NULL,NULL,'','0000932136','0000043256','','IL','1','Reed','Nichole','Yvonne','','','34','297968120','111 W. Cooper St.',0,'McComb','OH','45858',NULL,'CY','39063','1994-07-11','F','',':RET:2106-3','N','021','HLT','3147829','92036OH005001505','2014-03-01','2014-02-03 19:30:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2014-02-04 21:01:10'),(20847,16662,'N','19','021','EC','A',NULL,NULL,'','0000024143','0000857149','','IL','1','Ganim','Max','','','','34','281044446','852 EDGAR LN',0,'BRUNSWICK','OH','44212','5634','CY','39103','1999-05-26','M','',':RET:2106-3','N','021','DEN','3614093','99734OH005000301','2014-03-01','2014-01-30 20:04:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-31 21:00:50'),(19626,15643,'Y','18','021','EC','A','','','AC','0000449900','0000449900','OH00002513619','IL','1','MECHLING','SHANNON','','','','34','296861970','210 W MAIN ST',0,'MOUNT STERLING','OH','43143','1211','CY','39097','1980-12-25','M','U',NULL,'T','021','DEN','3094087','99734OH005000401','2014-03-01','2014-01-23 07:37:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:00:06'),(15808,12654,'Y','18','021','EC','A','','','AC','0001505515','0001505515','LA00001650438','IL','1','CARTER','JOYCE','','','','34','439841726','146 EVANGELINE DR',0,'DONALDSONVILLE','LA','70346','4325','CY','22005','1950-05-16','F','M',':RET:2054-5','N','021','DEN','2382811','18575LA002000201','2014-02-01','2014-01-02 15:50:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:03:06'),(9793,7754,'N','01','021','EC','A',NULL,NULL,'','0000245251','0000244175','','IL','1','Dickson','David','Patrick','','','34','231900310','32432 MERCIER RD',0,'DENHAM SPRINGS','LA','70706','1023','CY','22063','1964-09-22','M','',':RET:2106-3','N','021','DEN','922185','18575LA002000101','2014-01-01','2013-10-20 19:58:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 05:01:02'),(3703,2963,'Y','18','021','EC','A','','','AC','0001136636','0001136636','OH00000389313','IL','1','PORCHE','WENDI','','','','34','275800816','24835 W NORTHWOOD DR',0,'OLMSTED FALLS','OH','44138','3240','CY','39035','1967-03-06','F','U',':RET:2106-3','N','021','DEN','315314','99734OH005000401','2014-01-01','2013-12-13 13:38:40','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:32:01'),(4387,3488,'Y','18','021','EC','A','','','AC','0000289506','0000289506','OH00000075161','IL','1','Runions','Emily','','','','34','299887600','788 GRIFFIN LN',0,'MONROE','OH','45050','2491','CY','39017','1988-07-01','F','U',NULL,'N','021','DEN','464118','99734OH005000401','2014-01-01','2013-12-12 11:09:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:00:47'),(19724,15718,'Y','18','021','EC','A','','','AC','0001904931','0001904931','LA00002350704','IL','1','Vo','Ha','','','','34','663033784','2321 North Parc Green Lane',0,'Harvey','LA','70058',NULL,'CY','22051','1962-08-10','F','U',':RET:2028-9','N','021','DEN','2658307','18575LA002000201','2014-03-01','2014-01-23 10:37:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:00'),(17642,14102,'Y','18','024','14','A','','','TE','0000516871','0000516871','','IL','1','ARLEDGE','RANDALL','PATRICK',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-30','M','',NULL,NULL,NULL,'','1828943','','2014-01-13','2014-01-13 09:14:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-14 01:32:37'),(17414,13937,'Y','18','024','14','A','','','TE','0001203227','0001203227','','IL','1','HUNDLEY','ROBERT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-28','M','',NULL,NULL,NULL,'','1741205','','2014-01-10','2014-01-10 10:08:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:24'),(5613,4455,'N','19','021','EC','A',NULL,NULL,'','0000666729','0000951761','','IL','1','Yohe','Sydney','','','','34','297132006','3436 ERHART RD',0,'LITCHFIELD','OH','44253','9731','CY','39103','2008-04-28','F','',':RET:2106-3','N','021','DEN','834245','99734OH005000401','2014-01-01','2013-11-26 08:16:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:36'),(25053,19867,'Y','18','021','EC','A','','','AC','0000192780','0000192780','OH00002765010','IL','1','Zink','Eileen','','','','34','272520462','3868 Yale Avenue',0,'Lima','OH','45804',NULL,'CY','39003','1951-10-30','F','U',':RET:2106-3','N','021','DEN','3698137','99734OH005000401','2014-04-01','2014-02-20 08:37:59','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-20 22:01:18'),(26967,21365,'Y','18','021','EC','A','','','AC','0000423996','0000423996','TX00002400667','IL','1','Ramirez','Maria','','','','34','372608915','3716 MILE 13 N',0,'MERCEDES','TX','78570','5945','CY','48215','1955-12-22','F','M',':RET:2106-3','N','021','DEN','3242300','33348TX002000101','2014-04-01','2014-03-01 22:18:07','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2014-03-03 01:00:33'),(27965,22123,'Y','18','021','EC','A','','','AC','0002151075','0002151075','LA00003530440','IL','1','allen','lakeisha','','','','34','435738004','14409 ROYAL OAKS AVE',0,'BATON ROUGE','LA','70816','2650','CY','22033','1988-10-23','F','U',':RET:2054-5','N','021','DEN','3731333','18575LA002000201','2014-04-01','2014-03-05 23:15:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:47'),(17,13,'Y','18','021','EC','A','','','AC','0000954272','0000954272','OH00000339065','IL','1','FROMAN','JEFFERY','','','','34','292629971','914 ALBERTON',0,'HAMILTON','OH','45013',NULL,'CY','39017','1960-11-28','M','U',':RET:2106-3','N','021','DEN','1185373','99734OH005000401','2014-01-01','2013-12-05 09:52:07','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:15:26'),(24292,19293,'Y','18','021','EC','A','','','AC','0000039862','0000039862','OH00002735156','IL','1','Provitt','Yana','','','','34','277706773','1491 OAKWOOD AVE',0,'AKRON','OH','44301','2315','CY','39153','1975-05-14','F','M',':RET:2054-5','N','021','HLT','3487101','52664OH151001304','2014-04-01','2014-02-18 14:11:22','106.37',NULL,NULL,'277.87','171.50','R-OH012','OH0','277.87','CIC',0,'2014-02-18 21:30:14'),(1870,1526,'N','01','021','EC','A',NULL,NULL,'','0000578790','0000563139','','IL','1','Barnett','Ronald','','','','34','290501235','3974 Colony Rd',0,'South Euclid','OH','44118',NULL,'CY','39035','1952-03-15','M','',':RET:2054-5','N','021','HLT','2138772','52664OH152000901','2014-01-01','2013-12-24 14:29:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','517.67',NULL,0,'2013-12-25 18:58:16'),(22444,17921,'Y','18','021','EC','A','','','AC','0000276627','0000276627','TX00002271654','IL','1','rayos','rosa','r','','','34','452949664','18660 sobrino dr',0,'tornillo','TX','79853',NULL,'CY','48141','1950-02-28','F','M',':RET:2106-3','N','021','DEN','3403538','33348TX002000201','2014-03-01','2014-02-10 13:42:20','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-10 21:30:43'),(21283,17009,'Y','18','024','14','A','','','TE','0000751023','0000751023','','IL','1','Moore','Abbey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-11-09','F','',NULL,NULL,NULL,'','2500992','','2014-02-03','2014-02-03 18:28:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-04 21:00:03'),(19383,15451,'Y','18','021','EC','A','','','AC','0001253158','0001253158','TX00001439297','IL','1','RODMAN','JOSEPH','','','','34','463470220','2201 E PLUM ST',0,'LAREDO','TX','78043','1602','CY','48479','1964-01-17','M','M',':RET:2106-3','N','021','DEN','3055553','33348TX002000101','2014-03-01','2014-01-21 13:15:23','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02',NULL,1,'2014-01-22 03:22:43'),(26038,20650,'N','01','021','EC','A',NULL,NULL,'','0000179959','0000127018','','IL','1','Lintner','Donald','','','','34','293522440','36 OUTLOOK DR',0,'TALLMADGE','OH','44278','1928','CY','39153','1953-04-01','M','',NULL,'N','021','HLT','3501144','52664OH151001305','2014-04-01','2014-02-26 11:47:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','626.65',NULL,0,'2014-02-26 21:02:25'),(26880,21303,'Y','18','024','14','A','','','TE','0001187688','0001187688','','IL','1','Civitarese','Frank',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-11-25','M','',NULL,NULL,NULL,'','3280684','','2014-03-01','2014-03-01 14:37:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-01 21:01:08'),(27905,22077,'Y','18','021','EC','A','','','AC','0000698591','0000698591','TX00003037779','IL','1','Larry','Cecil','','','','34','449252894','929 WHITEWATER TRL',0,'DESOTO','TX','75115','5444','CY','48113','1957-05-06','F','M',NULL,'N','021','DEN','3811459','33348TX002000201','2014-04-01','2014-03-05 19:11:10','0.00',NULL,NULL,'72.22','72.22','R-TX008','TX0','15.85',NULL,0,'2014-03-06 21:00:12'),(9473,7513,'N','01','021','EC','A',NULL,NULL,'','0000125551','0000130688','','IL','1','Curry','John','','','','34','297924303','4434 VALENCE DR',0,'CINCINNATI','OH','45238','5827','CY','39061','1983-09-08','M','',':RET:2106-3','N','021','DEN','1425821','99734OH005000401','2014-01-01','2013-12-21 10:51:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:29'),(24392,19374,'Y','18','021','EC','A','','','AC','0000060315','0000060315','OH00002922705','IL','1','FLICK','OLGA','','','','34','300541224','10900 RONALD DRIVE',0,'CLEVELAND','OH','44130',NULL,'CY','39035','1952-05-10','F','U',NULL,'N','021','DEN','3848493','99734OH005000401','2014-04-01','2014-02-18 13:19:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-18 22:00:49'),(21663,17302,'Y','18','021','EC','A','','','AC','0001671586','0001671586','LA00001503309','IL','1','FARRELL','SIDNEY','','','Jr','34','433683748','1241 FAIRWAY ST',0,'KENNER','LA','70062',NULL,'CY','22051','1951-12-03','M','M',NULL,'T','021','DEN','2943992','18575LA002000201','2014-03-01','2014-02-05 13:48:28','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:56'),(9226,7321,'Y','18','021','EC','A','','','AC','0000655803','0000655803','OH00000730728','IL','1','Packard','Abigail','','','','34','345067752','2063 Whispering Willow Ln',0,'Amelia','OH','45102',NULL,'CY','39025','2007-05-07','F','R',':RET:2106-3','N','021','HLT','2360834','92036OH006000601','2014-01-01','2013-12-18 12:35:38','100.58',NULL,NULL,'108.11','7.53','R-OH005','OH0','108.11',NULL,0,'2013-12-26 04:10:21'),(3654,2924,'Y','18','021','EC','A','','','AC','0000460565','0000460565','OH00000647511','IL','1','Bosch','Alica','','','','34','272841770','451 MONROE ST',0,'CONNEAUT','OH','44030','2548','CY','39007','1984-03-20','F','M',':RET:2106-3','N','021','DEN','266666','99734OH005000401','2014-01-01','2013-12-12 19:21:19','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:30:42'),(20853,16668,'Y','18','024','14','A','','','TE','0000532122','0000532122','','IL','1','POPOLIZIO','LEAH',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-07-11','F','',NULL,NULL,NULL,'','1395674','','2014-01-31','2014-01-31 10:14:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:00:54'),(20655,16506,'Y','18','024','14','A','','','TE','0000049311','0000049311','','IL','1','GARZA','MARIANELA','P',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-15','F','',NULL,NULL,NULL,'','1538097','','2014-01-30','2014-01-30 16:12:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-30 21:00:41'),(19786,15773,'Y','18','021','EC','A','','','AC','0000352867','0000352867','OH00001697964','IL','1','Hamilton','Etta','','','','34','232864216','574 GRACE AVE',0,'AKRON','OH','44320','2917','CY','39153','1951-07-29','F','M',':RET:2054-5','N','021','HLT','3348184','52664OH151001305','2014-03-01','2014-01-23 09:12:02','488.00',NULL,NULL,'640.70','152.70','R-OH012','OH0','640.70',NULL,0,'2014-01-23 21:01:37'),(4607,3648,'Y','18','021','EC','A','','','AC','0000340265','0000340265','OH00000611476','IL','1','McMaster','Christopher','','','','34','289783927','3660 Kent Rd.',0,'Stow','OH','44224',NULL,'CY','39153','1982-04-16','M','U',':RET:2106-3','N','021','HLT','1081173','52664OH151001501','2014-01-01','2013-12-11 20:53:33','0.00',NULL,NULL,'309.99','309.99','R-OH012','OH0','309.99',NULL,0,'2013-12-25 22:05:52'),(19122,15236,'Y','18','021','EC','A','','','AC','0000330904','0000330904','OH00001391737','IL','1','Gerhard','Tamera','Joyce','','','34','293686173','331 W OCONNOR AVE',0,'LIMA','OH','45801','3633','CY','39003','1970-08-03','F','U',':RET:2106-3','N','021','HLT','2951075','92036OH002001501','2014-03-01','2014-01-19 16:02:13','0.00',NULL,NULL,'344.89','344.89','R-OH002','OH0','344.89',NULL,0,'2014-01-21 08:45:18'),(7369,5836,'Y','18','021','EC','A','','','AC','0000004976','0000004976','LA00000393741','31','1','Irfan','Wajeeh','','','','34','111823352','11142 coniston way',0,'Windermere','FL','34786',NULL,'CY','22071','1985-03-12','M','U',':RET:2028-9','N','021','DEN','645100','18575LA002000201','2014-01-01','2013-11-22 21:10:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:15:36'),(17745,14177,'Y','18','021','EC','A','','','AC','0001081821','0001081821','OH00002404610','IL','1','Stevens','Elizabeth','','','','34','096465878','142 NORTHGATE DR NE',0,'WARREN','OH','44484','5536','CY','39155','1953-06-10','F','U',NULL,'N','021','HLT','1468256','52664OH151001306','2014-02-01','2014-01-13 16:16:42','559.00',NULL,NULL,'686.36','127.36','R-OH013','OH0','686.36',NULL,0,'2014-01-14 01:33:25'),(16916,13537,'Y','18','021','EC','A','','','AC','0000638522','0000638522','OH00001641399','IL','1','Royer','Diana','Marie','','','34','289724675','715 MAGNOLIA DR',0,'GREENVILLE','OH','45331','2467','CY','39037','1962-02-06','F','U',NULL,'N','021','DEN','2260731','99734OH005000401','2014-02-01','2014-01-09 15:38:40','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:19:41'),(14280,11392,'Y','18','021','EC','A','','','AC','0000750521','0000750521','MS00000257708','IL','1','Montgomery','Willie','','','','34','426292316','325 BEECHCREST DR',0,'JACKSON','MS','39211','3412','CY','28049','1971-11-30','M','U',':RET:2054-5','N','021','DEN','2580265','46300MS002000201','2014-02-01','2013-12-26 16:11:24','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:18'),(15932,12755,'N','01','021','EC','A',NULL,NULL,'','0000030555','0000851847','','IL','1','DeLeon','Victor','','','Jr','34','309548301','5144 US Rte 250 N Lot 117',0,'Norwalk','OH','44857',NULL,'CY','39077','1950-05-30','M','',NULL,'T','021','HLT','2545249','92036OH004002701','2014-02-01','2014-01-01 18:35:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','532.27',NULL,0,'2014-01-03 02:06:55'),(15041,12023,'Y','18','021','EC','A','','','AC','0002123794','0002123794','LA00001350137','IL','1','YOUNG','YVETTE','A','','','34','434172304','9217 PALM ST',0,'NEW ORLEANS','LA','70118',NULL,'CY','22071','1958-02-01','F','U',NULL,'N','021','DEN','1832796','18575LA002000201','2014-02-01','2013-12-30 12:57:06','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-01 12:02:57'),(24748,19639,'N','19','021','EC','A',NULL,NULL,'','0000027939','0000507028','','IL','1','Dugan','Vincent','A','','III','34','300945929','3505 Scioto Run Blvd',0,'Hilliard','OH','43026',NULL,'CY','39049','1992-07-07','M','',NULL,'N','021','DEN','3529544','99734OH005000401','2014-04-01','2014-02-19 10:36:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:40:54'),(13383,10684,'Y','18','021','EC','A','','','AC','0000652124','0000652124','OH00000655725','IL','1','Homer','Brian','','','','34','277885161','309 RICE ST',0,'ELMORE','OH','43416','9404','CY','39123','1982-04-24','M','M',':RET:2106-3','N','021','DEN','2259194','99734OH005000301','2014-01-01','2013-12-22 23:36:25','0.00',NULL,NULL,'42.26','42.26','R-OH006','OH0','0.00',NULL,0,'2013-12-26 12:59:57'),(2606,2117,'Y','18','021','EC','A','','','AC','0001174374','0001174374','OH00000983081','IL','1','LONGBOTTOM','BARBARA','','','','34','272524510','118 E WOODLAND AVE',0,'COLUMBIANA','OH','44408','1519','CY','39029','1953-01-31','F','M',':RET:2106-3','N','021','DEN','835425','99734OH005000401','2014-01-01','2013-12-02 09:06:17','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 19:45:28'),(22152,17682,'Y','18','021','EC','A','','','AC','0000140333','0000140333','OH00002007864','IL','1','WHORTON','TODD','','','','34','299602258','738 EDGEHILL AVE',0,'ASHLAND','OH','44805','4118','CY','39005','1970-01-26','M','U',NULL,'N','021','HLT','2773800','52664OH151001306','2014-03-01','2014-02-08 14:32:47','284.00',NULL,NULL,'311.54','27.54','R-OH012','OH0','311.54',NULL,0,'2014-02-08 19:00:54'),(18799,14972,'Y','18','021','EC','A','','','AC','0000799917','0000799917','OH00001995072','IL','1','Buccino','Gina','','','','34','302480988','6408 INVERNESS WAY',0,'MASON','OH','45040','2054','CY','39165','1956-11-05','F','U',':RET:2106-3','N','021','DEN','1732087','99734OH005000401','2014-03-01','2014-01-16 11:41:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:35:59'),(18402,14683,'Y','18','021','EC','A','','','AC','0000096422','0000096422','OH00002303719','IL','1','anthony','stephen','','','','34','296880737','6360 PARK POINTE CT',0,'PEPPER PIKE','OH','44124','5390','CY','39035','1987-03-21','M','U',':RET:2106-3','N','021','DEN','2281023','99734OH005000301','2014-02-01','2014-01-15 17:23:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:43'),(18069,14432,'N','01','021','EC','A',NULL,NULL,'','0001390894','0001321413','','IL','1','Marbury','Jessica','L','','','34','433615994','17269 Milton Dr',0,'French Settlement','LA','70733',NULL,'CY','22063','1986-04-25','F','',':RET:2106-3','N','021','DEN','1915052','18575LA002000201','2014-02-01','2014-01-14 01:04:27',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:23'),(16639,13312,'Y','18','021','EC','A','','','AC','0000236288','0000236288','OH00001525102','IL','1','Prisbylla','Pamela','Kay','','','34','273562780','18 PUEBLO TRL',0,'MALVERN','OH','44644','9528','CY','39019','1952-10-02','F','M',NULL,'N','021','DEN','2323309','99734OH005000401','2014-02-01','2014-01-07 11:43:26','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-08 18:24:17'),(16605,13282,'Y','18','021','EC','A','','','AC','0001649918','0001649918','LA00002236060','IL','1','Antunez','Ana','M','','','34','056501917','1008 COMPROMISE ST',0,'KENNER','LA','70062','6740','CY','22051','1955-07-26','F','U',NULL,'N','021','DEN','1445973','18575LA002000201','2014-02-01','2014-01-07 15:14:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:24:05'),(15519,12416,'Y','18','021','EC','A','','','AC','0002171641','0002171641','LA00001598239','IL','1','harrell','kevin','','','','34','439790147','294 WRIGHT AVE',0,'TERRYTOWN','LA','70056','2604','CY','22051','1990-10-25','M','U',':RET:2054-5','N','021','DEN','2092559','18575LA002000201','2014-02-01','2013-12-30 19:42:28','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:30:16'),(13801,11016,'N','19','021','EC','A',NULL,NULL,'','0000615442','0000068505','','IL','1','Stewart','Loren','','','','34','602606140','1445 GATES RD',0,'COLUMBIA','MS','39429','5042','CY','28091','1992-02-24','M','',':RET:2054-5','N','021','DEN','2044531','46300MS002000101','2014-01-01','2013-12-23 12:45:45',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-26 13:11:22'),(28514,22565,'Y','18','021','EC','A','','','AC','0000500463','0000500463','OH00003241011','IL','1','Cunningham','Anthony','','','','34','294869900','4643 BLUEJAY CT',0,'CINCINNATI','OH','45244','1178','CY','39025','1980-08-13','M','M',':RET:2106-3','N','021','HLT','3116203','92036OH001000601','2014-04-01','2014-03-06 20:49:44','236.00',NULL,NULL,'604.10','368.10','R-OH005','OH0','310.20',NULL,0,'2014-03-07 21:31:56'),(8149,6446,'Y','18','021','EC','A','','','AC','0000602635','0000602635','TX00001033118','IL','1','Diggins','Lupita','','','','34','456278578','3421 MICHELLE RIDGE DR',0,'FORT WORTH','TX','76123','2090','CY','48439','1974-05-10','F','U',':RET:2054-5','N','021','DEN','1102094','33348TX002000101','2014-01-01','2013-11-22 13:36:32','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 03:15:58'),(1067,873,'N','01','021','EC','A',NULL,NULL,'','0000121502','0000493190','','IL','1','Sarkis','Renee','Awkar','','','34','297862366','1289 WARREN RD',0,'LAKEWOOD','OH','44107','2515','CY','39035','1961-02-28','F','',':RET:2106-3','N','021','DEN','1092913','99734OH005000401','2014-01-01','2013-12-02 22:37:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:16:25'),(22311,17812,'Y','18','021','EC','A','','','AC','0000601851','0000601851','MS00001969060','IL','1','handy','keith','','','','34','426358722','3043 BIENVILLE DR',0,'JACKSON','MS','39212','2576','CY','28049','1979-03-12','M','U',':RET:2054-5','N','021','DEN','1526279','46300MS002000101','2014-03-01','2014-01-26 17:10:15','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-10 11:00:45'),(21054,16821,'Y','18','021','EC','A','','','AC','0002383576','0002383576','LA00001846709','IL','1','Johnson','Rachael','','','','34','260615002','1625 SAINT CHARLES AVE',0,'NEW ORLEANS','LA','70130','4435','CY','22071','1977-05-14','F','U',':RET:2106-3','N','021','DEN','3329141','18575LA002000201','2014-03-01','2014-02-01 19:02:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-02 19:00:07'),(17394,13918,'Y','18','021','EC','A','','','AC','0000636027','0000636027','OH00002446029','IL','1','brittin','ashley','','','','34','274827176','1120 BIG HILL RD',0,'SOUTH CHARLESTON','OH','45368','9715','CY','39023','1984-04-07','F','U',':RET:2047-9^:RET:2106-3','N','021','DEN','2133905','99734OH005000401','2014-02-01','2014-01-10 16:18:43','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-13 03:00:12'),(23517,18734,'Y','18','021','EC','A','','','AC','0000740948','0000740948','MS00001746707','31','1','Moore','Margareta','','','','34','587749176','PO Box 1286',0,'Starkville','MS','39760',NULL,'CY','28105','1957-07-18','F','U',':RET:2054-5','N','021','DEN','2990339','46300MS002000101','2014-03-01','2014-02-13 16:11:43','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-13 22:02:18'),(25967,20593,'Y','18','021','EC','A','','','AC','0000566671','0000566671','OH00002583035','IL','1','michaels','debra','','','','34','302627394','8595 abbot cove ave',0,'galloway','OH','43119',NULL,'CY','39049','1958-09-25','F','M',':RET:2106-3','N','021','DEN','3531056','99734OH005000401','2014-03-01','2014-02-26 12:56:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-26 21:01:44'),(28254,22356,'Y','18','024','14','A','','','TE','0000383369','0000383369','','IL','1','PHILBRICK','cythnia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-03','F','',NULL,NULL,NULL,'','2552362','','2014-03-31','2014-03-07 17:33:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:14'),(8972,7116,'N','19','021','EC','A',NULL,NULL,'','0000370007','0001045673','','S1','1','Ward','Benjamin','','','','34','286085609','2525 BRENDEL DR',0,'COLUMBUS','OH','43235','8004','CY','39049','2003-09-10','F','',NULL,'N','021','DEN','2186646','99734OH005000401','2014-01-01','2013-12-18 15:16:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:04:06'),(1633,1364,'Y','18','021','EC','A','','','AC','0000360333','0000360333','TX00000280777','31','1','Lam','Thai','','','','34','586304312','P O Box 195',0,'Annona','TX','75550',NULL,'CY','48387','1961-01-17','M','U',':RET:2028-9','T','021','DEN','2388939','33348TX002000201','2014-01-01','2013-12-24 15:07:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:52:52'),(22536,17994,'Y','18','021','EC','A','','','AC','0000612869','0000612869','MS00001861643','IL','1','Stephenson','Michael','','','','34','219584338','1521 Lima St.',0,'Gautier','MS','39553',NULL,'CY','28059','1951-08-13','M','U',':RET:2106-3','N','021','DEN','3856757','46300MS002000201','2014-03-01','2014-02-10 13:38:01','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-10 21:31:35'),(22500,17962,'Y','18','021','EC','A','','','AC','0000807535','0000807535','OH00001515649','IL','1','NI','MINGJUAN','','','','34','285046048','1210 ASHMORE CT',0,'CINCINNATI','OH','45231','5590','CY','39061','1966-07-06','F','M',':RET:2034-7','N','021','DEN','3526612','99734OH005000301','2014-03-01','2014-02-10 15:15:24','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-10 21:31:12'),(22495,17958,'N','01','021','EC','A',NULL,NULL,'','0000403701','0000049553','','IL','1','Frail','Brian','G','','','34','289861881','10423 BAILEY RD',0,'WATERVILLE','OH','43566','9716','CY','39095','1977-03-07','M','',':RET:2106-3','N','021','DEN','3030303','99734OH005000301','2014-03-01','2014-02-10 14:03:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-10 21:31:10'),(13422,10709,'Y','18','024','14','A','','','TE','0000540299','0000540299','','IL','1','Mecklenborg','Evan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-07-19','M','',NULL,NULL,NULL,'','1618729','','2013-12-23','2013-12-23 11:34:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:00:51'),(21183,16928,'Y','18','021','EC','A','','','AC','0000284891','0000284891','MS00001472015','IL','1','LOFTON','SHENIKA','','','','34','426650923','1433 PLUM ST',0,'JACKSON','MS','39209','4638','CY','28049','1980-12-11','F','U',NULL,'N','021','DEN','1811804','46300MS002000101','2014-03-01','2014-02-02 23:49:12','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-03 21:00:44'),(20289,16194,'Y','18','021','EC','A','','','AC','0001436520','0001436520','LA00001737941','31','1','Baham','Floyd','','','','34','438646383','null null',0,'NEW ORLEANS','LA','70182','8340','CY','22071','1945-07-07','M','M',':RET:2054-5','T','021','DEN','2808123','18575LA002000201','2014-03-01','2014-01-27 20:15:57','0.00',NULL,NULL,'16.22','16.22','R-LA001','LA0','16.22',NULL,0,'2014-01-28 21:00:34'),(13475,10746,'Y','18','021','EC','A','','','AC','0000412210','0000412210','OH00001085587','IL','1','dearing','debra','','','','34','233946307','4538 NATURAL TRL',0,'NEW ALBANY','OH','43054','8858','CY','39049','1958-09-01','F','U',NULL,'N','021','DEN','1977805','99734OH005000301','2014-01-01','2013-12-23 17:05:39','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:02:06'),(18244,14563,'Y','18','024','14','A','','','TE','0001196672','0001196672','','IL','1','Gonzalez','Maria','D',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-11-01','F','',NULL,NULL,NULL,'','1920141','','2014-01-15','2014-01-15 12:49:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-16 08:44:27'),(17314,13847,'Y','18','021','EC','A','','','AC','0001244354','0001244354','TX00001825214','IL','1','Steinberger','Summer','','','','34','628149313','1728 Rockridge Drive',0,'Wichita Falls','TX','76310',NULL,'CY','48485','1977-02-03','F','U',':RET:2106-3','T','021','DEN','2300100','33348TX002000201','2014-02-01','2014-01-10 14:49:26','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-01-13 02:23:46'),(17224,13783,'Y','18','021','EC','A','','','AC','0001168016','0001168016','OH00001821082','IL','1','WILSON','AUGUSTA','','','','34','276485542','822 SATURN DR',0,'TOLEDO','OH','43615','4450','CY','39095','1950-10-11','F','U',':RET:2054-5','N','021','HLT','2205945','92036OH005002605','2014-02-01','2014-01-08 16:25:50','469.00',NULL,NULL,'575.62','106.62','R-OH001','OH0','575.62',NULL,0,'2014-01-13 02:22:35'),(765,632,'Y','18','021','EC','A','','','AC','0000987102','0000987102','TX00000375988','IL','1','Chapin','Carl','','','','34','458253694','11715 SANTA CRUZ DR',0,'AUSTIN','TX','78759','4254','CY','48453','1962-02-22','M','U',NULL,'T','021','DEN','1627992','33348TX002000201','2014-01-01','2013-12-16 11:59:01','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:40'),(23127,18433,'Y','18','021','EC','A','','','AC','0000687258','0000687258','OH00002260827','IL','1','Young','Deborah','','','','34','272564373','1750 Adelaide Blvd.',0,'Akron','OH','44305',NULL,'CY','39153','1954-02-20','F','U',':RET:2106-3','N','021','DEN','3614391','99734OH005000401','2014-03-01','2014-02-12 14:37:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-12 21:31:27'),(1914,1562,'N','01','021','EC','A',NULL,NULL,'','0000828235','0000956654','','IL','1','Schultz','Juli','','','','34','269705217','5865 SQUIREHILL CT',0,'CINCINNATI','OH','45241','6021','CY','39061','1963-08-20','F','',':RET:2106-3','N','021','HLT','1521879','92036OH003001201','2014-01-01','2013-12-24 17:57:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','400.38',NULL,0,'2013-12-25 18:59:26'),(14275,11388,'N','01','021','EC','A',NULL,NULL,'','0000174157','0000346439','','IL','1','ROMINES','RICKY','','','','34','587454998','267 WOODGATE LN',0,'BRANDON','MS','39042','2040','CY','28121','1982-12-06','M','',':RET:2106-3','N','021','DEN','2355292','46300MS002000201','2014-02-01','2013-12-26 15:28:30',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-27 02:06:11'),(21757,17373,'Y','18','024','14','A','','','TE','0000825449','0000825449','','IL','1','PHAM','Mc',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-02-07','M','',NULL,NULL,NULL,'','1418673','','2014-02-20','2014-02-05 23:51:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-06 21:00:24'),(15508,12407,'N','19','021','EC','A',NULL,NULL,'','0000539292','0000827171','','IL','1','cleveland','anna','','','','34','278963083','383 DAY LIGHT LN',0,'POWELL','OH','43065','8213','CY','39041','1993-04-23','F','',':RET:2106-3','N','021','DEN','1522065','99734OH005000401','2014-02-01','2013-12-31 14:43:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:29:54'),(14885,11888,'Y','18','021','EC','A','','','AC','0002349629','0002349629','LA00001438704','IL','1','Williams','Earl','','','','34','438173666','5613 OLD BOYCE RD',0,'BOYCE','LA','71409','9202','CY','22079','1960-08-28','M','M',':RET:2054-5','N','021','DEN','2554408','18575LA002000201','2014-02-01','2013-12-28 18:29:35','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-30 00:00:39'),(15259,12197,'Y','18','021','EC','A','','','AC','0000403668','0000403668','OH00001042296','31','1','Kowalski','Kelly','','','','34','284883337','3829 WILLYS PKWY',0,'TOLEDO','OH','43612','1214','CY','39095','1978-11-18','F','U',NULL,'N','021','HLT','2441276','92036OH001002601','2014-02-01','2013-12-30 12:14:50','28.00',NULL,NULL,'287.41','259.41','R-OH001','OH0','287.41',NULL,0,'2014-01-01 12:09:12'),(20,16,'Y','18','021','EC','A','','','AC','0001074121','0001074121','OH00000206043','IL','1','Singleton','Calvin','M','','Jr','34','301508757','14706 SUPERIOR RD',0,'CLEVELAND HEIGHTS','OH','44118','2112','CY','39035','1955-12-16','M','U',':RET:2054-5','N','021','DEN','340641','99734OH005000401','2014-01-01','2013-12-05 10:55:03','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:15:31'),(21495,17174,'N','19','021','EC','A',NULL,NULL,'','0000639560','0001213498','','IL','1','ON','HOPE','','','','34','664457809','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','2011-08-01','F','',NULL,'N','021','HLT','3733016','92036OH003001204','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-04 21:01:49'),(7733,6125,'Y','18','021','EC','A','','','AC','0000132066','0000132066','OH00000302892','IL','1','BUSH','JUSTIN','','','','34','281900738','2054 SUMMER BANKS DR',0,'GROVE CITY','OH','43123','4861','CY','39049','1984-04-27','M','M',':RET:2106-3','N','021','DEN','2308052','99734OH005000401','2014-01-01','2013-12-20 15:19:29','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:02:04'),(19475,15523,'Y','18','021','EC','A','','','AC','0000213416','0000213416','TX00002086965','IL','1','Castaneda','Jose','','','','34','451498298','1052 RICHARD DR',0,'EL PASO','TX','79907','1510','CY','48141','1970-03-09','M','U',NULL,'T','021','DEN','2513507','33348TX002000201','2014-03-01','2014-01-22 11:40:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-23 03:02:01'),(22264,17770,'Y','18','021','EC','A','','','AC','0000693573','0000693573','TX00001488352','IL','1','Fields','Trevon','','','','34','466690150','2690 ROGERS RD',0,'IOWA PARK','TX','76367','6503','CY','48485','1979-08-23','M','U',':RET:2054-5','N','021','DEN','3031300','33348TX002000201','2014-03-01','2014-01-21 10:31:00','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-10 11:00:09'),(16083,12880,'Y','18','021','EC','A','','','AC','0001050654','0001050654','OH00001978459','IL','1','Guthridge','Mark','V','','','34','282820373','51 GERTRUDE AVE',0,'YOUNGSTOWN','OH','44512','2905','CY','39099','1984-07-02','M','U',':RET:2106-3','N','021','DEN','2034604','99734OH005000401','2014-02-01','2014-01-03 16:17:54','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-04 02:04:10'),(6831,5414,'Y','18','021','EC','A','','','AC','0001173176','0001173176','OH00001071948','IL','1','Cole','Amy','','','','34','294762211','2149 STATE ROUTE 95',0,'EDISON','OH','43320','9759','CY','39117','1976-06-22','F','U',NULL,'T','021','DEN','362699','99734OH005000401','2014-01-01','2013-11-13 23:02:46','0.00',NULL,NULL,'15.78','15.78','R-OH008','OH0','0.00',NULL,0,'2013-12-26 01:30:48'),(6103,4838,'N','01','021','EC','A',NULL,NULL,'','0000926232','0000066212','','IL','1','BREEST','KATHIE','L','','','34','270487172','636 MORRIS DR',0,'VERMILION','OH','44089','2370','CY','39093','1950-09-15','F','',':RET:2106-3','N','021','DEN','789801','99734OH005000401','2014-01-01','2013-11-21 08:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:15:16'),(13963,11129,'Y','18','021','EC','A','','','AC','0000710142','0000710142','OH00000798102','IL','1','Gross','Scarlet','Tannia','','','34','269483435','503 Beamsville Union City Rd',0,'Union City','OH','45390',NULL,'CY','39037','1955-06-12','F','U',':RET:2106-3','T','021','HLT','2306672','92036OH005000505','2014-01-01','2013-12-23 14:31:32','525.00',NULL,NULL,'696.51','171.51','R-OH003','OH0','696.51',NULL,0,'2013-12-26 13:15:11'),(6045,4788,'Y','18','021','EC','A','','','AC','0000721317','0000721317','OH00000132220','IL','1','Heskamp','Joshua','','','','34','129728619','419 Kellyann Ct.',0,'Wadsworth','OH','44281',NULL,'CY','39103','1987-10-22','M','U',':RET:2106-3','N','021','DEN','47175','99734OH005000401','2014-01-01','2013-12-01 13:31:24','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 00:01:31'),(1270,1048,'Y','18','021','EC','A','','','AC','0000574718','0000574718','TX00001195011','IL','1','Cristobal','Gloria','','','','34','460659777','50 HANNAH DR',0,'BROWNSVILLE','TX','78520','9702','CY','48061','1976-03-16','F','M',':RET:2106-3','N','021','DEN','610696','33348TX002000201','2014-01-01','2013-11-29 15:58:18','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-25 18:30:14'),(24661,19576,'Y','18','021','EC','A','','','AC','0000981669','0000981669','OH00002180420','IL','1','Wilson','Jill','','','','34','366620143','807 STANDISH DR',0,'BOWLING GREEN','OH','43402','1228','CY','39173','1952-04-23','F','U',NULL,'T','021','HLT','2921129','92036OH004002601','2014-04-01','2014-02-19 15:53:20','271.00',NULL,NULL,'506.69','235.69','R-OH001','OH0','506.69',NULL,0,'2014-02-20 04:25:16'),(25854,20496,'Y','18','021','EC','A','','','AC','0001189368','0001189368','LA00003166828','IL','1','OSBORNE','GERIC','','','','34','434867011','4032 CHESTNUT ST',0,'MARRERO','LA','70072','4008','CY','22051','1952-04-26','M','U',':RET:2054-5','N','021','DEN','3375491','18575LA002000201','2014-03-01','2014-02-26 09:32:10','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:41'),(27266,21590,'Y','18','021','EC','A','','','AC','0001532891','0001532891','LA00003089188','IL','1','BARBER','BARBARA','V','','','34','436847032','1114 AMERICA ST',0,'MANDEVILLE','LA','70448','4202','CY','22103','1951-01-31','F','U',NULL,'N','021','DEN','3874188','18575LA002000101','2014-04-01','2014-03-04 14:11:23','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-04 21:00:12'),(27302,21619,'Y','18','021','EC','A','','','AC','0000105192','0000105192','TX00003500921','IL','1','STANLEY','MIKE','','','','34','530849525','1007 W 12TH ST',0,'CISCO','TX','76437','3708','CY','48133','1963-07-26','M','M',':RET:2036-2','N','021','DEN','2969629','33348TX002000201','2014-04-01','2014-03-04 13:36:31','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-04 21:00:35'),(18,14,'Y','18','021','EC','A','','','AC','0000125531','0000125531','OH00000393881','IL','1','Dusseau','Donald','Charles','','','34','288441926','4702 Corduroy Rd.',0,'Oregon','OH','43616',NULL,'CY','39095','1955-09-15','M','M',':RET:2106-3','N','021','DEN','289914','99734OH005000401','2014-01-01','2013-12-05 10:30:47','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-25 17:15:27'),(19633,15647,'Y','18','021','EC','A','','','AC','0001144800','0001144800','OH00001523032','IL','1','kennedy','lynn','','','','34','277528425','8078 BRECKSVILLE RD',0,'BRECKSVILLE','OH','44141','1276','CY','39035','1961-03-01','F','U',':RET:2106-3','N','021','DEN','2169929','99734OH005000401','2014-03-01','2014-01-23 10:42:19','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-23 21:00:10'),(9408,7464,'Y','18','021','EC','A','','','AC','0000703531','0000703531','TX00001251060','31','1','Anderson','Diana','','','','34','464924245','6717 WOOD DUCK DR',0,'CORPUS CHRISTI','TX','78413','2331','CY','48355','1957-07-26','F','U',NULL,'N','021','DEN','2564366','33348TX002000201','2014-01-01','2013-12-21 11:24:42','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2013-12-26 04:32:48'),(18331,14637,'Y','18','021','EC','A','','','AC','0000443479','0000443479','OH00001893849','IL','1','ARRIGO','JAMES','V','','','34','287741235','6871 BRECK CT',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1966-02-07','M','M',NULL,'N','021','DEN','2765550','99734OH005000401','2014-02-01','2014-01-15 16:19:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:12'),(758,626,'Y','18','021','EC','A','','','AC','0001167737','0001167737','TX00000482421','31','1','Supak','Pamela','','','','34','456861998','P O Box 6644',0,'Bryan','TX','77805',NULL,'CY','48041','1965-01-20','F','U',':RET:2106-3','N','021','DEN','2057624','33348TX002000201','2014-01-01','2013-12-16 11:10:24','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 18:04:29'),(7523,5954,'Y','18','021','EC','A','','','AC','0000157976','0000157976','OH00001013976','IL','1','Boling','Phillip','','','','34','405782463','188 TRUMAN PARK',0,'BLUE CREEK','OH','45616','9797','CY','39001','1953-10-07','M','M',':RET:2106-3','T','021','HLT','665019','92036OH001000601','2014-01-01','2013-12-14 20:18:25','561.00',NULL,NULL,'808.17','247.17','R-OH005','OH0','808.17',NULL,0,'2013-12-26 02:32:27'),(16272,13028,'Y','18','021','EC','A','','','AC','0001223184','0001223184','OH00000391353','IL','1','BLEKNAP','ERIN','','','','34','543983421','2406 BRIO DR',0,'DAYTON','OH','45424',NULL,'CY','39113','1980-08-09','F','U',':RET:2106-3','N','021','DEN','2048667','99734OH005000401','2014-02-01','2014-01-06 08:38:30','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-07 04:00:18'),(3794,3040,'Y','18','021','EC','A','','','AC','0001142146','0001142146','OH00000910493','IL','1','Gibson','Perry','Allen','','III','34','287529051','2943 Leonards Place',0,'Fremont','OH','43420',NULL,'CY','39143','1952-04-13','M','U',':RET:2106-3','N','021','DEN','807238','99734OH005000301','2014-01-01','2013-12-13 10:55:13','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 21:34:19'),(4501,3568,'Y','18','021','EC','A','','','AC','0001148362','0001148362','TX00000967082','IL','1','Pryor','Patrick','','','','34','147927445','5209 Joe Sayers Avenue',0,'Austin','TX','78756',NULL,'CY','48453','1987-07-24','M','U',NULL,'N','021','DEN','796106','33348TX002000201','2014-01-01','2013-12-11 21:35:38','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 22:03:22'),(5911,4682,'Y','18','021','EC','A','','','AC','0000955090','0000955090','TX00001126535','IL','1','MARACINE','DUMITRU','','','','34','634092861','2522 QUAIL GLEN RD',0,'CARROLLTON','TX','75006','2011','CY','48113','1954-07-26','M','M',':RET:2106-3','N','021','DEN','1996315','33348TX002000101','2014-01-01','2013-12-23 22:08:13','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:02'),(3747,2998,'Y','18','021','EC','A','','','AC','0001030200','0001030200','TX00000152777','IL','1','Walsh','Robert','','','','34','547842274','21520 HORSESHOE LOOP',0,'LAGO VISTA','TX','78645','4743','CY','48453','1950-05-21','M','M',':RET:2106-3','N','021','DEN','238066','33348TX002000201','2014-01-01','2013-12-13 14:47:28','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:33:04'),(5857,4651,'N','01','021','EC','A',NULL,NULL,'','0001040852','0000282015','','IL','1','lawson','alicia','','','','34','285707670','3702 VICTORY AVE',0,'TOLEDO','OH','43607','2214','CY','39095','1970-02-22','F','',':RET:2054-5','N','021','HLT','2603086','92036OH005002601','2014-01-01','2013-12-23 21:07:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','264.60',NULL,0,'2013-12-25 23:48:57'),(24807,19671,'N','01','021','EC','A',NULL,NULL,'','0001126924','0000547931','','IL','1','cheema','navjot','','','','34','095829646','7532 mount whitney',0,'Dayton','OH','45424',NULL,'CY','39113','1986-02-10','F','',':RET:2028-9','N','021','DEN','3430354','99734OH005000401','2014-04-01','2014-02-19 16:54:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:48:56'),(25483,20218,'N','19','021','EC','A',NULL,NULL,'','0000289578','0001062180','','IL','1','Werring','Matthew','W','','','34','299983915','2896 STATE ROUTE 286',0,'WILLIAMSBURG','OH','45176','6527','CY','39015','1996-05-11','M','',':RET:2106-3','N','021','HLT','3367977','92036OH005000601','2014-04-01','2014-02-25 10:39:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2014-02-25 21:31:44'),(27765,21956,'Y','18','021','EC','A','','','AC','0001600451','0001600451','LA00003094062','IL','1','Nguyen','Lieu','Kim','','','34','439530015','1605 APPLEBY LN',0,'HARVEY','LA','70058','6600','CY','22051','1951-07-16','F','M',':RET:2047-9','N','021','DEN','3994172','18575LA002000201','2014-04-01','2014-03-05 13:24:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-05 21:31:23'),(29002,22953,'Y','18','021','EC','A','','','AC','0000114267','0000114267','OH00003110314','IL','1','McElhaney','Brandon','','','','34','285949154','1030 EAGLE DR',0,'AKRON','OH','44312','5849','CY','39153','1991-11-19','M','U',':RET:2106-3','T','021','HLT','3332696','52664OH152000901','2014-04-01','2014-03-09 22:10:55','177.00',NULL,NULL,'187.84','10.84','R-OH012','OH0','187.84',NULL,0,'2014-03-10 21:01:19'),(677,557,'Y','18','021','EC','A','','','AC','0001045667','0001045667','OH00000958437','IL','1','Hemsath','Sharon','','','','34','287621050','14319 VIOLA AVE',0,'CLEVELAND','OH','44111','4357','CY','39035','1959-04-01','F','U',':RET:2106-3','N','021','DEN','1658812','99734OH005000301','2014-01-01','2013-12-16 10:38:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:02:16'),(19071,15193,'Y','18','021','EC','A','','','AC','0000952274','0000952274','MS00001802157','IL','1','January','Robin','Elaine','','','34','427197283','209 LYNDA LEE DR',0,'NATCHEZ','MS','39120','2612','CY','28001','1960-12-27','F','U',':RET:2054-5','N','021','DEN','1432397','46300MS002000101','2014-03-01','2014-01-17 19:33:47','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-21 08:44:20'),(19142,15251,'N','19','021','EC','A',NULL,NULL,'','0000632500','0000584514','','IL','1','AGUIRRE','DENISE','IVETTE','','','34','640200215','13033 PERICO DR',0,'SAN ELIZARIO','TX','79849','9509','CY','48141','1991-01-16','F','',NULL,'N','021','DEN','1877204','33348TX002000201','2014-03-01','2014-01-19 17:22:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-21 08:45:29'),(24643,19560,'Y','18','021','EC','A','','','AC','0001240103','0001240103','LA00002247373','31','1','SILAS','LINDA','','','','34','436299221','PO BOX 1173',0,'COTTONPORT','LA','71327',NULL,'CY','22009','1976-08-27','F','U',NULL,'N','021','DEN','2950258','18575LA002000201','2014-04-01','2014-02-19 12:41:24','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-20 04:20:42'),(27862,22038,'Y','18','021','EC','A','','','AC','0000093908','0000093908','OH00002778238','IL','1','offutt','marlene','','','','34','301944621','4377 W 28th Street',0,'Cleveland','OH','44109',NULL,'CY','39035','1989-02-23','F','U',NULL,'N','021','HLT','3489958','92036OH004000801','2014-04-01','2014-03-05 16:33:45','63.00',NULL,NULL,'188.75','125.75','R-OH011','OH0','188.75',NULL,0,'2014-03-05 21:32:19'),(657,542,'Y','18','021','EC','A','','','AC','0001155091','0001155091','OH00000088750','IL','1','Furlong','Michelle','','','','34','291882920','125 MARYMONT CT',0,'MIDDLETOWN','OH','45042','3755','CY','39017','1976-04-27','F','U',':RET:2106-3','N','021','DEN','594571','99734OH005000301','2014-01-01','2013-12-15 19:09:56','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:46'),(7635,6044,'Y','18','021','EC','A','','','AC','0000271387','0000271387','OH00000682934','IL','1','Wisneski','Tina','','','','34','286704500','505 Gilpin dr.',0,'Springboro','OH','45066',NULL,'CY','39165','1961-12-18','F','U',NULL,'N','021','HLT','1146013','92036OH004001201','2014-01-01','2013-10-13 20:36:44','334.47',NULL,NULL,'336.93','2.46','R-OH004','OH0','336.93',NULL,0,'2013-12-26 02:46:23'),(5510,4373,'N','19','021','EC','A',NULL,NULL,'','0001207117','0000021353','','IL','1','Stamp','Noah','Tyler','','','34','283065667','11818 Hidden Lake Dr.',0,'Marshallville','OH','44645',NULL,'CY','39169','2001-06-18','M','',':RET:2106-3','N','021','DEN','1073474','99734OH005000301','2014-01-01','2013-11-26 18:22:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:07'),(2298,1871,'N','01','021','EC','A',NULL,NULL,'','0001151056','0000253023','','31','1','Coolidge','Robin','Dale','','Jr','34','285723274','4640 WYANDOTTE DR',0,'COLUMBUS','OH','43230','1258','CY','39049','1963-04-07','M','',':RET:2106-3','N','021','DEN','856432','99734OH005000301','2014-01-01','2013-12-09 16:23:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:55'),(4545,3602,'Y','18','021','EC','A','','','AC','0001145947','0001145947','OH00000379694','31','1','HOEFLER','WILLIAM','','','','34','290486779','pobox 214',0,'Tipp City','OH','45371',NULL,'CY','39109','1949-10-19','M','U',':RET:2106-3','T','021','HLT','558764','92036OH006000501','2014-01-01','2013-12-11 18:54:37','572.00',NULL,NULL,'650.37','78.37','R-OH003','OH0','650.37',NULL,0,'2013-12-25 22:04:24'),(19847,15829,'Y','18','024','14','A','','','TE','0000198831','0000198831','','IL','1','Brown','Keith',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-11-17','M','',NULL,NULL,NULL,'','1025624','','2014-01-24','2014-01-24 10:42:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-24 21:00:29'),(19731,15724,'Y','18','021','EC','A','','','AC','0002277343','0002277343','LA00001367255','IL','1','SIMON','STACY','','','','34','433679782','6541 MERRICK ST',0,'MANSURA','LA','71350','4509','CY','22009','1983-06-05','F','U',':RET:2054-5','T','021','DEN','1892234','18575LA002000201','2014-03-01','2014-01-23 16:44:12','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-23 21:01:05'),(25494,20224,'Y','18','021','EC','A','','','AC','0001073203','0001073203','OH00001458345','IL','1','Rose','Ronald','','','','34','272644914','6366 TOWNSHIP ROAD 96',0,'MC COMB','OH','45858','9452','CY','39063','1959-05-22','M','U',':RET:2106-3','N','021','HLT','3200463','92036OH003001505','2014-04-01','2014-02-24 21:28:25','425.00',NULL,NULL,'490.70','65.70','R-OH002','OH0','490.70',NULL,0,'2014-02-25 21:31:49'),(28082,22225,'Y','18','021','EC','A','','','AC','0000524344','0000524344','TX00003285297','IL','1','WALLACE','CYNTHIA','','','','34','466379748','19472 FM 850',0,'ARP','TX','75750',NULL,'CY','48423','1961-02-24','F','M',':RET:2054-5','T','021','DEN','3760085','33348TX002000101','2014-04-01','2014-03-06 14:45:19','0.00',NULL,NULL,'50.04','50.04','R-TX022','TX0','25.02',NULL,0,'2014-03-06 21:01:58'),(7820,6195,'Y','18','021','EC','A','','','AC','0000029449','0000029449','TX00001008258','IL','1','Luckey','Gary','','','','34','493888526','121 N FAULKNER ST',0,'PAMPA','TX','79065','6114','CY','48179','1968-03-22','M','M',':RET:2106-3','N','021','DEN','2079738','33348TX002000201','2014-01-01','2013-12-20 18:24:59','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:04:10'),(23774,18917,'Y','18','021','EC','A','','','AC','0000162387','0000162387','MS00001934237','31','1','ODOM','GLORIA','','','','34','425159483','PO Box 68278',0,'Jackson','MS','39286',NULL,'CY','28049','1959-10-17','F','U',NULL,'N','021','DEN','3780269','46300MS002000201','2014-03-01','2014-02-13 18:45:48','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-14 21:31:15'),(1858,1521,'N','19','021','EC','A',NULL,NULL,'','0000205787','0000987404','','S3','1','Biggs','Robert','Wayne','','','34','297085228','148 MORRISON AVE',0,'CUYAHOGA FALLS','OH','44221','2127','CY','39153','2004-04-21','F','',':RET:2106-3','N','021','HLT','1628559','52664OH152000901','2014-01-01','2013-12-24 10:41:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 18:58:06'),(23574,18782,'Y','18','021','EC','A','','','AC','0001125480','0001125480','OH00001633429','IL','1','Mohr','Jamie','','','','34','300823824','4760 Co. Rd. 3',0,'Swanton','OH','43558',NULL,'CY','39051','1971-07-07','F','M',':RET:2106-3','N','021','HLT','3098417','92036OH003002605','2014-03-01','2014-02-13 14:37:07','378.00',NULL,NULL,'554.30','176.30','R-OH001','OH0','269.82',NULL,0,'2014-02-13 22:02:53'),(7517,5948,'Y','18','021','EC','A','','','AC','0000711968','0000711968','LA00000293748','IL','1','Meche','Janie','A','','','34','433314297','219 4TH ST',0,'ABBEVILLE','LA','70510','6649','CY','22113','1962-06-06','F','M',':RET:2106-3','N','021','DEN','573028','18575LA002000201','2014-01-01','2013-12-15 13:25:52','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-26 02:32:16'),(19866,15846,'Y','18','021','EC','A','','','AC','0000362523','0000362523','OH00001597845','IL','1','JACKSON','MELODY','J','','','34','284668834','9100 BLUE CREEK RD',0,'BLUE CREEK','OH','45616','9045','CY','39001','1958-05-01','F','M',':RET:2106-3','N','021','DEN','2709054','99734OH005000401','2014-03-01','2014-01-24 12:14:19','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-24 21:00:38'),(6741,5347,'N','01','021','EC','A',NULL,NULL,'','0001171852','0000609501','','IL','1','Vestal','Emily','A','','','34','276745616','645 Senn Drive',0,'Tallmadge','OH','44278',NULL,'CY','39153','1962-10-09','F','',':RET:2106-3','N','021','HLT','862829','52664OH151001306','2014-01-01','2013-11-25 11:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2013-12-26 01:15:47'),(17505,13996,'N','19','021','EC','A',NULL,NULL,'','0000530709','0000616886','','IL','1','Lampert','Nicholas','','','','34','273048380','7291 Lauren J Drive',0,'Mentor','OH','44060',NULL,'CY','39085','1998-12-30','M','',':RET:2106-3','N','021','HLT','1596454','52664OH151001501','2014-02-01','2014-01-11 19:22:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','191.55',NULL,0,'2014-01-13 03:01:27'),(13990,11145,'Y','18','024','14','A','','','TE','0000581489','0000581489','','IL','1','Day','Kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-12-31','M','',NULL,NULL,NULL,'','1632211','','2013-12-23','2013-12-23 13:13:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:15:46'),(9612,7612,'N','01','021','EC','A',NULL,NULL,'','0000258145','0000249120','','IL','1','Riffle','Barbara','C','','','34','320501943','2318 Killian Rd',0,'Akron','OH','44312',NULL,'CY','39153','1953-08-22','F','',NULL,'N','021','HLT','2525711','52664OH151001301','2014-01-01','2013-12-21 16:35:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','605.24',NULL,0,'2013-12-26 04:37:40'),(5790,4598,'Y','18','021','EC','A','','','AC','0000762296','0000762296','OH00000006849','IL','1','feyisa','teferi','','','','34','365356649','1095 irongate ln',0,'columbus','OH','43213',NULL,'CY','39049','1975-07-19','M','U',':RET:2054-5','N','021','DEN','2010743','99734OH005000401','2014-01-01','2013-12-24 00:26:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:47:14'),(3143,2527,'Y','18','021','EC','A','','','AC','0000635791','0000635791','TX00000964322','IL','1','Craig','Andrew','Ryan','','','34','645054881','140 PRIDDY LN',0,'FORT WORTH','TX','76114','3911','CY','48439','1987-11-08','M','U',NULL,'N','021','DEN','145319','33348TX002000201','2014-01-01','2013-11-18 08:44:10','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:30:50'),(3442,2767,'Y','18','021','EC','A','','','AC','0000151970','0000151970','OH00000892725','IL','1','MCMANN','FAYE','','','','34','281587650','2874 Kent Road',0,'Silver Lake','OH','44224',NULL,'CY','39153','1958-05-24','F','U',':RET:2106-3','N','021','DEN','1994916','99734OH005000401','2014-01-01','2013-12-21 19:41:10','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:19:15'),(1915,1563,'Y','18','021','EC','A','','','AC','0000114156','0000114156','OH00000382107','IL','1','zarebi','vickie','','','','34','275788991','7714 MIDDLETOWN RD',0,'GALION','OH','44833','9717','CY','39033','1967-05-12','F','M',':RET:2106-3','N','021','DEN','81513','99734OH005000301','2014-01-01','2013-11-19 18:15:28','0.00',NULL,NULL,'21.13','21.13','R-OH007','OH0','0.00',NULL,0,'2013-12-25 19:00:03'),(24716,19625,'Y','18','021','EC','A','','','AC','0000089877','0000089877','OH00002764978','IL','1','Phillips','Rhonda','','','','34','284689766','2739 TownTerrace',0,'Cincinnati','OH','45251',NULL,'CY','39061','1963-01-29','F','U',':RET:2054-5','N','021','DEN','3187442','99734OH005000401','2014-04-01','2014-02-19 00:11:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-20 04:36:51'),(25664,20360,'N','01','021','EC','A',NULL,NULL,'','0001298660','0002171666','','IL','1','ZULETA','CATALINA','','','','34','886365862','3102 GRASSY LAKE DR',0,'BATON ROUGE','LA','70816','3770','CY','22033','1959-12-02','F','',NULL,'N','021','DEN','3355227','18575LA002000101','2014-04-01','2014-02-21 19:55:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-26 08:30:47'),(29192,23104,'Y','18','021','EC','A','','','AC','0001282489','0001282489','LA00002838438','IL','1','Osburn','Sheila','M','','','34','433374086','44292 DOC HYDE RD',0,'PONCHATOULA','LA','70454','5657','CY','22105','1967-02-21','F','M',':RET:2106-3','N','021','DEN','4204357','18575LA002000201','2014-04-01','2014-03-10 10:56:50','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61','CIC',0,'2014-03-10 21:30:06'),(9170,7273,'Y','18','024','14','A','','','TE','0000451237','0000451237','','IL','1','MILLS','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-07-11','M','',NULL,NULL,NULL,'','136146','','2013-12-18','2013-12-18 08:52:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:08:54'),(5535,4391,'Y','18','021','EC','A','','','AC','0001020383','0001020383','OH00000409732','IL','1','chan','winnie','','','','34','095447949','5690 ironwood ct',0,'columbus','OH','43229',NULL,'CY','39049','1949-06-21','F','R',':RET:2034-7','T','021','DEN','65290','99734OH005000401','2014-01-01','2013-11-27 14:39:20','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:15:41'),(4861,3852,'Y','18','021','EC','A','','','AC','0001167674','0001167674','TX00000496815','IL','1','Bowie','Karen','','','','34','643019275','1215 INDIAN PAINT TRL',0,'LEWISVILLE','TX','75067','5537','CY','48121','1988-08-21','F','U',':RET:2054-5','N','021','DEN','6253','33348TX002000101','2014-01-01','2013-11-08 12:39:24','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 22:30:40'),(9489,7525,'N','01','021','EC','A',NULL,NULL,'','0000162263','0000177630','','IL','1','Stregl','Debra','K','','','34','103564740','7817 Hidden Hollow Dr',0,'Mentor','OH','44060',NULL,'CY','39085','1959-04-03','F','',':RET:2106-3','T','021','DEN','1639610','99734OH005000401','2014-01-01','2013-12-21 13:14:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:34:51'),(13754,10978,'Y','18','021','EC','A','','','AC','0000323782','0000323782','MS00000327224','IL','1','Bell-Madison','Sophia','','','','34','426617347','6017 Samantha dr',0,'Jackson','MS','39209',NULL,'CY','28049','1976-09-10','F','M',':RET:2054-5','N','021','DEN','2539547','46300MS002000201','2014-01-01','2013-12-22 20:08:20','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 13:10:01'),(14044,11189,'Y','18','021','EC','A','','','AC','0000268911','0000268911','OH00001460751','IL','1','Little','Robert','','','','34','268644708','70 Bent Tree Dr',0,'Fairfield','OH','45014',NULL,'CY','39017','1963-09-11','M','U',':RET:2106-3','N','021','DEN','1924031','99734OH005000301','2014-02-01','2013-12-25 20:06:29','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:00:06'),(17183,13749,'Y','18','021','EC','A','','','AC','0000939795','0000939795','OH00002018846','IL','1','NEILSEN','JAMES','','','','34','287480512','2595 JEFFERSON PL',0,'STOW','OH','44224',NULL,'CY','39153','1949-10-04','M','U',NULL,'N','021','DEN','2148963','99734OH005000301','2014-02-01','2014-01-08 15:59:43','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-01-13 02:22:14'),(24625,19544,'Y','18','021','EC','A','','','AC','0001585065','0001585065','LA00001675697','IL','1','GALMON','RICARDO','','','','34','435736617','1366 GUY RD',0,'GREENSBURG','LA','70441','4610','CY','22091','1989-02-01','M','U',NULL,'T','021','DEN','3674870','18575LA002000201','2014-04-01','2014-02-18 18:33:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:17:00'),(29171,23089,'Y','18','021','EC','A','','','AC','0000971526','0000971526','OH00003106208','IL','1','Bann','Christopher','','','','34','548850247','11 WATER ST',0,'YOUNGSTOWN','OH','44514','1758','CY','39099','1980-08-09','M','R',':RET:1002-5','N','021','HLT','4219067','52664OH151001501','2014-04-01','2014-03-10 15:32:10','0.00',NULL,NULL,'363.37','363.37','R-OH013','OH0','363.37',NULL,0,'2014-03-10 21:02:59'),(478,390,'Y','18','021','EC','A','','','AC','0000148166','0000148166','LA00000049910','IL','1','Kheel','Claudia','','','','34','110386781','221 ANGELA ST',0,'ARABI','LA','70032','1003','CY','22087','1956-11-24','F','U',':RET:2106-3','N','021','DEN','984622','18575LA002000201','2014-01-01','2013-12-03 20:46:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 17:48:04'),(1613,1348,'Y','18','021','EC','A','','','AC','0000421581','0000421581','TX00001007356','IL','1','Padron','Maria','','','','34','459177903','2099 HIGHWAY 80',0,'KARNES CITY','TX','78118','6225','CY','48255','1955-07-02','F','M',NULL,'N','021','DEN','1790979','33348TX002000201','2014-01-01','2013-12-24 13:08:21','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:52:22'),(8016,6345,'Y','18','021','EC','A','','','AC','0001135160','0001135160','OH00000005524','IL','1','mckean','william','','','','34','202629797','1215 bentonville rd',0,'west union','OH','45693',NULL,'CY','39001','1980-12-21','F','M',':RET:2106-3','N','021','HLT','1492107','92036OH006000601','2014-01-01','2013-12-19 23:01:21','0.00',NULL,NULL,'203.95','203.95','R-OH005','OH0','203.95',NULL,0,'2013-12-26 03:08:47'),(21200,16940,'N','19','021','EC','A',NULL,NULL,'','0000523443','0000300445','','IL','1','Newell','Jessica','Erin','','','34','294926616','12970 HARLON AVE',0,'LAKEWOOD','OH','44107','2812','CY','39035','1990-10-03','F','',':RET:2106-3','N','021','HLT','3593362','92036OH005000801','2014-03-01','2014-02-02 23:41:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','233.79',NULL,0,'2014-02-03 21:00:52'),(19668,15673,'Y','18','021','EC','A','','','AC','0002025400','0002025400','LA00001608593','IL','1','Sandlin','James','','','','34','569370261','139 PRINCETON LN E',0,'PRINCETON','LA','71067','8390','CY','22015','1969-02-07','M','U',':RET:2106-3','N','021','DEN','2350005','18575LA002000101','2014-03-01','2014-01-23 12:56:39','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-23 21:00:29'),(24550,19499,'N','19','021','EC','A',NULL,NULL,'','0000009892','0000438022','','IL','1','Mahone','William','Benjamin','','','34','259873348','3378 Whitebeech Lane',0,'Youngstown','OH','44511',NULL,'CY','39099','1993-09-02','M','',':RET:2054-5','N','021','HLT','3026681','52664OH151001305','2014-04-01','2014-02-19 15:59:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','160.59',NULL,0,'2014-02-20 04:04:09'),(26745,21195,'N','19','021','EC','A',NULL,NULL,'','0000992728','0000828299','','IL','1','Supe','Tyler','','','','34','297116485','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2006-05-18','M','',':RET:2106-3','N','021','HLT','3540690','92036OH003001205','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2014-02-28 21:31:56'),(27040,21416,'Y','18','021','EC','A','','','AC','0002253953','0002253953','LA00003645012','IL','1','Bradford','anna','','','','34','435533621','134 FOUNTAIN DR',0,'SLIDELL','LA','70458','1559','CY','22103','1975-04-26','F','U',':RET:2106-3','N','021','DEN','3705898','18575LA002000201','2014-04-01','2014-03-03 11:17:41','0.00',NULL,NULL,'52.83','52.83','R-LA001','LA0','14.61','CIC',0,'2014-03-03 21:00:21'),(2254,1848,'N','19','021','EC','A',NULL,NULL,'','0000385874','0000910497','','IL','1','MESONES','SANDRA','C','','','34','276028098','8717 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','1990-02-14','F','',':RET:2106-3','N','021','DEN','688704','99734OH005000301','2014-01-01','2013-12-08 19:49:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:08'),(24062,19134,'N','01','021','EC','A',NULL,NULL,'','0000270061','0000981664','','IL','1','phifer','alan','','','','34','297764727','2400 SAYBROOK RD',0,'UNIVERSITY HEIGHTS','OH','44118','3702','CY','39035','1967-01-22','M','',NULL,'N','021','DEN','3367779','99734OH005000301','2014-03-01','2014-02-15 14:05:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:09'),(7892,6241,'Y','18','021','EC','A','','','AC','0001158907','0001158907','OH00000316438','IL','1','Robinson','Brenda','','','','34','429117600','195 W ROSEWOOD AVE',0,'DEFIANCE','OH','43512','3448','CY','39039','1956-06-03','F','U',':RET:2054-5','N','021','HLT','1814228','92036OH005002605','2014-01-01','2013-12-20 15:02:48','407.00',NULL,NULL,'475.21','68.21','R-OH001','OH0','475.21',NULL,0,'2013-12-26 03:05:38'),(6437,5105,'Y','18','021','EC','A','','','AC','0000292875','0000292875','LA00000997434','IL','1','Rode','Paul','','','','34','548136879','604 Shady Lane',0,'Sulphur','LA','70663',NULL,'CY','22019','1957-04-17','M','U',':RET:2106-3','N','021','DEN','18760','18575LA002000201','2014-01-01','2013-12-11 16:28:49','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 00:49:20'),(18731,14927,'N','19','021','EC','A',NULL,NULL,'','0000253078','0001071804','','S1','1','Winters','Camden',NULL,NULL,NULL,NULL,NULL,'6282 E US HIGHWAY 36',0,'CABLE','OH','43009','9625','CY','39021','2009-02-05','F','',':RET:2106-3','N','021','DEN','2107235','99734OH005000301','2014-03-01','2014-01-16 00:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:37'),(14166,11293,'Y','18','021','EC','A','','','AC','0001376650','0001376650','LA00001600777','IL','1','HYMEL','BARBRA','','','','34','433868631','423 FOCIS ST',0,'METAIRIE','LA','70005','3435','CY','22051','1949-10-21','F','U',':RET:2106-3','N','021','DEN','2283363','18575LA002000201','2014-02-01','2013-12-26 17:21:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-27 02:03:18'),(16027,12830,'Y','18','021','EC','A','','','AC','0002172763','0002172763','LA00000688173','IL','1','TURNER','LARRY','','','','34','435176680','3416 EVERGREEN DR',0,'ALEXANDRIA','LA','71302','3311','CY','22079','1958-12-01','M','M',':RET:2054-5','N','021','DEN','2137652','18575LA002000201','2014-02-01','2014-01-03 10:56:56','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-04 02:02:20'),(16729,13389,'Y','18','021','EC','A','','','AC','0000303382','0000303382','OH00002208023','IL','1','CHEATHAM','LATOYA','','','','34','275901991','742 ROSLYN AVE',0,'AKRON','OH','44320','1848','CY','39153','1983-04-06','F','U',':RET:2054-5','N','021','HLT','1661015','52664OH151001305','2014-02-01','2014-01-07 16:43:40','145.00',NULL,NULL,'253.11','108.11','R-OH012','OH0','253.11',NULL,0,'2014-01-08 18:24:49'),(25939,20570,'Y','18','021','EC','A','','','AC','0000470805','0000470805','TX00002927771','IL','1','Ayers','Billy','Floyd','','','34','451173296','4011 City St.',0,'Caldwell','TX','77836',NULL,'CY','48051','1954-03-09','M','M',':RET:2054-5','N','021','DEN','2659110','33348TX002000201','2014-04-01','2014-02-26 17:23:38','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-26 21:01:30'),(24073,19145,'Y','18','021','EC','A','','','AC','0000368594','0000368594','OH00002018632','IL','1','Vaughan','Barbara','','','','34','283528782','782 Orchard St',0,'Wadsworth','OH','44281',NULL,'CY','39103','1952-05-21','F','U',':RET:2106-3','N','021','HLT','3418957','52664OH151001305','2014-03-01','2014-02-14 19:07:21','493.00',NULL,NULL,'626.65','133.65','R-OH012','OH0','626.65',NULL,0,'2014-02-15 22:01:18'),(890,737,'Y','18','021','EC','A','','','AC','0000298203','0000298203','OH00001147267','IL','1','Hoskins','William','','','','34','281646535','1704 Frazier Rd',0,'Midland','OH','45148',NULL,'CY','39027','1958-02-03','M','U',':RET:2106-3','N','021','HLT','2585906','92036OH002000601','2014-01-01','2013-12-16 14:24:16','260.00',NULL,NULL,'552.84','292.84','R-OH005','OH0','552.84',NULL,0,'2013-12-25 18:07:58'),(22379,17872,'Y','18','021','EC','A','','','AC','0000828277','0000828277','OH00002286977','IL','1','Warnick','Karen','','','','34','268524886','1336 TREASCH DR',0,'CUYAHOGA FALLS','OH','44221','5247','CY','39153','1955-12-01','F','U',NULL,'N','021','HLT','2792252','52664OH151001305','2014-03-01','2014-02-10 09:16:10','441.00',NULL,NULL,'568.22','127.22','R-OH012','OH0','568.22',NULL,0,'2014-02-10 21:30:08'),(19366,15437,'Y','18','021','EC','A','','','AC','0000009871','0000009871','OH00002080465','IL','1','Catsoulakis','Lisa','','','','34','282722869','742 CLIFFSIDE DR',0,'AKRON','OH','44313','5657','CY','39153','1964-09-07','F','U',':RET:2106-3','N','021','HLT','3050700','52664OH151001306','2014-03-01','2014-01-21 13:56:00','290.00',NULL,NULL,'380.45','90.45','R-OH012','OH0','380.45',NULL,1,'2014-01-22 03:22:33'),(19267,15356,'Y','18','021','EC','A','','','AC','0000001062','0000001062','OH00001798093','IL','1','Crouch','Vera','','','','34','302620431','338 OCONNELL ST',0,'TOLEDO','OH','43608','1027','CY','39095','1958-06-01','F','M',':RET:2106-3','N','021','HLT','2713704','92036OH006002601','2014-03-01','2014-01-19 20:45:44','631.00',NULL,NULL,'721.73','90.73','R-OH001','OH0','344.86',NULL,0,'2014-01-21 08:46:52'),(16404,13126,'Y','18','021','EC','A','','','AC','0000769605','0000769605','TX00001842462','IL','1','Juarez','Emilio','','','','34','449379805','1106 PASEO DE DANUBIO',0,'RIO BRAVO','TX','78046','7647','CY','48479','1956-01-19','M','U',NULL,'N','021','DEN','1816917','33348TX002000201','2014-02-01','2014-01-05 21:04:06','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-01-07 04:04:00'),(17985,14372,'Y','18','021','EC','A','','','AC','0000282035','0000282035','OH00001551701','IL','1','WEST','MARK','','','','34','278546382','148 TIMOTHY DR',0,'TALLMADGE','OH','44278','2561','CY','39153','1954-01-14','M','U',':RET:2106-3','T','021','HLT','2744853','52664OH151001305','2014-02-01','2014-01-14 16:47:15','441.00',NULL,NULL,'696.03','255.03','R-OH012','OH0','696.03',NULL,0,'2014-01-15 02:06:54'),(18149,14493,'Y','18','021','EC','A','','','AC','0001455028','0001455028','LA00002114013','IL','1','George','Donald','','','','34','438252045','P.O. Box 541',0,'Springfield','LA','70462',NULL,'CY','22063','1967-05-15','M','U',':RET:1002-5^:RET:2054-5','T','021','DEN','2512135','18575LA002000101','2014-02-01','2014-01-14 16:52:41','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-15 02:07:49'),(28157,22281,'Y','18','021','EC','A','','','AC','0000710206','0000710206','OH00002641204','IL','1','Haas','Jodi',NULL,NULL,NULL,NULL,NULL,'10517 RIVER OAKS DR',0,'PERRYSBURG','OH','43551','1694','CY','39173','1968-03-10','F','U',':RET:2106-3','N','021','HLT','3919512','92036OH005002606','2014-04-01','2014-03-06 15:53:24','220.00',NULL,NULL,'292.49','72.49','R-OH001','OH0','292.49',NULL,0,'2014-03-06 21:02:39'),(28395,22465,'Y','18','021','EC','A','','','AC','0000116644','0000116644','OH00002625463','IL','1','Morrow','Eric','','','','34','297927662','2551 SANDBURY BLVD',0,'COLUMBUS','OH','43235','1871','CY','39049','1990-12-06','M','U',':RET:2106-3','T','021','DEN','3601502','99734OH005000401','2014-04-01','2014-03-06 18:36:15','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-07 21:30:46'),(1362,1128,'Y','18','024','14','A','','','TE','0000976419','0000976419','','IL','1','Dang','Mikal',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-06','M','',NULL,NULL,NULL,'','1656544','','2013-12-24','2013-12-24 14:30:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:45:32'),(22662,18096,'Y','18','021','EC','A','','','AC','0000393503','0000393503','TX00002270432','IL','1','Hamblin','Steven','','','','34','464931204','505 S HOLMAN ST',0,'SEYMOUR','TX','76380','3122','CY','48023','1982-12-08','M','M',':RET:2106-3','T','021','DEN','3797026','33348TX002000201','2014-03-01','2014-02-11 13:21:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:35'),(7654,6061,'Y','18','021','EC','A','','','AC','0001735358','0001735358','LA00000956418','31','1','Patterson','Jessica','','','','34','439698997','9283 SAMOA AVE',0,'BATON ROUGE','LA','70810','1164','CY','22063','1987-04-16','F','U',NULL,'N','021','DEN','2250176','18575LA002000101','2014-01-01','2013-12-19 19:31:06','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:05'),(21080,16845,'Y','18','021','EC','A','','','AC','0000769712','0000769712','TX00001540907','IL','1','Rush','Joel','','','','34','460045281','14279 PECAN LN',0,'FORNEY','TX','75126','6842','CY','48257','1955-12-19','M','M',':RET:2106-3','N','021','DEN','3607799','33348TX002000101','2014-03-01','2014-02-02 17:02:03','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-02 19:00:21'),(1637,1367,'Y','18','021','EC','A','','','AC','0000511503','0000511503','TX00001261574','IL','1','genac','david','','','','34','387626249','950 W 22ND ST',0,'HOUSTON','TX','77008','1802','CY','48201','1964-02-01','M','R',':RET:2106-3','N','021','DEN','2581291','33348TX002000201','2014-01-01','2013-12-24 15:16:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:52:58'),(18554,14796,'Y','18','021','EC','A','','','AC','0001063270','0001063270','OH00001944298','IL','1','Fritz','Megan','','','','34','280880493','18477 COUNTY ROAD G1',0,'HOLGATE','OH','43527','9528','CY','39069','1988-01-14','F','M',NULL,'N','021','HLT','2366262','92036OH005002601','2014-02-01','2014-01-14 22:06:19','0.00',NULL,NULL,'199.67','199.67','R-OH001','OH0','199.67',NULL,0,'2014-01-16 08:46:55'),(15813,12658,'Y','18','021','EC','A','','','AC','0001417281','0001417281','LA00000181558','IL','1','Griggs','Elnora','','','','34','227744964','113 PEACH ST',0,'RIDGECREST','LA','71334','3635','CY','22029','1949-09-03','F','U',':RET:2054-5','N','021','DEN','1805005','18575LA002000201','2014-02-01','2014-01-02 17:37:36','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-03 02:03:15'),(14968,11963,'Y','18','021','EC','A','','','AC','0000228213','0000228213','TX00001030682','IL','1','Austin','James','','','','34','462477293','1602 Ten Mile Lane',0,'Duncanville','TX','75137',NULL,'CY','48113','1973-05-16','M','U',':RET:2039-6','N','021','DEN','2057056','33348TX002000201','2014-02-01','2013-12-30 11:46:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-01 12:00:41'),(13736,10963,'Y','18','024','14','A','','','TE','0001249587','0001249587','','IL','1','Smith','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-06','F','',NULL,NULL,NULL,'','1769990','','2013-12-23','2013-12-23 18:30:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:32'),(2182,1794,'Y','18','021','EC','A','','','AC','0000539662','0000539662','TX00000703196','IL','1','Buckley','Adam','','','','34','461816895','127 South G Street',0,'Kerrville','TX','78028',NULL,'CY','48265','1987-03-02','M','U',':RET:2106-3','N','021','DEN','1241935','33348TX002000101','2014-01-01','2013-12-09 21:33:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 19:19:27'),(6135,4865,'Y','18','021','EC','A','','','AC','0000588228','0000588228','LA00000671848','IL','1','Dupont','Sheila','','','','34','439495717','1163 BEL OIL RD',0,'ELTON','LA','70532','5412','CY','22003','1981-01-04','F','U',':RET:2106-3','N','021','DEN','270531','18575LA002000201','2014-01-01','2013-11-21 09:10:24','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 00:16:06'),(4278,3408,'Y','18','021','EC','A','','','AC','0000506950','0000506950','OH00000660726','IL','1','kramer','vicki','','','','34','291509823','10990 dutch rd',0,'delphos','OH','45833',NULL,'CY','39003','1951-04-02','F','M',':RET:2106-3','N','021','HLT','2396398','92036OH005001501','2014-01-01','2013-12-16 21:05:40','201.00',NULL,NULL,'632.30','431.30','R-OH002','OH0','632.30',NULL,0,'2013-12-25 21:51:57'),(24516,19475,'Y','18','021','EC','A','','','AC','0000212164','0000212164','TX00002098829','IL','1','Santos','Marnie','','','','34','258730056','1026 HIGHLAND AVE',0,'ABILENE','TX','79605','3212','CY','48441','1973-01-22','F','U',':RET:2106-3','N','021','DEN','2635073','33348TX002000201','2014-04-01','2014-02-19 12:35:11','0.00',NULL,NULL,'14.61','14.61','R-TX001','TX0','14.61',NULL,0,'2014-02-20 03:55:08'),(24990,19820,'Y','18','021','EC','A','','','AC','0000746962','0000746962','TX00001786414','IL','1','LIU','SHUFEN','','','','34','642112575','7623 TUSSENDO DR',0,'HOUSTON','TX','77083','3452','CY','48201','1966-02-20','F','M',':RET:2034-7','N','021','DEN','2807435','33348TX002000201','2014-04-01','2014-02-20 14:05:02','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-20 22:00:39'),(27075,21437,'N','19','021','EC','A',NULL,NULL,'','0000671758','0000084108','','IL','1','allen','ashlyn','','','','34','289049235','1230 BYE ST',0,'AKRON','OH','44320','1902','CY','39153','1999-11-19','F','',':RET:2054-5','N','021','HLT','3721635','52664OH152000901','2014-04-01','2014-03-02 19:29:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-03 21:30:08'),(27687,21896,'N','01','021','EC','A',NULL,NULL,'','0000018083','0000587323','','IL','1','Cunningham','Joseph','William','','','34','450082988','113 Melba',0,'Longview','TX','75602',NULL,'CY','48183','1956-06-21','M','',':RET:2106-3','N','021','DEN','4037892','33348TX002000201','2014-04-01','2014-03-05 05:05:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:42'),(4802,3806,'Y','18','021','EC','A','','','AC','0000565608','0000565608','LA00000803658','31','1','Turner','Michelle','Sanders','','','34','433417719','P.O. Box 8532',0,'Clinton','LA','70722',NULL,'CY','22037','1970-09-05','F','M',':RET:2054-5','N','021','DEN','299376','18575LA002000201','2014-01-01','2013-12-08 10:22:03','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:16:32'),(4988,3959,'N','01','021','EC','A',NULL,NULL,'','0000136048','0000221259','','IL','1','Miller','Terrell','','','Sr','34','269723581','352 Enos Loomis st',0,'Pataskala','OH','43062',NULL,'CY','39089','1973-08-03','M','',NULL,'N','021','DEN','667559','99734OH005000301','2014-01-01','2013-12-06 19:55:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:46:53'),(9047,7177,'N','19','021','EC','A',NULL,NULL,'','0000168879','0000807484','','IL','1','Yokie','Myrissa','Annette','','','34','285941790','7155 CHAPEL RD',0,'MADISON','OH','44057','2240','CY','39085','1991-11-11','F','',NULL,'N','021','HLT','2472454','52664OH151001306','2014-01-01','2013-12-18 16:30:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2013-12-26 04:05:57'),(17246,13800,'Y','18','021','EC','A','','','AC','0000910543','0000910543','OH00002321112','IL','1','Berger','Duane','','','','34','287548093','4494 State Route 133',0,'Batavia','OH','45103',NULL,'CY','39025','1954-12-10','M','M',NULL,'N','021','HLT','1858102','92036OH006000601','2014-02-01','2014-01-08 16:01:25','370.00',NULL,NULL,'443.16','73.16','R-OH005','OH0','443.16',NULL,0,'2014-01-13 02:22:48'),(18273,14588,'Y','18','024','14','A','','','TE','0000972370','0000972370','','IL','1','Fuentes','Guillermo',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-03-21','M','',NULL,NULL,NULL,'','1406039','','2014-01-15','2014-01-15 17:30:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-16 08:44:42'),(18129,14478,'N','19','021','EC','A',NULL,NULL,'','0000073961','0000125577','','IL','1','Ker','Heather','Renae','','','34','280981847','423 SANDRA DR',0,'OXFORD','OH','45056','2542','CY','39017','1995-03-22','F','',':RET:2106-3','N','021','HLT','2576820','92036OH004001201','2014-02-01','2014-01-14 14:56:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-15 02:07:43'),(28470,22528,'N','01','021','EC','A',NULL,NULL,'','0000946174','0001159000','','IL','1','Hu','Mei','','','','34','104884805','7922 ALBRITTON PL',0,'WEST CHESTER','OH','45069','2057','CY','39017','1957-06-25','F','',':RET:2034-7','N','021','DEN','3481385','99734OH005000301','2014-04-01','2014-03-07 00:45:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-07 21:31:31'),(2853,2306,'Y','18','021','EC','A','','','AC','0000464419','0000464419','LA00000419097','IL','1','linson','james','','','','34','435794429','8235 GREENWELL SPRINGS RD',0,'BATON ROUGE','LA','70814','2224','CY','22033','1990-06-20','M','U',':RET:2054-5','N','021','DEN','1095356','18575LA002000201','2014-01-01','2013-11-01 19:58:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:01:27'),(7425,5876,'Y','18','021','EC','A','','','AC','0000754529','0000754529','OH00000106285','IL','1','HARTZELL','SHANNON','','','','34','299890832','2670 S TOWNSHIP ROAD 109',0,'TIFFIN','OH','44883','8883','CY','39147','1976-11-24','F','U',':RET:2106-3','N','021','HLT','459657','92036OH006002701','2014-01-01','2013-10-28 14:31:49','0.00',NULL,NULL,'191.45','191.45','R-OH006','OH0','191.45',NULL,0,'2013-12-26 02:17:09'),(6065,4805,'N','01','021','EC','A',NULL,NULL,'','0000436575','0000995405','','IL','1','LINDHAL','KAREN','R','','','34','299581025','1522 E MORGAN RD',0,'JEFFERSON','OH','44047','8122','CY','39007','1958-04-13','F','',':RET:2106-3','N','021','DEN','494574','99734OH005000401','2014-01-01','2013-12-01 12:11:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:02:02'),(6037,4781,'Y','18','021','EC','A','','','AC','0000696992','0000696992','LA00000101687','IL','1','Rainer','Sam','','','','34','435432441','202 BELMONT CIR',0,'MONROE','LA','71203','2923','CY','22073','1978-05-01','M','U',':RET:2106-3','N','021','DEN','1250239','18575LA002000101','2014-01-01','2013-11-30 20:54:16','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2013-12-26 00:01:19'),(5088,4032,'Y','18','021','EC','A','','','AC','0000177799','0000177799','TX00000492044','IL','1','White','Timothy','B','','','34','284621624','115 E 2ND ST',0,'WEATHERFORD','TX','76086','2141','CY','48367','1960-12-09','M','U',':RET:2106-3','T','021','DEN','1463254','33348TX002000201','2014-01-01','2013-12-19 14:35:20','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 23:01:07'),(19657,15663,'Y','18','021','EC','A','','','AC','0000598782','0000598782','OH00002466275','IL','1','Lovill','Kimberly','','','','34','281644013','2335 UNION RD',0,'MIDDLETOWN','OH','45044','8828','CY','39165','1959-03-01','F','M',NULL,'N','021','DEN','3296350','99734OH005000401','2014-03-01','2014-01-23 15:12:44','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-23 21:00:23'),(19141,15251,'Y','18','021','EC','A','','','AC','0000632500','0000632500','TX00001659483','IL','1','AGUIRRE','MARGARITA','','','','34','551935789','13033 PERICO DR',0,'SAN ELIZARIO','TX','79849','9509','CY','48141','1959-11-30','F','M',NULL,'N','021','DEN','1877204','33348TX002000201','2014-03-01','2014-01-19 17:22:37','0.00',NULL,NULL,'43.83','43.83','R-TX009','TX0','14.61',NULL,0,'2014-01-21 08:45:29'),(18299,14609,'N','01','021','EC','A',NULL,NULL,'','0000830659','0000627897','','IL','1','Klein','Carl','Douglas','','','34','298522219','403 NORTHWEST ST',0,'BELLEVUE','OH','44811','1024','CY','39143','1954-03-20','M','',NULL,'N','021','DEN','1555873','99734OH005000401','2014-02-01','2014-01-15 10:01:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:44:56'),(4709,3733,'Y','18','021','EC','A','','','AC','0000199632','0000199632','OH00001275146','IL','1','Hunter','Janet','','','','34','363665480','13737 St. Rt. 582',0,'Bowling Green','OH','43402',NULL,'CY','39173','1955-01-04','F','U',':RET:2106-3','T','021','HLT','932423','92036OH006002601','2014-01-01','2013-12-12 11:10:25','335.00',NULL,NULL,'453.13','118.13','R-OH001','OH0','453.13',NULL,0,'2013-12-25 22:08:39'),(3752,3002,'Y','18','021','EC','A','','','AC','0000574767','0000574767','TX00000112539','IL','1','Castaneda','Daniel','','','Jr','34','466639861','4324 N FLORES ST',0,'EDINBURG','TX','78541','2742','CY','48215','1970-10-18','M','U',NULL,'N','021','DEN','532516','33348TX002000201','2014-01-01','2013-12-13 16:30:30','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 21:33:11'),(17228,13787,'Y','18','021','EC','A','','','AC','0000128672','0000128672','MS00002233916','IL','1','Reynolds','Jamie','','','','34','587548482','131 SANDRA CIR',0,'DREW','MS','38737','3258','CY','28133','1951-08-04','F','U',':RET:2106-3','N','021','DEN','2418199','46300MS002000101','2014-02-01','2014-01-08 11:04:39','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:22:38'),(16316,13064,'Y','18','021','EC','A','','','AC','0001249435','0001249435','LA00001888540','IL','1','warner','ralph','','','','34','041747387','5400 BARKSDALE BLVD',0,'BOSSIER CITY','LA','71112','4538','CY','22015','1968-11-26','M','M',':RET:2054-5','T','021','DEN','2589166','18575LA002000201','2014-02-01','2014-01-06 16:41:55','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-01-07 04:01:35'),(15057,12035,'Y','18','021','EC','A','','','AC','0001266155','0001266155','LA00000352412','IL','1','Prelow','Aljilia','','','','34','437675674','1033 Swan Ave',0,'Baton Rouge','LA','70807',NULL,'CY','22033','1985-11-08','F','U',':RET:2054-5','N','021','DEN','2149721','18575LA002000201','2014-02-01','2013-12-30 14:56:18','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-01 12:03:25'),(16097,12893,'Y','18','021','EC','A','','','AC','0000204571','0000204571','OH00000769988','IL','1','Lee','Tracy','','','','34','288846568','923 Gibbs St',0,'Maumee','OH','43537',NULL,'CY','39095','1972-06-26','F','M',':RET:2106-3','N','021','HLT','1553161','92036OH006002601','2014-02-01','2014-01-03 10:19:27','0.00',NULL,NULL,'201.35','201.35','R-OH001','OH0','201.35',NULL,0,'2014-01-04 02:04:39'),(15311,12244,'Y','18','021','EC','A','','','AC','0001075471','0001075471','TX00001421565','IL','1','Bagwell','Ronnie','','','','34','452837121','2109 RICHWOOD DR',0,'GARLAND','TX','75044','7117','CY','48113','1978-12-24','M','U',':RET:2106-3','N','021','DEN','2228452','33348TX002000101','2014-02-01','2013-12-31 23:49:11','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,1,'2014-01-02 04:23:13'),(27200,21537,'Y','18','021','EC','A','','','AC','0001197945','0001197945','TX00002421356','IL','1','Ochoa','Luz','','','','34','631274935','6820 PRESTON RD',0,'PLANO','TX','75024','2541','CY','48085','1973-07-05','F','U',NULL,'N','021','DEN','3414645','33348TX002000201','2014-04-01','2014-03-03 17:28:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-03 21:31:22'),(27264,21588,'Y','18','021','EC','A','','','AC','0001862441','0001862441','LA00003596487','31','1','WEBB','KIM','','','','34','435231277','P.O. BOX 74842',0,'BATON ROUGE','LA','70874',NULL,'CY','22033','1960-08-02','F','U',NULL,'N','021','DEN','3849820','18575LA002000101','2014-04-01','2014-03-04 05:06:35','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-03-04 21:00:11'),(27831,22012,'Y','18','024','14','A','','','TE','0000913020','0000913020','','IL','1','METCALF','JAMES',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-28','M','',NULL,NULL,NULL,'','3764645','','2014-03-05','2014-03-05 10:44:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-05 21:32:01'),(2133,1751,'Y','18','021','EC','A','','','AC','0000309414','0000309414','OH00000923479','IL','1','Fletcher','Roy',NULL,NULL,NULL,NULL,NULL,'5021 BUFFALO RUN',0,'WESTERVILLE','OH','43081','6705','CY','39049','1955-06-29','M','R',':RET:2106-3','N','021','DEN','732010','99734OH005000401','2014-01-01','2013-12-10 16:47:31','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:18:01'),(7786,6166,'Y','18','021','EC','A','','','AC','0000416687','0000416687','TX00000671207','IL','1','Harris','Sharon','L','','','34','454250441','3815 East Houston Street',0,'Paris','TX','75460',NULL,'CY','48277','1962-09-05','F','M',NULL,'N','021','DEN','2285505','33348TX002000201','2014-01-01','2013-12-20 14:12:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:18'),(22421,17902,'Y','18','021','EC','A','','','AC','0001362512','0001362512','LA00002294235','IL','1','SNYDER','JESSIE','','','','34','433236217','4207 HIGHWAY 165 N',0,'MONROE','LA','71203',NULL,'CY','22073','1958-11-04','M','U',':RET:2054-5','N','021','DEN','3272740','18575LA002000201','2014-03-01','2014-02-10 13:57:58','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-10 21:30:30'),(2243,1843,'N','19','021','EC','A',NULL,NULL,'','0000991516','0000758241','','IL','1','Schriml','Emma','','','','34','296110371','7118 KIRKCALDY DR',0,'WEST CHESTER','OH','45069','4002','CY','39017','2006-04-11','F','',':RET:2106-3','N','021','HLT','420479','92036OH003001205','2014-01-01','2013-12-10 16:51:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 19:21:06'),(16883,13509,'Y','18','024','14','A','','','TE','0000629485','0000629485','','IL','1','Preston','Laurie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-02','F','',NULL,NULL,NULL,'','2295428','','2014-01-09','2014-01-09 11:18:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-13 02:19:22'),(14614,11664,'N','01','021','EC','A',NULL,NULL,'','0000716112','0001123428','','IL','1','Stamps','Kelvin','','','','34','427087135','3765 CHICHESTER RD',0,'EDWARDS','MS','39066','9376','CY','28049','1971-01-26','M','',NULL,'N','021','DEN','2260429','46300MS002000101','2014-02-01','2013-12-27 00:14:51',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2013-12-28 03:36:44'),(7497,5930,'Y','18','021','EC','A','','','AC','0000690707','0000690707','OH00000223256','IL','1','Sarisky','Michael','','','','34','298441448','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1954-05-03','M','M',':RET:2106-3','N','021','DEN','449387','99734OH005000401','2014-01-01','2013-12-15 15:21:36','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:31:45'),(2743,2220,'Y','18','021','EC','A','','','AC','0000979276','0000979276','OH00000692082','IL','1','Thompson','John','','','','34','291626079','60 Rittman Ave',0,'Rittman','OH','44270',NULL,'CY','39169','1957-05-26','M','U',':RET:2106-3','N','021','HLT','1159461','52664OH152000901','2014-01-01','2013-12-02 09:46:24','381.07',NULL,NULL,'381.07','0.00','R-OH014','OH0','381.07',NULL,0,'2013-12-25 19:48:51'),(26556,21054,'N','19','021','EC','A',NULL,NULL,'','0001030419','0000901128','','IL','1','Supe','Ryan','','','','34','295131704','60 VISTA CT',0,'MONROE','OH','45050','1639','CY','39017','2008-03-21','M','',':RET:2106-3','N','021','DEN','2969530','99734OH005000301','2014-03-01','2014-02-28 15:58:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 21:30:17'),(27447,21722,'Y','18','021','EC','A','','','AC','0000133372','0000133372','OH00002871307','IL','1','Andrews','Russell','Davis','','Jr','34','260024244','350 ROBERT DR',0,'KENT','OH','44240','2156','CY','39133','1960-04-08','M','M',':RET:2106-3','N','021','HLT','3852436','52664OH151001501','2014-04-01','2014-03-04 09:00:47','0.00',NULL,NULL,'1237.56','1237.56','R-OH012','OH0','545.63',NULL,0,'2014-03-04 21:01:57'),(27637,21859,'Y','18','024','14','A','','','TE','0000636019','0000636019','','IL','1','Doughty','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-04-08','M','',NULL,NULL,NULL,'','2416684','','2014-03-20','2014-03-05 10:50:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-05 21:30:13'),(543,444,'Y','18','021','EC','A','','','AC','0000225986','0000225986','OH00001304605','IL','1','edwards','taylor','','','','34','295925637','435 Aqueduct St',0,'Akron','OH','44303',NULL,'CY','39153','1989-11-29','F','U',':RET:2054-5','N','021','HLT','1087705','52664OH152000901','2014-01-01','2013-12-03 21:14:48','100.00',NULL,NULL,'163.34','63.34','R-OH012','OH0','163.34',NULL,0,'2013-12-25 17:49:47'),(23915,19021,'N','19','021','EC','A',NULL,NULL,'','0000813132','0000695682','','IL','1','Trimmer','Emma','','','','34','014698504','2266 TIMBER RIDGE TRL',0,'STREETSBORO','OH','44241','4202','CY','39133','2013-01-22','F','',':RET:2106-3','N','021','DEN','3787451','99734OH005000301','2014-03-01','2014-02-13 23:40:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-14 22:00:04'),(13317,10632,'Y','18','021','EC','A','','','AC','0001131861','0001131861','TX00000045907','IL','1','ARRINGTON','DIAMOND','','','','34','597249291','14606 WYNBOURN WAY',0,'HOUSTON','TX','77083',NULL,'CY','48157','1987-07-10','F','U',NULL,'N','021','DEN','2210897','33348TX002000201','2014-01-01','2013-12-23 16:30:59','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:58:14'),(894,741,'Y','18','021','EC','A','','','AC','0000357179','0000357179','OH00000892438','IL','1','McFadden','Jennifer','','','','34','162706412','501 E LOCUST ST',0,'WILMINGTON','OH','45177','2309','CY','39027','1988-09-23','F','U',':RET:2106-3','N','021','HLT','1686541','92036OH005000606','2014-01-01','2013-12-16 13:25:25','175.00',NULL,NULL,'215.53','40.53','R-OH005','OH0','215.53',NULL,0,'2013-12-25 18:08:05'),(7370,5837,'Y','18','021','EC','A','','','AC','0000258116','0000258116','OH00000624181','IL','1','williams','terri','','','','34','300565128','2011 CREST RD',0,'CINCINNATI','OH','45240','2063','CY','39061','1957-05-21','F','M',':RET:2054-5','N','021','DEN','1185264','99734OH005000401','2014-01-01','2013-11-23 09:43:59','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:15:38'),(16981,13591,'Y','18','021','EC','A','','','AC','0000407385','0000407385','OH00001948749','31','1','price','denny','','','','34','297560014','po box 99',0,'winchester','OH','45697',NULL,'CY','39015','1954-09-06','M','M',':RET:2106-3','N','021','HLT','1455930','92036OH005000606','2014-02-01','2014-01-08 20:53:19','878.00',NULL,NULL,'1059.62','181.62','R-OH005','OH0','558.80',NULL,0,'2014-01-13 02:20:18'),(7182,5695,'Y','18','021','EC','A','','','AC','0000983815','0000983815','OH00000182041','IL','1','abdallah','ramzi','','','','34','292027746','897 DEERHURST DR',0,'VANDALIA','OH','45377','9409','CY','39113','1973-12-17','M','M',':RET:2028-9','N','021','DEN','1065162','99734OH005000301','2014-01-01','2013-12-14 11:41:55','0.00',NULL,NULL,'87.78','87.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:00:14'),(6587,5222,'Y','18','021','EC','A','','','AC','0000542653','0000542653','OH00001205154','IL','1','Barlow','Jerry','','','','34','301547929','1484 JONQUILMEADOW DR',0,'CINCINNATI','OH','45240','2940','CY','39061','1953-12-09','M','U',':RET:2106-3','N','021','HLT','8782','92036OH003001204','2014-01-01','2013-12-11 12:53:53','374.00',NULL,NULL,'608.42','234.42','R-OH004','OH0','608.42',NULL,0,'2013-12-26 00:53:07'),(6005,4754,'N','19','021','EC','A',NULL,NULL,'','0000044232','0000482159','','IL','1','Helms','Joshua','Matthew','','','34','407679474','1003 KENNEDYS LNDG',0,'CINCINNATI','OH','45245','5121','CY','39025','2007-10-30','M','',':RET:2106-3','N','021','DEN','463831','99734OH005000301','2014-01-01','2013-12-01 10:29:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:28'),(5904,4677,'Y','18','021','EC','A','','','AC','0000070307','0000070307','OH00000630925','IL','1','Ferris','Navia','Desiree','','','34','200991496','2968 ASBURY CT',0,'MIAMISBURG','OH','45342','4433','CY','39113','2012-01-27','F','R',':RET:2106-3','N','021','DEN','2583993','99734OH005000301','2014-01-01','2013-12-24 00:22:41','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','21.13',NULL,0,'2013-12-25 23:49:51'),(27840,22021,'Y','18','021','EC','A','','','AC','0000664529','0000664529','TX00003652750','IL','1','Day','Dorcia','','','','34','329483389','4603 Cypresswood Dr.',0,'Spring','TX','77379',NULL,'CY','48201','1951-12-18','F','U',':RET:2054-5','N','021','DEN','3354518','33348TX002000101','2014-04-01','2014-03-04 19:33:49','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-05 21:32:07'),(2392,1953,'Y','18','021','EC','A','','','AC','0001135143','0001135143','OH00000446014','IL','1','Brown','Ronald','','','','34','239806214','10312 FORESTVIEW DR',0,'STRONGSVILLE','OH','44136','2662','CY','39035','1949-08-09','M','M',':RET:2106-3','N','021','DEN','95898','99734OH005000401','2014-01-01','2013-12-09 12:16:11','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:33:19'),(3282,2646,'N','01','021','EC','A',NULL,NULL,'','0000061312','0001162593','','IL','1','Dowling-Coll','Julidse','','','','34','732012920','32356 S ROUNDHEAD DR',0,'SOLON','OH','44139','4769','CY','39035','1980-05-09','F','',NULL,'N','021','DEN','1722878','99734OH005000301','2014-01-01','2013-12-21 19:59:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:17'),(5947,4711,'Y','18','021','EC','A','','','AC','0000584274','0000584274','OH00001369928','IL','1','Warren','Robert','','','','34','405980843','651 FAWCETT RD',0,'PEEBLES','OH','45660','9741','CY','39001','1971-08-23','M','M',':RET:2106-3','N','021','HLT','1750130','92036OH003000606','2014-01-01','2013-12-23 21:47:21','480.00',NULL,NULL,'570.98','90.98','R-OH005','OH0','297.05',NULL,0,'2013-12-25 23:51:00'),(14836,11848,'Y','18','021','EC','A','','','AC','0000145387','0000145387','OH00000668013','IL','1','ARMOUR','DIANE','','','','34','299584575','2175 PRESTWICK DR',0,'UNIONTOWN','OH','44685','7552','CY','39153','1957-05-20','F','U',NULL,'N','021','DEN','1428335','99734OH005000301','2014-01-01','2013-12-23 20:32:27','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,1,'2013-12-29 11:14:42'),(20886,16691,'Y','18','021','EC','A','','','AC','0000969471','0000969471','OH00002066030','IL','1','Zaerr','Lon','','','','34','489704586','1127 ROBIN RD',0,'SAINT MARYS','OH','45885','1329','CY','39011','1970-05-22','M','U',':RET:2106-3','T','021','HLT','3640606','92036OH004001501','2014-03-01','2014-01-30 21:18:04','166.00',NULL,NULL,'276.16','110.16','R-OH002','OH0','276.16',NULL,0,'2014-01-31 21:01:11'),(19333,15412,'Y','18','024','14','A','','','TE','0000452937','0000452937','','IL','1','Torres','Estela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-01','F','',NULL,NULL,NULL,'','387799','','2014-01-21','2014-01-21 12:20:54',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:17'),(15392,12313,'Y','18','021','EC','A','','','AC','0000825921','0000825921','OH00000289449','IL','1','Carmichael','Paul','','','','34','301547268','1001 BIRCHAVEN ST',0,'ALLIANCE','OH','44601','5242','CY','39151','1955-06-21','M','M',':RET:2106-3','N','021','HLT','1786104','52664OH151001501','2014-02-01','2014-01-01 15:05:47','784.00',NULL,NULL,'1227.13','443.13','R-OH015','OH0','681.50',NULL,1,'2014-01-02 04:25:47'),(15577,12464,'Y','18','021','EC','A','','','AC','0000577334','0000577334','OH00001959952','IL','1','Anderson','Carla','','','','34','268889171','349 Cloverdale Avenue',0,'Akron','OH','44302',NULL,'CY','39153','1978-08-04','F','U',':RET:2106-3','N','021','HLT','2564821','52664OH151001304','2014-02-01','2013-12-31 16:04:36','35.00',NULL,NULL,'272.52','237.52','R-OH012','OH0','272.52',NULL,1,'2014-01-02 04:32:03'),(26672,21146,'Y','18','021','EC','A','','','AC','0002100994','0002100994','LA00003036427','IL','1','Brown','Blaire','','','','34','438756307','5131 Sharp Road',0,'Mandeville','LA','70471',NULL,'CY','22103','1988-04-05','F','U',':RET:2106-3','N','021','DEN','3668344','18575LA002000201','2014-05-01','2014-02-28 11:48:14','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-28 21:31:18'),(26792,21234,'Y','18','021','EC','A','','','AC','0001651031','0001651031','LA00002575621','IL','1','Elkhansa','Mona','','','','34','433777107','215 MAUREEN DR',0,'YOUNGSVILLE','LA','70592','5817','CY','22055','1967-06-15','F','U',':RET:2106-3','N','021','DEN','3067362','18575LA002000101','2014-04-01','2014-03-01 15:22:59','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-03-01 21:00:19'),(28151,22278,'Y','18','021','EC','A','','','AC','0000071702','0000071702','OH00002711657','31','1','Stachowiak','Dennis','','','','34','271525574','Box 46',0,'Miller City','OH','45864',NULL,'CY','39137','1951-08-16','M','M',':RET:2106-3','N','021','HLT','3990037','92036OH004001501','2014-04-01','2014-03-06 11:37:38','293.00',NULL,NULL,'508.42','215.42','R-OH002','OH0','508.42',NULL,0,'2014-03-06 21:02:37'),(9102,7225,'Y','18','021','EC','A','','','AC','0000422802','0000422802','OH00001071097','IL','1','Grattan','Mitchell','','','','34','290649949','20277 Applewood Lane',0,'Strongsville','OH','44149',NULL,'CY','39035','1961-07-12','M','U',':RET:2106-3','T','021','DEN','2121955','99734OH005000301','2014-01-01','2013-12-18 15:04:17','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:07:25'),(7864,6223,'N','01','021','EC','A',NULL,NULL,'','0000141500','0000776422','','IL','1','FRITZ','DIANE','J','','','34','273489272','2854 LAUREL WOODS BLVD',0,'STOW','OH','44224','5120','CY','39153','1949-04-30','F','',':RET:2106-3','N','021','DEN','1801944','99734OH005000301','2014-01-01','2013-12-20 14:41:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:05:03'),(23592,18793,'Y','18','021','EC','A','','','AC','0001214847','0001214847','OH00002776486','IL','1','FREY','DENNY','P','','','34','269641662','2448 FULTON RD',0,'WOOSTER','OH','44691','7750','CY','39169','1958-02-09','M','U',':RET:2106-3','T','021','HLT','3083291','52664OH152000901','2014-03-01','2014-02-13 13:40:17','390.00',NULL,NULL,'438.23','48.23','R-OH014','OH0','438.23',NULL,0,'2014-02-13 22:03:02'),(7658,6064,'N','01','021','EC','A',NULL,NULL,'','0001632261','0001284849','','IL','1','VO','HIEN','','','','34','659097097','12367 DUTCHTOWN VILLA DR',0,'GEISMAR','LA','70734','3160','CY','22005','1978-08-25','F','',NULL,'N','021','DEN','2414862','18575LA002000101','2014-01-01','2013-12-20 09:20:58',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 03:00:12'),(21643,17283,'Y','18','021','EC','A','','','AC','0001024558','0001024558','TX00001488664','IL','1','Fletcher','Tamiyah','','','','34','457939848','909 MULDER DR',0,'ARLINGTON','TX','76001','5935','CY','48439','1979-05-01','F','U',':RET:2054-5','N','021','DEN','3780081','33348TX002000201','2014-03-01','2014-02-05 17:23:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-05 21:30:46'),(20112,16047,'Y','18','021','EC','A','','','AC','0000919427','0000919427','OH00001488451','IL','1','jusko','david','','','','34','292667821','35975 MATOMA BLVD',0,'EASTLAKE','OH','44095','1518','CY','39085','1959-10-29','M','R',':RET:2106-3','N','021','DEN','2825185','99734OH005000401','2014-03-01','2014-01-26 19:58:48','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-01-27 21:00:41'),(4272,3403,'Y','18','021','EC','A','','','AC','0000661336','0000661336','OH00000547787','IL','1','Eversole','Deborah','','','','34','287549922','6211  Watchcreek Way Apt. 103',0,'Milford','OH','45150',NULL,'CY','39025','1952-06-24','F','U',':RET:2106-3','N','021','HLT','1413576','92036OH001000601','2014-01-01','2013-12-16 20:56:12','379.00',NULL,NULL,'727.64','348.64','R-OH005','OH0','727.64',NULL,0,'2013-12-25 21:51:48'),(4786,3797,'N','19','021','EC','A',NULL,NULL,'','0000505713','0001255005','','IL','1','Ruedlinger','Robert','','','','34','296942658','125 GARFIELD ST',0,'WADSWORTH','OH','44281','1431','CY','39103','1992-03-02','M','',':RET:2106-3','N','021','HLT','1233676','52664OH151001305','2014-01-01','2013-12-07 19:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2013-12-25 22:16:12'),(5137,4071,'Y','18','021','EC','A','','','AC','0000426153','0000426153','TX00000335928','IL','1','Whitt','Lacy','','','','34','454590086','125 BURLESON ST',0,'ROCKDALE','TX','76567','2816','CY','48331','1967-02-07','F','U',NULL,'N','021','DEN','1746944','33348TX002000101','2014-01-01','2013-12-19 18:26:23','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 23:02:24'),(731,606,'Y','18','021','EC','A','','','AC','0000686673','0000686673','TX00000293760','IL','1','Deal','Christopher','','','','34','237698962','2306 BROOKHILL DR',0,'AUSTIN','TX','78745','3553','CY','48453','1985-08-11','M','U',':RET:2106-3','N','021','DEN','483097','33348TX002000201','2014-01-01','2013-12-15 19:09:26','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:03:48'),(24166,19199,'N','19','021','EC','A',NULL,NULL,'','0000784408','0000533349','','IL','1','Stolarski','Nicholas','A','','','34','291048630','7923 KENILWORTH AVE',0,'PARMA','OH','44129','1829','CY','39035','2000-01-04','M','',':RET:2106-3','N','021','HLT','3850903','92036OH005000806','2014-03-01','2014-02-15 12:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','148.47',NULL,0,'2014-02-15 22:02:06'),(23974,19060,'N','01','021','EC','A',NULL,NULL,'','0001476653','0002270845','','IL','1','WICKER','CHERYL','','','','34','410069492','1416 JACKSON ST',0,'MONROE','LA','71202','2026','CY','22073','1960-08-15','F','',NULL,'N','021','DEN','3131012','18575LA002000201','2014-03-01','2014-02-14 22:15:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-15 22:00:16'),(13822,11032,'Y','18','021','EC','A','','','AC','0001184879','0001184879','OH00000634797','IL','1','Jenkins','Debra','','','','34','272546712','8823 GETTYSBURG DR',0,'TWINSBURG','OH','44087','1550','CY','39153','1953-03-29','F','R',':RET:2106-3','N','021','HLT','1436635','52664OH152000901','2014-01-01','2013-12-22 20:32:40','0.00',NULL,NULL,'443.31','443.31','R-OH012','OH0','443.31',NULL,0,'2013-12-26 13:11:54'),(21475,17160,'N','19','021','EC','A',NULL,NULL,'','0000168920','0000154694','','IL','1','ON','JOY','','','','34','283112440','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','2005-07-06','F','',NULL,'N','021','DEN','3006962','99734OH005000301','2014-03-01','2014-02-04 11:15:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:01:40'),(21414,17116,'Y','18','021','EC','A','','','AC','0000932136','0000932136','OH00001608787','IL','1','Reed','Michael','','','','34','283545620','111 W. Cooper St.',0,'McComb','OH','45858',NULL,'CY','39063','1969-04-22','M','U',':RET:2106-3','N','021','HLT','3147829','92036OH005001505','2014-03-01','2014-02-03 19:30:05','385.00',NULL,NULL,'447.22','62.22','R-OH002','OH0','307.46',NULL,0,'2014-02-04 21:01:10'),(2450,1994,'N','19','021','EC','A',NULL,NULL,'','0000015218','0000529215','','IL','1','Sabath','Keni','Rae','','','34','576672273','4214 Waterside Ct.',0,'Missouri City','TX','77459',NULL,'CY','48157','1994-02-09','F','',':RET:2039-6^:RET:2106-3','N','021','DEN','613568','33348TX002000101','2014-01-01','2013-12-08 20:25:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2013-12-25 19:34:39'),(20107,16042,'N','01','021','EC','A',NULL,NULL,'','0001260708','0001661917','','IL','1','Whitemore','Dana','Anthony','','','34','525719105','1249 KERLEREC ST',0,'NEW ORLEANS','LA','70116','1909','CY','22071','1976-10-22','M','',NULL,'T','021','DEN','3199807','18575LA002000201','2014-03-01','2014-01-27 16:13:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-27 21:00:38'),(16591,13271,'Y','18','021','EC','A','','','AC','0001610455','0001610455','LA00001666465','IL','1','Dailey','Amanda','','','','34','441948441','3930 DUMAINE ST',0,'NEW ORLEANS','LA','70119','3836','CY','22071','1974-10-02','F','U',':RET:2106-3','N','021','DEN','2188578','18575LA002000201','2014-02-01','2014-01-07 16:45:41','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-08 18:24:01'),(14140,11271,'Y','18','021','EC','A','','','AC','0002149670','0002149670','LA00001258818','IL','1','WILLIAMS','DONALD','','','','34','436883804','6100 N WEATHERBY DR',0,'SHREVEPORT','LA','71129','3919','CY','22017','1950-02-18','M','M',NULL,'N','021','DEN','2611129','18575LA002000201','2014-02-01','2013-12-26 11:58:57','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-27 02:02:38'),(4212,3351,'Y','18','021','EC','A','','','AC','0000604128','0000604128','TX00000326905','IL','1','Pittard','Theresa','Louise','','','34','013527796','5750 Maquita Ave',0,'Dallas','TX','75206',NULL,'CY','48113','1957-12-02','F','U',':RET:2106-3','N','021','DEN','1759978','33348TX002000201','2014-01-01','2013-12-17 07:59:05','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 21:50:12'),(5086,4031,'Y','18','021','EC','A','','','AC','0000224374','0000224374','TX00000730820','IL','1','Leggett','Wanda','','','','34','451191846','17582 HIGHWAY 105 E',0,'CONROE','TX','77306','5908','CY','48339','1956-07-15','F','M',':RET:2106-3','N','021','DEN','1919441','33348TX002000201','2014-01-01','2013-12-19 14:32:28','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 23:01:04'),(6216,4926,'Y','18','021','EC','A','','','AC','0000072510','0000072510','MS00000559806','IL','1','TAYLOR','YOLANDA','','','','34','262218904','136 WOODLAND WAY',0,'JACKSON','MS','39209','3565','CY','28049','1965-09-14','F','U',NULL,'N','021','DEN','655951','46300MS002000101','2014-01-01','2013-10-15 19:57:27','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 00:31:01'),(4867,3858,'Y','18','021','EC','A','','','AC','0000219949','0000219949','OH00000200867','IL','1','Svatos','William','','','','34','281607391','498 Park Ridge Dr.',0,'Munroe Falls','OH','44262',NULL,NULL,NULL,'1961-02-24','M','U',NULL,'N','021','DEN','205610','99734OH005000401','2014-01-01','2013-10-10 11:28:34','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:30:53'),(7847,6213,'N','01','021','EC','A',NULL,NULL,'','0000418885','0000228330','','IL','1','Balanson','Shimshon','','','','34','271904247','16509 W PARK RD',0,'CLEVELAND','OH','44111','3966','CY','39035','1980-12-30','M','',':RET:2106-3','N','021','DEN','1558839','99734OH005000301','2014-01-01','2013-12-20 00:13:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:04:43'),(25325,20092,'Y','18','021','EC','A','','','AC','0001279821','0001279821','LA00002802546','IL','1','LEE','JERRI','M','','','34','439298507','4776 PRESCOTT RD',0,'BATON ROUGE','LA','70805','5251','CY','22033','1967-04-24','F','U',':RET:2054-5','N','021','DEN','3591035','18575LA002000201','2014-04-01','2014-02-25 11:49:36','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:12'),(25332,20099,'Y','18','021','EC','A','','','AC','0001627552','0001627552','LA00002712457','IL','1','Baker','Nicole','','','','34','034749643','2900 Ursulines Ave',0,'New Orleans','LA','70119',NULL,'CY','22071','1986-09-19','F','U',NULL,'N','021','DEN','3503423','18575LA002000201','2014-04-01','2014-02-25 14:30:45','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:19'),(9548,7567,'Y','18','021','EC','A','','','AC','0000290794','0000290794','OH00001168831','IL','1','Huelskamp','Emily','','','','34','274924287','249 E Main St',0,'Piqua','OH','45356',NULL,'CY','39109','1984-09-11','F','U',':RET:2106-3','N','021','DEN','1945348','99734OH005000301','2014-01-01','2013-12-21 12:32:48','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:36:12'),(23260,18545,'Y','18','024','14','A','','','TE','0000600455','0000600455','','IL','1','PURIFOY','MARCIE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1970-12-10','F','',NULL,NULL,NULL,'','1708291','','2014-02-28','2014-02-13 15:21:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-13 21:30:09'),(9033,7168,'Y','18','021','EC','A','','','AC','0000460570','0000460570','OH00000635584','IL','1','Gal','Roger','','','','34','297747918','912 E CASTON RD',0,'UNIONTOWN','OH','44685','6914','CY','39153','1966-12-10','M','M',':RET:2106-3','N','021','HLT','2150533','52664OH151001305','2014-01-01','2013-12-18 12:30:05','134.00',NULL,NULL,'348.56','214.56','R-OH012','OH0','348.56',NULL,0,'2013-12-26 04:05:38'),(3157,2539,'Y','18','021','EC','A','','','AC','0000435268','0000435268','OH00000993053','IL','1','Leggett','Jeff','','','','34','299661137','3510 POE AVE',0,'CLEVELAND','OH','44109','2252','CY','39035','1970-08-25','M','U',':RET:2106-3','N','021','DEN','1066111','99734OH005000401','2014-01-01','2013-11-17 23:12:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:31:11'),(19574,15602,'N','01','021','EC','A',NULL,NULL,'','0001647541','0002099470','','IL','1','Caston','CaSandra','Tillman','','','34','439378456','6316 Timberman Place',0,'Shreveport','LA','71119',NULL,'CY','22017','1964-06-01','F','',':RET:2054-5','N','021','DEN','1758740','18575LA002000201','2014-03-01','2014-01-22 14:23:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-23 03:02:37'),(18375,14666,'Y','18','021','EC','A','','','AC','0000383383','0000383383','OH00001736570','IL','1','Krinn','Karmen','','','','34','288761729','152 LEXINGTON BLVD',0,'DELAWARE','OH','43015','1074','CY','39041','1971-12-18','F','U',NULL,'N','021','DEN','1737023','99734OH005000301','2014-02-01','2014-01-15 14:05:21','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-16 08:45:32'),(5616,4456,'Y','18','021','EC','A','','','AC','0000079875','0000079875','OH00001060998','31','1','Haley','Tina','','','','34','272585279','P.O. Box 426',0,'Maineville','OH','45039',NULL,'CY','39165','1957-07-05','F','U',':RET:2106-3','N','021','DEN','173039','99734OH005000401','2014-01-01','2013-11-26 08:38:27','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:30:37'),(13804,11018,'Y','18','021','EC','A','','','AC','0000681873','0000681873','MS00001203372','IL','1','Wesley','Stanley','','','','34','426271200','3152 RENO ST',0,'JACKSON','MS','39212','2935','CY','28049','1966-10-17','M','U',':RET:2054-5','N','021','DEN','1627204','46300MS002000101','2014-01-01','2013-12-23 19:08:24','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 13:11:25'),(23880,19000,'Y','18','021','EC','A','','','AC','0001036174','0001036174','OH00002127464','IL','1','Kiger','Nathan','','','','34','268848283','6761 Beagle Drive',0,'Hamilton','OH','45011',NULL,'CY','39017','1973-01-07','M','M',':RET:2106-3','T','021','HLT','3830411','92036OH002001201','2014-03-01','2014-02-14 02:03:51','245.00',NULL,NULL,'851.41','606.41','R-OH004','OH0','371.20',NULL,0,'2014-02-14 21:32:14'),(24270,19275,'Y','18','021','EC','A','','','AC','0000944916','0000944916','OH00002459199','IL','1','Fakhravar','Mahin','','','','34','363253574','8152 PEPPERWOOD DR',0,'WEST CHESTER','OH','45069','1861','CY','39017','1954-12-21','F','M',':RET:2106-3','N','021','HLT','3249596','92036OH006001201','2014-04-01','2014-02-17 14:41:01','819.00',NULL,NULL,'993.74','174.74','R-OH004','OH0','443.16',NULL,0,'2014-02-17 19:00:17'),(24784,19658,'Y','18','021','EC','A','','','AC','0000451328','0000451328','OH00002598971','IL','1','Kopis','Karen','','','','34','291626186','284 ROOSEVELT AVE',0,'ELYRIA','OH','44035','3948','CY','39093','1958-07-07','F','U',':RET:2106-3','N','021','DEN','2960752','99734OH005000401','2014-04-01','2014-02-19 13:32:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:45:50'),(24882,19729,'Y','18','021','EC','A','','','AC','0001059504','0001059504','OH00002242434','IL','1','DELLISANTI','CAROL','JOYCE','','','34','299528640','40449 BUTTERNUT RIDGE RD',0,'ELYRIA','OH','44035','7909','CY','39093','1952-12-22','F','M',NULL,'N','021','DEN','2744566','99734OH005000301','2014-04-01','2014-02-19 12:49:46','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00','CIC',0,'2014-02-20 05:36:31'),(25379,20135,'Y','18','021','EC','A','','','AC','0000994024','0000994024','OH00003274796','IL','1','WEIMER','MICHAEL','LYNN','','','34','289824186','571 ETTER RD',0,'MOGADORE','OH','44260','9601','CY','39153','1984-10-25','M','U',':RET:2106-3','T','021','DEN','3472453','99734OH005000301','2014-04-01','2014-02-25 16:22:05','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-25 21:30:45'),(28056,22202,'Y','18','021','EC','A','','','AC','0000768896','0000768896','OH00002692414','IL','1','WILLIAMS','TIMOTHY','','','','34','299787440','5344 WILDCAT PIKE',0,'MARION','OH','43302','9432','CY','39101','1982-09-07','M','M',':RET:2106-3','N','021','DEN','3987665','99734OH005000301','2014-04-01','2014-03-05 18:34:42','0.00',NULL,NULL,'42.26','42.26','R-OH008','OH0','0.00',NULL,0,'2014-03-06 21:01:41'),(28238,22343,'Y','18','024','14','A','','','TE','0000578830','0000578830','','IL','1','Bregitzer','Madison',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'2009-12-29','F','',NULL,NULL,NULL,'','3607339','','2014-03-31','2014-03-07 10:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:09'),(28689,22705,'Y','18','021','EC','A','','','AC','0000392431','0000392431','OH00003505896','IL','1','Coleman','Tammy','','','','34','284725154','994 SUNSET VIEW BLVD',0,'TALLMADGE','OH','44278','3232','CY','39153','1973-11-27','F','R',NULL,'N','021','HLT','3433379','52664OH152000901','2014-04-01','2014-03-08 15:19:09','0.00',NULL,NULL,'438.29','438.29','R-OH012','OH0','208.75',NULL,0,'2014-03-08 21:31:02'),(1533,1276,'N','01','021','EC','A',NULL,NULL,'','0001124069','0001158926','','IL','1','Brasty','James','Robert','','','34','269549994','9114 Chatham Road',0,'Medina','OH','44256',NULL,'CY','39103','1954-09-12','M','',':RET:2106-3','N','021','DEN','1529284','99734OH005000401','2014-01-01','2013-12-24 16:10:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:50:03'),(2229,1835,'Y','18','021','EC','A','','','AC','0000921892','0000921892','OH00000570369','IL','1','Macaluso','Joseph','','','','34','272507690','2 CURRY LN',0,'MILFORD','OH','45150','1891','CY','39025','1951-10-17','M','M',':RET:2106-3','N','021','HLT','869616','92036OH001000601','2014-01-01','2013-12-10 14:33:04','744.00',NULL,NULL,'1520.74','776.74','R-OH005','OH0','743.93',NULL,0,'2013-12-25 19:20:45'),(21715,17340,'Y','18','021','EC','A','','','AC','0000692963','0000692963','OH00002255770','IL','1','Harmon','Michael','','','','34','379524888','2927 KINGSTON AVE',0,'DAYTON','OH','45420','2627','CY','39113','1954-11-18','M','M',':RET:2106-3','N','021','HLT','3810663','92036OH004000501','2014-03-01','2014-02-05 12:31:27','48.00',NULL,NULL,'497.54','449.54','R-OH003','OH0','497.54',NULL,0,'2014-02-05 21:31:17'),(7717,6111,'Y','18','021','EC','A','','','AC','0000453911','0000453911','OH00000579004','IL','1','beisner','karry','kaye','','','34','303826850','1316 manier ave',0,'piqua','OH','45356',NULL,'CY','39109','1961-10-10','F','M',':RET:2106-3','N','021','DEN','2145758','99734OH005000401','2014-01-01','2013-12-20 13:16:58','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:01:39'),(19934,15898,'Y','18','021','EC','A','','','AC','0000946139','0000946139','OH00002456534','31','1','Bourcier','Mark','','','','34','368623525','4609 SOUTH AVE',0,'TOLEDO','OH','43615','6420','CY','39095','1967-05-23','M','U',':RET:2106-3','N','021','HLT','1920524','92036OH004002601','2014-03-01','2014-01-24 13:16:19','64.00',NULL,NULL,'235.18','171.18','R-OH001','OH0','235.18',NULL,0,'2014-01-24 21:01:11'),(14422,11502,'Y','18','021','EC','A','','','AC','0000184728','0000184728','TX00001155325','IL','1','Ayers','Benjamin','','','','34','438773980','1410 MARTINSVILLE ST',0,'NACOGDOCHES','TX','75961','4955','CY','48347','1989-07-28','M','M',':RET:2106-3','N','021','DEN','1438456','33348TX002000101','2014-02-01','2013-12-27 13:29:46','0.00',NULL,NULL,'50.04','50.04','R-TX026','TX0','25.02',NULL,0,'2013-12-28 03:31:43'),(18829,14997,'Y','18','021','EC','A','','','AC','0000914406','0000914406','MS00001697818','IL','1','ENGLAND','JAMES','R','','','34','311508176','6300 OLD CANTON RD',0,'JACKSON','MS','39211','2480','CY','28049','1954-11-25','M','U',NULL,'N','021','DEN','2722736','46300MS002000201','2014-02-01','2014-01-15 19:27:17','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-17 03:36:09'),(17814,14229,'N','01','021','EC','A',NULL,NULL,'','0000684082','0000843486','','IL','1','Silva','Kristy','Ann','','','34','638106182','21902 TOWER TER',0,'SAN ANTONIO','TX','78259','2758','CY','48029','1986-12-10','F','',NULL,'N','021','DEN','1448365','33348TX002000101','2014-02-01','2014-01-14 16:43:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-01-15 02:05:53'),(16332,13076,'N','19','021','EC','A',NULL,NULL,'','0001380428','0001837250','','IL','1','Jones','Brittany','Rachelle','','','34','353887066','41154 Clearwater Avenue',0,'Gonzales','LA','70737',NULL,'CY','22005','1992-10-01','F','',':RET:2054-5','N','021','DEN','1879623','18575LA002000201','2014-02-01','2014-01-06 17:56:55',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-07 04:02:01'),(25680,20373,'Y','18','021','EC','A','','','AC','0001138094','0001138094','OH00003216368','IL','1','NEAL','DEETTA','','','','34','274605270','6787 HEATHER MOOR TRL',0,'HILLSBORO','OH','45133','9266','CY','39071','1956-03-08','F','U',NULL,'T','021','HLT','2997752','92036OH006000601','2014-04-01','2014-02-23 18:14:27','393.00',NULL,NULL,'498.84','105.84','R-OH005','OH0','498.84',NULL,0,'2014-02-26 09:30:03'),(26810,21246,'Y','18','021','EC','A','','','AC','0000840585','0000840585','OH00003483026','IL','1','Adkins','Susan','','','','34','363745112','1830  Peacock Lane',0,'Holland','OH','43528',NULL,'CY','39095','1958-01-17','F','M',':RET:2106-3','N','021','HLT','3868694','92036OH006002601','2014-04-01','2014-02-28 18:41:46','798.00',NULL,NULL,'805.07','7.07','R-OH001','OH0','360.78',NULL,0,'2014-03-01 21:00:28'),(1468,1223,'Y','18','021','EC','A','','','AC','0000637111','0000637111','OH00000230826','31','1','Givens','Garland','','','','34','285803627','P. O. Box 2731',0,'Springfield','OH','45501',NULL,'CY','39023','1983-05-12','M','U',':RET:2054-5','N','021','DEN','1960578','99734OH005000401','2014-01-01','2013-12-24 09:09:04','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:48:29'),(22866,18241,'Y','18','021','EC','A','','','AC','0000876880','0000876880','MS00002271698','IL','1','Widener','Michelle','','','','34','426516171','539 OAK RIDGE WAY',0,'PEARL','MS','39208','8076','CY','28121','1974-01-23','F','M',':RET:2106-3','N','021','DEN','3469468','46300MS002000201','2014-03-01','2014-02-11 15:38:13','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-11 21:02:28'),(5412,4294,'N','01','021','EC','A',NULL,NULL,'','0000974082','0000969428','','IL','1','Middleton','Carolyn','Anne','','','34','296525123','719 MCCUNE RD',0,'WILMINGTON','OH','45177','8715','CY','39027','1960-12-08','F','',':RET:2106-3','N','021','HLT','1575700','92036OH003000601','2014-01-01','2013-12-19 13:29:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','457.33',NULL,0,'2013-12-25 23:09:09'),(21426,17123,'N','01','021','EC','A',NULL,NULL,'','0000904297','0000885635','','IL','1','Haddad','Saba',NULL,NULL,NULL,NULL,NULL,'5467 surrey ct',0,'West chester','OH','45069',NULL,'CY','39017','1980-11-18','M','',':RET:2106-3','N','021','HLT','3428920','92036OH004001201','2014-03-01','2014-02-03 23:16:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','206.78',NULL,0,'2014-02-04 21:01:15'),(14516,11582,'Y','18','021','EC','A','','','AC','0001004062','0001004062','TX00000729967','IL','1','Church','Ryan','','','','34','460157762','528 N COMMERCE ST',0,'GAINESVILLE','TX','76240','3935','CY','48097','1976-07-15','M','M',':RET:2106-3','N','021','DEN','1831425','33348TX002000201','2014-02-01','2013-12-27 16:22:42','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-28 03:34:11'),(17163,13733,'Y','18','021','EC','A','','','AC','0002036751','0002036751','LA00002163802','IL','1','Cooper','William','','','','34','436692675','1919 Blvd de Province',0,'Baton Rouge','LA','70816',NULL,'CY','22033','1981-02-24','M','U',':RET:2054-5','T','021','DEN','1913405','18575LA002000201','2014-02-01','2014-01-08 13:22:56','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:22:03'),(16772,13417,'Y','18','021','EC','A','','','AC','0000678135','0000678135','MS00002133421','IL','1','HOPES','MARY','K','','','34','393587321','11213 BERRY CIR',0,'DIBERVILLE','MS','39540','2451','CY','28047','1953-08-06','F','M',':RET:2106-3','N','021','DEN','1756931','46300MS002000101','2014-02-01','2014-01-07 16:50:34','0.00',NULL,NULL,'27.15','27.15','R-MS005','MS0','27.15',NULL,0,'2014-01-08 18:25:02'),(25699,20389,'Y','18','021','EC','A','','','AC','0000409368','0000409368','TX00002207692','IL','1','MARTINEZ RODRIGUEZ','MAGDA','','','','34','449959494','2412 DURHAM AVE',0,'BROWNWOOD','TX','76801','4921','CY','48049','1959-11-28','F','M',NULL,'N','021','DEN','2644264','33348TX002000201','2014-04-01','2014-02-24 12:09:38','0.00',NULL,NULL,'67.44','67.44','R-TX026','TX0','14.61',NULL,0,'2014-02-26 09:30:18'),(26224,20798,'Y','18','021','EC','A','','','AC','0001172800','0001172800','TX00003356973','IL','1','MALONE','EARNESTINE','','','','34','429111418','4602 CALLE ROBLE',0,'TEMPLE','TX','76502',NULL,'CY','48027','1959-06-08','F','U',':RET:2054-5','N','021','DEN','3803541','33348TX002000201','2014-04-01','2014-02-26 20:58:02','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-28 06:30:58'),(26649,21128,'N','17','021','EC','A',NULL,NULL,'','0000672817','0000776488','','IL','1','Wiener','William','P','','','34','593439290','813  N. Main St.',0,'North Canton','OH','44720',NULL,'CY','39151','1994-07-03','M','',':RET:2106-3','N','021','HLT','3047338','52664OH151001305','2014-03-01','2014-02-28 11:49:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:06'),(1556,1298,'N','01','021','EC','A',NULL,NULL,'','0000639454','0000466130','','IL','1','LEE','JARED','','','','34','595382394','1828 TOWNSHIP RD',0,'LAUREL','MS','39443',NULL,'CY','28067','1983-12-28','F','',':RET:2106-3','N','021','DEN','2554267','46300MS002000201','2014-01-01','2013-12-24 14:06:33',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-25 18:50:45'),(23082,18403,'N','01','021','EC','A',NULL,NULL,'','0001146007','0000694241','','IL','1','Kossick','Lori','','','','34','278624885','103 HALL ST',0,'AKRON','OH','44303','2117','CY','39153','1963-05-09','F','',':RET:2106-3','N','021','DEN','3609479','99734OH005000401','2014-03-01','2014-02-11 19:43:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:03'),(7702,6098,'N','01','021','EC','A',NULL,NULL,'','0000919381','0000350566','','IL','1','robinson','deborah','s','','','34','297444002','5909 alice drive',0,'westerville','OH','43081',NULL,'CY','39049','1953-01-11','F','',':RET:2106-3','N','021','DEN','1466067','99734OH005000401','2014-01-01','2013-12-20 09:09:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:01:18'),(22826,18213,'N','19','021','EC','A',NULL,NULL,'','0001182541','0000401281','','IL','1','Plum','Mitchell',NULL,NULL,NULL,NULL,NULL,'1269 SPRUCE WOOD WAY',0,'UNIONTOWN','OH','44685','9579','CY','39153','1991-05-31','M','',NULL,'N','021','HLT','3637434','52664OH151001301','2014-03-01','2014-02-11 09:10:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01',NULL,0,'2014-02-11 21:02:04'),(5754,4569,'Y','18','021','EC','A','','','AC','0000254536','0000254536','OH00001213768','IL','1','Patterson','Paul','','','','34','277541449','317 Saint Clair Street',0,'Girard','OH','44420',NULL,'CY','39155','1951-08-16','M','U',':RET:2106-3','N','021','DEN','1609341','99734OH005000401','2014-01-01','2013-12-23 21:04:00','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:46:18'),(22510,17970,'Y','18','021','EC','A','','','AC','0000040987','0000040987','OH00002678038','IL','1','Black','Katherine','M','','','34','301922689','25490 Lakeshore Blvd',0,'Euclid','OH','44123',NULL,'CY','39035','1991-01-23','F','R',':RET:2106-3','N','021','HLT','3404530','92036OH001000801','2014-03-01','2014-02-09 19:07:13','0.00',NULL,NULL,'282.01','282.01','R-OH011','OH0','282.01',NULL,0,'2014-02-10 21:31:18'),(21796,17408,'Y','18','021','EC','A','','','AC','0001043429','0001043429','OH00001647123','IL','1','wilkey','ronald','','','','34','279782829','2120 S HADLEY RD',0,'SPRINGFIELD','OH','45505','4415','CY','39023','1981-10-08','M','U',NULL,'T','021','DEN','3636125','99734OH005000401','2014-03-01','2014-02-06 16:58:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-06 21:00:47'),(21736,17357,'Y','18','021','EC','A','','','AC','0001232010','0001232010','TX00002601907','IL','1','Simpson','Deborah','','','','34','402989482','2506 BARRON RD',0,'COLLEGE STATION','TX','77845','9164','CY','48041','1961-09-01','F','M',':RET:2106-3','N','021','DEN','3176846','33348TX002000201','2014-03-01','2014-02-06 17:24:52','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-06 21:00:12'),(21608,17253,'Y','18','021','EC','A','','','AC','0001162635','0001162635','OH00001798378','IL','1','David','Ronald','','','','34','422649420','962 GALLATIN CT',0,'CINCINNATI','OH','45240','2406','CY','39061','1951-11-10','M','M',':RET:2054-5','N','021','DEN','2649820','99734OH005000301','2014-03-01','2014-02-05 13:27:17','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:33'),(4123,3293,'Y','18','021','EC','A','','','AC','0001133930','0001133930','OH00001055209','IL','1','Fineran','Andrew','','','','34','199669784','2631 MAPLE AVE NE',0,'CANTON','OH','44714','1890','CY','39151','1986-11-30','M','R',':RET:2106-3','N','021','DEN','1626766','99734OH005000301','2014-01-01','2013-12-16 22:51:41','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2013-12-25 21:48:14'),(21066,16832,'Y','18','024','14','A','','','TE','0000053091','0000053091','','IL','1','Yaegel','Joseph','Patrick',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-08-05','M','',NULL,NULL,NULL,'','3559209','','2014-02-01','2014-02-01 19:26:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-02 19:00:14'),(19649,15659,'Y','18','021','EC','A','','','AC','0000741751','0000741751','OH00001974633','IL','1','Bowman','Margaret','','','','34','401177729','517 S Marion St',0,'Cardington','OH','43315',NULL,'CY','39117','1975-09-02','F','M',':RET:2106-3','T','021','DEN','3267520','99734OH005000401','2014-03-01','2014-01-23 12:20:34','0.00',NULL,NULL,'71.95','71.95','R-OH008','OH0','0.00',NULL,0,'2014-01-23 21:00:19'),(19105,15222,'Y','18','021','EC','A','','','AC','0001823365','0001823365','LA00001705704','IL','1','tomasella','gina','','','','34','435395844','600 WILLOW OAK LN',0,'MANDEVILLE','LA','70471','2728','CY','22103','1972-02-14','F','M',':RET:2106-3','N','021','DEN','1972598','18575LA002000201','2014-03-01','2014-01-18 16:26:42','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-21 08:44:41'),(18044,14415,'Y','18','021','EC','A','','','AC','0000856514','0000856514','MS00002509437','IL','1','Hydrick','Robert','','','','34','425653510','168 FERN VALLEY RD',0,'BRANDON','MS','39042','1926','CY','28121','1983-07-06','M','M',':RET:2106-3','N','021','DEN','1661173','46300MS002000101','2014-02-01','2014-01-13 20:39:52','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-15 02:07:14'),(17119,13701,'Y','18','021','EC','A','','','AC','0000643242','0000643242','OH00002417248','IL','1','MATHEWS','ROBERT','E','','','34','282505781','253 S ALPHA BELLBROOK RD',0,'XENIA','OH','45385','9397','CY','39057','1952-03-24','M','M',':RET:2106-3','N','021','DEN','1909219','99734OH005000401','2014-02-01','2014-01-08 10:25:46','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-13 02:21:41'),(15055,12033,'Y','18','021','EC','A','','','AC','0002091931','0002091931','LA00001283473','IL','1','DAVIS','SHAYLYNN','T','','','34','439811730','2210 WEST HARPER STREET',0,'WINNSBORO','LA','71295',NULL,'CY','22041','1991-06-18','F','U',':RET:2054-5','N','021','DEN','2069799','18575LA002000201','2014-02-01','2013-12-30 14:37:23','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-01 12:03:22'),(3073,2469,'Y','18','021','EC','A','','','AC','0000637258','0000637258','LA00000382260','IL','1','PRIESTLEY','JULES','A','','','34','434988481','3170 ANN ST',0,'VACHERIE','LA','70090','7021','CY','22093','1956-07-27','M','M',':RET:2054-5','N','021','DEN','350687','18575LA002000101','2014-01-01','2013-12-06 00:02:21','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-25 20:19:31'),(25239,20021,'Y','18','021','EC','A','','','AC','0000619688','0000619688','OH00003052501','IL','1','Litzinger','Haley','','','','34','269907134','1508 MAIN ST',0,'PENINSULA','OH','44264','9740','CY','39153','1982-07-14','F','U',':RET:2106-3','N','021','HLT','2639243','52664OH151001501','2014-04-01','2014-02-21 11:41:58','25.00',NULL,NULL,'309.99','284.99','R-OH012','OH0','309.99',NULL,0,'2014-02-21 22:01:07'),(26948,21353,'Y','18','021','EC','A','','','AC','0000513386','0000513386','OH00002704666','IL','1','Graham','Matthew','','','','34','275868002','403 Lincoln St',0,'Elmore','OH','43416',NULL,'CY','39123','1981-12-15','M','M',NULL,'N','021','HLT','2959874','92036OH003002705','2014-04-01','2014-03-01 20:32:10','309.00',NULL,NULL,'468.76','159.76','R-OH006','OH0','240.90',NULL,0,'2014-03-03 01:00:25'),(2031,1663,'Y','18','021','EC','A','','','AC','0000240323','0000240323','OH00001216329','IL','1','Levin','Ann','','','','34','182422019','2666 ROCKLYN RD',0,'SHAKER HEIGHTS','OH','44122','2124','CY','39035','1951-05-06','F','M',':RET:2106-3','N','021','HLT','176084','52664OH152000901','2014-01-01','2013-12-10 16:57:50','850.00',NULL,NULL,'1058.56','208.56','R-OH011','OH0','529.28',NULL,0,'2013-12-25 19:15:21'),(23892,19005,'Y','18','024','14','A','','','TE','0000350602','0000350602','','IL','1','Moore','Gloria',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-21','F','',NULL,NULL,NULL,'','3304530','','2014-02-14','2014-02-14 08:38:29',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:32:19'),(23369,18621,'Y','18','021','EC','A','','','AC','0000459201','0000459201','OH00002236923','IL','1','Miller','Lynn','','','','34','286548993','2255 WOODWARD AVE',0,'LAKEWOOD','OH','44107','5734','CY','39035','1953-04-01','F','U',':RET:2106-3','N','021','DEN','3613248','99734OH005000401','2014-03-01','2014-02-12 19:53:23','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:51'),(4676,3707,'Y','18','021','EC','A','','','AC','0000620347','0000620347','LA00000821424','31','1','JOESPH','PAULA','M','','','34','434251281','P.O BOX 102',0,'CHATAIGNIER','LA','70524',NULL,'CY','22039','1967-01-25','F','M',':RET:2054-5','N','021','DEN','27560','18575LA002000201','2014-01-01','2013-12-12 15:00:13','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,0,'2013-12-25 22:07:45'),(6816,5405,'N','19','021','EC','A',NULL,NULL,'','0000449829','0001102053','','IL','1','Smas','Thomas','','','','34','287156990','917 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44221','3843','CY','39153','2009-10-26','M','',NULL,'N','021','HLT','629212','52664OH151001305','2014-01-01','2013-11-13 22:31:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-26 01:30:25'),(19299,15384,'Y','18','021','EC','A','','','AC','0001314138','0001314138','LA00002422857','IL','1','Simmons','Angela','','','','34','436515608','27699 CHURCH OF GOD RD',0,'SPRINGFIELD','LA','70462','9023','CY','22063','1979-02-05','F','U',':RET:2106-3','T','021','DEN','3080531','18575LA002000101','2014-03-01','2014-01-20 18:37:06','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,1,'2014-01-22 03:21:59'),(4754,3769,'Y','18','021','EC','A','','','AC','0000393212','0000393212','TX00000988178','IL','1','Pereira','Lianne','','','','34','289580951','200 SW COUNTY ROAD 3050',0,'PURDON','TX','76679','3103','CY','48349','1959-05-09','F','U',':RET:2106-3','N','021','DEN','924921','33348TX002000201','2014-01-01','2013-12-08 15:38:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 22:15:18'),(5295,4196,'Y','18','021','EC','A','','','AC','0000236263','0000236263','OH00000382750','IL','1','Carpenter','Karen','','','','34','280487803','1877 TOWNSHIP ROAD 72',0,'KILLBUCK','OH','44637','9717','CY','39075','1951-05-15','F','M',':RET:2106-3','T','021','HLT','1916889','52664OH151001304','2014-01-01','2013-12-19 18:12:57','467.00',NULL,NULL,'736.81','269.81','R-OH014','OH0','736.81',NULL,0,'2013-12-25 23:06:09'),(13721,10949,'N','01','021','EC','A',NULL,NULL,'','0000872037','0000733588','','IL','1','Thielenhaus','Brenda','Jean','','','34','275805507','7884 SPENCER LAKE RD',0,'MEDINA','OH','44256','9193','CY','39103','1969-07-15','F','',':RET:2106-3','N','021','HLT','1772509','52664OH151001305','2014-01-01','2013-12-23 17:29:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','311.54',NULL,0,'2013-12-26 13:09:13'),(27047,21419,'N','01','021','EC','A',NULL,NULL,'','0000265305','0000880578','','IL','1','Drees','Richard','H','','','34','283549176','5831 MURNEN RD',0,'TOLEDO','OH','43623','1413','CY','39095','1962-06-01','M','',':RET:2106-3','N','021','HLT','3396980','92036OH005002601','2014-04-01','2014-03-03 11:30:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.68','CIC',0,'2014-03-03 21:00:23'),(27738,21935,'Y','18','021','EC','A','','','AC','0001152680','0001152680','TX00003763012','31','1','webb','pamela','k','','','34','264472483','po box 465',0,'longview','TX','75606',NULL,'CY','48203','1957-12-26','F','U',':RET:2106-3','N','021','DEN','2720272','33348TX002000201','2014-04-01','2014-03-05 17:20:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-05 21:31:08'),(2724,2203,'Y','18','021','EC','A','','','AC','0001038612','0001038612','LA00000448270','IL','1','Geystan','Judith','Y','','','34','434634423','502 Pine Street',0,'Alexandra','LA','71301',NULL,'CY','22079','1972-07-24','F','U',':RET:2054-5','N','021','DEN','237741','18575LA002000201','2014-01-01','2013-12-02 14:46:50','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 19:48:17'),(24352,19341,'Y','18','021','EC','A','','','AC','0000931192','0000931192','PA00001848140','IL','1','HARRIS','RYAN','','','','34','173669388','1144 W 5TH ST',0,'ERRI','PA','75421',NULL,'CY','48277','1986-01-24','M','U',':RET:2054-5','N','021','DEN','3127551','33348TX002000201','2014-04-01','2014-02-18 13:01:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','PA0','14.61',NULL,0,'2014-02-18 22:00:27'),(24138,19184,'Y','18','021','EC','A','','','AC','0000702823','0000702823','OH00001881830','IL','1','Raper','Stefanie','','','','34','269886806','4439 Happiness Lane',0,'Cincinnati','OH','45245',NULL,'CY','39025','1972-11-12','F','M',':RET:2106-3','N','021','HLT','3217890','92036OH004000601','2014-03-01','2014-02-15 10:42:48','63.99',NULL,NULL,'553.57','489.58','R-OH005','OH0','224.74',NULL,0,'2014-02-15 22:01:51'),(22950,18298,'Y','18','021','EC','A','','','AC','0000327240','0000327240','OH00002487634','IL','1','ROLLER','PATRICIA','','','','34','147448027','27192 CLIFFSIDE CIR',0,'OLMSTED TWP','OH','44138','8171','CY','39035','1951-01-08','F','U',':RET:2106-3','N','021','HLT','3204086','52664OH151001306','2014-03-01','2014-02-11 16:26:58','524.00',NULL,NULL,'742.48','218.48','R-OH011','OH0','742.48','CIC',0,'2014-02-11 21:30:27'),(22095,17637,'Y','18','021','EC','A','','','AC','0000121585','0000121585','OH00001840689','IL','1','HOLMANN','ELIZABETH','','','','34','400868994','2243 HAMILTON CLEAVE ROAD',0,'HAMILTON','OH','45013',NULL,'CY','39017','1957-10-08','F','U',':RET:2106-3','N','021','DEN','2810538','99734OH005000301','2014-03-01','2014-02-07 18:46:36','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-08 19:00:26'),(9083,7207,'Y','18','024','14','A','','','TE','0000982668','0000982668','','IL','1','Roberts','Nanette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-02-19','F','',NULL,NULL,NULL,'','1008531','','2013-12-18','2013-12-18 08:48:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:06:53'),(21607,17252,'N','19','021','EC','A',NULL,NULL,'','0000895755','0000920849','','IL','1','Carver','Magdalene','Abbigail','','','34','271060246','4577 CARNOUSTIE',0,'BATAVIA','OH','45103','4008','CY','39025','2000-10-15','F','',':RET:2106-3','N','021','DEN','3280349','99734OH005000301','2014-03-01','2014-02-05 13:20:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:33'),(21239,16970,'Y','18','021','EC','A','','','AC','0000969475','0000969475','OH00002564542','IL','1','Chapamn','Aretha','','','','34','290744717','1006 Redbird Drive',0,'Cincinnati','OH','45231',NULL,'CY','39061','1967-07-14','F','R',':RET:2054-5','N','021','DEN','2745253','99734OH005000301','2014-03-01','2014-02-03 13:23:06','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-03 21:01:12'),(8883,7042,'N','01','021','EC','A',NULL,NULL,'','0000826830','0001077875','','IL','1','Temple','Wesley','','','','34','628168647','102 HOLT ST',0,'EUSTACE','TX','75124','9679','CY','48213','1988-03-22','M','',':RET:2106-3','N','021','DEN','1911413','33348TX002000201','2014-01-01','2013-12-18 15:43:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:50'),(20805,16625,'Y','18','021','EC','A','','','AC','0000721541','0000721541','TX00001570738','IL','1','padia','raymond','','','','34','458551393','10235 PHELAN BLVD',0,'BEAUMONT','TX','77713','9670','CY','48245','1974-09-27','M','M',':RET:2106-3','N','021','DEN','3409032','33348TX002000201','2014-03-01','2014-01-31 15:56:06','0.00',NULL,NULL,'29.22','29.22','R-TX004','TX0','14.61',NULL,0,'2014-01-31 21:00:24'),(19154,15260,'Y','18','021','EC','A','','','AC','0000184961','0000184961','OH00001435000','IL','1','brown','thomas','','','','34','278748539','5405 north ridge rd e',0,'ashtabula','OH','44004',NULL,'CY','39007','1963-07-14','M','U',':RET:2106-3','N','021','HLT','2370266','52664OH152000901','2014-03-01','2014-01-18 21:49:01','329.02',NULL,NULL,'329.02','0.00','R-OH011','OH0','329.02',NULL,0,'2014-01-21 08:45:36'),(3190,2566,'Y','18','021','EC','A','','','AC','0000363743','0000363743','OH00000150932','IL','1','Holmer','Paul','W','','','34','270468583','405 Liberty Street',0,'Attica','OH','44807',NULL,'CY','39147','1949-10-14','M','M',':RET:2106-3','N','021','HLT','1151331','92036OH003002701','2014-01-01','2013-11-18 13:02:43','229.00',NULL,NULL,'610.89','381.89','R-OH006','OH0','610.89',NULL,0,'2013-12-25 20:32:07'),(4964,3940,'Y','18','021','EC','A','','','AC','0000946250','0000946250','LA00000152588','IL','1','DAVIS','SHARRON','','','','34','434924321','1056 LESAN DR',0,'KENNER','LA','70062','6830','CY','22051','1953-05-16','F','U',':RET:2054-5','N','021','DEN','1039646','18575LA002000201','2014-01-01','2013-12-07 16:54:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:46:14'),(15141,12101,'Y','18','021','EC','A','','','AC','0000291979','0000291979','OH00001661950','IL','1','Sanders','ShonZia','','','','34','273922286','4681 Country Ln',0,'Warrensville Hts','OH','44128',NULL,'CY','39035','1990-01-19','F','U',':RET:2054-5','N','021','DEN','2034474','99734OH005000401','2014-02-01','2013-12-30 08:49:21','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-01 12:05:44'),(14957,11955,'Y','18','021','EC','A','','','AC','0000842374','0000842374','TX00000649513','IL','1','LEE','JON','LUKE','','','34','446948527','400 W VALENCIA DR',0,'AMARILLO','TX','79118',NULL,'CY','48381','1980-02-24','M','M',':RET:2106-3','N','021','DEN','1967340','33348TX002000201','2014-02-01','2013-12-30 08:02:31','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2014-01-01 12:00:24'),(13832,11039,'Y','18','021','EC','A','','','AC','0001031448','0001031448','OH00000131676','IL','1','Sisouphanh','Viengvilay','','','','34','296845344','3140 GRENFALL RD',0,'NORTON','OH','44203','5677','CY','39153','1974-08-01','M','U',':RET:2028-9','N','021','HLT','1914416','52664OH152000901','2014-01-01','2013-12-23 09:36:20','12.00',NULL,NULL,'413.58','401.58','R-OH012','OH0','206.14',NULL,0,'2013-12-26 13:12:08'),(5186,4114,'Y','18','021','EC','A','','','AC','0000459141','0000459141','OH00000766544','IL','1','VOGELGESANG','AMY','JOAN','','','34','269567893','177 CALDWELL DR',0,'CINCINNATI','OH','45216',NULL,'CY','39061','1953-11-01','F','U',':RET:2106-3','N','021','DEN','1667334','99734OH005000401','2014-01-01','2013-12-19 13:07:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:03:38'),(9792,7754,'Y','18','021','EC','A','','','AC','0000245251','0000245251','LA00000088223','IL','1','dickson','bridget','','','','34','261634573','32432 MERCIER RD',0,'DENHAM SPRINGS','LA','70706','1023','CY','22063','1960-11-10','F','U',':RET:2106-3','N','021','DEN','922185','18575LA002000101','2014-01-01','2013-10-20 19:58:47','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2013-12-26 05:01:01'),(6223,4933,'Y','18','024','14','A','','','TE','0000478438','0000478438','','IL','1','Moore','Erica','Jane',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-07-08','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-16 20:06:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:31:13'),(7784,6164,'Y','18','021','EC','A','','','AC','0000703523','0000703523','TX00000831067','31','1','Crone','Swen','','','','34','450479425','Box 1630',0,'Hilltop Lakes','TX','77871',NULL,'CY','48289','1962-10-24','M','U',NULL,'N','021','DEN','2039326','33348TX002000201','2014-01-01','2013-12-20 09:00:20','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:15'),(7644,6051,'N','01','021','EC','A',NULL,NULL,'','0000644634','0000151936','','IL','1','Estridge','Stephanie','Ann','','','34','282926362','3081 Neisel Ave',0,'Cincinnati','OH','45248',NULL,'CY','39061','1990-06-02','F','',':RET:2106-3','N','021','DEN','530872','99734OH005000401','2014-01-01','2013-11-10 11:38:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:46:39'),(25793,20455,'N','19','021','EC','A',NULL,NULL,'','0000394984','0000834511','','IL','1','Roth','Justin','','','','34','296984190','1155 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1996-02-28','M','',':RET:2106-3','N','021','DEN','3284779','99734OH005000301','2014-03-01','2014-02-26 10:00:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:00:12'),(26242,20813,'Y','18','024','14','A','','','TE','0001226884','0001226884','','IL','1','KRENEK','HELEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-02-10','F','',NULL,NULL,NULL,'','3672296','','2014-02-27','2014-02-27 11:03:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-28 06:31:05'),(26756,21204,'N','01','021','EC','A',NULL,NULL,'','0000674883','0000879894','','IL','1','Fuller','Michelle','Renee','','','34','454633797','308 CR 3062',0,'Newton','TX','75966',NULL,'CY','48351','1971-07-23','F','',':RET:2106-3','T','021','DEN','3528589','33348TX002000201','2014-04-01','2014-03-01 17:48:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61','CIC',0,'2014-03-01 19:00:05'),(28299,22390,'Y','18','024','14','A','','','TE','0000876105','0000876105','','IL','1','Morris','Paul',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-02-02','M','',NULL,NULL,NULL,'','3748993','','2014-03-31','2014-03-07 11:14:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:31'),(864,715,'Y','18','021','EC','A','','','AC','0001083069','0001083069','OH00000626994','IL','1','quaintance','george','','','','34','281502296','1073 BIRCH DR',0,'PERRYSBURG','OH','43551','2329','CY','39173','1951-05-19','M','U',NULL,'T','021','HLT','1639271','92036OH006002601','2014-01-01','2013-12-16 09:34:54','505.00',NULL,NULL,'510.93','5.93','R-OH001','OH0','510.93',NULL,0,'2013-12-25 18:07:15'),(23300,18575,'Y','18','021','EC','A','','','AC','0000359726','0000359726','OH00001861735','S3','1','Smith','Jeffery','Janine','','','34','312170809','2303 MARION MOUNT GILEAD RD',0,'MARION','OH','43302','8912','CY','39101','1996-04-29','F','U',':RET:2106-3','N','021','DEN','3575229','99734OH005000301','2014-03-01','2014-02-13 01:12:11','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','21.13',NULL,0,'2014-02-13 22:00:13'),(3789,3035,'N','01','021','EC','A',NULL,NULL,'','0000195113','0000725042','','IL','1','Spencer','Richard','O','','Sr','34','288480556','8066 WAGGONER TRACE DR',0,'BLACKLICK','OH','43004','7093','CY','39049','1950-12-29','M','',':RET:2054-5','N','021','DEN','1231216','99734OH005000301','2014-01-01','2013-12-13 09:53:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:34:10'),(21106,16863,'N','01','021','EC','A',NULL,NULL,'','0000874735','0000333906','','IL','1','Pylypuik','Laura','S',NULL,NULL,NULL,NULL,'9155 BEAUTIFUL LN',0,'SYLVANIA','OH','43560','9269','CY','39095','1971-12-29','F','',NULL,'N','021','HLT','2805952','92036OH004002601','2014-03-01','2014-02-02 18:08:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','207.75',NULL,0,'2014-02-03 21:00:04'),(8856,7021,'Y','18','021','EC','A','','','AC','0000217244','0000217244','TX00000222213','IL','1','Nelms','Aurelia','','','','34','455176418','124 ACE RANCH RD',0,'KERRVILLE','TX','78028','9711','CY','48265','1953-09-25','F','U',NULL,'N','021','DEN','2355885','33348TX002000201','2014-01-01','2013-12-18 10:41:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:01:09'),(4653,3689,'Y','18','021','EC','A','','','AC','0000864799','0000864799','OH00001086363','IL','1','Wilson','Cecily','','','','34','301868777','6573 PLAINFIELD RD',0,'CINCINNATI','OH','45213','1927','CY','39061','1977-12-27','F','U',':RET:1002-5^:RET:2054-5','N','021','HLT','453420','92036OH004001201','2014-01-01','2013-12-11 23:26:53','86.00',NULL,NULL,'212.32','126.32','R-OH004','OH0','212.32',NULL,0,'2013-12-25 22:07:09'),(18070,14433,'Y','18','021','EC','A','','','AC','0002165889','0002165889','LA00002353074','IL','1','Percival','Brandy','','','','34','434534815','122 JACK ST',0,'HAUGHTON','LA','71037','9105','CY','22015','1972-11-08','F','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1443841','18575LA002000201','2014-02-01','2014-01-14 01:07:31','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-15 02:07:23'),(16728,13388,'Y','18','021','EC','A','','','AC','0000054475','0000054475','OH00001936319','IL','1','knutty','michael','','','','34','287680885','1708 apt a horizon',0,'akron','OH','44313',NULL,'CY','39153','1966-07-28','M','U',':RET:2106-3','N','021','HLT','1587227','52664OH151001306','2014-02-01','2014-01-07 14:12:02','261.00',NULL,NULL,'348.56','87.56','R-OH012','OH0','348.56',NULL,0,'2014-01-08 18:24:49'),(7754,6142,'Y','18','021','EC','A','','','AC','0000236264','0000236264','OH00001040789','IL','1','SMITH','LISA','','','','34','287680105','11950 SPERRY RD',0,'CHESTERLAND','OH','44026','2225','CY','39055','1959-07-27','F','U',':RET:2106-3','N','021','DEN','2484251','99734OH005000401','2014-01-01','2013-12-20 16:41:17','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 03:02:35'),(26078,20680,'Y','18','021','EC','A','','','AC','0001372530','0001372530','LA00002562717','IL','1','BAILEY','JUDY','','','','34','437960972','1419 OAKLAND ST',0,'PINEVILLE','LA','71360','5167','CY','22079','1955-07-12','F','U',':RET:2106-3','N','021','DEN','3536755','18575LA002000201','2014-04-01','2014-02-26 18:00:46','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-02-28 06:30:03'),(26320,20881,'N','01','021','EC','A',NULL,NULL,'','0000910577','0000476020','','IL','1','Horwath','Jessica','Nicole','','','34','281887482','223 LAFAYETTE AVE',0,'URBANA','OH','43078','1421','CY','39021','1986-12-12','F','',':RET:2106-3','N','021','HLT','2766489','92036OH005000501','2014-04-01','2014-02-27 17:40:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','249.11',NULL,0,'2014-02-28 06:31:36'),(26513,21029,'Y','18','021','EC','A','','','AC','0000117830','0000117830','OH00003321712','IL','1','Knape','Steven','','','','34','503904461','128 MEEKER ST',0,'BOWLING GREEN','OH','43402','2215','CY','39173','1963-03-19','M','U',':RET:2106-3','N','021','HLT','2920213','92036OH002002601','2014-04-01','2014-02-28 12:04:03','65.00',NULL,NULL,'419.99','354.99','R-OH001','OH0','419.99','CIC',0,'2014-02-28 21:00:20'),(28285,22382,'Y','18','024','14','A','','','TE','0002253953','0002253953','','IL','1','Bradford','anna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-04-26','F','',NULL,NULL,NULL,'','3705898','','2014-03-07','2014-03-07 15:05:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-03-07 21:00:26'),(384,319,'Y','18','021','EC','A','','','AC','0000827126','0000827126','OH00001145372','IL','1','McRae-Gibson','Margaret','','','','34','284624412','1520 Norman Ave.',0,'Youngstown','OH','44506',NULL,'CY','39099','1958-04-08','F','M',':RET:2054-5','N','021','HLT','25262','92036OH004003201','2014-01-01','2013-12-03 18:22:43','818.05',NULL,NULL,'824.07','6.02','R-OH013','OH0','434.03',NULL,0,'2013-12-25 17:45:49'),(23564,18772,'Y','18','021','EC','A','','','AC','0000223741','0000223741','OH00002390124','IL','1','Wiechman','Janet','','','','34','280484049','618 PARK AVE',0,'FOSTORIA','OH','44830','1449','CY','39173','1951-05-11','F','U',':RET:2106-3','N','021','HLT','2940319','92036OH004002601','2014-03-01','2014-02-13 09:56:56','447.17',NULL,NULL,'450.46','3.29','R-OH001','OH0','450.46',NULL,0,'2014-02-13 22:02:46'),(23133,18439,'Y','18','021','EC','A','','','AC','0000821057','0000821057','OH00002110797','IL','1','Burchette','Krystal','','','','34','300888793','815 ROCK CREEK DR',0,'AURORA','OH','44202','7610','CY','39133','1988-08-01','F','R',':RET:2054-5','N','021','HLT','2847653','52664OH151001301','2014-03-01','2014-02-11 19:47:09','0.00',NULL,NULL,'223.90','223.90','R-OH012','OH0','223.90',NULL,0,'2014-02-12 21:31:31'),(9262,7346,'Y','18','021','EC','A','','','AC','0000064171','0000064171','LA00000060751','31','1','gervais','bret','n','','','34','439775703','344 hellios ave',0,'metairi','LA','70005',NULL,'CY','22051','1984-07-02','M','U',':RET:2106-3','N','021','DEN','1155520','18575LA002000201','2014-01-01','2013-11-30 13:05:07','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 04:15:21'),(4757,3772,'Y','18','021','EC','A','','','AC','0000115352','0000115352','TX00000121043','IL','1','Cox','Rebecca','','','','34','462212279','1504 PHILLIP CT',0,'IRVING','TX','75060','5731','CY','48113','1959-08-24','F','U',':RET:2106-3','N','021','DEN','581138','33348TX002000101','2014-01-01','2013-12-07 22:12:55','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 22:15:25'),(15276,12212,'Y','18','021','EC','A','','','AC','0001064727','0001064727','OH00001402879','IL','1','Phillips','Daniel','','','','34','566027169','1392 PRESIDENTIAL DR',0,'COLUMBUS','OH','43212','1295','CY','39049','1966-03-13','M','U',NULL,'N','021','DEN','2493669','99734OH005000401','2014-02-01','2014-01-01 09:10:04','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:21:57'),(14293,11402,'Y','18','021','EC','A','','','AC','0000767403','0000767403','OH00000057101','IL','1','Tartaglia','Michael','','','','34','113600755','11219 Detroit Ave.',0,'Cleveland','OH','44102',NULL,'CY','39035','1962-03-04','M','U',NULL,'T','021','HLT','1751573','52664OH152000901','2014-02-01','2013-12-26 12:43:11','0.00',NULL,NULL,'395.11','395.11','R-OH011','OH0','395.11',NULL,0,'2013-12-27 02:06:37'),(19725,15719,'Y','18','021','EC','A','','','AC','0001785149','0001785149','LA00001404741','IL','1','HARDAWAY','JAMES','','','Jr','34','327509006','2020 VALLEY VIEW CIRCLE',0,'BOSSIER CITY','LA','71111',NULL,'CY','22015','1955-09-26','M','U',':RET:2054-5','N','021','DEN','1515320','18575LA002000201','2014-03-01','2014-01-23 10:47:29','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-23 21:01:00'),(14372,11463,'Y','18','021','EC','A','','','AC','0000110528','0000110528','OH00001209774','IL','1','Nixon','Heather','Teresa','','','34','296863296','3025 WESTWOOD NORTHERN BLVD',0,'CINCINNATI','OH','45211','3625','CY','39061','1982-03-07','F','U',':RET:2106-3','N','021','DEN','1416524','99734OH005000401','2014-02-01','2013-12-27 11:22:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-28 03:30:33'),(19407,15474,'Y','18','024','14','A','','','TE','0000813101','0000813101','','IL','1','GRIFFIN','STANLEY','J','','Jr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-09-19','M','',NULL,NULL,NULL,'','1592410','','2014-01-21','2014-01-21 11:05:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:56'),(19262,15351,'Y','18','024','14','A','','','TE','0001043367','0001043367','','IL','1','BUTTRAM','MICHAEL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-03-06','M','',NULL,NULL,NULL,'','993817','','2014-01-20','2014-01-20 12:16:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:49'),(17030,13625,'Y','18','021','EC','A','','','AC','0000179917','0000179917','OH00001974297','IL','1','Hudson','David','','','','34','300606135','1556 CLAY AVE',0,'TOLEDO','OH','43608','2260','CY','39095','1971-06-04','M','U',':RET:2054-5','N','021','HLT','1612309','92036OH005002601','2014-02-01','2014-01-09 10:30:57','0.00',NULL,NULL,'258.38','258.38','R-OH001','OH0','258.38',NULL,0,'2014-01-13 02:20:43'),(17519,14006,'Y','18','021','EC','A','','','AC','0000721360','0000721360','OH00002152543','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','N','021','DEN','1619392','99734OH005000401','2014-02-01','2014-01-12 10:26:55','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:35'),(25042,19859,'Y','18','021','EC','A','','','AC','0000300457','0000300457','OH00002186461','IL','1','Stacy','Vernon','','','','34','406844295','25 HELMER CIR',0,'ENON','OH','45323','1229','CY','39023','1956-02-22','M','U',':RET:2106-3','N','021','HLT','3508452','92036OH006000501','2014-04-01','2014-02-19 19:50:27','369.00',NULL,NULL,'480.33','111.33','R-OH003','OH0','480.33',NULL,0,'2014-02-20 22:01:11'),(885,733,'Y','18','021','EC','A','','','AC','0000993958','0000993958','OH00000404233','IL','1','Detwiler','Joesph','','','','34','284482122','9707 U.S. RT 224',0,'VAN WERT','OH','45891',NULL,'CY','39161','1950-03-03','M','M',':RET:2106-3','N','021','HLT','2123254','92036OH002001501','2014-01-01','2013-12-16 11:24:38','949.00',NULL,NULL,'1411.87','462.87','R-OH002','OH0','750.27',NULL,0,'2013-12-25 18:07:51'),(22648,18083,'Y','18','024','14','A','','','TE','0000044816','0000044816','','IL','1','Hollister','Philip',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1966-01-21','M','',NULL,NULL,NULL,'','3519821','','2014-02-11','2014-02-11 11:02:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-11 21:00:26'),(7456,5899,'N','01','021','EC','A',NULL,NULL,'','0000896969','0000589300','','IL','1','KOPPEL','MELANIE','ANN','','','34','453679813','2162 TOWNLINE RD',0,'MADISON','OH','44057','1762','CY','39085','1968-03-31','F','',':RET:2106-3','N','021','DEN','1020153','99734OH005000301','2014-01-01','2013-12-15 12:34:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:30:46'),(22341,17842,'Y','18','021','EC','A','','','AC','0000525613','0000525613','OH00002478394','IL','1','yassine','mahmoud','','','','34','293119523','7160 LOCUST AVE',0,'YOUNGSTOWN','OH','44512','4823','CY','39099','1982-07-13','M','R',':RET:2106-3','N','021','HLT','3325278','52664OH151001501','2014-03-01','2014-02-02 15:37:48','0.00',NULL,NULL,'351.54','351.54','R-OH013','OH0','351.54',NULL,0,'2014-02-10 11:01:08'),(4379,3480,'Y','18','021','EC','A','','','AC','0000190181','0000190181','OH00000151277','IL','1','Hoq','Reyhan','','','','34','514904864','1763 SUMMERSWEET CIR',0,'LEWIS CENTER','OH','43035','7198','CY','39041','1986-03-07','M','U',':RET:2029-7','N','021','DEN','703397','99734OH005000401','2014-01-01','2013-12-12 09:08:45','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:33'),(15321,12253,'Y','18','021','EC','A','','','AC','0000487887','0000487887','TX00001482652','IL','1','Harris','Gracie','','','','34','467454654','5500 ROLLING GREEN RD',0,'ARLINGTON','TX','76017','6263','CY','48439','1963-10-16','F','U',':RET:2054-5','N','021','DEN','2040948','33348TX002000201','2014-02-01','2013-12-31 21:27:04','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:23:33'),(19211,15306,'Y','18','024','14','A','','','TE','0000029072','0000029072','','IL','1','PILKINGTON','SCOT',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-04-12','M','',NULL,NULL,NULL,'','3017560','','2014-01-20','2014-01-20 11:17:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:22'),(18265,14582,'Y','18','021','EC','A','','','AC','0000034473','0000034473','TX00002480343','IL','1','Sotelo','Gudelia','','','','34','466975157','301 FORREST LN',0,'CORSICANA','TX','75110','1811','CY','48349','1950-09-29','F','U',NULL,'N','021','DEN','2480025','33348TX002000201','2014-02-01','2014-01-15 15:30:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-16 08:44:39'),(28635,22661,'Y','18','021','EC','A','','','AC','0000892767','0000892767','TX00003270264','IL','1','Hanyon','Catherine','','','','34','098402347','107 Cathedral Mtn Pass',0,'Georgetown','TX','78633',NULL,'CY','48491','1958-07-19','F','U',':RET:2106-3','N','021','DEN','3826259','33348TX002000201','2014-04-01','2014-03-08 12:12:20','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-03-08 21:30:29'),(1811,1489,'Y','18','021','EC','A','','','AC','0001166821','0001166821','OH00000177567','IL','1','Niklas','Christian','','','','34','298866478','80 E CASE DR',0,'HUDSON','OH','44236','2744','CY','39153','1971-08-21','M','M',':RET:2106-3','N','021','HLT','2153126','52664OH151001501','2014-01-01','2013-12-24 14:40:41','101.00',NULL,NULL,'1048.46','947.46','R-OH012','OH0','354.39',NULL,0,'2013-12-25 18:57:02'),(2137,1755,'Y','18','024','14','A','','','TE','0000309414','0000309414','','IL','1','Fletcher','Roy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-06-29','M','',NULL,NULL,NULL,'','732010','','2013-12-10','2013-12-10 16:55:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 19:18:08'),(23001,18337,'Y','18','021','EC','A','','','AC','0000784404','0000784404','OH00002276906','IL','1','Van dusen','Thomas','','','','34','302509572','1015 MCDOWELL ST NE',0,'CANTON','OH','44721','3136','CY','39151','1954-04-17','M','M',':RET:2106-3','N','021','DEN','2627613','99734OH005000301','2014-03-01','2014-02-12 14:00:31','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2014-02-12 21:30:19'),(22771,18180,'Y','18','021','EC','A','','','AC','0000376180','0000376180','OH00002285826','IL','1','Simonson','Kathy','J','','','34','291844620','245 SCOTT DR',0,'ENGLEWOOD','OH','45322','1145','CY','39113','1971-07-02','F','M',':RET:2106-3','N','021','DEN','2863326','99734OH005000401','2014-03-01','2014-02-11 12:25:43','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-11 21:01:37'),(6152,4877,'N','01','021','EC','A',NULL,NULL,'','0000608572','0000441835','','IL','1','kuliska','melissa','ann','','','34','190662344','821 AURORA ST',0,'HOUSTON','TX','77009','1053','CY','48201','1970-01-06','F','',NULL,'N','021','DEN','1117264','33348TX002000101','2014-01-01','2013-11-21 11:08:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 00:16:32'),(19726,15720,'Y','18','021','EC','A','','','AC','0002260191','0002260191','LA00002293898','IL','1','JONES','CHELSEA','','','','34','437734564','559 MAGNOLIA DR',0,'MARRERO','LA','70072','1112','CY','22051','1985-01-06','F','U',NULL,'N','021','DEN','1830714','18575LA002000201','2014-03-01','2014-01-23 13:04:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-23 21:01:01'),(19315,15397,'Y','18','021','EC','A','','','AC','0001110614','0001110614','TX00002582290','IL','1','GARZA','ANGELICA','','','','34','459797329','3926 PANAMA DR',0,'CORPUS CHRISTI','TX','78415',NULL,'CY','48355','1986-11-03','F','U',NULL,'T','021','DEN','3169772','33348TX002000201','2014-03-01','2014-01-21 00:49:33','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,1,'2014-01-22 03:22:08'),(15140,12100,'Y','18','021','EC','A','','','AC','0000890762','0000890762','OH00001177985','IL','1','WILLIS','MARTIN','','','','34','298742774','1707 JOSEPH COURT',0,'CINCINATTI','OH','45231',NULL,'CY','39061','1978-07-31','M','U',':RET:2054-5','N','021','DEN','2024951','99734OH005000401','2014-02-01','2013-12-30 08:19:12','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:05:42'),(18563,14804,'Y','18','021','EC','A','','','AC','0000047110','0000047110','OH00001504333','IL','1','dehart','Melissa','','','','34','269901971','5491 st rt 138',0,'hillsboro','OH','45133',NULL,'CY','39071','1983-03-14','F','U',NULL,'N','021','HLT','3015009','92036OH005000606','2014-02-01','2014-01-15 17:38:32','208.00',NULL,NULL,'243.66','35.66','R-OH005','OH0','243.66',NULL,0,'2014-01-16 08:47:00'),(16096,12892,'Y','18','021','EC','A','','','AC','0001095668','0001095668','OH00001706378','IL','1','Della Flora','Michael','','','','34','292423365','808 ATLANTIC AVE',0,'TOLEDO','OH','43609','3008','CY','39095','1957-06-18','M','M',NULL,'N','021','HLT','1878096','92036OH006002601','2014-02-01','2014-01-03 08:24:27','23.00',NULL,NULL,'360.78','337.78','R-OH001','OH0','360.78',NULL,0,'2014-01-04 02:04:37'),(25448,20192,'Y','18','021','EC','A','','','AC','0000763614','0000763614','TX00003278587','IL','1','DAVISON','JEFF','','','','34','551492603','210 S PALMER AVE',0,'TYLER','TX','75702','6353','CY','48423','1973-10-27','M','U',':RET:2054-5','N','021','DEN','2938415','33348TX002000201','2014-04-01','2014-02-25 13:04:26','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-25 21:31:24'),(26960,21361,'Y','18','021','EC','A','','','AC','0000927364','0000927364','OH00002497385','IL','1','MOZINA','LISA','','','','34','288804045','9102 TANGLEWOOD RD',0,'MACEDONIA','OH','44056',NULL,'CY','39153','1969-02-18','F','M',NULL,'N','021','HLT','2807667','52664OH151001301','2014-04-01','2014-03-02 13:46:54','530.00',NULL,NULL,'960.94','430.94','R-OH012','OH0','322.02',NULL,0,'2014-03-03 01:00:30'),(27422,21701,'Y','18','021','EC','A','','','AC','0001535481','0001535481','LA00003081516','IL','1','DAVIS','WENDELL','KENNETH','','','34','435985837','203 CALIFORNIA ST',0,'THIBODAUX','LA','70301','6117','CY','22057','1957-09-21','M','U',':RET:2054-5','N','021','DEN','3539665','18575LA002000201','2014-04-01','2014-03-03 21:36:23','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-03-04 21:01:40'),(27623,21848,'Y','18','021','EC','A','','','AC','0001413961','0001413961','LA00003382543','IL','1','White','Beverly','','','','34','433984271','400 Voters Road',0,'Slidell','LA','70461',NULL,'CY','22103','1954-12-14','F','U',':RET:2054-5','N','021','DEN','3347839','18575LA002000101','2014-04-01','2014-03-05 17:53:08','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-03-05 21:30:05'),(5798,4606,'Y','18','021','EC','A','','','AC','0001084152','0001084152','OH00000447840','IL','1','Temple','Kathleen','','','','34','268502660','520 Milan Ave.',0,'Norwalk','OH','44857',NULL,'CY','39077','1952-07-13','F','U',':RET:2106-3','N','021','DEN','2029435','99734OH005000401','2014-01-01','2013-12-24 01:51:55','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2013-12-25 23:47:26'),(23113,18422,'Y','18','021','EC','A','','','AC','0000476010','0000476010','OH00002243474','IL','1','GINGRAS','CHRISTINA','MARIE','','','34','274822574','859 CASCADE RD',0,'CINCINNATI','OH','45240','3611','CY','39061','1978-02-23','F','U',':RET:2106-3','T','021','DEN','3006222','99734OH005000401','2014-03-01','2014-02-12 17:12:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-12 21:31:19'),(20290,16195,'Y','18','021','EC','A','','','AC','0001177293','0001177293','LA00002399952','IL','1','DAIRE','CRYSTAL','RENEE','','','34','433675122','6618 LONGLEAF TRCE',0,'BALL','LA','71405','3130','CY','22079','1981-09-24','F','U',':RET:2106-3','N','021','DEN','3491775','18575LA002000201','2014-03-01','2014-01-28 10:51:44','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2014-01-28 21:00:35'),(4608,3649,'Y','18','021','EC','A','','','AC','0000221265','0000221265','OH00001229282','IL','1','Nesbitt','Valarie','Jean','','','34','291741146','1131 HARDESTY BLVD',0,'AKRON','OH','44320','3506','CY','39153','1966-01-18','F','U',':RET:2054-5','N','021','HLT','931393','52664OH151001501','2014-01-01','2013-12-11 20:55:23','0.00',NULL,NULL,'418.05','418.05','R-OH012','OH0','418.05',NULL,0,'2013-12-25 22:05:54'),(2525,2058,'Y','18','021','EC','A','','','AC','0000707593','0000707593','OH00001183053','IL','1','Maghiar','Angelica','','','','34','272822331','3120 WESTMORELAND AVE NW',0,'CANTON','OH','44718','3339','CY','39151','1954-11-17','F','U',NULL,'N','021','HLT','1096813','52664OH152000901','2014-01-01','2013-12-09 16:53:23','319.00',NULL,NULL,'425.18','106.18','R-OH015','OH0','425.18',NULL,0,'2013-12-25 19:36:41'),(3547,2847,'N','19','021','EC','A',NULL,NULL,'','0000454421','0000906185','','IL','1','Wolfe','Justin','Jay','','Jr','34','818791483','3112 E COUNTY ROAD 136',0,'MIDLAND','TX','79706','7130','CY','48329','2012-04-04','M','',NULL,'N','021','DEN','2252551','33348TX002000101','2014-01-01','2013-12-22 18:23:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2013-12-25 21:21:56'),(18144,14489,'Y','18','021','EC','A','','','AC','0002261621','0002261621','LA00002159250','IL','1','king','kody','','','','34','434735898','16086 smith-wallace rd',0,'franklinton','LA','70438',NULL,'CY','22117','1988-04-26','M','U',':RET:2106-3','T','021','DEN','2834790','18575LA002000101','2014-02-01','2014-01-14 15:22:43','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-15 02:07:47'),(9420,7473,'N','01','021','EC','A',NULL,NULL,'','0000623645','0001209508','','IL','1','Brown','Jarrod',NULL,NULL,NULL,NULL,NULL,'360 COUNTY ROAD 430',0,'STEPHENVILLE','TX','76401','7281','CY','48143','1983-12-28','M','',':RET:2106-3','N','021','DEN','2309508','33348TX002000201','2014-01-01','2013-12-21 14:17:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:33:04'),(23692,18867,'N','01','021','EC','A',NULL,NULL,'','0001214848','0000563186','','IL','1','BLACKWOOD','GREGORY','','','','34','270704932','267 SOUTH BLVD',0,'WADSWORTH','OH','44281','1782','CY','39103','1960-10-20','M','',':RET:2106-3','N','021','DEN','2934668','99734OH005000401','2014-03-01','2014-02-13 22:27:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:38'),(1336,1106,'Y','18','021','EC','A','','','AC','0000573026','0000573026','OH00000525751','IL','1','silver','marlo','','','','34','544663136','7238 HERRICK PARK DR',0,'HUDSON','OH','44236','2316','CY','39153','1969-05-10','F','M',':RET:2106-3','N','021','HLT','682879','52664OH151001304','2014-01-01','2013-11-07 01:59:13','316.00',NULL,NULL,'592.98','276.98','R-OH012','OH0','311.54',NULL,0,'2013-12-25 18:32:16'),(5335,4231,'Y','18','021','EC','A','','','AC','0000380044','0000380044','OH00001143605','IL','1','Schmittauer','John','','','','34','287543622','10500 SAND RIDGE RD',0,'MILLFIELD','OH','45761','9665','CY','39009','1953-02-22','M','U',':RET:2106-3','N','021','DEN','1891204','99734OH005000301','2014-01-01','2013-12-19 14:26:55','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 23:07:11'),(19969,15928,'N','19','021','EC','A',NULL,NULL,'','0000520989','0000770022','','IL','1','PODLICH','JOSHUA','EUGENE','','','34','276904940','360 HENRY ST',0,'AMHERST','OH','44001','2427','CY','39093','1989-01-02','M','',':RET:2106-3','N','021','DEN','2865151','99734OH005000301','2014-03-01','2014-01-25 13:22:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:10'),(19310,15393,'Y','18','024','14','A','','','TE','0000067029','0000067029','','IL','1','Saltzman','Angel','Michelle-Harris',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-05-27','F','',NULL,NULL,NULL,'','2730131','','2014-01-20','2014-01-20 22:03:12',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',1,'2014-01-22 03:22:05'),(18461,14727,'Y','18','021','EC','A','','','AC','0001156322','0001156322','LA00001904235','IL','1','Webb','Carolyn','','','','34','434948123','407 MORRIS AVE',0,'MONROE','LA','71202','2039','CY','22073','1954-08-22','F','U',':RET:2054-5','N','021','DEN','2741271','18575LA002000101','2014-02-01','2014-01-15 09:50:05','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-01-16 08:46:12'),(16945,13562,'Y','18','021','EC','A','','','AC','0001407471','0001407471','LA00001612920','IL','1','corney','leora','','','','34','435271500','12236 GEBHART DR',0,'baton rouge','LA','70816',NULL,'CY','22033','1972-05-03','F','U',':RET:2054-5','N','021','DEN','2046134','18575LA002000201','2014-02-01','2014-01-09 15:10:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:19:56'),(4915,3899,'Y','18','021','EC','A','','','AC','0000128654','0000128654','MS00000290561','IL','1','dent','latesha','','','','34','322664499','932 Richburg Road',0,'Hattiesburg','MS','39402',NULL,'CY','28073','1977-07-21','F','U',':RET:2054-5','N','021','DEN','274099','46300MS002000201','2014-01-01','2013-10-25 21:12:22','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-25 22:32:13'),(15534,12429,'Y','18','021','EC','A','','','AC','0001506555','0001506555','LA00000608362','31','1','Heckard','Marquis','','','','34','458670454','P.O. Box 608',0,'Gilbert','LA','71336',NULL,'CY','22041','1983-06-21','M','U',':RET:2054-5','T','021','DEN','1501272','18575LA002000201','2014-02-01','2013-12-31 13:34:19','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:30:44'),(1455,1213,'Y','18','021','EC','A','','','AC','0000763526','0000763526','OH00000041253','IL','1','Pamphilis','Annamarie','','','','34','284749157','4801 SPRUCEWOOD ST',0,'AVON','OH','44011','2716','CY','39093','1963-01-19','F','M',':RET:2106-3','N','021','DEN','2219502','99734OH005000401','2014-01-01','2013-12-24 08:03:59','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:48:10'),(4020,3210,'Y','18','021','EC','A','','','AC','0000843321','0000843321','OH00000348149','IL','1','Bates','Geneva','','','','34','407704489','335 GUINTHER CT',0,'GALION','OH','44833','2565','CY','39033','1952-10-15','F','M',':RET:2106-3','N','021','DEN','2258852','99734OH005000401','2014-01-01','2013-12-17 08:30:28','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 21:45:38'),(14102,11238,'Y','18','021','EC','A','','','AC','0000224729','0000224729','OH00000880025','IL','1','Loury','Donnell','','','','34','302703142','754EAST118 3RD FLOOR',0,'Clevland','OH','44108',NULL,'CY','39035','1963-11-05','M','U',':RET:2054-5','T','021','DEN','1360037','99734OH005000401','2014-02-01','2013-12-26 12:55:56','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:01:37'),(3306,2660,'N','19','021','EC','A',NULL,NULL,'','0000097572','0000553909','','IL','1','Manansala','Kaden','','','','34','157697376','1085 TREELINE WAY',0,'DELAWARE','OH','43015','3547','CY','39041','2013-06-24','M','',':RET:2036-2','N','021','DEN','1644492','99734OH005000301','2014-01-01','2013-12-22 13:36:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:15:48'),(3171,2549,'Y','18','021','EC','A','','','AC','0000307066','0000307066','OH00000856261','IL','1','Wainscott','Peggy','','','','34','296526826','7560 EVANS CT',0,'FAIRFIELD','OH','45011','9308','CY','39017','1952-12-13','F','U',':RET:2106-3','N','021','DEN','878199','99734OH005000401','2014-01-01','2013-11-18 13:52:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 20:31:31'),(23933,19031,'Y','18','021','EC','A','','','AC','0001111704','0001111704','OH00002180310','IL','1','Wilcox','Debra','','','','34','234940392','5860 KILBURY HUBER RD',0,'PLAIN CITY','OH','43064','9557','CY','39097','1970-08-30','F','M',NULL,'N','021','DEN','2969208','99734OH005000401','2014-03-01','2014-02-14 18:29:08','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00','CIC',0,'2014-02-15 21:00:04'),(27190,21528,'Y','18','021','EC','A','','','AC','0000525651','0000525651','TX00003016583','IL','1','SCOTT','DESMOND','','','','34','455659381','216 WEST FERRIS STREET',0,'WARDEN','TX','77488',NULL,'CY','48481','1986-11-03','M','M',':RET:2054-5','N','021','DEN','3554050','33348TX002000201','2014-04-01','2014-03-03 15:44:28','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:15'),(27638,21860,'Y','18','021','EC','A','','','AC','0000305899','0000305899','OH00003159890','IL','1','Jones','Marla','','','','34','272882259','9102 MEADOWGLEN DR',0,'CINCINNATI','OH','45231','3637','CY','39061','1983-04-22','F','U',NULL,'N','021','DEN','3828506','99734OH005000401','2014-04-01','2014-03-05 10:51:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:30:14'),(27954,22114,'Y','18','021','EC','A','','','AC','0000153234','0000153234','TX00003376424','IL','1','Phillips','Amy','','','','34','480060898','810 W MARFA AVE',0,'ALPINE','TX','79830','1729','CY','48043','1979-12-01','F','M',':RET:2106-3','N','021','DEN','3570032','33348TX002000201','2014-04-01','2014-03-06 17:54:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:40'),(28077,22221,'Y','18','021','EC','A','','','AC','0000158072','0000158072','TX00002870036','IL','1','Mejia','Veronica','','','','34','318780779','7550 Kirby dr',0,'Houston','TX','77030',NULL,'CY','48201','1987-01-13','F','U',NULL,'N','021','DEN','4018850','33348TX002000101','2014-04-01','2014-03-05 19:43:05','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-03-06 21:01:54'),(971,795,'N','01','021','EC','A',NULL,NULL,'','0000214615','0000682116','','IL','1','Wright','Carolyn','Maxine','','','34','282529590','3820 Townsend Angling Road',0,'Collins','OH','44826',NULL,'CY','39077','1954-02-20','F','',':RET:2106-3','N','021','HLT','827071','92036OH002002701','2014-01-01','2013-10-28 19:32:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','586.17',NULL,0,'2013-12-25 18:10:01'),(4172,3321,'Y','18','021','EC','A','','','AC','0000342719','0000342719','OH00000570632','IL','1','Trimble','Randi','','','','34','269704892','5086 SANTA FE DR',0,'DAYTON','OH','45414','3628','CY','39113','1960-01-22','F','M',':RET:2106-3','T','021','HLT','1730921','92036OH006000501','2014-01-01','2013-12-16 19:24:13','0.00',NULL,NULL,'442.26','442.26','R-OH003','OH0','442.26',NULL,0,'2013-12-25 21:49:15'),(19251,15341,'Y','18','024','14','A','','','TE','0000188827','0000188827','','IL','1','Dinh','Lan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-04-22','F','',NULL,NULL,NULL,'','1256918','','2014-01-20','2014-01-20 09:49:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:43'),(18355,14653,'Y','18','021','EC','A','','','AC','0000404820','0000404820','OH00002448608','IL','1','Koloskee','Michael','','','','34','297681491','12511 CLIFTON BLVD',0,'LAKEWOOD','OH','44107','6502','CY','39035','1975-12-01','M','U',':RET:2106-3','N','021','DEN','2915708','99734OH005000301','2014-02-01','2014-01-14 22:00:38','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:23'),(4353,3455,'Y','18','021','EC','A','','','AC','0000336412','0000336412','OH00000793034','IL','1','Nizny','Stuart','','','','34','278707739','211 KLOTTER AVE',0,'CINCINNATI','OH','45219','1422','CY','39061','1967-10-02','M','U',NULL,'N','021','HLT','1512645','92036OH005001205','2014-01-01','2013-12-17 13:08:46','205.00',NULL,NULL,'322.00','117.00','R-OH004','OH0','322.00',NULL,0,'2013-12-25 21:53:31'),(24001,19085,'Y','18','021','EC','A','','','AC','0000559489','0000559489','OH00001801474','IL','1','Waters','Jennifer','','','','34','284806925','926 MEADOW LN',0,'LEBANON','OH','45036','1427','CY','39165','1970-09-09','F','M',':RET:2106-3','N','021','DEN','3551481','99734OH005000401','2014-03-01','2014-02-15 10:07:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-15 22:00:33'),(17220,13780,'N','19','021','EC','A',NULL,NULL,'','0000468835','0000968912','','IL','1','Lofton','Owond','D','','','34','426734680','134 NORTHVIEW ST',0,'UTICA','MS','39175','8800','CY','28049','1992-01-12','M','',':RET:2054-5','N','021','DEN','2570046','46300MS002000201','2014-02-01','2014-01-08 15:50:22',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 02:22:33'),(17011,13615,'N','19','021','EC','A',NULL,NULL,'','0000145400','0000787211','','IL','1','Hurley','Alexander','James','','','34','029760847','2605 WELLINGTON RD',0,'CLEVELAND HEIGHTS','OH','44118','4120','CY','39035','1993-04-30','M','',':RET:2106-3','N','021','DEN','2106998','99734OH005000301','2014-02-01','2014-01-09 13:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:36'),(28941,22902,'Y','18','021','EC','A','','','AC','0000763595','0000763595','OH00003501142','IL','1','Geib','Douglas','','','','34','290665496','263 Massachusetts Ave.',0,'Elyria','OH','44035',NULL,'CY','39093','1971-01-15','M','U',':RET:2106-3','N','021','DEN','3373515','99734OH005000301','2014-04-01','2014-03-10 17:36:58','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:00:43'),(4274,3405,'Y','18','021','EC','A','','','AC','0000455298','0000455298','OH00000475366','IL','1','hawkins','greg','','','','34','280780271','318 bigelow street',0,'hillsboro','OH','45133',NULL,'CY','39071','1969-08-04','M','U',':RET:2106-3','N','021','HLT','1973892','92036OH001000601','2014-01-01','2013-12-17 10:55:07','60.00',NULL,NULL,'361.74','301.74','R-OH005','OH0','361.74',NULL,0,'2013-12-25 21:51:50'),(20694,16534,'N','01','021','EC','A',NULL,NULL,'','0000854219','0000613026','','IL','1','Henry','Melissa','','','','34','403172076','2440 CONCORDGREEN DR',0,'CINCINNATI','OH','45244','3626','CY','39061','1965-07-06','F','',':RET:2106-3','N','021','DEN','2798559','99734OH005000301','2014-03-01','2014-01-30 11:12:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-30 21:00:59'),(19913,15882,'Y','18','024','14','A','','','TE','0001077629','0001077629','','IL','1','Stevens','Julie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1990-02-22','F','',NULL,NULL,NULL,'','1755522','','2014-01-24','2014-01-24 13:41:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-24 21:01:01'),(19821,15804,'Y','18','021','EC','A','','','AC','0000566636','0000566636','TX00002374819','IL','1','REYES','CRISTIANA','','','','34','082311308','2239 GLASSBURN RD',0,'EL PASO','TX','79906',NULL,'CY','48141','1950-11-30','F','U',NULL,'N','021','DEN','3345455','33348TX002000201','2014-03-01','2014-01-24 16:59:19','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-24 21:00:14'),(19317,15399,'Y','18','021','EC','A','','','AC','0000257704','0000257704','TX00002242978','IL','1','wei','jack','','','','34','639268272','1215 LINCOLN ST',0,'LAREDO','TX','78040','5709','CY','48479','1964-11-26','M','M',':RET:2034-7','N','021','DEN','2381931','33348TX002000201','2014-03-01','2014-01-21 09:39:47','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,1,'2014-01-22 03:22:09'),(5883,4667,'Y','18','021','EC','A','','','AC','0000473653','0000473653','OH00000148165','IL','1','Murphy','Mallory','','','','34','295849282','506 Flintwood Drive',0,'Gahanna','OH','43230',NULL,'CY','39049','1986-08-28','F','U',NULL,'N','021','DEN','1584368','99734OH005000301','2014-01-01','2013-12-23 22:38:06','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:49:28'),(13767,10989,'Y','18','021','EC','A','','','AC','0000439559','0000439559','MS00000029449','31','1','Harris','Leon','','','','34','587500950','P O Box 54',0,'Maben','MS','39750',NULL,'CY','28105','1952-05-21','M','M',':RET:2054-5','N','021','DEN','2612041','46300MS002000201','2014-01-01','2013-12-23 11:01:02','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:24'),(17453,13958,'Y','18','021','EC','A','','','AC','0001005730','0001005730','OH00001697638','IL','1','Kennedy','John','','','','34','283808167','215 STATE ROUTE 781',0,'PEEBLES','OH','45660','9735','CY','39001','1978-04-23','M','M',':RET:2106-3','N','021','HLT','1835802','92036OH002000601','2014-02-01','2014-01-10 14:33:33','310.00',NULL,NULL,'899.17','589.17','R-OH005','OH0','302.93',NULL,0,'2014-01-13 03:00:39'),(7487,5923,'Y','18','021','EC','A','','','AC','0000863449','0000863449','OH00000947170','IL','1','Mitchell','Justin','','','','34','378062314','505 stillpass way',0,'Monroe','OH','45050',NULL,'CY','39017','1988-11-21','M','U',':RET:2106-3','N','021','DEN','1112116','99734OH005000401','2014-01-01','2013-12-15 14:33:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:31:31'),(16062,12863,'Y','18','021','EC','A','','','AC','0000697926','0000697926','OH00002142012','IL','1','Hemmig','Linda','','','','34','283462737','4207 FAIRVIEW DR',0,'TOLEDO','OH','43612','1832','CY','39095','1950-02-12','F','U',':RET:2106-3','N','021','DEN','2436294','99734OH005000401','2014-02-01','2014-01-03 10:34:05','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-01-04 02:03:32'),(6634,5262,'Y','18','021','EC','A','','','AC','0000582776','0000582776','OH00000215686','IL','1','Steagall','Brandi','','','','34','300929115','2610 MOORMAN AVE',0,'CINCINNATI','OH','45206','2182','CY','39061','1976-06-14','F','U',':RET:2054-5','N','021','DEN','810677','99734OH005000401','2014-01-01','2013-11-12 13:10:28','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:00:06'),(15313,12246,'Y','18','021','EC','A','','','AC','0000918858','0000918858','TX00000016535','IL','1','Carter','Kim','','','','34','461068420','1013 NW 10TH ST',0,'TULIA','TX','79088','1023','CY','48437','1953-05-16','M','M',':RET:2106-3','N','021','DEN','1874197','33348TX002000101','2014-02-01','2014-01-01 09:54:54','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,1,'2014-01-02 04:23:17'),(14301,11408,'N','01','021','EC','A',NULL,NULL,'','0000490477','0000965776','','IL','1','Strayer','Kristie','','','','34','280768934','933 TAMARACK DR',0,'WILLARD','OH','44890','9443','CY','39077','1974-02-20','F','',':RET:2106-3','N','021','HLT','1753884','92036OH005002705','2014-02-01','2013-12-26 17:17:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','246.08',NULL,0,'2013-12-27 02:06:50'),(14603,11655,'N','01','021','EC','A',NULL,NULL,'','0000111903','0000171239','','IL','1','GRANDSTAFF','TAMARA','L','','','34','294583342','1345 TOWNSHIP RD 206',0,'MARENGO','OH','43334',NULL,'CY','39117','1956-10-06','F','',':RET:2106-3','N','021','DEN','1686067','99734OH005000301','2014-02-01','2013-12-27 11:42:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-28 03:36:27'),(28127,22259,'Y','18','021','EC','A','','','AC','0000432824','0000432824','OH00003390976','IL','1','Crane','Robert','','','','34','278445175','286 BRENTWOOD DR',0,'HUDSON','OH','44236','1656','CY','39153','1950-08-11','M','M',NULL,'N','021','HLT','3481340','52664OH151001305','2014-04-01','2014-03-06 10:59:54','1005.00',NULL,NULL,'1284.97','279.97','R-OH012','OH0','658.32',NULL,0,'2014-03-06 21:02:23'),(7580,5996,'N','19','021','EC','A',NULL,NULL,'','0000440802','0000255943','','IL','1','Kienzle','Page','A','','','34','362116348','2238 SCOTTWOOD AVE',0,'TOLEDO','OH','43620','1102','CY','39095','1989-09-20','F','',':RET:2106-3','N','021','HLT','394135','92036OH001002601','2014-01-01','2013-12-15 12:30:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','235.20',NULL,0,'2013-12-26 02:33:55'),(24240,19249,'Y','18','021','EC','A','','','AC','0001036178','0001036178','OH00002196766','IL','1','Caseres','Nowlhas','Eurick','','','34','276964235','601 W HOBART AVE',0,'FINDLAY','OH','45840','1230','CY','39063','1969-02-19','M','M',NULL,'N','021','HLT','3207014','92036OH005001505','2014-03-01','2014-02-15 21:56:57','189.00',NULL,NULL,'317.81','128.81','R-OH002','OH0','317.81',NULL,0,'2014-02-16 19:00:39'),(23014,18349,'Y','18','021','EC','A','','','AC','0002168365','0002168365','LA00002335372','IL','1','Sharon','Kathlenn','','','','34','439941491','40455 HIGHWAY 42',0,'PRAIRIEVILLE','LA','70769','5248','CY','22005','1952-03-22','F','U',':RET:2106-3','N','021','DEN','2895867','18575LA002000101','2014-03-01','2014-02-12 10:29:23','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-12 21:30:25'),(4806,3809,'Y','18','021','EC','A','','','AC','0000929819','0000929819','OH00001106914','IL','1','Kaiser','Bettyann','Virginia','','','34','275660036','3775 THORNTON DR',0,'CINCINNATI','OH','45236','3350','CY','39061','1957-11-26','F','U',':RET:2106-3','N','021','HLT','1060705','92036OH002001201','2014-01-01','2013-12-07 19:55:18','100.00',NULL,NULL,'578.36','478.36','R-OH004','OH0','578.36',NULL,0,'2013-12-25 22:16:38'),(22270,17775,'Y','18','021','EC','A','','','AC','0000113045','0000113045','TX00001663718','31','1','Lanham','Amber','','','','34','465859733','PO Box 7731',0,'Horseshoe Bay','TX','78657',NULL,'CY','48299','1983-12-07','F','M',':RET:2106-3','T','021','DEN','3274074','33348TX002000201','2014-03-01','2014-02-03 14:04:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 11:00:13'),(22180,17701,'Y','18','021','EC','A','','','AC','0001160447','0001160447','OH00002042785','IL','1','Quaye','Isaac','','','','34','752134585','935 PYRAMID HILL BLVD',0,'HAMILTON','OH','45013','3780','CY','39017','1984-02-16','M','M',':RET:2054-5','N','021','HLT','3789592','92036OH006001201','2014-03-01','2014-02-08 15:36:58','0.00',NULL,NULL,'193.23','193.23','R-OH004','OH0','193.23','CIC',0,'2014-02-08 19:30:11'),(6887,5463,'Y','18','021','EC','A','','','AC','0001737478','0001737478','LA00001137809','IL','1','deBrueys','Denise','','','','34','349527294','120 BAYBERRY DR',0,'COVINGTON','LA','70433','4702','CY','22103','1955-07-21','F','U',':RET:2106-3','N','021','DEN','2401513','18575LA002000201','2014-01-01','2013-12-24 20:05:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:16'),(6530,5177,'Y','18','021','EC','A','','','AC','0001048761','0001048761','TX00000346472','IL','1','Robles','Dolores','','','','34','454896337','4193 FM 82',0,'CALL','TX','75933','3029','CY','48351','1973-06-20','F','U',':RET:2106-3','N','021','DEN','1059447','33348TX002000201','2014-01-01','2013-12-10 20:03:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:51:38'),(16774,13418,'N','01','021','EC','A',NULL,NULL,'','0000694382','0000479626','','IL','1','Bichon','Mark','J','','','34','411539347','3445 Clepsyda Dr',0,'Hernando','MS','38632',NULL,'CY','28033','1977-11-27','M','',':RET:2106-3','N','021','DEN','2079024','46300MS002000101','2014-02-01','2014-01-07 11:11:19',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','27.15',NULL,0,'2014-01-08 18:25:03'),(26661,21135,'Y','18','021','EC','A','','','AC','0000636067','0000636067','OH00002755179','IL','1','TEKANCIC','MICHELLE','','','','34','296863226','5800 LAURENT DR',0,'PARMA','OH','44129','5969','CY','39035','1985-11-06','F','U',':RET:2106-3','N','021','HLT','3241346','52664OH151001305','2014-04-01','2014-02-28 15:22:38','86.00',NULL,NULL,'273.40','187.40','R-OH011','OH0','273.40',NULL,0,'2014-02-28 21:31:12'),(27335,21645,'Y','18','021','EC','A','','','AC','0001235244','0001235244','OH00003430746','IL','1','WHITESIDE','DAVID','','','','34','282947143','290 ALTAMONT RD',0,'VERMILION','OH','44089','2208','CY','39093','1989-05-16','M','M',NULL,'N','021','DEN','3581909','99734OH005000401','2014-04-01','2014-03-04 08:22:35','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:00:55'),(2,1,'N','01','021','EC','A',NULL,NULL,'','0000390876','0000667747','','IL','1','robinson','linda','','','','34','294569174','1183 COUNTY ROAD 30A',0,'ASHLAND','OH','44805','9424','CY','39005','1954-03-03','F','',':RET:2106-3','N','021','DEN','1054858','99734OH005000401','2014-01-01','2013-12-04 18:13:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:15:04'),(3019,2427,'N','01','021','EC','A',NULL,NULL,'','0000578762','0000236237','','IL','1','Moore','Donald','','','Jr','34','283748627','1767 GARDEN PL',0,'AKRON','OH','44312','5103','CY','39153','1965-08-05','M','',':RET:2106-3','N','021','HLT','467976','52664OH151001301','2014-01-01','2013-12-06 12:29:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','364.62',NULL,0,'2013-12-25 20:18:06'),(3350,2684,'Y','18','021','EC','A','','','AC','0001129351','0001129351','TX00000569430','IL','1','McGuffey','Colleen',NULL,NULL,NULL,NULL,NULL,'2001 Parker Lane',0,'Austin','TX','78741',NULL,'CY','48453','1977-02-26','F','U',':RET:2039-6^:RET:2106-3','N','021','DEN','1698264','33348TX002000201','2014-01-01','2013-12-22 07:29:45','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 21:16:43'),(23766,18912,'Y','18','021','EC','A','','','AC','0001255078','0001255078','OH00002719582','IL','1','Barbera','Athena','','','','34','283744880','5030 West Blvd NW',0,'Canton','OH','44718',NULL,'CY','39151','1967-10-19','F','U',':RET:2106-3','N','021','DEN','3854439','99734OH005000301','2014-03-01','2014-02-14 15:37:55','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-14 21:31:11'),(3446,2770,'Y','18','021','EC','A','','','AC','0000501608','0000501608','OH00001119263','IL','1','Hammond','Hope','','','','34','270905218','180 College Park Drive',0,'Elyria','OH','44053',NULL,'CY','39093','1984-04-23','F','U',':RET:2106-3','N','021','DEN','1712911','99734OH005000401','2014-01-01','2013-12-21 21:19:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:19:22'),(5870,4658,'Y','18','021','EC','A','','','AC','0000079915','0000079915','OH00000972746','IL','1','Davis','Javon','','','','34','153846477','249 Kinsey Rd',0,'Xenia','OH','45385',NULL,'CY','39057','1988-04-13','M','U',':RET:2054-5','N','021','HLT','2112287','92036OH005000506','2014-01-01','2013-12-23 21:09:04','140.00',NULL,NULL,'238.66','98.66','R-OH003','OH0','238.66',NULL,0,'2013-12-25 23:49:12'),(20146,16076,'Y','18','021','EC','A','','','AC','0001021505','0001021505','OH00001650992','IL','1','GILLS','JAMAL','','','','34','295705745','3109 E LIVINGSTON AVE',0,'COLUMBUS','OH','43227','1889','CY','39049','1973-10-03','M','U',':RET:2054-5','N','021','DEN','2803606','99734OH005000401','2014-03-01','2014-01-27 17:21:51','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-27 21:01:01'),(19798,15784,'Y','18','021','EC','A','','','AC','0000525607','0000525607','OH00001644126','IL','1','Market','Cheryl','','','','34','268568620','801 S BLACKHOOF ST',0,'WAPAKONETA','OH','45895','2205','CY','39011','1955-09-20','F','M',':RET:2106-3','N','021','HLT','3163402','92036OH003001505','2014-03-01','2014-01-23 12:12:59','447.00',NULL,NULL,'585.61','138.61','R-OH002','OH0','585.61',NULL,0,'2014-01-23 21:01:47'),(27243,21571,'N','19','021','EC','A',NULL,NULL,'','0000784423','0000761170','','IL','1','Armacost','Brian','','','','34','290944663','2470 A State Rt 756',0,'Moscow','OH','45153',NULL,'CY','39025','1992-02-24','M','',NULL,'N','021','HLT','3970552','92036OH004000601','2014-04-01','2014-03-03 11:28:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-03-03 21:31:48'),(27669,21886,'Y','18','021','EC','A','','','AC','0000655742','0000655742','TX00002859449','IL','1','garza','wenceslada','c','','','34','267279693','2314 GUAVA DR',0,'WESLACO','TX','78596','1790','CY','48215','1956-08-20','F','M',NULL,'N','021','DEN','3000388','33348TX002000201','2014-04-01','2014-03-04 18:28:00','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-03-05 21:30:32'),(28206,22320,'N','19','021','EC','A',NULL,NULL,'','0000848367','0000935587','','S1','1','Moser','Gregory','','','','34','632502712','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1995-10-24','M','',':RET:2106-3','N','021','DEN','3200824','33348TX002000101','2014-04-01','2014-03-06 16:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10','CIC',0,'2014-03-06 21:30:11'),(886,733,'N','01','021','EC','A',NULL,NULL,'','0000993958','0000997734','','IL','1','DETWILER','PAMELA','M','','','34','282548386','9707 U.S. RT 224',0,'VAN WERT','OH','45891',NULL,'CY','39161','1954-03-30','F','',':RET:2106-3','N','021','HLT','2123254','92036OH002001501','2014-01-01','2013-12-16 11:24:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','661.60',NULL,0,'2013-12-25 18:07:52'),(25166,19961,'N','01','021','EC','A',NULL,NULL,'','0000627925','0000317385','','IL','1','SIANG','YANGING','','','','34','273942814','1811 HAWK AVE',0,'PIQUA','OH','45356',NULL,'CY','39109','1956-08-17','F','',NULL,'N','021','DEN','3524406','99734OH005000401','2014-04-01','2014-02-20 23:24:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-21 22:00:25'),(13246,10571,'Y','18','021','EC','A','','','AC','0001154917','0001154917','TX00000070594','31','1','hamilton','robert','','','','34','462612093','null null',0,'HEMPHILL','TX','75948','1750','CY','48403','1966-03-26','M','M',':RET:2106-3','N','021','DEN','1406546','33348TX002000201','2014-01-01','2013-12-23 10:13:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:56:15'),(9627,7625,'Y','18','021','EC','A','','','AC','0000869255','0000869255','OH00000544208','31','1','Jones','Jonathan','','','','34','276867738','740 GARMON AVE',0,'ASHLAND','OH','44805','3725','CY','39005','1981-11-11','M','M',':RET:2106-3','N','021','HLT','2098575','52664OH152000901','2014-01-01','2013-12-20 21:21:44','105.00',NULL,NULL,'193.23','88.23','R-OH012','OH0','193.23',NULL,0,'2013-12-26 04:38:05'),(24115,19170,'Y','18','021','EC','A','','','AC','0000186138','0000186138','TX00001885602','IL','1','Garza','Francisco','','','','34','458410597','220 S 83RD ST',0,'EDINBURG','TX','78542','2168','CY','48215','1965-03-03','M','M',':RET:2106-3','N','021','DEN','2759974','33348TX002000201','2014-03-01','2014-02-15 13:29:09','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-15 22:01:39'),(21832,17434,'Y','18','024','14','A','','','TE','0001199297','0001199297','','IL','1','SIMONS','RAYMOND',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-09-26','M','',NULL,NULL,NULL,'','2521566','','2014-02-06','2014-02-06 04:24:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-06 21:01:05'),(25866,20507,'Y','18','021','EC','A','','','AC','0001435418','0001435418','LA00003257329','IL','1','MALBREW','SHEILA','','','','34','436355109','280 AUSTIN RD',0,'VILLE PLATTE','LA','70586','6817','CY','22039','1975-02-20','F','U',':RET:2054-5','N','021','DEN','3767986','18575LA002000201','2014-04-01','2014-02-26 14:22:21','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 21:00:47'),(236,197,'Y','18','021','EC','A','','','AC','0000344108','0000344108','OH00000397828','IL','1','Phan','Dinh','','','','34','609542194','3228 YORKTOWN DR',0,'OREGON','OH','43616','2991','CY','39095','1969-09-23','M','U',':RET:2047-9','N','021','HLT','24683','92036OH002002601','2014-01-01','2013-12-05 09:43:13','95.00',NULL,NULL,'314.59','219.59','R-OH001','OH0','314.59',NULL,0,'2013-12-25 17:21:10'),(8147,6444,'Y','18','021','EC','A','','','AC','0001184956','0001184956','TX00000544960','IL','1','PATTERSON','HOLLY','','','','34','450556458','1420 W MCDERMOTT DR',0,'ALLEN','TX','75013','3333','CY','48085','1978-08-09','F','U',':RET:2106-3','N','021','DEN','1115997','33348TX002000101','2014-01-01','2013-11-22 07:07:37','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 03:15:54'),(1355,1123,'Y','18','021','EC','A','','','AC','0001135501','0001135501','TX00000477170','IL','1','Biddle','Craig','','','','34','047382081','2303 GREENLEE DR',0,'AUSTIN','TX','78703','1710','CY','48453','1958-10-10','M','M',NULL,'N','021','DEN','1696004','33348TX002000101','2014-01-01','2013-12-24 13:37:48','0.00',NULL,NULL,'101.40','101.40','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:23'),(18699,14908,'Y','18','021','EC','A','','','AC','0001711424','0001711424','LA00001821331','IL','1','Sylvester-Emery','Emma','','','','34','587200440','11057 TOLEDO BEND AVE',0,'BATON ROUGE','LA','70814','5161','CY','22033','1949-10-12','F','U',':RET:2054-5','N','021','DEN','2937608','18575LA002000101','2014-03-01','2014-01-16 17:00:14','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-17 03:35:27'),(18574,14813,'Y','18','021','EC','A','','','AC','0000618388','0000618388','OH00001521716','IL','1','Youssefi','Nafisa','','','','34','278909860','1216 MAGDALYN DR',0,'AKRON','OH','44320','1426','CY','39153','1959-02-09','F','M',':RET:2106-3','N','021','HLT','2686554','52664OH152000901','2014-02-01','2014-01-15 15:43:15','656.00',NULL,NULL,'889.38','233.38','R-OH012','OH0','348.73',NULL,0,'2014-01-16 08:47:06'),(17960,14351,'Y','18','021','EC','A','','','AC','0000368327','0000368327','TX00001909934','IL','1','Warren','Janet','','','','34','449900899','12053 CR 2138',0,'Kemp','TX','75143',NULL,'CY','48213','1950-12-04','F','U',':RET:2106-3','N','021','DEN','1778277','33348TX002000201','2014-02-01','2014-01-14 18:30:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:45'),(2088,1709,'Y','18','021','EC','A','','','AC','0000434571','0000434571','LA00000523740','IL','1','Paul','Lisa','','','','34','568515118','2274 71ST AVE',0,'BATON ROUGE','LA','70807','5912','CY','22033','1978-02-11','F','M',':RET:2054-5','N','021','DEN','648850','18575LA002000201','2014-01-01','2013-12-10 16:04:29','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:16:47'),(16977,13587,'N','01','021','EC','A',NULL,NULL,'','0001191222','0000217998','','IL','1','Barrera','Jose','','','','34','594455527','549 PLANTERS DR',0,'PEARL','MS','39208','7028','CY','28121','1975-03-09','M','',NULL,'N','021','DEN','2053553','46300MS002000201','2014-02-01','2014-01-08 23:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 02:20:16'),(16409,13131,'Y','18','021','EC','A','','','AC','0000793475','0000793475','TX00002304630','IL','1','De Anda','Melissa','','','','34','125604988','310 MORGAN ST',0,'CARRIZO SPRINGS','TX','78834','2008','CY','48127','1977-11-10','F','M',NULL,'N','021','DEN','2303607','33348TX002000201','2014-02-01','2014-01-06 14:49:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-07 04:04:09'),(6984,5542,'Y','18','021','EC','A','','','AC','0000498167','0000498167','OH00000210632','IL','1','Graven','John','','','','34','282483993','9213 ROANOKE CT',0,'NORTH ROYALTON','OH','44133','1777','CY','39035','1957-01-13','M','M',':RET:2106-3','N','021','DEN','1534400','99734OH005000401','2014-02-01','2013-12-25 00:26:19','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 01:47:49'),(6775,5374,'N','01','021','EC','A',NULL,NULL,'','0000566575','0001097749','','IL','1','BACOVIN','DEAN','R','','','34','291642368','10433 WALKINGFERN DR',0,'HARRISON','OH','45030','1654','CY','39061','1958-09-27','M','',':RET:2106-3','N','021','DEN','624387','99734OH005000301','2014-01-01','2013-11-25 15:36:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:16:42'),(15227,12172,'Y','18','021','EC','A','','','AC','0001970810','0001970810','LA00001756981','IL','1','James','Jillian','','','','34','439638158','5131 BUNDY RD',0,'NEW ORLEANS','LA','70127','5351','CY','22071','1987-04-16','F','U',':RET:2054-5','N','021','DEN','2169418','18575LA002000101','2014-02-01','2013-12-30 18:37:06','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-01 12:08:13'),(4328,3438,'N','01','021','EC','A',NULL,NULL,'','0001207128','0000703765','','IL','1','GOULD','DEBRA','','','','34','300501458','47 summerberry lane',0,'NILES','OH','44446',NULL,'CY','39155','1955-06-14','F','',NULL,'N','021','HLT','1727193','92036OH002003201','2014-01-01','2013-12-17 09:32:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','712.23',NULL,0,'2013-12-25 21:52:57'),(25079,19889,'Y','18','021','EC','A','','','AC','0001065985','0001065985','OH00003025183','IL','1','CORNE','KATHLEEN','','','','34','378544819','300 MARGARET PLACE',0,'PERRYSBURG','OH','43551',NULL,'CY','39173','1949-06-08','F','U',':RET:2106-3','N','021','HLT','2992921','92036OH004002601','2014-04-01','2014-02-20 12:06:34','0.00',NULL,NULL,'470.37','470.37','R-OH001','OH0','470.37',NULL,0,'2014-02-20 22:01:36'),(25733,20412,'Y','18','021','EC','A','','','AC','0002397130','0002397130','LA00002833227','IL','1','Anderson','Marie','','','','34','433151558','2726 PARKRIDGE ST',0,'SHREVEPORT','LA','71108','4537','CY','22017','1957-12-01','F','U',':RET:2054-5','N','021','DEN','3387938','18575LA002000201','2014-04-01','2014-02-24 16:07:00','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-26 09:30:36'),(26470,20997,'Y','18','021','EC','A','','','AC','0002042484','0002042484','LA00002052099','IL','1','pardillo','julio','alberto','','Jr','34','591167766','11715 Glenda dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1982-01-19','M','M',':RET:2106-3','N','021','DEN','3425712','18575LA002000101','2014-04-01','2014-02-27 14:36:47','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02','CIC',0,'2014-02-28 07:30:37'),(102,90,'N','19','021','EC','A',NULL,NULL,'','0001102353','0000444422','','IL','1','Otero','Michelle','Marie','','','34','643288507','1472 Franklin St',0,'Brownsville','TX','78520',NULL,'CY','48061','1992-01-27','F','',':RET:2106-3','N','021','DEN','512013','33348TX002000201','2014-01-01','2013-12-05 13:41:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 17:17:45'),(23057,18383,'Y','18','021','EC','A','','','AC','0001673974','0001673974','LA00001606555','IL','1','Clark','Donna','','','','34','437475915','401 BUTLER DR',0,'AVONDALE','LA','70094','2639','CY','22051','1967-11-30','F','U',':RET:2054-5','N','021','DEN','3408069','18575LA002000201','2014-03-01','2014-02-11 23:14:33','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:49'),(8136,6438,'Y','18','021','EC','A','','','AC','0001132729','0001132729','OH00001001892','IL','1','Patterson','Joe','','','','34','294527022','311 anna street',0,'dayton','OH','45417',NULL,'CY','39113','1955-11-07','M','U',':RET:2054-5','N','021','DEN','131278','99734OH005000301','2014-01-01','2013-11-22 15:44:58','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:15:41'),(3051,2451,'Y','18','021','EC','A','','','AC','0000338282','0000338282','LA00000367667','IL','1','Cole','Bickford','Joseph','','','34','433887571','222 FRED ST',0,'MAMOU','LA','70554','2941','CY','22039','1951-06-10','M','M',':RET:2106-3','N','021','DEN','865509','18575LA002000201','2014-01-01','2013-12-06 11:12:15','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 20:18:54'),(5882,4666,'Y','18','021','EC','A','','','AC','0000070306','0000070306','OH00000857287','IL','1','Woods','Emily','','','','34','282902773','25620 BROADWAY AVE',0,'OAKWOOD VILLAGE','OH','44146','6321','CY','39035','1984-05-11','F','U',':RET:2106-3','N','021','DEN','2137341','99734OH005000301','2014-01-01','2013-12-23 22:29:15','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:49:26'),(19895,15869,'Y','18','021','EC','A','','','AC','0001874262','0001874262','LA00001708018','IL','1','Mosley','Roger','','','','34','436393945','2021Seventh Street',0,'New Orleans','LA','70115',NULL,'CY','22071','1970-12-14','M','U',':RET:2106-3','T','021','DEN','2930907','18575LA002000101','2014-03-01','2014-01-23 18:26:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-24 21:00:53'),(17488,13983,'Y','18','021','EC','A','','','AC','0000424846','0000424846','TX00002271012','IL','1','rivera','Cynthia','','','','34','456436764','Po Box 4276',0,'Eagle pass','TX','78853',NULL,'CY','48323','1971-05-15','F','U',':RET:2106-3','N','021','DEN','1486784','33348TX002000201','2014-02-01','2014-01-12 17:58:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 03:01:18'),(19768,15758,'Y','18','021','EC','A','','','AC','0000590249','0000590249','MS00002525555','IL','1','DEVEREUX','TENA','','','','34','414940712','4884 WILLIAMS RD',0,'HERNANDO','MS','38632','9770','CY','28033','1955-06-01','F','U',NULL,'N','021','DEN','2929675','46300MS002000101','2014-03-01','2014-01-23 12:30:05','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-23 21:01:27'),(18388,14677,'Y','18','021','EC','A','','','AC','0001031474','0001031474','OH00002404706','IL','1','KNOTTS','LORETTA','G','','','34','282564836','2439 LADD ST',0,'AKRON','OH','44312',NULL,'CY','39153','1955-05-09','F','M',':RET:2106-3','N','021','DEN','1458553','99734OH005000301','2014-02-01','2014-01-15 15:38:54','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:38'),(26037,20650,'Y','18','021','EC','A','','','AC','0000179959','0000179959','OH00002677114','IL','1','Lintner','Lou','','','','34','288545907','36 OUTLOOK DR',0,'TALLMADGE','OH','44278','1928','CY','39153','1953-06-28','F','M',NULL,'N','021','HLT','3501144','52664OH151001305','2014-04-01','2014-02-26 11:47:44','968.00',NULL,NULL,'1231.89','263.89','R-OH012','OH0','605.24',NULL,0,'2014-02-26 21:02:25'),(27010,21393,'Y','18','024','14','A','','','TE','0000209648','0000209648','','IL','1','hinkle','susan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-11-07','F','',NULL,NULL,NULL,'','2569897','','2014-03-31','2014-03-03 17:15:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-03 21:00:06'),(28016,22170,'Y','18','021','EC','A','','','AC','0000491942','0000491942','OH00002627701','IL','1','Neff','Timothy','','','','34','279522866','4625A COX DR',0,'STOW','OH','44224','5380','CY','39153','1953-07-24','M','U',NULL,'N','021','DEN','3754807','99734OH005000401','2014-04-01','2014-03-06 12:33:00','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-03-06 21:01:18'),(29047,22989,'Y','18','021','EC','A','','','AC','0000159479','0000159479','OH00003692753','IL','1','BALDRICK','TERRY','','','','34','278688589','2000 QUEEN CITY AVE',0,'CINCINNATI','OH','45214',NULL,'CY','39061','1962-01-01','F','U',NULL,'N','021','DEN','4233443','99734OH005000401','2014-04-01','2014-03-10 13:58:08','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:43'),(147,125,'N','19','021','EC','A',NULL,NULL,'','0000204539','0001216235','','IL','1','Beal','Molly','','','','34','282986081','3662 MARK DALE DR',0,'WADSWORTH','OH','44281','8341','CY','39103','1995-05-18','F','',':RET:2106-3','N','021','HLT','217583','52664OH152000901','2014-01-01','2013-12-05 12:07:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 17:18:52'),(347,284,'Y','18','021','EC','A','','','AC','0000930079','0000930079','TX00000303414','IL','1','Escamilla','Violet','','','','34','643031064','319 Mae Drive',0,'Kerrville','TX','78028',NULL,'CY','48265','1989-02-13','F','U',':RET:2106-3','N','021','DEN','1053498','33348TX002000201','2014-01-01','2013-11-09 00:22:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:32:09'),(21219,16956,'N','01','021','EC','A',NULL,NULL,'','0002045234','0001808501','','IL','1','Davis','Kindra','','','','34','435775384','267 randy road',0,'West monroe','LA','71292',NULL,'CY','22073','1984-11-29','F','',':RET:2106-3','N','021','DEN','3089576','18575LA002000201','2014-03-01','2014-02-03 15:38:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-03 21:01:03'),(654,539,'Y','18','021','EC','A','','','AC','0000564194','0000564194','OH00001112206','S3','1','MACK','DAYESHEANNA','JAMEE LAMONET','','','34','283158124','3806 WYNDEHAM RIDGE DR',0,'STOW','OH','44224',NULL,'CY','39153','2009-08-04','F','U',':RET:2054-5','N','021','DEN','1408775','99734OH005000401','2014-01-01','2013-12-16 17:04:16','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','15.78',NULL,0,'2013-12-25 18:01:41'),(5008,3971,'N','01','021','EC','A',NULL,NULL,'','0000098969','0000088530','','IL','1','Smith','Renelle','','','','34','290867607','4608 EDGEWOOD DR',0,'LORAIN','OH','44053','3047','CY','39093','1975-09-26','F','',NULL,'N','021','DEN','753375','99734OH005000301','2014-01-01','2013-12-07 14:24:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:17'),(6594,5228,'Y','18','021','EC','A','','','AC','0000014957','0000014957','MS00001009063','IL','1','GORDON','ELIZABETH','RUTH','','','34','426595779','120 WAYCROSS CT',0,'JACKSON','MS','39206','2203','CY','28049','1980-07-19','F','U',':RET:2054-5','N','021','DEN','911104','46300MS002000101','2014-01-01','2013-12-11 00:54:00','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-26 00:53:21'),(19986,15942,'Y','18','021','EC','A','','','AC','0000613031','0000613031','OH00001641750','IL','1','Domonkos','Cathleen','L','','','34','280523401','4201 Secor Rd.',0,'Toledo','OH','43623',NULL,'CY','39095','1952-06-21','F','U',':RET:2106-3','N','021','HLT','3071508','92036OH004002601','2014-03-01','2014-01-25 17:33:47','264.00',NULL,NULL,'440.60','176.60','R-OH001','OH0','440.60',NULL,0,'2014-01-25 19:00:17'),(19606,15626,'N','01','021','EC','A',NULL,NULL,'','0000253081','0000895743','','IL','1','Haymond','James','','','','34','294563974','686 W. Liberty St.',0,'Medina','OH','44256',NULL,'CY','39103','1960-03-17','M','',NULL,'N','021','HLT','2645899','52664OH152000901','2014-03-01','2014-01-22 09:36:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','333.21',NULL,0,'2014-01-23 03:02:49'),(19230,15323,'Y','18','024','14','A','','','TE','0000968239','0000968239','','IL','1','Hummer','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-05-10','M','',NULL,NULL,NULL,'','1750843','','2014-01-20','2014-01-20 11:27:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:32'),(17294,13831,'Y','18','021','EC','A','','','AC','0000220894','0000220894','TX00001383737','IL','1','Lin','Paul','','','','34','012447630','11919 CHADWELL DR',0,'HOUSTON','TX','77031','2701','CY','48201','1952-05-09','M','M',':RET:2500-7','N','021','DEN','2608901','33348TX002000201','2014-02-01','2014-01-09 23:28:55','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:23:35'),(17026,13623,'N','19','021','EC','A',NULL,NULL,'','0001217387','0000385919','','IL','1','RUMMER','RACHEL','','','','34','283967590','3276 WHIPPLE DR',0,'NORTON','OH','44203','5221','CY','39153','1993-06-16','F','',':RET:2106-3','N','021','HLT','1701414','52664OH152000901','2014-02-01','2014-01-09 15:19:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:20:42'),(15986,12795,'N','01','021','EC','A',NULL,NULL,'','0000945523','0001262907','','IL','1','sprabeary','robert','j','','Jr','34','449958773','324 QUAIL CROSSING DR',0,'SANGER','TX','76266','6611','CY','48121','1981-10-04','M','',':RET:2106-3','N','021','DEN','2597027','33348TX002000201','2014-02-01','2014-01-03 11:28:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-04 02:01:07'),(14417,11498,'N','01','021','EC','A',NULL,NULL,'','0000689561','0000183344','','IL','1','Mirelez','Nancy','Y','','','34','533311633','7027 SHAMAN LN',0,'HOUSTON','TX','77083','8022','CY','48201','1971-01-24','F','',NULL,'N','021','DEN','1586934','33348TX002000101','2014-02-01','2013-12-27 10:15:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-28 03:31:37'),(25980,20604,'Y','18','021','EC','A','','','AC','0000268950','0000268950','OH00002911471','IL','1','Cook','Jennifer','L','','','34','297726645','724 KYLE DR',0,'TIPP CITY','OH','45371','1436','CY','39109','1967-10-24','F','M',':RET:2106-3','N','021','DEN','3825901','99734OH005000401','2014-03-01','2014-02-26 16:31:18','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-02-26 21:01:51'),(27821,22003,'Y','18','021','EC','A','','','AC','0000665709','0000665709','OH00003610874','IL','1','McLaren','Amy','','','','34','276806239','8683 Brent Dr.',0,'Cincinnati','OH','45231',NULL,'CY','39061','1969-06-10','F','R',':RET:2106-3','N','021','DEN','2747255','99734OH005000301','2014-04-01','2014-03-04 21:12:32','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:31:55'),(28506,22558,'Y','18','021','EC','A','','','AC','0000132132','0000132132','OH00002821084','IL','1','Finitzer','Bonnie','','','','34','300429221','5888 KINGS HWY',0,'PARMA HEIGHTS','OH','44130','1747','CY','39035','1956-02-05','F','U',':RET:2106-3','N','021','HLT','4181506','52664OH151001305','2014-04-01','2014-03-07 12:38:22','431.00',NULL,NULL,'640.87','209.87','R-OH011','OH0','640.87',NULL,0,'2014-03-07 21:31:51'),(28649,22670,'Y','18','021','EC','A','','','AC','0000609502','0000609502','MS00003197066','IL','1','Litzkow','Thirada','','','','34','416559646','7412 English Ivy W',0,'Olive Branch','MS','38654',NULL,'CY','28033','1978-12-02','F','U',':RET:2028-9','N','021','DEN','2782217','46300MS002000101','2014-04-01','2014-03-08 14:45:03','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-03-08 21:30:36'),(28792,22792,'Y','18','021','EC','A','','','AC','0000994041','0000994041','TX00003385083','IL','1','JURGENSEN','MARIAN','','','','34','450782681','2637 WESTMINSTER AVE.',0,'DALLAS','TX','75205',NULL,'CY','48113','1954-04-24','F','M',NULL,'T','021','DEN','4348043','33348TX002000101','2014-04-01','2014-03-09 14:40:56','0.00',NULL,NULL,'54.30','54.30','R-TX008','TX0','27.15',NULL,0,'2014-03-09 21:00:43'),(3795,3041,'Y','18','021','EC','A','','','AC','0000926249','0000926249','OH00000184746','IL','1','Higgins','James','','','','34','180440249','2180 Kingsborough Dr.',0,'Painesville','OH','44077',NULL,'CY','39085','1953-10-09','M','U',':RET:2106-3','N','021','DEN','73748','99734OH005000301','2014-01-01','2013-12-13 11:02:56','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:34:21'),(5403,4289,'N','01','021','EC','A',NULL,NULL,'','0000619631','0000168882','','IL','1','Sparough','Geralyn','','','','34','573333211','4228 DELANEY ST',0,'CINCINNATI','OH','45223','2017','CY','39061','1959-01-01','F','',':RET:2106-3','N','021','HLT','1686742','92036OH006001201','2014-01-01','2013-12-19 14:41:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','379.65',NULL,0,'2013-12-25 23:09:00'),(6956,5524,'N','01','021','EC','A',NULL,NULL,'','0000049495','0001156218','','IL','1','Lian','Don','Ngaih','','','34','296134626','53 S POWELL AVE',0,'COLUMBUS','OH','43204','3031','CY','39049','1955-09-15','F','',':RET:2028-9','N','021','DEN','1917274','99734OH005000401','2014-01-01','2013-12-24 21:58:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:10'),(22371,17866,'Y','18','021','EC','A','','','AC','0000300124','0000300124','TX00002135153','IL','1','Aziz','Sikander','','','','34','635923204','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1958-09-29','M','M',':RET:2029-7','N','021','DEN','3129623','33348TX002000101','2014-03-01','2014-02-10 15:13:57','0.00',NULL,NULL,'81.45','81.45','R-TX008','TX0','27.15','CIC',0,'2014-02-10 21:00:13'),(21044,16813,'Y','18','021','EC','A','','','AC','0000913717','0000913717','TX00002340152','IL','1','Austin','Bonnie','','','','34','453676584','130 CEDAR',0,'ONALASKA','TX','77360','7028','CY','48373','1978-01-24','F','U',':RET:2106-3','N','021','DEN','3570541','33348TX002000101','2014-03-01','2014-02-01 16:38:02','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-01 19:00:52'),(20935,16731,'N','01','021','EC','A',NULL,NULL,'','0001006856','0001182534','','IL','1','Morris','Jerry','','','','34','285706501','15675 KRUSE RD',0,'WAPAKONETA','OH','45895','9579','CY','39011','1961-02-01','M','',NULL,'N','021','HLT','3352328','92036OH002001501','2014-03-01','2014-01-31 13:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','518.49',NULL,0,'2014-01-31 21:01:39'),(14870,11874,'Y','18','021','EC','A','','','AC','0000175019','0000175019','TX00000768476','IL','1','Kearney','Tracey','','','','34','253907395','18219 EASTSIDE RD',0,'TROUP','TX','75789','3601','CY','48423','1964-04-29','F','U',':RET:2106-3','N','021','DEN','1360108','33348TX002000201','2014-02-01','2013-12-29 09:57:37','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2013-12-30 00:00:11'),(20417,16308,'Y','18','021','EC','A','','','AC','0000319703','0000319703','OH00001808569','IL','1','Colbow','Barbara','','','','34','284528350','2737 State Route 60',0,'Loudonville','OH','44842',NULL,'CY','39005','1952-04-05','F','M',':RET:2106-3','N','021','DEN','1600309','99734OH005000301','2014-03-01','2014-01-28 22:41:34','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-29 21:00:28'),(17975,14363,'Y','18','021','EC','A','','','AC','0001024298','0001024298','OH00002418790','IL','1','Arnold','Laura','','','','34','280625395','175 ERNEST DR',0,'TALLMADGE','OH','44278','1628','CY','39153','1964-09-02','F','U',':RET:2106-3','N','021','HLT','2436559','52664OH151001305','2014-02-01','2014-01-14 12:13:55','260.00',NULL,NULL,'380.45','120.45','R-OH012','OH0','380.45',NULL,0,'2014-01-15 02:06:51'),(19250,15340,'Y','18','021','EC','A','','','AC','0000963259','0000963259','OH00001967704','IL','1','Williams','Martin','','','','34','269480837','1849 STATE ROUTE 232',0,'NEW RICHMOND','OH','45157','8637','CY','39025','1950-10-23','M','U',':RET:2106-3','N','021','HLT','2677696','92036OH003000604','2014-03-01','2014-01-20 09:33:32','407.00',NULL,NULL,'661.77','254.77','R-OH005','OH0','661.77',NULL,0,'2014-01-21 08:46:43'),(25606,20316,'Y','18','024','14','A','','','TE','0000142130','0000142130','','IL','1','McWhorter','Terri',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-09-07','F','',NULL,NULL,NULL,'','2616364','','2014-03-08','2014-02-21 22:52:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERM',0,'2014-02-26 08:30:05'),(25710,20395,'N','01','021','EC','A',NULL,NULL,'','0000537644','0001263098','','IL','1','GILBERT','STARLA','','','','34','452479865','25343 WILLIAMS DR',0,'JUSTIN','TX','76247','7520','CY','48121','1969-08-29','F','',':RET:2106-3','N','021','DEN','3241204','33348TX002000201','2014-04-01','2014-02-24 15:49:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-26 09:30:23'),(27138,21485,'Y','18','021','EC','A','','','AC','0000406182','0000406182','OH00003096441','IL','1','loaiza','felicia','','','','34','297048697','5235 FLOWER VALLEY DR',0,'CANAL WINCHESTER','OH','43110','8520','CY','39049','1989-01-26','F','U',':RET:2106-3','N','021','DEN','3162865','99734OH005000401','2014-04-01','2014-03-03 11:55:58','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-03 21:30:45'),(7684,6085,'Y','18','021','EC','A','','','AC','0001059465','0001059465','OH00000594228','IL','1','WOYAN','TIMOTHY','SCOTT','','','34','278865219','3090 CELERON AVE',0,'CINCINNATI','OH','45209','2130','CY','39061','1981-05-06','M','U',NULL,'N','021','DEN','1873643','99734OH005000401','2014-01-01','2013-12-19 20:12:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:00:52'),(2095,1716,'Y','18','021','EC','A','','','AC','0000242689','0000242689','OH00000856546','31','1','Sullivan','Judith','','','','34','281382982','1385 TIMSHEL ST',0,'DAYTON','OH','45440','3964','CY','39057','1949-08-06','F','M',':RET:2106-3','N','021','DEN','249398','99734OH005000401','2014-01-01','2013-12-09 20:06:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 19:17:00'),(6748,5354,'Y','18','021','EC','A','','','AC','0001135135','0001135135','OH00001074477','IL','1','Forbess','Linda','','','','34','295427062','1624 Baringer Drive',0,'Defiance','OH','43512',NULL,'CY','39039','1953-05-14','F','M',':RET:2106-3','N','021','HLT','214533','92036OH005002601','2014-01-01','2013-11-25 11:37:40','0.00',NULL,NULL,'529.21','529.21','R-OH001','OH0','529.21',NULL,0,'2013-12-26 01:16:00'),(19057,15180,'Y','18','021','EC','A','','','AC','0000595326','0000595326','MS00001535570','IL','1','Jones','Ollie','','','','34','426271773','2071 Camellia Lane',0,'Jackson','MS','39204',NULL,'CY','28049','1960-09-27','M','U',':RET:2054-5','T','021','DEN','2209142','46300MS002000201','2014-03-01','2014-01-18 14:37:21','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-21 08:44:12'),(18072,14434,'N','01','021','EC','A',NULL,NULL,'','0001416165','0001774508','','IL','1','bamburg','brandon','thomas','','','34','433812873','1214 hayes st',0,'west monroe','LA','71292',NULL,'CY','22073','1987-12-23','M','',':RET:2106-3','N','021','DEN','1438845','18575LA002000201','2014-02-01','2014-01-14 08:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-15 02:07:24'),(13093,10439,'Y','18','021','EC','A','','','AC','0000953246','0000953246','OH00000294179','IL','1','Snow','Paul','','','','34','413336972','219 North Cooper Avenue',0,'Cincinnati','OH','45215',NULL,'CY','39061','1966-02-20','M','M',':RET:1002-5^:RET:2106-3','N','021','DEN','1789542','99734OH005000401','2014-01-01','2013-12-23 11:43:57','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:51:56'),(4930,3911,'Y','18','021','EC','A','','','AC','0000647054','0000647054','OH00001006494','IL','1','Mojumdar','Sabita','','','','34','289156034','34936 CLEAR CREEK DR',0,'NORTH RIDGEVILLE','OH','44039','3975','CY','39093','1938-09-07','F','U',':RET:2029-7','N','021','DEN','250498','99734OH005000401','2014-01-01','2013-12-06 20:22:11','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:45:24'),(3352,2686,'Y','18','024','14','A','','','TE','0000645231','0000645231','','IL','1','Lewis','Dennis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-03-03','M','',NULL,NULL,NULL,'','104346','','2013-12-22','2013-12-22 08:16:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:16:45'),(2715,2196,'Y','18','021','EC','A','','','AC','0000155742','0000155742','OH00000908100','IL','1','young','william','','','','34','287480956','5935 S MYERS RD',0,'CLINTON','OH','44216','8703','CY','39153','1950-07-26','M','U',':RET:2106-3','N','021','HLT','385522','52664OH151001501','2014-01-01','2013-12-02 13:57:02','498.00',NULL,NULL,'789.56','291.56','R-OH012','OH0','789.56',NULL,0,'2013-12-25 19:48:02'),(26032,20646,'Y','18','021','EC','A','','','AC','0000409537','0000409537','MS00002878640','IL','1','HAMPTON','TIMOTHY','','','','34','587397411','5214 MOUNT SINAI RD',0,'LIBERTY','MS','39645',NULL,'CY','28005','1975-12-07','M','M',':RET:2054-5','N','021','DEN','3424307','46300MS002000101','2014-04-01','2014-02-26 16:14:01','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,0,'2014-02-26 21:02:22'),(27064,21428,'Y','18','021','EC','A','','','AC','0001917284','0001917284','LA00003474407','IL','1','taylor','mattie','','','','34','435960925','5233 VIRGINIA AVE',0,'SHREVEPORT','LA','71108','2818','CY','22017','1955-05-28','F','U',':RET:2054-5','N','021','DEN','3221604','18575LA002000201','2014-04-01','2014-03-03 09:19:21','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-03 21:30:01'),(9755,7725,'Y','18','021','EC','A','','','AC','0000520158','0000520158','TX00000595792','IL','1','Greyard','Shahala','','','','34','565437904','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','1973-12-02','F','M',NULL,'N','021','DEN','305838','33348TX002000101','2014-01-01','2013-10-19 20:57:42','0.00',NULL,NULL,'25.02','25.02','R-TX017','TX0','25.02',NULL,0,'2013-12-26 05:00:03'),(5337,4233,'Y','18','021','EC','A','','','AC','0000191356','0000191356','OH00001071155','IL','1','Gellermann','Janelle','','','','34','483860072','88 FAYETTE ST',0,'NELSONVILLE','OH','45764','1205','CY','39009','1962-05-07','F','U',':RET:2106-3','N','021','DEN','1852300','99734OH005000301','2014-01-01','2013-12-19 14:52:58','0.00',NULL,NULL,'21.13','21.13','R-OH017','OH0','0.00',NULL,0,'2013-12-25 23:07:14'),(4416,3508,'Y','18','021','EC','A','','','AC','0000105349','0000105349','OH00000228956','IL','1','JORDAN','WILLIAM','','','Jr','34','293668659','119 E BLAKE AVE',0,'COLUMBUS','OH','43202','2907','CY','39049','1965-06-27','M','U',':RET:2106-3','N','021','DEN','449289','99734OH005000401','2014-01-01','2013-12-12 15:43:57','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:01:29'),(20731,16564,'Y','18','024','14','A','','','TE','0000639496','0000639496','','IL','1','laurie','jamie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1985-09-28','F','',NULL,NULL,NULL,'','1035658','','2014-01-30','2014-01-30 01:44:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:01:19'),(20617,16475,'Y','18','024','14','A','','','TE','0001662948','0001662948','','IL','1','COLBERT','TINICA','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-07-10','F','',NULL,NULL,NULL,'','2118920','','2014-01-30','2014-01-30 14:50:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-30 21:00:22'),(20465,16349,'Y','18','021','EC','A','','','AC','0000558181','0000558181','OH00001644233','IL','1','Berlean','Christopher','','','','34','278882127','7405 REFUGEE RD',0,'PICKERINGTON','OH','43147','9101','CY','39045','1978-07-30','M','M',':RET:2106-3','N','021','DEN','3169905','99734OH005000401','2014-03-01','2014-01-29 11:46:27','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:53'),(20336,16239,'Y','18','021','EC','A','','','AC','0001578987','0001578987','LA00002506997','IL','1','Sutton','Travis','','','','34','437452950','6835 MAYO BLVD',0,'NEW ORLEANS','LA','70126','7355','CY','22071','1981-11-19','M','R',':RET:2054-5','T','021','DEN','3446390','18575LA002000101','2014-03-01','2014-01-28 10:05:22','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-28 21:01:05'),(4238,3375,'Y','18','021','EC','A','','','AC','0000511424','0000511424','TX00000272953','IL','1','Cameron','Devon','','','','34','464717311','2520 HICKORY DR',0,'COLLEGE STATION','TX','77840','5069','CY','48041','1982-08-09','F','M',':RET:2106-3','N','021','DEN','2580821','33348TX002000201','2014-01-01','2013-12-17 15:09:10','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 21:50:56'),(18358,14655,'N','01','021','EC','A',NULL,NULL,'','0000167789','0000130717','','IL','1','Schivelbein','Julie','','','','34','279684115','5137 Bay Ridge Court',0,'Oregon','OH','43616',NULL,'CY','39095','1972-06-04','F','',':RET:2106-3','N','021','DEN','2772125','99734OH005000301','2014-02-01','2014-01-14 22:51:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-16 08:45:25'),(22986,18326,'Y','18','021','EC','A','','','AC','0000421506','0000421506','OH00002163473','IL','1','HILDRETH','MICHELLE','R','','','34','297749391','146 GOODVIEW AVE',0,'AKRON','OH','44305','3619','CY','39153','1963-04-20','F','U',':RET:2106-3','N','021','DEN','3436698','99734OH005000301','2014-03-01','2014-02-12 09:18:58','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-12 21:30:11'),(2908,2344,'Y','18','021','EC','A','','','AC','0001102066','0001102066','OH00000245408','IL','1','Ellerhorst','Chasity','','','','34','400295597','548 ASPEN GLEN DR',0,'CINCINNATI','OH','45244','1892','CY','39025','1986-03-02','F','U',':RET:2106-3','N','021','DEN','1085226','99734OH005000401','2014-01-01','2013-12-06 11:12:52','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 20:15:30'),(14541,11603,'N','19','021','EC','A',NULL,NULL,'','0001213447','0001230884','','IL','1','MANUEL','NATASHA','','','','34','428777064','6825 S SIWELL RD',0,'BYRAM','MS','39272','8701','CY','28049','1994-08-24','F','',':RET:2054-5','N','021','DEN','2009582','46300MS002000201','2014-02-01','2013-12-27 13:36:10',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','40.52',NULL,0,'2013-12-28 03:34:48'),(16146,12932,'Y','18','021','EC','A','','','AC','0000532115','0000532115','OH00001468983','IL','1','Wallbridge','Noel','','','','34','299928500','527 S REVERE RD',0,'CINCINNATI','OH','45255','5085','CY','39025','1975-06-07','M','R',':RET:2106-3','N','021','HLT','1372273','92036OH001000601','2014-02-01','2014-01-03 15:35:49','0.00',NULL,NULL,'972.10','972.10','R-OH005','OH0','322.66',NULL,0,'2014-01-04 02:06:08'),(26561,21057,'Y','18','021','EC','A','','','AC','0001074199','0001074199','OH00002797510','IL','1','McMahan','Mary','','','','34','275842964','3620 CORAL GABLES RD',0,'CINCINNATI','OH','45248','3133','CY','39061','1971-05-15','F','U',':RET:2106-3','N','021','DEN','2935008','99734OH005000401','2014-04-01','2014-02-27 21:02:20','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:19'),(28384,22458,'N','19','021','EC','A',NULL,NULL,'','0000420082','0000767473','','IL','1','RAMSEY','LEO','M','','','34','292044183','1194 BIG FALLS AVE',0,'AKRON','OH','44310','1134','CY','39153','2000-01-05','M','',':RET:2106-3','N','021','HLT','3025864','52664OH152000901','2014-04-01','2014-03-07 14:53:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-07 21:30:41'),(9120,7236,'Y','18','021','EC','A','','','AC','0000323491','0000323491','OH00000268817','IL','1','Hornbach-Torres','Terri','','','','34','299522416','7973 SCHOOL HOUSE LN',0,'MONTGOMERY','OH','45242','5928','CY','39061','1960-09-08','F','M',':RET:2106-3','N','021','DEN','1795337','99734OH005000301','2014-01-01','2013-12-18 18:04:39','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:07:46'),(2887,2332,'N','01','021','EC','A',NULL,NULL,'','0001241833','0000167741','','IL','1','domer','sherry','l','','','34','300645326','2965 SMITH KRAMER ST NE',0,'HARTVILLE','OH','44632','9706','CY','39151','1958-03-27','F','',':RET:2106-3','N','021','HLT','1087758','52664OH151001501','2014-01-01','2013-12-05 19:02:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','596.45',NULL,0,'2013-12-25 20:15:04'),(21789,17401,'Y','18','021','EC','A','','','AC','0000611992','0000611992','OH00002024131','IL','1','Garcia','Alicia','','','','34','581279013','6815 Madison Ave',0,'Cleveland','OH','44102',NULL,'CY','39035','1963-11-17','F','R',NULL,'N','021','DEN','2813175','99734OH005000401','2014-03-01','2014-02-06 14:15:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-06 21:00:43'),(3010,2420,'Y','18','021','EC','A','','','AC','0000816403','0000816403','OH00000944313','IL','1','ZEISIG','LESLIE','FRANCIS','','','34','298482292','10780 MOGADORE AVE NW',0,'UNIONTOWN','OH','44685',NULL,'CY','39151','1950-03-07','M','U',':RET:2106-3','N','021','HLT','776606','52664OH151001305','2014-01-01','2013-12-06 14:33:04','491.00',NULL,NULL,'658.32','167.32','R-OH015','OH0','658.32',NULL,0,'2013-12-25 20:17:54'),(19092,15211,'Y','18','021','EC','A','','','AC','0000045796','0000045796','OH00001809764','IL','1','Cook','Jerico','','','','34','236391122','2415 TAYLOR AVE',0,'COLUMBUS','OH','43211','1873','CY','39049','1992-05-16','F','U',':RET:2106-3','N','021','DEN','2742535','99734OH005000301','2014-03-01','2014-01-17 20:40:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-21 08:44:33'),(17875,14279,'N','19','021','EC','A',NULL,NULL,'','0001126890','0000992698','','IL','1','Vollmer','Annabelle','','','','34','856536384','8015 PEREGRINE LN',0,'CINCINNATI','OH','45243','2713','CY','39061','2012-09-17','F','',':RET:2106-3','N','021','DEN','1990421','99734OH005000401','2014-02-01','2014-01-14 14:19:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:15'),(3955,3165,'Y','18','021','EC','A','','','AC','0000357174','0000357174','OH00000147599','IL','1','BENSON','CYNTHIA','LOUISE','','','34','301460281','1105 7TH AVE',0,'AKRON','OH','44306','1727','CY','39153','1949-03-13','F','U',':RET:2054-5','N','021','HLT','290151','52664OH151001501','2014-01-01','2013-12-13 10:48:21','507.00',NULL,NULL,'802.40','295.40','R-OH012','OH0','802.38',NULL,0,'2013-12-25 21:38:16'),(26947,21352,'Y','18','021','EC','A','','','AC','0000130751','0000130751','OH00002722151','IL','1','Estep','Geoffrey','','','','34','272786732','59 BEECHVIEW DR',0,'BROOKVILLE','OH','45309','9206','CY','39113','1972-11-10','M','M',':RET:2106-3','N','021','HLT','3453600','92036OH006000501','2014-04-01','2014-03-01 19:35:13','0.00',NULL,NULL,'245.45','245.45','R-OH003','OH0','245.45',NULL,0,'2014-03-03 01:00:25'),(27702,21906,'N','01','021','EC','A',NULL,NULL,'','0000428667','0000720508','','IL','1','Brooks','Quatro','','','','34','451550392','30230 TUDOR WAY',0,'MAGNOLIA','TX','77355','2748','CY','48339','1971-01-29','M','',NULL,'N','021','DEN','2896425','33348TX002000201','2014-04-01','2014-03-05 11:52:56',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-03-05 21:30:49'),(2670,2167,'Y','18','021','EC','A','','','AC','0000868197','0000868197','OH00000027520','IL','1','Brandt','Ronald','','','','34','277526561','8881 WILDWOOD DR',0,'NORTH ROYALTON','OH','44133','1155','CY','39035','1953-04-19','M','M',':RET:2106-3','N','021','DEN','433252','99734OH005000301','2014-01-01','2013-12-02 15:08:43','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:47:02'),(23896,19008,'Y','18','024','14','A','','','TE','0000362522','0000362522','','IL','1','MAY','JANELLE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-04','F','',NULL,NULL,NULL,'','2884595','','2014-02-14','2014-02-14 10:16:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-14 21:32:21'),(23239,18528,'Y','18','021','EC','A','','','AC','0000038430','0000038430','OH00001565876','IL','1','Martin','Kristi','','','','34','277906520','462 CHERRY ST',0,'BLUFFTON','OH','45817','1355','CY','39003','1987-03-29','F','U',NULL,'N','021','HLT','3502122','92036OH006001501','2014-03-01','2014-02-12 16:12:02','134.00',NULL,NULL,'178.73','44.73','R-OH002','OH0','178.73',NULL,0,'2014-02-12 21:32:31'),(21542,17207,'Y','18','024','14','A','','','TE','0001249617','0001249617','','IL','1','Napier','Jim',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-26','M','',NULL,NULL,NULL,'','2881110','','2014-02-05','2014-02-05 05:23:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-05 21:30:09'),(20126,16059,'Y','18','024','14','A','','','TE','0000289506','0000289506','','IL','1','Runions','Emily',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-07-01','F','',NULL,NULL,NULL,'','464118','','2014-01-27','2014-01-27 10:54:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:00:49'),(5655,4485,'N','01','021','EC','A',NULL,NULL,'','0000485191','0000944151','','IL','1','Wear','Rickey','','','','34','550909912','9101 TEAL FLIGHT WAY',0,'TYLER','TX','75703','5303','CY','48423','1955-03-19','M','',NULL,'N','021','DEN','598587','33348TX002000201','2014-01-01','2013-11-26 15:52:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:31:36'),(13316,10631,'N','01','021','EC','A',NULL,NULL,'','0001240342','0000678530','','IL','1','Brown','Justin','Jack','','','34','458775085','1402 W BLUFF ST',0,'GRANBURY','TX','76048','1835','CY','48221','1985-12-31','M','',':RET:2106-3','N','021','DEN','1905995','33348TX002000201','2014-01-01','2013-12-23 16:20:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 12:58:13'),(13109,10453,'Y','18','021','EC','A','','','AC','0000421462','0000421462','OH00000205702','IL','1','Bonner','Mary','','','','34','285766193','1466 knuth',0,'euclid','OH','44132',NULL,'CY','39035','1980-07-22','F','U',NULL,'T','021','DEN','1544863','99734OH005000401','2014-01-01','2013-12-23 13:21:48','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:52:24'),(8900,7057,'Y','18','021','EC','A','','','AC','0000190185','0000190185','OH00000141453','IL','1','kelly','ann','','','','34','108468339','3385 FOREST HILLS DR',0,'MEDINA','OH','44256','8732','CY','39103','1953-04-12','F','R',':RET:2106-3','N','021','DEN','2150493','99734OH005000401','2014-01-01','2013-12-17 18:38:29','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:02:14'),(17110,13693,'Y','18','021','EC','A','','','AC','0001014391','0001014391','OH00002009426','IL','1','Scully','Michael','','','','34','273568039','527 Rawson Avenue',0,'Fremont','OH','43420',NULL,'CY','39143','1954-02-05','M','U',':RET:2106-3','N','021','DEN','1591017','99734OH005000401','2014-02-01','2014-01-08 18:17:18','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-01-13 02:21:36'),(17548,14029,'Y','18','021','EC','A','','','AC','0000376162','0000376162','OH00002288654','IL','1','STONE','DONALD','M','','','34','280683701','6488 BLUE CREEK RD',0,'STOUT','OH','45684','9633','CY','39001','1974-07-21','M','U',':RET:2106-3','N','021','HLT','1524907','92036OH003000606','2014-02-01','2014-01-12 13:35:05','224.00',NULL,NULL,'282.91','58.91','R-OH005','OH0','282.91',NULL,0,'2014-01-13 03:01:52'),(27329,21639,'Y','18','021','EC','A','','','AC','0000398720','0000398720','TX00002625378','IL','1','Hernandez','Dorothy','Roberta','','','34','580045809','1900 BACON RANCH RD',0,'KILLEEN','TX','76542','2879','CY','48027','1964-10-19','F','U',':RET:2054-5','N','021','DEN','3252553','33348TX002000201','2014-04-01','2014-03-04 17:30:07','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-03-04 21:00:50'),(408,336,'Y','18','021','EC','A','','','AC','0000051885','0000051885','OH00000530906','IL','1','Rosenbauer','Barbara','','','','34','269546507','27001 MORGAN RUN',0,'WESTLAKE','OH','44145','5498','CY','39035','1952-05-10','F','M',NULL,'N','021','DEN','427071','99734OH005000401','2014-01-01','2013-12-04 15:06:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:20'),(1122,923,'N','19','021','EC','A',NULL,NULL,'','0001118687','0001242942','','IL','1','Winegardner','Brayden',NULL,NULL,NULL,NULL,NULL,'100 MASTERS CT',0,'LIMA','OH','45805','4007','CY','39003','2003-05-29','M','',':RET:2106-3','N','021','HLT','1096653','92036OH003001501','2014-01-01','2013-12-02 19:33:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','145.95',NULL,0,'2013-12-25 18:17:49'),(22193,17713,'Y','18','021','EC','A','','','AC','0000575032','0000575032','TX00001861618','IL','1','crawford','bradley','r','','','34','465811733','402 S MAIN ST',0,'DAWSON','TX','76639','3213','CY','48349','1970-09-18','M','U',':RET:1002-5^:RET:2106-3','N','021','DEN','3216559','33348TX002000201','2014-03-01','2014-02-09 14:31:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-09 19:00:11'),(28164,22287,'Y','18','021','EC','A','','','AC','0000542747','0000542747','OH00003607002','IL','1','Merriman','Mark','','','','34','276805443','3091 STATE ROUTE 72 S',0,'JAMESTOWN','OH','45335','9546','CY','39057','1973-04-03','M','M',':RET:2106-3','N','021','HLT','3161857','92036OH004000501','2014-04-01','2014-03-06 11:44:16','0.00',NULL,NULL,'244.27','244.27','R-OH003','OH0','244.27',NULL,0,'2014-03-06 21:02:44'),(28673,22689,'N','19','021','EC','A',NULL,NULL,'','0000909531','0000092587','','IL','1','Collins','Kaitlin',NULL,NULL,NULL,NULL,NULL,'518 Perry Street',0,'Hicksville','OH','43526',NULL,'CY','39039','1997-03-02','F','',':RET:2106-3','N','021','HLT','4222628','92036OH006002601','2014-04-01','2014-03-07 18:35:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','98.20',NULL,0,'2014-03-08 21:30:50'),(675,556,'N','19','021','EC','A',NULL,NULL,'','0000079893','0000850482','','IL','1','Barlage','Holly','E','','','34','298043178','1021 W BRIDLEPATH LN',0,'LOVELAND','OH','45140','8073','CY','39025','2000-05-07','F','',':RET:2106-3','N','021','DEN','2369019','99734OH005000301','2014-01-01','2013-12-16 10:16:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:15'),(20971,16757,'Y','18','021','EC','A','','','AC','0000917588','0000917588','TX00002564520','IL','1','Martinez','Michael','','','','34','628079877','1655 LEROY BONSE DR',0,'EL PASO','TX','79936','5705','CY','48141','1987-08-19','M','U',NULL,'T','021','DEN','1676358','33348TX002000201','2014-03-01','2014-02-01 16:10:24','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-01 19:00:14'),(20964,16752,'N','19','021','EC','A',NULL,NULL,'','0000860859','0000421746','','IL','1','Cobos','Christina','','','','34','639167210','3303 GARNET DR',0,'EL PASO','TX','79904','2532','CY','48141','1990-04-20','F','',':RET:2106-3','N','021','DEN','2947476','33348TX002000201','2014-03-01','2014-02-01 17:07:24',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-01 19:00:11'),(6700,5312,'Y','18','021','EC','A','','','AC','0000220105','0000220105','LA00001085969','IL','1','Hess','Marilyn','','','','34','571510608','3305 N General Wainwright dr',0,'lake charles','LA','70615',NULL,'CY','22019','1978-01-30','F','M',':RET:2054-5','N','021','DEN','929732','18575LA002000201','2014-01-01','2013-11-04 19:18:30','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2013-12-26 01:01:53'),(19666,15671,'Y','18','021','EC','A','','','AC','0001861390','0001861390','LA00001785761','IL','1','Brown','Edward','','','','34','435398771','1555 GENTILLY BLVD',0,'NEW ORLEANS','LA','70119','2254','CY','22071','1979-10-29','M','U',':RET:2054-5','N','021','DEN','1732195','18575LA002000101','2014-03-01','2014-01-22 22:56:57','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-23 21:00:28'),(930,770,'Y','18','021','EC','A','','','AC','0000242668','0000242668','OH00001215968','IL','1','Daffeh','Sankung','','','','34','010331954','5697 Forest Ash Lane',0,'Columbus','OH','43229',NULL,'CY','39049','1971-12-25','M','M',':RET:2054-5','N','021','DEN','20982','99734OH005000401','2014-01-01','2013-10-29 00:24:15','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:09:03'),(21983,17555,'N','01','021','EC','A',NULL,NULL,'','0002205384','0001956101','','IL','1','THAMPAGNE','WANDA','','','','34','433868226','9418 S LIBERALS DR',0,'BATONROGE','LA','70815',NULL,'CY','22033','1951-04-22','F','',':RET:2054-5','N','021','DEN','2789793','18575LA002000201','2014-03-01','2014-02-06 18:45:07',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-07 19:00:38'),(17929,14323,'Y','18','021','EC','A','','','AC','0000615065','0000615065','TX00001821224','IL','1','Wilson','Joanna','','','','34','462918071','1057 IVY LN',0,'SAN ANTONIO','TX','78209','6061','CY','48029','1977-10-10','F','U',':RET:2106-3','N','021','DEN','2003491','33348TX002000201','2014-02-01','2014-01-14 12:52:06','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-15 02:06:34'),(1979,1618,'Y','18','024','14','A','','','TE','0000557752','0000557752','','IL','1','Carter','Eddie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-05-14','M','',NULL,NULL,NULL,'','931032','','2013-11-19','2013-11-19 23:03:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:01:40'),(5730,4548,'Y','18','021','EC','A','','','AC','0001190743','0001190743','LA00000138317','IL','1','Taylor','Corandolia','','','','34','433923596','11227 Flamingo Drive',0,'Baton Rouge','LA','70814',NULL,'CY','22033','1953-01-20','F','M',NULL,'N','021','DEN','2059576','18575LA002000201','2014-01-01','2013-12-23 22:48:51','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:45:39'),(13418,10706,'Y','18','021','EC','A','','','AC','0000432756','0000432756','OH00000362290','IL','1','williams','richard','','','','34','274567581','1687 REBECCA DR',0,'LIMA','OH','45805','1666','CY','39003','1953-04-11','M','M',':RET:2106-3','N','021','DEN','1937819','99734OH005000301','2014-01-01','2013-12-23 11:07:37','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,0,'2013-12-26 13:00:45'),(2043,1673,'Y','18','021','EC','A','','','AC','0000246807','0000246807','TX00000738804','IL','1','Rios','Yolanda','','','','34','154653187','9285 RAILROAD DR',0,'EL PASO','TX','79924','7432','CY','48141','1967-03-25','F','U',NULL,'N','021','DEN','964521','33348TX002000201','2014-01-01','2013-12-10 11:07:35','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 19:15:38'),(4628,3667,'Y','18','021','EC','A','','','AC','0000487494','0000487494','MS00000952355','IL','1','JORDAN','KAWANDA','','','','34','427559441','6680 S SIWELL RD',0,'BYRAM','MS','39212','9659','CY','28049','1986-10-24','F','U',':RET:2054-5','N','021','DEN','236834','46300MS002000101','2014-01-01','2013-12-11 22:51:05','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 22:06:26'),(4901,3886,'N','01','021','EC','A',NULL,NULL,'','0000743040','0000741682','','IL','1','Stennett','Sarah','','','','34','285808952','17683 brim rd',0,'Bowling Green','OH','43402',NULL,'CY','39173','1979-04-14','F','',':RET:2106-3','N','021','DEN','947616','99734OH005000401','2014-01-01','2013-10-26 01:07:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:31:47'),(5014,3973,'Y','18','024','14','A','','','TE','0000045728','0000045728','','IL','1','Weihrauch','Pamela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-05-16','F','',NULL,NULL,NULL,'','755735','','2013-12-07','2013-12-07 05:40:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:47:22'),(24491,19456,'Y','18','021','EC','A','','','AC','0000840142','0000840142','TX00002889987','IL','1','Estrada Gonzalez','Rosa','','','','34','643193628','8395 PEBBLEDOWNE DR',0,'HOUSTON','TX','77064','8210','CY','48201','1965-01-16','F','U',':RET:2106-3','N','021','DEN','3250939','33348TX002000201','2014-04-01','2014-02-18 18:10:46','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-20 03:44:33'),(25310,20078,'Y','18','021','EC','A','','','AC','0000511990','0000511990','OH00002066559','IL','1','Macias','Gregory','','','','34','268740029','154 E FREMONT ST',0,'FOSTORIA','OH','44830','2801','CY','39147','1974-05-16','M','U',NULL,'N','021','HLT','2873098','92036OH005002705','2014-04-01','2014-02-25 10:54:48','147.00',NULL,NULL,'246.08','99.08','R-OH006','OH0','246.08','CIC',0,'2014-02-25 21:00:31'),(25327,20094,'Y','18','021','EC','A','','','AC','0002292257','0002292257','LA00002843526','IL','1','ALLISON','MARKKEITH','','','','34','434835111','314 N WESTERN AVE',0,'CROWLEY','LA','70526','4850','CY','22001','1991-02-22','M','U',':RET:2054-5','N','021','DEN','2779026','18575LA002000201','2014-04-01','2014-02-25 12:30:32','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-25 21:30:14'),(6398,5070,'Y','18','021','EC','A','','','AC','0000963206','0000963206','OH00001123253','IL','1','Condo','Stanley','','','','34','289488607','7293 IPSWICH DR',0,'CINCINNATI','OH','45224','1417','CY','39061','1950-04-18','M','U',':RET:2106-3','N','021','DEN','1044960','99734OH005000301','2014-01-01','2013-12-11 12:35:37','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:48:16'),(22192,17712,'Y','18','021','EC','A','','','AC','0000315535','0000315535','TX00001424509','31','1','Vo','Trung','Thanh','','','34','612835257','1504 Holleman Dr',0,'College Station','TX','77840',NULL,'CY','48201','1988-10-18','M','U',':RET:2047-9','N','021','DEN','3826505','33348TX002000201','2014-03-01','2014-02-09 14:11:46','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-09 19:00:10'),(4617,3656,'Y','18','021','EC','A','','','AC','0001199477','0001199477','OH00000411466','IL','1','buckey','Jeffrey','','','','34','278703826','358 CLEVELAND ST',0,'AKRON','OH','44306','1166','CY','39153','1960-10-13','M','U',':RET:2106-3','T','021','HLT','795028','52664OH151001501','2014-01-01','2013-12-12 17:37:44','283.00',NULL,NULL,'627.47','344.47','R-OH012','OH0','627.47',NULL,0,'2013-12-25 22:06:07'),(5021,3979,'N','01','021','EC','A',NULL,NULL,'','0000393405','0000586099','','IL','1','CURRY','TERESA','','','','34','439216441','6735 DOGWOOD DR',0,'PINEVILLE','LA','71360',NULL,'CY','22079','1959-03-07','F','',NULL,'N','021','DEN','475278','18575LA002000101','2014-01-01','2013-12-07 16:59:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 22:47:32'),(18276,14591,'Y','18','021','EC','A','','','AC','0000800811','0000800811','TX00002241659','IL','1','DUSZIK','MARGARET','','','','34','639282614','1303 LE DUKE BLVD',0,'LONGVIEW','TX','75601','4124','CY','48183','1991-11-27','F','U',NULL,'N','021','DEN','1883823','33348TX002000201','2014-02-01','2014-01-15 17:48:34','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-16 08:44:44'),(23943,19037,'Y','18','021','EC','A','','','AC','0000720295','0000720295','OH00002812635','IL','1','HARRIS','SAMANTHA','','','','34','436678192','2706 LOST CREEK BLVD',0,'LIMA','OH','45804','3356','CY','39003','1978-08-14','F','M',NULL,'N','021','HLT','3097193','92036OH005001501','2014-03-01','2014-02-15 11:29:28','0.00',NULL,NULL,'268.93','268.93','R-OH002','OH0','268.93','CIC',0,'2014-02-15 21:00:10'),(24122,19174,'N','01','021','EC','A',NULL,NULL,'','0000402934','0000606792','','IL','1','Salazar','Nadine','','','','34','461907717','232 County Rd 4702',0,'Winnsboro','TX','75494',NULL,'CY','48499','1950-04-18','F','',':RET:2106-3','N','021','DEN','3118511','33348TX002000201','2014-03-01','2014-02-15 15:46:28',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-15 22:01:42'),(3208,2581,'Y','18','021','EC','A','','','AC','0000205744','0000205744','OH00000431257','IL','1','Kuehn','William','','','','34','509526035','3973 RITZ CT',0,'MEDINA','OH','44256','7003','CY','39103','1955-07-15','M','M',NULL,'N','021','DEN','1174002','99734OH005000301','2014-01-01','2013-11-01 10:04:31','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:45:22'),(3755,3005,'Y','18','021','EC','A','','','AC','0000155751','0000155751','OH00001183208','IL','1','mccroskey','charles','','','','34','289502995','3026 west main street',0,'kingsville','OH','44048',NULL,'CY','39007','1950-11-08','M','M',':RET:2106-3','T','021','HLT','31394','52664OH151001306','2014-01-01','2013-12-13 17:58:49','1409.00',NULL,NULL,'1560.63','151.63','R-OH011','OH0','853.86',NULL,0,'2013-12-25 21:33:17'),(13039,10395,'Y','18','021','EC','A','','','AC','0000426424','0000426424','OH00000683870','IL','1','Crowe','Kathy','Ann','','','34','234860608','1057 STEWART RD N',0,'MANSFIELD','OH','44905','1547','CY','39139','1953-10-28','F','M',':RET:2106-3','N','021','DEN','2446070','99734OH005000401','2014-01-01','2013-12-23 06:29:29','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-26 12:50:33'),(15988,12796,'N','19','021','EC','A',NULL,NULL,'','0000720281','0000500796','','IL','1','Rodriguez','Isaac','','','','34','630307067','235 BLUE BIRD CIR',0,'KERRVILLE','TX','78028','8187','CY','48265','1992-03-22','M','',NULL,'N','021','DEN','2077427','33348TX002000201','2014-02-01','2014-01-03 11:38:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:01:10'),(16082,12879,'Y','18','021','EC','A','','','AC','0000195148','0000195148','OH00002067937','IL','1','Radel','Jennifer','','','','34','287720131','4306 Overton Ln',0,'Cincinnati','OH','45248',NULL,'CY','39061','1975-07-10','F','U',':RET:2106-3','N','021','DEN','2340342','99734OH005000401','2014-02-01','2014-01-03 15:33:34','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:04:08'),(16801,13439,'Y','18','021','EC','A','','','AC','0000512759','0000512759','TX00002411136','31','1','sheeley','courtney','','','','34','645149237','PO Box 332',0,'Hawkins','TX','75765',NULL,'CY','48499','1990-05-08','F','M',':RET:2054-5','N','021','DEN','2304835','33348TX002000201','2014-02-01','2014-01-11 11:35:07','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:18:11'),(18500,14756,'Y','18','021','EC','A','','','AC','0000570582','0000570582','OH00002180826','IL','1','Grimm','James','','','','34','294681714','191 GRANDVIEW AVE',0,'WADSWORTH','OH','44281','1156','CY','39103','1965-01-14','M','M',':RET:2106-3','N','021','HLT','1938581','52664OH151001306','2014-02-01','2014-01-15 16:49:51','557.00',NULL,NULL,'745.07','188.07','R-OH012','OH0','380.45',NULL,0,'2014-01-16 08:46:29'),(24914,19754,'Y','18','021','EC','A','','','AC','0000378631','0000378631','OH00002125114','IL','1','VAUGHT','DIANE','','','','34','285648136','1993 BRONX CORNER RD',0,'RAY','OH','45672','9629','CY','39079','1957-06-18','F','M',NULL,'N','021','DEN','2692320','99734OH005000401','2014-03-01','2014-02-20 17:30:45','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00','CIC',0,'2014-02-20 21:30:09'),(25408,20158,'Y','18','021','EC','A','','','AC','0000232694','0000232694','OH00003026389','31','1','DIRIYE','ABDIRAHMAN','','','','34','605292650','PO BOX 24321',0,'COLUMBUS','OH','43224',NULL,'CY','39049','1972-01-01','M','U',':RET:2054-5','N','021','DEN','3588564','99734OH005000401','2014-04-01','2014-02-24 23:32:46','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-25 21:31:01'),(2344,1909,'Y','18','021','EC','A','','','AC','0000550540','0000550540','TX00001241491','IL','1','Sanchez','Martin','','','','34','565153682','267 McGaugh Avenue',0,'New Braunfels','TX','78130',NULL,'CY','48091','1965-12-26','M','U',NULL,'N','021','DEN','285885','33348TX002000201','2014-01-01','2013-12-09 14:01:22','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2013-12-25 19:32:02'),(3975,3176,'Y','18','021','EC','A','','','AC','0001173197','0001173197','OH00000493082','IL','1','Milano','John','Mark','','','34','293769242','4225 HAMILTON AVE',0,'CINCINNATI','OH','45223','2033','CY','39061','1970-11-12','M','U',':RET:2106-3','N','021','HLT','999182','92036OH006001201','2014-01-01','2013-12-13 11:51:00','0.00',NULL,NULL,'231.02','231.02','R-OH004','OH0','231.02',NULL,0,'2013-12-25 21:38:42'),(3991,3186,'Y','18','021','EC','A','','','AC','0000317319','0000317319','OH00000994867','IL','1','kutzli','darcy','l','','','34','269548438','126 TIMOTHY ST',0,'DEFIANCE','OH','43512','2369','CY','39039','1954-02-04','F','U',':RET:2106-3','N','021','HLT','454744','92036OH005002601','2014-01-01','2013-12-13 16:58:57','260.00',NULL,NULL,'507.58','247.58','R-OH001','OH0','507.58',NULL,0,'2013-12-25 21:39:05'),(14091,11230,'Y','18','021','EC','A','','','AC','0000266533','0000266533','OH00001550238','IL','1','WELAGE','MARK','','','','34','287623129','4160 WEBSTER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1957-12-07','M','M',':RET:2106-3','N','021','DEN','1815645','99734OH005000401','2014-02-01','2013-12-26 11:09:34','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-27 02:01:21'),(21994,17564,'Y','18','021','EC','A','','','AC','0002029265','0002029265','LA00002122365','IL','1','Busby','Cyndi','','','','34','436651252','114 Current Dr',0,'Monroe','LA','71203',NULL,'CY','22073','1972-07-06','F','M',NULL,'N','021','DEN','2754783','18575LA002000201','2014-03-01','2014-02-07 10:24:59','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-02-07 19:00:44'),(19542,15576,'Y','18','021','EC','A','','','AC','0000707647','0000707647','OH00001709290','IL','1','Davis','Steven','','','','34','289464639','5065 HALLGATE AVE',0,'TOLEDO','OH','43612','3033','CY','39095','1950-02-12','M','U',':RET:2106-3','N','021','HLT','2610407','92036OH004002601','2014-03-01','2014-01-22 15:52:10','365.00',NULL,NULL,'470.37','105.37','R-OH001','OH0','470.37',NULL,0,'2014-01-23 03:02:25'),(24916,19756,'Y','18','021','EC','A','','','AC','0000407413','0000407413','OH00002121263','IL','1','Cain','Diane','m','','','34','297807583','1232 PEACH WOOD WAY',0,'UNIONTOWN','OH','44685','9500','CY','39153','1978-03-14','F','U',':RET:2106-3','N','021','HLT','3076164','52664OH151001306','2014-04-01','2014-02-20 13:42:26','229.00',NULL,NULL,'274.30','45.30','R-OH012','OH0','274.30','CIC',0,'2014-02-20 21:30:11'),(25504,20234,'Y','18','021','EC','A','','','AC','0000638563','0000638563','OH00003348371','IL','1','Blakely','Lynn','M','','','34','276567388','1650 Woods Road',0,'Akron','OH','44306',NULL,'CY','39153','1954-05-12','F','M',NULL,'N','021','HLT','3391719','52664OH152000901','2014-04-01','2014-02-25 10:12:49','52.00',NULL,NULL,'425.18','373.18','R-OH012','OH0','425.18',NULL,0,'2014-02-25 21:31:57'),(3412,2739,'N','01','021','EC','A',NULL,NULL,'','0002253929','0001704381','','IL','1','Cavalier','Virginia','Ann','','','34','433472464','58321 Harbor Road',0,'Slidell','LA','70460',NULL,'CY','22103','1965-08-03','F','',':RET:2106-3','N','021','DEN','2379692','18575LA002000201','2014-01-01','2013-12-22 15:48:36',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 21:18:24'),(6912,5486,'Y','18','021','EC','A','','','AC','0001258165','0001258165','LA00000646792','IL','1','Smith-Jones','Kimberly','','','','34','439377728','5000 PAUGER ST',0,'NEW ORLEANS','LA','70122','4032','CY','22071','1966-08-29','F','M',':RET:2054-5','N','021','DEN','1621127','18575LA002000201','2014-02-01','2013-12-25 00:35:18','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:57'),(4012,3205,'Y','18','021','EC','A','','','AC','0001165323','0001165323','OH00001214364','IL','1','FENNMORE','CHARLENE','D','','','34','312602119','6673 FERNSHIRE CT',0,'MASON','OH','45040','1192','CY','39165','1952-02-28','F','R',':RET:2106-3','N','021','DEN','2127885','99734OH005000401','2014-01-01','2013-12-16 23:28:05','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 21:45:26'),(22041,17594,'N','01','021','EC','A',NULL,NULL,'','0000429493','0000594183','','IL','1','Stallion','Tillman','','','','34','587809012','500 AIRPORT RD',0,'BELZONI','MS','39038','3887','CY','28053','1958-04-24','M','',NULL,'N','021','DEN','3353840','46300MS002000201','2014-03-01','2014-02-07 17:13:28',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-07 19:01:08'),(21843,17444,'Y','18','021','EC','A','','','AC','0000924832','0000924832','OH00002169264','IL','1','KNAPP','IRENE','','','','34','297926640','6677 CASEBEER MILLER RD',0,'HICKSVILLE','OH','43526',NULL,'CY','39039','1990-12-12','F','U',':RET:2106-3','N','021','HLT','3552355','92036OH005002606','2014-03-01','2014-02-06 10:51:12','100.00',NULL,NULL,'194.99','94.99','R-OH001','OH0','194.99',NULL,0,'2014-02-06 21:01:12'),(21771,17386,'Y','18','021','EC','A','','','AC','0000171271','0000171271','OH00002578729','IL','1','CIMINI','LARRY','','','','34','274521649','8153 US HIGHWAY 23 N',0,'DELAWARE','OH','43015','9697','CY','39041','1952-02-14','M','M',':RET:2106-3','N','021','DEN','3845843','99734OH005000401','2014-03-01','2014-02-06 13:34:28','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:32'),(4650,3686,'Y','18','021','EC','A','','','AC','0000491855','0000491855','OH00000771446','IL','1','stewart','robert','','','','34','334605123','810 clough pike',0,'cincinnati','OH','45245',NULL,'CY','39025','1960-05-02','M','U',':RET:2106-3','T','021','HLT','827468','92036OH003000605','2014-01-01','2013-12-12 08:35:45','280.00',NULL,NULL,'525.93','245.93','R-OH005','OH0','525.93',NULL,0,'2013-12-25 22:07:02'),(19961,15923,'Y','18','021','EC','A','','','AC','0001212111','0001212111','TX00001996532','IL','1','Pena','Mary','Elizabeth','','','34','452778435','1515 HARVARD AVE',0,'BROWNSVILLE','TX','78520','8221','CY','48061','1975-11-12','F','U',NULL,'N','021','DEN','3192057','33348TX002000201','2014-03-01','2014-01-25 15:04:48','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2014-01-25 19:00:07'),(6219,4929,'Y','18','024','14','A','','','TE','0000019074','0000019074','','IL','1','davidson','terrence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-07-18','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-15 22:03:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:31:06'),(17221,13780,'N','01','021','EC','A',NULL,NULL,'','0000468835','0000681881','','IL','1','Lofton','Osie','D','','','34','427047938','134 NORTHVIEW ST',0,'UTICA','MS','39175','8800','CY','28049','1959-05-02','M','',':RET:2054-5','N','021','DEN','2570046','46300MS002000201','2014-02-01','2014-01-08 15:50:22',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-01-13 02:22:33'),(24430,19406,'Y','18','021','EC','A','','','AC','0000682190','0000682190','OH00002552984','IL','1','rudes','Cynthia','l','','','34','278521207','5671 CHIPPEWA RD',0,'CHIPPEWA LAKE','OH','44215','8882','CY','39103','1953-01-15','F','M',NULL,'N','021','HLT','3648941','52664OH151001305','2014-04-01','2014-02-18 11:20:31','422.00',NULL,NULL,'626.65','204.65','R-OH012','OH0','626.65',NULL,0,'2014-02-18 22:01:13'),(19398,15465,'Y','18','021','EC','A','','','AC','0000392388','0000392388','OH00002536306','IL','1','SHOULTS','CHARLOTTE','','','','34','275505968','7 LEEDS RD',0,'CHILLICOTHE','OH','45601','1045','CY','39141','1954-10-14','F','U',':RET:2106-3','N','021','DEN','2437955','99734OH005000401','2014-03-01','2014-01-21 17:45:02','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,1,'2014-01-22 03:22:51'),(18810,14982,'Y','18','021','EC','A','','','AC','0001008967','0001008967','OH00002054744','S3','1','GROSSMAN','ELLIOTT','YUN','','','34','730200094','957 ASHIRE CT',0,'LOVELAND','OH','45140','8147','CY','39025','2008-01-10','F','U',NULL,'N','021','DEN','2961148','99734OH005000401','2014-03-01','2014-01-16 16:54:19','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','15.78',NULL,0,'2014-01-17 03:36:03'),(3035,2440,'N','01','021','EC','A',NULL,NULL,'','0000157969','0000712494','','IL','1','Faulkner','Rodney','Clark','','','34','465477063','3360 S PRICETOWN RD',0,'BERLIN CENTER','OH','44401','9738','CY','39099','1964-10-26','M','',':RET:2106-3','T','021','HLT','56316','52664OH152000901','2014-01-01','2013-12-05 21:40:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.41',NULL,0,'2013-12-25 20:18:30'),(24365,19351,'Y','18','021','EC','A','','','AC','0002230461','0002230461','LA00001650101','IL','1','ADAMS','TERRY','N','','','34','437279656','324 CODIFER BLVD',0,'METAIRIE','LA','70005','3764','CY','22051','1960-03-05','F','U',NULL,'N','021','DEN','3257371','18575LA002000201','2014-04-01','2014-02-18 11:24:30','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-18 22:00:34'),(8835,7003,'Y','18','021','EC','A','','','AC','0001211920','0001211920','TX00000072798','IL','1','King','Aaron','','','','34','631075345','533 COUNTY ROAD 222',0,'NACOGDOCHES','TX','75965','4809','CY','48347','1987-06-08','M','U',':RET:2106-3','N','021','DEN','2095853','33348TX002000201','2014-01-01','2013-12-17 20:51:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:35'),(14294,11403,'Y','18','021','EC','A','','','AC','0000179907','0000179907','OH00000590485','IL','1','Asplin','Jeff','','','','34','288661710','714 WOODLAKE DR',0,'AURORA','OH','44202','7656','CY','39133','1960-07-29','M','U',NULL,'N','021','HLT','1977985','52664OH152000901','2014-02-01','2013-12-26 16:01:35','221.00',NULL,NULL,'333.21','112.21','R-OH012','OH0','333.21',NULL,0,'2013-12-27 02:06:40'),(22061,17611,'Y','18','021','EC','A','','','AC','0000672371','0000672371','TX00001980653','IL','1','PETEET','JAMES','C','','','34','453866004','408 E HOPKINS ST',0,'MEXIA','TX','76667','3634','CY','48293','1951-01-12','M','U',':RET:2054-5','T','021','DEN','2942772','33348TX002000201','2014-03-01','2014-02-08 12:32:18','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-08 19:00:10'),(18156,14500,'Y','18','021','EC','A','','','AC','0000814306','0000814306','OH00001394298','IL','1','Kunar','Joshua','Alan','','','34','290823608','512 ADRIAN ST',0,'DELTA','OH','43515','1063','CY','39051','1984-03-22','M','M',':RET:2106-3','N','021','HLT','1605988','92036OH005002606','2014-02-01','2014-01-13 22:19:02','362.00',NULL,NULL,'439.52','77.52','R-OH001','OH0','218.20',NULL,0,'2014-01-15 02:07:52'),(26056,20665,'Y','18','021','EC','A','','','AC','0000121603','0000121603','OH00002477723','IL','1','White','Cathryn','Marie','','','34','285489213','42 E Main Street',0,'Wakeman','OH','44889',NULL,'CY','39077','1952-03-03','F','M',NULL,'N','021','HLT','2814887','92036OH003002705','2014-04-01','2014-02-26 11:19:43','481.00',NULL,NULL,'585.04','104.04','R-OH006','OH0','585.04',NULL,0,'2014-02-26 21:02:36'),(28256,22358,'Y','18','024','14','A','','','TE','0001204586','0001204586','','IL','1','ALSHAHAL','MANAL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-05-18','F','',NULL,NULL,NULL,'','2969726','','2014-03-06','2014-03-06 19:19:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-03-07 21:00:15'),(784,646,'Y','18','021','EC','A','','','AC','0001005466','0001005466','TX00001090052','IL','1','DAVIS','JEFFREY','W','','','34','539621542','4500 STEINER RANCH BLVD',0,'AUSTIN','TX','78732',NULL,'CY','48453','1959-10-03','M','U',':RET:2106-3','N','021','DEN','1908324','33348TX002000201','2014-01-01','2013-12-16 15:12:41','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:05:07'),(22652,18087,'Y','18','021','EC','A','','','AC','0000852203','0000852203','TX00002159885','IL','1','Smith','Teresita','','','','34','452296297','2906 S BIVINS ST',0,'AMARILLO','TX','79103','4602','CY','48381','1950-04-06','F','U',':RET:2036-2','T','021','DEN','2840220','33348TX002000201','2014-03-01','2014-02-11 11:44:49','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2014-02-11 21:00:28'),(9782,7747,'Y','18','021','EC','A','','','AC','0000409701','0000409701','OH00001022695','IL','1','Gilbert','George','','','','34','301700912','14412 Granger Road',0,'Maple Hts','OH','44137',NULL,'CY','39035','1968-12-07','M','U',':RET:2054-5','N','021','DEN','580844','99734OH005000301','2014-01-01','2013-10-21 00:33:15','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-26 05:00:45'),(9679,7668,'Y','18','021','EC','A','','','AC','0000165069','0000165069','OH00000665785','IL','1','VanHoutte','Jerled','A','','','34','365507131','11160 US ROUTE 24',0,'GRAND RAPIDS','OH','43522','9345','CY','39095','1951-07-11','M','U',NULL,'N','021','HLT','2322732','92036OH003002606','2014-01-01','2013-12-21 09:57:07','500.00',NULL,NULL,'585.04','85.04','R-OH001','OH0','585.04',NULL,0,'2013-12-26 04:39:26'),(994,814,'Y','18','021','EC','A','','','AC','0001100562','0001100562','OH00000086130','IL','1','debord','dawn','','','','34','301605993','724 UNION RD',0,'FRANKLIN','OH','45005','2568','CY','39165','1976-09-07','F','U',':RET:2106-3','N','021','DEN','861401','99734OH005000401','2014-01-01','2013-11-11 16:38:39','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:10:42'),(23095,18411,'Y','18','021','EC','A','','','AC','0000991586','0000991586','OH00001732007','IL','1','PENNINGTON','PATRICK','','','','34','302602388','26407 LUNDA RD',0,'WEST MANSFIELD','OH','43358','9644','CY','39159','1967-03-17','M','M',':RET:2106-3','N','021','DEN','3377749','99734OH005000401','2014-03-01','2014-02-12 13:55:33','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-02-12 21:31:09'),(19099,15216,'N','01','021','EC','A',NULL,NULL,'','0001163379','0001712557','','IL','1','HEHOLT','TAMMY','','','','34','554378443','2553 COURT STREET',0,'PORT ALLEN','LA','70767',NULL,'CY','22121','1961-06-24','F','',NULL,'N','021','DEN','1683024','18575LA002000201','2014-03-01','2014-01-18 09:55:57',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-21 08:44:37'),(6970,5531,'N','01','021','EC','A',NULL,NULL,'','0000073947','0000509211','','IL','1','Mejia','Adrian','Jerome','','','34','266259187','9211 Deercross Pkwy 1B',0,'Cincinnati','OH','45236',NULL,'CY','39061','1954-09-28','M','',':RET:2106-3','N','021','DEN','1655274','99734OH005000401','2014-01-01','2013-12-24 23:05:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:47:26'),(1395,1158,'N','19','021','EC','A',NULL,NULL,'','0001538869','0001861368','','IL','1','BLAKE','KINYA','','','','34','436832534','1605 N PRIEUR ST',0,'NEW ORLEANS','LA','70116','1311','CY','22071','1991-11-09','F','',NULL,'N','021','DEN','2056894','18575LA002000201','2014-01-01','2013-12-24 11:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 18:46:27'),(6711,5321,'Y','18','021','EC','A','','','AC','0000251586','0000251586','OH00000354092','IL','1','DeLong','Deaneane','','','','34','281666455','3431 Parallel Rd',0,'Moraine','OH','45439',NULL,'CY','39113','1960-10-23','F','U',':RET:2106-3','N','021','HLT','757054','92036OH004000501','2014-01-01','2013-11-05 12:49:25','387.07',NULL,NULL,'389.92','2.85','R-OH003','OH0','389.92',NULL,0,'2013-12-26 01:02:15'),(15343,12272,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','2331181','','2014-01-01','2014-01-01 10:48:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-02 04:24:19'),(14001,11154,'Y','18','021','EC','A','','','AC','0000082565','0000082565','OH00000141749','IL','1','Ramps','Joseph','','','','34','280507138','1017 WOODLAWN AVE',0,'GIRARD','OH','44420','2060','CY','39155','1957-11-08','M','U',':RET:2106-3','N','021','HLT','2190726','92036OH002003201','2014-01-01','2013-12-23 08:21:10','425.00',NULL,NULL,'652.13','227.13','R-OH013','OH0','652.13',NULL,0,'2013-12-26 13:16:03'),(13714,10943,'Y','18','021','EC','A','','','AC','0001186314','0001186314','OH00001355259','IL','1','Gelsinger','Pamela','','','','34','271465835','2148 MOGADORE RD',0,'AKRON','OH','44312','1130','CY','39153','1953-02-17','F','U',':RET:2106-3','N','021','HLT','2433322','52664OH151001304','2014-01-01','2013-12-23 14:38:39','381.00',NULL,NULL,'605.24','224.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 13:09:01'),(13712,10941,'Y','18','021','EC','A','','','AC','0001186314','0001186314','OH00000271831','IL','1','Gelsinger','Pamela','','','','34','271465835','2148 MOGADORE RD',0,'AKRON','OH','44312','1130','CY','39153','1953-02-17','F','U',':RET:2106-3','N','021','HLT','1405368','52664OH151001304','2014-01-01','2013-12-23 14:30:30','381.00',NULL,NULL,'605.24','224.24','R-OH012','OH0','605.24',NULL,0,'2013-12-26 13:08:58'),(3876,3104,'Y','18','021','EC','A','','','AC','0000175537','0000175537','LA00000170102','IL','1','Ducote','Michael','','','','34','434790309','15320 BECKY LEE DR',0,'BATON ROUGE','LA','70819','3403','CY','22033','1985-06-09','M','U',':RET:2106-3','T','021','DEN','1203263','18575LA002000201','2014-01-01','2013-12-13 13:07:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:36:18'),(3217,2588,'Y','18','021','EC','A','','','AC','0000841880','0000841880','OH00000629868','IL','1','jackson','paul','w','','Sr','34','287748486','1151 grant st',0,'akron','OH','44301',NULL,'CY','39153','1963-10-16','M','M',':RET:2106-3','T','021','HLT','797786','52664OH151001301','2014-01-01','2013-11-01 06:35:25','0.00',NULL,NULL,'458.04','458.04','R-OH012','OH0','458.04',NULL,0,'2013-12-25 20:45:36'),(28358,22437,'N','01','021','EC','A',NULL,NULL,'','0001123826','0000941940','','IL','1','North','Jeran','','','','34','463811257','289 BRIGGS BLVD',0,'POINT','TX','75472','7141','CY','48379','1984-09-25','F','',':RET:2106-3','N','021','DEN','4200488','33348TX002000201','2014-04-01','2014-03-07 14:00:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-07 21:30:27'),(2333,1899,'Y','18','021','EC','A','','','AC','0001235239','0001235239','TX00000946971','IL','1','Roye','Lorenza','Eugene','','','34','579840814','611 W. 3rd St.',0,'Sweetwater','TX','79556',NULL,'CY','48353','1959-05-23','M','U',':RET:2054-5','N','021','DEN','823448','33348TX002000201','2014-01-01','2013-12-09 12:27:43','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:31:45'),(4098,3275,'Y','18','021','EC','A','','','AC','0000316687','0000316687','TX00000309650','IL','1','Tucker','Dan','','','','34','455155773','1884 S CONCHO DR',0,'SAN ANGELO','TX','76904','7971','CY','48451','1957-07-16','M','M',':RET:2106-3','N','021','DEN','1479746','33348TX002000101','2014-01-01','2013-12-16 20:28:03','0.00',NULL,NULL,'50.04','50.04','R-TX018','TX0','25.02',NULL,0,'2013-12-25 21:47:40'),(23685,18861,'Y','18','021','EC','A','','','AC','0000422856','0000422856','OH00002305491','IL','1','SMITH','TIMOTHY','','','','34','289709537','5391 WOODBINE AVE',0,'DAYTON','OH','45432','3652','CY','39113','1970-04-27','M','U',':RET:2106-3','N','021','DEN','3623080','99734OH005000401','2014-03-01','2014-02-13 19:08:05','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-14 21:30:33'),(22513,17973,'Y','18','021','EC','A','','','AC','0000999224','0000999224','TX00002649329','IL','1','Moore','Bobby','','','','34','642106713','7618 MAXWELL AVE',0,'DALLAS','TX','75217','1652','CY','48113','1985-04-15','M','U',':RET:2106-3','N','021','DEN','2642621','33348TX002000101','2014-03-01','2014-02-09 22:36:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-10 21:31:20'),(6422,5092,'Y','18','024','14','A','','','TE','0000577169','0000577169','','IL','1','Gravois','Evelie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-01-31','F','',NULL,NULL,NULL,'','601178','','2013-12-10','2013-12-10 19:29:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 00:48:56'),(21990,17561,'Y','18','021','EC','A','','','AC','0002074915','0002074915','LA00002010012','IL','1','Stevenson','Bernita','','','','34','435844509','447 E OLIVE ST',0,'SHREVEPORT','LA','71104','2764','CY','22017','1950-08-24','F','U',':RET:2054-5','N','021','DEN','3292472','18575LA002000201','2014-03-01','2014-02-06 22:05:15','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-02-07 19:00:41'),(15377,12300,'Y','18','021','EC','A','','','AC','0000153379','0000153379','OH00000785557','IL','1','harrison','danette','','','','34','299601835','1347Longacre dr',0,'Cincinatti','OH','45240',NULL,'CY','39061','1965-02-18','F','U',':RET:2106-3','T','021','HLT','1629953','92036OH005001204','2014-02-01','2014-01-01 10:29:46','116.00',NULL,NULL,'403.64','287.64','R-OH004','OH0','403.64',NULL,1,'2014-01-02 04:25:18'),(15734,12586,'Y','18','021','EC','A','','','AC','0000136094','0000136094','OH00002210441','IL','1','Kiphart','Jonathan','','','','34','289723174','8516 Breezewood Ct',0,'West Chester','OH','45069',NULL,'CY','39017','1973-09-27','M','U',':RET:2106-3','N','021','DEN','2170757','99734OH005000301','2014-02-01','2014-01-02 11:26:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:00:37'),(17012,13615,'N','19','021','EC','A',NULL,NULL,'','0000145400','0000471029','','IL','1','Hurley','Katherine','Stupnik','','','34','012741016','2605 WELLINGTON RD',0,'CLEVELAND HEIGHTS','OH','44118','4120','CY','39035','1990-01-29','F','',':RET:2106-3','N','021','DEN','2106998','99734OH005000301','2014-02-01','2014-01-09 13:42:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:20:36'),(25739,20415,'N','19','021','EC','A',NULL,NULL,'','0001033720','0000358382','','IL','1','WILLSON','DEMETRIUS','','','Jr','34','299948655','38718 AVENEL CT',0,'WILLOUGHBY','OH','44094','8068','CY','39085','1992-10-20','M','',':RET:2054-5','N','021','DEN','2970780','99734OH005000401','2014-04-01','2014-02-24 11:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:39'),(26357,20909,'Y','18','021','EC','A','','','AC','0000060320','0000060320','OH00001935995','IL','1','Wilder-Kulnane','Jody','','','','34','280861695','582 MAGNOLIA DR',0,'PAINESVILLE','OH','44077','2624','CY','39085','1973-06-20','F','M',':RET:2106-3','N','021','DEN','3087814','99734OH005000301','2014-03-01','2014-02-26 09:50:45','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00','CIC',0,'2014-02-28 07:00:03'),(26907,21325,'Y','18','021','EC','A','','','AC','0001293711','0001293711','LA00002426065','IL','1','LUWIS','TIMOTHY','','','','34','434432525','5108 FELICIANA DR',0,'NEW ORLEANS','LA','70126','3514','CY','22071','1977-06-28','M','U',':RET:2054-5','T','021','DEN','2828770','18575LA002000201','2014-04-01','2014-03-02 10:44:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-03 01:00:10'),(13772,10993,'N','01','021','EC','A',NULL,NULL,'','0000104383','0000399300','','IL','1','Reed','Bruce','Anthony','','','34','425044587','4631 N CHAPEL HILL RD',0,'EDWARDS','MS','39066','9174','CY','28049','1956-11-20','M','',':RET:2054-5','N','021','DEN','2049494','46300MS002000201','2014-01-01','2013-12-23 12:49:48',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 13:10:32'),(1492,1245,'Y','18','024','14','A','','','TE','0001030376','0001030376','','IL','1','Nicholas','John',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1959-07-13','M','',NULL,NULL,NULL,'','2527330','','2013-12-24','2013-12-24 11:18:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:49:04'),(13427,10711,'Y','18','021','EC','A','','','AC','0000067671','0000067671','OH00000252698','IL','1','Hovey','Gary','','','','34','259901441','6400 BOTKINS RD',0,'NEW KNOXVILLE','OH','45871','9522','CY','39149','1959-02-23','M','M',':RET:2106-3','N','021','DEN','2231960','99734OH005000301','2014-01-01','2013-12-23 11:38:29','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 13:00:56'),(24377,19363,'Y','18','021','EC','A','','','AC','0000763569','0000763569','OH00002694752','IL','1','Grier','Ralph','','','','34','230889174','9654 FALLSHILL CIR',0,'CINCINNATI','OH','45231','2886','CY','39061','1958-09-20','M','U',':RET:2054-5','N','021','DEN','2897405','99734OH005000401','2014-04-01','2014-02-18 08:13:02','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-18 22:00:42'),(7436,5885,'Y','18','021','EC','A','','','AC','0000799874','0000799874','OH00000864579','IL','1','Beane','Heidi','','','','34','277847138','964 Treat Blvd.',0,'Tallmadge','OH','44278',NULL,'CY','39153','1969-10-15','F','U',':RET:2106-3','N','021','HLT','628415','52664OH151001305','2014-01-01','2013-12-15 11:06:22','198.00',NULL,NULL,'311.54','113.54','R-OH012','OH0','311.54',NULL,0,'2013-12-26 02:30:16'),(24120,19173,'Y','18','021','EC','A','','','AC','0000488060','0000488060','TX00001758026','IL','1','Hawkins','Aaron','','','','34','549714029','2501 Tanglewilde Street',0,'Houston','TX','77063',NULL,'CY','48201','1982-01-25','M','U',':RET:2054-5','N','021','DEN','2628966','33348TX002000201','2014-03-01','2014-02-15 15:43:15','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-15 22:01:41'),(14006,11158,'N','01','021','EC','A',NULL,NULL,'','0000485859','0000712519','','IL','1','Bickerstaff','Jack','E','','','34','268445844','3016 NILES CARVER RD',0,'NILES','OH','44446','1330','CY','39155','1950-07-13','M','',':RET:2106-3','T','021','HLT','1370468','92036OH003003201','2014-01-01','2013-12-23 09:39:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','858.11',NULL,0,'2013-12-26 13:16:14'),(16807,13443,'Y','18','021','EC','A','','','AC','0000710854','0000710854','TX00001907365','IL','1','khan','sadaqat','','','','34','602683133','1213 N GRAY ST',0,'KILLEEN','TX','76541','3440','CY','48027','1962-10-02','M','M',':RET:2028-9','N','021','DEN','2192619','33348TX002000201','2014-02-01','2014-01-11 14:02:35','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-01-13 02:18:14'),(19153,15259,'N','19','021','EC','A',NULL,NULL,'','0000825935','0001115974','','IL','1','Fordham','James','','','Jr','34','278804313','3327 ARLINGTON AVE',0,'TOLEDO','OH','43614','2475','CY','39095','1995-01-27','M','',NULL,'N','021','HLT','2760812','92036OH004002601','2014-03-01','2014-01-18 20:23:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2014-01-21 08:45:36'),(25307,20076,'N','19','021','EC','A',NULL,NULL,'','0000761132','0000680905','','S3','1','L\'Heureux','Wiliam',NULL,NULL,NULL,NULL,NULL,'357 W WASHINGTON ST',0,'NELSONVILLE','OH','45764','1164','CY','39009','2009-12-17','M','',':RET:2106-3','N','021','DEN','3445971','99734OH005000301','2014-03-01','2014-02-25 16:09:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-25 21:00:30'),(25890,20528,'Y','18','021','EC','A','','','AC','0000437109','0000437109','TX00002330040','IL','1','ROSZEL','NORMAN','','','','34','440480592','321 GRANITE BLVD',0,'MARBLE FALLS','TX','78654','9202','CY','48053','1954-07-02','M','M',':RET:2106-3','N','021','DEN','3764399','33348TX002000201','2014-04-01','2014-02-26 11:00:19','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-26 21:01:03'),(27476,21742,'N','01','021','EC','A',NULL,NULL,'','0000237646','0001239181','','IL','1','Choe','Chong','Im','','','34','269905911','8586 W STATE ROUTE 163',0,'OAK HARBOR','OH','43449','8815','CY','39123','1966-03-23','F','',':RET:2040-4','T','021','HLT','3693657','92036OH003002705','2014-04-01','2014-03-03 21:46:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','382.89',NULL,0,'2014-03-04 21:02:14'),(28104,22245,'Y','18','021','EC','A','','','AC','0000246512','0000246512','OH00002950624','IL','1','Stehler','Greg','','','','34','287484330','1984 PONDVIEW CIR NW',0,'UNIONTOWN','OH','44685','7376','CY','39151','1952-04-08','M','U',':RET:2106-3','N','021','HLT','3950266','52664OH152000901','2014-04-01','2014-03-06 13:27:34','344.00',NULL,NULL,'458.99','114.99','R-OH015','OH0','458.99',NULL,0,'2014-03-06 21:02:12'),(28519,22569,'Y','18','021','EC','A','','','AC','0000152047','0000152047','OH00003485810','IL','1','ARMSTRONG','SUZANNE','W','','','34','275507956','12073 N SHORE DR',0,'HILLSBORO','OH','45133','9211','CY','39071','1952-07-10','F','M',NULL,'N','021','HLT','4207851','92036OH004000601','2014-04-01','2014-03-07 10:37:23','255.00',NULL,NULL,'485.05','230.05','R-OH005','OH0','485.05',NULL,0,'2014-03-07 21:31:59'),(1397,1160,'Y','18','021','EC','A','','','AC','0002093128','0002093128','LA00001095442','IL','1','savage','joan','','','','34','437503267','3991 HIGHWAY 306',0,'DES ALLEMANDS','LA','70030','3419','CY','22089','1953-05-02','F','M',':RET:2106-3','N','021','DEN','2585372','18575LA002000201','2014-01-01','2013-12-24 12:19:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:30'),(9136,7246,'Y','18','021','EC','A','','','AC','0000781886','0000781886','OH00000956268','IL','1','Warner','Harmony','','','','34','536846193','809 Morse St.',0,'Findlay','OH','45840',NULL,'CY','39063','1979-11-03','F','M',':RET:2054-5^:RET:2106-3','N','021','HLT','1864009','92036OH003001505','2014-01-01','2013-12-17 21:30:14','469.16',NULL,NULL,'569.07','99.91','R-OH002','OH0','279.02',NULL,0,'2013-12-26 04:08:06'),(1198,987,'Y','18','021','EC','A','','','AC','0000425060','0000425060','OH00000005979','IL','1','Lovell','Bethany','','','','34','277880736','311 E COLUMBUS ST',0,'COLUMBUS','OH','43206','2265','CY','39049','1979-08-04','F','R',':RET:2106-3','N','021','DEN','794785','99734OH005000301','2014-01-01','2013-12-03 15:59:55','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:19:48'),(19449,15503,'Y','18','021','EC','A','','','AC','0000994001','0000994001','OH00001560248','IL','1','Rosario','Ramona','','','','34','584192999','47405 MIDDLE RIDGE RD',0,'AMHERST','OH','44001','3209','CY','39093','1961-12-10','F','M',NULL,'N','021','DEN','3150951','99734OH005000301','2014-03-01','2014-01-22 11:23:46','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-23 03:01:52'),(6636,5264,'Y','18','021','EC','A','','','AC','0000830594','0000830594','OH00001183920','IL','1','Samuels','Tana','','','','34','282868151','1431 ORCHARD PARK DR',0,'COLUMBUS','OH','43232','6432','CY','39049','1978-11-25','F','U',NULL,'N','021','DEN','503100','99734OH005000401','2014-01-01','2013-11-12 17:53:25','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 01:00:10'),(6495,5146,'Y','18','021','EC','A','','','AC','0000625403','0000625403','OH00001217621','IL','1','West','Robin','','','','34','302582014','34 West Woodsdale Avenue',0,'Akron','OH','44301',NULL,'CY','39153','1962-10-07','F','M',':RET:2106-3','N','021','HLT','141822','52664OH151001305','2014-01-01','2013-12-11 14:33:38','446.00',NULL,NULL,'672.37','226.37','R-OH012','OH0','415.91',NULL,0,'2013-12-26 00:50:41'),(5508,4373,'Y','18','021','EC','A','','','AC','0001207117','0001207117','OH00000572802','IL','1','Stamp','John','Wayne','','','34','284708782','11818 Hidden Lake Dr.',0,'Marshallville','OH','44645',NULL,'CY','39169','1965-07-07','M','R',':RET:2106-3','N','021','DEN','1073474','99734OH005000301','2014-01-01','2013-11-26 18:22:30','0.00',NULL,NULL,'87.78','87.78','R-OH014','OH0','0.00',NULL,0,'2013-12-25 23:15:06'),(2044,1674,'Y','18','024','14','A','','','TE','0000246807','0000246807','','IL','1','Rios','Yolanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-03-25','F','',NULL,NULL,NULL,'','230870','','2013-12-10','2013-12-10 11:07:35',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 19:15:40'),(3132,2517,'Y','18','021','EC','A','','','AC','0000310819','0000310819','OH00001218423','IL','1','woodward','sandra','','','','34','281441611','3110 MAYFIELD RD',0,'SILVER LAKE','OH','44224','3120','CY','39153','1954-12-08','F','U',NULL,'N','021','HLT','1069560','52664OH151001301','2014-01-01','2013-10-13 13:05:23','0.00',NULL,NULL,'580.49','580.49','R-OH012','OH0','580.49',NULL,0,'2013-12-25 20:30:33'),(24545,19498,'Y','18','021','EC','A','','','AC','0000700436','0000700436','OH00002873566','IL','1','Wingo','Cerra','','','','34','283845987','750 MULL AVE',0,'AKRON','OH','44313','7561','CY','39153','1985-11-27','F','U',':RET:1002-5^:RET:2054-5','N','021','HLT','3299255','52664OH151001305','2014-04-01','2014-02-18 20:59:47','126.00',NULL,NULL,'242.41','116.41','R-OH012','OH0','242.41',NULL,0,'2014-02-20 04:03:20'),(13121,10464,'N','01','021','EC','A',NULL,NULL,'','0000870628','0000830631','','IL','1','Kuhre','Siri','','','','34','194389926','9483 Conklin Avenue',0,'Cincinnati','OH','45242',NULL,'CY','39061','1963-10-12','F','',':RET:2106-3','N','021','DEN','1790866','99734OH005000401','2014-01-01','2013-12-23 14:06:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:52:45'),(13094,10439,'N','01','021','EC','A',NULL,NULL,'','0000953246','0001166814','','IL','1','Snow','Kimberly','','','','34','411989356','219 North Cooper Avenue',0,'Cincinnati','OH','45215',NULL,'CY','39061','1968-06-04','F','',':RET:2106-3','N','021','DEN','1789542','99734OH005000401','2014-01-01','2013-12-23 11:43:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:58'),(9595,7599,'Y','18','024','14','A','','','TE','0000370013','0000370013','','IL','1','Martin','James',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-04-24','M','',NULL,NULL,NULL,'','1814206','','2013-12-20','2013-12-20 21:50:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:37:16'),(21889,17478,'Y','18','021','EC','A','','','AC','0001118759','0001118759','OH00001561915','IL','1','Shurelds','Tony','','','','34','277561975','302 West Spring',0,'Lima','OH','45801',NULL,'CY','39003','1958-03-05','M','U',NULL,'N','021','HLT','3817930','92036OH003001505','2014-03-01','2014-02-06 15:40:51','443.00',NULL,NULL,'512.54','69.54','R-OH002','OH0','512.54',NULL,0,'2014-02-06 21:01:37'),(20296,16201,'Y','18','021','EC','A','','','AC','0001530680','0001530680','LA00002567080','IL','1','BELTON','LEE','','','','34','435233155','3606 WHITE STREET',0,'MONROE','LA','71203',NULL,'CY','22073','1961-04-10','M','U',':RET:2054-5','N','021','DEN','2139577','18575LA002000201','2014-03-01','2014-01-28 17:06:16','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-28 21:00:40'),(20285,16190,'Y','18','024','14','A','','','TE','0000272525','0000272525','','IL','1','Simes','Lisa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-07-13','F','',NULL,NULL,NULL,'','2646956','','2014-01-28','2014-01-28 17:15:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-28 21:00:32');
INSERT INTO `EdiParticipant` VALUES (19298,15383,'N','01','021','EC','A',NULL,NULL,'','0002112197','0001724237','','IL','1','Hall','Darrell','Eugene','','','34','421883573','632 W Marlin Ct',0,'Terrytown','LA','70056',NULL,'CY','22051','1957-09-23','M','',':RET:2054-5','N','021','DEN','2491267','18575LA002000201','2014-03-01','2014-01-21 16:40:42',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-22 03:21:59'),(17122,13702,'N','01','021','EC','A',NULL,NULL,'','0000866911','0000397350','','IL','1','CRABTREE','MICHAEL','W','','','34','268585566','1485B MCDERMOTT POND CREEK RD',0,'MC DERMOTT','OH','45652','8978','CY','39145','1954-08-26','M','',':RET:2106-3','T','021','DEN','1900184','99734OH005000401','2014-02-01','2014-01-08 10:36:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:42'),(16339,13080,'N','19','021','EC','A',NULL,NULL,'','0000910539','0000665660','','S1','1','CONRAD','CURT','W','','','34','277155148','4609 CREEKRUN DR',0,'MASON','OH','45040',NULL,'CY','39165','2009-03-20','F','',NULL,'N','021','DEN','2064786','99734OH005000301','2014-02-01','2014-01-06 12:31:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-07 04:02:12'),(15953,12771,'N','01','021','EC','A',NULL,NULL,'','0000740289','0001236590','','IL','1','Inthasom','Souphansa','','','','34','245530994','8241 CELESTIAL CIR',0,'LIBERTY TOWNSHIP','OH','45044','8399','CY','39017','1984-04-04','F','',NULL,'N','021','DEN','2336484','99734OH005000301','2014-02-01','2014-01-02 22:43:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:10'),(6718,5328,'Y','18','021','EC','A','','','AC','0000645939','0000645939','OH00000873493','IL','1','Ludwig','Richard','','','','34','278443645','1166 N. Jefferson St.',0,'Medina','OH','44256',NULL,'CY','39103','1949-07-09','M','U',':RET:2106-3','N','021','DEN','730619','99734OH005000401','2014-01-01','2013-11-25 13:01:11','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:15:07'),(6753,5358,'N','01','021','EC','A',NULL,NULL,'','0001140734','0001025478','','IL','1','Scarlato','Victoria','Lynn','','','34','284802728','3633 Darwin ave',0,'Cincinnati','OH','45211',NULL,'CY','39061','1973-03-30','F','',':RET:2106-3','N','021','HLT','72764','92036OH004001201','2014-01-01','2013-11-24 23:30:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','220.60',NULL,0,'2013-12-26 01:16:08'),(26173,20754,'Y','18','021','EC','A','','','AC','0001031168','0001031168','MS00003405901','IL','1','Johson','Linda','','','','34','427190156','2409 GEORGETOWN AVE',0,'JACKSON','MS','39213','7306','CY','28049','1961-12-26','F','U',':RET:2054-5','N','021','DEN','2806538','46300MS002000201','2014-04-01','2014-02-27 12:20:57','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-28 06:30:37'),(26965,21364,'Y','18','021','EC','A','','','AC','0000261557','0000261557','OH00003111419','IL','1','SHOFFSTALL','MICHAEL','','','','34','300482337','2513 VICTORIA PKWY',0,'HUDSON','OH','44236','3122','CY','39153','1954-09-08','M','M',':RET:2106-3','N','021','HLT','3677421','52664OH151001305','2014-04-01','2014-03-02 15:45:36','750.00',NULL,NULL,'1160.98','410.98','R-OH012','OH0','580.49',NULL,0,'2014-03-03 01:00:32'),(27967,22125,'Y','18','024','14','A','','','TE','0000149183','0000149183','','IL','1','Mayfield','LaKitta','Marie',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-11-15','F','',NULL,NULL,NULL,'','70288','','2014-03-31','2014-03-06 10:32:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-06 21:00:48'),(28097,22239,'Y','18','021','EC','A','','','AC','0000232046','0000232046','MS00003259139','IL','1','DUBOIS','ROBERT','','','','34','134628918','51 KARLA DR',0,'VICKSBURG','MS','39180','9761','CY','28149','1971-10-26','M','M',NULL,'T','021','DEN','3784507','46300MS002000101','2014-04-01','2014-03-06 17:57:43','0.00',NULL,NULL,'54.30','54.30','R-MS003','MS0','27.15',NULL,0,'2014-03-06 21:02:08'),(28716,22726,'Y','18','021','EC','A','','','AC','0000333930','0000333930','OH00002749241','IL','1','BROWNING','DAVE','','','','34','292428391','4997 STATE ROUTE 350',0,'CLARKSVILLE','OH','45113','9420','CY','39027','1955-03-13','M','M',NULL,'T','021','HLT','3481439','92036OH004000601','2014-04-01','2014-03-08 15:05:47','992.00',NULL,NULL,'1022.50','30.50','R-OH005','OH0','516.72',NULL,0,'2014-03-08 21:31:18'),(13706,10935,'N','01','021','EC','A',NULL,NULL,'','0000060265','0000280833','','IL','1','Kinney','Robin','S','','','34','285722188','3121 WATTOVA RD NW',0,'MASSILLON','OH','44646','3076','CY','39151','1961-05-19','F','',NULL,'N','021','HLT','2087159','52664OH151001301','2014-01-01','2013-12-23 13:02:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2013-12-26 13:08:49'),(24273,19276,'Y','18','021','EC','A','','','AC','0000938576','0000938576','OH00002552976','IL','1','Bamberger','Mark','','','','34','281601575','1628 SPRING VALLEY PAINTERS RD',0,'SPRING VALLEY','OH','45370','8796','CY','39057','1962-03-04','M','R',NULL,'N','021','HLT','3632396','92036OH004000501','2014-04-01','2014-02-17 15:01:26','0.00',NULL,NULL,'373.09','373.09','R-OH003','OH0','373.09',NULL,0,'2014-02-17 19:00:18'),(24209,19227,'Y','18','021','EC','A','','','AC','0001310125','0001310125','LA00002112099','IL','1','wilkinson','katheryn','','','','34','466715160','20832 HIGHWAY 22',0,'MAUREPAS','LA','70449','3200','CY','22063','1969-06-15','F','U',':RET:2106-3','N','021','DEN','3750498','18575LA002000201','2014-04-01','2014-02-16 00:36:37','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-16 19:00:22'),(6567,5206,'Y','18','021','EC','A','','','AC','0000218309','0000218309','TX00000383655','IL','1','Tucker','Jody','','','','34','527885307','1704 COUNTY ROAD 313',0,'GLEN ROSE','TX','76043',NULL,'CY','48425','1951-03-05','F','M',NULL,'N','021','DEN','1251677','33348TX002000201','2014-01-01','2013-12-11 14:40:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:34'),(5881,4665,'Y','18','021','EC','A','','','AC','0000315935','0000315935','OH00000838909','31','1','SHORTS','TONI','','','','34','281445322','PO BOX 109',0,'BLOOMFIELD','OH','44450',NULL,'CY','39155','1949-07-29','F','U',':RET:2106-3','N','021','DEN','2391751','99734OH005000301','2014-01-01','2013-12-23 22:19:39','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2013-12-25 23:49:24'),(2725,2204,'Y','18','021','EC','A','','','AC','0000358841','0000358841','LA00000907086','IL','1','Corley','Tommy','E','','','34','437788326','38232 ZILDA ST',0,'GONZALES','LA','70737','5917','CY','22005','1951-08-02','M','M',':RET:2106-3','N','021','DEN','1051354','18575LA002000201','2014-01-01','2013-12-02 14:49:53','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:48:19'),(20620,16478,'Y','18','021','EC','A','','','AC','0002031695','0002031695','LA00002498093','IL','1','Boyet','Warren','Bruce','','Sr','34','434490749','630 S PLEASANT AVE',0,'GONZALES','LA','70737','3424','CY','22005','1968-11-02','M','M',':RET:2106-3','N','021','DEN','2842561','18575LA002000101','2014-03-01','2014-01-30 17:20:13','0.00',NULL,NULL,'50.04','50.04','R-LA005','LA0','25.02',NULL,0,'2014-01-30 21:00:23'),(15816,12661,'Y','18','021','EC','A','','','AC','0000948425','0000948425','OH00001417609','IL','1','BIRT','MARTHA','','','','34','281483813','3616 sargent rd',0,'GUYSVILLE','OH','45735',NULL,'CY','39009','1951-02-27','F','M',NULL,'N','021','DEN','1918872','99734OH005000401','2014-02-01','2014-01-02 10:03:06','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2014-01-03 02:03:23'),(27713,21915,'Y','18','021','EC','A','','','AC','0000879243','0000879243','TX00003213040','IL','1','PEREZ','SERGIO','','','','34','644032982','21835 FM 493',0,'ELSA','TX','78543',NULL,'CY','48215','1962-01-16','M','M',NULL,'N','021','DEN','2955847','33348TX002000201','2014-04-01','2014-03-05 12:52:05','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-03-05 21:30:54'),(28004,22159,'Y','18','021','EC','A','','','AC','0000572050','0000572050','OH00003697159','IL','1','DENUNZIO','Ana','','','','34','302117948','7193 west cross creek trl',0,'brecksville','OH','44141',NULL,'CY','39035','1974-09-12','F','M',NULL,'N','021','DEN','3790321','99734OH005000401','2014-04-01','2014-03-05 23:12:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-06 21:01:10'),(405,333,'Y','18','021','EC','A','','','AC','0000408442','0000408442','OH00000661550','IL','1','Glover','Harriet','','','','34','272665936','5231 ARCH ST',0,'MAPLE HEIGHTS','OH','44137','1507','CY','39035','1959-11-19','F','U',':RET:2054-5','N','021','DEN','374020','99734OH005000401','2014-01-01','2013-12-04 09:58:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:46:15'),(1534,1277,'Y','18','021','EC','A','','','AC','0000015269','0000015269','OH00001625092','IL','1','Tayse','Heather','','','','34','301909676','154 MARTIN AVE',0,'COLUMBUS','OH','43222','1434','CY','39049','1987-12-17','F','U',':RET:2106-3','N','021','DEN','1515966','99734OH005000401','2014-01-01','2013-12-24 16:13:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:50:05'),(23526,18741,'N','19','021','EC','A',NULL,NULL,'','0001647551','0001651023','','IL','1','VASALLE','RENELL','','','Jr','34','439852159','2611 BERTRAND AVE',0,'LAKE CHARLES','LA','70611','3617','CY','22019','1992-11-22','M','',':RET:2106-3','T','021','DEN','2916341','18575LA002000201','2014-03-01','2014-02-13 08:27:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-13 22:02:23'),(3302,2658,'Y','18','021','EC','A','','','AC','0000658418','0000658418','OH00000447651','IL','1','Brown','Daniel','','','Sr','34','285648138','8630 Lawton Dr',0,'Macedonia','OH','44056',NULL,'CY','39153','1959-04-04','M','M',NULL,'T','021','DEN','2403811','99734OH005000301','2014-01-01','2013-12-22 12:34:07','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:15:43'),(15805,12652,'Y','18','021','EC','A','','','AC','0001818119','0001818119','LA00000660086','IL','1','Epperson','Martha','','','','34','459879349','15624 Hogenville Ave',0,'Baton Rouge','LA','70817',NULL,'CY','22033','1974-11-07','F','R',':RET:2106-3','N','021','DEN','1435926','18575LA002000201','2014-02-01','2014-01-02 13:35:49','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-03 02:03:01'),(16681,13348,'N','19','021','EC','A',NULL,NULL,'','0000012450','0000413375','','IL','1','KNUTSON','NILE','','','','34','289150679','6982 FRANCIS DR',0,'LIBERTY TOWNSHIP','OH','45044','9254','CY','39017','2009-11-21','M','',':RET:2106-3','N','021','DEN','1575019','99734OH005000301','2014-02-01','2014-01-07 15:25:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(26892,21312,'Y','18','021','EC','A','','','AC','0000828253','0000828253','OH00003343365','IL','1','williams','amanda','','','','34','284740187','837 MIRABEAU ST',0,'GREENFIELD','OH','45123','1238','CY','39071','1976-09-07','F','U',':RET:2106-3','N','021','HLT','2869805','92036OH003000604','2014-04-01','2014-03-01 19:19:46','42.00',NULL,NULL,'277.53','235.53','R-OH005','OH0','277.53',NULL,0,'2014-03-03 01:00:03'),(248,206,'N','01','021','EC','A',NULL,NULL,'','0000491838','0000439392','','IL','1','Snyder','Keith','','','','34','280848791','10745 HALLER ST',0,'DEFIANCE','OH','43512','1274','CY','39039','1983-09-02','M','',':RET:2106-3','N','021','HLT','660869','92036OH003002606','2014-01-01','2013-12-05 13:45:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','231.13',NULL,0,'2013-12-25 17:21:29'),(24523,19481,'Y','18','021','EC','A','','','AC','0000234502','0000234502','TX00001864408','IL','1','MENDEZ','PATRICIO','','','','34','455850766','8529 OLD HEARNE RD',0,'HEARNE','TX','77859','3977','CY','48395','1957-03-17','M','M',':RET:2106-3','N','021','DEN','3439517','33348TX002000201','2014-04-01','2014-02-19 15:00:20','0.00',NULL,NULL,'29.22','29.22','R-TX006','TX0','14.61',NULL,0,'2014-02-20 03:58:17'),(2255,1848,'N','01','021','EC','A',NULL,NULL,'','0000385874','0000418868','','IL','1','MESONES','INES','E','','','34','276024346','8717 LANDEN DR',0,'MAINEVILLE','OH','45039','9787','CY','39165','1965-05-08','F','',':RET:2106-3','N','021','DEN','688704','99734OH005000301','2014-01-01','2013-12-08 19:49:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:30:09'),(20776,16599,'Y','18','024','14','A','','','TE','0000132642','0000132642','','IL','1','Hawkins','Robin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-05','F','',NULL,NULL,NULL,'','2912423','','2014-01-30','2014-01-30 18:44:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-31 21:00:06'),(3181,2558,'Y','18','021','EC','A','','','AC','0000001005','0000001005','LA00000092138','IL','1','lensey','trichelle','','','','34','439615434','2925 abbie st',0,'shreveport','LA','71103',NULL,'CY','22017','1986-09-06','F','U',':RET:2054-5','N','021','DEN','127711','18575LA002000201','2014-01-01','2013-11-18 09:16:06','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-25 20:31:51'),(17862,14269,'Y','18','021','EC','A','','','AC','0000437994','0000437994','OH00001407336','IL','1','Guzman','Jennifer','','','','34','484064488','1356 SILVERTREE DR',0,'GALLOWAY','OH','43119','9051','CY','39097','1985-03-09','F','U',NULL,'N','021','DEN','2633166','99734OH005000401','2014-02-01','2014-01-14 11:31:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:10'),(16415,13137,'Y','18','021','EC','A','','','AC','0001099200','0001099200','OH00001880903','IL','1','fuda','ryan','','','','34','200629570','8716 TIPPECANOE RD',0,'CANFIELD','OH','44406','8107','CY','39099','1976-04-17','M','U',':RET:2106-3','N','021','HLT','2272901','52664OH151001501','2014-02-01','2014-01-06 15:09:38','0.00',NULL,NULL,'375.50','375.50','R-OH013','OH0','375.50',NULL,0,'2014-01-07 04:04:21'),(13785,11002,'Y','18','021','EC','A','','','AC','0001112198','0001112198','MS00000026968','IL','1','Parson','Tanner','Lee','','Jr','34','425574720','69 CHICORA BAPTIST CHURCH DR',0,'BUCKATUNNA','MS','39322','9782','CY','28153','1987-02-02','M','U',':RET:2054-5','N','021','DEN','2435948','46300MS002000201','2014-01-01','2013-12-23 17:54:12','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:52'),(24330,19322,'N','19','021','EC','A',NULL,NULL,'','0001036844','0001123728','','IL','1','WINN','LOGAN','A','','','34','635247769','1701B SHADOWVIEW DR',0,'AUSTIN','TX','78758',NULL,'CY','48453','1991-07-18','M','',NULL,'T','021','DEN','3470784','33348TX002000201','2014-04-01','2014-02-18 13:30:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-18 22:00:13'),(5405,4291,'Y','18','024','14','A','','','TE','0000493200','0000493200','','IL','1','Flaherty','Gregory',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-20','M','',NULL,NULL,NULL,'','525207','','2013-12-18','2013-12-18 22:02:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:09:03'),(6076,4816,'Y','18','021','EC','A','','','AC','0000546896','0000546896','MS00000100325','IL','1','Matthiesen','Penny','L','','','34','349503294','73647 DIAMONDHEAD DR N',0,'DIAMONDHEAD','MS','39525','3927','CY','28045','1955-07-31','F','M',':RET:2106-3','N','021','DEN','519725','46300MS002000201','2014-01-01','2013-12-01 08:32:18','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2013-12-26 00:02:21'),(7977,6315,'Y','18','021','EC','A','','','AC','0000465903','0000465903','OH00000451280','IL','1','Kessen','Jennifer','','','','34','302845120','442 TULIP TRL',0,'WADSWORTH','OH','44281','1247','CY','39103','1987-01-17','F','U',':RET:2106-3','T','021','HLT','1429251','52664OH151001306','2014-01-01','2013-12-20 10:10:17','177.00',NULL,NULL,'262.61','85.61','R-OH012','OH0','262.61',NULL,0,'2013-12-26 03:07:51'),(5432,4314,'Y','18','021','EC','A','','','AC','0001992200','0001992200','LA00000490985','IL','1','Porrazzo','Frank','','','','34','436826889','225 MARYLAND AVE',0,'METAIRIE','LA','70003','6826','CY','22051','1951-10-17','M','U',':RET:2106-3','N','021','DEN','1791973','18575LA002000101','2014-01-01','2013-12-19 15:36:55','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:41'),(6593,5227,'Y','18','021','EC','A','','','AC','0000536078','0000536078','TX00000421926','IL','1','Falk','Paula','E','','','34','354727899','2909 SILVERLEAF DR',0,'AUSTIN','TX','78757','1606','CY','48453','1969-07-17','F','U',':RET:2106-3','N','021','DEN','1238546','33348TX002000101','2014-01-01','2013-12-11 16:28:48','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-26 00:53:19'),(9570,7582,'Y','18','021','EC','A','','','AC','0000062528','0000062528','OH00001047211','IL','1','nguyen','ngan','','','','34','443827485','2211 WOODEDGE CT',0,'MIAMISBURG','OH','45342','6403','CY','39113','1973-02-01','M','M',':RET:2047-9','N','021','DEN','1694578','99734OH005000301','2014-01-01','2013-12-21 16:23:12','0.00',NULL,NULL,'42.26','42.26','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:36:42'),(25550,20271,'Y','18','021','EC','A','','','AC','0001553074','0001553074','LA00002971192','IL','1','JONES','DEONNE','','','','34','434310611','1455 N ROCHEBLAVE ST',0,'NEW ORLEANS','LA','70119','2523','CY','22071','1970-02-06','F','U',':RET:2054-5','N','021','DEN','3589761','18575LA002000201','2014-04-01','2014-02-22 22:50:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 08:00:18'),(27340,21649,'Y','18','021','EC','A','','','AC','0000930975','0000930975','OH00003639767','IL','1','stewart','joyce','','','','34','293722920','4516 barbara pl',0,'cincinnati','OH','45229',NULL,'CY','39061','1964-11-09','F','U',':RET:2054-5','N','021','DEN','2935146','99734OH005000401','2014-04-01','2014-03-04 10:14:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-04 21:00:58'),(27547,21789,'N','01','021','EC','A',NULL,NULL,'','0001129077','0000930977','','IL','1','BOSHKOZSKI','ZORA','','','','34','793277853','7994 EQUITANA WAY',0,'BLACKLICK','OH','43004','9176','CY','39049','1972-07-13','F','',':RET:2106-3','N','021','DEN','3912098','99734OH005000401','2014-04-01','2014-03-04 13:09:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-04 21:30:09'),(28671,22688,'N','01','021','EC','A',NULL,NULL,'','0001897943','0001351117','','IL','1','Huxen','Jeffrey','Crocker','','','34','436412685','10345 SPRINGPARK AVE',0,'BATON ROUGE','LA','70810','0769','CY','22033','1980-06-16','M','',':RET:2106-3','N','021','DEN','3153402','18575LA002000201','2014-04-01','2014-03-08 16:36:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-08 21:30:49'),(1138,936,'Y','18','024','14','A','','','TE','0000588228','0000588228','','IL','1','Dupont','Sheila',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-01-04','F','',NULL,NULL,NULL,'','337035','','2013-12-03','2013-12-03 09:10:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 18:18:15'),(2835,2291,'Y','18','021','EC','A','','','AC','0001002887','0001002887','LA00001216043','IL','1','figaro','cedric','','','','34','435692967','517 PHYLLIS DR',0,'AVONDALE','LA','70094','2927','CY','22051','1981-11-20','M','U',':RET:2054-5','N','021','DEN','496920','18575LA002000201','2014-01-01','2013-11-24 17:25:42','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 20:00:52'),(7016,5570,'Y','18','021','EC','A','','','AC','0000235641','0000235641','TX00001358108','IL','1','Baxter','Debra','','','','34','454213429','692 BOX CAR RD',0,'LUFKIN','TX','75904','7325','CY','48005','1956-11-16','F','M',':RET:2106-3','N','021','DEN','1843680','33348TX002000201','2014-01-01','2013-12-24 20:28:01','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:48:40'),(19839,15822,'Y','18','021','EC','A','','','AC','0001814434','0001814434','LA00001760234','IL','1','HOWARD','TIFFANY','N','','','34','437592902','281 WILLOW ST.',0,'WINNSBORO','LA','71295',NULL,'CY','22041','1985-10-25','F','U',':RET:2054-5','N','021','DEN','2173939','18575LA002000201','2014-03-01','2014-01-23 20:42:30','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-24 21:00:24'),(17284,13822,'Y','18','021','EC','A','','','AC','0001231901','0001231901','TX00001466810','IL','1','RACE','STEPHEN','FREDERICK','','','34','452925840','10616 MELLOW MEADOWS',0,'AUSTIN','TX','78750',NULL,'CY','48453','1953-03-27','M','U',':RET:2106-3','N','021','DEN','2612579','33348TX002000201','2014-02-01','2014-01-09 18:27:35','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:23:27'),(6068,4808,'Y','18','021','EC','A','','','AC','0001093116','0001093116','OH00000647231','IL','1','Johnson','Alana','','','','34','291506496','4028 S JEFFERSON AVE',0,'NORWOOD','OH','45212','4020','CY','39061','1951-03-25','F','U',':RET:2106-3','N','021','DEN','287091','99734OH005000401','2014-01-01','2013-12-01 12:38:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:02:07'),(5931,4695,'Y','18','021','EC','A','','','AC','0000916129','0000916129','TX00001166524','IL','1','Galdamez','Dennis','J','','','34','461772678','213 LAVENDER DR',0,'CEDAR HILL','TX','75104','2307','CY','48113','1984-07-26','M','U',':RET:2106-3','N','021','DEN','1531807','33348TX002000101','2014-01-01','2013-12-24 01:43:21','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 23:50:29'),(5833,4633,'Y','18','021','EC','A','','','AC','0000103668','0000103668','TX00001024888','IL','1','Cedillo','Gabriel','','','','34','454791162','1821 S. Hill',0,'San Angelo','TX','76903',NULL,'CY','48451','1983-09-03','M','U',':RET:2106-3','T','021','DEN','1939299','33348TX002000201','2014-01-01','2013-12-23 23:18:55','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2013-12-25 23:48:21'),(4526,3586,'Y','18','021','EC','A','','','AC','0000197556','0000197556','TX00000067701','31','1','MORALES','ADELA','','','','34','459069946','PO BOX 844',0,'WESLACO','TX','78596',NULL,'CY','48215','1954-02-07','F','U',':RET:2106-3','N','021','DEN','186043','33348TX002000201','2014-01-01','2013-12-12 14:33:10','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-25 22:03:56'),(26853,21284,'Y','18','021','EC','A','','','AC','0000436961','0000436961','MS00002647322','IL','1','Brennan','Kerri','','','','34','424193415','323 WILLOW RUN',0,'PEARL','MS','39208','8111','CY','28121','1978-12-25','F','M',NULL,'N','021','DEN','3672384','46300MS002000201','2014-04-01','2014-02-28 19:20:01','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-01 21:00:52'),(27947,22108,'Y','18','021','EC','A','','','AC','0000940637','0000940637','TX00002916987','IL','1','ROBINSON','MARY','','','','34','455863129','200 CHURCH ST',0,'LELIA LAKE','TX','79240',NULL,'CY','48129','1951-08-02','F','U',':RET:2106-3','N','021','DEN','3691113','33348TX002000201','2014-04-01','2014-03-06 16:19:19','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:35'),(9209,7304,'N','01','021','EC','A',NULL,NULL,'','0001032429','0001171134','','IL','1','WARD','OLIVIA','','','','34','313548921','5311 WILLIAMS DR',0,'JACKSON','MS','39209','4546','CY','28049','1951-09-11','F','',NULL,'N','021','DEN','1734617','46300MS002000201','2014-01-01','2013-12-18 14:25:49',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-26 04:09:51'),(9028,7163,'Y','18','021','EC','A','','','AC','0000120057','0000120057','OH00000855702','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,'23872 Glenhill',0,'Cleveland','OH','44122',NULL,'CY','39035','1950-01-06','F','U',':RET:2106-3','N','021','HLT','1777269','52664OH151001306','2014-01-01','2013-12-18 10:30:55','549.00',NULL,NULL,'742.48','193.48','R-OH011','OH0','742.48',NULL,0,'2013-12-26 04:05:30'),(3895,3118,'Y','18','021','EC','A','','','AC','0000278304','0000278304','OH00000379785','IL','1','Piesciuk','Stephen','','','','34','066469661','3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-07-18','M','M',':RET:2106-3','N','021','HLT','550746','52664OH152000901','2014-01-01','2013-12-13 14:24:43','559.00',NULL,NULL,'796.12','237.12','R-OH012','OH0','398.06',NULL,0,'2013-12-25 21:36:44'),(13358,10669,'Y','18','021','EC','A','','','AC','0001209584','0001209584','OH00000491131','IL','1','JUNG','KEVIN','','','','34','478749786','6231 CROOKED CREEK DR',0,'MASON','OH','45040','2443','CY','39165','1973-01-05','M','M',NULL,'N','021','DEN','2322802','99734OH005000301','2014-01-01','2013-12-22 19:48:29','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:59:24'),(16798,13436,'N','01','021','EC','A',NULL,NULL,'','0000360431','0000493210','','IL','1','Gnecco','Jeanne','E','','','34','079442114','18022 SHADY KNL',0,'SAN ANTONIO','TX','78258','3410','CY','48029','1950-11-16','F','',':RET:2106-3','N','021','DEN','1926881','33348TX002000201','2014-02-01','2014-01-11 09:40:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-13 02:18:09'),(13903,11088,'Y','18','021','EC','A','','','AC','0000720252','0000720252','OH00001283129','IL','1','Price','Nathan','','','','34','297785035','2166 N KATHY LN',0,'GENOA','OH','43430','9763','CY','39123','1981-09-15','M','U',':RET:2106-3','N','021','HLT','2484369','92036OH005002706','2014-01-01','2013-12-22 21:36:50','190.00',NULL,NULL,'230.68','40.68','R-OH006','OH0','230.68',NULL,0,'2013-12-26 13:13:44'),(27895,22068,'Y','18','024','14','A','','','TE','0001001127','0001001127','','IL','1','harris','michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-02-12','M','',NULL,NULL,NULL,'','462819','','2014-03-20','2014-03-05 14:38:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-05 21:32:42'),(6395,5068,'N','19','021','EC','A',NULL,NULL,'','0000355013','0001153599','','IL','1','Bressman','Jared','Allan','','','34','294966999','8633 BROADACRE DR',0,'POWELL','OH','43065','9010','CY','39049','1993-11-20','M','',':RET:2106-3','N','021','DEN','622071','99734OH005000301','2014-01-01','2013-12-11 11:46:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:13'),(9586,7591,'Y','18','021','EC','A','','','AC','0000949898','0000949898','MS00001247010','31','1','CARTER','WILMER','','','','34','587620042','P.O. BOX 532',0,'BEAUMONT','MS','39423',NULL,'CY','28111','1951-07-04','M','M',':RET:2054-5','N','021','DEN','2613302','46300MS002000201','2014-01-01','2013-12-20 20:01:09','0.00',NULL,NULL,'31.70','31.70','R-MS004','MS0','15.85',NULL,0,'2013-12-26 04:37:02'),(8164,6459,'Y','18','021','EC','A','','','AC','0000750980','0000750980','OH00000041464','IL','1','MCKINNEY','LARRY','H','','','34','299482279','2687 ROUTE 50',0,'BATAVIA','OH','45103',NULL,'CY','39025','1950-09-13','M','U',NULL,'N','021','HLT','138984','92036OH006000601','2014-01-01','2013-11-22 09:48:03','330.00',NULL,NULL,'502.56','172.56','R-OH005','OH0','502.56',NULL,0,'2013-12-26 03:16:26'),(7791,6169,'Y','18','021','EC','A','','','AC','0001116571','0001116571','TX00001091503','IL','1','REIL','HENRIC','','','','34','449879311','152 OAK LEAF PKWY',0,'EMORY','TX','75440','2250','CY','48379','1975-09-14','M','U',NULL,'N','021','DEN','2537085','33348TX002000201','2014-01-01','2013-12-20 14:54:40','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:25'),(7163,5682,'Y','18','021','EC','A','','','AC','0000383367','0000383367','OH00001153834','IL','1','burke','robert','','','','34','206402526','9407 wyoming point',0,'cincinnati','OH','45231',NULL,'CY','39061','1952-03-23','M','U',':RET:2106-3','N','021','HLT','1997701','92036OH006001201','2014-01-01','2013-12-24 21:52:40','0.00',NULL,NULL,'478.41','478.41','R-OH004','OH0','478.41',NULL,0,'2013-12-26 01:52:33'),(19456,15508,'Y','18','021','EC','A','','','AC','0001103980','0001103980','TX00001480689','IL','1','MANZAR','SHAZIA','','','','34','114886055','801 COUNTRY PLACE DR',0,'HOUSTON','TX','77079','8513','CY','48201','1981-08-03','F','U',':RET:2029-7','N','021','DEN','2964854','33348TX002000201','2014-03-01','2014-01-21 20:02:42','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-23 03:01:54'),(16971,13583,'N','19','021','EC','A',NULL,NULL,'','0000218843','0000727291','','IL','1','Mahoney','Kelly','K','','','34','282940551','27261 NANTUCKET DR',0,'NORTH OLMSTED','OH','44070','4456','CY','39035','1991-11-15','F','',':RET:2106-3','N','021','HLT','1823189','52664OH151001305','2014-02-01','2014-01-09 17:12:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','251.52',NULL,0,'2014-01-13 02:20:13'),(7059,5607,'Y','18','021','EC','A','','','AC','0000873246','0000873246','OH00000352266','IL','1','prince','matt','','','','34','289707111','700 cass street',0,'dresden','OH','43821',NULL,'CY','39119','1975-12-30','M','U',NULL,'N','021','DEN','2498169','99734OH005000301','2014-01-01','2013-12-24 20:57:38','0.00',NULL,NULL,'21.13','21.13','R-OH016','OH0','0.00',NULL,0,'2013-12-26 01:49:53'),(14882,11885,'Y','18','021','EC','A','','','AC','0000008810','0000008810','TX00001053348','IL','1','Barranco','Martha','Alicia','','','34','463431180','740 Pendale Rd',0,'El Paso','TX','79907',NULL,'CY','48141','1977-07-01','F','M',':RET:2106-3','N','021','DEN','2205699','33348TX002000201','2014-02-01','2013-12-29 15:59:45','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-30 00:00:33'),(14852,11859,'Y','18','021','EC','A','','','AC','0000181010','0000181010','OH00000553348','IL','1','Leising','Christopher','','','','34','407925715','13673 Cinnamon Lane Ave NW',0,'Mogadore','OH','44260',NULL,'CY','39151','1969-10-03','M','M',NULL,'N','021','HLT','2294928','52664OH151001304','2014-01-01','2013-12-23 19:37:15','228.00',NULL,NULL,'607.02','379.02','R-OH015','OH0','311.54',NULL,1,'2013-12-29 11:15:08'),(14502,11569,'Y','18','021','EC','A','','','AC','0000568996','0000568996','TX00001770343','IL','1','GARCIA','CELIA','','','','34','466836465','1308 W WASHINGTON AVE',0,'MIDLAND','TX','79701','7076','CY','48329','1953-05-21','F','U',NULL,'N','021','DEN','1904819','33348TX002000201','2014-02-01','2013-12-27 14:29:26','0.00',NULL,NULL,'14.61','14.61','R-TX016','TX0','14.61',NULL,0,'2013-12-28 03:33:49'),(6936,5507,'Y','18','021','EC','A','','','AC','0000424032','0000424032','OH00000624003','IL','1','totman','elizabeth','','','','34','548110573','414 s. main',0,'ansoina','OH','45303',NULL,'CY','39037','1971-06-26','F','M',':RET:2106-3','N','021','DEN','1389052','99734OH005000401','2014-01-01','2013-12-24 20:15:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 01:46:40'),(26408,20944,'Y','18','021','EC','A','','','AC','0000897036','0000897036','OH00003171732','IL','1','Ahmad','Hira','','','','34','779296685','5108 OCALA DR',0,'MIDDLETOWN','OH','45044','7179','CY','39165','1987-10-27','F','M',NULL,'N','021','HLT','3788814','92036OH005001205','2014-04-01','2014-02-26 13:57:48','318.00',NULL,NULL,'473.78','155.78','R-OH004','OH0','219.82','CIC',0,'2014-02-28 07:00:36'),(27572,21806,'Y','18','021','EC','A','','','AC','0000639476','0000639476','MS00002745451','IL','1','Jones','Willie','R','','','34','587110456','1445 BUCK LN',0,'JACKSON','MS','39209','9437','CY','28049','1958-02-25','M','M',':RET:2054-5','N','021','DEN','2953183','46300MS002000201','2014-04-01','2014-03-04 11:39:08','40.52',NULL,NULL,'72.22','31.70','R-MS003','MS0','15.85','CIC',0,'2014-03-04 21:30:21'),(28550,22596,'Y','18','021','EC','A','','','AC','0000456593','0000456593','OH00002862168','IL','1','SCHNEIDER','KENNETH','','','','34','295529024','5352 MONROE STREET',0,'TOLEDO','OH','43623',NULL,'CY','39095','1952-10-27','M','U',NULL,'N','021','HLT','3251452','92036OH005002605','2014-04-01','2014-03-07 14:39:45','449.00',NULL,NULL,'547.95','98.95','R-OH001','OH0','547.95',NULL,0,'2014-03-07 21:32:20'),(562,461,'Y','18','021','EC','A','','','AC','0000401215','0000401215','OH00000400453','IL','1','Weiker','Thomas','','','','34','287566569','14490 E TOWNSHIP ROAD 44',0,'ATTICA','OH','44807','9774','CY','39147','1957-07-07','M','U',':RET:2106-3','N','021','HLT','831928','92036OH004002701','2014-01-01','2013-12-03 19:12:10','0.00',NULL,NULL,'365.79','365.79','R-OH006','OH0','365.79',NULL,0,'2013-12-25 17:50:21'),(826,683,'Y','18','021','EC','A','','','AC','0000882834','0000882834','OH00000717781','IL','1','Grano','Tyler','','','','34','274905295','218 EDGEWOOD DR',0,'BEREA','OH','44017','1443','CY','39035','1987-11-15','M','U',':RET:2106-3','N','021','HLT','1691776','52664OH151001306','2014-01-01','2013-12-16 15:08:47','154.00',NULL,NULL,'257.56','103.56','R-OH011','OH0','257.56',NULL,0,'2013-12-25 18:06:12'),(22183,17704,'Y','18','021','EC','A','','','AC','0001031762','0001031762','TX00002041483','IL','1','Binz','John','','','','34','631322196','462 REFUGIO HWY',0,'VICTORIA','TX','77905','3916','CY','48469','1992-07-16','M','U',':RET:2106-3','N','021','DEN','3339529','33348TX002000201','2014-03-01','2014-02-09 15:26:24','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61','CIC',0,'2014-02-09 19:00:04'),(2059,1686,'N','01','021','EC','A',NULL,NULL,'','0000777652','0000792199','','IL','1','SENDER','JOHN','PETER','','','34','283620771','5874 HICKORY TRL',0,'NORTH RIDGEVILLE','OH','44039',NULL,'CY','39093','1958-10-21','M','',':RET:2106-3','N','021','DEN','486797','99734OH005000301','2014-01-01','2013-12-10 12:57:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:16:04'),(21668,17305,'Y','18','021','EC','A','','','AC','0001441723','0001441723','LA00002618128','IL','1','Tardo','Magen','','','','34','439759721','2421 MARGARET LN',0,'MERAUX','LA','70075','2731','CY','22087','1985-08-05','F','M',':RET:2106-3','N','021','DEN','3440477','18575LA002000201','2014-03-01','2014-02-05 15:12:38','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-02-05 21:30:57'),(20553,16425,'Y','18','024','14','A','','','TE','0000964638','0000964638','','IL','1','Shaferly','Sarah',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-08-01','F','',NULL,NULL,NULL,'','2743747','','2014-01-29','2014-01-29 15:09:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:43'),(7291,5778,'N','01','021','EC','A',NULL,NULL,'','0000998761','0000750996','','IL','1','Rogers','David','','','','34','293722355','10016 HOMESTEAD RD',0,'WADSWORTH','OH','44281','9033','CY','39103','1963-05-04','M','',NULL,'N','021','HLT','980982','52664OH151001501','2014-01-01','2013-12-14 10:26:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','477.69',NULL,0,'2013-12-26 02:02:53'),(16864,13493,'Y','18','021','EC','A','','','AC','0001035406','0001035406','TX00002506552','IL','1','SALMERON','LISBETH','','','','34','459512295','3200 WAYSIDE ST',0,'EL PASO','TX','79936','1919','CY','48141','1980-09-27','F','M',NULL,'N','021','DEN','2585755','33348TX002000201','2014-02-01','2014-01-09 10:41:52','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:19:12'),(3705,2965,'Y','18','021','EC','A','','','AC','0000679512','0000679512','OH00000353084','IL','1','Kiaski','Anthony','','','','34','268500539','3345 PORTLAND BLVD',0,'STEUBENVILLE','OH','43952','3502','CY','39081','1950-10-11','M','U',':RET:2106-3','N','021','DEN','64154','99734OH005000401','2014-01-01','2013-12-13 14:21:00','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2013-12-25 21:32:05'),(4520,3582,'Y','18','021','EC','A','','','AC','0001096597','0001096597','TX00000503307','IL','1','Courtney','Maureen','','','','34','218702674','1212 Brook Drive',0,'Allen','TX','75002',NULL,'CY','48085','1958-04-30','F','M',':RET:2106-3','N','021','DEN','294001','33348TX002000201','2014-01-01','2013-12-12 12:36:33','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 22:03:49'),(13967,11132,'Y','18','021','EC','A','','','AC','0000879487','0000879487','OH00000961329','IL','1','Taylor','Nicole','','','','34','283846655','8695 MCMECHAM RD',0,'GREENVILLE','OH','45331','9466','CY','39037','1983-01-02','F','M',':RET:2106-3','N','021','HLT','2330830','92036OH003000505','2014-01-01','2013-12-23 17:40:41','149.00',NULL,NULL,'281.76','132.76','R-OH003','OH0','281.76',NULL,0,'2013-12-26 13:15:17'),(9208,7304,'Y','18','021','EC','A','','','AC','0001032429','0001032429','MS00001171115','IL','1','WARD','EARL','','','Jr','34','427960884','5311 WILLIAMS DR',0,'JACKSON','MS','39209','4546','CY','28049','1950-07-22','M','M',NULL,'T','021','DEN','1734617','46300MS002000201','2014-01-01','2013-12-18 14:25:49','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:09:50'),(22674,18106,'N','01','021','EC','A',NULL,NULL,'','0000252360','0000740188','','IL','1','manto','carmencita','estrella','','','34','730094603','1730 sheffield drive',0,'nacogdoches','TX','75965',NULL,'CY','48347','1951-08-25','F','',':RET:2036-2','N','021','DEN','2931259','33348TX002000201','2014-03-01','2014-02-11 15:26:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-11 21:00:43'),(22433,17912,'Y','18','021','EC','A','','','AC','0000165312','0000165312','TX00002562320','31','1','Boyer','Brandon','','','','34','459911900','PO Box 141',0,'Weesatche','TX','77993',NULL,'CY','48175','1987-06-16','M','U',NULL,'N','021','DEN','3741690','33348TX002000201','2014-03-01','2014-02-09 22:54:53','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-10 21:30:37'),(22217,17734,'Y','18','021','EC','A','','','AC','0001220869','0001220869','LA00001866935','IL','1','Fontenot','Jackie','','','','34','433637657','2877 South Beglis Pkwy',0,'Sulphur','LA','70665',NULL,'CY','22019','1986-11-26','F','U',':RET:2106-3','N','021','DEN','3139407','18575LA002000201','2014-03-01','2014-02-09 15:47:17','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2014-02-09 19:00:24'),(20712,16550,'Y','18','021','EC','A','','','AC','0001236369','0001236369','LA00001373097','IL','1','Lemoine','Kenneth','','','','34','436594952','12420 FAIRGREEN AVE',0,'BATON ROUGE','LA','70816','1074','CY','22033','1975-08-02','M','U',':RET:2106-3','N','021','DEN','3412502','18575LA002000201','2014-03-01','2014-01-30 15:38:39','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-30 21:01:09'),(20230,16140,'N','01','021','EC','A',NULL,NULL,'','0001257358','0000459187','','IL','1','Bonifas','Jerald','','','','34','280520475','12198 MIDDLEPOINT WETZEL RD',0,'DELPHOS','OH','45833','8808','CY','39161','1956-05-25','M','',NULL,'N','021','HLT','3223216','92036OH005001501','2014-03-01','2014-01-27 16:49:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','536.36',NULL,0,'2014-01-27 21:01:49'),(9142,7250,'Y','18','021','EC','A','','','AC','0000121523','0000121523','OH00000747505','IL','1','Ferguson','Denise','','','','34','186648535','1154 BEARDSLEY ST',0,'AKRON','OH','44301','1818','CY','39153','1972-08-21','F','M',NULL,'N','021','HLT','2436779','52664OH151001501','2014-01-01','2013-12-18 08:38:04','427.00',NULL,NULL,'679.36','252.36','R-OH012','OH0','348.24',NULL,0,'2013-12-26 04:08:13'),(21631,17271,'Y','18','021','EC','A','','','AC','0000892630','0000892630','TX00001589247','IL','1','NAVARRO','YOLANDA','','','','34','641250020','310 ACR 2413',0,'MONTALBA','TX','75853',NULL,'CY','48001','1987-12-18','F','M',':RET:2106-3','N','021','DEN','3647356','33348TX002000201','2014-03-01','2014-02-05 11:13:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:41'),(2008,1647,'Y','18','021','EC','A','','','AC','0000972852','0000972852','LA00000237515','31','1','Brock','Tracey','','','','34','435258146','P.O. Box 663',0,'Violet','LA','70092',NULL,'CY','22087','1966-03-28','F','U',':RET:2054-5','N','021','DEN','1139099','18575LA002000201','2014-01-01','2013-11-20 13:25:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:02:25'),(6408,5079,'Y','18','021','EC','A','','','AC','0000927287','0000927287','OH00000494534','IL','1','Vroman','Karen','Jean','','','34','301625311','10041 COLUMBUS GROVE RD',0,'BLUFFTON','OH','45817','9595','CY','39003','1958-09-11','F','U',':RET:2106-3','N','021','DEN','1158404','99734OH005000301','2014-01-01','2013-12-11 18:19:06','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-26 00:48:32'),(14720,11753,'Y','18','021','EC','A','','','AC','0001164817','0001164817','LA00000549906','IL','1','McEacharn','Kimberly','','','','34','436533577','4075 ELLIOTT ST',0,'OLLA','LA','71465','5384','CY','22059','1968-09-02','F','U',NULL,'N','021','DEN','1803499','18575LA002000201','2014-02-01','2013-12-28 12:25:15','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,1,'2013-12-29 11:09:33'),(18020,14395,'N','01','021','EC','A',NULL,NULL,'','0000317360','0001157583','','IL','1','Hull','Jason','','','','34','289883193','1003 Wilmington Ave',0,'Dayton','OH','45420',NULL,'CY','39113','1972-11-16','M','',':RET:2106-3','T','021','DEN','2558646','99734OH005000301','2014-02-01','2014-01-14 12:36:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:05'),(14912,11914,'Y','18','021','EC','A','','','AC','0000790879','0000790879','OH00001421473','IL','1','Haddix','Samantha','','','','34','299925608','4330 GREEN ARBORS LN',0,'CINCINNATI','OH','45249','8010','CY','39061','1990-12-21','F','U',':RET:2106-3','N','021','DEN','2044828','99734OH005000401','2014-02-01','2013-12-28 20:36:15','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-30 00:01:27'),(15250,12188,'N','01','021','EC','A',NULL,NULL,'','0000627884','0000126981','','IL','1','nicholas','raejean','','','','34','340624688','206 n lincoln st',0,'christiansbrg','OH','45389',NULL,'CY','39021','1968-10-26','F','',':RET:2106-3','T','021','HLT','1411810','92036OH003000505','2014-02-01','2013-12-30 11:06:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','412.23',NULL,0,'2014-01-01 12:08:55'),(416,341,'Y','18','021','EC','A','','','AC','0000347876','0000347876','OH00001225105','IL','1','mayle','bryan','','','','34','293940318','502 park ave',0,'girard','OH','44420',NULL,'CY','39155','1992-03-23','M','U',':RET:2106-3','T','021','DEN','909741','99734OH005000401','2014-01-01','2013-12-03 19:13:48','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 17:46:30'),(13318,10633,'Y','18','021','EC','A','','','AC','0000007405','0000007405','TX00001001359','IL','1','Mileykovskiy','Boris','','','','34','625089834','3946 FM 3277',0,'Livingston','TX','77351',NULL,'CY','48373','1950-06-19','M','M',':RET:2106-3','N','021','DEN','2443281','33348TX002000201','2014-01-01','2013-12-23 16:34:25','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 12:58:16'),(9272,7356,'Y','18','021','EC','A','','','AC','0001135137','0001135137','OH00000491458','IL','1','Perusek','Jennifer','','','','34','247670326','3622 MIDDLETON AVE',0,'CINCINNATI','OH','45220','1666','CY','39061','1984-10-27','F','U',':RET:2106-3','N','021','DEN','549093','99734OH005000401','2014-01-01','2013-11-30 12:11:29','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:15:41'),(19836,15819,'Y','18','021','EC','A','','','AC','0001097807','0001097807','OH00002488629','IL','1','Ankney','Denise','','','','34','281540990','606 RIVERSIDE AVE',0,'DEFIANCE','OH','43512','2894','CY','39039','1954-12-03','F','U',NULL,'N','021','HLT','2983352','92036OH005002605','2014-03-01','2014-01-24 07:20:14','468.00',NULL,NULL,'507.58','39.58','R-OH001','OH0','507.58',NULL,0,'2014-01-24 21:00:22'),(17930,14324,'Y','18','021','EC','A','','','AC','0000080992','0000080992','TX00002226896','IL','1','Vandroff','Jahlil','','','','34','616765748','1900 Preston road',0,'Plano','TX','75093',NULL,'CY','48085','1992-08-22','M','U',':RET:2054-5','N','021','DEN','1657200','33348TX002000201','2014-02-01','2014-01-14 12:52:36','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-15 02:06:35'),(16474,13183,'Y','18','021','EC','A','','','AC','0001148736','0001148736','OH00001808085','IL','1','Lee','Ronald','','','','34','291467678','249 31ST ST SW',0,'BARBERTON','OH','44203','7603','CY','39153','1949-12-20','M','U',':RET:2106-3','N','021','HLT','1399432','52664OH151001306','2014-02-01','2014-01-06 16:32:17','575.00',NULL,NULL,'669.00','94.00','R-OH012','OH0','669.00',NULL,0,'2014-01-07 04:06:03'),(14803,11822,'Y','18','021','EC','A','','','AC','0001154833','0001154833','LA00001171485','31','1','Nash','Shawanna','','','','34','644128409','3921 Jennifer St',0,'ALEXANDRIA','LA','71302','2705','CY','22079','1974-09-07','F','U',':RET:2054-5','N','021','DEN','1629641','18575LA002000101','2014-01-01','2013-12-23 20:22:48','0.00',NULL,NULL,'25.02','25.02','R-LA006','LA0','25.02',NULL,1,'2013-12-29 11:13:49'),(4191,3334,'Y','18','021','EC','A','','','AC','0000899551','0000899551','OH00000460056','IL','1','WOLCOTT','ANITA','','','','34','288580139','2333 WRIGHT RD',0,'AKRON','OH','44320','2445','CY','39153','1956-06-14','F','U',NULL,'N','021','HLT','1715988','52664OH151001304','2014-01-01','2013-12-17 14:51:23','309.00',NULL,NULL,'543.47','234.47','R-OH012','OH0','543.47',NULL,0,'2013-12-25 21:49:39'),(9022,7158,'Y','18','024','14','A','','','TE','0000121522','0000121522','','IL','1','MYERS','BRENDA','SUE',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-07-30','F','',NULL,NULL,NULL,'','2046421','','2013-12-17','2013-12-17 21:28:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:21'),(26422,20955,'Y','18','021','EC','A','','','AC','0000506948','0000506948','TX00002657000','IL','1','MOLINA','ENRIQUE','','','','34','455968726','710 BRAZOS ST',0,'MISSION','TX','78572','7429','CY','48215','1951-11-01','M','M',NULL,'N','021','DEN','3323319','33348TX002000201','2014-04-01','2014-02-27 10:55:28','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61','CIC',0,'2014-02-28 07:30:09'),(27827,22008,'Y','18','021','EC','A','','','AC','0000277320','0000277320','OH00002687440','IL','1','Lopez','John','','','','34','274562136','175 WEATHERSTONE CT',0,'COPLEY','OH','44321','3226','CY','39153','1954-02-21','M','U',':RET:2106-3','N','021','DEN','3605279','99734OH005000301','2014-04-01','2014-03-05 09:59:42','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:31:58'),(28485,22538,'Y','18','024','14','A','','','TE','0000614172','0000614172','','IL','1','Badertscher','Amanda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-06-16','F','',NULL,NULL,NULL,'','2817303','','2014-03-07','2014-03-07 15:36:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-07 21:31:38'),(13417,10705,'Y','18','021','EC','A','','','AC','0000155773','0000155773','OH00000673979','IL','1','Collier','Rhonda','Kay','','','34','279663565','288 Oakland Sq',0,'Bellefontaine','OH','43311',NULL,'CY','39091','1960-08-26','F','M',':RET:2054-5','N','021','DEN','2519514','99734OH005000301','2014-01-01','2013-12-23 10:55:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-26 13:00:43'),(6134,4864,'N','01','021','EC','A',NULL,NULL,'','0000313846','0000981853','','IL','1','MacDougall','Pamela','','','','34','008449403','14302 RIVERLAKE DR',0,'COVINGTON','LA','70435','5783','CY','22103','1956-07-22','F','',':RET:2106-3','N','021','DEN','140323','18575LA002000201','2014-01-01','2013-11-20 21:48:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 00:16:05'),(17728,14166,'Y','18','021','EC','A','','','AC','0000129273','0000129273','OH00001567619','IL','1','Babcock','Patrick','','','','34','268907834','1391 GOODYEAR BLVD',0,'AKRON','OH','44305','3447','CY','39153','1975-05-22','M','M',':RET:2106-3','N','021','HLT','2450661','52664OH151001305','2014-02-01','2014-01-13 09:30:54','371.00',NULL,NULL,'573.35','202.35','R-OH012','OH0','277.87',NULL,0,'2014-01-14 01:33:18'),(19378,15448,'Y','18','021','EC','A','','','AC','0000380605','0000380605','MS00001652244','31','1','Taylor','Machanna','S','','','34','427237311','PO Box 416',0,'Magnolia','MS','39652',NULL,'CY','28113','1974-06-05','F','M',NULL,'N','021','DEN','2914592','46300MS002000101','2014-03-01','2014-01-21 17:17:51','0.00',NULL,NULL,'54.30','54.30','R-MS006','MS0','27.15',NULL,1,'2014-01-22 03:22:40'),(20690,16533,'Y','18','024','14','A','','','TE','0000854219','0000854219','','IL','1','Henry','Matthew',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-07-14','M','',NULL,NULL,NULL,'','3018902','','2014-01-30','2014-01-30 11:11:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-30 21:00:58'),(26305,20869,'Y','18','021','EC','A','','','AC','0000180590','0000180590','TX00001660309','IL','1','Kahn','Alicia','','','','34','463898047','122 N AVENUE C',0,'SHINER','TX','77984','7129','CY','48285','1984-09-09','F','U',':RET:2106-3','N','021','DEN','3846331','33348TX002000101','2014-04-01','2014-02-27 11:18:30','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-28 06:31:30'),(27978,22135,'Y','18','021','EC','A','','','AC','0002316292','0002316292','LA00003698172','IL','1','Cannon','Linda','L','','','34','221464194','14475 SUMMERSET DR',0,'GONZALES','LA','70737','7087','CY','22005','1960-02-21','F','U',':RET:2054-5','N','021','DEN','3866616','18575LA002000201','2014-04-01','2014-03-06 14:24:59','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:55'),(2244,1843,'N','19','021','EC','A',NULL,NULL,'','0000991516','0000196120','','IL','1','Schriml','Benjamin','','','','34','301086860','7118 KIRKCALDY DR',0,'WEST CHESTER','OH','45069','4002','CY','39017','2004-07-23','M','',':RET:2106-3','N','021','HLT','420479','92036OH003001205','2014-01-01','2013-12-10 16:51:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 19:21:06'),(13527,10783,'N','01','021','EC','A',NULL,NULL,'','0001516492','0001725399','','IL','1','Sidora','Amanda','','','','34','437771602','105 Firethorn DR',0,'Gretna','LA','70056',NULL,'CY','22051','1989-10-25','F','',NULL,'N','021','DEN','2359656','18575LA002000201','2014-01-01','2013-12-23 10:44:59',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 13:03:21'),(21728,17350,'N','01','021','EC','A',NULL,NULL,'','0000307865','0000316962','','IL','1','Phan','kimlan','','','','34','586460663','2230 Templeton DR',0,'Arlington','TX','76006',NULL,'CY','48439','1953-10-30','F','',':RET:2047-9','N','021','DEN','3493068','33348TX002000201','2014-03-01','2014-02-06 13:55:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-06 21:00:08'),(20932,16729,'Y','18','021','EC','A','','','AC','0000446316','0000446316','OH00002528434','IL','1','Shotts','Anita','','','','34','284547813','2121 VILLA RD',0,'SPRINGFIELD','OH','45503','1841','CY','39023','1952-06-23','F','M',':RET:2106-3','N','021','HLT','3041452','92036OH002000501','2014-03-01','2014-01-31 12:51:58','308.00',NULL,NULL,'771.40','463.40','R-OH003','OH0','771.40',NULL,0,'2014-01-31 21:01:38'),(19254,15343,'N','01','021','EC','A',NULL,NULL,'','0001456288','0001933120','','IL','1','Novoa','Abby','','','','34','073683035','37346 ALICE BRAUD LN',0,'PRAIRIEVILLE','LA','70769','3546','CY','22005','1981-11-10','F','',':RET:2106-3','N','021','DEN','2712614','18575LA002000201','2014-03-01','2014-01-20 11:48:24',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-21 08:46:45'),(16625,13300,'Y','18','021','EC','A','','','AC','0000997768','0000997768','OH00001288955','IL','1','MILLS','MARY','ELIZABETH','','','34','281544484','11436 BRYANT RD',0,'MOUNT VERNON','OH','43050','9622','CY','39083','1954-01-09','F','M',':RET:2106-3','N','021','DEN','1735470','99734OH005000401','2014-02-01','2014-01-07 14:56:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-08 18:24:12'),(4998,3964,'N','19','021','EC','A',NULL,NULL,'','0001234104','0000221260','','IL','1','Kontos','Nicholas','','','','34','286962750','1811 KATHRYN DR',0,'WESTLAKE','OH','44145','3557','CY','39035','1993-06-11','M','',':RET:2106-3','N','021','DEN','490921','99734OH005000301','2014-01-01','2013-12-07 10:35:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:47:05'),(6145,4874,'Y','18','021','EC','A','','','AC','0001188762','0001188762','OH00000595868','IL','1','WAGNER','JOHN','J','','','34','285625222','1782 DRY BONE ROAD',0,'PEEPLES','OH','45660',NULL,'CY','39131','1959-11-01','M','M',':RET:2106-3','T','021','DEN','1140206','99734OH005000301','2014-01-01','2013-11-21 10:24:48','0.00',NULL,NULL,'42.26','42.26','R-OH010','OH0','0.00',NULL,0,'2013-12-26 00:16:23'),(6600,5234,'Y','18','021','EC','A','','','AC','0000760424','0000760424','MS00000774160','IL','1','PHILLIPS','VICKI','M','','','34','425021773','25 ROBBINS RD',0,'LUMBERTON','MS','39455','8313','CY','28073','1955-05-26','F','M',':RET:2106-3','N','021','DEN','24838','46300MS002000101','2014-01-01','2013-12-11 15:40:58','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2013-12-26 00:53:31'),(8930,7079,'N','01','021','EC','A',NULL,NULL,'','0000520946','0000783213','','IL','1','serpette','rebecca','','','','34','343467195','368 Juhl rd',0,'circleville','OH','43113',NULL,'CY','39129','1951-11-04','F','',':RET:2106-3','N','021','DEN','2215331','99734OH005000401','2014-01-01','2013-12-18 09:50:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:03:00'),(27282,21603,'N','01','021','EC','A',NULL,NULL,'','0000148406','0000342753','','IL','1','GUIRGUIS','GEORGES DIT MOUNIR','','','','34','107808715','5948 DAVENHILL DR',0,'PLANO','TX','75093','4346','CY','48085','1928-12-04','M','',NULL,'N','021','DEN','3658583','33348TX002000201','2014-04-01','2014-03-03 22:57:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','17.60',NULL,0,'2014-03-04 21:00:23'),(28037,22187,'N','19','021','EC','A',NULL,NULL,'','0000926336','0000569381','','S1','1','KLUN','BRIAN','','','','34','296027185','860 E 239TH ST',0,'EUCLID','OH','44123',NULL,'CY','39035','1998-04-19','M','',NULL,'N','021','DEN','3540924','99734OH005000401','2014-04-01','2014-03-06 17:35:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:30'),(28110,22248,'N','19','021','EC','A',NULL,NULL,'','0001019326','0000001096','','IL','1','Ulman','Ian',NULL,NULL,NULL,NULL,NULL,'550 RAWLINS AVE',0,'AKRON','OH','44319','4343','CY','39153','1993-11-13','M','',':RET:2106-3','N','021','HLT','3177573','52664OH152000901','2014-04-01','2014-03-06 15:36:51',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-06 21:02:15'),(313,256,'Y','18','021','EC','A','','','AC','0000737804','0000737804','LA00001102771','IL','1','Van de Putte','Mary','','','','34','372908489','8564 CULLEN AVE',0,'BATON ROUGE','LA','70809','1759','CY','22033','1982-01-22','F','U',':RET:2106-3','N','021','DEN','1110153','18575LA002000201','2014-01-01','2013-11-13 13:28:51','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:31:05'),(25201,19991,'Y','18','021','EC','A','','','AC','0001189366','0001189366','LA00002138198','IL','1','OULDSIDIRIJAL','MOHAMED','','','','34','401533303','3605 DELAMBERT ST',0,'CHALMETTE','LA','70043','2312','CY','22087','1969-12-12','M','U',NULL,'N','021','DEN','3657069','18575LA002000201','2014-04-01','2014-02-21 13:24:34','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-21 22:00:46'),(23751,18907,'N','19','021','EC','A',NULL,NULL,'','0000221362','0000170201','','IL','1','Dahl','Ellery','Jane Peterson','','','34','210843053','961 MCCLAIN RD',0,'GRANDVIEW HEIGHTS','OH','43212','3706','CY','39049','2009-04-15','F','',':RET:2106-3','N','021','DEN','2644067','99734OH005000301','2014-03-01','2014-02-14 11:21:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:07'),(23718,18884,'Y','18','021','EC','A','','','AC','0000647117','0000647117','OH00001709817','IL','1','Jester','Lauren','','','','34','291861934','8876 LYNCRIS DR',0,'CINCINNATI','OH','45242','7316','CY','39061','1984-05-24','F','U',':RET:2106-3','T','021','DEN','2723335','99734OH005000401','2014-03-01','2014-02-14 17:35:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:50'),(22773,18181,'Y','18','021','EC','A','','','AC','0000022836','0000022836','OH00002589681','IL','1','BROWN','PATRICIA','','','','34','545925214','1414 HADDON RD',0,'COLUMBUS','OH','43209','3104','CY','39049','1951-07-01','F','U',':RET:2054-5','N','021','DEN','2836823','99734OH005000401','2014-03-01','2014-02-11 13:06:16','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-11 21:01:39'),(606,499,'Y','18','021','EC','A','','','AC','0000038364','0000038364','OH00001222875','IL','1','HUNTER','JATAUN','H','','','34','283808388','4395 NORTHFIELD RD',0,'WARRENSVILLE','OH','44128',NULL,'CY','39035','1976-05-07','F','U',':RET:2054-5','N','021','DEN','1925914','99734OH005000401','2014-01-01','2013-12-16 09:13:29','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:00:26'),(21420,17121,'Y','18','021','EC','A','','','AC','0000190230','0000190230','OH00001703163','IL','1','Stoner','Rhonda','','','','34','301684815','3830 HOMEWOOD AVE',0,'TOLEDO','OH','43612','1206','CY','39095','1963-09-28','F','M',NULL,'N','021','HLT','2810468','92036OH006002601','2014-03-01','2014-02-04 14:07:45','38.00',NULL,NULL,'276.19','238.19','R-OH001','OH0','276.19',NULL,0,'2014-02-04 21:01:13'),(1231,1014,'Y','18','021','EC','A','','','AC','0000265205','0000265205','OH00001181890','IL','1','Kusak','David','A','','','34','302866584','220 Napoleon Road',0,'Bowling Green','OH','43402',NULL,'CY','39173','1981-02-18','M','M',':RET:2106-3','N','021','HLT','67689','92036OH004002601','2014-01-01','2013-12-03 09:23:42','0.00',NULL,NULL,'185.49','185.49','R-OH001','OH0','185.49',NULL,0,'2013-12-25 18:20:43'),(2696,2184,'Y','18','021','EC','A','','','AC','0000460462','0000460462','TX00000249480','IL','1','Kalloor','Sheila','','','','34','458276539','707Clayton Circle',0,'Coppell','TX','75019',NULL,'CY','48113','1950-05-02','F','R',NULL,'N','021','DEN','17430','33348TX002000201','2014-01-01','2013-12-02 12:28:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 19:47:37'),(19590,15616,'Y','18','021','EC','A','','','AC','0000911824','0000911824','MS00002189701','IL','1','Mckennis','Daniel','','','','34','426179725','1636 DANSBY ST',0,'JACKSON','MS','39204','2543','CY','28049','1959-05-22','M','U',':RET:2054-5','N','021','DEN','3240480','46300MS002000201','2014-03-01','2014-01-22 11:06:53','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-23 03:02:44'),(3409,2737,'Y','18','021','EC','A','','','AC','0001179675','0001179675','LA00000726786','31','1','Williams','Dale','','','','34','437853238','p.o. box 294',0,'Tickfaw','LA','70466',NULL,'CY','22105','1992-10-10','M','U',':RET:2054-5','N','021','DEN','1846263','18575LA002000201','2014-01-01','2013-12-22 15:24:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:18:20'),(18925,15079,'Y','18','024','14','A','','','TE','0000640953','0000640953','','IL','1','johnson','nicholas','james',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-01-10','M','',NULL,NULL,NULL,'','2931871','','2014-01-16','2014-01-16 21:27:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-20 08:05:35'),(3438,2763,'Y','18','021','EC','A','','','AC','0002068744','0002068744','LA00000411916','IL','1','HART','RAYMOND','P','','','34','434880753','961 KITTY ST',0,'BATON ROUGE','LA','70807','4523','CY','22033','1953-09-26','M','U',':RET:2054-5','N','021','DEN','1595793','18575LA002000101','2014-01-01','2013-12-22 14:47:24','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 21:19:08'),(17385,13910,'Y','18','021','EC','A','','','AC','0001176862','0001176862','OH00002534657','IL','1','Wagner','Matthew','','','','34','076764663','994 POLARIS CROSSING BLVD',0,'WESTERVILLE','OH','43081','8990','CY','39049','1982-04-29','M','R',':RET:2106-3','N','021','DEN','2507109','99734OH005000401','2014-02-01','2014-01-10 11:19:19','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-13 03:00:08'),(16510,13208,'Y','18','021','EC','A','','','AC','0000641374','0000641374','TX00001649087','31','1','MCINTIRE','MICHAEL','O','','','34','479709073','PO BOX 314',0,'WINK','TX','79789',NULL,'CY','48495','1955-02-16','M','M',':RET:2106-3','N','021','DEN','1545294','33348TX002000201','2014-02-01','2014-01-04 19:05:05','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,1,'2014-01-07 10:21:21'),(27360,21666,'N','01','021','EC','A',NULL,NULL,'','0001031515','0000977997','','IL','1','Iliev','Vall','','','','34','058624496','4323 LORWOOD DR',0,'STOW','OH','44224','2734','CY','39153','1955-04-23','M','',NULL,'N','021','DEN','3803723','99734OH005000401','2014-04-01','2014-03-04 15:59:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-04 21:01:10'),(3078,2473,'Y','18','021','EC','A','','','AC','0000662673','0000662673','OH00000770289','IL','1','Beck','David','M','','Sr','34','300540036','12656 STATION RD',0,'COLUMBIA STATION','OH','44028','9502','CY','39093','1957-03-05','M','M',':RET:2106-3','N','021','HLT','1095596','92036OH003000804','2014-01-01','2013-12-06 11:58:11','204.00',NULL,NULL,'569.61','365.61','R-OH011','OH0','569.61',NULL,0,'2013-12-25 20:19:39'),(19263,15352,'Y','18','021','EC','A','','','AC','0000908055','0000908055','OH00002019141','IL','1','BUTLER','HENRY','LEE','','','34','301769909','114 WESTFIELD AVE',0,'DEFIANCE','OH','43512',NULL,'CY','39039','1967-01-23','M','U',NULL,'N','021','HLT','2378204','92036OH003002605','2014-03-01','2014-01-20 12:02:08','244.00',NULL,NULL,'318.29','74.29','R-OH001','OH0','318.29',NULL,0,'2014-01-21 08:46:50'),(26065,20670,'Y','18','021','EC','A','','','AC','0000087536','0000087536','OH00003235616','31','1','RUSSO','ALFRED','','','','34','056543670','PO BOX 105',0,'FINDLAY','OH','45839',NULL,'CY','39063','1960-01-23','M','M',NULL,'T','021','HLT','3788828','92036OH002001501','2014-04-01','2014-02-26 17:02:36','462.00',NULL,NULL,'879.22','417.22','R-OH002','OH0','624.03',NULL,0,'2014-02-26 21:02:41'),(24331,19323,'Y','18','021','EC','A','','','AC','0000745682','0000745682','TX00002873546','IL','1','ORTIZ MUNOZ','ABEL','','','','34','054084637','113 MARIE DR',0,'COMFORT','TX','78013','3366','CY','48265','1959-04-27','M','M',':RET:2106-3','N','021','DEN','2982930','33348TX002000201','2014-04-01','2014-02-18 13:37:11','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-18 22:00:13'),(15116,12082,'N','01','021','EC','A',NULL,NULL,'','0000280843','0001008954','','IL','1','Butto','Pamela','','','','34','280580919','221 BEAVER AVE',0,'NILES','OH','44446','2606','CY','39155','1963-02-01','F','',':RET:2106-3','T','021','DEN','1678632','99734OH005000301','2014-02-01','2013-12-30 15:17:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:07'),(17856,14264,'Y','18','021','EC','A','','','AC','0000178910','0000178910','OH00002402076','IL','1','WATKINS','BONNIE','','','','34','278563134','31 BRENNER AVE',0,'DAYTON','OH','45403','1121','CY','39113','1954-06-20','F','M',':RET:2106-3','N','021','DEN','2539014','99734OH005000401','2014-02-01','2014-01-14 10:57:15','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:09'),(15170,12123,'Y','18','021','EC','A','','','AC','0001006832','0001006832','OH00000561048','IL','1','DARBY','JAMES','WILLIAM','','','34','161449734','7 WHITEFRIARS DR',0,'AKRON','OH','44319',NULL,'CY','39153','1953-09-21','M','M',':RET:2106-3','N','021','DEN','2397118','99734OH005000401','2014-02-01','2013-12-30 15:35:05','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-01 12:06:32'),(26376,20924,'Y','18','021','EC','A','','','AC','0001090915','0001090915','OH00002561351','IL','1','Mack','Vada','','','','34','294661624','9947 Darrow Park Drive',0,'Twinsburg','OH','44087',NULL,'CY','39153','1960-10-03','F','U',':RET:2054-5','N','021','DEN','2936133','99734OH005000401','2014-03-01','2014-02-26 17:28:53','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-28 07:00:16'),(27979,22136,'Y','18','021','EC','A','','','AC','0002009294','0002009294','LA00003578499','IL','1','Cox','Carla','J','','','34','429351207','9657 W TAMPA DR',0,'BATON ROUGE','LA','70815','8954','CY','22033','1968-05-16','F','U',':RET:2054-5','N','021','DEN','4008628','18575LA002000201','2014-04-01','2014-03-06 15:11:52','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-06 21:00:55'),(28330,22416,'Y','18','021','EC','A','','','AC','0000872922','0000872922','TX00003266648','IL','1','Denbow','Jayna','E','','','34','631178733','205 S ROLLING MEADOWS DR',0,'WYLIE','TX','75098','5166','CY','48085','1979-02-20','F','M',':RET:2106-3','N','021','DEN','3020130','33348TX002000201','2014-04-01','2014-03-07 00:39:49','0.00',NULL,NULL,'72.22','72.22','R-TX008','TX0','15.85',NULL,0,'2014-03-07 21:30:10'),(488,398,'Y','18','021','EC','A','','','AC','0000941346','0000941346','LA00001238629','IL','1','Sharp','Ken','','','','34','434021647','6926 W ACHORD RD',0,'BATON ROUGE','LA','70817','4107','CY','22033','1956-12-29','M','U',':RET:2106-3','N','021','DEN','754682','18575LA002000201','2014-01-01','2013-12-03 21:20:08','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:48:20'),(9578,7584,'N','01','021','EC','A',NULL,NULL,'','0000368543','0000208491','','IL','1','ECCARD','DAVID','','','','34','299488345','1711 COTTONTAIL DR',0,'MILFORD','OH','45150','5520','CY','39025','1950-05-18','M','',':RET:2106-3','N','021','DEN','1556347','99734OH005000301','2014-01-01','2013-12-21 17:13:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:49'),(9239,7329,'N','19','021','EC','A',NULL,NULL,'','0000685832','0000780498','','IL','1','okes','Joseph','frank','','','34','273947870','11 phillip court',0,'elyria','OH','44035',NULL,'CY','39093','1991-02-26','M','',':RET:2106-3','N','021','HLT','2256482','92036OH004000801','2014-01-01','2013-12-18 15:51:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','187.99',NULL,0,'2013-12-26 04:10:38'),(21234,16968,'Y','18','024','14','A','','','TE','0000558114','0000558114','','IL','1','Campbell','Sandra','L',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-08-12','F','',NULL,NULL,NULL,'','507137','','2014-02-03','2014-02-03 13:04:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:10'),(4445,3532,'Y','18','021','EC','A','','','AC','0001149851','0001149851','OH00000942056','IL','1','Santa','Michael','','','','34','275827937','563 KOERBER AVE',0,'AKRON','OH','44314','1767','CY','39153','1978-06-07','M','U',':RET:2106-3','N','021','DEN','26191','99734OH005000301','2014-01-01','2013-12-12 00:09:00','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 22:02:14'),(20538,16411,'Y','18','021','EC','A','','','AC','0000515862','0000515862','OH00001654849','IL','1','Spahr','Charles','','','','34','296507701','1056 Mindy Lane',0,'Wooster','OH','44691',NULL,'CY','39169','1952-02-02','M','M',':RET:2106-3','T','021','HLT','3352279','52664OH152000901','2014-03-01','2014-01-29 14:07:42','508.00',NULL,NULL,'539.67','31.67','R-OH014','OH0','539.67',NULL,0,'2014-01-29 21:01:34'),(15630,12501,'N','01','021','EC','A',NULL,NULL,'','0001366366','0001266157','','IL','1','Ferrand','Charmaine','M','','','34','433315916','207 LESNA LN',0,'RUSTON','LA','71270','9031','CY','22061','1962-10-22','F','',':RET:2054-5','N','021','DEN','2081332','18575LA002000101','2014-02-01','2013-12-31 12:14:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,1,'2014-01-02 04:33:26'),(18317,14624,'Y','18','021','EC','A','','','AC','0000936079','0000936079','OH00002017967','IL','1','Zhang','Francis','','','','34','471069563','375 Allyn Street',0,'Akron','OH','44304',NULL,'CY','39153','1955-02-01','M','U',':RET:2034-7','N','021','DEN','2633238','99734OH005000401','2014-02-01','2014-01-15 14:08:34','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-16 08:45:05'),(26981,21373,'N','01','021','EC','A',NULL,NULL,'','0001024334','0001014436','','IL','1','Blessing','Timothy','','','','34','282681731','4188 Kincheloe Rd.',0,'Georgetown','OH','45121',NULL,'CY','39015','1971-02-24','M','',':RET:2106-3','N','021','HLT','3749471','92036OH004000601','2014-04-01','2014-03-02 12:31:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','234.23',NULL,0,'2014-03-03 01:00:38'),(27949,22109,'N','01','021','EC','A',NULL,NULL,'','0000452002','0000063237','','IL','1','Tobar','Elisa','V','','','34','451239477','1103 Pecan St',0,'Ozona','TX','76943',NULL,'CY','48105','1958-08-05','F','',NULL,'N','021','DEN','3400744','33348TX002000201','2014-04-01','2014-03-06 16:21:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-06 21:00:37'),(28304,22395,'Y','18','024','14','A','','','TE','0000212216','0000212216','','IL','1','Spray','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-05-17','F','',NULL,NULL,NULL,'','3394059','','2014-03-31','2014-03-07 14:48:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-03-07 21:00:33'),(13928,11108,'Y','18','021','EC','A','','','AC','0000793469','0000793469','OH00001247109','IL','1','sherburne','karen',NULL,NULL,NULL,NULL,NULL,'1752 fairfax road',0,'toledo','OH','43613',NULL,'CY','39095','1953-12-13','F','U',':RET:2106-3','N','021','HLT','2524290','92036OH004002601','2014-01-01','2013-12-22 22:01:01','398.00',NULL,NULL,'425.53','27.53','R-OH001','OH0','425.53',NULL,0,'2013-12-26 13:14:22'),(9123,7236,'N','19','021','EC','A',NULL,NULL,'','0000323491','0000435286','','IL','1','Torres','Rachel','','','','34','018807336','7973 SCHOOL HOUSE LN',0,'MONTGOMERY','OH','45242','5928','CY','39061','1996-06-26','F','',':RET:2106-3','N','021','DEN','1795337','99734OH005000301','2014-01-01','2013-12-18 18:04:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:07:48'),(7073,5613,'N','19','021','EC','A',NULL,NULL,'','0000566628','0000485867','','IL','1','Blair','Cassandra','Kaylinda','','','34','299062251','6839 HERRON PL',0,'DAYTON','OH','45424','1842','CY','39113','2002-03-25','F','',':RET:2106-3','N','021','DEN','2053197','99734OH005000301','2014-01-01','2013-12-24 22:59:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:07'),(6901,5476,'Y','18','021','EC','A','','','AC','0002244819','0002244819','LA00000135759','IL','1','Smith','Dominique','','','','34','433759179','6805 RENOIR AVE',0,'BATON ROUGE','LA','70806','2184','CY','22033','1988-11-10','F','R',':RET:2054-5','N','021','DEN','2075234','18575LA002000201','2014-01-01','2013-12-24 22:38:00','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:38'),(6009,4757,'N','01','021','EC','A',NULL,NULL,'','0001006780','0000170126','','IL','1','Gonyer','Emily','','','','34','297906243','4095 ELMHURST RD SW',0,'CARROLLTON','OH','44615','8982','CY','39019','1984-05-07','F','',':RET:2106-3','N','021','DEN','10070','99734OH005000301','2014-01-01','2013-12-01 08:33:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:00:34'),(16701,13366,'Y','18','021','EC','A','','','AC','0000008810','0000008810','TX00002069257','IL','1','Barranco','Martha','','','','34','463431180','740 Pendale Rd',0,'El Paso','TX','79907',NULL,'CY','48141','1977-07-01','F','M',':RET:2106-3','N','021','DEN','1879649','33348TX002000201','2014-02-01','2014-01-07 16:52:34','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-08 18:24:38'),(23580,18787,'Y','18','021','EC','A','','','AC','0000569363','0000569363','OH00001385590','IL','1','bucher','kevin','','','','34','288563131','2222 TRAPPERS KNOLL DR',0,'BATAVIA','OH','45103','2656','CY','39025','1954-11-11','M','M',':RET:2106-3','N','021','HLT','3720006','92036OH004000601','2014-03-01','2014-02-13 13:00:49','552.00',NULL,NULL,'852.02','300.02','R-OH005','OH0','449.32',NULL,0,'2014-02-13 22:02:57'),(18648,14867,'Y','18','021','EC','A','','','AC','0000861937','0000861937','TX00001449045','IL','1','Marsh','Thomas','','','','34','450890557','9014 McGallion Rd.',0,'Houston','TX','77022',NULL,'CY','48201','1972-09-20','M','M',':RET:2106-3','N','021','DEN','2022939','33348TX002000201','2014-03-01','2014-01-16 09:24:42','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-17 03:35:09'),(20453,16337,'Y','18','021','EC','A','','','AC','0000051953','0000051953','OH00002195088','IL','1','KIRSCH','JAMES','','','','34','277744184','1715 HIGHLAND AVE',0,'PORTSMOUTH','OH','45662','3610','CY','39145','1978-09-28','M','U',':RET:2106-3','N','021','DEN','2307603','99734OH005000401','2014-03-01','2014-01-28 20:02:10','0.00',NULL,NULL,'15.78','15.78','R-OH010','OH0','0.00',NULL,0,'2014-01-29 21:00:46'),(19948,15911,'Y','18','021','EC','A','','','AC','0000024141','0000024141','OH00001714131','IL','1','Rohrer','Mary','','','','34','316705874','391 HANNAH CT',0,'WILMINGTON','OH','45177','7320','CY','39027','1957-08-30','F','U',':RET:2106-3','N','021','HLT','2678976','92036OH006000601','2014-03-01','2014-01-24 14:54:26','0.00',NULL,NULL,'397.18','397.18','R-OH005','OH0','397.18',NULL,0,'2014-01-24 21:01:19'),(19800,15786,'Y','18','021','EC','A','','','AC','0001132025','0001132025','TX00002594573','IL','1','Castillo','Francisco','','','','34','450130004','1252 INDIANA ST',0,'EL PASO','TX','79930','1131','CY','48141','1956-03-06','M','M',':RET:2106-3','N','021','DEN','2649596','33348TX002000201','2014-03-01','2014-01-24 11:42:26','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-01-24 21:00:04'),(26975,21370,'N','19','021','EC','A',NULL,NULL,'','0001142233','0000824650','','IL','1','Carmany','Alexander','Joseph','','','34','268989893','556 BREITON CIR',0,'BARBERTON','OH','44203','7783','CY','39153','1994-06-16','M','',':RET:2106-3','N','021','HLT','3493627','52664OH152000901','2014-04-01','2014-03-02 12:17:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-03 01:00:36'),(506,413,'N','01','021','EC','A',NULL,NULL,'','0000911738','0000047065','','IL','1','Vranich','John','S','','','34','383546833','14335 MILL HOLLOW LN',0,'STRONGSVILLE','OH','44136','5423','CY','39035','1956-08-11','M','',':RET:2106-3','N','021','DEN','741892','99734OH005000301','2014-01-01','2013-12-04 12:23:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:48:49'),(25654,20353,'Y','18','021','EC','A','','','AC','0000509257','0000509257','OH00002501351','IL','1','Burchett','Heather','','','','34','276728674','3449 beechgrove rd',0,'Dayton','OH','45439',NULL,'CY','39113','1974-12-30','F','U',':RET:2106-3','N','021','DEN','3474917','99734OH005000401','2014-04-01','2014-02-22 15:06:42','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-26 08:30:40'),(9242,7331,'Y','18','021','EC','A','','','AC','0000755986','0000755986','OH00000555375','IL','1','Halton','Gabriel',NULL,NULL,NULL,NULL,NULL,'491 STONELEDGE DR',0,'RICHMOND HTS','OH','44143','2582','CY','39035','1965-11-06','M','M',NULL,'N','021','HLT','1570631','92036OH004000801','2014-01-01','2013-12-18 17:19:01','0.00',NULL,NULL,'601.21','601.21','R-OH011','OH0','307.37',NULL,0,'2013-12-26 04:10:40'),(24979,19811,'Y','18','021','EC','A','','','AC','0000270459','0000270459','TX00002905357','IL','1','BENAVIDES','BEATRIZ',NULL,NULL,NULL,NULL,NULL,'101 KENSINGTON DR',0,'VICTORIA','TX','77901','4565','CY','48469','1951-11-29','F','M',NULL,'N','021','DEN','2855637','33348TX002000201','2014-04-01','2014-02-20 11:07:12','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-02-20 22:00:32'),(24706,19615,'Y','18','021','EC','A','','','AC','0000152036','0000152036','OH00002879971','S1','1','tucker','christopher','','','','34','291082360','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2003-11-27','M','U',':RET:2106-3','N','021','DEN','3730892','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:35:03'),(23622,18811,'N','01','021','EC','A',NULL,NULL,'','0000024155','0000949561','','IL','1','Schmidt','Justin','M','','','34','277723027','15 FARMVIEW CT',0,'HARRISON','OH','45030','2013','CY','39061','1972-12-02','M','',':RET:2106-3','N','021','HLT','3274336','92036OH004001201','2014-03-01','2014-02-13 15:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.74',NULL,0,'2014-02-13 22:03:17'),(23121,18428,'N','19','021','EC','A',NULL,NULL,'','0000270056','0000759740','','IL','1','CLARKE','LAUREN','','','','34','283943826','4205 HEGNER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1991-09-28','F','',':RET:2106-3','N','021','DEN','2856415','99734OH005000401','2014-03-01','2014-02-12 12:21:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:24'),(697,574,'Y','18','021','EC','A','','','AC','0000846132','0000846132','OH00000503424','IL','1','KOHR','DIANA','','','','34','274542984','3005 OGDEN DR',0,'MIDDLETOW','OH','45044',NULL,'CY','39017','1955-04-25','F','M',':RET:2106-3','N','021','DEN','1982225','99734OH005000301','2014-01-01','2013-12-16 15:38:56','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:02:47'),(19431,15490,'Y','18','021','EC','A','','','AC','0001210954','0001210954','OH00001468251','IL','1','SAUNDERS','RYAN','','','','34','275881782','127 W VINE ST',0,'BRADFORD','OH','45308','1227','CY','39037','1978-10-04','M','U',NULL,'T','021','HLT','2540378','92036OH003000504','2014-03-01','2014-01-21 12:09:55','191.58',NULL,NULL,'348.83','157.25','R-OH003','OH0','348.83',NULL,1,'2014-01-22 03:23:07'),(18606,14833,'N','19','021','EC','A',NULL,NULL,'','0000816438','0001209602','','IL','1','CAMPOLONGO','DANIELLE','','','','34','301068777','6285 COUNCILRIDGE CT',0,'LOVELAND','OH','45140','7506','CY','39025','2002-07-14','F','',NULL,'N','021','HLT','1840005','92036OH004000601','2014-02-01','2014-01-15 16:53:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-01-16 08:47:21'),(2873,2322,'Y','18','021','EC','A','','','AC','0000163688','0000163688','TX00000306561','IL','1','Farias','Gabriel','','','','34','462792220','226 CAMARGO ST',0,'SAN ANTONIO','TX','78210','1088','CY','48029','1971-06-27','M','M',':RET:2148-5^:RET:2106-3','N','021','DEN','762156','33348TX002000201','2014-01-01','2013-10-22 00:17:20','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-25 20:01:59'),(16148,12932,'N','19','021','EC','A',NULL,NULL,'','0000532115','0000731211','','IL','1','wallbridge','loryn','elizabeth',NULL,NULL,NULL,NULL,'527 S REVERE RD',0,'CINCINNATI','OH','45255','5085','CY','39025','2009-02-05','F','',':RET:2106-3','N','021','HLT','1372273','92036OH001000601','2014-02-01','2014-01-03 15:35:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2014-01-04 02:06:10'),(6256,4958,'Y','18','021','EC','A','','','AC','0000496246','0000496246','MS00000140865','IL','1','durr','christine','','','','34','587487469','5452 CLINTON BLVD',0,'JACKSON','MS','39209','3004','CY','28049','1951-07-21','F','M',':RET:2054-5','N','021','DEN','262576','46300MS002000201','2014-01-01','2013-11-19 13:25:02','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 00:32:07'),(3473,2789,'N','19','021','EC','A',NULL,NULL,'','0000086420','0001021465','','IL','1','sutherland','kelvin','','','','34','294113337','5120 Free Pike',0,'trotwood','OH','45426',NULL,'CY','39113','1994-11-02','M','',':RET:2054-5','N','021','DEN','2570534','99734OH005000401','2014-01-01','2013-12-22 10:33:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:01'),(3510,2820,'Y','18','021','EC','A','','','AC','0000848346','0000848346','OH00000425901','IL','1','GLUTZ','DEBORAH','','','','34','270547953','57555 KELLOGG AVE',0,'CINCINNATI','OH','45230',NULL,'CY','39061','1951-09-08','F','U',':RET:2106-3','N','021','HLT','2291993','92036OH002001201','2014-01-01','2013-12-22 11:09:30','430.00',NULL,NULL,'712.24','282.24','R-OH004','OH0','712.24',NULL,0,'2013-12-25 21:20:58'),(29063,23003,'Y','18','021','EC','A','','','AC','0000546531','0000546531','OH00003657823','IL','1','zunk','cory','','','','34','277882673','3459 140TH ST',0,'TOLEDO','OH','43611','2486','CY','39095','1985-07-10','M','U',':RET:2106-3','N','021','HLT','4292205','92036OH004002601','2014-04-01','2014-03-09 22:27:08','169.19',NULL,NULL,'170.44','1.25','R-OH001','OH0','170.44',NULL,0,'2014-03-10 21:01:53'),(53,48,'Y','18','021','EC','A','','','AC','0000309408','0000309408','OH00000999499','IL','1','Castillo','Barbara','','','','34','273701380','1210 STATE ROUTE 302',0,'ASHLAND','OH','44805','9321','CY','39005','1961-05-13','F','U',':RET:2106-3','N','021','DEN','304699','99734OH005000301','2014-01-01','2013-12-04 19:11:14','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:16:27'),(4814,3816,'Y','18','021','EC','A','','','AC','0001033632','0001033632','OH00000673321','IL','1','Uzoma','Chukwuemeka','','','','34','341980478','324 W. Mcmillan St',0,'Cincinnati','OH','45219',NULL,'CY','39061','1981-11-03','M','U',':RET:2054-5','N','021','HLT','1191947','92036OH006001201','2014-01-01','2013-12-08 16:30:48','199.93',NULL,NULL,'201.40','1.47','R-OH004','OH0','201.40',NULL,0,'2013-12-25 22:16:53'),(13410,10700,'N','19','021','EC','A',NULL,NULL,'','0000540299','0000171233','','IL','1','Mecklenborg','Rosie','Mae',NULL,NULL,NULL,NULL,'3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2013-11-02','F','',NULL,'N','021','DEN','1618729','99734OH005000301','2014-01-01','2013-12-23 10:06:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:00:34'),(20134,16067,'Y','18','021','EC','A','','','AC','0001132790','0001132790','OH00001945442','IL','1','HALLER','NORMA','','','','34','299584057','1865 ADELAIDE BLVD',0,'AKRON','OH','44305','4353','CY','39153','1960-07-20','F','U',':RET:2106-3','N','021','DEN','2757134','99734OH005000401','2014-03-01','2014-01-27 13:24:44','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-27 21:00:53'),(24272,19275,'N','01','021','EC','A',NULL,NULL,'','0000944916','0000397394','','IL','1','saeidi','michael','F','','','34','363258229','8152 PEPPERWOOD DR',0,'WEST CHESTER','OH','45069','1861','CY','39017','1958-07-26','M','',':RET:2106-3','N','021','HLT','3249596','92036OH006001201','2014-04-01','2014-02-17 14:41:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','379.65',NULL,0,'2014-02-17 19:00:17'),(13050,10404,'Y','18','021','EC','A','','','AC','0000721340','0000721340','OH00001089246','IL','1','Reynolds','Roy','','','','34','277869131','653 Brent Boulevard',0,'Columbus','OH','43228',NULL,'CY','39049','1974-07-25','M','U',':RET:2106-3','T','021','DEN','2458395','99734OH005000401','2014-01-01','2013-12-23 09:04:06','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 12:50:51'),(5994,4746,'Y','18','021','EC','A','','','AC','0000413840','0000413840','LA00000315765','IL','1','Symsek','Timothy','','','','34','174523840','805 PARK RIDGE DR',0,'RIVER RIDGE','LA','70123','1180','CY','22051','1957-03-02','M','U',':RET:2106-3','N','021','DEN','566164','18575LA002000201','2014-01-01','2013-12-01 10:10:47','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 00:00:09'),(19423,15483,'Y','18','021','EC','A','','','AC','0000488015','0000488015','OH00002022755','IL','1','Haarburger','Daniel','','','','34','287967792','4549 EDMOND DR',0,'SOUTH EUCLID','OH','44121','3907','CY','39035','1993-08-01','M','U',':RET:2106-3','N','021','HLT','1817323','92036OH004000801','2014-03-01','2014-01-21 13:49:26','100.00',NULL,NULL,'119.38','19.38','R-OH011','OH0','119.38',NULL,1,'2014-01-22 03:23:03'),(22639,18077,'N','01','021','EC','A',NULL,NULL,'','0000307865','0000316962','','IL','1','Phan','kimlan','','','','34','586460663','2230 Templeton DR',0,'Arlington','TX','76006',NULL,'CY','48439','1953-10-30','F','',':RET:2047-9','N','021','DEN','3472072','33348TX002000201','2014-03-01','2014-02-11 09:58:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-11 21:00:22'),(8160,6455,'N','01','021','EC','A',NULL,NULL,'','0000012398','0001122703','','IL','1','Olmstead','David','C','','','34','270546319','1901 LOGAN AVE',0,'FINDLAY','OH','45840','1621','CY','39063','1952-05-02','M','',':RET:2106-3','N','021','HLT','481187','92036OH004001501','2014-01-01','2013-11-22 12:57:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','497.29',NULL,0,'2013-12-26 03:16:19'),(18171,14510,'Y','18','021','EC','A','','','AC','0000221318','0000221318','OH00001458959','IL','1','Taylor','Brian','S','','','34','287427721','7381 N TOWNSHIP ROAD 63',0,'FOSTORIA','OH','44830','9574','CY','39147','1956-08-28','M','M',':RET:2106-3','N','021','HLT','2384160','92036OH005002701','2014-02-01','2014-01-14 08:46:42','580.00',NULL,NULL,'972.05','392.05','R-OH006','OH0','475.21',NULL,0,'2014-01-15 02:07:57'),(17957,14348,'Y','18','021','EC','A','','','AC','0000843489','0000843489','TX00002569286','IL','1','Bryant','DeAnn','R','','','34','462531525','698 STATE HIGHWAY 207',0,'POST','TX','79356','5122','CY','48169','1962-12-15','F','U',':RET:2106-3','N','021','DEN','2188780','33348TX002000201','2014-02-01','2014-01-14 18:04:54','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:44'),(17300,13835,'Y','18','021','EC','A','','','AC','0000485377','0000485377','TX00002463641','IL','1','Kim','Yeon','Won','','','34','460698739','3951 CLUBWAY LN',0,'DALLAS','TX','75244','5416','CY','48113','1957-03-22','F','M',':RET:2040-4','N','021','DEN','2616656','33348TX002000201','2014-02-01','2014-01-10 12:06:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-13 02:23:38'),(8047,6370,'Y','18','021','EC','A','','','AC','0000532095','0000532095','OH00001207986','IL','1','Johns','Brian','','','','34','282602090','6931 Apple Creek Rd',0,'Sylvania','OH','43560',NULL,'CY','39095','1956-10-18','M','R',NULL,'N','021','HLT','1795433','92036OH004002601','2014-01-01','2013-12-20 07:24:52','0.00',NULL,NULL,'382.11','382.11','R-OH001','OH0','382.11',NULL,0,'2013-12-26 03:09:34'),(15901,12733,'Y','18','024','14','A','','','TE','0000153379','0000153379','','IL','1','harrison','danette',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-02-18','F','',NULL,NULL,NULL,'','1629953','','2014-01-01','2014-01-01 19:13:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:06:05'),(5765,4580,'Y','18','021','EC','A','','','AC','0000217595','0000217595','OH00000434898','IL','1','Lyttle','David','','','','34','278623856','4607 KENTFIELD DR',0,'TROTWOOD','OH','45426','1853','CY','39113','1955-02-01','M','M',':RET:2054-5','N','021','DEN','2226872','99734OH005000401','2014-01-01','2013-12-23 22:13:35','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2013-12-25 23:46:38'),(3838,3070,'Y','18','024','14','A','','','TE','0000776457','0000776457','','IL','1','Smith','Ricky',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-06-14','M','',NULL,NULL,NULL,'','512256','','2013-12-13','2013-12-13 18:05:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-25 21:35:19'),(26161,20744,'Y','18','021','EC','A','','','AC','0000347971','0000347971','OH00002970094','IL','1','BROWN','JUDY','','','','34','284544977','2749 WARRENSBURG RD',0,'DELAWARE','OH','43015','1345','CY','39041','1952-12-23','F','M',':RET:2106-3','N','021','DEN','3318165','99734OH005000401','2014-04-01','2014-02-27 17:49:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 06:30:32'),(27729,21928,'N','01','021','EC','A',NULL,NULL,'','0001203023','0000627553','','IL','1','delfin','maria','c','','','34','642845241','416 16TH ST',0,'HUNTSVILLE','TX','77340','5305','CY','48471','1963-12-20','F','',NULL,'N','021','DEN','3478787','33348TX002000201','2014-04-01','2014-03-05 15:21:49',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:31:03'),(1261,1040,'Y','18','021','EC','A','','','AC','0000437941','0000437941','OH00000155138','IL','1','wolfelt','cierra',NULL,NULL,NULL,NULL,NULL,'285 W 4TH ST',0,'FOSTORIA','OH','44830','2416','CY','39147','1988-11-03','F','U',':RET:2106-3','T','021','HLT','532236','92036OH005002706','2014-01-01','2013-12-03 16:43:20','190.00',NULL,NULL,'225.15','35.15','R-OH006','OH0','225.15',NULL,0,'2013-12-25 18:21:32'),(21917,17504,'Y','18','021','EC','A','','','AC','0000764941','0000764941','TX00001537033','IL','1','Rice','Beatrica','','','','34','644018598','3565 Timberglen Road',0,'Dallas','TX','75287',NULL,'CY','48121','1988-07-06','F','U',':RET:2054-5','N','021','DEN','3782338','33348TX002000201','2014-03-01','2014-02-06 18:21:35','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-07 19:00:03'),(21834,17436,'Y','18','021','EC','A','','','AC','0000667368','0000667368','TX00002136364','IL','1','Graves','Belinda','','','','34','465881968','2055 HILL TOP CIR',0,'WEATHERFORD','TX','76085','3018','CY','48367','1950-07-12','F','U',':RET:2106-3','N','021','DEN','2767061','33348TX002000101','2014-03-01','2014-02-06 14:59:31','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-06 21:01:06'),(2166,1782,'N','01','021','EC','A',NULL,NULL,'','0001198092','0000314677','','IL','1','Kruger','Vicki','','','','34','293606874','1147 GLENVIEW DR',0,'MOGADORE','OH','44260','9546','CY','39133','1961-12-30','F','',':RET:2106-3','N','021','HLT','46862','52664OH151001501','2014-01-01','2013-12-10 15:37:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','522.09',NULL,0,'2013-12-25 19:19:03'),(5961,4721,'N','19','021','EC','A',NULL,NULL,'','0000599756','0000692921','','IL','1','Painter','Johnathan','W',NULL,NULL,NULL,NULL,'4333 Aaron Ct',0,'Cincinnati','OH','45241',NULL,'CY','39017','2002-06-04','M','',':RET:2106-3','N','021','HLT','1566099','92036OH005001201','2014-01-01','2013-12-23 22:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 23:51:24'),(5806,4612,'Y','18','021','EC','A','','','AC','0000133946','0000133946','TX00000004601','IL','1','Manahan','Steve','','','','34','463963684','109 E 75TH ST',0,'LUBBOCK','TX','79404','6403','CY','48303','1955-05-29','M','M',':RET:2054-5','T','021','DEN','2403967','33348TX002000201','2014-01-01','2013-12-23 21:17:37','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 23:47:38'),(19096,15214,'N','01','021','EC','A',NULL,NULL,'','0000373656','0001030393','','IL','1','Vance','Randy','L',NULL,NULL,NULL,NULL,'11217 Tecumseh Path',0,'Lakeview','OH','43331',NULL,'CY','39091','1956-08-10','M','',':RET:2106-3','N','021','DEN','1481954','99734OH005000301','2014-03-01','2014-01-18 14:07:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-21 08:44:35'),(19024,15151,'Y','18','024','14','A','','','TE','0000368306','0000368306','','IL','1','BILLINGSLEA','DEBRA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-04-05','F','',NULL,NULL,NULL,'','2283769','','2014-01-17','2014-01-17 12:09:21',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-20 08:06:27'),(5481,4352,'Y','18','021','EC','A','','','AC','0000959087','0000959087','OH00000430612','IL','1','brinkman','patricia','','','','34','291484951','835 PINEHURST DR',0,'delphos','OH','45833',NULL,'CY','39161','1950-07-16','F','M',':RET:2106-3','N','021','HLT','1999733','92036OH005001501','2014-01-01','2013-12-19 09:42:23','1078.00',NULL,NULL,'1299.36','221.36','R-OH002','OH0','649.68',NULL,0,'2013-12-25 23:10:51'),(5440,4322,'Y','18','021','EC','A','','','AC','0001828561','0001828561','LA00000393411','IL','1','Park','No','','','','34','434917211','1446 Helios Ave',0,'Metairie','LA','70005',NULL,'CY','22051','1957-07-29','M','M',NULL,'N','021','DEN','1435366','18575LA002000101','2014-01-01','2013-12-19 17:01:49','0.00',NULL,NULL,'50.04','50.04','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:55'),(18121,14473,'Y','18','021','EC','A','','','AC','0000676735','0000676735','OH00001652063','IL','1','Meyers','Dennis','','','','34','191423809','1770 AKRON PENINSULA RD',0,'AKRON','OH','44313','4815','CY','39153','1952-01-29','M','M',NULL,'N','021','HLT','2628229','52664OH152000901','2014-02-01','2014-01-14 16:26:16','938.56',NULL,NULL,'938.56','0.00','R-OH012','OH0','469.28',NULL,0,'2014-01-15 02:07:40'),(18080,14440,'Y','18','021','EC','A','','','AC','0001320369','0001320369','LA00002484123','IL','1','JONES','ERICA','','','','34','434493756','169 S. Beadle Rd.',0,'Lafayette','LA','70508',NULL,'CY','22055','1977-09-29','F','U',':RET:2054-5','N','021','DEN','1459963','18575LA002000201','2014-02-01','2014-01-14 10:49:59','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-15 02:07:26'),(17656,14111,'Y','18','021','EC','A','','','AC','0001115960','0001115960','OH00002141118','IL','1','gamiere','kevin','l','','','34','297588804','4425 elberta road',0,'perry','OH','44081',NULL,'CY','39085','1956-04-07','M','M',':RET:2106-3','N','021','DEN','2280887','99734OH005000301','2014-02-01','2014-01-13 13:02:47','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-14 01:32:42'),(15506,12407,'Y','18','021','EC','A','','','AC','0000539292','0000539292','OH00001564927','IL','1','cleveland','laura','','','','34','287587276','383 DAY LIGHT LN',0,'POWELL','OH','43065','8213','CY','39041','1961-10-03','F','M',':RET:2106-3','N','021','DEN','1522065','99734OH005000401','2014-02-01','2013-12-31 14:43:41','0.00',NULL,NULL,'71.95','71.95','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:52'),(15219,12165,'Y','18','021','EC','A','','','AC','0002205363','0002205363','LA00001524915','IL','1','Jordan','Michelle','','','','34','551750562','1993 WHITE OAK ST',0,'VINTON','LA','70668','5944','CY','22019','1967-10-18','F','U',':RET:2106-3','N','021','DEN','2315909','18575LA002000101','2014-02-01','2013-12-29 23:33:56','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-01-01 12:07:57'),(24985,19817,'Y','18','021','EC','A','','','AC','0000353269','0000353269','TX00002498593','IL','1','wise','colleen','','','','34','346626400','1407 SYCAMORE DR',0,'BURKBURNETT','TX','76354','3140','CY','48485','1959-12-29','F','M',':RET:2106-3','N','021','DEN','3802219','33348TX002000201','2014-04-01','2014-02-20 13:30:01','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-20 22:00:36'),(27968,22126,'Y','18','021','EC','A','','','AC','0001400135','0001400135','LA00002842643','IL','1','KING','ANTOINETTE','','','','34','436697986','719 EDWARDS ST',0,'SHREVEPORT','LA','71101','3657','CY','22017','1986-09-09','F','U',':RET:2054-5','T','021','DEN','3853772','18575LA002000201','2014-04-01','2014-03-06 11:06:33','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-03-06 21:00:48'),(690,568,'Y','18','021','EC','A','','','AC','0001115923','0001115923','OH00000482435','IL','1','BARCUS','AMANDA','','','','34','287847153','1116 DAISY LN',0,'HEATH','OH','43056','1118','CY','39089','1984-08-16','F','M',':RET:2106-3','T','021','DEN','1821049','99734OH005000301','2014-01-01','2013-12-16 14:50:22','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 18:02:36'),(23250,18535,'N','01','021','EC','A',NULL,NULL,'','0000132073','0000491883','','IL','1','Payten','Creshinda','J','','','34','279624056','5206 CATO ST',0,'MAPLE HEIGHTS','OH','44137','1416','CY','39035','1964-08-02','F','',':RET:2054-5','N','021','DEN','3272818','99734OH005000401','2014-03-01','2014-02-13 09:29:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-13 21:30:05'),(22885,18248,'Y','18','021','EC','A','','','AC','0000017667','0000017667','OH00002589666','S1','1','Osborne','Bich Son','L','','','34','301159983','2646 AEDEN DR',0,'COLUMBUS','OH','43219','8147','CY','39049','2010-09-09','F','U',':RET:2029-7^:RET:2106-3','N','021','DEN','3847136','99734OH005000101','2014-03-01','2014-02-11 09:34:30','0.00',NULL,NULL,'27.59','27.59','R-OH009','OH0','27.59',NULL,0,'2014-02-11 21:02:35'),(22230,17744,'Y','18','021','EC','A','','','AC','0000184881','0000184881','TX00001843216','IL','1','Briseno','Jessica','','','','34','628328393','2101 rio grande',0,'austin','TX','78705',NULL,'CY','48453','1991-12-04','F','U',':RET:2106-3','N','021','DEN','3695621','33348TX002000101','2014-03-01','2014-02-08 22:30:32','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-09 19:00:32'),(13672,10909,'Y','18','021','EC','A','','','AC','0001944616','0001944616','LA00001050285','IL','1','Lane','Betty','','','','34','433807480','1849 Hwy. 5',0,'Grand Cane','LA','71032',NULL,'CY','22031','1950-10-27','F','U',':RET:2054-5','N','021','DEN','2292136','18575LA002000101','2014-01-01','2013-12-23 18:11:17','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2013-12-26 13:07:57'),(20414,16305,'Y','18','024','14','A','','','TE','0000060300','0000060300','','IL','1','Covill','Scott',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-08-05','M','',NULL,NULL,NULL,'','3123212','','2014-01-28','2014-01-28 18:48:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:26'),(13065,10413,'N','01','021','EC','A',NULL,NULL,'','0000629231','0000921903','','IL','1','Paulo','Salome','Daniel','','','34','288136241','3450 Partridge place',0,'Columbus','OH','43231',NULL,'CY','39049','1976-02-05','F','',':RET:2054-5','N','021','DEN','2439429','99734OH005000401','2014-01-01','2013-12-23 09:31:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:51:09'),(18981,15122,'Y','18','021','EC','A','','','AC','0001016881','0001016881','OH00002208338','IL','1','KHAWLI','MIREYA','','','','34','572021213','4507 SHERIDAN ROAD',0,'YOUNGSTOWN','OH','44514',NULL,'CY','39099','1949-10-23','F','U',NULL,'N','021','DEN','2619408','99734OH005000301','2014-03-01','2014-01-17 17:28:18','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-20 08:06:06'),(14339,11439,'Y','18','021','EC','A','','','AC','0000920815','0000920815','OH00001064358','IL','1','Zellmann','Ronald','','','','34','359503846','520 N PHILLIPS RD',0,'HARROD','OH','45850','9448','CY','39003','1956-02-19','M','U',':RET:2106-3','T','021','HLT','2539795','92036OH003001504','2014-02-01','2013-12-26 15:09:54','373.00',NULL,NULL,'644.14','271.14','R-OH002','OH0','644.14',NULL,0,'2013-12-27 02:07:49'),(14642,11686,'Y','18','021','EC','A','','','AC','0000848367','0000848367','TX00001743506','IL','1','Moser','Natalie','','','','34','644149207','1103 MESA VERDE DR',0,'MISSOURI CITY','TX','77489','1504','CY','48157','1974-04-24','F','M',':RET:2106-3','N','021','DEN','2409236','33348TX002000101','2014-02-01','2013-12-27 19:15:53','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,1,'2013-12-29 11:07:28'),(25625,20331,'Y','18','021','EC','A','','','AC','0000650818','0000650818','OH00003052515','IL','1','CHESHIRE','SANDRA','','','','34','292587670','319 MISSISSIPPI ST SE',0,'NORTH CANTON','OH','44720','3607','CY','39151','1958-09-04','F','U',NULL,'N','021','DEN','3747941','99734OH005000301','2014-04-01','2014-02-21 18:29:27','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-02-26 08:30:20'),(26219,20794,'Y','18','021','EC','A','','','AC','0000222168','0000222168','TX00002331404','IL','1','Vogel','Rosemarie','','','','34','101423265','132 BOBWHITE TRL',0,'SEGUIN','TX','78155','9460','CY','48187','1950-07-05','F','U',NULL,'N','021','DEN','2875718','33348TX002000201','2014-04-01','2014-02-26 18:46:30','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-02-28 06:30:56'),(26526,21036,'Y','18','021','EC','A','','','AC','0000476002','0000476002','OH00003193127','IL','1','Stevens','Gregory','Alan','','','34','276646527','276 State Route 196',0,'New Hampshire','OH','45870',NULL,'CY','39011','1960-02-27','M','M',':RET:2106-3','N','021','HLT','3425745','92036OH003001505','2014-03-01','2014-02-28 14:55:37','950.00',NULL,NULL,'1105.52','155.52','R-OH002','OH0','490.70','CIC',0,'2014-02-28 21:00:26'),(28197,22313,'Y','18','024','14','A','','','TE','0000566636','0000566636','','IL','1','REYES','CRISTIANA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-30','F','',NULL,NULL,NULL,'','3345455','','2014-03-31','2014-03-06 11:29:13',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-06 21:30:07'),(28832,22818,'Y','18','021','EC','A','','','AC','0000501999','0000501999','MS00003823674','IL','1','JONES','ANNIE','','','','34','587338815','2855 MARYDALE DR',0,'JACKSON','MS','39212','2733','CY','28049','1970-01-30','F','U',':RET:2054-5','N','021','DEN','3901397','46300MS002000201','2014-04-01','2014-03-09 12:37:44','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-09 21:01:08'),(29146,23072,'Y','18','024','14','A','','','TE','0001071848','0001071848','','IL','1','Burns','Jamour',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-01-28','M','',NULL,NULL,NULL,'','3931954','','2014-03-10','2014-03-10 12:38:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-03-10 21:02:46'),(13662,10900,'Y','18','021','EC','A','','','AC','0001218837','0001218837','LA00000024297','IL','1','Folse','Mark','','','','34','434064028','3036 FORTIN ST',0,'NEW ORLEANS','LA','70119','2806','CY','22071','1957-06-07','M','R',':RET:2106-3','T','021','DEN','1375575','18575LA002000101','2014-01-01','2013-12-23 09:50:46','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:38'),(23436,18669,'Y','18','021','EC','A','','','AC','0000546688','0000546688','TX00002618345','31','1','Chumbley','Michael','','','','34','630077647','3410 98th street',0,'Lubbock','TX','79423',NULL,'CY','48303','1986-02-17','M','U',':RET:2106-3','T','021','DEN','3599645','33348TX002000201','2014-03-01','2014-02-13 10:29:05','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-13 22:01:29'),(23424,18663,'N','01','021','EC','A',NULL,NULL,'','0001197873','0000682714','','IL','1','Lopez','Eleno','','','Jr','34','457923463','216 E OCEAN BLVD',0,'LOS FRESNOS','TX','78566','3227','CY','48061','1952-09-27','M','',':RET:2106-3','N','021','DEN','3566845','33348TX002000201','2014-03-01','2014-02-12 23:25:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:24'),(9405,7461,'Y','18','021','EC','A','','','AC','0000705850','0000705850','TX00000910901','IL','1','COSTLEY','TONI','','','','34','217888175','3604 LITTLELEAF DR',0,'KILLEEN','TX','76549','3185','CY','48027','1971-12-23','F','U',':RET:2054-5','N','021','DEN','2384772','33348TX002000201','2014-01-01','2013-12-21 10:24:17','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-26 04:32:42'),(1398,1161,'Y','18','021','EC','A','','','AC','0002152355','0002152355','LA00001100134','IL','1','vilaysack','toun','','','','34','586565781','2250 turkey creek',0,'glenmora','LA','71433',NULL,'CY','22079','1950-04-02','M','M',':RET:2028-9','N','021','DEN','1836488','18575LA002000201','2014-01-01','2013-12-24 12:19:59','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-25 18:46:32'),(19044,15167,'Y','18','021','EC','A','','','AC','0000148364','0000148364','OH00002013403','IL','1','Clayton','Phillip','','','','34','294806960','5600 West Alexis Road',0,'Sylvania','OH','43560',NULL,'CY','39095','1981-11-30','M','M',':RET:2106-3','N','021','HLT','1817281','92036OH006002601','2014-03-01','2014-01-17 17:19:42','31.00',NULL,NULL,'182.95','151.95','R-OH001','OH0','182.95',NULL,0,'2014-01-20 08:06:39'),(16204,12974,'Y','18','021','EC','A','','','AC','0000820639','0000820639','TX00002204153','IL','1','MATA','LAUREN','','','','34','629099261','1301 STATE ST',0,'SAN ANGELO','TX','76905',NULL,'CY','48451','1989-09-02','F','M',NULL,'N','021','DEN','1755404','33348TX002000201','2014-02-01','2014-01-04 13:07:37','0.00',NULL,NULL,'14.61','14.61','R-TX018','TX0','14.61',NULL,0,'2014-01-05 00:01:13'),(3586,2876,'Y','18','021','EC','A','','','AC','0000176388','0000176388','OH00000205619','IL','1','QUINN','MICHAEL','','','','34','299625941','899 GILCREST LN',0,'CINCINNATI','OH','45238',NULL,'CY','39061','1958-10-10','M','U',':RET:2106-3','N','021','HLT','1895109','92036OH006001201','2014-01-01','2013-12-22 15:32:47','337.00',NULL,NULL,'379.65','42.65','R-OH004','OH0','379.65',NULL,0,'2013-12-25 21:22:51'),(5907,4679,'N','19','021','EC','A',NULL,NULL,'','0000321045','0000464634','','IL','1','Pullalarevu','Arjun','Reddy',NULL,NULL,NULL,NULL,'10820 Kingslake Dr',0,'Cincinnati','OH','45242',NULL,'CY','39061','2013-11-26','M','',':RET:2029-7','N','021','DEN','1698426','99734OH005000301','2014-01-01','2013-12-24 00:42:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:55'),(2135,1753,'Y','18','021','EC','A','','','AC','0000717807','0000717807','OH00000269962','IL','1','Baker','Tamara','Lynn','','','34','300662132','480 Starling Court',0,'Wadsworth','OH','44281',NULL,'CY','39103','1966-05-27','F','U',':RET:2106-3','N','021','DEN','93524','99734OH005000401','2014-01-01','2013-12-10 16:53:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:18:04'),(4160,3313,'N','01','021','EC','A',NULL,NULL,'','0000930898','0001186299','','IL','1','NAKKA','JOSEPHINE','','','','34','273089064','5975 PONDVIEW CT',0,'HILLIARD','OH','43026','7087','CY','39049','1977-06-09','F','',':RET:2029-7','N','021','DEN','1675008','99734OH005000301','2014-01-01','2013-12-17 15:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:48:57'),(4194,3337,'Y','18','021','EC','A','','','AC','0000030526','0000030526','OH00000164215','IL','1','Gerber','Melissa','','','','34','294820573','969 BROOK RD',0,'WADSWORTH','OH','44281','9057','CY','39103','1971-09-30','F','M',':RET:2106-3','N','021','HLT','1768557','52664OH151001304','2014-01-01','2013-12-17 16:30:38','468.00',NULL,NULL,'881.32','413.32','R-OH012','OH0','295.48',NULL,0,'2013-12-25 21:49:44'),(1817,1492,'Y','18','021','EC','A','','','AC','0001152192','0001152192','OH00000506314','IL','1','may','william','','','','34','284902812','11701 ROYALTON RD',0,'NORTH ROYALTON','OH','44133','4210','CY','39035','1987-10-03','M','U',':RET:2106-3','N','021','HLT','1825113','92036OH004000801','2014-01-01','2013-12-24 08:53:53','43.00',NULL,NULL,'192.50','149.50','R-OH011','OH0','192.50',NULL,0,'2013-12-25 18:57:09'),(18567,14807,'Y','18','021','EC','A','','','AC','0000457828','0000457828','OH00002049018','IL','1','KANDIKO','CHARLES','','','','34','295447483','118 WOOLF AVE',0,'AKRON','OH','44312','1577','CY','39153','1952-12-06','M','U',NULL,'N','021','HLT','1808932','52664OH152000901','2014-02-01','2014-01-15 10:07:05','292.00',NULL,NULL,'458.99','166.99','R-OH012','OH0','458.99',NULL,0,'2014-01-16 08:47:02'),(18462,14728,'Y','18','021','EC','A','','','AC','0002046404','0002046404','LA00001740614','IL','1','PLAUCHE','JOHN','','','','34','433960540','2245 COLLEGE DR',0,'BATON ROUGE','LA','70808',NULL,'CY','22033','1956-01-13','M','U',':RET:2106-3','N','021','DEN','2714619','18575LA002000101','2014-02-01','2014-01-15 11:35:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-16 08:46:13'),(3533,2836,'Y','18','021','EC','A','','','AC','0001255271','0001255271','TX00000671283','IL','1','GRAHAM','CHRIS','','','','34','449252686','913 PYEGRAVE PL',0,'AUSTIN','TX','78753','6943','CY','48453','1961-03-21','M','U',NULL,'N','021','DEN','2238057','33348TX002000101','2014-01-01','2013-12-21 23:55:05','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:21:32'),(14400,11483,'Y','18','021','EC','A','','','AC','0001219601','0001219601','OH00000384508','IL','1','Arrone','Vickie','','','','34','294586944','118 S OLD MILL RD',0,'UNION','OH','45322','2954','CY','39113','1961-11-08','F','U',':RET:2054-5','N','021','DEN','2112496','99734OH005000401','2014-02-01','2013-12-27 16:14:07','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-28 03:31:10'),(13616,10857,'Y','18','021','EC','A','','','AC','0000130697','0000130697','OH00000901384','IL','1','Couch','Pam','','','','34','282586336','1621 STAHLHEBER RD',0,'HAMILTON','OH','45013','1919','CY','39017','1954-12-27','F','M',NULL,'N','021','HLT','2205443','92036OH002001201','2014-01-01','2013-12-23 15:21:33','683.00',NULL,NULL,'1357.56','674.56','R-OH004','OH0','645.32',NULL,0,'2013-12-26 13:05:44'),(4239,3376,'Y','18','021','EC','A','','','AC','0000734787','0000734787','TX00000483770','IL','1','Monroe','Glenda','','','','34','455811724','1611 TAYLOR ST',0,'WICHITA FALLS','TX','76309','2361','CY','48485','1987-02-09','F','U',':RET:2106-3','N','021','DEN','2135785','33348TX002000201','2014-01-01','2013-12-17 15:21:08','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2013-12-25 21:50:58'),(4226,3364,'Y','18','021','EC','A','','','AC','0000435679','0000435679','TX00001286875','IL','1','GREEN','KIMBERLY','','','','34','457937363','718 E MARTIN LUTHER KING ST',0,'BRYAN','TX','77803',NULL,'CY','48041','1983-03-17','F','U',':RET:2054-5','N','021','DEN','2253751','33348TX002000201','2014-01-01','2013-12-17 11:16:37','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2013-12-25 21:50:33'),(4937,3918,'Y','18','021','EC','A','','','AC','0001220815','0001220815','OH00000684440','IL','1','Hensley','Alan','James','','','34','234880854','288 E BEECH ST',0,'JEFFERSON','OH','44047','9490','CY','39007','1954-06-02','M','M',':RET:2106-3','N','021','DEN','834401','99734OH005000401','2014-01-01','2013-12-07 13:00:13','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-25 22:45:35'),(24764,19649,'Y','18','021','EC','A','','','AC','0000934709','0000934709','OH00002902512','IL','1','KOMYATI','ANTOINETTE','M','','','34','287642324','1939 GLENWOOD DR',0,'TWINSBURG','OH','44087','1256','CY','39153','1956-11-16','F','M',':RET:2106-3','T','021','DEN','3264613','99734OH005000401','2014-04-01','2014-02-19 11:36:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-20 04:43:23'),(140,119,'Y','18','021','EC','A','','','AC','0001258628','0001258628','OH00000571637','IL','1','Marquette','erik','','','','34','298924483','6633 LAKE O SPRINGS AVE NW',0,'CANTON','OH','44718','1171','CY','39151','1990-12-08','M','U',':RET:2106-3','N','021','HLT','1092980','52664OH152000901','2014-01-01','2013-12-04 23:19:27','163.34',NULL,NULL,'163.34','0.00','R-OH015','OH0','163.34',NULL,0,'2013-12-25 17:18:40'),(24041,19119,'Y','18','021','EC','A','','','AC','0000546512','0000546512','OH00002460419','IL','1','Soutendijk','Diana','','','','34','295581081','3299 State Route 82',0,'Mantua','OH','44255',NULL,'CY','39133','1957-10-01','F','U',NULL,'N','021','DEN','3563135','99734OH005000301','2014-03-01','2014-02-15 10:48:37','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-02-15 22:00:58'),(8868,7031,'Y','18','021','EC','A','','','AC','0000926397','0000926397','TX00000461219','IL','1','NWEKE','HATTIE','D','','','34','449752178','1180 N MASTERS DR',0,'DALLAS','TX','75217','3771','CY','48113','1985-01-05','F','U',':RET:2054-5','T','021','DEN','2069152','33348TX002000201','2014-01-01','2013-12-18 13:19:40','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 04:01:29'),(7356,5825,'N','01','021','EC','A',NULL,NULL,'','0000728636','0000870128','','IL','1','SHIN','YONG','','','','34','460458455','810 KENSINGTON DR',0,'DUNCANVILLE','TX','75137','2118','CY','48113','1950-11-08','M','',':RET:2040-4','N','021','DEN','445497','33348TX002000201','2014-01-01','2013-11-23 12:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:15:15'),(7185,5695,'N','01','021','EC','A',NULL,NULL,'','0000983815','0000650764','','IL','1','abdallah','tahani','a','','','34','140748940','897 DEERHURST DR',0,'VANDALIA','OH','45377','9409','CY','39113','1978-10-24','F','',':RET:2028-9','N','021','DEN','1065162','99734OH005000301','2014-01-01','2013-12-14 11:41:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:00:16'),(989,809,'Y','18','021','EC','A','','','AC','0000841879','0000841879','OH00001067140','IL','1','Perdue','Michael','','','','34','297508418','1814 BOWMAN DR',0,'XENIA','OH','45385','3810','CY','39057','1951-06-07','M','M',':RET:2106-3','T','021','HLT','1233389','92036OH006000501','2014-01-01','2013-10-31 15:24:14','0.00',NULL,NULL,'622.85','622.85','R-OH003','OH0','622.85',NULL,0,'2013-12-25 18:10:33'),(4381,3482,'Y','18','021','EC','A','','','AC','0000633720','0000633720','OH00001075856','IL','1','KIPKER','DENISE','','','','34','286520415','10753 STATE ROUTE 274',0,'LEWISTOWN','OH','43333','9705','CY','39091','1954-10-25','F','M',':RET:2106-3','N','021','DEN','819597','99734OH005000401','2014-01-01','2013-12-12 09:26:00','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 22:00:37'),(18949,15098,'Y','18','021','EC','A','','','AC','0000573844','0000573844','TX00001768020','IL','1','KELLY','SHANDRA','C','','','34','657288233','3727 W PIONEER DR',0,'IRVING','TX','75061','8270','CY','48113','1968-04-05','F','U',':RET:2054-5','N','021','DEN','1677673','33348TX002000201','2014-03-01','2014-01-17 13:47:20','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-20 08:05:47'),(1042,855,'Y','18','021','EC','A','','','AC','0000811860','0000811860','TX00000248074','IL','1','KOPYCINSKI','MIKE','','','','34','454130257','8323 VALLEY DRIVE',0,'CHAPPELL HILL','TX','77426',NULL,'CY','48477','1956-03-09','M','M',':RET:2106-3','N','021','DEN','47773','33348TX002000201','2014-01-01','2013-12-03 11:44:13','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:15:48'),(18481,14742,'N','19','021','EC','A',NULL,NULL,'','0000793489','0000499328','','IL','1','Ziss','Sydney','Anne','','','34','288044006','4076 KINGSBURY BLVD',0,'COPLEY','OH','44321','2841','CY','39153','1999-10-23','F','',NULL,'N','021','HLT','2557525','52664OH151001301','2014-02-01','2014-01-14 21:44:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-16 08:46:21'),(14137,11269,'Y','18','021','EC','A','','','AC','0002008003','0002008003','LA00001463076','IL','1','Jalili','Mohammad','','','','34','843135189','1803 Martin Luther King BLVD',0,'Houma','LA','70360',NULL,'CY','22109','1949-03-23','M','M',':RET:2029-7','N','021','DEN','2349335','18575LA002000201','2014-02-01','2013-12-26 11:50:11','0.00',NULL,NULL,'29.22','29.22','R-LA002','LA0','14.61',NULL,0,'2013-12-27 02:02:33'),(17552,14033,'Y','18','021','EC','A','','','AC','0000464774','0000464774','MS00001810968','IL','1','gray','rhonda','','','','34','428119329','5504 HIGHWAY 311',0,'HOLLY SPRINGS','MS','38635','9509','CY','28093','1962-12-28','F','U',':RET:2106-3','N','021','DEN','1970247','46300MS002000101','2014-02-01','2014-01-12 14:03:13','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-01-13 03:01:54'),(22156,17684,'N','19','021','EC','A',NULL,NULL,'','0000237617','0000627916','','IL','1','Kuhn','Jonathan','','','','34','294089153','838 OLD MILL DR',0,'LOVELAND','OH','45140','8077','CY','39025','2004-03-01','M','',':RET:2106-3','N','021','HLT','3338375','92036OH004000601','2014-03-01','2014-02-08 10:32:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-08 19:00:56'),(15471,12379,'Y','18','021','EC','A','','','AC','0000910534','0000910534','OH00000216893','IL','1','DEVORE','DREW','','','','34','272902005','1914 MOUNT VERNON BLVD NW',0,'CANTON','OH','44709','2721','CY','39151','1985-09-20','M','M',NULL,'N','021','DEN','1454396','99734OH005000401','2014-02-01','2013-12-30 19:18:46','0.00',NULL,NULL,'71.95','71.95','R-OH015','OH0','0.00',NULL,1,'2014-01-02 04:28:55'),(21681,17314,'Y','18','021','EC','A','','','AC','0000558184','0000558184','OH00001783499','IL','1','Norris','Samantha','','','','34','159621454','497 old boston road',0,'Batavia','OH','45103',NULL,'CY','39025','1975-11-19','F','U',NULL,'N','021','HLT','2971797','92036OH004000601','2014-03-01','2014-02-05 13:23:55','188.00',NULL,NULL,'215.09','27.09','R-OH005','OH0','215.09',NULL,0,'2014-02-05 21:31:02'),(25904,20539,'Y','18','021','EC','A','','','AC','0000713966','0000713966','TX00002439167','IL','1','dunn','jeremiah','','','','34','450917559','210 BEAVER LOOP',0,'TEMPLE','TX','76502','6331','CY','48027','1974-11-02','M','U',':RET:2106-3','N','021','DEN','3684735','33348TX002000201','2014-04-01','2014-02-26 13:45:52','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-26 21:01:10'),(9155,7262,'Y','18','021','EC','A','','','AC','0000289515','0000289515','OH00000226894','IL','1','Forman Fall','Jody','','','','34','291524752','6750 Weathered Oaks Court',0,'Hamilton','OH','45011',NULL,'CY','39017','1952-07-26','F','M',':RET:2106-3','N','021','HLT','2093378','92036OH006001201','2014-01-01','2013-12-17 21:38:37','222.00',NULL,NULL,'478.41','256.41','R-OH004','OH0','478.41',NULL,0,'2013-12-26 04:08:33'),(7215,5719,'Y','18','021','EC','A','','','AC','0000904246','0000904246','OH00000923618','IL','1','Davis','Bruce','','','','34','276525355','19916 SR 136',0,'WINCHESTER','OH','45697','0427','CY','39001','1952-07-03','M','M',':RET:2106-3','T','021','DEN','1062345','99734OH005000401','2014-01-01','2013-12-14 11:51:08','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 02:01:01'),(18327,14633,'Y','18','021','EC','A','','','AC','0001118743','0001118743','OH00002200980','IL','1','moore','scott','','','','34','356524973','1422 som center road',0,'mayfield heights','OH','44124',NULL,'CY','39035','1956-10-13','M','U',':RET:2106-3','N','021','DEN','2755677','99734OH005000401','2014-02-01','2014-01-15 13:34:49','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-16 08:45:10'),(24470,19438,'N','01','021','EC','A',NULL,NULL,'','0000653250','0000841970','','IL','1','ST GERMAIN','MICHAEL','','','','34','279461753','1822 JERMAIN DR',0,'TOLEDO','OH','43606','4038','CY','39095','1949-05-23','M','',':RET:2106-3','N','021','HLT','3512669','92036OH004002601','2014-04-01','2014-02-18 12:21:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','470.37',NULL,0,'2014-02-18 22:01:38'),(17865,14271,'N','01','021','EC','A',NULL,NULL,'','0000781921','0000809693','','IL','1','Brooks','Linda','','','','34','282544151','2954 COUNTRY CLUB LN',0,'TWINSBURG','OH','44087','2949','CY','39153','1953-11-25','F','',NULL,'N','021','DEN','2070142','99734OH005000401','2014-02-01','2014-01-14 11:47:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:12'),(6904,5478,'Y','18','021','EC','A','','','AC','0001403846','0001403846','LA00000119402','IL','1','Barnes','Juan','','','','34','436658494','8010 Sandpiper Dr.',0,'New Orleans','LA','70128',NULL,'CY','22071','1986-02-22','M','U',':RET:2054-5','N','021','DEN','1380888','18575LA002000201','2014-01-01','2013-12-24 23:27:09','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 01:45:43'),(17155,13726,'Y','18','021','EC','A','','','AC','0001968357','0001968357','LA00001610403','IL','1','goldberg','annette','','','','34','457884833','12575 mansfield road',0,'keithville','LA','71047',NULL,'CY','22017','1949-09-30','F','U',':RET:2106-3','T','021','DEN','2172131','18575LA002000201','2014-02-01','2014-01-08 08:36:17','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-13 02:21:58'),(16198,12968,'Y','18','021','EC','A','','','AC','0000269059','0000269059','TX00001627694','IL','1','Fadojutimi','Joycelyne','A','','','34','463574726','888 Garden Drive',0,'Longview','TX','75603',NULL,'CY','48183','1955-08-01','F','M',':RET:2054-5','N','021','DEN','1363006','33348TX002000201','2014-02-01','2014-01-04 12:47:23','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2014-01-05 00:01:03'),(6547,5191,'Y','18','021','EC','A','','','AC','0000156343','0000156343','TX00000342801','IL','1','Edler','Paula','','','','34','643091084','4122 N BRAESWOOD BLVD',0,'HOUSTON','TX','77025','2906','CY','48201','1987-11-27','F','U',':RET:2106-3','N','021','DEN','533598','33348TX002000201','2014-01-01','2013-12-11 11:34:35','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 00:52:04'),(25740,20415,'N','01','021','EC','A',NULL,NULL,'','0001033720','0000117846','','IL','1','WILLSON','DEMETRIUS','','','','34','270727367','38718 AVENEL CT',0,'WILLOUGHBY','OH','44094','8068','CY','39085','1974-08-31','M','',':RET:2054-5','N','021','DEN','2970780','99734OH005000401','2014-04-01','2014-02-24 11:43:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:39'),(4521,3582,'N','01','021','EC','A',NULL,NULL,'','0001096597','0000858179','','IL','1','Courtney','Thomas','J','','','34','484840719','1212 Brook Drive',0,'Allen','TX','75002',NULL,'CY','48085','1958-07-01','M','',':RET:2106-3','N','021','DEN','294001','33348TX002000201','2014-01-01','2013-12-12 12:36:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 22:03:50'),(14623,11672,'Y','18','021','EC','A','','','AC','0000276281','0000276281','OH00001502429','IL','1','Francis','Terri','','','','34','286621924','1318 EXCHANGE RD S',0,'NEW LONDON','OH','44851','9351','CY','39077','1958-04-20','F','M',':RET:2106-3','T','021','HLT','1935445','92036OH006002701','2014-02-01','2013-12-27 10:50:48','682.00',NULL,NULL,'840.87','158.87','R-OH006','OH0','396.58',NULL,0,'2013-12-28 03:36:59'),(16696,13361,'N','01','021','EC','A',NULL,NULL,'','0000685455','0000897635','','IL','1','CAMPOS-RODRIGUEZ','PEDRO','ANTONIO','','','34','631115053','1103 E VALLE VISTA AVE',0,'PHARR','TX','78577',NULL,'CY','48215','1951-01-31','M','',NULL,'N','021','DEN','2489619','33348TX002000201','2014-02-01','2014-01-07 14:07:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-08 18:24:37'),(23704,18875,'Y','18','021','EC','A','','','AC','0000231548','0000231548','OH00001600635','IL','1','KIM','JIN','','','','34','381133529','5656 E FOUNTAIN CIR',0,'MASON','OH','45040','7310','CY','39165','1966-08-09','M','M',':RET:2040-4','N','021','DEN','2796352','99734OH005000401','2014-03-01','2014-02-14 12:16:29','0.00',NULL,NULL,'71.95','71.95','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:44'),(23553,18764,'Y','18','021','EC','A','','','AC','0000371521','0000371521','OH00001695905','IL','1','vantilburg','denise','','','','34','290686516','1410 NEIL AVE',0,'SAINT MARYS','OH','45885','1457','CY','39011','1975-02-06','F','U',':RET:2106-3','T','021','HLT','3652957','92036OH005001506','2014-03-01','2014-02-13 11:16:23','140.00',NULL,NULL,'319.40','179.40','R-OH002','OH0','319.40',NULL,0,'2014-02-13 22:02:39'),(23402,18645,'N','19','021','EC','A',NULL,NULL,'','0000546511','0000797003','','IL','1','Johnson','Alexandria','','','','34','275986622','5990 MARATHON EDENTON RD',0,'BLANCHESTER','OH','45107','8355','CY','39025','1994-12-08','F','',NULL,'N','021','DEN','3723875','99734OH005000401','2014-03-01','2014-02-13 15:56:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-13 22:01:10'),(17111,13694,'Y','18','021','EC','A','','','AC','0000824597','0000824597','OH00002369265','IL','1','Ranford','Kelvin','Armon','','','34','280849906','34 HORIZON CT',0,'FAIRFIELD','OH','45014','4908','CY','39017','1985-09-14','M','U',':RET:2054-5','N','021','DEN','1681666','99734OH005000401','2014-02-01','2014-01-07 19:18:14','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 02:21:37'),(21169,16917,'Y','18','021','EC','A','','','AC','0001204570','0001204570','OH00002004041','IL','1','Kytta','Allison','','','','34','274906141','1418 W 45TH ST',0,'CLEVELAND','OH','44102','3402','CY','39035','1988-01-10','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','3683041','99734OH005000401','2014-03-01','2014-02-03 12:49:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:37'),(20973,16759,'Y','18','021','EC','A','','','AC','0000164892','0000164892','MS00002599453','IL','1','Conville','Richard','','','','34','033487846','205 SOUTHAMPTON RD',0,'HATTIESBURG','MS','39401','7070','CY','28035','1972-06-21','M','U',':RET:2106-3','T','021','DEN','2901893','46300MS002000101','2014-03-01','2014-01-31 18:41:22','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-01 19:00:16'),(25540,20261,'Y','18','021','EC','A','','','AC','0000345641','0000345641','OH00002514321','IL','1','colson','laura',NULL,NULL,NULL,NULL,NULL,'3641 w 139',0,'cleveland','OH','44111',NULL,'CY','39035','1971-04-25','F','U',':RET:2054-5','N','021','DEN','3599885','99734OH005000301','2014-04-01','2014-02-23 13:35:41','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-26 08:00:10'),(26471,20997,'N','01','021','EC','A',NULL,NULL,'','0002042484','0001571199','','IL','1','pardillo','vanessa','','','','34','770148608','11715 Glenda dr',0,'Baton Rouge','LA','70815',NULL,'CY','22033','1985-03-14','F','',':RET:2106-3','N','021','DEN','3425712','18575LA002000101','2014-04-01','2014-02-27 14:36:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02','CIC',0,'2014-02-28 07:30:37'),(27432,21711,'Y','18','021','EC','A','','','AC','0001997237','0001997237','LA00002637131','IL','1','GRIER','ASHLEY','','','','34','452719638','3027 GEORGE JOHNIKINS RD',0,'SPEARSVILLE','LA','71277','2263','CY','22111','1983-07-28','F','M',':RET:2106-3','N','021','DEN','3497657','18575LA002000201','2014-04-01','2014-03-04 13:19:17','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,0,'2014-03-04 21:01:47'),(2788,2253,'Y','18','021','EC','A','','','AC','0000352800','0000352800','OH00001307091','IL','1','Nunemaker','Jane','','','','34','268525324','4931 Hunters green drive',0,'Toledo','OH','43623',NULL,'CY','39095','1952-08-19','F','M',':RET:2106-3','N','021','HLT','1083773','92036OH004002601','2014-01-01','2013-12-02 16:34:06','316.00',NULL,NULL,'440.60','124.60','R-OH001','OH0','440.60',NULL,0,'2013-12-25 19:50:02'),(7929,6270,'Y','18','021','EC','A','','','AC','0001427504','0001427504','LA00001142369','IL','1','Guilbeau','Charles','','','','34','435868780','13431 DEWEY BREAUX RD',0,'GONZALES','LA','70737','6851','CY','22005','1954-10-08','M','U',':RET:2106-3','T','021','DEN','1568335','18575LA002000201','2014-01-01','2013-12-20 09:21:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 03:06:33'),(7476,5915,'N','01','021','EC','A',NULL,NULL,'','0000279532','0000281992','','IL','1','Hattar','Barbara',NULL,NULL,NULL,NULL,NULL,'3906 JEFFERSON LN',0,'AMELIA','OH','45102','1180','CY','39025','1982-04-28','F','',NULL,'N','021','DEN','235962','99734OH005000401','2014-01-01','2013-12-15 09:24:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:17'),(7206,5710,'Y','18','021','EC','A','','','AC','0000224708','0000224708','OH00000748822','IL','1','McCarty','James','','','','34','280506066','1074 EVERETT HULL RD',0,'CORTLAND','OH','44410','9552','CY','39155','1950-10-09','M','M',':RET:2106-3','N','021','DEN','220313','99734OH005000401','2014-01-01','2013-12-13 20:53:20','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 02:00:47'),(5176,4107,'Y','18','021','EC','A','','','AC','0000042048','0000042048','OH00000660845','IL','1','BOSO','LARRY','','','','34','301586645','19916 Echo Dr',0,'Strongsville','OH','44149',NULL,'CY','39035','1955-08-24','M','M',':RET:2106-3','N','021','DEN','1894923','99734OH005000401','2014-01-01','2013-12-19 12:30:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:03:26'),(14448,11525,'Y','18','021','EC','A','','','AC','0001894135','0001894135','LA00000010439','IL','1','PAIGE','ASHLEY','','','','34','435550408','1044 MONTERREY BLVD',0,'BATON ROUGE','LA','70815','1038','CY','22033','1984-02-23','F','U',NULL,'N','021','DEN','2238407','18575LA002000201','2014-02-01','2013-12-27 12:50:13','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-28 03:32:25'),(15935,12758,'Y','18','021','EC','A','','','AC','0000501628','0000501628','OH00000096100','IL','1','Humm','Dennis','','','','34','316500533','7316 WITHERBY CT',0,'HOLLAND','OH','43528','7720','CY','39095','1952-07-28','M','U',':RET:2106-3','N','021','HLT','1729370','92036OH005002605','2014-02-01','2014-01-02 13:19:20','450.00',NULL,NULL,'547.95','97.95','R-OH001','OH0','547.95',NULL,0,'2014-01-03 02:07:01'),(16061,12862,'Y','18','021','EC','A','','','AC','0000481089','0000481089','OH00001600972','IL','1','Vetturini','linda','','','','34','289783951','8118 WILSON MILLS RD',0,'CHESTERLAND','OH','44026','1854','CY','39055','1966-12-04','F','U',NULL,'N','021','DEN','2576544','99734OH005000401','2014-02-01','2014-01-03 10:19:20','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-04 02:03:30'),(23746,18906,'N','19','021','EC','A',NULL,NULL,'','0000137619','0000708988','','IL','1','MIDAMBA','WALTER','','','','34','288080113','3909 PINE CREST DRIVE',0,'BEACHWOOD','OH','44122',NULL,'CY','39035','2003-09-04','M','',':RET:2054-5','N','021','DEN','2972052','99734OH005000301','2014-03-01','2014-02-14 05:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:06'),(23715,18882,'N','01','021','EC','A',NULL,NULL,'','0000352885','0000830684','','IL','1','YOUNG','GARY','','','','34','293500169','1125 WOODLAND AVE SE',0,'MASSILLON','OH','44646','8161','CY','39151','1950-10-16','M','',NULL,'N','021','DEN','2978970','99734OH005000401','2014-03-01','2014-02-14 16:22:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:30:49'),(22961,18306,'Y','18','021','EC','A','','','AC','0001044259','0001044259','TX00002523445','IL','1','MATHIS','PATRICIA','','','','34','449961155','455 LANGE LAKE RD',0,'BRENHAM','TX','77833','8513','CY','48477','1951-07-27','F','M',NULL,'N','021','DEN','2983713','33348TX002000201','2014-03-01','2014-02-12 16:06:44','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-12 21:00:08'),(22013,17574,'Y','18','021','EC','A','','','AC','0000371517','0000371517','OH00002264081','IL','1','Nichols','Angela','','','','34','293927488','4976 TAMARACK BLVD',0,'COLUMBUS','OH','43229','5241','CY','39049','1987-09-16','F','U',':RET:2106-3','N','021','DEN','3245148','99734OH005000301','2014-03-01','2014-02-07 15:56:29','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-02-07 19:00:53'),(19797,15783,'Y','18','021','EC','A','','','AC','0000696865','0000696865','MS00001927377','IL','1','Wooley','Judy','','','','34','439923941','3507 WHEATLEY ST',0,'JACKSON','MS','39212','4714','CY','28049','1955-03-14','F','U',NULL,'N','021','DEN','2953695','46300MS002000201','2014-03-01','2014-01-23 12:00:58','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-23 21:01:46'),(17707,14150,'Y','18','021','EC','A','','','AC','0002364097','0002364097','LA00002018957','IL','1','Lange','Valerie','','','','34','439827170','33239 BAYOU PAQUET RD',0,'SLIDELL','LA','70460','3267','CY','22103','1951-05-26','F','U',NULL,'N','021','DEN','2670992','18575LA002000201','2014-02-01','2014-01-13 14:46:55','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-14 01:33:07'),(16842,13473,'Y','18','021','EC','A','','','AC','0000745457','0000745457','OH00002030722','IL','1','mckeown','maxine','','','','34','294562579','103 EMMONS AVE',0,'AKRON','OH','44312','1340','CY','39153','1954-12-15','F','U',NULL,'N','021','HLT','2088905','52664OH151001304','2014-02-01','2014-01-11 18:07:00','357.00',NULL,NULL,'580.49','223.49','R-OH012','OH0','580.49',NULL,0,'2014-01-13 02:18:34'),(9324,7391,'Y','18','021','EC','A','','','AC','0001172220','0001172220','LA00001320236','IL','1','Semien','Shelly','','','','34','439690274','105 FEATHER TAIL CV',0,'CARENCRO','LA','70520','5861','CY','22055','1985-10-30','F','U',NULL,'N','021','DEN','1924964','18575LA002000101','2014-01-01','2013-12-21 14:18:04','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-26 04:30:34'),(25560,20276,'N','19','021','EC','A',NULL,NULL,'','0000929892','0001074197','','IL','1','Dunning','Lillian',NULL,NULL,NULL,NULL,NULL,'207 INWOOD RD',0,'WILMINGTON','OH','45177','8355','CY','39027','1999-03-05','F','',NULL,'N','021','HLT','2937340','92036OH004000601','2014-04-01','2014-02-23 13:40:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-26 08:00:22'),(25198,19989,'Y','18','021','EC','A','','','AC','0001939797','0001939797','LA00001980993','IL','1','Lambert','Brandi','Michelle','','','34','437495945','65347 WD WALKER RD',0,'KENTWOOD','LA','70444','6217','CY','22105','1982-05-03','F','U',':RET:2106-3','N','021','DEN','3668173','18575LA002000201','2014-04-01','2014-02-21 12:21:38','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-21 22:00:44'),(23173,18475,'Y','18','021','EC','A','','','AC','0000876105','0000876105','OH00002122482','IL','1','Morris','Paul','','','','34','282806696','1050 Cooks Crossing Dr',0,'Milford','OH','45150',NULL,'CY','39025','1971-02-02','M','M',':RET:2106-3','N','021','HLT','3748993','92036OH003000605','2014-03-01','2014-02-12 15:54:31','93.00',NULL,NULL,'304.21','211.21','R-OH005','OH0','304.21',NULL,0,'2014-02-12 21:31:54'),(4423,3514,'Y','18','024','14','A','','','TE','0000680814','0000680814','','IL','1','Shafitz','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-08-25','M','',NULL,NULL,NULL,'','24288','','2013-12-12','2013-12-12 16:37:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:01:39'),(21450,17143,'Y','18','021','EC','A','','','AC','0000899601','0000899601','OH00001769775','IL','1','ROSE','LASHON','','','','34','293703109','906 MCKINLEY AVE',0,'AKRON','OH','44306','1908','CY','39153','1969-07-23','F','M',NULL,'N','021','HLT','3783691','52664OH151001301','2014-03-01','2014-02-04 09:51:40','0.00',NULL,NULL,'639.29','639.29','R-OH012','OH0','311.54',NULL,0,'2014-02-04 21:01:28'),(20549,16421,'N','01','021','EC','A',NULL,NULL,'','0001166846','0000810818','','IL','1','Rodriguez','Sifredo','C','','','34','594496472','4494 TYLERSVILLE RD',0,'WEST CHESTER','OH','45011','8635','CY','39017','1968-01-13','M','',':RET:2106-3','N','021','HLT','3594492','92036OH005001201','2014-03-01','2014-01-29 17:06:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','322.00',NULL,0,'2014-01-29 21:01:40'),(1807,1485,'Y','18','021','EC','A','','','AC','0001111667','0001111667','OH00000537198','IL','1','Hillery','George','','','','34','384709925','1346 Weathervane LN',0,'Akron','OH','44313',NULL,'CY','39153','1971-05-16','M','U',':RET:2054-5','T','021','HLT','1911805','52664OH151001501','2014-01-01','2013-12-24 08:48:28','0.00',NULL,NULL,'407.55','407.55','R-OH012','OH0','407.55',NULL,0,'2013-12-25 18:56:56'),(19322,15403,'Y','18','021','EC','A','','','AC','0001206092','0001206092','TX00001729354','IL','1','MERAZ','LOURDES','','','','34','466376622','3215 TULAROSA AVE',0,'EL PASO','TX','79903','4205','CY','48141','1961-02-17','F','U',NULL,'N','021','DEN','1796545','33348TX002000201','2014-03-01','2014-01-21 11:51:42','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2014-01-22 03:22:12'),(14430,11508,'Y','18','021','EC','A','','','AC','0001266152','0001266152','LA00000652341','IL','1','Sarmento','jonathon','','','','34','556951358','11843 morgan hill ct',0,'baton rouge','LA','70818',NULL,'CY','22033','1980-11-24','M','U',':RET:2106-3','N','021','DEN','1594942','18575LA002000201','2014-02-01','2013-12-26 19:19:58','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-28 03:31:55'),(16258,13016,'Y','18','021','EC','A','','','AC','0000478179','0000478179','MS00001433439','IL','1','davis','shuan','','','','34','425235599','4400 ely avenue',0,'moss point','MS','39563',NULL,'CY','28059','1973-11-30','M','U',':RET:2054-5','N','021','DEN','2457509','46300MS002000201','2014-02-01','2014-01-04 13:44:13','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-05 00:02:49'),(16413,13135,'Y','18','021','EC','A','','','AC','0000183390','0000183390','TX00001427486','31','1','Nugent','Jennifer','','','','34','454041169','P.O. Box 4785',0,'Victoria','TX','77903',NULL,'CY','48469','1969-09-25','F','U',':RET:2106-3','N','021','DEN','2501273','33348TX002000201','2014-02-01','2014-01-06 17:51:29','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-07 04:04:16'),(25898,20534,'Y','18','021','EC','A','','','AC','0000530827','0000530827','TX00002735318','IL','1','Banks','Ruby','','','','34','464840714','3205 CARTER BLVD E',0,'TYLER','TX','75702','1116','CY','48423','1950-08-02','F','U',NULL,'N','021','DEN','3498639','33348TX002000201','2014-04-01','2014-02-26 13:05:39','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61',NULL,0,'2014-02-26 21:01:06'),(26031,20645,'Y','18','024','14','A','','','TE','0000679586','0000679586','','IL','1','barnett','randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-05-20','M','',NULL,NULL,NULL,'','2871815','','2014-02-26','2014-02-26 14:29:09',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-02-26 21:02:21'),(26356,20908,'Y','18','021','EC','A','','','AC','0001236644','0001236644','OH00003358463','IL','1','Yi','Yeo San','','','','34','273764866','3421 WOODSIDE DR',0,'FAIRFIELD','OH','45014','5071','CY','39017','1956-07-06','F','M',':RET:2040-4','N','021','HLT','3768042','92036OH002001201','2014-04-01','2014-02-27 16:49:00','83.00',NULL,NULL,'604.16','521.16','R-OH004','OH0','604.16',NULL,0,'2014-02-28 06:31:49'),(26543,21047,'Y','18','021','EC','A','','','AC','0001121453','0001121453','OH00003111361','IL','1','POKORNY','SYNTHIA','ELLEN','','','34','300660598','11430 WOODIEBROOK RD',0,'CHARDON','OH','44024','8496','CY','39055','1959-08-04','F','M',NULL,'N','021','DEN','2898781','99734OH005000301','2014-03-01','2014-02-28 12:20:43','0.00',NULL,NULL,'59.76','59.76','R-OH011','OH0','0.00',NULL,0,'2014-02-28 21:30:09'),(28191,22308,'Y','18','024','14','A','','','TE','0001059944','0001059944','','IL','1','Nguyen','Kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-08-06','M','',NULL,NULL,NULL,'','2886948','','2014-03-31','2014-03-05 19:08:18',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-06 21:30:04'),(28581,22619,'Y','18','021','EC','A','','','AC','0001100653','0001100653','OH00003069509','IL','1','Lewis','Kathleen','Ann','','','34','302501326','789 WISBEY RD',0,'BLANCHESTER','OH','45107','9788','CY','39027','1953-05-30','F','M',':RET:2106-3','N','021','HLT','4205570','92036OH003000601','2014-05-01','2014-03-08 13:35:47','0.00',NULL,NULL,'608.42','608.42','R-OH005','OH0','608.42','CIC',0,'2014-03-08 21:00:07'),(5940,4704,'Y','18','021','EC','A','','','AC','0001248002','0001248002','LA00000609497','IL','1','Nettles','Danielle','','','','34','376117679','4916 LOYOLA AVE',0,'NEW ORLEANS','LA','70115','5602','CY','22071','1982-04-12','F','M',':RET:2106-3','N','021','DEN','2183418','18575LA002000101','2014-01-01','2013-12-23 23:57:18','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:50:46'),(22742,18156,'N','01','021','EC','A',NULL,NULL,'','0002358383','0001512639','','IL','1','WILSON','KIM','ELIZABETH','','','34','438117519','1715 DEBORAH DR',0,'SAINT BERNARD','LA','70085','4811','CY','22087','1957-03-03','F','',':RET:2106-3','N','021','DEN','3806865','18575LA002000201','2014-03-01','2014-02-11 17:14:02',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:20'),(20627,16482,'Y','18','021','EC','A','','','AC','0000638660','0000638660','TX00002003949','IL','1','RIVERA','ANNETE','','','','34','465593968','305 PALM ST',0,'CARRIZO SPRINGS','TX','78834','2009','CY','48127','1978-07-29','F','U',NULL,'N','021','DEN','2649698','33348TX002000201','2014-03-01','2014-01-29 19:27:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-30 21:00:26'),(19979,15936,'Y','18','021','EC','A','','','AC','0001012956','0001012956','OH00002284133','31','1','REEDY','TRACY','M','','','34','299681507','PO BOX 23',0,'LAKEMORE','OH','44250',NULL,'CY','39153','1961-10-21','F','U',':RET:2106-3','T','021','DEN','2147957','99734OH005000401','2014-03-01','2014-01-25 11:57:03','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-25 19:00:15'),(5993,4745,'Y','18','021','EC','A','','','AC','0001042259','0001042259','OH00001236380','IL','1','Lindelof','Kara','Louisa','','','34','027644543','2404 COUNTRY SQUIRE LN',0,'TOLEDO','OH','43615','2735','CY','39095','1983-06-18','F','U',':RET:2106-3','N','021','HLT','609203','92036OH004002601','2014-01-01','2013-12-01 09:37:38','0.00',NULL,NULL,'177.96','177.96','R-OH001','OH0','177.96',NULL,0,'2013-12-26 00:00:07'),(14718,11751,'Y','18','021','EC','A','','','AC','0000986016','0000986016','OH00000095984','IL','1','brown','joyce','','','','34','268608451','1750 baker rd',0,'springfield','OH','45504',NULL,'CY','39023','1958-02-12','F','U',':RET:2106-3','N','021','HLT','1939472','92036OH006000501','2014-02-01','2013-12-28 12:12:31','318.00',NULL,NULL,'420.39','102.39','R-OH003','OH0','420.39',NULL,1,'2013-12-29 11:09:29'),(14147,11276,'Y','18','021','EC','A','','','AC','0001630023','0001630023','LA00000827189','IL','1','Powell','Glenda','','','','34','436194856','207 GRANT DR',0,'MONROE','LA','71203','6832','CY','22073','1963-09-21','F','U',':RET:2054-5','N','021','DEN','1373359','18575LA002000201','2014-02-01','2013-12-26 12:50:49','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-27 02:02:47'),(1032,846,'Y','18','024','14','A','','','TE','0000361659','0000361659','','IL','1','Kay','Richard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-04-04','M','',NULL,NULL,NULL,'','667458','','2013-12-03','2013-12-03 13:00:01',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 18:15:32'),(5085,4030,'Y','18','021','EC','A','','','AC','0000830375','0000830375','TX00000099790','IL','1','VASQUES','TOMMIE','','','','34','456782774','6212 21ST ST',0,'LUBBOCK','TX','79407','1412','CY','48303','1949-09-22','F','U',':RET:2106-3','N','021','DEN','2483193','33348TX002000201','2014-01-01','2013-12-19 14:29:48','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-25 23:01:02'),(6863,5442,'Y','18','021','EC','A','','','AC','0000092463','0000092463','OH00000264273','IL','1','Bracken','Jennifer','','','','34','193620839','76 LAKEVIEW RD',0,'NILES','OH','44446','2102','CY','39155','1981-09-09','F','U',NULL,'N','021','DEN','830475','99734OH005000401','2014-01-01','2013-10-05 17:31:13','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 01:31:43'),(18183,14517,'N','01','021','EC','A',NULL,NULL,'','0000864841','0001186338','','IL','1','Pliska','Shelley','','','','34','281501051','913 SUPERIOR ST',0,'GENOA','OH','43430','1532','CY','39123','1961-01-09','F','',':RET:2106-3','N','021','HLT','2711115','92036OH003002705','2014-02-01','2014-01-14 10:44:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.41',NULL,0,'2014-01-15 02:08:01'),(18551,14794,'Y','18','021','EC','A','','','AC','0000664310','0000664310','MS00001421942','IL','1','MOORE','NORA','','','','34','425069458','512 S LANE RD',0,'MOUND BAYOU','MS','38762','9583','CY','28011','1957-03-18','F','U',NULL,'N','021','DEN','2994397','46300MS002000101','2014-02-01','2014-01-15 15:51:30','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-16 08:46:54'),(26070,20674,'Y','18','021','EC','A','','','AC','0000872104','0000872104','OH00003269892','IL','1','HUBSON','CHARLES','BURNELL','','III','34','287764746','6716 DOON AVE',0,'CINCINNATI','OH','45213',NULL,'CY','39061','1968-07-08','M','U',':RET:2054-5','T','021','HLT','3569713','92036OH006001201','2014-04-01','2014-02-26 16:00:34','0.00',NULL,NULL,'282.72','282.72','R-OH004','OH0','282.72',NULL,0,'2014-02-26 21:02:44'),(28271,22372,'Y','18','021','EC','A','','','AC','0001009017','0001009017','TX00002847646','IL','1','NEWSOME','TOSHIA','','','','34','452910721','1308 PATSYS GLEN',0,'BRYAN','TX','77803',NULL,'CY','48041','1977-04-08','F','U',':RET:2054-5','N','021','DEN','2963529','33348TX002000201','2014-04-01','2014-03-07 12:09:02','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61','CIC',0,'2014-03-07 21:00:21'),(1085,891,'Y','18','021','EC','A','','','AC','0000183463','0000183463','OH00000870054','IL','1','Dean','Jeffrey','','','','34','268684769','8 SPRING LAKE BLVD',0,'PAINESVILLE','OH','44077','4994','CY','39085','1963-12-19','M','U',':RET:2106-3','T','021','DEN','447975','99734OH005000401','2014-01-01','2013-12-03 13:15:54','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:16:52'),(9049,7178,'Y','18','024','14','A','','','TE','0000089799','0000089799','','IL','1','Duncan','Erik',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-09-03','M','',NULL,NULL,NULL,'','601127','','2013-12-18','2013-12-18 17:40:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:05:58'),(3775,3023,'Y','18','024','14','A','','','TE','0000120057','0000120057','','IL','1','Jacob','Karen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-06','F','',NULL,NULL,NULL,'','1103784','','2013-12-13','2013-12-13 16:18:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:33:49'),(24710,19619,'Y','18','021','EC','A','','','AC','0000172464','0000172464','OH00003048651','S1','1','tucker','christopher','','','','34','295117035','6255 AVEBURY CT',0,'MORROW','OH','45152','7908','CY','39165','2006-02-14','M','U',':RET:2106-3','N','021','DEN','3785204','99734OH005000401','2014-04-01','2014-02-18 22:31:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2014-02-20 04:35:48'),(5602,4445,'Y','18','021','EC','A','','','AC','0001066946','0001066946','OH00000425144','IL','1','Hanna','Murad','','','','34','791044628','31565 WOODBRIDGE WAY',0,'AVON LAKE','OH','44012','4037','CY','39093','1984-01-01','M','U',':RET:2106-3','N','021','DEN','44965','99734OH005000401','2014-01-01','2013-11-25 18:41:12','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:30:16'),(23982,19068,'Y','18','024','14','A','','','TE','0002189757','0002189757','','IL','1','Butters','Gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-02-28','M','',NULL,NULL,NULL,'','1455453','','2014-03-01','2014-02-14 20:25:26',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-15 22:00:21'),(18187,14520,'Y','18','021','EC','A','','','AC','0001053077','0001053077','OH00002179587','IL','1','Brooks','Diane','','','','34','563784052','8063 St. Rt. 245',0,'North Lewisburg','OH','43060',NULL,'CY','39021','1950-12-27','F','M',':RET:2106-3','N','021','HLT','1829294','92036OH004000501','2014-02-01','2014-01-14 15:37:47','748.00',NULL,NULL,'956.78','208.78','R-OH003','OH0','564.22',NULL,0,'2014-01-15 02:08:02'),(18787,14964,'N','19','021','EC','A',NULL,NULL,'','0000359703','0000553940','','IL','1','Huelskamp','Shegael','','','','34','807128134','1877 Kremer Rd.',0,'Maria Stein','OH','45860',NULL,'CY','39107','2011-11-19','F','',NULL,'N','021','DEN','1766210','99734OH005000401','2014-02-01','2014-01-15 21:55:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:55'),(21733,17355,'Y','18','021','EC','A','','','AC','0000186088','0000186088','TX00002552706','IL','1','Nguyen','Trang','','','','34','632862190','17018 SERENIAH CIR',0,'HOUSTON','TX','77084','1357','CY','48201','1975-12-20','F','M',':RET:2047-9','N','021','DEN','3760590','33348TX002000201','2014-03-01','2014-02-06 15:47:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-06 21:00:10'),(28142,22270,'N','01','021','EC','A',NULL,NULL,'','0000710207','0000655884','','IL','1','Kalsi','Bhupinder','','','','34','685906067','3212 ESTUARY PL',0,'MAUMEE','OH','43537','9435','CY','39095','1985-05-29','M','',NULL,'N','021','HLT','3845220','92036OH006002601','2014-04-01','2014-03-06 16:37:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','168.10',NULL,0,'2014-03-06 21:02:31'),(28573,22612,'Y','18','024','14','A','','','TE','0000736304','0000736304','','IL','1','CANALES','MARCO','ANTONIO',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-12-06','M','',NULL,NULL,NULL,'','4293616','','2014-03-08','2014-03-08 11:21:30',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-08 21:00:03'),(28596,22631,'Y','18','021','EC','A','','','AC','0001050698','0001050698','OH00003091863','IL','1','KRAMER','DEANN','','','','34','296721088','3620 HIGHLAND GRN',0,'CINCINNATI','OH','45245','1755','CY','39025','1962-07-27','F','M',NULL,'N','021','DEN','3574394','99734OH005000401','2014-04-01','2014-03-08 09:44:24','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-03-08 21:30:06'),(566,464,'N','19','021','EC','A',NULL,NULL,'','0000180978','0001166778','','IL','1','barton','andrew','d','','','34','271960987','5086 Norwich rd',0,'toledo','OH','43615',NULL,'CY','39095','1992-11-12','M','',':RET:2106-3','N','021','HLT','175935','92036OH006002601','2014-01-01','2013-12-03 23:24:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','154.64',NULL,0,'2013-12-25 17:50:28'),(25180,19973,'Y','18','021','EC','A','','','AC','0001201943','0001201943','OH00002848238','IL','1','Newburn','Kathy','','','','34','277587112','3686 COUNTY ROAD 39',0,'BLOOMINGDALE','OH','43910','7937','CY','39081','1955-06-11','F','M',':RET:2106-3','N','021','DEN','3606094','99734OH005000401','2014-04-01','2014-02-21 13:25:59','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2014-02-21 22:00:33'),(23343,18604,'N','19','021','EC','A',NULL,NULL,'','0000110556','0000956696','','IL','1','Bencina','Brant','Richard','','','34','292041640','38278 Roselawn Street',0,'Willoughby','OH','44094',NULL,'CY','39085','2000-01-16','M','',NULL,'N','021','HLT','3683295','52664OH151001305','2014-03-01','2014-02-12 21:48:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2014-02-13 22:00:38'),(23326,18591,'Y','18','021','EC','A','','','AC','0000982751','0000982751','OH00002234747','IL','1','ZATORSCKE','HALINA','','','','34','274527590','98 CHATFIELD DR',0,'PAINESVILLE','OH','44077','2504','CY','39085','1951-03-30','F','U',':RET:2106-3','N','021','DEN','2621396','99734OH005000301','2014-03-01','2014-02-13 14:42:09','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-13 22:00:27'),(27328,21638,'N','01','021','EC','A',NULL,NULL,'','0000196604','0000636257','','IL','1','Obregon De Garza','Estela','O','','','34','636447529','416 W. Diamondhead Ave',0,'Alton','TX','78573',NULL,'CY','48215','1958-05-06','F','',':RET:2106-3','N','021','DEN','3859396','33348TX002000201','2014-04-01','2014-03-04 17:05:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-04 21:00:50'),(2528,2060,'N','19','021','EC','A',NULL,NULL,'','0001241834','0000115467','','IL','1','Andreadis','Brevin','','','','34','288067238','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','2001-10-05','M','',':RET:2106-3','N','021','HLT','1176892','92036OH001001201','2014-01-01','2013-12-09 08:04:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','164.44',NULL,0,'2013-12-25 19:36:46'),(3587,2877,'Y','18','021','EC','A','','','AC','0000672544','0000672544','IN00000256052','IL','1','Schlatter','Ellen','','','','34','316509933','1317 Glenwood Avenue',0,'Fort Wayne','IN','45805',NULL,'CY','39003','1956-09-02','F','U',':RET:2106-3','T','021','HLT','1970627','92036OH002001501','2014-01-01','2013-12-22 09:50:30','224.00',NULL,NULL,'712.31','488.31','R-OH002','IN0','712.31',NULL,0,'2013-12-25 21:22:53'),(22289,17794,'Y','18','021','EC','A','','','AC','0000859728','0000859728','OH00002076530','IL','1','Sonstegard','Robin','','','','34','280600189','204 W MCKIBBEN ST',0,'LIMA','OH','45801','4323','CY','39003','1958-12-06','F','U',':RET:2106-3','N','021','HLT','2515008','92036OH003001505','2014-03-01','2014-01-27 17:59:39','392.00',NULL,NULL,'512.54','120.54','R-OH002','OH0','512.54',NULL,0,'2014-02-10 11:00:28'),(22094,17636,'N','01','021','EC','A',NULL,NULL,'','0000869534','0001140049','','IL','1','Lawrence','Barbara','Jean','','','34','408987999','10619 N. Cockrum Dr.',0,'Hernando','MS','38632',NULL,'CY','28033','1954-08-04','F','',':RET:2106-3','N','021','DEN','3650086','46300MS002000201','2014-03-01','2014-02-08 17:41:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2014-02-08 19:00:26'),(20965,16753,'Y','18','021','EC','A','','','AC','0000791304','0000791304','TX00001879014','IL','1','Dang','Hoa','','','','34','458930044','6715 FAIRFIELD WAY',0,'SACHSE','TX','75048','2867','CY','48113','1967-09-18','F','U',':RET:2047-9','N','021','DEN','3260326','33348TX002000201','2014-03-01','2014-02-01 17:36:16','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-01 19:00:11'),(3662,2929,'Y','18','021','EC','A','','','AC','0001133928','0001133928','OH00000941068','IL','1','Vivens','Kimberly','','','','34','302800161','2826 E 5TH AVE',0,'COLUMBUS','OH','43219','2849','CY','39049','1968-08-13','F','R',':RET:2054-5','N','021','DEN','181091','99734OH005000401','2014-01-01','2013-12-12 20:21:11','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:30:54'),(19505,15546,'Y','18','021','EC','A','','','AC','0000247034','0000247034','TX00001457620','IL','1','Villegas','Iovani','','','','34','639240282','2927 EISENHOWER DR',0,'DALLAS','TX','75224','3539','CY','48113','1988-02-04','M','U',NULL,'N','021','DEN','3067866','33348TX002000101','2014-03-01','2014-01-21 21:40:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-23 03:02:12'),(18780,14958,'Y','18','021','EC','A','','','AC','0000323532','0000323532','OH00001811130','IL','1','SAYRE','RONALD','','','','34','271528671','821 JEAN RD',0,'TOLEDO','OH','43615','4413','CY','39095','1954-01-23','M','U',':RET:2106-3','N','021','HLT','1868539','92036OH003002605','2014-02-01','2014-01-15 18:38:12','394.00',NULL,NULL,'552.66','158.66','R-OH001','OH0','552.66',NULL,0,'2014-01-17 03:35:52'),(4089,3266,'Y','18','021','EC','A','','','AC','0000570543','0000570543','OH00000770630','IL','1','BIDLACK','RUTH ANN','','','','34','294428959','304 ASPEN TER',0,'DEFIANCE','OH','43512','8703','CY','39039','1953-01-30','F','U',NULL,'N','021','HLT','1881507','92036OH005002604','2014-01-01','2013-12-17 10:50:19','392.00',NULL,NULL,'529.21','137.21','R-OH001','OH0','529.21',NULL,0,'2013-12-25 21:47:22'),(4864,3855,'Y','18','021','EC','A','','','AC','0000898418','0000898418','OH00000013184','IL','1','Hanna','Robert','','','','34','270445117','410 Cedar St.',0,'Defiance','OH','43512',NULL,'CY','39039','1952-08-30','M','U',':RET:2106-3','N','021','DEN','760766','99734OH005000301','2014-01-01','2013-11-08 10:10:39','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:30:46'),(7546,5971,'N','01','021','EC','A',NULL,NULL,'','0000225825','0000124108','','IL','1','Dreyer','Shaneda','Marie','','','34','527855885','401 Fleming St',0,'Wylie','TX','75098',NULL,'CY','48085','1974-07-15','F','',':RET:2106-3','T','021','DEN','633415','33348TX002000201','2014-01-01','2013-12-15 18:03:48',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 02:33:04'),(4681,3710,'N','01','021','EC','A',NULL,NULL,'','0000614154','0000115490','','IL','1','broussard-hoffpauir','judith','ann','','','34','438880334','7793 HIGHWAY 27',0,'BELL CITY','LA','70630','3010','CY','22019','1949-08-05','F','',':RET:2106-3','N','021','DEN','30310','18575LA002000201','2014-01-01','2013-12-12 16:15:01',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 22:07:53'),(25159,19957,'Y','18','021','EC','A','','','AC','0001060038','0001060038','TX00002748734','IL','1','GONZALEZ','KARINA','MARISOL','','','34','642185828','127 LA VISTA CIRCLE',0,'ELSA','TX','78543',NULL,'CY','48215','1985-11-26','F','M',NULL,'N','021','DEN','2872056','33348TX002000201','2014-04-01','2014-02-21 17:18:12','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2014-02-21 22:00:21'),(25897,20533,'N','01','021','EC','A',NULL,NULL,'','0000770975','0001169193','','IL','1','Tillman','Paul','A','','','34','455414887','8003 MISTY BREEZE',0,'SAN ANTONIO','TX','78250','4643','CY','48029','1963-06-04','M','',':RET:2106-3','N','021','DEN','2698591','33348TX002000201','2014-03-01','2014-02-26 13:02:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:06'),(13071,10419,'Y','18','021','EC','A','','','AC','0001021468','0001021468','OH00001157746','IL','1','Simmons','Janice','','','','34','294526977','9625 YORKRIDGE CT',0,'MIAMISBURG','OH','45342','5208','CY','39113','1956-02-03','F','U',':RET:2106-3','N','021','DEN','2153988','99734OH005000401','2014-01-01','2013-12-23 10:15:47','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 12:51:18'),(8988,7130,'Y','18','021','EC','A','','','AC','0000314690','0000314690','OH00000623571','IL','1','johnson','wilbert','','','','34','280702628','10082 GRANDVIEW AVE',0,'CINCINNATI','OH','45215','1412','CY','39061','1961-05-13','M','U',':RET:2054-5','N','021','DEN','2596350','99734OH005000401','2014-01-01','2013-12-18 16:57:21','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:30'),(22307,17808,'Y','18','021','EC','A','','','AC','0000865883','0000865883','MS00002271507','IL','1','EDWARDS','LIZA','','','','34','428472841','760 WILLOW ST',0,'JACKSON','MS','39204','2975','CY','28049','1979-06-01','F','U',':RET:2054-5','T','021','DEN','3045664','46300MS002000201','2014-03-01','2014-02-03 18:46:49','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-02-10 11:00:41'),(18766,14952,'N','19','021','EC','A',NULL,NULL,'','0000427340','0000716143','','S1','1','WADE','STACY','','','','34','628746912','2610 CODY CT',0,'MIDLOTHIAN','TX','76065','7023','CY','48139','2000-10-31','F','',NULL,'N','021','DEN','2815071','33348TX002000101','2014-03-01','2014-01-16 17:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','47.10',NULL,0,'2014-01-17 03:35:49'),(6262,4964,'Y','18','021','EC','A','','','AC','0000162235','0000162235','OH00001072911','IL','1','Cooper','Julian','','','','34','272805902','8217 DAVIS ST',0,'MASURY','OH','44438','1111','CY','39155','1983-03-01','M','U',NULL,'N','021','DEN','584902','99734OH005000401','2014-01-01','2013-10-06 21:11:08','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:32:16'),(16608,13285,'Y','18','021','EC','A','','','AC','0001570019','0001570019','LA00002411043','IL','1','Roberson','Tonya','Michele','','','34','433217334','3417 Dayton St',0,'Baton Rouge','LA','70805',NULL,'CY','22033','1962-03-01','F','U',':RET:2054-5','T','021','DEN','1550642','18575LA002000201','2014-02-01','2014-01-07 18:09:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-08 18:24:06'),(5682,4509,'Y','18','021','EC','A','','','AC','0001235138','0001235138','OH00001304512','31','1','Whitaker','Antwon','D','','Sr','34','291909508','628 lake',0,'Toledo','OH','43608',NULL,'CY','39095','1989-10-16','M','M',':RET:2054-5','N','021','HLT','570024','92036OH006002601','2014-01-01','2013-11-25 22:45:22','150.00',NULL,NULL,'309.28','159.28','R-OH001','OH0','154.64',NULL,0,'2013-12-25 23:32:21'),(5538,4393,'N','01','021','EC','A',NULL,NULL,'','0000133279','0000154613','','IL','1','Hill','Jack','L','','','34','294580429','49499 MURRAY RD',0,'HOPEDALE','OH','43976','9803','CY','39067','1958-09-05','M','',':RET:2106-3','N','021','DEN','568618','99734OH005000401','2014-01-01','2013-11-27 17:00:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:15:43'),(5491,4359,'Y','18','021','EC','A','','','AC','0000086410','0000086410','OH00000648989','IL','1','Slaughterbeck','Constance','','','','34','276546437','3021 STRATHMOOR AVE',0,'TOLEDO','OH','43614','3926','CY','39095','1952-06-01','F','U',NULL,'N','021','HLT','2309396','92036OH003002606','2014-01-01','2013-12-19 14:12:16','470.00',NULL,NULL,'572.23','102.23','R-OH001','OH0','572.23',NULL,0,'2013-12-25 23:11:03'),(25419,20169,'Y','18','021','EC','A','','','AC','0000194111','0000194111','OH00002874965','IL','1','jones','charles','','','','34','378783539','4091 victory parkway',0,'cincinnati','OH','45229',NULL,'CY','39061','1967-02-23','M','U',':RET:2054-5','N','021','DEN','2903752','99734OH005000401','2014-04-01','2014-02-25 14:54:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-25 21:31:08'),(14240,11355,'Y','18','021','EC','A','','','AC','0000915432','0000915432','MS00000394819','IL','1','Lyons','Tabatha','','','','34','425699362','5610 Shaw Rd.',0,'Jackson','MS','39209',NULL,'CY','28049','1976-02-10','F','U',':RET:2054-5','N','021','DEN','2187159','46300MS002000101','2014-02-01','2013-12-26 13:31:15','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-27 02:05:12'),(24176,19207,'Y','18','021','EC','A','','','AC','0000532593','0000532593','MS00002122601','IL','1','Burleson','Shun','','','','34','555479779','9305 Stateline Road',0,'Olive Branch','MS','38654',NULL,'CY','28033','1975-09-24','M','U',':RET:2054-5','T','021','DEN','3263015','46300MS002000101','2014-03-01','2014-02-15 21:34:56','0.00',NULL,NULL,'27.15','27.15','R-MS001','MS0','27.15',NULL,0,'2014-02-16 19:00:05'),(22748,18161,'N','01','021','EC','A',NULL,NULL,'','0000034419','0000342766','','IL','1','Kummer','Janice','V','','','34','405722943','6710 LINDER LN',0,'CINCINNATI','OH','45244','3507','CY','39061','1954-02-12','F','',':RET:2106-3','N','021','HLT','3219939','92036OH006001201','2014-03-01','2014-02-11 16:37:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','462.04',NULL,0,'2014-02-11 21:01:24'),(1108,912,'Y','18','021','EC','A','','','AC','0000720220','0000720220','OH00001114561','IL','1','deter','theodore','','','','34','300867133','1050 THOMAS DR',0,'ASHLAND','OH','44805','2951','CY','39005','1985-11-12','M','M',':RET:2106-3','N','021','DEN','1219681','99734OH005000401','2014-01-01','2013-12-03 16:30:34','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:17:26'),(21629,17269,'Y','18','021','EC','A','','','AC','0000792306','0000792306','TX00001903166','IL','1','Pete','Kenneth','','','','34','462273230','2521 CROSSTIMBERS ST',0,'HUNTSVILLE','TX','77320','3400','CY','48471','1961-12-21','M','U',':RET:2054-5','N','021','DEN','3396314','33348TX002000201','2014-03-01','2014-02-05 10:31:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-05 21:30:40'),(18837,15003,'Y','18','021','EC','A','','','AC','0000329670','0000329670','OH00002143531','IL','1','Meador','Alan','','','','34','281660872','407 MARVIEL DR',0,'FAIRLAWN','OH','44333','3174','CY','39153','1959-02-14','M','U',':RET:2106-3','N','021','HLT','1847123','52664OH151001301','2014-03-01','2014-01-16 11:43:23','0.00',NULL,NULL,'497.31','497.31','R-OH012','OH0','497.31',NULL,0,'2014-01-17 03:36:11'),(2204,1815,'Y','18','021','EC','A','','','AC','0000507957','0000507957','OH00000112402','IL','1','phipps','melvin','w','','','34','279708293','821 e 2nd st',0,'lima','OH','45804',NULL,'CY','39003','1965-08-03','M','U',':RET:2106-3','N','021','HLT','769215','92036OH005001505','2014-01-01','2013-12-10 12:27:18','259.00',NULL,NULL,'359.84','100.84','R-OH002','OH0','359.84',NULL,0,'2013-12-25 19:20:06'),(16610,13287,'Y','18','021','EC','A','','','AC','0000399904','0000399904','OH00001722694','IL','1','Bishop','Randall','','','','34','271446607','1600 NEVADA WYNFORD RD',0,'BUCYRUS','OH','44820','8506','CY','39033','1955-07-06','M','M',':RET:2106-3','N','021','DEN','1582577','99734OH005000401','2014-02-01','2014-01-06 18:36:35','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-01-08 18:24:07'),(15993,12801,'Y','18','021','EC','A','','','AC','0000393367','0000393367','TX00000231092','IL','1','Coleman','David','','','','34','463370350','111 FM 1996',0,'OGLESBY','TX','76561','2014','CY','48099','1975-10-04','M','M',':RET:2106-3','T','021','DEN','1880895','33348TX002000201','2014-02-01','2014-01-03 13:31:44','0.00',NULL,NULL,'29.22','29.22','R-TX011','TX0','14.61',NULL,0,'2014-01-04 02:01:18'),(15457,12369,'Y','18','021','EC','A','','','AC','0000829389','0000829389','TX00001754452','IL','1','MORAIGN','ALFRED','','','','34','450297835','505 GALLAGHER ST',0,'EL PASO','TX','79915','3104','CY','48141','1959-10-25','M','U',NULL,'N','021','DEN','2028569','33348TX002000201','2014-02-01','2013-12-31 17:30:38','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,1,'2014-01-02 04:28:32'),(9158,7265,'Y','18','021','EC','A','','','AC','0000991523','0000991523','OH00000826689','IL','1','Singh','Gretchen','','','','34','281626504','8367 PATRILLA LN',0,'CINCINNATI','OH','45249','1701','CY','39061','1971-07-26','F','U',':RET:2106-3','N','021','HLT','2409749','92036OH005001206','2014-01-01','2013-12-17 23:43:58','181.00',NULL,NULL,'284.44','103.44','R-OH004','OH0','284.44',NULL,0,'2013-12-26 04:08:38'),(7357,5826,'Y','18','021','EC','A','','','AC','0001210603','0001210603','TX00001166921','IL','1','THOMPSON','EARL','RAY','','','34','368766275','3514 APPLE DALE DR',0,'HOUSTON','TX','77084','7086','CY','48201','1961-08-09','M','U',':RET:2054-5','N','021','DEN','929826','33348TX002000201','2014-01-01','2013-11-23 15:54:37','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 02:15:16'),(20299,16204,'Y','18','021','EC','A','','','AC','0001851103','0001851103','LA00001906697','IL','1','JUMONVILLE','SHANE','','','','34','435372543','47238 HIGHWAY 22',0,'SAINT AMANT','LA','70774','4404','CY','22005','1966-01-25','M','M',':RET:2106-3','N','021','DEN','3134169','18575LA002000201','2014-03-01','2014-01-28 18:03:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-28 21:00:42'),(3544,2846,'Y','18','021','EC','A','','','AC','0001074226','0001074226','TX00000676639','IL','1','Wolcott','Danni','','','','34','457065923','113 Forest Lane',0,'Bastrop','TX','78602',NULL,'CY','48021','1955-11-26','F','M',NULL,'N','021','DEN','2404909','33348TX002000101','2014-01-01','2013-12-22 17:15:16','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 21:21:53'),(22462,17934,'N','01','021','EC','A',NULL,NULL,'','0000469409','0000831627','','IL','1','Popham','Heather','Renee','','','34','464774576','1581 COUNTY ROAD 321',0,'LA VERNIA','TX','78121','5634','CY','48493','1972-11-22','F','',':RET:2106-3','N','021','DEN','3102811','33348TX002000201','2014-03-01','2014-02-10 16:09:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-10 21:30:53'),(15922,12750,'Y','18','021','EC','A','','','AC','0000681876','0000681876','MS00001638695','IL','1','Arrington','Valerie','','','','34','427192120','142 Mansell Rd',0,'Camden','MS','39045',NULL,'CY','28089','1960-03-21','F','M',':RET:2054-5','N','021','DEN','1938213','46300MS002000201','2014-02-01','2014-01-02 13:08:02','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2014-01-03 02:06:42'),(27684,21894,'N','01','021','EC','A',NULL,NULL,'','0000787432','0000659144','','IL','1','QUIROZ LEYVA','SAMUEL','','','','34','640302840','1711 WALNUT LN',0,'MIDLAND','TX','79701','3752','CY','48329','1979-11-14','M','',NULL,'N','021','DEN','3110691','33348TX002000201','2014-04-01','2014-03-04 23:34:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:30:40'),(9756,7726,'Y','18','021','EC','A','','','AC','0000382728','0000382728','TX00001056905','IL','1','Glass','Monica','','','','34','455816414','3919 Perrin Central Blvd',0,'San Antonio','TX','78217',NULL,'CY','48029','1987-01-28','F','U',NULL,'N','021','DEN','573630','33348TX002000101','2014-01-01','2013-10-21 17:04:29','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02',NULL,0,'2013-12-26 05:00:05'),(9638,7636,'Y','18','024','14','A','','','TE','0001066133','0001066133','','IL','1','Luttrell','Regina',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-08-02','F','',NULL,NULL,NULL,'','242078','','2013-12-21','2013-12-21 10:32:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:38:25'),(22197,17716,'N','01','021','EC','A',NULL,NULL,'','0000214701','0000920853','','IL','1','Knight','Kelly','Erin','','','34','284889508','3925 ELM AVE',0,'CINCINNATI','OH','45236','3907','CY','39061','1984-12-20','F','',':RET:2106-3','N','021','DEN','2932314','99734OH005000401','2014-03-01','2014-02-08 19:23:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-09 19:00:13'),(9069,7198,'Y','18','024','14','A','','','TE','0000291791','0000291791','','IL','1','STEERS','TERRI','ANN',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-09-17','F','',NULL,NULL,NULL,'','757020','','2013-12-18','2013-12-18 17:00:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 04:06:34'),(25110,19918,'Y','18','021','EC','A','','','AC','0000244858','0000244858','TX00001445626','IL','1','BUTLER','MARIA','','','','34','372609998','315 S 35TH ST',0,'TEMPLE','TX','76504','4022','CY','48027','1957-08-18','F','M',NULL,'N','021','DEN','3564331','33348TX002000201','2014-04-01','2014-02-21 17:34:26','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61','CIC',0,'2014-02-21 21:30:15'),(23650,18832,'Y','18','021','EC','A','','','AC','0000828373','0000828373','TX00002285914','IL','1','Siddig','Ahmed','','','','34','645700569','8023 YORK BEACH PL',0,'ARLINGTON','TX','76002','3782','CY','48439','1981-08-15','M','M',':RET:2054-5','N','021','DEN','3637514','33348TX002000201','2014-03-01','2014-02-13 23:23:43','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-14 21:30:13'),(6725,5335,'Y','18','021','EC','A','','','AC','0000166342','0000166342','OH00001026803','IL','1','Wise','Rosilyn','','','','34','292523716','1870 WINDMILL WAY',0,'CINCINNATI','OH','45240','3340','CY','39061','1951-08-21','F','M',NULL,'N','021','DEN','529787','99734OH005000401','2014-01-01','2013-11-25 17:57:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 01:15:21'),(15015,12002,'N','19','021','EC','A',NULL,NULL,'','0000276285','0000146901','','IL','1','ZHANG','TAYLOR','','','Jr','34','299963386','3313 SHEPHERD STREET NW',0,'NORTH CANTON','OH','44720',NULL,'CY','39151','1994-05-02','M','',':RET:2034-7','N','021','HLT','1470322','52664OH151001305','2014-02-01','2013-12-30 15:23:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-01-01 12:02:08'),(19953,15916,'Y','18','021','EC','A','','','AC','0001505532','0001505532','LA00002506954','IL','1','RAMIREZ','ED','','','','34','534952010','4318 MACARTHUR BLVD',0,'NEW ORLEANS','LA','70131','6844','CY','22071','1961-02-16','M','M',NULL,'N','021','DEN','3158785','18575LA002000201','2014-03-01','2014-01-25 16:41:08','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-25 19:00:04'),(26126,20719,'N','01','021','EC','A',NULL,NULL,'','0000064942','0000745492','','IL','1','ASBURY','MICHAEL','R','','','34','299647625','119 MILL STREAM CIR',0,'ELYRIA','OH','44035',NULL,'CY','39093','1960-06-15','M','',':RET:2106-3','N','021','DEN','3881704','99734OH005000401','2014-04-01','2014-02-27 10:17:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-28 06:30:21'),(1128,928,'Y','18','021','EC','A','','','AC','0001174819','0001174819','TX00000752370','IL','1','Perez','Maria','','','','34','465988957','422 S 28TH AVE',0,'EDINBURG','TX','78542','5227','CY','48215','1949-06-16','F','U',':RET:2106-3','N','021','DEN','143103','33348TX002000101','2014-01-01','2013-12-03 15:40:02','0.00',NULL,NULL,'25.02','25.02','R-TX015','TX0','25.02',NULL,0,'2013-12-25 18:17:58'),(2563,2083,'N','01','021','EC','A',NULL,NULL,'','0001063209','0000701661','','IL','1','Wilson','Linda','','','','34','277709391','200 PARK AVE',0,'TIFFIN','OH','44883','1040','CY','39147','1957-04-02','F','',':RET:2106-3','N','021','HLT','1050282','92036OH003002701','2014-01-01','2013-12-09 16:09:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','475.07',NULL,0,'2013-12-25 19:37:30'),(23577,18784,'Y','18','021','EC','A','','','AC','0001219633','0001219633','OH00001671386','IL','1','Adams','Russell','','','','34','292423393','2056 STATE ROUTE 131',0,'BATAVIA','OH','45103','9699','CY','39025','1952-01-26','M','U',':RET:2106-3','N','021','HLT','2831888','92036OH004000601','2014-03-01','2014-02-13 11:21:41','339.00',NULL,NULL,'495.91','156.91','R-OH005','OH0','495.91',NULL,0,'2014-02-13 22:02:55'),(19232,15325,'Y','18','021','EC','A','','','AC','0001157590','0001157590','OH00002442537','IL','1','Collett','Robert','','','','34','275525116','6755 WINDWARD HILLS DR',0,'BRECKSVILLE','OH','44141','2469','CY','39035','1953-07-09','M','M',NULL,'N','021','DEN','1801575','99734OH005000301','2014-03-01','2014-01-20 12:47:56','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:33'),(7142,5666,'Y','18','021','EC','A','','','AC','0000289222','0000289222','TX00001226064','IL','1','Dane','Anita','','','','34','465296101','2391 COUNTY ROAD 178',0,'GAINESVILLE','TX','76240','7695','CY','48097','1959-02-04','F','U',':RET:2106-3','N','021','DEN','1528100','33348TX002000101','2014-01-01','2013-12-24 21:55:05','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 01:51:55'),(17135,13712,'N','01','021','EC','A',NULL,NULL,'','0000998798','0000357213','','IL','1','Ashcraft','James','Virgil','','','34','276540727','7960 Rio Grande Dr',0,'Cleves','OH','45002',NULL,'CY','39061','1954-06-26','M','',':RET:2106-3','T','021','DEN','1936869','99734OH005000401','2014-02-01','2014-01-08 14:42:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-13 02:21:48'),(16511,13208,'N','01','021','EC','A',NULL,NULL,'','0000641374','0000306514','','IL','1','MCINTIRE','MAI','','','','34','586303055','618 N WINKLER AVE',0,'WINK','TX','79789',NULL,'CY','48495','1957-06-23','F','',NULL,'N','021','DEN','1545294','33348TX002000201','2014-02-01','2014-01-04 19:05:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,1,'2014-01-07 10:21:22'),(15744,12595,'Y','18','021','EC','A','','','AC','0001019865','0001019865','TX00001649040','IL','1','DAVIS','DIANE','D','','','34','457276440','8350 FM 2410',0,'BELTON','TX','76513','7210','CY','48027','1957-10-06','F','U',NULL,'T','021','DEN','2118842','33348TX002000201','2014-02-01','2014-01-02 12:34:16','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-03 02:00:56'),(9472,7513,'Y','18','021','EC','A','','','AC','0000125551','0000125551','OH00001253138','IL','1','Curry','Carrie','','','','34','305049395','4434 VALENCE DR',0,'CINCINNATI','OH','45238','5827','CY','39061','1986-04-12','F','M',':RET:2106-3','N','021','DEN','1425821','99734OH005000401','2014-01-01','2013-12-21 10:51:10','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:34:28'),(15304,12237,'Y','18','021','EC','A','','','AC','0001202209','0001202209','LA00000456871','IL','1','BROUSSARD','CHARLES','','','','34','437737567','206 HENRY ST',0,'NEW IBERIA','LA','70563','2404','CY','22045','1988-07-21','M','M',NULL,'T','021','DEN','1693573','18575LA002000201','2014-02-01','2014-01-01 12:58:29','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,1,'2014-01-02 04:22:56'),(172,142,'N','01','021','EC','A',NULL,NULL,'','0000635981','0000008386','','IL','1','Votaw','Michael','','','','34','289904132','4891 W Main St',0,'Berlin','OH','44610',NULL,'CY','39075','1954-11-24','M','',':RET:2106-3','N','021','HLT','469132','52664OH151001305','2014-01-01','2013-12-04 21:19:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2013-12-25 17:19:26'),(25333,20100,'Y','18','021','EC','A','','','AC','0001183220','0001183220','LA00003257300','IL','1','Jackson','Eric','','','','34','435159853','647 N. 36th Street',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1960-02-07','M','U',':RET:2054-5','N','021','DEN','3429417','18575LA002000201','2014-04-01','2014-02-25 14:31:40','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-25 21:30:19'),(2991,2407,'Y','18','021','EC','A','','','AC','0001235146','0001235146','OH00001050991','IL','1','Park','Hyun','','','','34','282086350','8655 GOLD LEAF LN',0,'DUBLIN','OH','43016','8444','CY','39049','1957-01-10','F','M',':RET:2040-4','N','021','DEN','908788','99734OH005000301','2014-01-01','2013-12-06 14:57:44','0.00',NULL,NULL,'42.26','42.26','R-OH009','OH0','0.00',NULL,0,'2013-12-25 20:17:27'),(23688,18864,'Y','18','021','EC','A','','','AC','0000582848','0000582848','OH00002837748','IL','1','Lavery','Shannon','','','','34','419270624','4000 WOODFORD RD',0,'CINCINNATI','OH','45213','2376','CY','39061','1981-12-30','F','U',NULL,'N','021','DEN','2821668','99734OH005000401','2014-03-01','2014-02-13 19:53:59','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-14 21:30:35'),(14478,11552,'Y','18','021','EC','A','','','AC','0000699469','0000699469','TX00000069501','IL','1','Arredondo Cervantes','Eduardo','','','','34','644521314','1403 Camp Craft Rd',0,'Austin','TX','78746',NULL,'CY','48453','1959-12-14','M','M',NULL,'N','021','DEN','2265116','33348TX002000201','2014-02-01','2013-12-26 21:31:33','0.00',NULL,NULL,'47.55','47.55','R-TX003','TX0','15.85',NULL,0,'2013-12-28 03:33:14'),(3207,2580,'N','01','021','EC','A',NULL,NULL,'','0000858456','0000130651','','IL','1','Mahone','Elizabeth','Rakowski','','','34','372989990','1404 E MCMILLAN ST',0,'CINCINNATI','OH','45206','2242','CY','39061','1979-07-11','F','',':RET:2106-3','N','021','DEN','100398','99734OH005000301','2014-01-01','2013-10-31 23:29:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:45:21'),(19552,15585,'Y','18','021','EC','A','','','AC','0000022824','0000022824','OH00002109038','IL','1','StJohns','Linda','','','','34','295528229','5937 RAMBO LN',0,'TOLEDO','OH','43623','1309','CY','39095','1953-06-23','F','M',':RET:2106-3','N','021','HLT','2525256','92036OH006002601','2014-03-01','2014-01-22 12:33:03','80.00',NULL,NULL,'419.70','339.70','R-OH001','OH0','419.70',NULL,0,'2014-01-23 03:02:29'),(19240,15331,'Y','18','021','EC','A','','','AC','0000021411','0000021411','OH00002566918','IL','1','Butler','Jessica','','','','34','271728309','442 Clearview Drive',0,'Euclid','OH','44123',NULL,'CY','39035','1973-12-29','F','U',':RET:2054-5','N','021','DEN','1516634','99734OH005000301','2014-03-01','2014-01-20 16:29:50','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:37'),(18195,14525,'N','01','021','EC','A',NULL,NULL,'','0000305858','0000712545','','IL','1','Murphy','Joanna','','','','34','276900100','13528 KAUFMAN AVE NW',0,'HARTVILLE','OH','44632','9042','CY','39151','1984-06-26','F','',':RET:2106-3','N','021','HLT','2223456','52664OH151001501','2014-02-01','2014-01-14 15:17:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','299.29',NULL,0,'2014-01-15 02:08:05'),(8830,7000,'N','01','021','EC','A',NULL,NULL,'','0000534992','0000426139','','IL','1','Garza','Miguel','','','','34','458218084','184 SHORELINE DR',0,'BROWNSVILLE','TX','78521','4333','CY','48061','1958-04-28','M','',':RET:2106-3','N','021','DEN','2086795','33348TX002000201','2014-01-01','2013-12-17 20:08:44',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:00:30'),(17479,13975,'Y','18','021','EC','A','','','AC','0000884961','0000884961','TX00002580946','IL','1','Brecheen','Jonathan','Barry','','','34','438418597','9445 PASTIME CT',0,'FORT WORTH','TX','76244','8680','CY','48439','1980-09-20','M','M',':RET:2106-3','N','021','DEN','1969082','33348TX002000201','2014-02-01','2014-01-12 12:27:16','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-01-13 03:01:12'),(15379,12302,'Y','18','021','EC','A','','','AC','0000469548','0000469548','OH00001430893','IL','1','Barlow','William','James','','','34','281487772','1550 West Galbreith',0,'Cincinnati','OH','45231',NULL,'CY','39061','1952-09-29','M','U',':RET:2054-5','N','021','HLT','1993994','92036OH006001201','2014-02-01','2014-01-01 12:36:26','0.00',NULL,NULL,'478.41','478.41','R-OH004','OH0','478.41',NULL,1,'2014-01-02 04:25:21'),(7025,5578,'Y','18','021','EC','A','','','AC','0000626162','0000626162','TX00001385940','31','1','Orias','Oscar','','','','34','450977258','13542 CREEK SPRINGS DR',0,'HOUSTON','TX','77083','1832','CY','48201','1985-11-19','M','U',':RET:2106-3','N','021','DEN','1798360','33348TX002000201','2014-01-01','2013-12-24 22:19:52','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 01:48:58'),(27379,21677,'Y','18','021','EC','A','','','AC','0001092477','0001092477','MS00002938714','IL','1','BARNES','CRYSTAL','','','','34','427310492','850 PRIMOS AVE',0,'JACKSON','MS','39209','6137','CY','28049','1975-01-26','F','U',':RET:2054-5','N','021','DEN','3700801','46300MS002000101','2014-04-01','2014-03-04 17:10:07','46.61',NULL,NULL,'74.25','27.64','R-MS003','MS0','27.15',NULL,0,'2014-03-04 21:01:20'),(4270,3401,'Y','18','024','14','A','','','TE','0001152170','0001152170','','IL','1','Griffith','Tereasa',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1967-07-18','F','',NULL,NULL,NULL,'','2499077','','2013-12-17','2013-12-17 08:08:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:51:44'),(22819,18210,'N','19','021','EC','A',NULL,NULL,'','0001103479','0000125603','','IL','1','White','Brandon','','','','34','301980883','1409 Grimes Circle',0,'Urbana','OH','43078',NULL,'CY','39021','1996-06-01','M','',':RET:2106-3','N','021','HLT','3303777','92036OH005000504','2014-03-01','2014-02-10 20:37:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2014-02-11 21:02:02'),(22007,17569,'N','01','021','EC','A',NULL,NULL,'','0000273834','0000696849','','IL','1','Harbeson','Ashley','','','','34','229458468','3894 WINTER HILL DR',0,'HAMILTON','OH','45011','6421','CY','39017','1984-06-14','F','',NULL,'N','021','DEN','3480609','99734OH005000301','2014-03-01','2014-02-06 23:05:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-07 19:00:49'),(6334,5022,'N','19','021','EC','A',NULL,NULL,'','0001088245','0000799867','','IL','1','Jordan','Kole','','','','34','274177628','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','2011-03-07','M','',NULL,'N','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:40'),(17460,13962,'Y','18','024','14','A','','','TE','0001124072','0001124072','','IL','1','Bruskotter','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-12-30','M','',NULL,NULL,NULL,'','1820313','','2014-01-10','2014-01-10 16:34:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 03:00:42'),(16947,13564,'Y','18','021','EC','A','','','AC','0000095218','0000095218','MS00002076120','IL','1','Harveston','Catherine','','','','34','427230282','2762 Norton-Assink Rd. NW',0,'Wesson','MS','39191',NULL,'CY','28085','1972-12-22','F','R',':RET:2106-3','N','021','DEN','1938357','46300MS002000101','2014-02-01','2014-01-08 18:30:42','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-01-13 02:19:57'),(1214,997,'Y','18','021','EC','A','','','AC','0000192703','0000192703','OH00000066009','IL','1','Hoy','Judith','','','','34','587761299','1925 SAINT PARIS PIKE',0,'SPRINGFIELD','OH','45504','1205','CY','39023','1953-12-01','F','U',':RET:2106-3','N','021','HLT','451802','92036OH005000505','2014-01-01','2013-12-03 09:04:21','474.00',NULL,NULL,'645.13','171.13','R-OH003','OH0','645.13',NULL,0,'2013-12-25 18:20:11'),(24601,19527,'N','01','021','EC','A',NULL,NULL,'','0000788253','0000136132','','IL','1','Sexton','Tiffany','Lee','','','34','272880493','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','1984-08-24','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:12:48'),(23422,18662,'N','01','021','EC','A',NULL,NULL,'','0001245558','0000885067','','IL','1','Hughes','Carolyn','','','','34','460855466','410 Mills Street',0,'Fort Worth','TX','76102',NULL,'CY','48439','1980-04-08','F','',':RET:2054-5','N','021','DEN','2992745','33348TX002000201','2014-03-01','2014-02-12 21:51:20',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-13 22:01:23'),(15149,12108,'Y','18','021','EC','A','','','AC','0000296796','0000296796','OH00001301874','IL','1','SPENCER','RICHARD','','','','34','280689330','2012 PEARL ST',0,'MIDDLETOWN','OH','45044','5925','CY','39017','1970-06-20','M','U',':RET:2106-3','N','021','DEN','2414252','99734OH005000401','2014-02-01','2013-12-30 12:10:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-01 12:06:00'),(22732,18150,'N','01','021','EC','A',NULL,NULL,'','0001356215','0001823380','','IL','1','watson','kentrell','c','','Sr','34','434238513','2360 BENEFIT ST',0,'NEW ORLEANS','LA','70122','4454','CY','22071','1973-08-31','M','',':RET:2054-5','N','021','DEN','3138493','18575LA002000201','2014-03-01','2014-02-11 15:46:05',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:16'),(22592,18045,'Y','18','024','14','A','','','TE','0000120038','0000120038','','IL','1','Sharpe','Keven','James',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-09-30','M','',NULL,NULL,NULL,'','629207','','2014-02-25','2014-02-10 12:19:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-10 21:32:10'),(1758,1454,'N','19','021','EC','A',NULL,NULL,'','0001260013','0000895714','','IL','1','Bepler','Carter','Louis','','','34','288088434','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','2003-09-28','M','',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:52'),(19939,15902,'N','01','021','EC','A',NULL,NULL,'','0001074115','0000335124','','IL','1','FISHER','TIMOTHY','JOE','','','34','287462571','9014 STATE ROUTE 3 WEST',0,'CLARKSVILLE','OH','45113',NULL,'CY','39027','1952-01-17','M','',':RET:2106-3','N','021','HLT','2658337','92036OH001000601','2014-03-01','2014-01-24 10:36:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','743.93',NULL,0,'2014-01-24 21:01:13'),(2281,1861,'Y','18','021','EC','A','','','AC','0001237681','0001237681','OH00000005084','IL','1','Johnson','Carmen','M','','','34','348569726','2610 KEMPERWOOD DR',0,'BLACKLICK','OH','43004','8667','CY','39049','1968-02-08','F','M',NULL,'N','021','DEN','551987','99734OH005000301','2014-01-01','2013-12-09 12:47:54','0.00',NULL,NULL,'59.76','59.76','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:30:34'),(5264,4175,'Y','18','021','EC','A','','','AC','0001233045','0001233045','OH00000091381','IL','1','Youngblood','Te','','','','34','503117601','432 W. Main St.',0,'Ravenna','OH','44266',NULL,'CY','39133','1986-11-07','F','U',':RET:2054-5','N','021','HLT','2085704','52664OH151001304','2014-01-01','2013-12-19 11:21:54','80.00',NULL,NULL,'233.71','153.71','R-OH012','OH0','233.71',NULL,0,'2013-12-25 23:05:26'),(7234,5735,'Y','18','021','EC','A','','','AC','0000310840','0000310840','OH00000091174','IL','1','Leone','Silvana','','','','34','288626764','345 ILLINOIS AVE',0,'DAYTON','OH','45410','2047','CY','39113','1958-08-20','F','U',':RET:2106-3','N','021','DEN','1002870','99734OH005000401','2014-01-01','2013-12-14 17:46:23','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 02:01:29'),(6230,4938,'Y','18','021','EC','A','','','AC','0000051877','0000051877','OH00000625229','IL','1','TORRES','DEBORAH','MARSHELLE','','','34','284625294','1331 SECTION RD',0,'CINCINNATI','OH','45237','2617','CY','39061','1957-08-11','F','U',':RET:2054-5','N','021','DEN','776408','99734OH005000401','2014-01-01','2013-11-19 17:16:51','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:31:24'),(16261,13019,'Y','18','021','EC','A','','','AC','0001174413','0001174413','OH00001541719','IL','1','BURLINGAME','LARISA','','','','34','276068917','3024 N OAK HILL RD',0,'SILVER LAKE','OH','44224',NULL,'CY','39153','1952-03-05','F','M',':RET:2106-3','N','021','HLT','2245957','52664OH152000901','2014-02-01','2014-01-04 16:35:58','188.00',NULL,NULL,'458.99','270.99','R-OH012','OH0','458.99',NULL,0,'2014-01-05 00:02:56'),(27005,21389,'Y','18','021','EC','A','','','AC','0000338934','0000338934','OH00002721161','IL','1','JENKINS','ARTHUR','','','','34','296646026','3558 CUMMINGS RD',0,'CLEVELAND HEIGHTS','OH','44118','2625','CY','39035','1960-01-19','M','U',':RET:2106-3','N','021','DEN','3071264','99734OH005000401','2014-04-01','2014-03-03 13:21:57','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00','CIC',0,'2014-03-03 21:00:04'),(27080,21439,'N','19','021','EC','A',NULL,NULL,'','0000807563','0000457859','','IL','1','Jensen','Daniel','','','','34','298029234','23 N HAYDEN PKWY',0,'HUDSON','OH','44236','3149','CY','39153','1998-06-02','M','',':RET:2106-3','N','021','HLT','2723732','52664OH152000901','2014-04-01','2014-03-03 16:38:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-03-03 21:30:10'),(588,483,'Y','18','021','EC','A','','','AC','0000402430','0000402430','OH00000864294','IL','1','Ledsome','Melissa','','','','34','277963877','11246  crestline st sw',0,'beach city','OH','44608',NULL,'CY','39151','1993-01-29','F','U',':RET:2106-3','N','021','HLT','757222','52664OH152001001','2014-01-01','2013-12-04 14:36:03','0.00',NULL,NULL,'77.86','77.86','R-OH015','OH0','77.86',NULL,0,'2013-12-25 17:51:07'),(17338,13869,'Y','18','021','EC','A','','','AC','0001587656','0001587656','LA00001969898','IL','1','BELLARD','LINDA','','','','34','434215278','1527 HIGHWAY 749',0,'OPELOUSAS','LA','70570','1100','CY','22097','1960-10-20','F','U',':RET:2054-5','N','021','DEN','2100639','18575LA002000201','2014-02-01','2014-01-10 16:46:12','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-13 02:24:01'),(16723,13384,'Y','18','021','EC','A','','','AC','0000120105','0000120105','OH00000590733','IL','1','LOCHER','JEFFREY','JOHN','','','34','289742704','3899 AUSTINBURG RD',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1965-05-24','M','U',':RET:2106-3','N','021','HLT','2331296','52664OH151001306','2014-02-01','2014-01-06 19:28:53','364.00',NULL,NULL,'411.23','47.23','R-OH011','OH0','411.23',NULL,0,'2014-01-08 18:24:47'),(975,798,'Y','18','021','EC','A','','','AC','0000077256','0000077256','LA00001125446','IL','1','Melancon','Michael','','','','34','437845614','816 LeBeau St.',0,'Arabi','LA','70032',NULL,'CY','22087','1952-06-18','M','U',':RET:2106-3','N','021','DEN','277831','18575LA002000201','2014-01-01','2013-10-29 09:56:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:10:06'),(16167,12944,'Y','18','021','EC','A','','','AC','0002255084','0002255084','LA00001582647','IL','1','Pham','Soan','','','','34','621500471','11368 GLENDA DR',0,'BATON ROUGE','LA','70815','2421','CY','22033','1969-07-10','F','M',NULL,'N','021','DEN','1513428','18575LA002000201','2014-02-01','2014-01-03 18:52:22','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-01-05 00:00:08'),(15578,12465,'Y','18','021','EC','A','','','AC','0000830645','0000830645','OH00000540782','IL','1','Deeter','Mark','','','','34','300440970','488 US Route 42',0,'Ashland','OH','44805',NULL,'CY','39005','1960-06-24','M','U',':RET:2106-3','T','021','HLT','1687299','52664OH151001306','2014-02-01','2013-12-31 17:22:41','424.00',NULL,NULL,'523.18','99.18','R-OH012','OH0','523.18',NULL,1,'2014-01-02 04:32:06'),(7688,6088,'Y','18','024','14','A','','','TE','0001106771','0001106771','','IL','1','SPRADLING','JACK','RONALD','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-16','M','',NULL,NULL,NULL,'','116837','','2013-12-19','2013-12-19 21:04:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:00:57'),(5479,4350,'Y','18','024','14','A','','','TE','0000659881','0000659881','','IL','1','Brown','Bonnie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-04-20','F','',NULL,NULL,NULL,'','1255472','','2013-12-19','2013-12-19 14:55:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:47'),(9148,7255,'Y','18','021','EC','A','','','AC','0000853011','0000853011','OH00000211629','IL','1','Douglas','Susan','','','','34','415113035','3903 HILE RD',0,'STOW','OH','44224','4230','CY','39153','1959-07-27','F','U',':RET:2106-3','N','021','HLT','1698038','52664OH151001501','2014-01-01','2013-12-18 12:04:06','290.00',NULL,NULL,'571.04','281.04','R-OH012','OH0','571.04',NULL,0,'2013-12-26 04:08:21'),(6129,4861,'Y','18','021','EC','A','','','AC','0000470446','0000470446','TX00000512702','IL','1','hornecker','john','','','','34','573956150','6118 ADIRONDACK TRL',0,'AMARILLO','TX','79106','3404','CY','48375','1971-02-10','M','M',':RET:2106-3','N','021','DEN','356423','33348TX002000201','2014-01-01','2013-11-21 17:40:08','0.00',NULL,NULL,'29.22','29.22','R-TX002','TX0','14.61',NULL,0,'2013-12-26 00:15:57'),(9717,7696,'N','01','021','EC','A',NULL,NULL,'','0000223675','0000700342','','IL','1','Phillips','Michele','R','','','34','283540206','5546 MERYTON PL',0,'CINCINNATI','OH','45224','2818','CY','39061','1950-02-25','F','',':RET:2106-3','N','021','DEN','996297','99734OH005000401','2014-01-01','2013-11-15 11:31:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:45:21'),(14609,11660,'Y','18','021','EC','A','','','AC','0001212347','0001212347','OH00000972927','IL','1','Hill','Michael','Charles','','Sr','34','293743861','3056 THORNTON ST NW',0,'NORTH CANTON','OH','44720',NULL,'CY','39151','1963-08-11','M','M',':RET:2106-3','N','021','DEN','1940759','99734OH005000301','2014-02-01','2013-12-27 14:24:07','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-28 03:36:36'),(23600,18800,'Y','18','021','EC','A','','','AC','0000003621','0000003621','OH00002640568','IL','1','Hemenway','Maureen','','','','34','298469195','2610 STATE ROUTE 61',0,'NORWALK','OH','44857','9188','CY','39077','1965-05-11','F','M',':RET:2106-3','N','021','HLT','3757008','92036OH006002701','2014-03-01','2014-02-13 15:09:17','211.00',NULL,NULL,'529.03','318.03','R-OH006','OH0','252.84',NULL,0,'2014-02-13 22:03:08'),(503,411,'Y','18','024','14','A','','','TE','0000589278','0000589278','','IL','1','Hill','Willis',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-12-20','M','',NULL,NULL,NULL,'','89116','','2013-12-04','2013-12-04 12:21:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:48:45'),(16669,13340,'Y','18','021','EC','A','','','AC','0001070488','0001070488','OH00001962409','IL','1','ROBINSON','DENISE','','','','34','293608584','5565 MANCHESTER RD',0,'FRANKLIN','OH','45005','4348','CY','39165','1961-01-19','F','M',':RET:2106-3','N','021','DEN','1644070','99734OH005000301','2014-02-01','2014-01-07 12:54:00','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-08 18:24:28'),(16034,12837,'Y','18','021','EC','A','','','AC','0002356863','0002356863','LA00002064280','IL','1','Turner','Shelia','','','','34','438857482','54950 Cypress Street',0,'White Castle','LA','70788',NULL,'CY','22047','1992-11-06','F','U',':RET:2054-5','N','021','DEN','2091216','18575LA002000201','2014-02-01','2014-01-03 14:09:41','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-04 02:02:36'),(25289,20065,'Y','18','021','EC','A','','','AC','0001104507','0001104507','OH00002969992','IL','1','VON AHN','ERICK','','','','34','063443241','29 Zeller Court',0,'Berea','OH','44017',NULL,'CY','39035','1967-09-16','M','M',':RET:2106-3','N','021','HLT','3055167','52664OH151001306','2014-03-01','2014-02-25 13:22:17','700.00',NULL,NULL,'991.99','291.99','R-OH011','OH0','377.28','CIC',0,'2014-02-25 21:00:22'),(25638,20338,'N','19','021','EC','A',NULL,NULL,'','0002128636','0002025414','','IL','1','Forestier','Victoria','','','','34','435853244','201 south college drive',0,'Lafayette','LA','70506',NULL,'CY','22055','1992-05-26','F','',':RET:2106-3','N','021','DEN','2729400','18575LA002000201','2014-04-01','2014-02-21 22:35:11',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-26 08:30:29'),(26719,21180,'Y','18','021','EC','A','','','AC','0000508360','0000508360','MS00002678518','IL','1','Street','Roshanda','','','','34','587337588','276 ELTON PARK DR',0,'JACKSON','MS','39212','8790','CY','28049','1978-08-01','F','U',NULL,'N','021','DEN','2795567','46300MS002000101','2014-04-01','2014-02-27 23:50:57','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-02-28 21:31:43'),(26739,21192,'Y','18','021','EC','A','','','AC','0000596337','0000596337','OH00002303419','IL','1','King','Jacob','','','','34','296781530','65 MAIN ST',0,'TIFFIN','OH','44883','3067','CY','39147','1981-01-08','M','U',':RET:2106-3','N','021','HLT','3398038','92036OH005002704','2014-04-01','2014-02-28 14:06:43','75.00',NULL,NULL,'233.59','158.59','R-OH006','OH0','233.59',NULL,0,'2014-02-28 21:31:54'),(28360,22439,'Y','18','021','EC','A','','','AC','0000641606','0000641606','TX00002928101','IL','1','Walker','Kevin','','','','34','467046959','1301 DESIERTO RICO AVE',0,'EL PASO','TX','79912','8009','CY','48141','1963-12-22','M','U',':RET:2106-3','N','021','DEN','3190484','33348TX002000201','2014-04-01','2014-03-07 14:15:01','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-03-07 21:30:28'),(28812,22804,'N','01','021','EC','A',NULL,NULL,'','0000053121','0000840589','','IL','1','Young','Deanne','L','','','34','270568493','1550 Co. Rd. 175',0,'Jeromesville','OH','44840',NULL,'CY','39005','1962-03-07','F','',':RET:2106-3','N','021','HLT','3524890','52664OH151001305','2014-04-01','2014-03-09 11:43:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','435.31',NULL,0,'2014-03-09 21:00:55'),(6795,5389,'N','01','021','EC','A',NULL,NULL,'','0001204493','0001044443','','IL','1','Durliat','Christine','L','','','34','284524667','881 Manning Rd NW',0,'Hartville','OH','44632',NULL,'CY','39133','1950-10-02','F','',':RET:2106-3','T','021','HLT','2360','52664OH151001501','2014-01-01','2013-11-25 15:47:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','907.99',NULL,0,'2013-12-26 01:17:11'),(23298,18573,'Y','18','021','EC','A','','','AC','0000643274','0000643274','OH00002634178','S3','1','Smith','Jeffery','Michelle','','','34','352967673','2303 MARION MOUNT GILEAD RD',0,'MARION','OH','43302','8912','CY','39101','2000-03-04','F','U',':RET:2106-3','N','021','DEN','3523002','99734OH005000301','2014-03-01','2014-02-13 01:12:11','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','21.13',NULL,0,'2014-02-13 22:00:12'),(23245,18532,'Y','18','021','EC','A','','','AC','0000533271','0000533271','OH00001691819','IL','1','Lloyd','Anna','','','','34','272866165','3400 CHARRING CROSS DR',0,'STOW','OH','44224','4609','CY','39153','1985-11-16','F','U',':RET:2106-3','N','021','DEN','3479436','99734OH005000401','2014-03-01','2014-02-12 21:11:04','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00','CIC',0,'2014-02-13 21:30:04'),(8921,7073,'Y','18','021','EC','A','','','AC','0001018220','0001018220','OH00000235571','IL','1','Brunicardi','Elio','','','','34','288133774','3347 ULTIMATE WAY',0,'DAYTON','OH','45449','3541','CY','39113','1955-07-24','M','U',':RET:2106-3','N','021','DEN','2334667','99734OH005000401','2014-01-01','2013-12-18 07:37:55','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:02:46'),(22339,17840,'Y','18','021','EC','A','','','AC','0000249146','0000249146','OH00002308223','IL','1','Bunnell','David','L','','','34','287862354','1700 Croydon Lane',0,'Middletown','OH','45042',NULL,'CY','39017','1972-03-09','M','U',':RET:2106-3','N','021','HLT','1537634','92036OH003001204','2014-03-01','2014-01-21 14:58:12','74.00',NULL,NULL,'291.89','217.89','R-OH004','OH0','291.89',NULL,0,'2014-02-10 11:01:07'),(17202,13766,'Y','18','021','EC','A','','','AC','0001198125','0001198125','OH00001817389','IL','1','Litt','Michael','','','','34','141529828','250 SCHOCALOG RD',0,'AKRON','OH','44313','4579','CY','39153','1965-08-07','M','U',':RET:2106-3','T','021','HLT','2520032','52664OH151001501','2014-02-01','2014-01-07 23:03:59','199.00',NULL,NULL,'502.90','303.90','R-OH012','OH0','502.90',NULL,0,'2014-01-13 02:22:25'),(21332,17047,'Y','18','021','EC','A','','','AC','0001229661','0001229661','TX00001534634','IL','1','Shelby','Pearl','','','','34','433716159','3402 Hereford Lane',0,'Killeen','TX','76542',NULL,'CY','48027','1981-06-17','F','M',':RET:2054-5','T','021','DEN','2731708','33348TX002000201','2014-03-01','2014-02-03 18:57:45','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-02-04 21:00:29'),(21577,17235,'Y','18','024','14','A','','','TE','0000999881','0000999881','','IL','1','Jeffries','Stephone',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-07-16','M','',NULL,NULL,NULL,'','3011734','','2014-02-05','2014-02-05 12:50:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-05 21:30:23'),(26495,21018,'Y','18','024','14','A','','','TE','0000345647','0000345647','','IL','1','PALUMBO','JENNIFER',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-02-02','F','',NULL,NULL,NULL,'','3409648','','2014-02-28','2014-02-28 10:32:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCELCIC',0,'2014-02-28 21:00:13'),(130,113,'Y','18','021','EC','A','','','AC','0000128077','0000128077','OH00000309307','IL','1','DeFratis','Barbara','','','','34','296480785','5107 ROCKPORT CV',0,'STOW','OH','44224','1570','CY','39153','1961-08-15','F','U',':RET:2106-3','N','021','HLT','71776','52664OH152000901','2014-01-01','2013-12-04 18:53:36','186.00',NULL,NULL,'318.84','132.84','R-OH012','OH0','318.84',NULL,0,'2013-12-25 17:18:27'),(466,381,'Y','18','021','EC','A','','','AC','0000626707','0000626707','OH00000153737','IL','1','Riggs','Amanda','','','','34','299780915','279 COUNTY ROAD 40',0,'SULLIVAN','OH','44880','9731','CY','39005','1979-10-02','F','M',':RET:2106-3','N','021','HLT','476605','52664OH151001301','2014-01-01','2013-12-04 10:57:13','0.00',NULL,NULL,'553.95','553.95','R-OH012','OH0','270.73',NULL,0,'2013-12-25 17:47:46'),(13114,10458,'Y','18','021','EC','A','','','AC','0000847153','0000847153','OH00000269120','IL','1','BENNETT','EILEEN','','','','34','298584196','1858 YORKTOWN RD',0,'CINCINNATI','OH','45237',NULL,'CY','39061','1958-03-17','F','U',':RET:2054-5','T','021','DEN','1409199','99734OH005000401','2014-01-01','2013-12-23 13:38:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:52:34'),(13049,10403,'Y','18','021','EC','A','','','AC','0000372601','0000372601','OH00001027614','IL','1','okunoye','yetunde','','','','34','294906913','5065 ROLLMAN ESTATES DR',0,'CINCINNATI','OH','45236','1455','CY','39061','1974-06-07','F','U',':RET:2054-5','N','021','DEN','1759281','99734OH005000401','2014-01-01','2013-12-23 08:49:19','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 12:50:49'),(18405,14685,'Y','18','021','EC','A','','','AC','0000963257','0000963257','OH00002037181','IL','1','packo','joseph','','','','34','290540226','100 S BAYSHORE DR',0,'COLUMBIANA','OH','44408','9312','CY','39099','1953-01-02','M','M',':RET:2106-3','N','021','DEN','2956132','99734OH005000301','2014-02-01','2014-01-15 18:02:53','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2014-01-16 08:45:45'),(16085,12882,'Y','18','021','EC','A','','','AC','0000927317','0000927317','OH00001106544','IL','1','Nehrkorn','Brandon','','','','34','283866851','99 W STARR AVE',0,'COLUMBUS','OH','43201','3429','CY','39049','1986-03-31','M','U',':RET:2039-6^:RET:2106-3','N','021','DEN','2337670','99734OH005000401','2014-02-01','2014-01-03 16:41:13','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-04 02:04:15'),(15911,12742,'Y','18','021','EC','A','','','AC','0000590892','0000590892','TX00002214181','31','1','MITCHELL','DEBBIE','LORAINE','','','34','462639559','PO BOX 406',0,'BLOOMINGTON','TX','77951',NULL,'CY','48239','1967-06-04','F','U',':RET:2054-5','N','021','DEN','2426800','33348TX002000101','2014-02-01','2014-01-02 14:53:47','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-03 02:06:24'),(1294,1070,'Y','18','021','EC','A','','','AC','0000566388','0000566388','TX00000843356','IL','1','Vanwie','Joseph','','','','34','398084151','1814 CANYON CREEK DR',0,'TEMPLE','TX','76502','3211','CY','48027','1991-12-29','M','U',':RET:2106-3','N','021','DEN','511909','33348TX002000101','2014-01-01','2013-11-29 14:54:34','0.00',NULL,NULL,'25.02','25.02','R-TX011','TX0','25.02',NULL,0,'2013-12-25 18:30:57'),(14411,11493,'Y','18','021','EC','A','','','AC','0000359268','0000359268','TX00001573732','IL','1','Jones','Rashad','','','','34','638128261','3035 BLUE LAGOON CT',0,'MISSOURI CITY','TX','77459','7611','CY','48157','1987-09-17','M','U',':RET:2054-5','N','021','DEN','1799489','33348TX002000101','2014-02-01','2013-12-26 21:31:49','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-28 03:31:28'),(6419,5089,'Y','18','021','EC','A','','','AC','0001047980','0001047980','OH00000927092','31','1','Patterson','Steven','','','','34','403848756','2566 W. Vincinnes trail',0,'Salem','IN','47167',NULL,'CY','39011','1957-04-19','M','U',':RET:2106-3','T','021','HLT','120414','92036OH006001501','2014-01-01','2013-12-10 18:37:07','388.00',NULL,NULL,'468.28','80.28','R-OH002','OH0','468.28',NULL,0,'2013-12-26 00:48:49'),(26058,20667,'Y','18','021','EC','A','','','AC','0000528303','0000528303','OH00002789200','IL','1','fletcher','deitra','','','','34','275684182','8135 Stringdown Rd',0,'Aberdeen','OH','45101',NULL,'CY','39015','1973-11-08','F','M',NULL,'N','021','HLT','2693691','92036OH004000601','2014-04-01','2014-02-26 12:27:33','318.00',NULL,NULL,'554.95','236.95','R-OH005','OH0','220.60',NULL,0,'2014-02-26 21:02:38'),(29041,22985,'N','19','021','EC','A',NULL,NULL,'','0000239095','0001216317','','IL','1','MITCHELL','DALLAS','','','','34','283133721','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','2007-06-20','M','',NULL,'N','021','DEN','3542283','99734OH005000401','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:41'),(9481,7518,'Y','18','021','EC','A','','','AC','0000397332','0000397332','OH00000215320','IL','1','Creech','Sarah','M','','','34','297949050','209 W ELM ST',0,'CASTINE','OH','45304','9115','CY','39037','1992-05-09','F','U',':RET:2106-3','N','021','DEN','2113302','99734OH005000401','2014-01-01','2013-12-21 11:51:09','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:34:38'),(632,523,'Y','18','021','EC','A','','','AC','0000367365','0000367365','OH00001024375','IL','1','Luu','Nhan','Thanh','','','34','370255656','12085 Brookston Dr',0,'Cincinnati','OH','45240','1350','CY','39061','1970-04-27','F','M',':RET:2047-9','N','021','DEN','1367458','99734OH005000401','2014-01-01','2013-12-16 13:17:58','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:01:08'),(21276,17004,'Y','18','021','EC','A','','','AC','0001136679','0001136679','OH00002330820','IL','1','Hysell','Ryan','','','','34','278865437','249 S BEECHGROVE RD',0,'WILMINGTON','OH','45177','7617','CY','39027','1985-12-28','M','M',':RET:2106-3','N','021','HLT','3238278','92036OH005000605','2014-03-01','2014-02-03 16:18:11','376.00',NULL,NULL,'477.01','101.01','R-OH005','OH0','233.35',NULL,0,'2014-02-03 21:01:33'),(25331,20098,'Y','18','021','EC','A','','','AC','0001670289','0001670289','LA00002961332','IL','1','ZHENG','DAIYING','','','','34','068844281','106 BROADMOOR DR',0,'ABBEVILLE','LA','70510','4102','CY','22113','1981-11-19','M','M',NULL,'N','021','DEN','3625956','18575LA002000201','2014-04-01','2014-02-25 13:46:44','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-25 21:30:18'),(23206,18501,'Y','18','021','EC','A','','','AC','0000511990','0000511990','OH00002517739','IL','1','Macias','Gregory','','','','34','268740029','154 E FREMONT ST',0,'FOSTORIA','OH','44830','2801','CY','39147','1974-05-16','M','U',NULL,'N','021','HLT','3205590','92036OH003002704','2014-03-01','2014-02-12 17:47:54','123.00',NULL,NULL,'256.98','133.98','R-OH006','OH0','256.98',NULL,0,'2014-02-12 21:32:10'),(19245,15335,'Y','18','021','EC','A','','','AC','0000154234','0000154234','MS00001536687','IL','1','WINTERS','MATTIE','','','','34','426152175','3549 JACKYE LN',0,'JACKSON','MS','39213','5112','CY','28049','1959-04-20','F','U',':RET:2054-5','N','021','DEN','2862905','46300MS002000101','2014-03-01','2014-01-20 11:37:35','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-21 08:46:40'),(6128,4860,'Y','18','021','EC','A','','','AC','0000755212','0000755212','TX00000053279','IL','1','CORREA','JEFFREY','GERSON','','','34','614608974','4128 n belt line rd apt 124',0,'IRVING','TX','75038',NULL,'CY','48113','1992-10-04','M','U',NULL,'N','021','DEN','524791','33348TX002000201','2014-01-01','2013-11-21 17:27:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 00:15:56'),(4749,3764,'Y','18','021','EC','A','','','AC','0000365599','0000365599','TX00000099283','IL','1','Campos','Leticia','','','','34','454337531','1411 GRISSOM LN',0,'EL PASO','TX','79903','2309','CY','48141','1960-01-01','F','M',NULL,'N','021','DEN','1087801','33348TX002000201','2014-01-01','2013-12-08 08:41:42','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 22:15:09'),(4600,3642,'Y','18','021','EC','A','','','AC','0000783208','0000783208','OH00000239256','IL','1','Lombardo','Bruce','','','','34','299486645','6636 STATE ROUTE 753',0,'HILLSBORO','OH','45133','9324','CY','39071','1956-08-05','M','U',':RET:2106-3','N','021','HLT','480302','92036OH006000601','2014-01-01','2013-12-11 19:22:53','261.00',NULL,NULL,'414.90','153.90','R-OH005','OH0','414.90',NULL,0,'2013-12-25 22:05:41'),(2011,1650,'Y','18','021','EC','A','','','AC','0000620339','0000620339','LA00000396302','IL','1','Martin','Celeste','','','','34','458917409','823 OLGA ST',0,'NEW ORLEANS','LA','70119','3841','CY','22071','1979-06-04','F','M',':RET:2106-3','N','021','DEN','620431','18575LA002000201','2014-01-01','2013-11-20 14:03:08','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:02:30'),(15126,12089,'Y','18','024','14','A','','','TE','0000112895','0000112895','','IL','1','Pyle','Hamilton',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-09-12','M','',NULL,NULL,NULL,'','440793','','2013-12-30','2013-12-30 17:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:05:22'),(1757,1454,'N','19','021','EC','A',NULL,NULL,'','0001260013','0000959102','','IL','1','Bepler','Reid','Oneal','','','34','287116112','4598 BURKESHIRE DR',0,'COLUMBUS','OH','43232','6174','CY','39049','2005-10-03','M','',':RET:2106-3','N','021','DEN','2169255','99734OH005000301','2014-01-01','2013-12-24 13:25:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:52'),(25892,20529,'Y','18','021','EC','A','','','AC','0000439630','0000439630','TX00003243500','IL','1','le','thu','t','','','34','808336161','3156 ATRIUM DR',0,'GRAND PRAIRIE','TX','75052','7019','CY','48439','1965-07-10','F','M',':RET:2047-9','N','021','DEN','3275917','33348TX002000201','2014-04-01','2014-02-26 11:40:58','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:04'),(27452,21725,'Y','18','021','EC','A','','','AC','0001086840','0001086840','OH00003502058','IL','1','Davis','Joann','','','','34','291468978','1310 BROAD BLVD',0,'CUYAHOGA FALLS','OH','44223','2431','CY','39153','1949-12-20','F','U',':RET:2106-3','N','021','HLT','3689960','52664OH151001501','2014-04-01','2014-03-04 17:45:17','435.00',NULL,NULL,'802.38','367.38','R-OH012','OH0','802.38',NULL,0,'2014-03-04 21:01:59'),(97,86,'Y','18','021','EC','A','','','AC','0001129288','0001129288','TX00000637623','IL','1','HENDERSON','JOSEPHINE','H','','','34','449801791','309 RAGLAND ST',0,'SWEETWATER','TX','79556','4619','CY','48353','1952-11-18','F','U',':RET:2106-3','T','021','DEN','1233614','33348TX002000201','2014-01-01','2013-12-05 09:45:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:17:37'),(9753,7723,'Y','18','021','EC','A','','','AC','0000664143','0000664143','OH00001161874','IL','1','McCallum','Steven','d','','','34','294480383','6681 N CHESTNUT ST',0,'RAVENNA','OH','44266','3905','CY','39133','1951-07-08','M','M',':RET:2106-3','N','021','HLT','1051244','52664OH152000901','2014-01-01','2013-11-15 12:37:50','175.00',NULL,NULL,'469.28','294.28','R-OH012','OH0','469.28',NULL,0,'2013-12-26 04:46:17'),(23429,18665,'N','19','021','EC','A',NULL,NULL,'','0000520158','0000510463','','IL','1','Mook','Brenden','','','','34','632087086','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','2007-03-18','M','',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-13 22:01:26'),(21601,17249,'N','19','021','EC','A',NULL,NULL,'','0001076598','0000158029','','IL','1','SAMI','KINZA','','','','34','285025955','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','1997-06-10','F','',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(6981,5540,'Y','18','021','EC','A','','','AC','0000573061','0000573061','OH00000275898','IL','1','Hedges','Deborah','Jean','','','34','285629181','4413 BENNETT RD',0,'TOLEDO','OH','43612','1909','CY','39095','1960-06-01','F','M',':RET:2106-3','N','021','DEN','2214724','99734OH005000401','2014-02-01','2013-12-25 00:04:45','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-26 01:47:44'),(3738,2989,'Y','18','021','EC','A','','','AC','0001020887','0001020887','TX00000301226','31','1','RULLAN','SYLVIA','','','','34','633101492','3902 AIDIN ST',0,'LAREDO','TX','78045',NULL,'CY','48479','1967-03-05','F','U',NULL,'N','021','DEN','1180458','33348TX002000201','2014-01-01','2013-12-13 12:23:36','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2013-12-25 21:32:48'),(4490,3559,'Y','18','021','EC','A','','','AC','0000085147','0000085147','OH00001273026','IL','1','Berger','Malerie','','','','34','270582719','1015 Valley Bluff Dr.',0,'Perrysburg','OH','43551',NULL,'CY','39173','1958-08-13','F','U',':RET:2106-3','N','021','DEN','1179186','99734OH005000301','2014-01-01','2013-12-12 17:02:52','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:03:07'),(19043,15166,'Y','18','021','EC','A','','','AC','0001170200','0001170200','TX00001783174','IL','1','Forward','Monique','','','','34','456935921','5002 ANDREA ST',0,'HOUSTON','TX','77021','5110','CY','48201','1973-04-19','F','R',':RET:2054-5','N','021','DEN','2271900','33348TX002000101','2014-03-01','2014-01-17 16:43:14','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-01-20 08:06:38'),(18656,14873,'Y','18','021','EC','A','','','AC','0000427339','0000427339','TX00002407271','31','1','Smallwood','Larka','','','','34','456137980','PO Box 429',0,'La Coste','TX','78039',NULL,'CY','48325','1958-07-29','F','U',NULL,'T','021','DEN','1733375','33348TX002000201','2014-03-01','2014-01-16 14:21:12','0.00',NULL,NULL,'14.61','14.61','R-TX019','TX0','14.61',NULL,0,'2014-01-17 03:35:12'),(16129,12919,'Y','18','021','EC','A','','','AC','0000969450','0000969450','OH00000092011','IL','1','Clift','Linda','F','','','34','296527380','2929 N FEESBURG RD',0,'HAMERSVILLE','OH','45130','8791','CY','39015','1952-12-05','F','M',':RET:2106-3','N','021','HLT','1926720','92036OH006000601','2014-02-01','2014-01-03 15:25:20','0.00',NULL,NULL,'478.41','478.41','R-OH005','OH0','478.41',NULL,0,'2014-01-04 02:05:37'),(16086,12883,'Y','18','021','EC','A','','','AC','0000857113','0000857113','OH00001290271','IL','1','Armstrong','Theodore','J','','','34','274687243','234 Blair Dr',0,'Fairborn','OH','45324',NULL,'CY','39057','1960-07-12','M','M',':RET:2106-3','N','021','DEN','2523555','99734OH005000401','2014-02-01','2014-01-03 16:53:35','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-04 02:04:17'),(21906,17494,'Y','18','021','EC','A','','','AC','0000792308','0000792308','MS00001979171','IL','1','rias','tina','','','','34','427316663','799 W PEARL ST',0,'GRENADA','MS','38901','1840','CY','28043','1974-06-19','F','M',NULL,'N','021','DEN','3301525','46300MS002000101','2014-03-01','2014-02-06 14:02:06','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2014-02-06 21:01:50'),(21747,17366,'Y','18','021','EC','A','','','AC','0000825669','0000825669','TX00001379515','IL','1','FLORES','BLANCA','','','','34','463376520','464 PINEWOOD ST',0,'EL PASO','TX','79907','4349','CY','48141','1953-11-30','F','M',':RET:2106-3','N','021','DEN','3268971','33348TX002000201','2014-03-01','2014-02-05 19:11:54','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-02-06 21:00:18'),(13836,11041,'Y','18','021','EC','A','','','AC','0000607158','0000607158','OH00000930032','IL','1','Rinella','Ron','','','','34','284524202','2459 13TH ST',0,'CUYAHOGA FALLS','OH','44223','2029','CY','39153','1953-06-01','M','U',':RET:2106-3','T','021','HLT','1639713','52664OH152000901','2014-01-01','2013-12-23 10:58:31','485.00',NULL,NULL,'509.80','24.80','R-OH012','OH0','509.80',NULL,0,'2013-12-26 13:12:12'),(13813,11025,'Y','18','021','EC','A','','','AC','0000827155','0000827155','OH00000410558','IL','1','Stear','Christina','Sevilla','','','34','301849481','508 LIBERTY HL',0,'CINCINNATI','OH','45202','6892','CY','39061','1985-06-28','F','R',':RET:2036-2^:RET:2106-3','N','021','HLT','2413933','92036OH005001201','2014-01-01','2013-12-23 09:00:21','0.00',NULL,NULL,'233.35','233.35','R-OH004','OH0','233.35',NULL,0,'2013-12-26 13:11:39'),(13710,10939,'Y','18','021','EC','A','','','AC','0001149877','0001149877','OH00000946497','IL','1','PRINGLE','KIMBERLY','','','','34','288581484','1267 NESTOR AVE',0,'AKRON','OH','44314','1450','CY','39153','1962-07-14','F','M',NULL,'T','021','HLT','2097438','52664OH151001304','2014-01-01','2013-12-23 14:01:01','103.00',NULL,NULL,'478.30','375.30','R-OH012','OH0','478.30',NULL,0,'2013-12-26 13:08:55'),(18333,14639,'Y','18','021','EC','A','','','AC','0000442210','0000442210','OH00002296400','IL','1','ALLEN','GENIA','','','','34','274644973','18 CLERTOMA DR',0,'MILFORD','OH','45150','1606','CY','39025','1959-09-08','F','U',NULL,'N','021','DEN','1462733','99734OH005000401','2014-02-01','2014-01-15 17:05:43','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-16 08:45:13'),(18185,14519,'Y','18','021','EC','A','','','AC','0000956670','0000956670','OH00002372063','IL','1','Line','Steven','','','','34','286665623','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1959-06-13','M','M',':RET:2106-3','T','021','HLT','2739789','92036OH004000501','2014-02-01','2014-01-14 11:16:40','852.93',NULL,NULL,'859.21','6.28','R-OH003','OH0','469.29',NULL,0,'2014-01-15 02:08:02'),(16792,13432,'Y','18','021','EC','A','','','AC','0001166835','0001166835','OH00002321182','IL','1','Donnadio','Mark','','','','34','281729506','2598 COBLENTZ DR',0,'POLAND','OH','44514','2401','CY','39099','1960-10-20','M','U',':RET:2106-3','N','021','DEN','2409592','99734OH005000301','2014-02-01','2014-01-11 14:38:37','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-13 02:18:06'),(15746,12597,'Y','18','024','14','A','','','TE','0000770769','0000770769','','IL','1','CISNEROS','RAUL',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-01-25','M','',NULL,NULL,NULL,'','2075413','','2014-01-02','2014-01-02 12:41:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-03 02:01:00'),(9132,7243,'Y','18','024','14','A','','','TE','0000872294','0000872294','','IL','1','BROWN','DEREK',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1963-08-31','M','',NULL,NULL,NULL,'','1205773','','2013-12-18','2013-12-18 16:04:39',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2013-12-26 04:08:00'),(8938,7087,'Y','18','024','14','A','','','TE','0000338853','0000338853','','IL','1','McKinney','Debra',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-12','F','',NULL,NULL,NULL,'','347228','','2013-12-18','2013-12-18 10:45:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:03:15'),(2452,1994,'N','01','021','EC','A',NULL,NULL,'','0000015218','0000874031','','IL','1','Sabath','Lanko','Shoji','','','34','410371812','4214 Waterside Ct.',0,'Missouri City','TX','77459',NULL,'CY','48157','1958-07-25','F','',':RET:2039-6','N','021','DEN','613568','33348TX002000101','2014-01-01','2013-12-08 20:25:34',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-25 19:34:40'),(2033,1664,'Y','18','021','EC','A','','','AC','0000929032','0000929032','TX00001068606','IL','1','WINN','ABRAHAM','','','Jr','34','451943387','1218 TINY TREE DR',0,'MISSOURI CITY','TX','77489','4134','CY','48157','1953-07-16','M','U',NULL,'N','021','DEN','954534','33348TX002000201','2014-01-01','2013-12-09 18:23:32','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 19:15:24'),(3753,3003,'Y','18','021','EC','A','','','AC','0000500642','0000500642','TX00000910521','IL','1','Millsap','Davella','','','','34','466020635','3110 STILLHOUSE RD',0,'PARIS','TX','75462','2031','CY','48277','1955-06-20','F','M',':RET:2106-3','N','021','DEN','662521','33348TX002000201','2014-01-01','2013-12-13 16:34:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:33:12'),(15388,12309,'Y','18','021','EC','A','','','AC','0001058012','0001058012','OH00001158141','IL','1','Thompson','Aaron','','','','34','273909848','1589 STATTEN CT',0,'PAINESVILLE','OH','44077','5053','CY','39085','1989-01-01','M','R',':RET:2106-3','N','021','HLT','2314553','52664OH151001301','2014-02-01','2014-01-01 11:34:07','0.00',NULL,NULL,'252.53','252.53','R-OH011','OH0','252.53',NULL,1,'2014-01-02 04:25:38'),(21660,17299,'Y','18','024','14','A','','','TE','0001352531','0001352531','','IL','1','Gough','August',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-12-05','M','',NULL,NULL,NULL,'','2861645','','2014-02-05','2014-02-05 12:24:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-02-05 21:30:54'),(16060,12861,'Y','18','021','EC','A','','','AC','0000653212','0000653212','OH00001445972','IL','1','Jones','Amanda','','','','34','288909909','553 Aston View Ln',0,'Cleves','OH','45002',NULL,'CY','39061','1987-05-23','F','U',':RET:2106-3','N','021','DEN','2001773','99734OH005000401','2014-02-01','2014-01-03 10:07:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:29'),(17421,13941,'N','01','021','EC','A',NULL,NULL,'','0000084064','0000877133','','IL','1','Hesson','Eugene','','','','34','271727213','12821 Capetown Ave. NW',0,'Uniontown','OH','44685',NULL,'CY','39151','1971-09-13','M','',':RET:2106-3','N','021','HLT','2462696','52664OH151001304','2014-02-01','2014-01-10 12:06:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,0,'2014-01-13 03:00:27'),(26383,20929,'N','01','021','EC','A',NULL,NULL,'','0002266676','0001428844','','IL','1','Jewell','Linda','Williams','','','34','456804143','13544 MINOU AVE',0,'BATON ROUGE','LA','70809','5425','CY','22033','1952-09-20','F','',':RET:2106-3','N','021','DEN','2951895','18575LA002000201','2014-04-01','2014-02-26 15:30:40',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61','CIC',0,'2014-02-28 07:00:21'),(27575,21807,'Y','18','021','EC','A','','','AC','0000440869','0000440869','OH00003361187','IL','1','Anderson','Clarice','','','','34','279563936','703 EUCLID ST',0,'WILLARD','OH','44890','1241','CY','39077','1954-10-27','F','U',':RET:2106-3','N','021','HLT','3988828','92036OH005002705','2014-04-01','2014-03-04 12:30:02','599.00',NULL,NULL,'702.57','103.57','R-OH006','OH0','507.58','CIC',0,'2014-03-04 21:30:22'),(60,54,'Y','18','021','EC','A','','','AC','0000038354','0000038354','OH00000771274','IL','1','sullivan','thomas','','','','34','219881425','7706 Norwalk Rd',0,'Medina','OH','44256',NULL,'CY','39103','1977-02-07','M','M',NULL,'N','021','DEN','669743','99734OH005000301','2014-01-01','2013-12-05 09:47:36','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2013-12-25 17:16:39'),(251,208,'N','01','021','EC','A',NULL,NULL,'','0000624089','0000796900','','IL','1','Cazes','Bonnie','','','','34','434988916','3515 POYDRAS BAYOU DR',0,'PORT ALLEN','LA','70767','5417','CY','22121','1957-11-19','F','',':RET:2106-3','N','021','DEN','445601','18575LA002000101','2014-01-01','2013-12-05 00:08:18',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 17:21:34'),(25824,20476,'Y','18','021','EC','A','','','AC','0000733653','0000733653','OH00002360286','IL','1','Thompson','Desirae','','','','34','281842009','1810 CHAPEL HILL DR',0,'YOUNGSTOWN','OH','44511','1223','CY','39099','1979-05-10','F','M',':RET:2054-5','N','021','DEN','3351771','99734OH005000301','2014-04-01','2014-02-26 16:38:02','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-02-26 21:00:27'),(6470,5126,'N','01','021','EC','A',NULL,NULL,'','0000119038','0000460558','','IL','1','Belair','Lawrence','','','','34','296500801','10383 GOLDEN RIDGE DR',0,'WADSWORTH','OH','44281','8648','CY','39103','1956-05-09','M','',':RET:2106-3','N','021','HLT','469279','52664OH151001305','2014-01-01','2013-12-10 19:54:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','543.47',NULL,0,'2013-12-26 00:50:06'),(22314,17815,'Y','18','021','EC','A','','','AC','0002392036','0002392036','LA00001854034','IL','1','ROGERS','KENNY','','','','34','433069331','902 CASS ST',0,'SULPHUR','LA','70663','1056','CY','22019','1963-01-15','M','M',NULL,'N','021','DEN','2689398','18575LA002000101','2014-03-01','2014-01-27 08:59:29','0.00',NULL,NULL,'25.02','25.02','R-LA004','LA0','25.02',NULL,0,'2014-02-10 11:00:48'),(5624,4463,'N','01','021','EC','A',NULL,NULL,'','0001049338','0000788163','','IL','1','Burrows','Shervian','','','','34','282704629','3454 OAKLAWN ST',0,'COLUMBUS','OH','43224','3454','CY','39049','1974-10-03','F','',':RET:2054-5','N','021','DEN','1110220','99734OH005000401','2014-01-01','2013-11-26 17:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:30:52'),(20539,16412,'Y','18','021','EC','A','','','AC','0001028095','0001028095','OH00001509326','IL','1','Winget','Mary','','','','34','283481806','2594 Jefferson Place',0,'Stow','OH','44224',NULL,'CY','39153','1949-07-20','F','U',':RET:2106-3','N','021','HLT','2617177','52664OH152000901','2014-03-01','2014-01-29 15:30:18','0.00',NULL,NULL,'490.00','490.00','R-OH012','OH0','490.00',NULL,0,'2014-01-29 21:01:34'),(19881,15859,'Y','18','021','EC','A','','','AC','0001181048','0001181048','OH00001495877','IL','1','JAMISON','DEBORAH','','','','34','286565186','1327 NORTHWOLD ST',0,'LIMA','OH','45801','3515','CY','39003','1956-09-08','F','M',':RET:2106-3','N','021','HLT','2936718','92036OH006001501','2014-03-01','2014-01-24 11:44:55','859.00',NULL,NULL,'893.64','34.64','R-OH002','OH0','425.36',NULL,0,'2014-01-24 21:00:46'),(19783,15771,'Y','18','021','EC','A','','','AC','0000427663','0000427663','OH00002338757','IL','1','Fabian','Donna','','','','34','272561476','1738 Northampton Rd',0,'Akron','OH','44313',NULL,'CY','39153','1954-04-05','F','U',':RET:2106-3','N','021','HLT','2863974','52664OH151001305','2014-03-01','2014-01-23 11:48:55','437.00',NULL,NULL,'580.49','143.49','R-OH012','OH0','580.49',NULL,0,'2014-01-23 21:01:35'),(1306,1081,'Y','18','021','EC','A','','','AC','0000210315','0000210315','TX00001058302','IL','1','Morrow','Jason','Alan','','','34','466833201','2509 JUGLAN DR',0,'VICTORIA','TX','77901','4320','CY','48469','1987-05-24','M','U',':RET:2106-3','T','021','DEN','854922','33348TX002000201','2014-01-01','2013-11-04 17:39:22','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-25 18:31:19'),(19248,15338,'Y','18','021','EC','A','','','AC','0000026399','0000026399','MS00002026305','IL','1','Bradley','Earlean','','','','34','587766702','1277 Murray Road',0,'Edwards','MS','39066',NULL,'CY','28049','1953-06-22','F','M',':RET:2054-5','N','021','DEN','2794652','46300MS002000101','2014-03-01','2014-01-20 13:55:52','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-21 08:46:42'),(18180,14515,'N','01','021','EC','A',NULL,NULL,'','0000359699','0000363792','','IL','1','ELSTON','JOHN','W','','','34','270645901','218 E TOWNLINE STREET',0,'PAYNE','OH','45891',NULL,'CY','39161','1957-11-18','M','',':RET:2106-3','T','021','HLT','1775806','92036OH005001506','2014-02-01','2014-01-14 10:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','590.47',NULL,0,'2014-01-15 02:08:00'),(17256,13808,'Y','18','021','EC','A','','','AC','0000515851','0000515851','OH00002052346','IL','1','SCHEIENNER','HAROLD','','','','34','286548962','30387 HILLIARD BLVD',0,'WESTLAKE','OH','44145','3715','CY','39035','1954-12-14','M','M',NULL,'N','021','DEN','2460263','99734OH005000301','2014-02-01','2014-01-10 11:19:51','0.00',NULL,NULL,'87.78','87.78','R-OH011','OH0','0.00',NULL,0,'2014-01-13 02:23:15'),(2600,2112,'Y','18','021','EC','A','','','AC','0000990038','0000990038','OH00000255303','IL','1','anderson','timothy','','','','34','272505879','487 HIBERNIA DR',0,'CINCINNATI','OH','45238','5116','CY','39061','1950-06-20','M','U',':RET:2106-3','N','021','DEN','1026611','99734OH005000401','2014-01-01','2013-12-01 20:40:38','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:19'),(15269,12206,'Y','18','021','EC','A','','','AC','0000802586','0000802586','OH00000177781','IL','1','THOMAS','OTTO','','','','34','274742479','5454 BLUE CLOUD LN, APT',0,'WESTERVILLE','OH','43081',NULL,'CY','39049','1964-12-30','M','U',NULL,'N','021','DEN','2389144','99734OH005000401','2014-02-01','2013-12-31 18:34:39','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:21:44'),(26463,20990,'Y','18','024','14','A','','','TE','0001594364','0001594364','','IL','1','Gulbengay','Erin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-03-02','F','',NULL,NULL,NULL,'','3460524','','2014-03-31','2014-02-27 15:14:52',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-28 07:30:32'),(27311,21624,'Y','18','021','EC','A','','','AC','0001100602','0001100602','TX00002926837','IL','1','Wilcox','Morgan','','','','34','590167941','14403 PENNLAND LN',0,'CYPRESS','TX','77429','4387','CY','48201','1982-10-30','F','U',NULL,'N','021','DEN','3454882','33348TX002000201','2014-04-01','2014-03-04 14:05:03','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-04 21:00:39'),(944,780,'N','19','021','EC','A',NULL,NULL,'','0000321006','0000180971','','IL','1','Bundy','Aiden','','','','34','271131301','218 BAKER ST',0,'LODI','OH','44254','1407','CY','39103','2006-11-07','M','',':RET:2106-3','N','021','DEN','133654','99734OH005000301','2014-01-01','2013-10-28 22:38:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:09:26'),(13808,11021,'Y','18','024','14','A','','','TE','0000700375','0000700375','','IL','1','Crutcher','Carrie',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-12-15','F','',NULL,NULL,NULL,'','2382402','','2013-12-22','2013-12-22 19:38:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:11:33'),(24075,19146,'N','19','021','EC','A',NULL,NULL,'','0000790924','0000333912','','IL','1','morris','morgan','','','','34','289961295','104 CENTER ST',0,'SEVILLE','OH','44273','9504','CY','39103','1993-07-23','F','',':RET:2106-3','N','021','HLT','3076050','52664OH151001305','2014-03-01','2014-02-14 19:15:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:19'),(1620,1354,'Y','18','021','EC','A','','','AC','0001041352','0001041352','TX00000809574','IL','1','Contreras','Colleen','','','','34','216640715','150 Wildrose Ave',0,'San Antonio','TX','78209',NULL,'CY','48029','1967-06-08','F','R',':RET:2106-3','N','021','DEN','2483563','33348TX002000201','2014-01-01','2013-12-24 13:52:26','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2013-12-25 18:52:34'),(1672,1396,'N','19','021','EC','A',NULL,NULL,'','0000175106','0000437973','','IL','1','Phelps','Charley','','','','34','849473738','500 HARRISON LN',0,'ANDERSON','OH','45244','2205','CY','39025','2012-03-17','F','',':RET:2106-3','N','021','HLT','1387674','92036OH005000605','2014-01-01','2013-12-24 05:22:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 18:53:55'),(4389,3489,'N','01','021','EC','A',NULL,NULL,'','0000078743','0000547861','','IL','1','Dawson','Catherine','','','','34','255190066','4000 WOODFORD RD',0,'CINCINNATI','OH','45213','2376','CY','39061','1959-03-03','F','',NULL,'N','021','DEN','242434','99734OH005000401','2014-01-01','2013-12-12 11:12:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:00:50'),(21911,17499,'Y','18','021','EC','A','','','AC','0000523447','0000523447','OH00001750461','IL','1','COTTRELL','BLANCHE','','','','34','297645863','220 Spring St',0,'Greenfield','OH','45123',NULL,'CY','39071','1958-12-11','F','M',NULL,'N','021','HLT','2275999','92036OH004000601','2014-03-01','2014-02-06 16:14:04','244.00',NULL,NULL,'384.93','140.93','R-OH005','OH0','384.93',NULL,0,'2014-02-06 21:01:54'),(5485,4354,'N','01','021','EC','A',NULL,NULL,'','0000414690','0001261199','','IL','1','Johnson','Patricia','M','','','34','275585944','2410 GATETREE LN',0,'BATAVIA','OH','45103','8951','CY','39025','1953-02-20','F','',':RET:2106-3','N','021','HLT','1944088','92036OH005000605','2014-01-01','2013-12-19 09:44:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','582.60',NULL,0,'2013-12-25 23:10:55'),(19558,15591,'Y','18','021','EC','A','','','AC','0002009275','0002009275','LA00001462547','IL','1','Watson','Cynthia','','','','34','438610715','1734 SAINT LOUIS ST',0,'BOGALUSA','LA','70427','5248','CY','22117','1974-07-27','F','U',':RET:2054-5','N','021','DEN','2781115','18575LA002000101','2014-03-01','2014-01-22 17:47:59','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-23 03:02:32'),(7701,6098,'Y','18','021','EC','A','','','AC','0000919381','0000919381','OH00000233132','IL','1','robinson','steven','','','','34','288522756','5909 alice drive',0,'westerville','OH','43081',NULL,'CY','39049','1952-08-31','M','R',':RET:2106-3','N','021','DEN','1466067','99734OH005000401','2014-01-01','2013-12-20 09:09:48','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2013-12-26 03:01:16'),(26152,20735,'Y','18','021','EC','A','','','AC','0000120142','0000120142','OH00002476469','IL','1','DOENCH','SANDRA','','','','34','289506139','135 LEE CT',0,'MONROE','OH','45050','1605','CY','39017','1951-03-07','F','M',NULL,'N','021','DEN','3184825','99734OH005000401','2014-04-01','2014-02-27 14:54:25','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:29'),(15974,12784,'Y','18','021','EC','A','','','AC','0000096139','0000096139','TX00000356765','IL','1','LEDESMA','ISELA','','','','34','464852050','2130 DOMINGO TREVINO DR',0,'MISSION','TX','78572','1435','CY','48215','1987-06-20','F','M',NULL,'T','021','DEN','1999211','33348TX002000201','2014-02-01','2014-01-02 21:20:07','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-04 02:00:41'),(2123,1743,'Y','18','021','EC','A','','','AC','0000910499','0000910499','OH00000687190','IL','1','Dickinson','Freda','Diane','','','34','294562079','2018 HIGHBRIDGE RD',0,'CUYAHOGA FALLS','OH','44223','1316','CY','39153','1954-10-06','F','R',':RET:2106-3','N','021','DEN','38580','99734OH005000401','2014-01-01','2013-12-10 14:21:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:17:46'),(14737,11766,'Y','18','021','EC','A','','','AC','0001046845','0001046845','OH00001741250','IL','1','Smith','Mitchell','','','','34','290822329','8665 twp. Rd. 460',0,'Loudonville','OH','44842',NULL,'CY','39075','1974-09-28','M','U',':RET:2106-3','N','021','HLT','1406838','52664OH151001501','2014-02-01','2013-12-28 16:20:40','141.00',NULL,NULL,'337.54','196.54','R-OH014','OH0','337.54',NULL,1,'2013-12-29 11:09:56'),(24729,19632,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000253096','','IL','1','HENRY','QUAN DEZ','','','','34','270088561','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2002-09-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:39:07'),(9288,7366,'Y','18','021','EC','A','','','AC','0000006959','0000006959','OH00000130859','IL','1','MCCALL','YVONNE','M','','','34','294548941','2994 CONLIN DR',0,'AKRON','OH','44319','2508','CY','39153','1963-11-16','F','U',':RET:2106-3','N','021','DEN','827197','99734OH005000301','2014-01-01','2013-11-30 17:43:11','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 04:16:05'),(15248,12188,'Y','18','021','EC','A','','','AC','0000627884','0000627884','OH00001981057','31','1','nicholas','kent','','','','34','270785225','po box 19',0,'christiansburg','OH','45389',NULL,'CY','39021','1966-12-27','M','M',':RET:2106-3','T','021','HLT','1411810','92036OH003000505','2014-02-01','2013-12-30 11:06:06','687.00',NULL,NULL,'1016.07','329.07','R-OH003','OH0','446.20',NULL,0,'2014-01-01 12:08:54'),(21872,17462,'N','19','021','EC','A',NULL,NULL,'','0002388442','0001478778','','IL','1','BERLIN','TYLER','','','','34','302929992','4000 LAKEWAY BLVD',0,'BENTON','LA','71006','9325','CY','22015','1991-03-04','M','',':RET:2106-3','N','021','DEN','3036569','18575LA002000201','2014-03-01','2014-02-05 22:07:15',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-06 21:01:26'),(16064,12865,'Y','18','021','EC','A','','','AC','0000748196','0000748196','OH00001126841','IL','1','Zerbe','Harry','','','','34','401395865','3908 S MADISON AVE',0,'CINCINNATI','OH','45212','4022','CY','39061','1987-12-23','M','U',NULL,'N','021','DEN','2232338','99734OH005000401','2014-02-01','2014-01-03 10:43:47','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-04 02:03:36'),(17899,14297,'Y','18','021','EC','A','','','AC','0000221323','0000221323','OH00001746045','IL','1','COOK','CELESTE','','','','34','291780521','4361 Clarkwood Pkwy',0,'Warrensville','OH','44128',NULL,'CY','39035','1980-12-06','F','U',':RET:2054-5','N','021','DEN','1477026','99734OH005000401','2014-02-01','2014-01-14 18:08:58','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:06:22'),(4632,3670,'Y','18','021','EC','A','','','AC','0000490414','0000490414','MS00000608924','IL','1','Robinson','Joseph','','','','34','587513153','138 COUNTY ROAD 299',0,'IUKA','MS','38852','6821','CY','28141','1984-09-26','M','U',':RET:2106-3','N','021','DEN','902752','46300MS002000101','2014-01-01','2013-12-12 15:07:24','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 22:06:34'),(6693,5305,'Y','18','021','EC','A','','','AC','0000841882','0000841882','OH00000107752','IL','1','Olds','Ben','','','','34','280666103','2115 Pinebrook Trail',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1958-01-18','M','U',':RET:2106-3','N','021','HLT','96870','52664OH151001305','2014-01-01','2013-11-04 22:13:39','350.00',NULL,NULL,'497.31','147.31','R-OH012','OH0','497.31',NULL,0,'2013-12-26 01:01:38'),(3877,3105,'Y','18','021','EC','A','','','AC','0000665527','0000665527','LA00000111072','IL','1','LAVINE','SALLY','ANN','','','34','433945286','114 CROFTEN ST',0,'NEW IBERIA','LA','70563',NULL,'CY','22045','1951-11-06','F','U',':RET:2054-5','N','021','DEN','1005106','18575LA002000201','2014-01-01','2013-12-13 13:19:08','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-25 21:36:20'),(134,116,'Y','18','021','EC','A','','','AC','0000001006','0000001006','OH00001251561','IL','1','Pieronek','Sherri','','','','34','301560846','9081 Milford Drive',0,'Northfield','OH','44067',NULL,'CY','39153','1956-08-11','F','U',NULL,'T','021','HLT','204638','52664OH152000901','2014-01-01','2013-12-04 20:27:04','457.77',NULL,NULL,'457.77','0.00','R-OH012','OH0','457.77',NULL,0,'2013-12-25 17:18:33'),(14628,11675,'Y','18','021','EC','A','','','AC','0000691839','0000691839','OH00000531928','IL','1','STIFT','CATHY','','','','34','295520770','1692 WILDERNESS RIDGE RD',0,'MILFORD','OH','45150','1527','CY','39025','1951-02-05','F','M',':RET:2106-3','T','021','HLT','2181082','92036OH004000601','2014-02-01','2013-12-27 12:23:12','232.00',NULL,NULL,'570.30','338.30','R-OH005','OH0','570.30',NULL,0,'2013-12-28 03:37:06'),(25931,20563,'N','01','021','EC','A',NULL,NULL,'','0000127017','0000934171','','IL','1','WHITE','RAY','','','','34','465069953','50 COOPER CIR',0,'DE KALB','TX','75559','1305','CY','48037','1956-09-18','M','',NULL,'N','021','DEN','3571101','33348TX002000201','2014-03-01','2014-02-26 16:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 21:01:26'),(7712,6106,'Y','18','024','14','A','','','TE','0001207139','0001207139','','IL','1','Alvarado','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-08-18','M','',NULL,NULL,NULL,'','2428279','','2013-12-20','2013-12-20 10:01:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:01:32'),(21204,16944,'Y','18','021','EC','A','','','AC','0002293461','0002293461','LA00001842006','IL','1','Nguyen','Nhai','','','','34','586507721','301 GRIZZAFFI ST',0,'MORGAN CITY','LA','70380','2360','CY','22101','1957-04-18','F','U',':RET:2047-9','N','021','DEN','3205352','18575LA002000201','2014-03-01','2014-02-03 10:22:19','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-03 21:00:55'),(19812,15796,'Y','18','021','EC','A','','','AC','0000840061','0000840061','TX00001746231','IL','1','SPAULDING','JERRY','','','','34','541760357','21005 LITTLE LN',0,'LAGO VISTA','TX','78645','4600','CY','48453','1958-02-26','M','U',':RET:2106-3','N','021','DEN','1758765','33348TX002000201','2014-03-01','2014-01-23 19:17:42','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-24 21:00:09'),(7017,5571,'Y','18','021','EC','A','','','AC','0001120678','0001120678','TX00000397346','IL','1','Blanco','Alfredo','','','','34','459493584','510 S. Westgate Dr.',0,'Weslaco','TX','78596',NULL,'CY','48215','1979-11-09','M','U',':RET:2106-3','N','021','DEN','1451903','33348TX002000201','2014-01-01','2013-12-24 20:35:43','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2013-12-26 01:48:42'),(6647,5274,'N','01','021','EC','A',NULL,NULL,'','0001037553','0001184947','','IL','1','Arriaga','Jose','Juan','','','34','459294274','4623 County Road 1170',0,'Lubbock','TX','79407',NULL,'CY','48303','1958-06-24','M','',':RET:2106-3','N','021','DEN','223668','33348TX002000201','2014-01-01','2013-11-12 15:31:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 01:00:29'),(28462,22521,'Y','18','021','EC','A','','','AC','0000440878','0000440878','OH00002759246','IL','1','Alsept','Adam','','','','34','292980373','322 E MAIN ST',0,'WEST CARROLLTON','OH','45449','1308','CY','39113','1983-04-08','M','U',':RET:2106-3','N','021','DEN','4002738','99734OH005000301','2014-04-01','2014-03-06 19:47:28','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2014-03-07 21:31:26'),(14035,11180,'Y','18','021','EC','A','','','AC','0000098997','0000098997','OH00000347116','IL','1','Day','Veronica','','','','34','279842908','5979 Meadowcreek Drive',0,'Milford','OH','45150',NULL,'CY','39025','1985-03-14','F','U',':RET:2106-3','N','021','HLT','2182036','92036OH005000605','2014-01-01','2013-12-23 14:59:33','100.00',NULL,NULL,'233.35','133.35','R-OH005','OH0','233.35',NULL,0,'2013-12-26 13:16:59'),(22352,17852,'Y','18','024','14','A','','','TE','0000024361','0000024361','','IL','1','jones','gerald',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-07-21','M','',NULL,NULL,NULL,'','1130406','','2014-02-28','2014-02-10 08:53:47',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-02-10 21:00:04'),(3393,2722,'Y','18','021','EC','A','','','AC','0001960924','0001960924','LA00000671285','IL','1','Grant','Mariah','','','','34','433670251','7730 NEWCASTLE ST',0,'NEW ORLEANS','LA','70126','1628','CY','22071','1976-04-05','F','M',':RET:2054-5','N','021','DEN','1606769','18575LA002000201','2014-01-01','2013-12-22 00:40:59','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:17:54'),(6780,5378,'Y','18','021','EC','A','','','AC','0001056113','0001056113','TX00001231758','IL','1','BARNER','VICTOR','CARNEL','','','34','463392239','973 COUNTY ROAD 408',0,'KIRBYVILLE','TX','75956','1422','CY','48241','1973-05-19','M','U',':RET:2106-3','T','021','DEN','270556','33348TX002000201','2014-01-01','2013-11-25 15:21:31','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 01:16:50'),(19600,15624,'Y','18','021','EC','A','','','AC','0000564233','0000564233','OH00002404836','IL','1','Houstin','Kathleen','','','','34','276546427','5109 WINONA DR',0,'TOLEDO','OH','43613','2725','CY','39095','1957-07-05','F','U',':RET:2106-3','N','021','HLT','1921885','92036OH005002606','2014-03-01','2014-01-21 23:03:36','331.00',NULL,NULL,'454.92','123.92','R-OH001','OH0','454.92',NULL,0,'2014-01-23 03:02:47'),(8982,7125,'Y','18','021','EC','A','','','AC','0000437961','0000437961','OH00001191993','IL','1','Carpenter','Dana','','','','34','284881849','4967 SCHROER AVE',0,'CINCINNATI','OH','45238','5727','CY','39061','1982-11-13','F','M',':RET:2106-3','N','021','DEN','1827005','99734OH005000401','2014-01-01','2013-12-18 16:05:42','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:22'),(20319,16222,'Y','18','021','EC','A','','','AC','0000184848','0000184848','TX00002136183','31','1','Espinosa','Celia','R','','','34','378602114','P.O.Box 1034',0,'Progreso','TX','78579',NULL,'CY','48215','1956-08-11','F','M',NULL,'N','021','DEN','3530354','33348TX002000201','2014-03-01','2014-01-28 14:05:39','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-28 21:00:54'),(743,616,'Y','18','021','EC','A','','','AC','0001241620','0001241620','TX00000811404','IL','1','Ibekwe','John','','','','34','638846686','416 PECAN HOLLOW DR',0,'COPPELL','TX','75019','4848','CY','48113','1956-07-29','M','M',':RET:2054-5','N','021','DEN','640755','33348TX002000201','2014-01-01','2013-12-16 00:44:23','0.00',NULL,NULL,'88.07','88.07','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:04:07'),(2146,1764,'Y','18','021','EC','A','','','AC','0000960575','0000960575','OH00000570363','IL','1','Lewis','Jack','','','','34','285502772','9150 BLUE CREEK RD',0,'BLUE CREEK','OH','45616','9045','CY','39001','1950-07-25','M','M',':RET:2106-3','T','021','HLT','272092','92036OH004000601','2014-01-01','2013-12-10 10:53:58','547.00',NULL,NULL,'585.97','38.97','R-OH005','OH0','585.97',NULL,0,'2013-12-25 19:18:25'),(18650,14868,'Y','18','021','EC','A','','','AC','0000290635','0000290635','TX00001851429','IL','1','session','christina','n','','','34','453511739','1658 HIGHWAY 304',0,'SMITHVILLE','TX','78957','2369','CY','48021','1980-08-03','F','U',':RET:2054-5','N','021','DEN','1403687','33348TX002000201','2014-03-01','2014-01-16 10:00:09','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-17 03:35:09'),(20170,16096,'Y','18','024','14','A','','','TE','0001214823','0001214823','','IL','1','laurianti','carl',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-07-29','M','',NULL,NULL,NULL,'','2988478','','2014-01-27','2014-01-27 10:21:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:14'),(19261,15350,'Y','18','024','14','A','','','TE','0000082583','0000082583','','IL','1','Jones','Billy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-10-09','M','',NULL,NULL,NULL,'','2407160','','2014-01-20','2014-01-20 11:34:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-21 08:46:49'),(1385,1150,'Y','18','021','EC','A','','','AC','0001293668','0001293668','LA00000869762','IL','1','Hobbs','Alice','','','','34','436047098','5403 Airview Dr',0,'Alexandria','LA','71302',NULL,'CY','22079','1957-02-15','F','U',':RET:2054-5','N','021','DEN','2247958','18575LA002000201','2014-01-01','2013-12-24 10:35:36','0.00',NULL,NULL,'14.61','14.61','R-LA006','LA0','14.61',NULL,0,'2013-12-25 18:46:12'),(24896,19739,'Y','18','021','EC','A','','','AC','0000864125','0000864125','TX00002248581','IL','1','molina','patricia','','','','34','464430929','2322 DON BETO',0,'LAREDO','TX','78041','2015','CY','48479','1954-03-17','F','U',':RET:2106-3','N','021','DEN','3320821','33348TX002000101','2014-04-01','2014-02-19 14:47:58','0.00',NULL,NULL,'25.02','25.02','R-TX012','TX0','25.02','CIC',0,'2014-02-20 05:40:17'),(23850,18977,'Y','18','021','EC','A','','','AC','0000632729','0000632729','OH00002008050','IL','1','Kilpatrick','Laura','','','','34','237047857','401 Prentiss Avenue',0,'Findlay','OH','45840',NULL,'CY','39063','1961-06-09','F','M',':RET:2106-3','N','021','HLT','2771334','92036OH005001506','2014-03-01','2014-02-14 11:40:58','415.00',NULL,NULL,'429.60','14.60','R-OH002','OH0','429.60',NULL,0,'2014-02-14 21:31:58'),(23845,18973,'Y','18','021','EC','A','','','AC','0001196859','0001196859','OH00002141836','IL','1','Perez','Raquel','','','','34','272887131','995 S Main St',0,'Bowling Green','OH','43402',NULL,'CY','39173','1974-09-17','F','U',NULL,'N','021','HLT','2716779','92036OH004002601','2014-03-01','2014-02-13 22:51:16','0.00',NULL,NULL,'197.87','197.87','R-OH001','OH0','197.87',NULL,0,'2014-02-14 21:31:55'),(1438,1200,'Y','18','021','EC','A','','','AC','0000338634','0000338634','MS00000705098','IL','1','WHATLEY','MICHAEL','','','','34','216764647','92 FIRST COLONY CIR',0,'COLUMBUS','MS','39702','7900','CY','28087','1959-10-12','M','U',':RET:2106-3','N','021','DEN','1384681','46300MS002000101','2014-01-01','2013-12-24 11:08:18','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-25 18:47:46'),(8163,6458,'Y','18','021','EC','A','','','AC','0000357523','0000357523','LA00000524662','IL','1','CALLAHAN','BOB','','','','34','435942485','37180 LONE STAR ROAD',0,'WHITE CASTLE','LA','70788',NULL,NULL,NULL,'1952-06-10','M','U',':RET:2106-3','N','021','DEN','457676','18575LA002000101','2014-01-01','2013-11-22 09:16:53','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:16:24'),(5017,3976,'Y','18','024','14','A','','','TE','0000611924','0000611924','','IL','1','Bonnington','Thomas','Edward',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-01-23','M','',NULL,NULL,NULL,'','1117219','','2013-12-07','2013-12-07 14:04:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:47:27'),(7101,5632,'Y','18','021','EC','A','','','AC','0000659913','0000659913','OH00000966645','IL','1','mcmahon','brian','','','','34','050607987','1587 ELIZABETH PL',0,'CINCINNATI','OH','45237','5622','CY','39061','1960-04-08','M','U',NULL,'N','021','HLT','1497844','92036OH004001201','2014-01-01','2013-12-24 18:53:37','0.00',NULL,NULL,'352.13','352.13','R-OH004','OH0','352.13',NULL,0,'2013-12-26 01:50:45'),(6280,4980,'Y','18','021','EC','A','','','AC','0000927284','0000927284','OH00000070017','IL','1','miller','randy','','','','34','289528760','28 beechwood dr',0,'youngstown','OH','44512',NULL,'CY','39099','1952-07-22','M','M',':RET:2106-3','N','021','DEN','558732','99734OH005000401','2014-01-01','2013-12-10 20:10:49','0.00',NULL,NULL,'31.57','31.57','R-OH013','OH0','0.00',NULL,0,'2013-12-26 00:45:21'),(25146,19948,'Y','18','021','EC','A','','','AC','0000853480','0000853480','TX00003184609','IL','1','Guerra','Guadalupe','','','','34','450899600','1201 E WARREN AVE',0,'KINGSVILLE','TX','78363','6472','CY','48273','1982-05-23','M','M',NULL,'N','021','DEN','2906292','33348TX002000201','2014-04-01','2014-02-21 12:11:28','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-21 22:00:14'),(24628,19546,'Y','18','021','EC','A','','','AC','0001888236','0001888236','LA00002558648','IL','1','CAREY','DENISE','RENDELL','','','34','438597142','36470 MARCELL RD',0,'GEISMAR','LA','70734','3107','CY','22005','1972-09-30','F','U',':RET:2054-5','N','021','DEN','2875540','18575LA002000201','2014-04-01','2014-02-19 09:07:11','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:17:24'),(1689,1411,'Y','18','021','EC','A','','','AC','0002083361','0002083361','LA00001549137','IL','1','YOUNG','BRENDA','','','','34','439982458','7102 YOUNG AVE',0,'PORT ALLEN','LA','70767','4747','CY','22121','1954-11-29','F','U',':RET:2054-5','N','021','DEN','2570789','18575LA002000101','2014-01-01','2013-12-24 17:27:24','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 18:54:24'),(6931,5503,'Y','18','021','EC','A','','','AC','0000301895','0000301895','OH00000531871','31','1','Wallace','Elizabeth','','','','34','278827640','512 MADERA ST',0,'LODI','OH','44254','1120','CY','39103','1984-05-04','F','M',':RET:2106-3','N','021','DEN','1462174','99734OH005000401','2014-01-01','2013-12-24 20:03:01','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:46:32'),(4359,3461,'Y','18','021','EC','A','','','AC','0000162255','0000162255','OH00001311124','IL','1','Quaintance','Patrick','','','','34','270863992','7534 VALHALLA DR',0,'MAUMEE','OH','43537','9512','CY','39095','1987-02-23','M','U',':RET:2106-3','N','021','HLT','1819719','92036OH006002601','2014-01-01','2013-12-17 13:42:17','103.00',NULL,NULL,'158.35','55.35','R-OH001','OH0','158.35',NULL,0,'2013-12-25 21:53:41'),(6585,5221,'Y','18','021','EC','A','','','AC','0000920784','0000920784','OH00001276445','IL','1','Myers','Melissa','','','','34','274805763','10140 STATE ROUTE 132',0,'PLEASANT PLAIN','OH','45162','9789','CY','39165','1968-01-20','F','M',NULL,'N','021','HLT','187408','92036OH003001205','2014-01-01','2013-12-11 12:21:23','486.00',NULL,NULL,'741.83','255.83','R-OH004','OH0','323.72',NULL,0,'2013-12-26 00:53:05'),(4402,3500,'Y','18','021','EC','A','','','AC','0000447445','0000447445','OH00001036183','IL','1','MEIDT','KYLE','MARIE','','','34','283463904','4811 LARKHAVEN DR',0,'TOLEDO','OH','43623','3053','CY','39095','1957-12-02','F','M',':RET:2106-3','N','021','DEN','1187087','99734OH005000401','2014-01-01','2013-12-12 14:18:08','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-25 22:01:11'),(254,211,'Y','18','021','EC','A','','','AC','0000118408','0000118408','LA00000974683','IL','1','Hall','Rondle','','','','34','524375373','1113 Canal St',0,'New Orleans','LA','70112',NULL,'CY','22071','1979-08-08','M','U',':RET:2106-3','T','021','DEN','318800','18575LA002000101','2014-01-01','2013-12-05 14:36:57','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 17:21:38'),(3871,3099,'N','19','021','EC','A',NULL,NULL,'','0000852787','0000851665','','IL','1','LINDE','WILLIAM','CONNOR','','','34','433754183','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1988-10-03','M','',':RET:2106-3','N','021','DEN','934813','18575LA002000201','2014-01-01','2013-12-13 09:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 21:36:12'),(25723,20403,'Y','18','021','EC','A','','','AC','0002399279','0002399279','LA00002037995','IL','1','GREGERSON','SETH','','','','34','433751252','1917 IOWA AVE',0,'KENNER','LA','70062',NULL,'CY','22051','1988-06-28','M','U',':RET:2106-3','N','021','DEN','2812295','18575LA002000201','2014-04-01','2014-02-23 21:40:01','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 09:30:29'),(26396,20936,'Y','18','024','14','A','','','TE','0001167985','0001167985','','IL','1','Mollohan','Nicole',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-12-08','F','',NULL,NULL,NULL,'','1744072','','2014-02-28','2014-02-26 14:11:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-28 07:00:28'),(7890,6240,'Y','18','021','EC','A','','','AC','0000659881','0000659881','OH00001121537','IL','1','Brown','Bonnie','','','','34','278643030','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1957-04-20','F','M',':RET:2106-3','N','021','HLT','1394898','92036OH005002605','2014-01-01','2013-12-20 08:35:34','724.00',NULL,NULL,'930.13','206.13','R-OH001','OH0','454.92',NULL,0,'2013-12-26 03:05:36'),(25493,20223,'Y','18','021','EC','A','','','AC','0001174845','0001174845','MS00002599994','IL','1','CRUMB','BERNICE','','','','34','412927518','233 HOLLAND RD',0,'HOLLY SPRINGS','MS','38635','9499','CY','28093','1950-07-06','F','M',NULL,'N','021','DEN','2808733','46300MS002000201','2014-04-01','2014-02-25 17:35:31','0.00',NULL,NULL,'15.85','15.85','R-MS001','MS0','15.85',NULL,0,'2014-02-25 21:31:48'),(24443,19415,'N','01','021','EC','A',NULL,NULL,'','0001040897','0000421513','','IL','1','SNYDER','PAUL','','','','34','292441874','27 COMO ST',0,'STRUTHERS','OH','44471','1602','CY','39099','1949-08-11','M','',NULL,'N','021','HLT','2633971','92036OH002003201','2014-04-01','2014-02-18 10:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','838.57',NULL,0,'2014-02-18 22:01:20'),(21767,17382,'Y','18','024','14','A','','','TE','0000426424','0000426424','','IL','1','Crowe','Kathy','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1953-10-28','F','',NULL,NULL,NULL,'','2446070','','2014-02-21','2014-02-06 06:05:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-06 21:00:30'),(3584,2874,'N','01','021','EC','A',NULL,NULL,'','0001175706','0000950671','','IL','1','Taylor','Tina','M','','','34','275563422','1369 Irvin Rd.',0,'Blanchester','OH','45107',NULL,'CY','39027','1954-02-23','F','',':RET:2106-3','N','021','HLT','1409126','92036OH004000601','2014-01-01','2013-12-22 11:20:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','449.32',NULL,0,'2013-12-25 21:22:48'),(6535,5181,'N','19','021','EC','A',NULL,NULL,'','0001000382','0000775690','','IL','1','Kwong','Keilam','Cheryl','','','34','632586938','17618 Cleeves Dr.',0,'Richmond','TX','77407',NULL,'CY','48157','1992-12-22','F','',':RET:2034-7','N','021','DEN','688784','33348TX002000201','2014-01-01','2013-12-10 22:24:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-26 00:51:46'),(15605,12483,'N','19','021','EC','A',NULL,NULL,'','0000066261','0000421479','','IL','1','Mecklenborg','Jack','','','','34','286154917','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2009-09-26','M','',':RET:2106-3','N','021','DEN','1692472','99734OH005000301','2014-02-01','2013-12-31 15:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:41'),(6201,4914,'Y','18','021','EC','A','','','AC','0000398574','0000398574','OH00001042541','IL','1','Reed','Andrea','','','','34','290821200','41 PENNSYLVANIA AVE',0,'WATERVILLE','OH','43566','1060','CY','39095','1970-12-26','F','U',NULL,'N','021','DEN','229079','99734OH005000401','2014-01-01','2013-10-16 02:06:57','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2013-12-26 00:30:37'),(26075,20677,'N','19','021','EC','A',NULL,NULL,'','0000324885','0000183552','','S3','1','URTON','MARIA','','','','34','293082931','501 LANTERN GLOW CT',0,'LEBANON','OH','45036','8029','CY','39165','2004-01-31','M','',':RET:1002-5^:RET:2106-3','N','021','HLT','2766460','92036OH004001201','2014-03-01','2014-02-26 17:38:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-26 21:02:46'),(25509,20238,'Y','18','021','EC','A','','','AC','0000938584','0000938584','OH00002199552','IL','1','HOLSINGER','TERRY','ALLEN','','','34','279622399','420 SOUTH WEST ST.',0,'HILLSBORO','OH','45133',NULL,'CY','39071','1958-07-18','M','M',NULL,'T','021','HLT','3814901','92036OH004000601','2014-04-01','2014-02-25 13:44:55','792.00',NULL,NULL,'866.48','74.48','R-OH005','OH0','442.67',NULL,0,'2014-02-25 21:32:00'),(5771,4584,'Y','18','024','14','A','','','TE','0000645975','0000645975','','IL','1','Eck','Kyle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-09-02','M','',NULL,NULL,NULL,'','2255413','','2013-12-23','2013-12-23 22:34:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:46:48'),(24177,19208,'Y','18','021','EC','A','','','AC','0000688335','0000688335','OH00002507490','IL','1','Porter','Thomas','','','','34','291448039','522 Ledge Rd.',0,'Macedonia','OH','44056',NULL,'CY','39153','1959-08-24','M','M',':RET:2106-3','N','021','HLT','3797182','52664OH152000901','2014-03-01','2014-02-15 18:01:55','803.00',NULL,NULL,'816.70','13.70','R-OH012','OH0','348.73',NULL,0,'2014-02-16 19:00:06'),(13908,11093,'Y','18','024','14','A','','','TE','0000896951','0000896951','','IL','1','Biggert','Robin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1961-09-26','F','',NULL,NULL,NULL,'','1835997','','2013-12-23','2013-12-23 08:45:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:13:53'),(5234,4153,'N','19','021','EC','A',NULL,NULL,'','0000446277','0000691826','','IL','1','Kress','Nicholas','R','','','34','269085124','2525 SUSSEX DR',0,'CLINTON','OH','44216','9726','CY','39153','2002-07-17','M','',':RET:2106-3','N','021','HLT','1716068','52664OH151001301','2014-01-01','2013-12-18 19:51:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:04:48'),(20203,16120,'N','01','021','EC','A',NULL,NULL,'','0000728747','0000647096','','IL','1','Steinert','Joshua','','','','34','113722808','4586 Lakeland Dr',0,'Batavia','OH','45103',NULL,'CY','39025','1981-01-10','M','',NULL,'N','021','HLT','1868716','92036OH006000601','2014-03-01','2014-01-27 12:12:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','203.95',NULL,0,'2014-01-27 21:01:33'),(19603,15625,'N','19','021','EC','A',NULL,NULL,'','0000727314','0000460607','','IL','1','SPORLEDER','KELSEY','RAE','','','34','296942192','6020 MAIN ST',0,'SYLVANIA','OH','43560','1265','CY','39095','1992-04-27','F','',':RET:2106-3','N','021','HLT','2809126','92036OH005002604','2014-03-01','2014-01-22 10:49:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','194.99',NULL,0,'2014-01-23 03:02:48'),(5482,4352,'N','01','021','EC','A',NULL,NULL,'','0000959087','0000005821','','IL','1','brinkman','roger','','','','34','273509793','835 PINEHURST DR',0,'delphos','OH','45833',NULL,'CY','39161','1950-05-08','M','',':RET:2106-3','N','021','HLT','1999733','92036OH005001501','2014-01-01','2013-12-19 09:42:23',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','649.68',NULL,0,'2013-12-25 23:10:52'),(18019,14395,'N','19','021','EC','A',NULL,NULL,'','0000317360','0000680868','','S1','1','Hull','Jason','','','','34','676650078','1003 Wilmington Ave',0,'Dayton','OH','45420',NULL,'CY','39113','2013-12-11','M','',':RET:2106-3','N','021','DEN','2558646','99734OH005000301','2014-02-01','2014-01-14 12:36:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:07:05'),(29051,22993,'Y','18','021','EC','A','','','AC','0000249182','0000249182','OH00003546470','IL','1','JONES','SANDRA','','','','34','293529410','5875 GROVEWOOD DR',0,'MENTOR','OH','44060','2049','CY','39085','1952-05-02','F','U',NULL,'N','021','DEN','4081348','99734OH005000401','2014-04-01','2014-03-10 14:43:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-10 21:01:46'),(14619,11668,'Y','18','024','14','A','','','TE','0000399894','0000399894','','IL','1','Green','Angela',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-19','F','',NULL,NULL,NULL,'','1656723','','2013-12-27','2013-12-27 10:27:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-28 03:36:53'),(25524,20250,'Y','18','021','EC','A','','','AC','0001220886','0001220886','OH00001692083','IL','1','PLATTENBURG','TED','','','','34','268685315','54 FLEMING RD',0,'CINCINNATI','OH','45215','2644','CY','39061','1961-01-01','M','M',NULL,'T','021','HLT','3737360','92036OH004001201','2014-04-01','2014-02-25 16:24:26','270.00',NULL,NULL,'976.30','706.30','R-OH004','OH0','404.95',NULL,0,'2014-02-25 21:32:09'),(1559,1301,'Y','18','021','EC','A','','','AC','0001048576','0001048576','MS00001538648','IL','1','Hobson','Odell','','','','34','587641539','415 EDWINA CIR',0,'JACKSON','MS','39212','5229','CY','28049','1951-05-10','M','U',':RET:2054-5','N','021','DEN','1599477','46300MS002000201','2014-01-01','2013-12-24 16:12:26','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 18:50:50'),(20633,16488,'Y','18','021','EC','A','','','AC','0001016702','0001016702','TX00002505583','IL','1','SAULS','BREANNA','','','','34','634424568','14502 ROYAL MOUNTAIN DR',0,'HOUSTON','TX','77090','6200','CY','48201','1993-01-06','F','M',':RET:2054-5^:RET:2106-3','N','021','DEN','2967657','33348TX002000201','2014-03-01','2014-01-30 06:10:38','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-30 21:00:30'),(20087,16025,'Y','18','021','EC','A','','','AC','0001233928','0001233928','LA00002445293','IL','1','Cashill','Louann','','','','34','438414334','3408 RIDGEWAY DR',0,'METAIRIE','LA','70002','1952','CY','22051','1966-09-15','F','U',':RET:2106-3','N','021','DEN','3332785','18575LA002000101','2014-03-01','2014-01-27 15:10:20','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-27 21:00:27'),(5669,4498,'Y','18','021','EC','A','','','AC','0001207116','0001207116','OH00000162407','IL','1','wilson','vicki','','','','34','301528661','2001 W BEAL RD',0,'JAMESTOWN','OH','45335','9747','CY','39057','1955-12-26','F','U',':RET:2106-3','T','021','HLT','843665','92036OH004000501','2014-01-01','2013-11-25 20:20:33','0.00',NULL,NULL,'989.11','989.11','R-OH003','OH0','560.05',NULL,0,'2013-12-25 23:32:00'),(19499,15541,'Y','18','021','EC','A','','','AC','0000584304','0000584304','OH00001637731','IL','1','Caskey','Jonathan','','','','34','279541312','14847 FOSNIGHT RD',0,'ORRVILLE','OH','44667','9716','CY','39169','1959-03-21','M','M',NULL,'N','021','HLT','2307491','52664OH151001305','2014-03-01','2014-01-22 12:11:53','648.00',NULL,NULL,'874.41','226.41','R-OH014','OH0','476.12',NULL,0,'2014-01-23 03:02:10'),(17162,13732,'Y','18','021','EC','A','','','AC','0002005314','0002005314','LA00002431035','IL','1','THEN','JOSEFINA','','','','34','664074016','3301 W ESPLANADE AVE N',0,'METAIRIE','LA','70002','1691','CY','22051','1982-08-20','F','U',NULL,'N','021','DEN','2169587','18575LA002000201','2014-02-01','2014-01-08 12:58:02','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:22:02'),(15598,12482,'Y','18','021','EC','A','','','AC','0000283270','0000283270','OH00000167457','31','1','Rengel','Dale','','','','34','295584912','421 Jackson Street',0,'Sandusky','OH','44870',NULL,'CY','39043','1957-03-22','M','M',':RET:2106-3','N','021','DEN','2124004','99734OH005000301','2014-02-01','2013-12-31 14:43:11','0.00',NULL,NULL,'87.78','87.78','R-OH006','OH0','0.00',NULL,1,'2014-01-02 04:32:35'),(27972,22130,'Y','18','021','EC','A','','','AC','0001340455','0001340455','LA00003402350','IL','1','HUGHES','CATHERINE','','','','34','579641798','6501 MEMPHIS ST',0,'NEW ORLEANS','LA','70124','3235','CY','22071','1960-01-05','F','R',':RET:2106-3','N','021','DEN','4154164','18575LA002000201','2014-04-01','2014-03-06 13:04:27','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-06 21:00:51'),(28202,22318,'Y','18','021','EC','A','','','AC','0001215804','0001215804','TX00002691074','IL','1','Abeln','Samantha','E','','','34','456796194','3609 WILLOW RIDGE DR',0,'ARLINGTON','TX','76017','1520','CY','48439','1985-06-05','F','U',':RET:2106-3','N','021','DEN','3729993','33348TX002000101','2014-04-01','2014-03-06 13:24:38','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15','CIC',0,'2014-03-06 21:30:09'),(3077,2472,'Y','18','021','EC','A','','','AC','0000353944','0000353944','OH00000571672','IL','1','Streithorst','Deborah','','','','34','286629083','5777 Valley Vista Way',0,'Cincinnati','OH','45247',NULL,'CY','39061','1968-02-11','F','U',NULL,'N','021','HLT','577447','92036OH003001205','2014-01-01','2013-12-06 11:54:18','149.00',NULL,NULL,'323.72','174.72','R-OH004','OH0','323.72',NULL,0,'2013-12-25 20:19:37'),(25109,19917,'Y','18','024','14','A','','','TE','0000244858','0000244858','','IL','1','BULTER','MARIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1957-08-18','F','',NULL,NULL,NULL,'','2701445','','2014-03-31','2014-02-21 17:34:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-21 21:30:14'),(9571,7582,'N','01','021','EC','A',NULL,NULL,'','0000062528','0000078764','','IL','1','nguyen','Anhthu','thoai','','','34','377982253','2211 WOODEDGE CT',0,'MIAMISBURG','OH','45342','6403','CY','39113','1975-01-06','F','',':RET:2047-9','N','021','DEN','1694578','99734OH005000301','2014-01-01','2013-12-21 16:23:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 04:36:43'),(22203,17721,'Y','18','021','EC','A','','','AC','0000703816','0000703816','OH00002608575','IL','1','BERNARD-BROWNING','ARELLA','','','','34','280724606','649 CIRCLE RD',0,'DAYTON','OH','45417','1208','CY','39113','1968-10-18','F','U',':RET:2054-5','T','021','DEN','3815530','99734OH005000401','2014-03-01','2014-02-09 13:22:41','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-09 19:00:16'),(7783,6163,'Y','18','021','EC','A','','','AC','0000294768','0000294768','TX00000022809','IL','1','Marx','Helen','','','','34','449875707','1052 COUNTY ROAD 175',0,'GARY','TX','75643','4936','CY','48365','1978-08-29','F','U',':RET:2106-3','N','021','DEN','1908549','33348TX002000201','2014-01-01','2013-12-20 08:52:24','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:14'),(21630,17270,'Y','18','021','EC','A','','','AC','0000835363','0000835363','TX00001718193','IL','1','Martin','James','','','','34','260212004','1805 W 18TH ST',0,'TEXARKANA','TX','75501','3648','CY','48037','1966-01-14','M','M',':RET:2106-3','T','021','DEN','3045693','33348TX002000201','2014-03-01','2014-02-05 10:33:21','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-02-05 21:30:40'),(3870,3099,'Y','18','021','EC','A','','','AC','0000852787','0000852787','LA00000321804','IL','1','LINDE','BARBARA','','','','34','439920749','602 ALBERT ST',0,'MANDEVILLE','LA','70448','5404','CY','22103','1952-04-09','F','M',':RET:2106-3','N','021','DEN','934813','18575LA002000201','2014-01-01','2013-12-13 09:27:22','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:36:10'),(6394,5068,'N','19','021','EC','A',NULL,NULL,'','0000355013','0000382130','','IL','1','Bressman','Jedidiah','Irving','','','34','274967005','8633 BROADACRE DR',0,'POWELL','OH','43065','9010','CY','39049','1993-01-11','M','',':RET:2106-3','N','021','DEN','622071','99734OH005000301','2014-01-01','2013-12-11 11:46:04',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:48:13'),(21099,16862,'Y','18','021','EC','A','','','AC','0000214693','0000214693','OH00001935428','IL','1','Carter','Gregory','','','','34','295782756','10487 COUNTY ROAD 4',0,'SWANTON','OH','43558','9219','CY','39051','1981-10-13','M','U',':RET:2106-3','T','021','HLT','3526461','92036OH006002601','2014-03-01','2014-02-02 17:47:09','0.00',NULL,NULL,'210.39','210.39','R-OH001','OH0','210.39',NULL,0,'2014-02-02 19:00:33'),(21062,16829,'Y','18','021','EC','A','','','AC','0001875540','0001875540','LA00002537781','IL','1','SMITH-PETERS','LINDA','','','','34','437844318','2756 JONQUIL STREET',0,'NEW ORLEANS','LA','70122',NULL,'CY','22071','1951-01-13','F','U',':RET:2054-5','N','021','DEN','3605618','18575LA002000201','2014-03-01','2014-02-02 17:31:38','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-02 19:00:12'),(20791,16612,'Y','18','021','EC','A','','','AC','0001163290','0001163290','TX00002260539','IL','1','EASTER','ROMEIKA','','','','34','449692386','204 SOUTH DOWIE ST',0,'BOSTON','TX','75570',NULL,'CY','48037','1981-02-01','F','U',NULL,'N','021','DEN','2773634','33348TX002000201','2014-03-01','2014-01-31 10:07:27','0.00',NULL,NULL,'14.61','14.61','R-TX021','TX0','14.61',NULL,0,'2014-01-31 21:00:15'),(5489,4357,'Y','18','024','14','A','','','TE','0001224434','0001224434','','IL','1','Malicki','Charlene',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-06-27','F','',NULL,NULL,NULL,'','967960','','2013-12-19','2013-12-19 13:26:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:11:01'),(15541,12435,'N','01','021','EC','A',NULL,NULL,'','0002159651','0002232947','','IL','1','LOTT','SAMANTHA','','','','34','458817215','1106 CARROLL ST',0,'TALLULAH','LA','71282',NULL,'CY','22065','1983-06-04','F','',':RET:2106-3','T','021','DEN','1592306','18575LA002000201','2014-02-01','2013-12-31 14:41:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,1,'2014-01-02 04:30:58'),(17489,13984,'Y','18','021','EC','A','','','AC','0002324974','0002324974','LA00001587415','IL','1','LOZIER','AARON','','','','34','451518850','309 COPPERFIELD WAY',0,'YOUNGSVILLE','LA','70592',NULL,'CY','22055','1978-11-02','M','M',NULL,'N','021','DEN','1550730','18575LA002000201','2014-02-01','2014-01-11 18:51:36','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-01-13 03:01:19'),(25894,20531,'Y','18','021','EC','A','','','AC','0001201443','0001201443','TX00002199573','IL','1','Lujan','Dominique','','','','34','645166881','2002 61st Street',0,'Lubbock','TX','79412',NULL,'CY','48303','1990-08-05','F','U',':RET:2106-3','N','021','DEN','3460742','33348TX002000201','2014-04-01','2014-02-26 12:12:15','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-26 21:01:05'),(27261,21585,'Y','18','021','EC','A','','','AC','0001046906','0001046906','OH00002994544','IL','1','Templeton','Catherine','','','','34','292586826','525 RIDGEWOOD AVE',0,'HAMILTON','OH','45013','3248','CY','39017','1957-01-22','F','U',':RET:2106-3','N','021','HLT','3671438','92036OH003001205','2014-04-01','2014-03-03 17:41:09','388.00',NULL,NULL,'546.34','158.34','R-OH004','OH0','546.34',NULL,0,'2014-03-03 21:32:00'),(4229,3367,'Y','18','021','EC','A','','','AC','0000115390','0000115390','TX00001105794','IL','1','Falkenberg','Rex','Alton','','','34','449969328','837 HCR 2312',0,'HILLSBORO','TX','76645','4229','CY','48217','1952-09-30','M','U',':RET:2106-3','T','021','DEN','2267070','33348TX002000201','2014-01-01','2013-12-17 12:56:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:39'),(20682,16525,'N','19','021','EC','A',NULL,NULL,'','0000167726','0000096241','','IL','1','Hassan','Aaishah','','','','34','645727997','643 LEAFY RDG',0,'SAN ANTONIO','TX','78251','4251','CY','48029','2000-10-05','F','',NULL,'N','021','DEN','3626848','33348TX002000101','2014-03-01','2014-01-29 19:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','0.00',NULL,0,'2014-01-30 21:00:54'),(14856,11861,'N','01','021','EC','A',NULL,NULL,'','0000479847','0000361012','','IL','1','Prince','Marshall','','','','34','299761281','344 SILVER ST',0,'AKRON','OH','44303','2237','CY','39153','1967-04-22','M','',':RET:2054-5','N','021','HLT','1422462','52664OH152000901','2014-01-01','2013-12-23 19:52:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','245.01',NULL,1,'2013-12-29 11:15:13'),(8984,7126,'Y','18','021','EC','A','','','AC','0000944851','0000944851','OH00000085327','IL','1','Fayson','Lamont','','','','34','292522693','9403 HADDINGTON CT',0,'CINCINNATI','OH','45251','2374','CY','39061','1952-10-17','M','U',':RET:2054-5','N','021','DEN','2360859','99734OH005000401','2014-01-01','2013-12-18 16:21:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:04:25'),(19064,15186,'Y','18','021','EC','A','','','AC','0000368349','0000368349','TX00002483036','31','1','Hickle','Shanna','','','','34','449271811','P.O. Box 1514',0,'Alpine','TX','79831',NULL,'CY','48043','1962-05-16','F','U',':RET:2106-3','N','021','DEN','2058817','33348TX002000201','2014-03-01','2014-01-18 12:38:58','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-21 08:44:16'),(18868,15030,'Y','18','021','EC','A','','','AC','0001241382','0001241382','LA00001389038','IL','1','Henoumont','Guy','','','','34','528431296','1318 8TH ST',0,'NEW ORLEANS','LA','70115','3335','CY','22071','1959-10-08','M','U',':RET:2106-3','N','021','DEN','2162319','18575LA002000201','2014-03-01','2014-01-16 11:30:24','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-17 03:36:23'),(18789,14965,'Y','18','021','EC','A','','','AC','0000565566','0000565566','OH00002257975','IL','1','Baker','Brittany','','','','34','280944579','4466 SPRUCE CREEK DR',0,'BATAVIA','OH','45103','1558','CY','39025','1991-08-27','F','U',':RET:2106-3','N','021','DEN','2911036','99734OH005000401','2014-02-01','2014-01-15 22:07:44','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-01-17 03:35:55'),(7243,5743,'Y','18','021','EC','A','','','AC','0000060164','0000060164','LA00000411518','IL','1','Hahn','Tristan','','','','34','626425680','16521 MOREL AVE',0,'BATON ROUGE','LA','70817','5636','CY','22033','1985-06-05','M','U',':RET:2106-3','N','021','DEN','1024297','18575LA002000201','2014-01-01','2013-12-14 11:37:57','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:01:43'),(24653,19570,'Y','18','021','EC','A','','','AC','0000227100','0000227100','OH00002656788','IL','1','Harris-Carr','Patricia','','','','34','299421632','22095 COUNTY ROAD 226',0,'FOSTORIA','OH','44830','9703','CY','39173','1950-10-29','F','M',':RET:2106-3','T','021','HLT','3117242','92036OH004002601','2014-04-01','2014-02-18 19:26:04','0.00',NULL,NULL,'532.27','532.27','R-OH001','OH0','532.27',NULL,0,'2014-02-20 04:23:44'),(7027,5580,'Y','18','021','EC','A','','','AC','0000505533','0000505533','TX00000697911','IL','1','rasbury','deborah','','','','34','453987785','7059 DEER RIDGE DR',0,'FORT WORTH','TX','76137','4715','CY','48439','1952-08-19','F','U',':RET:2106-3','N','021','DEN','2514260','33348TX002000201','2014-01-01','2013-12-24 22:26:43','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:01'),(17280,13819,'N','19','021','EC','A',NULL,NULL,'','0000885609','0000040967','','IL','1','Karasek','Leah','','','','34','278984549','112 WHITTLESEY DR',0,'TALLMADGE','OH','44278','1614','CY','39153','1995-03-07','F','',':RET:2106-3','N','021','HLT','2246097','52664OH152000901','2014-02-01','2014-01-10 14:37:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-13 02:23:25'),(6337,5022,'N','19','021','EC','A',NULL,NULL,'','0001088245','0000914413','','IL','1','Jordan','Kaydence','','','','34','300089518','2800 CRESCENT DR NE',0,'WARREN','OH','44483','5624','CY','39155','2004-06-29','F','',NULL,'N','021','DEN','1081150','99734OH005000401','2014-01-01','2013-12-11 11:44:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 00:46:41'),(14698,11735,'Y','18','024','14','A','','','TE','0000205793','0000205793','','IL','1','Bidlencsik','Cynthia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-01-02','F','',NULL,NULL,NULL,'','1838126','','2013-12-28','2013-12-28 00:37:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2013-12-29 11:08:59'),(303,249,'N','01','021','EC','A',NULL,NULL,'','0000290755','0000251587','','IL','1','Jolly','Megan','C','','','34','300725865','10632 GILBERT RD',0,'NEWTON FALLS','OH','44444','9269','CY','39133','1971-05-11','F','',NULL,'N','021','HLT','426917','52664OH151001301','2014-01-01','2013-11-13 01:46:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','295.48',NULL,0,'2013-12-25 17:30:50'),(16168,12944,'N','01','021','EC','A',NULL,NULL,'','0002255084','0001670254','','IL','1','Le','Tam','Trung','','','34','546618417','11368 GLENDA DR',0,'BATON ROUGE','LA','70815','2421','CY','22033','1965-10-20','M','',NULL,'N','021','DEN','1513428','18575LA002000201','2014-02-01','2014-01-03 18:52:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-05 00:00:09'),(14453,11530,'Y','18','021','EC','A','','','AC','0000001004','0000001004','LA00000381765','31','1','Bruce','Staci','','','','34','425498836','614 SOPHIA LN',0,'SHREVEPORT','LA','71115','2406','CY','22017','1981-06-27','F','U',':RET:2106-3','N','021','DEN','2205667','18575LA002000201','2014-02-01','2013-12-27 14:02:21','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-28 03:32:32'),(4473,3552,'N','17','021','EC','A',NULL,NULL,'','0000129245','0000818554','','IL','1','Smith','Cody',NULL,NULL,NULL,NULL,NULL,'6120 PEBBLE STONE LN',0,'WOOSTER','OH','44691','6920','CY','39169','1995-02-24','M','',NULL,'N','021','DEN','963433','99734OH005000301','2014-01-01','2013-12-12 14:53:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:52'),(6797,5391,'Y','18','021','EC','A','','','AC','0000780469','0000780469','OH00000355515','IL','1','rayon','david','','','Sr','34','294464969','5464 fleet',0,'toledo','OH','43615',NULL,'CY','39095','1950-01-01','M','M',':RET:2106-3','N','021','HLT','690893','92036OH001002601','2014-01-01','2013-11-25 17:30:41','417.00',NULL,NULL,'705.61','288.61','R-OH001','OH0','705.61',NULL,0,'2013-12-26 01:17:15'),(22823,18212,'Y','18','021','EC','A','','','AC','0000217642','0000217642','OH00002201506','IL','1','SAY','KYAW','','','','34','292138772','92 COLONIAL HILL DRIVE',0,'AKRON','OH','44310',NULL,'CY','39153','1979-12-25','M','U',':RET:2028-9','N','021','HLT','3325458','52664OH151001301','2014-03-01','2014-02-10 22:34:58','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,0,'2014-02-11 21:02:03'),(6800,5394,'Y','18','021','EC','A','','','AC','0000422785','0000422785','OH00000208507','IL','1','Pozo','Angelica','','','','34','103464017','1193 HOLMDEN AVE',0,'CLEVELAND','OH','44109','1877','CY','39035','1954-02-17','F','U',':RET:2054-5','N','021','HLT','1175274','92036OH005000806','2014-01-01','2013-11-25 00:19:53','400.00',NULL,NULL,'608.59','208.59','R-OH011','OH0','608.59',NULL,0,'2013-12-26 01:17:22'),(19882,15859,'N','01','021','EC','A',NULL,NULL,'','0001181048','0000919425','','IL','1','JAMISON','DAVID','','','','34','272608924','1327 NORTHWOLD ST',0,'LIMA','OH','45801','3515','CY','39003','1957-10-31','M','',':RET:2106-3','T','021','HLT','2936718','92036OH006001501','2014-03-01','2014-01-24 11:44:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','468.28',NULL,0,'2014-01-24 21:00:47'),(7954,6294,'Y','18','021','EC','A','','','AC','0001328943','0001328943','LA00000385631','IL','1','Robinsin','Sasha','','','','34','437717769','7117 W CANAL BLVD',0,'SHREVEPORT','LA','71108','4909','CY','22017','1988-07-29','F','U',':RET:2054-5','N','021','DEN','2148264','18575LA002000201','2014-01-01','2013-12-20 18:34:18','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 03:07:15'),(5055,4004,'Y','18','021','EC','A','','','AC','0000024542','0000024542','TX00000463546','IL','1','Medina','Jesse','','','','34','463437848','104 COMMERCE ST',0,'REFUGIO','TX','78377','3302','CY','48391','1963-12-31','M','U',NULL,'N','021','DEN','2350225','33348TX002000201','2014-01-01','2013-12-18 20:59:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:00:17'),(5789,4597,'N','01','021','EC','A',NULL,NULL,'','0000518419','0000827161','','IL','1','Harper','Johnna','Sheri','','','34','270581237','7022 COUNTY ROAD 13',0,'WAUSEON','OH','43567','9002','CY','39051','1968-10-16','F','',':RET:2106-3','N','021','DEN','1997609','99734OH005000401','2014-01-01','2013-12-24 00:09:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:47:13'),(27222,21555,'Y','18','021','EC','A','','','AC','0001257143','0001257143','MS00002601454','IL','1','KING','MAURINE','CATHERINE','','','34','426025106','128 BERMUDA CIR',0,'PEARL','MS','39208','5435','CY','28121','1957-08-05','F','M',':RET:2106-3','N','021','DEN','3818564','46300MS002000201','2014-04-01','2014-03-03 14:51:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-03 21:31:35'),(28292,22386,'N','19','021','EC','A',NULL,NULL,'','0000198629','0000644738','','S1','1','Reddy','James','Martin',NULL,NULL,NULL,NULL,'2210 US HIGHWAY 52',0,'GEORGETOWN','OH','45121','9779','CY','39015','2009-03-03','M','',':RET:2106-3','N','021','HLT','3096511','92036OH004000601','2014-04-01','2014-03-07 11:10:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61','CIC',0,'2014-03-07 21:00:28'),(1491,1244,'Y','18','021','EC','A','','','AC','0000995437','0000995437','OH00000107296','31','1','THOMAS','DARLENE','','','','34','273522311','PO BOX 201',0,'CORTLAND','OH','44410',NULL,'CY','39155','1951-12-14','F','U',':RET:2106-3','N','021','DEN','1803370','99734OH005000401','2014-01-01','2013-12-24 11:17:46','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2013-12-25 18:49:01'),(24487,19453,'Y','18','021','EC','A','','','AC','0002107209','0002107209','LA00001912982','IL','1','Hills','Natashia','','','','34','587453362','2670 HOLLY RIDGE RD',0,'JACKSON','LA','70748','3209','CY','22037','1978-11-03','F','U',':RET:2054-5','N','021','DEN','2718367','18575LA002000101','2014-04-01','2014-02-19 15:10:38','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-20 03:42:47'),(23603,18802,'Y','18','021','EC','A','','','AC','0000199711','0000199711','OH00002449225','IL','1','MOONEY','MARGARET','','','','34','283700185','441 S DEWEY AVE',0,'LIMA','OH','45804','3015','CY','39003','1963-12-04','F','M',':RET:2106-3','N','021','HLT','3636285','92036OH003001505','2014-03-01','2014-02-13 12:48:27','710.00',NULL,NULL,'859.11','149.11','R-OH002','OH0','410.48',NULL,0,'2014-02-13 22:03:09'),(22917,18268,'Y','18','021','EC','A','','','AC','0000849473','0000849473','OH00002436475','IL','1','Wilson','Rae','','','','34','295865039','24 W 8TH ST',0,'MANCHESTER','OH','45144','1239','CY','39001','1981-12-14','F','M',':RET:2106-3','N','021','HLT','3837944','92036OH003000604','2014-03-01','2014-02-11 16:07:54','297.00',NULL,NULL,'548.12','251.12','R-OH005','OH0','265.21',NULL,0,'2014-02-11 21:02:52'),(9778,7744,'Y','18','021','EC','A','','','AC','0000313215','0000313215','OH00001070442','IL','1','DIXON','HAROLD','','','Jr','34','403926078','1914 FALLBROOK LN',0,'CINCINNATI','OH','45240','1016','CY','39061','1963-07-20','M','U',NULL,'T','021','DEN','400210','99734OH005000301','2014-01-01','2013-10-20 18:42:52','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 05:00:40'),(13895,11083,'N','01','021','EC','A',NULL,NULL,'','0001179626','0001195506','','IL','1','Lyons-Dagg','Karan','K','','','34','177547922','29545 E. Broadway Street',0,'Walbridge','OH','43465',NULL,'CY','39173','1960-12-15','F','',':RET:2106-3','N','021','HLT','2147085','92036OH005002604','2014-01-01','2013-12-23 19:06:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','397.79',NULL,0,'2013-12-26 13:13:34'),(19834,15817,'Y','18','021','EC','A','','','AC','0000325496','0000325496','TX00001461411','IL','1','BORJAS','STEPHANIE','','','','34','638034088','5006 DONNELLY AVE',0,'FORT WORTH','TX','76107','6007','CY','48439','1985-06-10','F','U',':RET:2106-3','N','021','DEN','3311036','33348TX002000201','2014-03-01','2014-01-24 14:30:20','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-24 21:00:21'),(17529,14015,'Y','18','021','EC','A','','','AC','0000049512','0000049512','OH00001859805','IL','1','DAVIDSON','DANIEL','','','','34','207503411','521 GOBEL AVE SE',0,'CANTON','OH','44707','2721','CY','39151','1958-11-11','M','M',':RET:2106-3','T','021','DEN','1836936','99734OH005000401','2014-02-01','2014-01-12 17:40:10','0.00',NULL,NULL,'15.78','15.78','R-OH015','OH0','0.00',NULL,0,'2014-01-13 03:01:41'),(16464,13173,'Y','18','021','EC','A','','','AC','0000390910','0000390910','OH00000494031','IL','1','Watkins','Armints','','','','34','407888491','13462 WALLS LN',0,'SARDINIA','OH','45171','9352','CY','39015','1977-01-14','M','U',':RET:2106-3','T','021','HLT','1710036','92036OH004000601','2014-02-01','2014-01-06 17:51:03','199.00',NULL,NULL,'245.74','46.74','R-OH005','OH0','245.74',NULL,0,'2014-01-07 04:05:45'),(16366,13097,'Y','18','021','EC','A','','','AC','0000208944','0000208944','MS00002183026','IL','1','Norvell','Marceita','','','','34','288564221','824 HENRY HALL RD',0,'MOUND BAYOU','MS','38762','9713','CY','28011','1952-08-12','F','M',':RET:2054-5','N','021','DEN','2361608','46300MS002000201','2014-02-01','2014-01-06 11:27:03','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-01-07 04:02:54'),(14438,11515,'Y','18','021','EC','A','','','AC','0001721770','0001721770','LA00000027183','IL','1','Rodney','Keith','','','','34','099605465','504 Texas Eastern Rd',0,'Opelousas','LA','70570',NULL,'CY','22097','1963-01-19','M','U',':RET:2054-5','N','021','DEN','1506146','18575LA002000201','2014-02-01','2013-12-27 11:08:32','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-28 03:32:06'),(15657,12527,'Y','18','021','EC','A','','','AC','0001217382','0001217382','OH00002077156','IL','1','Wright','Jeremiah','','','','34','300781321','501 W Main St',0,'Cairo','OH','45820',NULL,'CY','39003','1981-02-24','M','M',':RET:2106-3','N','021','HLT','2473082','92036OH005001506','2014-02-01','2013-12-31 15:49:05','415.00',NULL,NULL,'499.60','84.60','R-OH002','OH0','260.36',NULL,1,'2014-01-02 04:34:19'),(15138,12098,'Y','18','024','14','A','','','TE','0000026628','0000026628','','IL','1','Mitchell','Marguerite',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-01-24','F','',NULL,NULL,NULL,'','1736564','','2013-12-30','2013-12-30 06:33:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:05:39'),(26340,20897,'N','01','021','EC','A',NULL,NULL,'','0000904319','0001239176','','IL','1','Evans','Denise','Faith','','','34','277663131','5331 EDGEWATER DR',0,'TOLEDO','OH','43611','2640','CY','39095','1958-02-21','F','',NULL,'T','021','HLT','2868388','92036OH006002601','2014-04-01','2014-02-27 13:55:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','414.89',NULL,0,'2014-02-28 06:31:43'),(29122,23055,'Y','18','021','EC','A','','','AC','0000205856','0000205856','OH00003181618','IL','1','O\'Keefe','Michael','','','','34','350741821','2548 INDIAN MOUND AVE',0,'NORWOOD','OH','45212','1759','CY','39061','1981-09-14','M','M',':RET:2106-3','N','021','HLT','2906811','92036OH002001201','2014-04-01','2014-03-10 09:36:05','0.00',NULL,NULL,'596.21','596.21','R-OH004','OH0','293.28',NULL,0,'2014-03-10 21:02:31'),(5436,4318,'Y','18','021','EC','A','','','AC','0001973373','0001973373','LA00000418327','IL','1','TAYLOR','RENATTA','','','','34','433418950','1309 TANGLEWOOD DR',0,'WESTWEGO','LA','70094','5245','CY','22051','1979-10-24','F','U',NULL,'N','021','DEN','2532190','18575LA002000101','2014-01-01','2013-12-19 16:42:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 23:09:48'),(25367,20127,'N','01','021','EC','A',NULL,NULL,'','0000866950','0000739071','','IL','1','Wilson','Christopher','Dale','','','34','269745837','660 DELTA AVE',0,'CINCINNATI','OH','45226','1926','CY','39061','1976-09-18','M','',':RET:2106-3','N','021','DEN','3537964','99734OH005000301','2014-04-01','2014-02-25 11:38:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-25 21:30:39'),(23026,18358,'N','01','021','EC','A',NULL,NULL,'','0000223207','0000723066','','IL','1','Levario','Fernando','','','','34','456590593','2123 20TH ST',0,'LUBBOCK','TX','79411','1101','CY','48303','1974-10-22','M','',NULL,'N','021','DEN','2807192','33348TX002000201','2014-03-01','2014-02-11 22:50:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-12 21:30:32'),(22955,18301,'N','01','021','EC','A',NULL,NULL,'','0000407414','0000262768','','IL','1','Braig','Charles','','','','34','280563007','7793 CARRAWAY CT',0,'MAINEVILLE','OH','45039','8995','CY','39165','1953-09-18','M','',':RET:2106-3','N','021','DEN','3621883','99734OH005000301','2014-03-01','2014-02-11 19:17:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-12 21:00:04'),(22909,18261,'Y','18','021','EC','A','','','AC','0000092562','0000092562','OH00002637811','IL','1','Trump','Terry','','','','34','275485627','4421 MANCHESTER RD',0,'AKRON','OH','44319','3322','CY','39153','1949-11-03','F','U',':RET:2106-3','N','021','HLT','3024160','52664OH152000901','2014-03-01','2014-02-11 15:55:20','406.00',NULL,NULL,'490.00','84.00','R-OH012','OH0','490.00',NULL,0,'2014-02-11 21:02:47'),(21097,16860,'Y','18','021','EC','A','','','AC','0000979332','0000979332','OH00001387982','IL','1','Johns','Kathleen','','','','34','500607845','798 S Johnsville Rd',0,'New Lebanon','OH','45345',NULL,'CY','39113','1951-11-11','F','U',':RET:2106-3','N','021','HLT','2864162','92036OH005000501','2014-03-01','2014-02-02 15:35:36','354.00',NULL,NULL,'682.93','328.93','R-OH003','OH0','682.93',NULL,0,'2014-02-02 19:00:32'),(17517,14004,'Y','18','021','EC','A','','','AC','0000721360','0000721360','OH00001693662','IL','1','Mitchell','Roy','','','','34','298540937','3240 CARPER AVE',0,'AKRON','OH','44312','3602','CY','39153','1954-06-25','M','M',':RET:2106-3','N','021','DEN','2037254','99734OH005000401','2014-02-01','2014-01-12 10:07:57','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-01-13 03:01:34'),(17999,14382,'N','01','021','EC','A',NULL,NULL,'','0000048215','0000034400','','IL','1','Watson','Sharan','','','','34','295627201','5646 Waterbury Avenue',0,'Maple Heights','OH','44137',NULL,'CY','39035','1959-02-20','F','',NULL,'N','021','DEN','2021397','99734OH005000301','2014-02-01','2014-01-13 20:41:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-15 02:06:59'),(18544,14789,'Y','18','021','EC','A','','','AC','0000256241','0000256241','MS00002598233','IL','1','Romine','Charles','','','','34','448662644','147 FOREST RIDGE DR',0,'BRANDON','MS','39042','2031','CY','28121','1968-08-08','M','U',':RET:2106-3','N','021','DEN','2683966','46300MS002000101','2014-02-01','2014-01-15 14:46:32','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-16 08:46:50'),(18546,14791,'Y','18','021','EC','A','','','AC','0000512891','0000512891','MS00001722913','IL','1','Taylor','Patsy','','','','34','426251198','3237 BOOKER ST',0,'JACKSON','MS','39209','7219','CY','28049','1961-05-08','F','U',':RET:2054-5','N','021','DEN','2891425','46300MS002000101','2014-02-01','2014-01-14 18:50:20','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-16 08:46:51'),(18582,14817,'Y','18','021','EC','A','','','AC','0000381170','0000381170','OH00002012105','IL','1','KIRINGODA','RUWANI','','','','34','269882437','755 FRANK BLVD',0,'AKRON','OH','44320',NULL,'CY','39153','1978-04-10','F','U',NULL,'N','021','HLT','2042532','52664OH151001501','2014-02-01','2014-01-15 16:47:39','0.00',NULL,NULL,'326.84','326.84','R-OH012','OH0','326.84',NULL,0,'2014-01-16 08:47:09'),(18776,14956,'N','01','021','EC','A',NULL,NULL,'','0000794535','0000841943','','IL','1','swope','elliott','','','','34','283720485','13391 WARDLOW RD',0,'SARDINIA','OH','45171','9706','CY','39015','1974-11-21','M','',':RET:2106-3','N','021','HLT','2984581','92036OH004000601','2014-02-01','2014-01-15 18:35:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','217.83',NULL,0,'2014-01-17 03:35:51'),(26262,20830,'Y','18','021','EC','A','','','AC','0000113143','0000113143','TX00002953213','IL','1','PATEL','KAMLESH','','','','34','642243234','1516 HWY 16 SOUTH',0,'GRAHAM','TX','76450',NULL,'CY','48503','1973-03-13','M','M',NULL,'N','021','DEN','3707086','33348TX002000201','2014-04-01','2014-02-27 15:58:48','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-28 06:31:13'),(2018,1656,'Y','18','021','EC','A','','','AC','0001126841','0001126841','OH00000288466','IL','1','Chiofolo','Kathleen','','','','34','278523412','2785 BYRON DR',0,'NORTH CANTON','OH','44720','1201','CY','39153','1951-08-28','F','M',':RET:2106-3','N','021','HLT','970695','52664OH152000901','2014-01-01','2013-12-09 19:38:58','845.00',NULL,NULL,'1023.79','178.79','R-OH012','OH0','469.28',NULL,0,'2013-12-25 19:15:05'),(9776,7742,'Y','18','021','EC','A','','','AC','0000558114','0000558114','OH00001010986','IL','1','Campbell','Sandra','L','','','34','285667579','1784 Millville Avenue',0,'Hamilton','OH','45013',NULL,'CY','39017','1958-08-12','F','U',':RET:2080-0','T','021','DEN','507137','99734OH005000301','2014-01-01','2013-10-19 22:53:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 05:00:37'),(23714,18882,'Y','18','021','EC','A','','','AC','0000352885','0000352885','OH00002110912','IL','1','YOUNG','MARANDIA','','','','34','225760614','1125 WOODLAND AVE SE',0,'MASSILLON','OH','44646','8161','CY','39151','1956-02-13','F','M',NULL,'N','021','DEN','2978970','99734OH005000401','2014-03-01','2014-02-14 16:22:46','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-14 21:30:48'),(22629,18071,'Y','18','021','EC','A','','','AC','0000239793','0000239793','TX00001406467','IL','1','Mehdi-Kashi','Abdollah','','','','34','528214245','5507 Azalea Trail Lane',0,'Sugar Land','TX','77479',NULL,'CY','48157','1950-01-22','M','M',':RET:2106-3','N','021','DEN','3384033','33348TX002000201','2014-03-01','2014-02-11 00:09:43','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-02-11 21:00:16'),(22172,17695,'Y','18','021','EC','A','','','AC','0000018993','0000018993','TX00001914085','IL','1','Pilgrim','Monnie','','','','34','450882470','305 OAK ST',0,'BULLARD','TX','75757','5033','CY','48423','1950-12-17','F','M',':RET:2106-3','T','021','DEN','3089688','33348TX002000201','2014-03-01','2014-02-07 18:47:32','0.00',NULL,NULL,'14.61','14.61','R-TX022','TX0','14.61','CIC',0,'2014-02-08 19:30:05'),(8840,7007,'Y','18','021','EC','A','','','AC','0000966842','0000966842','TX00000465632','31','1','Tran','Kevin',NULL,NULL,NULL,NULL,NULL,'1304 Junction HWY',0,'Kerrville','TX','78028',NULL,'CY','48265','1968-01-29','M','M',':RET:2047-9','N','021','DEN','2083305','33348TX002000201','2014-01-01','2013-12-17 22:02:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-26 04:00:43'),(4334,3443,'Y','18','021','EC','A','','','AC','0000827147','0000827147','OH00000364150','IL','1','Opaczewski','Deborah','','','','34','295528692','87 E BACK BAY RD',0,'BOWLING GREEN','OH','43402','9228','CY','39173','1951-06-20','F','M',':RET:2106-3','N','021','HLT','1365098','92036OH003002605','2014-01-01','2013-12-17 11:32:12','400.00',NULL,NULL,'585.04','185.04','R-OH001','OH0','585.04',NULL,0,'2013-12-25 21:53:05'),(20798,16618,'Y','18','021','EC','A','','','AC','0000815796','0000815796','TX00002132564','IL','1','HACKETT','STEPHEN','G','','','34','627489004','9018 CORAL COVE DR',0,'DALLAS','TX','75243','6142','CY','48113','1985-12-04','M','U',':RET:2106-3','N','021','DEN','3394995','33348TX002000201','2014-03-01','2014-01-31 11:43:50','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-31 21:00:19'),(20084,16022,'Y','18','021','EC','A','','','AC','0001659571','0001659571','LA00002398900','IL','1','WILLIS','MARK','','','','34','437614368','9149 RIDGE PINE DR',0,'BATON ROUGE','LA','70810','7093','CY','22033','1984-12-08','M','M',':RET:2106-3','N','021','DEN','1956218','18575LA002000101','2014-03-01','2014-01-26 20:32:18','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-27 21:00:25'),(4914,3898,'Y','18','021','EC','A','','','AC','0000140633','0000140633','MS00001075449','IL','1','Redmon','Karl','','','','34','426713813','1 PECAN ST',0,'FLORENCE','MS','39073','8429','CY','28121','1986-09-04','M','U',':RET:2106-3','N','021','DEN','8767','46300MS002000101','2014-01-01','2013-10-26 13:40:04','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2013-12-25 22:32:11'),(27281,21603,'Y','18','021','EC','A','','','AC','0000148406','0000148406','TX00002725885','IL','1','MORCOS','LUCIENNE','','','','34','107809601','5948 DAVENHILL DR',0,'PLANO','TX','75093','4346','CY','48085','1942-01-21','F','M',NULL,'N','021','DEN','3658583','33348TX002000201','2014-04-01','2014-03-03 22:57:06','0.00',NULL,NULL,'35.20','35.20','R-TX008','TX0','17.60',NULL,0,'2014-03-04 21:00:22'),(29173,23091,'Y','18','021','EC','A','','','AC','0000519899','0000519899','OH00003391125','IL','1','PATTON','BECKY','','','','34','294804385','2947 BURNHAM JUMP DR',0,'CUYAHOGA FALLS','OH','44223','1218','CY','39153','1983-05-17','F','M',NULL,'N','021','HLT','4011165','52664OH151001501','2014-04-01','2014-03-10 16:55:59','0.00',NULL,NULL,'836.36','836.36','R-OH012','OH0','303.57',NULL,0,'2014-03-10 21:03:01'),(1074,880,'Y','18','024','14','A','','','TE','0000721317','0000721317','','IL','1','Heskamp','Joshua',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-10-22','M','',NULL,NULL,NULL,'','47175','','2013-12-03','2013-12-03 09:09:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:16:36'),(7310,5794,'Y','18','021','EC','A','','','AC','0001029340','0001029340','OH00000949926','IL','1','Schrack','Curtis','','','','34','297781975','1432 CHIPPEWA AVE',0,'AKRON','OH','44305','2706','CY','39153','1966-06-07','M','M',NULL,'N','021','HLT','1198503','52664OH151001305','2014-01-01','2013-12-14 17:23:19','447.00',NULL,NULL,'651.18','204.18','R-OH012','OH0','348.56',NULL,0,'2013-12-26 02:03:20'),(23752,18907,'N','19','021','EC','A',NULL,NULL,'','0000221362','0000895762','','IL','1','Dahl','Cooper','Henry Talsnes','','','34','204821328','961 MCCLAIN RD',0,'GRANDVIEW HEIGHTS','OH','43212','3706','CY','39049','2006-02-09','M','',':RET:2106-3','N','021','DEN','2644067','99734OH005000301','2014-03-01','2014-02-14 11:21:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:07'),(7019,5573,'Y','18','021','EC','A','','','AC','0001247839','0001247839','TX00001245046','IL','1','Neill','Samuel','','','','34','630074639','3712 64TH DR',0,'LUBBOCK','TX','79413','5312','CY','48303','1986-05-20','M','U',':RET:2106-3','N','021','DEN','2385088','33348TX002000201','2014-01-01','2013-12-24 20:40:48','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 01:48:47'),(21164,16913,'Y','18','021','EC','A','','','AC','0000246488','0000246488','OH00002011327','IL','1','Coleman','Willie','R','','','34','269668517','1126 E 147TH ST',0,'CLEVELAND','OH','44110','3321','CY','39035','1961-06-07','M','U',':RET:2054-5','T','021','DEN','3783662','99734OH005000401','2014-03-01','2014-02-03 11:24:30','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-03 21:00:34'),(3707,2967,'Y','18','021','EC','A','','','AC','0001095634','0001095634','OH00000050185','IL','1','Piesciuk','Stephen','','','','34','066469661','3249 Creekside Drive',0,'Norton','OH','44203',NULL,'CY','39153','1956-07-18','M','M',':RET:2106-3','N','021','DEN','171040','99734OH005000401','2014-01-01','2013-12-13 14:24:49','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:32:07'),(20267,16172,'Y','18','021','EC','A','','','AC','0000067698','0000067698','OH00001909213','IL','1','BLACKSTONE','DEANNA','','','','34','571041950','6752 FALLON LN',0,'CANAL WINCHESTER','OH','43110','8790','CY','39049','1969-07-30','F','U',':RET:2106-3','N','021','DEN','3565060','99734OH005000301','2014-03-01','2014-01-28 16:01:56','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-28 21:00:21'),(5492,4360,'Y','18','021','EC','A','','','AC','0000659881','0000659881','OH00000658090','IL','1','Brown','Bonnie','','','','34','278643030','11930 ECKEL JUNCTION RD',0,'PERRYSBURG','OH','43551','1817','CY','39173','1957-04-20','F','M',':RET:2106-3','N','021','HLT','2099730','92036OH003002605','2014-01-01','2013-12-19 14:55:48','724.00',NULL,NULL,'971.34','247.34','R-OH001','OH0','475.07',NULL,0,'2013-12-25 23:11:04'),(19609,15628,'Y','18','024','14','A','','','TE','0000764925','0000764925','','IL','1','Saviciunas','Ray',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-05-05','M','',NULL,NULL,NULL,'','596267','','2014-01-22','2014-01-22 13:38:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-23 03:02:50'),(15640,12511,'Y','18','024','14','A','','','TE','0001160631','0001160631','','IL','1','Bui','Van',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-04-24','F','',NULL,NULL,NULL,'','2282017','','2013-12-30','2013-12-30 20:57:06',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',1,'2014-01-02 04:33:48'),(25880,20520,'Y','18','021','EC','A','','','AC','0002384912','0002384912','LA00003265274','IL','1','Dawson III','Harry','','','','34','434659724','2808 Stahl Drive',0,'Kenner','LA','70065',NULL,'CY','22051','1987-04-10','M','U',':RET:2106-3','N','021','DEN','3468489','18575LA002000201','2014-03-01','2014-02-26 17:52:32','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-26 21:00:57'),(16537,13228,'Y','18','021','EC','A','','','AC','0000191384','0000191384','OH00001848471','IL','1','lecorchick','willis','','','','34','284728788','2911 Parklane st. NW',0,'canton','OH','44709',NULL,'CY','39151','1976-11-11','M','U',':RET:2106-3','N','021','HLT','1514888','52664OH152000901','2014-02-01','2014-01-05 17:42:20','0.00',NULL,NULL,'202.22','202.22','R-OH015','OH0','202.22',NULL,1,'2014-01-07 10:22:12'),(26980,21373,'N','17','021','EC','A',NULL,NULL,'','0001024334','0000267586','','IL','1','Blessing','Linda','','','','34','276968584','4188 Kincheloe Rd.',0,'Georgetown','OH','45121',NULL,'CY','39015','1993-01-01','F','',':RET:2106-3','N','021','HLT','3749471','92036OH004000601','2014-04-01','2014-03-02 12:31:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','172.61',NULL,0,'2014-03-03 01:00:38'),(27929,22093,'Y','18','024','14','A','','','TE','0000169056','0000169056','','IL','1','WOOLBRIGHT','ROSE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-04-07','F','',NULL,NULL,NULL,'','3268239','','2014-03-06','2014-03-06 10:52:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-06 21:00:24'),(28597,22631,'N','01','021','EC','A',NULL,NULL,'','0001050698','0000116646','','IL','1','KRAMER','VINCENT','','','','34','292600706','3620 HIGHLAND GRN',0,'CINCINNATI','OH','45245','1755','CY','39025','1962-08-25','M','',NULL,'N','021','DEN','3574394','99734OH005000401','2014-04-01','2014-03-08 09:44:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-08 21:30:06'),(29118,23051,'Y','18','021','EC','A','','','AC','0000440829','0000440829','MS00003822655','IL','1','SMITH','THELMA','','','','34','587239891','1043 LARKSPUR ST',0,'JACKSON','MS','39213','6550','CY','28089','1958-03-26','F','U',NULL,'N','021','DEN','4080009','46300MS002000201','2014-04-01','2014-03-10 15:02:56','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-10 21:02:28'),(14277,11390,'Y','18','021','EC','A','','','AC','0000172872','0000172872','MS00000608248','IL','1','MOORE','ALEXANDER','','','','34','428233736','2304 LADD ST',0,'JACKSON','MS','39209',NULL,'CY','28049','1965-03-29','M','M',':RET:2054-5','N','021','DEN','1453080','46300MS002000201','2014-02-01','2013-12-26 15:57:04','0.00',NULL,NULL,'31.70','31.70','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:15'),(6179,4896,'Y','18','021','EC','A','','','AC','0000019074','0000019074','OH00000218181','IL','1','davidson','terrence','','','','34','488805725','4322 JACKMAN RD',0,'TOLEDO','OH','43612','1528','CY','39095','1976-07-18','M','U',NULL,'N','021','HLT','258668','92036OH006002601','2014-01-01','2013-10-02 16:16:34','0.00',NULL,NULL,'191.45','191.45','R-OH001','OH0','191.45',NULL,0,'2013-12-26 00:17:16'),(20638,16491,'N','01','021','EC','A',NULL,NULL,'','0000370871','0000535184','','IL','1','Montague','Keairra','','','','34','408510425','4914 Monteith Drive',0,'Spring','TX','77373',NULL,'CY','48201','1986-04-15','F','',NULL,'N','021','DEN','3483239','33348TX002000201','2014-03-01','2014-01-30 11:30:27',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-01-30 21:00:32'),(5537,4393,'Y','18','021','EC','A','','','AC','0000133279','0000133279','OH00000315746','IL','1','Hill','Polly','Ann','','','34','302766164','49499 MURRAY RD',0,'HOPEDALE','OH','43976','9803','CY','39067','1965-04-04','F','M',':RET:2106-3','N','021','DEN','568618','99734OH005000401','2014-01-01','2013-11-27 17:00:17','0.00',NULL,NULL,'31.57','31.57','R-OH016','OH0','0.00',NULL,0,'2013-12-25 23:15:43'),(18660,14876,'Y','18','021','EC','A','','','AC','0000713797','0000713797','TX00001658073','IL','1','NICHOLSON','WESLEY','','','','34','525519283','1710 HOWELL DR',0,'KINGSVILLE','TX','78363',NULL,'CY','48273','1965-08-02','M','U',':RET:1002-5','N','021','DEN','2190050','33348TX002000201','2014-03-01','2014-01-16 14:45:37','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-17 03:35:13'),(14888,11890,'Y','18','021','EC','A','','','AC','0002123792','0002123792','LA00001274795','IL','1','Darby','Raven','','','','34','249897274','132 North Cemetary Road',0,'Saint Martinville','LA','70582',NULL,'CY','22099','1992-06-10','F','U',':RET:2054-5','N','021','DEN','1638751','18575LA002000201','2014-02-01','2013-12-28 19:15:14','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2013-12-30 00:00:42'),(27441,21718,'Y','18','021','EC','A','','','AC','0001426207','0001426207','LA00003726029','31','1','Feeheley','Brian','P','','','34','369701196','P.O. Box 710',0,'Ringgold','LA','71068',NULL,'CY','22013','1957-12-07','M','M',NULL,'N','021','DEN','3236131','18575LA002000201','2014-04-01','2014-03-04 15:41:23','0.00',NULL,NULL,'29.22','29.22','R-LA008','LA0','14.61',NULL,0,'2014-03-04 21:01:53'),(2527,2060,'Y','18','021','EC','A','','','AC','0001241834','0001241834','OH00000822637','IL','1','Andreadis','Steve','','','','34','292642644','774 ROUNDTREE CT',0,'CINCINNATI','OH','45230','4329','CY','39061','1966-04-28','M','M',':RET:2106-3','N','021','HLT','1176892','92036OH001001201','2014-01-01','2013-12-09 08:04:19','518.00',NULL,NULL,'1286.45','768.45','R-OH004','OH0','404.73',NULL,0,'2013-12-25 19:36:46'),(13476,10747,'Y','18','021','EC','A','','','AC','0000640926','0000640926','OH00000939505','IL','1','Glier','Eric','','','','34','310765831','3663 STETTINIUS AVE',0,'CINCINNATI','OH','45208','1152','CY','39061','1975-07-28','M','U',NULL,'N','021','DEN','2103880','99734OH005000301','2014-01-01','2013-12-23 17:17:07','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 13:02:07'),(6410,5080,'N','01','021','EC','A',NULL,NULL,'','0000012411','0000190178','','IL','1','Wheeler','Erin','','','','34','285806187','2567 Shiloh Park',0,'Westlake','OH','44145',NULL,'CY','39035','1978-09-25','F','',':RET:2106-3','N','021','HLT','955981','92036OH005000806','2014-01-01','2013-12-10 18:29:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','285.69',NULL,0,'2013-12-26 00:48:36'),(22435,17913,'N','01','021','EC','A',NULL,NULL,'','0000832969','0000208067','','IL','1','reyes','maria','t','','','34','644543417','412 BRISTOL',0,'SAN ANTONIO','TX','78214','2128','CY','48029','1961-08-02','F','',NULL,'N','021','DEN','3564023','33348TX002000201','2014-03-01','2014-02-10 08:56:45',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-10 21:30:38'),(5661,4491,'Y','18','021','EC','A','','','AC','0000890715','0000890715','OH00000471439','IL','1','Gallagher','Brian','','','','34','289805297','1098 STONECREST DR',0,'TALLMADGE','OH','44278','3233','CY','39153','1979-06-12','M','U',':RET:2106-3','N','021','HLT','409360','52664OH151001301','2014-01-01','2013-11-25 19:41:50','0.00',NULL,NULL,'270.73','270.73','R-OH012','OH0','270.73',NULL,0,'2013-12-25 23:31:46'),(19605,15626,'Y','18','021','EC','A','','','AC','0000253081','0000253081','OH00002136066','IL','1','Rodgers','Tanya','','','','34','280708638','686 W. Liberty St.',0,'Medina','OH','44256',NULL,'CY','39103','1962-02-10','F','M',NULL,'N','021','HLT','2645899','52664OH152000901','2014-03-01','2014-01-22 09:36:18','504.00',NULL,NULL,'652.05','148.05','R-OH012','OH0','318.84',NULL,0,'2014-01-23 03:02:49'),(15341,12270,'Y','18','021','EC','A','','','AC','0001252123','0001252123','OH00001733610','IL','1','Hershberger','Trena','','','','34','284861773','15091 portage street lot 81',0,'Doylestown','OH','44230',NULL,'CY','39169','1987-06-02','F','U',':RET:2106-3','N','021','HLT','2331181','52664OH152000901','2014-02-01','2014-01-01 10:40:52','126.00',NULL,NULL,'167.26','41.26','R-OH014','OH0','167.26',NULL,1,'2014-01-02 04:24:14'),(27811,21996,'Y','18','021','EC','A','','','AC','0001173277','0001173277','OH00002865870','IL','1','Gauss','Randall','','','','34','283528163','180 WINCHESTER RD',0,'FAIRLAWN','OH','44333','3562','CY','39153','1951-11-10','M','M',':RET:2106-3','N','021','HLT','3737634','52664OH151001305','2014-04-01','2014-03-05 14:49:10','474.00',NULL,NULL,'640.70','166.70','R-OH012','OH0','640.70',NULL,0,'2014-03-05 21:31:50'),(29042,22985,'N','01','021','EC','A',NULL,NULL,'','0000239095','0001039820','','IL','1','MITCHELL','SUZANNE','','','','34','272847290','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','1973-11-16','F','',NULL,'N','021','DEN','3542283','99734OH005000401','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:41'),(1210,995,'Y','18','021','EC','A','','','AC','0000585505','0000585505','OH00000396405','IL','1','Carpenter','Kim','','','','34','273529325','10255 THWING RD',0,'CHARDON','OH','44024','9788','CY','39055','1951-12-03','M','M',NULL,'N','021','DEN','552941','99734OH005000301','2014-01-01','2013-12-03 16:32:15','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:20:05'),(25559,20276,'N','01','021','EC','A',NULL,NULL,'','0000929892','0001140831','','IL','1','Dunning','Connie',NULL,NULL,NULL,NULL,NULL,'207 INWOOD RD',0,'WILMINGTON','OH','45177','8355','CY','39027','1961-04-06','F','',NULL,'T','021','HLT','2937340','92036OH004000601','2014-04-01','2014-02-23 13:40:28',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','387.47',NULL,0,'2014-02-26 08:00:22'),(7667,6073,'Y','18','021','EC','A','','','AC','0001861361','0001861361','LA00001214596','IL','1','Robinson','Linda','','','','34','436929486','9582 KEVEL DR',0,'BATON ROUGE','LA','70810','4039','CY','22033','1952-05-12','F','U',':RET:2106-3','N','021','DEN','2600063','18575LA002000101','2014-01-01','2013-12-20 15:44:30','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 03:00:27'),(22423,17904,'Y','18','021','EC','A','','','AC','0002377667','0002377667','LA00002604807','IL','1','Cox','Jay','Merrill','','','34','425578247','3151 DAUPHINE ST',0,'NEW ORLEANS','LA','70117','6726','CY','22071','1980-03-29','M','U',':RET:2106-3','N','021','DEN','3404554','18575LA002000201','2014-03-01','2014-02-10 15:00:11','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-10 21:30:31'),(4006,3200,'Y','18','021','EC','A','','','AC','0001245581','0001245581','OH00000794411','IL','1','Eversole','Deborah','','','','34','287549922','6211  Watchcreek Way Apt. 103',0,'Milford','OH','45150',NULL,'CY','39025','1952-06-24','F','U',':RET:2106-3','N','021','DEN','2047812','99734OH005000401','2014-01-01','2013-12-16 21:13:54','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 21:45:18'),(5348,4242,'Y','18','021','EC','A','','','AC','0001196802','0001196802','OH00000058929','IL','1','Mahony','Mary','','','','34','292529037','3049 Hamlin Rd',0,'Medina','OH','44256',NULL,'CY','39103','1952-08-30','F','M',':RET:2106-3','N','021','HLT','1858452','52664OH152000901','2014-01-01','2013-12-19 10:50:49','657.00',NULL,NULL,'917.98','260.98','R-OH012','OH0','458.99',NULL,0,'2013-12-25 23:07:34'),(21315,17032,'Y','18','021','EC','A','','','AC','0001452421','0001452421','LA00002180030','31','1','Bryant','Shannon','','','','34','433839877','P. O. Box 273',0,'Grayson','LA','71435',NULL,'CY','22021','1991-09-21','M','U',':RET:2106-3','N','021','DEN','3146378','18575LA002000201','2014-03-01','2014-02-04 14:13:31','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-04 21:00:19'),(19005,15135,'Y','18','024','14','A','','','TE','0002030436','0002030436','','IL','1','Savage','Christopher',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-10-18','M','',NULL,NULL,NULL,'','2731397','','2014-01-17','2014-01-17 13:20:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-20 08:06:17'),(18726,14925,'N','01','021','EC','A',NULL,NULL,'','0001113169','0001257355','','IL','1','TURNER-YAMAMOTO','SHINJI','','','','34','697079776','2324 MADISON RD',0,'CINCINNATI','OH','45208',NULL,'CY','39061','1965-01-31','M','',':RET:2039-6','N','021','DEN','2132845','99734OH005000301','2014-02-01','2014-01-15 23:37:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:36'),(17599,14068,'Y','18','021','EC','A','','','AC','0000289082','0000289082','MS00001566658','IL','1','Briggs','Justin','','','','34','425537426','523 Foster Rd',0,'Florence','MS','39073',NULL,'CY','28121','1981-08-18','M','U',':RET:2054-5','T','021','DEN','1565414','46300MS002000201','2014-02-01','2014-01-13 18:23:10','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-14 01:32:15'),(15939,12761,'N','19','021','EC','A',NULL,NULL,'','0001016864','0001153624','','IL','1','FISHBACK','ANTHONY','','','','34','272941687','1 ALLISON CT',0,'WILLIAMSBURG','OH','45176','9298','CY','39025','1991-04-25','M','',':RET:2106-3','N','021','HLT','1995400','92036OH005000606','2014-02-01','2014-01-02 13:38:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','214.67',NULL,0,'2014-01-03 02:07:10'),(26570,21066,'Y','18','021','EC','A','','','AC','0000376195','0000376195','OH00002356617','IL','1','Payne','John','','','','34','272444664','3103 COUNTY ROAD 231',0,'FREMONT','OH','43420','9226','CY','39143','1952-02-07','M','U',NULL,'N','021','DEN','3716714','99734OH005000401','2014-04-01','2014-02-28 11:07:06','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-28 21:30:25'),(27515,21767,'Y','18','021','EC','A','','','AC','0000479913','0000479913','OH00002704757','IL','1','lawrence','patrice','','','','34','272728389','6544 Maplewood rd',0,'cleveland','OH','44124',NULL,'CY','39035','1972-07-25','F','U',':RET:2054-5','N','021','HLT','3666016','92036OH001000801','2014-04-01','2014-03-04 11:13:04','0.00',NULL,NULL,'367.19','367.19','R-OH011','OH0','367.19',NULL,0,'2014-03-04 21:02:35'),(27614,21839,'Y','18','024','14','A','','','TE','0000008568','0000008568','','IL','1','rives','Laureen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-04-08','F','',NULL,NULL,NULL,'','803427','','2014-03-31','2014-03-05 17:39:28',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-05 21:00:30'),(28050,22196,'Y','18','021','EC','A','','','AC','0000136325','0000136325','MS00002887743','IL','1','MORRIS','JOYCELYN','L','','','34','428713948','71 BELLAIRE DR',0,'VICKSBURG','MS','39180','5311','CY','28149','1991-07-01','F','U',':RET:2054-5','N','021','DEN','2796860','46300MS002000201','2014-04-01','2014-03-06 10:58:39','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-03-06 21:01:37'),(28106,22247,'Y','18','021','EC','A','','','AC','0000176453','0000176453','OH00003694894','IL','1','BLOMGREN','MARY','','','','34','283485136','3427 HILLTOP DRIVE NW',0,'UNIONTOWN','OH','44685',NULL,'CY','39151','1950-01-19','F','U',':RET:2106-3','T','021','HLT','3020105','52664OH152000901','2014-04-01','2014-03-06 15:29:58','510.00',NULL,NULL,'563.50','53.50','R-OH015','OH0','563.50',NULL,0,'2014-03-06 21:02:13'),(1802,1480,'Y','18','021','EC','A','','','AC','0000664185','0000664185','OH00001128002','IL','1','COHEN','MICHELLE','L','','','34','273761670','3306 VIENNA WOODS DR',0,'CINCINNATI','OH','45211','2902','CY','39061','1979-12-03','F','U',':RET:2054-5','N','021','HLT','1488564','92036OH004001201','2014-01-01','2013-12-24 10:28:37','98.00',NULL,NULL,'209.55','111.55','R-OH004','OH0','209.55',NULL,0,'2013-12-25 18:56:47'),(22244,17755,'Y','18','021','EC','A','','','AC','0000700424','0000700424','OH00001467467','IL','1','Buckner','Janet','','','','34','274503530','1100 Bernath Pkwy',0,'Toledo','OH','43615',NULL,'CY','39095','1953-12-11','F','U',':RET:2106-3','N','021','DEN','2727533','99734OH005000301','2014-03-01','2014-02-09 15:54:43','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-09 19:00:39'),(21782,17395,'Y','18','021','EC','A','','','AC','0000847186','0000847186','OH00001912623','IL','1','Loomis','William','','','','34','224118600','5626 Summerville Dr',0,'Galloway','OH','43119',NULL,'CY','39049','1966-07-03','M','M',':RET:2106-3','N','021','DEN','3376436','99734OH005000401','2014-03-01','2014-02-05 23:29:38','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-06 21:00:38'),(7402,5857,'N','01','021','EC','A',NULL,NULL,'','0000680804','0000980499','','IL','1','CLOSSON','GLORIA','','','','34','283503317','1284 S BREDEICK ST',0,'DELPHOS','OH','45833','2299','CY','39161','1951-04-24','F','',':RET:2106-3','N','021','HLT','81544','92036OH006001501','2014-01-01','2013-11-23 08:24:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','501.46',NULL,0,'2013-12-26 02:16:26'),(20893,16698,'Y','18','021','EC','A','','','AC','0001157596','0001157596','OH00001664720','IL','1','dominic','susan','','','','34','275601888','205 LAUREL ST',0,'YOUNGSTOWN','OH','44505','1923','CY','39155','1955-11-30','F','U',NULL,'N','021','DEN','3241636','99734OH005000401','2014-03-01','2014-01-31 10:38:52','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,0,'2014-01-31 21:01:16'),(3201,2575,'Y','18','021','EC','A','','','AC','0000160746','0000160746','OH00000252891','IL','1','Lawson','Aaron','','','','34','291867354','104 Plaza ct',0,'Akron','OH','44312',NULL,'CY','39153','1974-10-02','M','U',':RET:2106-3','N','021','DEN','726907','99734OH005000401','2014-01-01','2013-10-31 20:04:31','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:45:10'),(17051,13644,'Y','18','021','EC','A','','','AC','0000877132','0000877132','OH00002216888','IL','1','Nye','Larry','','','','34','287443102','829 Cory St.',0,'Fostoria','OH','44830',NULL,'CY','39147','1950-12-19','M','U',':RET:2106-3','N','021','HLT','1541695','92036OH003002705','2014-02-01','2014-01-08 21:49:42','528.00',NULL,NULL,'601.12','73.12','R-OH006','OH0','601.12',NULL,0,'2014-01-13 02:20:58'),(16289,13040,'Y','18','024','14','A','','','TE','0000979310','0000979310','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','2179776','','2014-01-06','2014-01-06 17:02:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:00:47'),(3966,3170,'N','19','021','EC','A',NULL,NULL,'','0000951775','0000696796','','IL','1','Cickovskis','Max','Paul','','','34','294926514','3440 W SPRAGUE RD',0,'PARMA','OH','44134','6378','CY','39035','1990-10-01','M','',':RET:2106-3','N','021','HLT','584244','52664OH151001501','2014-01-01','2013-12-13 16:16:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','301.66',NULL,0,'2013-12-25 21:38:29'),(4884,3873,'Y','18','024','14','A','','','TE','0000019074','0000019074','','IL','1','davidson','terrence',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-07-18','M','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 22:31:19'),(26386,20931,'N','19','021','EC','A',NULL,NULL,'','0000194050','0001224518','','IL','1','TAYLOR','OLIVIA','','','','34','277155468','427 S PROSPECT ST',0,'MEDINA','OH','44256','2348','CY','39103','2009-03-22','F','',NULL,'N','021','HLT','3232398','52664OH151001301','2014-03-01','2014-02-26 11:42:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61','CIC',0,'2014-02-28 07:00:23'),(3497,2808,'Y','18','021','EC','A','','','AC','0000949512','0000949512','OH00000575055','IL','1','Moore','Terrance','','','','34','271642062','7609 SPAFFORD RD',0,'CLEVELAND','OH','44105','3628','CY','39035','1956-02-11','M','R',':RET:2106-3','N','021','DEN','2285607','99734OH005000401','2014-01-01','2013-12-22 14:51:16','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:35'),(9215,7310,'Y','18','021','EC','A','','','AC','0000241511','0000241511','OH00000264888','IL','1','STRIKE','NICHOLAS','','','','34','295842232','1516 CHARLESTON LN',0,'LOVELAND','OH','45140','8016','CY','39025','1970-10-09','M','U',':RET:2106-3','N','021','HLT','1418462','92036OH001000601','2014-01-01','2013-12-18 11:12:37','173.00',NULL,NULL,'351.38','178.38','R-OH005','OH0','351.38',NULL,0,'2013-12-26 04:10:01'),(3918,3136,'Y','18','021','EC','A','','','AC','0000641254','0000641254','TX00000103225','IL','1','Cornett','Barbara','','','','34','453947322','1815 GEARY ST',0,'GARLAND','TX','75043','7535','CY','48113','1951-10-12','F','R',':RET:2106-3','N','021','DEN','1207332','33348TX002000101','2014-01-01','2013-12-13 16:50:58','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 21:37:17'),(93,82,'Y','18','021','EC','A','','','AC','0000742657','0000742657','TX00000218404','31','1','Ruiz Healy','Josephine','','','','34','455614413','2829 BABCOCK RD',0,'SAN ANTONIO','TX','78229','6028','CY','48125','1957-08-04','F','U',':RET:2106-3','N','021','DEN','421707','33348TX002000201','2014-01-01','2013-12-04 20:47:53','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:17:29'),(25871,20512,'Y','18','021','EC','A','','','AC','0001356226','0001356226','LA00003443165','31','1','LaFountain','Toni','','','','34','009481325','po box 2',0,'Erath','LA','70533',NULL,'CY','22113','1976-10-31','F','U',':RET:2106-3','N','021','DEN','3086868','18575LA002000201','2014-04-01','2014-02-26 16:17:52','0.00',NULL,NULL,'14.61','14.61','R-LA003','LA0','14.61',NULL,0,'2014-02-26 21:00:51'),(538,439,'Y','18','021','EC','A','','','AC','0000590241','0000590241','MS00001095828','IL','1','COWAN','DEBORAH','NICOLE','','','34','428878806','3425 OLD PIGEON ROOST ROAD',0,'BYHALIA','MS','38611',NULL,'CY','28033','2000-02-28','F','U',':RET:2054-5','N','021','DEN','1015060','46300MS002000101','2014-01-01','2013-12-04 11:22:28','0.00',NULL,NULL,'47.10','47.10','R-MS001','MS0','47.10',NULL,0,'2013-12-25 17:49:38'),(6023,4767,'Y','18','021','EC','A','','','AC','0000762156','0000762156','TX00000822458','IL','1','Walstrom','Elias','','','','34','629129668','6201 Escondido Dr',0,'El Paso','TX','79912',NULL,'CY','48141','1982-05-14','M','U',':RET:2106-3','N','021','DEN','919642','33348TX002000201','2014-01-01','2013-12-01 13:21:18','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 00:00:55'),(21334,17049,'Y','18','024','14','A','','','TE','0001162013','0001162013','','IL','1','waller','terry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-05-11','M','',NULL,NULL,NULL,'','2480201','','2014-02-03','2014-02-03 19:43:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-04 21:00:30'),(28057,22202,'N','01','021','EC','A',NULL,NULL,'','0000768896','0000214664','','IL','1','WILLIAMS','COLLEEN','','','','34','269843864','5344 WILDCAT PIKE',0,'MARION','OH','43302','9432','CY','39101','1985-07-30','F','',':RET:2106-3','N','021','DEN','3987665','99734OH005000301','2014-04-01','2014-03-05 18:34:42',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-06 21:01:41'),(21140,16892,'Y','18','021','EC','A','','','AC','0001153976','0001153976','TX00001407789','IL','1','Stephens','Richard','','','','34','461829676','8284 CARRIAGE LN',0,'WICHITA FALLS','TX','76305','6022','CY','48485','1950-05-07','M','M',':RET:2106-3','N','021','DEN','3335449','33348TX002000201','2014-03-01','2014-02-03 16:40:56','0.00',NULL,NULL,'15.85','15.85','R-TX025','TX0','15.85',NULL,0,'2014-02-03 21:00:21'),(19464,15514,'N','01','021','EC','A',NULL,NULL,'','0000153046','0000300118','','IL','1','LIU','MEI-YING','','','','34','101961617','3801 49TH ST',0,'LUBBOCK','TX','79413','3717','CY','48303','1984-10-07','F','',':RET:2034-7','N','021','DEN','1928678','33348TX002000201','2014-03-01','2014-01-22 10:22:08',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 03:01:57'),(19236,15328,'Y','18','021','EC','A','','','AC','0000597328','0000597328','OH00001456521','IL','1','Powell','Robert','','','','34','292866618','1185 CAREY AVE',0,'AKRON','OH','44314','1935','CY','39153','1985-01-11','M','M',':RET:2106-3','N','021','DEN','2513463','99734OH005000301','2014-03-01','2014-01-20 10:02:40','0.00',NULL,NULL,'42.26','42.26','R-OH012','OH0','0.00',NULL,0,'2014-01-21 08:46:35'),(18521,14768,'Y','18','021','EC','A','','','AC','0001199248','0001199248','TX00001685057','IL','1','pell','abbie','','','','34','627038734','7041 N US HIGHWAY 281',0,'BURNET','TX','78611','5780','CY','48053','1988-03-21','F','U',':RET:2106-3','N','021','DEN','1566743','33348TX002000101','2014-02-01','2014-01-15 00:05:30','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-16 08:46:38'),(16285,13037,'Y','18','021','EC','A','','','AC','0001010222','0001010222','OH00001495434','IL','1','Duff','Angela','','','','34','407137135','105 West 4th st.',0,'Cincinnati','OH','45202',NULL,'CY','39061','1980-01-21','F','R',':RET:2106-3','T','021','DEN','2354535','99734OH005000401','2014-02-01','2014-01-06 11:39:28','0.00',NULL,NULL,'31.57','31.57','R-OH004','OH0','0.00',NULL,0,'2014-01-07 04:00:39'),(772,638,'Y','18','021','EC','A','','','AC','0000987102','0000987102','TX00000594007','IL','1','Chapin','Carl','','','','34','458253694','11715 SANTA CRUZ DR',0,'AUSTIN','TX','78759','4254','CY','48453','1962-02-22','M','U',NULL,'T','021','DEN','2134259','33348TX002000201','2014-01-01','2013-12-16 12:37:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 18:04:50'),(26550,21050,'Y','18','021','EC','A','','','AC','0000304700','0000304700','OH00003434326','IL','1','DICKERSON','DARLENE','','','','34','280567389','5434 FOX RD',0,'CINCINNATI','OH','45239',NULL,'CY','39061','1958-02-22','F','M',':RET:2054-5','N','021','DEN','3605113','99734OH005000301','2014-04-01','2014-02-28 14:23:49','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-02-28 21:30:12'),(9245,7332,'N','19','021','EC','A',NULL,NULL,'','0001157551','0000440808','','IL','1','Roessner','Jason','M',NULL,NULL,NULL,NULL,'PO Box 380  704 Little Turtle Drive',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1998-09-11','M','',':RET:2106-3','N','021','HLT','2146728','92036OH002001501','2014-01-01','2013-12-18 17:07:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','161.40',NULL,0,'2013-12-26 04:10:43'),(23652,18833,'Y','18','021','EC','A','','','AC','0000997938','0000997938','TX00002709674','IL','1','Pena','Gustavo','','','','34','627187190','1408 Hemlock Dr.',0,'Laredo','TX','78041',NULL,'CY','48479','1986-09-22','M','U',':RET:2106-3','N','021','DEN','3765476','33348TX002000201','2014-03-01','2014-02-13 23:39:13','0.00',NULL,NULL,'14.61','14.61','R-TX012','TX0','14.61',NULL,0,'2014-02-14 21:30:14'),(22890,18249,'N','01','021','EC','A',NULL,NULL,'','0000401282','0001039792','','IL','1','Bray','Timothy','','','','34','279684437','2275 ORCHARD HILLS BLVD',0,'TOLEDO','OH','43615','2638','CY','39095','1963-07-26','M','',':RET:2106-3','N','021','HLT','3603202','92036OH003002604','2014-03-01','2014-02-11 10:03:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','363.68',NULL,0,'2014-02-11 21:02:36'),(22673,18106,'Y','18','021','EC','A','','','AC','0000252360','0000252360','TX00001548965','IL','1','manto','rolando','','','','34','730094602','1730 sheffield drive',0,'nacogdoches','TX','75965',NULL,'CY','48347','1951-12-22','M','M',':RET:2036-2','N','021','DEN','2931259','33348TX002000201','2014-03-01','2014-02-11 15:26:17','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-11 21:00:43'),(16159,12940,'Y','18','021','EC','A','','','AC','0000801241','0000801241','OH00000611639','IL','1','Iddrissu','Assanatu','','','','34','302110340','1100 RING NECK DR',0,'BLACKLICK','OH','43004','7035','CY','39049','1977-10-28','F','U',':RET:2054-5','N','021','DEN','1671017','99734OH005000401','2014-01-01','2013-12-16 22:09:14','0.00',NULL,NULL,'50.05','50.05','R-OH009','OH0','0.00',NULL,0,'2014-01-04 06:00:09'),(4851,3843,'Y','18','021','EC','A','','','AC','0001090877','0001090877','OH00000969218','IL','1','Robinson','Marya','','','','34','291868416','11 S. Timber Hollow Dr.',0,'Fairfield','OH','45014',NULL,'CY','39017','1987-09-17','F','U',NULL,'N','021','DEN','1036818','99734OH005000401','2014-01-01','2013-11-08 14:13:58','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:30:22'),(25905,20540,'Y','18','024','14','A','','','TE','0000758335','0000758335','','IL','1','Jefferson','Larry',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-18','M','',NULL,NULL,NULL,'','2418478','','2014-02-26','2014-02-26 14:10:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-26 21:01:11'),(24881,19728,'N','01','021','EC','A',NULL,NULL,'','0000540301','0001162595','','IL','1','Knoll','Susan','','','','34','397704969','6986 COUNTY ROAD 39',0,'HUNTSVILLE','OH','43324','9615','CY','39091','1971-05-16','F','',':RET:2106-3','N','021','DEN','3096036','99734OH005000301','2014-04-01','2014-02-19 10:20:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-20 05:36:15'),(15868,12706,'Y','18','024','14','A','','','TE','0000200446','0000200446','','IL','1','Yeager','Jaimee',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1991-01-08','F','',NULL,NULL,NULL,'','1987830','','2014-01-02','2014-01-02 14:20:55',NULL,NULL,NULL,NULL,NULL,NULL,'MS0',NULL,'CANCEL',0,'2014-01-03 02:05:00'),(21814,17420,'Y','18','021','EC','A','','','AC','0000666797','0000666797','OH00001647111','IL','1','Pryseski','Julie','','','','34','300601510','63 CASTLE BLVD',0,'AKRON','OH','44313','6528','CY','39153','1962-10-28','F','U',':RET:2106-3','N','021','HLT','2650855','52664OH151001305','2014-03-01','2014-02-06 12:52:35','374.00',NULL,NULL,'557.52','183.52','R-OH012','OH0','415.91',NULL,0,'2014-02-06 21:00:55'),(15005,11994,'Y','18','024','14','A','','','TE','0001230670','0001230670','','IL','1','Pitts','Kenneth',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-09-27','M','',NULL,NULL,NULL,'','61576','','2013-12-30','2013-12-30 18:38:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-01 12:01:51'),(551,452,'Y','18','021','EC','A','','','AC','0000804298','0000804298','TX00000692143','31','1','Gonzales','Maria','','','','34','568848855','621 W MAIN ST',0,'UVALDE','TX','78801','5126','CY','48463','1950-03-03','F','M',':RET:2106-3','N','021','DEN','1211','33348TX002000101','2014-01-01','2013-12-04 12:46:21','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-25 17:50:02'),(684,563,'Y','18','021','EC','A','','','AC','0000017611','0000017611','OH00001048373','IL','1','Guest','Timothy','','','','34','386800400','5775 Kensington Ridge Drive',0,'Cincinnati','OH','45230',NULL,'CY','39061','1961-01-03','M','R',':RET:2106-3','N','021','DEN','1640599','99734OH005000301','2014-01-01','2013-12-16 12:12:15','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 18:02:28'),(9559,7577,'Y','18','021','EC','A','','','AC','0000427622','0000427622','OH00001343028','IL','1','Turner','Shirley','','','','34','300504332','2558 LA PLATA DR',0,'KETTERING','OH','45420','1121','CY','39113','1950-02-02','F','U',':RET:2106-3','N','021','DEN','1716199','99734OH005000301','2014-01-01','2013-12-21 15:14:30','0.00',NULL,NULL,'21.13','21.13','R-OH003','OH0','0.00',NULL,0,'2013-12-26 04:36:31'),(23847,18975,'Y','18','024','14','A','','','TE','0000216105','0000216105','','IL','1','DeGroff','Leanna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-03-23','F','',NULL,NULL,NULL,'','2143577','','2014-03-01','2014-02-14 13:22:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-14 21:31:56'),(9172,7275,'Y','18','021','EC','A','','','AC','0000255949','0000255949','OH00001254327','IL','1','brammer','marjorie','','','','34','283469728','50 JEE RD',0,'WINCHESTER','OH','45697','9490','CY','39001','1950-06-30','F','U',':RET:2106-3','N','021','HLT','1643230','92036OH005000606','2014-01-01','2013-12-18 09:23:55','607.00',NULL,NULL,'633.70','26.70','R-OH005','OH0','633.70',NULL,0,'2013-12-26 04:08:58'),(19117,15231,'Y','18','021','EC','A','','','AC','0001162621','0001162621','OH00001663464','IL','1','Hutchinson','John','','','','34','281526306','4861 State Rt 133',0,'Williamsburg','OH','45176',NULL,'CY','39025','1956-08-02','M','U',NULL,'T','021','HLT','2804635','92036OH003000604','2014-03-01','2014-01-18 16:49:51','296.00',NULL,NULL,'628.29','332.29','R-OH005','OH0','628.29',NULL,0,'2014-01-21 08:44:48'),(25391,20145,'N','01','021','EC','A',NULL,NULL,'','0000493295','0000111943','','IL','1','KRANES','CYNTHIA','L','','','34','285646758','35888 CHESTNUT RIDGE RD',0,'NORTH RIDGEVILLE','OH','44039','3928','CY','39093','1956-05-23','F','',NULL,'T','021','HLT','2960853','52664OH151001301','2014-04-01','2014-02-25 10:31:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','704.90',NULL,0,'2014-02-25 21:30:52'),(13436,10718,'N','01','021','EC','A',NULL,NULL,'','0000540301','0001162595','','IL','1','Knoll','Susan','','','','34','397704969','6986 COUNTY ROAD 39',0,'HUNTSVILLE','OH','43324','9615','CY','39091','1971-06-16','F','',':RET:2106-3','N','021','DEN','1908737','99734OH005000301','2014-01-01','2013-12-23 13:03:50',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:01:10'),(23842,18970,'Y','18','021','EC','A','','','AC','0001170879','0001170879','OH00002420938','IL','1','Lopez','MaryAnne','','','','34','041407922','210 BUCKEYE ST',0,'GENOA','OH','43430','1817','CY','39123','1957-11-10','F','U',':RET:2106-3','T','021','HLT','3552579','92036OH003002706','2014-03-01','2014-02-13 21:52:12','398.00',NULL,NULL,'546.33','148.33','R-OH006','OH0','546.33',NULL,0,'2014-02-14 21:31:53'),(13333,10646,'Y','18','021','EC','A','','','AC','0000467823','0000467823','TX00001238397','IL','1','Chavez','Margarita','','','','34','466677199','411 51ST ST',0,'LUBBOCK','TX','79404','4405','CY','48303','1968-10-23','F','U',NULL,'N','021','DEN','2583949','33348TX002000201','2014-01-01','2013-12-23 17:57:10','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 12:58:41'),(23394,18643,'Y','18','021','EC','A','','','AC','0000766018','0000766018','OH00002150631','IL','1','Cress','Pamela','','','','34','270441680','200 Maple St.',0,'Sugar Grove','OH','43155',NULL,'CY','39045','1954-12-12','F','M',':RET:2106-3','N','021','DEN','3593617','99734OH005000401','2014-03-01','2014-02-13 15:40:22','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:01:07'),(20724,16559,'N','01','021','EC','A',NULL,NULL,'','0000752115','0000078804','','IL','1','GRADY','JACQUELINE','','','','34','289508294','2927 STANFIELD DR',0,'PARMA','OH','44134',NULL,'CY','39035','1950-02-03','F','',NULL,'N','021','HLT','2626403','52664OH151001301','2014-03-01','2014-01-30 09:58:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','754.54',NULL,0,'2014-01-30 21:01:16'),(20160,16089,'Y','18','021','EC','A','','','AC','0000483511','0000483511','OH00002352154','IL','1','WISE','CHINESA','','','','34','298583196','1925 EMMA PL',0,'CINCINNATI','OH','45223','2436','CY','39061','1957-11-27','F','U',NULL,'N','021','DEN','1399885','99734OH005000301','2014-03-01','2014-01-27 15:38:49','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-27 21:01:09'),(8914,7070,'Y','18','021','EC','A','','','AC','0000581469','0000581469','OH00000143644','IL','1','ryan','james','a','','','34','284541280','82 S 33RD ST',0,'NEWARK','OH','43055','1919','CY','39089','1954-03-29','M','M',':RET:2106-3','N','021','DEN','1491964','99734OH005000401','2014-01-01','2013-12-18 00:21:42','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:02:39'),(3917,3135,'Y','18','024','14','A','','','TE','0000637200','0000637200','','IL','1','maley','emily',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-11-27','F','',NULL,NULL,NULL,'','1197953','','2013-12-13','2013-12-13 15:48:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:37:16'),(610,502,'Y','18','021','EC','A','','','AC','0000710119','0000710119','OH00000059876','IL','1','HUGHES','CONSTANCE','','','','34','286565506','1324 BRICE AVE',0,'LIMA','OH','45805','2416','CY','39003','1959-02-13','F','U',':RET:2054-5','N','021','DEN','2049055','99734OH005000401','2014-01-01','2013-12-16 10:01:49','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-25 18:00:32'),(9426,7478,'Y','18','021','EC','A','','','AC','0000322831','0000322831','TX00000514573','IL','1','Stewart','Daniel','','','','34','627223958','7025 DESERT CANYON DR',0,'EL PASO','TX','79912','7662','CY','48141','1987-10-09','M','U',':RET:2106-3','N','021','DEN','1456584','33348TX002000201','2014-01-01','2013-12-21 16:53:00','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 04:33:15'),(26712,21174,'N','01','021','EC','A',NULL,NULL,'','0000991598','0001183579','','IL','1','BENNER','RICHARD','','','','34','268689536','363 S HOWARD ST',0,'SABINA','OH','45169','1402','CY','39027','1959-02-11','M','',':RET:2106-3','T','021','HLT','3777685','92036OH003000601','2014-03-01','2014-02-28 09:57:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','574.91',NULL,0,'2014-02-28 21:31:38'),(20280,16185,'Y','18','021','EC','A','','','AC','0000203116','0000203116','OH00001734202','IL','1','LEONBERGER','ROBERT','D','','','34','300524119','754 LINCOLN HWY',0,'BUCYRUS','OH','44820','9760','CY','39033','1958-10-22','M','U',':RET:2106-3','N','021','DEN','3287684','99734OH005000401','2014-03-01','2014-01-28 13:52:17','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-01-28 21:00:28'),(19916,15883,'N','01','021','EC','A',NULL,NULL,'','0000300124','0000487972','','IL','1','Aziz','Ashrafunissa','','','','34','635923205','3957 INDIAN OAKS LN',0,'CARROLLTON','TX','75010','6440','CY','48121','1958-02-24','F','',':RET:2029-7','N','021','DEN','2526649','33348TX002000101','2014-03-01','2014-01-24 00:06:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-24 21:01:02'),(9241,7330,'Y','18','021','EC','A','','','AC','0000789658','0000789658','OH00000055162','IL','1','Johnson','Paula',NULL,NULL,NULL,NULL,NULL,'1866 MARLOES AVE',0,'EAST CLEVELAND','OH','44112','3922','CY','39035','1974-06-11','F','U',NULL,'N','021','HLT','1583018','92036OH004000801','2014-01-01','2013-12-18 15:57:55','87.00',NULL,NULL,'237.24','150.24','R-OH011','OH0','237.24',NULL,0,'2013-12-26 04:10:39'),(6351,5033,'Y','18','024','14','A','','','TE','0000950644','0000950644','','IL','1','JANSON','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-08-03','F','',NULL,NULL,NULL,'','292227','','2013-12-11','2013-12-11 13:34:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 00:47:03'),(26228,20802,'Y','18','021','EC','A','','','AC','0000054575','0000054575','TX00003014948','IL','1','CRUZ','MARY JANE','','','','34','219700278','312 N AVENUE S',0,'LUBBOCK','TX','79415','3111','CY','48303','1964-04-28','F','M',NULL,'N','021','DEN','3533235','33348TX002000201','2014-04-01','2014-02-26 21:36:34','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-02-28 06:31:00'),(24624,19543,'Y','18','021','EC','A','','','AC','0001585065','0001585065','LA00001675697','IL','1','GALMON','RICARDO','','','','34','435736617','1366 GUY RD',0,'GREENSBURG','LA','70441','4610','CY','22091','1989-02-01','M','U',NULL,'T','021','DEN','3674870','18575LA002000201','2014-04-01','2014-02-18 18:33:07','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-20 04:16:43'),(8025,6353,'Y','18','021','EC','A','','','AC','0001232944','0001232944','MS00001102400','IL','1','Scruggs','Elizabeth','B','','','34','428552688','6870 WROTEN RD',0,'SMITHDALE','MS','39664','8743','CY','28005','1973-07-10','F','M',':RET:2106-3','N','021','DEN','2529561','46300MS002000101','2014-01-01','2013-12-19 21:13:12','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 03:09:00'),(2503,2039,'Y','18','021','EC','A','','','AC','0000161576','0000161576','LA00001249126','IL','1','Pevey','Richard','','','','34','435845309','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1951-10-23','M','M',':RET:2106-3','N','021','DEN','377343','18575LA002000201','2014-01-01','2013-12-09 17:52:16','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:36:04'),(22899,18253,'Y','18','021','EC','A','','','AC','0000604746','0000604746','OH00001518486','IL','1','Schwab','Patricia','','','','34','296581604','5561 S State Rt 19',0,'Bloomville','OH','44818',NULL,'CY','39147','1956-08-12','F','M',':RET:2106-3','N','021','HLT','2791158','92036OH004002701','2014-03-01','2014-02-11 10:24:48','307.00',NULL,NULL,'382.11','75.11','R-OH006','OH0','382.11',NULL,0,'2014-02-11 21:02:40'),(1374,1139,'Y','18','021','EC','A','','','AC','0000044688','0000044688','TX00000962745','IL','1','Mosley','Jeff','','','','34','467678184','2600 PENNY LN',0,'AUSTIN','TX','78757','7604','CY','48453','1979-05-15','M','U',':RET:2106-3','T','021','DEN','2262600','33348TX002000101','2014-01-01','2013-12-24 17:45:28','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:52'),(22222,17738,'Y','18','021','EC','A','','','AC','0001126916','0001126916','OH00002173314','IL','1','Norman','Robert','','','','34','272880256','2926 State Road',0,'Cuyahoga Falls','OH','44223',NULL,'CY','39153','1982-01-13','M','U',':RET:2106-3','N','021','HLT','3460329','52664OH151001305','2014-03-01','2014-02-08 20:56:51','170.00',NULL,NULL,'263.82','93.82','R-OH012','OH0','263.82',NULL,0,'2014-02-09 19:00:27'),(19392,15460,'Y','18','021','EC','A','','','AC','0000553942','0000553942','OH00002250407','IL','1','Wever','Natasha','','','','34','446923249','3863 OLIVETTE AVE',0,'CINCINNATI','OH','45211','4816','CY','39061','1982-08-24','F','U',':RET:2106-3','T','021','DEN','3236545','99734OH005000401','2014-03-01','2014-01-21 11:38:09','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-22 03:22:48'),(17296,13832,'Y','18','021','EC','A','','','AC','0000667265','0000667265','TX00002298535','IL','1','DOBBELS','JENNIFER','','','','34','451352762','630 WEST HWY 56',0,'BONAHM','TX','75418',NULL,'CY','48147','1975-12-06','F','U',':RET:2106-3','N','021','DEN','1522271','33348TX002000201','2014-02-01','2014-01-10 10:18:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-13 02:23:35'),(1504,1253,'N','01','021','EC','A',NULL,NULL,'','0000122982','0000869285','','IL','1','Hollenbeck','William','Andrew','','','34','402174751','10947 SHADOW GLEN DR',0,'LOVELAND','OH','45140','7800','CY','39061','1981-04-15','M','',':RET:2106-3','N','021','DEN','1642424','99734OH005000401','2014-01-01','2013-12-24 12:24:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:49:19'),(26487,21010,'Y','18','021','EC','A','','','AC','0002280124','0002280124','LA00001899996','IL','1','Turner','Tress','','','','34','439378400','823 NAVARRE AVE',0,'NEW ORLEANS','LA','70124','2707','CY','22071','1965-06-20','F','U',':RET:2106-3','N','021','DEN','3750783','18575LA002000201','2014-04-01','2014-02-27 22:08:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61','CIC',0,'2014-02-28 21:00:08'),(5121,4058,'Y','18','021','EC','A','','','AC','0000534995','0000534995','TX00000825402','31','1','Lipsey','Susannah','','','','34','643054155','PO Box 43',0,'Marfa','TX','79843',NULL,'CY','48377','1981-01-26','F','U',':RET:2106-3','N','021','DEN','2190505','33348TX002000201','2014-01-01','2013-12-18 18:39:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 23:01:57'),(7245,5745,'Y','18','021','EC','A','','','AC','0000440985','0000440985','LA00000541450','IL','1','TIPPY','DEBORAH','SUE','','','34','428988567','12120 RIVER HIGHLANDS DR',0,'SAINT AMANT','LA','70774','5004','CY','22005','1954-02-07','F','U',':RET:2106-3','N','021','DEN','628402','18575LA002000201','2014-01-01','2013-12-14 13:55:32','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:01:46'),(7009,5563,'Y','18','021','EC','A','','','AC','0000294840','0000294840','TX00000567033','IL','1','Gonzalez','Sarah','','','','34','631365546','5310 WILDERNESS DR',0,'BROWNSVILLE','TX','78526','3832','CY','48061','1990-02-03','F','U',NULL,'N','021','DEN','2076183','33348TX002000201','2014-01-01','2013-12-24 19:33:02','0.00',NULL,NULL,'14.61','14.61','R-TX005','TX0','14.61',NULL,0,'2013-12-26 01:48:28'),(1409,1171,'Y','18','021','EC','A','','','AC','0001876873','0001876873','LA00000191440','IL','1','Dawson-Erdman','Ryan','','','','34','610078256','7902 SYCAMORE ST',0,'NEW ORLEANS','LA','70118','4229','CY','22071','1987-09-07','M','U',':RET:2106-3','N','021','DEN','1457969','18575LA002000201','2014-01-01','2013-12-24 13:12:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:51'),(3973,3174,'Y','18','021','EC','A','','','AC','0001210901','0001210901','OH00000170103','IL','1','Crider','Jessica','','','','34','293923476','2780 S BANTAM RD',0,'BETHEL','OH','45106','9516','CY','39025','1987-12-04','F','U',NULL,'N','021','HLT','976125','92036OH004000601','2014-01-01','2013-12-13 13:20:49','166.00',NULL,NULL,'176.75','10.75','R-OH005','OH0','176.75',NULL,0,'2013-12-25 21:38:38'),(6892,5468,'Y','18','021','EC','A','','','AC','0001591649','0001591649','LA00000710227','IL','1','GARDNER','GINA','','','','34','439754142','6112 LANDMOR DR',0,'GREENWELL SPRINGS','LA','70739','4329','CY','22033','1987-09-10','F','U',':RET:2106-3','N','021','DEN','1987616','18575LA002000201','2014-01-01','2013-12-24 21:30:31','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:24'),(28029,22182,'Y','18','021','EC','A','','','AC','0000814348','0000814348','OH00002646280','31','1','JONES','MARILYN','','','','34','296564292','PO BOX 141001',0,'TOLEDO','OH','43614',NULL,'CY','39095','1956-03-31','F','U',':RET:2054-5^:RET:2106-3','N','021','DEN','3435886','99734OH005000401','2014-04-01','2014-03-06 16:50:50','0.00',NULL,NULL,'15.78','15.78','R-OH001','OH0','0.00',NULL,0,'2014-03-06 21:01:26'),(28737,22743,'N','19','021','EC','A',NULL,NULL,'','0000069140','0000913025','','IL','1','Rutschilling','Adam','','','','34','298943726','223 W. Walnut St.',0,'Coldwater','OH','45828',NULL,'CY','39107','1992-03-16','M','',':RET:2106-3','N','021','HLT','3616279','92036OH001001501','2014-04-01','2014-03-08 18:15:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.47',NULL,0,'2014-03-09 21:00:06'),(304,250,'Y','18','021','EC','A','','','AC','0000209588','0000209588','OH00000693193','IL','1','Brinkley','Brian','','','','34','300488245','1223 WAVERLY AVE',0,'TOLEDO','OH','43607','3741','CY','39095','1960-10-28','M','U',':RET:2054-5','N','021','DEN','518194','99734OH005000301','2014-01-01','2013-11-13 09:02:24','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2013-12-25 17:30:52'),(24889,19734,'Y','18','021','EC','A','','','AC','0001152250','0001152250','OH00002309934','IL','1','Irby','Melissa','','','','34','226660459','2237 SARATOGA DR',0,'FINDLAY','OH','45840','7400','CY','39063','1954-07-12','F','M',':RET:2106-3','N','021','HLT','3755831','92036OH003001505','2014-04-01','2014-02-19 10:59:04','655.00',NULL,NULL,'828.10','173.10','R-OH002','OH0','598.27','CIC',0,'2014-02-20 05:38:31'),(24325,19318,'N','19','021','EC','A',NULL,NULL,'','0001036844','0001123728','','IL','1','WINN','LOGAN','A','','','34','635247769','1701B SHADOWVIEW DR',0,'AUSTIN','TX','78758',NULL,'CY','48453','1991-07-18','M','',NULL,'T','021','DEN','3214529','33348TX002000201','2014-04-01','2014-02-18 12:42:32',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-18 22:00:10'),(22562,18019,'Y','18','021','EC','A','','','AC','0001219628','0001219628','OH00002255857','IL','1','POWERS','JEFFREY','','','','34','291648957','3691 WEAVER RD',0,'WILLIAMSBURG','OH','45176','9376','CY','39025','1963-05-12','M','M',NULL,'N','021','DEN','2970424','99734OH005000401','2014-03-01','2014-02-10 12:48:53','0.00',NULL,NULL,'31.57','31.57','R-OH005','OH0','0.00',NULL,0,'2014-02-10 21:31:51'),(20162,16090,'N','17','021','EC','A',NULL,NULL,'','0000600828','0000318440','','IL','1','CECIL','TARA','LIN','','','34','272963170','5554 MILLWOOD DR',0,'BROADVIEW HEIGHTS','OH','44147','2246','CY','39035','1992-12-12','F','',':RET:2106-3','N','021','DEN','3238156','99734OH005000301','2014-03-01','2014-01-27 15:39:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-27 21:01:10'),(4899,3886,'N','19','021','EC','A',NULL,NULL,'','0000743040','0000740224','','IL','1','Stennett','Alex','','','','34','277157777','17683 brim rd',0,'Bowling Green','OH','43402',NULL,'CY','39173','2009-03-30','M','',':RET:2106-3','N','021','DEN','947616','99734OH005000401','2014-01-01','2013-10-26 01:07:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:31:46'),(3923,3140,'N','01','021','EC','A',NULL,NULL,'','0000855614','0000519808','','IL','1','Bailey','Jennifer','Lynn','','','34','284623656','405 N. Wright St.',0,'Blanchester','OH','45107',NULL,'CY','39027','1965-05-03','F','',':RET:2106-3','T','021','HLT','950639','92036OH001000601','2014-01-01','2013-12-12 19:45:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','486.88',NULL,0,'2013-12-25 21:37:25'),(18974,15119,'Y','18','021','EC','A','','','AC','0000737887','0000737887','OH00001775539','IL','1','Thacker','Karen','','','','34','289505271','914 Hampton Ct',0,'Lebanon','OH','45036',NULL,'CY','39165','1951-01-14','F','M',':RET:2106-3','N','021','DEN','1627945','99734OH005000301','2014-03-01','2014-01-17 00:45:40','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-20 08:06:03'),(20472,16353,'Y','18','021','EC','A','','','AC','0000611983','0000611983','OH00002261636','IL','1','Heaton','Daniel','','','','34','309482582','153 SILVERWOOD CIR',0,'SPRINGDALE','OH','45246','2442','CY','39061','1958-04-08','M','M',':RET:2106-3','N','021','DEN','2742737','99734OH005000401','2014-03-01','2014-01-29 13:38:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-29 21:00:56'),(26300,20864,'Y','18','021','EC','A','','','AC','0000188906','0000188906','OH00003282407','IL','1','griesinger','charles','','','','34','279686455','1168 N RYMERS RD',0,'PORT CLINTON','OH','43452','9408','CY','39123','1971-07-26','M','U',':RET:2106-3','N','021','HLT','3271747','92036OH005002706','2014-04-01','2014-02-26 21:59:51','221.00',NULL,NULL,'258.38','37.38','R-OH006','OH0','258.38',NULL,0,'2014-02-28 06:31:28'),(26409,20944,'N','01','021','EC','A',NULL,NULL,'','0000897036','0000905643','','IL','1','Iqbal','Imran','','','','34','294887593','5108 OCALA DR',0,'MIDDLETOWN','OH','45044','7179','CY','39165','1982-02-12','M','',NULL,'N','021','HLT','3788814','92036OH005001205','2014-04-01','2014-02-26 13:57:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','253.96','CIC',0,'2014-02-28 07:00:37'),(28510,22561,'Y','18','021','EC','A','','','AC','0000308336','0000308336','OH00003594017','IL','1','Carli','Carolyn','Sue','','','34','271487071','1972 TONAWANDA AVE',0,'AKRON','OH','44305','3657','CY','39153','1951-09-29','F','U',':RET:2106-3','N','021','HLT','3236249','52664OH151001305','2014-04-01','2014-03-07 14:33:30','484.00',NULL,NULL,'640.70','156.70','R-OH012','OH0','640.70',NULL,0,'2014-03-07 21:31:54'),(5101,4042,'N','01','021','EC','A',NULL,NULL,'','0000336428','0000499577','','IL','1','DUDLEY','LESLEY','','','','34','175276941','15982 CR 4141',0,'Lindale','TX','75771',NULL,'CY','48423','1975-02-17','F','',':RET:2106-3','N','021','DEN','1459094','33348TX002000201','2014-01-01','2013-12-19 16:46:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:26'),(17382,13908,'Y','18','021','EC','A','','','AC','0000653212','0000653212','OH00002327884','IL','1','Jones','Amanda','','','','34','288909909','553 Aston View Ln',0,'Cleves','OH','45002',NULL,'CY','39061','1987-05-23','F','U',':RET:2106-3','N','021','DEN','1506468','99734OH005000401','2014-02-01','2014-01-10 11:03:53','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-13 03:00:07'),(25592,20303,'Y','18','024','14','A','','','TE','0001697898','0001697898','','IL','1','Faciane','Mary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-11-10','F','',NULL,NULL,NULL,'','3529529','','2014-02-24','2014-02-24 17:00:04',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCELCIC',0,'2014-02-26 08:00:44'),(25117,19925,'Y','18','021','EC','A','','','AC','0001025531','0001025531','OH00002998868','IL','1','Lantz','Robert','','','','34','090547898','6935 WOODY CT',0,'CANAL WINCHESTER','OH','43110','9645','CY','39049','1960-03-30','M','U',':RET:2106-3','N','021','DEN','3669645','99734OH005000301','2014-04-01','2014-02-20 20:09:44','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00','CIC',0,'2014-02-21 21:30:19'),(7506,5938,'Y','18','021','EC','A','','','AC','0000592961','0000592961','LA00000067804','IL','1','shoffner','james','','','','34','437858872','2408 OAK ALY',0,'NEW ORLEANS','LA','70119','5632','CY','22071','1992-11-12','M','U',':RET:2054-5','N','021','DEN','40006','18575LA002000201','2014-01-01','2013-12-14 19:49:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 02:31:59'),(21903,17491,'Y','18','021','EC','A','','','AC','0000053096','0000053096','OH00002616824','IL','1','Smith','Cassandra','','','','34','298681115','3561 TRUMAN RD',0,'PERRYSBURG','OH','43551','9554','CY','39173','1959-07-28','F','M',':RET:2106-3','T','021','HLT','3469355','92036OH006002601','2014-03-01','2014-02-06 12:20:03','46.00',NULL,NULL,'379.69','333.69','R-OH001','OH0','379.69',NULL,0,'2014-02-06 21:01:48'),(21113,16870,'Y','18','021','EC','A','','','AC','0000497145','0000497145','TX00001775806','IL','1','King','Joshua','','','','34','466993241','32946 CR 2142',0,'Kemp','TX','75143',NULL,'CY','48213','1982-12-22','M','M',':RET:2106-3','N','021','DEN','2825314','33348TX002000201','2014-03-01','2014-02-02 18:47:24','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-02-03 21:00:08'),(3987,3183,'Y','18','021','EC','A','','','AC','0000953227','0000953227','OH00000952418','IL','1','Skinner','Gregory','','','','34','287429445','1055 W ELM ST',0,'LIMA','OH','45805','3265','CY','39003','1949-05-29','M','M',':RET:2106-3','N','021','HLT','371773','92036OH004001501','2014-01-01','2013-12-13 14:05:17','315.00',NULL,NULL,'530.89','215.89','R-OH002','OH0','530.89',NULL,0,'2013-12-25 21:38:58'),(27624,21849,'Y','18','021','EC','A','','','AC','0000115553','0000115553','OH00003231031','IL','1','Harriger','Mary','','','','34','295566810','56 PINEWOOD',0,'BUCYRUS','OH','44820','3477','CY','39033','1957-04-30','F','U',':RET:2106-3','N','021','DEN','3727007','99734OH005000401','2014-04-01','2014-03-04 18:06:14','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2014-03-05 21:30:06'),(582,477,'Y','18','021','EC','A','','','AC','0000652094','0000652094','OH00000986835','IL','1','VROOMAN','JEFF','','','','34','107582744','Lucy St. 502',0,'Masury','OH','44438',NULL,'CY','39155','1968-02-20','M','U',':RET:2106-3','T','021','HLT','539715','92036OH005003206','2014-01-01','2013-12-04 16:14:59','269.00',NULL,NULL,'401.96','132.96','R-OH013','OH0','401.96',NULL,0,'2013-12-25 17:50:55'),(15120,12085,'N','19','021','EC','A',NULL,NULL,'','0001063253','0001071789','','S1','1','mcguire','david','','','','34','299029570','807 Green Acres Dr.',0,'Dayton','OH','45414',NULL,'CY','39113','1998-06-22','M','',NULL,'N','021','DEN','2611229','99734OH005000301','2014-02-01','2013-12-30 15:51:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-01 12:05:14'),(23742,18904,'Y','18','021','EC','A','','','AC','0001099226','0001099226','OH00002850614','IL','1','Grant','Juanita','','','','34','249042251','35 AUGUSTA LN',0,'TIFFIN','OH','44883','5505','CY','39147','1950-01-09','F','M',':RET:2054-5','N','021','DEN','3498395','99734OH005000301','2014-03-01','2014-02-14 00:29:38','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2014-02-14 21:31:04'),(14681,11721,'Y','18','021','EC','A','','','AC','0000605757','0000605757','MS00000101402','IL','1','Mclaughlin','Billy','Ray','','','34','587903375','165 COUNTY ROAD 158',0,'QUITMAN','MS','39355','7749','CY','28023','1952-08-12','M','M',':RET:2054-5','T','021','DEN','2024929','46300MS002000201','2014-02-01','2013-12-28 00:28:29','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,1,'2013-12-29 11:08:33'),(21494,17174,'Y','18','021','EC','A','','','AC','0000639560','0000639560','OH00002499526','IL','1','ON','HELEN','','','','34','281111735','7752 MONTGOMERY ROAD',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1977-08-25','F','M',NULL,'N','021','HLT','3733016','92036OH003001204','2014-03-01','2014-02-04 11:15:32','363.00',NULL,NULL,'846.98','483.98','R-OH004','OH0','275.75',NULL,0,'2014-02-04 21:01:49'),(819,678,'Y','18','021','EC','A','','','AC','0000695621','0000695621','OH00001199200','IL','1','Warren','Tricia','','','','34','284881072','4750 Tahiti Dr',0,'Akron','OH','44319',NULL,'CY','39153','1974-03-07','F','U',':RET:2106-3','N','021','HLT','2294465','52664OH151001305','2014-01-01','2013-12-16 13:21:50','176.00',NULL,NULL,'281.44','105.44','R-OH012','OH0','281.44',NULL,0,'2013-12-25 18:06:02'),(4809,3812,'Y','18','021','EC','A','','','AC','0000274761','0000274761','OH00000289849','IL','1','Lowther','Kenneth','','','','34','298489951','570 MURRAY HILL DR',0,'YOUNGSTOWN','OH','44505','1564','CY','39155','1952-07-31','M','M',':RET:2106-3','N','021','DEN','77811','99734OH005000301','2014-01-01','2013-12-08 11:29:37','0.00',NULL,NULL,'42.26','42.26','R-OH013','OH0','0.00',NULL,0,'2013-12-25 22:16:45'),(18685,14896,'Y','18','021','EC','A','','','AC','0001326501','0001326501','LA00002223499','IL','1','WATSON','PETER','','','','34','464759433','1160 JANTHER PL',0,'SHREVEPORT','LA','71104','4126','CY','22017','1973-05-07','M','U',NULL,'N','021','DEN','2788335','18575LA002000101','2014-02-01','2014-01-15 18:31:02','0.00',NULL,NULL,'25.02','25.02','R-LA008','LA0','25.02',NULL,0,'2014-01-17 03:35:22'),(1932,1574,'Y','18','021','EC','A','','','AC','0001155919','0001155919','TX00000231227','IL','1','crosby','betty','','','','34','454026892','49 TRINITY ST',0,'BAY CITY','TX','77414','2141','CY','48321','1954-08-12','F','M',':RET:2106-3','N','021','DEN','662131','33348TX002000201','2014-01-01','2013-11-19 23:31:17','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2013-12-25 19:00:25'),(16720,13381,'Y','18','021','EC','A','','','AC','0001142442','0001142442','TX00002338340','IL','1','PENA','MARIO','','','','34','455132610','202 SAN DIEGO',0,'RIO GRANDE','TX','78582',NULL,'CY','48427','1961-07-01','M','M',NULL,'T','021','DEN','1780687','33348TX002000201','2014-02-01','2014-01-07 17:14:09','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-08 18:24:46'),(7879,6233,'Y','18','021','EC','A','','','AC','0000545235','0000545235','OH00000312571','IL','1','Petzold','Kathryn','','','','34','073440198','4466 US HIGHWAY 62',0,'HILLSBORO','OH','45133','9525','CY','39071','1950-01-08','F','M',':RET:2106-3','N','021','DEN','2501982','99734OH005000301','2014-01-01','2013-12-20 17:29:29','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2013-12-26 03:05:23'),(27171,21513,'Y','18','021','EC','A','','','AC','0000819360','0000819360','TX00003092622','IL','1','Nguyen','Long','','','','34','629927040','1751 YORK CREEK DR',0,'HOUSTON','TX','77014','2086','CY','48201','1988-05-31','M','M',':RET:2047-9','N','021','DEN','3255069','33348TX002000201','2014-04-01','2014-03-03 11:32:35','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-03-03 21:31:05'),(275,227,'Y','18','021','EC','A','','','AC','0000242175','0000242175','TX00000020604','IL','1','Hoot','Alton','','','','34','464929029','P.O. Box 1821',0,'Johnson City','TX','78636',NULL,'CY','48031','1952-08-20','M','U',NULL,'N','021','DEN','970367','33348TX002000201','2014-01-01','2013-10-12 08:28:08','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 17:30:08'),(24310,19306,'N','19','021','EC','A',NULL,NULL,'','0001885767','0001866016','','S1','1','STEWART','CRAIG','','','Sr',NULL,NULL,'216 EVELYN AVE',0,'HOUMA','LA','70363',NULL,'CY','22109','1996-08-14','F','',':RET:2054-5','N','021','DEN','3121202','18575LA002000101','2014-03-01','2014-02-18 17:30:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','44.55','CIC',0,'2014-02-18 21:30:24'),(22175,17698,'Y','18','021','EC','A','','','AC','0000586666','0000586666','OH00001934046','31','1','Schimmel','Edward','','','','34','289601125','2239 RICHMAND DR',0,'NORTHWOOD','OH','43619','1124','CY','39173','1977-05-14','M','M',':RET:2106-3','N','021','DEN','3246499','99734OH005000301','2014-03-01','2014-02-08 00:24:42','0.00',NULL,NULL,'42.26','42.26','R-OH001','OH0','0.00','CIC',0,'2014-02-08 19:30:07'),(7066,5611,'N','19','021','EC','A',NULL,NULL,'','0000816435','0000364893','','IL','1','Yang','Jake','','','','34','288020289','5 AMBER WAY',0,'NORWALK','OH','44857','9051','CY','39077','1997-10-22','M','',':RET:2034-7','N','021','DEN','2566021','99734OH005000301','2014-01-01','2013-12-24 22:07:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:02'),(5953,4714,'Y','18','021','EC','A','','','AC','0001037570','0001037570','MS00001425951','IL','1','Bryant','Kathy','','','','34','426618946','120 AMETHYST LN',0,'BRANDON','MS','39047','6375','CY','28121','1986-02-25','F','U',':RET:2054-5','N','021','DEN','1989890','46300MS002000201','2014-01-01','2013-12-23 23:29:35','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 23:51:08'),(5095,4039,'Y','18','021','EC','A','','','AC','0001155997','0001155997','TX00000722538','IL','1','SOLIAS','ENEDELIA','','','','34','384508205','2309 BRIARWOOD DR',0,'MISSION','TX','78574','2307','CY','48215','1950-08-23','F','M',NULL,'N','021','DEN','1574316','33348TX002000201','2014-01-01','2013-12-19 15:34:50','0.00',NULL,NULL,'29.22','29.22','R-TX015','TX0','14.61',NULL,0,'2013-12-25 23:01:19'),(15067,12044,'N','01','021','EC','A',NULL,NULL,'','0001298631','0002157184','','IL','1','smith','Richard','','','','34','438398054','603 highway 486',0,'campti','LA','71411',NULL,'CY','22069','1964-04-23','M','',':RET:2106-3','N','021','DEN','1420274','18575LA002000201','2014-02-01','2013-12-30 17:32:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-01 12:03:46'),(1952,1591,'N','01','021','EC','A',NULL,NULL,'','0001095224','0000865312','','IL','1','Rich','Yvonne','Sanchez','','','34','459474012','26427 WALDEN OAK',0,'SAN ANTONIO','TX','78260','6006','CY','48029','1978-09-29','F','',NULL,'N','021','DEN','1013885','33348TX002000101','2014-01-01','2013-11-19 22:42:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2013-12-25 19:01:00'),(21401,17103,'Y','18','021','EC','A','','','AC','0000309482','0000309482','OH00002585664','IL','1','reiss','joan','','','','34','268563080','126 S VANDEMARK RD',0,'SIDNEY','OH','45365','2436','CY','39149','1953-11-08','F','U',':RET:2106-3','N','021','DEN','3605652','99734OH005000401','2014-03-01','2014-02-04 13:07:36','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-04 21:01:02'),(28509,22560,'Y','18','021','EC','A','','','AC','0000622558','0000622558','OH00002745604','IL','1','BOOTH','DANIEL','L','','','34','281726358','1492 KOONS RD',0,'NORTH CANTON','OH','44720','1316','CY','39153','1975-05-09','M','M',':RET:2106-3','N','021','HLT','3388316','52664OH151001306','2014-05-01','2014-03-07 14:05:41','210.00',NULL,NULL,'277.87','67.87','R-OH012','OH0','277.87',NULL,0,'2014-03-07 21:31:53'),(8117,6420,'N','01','021','EC','A',NULL,NULL,'','0000713601','0001124034','','IL','1','FISHER','SHARON','E','','','34','277522045','26 S CLAY ST',0,'BROOKVILLE','OH','45309','1409','CY','39113','1951-03-24','F','',':RET:2106-3','N','021','DEN','380629','99734OH005000401','2014-01-01','2013-11-21 18:57:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 03:15:11'),(25970,20595,'N','01','021','EC','A',NULL,NULL,'','0001146029','0001182551','','IL','1','Grilli','Bernard','','','','34','200503004','4102 LOCKWOOD BLVD',0,'YOUNGSTOWN','OH','44511',NULL,'CY','39099','1957-12-07','M','',':RET:2106-3','T','021','DEN','3784217','99734OH005000401','2014-04-01','2014-02-26 13:31:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 21:01:46'),(1570,1311,'Y','18','021','EC','A','','','AC','0001163127','0001163127','TX00000879917','IL','1','Tran','HongAnh','','','','34','627485823','6619 VICTORIA AVE',0,'DALLAS','TX','75209','4522','CY','48113','1971-07-05','F','M',':RET:2047-9','N','021','DEN','1753764','33348TX002000201','2014-01-01','2013-12-24 09:09:24','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2013-12-25 18:51:10'),(26698,21165,'Y','18','021','EC','A','','','AC','0002277370','0002277370','LA00003355592','IL','1','Jackson','Deborah','','','','34','437065864','35274 RAYVILLE RD',0,'DONALDSONVILLE','LA','70346','9206','CY','22005','1961-02-24','F','U',NULL,'N','021','DEN','3762146','18575LA002000101','2014-04-01','2014-02-28 16:46:16','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-02-28 21:31:32'),(28520,22570,'Y','18','021','EC','A','','','AC','0001149923','0001149923','OH00003548780','IL','1','MARTINEZ','MARSENA','','','','34','460040427','420 WATER ST',0,'TIFFIN','OH','44883','1649','CY','39147','1969-09-18','F','M',NULL,'T','021','HLT','3497772','92036OH001002701','2014-04-01','2014-03-06 21:02:20','0.00',NULL,NULL,'377.88','377.88','R-OH006','OH0','377.88',NULL,0,'2014-03-07 21:32:00'),(63,56,'Y','18','024','14','A','','','TE','0000589280','0000589280','','IL','1','Neff','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1969-03-16','F','',NULL,NULL,NULL,'','989941','','2013-12-05','2013-12-05 10:04:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 17:16:42'),(25717,20398,'N','01','021','EC','A',NULL,NULL,'','0001044303','0000381747','','IL','1','Dingman','Tommy','','','','34','450237165','8324 N US HIGHWAY 281',0,'STEPHENVILLE','TX','76401','8905','CY','48143','1957-11-27','M','',':RET:2106-3','N','021','DEN','3058894','33348TX002000201','2014-04-01','2014-02-24 16:37:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-26 09:30:25'),(1287,1064,'Y','18','021','EC','A','','','AC','0001111631','0001111631','OH00000561358','IL','1','Corbet','Patricia',NULL,NULL,NULL,NULL,NULL,'1342 Sparhawk Ave',0,'Akron','OH','44305',NULL,'CY','39153','1950-12-15','F','U',':RET:2106-3','N','021','HLT','578756','52664OH151001306','2014-01-01','2013-11-29 13:18:23','578.00',NULL,NULL,'658.32','80.32','R-OH012','OH0','658.32',NULL,0,'2013-12-25 18:30:45'),(2640,2144,'N','01','021','EC','A',NULL,NULL,'','0000993939','0000261461','','IL','1','Faulkner','David','Ralph','','','34','295644751','484 DREXEL AVE',0,'LEBANON','OH','45036','1616','CY','39165','1959-01-05','M','',':RET:2106-3','T','021','DEN','39663','99734OH005000401','2014-01-01','2013-12-02 16:14:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 19:46:19'),(595,490,'Y','18','021','EC','A','','','AC','0001204510','0001204510','OH00000099580','IL','1','Momper','Daniel','','','','34','275562624','1236 Arapaho Lane',0,'Cincinnati','OH','45244',NULL,'CY','39025','1954-04-03','M','U',':RET:2106-3','N','021','DEN','277014','99734OH005000401','2014-01-01','2013-12-15 19:51:28','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-25 18:00:10'),(5888,4669,'N','19','021','EC','A',NULL,NULL,'','0000125559','0000951800','','IL','1','Walker','Collin','Thomas','','','34','276062882','6803 BREMEN RD SE',0,'LANCASTER','OH','43130','9417','CY','39045','2001-02-05','M','',':RET:2106-3','N','021','DEN','2554208','99734OH005000301','2014-01-01','2013-12-23 22:43:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:34'),(19610,15629,'Y','18','021','EC','A','','','AC','0000211037','0000211037','OH00002330619','IL','1','lisle','helena','','','','34','288580586','618 fruit dr',0,'akron','OH','44319',NULL,'CY','39153','1956-12-31','F','U',':RET:2106-3','T','021','HLT','2872403','52664OH152000901','2014-03-01','2014-01-22 17:12:00','457.77',NULL,NULL,'457.77','0.00','R-OH012','OH0','457.77',NULL,0,'2014-01-23 03:02:50'),(19467,15516,'N','01','021','EC','A',NULL,NULL,'','0000807316','0000723002','','IL','1','Ray','James','','','','34','462907255','5180 County Road 4833',0,'Larue','TX','75770',NULL,'CY','48213','1950-12-19','M','',NULL,'N','021','DEN','1461376','33348TX002000201','2014-03-01','2014-01-22 10:56:36',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-23 03:01:58'),(13081,10428,'Y','18','021','EC','A','','','AC','0000187469','0000187469','OH00001215772','IL','1','Klemencic','Deborah','','','','34','289727552','14644 STILLWELL RD',0,'CHARDON','OH','44024','9597','CY','39055','1967-04-27','F','R',':RET:2106-3','N','021','DEN','1716303','99734OH005000401','2014-01-01','2013-12-23 10:43:13','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:51:34'),(3718,2972,'N','19','021','EC','A',NULL,NULL,'','0001165319','0000726112','','IL','1','Anaya','Adlynn','Kennedy','','','34','279960857','6215 CORTELYOU AVE',0,'CINCINNATI','OH','45213','1307','CY','39061','1993-04-19','F','',':RET:2106-3','N','021','DEN','210262','99734OH005000401','2014-01-01','2013-12-13 14:59:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:32:19'),(5794,4602,'Y','18','021','EC','A','','','AC','0000209634','0000209634','OH00000066823','IL','1','Lange','Nancy','','','','34','283486985','2715 Silver Springs Dr',0,'Norton','OH','44203',NULL,'CY','39153','1950-02-02','F','U',':RET:2106-3','N','021','DEN','2379858','99734OH005000401','2014-01-01','2013-12-24 01:42:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 23:47:20'),(14071,11213,'Y','18','021','EC','A','','','AC','0000198569','0000198569','OH00001702283','IL','1','Stankovic','Mirna','','','','34','276027995','34 Rathbone',0,'Columbus','OH','43214',NULL,'CY','39049','1978-07-24','F','U',':RET:2106-3','N','021','DEN','2510477','99734OH005000401','2014-02-01','2013-12-26 09:42:47','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-27 02:00:52'),(7230,5731,'Y','18','021','EC','A','','','AC','0000920790','0000920790','OH00001161084','IL','1','Bartlett','Joyce','','','','34','401806995','4243 Tower Ave.',0,'Cincinnati','OH','45217',NULL,'CY','39061','1950-05-10','F','U',':RET:2106-3','N','021','DEN','613750','99734OH005000401','2014-01-01','2013-12-14 16:10:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 02:01:20'),(7032,5584,'Y','18','021','EC','A','','','AC','0001018822','0001018822','TX00001280865','IL','1','Drennon','Christopher','','','','34','450699592','8700 CORRAL CIR',0,'FORT WORTH','TX','76244','8026','CY','48439','1982-09-22','M','M',':RET:2106-3','N','021','DEN','2012244','33348TX002000201','2014-01-01','2013-12-24 23:27:00','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-26 01:49:08'),(28728,22736,'Y','18','024','14','A','','','TE','0001170986','0001170986','','IL','1','Tademy','Rose',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-01-30','F','',NULL,NULL,NULL,'','2114702','','2014-03-31','2014-03-09 12:11:19',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-09 21:00:01'),(2399,1959,'Y','18','021','EC','A','','','AC','0000459126','0000459126','OH00000561546','IL','1','Searfos','Bryan','Dean','','','34','284620267','758 silverleaf oak ct',0,'westerville','OH','43081',NULL,'CY','39049','1958-09-24','M','M',':RET:2106-3','N','021','DEN','1233701','99734OH005000401','2014-01-01','2013-12-09 13:44:23','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 19:33:30'),(25002,19829,'Y','18','021','EC','A','','','AC','0001071837','0001071837','OH00002550739','IL','1','ESCRIBANO','GIOVANNY','FRANCISCO','','','34','597204898','69 N MONTGOMERY AVE',0,'YOUNGSTOWN','OH','44506','1834','CY','39099','1974-01-28','M','M',NULL,'N','021','HLT','3111785','52664OH151001304','2014-04-01','2014-02-20 14:08:12','330.00',NULL,NULL,'616.31','286.31','R-OH013','OH0','323.20',NULL,0,'2014-02-20 22:00:47'),(24908,19748,'Y','18','021','EC','A','','','AC','0000929819','0000929819','OH00002231716','IL','1','Kaiser','Bettyann','Virginia','','','34','275660036','3775 THORNTON DR',0,'CINCINNATI','OH','45236','3350','CY','39061','1957-11-26','F','U',':RET:2106-3','N','021','HLT','3134687','92036OH002001201','2014-04-01','2014-02-19 19:15:27','116.00',NULL,NULL,'578.36','462.36','R-OH004','OH0','578.36','CIC',0,'2014-02-20 21:30:06'),(16014,12818,'Y','18','021','EC','A','','','AC','0002238063','0002238063','LA00000615954','IL','1','Garner','James','','','','34','434702284','8820 CHADWICK DR',0,'SHREVEPORT','LA','71129','5119','CY','22017','1950-05-23','M','M',':RET:1002-5','N','021','DEN','2292491','18575LA002000201','2014-02-01','2014-01-02 20:59:10','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2014-01-04 02:01:56'),(22454,17927,'Y','18','021','EC','A','','','AC','0001115782','0001115782','TX00001947138','IL','1','trigo','rosa','','','','34','461132853','663 PRIVATE ROAD 1131',0,'NIXON','TX','78140','5249','CY','48177','1957-08-11','F','U',':RET:2106-3','N','021','DEN','2634814','33348TX002000201','2014-03-01','2014-02-10 14:53:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-10 21:30:48'),(16833,13464,'Y','18','024','14','A','','','TE','0000399903','0000399903','','IL','1','Warren','Jean',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1955-02-02','F','',NULL,NULL,NULL,'','1655538','','2014-01-11','2014-01-11 13:44:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-13 02:18:29'),(29019,22968,'Y','18','024','14','A','','','TE','0001076595','0001076595','','IL','1','Morrison','Darren',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1988-01-23','M','',NULL,NULL,NULL,'','3050876','','2014-03-31','2014-03-10 09:12:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-03-10 21:01:29'),(7770,6151,'N','01','021','EC','A',NULL,NULL,'','0000888520','0000142033','','IL','1','Ochoa','Dina','','','','34','459431947','2108 DOMINGO TREVINO DR',0,'MISSION','TX','78572','1435','CY','48215','1965-07-23','F','',NULL,'N','021','DEN','2600028','33348TX002000201','2014-01-01','2013-12-19 18:52:39',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 03:02:53'),(9225,7320,'Y','18','021','EC','A','','','AC','0000178876','0000178876','OH00001057556','IL','1','Vajen','Sheila','','','','34','279589822','16774 COUNTY ROAD V',0,'NAPOLEON','OH','43545','9750','CY','39069','1955-10-11','F','M',NULL,'N','021','HLT','2125547','92036OH005002606','2014-01-01','2013-12-18 14:06:23','489.00',NULL,NULL,'496.84','7.84','R-OH001','OH0','496.84',NULL,0,'2013-12-26 04:10:19'),(26005,20624,'N','01','021','EC','A',NULL,NULL,'','0001235098','0001642193','','IL','1','Watkins','Jiovonta','','','','34','587390616','5445 PROVINE PL',0,'ALEXANDRIA','LA','71303','5801','CY','22079','1981-07-31','M','',':RET:2054-5','N','021','DEN','3854689','18575LA002000101','2014-04-01','2014-02-26 14:05:43',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-02-26 21:02:06'),(8870,7033,'Y','18','021','EC','A','','','AC','0000639854','0000639854','TX00000704665','IL','1','Mueller','Jimmy','','','','34','462117474','1312 E PARK AVE',0,'VICTORIA','TX','77901','5513','CY','48469','1955-10-14','M','U',NULL,'N','021','DEN','2378351','33348TX002000201','2014-01-01','2013-12-18 13:32:24','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2013-12-26 04:01:33'),(15221,12167,'Y','18','021','EC','A','','','AC','0001751419','0001751419','LA00001962249','IL','1','Clark','Jonathan','','','','34','435458422','4207 HIDDEN PASS AVE',0,'ZACHARY','LA','70791','2783','CY','22033','1981-09-21','M','U',':RET:2054-5','N','021','DEN','2327246','18575LA002000101','2014-02-01','2013-12-30 13:45:25','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-01 12:08:01'),(15454,12366,'Y','18','021','EC','A','','','AC','0000871547','0000871547','TX00000506529','IL','1','Ulanowski','Aarin','M','','','34','631585179','7304 BRIARWYCK CT',0,'FORT WORTH','TX','76137','1700','CY','48439','1985-01-14','F','M',':RET:2106-3','N','021','DEN','2223147','33348TX002000201','2014-02-01','2013-12-31 16:06:26','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:28:28'),(19068,15190,'Y','18','021','EC','A','','','AC','0000938539','0000938539','OH00001890282','IL','1','Vasquez','Blanca','','','','34','287809469','1543 CRESTWOOD RD',0,'TOLEDO','OH','43612','2770','CY','39095','1983-08-05','F','U',NULL,'N','021','HLT','2664130','92036OH004002601','2014-03-01','2014-01-17 19:08:15','0.00',NULL,NULL,'177.96','177.96','R-OH001','OH0','177.96',NULL,0,'2014-01-21 08:44:18'),(13673,10910,'Y','18','021','EC','A','','','AC','0000541639','0000541639','OH00000201808','IL','1','Bull','James','','','','34','285706242','268 Lakefront Dr',0,'Akron','OH','44319',NULL,'CY','39153','1963-08-26','M','M',':RET:2106-3','N','021','HLT','2098673','52664OH151001306','2014-01-01','2013-12-22 19:46:29','639.00',NULL,NULL,'746.85','107.85','R-OH012','OH0','398.29',NULL,0,'2013-12-26 13:07:59'),(17624,14090,'Y','18','021','EC','A','','','AC','0000218462','0000218462','TX00002539763','IL','1','Schuur Sousa','Alexandra','','','','34','027744245','502 Southwest Parkway',0,'College Station','TX','77840',NULL,'CY','48041','1991-04-11','F','U',':RET:2106-3','N','021','DEN','1697716','33348TX002000201','2014-02-01','2014-01-13 15:01:28','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,0,'2014-01-14 01:32:29'),(19123,15237,'Y','18','021','EC','A','','','AC','0001003331','0001003331','OH00002479130','IL','1','Wang','Chuanhong','','','','34','298960872','27568 REMINGTON CIR',0,'WESTLAKE','OH','44145','2139','CY','39035','1963-06-16','M','U',':RET:2034-7','N','021','DEN','2876390','99734OH005000401','2014-03-01','2014-01-19 16:16:30','0.00',NULL,NULL,'50.05','50.05','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:45:18'),(23087,18405,'N','19','021','EC','A',NULL,NULL,'','0000632726','0000057375','','IL','1','Stahl','Jenna','','','','34','284131189','3151 Hwy 123',0,'Blanchester','OH','45107',NULL,'CY','39015','2007-07-22','F','',NULL,'N','021','DEN','2821595','99734OH005000401','2014-03-01','2014-02-12 11:27:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-12 21:31:05'),(22738,18153,'N','01','021','EC','A',NULL,NULL,'','0001662974','0001254660','','IL','1','US CAM','RUBEN','ALFREDO','','','34','660124120','903 TERRY ST',0,'DERIDDER','LA','70634','3324','CY','22011','1975-07-18','M','',NULL,'N','021','DEN','2705773','18575LA002000201','2014-03-01','2014-02-11 16:00:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-11 21:01:18'),(27849,22027,'N','01','021','EC','A',NULL,NULL,'','0000968642','0000081224','','IL','1','Waldoch','Kent','','','','34','529860845','1008 TRINITY CUT OFF',0,'HUNTSVILLE','TX','77320','8987','CY','48471','1954-06-03','M','',NULL,'N','021','DEN','3259003','33348TX002000101','2014-04-01','2014-03-05 14:24:16',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-05 21:32:12'),(13575,10827,'Y','18','021','EC','A','','','AC','0001326483','0001326483','LA00001295264','IL','1','McGee','Larry','','','','34','434909404','1212 LAKE LOUISE DR',0,'GRETNA','LA','70056','8341','CY','22051','1953-02-25','M','M',':RET:2054-5','N','021','DEN','1674133','18575LA002000201','2014-01-01','2013-12-23 17:37:41','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:46'),(23480,18702,'Y','18','021','EC','A','','','AC','0001677505','0001677505','LA00001811694','IL','1','Duplantis','Rebecca','','','','34','433728367','200 Lodge Drive',0,'Lafayette','LA','70506',NULL,'CY','22055','1954-12-13','F','U',':RET:2106-3','N','021','DEN','3416656','18575LA002000101','2014-03-01','2014-02-12 19:36:33','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2014-02-13 22:01:54'),(26358,20909,'N','19','021','EC','A',NULL,NULL,'','0000060320','0000084105','','IL','1','Wilder','Emma','Riley','','','34','277170208','582 MAGNOLIA DR',0,'PAINESVILLE','OH','44077','2624','CY','39085','2011-05-08','F','',':RET:2106-3','N','021','DEN','3087814','99734OH005000301','2014-03-01','2014-02-26 09:50:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-28 07:00:04'),(1800,1478,'N','01','021','EC','A',NULL,NULL,'','0000199663','0000177636','','IL','1','Unger','Pamela','Sue','','','34','271608059','2730 RED FOX',0,'DUNCAN FALLS','OH','43734','9740','CY','39119','1955-03-24','F','',':RET:2106-3','N','021','DEN','2034345','99734OH005000301','2014-01-01','2013-12-24 18:11:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:56:44'),(13746,10972,'N','01','021','EC','A',NULL,NULL,'','0000951798','0000078766','','IL','1','Farmer','Erin','','','','34','159681237','822 TEAKWOOD CT',0,'LEBANON','OH','45036','8650','CY','39165','1985-12-08','F','',':RET:2106-3','N','021','HLT','2344128','92036OH003001205','2014-01-01','2013-12-23 16:11:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','243.69',NULL,0,'2013-12-26 13:09:50'),(4801,3805,'Y','18','021','EC','A','','','AC','0000192616','0000192616','LA00000889463','IL','1','Lee','Mark',NULL,NULL,NULL,NULL,NULL,'221 East Grant St',0,'Baton Rouge','LA','70802',NULL,'CY','22033','1967-09-21','M','U',':RET:2054-5','N','021','DEN','529970','18575LA002000201','2014-01-01','2013-12-08 09:09:21','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 22:16:30'),(13074,10422,'Y','18','021','EC','A','','','AC','0001144767','0001144767','OH00000719272','IL','1','FENNELL','LINDA','','','','34','283505148','5400 GRACE RUN RD',0,'SEAMAN','OH','45679','9001','CY','39001','1951-11-20','F','U',':RET:2106-3','N','021','DEN','1444343','99734OH005000401','2014-01-01','2013-12-23 10:27:48','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2013-12-26 12:51:23'),(17429,13945,'N','19','021','EC','A',NULL,NULL,'','0000817556','0000315953','','IL','1','Digonno','Katealin','D','','','34','292925887','2531 REGINA PL',0,'HAMILTON','OH','45013','4812','CY','39017','1990-03-31','F','',':RET:2106-3','N','021','HLT','2087727','92036OH003001205','2014-02-01','2014-01-10 12:11:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','224.18',NULL,0,'2014-01-13 03:00:30'),(20434,16321,'Y','18','021','EC','A','','','AC','0000598786','0000598786','OH00002325967','31','1','SILWANI','SARI','','','','34','285826933','P.O. Box 20486',0,'Columbus','OH','43220',NULL,'CY','39049','1963-08-31','M','U',':RET:2106-3','N','021','DEN','3415277','99734OH005000301','2014-03-01','2014-01-29 16:37:24','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-29 21:00:36'),(28379,22454,'Y','18','021','EC','A','','','AC','0000983910','0000983910','OH00003756819','IL','1','Jones','John','R','','','34','293521203','1158 HARTFORD AVE',0,'AKRON','OH','44320','3553','CY','39153','1951-11-22','M','U',':RET:2106-3','T','021','HLT','2842040','52664OH152000901','2014-04-01','2014-03-06 18:27:07','420.00',NULL,NULL,'539.67','119.67','R-OH012','OH0','539.67',NULL,0,'2014-03-07 21:30:38'),(732,607,'Y','18','021','EC','A','','','AC','0000162650','0000162650','TX00000745959','IL','1','white','mary','','','','34','453252175','3929 HEATHERGLEN ST',0,'BAY CITY','TX','77414','6925','CY','48321','1958-06-08','F','M',':RET:2106-3','N','021','DEN','1175733','33348TX002000201','2014-01-01','2013-12-15 19:10:34','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 18:03:50'),(5962,4721,'N','19','021','EC','A',NULL,NULL,'','0000599756','0001245595','','IL','1','Painter','Harrison','R',NULL,NULL,NULL,NULL,'4333 Aaron Ct',0,'Cincinnati','OH','45241',NULL,'CY','39017','2000-06-18','M','',':RET:2106-3','N','021','HLT','1566099','92036OH005001201','2014-01-01','2013-12-23 22:11:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-25 23:51:24'),(2653,2156,'Y','18','021','EC','A','','','AC','0000119025','0000119025','OH00001310656','IL','1','Perkins','Curtis','','','','34','296487431','4295 Brookside Blvd',0,'Cleveland','OH','44135',NULL,'CY','39035','1950-07-06','M','U',NULL,'N','021','DEN','834276','99734OH005000301','2014-01-01','2013-12-01 18:39:46','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:46:40'),(22613,18058,'Y','18','021','EC','A','','','AC','0001244444','0001244444','TX00002700633','IL','1','BARREE','LADALE','','','','34','460964210','1004 PINEDALE LN',0,'DALLAS','TX','75241','1941','CY','48113','1950-10-21','F','U',':RET:2054-5','N','021','DEN','3110091','33348TX002000201','2014-03-01','2014-02-10 18:46:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-11 21:00:06'),(17730,14167,'Y','18','021','EC','A','','','AC','0000919417','0000919417','OH00001996200','IL','1','sands','ellen','','','','34','273448558','1858 INDIAN HILLS TRL',0,'AKRON','OH','44313','4790','CY','39153','1953-03-27','F','U',':RET:2106-3','N','021','HLT','2590537','52664OH151001305','2014-02-01','2014-01-13 09:49:30','439.00',NULL,NULL,'605.24','166.24','R-OH012','OH0','605.24',NULL,0,'2014-01-14 01:33:19'),(5392,4279,'Y','18','021','EC','A','','','AC','0002114750','0002114750','LA00000174757','IL','1','Truax','Ana','Maria','','','34','434979398','5304 PORT HUDSON DR',0,'BATON ROUGE','LA','70817','2527','CY','22033','1960-05-22','F','U',NULL,'N','021','DEN','1797970','18575LA002000201','2014-01-01','2013-12-19 16:46:30','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 23:08:42'),(15329,12261,'Y','18','021','EC','A','','','AC','0001025717','0001025717','TX00002143148','IL','1','CAGLIA','ANTHONY','','','','34','074442875','1431 CIBOLO DR',0,'ALLEN','TX','75013','4659','CY','48085','1951-03-08','M','U',':RET:2106-3','N','021','DEN','2234816','33348TX002000201','2014-02-01','2014-01-01 14:09:09','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,1,'2014-01-02 04:23:51'),(420,344,'N','01','021','EC','A',NULL,NULL,'','0000279518','0001102059','','IL','1','Fisher','Jessie','','','','34','295549995','1380 OLD 122 RD',0,'LEBANON','OH','45036','9496','CY','39165','1964-10-16','F','',':RET:2106-3','N','021','DEN','614518','99734OH005000401','2014-01-01','2013-12-03 23:43:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:46:37'),(9162,7267,'Y','18','021','EC','A','','','AC','0000114179','0000114179','OH00000341946','IL','1','Brewer','Nancy','Ann','','','34','299567614','10220 GREENVILLE SAINT MARYS RD',0,'VERSAILLES','OH','45380','9538','CY','39037','1954-10-30','F','M',':RET:2106-3','N','021','HLT','1628102','92036OH003000501','2014-01-01','2013-12-18 07:49:43','0.00',NULL,NULL,'646.18','646.18','R-OH003','OH0','646.18',NULL,0,'2013-12-26 04:08:43'),(18023,14398,'Y','18','021','EC','A','','','AC','0000848376','0000848376','OH00001955477','IL','1','schiavi','candice','','','','34','270686790','2646 shirley rd',0,'youngstown','OH','44502',NULL,'CY','39099','1972-07-13','F','U',NULL,'N','021','DEN','2371460','99734OH005000301','2014-02-01','2014-01-14 13:17:21','0.00',NULL,NULL,'21.13','21.13','R-OH013','OH0','0.00',NULL,0,'2014-01-15 02:07:06'),(20365,16266,'Y','18','021','EC','A','','','AC','0000265271','0000265271','OH00002026463','IL','1','Donohoe','Stephen','J','','','34','269503020','1330 W RICHEY RD',0,'PORT CLINTON','OH','43452','9451','CY','39123','1952-12-20','M','U',':RET:2106-3','N','021','HLT','2753140','92036OH004002701','2014-03-01','2014-01-28 18:12:16','437.38',NULL,NULL,'440.60','3.22','R-OH006','OH0','440.60',NULL,0,'2014-01-28 21:01:23'),(935,773,'Y','18','024','14','A','','','TE','0000115452','0000115452','','IL','1','Rini','Jennifer','Ann',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-18','F','',NULL,NULL,NULL,'','UNAVAILABLE','','2014-12-31','2013-10-31 11:26:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:09:10'),(16307,13056,'Y','18','021','EC','A','','','AC','0001963564','0001963564','LA00002135658','IL','1','Fury','Nicole','','','','34','437719112','4520 Senac Dr',0,'Metairie','LA','70003',NULL,'CY','22051','1988-01-21','F','U',':RET:2106-3','N','021','DEN','2174869','18575LA002000201','2014-02-01','2014-01-06 06:54:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-01-07 04:01:18'),(3894,3117,'Y','18','024','14','A','','','TE','0000278304','0000278304','','IL','1','Piesciuk','Stephen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-18','M','',NULL,NULL,NULL,'','605789','','2013-12-13','2013-12-13 14:24:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:36:43'),(13043,10397,'N','19','021','EC','A',NULL,NULL,'','0001242972','0001163831','','IL','1','Mehaffey','Michael','K','','','34','282989455','1721 BENSON DR',0,'DAYTON','OH','45406','4030','CY','39113','1993-10-18','M','',':RET:2054-5','N','021','DEN','2440963','99734OH005000401','2014-01-01','2013-12-23 07:00:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 12:50:39'),(22,17,'N','01','021','EC','A',NULL,NULL,'','0000690707','0001077700','','IL','1','Sarisky','Jacqueline','','','','34','285520777','49195 Eagle Dr.',0,'East Liverpool','OH','43920',NULL,'CY','39029','1953-01-05','F','',':RET:1002-5^:RET:2106-3','T','021','DEN','1239419','99734OH005000401','2014-01-01','2013-12-05 13:28:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:15:33'),(13473,10745,'N','19','021','EC','A',NULL,NULL,'','0001240556','0000290800','','IL','1','LEE','MIKAYLA','','','','34','064633432','8330 MEETING ST',0,'WEST CHESTER','OH','45069','5164','CY','39017','2012-06-06','F','',':RET:2106-3','N','021','DEN','1727612','99734OH005000301','2014-01-01','2013-12-23 16:30:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:04'),(24205,19223,'Y','18','021','EC','A','','','AC','0001469184','0001469184','LA00001439856','IL','1','MENENDEZ','LISSETTE','C','','','34','437087565','3951 CREEK SHADOW CT',0,'BATON ROUGE','LA','70816','9098','CY','22033','1954-03-04','F','U',NULL,'N','021','DEN','3219028','18575LA002000201','2014-03-01','2014-02-15 19:45:05','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-02-16 19:00:19'),(21804,17412,'Y','18','021','EC','A','','','AC','0000483515','0000483515','OH00002385175','IL','1','DeCurtins','Abbey','','','','34','270861806','8530 CLYDE DR',0,'CELINA','OH','45822','7140','CY','39107','1975-07-13','F','U',NULL,'N','021','HLT','3502979','92036OH004001501','2014-03-01','2014-02-05 22:07:08','152.00',NULL,NULL,'220.51','68.51','R-OH002','OH0','220.51',NULL,0,'2014-02-06 21:00:50'),(20332,16235,'Y','18','021','EC','A','','','AC','0000460609','0000460609','OH00002038910','IL','1','Chung','Terrence','','','','34','470194959','2304 PARKER RD',0,'AKRON','OH','44313','4306','CY','39153','1967-11-29','M','R',':RET:2054-5','N','021','HLT','1596811','52664OH151001501','2014-03-01','2014-01-27 22:10:22','0.00',NULL,NULL,'401.20','401.20','R-OH012','OH0','401.20',NULL,0,'2014-01-28 21:01:02'),(19810,15794,'Y','18','021','EC','A','','','AC','0000311745','0000311745','TX00002553743','31','1','Roblow','Phyllis','','','','34','455136333','PO Box 572',0,'Teague','TX','75860',NULL,'CY','48161','1957-10-06','F','U',':RET:2054-5','N','021','DEN','2449553','33348TX002000201','2014-03-01','2014-01-24 18:07:50','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-01-24 21:00:08'),(7292,5779,'Y','18','021','EC','A','','','AC','0000566604','0000566604','OH00001041545','IL','1','DePaolo','Anthony','','','','34','179443983','38155 STATE ROUTE 303',0,'GRAFTON','OH','44044','9013','CY','39093','1953-02-07','M','R',':RET:2106-3','N','021','HLT','517557','52664OH151001501','2014-01-01','2013-12-14 10:27:39','0.00',NULL,NULL,'818.71','818.71','R-OH011','OH0','818.71',NULL,0,'2013-12-26 02:02:54'),(15859,12698,'Y','18','024','14','A','','','TE','0000627881','0000627881','','IL','1','shearer','randall',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-05-30','M','',NULL,NULL,NULL,'','2166000','','2014-01-02','2014-01-02 10:16:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:04:43'),(5894,4673,'N','01','021','EC','A',NULL,NULL,'','0000146891','0001037361','','IL','1','Tucker','Tracy','Lynn','','','34','289606698','2517 HUFFMAN RD',0,'CENTERBURG','OH','43011','9470','CY','39083','1977-05-28','F','',':RET:2106-3','N','021','DEN','1679922','99734OH005000301','2014-01-01','2013-12-23 23:12:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:49:41'),(5777,4589,'Y','18','021','EC','A','','','AC','0000358329','0000358329','OH00000809518','IL','1','Kyles','Diwona','','','','34','269600575','618 Louis Place',0,'Middletown','OH','45044',NULL,'CY','39017','1956-04-24','F','U',':RET:2054-5','N','021','DEN','1881933','99734OH005000401','2014-01-01','2013-12-23 23:04:01','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 23:46:56'),(338,277,'N','01','021','EC','A',NULL,NULL,'','0000559404','0001105494','','IL','1','Cho','Jong','Kun','','','34','338663706','2605 N BEND RD',0,'ASHTABULA','OH','44004','8674','CY','39007','1950-02-09','M','',':RET:2040-4','N','021','DEN','989903','99734OH005000401','2014-01-01','2013-11-09 17:14:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 17:31:53'),(25954,20584,'Y','18','024','14','A','','','TE','0001144745','0001144745','','IL','1','Kundrach','Marghrettia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-03-24','F','',NULL,NULL,NULL,'','745758','','2014-03-13','2014-02-26 11:28:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 21:01:38'),(25315,20082,'Y','18','021','EC','A','','','AC','0001653687','0001653687','LA00002469869','IL','1','VILLAVASSO','DEBBIE','','','','34','437512579','5140 KENDALL DR',0,'NEW ORLEANS','LA','70126','3556','CY','22071','1979-06-29','F','U',':RET:2054-5^:RET:2106-3','T','021','DEN','3457192','18575LA002000201','2014-04-01','2014-02-24 18:09:19','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-25 21:30:04'),(24401,19382,'Y','18','024','14','A','','','TE','0000040996','0000040996','','IL','1','Nowak','Troy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-01-23','M','',NULL,NULL,NULL,'','3524340','','2014-02-18','2014-02-18 14:24:31',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-18 22:00:54'),(23913,19020,'Y','18','021','EC','A','','','AC','0000590941','0000590941','TX00002676854','IL','1','Holt','Joseph','','','','34','259555920','212 WILLOW CRST',0,'CIBOLO','TX','78108','2376','CY','48187','1979-02-20','M','U',':RET:2106-3','N','021','DEN','2961724','33348TX002000101','2014-03-01','2014-02-13 19:02:34','0.00',NULL,NULL,'25.02','25.02','R-TX019','TX0','25.02','CIC',0,'2014-02-14 22:00:03'),(1723,1437,'Y','18','021','EC','A','','','AC','0000876064','0000876064','OH00000523163','IL','1','Maisto','Maria','','','','34','578845881','287 CASTLE BLVD',0,'AKRON','OH','44313','6534','CY','39153','1967-09-22','F','M',':RET:2036-2^:RET:2106-3','N','021','DEN','1370597','99734OH005000301','2014-01-01','2013-12-24 10:25:08','0.00',NULL,NULL,'59.76','59.76','R-OH012','OH0','0.00',NULL,0,'2013-12-25 18:55:15'),(22456,17929,'Y','18','021','EC','A','','','AC','0000302832','0000302832','TX00001777421','IL','1','Cortina','Nora','','','','34','634667940','4809 W MILE 4 RD',0,'MISSION','TX','78574','3736','CY','48215','1970-07-04','F','U',NULL,'N','021','DEN','3192381','33348TX002000201','2014-03-01','2014-02-10 15:15:13','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-10 21:30:50'),(21402,17104,'Y','18','021','EC','A','','','AC','0001068301','0001068301','OH00002294108','IL','1','COSTON','DEBORAH','','','','34','299520629','5706 MONTGOMERY RD',0,'CINCINNATI','OH','45212','1969','CY','39061','1954-10-25','F','U',NULL,'N','021','DEN','3576241','99734OH005000401','2014-03-01','2014-02-04 13:16:40','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-04 21:01:03'),(2208,1819,'Y','18','021','EC','A','','','AC','0000940831','0000940831','OH00001104537','IL','1','Wallace','Tom','E','','','34','301463989','4936 SHERMAN WOOD DR',0,'KENT','OH','44240','7049','CY','39133','1949-04-14','M','M',':RET:2106-3','N','021','HLT','222793','52664OH151001304','2014-01-01','2013-12-10 14:13:27','977.00',NULL,NULL,'1309.70','332.70','R-OH012','OH0','669.00',NULL,0,'2013-12-25 19:20:14'),(21225,16961,'Y','18','024','14','A','','','TE','0000969418','0000969418','','IL','1','Williams','Katherine',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1962-07-10','F','',NULL,NULL,NULL,'','1076213','','2014-02-03','2014-02-03 16:59:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-03 21:01:05'),(20806,16625,'N','01','021','EC','A',NULL,NULL,'','0000721541','0001016709','','IL','1','Padia','Cynthia','','','','34','462854610','10235 PHELAN BLVD',0,'BEAUMONT','TX','77713','9670','CY','48245','1974-11-07','F','',':RET:2106-3','N','021','DEN','3409032','33348TX002000201','2014-03-01','2014-01-31 15:56:06',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-31 21:00:25'),(2613,2124,'Y','18','021','EC','A','','','AC','0000956619','0000956619','OH00000764667','IL','1','Dale','Ryan','','','','34','268929498','3625 MORRIS PL',0,'CINCINNATI','OH','45226','2129','CY','39061','1986-07-09','M','U',':RET:2106-3','N','021','DEN','405657','99734OH005000401','2014-01-01','2013-12-02 11:54:13','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:39'),(17783,14207,'Y','18','021','EC','A','','','AC','0000294433','0000294433','OH00002505223','IL','1','Dietrich','Keith','','','','34','298720882','320 W 5th Street',0,'Port Clinton','OH','43452',NULL,'CY','39123','1975-07-03','M','M',NULL,'N','021','HLT','2494975','92036OH005002706','2014-02-01','2014-01-13 13:26:34','423.00',NULL,NULL,'489.06','66.06','R-OH006','OH0','242.98',NULL,0,'2014-01-14 01:33:44'),(2735,2213,'Y','18','021','EC','A','','','AC','0000941342','0000941342','LA00000495582','IL','1','Hawks','Tyler','William','','','34','399047828','3123 ROYAL ST',0,'NEW ORLEANS','LA','70117','6742','CY','22071','1989-11-15','M','U',':RET:2106-3','N','021','DEN','1082361','18575LA002000201','2014-01-01','2013-12-02 13:28:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:48:35'),(8825,6997,'Y','18','021','EC','A','','','AC','0000782741','0000782741','TX00000911981','IL','1','anderson','susiette','','','','34','587346161','18743 clover glen lane',0,'houston','TX','77084',NULL,'CY','48201','1951-01-30','F','M',':RET:2054-5','N','021','DEN','1401288','33348TX002000201','2014-01-01','2013-12-17 19:47:53','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 04:00:22'),(8018,6347,'Y','18','024','14','A','','','TE','0001066944','0001066944','','IL','1','TIPTON','PATRICIA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-02-17','F','',NULL,NULL,NULL,'','755643','','2013-12-20','2013-12-20 14:29:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 03:08:50'),(7472,5912,'N','01','021','EC','A',NULL,NULL,'','0000411095','0001231752','','IL','1','Tompkins','Angie','J','','','34','409886082','670 Babbitt Rd',0,'Euclid','OH','44123',NULL,'CY','39035','1950-05-07','F','',':RET:2054-5','N','021','DEN','721135','99734OH005000401','2014-01-01','2013-12-14 21:38:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:31:12'),(27826,22007,'Y','18','021','EC','A','','','AC','0000328467','0000328467','OH00003529408','IL','1','Lopez','Joseph','Anthony','','','34','273988438','186 Scenic View Drive',0,'Copley','OH','44321',NULL,'CY','39153','1994-10-20','M','U',':RET:2106-3','N','021','DEN','3248567','99734OH005000301','2014-04-01','2014-03-05 09:59:42','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','21.13',NULL,0,'2014-03-05 21:31:58'),(13733,10960,'Y','18','024','14','A','','','TE','0001249587','0001249587','','IL','1','Smith','Shannon',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-06','F','',NULL,NULL,NULL,'','1557898','','2013-12-23','2013-12-23 18:22:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 13:09:29'),(918,761,'N','19','021','EC','A',NULL,NULL,'','0000915632','0001089541','','IL','1','Fowler','Claire','Metthe','','','34','288048764','821 PARK AVE',0,'HAMILTON','OH','45013','2973','CY','39017','1999-10-29','F','',':RET:2106-3','N','021','HLT','1467176','92036OH003001201','2014-01-01','2013-12-16 16:03:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','142.36',NULL,0,'2013-12-25 18:08:43'),(23435,18668,'N','01','021','EC','A',NULL,NULL,'','0001091828','0000145915','','IL','1','MENDOZA CABALLERO','JOSE','ARLREDO','','','34','633843795','3220 HUBERT DR',0,'BROWNSVILLE','TX','78526','2889','CY','48061','1952-04-30','M','',NULL,'N','021','DEN','3849358','33348TX002000201','2014-03-01','2014-02-13 10:27:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-13 22:01:29'),(7923,6265,'Y','18','021','EC','A','','','AC','0001896684','0001896684','LA00000080564','IL','1','EDWARDS','EMMANUEL','','','','34','436635953','200 CARONDELET ST',0,'NEW ORLEANS','LA','70130',NULL,'CY','22071','1983-09-04','M','U',':RET:2054-5','N','021','DEN','2167929','18575LA002000201','2014-01-01','2013-12-20 08:36:05','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 03:06:23'),(20224,16136,'Y','18','021','EC','A','','','AC','0000012462','0000012462','OH00002148832','IL','1','Jones','David','','','','34','281829789','2063 garden lake dr.',0,'toledo','OH','43614',NULL,'CY','39095','1967-11-24','M','M',':RET:2106-3','T','021','HLT','2741518','92036OH006002601','2014-03-01','2014-01-27 18:17:31','32.00',NULL,NULL,'266.76','234.76','R-OH001','OH0','266.76',NULL,0,'2014-01-27 21:01:46'),(20155,16084,'Y','18','024','14','A','','','TE','0001192669','0001192669','','IL','1','Vaiksnoras','Eric',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1973-11-03','M','',NULL,NULL,NULL,'','1976544','','2014-01-27','2014-01-27 11:11:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-27 21:01:06'),(20062,16001,'Y','18','021','EC','A','','','AC','0000220947','0000220947','TX00002154063','IL','1','VALVERDE','YVONNE','','','','34','453535066','450 GALLAGHER APT 208 B',0,'EL PASO','TX','79915',NULL,'CY','48141','1978-08-31','F','U',NULL,'N','021','DEN','2681731','33348TX002000201','2014-03-01','2014-01-27 11:56:29','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-27 21:00:12'),(18578,14814,'Y','18','021','EC','A','','','AC','0000358353','0000358353','OH00001957564','IL','1','Beasley','Justin','','','','34','237618806','2741 ROYAL GLEN DR',0,'CINCINNATI','OH','45239','4525','CY','39061','1981-06-09','M','U',':RET:2106-3','T','021','HLT','2373940','92036OH006001201','2014-02-01','2014-01-14 23:40:50','75.00',NULL,NULL,'231.61','156.61','R-OH004','OH0','231.61',NULL,0,'2014-01-16 08:47:07'),(7828,6200,'Y','18','021','EC','A','','','AC','0001032598','0001032598','OH00000205490','IL','1','Crawford','Daniel','','','','34','272442348','5101 Sumter Ave.',0,'cincinnati','OH','45238',NULL,'CY','39061','1951-10-06','M','U',':RET:2106-3','N','021','DEN','2229294','99734OH005000301','2014-01-01','2013-12-19 19:02:01','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-26 03:04:21'),(17593,14062,'Y','18','021','EC','A','','','AC','0000013797','0000013797','OH00001923452','IL','1','Plummer','Jeremy','','','','34','288865075','2775 OLD SPRINGFIELD RD',0,'SPRINGFIELD','OH','45502','9334','CY','39023','1986-04-08','M','U',':RET:2106-3','T','021','HLT','2536527','92036OH003000505','2014-02-01','2014-01-13 17:12:19','60.00',NULL,NULL,'299.17','239.17','R-OH003','OH0','299.17',NULL,0,'2014-01-14 01:32:11'),(16265,13023,'Y','18','021','EC','A','','','AC','0000091162','0000091162','OH00001550483','IL','1','oquendo','emily','','','','34','142822349','653 GLENMONT AVE',0,'COLUMBUS','OH','43214','3211','CY','39049','1975-11-07','F','M',':RET:2106-3','N','021','DEN','2532907','99734OH005000401','2014-02-01','2014-01-06 12:54:02','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-07 04:00:08'),(7776,6157,'Y','18','021','EC','A','','','AC','0000962211','0000962211','TX00000901179','31','1','FRANKLIN','lISA','','','','34','462271400','P O BOX 443',0,'MEMPHIS','TX','79245',NULL,'CY','48191','1962-08-04','F','M',NULL,'N','021','DEN','1482379','33348TX002000201','2014-01-01','2013-12-19 22:27:49','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 03:03:04'),(7646,6053,'Y','18','021','EC','A','','','AC','0000780238','0000780238','TX00000505247','IL','1','perry','kwame','','','','34','455876843','2931 barker cypress road',0,'houston','TX','77084',NULL,'CY','48201','1981-12-23','M','U',':RET:2054-5','N','021','DEN','517067','33348TX002000101','2014-01-01','2013-11-09 22:45:40','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:46:42'),(29210,23117,'Y','18','024','14','A','','','TE','0000525592','0000525592','','IL','1','Thomas','Alica',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1981-08-05','F','',NULL,NULL,NULL,'','3263025','','2014-03-10','2014-03-10 16:28:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCELCIC',0,'2014-03-10 21:30:15'),(1391,1155,'Y','18','021','EC','A','','','AC','0001472769','0001472769','LA00001155191','31','1','Rancifer','Cinuray','','','','34','435214599','P.O.Box 641988',0,'Kenner','LA','70064',NULL,'CY','22051','1974-10-31','F','U',':RET:2054-5','N','021','DEN','1472912','18575LA002000201','2014-01-01','2013-12-24 11:14:23','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:46:22'),(25531,20254,'Y','18','021','EC','A','','','AC','0000362010','0000362010','TX00002538305','IL','1','Oneal','Stan','','','','34','433693606','211 COWLES ST',0,'HALLSVILLE','TX','75650','6085','CY','48203','1987-05-21','M','U',':RET:2054-5','N','021','DEN','3749280','33348TX002000201','2014-04-01','2014-02-22 21:37:46','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-26 08:00:05'),(1676,1398,'Y','18','021','EC','A','','','AC','0000511959','0000511959','OH00000111790','IL','1','HOCHSCHILD','Cynthia','','','','34','277565967','21317 STATE ROUTE 125',0,'BLUE CREEK','OH','45616','9734','CY','39001','1954-12-19','F','M',':RET:2106-3','T','021','HLT','1866853','92036OH005000605','2014-01-01','2013-12-24 17:36:35','482.00',NULL,NULL,'642.62','160.62','R-OH005','OH0','642.62',NULL,0,'2013-12-25 18:54:00'),(8075,6395,'Y','18','021','EC','A','','','AC','0000889600','0000889600','OH00000160527','31','1','ring','don','','','Jr','34','363846718','PO Box 661',0,'Saint marys','OH','45885',NULL,'CY','39011','1963-12-07','M','M',':RET:2106-3','N','021','HLT','1516931','92036OH004001501','2014-01-01','2013-12-20 15:21:00','535.45',NULL,NULL,'539.39','3.94','R-OH002','OH0','316.06',NULL,0,'2013-12-26 03:10:19'),(1835,1504,'N','01','021','EC','A',NULL,NULL,'','0000016620','0000783236','','IL','1','FOX','DENIS','CARMEN','','','34','299467165','1083 TOWNSHIP ROAD 713',0,'ASHLAND','OH','44805','9791','CY','39005','1950-06-29','M','',':RET:2106-3','N','021','HLT','2368236','52664OH151001305','2014-01-01','2013-12-24 11:20:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,0,'2013-12-25 18:57:31'),(2440,1988,'Y','18','021','EC','A','','','AC','0000848322','0000848322','OH00000071322','IL','1','Srebernak','Pam','','','','34','273643827','9415 INDIAN RUN',0,'MACEDONIA','OH','44056','1013','CY','39153','1964-06-14','F','U',NULL,'N','021','HLT','15273','52664OH151001305','2014-01-01','2013-12-09 16:00:18','267.00',NULL,NULL,'380.45','113.45','R-OH012','OH0','380.45',NULL,0,'2013-12-25 19:34:25'),(2630,2138,'Y','18','021','EC','A','','','AC','0000235176','0000235176','OH00000076114','IL','1','rollins','gary','w','','','34','305647029','2636 HARRISON AVE',0,'CINCINNATI','OH','45211','7743','CY','39061','1953-11-22','M','U',':RET:2106-3','T','021','DEN','85505','99734OH005000401','2014-01-01','2013-12-02 10:19:31','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:46:05'),(6915,5488,'Y','18','021','EC','A','','','AC','0001235054','0001235054','LA00001706157','IL','1','Tabora','Juan','','','','34','434813775','374 COLLEGE HILL DR',0,'BATON ROUGE','LA','70808','4943','CY','22033','1986-09-27','M','U',NULL,'T','021','DEN','2310931','18575LA002000201','2014-02-01','2013-12-25 14:12:17','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:46:00'),(17908,14304,'Y','18','021','EC','A','','','AC','0001178637','0001178637','TX00002421586','IL','1','WILLARD','LOLA','','','','34','453477300','4020 STATE HIGHWAY 155',0,'PALESTINE','TX','75803','1737','CY','48001','1976-06-08','F','M',':RET:2106-3','N','021','DEN','2183989','33348TX002000201','2014-02-01','2014-01-13 20:00:56','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-01-15 02:06:26'),(20187,16108,'N','01','021','EC','A',NULL,NULL,'','0000533968','0001088567','','IL','1','ware','jennifer','l','','','34','432254495','1609 LAKE TAWAKONI DR',0,'ALLEN','TX','75002','1895','CY','48085','1974-03-11','F','',':RET:2106-3','N','021','DEN','2702806','33348TX002000101','2014-03-01','2014-01-27 00:47:11',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-27 21:01:24'),(20052,15992,'Y','18','021','EC','A','','','AC','0000602902','0000602902','TX00001589054','IL','1','Cunningham','Quentin','','','','34','422198014','1105 18th st',0,'killeen','TX','76548',NULL,'CY','48027','1978-11-25','M','U',':RET:2054-5','T','021','DEN','3329006','33348TX002000201','2014-03-01','2014-01-26 20:35:59','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2014-01-27 21:00:06'),(19761,15753,'Y','18','021','EC','A','','','AC','0000438000','0000438000','OH00001603906','31','1','ADAMS','MITCHELL','CALVIN','','','34','301506934','2302 COPPER KETTLE HWY',0,'ROCKWOOD','PA','15557',NULL,'CY','39047','1951-02-19','M','U',NULL,'N','021','DEN','2907140','99734OH005000301','2014-03-01','2014-01-23 15:54:14','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2014-01-23 21:01:23'),(19209,15304,'Y','18','021','EC','A','','','AC','0000005865','0000005865','OH00001526546','IL','1','Chop','John','','','','34','321601567','371 Park ave.',0,'Chardon','OH','44024',NULL,'CY','39055','1962-06-18','M','R',':RET:2106-3','T','021','DEN','1661344','99734OH005000401','2014-03-01','2014-01-20 09:11:53','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:46:20'),(19018,15145,'Y','18','021','EC','A','','','AC','0000216129','0000216129','OH00001845446','IL','1','Laurich','Daniel','','','','34','297500533','26241 Lake Shore Bl',0,'Euclid','OH','44132',NULL,'CY','39035','1950-11-19','M','U',':RET:2106-3','N','021','HLT','1870029','52664OH152000901','2014-03-01','2014-01-17 11:17:11','530.00',NULL,NULL,'543.83','13.83','R-OH011','OH0','543.83',NULL,0,'2014-01-20 08:06:24'),(19000,15132,'N','01','021','EC','A',NULL,NULL,'','0000762319','0000558173','','IL','1','RITTER','SOPHIA','','','','34','284627021','3001 GALE DR',0,'AKRON','OH','44312','2937','CY','39153','1954-11-30','F','',':RET:2106-3','N','021','HLT','2954796','52664OH151001305','2014-03-01','2014-01-17 12:31:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','580.49',NULL,0,'2014-01-20 08:06:15'),(18048,14419,'Y','18','021','EC','A','','','AC','0000293078','0000293078','MS00001746007','IL','1','LOVE','ROBIN','LYNN','','','34','425237801','137 PISGAH BOTTOM  RD',0,'CANTON','MS','39046',NULL,'CY','28089','1961-05-06','M','M',NULL,'N','021','DEN','2659221','46300MS002000101','2014-02-01','2014-01-14 09:53:16','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-15 02:07:15'),(28549,22595,'Y','18','021','EC','A','','','AC','0001260078','0001260078','OH00002656072','IL','1','Simon','Deborah','','','','34','268604922','18825 RANGE LINE RD',0,'BOWLING GREEN','OH','43402','9750','CY','39173','1956-05-02','F','U',NULL,'N','021','HLT','2988451','92036OH005002606','2014-04-01','2014-03-07 12:34:56','392.00',NULL,NULL,'475.21','83.21','R-OH001','OH0','475.21',NULL,0,'2014-03-07 21:32:19'),(167,140,'Y','18','021','EC','A','','','AC','0000141476','0000141476','OH00001283841','IL','1','Castillo','Barbara','','','','34','273701380','1210 STATE ROUTE 302',0,'ASHLAND','OH','44805','9321','CY','39005','1961-05-13','F','U',':RET:2106-3','N','021','HLT','724736','52664OH151001304','2014-01-01','2013-12-04 19:11:14','310.00',NULL,NULL,'435.31','125.31','R-OH012','OH0','435.31',NULL,0,'2013-12-25 17:19:20'),(27263,21587,'Y','18','021','EC','A','','','AC','0001452443','0001452443','LA00003406053','IL','1','Hill','Samantha','','','','34','439615500','3869 HIghway 576',0,'Mangham','LA','71259',NULL,'CY','22083','1985-11-13','F','U',':RET:2106-3','N','021','DEN','3290806','18575LA002000101','2014-04-01','2014-03-03 21:43:59','0.00',NULL,NULL,'25.02','25.02','R-LA007','LA0','25.02',NULL,0,'2014-03-04 21:00:10'),(23912,19019,'Y','18','024','14','A','','','TE','0000590941','0000590941','','IL','1','holt','joseph',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-02-20','M','',NULL,NULL,NULL,'','1908131','','2014-02-28','2014-02-13 19:02:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-02-14 22:00:03'),(21829,17431,'Y','18','021','EC','A','','','AC','0000606753','0000606753','TX00001534720','IL','1','Hamlett','Tristan','','','','34','641181361','6706 Wagonwheel Lane',0,'Houston','TX','77088',NULL,'CY','48201','1986-09-26','F','U',NULL,'N','021','DEN','2716573','33348TX002000101','2014-03-01','2014-02-06 17:09:14','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2014-02-06 21:01:03'),(21126,16881,'Y','18','024','14','A','','','TE','0000201944','0000201944','','IL','1','Baars','Brandt',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-02-14','M','',NULL,NULL,NULL,'','3645895','','2014-02-03','2014-02-03 14:24:31',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-02-03 21:00:15'),(822,680,'Y','18','021','EC','A','','','AC','0000644658','0000644658','OH00001342728','IL','1','FRITZ','ANNETTE','A','','','34','039328263','5738 NOLLEY RD',0,'AKRON','OH','44319','4656','CY','39153','1951-12-21','F','M',':RET:2106-3','N','021','HLT','2131661','52664OH151001301','2014-01-01','2013-12-16 14:31:31','0.00',NULL,NULL,'640.70','640.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 18:06:06'),(1861,1522,'N','19','021','EC','A',NULL,NULL,'','0001230390','0000589326','','IL','1','Wilke','Sophia','L','','','34','272176244','9336 BRYANT RD',0,'WINDHAM','OH','44288','9547','CY','39133','2011-01-26','F','',':RET:2106-3','N','021','HLT','2563089','52664OH152000901','2014-01-01','2013-12-24 10:59:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 18:58:08'),(6905,5479,'Y','18','021','EC','A','','','AC','0001792334','0001792334','LA00000135767','IL','1','johnson','cheryl','','','','34','434151139','6630 seigen ln',0,'baton rouge','LA','70809',NULL,'CY','22033','1960-05-12','F','U',':RET:1002-5^:RET:2054-5','N','021','DEN','2516889','18575LA002000201','2014-01-01','2013-12-24 23:41:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 01:45:45'),(9805,7764,'Y','18','021','EC','A','','','AC','0000043169','0000043169','MS00000532134','IL','1','Teague','Gerone','','','','34','403499482','640 BRIARWOOD DR',0,'JACKSON','MS','39211','2601','CY','28049','1995-12-28','F','U',NULL,'N','021','DEN','942438','46300MS001000101','2014-01-01','2013-10-21 00:03:37','0.00',NULL,NULL,'47.10','47.10','R-MS003','MS0','47.10',NULL,0,'2013-12-26 05:01:20'),(1082,888,'Y','18','021','EC','A','','','AC','0000712491','0000712491','OH00000770206','IL','1','Nickoson','Gerri','','','','34','272647229','598 LOUISE DR',0,'XENIA','OH','45385','1701','CY','39057','1956-09-04','F','U',NULL,'N','021','DEN','1183973','99734OH005000401','2014-01-01','2013-12-03 10:14:52','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-25 18:16:48'),(26158,20741,'Y','18','021','EC','A','','','AC','0000749592','0000749592','OH00003170605','IL','1','CHATMAN','TABITHA','','','','34','405941349','309 S WAYNE AVE APT 7',0,'CINCINNATI','OH','45215',NULL,'CY','39061','1971-07-14','F','M',':RET:2054-5','N','021','DEN','3601244','99734OH005000401','2014-04-01','2014-02-27 17:23:03','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-28 06:30:31'),(25564,20279,'N','01','021','EC','A',NULL,NULL,'','0000087629','0001017890','','IL','1','Williams','James','Wesley','','','34','455533396','121 S. Frank Rd.',0,'Trinity','TX','75862',NULL,'CY','48455','1966-09-25','M','',':RET:2106-3','T','021','DEN','3144644','33348TX002000101','2014-04-01','2014-02-23 17:52:04',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-02-26 08:00:25'),(7364,5832,'Y','18','021','EC','A','','','AC','0000709821','0000709821','LA00000662591','IL','1','Howard','Edith','','','','34','433551393','127 HOWARD LN',0,'FRIERSON','LA','71027','2154','CY','22031','1984-03-13','F','U',':RET:2054-5','N','021','DEN','1094024','18575LA002000201','2014-01-01','2013-11-22 22:31:37','0.00',NULL,NULL,'14.61','14.61','R-LA008','LA0','14.61',NULL,0,'2013-12-26 02:15:29'),(2924,2356,'Y','18','021','EC','A','','','AC','0000186083','0000186083','OH00000068615','IL','1','Andregg','Emily','','','','34','282768564','3628 Trails End Dr',0,'Medina','OH','44256',NULL,'CY','39103','1980-05-05','F','U',NULL,'T','021','DEN','352870','99734OH005000401','2014-01-01','2013-12-06 17:44:07','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 20:15:50'),(15611,12487,'Y','18','021','EC','A','','','AC','0000869293','0000869293','OH00000340125','IL','1','Haines','Heather','','','','34','286724532','202 W FOREST ST',0,'CELINA','OH','45822','1062','CY','39107','1971-11-23','F','M',':RET:2106-3','N','021','DEN','2331173','99734OH005000301','2014-02-01','2013-12-31 18:30:14','0.00',NULL,NULL,'42.26','42.26','R-OH002','OH0','0.00',NULL,1,'2014-01-02 04:32:50'),(28542,22590,'Y','18','021','EC','A','','','AC','0001248393','0001248393','OH00002847642','IL','1','Simmons','Shannon','','','','34','288806618','416 W PENNSYLVANIA AVE',0,'SEBRING','OH','44672','1141','CY','39099','1982-07-23','F','M',':RET:2106-3','N','021','HLT','2770535','52664OH151001501','2014-04-01','2014-03-07 11:24:41','0.00',NULL,NULL,'734.32','734.32','R-OH013','OH0','351.54',NULL,0,'2014-03-07 21:32:15'),(26587,21081,'Y','18','021','EC','A','','','AC','0000934714','0000934714','OH00003317390','IL','1','Rusher','Donna','','','','34','300660393','7814 Red Maple Pl',0,'Westerville','OH','43082',NULL,'CY','39041','1962-09-24','F','U',':RET:2106-3','N','021','DEN','3119919','99734OH005000401','2014-03-01','2014-02-28 17:58:14','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-28 21:30:34'),(13651,10890,'Y','18','021','EC','A','','','AC','0002116181','0002116181','LA00001260099','IL','1','delgado','david','','','','34','434733174','1175 MADRID AVE',0,'SAINT GABRIEL','LA','70776','5332','CY','22047','1985-03-30','M','U',':RET:2106-3','T','021','DEN','1393838','18575LA002000101','2014-01-01','2013-12-22 21:40:17','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-26 13:07:19'),(24688,19597,'Y','18','021','EC','A','','','AC','0000991176','0000991176','TX00002083800','IL','1','snider','susan','','','','34','459926046','110w 1st st',0,'shiner','TX','77984',NULL,'CY','48285','1950-06-01','F','U',':RET:2106-3','N','021','DEN','3007336','33348TX002000101','2014-04-01','2014-02-19 14:24:51','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-02-20 04:31:42'),(23371,18623,'Y','18','021','EC','A','','','AC','0000326230','0000326230','OH00002705746','IL','1','BRICKER','JODI','','','','34','282888741','5845 HARLEM RD',0,'GALENA','OH','43021','9634','CY','39041','1975-06-18','F','M',NULL,'T','021','DEN','2966457','99734OH005000401','2014-03-01','2014-02-12 22:09:03','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-13 22:00:53'),(9159,7266,'Y','18','021','EC','A','','','AC','0000929828','0000929828','OH00000650308','IL','1','Vickers','Brandy','','','','34','294724613','6246 BENNEVILLE ST',0,'CINCINNATI','OH','45230','1901','CY','39061','1974-10-08','F','M',':RET:2106-3','N','021','HLT','2232955','92036OH005001201','2014-01-01','2013-12-18 06:18:18','0.00',NULL,NULL,'667.84','667.84','R-OH004','OH0','270.91',NULL,0,'2013-12-26 04:08:40'),(5558,4412,'Y','18','021','EC','A','','','AC','0000061404','0000061404','LA00001261890','IL','1','Smith','Whitley','','','','34','433814267','4825 VIRGILIAN ST',0,'NEW ORLEANS','LA','70126','3936','CY','22071','1988-07-12','F','U',':RET:2054-5','N','021','DEN','922299','18575LA002000201','2014-01-01','2013-11-27 12:53:21','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:16:20'),(1700,1419,'Y','18','021','EC','A','','','AC','0000999850','0000999850','OH00000556971','31','1','Holley','Pamela','','','','34','317622556','PO Box 71',0,'Fayette','OH','43521',NULL,'CY','39051','1960-09-10','F','U',':RET:2106-3','N','021','HLT','2496973','92036OH001002601','2014-01-01','2013-12-24 07:15:12','0.00',NULL,NULL,'479.83','479.83','R-OH001','OH0','479.83',NULL,0,'2013-12-25 18:54:41'),(3237,2607,'Y','18','021','EC','A','','','AC','0000252004','0000252004','TX00000388817','IL','1','Killen','Molly','','','','34','450915999','701 Legacy Drive',0,'Plano','TX','75023',NULL,'CY','48085','1983-02-16','F','U',NULL,'N','021','DEN','605341','33348TX002000201','2014-01-01','2013-10-05 19:55:24','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2013-12-25 20:46:12'),(5437,4319,'Y','18','021','EC','A','','','AC','0001211587','0001211587','LA00000725188','IL','1','WILLIAMS','CYNTHIA','','','','34','439758603','4980 N LOWER ZACHARY RD',0,'ZACHARY','LA','70791','5338','CY','22033','1990-01-04','F','M',':RET:2054-5','N','021','DEN','2044330','18575LA002000101','2014-01-01','2013-12-19 16:46:08','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:09:50'),(17108,13691,'N','01','021','EC','A',NULL,NULL,'','0000457820','0000956666','','IL','1','Null','Phillip','','','','34','296543834','4901 Turkey Road',0,'Hillsboro','OH','45133',NULL,'CY','39071','1954-07-29','M','',NULL,'T','021','HLT','2592942','92036OH004000601','2014-02-01','2014-01-08 14:01:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','516.72',NULL,0,'2014-01-13 02:21:35'),(27196,21534,'Y','18','021','EC','A','','','AC','0000991227','0000991227','TX00003317455','IL','1','NGUYEN','HIEN','','','','34','636320031','103  Henderson. St',0,'Palacios','TX','77465',NULL,'CY','48321','1974-02-05','F','M',':RET:2047-9','N','021','DEN','3680090','33348TX002000201','2014-04-01','2014-03-03 16:33:34','0.00',NULL,NULL,'29.22','29.22','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:19'),(571,468,'Y','18','021','EC','A','','','AC','0000201900','0000201900','OH00000628907','IL','1','Carpenter','Randall',NULL,NULL,NULL,NULL,NULL,'5312 Little Turtle Dr.',0,'South Lebanon','OH','45065',NULL,'CY','39165','1953-09-04','M','R',':RET:2106-3','N','021','HLT','747075','92036OH005001201','2014-01-01','2013-12-03 21:06:06','0.00',NULL,NULL,'582.60','582.60','R-OH004','OH0','582.60',NULL,0,'2013-12-25 17:50:36'),(25026,19845,'Y','18','021','EC','A','','','AC','0000825449','0000825449','TX00003045939','IL','1','PHAM','MC','','','','34','479271409','1633 Webster St.',0,'League City','TX','77573',NULL,'CY','48167','1974-02-07','M','M',':RET:2047-9','N','021','DEN','3850995','33348TX002000101','2014-04-01','2014-02-20 14:25:49','0.00',NULL,NULL,'54.30','54.30','R-TX010','TX0','27.15',NULL,0,'2014-02-20 22:01:00'),(16262,13020,'Y','18','021','EC','A','','','AC','0000345591','0000345591','OH00001554383','IL','1','bailey','nathan','','','','34','274926553','6645 SEVILLE RD',0,'SEVILLE','OH','44273','9149','CY','39103','1990-03-28','M','U',':RET:2106-3','N','021','HLT','1808673','52664OH152000901','2014-02-01','2014-01-04 13:18:45','52.00',NULL,NULL,'163.34','111.34','R-OH012','OH0','163.34',NULL,0,'2014-01-05 00:02:58'),(3394,2723,'Y','18','021','EC','A','','','AC','0001475364','0001475364','LA00001279200','IL','1','Simmons','Kesha','','','','34','436634149','2292 COLOMBO DR',0,'HARVEY','LA','70058','3006','CY','22051','1971-02-23','F','U',':RET:2054-5','N','021','DEN','2548378','18575LA002000201','2014-01-01','2013-12-22 00:52:15','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 21:17:56'),(19400,15467,'Y','18','024','14','A','','','TE','0000926274','0000926274','','IL','1','Schroer','Robert',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-05-10','M','',NULL,NULL,NULL,'','2000078','','2014-01-21','2014-01-21 12:29:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',1,'2014-01-22 03:22:52'),(9567,7581,'Y','18','021','EC','A','','','AC','0001245588','0001245588','OH00000122971','IL','1','STUNTEBECK','PETER','JOSEPH','','','34','302528389','11588 KEMPER WOODS DR',0,'CINCINNATI','OH','45249','1752','CY','39061','1951-04-20','M','M',NULL,'N','021','DEN','1827183','99734OH005000301','2014-01-01','2013-12-21 16:14:56','0.00',NULL,NULL,'59.76','59.76','R-OH004','OH0','0.00',NULL,0,'2013-12-26 04:36:40'),(14278,11390,'N','01','021','EC','A',NULL,NULL,'','0000172872','0001059531','','IL','1','MOORE','JANEEN','','','','34','438277531','2304 LADD ST',0,'JACKSON','MS','39209',NULL,'CY','28049','1969-09-14','F','',':RET:2054-5','N','021','DEN','1453080','46300MS002000201','2014-02-01','2013-12-26 15:57:04',NULL,NULL,NULL,NULL,NULL,NULL,'MS0','15.85',NULL,0,'2013-12-27 02:06:16'),(21597,17249,'Y','18','021','EC','A','','','AC','0001076598','0001076598','OH00002007803','IL','1','SAMI','SHARIQ','','','','34','447049023','3853 BLOSSOM COURT',0,'MASON','OH','45040',NULL,'CY','39165','1966-07-15','M','M',':RET:2028-9','N','021','DEN','3713299','99734OH005000301','2014-03-01','2014-02-05 12:25:22','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-02-05 21:30:31'),(18930,15083,'N','01','021','EC','A',NULL,NULL,'','0000274809','0001130251','','IL','1','HUFFMAN','ERIC','','','','34','285728769','7945 N PALMYRA RD',0,'CANFIELD','OH','44406',NULL,'CY','39099','1965-09-23','M','',NULL,'N','021','DEN','2271896','99734OH005000401','2014-03-01','2014-01-17 10:32:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:05:37'),(18576,14813,'N','19','021','EC','A',NULL,NULL,'','0000618388','0000573074','','IL','1','Youssefi','Jeala','','','','34','270028842','1216 MAGDALYN DR',0,'AKRON','OH','44320','1426','CY','39153','1996-09-21','F','',':RET:2106-3','N','021','HLT','2686554','52664OH152000901','2014-02-01','2014-01-15 15:43:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2014-01-16 08:47:06'),(4451,3537,'N','01','021','EC','A',NULL,NULL,'','0000911738','0000047065','','IL','1','Vranich','John','S','','','34','383546833','14335 MILL HOLLOW LN',0,'STRONGSVILLE','OH','44136','5423','CY','39035','1956-08-11','M','',':RET:2106-3','N','021','DEN','330659','99734OH005000301','2014-01-01','2013-12-12 10:01:10',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 22:02:23'),(1752,1450,'N','01','021','EC','A',NULL,NULL,'','0000665651','0000644672','','IL','1','Brown','Pamela','','','','34','299627618','109 S PRIMROSE PL',0,'LIMA','OH','45805','2623','CY','39003','1956-12-09','F','',NULL,'N','021','DEN','2082437','99734OH005000301','2014-01-01','2013-12-24 12:24:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:55:44'),(20355,16256,'Y','18','021','EC','A','','','AC','0000868265','0000868265','OH00001407675','IL','1','Sigler','Tony','','','','34','273640741','506 N BEVER ST',0,'WOOSTER','OH','44691','3532','CY','39169','1958-10-07','M','U',':RET:2106-3','N','021','HLT','3530350','52664OH152000901','2014-03-01','2014-01-28 12:44:07','334.00',NULL,NULL,'364.25','30.25','R-OH014','OH0','364.25',NULL,0,'2014-01-28 21:01:16'),(1856,1520,'Y','18','021','EC','A','','','AC','0000773980','0000773980','OH00000285557','IL','1','MENNINGER','JAMES','','','','34','273468750','3 OLD DUXBURY CT',0,'FAIRFIELD','OH','45014','5227','CY','39017','1953-03-19','M','U',NULL,'N','021','HLT','1600887','92036OH005001204','2014-01-01','2013-12-24 17:09:40','360.00',NULL,NULL,'582.60','222.60','R-OH004','OH0','582.60',NULL,0,'2013-12-25 18:58:03'),(18730,14927,'N','19','021','EC','A',NULL,NULL,'','0000253078','0000774007','','S1','1','Winters','Camden',NULL,NULL,NULL,NULL,NULL,'6282 E US HIGHWAY 36',0,'CABLE','OH','43009','9625','CY','39021','2010-10-21','F','',':RET:2106-3','N','021','DEN','2107235','99734OH005000301','2014-03-01','2014-01-16 00:24:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-17 03:35:37'),(17883,14282,'Y','18','021','EC','A','','','AC','0000841939','0000841939','OH00002375581','IL','1','Johnson','Charles','R','','','34','269601906','5900 WITHROW WAY',0,'DAYTON','OH','45415','2953','CY','39113','1958-03-11','M','U',':RET:2054-5','N','021','DEN','2766525','99734OH005000401','2014-02-01','2014-01-14 14:37:04','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-01-15 02:06:17'),(8977,7120,'Y','18','021','EC','A','','','AC','0000969424','0000969424','OH00000939191','IL','1','steffan','victoria','','','','34','293484992','1300 FOSTORIA AVE',0,'FINDLAY','OH','45840','6212','CY','39063','1950-06-21','F','U',':RET:2106-3','N','021','DEN','1685573','99734OH005000401','2014-01-01','2013-12-18 15:28:56','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2013-12-26 04:04:12'),(28544,22591,'Y','18','021','EC','A','','','AC','0000841985','0000841985','OH00002923209','IL','1','Adamczyk','James','','','','34','296541406','528 East Maple St',0,'Hartville','OH','44632',NULL,'CY','39151','1953-11-25','M','U',':RET:2106-3','T','021','HLT','3424662','52664OH151001501','2014-04-01','2014-03-07 11:46:18','350.00',NULL,NULL,'834.79','484.79','R-OH015','OH0','834.79',NULL,0,'2014-03-07 21:32:16'),(1965,1604,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00000478553','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','821707','33348TX002000101','2014-01-01','2013-11-19 22:59:48','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:19'),(21517,17191,'N','19','021','EC','A',NULL,NULL,'','0001210808','0000369595','','IL','1','Johnson','Raven','','','','34','627084002','3200 Ross Ave Unit 24',0,'Dallas','TX','75204',NULL,'CY','48113','2007-02-11','F','',':RET:2054-5','N','021','DEN','2829283','33348TX002000201','2014-03-01','2014-02-05 12:55:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','40.52','CIC',0,'2014-02-05 21:00:05'),(3320,2665,'Y','18','021','EC','A','','','AC','0001187636','0001187636','OH00000927651','IL','1','Tracy','Mary','','','','34','279721353','203 N Campbell St',0,'Forest','OH','45843',NULL,'CY','39065','1961-09-01','F','U',':RET:2106-3','N','021','DEN','1535640','99734OH005000301','2014-01-01','2013-12-22 15:55:21','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 21:16:03'),(9497,7532,'Y','18','021','EC','A','','','AC','0000353967','0000353967','OH00001138910','IL','1','James','Robin','Brintnall','','','34','369585909','2743 SPANGLER RD',0,'COLUMBUS','OH','43207','6500','CY','39049','1956-11-24','M','U',':RET:2106-3','N','021','DEN','2092125','99734OH005000401','2014-01-01','2013-12-21 14:50:27','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2013-12-26 04:35:04'),(817,676,'Y','18','021','EC','A','','','AC','0000662682','0000662682','OH00000585867','IL','1','Sigel','Thomas','','','','34','294525179','4403 BELMONT CT',0,'MEDINA','OH','44256','7485','CY','39103','1965-01-27','M','U',':RET:2106-3','N','021','HLT','2503844','52664OH151001304','2014-01-01','2013-12-16 12:33:26','192.00',NULL,NULL,'364.62','172.62','R-OH012','OH0','364.62',NULL,0,'2013-12-25 18:05:58'),(1893,1548,'Y','18','021','EC','A','','','AC','0001002177','0001002177','OH00000391064','IL','1','Hamilton','Larry','','','','34','274483955','418 North Main Street',0,'Celina','OH','45822',NULL,'CY','39107','1950-08-18','M','M',':RET:2106-3','N','021','HLT','2493458','92036OH005001505','2014-01-01','2013-12-24 12:26:18','564.00',NULL,NULL,'649.68','85.68','R-OH002','OH0','649.68',NULL,0,'2013-12-25 18:58:54'),(23659,18839,'N','01','021','EC','A',NULL,NULL,'','0000576485','0000418043','','IL','1','Hebert','Robert','','','III','34','458652000','400 COUNTY ROAD 3136',0,'BUNA','TX','77612','3436','CY','48241','1983-06-21','M','',NULL,'N','021','DEN','3581475','33348TX002000201','2014-03-01','2014-02-14 10:55:38',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-14 21:30:19'),(16660,13331,'Y','18','021','EC','A','','','AC','0001577574','0001577574','LA00001884680','IL','1','Davis','sonja','a','','','34','436210092','556 E BOLIVAR DR',0,'BATON ROUGE','LA','70819','3307','CY','22033','1971-08-22','F','U',':RET:2054-5','N','021','DEN','2390731','18575LA002000101','2014-02-01','2014-01-07 12:17:33','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-08 18:24:24'),(27167,21510,'Y','18','021','EC','A','','','AC','0000541102','0000541102','TX00003282494','IL','1','Berry','Rebekka','','','','34','463830504','4314 Faith Rd',0,'Wichita Falls','TX','76308',NULL,'CY','48485','1977-05-09','F','M',':RET:2106-3','N','021','DEN','3176103','33348TX002000201','2014-04-01','2014-03-03 00:33:35','0.00',NULL,NULL,'31.70','31.70','R-TX025','TX0','15.85',NULL,0,'2014-03-03 21:31:03'),(13494,10755,'N','19','021','EC','A',NULL,NULL,'','0000645986','0000777678','','S1','1','Giovannazzo','Emily','J','','','34','032864672','26311 LAKE RD',0,'BAY VILLAGE','OH','44140','2570','CY','39035','2003-09-30','M','',NULL,'N','021','DEN','2373290','99734OH005000301','2014-01-01','2013-12-23 18:14:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 13:02:27'),(23404,18646,'Y','18','021','EC','A','','','AC','0000638554','0000638554','OH00002424567','IL','1','KENNA','DAN','','','','34','270681811','120 MONTROSE WEST AVE',0,'COPLEY','OH','44321','1372','CY','39153','1960-02-03','M','U',':RET:2106-3','N','021','DEN','3812152','99734OH005000401','2014-03-01','2014-02-13 17:22:14','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-13 22:01:10'),(13143,10483,'Y','18','021','EC','A','','','AC','0000746887','0000746887','OH00001219446','IL','1','JAIN','SARITA','S','','','34','157688012','5630 SADDLE LN',0,'SOLON','OH','44139','1580','CY','39035','1953-05-25','F','M',':RET:2029-7','N','021','DEN','2286888','99734OH005000401','2014-01-01','2013-12-23 16:00:35','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:53:22'),(6332,5021,'Y','18','021','EC','A','','','AC','0000519804','0000519804','OH00000121128','IL','1','Karadeniz','Courtney','L','','','34','275802257','322 BROOKFOREST DR',0,'CINCINNATI','OH','45238','5610','CY','39061','1982-12-06','F','U',':RET:2106-3','N','021','DEN','1005018','99734OH005000401','2014-01-01','2013-12-11 11:36:10','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:38'),(16558,13247,'Y','18','024','14','A','','','TE','0002036750','0002036750','','IL','1','Carter','Nichelle',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-07','F','',NULL,NULL,NULL,'','1875469','','2014-01-05','2014-01-05 17:36:06',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',1,'2014-01-07 10:22:57'),(3940,3154,'Y','18','021','EC','A','','','AC','0000066226','0000066226','OH00000948529','IL','1','MERCER','NORMAN','JOHN','','','34','272444946','1375 COUNTY ROAD B',0,'SWANTON','OH','43558','9753','CY','39051','1949-12-15','M','U',':RET:2106-3','N','021','HLT','148201','92036OH006002601','2014-01-01','2013-12-13 09:17:56','335.00',NULL,NULL,'463.92','128.92','R-OH001','OH0','463.92',NULL,0,'2013-12-25 21:37:54'),(3249,2619,'Y','18','021','EC','A','','','AC','0001016820','0001016820','OH00001273754','IL','1','black','william','james','','Jr','34','278501400','684 TOLLIS PKWY',0,'BROADVIEW HEIGHTS','OH','44147','1812','CY','39035','1949-06-07','M','U',':RET:2106-3','N','021','DEN','763616','99734OH005000401','2014-01-01','2013-11-28 12:06:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 20:46:35'),(8873,7035,'N','01','021','EC','A',NULL,NULL,'','0000605503','0000385271','','IL','1','RAMIREZ','RAUL','','','Jr','34','449024595','701 LA PALMA ST',0,'SAN BENITO','TX','78586','4209','CY','48061','1956-02-02','M','',NULL,'N','021','DEN','2460482','33348TX002000201','2014-01-01','2013-12-18 14:18:09',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-26 04:01:38'),(4067,3249,'Y','18','021','EC','A','','','AC','0000670244','0000670244','OH00000320488','IL','1','Lamovsky','Saul','','','','34','273727389','516 Massillon Rd',0,'Akron','OH','44306',NULL,'CY','39153','1972-02-22','M','M',':RET:2106-3','N','021','DEN','1713794','99734OH005000401','2014-01-01','2013-12-17 16:38:32','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:46:50'),(26840,21273,'N','19','021','EC','A',NULL,NULL,'','0002193502','0001870572','','IL','1','Calcagno','David','Joseph','','Jr','34','439852256','153 MIANO ST',0,'GARYVILLE','LA','70051','3218','CY','22095','1992-12-23','M','',':RET:2106-3','N','021','DEN','3707131','18575LA002000201','2014-03-01','2014-02-28 23:15:31',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-03-01 21:00:45'),(26215,20791,'Y','18','021','EC','A','','','AC','0001100595','0001100595','OH00003395351','IL','1','Estep','Rita','','','','34','268521717','125 MEDINA ST',0,'RITTMAN','OH','44270','1532','CY','39169','1950-08-24','F','M',':RET:2106-3','N','021','HLT','3050183','52664OH151001305','2014-03-01','2014-02-27 15:52:04','518.00',NULL,NULL,'658.32','140.32','R-OH014','OH0','658.32',NULL,0,'2014-02-28 06:30:55'),(26127,20720,'Y','18','021','EC','A','','','AC','0000560603','0000560603','OH00002810255','S3','1','TAYLOR','KATHLEEN','ELIZABETH','','','34','292064728','10250 MORTON ST',0,'BYESVILLE','OH','43723','9742','CY','39059','2002-01-02','M','U',NULL,'N','021','DEN','3407173','99734OH005000401','2014-04-01','2014-02-27 10:58:21','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','15.78',NULL,0,'2014-02-28 06:30:21'),(22726,18146,'N','19','021','EC','A',NULL,NULL,'','0001970837','0001367537','','S1','1','Berroa','Body','Marie','','','34','036649644','1526 London Cross Rd',0,'Harvey','LA','70058',NULL,'CY','22051','1995-07-06','F','',NULL,'N','021','DEN','3214343','18575LA002000201','2014-03-01','2014-02-11 13:54:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','38.22',NULL,0,'2014-02-11 21:01:13'),(6311,5006,'Y','18','021','EC','A','','','AC','0000057310','0000057310','OH00000656397','IL','1','VANLANDINGHAM','AMY','','','','34','290743095','430 E MAIN ST',0,'LEBANON','OH','45036','2234','CY','39165','1978-04-30','F','U',':RET:2106-3','N','021','DEN','1095715','99734OH005000401','2014-01-01','2013-12-11 10:42:55','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-26 00:46:10'),(17309,13843,'Y','18','021','EC','A','','','AC','0000168905','0000168905','TX00002439470','IL','1','mickelson','victoria','','','','34','467436230','4811 Timberview dr',0,'Sherman','TX','75090',NULL,'CY','48181','1967-08-06','F','U',':RET:2106-3','T','021','DEN','2362833','33348TX002000201','2014-02-01','2014-01-10 14:11:29','0.00',NULL,NULL,'15.85','15.85','R-TX020','TX0','15.85',NULL,0,'2014-01-13 02:23:43'),(9337,7401,'Y','18','021','EC','A','','','AC','0001280981','0001280981','LA00001181448','IL','1','Barber','Kenneth','','','','34','434049310','4971 PERTHSHIRE DR',0,'BATON ROUGE','LA','70817','1241','CY','22033','1958-10-24','M','U',':RET:2054-5','N','021','DEN','1588833','18575LA002000201','2014-01-01','2013-12-20 19:53:33','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 04:30:55'),(14305,11412,'Y','18','021','EC','A','','','AC','0000929847','0000929847','OH00000750777','IL','1','RIFE','CARMEN','','','','34','291841230','971 HOMEWOOD AVE SE',0,'WARREN','OH','44484','4908','CY','39155','1971-08-14','F','M',':RET:2054-5^:RET:2106-3','N','021','HLT','1611962','92036OH001003201','2014-02-01','2013-12-26 10:57:57','292.00',NULL,NULL,'750.69','458.69','R-OH013','OH0','386.87',NULL,0,'2013-12-27 02:06:57'),(22226,17741,'Y','18','021','EC','A','','','AC','0001775734','0001775734','LA00001720930','IL','1','Egan','Emily','','','','34','044748322','3529 LOUISIANA AVENUE PKWY',0,'NEW ORLEANS','LA','70125','3734','CY','22071','1981-08-07','F','U',':RET:2106-3','N','021','DEN','2652001','18575LA002000101','2014-03-01','2014-02-08 18:47:17','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-09 19:00:29'),(26622,21109,'Y','18','021','EC','A','','','AC','0000200559','0000200559','TX00003001371','IL','1','Carter','Dorothea','Lillie Hunter','','','34','451439447','3615 Rosedale St',0,'Houston','TX','77004',NULL,'CY','48201','1967-06-10','F','M',':RET:2054-5','N','021','DEN','3137373','33348TX002000201','2014-04-01','2014-02-28 12:35:59','0.00',NULL,NULL,'72.22','72.22','R-TX010','TX0','15.85',NULL,0,'2014-02-28 21:30:52'),(26480,21004,'Y','18','021','EC','A','','','AC','0001057309','0001057309','TX00003480743','IL','1','Kindle','Linda','','','','34','459157141','189 VZCR 1114',0,'Fruitvale','TX','75127',NULL,'CY','48467','1956-09-15','F','M',':RET:2106-3','N','021','DEN','3776386','33348TX002000201','2014-04-01','2014-02-28 16:03:00','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-02-28 21:00:03'),(3452,2776,'Y','18','024','14','A','','','TE','0000501608','0000501608','','IL','1','Hammond','Hope',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1984-04-23','F','',NULL,NULL,NULL,'','2273494','','2013-12-21','2013-12-21 22:04:52',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:19:33'),(26188,20768,'Y','18','021','EC','A','','','AC','0000552675','0000552675','OH00002884658','IL','1','Metcalf','Karen','','','','34','290768647','2685 SHEFFIELD RD',0,'JEFFERSON','OH','44047','9748','CY','39007','1964-12-05','F','R',':RET:2106-3','N','021','DEN','3685983','99734OH005000301','2014-04-01','2014-02-27 12:28:04','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-28 06:30:43'),(20088,16026,'Y','18','024','14','A','','','TE','0001492074','0001492074','','IL','1','DAVIS','Lenard',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-09-18','M','',NULL,NULL,NULL,'','1591186','','2014-01-27','2014-01-27 15:44:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-27 21:00:28'),(28547,22593,'Y','18','021','EC','A','','','AC','0000563203','0000563203','OH00003619497','IL','1','Pietz','Gabriela','','','','34','302064131','2234 DUNHAM ST',0,'TOLEDO','OH','43609','1639','CY','39095','1969-10-16','F','M',NULL,'N','021','HLT','3617594','92036OH005002606','2014-04-01','2014-03-07 11:25:55','221.00',NULL,NULL,'272.41','51.41','R-OH001','OH0','272.41',NULL,0,'2014-03-07 21:32:18'),(6581,5218,'Y','18','021','EC','A','','','AC','0000944845','0000944845','OH00000169996','IL','1','Steinspring','Stacy','','','','34','480940306','1400 Bernice ave',0,'Middletown','OH','45044',NULL,'CY','39017','1974-10-07','M','U',':RET:2106-3','T','021','HLT','1212953','92036OH003001205','2014-01-01','2013-12-10 21:07:20','141.00',NULL,NULL,'325.35','184.35','R-OH004','OH0','325.35',NULL,0,'2013-12-26 00:52:59'),(26303,20867,'Y','18','021','EC','A','','','AC','0000337656','0000337656','OH00002822195','IL','1','Arant','Daniel','','','','34','506230472','1799 FRAIL RD',0,'LIMA','OH','45806','1736','CY','39003','1987-11-16','M','U',':RET:2106-3','N','021','HLT','3074889','92036OH006001501','2014-03-01','2014-02-26 22:46:14','87.00',NULL,NULL,'178.73','91.73','R-OH002','OH0','178.73',NULL,0,'2014-02-28 06:31:30'),(3551,2850,'Y','18','021','EC','A','','','AC','0001166810','0001166810','OH00000607934','IL','1','Little','Amanda','','','','34','289683109','571 LETCHWORTH DR',0,'AKRON','OH','44303','1727','CY','39153','1975-08-28','F','U',':RET:2106-3','N','021','HLT','1390230','52664OH151001306','2014-01-01','2013-12-22 01:33:04','197.00',NULL,NULL,'277.87','80.87','R-OH012','OH0','277.87',NULL,0,'2013-12-25 21:22:01'),(16520,13216,'Y','18','021','EC','A','','','AC','0000327873','0000327873','TX00001485299','IL','1','Hays','Bradly','','','','34','410314480','5605 BUNNY TRL',0,'KILLEEN','TX','76549','4816','CY','48027','1972-12-23','M','U',':RET:2106-3','T','021','DEN','1823068','33348TX002000201','2014-02-01','2014-01-05 13:55:14','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,1,'2014-01-07 10:21:40'),(14935,11934,'N','01','021','EC','A',NULL,NULL,'','0000569321','0000383370','','IL','1','Jacobs','cynthia','','','','34','278564551','330 WELLESLEY WAY',0,'DAYTON','OH','45459','2931','CY','39113','1954-03-16','F','',':RET:2106-3','N','021','HLT','2192278','92036OH006000501','2014-02-01','2013-12-29 08:18:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','490.72',NULL,0,'2013-12-30 00:02:08'),(23252,18537,'Y','18','024','14','A','','','TE','0000574421','0000574421','','IL','1','BEVLY','CHARLOTTE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1950-06-23','F','',NULL,NULL,NULL,'','430853','','2014-02-28','2014-02-13 10:41:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-13 21:30:06'),(20729,16563,'Y','18','021','EC','A','','','AC','0000676747','0000676747','OH00001574503','IL','1','Prince','Marshall','','','','34','299761281','344 Silver St',0,'Akron','OH','44303',NULL,'CY','39153','1967-04-22','M','M',':RET:2054-5','N','021','HLT','3287722','52664OH152000901','2014-03-01','2014-01-29 20:23:33','503.00',NULL,NULL,'512.07','9.07','R-OH012','OH0','245.01',NULL,0,'2014-01-30 21:01:18'),(19909,15879,'Y','18','021','EC','A','','','AC','0000847175','0000847175','OH00001865307','IL','1','sturm','gary','','','','34','299524772','551 mohawk ave.',0,'akron','OH','44305',NULL,'CY','39153','1958-06-11','M','M',':RET:2106-3','N','021','HLT','1403862','52664OH151001501','2014-03-01','2014-01-24 17:12:46','414.00',NULL,NULL,'1142.08','728.08','R-OH012','OH0','596.45',NULL,0,'2014-01-24 21:00:59'),(28407,22477,'Y','18','021','EC','A','','','AC','0000115559','0000115559','OH00003449031','IL','1','Heskett','Shannon','','','','34','297606167','2956 TOWNSHIP ROAD 484',0,'COSHOCTON','OH','43812','9678','CY','39031','1963-08-15','F','U',':RET:2106-3','N','021','DEN','2862681','99734OH005000401','2014-04-01','2014-03-07 11:01:53','0.00',NULL,NULL,'15.78','15.78','R-OH016','OH0','0.00',NULL,0,'2014-03-07 21:30:55'),(5866,4655,'N','19','021','EC','A',NULL,NULL,'','0000858492','0000069077','','S1','1','Warnick','Matt','Ann','','','34','400791382','1520 N HAMETOWN RD',0,'AKRON','OH','44333','1058','CY','39153','2012-10-12','F','',':RET:2106-3','N','021','HLT','2518207','52664OH152000901','2014-01-01','2013-12-23 22:53:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,0,'2013-12-25 23:49:07'),(2927,2358,'N','01','021','EC','A',NULL,NULL,'','0000642051','0001161511','','IL','1','johnson','Antoinette','','','','34','292521519','620 BAURICHTER ST',0,'CINCINNATI','OH','45204','1142','CY','39061','1955-06-15','F','',':RET:2106-3','N','021','DEN','240090','99734OH005000401','2014-01-01','2013-12-06 18:12:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:55'),(21282,17008,'Y','18','021','EC','A','','','AC','0000687249','0000687249','OH00002305242','IL','1','Anderson','Terry','','','','34','284706196','2753 CEDARVILLE RD',0,'GOSHEN','OH','45122','9420','CY','39025','1961-09-20','F','M',NULL,'N','021','HLT','2825346','92036OH004000601','2014-03-01','2014-02-03 17:47:34','284.00',NULL,NULL,'336.93','52.93','R-OH005','OH0','336.93',NULL,0,'2014-02-03 21:01:38'),(18517,14765,'Y','18','021','EC','A','','','AC','0000293476','0000293476','TX00002049004','IL','1','Hill','Alexander','','','','34','464883963','1302 Jefferson Street',0,'Plainview','TX','79072',NULL,'CY','48189','1957-05-04','M','U',':RET:2106-3','T','021','DEN','2014834','33348TX002000101','2014-02-01','2014-01-14 21:16:58','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-16 08:46:36'),(18173,14511,'Y','18','021','EC','A','','','AC','0000284429','0000284429','OH00002543375','IL','1','Peiples','Michael','','','','34','293749263','24 FAIRWOOD AVE',0,'NORWALK','OH','44857','2381','CY','39077','1966-05-17','M','M',':RET:2106-3','N','021','HLT','2036130','92036OH005002705','2014-02-01','2014-01-14 11:30:20','367.00',NULL,NULL,'546.18','179.18','R-OH006','OH0','304.78',NULL,0,'2014-01-15 02:07:58'),(28701,22714,'Y','18','021','EC','A','','','AC','0000662760','0000662760','OH00003250149','IL','1','Flory','Vicki','','','','34','289581610','639 Township Road 1041',0,'Nova','OH','44859',NULL,'CY','39005','1956-03-30','F','U',':RET:2106-3','N','021','HLT','3076647','52664OH151001305','2014-04-01','2014-03-08 10:00:49','488.00',NULL,NULL,'568.22','80.22','R-OH012','OH0','568.22',NULL,0,'2014-03-08 21:31:09'),(6565,5204,'Y','18','021','EC','A','','','AC','0000427147','0000427147','TX00000342811','IL','1','RINGENER','JAMES','PHILIP','','','34','457214853','2609 WASSON RD',0,'BIG SPRING','TX','79720',NULL,'CY','48227','1958-10-14','M','U',':RET:2106-3','T','021','DEN','460020','33348TX002000201','2014-01-01','2013-12-11 13:57:56','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-26 00:52:31'),(13899,11085,'N','19','021','EC','A',NULL,NULL,'','0000087482','0000043225','','IL','1','Mckenzie','Brian','Adam','','','34','374156562','104 Cove Ln',0,'Rossford','OH','43460',NULL,'CY','39173','1992-10-11','M','',':RET:2106-3','N','021','HLT','2246747','92036OH006002601','2014-01-01','2013-12-22 23:16:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','154.64',NULL,0,'2013-12-26 13:13:38'),(7403,5858,'Y','18','021','EC','A','','','AC','0000139247','0000139247','TX00000388926','IL','1','Sharp','Kimberly','','','','34','493982225','2610 ASH HAVEN LN',0,'KATY','TX','77449','6786','CY','48201','1988-09-28','F','U',':RET:2054-5','N','021','DEN','755689','33348TX002000101','2014-01-01','2013-11-23 14:25:38','0.00',NULL,NULL,'27.15','27.15','R-TX010','TX0','27.15',NULL,0,'2013-12-26 02:16:28'),(20394,16291,'Y','18','021','EC','A','','','AC','0000807338','0000807338','TX00002336346','IL','1','Tran','Marianna','','','','34','580184088','11963 Silver Island Circle',0,'Houston','TX','77067',NULL,'CY','48201','1957-02-19','F','U',':RET:2047-9','N','021','DEN','2954975','33348TX002000201','2014-03-01','2014-01-29 12:26:03','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2014-01-29 21:00:17'),(17059,13652,'Y','18','021','EC','A','','','AC','0001240422','0001240422','TX00001989857','IL','1','Martinez','Rebeca','','','','34','457617491','10404 CANDLEWOOD AVE',0,'EL PASO','TX','79925','7912','CY','48141','1952-08-28','F','U',':RET:2106-3','N','021','DEN','1392965','33348TX002000201','2014-02-01','2014-01-07 19:30:12','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2014-01-13 02:21:10'),(15764,12614,'Y','18','021','EC','A','','','AC','0000327865','0000327865','TX00002025833','IL','1','MAGALLON','JAIME','ARTURO','','','34','607228922','1807 HOLLAND STREET',0,'HOUSTON','TX','77029',NULL,'CY','48201','1959-06-26','M','U',NULL,'N','021','DEN','1599718','33348TX002000201','2014-02-01','2014-01-02 13:07:10','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-03 02:01:36'),(15505,12406,'Y','18','021','EC','A','','','AC','0000307107','0000307107','OH00000067083','IL','1','DROKE','SUSAN','','','','34','270888910','2289 VENICE BLVD',0,'FAIRFIELD','OH','45014',NULL,'CY','39017','1980-09-17','F','M',':RET:2106-3','T','021','DEN','2085032','99734OH005000401','2014-02-01','2013-12-31 14:37:00','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,1,'2014-01-02 04:29:51'),(22388,17877,'Y','18','021','EC','A','','','AC','0000077602','0000077602','OH00002592099','IL','1','MARRAS','MICHAEL','','','','34','277904281','273 EAST  WILBETH',0,'AKRON','OH','44301',NULL,'CY','39153','1983-08-07','M','U',NULL,'N','021','HLT','2824060','52664OH151001305','2014-03-01','2014-02-10 12:13:00','145.00',NULL,NULL,'253.11','108.11','R-OH012','OH0','253.11',NULL,0,'2014-02-10 21:30:13'),(20025,15970,'N','01','021','EC','A',NULL,NULL,'','0001624876','0001157747','','IL','1','Britton','Lillian','Marie','','','34','438080858','3400 CLAIBORNE AVE',0,'METAIRIE','LA','70001','5812','CY','22051','1959-07-11','F','',':RET:2054-5','T','021','DEN','3305760','18575LA002000201','2014-03-01','2014-01-25 22:20:10',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-01-26 19:00:17'),(28488,22541,'Y','18','021','EC','A','','','AC','0000577379','0000577379','OH00002921858','IL','1','WILLIAMS','TAMARA','','','','34','274866334','5539 COUNTY ROAD 20.50',0,'STRYKER','OH','43557',NULL,'CY','39171','1975-08-16','F','U',':RET:2106-3','N','021','DEN','2793067','99734OH005000301','2014-04-01','2014-03-07 16:52:08','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-03-07 21:31:39'),(16371,13100,'N','01','021','EC','A',NULL,NULL,'','0000071699','0000543833','','IL','1','Wingfield','Richard','Bryan','','','34','449113102','4200 SCOTLAND ST',0,'HOUSTON','TX','77007',NULL,'CY','48201','1960-02-22','M','',':RET:2106-3','N','021','DEN','1673024','33348TX002000101','2014-02-01','2014-01-06 12:32:14',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-01-07 04:03:02'),(27550,21792,'Y','18','021','EC','A','','','AC','0000673739','0000673739','TX00003514105','IL','1','Davila','Delila','Lisa','','','34','641010797','804 Kennedy st',0,'Alice','TX','78332',NULL,'CY','48249','1988-09-08','F','U',NULL,'N','021','DEN','2940844','33348TX002000201','2014-04-01','2014-03-03 20:29:12','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61','CIC',0,'2014-03-04 21:30:11'),(26650,21128,'N','01','021','EC','A',NULL,NULL,'','0000672817','0000965830','','IL','1','Kroh','MaryLynn','','','','34','295668276','813  N. Main St.',0,'North Canton','OH','44720',NULL,'CY','39151','1962-05-18','F','',':RET:2106-3','N','021','HLT','3047338','52664OH151001305','2014-03-01','2014-02-28 11:49:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2014-02-28 21:31:07'),(5933,4697,'Y','18','021','EC','A','','','AC','0002330858','0002330858','LA00000025564','IL','1','Kelly','Marguerite','','','','34','251022755','19721 W PINEY POINT AVE',0,'BATON ROUGE','LA','70817','2740','CY','22033','1952-07-24','F','U',':RET:2106-3','N','021','DEN','1382047','18575LA002000101','2014-01-01','2013-12-23 21:48:49','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2013-12-25 23:50:34'),(24518,19476,'N','01','021','EC','A',NULL,NULL,'','0000882618','0000101071','','IL','1','VERDUGO','ENRIQUE','','','','34','524212945','11701 CANARY PALM CT',0,'EL PASO','TX','79936',NULL,'CY','48141','1976-09-27','M','',NULL,'N','021','DEN','2881620','33348TX002000201','2014-04-01','2014-02-19 12:53:00',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-02-20 03:55:58'),(8863,7027,'Y','18','021','EC','A','','','AC','0000375342','0000375342','TX00000863447','IL','1','Jenkins','Beverly',NULL,NULL,NULL,NULL,NULL,'5002 Bowie',0,'Amarillo','TX','79110',NULL,'CY','48381','1949-11-02','F','U',':RET:2106-3','T','021','DEN','1981291','33348TX002000201','2014-01-01','2013-12-18 12:31:04','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 04:01:20'),(4479,3554,'Y','18','021','EC','A','','','AC','0000500368','0000500368','OH00001091160','31','1','Bodi','Amanda','','','','34','300906228','PO Box 313',0,'Castalia','OH','44824',NULL,'CY','39043','1987-11-13','F','M',':RET:2106-3','N','021','DEN','1233808','99734OH005000301','2014-01-01','2013-12-12 15:00:19','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-25 22:02:55'),(4156,3312,'Y','18','024','14','A','','','TE','0000930898','0000930898','','IL','1','NAKKA','COTTON',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1976-04-24','M','',NULL,NULL,NULL,'','1476001','','2013-12-17','2013-12-17 15:18:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:48:54'),(15431,12345,'Y','18','021','EC','A','','','AC','0000082256','0000082256','TX00001517553','IL','1','HARRISON','LINDA','FAY','','','34','465083190','6627 BRITTANY FERRY LN',0,'HOUSTON','TX','77049','1652','CY','48201','1957-10-26','F','M',':RET:2054-5','N','021','DEN','2040927','33348TX002000201','2014-02-01','2013-12-31 12:10:21','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,1,'2014-01-02 04:27:44'),(6159,4883,'Y','18','021','EC','A','','','AC','0000005162','0000005162','MS00000807509','IL','1','Bryant','Asa','','','','34','587543807','31 CANAL DR',0,'HATTIESBURG','MS','39402','2926','CY','28073','1956-12-29','M','U',':RET:2106-3','N','021','DEN','1039447','46300MS002000201','2014-01-01','2013-11-21 17:51:01','0.00',NULL,NULL,'15.85','15.85','R-MS004','MS0','15.85',NULL,0,'2013-12-26 00:16:42'),(20213,16128,'Y','18','021','EC','A','','','AC','0001165368','0001165368','OH00001549848','IL','1','coakley','richard','','','','34','283562682','1293 opal st.',0,'toledo','OH','43614',NULL,'CY','39095','1955-01-18','M','U',NULL,'N','021','HLT','1916649','92036OH003002601','2014-03-01','2014-01-27 12:12:27','195.00',NULL,NULL,'530.07','335.07','R-OH001','OH0','530.07',NULL,0,'2014-01-27 21:01:39'),(17678,14127,'Y','18','021','EC','A','','','AC','0002280100','0002280100','LA00001463514','IL','1','Richards','Robert','','','','34','415373471','727 SPAIN ST',0,'NEW ORLEANS','LA','70117','7822','CY','22071','1970-11-28','M','U',':RET:2106-3','N','021','DEN','2694099','18575LA002000101','2014-02-01','2014-01-13 13:34:48','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-14 01:32:53'),(17663,14115,'N','19','021','EC','A',NULL,NULL,'','0001128018','0000756025','','IL','1','Hussein','Anwar','','','','34','230750628','4689 CRYSTAL LAKE DR',0,'HILLIARD','OH','43026','2824','CY','39049','1996-02-22','M','',':RET:2054-5','N','021','DEN','2598500','99734OH005000301','2014-02-01','2014-01-13 15:18:53',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-14 01:32:46'),(7334,5808,'N','01','021','EC','A',NULL,NULL,'','0000491858','0000717812','','IL','1','Maus','Rena','Lea','','','34','277783876','822 BOLENDER RD',0,'MOSCOW','OH','45153','9650','CY','39025','1981-04-14','F','',':RET:2106-3','N','021','HLT','711943','92036OH003000601','2014-01-01','2013-12-14 14:54:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','265.21',NULL,0,'2013-12-26 02:03:51'),(7382,5845,'N','19','021','EC','A',NULL,NULL,'','0001233017','0000138974','','IL','1','Cameron','Ethan',NULL,NULL,NULL,NULL,NULL,'735 AMBERLY DR',0,'HAMILTON','OH','45013','3458','CY','39017','2004-05-28','M','',':RET:2106-3','N','021','DEN','914454','99734OH005000401','2014-01-01','2013-11-23 10:53:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 02:15:58'),(14440,11517,'Y','18','021','EC','A','','','AC','0001572264','0001572264','LA00000804564','IL','1','Shalett','Monte','','','','34','437510088','115 Sherwood Forest Dr',0,'New Orleans','LA','70119',NULL,'CY','22071','1983-05-21','M','U',':RET:2106-3','N','021','DEN','1688549','18575LA002000201','2014-02-01','2013-12-27 11:39:50','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-28 03:32:09'),(5684,4510,'Y','18','024','14','A','','','TE','0001235138','0001235138','','IL','1','Whitaker','Antwon','D','','Sr',NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1989-10-16','M','',NULL,NULL,NULL,'','570024','','2013-11-26','2013-11-26 12:52:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:32:24'),(24534,19488,'Y','18','021','EC','A','','','AC','0001455054','0001455054','LA00002189017','IL','1','LASSITTER','JAMES','','','','34','263338620','5510 LA 44',0,'CONVENT','LA','70723','2114','CY','22093','1955-10-19','M','M',':RET:2106-3','T','021','DEN','2620043','18575LA002000101','2014-04-01','2014-02-18 19:48:16','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-02-20 04:00:56'),(23219,18510,'Y','18','021','EC','A','','','AC','0000600452','0000600452','MS00001539768','IL','1','Starnes','Diana','','','','34','413966313','5625 MAXWELL DR',0,'OLIVE BRANCH','MS','38654','9611','CY','28033','1954-06-11','F','M',':RET:2106-3','N','021','DEN','2736810','46300MS002000201','2014-03-01','2014-02-12 12:35:45','0.00',NULL,NULL,'31.70','31.70','R-MS001','MS0','15.85',NULL,0,'2014-02-12 21:32:18'),(20680,16525,'N','19','021','EC','A',NULL,NULL,'','0000167726','0001070350','','IL','1','Hassan','Hamza','','','','34','633131112','643 LEAFY RDG',0,'SAN ANTONIO','TX','78251','4251','CY','48029','2007-12-14','M','',NULL,'N','021','DEN','3626848','33348TX002000101','2014-03-01','2014-01-29 19:08:53',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','44.55',NULL,0,'2014-01-30 21:00:54'),(4235,3372,'Y','18','021','EC','A','','','AC','0000499562','0000499562','TX00001303881','IL','1','Rodriguez','Gloria','','','','34','466889997','274 COUNTY ROAD 125',0,'RIESEL','TX','76682','2939','CY','48145','1952-10-15','F','M',':RET:2106-3','N','021','DEN','1786692','33348TX002000201','2014-01-01','2013-12-17 14:04:22','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:50'),(14070,11212,'Y','18','021','EC','A','','','AC','0000837701','0000837701','OH00001177873','IL','1','Ryan','Annette','','','','34','297606758','5896 TWIN LAKES DR',0,'PARMA','OH','44129','3506','CY','39035','1963-04-07','F','U',':RET:2106-3','N','021','DEN','2493521','99734OH005000401','2014-02-01','2013-12-26 09:38:10','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-27 02:00:49'),(7993,6325,'N','01','021','EC','A',NULL,NULL,'','0000563130','0001246926','','IL','1','Hockstra','Jennifer','','','','34','278744194','3170 BENT OAK TRL',0,'RAVENNA','OH','44266','8285','CY','39133','1978-09-20','F','',NULL,'N','021','HLT','2591260','52664OH151001304','2014-01-01','2013-12-20 15:06:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','272.52',NULL,0,'2013-12-26 03:08:11'),(18115,14468,'Y','18','021','EC','A','','','AC','0001105560','0001105560','OH00001902758','IL','1','FLYNN','KATHLEEN','','','','34','278503006','9257 COUNTY ROAD 35',0,'MILLERSBURG','OH','44654','9637','CY','39075','1951-01-06','F','U',':RET:2106-3','N','021','HLT','1466891','52664OH152000901','2014-02-01','2014-01-14 09:53:11','0.00',NULL,NULL,'482.18','482.18','R-OH014','OH0','482.18',NULL,0,'2014-01-15 02:07:38'),(3328,2670,'Y','18','021','EC','A','','','AC','0000787182','0000787182','OH00000524314','IL','1','McClelland','James','','','Sr','34','286503924','925 STARK ST',0,'SHEFFIELD LAKE','OH','44054','2007','CY','39093','1952-12-05','M','M',NULL,'N','021','DEN','1901022','99734OH005000301','2014-01-01','2013-12-22 17:13:14','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:16:13'),(27665,21882,'N','01','021','EC','A',NULL,NULL,'','0000041009','0000889667','','IL','1','Wagner','Liane','M','','','34','532727803','3943 OLD TROY PIKE',0,'DAYTON','OH','45404','1322','CY','39113','1961-08-21','F','',':RET:1002-5^:RET:2106-3','N','021','DEN','3858427','99734OH005000401','2014-05-01','2014-03-05 16:27:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-05 21:30:29'),(16579,13261,'Y','18','021','EC','A','','','AC','0001178465','0001178465','LA00001399512','IL','1','Heckard','Charles','','','','34','439928167','2608 MAY ST',0,'MONROE','LA','71202','3241','CY','22073','1955-08-08','M','U',':RET:2054-5','N','021','DEN','1944813','18575LA002000201','2014-02-01','2014-01-06 18:35:51','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-01-08 18:23:56'),(13169,10505,'Y','18','021','EC','A','','','AC','0000574448','0000574448','OH00001305437','IL','1','tyler','alonzo','','','','34','271583616','4512 catlin drive',0,'richmond heights','OH','44143',NULL,'CY','39035','1956-08-06','M','M',':RET:2054-5','N','021','DEN','1768957','99734OH005000401','2014-01-01','2013-12-23 18:34:50','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2013-12-26 12:54:02'),(23410,18652,'Y','18','021','EC','A','','','AC','0000673739','0000673739','TX00002763676','IL','1','Davila','Delila','','','','34','641010797','804 Kennedy st',0,'Alice','TX','78332',NULL,'CY','48249','1988-09-08','F','U',NULL,'N','021','DEN','3771543','33348TX002000201','2014-03-01','2014-02-12 19:23:55','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:15'),(23427,18665,'N','19','021','EC','A',NULL,NULL,'','0000520158','0000694981','','IL','1','Tippett','Rory','','','','34','074995028','210 ORCHARD DR',0,'ODESSA','TX','79764','6841','CY','48135','2012-12-23','M','',':RET:2106-3','N','021','DEN','3314793','33348TX002000201','2014-03-01','2014-02-13 07:35:42',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','38.22',NULL,0,'2014-02-13 22:01:26'),(850,704,'Y','18','021','EC','A','','','AC','0000737843','0000737843','OH00000333217','IL','1','Hanna','Amy','','','','34','295844922','24455 LAKE SHORE BLVD',0,'EUCLID','OH','44123','4405','CY','39035','1970-11-01','F','U',':RET:2106-3','N','021','HLT','1097028','52664OH152000901','2014-01-01','2013-12-15 23:46:10','0.00',NULL,NULL,'249.99','249.99','R-OH011','OH0','249.99',NULL,0,'2013-12-25 18:06:52'),(27102,21454,'Y','18','021','EC','A','','','AC','0000199730','0000199730','OH00001984934','IL','1','McGuire','Timothy','','','','34','300860217','313 Michael Ave.',0,'Hamilton','OH','45011',NULL,'CY','39017','1980-12-03','M','M',':RET:2106-3','N','021','DEN','3920518','99734OH005000301','2014-04-01','2014-03-03 09:37:08','0.00',NULL,NULL,'42.26','42.26','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:22'),(14759,11784,'Y','18','021','EC','A','','','AC','0000739990','0000739990','TX00000368450','IL','1','Bhatkar','Navina','','','','34','464879633','2913 RAYADO CT S',0,'COLLEGE STATION','TX','77845','7715','CY','48041','1981-03-24','F','U',':RET:2029-7^:RET:2106-3','N','021','DEN','1695929','33348TX002000201','2014-01-01','2013-12-23 20:09:07','0.00',NULL,NULL,'14.61','14.61','R-TX006','TX0','14.61',NULL,1,'2013-12-29 11:12:38'),(26047,20657,'Y','18','021','EC','A','','','AC','0000794564','0000794564','OH00003047419','IL','1','Garrett','Stephanie','','','','34','287901843','8907 FAIRPARK AVE NW',0,'CANAL FULTON','OH','44614','9683','CY','39151','1987-07-26','F','U',':RET:2106-3','N','021','HLT','3138870','52664OH151001305','2014-04-01','2014-02-26 16:37:41','123.00',NULL,NULL,'228.36','105.36','R-OH015','OH0','228.36',NULL,0,'2014-02-26 21:02:30'),(21509,17184,'Y','18','021','EC','A','','','AC','0000108194','0000108194','OH00001652528','IL','1','SINGIAN','ANTHONY','','','','34','291969648','1195 BIKINI DR',0,'LIMA','OH','45801','2412','CY','39003','1955-06-12','M','U',':RET:2036-2','N','021','HLT','2935616','92036OH004001501','2014-03-01','2014-02-04 15:39:46','400.00',NULL,NULL,'450.90','50.90','R-OH002','OH0','450.90',NULL,0,'2014-02-04 21:01:57'),(5850,4646,'Y','18','021','EC','A','','','AC','0000102305','0000102305','TX00001173908','IL','1','HINOJOSA','BLANCA','','','','34','463080093','7627 SPRINGWOOD DR',0,'EL PASO','TX','79925','7631','CY','48141','1954-12-28','F','U',NULL,'N','021','DEN','2330893','33348TX002000201','2014-01-01','2013-12-24 00:36:33','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 23:48:46'),(18828,14996,'Y','18','021','EC','A','','','AC','0000344102','0000344102','MS00001705668','IL','1','GEORGE','WANDA','','','','34','426197926','3614 MACPHELAH RD',0,'MOSS POINT','MS','39563','5944','CY','28059','1961-04-17','F','U',NULL,'T','021','DEN','2706438','46300MS002000201','2014-03-01','2014-01-16 12:05:42','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-01-17 03:36:08'),(5620,4460,'Y','18','021','EC','A','','','AC','0000577287','0000577287','OH00000361458','IL','1','Rosfeld','Baylee','Nicole','','','34','290964645','61 N MAIN ST',0,'WEST ALEXANDRIA','OH','45381','1153','CY','39135','1993-11-05','F','U',':RET:2106-3','N','021','DEN','1166911','99734OH005000401','2014-01-01','2013-11-26 14:49:49','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','15.78',NULL,0,'2013-12-25 23:30:45'),(1433,1195,'Y','18','021','EC','A','','','AC','0002026458','0002026458','LA00001454752','IL','1','Fasano','Maria','','','','34','490824404','8228 SYCAMORE PL',0,'NEW ORLEANS','LA','70118','2939','CY','22071','1976-02-06','F','M',NULL,'T','021','DEN','2148624','18575LA002000201','2014-01-01','2013-12-24 17:38:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:37'),(26733,21188,'Y','18','021','EC','A','','','AC','0000739075','0000739075','OH00003157334','IL','1','hughes','debra','','','','34','268729954','623 SOUTH ST',0,'FINDLAY','OH','45840','5927','CY','39063','1974-07-10','F','M',':RET:2106-3','N','021','HLT','2713469','92036OH004001501','2014-04-01','2014-02-28 12:50:17','397.00',NULL,NULL,'463.47','66.47','R-OH002','OH0','223.33',NULL,0,'2014-02-28 21:31:50'),(25937,20568,'Y','18','021','EC','A','','','AC','0000845964','0000845964','TX00002483851','IL','1','HICKMAN','NORMA','','','','34','643021473','4705 ALAMO CT',0,'GRAND PRAIRIE','TX','75052','1704','CY','48113','1974-10-11','F','U',NULL,'N','021','DEN','3399334','33348TX002000201','2014-04-01','2014-02-26 16:58:30','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-02-26 21:01:29'),(9236,7328,'Y','18','024','14','A','','','TE','0001026926','0001026926','','IL','1','RINELLA','MICHAEL','ANTHONY',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1992-11-12','M','',NULL,NULL,NULL,'','1774825','','2013-12-18','2013-12-18 15:14:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 04:10:35'),(27732,21930,'Y','18','021','EC','A','','','AC','0000913838','0000913838','TX00003042494','IL','1','GARCIA','JAIME','','','','34','525040905','4250 LOMA ROSADA DR',0,'EL PASO','TX','79934','3772','CY','48141','1962-05-12','M','M',NULL,'N','021','DEN','2887893','33348TX002000201','2014-04-01','2014-03-05 16:14:18','0.00',NULL,NULL,'29.22','29.22','R-TX009','TX0','14.61',NULL,0,'2014-03-05 21:31:04'),(14564,11619,'N','01','021','EC','A',NULL,NULL,'','0000578790','0000563139','','IL','1','Barnett','Ronald','','','','34','290501235','3974 Colony Rd',0,'South Euclid','OH','44118',NULL,'CY','39035','1952-03-15','M','',':RET:2054-5','N','021','HLT','1756668','52664OH152000901','2014-02-01','2013-12-27 12:46:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','517.67',NULL,0,'2013-12-28 03:35:20'),(21454,17145,'Y','18','021','EC','A','','','AC','0001104484','0001104484','OH00002098472','IL','1','Ford','Crystal','','','','34','294561447','865 PEERLESS AVE',0,'AKRON','OH','44320','2821','CY','39153','1956-12-24','F','U',':RET:2054-5','N','021','HLT','3451636','52664OH151001305','2014-03-01','2014-02-04 12:15:19','384.00',NULL,NULL,'543.47','159.47','R-OH012','OH0','543.47',NULL,0,'2014-02-04 21:01:30'),(21010,16788,'Y','18','024','14','A','','','TE','0001067016','0001067016','','IL','1','Le','Tien',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-11-12','M','',NULL,NULL,NULL,'','3406537','','2014-02-01','2014-02-01 01:30:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-01 19:00:34'),(808,668,'Y','18','021','EC','A','','','AC','0000619624','0000619624','OH00000864595','IL','1','VELEZ','CHERYL','','','','34','302588483','5200 REED AVE',0,'ASHTABULA','OH','44004',NULL,'CY','39007','1956-11-22','F','M',':RET:2106-3','N','021','HLT','704751','52664OH151001305','2014-01-01','2013-12-15 19:46:54','515.00',NULL,NULL,'612.95','97.95','R-OH011','OH0','612.95',NULL,0,'2013-12-25 18:05:44'),(19937,15901,'Y','18','024','14','A','','','TE','0001074115','0001074115','','IL','1','Fisher','Colleen',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-06-09','F','',NULL,NULL,NULL,'','558510','','2014-01-24','2014-01-24 09:24:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-24 21:01:12'),(2718,2198,'Y','18','021','EC','A','','','AC','0000866223','0000866223','LA00000327794','IL','1','johnson','brenda','sue','','','34','434901494','740 alexandria hwy',0,'leesville','LA','71446',NULL,'CY','22115','1951-12-17','F','M',':RET:2106-3','N','021','DEN','1031697','18575LA002000201','2014-01-01','2013-12-01 19:00:10','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2013-12-25 19:48:07'),(2742,2219,'N','01','021','EC','A',NULL,NULL,'','0000616838','0000825881','','IL','1','christy','frank','','','','34','269803450','7366 West Lake Blvd',0,'Kent','OH','44240',NULL,'CY','39133','1966-12-08','M','',':RET:2106-3','N','021','HLT','181923','52664OH152000901','2014-01-01','2013-12-02 09:17:12',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','255.30',NULL,0,'2013-12-25 19:48:49'),(3606,2889,'N','01','021','EC','A',NULL,NULL,'','0000309439','0000282006','','IL','1','Haven','Mary','','','','34','272684703','5992 HEYL RD',0,'WOOSTER','OH','44691','7454','CY','39169','1965-01-11','F','',NULL,'T','021','HLT','1869103','52664OH152000901','2014-01-01','2013-12-22 12:30:16',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','307.12',NULL,0,'2013-12-25 21:23:21'),(6423,5093,'Y','18','021','EC','A','','','AC','0000250188','0000250188','LA00000284808','IL','1','Morgan','Anne','','','','34','435532635','48011A LAURA ROGERS RD',0,'TICKFAW','LA','70466','5101','CY','22105','1978-09-22','F','M',':RET:2106-3','N','021','DEN','482932','18575LA002000201','2014-01-01','2013-12-10 20:50:53','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-26 00:48:57'),(5985,4737,'Y','18','021','EC','A','','','AC','0000006989','0000006989','OH00001441383','IL','1','Oberhaus','Anthony','','','','34','277866182','R493 COUNTY ROAD 8',0,'NAPOLEON','OH','43545','6947','CY','39069','1982-09-14','M','U',':RET:2106-3','N','021','HLT','1587949','92036OH003002605','2014-01-01','2013-12-24 00:44:16','101.00',NULL,NULL,'236.02','135.02','R-OH001','OH0','236.02',NULL,0,'2013-12-25 23:52:02'),(7223,5725,'Y','18','021','EC','A','','','AC','0000356028','0000356028','OH00000539934','IL','1','Mest','Gary','','','Jr','34','175709668','403 N LYMAN ST',0,'WADSWORTH','OH','44281','1824','CY','39103','1983-09-09','M','M',':RET:2106-3','T','021','DEN','210289','99734OH005000401','2014-01-01','2013-12-14 13:55:54','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-26 02:01:11'),(26646,21127,'N','19','021','EC','A',NULL,NULL,'','0000759761','0000091211','','IL','1','Torres','Gustavo','G','','','34','293114123','4523 Vista Circle',0,'Kent','OH','44240',NULL,'CY','39133','2006-02-14','M','',NULL,'N','021','HLT','2980732','52664OH151001304','2014-04-01','2014-02-28 10:31:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-28 21:31:05'),(1972,1611,'Y','18','021','EC','A','','','AC','0000557752','0000557752','TX00001052147','IL','1','Carter','Eddie','','','','34','430021241','1211 MANCHESTER DR',0,'MANSFIELD','TX','76063','7581','CY','48439','1953-05-14','M','M',':RET:2054-5','N','021','DEN','149271','33348TX002000101','2014-01-01','2013-11-19 23:01:07','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-25 19:01:30'),(21055,16822,'Y','18','021','EC','A','','','AC','0001787704','0001787704','LA00001664742','IL','1','Thomas','Jennifer','','','','34','107701529','252 RIVERWOOD DR',0,'HOUMA','LA','70360','7984','CY','22109','1983-08-30','F','M',':RET:2029-7','N','021','DEN','3243804','18575LA002000201','2014-03-01','2014-02-01 21:03:10','0.00',NULL,NULL,'14.61','14.61','R-LA002','LA0','14.61',NULL,0,'2014-02-02 19:00:08'),(20000,15953,'Y','18','021','EC','A','','','AC','0000354005','0000354005','OH00002403552','IL','1','Pieffer','Jaclyn','','','','34','302866687','3881 W 227TH ST',0,'FAIRVIEW PARK','OH','44126','1031','CY','39035','1977-09-21','F','M',':RET:2106-3','N','021','DEN','2594871','99734OH005000401','2014-03-01','2014-01-26 11:43:55','0.00',NULL,NULL,'71.95','71.95','R-OH011','OH0','0.00',NULL,0,'2014-01-26 19:00:04'),(7499,5931,'Y','18','024','14','A','','','TE','0000690707','0000690707','','IL','1','Sarisky','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-05-03','M','',NULL,NULL,NULL,'','1130861','','2013-12-15','2013-12-15 15:21:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 02:31:47'),(2587,2103,'Y','18','021','EC','A','','','AC','0000666739','0000666739','OH00001295672','IL','1','ESTEP','ELLEN','L','','','34','274642702','1110 SOUTHRIDGE AVE',0,'WILMINGTON','OH','45177','2934','CY','39027','1951-02-14','F','M',':RET:2106-3','N','021','HLT','833410','92036OH003000605','2014-01-01','2013-12-09 18:02:59','477.00',NULL,NULL,'644.07','167.07','R-OH005','OH0','644.07',NULL,0,'2013-12-25 19:38:11'),(24056,19131,'N','17','021','EC','A',NULL,NULL,'','0000558192','0000824635','','IL','1','BEGLEY','MICHELE','','','','34','295968809','4238 WILLIAMSPORT DR',0,'BEAVERCREEK','OH','45430','1837','CY','39057','1994-02-17','F','',':RET:2106-3','N','021','DEN','3143301','99734OH005000301','2014-03-01','2014-02-14 20:03:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-15 22:01:07'),(2685,2175,'Y','18','021','EC','A','','','AC','0000769453','0000769453','TX00000512766','IL','1','Spencer','Michael','','','','34','575234780','54 Rainey Street',0,'Austin','TX','78701',NULL,'CY','48453','1969-07-06','M','U',':RET:2039-6^:RET:2106-3','T','021','DEN','1087660','33348TX002000201','2014-01-01','2013-12-01 19:04:32','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-25 19:47:20'),(5739,4555,'N','01','021','EC','A',NULL,NULL,'','0002277331','0002163480','','IL','1','cleveland','shawn','','','','34','336582324','13564 NEIL AVE',0,'BATON ROUGE','LA','70810','5137','CY','22033','1973-08-15','M','',':RET:2106-3','N','021','DEN','2203223','18575LA002000201','2014-01-01','2013-12-23 23:38:34',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 23:45:54'),(15405,12322,'Y','18','021','EC','A','','','AC','0000173864','0000173864','TX00001626553','IL','1','Jenkins','Manuel','Edward','','','34','567761352','410 PECOS ST',0,'ODESSA','TX','79761','6815','CY','48135','1951-08-25','M','M',NULL,'N','021','DEN','2100358','33348TX002000201','2014-02-01','2013-12-30 20:18:12','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,1,'2014-01-02 04:26:54'),(15548,12441,'Y','18','021','EC','A','','','AC','0001752764','0001752764','LA00000974305','IL','1','Anderson','Steven','','','','34','476847471','1032 gallier',0,'new orleans','LA','70117',NULL,'CY','22071','1964-06-11','M','U',':RET:2106-3','T','021','DEN','1452057','18575LA002000201','2014-02-01','2013-12-31 16:03:36','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,1,'2014-01-02 04:31:11'),(27853,22029,'N','01','021','EC','A',NULL,NULL,'','0000509118','0001203021','','IL','1','FLORES','JUAN','JAVIER','','','34','561110834','2511 E 28TH ST',0,'MISSION','TX','78574','1979','CY','48215','1967-02-19','M','',NULL,'N','021','DEN','3326083','33348TX002000101','2014-04-01','2014-03-05 14:36:02',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','25.02',NULL,0,'2014-03-05 21:32:13'),(1048,860,'Y','18','021','EC','A','','','AC','0000399383','0000399383','TX00000156334','IL','1','tran','catina','chau','','','34','680683111','4666 University ave',0,'Wichita falls','TX','76308',NULL,'CY','48485','1977-03-02','F','M',':RET:2047-9','N','021','DEN','168363','33348TX002000201','2014-01-01','2013-12-03 12:10:31','0.00',NULL,NULL,'31.70','31.70','R-TX025','TX0','15.85',NULL,0,'2013-12-25 18:15:58'),(4824,3823,'Y','18','021','EC','A','','','AC','0000783200','0000783200','OH00000846420','IL','1','Drake','Joan','','','','34','381485881','6800 KRISTI LYNNE LN',0,'TOLEDO','OH','43617','1279','CY','39095','1956-08-25','F','M',':RET:2106-3','N','021','HLT','30044','92036OH005002601','2014-01-01','2013-12-08 12:53:24','0.00',NULL,NULL,'950.42','950.42','R-OH001','OH0','475.21',NULL,0,'2013-12-25 22:17:11'),(19613,15632,'Y','18','021','EC','A','','','AC','0000350602','0000350602','OH00002192299','IL','1','Moore','Gloria','','','','34','283506331','608 Creekview Dr.',0,'Ripley','OH','45167',NULL,'CY','39015','1950-06-21','F','M',NULL,'N','021','HLT','3304530','92036OH004000601','2014-03-01','2014-01-22 13:43:06','408.00',NULL,NULL,'509.54','101.54','R-OH005','OH0','509.54',NULL,0,'2014-01-23 03:02:51'),(7034,5586,'Y','18','021','EC','A','','','AC','0000519024','0000519024','TX00001687003','IL','1','Miller','Amanda','','','','34','466891064','10017 WOODLAND VILLAGE DR',0,'AUSTIN','TX','78750','2221','CY','48491','1977-10-31','F','M',':RET:2106-3','N','021','DEN','2388981','33348TX002000201','2014-01-01','2013-12-24 23:44:55','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 01:49:13'),(7922,6264,'Y','18','021','EC','A','','','AC','0002133298','0002133298','LA00000401049','IL','1','Roberts','Marlon','','','','34','438881266','411 LOUISIANA AVE',0,'SULPHUR','LA','70663','5219','CY','22019','1952-04-15','M','U',NULL,'N','021','DEN','2139849','18575LA002000201','2014-01-01','2013-12-20 08:22:15','0.00',NULL,NULL,'14.61','14.61','R-LA004','LA0','14.61',NULL,0,'2013-12-26 03:06:21'),(9046,7177,'N','19','021','EC','A',NULL,NULL,'','0000168879','0000509186','','IL','1','Yokie','Quinn','Alexandria','','','34','293967385','7155 CHAPEL RD',0,'MADISON','OH','44057','2240','CY','39085','1993-12-02','F','',NULL,'N','021','HLT','2472454','52664OH151001306','2014-01-01','2013-12-18 16:30:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','159.71',NULL,0,'2013-12-26 04:05:57'),(26878,21301,'N','01','021','EC','A',NULL,NULL,'','0000947447','0000447538','','IL','1','Kulow','Cheryl','A','','','34','281607488','3742 MUIR TAP DR',0,'MEDINA','OH','44256','6464','CY','39103','1964-12-08','F','',':RET:2106-3','N','021','HLT','3221564','52664OH152000901','2014-03-01','2014-02-28 22:48:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','278.66',NULL,0,'2014-03-01 21:01:07'),(27629,21854,'Y','18','021','EC','A','','','AC','0000667837','0000667837','OH00002485408','IL','1','BOYLE','MICHAEL','A','','','34','269601232','361 ROCKFORD DR',0,'HAMILTON','OH','45013','2252','CY','39017','1956-09-01','M','U',NULL,'N','021','DEN','2834644','99734OH005000401','2014-04-01','2014-03-04 20:41:42','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-05 21:30:09'),(6872,5449,'N','01','021','EC','A',NULL,NULL,'','0000904224','0000644633','','IL','1','del rio','manzanita','rose','','','34','601848619','4695 MARBLEHEAD CT',0,'COLUMBUS','OH','43220','3454','CY','39049','1980-12-29','F','',':RET:2106-3','N','021','DEN','156280','99734OH005000301','2014-01-01','2013-11-03 13:59:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:32:01'),(25703,20391,'Y','18','021','EC','A','','','AC','0000719027','0000719027','TX00002575446','IL','1','Haley','Sharon','','','','34','465046219','2601 FM 3136',0,'CLEBURNE','TX','76031','9070','CY','48251','1954-05-08','F','M',NULL,'N','021','DEN','3253464','33348TX002000201','2014-04-01','2014-02-24 13:27:03','0.00',NULL,NULL,'31.70','31.70','R-TX008','TX0','15.85',NULL,0,'2014-02-26 09:30:19'),(24229,19241,'Y','18','021','EC','A','','','AC','0001195542','0001195542','OH00002578997','IL','1','James','Carla','','','','34','437359903','4974 MYERS RD',0,'COLUMBUS','OH','43232','2667','CY','39049','1969-10-19','F','U',':RET:2054-5','N','021','DEN','3816798','99734OH005000401','2014-04-01','2014-02-16 10:24:48','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-16 19:00:33'),(1933,1574,'N','01','021','EC','A',NULL,NULL,'','0001155919','0000898484','','IL','1','crosby','david','l','','','34','460826433','49 TRINITY ST',0,'BAY CITY','TX','77414','2141','CY','48321','1950-02-16','M','',':RET:2106-3','N','021','DEN','662131','33348TX002000201','2014-01-01','2013-11-19 23:31:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 19:00:27'),(20483,16363,'Y','18','021','EC','A','','','AC','0000812056','0000812056','OH00002461420','IL','1','Bechtel','Stacy','','','','34','480868680','26 EVERETT AVE',0,'AKRON','OH','44302','1020','CY','39153','1971-06-27','F','U',':RET:2106-3','T','021','HLT','3403301','52664OH151001305','2014-03-01','2014-01-28 23:39:14','174.00',NULL,NULL,'339.81','165.81','R-OH012','OH0','339.81',NULL,0,'2014-01-29 21:01:02'),(15620,12493,'Y','18','021','EC','A','','','AC','0001219762','0001219762','MS00001630091','31','1','Whitten','Vallerie','','','','34','587332819','P.O. Box 2084',0,'Verona','MS','38879',NULL,'CY','28081','1964-11-07','F','U',':RET:2106-3','T','021','DEN','1465153','46300MS002000101','2014-02-01','2013-12-31 13:41:23','0.00',NULL,NULL,'27.15','27.15','R-MS002','MS0','27.15',NULL,1,'2014-01-02 04:33:06'),(14202,11325,'Y','18','021','EC','A','','','AC','0000916022','0000916022','TX00000871046','IL','1','RAUCH','KRISTEN','','','','34','539788595','1076 IRON HILL ROAD',0,'CAT SPRING','TX','78933',NULL,'CY','48089','1968-02-12','F','U',NULL,'N','021','DEN','1981797','33348TX002000201','2014-02-01','2013-12-26 13:37:04','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-27 02:04:16'),(669,551,'N','01','021','EC','A',NULL,NULL,'','0000495437','0001252099','','IL','1','PUFFER','KEITH','','','','34','393608054','11050 FANCHER RD',0,'WESTERVILLE','OH','43082',NULL,'CY','39041','1953-08-30','M','',':RET:2106-3','T','021','DEN','1392044','99734OH005000301','2014-01-01','2013-12-16 08:58:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 18:02:04'),(24655,19572,'Y','18','021','EC','A','','','AC','0000457850','0000457850','OH00002547968','IL','1','Graham','Sharon','','','','34','290522434','2318 Kenwood Blvd',0,'Toledo','OH','43606',NULL,'CY','39095','1952-07-01','F','U',NULL,'N','021','HLT','2864581','92036OH004002601','2014-04-01','2014-02-18 21:51:57','167.00',NULL,NULL,'440.60','273.60','R-OH001','OH0','440.60',NULL,0,'2014-02-20 04:24:16'),(811,671,'Y','18','021','EC','A','','','AC','0001011536','0001011536','OH00000447300','IL','1','Drake','Teri','','','','34','281546541','226 Half E. 10th St.',0,'Ashland','OH','44805',NULL,'CY','39005','1953-05-07','F','U',':RET:2106-3','N','021','HLT','2315194','52664OH151001305','2014-01-01','2013-12-16 10:18:36','538.00',NULL,NULL,'605.24','67.24','R-OH012','OH0','605.24',NULL,0,'2013-12-25 18:05:49'),(17355,13885,'Y','18','021','EC','A','','','AC','0001899374','0001899374','LA00002235069','IL','1','BRIGNAC','SHELLEY','','','','34','436238456','10476 BROWN RD',0,'DENHAM SPRINGS','LA','70726',NULL,'CY','22063','1961-10-30','F','U',NULL,'N','021','DEN','1630164','18575LA002000101','2014-02-01','2014-01-10 16:01:28','0.00',NULL,NULL,'25.02','25.02','R-LA005','LA0','25.02',NULL,0,'2014-01-13 02:24:11'),(27176,21516,'Y','18','021','EC','A','','','AC','0000374570','0000374570','TX00002824582','IL','1','DURON LOPEZ','JESUS','','','','34','454131565','1028 VENESA DR',0,'EAGLE PASS','TX','78852','3037','CY','48323','1956-12-25','M','M',NULL,'N','021','DEN','2760332','33348TX002000201','2014-04-01','2014-03-03 12:04:16','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-03 21:31:07'),(14092,11230,'N','01','021','EC','A',NULL,NULL,'','0000266533','0000109284','','IL','1','WELAGE','DEBRA','','','','34','275609926','4160 WEBSTER AVE',0,'CINCINNATI','OH','45236',NULL,'CY','39061','1955-11-29','F','',':RET:2106-3','N','021','DEN','1815645','99734OH005000401','2014-02-01','2013-12-26 11:09:34',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:22'),(25019,19838,'Y','18','021','EC','A','','','AC','0000545293','0000545293','OH00001813295','IL','1','OLOUGHLIN','ALICE','','','','34','289504948','1215 CRANFORD AVE',0,'LAKEWOOD','OH','44107','2307','CY','39035','1950-11-05','F','U',NULL,'N','021','DEN','2823267','99734OH005000301','2014-04-01','2014-02-20 16:12:26','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-20 22:00:56'),(24961,19795,'Y','18','021','EC','A','','','AC','0001967169','0001967169','LA00002601196','IL','1','Walker','Latonya','','','','34','436750404','610 VAN ZELFDEN ST',0,'TALLULAH','LA','71282','2910','CY','22065','1989-08-30','F','U',NULL,'N','021','DEN','3465562','18575LA002000201','2014-04-01','2014-02-20 16:20:58','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 22:00:19'),(6991,5548,'Y','18','021','EC','A','','','AC','0001260015','0001260015','OH00001245029','IL','1','Norwood','Cherylanne','','','','34','281622007','P.O. Box 2444',0,'Toledo','OH','43606',NULL,'CY','39095','1958-04-03','F','U',':RET:2054-5','N','021','HLT','2412645','92036OH005002601','2014-01-01','2013-12-24 18:22:29','108.00',NULL,NULL,'434.84','326.84','R-OH001','OH0','434.84',NULL,0,'2013-12-26 01:48:00'),(8046,6369,'Y','18','021','EC','A','','','AC','0000242703','0000242703','OH00001021203','IL','1','Kostoff','Thomas','','','','34','286461861','161 Grayling Drive',0,'Fairlawn','OH','44333',NULL,'CY','39153','1954-02-06','M','U',':RET:2106-3','N','021','HLT','2041647','52664OH152000901','2014-01-01','2013-12-20 15:41:07','136.00',NULL,NULL,'425.18','289.18','R-OH012','OH0','425.18',NULL,0,'2013-12-26 03:09:32'),(13846,11050,'Y','18','021','EC','A','','','AC','0000862432','0000862432','OH00000936045','IL','1','LAUBENTHAL','JACQUELINE','','','','34','282562946','1603 SUNNYACRES RD',0,'COPLEY','OH','44321','2330','CY','39153','1954-03-01','F','M',':RET:2106-3','T','021','HLT','1780249','52664OH152000901','2014-01-01','2013-12-23 18:11:16','134.00',NULL,NULL,'488.95','354.95','R-OH012','OH0','488.95',NULL,0,'2013-12-26 13:12:27'),(19284,15371,'Y','18','021','EC','A','','','AC','0001187862','0001187862','LA00001467094','IL','1','Walpon','Cheryl','','','','34','367982062','2356 S MAGNOLIA DR',0,'BAKER','LA','70714','3322','CY','22033','1986-03-10','F','M',NULL,'N','021','DEN','1782517','18575LA002000201','2014-03-01','2014-01-20 18:35:05','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,1,'2014-01-22 03:21:51'),(17633,14098,'Y','18','021','EC','A','','','AC','0000991557','0000991557','OH00001464588','IL','1','NASH','KATHERINE','','','','34','224763765','38280 NORTH LN',0,'WILLOUGHBY','OH','44094','7452','CY','39085','1950-10-07','F','U',NULL,'N','021','DEN','2230112','99734OH005000301','2014-02-01','2014-01-12 19:51:44','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-14 01:32:34'),(15727,12579,'Y','18','021','EC','A','','','AC','0001194138','0001194138','OH00000129472','IL','1','Lyons','Sean','','','','34','283906806','1857 BALLYMORE LN',0,'CINCINNATI','OH','45233','4457','CY','39061','1986-03-03','M','U',':RET:2106-3','N','021','DEN','1532115','99734OH005000301','2014-02-01','2014-01-02 16:35:10','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-01-03 02:00:21'),(26957,21359,'N','19','021','EC','A',NULL,NULL,'','0000245041','0000015322','','S1','1','Hamric','Craig','Allen','','','34','293023960','576 BELDEN AVE',0,'AKRON','OH','44310','1501','CY','39153','1998-01-30','F','',':RET:2106-3','N','021','HLT','3266135','52664OH151001305','2014-04-01','2014-03-01 21:31:20',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-03-03 01:00:29'),(1354,1122,'Y','18','021','EC','A','','','AC','0001134227','0001134227','TX00001260289','IL','1','Schroeder','Paul','','','','34','453804481','934 OLD PIN OAK RD',0,'PAIGE','TX','78659','4310','CY','48021','1953-12-06','M','M',':RET:2106-3','N','021','DEN','2341550','33348TX002000101','2014-01-01','2013-12-24 13:36:03','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2013-12-25 18:45:21'),(21927,17512,'Y','18','021','EC','A','','','AC','0000812136','0000812136','TX00002594820','31','1','SIMON','RONALD','D','','Sr','34','423646720','PO BOX 152013',0,'LUFKIN','TX','75915',NULL,'CY','48005','1950-01-04','M','U',NULL,'T','021','DEN','3685456','33348TX002000201','2014-03-01','2014-02-06 20:48:59','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-07 19:00:09'),(17587,14058,'Y','18','021','EC','A','','','AC','0000317359','0000317359','OH00002142267','IL','1','Trent','Karoline','','','','34','290608087','3063 HICKORY ST',0,'CLINTON','OH','44216','9115','CY','39153','1962-08-12','F','M',':RET:2106-3','T','021','DEN','1461125','99734OH005000401','2014-02-01','2014-01-13 16:29:59','0.00',NULL,NULL,'31.57','31.57','R-OH012','OH0','0.00',NULL,0,'2014-01-14 01:32:08'),(15193,12141,'Y','18','024','14','A','','','TE','0001169413','0001169413','','IL','1','Currie','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-07-10','M','',NULL,NULL,NULL,'','1078422','','2013-12-30','2013-12-30 16:34:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-01 12:07:10'),(27244,21572,'Y','18','021','EC','A','','','AC','0001100648','0001100648','OH00002570376','IL','1','Malone','Terry A','','','','34','274447537','193 ROSS DR',0,'WEST UNION','OH','45693','9628','CY','39001','1956-03-10','M','M',NULL,'N','021','HLT','3616065','92036OH004000601','2014-04-01','2014-03-03 15:00:27','873.18',NULL,NULL,'879.62','6.44','R-OH005','OH0','439.81',NULL,0,'2014-03-03 21:31:49'),(332,273,'Y','18','021','EC','A','','','AC','0000536040','0000536040','TX00000793817','IL','1','barnett','sammye','','','','34','402132912','3111 Avenue Q',0,'Galveston','TX','77550',NULL,'CY','48167','1972-06-06','F','U',NULL,'N','021','DEN','1036777','33348TX002000201','2014-01-01','2013-10-11 12:17:39','0.00',NULL,NULL,'31.70','31.70','R-TX010','TX0','15.85',NULL,0,'2013-12-25 17:31:42'),(23379,18629,'Y','18','021','EC','A','','','AC','0000586737','0000586737','OH00002522239','IL','1','CRAINE','DEBORA','','','','34','273669421','827 HAMILTON RD',0,'LYNX','OH','45650','9714','CY','39001','1958-02-19','F','U',NULL,'T','021','DEN','3130944','99734OH005000401','2014-03-01','2014-02-13 12:03:57','0.00',NULL,NULL,'15.78','15.78','R-OH005','OH0','0.00',NULL,0,'2014-02-13 22:00:58'),(14858,11863,'Y','18','021','EC','A','','','AC','0000432758','0000432758','OH00000811894','IL','1','Attewell','Erica','','','','34','128567855','4746 CYPRESS POINT DR',0,'BRUNSWICK','OH','44212','6439','CY','39103','1965-02-27','F','U',':RET:2106-3','N','021','HLT','2303207','52664OH152000901','2014-01-01','2013-12-23 20:27:55','0.00',NULL,NULL,'267.06','267.06','R-OH012','OH0','267.06',NULL,1,'2013-12-29 11:15:16'),(17950,14341,'N','01','021','EC','A',NULL,NULL,'','0001099291','0000089866','','IL','1','Ondreas','Kenneth','James','','','34','451210128','291 CLEGG RD',0,'PORT LAVACA','TX','77979','5617','CY','48057','1956-09-20','M','',':RET:2106-3','N','021','DEN','2036165','33348TX002000201','2014-02-01','2014-01-14 16:41:05',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-15 02:06:42'),(4604,3646,'Y','18','021','EC','A','','','AC','0000783200','0000783200','OH00001153097','IL','1','Drake','Joan','','','','34','381485881','6800 KRISTI LYNNE LN',0,'TOLEDO','OH','43617','1279','CY','39095','1956-08-25','F','M',':RET:2106-3','N','021','HLT','644090','92036OH005002601','2014-01-01','2013-12-11 21:23:29','0.00',NULL,NULL,'950.42','950.42','R-OH001','OH0','475.21',NULL,0,'2013-12-25 22:05:47'),(143,122,'Y','18','021','EC','A','','','AC','0001245571','0001245571','OH00001148158','IL','1','Bittinger','Sheryl','','','','34','299523758','873 Foxglove Circle',0,'Barberton','OH','44203',NULL,'CY','39153','1951-10-28','F','M',':RET:2106-3','N','021','HLT','12652','52664OH152000901','2014-01-01','2013-12-05 14:13:48','469.28',NULL,NULL,'469.28','0.00','R-OH012','OH0','469.28',NULL,0,'2013-12-25 17:18:45'),(5885,4669,'Y','18','021','EC','A','','','AC','0000125559','0000125559','OH00001421318','IL','1','Walker','Shelley','','','','34','291706601','6803 BREMEN RD SE',0,'LANCASTER','OH','43130','9417','CY','39045','1970-06-22','F','M',':RET:2106-3','N','021','DEN','2554208','99734OH005000301','2014-01-01','2013-12-23 22:43:43','0.00',NULL,NULL,'87.78','87.78','R-OH009','OH0','0.00',NULL,0,'2013-12-25 23:49:32'),(24144,19186,'N','19','021','EC','A',NULL,NULL,'','0000444955','0000504513','','IL','1','Bingamon','Jesse','','','','34','296044831','3533 NEALS CIR',0,'BATAVIA','OH','45103','9709','CY','39025','2000-04-01','M','',':RET:2106-3','N','021','HLT','3320747','92036OH004000601','2014-03-01','2014-02-15 11:05:49',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-15 22:01:54'),(28910,22884,'Y','18','021','EC','A','','','AC','0000435375','0000435375','OH00002924653','IL','1','Arteaga','Alejandro','','','','34','562836806','1327 MAPLE AVE NE',0,'CANTON','OH','44705','1717','CY','39151','1984-05-30','M','R',NULL,'T','021','DEN','3664828','99734OH005000301','2014-04-01','2014-03-09 23:46:38','0.00',NULL,NULL,'42.26','42.26','R-OH015','OH0','0.00',NULL,0,'2014-03-10 21:00:26'),(6544,5188,'Y','18','024','14','A','','','TE','0000128151','0000128151','','IL','1','Gomez','Senia',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-01-13','F','',NULL,NULL,NULL,'','355575','','2013-12-11','2013-12-11 10:43:58',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:52:00'),(25984,20607,'Y','18','021','EC','A','','','AC','0000590836','0000590836','OH00003207565','IL','1','GADSON','IVAN','','','','34','180482579','6200 LEXINGTON AVE',0,'CLEVELAND','OH','44103',NULL,'CY','39035','1968-02-03','M','U',NULL,'N','021','DEN','3839795','99734OH005000401','2014-04-01','2014-02-26 16:45:18','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-02-26 21:01:53'),(25780,20445,'Y','18','021','EC','A','','','AC','0000289577','0000289577','OH00002045745','IL','1','Sauer','Scott','','','','34','272922058','16 PARKVIEW DR',0,'MEDINA','OH','44256','2641','CY','39103','1988-03-08','M','U',':RET:2106-3','T','021','HLT','3672227','52664OH152001001','2014-04-01','2014-02-24 13:55:52','0.00',NULL,NULL,'144.38','144.38','R-OH012','OH0','144.38',NULL,0,'2014-02-26 09:31:01'),(25285,20062,'Y','18','024','14','A','','','TE','0000723875','0000723875','','IL','1','Baker','Holly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1972-04-13','F','',NULL,NULL,NULL,'','662416','','2014-03-31','2014-02-24 21:12:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-25 21:00:20'),(20475,16356,'Y','18','021','EC','A','','','AC','0000718949','0000718949','OH00001609757','S1','1','shaferly','michael','david','','','34','279083491','22918 Twp rd 206',0,'Alvada','OH','44802',NULL,'CY','39063','2003-04-04','M','U',':RET:2106-3','N','021','DEN','3552201','99734OH005000401','2014-03-01','2014-01-29 15:11:14','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','15.78',NULL,0,'2014-01-29 21:00:58'),(20050,15990,'N','01','021','EC','A',NULL,NULL,'','0001071713','0000106556','','IL','1','buba','maria','omer','','','34','227857452','8330 POTRANCO RD',0,'SAN ANTONIO','TX','78251','2995','CY','48029','1972-01-10','F','',':RET:2054-5','N','021','DEN','2943792','33348TX002000201','2014-03-01','2014-01-26 18:46:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-27 21:00:04'),(19844,15827,'Y','18','024','14','A','','','TE','0002339706','0002339706','','IL','1','Galatas','Shelly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-08-31','F','',NULL,NULL,NULL,'','2750320','','2014-01-24','2014-01-24 13:45:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'CANCEL',0,'2014-01-24 21:00:27'),(2869,2319,'Y','18','021','EC','A','','','AC','0000625000','0000625000','TX00000584244','IL','1','Beckett','Clark','','','','34','445945566','4940 vista grande cir',0,'El Paso','TX','79922',NULL,'CY','48141','1985-01-31','M','U',':RET:2106-3','N','021','DEN','573631','33348TX002000201','2014-01-01','2013-10-21 18:33:36','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-25 20:01:53'),(19593,15619,'Y','18','021','EC','A','','','AC','0000177454','0000177454','MS00001614386','IL','1','Ramos','Jessica','','','','34','446886255','4056 RICHARDSON RD',0,'BOLTON','MS','39041','3148','CY','28049','1976-01-16','F','U',':RET:2040-4^:RET:2106-3','N','021','DEN','1749537','46300MS002000201','2014-03-01','2014-01-22 12:15:50','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-23 03:02:45'),(18982,15123,'Y','18','021','EC','A','','','AC','0000547910','0000547910','OH00001573213','31','1','PRICE','DEBORAH','L','','','34','162488463','PO BOX 351',0,'LA RUE','OH','43332',NULL,'CY','39101','1956-03-17','F','M',':RET:2106-3','N','021','DEN','2096969','99734OH005000301','2014-03-01','2014-01-17 09:46:38','0.00',NULL,NULL,'21.13','21.13','R-OH008','OH0','0.00',NULL,0,'2014-01-20 08:06:07'),(18851,15013,'Y','18','021','EC','A','','','AC','0000885623','0000885623','OH00002389521','IL','1','Milioni','Danielle','','','','34','385086978','591 TWILIGHT TRL',0,'CHIPPEWA LAKE','OH','44215','9798','CY','39103','1990-04-30','F','M',NULL,'N','021','HLT','2236208','52664OH151001305','2014-02-01','2014-01-15 19:45:02','88.00',NULL,NULL,'223.01','135.01','R-OH012','OH0','223.01',NULL,0,'2014-01-17 03:36:16'),(18818,14988,'Y','18','021','EC','A','','','AC','0000830665','0000830665','OH00001812569','IL','1','Smith','Harold','','','','34','421214034','2722 Queen City Ave',0,'Cincinnati','OH','45238',NULL,'CY','39061','1985-07-24','M','U',':RET:2054-5','N','021','DEN','1575259','99734OH005000401','2014-02-01','2014-01-15 20:29:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-01-17 03:36:05'),(28881,22857,'Y','18','021','EC','A','','','AC','0000752849','0000752849','TX00002853579','IL','1','Nguyen','Nhan','Hoai','','','34','634464859','10107 PAINTBRUSH LN',0,'SUGAR LAND','TX','77498','1459','CY','48157','1968-04-17','M','U',':RET:2047-9','T','021','DEN','3791944','33348TX002000201','2014-04-01','2014-03-10 12:09:40','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-10 21:00:08'),(29020,22969,'Y','18','021','EC','A','','','AC','0000544176','0000544176','OH00002921910','IL','1','BOSWELL','STEPHEN','','','','34','172568987','4823 KINGSHILL DRIVE',0,'COLUMBUS','OH','43229',NULL,'CY','39049','1968-08-23','M','U',':RET:2054-5','N','021','DEN','3250237','99734OH005000401','2014-04-01','2014-03-10 10:11:54','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-03-10 21:01:29'),(6704,5315,'Y','18','021','EC','A','','','AC','0001021436','0001021436','OH00000370158','IL','1','bailey','jennifer','','','','34','274785028','5553 lewis ave',0,'toledo','OH','43612',NULL,'CY','39095','1977-09-05','F','U',':RET:2106-3','N','021','HLT','941002','92036OH004002601','2014-01-01','2013-11-04 23:52:55','0.00',NULL,NULL,'192.86','192.86','R-OH001','OH0','192.86',NULL,0,'2013-12-26 01:02:00'),(23531,18745,'Y','18','021','EC','A','','','AC','0001834744','0001834744','LA00002432934','IL','1','Delancy','James','','','','34','439215572','1512 London at',0,'Olla','LA','71465',NULL,'CY','22059','1970-12-21','M','M',':RET:2106-3','N','021','DEN','2625243','18575LA002000201','2014-03-01','2014-02-13 11:30:56','0.00',NULL,NULL,'29.22','29.22','R-LA006','LA0','14.61',NULL,0,'2014-02-13 22:02:26'),(7633,6042,'Y','18','021','EC','A','','','AC','0000367337','0000367337','OH00001178133','IL','1','Karniotis','Constance','','','','34','281868975','5706 SUSAN DR',0,'CASTALIA','OH','44824','9755','CY','39043','1974-03-02','F','U',NULL,'N','021','DEN','805623','99734OH005000301','2014-01-01','2013-10-13 22:35:40','0.00',NULL,NULL,'21.13','21.13','R-OH006','OH0','0.00',NULL,0,'2013-12-26 02:46:19'),(2539,2066,'Y','18','021','EC','A','','','AC','0000418870','0000418870','OH00000012116','IL','1','SNOW','RAYMOND','','','','34','308521238','8364 FOSSIL DR',0,'SYLVANIA','OH','43560','9883','CY','39095','1950-07-22','M','U',':RET:2106-3','T','021','HLT','787040','92036OH006002601','2014-01-01','2013-12-09 09:53:43','255.00',NULL,NULL,'524.98','269.98','R-OH001','OH0','524.98',NULL,0,'2013-12-25 19:36:59'),(6172,4891,'Y','18','021','EC','A','','','AC','0000017661','0000017661','TX00000115462','IL','1','Nickle','Allison','','','','34','466957564','6420 Clairmont Dr.',0,'Austin','TX','78749',NULL,'CY','48453','1985-12-30','F','U',NULL,'N','021','DEN','172927','33348TX002000201','2014-01-01','2013-10-02 10:40:12','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2013-12-26 00:17:05'),(3989,3184,'N','01','021','EC','A',NULL,NULL,'','0000401227','0000268885','','IL','1','Roehm','Suellen','','','','34','298428933','9591Pausch Rd.',0,'Leesburg','OH','45135',NULL,'CY','39071','1953-01-22','F','',':RET:2106-3','N','021','HLT','128049','92036OH002000601','2014-01-01','2013-12-13 14:31:48',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','672.81',NULL,0,'2013-12-25 21:39:02'),(16781,13423,'Y','18','021','EC','A','','','AC','0000043242','0000043242','OH00001853617','IL','1','Gilliland','Lindsay','','','','34','289802189','909 ROSEWOOD DR',0,'CELINA','OH','45822','1330','CY','39107','1983-08-25','F','M',':RET:2106-3','N','021','HLT','1363070','92036OH003001506','2014-02-01','2014-01-07 15:56:41','451.00',NULL,NULL,'548.19','97.19','R-OH002','OH0','260.87',NULL,0,'2014-01-08 18:25:06'),(6500,5150,'Y','18','021','EC','A','','','AC','0000352810','0000352810','OH00001067509','IL','1','Eberhard','Ernest','','','','34','299527916','26606 CENTRAL PARK BLVD',0,'OLMSTED FALLS','OH','44138','2626','CY','39035','1953-11-23','M','U',':RET:2106-3','N','021','HLT','484337','52664OH151001304','2014-01-01','2013-12-11 15:55:53','395.00',NULL,NULL,'682.62','287.62','R-OH011','OH0','682.62',NULL,0,'2013-12-26 00:50:49'),(26702,21168,'Y','18','021','EC','A','','','AC','0000646056','0000646056','OH00003234513','IL','1','Conwell','Grant','','','','34','279926845','121 Vernon Ave',0,'Ashland','OH','44805',NULL,'CY','39005','1990-04-10','M','M',':RET:2106-3','T','021','HLT','3777672','52664OH152001001','2014-04-01','2014-02-27 19:02:45','0.00',NULL,NULL,'141.00','141.00','R-OH012','OH0','141.00',NULL,0,'2014-02-28 21:31:33'),(16678,13348,'Y','18','021','EC','A','','','AC','0000012450','0000012450','OH00002263380','IL','1','KNUTSON','ANTHONY','','','','34','302705900','6982 FRANCIS DR',0,'LIBERTY TOWNSHIP','OH','45044','9254','CY','39017','1976-07-17','M','M',':RET:2106-3','N','021','DEN','1575019','99734OH005000301','2014-02-01','2014-01-07 15:25:27','0.00',NULL,NULL,'87.78','87.78','R-OH004','OH0','0.00',NULL,0,'2014-01-08 18:24:31'),(3052,2452,'Y','18','021','EC','A','','','AC','0000025406','0000025406','LA00000643576','IL','1','holland','Carmon','','','','34','425152682','4949 STUMBERG LN',0,'BATON ROUGE','LA','70816','4793','CY','22033','1962-01-21','M','R',':RET:2106-3','N','021','DEN','433359','18575LA002000201','2014-01-01','2013-12-06 14:57:39','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 20:18:56'),(23664,18842,'Y','18','021','EC','A','','','AC','0000987415','0000987415','TX00002474077','IL','1','Vaid','Shakila','','','','34','461456714','20927 SHELBY MEADOW LN',0,'RICHMOND','TX','77407','4024','CY','48157','1959-08-19','F','M',':RET:2028-9','N','021','DEN','3056089','33348TX002000201','2014-03-01','2014-02-14 13:09:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-02-14 21:30:20'),(9244,7332,'Y','18','021','EC','A','','','AC','0001157551','0001157551','OH00000411714','IL','1','Roessner','Jeff','','','','34','280620989','PO Box 380  704 Little Turtle Drive',0,'Fort Recovery','OH','45846',NULL,'CY','39107','1956-07-31','M','M',':RET:2106-3','N','021','HLT','2146728','92036OH002001501','2014-01-01','2013-12-18 17:07:16','909.00',NULL,NULL,'1670.38','761.38','R-OH002','OH0','619.40',NULL,0,'2013-12-26 04:10:42'),(17102,13687,'Y','18','021','EC','A','','','AC','0001095415','0001095415','TX00002069292','IL','1','Street','Samuel','','','','34','463895074','3003 ROYAL CIRCLE DR',0,'KINGWOOD','TX','77339','2556','CY','48201','1984-08-25','M','U',':RET:2106-3','N','021','DEN','2202587','33348TX002000201','2014-02-01','2014-01-08 17:06:12','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 02:21:32'),(20837,16654,'N','01','021','EC','A',NULL,NULL,'','0000696847','0000564240','','IL','1','Drugan','Lori',NULL,NULL,NULL,NULL,NULL,'1660 CREIGHTON AVE',0,'AKRON','OH','44310','2612','CY','39153','1962-08-21','F','',':RET:2106-3','N','021','HLT','2698996','52664OH151001305','2014-03-01','2014-01-31 09:43:21',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.91',NULL,0,'2014-01-31 21:00:44'),(17915,14310,'Y','18','021','EC','A','','','AC','0000349036','0000349036','TX00002086772','31','1','SHIRLEY','MISTY','D','','','34','461279555','PO BOX 801',0,'INGOESIDE','TX','78362',NULL,'CY','48409','1972-12-03','F','U',':RET:2106-3','N','021','DEN','2119103','33348TX002000201','2014-02-01','2014-01-13 23:17:31','0.00',NULL,NULL,'14.61','14.61','R-TX007','TX0','14.61',NULL,0,'2014-01-15 02:06:29'),(14983,11974,'Y','18','021','EC','A','','','AC','0001141070','0001141070','TX00001901176','IL','1','HARRIS','ISAIAH','','','III','34','458734205','3610 BLACKBERRY CIRCLE',0,'MISSOURI CITY','TX','77459',NULL,'CY','48157','1985-05-02','M','U',':RET:2054-5','N','021','DEN','2377707','33348TX002000201','2014-02-01','2013-12-30 14:23:07','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:01:09'),(14668,11709,'Y','18','021','EC','A','','','AC','0001171315','0001171315','TX00001299113','IL','1','Taggart','Shannyn','','','','34','464911638','813 E 16TH ST',0,'SWEETWATER','TX','79556','1819','CY','48353','1975-08-22','F','R',':RET:2106-3','N','021','DEN','2051209','33348TX002000201','2014-02-01','2013-12-28 17:18:07','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,1,'2013-12-29 11:08:09'),(25624,20330,'Y','18','021','EC','A','','','AC','0000467143','0000467143','OH00003057266','IL','1','Austin','Barbara','','','','34','279604577','1236 E 80TH ST',0,'CLEVELAND','OH','44103','2204','CY','39035','1958-12-18','F','U',':RET:2054-5','T','021','DEN','2874445','99734OH005000301','2014-04-01','2014-02-21 18:13:11','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-02-26 08:30:19'),(21953,17530,'Y','18','021','EC','A','','','AC','0001214841','0001214841','OH00002477304','IL','1','nguyen','hieu','','','','34','293942409','765 corice st',0,'akron','OH','44306',NULL,'CY','39153','1989-03-15','M','U',':RET:2047-9','N','021','DEN','3422437','99734OH005000401','2014-03-01','2014-02-07 00:34:39','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-07 19:00:21'),(3478,2792,'N','19','021','EC','A',NULL,NULL,'','0000769988','0001106785','','IL','1','Riesenberg','Meg','','','','34','268969624','12016 CROSSINGS DR',0,'SPRINGDALE','OH','45246','1502','CY','39061','1992-08-08','F','',':RET:2106-3','N','021','DEN','1874880','99734OH005000401','2014-01-01','2013-12-22 11:02:05',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 21:20:08'),(18979,15121,'N','19','021','EC','A',NULL,NULL,'','0000228366','0001034689','','IL','1','WHITLATCH','CASSANDRA','L','','','34','285982522','537 FOWLER ST',0,'NEW LEXINGTON','OH','43764',NULL,'CY','39127','1995-07-15','F','',':RET:2106-3','N','021','DEN','2237610','99734OH005000301','2014-03-01','2014-01-17 13:47:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-20 08:06:06'),(18695,14904,'N','01','021','EC','A',NULL,NULL,'','0002015318','0001306119','','IL','1','Clavo','Alonzo','','','','34','436293805','6300 MORRISON RD',0,'NEW ORLEANS','LA','70126','1511','CY','22071','1974-09-15','M','',':RET:2054-5','N','021','DEN','2065126','18575LA002000101','2014-03-01','2014-01-16 10:38:45',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-17 03:35:26'),(447,367,'Y','18','021','EC','A','','','AC','0000075214','0000075214','OH00000093527','IL','1','Detrick','Daniel','Harold','','Jr','34','298608869','50 NUTMEG SQ',0,'SPRINGBORO','OH','45066','1027','CY','39165','1971-09-22','M','U',':RET:2106-3','N','021','DEN','481303','99734OH005000401','2014-01-01','2013-12-04 14:59:37','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:47:19'),(27229,21562,'Y','18','024','14','A','','','TE','0001863552','0001863552','','IL','1','Roberts','Huey',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-01-02','M','',NULL,NULL,NULL,'','1962225','','2014-03-31','2014-03-03 17:32:53',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-03-03 21:31:40'),(25527,20250,'N','01','021','EC','A',NULL,NULL,'','0001220886','0000748236','','IL','1','PLATTENBURG','EVA','','','','34','273947242','54 FLEMING RD',0,'CINCINNATI','OH','45215','2644','CY','39061','1960-12-06','F','',NULL,'N','021','HLT','3737360','92036OH004001201','2014-04-01','2014-02-25 16:24:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','352.13',NULL,0,'2014-02-25 21:32:09'),(6763,5365,'N','01','021','EC','A',NULL,NULL,'','0000373984','0000458021','','IL','1','Karl','Michael','R','','','34','434766421','28 belle vu loop',0,'covington','LA','70433',NULL,'CY','22103','1949-06-01','M','',':RET:2106-3','N','021','DEN','48923','18575LA002000201','2014-01-01','2013-11-25 13:18:33',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-26 01:16:24'),(3101,2491,'N','01','021','EC','A',NULL,NULL,'','0000084016','0000607124','','IL','1','FLAUGHER','JERRY','','','','34','283746175','807 JACK ROUSH WAY',0,'MANCHESTER','OH','45144','1405','CY','39001','1962-11-17','M','',':RET:2106-3','T','021','HLT','1011368','92036OH005000605','2014-01-01','2013-12-06 15:14:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','460.43',NULL,0,'2013-12-25 20:20:16'),(20700,16540,'Y','18','021','EC','A','','','AC','0002034167','0002034167','LA00001643060','IL','1','Shropshire','Charles','','','','34','437619803','5776 Maplewood Drive',0,'Baton Rouge','LA','70812',NULL,'CY','22033','1986-05-04','M','R',':RET:2054-5','N','021','DEN','3530387','18575LA002000201','2014-03-01','2014-01-29 22:52:16','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-30 21:01:03'),(4727,3746,'Y','18','021','EC','A','','','AC','0000688267','0000688267','OH00000289990','IL','1','Hester','Ricky','','','','34','284524229','29 California Blvd',0,'Toledo','OH','43612',NULL,'CY','39095','1954-08-01','M','M',':RET:2106-3','N','021','HLT','613692','92036OH003002601','2014-01-01','2013-12-12 16:32:12','160.00',NULL,NULL,'530.07','370.07','R-OH001','OH0','530.07',NULL,0,'2013-12-25 22:09:05'),(14328,11428,'Y','18','024','14','A','','','TE','0000491838','0000491838','','IL','1','Snyder','Tabitha',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-06-05','F','',NULL,NULL,NULL,'','660869','','2013-12-26','2013-12-26 12:35:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:07:28'),(5032,3986,'Y','18','021','EC','A','','','AC','0001175687','0001175687','OH00000084918','IL','1','Dunn','James','','','','34','285484995','107 SANTA MARIA WOODS DR',0,'MOSCOW','OH','45153','9656','CY','39025','1949-06-10','M','M',':RET:2106-3','T','021','HLT','63967','92036OH006000601','2014-01-01','2013-12-07 16:37:11','870.00',NULL,NULL,'1174.68','304.68','R-OH005','OH0','587.34',NULL,0,'2013-12-25 22:47:47'),(16116,12910,'Y','18','021','EC','A','','','AC','0001809817','0001809817','LA00001813531','IL','1','Hemani','Hussain','','','','34','454672273','7009 LEGACY LOOP',0,'PINEVILLE','LA','71360','4680','CY','22079','1959-06-23','M','M',':RET:2028-9','N','021','DEN','2193823','18575LA002000101','2014-02-01','2014-01-03 00:10:45','0.00',NULL,NULL,'50.04','50.04','R-LA006','LA0','25.02',NULL,0,'2014-01-04 02:05:17'),(111,97,'N','01','021','EC','A',NULL,NULL,'','0000097382','0000960877','','IL','1','le','thuy','','','','34','510237331','4400 texas blvd',0,'texarkana','TX','75503',NULL,'CY','48037','1972-01-24','F','',':RET:2047-9','N','021','DEN','535951','33348TX002000201','2014-01-01','2013-12-05 11:59:15',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 17:17:58'),(15317,12249,'Y','18','021','EC','A','','','AC','0001215562','0001215562','TX00001453771','IL','1','boyce','david','','','','34','451513016','103 BELL MEADOWS DR',0,'HUTTO','TX','78634','3077','CY','48491','1965-11-20','M','R',NULL,'N','021','DEN','1568850','33348TX002000201','2014-02-01','2013-12-31 19:24:12','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,1,'2014-01-02 04:23:24'),(18899,15059,'Y','18','021','EC','A','','','AC','0000680875','0000680875','OH00002508166','IL','1','Leu','Tommy','','','','34','277665157','2510 Consaul Street',0,'Toledo','OH','43605',NULL,'CY','39095','1958-11-21','M','M',NULL,'N','021','HLT','1617051','92036OH006002601','2014-03-01','2014-01-16 11:27:39','536.00',NULL,NULL,'675.02','139.02','R-OH001','OH0','344.86',NULL,0,'2014-01-17 03:36:35'),(24395,19377,'Y','18','021','EC','A','','','AC','0001203273','0001203273','OH00002927606','IL','1','Civitarese','Frank','','','','34','289787703','210 MONROE ST',0,'LOUDONVILLE','OH','44842','1328','CY','39005','1981-11-25','M','M',':RET:2106-3','N','021','DEN','3601019','99734OH005000401','2014-04-01','2014-02-18 13:52:02','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2014-02-18 22:00:51'),(23782,18925,'Y','18','021','EC','A','','','AC','0000588023','0000588023','OH00001524697','IL','1','Blackburn','Cory','','','','34','610421635','15352 County Rd 25A',0,'Anna','OH','45302',NULL,'CY','39149','1989-08-30','M','U',':RET:2106-3','N','021','HLT','3408141','92036OH001000501','2014-03-01','2014-02-13 18:52:28','0.00',NULL,NULL,'286.72','286.72','R-OH003','OH0','286.72',NULL,0,'2014-02-14 21:31:20'),(21387,17092,'N','19','021','EC','A',NULL,NULL,'','0000552661','0000108193','','IL','1','Mason','Cooper','','','','34','291153348','3800 MILNER RD',0,'NEWARK','OH','43055','9304','CY','39089','2010-01-18','M','',':RET:2106-3','N','021','DEN','3762814','99734OH005000401','2014-03-01','2014-02-04 09:27:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-04 21:00:56'),(22310,17811,'Y','18','021','EC','A','','','AC','0000802908','0000802908','MS00002528385','IL','1','McClain','Travis','Lorenza','','','34','426150552','8424 WEST ST',0,'OCEAN SPRINGS','MS','39565','9404','CY','28059','1958-05-25','M','M',':RET:2054-5','N','021','DEN','1927279','46300MS002000201','2014-03-01','2014-01-29 16:43:53','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-10 11:00:44'),(29025,22974,'Y','18','021','EC','A','','','AC','0000662762','0000662762','OH00002812118','IL','1','HALLEZ','MARYAM','','','','34','457553842','1124 FULLER ST',0,'CINCINNATI','OH','45202','1715','CY','39061','1952-07-27','F','U',':RET:2106-3','N','021','DEN','3853891','99734OH005000401','2014-04-01','2014-03-10 10:48:26','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-03-10 21:01:33'),(15732,12584,'Y','18','024','14','A','','','TE','0000637122','0000637122','','IL','1','Sommer','Michele','Irene',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1952-03-23','F','',NULL,NULL,NULL,'','1699748','','2014-01-02','2014-01-02 09:43:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:00:33'),(2464,2005,'Y','18','021','EC','A','','','AC','0000145799','0000145799','LA00000506953','IL','1','Sears','Louis','','','','34','439823535','606 CLARE CT',0,'NEW ORLEANS','LA','70124','1764','CY','22071','1951-01-06','M','U',':RET:2106-3','N','021','DEN','1240783','18575LA002000101','2014-01-01','2013-12-09 14:42:25','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 19:35:02'),(22245,17756,'Y','18','021','EC','A','','','AC','0000651587','0000651587','MS00002614751','IL','1','RAMIREZ','LEOBARDO','','','','34','415951069','5933 ALEXANDRIA LN',0,'SOUTHAVEN','MS','38671','1829','CY','28033','1972-09-25','M','M',NULL,'N','021','DEN','2819235','46300MS002000101','2014-03-01','2014-02-09 13:07:02','0.00',NULL,NULL,'54.30','54.30','R-MS001','MS0','27.15',NULL,0,'2014-02-09 19:00:40'),(22089,17632,'Y','18','021','EC','A','','','AC','0000227789','0000227789','MS00001432909','IL','1','Cigliola','Francesca','','','','34','428710123','15513 Lyda steen dr',0,'Biloxi','MS','39532',NULL,'CY','28059','1991-05-15','F','U',':RET:2106-3','N','021','DEN','3566705','46300MS002000201','2014-03-01','2014-02-07 18:40:33','0.00',NULL,NULL,'15.85','15.85','R-MS005','MS0','15.85',NULL,0,'2014-02-08 19:00:23'),(22044,17597,'Y','18','021','EC','A','','','AC','0001066020','0001066020','OH00002495508','IL','1','Wilson','Christopher','Arthur','','','34','275427439','5525 W BANCROFT ST',0,'TOLEDO','OH','43615','2825','CY','39095','1953-04-08','M','M',':RET:2106-3','N','021','HLT','3183131','92036OH006002601','2014-03-01','2014-02-07 17:45:52','833.00',NULL,NULL,'854.26','21.26','R-OH001','OH0','419.70',NULL,0,'2014-02-07 19:01:10'),(13559,10813,'Y','18','021','EC','A','','','AC','0001788820','0001788820','LA00001306776','IL','1','Angell','Patricia','','','','34','439886414','1516 LYNNETTE DR',0,'METAIRIE','LA','70003','5508','CY','22051','1953-08-05','F','U',':RET:2106-3','N','021','DEN','2222815','18575LA002000201','2014-01-01','2013-12-23 15:34:18','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:04:18'),(19489,15534,'Y','18','021','EC','A','','','AC','0001091762','0001091762','TX00001920965','IL','1','White','Gabrial','','','','34','525398952','1710 NABORS LN',0,'ODESSA','TX','79761','1545','CY','48135','1971-11-30','M','U',':RET:1002-5','N','021','DEN','2657136','33348TX002000201','2014-03-01','2014-01-22 15:25:49','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-23 03:02:06'),(9005,7145,'N','19','021','EC','A',NULL,NULL,'','0000289516','0000282001','','IL','1','Thorp','Christopher','J','','','34','288921465','4601 BURGER AVE',0,'CLEVELAND','OH','44109','5323','CY','39035','1987-10-25','M','',':RET:2106-3','N','021','HLT','2384584','52664OH152000901','2014-01-01','2013-12-18 11:13:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','188.65',NULL,0,'2013-12-26 04:04:58'),(19163,15267,'Y','18','021','EC','A','','','AC','0001194152','0001194152','OH00002173995','IL','1','BOLING','RUTH ANN','','','','34','300485249','62 N ERIE BEACH RD',0,'LAKESIDE','OH','43440',NULL,'CY','39123','1950-04-04','F','M',':RET:2106-3','N','021','HLT','3045391','92036OH004002701','2014-03-01','2014-01-19 11:54:03','838.77',NULL,NULL,'844.95','6.18','R-OH006','OH0','462.84',NULL,0,'2014-01-21 08:45:42'),(15965,12777,'N','19','021','EC','A',NULL,NULL,'','0000572007','0000546487','','IL','1','EGGERS','SARAH','','','','34','281119979','40965 DOUGLAS RD TR 245',0,'COOLVILLE','OH','45723',NULL,'CY','39105','2005-06-08','F','',':RET:2106-3','N','021','DEN','1807707','99734OH005000301','2014-02-01','2014-01-03 14:33:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-04 02:00:26'),(28388,22461,'Y','18','021','EC','A','','','AC','0000783310','0000783310','OH00003487325','IL','1','mcginnis hosey','shannon','','','','34','346629486','320 east marina parkway',0,'lorain','OH','44052',NULL,'CY','39093','1970-08-17','F','U',':RET:2106-3','N','021','HLT','4203021','52664OH152000901','2014-04-01','2014-03-07 17:28:28','132.00',NULL,NULL,'249.99','117.99','R-OH011','OH0','249.99',NULL,0,'2014-03-07 21:30:43'),(23839,18968,'Y','18','021','EC','A','','','AC','0001231817','0001231817','OH00002107058','IL','1','Bailey','Nathan','','','','34','277787749','3639 EL REGO DR',0,'AMELIA','OH','45102','1624','CY','39025','1981-09-21','M','R',':RET:2106-3','N','021','HLT','3499568','92036OH005000601','2014-03-01','2014-02-13 21:28:34','0.00',NULL,NULL,'468.63','468.63','R-OH005','OH0','253.96',NULL,0,'2014-02-14 21:31:51'),(9484,7521,'Y','18','021','EC','A','','','AC','0001011560','0001011560','OH00000715504','IL','1','Boedecker','Shannon','','','','34','290908313','2095 W 103RD ST',0,'CLEVELAND','OH','44102','3524','CY','39035','1984-02-08','F','M',':RET:2106-3','N','021','DEN','1634507','99734OH005000401','2014-01-01','2013-12-21 12:38:06','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:34:43'),(18853,15015,'Y','18','021','EC','A','','','AC','0000397370','0000397370','OH00002180840','IL','1','Penland','Troy','','','','34','270889620','235 SULLIVAN PL',0,'AKRON','OH','44310','3318','CY','39153','1977-08-14','M','U',':RET:2106-3','N','021','HLT','1976183','52664OH151001306','2014-02-01','2014-01-15 20:30:26','204.00',NULL,NULL,'274.30','70.30','R-OH012','OH0','274.30',NULL,0,'2014-01-17 03:36:16'),(464,379,'Y','18','021','EC','A','','','AC','0000643202','0000643202','OH00000058445','IL','1','WOHLFORD','SUSAN','','','','34','298480437','437 BOYD AVE',0,'AKRON','OH','44305','3805','CY','39153','1951-04-18','F','U',':RET:2106-3','N','021','HLT','835461','52664OH151001306','2014-01-01','2013-12-03 21:00:12','557.00',NULL,NULL,'640.70','83.70','R-OH012','OH0','640.70',NULL,0,'2013-12-25 17:47:42'),(3109,2497,'Y','18','021','EC','A','','','AC','0000261466','0000261466','OH00001269987','IL','1','mangas','jeffery','','','','34','295604524','h-648 rd. 8',0,'deshler','OH','43516',NULL,'CY','39069','1970-04-22','M','M',':RET:2106-3','N','021','HLT','669787','92036OH002002601','2014-01-01','2013-12-06 16:17:03','0.00',NULL,NULL,'305.57','305.57','R-OH001','OH0','305.57',NULL,0,'2013-12-25 20:20:28'),(5445,4326,'Y','18','024','14','A','','','TE','0000092468','0000092468','','IL','1','RITSON','JANET',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-11-26','F','',NULL,NULL,NULL,'','436057','','2013-12-18','2013-12-18 22:24:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 23:10:02'),(6303,5000,'Y','18','021','EC','A','','','AC','0001066955','0001066955','OH00000127137','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','DEN','475369','99734OH005000401','2014-01-01','2013-12-11 09:42:35','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 00:45:58'),(24607,19529,'N','19','021','EC','A',NULL,NULL,'','0000788253','0000326237','','IL','1','Sexton','Sophia','Elizabeth','','','34','288113995','44901 NEW LONDON EASTERN RD',0,'SULLIVAN','OH','44880','9610','CY','39093','2005-10-21','F','',':RET:2106-3','N','021','DEN','3209628','99734OH005000301','2014-04-01','2014-02-19 16:01:25',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:13:27'),(16347,13085,'Y','18','021','EC','A','','','AC','0000717845','0000717845','OH00002222059','IL','1','Shephard','Horace','','','','34','196587708','71 HAMILTON DR',0,'TORONTO','OH','43964','2004','CY','39081','1978-01-03','M','M',NULL,'N','021','DEN','1751807','99734OH005000301','2014-02-01','2014-01-06 10:26:32','0.00',NULL,NULL,'42.26','42.26','R-OH016','OH0','0.00',NULL,0,'2014-01-07 04:02:23'),(19525,15561,'N','19','021','EC','A',NULL,NULL,'','0000689722','0000329671','','IL','1','Ventura','Kally','','','','34','270064048','7350 JAGUAR CT',0,'WAYNESVILLE','OH','45068','8210','CY','39165','2000-10-02','F','',':RET:2047-9','N','021','DEN','2134178','99734OH005000401','2014-03-01','2014-01-21 18:59:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-23 03:02:19'),(6576,5214,'Y','18','021','EC','A','','','AC','0000947475','0000947475','LA00000805089','IL','1','Lewis','Hattie','','','','34','439801276','2401 Houma Blvd.',0,'Metairie','LA','70001',NULL,'CY','22051','1950-06-25','F','U',':RET:2054-5','N','021','DEN','891593','18575LA002000101','2014-01-01','2013-12-11 15:21:32','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:52:49'),(22737,18153,'Y','18','021','EC','A','','','AC','0001662974','0001662974','LA00002536759','IL','1','ABAN KU','DULCE','MARIA','','','34','661227656','903 TERRY ST',0,'DERIDDER','LA','70634','3324','CY','22011','1980-01-25','F','M',NULL,'N','021','DEN','2705773','18575LA002000201','2014-03-01','2014-02-11 16:00:53','0.00',NULL,NULL,'29.22','29.22','R-LA004','LA0','14.61',NULL,0,'2014-02-11 21:01:18'),(17840,14252,'Y','18','021','EC','A','','','AC','0000636034','0000636034','OH00001413284','IL','1','Gassaway','Sherry','','','','34','308800506','6821 VILLABROOK DR',0,'COLUMBUS','OH','43235','3932','CY','39049','1969-01-29','F','M',':RET:2106-3','N','021','DEN','1902776','99734OH005000401','2014-02-01','2014-01-13 20:20:38','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-15 02:06:03'),(17420,13941,'Y','18','021','EC','A','','','AC','0000084064','0000084064','OH00002462377','IL','1','Hesson','Teresa','','','','34','296846231','12821 Capetown Ave. NW',0,'Uniontown','OH','44685',NULL,'CY','39151','1975-09-08','F','M',':RET:2106-3','N','021','HLT','2462696','52664OH151001304','2014-02-01','2014-01-10 12:06:08','219.00',NULL,NULL,'573.35','354.35','R-OH015','OH0','277.87',NULL,0,'2014-01-13 03:00:27'),(13738,10965,'Y','18','021','EC','A','','','AC','0000665644','0000665644','OH00000248945','IL','1','HANLIN','DEBORAH','LYNN','','','34','290504348','2692 DAL DR',0,'NORTON','OH','44203','4914','CY','39153','1951-06-25','F','M',':RET:2106-3','N','021','HLT','2233323','52664OH151001305','2014-01-01','2013-12-23 18:45:49','436.00',NULL,NULL,'640.70','204.70','R-OH012','OH0','640.70',NULL,0,'2013-12-26 13:09:35'),(7511,5942,'Y','18','021','EC','A','','','AC','0000698157','0000698157','LA00000663017','IL','1','DAVIS','KIRK','','','Sr','34','434711332','47393 MCGEE RD',0,'HAMMOND','LA','70401','7528','CY','22105','1988-03-14','M','M',':RET:2054-5','N','021','DEN','522570','18575LA002000201','2014-01-01','2013-12-15 09:11:22','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-26 02:32:05'),(27927,22091,'Y','18','021','EC','A','','','AC','0000740293','0000740293','TX00003269036','IL','1','Scott','Theresa','','','','34','454531260','305 S PROMENADE ST',0,'HALLETTSVILLE','TX','77964','2937','CY','48285','1980-12-09','F','M',NULL,'N','021','DEN','3646703','33348TX002000201','2014-04-01','2014-03-06 10:09:03','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-06 21:00:23'),(16381,13108,'Y','18','021','EC','A','','','AC','0000091169','0000091169','TX00001465583','31','1','AMAYA','ANA','MARIA','','','34','454831617','PO BOX 386',0,'TELFERNER','TX','77988',NULL,'CY','48469','1962-02-17','F','M',NULL,'N','021','DEN','1636253','33348TX002000201','2014-02-01','2014-01-06 15:51:47','0.00',NULL,NULL,'14.61','14.61','R-TX023','TX0','14.61',NULL,0,'2014-01-07 04:03:19'),(19756,15748,'Y','18','021','EC','A','','','AC','0000217629','0000217629','OH00002576001','IL','1','Digman','Mary','K','','','34','271645940','5881 Woolman Ct.',0,'Parma','OH','44130',NULL,'CY','39035','1965-08-14','F','U',NULL,'N','021','DEN','2901724','99734OH005000301','2014-03-01','2014-01-23 14:38:25','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-23 21:01:21'),(22209,17726,'Y','18','021','EC','A','','','AC','0001006861','0001006861','OH00001548917','IL','1','Delaet','Anthony','','','','34','294722060','6519 MENLO WAY',0,'HUBER HEIGHTS','OH','45424','3425','CY','39113','1977-03-13','M','U',':RET:2106-3','N','021','DEN','3735680','99734OH005000401','2014-03-01','2014-02-09 15:56:51','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2014-02-09 19:00:19'),(4393,3492,'Y','18','021','EC','A','','','AC','0000057312','0000057312','OH00000829237','IL','1','Stevens','Opal','','','','34','289582218','625 WIGGS CT',0,'GALION','OH','44833','2425','CY','39033','1955-11-17','F','M',':RET:2106-3','N','021','DEN','5586','99734OH005000401','2014-01-01','2013-12-12 12:30:17','0.00',NULL,NULL,'15.78','15.78','R-OH007','OH0','0.00',NULL,0,'2013-12-25 22:00:56'),(27122,21469,'Y','18','021','EC','A','','','AC','0000408540','0000408540','OH00003304902','IL','1','MACKENZIE-THURLEY','IAN','','','','34','678779875','3349 HAMILTON SCIPIO RD',0,'HAMILTON','OH','45013','8202','CY','39017','1974-02-25','M','M',NULL,'N','021','DEN','2883207','99734OH005000301','2014-04-01','2014-03-03 13:16:39','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2014-03-03 21:30:34'),(15968,12779,'N','01','021','EC','A',NULL,NULL,'','0000652649','0000981056','','IL','1','Garcia','Maria','Del Socorro','','','34','459048671','704 E 4TH ST',0,'ODESSA','TX','79761','5210','CY','48135','1952-04-17','F','',NULL,'N','021','DEN','1855243','33348TX002000201','2014-02-01','2014-01-02 18:35:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-01-04 02:00:31'),(20753,16582,'N','01','021','EC','A',NULL,NULL,'','0000381179','0000226047','','IL','1','Ahrmann','Kevin','','','','34','294820046','364 Hawthrone Drive',0,'Wilmington','OH','45177',NULL,'CY','39027','1979-11-19','M','',':RET:2106-3','N','021','HLT','2977304','92036OH002000601','2014-03-01','2014-01-30 11:12:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','300.96',NULL,0,'2014-01-30 21:01:31'),(1544,1287,'Y','18','021','EC','A','','','AC','0000444918','0000444918','OH00001352753','IL','1','PATEL','SURYAKANT','','','','34','165705417','7233 ENGLE RD',0,'MIDDLEBURG HEIGHTS','OH','44130',NULL,'CY','39035','1948-05-02','M','M',NULL,'N','021','DEN','2017676','99734OH005000401','2014-01-01','2013-12-24 17:50:25','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:24'),(3502,2813,'Y','18','021','EC','A','','','AC','0001229306','0001229306','OH00001116728','IL','1','Freeman','Ralph','','','','34','350686825','227 PRESERVE LN',0,'MACEDONIA','OH','44056','1792','CY','39153','1980-02-23','M','U',':RET:2054-5','N','021','DEN','1605296','99734OH005000401','2014-01-01','2013-12-22 17:04:37','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:20:44'),(13281,10600,'Y','18','021','EC','A','','','AC','0000842335','0000842335','TX00000513568','IL','1','Ceballos','Robert','Javier','','','34','461674700','1741 KARL WYLER DR',0,'EL PASO','TX','79936','4911','CY','48141','1977-06-15','M','U',':RET:2054-5','N','021','DEN','1600752','33348TX002000201','2014-01-01','2013-12-23 13:02:09','0.00',NULL,NULL,'14.61','14.61','R-TX009','TX0','14.61',NULL,0,'2013-12-26 12:57:11'),(7419,5871,'Y','18','021','EC','A','','','AC','0000551387','0000551387','OH00000024532','IL','1','Armogida','Luigi','','','','34','282742153','1296 Main ST',0,'Cleveland','OH','44114','2251','CY','39035','1976-04-15','M','U',':RET:2106-3','N','021','HLT','1005988','52664OH151001301','2014-01-01','2013-10-28 14:42:43','21.00',NULL,NULL,'311.38','290.38','R-OH011','OH0','311.38',NULL,0,'2013-12-26 02:16:58'),(14592,11646,'N','01','021','EC','A',NULL,NULL,'','0000960613','0000794504','','IL','1','Rigby','AnnMarie','','','','34','068442772','4126 WAXWING TRL',0,'STOW','OH','44224','2573','CY','39153','1959-06-19','F','',':RET:2106-3','N','021','HLT','1366984','52664OH151001306','2014-02-01','2013-12-27 10:37:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','476.12',NULL,0,'2013-12-28 03:36:09'),(15604,12483,'N','19','021','EC','A',NULL,NULL,'','0000066261','0000187483','','IL','1','Mecklenborg','Lucy','','','','34','841505100','3321 FAIRHAVEN LN',0,'CINCINNATI','OH','45237','1805','CY','39061','2011-09-01','F','',':RET:2106-3','N','021','DEN','1692472','99734OH005000301','2014-02-01','2013-12-31 15:23:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-02 04:32:40'),(27248,21575,'Y','18','021','EC','A','','','AC','0000060682','0000060682','TX00003307176','IL','1','Chicoine','Kristen','','','','34','644485796','4212 N CORAL SPRINGS DR',0,'FORT WORTH','TX','76123','1457','CY','48439','1976-12-26','F','R',':RET:2106-3','N','021','DEN','2884345','33348TX002000101','2014-04-01','2014-03-03 14:40:04','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-03-03 21:31:51'),(25541,20262,'Y','18','021','EC','A','','','AC','0000351620','0000351620','OH00002549525','IL','1','LOCKER','MICHAEL','','','','34','281703478','335 NORTHWAY DR',0,'SAINT MARYS','OH','45885','1243','CY','39011','1962-07-14','M','U',NULL,'N','021','DEN','3278557','99734OH005000301','2014-04-01','2014-02-23 14:28:04','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2014-02-26 08:00:11'),(489,399,'Y','18','021','EC','A','','','AC','0000709822','0000709822','LA00000362617','IL','1','Medaries','Clyde','Corley','','','34','434869788','2984 Highway 80 West',0,'Calhoun','LA','71225',NULL,'CY','22073','1949-11-22','M','U',':RET:2106-3','T','021','DEN','487959','18575LA002000201','2014-01-01','2013-12-03 21:53:17','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2013-12-25 17:48:21'),(5096,4039,'N','01','021','EC','A',NULL,NULL,'','0001155997','0000969752','','IL','1','SOLIAS','JOSE','HERNAN','','','34','272408572','2309 BRIARWOOD DR',0,'MISSION','TX','78574','2307','CY','48215','1949-08-28','M','',NULL,'N','021','DEN','1574316','33348TX002000201','2014-01-01','2013-12-19 15:34:50',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 23:01:20'),(5301,4201,'Y','18','021','EC','A','','','AC','0000666754','0000666754','OH00001142291','IL','1','Maag','Angie','','','','34','298821886','9798 Road 10  I',0,'Ottawa','OH','45875',NULL,'CY','39137','1971-06-04','F','U',NULL,'N','021','HLT','2197068','92036OH003001501','2014-01-01','2013-12-19 08:43:18','109.00',NULL,NULL,'304.54','195.54','R-OH002','OH0','304.54',NULL,0,'2013-12-25 23:06:17'),(14276,11389,'Y','18','021','EC','A','','','AC','0001137289','0001137289','MS00001650274','IL','1','Earls','Latonya','','','','34','097789301','1501 HIGHWAY 80 E',0,'CLINTON','MS','39056','5358','CY','28049','1990-11-10','F','U',':RET:2054-5','N','021','DEN','1529359','46300MS002000201','2014-02-01','2013-12-26 15:49:17','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-27 02:06:13'),(484,395,'Y','18','021','EC','A','','','AC','0000019448','0000019448','LA00000524786','IL','1','Chance','Robert','','','','34','437869251','142 S GATE DR',0,'PONCHATOULA','LA','70454','9401','CY','22105','1951-07-20','M','M',':RET:2106-3','N','021','DEN','811884','18575LA002000201','2014-01-01','2013-12-03 19:52:09','0.00',NULL,NULL,'29.22','29.22','R-LA005','LA0','14.61',NULL,0,'2013-12-25 17:48:14'),(23323,18588,'Y','18','021','EC','A','','','AC','0000743130','0000743130','OH00002797159','IL','1','Barkman','Frederick','','','','34','299544893','721 SHADOW LN',0,'TOLEDO','OH','43615','7798','CY','39095','1953-01-21','M','U',NULL,'N','021','DEN','3167754','99734OH005000301','2014-03-01','2014-02-13 13:47:37','0.00',NULL,NULL,'21.13','21.13','R-OH001','OH0','0.00',NULL,0,'2014-02-13 22:00:25'),(13898,11085,'Y','18','021','EC','A','','','AC','0000087482','0000087482','OH00000755849','IL','1','Mckenzie','Mark','','','','34','567927369','104 Cove Ln',0,'Rossford','OH','43460',NULL,'CY','39173','1954-12-13','M','U',':RET:2106-3','N','021','HLT','2246747','92036OH006002601','2014-01-01','2013-12-22 23:16:11','553.11',NULL,NULL,'557.18','4.07','R-OH001','OH0','402.54',NULL,0,'2013-12-26 13:13:38'),(22954,18301,'N','19','021','EC','A',NULL,NULL,'','0000407414','0000020218','','IL','1','Braig','Cameron','','','','34','280942837','7793 CARRAWAY CT',0,'MAINEVILLE','OH','45039','8995','CY','39165','1991-07-09','M','',':RET:2106-3','N','021','DEN','3621883','99734OH005000301','2014-03-01','2014-02-11 19:17:03',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-02-12 21:00:04'),(6640,5268,'Y','18','021','EC','A','','','AC','0000091999','0000091999','TX00001230223','IL','1','scott','dale','','','','34','449965639','7213 moser dr',0,'amarillo','TX','79110',NULL,'CY','48381','1953-11-09','M','U',':RET:2106-3','N','021','DEN','243066','33348TX002000201','2014-01-01','2013-11-12 02:16:57','0.00',NULL,NULL,'14.61','14.61','R-TX002','TX0','14.61',NULL,0,'2013-12-26 01:00:17'),(18907,15066,'Y','18','021','EC','A','','','AC','0000097907','0000097907','MS00001848810','IL','1','Harrell','Rekesha','','','','34','438516745','4860 AUTUMN WOODS DR',0,'JACKSON','MS','39206','6218','CY','28049','1983-09-24','F','U',':RET:2054-5','N','021','DEN','2526540','46300MS002000101','2014-03-01','2014-01-16 16:07:44','0.00',NULL,NULL,'27.15','27.15','R-MS003','MS0','27.15',NULL,0,'2014-01-17 03:36:39'),(4302,3421,'Y','18','021','EC','A','','','AC','0000524471','0000524471','OH00000596378','IL','1','Harper','Larry','allen','','','34','273503806','9598 MAD RIVER RD',0,'HILLSBORO','OH','45133','9447','CY','39071','1950-10-08','M','M',':RET:2106-3','N','021','HLT','1365097','92036OH005000604','2014-01-01','2013-12-17 11:12:36','479.00',NULL,NULL,'633.70','154.70','R-OH005','OH0','633.70',NULL,0,'2013-12-25 21:52:22'),(1740,1444,'Y','18','024','14','A','','','TE','0000178879','0000178879','','IL','1','diep','tuan',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-06-03','M','',NULL,NULL,NULL,'','1963916','','2013-12-24','2013-12-24 11:07:27',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:55:32'),(14741,11770,'Y','18','021','EC','A','','','AC','0001992210','0001992210','LA00001480084','IL','1','Guy','Gussie','','','','34','439860269','11403 E Admiral Doyle Lot1',0,'Jeanerette','LA','70544',NULL,'CY','22045','1951-07-06','F','M',':RET:2054-5','N','021','DEN','2569762','18575LA002000101','2014-02-01','2013-12-27 19:30:00','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,1,'2013-12-29 11:10:02'),(3988,3184,'Y','18','021','EC','A','','','AC','0000401227','0000401227','OH00001196634','IL','1','Roehm','David','','','','34','287429174','9591Pausch Rd.',0,'Leesburg','OH','45135',NULL,'CY','39071','1952-06-30','M','M',':RET:2106-3','N','021','HLT','128049','92036OH002000601','2014-01-01','2013-12-13 14:31:48','834.00',NULL,NULL,'1369.45','535.45','R-OH005','OH0','696.64',NULL,0,'2013-12-25 21:39:01'),(14096,11232,'N','01','021','EC','A',NULL,NULL,'','0000388650','0000002301','','IL','1','whitaker','vicki','e','','','34','275644809','607 W WILLIAM ST',0,'MAUMEE','OH','43537','2061','CY','39095','1959-05-23','F','',':RET:2106-3','T','021','DEN','2163191','99734OH005000401','2014-02-01','2013-12-26 11:27:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-27 02:01:27'),(19512,15552,'Y','18','021','EC','A','','','AC','0000597162','0000597162','TX00001723092','31','1','Ellis','Lydia','','','','34','450844301','PO BOX 1714',0,'Cleburne','TX','76033','1741','CY','48251','1953-08-05','F','M',NULL,'N','021','DEN','3003205','33348TX002000101','2014-03-01','2014-01-22 15:53:22','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-01-23 03:02:15'),(20576,16444,'Y','18','024','14','A','','','TE','0000232671','0000232671','','IL','1','Ford','Betty',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1956-07-13','F','',NULL,NULL,NULL,'','2751560','','2014-01-29','2014-01-29 18:12:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:01:55'),(20026,15971,'Y','18','021','EC','A','','','AC','0001435407','0001435407','LA00001916179','IL','1','Truong','Hai','V','','','34','566595978','198 EVANGELINE RD',0,'LA PLACE','LA','70068','8916','CY','22095','1952-11-15','M','M',':RET:2047-9','T','021','DEN','2867625','18575LA002000201','2014-03-01','2014-01-25 22:41:40','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-26 19:00:17'),(15841,12685,'Y','18','021','EC','A','','','AC','0000172417','0000172417','OH00000830168','IL','1','Line','Steven','','','','34','286665623','612 FAIR RD',0,'SIDNEY','OH','45365','2945','CY','39149','1959-06-13','M','M',':RET:2106-3','T','021','DEN','1394281','99734OH005000401','2014-02-01','2014-01-02 15:38:15','0.00',NULL,NULL,'31.57','31.57','R-OH003','OH0','0.00',NULL,0,'2014-01-03 02:04:10'),(6779,5377,'Y','18','021','EC','A','','','AC','0001073108','0001073108','OH00001050821','IL','1','starner','jessica','','','','34','293841342','1863 13TH ST',0,'CUYAHOGA FALLS','OH','44223','2410','CY','39153','1985-11-17','F','U',':RET:2106-3','T','021','DEN','1055793','99734OH005000301','2014-01-01','2013-11-25 12:08:45','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2013-12-26 01:16:47'),(26053,20662,'Y','18','021','EC','A','','','AC','0000568077','0000568077','OH00001888271','IL','1','Brace','Eric','','','','34','368861334','433 S FIRESTONE BLVD',0,'AKRON','OH','44301','2610','CY','39153','1976-04-27','M','U',NULL,'N','021','HLT','3717642','52664OH151001501','2014-04-01','2014-02-26 11:11:18','0.00',NULL,NULL,'331.12','331.12','R-OH012','OH0','331.12',NULL,0,'2014-02-26 21:02:34'),(6345,5028,'Y','18','021','EC','A','','','AC','0000058734','0000058734','OH00000293591','IL','1','Landrum','Marsha','Kay','','','34','281541341','712 OVERLOOK HEIGHTS LN',0,'CHILLICOTHE','OH','45601','8452','CY','39141','1953-10-03','F','M',':RET:2106-3','N','021','DEN','829840','99734OH005000401','2014-01-01','2013-12-11 12:43:04','0.00',NULL,NULL,'31.57','31.57','R-OH010','OH0','0.00',NULL,0,'2013-12-26 00:46:52'),(18906,15065,'Y','18','021','EC','A','','','AC','0001060936','0001060936','OH00002193495','IL','1','Sole','Ryan',NULL,NULL,NULL,NULL,NULL,'4467 Rootstown Rd',0,'Ravenna','OH','44266',NULL,'CY','39133','1990-06-01','M','M',':RET:2106-3','T','021','HLT','2111561','52664OH152001001','2014-03-01','2014-01-16 15:36:42','0.00',NULL,NULL,'141.00','141.00','R-OH012','OH0','141.00',NULL,0,'2014-01-17 03:36:38'),(17039,13634,'Y','18','021','EC','A','','','AC','0001315472','0001315472','LA00002135755','IL','1','Maye','Larry','','','','34','425319735','1247 Aberdeen Dr',0,'Harvey','LA','70058',NULL,'CY','22051','1971-08-19','M','U',':RET:2054-5','N','021','DEN','2377939','18575LA002000101','2014-02-01','2014-01-09 13:44:54','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2014-01-13 02:20:50'),(26749,21198,'Y','18','024','14','A','','','TE','0000560635','0000560635','','IL','1','SOWEMIMO','RAYMOND',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-08-13','M','',NULL,NULL,NULL,'','3222083','','2014-03-31','2014-02-28 18:00:19',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'TERMCIC',0,'2014-03-01 19:00:02'),(15003,11992,'Y','18','021','EC','A','','','AC','0000889740','0000889740','TX00000173949','31','1','Liang','Karen','','','','34','634287055','2121 El Paseo St',0,'Houston','TX','77054',NULL,'CY','48157','1987-05-06','F','U',':RET:2034-7','N','021','DEN','2442270','33348TX002000201','2014-02-01','2013-12-30 18:14:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-01 12:01:46'),(1130,930,'Y','18','021','EC','A','','','AC','0000890888','0000890888','TX00000721989','31','1','GARCIA','RAMON','','','','34','455358649','PO BOX 805',0,'LUBBOCK','TX','79408',NULL,'CY','48303','1964-06-15','M','U',NULL,'N','021','DEN','972032','33348TX002000101','2014-01-01','2013-12-03 14:52:33','0.00',NULL,NULL,'25.02','25.02','R-TX014','TX0','25.02',NULL,0,'2013-12-25 18:18:02'),(23614,18808,'Y','18','021','EC','A','','','AC','0000703826','0000703826','OH00001617198','IL','1','VELASQUEZ','FLEIPE','','','','34','378664744','494 CLEVELAND AVE',0,'DEFIANCE','OH','43512','3517','CY','39039','1972-02-24','M','M',NULL,'N','021','HLT','3642228','92036OH002002601','2014-03-01','2014-02-13 14:37:32','603.00',NULL,NULL,'823.73','220.73','R-OH001','OH0','298.38',NULL,0,'2014-02-13 22:03:14'),(14712,11746,'N','19','021','EC','A',NULL,NULL,'','0001151084','0000084051','','IL','1','GREEN','DWAYNE',NULL,NULL,NULL,NULL,NULL,'4285 BOWMAN MEADOW DR',0,'CANAL WINCHESTER','OH','43110','7843','CY','39049','2003-08-24','M','',':RET:2054-5','N','021','DEN','2386547','99734OH005000301','2014-02-01','2013-12-27 19:31:08',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2013-12-29 11:09:20'),(23211,18504,'N','19','021','EC','A',NULL,NULL,'','0000196137','0000665642','','IL','1','Gelter','Derek','T','','','34','283021226','1180 Little Indian Creek Road',0,'New Richmond','OH','45157',NULL,'CY','39025','1997-06-11','M','',':RET:2106-3','N','021','HLT','2825581','92036OH004000601','2014-03-01','2014-02-12 14:33:26',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-12 21:32:13'),(13930,11110,'Y','18','021','EC','A','','','AC','0000350574','0000350574','OH00000935973','IL','1','Kaszowski','John','','','','34','304042459','9926 US HIGHWAY 127',0,'SHERWOOD','OH','43556','9739','CY','39039','1982-12-26','M','U',':RET:2106-3','N','021','HLT','1733805','92036OH004002601','2014-01-01','2013-12-23 08:36:28','52.00',NULL,NULL,'181.73','129.73','R-OH001','OH0','181.73',NULL,0,'2013-12-26 13:14:26'),(20420,16310,'Y','18','024','14','A','','','TE','0000373656','0000373656','','IL','1','Vance','Brenda',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-01-31','F','',NULL,NULL,NULL,'','1481954','','2014-01-29','2014-01-29 10:16:15',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-29 21:00:30'),(18843,15009,'Y','18','021','EC','A','','','AC','0001160433','0001160433','OH00002253066','IL','1','KOHUT','PENNY','S','','','34','301560031','78 W HINES HILL RD',0,'HUDSON','OH','44236','1031','CY','39153','1959-01-31','F','M',':RET:2106-3','N','021','HLT','2756934','52664OH151001301','2014-03-01','2014-01-16 16:00:43','0.00',NULL,NULL,'932.62','932.62','R-OH012','OH0','497.31',NULL,0,'2014-01-17 03:36:14'),(5585,4430,'Y','18','021','EC','A','','','AC','0000137072','0000137072','LA00000728742','IL','1','Becker','Suzanne','Ashton','','','34','523172109','1533 HILLARY ST',0,'NEW ORLEANS','LA','70118','4007','CY','22071','1961-04-14','F','U',':RET:2106-3','N','021','DEN','614343','18575LA002000201','2014-01-01','2013-11-06 15:13:58','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:17:03'),(4256,3391,'Y','18','021','EC','A','','','AC','0000765962','0000765962','OH00000790749','IL','1','Vickroy','Nancy','','','','34','294727756','410 RUTLAND AVE',0,'AKRON','OH','44305','3147','CY','39153','1963-09-23','F','U',':RET:2106-3','N','021','HLT','1651932','52664OH151001501','2014-01-01','2013-12-17 10:58:21','194.00',NULL,NULL,'477.69','283.69','R-OH012','OH0','477.69',NULL,0,'2013-12-25 21:51:25'),(5327,4224,'N','01','021','EC','A',NULL,NULL,'','0000817528','0000418882','','IL','1','SPENCE','ALEESHA','','','','34','363060082','741 RIDGEWOOD AVE',0,'HAMILTON','OH','45013','3201','CY','39017','1980-02-20','F','',':RET:2106-3','N','021','DEN','2053923','99734OH005000301','2014-01-01','2013-12-19 11:02:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:06:59'),(16725,13386,'Y','18','021','EC','A','','','AC','0001195517','0001195517','OH00002331677','IL','1','Davis','Melanie','','','','34','298804267','6566 STYME RD',0,'LOWELLVILLE','OH','44436','9541','CY','39099','1982-04-22','F','M',':RET:2106-3','N','021','HLT','1807784','52664OH151001306','2014-02-01','2014-01-07 12:44:30','482.00',NULL,NULL,'596.08','114.08','R-OH013','OH0','293.11',NULL,0,'2014-01-08 18:24:48'),(328,270,'Y','18','021','EC','A','','','AC','0000229398','0000229398','OH00000580447','IL','1','Pryor','Daniel','','','','34','277767568','463 WALKER LN',0,'PAINESVILLE','OH','44077','6134','CY','39085','1980-01-06','M','U',NULL,'N','021','DEN','1079715','99734OH005000401','2014-01-01','2013-10-11 09:11:51','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:31:36'),(27601,21829,'N','01','021','EC','A',NULL,NULL,'','0000246511','0000653262','','IL','1','Emch','Amber','K','','','34','043885410','7699 N HONEYTOWN RD',0,'SMITHVILLE','OH','44677','9747','CY','39169','1989-06-26','F','',':RET:2106-3','N','021','HLT','3737607','52664OH151001305','2014-04-01','2014-03-05 08:01:00',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','223.01','CIC',0,'2014-03-05 21:00:23'),(5026,3984,'Y','18','021','EC','A','','','AC','0000194026','0000194026','OH00000638719','IL','1','Crehan','Kellie',NULL,NULL,NULL,NULL,NULL,'7350 S TIMBERLANE DR',0,'CINCINNATI','OH','45243','1844','CY','39061','1970-10-08','F','R',':RET:2106-3','N','021','HLT','141721','92036OH004001201','2014-01-01','2013-12-07 11:34:12','0.00',NULL,NULL,'563.06','563.06','R-OH004','OH0','234.23',NULL,0,'2013-12-25 22:47:41'),(2912,2347,'Y','18','021','EC','A','','','AC','0000095211','0000095211','OH00000961897','IL','1','ROBERTS','STANLEY','','','','34','268546880','822 IMANI CIR',0,'TOLEDO','OH','43604','8427','CY','39095','1952-06-07','M','M',':RET:2054-5','N','021','DEN','267905','99734OH005000401','2014-01-01','2013-12-06 11:29:47','0.00',NULL,NULL,'31.57','31.57','R-OH001','OH0','0.00',NULL,0,'2013-12-25 20:15:34'),(16273,13029,'Y','18','024','14','A','','','TE','0000787201','0000787201','','IL','1','Bahta','Alem',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1982-02-26','F','',NULL,NULL,NULL,'','1595022','','2014-01-06','2014-01-06 10:54:45',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-07 04:00:20'),(23065,18389,'Y','18','021','EC','A','','','AC','0001622328','0001622328','LA00002766246','IL','1','Lipman','Zoe','','','','34','435631561','16309 E BREWSTER RD',0,'COVINGTON','LA','70433','7212','CY','22103','1969-07-20','F','U',NULL,'N','021','DEN','2683532','18575LA002000201','2014-03-01','2014-02-12 17:54:46','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-12 21:30:53'),(2488,2027,'Y','18','021','EC','A','','','AC','0000114337','0000114337','LA00000354377','IL','1','Tolliver','Treasure','','','','34','418273931','560 GLENMORE AVE',0,'BATON ROUGE','LA','70806','5860','CY','22033','1976-07-04','M','U',':RET:2106-3','N','021','DEN','267965','18575LA002000201','2014-01-01','2013-12-09 16:05:23','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 19:35:43'),(13664,10902,'Y','18','021','EC','A','','','AC','0001460334','0001460334','LA00000905371','IL','1','Stevens','Jeremy','','','','34','224157096','4903 .5 Camp Street',0,'New Orleans','LA','70115',NULL,'CY','22071','1977-10-23','M','U',':RET:2106-3','N','021','DEN','1463478','18575LA002000101','2014-01-01','2013-12-23 12:33:49','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 13:07:43'),(13707,10936,'Y','18','021','EC','A','','','AC','0000050687','0000050687','OH00001171434','IL','1','huntsman','james','','','','34','284522436','3400 Stratford Green',0,'Uniontown','OH','44685',NULL,'CY','39153','1960-03-03','M','U',':RET:2106-3','N','021','HLT','2342633','52664OH151001304','2014-01-01','2013-12-23 13:27:33','288.00',NULL,NULL,'454.94','166.94','R-OH012','OH0','454.94',NULL,0,'2013-12-26 13:08:50'),(518,423,'Y','18','021','EC','A','','','AC','0000796926','0000796926','OH00000723347','IL','1','Murrell','Cynthia','','','','34','272505315','3579 MCHENRY AVE',0,'CINCINNATI','OH','45225','1159','CY','39061','1950-06-30','F','M',':RET:2054-5','N','021','DEN','983601','99734OH005000301','2014-01-01','2013-12-04 16:28:42','0.00',NULL,NULL,'21.13','21.13','R-OH004','OH0','0.00',NULL,0,'2013-12-25 17:49:08'),(24092,19153,'N','19','021','EC','A',NULL,NULL,'','0001109274','0000754618','','S1','1','Krause','Gary','Jay','','Jr','34','287049985','3024 Frost Road',0,'Mantua','OH','44255',NULL,'CY','39133','1999-08-24','F','',':RET:2106-3','N','021','HLT','3679734','52664OH151001304','2014-03-01','2014-02-15 14:30:46',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2014-02-15 22:01:26'),(20999,16778,'N','19','021','EC','A',NULL,NULL,'','0000469571','0000421498','','IL','1','HILL','MIRANDA','','','','34','274060371','8330 TUCKER DRIVE',0,'WEST CHESTER','OH','45069',NULL,'CY','39017','2000-12-23','F','',':RET:2106-3','N','021','DEN','3262694','99734OH005000301','2014-03-01','2014-02-01 14:09:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-01 19:00:27'),(1045,857,'Y','18','021','EC','A','','','AC','0000079313','0000079313','TX00000986797','IL','1','dockery','larry','w','','','34','439047794','6330 fairmont pkwy',0,'pasadena','TX','77505',NULL,'CY','48201','1957-11-29','M','M',':RET:2054-5','N','021','DEN','693562','33348TX002000201','2014-01-01','2013-12-03 14:59:27','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-25 18:15:53'),(19966,15927,'N','01','021','EC','A',NULL,NULL,'','0000469568','0001062148','','IL','1','Givens','Debra','K','','','34','402843755','320 BRENNAN RD',0,'CHILLICOTHE','OH','45601','2201','CY','39141','1956-01-26','F','',':RET:2054-5','N','021','DEN','2890569','99734OH005000301','2014-03-01','2014-01-24 22:14:33',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:10'),(29179,23094,'Y','18','021','EC','A','','','AC','0000447554','0000447554','OH00003528310','IL','1','Darnell','Catherine','','','','34','291488518','4458 SCHOOLHOUSE RD',0,'BATAVIA','OH','45103','1448','CY','39025','1950-04-14','F','M',':RET:2106-3','N','021','HLT','4230460','92036OH005000604','2014-04-01','2014-03-10 16:52:49','330.00',NULL,NULL,'633.70','303.70','R-OH005','OH0','633.70',NULL,0,'2014-03-10 21:03:03'),(8142,6441,'N','19','021','EC','A',NULL,NULL,'','0000176358','0000376119','','IL','1','Leis','Courtney','','','','34','293026075','66 CRESTWOOD DR',0,'WILLARD','OH','44890','1607','CY','39077','1998-02-16','F','',':RET:2106-3','N','021','HLT','1222029','92036OH004002701','2014-01-01','2013-11-21 21:10:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','99.57',NULL,0,'2013-12-26 03:15:49'),(28447,22509,'Y','18','021','EC','A','','','AC','0001808526','0001808526','LA00003507154','IL','1','CRUZ','MARGOT','E','','','34','661092749','4833 ZENITH ST',0,'METAIRIE','LA','70001','6739','CY','22051','1970-09-12','F','U',NULL,'N','021','DEN','3833222','18575LA002000201','2014-04-01','2014-03-07 09:45:29','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:17'),(2770,2238,'N','19','021','EC','A',NULL,NULL,'','0000655790','0000192700','','IL','1','Toth','Caroline',NULL,NULL,NULL,NULL,NULL,'1121 WALDO WAY',0,'TWINSBURG','OH','44087','1028','CY','39153','1997-05-01','F','',':RET:2106-3','N','021','HLT','212152','52664OH151001304','2014-01-01','2013-12-02 13:37:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','141.61',NULL,0,'2013-12-25 19:49:30'),(5469,4345,'Y','18','021','EC','A','','','AC','0001037345','0001037345','OH00000486065','IL','1','Schramm','Pamela','','','','34','294621748','10784 Reitz',0,'Perrysburg','OH','43551',NULL,'CY','39173','1958-02-08','F','U',':RET:2106-3','N','021','HLT','1847490','92036OH006002601','2014-01-01','2013-12-19 17:28:34','226.00',NULL,NULL,'344.86','118.86','R-OH001','OH0','344.86',NULL,0,'2013-12-25 23:10:37'),(6250,4953,'Y','18','021','EC','A','','','AC','0001200858','0001200858','OH00000970465','IL','1','HUMPHREY','HOLLY','','','','34','285660929','20545 STATE ROUTE 247',0,'SEAMAN','OH','45679',NULL,'CY','39001','1972-12-20','F','M',':RET:2106-3','N','021','HLT','931025','92036OH005000605','2014-01-01','2013-11-18 19:46:39','356.00',NULL,NULL,'589.49','233.49','R-OH005','OH0','279.50',NULL,0,'2013-12-26 00:31:55'),(15691,12553,'Y','18','021','EC','A','','','AC','0000974102','0000974102','OH00000576688','IL','1','Bauman','Jeremy','','','','34','270847902','9743 PLEASANT HOME RD',0,'STERLING','OH','44276','9609','CY','39169','1977-03-08','M','M',':RET:2106-3','T','021','HLT','2330073','52664OH152000901','2014-02-01','2013-12-31 18:09:49','0.00',NULL,NULL,'231.05','231.05','R-OH014','OH0','231.05',NULL,1,'2014-01-02 04:35:21'),(1422,1184,'Y','18','021','EC','A','','','AC','0001200835','0001200835','LA00000749445','IL','1','Tillman','Donna','','','','34','263026711','1923 UPPERLINE ST',0,'NEW ORLEANS','LA','70115','5549','CY','22071','1952-03-30','F','U',':RET:2106-3','N','021','DEN','2272610','18575LA002000201','2014-01-01','2013-12-24 15:19:00','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 18:47:16'),(27825,22006,'Y','18','021','EC','A','','','AC','0000503038','0000503038','OH00003152615','IL','1','Lopez','Gabrielle','Marie','','','34','299922905','186 Scenic View Drive',0,'Copley','OH','44321',NULL,'CY','39153','1990-10-25','F','U',':RET:2106-3','N','021','DEN','3902381','99734OH005000301','2014-04-01','2014-03-05 09:59:42','0.00',NULL,NULL,'21.13','21.13','R-OH012','OH0','0.00',NULL,0,'2014-03-05 21:31:58'),(28286,22383,'Y','18','021','EC','A','','','AC','0000308334','0000308334','OH00002895169','IL','1','Kline','Elizabeth','','','','34','288544215','3518 RANDOLPH RD',0,'MOGADORE','OH','44260','9453','CY','39133','1951-11-17','F','M',':RET:2106-3','N','021','HLT','3455015','52664OH151001305','2014-04-01','2014-03-07 10:30:10','1036.00',NULL,NULL,'1309.70','273.70','R-OH012','OH0','640.70','CIC',0,'2014-03-07 21:00:27'),(7149,5672,'N','01','021','EC','A',NULL,NULL,'','0001077948','0001233033','','IL','1','English','Carole','','','','34','051566108','12319 PIN OAK DR',0,'MAGNOLIA','TX','77354','6255','CY','48339','1964-03-18','F','',':RET:2106-3','N','021','DEN','1703693','33348TX002000101','2014-02-01','2013-12-25 00:55:40',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2013-12-26 01:52:09'),(25644,20343,'Y','18','021','EC','A','','','AC','0000740333','0000740333','OH00002759917','IL','1','Hagy-Ingramm','Walter','','','','34','291620845','248 MADISON ST',0,'RAVENNA','OH','44266','2661','CY','39133','1961-06-25','M','M',':RET:2106-3','N','021','HLT','3122418','52664OH151001305','2014-04-01','2014-02-22 17:41:35','262.00',NULL,NULL,'435.31','173.31','R-OH012','OH0','435.31',NULL,0,'2014-02-26 08:30:33'),(15300,12234,'Y','18','021','EC','A','','','AC','0002134549','0002134549','LA00000752178','IL','1','Scott','Edward','','','','34','338809040','184 DUNBAR ST',0,'GRAMBLING','LA','71245','2206','CY','22061','1972-12-06','M','M',':RET:2054-5','N','021','DEN','2539922','18575LA002000201','2014-02-01','2013-12-31 20:03:58','0.00',NULL,NULL,'29.22','29.22','R-LA007','LA0','14.61',NULL,1,'2014-01-02 04:22:48'),(23758,18909,'N','01','021','EC','A',NULL,NULL,'','0000661393','0000230485','','IL','1','Falck','Frank','','','','34','295661722','461 North Street',0,'Batavia','OH','45103',NULL,'CY','39025','1961-01-12','M','',':RET:2106-3','N','021','DEN','2834135','99734OH005000301','2014-03-01','2014-02-14 08:35:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:09'),(3695,2957,'Y','18','021','EC','A','','','AC','0000109264','0000109264','OH00000102023','IL','1','Laughery','Patricia','','','','34','280427490','1209 HILLCREST DR',0,'ASHLAND','OH','44805','4413','CY','39005','1954-07-06','F','U',':RET:2106-3','N','021','DEN','1159758','99734OH005000401','2014-01-01','2013-12-13 10:48:56','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 21:31:49'),(20936,16732,'Y','18','021','EC','A','','','AC','0000679557','0000679557','OH00001930258','IL','1','Cook','Julie','','','','34','275644222','500 Coventry Drive',0,'Findlay','OH','45840',NULL,'CY','39063','1971-05-06','F','U',':RET:2106-3','N','021','HLT','3447841','92036OH002001501','2014-03-01','2014-01-31 15:44:51','0.00',NULL,NULL,'336.77','336.77','R-OH002','OH0','336.77',NULL,0,'2014-01-31 21:01:40'),(17682,14129,'N','01','021','EC','A',NULL,NULL,'','0001521983','0001658411','','IL','1','bratcher','donna','','','','34','437788252','425 BELLEVUE DR',0,'LA PLACE','LA','70068','3403','CY','22095','1959-01-29','F','',NULL,'N','021','DEN','2433904','18575LA002000101','2014-02-01','2014-01-13 15:13:46',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2014-01-14 01:32:54'),(14689,11728,'Y','18','021','EC','A','','','AC','0000186121','0000186121','OH00001524905','IL','1','McKee','Gerald','','','','34','285442955','4221 Perry Ridge Road',0,'Nelsonville','OH','45764',NULL,'CY','39009','1949-10-27','M','M',':RET:2106-3','N','021','DEN','2255828','99734OH005000401','2014-02-01','2013-12-28 16:57:44','0.00',NULL,NULL,'31.57','31.57','R-OH017','OH0','0.00',NULL,1,'2013-12-29 11:08:45'),(17151,13723,'Y','18','021','EC','A','','','AC','0002246138','0002246138','LA00002416056','IL','1','JANVIER','JEAN','','','','34','592217308','733 CARROLLWOOD VILLAGE DR',0,'GRETNA','LA','70056',NULL,'CY','22051','1965-05-25','M','M',':RET:2054-5','N','021','DEN','2545384','18575LA002000201','2014-02-01','2014-01-07 22:51:29','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-01-13 02:21:57'),(27920,22086,'Y','18','024','14','A','','','TE','0000375619','0000375619','','IL','1','HONG','YOUNG GI',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1964-05-18','M','',NULL,NULL,NULL,'','3174494','','2014-03-05','2014-03-05 22:02:22',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-06 21:00:19'),(27698,21905,'Y','18','024','14','A','','','TE','0000428667','0000428667','','IL','1','Brooks','Kimberly',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1975-09-12','F','',NULL,NULL,NULL,'','3841046','','2014-03-05','2014-03-05 11:52:55',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-03-05 21:30:48'),(27346,21654,'Y','18','021','EC','A','','','AC','0000757206','0000757206','OH00002678655','IL','1','Hansen','Kimberly','','','','34','190545343','9656 Pleasant Lake Blvd Apt Y9',0,'Parma','OH','44130',NULL,'CY','39035','1965-09-16','F','M',':RET:2106-3','N','021','DEN','3467206','99734OH005000401','2014-04-01','2014-03-04 10:47:59','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-04 21:01:02'),(13243,10568,'Y','18','021','EC','A','','','AC','0000801856','0000801856','TX00000178826','IL','1','Broome','Amanda','','','','34','452818185','3309 38TH ST',0,'LUBBOCK','TX','79413','2713','CY','48303','1978-10-11','F','U',':RET:2106-3','N','021','DEN','2571982','33348TX002000201','2014-01-01','2013-12-23 08:58:22','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2013-12-26 12:56:09'),(18386,14675,'Y','18','021','EC','A','','','AC','0001176863','0001176863','OH00001765086','IL','1','SANDERSON','IAN','','','','34','278805813','5759 FRANK RD NW',0,'NORTH CANTON','OH','44720','7541','CY','39151','1981-01-16','M','U',':RET:2106-3','N','021','DEN','2352222','99734OH005000301','2014-02-01','2014-01-15 16:37:55','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2014-01-16 08:45:37'),(17910,14305,'Y','18','021','EC','A','','','AC','0001190332','0001190332','TX00001745996','IL','1','Deanda','Pedro','','','','34','465332484','2109 AZALEA ST',0,'MISSION','TX','78573','6761','CY','48215','1969-06-22','M','U',NULL,'N','021','DEN','1881165','33348TX002000201','2014-02-01','2014-01-13 20:23:00','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-01-15 02:06:26'),(17481,13976,'Y','18','021','EC','A','','','AC','0001065142','0001065142','TX00001862183','IL','1','HUNTER','MURLINE','','','','34','133520301','8282 CAMBRIDGE ST',0,'HOUSTON','TX','77054',NULL,'CY','48201','1950-09-27','F','U',NULL,'N','021','DEN','2170982','33348TX002000201','2014-02-01','2014-01-12 12:30:33','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-01-13 03:01:13'),(6617,5247,'Y','18','021','EC','A','','','AC','0001153598','0001153598','OH00000072536','IL','1','McKean','Donna','','','','34','203527947','9595 STATE ROUTE 41',0,'WEST UNION','OH','45693','8965','CY','39001','1960-01-31','F','U',NULL,'N','021','HLT','357996','92036OH006000601','2014-01-01','2013-12-11 10:55:22','176.00',NULL,NULL,'347.30','171.30','R-OH005','OH0','347.30',NULL,0,'2013-12-26 00:53:55'),(4227,3365,'Y','18','021','EC','A','','','AC','0000030814','0000030814','TX00000390533','IL','1','DELAFUENTE','TERESA','','','','34','629096491','1302 HOUGH ST',0,'ATKIENS','TX','78071',NULL,'CY','48297','1989-07-01','F','U',NULL,'N','021','DEN','1445135','33348TX002000201','2014-01-01','2013-12-17 11:23:57','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2013-12-25 21:50:35'),(6040,4783,'Y','18','021','EC','A','','','AC','0000799576','0000799576','LA00001178283','IL','1','Domke','Zachary','','','','34','439770705','204 S Massachusetts St',0,'Covington','LA','70433',NULL,'CY','22103','1989-11-21','M','U',':RET:2106-3','T','021','DEN','61166','18575LA002000101','2014-01-01','2013-12-01 12:23:34','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-26 00:01:22'),(27213,21546,'N','01','021','EC','A',NULL,NULL,'','0001214858','0000160835','','IL','1','BROWN','DENISE','','','','34','270820985','302 N WALNUT ST',0,'MIDDLE POINT','OH','45863',NULL,'CY','39161','1969-02-17','F','',':RET:2106-3','T','021','HLT','2787050','92036OH004001501','2014-04-01','2014-03-02 18:49:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','293.88',NULL,0,'2014-03-03 21:31:29'),(3951,3161,'Y','18','024','14','A','','','TE','0000151961','0000151961','','IL','1','GOODMAN','GREGORY','JOSEPH',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-08-29','M','',NULL,NULL,NULL,'','812138','','2013-12-13','2013-12-13 10:43:19',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:38:10'),(6843,5425,'N','03','021','EC','A',NULL,NULL,'','0001179578','0000972711','','IL','1','Pagan','Ethan','Robert','','','34','297119202','65 W Main St',0,'Sardinia','OH','45171',NULL,'CY','39071','2006-05-21','M','',NULL,'N','021','HLT','1117234','92036OH005000601','2014-01-01','2013-11-14 11:46:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-26 01:31:10'),(28052,22198,'Y','18','021','EC','A','','','AC','0000446827','0000446827','MS00002621695','IL','1','KEYES','JOHNNIE','','','','34','427493219','817 SCR 103',0,'LOUIN','MS','39338','4970','CY','28129','1981-08-15','M','U',':RET:2054-5','N','021','DEN','3164493','46300MS002000201','2014-04-01','2014-03-06 12:25:39','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-03-06 21:01:38'),(26203,20781,'Y','18','021','EC','A','','','AC','0001019318','0001019318','OH00002924309','IL','1','fogler','john','','','','34','298540027','8671 LANSDALE AVE NW',0,'NORTH CANTON','OH','44720','5137','CY','39151','1955-02-22','M','U',':RET:2106-3','N','021','HLT','2980691','52664OH151001306','2014-04-01','2014-02-27 10:08:10','443.00',NULL,NULL,'580.49','137.49','R-OH015','OH0','580.49',NULL,0,'2014-02-28 06:30:49'),(15596,12480,'Y','18','021','EC','A','','','AC','0000516871','0000516871','OH00001776521','IL','1','ARLEDGE','RANDALL','PATRICK','','','34','293623667','3771 HENDERSON RD',0,'columbus','OH','43220',NULL,'CY','39049','1958-09-30','M','U',':RET:2106-3','N','021','DEN','1828943','99734OH005000301','2014-02-01','2013-12-31 12:07:09','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:32:31'),(2883,2330,'Y','18','021','EC','A','','','AC','0000184896','0000184896','OH00001069337','IL','1','Saunders','Gary','','','','34','290844488','201 CLAY ST',0,'ROCKFORD','OH','45882','9207','CY','39107','1986-05-22','M','U',NULL,'N','021','DEN','916773','99734OH005000301','2014-01-01','2013-10-08 11:02:47','0.00',NULL,NULL,'21.13','21.13','R-OH002','OH0','0.00',NULL,0,'2013-12-25 20:02:17'),(9321,7389,'N','19','021','EC','A',NULL,NULL,'','0001888235','0001501878','','IL','1','Placide','Fabienne','Hanan','','','34','436837755','103 BERKLEY DR',0,'NEW ORLEANS','LA','70131','4005','CY','22071','1991-12-04','F','',':RET:2054-5','N','021','DEN','1679721','18575LA002000101','2014-01-01','2013-12-21 13:32:00',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-26 04:30:30'),(2619,2129,'Y','18','021','EC','A','','','AC','0000043201','0000043201','OH00001012191','IL','1','Williams','Paul','','','','34','406119033','1815 WILLIAM HOWARD TAFT RD',0,'CINCINNATI','OH','45206','1842','CY','39061','1964-06-01','M','U',':RET:2106-3','T','021','DEN','1049054','99734OH005000401','2014-01-01','2013-12-02 17:20:18','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 19:45:49'),(14801,11820,'Y','18','021','EC','A','','','AC','0001196815','0001196815','OH00001394755','IL','1','Laskin','Ilene','','','','34','294569244','6120 Clingan Rd',0,'Poland','OH','44514',NULL,'CY','39099','1954-12-12','F','U',':RET:2106-3','N','021','DEN','1487353','99734OH005000401','2014-01-01','2013-12-23 20:44:44','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','0.00',NULL,1,'2013-12-29 11:13:45'),(1581,1319,'Y','18','021','EC','A','','','AC','0000600455','0000600455','TX00000632343','IL','1','PURIFOY','MARCIE','','','','34','422153395','2705 BERMUDA DR',0,'KILLEEN','TX','76549','8204','CY','48027','1970-12-10','F','U',NULL,'N','021','DEN','1708291','33348TX002000201','2014-01-01','2013-12-24 10:49:24','0.00',NULL,NULL,'14.61','14.61','R-TX011','TX0','14.61',NULL,0,'2013-12-25 18:51:26'),(28445,22508,'Y','18','021','EC','A','','','AC','0001318084','0001318084','LA00003364053','IL','1','Bandi','Jeanea','','','','34','436982746','5418 S ROCHEBLAVE ST',0,'NEW ORLEANS','LA','70125','4322','CY','22071','1970-01-03','F','M',':RET:2106-3','N','021','DEN','3236224','18575LA002000201','2014-04-01','2014-03-06 22:42:49','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2014-03-07 21:31:16'),(26704,21170,'Y','18','021','EC','A','','','AC','0001174451','0001174451','OH00002711426','IL','1','KRAUSE','AISLINN','','','','34','274905982','13  and half State St',0,'Little Rock','OH','44857',NULL,'CY','39077','1988-07-31','F','U',NULL,'N','021','HLT','3319487','92036OH004002701','2014-04-01','2014-02-27 20:37:00','156.27',NULL,NULL,'157.42','1.15','R-OH006','OH0','157.42',NULL,0,'2014-02-28 21:31:35'),(16375,13103,'Y','18','021','EC','A','','','AC','0001105083','0001105083','TX00001828302','IL','1','rangel','nancy','','','','34','449992783','614 NW 8TH PL',0,'ANDREWS','TX','79714','4805','CY','48003','1988-05-05','F','U',':RET:2106-3','N','021','DEN','1809814','33348TX002000101','2014-02-01','2014-01-06 14:21:55','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2014-01-07 04:03:07'),(21945,17525,'Y','18','021','EC','A','','','AC','0000050723','0000050723','OH00002400141','IL','1','Gerding','Katherine','','','','34','286883852','719 E State St',0,'Port Clinton','OH','43452',NULL,'CY','39123','1980-05-07','F','U',':RET:2106-3','N','021','DEN','3179613','99734OH005000401','2014-03-01','2014-02-06 18:26:07','0.00',NULL,NULL,'15.78','15.78','R-OH006','OH0','0.00',NULL,0,'2014-02-07 19:00:18'),(17629,14094,'Y','18','021','EC','A','','','AC','0000389492','0000389492','TX00002299907','IL','1','CHAPMAN','JENNIFER','','','','34','457134080','13270 TRAUTWEIN RD',0,'AUSTIN','TX','78737','8517','CY','48209','1957-06-16','F','M',':RET:2106-3','N','021','DEN','2066408','33348TX002000201','2014-02-01','2014-01-13 16:54:41','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-14 01:32:32'),(15893,12726,'Y','18','024','14','A','','','TE','0001252123','0001252123','','IL','1','Hershberger','Trena',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1987-06-02','F','',NULL,NULL,NULL,'','1485397','','2014-01-01','2014-01-01 18:47:40',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-03 02:05:49'),(4219,3357,'Y','18','024','14','A','','','TE','0000838399','0000838399','','IL','1','Leavell','Scott','M',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1980-11-28','M','',NULL,NULL,NULL,'','2059078','','2013-12-17','2013-12-17 10:39:37',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-25 21:50:22'),(24554,19503,'Y','18','024','14','A','','','TE','0000706180','0000706180','','IL','1','Smith','Michael',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1965-12-28','M','',NULL,NULL,NULL,'','1966643','','2014-03-05','2014-02-18 18:08:59',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-20 04:04:57'),(1009,826,'N','01','021','EC','A',NULL,NULL,'','0000281966','0000550030','','IL','1','Meisner','Jennifer','Dawn','','','34','282789816','423 CENTER ST',0,'FINDLAY','OH','45840','5747','CY','39063','1965-10-24','F','',':RET:2080-0','N','021','HLT','554112','92036OH002001501','2014-01-01','2013-10-19 15:00:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','415.56',NULL,0,'2013-12-25 18:11:11'),(16092,12888,'Y','18','021','EC','A','','','AC','0000419438','0000419438','MS00001721314','IL','1','Rester','Linda','','','','34','587768583','664 PARKER PL',0,'BRANDON','MS','39042','8493','CY','28121','1953-02-03','F','U',':RET:2106-3','N','021','DEN','1408228','46300MS002000201','2014-02-01','2014-01-03 16:14:34','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2014-01-04 02:04:28'),(25912,20547,'Y','18','021','EC','A','','','AC','0000780594','0000780594','TX00003053783','IL','1','Long','Amelia','','','','34','579083885','6309 KENILWORTH DR',0,'AUSTIN','TX','78723','2037','CY','48453','1984-02-10','F','U',NULL,'N','021','DEN','2881769','33348TX002000201','2014-03-01','2014-02-26 14:50:02','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-02-26 21:01:14'),(3947,3159,'Y','18','021','EC','A','','','AC','0000151961','0000151961','OH00000258286','IL','1','GOODMAN','GREGORY','JOSEPH','','','34','279680232','75 N SCHOONER POINT DR',0,'PORT CLINTON','OH','43452','9110','CY','39123','1965-08-29','M','M',':RET:2106-3','N','021','HLT','812138','92036OH006002701','2014-01-01','2013-12-13 10:39:46','578.74',NULL,NULL,'583.00','4.26','R-OH006','OH0','252.84',NULL,0,'2013-12-25 21:38:04'),(25240,20022,'Y','18','021','EC','A','','','AC','0000043266','0000043266','OH00002605086','IL','1','BACKS','EDWARD','','','','34','268762247','203 W SOUTH ST',0,'SAINT MARYS','OH','45885','2524','CY','39011','1964-04-27','M','U',':RET:2106-3','N','021','HLT','3604932','92036OH004001501','2014-04-01','2014-02-20 18:27:33','294.00',NULL,NULL,'301.91','7.91','R-OH002','OH0','301.91',NULL,0,'2014-02-21 22:01:08'),(7568,5991,'Y','18','021','EC','A','','','AC','0000682137','0000682137','OH00001035023','IL','1','cramer','nicole','','','','34','275768680','10054 TOWNSHIP ROAD 10',0,'FINDLAY','OH','45840','9397','CY','39063','1979-01-13','F','R',':RET:2106-3','N','021','HLT','333500','92036OH004001501','2014-01-01','2013-12-15 12:53:28','0.00',NULL,NULL,'327.21','327.21','R-OH002','OH0','214.83',NULL,0,'2013-12-26 02:33:41'),(3441,2766,'Y','18','024','14','A','','','TE','0000696797','0000696797','','IL','1','Krueger','Timothy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1978-06-18','M','',NULL,NULL,NULL,'','808444','','2013-12-21','2013-12-21 18:51:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 21:19:14'),(6993,5550,'Y','18','024','14','A','','','TE','0000493005','0000493005','','IL','1','McGee','Crystal','Rae',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1983-03-26','F','',NULL,NULL,NULL,'','1901249','','2013-12-24','2013-12-24 18:28:52',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 01:48:03'),(28879,22855,'Y','18','021','EC','A','','','AC','0000853601','0000853601','TX00003841177','IL','1','Ellis','Tanner','Gene','','','34','630306604','6738 FM 16',0,'VAN','TX','75790','2606','CY','48467','1992-03-04','M','U',':RET:2106-3','N','021','DEN','3176392','33348TX002000201','2014-04-01','2014-03-10 11:38:52','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-03-10 21:00:07'),(16394,13118,'Y','18','021','EC','A','','','AC','0000525434','0000525434','TX00002215587','IL','1','Penrod','David','','','','34','612038279','8110 ROYAL FLD',0,'SAN ANTONIO','TX','78255','3318','CY','48029','1987-03-19','M','M',':RET:2036-2^:RET:2106-3','N','021','DEN','1887562','33348TX002000201','2014-02-01','2014-01-06 10:37:27','0.00',NULL,NULL,'29.22','29.22','R-TX019','TX0','14.61',NULL,0,'2014-01-07 04:03:40'),(28864,22842,'Y','18','024','14','A','','','TE','0001153742','0001153742','','IL','1','owen','kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1979-07-01','M','',NULL,NULL,NULL,'','2872736','','2014-03-31','2014-03-09 13:52:41',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERMCIC',0,'2014-03-09 21:30:06'),(6096,4832,'Y','18','021','EC','A','','','AC','0000913401','0000913401','LA00000707768','IL','1','SENEGAL','EDITH','L','','','34','439042886','616 N WILSON ST',0,'CHURCH POINT','LA','70525','2418','CY','22001','1957-10-18','F','U',':RET:2054-5','N','021','DEN','263770','18575LA002000101','2014-01-01','2013-11-20 19:59:54','0.00',NULL,NULL,'25.02','25.02','R-LA003','LA0','25.02',NULL,0,'2013-12-26 00:15:03'),(23582,18788,'Y','18','021','EC','A','','','AC','0000768921','0000768921','OH00001919909','IL','1','Topie','William','','','','34','279804049','5407 MAPLE GROVE AVE',0,'BLANCHESTER','OH','45107','1531','CY','39027','1966-11-10','M','U',NULL,'T','021','HLT','3785101','92036OH004000601','2014-03-01','2014-02-13 14:47:04','139.00',NULL,NULL,'310.27','171.27','R-OH005','OH0','310.27',NULL,0,'2014-02-13 22:02:57'),(25011,19834,'N','01','021','EC','A',NULL,NULL,'','0000066305','0001209638','','IL','1','jarrett','jerry','','','','34','232804880','12133 eaton blvd',0,'grafton','OH','44044',NULL,'CY','39093','1950-04-06','M','',':RET:2106-3','N','021','HLT','3339829','52664OH151001304','2014-04-01','2014-02-20 16:30:09',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','742.48',NULL,0,'2014-02-20 22:00:52'),(5487,4355,'N','01','021','EC','A',NULL,NULL,'','0001161533','0000240339','','IL','1','Wright','Debora','Faith','','','34','296428317','810 s. 7th. St.',0,'Greenfield','OH','45123',NULL,'CY','39071','1960-08-18','F','',':RET:2106-3','T','021','HLT','1531508','92036OH005000604','2014-01-01','2013-12-19 18:24:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','503.62',NULL,0,'2013-12-25 23:10:58'),(373,309,'N','01','021','EC','A',NULL,NULL,'','0000935166','0000019711','','IL','1','Fairbrother','Alyssa','Michelle','','','34','637341976','118 N IMPALA RD',0,'GILMER','TX','75644','4411','CY','48459','1992-11-23','F','',':RET:2106-3','N','021','DEN','205831','33348TX002000201','2014-01-01','2013-12-04 15:52:10',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2013-12-25 17:45:29'),(2920,2353,'N','01','021','EC','A',NULL,NULL,'','0000031910','0000695610','','IL','1','Curry','Shelley','','','','34','294600299','2490 ST RT 545',0,'Mansfield','OH','44905',NULL,'CY','39139','1963-01-22','F','',':RET:2106-3','N','021','DEN','312315','99734OH005000401','2014-01-01','2013-12-06 17:15:37',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 20:15:46'),(25690,20383,'Y','18','021','EC','A','','','AC','0001260065','0001260065','OH00001913061','IL','1','Geer','Kimberly','','','','34','273723097','6030 FERRY RD',0,'WAKEMAN','OH','44889','9405','CY','39077','1966-09-22','F','M',':RET:2106-3','N','021','HLT','2776711','92036OH003002704','2014-04-01','2014-02-23 20:33:38','606.00',NULL,NULL,'863.01','257.01','R-OH006','OH0','318.29',NULL,0,'2014-02-26 09:30:12'),(23499,18718,'N','01','021','EC','A',NULL,NULL,'','0000814518','0000772142','','IL','1','LIANG','XIAO','LING','','','34','635942301','6000 REIMS ROAD',0,'HOUSTON','TX','77036',NULL,'CY','48201','1958-04-11','F','',':RET:2034-7','N','021','DEN','2754927','33348TX002000101','2014-03-01','2014-02-13 00:25:25',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','27.15',NULL,0,'2014-02-13 22:02:07'),(22728,18147,'Y','18','021','EC','A','','','AC','0001457766','0001457766','LA00002273058','IL','1','MEYER','AIMEE','','','','34','627126002','546 CHOCTAW DR',0,'ABITA SPRINGS','LA','70420','3324','CY','22103','1987-07-06','F','U',':RET:2106-3','N','021','DEN','3074516','18575LA002000201','2014-03-01','2014-02-11 13:55:40','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2014-02-11 21:01:13'),(20008,15957,'Y','18','021','EC','A','','','AC','0000722664','0000722664','OH00001590225','IL','1','Frimel','Violet',NULL,NULL,NULL,NULL,NULL,'12742 DRAKE RD',0,'NORTH ROYALTON','OH','44133','5434','CY','39035','1949-09-29','F','M',NULL,'N','021','DEN','2664265','99734OH005000401','2014-03-01','2014-01-26 15:52:55','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-01-26 19:00:08'),(8945,7093,'Y','18','021','EC','A','','','AC','0001186301','0001186301','OH00001039115','IL','1','Agee','Brittani','','','','34','275968708','6053 APPLECREST CT',0,'BOARDMAN','OH','44512','3176','CY','39099','1993-01-16','F','U',':RET:2054-5','N','021','DEN','2486712','99734OH005000401','2014-01-01','2013-12-18 11:01:36','0.00',NULL,NULL,'15.78','15.78','R-OH013','OH0','15.78',NULL,0,'2013-12-26 04:03:25'),(19356,15428,'N','01','021','EC','A',NULL,NULL,'','0000426465','0000680879','','IL','1','IANNI','SARINA','','','','34','283569448','32556 LISA LN',0,'SOLON','OH','44139','5581','CY','39035','1953-12-27','F','',':RET:2106-3','N','021','DEN','2667751','99734OH005000301','2014-03-01','2014-01-21 15:07:02',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,1,'2014-01-22 03:22:28'),(9495,7530,'Y','18','021','EC','A','','','AC','0000154644','0000154644','OH00000958753','IL','1','Miller','Marcia','','','','34','315724956','932 HILLSIDE DR',0,'AMHERST','OH','44001','2570','CY','39093','1958-07-04','F','M',':RET:2106-3','N','021','DEN','2316534','99734OH005000401','2014-01-01','2013-12-21 14:16:33','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 04:35:01'),(5546,4401,'Y','18','021','EC','A','','','AC','0000338845','0000338845','OH00000184410','IL','1','SANDERS','ANN','','','','34','287606048','917 MULL AVE',0,'AKRON','OH','44313','7507','CY','39153','1964-07-15','F','U',':RET:2106-3','N','021','HLT','455543','52664OH151001305','2014-01-01','2013-11-27 13:08:38','283.00',NULL,NULL,'380.45','97.45','R-OH012','OH0','380.45',NULL,0,'2013-12-25 23:15:59'),(13220,10547,'Y','18','021','EC','A','','','AC','0000546443','0000546443','TX00001078904','IL','1','Daniel','Barbara','','','','34','452943428','1501 County Rd 23',0,'Damon','TX','77430',NULL,'CY','48039','1953-03-18','F','U',':RET:2106-3','N','021','DEN','1558998','33348TX002000201','2014-01-01','2013-12-22 19:51:54','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2013-12-26 12:55:27'),(5901,4675,'Y','18','021','EC','A','','','AC','0000130699','0000130699','OH00001394777','IL','1','Stanic','Milojka','','','','34','286067310','7013 STATE RD',0,'PARMA','OH','44134','4950','CY','39035','1968-09-27','F','M',':RET:2106-3','T','021','DEN','1366867','99734OH005000301','2014-01-01','2013-12-23 23:36:54','0.00',NULL,NULL,'42.26','42.26','R-OH011','OH0','0.00',NULL,0,'2013-12-25 23:49:46'),(7699,6096,'Y','18','021','EC','A','','','AC','0000121526','0000121526','OH00001149720','IL','1','Soden','Earl','','','','34','294466071','420 grafton ave',0,'dayton','OH','45406',NULL,'CY','39113','1950-10-03','M','M',':RET:2106-3','N','021','DEN','1656318','99734OH005000401','2014-01-01','2013-12-20 08:51:45','0.00',NULL,NULL,'15.78','15.78','R-OH003','OH0','0.00',NULL,0,'2013-12-26 03:01:13'),(27725,21925,'N','01','021','EC','A',NULL,NULL,'','0001025992','0000091415','','IL','1','Davis','Roy','','','Jr','34','450378818','4943 GUADALUPE DR',0,'EL PASO','TX','79904','2009','CY','48141','1961-08-01','M','',':RET:2054-5','N','021','DEN','3318362','33348TX002000201','2014-04-01','2014-03-05 14:58:21',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','14.61',NULL,0,'2014-03-05 21:31:00'),(16700,13365,'Y','18','024','14','A','','','TE','0000008810','0000008810','','IL','1','Barranco','Martha','Alicia',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1977-07-01','F','',NULL,NULL,NULL,'','2205699','','2014-01-07','2014-01-07 16:11:29',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2014-01-08 18:24:38'),(19157,15263,'Y','18','021','EC','A','','','AC','0000959127','0000959127','OH00002403454','IL','1','Mullen','Jessica','','','','34','288828549','1330 Fillmore Circle',0,'Lorain','OH','44052',NULL,'CY','39093','1984-07-07','F','U',':RET:2106-3','T','021','DEN','2074561','99734OH005000301','2014-03-01','2014-01-19 12:42:05','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-21 08:45:39'),(9264,7348,'Y','18','021','EC','A','','','AC','0000256230','0000256230','MS00000546023','IL','1','Myles','Shenika','','','','34','587512122','239 Mimosa Drive',0,'Canton','MS','39046',NULL,'CY','28089','1984-07-02','F','U',':RET:2054-5','N','021','DEN','1074597','46300MS002000201','2014-01-01','2013-11-29 20:48:12','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-26 04:15:25'),(28121,22255,'Y','18','021','EC','A','','','AC','0000823576','0000823576','OH00003032613','IL','1','Parker','Mary','','','','34','283548464','2022 SOUTH AVE',0,'TOLEDO','OH','43609','1818','CY','39095','1957-11-06','F','U',NULL,'N','021','HLT','2928147','92036OH003002605','2014-04-01','2014-03-06 11:47:30','316.00',NULL,NULL,'475.07','159.07','R-OH001','OH0','475.07',NULL,0,'2014-03-06 21:02:20'),(29040,22985,'N','19','021','EC','A',NULL,NULL,'','0000239095','0000515896','','IL','1','MITCHELL','GRIFFIN','','','','34','278154772','2616 WILLOW RD',0,'SPRINGFIELD','OH','45502','9596','CY','39023','2009-04-13','M','',NULL,'N','021','DEN','3542283','99734OH005000401','2014-04-01','2014-03-10 13:16:43',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-03-10 21:01:41'),(14722,11755,'Y','18','021','EC','A','','','AC','0001537834','0001537834','LA00001788050','IL','1','MILLER','ROSE','','','','34','439313819','1044 NECESSITY LN',0,'BASILE','LA','70515','5315','CY','22039','1971-09-04','F','M',':RET:2106-3','N','021','DEN','1864587','18575LA002000201','2014-02-01','2013-12-28 14:16:43','0.00',NULL,NULL,'29.22','29.22','R-LA003','LA0','14.61',NULL,1,'2013-12-29 11:09:36'),(26607,21096,'Y','18','021','EC','A','','','AC','0000896513','0000896513','TX00003481946','IL','1','Aguilar','Adrian','','','','34','631202882','1601 BRAHMAN ST',0,'MERCEDES','TX','78570','4024','CY','48215','1991-01-13','M','U',':RET:2106-3','N','021','DEN','2812421','33348TX002000201','2014-04-01','2014-02-27 22:48:28','0.00',NULL,NULL,'14.61','14.61','R-TX015','TX0','14.61',NULL,0,'2014-02-28 21:30:45'),(25977,20602,'Y','18','021','EC','A','','','AC','0000690795','0000690795','OH00003190407','IL','1','CRAWFORD','BILLY','R','','','34','273667450','44 JONES ALY',0,'CINCINNATI','OH','45215','1338','CY','39061','1961-04-11','M','U',NULL,'N','021','DEN','3216981','99734OH005000401','2014-04-01','2014-02-26 15:27:56','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2014-02-26 21:01:49'),(25769,20437,'N','01','021','EC','A',NULL,NULL,'','0001168054','0000766009','','IL','1','MASON','ANGELA','','','','34','291785797','3800 Milner rd',0,'Newark','OH','43055',NULL,'CY','39089','1982-05-31','F','',NULL,'N','021','DEN','3409536','99734OH005000301','2014-04-01','2014-02-24 13:04:44',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-26 09:30:55'),(22018,17579,'Y','18','021','EC','A','','','AC','0000402821','0000402821','MS00002392112','IL','1','DAVISON','GLORIA','A','','','34','426216710','1427 QUEEN ST',0,'LAUREL','MS','39440',NULL,'CY','28067','1961-05-20','F','U',':RET:2054-5','N','021','DEN','3009324','46300MS002000101','2014-03-01','2014-02-07 16:39:23','0.00',NULL,NULL,'27.15','27.15','R-MS004','MS0','27.15',NULL,0,'2014-02-07 19:00:56'),(8071,6392,'Y','18','021','EC','A','','','AC','0000091130','0000091130','OH00000247345','IL','1','Clark','Margaret','','','','34','316580928','3394 COLE RD',0,'AMELIA','OH','45102','1843','CY','39025','1951-08-30','F','M',':RET:2106-3','N','021','HLT','1923653','92036OH004000601','2014-01-01','2013-12-20 09:46:46','0.00',NULL,NULL,'495.91','495.91','R-OH005','OH0','495.91',NULL,0,'2013-12-26 03:10:13'),(5577,4424,'N','01','021','EC','A',NULL,NULL,'','0000863428','0000254505','','IL','1','kennedy','Roberta','Ann','','','34','292547822','1633parkridgeln.',0,'toledo','OH','43614',NULL,'CY','39095','1952-11-15','F','',':RET:2106-3','N','021','DEN','29787','99734OH005000401','2014-01-01','2013-11-06 14:24:39',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-25 23:16:51'),(4763,3778,'Y','18','021','EC','A','','','AC','0000039781','0000039781','OH00000560079','31','1','Kirby','Donald','','','','34','592182676','PO Box 496',0,'Franklin','OH','45005',NULL,'CY','39017','1983-01-18','M','U',NULL,'N','021','DEN','14570','99734OH005000401','2014-01-01','2013-12-07 21:22:04','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','0.00',NULL,0,'2013-12-25 22:15:36'),(28623,22652,'Y','18','021','EC','A','','','AC','0000450927','0000450927','TX00003115219','IL','1','Jones','Jermaine','R','','','34','631344039','1023 AUBURN VIEW LN',0,'FRESNO','TX','77545','2035','CY','48157','1987-09-14','M','U',':RET:2054-5','N','021','DEN','4159555','33348TX002000201','2014-04-01','2014-03-08 09:35:50','0.00',NULL,NULL,'15.85','15.85','R-TX010','TX0','15.85',NULL,0,'2014-03-08 21:30:22'),(16570,13254,'Y','18','021','EC','A','','','AC','0000430285','0000430285','OH00001074280','IL','1','Hoot','Samantha','','','','34','274901087','1128 S 5th St',0,'Waterville','OH','43566',NULL,'CY','39095','1988-10-26','F','U',':RET:2106-3','N','021','HLT','2121573','92036OH006002601','2014-02-01','2014-01-04 20:46:26','118.00',NULL,NULL,'155.27','37.27','R-OH001','OH0','155.27',NULL,1,'2014-01-07 10:23:18'),(25346,20111,'Y','18','024','14','A','','','TE','0001368857','0001368857','','IL','1','Lee','Jennifer',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-11-27','F','',NULL,NULL,NULL,'','2600159','','2014-03-11','2014-02-24 18:12:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-25 21:30:28'),(2521,2055,'N','01','021','EC','A',NULL,NULL,'','0000249097','0001038571','','IL','1','HOPKINS','GARY','','','','34','288505286','66 N 4TH ST',0,'RITTMAN','OH','44270','1334','CY','39169','1950-10-29','M','',':RET:2106-3','N','021','HLT','1216725','52664OH152000901','2014-01-01','2013-12-09 13:16:11',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','482.18',NULL,0,'2013-12-25 19:36:36'),(16536,13227,'N','19','021','EC','A',NULL,NULL,'','0000499319','0000145399','','IL','1','JONES','BROOKE','','','','34','589634010','242 GREAT OAKS TRL',0,'WADSWORTH','OH','44281','8208','CY','39103','1996-08-05','F','',':RET:2106-3','N','021','HLT','1968912','52664OH152000901','2014-02-01','2014-01-04 23:43:32',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','103.72',NULL,1,'2014-01-07 10:22:11'),(18179,14515,'Y','18','021','EC','A','','','AC','0000359699','0000359699','OH00002338526','IL','1','ELSTON','DIANA','L','','','34','294729544','218 E TOWNLINE STREET',0,'PAYNE','OH','45891',NULL,'CY','39161','1962-01-26','F','M',':RET:2106-3','N','021','HLT','1775806','92036OH005001506','2014-02-01','2014-01-14 10:18:33','912.00',NULL,NULL,'1020.07','108.07','R-OH002','OH0','429.60',NULL,0,'2014-01-15 02:08:00'),(2113,1733,'Y','18','021','EC','A','','','AC','0000474933','0000474933','OH00000861689','IL','1','Dockery','Deborah','','','','34','271542016','74 YOUTZ AVE',0,'AKRON','OH','44301','2526','CY','39153','1952-01-23','F','U',':RET:2106-3','N','021','DEN','379800','99734OH005000401','2014-01-01','2013-12-10 10:53:17','0.00',NULL,NULL,'15.78','15.78','R-OH012','OH0','0.00',NULL,0,'2013-12-25 19:17:30'),(14630,11677,'Y','18','021','EC','A','','','AC','0000679539','0000679539','OH00001761017','IL','1','Davis','Sharon','','','','34','272529424','2500 TROY RD',0,'SPRINGFIELD','OH','45504','4236','CY','39023','1951-07-09','F','M',':RET:2106-3','T','021','HLT','1946785','92036OH003000504','2014-02-01','2013-12-27 12:37:49','394.00',NULL,NULL,'820.16','426.16','R-OH003','OH0','820.16',NULL,0,'2013-12-28 03:37:10'),(877,725,'N','01','021','EC','A',NULL,NULL,'','0000305823','0000593656','','IL','1','Chadwick','Jennifer','Anne','','','34','278647456','17 EDGEWOOD DR',0,'ARCANUM','OH','45304','1431','CY','39037','1972-01-18','F','',':RET:2106-3','N','021','HLT','1528684','92036OH001000501','2014-01-01','2013-12-16 10:10:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','373.32',NULL,0,'2013-12-25 18:07:36'),(15486,12390,'Y','18','021','EC','A','','','AC','0000388654','0000388654','OH00001689699','IL','1','GARNER','PHILLIP','','','','34','345704102','6102 CAPLINGER AVE',0,'WESTERVILLE','OH','43081',NULL,'CY','39049','1978-07-09','M','M',NULL,'N','021','DEN','2189640','99734OH005000401','2014-02-01','2013-12-31 10:14:29','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,1,'2014-01-02 04:29:20'),(25691,20383,'N','19','021','EC','A',NULL,NULL,'','0001260065','0001099232','','S1','1','Geer','Kenneth','','','','34','289086702','6030 FERRY RD',0,'WAKEMAN','OH','44889','9405','CY','39077','2003-10-15','F','',':RET:2106-3','N','021','HLT','2776711','92036OH003002704','2014-04-01','2014-02-23 20:33:38',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','129.31',NULL,0,'2014-02-26 09:30:12'),(13055,10407,'Y','18','024','14','A','','','TE','0000530677','0000530677','','IL','1','BUCHER','LINDA',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1949-11-25','F','',NULL,NULL,NULL,'','2385873','','2013-12-23','2013-12-23 09:14:57',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-26 12:50:56'),(434,357,'Y','18','021','EC','A','','','AC','0000109258','0000109258','OH00001044095','IL','1','Campbell','Jennifer','','','','34','280581680','6936 Highlandview Dr',0,'Concord Twp','OH','44077',NULL,'CY','39085','1956-10-11','F','U',':RET:2106-3','T','021','DEN','687242','99734OH005000401','2014-01-01','2013-12-04 08:24:43','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 17:47:00'),(26538,21044,'Y','18','021','EC','A','','','AC','0000106767','0000106767','OH00002374151','IL','1','Williams','Letitia','','','','34','271780312','345 Wise Rd.',0,'Lynchburg','OH','45142',NULL,'CY','39071','1977-04-26','F','M',':RET:2106-3','N','021','DEN','3877889','99734OH005000301','2014-03-01','2014-02-28 10:30:59','0.00',NULL,NULL,'21.13','21.13','R-OH005','OH0','0.00',NULL,0,'2014-02-28 21:30:06'),(13759,10982,'Y','18','021','EC','A','','','AC','0000156982','0000156982','MS00000399831','IL','1','johnson','alon','','','','34','428133947','331 SUGGS ST',0,'WATER VALLEY','MS','38965','1622','CY','28161','1977-08-20','M','U',':RET:2054-5','N','021','DEN','2561511','46300MS002000201','2014-01-01','2013-12-23 09:29:43','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2013-12-26 13:10:10'),(1322,1093,'Y','18','021','EC','A','','','AC','0000987352','0000987352','OH00001017976','IL','1','Light','Kristine','E','','','34','071500015','137 Vance st',0,'Bluffton','OH','45817',NULL,'CY','39003','1968-01-24','F','U',NULL,'T','021','HLT','510565','92036OH001001501','2014-01-01','2013-11-03 23:06:48','0.00',NULL,NULL,'440.85','440.85','R-OH002','OH0','440.85',NULL,0,'2013-12-25 18:31:46'),(24658,19574,'N','01','021','EC','A',NULL,NULL,'','0000509255','0000637164','','IL','1','jackson','norman','','','','34','285724497','817 HOAG ST',0,'TOLEDO','OH','43607','4114','CY','39095','1968-06-18','M','',NULL,'N','021','HLT','3338672','92036OH004002601','2014-04-01','2014-02-19 15:38:13',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','226.41',NULL,0,'2014-02-20 04:24:57'),(24108,19165,'Y','18','021','EC','A','','','AC','0000926657','0000926657','TX00002660634','IL','1','holguin','gloria','lee','','','34','464027814','4502 HAYNES AVE',0,'LAREDO','TX','78041','6637','CY','48479','1954-10-23','F','M',':RET:2106-3','N','021','DEN','3005112','33348TX002000201','2014-03-01','2014-02-14 20:18:31','0.00',NULL,NULL,'29.22','29.22','R-TX012','TX0','14.61',NULL,0,'2014-02-15 22:01:35'),(9160,7266,'N','19','021','EC','A',NULL,NULL,'','0000929828','0000938511','','IL','1','Plum','Berit','','','','34','196956011','6246 BENNEVILLE ST',0,'CINCINNATI','OH','45230','1901','CY','39061','2012-01-09','F','',':RET:2106-3','N','021','HLT','2232955','92036OH005001201','2014-01-01','2013-12-18 06:18:18',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','136.32',NULL,0,'2013-12-26 04:08:42'),(2010,1649,'Y','18','021','EC','A','','','AC','0000716858','0000716858','LA00000953265','IL','1','Malloy','Tasha','','','','34','168565852','5960 Winchester Park Drive',0,'New Orleans','LA','70128',NULL,'CY','22071','1971-06-20','F','U',':RET:1002-5^:RET:2054-5','T','021','DEN','598545','18575LA002000201','2014-01-01','2013-11-20 12:10:43','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 19:02:28'),(27752,21946,'Y','18','021','EC','A','','','AC','0002324992','0002324992','LA00002819486','IL','1','Jones','Martin','','','','34','458456112','14305 Vincent Place Ave.',0,'Denham Springs','LA','70726',NULL,'CY','22063','1963-03-29','M','M',NULL,'T','021','DEN','3195607','18575LA002000201','2014-04-01','2014-03-05 08:48:54','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-03-05 21:31:16'),(26301,20865,'Y','18','021','EC','A','','','AC','0000731248','0000731248','OH00002506215','IL','1','NORRIS','JACQULIN','','','','34','270506738','1 EVERGREEN DR',0,'NORWALK','OH','44857','2383','CY','39077','1950-01-01','F','U',':RET:2106-3','N','021','HLT','2994078','92036OH005002705','2014-03-01','2014-02-27 09:44:34','521.00',NULL,NULL,'584.98','63.98','R-OH006','OH0','584.98',NULL,0,'2014-02-28 06:31:29'),(25036,19853,'Y','18','024','14','A','','','TE','0002090690','0002090690','','IL','1','Ancar','Donna',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1954-10-17','F','',NULL,NULL,NULL,'','2117589','','2014-03-07','2014-02-20 17:13:49',NULL,NULL,NULL,NULL,NULL,NULL,'LA0',NULL,'TERM',0,'2014-02-20 22:01:06'),(9261,7345,'Y','18','021','EC','A','','','AC','0000829855','0000829855','LA00001181849','IL','1','Goings','Flora','','','','34','433680422','2320 BARTHOLOMEW ST',0,'NEW ORLEANS','LA','70117','5018','CY','22071','1941-03-06','F','U',':RET:2054-5','N','021','DEN','450279','18575LA002000201','2014-01-01','2013-11-29 18:42:14','0.00',NULL,NULL,'16.22','16.22','R-LA001','LA0','16.22',NULL,0,'2013-12-26 04:15:19'),(20985,16771,'Y','18','021','EC','A','','','AC','0000979330','0000979330','OH00002079273','IL','1','Bailey','Larry','','','','34','278927350','431 SUNNYBROOK DR',0,'FRANKLIN','OH','45005','2441','CY','39165','1987-06-08','M','U',':RET:2106-3','N','021','HLT','2889402','92036OH003001205','2014-03-01','2014-01-31 20:19:07','85.00',NULL,NULL,'229.56','144.56','R-OH004','OH0','229.56',NULL,0,'2014-02-01 19:00:22'),(18840,15006,'Y','18','021','EC','A','','','AC','0001237735','0001237735','OH00001750076','IL','1','Foster','Jill','','','','34','277862665','2939 FAIR OAKS DR',0,'NORTON','OH','44203','6334','CY','39153','1975-04-04','F','U',':RET:2106-3','N','021','HLT','2424874','52664OH151001306','2014-03-01','2014-01-16 12:28:56','192.00',NULL,NULL,'277.87','85.87','R-OH012','OH0','277.87',NULL,0,'2014-01-17 03:36:13'),(4655,3691,'Y','18','021','EC','A','','','AC','0001004143','0001004143','LA00001110758','IL','1','Caraway','George','','','','34','436983679','24 Belle Grove Drive',0,'Destrehan','LA','70047',NULL,'CY','22089','1955-04-02','M','M',':RET:2106-3','N','021','DEN','345801','18575LA002000201','2014-01-01','2013-12-12 09:12:57','0.00',NULL,NULL,'29.22','29.22','R-LA001','LA0','14.61',NULL,0,'2013-12-25 22:07:13'),(6031,4775,'Y','18','024','14','A','','','TE','0000589337','0000589337','','IL','1','mohon','jeremy',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1986-02-20','M','',NULL,NULL,NULL,'','842153','','2013-11-30','2013-11-30 23:49:17',NULL,NULL,NULL,NULL,NULL,NULL,'TX0',NULL,'CANCEL',0,'2013-12-26 00:01:08'),(28315,22402,'N','01','021','EC','A',NULL,NULL,'','0001179578','0000402421','','IL','1','Cantrell','Cassandra','','','','34','290088278','65 W MAIN ST',0,'SARDINIA','OH','45171','8000','CY','39071','1984-10-14','F','',':RET:2106-3','N','021','HLT','3668637','92036OH002000601','2014-04-01','2014-03-07 16:23:55',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','277.40','CIC',0,'2014-03-07 21:00:37'),(2387,1948,'Y','18','021','EC','A','','','AC','0000464607','0000464607','OH00000876384','IL','1','Goddard','Patsy','J','','','34','295524635','360 GALE AVE',0,'NEWPORT','OH','45768','5035','CY','39167','1952-01-26','F','U',':RET:2106-3','N','021','DEN','191158','99734OH005000401','2014-01-01','2013-12-09 11:31:14','0.00',NULL,NULL,'15.78','15.78','R-OH017','OH0','0.00',NULL,0,'2013-12-25 19:33:10'),(21039,16810,'Y','18','021','EC','A','','','AC','0000942028','0000942028','OH00002248130','IL','1','Hittle','Cheryl','Lynn','','','34','293820998','1024 CLEPPER LN',0,'BATAVIA','OH','45103','2351','CY','39025','1982-10-09','F','M',':RET:2106-3','N','021','HLT','2757257','92036OH005000605','2014-03-01','2014-02-01 14:27:48','305.00',NULL,NULL,'505.97','200.97','R-OH005','OH0','248.81',NULL,0,'2014-02-01 19:00:49'),(4113,3287,'Y','18','021','EC','A','','','AC','0000442158','0000442158','OH00001048404','IL','1','Moss','Danielle','Niccole','','','34','282845684','275 W 9TH ST',0,'MARYSVILLE','OH','43040','1502','CY','39159','1986-01-30','F','M',':RET:2106-3','N','021','DEN','1754565','99734OH005000301','2014-01-01','2013-12-16 20:23:23','0.00',NULL,NULL,'21.13','21.13','R-OH009','OH0','0.00',NULL,0,'2013-12-25 21:48:03'),(2782,2249,'Y','18','021','EC','A','','','AC','0000305806','0000305806','OH00000388991','IL','1','Moores','Pamela','','','','34','296448309','8759 ANGOLA RD',0,'HOLLAND','OH','43528','8816','CY','39095','1958-10-01','F','M',':RET:2106-3','N','021','HLT','1006131','92036OH004002601','2014-01-01','2013-12-02 14:38:18','459.00',NULL,NULL,'749.15','290.15','R-OH001','OH0','349.65',NULL,0,'2013-12-25 19:49:54'),(13979,11138,'N','01','021','EC','A',NULL,NULL,'','0000553911','0000818575','','IL','1','Hundley','Jill','','','','34','299485408','192 COUNTRY VIEW DR',0,'HARRISON','OH','45030',NULL,'CY','39061','1964-07-29','F','',':RET:2106-3','N','021','HLT','2519518','92036OH004001201','2014-01-01','2013-12-23 11:07:35',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','294.48',NULL,0,'2013-12-26 13:15:33'),(26994,21380,'N','19','021','EC','A',NULL,NULL,'','0000779160','0000005898','','IL','1','Vo','Christy','','','','34','298086173','6938 Hawksbeard dr',0,'Westerville','OH','43082',NULL,'CY','39041','2004-05-03','F','',':RET:2047-9','N','021','DEN','3839908','99734OH005000301','2014-04-01','2014-03-02 11:43:22',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00','CIC',0,'2014-03-03 01:29:59'),(116,101,'N','19','021','EC','A',NULL,NULL,'','0000745350','0001182291','','IL','1','KERVIN','DIAMOND','','','','34','260776073','10865 COLONIAL HEIGHTS LANE',0,'FORT WORTH','TX','76179',NULL,'CY','48439','1990-12-23','F','',NULL,'N','021','DEN','13983','33348TX002000201','2014-01-01','2013-12-05 15:16:33',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 17:18:05'),(5286,4188,'N','01','021','EC','A',NULL,NULL,'','0000061308','0000086412','','IL','1','Landry','Christine','Mary','','','34','279502516','3188 SURREY HILL LN',0,'STOW','OH','44224','4757','CY','39153','1950-02-23','F','',':RET:2106-3','N','021','HLT','2104845','52664OH151001305','2014-01-01','2013-12-19 15:26:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','658.32',NULL,0,'2013-12-25 23:05:54'),(5736,4553,'Y','18','021','EC','A','','','AC','0001842601','0001842601','LA00000337408','IL','1','BATTERMAN','MICHAEL','ANDREW','','','34','074548904','1821 DELACHAISE ST',0,'NEW ORLEANS','LA','70115','5326','CY','22071','1967-05-29','M','M',':RET:2106-3','N','021','DEN','2556920','18575LA002000201','2014-01-01','2013-12-23 23:08:57','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-25 23:45:49'),(635,525,'Y','18','024','14','A','','','TE','0000827134','0000827134','','IL','1','Churchill','Gary',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-03-04','M','',NULL,NULL,NULL,'','289986','','2013-12-16','2013-12-16 13:19:58',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-25 18:01:12'),(13795,11012,'Y','18','021','EC','A','','','AC','0000053524','0000053524','MS00000642064','31','1','JAMES','CEDRIC','ALTON','','','34','427575181','P.O. BOX 9076',0,'GREENWOOD','MS','38930',NULL,'CY','28083','1975-09-12','M','M',':RET:2054-5','N','021','DEN','2209571','46300MS002000101','2014-01-01','2013-12-23 10:18:31','0.00',NULL,NULL,'27.15','27.15','R-MS006','MS0','27.15',NULL,0,'2013-12-26 13:11:12'),(14981,11972,'Y','18','021','EC','A','','','AC','0001162013','0001162013','TX00000331209','IL','1','waller','terry','','','','34','449020214','4712 COUNTRY AIRE DR',0,'WACO','TX','76708','5629','CY','48309','1955-05-11','M','U',':RET:2106-3','N','021','DEN','1682527','33348TX002000201','2014-02-01','2013-12-30 13:56:27','0.00',NULL,NULL,'14.61','14.61','R-TX024','TX0','14.61',NULL,0,'2014-01-01 12:01:04'),(7474,5914,'Y','18','021','EC','A','','','AC','0000393653','0000393653','OH00001160073','IL','1','McGee','Matthew','','','','34','290920338','34330 ROSEWOOD TRL',0,'WILLOUGHBY HILLS','OH','44094','8479','CY','39085','1988-03-01','M','U',':RET:2106-3','N','021','DEN','1089459','99734OH005000401','2014-01-01','2013-12-15 08:31:36','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-26 02:31:15'),(3873,3101,'Y','18','021','EC','A','','','AC','0000467572','0000467572','LA00000597563','IL','1','Schilling','Barbara','','','','34','435860082','54112 HIGHWAY 16',0,'BOGALUSA','LA','70427','1244','CY','22117','1953-02-17','F','M',NULL,'N','021','DEN','484427','18575LA002000201','2014-01-01','2013-12-13 11:48:15','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2013-12-25 21:36:14'),(27703,21907,'Y','18','021','EC','A','','','AC','0000208181','0000208181','TX00002340970','IL','1','Iles','Marvin','','','','34','455198110','109 SALLY ST',0,'JOSHUA','TX','76058','3142','CY','48251','1960-02-26','M','U',':RET:2106-3','T','021','DEN','3302229','33348TX002000201','2014-04-01','2014-03-05 12:01:37','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-03-05 21:30:49'),(24632,19549,'Y','18','021','EC','A','','','AC','0001193474','0001193474','LA00002271908','IL','1','Scott','Jesse','','','','34','437136504','700 K ST',0,'MONROE','LA','71201','4720','CY','22073','1959-07-19','M','U',':RET:2106-3','N','021','DEN','2714365','18575LA002000201','2014-04-01','2014-02-19 09:46:45','0.00',NULL,NULL,'14.61','14.61','R-LA007','LA0','14.61',NULL,0,'2014-02-20 04:18:02'),(23384,18634,'Y','18','021','EC','A','','','AC','0000323550','0000323550','OH00002476168','IL','1','CONLEY','KELLEY','','','','34','275908080','1435 FAIRLANE AVE SW',0,'CANTON','OH','44710','1349','CY','39151','1983-01-31','F','M',NULL,'T','021','DEN','3338533','99734OH005000401','2014-03-01','2014-02-13 13:54:17','0.00',NULL,NULL,'31.57','31.57','R-OH015','OH0','0.00',NULL,0,'2014-02-13 22:01:01'),(4139,3302,'Y','18','021','EC','A','','','AC','0000690729','0000690729','OH00000076544','IL','1','DOANE','JOYCE','','','','34','289465272','2118 41ST ST NW',0,'CANTON','OH','44709','2339','CY','39151','1949-11-30','F','U',':RET:2106-3','N','021','DEN','1865256','99734OH005000301','2014-01-01','2013-12-17 11:44:36','0.00',NULL,NULL,'21.13','21.13','R-OH015','OH0','0.00',NULL,0,'2013-12-25 21:48:32'),(13934,11114,'Y','18','021','EC','A','','','AC','0000481075','0000481075','OH00001311499','IL','1','Godwin','Amy','','','','34','293820408','735 LOUISIANA AVE',0,'PERRYSBURG','OH','43551','2334','CY','39173','1978-09-02','F','U',NULL,'N','021','HLT','1807283','92036OH004002601','2014-01-01','2013-12-23 12:44:05','174.00',NULL,NULL,'191.59','17.59','R-OH001','OH0','191.59',NULL,0,'2013-12-26 13:14:34'),(7146,5670,'Y','18','021','EC','A','','','AC','0000897589','0000897589','TX00001287410','IL','1','Walters','Jan','','','','34','467905273','2813 COLLEEN DR',0,'GARLAND','TX','75043','1216','CY','48113','1950-04-09','F','U',':RET:2106-3','N','021','DEN','2515714','33348TX002000101','2014-02-01','2013-12-25 00:09:17','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2013-12-26 01:52:03'),(28604,22638,'Y','18','021','EC','A','','','AC','0000323566','0000323566','OH00003456590','IL','1','Libman','Douglas','','','','34','285883854','P.O. Box 673',0,'LaGrange','OH','44050',NULL,'CY','39093','1976-04-22','M','U',':RET:2106-3','N','021','DEN','3608793','99734OH005000401','2014-04-01','2014-03-08 14:14:39','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2014-03-08 21:30:11'),(28576,22614,'Y','18','021','EC','A','','','AC','0000439680','0000439680','TX00003753649','IL','1','Hoshimiya','Stacey','','','','34','615079691','2107 RABB GLEN ST',0,'AUSTIN','TX','78704','3945','CY','48453','1973-12-02','F','U',':RET:2039-6^:RET:2106-3','N','021','DEN','3567569','33348TX002000201','2014-04-01','2014-03-08 13:07:00','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85','CIC',0,'2014-03-08 21:00:04'),(24783,19659,'Y','18','021','EC','A','','','AC','0000947441','0000947441','OH00002802438','IL','1','GARZA','EMILY','','','','34','280843026','2028 E 37TH ST',0,'LORAIN','OH','44055','2703','CY','39093','1982-04-26','F','M',':RET:2106-3','T','021','DEN','2678422','99734OH005000401','2014-04-01','2014-02-19 12:40:40','0.00',NULL,NULL,'31.57','31.57','R-OH011','OH0','0.00',NULL,0,'2014-02-20 04:45:49'),(20585,16448,'Y','18','021','EC','A','','','AC','0001059505','0001059505','OH00002369792','IL','1','Phipps','Tad','','','','34','297761178','5624A Hibernia Dr',0,'Columbus','OH','43232',NULL,'CY','39049','1968-01-06','M','M',':RET:2106-3','T','021','DEN','2943858','99734OH005000401','2014-03-01','2014-01-29 20:29:26','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-01-30 21:00:05'),(21618,17261,'N','01','021','EC','A',NULL,NULL,'','0000230793','0000043603','','IL','1','Yilma','Ataklet',NULL,NULL,NULL,NULL,NULL,'12349 METRIC BLVD',0,'AUSTIN','TX','78758','2585','CY','48453','1979-11-15','F','',NULL,'N','021','DEN','3094368','33348TX002000201','2014-03-01','2014-02-04 20:13:59',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2014-02-05 21:30:37'),(21669,17305,'N','01','021','EC','A',NULL,NULL,'','0001441723','0001241393','','IL','1','tardo','Joel','','','','34','439673412','2421 MARGARET LN',0,'MERAUX','LA','70075','2731','CY','22087','1982-09-25','M','',':RET:2106-3','N','021','DEN','3440477','18575LA002000201','2014-03-01','2014-02-05 15:12:38',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2014-02-05 21:30:58'),(18022,14397,'Y','18','021','EC','A','','','AC','0000298251','0000298251','OH00002392631','IL','1','BENTLEY','VERNEVA','','','','34','272542462','427 SAINT ANDREWS LN',0,'BROADVIEW HTS','OH','44147','3082','CY','39035','1951-07-04','F','U',NULL,'N','021','DEN','2100730','99734OH005000301','2014-02-01','2014-01-14 13:17:18','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2014-01-15 02:07:06'),(17336,13867,'Y','18','021','EC','A','','','AC','0001413927','0001413927','LA00002206669','31','1','levi','trelissa','','','','34','435711527','p.o. box23',0,'batchelor','LA','70715',NULL,'CY','22077','1988-04-13','F','U',':RET:2054-5','N','021','DEN','2376722','18575LA002000201','2014-02-01','2014-01-10 14:03:26','0.00',NULL,NULL,'14.61','14.61','R-LA005','LA0','14.61',NULL,0,'2014-01-13 02:23:59'),(13585,10835,'Y','18','021','EC','A','','','AC','0002312698','0002312698','LA00000472300','IL','1','Harris','Deyandra','','','','34','436613720','2212 Independence Street',0,'New Orleans','LA','70117',NULL,'CY','22071','1975-09-08','F','U',':RET:2054-5','N','021','DEN','2252658','18575LA002000201','2014-01-01','2013-12-23 18:23:54','0.00',NULL,NULL,'14.61','14.61','R-LA001','LA0','14.61',NULL,0,'2013-12-26 13:05:00'),(6487,5138,'Y','18','021','EC','A','','','AC','0000500377','0000500377','OH00000737789','IL','1','Scheible','Bradley','','','','34','294564344','4001 Osage St',0,'Stow','OH','44224',NULL,'CY','39153','1954-11-22','M','U',NULL,'N','021','HLT','333368','52664OH151001305','2014-01-01','2013-12-11 11:17:46','466.00',NULL,NULL,'580.49','114.49','R-OH012','OH0','580.49',NULL,0,'2013-12-26 00:50:28'),(24262,19267,'Y','18','021','EC','A','','','AC','0001045450','0001045450','TX00002652998','IL','1','devidegaray','cindy','','','','34','627039543','1304 MCKIE DR',0,'AUSTIN','TX','78752','2851','CY','48453','1987-05-10','F','U',':RET:2106-3','N','021','DEN','3083381','33348TX002000101','2014-04-01','2014-02-17 01:17:05','0.00',NULL,NULL,'27.15','27.15','R-TX003','TX0','27.15',NULL,0,'2014-02-17 19:00:11'),(23003,18338,'Y','18','024','14','A','','','TE','0000361049','0000361049','','IL','1','bricker','kevin',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1958-06-14','M','',NULL,NULL,NULL,'','3194870','','2014-02-12','2014-02-12 14:35:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-02-12 21:30:19'),(1643,1373,'Y','18','021','EC','A','','','AC','0000511504','0000511504','TX00001257228','IL','1','Hollins','Carlton','','','','34','436139343','214 RAY CREEK DR',0,'LONGVIEW','TX','75605','1207','CY','48183','1970-01-20','M','M',':RET:2054-5','N','021','DEN','1715447','33348TX002000201','2014-01-01','2013-12-24 15:46:16','0.00',NULL,NULL,'14.61','14.61','R-TX013','TX0','14.61',NULL,0,'2013-12-25 18:53:08'),(2389,1950,'Y','18','021','EC','A','','','AC','0000231480','0000231480','OH00000414259','IL','1','Conner','Chasity','','','','34','285963927','402 FOUR SEASONS DR',0,'MASON','OH','45040','1967','CY','39165','1993-08-04','F','R',':RET:2106-3','N','021','DEN','1007520','99734OH005000401','2014-01-01','2013-12-09 11:59:06','0.00',NULL,NULL,'15.78','15.78','R-OH004','OH0','15.78',NULL,0,'2013-12-25 19:33:13'),(2498,2035,'N','01','021','EC','A',NULL,NULL,'','0000161576','0000208237','','IL','1','Pevey','Donna','','','','34','433944964','62549 RUSSELL TOWN RD',0,'ROSELAND','LA','70456','2035','CY','22105','1953-09-12','F','',':RET:2106-3','N','021','DEN','740848','18575LA002000201','2014-01-01','2013-12-09 17:34:25',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','14.61',NULL,0,'2013-12-25 19:35:59'),(17350,13880,'N','19','021','EC','A',NULL,NULL,'','0000443473','0000061333','','IL','1','AHMOUDA','MUHAMED','','','','34','279963277','1366 VIMLA WAY',0,'XENIA','OH','45385','5731','CY','39057','1993-06-14','M','',':RET:2106-3','N','021','HLT','1969042','92036OH005000506','2014-02-01','2014-01-09 19:48:56',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','150.95',NULL,0,'2014-01-13 02:24:08'),(14532,11595,'Y','18','021','EC','A','','','AC','0001015886','0001015886','MS00000269347','IL','1','Johnson','Carolyn','','','','34','426060128','428 Countryside',0,'Vicksburg','MS','39180',NULL,'CY','28149','1953-11-26','F','U',NULL,'N','021','DEN','2490649','46300MS002000201','2014-02-01','2013-12-26 20:06:10','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-28 03:34:36'),(3501,2812,'Y','18','021','EC','A','','','AC','0000995432','0000995432','OH00000487475','IL','1','Chapman','Gregory','','','','34','279486962','12095 Burlington Glen Dr.',0,'Chardon','OH','44024',NULL,'CY','39055','1950-01-05','M','U',':RET:2106-3','N','021','DEN','1704818','99734OH005000401','2014-01-01','2013-12-22 16:35:07','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 21:20:42'),(1563,1304,'N','01','021','EC','A',NULL,NULL,'','0001114090','0000207885','','IL','1','HATTON','ANTHONY','','','','34','459338224','926 SILVER SAGE DR',0,'WYLIE','TX','75098','8603','CY','48085','1968-01-06','M','',':RET:2054-5','N','021','DEN','1863128','33348TX002000201','2014-01-01','2013-12-24 05:08:57',NULL,NULL,NULL,NULL,NULL,NULL,'TX0','15.85',NULL,0,'2013-12-25 18:50:57'),(19867,15847,'Y','18','021','EC','A','','','AC','0000055948','0000055948','OH00001837038','IL','1','Cho','Chae','','','','34','269866155','2405 Cedar Creek Drive',0,'Grove City','OH','43123',NULL,'CY','39049','1952-06-10','M','M',':RET:2040-4','T','021','DEN','2228990','99734OH005000401','2014-03-01','2014-01-23 21:36:33','0.00',NULL,NULL,'31.57','31.57','R-OH009','OH0','0.00',NULL,0,'2014-01-24 21:00:39'),(26170,20751,'Y','18','021','EC','A','','','AC','0001239785','0001239785','MS00002319878','31','1','BROWN','WALTER','','','','34','587562965','P.O BOX 94',0,'CHARLESTON','MS','38921',NULL,'CY','28135','1953-01-06','M','U',':RET:2054-5','N','021','DEN','2687469','46300MS002000201','2014-03-01','2014-02-27 09:23:24','0.00',NULL,NULL,'15.85','15.85','R-MS006','MS0','15.85',NULL,0,'2014-02-28 06:30:36'),(21431,17128,'Y','18','021','EC','A','','','AC','0000530739','0000530739','TX00002488825','IL','1','McDonald','Saige','','','','34','462914727','1800 preston on the lake blvd',0,'little elm','TX','75068',NULL,'CY','48121','1987-11-06','F','U',':RET:2106-3','N','021','DEN','2745271','33348TX002000101','2014-03-01','2014-02-03 23:16:17','0.00',NULL,NULL,'27.15','27.15','R-TX008','TX0','27.15',NULL,0,'2014-02-04 21:01:18'),(20302,16207,'Y','18','021','EC','A','','','AC','0000679919','0000679919','TX00002472603','IL','1','Ohrvall','Jenee','','','','34','456513013','4105 BOLEN ST',0,'FT WORTH','TX','76244','6018','CY','48439','1964-08-05','F','R',':RET:2106-3','N','021','DEN','2002333','33348TX002000201','2014-03-01','2014-01-27 20:19:47','0.00',NULL,NULL,'15.85','15.85','R-TX008','TX0','15.85',NULL,0,'2014-01-28 21:00:44'),(16873,13500,'Y','18','021','EC','A','','','AC','0000875430','0000875430','TX00001413178','IL','1','Grossman','Patrick','','','','34','449858369','401 HUGHSON DR',0,'SAN MARCOS','TX','78666','2585','CY','48209','1987-06-30','M','U',':RET:2106-3','N','021','DEN','1633902','33348TX002000201','2014-02-01','2014-01-09 16:51:10','0.00',NULL,NULL,'15.85','15.85','R-TX003','TX0','15.85',NULL,0,'2014-01-13 02:19:17'),(24214,19232,'Y','18','021','EC','A','','','AC','0000834329','0000834329','TX00002885869','IL','1','PEREZ','CLAUDIA','','','','34','635071419','155 HILLCREST LN',0,'LIBERTY HILL','TX','78642','4436','CY','48491','1986-05-16','F','M',NULL,'N','021','DEN','3676029','33348TX002000201','2014-03-01','2014-02-15 20:13:29','0.00',NULL,NULL,'31.70','31.70','R-TX003','TX0','15.85',NULL,0,'2014-02-16 19:00:25'),(23756,18909,'N','19','021','EC','A',NULL,NULL,'','0000661393','0000890796','','S1','1','Falck','Frank','Rose','','','34','276068401','461 North Street',0,'Batavia','OH','45103',NULL,'CY','39025','2001-02-07','F','',':RET:2106-3','N','021','DEN','2834135','99734OH005000301','2014-03-01','2014-02-14 08:35:54',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-14 21:31:08'),(23617,18810,'Y','18','021','EC','A','','','AC','0000730018','0000730018','OH00002402723','IL','1','SPOERR','ALBERT','','','','34','296507478','600 N SANDUSKY ST',0,'BELLEVUE','OH','44811','1251','CY','39077','1951-01-08','M','M',NULL,'N','021','HLT','3324397','92036OH004002701','2014-03-01','2014-02-13 14:51:18','218.00',NULL,NULL,'462.84','244.84','R-OH006','OH0','462.84',NULL,0,'2014-02-13 22:03:16'),(22290,17795,'Y','18','021','EC','A','','','AC','0000298261','0000298261','OH00001595536','IL','1','Schmehl','Carol','A','','','34','269741201','01909 Feeder Rd',0,'St Marys','OH','45885',NULL,'CY','39011','1964-10-29','F','M',':RET:2106-3','N','021','HLT','2960220','92036OH003001501','2014-03-01','2014-01-24 22:11:29','597.00',NULL,NULL,'966.72','369.72','R-OH002','OH0','392.11',NULL,0,'2014-02-10 11:00:29'),(1233,1016,'Y','18','021','EC','A','','','AC','0000117045','0000117045','LA00001240022','IL','1','Heuer','Frank','','','','34','439040131','3013 Ridgelake Dr',0,'Metairie','LA','70002',NULL,'CY','22051','1955-07-01','M','U',':RET:2106-3','N','021','DEN','1007377','18575LA002000101','2014-01-01','2013-12-03 09:08:02','0.00',NULL,NULL,'25.02','25.02','R-LA001','LA0','25.02',NULL,0,'2013-12-25 18:20:47'),(9187,7287,'N','19','021','EC','A',NULL,NULL,'','0000232645','0000170147','','IL','1','Yang','Simon','','','','34','098829934','108 S WALNUT ST',0,'NEW BREMEN','OH','45869','1239','CY','39011','1993-10-28','M','',':RET:2034-7','N','021','HLT','1864053','92036OH005001505','2014-01-01','2013-12-18 15:39:24',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','139.76',NULL,0,'2013-12-26 04:09:19'),(7080,5617,'N','01','021','EC','A',NULL,NULL,'','0000463240','0000141518','','IL','1','Skaggs','Ian','Matthew','','','34','286864815','407 LAUREL ST',0,'CHILLICOTHE','OH','45601','1444','CY','39141','1980-02-14','M','',':RET:2106-3','T','021','DEN','1930521','99734OH005000301','2014-02-01','2013-12-25 00:19:30',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2013-12-26 01:50:16'),(2292,1868,'Y','18','021','EC','A','','','AC','0000262700','0000262700','OH00000314516','IL','1','Parker','Christopher','','','','34','593187143','561 EDINBOROUGH DR',0,'BAY VILLAGE','OH','44140','3015','CY','39035','1967-04-20','M','R',':RET:2106-3','N','021','DEN','994016','99734OH005000301','2014-01-01','2013-12-09 15:37:14','0.00',NULL,NULL,'21.13','21.13','R-OH011','OH0','0.00',NULL,0,'2013-12-25 19:30:47'),(1239,1019,'N','01','021','EC','A',NULL,NULL,'','0000805935','0000029760','','IL','1','Allen','Mark','Wayne','','Sr','34','433730294','32455 Leona Ave',0,'White Castle','LA','70788',NULL,'CY','22047','1971-04-28','M','',':RET:2054-5','N','021','DEN','532233','18575LA002000101','2014-01-01','2013-12-03 16:20:22',NULL,NULL,NULL,NULL,NULL,NULL,'LA0','25.02',NULL,0,'2013-12-25 18:20:53'),(25974,20599,'Y','18','024','14','A','','','TE','0001246955','0001246955','','IL','1','WOLLERMAN','RENEE',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1974-09-05','F','',NULL,NULL,NULL,'','2282235','','2014-03-13','2014-02-26 14:37:36',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERM',0,'2014-02-26 21:01:48'),(1259,1038,'Y','18','021','EC','A','','','AC','0000460552','0000460552','OH00000286037','IL','1','LEWIS','RICK','','','','34','286587343','4641 N ELM TREE ROAD',0,'CONOVER','OH','45317',NULL,'CY','39021','1956-01-31','M','U',':RET:2106-3','N','021','HLT','1191823','92036OH002000501','2014-01-01','2013-12-03 14:39:52','431.00',NULL,NULL,'669.00','238.00','R-OH003','OH0','669.00',NULL,0,'2013-12-25 18:21:28'),(23459,18687,'Y','18','021','EC','A','','','AC','0000869211','0000869211','TX00001760679','31','1','PEREZ','SILVIA','NELLY','','','34','465272393','126 LAS LOMAS',0,'RIO GRANDE CITY','TX','78582',NULL,'CY','48427','1967-02-24','F','U',NULL,'N','021','DEN','2973275','33348TX002000201','2014-03-01','2014-02-13 14:21:23','0.00',NULL,NULL,'14.61','14.61','R-TX026','TX0','14.61',NULL,0,'2014-02-13 22:01:42'),(22965,18310,'Y','18','024','14','A','','','TE','0000545210','0000545210','','IL','1','miller','robert','l',NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1951-07-17','M','',NULL,NULL,NULL,'','805878','','2014-02-28','2014-02-12 11:51:47',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'TERMCIC',0,'2014-02-12 21:00:13'),(22282,17787,'Y','18','021','EC','A','','','AC','0001071806','0001071806','OH00002267528','31','1','MCVEY','DAVID','','','','34','622056902','PO Box 8171',0,'Columbus','OH','43201',NULL,'CY','39049','1978-03-29','M','U',NULL,'N','021','DEN','2302553','99734OH005000401','2014-03-01','2014-01-19 20:14:53','0.00',NULL,NULL,'15.78','15.78','R-OH009','OH0','0.00',NULL,0,'2014-02-10 11:00:23'),(3642,2914,'Y','18','021','EC','A','','','AC','0000406663','0000406663','MS00000197562','IL','1','MOORE','ROBERT','WAYNE','','','34','587642360','110 OLD HWY 49 SOUTH BOX8',0,'RICHLAND','MS','39218',NULL,'CY','28121','1951-07-28','M','U',':RET:2106-3','N','021','DEN','1145294','46300MS002000201','2014-01-01','2013-12-13 16:33:23','0.00',NULL,NULL,'15.85','15.85','R-MS003','MS0','15.85',NULL,0,'2013-12-25 21:30:23'),(17793,14213,'Y','18','021','EC','A','','','AC','0000158010','0000158010','OH00001766413','IL','1','MASTERS','DOUGLAS','','','','34','272721309','1703 E SIEBENTHALER AVE',0,'DAYTON','OH','45414','5330','CY','39113','1964-02-14','M','U',':RET:2106-3','N','021','HLT','1639106','92036OH005000505','2014-02-01','2014-01-13 15:37:38','247.00',NULL,NULL,'405.53','158.53','R-OH003','OH0','405.53',NULL,0,'2014-01-14 01:33:49'),(17427,13945,'Y','18','021','EC','A','','','AC','0000817556','0000817556','OH00002458300','IL','1','Digonno','Ruby','','','','34','403801641','2531 REGINA PL',0,'HAMILTON','OH','45013','4812','CY','39017','1953-09-04','F','M',':RET:2106-3','N','021','HLT','2087727','92036OH003001205','2014-02-01','2014-01-10 12:11:31','981.00',NULL,NULL,'1474.88','493.88','R-OH004','OH0','608.42',NULL,0,'2014-01-13 03:00:30'),(24750,19640,'N','19','021','EC','A',NULL,NULL,'','0000720297','0000253096','','IL','1','HENRY','QUAN DEZ','','','','34','270088561','2724 RAPHAEL DR',0,'COLUMBUS','OH','43232','4791','CY','39049','2002-09-09','M','',':RET:2054-5','N','021','DEN','3291586','99734OH005000401','2014-04-01','2014-02-19 10:21:41',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-02-20 04:41:07'),(20814,16633,'Y','18','024','14','A','','','TE','0001160414','0001160414','','IL','1','Boggs','Charlotte',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1960-07-08','F','',NULL,NULL,NULL,'','1492331','','2014-01-31','2014-01-31 13:20:06',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2014-01-31 21:00:30'),(19182,15282,'Y','18','021','EC','A','','','AC','0000842454','0000842454','TX00002488559','IL','1','WALLACE','STEVEN','','','','34','458789355','1402 TEXAS AVE',0,'LUBBOCK','TX','79401',NULL,'CY','48303','1953-01-19','M','U',NULL,'N','021','DEN','2654763','33348TX002000201','2014-03-01','2014-01-20 16:29:11','0.00',NULL,NULL,'14.61','14.61','R-TX014','TX0','14.61',NULL,0,'2014-01-21 08:46:08'),(15755,12605,'Y','18','021','EC','A','','','AC','0001177516','0001177516','TX00000436497','IL','1','Supertzi','Margie','','','','34','462315457','1817 E 52nd St',0,'Odessa','TX','79762',NULL,'CY','48135','1972-05-24','F','R',':RET:2106-3','N','021','DEN','2001766','33348TX002000201','2014-02-01','2014-01-02 18:06:07','0.00',NULL,NULL,'14.61','14.61','R-TX017','TX0','14.61',NULL,0,'2014-01-03 02:01:18'),(1536,1279,'Y','18','021','EC','A','','','AC','0000300414','0000300414','OH00000733637','IL','1','Joyce','Marianne','Beth','','','34','287580588','111 E 199th, APT',0,'Euclid','OH','44119',NULL,'CY','39035','1957-12-08','F','U',NULL,'N','021','DEN','1390471','99734OH005000401','2014-01-01','2013-12-24 16:40:38','0.00',NULL,NULL,'15.78','15.78','R-OH011','OH0','0.00',NULL,0,'2013-12-25 18:50:09'),(14307,11413,'Y','18','024','14','A','','','TE','0000929847','0000929847','','IL','1','RIFE','CARMEN',NULL,NULL,NULL,NULL,NULL,NULL,0,'','','',NULL,NULL,NULL,'1971-08-14','F','',NULL,NULL,NULL,'','1611962','','2013-12-26','2013-12-26 11:07:07',NULL,NULL,NULL,NULL,NULL,NULL,'OH0',NULL,'CANCEL',0,'2013-12-27 02:06:59'),(13200,10533,'Y','18','021','EC','A','','','AC','0000369424','0000369424','TX00001119390','IL','1','McLean','Leslie','','','','34','457111143','22905 STATE HIGHWAY 110 N',0,'TROUP','TX','75789','7337','CY','48073','1954-08-23','F','U',':RET:2106-3','N','021','DEN','1798188','33348TX002000101','2014-01-01','2013-12-23 14:05:37','0.00',NULL,NULL,'25.02','25.02','R-TX026','TX0','25.02',NULL,0,'2013-12-26 12:54:55'),(7640,6049,'Y','18','021','EC','A','','','AC','0000378543','0000378543','OH00000724441','IL','1','Browder','Sandra','','','','34','283680833','714 WASHINGTON ST',0,'VERSAILLES','OH','45380','1346','CY','39037','1960-06-20','F','U',NULL,'N','021','HLT','1118401','92036OH003000505','2014-01-01','2013-10-14 11:12:44','368.00',NULL,NULL,'506.41','138.41','R-OH003','OH0','506.41',NULL,0,'2013-12-26 02:46:32'),(9610,7611,'Y','18','021','EC','A','','','AC','0001165334','0001165334','OH00000112930','IL','1','Morris','Lauress','','','','34','273540631','1333 VERMONT PL NE',0,'CANTON','OH','44714','2157','CY','39151','1960-03-29','F','U',':RET:2106-3','N','021','HLT','2539487','52664OH151001306','2014-01-01','2013-12-21 14:19:58','345.00',NULL,NULL,'454.94','109.94','R-OH015','OH0','454.94',NULL,0,'2013-12-26 04:37:37'),(6802,5395,'N','01','021','EC','A',NULL,NULL,'','0000045723','0000197121','','IL','1','Crick','Christa','K','','','34','283667159','313 S MIAMI AVE',0,'BRADFORD','OH','45308','1217','CY','39037','1965-08-22','F','',':RET:2106-3','T','021','HLT','840784','92036OH003000505','2014-01-01','2013-11-25 10:09:14',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','466.75',NULL,0,'2013-12-26 01:17:25'),(3013,2423,'Y','18','021','EC','A','','','AC','0001186272','0001186272','OH00000552552','IL','1','DeCastro','Robert','','','','34','282806020','1586 NORLEDGE RD',0,'AKRON','OH','44305','1343','CY','39153','1982-09-09','M','M',':RET:2106-3','N','021','HLT','629470','52664OH151001305','2014-01-01','2013-12-06 18:09:05','312.00',NULL,NULL,'511.58','199.58','R-OH012','OH0','258.47',NULL,0,'2013-12-25 20:17:59'),(26048,20658,'Y','18','021','EC','A','','','AC','0000862492','0000862492','OH00002501453','IL','1','FORGACS','CYNTHIA','','','','34','293587258','2304 ECHO VALLEY DR',0,'STOW','OH','44224','2700','CY','39153','1957-04-06','F','M',':RET:2106-3','N','021','HLT','3048556','52664OH151001301','2014-03-01','2014-02-26 16:58:20','196.00',NULL,NULL,'520.28','324.28','R-OH012','OH0','520.28',NULL,0,'2014-02-26 21:02:31'),(23998,19082,'Y','18','021','EC','A','','','AC','0000933252','0000933252','OH00002054243','IL','1','KINKLE','DEBORAH','','','','34','298549751','713 ELSON AVE',0,'VAN WERT','OH','45891','1626','CY','39161','1953-09-12','F','U',':RET:2106-3','N','021','DEN','3094668','99734OH005000401','2014-03-01','2014-02-14 22:21:24','0.00',NULL,NULL,'15.78','15.78','R-OH002','OH0','0.00',NULL,0,'2014-02-15 22:00:31'),(23620,18811,'N','19','021','EC','A',NULL,NULL,'','0000024155','0001103483','','IL','1','Schmidt','Olivia','k','','','34','298062476','15 FARMVIEW CT',0,'HARRISON','OH','45030','2013','CY','39061','2002-04-24','F','',':RET:2106-3','N','021','HLT','3274336','92036OH004001201','2014-03-01','2014-02-13 15:06:17',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','109.61',NULL,0,'2014-02-13 22:03:17'),(19973,15931,'N','01','021','EC','A',NULL,NULL,'','0000305868','0000604735','','IL','1','GLAMBIN','James','','','','34','272604070','119 LOCUST ST',0,'LUCKEY','OH','43443','9741','CY','39173','1960-12-10','M','',':RET:2106-3','N','021','DEN','3398650','99734OH005000301','2014-03-01','2014-01-25 15:24:01',NULL,NULL,NULL,NULL,NULL,NULL,'OH0','0.00',NULL,0,'2014-01-25 19:00:12');
/*!40000 ALTER TABLE `EdiParticipant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiParticipantContact`
--

DROP TABLE IF EXISTS `EdiParticipantContact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiParticipantContact` (
  `EdiParticipantContactId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiParticipantId` bigint(64) NOT NULL,
  `CommunicationNumberQualifier` enum('TP','AP','EM','TE','BN','CP','EX','FX','WP','HP') NOT NULL,
  `CommunicationNumber` varchar(100) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiParticipantContactId`),
  KEY `EdiParticipantContact_EdiParticipantId_fk_idx` (`EdiParticipantId`)
) ENGINE=innodb AUTO_INCREMENT=44016 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiParticipantContact`
--

LOCK TABLES `EdiParticipantContact` WRITE;
/*!40000 ALTER TABLE `EdiParticipantContact` DISABLE KEYS */;
INSERT INTO `EdiParticipantContact` VALUES (16,9,'AP','3308153716',0,'2013-12-25 17:15:16',NULL,NULL),(5990,3848,'AP','3187949980',0,'2013-12-25 21:35:34',NULL,NULL),(22967,14813,'AP','9854454748',1,'2013-12-29 11:14:08',NULL,NULL),(1798,1114,'EM','Missinell@gmail.com',0,'2013-12-25 18:17:36',NULL,NULL),(22660,14609,'EM','MLMQH1@hotmail.com',0,'2013-12-28 03:36:37',NULL,NULL),(12352,8086,'EM','LBROOKS1@FRONTIER.COM',0,'2013-12-26 03:10:33',NULL,NULL),(14752,9648,'AP','7652771361',0,'2013-12-26 04:38:42',NULL,NULL),(14865,9729,'TE','5134246446',0,'2013-12-26 04:45:38',NULL,NULL),(21362,13734,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:30',NULL,NULL),(31843,20788,'EM','ctrauthwein1953@att.net',0,'2014-01-31 21:00:14',NULL,NULL),(33252,21774,'AP','6145981649',0,'2014-02-06 21:00:34',NULL,NULL),(42327,28107,'AP','3305240989',0,'2014-03-06 21:02:14',NULL,NULL),(43283,28757,'AP','2817961344',0,'2014-03-09 21:00:20',NULL,NULL),(10549,6868,'EM','jdgraves86@yahoo.com',0,'2013-12-26 01:31:55',NULL,NULL),(1029,636,'TE','3303729572',0,'2013-12-25 18:01:13',NULL,NULL),(30594,19851,'AP','2162280527',0,'2014-01-24 21:00:31',NULL,NULL),(37886,24993,'EM','amanfiss@gmail.com',0,'2014-02-20 22:00:41',NULL,NULL),(42406,28165,'TE','9375479224',0,'2014-03-06 21:02:45',NULL,NULL),(5509,3525,'EM','jeffstevens829@gmail.com',0,'2013-12-25 21:21:21',NULL,NULL),(28365,18277,'TE','4695346796',0,'2014-01-16 08:44:45',NULL,NULL),(25819,16643,'EM','kcross24@gmail.com',0,'2014-01-08 18:24:18',NULL,NULL),(23482,15144,'TE','5133404465',0,'2014-01-01 12:05:50',NULL,NULL),(23401,15072,'AP','2144152927',0,'2014-01-01 12:03:56',NULL,NULL),(14513,9483,'AP','4192901163',0,'2013-12-26 04:34:42',NULL,NULL),(6301,4060,'AP','4408290684',0,'2013-12-25 21:46:40',NULL,NULL),(3200,2010,'EM','tmalloy504@gmail.com',0,'2013-12-25 19:02:29',NULL,NULL),(33222,21755,'AP','9032887163',0,'2014-02-06 21:00:23',NULL,NULL),(36004,23684,'AP','8453802313',0,'2014-02-14 21:30:33',NULL,NULL),(41050,27273,'TE','9363966767',0,'2014-03-04 21:00:17',NULL,NULL),(29195,18862,'AP','2254446738',0,'2014-01-17 03:36:20',NULL,NULL),(14360,9387,'TE','9032921016',0,'2013-12-26 04:32:15',NULL,NULL),(10381,6765,'AP','9855101040',0,'2013-12-26 01:16:28',NULL,NULL),(2267,1388,'EM','chadmccraine@gmail.com',0,'2013-12-25 18:46:18',NULL,NULL),(10450,6809,'TE','3252775585',0,'2013-12-26 01:30:15',NULL,NULL),(7216,4701,'EM','gregoryg216@gmail.com',0,'2013-12-25 22:08:26',NULL,NULL),(6848,4444,'TE','6148297103',0,'2013-12-25 22:02:12',NULL,NULL),(34608,22694,'TE','8323523895',0,'2014-02-11 21:00:54',NULL,NULL),(35130,23072,'AP','9857899321',0,'2014-02-12 21:30:58',NULL,NULL),(37462,24673,'TE','4199577465',0,'2014-02-20 04:27:42',NULL,NULL),(40837,27136,'TE','5133451090',0,'2014-03-03 21:30:44',NULL,NULL),(41033,27263,'AP','3183663240',0,'2014-03-04 21:00:10',NULL,NULL),(42825,28482,'AP','5138078703',0,'2014-03-07 21:31:36',NULL,NULL),(23529,15183,'EM','childofdune@gmail.com',0,'2014-01-01 12:06:53',NULL,NULL),(628,388,'EM','mmarg1520@sbcglobal.net',0,'2013-12-25 17:45:52',NULL,NULL),(23051,14867,'EM','bender00008@gmail.com',0,'2013-12-30 00:00:08',NULL,NULL),(22234,14331,'TE','5672038450',0,'2013-12-27 02:07:33',NULL,NULL),(36384,23965,'TE','5126355635',0,'2014-02-15 22:00:11',NULL,NULL),(36983,24348,'TE','5129397078',0,'2014-02-18 22:00:25',NULL,NULL),(37461,24666,'EM','andybecky@bright.net',0,'2014-02-20 04:26:57',NULL,NULL),(38597,25505,'BN','3309906699',0,'2014-02-25 21:31:58',NULL,NULL),(43640,28967,'TE','5044353968',0,'2014-03-10 21:01:00',NULL,NULL),(12330,8063,'AP','4192662691',0,'2013-12-26 03:10:01',NULL,NULL),(46,29,'AP','5056994967',0,'2013-12-25 17:15:45',NULL,NULL),(297,183,'TE','3307247875',0,'2013-12-25 17:19:45',NULL,NULL),(10557,6871,'EM','carlos@agillian.com',0,'2013-12-26 01:32:00',NULL,NULL),(9273,6069,'TE','3304593156',0,'2013-12-26 00:02:09',NULL,NULL),(33143,21709,'TE','5137376016',0,'2014-02-05 21:31:14',NULL,NULL),(40915,27188,'AP','9563138844',0,'2014-03-03 21:31:14',NULL,NULL),(22195,14296,'EM','crow.198310@yahoo.com',0,'2013-12-27 02:06:44',NULL,NULL),(8802,5765,'EM','dlyttle@woh.rr.com',0,'2013-12-25 23:46:39',NULL,NULL),(8627,5667,'TE','3306991357',0,'2013-12-25 23:31:56',NULL,NULL),(32491,21229,'EM','neil.jacobsen1@gmail.com',0,'2014-02-03 21:01:08',NULL,NULL),(33292,21800,'AP','5672598898',0,'2014-02-06 21:00:49',NULL,NULL),(33683,22093,'AP','9012623571',0,'2014-02-08 19:00:26',NULL,NULL),(36694,24159,'EM','judith3530@windstream.net',0,'2014-02-15 22:02:02',NULL,NULL),(25677,16553,'TE','2258036205',1,'2014-01-07 10:22:49',NULL,NULL),(22189,14293,'EM','aca.mtartaglia62@yahoo.com',0,'2013-12-27 02:06:39',NULL,NULL),(6476,4189,'AP','3303576707',0,'2013-12-25 21:49:37',NULL,NULL),(6717,4365,'EM','cindy.cheh@gmail.com',0,'2013-12-25 22:00:09',NULL,NULL),(21531,13843,'EM','crickens@neo.rr.com',0,'2013-12-26 13:12:22',NULL,NULL),(29999,19425,'AP','5136028392',1,'2014-01-22 03:23:04',NULL,NULL),(34755,22787,'TE','4196318999',0,'2014-02-11 21:01:47',NULL,NULL),(39769,26298,'TE','4193492249',0,'2014-02-28 06:31:27',NULL,NULL),(40937,27200,'AP','2144052741',0,'2014-03-03 21:31:22',NULL,NULL),(6541,4229,'TE','2545825905',0,'2013-12-25 21:50:39',NULL,NULL),(27941,18004,'AP','6142083673',0,'2014-01-15 02:07:01',NULL,NULL),(773,483,'TE','9852317678',0,'2013-12-25 17:48:12',NULL,NULL),(2075,1283,'AP','5137682769',0,'2013-12-25 18:30:37',NULL,NULL),(4177,2668,'EM','lmberry@neo.rr.com',0,'2013-12-25 19:47:00',NULL,NULL),(13944,9092,'TE','7404080307',0,'2013-12-26 04:07:08',NULL,NULL),(23200,14952,'AP','9566395295',0,'2014-01-01 12:00:13',NULL,NULL),(24034,15516,'TE','3373521069',1,'2014-01-02 04:30:13',NULL,NULL),(30780,20011,'TE','9158563753',0,'2014-01-26 19:00:10',NULL,NULL),(31424,20484,'AP','3308585870',0,'2014-01-29 21:01:03',NULL,NULL),(32982,21592,'AP','9378441723',0,'2014-02-05 21:30:29',NULL,NULL),(34665,22728,'EM','amey56812@aol.com',0,'2014-02-11 21:01:14',NULL,NULL),(37481,24679,'EM','david0685@gmail.com',0,'2014-02-20 04:30:15',NULL,NULL),(42887,28523,'EM','nllewis45@yahoo.com',0,'2014-03-07 21:32:02',NULL,NULL),(10861,7050,'EM','joshua.gunsher@gmail.com',0,'2013-12-26 01:49:40',NULL,NULL),(29150,18833,'TE','3306772435',0,'2014-01-17 03:36:10',NULL,NULL),(9707,6355,'EM','violapower3@hotmail.com',0,'2013-12-26 00:47:11',NULL,NULL),(27351,17610,'AP','3257213811',0,'2014-01-14 01:32:21',NULL,NULL),(37249,24511,'AP','2146491712',0,'2014-02-20 03:53:43',NULL,NULL),(37537,24715,'AP','4405037555',0,'2014-02-20 04:37:00',NULL,NULL),(39272,25985,'TE','2169522408',0,'2014-02-26 21:01:53',NULL,NULL),(39822,26334,'TE','4199056885',0,'2014-02-28 06:31:42',NULL,NULL),(10027,6559,'TE','9403825451',0,'2013-12-26 00:52:23',NULL,NULL),(7711,5036,'TE','9377255548',0,'2013-12-25 22:47:52',NULL,NULL),(5751,3686,'TE','9379028810',0,'2013-12-25 21:31:36',NULL,NULL),(1981,1224,'EM','Carpntr59@att.net',0,'2013-12-25 18:20:30',NULL,NULL),(4243,2715,'AP','3309907936',0,'2013-12-25 19:48:03',NULL,NULL),(3677,2332,'AP','8305137562',0,'2013-12-25 19:31:44',NULL,NULL),(29591,19121,'EM','jlecrow@yahoo.com',0,'2014-01-21 08:45:17',NULL,NULL),(24118,15571,'TE','3305753103',1,'2014-01-02 04:31:53',NULL,NULL),(31799,20758,'AP','4193488794',0,'2014-01-30 21:01:33',NULL,NULL),(32687,21381,'TE','3302459905',0,'2014-02-04 21:00:53',NULL,NULL),(33791,22182,'TE','8063191174',0,'2014-02-09 19:00:04',NULL,NULL),(35582,23404,'TE','3306664811',0,'2014-02-13 22:01:11',NULL,NULL),(37724,24876,'EM','PGANTZ@GMAIL.COM',0,'2014-02-20 05:34:45',NULL,NULL),(41047,27270,'TE','9038632516',0,'2014-03-04 21:00:15',NULL,NULL),(42162,28008,'TE','5136926985',0,'2014-03-06 21:01:13',NULL,NULL),(43376,28807,'AP','3306344893',0,'2014-03-09 21:00:52',NULL,NULL),(27495,17711,'BN','2253248447',0,'2014-01-14 01:33:10',NULL,NULL),(8408,5534,'TE','4405255075',0,'2013-12-25 23:15:39',NULL,NULL),(5015,3219,'TE','5046994532',0,'2013-12-25 20:45:40',NULL,NULL),(3033,1888,'TE','5137321891',0,'2013-12-25 18:58:46',NULL,NULL),(30327,19647,'TE','6149330129',0,'2014-01-23 21:00:18',NULL,NULL),(41267,27423,'EM','alorna.peyton@gmail.com',0,'2014-03-04 21:01:41',NULL,NULL),(41408,27510,'BN','4197046493',0,'2014-03-04 21:02:33',NULL,NULL),(28074,18093,'AP','5049127535',0,'2014-01-15 02:07:31',NULL,NULL),(24180,15622,'TE','6012120978',1,'2014-01-02 04:33:12',NULL,NULL),(4053,2586,'AP','2162560066',0,'2013-12-25 19:38:09',NULL,NULL),(20206,13019,'EM','basinger.josh@me.com',0,'2013-12-26 12:50:00',NULL,NULL),(13608,8869,'AP','7138067118',0,'2013-12-26 04:01:31',NULL,NULL),(6482,4193,'TE','3302200773',0,'2013-12-25 21:49:43',NULL,NULL),(2383,1448,'EM','erntaz01@hotmail.com',0,'2013-12-25 18:48:03',NULL,NULL),(24267,15683,'TE','4199057202',1,'2014-01-02 04:35:04',NULL,NULL),(22925,14791,'AP','2165136699',1,'2013-12-29 11:13:31',NULL,NULL),(22692,14636,'AP','4193710697',0,'2013-12-28 03:37:18',NULL,NULL),(31254,20360,'TE','4193762560',0,'2014-01-28 21:01:19',NULL,NULL),(38727,25600,'TE','6149449056',0,'2014-02-26 08:00:50',NULL,NULL),(40571,26928,'TE','2169031533',0,'2014-03-03 01:00:18',NULL,NULL),(42295,28086,'TE','2146005591',0,'2014-03-06 21:02:01',NULL,NULL),(42748,28432,'BN','4197336700',0,'2014-03-07 21:31:10',NULL,NULL),(42908,28534,'TE','9376076790',0,'2014-03-07 21:32:10',NULL,NULL),(24955,16084,'TE','3302255968',0,'2014-01-04 02:04:13',NULL,NULL),(10791,7015,'TE','8172018102',0,'2013-12-26 01:48:38',NULL,NULL),(1994,1230,'AP','6147831259',0,'2013-12-25 18:20:42',NULL,NULL),(1593,982,'AP','7132035452',0,'2013-12-25 18:10:20',NULL,NULL),(33457,21918,'AP','8063163333',0,'2014-02-07 19:00:04',NULL,NULL),(35606,23415,'TE','9157600913',0,'2014-02-13 22:01:18',NULL,NULL),(38504,25446,'TE','2544349164',0,'2014-02-25 21:31:23',NULL,NULL),(23362,15049,'AP','9852246877',0,'2014-01-01 12:03:13',NULL,NULL),(6813,4419,'AP','4192049439',0,'2013-12-25 22:01:35',NULL,NULL),(4878,3123,'TE','9377081426',0,'2013-12-25 20:30:21',NULL,NULL),(22808,14705,'EM','jakefiorino@gmail.com',1,'2013-12-29 11:09:12',NULL,NULL),(10082,6589,'TE','8172797412',0,'2013-12-26 00:53:13',NULL,NULL),(21658,13937,'TE','4198255600',0,'2013-12-26 13:14:41',NULL,NULL),(20488,13193,'EM','signtees@sbcglobal.net',0,'2013-12-26 12:54:43',NULL,NULL),(30872,20068,'TE','9725892763',0,'2014-01-27 21:00:15',NULL,NULL),(31202,20319,'TE','9568547081',0,'2014-01-28 21:00:54',NULL,NULL),(31774,20740,'EM','scsiler@hotmail.com',0,'2014-01-30 21:01:23',NULL,NULL),(39710,26261,'TE','9159227186',0,'2014-02-28 06:31:12',NULL,NULL),(39770,26299,'TE','9376054533',0,'2014-02-28 06:31:28',NULL,NULL),(41158,27335,'AP','4403877951',0,'2014-03-04 21:00:55',NULL,NULL),(41170,27343,'AP','6142050823',0,'2014-03-04 21:01:00',NULL,NULL),(28188,18169,'AP','5132369923',0,'2014-01-15 02:07:56',NULL,NULL),(6115,3937,'TE','9375649179',0,'2013-12-25 21:37:48',NULL,NULL),(9222,6035,'EM','MichaelSmith70815@yahoo.com',0,'2013-12-26 00:01:15',NULL,NULL),(653,407,'TE','4197681235',0,'2013-12-25 17:46:19',NULL,NULL),(668,418,'TE','5138230069',0,'2013-12-25 17:46:34',NULL,NULL),(2719,1651,'EM','hkatta@gmail.com',0,'2013-12-25 18:53:21',NULL,NULL),(31267,20368,'AP','8504965274',0,'2014-01-29 21:00:04',NULL,NULL),(43357,28797,'EM','eeyrkell@hotmail.com',0,'2014-03-09 21:00:46',NULL,NULL),(25982,16740,'TE','2163288534',0,'2014-01-08 18:24:51',NULL,NULL),(20403,13140,'TE','5138965040',0,'2013-12-26 12:53:17',NULL,NULL),(6092,3922,'TE','9377280525',0,'2013-12-25 21:37:25',NULL,NULL),(41828,27811,'EM','dgausskw@gmail.com',0,'2014-03-05 21:31:50',NULL,NULL),(42238,28056,'AP','7403960635',0,'2014-03-06 21:01:41',NULL,NULL),(42372,28140,'AP','2148665496',0,'2014-03-06 21:02:31',NULL,NULL),(13615,8872,'AP','9564561808',0,'2013-12-26 04:01:37',NULL,NULL),(28823,18603,'AP','5135605839',0,'2014-01-16 08:47:20',NULL,NULL),(25119,16193,'TE','8066764591',0,'2014-01-05 00:00:54',NULL,NULL),(11728,7634,'TE','5139675614',0,'2013-12-26 02:46:21',NULL,NULL),(9205,6023,'EM','eliaswalstrom@yahoo.com',0,'2013-12-26 00:00:56',NULL,NULL),(24514,15813,'TE','6018076977',0,'2014-01-03 02:03:16',NULL,NULL),(23156,14926,'AP','5133400705',0,'2013-12-30 00:01:51',NULL,NULL),(38250,25254,'TE','3304103651',0,'2014-02-21 22:01:16',NULL,NULL),(13560,8842,'AP','5127759875',0,'2013-12-26 04:00:47',NULL,NULL),(641,399,'TE','3309834271',0,'2013-12-25 17:46:06',NULL,NULL),(7617,4963,'TE','5044553165',0,'2013-12-25 22:46:13',NULL,NULL),(28729,18539,'AP','2283272601',0,'2014-01-16 08:46:48',NULL,NULL),(27995,18043,'EM','balfrettaburton@aol.com',0,'2014-01-15 02:07:14',NULL,NULL),(26610,17119,'EM','MATHEWS_R@YMAIL.COM',0,'2014-01-13 02:21:41',NULL,NULL),(31381,20455,'TE','5132609632',0,'2014-01-29 21:00:47',NULL,NULL),(33771,22164,'EM','christopherpauloder@gmail.com',0,'2014-02-08 19:01:00',NULL,NULL),(40736,27071,'EM','Cheryl.Njapau@gmail.com',0,'2014-03-03 21:30:06',NULL,NULL),(30640,19884,'TE','3304170518',0,'2014-01-24 21:00:48',NULL,NULL),(3312,2084,'AP','3379623973',0,'2013-12-25 19:16:42',NULL,NULL),(10545,6867,'AP','8069306122',0,'2013-12-26 01:31:52',NULL,NULL),(31754,20723,'TE','4408888334',0,'2014-01-30 21:01:15',NULL,NULL),(36027,23695,'EM','cunningham01@zoominternet.net',0,'2014-02-14 21:30:40',NULL,NULL),(38419,25384,'EM','zorness@yahoo.com',0,'2014-02-25 21:30:48',NULL,NULL),(41538,27621,'EM','christinap1202@gmail.com',0,'2014-03-05 21:30:04',NULL,NULL),(43256,28741,'AP','5046284928',0,'2014-03-09 21:00:10',NULL,NULL),(43458,28859,'AP','5133024955',0,'2014-03-09 21:30:02',NULL,NULL),(11969,7799,'EM','joannasanchez48@yahoo.com',0,'2013-12-26 03:03:38',NULL,NULL),(30286,19620,'EM','alisaswissa@gmail.com',0,'2014-01-23 21:00:03',NULL,NULL),(6477,4189,'EM','svaidhyanath@gmail.com',0,'2013-12-25 21:49:37',NULL,NULL),(24616,15875,'AP','7879519978',0,'2014-01-03 02:05:13',NULL,NULL),(22537,14530,'AP','9565703110',0,'2013-12-28 03:34:33',NULL,NULL),(11007,7146,'AP','2145372770',0,'2013-12-26 01:52:04',NULL,NULL),(20583,13242,'EM','LHICKS66@YAHOO.COM',0,'2013-12-26 12:56:08',NULL,NULL),(21021,13525,'AP','5044507077',0,'2013-12-26 13:03:19',NULL,NULL),(32139,20988,'TE','4407735666',0,'2014-02-01 19:00:24',NULL,NULL),(36192,23822,'EM','ksings5@aol.com',0,'2014-02-14 21:31:41',NULL,NULL),(36211,23834,'AP','5135086200',0,'2014-02-14 21:31:48',NULL,NULL),(30281,19618,'AP','4199662089',0,'2014-01-23 03:02:54',NULL,NULL),(22571,14555,'TE','3308829460',0,'2013-12-28 03:35:09',NULL,NULL),(3439,2157,'TE','3182358368',0,'2013-12-25 19:18:45',NULL,NULL),(9798,6409,'EM','eric_m_wheeler@yahoo.com',0,'2013-12-26 00:48:35',NULL,NULL),(6225,4013,'TE','5133744742',0,'2013-12-25 21:45:29',NULL,NULL),(6118,3938,'AP','4193767392',0,'2013-12-25 21:37:51',NULL,NULL),(37548,24722,'TE','5134851656',0,'2014-02-20 04:38:16',NULL,NULL),(42713,28410,'AP','2168945754',0,'2014-03-07 21:30:56',NULL,NULL),(43511,28890,'TE','9039083489',0,'2014-03-10 21:00:14',NULL,NULL),(226,139,'AP','4196064247',0,'2013-12-25 17:18:38',NULL,NULL),(8850,5800,'TE','4407294397',0,'2013-12-25 23:47:29',NULL,NULL),(7406,4817,'TE','5134440220',0,'2013-12-25 22:16:58',NULL,NULL),(5983,3844,'AP','8043479840',0,'2013-12-25 21:35:28',NULL,NULL),(12052,7866,'AP','6147492291',0,'2013-12-26 03:05:07',NULL,NULL),(5906,3789,'TE','6148634977',0,'2013-12-25 21:34:11',NULL,NULL),(26468,17035,'EM','cheforaday@yahoo.com',0,'2014-01-13 02:20:48',NULL,NULL),(27807,17920,'EM','cgcamarillo83@gmail.com',0,'2014-01-15 02:06:31',NULL,NULL),(41049,27272,'TE','9363966767',0,'2014-03-04 21:00:17',NULL,NULL),(41096,27297,'AP','9795513375',0,'2014-03-04 21:00:32',NULL,NULL),(41794,27785,'TE','6014971129',0,'2014-03-05 21:31:37',NULL,NULL),(43609,28951,'EM','chrisrmireles@gmail.com',0,'2014-03-10 21:00:50',NULL,NULL),(7538,4911,'TE','9728417096',0,'2013-12-25 22:32:07',NULL,NULL),(14395,9413,'TE','9727422607',0,'2013-12-26 04:32:55',NULL,NULL),(23870,15403,'AP','4147912843',1,'2014-01-02 04:26:52',NULL,NULL),(5020,3221,'AP','2692903867',0,'2013-12-25 20:45:45',NULL,NULL),(23554,15203,'AP','6019421661',0,'2014-01-01 12:07:29',NULL,NULL),(31557,20571,'TE','5672776096',0,'2014-01-29 21:01:53',NULL,NULL),(32487,21228,'AP','9375465188',0,'2014-02-03 21:01:08',NULL,NULL),(33141,21708,'AP','5134798443',0,'2014-02-05 21:31:14',NULL,NULL),(36196,23825,'AP','6014084211',0,'2014-02-14 21:31:43',NULL,NULL),(37760,24916,'EM','dianedmc2@msn.com',0,'2014-02-20 21:30:11',NULL,NULL),(39994,26487,'AP','5049204867',0,'2014-02-28 21:00:08',NULL,NULL),(30144,19532,'EM','lovingjustyou@yahoo.com',0,'2014-01-23 03:02:21',NULL,NULL),(29395,18998,'AP','3304727128',0,'2014-01-20 08:06:14',NULL,NULL),(28882,18648,'TE','8322263500',0,'2014-01-17 03:35:09',NULL,NULL),(27528,17735,'EM','toastmastersusanne@hotmail.com',0,'2014-01-14 01:33:21',NULL,NULL),(3569,2237,'TE','5134157570',0,'2013-12-25 19:20:54',NULL,NULL),(27332,17600,'TE','9562446954',0,'2014-01-14 01:32:16',NULL,NULL),(26524,17064,'AP','8179758473',0,'2014-01-13 02:21:14',NULL,NULL),(23405,15076,'TE','9032353834',0,'2014-01-01 12:04:02',NULL,NULL),(20949,13475,'TE','6145708436',0,'2013-12-26 13:02:06',NULL,NULL),(33253,21776,'TE','5137265333',0,'2014-02-06 21:00:35',NULL,NULL),(41424,27520,'AP','2165439654',0,'2014-03-04 21:02:39',NULL,NULL),(43002,28598,'TE','3303212172',0,'2014-03-08 21:30:07',NULL,NULL),(43422,28834,'TE','9374227368',0,'2014-03-09 21:01:09',NULL,NULL),(21792,14040,'EM','garrett.j.openshaw@gmail.com',0,'2013-12-26 13:17:10',NULL,NULL),(3589,2250,'TE','2163702432',0,'2013-12-25 19:30:05',NULL,NULL),(9536,6244,'AP','5139104244',0,'2013-12-26 00:31:44',NULL,NULL),(1917,1185,'TE','3303688817',0,'2013-12-25 18:19:29',NULL,NULL),(25923,16704,'EM','kstar164@earthlink.net',0,'2014-01-08 18:24:40',NULL,NULL),(6564,4238,'EM','devonxoxo@hotmail.com',0,'2013-12-25 21:50:57',NULL,NULL),(4030,2573,'AP','3309848689',0,'2013-12-25 19:37:45',NULL,NULL),(5521,3532,'TE','8306601016',0,'2013-12-25 21:21:31',NULL,NULL),(6272,4046,'TE','4194634247',0,'2013-12-25 21:46:15',NULL,NULL),(25252,16283,'EM','jbz524@aol.com',0,'2014-01-07 04:00:36',NULL,NULL),(29871,19326,'TE','9365605518',1,'2014-01-22 03:22:14',NULL,NULL),(32359,21145,'TE','4322138828',0,'2014-02-03 21:00:24',NULL,NULL),(37173,24470,'TE','4194741443',0,'2014-02-18 22:01:38',NULL,NULL),(40005,26498,'TE','3306538973',0,'2014-02-28 21:00:14',NULL,NULL),(43496,28882,'AP','2544356283',0,'2014-03-10 21:00:09',NULL,NULL),(14680,9607,'TE','3305921163',0,'2013-12-26 04:37:32',NULL,NULL),(12084,7896,'TE','4198735588',0,'2013-12-26 03:05:42',NULL,NULL),(7139,4657,'TE','3188728233',0,'2013-12-25 22:07:16',NULL,NULL),(35176,23104,'EM','garyblaich@aol.com',0,'2014-02-12 21:31:14',NULL,NULL),(36396,23971,'TE','2259545110',0,'2014-02-15 22:00:14',NULL,NULL),(37330,24570,'EM','cerra.wingo@gmail.com',0,'2014-02-20 04:07:35',NULL,NULL),(10269,6708,'TE','6015067463',0,'2013-12-26 01:02:09',NULL,NULL),(28198,18173,'AP','4195411379',0,'2014-01-15 02:07:58',NULL,NULL),(3969,2519,'TE','3303102650',0,'2013-12-25 19:36:33',NULL,NULL),(27219,17525,'EM','danieldordick@yahoo.com',0,'2014-01-13 03:01:39',NULL,NULL),(25203,16250,'AP','2166441481',0,'2014-01-05 00:02:38',NULL,NULL),(13919,9077,'AP','2162586778',0,'2013-12-26 04:06:44',NULL,NULL),(35244,23146,'EM','mgruesen@neo.rr.com',0,'2014-02-12 21:31:39',NULL,NULL),(38214,25223,'EM','EMCMILLION@NEO.RR.COM',0,'2014-02-21 22:00:58',NULL,NULL),(42234,28054,'EM','kodies85@gmail.com',0,'2014-03-06 21:01:40',NULL,NULL),(43037,28614,'AP','9408591542',0,'2014-03-08 21:30:17',NULL,NULL),(28899,18656,'EM','larkasmallwood@sbcglobal.net',0,'2014-01-17 03:35:12',NULL,NULL),(10648,6923,'EM','luvthenati@gmail.com',0,'2013-12-26 01:46:17',NULL,NULL),(26335,16951,'EM','mcouncil@comcast.net',0,'2014-01-13 02:20:01',NULL,NULL),(26208,16871,'TE','2543867249',0,'2014-01-13 02:19:15',NULL,NULL),(3698,2345,'TE','2548982424',0,'2013-12-25 19:32:05',NULL,NULL),(1768,1091,'TE','2164477716',0,'2013-12-25 18:17:03',NULL,NULL),(9254,6056,'TE','7404077612',0,'2013-12-26 00:01:49',NULL,NULL),(7255,4730,'AP','4196010248',0,'2013-12-25 22:09:09',NULL,NULL),(7143,4659,'TE','2256739197',0,'2013-12-25 22:07:20',NULL,NULL),(37187,24478,'TE','3309589105',0,'2014-02-18 22:01:43',NULL,NULL),(43069,28633,'EM','esmeraldaoviedo95@gmail.com',0,'2014-03-08 21:30:28',NULL,NULL),(8,5,'AP','5137736264',0,'2013-12-25 17:15:09',NULL,NULL),(13532,8824,'EM','ronnienu@yahoo.com',0,'2013-12-26 04:00:21',NULL,NULL),(8286,5430,'EM','lydell@cox.net',0,'2013-12-25 23:09:38',NULL,NULL),(5019,3221,'TE','2692903867',0,'2013-12-25 20:45:44',NULL,NULL),(3216,2020,'TE','4407170481',0,'2013-12-25 19:15:08',NULL,NULL),(8794,5761,'TE','6145577002',0,'2013-12-25 23:46:31',NULL,NULL),(7396,4812,'TE','6143168550',0,'2013-12-25 22:16:49',NULL,NULL),(6473,4187,'EM','tigelm6@aol.com',0,'2013-12-25 21:49:34',NULL,NULL),(29160,18839,'AP','3304648849',0,'2014-01-17 03:36:12',NULL,NULL),(33387,21876,'AP','5043437941',0,'2014-02-06 21:01:28',NULL,NULL),(35959,23656,'TE','3253389217',0,'2014-02-14 21:30:17',NULL,NULL),(38235,25240,'AP','4199538875',0,'2014-02-21 22:01:08',NULL,NULL),(42952,28562,'AP','9379998607',0,'2014-03-07 21:32:27',NULL,NULL),(24423,15767,'EM','jandrews8@gmail.com',0,'2014-01-03 02:01:42',NULL,NULL),(8733,5727,'AP','9855190872',0,'2013-12-25 23:45:35',NULL,NULL),(23956,15458,'TE','9032918334',1,'2014-01-02 04:28:35',NULL,NULL),(7534,4909,'EM','michaelkroeger@fuse.net',0,'2013-12-25 22:32:03',NULL,NULL),(23042,14863,'AP','5138891094',1,'2013-12-29 11:15:26',NULL,NULL),(30364,19671,'TE','3612072671',0,'2014-01-23 21:00:32',NULL,NULL),(33538,21988,'TE','4782580608',0,'2014-02-07 19:00:40',NULL,NULL),(35533,23369,'AP','2165135056',0,'2014-02-13 22:00:51',NULL,NULL),(24391,15749,'TE','3256729653',0,'2014-01-03 02:01:07',NULL,NULL),(3949,2508,'TE','5672045902',0,'2013-12-25 19:36:12',NULL,NULL),(2989,1850,'EM','cece@cecefox.com',0,'2013-12-25 18:57:53',NULL,NULL),(23047,14866,'TE','9405943966',0,'2013-12-30 00:00:06',NULL,NULL),(7442,4847,'EM','Tdavidson@fuse.net',0,'2013-12-25 22:30:17',NULL,NULL),(1922,1191,'EM','lsmit142@yahoo.com',0,'2013-12-25 18:19:36',NULL,NULL),(12442,8151,'AP','9402563570',0,'2013-12-26 03:16:02',NULL,NULL),(35654,23448,'AP','4694004467',0,'2014-02-13 22:01:36',NULL,NULL),(37316,24556,'TE','4199577465',0,'2014-02-20 04:05:25',NULL,NULL),(38966,25762,'AP','3304167855',0,'2014-02-26 09:30:52',NULL,NULL),(43243,28734,'TE','2257731054',0,'2014-03-09 21:00:05',NULL,NULL),(29028,18742,'AP','4408656996',0,'2014-01-17 03:35:40',NULL,NULL),(3212,2017,'TE','3302424660',0,'2013-12-25 19:15:04',NULL,NULL),(11797,7672,'AP','4196186339',0,'2013-12-26 03:00:37',NULL,NULL),(30146,19534,'AP','5132074010',0,'2014-01-23 03:02:22',NULL,NULL),(30189,19557,'TE','2253244288',0,'2014-01-23 03:02:31',NULL,NULL),(42013,27926,'AP','2142089776',0,'2014-03-06 21:00:22',NULL,NULL),(25849,16663,'TE','5047828976',0,'2014-01-08 18:24:25',NULL,NULL),(13872,9044,'EM','sportythief6428@aol.com',0,'2013-12-26 04:05:55',NULL,NULL),(31586,20601,'AP','5132255772',0,'2014-01-30 21:00:13',NULL,NULL),(33383,21875,'TE','3184011772',0,'2014-02-06 21:01:27',NULL,NULL),(34111,22362,'TE','4408455597',0,'2014-02-10 21:00:08',NULL,NULL),(39581,26184,'TE','4197543084',0,'2014-02-28 06:30:42',NULL,NULL),(43983,29179,'TE','5137533112',0,'2014-03-10 21:03:04',NULL,NULL),(12308,8048,'AP','4198104555',0,'2013-12-26 03:09:37',NULL,NULL),(24761,15975,'AP','9365725431',0,'2014-01-04 02:00:44',NULL,NULL),(22380,14436,'TE','3186172412',0,'2013-12-28 03:32:03',NULL,NULL),(4668,2986,'EM','sastidham@hotmail.com',0,'2013-12-25 20:17:18',NULL,NULL),(10636,6918,'AP','5134780854',0,'2013-12-26 01:46:08',NULL,NULL),(4685,2998,'TE','4404886278',0,'2013-12-25 20:17:34',NULL,NULL),(30811,20034,'TE','4404886747',0,'2014-01-26 19:00:22',NULL,NULL),(31656,20651,'EM','govea98@gmail.com',0,'2014-01-30 21:00:39',NULL,NULL),(32560,21292,'TE','2252722116',0,'2014-02-04 21:00:07',NULL,NULL),(42395,28158,'EM','kashawnnataylor@yahoo.com',0,'2014-03-06 21:02:40',NULL,NULL),(178,106,'TE','6178003094',0,'2013-12-25 17:17:50',NULL,NULL),(28599,18434,'TE','3185030615',0,'2014-01-16 08:46:00',NULL,NULL),(26140,16828,'TE','2163965165',0,'2014-01-13 02:18:27',NULL,NULL),(10305,6723,'TE','2164109132',0,'2013-12-26 01:15:17',NULL,NULL),(14117,9233,'AP','5133242999',0,'2013-12-26 04:10:30',NULL,NULL),(24485,15798,'EM','wilson.theronlyn@yahoo.com',0,'2014-01-03 02:02:46',NULL,NULL),(32509,21251,'AP','3307607153',0,'2014-02-03 21:01:18',NULL,NULL),(34161,22402,'TE','3303342666',0,'2014-02-10 21:30:20',NULL,NULL),(34310,22512,'TE','9562925536',0,'2014-02-10 21:31:20',NULL,NULL),(11616,7553,'EM','rmaxwell1965@neo.rr.com',0,'2013-12-26 02:33:18',NULL,NULL),(6142,3955,'TE','3306222919',0,'2013-12-25 21:38:16',NULL,NULL),(5103,3273,'TE','4197891521',0,'2013-12-25 20:47:16',NULL,NULL),(4659,2976,'EM','willpatt@ev1.net',0,'2013-12-25 20:17:07',NULL,NULL),(22599,14574,'EM','kmoreo34@yahoo.com',0,'2013-12-28 03:35:39',NULL,NULL),(22412,14454,'AP','5043205315',0,'2013-12-28 03:32:34',NULL,NULL),(30151,19536,'TE','4194785669',0,'2014-01-23 03:02:22',NULL,NULL),(31375,20451,'EM','jkirschy@gmail.com',0,'2014-01-29 21:00:45',NULL,NULL),(35653,23448,'TE','4694004467',0,'2014-02-13 22:01:36',NULL,NULL),(36417,23986,'TE','3373492733',0,'2014-02-15 22:00:23',NULL,NULL),(36568,24071,'TE','3306996744',0,'2014-02-15 22:01:17',NULL,NULL),(39072,25842,'TE','3309361155',0,'2014-02-26 21:00:36',NULL,NULL),(41559,27631,'TE','9372388661',0,'2014-03-05 21:30:11',NULL,NULL),(42043,27941,'TE','9154877557',0,'2014-03-06 21:00:32',NULL,NULL),(42619,28353,'TE','9177417855',0,'2014-03-07 21:30:24',NULL,NULL),(14602,9547,'TE','5133443843',0,'2013-12-26 04:36:11',NULL,NULL),(9056,5940,'TE','9046108142',0,'2013-12-25 23:50:47',NULL,NULL),(8649,5682,'AP','4199176602',0,'2013-12-25 23:32:22',NULL,NULL),(2029,1255,'AP','9372194620',0,'2013-12-25 18:21:22',NULL,NULL),(7432,4835,'TE','4196771923',0,'2013-12-25 22:17:26',NULL,NULL),(14519,9487,'TE','5132353167',0,'2013-12-26 04:34:49',NULL,NULL),(42326,28107,'TE','3305240989',0,'2014-03-06 21:02:14',NULL,NULL),(6130,3946,'AP','9372140598',0,'2013-12-25 21:38:03',NULL,NULL),(28607,18439,'AP','2253370055',0,'2014-01-16 08:46:03',NULL,NULL),(23689,15294,'TE','2259100150',1,'2014-01-02 04:22:34',NULL,NULL),(603,372,'TE','9037250258',0,'2013-12-25 17:45:29',NULL,NULL),(20389,13134,'TE','3302219997',0,'2013-12-26 12:53:06',NULL,NULL),(14907,9754,'TE','3259493385',0,'2013-12-26 04:46:19',NULL,NULL),(33026,21636,'TE','2103620875',0,'2014-02-05 21:30:43',NULL,NULL),(33695,22101,'AP','7247773860',0,'2014-02-08 19:00:30',NULL,NULL),(29136,18821,'AP','6014478606',0,'2014-01-17 03:36:06',NULL,NULL),(6742,4378,'EM','nicogonz@msn.com',0,'2013-12-25 22:00:32',NULL,NULL),(22801,14702,'EM','STUDE6958@YAHOO.COM',1,'2013-12-29 11:09:06',NULL,NULL),(9214,6027,'AP','3615586040',0,'2013-12-26 00:01:03',NULL,NULL),(6122,3940,'TE','4194617074',0,'2013-12-25 21:37:55',NULL,NULL),(4119,2626,'AP','4195593491',0,'2013-12-25 19:46:01',NULL,NULL),(8813,5770,'AP','6145788309',0,'2013-12-25 23:46:47',NULL,NULL),(30285,19620,'AP','6145791914',0,'2014-01-23 21:00:03',NULL,NULL),(30403,19701,'EM','DELIA56@HUGHES.NET',0,'2014-01-23 21:00:48',NULL,NULL),(40566,26926,'AP','7402746222',0,'2014-03-03 01:00:17',NULL,NULL),(41721,27742,'TE','4192612654',0,'2014-03-05 21:31:10',NULL,NULL),(7990,5214,'TE','2163331172',0,'2013-12-25 23:04:22',NULL,NULL),(26713,17184,'TE','4402650612',0,'2014-01-13 02:22:14',NULL,NULL),(26284,16917,'TE','7403621346',0,'2014-01-13 02:19:42',NULL,NULL),(25877,16678,'TE','5138471124',0,'2014-01-08 18:24:31',NULL,NULL),(25270,16292,'EM','mr7saint@hotmail.com',0,'2014-01-07 04:00:54',NULL,NULL),(24293,15696,'AP','5133043630',1,'2014-01-02 04:35:33',NULL,NULL),(34065,22333,'EM','adriansconiers@gmail.com',0,'2014-02-10 11:01:03',NULL,NULL),(37487,24686,'TE','3612930628',0,'2014-02-20 04:31:33',NULL,NULL),(37851,24972,'TE','8327584106',0,'2014-02-20 22:00:27',NULL,NULL),(38391,25362,'EM','dennnnnna@aol.com',0,'2014-02-25 21:30:37',NULL,NULL),(29802,19277,'TE','5133137326',0,'2014-01-21 08:46:58',NULL,NULL),(14394,9411,'AP','9155394135',0,'2013-12-26 04:32:53',NULL,NULL),(6062,3900,'TE','3303253408',0,'2013-12-25 21:36:51',NULL,NULL),(1871,1155,'TE','5046101251',0,'2013-12-25 18:18:45',NULL,NULL),(27249,17543,'AP','3302686163',0,'2014-01-13 03:01:50',NULL,NULL),(20839,13397,'EM','pgmcustom@aol.com',0,'2013-12-26 13:00:15',NULL,NULL),(3353,2109,'TE','3307553783',0,'2013-12-25 19:17:23',NULL,NULL),(2086,1289,'TE','5135630625',0,'2013-12-25 18:30:49',NULL,NULL),(20264,13061,'TE','3304147918',0,'2013-12-26 12:51:03',NULL,NULL),(37177,24472,'EM','coger_terry@yahoo.com',0,'2014-02-18 22:01:39',NULL,NULL),(39457,26094,'TE','4255051939',0,'2014-02-28 06:30:10',NULL,NULL),(42620,28353,'AP','9177417855',0,'2014-03-07 21:30:24',NULL,NULL),(27159,17486,'TE','4693354337',0,'2014-01-13 03:01:17',NULL,NULL),(22440,14472,'AP','9564558514',0,'2013-12-28 03:33:03',NULL,NULL),(8420,5543,'EM','greeneyes3421@gmail.com',0,'2013-12-25 23:15:54',NULL,NULL),(20784,13356,'AP','4074216994',0,'2013-12-26 12:59:21',NULL,NULL),(14412,9422,'EM','cdrapala@hotmail.com',0,'2013-12-26 04:33:09',NULL,NULL),(30784,20017,'TE','8304839566',0,'2014-01-26 19:00:12',NULL,NULL),(32995,21610,'EM','mccue330@yahoo.com',0,'2014-02-05 21:30:34',NULL,NULL),(34782,22812,'AP','5135942240',0,'2014-02-11 21:01:58',NULL,NULL),(41069,27283,'AP','8323398345',0,'2014-03-04 21:00:23',NULL,NULL),(25645,16539,'TE','3303104650',1,'2014-01-07 10:22:17',NULL,NULL),(20343,13106,'TE','5137030748',0,'2013-12-26 12:52:19',NULL,NULL),(5453,3490,'AP','9374166847',0,'2013-12-25 21:20:26',NULL,NULL),(36672,24143,'EM','Bingamon@fuse.net',0,'2014-02-15 22:01:53',NULL,NULL),(41816,27800,'TE','3309076676',0,'2014-03-05 21:31:45',NULL,NULL),(42042,27940,'EM','jamiwells08@yahoo.com',0,'2014-03-06 21:00:31',NULL,NULL),(42964,28572,'TE','5125768200',0,'2014-03-08 21:00:02',NULL,NULL),(43821,29086,'AP','8328019430',0,'2014-03-10 21:02:07',NULL,NULL),(10627,6915,'TE','5044279568',0,'2013-12-26 01:46:01',NULL,NULL),(29397,18999,'TE','3306281064',0,'2014-01-20 08:06:15',NULL,NULL),(2669,1620,'TE','3015292940',0,'2013-12-25 18:52:34',NULL,NULL),(26261,16900,'EM','mershonr17@yahoo.com',0,'2014-01-13 02:19:32',NULL,NULL),(21680,13958,'EM','cathy.eastlakeinsurance@gmail.com',0,'2013-12-26 13:15:04',NULL,NULL),(31968,20874,'TE','2252849728',0,'2014-01-31 21:01:04',NULL,NULL),(38823,25665,'EM','danob377@gmail.com',0,'2014-02-26 08:30:48',NULL,NULL),(42358,28133,'EM','david05r6@gmail.com',0,'2014-03-06 21:02:26',NULL,NULL),(7229,4708,'EM','glbrtrt@aol.com',0,'2013-12-25 22:08:38',NULL,NULL),(24816,16009,'EM','nippy12@earthlink.net',0,'2014-01-04 02:01:45',NULL,NULL),(4260,2724,'TE','3189553440',0,'2013-12-25 19:48:18',NULL,NULL),(31081,20223,'AP','4198104361',0,'2014-01-27 21:01:46',NULL,NULL),(37603,24779,'AP','9377257737',0,'2014-02-20 04:45:18',NULL,NULL),(39210,25932,'TE','3257635125',0,'2014-02-26 21:01:26',NULL,NULL),(41360,27478,'TE','8173334287',0,'2014-03-04 21:02:15',NULL,NULL),(43756,29048,'EM','amygroya@gmail.com',0,'2014-03-10 21:01:44',NULL,NULL),(337,210,'AP','2252477326',0,'2013-12-25 17:20:27',NULL,NULL),(23703,15300,'TE','3184369580',1,'2014-01-02 04:22:48',NULL,NULL),(11004,7145,'AP','8326083806',0,'2013-12-26 01:52:02',NULL,NULL),(7071,4618,'TE','3304947903',0,'2013-12-25 22:06:09',NULL,NULL),(22813,14710,'AP','5133724350',1,'2013-12-29 11:09:18',NULL,NULL),(14512,9483,'TE','4192901163',0,'2013-12-26 04:34:42',NULL,NULL),(32745,21422,'TE','5132589243',0,'2014-02-04 21:01:14',NULL,NULL),(36491,24022,'AP','4199447453',0,'2014-02-15 22:00:48',NULL,NULL),(39690,26248,'AP','2546523943',0,'2014-02-28 06:31:07',NULL,NULL),(42671,28386,'TE','3307943247',0,'2014-03-07 21:30:42',NULL,NULL),(43945,29150,'TE','5136586803',0,'2014-03-10 21:02:49',NULL,NULL),(7199,4689,'AP','5135087200',0,'2013-12-25 22:08:08',NULL,NULL),(5887,3776,'EM','kjessee@att.net',0,'2013-12-25 21:33:51',NULL,NULL),(11706,7622,'TE','9366452484',0,'2013-12-26 02:45:57',NULL,NULL),(28659,18483,'EM','edwardswon@gmail.com',0,'2014-01-16 08:46:22',NULL,NULL),(3111,1940,'AP','9373670122',0,'2013-12-25 19:00:39',NULL,NULL),(9334,6113,'TE','3305920861',0,'2013-12-26 00:15:31',NULL,NULL),(31751,20721,'TE','9377799008',0,'2014-01-30 21:01:14',NULL,NULL),(43542,28909,'EM','ashleyp5053@yahoo.com',0,'2014-03-10 21:00:26',NULL,NULL),(29971,19393,'TE','9376427803',1,'2014-01-22 03:22:49',NULL,NULL),(21295,13682,'AP','3308422949',0,'2013-12-26 13:08:13',NULL,NULL),(21978,14157,'EM','basscom42@yahoo.com',0,'2013-12-27 02:03:04',NULL,NULL),(29841,19307,'TE','2256140785',1,'2014-01-22 03:22:04',NULL,NULL),(38506,25448,'TE','9039410963',0,'2014-02-25 21:31:24',NULL,NULL),(40990,27234,'AP','6627861323',0,'2014-03-03 21:31:43',NULL,NULL),(8077,5287,'TE','3307159477',0,'2013-12-25 23:05:56',NULL,NULL),(8533,5606,'TE','5136801043',0,'2013-12-25 23:30:25',NULL,NULL),(6790,4403,'AP','4192904693',0,'2013-12-25 22:01:13',NULL,NULL),(2005,1241,'TE','5042184224',0,'2013-12-25 18:20:56',NULL,NULL),(34155,22394,'EM','dvecurtislin@aol.com',0,'2014-02-10 21:30:17',NULL,NULL),(34536,22655,'TE','5128881198',0,'2014-02-11 21:00:30',NULL,NULL),(38147,25177,'EM','robnewman08@yahoo.com',0,'2014-02-21 22:00:32',NULL,NULL),(41160,27336,'AP','4403877951',0,'2014-03-04 21:00:56',NULL,NULL),(41872,27843,'TE','3259989692',0,'2014-03-05 21:32:08',NULL,NULL),(29926,19367,'AP','3306973531',1,'2014-01-22 03:22:34',NULL,NULL),(10682,6941,'AP','6145303700',0,'2013-12-26 01:46:49',NULL,NULL),(22066,14211,'TE','3254506585',0,'2013-12-27 02:04:30',NULL,NULL),(34565,22666,'EM','mavish357@yahoo.com',0,'2014-02-11 21:00:39',NULL,NULL),(38691,25570,'TE','5136336897',0,'2014-02-26 08:00:30',NULL,NULL),(7919,5159,'AP','4407230638',0,'2013-12-25 23:03:01',NULL,NULL),(30926,20112,'TE','4405208799',0,'2014-01-27 21:00:41',NULL,NULL),(1776,1097,'AP','2167730746',0,'2013-12-25 18:17:11',NULL,NULL),(27996,18046,'TE','8327188460',0,'2014-01-15 02:07:15',NULL,NULL),(24659,15899,'TE','4195236382',0,'2014-01-03 02:06:01',NULL,NULL),(23589,15232,'TE','5136357237',0,'2014-01-01 12:08:18',NULL,NULL),(34196,22428,'TE','8305156481',0,'2014-02-10 21:30:34',NULL,NULL),(34891,22895,'EM','alisonhuff@gmail.com',0,'2014-02-11 21:02:39',NULL,NULL),(37062,24405,'AP','7408197187',0,'2014-02-18 22:00:57',NULL,NULL),(40515,26892,'TE','9379814796',0,'2014-03-03 01:00:03',NULL,NULL),(14383,9405,'TE','2542580611',0,'2013-12-26 04:32:43',NULL,NULL),(10744,6984,'EM','John.graven@gmail.com',0,'2013-12-26 01:47:49',NULL,NULL),(28602,18435,'AP','2253023953',0,'2014-01-16 08:46:00',NULL,NULL),(9777,6398,'TE','5132360803',0,'2013-12-26 00:48:16',NULL,NULL),(2584,1577,'TE','8064017932',0,'2013-12-25 18:51:20',NULL,NULL),(28516,18382,'TE','4403825189',0,'2014-01-16 08:45:35',NULL,NULL),(6893,4481,'TE','7404258709',0,'2013-12-25 22:02:59',NULL,NULL),(5653,3629,'TE','5132840229',0,'2013-12-25 21:30:05',NULL,NULL),(22405,14449,'TE','5044307777',0,'2013-12-28 03:32:26',NULL,NULL),(5702,3660,'AP','5133798250',0,'2013-12-25 21:30:52',NULL,NULL),(27755,17896,'TE','6785764484',0,'2014-01-15 02:06:21',NULL,NULL),(22273,14355,'TE','6145567014',0,'2013-12-28 03:30:08',NULL,NULL),(3886,2469,'EM','chuckellis3@gmail.com',0,'2013-12-25 19:35:10',NULL,NULL),(4002,2544,'EM','drt238@aol.com',0,'2013-12-25 19:37:07',NULL,NULL),(22139,14259,'TE','5045592517',0,'2013-12-27 02:05:45',NULL,NULL),(8834,5783,'EM','dna.latta@gmail.com',0,'2013-12-25 23:47:07',NULL,NULL),(36072,23727,'TE','2816601770',0,'2014-02-14 21:30:55',NULL,NULL),(36707,24169,'AP','6015947522',0,'2014-02-15 22:02:08',NULL,NULL),(37105,24428,'AP','3307153127',0,'2014-02-18 22:01:12',NULL,NULL),(39101,25869,'AP','5046214456',0,'2014-02-26 21:00:50',NULL,NULL),(40994,27236,'TE','6018455585',0,'2014-03-03 21:31:45',NULL,NULL),(7611,4956,'AP','2252662564',0,'2013-12-25 22:46:04',NULL,NULL),(6864,4453,'TE','6148634977',0,'2013-12-25 22:02:26',NULL,NULL),(3344,2103,'TE','6148066472',0,'2013-12-25 19:17:14',NULL,NULL),(13987,9125,'AP','6626890618',0,'2013-12-26 04:07:51',NULL,NULL),(28692,18516,'EM','frankjaf@hotmail.com',0,'2014-01-16 08:46:35',NULL,NULL),(38572,25494,'TE','4192933140',0,'2014-02-25 21:31:49',NULL,NULL),(39845,26355,'EM','dbarnes@iac.net',0,'2014-02-28 06:31:49',NULL,NULL),(28101,18111,'AP','6785079941',0,'2014-01-15 02:07:37',NULL,NULL),(493,314,'TE','2257729336',0,'2013-12-25 17:31:07',NULL,NULL),(24878,16041,'EM','DRAMSEY@CONSOLIDATED.NET',0,'2014-01-04 02:02:51',NULL,NULL),(20733,13326,'TE','5124617807',0,'2013-12-26 12:58:29',NULL,NULL),(8756,5740,'TE','2252019208',0,'2013-12-25 23:45:55',NULL,NULL),(5309,3403,'TE','2259369369',0,'2013-12-25 21:18:10',NULL,NULL),(32830,21482,'EM','btucker715@aol.com',0,'2014-02-04 21:01:43',NULL,NULL),(35810,23548,'TE','8325731388',0,'2014-02-13 22:02:37',NULL,NULL),(6010,3859,'EM','termerrialtaylor01@yahoo.com',0,'2013-12-25 21:35:53',NULL,NULL),(28079,18095,'AP','3185357118',0,'2014-01-15 02:07:32',NULL,NULL),(21576,13876,'AP','9175544988',0,'2013-12-26 13:13:11',NULL,NULL),(32393,21165,'AP','4403194352',0,'2014-02-03 21:00:35',NULL,NULL),(33643,22062,'TE','7138261776',0,'2014-02-08 19:00:11',NULL,NULL),(37453,24661,'AP','4192797137',0,'2014-02-20 04:25:32',NULL,NULL),(41288,27433,'TE','9365811978',0,'2014-03-04 21:01:48',NULL,NULL),(42070,27955,'AP','2147143684',0,'2014-03-06 21:00:41',NULL,NULL),(42941,28550,'AP','4198107433',0,'2014-03-07 21:32:20',NULL,NULL),(43819,29085,'EM','mickeycase@att.net',0,'2014-03-10 21:02:07',NULL,NULL),(14904,9752,'TE','5136252276',0,'2013-12-26 04:46:15',NULL,NULL),(4975,3192,'TE','6015966298',0,'2013-12-25 20:32:12',NULL,NULL),(36390,23968,'TE','3615435432',0,'2014-02-15 22:00:12',NULL,NULL),(37601,24779,'TE','9377257737',0,'2014-02-20 04:45:09',NULL,NULL),(39649,26218,'BN','3306221743',0,'2014-02-28 06:30:56',NULL,NULL),(40734,27071,'TE','2406014646',0,'2014-03-03 21:30:05',NULL,NULL),(9116,5973,'TE','9374523253',0,'2013-12-25 23:51:42',NULL,NULL),(494,314,'AP','2257729336',0,'2013-12-25 17:31:07',NULL,NULL),(5967,3830,'EM','pastormarksch@sbcglobal.net',0,'2013-12-25 21:35:11',NULL,NULL),(25124,16195,'TE','9152526622',0,'2014-01-05 00:00:59',NULL,NULL),(23455,15117,'AP','9375546003',0,'2014-01-01 12:05:09',NULL,NULL),(7475,4865,'EM','williswhill1@gmail.com',0,'2013-12-25 22:30:48',NULL,NULL),(6896,4488,'TE','3308634440',0,'2013-12-25 22:03:05',NULL,NULL),(7133,4654,'TE','5042893733',0,'2013-12-25 22:07:11',NULL,NULL),(14086,9210,'EM','adencb@gmail.com',0,'2013-12-26 04:09:53',NULL,NULL),(14901,9749,'AP','3308014545',0,'2013-12-26 04:46:11',NULL,NULL),(21103,13568,'TE','5042310268',0,'2013-12-26 13:04:35',NULL,NULL),(31124,20270,'AP','5133304247',0,'2014-01-28 21:00:23',NULL,NULL),(40995,27237,'TE','6012254564',0,'2014-03-03 21:31:45',NULL,NULL),(43323,28779,'TE','5133060624',0,'2014-03-09 21:00:34',NULL,NULL),(11072,7190,'EM','drgio28@hotmail.com',0,'2013-12-26 02:00:25',NULL,NULL),(10534,6859,'AP','7404443291',0,'2013-12-26 01:31:38',NULL,NULL),(26103,16809,'EM','lcarter267@yahoo.com',0,'2014-01-13 02:18:15',NULL,NULL),(21780,14035,'TE','5133054218',0,'2013-12-26 13:16:59',NULL,NULL),(14751,9648,'TE','7652771361',0,'2013-12-26 04:38:41',NULL,NULL),(29366,18974,'BN','5136802555',0,'2014-01-20 08:06:04',NULL,NULL),(37641,24809,'AP','6143138857',0,'2014-02-20 04:49:35',NULL,NULL),(27293,17574,'TE','3306227137',0,'2014-01-14 01:32:03',NULL,NULL),(25506,16447,'AP','6015063054',0,'2014-01-07 04:05:17',NULL,NULL),(14455,9444,'TE','6143166572',0,'2013-12-26 04:33:47',NULL,NULL),(1212,739,'EM','Mg_aragon@hotmail.com',0,'2013-12-25 18:04:00',NULL,NULL),(12389,8113,'TE','9853730088',0,'2013-12-26 03:15:05',NULL,NULL),(8033,5254,'TE','4408450747',0,'2013-12-25 23:05:13',NULL,NULL),(10533,6859,'TE','7404225004',0,'2013-12-26 01:31:38',NULL,NULL),(35921,23636,'TE','5042373633',0,'2014-02-14 21:30:06',NULL,NULL),(42750,28437,'TE','4196492037',0,'2014-03-07 21:31:11',NULL,NULL),(14978,9800,'TE','4193440578',0,'2013-12-26 05:01:13',NULL,NULL),(7848,5123,'TE','9563722182',0,'2013-12-25 23:02:00',NULL,NULL),(29947,19381,'TE','5126745889',1,'2014-01-22 03:22:42',NULL,NULL),(38294,25286,'AP','5132848620',0,'2014-02-25 21:00:20',NULL,NULL),(41440,27531,'AP','3305923026',0,'2014-03-04 21:02:47',NULL,NULL),(43249,28739,'TE','5044525409',0,'2014-03-09 21:00:08',NULL,NULL),(614,378,'AP','9032585003',0,'2013-12-25 17:45:38',NULL,NULL),(32674,21368,'AP','2549818772',0,'2014-02-04 21:00:47',NULL,NULL),(35756,23515,'AP','6622298698',0,'2014-02-13 22:02:16',NULL,NULL),(38374,25347,'EM','quentin@splashbr.com',0,'2014-02-25 21:30:29',NULL,NULL),(40119,26606,'AP','9366768296',0,'2014-02-28 21:30:44',NULL,NULL),(43683,28993,'AP','9372170522',0,'2014-03-10 21:01:16',NULL,NULL),(28042,18071,'TE','3182359292',0,'2014-01-15 02:07:24',NULL,NULL),(24906,16053,'EM','blue@bluegreenfilms.com',0,'2014-01-04 02:03:18',NULL,NULL),(21320,13699,'EM','yorkwhk3@yahoo.com',0,'2013-12-26 13:08:37',NULL,NULL),(3141,1959,'AP','8176816774',0,'2013-12-25 19:01:11',NULL,NULL),(9333,6112,'EM','crawson@neo.rr.com',0,'2013-12-26 00:15:29',NULL,NULL),(9144,5990,'AP','4197066814',0,'2013-12-25 23:52:12',NULL,NULL),(29789,19265,'EM','hudshil@aol.com',0,'2014-01-21 08:46:51',NULL,NULL),(34736,22777,'TE','5135215363',0,'2014-02-11 21:01:41',NULL,NULL),(36748,24195,'AP','6505751972',0,'2014-02-16 19:00:15',NULL,NULL),(37814,24954,'TE','3373094243',0,'2014-02-20 22:00:14',NULL,NULL),(41925,27874,'AP','6012146540',0,'2014-03-05 21:32:27',NULL,NULL),(4509,2868,'TE','3182670071',0,'2013-12-25 20:01:51',NULL,NULL),(25707,16571,'EM','josh3133@live.com',1,'2014-01-07 10:23:22',NULL,NULL),(7222,4703,'EM','ON6ACRES@ROADRUNNER.COM',0,'2013-12-25 22:08:30',NULL,NULL),(24844,16025,'TE','3186865630',0,'2014-01-04 02:02:17',NULL,NULL),(24286,15692,'EM','dmrmillbury@frontier.com',1,'2014-01-02 04:35:25',NULL,NULL),(22640,14599,'TE','3307199810',0,'2013-12-28 03:36:21',NULL,NULL),(34312,22513,'TE','2143916569',0,'2014-02-10 21:31:20',NULL,NULL),(36630,24114,'AP','9156138049',0,'2014-02-15 22:01:38',NULL,NULL),(37729,24880,'EM','Scottybears@me.com',0,'2014-02-20 05:36:12',NULL,NULL),(43788,29067,'AP','4192830969',0,'2014-03-10 21:01:55',NULL,NULL),(25329,16333,'AP','9859910236',0,'2014-01-07 04:02:03',NULL,NULL),(21585,13883,'EM','todd@bluedakota.com',0,'2013-12-26 13:13:20',NULL,NULL),(7899,5147,'EM','jamesmurphey395@yahoo.com',0,'2013-12-25 23:02:43',NULL,NULL),(20470,13186,'EM','Robin.ivy.p@gmail.com',0,'2013-12-26 12:54:28',NULL,NULL),(4120,2628,'TE','7402587100',0,'2013-12-25 19:46:03',NULL,NULL),(3819,2430,'AP','4407281055',0,'2013-12-25 19:34:09',NULL,NULL),(29737,19228,'AP','5136854768',0,'2014-01-21 08:46:31',NULL,NULL),(30985,20156,'TE','2163570142',0,'2014-01-27 21:01:07',NULL,NULL),(31916,20833,'BN','3308041951',0,'2014-01-31 21:00:42',NULL,NULL),(43818,29085,'AP','7139223205',0,'2014-03-10 21:02:06',NULL,NULL),(104,60,'AP','3304218590',0,'2013-12-25 17:16:39',NULL,NULL),(3520,2201,'AP','9374171757',0,'2013-12-25 19:20:02',NULL,NULL),(23914,15428,'EM','taylorphan123@yahoo.com',1,'2014-01-02 04:27:41',NULL,NULL),(22302,14373,'AP','3302684412',0,'2013-12-28 03:30:36',NULL,NULL),(22345,14410,'TE','2059011005',0,'2013-12-28 03:31:26',NULL,NULL),(29883,19338,'EM','BOOLEANTRADER@HOTMAIL.COM',1,'2014-01-22 03:22:19',NULL,NULL),(30027,19448,'TE','2165262381',0,'2014-01-23 03:01:51',NULL,NULL),(30672,19917,'AP','5124617807',0,'2014-01-24 21:01:03',NULL,NULL),(37440,24651,'TE','6143987629',0,'2014-02-20 04:23:06',NULL,NULL),(41857,27835,'AP','5672302208',0,'2014-03-05 21:32:03',NULL,NULL),(28865,18638,'AP','9567469827',0,'2014-01-17 03:35:05',NULL,NULL),(1601,986,'AP','3308081032',0,'2013-12-25 18:10:27',NULL,NULL),(28781,18572,'EM','Golbezhatred@yahoo.com',0,'2014-01-16 08:47:05',NULL,NULL),(24864,16034,'TE','2252530706',0,'2014-01-04 02:02:36',NULL,NULL),(4564,2909,'TE','4402201652',0,'2013-12-25 20:15:31',NULL,NULL),(31638,20640,'AP','2144918508',0,'2014-01-30 21:00:33',NULL,NULL),(33821,22207,'AP','9374697564',0,'2014-02-09 19:00:18',NULL,NULL),(34270,22483,'EM','terriblack@att.net',0,'2014-02-10 21:31:04',NULL,NULL),(43492,28880,'AP','9793374070',0,'2014-03-10 21:00:08',NULL,NULL),(7345,4774,'TE','2163191291',0,'2013-12-25 22:15:55',NULL,NULL),(10853,7044,'EM','DonaldWHunter@gmail.com',0,'2013-12-26 01:49:30',NULL,NULL),(28377,18284,'AP','7405919818',0,'2014-01-16 08:44:48',NULL,NULL),(27534,17743,'AP','2165434277',0,'2014-01-14 01:33:24',NULL,NULL),(3624,2292,'AP','2168623013',0,'2013-12-25 19:30:48',NULL,NULL),(4170,2664,'AP','5136738802',0,'2013-12-25 19:46:54',NULL,NULL),(25958,16721,'AP','4095495352',0,'2014-01-08 18:24:46',NULL,NULL),(27861,17951,'EM','ssassy92@aol.com',0,'2014-01-15 02:06:42',NULL,NULL),(4065,2595,'AP','9377187504',0,'2013-12-25 19:45:10',NULL,NULL),(26806,17241,'EM','Kelli11308@aol.com',0,'2014-01-13 02:22:46',NULL,NULL),(10514,6847,'AP','2812531562',0,'2013-12-26 01:31:18',NULL,NULL),(14084,9210,'TE','6018741928',0,'2013-12-26 04:09:52',NULL,NULL),(8124,5320,'EM','nxtlbron07@gmail.com',0,'2013-12-25 23:06:48',NULL,NULL),(30341,19661,'AP','9372124146',0,'2014-01-23 21:00:24',NULL,NULL),(31654,20651,'TE','9158735996',0,'2014-01-30 21:00:39',NULL,NULL),(32481,21222,'AP','3182944121',0,'2014-02-03 21:01:04',NULL,NULL),(37902,25001,'AP','3304145341',0,'2014-02-20 22:00:47',NULL,NULL),(13883,9054,'AP','2814337246',0,'2013-12-26 04:06:08',NULL,NULL),(12452,8155,'TE','3309233643',0,'2013-12-26 03:16:10',NULL,NULL),(4943,3174,'TE','3306080779',0,'2013-12-25 20:31:38',NULL,NULL),(26934,17324,'TE','9404477162',0,'2014-01-13 02:23:52',NULL,NULL),(26254,16896,'AP','6147438350',0,'2014-01-13 02:19:30',NULL,NULL),(3194,2007,'TE','4912291250',0,'2013-12-25 19:02:23',NULL,NULL),(24692,15927,'TE','6016130356',0,'2014-01-03 02:06:48',NULL,NULL),(22782,14691,'AP','2162963753',1,'2013-12-29 11:08:48',NULL,NULL),(30010,19434,'TE','4193500218',1,'2014-01-22 03:23:09',NULL,NULL),(31084,20233,'AP','6016088679',0,'2014-01-28 21:00:03',NULL,NULL),(32161,21007,'EM','rkenard@yahoo.com',0,'2014-02-01 19:00:32',NULL,NULL),(39618,26203,'EM','jfog01@msn.com',0,'2014-02-28 06:30:50',NULL,NULL),(39996,26489,'TE','5049204867',0,'2014-02-28 21:00:09',NULL,NULL),(43123,28667,'TE','5046718004',0,'2014-03-08 21:30:47',NULL,NULL),(43387,28817,'TE','3306303643',0,'2014-03-09 21:00:57',NULL,NULL),(28775,18566,'EM','greenthumb353@aol.com',0,'2014-01-16 08:47:02',NULL,NULL),(7045,4602,'TE','4197796133',0,'2013-12-25 22:05:45',NULL,NULL),(22237,14332,'TE','4197070483',0,'2013-12-27 02:07:36',NULL,NULL),(21361,13732,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:28',NULL,NULL),(30312,19636,'AP','6148436306',0,'2014-01-23 21:00:12',NULL,NULL),(37262,24519,'AP','8172691667',0,'2014-02-20 03:56:33',NULL,NULL),(39782,26305,'TE','3614011799',0,'2014-02-28 06:31:31',NULL,NULL),(40782,27104,'TE','5135468804',0,'2014-03-03 21:30:23',NULL,NULL),(41066,27281,'EM','NIRVANAFAHMY@VERIZON.NET',0,'2014-03-04 21:00:22',NULL,NULL),(43312,28774,'TE','4198225485',0,'2014-03-09 21:00:31',NULL,NULL),(25218,16260,'EM','c.fusselman@aol.com',0,'2014-01-05 00:02:55',NULL,NULL),(41110,27309,'TE','9033944428',0,'2014-03-04 21:00:38',NULL,NULL),(1115,684,'TE','2487091547',0,'2013-12-25 18:02:28',NULL,NULL),(29218,18873,'AP','5042207540',0,'2014-01-17 03:36:25',NULL,NULL),(1846,1141,'AP','2252880881',0,'2013-12-25 18:18:20',NULL,NULL),(29035,18745,'AP','6147783026',0,'2014-01-17 03:35:42',NULL,NULL),(25253,16284,'TE','5136836678',0,'2014-01-07 04:00:38',NULL,NULL),(24594,15862,'EM','ms.kiki15@yahoo.com',0,'2014-01-03 02:04:49',NULL,NULL),(34567,22667,'AP','8176086187',0,'2014-02-11 21:00:39',NULL,NULL),(36580,24077,'EM','amber.marq@gmail.com',0,'2014-02-15 22:01:20',NULL,NULL),(37430,24647,'AP','5043449068',0,'2014-02-20 04:21:56',NULL,NULL),(124,72,'EM','garyasolomon@gmail.com',0,'2013-12-25 17:16:58',NULL,NULL),(30032,19451,'AP','5133099431',0,'2014-01-23 03:01:52',NULL,NULL),(29138,18822,'AP','6014478606',0,'2014-01-17 03:36:06',NULL,NULL),(28530,18390,'TE','4408656996',0,'2014-01-16 08:45:39',NULL,NULL),(27942,18004,'EM','luannfuller61@gmail.com',0,'2014-01-15 02:07:01',NULL,NULL),(4747,3040,'TE','3307056303',0,'2013-12-25 20:18:38',NULL,NULL),(23771,15332,'TE','8309972789',1,'2014-01-02 04:23:57',NULL,NULL),(9745,6373,'AP','2164086017',0,'2013-12-26 00:47:43',NULL,NULL),(30920,20106,'TE','5049456686',0,'2014-01-27 21:00:38',NULL,NULL),(34542,22657,'AP','9152021249',0,'2014-02-11 21:00:32',NULL,NULL),(37357,24592,'EM','TIMESCAPEMASS@HOTMAIL.COM',0,'2014-02-20 04:11:12',NULL,NULL),(39655,26221,'AP','7133012530',0,'2014-02-28 06:30:57',NULL,NULL),(4489,2854,'AP','2254397000',0,'2013-12-25 20:01:29',NULL,NULL),(8571,5636,'TE','9404441649',0,'2013-12-25 23:31:06',NULL,NULL),(14550,9507,'TE','5135451378',0,'2013-12-26 04:35:18',NULL,NULL),(14325,9366,'EM','JAMES.WOODARD2013@YAHOO.COM',0,'2013-12-26 04:31:41',NULL,NULL),(32911,21546,'BN','6142713596',0,'2014-02-05 21:30:12',NULL,NULL),(38096,25146,'TE','3615950091',0,'2014-02-21 22:00:14',NULL,NULL),(7327,4763,'EM','webwolf2002@me.com',0,'2013-12-25 22:15:37',NULL,NULL),(5799,3721,'TE','7406382370',0,'2013-12-25 21:32:22',NULL,NULL),(25467,16423,'EM','jsuttonmovieads@msn.com',0,'2014-01-07 04:04:34',NULL,NULL),(14654,9584,'EM','sgilbert84@icloud.com',0,'2013-12-26 04:37:00',NULL,NULL),(13831,9017,'TE','3307849480',0,'2013-12-26 04:05:15',NULL,NULL),(23356,15046,'TE','2256548085',0,'2014-01-01 12:03:07',NULL,NULL),(22228,14327,'TE','9375910728',0,'2013-12-27 02:07:26',NULL,NULL),(11180,7271,'TE','2102510120',0,'2013-12-26 02:02:26',NULL,NULL),(21564,13868,'AP','3307150439',0,'2013-12-26 13:12:58',NULL,NULL),(22106,14240,'TE','7697983745',0,'2013-12-27 02:05:12',NULL,NULL),(30685,19932,'EM','roaddoggy67@yahoo.com',0,'2014-01-24 21:01:10',NULL,NULL),(31450,20498,'AP','3372518040',0,'2014-01-29 21:01:11',NULL,NULL),(37443,24652,'AP','6143987629',0,'2014-02-20 04:23:25',NULL,NULL),(40182,26651,'EM','gid266@earthlink.net',0,'2014-02-28 21:31:07',NULL,NULL),(11173,7267,'AP','8312292909',0,'2013-12-26 02:02:19',NULL,NULL),(10019,6554,'AP','9366626833',0,'2013-12-26 00:52:16',NULL,NULL),(21873,14091,'EM','dwelage2@cinci.rr.com',0,'2013-12-27 02:01:22',NULL,NULL),(2993,1852,'TE','5137721208',0,'2013-12-25 18:57:57',NULL,NULL),(8419,5543,'AP','3309689050',0,'2013-12-25 23:15:53',NULL,NULL),(14897,9748,'TE','9853796664',0,'2013-12-26 04:46:08',NULL,NULL),(14765,9659,'TE','9372774985',0,'2013-12-26 04:38:56',NULL,NULL),(35768,23522,'EM','harrypmay@hotmail.com',0,'2014-02-13 22:02:21',NULL,NULL),(41274,27426,'AP','3189906112',0,'2014-03-04 21:01:43',NULL,NULL),(42267,28072,'TE','5137195116',0,'2014-03-06 21:01:51',NULL,NULL),(24022,15512,'TE','4193504294',1,'2014-01-02 04:30:02',NULL,NULL),(23236,14973,'TE','2149069724',0,'2014-01-01 12:00:53',NULL,NULL),(7934,5171,'AP','3303577343',0,'2013-12-25 23:03:19',NULL,NULL),(33314,21818,'AP','3302127230',0,'2014-02-06 21:00:58',NULL,NULL),(38449,25408,'AP','6154233660',0,'2014-02-25 21:31:01',NULL,NULL),(39965,26459,'EM','fcasby@cox.net',0,'2014-02-28 07:30:30',NULL,NULL),(10095,6595,'TE','6019247548',0,'2013-12-26 00:53:24',NULL,NULL),(8178,5350,'AP','3302088058',0,'2013-12-25 23:07:36',NULL,NULL),(1487,915,'EM','jrcoates@cinci.rr.com',0,'2013-12-25 18:08:39',NULL,NULL),(26901,17307,'EM','ellentmurphy@yahoo.com',0,'2014-01-13 02:23:42',NULL,NULL),(2076,1284,'TE','6018508281',0,'2013-12-25 18:30:39',NULL,NULL),(8023,5246,'TE','4402368383',0,'2013-12-25 23:05:02',NULL,NULL),(24865,16034,'AP','2252530706',0,'2014-01-04 02:02:37',NULL,NULL),(26728,17190,'EM','bveit@woh.rr.com',0,'2014-01-13 02:22:18',NULL,NULL),(42403,28164,'TE','9376313752',0,'2014-03-06 21:02:44',NULL,NULL),(321,200,'TE','4199798053',0,'2013-12-25 17:20:11',NULL,NULL),(12087,7899,'EM','jenny17@frontier.com',0,'2013-12-26 03:05:46',NULL,NULL),(7082,4626,'TE','5049052476',0,'2013-12-25 22:06:22',NULL,NULL),(29890,19341,'AP','8067873410',1,'2014-01-22 03:22:21',NULL,NULL),(29196,18862,'EM','davidsandifer@att.net',0,'2014-01-17 03:36:20',NULL,NULL),(26798,17238,'AP','9173857841',0,'2014-01-13 02:22:44',NULL,NULL),(2773,1680,'AP','5048106428',0,'2013-12-25 18:54:08',NULL,NULL),(32064,20936,'EM','jec1765@gmail.com',0,'2014-01-31 21:01:40',NULL,NULL),(42855,28501,'TE','3306711655',0,'2014-03-07 21:31:48',NULL,NULL),(21457,13790,'AP','6019888220',0,'2013-12-26 13:11:03',NULL,NULL),(7350,4776,'EM','cahousley@aol.com',0,'2013-12-25 22:15:59',NULL,NULL),(3108,1939,'AP','2169038772',0,'2013-12-25 19:00:37',NULL,NULL),(27983,18038,'EM','l.mcq@roadrunner.com',0,'2014-01-15 02:07:11',NULL,NULL),(34369,22541,'AP','2252902199',0,'2014-02-10 21:31:39',NULL,NULL),(35674,23462,'EM','dcfindley@gmail.com',0,'2014-02-13 22:01:44',NULL,NULL),(24346,15725,'AP','2162153579',0,'2014-01-03 02:00:17',NULL,NULL),(21689,13965,'AP','9374181295',0,'2013-12-26 13:15:15',NULL,NULL),(20350,13109,'EM','marylbonner09@gmail.com',0,'2013-12-26 12:52:25',NULL,NULL),(10926,7104,'TE','5134295642',0,'2013-12-26 01:50:50',NULL,NULL),(4832,3092,'EM','maggie61062@msn.com',0,'2013-12-25 20:20:03',NULL,NULL),(30294,19625,'AP','6146008580',0,'2014-01-23 21:00:06',NULL,NULL),(33263,21781,'EM','davidjancewicz@cox.net',0,'2014-02-06 21:00:38',NULL,NULL),(34743,22781,'EM','scrott@att.net',0,'2014-02-11 21:01:44',NULL,NULL),(39076,25844,'AP','3302037723',0,'2014-02-26 21:00:37',NULL,NULL),(25298,16313,'TE','3372747439',0,'2014-01-07 04:01:29',NULL,NULL),(870,541,'EM','rlanderson1954@gmail.com',0,'2013-12-25 17:49:44',NULL,NULL),(23672,15284,'TE','6019189868',1,'2014-01-02 04:22:15',NULL,NULL),(23468,15134,'EM','benpettey@gmail.com',0,'2014-01-01 12:05:32',NULL,NULL),(22976,14819,'TE','9032938145',1,'2013-12-29 11:14:18',NULL,NULL),(31670,20662,'TE','9035061841',0,'2014-01-30 21:00:44',NULL,NULL),(32867,21510,'TE','9374512880',0,'2014-02-04 21:01:58',NULL,NULL),(41445,27533,'TE','6149610532',0,'2014-03-04 21:02:48',NULL,NULL),(11601,7545,'TE','2145923731',0,'2013-12-26 02:33:03',NULL,NULL),(24465,15791,'TE','2253419061',0,'2014-01-03 02:02:30',NULL,NULL),(11523,7500,'TE','4403640311',0,'2013-12-26 02:31:49',NULL,NULL),(2624,1595,'AP','9035192651',0,'2013-12-25 18:51:54',NULL,NULL),(23610,15243,'TE','4196190750',0,'2014-01-01 12:08:41',NULL,NULL),(2329,1420,'EM','pamdulock@yahoo.com',0,'2013-12-25 18:47:13',NULL,NULL),(14335,9373,'TE','3188344564',0,'2013-12-26 04:31:51',NULL,NULL),(22984,14825,'AP','4197376427',1,'2013-12-29 11:14:25',NULL,NULL),(34697,22752,'EM','delaneywanda@aol.com',0,'2014-02-11 21:01:27',NULL,NULL),(36900,24302,'TE','8305708742',0,'2014-02-18 21:30:20',NULL,NULL),(37808,24951,'TE','5043279301',0,'2014-02-20 22:00:11',NULL,NULL),(40001,26493,'TE','9855191082',0,'2014-02-28 21:00:11',NULL,NULL),(11745,7646,'EM','evilinside2020@gmail.com',0,'2013-12-26 02:46:42',NULL,NULL),(9999,6542,'TE','8173373898',0,'2013-12-26 00:51:57',NULL,NULL),(678,422,'AP','7404162025',0,'2013-12-25 17:46:41',NULL,NULL),(910,562,'TE','4196033052',0,'2013-12-25 17:50:21',NULL,NULL),(28263,18225,'TE','9727416288',0,'2014-01-16 08:44:16',NULL,NULL),(9350,6122,'TE','5122189951',0,'2013-12-26 00:15:46',NULL,NULL),(21677,13957,'AP','5133483505',0,'2013-12-26 13:15:02',NULL,NULL),(20653,13282,'AP','9566427678',0,'2013-12-26 12:57:14',NULL,NULL),(36779,24216,'AP','5126806048',0,'2014-02-16 19:00:26',NULL,NULL),(40909,27185,'AP','5127879479',0,'2014-03-03 21:31:12',NULL,NULL),(28035,18067,'TE','5042185557',0,'2014-01-15 02:07:22',NULL,NULL),(533,334,'TE','9372386677',0,'2013-12-25 17:31:45',NULL,NULL),(24788,15989,'AP','9562921695',0,'2014-01-04 02:01:12',NULL,NULL),(21598,13901,'TE','4195099304',0,'2013-12-26 13:13:41',NULL,NULL),(2196,1350,'AP','5128031884',0,'2013-12-25 18:45:13',NULL,NULL),(29992,19416,'EM','foxworthagency@att.net',1,'2014-01-22 03:23:00',NULL,NULL),(33730,22129,'EM','rstage@gmail.com',0,'2014-02-08 19:00:43',NULL,NULL),(38528,25460,'EM','DRothkrug@yahoo.com',0,'2014-02-25 21:31:31',NULL,NULL),(29622,19137,'AP','3252276739',0,'2014-01-21 08:45:27',NULL,NULL),(10999,7143,'AP','9726898366',0,'2013-12-26 01:51:58',NULL,NULL),(25420,16395,'AP','2108836426',0,'2014-01-07 04:03:42',NULL,NULL),(1825,1130,'TE','8065597132',0,'2013-12-25 18:18:02',NULL,NULL),(21261,13663,'TE','5042373582',0,'2013-12-26 13:07:41',NULL,NULL),(21120,13579,'AP','7184909577',0,'2013-12-26 13:04:52',NULL,NULL),(30833,20044,'EM','meganfries08@gmail.com',0,'2014-01-26 19:00:29',NULL,NULL),(32823,21477,'EM','ycressie@att.net',0,'2014-02-04 21:01:41',NULL,NULL),(33518,21972,'EM','lyarbroughjr@hotmail.com',0,'2014-02-07 19:00:31',NULL,NULL),(39403,26054,'EM','LeAnnaweaver03@hotmail.com',0,'2014-02-26 21:02:35',NULL,NULL),(43259,28743,'TE','5635031050',0,'2014-03-09 21:00:11',NULL,NULL),(43745,29038,'EM','hippogriffre@gmail.com',0,'2014-03-10 21:01:40',NULL,NULL),(43930,29142,'EM','kaemery1@frontier.com',0,'2014-03-10 21:02:43',NULL,NULL),(43996,29188,'AP','3308253026',0,'2014-03-10 21:30:04',NULL,NULL),(11424,7432,'EM','gjdeiters@att.net',0,'2013-12-26 02:30:11',NULL,NULL),(29831,19299,'TE','2252902199',1,'2014-01-22 03:22:00',NULL,NULL),(3231,2030,'AP','3307156631',0,'2013-12-25 19:15:20',NULL,NULL),(3427,2151,'TE','2253121523',0,'2013-12-25 19:18:35',NULL,NULL),(28990,18713,'AP','4402212816',0,'2014-01-17 03:35:32',NULL,NULL),(5340,3421,'AP','2254131922',0,'2013-12-25 21:18:40',NULL,NULL),(25914,16701,'TE','9152521048',0,'2014-01-08 18:24:39',NULL,NULL),(11423,7432,'TE','3308822412',0,'2013-12-26 02:30:11',NULL,NULL),(28137,18138,'TE','3373945558',0,'2014-01-15 02:07:46',NULL,NULL),(25466,16423,'AP','5156815473',0,'2014-01-07 04:04:33',NULL,NULL),(3736,2372,'TE','9376411267',0,'2013-12-25 19:32:46',NULL,NULL),(33311,21817,'TE','3308583129',0,'2014-02-06 21:00:57',NULL,NULL),(36258,23861,'TE','9016840346',0,'2014-02-14 21:32:05',NULL,NULL),(38184,25202,'AP','6465297117',0,'2014-02-21 22:00:47',NULL,NULL),(43814,29083,'AP','9012688773',0,'2014-03-10 21:02:05',NULL,NULL),(29376,18984,'TE','7409925030',0,'2014-01-20 08:06:08',NULL,NULL),(27882,17967,'AP','3307606069',0,'2014-01-15 02:06:48',NULL,NULL),(13740,8955,'AP','6148356750',0,'2013-12-26 04:03:42',NULL,NULL),(26782,17229,'TE','6014287441',0,'2014-01-13 02:22:39',NULL,NULL),(23667,15282,'AP','2288617835',1,'2014-01-02 04:22:11',NULL,NULL),(2518,1542,'EM','ANNE@CHOPMIXMINGLE.COM',0,'2013-12-25 18:50:21',NULL,NULL),(22455,14481,'TE','3615584380',0,'2013-12-28 03:33:16',NULL,NULL),(40658,26990,'AP','6019512299',0,'2014-03-03 01:00:42',NULL,NULL),(27976,18035,'EM','sheilacaynor@yahoo.com',0,'2014-01-15 02:07:10',NULL,NULL),(9180,6008,'TE','3306274808',0,'2013-12-26 00:00:33',NULL,NULL),(33352,21849,'TE','5132713151',0,'2014-02-06 21:01:14',NULL,NULL),(33687,22095,'EM','CINCYSUZYQ@YAHOO.COM',0,'2014-02-08 19:00:27',NULL,NULL),(37116,24436,'AP','3305540644',0,'2014-02-18 22:01:16',NULL,NULL),(38335,25325,'AP','2253615239',0,'2014-02-25 21:30:13',NULL,NULL),(43245,28735,'TE','4197332950',0,'2014-03-09 21:00:06',NULL,NULL),(26433,17006,'EM','drdrew86@msn.com',0,'2014-01-13 02:20:34',NULL,NULL),(5167,3317,'EM','burnetbw@yahoo.com',0,'2013-12-25 21:15:59',NULL,NULL),(2099,1297,'AP','9282667521',0,'2013-12-25 18:31:02',NULL,NULL),(33494,21948,'AP','3308062894',0,'2014-02-07 19:00:20',NULL,NULL),(34772,22806,'EM','truthordarelucy_99@yahoo.com',0,'2014-02-11 21:01:55',NULL,NULL),(38057,25117,'AP','6148065991',0,'2014-02-21 21:30:19',NULL,NULL),(40350,26779,'TE','9032272343',0,'2014-03-01 21:00:12',NULL,NULL),(41751,27763,'EM','buechedillion@yahoo.com',0,'2014-03-05 21:31:21',NULL,NULL),(42533,28297,'AP','5138856851',0,'2014-03-07 21:00:30',NULL,NULL),(20196,13013,'TE','9373251349',0,'2013-12-26 12:49:50',NULL,NULL),(2866,1751,'EM','johnmbrown22@earthlink.net',0,'2013-12-25 18:55:44',NULL,NULL),(36088,23736,'TE','3303228889',0,'2014-02-14 21:31:01',NULL,NULL),(38660,25549,'EM','diannerfulmer@gmail.com',0,'2014-02-26 08:00:17',NULL,NULL),(38836,25670,'AP','5132590291',0,'2014-02-26 08:30:52',NULL,NULL),(43889,29121,'TE','4196194109',0,'2014-03-10 21:02:30',NULL,NULL),(30059,19471,'EM','missizzy80@gmail.com',0,'2014-01-23 03:02:00',NULL,NULL),(29775,19253,'TE','2256367979',0,'2014-01-21 08:46:45',NULL,NULL),(28725,18537,'TE','5133479599',0,'2014-01-16 08:46:46',NULL,NULL),(4873,3119,'AP','9199320642',0,'2013-12-25 20:30:15',NULL,NULL),(26531,17068,'AP','2147355189',0,'2014-01-13 02:21:16',NULL,NULL),(40708,27044,'AP','4193605483',0,'2014-03-03 21:00:23',NULL,NULL),(43807,29080,'EM','tamatha_thurman@yahoo.com',0,'2014-03-10 21:02:03',NULL,NULL),(1213,740,'TE','9565772278',0,'2013-12-25 18:04:01',NULL,NULL),(2250,1379,'TE','3372546025',0,'2013-12-25 18:46:02',NULL,NULL),(6739,4377,'TE','9374990910',0,'2013-12-25 22:00:30',NULL,NULL),(13867,9043,'TE','3307241074',0,'2013-12-26 04:05:52',NULL,NULL),(3890,2471,'EM','adamcbourgeois@gmail.com',0,'2013-12-25 19:35:14',NULL,NULL),(24670,15907,'AP','9375151810',0,'2014-01-03 02:06:17',NULL,NULL),(14695,9615,'AP','5135183916',0,'2013-12-26 04:37:46',NULL,NULL),(35751,23513,'TE','6626331618',0,'2014-02-13 22:02:15',NULL,NULL),(37563,24734,'EM','msswiger@yahoo.com',0,'2014-02-20 04:40:00',NULL,NULL),(42758,28441,'AP','5049124353',0,'2014-03-07 21:31:14',NULL,NULL),(43439,28848,'EM','driver29m@yahoo.com',0,'2014-03-09 21:01:17',NULL,NULL),(9317,6100,'AP','4406454527',0,'2013-12-26 00:15:12',NULL,NULL),(8755,5738,'EM','vonnie.hawkins@gmail.com',0,'2013-12-25 23:45:53',NULL,NULL),(14144,9260,'AP','5042509049',0,'2013-12-26 04:15:18',NULL,NULL),(31948,20854,'AP','9373619040',0,'2014-01-31 21:00:54',NULL,NULL),(14419,9426,'AP','9156378339',0,'2013-12-26 04:33:15',NULL,NULL),(7145,4659,'EM','patarceneaux@eatel.net',0,'2013-12-25 22:07:20',NULL,NULL),(30896,20084,'AP','2253159716',0,'2014-01-27 21:00:25',NULL,NULL),(7111,4644,'TE','2282842014',0,'2013-12-25 22:06:52',NULL,NULL),(11047,7172,'EM','q.goodbye32@gmail.com',0,'2013-12-26 01:52:45',NULL,NULL),(10271,6708,'EM','rebelx@comcast.net',0,'2013-12-26 01:02:09',NULL,NULL),(27269,17556,'AP','5129688551',0,'2014-01-13 03:01:58',NULL,NULL),(3907,2479,'EM','kjb1117@gmail.com',0,'2013-12-25 19:35:28',NULL,NULL),(9685,6345,'AP','7407011867',0,'2013-12-26 00:46:53',NULL,NULL),(7752,5062,'TE','3618540703',0,'2013-12-25 23:00:28',NULL,NULL),(34488,22625,'EM','cectat@gmail.com',0,'2014-02-11 21:00:14',NULL,NULL),(37941,25033,'TE','2256861725',0,'2014-02-20 22:01:05',NULL,NULL),(14124,9249,'AP','4197226932',0,'2013-12-26 04:10:46',NULL,NULL),(6589,4254,'TE','3305947119',0,'2013-12-25 21:51:22',NULL,NULL),(29797,19271,'EM','josh.beam@yahoo.com',0,'2014-01-21 08:46:54',NULL,NULL),(6411,4138,'AP','3303572586',0,'2013-12-25 21:48:31',NULL,NULL),(20652,13282,'TE','9566427678',0,'2013-12-26 12:57:14',NULL,NULL),(29734,19227,'TE','4192178846',0,'2014-01-21 08:46:30',NULL,NULL),(22146,14263,'TE','5133930614',0,'2013-12-27 02:05:52',NULL,NULL),(35260,23156,'AP','5135605977',0,'2014-02-12 21:31:44',NULL,NULL),(35532,23369,'TE','2162213987',0,'2014-02-13 22:00:51',NULL,NULL),(29055,18760,'AP','6315747868',0,'2014-01-17 03:35:47',NULL,NULL),(2110,1303,'EM','heleanaw@gmail.com',0,'2013-12-25 18:31:15',NULL,NULL),(23835,15379,'TE','5132370701',1,'2014-01-02 04:25:22',NULL,NULL),(1519,936,'EM','meicher1@columbus.rr.com',0,'2013-12-25 18:09:12',NULL,NULL),(23015,14844,'TE','4192068344',1,'2013-12-29 11:14:55',NULL,NULL),(39877,26382,'EM','fouratonce@gmail.com',0,'2014-02-28 07:00:21',NULL,NULL),(42020,27930,'TE','3023391116',0,'2014-03-06 21:00:25',NULL,NULL),(42832,28488,'AP','4193887729',0,'2014-03-07 21:31:40',NULL,NULL),(14000,9140,'AP','5027278238',0,'2013-12-26 04:08:10',NULL,NULL),(9590,6277,'EM','hanna1274@yahoo.com',0,'2013-12-26 00:45:17',NULL,NULL),(1680,1033,'TE','9724904327',0,'2013-12-25 18:15:34',NULL,NULL),(26753,17209,'TE','3306285387',0,'2014-01-13 02:22:28',NULL,NULL),(900,557,'TE','5043888755',0,'2013-12-25 17:50:12',NULL,NULL),(26549,17077,'AP','8063172028',0,'2014-01-13 02:21:21',NULL,NULL),(33647,22067,'AP','4045474579',0,'2014-02-08 19:00:12',NULL,NULL),(34969,22957,'BN','5049059596',0,'2014-02-12 21:00:06',NULL,NULL),(40027,26530,'EM','jacobcmills@gmail.com',0,'2014-02-28 21:00:28',NULL,NULL),(12083,7893,'TE','4198735588',0,'2013-12-26 03:05:40',NULL,NULL),(27227,17529,'AP','3304309280',0,'2014-01-13 03:01:42',NULL,NULL),(20828,13387,'AP','5133304247',0,'2013-12-26 13:00:03',NULL,NULL),(10891,7077,'TE','4192963454',0,'2013-12-26 01:50:13',NULL,NULL),(34990,22972,'EM','kayla_herrin09@yahoo.com',0,'2014-02-12 21:00:17',NULL,NULL),(40448,26852,'AP','6625885732',0,'2014-03-01 21:00:51',NULL,NULL),(11471,7460,'EM','rodriguezarmin@yahoo.com',0,'2013-12-26 02:30:54',NULL,NULL),(6511,4208,'TE','3614455851',0,'2013-12-25 21:50:07',NULL,NULL),(5454,3491,'TE','4407477817',0,'2013-12-25 21:20:27',NULL,NULL),(2502,1535,'TE','9377634922',0,'2013-12-25 18:50:07',NULL,NULL),(5060,3248,'AP','6785243107',0,'2013-12-25 20:46:33',NULL,NULL),(3014,1875,'TE','4405633292',0,'2013-12-25 18:58:24',NULL,NULL),(20611,13255,'AP','9033882281',0,'2013-12-26 12:56:32',NULL,NULL),(21652,13935,'TE','4194906645',0,'2013-12-26 13:14:36',NULL,NULL),(27823,17929,'EM','hobojo101@gmail.com',0,'2014-01-15 02:06:34',NULL,NULL),(25705,16571,'TE','4195091606',1,'2014-01-07 10:23:21',NULL,NULL),(31867,20803,'TE','9564668417',0,'2014-01-31 21:00:23',NULL,NULL),(38338,25327,'AP','3375819154',0,'2014-02-25 21:30:14',NULL,NULL),(38396,25366,'AP','5134329401',0,'2014-02-25 21:30:39',NULL,NULL),(11478,7465,'EM','deepsouthfs@comcast.net',0,'2013-12-26 02:31:02',NULL,NULL),(14776,9670,'TE','9374861000',0,'2013-12-26 04:39:12',NULL,NULL),(8116,5314,'TE','3304756609',0,'2013-12-25 23:06:40',NULL,NULL),(8942,5852,'EM','magetol@yahoo.com',0,'2013-12-25 23:48:51',NULL,NULL),(3938,2497,'TE','9857484039',0,'2013-12-25 19:35:58',NULL,NULL),(36478,24015,'AP','4402388223',0,'2014-02-15 22:00:43',NULL,NULL),(37376,24610,'EM','THUMBSUPINC@AOL.COM',0,'2014-02-20 04:14:04',NULL,NULL),(30453,19742,'TE','5134894514',0,'2014-01-23 21:01:12',NULL,NULL),(25421,16396,'TE','4694635571',0,'2014-01-07 04:03:44',NULL,NULL),(25171,16231,'EM','shaun2240@neo.rr.com',0,'2014-01-05 00:02:03',NULL,NULL),(22254,14341,'TE','4192038649',0,'2013-12-27 02:07:53',NULL,NULL),(31795,20751,'AP','4197051155',0,'2014-01-30 21:01:31',NULL,NULL),(35373,23243,'AP','3307011289',0,'2014-02-13 21:30:03',NULL,NULL),(37837,24964,'AP','5044212431',0,'2014-02-20 22:00:22',NULL,NULL),(37839,24965,'TE','6316729511',0,'2014-02-20 22:00:23',NULL,NULL),(28679,18502,'EM','door2moose@sssnet.com',0,'2014-01-16 08:46:30',NULL,NULL),(14841,9713,'AP','3305395585',0,'2013-12-26 04:45:16',NULL,NULL),(579,359,'TE','9372321567',0,'2013-12-25 17:45:06',NULL,NULL),(9644,6311,'TE','5132825199',0,'2013-12-26 00:46:10',NULL,NULL),(2964,1834,'EM','denis@denisfox.com',0,'2013-12-25 18:57:31',NULL,NULL),(5582,3567,'AP','4193463100',0,'2013-12-25 21:22:28',NULL,NULL),(38174,25195,'AP','2253021804',0,'2014-02-21 22:00:43',NULL,NULL),(38445,25407,'TE','2165348821',0,'2014-02-25 21:31:00',NULL,NULL),(20566,13235,'AP','5125547423',0,'2013-12-26 12:55:54',NULL,NULL),(598,368,'EM','forest1431@outlook.com',0,'2013-12-25 17:45:23',NULL,NULL),(28764,18561,'TE','9375159782',0,'2014-01-16 08:46:59',NULL,NULL),(5125,3283,'EM','greencitymail@aol.com',0,'2013-12-25 21:15:20',NULL,NULL),(5536,3539,'AP','8325189166',0,'2013-12-25 21:21:43',NULL,NULL),(2013,1248,'TE','9372188423',0,'2013-12-25 18:21:08',NULL,NULL),(9818,6423,'AP','9859814483',0,'2013-12-26 00:48:58',NULL,NULL),(7437,4844,'EM','gambill.carrie@yahoo.com',0,'2013-12-25 22:30:12',NULL,NULL),(38252,25254,'EM','timaltrichard@live.com',0,'2014-02-21 22:01:16',NULL,NULL),(43782,29063,'TE','4197260439',0,'2014-03-10 21:01:53',NULL,NULL),(14661,9592,'TE','3306301184',0,'2013-12-26 04:37:11',NULL,NULL),(998,614,'TE','5136082503',0,'2013-12-25 18:00:40',NULL,NULL),(13676,8915,'TE','5133350746',0,'2013-12-26 04:02:41',NULL,NULL),(25878,16683,'TE','3304219807',0,'2014-01-08 18:24:32',NULL,NULL),(20883,13428,'AP','4408126711',0,'2013-12-26 13:00:58',NULL,NULL),(41467,27556,'EM','DELIA56@HUGHES.NET',0,'2014-03-04 21:30:14',NULL,NULL),(42497,28262,'EM','jd.bizz@yahoo.com',0,'2014-03-07 21:00:17',NULL,NULL),(14495,9469,'AP','5133176986',0,'2013-12-26 04:34:24',NULL,NULL),(12236,7998,'EM','linda@bfkadopt.org',0,'2013-12-26 03:08:20',NULL,NULL),(25313,16324,'AP','9853609752',0,'2014-01-07 04:01:47',NULL,NULL),(11524,7500,'AP','4403640311',0,'2013-12-26 02:31:49',NULL,NULL),(8269,5417,'TE','4199833382',0,'2013-12-25 23:09:17',NULL,NULL),(39562,26175,'AP','7696107429',0,'2014-02-28 06:30:38',NULL,NULL),(30471,19755,'TE','6148288002',0,'2014-01-23 21:01:21',NULL,NULL),(11650,7585,'TE','5122171099',0,'2013-12-26 02:34:02',NULL,NULL),(22926,14791,'EM','coolfastback@sbcglobal.net',1,'2013-12-29 11:13:31',NULL,NULL),(4327,2761,'TE','2346783904',0,'2013-12-25 19:49:20',NULL,NULL),(2190,1346,'EM','Matthew.Momoh@gmail.com',0,'2013-12-25 18:45:08',NULL,NULL),(21938,14131,'AP','3182403848',0,'2013-12-27 02:02:24',NULL,NULL),(38232,25238,'EM','rpruitt92@hotmail.com',0,'2014-02-21 22:01:06',NULL,NULL),(6113,3933,'AP','4194903708',0,'2013-12-25 21:37:43',NULL,NULL),(36521,24044,'EM','deesoutendijk@gmail.com',0,'2014-02-15 22:01:00',NULL,NULL),(37298,24542,'EM','cerra.wingo@gmail.com',0,'2014-02-20 04:03:01',NULL,NULL),(38438,25403,'TE','3309930509',0,'2014-02-25 21:30:57',NULL,NULL),(25461,16418,'TE','9372072955',0,'2014-01-07 04:04:27',NULL,NULL),(456,287,'AP','7136798802',0,'2013-12-25 17:30:26',NULL,NULL),(22389,14441,'EM','PWheeler51@yahoo.com',0,'2013-12-28 03:32:12',NULL,NULL),(33564,22001,'BN','4193888596',0,'2014-02-07 19:00:48',NULL,NULL),(33816,22204,'TE','4403388225',0,'2014-02-09 19:00:16',NULL,NULL),(42577,28332,'TE','2147973992',0,'2014-03-07 21:30:11',NULL,NULL),(43279,28754,'AP','9153428209',0,'2014-03-09 21:00:18',NULL,NULL),(27433,17668,'EM','icursendingmemail@gmail.com',0,'2014-01-14 01:32:48',NULL,NULL),(1642,1008,'AP','4197226558',0,'2013-12-25 18:11:10',NULL,NULL),(25965,16725,'TE','3302618463',0,'2014-01-08 18:24:48',NULL,NULL),(10967,7126,'AP','6015598296',0,'2013-12-26 01:51:30',NULL,NULL),(27262,17553,'AP','9018265466',0,'2014-01-13 03:01:55',NULL,NULL),(20804,13367,'TE','5138074202',0,'2013-12-26 12:59:40',NULL,NULL),(33210,21747,'AP','9157400388',0,'2014-02-06 21:00:19',NULL,NULL),(3069,1910,'TE','5135305413',0,'2013-12-25 18:59:24',NULL,NULL),(26621,17128,'TE','2163280944',0,'2014-01-13 02:21:45',NULL,NULL),(24998,16112,'TE','9015173153',0,'2014-01-04 02:05:07',NULL,NULL),(4995,3206,'TE','6163083135',0,'2013-12-25 20:45:20',NULL,NULL),(3785,2402,'TE','9373994871',0,'2013-12-25 19:33:34',NULL,NULL),(3118,1944,'TE','5137231330',0,'2013-12-25 19:00:46',NULL,NULL),(23873,15406,'TE','3617261491',1,'2014-01-02 04:26:57',NULL,NULL),(22332,14400,'TE','9372699987',0,'2013-12-28 03:31:11',NULL,NULL),(39110,25873,'TE','5044444633',0,'2014-02-26 21:00:52',NULL,NULL),(812,505,'AP','5616328647',0,'2013-12-25 17:48:48',NULL,NULL),(2112,1304,'AP','9039161157',0,'2013-12-25 18:31:16',NULL,NULL),(28073,18093,'TE','5049127535',0,'2014-01-15 02:07:31',NULL,NULL),(27416,17658,'EM','feesburgfertilizer1@yahoo.com',0,'2014-01-14 01:32:44',NULL,NULL),(22718,14649,'EM','ray6120@gmail.com',1,'2013-12-29 11:07:42',NULL,NULL),(13853,9033,'TE','3308962481',0,'2013-12-26 04:05:38',NULL,NULL),(22020,14183,'TE','9036936881',0,'2013-12-27 02:03:46',NULL,NULL),(14291,9349,'AP','2252762493',0,'2013-12-26 04:31:12',NULL,NULL),(29401,19001,'AP','5042106596',0,'2014-01-20 08:06:16',NULL,NULL),(34444,22597,'TE','4194600964',0,'2014-02-10 21:32:13',NULL,NULL),(35543,23373,'AP','5134850560',0,'2014-02-13 22:00:55',NULL,NULL),(11525,7501,'TE','5139190865',0,'2013-12-26 02:31:51',NULL,NULL),(1725,1057,'TE','5126423279',0,'2013-12-25 18:16:12',NULL,NULL),(7668,4990,'EM','angelrice01@aol.com',0,'2013-12-25 22:46:58',NULL,NULL),(3954,2510,'EM','WIFK@AOL.COM',0,'2013-12-25 19:36:17',NULL,NULL),(30877,20070,'AP','9364393623',0,'2014-01-27 21:00:17',NULL,NULL),(31499,20524,'EM','rlmorris13@yahoo.com',0,'2014-01-29 21:01:27',NULL,NULL),(33297,21806,'TE','3306206530',0,'2014-02-06 21:00:52',NULL,NULL),(34428,22586,'TE','5676442537',0,'2014-02-10 21:32:06',NULL,NULL),(39452,26092,'TE','5043270402',0,'2014-02-28 06:30:09',NULL,NULL),(23859,15395,'EM','lyntone23@gmail.com',1,'2014-01-02 04:25:52',NULL,NULL),(6069,3907,'TE','4194832940',0,'2013-12-25 21:36:59',NULL,NULL),(23110,14900,'TE','3308055684',0,'2013-12-30 00:01:06',NULL,NULL),(10998,7143,'TE','9726898366',0,'2013-12-26 01:51:57',NULL,NULL),(4427,2823,'TE','5136072829',0,'2013-12-25 20:00:33',NULL,NULL),(5007,3214,'AP','2142137138',0,'2013-12-25 20:45:31',NULL,NULL),(36736,24186,'AP','5135157945',0,'2014-02-16 19:00:11',NULL,NULL),(38249,25253,'EM','marquisbrannon@yahoo.com',0,'2014-02-21 22:01:15',NULL,NULL),(40414,26826,'AP','2167896771',0,'2014-03-01 21:00:37',NULL,NULL),(28044,18071,'BN','3182359292',0,'2014-01-15 02:07:24',NULL,NULL),(6126,3944,'TE','9372140598',0,'2013-12-25 21:38:01',NULL,NULL),(5570,3558,'AP','3306878584',0,'2013-12-25 21:22:14',NULL,NULL),(5217,3354,'AP','3619443397',0,'2013-12-25 21:16:48',NULL,NULL),(26565,17089,'TE','3239193391',0,'2014-01-13 02:21:26',NULL,NULL),(1224,747,'EM','tammykantor@gmail.com',0,'2013-12-25 18:04:11',NULL,NULL),(3020,1882,'TE','4197260929',0,'2013-12-25 18:58:34',NULL,NULL),(1809,1118,'EM','wsherokie@yahoo.com',0,'2013-12-25 18:17:45',NULL,NULL),(26077,16795,'TE','2142930739',0,'2014-01-13 02:18:08',NULL,NULL),(12371,8098,'EM','Neotrucking@gmail.com',0,'2013-12-26 03:10:51',NULL,NULL),(22875,14759,'EM','navinabhatkar@yahoo.com',1,'2013-12-29 11:12:39',NULL,NULL),(29924,19366,'TE','3308645990',1,'2014-01-22 03:22:33',NULL,NULL),(34137,22385,'TE','8649407163',0,'2014-02-10 21:30:11',NULL,NULL),(39792,26308,'EM','rosa.saenz1961@gmail.com',0,'2014-02-28 06:31:32',NULL,NULL),(28284,18234,'EM','paula_noel@yahoo.com',0,'2014-01-16 08:44:21',NULL,NULL),(5306,3402,'TE','3182724065',0,'2013-12-25 21:18:08',NULL,NULL),(3693,2342,'TE','3129339414',0,'2013-12-25 19:32:00',NULL,NULL),(22870,14758,'TE','9152825092',1,'2013-12-29 11:12:36',NULL,NULL),(20874,13420,'EM','susesmith@mac.com',0,'2013-12-26 13:00:48',NULL,NULL),(32354,21141,'TE','5127043382',0,'2014-02-03 21:00:22',NULL,NULL),(34805,22831,'AP','3303211285',0,'2014-02-11 21:02:07',NULL,NULL),(41766,27772,'TE','2255055181',0,'2014-03-05 21:31:27',NULL,NULL),(42071,27956,'TE','3373712804',0,'2014-03-06 21:00:41',NULL,NULL),(14480,9455,'AP','5134976040',0,'2013-12-26 04:34:05',NULL,NULL),(5030,3226,'TE','5134466613',0,'2013-12-25 20:45:54',NULL,NULL),(3458,2164,'TE','3306700015',0,'2013-12-25 19:19:00',NULL,NULL),(6148,3958,'TE','3306509474',0,'2013-12-25 21:38:22',NULL,NULL),(4897,3144,'AP','6824380702',0,'2013-12-25 20:30:52',NULL,NULL),(21819,14057,'EM','rcreamer33@gmail.com',0,'2013-12-27 02:00:28',NULL,NULL),(6264,4042,'EM','diamond.ae@pg.com',0,'2013-12-25 21:46:08',NULL,NULL),(9809,6419,'AP','4197336344',0,'2013-12-26 00:48:50',NULL,NULL),(4319,2756,'TE','4404522498',0,'2013-12-25 19:49:12',NULL,NULL),(5325,3413,'AP','2253280848',0,'2013-12-25 21:18:26',NULL,NULL),(9134,5982,'TE','4408881843',0,'2013-12-25 23:51:58',NULL,NULL),(3855,2454,'AP','2107256292',0,'2013-12-25 19:34:44',NULL,NULL),(6518,4213,'TE','3252474090',0,'2013-12-25 21:50:15',NULL,NULL),(26426,17004,'AP','7408158006',0,'2014-01-13 02:20:33',NULL,NULL),(35947,23652,'TE','9562852621',0,'2014-02-14 21:30:14',NULL,NULL),(40086,26585,'TE','6142078754',0,'2014-02-28 21:30:33',NULL,NULL),(42308,28091,'AP','6624199554',0,'2014-03-06 21:02:05',NULL,NULL),(9385,6142,'AP','6145066844',0,'2013-12-26 00:16:18',NULL,NULL),(24015,15509,'TE','6143525678',1,'2014-01-02 04:29:55',NULL,NULL),(2174,1338,'TE','9379022240',0,'2013-12-25 18:32:19',NULL,NULL),(6619,4277,'TE','9372054911',0,'2013-12-25 21:51:55',NULL,NULL),(8469,5573,'TE','3048120595',0,'2013-12-25 23:16:44',NULL,NULL),(36595,24094,'TE','4196513530',0,'2014-02-15 22:01:27',NULL,NULL),(37466,24674,'AP','4199577465',0,'2014-02-20 04:28:05',NULL,NULL),(43599,28946,'EM','danielhart822@gmail.com',0,'2014-03-10 21:00:47',NULL,NULL),(113,67,'EM','mustanggt1302@gmail.com',0,'2013-12-25 17:16:49',NULL,NULL),(14110,9227,'AP','5133904399',0,'2013-12-26 04:10:23',NULL,NULL),(7467,4861,'TE','9723152521',0,'2013-12-25 22:30:41',NULL,NULL),(30081,19488,'AP','8303177887',0,'2014-01-23 03:02:05',NULL,NULL),(30697,19941,'TE','4198520704',0,'2014-01-24 21:01:15',NULL,NULL),(31887,20812,'EM','PINKISOO@AOL.COM',0,'2014-01-31 21:00:29',NULL,NULL),(34946,22938,'AP','9852120480',0,'2014-02-11 21:30:17',NULL,NULL),(36970,24343,'TE','2146977124',0,'2014-02-18 22:00:21',NULL,NULL),(39677,26236,'TE','9366618006',0,'2014-02-28 06:31:03',NULL,NULL),(43152,28680,'AP','9288309020',0,'2014-03-08 21:30:56',NULL,NULL),(27841,17937,'AP','9152441740',0,'2014-01-15 02:06:38',NULL,NULL),(11140,7243,'TE','3108040857',0,'2013-12-26 02:01:43',NULL,NULL),(2506,1537,'AP','3174424417',0,'2013-12-25 18:50:11',NULL,NULL),(1605,988,'TE','5135835619',0,'2013-12-25 18:10:31',NULL,NULL),(20405,13141,'TE','4403521268',0,'2013-12-26 12:53:19',NULL,NULL),(26318,16943,'EM','mjr1105@hotmail.com',0,'2014-01-13 02:19:55',NULL,NULL),(30420,19718,'TE','4195726741',0,'2014-01-23 21:00:57',NULL,NULL),(35938,23646,'TE','9723521763',0,'2014-02-14 21:30:11',NULL,NULL),(41104,27302,'EM','mikeandbarbara_stanley@yahoo.com',0,'2014-03-04 21:00:35',NULL,NULL),(42197,28029,'AP','4194100452',0,'2014-03-06 21:01:26',NULL,NULL),(42828,28486,'AP','7405171263',0,'2014-03-07 21:31:38',NULL,NULL),(43198,28708,'TE','7346254876',0,'2014-03-08 21:31:12',NULL,NULL),(26057,16784,'AP','4197044506',0,'2014-01-08 18:25:07',NULL,NULL),(4568,2915,'TE','5138250155',0,'2013-12-25 20:15:38',NULL,NULL),(9540,6245,'EM','monicamkoelsch@gmail.com',0,'2013-12-26 00:31:46',NULL,NULL),(7593,4944,'TE','4157139640',0,'2013-12-25 22:45:45',NULL,NULL),(2155,1327,'TE','3306855010',0,'2013-12-25 18:31:58',NULL,NULL),(3099,1933,'AP','9794798080',0,'2013-12-25 19:00:27',NULL,NULL),(28034,18066,'AP','9854744115',0,'2014-01-15 02:07:22',NULL,NULL),(24813,16007,'AP','5127994830',0,'2014-01-04 02:01:41',NULL,NULL),(726,456,'AP','4199662089',0,'2013-12-25 17:47:29',NULL,NULL),(9325,6107,'AP','6143297780',0,'2013-12-26 00:15:21',NULL,NULL),(41444,27532,'EM','zacharytmorgan2011@yahoo.com',0,'2014-03-04 21:02:48',NULL,NULL),(41759,27767,'AP','5044159748',0,'2014-03-05 21:31:24',NULL,NULL),(9164,5999,'EM','Brownaprild@aol.com',0,'2013-12-26 00:00:19',NULL,NULL),(6387,4114,'AP','9378230457',0,'2013-12-25 21:48:05',NULL,NULL),(30194,19560,'TE','2256870230',0,'2014-01-23 03:02:33',NULL,NULL),(5168,3318,'TE','5137031154',0,'2013-12-25 21:15:59',NULL,NULL),(4565,2910,'TE','5132271253',0,'2013-12-25 20:15:33',NULL,NULL),(22717,14649,'AP','9158459396',1,'2013-12-29 11:07:41',NULL,NULL),(23794,15347,'EM','dignanshade@gmail.com',1,'2014-01-02 04:24:26',NULL,NULL),(25250,16283,'TE','9374096728',0,'2014-01-07 04:00:35',NULL,NULL),(31568,20586,'AP','5134768337',0,'2014-01-30 21:00:06',NULL,NULL),(36063,23720,'TE','2163852047',0,'2014-02-14 21:30:52',NULL,NULL),(36179,23811,'AP','3308441008',0,'2014-02-14 21:31:35',NULL,NULL),(37497,24689,'BN','9567401351',0,'2014-02-20 04:32:23',NULL,NULL),(39305,26002,'TE','5043435735',0,'2014-02-26 21:02:04',NULL,NULL),(43855,29103,'AP','4192621693',0,'2014-03-10 21:02:18',NULL,NULL),(11198,7281,'EM','RBiggs02@hotmail.com',0,'2013-12-26 02:02:42',NULL,NULL),(24084,15548,'TE','4155480038',1,'2014-01-02 04:31:11',NULL,NULL),(9029,5922,'AP','8328848464',0,'2013-12-25 23:50:20',NULL,NULL),(3087,1929,'TE','5123290240',0,'2013-12-25 19:00:20',NULL,NULL),(8518,5600,'AP','5183310914',0,'2013-12-25 23:30:14',NULL,NULL),(20742,13331,'EM','holmes.cameron@gmail.com',0,'2013-12-26 12:58:38',NULL,NULL),(37916,25012,'EM','muse_mneme@yahoo.com',0,'2014-02-20 22:00:53',NULL,NULL),(42124,27984,'TE','2252884457',0,'2014-03-06 21:00:59',NULL,NULL),(42512,28275,'TE','3305441326',0,'2014-03-07 21:00:23',NULL,NULL),(29272,18906,'EM','r.sole24@gmail.com',0,'2014-01-17 03:36:38',NULL,NULL),(4236,2707,'EM','jtoth10570@msn.com',0,'2013-12-25 19:47:55',NULL,NULL),(6308,4065,'AP','5133147442',0,'2013-12-25 21:46:47',NULL,NULL),(40072,26571,'AP','7409619671',0,'2014-02-28 21:30:26',NULL,NULL),(40547,26909,'AP','9852010681',0,'2014-03-03 01:00:11',NULL,NULL),(13619,8874,'EM','tx4169@yahoo.com',0,'2013-12-26 04:01:40',NULL,NULL),(28501,18370,'AP','7404046767',0,'2014-01-16 08:45:30',NULL,NULL),(10920,7098,'EM','K.reagan724@gmail.com',0,'2013-12-26 01:50:42',NULL,NULL),(24767,15978,'EM','krystlelo@msn.com',0,'2014-01-04 02:00:51',NULL,NULL),(23894,15415,'EM','nguyens9@yahoo.com',1,'2014-01-02 04:27:16',NULL,NULL),(31283,20380,'AP','5127737012',0,'2014-01-29 21:00:10',NULL,NULL),(32853,21500,'AP','4199321586',0,'2014-02-04 21:01:51',NULL,NULL),(26050,16781,'TE','5676445157',0,'2014-01-08 18:25:06',NULL,NULL),(12146,7935,'AP','3373800800',0,'2013-12-26 03:06:44',NULL,NULL),(7527,4905,'AP','3375401450',0,'2013-12-25 22:31:55',NULL,NULL),(7459,4856,'TE','5678256107',0,'2013-12-25 22:30:31',NULL,NULL),(2365,1436,'TE','2252064236',0,'2013-12-25 18:47:43',NULL,NULL),(24431,15772,'TE','4326612514',0,'2014-01-03 02:01:51',NULL,NULL),(10177,6651,'AP','5133102064',0,'2013-12-26 01:00:34',NULL,NULL),(4966,3186,'AP','3303294695',0,'2013-12-25 20:32:00',NULL,NULL),(14285,9345,'AP','9587682264',0,'2013-12-26 04:31:06',NULL,NULL),(14659,9590,'EM','theresa.kessler@gmail.com',0,'2013-12-26 04:37:08',NULL,NULL),(20670,13292,'EM','thomas.godfrey5174@att.net',0,'2013-12-26 12:57:31',NULL,NULL),(31301,20396,'TE','9794060242',0,'2014-01-29 21:00:18',NULL,NULL),(32031,20907,'AP','2166323466',0,'2014-01-31 21:01:25',NULL,NULL),(33969,22285,'AP','2162589399',0,'2014-02-10 11:00:25',NULL,NULL),(36385,23965,'AP','5126355635',0,'2014-02-15 22:00:11',NULL,NULL),(37329,24570,'TE','3308619059',0,'2014-02-20 04:07:30',NULL,NULL),(40271,26715,'AP','6019185333',0,'2014-02-28 21:31:41',NULL,NULL),(41780,27777,'AP','3308079200',0,'2014-03-05 21:31:31',NULL,NULL),(28799,18586,'BN','4197074792',0,'2014-01-16 08:47:11',NULL,NULL),(7509,4893,'TE','2108728703',0,'2013-12-25 22:31:35',NULL,NULL),(25226,16265,'TE','6148243888',0,'2014-01-07 04:00:08',NULL,NULL),(7126,4651,'TE','5133770057',0,'2013-12-25 22:07:05',NULL,NULL),(25177,16236,'TE','3612051400',0,'2014-01-05 00:02:11',NULL,NULL),(21400,13759,'AP','5634956254',0,'2013-12-26 13:10:11',NULL,NULL),(2934,1805,'TE','5137029896',0,'2013-12-25 18:56:52',NULL,NULL),(4958,3182,'TE','5045595833',0,'2013-12-25 20:31:53',NULL,NULL),(8416,5541,'EM','karlkal@msn.com',0,'2013-12-25 23:15:49',NULL,NULL),(35087,23045,'TE','8302781353',0,'2014-02-12 21:30:42',NULL,NULL),(35757,23515,'EM','latonya_jade@yahoo.com',0,'2014-02-13 22:02:17',NULL,NULL),(43710,29017,'EM','jilliankehr3@gmail.com',0,'2014-03-10 21:01:28',NULL,NULL),(6987,4563,'EM','sp@neo.rr.com',0,'2013-12-25 22:04:45',NULL,NULL),(1113,683,'TE','9375649179',0,'2013-12-25 18:02:27',NULL,NULL),(14559,9513,'TE','6142365526',0,'2013-12-26 04:35:27',NULL,NULL),(28953,18689,'EM','brandonpmarks@gmail.com',0,'2014-01-17 03:35:24',NULL,NULL),(24303,15701,'TE','4194661928',1,'2014-01-02 04:35:43',NULL,NULL),(8086,5292,'TE','2057463319',0,'2013-12-25 23:06:04',NULL,NULL),(3424,2149,'TE','5134854795',0,'2013-12-25 19:18:31',NULL,NULL),(7832,5112,'TE','9564590203',0,'2013-12-25 23:01:44',NULL,NULL),(10283,6713,'EM','blebarre3381@gmail.com',0,'2013-12-26 01:02:20',NULL,NULL),(30384,19685,'TE','9038181137',0,'2014-01-23 21:00:40',NULL,NULL),(26557,17082,'TE','8302632029',0,'2014-01-13 02:21:23',NULL,NULL),(10157,6638,'AP','3309629987',0,'2013-12-26 01:00:14',NULL,NULL),(10116,6615,'TE','4198893730',0,'2013-12-26 00:53:52',NULL,NULL),(3990,2534,'TE','9373994871',0,'2013-12-25 19:36:52',NULL,NULL),(3850,2449,'AP','8323357638',0,'2013-12-25 19:34:39',NULL,NULL),(31615,20621,'AP','2254567218',0,'2014-01-30 21:00:24',NULL,NULL),(37557,24732,'TE','3308631538',0,'2014-02-20 04:39:26',NULL,NULL),(38233,25239,'EM','haleyandbebo@gmail.com',0,'2014-02-21 22:01:07',NULL,NULL),(30626,19876,'AP','2167992500',0,'2014-01-24 21:00:44',NULL,NULL),(20616,13257,'EM','aviator33r@rocketmail.com',0,'2013-12-26 12:56:35',NULL,NULL),(11899,7742,'TE','3302835717',0,'2013-12-26 03:02:18',NULL,NULL),(11430,7436,'AP','3305920675',0,'2013-12-26 02:30:17',NULL,NULL),(3650,2313,'TE','9723429197',0,'2013-12-25 19:31:14',NULL,NULL),(31505,20528,'EM','JESAJPRODUCTIONS@HOTMAIL.COM',0,'2014-01-29 21:01:29',NULL,NULL),(32025,20904,'AP','5135353181',0,'2014-01-31 21:01:23',NULL,NULL),(36627,24113,'TE','8067780782',0,'2014-02-15 22:01:38',NULL,NULL),(40608,26955,'TE','3303297070',0,'2014-03-03 01:00:29',NULL,NULL),(27667,17834,'TE','5136040638',0,'2014-01-15 02:06:01',NULL,NULL),(12228,7994,'AP','3308193470',0,'2013-12-26 03:08:13',NULL,NULL),(191,113,'AP','9033939088',0,'2013-12-25 17:18:02',NULL,NULL),(451,280,'TE','4197541320',0,'2013-12-25 17:30:16',NULL,NULL),(907,561,'TE','9373655041',0,'2013-12-25 17:50:19',NULL,NULL),(11147,7249,'AP','9853201275',0,'2013-12-26 02:01:52',NULL,NULL),(26888,17299,'TE','9562663751',0,'2014-01-13 02:23:37',NULL,NULL),(1408,859,'EM','funansun@aol.com',0,'2013-12-25 18:07:07',NULL,NULL),(20665,13288,'AP','2144761501',0,'2013-12-26 12:57:25',NULL,NULL),(14967,9791,'EM','cliverett@bellsouth.net',0,'2013-12-26 05:01:00',NULL,NULL),(33766,22159,'EM','schroeded@gmail.com',0,'2014-02-08 19:00:58',NULL,NULL),(42157,28005,'AP','2163142613',0,'2014-03-06 21:01:12',NULL,NULL),(42675,28388,'TE','8156036058',0,'2014-03-07 21:30:44',NULL,NULL),(43023,28606,'AP','6149375625',0,'2014-03-08 21:30:13',NULL,NULL),(28536,18395,'TE','2169522583',0,'2014-01-16 08:45:41',NULL,NULL),(9814,6421,'TE','2252659876',0,'2013-12-26 00:48:54',NULL,NULL),(26248,16893,'TE','3615420785',0,'2014-01-13 02:19:28',NULL,NULL),(1779,1100,'TE','9376455403',0,'2013-12-25 18:17:15',NULL,NULL),(3459,2164,'EM','davbenson@aol.com',0,'2013-12-25 19:19:00',NULL,NULL),(21150,13599,'AP','4194952686',0,'2013-12-26 13:05:23',NULL,NULL),(23032,14857,'EM','quitenicely@gmail.com',1,'2013-12-29 11:15:15',NULL,NULL),(32681,21372,'EM','bcortega@aol.com',0,'2014-02-04 21:00:49',NULL,NULL),(35352,23228,'EM','dollalyse@aol.com',0,'2014-02-12 21:32:24',NULL,NULL),(37280,24531,'EM','yrod703@gmail.com',0,'2014-02-20 04:00:47',NULL,NULL),(39278,25989,'AP','2282358259',0,'2014-02-26 21:01:55',NULL,NULL),(13618,8874,'AP','2817045916',0,'2013-12-26 04:01:39',NULL,NULL),(27911,17984,'AP','4406667764',0,'2014-01-15 02:06:54',NULL,NULL),(21038,13535,'TE','3182825770',0,'2013-12-26 13:03:36',NULL,NULL),(32669,21366,'AP','2145794965',0,'2014-02-04 21:00:46',NULL,NULL),(33675,22089,'EM','fcigliola@gmail.com',0,'2014-02-08 19:00:23',NULL,NULL),(33970,22285,'EM','payneriley_applehead@yahoo.com',0,'2014-02-10 11:00:25',NULL,NULL),(35330,23215,'AP','6019197205',0,'2014-02-12 21:32:15',NULL,NULL),(35998,23682,'AP','4408210525',0,'2014-02-14 21:30:31',NULL,NULL),(37877,24986,'AP','9159207795',0,'2014-02-20 22:00:37',NULL,NULL),(300,185,'AP','9126634963',0,'2013-12-25 17:19:48',NULL,NULL),(14171,9272,'AP','5132901897',0,'2013-12-26 04:15:42',NULL,NULL),(31003,20169,'TE','3307306366',0,'2014-01-27 21:01:14',NULL,NULL),(5050,3240,'AP','9033881858',0,'2013-12-25 20:46:19',NULL,NULL),(6692,4349,'EM','tierrejr@yahoo.com',0,'2013-12-25 21:53:26',NULL,NULL),(9725,6366,'TE','9373724147',0,'2013-12-26 00:47:29',NULL,NULL),(8445,5557,'TE','4404666007',0,'2013-12-25 23:16:19',NULL,NULL),(21739,14004,'TE','9374778618',0,'2013-12-26 13:16:10',NULL,NULL),(5344,3422,'EM','eotwsbayoupigeon@icloud.com',0,'2013-12-25 21:18:42',NULL,NULL),(3076,1919,'AP','2163164086',0,'2013-12-25 19:00:07',NULL,NULL),(29625,19143,'TE','9153569515',0,'2014-01-21 08:45:30',NULL,NULL),(152,92,'TE','3616589033',0,'2013-12-25 17:17:27',NULL,NULL),(28533,18391,'TE','7402756035',0,'2014-01-16 08:45:40',NULL,NULL),(21566,13869,'TE','3305543029',0,'2013-12-26 13:13:00',NULL,NULL),(5720,3670,'TE','7402281558',0,'2013-12-25 21:31:08',NULL,NULL),(12081,7892,'TE','4198909682',0,'2013-12-26 03:05:38',NULL,NULL),(6762,4389,'TE','5133493433',0,'2013-12-25 22:00:50',NULL,NULL),(14387,9406,'EM','startek67@yahoo.com',0,'2013-12-26 04:32:45',NULL,NULL),(14355,9384,'TE','3476660757',0,'2013-12-26 04:32:11',NULL,NULL),(4546,2891,'AP','3303477374',0,'2013-12-25 20:15:11',NULL,NULL),(32863,21506,'EM','crilldoug@yahoo.com',0,'2014-02-04 21:01:55',NULL,NULL),(38961,25760,'TE','4403447749',0,'2014-02-26 09:30:51',NULL,NULL),(41165,27339,'AP','2169051823',0,'2014-03-04 21:00:58',NULL,NULL),(42904,28532,'AP','8479037256',0,'2014-03-07 21:32:08',NULL,NULL),(27758,17897,'TE','7407468239',0,'2014-01-15 02:06:22',NULL,NULL),(21371,13742,'TE','3308006040',0,'2013-12-26 13:09:43',NULL,NULL),(11334,7384,'TE','5132534286',0,'2013-12-26 02:15:59',NULL,NULL),(13679,8917,'TE','3305243819',0,'2013-12-26 04:02:43',NULL,NULL),(9322,6103,'TE','4409673924',0,'2013-12-26 00:15:16',NULL,NULL),(34180,22414,'EM','ANAGUICARA@GMAIL.COM',0,'2014-02-10 21:30:27',NULL,NULL),(39547,26162,'EM','rorelli@gibsonassocs.com',0,'2014-02-28 06:30:33',NULL,NULL),(40398,26816,'EM','bryluna@yahoo.com',0,'2014-03-01 21:00:31',NULL,NULL),(27265,17554,'AP','5139811135',0,'2014-01-13 03:01:56',NULL,NULL),(21732,14001,'EM','jramps@neo.rr.com',0,'2013-12-26 13:16:04',NULL,NULL),(1207,735,'AP','8064380744',0,'2013-12-25 18:03:54',NULL,NULL),(21694,13968,'TE','9376635581',0,'2013-12-26 13:15:19',NULL,NULL),(12378,8107,'TE','4195815878',0,'2013-12-26 03:11:00',NULL,NULL),(29693,19194,'TE','2147526736',0,'2014-01-21 08:46:14',NULL,NULL),(30380,19683,'TE','3602208137',0,'2014-01-23 21:00:39',NULL,NULL),(34171,22409,'AP','5042286487',0,'2014-02-10 21:30:24',NULL,NULL),(34677,22740,'TE','9856874291',0,'2014-02-11 21:01:19',NULL,NULL),(22132,14256,'AP','2259102917',0,'2013-12-27 02:05:39',NULL,NULL),(22050,14200,'AP','5125733888',0,'2013-12-27 02:04:14',NULL,NULL),(21701,13973,'TE','9377488244',0,'2013-12-26 13:15:27',NULL,NULL),(8570,5635,'AP','9037440469',0,'2013-12-25 23:31:05',NULL,NULL),(11569,7527,'AP','9404440203',0,'2013-12-26 02:32:36',NULL,NULL),(28492,18358,'EM','julie.schivelbein@att.net',0,'2014-01-16 08:45:25',NULL,NULL),(23146,14922,'TE','2257725465',0,'2013-12-30 00:01:43',NULL,NULL),(22547,14540,'EM','hrm2@comcast.net',0,'2013-12-28 03:34:47',NULL,NULL),(6025,3868,'AP','3183555318',0,'2013-12-25 21:36:08',NULL,NULL),(2049,1269,'AP','9512884294',0,'2013-12-25 18:30:12',NULL,NULL),(14354,9383,'EM','FOODDANCEFILMS@MAC.COM',0,'2013-12-26 04:32:10',NULL,NULL),(14014,9150,'TE','2163424615',0,'2013-12-26 04:08:25',NULL,NULL),(30881,20072,'TE','8184150332',0,'2014-01-27 21:00:18',NULL,NULL),(33039,21644,'AP','8063881923',0,'2014-02-05 21:30:47',NULL,NULL),(37525,24711,'AP','6142260708',0,'2014-02-20 04:36:15',NULL,NULL),(43447,28854,'TE','5133351223',0,'2014-03-09 21:01:20',NULL,NULL),(20899,13438,'TE','5135453653',0,'2013-12-26 13:01:13',NULL,NULL),(6442,4162,'EM','jarter350@yahoo.com',0,'2013-12-25 21:49:01',NULL,NULL),(20276,13068,'EM','scottkalel17@gmail.com',0,'2013-12-26 12:51:14',NULL,NULL),(14939,9773,'AP','3184970878',0,'2013-12-26 05:00:32',NULL,NULL),(2973,1843,'TE','3302836353',0,'2013-12-25 18:57:41',NULL,NULL),(5824,3739,'EM','nykeluv@hotmail.com',0,'2013-12-25 21:32:50',NULL,NULL),(33284,21795,'EM','daiseysharkey@yahoo.com',0,'2014-02-06 21:00:46',NULL,NULL),(33844,22218,'TE','2409943415',0,'2014-02-09 19:00:25',NULL,NULL),(36019,23691,'EM','HAIDEY@AOL.COM',0,'2014-02-14 21:30:38',NULL,NULL),(36785,24220,'AP','7136799843',0,'2014-02-16 19:00:28',NULL,NULL),(29159,18839,'TE','3304648849',0,'2014-01-17 03:36:12',NULL,NULL),(4753,3043,'AP','3308081808',0,'2013-12-25 20:18:42',NULL,NULL),(9302,6092,'EM','gregoryabramsjcc@yahoo.com',0,'2013-12-26 00:02:48',NULL,NULL),(5560,3552,'EM','mustanglakes@gmail.com',0,'2013-12-25 21:22:04',NULL,NULL),(32846,21497,'AP','5138076618',0,'2014-02-04 21:01:50',NULL,NULL),(37630,24800,'TE','7403363602',0,'2014-02-20 04:48:13',NULL,NULL),(38428,25396,'AP','3308585222',0,'2014-02-25 21:30:53',NULL,NULL),(41516,27602,'AP','9379036479',0,'2014-03-05 21:00:24',NULL,NULL),(13858,9035,'TE','3302010665',0,'2013-12-26 04:05:41',NULL,NULL),(6633,4293,'TE','7697985875',0,'2013-12-25 21:52:12',NULL,NULL),(12244,8006,'AP','9039462157',0,'2013-12-26 03:08:31',NULL,NULL),(10949,7117,'TE','9374021177',0,'2013-12-26 01:51:14',NULL,NULL),(9391,6145,'AP','7406492939',0,'2013-12-26 00:16:24',NULL,NULL),(34737,22778,'TE','7142648337',0,'2014-02-11 21:01:42',NULL,NULL),(39220,25941,'TE','9565256024',0,'2014-02-26 21:01:31',NULL,NULL),(43722,29024,'TE','5136809317',0,'2014-03-10 21:01:32',NULL,NULL),(27449,17683,'TE','3186418682',0,'2014-01-14 01:32:55',NULL,NULL),(24794,15995,'TE','9035633096',0,'2014-01-04 02:01:21',NULL,NULL),(36159,23797,'AP','3308050613',0,'2014-02-14 21:31:28',NULL,NULL),(36952,24335,'TE','5129939862',0,'2014-02-18 22:00:16',NULL,NULL),(39668,26229,'TE','7136144412',0,'2014-02-28 06:31:00',NULL,NULL),(40418,26831,'AP','4196061115',0,'2014-03-01 21:00:40',NULL,NULL),(43622,28957,'AP','3373239216',0,'2014-03-10 21:00:54',NULL,NULL),(25929,16707,'TE','7193342320',0,'2014-01-08 18:24:41',NULL,NULL),(1011,622,'EM','jacki1973@gmail.com',0,'2013-12-25 18:00:53',NULL,NULL),(12277,8032,'TE','6622994701',0,'2013-12-26 03:09:10',NULL,NULL),(8230,5386,'TE','5044917671',0,'2013-12-25 23:08:31',NULL,NULL),(30688,19935,'TE','4198102000',0,'2014-01-24 21:01:11',NULL,NULL),(31023,20183,'TE','2163741086',0,'2014-01-27 21:01:22',NULL,NULL),(35229,23137,'TE','3306972542',0,'2014-02-12 21:31:34',NULL,NULL),(42114,27979,'TE','2259397107',0,'2014-03-06 21:00:56',NULL,NULL),(9787,6403,'AP','9374227635',0,'2013-12-26 00:48:25',NULL,NULL),(30228,19581,'TE','2256775977',0,'2014-01-23 03:02:40',NULL,NULL),(9491,6210,'TE','9727461748',0,'2013-12-26 00:30:52',NULL,NULL),(7390,4807,'EM','granmit3@yahoo.com',0,'2013-12-25 22:16:42',NULL,NULL),(26186,16857,'TE','4323851931',0,'2014-01-13 02:19:08',NULL,NULL),(23932,15443,'TE','7132317713',1,'2014-01-02 04:28:07',NULL,NULL),(32358,21143,'TE','2818619819',0,'2014-02-03 21:00:23',NULL,NULL),(40314,26748,'AP','3305719324',0,'2014-02-28 21:31:58',NULL,NULL),(40365,26791,'AP','3186584370',0,'2014-03-01 21:00:18',NULL,NULL),(42722,28417,'TE','5134444334',0,'2014-03-07 21:31:00',NULL,NULL),(28482,18355,'TE','2169654221',0,'2014-01-16 08:45:23',NULL,NULL),(26231,16884,'TE','5127990386',0,'2014-01-13 02:19:23',NULL,NULL),(1119,687,'TE','2163968822',0,'2013-12-25 18:02:32',NULL,NULL),(14009,9147,'TE','2164085250',0,'2013-12-26 04:08:20',NULL,NULL),(24804,16002,'AP','9039344386',0,'2014-01-04 02:01:32',NULL,NULL),(6489,4199,'TE','4404761494',0,'2013-12-25 21:49:49',NULL,NULL),(24357,15730,'TE','3012190444',0,'2014-01-03 02:00:28',NULL,NULL),(23443,15108,'TE','3306335042',0,'2014-01-01 12:04:54',NULL,NULL),(23535,15187,'EM','arquinter1@hotmail.com',0,'2014-01-01 12:07:00',NULL,NULL),(36609,24102,'EM','demetrarobertson@yahoo.com',0,'2014-02-15 22:01:31',NULL,NULL),(39964,26459,'AP','5049092396',0,'2014-02-28 07:30:30',NULL,NULL),(40477,26865,'AP','5129949733',0,'2014-03-01 21:01:00',NULL,NULL),(7189,4684,'TE','9856186250',0,'2013-12-25 22:07:59',NULL,NULL),(12061,7874,'EM','WAHOO755@AOL.COM',0,'2013-12-26 03:05:16',NULL,NULL),(10927,7105,'TE','5136017017',0,'2013-12-26 01:50:51',NULL,NULL),(27236,17534,'AP','5136331444',0,'2014-01-13 03:01:45',NULL,NULL),(9975,6526,'TE','5138583342',0,'2013-12-26 00:51:34',NULL,NULL),(2552,1559,'AP','6012917818',0,'2013-12-25 18:50:51',NULL,NULL),(7691,5019,'TE','3182188627',0,'2013-12-25 22:47:30',NULL,NULL),(9576,6270,'AP','2167892790',0,'2013-12-26 00:45:06',NULL,NULL),(27105,17437,'TE','4199730977',0,'2014-01-13 03:00:34',NULL,NULL),(20664,13288,'TE','2144761501',0,'2013-12-26 12:57:24',NULL,NULL),(24569,15846,'AP','4192362668',0,'2014-01-03 02:04:20',NULL,NULL),(27042,17391,'EM','jpee@woh.rr.com',0,'2014-01-13 03:00:11',NULL,NULL),(30541,19813,'TE','3612378124',0,'2014-01-24 21:00:10',NULL,NULL),(30841,20048,'AP','2814954570',0,'2014-01-27 21:00:03',NULL,NULL),(32261,21072,'TE','4195770414',0,'2014-02-02 19:00:17',NULL,NULL),(34491,22628,'TE','9156333426',0,'2014-02-11 21:00:15',NULL,NULL),(35483,23333,'EM','harmonia@core.com',0,'2014-02-13 22:00:32',NULL,NULL),(38759,25623,'TE','9152417843',0,'2014-02-26 08:30:18',NULL,NULL),(39685,26240,'TE','9567940839',0,'2014-02-28 06:31:04',NULL,NULL),(40395,26812,'EM','flanaganpm@frontier.com',0,'2014-03-01 21:00:29',NULL,NULL),(2426,1483,'TE','4409461318',0,'2013-12-25 18:48:52',NULL,NULL),(23496,15151,'EM','annaament@yahoo.com',0,'2014-01-01 12:06:05',NULL,NULL),(5046,3238,'AP','9727410985',0,'2013-12-25 20:46:15',NULL,NULL),(31912,20830,'AP','5044443671',0,'2014-01-31 21:00:40',NULL,NULL),(39306,26002,'AP','5043435735',0,'2014-02-26 21:02:04',NULL,NULL),(42149,28002,'BN','2165267776',0,'2014-03-06 21:01:09',NULL,NULL),(43407,28826,'AP','4193464777',0,'2014-03-09 21:01:03',NULL,NULL),(27984,18039,'TE','4192608785',0,'2014-01-15 02:07:12',NULL,NULL),(7885,5139,'EM','dsmadaras@att.net',0,'2013-12-25 23:02:29',NULL,NULL),(5831,3743,'TE','3616878232',0,'2013-12-25 21:32:57',NULL,NULL),(3119,1944,'AP','5137231330',0,'2013-12-25 19:00:46',NULL,NULL),(33481,21941,'AP','9567560758',0,'2014-02-07 19:00:15',NULL,NULL),(36955,24336,'AP','2104458438',0,'2014-02-18 22:00:16',NULL,NULL),(29896,19347,'TE','3305736946',1,'2014-01-22 03:22:24',NULL,NULL),(5801,3724,'EM','karenjacob1407@gmail.com',0,'2013-12-25 21:32:26',NULL,NULL),(29296,18929,'AP','4129928286',0,'2014-01-20 08:05:37',NULL,NULL),(2126,1310,'EM','drwillbashor@gmail.com',0,'2013-12-25 18:31:27',NULL,NULL),(8145,5330,'TE','9388903800',0,'2013-12-25 23:07:05',NULL,NULL),(4482,2851,'EM','hh69bb@gmail.com',0,'2013-12-25 20:01:23',NULL,NULL),(37498,24690,'AP','9567401351',0,'2014-02-20 04:32:30',NULL,NULL),(14010,9148,'TE','3305711389',0,'2013-12-26 04:08:22',NULL,NULL),(6555,4235,'AP','2547158757',0,'2013-12-25 21:50:50',NULL,NULL),(29769,19249,'AP','6624030381',0,'2014-01-21 08:46:42',NULL,NULL),(22583,14565,'AP','8109418227',0,'2013-12-28 03:35:22',NULL,NULL),(5385,3446,'AP','4405069319',0,'2013-12-25 21:19:23',NULL,NULL),(34425,22582,'TE','9373947517',0,'2014-02-10 21:32:04',NULL,NULL),(37109,24431,'TE','3307143571',0,'2014-02-18 22:01:14',NULL,NULL),(40510,26885,'EM','mamacat8149@yahoo.com',0,'2014-03-01 21:01:12',NULL,NULL),(43820,29086,'TE','8328019430',0,'2014-03-10 21:02:07',NULL,NULL),(27922,17990,'TE','3306455756',0,'2014-01-15 02:06:56',NULL,NULL),(11447,7445,'TE','6057319547',0,'2013-12-26 02:30:33',NULL,NULL),(27805,17920,'TE','5125072976',0,'2014-01-15 02:06:31',NULL,NULL),(25841,16659,'TE','3185125805',0,'2014-01-08 18:24:24',NULL,NULL),(23881,15409,'AP','9402286573',1,'2014-01-02 04:27:04',NULL,NULL),(20960,13484,'EM','acoopersmith22@gmail.com',0,'2013-12-26 13:02:18',NULL,NULL),(21959,14144,'AP','9738518095',0,'2013-12-27 02:02:44',NULL,NULL),(42007,27921,'AP','8062817938',0,'2014-03-06 21:00:20',NULL,NULL),(42024,27932,'TE','2147973992',0,'2014-03-06 21:00:26',NULL,NULL),(9694,6349,'EM','KFRAZIER91@YMAIL.COM',0,'2013-12-26 00:47:00',NULL,NULL),(27410,17652,'TE','3307920455',0,'2014-01-14 01:32:41',NULL,NULL),(23949,15452,'TE','9566226847',1,'2014-01-02 04:28:25',NULL,NULL),(4136,2638,'AP','2165361993',0,'2013-12-25 19:46:17',NULL,NULL),(6697,4353,'EM','stunizny@aol.com',0,'2013-12-25 21:53:32',NULL,NULL),(5710,3664,'EM','ray@rayorf.com',0,'2013-12-25 21:30:59',NULL,NULL),(20269,13064,'AP','6147079353',0,'2013-12-26 12:51:08',NULL,NULL),(22367,14427,'TE','7132619103',0,'2013-12-28 03:31:49',NULL,NULL),(32005,20893,'AP','9546484000',0,'2014-01-31 21:01:16',NULL,NULL),(37124,24439,'AP','4195846774',0,'2014-02-18 22:01:18',NULL,NULL),(37852,24972,'AP','8327584106',0,'2014-02-20 22:00:27',NULL,NULL),(38680,25564,'AP','9364330289',0,'2014-02-26 08:00:25',NULL,NULL),(12141,7931,'TE','3372553087',0,'2013-12-26 03:06:38',NULL,NULL),(22666,14614,'AP','6014541875',0,'2013-12-28 03:36:45',NULL,NULL),(10266,6707,'TE','7344302945',0,'2013-12-26 01:02:06',NULL,NULL),(3475,2177,'AP','4197227269',0,'2013-12-25 19:19:17',NULL,NULL),(4741,3036,'TE','3306736072',0,'2013-12-25 20:18:32',NULL,NULL),(9373,6135,'AP','3378845779',0,'2013-12-26 00:16:07',NULL,NULL),(8618,5662,'TE','6143021666',0,'2013-12-25 23:31:48',NULL,NULL),(37983,25058,'EM','kcorne.oh@gmail.com',0,'2014-02-20 22:01:21',NULL,NULL),(38625,25529,'AP','2283663427',0,'2014-02-26 08:00:04',NULL,NULL),(41696,27726,'AP','7144965916',0,'2014-03-05 21:31:01',NULL,NULL),(42104,27975,'TE','5043882419',0,'2014-03-06 21:00:53',NULL,NULL),(42436,28184,'AP','3308011530',0,'2014-03-06 21:02:56',NULL,NULL),(43811,29082,'TE','6012126618',0,'2014-03-10 21:02:04',NULL,NULL),(30271,19613,'TE','9373923053',0,'2014-01-23 03:02:51',NULL,NULL),(4126,2631,'TE','5135428689',0,'2013-12-25 19:46:08',NULL,NULL),(5407,3460,'TE','4198418548',0,'2013-12-25 21:19:44',NULL,NULL),(8431,5548,'EM','BBOBBERTO@YAHOO.COM',0,'2013-12-25 23:16:03',NULL,NULL),(3963,2515,'AP','6017165032',0,'2013-12-25 19:36:26',NULL,NULL),(34062,22332,'TE','9158772827',0,'2014-02-10 11:01:02',NULL,NULL),(35420,23285,'EM','gitieubao@gmail.com',0,'2014-02-13 21:30:18',NULL,NULL),(37322,24559,'AP','4199577465',0,'2014-02-20 04:06:11',NULL,NULL),(37594,24769,'TE','5137312560',0,'2014-02-20 04:44:12',NULL,NULL),(37984,25059,'TE','5138344078',0,'2014-02-20 22:01:22',NULL,NULL),(38128,25167,'AP','2165264746',0,'2014-02-21 22:00:25',NULL,NULL),(39683,26238,'TE','5129706493',0,'2014-02-28 06:31:04',NULL,NULL),(42414,28169,'TE','3379626667',0,'2014-03-06 21:02:47',NULL,NULL),(43186,28697,'AP','5043209447',0,'2014-03-08 21:31:07',NULL,NULL),(30868,20063,'EM','OZURY30@HOTMAIL.COM',0,'2014-01-27 21:00:13',NULL,NULL),(25122,16194,'AP','9037071568',0,'2014-01-05 00:00:57',NULL,NULL),(24257,15675,'AP','4193414773',1,'2014-01-02 04:34:49',NULL,NULL),(9338,6114,'AP','3307805171',0,'2013-12-26 00:15:33',NULL,NULL),(9118,5973,'EM','fordmanmax@yahoo.com',0,'2013-12-25 23:51:43',NULL,NULL),(37045,24395,'AP','4196061115',0,'2014-02-18 22:00:51',NULL,NULL),(37350,24590,'AP','3305502750',0,'2014-02-20 04:10:32',NULL,NULL),(26575,17097,'TE','4326848040',0,'2014-01-13 02:21:30',NULL,NULL),(4385,2795,'EM','iansenator@aol.com',0,'2013-12-25 19:50:15',NULL,NULL),(8120,5317,'TE','6142742091',0,'2013-12-25 23:06:44',NULL,NULL),(6491,4200,'TE','9404528456',0,'2013-12-25 21:49:52',NULL,NULL),(4918,3158,'EM','marybrackmann@yahoo.com',0,'2013-12-25 20:31:14',NULL,NULL),(33053,21652,'EM','pmbenit@yahoo.com',0,'2014-02-05 21:30:50',NULL,NULL),(34556,22663,'AP','3616481038',0,'2014-02-11 21:00:36',NULL,NULL),(36954,24336,'TE','2104458438',0,'2014-02-18 22:00:16',NULL,NULL),(14304,9355,'AP','4093927747',0,'2013-12-26 04:31:22',NULL,NULL),(31231,20340,'TE','9856418308',0,'2014-01-28 21:01:07',NULL,NULL),(6803,4414,'TE','5134516490',0,'2013-12-25 22:01:27',NULL,NULL),(26249,16893,'EM','AMALDONADO1107@YAHOO.COM',0,'2014-01-13 02:19:28',NULL,NULL),(24992,16107,'AP','6014413482',0,'2014-01-04 02:04:58',NULL,NULL),(9280,6075,'EM','kenmoyjr34@yahoo.com',0,'2013-12-26 00:02:19',NULL,NULL),(10619,6908,'AP','5049524825',0,'2013-12-26 01:45:51',NULL,NULL),(4281,2735,'TE','4145304295',0,'2013-12-25 19:48:37',NULL,NULL),(39928,26422,'EM','emolina2k@aol.com',0,'2014-02-28 07:30:09',NULL,NULL),(6689,4348,'AP','4193050824',0,'2013-12-25 21:53:23',NULL,NULL),(3163,1978,'AP','8176816774',0,'2013-12-25 19:01:39',NULL,NULL),(12415,8133,'TE','6149898259',0,'2013-12-26 03:15:35',NULL,NULL),(24800,16000,'TE','9792555310',0,'2014-01-04 02:01:29',NULL,NULL),(29518,19081,'BN','5136091303',0,'2014-01-21 08:44:26',NULL,NULL),(29031,18743,'EM','gramoon4@gmail.com',0,'2014-01-17 03:35:41',NULL,NULL),(35052,23018,'TE','3378877107',0,'2014-02-12 21:30:28',NULL,NULL),(37399,24628,'AP','2257177758',0,'2014-02-20 04:17:35',NULL,NULL),(43154,28681,'TE','3306594028',0,'2014-03-08 21:30:56',NULL,NULL),(43672,28983,'TE','3303424511',0,'2014-03-10 21:01:10',NULL,NULL),(43739,29035,'EM','JACKSONDENITA34@YAHOO.COM',0,'2014-03-10 21:01:38',NULL,NULL),(8241,5390,'EM','msdianaklein@hotmail.com',0,'2013-12-25 23:08:39',NULL,NULL),(25227,16265,'EM','eawoquendo@yahoo.com',0,'2014-01-07 04:00:08',NULL,NULL),(10300,6721,'AP','5133159980',0,'2013-12-26 01:15:13',NULL,NULL),(8607,5654,'AP','9035396279',0,'2013-12-25 23:31:36',NULL,NULL),(1698,1043,'AP','3252624455',0,'2013-12-25 18:15:50',NULL,NULL),(1759,1085,'AP','4405202807',0,'2013-12-25 18:16:53',NULL,NULL),(6868,4456,'TE','4409332433',0,'2013-12-25 22:02:31',NULL,NULL),(20816,13377,'EM','MJAKUPCA@GMAIL.COM',0,'2013-12-26 12:59:52',NULL,NULL),(32148,20997,'TE','5137599891',0,'2014-02-01 19:00:27',NULL,NULL),(33882,22237,'EM','shirleyhking@aol.com',0,'2014-02-09 19:00:36',NULL,NULL),(24368,15735,'TE','9378905998',0,'2014-01-03 02:00:39',NULL,NULL),(22424,14460,'TE','5044521102',0,'2013-12-28 03:32:45',NULL,NULL),(13541,8829,'EM','yolimgarza@yahoo.com',0,'2013-12-26 04:00:29',NULL,NULL),(11644,7574,'EM','zjgin@bright.net',0,'2013-12-26 02:33:49',NULL,NULL),(4356,2778,'EM','jdshults@netzero.net',0,'2013-12-25 19:49:46',NULL,NULL),(4940,3172,'EM','bill@truthbenefit.us',0,'2013-12-25 20:31:35',NULL,NULL),(4041,2580,'TE','9372188423',0,'2013-12-25 19:37:58',NULL,NULL),(34290,22496,'TE','3308980119',0,'2014-02-10 21:31:11',NULL,NULL),(36649,24126,'AP','3183326369',0,'2014-02-15 22:01:45',NULL,NULL),(38952,25754,'TE','4199751737',0,'2014-02-26 09:30:47',NULL,NULL),(41236,27388,'TE','5134602289',0,'2014-03-04 21:01:26',NULL,NULL),(43176,28691,'AP','3308822702',0,'2014-03-08 21:31:03',NULL,NULL),(23550,15201,'EM','kspitalo@att.net',0,'2014-01-01 12:07:25',NULL,NULL),(7610,4956,'TE','2256755550',0,'2013-12-25 22:46:04',NULL,NULL),(9196,6019,'TE','4408620050',0,'2013-12-26 00:00:48',NULL,NULL),(30914,20101,'TE','3189254451',0,'2014-01-27 21:00:35',NULL,NULL),(35357,23230,'EM','songbird2187@aol.com',0,'2014-02-12 21:32:25',NULL,NULL),(35603,23414,'TE','3259397426',0,'2014-02-13 22:01:18',NULL,NULL),(10292,6718,'TE','3307220068',0,'2013-12-26 01:15:07',NULL,NULL),(9509,6225,'TE','4197730331',0,'2013-12-26 00:31:16',NULL,NULL),(26573,17095,'TE','9566079550',0,'2014-01-13 02:21:29',NULL,NULL),(2938,1806,'EM','mosier4640@msn.com',0,'2013-12-25 18:56:55',NULL,NULL),(20418,13146,'AP','2167856465',0,'2013-12-26 12:53:29',NULL,NULL),(29286,18918,'TE','3303175363',0,'2014-01-17 03:36:42',NULL,NULL),(34445,22597,'AP','4194600964',0,'2014-02-10 21:32:13',NULL,NULL),(36734,24185,'EM','farrbonnie80@gmail.com',0,'2014-02-16 19:00:10',NULL,NULL),(40145,26625,'EM','lily4511@hotmail.com',0,'2014-02-28 21:30:54',NULL,NULL),(79,48,'TE','2673034299',0,'2013-12-25 17:16:18',NULL,NULL),(10459,6814,'TE','3304142197',0,'2013-12-26 01:30:24',NULL,NULL),(12068,7878,'AP','5136084001',0,'2013-12-26 03:05:22',NULL,NULL),(2828,1709,'EM','shannon@ultraparty.com',0,'2013-12-25 18:54:59',NULL,NULL),(3199,2010,'AP','5044536930',0,'2013-12-25 19:02:28',NULL,NULL),(31917,20834,'TE','4402288031',0,'2014-01-31 21:00:43',NULL,NULL),(31946,20852,'TE','6148932839',0,'2014-01-31 21:00:53',NULL,NULL),(33768,22160,'AP','5133791739',0,'2014-02-08 19:00:58',NULL,NULL),(37476,24677,'EM','shellymavrick@hotmail.com',0,'2014-02-20 04:29:32',NULL,NULL),(40134,26619,'TE','9035699025',0,'2014-02-28 21:30:51',NULL,NULL),(3318,2088,'TE','2256108905',0,'2013-12-25 19:16:48',NULL,NULL),(10238,6694,'AP','9402299283',0,'2013-12-26 01:01:41',NULL,NULL),(22463,14486,'AP','4094895605',0,'2013-12-28 03:33:24',NULL,NULL),(14797,9685,'AP','5133140552',0,'2013-12-26 04:39:33',NULL,NULL),(31405,20472,'AP','5133132847',0,'2014-01-29 21:00:56',NULL,NULL),(32220,21043,'AP','9362399052',0,'2014-02-01 19:00:51',NULL,NULL),(38865,25688,'TE','6018136314',0,'2014-02-26 09:30:10',NULL,NULL),(38917,25727,'AP','3183814086',0,'2014-02-26 09:30:33',NULL,NULL),(42155,28004,'EM','anadenunzio@gmail.com',0,'2014-03-06 21:01:11',NULL,NULL),(3665,2326,'EM','sheri_p@live.com',0,'2013-12-25 19:31:33',NULL,NULL),(21946,14137,'TE','5042640529',0,'2013-12-27 02:02:34',NULL,NULL),(10816,7025,'EM','oscar.orias86@gmail.com',0,'2013-12-26 01:48:58',NULL,NULL),(11104,7211,'EM','Judisullivan@woh.rr.com',0,'2013-12-26 02:00:57',NULL,NULL),(24959,16085,'EM','bnehrko@gmail.com',0,'2014-01-04 02:04:16',NULL,NULL),(20451,13174,'TE','3309622924',0,'2013-12-26 12:54:08',NULL,NULL),(35262,23158,'TE','2813189377',0,'2014-02-12 21:31:46',NULL,NULL),(41254,27410,'BN','4403172468',0,'2014-03-04 21:01:35',NULL,NULL),(9430,6172,'AP','5127969236',0,'2013-12-26 00:17:05',NULL,NULL),(644,400,'AP','2146827386',0,'2013-12-25 17:46:09',NULL,NULL),(3768,2390,'AP','9376235094',0,'2013-12-25 19:33:16',NULL,NULL),(29390,18993,'EM','BRETT_PODOLL@YAHOO.COM',0,'2014-01-20 08:06:12',NULL,NULL),(7040,4598,'TE','3307989489',0,'2013-12-25 22:05:38',NULL,NULL),(26245,16892,'TE','8177162578',0,'2014-01-13 02:19:28',NULL,NULL),(14364,9389,'AP','8064072177',0,'2013-12-26 04:32:18',NULL,NULL),(25578,16499,'EM','mav283236@yahoo.com',0,'2014-01-07 04:06:48',NULL,NULL),(30989,20159,'TE','3302409576',0,'2014-01-27 21:01:08',NULL,NULL),(35264,23158,'EM','F_COHEN_2005@YAHOO.COM',0,'2014-02-12 21:31:46',NULL,NULL),(37106,24428,'EM','skelly1745@windstream.net',0,'2014-02-18 22:01:12',NULL,NULL),(40217,26675,'AP','2253240638',0,'2014-02-28 21:31:20',NULL,NULL),(40754,27083,'AP','3306344893',0,'2014-03-03 21:30:12',NULL,NULL),(5169,3318,'AP','5137031154',0,'2013-12-25 21:16:00',NULL,NULL),(9676,6340,'EM','debdebbyg@aol.com',0,'2013-12-26 00:46:45',NULL,NULL),(8427,5546,'AP','3306085540',0,'2013-12-25 23:15:59',NULL,NULL),(21439,13782,'TE','6018260424',0,'2013-12-26 13:10:47',NULL,NULL),(22919,14788,'EM','thereselitt@yahoo.com',1,'2013-12-29 11:13:26',NULL,NULL),(29024,18738,'EM','brianduckro@gmail.com',0,'2014-01-17 03:35:39',NULL,NULL),(25147,16209,'AP','9036177965',0,'2014-01-05 00:01:25',NULL,NULL),(7514,4897,'TE','5137041770',0,'2013-12-25 22:31:43',NULL,NULL),(28805,18590,'EM','celinaflyguy@yahoo.com',0,'2014-01-16 08:47:13',NULL,NULL),(8415,5541,'AP','3309049797',0,'2013-12-25 23:15:49',NULL,NULL),(31386,20456,'EM','HABIBA.NABIL21@YAHOO.COM',0,'2014-01-29 21:00:48',NULL,NULL),(33271,21787,'TE','4407779146',0,'2014-02-06 21:00:41',NULL,NULL),(34579,22675,'TE','2542142151',0,'2014-02-11 21:00:44',NULL,NULL),(38246,25252,'TE','6627444365',0,'2014-02-21 22:01:14',NULL,NULL),(41115,27312,'EM','hussam_7889@yahoo.com',0,'2014-03-04 21:00:40',NULL,NULL),(41211,27371,'AP','6625153122',0,'2014-03-04 21:01:17',NULL,NULL),(41764,27770,'AP','5044944301',0,'2014-03-05 21:31:26',NULL,NULL),(42802,28463,'AP','3306711655',0,'2014-03-07 21:31:27',NULL,NULL),(43600,28947,'TE','9855174336',0,'2014-03-10 21:00:47',NULL,NULL),(11604,7548,'TE','9858049791',0,'2013-12-26 02:33:08',NULL,NULL),(26863,17287,'TE','8322928692',0,'2014-01-13 02:23:30',NULL,NULL),(10969,7128,'TE','5136737147',0,'2013-12-26 01:51:33',NULL,NULL),(26196,16861,'EM','broadwaynaomi@gmail.com',0,'2014-01-13 02:19:10',NULL,NULL),(26004,16753,'AP','2142269188',0,'2014-01-08 18:24:56',NULL,NULL),(25744,16591,'TE','9188999299',0,'2014-01-08 18:24:01',NULL,NULL),(21787,14038,'EM','carolhesser@aol.com',0,'2013-12-26 13:17:06',NULL,NULL),(23420,15086,'TE','2144178481',0,'2014-01-01 12:04:20',NULL,NULL),(31727,20705,'TE','3183683620',0,'2014-01-30 21:01:06',NULL,NULL),(39945,26439,'AP','4196061510',0,'2014-02-28 07:30:20',NULL,NULL),(41875,27844,'AP','9563138844',0,'2014-03-05 21:32:09',NULL,NULL),(26337,16953,'AP','6623476883',0,'2014-01-13 02:20:01',NULL,NULL),(12292,8039,'EM','jzeller51@hotmail.com',0,'2013-12-26 03:09:23',NULL,NULL),(6066,3904,'TE','4198623382',0,'2013-12-25 21:36:56',NULL,NULL),(23476,15140,'AP','5132524128',0,'2014-01-01 12:05:43',NULL,NULL),(14705,9622,'AP','4193490699',0,'2013-12-26 04:37:56',NULL,NULL),(8885,5821,'TE','4326382346',0,'2013-12-25 23:48:01',NULL,NULL),(4406,2807,'TE','5748504009',0,'2013-12-25 20:00:07',NULL,NULL),(32668,21366,'TE','2145794965',0,'2014-02-04 21:00:45',NULL,NULL),(35169,23100,'EM','dollalyse@aol.com',0,'2014-02-12 21:31:11',NULL,NULL),(26558,17082,'AP','8302632029',0,'2014-01-13 02:21:23',NULL,NULL),(21841,14069,'EM','wmarshall20@yahoo.com',0,'2013-12-27 02:00:48',NULL,NULL),(10291,6716,'EM','bf2@uakron.edu',0,'2013-12-26 01:15:04',NULL,NULL),(3180,1997,'TE','8176816774',0,'2013-12-25 19:02:06',NULL,NULL),(13792,8993,'TE','4197226932',0,'2013-12-26 04:04:37',NULL,NULL),(31131,20273,'EM','JBERTIERI@JUNO.COM',0,'2014-01-28 21:00:25',NULL,NULL),(31629,20631,'EM','CLAYPACATTE@GMAIL.COM',0,'2014-01-30 21:00:29',NULL,NULL),(31643,20644,'AP','7182000327',0,'2014-01-30 21:00:35',NULL,NULL),(33984,22294,'TE','5125145689',0,'2014-02-10 11:00:31',NULL,NULL),(41782,27778,'AP','3309030870',0,'2014-03-05 21:31:32',NULL,NULL),(5875,3768,'TE','3307931722',0,'2013-12-25 21:33:38',NULL,NULL),(28181,18165,'AP','9377284326',0,'2014-01-15 02:07:55',NULL,NULL),(10663,6930,'AP','2163235232',0,'2013-12-26 01:46:30',NULL,NULL),(9045,5933,'EM','margohkelly@gmail.com',0,'2013-12-25 23:50:35',NULL,NULL),(26199,16863,'TE','8705577123',0,'2014-01-13 02:19:11',NULL,NULL),(14482,9456,'EM','missjhood@yahoo.com',0,'2013-12-26 04:34:07',NULL,NULL),(23477,15141,'TE','2166780999',0,'2014-01-01 12:05:45',NULL,NULL),(25799,16626,'TE','9372344268',0,'2014-01-08 18:24:13',NULL,NULL),(42811,28469,'EM','humeixie@yahoo.com',0,'2014-03-07 21:31:31',NULL,NULL),(25001,16113,'TE','6623850101',0,'2014-01-04 02:05:09',NULL,NULL),(24157,15611,'TE','5675105527',1,'2014-01-02 04:32:50',NULL,NULL),(2096,1294,'AP','9282667521',0,'2013-12-25 18:30:58',NULL,NULL),(8313,5448,'TE','4197294445',0,'2013-12-25 23:10:06',NULL,NULL),(3615,2286,'TE','5132955085',0,'2013-12-25 19:30:39',NULL,NULL),(7695,5021,'TE','3184661655',0,'2013-12-25 22:47:33',NULL,NULL),(35113,23065,'TE','9856304711',0,'2014-02-12 21:30:53',NULL,NULL),(36382,23961,'AP','5129094575',0,'2014-02-15 22:00:10',NULL,NULL),(39734,26280,'AP','8322707444',0,'2014-02-28 06:31:19',NULL,NULL),(74,46,'AP','6013170148',0,'2013-12-25 17:16:14',NULL,NULL),(5549,3544,'TE','7138057997',0,'2013-12-25 21:21:54',NULL,NULL),(28089,18106,'TE','9852090741',0,'2014-01-15 02:07:35',NULL,NULL),(9763,6384,'EM','verevey16@yahoo.com',0,'2013-12-26 00:48:00',NULL,NULL),(2962,1833,'EM','c.dortch@att.net',0,'2013-12-25 18:57:29',NULL,NULL),(2386,1451,'EM','shannon@ultraparty.com',0,'2013-12-25 18:48:07',NULL,NULL),(9051,5936,'TE','5049135381',0,'2013-12-25 23:50:41',NULL,NULL),(14697,9618,'AP','5613191627',0,'2013-12-26 04:37:49',NULL,NULL),(20231,13033,'TE','2168326586',0,'2013-12-26 12:50:24',NULL,NULL),(26731,17193,'EM','benjamingullett@yahoo.com',0,'2014-01-13 02:22:19',NULL,NULL),(30982,20153,'BN','5132880018',0,'2014-01-27 21:01:05',NULL,NULL),(35274,23166,'TE','2542260749',0,'2014-02-12 21:31:50',NULL,NULL),(35928,23639,'TE','5126278299',0,'2014-02-14 21:30:07',NULL,NULL),(36022,23693,'EM','chays64@gmail.com',0,'2014-02-14 21:30:38',NULL,NULL),(36403,23976,'TE','4153502141',0,'2014-02-15 22:00:17',NULL,NULL),(38843,25678,'TE','4192301935',0,'2014-02-26 08:30:56',NULL,NULL),(897,556,'TE','9856647170',0,'2013-12-25 17:50:10',NULL,NULL),(1226,748,'AP','5122990219',0,'2013-12-25 18:04:12',NULL,NULL),(26316,16943,'TE','9856376811',0,'2014-01-13 02:19:55',NULL,NULL),(2559,1563,'TE','8173687755',0,'2013-12-25 18:50:58',NULL,NULL),(20462,13181,'EM','luckiebarry@yahoo.com',0,'2013-12-26 12:54:21',NULL,NULL),(20454,13179,'TE','2818275498',0,'2013-12-26 12:54:15',NULL,NULL),(5698,3659,'TE','5135038460',0,'2013-12-25 21:30:50',NULL,NULL),(32744,21421,'EM','nankopp@gmail.com',0,'2014-02-04 21:01:14',NULL,NULL),(9954,6513,'AP','3305729498',0,'2013-12-26 00:51:12',NULL,NULL),(20741,13331,'AP','7738496250',0,'2013-12-26 12:58:38',NULL,NULL),(701,434,'AP','4402511026',0,'2013-12-25 17:47:01',NULL,NULL),(9848,6440,'AP','5042587929',0,'2013-12-26 00:49:25',NULL,NULL),(31335,20419,'TE','5135433637',0,'2014-01-29 21:00:29',NULL,NULL),(31443,20495,'TE','7133922194',0,'2014-01-29 21:01:09',NULL,NULL),(31911,20830,'TE','5044443671',0,'2014-01-31 21:00:40',NULL,NULL),(37749,24908,'AP','5133148128',0,'2014-02-20 21:30:06',NULL,NULL),(38380,25353,'TE','5138290722',0,'2014-02-25 21:30:33',NULL,NULL),(41161,27337,'TE','5135509445',0,'2014-03-04 21:00:56',NULL,NULL),(43971,29170,'AP','5704197178',0,'2014-03-10 21:02:59',NULL,NULL),(29174,18851,'TE','3306964971',0,'2014-01-17 03:36:16',NULL,NULL),(26588,17106,'AP','9372174681',0,'2014-01-13 02:21:34',NULL,NULL),(4208,2689,'TE','3612186281',0,'2013-12-25 19:47:28',NULL,NULL),(34223,22446,'TE','8175623857',0,'2014-02-10 21:30:45',NULL,NULL),(34334,22526,'TE','9373795121',0,'2014-02-10 21:31:28',NULL,NULL),(34814,22835,'TE','4408453860',0,'2014-02-11 21:02:10',NULL,NULL),(38697,25573,'TE','4197333508',0,'2014-02-26 08:00:32',NULL,NULL),(39814,26329,'TE','6625797431',0,'2014-02-28 06:31:39',NULL,NULL),(42612,28349,'AP','3252453395',0,'2014-03-07 21:30:21',NULL,NULL),(7214,4701,'TE','2167013426',0,'2013-12-25 22:08:25',NULL,NULL),(28033,18066,'TE','9854744115',0,'2014-01-15 02:07:22',NULL,NULL),(24747,15967,'AP','4322100487',0,'2014-01-04 02:00:30',NULL,NULL),(3426,2149,'EM','williolacomme31@gmail.com',0,'2013-12-25 19:18:32',NULL,NULL),(24580,15854,'EM','huff.ronda@yahoo.com',0,'2014-01-03 02:04:32',NULL,NULL),(23661,15280,'AP','2168495076',1,'2014-01-02 04:22:05',NULL,NULL),(9652,6314,'TE','5132280753',0,'2013-12-26 00:46:16',NULL,NULL),(9480,6204,'AP','4197730331',0,'2013-12-26 00:30:42',NULL,NULL),(21299,13683,'EM','momamia2559@aol.com',0,'2013-12-26 13:08:15',NULL,NULL),(22386,14440,'AP','5044186689',0,'2013-12-28 03:32:10',NULL,NULL),(32473,21217,'TE','5048129425',0,'2014-02-03 21:01:02',NULL,NULL),(34379,22551,'TE','9379851580',0,'2014-02-10 21:31:45',NULL,NULL),(35235,23139,'EM','tomandpandy77@yahoo.com',0,'2014-02-12 21:31:35',NULL,NULL),(40495,26875,'EM','mikeytsai@icloud.com',0,'2014-03-01 21:01:06',NULL,NULL),(42569,28327,'TE','2147973992',0,'2014-03-07 21:30:08',NULL,NULL),(10598,6896,'AP','2253282842',0,'2013-12-26 01:45:31',NULL,NULL),(28422,18312,'AP','2165027174',0,'2014-01-16 08:45:03',NULL,NULL),(2800,1696,'AP','4198411758',0,'2013-12-25 18:54:34',NULL,NULL),(9414,6161,'AP','5137734297',0,'2013-12-26 00:16:48',NULL,NULL),(24369,15736,'TE','9378905998',0,'2014-01-03 02:00:40',NULL,NULL),(20955,13481,'TE','5136088540',0,'2013-12-26 13:02:13',NULL,NULL),(35575,23393,'EM','thollin89@hotmail.com',0,'2014-02-13 22:01:07',NULL,NULL),(39491,26120,'EM','SCIANELLI@HOTMAIL.COM',0,'2014-02-28 06:30:19',NULL,NULL),(41015,27252,'AP','4195741828',0,'2014-03-03 21:31:54',NULL,NULL),(41442,27532,'TE','6149610532',0,'2014-03-04 21:02:48',NULL,NULL),(42658,28380,'TE','2342009330',0,'2014-03-07 21:30:39',NULL,NULL),(12163,7945,'EM','gulfstate2001@yahoo.com',0,'2013-12-26 03:07:00',NULL,NULL),(5223,3356,'AP','9039752367',0,'2013-12-25 21:16:53',NULL,NULL),(27864,17955,'TE','5126737180',0,'2014-01-15 02:06:44',NULL,NULL),(23328,15031,'TE','5043905284',0,'2014-01-01 12:02:38',NULL,NULL),(27621,17806,'EM','jpr1414@hotmail.com',0,'2014-01-15 02:05:51',NULL,NULL),(31083,20233,'TE','6019241452',0,'2014-01-28 21:00:03',NULL,NULL),(33496,21951,'TE','3304883139',0,'2014-02-07 19:00:20',NULL,NULL),(34125,22374,'EM','hullfran@gmail.com',0,'2014-02-10 21:30:04',NULL,NULL),(43095,28649,'AP','6628125497',0,'2014-03-08 21:30:36',NULL,NULL),(14032,9166,'TE','4193025069',0,'2013-12-26 04:08:49',NULL,NULL),(26174,16851,'EM','staceyp1061@gmail.com',0,'2014-01-13 02:18:40',NULL,NULL),(4769,3053,'TE','2252099950',0,'2013-12-25 20:18:58',NULL,NULL),(1941,1200,'EM','gopens80@comcast.net',0,'2013-12-25 18:19:53',NULL,NULL),(36113,23766,'AP','3309363581',0,'2014-02-14 21:31:11',NULL,NULL),(38822,25665,'AP','3379367644',0,'2014-02-26 08:30:47',NULL,NULL),(13522,8818,'AP','9372133545',0,'2013-12-26 04:00:11',NULL,NULL),(8236,5388,'AP','5043444289',0,'2013-12-25 23:08:35',NULL,NULL),(11046,7172,'TE','4195317849',0,'2013-12-26 01:52:45',NULL,NULL),(29805,19281,'TE','9376630687',0,'2014-01-21 08:47:00',NULL,NULL),(10603,6901,'TE','2255906339',0,'2013-12-26 01:45:38',NULL,NULL),(29027,18742,'TE','4408656996',0,'2014-01-17 03:35:40',NULL,NULL),(4498,2861,'AP','5133782791',0,'2013-12-25 20:01:38',NULL,NULL),(31128,20272,'AP','7405680093',0,'2014-01-28 21:00:24',NULL,NULL),(33931,22267,'EM','aliyahya21@gmail.com',0,'2014-02-10 11:00:12',NULL,NULL),(35548,23376,'TE','7407960031',0,'2014-02-13 22:00:57',NULL,NULL),(35750,23511,'AP','2285634080',0,'2014-02-13 22:02:14',NULL,NULL),(36137,23782,'EM','cmoney2788@gmail.com',0,'2014-02-14 21:31:20',NULL,NULL),(36260,23863,'TE','5043432660',0,'2014-02-14 21:32:06',NULL,NULL),(38858,25684,'BN','9033120119',0,'2014-02-26 09:30:07',NULL,NULL),(29921,19365,'TE','3305736946',1,'2014-01-22 03:22:33',NULL,NULL),(25370,16360,'AP','5302499422',0,'2014-01-07 04:02:44',NULL,NULL),(23157,14928,'TE','4193566959',0,'2013-12-30 00:01:54',NULL,NULL),(11028,7158,'EM','forster43526@hotmail.com',0,'2013-12-26 01:52:23',NULL,NULL),(5519,3532,'TE','8306601016',0,'2013-12-25 21:21:31',NULL,NULL),(3549,2223,'TE','4196931824',0,'2013-12-25 19:20:35',NULL,NULL),(9490,6209,'AP','9727461748',0,'2013-12-26 00:30:50',NULL,NULL),(40869,27157,'TE','9375973099',0,'2014-03-03 21:30:56',NULL,NULL),(1151,707,'EM','jgreen5@uno.edu',0,'2013-12-25 18:03:05',NULL,NULL),(30464,19749,'BN','8179965170',0,'2014-01-23 21:01:17',NULL,NULL),(6914,4501,'EM','patrick.m.pryor@gmail.com',0,'2013-12-25 22:03:23',NULL,NULL),(26015,16760,'AP','3306082644',0,'2014-01-08 18:24:58',NULL,NULL),(25330,16334,'TE','2254543885',0,'2014-01-07 04:02:04',NULL,NULL),(2493,1529,'EM','stflakes@yahoo.com',0,'2013-12-25 18:49:59',NULL,NULL),(21578,13877,'TE','3307618446',0,'2013-12-26 13:13:13',NULL,NULL),(21179,13622,'EM','mattjordan3329@yahoo.com',0,'2013-12-26 13:05:54',NULL,NULL),(33224,21756,'TE','9032887163',0,'2014-02-06 21:00:23',NULL,NULL),(37857,24974,'TE','9364394303',0,'2014-02-20 22:00:29',NULL,NULL),(38002,25070,'TE','5133055805',0,'2014-02-20 22:01:30',NULL,NULL),(40033,26536,'EM','fayetyree85@yahoo.com',0,'2014-02-28 21:30:05',NULL,NULL),(30273,19614,'TE','3303961497',0,'2014-01-23 03:02:52',NULL,NULL),(424,258,'AP','9374082703',0,'2013-12-25 17:21:48',NULL,NULL),(29560,19102,'AP','3377390892',0,'2014-01-21 08:44:39',NULL,NULL),(10874,7060,'AP','6149755942',0,'2013-12-26 01:49:55',NULL,NULL),(24141,15586,'EM','jessie.maxfield@yahoo.com',1,'2014-01-02 04:32:20',NULL,NULL),(2200,1351,'EM','stuyvic_7276@yahoo.com',0,'2013-12-25 18:45:16',NULL,NULL),(437,272,'TE','6144391238',0,'2013-12-25 17:30:03',NULL,NULL),(13745,8957,'TE','5133109979',0,'2013-12-26 04:03:46',NULL,NULL),(22284,14363,'AP','5134047071',0,'2013-12-28 03:30:20',NULL,NULL),(31095,20241,'EM','vickifeazell@att.net',0,'2014-01-28 21:00:08',NULL,NULL),(32328,21118,'AP','8324125732',0,'2014-02-03 21:00:11',NULL,NULL),(33128,21699,'EM','glosharp@gmail.com',0,'2014-02-05 21:31:10',NULL,NULL),(34047,22324,'EM','JOEZABACK@GMAIL.COM',0,'2014-02-10 11:00:56',NULL,NULL),(36909,24307,'TE','9858578594',0,'2014-02-18 21:30:24',NULL,NULL),(41801,27788,'EM','elsewhere01@yahoo.com',0,'2014-03-05 21:31:39',NULL,NULL),(670,418,'TE','5138290069',0,'2013-12-25 17:46:34',NULL,NULL),(25549,16481,'TE','2162443341',0,'2014-01-07 04:06:17',NULL,NULL),(4549,2892,'EM','jaybbodzin@yahoo.com',0,'2013-12-25 20:15:13',NULL,NULL),(4527,2878,'TE','3612752210',0,'2013-12-25 20:02:09',NULL,NULL),(22830,14726,'TE','3182004135',1,'2013-12-29 11:09:41',NULL,NULL),(8674,5694,'EM','mharris2511@sbcglobal.net',0,'2013-12-25 23:32:43',NULL,NULL),(22781,14691,'TE','2162963753',1,'2013-12-29 11:08:48',NULL,NULL),(8039,5260,'AP','3304728307',0,'2013-12-25 23:05:21',NULL,NULL),(31261,20365,'EM','tvsteve2@yahoo.com',0,'2014-01-28 21:01:23',NULL,NULL),(34213,22437,'EM','m.smith2585@my.texarkanacollege.edu',0,'2014-02-10 21:30:40',NULL,NULL),(37331,24575,'TE','6142183307',0,'2014-02-20 04:07:59',NULL,NULL),(39319,26008,'AP','9123084597',0,'2014-02-26 21:02:08',NULL,NULL),(22185,14291,'EM','NEWMOONSRISING@YAHOO.COM',0,'2013-12-27 02:06:35',NULL,NULL),(6016,3862,'EM','bbutler3200@yahoo.com',0,'2013-12-25 21:35:59',NULL,NULL),(2125,1310,'AP','6147497701',0,'2013-12-25 18:31:27',NULL,NULL),(2376,1444,'TE','9377634922',0,'2013-12-25 18:47:55',NULL,NULL),(10327,6735,'TE','5137874168',0,'2013-12-26 01:15:36',NULL,NULL),(10226,6683,'TE','2166514730',0,'2013-12-26 01:01:27',NULL,NULL),(31136,20280,'TE','4195610760',0,'2014-01-28 21:00:29',NULL,NULL),(31248,20353,'TE','4194673594',0,'2014-01-28 21:01:16',NULL,NULL),(32112,20969,'EM','deleon0711@hotmail.com',0,'2014-02-01 19:00:14',NULL,NULL),(40461,26859,'AP','9372170522',0,'2014-03-01 21:00:55',NULL,NULL),(5568,3557,'TE','3304681458',0,'2013-12-25 21:22:12',NULL,NULL),(24920,16064,'TE','5132388370',0,'2014-01-04 02:03:37',NULL,NULL),(8704,5711,'TE','9523348795',0,'2013-12-25 23:45:09',NULL,NULL),(22022,14183,'TE','9034723275',0,'2013-12-27 02:03:46',NULL,NULL),(2661,1615,'EM','dlight2020@gmail.com',0,'2013-12-25 18:52:26',NULL,NULL),(6645,4305,'EM','cdfennimo@yahoo.com',0,'2013-12-25 21:52:28',NULL,NULL),(31060,20207,'AP','2282977310',0,'2014-01-27 21:01:36',NULL,NULL),(31404,20472,'TE','5133132847',0,'2014-01-29 21:00:56',NULL,NULL),(33285,21796,'TE','9374501485',0,'2014-02-06 21:00:47',NULL,NULL),(38683,25565,'EM','rogerdingee@yahoo.com',0,'2014-02-26 08:00:26',NULL,NULL),(41789,27782,'TE','7814191690',0,'2014-03-05 21:31:34',NULL,NULL),(27970,18031,'EM','bethkilbane@yahoo.com',0,'2014-01-15 02:07:08',NULL,NULL),(26790,17234,'AP','6017200637',0,'2014-01-13 02:22:41',NULL,NULL),(22353,14415,'AP','8322628076',0,'2013-12-28 03:31:34',NULL,NULL),(13959,9100,'TE','5135532371',0,'2013-12-26 04:07:21',NULL,NULL),(33400,21886,'TE','5132604781',0,'2014-02-06 21:01:34',NULL,NULL),(36238,23850,'AP','9193444197',0,'2014-02-14 21:31:58',NULL,NULL),(39922,26418,'EM','NFISHERFLORES@SBCGLOBAL.NET',0,'2014-02-28 07:30:06',NULL,NULL),(40425,26836,'AP','2165260187',0,'2014-03-01 21:00:42',NULL,NULL),(26838,17264,'EM','rita@concept4ins.com',0,'2014-01-13 02:23:19',NULL,NULL),(9837,6435,'AP','5049092396',0,'2013-12-26 00:49:17',NULL,NULL),(13558,8840,'EM','Ktran2k9@yahoo.com',0,'2013-12-26 04:00:44',NULL,NULL),(23820,15368,'AP','9372697678',1,'2014-01-02 04:25:00',NULL,NULL),(23183,14942,'TE','2169055041',0,'2013-12-30 00:02:21',NULL,NULL),(30543,19814,'TE','7139040919',0,'2014-01-24 21:00:11',NULL,NULL),(35031,23007,'TE','5044441523',0,'2014-02-12 21:30:21',NULL,NULL),(28410,18305,'TE','4404618715',0,'2014-01-16 08:44:59',NULL,NULL),(14347,9379,'TE','5042312335',0,'2013-12-26 04:32:02',NULL,NULL),(7293,4750,'TE','9152522924',0,'2013-12-25 22:15:10',NULL,NULL),(4559,2900,'AP','3303883414',0,'2013-12-25 20:15:21',NULL,NULL),(28808,18595,'AP','5137021536',0,'2014-01-16 08:47:15',NULL,NULL),(28874,18643,'BN','5125679389',0,'2014-01-17 03:35:07',NULL,NULL),(31282,20380,'TE','5128917173',0,'2014-01-29 21:00:10',NULL,NULL),(32899,21536,'EM','sales@positivecreations.com',0,'2014-02-05 21:30:08',NULL,NULL),(36028,23697,'TE','6143231608',0,'2014-02-14 21:30:40',NULL,NULL),(36576,24074,'AP','3308078321',0,'2014-02-15 22:01:19',NULL,NULL),(39121,25878,'TE','5043397070',0,'2014-02-26 21:00:56',NULL,NULL),(41024,27256,'EM','tmetalman@yahoo.com',0,'2014-03-03 21:31:57',NULL,NULL),(3281,2063,'AP','5675256382',0,'2013-12-25 19:16:10',NULL,NULL),(5031,3226,'AP','5134466613',0,'2013-12-25 20:45:55',NULL,NULL),(32588,21307,'EM','Katinajbankston73@yahoo.com',0,'2014-02-04 21:00:15',NULL,NULL),(412,253,'TE','2257697256',0,'2013-12-25 17:21:37',NULL,NULL),(23388,15064,'TE','2256427974',0,'2014-01-01 12:03:41',NULL,NULL),(30065,19474,'AP','2817038843',0,'2014-01-23 03:02:01',NULL,NULL),(31257,20361,'AP','4199660301',0,'2014-01-28 21:01:20',NULL,NULL),(41620,27668,'EM','Nursecowell@gmail.com',0,'2014-03-05 21:30:32',NULL,NULL),(42981,28585,'TE','7406449664',0,'2014-03-08 21:30:00',NULL,NULL),(25738,16588,'TE','9856346280',0,'2014-01-08 18:24:00',NULL,NULL),(3868,2459,'AP','8173717538',0,'2013-12-25 19:34:53',NULL,NULL),(3356,2111,'TE','7405164681',0,'2013-12-25 19:17:26',NULL,NULL),(24893,16048,'TE','2146161531',0,'2014-01-04 02:03:06',NULL,NULL),(7211,4698,'AP','9373081184',0,'2013-12-25 22:08:22',NULL,NULL),(7415,4821,'TE','3306664212',0,'2013-12-25 22:17:06',NULL,NULL),(23891,15414,'AP','9035781291',1,'2014-01-02 04:27:14',NULL,NULL),(11171,7266,'EM','patti.orr@sbcglobal.net',0,'2013-12-26 02:02:17',NULL,NULL),(37780,24934,'TE','7083743567',0,'2014-02-20 21:30:21',NULL,NULL),(39355,26030,'TE','6019278318',0,'2014-02-26 21:02:21',NULL,NULL),(40673,27005,'AP','8186358958',0,'2014-03-03 21:00:04',NULL,NULL),(42985,28590,'TE','3305752522',0,'2014-03-08 21:30:01',NULL,NULL),(28904,18659,'EM','rm61307@gmail.com',0,'2014-01-17 03:35:13',NULL,NULL),(11929,7771,'AP','9409234361',0,'2013-12-26 03:02:55',NULL,NULL),(24734,15957,'TE','5134763644',0,'2014-01-04 02:00:16',NULL,NULL),(22458,14483,'EM','d.annlkg@live.com',0,'2013-12-28 03:33:19',NULL,NULL),(3000,1855,'EM','nankopp@gmail.com',0,'2013-12-25 18:58:02',NULL,NULL),(31495,20523,'AP','2819101652',0,'2014-01-29 21:01:26',NULL,NULL),(33119,21695,'TE','3307338298',0,'2014-02-05 21:31:08',NULL,NULL),(36096,23741,'TE','5136813739',0,'2014-02-14 21:31:04',NULL,NULL),(39750,26288,'TE','3185149066',0,'2014-02-28 06:31:23',NULL,NULL),(40641,26974,'AP','3307807089',0,'2014-03-03 01:00:36',NULL,NULL),(40689,27020,'AP','6149059232',0,'2014-03-03 21:00:12',NULL,NULL),(22551,14545,'AP','6015635184',0,'2013-12-28 03:34:52',NULL,NULL),(14289,9347,'EM','doreenja@bellsouth.net',0,'2013-12-26 04:31:10',NULL,NULL),(2572,1569,'EM','CHRIS103157@GMAIL.COM',0,'2013-12-25 18:51:09',NULL,NULL),(1378,841,'TE','9374504070',0,'2013-12-25 18:06:38',NULL,NULL),(9381,6141,'TE','6142037527',0,'2013-12-26 00:16:16',NULL,NULL),(29427,19025,'EM','acedding@go.olemiss.edu',0,'2014-01-20 08:06:28',NULL,NULL),(31953,20866,'AP','4194644937',0,'2014-01-31 21:00:58',NULL,NULL),(37985,25059,'AP','5138344078',0,'2014-02-20 22:01:22',NULL,NULL),(42200,28033,'TE','9373607772',0,'2014-03-06 21:01:28',NULL,NULL),(42547,28312,'TE','7403523714',0,'2014-03-07 21:00:36',NULL,NULL),(43250,28739,'AP','5044525409',0,'2014-03-09 21:00:08',NULL,NULL),(20449,13174,'TE','3309622924',0,'2013-12-26 12:54:07',NULL,NULL),(5333,3417,'AP','3188379219',0,'2013-12-25 21:18:33',NULL,NULL),(14898,9748,'AP','9853796664',0,'2013-12-26 04:46:09',NULL,NULL),(8575,5638,'TE','8068936526',0,'2013-12-25 23:31:09',NULL,NULL),(8628,5667,'AP','3303544265',0,'2013-12-25 23:31:57',NULL,NULL),(7238,4713,'AP','4193480854',0,'2013-12-25 22:08:47',NULL,NULL),(30965,20141,'AP','5133620623',0,'2014-01-27 21:00:58',NULL,NULL),(32994,21608,'TE','5138257261',0,'2014-02-05 21:30:33',NULL,NULL),(34726,22771,'AP','9373041534',0,'2014-02-11 21:01:38',NULL,NULL),(37942,25034,'TE','3183871074',0,'2014-02-20 22:01:05',NULL,NULL),(42566,28323,'TE','9406415068',0,'2014-03-07 21:30:06',NULL,NULL),(24924,16065,'AP','9374141191',0,'2014-01-04 02:03:40',NULL,NULL),(14834,9710,'AP','9175753508',0,'2013-12-26 04:45:09',NULL,NULL),(4902,3147,'TE','8309979418',0,'2013-12-25 20:30:57',NULL,NULL),(10422,6795,'AP','3308062764',0,'2013-12-26 01:17:12',NULL,NULL),(32966,21581,'TE','3309838932',0,'2014-02-05 21:30:25',NULL,NULL),(35085,23042,'AP','2143922898',0,'2014-02-12 21:30:41',NULL,NULL),(40299,26733,'EM','debra_kraft@ymail.com',0,'2014-02-28 21:31:50',NULL,NULL),(40410,26824,'EM','chepkemboilynn@yahoo.com',0,'2014-03-01 21:00:36',NULL,NULL),(40887,27167,'TE','9406920372',0,'2014-03-03 21:31:03',NULL,NULL),(11942,7777,'TE','9362549084',0,'2013-12-26 03:03:06',NULL,NULL),(10715,6968,'TE','2167527724',0,'2013-12-26 01:47:24',NULL,NULL),(27878,17965,'TE','3309459502',0,'2014-01-15 02:06:47',NULL,NULL),(21284,13675,'AP','6025026262',0,'2013-12-26 13:08:02',NULL,NULL),(7663,4989,'TE','5132232603',0,'2013-12-25 22:46:55',NULL,NULL),(880,546,'EM','R_Compton43@hotmail.com',0,'2013-12-25 17:49:53',NULL,NULL),(8108,5307,'AP','6628098897',0,'2013-12-25 23:06:29',NULL,NULL),(41178,27348,'TE','7408169181',0,'2014-03-04 21:01:03',NULL,NULL),(43822,29086,'EM','gmaculo@gmail.com',0,'2014-03-10 21:02:07',NULL,NULL),(6713,4363,'EM','meier88@embarqmail.com',0,'2013-12-25 22:00:06',NULL,NULL),(912,563,'TE','4194475447',0,'2013-12-25 17:50:23',NULL,NULL),(21910,14115,'AP','4407257882',0,'2013-12-27 02:01:58',NULL,NULL),(21442,13783,'EM','cajunlady83169@yahoo.com',0,'2013-12-26 13:10:49',NULL,NULL),(2131,1313,'TE','4198499312',0,'2013-12-25 18:31:32',NULL,NULL),(6217,4009,'TE','5132381059',0,'2013-12-25 21:45:22',NULL,NULL),(34071,22335,'EM','rongconley@gmail.com',0,'2014-02-10 11:01:04',NULL,NULL),(36745,24191,'TE','9375873813',0,'2014-02-16 19:00:14',NULL,NULL),(36775,24214,'AP','5127888598',0,'2014-02-16 19:00:25',NULL,NULL),(6433,4155,'AP','2163147791',0,'2013-12-25 21:48:53',NULL,NULL),(26909,17310,'AP','9032638071',0,'2014-01-13 02:23:44',NULL,NULL),(26786,17231,'EM','Tplus5@juno.com',0,'2014-01-13 02:22:40',NULL,NULL),(26447,17021,'AP','3306102063',0,'2014-01-13 02:20:40',NULL,NULL),(22278,14357,'EM','danielczaplicki@me.com',0,'2013-12-28 03:30:12',NULL,NULL),(23194,14949,'TE','5123505357',0,'2014-01-01 12:00:07',NULL,NULL),(23533,15186,'AP','4194181023',0,'2014-01-01 12:06:58',NULL,NULL),(32168,21014,'TE','7405009087',0,'2014-02-01 19:00:35',NULL,NULL),(32523,21262,'TE','6627197214',0,'2014-02-03 21:01:24',NULL,NULL),(33578,22013,'EM','anic8716@gmail.com',0,'2014-02-07 19:00:53',NULL,NULL),(34051,22326,'TE','9855079757',0,'2014-02-10 11:00:57',NULL,NULL),(36541,24060,'EM','debcherry51@live.com',0,'2014-02-15 22:01:08',NULL,NULL),(9137,5985,'TE','4194385267',0,'2013-12-25 23:52:02',NULL,NULL),(5776,3699,'AP','5135430718',0,'2013-12-25 21:31:57',NULL,NULL),(4280,2735,'AP','4145304295',0,'2013-12-25 19:48:36',NULL,NULL),(28180,18165,'TE','9377284326',0,'2014-01-15 02:07:55',NULL,NULL),(24167,15617,'TE','6012141387',1,'2014-01-02 04:33:00',NULL,NULL),(1276,775,'TE','5129638761',0,'2013-12-25 18:04:56',NULL,NULL),(14119,9235,'TE','9377882154',0,'2013-12-26 04:10:33',NULL,NULL),(22744,14668,'EM','shannynt@msn.com',1,'2013-12-29 11:08:10',NULL,NULL),(33951,22277,'EM','j_full01@yahoo.com',0,'2014-02-10 11:00:19',NULL,NULL),(28289,18236,'AP','9035705560',0,'2014-01-16 08:44:22',NULL,NULL),(27930,17994,'AP','5138462037',0,'2014-01-15 02:06:58',NULL,NULL),(8773,5750,'TE','3374744696',0,'2013-12-25 23:46:11',NULL,NULL),(14225,9307,'TE','9857487017',0,'2013-12-26 04:30:09',NULL,NULL),(32346,21132,'TE','9797981336',0,'2014-02-03 21:00:19',NULL,NULL),(35627,23426,'TE','4326147331',0,'2014-02-13 22:01:25',NULL,NULL),(38357,25337,'TE','5049121771',0,'2014-02-25 21:30:22',NULL,NULL),(41111,27309,'AP','9033944428',0,'2014-03-04 21:00:38',NULL,NULL),(9640,6309,'TE','5672258106',0,'2013-12-26 00:46:06',NULL,NULL),(9129,5977,'EM','lflowe@gmail.com',0,'2013-12-25 23:51:51',NULL,NULL),(25389,16375,'EM','nancy.rangel75@gmail.com',0,'2014-01-07 04:03:08',NULL,NULL),(2954,1820,'AP','4198196762',0,'2013-12-25 18:57:15',NULL,NULL),(14664,9593,'AP','3306878328',0,'2013-12-26 04:37:13',NULL,NULL),(30940,20119,'TE','6143711786',0,'2014-01-27 21:00:45',NULL,NULL),(31348,20427,'AP','5132900594',0,'2014-01-29 21:00:33',NULL,NULL),(29049,18756,'AP','8322358299',0,'2014-01-17 03:35:45',NULL,NULL),(11926,7767,'EM','cindrei@aol.com',0,'2013-12-26 03:02:51',NULL,NULL),(422,257,'TE','4192221687',0,'2013-12-25 17:21:46',NULL,NULL),(26517,17062,'TE','8055588059',0,'2014-01-13 02:21:12',NULL,NULL),(14483,9457,'TE','5138363065',0,'2013-12-26 04:34:09',NULL,NULL),(32641,21347,'EM','bonniemunroe@me.com',0,'2014-02-04 21:00:36',NULL,NULL),(34361,22538,'AP','6018626183',0,'2014-02-10 21:31:37',NULL,NULL),(34907,22905,'TE','4198368806',0,'2014-02-11 21:02:44',NULL,NULL),(24159,15613,'TE','6145716822',1,'2014-01-02 04:32:53',NULL,NULL),(22164,14275,'AP','6015025961',0,'2013-12-27 02:06:12',NULL,NULL),(5949,3818,'AP','7408568369',0,'2013-12-25 21:34:53',NULL,NULL),(1205,733,'TE','9154797866',0,'2013-12-25 18:03:52',NULL,NULL),(32078,20950,'TE','9036543712',0,'2014-02-01 19:00:04',NULL,NULL),(32583,21303,'AP','3372581443',0,'2014-02-04 21:00:13',NULL,NULL),(33150,21714,'TE','5675252804',0,'2014-02-05 21:31:16',NULL,NULL),(37672,24840,'TE','6017204171',0,'2014-02-20 04:53:42',NULL,NULL),(41543,27624,'TE','4196899465',0,'2014-03-05 21:30:06',NULL,NULL),(41819,27804,'TE','3308489240',0,'2014-03-05 21:31:47',NULL,NULL),(29567,19105,'AP','9852319369',0,'2014-01-21 08:44:41',NULL,NULL),(11750,7649,'TE','2819703833',0,'2013-12-26 02:46:48',NULL,NULL),(26175,16852,'TE','5135059445',0,'2014-01-13 02:18:41',NULL,NULL),(25746,16592,'TE','9858395084',0,'2014-01-08 18:24:01',NULL,NULL),(5157,3309,'TE','5134901048',0,'2013-12-25 21:15:51',NULL,NULL),(8816,5772,'EM','kimbodagr8@cox.net',0,'2013-12-25 23:46:50',NULL,NULL),(5093,3269,'TE','4193827547',0,'2013-12-25 20:47:08',NULL,NULL),(4983,3200,'AP','6148003366',0,'2013-12-25 20:45:08',NULL,NULL),(4852,3106,'TE','4194654070',0,'2013-12-25 20:20:24',NULL,NULL),(20457,13180,'TE','6825571773',0,'2013-12-26 12:54:18',NULL,NULL),(21648,13933,'TE','4194721379',0,'2013-12-26 13:14:32',NULL,NULL),(30436,19730,'EM','mpad37@gmail.com',0,'2014-01-23 21:01:05',NULL,NULL),(32342,21130,'EM','nguyqt@gmail.com',0,'2014-02-03 21:00:17',NULL,NULL),(37371,24602,'TE','3304161204',0,'2014-02-20 04:12:59',NULL,NULL),(37463,24673,'AP','4199577465',0,'2014-02-20 04:27:50',NULL,NULL),(38909,25722,'AP','6018768111',0,'2014-02-26 09:30:29',NULL,NULL),(42348,28125,'TE','3307801564',0,'2014-03-06 21:02:22',NULL,NULL),(2798,1695,'AP','5672881614',0,'2013-12-25 18:54:32',NULL,NULL),(824,513,'TE','5132525602',0,'2013-12-25 17:48:59',NULL,NULL),(28092,18107,'AP','9857097841',0,'2014-01-15 02:07:36',NULL,NULL),(40330,26765,'BN','4407319052',0,'2014-03-01 19:00:11',NULL,NULL),(22346,14410,'AP','2059011005',0,'2013-12-28 03:31:26',NULL,NULL),(199,122,'TE','9376614447',0,'2013-12-25 17:18:13',NULL,NULL),(3787,2404,'AP','5133140487',0,'2013-12-25 19:33:36',NULL,NULL),(4686,2998,'AP','4404886278',0,'2013-12-25 20:17:35',NULL,NULL),(31332,20417,'TE','4196067414',0,'2014-01-29 21:00:28',NULL,NULL),(32617,21327,'TE','3303294425',0,'2014-02-04 21:00:26',NULL,NULL),(34980,22964,'EM','RobertMiller311@gmail.com',0,'2014-02-12 21:00:12',NULL,NULL),(38669,25558,'TE','9378852164',0,'2014-02-26 08:00:22',NULL,NULL),(391,239,'TE','4194340687',0,'2013-12-25 17:21:16',NULL,NULL),(10649,6924,'TE','9372061498',0,'2013-12-26 01:46:18',NULL,NULL),(26800,17239,'TE','9173857841',0,'2014-01-13 02:22:44',NULL,NULL),(9780,6401,'TE','5135985119',0,'2013-12-26 00:48:21',NULL,NULL),(25987,16744,'AP','3307145168',0,'2014-01-08 18:24:52',NULL,NULL),(3464,2169,'TE','4193761477',0,'2013-12-25 19:19:06',NULL,NULL),(25657,16544,'TE','2163701910',1,'2014-01-07 10:22:29',NULL,NULL),(9145,5991,'EM','philberryfarm@hotmail.com',0,'2013-12-26 00:00:03',NULL,NULL),(22208,14308,'TE','3308564729',0,'2013-12-27 02:07:01',NULL,NULL),(21730,14001,'TE','3305394573',0,'2013-12-26 13:16:03',NULL,NULL),(33826,22209,'AP','9376719037',0,'2014-02-09 19:00:19',NULL,NULL),(33974,22287,'EM','legalwoozer@yahoo.com',0,'2014-02-10 11:00:27',NULL,NULL),(43933,29143,'EM','Dragon_Master_@hotmail.com',0,'2014-03-10 21:02:44',NULL,NULL),(28933,18679,'TE','4797159673',0,'2014-01-17 03:35:20',NULL,NULL),(742,464,'EM','scw0418@aol.com',0,'2013-12-25 17:47:43',NULL,NULL),(28785,18574,'TE','3308360639',0,'2014-01-16 08:47:06',NULL,NULL),(11002,7144,'AP','7189306357',0,'2013-12-26 01:52:00',NULL,NULL),(10727,6977,'EM','jvor111@aol.com',0,'2013-12-26 01:47:36',NULL,NULL),(9030,5924,'EM','h.hunsaker@yahoo.com',0,'2013-12-25 23:50:22',NULL,NULL),(27317,17593,'AP','9372868304',0,'2014-01-14 01:32:11',NULL,NULL),(39099,25868,'EM','raynemorehouse@gmail.com',0,'2014-02-26 21:00:49',NULL,NULL),(40187,26657,'AP','3308600399',0,'2014-02-28 21:31:10',NULL,NULL),(8877,5815,'TE','4696563676',0,'2013-12-25 23:47:53',NULL,NULL),(29708,19209,'TE','2163190152',0,'2014-01-21 08:46:21',NULL,NULL),(9984,6533,'EM','jrouse01@att.net',0,'2013-12-26 00:51:44',NULL,NULL),(10133,6624,'AP','4194601465',0,'2013-12-26 00:54:09',NULL,NULL),(29440,19035,'AP','6018967369',0,'2014-01-20 08:06:34',NULL,NULL),(11434,7437,'EM','EMAILMARCIA2@AOL.COM',0,'2013-12-26 02:30:20',NULL,NULL),(25617,16521,'EM','joshua.t.tracy@gmail.com',1,'2014-01-07 10:21:45',NULL,NULL),(33290,21797,'EM','marktamismith@roadrunner.com',0,'2014-02-06 21:00:48',NULL,NULL),(33778,22168,'TE','4192035892',0,'2014-02-08 19:01:02',NULL,NULL),(39093,25866,'TE','3378853517',0,'2014-02-26 21:00:47',NULL,NULL),(40135,26619,'AP','9032455375',0,'2014-02-28 21:30:51',NULL,NULL),(149,88,'EM','rick@usahomeinspectors.com',0,'2013-12-25 17:17:22',NULL,NULL),(23931,15442,'EM','kimberly@orremedical.com',1,'2014-01-02 04:28:05',NULL,NULL),(4104,2618,'TE','2162535635',0,'2013-12-25 19:45:47',NULL,NULL),(9331,6112,'TE','3306075448',0,'2013-12-26 00:15:29',NULL,NULL),(7047,4602,'EM','Johnalmond84@yahoo.com',0,'2013-12-25 22:05:45',NULL,NULL),(35344,23225,'TE','2162516481',0,'2014-02-12 21:32:21',NULL,NULL),(36577,24074,'EM','themorris5@neo.rr.com',0,'2014-02-15 22:01:19',NULL,NULL),(42615,28350,'AP','5124311113',0,'2014-03-07 21:30:22',NULL,NULL),(11261,7339,'AP','3304666736',0,'2013-12-26 02:03:59',NULL,NULL),(8373,5503,'TE','3303071558',0,'2013-12-25 23:11:23',NULL,NULL),(3697,2344,'AP','8306600824',0,'2013-12-25 19:32:03',NULL,NULL),(23735,15313,'EM','Peglynn56@Gmail.com',1,'2014-01-02 04:23:18',NULL,NULL),(25646,16539,'AP','3303104650',1,'2014-01-07 10:22:18',NULL,NULL),(27720,17867,'TE','5137535099',0,'2014-01-15 02:06:12',NULL,NULL),(22811,14707,'AP','4192363037',1,'2013-12-29 11:09:15',NULL,NULL),(7224,4704,'AP','4194601532',0,'2013-12-25 22:08:31',NULL,NULL),(6537,4227,'AP','2108150175',0,'2013-12-25 21:50:36',NULL,NULL),(20871,13418,'AP','4193035078',0,'2013-12-26 13:00:46',NULL,NULL),(2554,1560,'AP','6016006764',0,'2013-12-25 18:50:53',NULL,NULL),(37077,24412,'AP','3305016154',0,'2014-02-18 22:01:02',NULL,NULL),(41818,27801,'TE','3303344180',0,'2014-03-05 21:31:46',NULL,NULL),(31652,20650,'TE','7604641456',0,'2014-01-30 21:00:38',NULL,NULL),(13612,8871,'TE','9156941266',0,'2013-12-26 04:01:35',NULL,NULL),(6854,4446,'TE','7402216235',0,'2013-12-25 22:02:16',NULL,NULL),(30929,20115,'AP','5132276660',0,'2014-01-27 21:00:43',NULL,NULL),(4882,3130,'TE','5133154977',0,'2013-12-25 20:30:29',NULL,NULL),(12320,8055,'AP','9374175510',0,'2013-12-26 03:09:49',NULL,NULL),(3481,2180,'EM','joanna.hirt@yahoo.com',0,'2013-12-25 19:19:23',NULL,NULL),(10678,6938,'TE','2164016085',0,'2013-12-26 01:46:44',NULL,NULL),(8321,5455,'EM','ldussel@yahoo.com',0,'2013-12-25 23:10:17',NULL,NULL),(26946,17329,'AP','5049098881',0,'2014-01-13 02:23:56',NULL,NULL),(24106,15561,'TE','3306280178',1,'2014-01-02 04:31:36',NULL,NULL),(25863,16669,'TE','9377439451',0,'2014-01-08 18:24:28',NULL,NULL),(37132,24444,'TE','5134222672',0,'2014-02-18 22:01:21',NULL,NULL),(38671,25559,'TE','9378852164',0,'2014-02-26 08:00:22',NULL,NULL),(29813,19289,'EM','tricia_1187@yahoo.com',1,'2014-01-22 03:21:54',NULL,NULL),(27734,17881,'AP','4405704809',0,'2014-01-15 02:06:16',NULL,NULL),(26270,16905,'AP','5132070946',0,'2014-01-13 02:19:35',NULL,NULL),(1552,955,'EM','caserta.16@gmail.com',0,'2013-12-25 18:09:39',NULL,NULL),(1697,1043,'TE','3252624455',0,'2013-12-25 18:15:50',NULL,NULL),(37321,24558,'AP','2169904376',0,'2014-02-20 04:06:05',NULL,NULL),(1179,723,'TE','9035654510',0,'2013-12-25 18:03:32',NULL,NULL),(30950,20132,'TE','5133748080',0,'2014-01-27 21:00:52',NULL,NULL),(26085,16800,'TE','2148753355',0,'2014-01-13 02:18:11',NULL,NULL),(11318,7374,'AP','5132829856',0,'2013-12-26 02:15:45',NULL,NULL),(2795,1691,'AP','4194941656',0,'2013-12-25 18:54:29',NULL,NULL),(34167,22407,'TE','2257885885',0,'2014-02-10 21:30:23',NULL,NULL),(34827,22842,'TE','4192047312',0,'2014-02-11 21:02:14',NULL,NULL),(38215,25224,'TE','3303369332',0,'2014-02-21 22:00:58',NULL,NULL),(12155,7940,'TE','3184423985',0,'2013-12-26 03:06:52',NULL,NULL),(24347,15725,'EM','jjpn1969x@yahoo.com',0,'2014-01-03 02:00:18',NULL,NULL),(591,363,'EM','mj7641@gmail.com',0,'2013-12-25 17:45:15',NULL,NULL),(23643,15267,'EM','tracy.close@yahoo.com',0,'2014-01-01 12:09:31',NULL,NULL),(2107,1302,'TE','9155643123',0,'2013-12-25 18:31:13',NULL,NULL),(11260,7339,'TE','3304666736',0,'2013-12-26 02:03:59',NULL,NULL),(10280,6712,'TE','8306260136',0,'2013-12-26 01:02:18',NULL,NULL),(3303,2078,'AP','3372987960',0,'2013-12-25 19:16:34',NULL,NULL),(10365,6756,'AP','4408652499',0,'2013-12-26 01:16:14',NULL,NULL),(6279,4049,'EM','capricewybarra@gmail.com',0,'2013-12-25 21:46:21',NULL,NULL),(33880,22237,'TE','3308359069',0,'2014-02-09 19:00:36',NULL,NULL),(37684,24847,'AP','5676940879',0,'2014-02-20 04:54:51',NULL,NULL),(25544,16479,'TE','3306280500',0,'2014-01-07 04:06:12',NULL,NULL),(692,429,'AP','2164088279',0,'2013-12-25 17:46:53',NULL,NULL),(10267,6707,'AP','7344302945',0,'2013-12-26 01:02:06',NULL,NULL),(4835,3095,'TE','4197061226',0,'2013-12-25 20:20:06',NULL,NULL),(11404,7422,'TE','6145251788',0,'2013-12-26 02:17:04',NULL,NULL),(3916,2485,'TE','2257769489',0,'2013-12-25 19:35:38',NULL,NULL),(9138,5985,'AP','4194385267',0,'2013-12-25 23:52:03',NULL,NULL),(35407,23276,'AP','9378316008',0,'2014-02-13 21:30:14',NULL,NULL),(36691,24158,'AP','4199663480',0,'2014-02-15 22:02:02',NULL,NULL),(37882,24992,'TE','4322500741',0,'2014-02-20 22:00:40',NULL,NULL),(38574,25494,'EM','mustangstallion1@frontier.com',0,'2014-02-25 21:31:50',NULL,NULL),(8185,5355,'AP','3306872802',0,'2013-12-25 23:07:43',NULL,NULL),(10015,6553,'TE','8176372971',0,'2013-12-26 00:52:13',NULL,NULL),(11815,7685,'TE','5136331088',0,'2013-12-26 03:00:55',NULL,NULL),(4078,2601,'TE','4405709144',0,'2013-12-25 19:45:21',NULL,NULL),(21231,13649,'TE','5042316601',0,'2013-12-26 13:07:14',NULL,NULL),(3081,1922,'TE','4197755955',0,'2013-12-25 19:00:12',NULL,NULL),(7434,4836,'EM','a.dewey@hotmail.com',0,'2013-12-25 22:17:28',NULL,NULL),(33240,21765,'AP','9036171809',0,'2014-02-06 21:00:29',NULL,NULL),(42897,28529,'TE','3184185087',0,'2014-03-07 21:32:06',NULL,NULL),(10688,6946,'EM','teresa.gustin@hotmail.com',0,'2013-12-26 01:46:55',NULL,NULL),(31589,20604,'TE','7406271453',0,'2014-01-30 21:00:14',NULL,NULL),(30379,19680,'TE','3259339392',0,'2014-01-23 21:00:38',NULL,NULL),(32908,21545,'AP','3308066462',0,'2014-02-05 21:30:11',NULL,NULL),(40925,27196,'TE','8327586028',0,'2014-03-03 21:31:19',NULL,NULL),(41825,27810,'AP','4196851573',0,'2014-03-05 21:31:50',NULL,NULL),(42803,28463,'EM','chloermallardi@gmail.com',0,'2014-03-07 21:31:27',NULL,NULL),(7212,4700,'TE','9373081184',0,'2013-12-25 22:08:23',NULL,NULL),(11142,7244,'AP','5044524308',0,'2013-12-26 02:01:45',NULL,NULL),(23838,15380,'EM','skeethler@larosas.com',1,'2014-01-02 04:25:24',NULL,NULL),(5366,3436,'TE','5043053707',0,'2013-12-25 21:19:05',NULL,NULL),(151,91,'TE','8179082720',0,'2013-12-25 17:17:26',NULL,NULL),(8667,5691,'TE','5133416696',0,'2013-12-25 23:32:36',NULL,NULL),(30303,19630,'EM','AMYEH90@ATT.NET',0,'2014-01-23 21:00:09',NULL,NULL),(20274,13067,'AP','6144047809',0,'2013-12-26 12:51:12',NULL,NULL),(8474,5574,'EM','fpainter3733@gmail.com',0,'2013-12-25 23:16:47',NULL,NULL),(11091,7205,'AP','9373467293',0,'2013-12-26 02:00:46',NULL,NULL),(22325,14391,'AP','6145816545',0,'2013-12-28 03:31:01',NULL,NULL),(40738,27072,'AP','3307150321',0,'2014-03-03 21:30:07',NULL,NULL),(8640,5674,'EM','netcab12@yahoo.com',0,'2013-12-25 23:32:08',NULL,NULL),(20404,13140,'AP','5132662833',0,'2013-12-26 12:53:17',NULL,NULL),(3354,2110,'TE','9374400915',0,'2013-12-25 19:17:24',NULL,NULL),(31313,20403,'TE','8177265873',0,'2014-01-29 21:00:21',NULL,NULL),(10360,6754,'EM','mharris2511@sbcglobal.net',0,'2013-12-26 01:16:10',NULL,NULL),(28329,18257,'TE','2103742941',0,'2014-01-16 08:44:34',NULL,NULL),(23749,15322,'TE','3239193391',1,'2014-01-02 04:23:35',NULL,NULL),(6418,4144,'AP','9375093801',0,'2013-12-25 21:48:38',NULL,NULL),(34951,22943,'EM','donnagrotenrath@gmail.com',0,'2014-02-11 21:30:21',NULL,NULL),(22143,14261,'TE','2257764327',0,'2013-12-27 02:05:49',NULL,NULL),(8511,5596,'TE','5047389558',0,'2013-12-25 23:30:07',NULL,NULL),(11226,7303,'TE','3307533623',0,'2013-12-26 02:03:12',NULL,NULL),(9835,6434,'EM','cvavapromo@gmail.com',0,'2013-12-26 00:49:15',NULL,NULL),(2750,1667,'EM','fard9@hotmail.com',0,'2013-12-25 18:53:48',NULL,NULL),(7842,5118,'TE','8065950331',0,'2013-12-25 23:01:53',NULL,NULL),(7604,4951,'TE','2254361225',0,'2013-12-25 22:45:57',NULL,NULL),(3710,2352,'AP','9362544746',0,'2013-12-25 19:32:16',NULL,NULL),(34900,22901,'AP','4192330475',0,'2014-02-11 21:02:42',NULL,NULL),(35144,23079,'AP','3304726819',0,'2014-02-12 21:31:02',NULL,NULL),(27454,17686,'AP','9857788359',0,'2014-01-14 01:32:57',NULL,NULL),(377,230,'EM','jkachuba@fuse.net',0,'2013-12-25 17:21:02',NULL,NULL),(24410,15760,'AP','9568545087',0,'2014-01-03 02:01:28',NULL,NULL),(1437,876,'EM','drewchadwick@gmail.com',0,'2013-12-25 18:07:36',NULL,NULL),(20282,13072,'AP','2162246522',0,'2013-12-26 12:51:21',NULL,NULL),(6367,4102,'TE','5127716831',0,'2013-12-25 21:47:46',NULL,NULL),(11723,7631,'AP','3304743134',0,'2013-12-26 02:46:15',NULL,NULL),(796,496,'AP','4437165788',0,'2013-12-25 17:48:33',NULL,NULL),(14016,9151,'EM','mbarker@neo.rr.com',0,'2013-12-26 04:08:27',NULL,NULL),(25445,16407,'AP','2542175447',0,'2014-01-07 04:04:06',NULL,NULL),(24051,15529,'EM','tracym@eatel.net',1,'2014-01-02 04:30:34',NULL,NULL),(22671,14616,'EM','lovejoy_mary43@yahoo.com',0,'2013-12-28 03:36:49',NULL,NULL),(6966,4542,'AP','8067293963',0,'2013-12-25 22:04:19',NULL,NULL),(37482,24680,'AP','9402229901',0,'2014-02-20 04:30:17',NULL,NULL),(41980,27905,'TE','2144358700',0,'2014-03-06 21:00:12',NULL,NULL),(43516,28895,'TE','8306901057',0,'2014-03-10 21:00:17',NULL,NULL),(11392,7416,'EM','TAllenohh1@NicheVision.com',0,'2013-12-26 02:16:53',NULL,NULL),(26869,17289,'AP','8062022525',0,'2014-01-13 02:23:32',NULL,NULL),(26310,16940,'AP','2282345256',0,'2014-01-13 02:19:53',NULL,NULL),(24202,15635,'TE','3185109710',1,'2014-01-02 04:33:37',NULL,NULL),(22384,14439,'TE','5047129009',0,'2013-12-28 03:32:08',NULL,NULL),(8079,5289,'AP','3303175564',0,'2013-12-25 23:05:59',NULL,NULL),(35371,23240,'EM','bpro600rr@gmail.com',0,'2014-02-12 21:32:32',NULL,NULL),(8182,5353,'TE','4402241676',0,'2013-12-25 23:07:41',NULL,NULL),(32194,21027,'EM','andy@mennofolk.org',0,'2014-02-01 19:00:43',NULL,NULL),(11211,7292,'EM','michelledepaolo@frontier.com',0,'2013-12-26 02:02:55',NULL,NULL),(2219,1365,'AP','4696582696',0,'2013-12-25 18:45:36',NULL,NULL),(7279,4743,'TE','9378768722',0,'2013-12-25 22:09:32',NULL,NULL),(41002,27242,'TE','5138760569',0,'2014-03-03 21:31:48',NULL,NULL),(43841,29097,'TE','5133043805',0,'2014-03-10 21:02:14',NULL,NULL),(9143,5990,'TE','4197066814',0,'2013-12-25 23:52:11',NULL,NULL),(1194,728,'EM','mnesmith@flash.net',0,'2013-12-25 18:03:43',NULL,NULL),(30465,19750,'TE','4193446438',0,'2014-01-23 21:01:17',NULL,NULL),(21651,13934,'EM','agodwin@kent.edu',0,'2013-12-26 13:14:35',NULL,NULL),(4847,3102,'TE','4196043239',0,'2013-12-25 20:20:18',NULL,NULL),(14420,9427,'TE','3256505626',0,'2013-12-26 04:33:17',NULL,NULL),(26783,17230,'TE','6624158261',0,'2014-01-13 02:22:39',NULL,NULL),(23223,14966,'TE','9035749792',0,'2014-01-01 12:00:39',NULL,NULL),(25041,16139,'AP','2108601315',0,'2014-01-04 02:05:56',NULL,NULL),(25104,16184,'AP','2816900189',0,'2014-01-05 00:00:38',NULL,NULL),(26703,17177,'AP','6149990535',0,'2014-01-13 02:22:11',NULL,NULL),(33455,21916,'EM','katehemmer@yahoo.com',0,'2014-02-06 21:30:06',NULL,NULL),(33783,22172,'EM','monnie.pilgrim@gmail.com',0,'2014-02-08 19:30:05',NULL,NULL),(35321,23208,'EM','donna.swearingen@gmail.com',0,'2014-02-12 21:32:12',NULL,NULL),(40399,26817,'TE','2488854786',0,'2014-03-01 21:00:32',NULL,NULL),(43579,28938,'EM','nischlaw@excite.com',0,'2014-03-10 21:00:41',NULL,NULL),(14553,9508,'TE','7405351932',0,'2013-12-26 04:35:20',NULL,NULL),(36637,24118,'TE','9155912891',0,'2014-02-15 22:01:41',NULL,NULL),(42543,28307,'TE','6622300938',0,'2014-03-07 21:00:35',NULL,NULL),(21181,13624,'EM','dhmc@woh.rr.com',0,'2013-12-26 13:05:57',NULL,NULL),(27062,17406,'TE','2815574344',0,'2014-01-13 03:00:19',NULL,NULL),(25978,16735,'TE','3306222290',0,'2014-01-08 18:24:50',NULL,NULL),(24186,15626,'TE','5044680698',1,'2014-01-02 04:33:20',NULL,NULL),(24171,15618,'TE','6015902317',1,'2014-01-02 04:33:03',NULL,NULL),(5275,3386,'AP','2257185756',0,'2013-12-25 21:17:41',NULL,NULL),(3287,2067,'EM','MMHGRS@AOL.COM',0,'2013-12-25 19:16:16',NULL,NULL),(33707,22110,'AP','4196511994',0,'2014-02-08 19:00:34',NULL,NULL),(38121,25161,'AP','9792575409',0,'2014-02-21 22:00:23',NULL,NULL),(40513,26887,'AP','5672598391',0,'2014-03-03 01:00:02',NULL,NULL),(43830,29093,'TE','2105771491',0,'2014-03-10 21:02:11',NULL,NULL),(32779,21444,'AP','3309906718',0,'2014-02-04 21:01:26',NULL,NULL),(29719,19217,'AP','9377288207',0,'2014-01-21 08:46:25',NULL,NULL),(27748,17890,'AP','6145603969',0,'2014-01-15 02:06:19',NULL,NULL),(23342,15039,'TE','3185477759',0,'2014-01-01 12:02:53',NULL,NULL),(4209,2690,'TE','8062733205',0,'2013-12-25 19:47:30',NULL,NULL),(33711,22113,'EM','charles.michael610@yahoo.com',0,'2014-02-08 19:00:35',NULL,NULL),(34599,22688,'TE','2104215731',0,'2014-02-11 21:00:51',NULL,NULL),(37955,25044,'AP','6147020651',0,'2014-02-20 22:01:12',NULL,NULL),(42269,28072,'EM','marilynbarton33@yahoo.com',0,'2014-03-06 21:01:51',NULL,NULL),(32092,20959,'AP','9153280768',0,'2014-02-01 19:00:08',NULL,NULL),(25588,16506,'TE','7406970295',1,'2014-01-07 10:21:14',NULL,NULL),(25351,16349,'TE','3305440322',0,'2014-01-07 04:02:27',NULL,NULL),(35465,23324,'AP','5133197283',0,'2014-02-13 22:00:26',NULL,NULL),(40446,26851,'EM','martin0433@bellsouth.net',0,'2014-03-01 21:00:51',NULL,NULL),(9345,6119,'TE','9035886056',0,'2013-12-26 00:15:42',NULL,NULL),(788,492,'AP','5043247667',0,'2013-12-25 17:48:27',NULL,NULL),(28487,18356,'EM','roblowe.bio@gmail.com',0,'2014-01-16 08:45:24',NULL,NULL),(25463,16418,'EM','peanutct@aol.com',0,'2014-01-07 04:04:28',NULL,NULL),(10982,7135,'TE','6623923083',0,'2013-12-26 01:51:44',NULL,NULL),(11983,7808,'TE','5129544755',0,'2013-12-26 03:03:52',NULL,NULL),(20397,13137,'TE','5132053384',0,'2013-12-26 12:53:12',NULL,NULL),(2512,1540,'AP','5138843420',0,'2013-12-25 18:50:16',NULL,NULL),(36173,23808,'EM','mgipe@neo.rr.com',0,'2014-02-14 21:31:34',NULL,NULL),(32134,20985,'BN','9375459126',0,'2014-02-01 19:00:22',NULL,NULL),(8832,5782,'TE','6145788309',0,'2013-12-25 23:47:05',NULL,NULL),(8761,5742,'TE','5617156348',0,'2013-12-25 23:45:59',NULL,NULL),(11054,7178,'TE','9376722738',0,'2013-12-26 02:00:08',NULL,NULL),(11020,7154,'TE','3305643434',0,'2013-12-26 01:52:17',NULL,NULL),(10380,6765,'TE','9855101040',0,'2013-12-26 01:16:28',NULL,NULL),(4205,2688,'TE','2544582329',0,'2013-12-25 19:47:26',NULL,NULL),(5001,3211,'TE','9035811585',0,'2013-12-25 20:45:26',NULL,NULL),(31471,20509,'AP','3187800577',0,'2014-01-29 21:01:18',NULL,NULL),(29744,19233,'TE','2166506915',0,'2014-01-21 08:46:34',NULL,NULL),(22963,14811,'AP','5042309698',1,'2013-12-29 11:14:04',NULL,NULL),(25598,16513,'EM','mandabearrawr@gmail.com',1,'2014-01-07 10:21:26',NULL,NULL),(39075,25844,'TE','3306584548',0,'2014-02-26 21:00:37',NULL,NULL),(31356,20435,'TE','4403719555',0,'2014-01-29 21:00:37',NULL,NULL),(30366,19672,'TE','9562831558',0,'2014-01-23 21:00:33',NULL,NULL),(21002,13513,'EM','rshumate@comcast.net',0,'2013-12-26 13:02:59',NULL,NULL),(5171,3319,'EM','cookgorsuch@yahoo.com',0,'2013-12-25 21:16:01',NULL,NULL),(11265,7341,'TE','3306067567',0,'2013-12-26 02:04:02',NULL,NULL),(29757,19243,'TE','3306302950',0,'2014-01-21 08:46:38',NULL,NULL),(26373,16976,'TE','6013106684',0,'2014-01-13 02:20:16',NULL,NULL),(25281,16300,'TE','3186315248',0,'2014-01-07 04:01:08',NULL,NULL),(39904,26408,'AP','5136499129',0,'2014-02-28 07:00:37',NULL,NULL),(20541,13221,'EM','ik5505@yahoo.com',0,'2013-12-26 12:55:30',NULL,NULL),(33089,21675,'EM','NGUYENXUANNAM2003@YAHOO.COM',0,'2014-02-05 21:31:00',NULL,NULL),(32804,21461,'EM','frswmr@sbcglobal.net',0,'2014-02-04 21:01:34',NULL,NULL),(8490,5585,'AP','5042289810',0,'2013-12-25 23:17:04',NULL,NULL),(38479,25429,'TE','8627548724',0,'2014-02-25 21:31:14',NULL,NULL),(39555,26169,'EM','Angelaerby_59@yahoo.com',0,'2014-02-28 06:30:35',NULL,NULL),(42202,28033,'BN','9373607772',0,'2014-03-06 21:01:29',NULL,NULL),(33456,21918,'TE','8063521532',0,'2014-02-07 19:00:04',NULL,NULL),(9342,6116,'TE','3306284035',0,'2013-12-26 00:15:37',NULL,NULL),(31860,20799,'AP','3612272837',0,'2014-01-31 21:00:20',NULL,NULL),(28580,18423,'AP','5043603094',0,'2014-01-16 08:45:54',NULL,NULL),(23068,14877,'EM','janice@e2website.com',0,'2013-12-30 00:00:24',NULL,NULL),(41109,27308,'AP','9563125198',0,'2014-03-04 21:00:37',NULL,NULL),(43380,28810,'TE','4408129771',0,'2014-03-09 21:00:54',NULL,NULL),(30565,19831,'AP','2147328177',0,'2014-01-24 21:00:20',NULL,NULL),(10358,6752,'EM','Nickscar33@gmail.com',0,'2013-12-26 01:16:07',NULL,NULL),(9966,6522,'TE','4194810648',0,'2013-12-26 00:51:26',NULL,NULL),(35088,23045,'EM','juanthr54@gmail.com',0,'2014-02-12 21:30:42',NULL,NULL),(39359,26032,'AP','6016006450',0,'2014-02-26 21:02:22',NULL,NULL),(31767,20736,'TE','9376214672',0,'2014-01-30 21:01:21',NULL,NULL),(31881,20809,'TE','8065440515',0,'2014-01-31 21:00:27',NULL,NULL),(43607,28951,'TE','3374996765',0,'2014-03-10 21:00:50',NULL,NULL),(20335,13102,'EM','dalton.43@wright.edu',0,'2013-12-26 12:52:12',NULL,NULL),(28931,18678,'AP','9563133994',0,'2014-01-17 03:35:19',NULL,NULL),(12461,8158,'EM','LJANSON4522@GMAIL.COM',0,'2013-12-26 03:16:17',NULL,NULL),(1829,1133,'TE','2252889807',0,'2013-12-25 18:18:06',NULL,NULL),(28458,18338,'EM','srpilkington@gmail.com',0,'2014-01-16 08:45:16',NULL,NULL),(7677,5001,'AP','3302724681',0,'2013-12-25 22:47:08',NULL,NULL),(3884,2469,'TE','3185724300',0,'2013-12-25 19:35:09',NULL,NULL),(10270,6708,'AP','6015067463',0,'2013-12-26 01:02:09',NULL,NULL),(9518,6230,'TE','5138852566',0,'2013-12-26 00:31:25',NULL,NULL),(25921,16704,'TE','3256536652',0,'2014-01-08 18:24:40',NULL,NULL),(9050,5935,'AP','3182678461',0,'2013-12-25 23:50:39',NULL,NULL),(38447,25407,'EM','J.M.Eich1987@gmail.com',0,'2014-02-25 21:31:00',NULL,NULL),(39635,26210,'TE','4193683784',0,'2014-02-28 06:30:53',NULL,NULL),(129,75,'AP','5136156899',0,'2013-12-25 17:17:03',NULL,NULL),(2542,1555,'TE','6014333066',0,'2013-12-25 18:50:44',NULL,NULL),(42741,28429,'TE','3307943247',0,'2014-03-07 21:31:08',NULL,NULL),(42798,28462,'TE','9373048522',0,'2014-03-07 21:31:26',NULL,NULL),(30861,20059,'EM','newsomenatasha@yahoo.com',0,'2014-01-27 21:00:10',NULL,NULL),(2474,1517,'TE','3305278017',0,'2013-12-25 18:49:42',NULL,NULL),(29716,19212,'EM','srpilkington@gmail.com',0,'2014-01-21 08:46:23',NULL,NULL),(26858,17285,'TE','9563268932',0,'2014-01-13 02:23:27',NULL,NULL),(11114,7228,'TE','3304421529',0,'2013-12-26 02:01:18',NULL,NULL),(23760,15325,'TE','7134106030',1,'2014-01-02 04:23:44',NULL,NULL),(32017,20901,'AP','2164101341',0,'2014-01-31 21:01:21',NULL,NULL),(38406,25375,'TE','5139413933',0,'2014-02-25 21:30:43',NULL,NULL),(30749,19979,'AP','3309575404',0,'2014-01-25 19:00:15',NULL,NULL),(28347,18265,'AP','9035133601',0,'2014-01-16 08:44:39',NULL,NULL),(27090,17422,'AP','3309904178',0,'2014-01-13 03:00:28',NULL,NULL),(730,458,'TE','7078158061',0,'2013-12-25 17:47:33',NULL,NULL),(23169,14932,'TE','9727426028',0,'2013-12-30 00:02:03',NULL,NULL),(23076,14882,'AP','9152521048',0,'2013-12-30 00:00:34',NULL,NULL),(4576,2919,'TE','4195223225',0,'2013-12-25 20:15:45',NULL,NULL),(20315,13092,'TE','8594090497',0,'2013-12-26 12:51:54',NULL,NULL),(8001,5221,'TE','3307634727',0,'2013-12-25 23:04:33',NULL,NULL),(28950,18688,'TE','3189909107',0,'2014-01-17 03:35:23',NULL,NULL),(1927,1193,'AP','5135192650',0,'2013-12-25 18:19:40',NULL,NULL),(13525,8819,'EM','brittany.psisinfo@gmail.com',0,'2013-12-26 04:00:13',NULL,NULL),(11267,7342,'EM','kmforsyth@aol.com',0,'2013-12-26 02:04:04',NULL,NULL),(6274,4046,'EM','meshellmybelle74@aol.com',0,'2013-12-25 21:46:16',NULL,NULL),(3331,2094,'TE','2164961948',0,'2013-12-25 19:16:59',NULL,NULL),(6826,4429,'AP','5133710753',0,'2013-12-25 22:01:50',NULL,NULL),(28359,18275,'TE','9039268528',0,'2014-01-16 08:44:43',NULL,NULL),(22787,14694,'TE','6144405177',1,'2013-12-29 11:08:53',NULL,NULL),(32153,21002,'EM','CAROLINECARNEY@GMAIL.COM',0,'2014-02-01 19:00:29',NULL,NULL),(4935,3167,'AP','5133073268',0,'2013-12-25 20:31:29',NULL,NULL),(939,579,'EM','scottwm4@yahoo.com',0,'2013-12-25 17:50:49',NULL,NULL),(8675,5696,'TE','3306761909',0,'2013-12-25 23:32:45',NULL,NULL),(5258,3376,'EM','reeise.kenneth@gmail.com',0,'2013-12-25 21:17:24',NULL,NULL),(28225,18197,'AP','5134766860',0,'2014-01-15 02:08:06',NULL,NULL),(21248,13656,'TE','2252161063',0,'2013-12-26 13:07:29',NULL,NULL),(25287,16305,'TE','3184871890',0,'2014-01-07 04:01:16',NULL,NULL),(33444,21907,'TE','6019515449',0,'2014-02-06 21:01:51',NULL,NULL),(36740,24188,'TE','7137850219',0,'2014-02-16 19:00:12',NULL,NULL),(37971,25052,'AP','5133822924',0,'2014-02-20 22:01:17',NULL,NULL),(38582,25498,'EM','angelcoleman70@yahoo.com',0,'2014-02-25 21:31:53',NULL,NULL),(40257,26708,'TE','5137534424',0,'2014-02-28 21:31:37',NULL,NULL),(40903,27178,'TE','4324387558',0,'2014-03-03 21:31:09',NULL,NULL),(28640,18466,'TE','5044188736',0,'2014-01-16 08:46:15',NULL,NULL),(7788,5085,'TE','8063191174',0,'2013-12-25 23:01:03',NULL,NULL),(14866,9729,'AP','5132656685',0,'2013-12-26 04:45:39',NULL,NULL),(1713,1051,'AP','9564077795',0,'2013-12-25 18:16:03',NULL,NULL),(2118,1306,'EM','vallkyria99@gmail.com',0,'2013-12-25 18:31:20',NULL,NULL),(24397,15752,'AP','9565872437',0,'2014-01-03 02:01:12',NULL,NULL),(4514,2870,'AP','8323878818',0,'2013-12-25 20:01:56',NULL,NULL),(3359,2112,'TE','5138276723',0,'2013-12-25 19:17:28',NULL,NULL),(31649,20648,'TE','9157511393',0,'2014-01-30 21:00:37',NULL,NULL),(32629,21335,'TE','2813859113',0,'2014-02-04 21:00:30',NULL,NULL),(33875,22234,'AP','2106694395',0,'2014-02-09 19:00:34',NULL,NULL),(36510,24038,'BN','4403195585',0,'2014-02-15 22:00:56',NULL,NULL),(39424,26070,'EM','cbhubson33@aol.com',0,'2014-02-26 21:02:44',NULL,NULL),(20830,13389,'EM','dalejrfan32832001@yahoo.com',0,'2013-12-26 13:00:06',NULL,NULL),(20427,13155,'TE','5139394564',0,'2013-12-26 12:53:42',NULL,NULL),(22078,14220,'TE','9562700104',0,'2013-12-27 02:04:43',NULL,NULL),(13977,9118,'TE','3304756609',0,'2013-12-26 04:07:42',NULL,NULL),(1711,1050,'EM','rskay@sbcglobal.net',0,'2013-12-25 18:16:01',NULL,NULL),(3289,2068,'AP','5134157570',0,'2013-12-25 19:16:18',NULL,NULL),(5076,3260,'TE','3308671059',0,'2013-12-25 20:46:51',NULL,NULL),(43142,28676,'AP','4197870160',0,'2014-03-08 21:30:53',NULL,NULL),(27438,17675,'TE','9853856066',0,'2014-01-14 01:32:51',NULL,NULL),(7346,4774,'AP','2163191291',0,'2013-12-25 22:15:56',NULL,NULL),(1745,1075,'AP','3302422474',0,'2013-12-25 18:16:37',NULL,NULL),(42656,28379,'TE','3304596400',0,'2014-03-07 21:30:38',NULL,NULL),(428,262,'EM','pt6pac@yahoo.com',0,'2013-12-25 17:21:52',NULL,NULL),(28471,18344,'EM','angelicdevas@sbcglobal.net',0,'2014-01-16 08:45:19',NULL,NULL),(7014,4581,'TE','3307631181',0,'2013-12-25 22:05:13',NULL,NULL),(8768,5747,'EM','lexk75@gmail.com',0,'2013-12-25 23:46:06',NULL,NULL),(36025,23695,'TE','3308130186',0,'2014-02-14 21:30:40',NULL,NULL),(41868,27840,'TE','8322795824',0,'2014-03-05 21:32:07',NULL,NULL),(43314,28774,'EM','rose2819@excite.com',0,'2014-03-09 21:00:31',NULL,NULL),(9474,6200,'AP','5136004621',0,'2013-12-26 00:30:36',NULL,NULL),(21900,14110,'TE','5135084648',0,'2013-12-27 02:01:49',NULL,NULL),(34342,22531,'TE','6019244051',0,'2014-02-10 21:31:32',NULL,NULL),(34858,22861,'AP','2283633657',0,'2014-02-11 21:02:25',NULL,NULL),(35367,23238,'TE','5137347567',0,'2014-02-12 21:32:30',NULL,NULL),(36021,23693,'AP','5133143299',0,'2014-02-14 21:30:38',NULL,NULL),(36294,23897,'TE','9374971199',0,'2014-02-14 21:32:21',NULL,NULL),(40115,26603,'TE','6822241644',0,'2014-02-28 21:30:42',NULL,NULL),(40246,26696,'AP','3185279444',0,'2014-02-28 21:31:31',NULL,NULL),(40453,26855,'TE','5138762791',0,'2014-03-01 21:00:53',NULL,NULL),(9166,6001,'AP','5044132223',0,'2013-12-26 00:00:21',NULL,NULL),(21260,13662,'AP','5045799672',0,'2013-12-26 13:07:39',NULL,NULL),(24700,15933,'EM','theodorebower1985@gmail.com',0,'2014-01-03 02:06:58',NULL,NULL),(22460,14484,'AP','8063950399',0,'2013-12-28 03:33:21',NULL,NULL),(33849,22219,'EM','vancreel7@yahoo.com',0,'2014-02-09 19:00:26',NULL,NULL),(35834,23565,'TE','4196544958',0,'2014-02-13 22:02:47',NULL,NULL),(40449,26852,'EM','ELDORAJONES@YAHOO.COM',0,'2014-03-01 21:00:51',NULL,NULL),(42132,27987,'AP','3373911357',0,'2014-03-06 21:01:01',NULL,NULL),(42916,28539,'AP','8325605676',0,'2014-03-07 21:32:13',NULL,NULL),(20966,13490,'TE','4402213935',0,'2013-12-26 13:02:24',NULL,NULL),(1023,631,'TE','9373278200',0,'2013-12-25 18:01:07',NULL,NULL),(7872,5134,'TE','9792577063',0,'2013-12-25 23:02:19',NULL,NULL),(31429,20489,'TE','3307249746',0,'2014-01-29 21:01:05',NULL,NULL),(30558,19828,'EM','friley66@gmail.com',0,'2014-01-24 21:00:18',NULL,NULL),(24941,16078,'TE','2165107181',0,'2014-01-04 02:04:00',NULL,NULL),(5817,3735,'TE','9038560217',0,'2013-12-25 21:32:43',NULL,NULL),(39478,26109,'TE','6143480659',0,'2014-02-28 06:30:15',NULL,NULL),(30913,20099,'EM','le.sel.de.mer@gmail.com',0,'2014-01-27 21:00:34',NULL,NULL),(14141,9259,'TE','5756023811',0,'2013-12-26 04:15:15',NULL,NULL),(29580,19113,'TE','9375540535',0,'2014-01-21 08:44:46',NULL,NULL),(26848,17272,'AP','3307600383',0,'2014-01-13 02:23:22',NULL,NULL),(7867,5132,'TE','4692078849',0,'2013-12-25 23:02:15',NULL,NULL),(25274,16294,'AP','2253050972',0,'2014-01-07 04:00:58',NULL,NULL),(21325,13702,'EM','jacksonclassie@yahoo.com',0,'2013-12-26 13:08:43',NULL,NULL),(33712,22114,'TE','8322361486',0,'2014-02-08 19:00:36',NULL,NULL),(35098,23054,'AP','8123415476',0,'2014-02-12 21:30:48',NULL,NULL),(36356,23943,'EM','aldridgebrooke@gmail.com',0,'2014-02-15 21:00:10',NULL,NULL),(42135,27988,'AP','3188014467',0,'2014-03-06 21:01:02',NULL,NULL),(42526,28291,'EM','bengalcincy05@gmail.com',0,'2014-03-07 21:00:28',NULL,NULL),(42716,28413,'TE','5135318944',0,'2014-03-07 21:30:58',NULL,NULL),(9487,6208,'TE','5125788591',0,'2013-12-26 00:30:48',NULL,NULL),(5003,3213,'TE','2142137138',0,'2013-12-25 20:45:29',NULL,NULL),(6248,4027,'EM','BKS924@COLUMBUS.RR.COM',0,'2013-12-25 21:45:49',NULL,NULL),(33277,21790,'AP','2163318706',0,'2014-02-06 21:00:43',NULL,NULL),(33370,21865,'TE','9375844747',0,'2014-02-06 21:01:22',NULL,NULL),(37133,24444,'EM','jakers1962@sbcglobal.net',0,'2014-02-18 22:01:21',NULL,NULL),(42791,28459,'TE','2253170845',0,'2014-03-07 21:31:24',NULL,NULL),(20524,13212,'TE','3252458748',0,'2013-12-26 12:55:17',NULL,NULL),(31982,20880,'AP','4197331352',0,'2014-01-31 21:01:08',NULL,NULL),(28784,18573,'EM','DEBBIE@AKRONMED.COM',0,'2014-01-16 08:47:06',NULL,NULL),(28646,18473,'EM','sbilinovich@gmail.com',0,'2014-01-16 08:46:18',NULL,NULL),(26425,17004,'TE','7408158006',0,'2014-01-13 02:20:32',NULL,NULL),(8422,5544,'AP','3304648199',0,'2013-12-25 23:15:55',NULL,NULL),(25348,16347,'EM','shephard0128@live.com',0,'2014-01-07 04:02:24',NULL,NULL),(23865,15400,'EM','tamaranwilson@yahoo.com',1,'2014-01-02 04:26:46',NULL,NULL),(22876,14760,'TE','8178328199',1,'2013-12-29 11:12:40',NULL,NULL),(22480,14496,'TE','9565695921',0,'2013-12-28 03:33:39',NULL,NULL),(35272,23165,'AP','8322296484',0,'2014-02-12 21:31:49',NULL,NULL),(40976,27226,'TE','5043318439',0,'2014-03-03 21:31:38',NULL,NULL),(41399,27503,'TE','4199801332',0,'2014-03-04 21:02:29',NULL,NULL),(25776,16611,'TE','4409987448',0,'2014-01-08 18:24:08',NULL,NULL),(23524,15175,'AP','6145890208',0,'2014-01-01 12:06:42',NULL,NULL),(7461,4858,'TE','3185477759',0,'2013-12-25 22:30:35',NULL,NULL),(7278,4742,'EM','cornett_adam@yahoo.com',0,'2013-12-25 22:09:30',NULL,NULL),(35906,23625,'AP','3307279204',0,'2014-02-13 22:03:19',NULL,NULL),(40940,27203,'TE','5128046100',0,'2014-03-03 21:31:23',NULL,NULL),(8946,5855,'EM','glenhames1@gmail.com',0,'2013-12-25 23:48:54',NULL,NULL),(8271,5418,'AP','7692160246',0,'2013-12-25 23:09:19',NULL,NULL),(26617,17125,'EM','therese_watkins@yahoo.com',0,'2014-01-13 02:21:44',NULL,NULL),(1389,848,'EM','lydell@cox.net',0,'2013-12-25 18:06:49',NULL,NULL),(26165,16846,'EM','jplakosh@gmail.com',0,'2014-01-13 02:18:36',NULL,NULL),(34305,22510,'AP','4407875539',0,'2014-02-10 21:31:18',NULL,NULL),(39073,25842,'AP','3309361155',0,'2014-02-26 21:00:36',NULL,NULL),(40975,27225,'AP','2255715393',0,'2014-03-03 21:31:38',NULL,NULL),(42347,28124,'EM','berniel.berniel@gmail.com',0,'2014-03-06 21:02:22',NULL,NULL),(42640,28365,'AP','9038265793',0,'2014-03-07 21:30:31',NULL,NULL),(11633,7567,'AP','4192966842',0,'2013-12-26 02:33:40',NULL,NULL),(27626,17808,'AP','7138069228',0,'2014-01-15 02:05:52',NULL,NULL),(25907,16696,'TE','9565151561',0,'2014-01-08 18:24:37',NULL,NULL),(5373,3440,'TE','9378676077',0,'2013-12-25 21:19:12',NULL,NULL),(11316,7373,'TE','5132829856',0,'2013-12-26 02:15:44',NULL,NULL),(36537,24054,'AP','9376022128',0,'2014-02-15 22:01:06',NULL,NULL),(37050,24397,'AP','7403610928',0,'2014-02-18 22:00:53',NULL,NULL),(40886,27166,'AP','2104544057',0,'2014-03-03 21:31:02',NULL,NULL),(42642,28366,'TE','9039264735',0,'2014-03-07 21:30:32',NULL,NULL),(29870,19324,'TE','9365605518',1,'2014-01-22 03:22:13',NULL,NULL),(26000,16752,'TE','9563308903',0,'2014-01-08 18:24:55',NULL,NULL),(1895,1169,'TE','3186173178',0,'2013-12-25 18:19:06',NULL,NULL),(10145,6632,'TE','6148768191',0,'2013-12-26 01:00:03',NULL,NULL),(35170,23101,'TE','6199370037',0,'2014-02-12 21:31:12',NULL,NULL),(7853,5125,'AP','2108600102',0,'2013-12-25 23:02:04',NULL,NULL),(27101,17435,'AP','5132957010',0,'2014-01-13 03:00:33',NULL,NULL),(26778,17226,'AP','4193609025',0,'2014-01-13 02:22:37',NULL,NULL),(24883,16044,'TE','5124660341',0,'2014-01-04 02:02:57',NULL,NULL),(13686,8923,'TE','5138072099',0,'2013-12-26 04:02:50',NULL,NULL),(22141,14260,'TE','9855032517',0,'2013-12-27 02:05:47',NULL,NULL),(5272,3385,'AP','2816717356',0,'2013-12-25 21:17:38',NULL,NULL),(39194,25923,'TE','5127346904',0,'2014-02-26 21:01:22',NULL,NULL),(41708,27735,'TE','9152471187',0,'2014-03-05 21:31:06',NULL,NULL),(20436,13160,'AP','5133403437',0,'2013-12-26 12:53:50',NULL,NULL),(4022,2568,'EM','nady.el-zayaty@waldenu.edu',0,'2013-12-25 19:37:36',NULL,NULL),(31816,20773,'TE','9033532061',0,'2014-01-31 21:00:05',NULL,NULL),(7991,5215,'TE','5135022831',0,'2013-12-25 23:04:23',NULL,NULL),(23897,15416,'EM','victormvr20@gmail.com',1,'2014-01-02 04:27:19',NULL,NULL),(22407,14450,'TE','5044734897',0,'2013-12-28 03:32:28',NULL,NULL),(36184,23815,'AP','3307494618',0,'2014-02-14 21:31:37',NULL,NULL),(36746,24194,'TE','9375873813',0,'2014-02-16 19:00:14',NULL,NULL),(37758,24916,'TE','3306082423',0,'2014-02-20 21:30:11',NULL,NULL),(39474,26105,'EM','Jacob.Mattes@yahoo.com',0,'2014-02-28 06:30:14',NULL,NULL),(39833,26347,'TE','9372188423',0,'2014-02-28 06:31:46',NULL,NULL),(40875,27159,'AP','5122559517',0,'2014-03-03 21:30:58',NULL,NULL),(44007,29202,'TE','9012395771',0,'2014-03-10 21:30:11',NULL,NULL),(24851,16028,'AP','5043392493',0,'2014-01-04 02:02:23',NULL,NULL),(21886,14101,'AP','9375910728',0,'2013-12-27 02:01:35',NULL,NULL),(20767,13344,'TE','7137236437',0,'2013-12-26 12:59:01',NULL,NULL),(9925,6495,'EM','miawest34@yahoo.com',0,'2013-12-26 00:50:42',NULL,NULL),(6340,4086,'EM','kcron22@hotmail.com',0,'2013-12-25 21:47:19',NULL,NULL),(10742,6983,'TE','9373053034',0,'2013-12-26 01:47:47',NULL,NULL),(33338,21839,'TE','5139178334',0,'2014-02-06 21:01:09',NULL,NULL),(35108,23061,'TE','2256355363',0,'2014-02-12 21:30:51',NULL,NULL),(38223,25228,'BN','4196516886',0,'2014-02-21 22:01:01',NULL,NULL),(38886,25704,'TE','8176456875',0,'2014-02-26 09:30:20',NULL,NULL),(39088,25859,'AP','3182068452',0,'2014-02-26 21:00:44',NULL,NULL),(41969,27898,'AP','4193450177',0,'2014-03-05 21:32:44',NULL,NULL),(31967,20872,'AP','6013163209',0,'2014-01-31 21:01:03',NULL,NULL),(2294,1406,'AP','2259382453',0,'2013-12-25 18:46:45',NULL,NULL),(3031,1887,'TE','5135513064',0,'2013-12-25 18:58:44',NULL,NULL),(9964,6521,'AP','4196544446',0,'2013-12-26 00:51:24',NULL,NULL),(12170,7951,'TE','3182210513',0,'2013-12-26 03:07:10',NULL,NULL),(14208,9296,'EM','TAMMY7MCKINNEY@GMAIL.COM',0,'2013-12-26 04:16:16',NULL,NULL),(7192,4686,'TE','5135367323',0,'2013-12-25 22:08:03',NULL,NULL),(7210,4698,'TE','9373081184',0,'2013-12-25 22:08:21',NULL,NULL),(33574,22012,'AP','4405250785',0,'2014-02-07 19:00:52',NULL,NULL),(36407,23979,'TE','3108093805',0,'2014-02-15 22:00:19',NULL,NULL),(39730,26276,'EM','abbyford@flooringonewm.com',0,'2014-02-28 06:31:18',NULL,NULL),(42279,28078,'TE','8327464734',0,'2014-03-06 21:01:55',NULL,NULL),(42507,28269,'EM','esbc1office@verizon.net',0,'2014-03-07 21:00:21',NULL,NULL),(42770,28447,'TE','5042893656',0,'2014-03-07 21:31:17',NULL,NULL),(30376,19679,'TE','3254367103',0,'2014-01-23 21:00:37',NULL,NULL),(2632,1601,'EM','LIBBYTEXAS@YAHOO.COM',0,'2013-12-25 18:52:03',NULL,NULL),(13572,8849,'TE','9035372929',0,'2013-12-26 04:00:59',NULL,NULL),(34316,22514,'EM','barbarakwhitley@yahoo.com',0,'2014-02-10 21:31:21',NULL,NULL),(42632,28360,'EM','rwalkerep@yahoo.com',0,'2014-03-07 21:30:28',NULL,NULL),(43746,29039,'TE','9372446326',0,'2014-03-10 21:01:40',NULL,NULL),(32369,21148,'AP','2145784561',0,'2014-02-03 21:00:26',NULL,NULL),(25942,16712,'EM','Mojicaj81@gmail.com',0,'2014-01-08 18:24:43',NULL,NULL),(23818,15367,'TE','2167956230',1,'2014-01-02 04:24:58',NULL,NULL),(5889,3777,'AP','5135463331',0,'2013-12-25 21:33:53',NULL,NULL),(20452,13177,'EM','dolsheski@satx.rr.com',0,'2013-12-26 12:54:12',NULL,NULL),(5364,3435,'TE','5049094169',0,'2013-12-25 21:19:03',NULL,NULL),(37677,24845,'TE','3304729927',0,'2014-02-20 04:54:20',NULL,NULL),(42444,28190,'TE','6622468279',0,'2014-03-06 21:30:03',NULL,NULL),(30459,19747,'TE','9562072624',0,'2014-01-23 21:01:15',NULL,NULL),(1502,924,'TE','4405520000',0,'2013-12-25 18:08:57',NULL,NULL),(27241,17538,'TE','3307532932',0,'2014-01-13 03:01:46',NULL,NULL),(4248,2718,'AP','3379128949',0,'2013-12-25 19:48:08',NULL,NULL),(26491,17048,'EM','engmar1@hotmail.com',0,'2014-01-13 02:20:56',NULL,NULL),(38992,25785,'TE','3307030143',0,'2014-02-26 09:31:05',NULL,NULL),(40345,26776,'AP','9033436836',0,'2014-03-01 21:00:10',NULL,NULL),(41045,27268,'AP','3186502486',0,'2014-03-04 21:00:14',NULL,NULL),(9587,6276,'EM','randybryant0111@gmail.com',0,'2013-12-26 00:45:15',NULL,NULL),(20789,13361,'AP','6025026262',0,'2013-12-26 12:59:27',NULL,NULL),(24289,15694,'TE','4196933055',1,'2014-01-02 04:35:28',NULL,NULL),(7575,4930,'TE','4403530341',0,'2013-12-25 22:45:25',NULL,NULL),(5562,3553,'AP','2162801622',0,'2013-12-25 21:22:06',NULL,NULL),(21512,13827,'TE','3306359230',0,'2013-12-26 13:12:02',NULL,NULL),(21337,13711,'TE','4408713909',0,'2013-12-26 13:08:57',NULL,NULL),(35589,23406,'EM','WSTOCKTON5296@LIVE.COM',0,'2014-02-13 22:01:12',NULL,NULL),(37484,24682,'TE','9363682240',0,'2014-02-20 04:30:50',NULL,NULL),(38564,25486,'AP','7692166137',0,'2014-02-25 21:31:45',NULL,NULL),(41085,27290,'EM','wandahartley52@gmail.com',0,'2014-03-04 21:00:28',NULL,NULL),(41098,27299,'TE','2549816517',0,'2014-03-04 21:00:33',NULL,NULL),(13657,8905,'TE','9372588424',0,'2013-12-26 04:02:24',NULL,NULL),(7801,5090,'AP','3616875409',0,'2013-12-25 23:01:12',NULL,NULL),(30717,19957,'AP','9566246396',0,'2014-01-25 19:00:05',NULL,NULL),(979,601,'EM','aliciababy35@gmail.com',0,'2013-12-25 18:00:20',NULL,NULL),(9920,6493,'TE','4406288344',0,'2013-12-26 00:50:38',NULL,NULL),(5763,3691,'AP','4193413302',0,'2013-12-25 21:31:44',NULL,NULL),(2766,1677,'AP','3184236172',0,'2013-12-25 18:54:03',NULL,NULL),(5244,3368,'AP','8067312355',0,'2013-12-25 21:17:11',NULL,NULL),(29188,18857,'AP','5043398206',0,'2014-01-17 03:36:18',NULL,NULL),(4905,3150,'TE','2817015189',0,'2013-12-25 20:31:01',NULL,NULL),(25783,16614,'TE','3309802182',0,'2014-01-08 18:24:09',NULL,NULL),(25736,16586,'AP','5044447657',0,'2014-01-08 18:23:59',NULL,NULL),(32592,21309,'TE','5047337804',0,'2014-02-04 21:00:17',NULL,NULL),(33727,22128,'AP','5137487645',0,'2014-02-08 19:00:42',NULL,NULL),(31192,20314,'TE','8322842506',0,'2014-01-28 21:00:51',NULL,NULL),(14552,9507,'EM','luebbela@gmail.com',0,'2013-12-26 04:35:19',NULL,NULL),(27094,17426,'AP','3307016920',0,'2014-01-13 03:00:29',NULL,NULL),(22827,14722,'TE','3374578541',1,'2013-12-29 11:09:36',NULL,NULL),(4834,3094,'TE','4197521302',0,'2013-12-25 20:20:05',NULL,NULL),(11731,7635,'AP','9376076256',0,'2013-12-26 02:46:23',NULL,NULL),(31626,20630,'TE','4329408862',0,'2014-01-30 21:00:28',NULL,NULL),(38261,25258,'AP','3307361490',0,'2014-02-22 19:00:11',NULL,NULL),(40567,26926,'EM','garydinnell@centurylink.net',0,'2014-03-03 01:00:17',NULL,NULL),(43148,28679,'TE','4402135980',0,'2014-03-08 21:30:55',NULL,NULL),(6372,4105,'AP','8179628585',0,'2013-12-25 21:47:50',NULL,NULL),(31246,20349,'AP','9376029934',0,'2014-01-28 21:01:13',NULL,NULL),(29165,18843,'TE','3306500220',0,'2014-01-17 03:36:14',NULL,NULL),(28710,18526,'AP','8327444902',0,'2014-01-16 08:46:41',NULL,NULL),(13838,9023,'TE','3303224661',0,'2013-12-26 04:05:23',NULL,NULL),(10845,7040,'TE','3257269775',0,'2013-12-26 01:49:24',NULL,NULL),(12265,8020,'AP','5136465759',0,'2013-12-26 03:08:53',NULL,NULL),(26014,16760,'TE','3306082644',0,'2014-01-08 18:24:58',NULL,NULL),(20368,13120,'AP','5137066543',0,'2013-12-26 12:52:44',NULL,NULL),(25803,16629,'TE','5132930683',0,'2014-01-08 18:24:14',NULL,NULL),(21772,14028,'TE','2162725627',0,'2013-12-26 13:16:48',NULL,NULL),(22570,14554,'TE','3308829460',0,'2013-12-28 03:35:08',NULL,NULL),(22776,14684,'TE','4405482930',1,'2013-12-29 11:08:40',NULL,NULL),(41741,27756,'TE','5042488703',0,'2014-03-05 21:31:18',NULL,NULL),(43538,28905,'TE','5123034242',0,'2014-03-10 21:00:24',NULL,NULL),(43755,29048,'AP','4408231147',0,'2014-03-10 21:01:44',NULL,NULL),(43787,29067,'TE','4192830969',0,'2014-03-10 21:01:55',NULL,NULL),(43910,29131,'BN','9379253641',0,'2014-03-10 21:02:37',NULL,NULL),(43924,29139,'AP','7279926027',0,'2014-03-10 21:02:42',NULL,NULL),(71,45,'AP','6018262442',0,'2013-12-25 17:16:12',NULL,NULL),(5968,3834,'TE','3302086027',0,'2013-12-25 21:35:12',NULL,NULL),(14622,9558,'EM','sidneyhorner5111@yahoo.com',0,'2013-12-26 04:36:30',NULL,NULL),(11029,7159,'TE','4194870366',0,'2013-12-26 01:52:24',NULL,NULL),(7244,4721,'AP','5136148859',0,'2013-12-25 22:08:57',NULL,NULL),(2864,1751,'TE','4192296000',0,'2013-12-25 18:55:43',NULL,NULL),(1828,1131,'TE','8304884685',0,'2013-12-25 18:18:04',NULL,NULL),(24803,16002,'TE','9039344386',0,'2014-01-04 02:01:32',NULL,NULL),(547,342,'TE','7405726676',0,'2013-12-25 17:31:59',NULL,NULL),(1208,737,'TE','9402285544',0,'2013-12-25 18:03:57',NULL,NULL),(6036,3877,'TE','3375605071',0,'2013-12-25 21:36:21',NULL,NULL),(11325,7377,'AP','4405253667',0,'2013-12-26 02:15:51',NULL,NULL),(12140,7930,'EM','gadglenda@yahoo.com',0,'2013-12-26 03:06:36',NULL,NULL),(37735,24885,'AP','5134843500',0,'2014-02-20 05:37:43',NULL,NULL),(25245,16280,'TE','5133768955',0,'2014-01-07 04:00:30',NULL,NULL),(5248,3370,'TE','2149911427',0,'2013-12-25 21:17:14',NULL,NULL),(3568,2233,'EM','clarkjc11@gmail.com',0,'2013-12-25 19:20:51',NULL,NULL),(2184,1344,'TE','5126800562',0,'2013-12-25 18:45:03',NULL,NULL),(5220,3355,'AP','2406453464',0,'2013-12-25 21:16:50',NULL,NULL),(34374,22548,'TE','9852273915',0,'2014-02-10 21:31:43',NULL,NULL),(36262,23867,'TE','4198935483',0,'2014-02-14 21:32:07',NULL,NULL),(41775,27775,'AP','3304144626',0,'2014-03-05 21:31:30',NULL,NULL),(42650,28372,'TE','5132271358',0,'2014-03-07 21:30:35',NULL,NULL),(42870,28510,'TE','3306712007',0,'2014-03-07 21:31:54',NULL,NULL),(24583,15855,'EM','ds1goddess@gmail.com',0,'2014-01-03 02:04:34',NULL,NULL),(20191,13008,'AP','5133140487',0,'2013-12-26 12:49:43',NULL,NULL),(7588,4941,'AP','2164088279',0,'2013-12-25 22:45:41',NULL,NULL),(22487,14499,'EM','Fayaor@gmail.com',0,'2013-12-28 03:33:45',NULL,NULL),(21583,13880,'EM','riehmhouse@sbcglobal.net',0,'2013-12-26 13:13:18',NULL,NULL),(32382,21159,'TE','4193412580',0,'2014-02-03 21:00:32',NULL,NULL),(37470,24676,'TE','4192317429',0,'2014-02-20 04:28:40',NULL,NULL),(1142,703,'TE','5042581293',0,'2013-12-25 18:02:57',NULL,NULL),(11924,7761,'TE','5138349825',0,'2013-12-26 03:02:46',NULL,NULL),(31373,20451,'TE','7403541073',0,'2014-01-29 21:00:45',NULL,NULL),(31360,20438,'AP','5133447359',0,'2014-01-29 21:00:39',NULL,NULL),(3095,1932,'TE','9794798080',0,'2013-12-25 19:00:26',NULL,NULL),(3022,1883,'TE','4196904827',0,'2013-12-25 18:58:36',NULL,NULL),(26462,17033,'EM','ahebert6@its.nicholls.edu',0,'2014-01-13 02:20:46',NULL,NULL),(26770,17222,'EM','becca5645@live.com',0,'2014-01-13 02:22:34',NULL,NULL),(36133,23780,'AP','2283265508',0,'2014-02-14 21:31:19',NULL,NULL),(39425,26071,'TE','3305441326',0,'2014-02-26 21:02:45',NULL,NULL),(40351,26779,'AP','9032272343',0,'2014-03-01 21:00:12',NULL,NULL),(43265,28745,'AP','3375324709',0,'2014-03-09 21:00:13',NULL,NULL),(8411,5538,'EM','jaksinn@gmail.com',0,'2013-12-25 23:15:44',NULL,NULL),(7705,5031,'TE','4192367632',0,'2013-12-25 22:47:45',NULL,NULL),(7567,4926,'EM','melisa242@yahoo.com',0,'2013-12-25 22:45:18',NULL,NULL),(14966,9791,'AP','5042433052',0,'2013-12-26 05:00:59',NULL,NULL),(14582,9535,'TE','3302962033',0,'2013-12-26 04:35:54',NULL,NULL),(9743,6372,'EM','dbailey15@woh.rr.com',0,'2013-12-26 00:47:41',NULL,NULL),(30289,19622,'AP','3302413697',0,'2014-01-23 21:00:05',NULL,NULL),(25586,16503,'BN','4403444421',0,'2014-01-07 04:06:56',NULL,NULL),(32377,21157,'TE','5133308028',0,'2014-02-03 21:00:30',NULL,NULL),(36093,23738,'TE','2167025571',0,'2014-02-14 21:31:02',NULL,NULL),(36273,23879,'AP','4408236043',0,'2014-02-14 21:32:13',NULL,NULL),(37232,24502,'TE','9564598149',0,'2014-02-20 03:49:33',NULL,NULL),(37940,25032,'EM','jennifer.ellzey1@yahoo.com',0,'2014-02-20 22:01:04',NULL,NULL),(40595,26948,'TE','9378305215',0,'2014-03-03 01:00:25',NULL,NULL),(42657,28379,'AP','3304596400',0,'2014-03-07 21:30:38',NULL,NULL),(920,568,'AP','9379441614',0,'2013-12-25 17:50:31',NULL,NULL),(14098,9217,'AP','4192695410',0,'2013-12-26 04:10:06',NULL,NULL),(7465,4859,'AP','3373519748',0,'2013-12-25 22:30:38',NULL,NULL),(28134,18136,'EM','nolaboy422@gmail.com',0,'2014-01-15 02:07:45',NULL,NULL),(26332,16950,'AP','6628226149',0,'2014-01-13 02:20:00',NULL,NULL),(20756,13339,'EM','edkeezer@sbcglobal.net',0,'2013-12-26 12:58:51',NULL,NULL),(32068,20939,'TE','5137350453',0,'2014-01-31 21:01:42',NULL,NULL),(38040,25098,'EM','atilio.zavala@sbcglobal.net',0,'2014-02-21 21:30:09',NULL,NULL),(29822,19295,'TE','3184390467',1,'2014-01-22 03:21:57',NULL,NULL),(23112,14900,'EM','erosenberg87@gmail.com',0,'2013-12-30 00:01:06',NULL,NULL),(5946,3817,'TE','7408568369',0,'2013-12-25 21:34:51',NULL,NULL),(10443,6806,'TE','8063177261',0,'2013-12-26 01:30:09',NULL,NULL),(34769,22805,'AP','3038189875',0,'2014-02-11 21:01:54',NULL,NULL),(39155,25899,'AP','4326318209',0,'2014-02-26 21:01:07',NULL,NULL),(12185,7962,'TE','6018578929',0,'2013-12-26 03:07:28',NULL,NULL),(31171,20300,'TE','3374058145',0,'2014-01-28 21:00:43',NULL,NULL),(8595,5649,'EM','p.neal11@yahoo.com',0,'2013-12-25 23:31:27',NULL,NULL),(27636,17813,'EM','jacobrsilva@gmail.com',0,'2014-01-15 02:05:53',NULL,NULL),(6566,4239,'AP','7136287739',0,'2013-12-25 21:50:59',NULL,NULL),(26750,17206,'TE','3306992408',0,'2014-01-13 02:22:27',NULL,NULL),(11152,7251,'EM','LISAALLEN652003@YAHOO.COM',0,'2013-12-26 02:01:56',NULL,NULL),(26488,17047,'TE','3307257029',0,'2014-01-13 02:20:55',NULL,NULL),(31740,20713,'EM','saracastillo3080@yahoo.com',0,'2014-01-30 21:01:10',NULL,NULL),(12133,7928,'AP','5046553895',0,'2013-12-26 03:06:32',NULL,NULL),(8393,5524,'AP','6145982219',0,'2013-12-25 23:15:24',NULL,NULL),(4536,2883,'AP','4199530250',0,'2013-12-25 20:02:18',NULL,NULL),(29600,19126,'TE','6145167497',0,'2014-01-21 08:45:20',NULL,NULL),(29358,18970,'TE','4403436865',0,'2014-01-20 08:06:01',NULL,NULL),(29126,18811,'TE','4197787210',0,'2014-01-17 03:36:03',NULL,NULL),(33209,21747,'TE','9157400388',0,'2014-02-06 21:00:19',NULL,NULL),(37467,24674,'EM','ruggersarge@yahoo.com',0,'2014-02-20 04:28:10',NULL,NULL),(40109,26598,'AP','5127888598',0,'2014-02-28 21:30:40',NULL,NULL),(41019,27255,'TE','9373734415',0,'2014-03-03 21:31:56',NULL,NULL),(30783,20015,'EM','uzmach@gmail.com',0,'2014-01-26 19:00:11',NULL,NULL),(8527,5604,'TE','6148686845',0,'2013-12-25 23:30:21',NULL,NULL),(29230,18879,'AP','3374143176',0,'2014-01-17 03:36:27',NULL,NULL),(20559,13233,'TE','7138228143',0,'2013-12-26 12:55:49',NULL,NULL),(1387,848,'TE','2254546457',0,'2013-12-25 18:06:48',NULL,NULL),(10647,6923,'AP','5133156165',0,'2013-12-26 01:46:17',NULL,NULL),(23193,14946,'EM','mamabascal@aol.com',0,'2014-01-01 12:00:03',NULL,NULL),(24197,15633,'AP','2252472791',1,'2014-01-02 04:33:32',NULL,NULL),(34524,22649,'AP','2149911577',0,'2014-02-11 21:00:26',NULL,NULL),(37334,24580,'AP','3308067219',0,'2014-02-20 04:08:37',NULL,NULL),(39161,25902,'EM','cat00a@hotmail.com',0,'2014-02-26 21:01:09',NULL,NULL),(40810,27118,'AP','4404742334',0,'2014-03-03 21:30:32',NULL,NULL),(320,199,'TE','9372717177',0,'2013-12-25 17:20:09',NULL,NULL),(31317,20407,'TE','9036942169',0,'2014-01-29 21:00:23',NULL,NULL),(24947,16080,'AP','4407150349',0,'2014-01-04 02:04:06',NULL,NULL),(22664,14613,'EM','donnastamps@bellsouth.net',0,'2013-12-28 03:36:44',NULL,NULL),(2987,1850,'TE','3308368324',0,'2013-12-25 18:57:53',NULL,NULL),(36393,23970,'TE','2816870722',0,'2014-02-15 22:00:13',NULL,NULL),(41159,27336,'TE','4403877951',0,'2014-03-04 21:00:56',NULL,NULL),(29185,18855,'AP','5134006870',0,'2014-01-17 03:36:18',NULL,NULL),(28246,18214,'AP','4193027695',0,'2014-01-15 02:08:11',NULL,NULL),(7342,4773,'TE','5139220922',0,'2013-12-25 22:15:53',NULL,NULL),(27678,17840,'AP','7407011338',0,'2014-01-15 02:06:03',NULL,NULL),(27801,17918,'EM','MARIBEL_SILVA@HOTMAIL.COM',0,'2014-01-15 02:06:30',NULL,NULL),(27843,17938,'TE','2146428639',0,'2014-01-15 02:06:38',NULL,NULL),(35535,23370,'TE','2163128653',0,'2014-02-13 22:00:53',NULL,NULL),(38399,25367,'AP','5134329401',0,'2014-02-25 21:30:39',NULL,NULL),(40204,26668,'TE','5042366428',0,'2014-02-28 21:31:16',NULL,NULL),(40312,26742,'EM','kjsupe@gmail.com',0,'2014-02-28 21:31:56',NULL,NULL),(40878,27161,'TE','9036030071',0,'2014-03-03 21:30:59',NULL,NULL),(43667,28980,'AP','3306896324',0,'2014-03-10 21:01:08',NULL,NULL),(32387,21161,'TE','5135518881',0,'2014-02-03 21:00:33',NULL,NULL),(2296,1407,'TE','5042754965',0,'2013-12-25 18:46:47',NULL,NULL),(7844,5119,'TE','8065950331',0,'2013-12-25 23:01:54',NULL,NULL),(1819,1127,'TE','9725521281',0,'2013-12-25 18:17:57',NULL,NULL),(31512,20533,'EM','j00040758@gmail.com',0,'2014-01-29 21:01:32',NULL,NULL),(26051,16781,'AP','5676445157',0,'2014-01-08 18:25:06',NULL,NULL),(34008,22308,'TE','6019133288',0,'2014-02-10 11:00:42',NULL,NULL),(34680,22741,'TE','5043121561',0,'2014-02-11 21:01:20',NULL,NULL),(37638,24809,'TE','6143138857',0,'2014-02-20 04:49:27',NULL,NULL),(38730,25601,'AP','9852328829',0,'2014-02-26 08:00:51',NULL,NULL),(40639,26972,'EM','maynard.randles@yahoo.com',0,'2014-03-03 01:00:35',NULL,NULL),(40939,27202,'TE','2143742122',0,'2014-03-03 21:31:23',NULL,NULL),(41202,27365,'AP','9378388672',0,'2014-03-04 21:01:13',NULL,NULL),(41477,27567,'AP','4402512222',0,'2014-03-04 21:30:19',NULL,NULL),(42717,28414,'TE','5135318944',0,'2014-03-07 21:30:58',NULL,NULL),(43467,28867,'EM','KFAYEB@YAHOO.COM',0,'2014-03-10 21:00:00',NULL,NULL),(11313,7371,'AP','5132829856',0,'2013-12-26 02:15:41',NULL,NULL),(31742,20714,'AP','5042309431',0,'2014-01-30 21:01:10',NULL,NULL),(25855,16665,'EM','gerri.d.costa@gmail.com',0,'2014-01-08 18:24:26',NULL,NULL),(10379,6764,'EM','badams@kaplantel.net',0,'2013-12-26 01:16:26',NULL,NULL),(25808,16632,'AP','9377184340',0,'2014-01-08 18:24:15',NULL,NULL),(3322,2089,'AP','9857503273',0,'2013-12-25 19:16:50',NULL,NULL),(21941,14134,'TE','5048813213',0,'2013-12-27 02:02:29',NULL,NULL),(38818,25663,'TE','2255738301',0,'2014-02-26 08:30:46',NULL,NULL),(41176,27346,'EM','kahjjhansen@yahoo.com',0,'2014-03-04 21:01:02',NULL,NULL),(649,403,'AP','6148060734',0,'2013-12-25 17:46:13',NULL,NULL),(29738,19228,'EM','the4thson@outlook.com',0,'2014-01-21 08:46:31',NULL,NULL),(29481,19055,'EM','butlerchristy@msn.com',0,'2014-01-21 08:44:11',NULL,NULL),(28862,18637,'AP','8065591407',0,'2014-01-17 03:35:04',NULL,NULL),(21335,13709,'EM','Faith_Weihe@yahoo.com',0,'2013-12-26 13:08:54',NULL,NULL),(2701,1642,'TE','9567467940',0,'2013-12-25 18:53:06',NULL,NULL),(14245,9318,'EM','chewcooper@yahoo.com',0,'2013-12-26 04:30:27',NULL,NULL),(25656,16543,'BN','9405947328',1,'2014-01-07 10:22:28',NULL,NULL),(4698,3005,'TE','4198946778',0,'2013-12-25 20:17:46',NULL,NULL),(22953,14806,'AP','5049527009',1,'2013-12-29 11:13:55',NULL,NULL),(12468,8164,'TE','5137326466',0,'2013-12-26 03:16:27',NULL,NULL),(40746,27079,'AP','4404634709',0,'2014-03-03 21:30:10',NULL,NULL),(10221,6681,'TE','6145991196',0,'2013-12-26 01:01:24',NULL,NULL),(32749,21426,'AP','5132589243',0,'2014-02-04 21:01:15',NULL,NULL),(31674,20663,'EM','Haileymaleik6@aol.com',0,'2014-01-30 21:00:45',NULL,NULL),(27182,17502,'EM','nora44889@yahoo.com',0,'2014-01-13 03:01:26',NULL,NULL),(34909,22906,'AP','4199136458',0,'2014-02-11 21:02:45',NULL,NULL),(36248,23855,'EM','GSCORCE@GMAIL.COM',0,'2014-02-14 21:32:01',NULL,NULL),(38365,25341,'AP','2257721396',0,'2014-02-25 21:30:25',NULL,NULL),(39177,25914,'TE','9037140341',0,'2014-02-26 21:01:16',NULL,NULL),(39813,26328,'EM','yong168@att.net',0,'2014-02-28 06:31:39',NULL,NULL),(40363,26790,'EM','Rarichoux@gmail.com',0,'2014-03-01 21:00:18',NULL,NULL),(42607,28345,'AP','4324254035',0,'2014-03-07 21:30:20',NULL,NULL),(12048,7863,'AP','3305543065',0,'2013-12-26 03:05:03',NULL,NULL),(10296,6719,'EM','dmb0825@gmail.com',0,'2013-12-26 01:15:09',NULL,NULL),(6463,4176,'EM','quinn4qb@yahoo.com',0,'2013-12-25 21:49:22',NULL,NULL),(31609,20618,'TE','3186351819',0,'2014-01-30 21:00:22',NULL,NULL),(24899,16051,'TE','5136041685',0,'2014-01-04 02:03:12',NULL,NULL),(25162,16220,'TE','4402555640',0,'2014-01-05 00:01:47',NULL,NULL),(25191,16241,'EM','pfsrvp1@yahoo.com',0,'2014-01-05 00:02:25',NULL,NULL),(31029,20188,'TE','9724679122',0,'2014-01-27 21:01:24',NULL,NULL),(35094,23052,'TE','5044683341',0,'2014-02-12 21:30:46',NULL,NULL),(31362,20439,'TE','5132379082',0,'2014-01-29 21:00:39',NULL,NULL),(25688,16561,'TE','4197954281',1,'2014-01-07 10:23:04',NULL,NULL),(23230,14970,'TE','9562120661',0,'2014-01-01 12:00:47',NULL,NULL),(33499,21954,'TE','2162697595',0,'2014-02-07 19:00:22',NULL,NULL),(29084,18784,'TE','4404792925',0,'2014-01-17 03:35:54',NULL,NULL),(1484,911,'AP','4193511557',0,'2013-12-25 18:08:34',NULL,NULL),(1592,982,'TE','2814654664',0,'2013-12-25 18:10:20',NULL,NULL),(27591,17788,'AP','9375157480',0,'2014-01-14 01:33:46',NULL,NULL),(24290,15695,'TE','4193502409',1,'2014-01-02 04:35:30',NULL,NULL),(10503,6840,'EM','gordy318@gmail.com',0,'2013-12-26 01:31:05',NULL,NULL),(8748,5735,'EM','nola_hustle@yahoo.com',0,'2013-12-25 23:45:47',NULL,NULL),(9282,6079,'TE','4192022706',0,'2013-12-26 00:02:25',NULL,NULL),(3683,2337,'EM','lc_lt@yahoo.com',0,'2013-12-25 19:31:50',NULL,NULL),(34851,22851,'EM','mattntiffany@bright.net',0,'2014-02-11 21:02:21',NULL,NULL),(24759,15974,'AP','9562715681',0,'2014-01-04 02:00:42',NULL,NULL),(10594,6894,'TE','2252881054',0,'2013-12-26 01:45:28',NULL,NULL),(9544,6248,'TE','2254851600',0,'2013-12-26 00:31:52',NULL,NULL),(8224,5384,'TE','5048137169',0,'2013-12-25 23:08:26',NULL,NULL),(5398,3454,'AP','5132254569',0,'2013-12-25 21:19:36',NULL,NULL),(12159,7943,'AP','9856305493',0,'2013-12-26 03:06:57',NULL,NULL),(35489,23335,'EM','dhandel1@hotmail.com',0,'2014-02-13 22:00:34',NULL,NULL),(38200,25215,'TE','9373465494',0,'2014-02-21 22:00:53',NULL,NULL),(28287,18235,'EM','stdamc46@shsu.edu',0,'2014-01-16 08:44:22',NULL,NULL),(6353,4093,'AP','6012788934',0,'2013-12-25 21:47:31',NULL,NULL),(23267,14991,'TE','9032676640',0,'2014-01-01 12:01:25',NULL,NULL),(34459,22610,'AP','5127058219',0,'2014-02-11 21:00:04',NULL,NULL),(5934,3805,'TE','4402512222',0,'2013-12-25 21:34:38',NULL,NULL),(6424,4151,'EM','jennifer43022@yahoo.com',0,'2013-12-25 21:48:46',NULL,NULL),(23540,15192,'AP','7657175461',0,'2014-01-01 12:07:08',NULL,NULL),(25034,16132,'EM','kridavjelly@gmail.com',0,'2014-01-04 02:05:45',NULL,NULL),(32292,21093,'AP','4195167649',0,'2014-02-02 19:00:29',NULL,NULL),(37802,24948,'TE','3379374864',0,'2014-02-20 22:00:09',NULL,NULL),(40525,26897,'BN','8329646161',0,'2014-03-03 01:00:06',NULL,NULL),(43939,29147,'TE','5132815332',0,'2014-03-10 21:02:46',NULL,NULL),(8158,5339,'TE','9375208110',0,'2013-12-25 23:07:18',NULL,NULL),(14667,9596,'TE','4403194436',0,'2013-12-26 04:37:18',NULL,NULL),(10798,7017,'EM','ablanco111979@hotmail.com',0,'2013-12-26 01:48:43',NULL,NULL),(14557,9512,'TE','6142365526',0,'2013-12-26 04:35:26',NULL,NULL),(38798,25650,'EM','anna_l71@yahoo.com',0,'2014-02-26 08:30:38',NULL,NULL),(43262,28744,'AP','3186172874',0,'2014-03-09 21:00:12',NULL,NULL),(10341,6742,'AP','4404653423',0,'2013-12-26 01:15:48',NULL,NULL),(31507,20530,'AP','6019069675',0,'2014-01-29 21:01:30',NULL,NULL),(29451,19043,'AP','7133205831',0,'2014-01-20 08:06:38',NULL,NULL),(28282,18234,'TE','9404953803',0,'2014-01-16 08:44:21',NULL,NULL),(27468,17695,'AP','5042756480',0,'2014-01-14 01:33:01',NULL,NULL),(1874,1156,'TE','2254506195',0,'2013-12-25 18:18:47',NULL,NULL),(22593,14572,'TE','4195316335',0,'2013-12-28 03:35:34',NULL,NULL),(24917,16062,'AP','4192774932',0,'2014-01-04 02:03:33',NULL,NULL),(23568,15215,'TE','9374920772',0,'2014-01-01 12:07:50',NULL,NULL),(34346,22532,'AP','6012917734',0,'2014-02-10 21:31:33',NULL,NULL),(4945,3175,'TE','4194220149',0,'2013-12-25 20:31:40',NULL,NULL),(39233,25951,'BN','6145723146',0,'2014-02-26 21:01:37',NULL,NULL),(39636,26210,'AP','4196510856',0,'2014-02-28 06:30:53',NULL,NULL),(40601,26952,'TE','4198414134',0,'2014-03-03 01:00:27',NULL,NULL),(40776,27100,'TE','3306344893',0,'2014-03-03 21:30:21',NULL,NULL),(25223,16264,'TE','3304959165',0,'2014-01-07 04:00:06',NULL,NULL),(22833,14728,'TE','2257733411',1,'2013-12-29 11:09:44',NULL,NULL),(8975,5883,'EM','mmurphy828@gmail.com',0,'2013-12-25 23:49:29',NULL,NULL),(22707,14644,'TE','5127996622',1,'2013-12-29 11:07:32',NULL,NULL),(8899,5828,'TE','9567925068',0,'2013-12-25 23:48:12',NULL,NULL),(38155,25182,'AP','4408674470',0,'2014-02-21 22:00:35',NULL,NULL),(40095,26589,'AP','2162464631',0,'2014-02-28 21:30:35',NULL,NULL),(40096,26590,'TE','4407252796',0,'2014-02-28 21:30:36',NULL,NULL),(41277,27427,'AP','2257763441',0,'2014-03-04 21:01:44',NULL,NULL),(43613,28953,'TE','5047290565',0,'2014-03-10 21:00:51',NULL,NULL),(29844,19309,'TE','4326347618',1,'2014-01-22 03:22:05',NULL,NULL),(11270,7348,'TE','8188078202',0,'2013-12-26 02:04:10',NULL,NULL),(6726,4371,'TE','6142862357',0,'2013-12-25 22:00:18',NULL,NULL),(37703,24859,'EM','gswing14@hotmail.com',0,'2014-02-20 04:56:51',NULL,NULL),(39089,25862,'TE','9852151403',0,'2014-02-26 21:00:46',NULL,NULL),(39493,26122,'TE','3306012835',0,'2014-02-28 06:30:19',NULL,NULL),(41885,27851,'AP','9563585457',0,'2014-03-05 21:32:13',NULL,NULL),(42559,28319,'AP','2103911739',0,'2014-03-07 21:30:04',NULL,NULL),(43460,28862,'TE','5043018988',0,'2014-03-09 21:30:04',NULL,NULL),(27022,17377,'EM','hhtohio@sssnet.com',0,'2014-01-13 03:00:04',NULL,NULL),(23189,14944,'AP','4195770358',0,'2013-12-30 00:02:26',NULL,NULL),(5253,3372,'EM','hngreen411@gmail.com',0,'2013-12-25 21:17:18',NULL,NULL),(5284,3389,'EM','enochthejeweler@gmail.com',0,'2013-12-25 21:17:47',NULL,NULL),(38812,25660,'TE','3304682940',0,'2014-02-26 08:30:44',NULL,NULL),(23841,15383,'TE','3304143243',1,'2014-01-02 04:25:29',NULL,NULL),(34715,22762,'TE','5136208503',0,'2014-02-11 21:01:33',NULL,NULL),(30263,19607,'EM','jethridge1964@yahoo.com',0,'2014-01-23 03:02:49',NULL,NULL),(25027,16130,'AP','3303388713',0,'2014-01-04 02:05:39',NULL,NULL),(20278,13070,'AP','2164108431',0,'2013-12-26 12:51:17',NULL,NULL),(11175,7268,'TE','2546340050',0,'2013-12-26 02:02:20',NULL,NULL),(2990,1851,'TE','5134791955',0,'2013-12-25 18:57:55',NULL,NULL),(5090,3266,'EM','perkinstheresa@yahoo.com',0,'2013-12-25 20:47:04',NULL,NULL),(3600,2267,'EM','daltonbulldog@att.net',0,'2013-12-25 19:30:20',NULL,NULL),(32684,21380,'TE','5132958628',0,'2014-02-04 21:00:52',NULL,NULL),(21513,13827,'AP','3306359230',0,'2013-12-26 13:12:02',NULL,NULL),(10030,6560,'EM','o.marina_h@yahoo.com',0,'2013-12-26 00:52:25',NULL,NULL),(4535,2883,'TE','4199530250',0,'2013-12-25 20:02:18',NULL,NULL),(34032,22318,'TE','9856490209',0,'2014-02-10 11:00:51',NULL,NULL),(37176,24472,'TE','4198331842',0,'2014-02-18 22:01:39',NULL,NULL),(31528,20546,'TE','4194475074',0,'2014-01-29 21:01:39',NULL,NULL),(515,324,'TE','4194388694',0,'2013-12-25 17:31:26',NULL,NULL),(12264,8020,'TE','5136465759',0,'2013-12-26 03:08:53',NULL,NULL),(12114,7918,'EM','chinafaerie@live.com',0,'2013-12-26 03:06:15',NULL,NULL),(27071,17410,'AP','9032098040',0,'2014-01-13 03:00:22',NULL,NULL),(11346,7390,'TE','3308724026',0,'2013-12-26 02:16:09',NULL,NULL),(23164,14930,'AP','8324551719',0,'2013-12-30 00:01:59',NULL,NULL),(10312,6727,'EM','Nickscar33@gmail.com',0,'2013-12-26 01:15:24',NULL,NULL),(4894,3140,'TE','2814827262',0,'2013-12-25 20:30:47',NULL,NULL),(36332,23928,'AP','3303522477',0,'2014-02-14 22:00:10',NULL,NULL),(41796,27786,'TE','6627542449',0,'2014-03-05 21:31:37',NULL,NULL),(42970,28575,'AP','8304219520',0,'2014-03-08 21:00:04',NULL,NULL),(43343,28790,'EM','kev861@yahoo.com',0,'2014-03-09 21:00:42',NULL,NULL),(32615,21326,'TE','9857892611',0,'2014-02-04 21:00:25',NULL,NULL),(7416,4821,'EM','avellana63@yahoo.com',0,'2013-12-25 22:17:06',NULL,NULL),(1135,697,'EM','charlie_diana@yahoo.com',0,'2013-12-25 18:02:48',NULL,NULL),(7824,5107,'TE','9155884374',0,'2013-12-25 23:01:36',NULL,NULL),(28394,18294,'TE','5133479599',0,'2014-01-16 08:44:54',NULL,NULL),(14641,9579,'TE','2163811591',0,'2013-12-26 04:36:51',NULL,NULL),(11022,7154,'EM','MIDREA01@GMAIL.COM',0,'2013-12-26 01:52:17',NULL,NULL),(28371,18279,'AP','8066261822',0,'2014-01-16 08:44:46',NULL,NULL),(5328,3414,'AP','5042591652',0,'2013-12-25 21:18:28',NULL,NULL),(21972,14154,'AP','6467869980',0,'2013-12-27 02:02:59',NULL,NULL),(34896,22900,'TE','7852824836',0,'2014-02-11 21:02:41',NULL,NULL),(40520,26894,'TE','2813440547',0,'2014-03-03 01:00:04',NULL,NULL),(41340,27463,'EM','mcinnes1942@yahoo.com',0,'2014-03-04 21:02:07',NULL,NULL),(29929,19369,'TE','3309282883',1,'2014-01-22 03:22:35',NULL,NULL),(7039,4597,'TE','4403285237',0,'2013-12-25 22:05:37',NULL,NULL),(1839,1137,'EM','candler@suddenlink.net',0,'2013-12-25 18:18:14',NULL,NULL),(2384,1450,'TE','5133850099',0,'2013-12-25 18:48:05',NULL,NULL),(2445,1498,'TE','5132844030',0,'2013-12-25 18:49:14',NULL,NULL),(6313,4067,'EM','sbll1616@yahoo.com',0,'2013-12-25 21:46:51',NULL,NULL),(14064,9193,'AP','4197877131',0,'2013-12-26 04:09:27',NULL,NULL),(14873,9735,'TE','8327442761',0,'2013-12-26 04:45:47',NULL,NULL),(29368,18975,'AP','4152542744',0,'2014-01-20 08:06:04',NULL,NULL),(27561,17763,'TE','9377834323',0,'2014-01-14 01:33:34',NULL,NULL),(41662,27695,'TE','9564339035',0,'2014-03-05 21:30:46',NULL,NULL),(43484,28876,'AP','2542953202',0,'2014-03-10 21:00:06',NULL,NULL),(22565,14552,'TE','3307019823',0,'2013-12-28 03:35:04',NULL,NULL),(22184,14291,'TE','3305923629',0,'2013-12-27 02:06:35',NULL,NULL),(31173,20302,'TE','8176290722',0,'2014-01-28 21:00:44',NULL,NULL),(29790,19266,'EM','captsavva@att.net',0,'2014-01-21 08:46:52',NULL,NULL),(11012,7148,'TE','2812596807',0,'2013-12-26 01:52:08',NULL,NULL),(7969,5201,'TE','3303260129',0,'2013-12-25 23:04:01',NULL,NULL),(34999,22980,'EM','devinholm27@gmail.com',0,'2014-02-12 21:30:08',NULL,NULL),(37698,24855,'AP','5139230015',0,'2014-02-20 04:56:10',NULL,NULL),(39886,26393,'TE','4404767132',0,'2014-02-28 07:00:27',NULL,NULL),(20271,13066,'TE','9377608808',0,'2013-12-26 12:51:10',NULL,NULL),(9433,6174,'TE','9374425707',0,'2013-12-26 00:17:09',NULL,NULL),(14226,9309,'TE','3376268478',0,'2013-12-26 04:30:12',NULL,NULL),(28584,18426,'BN','3185177836',0,'2014-01-16 08:45:55',NULL,NULL),(12300,8044,'EM','DRUMMER623@ATT.NET',0,'2013-12-26 03:09:30',NULL,NULL),(11963,7796,'TE','4325387022',0,'2013-12-26 03:03:32',NULL,NULL),(23934,15443,'EM','Patsybean@hotmail.com',1,'2014-01-02 04:28:08',NULL,NULL),(28494,18359,'EM','rmarmer1@yahoo.com',0,'2014-01-16 08:45:26',NULL,NULL),(26813,17245,'TE','4196688422',0,'2014-01-13 02:22:48',NULL,NULL),(33714,22115,'TE','5127209087',0,'2014-02-08 19:00:37',NULL,NULL),(43120,28666,'TE','3183449443',0,'2014-03-08 21:30:46',NULL,NULL),(401,247,'TE','4194389189',0,'2013-12-25 17:21:28',NULL,NULL),(21421,13772,'TE','6018576088',0,'2013-12-26 13:10:32',NULL,NULL),(20738,13329,'AP','2102194601',0,'2013-12-26 12:58:34',NULL,NULL),(1249,759,'TE','8176891383',0,'2013-12-25 18:04:31',NULL,NULL),(20635,13274,'TE','2814033470',0,'2013-12-26 12:56:59',NULL,NULL),(8110,5310,'TE','6622725160',0,'2013-12-25 23:06:33',NULL,NULL),(7974,5202,'EM','LRandall@cloverleaf.org',0,'2013-12-25 23:04:04',NULL,NULL),(5073,3259,'TE','9406343868',0,'2013-12-25 20:46:48',NULL,NULL),(11572,7530,'TE','2813647083',0,'2013-12-26 02:32:39',NULL,NULL),(35051,23017,'EM','cyndipmix@yahoo.com',0,'2014-02-12 21:30:28',NULL,NULL),(36612,24105,'TE','8177293283',0,'2014-02-15 22:01:33',NULL,NULL),(37832,24962,'AP','3184392733',0,'2014-02-20 22:00:20',NULL,NULL),(38539,25467,'TE','8304566523',0,'2014-02-25 21:31:35',NULL,NULL),(43586,28941,'EM','dginohio@gmail.com',0,'2014-03-10 21:00:43',NULL,NULL),(43786,29064,'AP','4192830969',0,'2014-03-10 21:01:54',NULL,NULL),(20502,13201,'TE','9036038856',0,'2013-12-26 12:54:57',NULL,NULL),(29950,19382,'TE','5126745889',1,'2014-01-22 03:22:42',NULL,NULL),(28486,18356,'AP','5134171258',0,'2014-01-16 08:45:24',NULL,NULL),(1721,1055,'TE','2145371011',0,'2013-12-25 18:16:09',NULL,NULL),(10787,7011,'AP','2549790129',0,'2013-12-26 01:48:33',NULL,NULL),(27857,17946,'AP','2106859341',0,'2014-01-15 02:06:41',NULL,NULL),(24130,15577,'TE','4349428032',1,'2014-01-02 04:32:04',NULL,NULL),(3762,2387,'TE','7405160182',0,'2013-12-25 19:33:11',NULL,NULL),(36527,24048,'EM','deesoutendijk@gmail.com',0,'2014-02-15 22:01:03',NULL,NULL),(163,96,'AP','9168449521',0,'2013-12-25 17:17:36',NULL,NULL),(28280,18233,'AP','5129225154',0,'2014-01-16 08:44:20',NULL,NULL),(27888,17970,'EM','snelson_snelson@yahoo.com',0,'2014-01-15 02:06:49',NULL,NULL),(27633,17812,'EM','ceramicdinosaur@gmail.com',0,'2014-01-15 02:05:53',NULL,NULL),(26969,17343,'EM','jalittle228@hotmail.com',0,'2014-01-13 02:24:04',NULL,NULL),(13643,8896,'AP','8178967854',0,'2013-12-26 04:02:09',NULL,NULL),(26535,17070,'AP','9033871721',0,'2014-01-13 02:21:17',NULL,NULL),(22703,14642,'AP','9493717506',1,'2013-12-29 11:07:29',NULL,NULL),(25340,16343,'TE','4196798186',0,'2014-01-07 04:02:17',NULL,NULL),(35408,23278,'TE','5048127496',0,'2014-02-13 21:30:15',NULL,NULL),(37336,24582,'EM','elliott1210@gmail.com',0,'2014-02-20 04:08:51',NULL,NULL),(39200,25925,'AP','9564331745',0,'2014-02-26 21:01:23',NULL,NULL),(43328,28784,'AP','2167983036',0,'2014-03-09 21:00:37',NULL,NULL),(43766,29053,'EM','ngangwisch@aol.com',0,'2014-03-10 21:01:48',NULL,NULL),(31537,20552,'AP','3366132520',0,'2014-01-29 21:01:42',NULL,NULL),(25821,16645,'EM','66lemieux@woh.rr.com',0,'2014-01-08 18:24:19',NULL,NULL),(8426,5546,'TE','3306085540',0,'2013-12-25 23:15:59',NULL,NULL),(23757,15324,'TE','8064667947',1,'2014-01-02 04:23:41',NULL,NULL),(23191,14945,'AP','4198525160',0,'2013-12-30 00:02:28',NULL,NULL),(35284,23173,'AP','5136009127',0,'2014-02-12 21:31:54',NULL,NULL),(20204,13019,'TE','4193062877',0,'2013-12-26 12:50:00',NULL,NULL),(13952,9097,'EM','sengewald.judith111@gmail.com',0,'2013-12-26 04:07:16',NULL,NULL),(1247,758,'TE','9798224253',0,'2013-12-25 18:04:29',NULL,NULL),(11912,7754,'TE','2169701724',0,'2013-12-26 03:02:35',NULL,NULL),(11582,7539,'TE','2542833186',0,'2013-12-26 02:32:50',NULL,NULL),(6899,4490,'TE','4197877387',0,'2013-12-25 22:03:07',NULL,NULL),(32981,21592,'TE','9378441723',0,'2014-02-05 21:30:29',NULL,NULL),(24055,15532,'TE','2253646893',1,'2014-01-02 04:30:40',NULL,NULL),(24566,15845,'AP','6143576764',0,'2014-01-03 02:04:17',NULL,NULL),(32374,21151,'EM','Dabrowskigeorge@gmail.com',0,'2014-02-03 21:00:28',NULL,NULL),(25673,16551,'AP','9375970584',1,'2014-01-07 10:22:45',NULL,NULL),(32338,21125,'TE','9155842136',0,'2014-02-03 21:00:15',NULL,NULL),(31155,20290,'AP','3183594334',0,'2014-01-28 21:00:35',NULL,NULL),(28847,18631,'TE','9723425697',0,'2014-01-17 03:35:02',NULL,NULL),(30910,20098,'AP','5042489911',0,'2014-01-27 21:00:33',NULL,NULL),(31027,20184,'AP','9727932685',0,'2014-01-27 21:01:23',NULL,NULL),(35448,23307,'TE','5135603298',0,'2014-02-13 22:00:19',NULL,NULL),(35891,23610,'TE','9374074091',0,'2014-02-13 22:03:12',NULL,NULL),(36156,23796,'TE','3308086994',0,'2014-02-14 21:31:27',NULL,NULL),(36941,24327,'EM','abp_8504@yahoo.com',0,'2014-02-18 22:00:12',NULL,NULL),(37359,24594,'TE','4197074981',0,'2014-02-20 04:11:36',NULL,NULL),(33384,21875,'AP','3184011772',0,'2014-02-06 21:01:27',NULL,NULL),(32299,21096,'AP','4405960677',0,'2014-02-02 19:00:31',NULL,NULL),(20261,13058,'TE','3304147918',0,'2013-12-26 12:51:00',NULL,NULL),(1801,1116,'TE','4196124424',0,'2013-12-25 18:17:39',NULL,NULL),(14508,9480,'TE','3308999595',0,'2013-12-26 04:34:37',NULL,NULL),(30348,19665,'TE','5042409432',0,'2014-01-23 21:00:27',NULL,NULL),(25983,16741,'TE','2163288534',0,'2014-01-08 18:24:51',NULL,NULL),(26380,16980,'TE','6014425694',0,'2014-01-13 02:20:18',NULL,NULL),(37544,24718,'EM','k_tweet99@hotmail.com',0,'2014-02-20 04:37:43',NULL,NULL),(39713,26263,'TE','9569074710',0,'2014-02-28 06:31:13',NULL,NULL),(41089,27293,'TE','2816770181',0,'2014-03-04 21:00:30',NULL,NULL),(43806,29080,'AP','6012128270',0,'2014-03-10 21:02:03',NULL,NULL),(32847,21498,'TE','5174886566',0,'2014-02-04 21:01:50',NULL,NULL),(22804,14704,'TE','5672883978',1,'2013-12-29 11:09:09',NULL,NULL),(6117,3938,'TE','4193767392',0,'2013-12-25 21:37:50',NULL,NULL),(30544,19814,'AP','7139040919',0,'2014-01-24 21:00:11',NULL,NULL),(21975,14156,'AP','2254395277',0,'2013-12-27 02:03:02',NULL,NULL),(29456,19045,'TE','4199449506',0,'2014-01-20 08:06:40',NULL,NULL),(27567,17768,'TE','4086665946',0,'2014-01-14 01:33:36',NULL,NULL),(29305,18934,'TE','4405413532',0,'2014-01-20 08:05:40',NULL,NULL),(28790,18581,'TE','3303350708',0,'2014-01-16 08:47:09',NULL,NULL),(22377,14434,'TE','2259272323',0,'2013-12-28 03:32:01',NULL,NULL),(27712,17862,'EM','jennguzman01@gmail.com',0,'2014-01-15 02:06:11',NULL,NULL),(23754,15323,'TE','8322573238',1,'2014-01-02 04:23:39',NULL,NULL),(21984,14162,'TE','3187899718',0,'2013-12-27 02:03:11',NULL,NULL),(1339,818,'AP','3302420092',0,'2013-12-25 18:06:01',NULL,NULL),(1623,996,'EM','dawnmdebord@gmail.com',0,'2013-12-25 18:10:48',NULL,NULL),(20802,13366,'AP','2403210828',0,'2013-12-26 12:59:38',NULL,NULL),(37429,24647,'TE','5043449068',0,'2014-02-20 04:21:51',NULL,NULL),(43403,28824,'TE','4193513454',0,'2014-03-09 21:01:02',NULL,NULL),(10921,7101,'TE','5136283723',0,'2013-12-26 01:50:46',NULL,NULL),(33656,22074,'AP','5044349798',0,'2014-02-08 19:00:16',NULL,NULL),(33084,21670,'TE','3187192828',0,'2014-02-05 21:30:58',NULL,NULL),(32942,21560,'AP','6462666585',0,'2014-02-05 21:30:18',NULL,NULL),(32446,21201,'AP','4196010097',0,'2014-02-03 21:00:53',NULL,NULL),(30998,20166,'TE','4197798332',0,'2014-01-27 21:01:12',NULL,NULL),(32983,21592,'EM','asheeley1026@hotmail.com',0,'2014-02-05 21:30:29',NULL,NULL),(30919,20104,'EM','moniquemartin9@gmail.com',0,'2014-01-27 21:00:37',NULL,NULL),(28249,18216,'TE','5133724071',0,'2014-01-15 02:08:12',NULL,NULL),(8238,5389,'EM','cheramiea1@aol.com',0,'2013-12-25 23:08:37',NULL,NULL),(38525,25458,'EM','tashalieberman@outlook.com',0,'2014-02-25 21:31:30',NULL,NULL),(38953,25755,'TE','4406676183',0,'2014-02-26 09:30:48',NULL,NULL),(43247,28738,'TE','5042220724',0,'2014-03-09 21:00:07',NULL,NULL),(26685,17164,'EM','jazz410@cox.net',0,'2014-01-13 02:22:04',NULL,NULL),(38781,25637,'EM','Danceledance@gmail.com',0,'2014-02-26 08:30:28',NULL,NULL),(40574,26929,'AP','4403432384',0,'2014-03-03 01:00:19',NULL,NULL),(33595,22025,'TE','9375443607',0,'2014-02-07 19:01:00',NULL,NULL),(32998,21612,'AP','2163751104',0,'2014-02-05 21:30:34',NULL,NULL),(32232,21053,'TE','7407771365',0,'2014-02-02 19:00:07',NULL,NULL),(29767,19246,'EM','stacys360@gmail.com',0,'2014-01-21 08:46:41',NULL,NULL),(5708,3664,'TE','9373049992',0,'2013-12-25 21:30:58',NULL,NULL),(9450,6186,'TE','8323735944',0,'2013-12-26 00:30:12',NULL,NULL),(29078,18781,'EM','hpierce@bex.net',0,'2014-01-17 03:35:52',NULL,NULL),(3177,1993,'AP','8176816774',0,'2013-12-25 19:02:01',NULL,NULL),(24673,15910,'TE','5126624547',0,'2014-01-03 02:06:21',NULL,NULL),(36979,24346,'TE','9563724545',0,'2014-02-18 22:00:23',NULL,NULL),(40355,26783,'EM','mfredpol@yahoo.com',0,'2014-03-01 21:00:14',NULL,NULL),(43779,29061,'TE','4409645078',0,'2014-03-10 21:01:52',NULL,NULL),(29872,19328,'TE','2144229690',1,'2014-01-22 03:22:14',NULL,NULL),(23176,14938,'TE','3183455684',0,'2013-12-30 00:02:13',NULL,NULL),(11675,7600,'TE','4405216728',0,'2013-12-26 02:45:22',NULL,NULL),(1790,1111,'AP','5676742994',0,'2013-12-25 18:17:30',NULL,NULL),(20672,13294,'AP','9037828183',0,'2013-12-26 12:57:33',NULL,NULL),(20380,13126,'TE','4194814953',0,'2013-12-26 12:52:54',NULL,NULL),(6004,3857,'TE','2252529604',0,'2013-12-25 21:35:49',NULL,NULL),(43235,28730,'AP','5186691888',0,'2014-03-09 21:00:02',NULL,NULL),(30645,19888,'AP','3472069613',0,'2014-01-24 21:00:50',NULL,NULL),(4368,2783,'AP','4194103568',0,'2013-12-25 19:49:56',NULL,NULL),(11296,7360,'EM','pmiracle1356@yahoo.com',0,'2013-12-26 02:15:24',NULL,NULL),(36266,23869,'AP','4193038352',0,'2014-02-14 21:32:09',NULL,NULL),(39481,26113,'TE','6142028760',0,'2014-02-28 06:30:16',NULL,NULL),(40485,26868,'TE','3303480453',0,'2014-03-01 21:01:02',NULL,NULL),(28477,18353,'TE','4192600572',0,'2014-01-16 08:45:22',NULL,NULL),(4057,2589,'TE','3042802722',0,'2013-12-25 19:45:03',NULL,NULL),(5229,3360,'EM','reeise.kenneth@gmail.com',0,'2013-12-25 21:16:58',NULL,NULL),(3390,2132,'AP','4199898940',0,'2013-12-25 19:17:59',NULL,NULL),(6315,4072,'TE','3309522262',0,'2013-12-25 21:46:57',NULL,NULL),(41315,27447,'TE','3306735819',0,'2014-03-04 21:01:57',NULL,NULL),(32384,21159,'EM','mark_smith206@outlook.com',0,'2014-02-03 21:00:32',NULL,NULL),(23186,14943,'TE','4199800565',0,'2013-12-30 00:02:23',NULL,NULL),(31738,20713,'TE','5042309431',0,'2014-01-30 21:01:10',NULL,NULL),(31233,20341,'TE','2162991254',0,'2014-01-28 21:01:08',NULL,NULL),(11603,7547,'EM','cmak@woh.rr.com',0,'2013-12-26 02:33:06',NULL,NULL),(6781,4399,'AP','3304884126',0,'2013-12-25 22:01:06',NULL,NULL),(25791,16620,'AP','4406675797',0,'2014-01-08 18:24:11',NULL,NULL),(28753,18556,'TE','5673954957',0,'2014-01-16 08:46:56',NULL,NULL),(34426,22584,'TE','9375612967',0,'2014-02-10 21:32:05',NULL,NULL),(38941,25745,'AP','5133484143',0,'2014-02-26 09:30:42',NULL,NULL),(22296,14371,'TE','2162568553',0,'2013-12-28 03:30:32',NULL,NULL),(27858,17947,'EM','kh77975@gmail.com',0,'2014-01-15 02:06:41',NULL,NULL),(26774,17225,'TE','9378308291',0,'2014-01-13 02:22:36',NULL,NULL),(2413,1470,'EM','jasonsweeney@gmail.com',0,'2013-12-25 18:48:34',NULL,NULL),(36696,24160,'AP','4198603910',0,'2014-02-15 22:02:03',NULL,NULL),(36946,24333,'TE','8328185112',0,'2014-02-18 22:00:14',NULL,NULL),(38106,25155,'TE','8322298197',0,'2014-02-21 22:00:19',NULL,NULL),(41299,27438,'EM','LATOMRED@YAHOO.COM',0,'2014-03-04 21:01:51',NULL,NULL),(9819,6423,'TE','9859814483',0,'2013-12-26 00:48:58',NULL,NULL),(31007,20171,'AP','3305539616',0,'2014-01-27 21:01:15',NULL,NULL),(20419,13148,'EM','carole.niedzialkowski@yahoo.com',0,'2013-12-26 12:53:32',NULL,NULL),(29016,18733,'AP','9374089491',0,'2014-01-17 03:35:37',NULL,NULL),(28840,18622,'TE','2165140880',0,'2014-01-16 08:47:29',NULL,NULL),(27763,17901,'TE','7204227159',0,'2014-01-15 02:06:23',NULL,NULL),(23385,15063,'TE','3186804870',0,'2014-01-01 12:03:39',NULL,NULL),(36055,23716,'AP','9377517770',0,'2014-02-14 21:30:49',NULL,NULL),(36586,24084,'TE','4403346120',0,'2014-02-15 22:01:23',NULL,NULL),(174,103,'AP','9033311776',0,'2013-12-25 17:17:46',NULL,NULL),(30215,19575,'TE','3374859305',0,'2014-01-23 03:02:38',NULL,NULL),(2206,1354,'AP','5122536902',0,'2013-12-25 18:45:21',NULL,NULL),(9195,6018,'EM','opicana@gmail.com',0,'2013-12-26 00:00:47',NULL,NULL),(9019,5919,'TE','9728801588',0,'2013-12-25 23:50:13',NULL,NULL),(8854,5802,'AP','9364653206',0,'2013-12-25 23:47:32',NULL,NULL),(27310,17588,'TE','3308823622',0,'2014-01-14 01:32:09',NULL,NULL),(24751,15971,'TE','2544588220',0,'2014-01-04 02:00:36',NULL,NULL),(35911,23627,'EM','barb82@live.com',0,'2014-02-13 22:03:21',NULL,NULL),(36470,24011,'EM','ESLC213@AOL.COM',0,'2014-02-15 22:00:40',NULL,NULL),(37389,24621,'TE','6019830020',0,'2014-02-20 04:16:17',NULL,NULL),(59,40,'TE','2165241194',0,'2013-12-25 17:16:02',NULL,NULL),(21104,13568,'AP','5042310268',0,'2013-12-26 13:04:35',NULL,NULL),(29246,18890,'AP','3307866893',0,'2014-01-17 03:36:32',NULL,NULL),(11844,7705,'EM','twincarbii@yahoo.com',0,'2013-12-26 03:01:23',NULL,NULL),(25356,16352,'TE','5014168529',0,'2014-01-07 04:02:32',NULL,NULL),(4432,2825,'AP','4403441240',0,'2013-12-25 20:00:37',NULL,NULL),(24386,15747,'AP','2147798263',0,'2014-01-03 02:01:02',NULL,NULL),(36840,24260,'AP','7137759093',0,'2014-02-17 19:00:10',NULL,NULL),(42695,28401,'AP','6095567231',0,'2014-03-07 21:30:51',NULL,NULL),(43533,28903,'TE','9156916129',0,'2014-03-10 21:00:22',NULL,NULL),(34537,22655,'AP','5128881198',0,'2014-02-11 21:00:31',NULL,NULL),(10043,6569,'AP','8064719728',0,'2013-12-26 00:52:38',NULL,NULL),(7689,5015,'EM','pjw2005yes@yahoo.com',0,'2013-12-25 22:47:24',NULL,NULL),(2767,1677,'EM','royalchildofgod@aol.com',0,'2013-12-25 18:54:03',NULL,NULL),(9199,6021,'TE','5134600189',0,'2013-12-26 00:00:51',NULL,NULL),(41771,27774,'TE','2165447757',0,'2014-03-05 21:31:29',NULL,NULL),(33907,22257,'TE','2542213272',0,'2014-02-10 11:00:05',NULL,NULL),(33862,22227,'AP','3182787904',0,'2014-02-09 19:00:30',NULL,NULL),(4934,3167,'TE','5133073268',0,'2013-12-25 20:31:29',NULL,NULL),(9341,6115,'AP','3302243582',0,'2013-12-26 00:15:36',NULL,NULL),(874,543,'TE','3306902806',0,'2013-12-25 17:49:48',NULL,NULL),(8853,5802,'TE','9364653206',0,'2013-12-25 23:47:32',NULL,NULL),(22011,14176,'TE','3614296834',0,'2013-12-27 02:03:36',NULL,NULL),(5851,3754,'AP','3304318100',0,'2013-12-25 21:33:16',NULL,NULL),(9041,5932,'AP','2256037647',0,'2013-12-25 23:50:33',NULL,NULL),(14116,9233,'TE','5133242999',0,'2013-12-26 04:10:30',NULL,NULL),(39585,26186,'TE','5135536345',0,'2014-02-28 06:30:43',NULL,NULL),(40235,26688,'AP','3372549723',0,'2014-02-28 21:31:27',NULL,NULL),(14638,9572,'EM','ghinkle@netlinkrg.com',0,'2013-12-26 04:36:45',NULL,NULL),(35027,23000,'AP','3305194655',0,'2014-02-12 21:30:18',NULL,NULL),(28690,18516,'TE','4196055393',0,'2014-01-16 08:46:35',NULL,NULL),(28048,18076,'EM','rseal344@yahoo.com',0,'2014-01-15 02:07:25',NULL,NULL),(26413,16998,'TE','3308197283',0,'2014-01-13 02:20:29',NULL,NULL),(36293,23895,'AP','5139192455',0,'2014-02-14 21:32:20',NULL,NULL),(43673,28985,'TE','3307458204',0,'2014-03-10 21:01:11',NULL,NULL),(52,33,'AP','7406015550',0,'2013-12-25 17:15:52',NULL,NULL),(33990,22296,'AP','6148065991',0,'2014-02-10 11:00:33',NULL,NULL),(14374,9400,'TE','2147348913',0,'2013-12-26 04:32:34',NULL,NULL),(30938,20118,'AP','6143711786',0,'2014-01-27 21:00:45',NULL,NULL),(29547,19095,'AP','9372101703',0,'2014-01-21 08:44:35',NULL,NULL),(6942,4523,'EM','fourskininc@yahoo.com',0,'2013-12-25 22:03:53',NULL,NULL),(23204,14953,'EM','emmatardif@gmail.com',0,'2014-01-01 12:00:16',NULL,NULL),(4133,2637,'TE','3304259302',0,'2013-12-25 19:46:15',NULL,NULL),(14736,9639,'TE','7137037436',0,'2013-12-26 04:38:27',NULL,NULL),(22831,14726,'EM','ZOE4DEEP84.AW@GMAIL.COM',1,'2013-12-29 11:09:41',NULL,NULL),(35775,23525,'AP','3377949880',0,'2014-02-13 22:02:23',NULL,NULL),(43903,29127,'EM','jameszachman@hotmail.com',0,'2014-03-10 21:02:35',NULL,NULL),(41,27,'EM','karla-smith@neo.rr.com',0,'2013-12-25 17:15:41',NULL,NULL),(9772,6389,'AP','6143787066',0,'2013-12-26 00:48:08',NULL,NULL),(34848,22850,'EM','katlynnywca@yahoo.com',0,'2014-02-11 21:02:20',NULL,NULL),(4331,2764,'TE','4405764926',0,'2013-12-25 19:49:23',NULL,NULL),(32582,21303,'TE','3372581443',0,'2014-02-04 21:00:13',NULL,NULL),(5262,3380,'TE','4174835673',0,'2013-12-25 21:17:29',NULL,NULL),(21265,13664,'AP','5409316179',0,'2013-12-26 13:07:43',NULL,NULL),(32443,21198,'TE','2162263791',0,'2014-02-03 21:00:52',NULL,NULL),(27742,17884,'EM','easywindzero@gmail.com',0,'2014-01-15 02:06:17',NULL,NULL),(30734,19967,'AP','4402131135',0,'2014-01-25 19:00:10',NULL,NULL),(31067,20212,'TE','3308359342',0,'2014-01-27 21:01:38',NULL,NULL),(30119,19510,'AP','9365819592',0,'2014-01-23 03:02:14',NULL,NULL),(28940,18684,'TE','2814606815',0,'2014-01-17 03:35:21',NULL,NULL),(24538,15826,'AP','4402251061',0,'2014-01-03 02:03:42',NULL,NULL),(10147,6633,'AP','6149461457',0,'2013-12-26 01:00:05',NULL,NULL),(8738,5730,'TE','2257267901',0,'2013-12-25 23:45:39',NULL,NULL),(10513,6847,'TE','2814380743',0,'2013-12-26 01:31:17',NULL,NULL),(8688,5704,'TE','3618169757',0,'2013-12-25 23:33:00',NULL,NULL),(7940,5178,'AP','5133073268',0,'2013-12-25 23:03:29',NULL,NULL),(3858,2455,'AP','9723333846',0,'2013-12-25 19:34:46',NULL,NULL),(7311,4756,'TE','8327626198',0,'2013-12-25 22:15:24',NULL,NULL),(13938,9090,'TE','9374335970',0,'2013-12-26 04:07:04',NULL,NULL),(22856,14749,'TE','5137531272',1,'2013-12-29 11:10:15',NULL,NULL),(3392,2133,'TE','9542240619',0,'2013-12-25 19:18:01',NULL,NULL),(23097,14895,'TE','2253566521',0,'2013-12-30 00:00:55',NULL,NULL),(42535,28298,'AP','5136009127',0,'2014-03-07 21:00:31',NULL,NULL),(751,471,'AP','4196512032',0,'2013-12-25 17:47:52',NULL,NULL),(24831,16016,'TE','5042965557',0,'2014-01-04 02:02:01',NULL,NULL),(32067,20938,'AP','9379265053',0,'2014-01-31 21:01:42',NULL,NULL),(11212,7293,'TE','3306783807',0,'2013-12-26 02:02:56',NULL,NULL),(29424,19023,'TE','6018590509',0,'2014-01-20 08:06:27',NULL,NULL),(4833,3093,'TE','4197526838',0,'2013-12-25 20:20:03',NULL,NULL),(28096,18109,'TE','2253435736',0,'2014-01-15 02:07:36',NULL,NULL),(27789,17913,'TE','8064014720',0,'2014-01-15 02:06:28',NULL,NULL),(40797,27113,'TE','9375727862',0,'2014-03-03 21:30:28',NULL,NULL),(40822,27130,'TE','6142542660',0,'2014-03-03 21:30:39',NULL,NULL),(27711,17862,'AP','6145125823',0,'2014-01-15 02:06:11',NULL,NULL),(13725,8945,'TE','3309790488',0,'2013-12-26 04:03:25',NULL,NULL),(13999,9140,'TE','5027278238',0,'2013-12-26 04:08:10',NULL,NULL),(6420,4149,'TE','3304684031',0,'2013-12-25 21:48:43',NULL,NULL),(14443,9437,'AP','5132215451',0,'2013-12-26 04:33:35',NULL,NULL),(4097,2613,'AP','5134785503',0,'2013-12-25 19:45:40',NULL,NULL),(33653,22071,'AP','8172711441',0,'2014-02-08 19:00:14',NULL,NULL),(22263,14346,'TE','9376225817',0,'2013-12-27 02:08:02',NULL,NULL),(30994,20161,'EM','laurakoncan@aim.com',0,'2014-01-27 21:01:10',NULL,NULL),(4707,3010,'TE','3305713922',0,'2013-12-25 20:17:55',NULL,NULL),(4762,3050,'AP','3185643237',0,'2013-12-25 20:18:52',NULL,NULL),(22494,14503,'TE','9158508561',0,'2013-12-28 03:33:51',NULL,NULL),(36020,23693,'TE','5133143299',0,'2014-02-14 21:30:38',NULL,NULL),(36896,24300,'TE','4093774360',0,'2014-02-18 21:30:19',NULL,NULL),(24611,15871,'AP','6019425330',0,'2014-01-03 02:05:07',NULL,NULL),(4198,2685,'TE','7025109507',0,'2013-12-25 19:47:20',NULL,NULL),(36755,24197,'BN','5133440653',0,'2014-02-16 19:00:17',NULL,NULL),(39855,26364,'AP','3303545829',0,'2014-02-28 07:00:07',NULL,NULL),(404,248,'TE','4194389189',0,'2013-12-25 17:21:30',NULL,NULL),(11428,7435,'AP','3307144110',0,'2013-12-26 02:30:15',NULL,NULL),(35443,23303,'EM','min_yue@yahoo.com',0,'2014-02-13 22:00:16',NULL,NULL),(33871,22233,'TE','2814135750',0,'2014-02-09 19:00:33',NULL,NULL),(11573,7530,'EM','rcheplick@comcast.net',0,'2013-12-26 02:32:40',NULL,NULL),(13569,8848,'TE','4322604188',0,'2013-12-26 04:00:56',NULL,NULL),(33256,21777,'AP','5133250620',0,'2014-02-06 21:00:36',NULL,NULL),(39082,25854,'TE','5043484828',0,'2014-02-26 21:00:41',NULL,NULL),(41326,27454,'AP','5134608588',0,'2014-03-04 21:02:01',NULL,NULL),(42458,28207,'TE','9493717506',0,'2014-03-06 21:30:11',NULL,NULL),(1993,1230,'TE','6147831259',0,'2013-12-25 18:20:42',NULL,NULL),(8792,5759,'EM','carebear0323@gmail.com',0,'2013-12-25 23:46:28',NULL,NULL),(12030,7848,'TE','2165200207',0,'2013-12-26 03:04:44',NULL,NULL),(33891,22244,'AP','4193461980',0,'2014-02-09 19:00:39',NULL,NULL),(32065,20937,'TE','4194755693',0,'2014-01-31 21:01:41',NULL,NULL),(21111,13571,'AP','5045200065',0,'2013-12-26 13:04:41',NULL,NULL),(27157,17485,'AP','8325428684',0,'2014-01-13 03:01:16',NULL,NULL),(24323,15714,'TE','4192142275',1,'2014-01-02 04:36:09',NULL,NULL),(37843,24968,'TE','8176961674',0,'2014-02-20 22:00:24',NULL,NULL),(40098,26593,'TE','4407252796',0,'2014-02-28 21:30:37',NULL,NULL),(535,335,'TE','2108378717',0,'2013-12-25 17:31:47',NULL,NULL),(32290,21091,'EM','candieladie05@gmail.com',0,'2014-02-02 19:00:28',NULL,NULL),(27408,17650,'AP','6149757802',0,'2014-01-14 01:32:40',NULL,NULL),(10040,6568,'AP','9153453960',0,'2013-12-26 00:52:36',NULL,NULL),(2328,1420,'AP','2543668201',0,'2013-12-25 18:47:13',NULL,NULL),(1671,1025,'EM','kjevans@gioninos.com',0,'2013-12-25 18:15:22',NULL,NULL),(29586,19117,'AP','5132594730',0,'2014-01-21 08:44:48',NULL,NULL),(21916,14118,'EM','juansp1000op@aol.com',0,'2013-12-27 02:02:03',NULL,NULL),(20954,13477,'EM','rawalish@gmail.com',0,'2013-12-26 13:02:10',NULL,NULL),(40657,26990,'TE','6019512299',0,'2014-03-03 01:00:42',NULL,NULL),(40766,27091,'TE','4404742334',0,'2014-03-03 21:30:17',NULL,NULL),(30579,19840,'AP','5042677446',0,'2014-01-24 21:00:25',NULL,NULL),(3571,2237,'EM','mandaw519@gmail.com',0,'2013-12-25 19:20:54',NULL,NULL),(4374,2790,'TE','4195863202',0,'2013-12-25 19:50:05',NULL,NULL),(28219,18191,'AP','4407851715',0,'2014-01-15 02:08:04',NULL,NULL),(5665,3640,'TE','7696102778',0,'2013-12-25 21:30:20',NULL,NULL),(14715,9627,'EM','jones.2800@gmail.com',0,'2013-12-26 04:38:06',NULL,NULL),(8780,5754,'TE','3305456830',0,'2013-12-25 23:46:19',NULL,NULL),(41117,27313,'AP','9565907670',0,'2014-03-04 21:00:41',NULL,NULL),(42602,28343,'TE','8179664378',0,'2014-03-07 21:30:18',NULL,NULL),(33262,21781,'AP','4402636065',0,'2014-02-06 21:00:38',NULL,NULL),(30265,19610,'AP','3306872654',0,'2014-01-23 03:02:50',NULL,NULL),(6203,3996,'TE','9373679726',0,'2013-12-25 21:45:04',NULL,NULL),(1462,895,'TE','4196562442',0,'2013-12-25 18:08:07',NULL,NULL),(21143,13594,'TE','2252200927',0,'2013-12-26 13:05:16',NULL,NULL),(1645,1010,'AP','5128263489',0,'2013-12-25 18:11:14',NULL,NULL),(33164,21721,'AP','4197874238',0,'2014-02-05 21:31:20',NULL,NULL),(20286,13077,'TE','6144775116',0,'2013-12-26 12:51:28',NULL,NULL),(9908,6485,'TE','3307539201',0,'2013-12-26 00:50:25',NULL,NULL),(5996,3852,'TE','3373085082',0,'2013-12-25 21:35:40',NULL,NULL),(7891,5142,'TE','3302895231',0,'2013-12-25 23:02:35',NULL,NULL),(1034,638,'TE','4406100191',0,'2013-12-25 18:01:17',NULL,NULL),(4335,2767,'EM','dlclark@uakron.edu',0,'2013-12-25 19:49:28',NULL,NULL),(11928,7771,'TE','9409234361',0,'2013-12-26 03:02:55',NULL,NULL),(37948,25039,'AP','4192961783',0,'2014-02-20 22:01:09',NULL,NULL),(42399,28160,'EM','wdeubler@yahoo.com',0,'2014-03-06 21:02:42',NULL,NULL),(34649,22718,'AP','3184030097',0,'2014-02-11 21:01:09',NULL,NULL),(8557,5621,'EM','christireis4@aol.com',0,'2013-12-25 23:30:48',NULL,NULL),(11832,7699,'AP','9376074232',0,'2013-12-26 03:01:13',NULL,NULL),(21573,13873,'AP','3308581920',0,'2013-12-26 13:13:07',NULL,NULL),(31062,20209,'TE','6015731298',0,'2014-01-27 21:01:37',NULL,NULL),(37325,24564,'TE','3308619059',0,'2014-02-20 04:06:45',NULL,NULL),(25014,16119,'AP','5043907107',0,'2014-01-04 02:05:22',NULL,NULL),(34193,22426,'TE','2543964962',0,'2014-02-10 21:30:34',NULL,NULL),(8198,5365,'EM','jim4355@prodigy.net',0,'2013-12-25 23:07:58',NULL,NULL),(3368,2115,'AP','5132507305',0,'2013-12-25 19:17:35',NULL,NULL),(20600,13251,'TE','9564346548',0,'2013-12-26 12:56:23',NULL,NULL),(1075,661,'TE','3306028240',0,'2013-12-25 18:01:54',NULL,NULL),(40445,26851,'TE','6623564188',0,'2014-03-01 21:00:51',NULL,NULL),(41021,27255,'EM','bettyboom_13@yahoo.com',0,'2014-03-03 21:31:56',NULL,NULL),(41417,27516,'TE','5133443417',0,'2014-03-04 21:02:36',NULL,NULL),(42175,28015,'AP','7405061697',0,'2014-03-06 21:01:18',NULL,NULL),(43196,28703,'AP','3304725394',0,'2014-03-08 21:31:11',NULL,NULL),(43635,28963,'AP','5042569282',0,'2014-03-10 21:00:58',NULL,NULL),(558,346,'EM','Shananicolerains@gmail.com',0,'2013-12-25 17:32:07',NULL,NULL),(25889,16689,'TE','8174581487',0,'2014-01-08 18:24:34',NULL,NULL),(25501,16444,'TE','6018856410',0,'2014-01-07 04:05:12',NULL,NULL),(11617,7555,'EM','debwillhite@sbcglobal.net',0,'2013-12-26 02:33:20',NULL,NULL),(10046,6571,'AP','9857050856',0,'2013-12-26 00:52:42',NULL,NULL),(31612,20620,'AP','2254567218',0,'2014-01-30 21:00:23',NULL,NULL),(3007,1868,'EM','glenmarie55@gmail.com',0,'2013-12-25 18:58:14',NULL,NULL),(31292,20385,'AP','8176006785',0,'2014-01-29 21:00:13',NULL,NULL),(26689,17166,'TE','3189741827',0,'2014-01-13 02:22:05',NULL,NULL),(27037,17385,'TE','4125923082',0,'2014-01-13 03:00:08',NULL,NULL),(36583,24078,'EM','mmahlendorf@mail.com',0,'2014-02-15 22:01:21',NULL,NULL),(37932,25028,'EM','itropical@yahoo.com',0,'2014-02-20 22:01:01',NULL,NULL),(43180,28694,'AP','2253850685',0,'2014-03-08 21:31:05',NULL,NULL),(21336,13710,'TE','3307536783',0,'2013-12-26 13:08:55',NULL,NULL),(31672,20663,'TE','9035061841',0,'2014-01-30 21:00:45',NULL,NULL),(5378,3442,'EM','FMCMANN2@GMAIL.COM',0,'2013-12-25 21:19:16',NULL,NULL),(29915,19360,'TE','3307602542',1,'2014-01-22 03:22:30',NULL,NULL),(26206,16866,'AP','5126329341',0,'2014-01-13 02:19:13',NULL,NULL),(2637,1603,'AP','8173722338',0,'2013-12-25 18:52:07',NULL,NULL),(40652,26987,'EM','marty.ulrich@yahoo.com',0,'2014-03-03 01:00:41',NULL,NULL),(24769,15980,'TE','5127154378',0,'2014-01-04 02:00:54',NULL,NULL),(29489,19059,'AP','4322448410',0,'2014-01-21 08:44:14',NULL,NULL),(22438,14470,'EM','mancini@megalink.net',0,'2013-12-28 03:33:01',NULL,NULL),(22099,14232,'EM','grewera@gmail.com',0,'2013-12-27 02:05:03',NULL,NULL),(8272,5418,'EM','ahughie@yahoo.com',0,'2013-12-25 23:09:19',NULL,NULL),(7913,5157,'TE','6145805632',0,'2013-12-25 23:02:57',NULL,NULL),(3467,2170,'AP','4197044473',0,'2013-12-25 19:19:09',NULL,NULL),(39333,26018,'EM','Tlcnrs15@yahoo.com',0,'2014-02-26 21:02:13',NULL,NULL),(22529,14526,'TE','9798283265',0,'2013-12-28 03:34:26',NULL,NULL),(31196,20316,'EM','cervenyruze0506@yahoo.com',0,'2014-01-28 21:00:52',NULL,NULL),(5331,3416,'EM','bryan.amy1@gmail.com',0,'2013-12-25 21:18:31',NULL,NULL),(33755,22150,'AP','3305657851',0,'2014-02-08 19:00:53',NULL,NULL),(34639,22712,'TE','5043439162',0,'2014-02-11 21:01:05',NULL,NULL),(40068,26565,'EM','davidrisk@yahoo.com',0,'2014-02-28 21:30:23',NULL,NULL),(43336,28787,'AP','9379358432',0,'2014-03-09 21:00:39',NULL,NULL),(43383,28811,'AP','4196060981',0,'2014-03-09 21:00:55',NULL,NULL),(14167,9270,'EM','Shantharris@yahoo.com',0,'2013-12-26 04:15:38',NULL,NULL),(11555,7521,'TE','5136715513',0,'2013-12-26 02:32:23',NULL,NULL),(4159,2653,'AP','2165701428',0,'2013-12-25 19:46:41',NULL,NULL),(10903,7085,'TE','3304193619',0,'2013-12-26 01:50:24',NULL,NULL),(28727,18538,'AP','6015172897',0,'2014-01-16 08:46:47',NULL,NULL),(34633,22708,'AP','5049391314',0,'2014-02-11 21:01:03',NULL,NULL),(33593,22021,'EM','vgf_21@yahoo.com',0,'2014-02-07 19:00:59',NULL,NULL),(21913,14117,'AP','3302056368',0,'2013-12-27 02:02:01',NULL,NULL),(13539,8829,'TE','9565444768',0,'2013-12-26 04:00:29',NULL,NULL),(9888,6466,'AP','3306036421',0,'2013-12-26 00:50:02',NULL,NULL),(2676,1624,'AP','9157304535',0,'2013-12-25 18:52:40',NULL,NULL),(27457,17688,'TE','3187938496',0,'2014-01-14 01:32:58',NULL,NULL),(5557,3551,'AP','3302834009',0,'2013-12-25 21:22:02',NULL,NULL),(26063,16787,'EM','kag390@gmail.com',0,'2014-01-08 18:25:08',NULL,NULL),(35007,22985,'TE','3305502106',0,'2014-02-12 21:30:11',NULL,NULL),(36190,23820,'EM','josephgreenler@gmail.com',0,'2014-02-14 21:31:40',NULL,NULL),(38074,25133,'AP','4328898135',0,'2014-02-21 22:00:05',NULL,NULL),(38665,25552,'TE','9856628899',0,'2014-02-26 08:00:19',NULL,NULL),(42737,28425,'EM','assabot101@gmail.com',0,'2014-03-07 21:31:05',NULL,NULL),(3702,2348,'EM','skilledtech50@hotmail.com',0,'2013-12-25 19:32:09',NULL,NULL),(1541,948,'AP','4192901862',0,'2013-12-25 18:09:30',NULL,NULL),(1634,1003,'AP','6018741872',0,'2013-12-25 18:11:00',NULL,NULL),(1948,1206,'TE','3307539798',0,'2013-12-25 18:20:00',NULL,NULL),(5733,3675,'EM','LaChris@execs.com',0,'2013-12-25 21:31:18',NULL,NULL),(36358,23944,'AP','4322545053',0,'2014-02-15 21:00:11',NULL,NULL),(37609,24782,'EM','carlye.myka@gmail.com',0,'2014-02-20 04:45:48',NULL,NULL),(40533,26903,'TE','5128267373',0,'2014-03-03 01:00:08',NULL,NULL),(42069,27955,'TE','2147143684',0,'2014-03-06 21:00:40',NULL,NULL),(11507,7488,'EM','dallas@woh.rr.com',0,'2013-12-26 02:31:33',NULL,NULL),(33064,21658,'TE','3375798229',0,'2014-02-05 21:30:53',NULL,NULL),(14384,9405,'AP','2542580611',0,'2013-12-26 04:32:43',NULL,NULL),(9211,6026,'TE','9153739916',0,'2013-12-26 00:01:01',NULL,NULL),(31056,20204,'AP','4197335383',0,'2014-01-27 21:01:34',NULL,NULL),(25932,16708,'TE','7193342320',0,'2014-01-08 18:24:41',NULL,NULL),(35770,23523,'AP','3306057787',0,'2014-02-13 22:02:22',NULL,NULL),(36464,24009,'AP','5133687818',0,'2014-02-15 22:00:39',NULL,NULL),(39252,25967,'AP','6146043415',0,'2014-02-26 21:01:44',NULL,NULL),(32496,21235,'AP','6142564466',0,'2014-02-03 21:01:11',NULL,NULL),(223,135,'TE','4198463258',0,'2013-12-25 17:18:35',NULL,NULL),(479,305,'TE','9378667136',0,'2013-12-25 17:30:54',NULL,NULL),(21304,13685,'EM','chickauto@sbcglobal.net',0,'2013-12-26 13:08:20',NULL,NULL),(30086,19492,'TE','4409699836',0,'2014-01-23 03:02:07',NULL,NULL),(29203,18866,'TE','2259363032',0,'2014-01-17 03:36:22',NULL,NULL),(11976,7802,'EM','marlymc8@gmail.com',0,'2013-12-26 03:03:43',NULL,NULL),(5976,3839,'AP','3184171196',0,'2013-12-25 21:35:20',NULL,NULL),(28483,18355,'AP','2169654221',0,'2014-01-16 08:45:23',NULL,NULL),(3979,2525,'TE','3302657162',0,'2013-12-25 19:36:41',NULL,NULL),(10213,6674,'TE','9857050874',0,'2013-12-26 01:01:13',NULL,NULL),(43914,29134,'AP','4193410259',0,'2014-03-10 21:02:39',NULL,NULL),(9703,6353,'EM','james@meyeranddial.com',0,'2013-12-26 00:47:08',NULL,NULL),(1209,737,'AP','9404440203',0,'2013-12-25 18:03:57',NULL,NULL),(26225,16879,'EM','tyler.chancellor@gmail.com',0,'2014-01-13 02:19:20',NULL,NULL),(4154,2649,'AP','2107227270',0,'2013-12-25 19:46:34',NULL,NULL),(34175,22412,'TE','5046212563',0,'2014-02-10 21:30:26',NULL,NULL),(37914,25012,'TE','6145921031',0,'2014-02-20 22:00:52',NULL,NULL),(41908,27864,'AP','3303224227',0,'2014-03-05 21:32:21',NULL,NULL),(42965,28572,'AP','5124311113',0,'2014-03-08 21:00:02',NULL,NULL),(33795,22185,'EM','rogerlinde@hotmail.com',0,'2014-02-09 19:00:06',NULL,NULL),(25628,16527,'TE','9365909520',1,'2014-01-07 10:21:57',NULL,NULL),(32244,21058,'EM','ninacori83@gmail.com',0,'2014-02-02 19:00:10',NULL,NULL),(29701,19202,'TE','3309629610',0,'2014-01-21 08:46:17',NULL,NULL),(22741,14667,'EM','Joshuaandkristi@sbcglobal.net',1,'2013-12-29 11:08:08',NULL,NULL),(11229,7307,'TE','2163815160',0,'2013-12-26 02:03:16',NULL,NULL),(20558,13232,'AP','5126996768',0,'2013-12-26 12:55:47',NULL,NULL),(9451,6186,'AP','8323735944',0,'2013-12-26 00:30:12',NULL,NULL),(12020,7833,'EM','mhurlow@email.com',0,'2013-12-26 03:04:28',NULL,NULL),(14011,9148,'AP','3305711389',0,'2013-12-26 04:08:22',NULL,NULL),(5304,3400,'AP','3185603599',0,'2013-12-25 21:18:06',NULL,NULL),(41022,27256,'TE','9374981538',0,'2014-03-03 21:31:57',NULL,NULL),(41760,27768,'TE','3184696498',0,'2014-03-05 21:31:25',NULL,NULL),(42213,28043,'AP','6626070879',0,'2014-03-06 21:01:33',NULL,NULL),(21025,13528,'TE','5044733705',0,'2013-12-26 13:03:23',NULL,NULL),(26579,17099,'AP','4098931682',0,'2014-01-13 02:21:31',NULL,NULL),(26137,16826,'TE','3306265661',0,'2014-01-13 02:18:26',NULL,NULL),(2091,1291,'TE','3307805914',0,'2013-12-25 18:30:53',NULL,NULL),(7804,5094,'TE','9034713638',0,'2013-12-25 23:01:18',NULL,NULL),(2562,1564,'AP','2145384089',0,'2013-12-25 18:51:00',NULL,NULL),(399,244,'TE','5137790681',0,'2013-12-25 17:21:25',NULL,NULL),(3431,2153,'TE','9857487017',0,'2013-12-25 19:18:39',NULL,NULL),(36673,24148,'TE','5137975230',0,'2014-02-15 22:01:55',NULL,NULL),(40638,26972,'AP','3306042402',0,'2014-03-03 01:00:35',NULL,NULL),(42097,27970,'AP','3183488610',0,'2014-03-06 21:00:50',NULL,NULL),(43138,28674,'EM','vhiris@gmail.com',0,'2014-03-08 21:30:51',NULL,NULL),(14734,9639,'TE','7137037436',0,'2013-12-26 04:38:26',NULL,NULL),(25190,16241,'AP','5134708042',0,'2014-01-05 00:02:24',NULL,NULL),(23740,15317,'AP','5126601305',1,'2014-01-02 04:23:25',NULL,NULL),(9642,6310,'TE','7406891492',0,'2013-12-26 00:46:08',NULL,NULL),(31560,20572,'TE','4192305484',0,'2014-01-29 21:01:53',NULL,NULL),(30036,19454,'TE','4406390312',0,'2014-01-23 03:01:53',NULL,NULL),(14540,9498,'TE','3305333324',0,'2013-12-26 04:35:07',NULL,NULL),(4103,2617,'TE','6148712855',0,'2013-12-25 19:45:46',NULL,NULL),(43982,29178,'TE','9373165098',0,'2014-03-10 21:03:03',NULL,NULL),(33561,22000,'TE','5042737835',0,'2014-02-07 19:00:47',NULL,NULL),(27936,18001,'EM','snelson_snelson@yahoo.com',0,'2014-01-15 02:07:00',NULL,NULL),(25542,16477,'AP','3308583375',0,'2014-01-07 04:06:09',NULL,NULL),(2471,1516,'TE','2165599731',0,'2013-12-25 18:49:40',NULL,NULL),(20801,13366,'TE','2403210828',0,'2013-12-26 12:59:38',NULL,NULL),(3178,1995,'TE','8176816774',0,'2013-12-25 19:02:03',NULL,NULL),(11030,7159,'AP','4194870366',0,'2013-12-26 01:52:24',NULL,NULL),(4085,2604,'AP','3305249333',0,'2013-12-25 19:45:26',NULL,NULL),(3860,2456,'TE','9723333846',0,'2013-12-25 19:34:47',NULL,NULL),(39642,26213,'EM','laura967@outlook.com',0,'2014-02-28 06:30:54',NULL,NULL),(41920,27872,'TE','2284939013',0,'2014-03-05 21:32:26',NULL,NULL),(42272,28073,'EM','duanetbubsey9@hotmail.com',0,'2014-03-06 21:01:52',NULL,NULL),(33608,22039,'TE','6013258298',0,'2014-02-07 19:01:08',NULL,NULL),(7021,4585,'TE','3306880599',0,'2013-12-25 22:05:19',NULL,NULL),(27773,17905,'EM','elissa.nadel@gmail.com',0,'2014-01-15 02:06:25',NULL,NULL),(2566,1566,'EM','ericj11111@gmail.com',0,'2013-12-25 18:51:03',NULL,NULL),(8012,5230,'TE','3307069760',0,'2013-12-25 23:04:46',NULL,NULL),(10436,6803,'AP','2165449159',0,'2013-12-26 01:30:04',NULL,NULL),(26100,16807,'AP','2542474459',0,'2014-01-13 02:18:14',NULL,NULL),(550,343,'AP','7405726676',0,'2013-12-25 17:32:01',NULL,NULL),(36286,23891,'TE','9374811597',0,'2014-02-14 21:32:18',NULL,NULL),(37401,24631,'TE','3187691160',0,'2014-02-20 04:18:05',NULL,NULL),(38573,25494,'AP','4192749130',0,'2014-02-25 21:31:49',NULL,NULL),(41231,27385,'AP','6018831930',0,'2014-03-04 21:01:24',NULL,NULL),(43100,28652,'AP','7408046051',0,'2014-03-08 21:30:38',NULL,NULL),(32271,21080,'TE','9725633603',0,'2014-02-02 19:00:21',NULL,NULL),(31251,20355,'EM','margo@broehllawoffice.com',0,'2014-01-28 21:01:17',NULL,NULL),(30775,20007,'TE','3309621952',0,'2014-01-26 19:00:07',NULL,NULL),(6571,4241,'AP','2146167763',0,'2013-12-25 21:51:03',NULL,NULL),(8246,5393,'EM','chedmoo@hotmail.com',0,'2013-12-25 23:08:44',NULL,NULL),(20968,13491,'TE','4404717308',0,'2013-12-26 13:02:26',NULL,NULL),(20684,13299,'TE','9729777224',0,'2013-12-26 12:57:43',NULL,NULL),(14031,9163,'EM','dtaister@gmail.com',0,'2013-12-26 04:08:45',NULL,NULL),(20388,13132,'TE','4403969988',0,'2013-12-26 12:53:04',NULL,NULL),(14295,9350,'EM','abates@bellsouth.net',0,'2013-12-26 04:31:14',NULL,NULL),(41648,27684,'AP','4322221489',0,'2014-03-05 21:30:40',NULL,NULL),(32193,21027,'AP','4192968431',0,'2014-02-01 19:00:43',NULL,NULL),(29278,18910,'EM','tanyaanderson21@gmail.com',0,'2014-01-17 03:36:40',NULL,NULL),(6526,4221,'TE','2818930157',0,'2013-12-25 21:50:25',NULL,NULL),(9412,6160,'EM','ratmafi@yahoo.com',0,'2013-12-26 00:16:46',NULL,NULL),(2970,1839,'EM','kustom442@yahoo.com',0,'2013-12-25 18:57:37',NULL,NULL),(6167,3974,'AP','9374032971',0,'2013-12-25 21:38:40',NULL,NULL),(37095,24422,'EM','adixon13@live.com',0,'2014-02-18 22:01:08',NULL,NULL),(286,177,'TE','3307247439',0,'2013-12-25 17:19:34',NULL,NULL),(11472,7461,'TE','6017610930',0,'2013-12-26 02:30:56',NULL,NULL),(28409,18304,'EM','don@designassoc.com',0,'2014-01-16 08:44:58',NULL,NULL),(12231,7995,'AP','3303045712',0,'2013-12-26 03:08:15',NULL,NULL),(20550,13227,'AP','3612076165',0,'2013-12-26 12:55:39',NULL,NULL),(5279,3387,'TE','3376606476',0,'2013-12-25 21:17:43',NULL,NULL),(27268,17556,'TE','5129688551',0,'2014-01-13 03:01:58',NULL,NULL),(23744,15319,'AP','8065980581',1,'2014-01-02 04:23:29',NULL,NULL),(31794,20751,'TE','4197051155',0,'2014-01-30 21:01:30',NULL,NULL),(30947,20127,'EM','MSLudwig59@yahoo.com',0,'2014-01-27 21:00:50',NULL,NULL),(28513,18379,'AP','6812036216',0,'2014-01-16 08:45:34',NULL,NULL),(28130,18133,'EM','brdn_kt@yahoo.com',0,'2014-01-15 02:07:44',NULL,NULL),(36631,24114,'EM','kakis218@aol.com',0,'2014-02-15 22:01:39',NULL,NULL),(39764,26296,'TE','4196303913',0,'2014-02-28 06:31:26',NULL,NULL),(1618,995,'TE','9379034808',0,'2013-12-25 18:10:45',NULL,NULL),(25696,16567,'AP','5672496586',1,'2014-01-07 10:23:13',NULL,NULL),(8585,5642,'TE','8326981537',0,'2013-12-25 23:31:17',NULL,NULL),(8146,5330,'EM','mlaforce1@yahoo.com',0,'2013-12-25 23:07:06',NULL,NULL),(11445,7444,'TE','4194611776',0,'2013-12-26 02:30:31',NULL,NULL),(34453,22603,'AP','9374676103',0,'2014-02-10 21:32:16',NULL,NULL),(32476,21218,'AP','3188161346',0,'2014-02-03 21:01:03',NULL,NULL),(22104,14238,'TE','6017901706',0,'2013-12-27 02:05:10',NULL,NULL),(29928,19368,'TE','3306683052',1,'2014-01-22 03:22:35',NULL,NULL),(35302,23187,'EM','jlrose10@gmail.com',0,'2014-02-12 21:32:02',NULL,NULL),(40019,26515,'EM','keithdietrich@hotmail.com',0,'2014-02-28 21:00:22',NULL,NULL),(43936,29145,'TE','3145567080',0,'2014-03-10 21:02:45',NULL,NULL),(24302,15700,'EM','beachconnie@gmail.com',1,'2014-01-02 04:35:42',NULL,NULL),(34796,22824,'EM','jplum@fulfab.com',0,'2014-02-11 21:02:04',NULL,NULL),(33967,22284,'AP','3303271506',0,'2014-02-10 11:00:24',NULL,NULL),(31042,20193,'EM','sdmoranii@gmail.com',0,'2014-01-27 21:01:28',NULL,NULL),(9591,6278,'TE','5138506072',0,'2013-12-26 00:45:19',NULL,NULL),(20625,13269,'TE','8063825904',0,'2013-12-26 12:56:51',NULL,NULL),(10841,7038,'EM','sarakayt@hotmail.com',0,'2013-12-26 01:49:20',NULL,NULL),(11199,7282,'TE','5139411854',0,'2013-12-26 02:02:44',NULL,NULL),(37018,24372,'AP','9855189357',0,'2014-02-18 22:00:39',NULL,NULL),(40357,26785,'AP','9562516760',0,'2014-03-01 21:00:15',NULL,NULL),(21949,14139,'TE','3184612987',0,'2013-12-27 02:02:36',NULL,NULL),(10171,6646,'AP','8068313536',0,'2013-12-26 01:00:29',NULL,NULL),(7072,4619,'EM','rkp2176@gmail.com',0,'2013-12-25 22:06:11',NULL,NULL),(2000,1235,'EM','smithrd.esq@gmail.com',0,'2013-12-25 18:20:50',NULL,NULL),(13520,8817,'EM','gerding3626@msn.com',0,'2013-12-26 04:00:09',NULL,NULL),(30160,19541,'AP','4197898309',0,'2014-01-23 03:02:25',NULL,NULL),(42006,27921,'TE','8062817938',0,'2014-03-06 21:00:20',NULL,NULL),(43081,28640,'AP','9569704802',0,'2014-03-08 21:30:32',NULL,NULL),(43702,29014,'TE','3302125054',0,'2014-03-10 21:01:25',NULL,NULL),(43897,29124,'TE','4195922885',0,'2014-03-10 21:02:33',NULL,NULL),(2278,1397,'AP','5043220954',0,'2013-12-25 18:46:31',NULL,NULL),(14653,9584,'AP','6012591046',0,'2013-12-26 04:37:00',NULL,NULL),(31316,20406,'TE','5122216815',0,'2014-01-29 21:00:22',NULL,NULL),(6465,4181,'AP','3304641663',0,'2013-12-25 21:49:25',NULL,NULL),(20612,13256,'TE','2547395395',0,'2013-12-26 12:56:33',NULL,NULL),(37769,24925,'BN','6013474332',0,'2014-02-20 21:30:16',NULL,NULL),(5422,3470,'AP','7408911089',0,'2013-12-25 21:19:57',NULL,NULL),(33539,21988,'AP','4782580608',0,'2014-02-07 19:00:40',NULL,NULL),(33446,21908,'TE','2166314526',0,'2014-02-06 21:01:52',NULL,NULL),(24255,15674,'TE','4194654296',1,'2014-01-02 04:34:47',NULL,NULL),(32862,21506,'TE','4197242403',0,'2014-02-04 21:01:55',NULL,NULL),(32466,21211,'EM','bearj05@bellsouth.net',0,'2014-02-03 21:00:59',NULL,NULL),(10800,7018,'AP','2107255263',0,'2013-12-26 01:48:45',NULL,NULL),(26808,17242,'AP','5133098954',0,'2014-01-13 02:22:46',NULL,NULL),(20234,13035,'TE','5133685194',0,'2013-12-26 12:50:27',NULL,NULL),(21777,14031,'TE','4194430336',0,'2013-12-26 13:16:53',NULL,NULL),(35817,23553,'TE','4199538623',0,'2014-02-13 22:02:40',NULL,NULL),(38653,25545,'BN','5132840751',0,'2014-02-26 08:00:14',NULL,NULL),(38758,25622,'AP','2544589227',0,'2014-02-26 08:30:18',NULL,NULL),(712,443,'TE','6144751367',0,'2013-12-25 17:47:13',NULL,NULL),(24642,15889,'TE','5133096913',0,'2014-01-03 02:05:41',NULL,NULL),(14375,9400,'EM','LORETTA_MCKENZIE11@YAHOO.COM',0,'2013-12-26 04:32:34',NULL,NULL),(33103,21683,'TE','9376615415',0,'2014-02-05 21:31:03',NULL,NULL),(2023,1252,'TE','5136622703',0,'2013-12-25 18:21:17',NULL,NULL),(24435,15774,'BN','2543713459',0,'2014-01-03 02:01:56',NULL,NULL),(22713,14647,'AP','9038265641',1,'2013-12-29 11:07:38',NULL,NULL),(7724,5043,'TE','8325413915',0,'2013-12-25 22:48:04',NULL,NULL),(5569,3558,'TE','3306878584',0,'2013-12-25 21:22:13',NULL,NULL),(21271,13667,'EM','dknox5605@aol.com',0,'2013-12-26 13:07:49',NULL,NULL),(41011,27249,'EM','eta1minute@yahoo.com',0,'2014-03-03 21:31:52',NULL,NULL),(43341,28790,'TE','2819053056',0,'2014-03-09 21:00:41',NULL,NULL),(899,556,'EM','dmhfinancial@gmail.com',0,'2013-12-25 17:50:11',NULL,NULL),(12202,7972,'EM','jgehring62@yahoo.com',0,'2013-12-26 03:07:44',NULL,NULL),(11064,7187,'TE','6143543021',0,'2013-12-26 02:00:19',NULL,NULL),(10590,6892,'TE','2259216449',0,'2013-12-26 01:45:24',NULL,NULL),(33932,22269,'TE','4322229478',0,'2014-02-10 11:00:13',NULL,NULL),(12336,8069,'TE','4199738283',0,'2013-12-26 03:10:10',NULL,NULL),(22140,14259,'AP','5045592517',0,'2013-12-27 02:05:46',NULL,NULL),(29828,19297,'EM','ladyvhall0715@yahoo.com',1,'2014-01-22 03:21:59',NULL,NULL),(3926,2489,'TE','2258103370',0,'2013-12-25 19:35:46',NULL,NULL),(28427,18315,'AP','3304315484',0,'2014-01-16 08:45:04',NULL,NULL),(7424,4828,'AP','5672806135',0,'2013-12-25 22:17:16',NULL,NULL),(1062,653,'EM','rexmcdonald@ymail.com',0,'2013-12-25 18:01:40',NULL,NULL),(14262,9328,'AP','5134048598',0,'2013-12-26 04:30:42',NULL,NULL),(41169,27343,'TE','6142050823',0,'2014-03-04 21:01:00',NULL,NULL),(43863,29106,'EM','lwerling1@woh.rr.com',0,'2014-03-10 21:02:21',NULL,NULL),(85,51,'TE','6147352922',0,'2013-12-25 17:16:24',NULL,NULL),(33487,21943,'EM','Clkerr75@yahoo.com',0,'2014-02-07 19:00:17',NULL,NULL),(11850,7711,'EM','chris.alvarado@alumni.nd.edu',0,'2013-12-26 03:01:31',NULL,NULL),(30788,20018,'AP','3612290317',0,'2014-01-26 19:00:13',NULL,NULL),(22123,14251,'AP','8322214842',0,'2013-12-27 02:05:30',NULL,NULL),(28722,18535,'EM','mm_taraschke@yahoo.com',0,'2014-01-16 08:46:45',NULL,NULL),(11781,7664,'EM','dctfreak2000@yahoo.com',0,'2013-12-26 03:00:23',NULL,NULL),(25626,16526,'TE','3615262024',1,'2014-01-07 10:21:55',NULL,NULL),(22727,14656,'TE','3618131555',1,'2013-12-29 11:07:52',NULL,NULL),(14454,9443,'AP','3308530388',0,'2013-12-26 04:33:45',NULL,NULL),(31937,20848,'EM','barbarajenkins@earthlink.net',0,'2014-01-31 21:00:50',NULL,NULL),(29068,18772,'TE','2816302696',0,'2014-01-17 03:35:50',NULL,NULL),(8005,5223,'EM','peggy@ericguilliod.com',0,'2013-12-25 23:04:36',NULL,NULL),(26080,16796,'AP','7145889943',0,'2014-01-13 02:18:09',NULL,NULL),(39034,25812,'TE','3302093770',0,'2014-02-26 21:00:22',NULL,NULL),(41892,27855,'TE','5127553143',0,'2014-03-05 21:32:15',NULL,NULL),(2494,1531,'TE','6147841615',0,'2013-12-25 18:50:01',NULL,NULL),(8971,5882,'AP','4407854412',0,'2013-12-25 23:49:26',NULL,NULL),(33799,22190,'EM','ramseyo@comcast.net',0,'2014-02-09 19:00:09',NULL,NULL),(30915,20103,'TE','3372882445',0,'2014-01-27 21:00:36',NULL,NULL),(4082,2603,'AP','3305249333',0,'2013-12-25 19:45:24',NULL,NULL),(20877,13423,'TE','5133838130',0,'2013-12-26 13:00:53',NULL,NULL),(29003,18723,'TE','5137020043',0,'2014-01-17 03:35:35',NULL,NULL),(38175,25195,'BN','2253021804',0,'2014-02-21 22:00:43',NULL,NULL),(40791,27111,'TE','7409492494',0,'2014-03-03 21:30:26',NULL,NULL),(43258,28742,'TE','9853601461',0,'2014-03-09 21:00:10',NULL,NULL),(11075,7193,'EM','xmasocks@aol.com',0,'2013-12-26 02:00:28',NULL,NULL),(2355,1432,'TE','3183211909',0,'2013-12-25 18:47:35',NULL,NULL),(20587,13244,'TE','2147323925',0,'2013-12-26 12:56:11',NULL,NULL),(32654,21357,'TE','8175287206',0,'2014-02-04 21:00:41',NULL,NULL),(10376,6763,'TE','9858679113',0,'2013-12-26 01:16:24',NULL,NULL),(8543,5610,'EM','klb8711@yahoo.com',0,'2013-12-25 23:30:33',NULL,NULL),(25451,16412,'AP','8068318010',0,'2014-01-07 04:04:15',NULL,NULL),(36435,23994,'AP','9854133488',0,'2014-02-15 22:00:28',NULL,NULL),(41000,27241,'AP','5133005394',0,'2014-03-03 21:31:47',NULL,NULL),(32754,21428,'EM','ebormuth_breesefarmsllc@yahoo.com',0,'2014-02-04 21:01:17',NULL,NULL),(32402,21173,'TE','6143150669',0,'2014-02-03 21:00:39',NULL,NULL),(14004,9142,'EM','attorney_denise_ferguson@NEORR.com',0,'2013-12-26 04:08:14',NULL,NULL),(34114,22364,'TE','3302207700',0,'2014-02-10 21:00:09',NULL,NULL),(39505,26131,'TE','5134791443',0,'2014-02-28 06:30:23',NULL,NULL),(41856,27835,'TE','5672302208',0,'2014-03-05 21:32:03',NULL,NULL),(10023,6557,'TE','5124302367',0,'2013-12-26 00:52:20',NULL,NULL),(4366,2782,'EM','pam.moores@yahoo.com',0,'2013-12-25 19:49:55',NULL,NULL),(33493,21948,'TE','3304883139',0,'2014-02-07 19:00:20',NULL,NULL),(28415,18307,'EM','dunkinchloe@gmail.com',0,'2014-01-16 08:45:00',NULL,NULL),(27089,17422,'TE','3306349594',0,'2014-01-13 03:00:28',NULL,NULL),(26619,17126,'AP','4405212842',0,'2014-01-13 02:21:44',NULL,NULL),(33665,22082,'EM','aldawes@outlook.com',0,'2014-02-08 19:00:19',NULL,NULL),(38978,25772,'EM','bkbeki2000@yahoo.com',0,'2014-02-26 09:30:57',NULL,NULL),(43850,29101,'AP','5133714021',0,'2014-03-10 21:02:17',NULL,NULL),(8191,5359,'EM','LARRYAL3364@YAHOO.COM',0,'2013-12-25 23:07:49',NULL,NULL),(10662,6930,'TE','2163235232',0,'2013-12-26 01:46:30',NULL,NULL),(14579,9533,'AP','4253010168',0,'2013-12-26 04:35:50',NULL,NULL),(10624,6912,'TE','5042836009',0,'2013-12-26 01:45:57',NULL,NULL),(2760,1674,'AP','5135827626',0,'2013-12-25 18:53:57',NULL,NULL),(36856,24270,'TE','5136822550',0,'2014-02-17 19:00:17',NULL,NULL),(21870,14090,'TE','2163241021',0,'2013-12-27 02:01:20',NULL,NULL),(29970,19392,'BN','5136166523',1,'2014-01-22 03:22:49',NULL,NULL),(468,294,'EM','msloubr@gmail.com',0,'2013-12-25 17:30:39',NULL,NULL),(20322,13095,'AP','4403911228',0,'2013-12-26 12:52:00',NULL,NULL),(29209,18869,'TE','5043739981',0,'2014-01-17 03:36:23',NULL,NULL),(26520,17063,'TE','4697677656',0,'2014-01-13 02:21:13',NULL,NULL),(25387,16375,'TE','4322026328',0,'2014-01-07 04:03:07',NULL,NULL),(4886,3132,'TE','3305733349',0,'2013-12-25 20:30:33',NULL,NULL),(36223,23842,'TE','4198555012',0,'2014-02-14 21:31:53',NULL,NULL),(40155,26633,'AP','8179954871',0,'2014-02-28 21:30:58',NULL,NULL),(43564,28931,'AP','6143061122',0,'2014-03-10 21:00:37',NULL,NULL),(22268,14352,'AP','5134057793',0,'2013-12-28 03:30:03',NULL,NULL),(10828,7032,'EM','chris@chrisdrennon.com',0,'2013-12-26 01:49:09',NULL,NULL),(28031,18065,'AP','9854744115',0,'2014-01-15 02:07:22',NULL,NULL),(10304,6722,'EM','nonygray@gmail.com',0,'2013-12-26 01:15:16',NULL,NULL),(2403,1465,'TE','4406701443',0,'2013-12-25 18:48:25',NULL,NULL),(10215,6674,'EM','rogerlinde@hotmail.com',0,'2013-12-26 01:01:13',NULL,NULL),(26194,16860,'AP','8064748749',0,'2014-01-13 02:19:10',NULL,NULL),(14464,9448,'AP','4192175622',0,'2013-12-26 04:33:54',NULL,NULL),(34517,22642,'EM','hoxudhi@yahoo.com',0,'2014-02-11 21:00:23',NULL,NULL),(39938,26429,'TE','6148879079',0,'2014-02-28 07:30:15',NULL,NULL),(42300,28088,'TE','9564140584',0,'2014-03-06 21:02:02',NULL,NULL),(26773,17224,'TE','4198670029',0,'2014-01-13 02:22:35',NULL,NULL),(22047,14199,'AP','5125733888',0,'2013-12-27 02:04:12',NULL,NULL),(26193,16860,'TE','8064748749',0,'2014-01-13 02:19:10',NULL,NULL),(24411,15761,'TE','8302634602',0,'2014-01-03 02:01:30',NULL,NULL),(20424,13151,'AP','4406546196',0,'2013-12-26 12:53:37',NULL,NULL),(8681,5699,'AP','6415023982',0,'2013-12-25 23:32:52',NULL,NULL),(11387,7415,'TE','4402561006',0,'2013-12-26 02:16:50',NULL,NULL),(8342,5476,'AP','4194198484',0,'2013-12-25 23:10:43',NULL,NULL),(2765,1677,'TE','3184236172',0,'2013-12-25 18:54:02',NULL,NULL),(2978,1845,'TE','4409516154',0,'2013-12-25 18:57:45',NULL,NULL),(34315,22514,'AP','2545419663',0,'2014-02-10 21:31:21',NULL,NULL),(37682,24846,'EM','TONIK81@YAHOO.COM',0,'2014-02-20 04:54:35',NULL,NULL),(42079,27959,'EM','hlbyrdie@gmail.com',0,'2014-03-06 21:00:44',NULL,NULL),(10751,6989,'TE','5134770759',0,'2013-12-26 01:47:57',NULL,NULL),(10409,6786,'TE','9792569525',0,'2013-12-26 01:16:58',NULL,NULL),(22489,14500,'AP','8062237698',0,'2013-12-28 03:33:46',NULL,NULL),(25993,16748,'AP','9793328958',0,'2014-01-08 18:24:54',NULL,NULL),(1995,1230,'EM','thomasrains01@gmail.com',0,'2013-12-25 18:20:42',NULL,NULL),(2300,1408,'AP','7732187521',0,'2013-12-25 18:46:50',NULL,NULL),(2313,1413,'TE','2258922321',0,'2013-12-25 18:47:00',NULL,NULL),(14633,9570,'TE','5805149160',0,'2013-12-26 04:36:42',NULL,NULL),(8011,5229,'EM','lprops@neo.rr.com',0,'2013-12-25 23:04:45',NULL,NULL),(11902,7743,'TE','5133733544',0,'2013-12-26 03:02:20',NULL,NULL),(35189,23113,'TE','5134076669',0,'2014-02-12 21:31:19',NULL,NULL),(35649,23439,'AP','2815360395',0,'2014-02-13 22:01:32',NULL,NULL),(38792,25645,'EM','missjunks@gmail.com',0,'2014-02-26 08:30:34',NULL,NULL),(21721,13994,'TE','4193941234',0,'2013-12-26 13:15:53',NULL,NULL),(20194,13010,'TE','6143194936',0,'2013-12-26 12:49:47',NULL,NULL),(5588,3571,'TE','9374595579',0,'2013-12-25 21:22:35',NULL,NULL),(6466,4182,'TE','4403154427',0,'2013-12-25 21:49:26',NULL,NULL),(27859,17949,'TE','3616767371',0,'2014-01-15 02:06:42',NULL,NULL),(26452,17028,'EM','drdnot@aol.com',0,'2014-01-13 02:20:43',NULL,NULL),(2497,1532,'TE','3306672923',0,'2013-12-25 18:50:03',NULL,NULL),(23811,15362,'TE','9373212846',1,'2014-01-02 04:24:49',NULL,NULL),(36639,24120,'TE','8327032548',0,'2014-02-15 22:01:42',NULL,NULL),(42778,28451,'BN','2258196551',0,'2014-03-07 21:31:20',NULL,NULL),(42796,28461,'TE','3372581716',0,'2014-03-07 21:31:25',NULL,NULL),(902,559,'AP','9174767638',0,'2013-12-25 17:50:15',NULL,NULL),(34112,22362,'EM','cthornton7@cox.net',0,'2014-02-10 21:00:09',NULL,NULL),(1715,1052,'TE','8309971119',0,'2013-12-25 18:16:05',NULL,NULL),(22206,14304,'AP','4195864822',0,'2013-12-27 02:06:56',NULL,NULL),(31224,20335,'AP','3305252012',0,'2014-01-28 21:01:04',NULL,NULL),(25291,16308,'TE','3182823142',0,'2014-01-07 04:01:21',NULL,NULL),(36841,24261,'TE','2252530309',0,'2014-02-17 19:00:10',NULL,NULL),(14796,9685,'TE','5133140552',0,'2013-12-26 04:39:33',NULL,NULL),(32788,21453,'TE','3308084306',0,'2014-02-04 21:01:29',NULL,NULL),(23414,15083,'TE','9567223834',0,'2014-01-01 12:04:14',NULL,NULL),(9863,6450,'TE','4196865464',0,'2013-12-26 00:49:38',NULL,NULL),(26584,17103,'EM','ron0434@sbcglobal.net',0,'2014-01-13 02:21:33',NULL,NULL),(6000,3854,'TE','3183770198',0,'2013-12-25 21:35:44',NULL,NULL),(6563,4238,'AP','2817401157',0,'2013-12-25 21:50:56',NULL,NULL),(40354,26783,'TE','2812429462',0,'2014-03-01 21:00:14',NULL,NULL),(40813,27120,'AP','4404742334',0,'2014-03-03 21:30:33',NULL,NULL),(32414,21181,'TE','9012887592',0,'2014-02-03 21:00:43',NULL,NULL),(30056,19470,'EM','jamiharris65@Yahoo.com',0,'2014-01-23 03:01:59',NULL,NULL),(26852,17277,'EM','Shavitressc14@gmail.com',0,'2014-01-13 02:23:24',NULL,NULL),(22940,14799,'AP','4403917830',1,'2013-12-29 11:13:43',NULL,NULL),(41539,27622,'TE','3377393639',0,'2014-03-05 21:30:04',NULL,NULL),(31931,20843,'EM','dealindustrial@gmail.com',0,'2014-01-31 21:00:48',NULL,NULL),(9721,6363,'TE','2164702366',0,'2013-12-26 00:47:25',NULL,NULL),(10311,6726,'EM','revreece7@ameritech.net',0,'2013-12-26 01:15:22',NULL,NULL),(28718,18532,'AP','4193080590',0,'2014-01-16 08:46:44',NULL,NULL),(28663,18487,'AP','4407493900',0,'2014-01-16 08:46:24',NULL,NULL),(3185,2001,'AP','8176816774',0,'2013-12-25 19:02:12',NULL,NULL),(28078,18095,'TE','3187247448',0,'2014-01-15 02:07:32',NULL,NULL),(27932,17997,'TE','4196834154',0,'2014-01-15 02:06:59',NULL,NULL),(26819,17248,'AP','4408557044',0,'2014-01-13 02:23:10',NULL,NULL),(1120,687,'AP','2163968822',0,'2013-12-25 18:02:33',NULL,NULL),(5138,3291,'EM','lowellslandscapes@cinci.rr.com',0,'2013-12-25 21:15:32',NULL,NULL),(35626,23425,'EM','diana375@gmail.com',0,'2014-02-13 22:01:25',NULL,NULL),(42665,28383,'TE','3302831628',0,'2014-03-07 21:30:41',NULL,NULL),(43553,28924,'TE','4408120447',0,'2014-03-10 21:00:32',NULL,NULL),(27666,17833,'AP','6012097172',0,'2014-01-15 02:06:00',NULL,NULL),(27496,17713,'TE','2252211261',0,'2014-01-14 01:33:11',NULL,NULL),(3616,2286,'AP','5132955085',0,'2013-12-25 19:30:39',NULL,NULL),(2404,1465,'AP','4406701443',0,'2013-12-25 18:48:26',NULL,NULL),(26882,17296,'TE','9032270952',0,'2014-01-13 02:23:36',NULL,NULL),(39392,26049,'TE','3307301049',0,'2014-02-26 21:02:32',NULL,NULL),(40506,26882,'AP','4193021688',0,'2014-03-01 21:01:10',NULL,NULL),(42846,28495,'TE','6019405221',0,'2014-03-07 21:31:44',NULL,NULL),(20584,13243,'TE','8062396090',0,'2013-12-26 12:56:09',NULL,NULL),(4621,2946,'TE','5133764120',0,'2013-12-25 20:16:24',NULL,NULL),(8088,5293,'EM','alicecrmb@yahoo.com',0,'2013-12-25 23:06:06',NULL,NULL),(36316,23914,'TE','3306269222',0,'2014-02-14 22:00:04',NULL,NULL),(39897,26403,'BN','4193029638',0,'2014-02-28 07:00:33',NULL,NULL),(41375,27485,'TE','3307606432',0,'2014-03-04 21:02:20',NULL,NULL),(33633,22053,'EM','chavira_jorge@yahoo.com',0,'2014-02-08 19:00:06',NULL,NULL),(25066,16159,'TE','6143162702',0,'2014-01-04 06:00:09',NULL,NULL),(24195,15631,'EM','browntyesha@yahoo.com',1,'2014-01-02 04:33:29',NULL,NULL),(9409,6159,'EM','chefasa@gmail.com',0,'2013-12-26 00:16:43',NULL,NULL),(33390,21877,'EM','roadjet728@gmail.com',0,'2014-02-06 21:01:29',NULL,NULL),(8664,5690,'TE','5133416696',0,'2013-12-25 23:32:35',NULL,NULL),(3604,2272,'TE','9374430990',0,'2013-12-25 19:30:25',NULL,NULL),(35394,23262,'AP','3308023130',0,'2014-02-13 21:30:10',NULL,NULL),(38416,25382,'AP','2289180792',0,'2014-02-25 21:30:47',NULL,NULL),(40035,26538,'TE','5136583530',0,'2014-02-28 21:30:06',NULL,NULL),(41866,27839,'AP','2108722773',0,'2014-03-05 21:32:06',NULL,NULL),(42179,28018,'TE','7408020560',0,'2014-03-06 21:01:20',NULL,NULL),(33819,22205,'EM','scdarby@ameritech.net',0,'2014-02-09 19:00:17',NULL,NULL),(33445,21907,'AP','6019515449',0,'2014-02-06 21:01:51',NULL,NULL),(7227,4706,'TE','4195083268',0,'2013-12-25 22:08:35',NULL,NULL),(29846,19309,'EM','mlujan1475@aol.com',1,'2014-01-22 03:22:05',NULL,NULL),(27442,17678,'TE','5048583191',0,'2014-01-14 01:32:53',NULL,NULL),(43645,28969,'AP','3376543928',0,'2014-03-10 21:01:01',NULL,NULL),(22053,14203,'AP','5122764186',0,'2013-12-27 02:04:18',NULL,NULL),(6906,4497,'AP','9033939088',0,'2013-12-25 22:03:16',NULL,NULL),(9000,5906,'EM','psasi36@gmail.com',0,'2013-12-25 23:49:55',NULL,NULL),(9018,5916,'TE','7135780031',0,'2013-12-25 23:50:11',NULL,NULL),(32192,21027,'TE','4192968431',0,'2014-02-01 19:00:43',NULL,NULL),(30078,19486,'TE','9033537813',0,'2014-01-23 03:02:05',NULL,NULL),(29322,18949,'TE','9723884021',0,'2014-01-20 08:05:47',NULL,NULL),(27909,17983,'TE','4402276074',0,'2014-01-15 02:06:54',NULL,NULL),(28059,18086,'TE','3184196946',0,'2014-01-15 02:07:28',NULL,NULL),(29262,18898,'TE','4192271923',0,'2014-01-17 03:36:35',NULL,NULL),(24599,15864,'AP','6624710972',0,'2014-01-03 02:04:53',NULL,NULL),(27420,17660,'AP','9372322355',0,'2014-01-14 01:32:45',NULL,NULL),(26875,17292,'AP','3617797652',0,'2014-01-13 02:23:33',NULL,NULL),(12368,8093,'EM','tim_miller@portagechapel.com',0,'2013-12-26 03:10:47',NULL,NULL),(9191,6017,'TE','2162442393',0,'2013-12-26 00:00:44',NULL,NULL),(2886,1766,'AP','6146380216',0,'2013-12-25 18:56:03',NULL,NULL),(36972,24343,'EM','mmalooly1@tx.rr.com',0,'2014-02-18 22:00:21',NULL,NULL),(37119,24437,'EM','Brian.Kurr@Gmail.com',0,'2014-02-18 22:01:17',NULL,NULL),(38348,25333,'TE','2255050429',0,'2014-02-25 21:30:19',NULL,NULL),(40550,26911,'AP','2253859214',0,'2014-03-03 01:00:12',NULL,NULL),(44015,29212,'TE','4194968115',0,'2014-03-10 21:30:17',NULL,NULL),(21827,14062,'TE','3307309805',0,'2013-12-27 02:00:36',NULL,NULL),(21303,13685,'AP','2163144336',0,'2013-12-26 13:08:19',NULL,NULL),(35813,23549,'AP','8325731388',0,'2014-02-13 22:02:37',NULL,NULL),(38309,25300,'EM','ECLARKEVA@GMAIL.COM',0,'2014-02-25 21:00:28',NULL,NULL),(38513,25451,'TE','9155390104',0,'2014-02-25 21:31:26',NULL,NULL),(33949,22277,'TE','9366155119',0,'2014-02-10 11:00:18',NULL,NULL),(10783,7009,'EM','sarag300@yahoo.com',0,'2013-12-26 01:48:29',NULL,NULL),(12283,8034,'AP','4193489641',0,'2013-12-26 03:09:15',NULL,NULL),(10164,6643,'AP','4327411532',0,'2013-12-26 01:00:23',NULL,NULL),(14660,9591,'TE','6016681178',0,'2013-12-26 04:37:09',NULL,NULL),(8244,5393,'TE','3183086370',0,'2013-12-25 23:08:43',NULL,NULL),(27802,17919,'TE','5127697784',0,'2014-01-15 02:06:30',NULL,NULL),(21676,13957,'TE','5137539327',0,'2013-12-26 13:15:02',NULL,NULL),(37108,24430,'TE','3307694225',0,'2014-02-18 22:01:13',NULL,NULL),(39638,26211,'AP','3303577582',0,'2014-02-28 06:30:53',NULL,NULL),(42670,28385,'EM','veggiefruit14@gmail.com',0,'2014-03-07 21:30:42',NULL,NULL),(1442,878,'EM','michaelhall881@gmail.com',0,'2013-12-25 18:07:39',NULL,NULL),(34870,22868,'TE','3304233196',0,'2014-02-11 21:02:29',NULL,NULL),(32055,20929,'TE','6015000124',0,'2014-01-31 21:01:36',NULL,NULL),(2321,1416,'AP','5044443671',0,'2013-12-25 18:47:06',NULL,NULL),(8301,5438,'TE','5043474303',0,'2013-12-25 23:09:52',NULL,NULL),(26334,16951,'AP','6014989859',0,'2014-01-13 02:20:00',NULL,NULL),(23037,14860,'AP','2282654006',1,'2013-12-29 11:15:20',NULL,NULL),(35356,23230,'AP','3305545426',0,'2014-02-12 21:32:25',NULL,NULL),(39693,26249,'AP','4095945922',0,'2014-02-28 06:31:08',NULL,NULL),(40519,26893,'AP','5135185732',0,'2014-03-03 01:00:04',NULL,NULL),(24502,15806,'AP','3373054059',0,'2014-01-03 02:03:03',NULL,NULL),(21740,14004,'AP','9374778618',0,'2013-12-26 13:16:11',NULL,NULL),(22970,14815,'TE','5139673682',1,'2013-12-29 11:14:12',NULL,NULL),(30235,19584,'AP','6014335636',0,'2014-01-23 03:02:42',NULL,NULL),(8859,5805,'TE','9032768598',0,'2013-12-25 23:47:37',NULL,NULL),(8270,5418,'TE','7692160246',0,'2013-12-25 23:09:19',NULL,NULL),(7761,5065,'AP','5128220856',0,'2013-12-25 23:00:34',NULL,NULL),(6935,4518,'AP','2145078737',0,'2013-12-25 22:03:47',NULL,NULL),(4841,3098,'EM','williak@ccf.org',0,'2013-12-25 20:20:11',NULL,NULL),(43547,28912,'AP','5135157325',0,'2014-03-10 21:00:27',NULL,NULL),(329,205,'EM','garyasolomon@gmail.com',0,'2013-12-25 17:20:18',NULL,NULL),(7454,4853,'AP','9377659953',0,'2013-12-25 22:30:26',NULL,NULL),(7236,4712,'EM','jimrode@hotmail.com',0,'2013-12-25 22:08:45',NULL,NULL),(9955,6513,'TE','3305729498',0,'2013-12-26 00:51:12',NULL,NULL),(11570,7529,'TE','2542145182',0,'2013-12-26 02:32:38',NULL,NULL),(38728,25600,'EM','avilescarlos009@gmail.com',0,'2014-02-26 08:00:50',NULL,NULL),(42747,28432,'AP','4197336700',0,'2014-03-07 21:31:09',NULL,NULL),(27114,17444,'TE','4196915384',0,'2014-01-13 03:00:37',NULL,NULL),(25548,16480,'EM','Tweetiecamaro1@aol.com',0,'2014-01-07 04:06:15',NULL,NULL),(27887,17970,'AP','4407968330',0,'2014-01-15 02:06:49',NULL,NULL),(2097,1295,'EM','Cesarnn007@hotmail.com',0,'2013-12-25 18:30:59',NULL,NULL),(8766,5747,'TE','3609090037',0,'2013-12-25 23:46:06',NULL,NULL),(20580,13241,'EM','jkhannan@gmail.com',0,'2013-12-26 12:56:05',NULL,NULL),(11413,7426,'TE','3302194211',0,'2013-12-26 02:17:12',NULL,NULL),(11481,7466,'EM','wendyjg123@gmail.com',0,'2013-12-26 02:31:04',NULL,NULL),(7326,4763,'AP','9377895000',0,'2013-12-25 22:15:37',NULL,NULL),(4721,3022,'AP','3306000583',0,'2013-12-25 20:18:11',NULL,NULL),(4687,2999,'TE','5135509077',0,'2013-12-25 20:17:36',NULL,NULL),(4595,2932,'AP','9379023941',0,'2013-12-25 20:16:02',NULL,NULL),(13807,8999,'TE','3308676062',0,'2013-12-26 04:04:49',NULL,NULL),(36134,23780,'EM','wiggins.tiffany@gmail.com',0,'2014-02-14 21:31:19',NULL,NULL),(37864,24977,'AP','8326201633',0,'2014-02-20 22:00:32',NULL,NULL),(41060,27278,'AP','9152403847',0,'2014-03-04 21:00:21',NULL,NULL),(42711,28408,'EM','www.g45pno@mac.com',0,'2014-03-07 21:30:56',NULL,NULL),(34576,22672,'TE','9406136650',0,'2014-02-11 21:00:42',NULL,NULL),(33568,22010,'TE','7403575597',0,'2014-02-07 19:00:51',NULL,NULL),(32746,21422,'AP','5132589243',0,'2014-02-04 21:01:14',NULL,NULL),(8227,5385,'TE','6196062686',0,'2013-12-25 23:08:29',NULL,NULL),(26431,17006,'TE','2169048435',0,'2014-01-13 02:20:34',NULL,NULL),(2357,1433,'TE','5049313982',0,'2013-12-25 18:47:37',NULL,NULL),(11872,7728,'TE','5137527221',0,'2013-12-26 03:01:56',NULL,NULL),(36214,23837,'AP','5133250620',0,'2014-02-14 21:31:49',NULL,NULL),(36623,24110,'EM','Margiehart55@hotmail.com',0,'2014-02-15 22:01:36',NULL,NULL),(38627,25531,'AP','9032613576',0,'2014-02-26 08:00:05',NULL,NULL),(40016,26513,'AP','4196010097',0,'2014-02-28 21:00:21',NULL,NULL),(3935,2495,'EM','cbright41@cox.net',0,'2013-12-25 19:35:55',NULL,NULL),(27539,17748,'TE','4192509227',0,'2014-01-14 01:33:26',NULL,NULL),(8078,5289,'TE','3303175564',0,'2013-12-25 23:05:59',NULL,NULL),(21760,14018,'TE','9373792083',0,'2013-12-26 13:16:32',NULL,NULL),(5071,3258,'AP','3306077220',0,'2013-12-25 20:46:46',NULL,NULL),(36901,24302,'AP','8305708742',0,'2014-02-18 21:30:20',NULL,NULL),(40136,26619,'EM','STORIWILLINGHAM@YAHOO.COM',0,'2014-02-28 21:30:51',NULL,NULL),(27950,18009,'TE','6148774814',0,'2014-01-15 02:07:03',NULL,NULL),(23056,14872,'AP','9404530810',0,'2013-12-30 00:00:15',NULL,NULL),(3153,1969,'AP','8176816774',0,'2013-12-25 19:01:26',NULL,NULL),(1284,782,'TE','9366976789',0,'2013-12-25 18:05:05',NULL,NULL),(10722,6973,'AP','5132630514',0,'2013-12-26 01:47:30',NULL,NULL),(9766,6386,'AP','4405378970',0,'2013-12-26 00:48:04',NULL,NULL),(34287,22494,'AP','4193188787',0,'2014-02-10 21:31:10',NULL,NULL),(128,75,'TE','5136156899',0,'2013-12-25 17:17:02',NULL,NULL),(4293,2741,'TE','3306033903',0,'2013-12-25 19:48:48',NULL,NULL),(31689,20671,'AP','7692202545',0,'2014-01-30 21:00:50',NULL,NULL),(11133,7236,'TE','3183057810',0,'2013-12-26 02:01:33',NULL,NULL),(32318,21113,'AP','9039106481',0,'2014-02-03 21:00:09',NULL,NULL),(39592,26190,'EM','manal7646@gmail.com',0,'2014-02-28 06:30:44',NULL,NULL),(39644,26214,'EM','viczngr52@hotmail.com',0,'2014-02-28 06:30:54',NULL,NULL),(42723,28418,'TE','3304184317',0,'2014-03-07 21:31:01',NULL,NULL),(43284,28757,'EM','skeen_james@yahoo.com',0,'2014-03-09 21:00:20',NULL,NULL),(43352,28795,'TE','8178251608',0,'2014-03-09 21:00:44',NULL,NULL),(127,74,'TE','4195299917',0,'2013-12-25 17:17:01',NULL,NULL),(24595,15863,'TE','6624710972',0,'2014-01-03 02:04:51',NULL,NULL),(8734,5727,'EM','peacemaker19@charter.net',0,'2013-12-25 23:45:35',NULL,NULL),(8464,5569,'EM','mikescrivs@aol.com',0,'2013-12-25 23:16:39',NULL,NULL),(20926,13456,'TE','9372721622',0,'2013-12-26 13:01:38',NULL,NULL),(10988,7137,'AP','2812827669',0,'2013-12-26 01:51:49',NULL,NULL),(6439,4161,'EM','lennycybulski@yahoo.com',0,'2013-12-25 21:48:59',NULL,NULL),(36296,23898,'AP','4192047412',0,'2014-02-14 21:32:22',NULL,NULL),(40112,26602,'TE','9159260240',0,'2014-02-28 21:30:42',NULL,NULL),(27803,17919,'AP','5127697784',0,'2014-01-15 02:06:30',NULL,NULL),(23993,15487,'EM','JGOSBORNE17@GMAIL.COM',1,'2014-01-02 04:29:22',NULL,NULL),(22859,14750,'AP','7406491378',1,'2013-12-29 11:10:17',NULL,NULL),(6333,4084,'TE','3308823997',0,'2013-12-25 21:47:14',NULL,NULL),(8933,5849,'TE','4693608909',0,'2013-12-25 23:48:44',NULL,NULL),(8872,5812,'TE','9038964117',0,'2013-12-25 23:47:49',NULL,NULL),(14669,9597,'TE','3306878584',0,'2013-12-26 04:37:19',NULL,NULL),(34415,22576,'AP','5133077483',0,'2014-02-10 21:32:00',NULL,NULL),(40199,26665,'TE','5042378299',0,'2014-02-28 21:31:14',NULL,NULL),(41127,27318,'TE','9038247951',0,'2014-03-04 21:00:44',NULL,NULL),(42662,28382,'TE','2162256840',0,'2014-03-07 21:30:40',NULL,NULL),(27345,17607,'EM','Jstoombs2011@yahoo.com',0,'2014-01-14 01:32:19',NULL,NULL),(25538,16474,'AP','3303885969',0,'2014-01-07 04:06:03',NULL,NULL),(364,223,'EM','r_judice@yahoo.com',0,'2013-12-25 17:20:50',NULL,NULL),(718,447,'EM','jdetrick@kenapi.com',0,'2013-12-25 17:47:19',NULL,NULL),(14205,9295,'TE','5134107261',0,'2013-12-26 04:16:13',NULL,NULL),(14425,9429,'TE','2147349927',0,'2013-12-26 04:33:21',NULL,NULL),(42917,28540,'TE','3259393814',0,'2014-03-07 21:32:13',NULL,NULL),(43885,29119,'TE','6012129684',0,'2014-03-10 21:02:29',NULL,NULL),(13620,8879,'TE','2105583672',0,'2013-12-26 04:01:45',NULL,NULL),(7545,4915,'TE','7048375624',0,'2013-12-25 22:32:14',NULL,NULL),(30795,20023,'AP','3188347065',0,'2014-01-26 19:00:16',NULL,NULL),(1388,848,'AP','2252875233',0,'2013-12-25 18:06:49',NULL,NULL),(1568,967,'TE','8306291506',0,'2013-12-25 18:09:55',NULL,NULL),(24000,15491,'TE','7409741955',1,'2014-01-02 04:29:31',NULL,NULL),(5842,3747,'EM','shakeydeal13@yahoo.com',0,'2013-12-25 21:33:05',NULL,NULL),(28433,18318,'AP','7406072359',0,'2014-01-16 08:45:06',NULL,NULL),(8769,5748,'TE','3189907573',0,'2013-12-25 23:46:08',NULL,NULL),(495,314,'EM','masheats@hotmail.com',0,'2013-12-25 17:31:08',NULL,NULL),(26059,16786,'TE','3305947020',0,'2014-01-08 18:25:07',NULL,NULL),(5184,3329,'TE','5132009782',0,'2013-12-25 21:16:15',NULL,NULL),(38255,25255,'EM','venetian2@sbcglobal.net',0,'2014-02-21 22:01:17',NULL,NULL),(39260,25975,'TE','6144758681',0,'2014-02-26 21:01:48',NULL,NULL),(32082,20951,'AP','2819232291',0,'2014-02-01 19:00:05',NULL,NULL),(29493,19062,'TE','9562427172',0,'2014-01-21 08:44:15',NULL,NULL),(5091,3267,'TE','5044160081',0,'2013-12-25 20:47:05',NULL,NULL),(41290,27434,'TE','5045799144',0,'2014-03-04 21:01:48',NULL,NULL),(43017,28604,'TE','4404977608',0,'2014-03-08 21:30:11',NULL,NULL),(31762,20729,'TE','3304004848',0,'2014-01-30 21:01:18',NULL,NULL),(29220,18874,'TE','5047018964',0,'2014-01-17 03:36:25',NULL,NULL),(26427,17004,'EM','auburnangel1980@gmail.com',0,'2014-01-13 02:20:33',NULL,NULL),(23678,15288,'EM','lovenlez35@gmail.com',1,'2014-01-02 04:22:22',NULL,NULL),(2806,1699,'TE','4193436544',0,'2013-12-25 18:54:39',NULL,NULL),(5353,3430,'TE','3373814609',0,'2013-12-25 21:18:54',NULL,NULL),(38455,25411,'TE','3307808867',0,'2014-02-25 21:31:03',NULL,NULL),(38927,25734,'TE','3373294777',0,'2014-02-26 09:30:37',NULL,NULL),(39334,26020,'TE','9568905499',0,'2014-02-26 21:02:14',NULL,NULL),(41451,27538,'AP','3302096445',0,'2014-03-04 21:30:06',NULL,NULL),(11515,7492,'EM','witt.naomi@gmail.com',0,'2013-12-26 02:31:39',NULL,NULL),(30615,19870,'TE','5133308968',0,'2014-01-24 21:00:40',NULL,NULL),(22633,14594,'AP','3303109592',0,'2013-12-28 03:36:12',NULL,NULL),(5201,3342,'AP','5129471047',0,'2013-12-25 21:16:31',NULL,NULL),(5117,3278,'EM','nessabutterfly80@gmail.com',0,'2013-12-25 21:15:12',NULL,NULL),(39530,26148,'TE','5133864932',0,'2014-02-28 06:30:28',NULL,NULL),(42163,28008,'AP','5136926985',0,'2014-03-06 21:01:14',NULL,NULL),(30515,19795,'TE','9378695723',0,'2014-01-23 21:01:44',NULL,NULL),(26187,16857,'EM','karlaingram@att.net',0,'2014-01-13 02:19:08',NULL,NULL),(9905,6484,'TE','2165136533',0,'2013-12-26 00:50:23',NULL,NULL),(1134,697,'TE','5134241753',0,'2013-12-25 18:02:48',NULL,NULL),(6392,4121,'TE','6148759683',0,'2013-12-25 21:48:11',NULL,NULL),(5406,3459,'TE','5134020998',0,'2013-12-25 21:19:43',NULL,NULL),(3748,2378,'TE','4405678483',0,'2013-12-25 19:32:56',NULL,NULL),(26822,17249,'AP','4408557044',0,'2014-01-13 02:23:11',NULL,NULL),(20803,13366,'EM','winnipeg16@msn.com',0,'2013-12-26 12:59:38',NULL,NULL),(5631,3608,'AP','3307054789',0,'2013-12-25 21:23:25',NULL,NULL),(4692,3002,'TE','3302311143',0,'2013-12-25 20:17:41',NULL,NULL),(5704,3662,'AP','6146227536',0,'2013-12-25 21:30:55',NULL,NULL),(6653,4316,'AP','5132396554',0,'2013-12-25 21:52:41',NULL,NULL),(3290,2068,'EM','mandaw519@gmail.com',0,'2013-12-25 19:16:18',NULL,NULL),(11778,7663,'TE','2256145743',0,'2013-12-26 03:00:21',NULL,NULL),(36654,24128,'TE','5044009168',0,'2014-02-15 22:01:47',NULL,NULL),(44013,29211,'TE','8175681272',0,'2014-03-10 21:30:16',NULL,NULL),(3613,2285,'AP','7343010089',0,'2013-12-25 19:30:37',NULL,NULL),(7252,4726,'EM','es@tasteoftoledo.com',0,'2013-12-25 22:09:04',NULL,NULL),(2465,1512,'AP','6143616301',0,'2013-12-25 18:49:33',NULL,NULL),(37426,24645,'AP','5043449068',0,'2014-02-20 04:21:22',NULL,NULL),(40236,26690,'TE','5049121440',0,'2014-02-28 21:31:28',NULL,NULL),(42168,28012,'EM','jimpytlik@aol.com',0,'2014-03-06 21:01:16',NULL,NULL),(43296,28766,'TE','3054944130',0,'2014-03-09 21:00:26',NULL,NULL),(20703,13308,'EM','ANNDEIGH@SBCGLOBAL.NET',0,'2013-12-26 12:58:01',NULL,NULL),(13915,9072,'EM','Crawbuick@yahoo.com',0,'2013-12-26 04:06:40',NULL,NULL),(1833,1134,'AP','4106032905',0,'2013-12-25 18:18:09',NULL,NULL),(7409,4819,'TE','5137611813',0,'2013-12-25 22:17:01',NULL,NULL),(5515,3528,'EM','moxymadiera@gmail.com',0,'2013-12-25 21:21:26',NULL,NULL),(7062,4611,'AP','3304149700',0,'2013-12-25 22:05:59',NULL,NULL),(34243,22459,'AP','8325121341',0,'2014-02-10 21:30:52',NULL,NULL),(39732,26277,'EM','beatricepmitchell@yahoo.com',0,'2014-02-28 06:31:19',NULL,NULL),(40770,27093,'AP','3303045712',0,'2014-03-03 21:30:18',NULL,NULL),(31831,20781,'AP','2542897777',0,'2014-01-31 21:00:09',NULL,NULL),(11952,7786,'TE','9037852518',0,'2013-12-26 03:03:19',NULL,NULL),(5688,3654,'TE','4405931684',0,'2013-12-25 21:30:42',NULL,NULL),(11979,7805,'TE','2546690291',0,'2013-12-26 03:03:47',NULL,NULL),(8644,5678,'EM','steve.c.mcgarvey@gmail.com',0,'2013-12-25 23:32:15',NULL,NULL),(2890,1769,'EM','davejellison@ymail.com',0,'2013-12-25 18:56:07',NULL,NULL),(8541,5610,'TE','5132521826',0,'2013-12-25 23:30:32',NULL,NULL),(38099,25148,'TE','9784950686',0,'2014-02-21 22:00:15',NULL,NULL),(42978,28581,'EM','nllewis45@yahoo.com',0,'2014-03-08 21:00:08',NULL,NULL),(31482,20515,'AP','8328848464',0,'2014-01-29 21:01:22',NULL,NULL),(24898,16050,'AP','5136041685',0,'2014-01-04 02:03:11',NULL,NULL),(24304,15701,'AP','4194661928',1,'2014-01-02 04:35:43',NULL,NULL),(5738,3677,'AP','6146576608',0,'2013-12-25 21:31:22',NULL,NULL),(23522,15173,'TE','5133146905',0,'2014-01-01 12:06:38',NULL,NULL),(2362,1434,'TE','3377811269',0,'2013-12-25 18:47:40',NULL,NULL),(5699,3659,'AP','5135038460',0,'2013-12-25 21:30:50',NULL,NULL),(38439,25403,'AP','3309930509',0,'2014-02-25 21:30:57',NULL,NULL),(26701,17176,'EM','kmazur35@yahoo.com',0,'2014-01-13 02:22:10',NULL,NULL),(11756,7651,'AP','8174750297',0,'2013-12-26 02:46:53',NULL,NULL),(10883,7068,'AP','7405907458',0,'2013-12-26 01:50:04',NULL,NULL),(14799,9687,'TE','4193056218',0,'2013-12-26 04:39:36',NULL,NULL),(1739,1069,'EM','Jane.Hilf@yahoo.com',0,'2013-12-25 18:16:29',NULL,NULL),(34720,22765,'AP','6145580722',0,'2014-02-11 21:01:35',NULL,NULL),(37269,24523,'TE','9792192926',0,'2014-02-20 03:58:23',NULL,NULL),(37771,24927,'TE','3147570616',0,'2014-02-20 21:30:17',NULL,NULL),(21272,13668,'TE','5044563876',0,'2013-12-26 13:07:50',NULL,NULL),(8529,5604,'EM','gregoryaxelrud@hotmail.com',0,'2013-12-25 23:30:22',NULL,NULL),(13819,9006,'TE','2346785483',0,'2013-12-26 04:05:00',NULL,NULL),(8098,5303,'TE','4194245967',0,'2013-12-25 23:06:20',NULL,NULL),(12076,7886,'EM','gmccoy80@yahoo.com',0,'2013-12-26 03:05:31',NULL,NULL),(14151,9264,'TE','6019555838',0,'2013-12-26 04:15:25',NULL,NULL),(7242,4717,'EM','barbcooper@mac.com',0,'2013-12-25 22:08:53',NULL,NULL),(7265,4736,'AP','9373363442',0,'2013-12-25 22:09:18',NULL,NULL),(33555,21998,'TE','3372585696',0,'2014-02-07 19:00:46',NULL,NULL),(34096,22349,'TE','4198681552',0,'2014-02-10 11:01:14',NULL,NULL),(35506,23348,'AP','6146686880',0,'2014-02-13 22:00:40',NULL,NULL),(36459,24006,'EM','hvreinhart@gmail.com',0,'2014-02-15 22:00:37',NULL,NULL),(40619,26963,'AP','2162692333',0,'2014-03-03 01:00:31',NULL,NULL),(41270,27424,'EM','cmbnola@gmail.com',0,'2014-03-04 21:01:41',NULL,NULL),(24285,15692,'AP','4193508629',1,'2014-01-02 04:35:25',NULL,NULL),(14061,9191,'AP','4194946433',0,'2013-12-26 04:09:24',NULL,NULL),(8383,5518,'TE','2166623960',0,'2013-12-25 23:15:15',NULL,NULL),(4566,2912,'TE','4192411520',0,'2013-12-25 20:15:34',NULL,NULL),(7313,4757,'AP','2148037695',0,'2013-12-25 22:15:26',NULL,NULL),(13890,9056,'EM','LYNNEE742@SBCGLOBAL.NET',0,'2013-12-26 04:06:12',NULL,NULL),(11407,7424,'TE','3302424934',0,'2013-12-26 02:17:07',NULL,NULL),(34146,22389,'TE','3304663343',0,'2014-02-10 21:30:14',NULL,NULL),(38774,25634,'AP','2076515860',0,'2014-02-26 08:30:26',NULL,NULL),(13637,8892,'AP','2548130935',0,'2013-12-26 04:02:03',NULL,NULL),(1054,650,'TE','7403866115',0,'2013-12-25 18:01:34',NULL,NULL),(1728,1058,'EM','angie_sareen@yahoo.com',0,'2013-12-25 18:16:14',NULL,NULL),(11500,7483,'TE','6145890104',0,'2013-12-26 02:31:26',NULL,NULL),(2875,1762,'AP','5133738629',0,'2013-12-25 18:55:55',NULL,NULL),(31536,20552,'TE','3366132520',0,'2014-01-29 21:01:42',NULL,NULL),(24420,15765,'AP','9562923348',0,'2014-01-03 02:01:39',NULL,NULL),(7557,4920,'AP','2343127200',0,'2013-12-25 22:45:09',NULL,NULL),(35136,23076,'AP','2252907818',0,'2014-02-12 21:31:00',NULL,NULL),(38269,25268,'TE','3609090037',0,'2014-02-25 21:00:10',NULL,NULL),(32083,20952,'TE','9567207950',0,'2014-02-01 19:00:05',NULL,NULL),(23647,15271,'TE','5133447426',1,'2014-01-02 04:21:48',NULL,NULL),(905,560,'AP','5135057962',0,'2013-12-25 17:50:17',NULL,NULL),(1560,961,'AP','9092828155',0,'2013-12-25 18:09:47',NULL,NULL),(40823,27130,'EM','cmr9390@aol.com',0,'2014-03-03 21:30:39',NULL,NULL),(41287,27432,'EM','ASNOWDEN48@YAHOO.COM',0,'2014-03-04 21:01:47',NULL,NULL),(42461,28208,'AP','6625447234',0,'2014-03-06 21:30:12',NULL,NULL),(32683,21378,'EM','elliott_robin01@yahoo.com',0,'2014-02-04 21:00:51',NULL,NULL),(21132,13588,'TE','5049403082',0,'2013-12-26 13:05:06',NULL,NULL),(31827,20779,'EM','kittykat25@suddenlink.net',0,'2014-01-31 21:00:08',NULL,NULL),(30442,19734,'AP','3184390271',0,'2014-01-23 21:01:07',NULL,NULL),(2320,1416,'TE','5043418833',0,'2013-12-25 18:47:05',NULL,NULL),(29102,18792,'EM','dwkushner@gmail.com',0,'2014-01-17 03:35:57',NULL,NULL),(2722,1653,'TE','9156268707',0,'2013-12-25 18:53:24',NULL,NULL),(4234,2707,'TE','3304259302',0,'2013-12-25 19:47:54',NULL,NULL),(35660,23452,'EM','malnkat@gmail.com',0,'2014-02-13 22:01:38',NULL,NULL),(37151,24455,'TE','9016502944',0,'2014-02-18 22:01:29',NULL,NULL),(40842,27139,'TE','9524576945',0,'2014-03-03 21:30:46',NULL,NULL),(43934,29144,'TE','5132326242',0,'2014-03-10 21:02:45',NULL,NULL),(32985,21595,'AP','9378441723',0,'2014-02-05 21:30:30',NULL,NULL),(504,318,'TE','3377396468',0,'2013-12-25 17:31:16',NULL,NULL),(21014,13521,'TE','3184526071',0,'2013-12-26 13:03:12',NULL,NULL),(31333,20417,'AP','4196067414',0,'2014-01-29 21:00:28',NULL,NULL),(11646,7577,'TE','4197547166',0,'2013-12-26 02:33:54',NULL,NULL),(7449,4851,'EM','robinsms87@gmail.com',0,'2013-12-25 22:30:23',NULL,NULL),(6430,4154,'AP','2163147791',0,'2013-12-25 21:48:51',NULL,NULL),(37069,24409,'TE','5132597731',0,'2014-02-18 22:01:00',NULL,NULL),(40526,26899,'TE','2145740586',0,'2014-03-03 01:00:06',NULL,NULL),(43925,29139,'EM','tbjada25@hotmail.com',0,'2014-03-10 21:02:42',NULL,NULL),(20314,13091,'EM','COOLJAYLIN@HOTMAIL.COM',0,'2013-12-26 12:51:53',NULL,NULL),(33704,22105,'TE','5133791739',0,'2014-02-08 19:00:32',NULL,NULL),(2823,1706,'AP','5138469315',0,'2013-12-25 18:54:54',NULL,NULL),(3986,2532,'AP','9374891389',0,'2013-12-25 19:36:49',NULL,NULL),(23584,15225,'AP','2253152414',0,'2014-01-01 12:08:09',NULL,NULL),(23674,15284,'EM','cspann103@att.net',1,'2014-01-02 04:22:16',NULL,NULL),(33597,22027,'TE','4197883466',0,'2014-02-07 19:01:01',NULL,NULL),(32009,20895,'BN','5136521671',0,'2014-01-31 21:01:17',NULL,NULL),(35348,23227,'AP','2165515360',0,'2014-02-12 21:32:23',NULL,NULL),(37056,24403,'AP','5133129753',0,'2014-02-18 22:00:56',NULL,NULL),(39550,26164,'BN','3306221743',0,'2014-02-28 06:30:34',NULL,NULL),(9547,6249,'AP','5044510380',0,'2013-12-26 00:31:54',NULL,NULL),(21015,13522,'TE','3378534014',0,'2013-12-26 13:03:13',NULL,NULL),(29119,18805,'AP','6142056662',0,'2014-01-17 03:36:01',NULL,NULL),(4688,2999,'AP','5135509077',0,'2013-12-25 20:17:37',NULL,NULL),(3746,2376,'AP','5134607057',0,'2013-12-25 19:32:54',NULL,NULL),(2672,1622,'TE','9792572018',0,'2013-12-25 18:52:37',NULL,NULL),(22758,14675,'AP','6013354161',1,'2013-12-29 11:08:23',NULL,NULL),(27052,17397,'AP','4196052054',0,'2014-01-13 03:00:14',NULL,NULL),(35140,23078,'TE','3302532538',0,'2014-02-12 21:31:01',NULL,NULL),(35345,23225,'AP','2167023368',0,'2014-02-12 21:32:22',NULL,NULL),(43217,28719,'TE','9376577729',0,'2014-03-08 21:31:19',NULL,NULL),(20760,13341,'AP','8327547780',0,'2013-12-26 12:58:55',NULL,NULL),(1901,1172,'EM','michellesandstrom@att.net',0,'2013-12-25 18:19:11',NULL,NULL),(26309,16940,'TE','2282345256',0,'2014-01-13 02:19:53',NULL,NULL),(13750,8962,'TE','9372662135',0,'2013-12-26 04:03:53',NULL,NULL),(2836,1719,'AP','2162547770',0,'2013-12-25 18:55:09',NULL,NULL),(7264,4736,'TE','9373363442',0,'2013-12-25 22:09:18',NULL,NULL),(5358,3431,'EM','Kekeboo90@msn.com',0,'2013-12-25 21:18:57',NULL,NULL),(7158,4670,'TE','3375834782',0,'2013-12-25 22:07:35',NULL,NULL),(41497,27586,'TE','8302361263',0,'2014-03-05 21:00:14',NULL,NULL),(43391,28818,'AP','3304313747',0,'2014-03-09 21:00:57',NULL,NULL),(31015,20178,'EM','poodlepooch2001@yahoo.com',0,'2014-01-27 21:01:19',NULL,NULL),(28075,18093,'EM','ashley_jeanfreau@yahoo.com',0,'2014-01-15 02:07:31',NULL,NULL),(10393,6772,'EM','bacovinjewlers@zoomtown.com',0,'2013-12-26 01:16:41',NULL,NULL),(4413,2812,'TE','9159749265',0,'2013-12-25 20:00:17',NULL,NULL),(5821,3737,'TE','8063677113',0,'2013-12-25 21:32:47',NULL,NULL),(25530,16469,'TE','2346786724',0,'2014-01-07 04:05:54',NULL,NULL),(38030,25085,'TE','2166314526',0,'2014-02-20 22:01:42',NULL,NULL),(41152,27333,'AP','2163226485',0,'2014-03-04 21:00:54',NULL,NULL),(21633,13926,'TE','4192640128',0,'2013-12-26 13:14:19',NULL,NULL),(33925,22265,'EM','kapukolohe@gmail.com',0,'2014-02-10 11:00:10',NULL,NULL),(28844,18629,'EM','margaretweirich@yahoo.com',0,'2014-01-16 08:47:31',NULL,NULL),(22799,14701,'AP','7203942216',1,'2013-12-29 11:09:05',NULL,NULL),(31757,20725,'TE','4197093386',0,'2014-01-30 21:01:16',NULL,NULL),(9771,6389,'TE','6143787066',0,'2013-12-26 00:48:08',NULL,NULL),(14672,9599,'TE','3302963251',0,'2013-12-26 04:37:22',NULL,NULL),(14629,9562,'TE','5136771769',0,'2013-12-26 04:36:36',NULL,NULL),(5604,3587,'EM','ellen.schlatter@gmail.com',0,'2013-12-25 21:22:54',NULL,NULL),(29239,18887,'AP','3304100580',0,'2014-01-17 03:36:30',NULL,NULL),(28430,18317,'AP','6144405177',0,'2014-01-16 08:45:05',NULL,NULL),(37786,24938,'AP','5048586558',0,'2014-02-20 21:30:24',NULL,NULL),(33162,21720,'EM','paul.allaer@thompsonhine.com',0,'2014-02-05 21:31:19',NULL,NULL),(32893,21531,'EM','latearria@yahoo.com',0,'2014-02-05 21:30:07',NULL,NULL),(35279,23168,'AP','4692378685',0,'2014-02-12 21:31:51',NULL,NULL),(42125,27984,'AP','2252884457',0,'2014-03-06 21:00:59',NULL,NULL),(42833,28488,'EM','tsw1975@gmail.com',0,'2014-03-07 21:31:40',NULL,NULL),(43482,28875,'EM','jenniferenzer@hotmail.com',0,'2014-03-10 21:00:05',NULL,NULL),(11967,7798,'AP','3257213811',0,'2013-12-26 03:03:36',NULL,NULL),(29372,18976,'EM','loriw43764@gmail.com',0,'2014-01-20 08:06:05',NULL,NULL),(25768,16605,'TE','5043388812',0,'2014-01-08 18:24:06',NULL,NULL),(31865,20801,'TE','9154784221',0,'2014-01-31 21:00:22',NULL,NULL),(35584,23405,'TE','5132679902',0,'2014-02-13 22:01:11',NULL,NULL),(38618,25523,'TE','5133142712',0,'2014-02-25 21:32:08',NULL,NULL),(41094,27296,'AP','9037207849',0,'2014-03-04 21:00:31',NULL,NULL),(42426,28175,'TE','3305404234',0,'2014-03-06 21:02:52',NULL,NULL),(43809,29081,'AP','6629029118',0,'2014-03-10 21:02:03',NULL,NULL),(43874,29111,'TE','2154073513',0,'2014-03-10 21:02:24',NULL,NULL),(7011,4579,'EM','cindy.cheh@gmail.com',0,'2013-12-25 22:05:10',NULL,NULL),(11474,7462,'EM','jacksoneducator@gmail.com',0,'2013-12-26 02:30:58',NULL,NULL),(3608,2279,'TE','4406690460',0,'2013-12-25 19:30:31',NULL,NULL),(5502,3519,'TE','6018538260',0,'2013-12-25 21:21:14',NULL,NULL),(32707,21395,'TE','4192423522',0,'2014-02-04 21:00:59',NULL,NULL),(27549,17755,'TE','6019189868',0,'2014-01-14 01:33:30',NULL,NULL),(26060,16786,'EM','kank3634@aol.com',0,'2014-01-08 18:25:08',NULL,NULL),(20610,13255,'TE','2547395395',0,'2013-12-26 12:56:32',NULL,NULL),(3092,1931,'TE','8322596610',0,'2013-12-25 19:00:24',NULL,NULL),(3788,2404,'TE','5133140487',0,'2013-12-25 19:33:37',NULL,NULL),(10827,7032,'AP','2817253013',0,'2013-12-26 01:49:09',NULL,NULL),(10946,7114,'TE','8506028769',0,'2013-12-26 01:51:09',NULL,NULL),(5747,3683,'EM','mitchstojsavljevic@yahoo.com',0,'2013-12-25 21:31:31',NULL,NULL),(32251,21063,'TE','4193089015',0,'2014-02-02 19:00:13',NULL,NULL),(33060,21656,'EM','letmebeyours69@gmail.com',0,'2014-02-05 21:30:52',NULL,NULL),(34084,22343,'TE','4198994729',0,'2014-02-10 11:01:10',NULL,NULL),(681,424,'AP','2168200824',0,'2013-12-25 17:46:43',NULL,NULL),(31698,20677,'TE','6015064270',0,'2014-01-30 21:00:53',NULL,NULL),(1523,938,'TE','5134007013',0,'2013-12-25 18:09:16',NULL,NULL),(30474,19760,'AP','2162541263',0,'2014-01-23 21:01:23',NULL,NULL),(7814,5102,'AP','8177152490',0,'2013-12-25 23:01:28',NULL,NULL),(2931,1803,'AP','5132844030',0,'2013-12-25 18:56:49',NULL,NULL),(3259,2051,'TE','8302755332',0,'2013-12-25 19:15:51',NULL,NULL),(11657,7588,'TE','9372171838',0,'2013-12-26 02:45:03',NULL,NULL),(28018,18058,'AP','9376909393',0,'2014-01-15 02:07:20',NULL,NULL),(5474,3503,'EM','tyronesmith04@gmail.com',0,'2013-12-25 21:20:47',NULL,NULL),(36656,24128,'EM','mamarosco@gmail.com',0,'2014-02-15 22:01:47',NULL,NULL),(638,396,'TE','3304212258',0,'2013-12-25 17:46:03',NULL,NULL),(30009,19433,'AP','4193500218',1,'2014-01-22 03:23:09',NULL,NULL),(25916,16701,'EM','barrancom1181@yahoo.com',0,'2014-01-08 18:24:39',NULL,NULL),(14928,9768,'AP','5132060744',0,'2013-12-26 05:00:23',NULL,NULL),(25247,16281,'AP','4192245256',0,'2014-01-07 04:00:32',NULL,NULL),(3771,2392,'TE','4405721257',0,'2013-12-25 19:33:19',NULL,NULL),(12357,8089,'AP','4193084532',0,'2013-12-26 03:10:39',NULL,NULL),(3534,2211,'TE','3304844602',0,'2013-12-25 19:20:18',NULL,NULL),(23588,15228,'TE','5136074725',0,'2014-01-01 12:08:15',NULL,NULL),(32226,21048,'TE','9726445022',0,'2014-02-02 19:00:04',NULL,NULL),(41140,27325,'TE','8326476330',0,'2014-03-04 21:00:49',NULL,NULL),(42460,28208,'TE','6625447234',0,'2014-03-06 21:30:12',NULL,NULL),(42816,28474,'EM','SHAMYTWINSMOM@YAHOO.COM',0,'2014-03-07 21:31:33',NULL,NULL),(14189,9284,'EM','mrkevinwagner@gmail.com',0,'2013-12-26 04:15:58',NULL,NULL),(1327,811,'TE','7405035545',0,'2013-12-25 18:05:50',NULL,NULL),(8446,5558,'TE','5044421886',0,'2013-12-25 23:16:21',NULL,NULL),(30655,19897,'TE','9859817362',0,'2014-01-24 21:00:54',NULL,NULL),(22731,14660,'TE','9152027431',1,'2013-12-29 11:07:58',NULL,NULL),(10587,6888,'TE','5043301908',0,'2013-12-26 01:45:18',NULL,NULL),(21443,13784,'TE','6015133424',0,'2013-12-26 13:10:51',NULL,NULL),(36695,24160,'TE','4198603910',0,'2014-02-15 22:02:03',NULL,NULL),(37016,24371,'AP','9853281415',0,'2014-02-18 22:00:38',NULL,NULL),(20362,13117,'AP','2164017218',0,'2013-12-26 12:52:39',NULL,NULL),(14809,9693,'AP','9376540395',0,'2013-12-26 04:39:47',NULL,NULL),(13953,9098,'TE','3306206267',0,'2013-12-26 04:07:18',NULL,NULL),(12353,8087,'TE','5135784924',0,'2013-12-26 03:10:35',NULL,NULL),(5056,3245,'AP','6147173797',0,'2013-12-25 20:46:28',NULL,NULL),(29064,18769,'TE','4795309085',0,'2014-01-17 03:35:49',NULL,NULL),(3419,2147,'AP','5135692310',0,'2013-12-25 19:18:27',NULL,NULL),(33086,21671,'TE','5043245167',0,'2014-02-05 21:30:59',NULL,NULL),(35409,23278,'AP','5048127496',0,'2014-02-13 21:30:15',NULL,NULL),(31934,20845,'TE','4407736286',0,'2014-01-31 21:00:49',NULL,NULL),(1188,726,'TE','8066763235',0,'2013-12-25 18:03:38',NULL,NULL),(25452,16413,'TE','3619356615',0,'2014-01-07 04:04:17',NULL,NULL),(10039,6568,'TE','9153453960',0,'2013-12-26 00:52:36',NULL,NULL),(33776,22167,'TE','4193945297',0,'2014-02-08 19:01:02',NULL,NULL),(40727,27066,'TE','9854744653',0,'2014-03-03 21:30:03',NULL,NULL),(42412,28168,'TE','8172475392',0,'2014-03-06 21:02:47',NULL,NULL),(6810,4418,'TE','2164001029',0,'2013-12-25 22:01:33',NULL,NULL),(20598,13250,'AP','8067899086',0,'2013-12-26 12:56:21',NULL,NULL),(30952,20134,'TE','3307335914',0,'2014-01-27 21:00:53',NULL,NULL),(6266,4043,'AP','4253271474',0,'2013-12-25 21:46:10',NULL,NULL),(30127,19513,'AP','7273653778',0,'2014-01-23 03:02:15',NULL,NULL),(23160,14929,'TE','7132613323',0,'2013-12-30 00:01:57',NULL,NULL),(24775,15982,'AP','9035735674',0,'2014-01-04 02:00:59',NULL,NULL),(24093,15552,'AP','2252237568',1,'2014-01-02 04:31:20',NULL,NULL),(41478,27571,'TE','7343954635',0,'2014-03-04 21:30:20',NULL,NULL),(13690,8924,'EM','landfeld@sbcglobal.net',0,'2013-12-26 04:02:53',NULL,NULL),(7277,4741,'EM','qest@fuse.net',0,'2013-12-25 22:09:28',NULL,NULL),(7589,4941,'EM','PAUL.YANOVICH@YAHOO.COM',0,'2013-12-25 22:45:41',NULL,NULL),(24343,15724,'TE','9376575699',0,'2014-01-03 02:00:15',NULL,NULL),(26007,16754,'AP','2107876067',0,'2014-01-08 18:24:56',NULL,NULL),(26459,17032,'AP','4194817672',0,'2014-01-13 02:20:45',NULL,NULL),(40003,26493,'EM','nhainugyen@aol.com',0,'2014-02-28 21:00:12',NULL,NULL),(43953,29156,'TE','4193456911',0,'2014-03-10 21:02:52',NULL,NULL),(6193,3991,'AP','4197892499',0,'2013-12-25 21:39:06',NULL,NULL),(10767,6999,'TE','7139350142',0,'2013-12-26 01:48:13',NULL,NULL),(2830,1712,'AP','4193442684',0,'2013-12-25 18:55:02',NULL,NULL),(7083,4626,'AP','5049052476',0,'2013-12-25 22:06:23',NULL,NULL),(34198,22428,'EM','klekartravis1991@gmail.com',0,'2014-02-10 21:30:35',NULL,NULL),(35090,23047,'AP','5124966276',0,'2014-02-12 21:30:43',NULL,NULL),(35546,23374,'AP','2167012020',0,'2014-02-13 22:00:56',NULL,NULL),(38071,25132,'TE','2817369021',0,'2014-02-21 22:00:04',NULL,NULL),(30866,20062,'EM','YVONNE_VALVERDE@YAHOO.COM',0,'2014-01-27 21:00:12',NULL,NULL),(9228,6037,'EM','srainer@novussoftwaresolutions.com',0,'2013-12-26 00:01:20',NULL,NULL),(27061,17402,'AP','6013426388',0,'2014-01-13 03:00:17',NULL,NULL),(10892,7077,'AP','4192963454',0,'2013-12-26 01:50:13',NULL,NULL),(3719,2357,'EM','angelbehring@gmail.com',0,'2013-12-25 19:32:25',NULL,NULL),(35794,23537,'TE','3184163367',0,'2014-02-13 22:02:30',NULL,NULL),(40264,26712,'TE','9377258956',0,'2014-02-28 21:31:39',NULL,NULL),(43483,28876,'TE','2542953202',0,'2014-03-10 21:00:05',NULL,NULL),(43734,29033,'AP','6142962422',0,'2014-03-10 21:01:36',NULL,NULL),(20786,13357,'AP','4408640048',0,'2013-12-26 12:59:23',NULL,NULL),(1353,827,'TE','3302035925',0,'2013-12-25 18:06:14',NULL,NULL),(29062,18765,'TE','2147526756',0,'2014-01-17 03:35:48',NULL,NULL),(33244,21770,'EM','jdeville77@hotmail.com',0,'2014-02-06 21:00:32',NULL,NULL),(33438,21902,'AP','4253299776',0,'2014-02-06 21:01:48',NULL,NULL),(35006,22984,'EM','D.rodabaugh@yahoo.com',0,'2014-02-12 21:30:10',NULL,NULL),(40919,27191,'TE','8325219035',0,'2014-03-03 21:31:16',NULL,NULL),(21037,13534,'EM','basilides.mcevilla@yahoo.com',0,'2013-12-26 13:03:34',NULL,NULL),(9993,6538,'EM','mancini@megalink.net',0,'2013-12-26 00:51:52',NULL,NULL),(32024,20904,'TE','5135353181',0,'2014-01-31 21:01:23',NULL,NULL),(9124,5975,'EM','lynn.mcs@gmail.com',0,'2013-12-25 23:51:48',NULL,NULL),(31500,20526,'TE','4192064884',0,'2014-01-29 21:01:28',NULL,NULL),(29529,19088,'TE','7403261313',0,'2014-01-21 08:44:30',NULL,NULL),(8940,5851,'EM','comedyguy420420@gmail.com',0,'2013-12-25 23:48:49',NULL,NULL),(27690,17849,'TE','4409379710',0,'2014-01-15 02:06:06',NULL,NULL),(22359,14419,'EM','dmirelez@hotmail.com',0,'2013-12-28 03:31:40',NULL,NULL),(23991,15486,'TE','6145983418',1,'2014-01-02 04:29:20',NULL,NULL),(26714,17184,'AP','4402650612',0,'2014-01-13 02:22:14',NULL,NULL),(33391,21878,'TE','2259078272',0,'2014-02-06 21:01:29',NULL,NULL),(33607,22037,'AP','9377266915',0,'2014-02-07 19:01:06',NULL,NULL),(39784,26306,'TE','8178965626',0,'2014-02-28 06:31:31',NULL,NULL),(14475,9453,'AP','5132585300',0,'2013-12-26 04:34:02',NULL,NULL),(28558,18413,'AP','3185120437',0,'2014-01-16 08:45:48',NULL,NULL),(10717,6970,'TE','5134295642',0,'2013-12-26 01:47:26',NULL,NULL),(27940,18004,'TE','6142083673',0,'2014-01-15 02:07:01',NULL,NULL),(6155,3962,'EM','redgrog@aol.com',0,'2013-12-25 21:38:26',NULL,NULL),(40955,27214,'AP','6018136265',0,'2014-03-03 21:31:30',NULL,NULL),(42677,28389,'TE','3302129507',0,'2014-03-07 21:30:44',NULL,NULL),(32016,20901,'TE','2164101341',0,'2014-01-31 21:01:21',NULL,NULL),(28803,18589,'EM','james@nicenetwork.com',0,'2014-01-16 08:47:13',NULL,NULL),(28675,18499,'AP','3307549090',0,'2014-01-16 08:46:29',NULL,NULL),(26484,17044,'AP','3308585023',0,'2014-01-13 02:20:53',NULL,NULL),(35370,23240,'AP','4197889534',0,'2014-02-12 21:32:32',NULL,NULL),(35468,23327,'TE','9372243300',0,'2014-02-13 22:00:28',NULL,NULL),(37736,24892,'TE','9378316008',0,'2014-02-20 05:39:12',NULL,NULL),(41363,27479,'EM','evieferrell@gmail.com',0,'2014-03-04 21:02:16',NULL,NULL),(41829,27812,'TE','2165343949',0,'2014-03-05 21:31:51',NULL,NULL),(32786,21452,'AP','3308084306',0,'2014-02-04 21:01:29',NULL,NULL),(3543,2218,'AP','3302122061',0,'2013-12-25 19:20:28',NULL,NULL),(27188,17510,'TE','3303736622',0,'2014-01-13 03:01:29',NULL,NULL),(32774,21442,'TE','3302459905',0,'2014-02-04 21:01:24',NULL,NULL),(38672,25560,'TE','9378852164',0,'2014-02-26 08:00:22',NULL,NULL),(43696,29006,'TE','3304661468',0,'2014-03-10 21:01:22',NULL,NULL),(3086,1927,'EM','sammyg987@outlook.com',0,'2013-12-25 19:00:18',NULL,NULL),(21638,13929,'TE','4193093165',0,'2013-12-26 13:14:24',NULL,NULL),(21008,13515,'EM','layfield.luke@gmail.com',0,'2013-12-26 13:03:04',NULL,NULL),(14566,9518,'TE','9372563885',0,'2013-12-26 04:35:35',NULL,NULL),(5667,3640,'TE','7696102778',0,'2013-12-25 21:30:21',NULL,NULL),(5501,3518,'AP','4199670351',0,'2013-12-25 21:21:12',NULL,NULL),(31009,20172,'TE','4403192078',0,'2014-01-27 21:01:16',NULL,NULL),(29665,19166,'AP','5129712376',0,'2014-01-21 08:46:01',NULL,NULL),(33881,22237,'AP','8125682116',0,'2014-02-09 19:00:36',NULL,NULL),(10061,6579,'TE','9377980383',0,'2013-12-26 00:52:55',NULL,NULL),(27166,17490,'TE','9857897129',0,'2014-01-13 03:01:20',NULL,NULL),(7386,4806,'AP','5133148128',0,'2013-12-25 22:16:39',NULL,NULL),(3455,2163,'TE','3307607305',0,'2013-12-25 19:18:58',NULL,NULL),(23441,15107,'AP','4406104467',0,'2014-01-01 12:04:52',NULL,NULL),(39496,26124,'TE','4196630642',0,'2014-02-28 06:30:20',NULL,NULL),(9573,6269,'AP','5132381161',0,'2013-12-26 00:45:04',NULL,NULL),(2447,1501,'TE','5137037151',0,'2013-12-25 18:49:17',NULL,NULL),(32921,21551,'TE','5132421395',0,'2014-02-05 21:30:14',NULL,NULL),(20656,13283,'EM','08ratpack@gmail.com',0,'2013-12-26 12:57:16',NULL,NULL),(39591,26190,'AP','6143167646',0,'2014-02-28 06:30:44',NULL,NULL),(40900,27177,'TE','9364144463',0,'2014-03-03 21:31:08',NULL,NULL),(29470,19051,'AP','3189531010',0,'2014-01-20 08:06:44',NULL,NULL),(21933,14128,'AP','2259334868',0,'2013-12-27 02:02:20',NULL,NULL),(14563,9515,'TE','5133258075',0,'2013-12-26 04:35:31',NULL,NULL),(13711,8935,'AP','4196068267',0,'2013-12-26 04:03:10',NULL,NULL),(2824,1706,'EM','cgride555@yahoo.com',0,'2013-12-25 18:54:54',NULL,NULL),(28991,18713,'EM','KATMAC1952@GMAIL.COM',0,'2014-01-17 03:35:32',NULL,NULL),(5072,3258,'TE','3306077220',0,'2013-12-25 20:46:47',NULL,NULL),(33600,22028,'AP','2162697595',0,'2014-02-07 19:01:02',NULL,NULL),(35026,23000,'TE','3305194655',0,'2014-02-12 21:30:18',NULL,NULL),(35360,23233,'AP','4196191185',0,'2014-02-12 21:32:27',NULL,NULL),(36162,23801,'TE','3307227493',0,'2014-02-14 21:31:30',NULL,NULL),(41861,27836,'EM','lhonican@zoomtown.com',0,'2014-03-05 21:32:04',NULL,NULL),(42628,28359,'TE','9363351108',0,'2014-03-07 21:30:27',NULL,NULL),(28220,18191,'EM','tonyalicea@yahoo.com',0,'2014-01-15 02:08:04',NULL,NULL),(26710,17181,'EM','twilson17@centurylink.net',0,'2014-01-13 02:22:13',NULL,NULL),(26490,17048,'AP','5024323310',0,'2014-01-13 02:20:55',NULL,NULL),(1826,1130,'AP','8065597132',0,'2013-12-25 18:18:02',NULL,NULL),(33677,22090,'AP','6626332752',0,'2014-02-08 19:00:24',NULL,NULL),(34411,22572,'TE','2162151795',0,'2014-02-10 21:31:57',NULL,NULL),(36330,23927,'EM','fallstoolrental@yahoo.com',0,'2014-02-14 22:00:09',NULL,NULL),(40282,26720,'TE','6018524915',0,'2014-02-28 21:31:44',NULL,NULL),(41503,27590,'TE','5124234190',0,'2014-03-05 21:00:17',NULL,NULL),(41958,27891,'EM','bigbaby.hart@gmail.com',0,'2014-03-05 21:32:39',NULL,NULL),(31787,20748,'AP','2394501641',0,'2014-01-30 21:01:28',NULL,NULL),(10684,6944,'TE','4407867721',0,'2013-12-26 01:46:52',NULL,NULL),(40681,27012,'EM','Lambertkl2@aol.com',0,'2014-03-03 21:00:08',NULL,NULL),(21816,14056,'TE','5137310030',0,'2013-12-27 02:00:26',NULL,NULL),(8809,5769,'TE','6148644825',0,'2013-12-25 23:46:45',NULL,NULL),(21163,13612,'AP','5136758350',0,'2013-12-26 13:05:39',NULL,NULL),(8565,5632,'TE','5133242385',0,'2013-12-25 23:30:59',NULL,NULL),(29257,18895,'AP','3308140610',0,'2014-01-17 03:36:34',NULL,NULL),(27565,17766,'TE','2106300169',0,'2014-01-14 01:33:35',NULL,NULL),(26241,16888,'TE','5122809200',0,'2014-01-13 02:19:26',NULL,NULL),(30514,19794,'EM','lhweeper6@gmail.com',0,'2014-01-23 21:01:44',NULL,NULL),(14054,9184,'TE','4198893730',0,'2013-12-26 04:09:15',NULL,NULL),(13578,8853,'TE','8303330694',0,'2013-12-26 04:01:05',NULL,NULL),(1228,749,'TE','8322747545',0,'2013-12-25 18:04:14',NULL,NULL),(9165,6001,'TE','5044132223',0,'2013-12-26 00:00:21',NULL,NULL),(1974,1220,'AP','2162535635',0,'2013-12-25 18:20:24',NULL,NULL),(8865,5809,'TE','9727529968',0,'2013-12-25 23:47:43',NULL,NULL),(30248,19593,'AP','6012094699',0,'2014-01-23 03:02:45',NULL,NULL),(28693,18517,'TE','8062933567',0,'2014-01-16 08:46:36',NULL,NULL),(2694,1637,'TE','7138993769',0,'2013-12-25 18:52:59',NULL,NULL),(6273,4046,'AP','4194634247',0,'2013-12-25 21:46:15',NULL,NULL),(22691,14636,'TE','4193710697',0,'2013-12-28 03:37:18',NULL,NULL),(34885,22891,'AP','4193201075',0,'2014-02-11 21:02:37',NULL,NULL),(39558,26172,'AP','6625888310',0,'2014-02-28 06:30:36',NULL,NULL),(9919,6492,'TE','3306783132',0,'2013-12-26 00:50:37',NULL,NULL),(96,57,'TE','5174905840',0,'2013-12-25 17:16:34',NULL,NULL),(341,213,'TE','2258029226',0,'2013-12-25 17:20:32',NULL,NULL),(365,224,'TE','2253482048',0,'2013-12-25 17:20:51',NULL,NULL),(25184,16239,'TE','3377253975',0,'2014-01-05 00:02:19',NULL,NULL),(11464,7457,'AP','5133833501',0,'2013-12-26 02:30:48',NULL,NULL),(22135,14257,'AP','5043077505',0,'2013-12-27 02:05:42',NULL,NULL),(11960,7794,'TE','9032751053',0,'2013-12-26 03:03:29',NULL,NULL),(38131,25170,'TE','4195642855',0,'2014-02-21 22:00:27',NULL,NULL),(719,448,'TE','5134046948',0,'2013-12-25 17:47:20',NULL,NULL),(21117,13578,'TE','3373094808',0,'2013-12-26 13:04:50',NULL,NULL),(33018,21632,'EM','tvalenta1@att.net',0,'2014-02-05 21:30:41',NULL,NULL),(32100,20963,'EM','cpedroza77707@yahoo.com',0,'2014-02-01 19:00:11',NULL,NULL),(11167,7263,'EM','Jeff.Betty@verizon.net',0,'2013-12-26 02:02:13',NULL,NULL),(28654,18479,'EM','ziss.bill@gmail.com',0,'2014-01-16 08:46:21',NULL,NULL),(23108,14898,'TE','3183021544',0,'2013-12-30 00:01:02',NULL,NULL),(42216,28045,'EM','dcstepteau@yahoo.com',0,'2014-03-06 21:01:34',NULL,NULL),(43890,29121,'AP','4196194109',0,'2014-03-10 21:02:30',NULL,NULL),(771,481,'AP','9852469102',0,'2013-12-25 17:48:10',NULL,NULL),(29044,18752,'EM','sharonmoore25@gmail.com',0,'2014-01-17 03:35:44',NULL,NULL),(1121,687,'EM','emilykbutcher05@sbcglobal.net',0,'2013-12-25 18:02:33',NULL,NULL),(23470,15135,'AP','9376137937',0,'2014-01-01 12:05:34',NULL,NULL),(22973,14816,'AP','5139673682',1,'2013-12-29 11:14:13',NULL,NULL),(2138,1319,'TE','6018562193',0,'2013-12-25 18:31:40',NULL,NULL),(37846,24969,'AP','4093838641',0,'2014-02-20 22:00:25',NULL,NULL),(10430,6799,'AP','4195867351',0,'2013-12-26 01:17:20',NULL,NULL),(33540,21989,'TE','7189154033',0,'2014-02-07 19:00:41',NULL,NULL),(32828,21481,'AP','5135041274',0,'2014-02-04 21:01:43',NULL,NULL),(29050,18756,'EM','dmirelez@hotmail.com',0,'2014-01-17 03:35:46',NULL,NULL),(21441,13783,'TE','6017987364',0,'2013-12-26 13:10:49',NULL,NULL),(9007,5911,'TE','2146755359',0,'2013-12-25 23:50:02',NULL,NULL),(29299,18932,'TE','5133498341',0,'2014-01-20 08:05:39',NULL,NULL),(955,589,'AP','4193028329',0,'2013-12-25 17:51:09',NULL,NULL),(2272,1391,'AP','5042480827',0,'2013-12-25 18:46:23',NULL,NULL),(4329,2763,'TE','3303455031',0,'2013-12-25 19:49:22',NULL,NULL),(20242,13040,'AP','5132924213',0,'2013-12-26 12:50:36',NULL,NULL),(23469,15135,'TE','9376137937',0,'2014-01-01 12:05:34',NULL,NULL),(27475,17699,'TE','2254446115',0,'2014-01-14 01:33:03',NULL,NULL),(38741,25611,'TE','8323859412',0,'2014-02-26 08:30:09',NULL,NULL),(40074,26573,'AP','6148861509',0,'2014-02-28 21:30:27',NULL,NULL),(42556,28318,'AP','9723758650',0,'2014-03-07 21:30:03',NULL,NULL),(29618,19135,'TE','9153076596',0,'2014-01-21 08:45:26',NULL,NULL),(372,226,'EM','KATHLEENHWHITE59@YAHOO.COM',0,'2013-12-25 17:20:56',NULL,NULL),(462,291,'AP','3184584340',0,'2013-12-25 17:30:33',NULL,NULL),(24505,15807,'AP','3373054059',0,'2014-01-03 02:03:05',NULL,NULL),(24232,15656,'TE','5673560476',1,'2014-01-02 04:34:17',NULL,NULL),(12109,7913,'EM','david.eidelman@gmail.com',0,'2013-12-26 03:06:09',NULL,NULL),(8801,5765,'AP','9375454407',0,'2013-12-25 23:46:38',NULL,NULL),(2711,1646,'EM','crystal_standokes@yahoo.com',0,'2013-12-25 18:53:14',NULL,NULL),(23246,14980,'AP','3614805683',0,'2014-01-01 12:01:03',NULL,NULL),(22059,14207,'TE','4325287773',0,'2013-12-27 02:04:24',NULL,NULL),(4989,3203,'TE','5672887318',0,'2013-12-25 20:45:14',NULL,NULL),(41376,27485,'AP','3307606432',0,'2014-03-04 21:02:20',NULL,NULL),(30372,19676,'EM','buddyboyd87@hotmail.com',0,'2014-01-23 21:00:35',NULL,NULL),(29505,19074,'AP','4193088509',0,'2014-01-21 08:44:22',NULL,NULL),(5486,3510,'TE','5132547123',0,'2013-12-25 21:20:58',NULL,NULL),(28036,18067,'AP','5042365603',0,'2014-01-15 02:07:22',NULL,NULL),(25137,16205,'TE','4074564332',0,'2014-01-05 00:01:16',NULL,NULL),(24442,15780,'TE','3103820755',0,'2014-01-03 02:02:06',NULL,NULL),(24364,15733,'AP','3302127618',0,'2014-01-03 02:00:35',NULL,NULL),(21152,13600,'AP','4193028609',0,'2013-12-26 13:05:25',NULL,NULL),(32973,21583,'EM','craigslitpics@gmail.com',0,'2014-02-05 21:30:26',NULL,NULL),(35398,23265,'EM','mcarnes74@yahoo.com',0,'2014-02-13 21:30:11',NULL,NULL),(36622,24110,'AP','2143276653',0,'2014-02-15 22:01:36',NULL,NULL),(38415,25382,'TE','2289180792',0,'2014-02-25 21:30:47',NULL,NULL),(41241,27395,'TE','7408192466',0,'2014-03-04 21:01:28',NULL,NULL),(42068,27954,'BN','4323868239',0,'2014-03-06 21:00:40',NULL,NULL),(13562,8843,'TE','2147143555',0,'2013-12-26 04:00:48',NULL,NULL),(20446,13171,'TE','3304212110',0,'2013-12-26 12:54:04',NULL,NULL),(1381,845,'TE','2259556328',0,'2013-12-25 18:06:43',NULL,NULL),(11073,7193,'TE','4405721425',0,'2013-12-26 02:00:27',NULL,NULL),(9354,6125,'TE','8172533117',0,'2013-12-26 00:15:50',NULL,NULL),(4913,3155,'EM','jseay1@mail.mvnu.edu',0,'2013-12-25 20:31:10',NULL,NULL),(36587,24084,'AP','4403346120',0,'2014-02-15 22:01:23',NULL,NULL),(25697,16567,'EM','cjohnson0406@msn.com',1,'2014-01-07 10:23:14',NULL,NULL),(14066,9195,'TE','3307044711',0,'2013-12-26 04:09:29',NULL,NULL),(6362,4098,'TE','3257632679',0,'2013-12-25 21:47:40',NULL,NULL),(25115,16191,'TE','9158524363',0,'2014-01-05 00:00:50',NULL,NULL),(31394,20461,'TE','5132228361',0,'2014-01-29 21:00:51',NULL,NULL),(11052,7177,'AP','9376722738',0,'2013-12-26 02:00:07',NULL,NULL),(30680,19928,'TE','6623178892',0,'2014-01-24 21:01:07',NULL,NULL),(28838,18620,'TE','3305059601',0,'2014-01-16 08:47:28',NULL,NULL),(5228,3360,'AP','8066641570',0,'2013-12-25 21:16:58',NULL,NULL),(10941,7112,'AP','3182073699',0,'2013-12-26 01:51:05',NULL,NULL),(9979,6531,'EM','rachealnaomi25@yahoo.com',0,'2013-12-26 00:51:40',NULL,NULL),(33803,22195,'TE','8065591643',0,'2014-02-09 19:00:12',NULL,NULL),(35693,23477,'AP','9374031494',0,'2014-02-13 22:01:53',NULL,NULL),(38400,25368,'TE','9374031823',0,'2014-02-25 21:30:40',NULL,NULL),(40186,26657,'TE','3308600399',0,'2014-02-28 21:31:09',NULL,NULL),(40545,26908,'EM','GALEHUVAL@ATT.NET',0,'2014-03-03 01:00:11',NULL,NULL),(43576,28937,'AP','3304311214',0,'2014-03-10 21:00:41',NULL,NULL),(1956,1212,'AP','9375726338',0,'2013-12-25 18:20:08',NULL,NULL),(20431,13157,'EM','patrickculliton@gmail.com',0,'2013-12-26 12:53:45',NULL,NULL),(28843,18629,'TE','5674556555',0,'2014-01-16 08:47:31',NULL,NULL),(12395,8115,'AP','3184471308',0,'2013-12-26 03:15:09',NULL,NULL),(23576,15220,'EM','sonia.brumen@gmail.com',0,'2014-01-01 12:08:00',NULL,NULL),(8562,5626,'TE','5138252211',0,'2013-12-25 23:30:54',NULL,NULL),(14146,9261,'TE','5044525037',0,'2013-12-26 04:15:20',NULL,NULL),(8396,5525,'TE','7409816197',0,'2013-12-25 23:15:26',NULL,NULL),(28030,18065,'TE','9854744115',0,'2014-01-15 02:07:22',NULL,NULL),(25642,16537,'EM','wal5@zips.uakron.edu',1,'2014-01-07 10:22:14',NULL,NULL),(7866,5131,'EM','nancytheredhead@gmail.com',0,'2013-12-25 23:02:14',NULL,NULL),(2860,1749,'TE','2165211452',0,'2013-12-25 18:55:40',NULL,NULL),(22989,14829,'TE','6019815719',1,'2013-12-29 11:14:31',NULL,NULL),(21458,13790,'TE','6019888220',0,'2013-12-26 13:11:03',NULL,NULL),(22586,14566,'EM','mrsoto74@hotmail.com',0,'2013-12-28 03:35:25',NULL,NULL),(33554,21996,'AP','5049941495',0,'2014-02-07 19:00:45',NULL,NULL),(35024,22998,'AP','3305194655',0,'2014-02-12 21:30:18',NULL,NULL),(41840,27820,'AP','7408048028',0,'2014-03-05 21:31:55',NULL,NULL),(23684,15291,'AP','3186521158',1,'2014-01-02 04:22:28',NULL,NULL),(36037,23703,'AP','9377260397',0,'2014-02-14 21:30:43',NULL,NULL),(26894,17302,'EM','glk5964@yahoo.com',0,'2014-01-13 02:23:39',NULL,NULL),(13526,8820,'TE','5132829556',0,'2013-12-26 04:00:14',NULL,NULL),(2374,1442,'TE','9377281725',0,'2013-12-25 18:47:53',NULL,NULL),(2833,1717,'TE','7403141604',0,'2013-12-25 18:55:06',NULL,NULL),(32718,21403,'AP','7405890064',0,'2014-02-04 21:01:04',NULL,NULL),(34761,22791,'EM','artplane210@earthlink.net',0,'2014-02-11 21:01:50',NULL,NULL),(38047,25110,'TE','2547733653',0,'2014-02-21 21:30:15',NULL,NULL),(39709,26260,'AP','9563369484',0,'2014-02-28 06:31:12',NULL,NULL),(30196,19562,'AP','3183550642',0,'2014-01-23 03:02:33',NULL,NULL),(27473,17698,'TE','3377077988',0,'2014-01-14 01:33:03',NULL,NULL),(9336,6113,'EM','sarahmstefan@gmail.com',0,'2013-12-26 00:15:32',NULL,NULL),(946,582,'TE','3304026823',0,'2013-12-25 17:50:56',NULL,NULL),(27429,17666,'AP','5135038070',0,'2014-01-14 01:32:47',NULL,NULL),(24146,15598,'TE','4192394360',1,'2014-01-02 04:32:35',NULL,NULL),(2601,1586,'TE','8065490133',0,'2013-12-25 18:51:35',NULL,NULL),(4606,2940,'TE','4157430979',0,'2013-12-25 20:16:12',NULL,NULL),(22225,14325,'EM','dbeery9150@gmail.com',0,'2013-12-27 02:07:22',NULL,NULL),(35992,23678,'EM','brenda.credeur@live.com',0,'2014-02-14 21:30:29',NULL,NULL),(38752,25619,'TE','2108007539',0,'2014-02-26 08:30:15',NULL,NULL),(8978,5884,'EM','kareemw908@gmail.com',0,'2013-12-25 23:49:31',NULL,NULL),(9681,6343,'EM','mb45123@cinci.rr.com',0,'2013-12-26 00:46:49',NULL,NULL),(35853,23575,'TE','4198253778',0,'2014-02-13 22:02:54',NULL,NULL),(31057,20206,'TE','5134619020',0,'2014-01-27 21:01:35',NULL,NULL),(11156,7253,'TE','5136254499',0,'2013-12-26 02:02:00',NULL,NULL),(9977,6531,'TE','2542052894',0,'2013-12-26 00:51:39',NULL,NULL),(23284,15003,'TE','2814908040',0,'2014-01-01 12:01:47',NULL,NULL),(3498,2186,'AP','6015725243',0,'2013-12-25 19:19:36',NULL,NULL),(3342,2102,'AP','5133169033',0,'2013-12-25 19:17:12',NULL,NULL),(35200,23118,'TE','5135411355',0,'2014-02-12 21:31:23',NULL,NULL),(35667,23458,'EM','dredic09@gmail.com',0,'2014-02-13 22:01:41',NULL,NULL),(9543,6247,'AP','5042539570',0,'2013-12-26 00:31:50',NULL,NULL),(11892,7738,'AP','3308193470',0,'2013-12-26 03:02:12',NULL,NULL),(8202,5368,'EM','angelalyman@gmail.com',0,'2013-12-25 23:08:02',NULL,NULL),(8993,5903,'AP','7405901877',0,'2013-12-25 23:49:49',NULL,NULL),(31469,20508,'TE','5042593911',0,'2014-01-29 21:01:17',NULL,NULL),(35164,23095,'AP','6145930146',0,'2014-02-12 21:31:09',NULL,NULL),(38507,25448,'AP','9039410963',0,'2014-02-25 21:31:24',NULL,NULL),(26180,16854,'EM','VIERSGENOA@AOL.COM',0,'2014-01-13 02:18:42',NULL,NULL),(27699,17854,'TE','5137206384',0,'2014-01-15 02:06:08',NULL,NULL),(27761,17899,'TE','4403155615',0,'2014-01-15 02:06:22',NULL,NULL),(31215,20329,'AP','4197968480',0,'2014-01-28 21:01:00',NULL,NULL),(20357,13112,'AP','2162804938',0,'2013-12-26 12:52:31',NULL,NULL),(14790,9679,'TE','4197045004',0,'2013-12-26 04:39:26',NULL,NULL),(12470,8166,'EM','buckeyebred81@yahoo.com',0,'2013-12-26 03:16:30',NULL,NULL),(11225,7302,'TE','3307533623',0,'2013-12-26 02:03:11',NULL,NULL),(10391,6771,'EM','cam011782@aol.com',0,'2013-12-26 01:16:39',NULL,NULL),(10083,6589,'AP','8172797412',0,'2013-12-26 00:53:13',NULL,NULL),(6752,4383,'TE','6146220086',0,'2013-12-25 22:00:41',NULL,NULL),(8002,5221,'AP','3307634727',0,'2013-12-25 23:04:33',NULL,NULL),(22904,14776,'AP','3306968511',1,'2013-12-29 11:13:07',NULL,NULL),(24636,15886,'AP','5042764361',0,'2014-01-03 02:05:34',NULL,NULL),(35342,23224,'AP','6144773193',0,'2014-02-12 21:32:21',NULL,NULL),(39443,26087,'AP','9197247867',0,'2014-02-28 06:30:07',NULL,NULL),(22788,14694,'AP','6144405177',1,'2013-12-29 11:08:54',NULL,NULL),(11761,7655,'AP','5046218593',0,'2013-12-26 03:00:07',NULL,NULL),(9769,6387,'AP','5854556149',0,'2013-12-26 00:48:06',NULL,NULL),(7001,4571,'TE','4699648288',0,'2013-12-25 22:04:59',NULL,NULL),(34300,22507,'EM','nicolestahl1@gmail.com',0,'2014-02-10 21:31:16',NULL,NULL),(39378,26044,'AP','3302892620',0,'2014-02-26 21:02:28',NULL,NULL),(38,26,'TE','9372784590',0,'2013-12-25 17:15:39',NULL,NULL),(28325,18255,'EM','LOSTEE2001@GMAIL.COM',0,'2014-01-16 08:44:33',NULL,NULL),(20244,13041,'TE','9372790650',0,'2013-12-26 12:50:38',NULL,NULL),(27850,17942,'TE','2104383755',0,'2014-01-15 02:06:40',NULL,NULL),(1782,1104,'TE','9377792897',0,'2013-12-25 18:17:20',NULL,NULL),(5760,3690,'TE','4193413302',0,'2013-12-25 21:31:42',NULL,NULL),(3066,1907,'AP','7407076751',0,'2013-12-25 18:59:18',NULL,NULL),(35791,23535,'AP','5049570306',0,'2014-02-13 22:02:29',NULL,NULL),(36563,24069,'AP','3302838999',0,'2014-02-15 22:01:15',NULL,NULL),(14138,9258,'TE','8063410656',0,'2013-12-26 04:15:13',NULL,NULL),(31406,20473,'TE','6142181469',0,'2014-01-29 21:00:57',NULL,NULL),(31051,20200,'TE','6018263451',0,'2014-01-27 21:01:32',NULL,NULL),(30353,19666,'EM','edward.brown985@gmail.com',0,'2014-01-23 21:00:28',NULL,NULL),(9279,6075,'AP','3305020380',0,'2013-12-26 00:02:19',NULL,NULL),(25305,16318,'TE','2256272096',0,'2014-01-07 04:01:37',NULL,NULL),(5372,3439,'AP','2253371241',0,'2013-12-25 21:19:11',NULL,NULL),(4900,3146,'TE','9565697381',0,'2013-12-25 20:30:55',NULL,NULL),(23171,14932,'EM','mtn_breeze@yahoo.com',0,'2013-12-30 00:02:04',NULL,NULL),(23069,14878,'TE','9038472154',0,'2013-12-30 00:00:26',NULL,NULL),(4816,3081,'TE','4196045337',0,'2013-12-25 20:19:44',NULL,NULL),(37651,24826,'AP','9372189001',0,'2014-02-20 04:51:15',NULL,NULL),(38958,25757,'EM','pkeinlee@hotmail.com',0,'2014-02-26 09:30:49',NULL,NULL),(39991,26485,'AP','2257186978',0,'2014-02-28 21:00:07',NULL,NULL),(20455,13179,'AP','2818275498',0,'2013-12-26 12:54:16',NULL,NULL),(26711,17182,'TE','7409624015',0,'2014-01-13 02:22:13',NULL,NULL),(285,175,'AP','3304218590',0,'2013-12-25 17:19:32',NULL,NULL),(4304,2747,'TE','9373640515',0,'2013-12-25 19:48:57',NULL,NULL),(11297,7362,'TE','6015198260',0,'2013-12-26 02:15:26',NULL,NULL),(10586,6887,'EM','ddebru@bellsouth.net',0,'2013-12-26 01:45:17',NULL,NULL),(4058,2589,'EM','rickbayardi@comcast.net',0,'2013-12-25 19:45:03',NULL,NULL),(26456,17031,'AP','4193467456',0,'2014-01-13 02:20:44',NULL,NULL),(25197,16246,'TE','2162565988',0,'2014-01-05 00:02:32',NULL,NULL),(36307,23905,'AP','8597600127',0,'2014-02-14 21:32:26',NULL,NULL),(37879,24987,'AP','9159207795',0,'2014-02-20 22:00:38',NULL,NULL),(38240,25246,'AP','4192033473',0,'2014-02-21 22:01:11',NULL,NULL),(43113,28658,'TE','2252436021',0,'2014-03-08 21:30:42',NULL,NULL),(28053,18080,'TE','3374120981',0,'2014-01-15 02:07:26',NULL,NULL),(23644,15270,'TE','6145325048',1,'2014-01-02 04:21:46',NULL,NULL),(5957,3823,'TE','3307843667',0,'2013-12-25 21:35:00',NULL,NULL),(37057,24403,'BN','5133129753',0,'2014-02-18 22:00:56',NULL,NULL),(39059,25834,'EM','kdorman2009@gmail.com',0,'2014-02-26 21:00:31',NULL,NULL),(39409,26058,'AP','5136338288',0,'2014-02-26 21:02:38',NULL,NULL),(40409,26822,'EM','rzehring2@woh.rr.com',0,'2014-03-01 21:00:35',NULL,NULL),(7676,5001,'TE','3302724681',0,'2013-12-25 22:47:08',NULL,NULL),(26562,17086,'TE','9158558920',0,'2014-01-13 02:21:25',NULL,NULL),(6644,4305,'AP','5132260327',0,'2013-12-25 21:52:27',NULL,NULL),(20358,13112,'EM','jjacobs0007@gmail.com',0,'2013-12-26 12:52:31',NULL,NULL),(6485,4194,'EM','mgerber989@aol.com',0,'2013-12-25 21:49:45',NULL,NULL),(10993,7141,'AP','9033850385',0,'2013-12-26 01:51:53',NULL,NULL),(42047,27943,'TE','8309652463',0,'2014-03-06 21:00:33',NULL,NULL),(11498,7481,'TE','4195479081',0,'2013-12-26 02:31:24',NULL,NULL),(30771,20005,'AP','5132402563',0,'2014-01-26 19:00:06',NULL,NULL),(26541,17073,'EM','kimberlyarmold@yahoo.com',0,'2014-01-13 02:21:18',NULL,NULL),(22201,14300,'EM','brunospizzeria@yahoo.com',0,'2013-12-27 02:06:50',NULL,NULL),(4887,3132,'AP','3305733349',0,'2013-12-25 20:30:33',NULL,NULL),(5713,3666,'EM','kirkhawthorne712@yahoo.com',0,'2013-12-25 21:31:01',NULL,NULL),(37546,24719,'AP','6142260708',0,'2014-02-20 04:37:53',NULL,NULL),(30216,19575,'AP','3374859305',0,'2014-01-23 03:02:38',NULL,NULL),(1419,865,'AP','4192835080',0,'2013-12-25 18:07:18',NULL,NULL),(24888,16045,'EM','memybaby119@hotmail.com',0,'2014-01-04 02:03:01',NULL,NULL),(1793,1112,'AP','9376207815',0,'2013-12-25 18:17:32',NULL,NULL),(10660,6929,'AP','7407072050',0,'2013-12-26 01:46:28',NULL,NULL),(5541,3541,'TE','5122196446',0,'2013-12-25 21:21:47',NULL,NULL),(4081,2603,'TE','3305249333',0,'2013-12-25 19:45:24',NULL,NULL),(4157,2651,'EM','maryplace39@gmail.com',0,'2013-12-25 19:46:37',NULL,NULL),(34691,22748,'AP','5134392250',0,'2014-02-11 21:01:24',NULL,NULL),(36827,24255,'TE','8322358023',0,'2014-02-17 19:00:06',NULL,NULL),(38187,25203,'EM','FPOAKLEY@YAHOO.COM',0,'2014-02-21 22:00:47',NULL,NULL),(43331,28785,'EM','joneste72@gmail.com',0,'2014-03-09 21:00:38',NULL,NULL),(9156,5995,'EM','andywesl@aol.com',0,'2013-12-26 00:00:12',NULL,NULL),(29806,19281,'AP','9373088977',0,'2014-01-21 08:47:00',NULL,NULL),(4609,2941,'TE','9373216187',0,'2013-12-25 20:16:14',NULL,NULL),(10527,6856,'TE','7409702043',0,'2013-12-26 01:31:32',NULL,NULL),(37477,24678,'EM','shellymavrick@hotmail.com',0,'2014-02-20 04:29:37',NULL,NULL),(37994,25064,'TE','5133649107',0,'2014-02-20 22:01:26',NULL,NULL),(38636,25537,'TE','5136753250',0,'2014-02-26 08:00:08',NULL,NULL),(41112,27311,'TE','2816532493',0,'2014-03-04 21:00:39',NULL,NULL),(31597,20611,'EM','DAVE@MEDIAMOUSEINK.COM',0,'2014-01-30 21:00:18',NULL,NULL),(31259,20365,'TE','4193418760',0,'2014-01-28 21:01:23',NULL,NULL),(7150,4662,'TE','3182817847',0,'2013-12-25 22:07:25',NULL,NULL),(5503,3521,'TE','6628406136',0,'2013-12-25 21:21:15',NULL,NULL),(13739,8955,'TE','6148356750',0,'2013-12-26 04:03:41',NULL,NULL),(29435,19033,'TE','2162534272',0,'2014-01-20 08:06:32',NULL,NULL),(27584,17782,'TE','4409414431',0,'2014-01-14 01:33:43',NULL,NULL),(37032,24381,'EM','keichert@cinci.rr.com',0,'2014-02-18 22:00:45',NULL,NULL),(39385,26046,'EM','gemelene@neo.rr.com',0,'2014-02-26 21:02:30',NULL,NULL),(39818,26330,'AP','6625797431',0,'2014-02-28 06:31:40',NULL,NULL),(40934,27199,'AP','2814607277',0,'2014-03-03 21:31:21',NULL,NULL),(41962,27894,'TE','4196671999',0,'2014-03-05 21:32:41',NULL,NULL),(31730,20706,'BN','3183519493',0,'2014-01-30 21:01:07',NULL,NULL),(9439,6179,'TE','4192556198',0,'2013-12-26 00:17:16',NULL,NULL),(30669,19916,'TE','9729041696',0,'2014-01-24 21:01:02',NULL,NULL),(37561,24734,'AP','6146535499',0,'2014-02-20 04:39:52',NULL,NULL),(38555,25477,'TE','4192966080',0,'2014-02-25 21:31:41',NULL,NULL),(39188,25920,'TE','7132641935',0,'2014-02-26 21:01:20',NULL,NULL),(42590,28337,'TE','3257862054',0,'2014-03-07 21:30:14',NULL,NULL),(4618,2945,'TE','3303070337',0,'2013-12-25 20:16:22',NULL,NULL),(29881,19338,'TE','8325150645',1,'2014-01-22 03:22:19',NULL,NULL),(5465,3499,'TE','4193034752',0,'2013-12-25 21:20:39',NULL,NULL),(8315,5450,'TE','4408823552',0,'2013-12-25 23:10:10',NULL,NULL),(27467,17695,'TE','5042756480',0,'2014-01-14 01:33:01',NULL,NULL),(23335,15035,'TE','3182816890',0,'2014-01-01 12:02:45',NULL,NULL),(25515,16452,'AP','9012700247',0,'2014-01-07 04:05:27',NULL,NULL),(35304,23189,'AP','3303283645',0,'2014-02-12 21:32:03',NULL,NULL),(37312,24552,'EM','jbarnette2@neo.rr.com',0,'2014-02-20 04:04:37',NULL,NULL),(29588,19118,'EM','bennett06@fuse.net',0,'2014-01-21 08:45:15',NULL,NULL),(25711,16574,'TE','5707804711',1,'2014-01-07 10:23:27',NULL,NULL),(11327,7378,'TE','4407894635',0,'2013-12-26 02:15:52',NULL,NULL),(6374,4106,'TE','5124202333',0,'2013-12-25 21:47:52',NULL,NULL),(10836,7036,'EM','castilloconstruction@gmail.com',0,'2013-12-26 01:49:17',NULL,NULL),(2030,1255,'EM','SHIRSCHFELD@ONEHOMEFINDER.COM',0,'2013-12-25 18:21:22',NULL,NULL),(11451,7446,'AP','5137229228',0,'2013-12-26 02:30:35',NULL,NULL),(30705,19948,'TE','9374810182',0,'2014-01-24 21:01:19',NULL,NULL),(28400,18300,'EM','mnewsome51@yahoo.com',0,'2014-01-16 08:44:56',NULL,NULL),(26326,16948,'TE','6018572327',0,'2014-01-13 02:19:58',NULL,NULL),(11861,7722,'TE','6142998706',0,'2013-12-26 03:01:46',NULL,NULL),(26021,16765,'TE','4193370525',0,'2014-01-08 18:24:59',NULL,NULL),(21142,13592,'TE','2253851630',0,'2013-12-26 13:05:14',NULL,NULL),(30744,19976,'AP','3308585870',0,'2014-01-25 19:00:14',NULL,NULL),(32999,21612,'EM','happylizzie3@yahoo.com',0,'2014-02-05 21:30:34',NULL,NULL),(36635,24117,'AP','9798484424',0,'2014-02-15 22:01:40',NULL,NULL),(37161,24461,'TE','8016808942',0,'2014-02-18 22:01:33',NULL,NULL),(40819,27124,'AP','6146205035',0,'2014-03-03 21:30:36',NULL,NULL),(41307,27441,'EM','bfeeheley@centurytel.net',0,'2014-03-04 21:01:54',NULL,NULL),(25491,16434,'AP','3309300382',0,'2014-01-07 04:04:57',NULL,NULL),(23288,15004,'EM','officialblakeelle@gmail.com',0,'2014-01-01 12:01:50',NULL,NULL),(9135,5983,'TE','4408881843',0,'2013-12-25 23:51:59',NULL,NULL),(5355,3430,'EM','alexius.prejean@gmail.com',0,'2013-12-25 21:18:55',NULL,NULL),(2220,1366,'TE','2818366305',0,'2013-12-25 18:45:37',NULL,NULL),(31493,20522,'EM','kp1970@yahoo.com',0,'2014-01-29 21:01:25',NULL,NULL),(32510,21252,'TE','3306181969',0,'2014-02-03 21:01:18',NULL,NULL),(39577,26182,'AP','6145469153',0,'2014-02-28 06:30:41',NULL,NULL),(39755,26290,'AP','3182651296',0,'2014-02-28 06:31:24',NULL,NULL),(10956,7121,'EM','dennisrford@gmail.com',0,'2013-12-26 01:51:20',NULL,NULL),(589,362,'AP','3252629290',0,'2013-12-25 17:45:13',NULL,NULL),(28272,18229,'AP','4694508157',0,'2014-01-16 08:44:18',NULL,NULL),(28141,18141,'EM','CARROLL.COEL@YAHOO.COM',0,'2014-01-15 02:07:46',NULL,NULL),(2348,1428,'TE','9852014576',0,'2013-12-25 18:47:29',NULL,NULL),(6064,3903,'TE','6625922903',0,'2013-12-25 21:36:54',NULL,NULL),(6562,4238,'TE','2817401157',0,'2013-12-25 21:50:56',NULL,NULL),(33126,21699,'TE','3307779796',0,'2014-02-05 21:31:10',NULL,NULL),(34852,22852,'TE','4193055513',0,'2014-02-11 21:02:21',NULL,NULL),(38514,25451,'AP','9155390104',0,'2014-02-25 21:31:26',NULL,NULL),(43015,28603,'TE','3307338547',0,'2014-03-08 21:30:10',NULL,NULL),(24654,15896,'TE','3307224127',0,'2014-01-03 02:05:55',NULL,NULL),(22842,14740,'TE','2257185756',1,'2013-12-29 11:10:00',NULL,NULL),(7447,4851,'TE','5138465353',0,'2013-12-25 22:30:22',NULL,NULL),(10734,6980,'TE','6147641136',0,'2013-12-26 01:47:42',NULL,NULL),(7107,4641,'EM','agiust@comcast.net',0,'2013-12-25 22:06:47',NULL,NULL),(36433,23993,'EM','dawnoliver@hotmail.com',0,'2014-02-15 22:00:28',NULL,NULL),(36633,24115,'AP','9562211892',0,'2014-02-15 22:01:39',NULL,NULL),(42474,28229,'TE','6143167646',0,'2014-03-06 21:30:22',NULL,NULL),(7938,5176,'EM','larryboso@sbcglobal.net',0,'2013-12-25 23:03:26',NULL,NULL),(10689,6948,'TE','2164867062',0,'2013-12-26 01:46:58',NULL,NULL),(27032,17382,'AP','5136088993',0,'2014-01-13 03:00:07',NULL,NULL),(8486,5583,'TE','3309255181',0,'2013-12-25 23:17:00',NULL,NULL),(6575,4244,'TE','2812424761',0,'2013-12-25 21:51:07',NULL,NULL),(6613,4274,'TE','9374031797',0,'2013-12-25 21:51:50',NULL,NULL),(2816,1703,'AP','5137041007',0,'2013-12-25 18:54:48',NULL,NULL),(5791,3712,'AP','4196052409',0,'2013-12-25 21:32:14',NULL,NULL),(4978,3197,'TE','5133442789',0,'2013-12-25 20:45:03',NULL,NULL),(4306,2749,'TE','5133672499',0,'2013-12-25 19:49:01',NULL,NULL),(32452,21204,'TE','9855191082',0,'2014-02-03 21:00:55',NULL,NULL),(33979,22289,'AP','4196106927',0,'2014-02-10 11:00:29',NULL,NULL),(34875,22873,'AP','6622136345',0,'2014-02-11 21:02:31',NULL,NULL),(40577,26930,'AP','4403432384',0,'2014-03-03 01:00:19',NULL,NULL),(42055,27948,'TE','3253922876',0,'2014-03-06 21:00:36',NULL,NULL),(43174,28689,'EM','planetgirl27@yahoo.com',0,'2014-03-08 21:31:02',NULL,NULL),(83,49,'AP','2673034299',0,'2013-12-25 17:16:20',NULL,NULL),(12460,8158,'AP','2167805601',0,'2013-12-26 03:16:17',NULL,NULL),(7779,5076,'TE','9729309908',0,'2013-12-25 23:00:50',NULL,NULL),(1043,642,'AP','2164062691',0,'2013-12-25 18:01:24',NULL,NULL),(12387,8112,'AP','2258920047',0,'2013-12-26 03:15:03',NULL,NULL),(7670,4993,'AP','5138501717',0,'2013-12-25 22:46:59',NULL,NULL),(23187,14943,'EM','xrayman1987@yahoo.com',0,'2013-12-30 00:02:23',NULL,NULL),(9210,6025,'EM','maribelgon_87@yahoo.com',0,'2013-12-26 00:01:00',NULL,NULL),(32883,21522,'TE','5136250081',0,'2014-02-05 21:00:07',NULL,NULL),(33092,21678,'TE','2257575957',0,'2014-02-05 21:31:01',NULL,NULL),(34901,22901,'BN','4192330475',0,'2014-02-11 21:02:42',NULL,NULL),(38132,25170,'AP','4195642855',0,'2014-02-21 22:00:27',NULL,NULL),(12417,8133,'EM','tenee.martin@yahoo.com',0,'2013-12-26 03:15:35',NULL,NULL),(14782,9672,'EM','jbak1961@yahoo.com',0,'2013-12-26 04:39:16',NULL,NULL),(12271,8026,'EM','rlwilliamson@comcast.net',0,'2013-12-26 03:09:02',NULL,NULL),(9545,6248,'AP','2254851600',0,'2013-12-26 00:31:52',NULL,NULL),(1806,1117,'EM','NALJVANNY@HOTMAIL.COM',0,'2013-12-25 18:17:42',NULL,NULL),(31781,20746,'TE','4192643852',0,'2014-01-30 21:01:27',NULL,NULL),(33313,21818,'TE','3302127230',0,'2014-02-06 21:00:58',NULL,NULL),(35421,23286,'TE','3306962094',0,'2014-02-13 22:00:04',NULL,NULL),(37761,24917,'TE','3305484587',0,'2014-02-20 21:30:12',NULL,NULL),(38743,25612,'TE','8303357397',0,'2014-02-26 08:30:10',NULL,NULL),(40250,26703,'TE','2163947785',0,'2014-02-28 21:31:34',NULL,NULL),(41239,27390,'TE','5137778053',0,'2014-03-04 21:01:27',NULL,NULL),(41841,27821,'TE','5135222303',0,'2014-03-05 21:31:56',NULL,NULL),(6524,4220,'TE','9406963476',0,'2013-12-25 21:50:24',NULL,NULL),(1148,706,'TE','2258694025',0,'2013-12-25 18:03:03',NULL,NULL),(6355,4094,'AP','5676983226',0,'2013-12-25 21:47:33',NULL,NULL),(24422,15766,'EM','Autumn28101981@live.com',0,'2014-01-03 02:01:41',NULL,NULL),(42755,28439,'EM','rlowe_breesefarmsllc@yahoo.com',0,'2014-03-07 21:31:12',NULL,NULL),(27790,17913,'AP','8064014720',0,'2014-01-15 02:06:28',NULL,NULL),(3777,2396,'TE','5134624316',0,'2013-12-25 19:33:25',NULL,NULL),(8344,5478,'AP','4194503633',0,'2013-12-25 23:10:46',NULL,NULL),(26189,16858,'AP','9155887629',0,'2014-01-13 02:19:08',NULL,NULL),(23759,15325,'AP','7134106030',1,'2014-01-02 04:23:43',NULL,NULL),(24243,15661,'AP','9033307962',1,'2014-01-02 04:34:28',NULL,NULL),(34199,22429,'TE','2149309327',0,'2014-02-10 21:30:35',NULL,NULL),(34549,22660,'TE','9563192284',0,'2014-02-11 21:00:34',NULL,NULL),(38221,25228,'TE','4196516886',0,'2014-02-21 22:01:01',NULL,NULL),(13646,8898,'TE','4197099167',0,'2013-12-26 04:02:13',NULL,NULL),(25830,16654,'TE','6622302117',0,'2014-01-08 18:24:21',NULL,NULL),(32411,21178,'EM','HEDGES532003@YAHOO.COM',0,'2014-02-03 21:00:42',NULL,NULL),(33716,22115,'EM','nancyj.jaber@gmail.com',0,'2014-02-08 19:00:37',NULL,NULL),(37595,24769,'AP','5132844411',0,'2014-02-20 04:44:17',NULL,NULL),(42886,28523,'TE','9372892608',0,'2014-03-07 21:32:02',NULL,NULL),(43870,29109,'EM','astorageinn11@att.net',0,'2014-03-10 21:02:23',NULL,NULL),(11594,7543,'AP','8323269441',0,'2013-12-26 02:32:59',NULL,NULL),(30301,19629,'TE','3303950776',0,'2014-01-23 21:00:08',NULL,NULL),(605,374,'TE','9725240040',0,'2013-12-25 17:45:31',NULL,NULL),(10477,6827,'TE','3304142197',0,'2013-12-26 01:30:40',NULL,NULL),(7333,4767,'TE','6143485529',0,'2013-12-25 22:15:44',NULL,NULL),(28178,18163,'AP','9377283222',0,'2014-01-15 02:07:55',NULL,NULL),(4013,2553,'TE','5137920405',0,'2013-12-25 19:37:19',NULL,NULL),(4276,2733,'TE','5042426262',0,'2013-12-25 19:48:33',NULL,NULL),(25075,16166,'AP','9867103202',0,'2014-01-05 00:00:06',NULL,NULL),(42837,28491,'TE','6016722180',0,'2014-03-07 21:31:42',NULL,NULL),(30163,19543,'TE','6019859272',0,'2014-01-23 03:02:26',NULL,NULL),(27824,17930,'TE','2147345383',0,'2014-01-15 02:06:35',NULL,NULL),(24059,15534,'TE','3184394715',1,'2014-01-02 04:30:44',NULL,NULL),(1081,665,'TE','3305595203',0,'2013-12-25 18:01:59',NULL,NULL),(21788,14039,'TE','5138752920',0,'2013-12-26 13:17:07',NULL,NULL),(3021,1882,'AP','4193507278',0,'2013-12-25 18:58:34',NULL,NULL),(12259,8015,'EM','red0723@frontier.com',0,'2013-12-26 03:08:46',NULL,NULL),(11780,7664,'TE','2256145743',0,'2013-12-26 03:00:22',NULL,NULL),(32350,21133,'AP','7134088056',0,'2014-02-03 21:00:19',NULL,NULL),(35802,23541,'EM','lolitapose@gmail.com',0,'2014-02-13 22:02:33',NULL,NULL),(35825,23557,'EM','Oviahnosa@aol.com',0,'2014-02-13 22:02:43',NULL,NULL),(39650,26219,'TE','8305601266',0,'2014-02-28 06:30:56',NULL,NULL),(43432,28844,'AP','3306343856',0,'2014-03-09 21:01:14',NULL,NULL),(9365,6131,'TE','9039339157',0,'2013-12-26 00:16:00',NULL,NULL),(436,271,'EM','wilbur37@hotmail.com',0,'2013-12-25 17:22:05',NULL,NULL),(30874,20069,'TE','8322266850',0,'2014-01-27 21:00:16',NULL,NULL),(7849,5123,'AP','9563722182',0,'2013-12-25 23:02:00',NULL,NULL),(30855,20056,'EM','mel8372@hotmail.com',0,'2014-01-27 21:00:08',NULL,NULL),(30173,19548,'AP','4192157661',0,'2014-01-23 03:02:28',NULL,NULL),(29771,19250,'AP','5135188160',0,'2014-01-21 08:46:43',NULL,NULL),(28816,18599,'TE','6018639076',0,'2014-01-16 08:47:18',NULL,NULL),(7351,4777,'EM','jshemekisa@yahoo.com',0,'2013-12-25 22:16:01',NULL,NULL),(41262,27421,'AP','2282298089',0,'2014-03-04 21:01:39',NULL,NULL),(28628,18456,'TE','2257516418',0,'2014-01-16 08:46:10',NULL,NULL),(24610,15871,'TE','6019425330',0,'2014-01-03 02:05:07',NULL,NULL),(6990,4566,'TE','4095270575',0,'2013-12-25 22:04:50',NULL,NULL),(22871,14758,'AP','9152825092',1,'2013-12-29 11:12:36',NULL,NULL),(4948,3176,'AP','2283425628',0,'2013-12-25 20:31:42',NULL,NULL),(7905,5152,'TE','3308251040',0,'2013-12-25 23:02:49',NULL,NULL),(5832,3743,'AP','3616878232',0,'2013-12-25 21:32:57',NULL,NULL),(33398,21885,'AP','5045794839',0,'2014-02-06 21:01:33',NULL,NULL),(36717,24176,'TE','6019421907',0,'2014-02-16 19:00:05',NULL,NULL),(43765,29053,'TE','4196261954',0,'2014-03-10 21:01:47',NULL,NULL),(13774,8978,'EM','mflower15@aim.com',0,'2013-12-26 04:04:15',NULL,NULL),(28224,18197,'TE','5134766860',0,'2014-01-15 02:08:05',NULL,NULL),(5418,3468,'EM','WBILLOPS1@HOTMAIL.COM',0,'2013-12-25 21:19:53',NULL,NULL),(24879,16042,'TE','9562354641',0,'2014-01-04 02:02:53',NULL,NULL),(35217,23131,'TE','2162516481',0,'2014-02-12 21:31:30',NULL,NULL),(36598,24095,'TE','4196513530',0,'2014-02-15 22:01:27',NULL,NULL),(40623,26964,'EM','delghazal@gmail.com',0,'2014-03-03 01:00:32',NULL,NULL),(42107,27976,'TE','5045353173',0,'2014-03-06 21:00:53',NULL,NULL),(6881,4467,'EM','kristinheffley@aol.com',0,'2013-12-25 22:02:45',NULL,NULL),(14914,9757,'AP','3302446388',0,'2013-12-26 05:00:08',NULL,NULL),(4271,2730,'AP','5044192691',0,'2013-12-25 19:48:27',NULL,NULL),(7652,4981,'AP','8178846459',0,'2013-12-25 22:46:44',NULL,NULL),(32263,21073,'EM','crazysue-6kids@sbcglobal.net',0,'2014-02-02 19:00:18',NULL,NULL),(34335,22526,'AP','5133197207',0,'2014-02-10 21:31:28',NULL,NULL),(43578,28938,'AP','4192768197',0,'2014-03-10 21:00:41',NULL,NULL),(26629,17134,'AP','5133796661',0,'2014-01-13 02:21:48',NULL,NULL),(12420,8134,'EM','esnyder7@sbcglobal.net',0,'2013-12-26 03:15:38',NULL,NULL),(556,346,'TE','5012496592',0,'2013-12-25 17:32:07',NULL,NULL),(8059,5277,'TE','3308070915',0,'2013-12-25 23:05:41',NULL,NULL),(2779,1683,'AP','5042367522',0,'2013-12-25 18:54:14',NULL,NULL),(2674,1623,'EM','pphillip59@yahoo.com',0,'2013-12-25 18:52:38',NULL,NULL),(21413,13767,'TE','6622425561',0,'2013-12-26 13:10:24',NULL,NULL),(31744,20715,'AP','3184038406',0,'2014-01-30 21:01:11',NULL,NULL),(35833,23564,'AP','4196192922',0,'2014-02-13 22:02:46',NULL,NULL),(36555,24066,'AP','5136558540',0,'2014-02-15 22:01:13',NULL,NULL),(38884,25702,'TE','9158864957',0,'2014-02-26 09:30:19',NULL,NULL),(41090,27293,'AP','2816770181',0,'2014-03-04 21:00:30',NULL,NULL),(31236,20342,'AP','2162991254',0,'2014-01-28 21:01:09',NULL,NULL),(28731,18540,'AP','6016705390',0,'2014-01-16 08:46:48',NULL,NULL),(8289,5431,'EM','gitieubao@gmail.com',0,'2013-12-25 23:09:40',NULL,NULL),(6402,4130,'TE','3308980677',0,'2013-12-25 21:48:23',NULL,NULL),(4716,3018,'TE','3306991598',0,'2013-12-25 20:18:06',NULL,NULL),(24779,15984,'TE','9037679637',0,'2014-01-04 02:01:03',NULL,NULL),(11358,7399,'TE','4195786065',0,'2013-12-26 02:16:23',NULL,NULL),(10776,7005,'TE','3617747558',0,'2013-12-26 01:48:23',NULL,NULL),(11240,7317,'EM','LLELEUX77@SBCGLOBAL.NET',0,'2013-12-26 02:03:31',NULL,NULL),(32559,21291,'TE','3183399218',0,'2014-02-04 21:00:07',NULL,NULL),(34380,22551,'AP','9379851580',0,'2014-02-10 21:31:45',NULL,NULL),(35882,23597,'TE','4194340312',0,'2014-02-13 22:03:06',NULL,NULL),(37712,24865,'TE','9723521763',0,'2014-02-20 05:31:36',NULL,NULL),(10034,6564,'AP','8178973590',0,'2013-12-26 00:52:30',NULL,NULL),(22065,14209,'AP','7136888075',0,'2013-12-27 02:04:28',NULL,NULL),(6038,3879,'TE','8325631044',0,'2013-12-25 21:36:23',NULL,NULL),(781,486,'EM','rlaurie6592@gmail.com',0,'2013-12-25 17:48:18',NULL,NULL),(14173,9273,'TE','7406452268',0,'2013-12-26 04:15:44',NULL,NULL),(37631,24800,'AP','7403363602',0,'2014-02-20 04:48:21',NULL,NULL),(37987,25060,'AP','4192170332',0,'2014-02-20 22:01:23',NULL,NULL),(38861,25685,'EM','kenta.hamilton@att.net',0,'2014-02-26 09:30:08',NULL,NULL),(1173,720,'EM','louiethelou@aol.com',0,'2013-12-25 18:03:26',NULL,NULL),(20279,13071,'TE','9374340898',0,'2013-12-26 12:51:19',NULL,NULL),(10975,7132,'AP','6012480265',0,'2013-12-26 01:51:38',NULL,NULL),(1724,1056,'AP','2102518301',0,'2013-12-25 18:16:11',NULL,NULL),(30074,19481,'TE','8326618787',0,'2014-01-23 03:02:03',NULL,NULL),(6933,4517,'TE','9155841421',0,'2013-12-25 22:03:45',NULL,NULL),(29053,18758,'EM','EWATERS@GIMED.NET',0,'2014-01-17 03:35:46',NULL,NULL),(28349,18266,'TE','8326838546',0,'2014-01-16 08:44:39',NULL,NULL),(25094,16179,'AP','2817707083',0,'2014-01-05 00:00:29',NULL,NULL),(5245,3368,'EM','Lautriv6@hotmail.com',0,'2013-12-25 21:17:11',NULL,NULL),(24827,16014,'EM','jgarner523@bellsouth.net',0,'2014-01-04 02:01:56',NULL,NULL),(32895,21532,'AP','5136499251',0,'2014-02-05 21:30:07',NULL,NULL),(35591,23407,'EM','monahan.ken@gmail.com',0,'2014-02-13 22:01:13',NULL,NULL),(24951,16082,'EM','jennradelk@yahoo.com',0,'2014-01-04 02:04:09',NULL,NULL),(9313,6098,'EM','timdirr@gmail.com',0,'2013-12-26 00:15:08',NULL,NULL),(8804,5767,'AP','7404417451',0,'2013-12-25 23:46:41',NULL,NULL),(32702,21393,'TE','7404528395',0,'2014-02-04 21:00:58',NULL,NULL),(38420,25385,'EM','jenbeers@neo.rr.com',0,'2014-02-25 21:30:49',NULL,NULL),(40238,26690,'EM','Helaine.wright@gmail.com',0,'2014-02-28 21:31:28',NULL,NULL),(20461,13181,'AP','8176910267',0,'2013-12-26 12:54:20',NULL,NULL),(34377,22549,'TE','2257154798',0,'2014-02-10 21:31:44',NULL,NULL),(34702,22755,'TE','9857788991',0,'2014-02-11 21:01:28',NULL,NULL),(40358,26786,'TE','3614531314',0,'2014-03-01 21:00:15',NULL,NULL),(26177,16853,'TE','5672860151',0,'2014-01-13 02:18:41',NULL,NULL),(9724,6364,'EM','suzeann1@windstream.net',0,'2013-12-26 00:47:27',NULL,NULL),(10581,6886,'TE','3182680823',0,'2013-12-26 01:45:14',NULL,NULL),(1868,1153,'AP','3183327199',0,'2013-12-25 18:18:41',NULL,NULL),(8256,5401,'TE','5137778806',0,'2013-12-25 23:08:57',NULL,NULL),(4465,2843,'TE','9379685491',0,'2013-12-25 20:01:07',NULL,NULL),(7614,4960,'EM','Mikecrawfish@cs.com',0,'2013-12-25 22:46:09',NULL,NULL),(22596,14573,'EM','bmwhaus62@yahoo.com',0,'2013-12-28 03:35:36',NULL,NULL),(25653,16542,'EM','dlance1124@yahoo.com',1,'2014-01-07 10:22:25',NULL,NULL),(35907,23625,'EM','aalgahmee33@gmail.com',0,'2014-02-13 22:03:19',NULL,NULL),(42365,28138,'TE','4193740525',0,'2014-03-06 21:02:29',NULL,NULL),(21868,14086,'EM','fslouis2169@yahoo.com',0,'2013-12-27 02:01:15',NULL,NULL),(14854,9720,'AP','4405033663',0,'2013-12-26 04:45:26',NULL,NULL),(30962,20140,'AP','4194642118',0,'2014-01-27 21:00:58',NULL,NULL),(13581,8855,'TE','9568005042',0,'2013-12-26 04:01:08',NULL,NULL),(25805,16629,'EM','Brandi3434@roadrunner.com',0,'2014-01-08 18:24:14',NULL,NULL),(23145,14921,'AP','7408561334',0,'2013-12-30 00:01:41',NULL,NULL),(2728,1655,'AP','8176584491',0,'2013-12-25 18:53:28',NULL,NULL),(8360,5495,'TE','9376051025',0,'2013-12-25 23:11:09',NULL,NULL),(11340,7387,'AP','6147361100',0,'2013-12-26 02:16:03',NULL,NULL),(33038,21644,'TE','8063881923',0,'2014-02-05 21:30:47',NULL,NULL),(9762,6384,'AP','3306066342',0,'2013-12-26 00:48:00',NULL,NULL),(31268,20368,'BN','8504965274',0,'2014-01-29 21:00:04',NULL,NULL),(11461,7451,'EM','KOPPEL.KREATIONS@YAHOO.COM',0,'2013-12-26 02:30:44',NULL,NULL),(14613,9554,'TE','9376715957',0,'2013-12-26 04:36:22',NULL,NULL),(41871,27841,'AP','9563830645',0,'2014-03-05 21:32:08',NULL,NULL),(42823,28481,'TE','7409175237',0,'2014-03-07 21:31:36',NULL,NULL),(25400,16381,'AP','3612124619',0,'2014-01-07 04:03:20',NULL,NULL),(22064,14209,'TE','7136888075',0,'2013-12-27 02:04:28',NULL,NULL),(5402,3455,'EM','chrystinebaker@gmail.com',0,'2013-12-25 21:19:38',NULL,NULL),(9335,6113,'AP','3305920861',0,'2013-12-26 00:15:31',NULL,NULL),(10731,6979,'TE','6143302872',0,'2013-12-26 01:47:40',NULL,NULL),(36222,23841,'AP','5132272498',0,'2014-02-14 21:31:52',NULL,NULL),(32144,20995,'TE','9373294786',0,'2014-02-01 19:00:26',NULL,NULL),(9853,6443,'TE','4193491086',0,'2013-12-26 00:49:30',NULL,NULL),(30578,19840,'TE','5042677446',0,'2014-01-24 21:00:25',NULL,NULL),(27258,17552,'TE','9014826034',0,'2014-01-13 03:01:55',NULL,NULL),(26821,17249,'TE','4408557044',0,'2014-01-13 02:23:11',NULL,NULL),(14020,9155,'EM','formanj@aol.com',0,'2013-12-26 04:08:34',NULL,NULL),(7649,4980,'TE','3613896849',0,'2013-12-25 22:46:42',NULL,NULL),(23882,15409,'EM','tuan_pham223@yahoo.com',1,'2014-01-02 04:27:04',NULL,NULL),(11381,7410,'EM','terri@lsaalubbock.com',0,'2013-12-26 02:16:43',NULL,NULL),(7570,4928,'TE','6145786308',0,'2013-12-25 22:45:21',NULL,NULL),(35389,23258,'TE','4322718750',0,'2014-02-13 21:30:08',NULL,NULL),(37787,24939,'TE','6012913759',0,'2014-02-20 22:00:03',NULL,NULL),(36743,24189,'AP','6822342762',0,'2014-02-16 19:00:13',NULL,NULL),(11609,7549,'EM','lydell@cox.net',0,'2013-12-26 02:33:10',NULL,NULL),(20567,13235,'EM','nealduncan@gmail.com',0,'2013-12-26 12:55:54',NULL,NULL),(24032,15515,'AP','3372772169',1,'2014-01-02 04:30:11',NULL,NULL),(2104,1300,'EM','mohonj4545@live.com',0,'2013-12-25 18:31:09',NULL,NULL),(23586,15226,'AP','3187914829',0,'2014-01-01 12:08:11',NULL,NULL),(13747,8958,'AP','9378447979',0,'2013-12-26 04:03:47',NULL,NULL),(5923,3798,'AP','5134656482',0,'2013-12-25 21:34:27',NULL,NULL),(43764,29052,'EM','kaemery1@frontier.com',0,'2014-03-10 21:01:47',NULL,NULL),(21761,14018,'EM','doty32@earthlink.net',0,'2013-12-26 13:16:32',NULL,NULL),(739,463,'AP','3304316249',0,'2013-12-25 17:47:41',NULL,NULL),(9854,6443,'AP','4193491086',0,'2013-12-26 00:49:30',NULL,NULL),(20463,13182,'EM','jmeasher@hotmail.com',0,'2013-12-26 12:54:22',NULL,NULL),(14833,9710,'TE','9175753508',0,'2013-12-26 04:45:09',NULL,NULL),(9736,6370,'TE','3306654746',0,'2013-12-26 00:47:38',NULL,NULL),(2417,1474,'AP','4193056191',0,'2013-12-25 18:48:39',NULL,NULL),(31955,20867,'TE','4193469485',0,'2014-01-31 21:00:59',NULL,NULL),(28244,18213,'TE','2163511708',0,'2014-01-15 02:08:11',NULL,NULL),(9140,5987,'TE','4403411795',0,'2013-12-25 23:52:06',NULL,NULL),(5636,3615,'TE','4199609347',0,'2013-12-25 21:23:32',NULL,NULL),(7322,4761,'EM','Lfatute@gmail.com',0,'2013-12-25 22:15:33',NULL,NULL),(35869,23589,'TE','3307536335',0,'2014-02-13 22:03:01',NULL,NULL),(36311,23907,'TE','9372152915',0,'2014-02-14 21:32:28',NULL,NULL),(39281,25991,'TE','6627010138',0,'2014-02-26 21:01:57',NULL,NULL),(40164,26637,'EM','KHANHDANH1986@YAHOO.COM',0,'2014-02-28 21:31:01',NULL,NULL),(40534,26903,'AP','5128267373',0,'2014-03-03 01:00:08',NULL,NULL),(42736,28424,'AP','3305657809',0,'2014-03-07 21:31:05',NULL,NULL),(43530,28902,'TE','3256503548',0,'2014-03-10 21:00:21',NULL,NULL),(32810,21467,'AP','6012150284',0,'2014-02-04 21:01:36',NULL,NULL),(32434,21193,'TE','6628339092',0,'2014-02-03 21:00:49',NULL,NULL),(1649,1012,'AP','5136806024',0,'2013-12-25 18:11:19',NULL,NULL),(7693,5020,'TE','3184661655',0,'2013-12-25 22:47:31',NULL,NULL),(6682,4338,'AP','9375093801',0,'2013-12-25 21:53:13',NULL,NULL),(39982,26472,'TE','2258695632',0,'2014-02-28 07:30:38',NULL,NULL),(41030,27260,'EM','maggiesissel@yahoo.com',0,'2014-03-03 21:31:59',NULL,NULL),(34471,22619,'TE','5052352666',0,'2014-02-11 21:00:09',NULL,NULL),(9834,6434,'AP','2252763389',0,'2013-12-26 00:49:14',NULL,NULL),(32056,20929,'AP','6015000124',0,'2014-01-31 21:01:36',NULL,NULL),(3360,2112,'EM','PRECIOUS1DI@GMAIL.COM',0,'2013-12-25 19:17:28',NULL,NULL),(21383,13751,'AP','4195162895',0,'2013-12-26 13:09:57',NULL,NULL),(1651,1013,'AP','5042356923',0,'2013-12-25 18:15:03',NULL,NULL),(22093,14230,'AP','9154911841',0,'2013-12-27 02:04:58',NULL,NULL),(276,169,'EM','connie.doc@frontier.com',0,'2013-12-25 17:19:25',NULL,NULL),(31587,20603,'TE','6148510787',0,'2014-01-30 21:00:14',NULL,NULL),(28868,18639,'BN','2144985588',0,'2014-01-17 03:35:06',NULL,NULL),(25372,16362,'AP','6013353543',0,'2014-01-07 04:02:48',NULL,NULL),(25059,16155,'TE','2162122535',0,'2014-01-04 02:06:23',NULL,NULL),(7388,4807,'TE','6147532693',0,'2013-12-25 22:16:41',NULL,NULL),(8943,5854,'EM','fokokhere@gmail.com',0,'2013-12-25 23:48:52',NULL,NULL),(8036,5258,'TE','3302458591',0,'2013-12-25 23:05:17',NULL,NULL),(3301,2077,'EM','Johnnyw1970@aol.com',0,'2013-12-25 19:16:32',NULL,NULL),(40071,26571,'TE','7409619671',0,'2014-02-28 21:30:26',NULL,NULL),(22991,14829,'EM','frj8350@aol.com',1,'2013-12-29 11:14:32',NULL,NULL),(25901,16693,'AP','9156267381',0,'2014-01-08 18:24:36',NULL,NULL),(34420,22580,'TE','4196155098',0,'2014-02-10 21:32:02',NULL,NULL),(30132,19516,'TE','4402279612',0,'2014-01-23 03:02:17',NULL,NULL),(14702,9621,'TE','4199800250',0,'2013-12-26 04:37:54',NULL,NULL),(29007,18724,'AP','4193108303',0,'2014-01-17 03:35:35',NULL,NULL),(35836,23565,'EM','bri43613@aol.com',0,'2014-02-13 22:02:47',NULL,NULL),(29328,18952,'TE','3612440199',0,'2014-01-20 08:05:50',NULL,NULL),(24848,16027,'AP','3184476940',0,'2014-01-04 02:02:21',NULL,NULL),(28965,18695,'TE','5045631875',0,'2014-01-17 03:35:26',NULL,NULL),(14259,9327,'TE','5044281160',0,'2013-12-26 04:30:40',NULL,NULL),(22387,14440,'EM','mcshalett@gmail.com',0,'2013-12-28 03:32:10',NULL,NULL),(23449,15113,'TE','3308121458',0,'2014-01-01 12:05:02',NULL,NULL),(8701,5709,'EM','jayeljay1@yahoo.com',0,'2013-12-25 23:45:06',NULL,NULL),(8281,5425,'TE','2203629082',0,'2013-12-25 23:09:30',NULL,NULL),(23413,15082,'AP','9729669874',0,'2014-01-01 12:04:12',NULL,NULL),(36571,24072,'AP','3308619997',0,'2014-02-15 22:01:17',NULL,NULL),(41193,27358,'TE','3306860020',0,'2014-03-04 21:01:10',NULL,NULL),(29166,18845,'TE','4404635374',0,'2014-01-17 03:36:14',NULL,NULL),(634,394,'EM','matthew.murtland@gmail.com',0,'2013-12-25 17:45:59',NULL,NULL),(24983,16101,'TE','5139390001',0,'2014-01-04 02:04:47',NULL,NULL),(11857,7718,'TE','6144249609',0,'2013-12-26 03:01:41',NULL,NULL),(10408,6785,'EM','sofia22h2002@yahoo.com',0,'2013-12-26 01:16:57',NULL,NULL),(10047,6572,'TE','5043924987',0,'2013-12-26 00:52:43',NULL,NULL),(789,493,'TE','3372775766',0,'2013-12-25 17:48:28',NULL,NULL),(22091,14229,'EM','cclairerockett@gmail.com',0,'2013-12-27 02:04:57',NULL,NULL),(4289,2739,'TE','3303225611',0,'2013-12-25 19:48:44',NULL,NULL),(4624,2947,'TE','3307443885',0,'2013-12-25 20:16:26',NULL,NULL),(1722,1055,'AP','2145371011',0,'2013-12-25 18:16:09',NULL,NULL),(5191,3332,'EM','CHOOCH69203@GMAIL.COM',0,'2013-12-25 21:16:21',NULL,NULL),(38072,25132,'AP','2817369021',0,'2014-02-21 22:00:04',NULL,NULL),(39851,26357,'EM','jlkulnane1@gmail.com',0,'2014-02-28 07:00:04',NULL,NULL),(31376,20453,'TE','7403541073',0,'2014-01-29 21:00:46',NULL,NULL),(7306,4755,'TE','9036914140',0,'2013-12-25 22:15:20',NULL,NULL),(2359,1433,'EM','mfasano333@yahoo.com',0,'2013-12-25 18:47:38',NULL,NULL),(28932,18678,'EM','mtrolinger@gmail.com',0,'2014-01-17 03:35:19',NULL,NULL),(3343,2102,'EM','Sarah.haussler@gmail.com',0,'2013-12-25 19:17:12',NULL,NULL),(1184,724,'EM','cpadistributions@hotmail.com',0,'2013-12-25 18:03:35',NULL,NULL),(21440,13782,'AP','6018260424',0,'2013-12-26 13:10:47',NULL,NULL),(36616,24106,'AP','7245573782',0,'2014-02-15 22:01:34',NULL,NULL),(38037,25096,'AP','5138344078',0,'2014-02-21 21:30:08',NULL,NULL),(43103,28654,'TE','6782218494',0,'2014-03-08 21:30:40',NULL,NULL),(120,70,'AP','5136087159',0,'2013-12-25 17:16:55',NULL,NULL),(10288,6715,'AP','5672252080',0,'2013-12-26 01:02:25',NULL,NULL),(10089,6593,'TE','5126367274',0,'2013-12-26 00:53:19',NULL,NULL),(8848,5798,'TE','4197066814',0,'2013-12-25 23:47:26',NULL,NULL),(8684,5700,'EM','terrymiller19@gmail.com',0,'2013-12-25 23:32:54',NULL,NULL),(30245,19591,'AP','6014106332',0,'2014-01-23 03:02:44',NULL,NULL),(28747,18551,'TE','6627197875',0,'2014-01-16 08:46:54',NULL,NULL),(23071,14879,'AP','8326921184',0,'2013-12-30 00:00:29',NULL,NULL),(23824,15370,'EM','rmetzger2222@att.net',1,'2014-01-02 04:25:04',NULL,NULL),(2288,1403,'TE','9857885822',0,'2013-12-25 18:46:40',NULL,NULL),(24822,16011,'EM','swtigler@gmail.com',0,'2014-01-04 02:01:51',NULL,NULL),(32267,21077,'EM','keithcfriedman@gmail.com',0,'2014-02-02 19:00:20',NULL,NULL),(9346,6119,'AP','9035886056',0,'2013-12-26 00:15:42',NULL,NULL),(9580,6274,'TE','5132524648',0,'2013-12-26 00:45:10',NULL,NULL),(7495,4882,'AP','4139490300',0,'2013-12-25 22:31:16',NULL,NULL),(30208,19568,'TE','5043618013',0,'2014-01-23 03:02:36',NULL,NULL),(25591,16508,'AP','4195091606',1,'2014-01-07 10:21:17',NULL,NULL),(9678,6341,'AP','2163757475',0,'2013-12-26 00:46:47',NULL,NULL),(10301,6721,'EM','Tteache@aol.com',0,'2013-12-26 01:15:13',NULL,NULL),(6683,4338,'TE','9375093801',0,'2013-12-25 21:53:13',NULL,NULL),(4145,2646,'TE','4322302084',0,'2013-12-25 19:46:28',NULL,NULL),(11671,7598,'AP','5673438312',0,'2013-12-26 02:45:18',NULL,NULL),(36418,23986,'AP','3373492733',0,'2014-02-15 22:00:23',NULL,NULL),(425,258,'EM','gobucks45503@yahoo.com',0,'2013-12-25 17:21:48',NULL,NULL),(27652,17825,'TE','6012680905',0,'2014-01-15 02:05:58',NULL,NULL),(21665,13947,'AP','5134101174',0,'2013-12-26 13:14:51',NULL,NULL),(20430,13156,'EM','fevance@yahoo.com',0,'2013-12-26 12:53:44',NULL,NULL),(9914,6489,'TE','3306901107',0,'2013-12-26 00:50:32',NULL,NULL),(20673,13294,'EM','beannie72662@yahoo.com',0,'2013-12-26 12:57:34',NULL,NULL),(9054,5938,'TE','2257662241',0,'2013-12-25 23:50:44',NULL,NULL),(9017,5916,'AP','7135780031',0,'2013-12-25 23:50:10',NULL,NULL),(8337,5469,'TE','4198743569',0,'2013-12-25 23:10:37',NULL,NULL),(7049,4606,'TE','3306071173',0,'2013-12-25 22:05:50',NULL,NULL),(5466,3500,'TE','5136580167',0,'2013-12-25 21:20:41',NULL,NULL),(4693,3002,'AP','3302311143',0,'2013-12-25 20:17:41',NULL,NULL),(36713,24172,'TE','4194746378',0,'2014-02-15 22:02:10',NULL,NULL),(42158,28005,'EM','jasmine.ruffner@gmail.com',0,'2014-03-06 21:01:12',NULL,NULL),(23447,15113,'TE','3308121458',0,'2014-01-01 12:05:02',NULL,NULL),(26876,17293,'TE','8325072089',0,'2014-01-13 02:23:34',NULL,NULL),(7330,4766,'TE','2164705042',0,'2013-12-25 22:15:42',NULL,NULL),(661,411,'TE','5132481126',0,'2013-12-25 17:46:26',NULL,NULL),(22514,14517,'TE','9564596251',0,'2013-12-28 03:34:12',NULL,NULL),(36610,24103,'TE','9403824707',0,'2014-02-15 22:01:32',NULL,NULL),(42332,28112,'AP','3303516822',0,'2014-03-06 21:02:16',NULL,NULL),(22825,14720,'TE','3184394257',1,'2013-12-29 11:09:33',NULL,NULL),(35567,23390,'AP','5136075515',0,'2014-02-13 22:01:05',NULL,NULL),(24838,16019,'AP','3184801352',0,'2014-01-04 02:02:07',NULL,NULL),(3279,2062,'EM','heatherjolliff15@yahoo.com',0,'2013-12-25 19:16:09',NULL,NULL),(1457,892,'TE','9373649226',0,'2013-12-25 18:08:01',NULL,NULL),(4116,2625,'AP','2164018177',0,'2013-12-25 19:45:59',NULL,NULL),(2805,1698,'EM','jijiuana@gmail.com',0,'2013-12-25 18:54:38',NULL,NULL),(6147,3957,'EM','granny.cyndi@yahoo.com',0,'2013-12-25 21:38:20',NULL,NULL),(14435,9433,'EM','jlewis@ncool.net',0,'2013-12-26 04:33:29',NULL,NULL),(1596,983,'EM','clacey521@gmail.com',0,'2013-12-25 18:10:23',NULL,NULL),(5755,3688,'TE','3045597892',0,'2013-12-25 21:31:39',NULL,NULL),(42824,28482,'TE','5138078703',0,'2014-03-07 21:31:36',NULL,NULL),(24997,16111,'AP','2283835382',0,'2014-01-04 02:05:05',NULL,NULL),(11484,7468,'EM','tray6364@yahoo.com',0,'2013-12-26 02:31:07',NULL,NULL),(31664,20658,'TE','2547733653',0,'2014-01-30 21:00:42',NULL,NULL),(1799,1115,'TE','7404511147',0,'2013-12-25 18:17:38',NULL,NULL),(14302,9354,'TE','3374855649',0,'2013-12-26 04:31:20',NULL,NULL),(2712,1647,'TE','9039161157',0,'2013-12-25 18:53:15',NULL,NULL),(44006,29199,'TE','9378905998',0,'2014-03-10 21:30:09',NULL,NULL),(30743,19976,'TE','3308585870',0,'2014-01-25 19:00:14',NULL,NULL),(9697,6350,'EM','nikki.cioffi@gmail.com',0,'2013-12-26 00:47:02',NULL,NULL),(6218,4009,'AP','5132381059',0,'2013-12-25 21:45:23',NULL,NULL),(8614,5660,'AP','3309999175',0,'2013-12-25 23:31:44',NULL,NULL),(20783,13356,'TE','4074216994',0,'2013-12-26 12:59:20',NULL,NULL),(21101,13567,'AP','5043122336',0,'2013-12-26 13:04:33',NULL,NULL),(21696,13969,'AP','4193490245',0,'2013-12-26 13:15:22',NULL,NULL),(37927,25026,'TE','4253191438',0,'2014-02-20 22:01:00',NULL,NULL),(41589,27649,'EM','DBStinson1979@gmail.com',0,'2014-03-05 21:30:21',NULL,NULL),(27870,17959,'TE','9152353418',0,'2014-01-15 02:06:45',NULL,NULL),(32430,21191,'AP','6015284221',0,'2014-02-03 21:00:48',NULL,NULL),(29032,18744,'TE','7402866902',0,'2014-01-17 03:35:41',NULL,NULL),(10968,7126,'EM','jwitcher1966@aol.com',0,'2013-12-26 01:51:30',NULL,NULL),(14810,9694,'TE','4402359708',0,'2013-12-26 04:39:49',NULL,NULL),(9471,6197,'AP','5133443629',0,'2013-12-26 00:30:30',NULL,NULL),(20498,13198,'AP','8177897735',0,'2013-12-26 12:54:52',NULL,NULL),(8554,5620,'TE','9378391914',0,'2013-12-25 23:30:46',NULL,NULL),(2663,1616,'AP','8328592789',0,'2013-12-25 18:52:28',NULL,NULL),(6298,4059,'AP','5132881477',0,'2013-12-25 21:46:38',NULL,NULL),(24119,15571,'AP','3305753103',1,'2014-01-02 04:31:54',NULL,NULL),(2187,1345,'TE','9723858908',0,'2013-12-25 18:45:06',NULL,NULL),(40210,26670,'TE','3373045107',0,'2014-02-28 21:31:18',NULL,NULL),(41431,27524,'EM','todd.chap54@gmail.com',0,'2014-03-04 21:02:42',NULL,NULL),(42050,27944,'AP','2145073830',0,'2014-03-06 21:00:34',NULL,NULL),(24593,15862,'AP','6014521616',0,'2014-01-03 02:04:49',NULL,NULL),(9263,6061,'EM','1beeman@roadrunner.com',0,'2013-12-26 00:01:57',NULL,NULL),(30818,20036,'AP','7404905493',0,'2014-01-26 19:00:23',NULL,NULL),(30012,19435,'TE','2162095601',1,'2014-01-22 03:23:10',NULL,NULL),(28156,18149,'TE','2254140223',0,'2014-01-15 02:07:49',NULL,NULL),(2307,1410,'EM','sean27483@gmail.com',0,'2013-12-25 18:46:54',NULL,NULL),(26131,16824,'TE','5442203216',0,'2014-01-13 02:18:24',NULL,NULL),(6898,4488,'EM','georgeleyda@aol.com',0,'2013-12-25 22:03:05',NULL,NULL),(41412,27514,'TE','5133099125',0,'2014-03-04 21:02:35',NULL,NULL),(43210,28714,'AP','4193025688',0,'2014-03-08 21:31:17',NULL,NULL),(2534,1551,'TE','6013197663',0,'2013-12-25 18:50:37',NULL,NULL),(25365,16358,'AP','9378381785',0,'2014-01-07 04:02:41',NULL,NULL),(8728,5725,'AP','6622310753',0,'2013-12-25 23:45:32',NULL,NULL),(31558,20571,'AP','5672776096',0,'2014-01-29 21:01:53',NULL,NULL),(28405,18303,'TE','6143160459',0,'2014-01-16 08:44:58',NULL,NULL),(13955,9098,'EM','rkdieter@gmail.com',0,'2013-12-26 04:07:18',NULL,NULL),(24757,15973,'AP','8065442146',0,'2014-01-04 02:00:40',NULL,NULL),(38426,25390,'AP','4403433332',0,'2014-02-25 21:30:52',NULL,NULL),(36597,24094,'EM','cdoerrer@zoominternet.net',0,'2014-02-15 22:01:27',NULL,NULL),(3503,2189,'EM','JHILLIARD2@ROADRUNNER.COM',0,'2013-12-25 19:19:42',NULL,NULL),(8742,5732,'TE','2257564882',0,'2013-12-25 23:45:42',NULL,NULL),(35310,23197,'TE','3309661631',0,'2014-02-12 21:32:06',NULL,NULL),(27140,17476,'AP','4692232306',0,'2014-01-13 03:01:10',NULL,NULL),(39309,26003,'AP','2147341455',0,'2014-02-26 21:02:05',NULL,NULL),(26751,17207,'TE','3307159525',0,'2014-01-13 02:22:27',NULL,NULL),(23280,15000,'TE','9092029806',0,'2014-01-01 12:01:41',NULL,NULL),(10593,6893,'TE','3376550315',0,'2013-12-26 01:45:26',NULL,NULL),(3652,2314,'TE','9799973300',0,'2013-12-25 19:31:16',NULL,NULL),(5222,3356,'TE','9033471001',0,'2013-12-25 21:16:52',NULL,NULL),(5257,3376,'AP','8066641570',0,'2013-12-25 21:17:24',NULL,NULL),(4724,3023,'AP','3307019374',0,'2013-12-25 20:18:13',NULL,NULL),(40037,26538,'EM','letitiawilliams04@gmail.com',0,'2014-02-28 21:30:07',NULL,NULL),(42873,28512,'AP','3306774001',0,'2014-03-07 21:31:55',NULL,NULL),(35740,23505,'TE','5129224299',0,'2014-02-13 22:02:10',NULL,NULL),(11796,7672,'TE','4196186339',0,'2013-12-26 03:00:36',NULL,NULL),(9943,6506,'AP','4194963545',0,'2013-12-26 00:51:00',NULL,NULL),(5880,3772,'AP','8036064401',0,'2013-12-25 21:33:44',NULL,NULL),(33860,22226,'EM','epegan2006@gmail.com',0,'2014-02-09 19:00:29',NULL,NULL),(29314,18943,'TE','9035002002',0,'2014-01-20 08:05:44',NULL,NULL),(1880,1161,'TE','3185371733',0,'2013-12-25 18:18:53',NULL,NULL),(26955,17336,'TE','2026797005',0,'2014-01-13 02:23:59',NULL,NULL),(37309,24551,'TE','3307922762',0,'2014-02-20 04:04:28',NULL,NULL),(39802,26319,'AP','9376314981',0,'2014-02-28 06:31:36',NULL,NULL),(40713,27053,'EM','milous56@yahoo.com',0,'2014-03-03 21:00:26',NULL,NULL),(40963,27219,'TE','6016221460',0,'2014-03-03 21:31:33',NULL,NULL),(42373,28141,'TE','4195099554',0,'2014-03-06 21:02:31',NULL,NULL),(42867,28509,'TE','3308967665',0,'2014-03-07 21:31:53',NULL,NULL),(28218,18191,'TE','4407851715',0,'2014-01-15 02:08:04',NULL,NULL),(11561,7523,'AP','9377792517',0,'2013-12-26 02:32:28',NULL,NULL),(39299,25999,'TE','3184333666',0,'2014-02-26 21:02:02',NULL,NULL),(41219,27379,'TE','6019694083',0,'2014-03-04 21:01:20',NULL,NULL),(43263,28744,'EM','hampton_carolyn@ymail.com',0,'2014-03-09 21:00:12',NULL,NULL),(43843,29097,'BN','5133043805',0,'2014-03-10 21:02:14',NULL,NULL),(496,315,'TE','9858635980',0,'2013-12-25 17:31:09',NULL,NULL),(2443,1498,'TE','5132844030',0,'2013-12-25 18:49:13',NULL,NULL),(10411,6786,'EM','beaglefever@hotmail.com',0,'2013-12-26 01:16:59',NULL,NULL),(36855,24268,'EM','djfrancis05@yahoo.com',0,'2014-02-17 19:00:16',NULL,NULL),(1360,829,'EM','bikermaximus@yahoo.com',0,'2013-12-25 18:06:19',NULL,NULL),(35726,23495,'AP','5416027496',0,'2014-02-13 22:02:05',NULL,NULL),(35251,23151,'AP','5137025903',0,'2014-02-12 21:31:42',NULL,NULL),(5458,3494,'TE','9374733785',0,'2013-12-25 21:20:31',NULL,NULL),(22559,14549,'EM','DOWE.DAKOTA@YAHOO.COM',0,'2013-12-28 03:34:59',NULL,NULL),(35148,23081,'EM','kkossick@me.com',0,'2014-02-12 21:31:03',NULL,NULL),(24060,15534,'AP','3184394715',1,'2014-01-02 04:30:45',NULL,NULL),(27889,17971,'TE','3306788383',0,'2014-01-15 02:06:49',NULL,NULL),(39856,26364,'BN','3303545829',0,'2014-02-28 07:00:07',NULL,NULL),(40114,26602,'EM','carter.h500@gmail.com',0,'2014-02-28 21:30:42',NULL,NULL),(41574,27641,'AP','9372696309',0,'2014-03-05 21:30:16',NULL,NULL),(913,563,'TE','4194554836',0,'2013-12-25 17:50:24',NULL,NULL),(35622,23424,'TE','9566396202',0,'2014-02-13 22:01:24',NULL,NULL),(2136,1318,'AP','2165771692',0,'2013-12-25 18:31:37',NULL,NULL),(39336,26020,'EM','Jlt2980@yahoo.com',0,'2014-02-26 21:02:15',NULL,NULL),(24894,16048,'AP','2146161531',0,'2014-01-04 02:03:07',NULL,NULL),(33266,21782,'EM','loomiswilliam@yahoo.com',0,'2014-02-06 21:00:39',NULL,NULL),(21485,13805,'AP','4197093143',0,'2013-12-26 13:11:29',NULL,NULL),(828,514,'AP','5133173474',0,'2013-12-25 17:49:02',NULL,NULL),(20535,13216,'EM','maumic@sbcglobal.net',0,'2013-12-26 12:55:24',NULL,NULL),(43979,29175,'AP','2165093092',0,'2014-03-10 21:03:01',NULL,NULL),(25569,16496,'TE','7403045261',0,'2014-01-07 04:06:39',NULL,NULL),(8014,5230,'EM','rkress@aol.com',0,'2013-12-25 23:04:47',NULL,NULL),(30212,19571,'EM','rtcaston@yahoo.com',0,'2014-01-23 03:02:37',NULL,NULL),(41153,27333,'EM','ssantana44112@gmail.com',0,'2014-03-04 21:00:54',NULL,NULL),(35157,23091,'AP','4403878293',0,'2014-02-12 21:31:07',NULL,NULL),(34768,22805,'TE','3038189875',0,'2014-02-11 21:01:54',NULL,NULL),(34118,22371,'TE','9729041696',0,'2014-02-10 21:00:13',NULL,NULL),(20957,13483,'EM','billschillingmusic@gmail.com',0,'2013-12-26 13:02:16',NULL,NULL),(28265,18225,'EM','eric.brannigan@ttu.edu',0,'2014-01-16 08:44:16',NULL,NULL),(43488,28879,'TE','9032793680',0,'2014-03-10 21:00:07',NULL,NULL),(255,156,'TE','8067623542',0,'2013-12-25 17:19:03',NULL,NULL),(1762,1086,'AP','4408583641',0,'2013-12-25 18:16:55',NULL,NULL),(32288,21091,'TE','3185184030',0,'2014-02-02 19:00:28',NULL,NULL),(12191,7967,'AP','6157130126',0,'2013-12-26 03:07:35',NULL,NULL),(31595,20611,'TE','6148938908',0,'2014-01-30 21:00:18',NULL,NULL),(28915,18666,'AP','9165886712',0,'2014-01-17 03:35:15',NULL,NULL),(25460,16416,'EM','angelmom2005@sbcglobal.net',0,'2014-01-07 04:04:24',NULL,NULL),(10650,6924,'AP','9372061498',0,'2013-12-26 01:46:19',NULL,NULL),(34383,22552,'AP','8034135585',0,'2014-02-10 21:31:46',NULL,NULL),(28194,18171,'EM','bk0502@gmail.com',0,'2014-01-15 02:07:58',NULL,NULL),(12284,8035,'TE','4198891268',0,'2013-12-26 03:09:16',NULL,NULL),(6504,4204,'AP','4322940524',0,'2013-12-25 21:50:00',NULL,NULL),(41813,27798,'AP','3308070588',0,'2014-03-05 21:31:44',NULL,NULL),(42702,28405,'TE','4195650818',0,'2014-03-07 21:30:53',NULL,NULL),(534,334,'AP','9372386677',0,'2013-12-25 17:31:46',NULL,NULL),(10142,6627,'EM','adonahue2008@live.com',0,'2013-12-26 00:54:15',NULL,NULL),(36271,23878,'EM','marilyncrowe@yahoo.com',0,'2014-02-14 21:32:13',NULL,NULL),(29511,19078,'EM','rbullard61@yahoo.com',0,'2014-01-21 08:44:24',NULL,NULL),(26251,16895,'TE','9376380844',0,'2014-01-13 02:19:30',NULL,NULL),(4669,2987,'TE','6069226831',0,'2013-12-25 20:17:20',NULL,NULL),(22100,14234,'TE','6626172231',0,'2013-12-27 02:05:06',NULL,NULL),(39544,26160,'EM','ronnie.flannigan@gmail.com',0,'2014-02-28 06:30:32',NULL,NULL),(40899,27176,'AP','8304210744',0,'2014-03-03 21:31:07',NULL,NULL),(34728,22772,'TE','9373041534',0,'2014-02-11 21:01:38',NULL,NULL),(32653,21356,'AP','2542399133',0,'2014-02-04 21:00:40',NULL,NULL),(2461,1510,'TE','7408819708',0,'2013-12-25 18:49:30',NULL,NULL),(31569,20586,'EM','jonparnell@outlook.com',0,'2014-01-30 21:00:06',NULL,NULL),(12256,8012,'TE','5136331088',0,'2013-12-26 03:08:42',NULL,NULL),(3602,2271,'TE','9373744790',0,'2013-12-25 19:30:23',NULL,NULL),(6538,4228,'TE','2148812664',0,'2013-12-25 21:50:37',NULL,NULL),(13535,8826,'EM','armantorshizi@gmail.com',0,'2013-12-26 04:00:25',NULL,NULL),(3885,2469,'AP','3185724300',0,'2013-12-25 19:35:10',NULL,NULL),(25732,16584,'AP','5043408880',0,'2014-01-08 18:23:58',NULL,NULL),(38203,25217,'AP','2166506915',0,'2014-02-21 22:00:54',NULL,NULL),(29242,18889,'TE','3398231684',0,'2014-01-17 03:36:31',NULL,NULL),(6123,3941,'TE','4198934498',0,'2013-12-25 21:37:56',NULL,NULL),(13782,8982,'TE','5137069339',0,'2013-12-26 04:04:22',NULL,NULL),(7284,4746,'TE','2147918457',0,'2013-12-25 22:15:03',NULL,NULL),(33764,22157,'TE','5136770590',0,'2014-02-08 19:00:56',NULL,NULL),(26011,16756,'TE','4193828541',0,'2014-01-08 18:24:57',NULL,NULL),(31840,20786,'AP','9039322834',0,'2014-01-31 21:00:13',NULL,NULL),(9596,6284,'TE','5132452595',0,'2013-12-26 00:45:26',NULL,NULL),(30652,19896,'TE','9852100420',0,'2014-01-24 21:00:54',NULL,NULL),(27880,17966,'TE','3309459502',0,'2014-01-15 02:06:48',NULL,NULL),(14228,9310,'TE','5042321355',0,'2013-12-26 04:30:14',NULL,NULL),(37778,24932,'AP','3307150439',0,'2014-02-20 21:30:20',NULL,NULL),(41931,27876,'EM','rkiessling2@roadrunner.com',0,'2014-03-05 21:32:29',NULL,NULL),(43394,28819,'EM','andrewdconnors@gmail.com',0,'2014-03-09 21:00:58',NULL,NULL),(31523,20542,'TE','4198654226',0,'2014-01-29 21:01:36',NULL,NULL),(1089,671,'TE','9375649179',0,'2013-12-25 18:02:07',NULL,NULL),(40198,26664,'AP','9856626670',0,'2014-02-28 21:31:14',NULL,NULL),(41527,27612,'TE','2259387326',0,'2014-03-05 21:00:29',NULL,NULL),(37570,24753,'AP','3304729927',0,'2014-02-20 04:41:32',NULL,NULL),(23578,15221,'AP','2255058109',0,'2014-01-01 12:08:02',NULL,NULL),(23313,15023,'TE','7185640095',0,'2014-01-01 12:02:22',NULL,NULL),(26378,16979,'TE','6013319421',0,'2014-01-13 02:20:17',NULL,NULL),(41787,27781,'TE','3302819401',0,'2014-03-05 21:31:34',NULL,NULL),(34559,22664,'AP','9722016039',0,'2014-02-11 21:00:37',NULL,NULL),(25757,16597,'EM','yajd23@gmail.com',0,'2014-01-08 18:24:03',NULL,NULL),(30488,19776,'TE','4196618821',0,'2014-01-23 21:01:31',NULL,NULL),(11329,7378,'EM','sharlene22a@gmail.com',0,'2013-12-26 02:15:53',NULL,NULL),(10090,6593,'AP','5126367274',0,'2013-12-26 00:53:19',NULL,NULL),(38323,25319,'TE','2257183965',0,'2014-02-25 21:30:07',NULL,NULL),(40620,26963,'EM','ray@raysohrabi.com',0,'2014-03-03 01:00:31',NULL,NULL),(40847,27142,'EM','alewis304@gmail.com',0,'2014-03-03 21:30:47',NULL,NULL),(41235,27387,'AP','6019543728',0,'2014-03-04 21:01:25',NULL,NULL),(33219,21754,'TE','2145580189',0,'2014-02-06 21:00:22',NULL,NULL),(6785,4400,'EM','bollingerstephanie@hotmail.com',0,'2013-12-25 22:01:09',NULL,NULL),(24117,15568,'EM','terrieshaheen@yahoo.com',1,'2014-01-02 04:31:49',NULL,NULL),(24068,15539,'TE','5044540059',1,'2014-01-02 04:30:54',NULL,NULL),(29886,19339,'EM','pampowellmasters@aim.com',1,'2014-01-22 03:22:20',NULL,NULL),(20195,13010,'EM','aelbeyli@gmail.com',0,'2013-12-26 12:49:47',NULL,NULL),(6222,4012,'TE','5132260327',0,'2013-12-25 21:45:27',NULL,NULL),(10978,7133,'TE','6626341449',0,'2013-12-26 01:51:41',NULL,NULL),(6089,3920,'TE','5672793627',0,'2013-12-25 21:37:21',NULL,NULL),(3557,2227,'TE','4194922808',0,'2013-12-25 19:20:42',NULL,NULL),(5847,3753,'TE','9037398663',0,'2013-12-25 21:33:13',NULL,NULL),(5561,3553,'TE','2162801622',0,'2013-12-25 21:22:06',NULL,NULL),(36339,23933,'TE','6148731696',0,'2014-02-15 21:00:05',NULL,NULL),(25672,16551,'TE','9376630352',1,'2014-01-07 10:22:44',NULL,NULL),(25257,16285,'EM','tweekacloud@yahoo.com',0,'2014-01-07 04:00:41',NULL,NULL),(24668,15906,'AP','4192031518',0,'2014-01-03 02:06:14',NULL,NULL),(3540,2216,'AP','7202716650',0,'2013-12-25 19:20:25',NULL,NULL),(10584,6887,'TE','9858984973',0,'2013-12-26 01:45:16',NULL,NULL),(12029,7845,'TE','2162335780',0,'2013-12-26 03:04:42',NULL,NULL),(20923,13453,'TE','9374744557',0,'2013-12-26 13:01:34',NULL,NULL),(38716,25591,'TE','9853817079',0,'2014-02-26 08:00:43',NULL,NULL),(40665,26998,'TE','6149482085',0,'2014-03-03 21:00:00',NULL,NULL),(359,221,'TE','2255679232',0,'2013-12-25 17:20:47',NULL,NULL),(28313,18249,'EM','huqakm@yahoo.com',0,'2014-01-16 08:44:30',NULL,NULL),(8347,5480,'EM','marmov13@aol.com',0,'2013-12-25 23:10:49',NULL,NULL),(7377,4801,'TE','2253810047',0,'2013-12-25 22:16:31',NULL,NULL),(20764,13342,'EM','ladylindak0@gmail.com',0,'2013-12-26 12:58:58',NULL,NULL),(27890,17971,'EM','sm14086@gmail.com',0,'2014-01-15 02:06:49',NULL,NULL),(6472,4187,'TE','3306993280',0,'2013-12-25 21:49:33',NULL,NULL),(1743,1072,'TE','3304824758',0,'2013-12-25 18:16:33',NULL,NULL),(38742,25611,'AP','8323859412',0,'2014-02-26 08:30:09',NULL,NULL),(39704,26256,'TE','9569074710',0,'2014-02-28 06:31:10',NULL,NULL),(30337,19656,'EM','jthomas407@gmail.com',0,'2014-01-23 21:00:22',NULL,NULL),(4719,3021,'TE','4405771906',0,'2013-12-25 20:18:09',NULL,NULL),(6003,3856,'TE','3184253648',0,'2013-12-25 21:35:47',NULL,NULL),(25037,16133,'EM','john@millikinsulating.com',0,'2014-01-04 02:05:47',NULL,NULL),(38753,25619,'AP','2108007539',0,'2014-02-26 08:30:15',NULL,NULL),(38964,25761,'EM','DPHILLIPS10@NEO.RR.COM',0,'2014-02-26 09:30:52',NULL,NULL),(42930,28545,'EM','abragg817@gmail.com',0,'2014-03-07 21:32:17',NULL,NULL),(1497,920,'AP','9374021002',0,'2013-12-25 18:08:48',NULL,NULL),(23543,15194,'AP','6012642044',0,'2014-01-01 12:07:13',NULL,NULL),(31294,20390,'AP','4322509083',0,'2014-01-29 21:00:15',NULL,NULL),(5470,3501,'EM','successwithgreg@yahoo.com',0,'2013-12-25 21:20:43',NULL,NULL),(7967,5197,'AP','9376051025',0,'2013-12-25 23:03:56',NULL,NULL),(5897,3782,'TE','4195565043',0,'2013-12-25 21:34:01',NULL,NULL),(4838,3097,'AP','2163968318',0,'2013-12-25 20:20:09',NULL,NULL),(39800,26314,'TE','5138435206',0,'2014-02-28 06:31:34',NULL,NULL),(42280,28078,'AP','8327464734',0,'2014-03-06 21:01:56',NULL,NULL),(33498,21953,'EM','htn89@yahoo.com',0,'2014-02-07 19:00:22',NULL,NULL),(24035,15518,'TE','3187171642',1,'2014-01-02 04:30:15',NULL,NULL),(28308,18247,'TE','9562238285',0,'2014-01-16 08:44:28',NULL,NULL),(22656,14608,'AP','4199730760',0,'2013-12-28 03:36:35',NULL,NULL),(5424,3471,'TE','5132374722',0,'2013-12-25 21:19:59',NULL,NULL),(5113,3277,'AP','5132000026',0,'2013-12-25 21:15:09',NULL,NULL),(21398,13758,'EM','bennettyolanda2002@yahoo.com',0,'2013-12-26 13:10:09',NULL,NULL),(6162,3971,'TE','9372188423',0,'2013-12-25 21:38:35',NULL,NULL),(1099,674,'AP','5136078358',0,'2013-12-25 18:02:14',NULL,NULL),(39731,26277,'TE','2258695632',0,'2014-02-28 06:31:19',NULL,NULL),(39829,26343,'AP','4192704704',0,'2014-02-28 06:31:44',NULL,NULL),(42710,28408,'TE','7402824892',0,'2014-03-07 21:30:55',NULL,NULL),(8908,5831,'TE','2108616627',0,'2013-12-25 23:48:18',NULL,NULL),(25415,16393,'AP','9568020225',0,'2014-01-07 04:03:38',NULL,NULL),(37922,25019,'TE','4404773222',0,'2014-02-20 22:00:56',NULL,NULL),(35943,23648,'AP','8068935935',0,'2014-02-14 21:30:13',NULL,NULL),(2623,1595,'TE','9035192651',0,'2013-12-25 18:51:53',NULL,NULL),(2909,1785,'TE','4409410530',0,'2013-12-25 18:56:26',NULL,NULL),(4163,2655,'AP','6148040490',0,'2013-12-25 19:46:44',NULL,NULL),(3686,2338,'EM','sethbnewell@gmail.com',0,'2013-12-25 19:31:53',NULL,NULL),(9693,6349,'AP','2165758065',0,'2013-12-26 00:47:00',NULL,NULL),(3717,2357,'TE','4193410013',0,'2013-12-25 19:32:25',NULL,NULL),(39380,26045,'TE','3306038346',0,'2014-02-26 21:02:29',NULL,NULL),(40291,26728,'TE','5136583530',0,'2014-02-28 21:31:47',NULL,NULL),(41331,27456,'TE','3309030870',0,'2014-03-04 21:02:03',NULL,NULL),(42129,27986,'TE','9853870194',0,'2014-03-06 21:01:00',NULL,NULL),(1562,962,'AP','9407049647',0,'2013-12-25 18:09:49',NULL,NULL),(4392,2798,'AP','3305595203',0,'2013-12-25 19:50:21',NULL,NULL),(7137,4655,'AP','5043774205',0,'2013-12-25 22:07:14',NULL,NULL),(21484,13805,'TE','4192279886',0,'2013-12-26 13:11:28',NULL,NULL),(4394,2799,'TE','3305595203',0,'2013-12-25 19:50:22',NULL,NULL),(4876,3122,'TE','3304160948',0,'2013-12-25 20:30:19',NULL,NULL),(26655,17147,'AP','2252358147',0,'2014-01-13 02:21:55',NULL,NULL),(32215,21039,'AP','5133027992',0,'2014-02-01 19:00:49',NULL,NULL),(26693,17169,'EM','pturbett@aol.com',0,'2014-01-13 02:22:07',NULL,NULL),(34458,22610,'TE','5127058219',0,'2014-02-11 21:00:04',NULL,NULL),(27513,17725,'TE','5134850468',0,'2014-01-14 01:33:16',NULL,NULL),(37452,24661,'TE','4192797137',0,'2014-02-20 04:25:25',NULL,NULL),(34866,22866,'TE','6013838316',0,'2014-02-11 21:02:28',NULL,NULL),(34592,22680,'AP','9035061624',0,'2014-02-11 21:00:47',NULL,NULL),(33884,22238,'AP','7407043147',0,'2014-02-09 19:00:37',NULL,NULL),(12103,7910,'AP','5044783056',0,'2013-12-26 03:06:03',NULL,NULL),(5148,3301,'TE','3306356686',0,'2013-12-25 21:15:42',NULL,NULL),(10138,6626,'TE','4193203254',0,'2013-12-26 00:54:12',NULL,NULL),(5917,3795,'EM','higs.higgins@sbcglobal.net',0,'2013-12-25 21:34:21',NULL,NULL),(31661,20656,'AP','8179027212',0,'2014-01-30 21:00:41',NULL,NULL),(3891,2472,'TE','3374567840',0,'2013-12-25 19:35:16',NULL,NULL),(150,89,'EM','eugenefranklin@aol.com',0,'2013-12-25 17:17:23',NULL,NULL),(37974,25053,'AP','4192961783',0,'2014-02-20 22:01:18',NULL,NULL),(3933,2495,'TE','5042526546',0,'2013-12-25 19:35:54',NULL,NULL),(6774,4395,'TE','4402220226',0,'2013-12-25 22:01:00',NULL,NULL),(36255,23859,'TE','9852553218',0,'2014-02-14 21:32:03',NULL,NULL),(35071,23031,'TE','2814454895',0,'2014-02-12 21:30:35',NULL,NULL),(30421,19718,'AP','4195726741',0,'2014-01-23 21:00:57',NULL,NULL),(29070,18772,'EM','mr1juanlopez@msn.com',0,'2014-01-17 03:35:50',NULL,NULL),(41494,27583,'AP','8067312355',0,'2014-03-05 21:00:13',NULL,NULL),(38557,25478,'TE','4194767427',0,'2014-02-25 21:31:42',NULL,NULL),(29504,19074,'TE','4193088509',0,'2014-01-21 08:44:22',NULL,NULL),(33526,21979,'TE','3182670729',0,'2014-02-07 19:00:35',NULL,NULL),(1647,1011,'EM','timtrz2@gmail.com',0,'2013-12-25 18:11:16',NULL,NULL),(26717,17185,'AP','8328132157',0,'2014-01-13 02:22:15',NULL,NULL),(14087,9212,'TE','6016700179',0,'2013-12-26 04:09:56',NULL,NULL),(3061,1903,'AP','9376385707',0,'2013-12-25 18:59:12',NULL,NULL),(9070,5947,'TE','8597538555',0,'2013-12-25 23:51:00',NULL,NULL),(2692,1635,'AP','9035398662',0,'2013-12-25 18:52:56',NULL,NULL),(8082,5290,'AP','3307037294',0,'2013-12-25 23:06:01',NULL,NULL),(22328,14393,'TE','6147991570',0,'2013-12-28 03:31:04',NULL,NULL),(700,434,'TE','4402511026',0,'2013-12-25 17:47:01',NULL,NULL),(4310,2750,'AP','5132059757',0,'2013-12-25 19:49:04',NULL,NULL),(25306,16319,'TE','2253248672',0,'2014-01-07 04:01:39',NULL,NULL),(22911,14785,'AP','3308812064',1,'2013-12-29 11:13:19',NULL,NULL),(14604,9548,'AP','9372140406',0,'2013-12-26 04:36:13',NULL,NULL),(33465,21925,'TE','8175592485',0,'2014-02-07 19:00:08',NULL,NULL),(39389,26048,'TE','3306862770',0,'2014-02-26 21:02:31',NULL,NULL),(10412,6790,'EM','lateifab@yahoo.com',0,'2013-12-26 01:17:03',NULL,NULL),(22550,14545,'TE','6015635184',0,'2013-12-28 03:34:52',NULL,NULL),(24439,15777,'TE','9792038985',0,'2014-01-03 02:02:01',NULL,NULL),(3889,2471,'AP','2253624164',0,'2013-12-25 19:35:14',NULL,NULL),(41108,27308,'TE','9563125198',0,'2014-03-04 21:00:37',NULL,NULL),(42388,28152,'EM','puppikatt@aol.com',0,'2014-03-06 21:02:38',NULL,NULL),(652,406,'EM','mrtankovich@earthlink.net',0,'2013-12-25 17:46:17',NULL,NULL),(32723,21406,'TE','2162442389',0,'2014-02-04 21:01:05',NULL,NULL),(21770,14027,'AP','5133103218',0,'2013-12-26 13:16:46',NULL,NULL),(20928,13456,'EM','lukefeerer@yahoo.com',0,'2013-12-26 13:01:39',NULL,NULL),(20353,13111,'TE','5137023752',0,'2013-12-26 12:52:28',NULL,NULL),(2144,1321,'EM','Koolkeiths@gmail.com',0,'2013-12-25 18:31:45',NULL,NULL),(909,561,'EM','JHILLIARD2@ROADRUNNER.COM',0,'2013-12-25 17:50:20',NULL,NULL),(706,438,'AP','6142967035',0,'2013-12-25 17:47:06',NULL,NULL),(3830,2437,'AP','2162990744',0,'2013-12-25 19:34:20',NULL,NULL),(3709,2352,'TE','9362544746',0,'2013-12-25 19:32:16',NULL,NULL),(28873,18643,'AP','5125679389',0,'2014-01-17 03:35:07',NULL,NULL),(4725,3023,'EM','TBOSNYAK01@GMAIL.COM',0,'2013-12-25 20:18:14',NULL,NULL),(36498,24029,'EM','jsiek86@gmail.com',0,'2014-02-15 22:00:52',NULL,NULL),(37997,25066,'AP','2162786459',0,'2014-02-20 22:01:27',NULL,NULL),(4955,3180,'TE','4409335397',0,'2013-12-25 20:31:49',NULL,NULL),(42960,28569,'AP','4194388188',0,'2014-03-07 21:32:30',NULL,NULL),(6822,4428,'TE','5133645102',0,'2013-12-25 22:01:48',NULL,NULL),(1333,816,'TE','3304147594',0,'2013-12-25 18:05:56',NULL,NULL),(25809,16632,'EM','cittybarb@yahoo.com',0,'2014-01-08 18:24:15',NULL,NULL),(25369,16360,'TE','5302499422',0,'2014-01-07 04:02:44',NULL,NULL),(397,243,'AP','9377601391',0,'2013-12-25 17:21:23',NULL,NULL),(22129,14253,'EM','Nikitawcastle@ymail.com',0,'2013-12-27 02:05:35',NULL,NULL),(34203,22430,'AP','2149309327',0,'2014-02-10 21:30:36',NULL,NULL),(1498,921,'TE','4195777888',0,'2013-12-25 18:08:49',NULL,NULL),(35091,23050,'TE','8178964560',0,'2014-02-12 21:30:45',NULL,NULL),(28431,18317,'EM','frzhang2012@163.com',0,'2014-01-16 08:45:05',NULL,NULL),(35814,23550,'TE','3376542997',0,'2014-02-13 22:02:38',NULL,NULL),(28902,18659,'TE','8177090750',0,'2014-01-17 03:35:13',NULL,NULL),(30975,20148,'EM','dbarl01@yahoo.com',0,'2014-01-27 21:01:02',NULL,NULL),(39497,26125,'TE','9372243300',0,'2014-02-28 06:30:21',NULL,NULL),(43487,28877,'AP','9565909197',0,'2014-03-10 21:00:06',NULL,NULL),(12232,7995,'EM','lorilitvin@yahoo.com',0,'2013-12-26 03:08:15',NULL,NULL),(26772,17223,'EM','pammesaros@gmail.com',0,'2014-01-13 02:22:35',NULL,NULL),(38452,25409,'EM','JSTRINE51@GMAIL.COM',0,'2014-02-25 21:31:02',NULL,NULL),(9492,6210,'AP','9727461748',0,'2013-12-26 00:30:52',NULL,NULL),(1832,1134,'TE','4106032905',0,'2013-12-25 18:18:09',NULL,NULL),(13907,9067,'TE','5129199061',0,'2013-12-26 04:06:31',NULL,NULL),(26148,16834,'TE','3304143055',0,'2014-01-13 02:18:30',NULL,NULL),(5856,3758,'TE','3306668252',0,'2013-12-25 21:33:21',NULL,NULL),(33023,21635,'TE','3617283411',0,'2014-02-05 21:30:43',NULL,NULL),(5252,3372,'AP','2149911427',0,'2013-12-25 21:17:18',NULL,NULL),(6157,3965,'AP','2165541076',0,'2013-12-25 21:38:29',NULL,NULL),(37168,24465,'AP','3305924347',0,'2014-02-18 22:01:36',NULL,NULL),(6856,4447,'TE','6149479475',0,'2013-12-25 22:02:18',NULL,NULL),(40344,26776,'TE','9033436836',0,'2014-03-01 21:00:10',NULL,NULL),(41946,27884,'AP','4193044236',0,'2014-03-05 21:32:35',NULL,NULL),(1928,1193,'EM','tonya_fore@yahoo.com',0,'2013-12-25 18:19:41',NULL,NULL),(9648,6312,'AP','4198893730',0,'2013-12-26 00:46:13',NULL,NULL),(38674,25562,'AP','2143649092',0,'2014-02-26 08:00:24',NULL,NULL),(28293,18238,'TE','8063192918',0,'2014-01-16 08:44:24',NULL,NULL),(7992,5215,'AP','5135022831',0,'2013-12-25 23:04:24',NULL,NULL),(25101,16183,'TE','9152493253',0,'2014-01-05 00:00:35',NULL,NULL),(41429,27524,'TE','3308816700',0,'2014-03-04 21:02:42',NULL,NULL),(42417,28170,'TE','5133176951',0,'2014-03-06 21:02:48',NULL,NULL),(4110,2622,'TE','2163754944',0,'2013-12-25 19:45:54',NULL,NULL),(35399,23266,'TE','5136738802',0,'2014-02-13 21:30:12',NULL,NULL),(32495,21235,'TE','6142564466',0,'2014-02-03 21:01:11',NULL,NULL),(28697,18518,'EM','daniel.sterling@utdallas.edu',0,'2014-01-16 08:46:37',NULL,NULL),(11241,7318,'TE','2143155378',0,'2013-12-26 02:03:32',NULL,NULL),(10400,6779,'AP','3304123123',0,'2013-12-26 01:16:48',NULL,NULL),(5383,3445,'TE','5133742380',0,'2013-12-25 21:19:21',NULL,NULL),(25015,16119,'EM','EJKCHEFN4U1@AOL.COM',0,'2014-01-04 02:05:22',NULL,NULL),(25068,16159,'EM','Misskapor@aol.com',0,'2014-01-04 06:00:10',NULL,NULL),(11946,7782,'TE','2103961777',0,'2013-12-26 03:03:12',NULL,NULL),(35069,23030,'AP','7139924779',0,'2014-02-12 21:30:34',NULL,NULL),(30323,19643,'TE','3308743252',0,'2014-01-23 21:00:16',NULL,NULL),(28569,18419,'TE','5042364824',0,'2014-01-16 08:45:51',NULL,NULL),(294,182,'TE','3307603196',0,'2013-12-25 17:19:42',NULL,NULL),(5746,3683,'AP','4404657718',0,'2013-12-25 21:31:31',NULL,NULL),(6021,3864,'EM','peacemaker19@charter.net',0,'2013-12-25 21:36:03',NULL,NULL),(7747,5059,'TE','3256511231',0,'2013-12-25 23:00:23',NULL,NULL),(14179,9276,'AP','9373075491',0,'2013-12-26 04:15:48',NULL,NULL),(35941,23647,'EM','rodriguezb417@gmail.com',0,'2014-02-14 21:30:12',NULL,NULL),(27110,17439,'TE','4194387621',0,'2014-01-13 03:00:35',NULL,NULL),(38065,25127,'TE','2253159713',0,'2014-02-21 21:30:24',NULL,NULL),(41833,27814,'TE','3302172798',0,'2014-03-05 21:31:52',NULL,NULL),(43224,28722,'AP','4193068518',0,'2014-03-08 21:31:22',NULL,NULL),(31942,20850,'AP','4406679232',0,'2014-01-31 21:00:52',NULL,NULL),(4001,2544,'TE','3307233226',0,'2013-12-25 19:37:06',NULL,NULL),(5652,3628,'TE','9373642515',0,'2013-12-25 21:30:03',NULL,NULL),(8268,5413,'EM','vontzshannon@yahoo.com',0,'2013-12-25 23:09:12',NULL,NULL),(11065,7187,'AP','6143543021',0,'2013-12-26 02:00:20',NULL,NULL),(39808,26326,'EM','smorton6@comcast.net',0,'2014-02-28 06:31:38',NULL,NULL),(2738,1661,'TE','9033712751',0,'2013-12-25 18:53:37',NULL,NULL),(27775,17906,'AP','2102043219',0,'2014-01-15 02:06:25',NULL,NULL),(37283,24535,'TE','9563400398',0,'2014-02-20 04:01:16',NULL,NULL),(37944,25038,'TE','4197492600',0,'2014-02-20 22:01:08',NULL,NULL),(40287,26722,'AP','6019401098',0,'2014-02-28 21:31:45',NULL,NULL),(40386,26806,'EM','TISHOMES123@GMAIL.COM',0,'2014-03-01 21:00:26',NULL,NULL),(29731,19226,'TE','4195089080',0,'2014-01-21 08:46:29',NULL,NULL),(28952,18688,'EM','jaycebuttram@yahoo.com',0,'2014-01-17 03:35:23',NULL,NULL),(26872,17291,'AP','3617797652',0,'2014-01-13 02:23:33',NULL,NULL),(23669,15283,'TE','6019577477',1,'2014-01-02 04:22:13',NULL,NULL),(8066,5282,'AP','3302891701',0,'2013-12-25 23:05:48',NULL,NULL),(42187,28024,'AP','4405419478',0,'2014-03-06 21:01:23',NULL,NULL),(366,224,'AP','2253482048',0,'2013-12-25 17:20:52',NULL,NULL),(22602,14576,'TE','2254445977',0,'2013-12-28 03:35:42',NULL,NULL),(31024,20183,'AP','2163741086',0,'2014-01-27 21:01:22',NULL,NULL),(30473,19760,'TE','2162541263',0,'2014-01-23 21:01:23',NULL,NULL),(14588,9537,'AP','8124304464',0,'2013-12-26 04:35:57',NULL,NULL),(22701,14641,'EM','texasgirl419@gmail.com',1,'2013-12-29 11:07:27',NULL,NULL),(14250,9323,'TE','8319176893',0,'2013-12-26 04:30:32',NULL,NULL),(2664,1617,'TE','4329430103',0,'2013-12-25 18:52:30',NULL,NULL),(23889,15413,'EM','tyian22@yahoo.com',1,'2014-01-02 04:27:12',NULL,NULL),(6577,4246,'TE','7135405165',0,'2013-12-25 21:51:09',NULL,NULL),(38828,25667,'AP','6623868880',0,'2014-02-26 08:30:49',NULL,NULL),(39843,26353,'EM','tech@knowtheatre.com',0,'2014-02-28 06:31:48',NULL,NULL),(42160,28007,'AP','6146782073',0,'2014-03-06 21:01:13',NULL,NULL),(43928,29142,'TE','4196997558',0,'2014-03-10 21:02:43',NULL,NULL),(35123,23069,'AP','2252745021',0,'2014-02-12 21:30:56',NULL,NULL),(30168,19545,'BN','6628325978',0,'2014-01-23 03:02:26',NULL,NULL),(14143,9260,'TE','5042509049',0,'2013-12-26 04:15:18',NULL,NULL),(24466,15791,'AP','2253419061',0,'2014-01-03 02:02:30',NULL,NULL),(5928,3801,'EM','DARLENEDICKERSON2258@YAHOO.COM',0,'2013-12-25 21:34:32',NULL,NULL),(3572,2238,'TE','4403225163',0,'2013-12-25 19:20:56',NULL,NULL),(4636,2959,'TE','3256583037',0,'2013-12-25 20:16:43',NULL,NULL),(39190,25921,'EM','oilboom2003@gmail.com',0,'2014-02-26 21:01:20',NULL,NULL),(34981,22966,'TE','4199624015',0,'2014-02-12 21:00:13',NULL,NULL),(8560,5623,'AP','6143841576',0,'2013-12-25 23:30:51',NULL,NULL),(6846,4442,'EM','amblakeoh@adelphia.net',0,'2013-12-25 22:02:10',NULL,NULL),(7512,4896,'TE','3302128470',0,'2013-12-25 22:31:40',NULL,NULL),(9246,6050,'AP','6146254605',0,'2013-12-26 00:01:40',NULL,NULL),(10919,7097,'EM','wrightpackaging@att.net',0,'2013-12-26 01:50:41',NULL,NULL),(33630,22051,'TE','9158568876',0,'2014-02-08 19:00:05',NULL,NULL),(31820,20774,'EM','Haileymaleik6@aol.com',0,'2014-01-31 21:00:06',NULL,NULL),(40747,27079,'EM','alankarendan@gmail.com',0,'2014-03-03 21:30:10',NULL,NULL),(14597,9544,'TE','4402579412',0,'2013-12-26 04:36:06',NULL,NULL),(35918,23635,'TE','9523039147',0,'2014-02-14 21:30:05',NULL,NULL),(7826,5107,'EM','cerodriguez3@yahoo.com',0,'2013-12-25 23:01:37',NULL,NULL),(5401,3455,'AP','6142046360',0,'2013-12-25 21:19:38',NULL,NULL),(31238,20344,'TE','3302391102',0,'2014-01-28 21:01:10',NULL,NULL),(37693,24850,'AP','5132253858',0,'2014-02-20 04:55:27',NULL,NULL),(3339,2101,'AP','4197044473',0,'2013-12-25 19:17:10',NULL,NULL),(30112,19505,'EM','iovanivillegas@yahoo.com',0,'2014-01-23 03:02:12',NULL,NULL),(27199,17515,'TE','3304416466',0,'2014-01-13 03:01:33',NULL,NULL),(11739,7641,'TE','4409513930',0,'2013-12-26 02:46:36',NULL,NULL),(23920,15434,'TE','3615711051',1,'2014-01-02 04:27:50',NULL,NULL),(4794,3066,'EM','paul@cincybasements.com',0,'2013-12-25 20:19:20',NULL,NULL),(9477,6203,'TE','3303412624',0,'2013-12-26 00:30:40',NULL,NULL),(9402,6153,'TE','8325882229',0,'2013-12-26 00:16:34',NULL,NULL),(25131,16200,'EM','hymel.ashley@gmail.com',0,'2014-01-05 00:01:07',NULL,NULL),(24483,15798,'TE','2257760809',0,'2014-01-03 02:02:45',NULL,NULL),(36921,24315,'AP','8172537476',0,'2014-02-18 22:00:05',NULL,NULL),(39138,25886,'TE','8304883357',0,'2014-02-26 21:01:01',NULL,NULL),(39266,25978,'TE','7404035993',0,'2014-02-26 21:01:50',NULL,NULL),(39354,26029,'AP','6015732290',0,'2014-02-26 21:02:20',NULL,NULL),(27873,17960,'EM','grannytexas124@yahoo.com',0,'2014-01-15 02:06:46',NULL,NULL),(8860,5806,'TE','8067486355',0,'2013-12-25 23:47:38',NULL,NULL),(8099,5304,'TE','6013164523',0,'2013-12-25 23:06:22',NULL,NULL),(1149,707,'TE','5038161502',0,'2013-12-25 18:03:04',NULL,NULL),(35927,23638,'AP','9794796361',0,'2014-02-14 21:30:07',NULL,NULL),(34416,22578,'TE','4192621661',0,'2014-02-10 21:32:01',NULL,NULL),(29100,18792,'TE','9375223111',0,'2014-01-17 03:35:57',NULL,NULL),(6755,4384,'TE','6144216826',0,'2013-12-25 22:00:43',NULL,NULL),(26069,16791,'TE','5136231187',0,'2014-01-13 02:18:06',NULL,NULL),(10609,6903,'AP','5044586058',0,'2013-12-26 01:45:42',NULL,NULL),(1345,820,'EM','sambursac@ameritech.net',0,'2013-12-25 18:06:05',NULL,NULL),(22849,14744,'TE','3309513774',1,'2013-12-29 11:10:07',NULL,NULL),(42156,28005,'TE','2163142613',0,'2014-03-06 21:01:11',NULL,NULL),(36481,24016,'AP','9374799812',0,'2014-02-15 22:00:44',NULL,NULL),(4651,2973,'TE','8063524053',0,'2013-12-25 20:17:01',NULL,NULL),(4910,3152,'EM','jason@bigmeek.com',0,'2013-12-25 20:31:05',NULL,NULL),(33632,22053,'AP','9153070468',0,'2014-02-08 19:00:06',NULL,NULL),(5872,3767,'TE','2165099707',0,'2013-12-25 21:33:36',NULL,NULL),(11079,7195,'AP','3307179376',0,'2013-12-26 02:00:32',NULL,NULL),(20933,13464,'AP','6143957986',0,'2013-12-26 13:01:50',NULL,NULL),(11565,7525,'TE','3309540311',0,'2013-12-26 02:32:32',NULL,NULL),(42266,28071,'EM','beverly.roach@sbcglobal.net',0,'2014-03-06 21:01:50',NULL,NULL),(22285,14364,'TE','4192393641',0,'2013-12-28 03:30:21',NULL,NULL),(32563,21294,'TE','9186079943',0,'2014-02-04 21:00:08',NULL,NULL),(29667,19170,'TE','9566274924',0,'2014-01-21 08:46:03',NULL,NULL),(14497,9470,'EM','bsmith77@fuse.net',0,'2013-12-26 04:34:26',NULL,NULL),(27536,17744,'TE','3307644371',0,'2014-01-14 01:33:24',NULL,NULL),(8435,5550,'AP','2546245024',0,'2013-12-25 23:16:07',NULL,NULL),(32987,21596,'EM','friendbuilderinc@aol.com',0,'2014-02-05 21:30:30',NULL,NULL),(27640,17817,'EM','mccartyderida@yahoo.com',0,'2014-01-15 02:05:55',NULL,NULL),(23960,15459,'EM','Monterrozaamadeo@yahoo.com',1,'2014-01-02 04:28:38',NULL,NULL),(27501,17716,'TE','3304416466',0,'2014-01-14 01:33:12',NULL,NULL),(5641,3617,'AP','4193034752',0,'2013-12-25 21:23:37',NULL,NULL),(22472,14490,'TE','2546972004',0,'2013-12-28 03:33:31',NULL,NULL),(11322,7376,'TE','7409833631',0,'2013-12-26 02:15:49',NULL,NULL),(42290,28082,'AP','9037527015',0,'2014-03-06 21:01:58',NULL,NULL),(1252,761,'TE','9724904327',0,'2013-12-25 18:04:34',NULL,NULL),(24656,15898,'TE','4196190029',0,'2014-01-03 02:05:58',NULL,NULL),(26896,17303,'AP','2547346046',0,'2014-01-13 02:23:40',NULL,NULL),(2862,1750,'TE','3307851232',0,'2013-12-25 18:55:42',NULL,NULL),(26387,16985,'TE','2104098599',0,'2014-01-13 02:20:21',NULL,NULL),(12388,8112,'EM','CASEYCAT1@COX.NET',0,'2013-12-26 03:15:04',NULL,NULL),(22385,14440,'TE','5044186689',0,'2013-12-28 03:32:10',NULL,NULL),(14708,9623,'AP','4197050738',0,'2013-12-26 04:37:58',NULL,NULL),(1947,1205,'EM','sumrgirl758@yahoo.com',0,'2013-12-25 18:19:58',NULL,NULL),(27314,17590,'AP','9373616612',0,'2014-01-14 01:32:10',NULL,NULL),(8192,5361,'TE','9373234302',0,'2013-12-25 23:07:51',NULL,NULL),(25161,16219,'TE','5134676055',0,'2014-01-05 00:01:46',NULL,NULL),(7441,4847,'AP','5135502174',0,'2013-12-25 22:30:16',NULL,NULL),(27104,17436,'AP','5132957010',0,'2014-01-13 03:00:33',NULL,NULL),(5984,3845,'TE','5045831118',0,'2013-12-25 21:35:29',NULL,NULL),(14126,9253,'TE','7245495798',0,'2013-12-26 04:15:03',NULL,NULL),(14045,9177,'TE','5138769707',0,'2013-12-26 04:09:05',NULL,NULL),(13843,9027,'TE','3306202018',0,'2013-12-26 04:05:28',NULL,NULL),(5533,3538,'AP','9726793599',0,'2013-12-25 21:21:41',NULL,NULL),(38359,25338,'TE','3186456252',0,'2014-02-25 21:30:23',NULL,NULL),(39480,26109,'EM','leetran12@yahoo.com',0,'2014-02-28 06:30:16',NULL,NULL),(37101,24424,'EM','ragonesilaw@gmail.com',0,'2014-02-18 22:01:10',NULL,NULL),(4376,2791,'TE','4054120980',0,'2013-12-25 19:50:08',NULL,NULL),(22641,14599,'AP','3307199810',0,'2013-12-28 03:36:21',NULL,NULL),(20739,13330,'EM','godscyn@earthlink.net',0,'2013-12-26 12:58:36',NULL,NULL),(36763,24206,'TE','5044501386',0,'2014-02-16 19:00:20',NULL,NULL),(30527,19801,'TE','9157313150',0,'2014-01-24 21:00:04',NULL,NULL),(32108,20968,'AP','9568677328',0,'2014-02-01 19:00:13',NULL,NULL),(26962,17339,'AP','4192830457',0,'2014-01-13 02:24:02',NULL,NULL),(24374,15740,'TE','9152349010',0,'2014-01-03 02:00:48',NULL,NULL),(22028,14186,'TE','2146417177',0,'2013-12-27 02:03:52',NULL,NULL),(14505,9476,'TE','6148343233',0,'2013-12-26 04:34:34',NULL,NULL),(21277,13671,'TE','5124262077',0,'2013-12-26 13:07:55',NULL,NULL),(38196,25209,'EM','kmcgough@pminsulation.com',0,'2014-02-21 22:00:51',NULL,NULL),(39270,25984,'TE','2169261801',0,'2014-02-26 21:01:53',NULL,NULL),(40121,26607,'AP','9566220492',0,'2014-02-28 21:30:45',NULL,NULL),(41018,27253,'EM','starrsmpw@yahoo.com',0,'2014-03-03 21:31:55',NULL,NULL),(569,352,'AP','2259934863',0,'2013-12-25 17:32:19',NULL,NULL),(33883,22238,'TE','7407871784',0,'2014-02-09 19:00:37',NULL,NULL),(32997,21612,'TE','2163751104',0,'2014-02-05 21:30:34',NULL,NULL),(31342,20423,'TE','4403211426',0,'2014-01-29 21:00:31',NULL,NULL),(31201,20318,'EM','cutietexasgirl20@yahoo.com',0,'2014-01-28 21:00:54',NULL,NULL),(22212,14315,'TE','4192024404',0,'2013-12-27 02:07:07',NULL,NULL),(27460,17691,'TE','9852102328',0,'2014-01-14 01:32:59',NULL,NULL),(21172,13619,'TE','5138513310',0,'2013-12-26 13:05:49',NULL,NULL),(11442,7442,'TE','7408910356',0,'2013-12-26 02:30:28',NULL,NULL),(26554,17081,'TE','3615481351',0,'2014-01-13 02:21:22',NULL,NULL),(39894,26400,'EM','nazolder1@yahoo.com',0,'2014-02-28 07:00:31',NULL,NULL),(40604,26953,'EM','terriem@gmail.com',0,'2014-03-03 01:00:27',NULL,NULL),(9695,6350,'TE','5132546376',0,'2013-12-26 00:47:01',NULL,NULL),(21087,13560,'AP','5019524534',0,'2013-12-26 13:04:21',NULL,NULL),(31970,20875,'TE','2252213600',0,'2014-01-31 21:01:04',NULL,NULL),(27546,17753,'TE','6014544588',0,'2014-01-14 01:33:29',NULL,NULL),(35781,23531,'TE','3185422391',0,'2014-02-13 22:02:26',NULL,NULL),(27116,17453,'EM','wkennedy@hotmail.com',0,'2014-01-13 03:00:39',NULL,NULL),(34206,22434,'TE','2105403210',0,'2014-02-10 21:30:38',NULL,NULL),(5764,3692,'TE','4193413302',0,'2013-12-25 21:31:45',NULL,NULL),(22543,14537,'TE','6015023478',0,'2013-12-28 03:34:43',NULL,NULL),(581,359,'EM','cimmonezaldrin@gmail.com',0,'2013-12-25 17:45:07',NULL,NULL),(22938,14798,'EM','randiholl@yahoo.com',1,'2013-12-29 11:13:41',NULL,NULL),(25689,16561,'AP','4193051926',1,'2014-01-07 10:23:04',NULL,NULL),(34984,22968,'EM','dmajer@netzero.com',0,'2014-02-12 21:00:15',NULL,NULL),(23682,15290,'EM','sheddie@suddenlink.net',1,'2014-01-02 04:22:27',NULL,NULL),(23224,14968,'TE','9728147226',0,'2014-01-01 12:00:41',NULL,NULL),(5773,3697,'EM','april_risner@yahoo.com',0,'2013-12-25 21:31:54',NULL,NULL),(20241,13040,'TE','5132568237',0,'2013-12-26 12:50:36',NULL,NULL),(12239,8003,'AP','5127318463',0,'2013-12-26 03:08:25',NULL,NULL),(2997,1853,'EM','thalpin@fuse.net',0,'2013-12-25 18:58:00',NULL,NULL),(33745,22143,'AP','7404590231',0,'2014-02-08 19:00:50',NULL,NULL),(32553,21284,'TE','5045592689',0,'2014-02-04 21:00:04',NULL,NULL),(33550,21994,'EM','cyndibw@yahoo.com',0,'2014-02-07 19:00:44',NULL,NULL),(35288,23179,'TE','9014613400',0,'2014-02-12 21:31:57',NULL,NULL),(28255,18220,'AP','5125525631',0,'2014-01-16 08:44:13',NULL,NULL),(35181,23107,'TE','4158191968',0,'2014-02-12 21:31:16',NULL,NULL),(29431,19028,'EM','jguilfoyle@cooperandadel.com',0,'2014-01-20 08:06:30',NULL,NULL),(37872,24983,'TE','8302377948',0,'2014-02-20 22:00:35',NULL,NULL),(43128,28669,'AP','3376392948',0,'2014-03-08 21:30:48',NULL,NULL),(43332,28786,'TE','5133740668',0,'2014-03-09 21:00:38',NULL,NULL),(1183,724,'AP','9039309332',0,'2013-12-25 18:03:34',NULL,NULL),(8958,5868,'TE','4402319513',0,'2013-12-25 23:49:09',NULL,NULL),(24557,15839,'TE','4409336467',0,'2014-01-03 02:04:07',NULL,NULL),(8828,5780,'AP','5135463609',0,'2013-12-25 23:47:02',NULL,NULL),(33088,21675,'TE','5043922702',0,'2014-02-05 21:31:00',NULL,NULL),(11806,7677,'TE','3305243819',0,'2013-12-26 03:00:45',NULL,NULL),(20546,13225,'EM','tmix23@yahoo.com',0,'2013-12-26 12:55:36',NULL,NULL),(23053,14870,'AP','9033638813',0,'2013-12-30 00:00:12',NULL,NULL),(22432,14465,'EM','susansle@sbcglobal.net',0,'2013-12-28 03:32:54',NULL,NULL),(21550,13857,'EM','mcclain.87@gmail.com',0,'2013-12-26 13:12:43',NULL,NULL),(4350,2775,'AP','6018135548',0,'2013-12-25 19:49:40',NULL,NULL),(3245,2042,'EM','SHERRIRENEE24@AOL.COM',0,'2013-12-25 19:15:37',NULL,NULL),(8811,5769,'EM','Eckk1@hotmail.com',0,'2013-12-25 23:46:45',NULL,NULL),(33635,22055,'AP','8328874803',0,'2014-02-08 19:00:07',NULL,NULL),(33123,21698,'TE','3308359450',0,'2014-02-05 21:31:09',NULL,NULL),(21357,13726,'AP','3309060192',0,'2013-12-26 13:09:19',NULL,NULL),(31278,20376,'AP','9032466287',0,'2014-01-29 21:00:09',NULL,NULL),(29449,19041,'EM','katstreng@gmail.com',0,'2014-01-20 08:06:37',NULL,NULL),(39670,26229,'EM','rebeccabickham@gmail.com',0,'2014-02-28 06:31:00',NULL,NULL),(40694,27031,'AP','9158868805',0,'2014-03-03 21:00:16',NULL,NULL),(28277,18232,'AP','8062022525',0,'2014-01-16 08:44:19',NULL,NULL),(29982,19404,'EM','JAG1955@ROADRUNNER.COM',1,'2014-01-22 03:22:55',NULL,NULL),(31844,20791,'TE','9035567194',0,'2014-01-31 21:00:15',NULL,NULL),(37421,24643,'AP','3182642812',0,'2014-02-20 04:20:52',NULL,NULL),(23615,15246,'TE','9802137607',0,'2014-01-01 12:08:48',NULL,NULL),(24923,16065,'TE','9374141191',0,'2014-01-04 02:03:39',NULL,NULL),(26167,16848,'TE','9372120519',0,'2014-01-13 02:18:38',NULL,NULL),(30339,19657,'EM','lovillelectric@yahoo.com',0,'2014-01-23 21:00:23',NULL,NULL),(24887,16045,'AP','9152278045',0,'2014-01-04 02:03:00',NULL,NULL),(8652,5685,'AP','5132128353',0,'2013-12-25 23:32:26',NULL,NULL),(6889,4479,'AP','4196568611',0,'2013-12-25 22:02:56',NULL,NULL),(4161,2654,'AP','6143123823',0,'2013-12-25 19:46:42',NULL,NULL),(39531,26148,'AP','5133864932',0,'2014-02-28 06:30:28',NULL,NULL),(39532,26148,'BN','5133864932',0,'2014-02-28 06:30:28',NULL,NULL),(35445,23306,'TE','9709019209',0,'2014-02-13 22:00:18',NULL,NULL),(23294,15008,'EM','IRISHALUM78@YAHOO.COM',0,'2014-01-01 12:01:58',NULL,NULL),(5274,3386,'TE','2257185756',0,'2013-12-25 21:17:40',NULL,NULL),(32447,21201,'EM','steveknape@hotmail.com',0,'2014-02-03 21:00:53',NULL,NULL),(13965,9102,'AP','4402255137',0,'2013-12-26 04:07:26',NULL,NULL),(32032,20907,'EM','ctb5020@yahoo.com',0,'2014-01-31 21:01:25',NULL,NULL),(31590,20606,'TE','6148649403',0,'2014-01-30 21:00:15',NULL,NULL),(11427,7435,'TE','3307842484',0,'2013-12-26 02:30:15',NULL,NULL),(29587,19118,'TE','5138922243',0,'2014-01-21 08:45:15',NULL,NULL),(36547,24063,'AP','5133155280',0,'2014-02-15 22:01:10',NULL,NULL),(8555,5621,'TE','4408011123',0,'2013-12-25 23:30:47',NULL,NULL),(22704,14642,'EM','nlmosercma@gmail.com',1,'2013-12-29 11:07:29',NULL,NULL),(22761,14677,'TE','6019944647',1,'2013-12-29 11:08:27',NULL,NULL),(26364,16970,'TE','4405392734',0,'2014-01-13 02:20:13',NULL,NULL),(36908,24305,'AP','3306067567',0,'2014-02-18 21:30:23',NULL,NULL),(39656,26222,'TE','9566479740',0,'2014-02-28 06:30:58',NULL,NULL),(40680,27012,'AP','4193488794',0,'2014-03-03 21:00:08',NULL,NULL),(42617,28351,'TE','7135142287',0,'2014-03-07 21:30:23',NULL,NULL),(30227,19579,'AP','2259218351',0,'2014-01-23 03:02:40',NULL,NULL),(24752,15971,'AP','2544588220',0,'2014-01-04 02:00:36',NULL,NULL),(29498,19068,'AP','4192830457',0,'2014-01-21 08:44:19',NULL,NULL),(7957,5189,'EM','moonbeamjb@roadrunner.com',0,'2013-12-25 23:03:44',NULL,NULL),(8711,5716,'TE','3302648877',0,'2013-12-25 23:45:17',NULL,NULL),(28789,18579,'EM','rojoco2@yahoo.com',0,'2014-01-16 08:47:08',NULL,NULL),(7420,4824,'EM','Joanldrake@gmail.com',0,'2013-12-25 22:17:11',NULL,NULL),(27430,17667,'TE','5135038070',0,'2014-01-14 01:32:48',NULL,NULL),(36259,23861,'EM','CAROLINECARNEY@GMAIL.COM',0,'2014-02-14 21:32:05',NULL,NULL),(40793,27111,'EM','seldabaja@hotmail.com',0,'2014-03-03 21:30:26',NULL,NULL),(24605,15869,'TE','6015170345',0,'2014-01-03 02:05:02',NULL,NULL),(28704,18522,'AP','2142081068',0,'2014-01-16 08:46:39',NULL,NULL),(8924,5840,'AP','9033528646',0,'2013-12-25 23:48:33',NULL,NULL),(4352,2777,'TE','6627060783',0,'2013-12-25 19:49:43',NULL,NULL),(22617,14585,'TE','9377267008',0,'2013-12-28 03:35:58',NULL,NULL),(5359,3432,'TE','3182188627',0,'2013-12-25 21:18:58',NULL,NULL),(20444,13168,'TE','6143613919',0,'2013-12-26 12:54:00',NULL,NULL),(40514,26887,'BN','5672598391',0,'2014-03-03 01:00:02',NULL,NULL),(42754,28439,'AP','4193060645',0,'2014-03-07 21:31:12',NULL,NULL),(24318,15708,'TE','2166636758',1,'2014-01-02 04:36:00',NULL,NULL),(22779,14689,'AP','7405908033',1,'2013-12-29 11:08:46',NULL,NULL),(9939,6504,'TE','3306356026',0,'2013-12-26 00:50:57',NULL,NULL),(7958,5190,'TE','2162141398',0,'2013-12-25 23:03:46',NULL,NULL),(2152,1325,'EM','rick.k.webster@gmail.com',0,'2013-12-25 18:31:54',NULL,NULL),(3883,2468,'AP','3187588719',0,'2013-12-25 19:35:08',NULL,NULL),(20710,13311,'TE','8176148601',0,'2013-12-26 12:58:07',NULL,NULL),(4976,3192,'AP','6015966298',0,'2013-12-25 20:32:13',NULL,NULL),(38316,25314,'TE','3184430209',0,'2014-02-25 21:30:04',NULL,NULL),(32926,21554,'TE','7408566434',0,'2014-02-05 21:30:15',NULL,NULL),(29572,19108,'TE','5082098335',0,'2014-01-21 08:44:43',NULL,NULL),(29095,18790,'AP','9374166462',0,'2014-01-17 03:35:56',NULL,NULL),(28859,18636,'AP','8303529482',0,'2014-01-17 03:35:04',NULL,NULL),(27625,17808,'TE','7138069228',0,'2014-01-15 02:05:51',NULL,NULL),(26939,17327,'TE','5043834109',0,'2014-01-13 02:23:54',NULL,NULL),(5172,3320,'TE','4197883957',0,'2013-12-25 21:16:03',NULL,NULL),(3219,2024,'EM','jaustin6@kent.edu',0,'2013-12-25 19:15:11',NULL,NULL),(10979,7134,'TE','7033035994',0,'2013-12-26 01:51:42',NULL,NULL),(12121,7922,'AP','3374997170',0,'2013-12-26 03:06:22',NULL,NULL),(36747,24195,'TE','6505751972',0,'2014-02-16 19:00:15',NULL,NULL),(39573,26180,'AP','2169249426',0,'2014-02-28 06:30:40',NULL,NULL),(42698,28402,'AP','2163014790',0,'2014-03-07 21:30:51',NULL,NULL),(33011,21629,'TE','9367143973',0,'2014-02-05 21:30:40',NULL,NULL),(30054,19470,'TE','8173339377',0,'2014-01-23 03:01:59',NULL,NULL),(10981,7134,'EM','helani.maria@gmail.com',0,'2013-12-26 01:51:43',NULL,NULL),(14342,9375,'AP','2253852747',0,'2013-12-26 04:31:56',NULL,NULL),(36777,24215,'AP','5127888598',0,'2014-02-16 19:00:26',NULL,NULL),(39753,26289,'AP','5044589607',0,'2014-02-28 06:31:23',NULL,NULL),(39917,26415,'AP','8323537918',0,'2014-02-28 07:30:04',NULL,NULL),(39992,26485,'EM','gumbojo1@att.net',0,'2014-02-28 21:00:07',NULL,NULL),(35858,23579,'TE','5137347144',0,'2014-02-13 22:02:56',NULL,NULL),(30416,19716,'TE','4192157829',0,'2014-01-23 21:00:55',NULL,NULL),(30247,19593,'TE','6012094699',0,'2014-01-23 03:02:45',NULL,NULL),(24709,15941,'TE','9374037906',0,'2014-01-03 02:07:12',NULL,NULL),(14321,9365,'TE','4092739400',0,'2013-12-26 04:31:38',NULL,NULL),(21032,13532,'AP','3376543741',0,'2013-12-26 13:03:30',NULL,NULL),(5565,3555,'EM','jdavis@acclimaging.com',0,'2013-12-25 21:22:09',NULL,NULL),(2709,1646,'TE','9039161157',0,'2013-12-25 18:53:14',NULL,NULL),(4760,3049,'AP','5049197727',0,'2013-12-25 20:18:50',NULL,NULL),(23473,15137,'EM','pmrider@fuse.net',0,'2014-01-01 12:05:38',NULL,NULL),(42923,28542,'AP','3304283539',0,'2014-03-07 21:32:15',NULL,NULL),(23216,14960,'TE','8179239148',0,'2014-01-01 12:00:29',NULL,NULL),(25682,16557,'TE','5043028884',1,'2014-01-07 10:22:56',NULL,NULL),(31049,20199,'TE','6018320622',0,'2014-01-27 21:01:31',NULL,NULL),(30709,19950,'AP','3187922681',0,'2014-01-25 19:00:03',NULL,NULL),(4962,3183,'EM','JULIETTEHARLOW@GMAIL.COM',0,'2013-12-25 20:31:55',NULL,NULL),(5603,3587,'AP','2604026808',0,'2013-12-25 21:22:54',NULL,NULL),(9641,6309,'AP','5672258106',0,'2013-12-26 00:46:07',NULL,NULL),(21769,14027,'TE','5133103218',0,'2013-12-26 13:16:45',NULL,NULL),(40049,26551,'EM','mat546@columbus.rr.com',0,'2014-02-28 21:30:13',NULL,NULL),(43774,29059,'AP','3302609846',0,'2014-03-10 21:01:51',NULL,NULL),(33682,22093,'TE','9012623571',0,'2014-02-08 19:00:26',NULL,NULL),(28696,18518,'AP','4692747208',0,'2014-01-16 08:46:36',NULL,NULL),(27944,18006,'AP','9376301718',0,'2014-01-15 02:07:02',NULL,NULL),(14090,9214,'TE','6015911552',0,'2013-12-26 04:09:59',NULL,NULL),(27568,17768,'AP','4086665946',0,'2014-01-14 01:33:37',NULL,NULL),(3025,1885,'TE','4192064045',0,'2013-12-25 18:58:39',NULL,NULL),(4637,2959,'AP','3252128854',0,'2013-12-25 20:16:43',NULL,NULL),(7533,4909,'AP','5134706087',0,'2013-12-25 22:32:02',NULL,NULL),(23560,15206,'TE','6013840688',0,'2014-01-01 12:07:34',NULL,NULL),(37796,24944,'AP','6019412856',0,'2014-02-20 22:00:07',NULL,NULL),(38616,25522,'AP','5135444519',0,'2014-02-25 21:32:07',NULL,NULL),(41212,27373,'TE','6628099332',0,'2014-03-04 21:01:17',NULL,NULL),(41353,27473,'TE','9015961666',0,'2014-03-04 21:02:12',NULL,NULL),(29373,18981,'TE','3305092636',0,'2014-01-20 08:06:06',NULL,NULL),(1472,903,'TE','6016955628',0,'2013-12-25 18:08:20',NULL,NULL),(4447,2834,'EM','pdalafayette@pdaorg.net',0,'2013-12-25 20:00:51',NULL,NULL),(10869,7054,'AP','5136009113',0,'2013-12-26 01:49:48',NULL,NULL),(12179,7955,'TE','3182008906',0,'2013-12-26 03:07:17',NULL,NULL),(3161,1977,'AP','8176816774',0,'2013-12-25 19:01:37',NULL,NULL),(2652,1611,'EM','toharrison@fastmail.us',0,'2013-12-25 18:52:19',NULL,NULL),(6255,4035,'TE','5132507305',0,'2013-12-25 21:45:59',NULL,NULL),(39067,25840,'TE','3307491287',0,'2014-02-26 21:00:34',NULL,NULL),(42304,28090,'TE','6018451464',0,'2014-03-06 21:02:04',NULL,NULL),(34242,22459,'TE','8325121341',0,'2014-02-10 21:30:52',NULL,NULL),(8847,5797,'EM','nlange@neo.rr.com',0,'2013-12-25 23:47:25',NULL,NULL),(1681,1033,'EM','rskay@sbcglobal.net',0,'2013-12-25 18:15:34',NULL,NULL),(9076,5952,'AP','6012912305',0,'2013-12-25 23:51:06',NULL,NULL),(389,237,'AP','4193437312',0,'2013-12-25 17:21:12',NULL,NULL),(3649,2312,'EM','MARYMHM@LIVE.COM',0,'2013-12-25 19:31:13',NULL,NULL),(35165,23098,'TE','5133155607',0,'2014-02-12 21:31:10',NULL,NULL),(31625,20629,'AP','3613432442',0,'2014-01-30 21:00:28',NULL,NULL),(20719,13318,'TE','7133848781',0,'2013-12-26 12:58:16',NULL,NULL),(21098,13566,'AP','2254398019',0,'2013-12-26 13:04:31',NULL,NULL),(23103,14897,'TE','8507124093',0,'2013-12-30 00:01:00',NULL,NULL),(31349,20427,'EM','mtouassi@yahoo.com',0,'2014-01-29 21:00:33',NULL,NULL),(7013,4580,'AP','3307631181',0,'2013-12-25 22:05:12',NULL,NULL),(271,168,'TE','3303287000',0,'2013-12-25 17:19:22',NULL,NULL),(12015,7828,'AP','5133774734',0,'2013-12-26 03:04:22',NULL,NULL),(36405,23978,'TE','4153502141',0,'2014-02-15 22:00:18',NULL,NULL),(34192,22425,'AP','5044819829',0,'2014-02-10 21:30:33',NULL,NULL),(33575,22012,'EM','mookieluke@aol.com',0,'2014-02-07 19:00:52',NULL,NULL),(22848,14743,'EM','bmnegrotto@gmail.com',1,'2013-12-29 11:10:06',NULL,NULL),(33101,21682,'TE','9376615415',0,'2014-02-05 21:31:03',NULL,NULL),(33014,21631,'TE','9038220286',0,'2014-02-05 21:30:41',NULL,NULL),(23785,15339,'TE','3308586636',1,'2014-01-02 04:24:11',NULL,NULL),(36175,23810,'TE','3303228889',0,'2014-02-14 21:31:34',NULL,NULL),(20768,13344,'AP','7138197267',0,'2013-12-26 12:59:02',NULL,NULL),(21897,14108,'TE','6142360412',0,'2013-12-27 02:01:46',NULL,NULL),(33551,21995,'TE','3183814086',0,'2014-02-07 19:00:44',NULL,NULL),(39744,26284,'AP','9857052054',0,'2014-02-28 06:31:21',NULL,NULL),(41297,27438,'TE','2257763441',0,'2014-03-04 21:01:51',NULL,NULL),(42554,28317,'EM','alfarhang@yahoo.com',0,'2014-03-07 21:30:02',NULL,NULL),(24946,16080,'TE','4407150349',0,'2014-01-04 02:04:05',NULL,NULL),(10289,6716,'TE','3304006036',0,'2013-12-26 01:15:04',NULL,NULL),(36379,23957,'EM','tripled33@ymail.com',0,'2014-02-15 22:00:08',NULL,NULL),(11370,7406,'TE','2255050341',0,'2013-12-26 02:16:35',NULL,NULL),(35931,23641,'TE','9034568312',0,'2014-02-14 21:30:09',NULL,NULL),(28713,18528,'TE','5132891812',0,'2014-01-16 08:46:42',NULL,NULL),(23457,15118,'TE','4197063670',0,'2014-01-01 12:05:11',NULL,NULL),(28450,18334,'TE','3309045269',0,'2014-01-16 08:45:14',NULL,NULL),(37572,24752,'EM','TONIK81@YAHOO.COM',0,'2014-02-20 04:41:40',NULL,NULL),(38744,25612,'AP','8303357397',0,'2014-02-26 08:30:10',NULL,NULL),(39955,26448,'AP','3303174657',0,'2014-02-28 07:30:25',NULL,NULL),(40980,27227,'AP','5043318439',0,'2014-03-03 21:31:39',NULL,NULL),(42116,27980,'TE','3184333252',0,'2014-03-06 21:00:56',NULL,NULL),(27981,18038,'TE','4198251772',0,'2014-01-15 02:07:11',NULL,NULL),(7945,5185,'AP','3302778990',0,'2013-12-25 23:03:36',NULL,NULL),(1706,1047,'EM','paulettesnowden@yahoo.com',0,'2013-12-25 18:15:57',NULL,NULL),(21801,14047,'TE','5133642775',0,'2013-12-27 02:00:11',NULL,NULL),(13717,8939,'TE','2166717265',0,'2013-12-26 04:03:17',NULL,NULL),(21381,13748,'TE','5677127899',0,'2013-12-26 13:09:53',NULL,NULL),(6183,3984,'EM','julieerudd@gmail.com',0,'2013-12-25 21:38:54',NULL,NULL),(4630,2952,'AP','8326073819',0,'2013-12-25 20:16:34',NULL,NULL),(20894,13435,'EM','Scottybears@me.com',0,'2013-12-26 13:01:10',NULL,NULL),(37396,24626,'TE','2257177758',0,'2014-02-20 04:17:12',NULL,NULL),(222,134,'AP','2162179394',0,'2013-12-25 17:18:33',NULL,NULL),(5292,3393,'AP','5042923039',0,'2013-12-25 21:17:54',NULL,NULL),(12326,8060,'TE','4198435431',0,'2013-12-26 03:09:57',NULL,NULL),(36483,24019,'TE','2162469779',0,'2014-02-15 22:00:45',NULL,NULL),(22373,14430,'TE','9857140901',0,'2013-12-28 03:31:55',NULL,NULL),(41650,27686,'TE','9034753759',0,'2014-03-05 21:30:41',NULL,NULL),(33940,22272,'AP','9562317036',0,'2014-02-10 11:00:15',NULL,NULL),(29528,19085,'AP','4192770038',0,'2014-01-21 08:44:29',NULL,NULL),(22768,14680,'AP','6622951864',1,'2013-12-29 11:08:32',NULL,NULL),(10505,6841,'AP','5042588697',0,'2013-12-26 01:31:07',NULL,NULL),(40154,26633,'TE','8179954871',0,'2014-02-28 21:30:58',NULL,NULL),(40319,26755,'EM','tazwoman723@aol.com',0,'2014-03-01 19:00:05',NULL,NULL),(37499,24690,'BN','9567401351',0,'2014-02-20 04:32:38',NULL,NULL),(1907,1178,'EM','rcryder@gmail.com',0,'2013-12-25 18:19:19',NULL,NULL),(32314,21110,'AP','5049755545',0,'2014-02-03 21:00:07',NULL,NULL),(21535,13846,'TE','3306314379',0,'2013-12-26 13:12:27',NULL,NULL),(10398,6778,'EM','Jkeltz9162@msn.com',0,'2013-12-26 01:16:46',NULL,NULL),(26868,17289,'TE','8062022525',0,'2014-01-13 02:23:32',NULL,NULL),(22930,14796,'TE','5136580269',1,'2013-12-29 11:13:36',NULL,NULL),(6299,4059,'EM','amyflesher@yahoo.com',0,'2013-12-25 21:46:38',NULL,NULL),(39041,25819,'TE','6144315191',0,'2014-02-26 21:00:25',NULL,NULL),(43347,28792,'TE','2143619408',0,'2014-03-09 21:00:43',NULL,NULL),(33658,22078,'EM','bernitaT1950@gmail.com',0,'2014-02-08 19:00:17',NULL,NULL),(8890,5822,'EM','minkiem3@gmail.com',0,'2013-12-25 23:48:03',NULL,NULL),(8963,5870,'AP','9372704085',0,'2013-12-25 23:49:13',NULL,NULL),(33125,21698,'EM','tchung800@sbcglobal.net',0,'2014-02-05 21:31:09',NULL,NULL),(3590,2250,'AP','2163702432',0,'2013-12-25 19:30:06',NULL,NULL),(7417,4822,'TE','4194489544',0,'2013-12-25 22:17:08',NULL,NULL),(3535,2211,'AP','3304952626',0,'2013-12-25 19:20:18',NULL,NULL),(11821,7691,'TE','2166181025',0,'2013-12-26 03:01:02',NULL,NULL),(14388,9407,'EM','hector531@yahoo.com',0,'2013-12-26 04:32:47',NULL,NULL),(24646,15891,'TE','4196934461',0,'2014-01-03 02:05:45',NULL,NULL),(21384,13751,'EM','jlambert2895@yahoo.com',0,'2013-12-26 13:09:57',NULL,NULL),(39388,26047,'EM','sgarret3@kent.edu',0,'2014-02-26 21:02:31',NULL,NULL),(30700,19942,'AP','9377269233',0,'2014-01-24 21:01:16',NULL,NULL),(6825,4429,'TE','5138441711',0,'2013-12-25 22:01:50',NULL,NULL),(14963,9790,'AP','4409156351',0,'2013-12-26 05:00:57',NULL,NULL),(5416,3468,'TE','6146228148',0,'2013-12-25 21:19:52',NULL,NULL),(3015,1875,'AP','4408120547',0,'2013-12-25 18:58:24',NULL,NULL),(21070,13550,'AP','3104359109',0,'2013-12-26 13:04:04',NULL,NULL),(14982,9804,'TE','9375644234',0,'2013-12-26 05:01:18',NULL,NULL),(3956,2512,'TE','6627385091',0,'2013-12-25 19:36:20',NULL,NULL),(4370,2784,'AP','4193606890',0,'2013-12-25 19:49:58',NULL,NULL),(38315,25313,'TE','3184430209',0,'2014-02-25 21:30:03',NULL,NULL),(38987,25781,'TE','4406672608',0,'2014-02-26 09:31:02',NULL,NULL),(39960,26456,'AP','6015294788',0,'2014-02-28 07:30:28',NULL,NULL),(43731,29032,'TE','9376533068',0,'2014-03-10 21:01:36',NULL,NULL),(1343,819,'EM','tricia_warren@sbcglobal.net',0,'2013-12-25 18:06:03',NULL,NULL),(1503,924,'AP','4405520000',0,'2013-12-25 18:08:57',NULL,NULL),(25864,16669,'EM','drr2834@yahoo.com',0,'2014-01-08 18:24:28',NULL,NULL),(34409,22571,'AP','3123715272',0,'2014-02-10 21:31:57',NULL,NULL),(25301,16314,'TE','2252538803',0,'2014-01-07 04:01:32',NULL,NULL),(34079,22340,'AP','3302891776',0,'2014-02-10 11:01:08',NULL,NULL),(23867,15402,'AP','2142893300',1,'2014-01-02 04:26:50',NULL,NULL),(33861,22227,'TE','3187289757',0,'2014-02-09 19:00:30',NULL,NULL),(33417,21894,'TE','4192364828',0,'2014-02-06 21:01:41',NULL,NULL),(14201,9289,'AP','5132122288',0,'2013-12-26 04:16:07',NULL,NULL),(14156,9266,'EM','lindamckee96@yahoo.com',0,'2013-12-26 04:15:29',NULL,NULL),(9488,6208,'AP','5125788591',0,'2013-12-26 00:30:48',NULL,NULL),(28944,18685,'EM','pwatson92@gmail.com',0,'2014-01-17 03:35:22',NULL,NULL),(37604,24781,'AP','6145569340',0,'2014-02-20 04:45:21',NULL,NULL),(43031,28611,'EM','sharon_shafer@yahoo.com',0,'2014-03-08 21:30:16',NULL,NULL),(43657,28975,'AP','3186641320',0,'2014-03-10 21:01:05',NULL,NULL),(688,428,'TE','6144249609',0,'2013-12-25 17:46:50',NULL,NULL),(29325,18950,'BN','8172336679',0,'2014-01-20 08:05:49',NULL,NULL),(2400,1461,'EM','nlange@neo.rr.com',0,'2013-12-25 18:48:21',NULL,NULL),(2164,1331,'AP','4196184046',0,'2013-12-25 18:32:06',NULL,NULL),(1293,787,'AP','9564668180',0,'2013-12-25 18:05:13',NULL,NULL),(7598,4946,'AP','4193094778',0,'2013-12-25 22:45:49',NULL,NULL),(11836,7701,'AP','6145071044',0,'2013-12-26 03:01:17',NULL,NULL),(11103,7210,'EM','katmil8701@gmail.com',0,'2013-12-26 02:00:55',NULL,NULL),(41528,27612,'AP','2259387326',0,'2014-03-05 21:00:29',NULL,NULL),(42027,27933,'EM','sanjsanchez01@sbcglobal.net',0,'2014-03-06 21:00:27',NULL,NULL),(43559,28927,'TE','3304533982',0,'2014-03-10 21:00:35',NULL,NULL),(2496,1531,'EM','hill5285@yahoo.com',0,'2013-12-25 18:50:02',NULL,NULL),(33833,22213,'AP','5042152437',0,'2014-02-09 19:00:22',NULL,NULL),(24026,15513,'AP','4405703261',1,'2014-01-02 04:30:05',NULL,NULL),(32061,20933,'EM','tjmathew421@hotmail.com',0,'2014-01-31 21:01:39',NULL,NULL),(27724,17870,'AP','5134701321',0,'2014-01-15 02:06:13',NULL,NULL),(26589,17106,'EM','tammlynn77@yahoo.com',0,'2014-01-13 02:21:35',NULL,NULL),(40083,26583,'TE','6148327682',0,'2014-02-28 21:30:31',NULL,NULL),(40301,26734,'AP','4195810862',0,'2014-02-28 21:31:51',NULL,NULL),(41798,27786,'EM','span.dexter@yahoo.com',0,'2014-03-05 21:31:37',NULL,NULL),(36359,23944,'EM','chelbiet@yahoo.com',0,'2014-02-15 21:00:11',NULL,NULL),(4019,2557,'EM','mchild2208@comcast.net',0,'2013-12-25 19:37:26',NULL,NULL),(24078,15544,'AP','3375791481',1,'2014-01-02 04:31:04',NULL,NULL),(22918,14788,'TE','4195893463',1,'2013-12-29 11:13:25',NULL,NULL),(33557,21998,'EM','AMYLANTIER1019@ATT.NET',0,'2014-02-07 19:00:46',NULL,NULL),(6070,3907,'EM','NTESSONE@YAHOO.COM',0,'2013-12-25 21:36:59',NULL,NULL),(35397,23265,'AP','5136738802',0,'2014-02-13 21:30:11',NULL,NULL),(1393,852,'TE','3308991181',0,'2013-12-25 18:06:56',NULL,NULL),(24537,15826,'TE','4402251061',0,'2014-01-03 02:03:42',NULL,NULL),(34092,22347,'AP','6143072406',0,'2014-02-10 11:01:13',NULL,NULL),(37451,24659,'TE','4192430397',0,'2014-02-20 04:25:02',NULL,NULL),(28652,18479,'TE','3306706197',0,'2014-01-16 08:46:21',NULL,NULL),(9791,6407,'TE','4193993746',0,'2013-12-26 00:48:30',NULL,NULL),(28252,18219,'TE','4196937280',0,'2014-01-15 02:08:13',NULL,NULL),(11202,7283,'TE','3306316896',0,'2013-12-26 02:02:46',NULL,NULL),(11453,7447,'TE','9376715957',0,'2013-12-26 02:30:37',NULL,NULL),(37933,25029,'EM','bigmike24000@comcast.net',0,'2014-02-20 22:01:02',NULL,NULL),(40688,27020,'TE','6149059232',0,'2014-03-03 21:00:12',NULL,NULL),(43784,29063,'EM','coryzunk71085@yahoo.com',0,'2014-03-10 21:01:54',NULL,NULL),(3453,2162,'AP','3307012255',0,'2013-12-25 19:18:56',NULL,NULL),(25439,16404,'TE','9568578412',0,'2014-01-07 04:04:00',NULL,NULL),(23965,15467,'TE','9374318874',1,'2014-01-02 04:28:48',NULL,NULL),(30350,19665,'EM','dwaynedcoleman@yahoo.com',0,'2014-01-23 21:00:28',NULL,NULL),(28898,18655,'EM','Bobbiebowden@gmail.com',0,'2014-01-17 03:35:12',NULL,NULL),(6376,4106,'EM','kara.andrade@gmail.com',0,'2013-12-25 21:47:53',NULL,NULL),(7792,5086,'EM','wfleggett@hotmail.com',0,'2013-12-25 23:01:05',NULL,NULL),(5645,3622,'TE','3306866026',0,'2013-12-25 21:23:43',NULL,NULL),(42164,28010,'TE','5133199866',0,'2014-03-06 21:01:15',NULL,NULL),(43676,28988,'TE','3305651282',0,'2014-03-10 21:01:13',NULL,NULL),(25072,16165,'TE','3377947048',0,'2014-01-05 00:00:03',NULL,NULL),(34075,22338,'AP','4195762141',0,'2014-02-10 11:01:06',NULL,NULL),(33287,21796,'EM','ronwilkey3@gmail.com',0,'2014-02-06 21:00:47',NULL,NULL),(5719,3669,'EM','mapthepaw@yahoo.com',0,'2013-12-25 21:31:07',NULL,NULL),(29381,18987,'TE','2163828268',0,'2014-01-20 08:06:10',NULL,NULL),(28046,18073,'AP','3183314652',0,'2014-01-15 02:07:24',NULL,NULL),(23721,15307,'AP','8323734673',1,'2014-01-02 04:23:04',NULL,NULL),(25903,16694,'AP','9159203724',0,'2014-01-08 18:24:36',NULL,NULL),(23085,14890,'TE','5048108181',0,'2013-12-30 00:00:45',NULL,NULL),(22368,14427,'AP','7132619103',0,'2013-12-28 03:31:50',NULL,NULL),(2476,1519,'TE','4403910090',0,'2013-12-25 18:49:44',NULL,NULL),(3415,2145,'AP','5133146684',0,'2013-12-25 19:18:24',NULL,NULL),(10130,6623,'TE','6628405598',0,'2013-12-26 00:54:06',NULL,NULL),(41187,27354,'AP','4406551869',0,'2014-03-04 21:01:07',NULL,NULL),(43147,28678,'EM','busangelf31@yahoo.com',0,'2014-03-08 21:30:54',NULL,NULL),(23296,15012,'TE','3305714403',0,'2014-01-01 12:02:03',NULL,NULL),(21472,13797,'TE','6015069342',0,'2013-12-26 13:11:17',NULL,NULL),(28855,18635,'TE','2545410965',0,'2014-01-17 03:35:03',NULL,NULL),(23049,14867,'TE','4097305717',0,'2013-12-30 00:00:07',NULL,NULL),(2434,1491,'EM','thomas_darlene@rocketmail.com',0,'2013-12-25 18:49:02',NULL,NULL),(1611,991,'AP','9375805289',0,'2013-12-25 18:10:38',NULL,NULL),(28005,18049,'EM','feefee.harris@yahoo.com',0,'2014-01-15 02:07:16',NULL,NULL),(40200,26665,'AP','5042378299',0,'2014-02-28 21:31:14',NULL,NULL),(209,127,'AP','7705709477',0,'2013-12-25 17:18:22',NULL,NULL),(10714,6964,'EM','J7SYNDER@KC.RR.COM',0,'2013-12-26 01:47:21',NULL,NULL),(34774,22807,'AP','7406030115',0,'2014-02-11 21:01:56',NULL,NULL),(11443,7442,'AP','7408910356',0,'2013-12-26 02:30:28',NULL,NULL),(12248,8007,'TE','8067909437',0,'2013-12-26 03:08:33',NULL,NULL),(13668,8909,'EM','aaron365@gmail.com',0,'2013-12-26 04:02:32',NULL,NULL),(1554,956,'AP','2164664947',0,'2013-12-25 18:09:41',NULL,NULL),(23874,15406,'AP','3612555567',1,'2014-01-02 04:26:57',NULL,NULL),(25345,16346,'AP','4196735451',0,'2014-01-07 04:02:22',NULL,NULL),(31747,20719,'TE','5132911269',0,'2014-01-30 21:01:13',NULL,NULL),(42256,28066,'AP','5133156270',0,'2014-03-06 21:01:47',NULL,NULL),(11242,7318,'AP','2143155378',0,'2013-12-26 02:03:33',NULL,NULL),(34682,22745,'TE','3187199680',0,'2014-02-11 21:01:22',NULL,NULL),(26827,17255,'TE','3306714819',0,'2014-01-13 02:23:14',NULL,NULL),(28222,18194,'AP','3308140379',0,'2014-01-15 02:08:05',NULL,NULL),(33741,22138,'TE','7403357044',0,'2014-02-08 19:00:47',NULL,NULL),(32866,21509,'AP','5673560152',0,'2014-02-04 21:01:57',NULL,NULL),(30633,19880,'TE','3305343331',0,'2014-01-24 21:00:46',NULL,NULL),(39717,26269,'EM','apolo121@yahoo.com',0,'2014-02-28 06:31:15',NULL,NULL),(36042,23708,'AP','5134847251',0,'2014-02-14 21:30:45',NULL,NULL),(34778,22811,'TE','5135942240',0,'2014-02-11 21:01:57',NULL,NULL),(937,579,'TE','5133101466',0,'2013-12-25 17:50:49',NULL,NULL),(23395,15069,'TE','6623343194',0,'2014-01-01 12:03:50',NULL,NULL),(32436,21193,'EM','kwashington766@gmail.com',0,'2014-02-03 21:00:50',NULL,NULL),(22181,14288,'EM','c_koenitzer@yahoo.com',0,'2013-12-27 02:06:31',NULL,NULL),(21892,14104,'AP','9372433805',0,'2013-12-27 02:01:41',NULL,NULL),(28665,18488,'TE','3309953701',0,'2014-01-16 08:46:24',NULL,NULL),(9983,6533,'AP','4055352568',0,'2013-12-26 00:51:43',NULL,NULL),(10672,6933,'EM','msayre87@gmail.com',0,'2013-12-26 01:46:36',NULL,NULL),(27334,17601,'AP','2147739109',0,'2014-01-14 01:32:16',NULL,NULL),(12050,7865,'TE','3527536850',0,'2013-12-26 03:05:05',NULL,NULL),(34403,22567,'AP','4194949351',0,'2014-02-10 21:31:54',NULL,NULL),(33516,21969,'TE','2162286856',0,'2014-02-07 19:00:30',NULL,NULL),(10073,6585,'TE','5138772174',0,'2013-12-26 00:53:05',NULL,NULL),(21131,13587,'AP','3182729101',0,'2013-12-26 13:05:04',NULL,NULL),(145,86,'EM','dallen555@att.net',0,'2013-12-25 17:17:18',NULL,NULL),(36678,24151,'TE','5133687818',0,'2014-02-15 22:01:56',NULL,NULL),(23856,15390,'EM','lizrhoades@ymail.com',1,'2014-01-02 04:25:44',NULL,NULL),(9761,6384,'TE','3306066342',0,'2013-12-26 00:48:00',NULL,NULL),(9870,6453,'AP','3305241572',0,'2013-12-26 00:49:44',NULL,NULL),(3471,2172,'TE','4197892499',0,'2013-12-25 19:19:12',NULL,NULL),(10182,6653,'EM','jsusich@smallbizsalesforce.com',0,'2013-12-26 01:00:38',NULL,NULL),(41034,27263,'EM','shill85_2004@yahoo.com',0,'2014-03-04 21:00:10',NULL,NULL),(42584,28334,'EM','nitrojen65@gmail.com',0,'2014-03-07 21:30:12',NULL,NULL),(26389,16986,'EM','info@zumbarocks.org',0,'2014-01-13 02:20:21',NULL,NULL),(23008,14840,'TE','6148988191',1,'2013-12-29 11:14:48',NULL,NULL),(8336,5468,'TE','4194508599',0,'2013-12-25 23:10:36',NULL,NULL),(22169,14280,'TE','6015643263',0,'2013-12-27 02:06:19',NULL,NULL),(21781,14035,'AP','5133054218',0,'2013-12-26 13:16:59',NULL,NULL),(35401,23268,'TE','9724753450',0,'2014-02-13 21:30:12',NULL,NULL),(33886,22239,'TE','7407871784',0,'2014-02-09 19:00:37',NULL,NULL),(20501,13200,'AP','9039690096',0,'2013-12-26 12:54:56',NULL,NULL),(10325,6734,'AP','5137874168',0,'2013-12-26 01:15:35',NULL,NULL),(10965,7125,'EM','lamees0711@yahoo.com',0,'2013-12-26 01:51:28',NULL,NULL),(33409,21890,'AP','6012871660',0,'2014-02-06 21:01:38',NULL,NULL),(28828,18610,'EM','Truckerlady011@aol.com',0,'2014-01-16 08:47:23',NULL,NULL),(29576,19110,'EM','brandy.oliver79@gmail.com',0,'2014-01-21 08:44:44',NULL,NULL),(30859,20059,'TE','9795510786',0,'2014-01-27 21:00:10',NULL,NULL),(40197,26664,'TE','9856626670',0,'2014-02-28 21:31:14',NULL,NULL),(37898,24999,'AP','3252481510',0,'2014-02-20 22:00:45',NULL,NULL),(34154,22394,'TE','3309224094',0,'2014-02-10 21:30:17',NULL,NULL),(31468,20507,'EM','lientran1@gmail.com',0,'2014-01-29 21:01:17',NULL,NULL),(720,448,'AP','5134046948',0,'2013-12-25 17:47:21',NULL,NULL),(31343,20423,'AP','4403211426',0,'2014-01-29 21:00:31',NULL,NULL),(27463,17692,'AP','5044275064',0,'2014-01-14 01:33:00',NULL,NULL),(14554,9508,'EM','gbracone@comcast.net',0,'2013-12-26 04:35:20',NULL,NULL),(38635,25536,'EM','casburn1@aol.com',0,'2014-02-26 08:00:08',NULL,NULL),(34227,22450,'AP','2146299224',0,'2014-02-10 21:30:46',NULL,NULL),(23828,15373,'AP','6014661152',1,'2014-01-02 04:25:10',NULL,NULL),(26216,16874,'TE','9037206887',0,'2014-01-13 02:19:17',NULL,NULL),(9417,6162,'AP','5672303977',0,'2013-12-26 00:16:51',NULL,NULL),(4481,2851,'AP','4199089073',0,'2013-12-25 20:01:22',NULL,NULL),(33706,22110,'TE','4196511994',0,'2014-02-08 19:00:33',NULL,NULL),(28436,18322,'TE','6144712759',0,'2014-01-16 08:45:08',NULL,NULL),(22227,14326,'AP','3303296870',0,'2013-12-27 02:07:24',NULL,NULL),(27250,17543,'EM','rayer22@gmail.com',0,'2014-01-13 03:01:50',NULL,NULL),(39583,26185,'TE','4403364687',0,'2014-02-28 06:30:42',NULL,NULL),(26582,17102,'TE','2817345476',0,'2014-01-13 02:21:32',NULL,NULL),(24705,15936,'TE','4194360250',0,'2014-01-03 02:07:05',NULL,NULL),(37207,24488,'AP','9152443276',0,'2014-02-20 03:43:32',NULL,NULL),(32282,21087,'EM','vlind03@aol.com',0,'2014-02-02 19:00:25',NULL,NULL),(21115,13575,'AP','5042591652',0,'2013-12-26 13:04:46',NULL,NULL),(26933,17323,'BN','2542266370',0,'2014-01-13 02:23:52',NULL,NULL),(14802,9689,'TE','4196190466',0,'2013-12-26 04:39:39',NULL,NULL),(42689,28398,'AP','9372054310',0,'2014-03-07 21:30:49',NULL,NULL),(25121,16194,'TE','9038962069',0,'2014-01-05 00:00:56',NULL,NULL),(8459,5564,'TE','7409641044',0,'2013-12-25 23:16:35',NULL,NULL),(28171,18158,'EM','BERT10450@AOL.COM',0,'2014-01-15 02:07:53',NULL,NULL),(29069,18772,'AP','2816302696',0,'2014-01-17 03:35:50',NULL,NULL),(3511,2193,'TE','9373832612',0,'2013-12-25 19:19:50',NULL,NULL),(32370,21150,'TE','5137514783',0,'2014-02-03 21:00:27',NULL,NULL),(35985,23676,'TE','7036252196',0,'2014-02-14 21:30:27',NULL,NULL),(41093,27296,'TE','9037583542',0,'2014-03-04 21:00:31',NULL,NULL),(43115,28660,'AP','3374597602',0,'2014-03-08 21:30:43',NULL,NULL),(25221,16263,'TE','5138879094',0,'2014-01-07 04:00:03',NULL,NULL),(11900,7742,'AP','3302835717',0,'2013-12-26 03:02:19',NULL,NULL),(1969,1218,'AP','3302088182',0,'2013-12-25 18:20:20',NULL,NULL),(32274,21083,'TE','9379197057',0,'2014-02-02 19:00:23',NULL,NULL),(8892,5824,'AP','9728243225',0,'2013-12-25 23:48:06',NULL,NULL),(34606,22693,'AP','2255733392',0,'2014-02-11 21:00:53',NULL,NULL),(39560,26173,'EM','jlinda136@yahoo.com',0,'2014-02-28 06:30:37',NULL,NULL),(39596,26195,'TE','5136932490',0,'2014-02-28 06:30:46',NULL,NULL),(40765,27089,'EM','dugger3316@gmail.com',0,'2014-03-03 21:30:16',NULL,NULL),(6289,4053,'EM','pminham@yahoo.com',0,'2013-12-25 21:46:29',NULL,NULL),(11746,7647,'TE','4258797730',0,'2013-12-26 02:46:44',NULL,NULL),(25140,16206,'TE','9564388855',0,'2014-01-05 00:01:18',NULL,NULL),(26768,17222,'TE','4195174803',0,'2014-01-13 02:22:34',NULL,NULL),(21536,13846,'AP','3306314379',0,'2013-12-26 13:12:27',NULL,NULL),(13521,8818,'TE','9372133545',0,'2013-12-26 04:00:10',NULL,NULL),(1289,784,'EM','jdaus51@hotmail.com',0,'2013-12-25 18:05:08',NULL,NULL),(5525,3534,'TE','9567835192',0,'2013-12-25 21:21:35',NULL,NULL),(23906,15423,'TE','9727529968',1,'2014-01-02 04:27:31',NULL,NULL),(9692,6349,'TE','2165758065',0,'2013-12-26 00:46:59',NULL,NULL),(651,405,'EM','luvmygrands0911@gmail.com',0,'2013-12-25 17:46:16',NULL,NULL),(22090,14229,'AP','8179963237',0,'2013-12-27 02:04:56',NULL,NULL),(623,382,'AP','5044580522',0,'2013-12-25 17:45:45',NULL,NULL),(37092,24421,'EM','CHRISCORNELIUS67@YAHOO.COM',0,'2014-02-18 22:01:07',NULL,NULL),(38247,25253,'TE','2167733032',0,'2014-02-21 22:01:15',NULL,NULL),(38407,25376,'TE','5134776484',0,'2014-02-25 21:30:44',NULL,NULL),(39666,26228,'TE','7727776155',0,'2014-02-28 06:31:00',NULL,NULL),(40383,26805,'EM','inna.libaax@gmail.com',0,'2014-03-01 21:00:25',NULL,NULL),(9574,6269,'EM','pat032476@yahoo.com',0,'2013-12-26 00:45:04',NULL,NULL),(42488,28253,'EM','cbbrick1994@yahoo.com',0,'2014-03-07 21:00:14',NULL,NULL),(8613,5660,'TE','3309999175',0,'2013-12-25 23:31:44',NULL,NULL),(39719,26270,'AP','9156332771',0,'2014-02-28 06:31:15',NULL,NULL),(41411,27511,'EM','adunlea1@cinci.rr.com',0,'2014-03-04 21:02:34',NULL,NULL),(32877,21516,'AP','2149863494',0,'2014-02-05 21:00:05',NULL,NULL),(30930,20115,'EM','Ryaniam21@hotmail.com',0,'2014-01-27 21:00:43',NULL,NULL),(23009,14841,'TE','9374415631',1,'2013-12-29 11:14:50',NULL,NULL),(35819,23553,'EM','deevantilburg@gmail.com',0,'2014-02-13 22:02:40',NULL,NULL),(10207,6670,'TE','4408219067',0,'2013-12-26 01:01:05',NULL,NULL),(7462,4858,'AP','3185477759',0,'2013-12-25 22:30:35',NULL,NULL),(33275,21789,'TE','2166314526',0,'2014-02-06 21:00:43',NULL,NULL),(7470,4863,'TE','8322941632',0,'2013-12-25 22:30:44',NULL,NULL),(22730,14658,'AP','3614455851',1,'2013-12-29 11:07:55',NULL,NULL),(22177,14286,'AP','4193407706',0,'2013-12-27 02:06:27',NULL,NULL),(5159,3309,'EM','dlatscha@hotmail.com',0,'2013-12-25 21:15:51',NULL,NULL),(41200,27364,'EM','cfmommy96@gmail.com',0,'2014-03-04 21:01:13',NULL,NULL),(43036,28614,'TE','9408591542',0,'2014-03-08 21:30:17',NULL,NULL),(8896,5827,'TE','9564514310',0,'2013-12-25 23:48:10',NULL,NULL),(4313,2751,'AP','5132935577',0,'2013-12-25 19:49:06',NULL,NULL),(800,498,'EM','rheamrshll@yahoo.com',0,'2013-12-25 17:48:37',NULL,NULL),(7732,5047,'TE','3615426830',0,'2013-12-25 23:00:04',NULL,NULL),(3913,2483,'AP','2253230560',0,'2013-12-25 19:35:35',NULL,NULL),(6865,4454,'TE','7407490012',0,'2013-12-25 22:02:27',NULL,NULL),(27466,17693,'EM','dawnbllt@aol.com',0,'2014-01-14 01:33:01',NULL,NULL),(27906,17981,'EM','valeriehowatt@yahoo.com',0,'2014-01-15 02:06:53',NULL,NULL),(3670,2329,'TE','8063671095',0,'2013-12-25 19:31:38',NULL,NULL),(6631,4286,'EM','bwood@tfc.edu',0,'2013-12-25 21:52:06',NULL,NULL),(43033,28612,'AP','9567891196',0,'2014-03-08 21:30:16',NULL,NULL),(33640,22058,'EM','gonzalez_ninfa1@yahoo.com',0,'2014-02-08 19:00:09',NULL,NULL),(28236,18209,'TE','5137859455',0,'2014-01-15 02:08:09',NULL,NULL),(28243,18212,'EM','gilbanka@aol.com',0,'2014-01-15 02:08:10',NULL,NULL),(5069,3257,'EM','Colleenbcreamer@gmail.com',0,'2013-12-25 20:46:44',NULL,NULL),(10661,6929,'EM','er305406@ohio.edu',0,'2013-12-26 01:46:28',NULL,NULL),(11221,7300,'TE','3307013823',0,'2013-12-26 02:03:07',NULL,NULL),(11598,7544,'EM','southernbelle5629@yahoo.com',0,'2013-12-26 02:33:01',NULL,NULL),(7937,5175,'EM','vklasa@yahoo.com',0,'2013-12-25 23:03:25',NULL,NULL),(2789,1689,'TE','2258034112',0,'2013-12-25 18:54:24',NULL,NULL),(5528,3535,'EM','moredrivera@yahoo.com',0,'2013-12-25 21:21:37',NULL,NULL),(6314,4071,'TE','5137212741',0,'2013-12-25 21:46:56',NULL,NULL),(1350,823,'EM','zacharylawrence@gmail.com',0,'2013-12-25 18:06:09',NULL,NULL),(25570,16496,'AP','7403045261',0,'2014-01-07 04:06:39',NULL,NULL),(34086,22344,'AP','4199138481',0,'2014-02-10 11:01:11',NULL,NULL),(6381,4110,'AP','7402602199',0,'2013-12-25 21:47:59',NULL,NULL),(14081,9205,'AP','6625745023',0,'2013-12-26 04:09:47',NULL,NULL),(7931,5170,'TE','5138910324',0,'2013-12-25 23:03:17',NULL,NULL),(24254,15672,'AP','5672793881',1,'2014-01-02 04:34:44',NULL,NULL),(10387,6770,'TE','2258103370',0,'2013-12-26 01:16:36',NULL,NULL),(27230,17530,'AP','6012580014',0,'2014-01-13 03:01:42',NULL,NULL),(28099,18110,'AP','2253435736',0,'2014-01-15 02:07:37',NULL,NULL),(33152,21714,'EM','charleswilson1964@yahoo.com',0,'2014-02-05 21:31:16',NULL,NULL),(27498,17714,'TE','5026815042',0,'2014-01-14 01:33:11',NULL,NULL),(14333,9371,'AP','5046572246',0,'2013-12-26 04:31:49',NULL,NULL),(29443,19036,'AP','6016725980',0,'2014-01-20 08:06:35',NULL,NULL),(31726,20704,'AP','9854142561',0,'2014-01-30 21:01:05',NULL,NULL),(34197,22428,'AP','8305156481',0,'2014-02-10 21:30:35',NULL,NULL),(20518,13208,'AP','5126807882',0,'2013-12-26 12:55:10',NULL,NULL),(36996,24357,'EM','LORI13960@YAHOO.COM',0,'2014-02-18 22:00:31',NULL,NULL),(41788,27781,'AP','3302819401',0,'2014-03-05 21:31:34',NULL,NULL),(43334,28786,'EM','antwansparks27@gmail.com',0,'2014-03-09 21:00:38',NULL,NULL),(20525,13212,'AP','3252458748',0,'2013-12-26 12:55:17',NULL,NULL),(21028,13529,'AP','5049058563',0,'2013-12-26 13:03:25',NULL,NULL),(2546,1557,'AP','6624175950',0,'2013-12-25 18:50:47',NULL,NULL),(21639,13929,'AP','4193093165',0,'2013-12-26 13:14:25',NULL,NULL),(27039,17385,'EM','matthewwagner82@gmail.com',0,'2014-01-13 03:00:09',NULL,NULL),(38531,25462,'TE','9137026124',0,'2014-02-25 21:31:32',NULL,NULL),(24434,15774,'AP','2543713459',0,'2014-01-03 02:01:55',NULL,NULL),(34656,22724,'TE','2259275804',0,'2014-02-11 21:01:11',NULL,NULL),(10781,7009,'TE','9565423083',0,'2013-12-26 01:48:28',NULL,NULL),(1564,963,'TE','4792092671',0,'2013-12-25 18:09:51',NULL,NULL),(32673,21368,'TE','2549818772',0,'2014-02-04 21:00:47',NULL,NULL),(21427,13776,'AP','6013372463',0,'2013-12-26 13:10:38',NULL,NULL),(32199,21031,'EM','mizzmezz@att.net',0,'2014-02-01 19:00:44',NULL,NULL),(4678,2991,'TE','6143594959',0,'2013-12-25 20:17:27',NULL,NULL),(21493,13814,'TE','5137064792',0,'2013-12-26 13:11:41',NULL,NULL),(39537,26158,'TE','5137067295',0,'2014-02-28 06:30:31',NULL,NULL),(41707,27734,'AP','9156916275',0,'2014-03-05 21:31:05',NULL,NULL),(26195,16860,'EM','dustymadkins@yahoo.com',0,'2014-01-13 02:19:10',NULL,NULL),(10188,6657,'AP','2165019521',0,'2013-12-26 01:00:45',NULL,NULL),(23046,14864,'EM','manionconstruction@gmail.com',0,'2013-12-30 00:00:04',NULL,NULL),(2128,1311,'AP','6145848804',0,'2013-12-25 18:31:29',NULL,NULL),(2258,1384,'AP','9859745744',0,'2013-12-25 18:46:11',NULL,NULL),(5029,3225,'EM','kayla.elliot@yahoo.com',0,'2013-12-25 20:45:54',NULL,NULL),(22157,14272,'EM','tomdeb3303@gmail.com',0,'2013-12-27 02:06:07',NULL,NULL),(26634,17138,'TE','4198788700',0,'2014-01-13 02:21:50',NULL,NULL),(11685,7606,'AP','4404152141',0,'2013-12-26 02:45:32',NULL,NULL),(11466,7458,'TE','6167453898',0,'2013-12-26 02:30:50',NULL,NULL),(39335,26020,'AP','9568905499',0,'2014-02-26 21:02:15',NULL,NULL),(38835,25670,'TE','5132590291',0,'2014-02-26 08:30:52',NULL,NULL),(38044,25107,'AP','8325331909',0,'2014-02-21 21:30:13',NULL,NULL),(41036,27264,'EM','RSHELTONEPIPHANY@AOL.COM',0,'2014-03-04 21:00:11',NULL,NULL),(41498,27586,'AP','8302361263',0,'2014-03-05 21:00:14',NULL,NULL),(27106,17437,'AP','4199730977',0,'2014-01-13 03:00:34',NULL,NULL),(38023,25081,'AP','5672077032',0,'2014-02-20 22:01:38',NULL,NULL),(28712,18527,'TE','8063435301',0,'2014-01-16 08:46:41',NULL,NULL),(36899,24301,'EM','cakerns@gmail.com',0,'2014-02-18 21:30:20',NULL,NULL),(30425,19721,'TE','5045799980',0,'2014-01-23 21:00:59',NULL,NULL),(21310,13689,'EM','kathykwri@gmail.com',0,'2013-12-26 13:08:26',NULL,NULL),(40429,26838,'TE','5044363107',0,'2014-03-01 21:00:44',NULL,NULL),(21979,14158,'TE','2256787902',0,'2013-12-27 02:03:05',NULL,NULL),(13694,8928,'AP','9372415193',0,'2013-12-26 04:02:57',NULL,NULL),(9037,5931,'TE','2146973296',0,'2013-12-25 23:50:30',NULL,NULL),(8611,5658,'EM','mmhepler@hotmail.com',0,'2013-12-25 23:31:41',NULL,NULL),(7907,5152,'EM','rthomas@neo.rr.com',0,'2013-12-25 23:02:50',NULL,NULL),(27437,17674,'AP','2259395683',0,'2014-01-14 01:32:51',NULL,NULL),(12196,7970,'AP','2283552951',0,'2013-12-26 03:07:39',NULL,NULL),(21397,13758,'AP','2288616780',0,'2013-12-26 13:10:09',NULL,NULL),(34424,22581,'EM','albers.trenching.service@hotmail.com',0,'2014-02-10 21:32:03',NULL,NULL),(35012,22989,'EM','tiffanybudzinski@hotmail.com',0,'2014-02-12 21:30:13',NULL,NULL),(29357,18968,'EM','olgakovach@yahoo.com',0,'2014-01-20 08:06:00',NULL,NULL),(615,379,'TE','8305694457',0,'2013-12-25 17:45:39',NULL,NULL),(8653,5686,'TE','4193484381',0,'2013-12-25 23:32:27',NULL,NULL),(8545,5616,'AP','5135026460',0,'2013-12-25 23:30:38',NULL,NULL),(6527,4221,'AP','2818186541',0,'2013-12-25 21:50:26',NULL,NULL),(7381,4803,'AP','2252442040',0,'2013-12-25 22:16:33',NULL,NULL),(8359,5494,'EM','a-babcock@hotmail.com',0,'2013-12-25 23:11:07',NULL,NULL),(28851,18632,'EM','robntam0@gmail.com',0,'2014-01-17 03:35:02',NULL,NULL),(26968,17343,'AP','2283131798',0,'2014-01-13 02:24:04',NULL,NULL),(36828,24255,'AP','8325121408',0,'2014-02-17 19:00:06',NULL,NULL),(39257,25970,'TE','3307887364',0,'2014-02-26 21:01:46',NULL,NULL),(40874,27159,'TE','5122559517',0,'2014-03-03 21:30:58',NULL,NULL),(30563,19830,'AP','8179642045',0,'2014-01-24 21:00:19',NULL,NULL),(13708,8934,'AP','3307664108',0,'2013-12-26 04:03:08',NULL,NULL),(30241,19587,'AP','6013834357',0,'2014-01-23 03:02:43',NULL,NULL),(7884,5139,'TE','4408452041',0,'2013-12-25 23:02:29',NULL,NULL),(12014,7828,'TE','5133774734',0,'2013-12-26 03:04:21',NULL,NULL),(30099,19498,'EM','colleen.enoch@yahoo.com',0,'2014-01-23 03:02:09',NULL,NULL),(24133,15578,'TE','4192812888',1,'2014-01-02 04:32:06',NULL,NULL),(23911,15427,'EM','OLIVIATREJO1960@YAHOO.COM',1,'2014-01-02 04:27:38',NULL,NULL),(4567,2914,'TE','4408358970',0,'2013-12-25 20:15:36',NULL,NULL),(3480,2180,'TE','4196489829',0,'2013-12-25 19:19:22',NULL,NULL),(23325,15028,'TE','5042647109',0,'2014-01-01 12:02:33',NULL,NULL),(34758,22789,'TE','7403357044',0,'2014-02-11 21:01:49',NULL,NULL),(35828,23562,'TE','4199802203',0,'2014-02-13 22:02:44',NULL,NULL),(37288,24538,'TE','9563303344',0,'2014-02-20 04:01:56',NULL,NULL),(40642,26974,'EM','tmagics1@aol.com',0,'2014-03-03 01:00:36',NULL,NULL),(42438,28186,'AP','7248562145',0,'2014-03-06 21:02:57',NULL,NULL),(43544,28910,'AP','3305546885',0,'2014-03-10 21:00:27',NULL,NULL),(43704,29015,'AP','9738668512',0,'2014-03-10 21:01:26',NULL,NULL),(33318,21822,'TE','9039484532',0,'2014-02-06 21:01:00',NULL,NULL),(32733,21412,'AP','5135454437',0,'2014-02-04 21:01:09',NULL,NULL),(29628,19144,'AP','9406319234',0,'2014-01-21 08:45:30',NULL,NULL),(1013,623,'AP','7068895620',0,'2013-12-25 18:00:54',NULL,NULL),(10674,6935,'AP','9373978301',0,'2013-12-26 01:46:39',NULL,NULL),(36383,23961,'EM','davidtmartin@gmail.com',0,'2014-02-15 22:00:10',NULL,NULL),(43024,28608,'TE','6143153618',0,'2014-03-08 21:30:14',NULL,NULL),(491,313,'TE','2253337997',0,'2013-12-25 17:31:05',NULL,NULL),(25352,16349,'EM','thackerph@att.net',0,'2014-01-07 04:02:27',NULL,NULL),(9438,6178,'TE','9374425707',0,'2013-12-26 00:17:14',NULL,NULL),(24192,15628,'AP','5042142826',1,'2014-01-02 04:33:25',NULL,NULL),(5038,3233,'TE','2164528521',0,'2013-12-25 20:46:06',NULL,NULL),(22548,14543,'TE','6013730490',0,'2013-12-28 03:34:50',NULL,NULL),(6292,4054,'EM','laura.burwell@hotmail.com',0,'2013-12-25 21:46:31',NULL,NULL),(2955,1826,'TE','4198655417',0,'2013-12-25 18:57:19',NULL,NULL),(21153,13600,'EM','runknrule@gmail.com',0,'2013-12-26 13:05:25',NULL,NULL),(41826,27811,'TE','3305643272',0,'2014-03-05 21:31:50',NULL,NULL),(13701,8932,'TE','2169730614',0,'2013-12-26 04:03:03',NULL,NULL),(8608,5655,'TE','9035396279',0,'2013-12-25 23:31:37',NULL,NULL),(28390,18291,'TE','9374165891',0,'2014-01-16 08:44:52',NULL,NULL),(4484,2852,'AP','4199089073',0,'2013-12-25 20:01:25',NULL,NULL),(5944,3815,'EM','agebremariam@gmail.com',0,'2013-12-25 21:34:48',NULL,NULL),(43985,29180,'TE','7406764666',0,'2014-03-10 21:29:58',NULL,NULL),(14923,9765,'TE','4405204152',0,'2013-12-26 05:00:18',NULL,NULL),(14234,9312,'EM','marinacol013@gmail.com',0,'2013-12-26 04:30:18',NULL,NULL),(797,496,'EM','pterois@fastmail.fm',0,'2013-12-25 17:48:34',NULL,NULL),(7453,4853,'TE','9377659953',0,'2013-12-25 22:30:26',NULL,NULL),(30489,19779,'TE','4199137997',0,'2014-01-23 21:01:33',NULL,NULL),(2449,1501,'TE','5137037151',0,'2013-12-25 18:49:18',NULL,NULL),(6708,4361,'TE','5138583174',0,'2013-12-25 21:53:46',NULL,NULL),(5711,3666,'TE','6146227536',0,'2013-12-25 21:31:01',NULL,NULL),(24307,15702,'EM','sarahcumpston@yahoo.com',1,'2014-01-02 04:35:46',NULL,NULL),(28863,18637,'EM','kenishaterry@ymail.com',0,'2014-01-17 03:35:05',NULL,NULL),(29464,19048,'BN','5044512210',0,'2014-01-20 08:06:42',NULL,NULL),(30136,19521,'TE','6146222709',0,'2014-01-23 03:02:18',NULL,NULL),(37067,24408,'TE','2168565404',0,'2014-02-18 22:00:59',NULL,NULL),(42966,28572,'EM','bang@kobeaustin.com',0,'2014-03-08 21:00:03',NULL,NULL),(1196,729,'AP','7346784866',0,'2013-12-25 18:03:44',NULL,NULL),(25254,16284,'AP','5136071001',0,'2014-01-07 04:00:38',NULL,NULL),(11894,7739,'TE','3303045712',0,'2013-12-26 03:02:14',NULL,NULL),(30454,19742,'AP','5134150013',0,'2014-01-23 21:01:12',NULL,NULL),(29832,19299,'AP','2252902199',1,'2014-01-22 03:22:00',NULL,NULL),(9879,6461,'TE','3306336843',0,'2013-12-26 00:49:54',NULL,NULL),(26924,17318,'TE','9155039517',0,'2014-01-13 02:23:49',NULL,NULL),(26469,17036,'TE','2253056276',0,'2014-01-13 02:20:48',NULL,NULL),(8911,5833,'TE','3256556544',0,'2013-12-25 23:48:22',NULL,NULL),(20450,13174,'AP','3309622924',0,'2013-12-26 12:54:08',NULL,NULL),(5336,3420,'TE','2252845053',0,'2013-12-25 21:18:37',NULL,NULL),(43406,28826,'TE','4193464777',0,'2014-03-09 21:01:03',NULL,NULL),(11914,7756,'TE','2169701724',0,'2013-12-26 03:02:38',NULL,NULL),(23549,15199,'EM','kspitalo@att.net',0,'2014-01-01 12:07:22',NULL,NULL),(8503,5593,'TE','6018740645',0,'2013-12-25 23:17:20',NULL,NULL),(10703,6956,'AP','6142828494',0,'2013-12-26 01:47:11',NULL,NULL),(8715,5719,'TE','5049054669',0,'2013-12-25 23:45:21',NULL,NULL),(4502,2864,'AP','4403436326',0,'2013-12-25 20:01:43',NULL,NULL),(39287,25993,'TE','6012785654',0,'2014-02-26 21:01:58',NULL,NULL),(41401,27505,'TE','4199801332',0,'2014-03-04 21:02:30',NULL,NULL),(28942,18684,'EM','rebecca.kellar@yahoo.com',0,'2014-01-17 03:35:22',NULL,NULL),(21504,13819,'TE','3309070192',0,'2013-12-26 13:11:51',NULL,NULL),(10676,6936,'AP','9376702614',0,'2013-12-26 01:46:41',NULL,NULL),(13671,8912,'AP','2163753907',0,'2013-12-26 04:02:36',NULL,NULL),(39303,26001,'AP','2257726110',0,'2014-02-26 21:02:03',NULL,NULL),(20931,13462,'EM','sagejax@aol.com',0,'2013-12-26 13:01:47',NULL,NULL),(2353,1431,'TE','2259288515',0,'2013-12-25 18:47:34',NULL,NULL),(33996,22299,'AP','3309628587',0,'2014-02-10 11:00:36',NULL,NULL),(29017,18734,'EM','jessillewellyn@gmail.com',0,'2014-01-17 03:35:37',NULL,NULL),(35225,23135,'TE','3307339082',0,'2014-02-12 21:31:32',NULL,NULL),(35687,23474,'TE','2103492373',0,'2014-02-13 22:01:50',NULL,NULL),(3028,1886,'TE','2163371531',0,'2013-12-25 18:58:41',NULL,NULL),(25436,16402,'EM','jreagan.kfda@gmail.com',0,'2014-01-07 04:03:56',NULL,NULL),(24637,15887,'TE','9377182076',0,'2014-01-03 02:05:36',NULL,NULL),(33929,22267,'TE','7137828896',0,'2014-02-10 11:00:12',NULL,NULL),(8693,5705,'EM','maryaridge@yahoo.com',0,'2013-12-25 23:33:04',NULL,NULL),(29754,19241,'TE','3304285446',0,'2014-01-21 08:46:38',NULL,NULL),(22623,14588,'EM','ohioguylive@live.com',0,'2013-12-28 03:36:04',NULL,NULL),(29500,19069,'AP','4197058843',0,'2014-01-21 08:44:19',NULL,NULL),(37583,24760,'TE','9377257737',0,'2014-02-20 04:42:51',NULL,NULL),(42516,28278,'EM','aryancunningham@gmail.com',0,'2014-03-07 21:00:24',NULL,NULL),(23048,14866,'AP','9405943966',0,'2013-12-30 00:00:06',NULL,NULL),(32781,21447,'TE','3306771115',0,'2014-02-04 21:01:27',NULL,NULL),(28090,18106,'EM','Gigliotruckingllc@yahoo.com',0,'2014-01-15 02:07:35',NULL,NULL),(9550,6250,'EM','BNOAB@YAHOO.COM',0,'2013-12-26 00:31:57',NULL,NULL),(27127,17464,'AP','4196746743',0,'2014-01-13 03:01:05',NULL,NULL),(8950,5858,'TE','4199133263',0,'2013-12-25 23:48:59',NULL,NULL),(7793,5087,'TE','9362642600',0,'2013-12-25 23:01:06',NULL,NULL),(622,382,'TE','5044580522',0,'2013-12-25 17:45:45',NULL,NULL),(2172,1335,'EM','drwillbashor@gmail.com',0,'2013-12-25 18:32:15',NULL,NULL),(5298,3396,'AP','2252840790',0,'2013-12-25 21:18:00',NULL,NULL),(5193,3337,'TE','2147298895',0,'2013-12-25 21:16:24',NULL,NULL),(1424,867,'EM','vargasdrywall@yahoo.com',0,'2013-12-25 18:07:22',NULL,NULL),(36833,24257,'AP','9152069514',0,'2014-02-17 19:00:08',NULL,NULL),(38723,25594,'EM','kidwillis1980@gmail.com',0,'2014-02-26 08:00:45',NULL,NULL),(41348,27469,'TE','5673712384',0,'2014-03-04 21:02:10',NULL,NULL),(23317,15024,'TE','3373021735',0,'2014-01-01 12:02:25',NULL,NULL),(22805,14704,'AP','5672883978',1,'2013-12-29 11:09:10',NULL,NULL),(1286,782,'EM','thefamilywood@gmail.com',0,'2013-12-25 18:05:05',NULL,NULL),(7854,5125,'EM','carol@cbmattick.com',0,'2013-12-25 23:02:05',NULL,NULL),(41456,27548,'EM','rosey017@aol.com',0,'2014-03-04 21:30:10',NULL,NULL),(1463,895,'AP','4196562442',0,'2013-12-25 18:08:07',NULL,NULL),(25896,16691,'AP','3105294834',0,'2014-01-08 18:24:35',NULL,NULL),(27832,17933,'TE','9564552741',0,'2014-01-15 02:06:36',NULL,NULL),(5828,3741,'TE','4322630765',0,'2013-12-25 21:32:54',NULL,NULL),(7286,4746,'TE','2147918457',0,'2013-12-25 22:15:04',NULL,NULL),(10298,6720,'AP','9375100919',0,'2013-12-26 01:15:11',NULL,NULL),(39506,26131,'EM','KDAVIS5916@GMAIL.COM',0,'2014-02-28 06:30:23',NULL,NULL),(40188,26658,'TE','3309330092',0,'2014-02-28 21:31:10',NULL,NULL),(43001,28596,'TE','5133127854',0,'2014-03-08 21:30:06',NULL,NULL),(43730,29031,'AP','3308434728',0,'2014-03-10 21:01:35',NULL,NULL),(34547,22659,'AP','8067879563',0,'2014-02-11 21:00:34',NULL,NULL),(32933,21556,'EM','paul.allaer@thompsonhine.com',0,'2014-02-05 21:30:16',NULL,NULL),(26950,17331,'TE','3185901818',0,'2014-01-13 02:23:57',NULL,NULL),(26381,16981,'TE','9376950590',0,'2014-01-13 02:20:18',NULL,NULL),(10773,7003,'TE','9037694310',0,'2013-12-26 01:48:20',NULL,NULL),(4372,2787,'EM','michaelswick@aol.com',0,'2013-12-25 19:50:01',NULL,NULL),(23939,15447,'TE','9035175446',1,'2014-01-02 04:28:15',NULL,NULL),(5350,3428,'TE','3374125390',0,'2013-12-25 21:18:51',NULL,NULL),(23129,14908,'TE','2163856019',0,'2013-12-30 00:01:22',NULL,NULL),(5,4,'TE','5136753181',0,'2013-12-25 17:15:07',NULL,NULL),(25856,16666,'TE','4196735451',0,'2014-01-08 18:24:27',NULL,NULL),(26803,17240,'AP','5672424394',0,'2014-01-13 02:22:45',NULL,NULL),(14631,9566,'TE','5136771769',0,'2013-12-26 04:36:39',NULL,NULL),(31427,20486,'AP','3308585429',0,'2014-01-29 21:01:04',NULL,NULL),(22313,14384,'TE','5136830004',0,'2013-12-28 03:30:51',NULL,NULL),(6198,3993,'EM','vondy3@hotmail.com',0,'2013-12-25 21:39:10',NULL,NULL),(1982,1225,'TE','3307539798',0,'2013-12-25 18:20:32',NULL,NULL),(36522,24046,'TE','8176090303',0,'2014-02-15 22:01:01',NULL,NULL),(35312,23198,'AP','5133772996',0,'2014-02-12 21:32:07',NULL,NULL),(25136,16204,'AP','3252457847',0,'2014-01-05 00:01:14',NULL,NULL),(34435,22590,'AP','2487051007',0,'2014-02-10 21:32:09',NULL,NULL),(14699,9619,'TE','4199663314',0,'2013-12-26 04:37:51',NULL,NULL),(33560,21999,'EM','lizdieu@yahoo.com',0,'2014-02-07 19:00:47',NULL,NULL),(23498,15154,'AP','6145929616',0,'2014-01-01 12:06:10',NULL,NULL),(24013,15506,'AP','6143525678',1,'2014-01-02 04:29:53',NULL,NULL),(28469,18344,'TE','9376578097',0,'2014-01-16 08:45:19',NULL,NULL),(32179,21018,'TE','5134798388',0,'2014-02-01 19:00:38',NULL,NULL),(37422,24644,'TE','3372968586',0,'2014-02-20 04:20:54',NULL,NULL),(34886,22891,'EM','aalt6264@hotmail.com',0,'2014-02-11 21:02:37',NULL,NULL),(33349,21847,'TE','9372982072',0,'2014-02-06 21:01:13',NULL,NULL),(9287,6083,'EM','patti.mielziner@gmail.com',0,'2013-12-26 00:02:31',NULL,NULL),(3168,1985,'TE','8176816774',0,'2013-12-25 19:01:49',NULL,NULL),(13713,8936,'TE','9373717143',0,'2013-12-26 04:03:12',NULL,NULL),(33304,21809,'TE','3305842783',0,'2014-02-06 21:00:54',NULL,NULL),(2702,1642,'AP','9567467149',0,'2013-12-25 18:53:07',NULL,NULL),(28896,18655,'TE','9033735721',0,'2014-01-17 03:35:11',NULL,NULL),(30411,19710,'AP','2102844996',0,'2014-01-23 21:00:52',NULL,NULL),(599,370,'EM','elmoyer87@gmail.com',0,'2013-12-25 17:45:25',NULL,NULL),(34551,22660,'EM','marylou_mata@yahoo.com',0,'2014-02-11 21:00:35',NULL,NULL),(11848,7711,'TE','2165263952',0,'2013-12-26 03:01:30',NULL,NULL),(32536,21273,'TE','3306412700',0,'2014-02-03 21:01:32',NULL,NULL),(27874,17963,'TE','2814871987',0,'2014-01-15 02:06:46',NULL,NULL),(26982,17354,'EM','skyjazzy@netzero.com',0,'2014-01-13 02:24:10',NULL,NULL),(23340,15037,'AP','5415201465',0,'2014-01-01 12:02:50',NULL,NULL),(1370,834,'EM','dstro1269@gmail.com',0,'2013-12-25 18:06:27',NULL,NULL),(39691,26248,'EM','rvmazz92@gmail.com',0,'2014-02-28 06:31:07',NULL,NULL),(41454,27548,'TE','3309981247',0,'2014-03-04 21:30:09',NULL,NULL),(33548,21994,'TE','3183814086',0,'2014-02-07 19:00:44',NULL,NULL),(25264,16290,'TE','3308586636',0,'2014-01-07 04:00:49',NULL,NULL),(21084,13559,'AP','5046554574',0,'2013-12-26 13:04:18',NULL,NULL),(30238,19586,'TE','6013834357',0,'2014-01-23 03:02:42',NULL,NULL),(9271,6068,'AP','5134782242',0,'2013-12-26 00:02:07',NULL,NULL),(8428,5546,'EM','ann_sanders44@yahoo.com',0,'2013-12-25 23:16:00',NULL,NULL),(22769,14681,'TE','6017763236',1,'2013-12-29 11:08:34',NULL,NULL),(22966,14813,'TE','9854454748',1,'2013-12-29 11:14:08',NULL,NULL),(5054,3244,'EM','ercrknight@aol.com',0,'2013-12-25 20:46:27',NULL,NULL),(23033,14858,'TE','3304724861',1,'2013-12-29 11:15:16',NULL,NULL),(27974,18034,'TE','3302412846',0,'2014-01-15 02:07:09',NULL,NULL),(38178,25197,'TE','5166551246',0,'2014-02-21 22:00:44',NULL,NULL),(40325,26760,'TE','4192225965',0,'2014-03-01 19:00:08',NULL,NULL),(41506,27593,'TE','5134709745',0,'2014-03-05 21:00:18',NULL,NULL),(41968,27898,'TE','4193450177',0,'2014-03-05 21:32:44',NULL,NULL),(34581,22675,'EM','roxytxnag@gmail.com',0,'2014-02-11 21:00:44',NULL,NULL),(31135,20278,'TE','4192382486',0,'2014-01-28 21:00:28',NULL,NULL),(28228,18200,'AP','4198895176',0,'2014-01-15 02:08:06',NULL,NULL),(22457,14483,'TE','9722988874',0,'2013-12-28 03:33:19',NULL,NULL),(1421,866,'TE','3308650008',0,'2013-12-25 18:07:20',NULL,NULL),(37705,24860,'AP','3304210660',0,'2014-02-20 04:56:54',NULL,NULL),(39288,25993,'AP','6012785654',0,'2014-02-26 21:01:58',NULL,NULL),(39653,26220,'AP','2143542586',0,'2014-02-28 06:30:57',NULL,NULL),(31492,20522,'AP','8328912892',0,'2014-01-29 21:01:25',NULL,NULL),(28684,18508,'AP','3303190742',0,'2014-01-16 08:46:32',NULL,NULL),(2273,1392,'TE','5043248607',0,'2013-12-25 18:46:24',NULL,NULL),(6278,4049,'AP','4407141821',0,'2013-12-25 21:46:20',NULL,NULL),(11408,7424,'AP','3302424934',0,'2013-12-26 02:17:08',NULL,NULL),(42768,28446,'TE','5042963136',0,'2014-03-07 21:31:17',NULL,NULL),(43816,29084,'AP','9012688773',0,'2014-03-10 21:02:06',NULL,NULL),(24471,15793,'TE','7155710123',0,'2014-01-03 02:02:35',NULL,NULL),(32424,21186,'TE','6014989593',0,'2014-02-03 21:00:46',NULL,NULL),(28796,18583,'EM','rmarmer1@yahoo.com',0,'2014-01-16 08:47:10',NULL,NULL),(21435,13780,'TE','9372602407',0,'2013-12-26 13:10:44',NULL,NULL),(12036,7850,'EM','psbaker@woh.rr.com',0,'2013-12-26 03:04:49',NULL,NULL),(3801,2419,'TE','5138718447',0,'2013-12-25 19:33:54',NULL,NULL),(23179,14939,'AP','6507049442',0,'2013-12-30 00:02:15',NULL,NULL),(9250,6051,'EM','songbird1861@yahoo.com',0,'2013-12-26 00:01:43',NULL,NULL),(9877,6459,'TE','2165363724',0,'2013-12-26 00:49:52',NULL,NULL),(10294,6719,'TE','3302558368',0,'2013-12-26 01:15:09',NULL,NULL),(10736,6980,'EM','jbailey38@yahoo.com',0,'2013-12-26 01:47:43',NULL,NULL),(4684,2994,'EM','Johnisenbarger2@gmail.com',0,'2013-12-25 20:17:32',NULL,NULL),(3664,2326,'AP','5596965201',0,'2013-12-25 19:31:32',NULL,NULL),(36229,23844,'AP','4196779676',0,'2014-02-14 21:31:54',NULL,NULL),(21241,13653,'AP','5042729004',0,'2013-12-26 13:07:23',NULL,NULL),(32892,21531,'AP','9363660046',0,'2014-02-05 21:30:07',NULL,NULL),(22326,14392,'TE','6144465014',0,'2013-12-28 03:31:03',NULL,NULL),(3251,2047,'TE','9156919872',0,'2013-12-25 19:15:45',NULL,NULL),(882,547,'AP','4407288395',0,'2013-12-25 17:49:55',NULL,NULL),(37502,24693,'AP','5132655186',0,'2014-02-20 04:33:08',NULL,NULL),(40332,26767,'EM','hplatzr@hotmail.com',0,'2014-03-01 19:00:12',NULL,NULL),(40890,27169,'TE','9155431079',0,'2014-03-03 21:31:04',NULL,NULL),(7398,4813,'TE','5132426877',0,'2013-12-25 22:16:51',NULL,NULL),(2878,1763,'AP','9376385707',0,'2013-12-25 18:55:57',NULL,NULL),(7241,4716,'TE','5672075504',0,'2013-12-25 22:08:51',NULL,NULL),(9055,5938,'AP','2259935110',0,'2013-12-25 23:50:44',NULL,NULL),(14933,9770,'EM','renee.geib@att.net',0,'2013-12-26 05:00:27',NULL,NULL),(12169,7950,'TE','3376603027',0,'2013-12-26 03:07:08',NULL,NULL),(4199,2685,'AP','7025109507',0,'2013-12-25 19:47:21',NULL,NULL),(5863,3762,'EM','robert.knoblock@gmail.com',0,'2013-12-25 21:33:27',NULL,NULL),(37354,24593,'TE','3307582631',0,'2014-02-20 04:11:06',NULL,NULL),(41849,27829,'TE','9373014089',0,'2014-03-05 21:32:00',NULL,NULL),(42385,28151,'TE','4198763803',0,'2014-03-06 21:02:37',NULL,NULL),(1490,916,'EM','maureenf37@yahoo.com',0,'2013-12-25 18:08:42',NULL,NULL),(25909,16697,'TE','9155331813',0,'2014-01-08 18:24:37',NULL,NULL),(2817,1703,'EM','travormassey@yahoo.com',0,'2013-12-25 18:54:48',NULL,NULL),(30937,20118,'TE','6143711786',0,'2014-01-27 21:00:45',NULL,NULL),(30900,20089,'TE','2257670606',0,'2014-01-27 21:00:28',NULL,NULL),(30183,19554,'TE','2252355683',0,'2014-01-23 03:02:30',NULL,NULL),(5144,3296,'EM','mbworley@embarqmail.com',0,'2013-12-25 21:15:38',NULL,NULL),(25126,16195,'EM','r.escobar03@sbcglobal.net',0,'2014-01-05 00:00:59',NULL,NULL),(950,583,'TE','4195130520',0,'2013-12-25 17:50:59',NULL,NULL),(23940,15447,'AP','9035175446',1,'2014-01-02 04:28:16',NULL,NULL),(6602,4263,'EM','jaw1957@aol.com',0,'2013-12-25 21:51:36',NULL,NULL),(38887,25705,'TE','9035610437',0,'2014-02-26 09:30:20',NULL,NULL),(39779,26303,'TE','4193713631',0,'2014-02-28 06:31:30',NULL,NULL),(40298,26733,'AP','4195810862',0,'2014-02-28 21:31:50',NULL,NULL),(40907,27180,'TE','9405691885',0,'2014-03-03 21:31:10',NULL,NULL),(40969,27221,'AP','7692262303',0,'2014-03-03 21:31:35',NULL,NULL),(33535,21982,'AP','5042317897',0,'2014-02-07 19:00:38',NULL,NULL),(30020,19442,'TE','5137873948',0,'2014-01-23 03:01:49',NULL,NULL),(28686,18511,'AP','4199577128',0,'2014-01-16 08:46:33',NULL,NULL),(1305,795,'AP','8177767630',0,'2013-12-25 18:05:25',NULL,NULL),(7151,4662,'AP','3182825496',0,'2013-12-25 22:07:25',NULL,NULL),(42128,27985,'AP','3183122851',0,'2014-03-06 21:01:00',NULL,NULL),(43450,28856,'TE','5132668466',0,'2014-03-09 21:29:59',NULL,NULL),(43605,28950,'TE','2057674522',0,'2014-03-10 21:00:49',NULL,NULL),(31949,20855,'TE','2152152899',0,'2014-01-31 21:00:55',NULL,NULL),(29761,19244,'AP','5049523139',0,'2014-01-21 08:46:39',NULL,NULL),(6550,4233,'EM','natnorm1977@hotmail.com',0,'2013-12-25 21:50:46',NULL,NULL),(22382,14438,'TE','3373086300',0,'2013-12-28 03:32:06',NULL,NULL),(26255,16897,'TE','9375324274',0,'2014-01-13 02:19:31',NULL,NULL),(23923,15435,'TE','2543944310',1,'2014-01-02 04:27:53',NULL,NULL),(35607,23415,'AP','9157600913',0,'2014-02-13 22:01:19',NULL,NULL),(40790,27110,'AP','6304869775',0,'2014-03-03 21:30:26',NULL,NULL),(6471,4186,'TE','2166504663',0,'2013-12-25 21:49:32',NULL,NULL),(175,103,'TE','9033311776',0,'2013-12-25 17:17:47',NULL,NULL),(2683,1628,'TE','8067891785',0,'2013-12-25 18:52:46',NULL,NULL),(32646,21354,'TE','4096172140',0,'2014-02-04 21:00:39',NULL,NULL),(32063,20936,'AP','4195758075',0,'2014-01-31 21:01:40',NULL,NULL),(11910,7751,'AP','7405077619',0,'2013-12-26 03:02:31',NULL,NULL),(24008,15495,'AP','3302681707',1,'2014-01-02 04:29:39',NULL,NULL),(31175,20302,'BN','8176290722',0,'2014-01-28 21:00:44',NULL,NULL),(30052,19465,'TE','8308727645',0,'2014-01-23 03:01:57',NULL,NULL),(36182,23814,'AP','3307494618',0,'2014-02-14 21:31:37',NULL,NULL),(41991,27910,'AP','9567758455',0,'2014-03-06 21:00:15',NULL,NULL),(22113,14243,'TE','3617726780',0,'2013-12-27 02:05:19',NULL,NULL),(30906,20093,'TE','2257675404',0,'2014-01-27 21:00:31',NULL,NULL),(928,572,'TE','5133880254',0,'2013-12-25 17:50:38',NULL,NULL),(14945,9776,'AP','5139074511',0,'2013-12-26 05:00:37',NULL,NULL),(28761,18559,'AP','9377799127',0,'2014-01-16 08:46:58',NULL,NULL),(26139,16827,'TE','3306265661',0,'2014-01-13 02:18:26',NULL,NULL),(9455,6187,'EM','cmcollander@gmail.com',0,'2013-12-26 00:30:15',NULL,NULL),(30706,19948,'AP','9374810182',0,'2014-01-24 21:01:19',NULL,NULL),(8609,5655,'AP','9035396279',0,'2013-12-25 23:31:37',NULL,NULL),(35447,23306,'EM','cstuckert@gmail.com',0,'2014-02-13 22:00:18',NULL,NULL),(36136,23782,'AP','9379355445',0,'2014-02-14 21:31:20',NULL,NULL),(38446,25407,'AP','2165348821',0,'2014-02-25 21:31:00',NULL,NULL),(22882,14765,'TE','7138822519',1,'2013-12-29 11:12:46',NULL,NULL),(388,237,'TE','4193437312',0,'2013-12-25 17:21:12',NULL,NULL),(31372,20447,'AP','2144998883',0,'2014-01-29 21:00:43',NULL,NULL),(883,547,'EM','Sircubano@gmail.com',0,'2013-12-25 17:49:55',NULL,NULL),(974,598,'TE','6142078672',0,'2013-12-25 18:00:16',NULL,NULL),(29467,19050,'TE','5043770292',0,'2014-01-20 08:06:44',NULL,NULL),(20708,13310,'AP','3614449431',0,'2013-12-26 12:58:05',NULL,NULL),(4715,3016,'EM','tadrake53@yahoo.com',0,'2013-12-25 20:18:03',NULL,NULL),(14587,9537,'TE','8124304464',0,'2013-12-26 04:35:57',NULL,NULL),(14493,9468,'TE','6148771130',0,'2013-12-26 04:34:22',NULL,NULL),(35057,23021,'TE','3615713454',0,'2014-02-12 21:30:30',NULL,NULL),(36216,23838,'TE','5133167999',0,'2014-02-14 21:31:50',NULL,NULL),(39037,25813,'AP','3302076728',0,'2014-02-26 21:00:23',NULL,NULL),(39673,26231,'EM','ahern464@aol.com',0,'2014-02-28 06:31:01',NULL,NULL),(40820,27124,'EM','swaggervrent@gmail.com',0,'2014-03-03 21:30:36',NULL,NULL),(13940,9091,'TE','7409819019',0,'2013-12-26 04:07:06',NULL,NULL),(24156,15610,'EM','MindyRutkowski@yahoo.com',1,'2014-01-02 04:32:48',NULL,NULL),(11652,7585,'EM','RSWLRussell@gmail.com',0,'2013-12-26 02:34:03',NULL,NULL),(11991,7811,'AP','2818891600',0,'2013-12-26 03:03:58',NULL,NULL),(7596,4945,'EM','maria_domin@att.net',0,'2013-12-25 22:45:47',NULL,NULL),(35894,23611,'AP','9374074091',0,'2014-02-13 22:03:12',NULL,NULL),(521,327,'TE','9372183480',0,'2013-12-25 17:31:33',NULL,NULL),(10900,7083,'TE','7406673810',0,'2013-12-26 01:50:21',NULL,NULL),(3064,1906,'AP','4192047446',0,'2013-12-25 18:59:16',NULL,NULL),(30455,19743,'TE','5134044660',0,'2014-01-23 21:01:13',NULL,NULL),(29852,19315,'TE','3614423955',1,'2014-01-22 03:22:08',NULL,NULL),(2430,1487,'EM','c.dortch@att.net',0,'2013-12-25 18:48:57',NULL,NULL),(14331,9370,'AP','5048109868',0,'2013-12-26 04:31:48',NULL,NULL),(29837,19301,'AP','2259534398',1,'2014-01-22 03:22:01',NULL,NULL),(1567,965,'AP','9724155299',0,'2013-12-25 18:09:53',NULL,NULL),(20950,13475,'EM','drdearing@aol.com',0,'2013-12-26 13:02:06',NULL,NULL),(29072,18777,'TE','5136254325',0,'2014-01-17 03:35:51',NULL,NULL),(26611,17121,'TE','7402596306',0,'2014-01-13 02:21:42',NULL,NULL),(10113,6612,'TE','4192221419',0,'2013-12-26 00:53:47',NULL,NULL),(11544,7514,'TE','2257786775',0,'2013-12-26 02:32:11',NULL,NULL),(36065,23720,'EM','martinmchenry63@yahoo.com',0,'2014-02-14 21:30:52',NULL,NULL),(44014,29211,'AP','8172537476',0,'2014-03-10 21:30:16',NULL,NULL),(184,109,'TE','9407676370',0,'2013-12-25 17:17:56',NULL,NULL),(35222,23133,'EM','krystalburchette@yahoo.com',0,'2014-02-12 21:31:31',NULL,NULL),(34360,22538,'TE','6018626183',0,'2014-02-10 21:31:37',NULL,NULL),(2575,1570,'EM','nhattich@yahoo.com',0,'2013-12-25 18:51:11',NULL,NULL),(4273,2732,'TE','3186353323',0,'2013-12-25 19:48:30',NULL,NULL),(22400,14446,'AP','5049755849',0,'2013-12-28 03:32:21',NULL,NULL),(22390,14442,'TE','5043199598',0,'2013-12-28 03:32:13',NULL,NULL),(35331,23215,'EM','bertfriedman@comcast.net',0,'2014-02-12 21:32:16',NULL,NULL),(40324,26759,'EM','webbalanwright@yahoo.com',0,'2014-03-01 19:00:07',NULL,NULL),(455,287,'TE','8327776071',0,'2013-12-25 17:30:26',NULL,NULL),(25482,16431,'AP','4197795212',0,'2014-01-07 04:04:49',NULL,NULL),(30531,19805,'AP','8306837200',0,'2014-01-24 21:00:06',NULL,NULL),(3967,2518,'TE','3303284085',0,'2013-12-25 19:36:31',NULL,NULL),(9714,6360,'TE','3306220968',0,'2013-12-26 00:47:19',NULL,NULL),(9801,6411,'EM','irene_motto@yahoo.com',0,'2013-12-26 00:48:38',NULL,NULL),(28677,18500,'EM','thggrimm64@gmail.com',0,'2014-01-16 08:46:29',NULL,NULL),(2444,1498,'AP','5132844030',0,'2013-12-25 18:49:14',NULL,NULL),(38236,25242,'EM','peterulrick@yahoo.com',0,'2014-02-21 22:01:09',NULL,NULL),(38481,25430,'AP','8177167358',0,'2014-02-25 21:31:14',NULL,NULL),(39892,26400,'TE','3304648849',0,'2014-02-28 07:00:30',NULL,NULL),(41054,27275,'EM','anointed@taylortel.net',0,'2014-03-04 21:00:18',NULL,NULL),(42404,28164,'AP','9376313752',0,'2014-03-06 21:02:44',NULL,NULL),(42989,28591,'EM','jaknghts44@aol.com',0,'2014-03-08 21:30:02',NULL,NULL),(1716,1052,'AP','8304566079',0,'2013-12-25 18:16:05',NULL,NULL),(28810,18596,'AP','5135058830',0,'2014-01-16 08:47:16',NULL,NULL),(24271,15684,'AP','4192620332',1,'2014-01-02 04:35:07',NULL,NULL),(8799,5764,'TE','2162297823',0,'2013-12-25 23:46:36',NULL,NULL),(7186,4683,'TE','2027316766',0,'2013-12-25 22:07:57',NULL,NULL),(26723,17187,'EM','airc@wt.net',0,'2014-01-13 02:22:16',NULL,NULL),(41959,27893,'TE','5672781279',0,'2014-03-05 21:32:40',NULL,NULL),(335,209,'EM','mariea_ross@yahoo.com',0,'2013-12-25 17:20:25',NULL,NULL),(22796,14700,'TE','4408435723',1,'2013-12-29 11:09:02',NULL,NULL),(9683,6344,'EM','gregjackson@columbus.rr.com',0,'2013-12-26 00:46:51',NULL,NULL),(7655,4982,'AP','9152535151',0,'2013-12-25 22:46:46',NULL,NULL),(22688,14633,'EM','avatar2011@gmail.com',0,'2013-12-28 03:37:15',NULL,NULL),(14804,9690,'TE','4192040926',0,'2013-12-26 04:39:41',NULL,NULL),(21817,14057,'TE','4195643297',0,'2013-12-27 02:00:27',NULL,NULL),(21541,13848,'AP','4194662309',0,'2013-12-26 13:12:32',NULL,NULL),(23445,15111,'EM','jewel.mills28@yahoo.com',0,'2014-01-01 12:04:58',NULL,NULL),(14060,9191,'TE','4194946433',0,'2013-12-26 04:09:23',NULL,NULL),(33807,22198,'AP','4404549454',0,'2014-02-09 19:00:13',NULL,NULL),(31814,20771,'EM','barbaracarter905@yahoo.com',0,'2014-01-30 21:01:40',NULL,NULL),(29827,19297,'AP','5044182143',1,'2014-01-22 03:21:59',NULL,NULL),(6876,4459,'EM','edwarren77@yahoo.com',0,'2013-12-25 22:02:37',NULL,NULL),(37118,24437,'AP','3309310646',0,'2014-02-18 22:01:16',NULL,NULL),(39143,25890,'TE','3615374336',0,'2014-02-26 21:01:03',NULL,NULL),(39508,26134,'TE','6143167646',0,'2014-02-28 06:30:23',NULL,NULL),(89,53,'EM','bcast8411@gmail.com',0,'2013-12-25 17:16:27',NULL,NULL),(3818,2430,'TE','4407281055',0,'2013-12-25 19:34:09',NULL,NULL),(3398,2136,'TE','9542240619',0,'2013-12-25 19:18:07',NULL,NULL),(2213,1361,'TE','9033662669',0,'2013-12-25 18:45:30',NULL,NULL),(7239,4714,'TE','4193480854',0,'2013-12-25 22:08:48',NULL,NULL),(31390,20458,'TE','2163238699',0,'2014-01-29 21:00:50',NULL,NULL),(30718,19958,'TE','2543155100',0,'2014-01-25 19:00:06',NULL,NULL),(28802,18587,'EM','LAYERS@SUPERIORCAREPLUS.COM',0,'2014-01-16 08:47:12',NULL,NULL),(29959,19386,'EM','JAG1955@ROADRUNNER.COM',1,'2014-01-22 03:22:45',NULL,NULL),(30344,19663,'AP','5134044660',0,'2014-01-23 21:00:26',NULL,NULL),(36892,24298,'TE','4695441911',0,'2014-02-18 21:30:18',NULL,NULL),(43039,28615,'AP','9729891290',0,'2014-03-08 21:30:18',NULL,NULL),(32330,21119,'EM','babygirl0766@gmail.com',0,'2014-02-03 21:00:12',NULL,NULL),(2279,1398,'TE','3184859860',0,'2013-12-25 18:46:32',NULL,NULL),(13790,8989,'EM','l_lee3286@hotmail.com',0,'2013-12-26 04:04:32',NULL,NULL),(22522,14521,'EM','challis.susan@gmail.com',0,'2013-12-28 03:34:19',NULL,NULL),(40288,26724,'TE','9727932685',0,'2014-02-28 21:31:46',NULL,NULL),(42351,28127,'EM','bobcthn8@gmail.com',0,'2014-03-06 21:02:23',NULL,NULL),(2451,1505,'AP','4156372412',0,'2013-12-25 18:49:21',NULL,NULL),(27518,17726,'EM','dave@answerglobal.com',0,'2014-01-14 01:33:17',NULL,NULL),(11045,7171,'AP','2164103859',0,'2013-12-26 01:52:43',NULL,NULL),(26460,17032,'EM','time4u72@yahoo.com',0,'2014-01-13 02:20:45',NULL,NULL),(23500,15156,'AP','6142645285',0,'2014-01-01 12:06:13',NULL,NULL),(5143,3296,'TE','5139327917',0,'2013-12-25 21:15:37',NULL,NULL),(5825,3740,'TE','8303778409',0,'2013-12-25 21:32:51',NULL,NULL),(36050,23712,'TE','3305340224',0,'2014-02-14 21:30:48',NULL,NULL),(25756,16597,'AP','5043339962',0,'2014-01-08 18:24:03',NULL,NULL),(33588,22020,'TE','2813822686',0,'2014-02-07 19:00:58',NULL,NULL),(29763,19245,'TE','6019064794',0,'2014-01-21 08:46:40',NULL,NULL),(703,435,'TE','4409495716',0,'2013-12-25 17:47:03',NULL,NULL),(8303,5439,'EM','indirachakravarty@hotmail.com',0,'2013-12-25 23:09:54',NULL,NULL),(12066,7877,'AP','5136161593',0,'2013-12-26 03:05:20',NULL,NULL),(37017,24372,'TE','9855189357',0,'2014-02-18 22:00:39',NULL,NULL),(38524,25458,'AP','2815127772',0,'2014-02-25 21:31:30',NULL,NULL),(39255,25969,'TE','3307887364',0,'2014-02-26 21:01:46',NULL,NULL),(40139,26622,'TE','8322839318',0,'2014-02-28 21:30:53',NULL,NULL),(41832,27813,'AP','3308146178',0,'2014-03-05 21:31:52',NULL,NULL),(41986,27908,'AP','8179649286',0,'2014-03-06 21:00:13',NULL,NULL),(43075,28638,'TE','2544344151',0,'2014-03-08 21:30:31',NULL,NULL),(24564,15844,'EM','kellysfitlifestyle@gmail.com',0,'2014-01-03 02:04:15',NULL,NULL),(14186,9283,'AP','4043379092',0,'2013-12-26 04:15:56',NULL,NULL),(14909,9755,'AP','4326147331',0,'2013-12-26 05:00:03',NULL,NULL),(37495,24689,'AP','9567401351',0,'2014-02-20 04:32:16',NULL,NULL),(38883,25699,'AP','3256433248',0,'2014-02-26 09:30:18',NULL,NULL),(26328,16948,'EM','Tamikaj601@yahoo.com',0,'2014-01-13 02:19:58',NULL,NULL),(33207,21745,'AP','5127508605',0,'2014-02-06 21:00:17',NULL,NULL),(2880,1764,'TE','3103467943',0,'2013-12-25 18:55:59',NULL,NULL),(12299,8044,'AP','3305543065',0,'2013-12-26 03:09:30',NULL,NULL),(40863,27154,'TE','5135785333',0,'2014-03-03 21:30:54',NULL,NULL),(23210,14956,'TE','2543508809',0,'2014-01-01 12:00:23',NULL,NULL),(25163,16221,'TE','5132181864',0,'2014-01-05 00:01:49',NULL,NULL),(14848,9716,'EM','mphillips12@cinci.rr.com',0,'2013-12-26 04:45:21',NULL,NULL),(35146,23081,'TE','3302532538',0,'2014-02-12 21:31:03',NULL,NULL),(7901,5149,'TE','6142641084',0,'2013-12-25 23:02:45',NULL,NULL),(23188,14944,'TE','4195770358',0,'2013-12-30 00:02:25',NULL,NULL),(29957,19385,'EM','CHEEKCOREY31@YAHOO.COM',1,'2014-01-22 03:22:44',NULL,NULL),(36614,24105,'EM','partynanna@sbcglobal.net',0,'2014-02-15 22:01:33',NULL,NULL),(36742,24189,'TE','6822342762',0,'2014-02-16 19:00:13',NULL,NULL),(38790,25645,'TE','5136751832',0,'2014-02-26 08:30:34',NULL,NULL),(41028,27260,'TE','5132802580',0,'2014-03-03 21:31:59',NULL,NULL),(9445,6183,'TE','2162291317',0,'2013-12-26 00:30:07',NULL,NULL),(4523,2876,'TE','2104990297',0,'2013-12-25 20:02:04',NULL,NULL),(34314,22514,'TE','2545419663',0,'2014-02-10 21:31:21',NULL,NULL),(31875,20807,'TE','8325428012',0,'2014-01-31 21:00:25',NULL,NULL),(8506,5594,'AP','3182184962',0,'2013-12-25 23:30:03',NULL,NULL),(31798,20758,'TE','4193488794',0,'2014-01-30 21:01:33',NULL,NULL),(28535,18391,'EM','micghr@comcast.net',0,'2014-01-16 08:45:40',NULL,NULL),(26237,16886,'AP','3617423746',0,'2014-01-13 02:19:24',NULL,NULL),(36733,24185,'AP','5135157945',0,'2014-02-16 19:00:10',NULL,NULL),(40156,26633,'EM','jessemonsivaisjr@gmail.com',0,'2014-02-28 21:30:59',NULL,NULL),(40763,27087,'AP','3306077559',0,'2014-03-03 21:30:15',NULL,NULL),(41164,27339,'TE','2169051823',0,'2014-03-04 21:00:58',NULL,NULL),(42131,27987,'TE','3373911357',0,'2014-03-06 21:01:01',NULL,NULL),(42398,28160,'AP','4192311464',0,'2014-03-06 21:02:41',NULL,NULL),(34297,22503,'AP','4405673862',0,'2014-02-10 21:31:14',NULL,NULL),(31771,20739,'AP','9376214672',0,'2014-01-30 21:01:22',NULL,NULL),(3751,2379,'TE','4406285248',0,'2013-12-25 19:32:59',NULL,NULL),(5472,3503,'TE','9373251349',0,'2013-12-25 21:20:46',NULL,NULL),(2658,1614,'TE','9156139224',0,'2013-12-25 18:52:24',NULL,NULL),(7630,4970,'EM','resendisjcbusiness@yahoo.com',0,'2013-12-25 22:46:25',NULL,NULL),(11940,7775,'AP','8322838634',0,'2013-12-26 03:03:03',NULL,NULL),(30313,19637,'TE','6148372870',0,'2014-01-23 21:00:13',NULL,NULL),(27891,17972,'TE','3306788383',0,'2014-01-15 02:06:50',NULL,NULL),(28833,18613,'AP','4196199227',0,'2014-01-16 08:47:24',NULL,NULL),(38154,25182,'TE','4408674470',0,'2014-02-21 22:00:34',NULL,NULL),(41792,27784,'AP','2282979179',0,'2014-03-05 21:31:36',NULL,NULL),(33317,21821,'BN','4195516940',0,'2014-02-06 21:01:00',NULL,NULL),(29899,19348,'TE','5136041132',1,'2014-01-22 03:22:25',NULL,NULL),(5010,3216,'TE','3303282630',0,'2013-12-25 20:45:34',NULL,NULL),(887,549,'EM','lauriedruck@earthlink.net',0,'2013-12-25 17:49:59',NULL,NULL),(41101,27300,'TE','3252761056',0,'2014-03-04 21:00:34',NULL,NULL),(43310,28772,'TE','6144323079',0,'2014-03-09 21:00:30',NULL,NULL),(33853,22223,'TE','3303389392',0,'2014-02-09 19:00:28',NULL,NULL),(14327,9368,'TE','2253549139',0,'2013-12-26 04:31:44',NULL,NULL),(7778,5073,'EM','faribab26@yahoo.com',0,'2013-12-25 23:00:48',NULL,NULL),(5628,3607,'AP','3306080398',0,'2013-12-25 21:23:23',NULL,NULL),(37184,24476,'EM','frankcivitaresejr@yahoo.com',0,'2014-02-18 22:01:42',NULL,NULL),(38566,25487,'TE','6014162077',0,'2014-02-25 21:31:46',NULL,NULL),(39265,25977,'AP','5136286016',0,'2014-02-26 21:01:50',NULL,NULL),(39533,26150,'TE','2167892581',0,'2014-02-28 06:30:29',NULL,NULL),(31806,20767,'AP','7186124922',0,'2014-01-30 21:01:37',NULL,NULL),(27856,17946,'TE','2106859341',0,'2014-01-15 02:06:41',NULL,NULL),(25575,16498,'AP','9378316516',0,'2014-01-07 04:06:45',NULL,NULL),(25534,16472,'AP','2165485666',0,'2014-01-07 04:05:59',NULL,NULL),(22971,14815,'AP','5139673682',1,'2013-12-29 11:14:12',NULL,NULL),(9090,5957,'TE','4197045087',0,'2013-12-25 23:51:18',NULL,NULL),(41636,27678,'EM','JANA.SHOEMAKER@YAHOO.COM',0,'2014-03-05 21:30:37',NULL,NULL),(34519,22645,'AP','8328596352',0,'2014-02-11 21:00:24',NULL,NULL),(33343,21842,'TE','4198775953',0,'2014-02-06 21:01:11',NULL,NULL),(14192,9286,'TE','3302734951',0,'2013-12-26 04:16:02',NULL,NULL),(14916,9758,'AP','4403829830',0,'2013-12-26 05:00:10',NULL,NULL),(29344,18961,'TE','9564599231',0,'2014-01-20 08:05:55',NULL,NULL),(2981,1846,'TE','3306904087',0,'2013-12-25 18:57:47',NULL,NULL),(6919,4506,'TE','8327442761',0,'2013-12-25 22:03:30',NULL,NULL),(38116,25159,'TE','9562626622',0,'2014-02-21 22:00:21',NULL,NULL),(39345,26025,'EM','WILLIAMS.ASHLEY2646@YAHOO.COM',0,'2014-02-26 21:02:18',NULL,NULL),(35551,23378,'AP','3305737953',0,'2014-02-13 22:00:58',NULL,NULL),(4034,2576,'EM','bonafide_nyer@yahoo.com',0,'2013-12-25 19:37:50',NULL,NULL),(3981,2525,'EM','Anmaghiar@gmail.com',0,'2013-12-25 19:36:42',NULL,NULL),(3262,2052,'TE','6143528229',0,'2013-12-25 19:15:54',NULL,NULL),(34757,22788,'TE','4199564710',0,'2014-02-11 21:01:48',NULL,NULL),(36440,23996,'TE','2028126520',0,'2014-02-15 22:00:30',NULL,NULL),(39100,25869,'TE','5046214456',0,'2014-02-26 21:00:49',NULL,NULL),(39241,25959,'TE','9372545987',0,'2014-02-26 21:01:41',NULL,NULL),(41247,27404,'TE','2167856615',0,'2014-03-04 21:01:32',NULL,NULL),(42958,28567,'EM','ashindeldecker@embarqmail.com',0,'2014-03-07 21:32:29',NULL,NULL),(43827,29090,'AP','2102901428',0,'2014-03-10 21:02:09',NULL,NULL),(43977,29173,'EM','BECKS935@YAHOO.COM',0,'2014-03-10 21:03:01',NULL,NULL),(3641,2304,'AP','9376043293',0,'2013-12-25 19:31:04',NULL,NULL),(9662,6326,'TE','7405373738',0,'2013-12-26 00:46:29',NULL,NULL),(12195,7970,'TE','2283552951',0,'2013-12-26 03:07:39',NULL,NULL),(10359,6754,'TE','3306761909',0,'2013-12-26 01:16:09',NULL,NULL),(5034,3228,'TE','9374747068',0,'2013-12-25 20:45:59',NULL,NULL),(4969,3188,'EM','yorkbrigg@hotmail.com',0,'2013-12-25 20:32:03',NULL,NULL),(34000,22301,'TE','3303090862',0,'2014-02-10 11:00:37',NULL,NULL),(34797,22828,'TE','3306010185',0,'2014-02-11 21:02:05',NULL,NULL),(27964,18029,'TE','5136809761',0,'2014-01-15 02:07:07',NULL,NULL),(25086,16174,'TE','2253615221',0,'2014-01-05 00:00:19',NULL,NULL),(20311,13090,'AP','2163265115',0,'2013-12-26 12:51:51',NULL,NULL),(14572,9528,'EM','Jojopb71@hotmail.com',0,'2013-12-26 04:35:44',NULL,NULL),(14111,9227,'EM','meyeball@roadrunner.com',0,'2013-12-26 04:10:23',NULL,NULL),(11422,7430,'EM','mwb45@zips.uakron.edu',0,'2013-12-26 02:30:08',NULL,NULL),(4980,3199,'TE','3308023127',0,'2013-12-25 20:45:06',NULL,NULL),(34974,22962,'AP','6012149442',0,'2014-02-12 21:00:10',NULL,NULL),(35686,23473,'EM','deckerator@gmail.com',0,'2014-02-13 22:01:50',NULL,NULL),(36991,24354,'TE','3375434640',0,'2014-02-18 22:00:29',NULL,NULL),(39589,26189,'AP','2162552025',0,'2014-02-28 06:30:44',NULL,NULL),(40029,26532,'AP','6146261146',0,'2014-02-28 21:30:03',NULL,NULL),(40468,26862,'AP','8322641182',0,'2014-03-01 21:00:57',NULL,NULL),(42732,28422,'TE','7409740843',0,'2014-03-07 21:31:04',NULL,NULL),(42809,28468,'EM','atwt92@aol.com',0,'2014-03-07 21:31:30',NULL,NULL),(23285,15003,'AP','2818818825',0,'2014-01-01 12:01:47',NULL,NULL),(14943,9775,'AP','5044914112',0,'2013-12-26 05:00:35',NULL,NULL),(2456,1508,'AP','9376233664',0,'2013-12-25 18:49:26',NULL,NULL),(42411,28167,'TE','2252646655',0,'2014-03-06 21:02:46',NULL,NULL),(43770,29055,'EM','kevinstinson68@yahoo.com',0,'2014-03-10 21:01:49',NULL,NULL),(995,613,'TE','3309298807',0,'2013-12-25 18:00:38',NULL,NULL),(21861,14083,'AP','4403710083',0,'2013-12-27 02:01:09',NULL,NULL),(9404,6155,'TE','4196282479',0,'2013-12-26 00:16:38',NULL,NULL),(13891,9057,'TE','8082260393',0,'2013-12-26 04:06:14',NULL,NULL),(21068,13549,'EM','cindygdenney@hotmail.com',0,'2013-12-26 13:04:03',NULL,NULL),(3268,2055,'EM','llt43@aol.com',0,'2013-12-25 19:15:59',NULL,NULL),(10994,7141,'EM','buflohotel@aol.com',0,'2013-12-26 01:51:54',NULL,NULL),(11217,7296,'AP','4405370689',0,'2013-12-26 02:03:01',NULL,NULL),(12150,7938,'TE','9856527666',0,'2013-12-26 03:06:48',NULL,NULL),(35883,23597,'AP','4194340312',0,'2014-02-13 22:03:06',NULL,NULL),(32053,20924,'TE','3309457616',0,'2014-01-31 21:01:34',NULL,NULL),(10739,6981,'EM','dttfamily@yahoo.com',0,'2013-12-26 01:47:45',NULL,NULL),(11898,7740,'EM','swimchessveg@gmail.com',0,'2013-12-26 03:02:16',NULL,NULL),(30804,20030,'TE','2252186541',0,'2014-01-26 19:00:19',NULL,NULL),(26509,17057,'EM','ellams_denise@yahoo.com',0,'2014-01-13 02:21:09',NULL,NULL),(11070,7189,'AP','5132566228',0,'2013-12-26 02:00:23',NULL,NULL),(1449,883,'EM','gmabowman4@gmail.com',0,'2013-12-25 18:07:48',NULL,NULL),(23373,15058,'TE','2258925411',0,'2014-01-01 12:03:27',NULL,NULL),(1967,1217,'TE','9372222482',0,'2013-12-25 18:20:17',NULL,NULL),(2103,1300,'TE','2819927249',0,'2013-12-25 18:31:09',NULL,NULL),(2119,1307,'TE','5044013921',0,'2013-12-25 18:31:22',NULL,NULL),(11051,7177,'TE','9376722738',0,'2013-12-26 02:00:07',NULL,NULL),(3900,2476,'TE','2256540558',0,'2013-12-25 19:35:23',NULL,NULL),(38609,25517,'EM','rettadirck@gmail.com',0,'2014-02-25 21:32:04',NULL,NULL),(40058,26560,'TE','6149299591',0,'2014-02-28 21:30:19',NULL,NULL),(42874,28513,'TE','3305024898',0,'2014-03-07 21:31:55',NULL,NULL),(9864,6451,'TE','4193511557',0,'2013-12-26 00:49:40',NULL,NULL),(22905,14776,'EM','DEA57ARMOUR@GMAIL.COM',1,'2013-12-29 11:13:07',NULL,NULL),(33426,21897,'AP','3304663614',0,'2014-02-06 21:01:44',NULL,NULL),(2284,1401,'TE','7655058493',0,'2013-12-25 18:46:36',NULL,NULL),(31618,20624,'EM','ERIKAPORRAS24@GMAIL.COM',0,'2014-01-30 21:00:25',NULL,NULL),(4860,3111,'AP','9373445262',0,'2013-12-25 20:20:33',NULL,NULL),(7935,5173,'TE','6142842195',0,'2013-12-25 23:03:22',NULL,NULL),(24795,15995,'AP','9035633096',0,'2014-01-04 02:01:21',NULL,NULL),(29577,19111,'TE','9377078597',0,'2014-01-21 08:44:45',NULL,NULL),(38690,25569,'BN','5132840751',0,'2014-02-26 08:00:29',NULL,NULL),(39123,25878,'EM','mustafa.hammad10@gmail.com',0,'2014-02-26 21:00:56',NULL,NULL),(39839,26350,'TE','4192176488',0,'2014-02-28 06:31:47',NULL,NULL),(41266,27423,'AP','2254543016',0,'2014-03-04 21:01:40',NULL,NULL),(5081,3261,'EM','Djhar@live.com',0,'2013-12-25 20:46:54',NULL,NULL),(196,120,'TE','3617394288',0,'2013-12-25 17:18:09',NULL,NULL),(6441,4162,'AP','5134460522',0,'2013-12-25 21:49:01',NULL,NULL),(3756,2382,'TE','6148435765',0,'2013-12-25 19:33:04',NULL,NULL),(14491,9466,'EM','jkernst@earthlink.net',0,'2013-12-26 04:34:20',NULL,NULL),(38432,25398,'EM','jewels@unlimitedcruises.com',0,'2014-02-25 21:30:55',NULL,NULL),(39297,25997,'AP','3184691914',0,'2014-02-26 21:02:01',NULL,NULL),(41558,27630,'EM','btf3eternal@gmail.com',0,'2014-03-05 21:30:10',NULL,NULL),(33443,21906,'TE','6624174644',0,'2014-02-06 21:01:50',NULL,NULL),(26727,17190,'TE','4197385390',0,'2014-01-13 02:22:18',NULL,NULL),(1460,894,'TE','9373669113',0,'2013-12-25 18:08:05',NULL,NULL),(8455,5562,'TE','5133899868',0,'2013-12-25 23:16:29',NULL,NULL),(23591,15232,'EM','rlewi35@yahoo.com',0,'2014-01-01 12:08:19',NULL,NULL),(5087,3264,'TE','3309459042',0,'2013-12-25 20:47:00',NULL,NULL),(14157,9267,'TE','4402130488',0,'2013-12-26 04:15:31',NULL,NULL),(39448,26089,'TE','3373220100',0,'2014-02-28 06:30:08',NULL,NULL),(1145,705,'TE','5042581293',0,'2013-12-25 18:03:01',NULL,NULL),(24140,15586,'AP','5133484108',1,'2014-01-02 04:32:20',NULL,NULL),(3732,2369,'EM','djraymond081850@gmail.com',0,'2013-12-25 19:32:42',NULL,NULL),(6111,3932,'EM','bleach3605@aol.com',0,'2013-12-25 21:37:41',NULL,NULL),(10233,6691,'TE','2166318985',0,'2013-12-26 01:01:35',NULL,NULL),(2269,1389,'AP','2257177758',0,'2013-12-25 18:46:20',NULL,NULL),(35062,23025,'TE','8063003202',0,'2014-02-12 21:30:32',NULL,NULL),(982,605,'AP','2165712289',0,'2013-12-25 18:00:25',NULL,NULL),(23088,14891,'TE','2254392872',0,'2013-12-30 00:00:48',NULL,NULL),(1727,1058,'AP','2108317457',0,'2013-12-25 18:16:14',NULL,NULL),(2618,1593,'TE','2546243723',0,'2013-12-25 18:51:49',NULL,NULL),(29990,19416,'TE','6014413572',1,'2014-01-22 03:23:00',NULL,NULL),(4155,2651,'TE','8174544683',0,'2013-12-25 19:46:37',NULL,NULL),(24915,16061,'TE','4400339942',0,'2014-01-04 02:03:31',NULL,NULL),(25814,16641,'AP','5135084648',0,'2014-01-08 18:24:17',NULL,NULL),(34802,22830,'TE','3303100462',0,'2014-02-11 21:02:06',NULL,NULL),(35544,23373,'BN','5134850560',0,'2014-02-13 22:00:55',NULL,NULL),(38216,25225,'TE','3307152701',0,'2014-02-21 22:00:59',NULL,NULL),(38710,25586,'TE','9852498103',0,'2014-02-26 08:00:40',NULL,NULL),(41757,27766,'AP','5044358685',0,'2014-03-05 21:31:24',NULL,NULL),(625,383,'AP','9567891365',0,'2013-12-25 17:45:47',NULL,NULL),(30888,20076,'EM','reidwfrederick@aol.com',0,'2014-01-27 21:00:21',NULL,NULL),(1877,1158,'AP','3372885315',0,'2013-12-25 18:18:49',NULL,NULL),(30570,19834,'AP','8178816605',0,'2014-01-24 21:00:21',NULL,NULL),(35492,23336,'EM','angelsheppy@yahoo.com',0,'2014-02-13 22:00:35',NULL,NULL),(39647,26218,'TE','3306221743',0,'2014-02-28 06:30:56',NULL,NULL),(1673,1026,'AP','9156268124',0,'2013-12-25 18:15:24',NULL,NULL),(24136,15580,'AP','5132365984',1,'2014-01-02 04:32:11',NULL,NULL),(20283,13074,'TE','9373860402',0,'2013-12-26 12:51:24',NULL,NULL),(27142,17477,'EM','sa@stephanieadams.me',0,'2014-01-13 03:01:10',NULL,NULL),(11697,7615,'TE','3302441839',0,'2013-12-26 02:45:46',NULL,NULL),(28288,18236,'TE','9035705560',0,'2014-01-16 08:44:22',NULL,NULL),(9594,6282,'TE','5134854408',0,'2013-12-26 00:45:23',NULL,NULL),(9064,5942,'EM','mjm4mjm@hotmail.com',0,'2013-12-25 23:50:52',NULL,NULL),(1931,1196,'TE','2345674247',0,'2013-12-25 18:19:45',NULL,NULL),(5352,3428,'EM','cailet_kvothe@icloud.com',0,'2013-12-25 21:18:52',NULL,NULL),(4028,2572,'TE','4196689306',0,'2013-12-25 19:37:42',NULL,NULL),(34709,22757,'AP','3187809287',0,'2014-02-11 21:01:30',NULL,NULL),(36023,23694,'TE','3309283431',0,'2014-02-14 21:30:39',NULL,NULL),(41598,27658,'AP','9376542662',0,'2014-03-05 21:30:25',NULL,NULL),(14798,9685,'EM','kcaldwell@fuse.net',0,'2013-12-26 04:39:34',NULL,NULL),(33196,21737,'AP','9797776107',0,'2014-02-06 21:00:13',NULL,NULL),(11216,7296,'TE','4404378776',0,'2013-12-26 02:03:01',NULL,NULL),(9359,6127,'TE','4096989104',0,'2013-12-26 00:15:54',NULL,NULL),(30170,19547,'AP','6627018310',0,'2014-01-23 03:02:27',NULL,NULL),(1640,1007,'EM','bettymatson82@gmail.com',0,'2013-12-25 18:11:08',NULL,NULL),(11681,7604,'TE','3303165908',0,'2013-12-26 02:45:28',NULL,NULL),(1548,954,'TE','4404947115',0,'2013-12-25 18:09:36',NULL,NULL),(37876,24986,'TE','9159207795',0,'2014-02-20 22:00:37',NULL,NULL),(38042,25101,'AP','2547231669',0,'2014-02-21 21:30:10',NULL,NULL),(38679,25564,'TE','9364330289',0,'2014-02-26 08:00:25',NULL,NULL),(2051,1270,'TE','9569097356',0,'2013-12-25 18:30:14',NULL,NULL),(25480,16430,'TE','3186351819',0,'2014-01-07 04:04:46',NULL,NULL),(25261,16287,'AP','9375438243',0,'2014-01-07 04:00:44',NULL,NULL),(33447,21909,'TE','9375493770',0,'2014-02-06 21:01:52',NULL,NULL),(29842,19307,'AP','2256140785',1,'2014-01-22 03:22:04',NULL,NULL),(3272,2058,'TE','4403275957',0,'2013-12-25 19:16:03',NULL,NULL),(8121,5318,'TE','2164648923',0,'2013-12-25 23:06:45',NULL,NULL),(29139,18823,'EM','renda_owens@yahoo.com',0,'2014-01-17 03:36:07',NULL,NULL),(28548,18404,'TE','5137025258',0,'2014-01-16 08:45:44',NULL,NULL),(28364,18276,'EM','blduszik@gmail.com',0,'2014-01-16 08:44:44',NULL,NULL),(35438,23301,'AP','6144042307',0,'2014-02-13 22:00:14',NULL,NULL),(41269,27424,'AP','8057295929',0,'2014-03-04 21:01:41',NULL,NULL),(31952,20866,'TE','4194644937',0,'2014-01-31 21:00:58',NULL,NULL),(25789,16618,'AP','9377508294',0,'2014-01-08 18:24:10',NULL,NULL),(27931,17994,'EM','jmaier949@yahoo.com',0,'2014-01-15 02:06:58',NULL,NULL),(27499,17714,'AP','5026815042',0,'2014-01-14 01:33:11',NULL,NULL),(2148,1324,'TE','3182074590',0,'2013-12-25 18:31:51',NULL,NULL),(12414,8131,'EM','sberihun27@yahoo.com',0,'2013-12-26 03:15:32',NULL,NULL),(36668,24142,'TE','5135286372',0,'2014-02-15 22:01:52',NULL,NULL),(38508,25448,'EM','jeffdvsn@yahoo.com',0,'2014-02-25 21:31:24',NULL,NULL),(34251,22468,'TE','6016844740',0,'2014-02-10 21:30:56',NULL,NULL),(29420,19020,'AP','9015987927',0,'2014-01-20 08:06:25',NULL,NULL),(27425,17665,'TE','5132755620',0,'2014-01-14 01:32:46',NULL,NULL),(3750,2378,'EM','michellemurphy@att.net',0,'2013-12-25 19:32:57',NULL,NULL),(43289,28761,'TE','8062237108',0,'2014-03-09 21:00:22',NULL,NULL),(43631,28961,'AP','5042360583',0,'2014-03-10 21:00:57',NULL,NULL),(34240,22457,'AP','9038758097',0,'2014-02-10 21:30:50',NULL,NULL),(8698,5708,'EM','mackenvie.pfahler@yahoo.com',0,'2013-12-25 23:45:04',NULL,NULL),(10076,6587,'TE','5133242999',0,'2013-12-26 00:53:08',NULL,NULL),(33838,22215,'TE','9852248201',0,'2014-02-09 19:00:23',NULL,NULL),(10652,6926,'TE','5138844449',0,'2013-12-26 01:46:22',NULL,NULL),(32088,20956,'EM','barbarakwhitley@yahoo.com',0,'2014-02-01 19:00:07',NULL,NULL),(31240,20345,'AP','2283839628',0,'2014-01-28 21:01:10',NULL,NULL),(30365,19671,'AP','3612072671',0,'2014-01-23 21:00:32',NULL,NULL),(39760,26294,'TE','4194510111',0,'2014-02-28 06:31:25',NULL,NULL),(513,322,'AP','5132271328',0,'2013-12-25 17:31:24',NULL,NULL),(29733,19226,'EM','rachelkrash@yahoo.com',0,'2014-01-21 08:46:30',NULL,NULL),(4283,2736,'AP','3183479069',0,'2013-12-25 19:48:38',NULL,NULL),(11590,7542,'TE','3613454588',0,'2013-12-26 02:32:56',NULL,NULL),(36989,24352,'EM','edhardy814@yahoo.com',0,'2014-02-18 22:00:27',NULL,NULL),(38581,25498,'TE','4095504817',0,'2014-02-25 21:31:53',NULL,NULL),(26157,16841,'BN','3306069956',0,'2014-01-13 02:18:34',NULL,NULL),(5120,3279,'TE','4806210880',0,'2013-12-25 21:15:14',NULL,NULL),(3449,2160,'EM','tmlogging@aol.com',0,'2013-12-25 19:18:52',NULL,NULL),(36185,23817,'TE','4199343257',0,'2014-02-14 21:31:38',NULL,NULL),(42305,28090,'AP','6016721409',0,'2014-03-06 21:02:04',NULL,NULL),(23452,15115,'TE','3306521695',0,'2014-01-01 12:05:06',NULL,NULL),(14905,9753,'TE','3308292929',0,'2013-12-26 04:46:17',NULL,NULL),(14756,9651,'TE','4192040926',0,'2013-12-26 04:38:47',NULL,NULL),(10125,6620,'EM','Samanthanj13@gmail.com',0,'2013-12-26 00:54:02',NULL,NULL),(7627,4968,'EM','J.jernigan65@yahoo.com',0,'2013-12-25 22:46:22',NULL,NULL),(7421,4826,'TE','4195845058',0,'2013-12-25 22:17:13',NULL,NULL),(13789,8988,'TE','5137714087',0,'2013-12-26 04:04:31',NULL,NULL),(36877,24288,'AP','7697987804',0,'2014-02-18 21:30:11',NULL,NULL),(38077,25135,'AP','9725138745',0,'2014-02-21 22:00:06',NULL,NULL),(2102,1299,'TE','3307551745',0,'2013-12-25 18:31:06',NULL,NULL),(32991,21604,'TE','3304315879',0,'2014-02-05 21:30:32',NULL,NULL),(32484,21226,'AP','4193412580',0,'2014-02-03 21:01:06',NULL,NULL),(22743,14668,'AP','3252364169',1,'2013-12-29 11:08:10',NULL,NULL),(27587,17784,'TE','4192039514',0,'2014-01-14 01:33:44',NULL,NULL),(27372,17621,'AP','8172285287',0,'2014-01-14 01:32:27',NULL,NULL),(35876,23592,'AP','3309886397',0,'2014-02-13 22:03:03',NULL,NULL),(40274,26716,'AP','6015730910',0,'2014-02-28 21:31:42',NULL,NULL),(41534,27620,'TE','5042370130',0,'2014-03-05 21:30:03',NULL,NULL),(41537,27621,'AP','2252769084',0,'2014-03-05 21:30:04',NULL,NULL),(42477,28233,'EM','martin.megan@gmail.com',0,'2014-03-06 21:30:24',NULL,NULL),(43032,28612,'TE','9567891196',0,'2014-03-08 21:30:16',NULL,NULL),(23161,14929,'AP','7132613323',0,'2013-12-30 00:01:57',NULL,NULL),(34056,22328,'TE','5134444750',0,'2014-02-10 11:00:59',NULL,NULL),(21035,13534,'TE','5042729341',0,'2013-12-26 13:03:33',NULL,NULL),(37392,24623,'TE','6019830020',0,'2014-02-20 04:16:32',NULL,NULL),(39253,25968,'TE','7405253034',0,'2014-02-26 21:01:45',NULL,NULL),(42472,28221,'TE','7402749338',0,'2014-03-06 21:30:19',NULL,NULL),(43967,29168,'TE','5704197178',0,'2014-03-10 21:02:58',NULL,NULL),(501,317,'TE','3302681789',0,'2013-12-25 17:31:14',NULL,NULL),(8218,5379,'TE','3182210513',0,'2013-12-25 23:08:19',NULL,NULL),(7707,5032,'TE','5135530912',0,'2013-12-25 22:47:47',NULL,NULL),(7165,4672,'EM','lexiecooper3@yahoo.com',0,'2013-12-25 22:07:40',NULL,NULL),(32057,20931,'EM','streetglidejimmy@hotmail.com',0,'2014-01-31 21:01:37',NULL,NULL),(10263,6705,'AP','6065842041',0,'2013-12-26 01:02:03',NULL,NULL),(14948,9778,'TE','5136480320',0,'2013-12-26 05:00:41',NULL,NULL),(31893,20816,'AP','6463464742',0,'2014-01-31 21:00:32',NULL,NULL),(5660,3634,'TE','6016183330',0,'2013-12-25 21:30:13',NULL,NULL),(3172,1989,'TE','8176816774',0,'2013-12-25 19:01:54',NULL,NULL),(31327,20415,'AP','4193413104',0,'2014-01-29 21:00:27',NULL,NULL),(26847,17272,'TE','3303367175',0,'2014-01-13 02:23:22',NULL,NULL),(27491,17708,'AP','5046572147',0,'2014-01-14 01:33:08',NULL,NULL),(30583,19842,'AP','5042298045',0,'2014-01-24 21:00:26',NULL,NULL),(36202,23831,'TE','6012126548',0,'2014-02-14 21:31:46',NULL,NULL),(40435,26843,'AP','5046508498',0,'2014-03-01 21:00:46',NULL,NULL),(24495,15802,'AP','9853188130',0,'2014-01-03 02:02:55',NULL,NULL),(34877,22880,'TE','3302563654',0,'2014-02-11 21:02:33',NULL,NULL),(31623,20628,'TE','9562515235',0,'2014-01-30 21:00:27',NULL,NULL),(24444,15780,'EM','aileenbrom@gmail.com',0,'2014-01-03 02:02:07',NULL,NULL),(14618,9557,'AP','5133140073',0,'2013-12-26 04:36:27',NULL,NULL),(36889,24295,'TE','3305453198',0,'2014-02-18 21:30:16',NULL,NULL),(42244,28060,'EM','jmc3352@yahoo.com',0,'2014-03-06 21:01:43',NULL,NULL),(43130,28670,'AP','2256107749',0,'2014-03-08 21:30:49',NULL,NULL),(43733,29033,'TE','6142962422',0,'2014-03-10 21:01:36',NULL,NULL),(33908,22257,'AP','2542213272',0,'2014-02-10 11:00:05',NULL,NULL),(29492,19060,'AP','9154497671',0,'2014-01-21 08:44:15',NULL,NULL),(26784,17231,'TE','6013717679',0,'2014-01-13 02:22:40',NULL,NULL),(8480,5579,'TE','4194389189',0,'2013-12-25 23:16:53',NULL,NULL),(6539,4228,'AP','2148812664',0,'2013-12-25 21:50:38',NULL,NULL),(891,552,'TE','8176050939',0,'2013-12-25 17:50:04',NULL,NULL),(14501,9473,'TE','5135821377',0,'2013-12-26 04:34:29',NULL,NULL),(23044,14864,'TE','2149571010',0,'2013-12-30 00:00:03',NULL,NULL),(2264,1387,'AP','2252393196',0,'2013-12-25 18:46:16',NULL,NULL),(3552,2225,'TE','4192832409',0,'2013-12-25 19:20:37',NULL,NULL),(37349,24589,'AP','2167121160',0,'2014-02-20 04:10:30',NULL,NULL),(41747,27762,'AP','5043385515',0,'2014-03-05 21:31:21',NULL,NULL),(44001,29194,'AP','4146904684',0,'2014-03-10 21:30:07',NULL,NULL),(22238,14332,'AP','4197070483',0,'2013-12-27 02:07:36',NULL,NULL),(25774,16609,'TE','6143275627',0,'2014-01-08 18:24:07',NULL,NULL),(26757,17211,'TE','3307450566',0,'2014-01-13 02:22:29',NULL,NULL),(34864,22865,'AP','6019545154',0,'2014-02-11 21:02:27',NULL,NULL),(34798,22828,'AP','3212981369',0,'2014-02-11 21:02:05',NULL,NULL),(29282,18913,'TE','9372125513',0,'2014-01-17 03:36:41',NULL,NULL),(28511,18378,'TE','3306992408',0,'2014-01-16 08:45:33',NULL,NULL),(14135,9257,'TE','9152535151',0,'2013-12-26 04:15:11',NULL,NULL),(1107,679,'TE','3303127825',0,'2013-12-25 18:02:21',NULL,NULL),(24872,16039,'TE','4098666953',0,'2014-01-04 02:02:46',NULL,NULL),(27412,17657,'TE','7404776329',0,'2014-01-14 01:32:43',NULL,NULL),(6727,4371,'AP','6142862357',0,'2013-12-25 22:00:19',NULL,NULL),(5926,3800,'AP','2165133447',0,'2013-12-25 21:34:30',NULL,NULL),(22258,14344,'TE','3307500414',0,'2013-12-27 02:07:58',NULL,NULL),(31699,20677,'AP','6015064270',0,'2014-01-30 21:00:53',NULL,NULL),(14568,9520,'TE','4199663314',0,'2013-12-26 04:35:37',NULL,NULL),(26125,16821,'EM','neshabyrd@yahoo.com',0,'2014-01-13 02:18:22',NULL,NULL),(43214,28718,'TE','5133351223',0,'2014-03-08 21:31:18',NULL,NULL),(35195,23116,'TE','3133003336',0,'2014-02-12 21:31:21',NULL,NULL),(23079,14883,'EM','djblairq@gmail.com',0,'2013-12-30 00:00:36',NULL,NULL),(37887,24994,'TE','2143349988',0,'2014-02-20 22:00:42',NULL,NULL),(30875,20069,'EM','cervenyruze0506@yahoo.com',0,'2014-01-27 21:00:16',NULL,NULL),(33491,21945,'EM','katieg.role@yahoo.com',0,'2014-02-07 19:00:18',NULL,NULL),(11957,7789,'TE','8068728284',0,'2013-12-26 03:03:23',NULL,NULL),(39223,25944,'AP','6142030130',0,'2014-02-26 21:01:33',NULL,NULL),(316,194,'TE','4195427894',0,'2013-12-25 17:20:03',NULL,NULL),(8089,5294,'TE','4408823552',0,'2013-12-25 23:06:07',NULL,NULL),(27579,17775,'TE','7134649277',0,'2014-01-14 01:33:40',NULL,NULL),(36449,24001,'AP','5132922388',0,'2014-02-15 22:00:33',NULL,NULL),(31889,20813,'AP','4195755546',0,'2014-01-31 21:00:30',NULL,NULL),(31364,20439,'EM','Tmason448@gmail.com',0,'2014-01-29 21:00:40',NULL,NULL),(28921,18673,'AP','8635348529',0,'2014-01-17 03:35:17',NULL,NULL),(41609,27664,'TE','9376540441',0,'2014-03-05 21:30:29',NULL,NULL),(24178,15621,'AP','6623471619',1,'2014-01-02 04:33:10',NULL,NULL),(29354,18966,'AP','3612431147',0,'2014-01-20 08:05:59',NULL,NULL),(30236,19585,'TE','6019641472',0,'2014-01-23 03:02:42',NULL,NULL),(30969,20145,'TE','2162462380',0,'2014-01-27 21:01:00',NULL,NULL),(36203,23831,'AP','6012126548',0,'2014-02-14 21:31:46',NULL,NULL),(40223,26682,'TE','2252844878',0,'2014-02-28 21:31:23',NULL,NULL),(433,267,'TE','4402189734',0,'2013-12-25 17:21:59',NULL,NULL),(8222,5382,'TE','3375784353',0,'2013-12-25 23:08:24',NULL,NULL),(31462,20505,'AP','5042088928',0,'2014-01-29 21:01:15',NULL,NULL),(22982,14824,'TE','9725676116',1,'2013-12-29 11:14:23',NULL,NULL),(24936,16074,'AP','7402442480',0,'2014-01-04 02:03:54',NULL,NULL),(7042,4600,'TE','9373651489',0,'2013-12-25 22:05:41',NULL,NULL),(2228,1369,'TE','5126579217',0,'2013-12-25 18:45:43',NULL,NULL),(14082,9205,'EM','rakeshmaisuria72@gmail.com',0,'2013-12-26 04:09:48',NULL,NULL),(1441,878,'AP','9376992337',0,'2013-12-25 18:07:39',NULL,NULL),(24328,15716,'TE','4194480129',1,'2014-01-02 04:36:14',NULL,NULL),(28605,18437,'AP','5046572147',0,'2014-01-16 08:46:02',NULL,NULL),(37143,24449,'TE','3184499345',0,'2014-02-18 22:01:25',NULL,NULL),(7094,4630,'AP','6622300938',0,'2013-12-25 22:06:31',NULL,NULL),(7914,5157,'AP','6145805632',0,'2013-12-25 23:02:58',NULL,NULL),(36787,24221,'AP','7136799843',0,'2014-02-16 19:00:28',NULL,NULL),(42138,27992,'TE','2163856042',0,'2014-03-06 21:01:04',NULL,NULL),(43749,29044,'TE','4402132430',0,'2014-03-10 21:01:42',NULL,NULL),(24324,15714,'EM','charleskitchingham@gmail.com',1,'2014-01-02 04:36:09',NULL,NULL),(3486,2182,'AP','2547180631',0,'2013-12-25 19:19:27',NULL,NULL),(2290,1404,'TE','7013402473',0,'2013-12-25 18:46:42',NULL,NULL),(4956,3181,'TE','3185078376',0,'2013-12-25 20:31:51',NULL,NULL),(22027,14185,'EM','moralesandres256@gmail.com',0,'2013-12-27 02:03:50',NULL,NULL),(21479,13800,'TE','6014244400',0,'2013-12-26 13:11:22',NULL,NULL),(31526,20544,'TE','4195092043',0,'2014-01-29 21:01:37',NULL,NULL),(23381,15061,'AP','3372788918',0,'2014-01-01 12:03:35',NULL,NULL),(40849,27143,'AP','5138864646',0,'2014-03-03 21:30:48',NULL,NULL),(1314,803,'TE','7138420102',0,'2013-12-25 18:05:37',NULL,NULL),(27627,17808,'EM','OVATIONS25@SCBGLOBALS.NET',0,'2014-01-15 02:05:52',NULL,NULL),(2634,1602,'AP','9565328256',0,'2013-12-25 18:52:05',NULL,NULL),(10070,6584,'TE','5134624316',0,'2013-12-26 00:53:03',NULL,NULL),(9566,6265,'TE','5133930345',0,'2013-12-26 00:32:22',NULL,NULL),(577,356,'AP','2282171378',0,'2013-12-25 17:32:27',NULL,NULL),(34917,22912,'TE','5134073582',0,'2014-02-11 21:02:49',NULL,NULL),(32167,21013,'AP','6146482484',0,'2014-02-01 19:00:35',NULL,NULL),(5600,3586,'TE','5139228057',0,'2013-12-25 21:22:51',NULL,NULL),(9400,6152,'TE','7138622015',0,'2013-12-26 00:16:33',NULL,NULL),(3292,2069,'AP','2253855745',0,'2013-12-25 19:16:21',NULL,NULL),(11362,7400,'EM','sapphireblu2000@gmail.com',0,'2013-12-26 02:16:24',NULL,NULL),(11282,7353,'EM','cboehme76@yahoo.com',0,'2013-12-26 02:15:11',NULL,NULL),(28274,18231,'AP','5128220604',0,'2014-01-16 08:44:19',NULL,NULL),(31165,20296,'TE','3183228606',0,'2014-01-28 21:00:40',NULL,NULL),(32503,21243,'TE','3309906535',0,'2014-02-03 21:01:14',NULL,NULL),(42907,28533,'EM','scocco_t@msn.com',0,'2014-03-07 21:32:09',NULL,NULL),(25795,16622,'AP','9548018213',0,'2014-01-08 18:24:12',NULL,NULL),(39357,26030,'EM','martwainw@gmail.com',0,'2014-02-26 21:02:21',NULL,NULL),(22936,14798,'TE','4403812357',1,'2013-12-29 11:13:40',NULL,NULL),(36178,23811,'TE','3308441008',0,'2014-02-14 21:31:35',NULL,NULL),(5107,3274,'EM','nessabutterfly80@gmail.com',0,'2013-12-25 21:15:04',NULL,NULL),(14686,9610,'TE','3304525556',0,'2013-12-26 04:37:37',NULL,NULL),(6080,3913,'EM','rblanca4@gmail.com',0,'2013-12-25 21:37:10',NULL,NULL),(7258,4733,'AP','4192049439',0,'2013-12-25 22:09:12',NULL,NULL),(7262,4735,'TE','4193480854',0,'2013-12-25 22:09:15',NULL,NULL),(21116,13577,'EM','dilmabollat@yahoo.com',0,'2013-12-26 13:04:48',NULL,NULL),(21591,13892,'AP','4199065482',0,'2013-12-26 13:13:30',NULL,NULL),(3536,2211,'EM','dkeeton2004@yahoo.com',0,'2013-12-25 19:20:18',NULL,NULL),(34088,22345,'TE','3306209445',0,'2014-02-10 11:01:11',NULL,NULL),(30599,19855,'EM','jrevans3@gmail.com',0,'2014-01-24 21:00:33',NULL,NULL),(28856,18635,'AP','2545410965',0,'2014-01-17 03:35:04',NULL,NULL),(29302,18933,'TE','2162123312',0,'2014-01-20 08:05:39',NULL,NULL),(27662,17831,'EM','Val376@gmail.com',0,'2014-01-15 02:06:00',NULL,NULL),(27035,17383,'AP','4194672270',0,'2014-01-13 03:00:08',NULL,NULL),(38810,25659,'AP','4196513824',0,'2014-02-26 08:30:44',NULL,NULL),(24679,15916,'TE','9565481088',0,'2014-01-03 02:06:29',NULL,NULL),(9128,5977,'AP','3477122298',0,'2013-12-25 23:51:51',NULL,NULL),(24859,16031,'TE','2252064357',0,'2014-01-04 02:02:30',NULL,NULL),(7674,4997,'AP','4405035944',0,'2013-12-25 22:47:04',NULL,NULL),(4895,3140,'AP','8325815170',0,'2013-12-25 20:30:48',NULL,NULL),(5707,3663,'AP','5132926152',0,'2013-12-25 21:30:57',NULL,NULL),(1777,1097,'EM','rralphe2003@aol.com',0,'2013-12-25 18:17:11',NULL,NULL),(5786,3707,'EM','sp@neo.rr.com',0,'2013-12-25 21:32:08',NULL,NULL),(40447,26852,'TE','6625885732',0,'2014-03-01 21:00:51',NULL,NULL),(39044,25820,'EM','DOZIERLI23@GMAIL.COM',0,'2014-02-26 21:00:26',NULL,NULL),(4765,3051,'AP','3376551763',0,'2013-12-25 20:18:54',NULL,NULL),(22834,14728,'AP','2257733411',1,'2013-12-29 11:09:44',NULL,NULL),(37220,24494,'EM','ouchley.laura@yahoo.com',0,'2014-02-20 03:46:18',NULL,NULL),(34291,22499,'TE','9376683050',0,'2014-02-10 21:31:12',NULL,NULL),(27063,17407,'TE','9568620687',0,'2014-01-13 03:00:19',NULL,NULL),(33618,22046,'EM','embank@lusfiber.net',0,'2014-02-07 19:30:04',NULL,NULL),(31653,20650,'AP','7604641456',0,'2014-01-30 21:00:38',NULL,NULL),(31981,20880,'TE','4197331352',0,'2014-01-31 21:01:08',NULL,NULL),(41570,27640,'TE','5135211861',0,'2014-03-05 21:30:15',NULL,NULL),(41938,27880,'BN','4197717934',0,'2014-03-05 21:32:32',NULL,NULL),(4004,2545,'AP','3306184326',0,'2013-12-25 19:37:09',NULL,NULL),(11247,7320,'EM','kevinwdobbs@att.net',0,'2013-12-26 02:03:37',NULL,NULL),(40333,26768,'TE','3306960612',0,'2014-03-01 19:00:12',NULL,NULL),(1245,757,'TE','8179999282',0,'2013-12-25 18:04:27',NULL,NULL),(9418,6164,'TE','9375470457',0,'2013-12-26 00:16:53',NULL,NULL),(39787,26307,'TE','3616528119',0,'2014-02-28 06:31:32',NULL,NULL),(38561,25482,'TE','5133159929',0,'2014-02-25 21:31:44',NULL,NULL),(21242,13653,'TE','5042729004',0,'2013-12-26 13:07:23',NULL,NULL),(22414,14455,'TE','9319808803',0,'2013-12-28 03:32:36',NULL,NULL),(5345,3424,'EM','lilaleg40@yahoo.com',0,'2013-12-25 21:18:45',NULL,NULL),(39179,25914,'EM','kathleentsmith@hotmail.com',0,'2014-02-26 21:01:16',NULL,NULL),(4759,3049,'TE','5049197727',0,'2013-12-25 20:18:50',NULL,NULL),(38983,25779,'EM','sharellwilson89@gmail.com',0,'2014-02-26 09:31:00',NULL,NULL),(35388,23257,'EM','Amemon2005@yahoo.com',0,'2014-02-13 21:30:08',NULL,NULL),(6330,4081,'TE','3308823997',0,'2013-12-25 21:47:12',NULL,NULL),(4275,2732,'EM','mecasmith@bellsouth.net',0,'2013-12-25 19:48:31',NULL,NULL),(22397,14445,'AP','3377729147',0,'2013-12-28 03:32:19',NULL,NULL),(31782,20746,'AP','4192643852',0,'2014-01-30 21:01:27',NULL,NULL),(23952,15454,'TE','8174227866',1,'2014-01-02 04:28:28',NULL,NULL),(29316,18945,'TE','2145172462',0,'2014-01-20 08:05:45',NULL,NULL),(41658,27693,'AP','9569295021',0,'2014-03-05 21:30:45',NULL,NULL),(39604,26198,'AP','3303481476',0,'2014-02-28 06:30:47',NULL,NULL),(28831,18611,'EM','BENPOLZIN@HOTMAIL.COM',0,'2014-01-16 08:47:23',NULL,NULL),(10771,7002,'AP','2145350453',0,'2013-12-26 01:48:18',NULL,NULL),(28201,18177,'TE','4199832300',0,'2014-01-15 02:07:59',NULL,NULL),(23249,14982,'TE','8176029368',0,'2014-01-01 12:01:07',NULL,NULL),(9730,6368,'TE','5134233040',0,'2013-12-26 00:47:33',NULL,NULL),(7785,5082,'AP','8303343828',0,'2013-12-25 23:00:59',NULL,NULL),(41432,27525,'TE','4197049694',0,'2014-03-04 21:02:43',NULL,NULL),(35333,23217,'TE','6013987545',0,'2014-02-12 21:32:17',NULL,NULL),(33670,22086,'AP','9852711204',0,'2014-02-08 19:00:21',NULL,NULL),(5320,3410,'AP','3375150562',0,'2013-12-25 21:18:22',NULL,NULL),(23832,15375,'TE','4193502409',1,'2014-01-02 04:25:14',NULL,NULL),(3636,2300,'AP','3304216277',0,'2013-12-25 19:30:59',NULL,NULL),(39436,26082,'EM','flyyboo@gmail.com',0,'2014-02-28 06:30:05',NULL,NULL),(39404,26055,'EM','eliejr00@hotmail.com',0,'2014-02-26 21:02:36',NULL,NULL),(1744,1075,'TE','3302422474',0,'2013-12-25 18:16:37',NULL,NULL),(37200,24485,'AP','9854454155',0,'2014-02-20 03:42:09',NULL,NULL),(4744,3039,'TE','4196512932',0,'2013-12-25 20:18:36',NULL,NULL),(8696,5708,'TE','3306440443',0,'2013-12-25 23:45:03',NULL,NULL),(36058,23718,'AP','5133491088',0,'2014-02-14 21:30:50',NULL,NULL),(24199,15634,'TE','3186788774',1,'2014-01-02 04:33:34',NULL,NULL),(25067,16159,'AP','6143162702',0,'2014-01-04 06:00:10',NULL,NULL),(32076,20947,'TE','4194260017',0,'2014-01-31 21:01:46',NULL,NULL),(5310,3403,'AP','2259369369',0,'2013-12-25 21:18:11',NULL,NULL),(36432,23993,'AP','5042733758',0,'2014-02-15 22:00:28',NULL,NULL),(32457,21206,'TE','2256246085',0,'2014-02-03 21:00:56',NULL,NULL),(32278,21086,'TE','5134760676',0,'2014-02-02 19:00:24',NULL,NULL),(2882,1764,'EM','christinanapier@gmail.com',0,'2013-12-25 18:56:00',NULL,NULL),(29548,19095,'EM','vance.brenda@yahoo.com',0,'2014-01-21 08:44:35',NULL,NULL),(11676,7600,'AP','4405216728',0,'2013-12-26 02:45:22',NULL,NULL),(12409,8125,'AP','5138287700',0,'2013-12-26 03:15:23',NULL,NULL),(27557,17759,'TE','9373862740',0,'2014-01-14 01:33:33',NULL,NULL),(25754,16596,'AP','3373498174',0,'2014-01-08 18:24:02',NULL,NULL),(40613,26959,'EM','lesleechilberti@yahoo.com',0,'2014-03-03 01:00:30',NULL,NULL),(41124,27316,'EM','lisadams95@yahoo.com',0,'2014-03-04 21:00:43',NULL,NULL),(35608,23415,'EM','NFACIO15@GMAIL.COM',0,'2014-02-13 22:01:19',NULL,NULL),(27865,17955,'AP','5126737180',0,'2014-01-15 02:06:44',NULL,NULL),(42227,28051,'AP','6019181442',0,'2014-03-06 21:01:38',NULL,NULL),(6143,3955,'AP','3306222919',0,'2013-12-25 21:38:17',NULL,NULL),(9938,6503,'EM','karenjacob1407@gmail.com',0,'2013-12-26 00:50:55',NULL,NULL),(38321,25318,'TE','5046100739',0,'2014-02-25 21:30:06',NULL,NULL),(35870,23590,'TE','3306064277',0,'2014-02-13 22:03:01',NULL,NULL),(7816,5103,'TE','4322518315',0,'2013-12-25 23:01:29',NULL,NULL),(33896,22248,'TE','4196661154',0,'2014-02-09 19:00:41',NULL,NULL),(4584,2925,'EM','dentar99@yahoo.com',0,'2013-12-25 20:15:53',NULL,NULL),(32305,21099,'EM','gregmc2370@gmail.com',0,'2014-02-02 19:00:34',NULL,NULL),(1020,628,'TE','6142583767',0,'2013-12-25 18:01:02',NULL,NULL),(12428,8139,'TE','9377370039',0,'2013-12-26 03:15:45',NULL,NULL),(30831,20044,'TE','4193044894',0,'2014-01-26 19:00:29',NULL,NULL),(24050,15529,'TE','2252796829',1,'2014-01-02 04:30:34',NULL,NULL),(24241,15660,'TE','8063177480',1,'2014-01-02 04:34:26',NULL,NULL),(27365,17616,'EM','leepreynolds@gmail.com',0,'2014-01-14 01:32:25',NULL,NULL),(29598,19125,'AP','4403449475',0,'2014-01-21 08:45:20',NULL,NULL),(29726,19222,'TE','3306962169',0,'2014-01-21 08:46:27',NULL,NULL),(37239,24505,'AP','8322731147',0,'2014-02-20 03:50:49',NULL,NULL),(32360,21145,'AP','4322138828',0,'2014-02-03 21:00:24',NULL,NULL),(8603,5652,'EM','etorres691@hotmail.com',0,'2013-12-25 23:31:33',NULL,NULL),(30414,19711,'EM','patriciavergil@yahoo.com',0,'2014-01-23 21:00:53',NULL,NULL),(26605,17113,'AP','4199669051',0,'2014-01-13 02:21:39',NULL,NULL),(42745,28431,'TE','4408454304',0,'2014-03-07 21:31:09',NULL,NULL),(39477,26107,'EM','falcon_price@yahoo.com',0,'2014-02-28 06:30:15',NULL,NULL),(10547,6868,'TE','9405671526',0,'2013-12-26 01:31:54',NULL,NULL),(1376,840,'AP','9376549005',0,'2013-12-25 18:06:36',NULL,NULL),(11696,7614,'EM','regina.luttrell@earthlink.net',0,'2013-12-26 02:45:44',NULL,NULL),(2065,1277,'TE','6143064339',0,'2013-12-25 18:30:28',NULL,NULL),(7631,4971,'TE','9728352275',0,'2013-12-25 22:46:27',NULL,NULL),(5681,3648,'AP','2168496368',0,'2013-12-25 21:30:35',NULL,NULL),(34204,22431,'TE','8174046109',0,'2014-02-10 21:30:37',NULL,NULL),(28311,18249,'TE','4692980695',0,'2014-01-16 08:44:29',NULL,NULL),(4203,2687,'AP','2544983624',0,'2013-12-25 19:47:24',NULL,NULL),(27943,18006,'TE','9376301718',0,'2014-01-15 02:07:02',NULL,NULL),(23181,14940,'TE','4195144603',0,'2013-12-30 00:02:17',NULL,NULL),(24860,16031,'AP','2252064357',0,'2014-01-04 02:02:31',NULL,NULL),(1549,954,'AP','2164072748',0,'2013-12-25 18:09:37',NULL,NULL),(34301,22509,'TE','5132135353',0,'2014-02-10 21:31:17',NULL,NULL),(34241,22457,'EM','tvalenta1@att.net',0,'2014-02-10 21:30:51',NULL,NULL),(5293,3393,'EM','henryagrantjr@yahoo.com',0,'2013-12-25 21:17:55',NULL,NULL),(33436,21900,'EM','foxangels@aol.com',0,'2014-02-06 21:01:47',NULL,NULL),(31380,20454,'AP','4193669643',0,'2014-01-29 21:00:47',NULL,NULL),(25311,16321,'AP','2252356241',0,'2014-01-07 04:01:43',NULL,NULL),(42759,28441,'BN','5049124353',0,'2014-03-07 21:31:14',NULL,NULL),(43531,28902,'AP','3256503548',0,'2014-03-10 21:00:21',NULL,NULL),(5673,3645,'TE','2343127647',0,'2013-12-25 21:30:29',NULL,NULL),(41272,27425,'AP','5045537038',0,'2014-03-04 21:01:42',NULL,NULL),(33112,21691,'TE','2253556367',0,'2014-02-05 21:31:06',NULL,NULL),(9726,6366,'AP','9375596016',0,'2013-12-26 00:47:30',NULL,NULL),(9237,6045,'EM','heskamp.josh@gmail.com',0,'2013-12-26 00:01:32',NULL,NULL),(7481,4868,'AP','5132870295',0,'2013-12-25 22:30:55',NULL,NULL),(32239,21056,'EM','heather.dlx1016@yahoo.com',0,'2014-02-02 19:00:09',NULL,NULL),(29549,19096,'TE','9372101703',0,'2014-01-21 08:44:35',NULL,NULL),(20754,13339,'TE','9158203903',0,'2013-12-26 12:58:51',NULL,NULL),(29264,18901,'TE','9377254918',0,'2014-01-17 03:36:36',NULL,NULL),(28451,18334,'AP','3309045269',0,'2014-01-16 08:45:14',NULL,NULL),(24739,15962,'TE','7408358661',0,'2014-01-04 02:00:22',NULL,NULL),(26527,17065,'AP','2147355189',0,'2014-01-13 02:21:14',NULL,NULL),(26546,17076,'TE','9566475140',0,'2014-01-13 02:21:20',NULL,NULL),(27963,18024,'BN','7407036736',0,'2014-01-15 02:07:06',NULL,NULL),(875,543,'AP','3306902806',0,'2013-12-25 17:49:48',NULL,NULL),(12077,7887,'TE','4193859709',0,'2013-12-26 03:05:33',NULL,NULL),(40047,26550,'EM','DARLENEDICKERSON2258@YAHOO.COM',0,'2014-02-28 21:30:13',NULL,NULL),(36724,24182,'TE','3304739345',0,'2014-02-16 19:00:08',NULL,NULL),(35722,23493,'AP','5136044829',0,'2014-02-13 22:02:03',NULL,NULL),(20900,13438,'AP','5135453653',0,'2013-12-26 13:01:14',NULL,NULL),(23297,15012,'AP','3305714403',0,'2014-01-01 12:02:04',NULL,NULL),(5726,3673,'TE','3302532548',0,'2013-12-25 21:31:14',NULL,NULL),(1035,638,'AP','4406100191',0,'2013-12-25 18:01:18',NULL,NULL),(1109,679,'EM','vargasdrywall@yahoo.com',0,'2013-12-25 18:02:22',NULL,NULL),(41515,27602,'TE','9379036479',0,'2014-03-05 21:00:23',NULL,NULL),(37973,25053,'TE','4192961783',0,'2014-02-20 22:01:18',NULL,NULL),(1399,855,'TE','4192343495',0,'2013-12-25 18:07:01',NULL,NULL),(37894,24997,'AP','2817286328',0,'2014-02-20 22:00:44',NULL,NULL),(35242,23145,'TE','3308645725',0,'2014-02-12 21:31:38',NULL,NULL),(4645,2967,'TE','8174481248',0,'2013-12-25 20:16:54',NULL,NULL),(30807,20031,'TE','5046170617',0,'2014-01-26 19:00:20',NULL,NULL),(3187,2003,'TE','5135750352',0,'2013-12-25 19:02:16',NULL,NULL),(30702,19945,'TE','5134230003',0,'2014-01-24 21:01:17',NULL,NULL),(22410,14453,'EM','stacimbruce@gmail.com',0,'2013-12-28 03:32:33',NULL,NULL),(11520,7496,'AP','7404665977',0,'2013-12-26 02:31:44',NULL,NULL),(3998,2540,'TE','4198413145',0,'2013-12-25 19:37:01',NULL,NULL),(6431,4154,'EM','rsmith@ffpis.com',0,'2013-12-25 21:48:52',NULL,NULL),(32752,21428,'TE','4194299136',0,'2014-02-04 21:01:16',NULL,NULL),(37175,24471,'AP','4193997902',0,'2014-02-18 22:01:38',NULL,NULL),(39610,26200,'EM','johnhmx@windstream.net',0,'2014-02-28 06:30:48',NULL,NULL),(40241,26691,'EM','lingcanizal@yahoo.com',0,'2014-02-28 21:31:29',NULL,NULL),(26855,17282,'EM','khsdvm@earthlink.net',0,'2014-01-13 02:23:26',NULL,NULL),(1015,624,'AP','3302831201',0,'2013-12-25 18:00:56',NULL,NULL),(1320,807,'TE','3305766768',0,'2013-12-25 18:05:43',NULL,NULL),(10306,6723,'EM','fkrajenke@gmail.com',0,'2013-12-26 01:15:17',NULL,NULL),(10253,6700,'AP','7025962921',0,'2013-12-26 01:01:54',NULL,NULL),(5124,3283,'AP','6145634377',0,'2013-12-25 21:15:19',NULL,NULL),(22557,14549,'TE','6015720032',0,'2013-12-28 03:34:58',NULL,NULL),(37947,25039,'TE','4192961783',0,'2014-02-20 22:01:09',NULL,NULL),(39682,26237,'EM','ali@dashrealty.com',0,'2014-02-28 06:31:03',NULL,NULL),(41371,27483,'EM','nicolelove41@gmail.com',0,'2014-03-04 21:02:19',NULL,NULL),(31980,20879,'EM','RAINOWL3@HOTMAIL.COM',0,'2014-01-31 21:01:08',NULL,NULL),(26930,17322,'EM','ansousa1161@yahoo.com',0,'2014-01-13 02:23:51',NULL,NULL),(14772,9667,'TE','5133443843',0,'2013-12-26 04:39:08',NULL,NULL),(1445,879,'EM','martiastephens@aol.com',0,'2013-12-25 18:07:42',NULL,NULL),(3519,2201,'TE','9375264412',0,'2013-12-25 19:20:02',NULL,NULL),(23636,15264,'TE','4198606105',0,'2014-01-01 12:09:23',NULL,NULL),(8491,5586,'TE','5134532531',0,'2013-12-25 23:17:06',NULL,NULL),(34644,22714,'AP','9174567350',0,'2014-02-11 21:01:07',NULL,NULL),(35364,23235,'EM','LadyMeii@aol.com',0,'2014-02-12 21:32:28',NULL,NULL),(41667,27699,'EM','qkbrooks@gmail.com',0,'2014-03-05 21:30:48',NULL,NULL),(43602,28948,'TE','3373810001',0,'2014-03-10 21:00:48',NULL,NULL),(28887,18651,'AP','9792044316',0,'2014-01-17 03:35:10',NULL,NULL),(2354,1431,'AP','2256204901',0,'2013-12-25 18:47:34',NULL,NULL),(9673,6333,'EM','boneman1982@gmail.com',0,'2013-12-26 00:46:40',NULL,NULL),(5884,3774,'TE','2162911407',0,'2013-12-25 21:33:48',NULL,NULL),(8549,5617,'EM','cherie1273@gmail.com',0,'2013-12-25 23:30:41',NULL,NULL),(41499,27588,'TE','2818275075',0,'2014-03-05 21:00:15',NULL,NULL),(9004,5910,'TE','4693371243',0,'2013-12-25 23:50:00',NULL,NULL),(26914,17312,'AP','7738377128',0,'2014-01-13 02:23:45',NULL,NULL),(5563,3553,'EM','everettmom2001@yahoo.com',0,'2013-12-25 21:22:06',NULL,NULL),(4404,2806,'TE','5748504009',0,'2013-12-25 20:00:06',NULL,NULL),(6048,3885,'TE','3309294135',0,'2013-12-25 21:36:34',NULL,NULL),(21627,13919,'EM','Danielle.baker.0901@gmail.com',0,'2013-12-26 13:14:10',NULL,NULL),(12345,8073,'EM','MRSSTUDMUFFIN61@YAHOO.COM',0,'2013-12-26 03:10:18',NULL,NULL),(25817,16642,'AP','3306047774',0,'2014-01-08 18:24:18',NULL,NULL),(9904,6482,'AP','4195540494',0,'2013-12-26 00:50:21',NULL,NULL),(14607,9550,'TE','9374861000',0,'2013-12-26 04:36:16',NULL,NULL),(7114,4646,'AP','6019548849',0,'2013-12-25 22:06:55',NULL,NULL),(28507,18374,'EM','PUGSLY54@YAHOO.COM',0,'2014-01-16 08:45:31',NULL,NULL),(3068,1908,'EM','bassettmichael@gmail.com',0,'2013-12-25 18:59:21',NULL,NULL),(3291,2069,'TE','2253855745',0,'2013-12-25 19:16:20',NULL,NULL),(23474,15139,'TE','5133403761',0,'2014-01-01 12:05:41',NULL,NULL),(23448,15113,'AP','3308121458',0,'2014-01-01 12:05:02',NULL,NULL),(445,276,'TE','5126709638',0,'2013-12-25 17:30:10',NULL,NULL),(34837,22845,'EM','pattijdickey@att.net',0,'2014-02-11 21:02:17',NULL,NULL),(37576,24754,'EM','msswiger@yahoo.com',0,'2014-02-20 04:42:07',NULL,NULL),(40460,26859,'TE','9372170522',0,'2014-03-01 21:00:55',NULL,NULL),(575,355,'EM','vansly2@yahoo.com',0,'2013-12-25 17:32:25',NULL,NULL),(13587,8859,'TE','8062185119',0,'2013-12-26 04:01:13',NULL,NULL),(1545,950,'EM','slkpcme@gmail.com',0,'2013-12-25 18:09:33',NULL,NULL),(11876,7730,'TE','2165488950',0,'2013-12-26 03:01:59',NULL,NULL),(1911,1182,'TE','5134178536',0,'2013-12-25 18:19:25',NULL,NULL),(2948,1817,'TE','2162585726',0,'2013-12-25 18:57:09',NULL,NULL),(32398,21169,'TE','3306359081',0,'2014-02-03 21:00:37',NULL,NULL),(11747,7647,'AP','4258797730',0,'2013-12-26 02:46:45',NULL,NULL),(6681,4338,'TE','9375093801',0,'2013-12-25 21:53:13',NULL,NULL),(11057,7179,'EM','smassie1856@gmail.com',0,'2013-12-26 02:00:10',NULL,NULL),(25833,16656,'TE','2283270201',0,'2014-01-08 18:24:22',NULL,NULL),(27145,17479,'TE','8173436357',0,'2014-01-13 03:01:12',NULL,NULL),(28002,18048,'EM','red1luv5@aol.com',0,'2014-01-15 02:07:16',NULL,NULL),(31822,20775,'AP','9035061841',0,'2014-01-31 21:00:06',NULL,NULL),(36084,23734,'EM','betty.fran@live.com',0,'2014-02-14 21:31:00',NULL,NULL),(41987,27909,'TE','8066554049',0,'2014-03-06 21:00:14',NULL,NULL),(27630,17810,'EM','duevu89@yahoo.com',0,'2014-01-15 02:05:52',NULL,NULL),(25887,16688,'AP','2148081962',0,'2014-01-08 18:24:34',NULL,NULL),(5919,3796,'AP','7248549029',0,'2013-12-25 21:34:23',NULL,NULL),(4322,2758,'TE','4197362764',0,'2013-12-25 19:49:15',NULL,NULL),(5662,3636,'TE','6019228207',0,'2013-12-25 21:30:16',NULL,NULL),(36204,23832,'TE','6012150085',0,'2014-02-14 21:31:47',NULL,NULL),(91,54,'EM','SARALOUISEHANLEY@HOTMAIL.COM',0,'2013-12-25 17:16:29',NULL,NULL),(28301,18242,'TE','8173080458',0,'2014-01-16 08:44:26',NULL,NULL),(7963,5195,'TE','2566510249',0,'2013-12-25 23:03:52',NULL,NULL),(3676,2332,'TE','8305137562',0,'2013-12-25 19:31:43',NULL,NULL),(9229,6040,'TE','9852372989',0,'2013-12-26 00:01:23',NULL,NULL),(1600,986,'TE','3308081032',0,'2013-12-25 18:10:26',NULL,NULL),(32792,21454,'EM','crysford865@gmail.com',0,'2014-02-04 21:01:30',NULL,NULL),(5712,3666,'AP','6146227536',0,'2013-12-25 21:31:01',NULL,NULL),(4872,3119,'TE','9199320642',0,'2013-12-25 20:30:15',NULL,NULL),(13742,8956,'TE','5136494573',0,'2013-12-26 04:03:43',NULL,NULL),(35018,22995,'TE','6143274176',0,'2014-02-12 21:30:16',NULL,NULL),(33048,21651,'TE','5043425109',0,'2014-02-05 21:30:50',NULL,NULL),(23739,15317,'TE','5126601305',1,'2014-01-02 04:23:25',NULL,NULL),(28172,18159,'TE','9372078115',0,'2014-01-15 02:07:53',NULL,NULL),(26179,16854,'AP','4193602655',0,'2014-01-13 02:18:42',NULL,NULL),(11678,7603,'TE','5673711217',0,'2013-12-26 02:45:26',NULL,NULL),(21051,13541,'TE','3184233507',0,'2013-12-26 13:03:47',NULL,NULL),(5965,3830,'TE','3302086027',0,'2013-12-25 21:35:10',NULL,NULL),(20974,13499,'AP','7407077188',0,'2013-12-26 13:02:34',NULL,NULL),(33814,22201,'EM','charles@softwaremeadows.com',0,'2014-02-09 19:00:15',NULL,NULL),(35433,23293,'EM','dgmoore7@gmail.com',0,'2014-02-13 22:00:10',NULL,NULL),(39479,26109,'AP','6143480659',0,'2014-02-28 06:30:15',NULL,NULL),(225,139,'TE','4196064247',0,'2013-12-25 17:18:38',NULL,NULL),(6652,4316,'TE','5132396554',0,'2013-12-25 21:52:40',NULL,NULL),(990,611,'TE','5138631481',0,'2013-12-25 18:00:34',NULL,NULL),(9327,6110,'AP','6143297780',0,'2013-12-26 00:15:25',NULL,NULL),(30511,19789,'EM','joe.dennis@sbcglobal.net',0,'2014-01-23 21:01:40',NULL,NULL),(20984,13505,'EM','kdavisbookkeeping@gmail.com',0,'2013-12-26 13:02:43',NULL,NULL),(21250,13657,'TE','5044273005',0,'2013-12-26 13:07:31',NULL,NULL),(29313,18938,'EM','gpost@cinci.rr.com',0,'2014-01-20 08:05:43',NULL,NULL),(26748,17204,'TE','5673565221',0,'2014-01-13 02:22:26',NULL,NULL),(34564,22666,'AP','9038064981',0,'2014-02-11 21:00:39',NULL,NULL),(35454,23313,'TE','5135427761',0,'2014-02-13 22:00:21',NULL,NULL),(35953,23654,'TE','6825600363',0,'2014-02-14 21:30:16',NULL,NULL),(36083,23734,'TE','5138517695',0,'2014-02-14 21:30:59',NULL,NULL),(37423,24644,'AP','3372968586',0,'2014-02-20 04:21:00',NULL,NULL),(43742,29037,'EM','MXS989@CASE.EDU',0,'2014-03-10 21:01:39',NULL,NULL),(2156,1327,'AP','3305268181',0,'2013-12-25 18:31:58',NULL,NULL),(32601,21316,'TE','2252187704',0,'2014-02-04 21:00:20',NULL,NULL),(30805,20030,'AP','2253616212',0,'2014-01-26 19:00:19',NULL,NULL),(3496,2185,'EM','kgoetz@bigcountryrealty.org',0,'2013-12-25 19:19:34',NULL,NULL),(22304,14375,'TE','3306803286',0,'2013-12-28 03:30:39',NULL,NULL),(5094,3269,'AP','4193442736',0,'2013-12-25 20:47:08',NULL,NULL),(4717,3020,'TE','3307245188',0,'2013-12-25 20:18:08',NULL,NULL),(39078,25846,'TE','3307907073',0,'2014-02-26 21:00:38',NULL,NULL),(40428,26837,'AP','2252533521',0,'2014-03-01 21:00:43',NULL,NULL),(41563,27635,'TE','6144571532',0,'2014-03-05 21:30:13',NULL,NULL),(21907,14112,'AP','4407257882',0,'2013-12-27 02:01:53',NULL,NULL),(24061,15534,'EM','heckardm@yahoo.com',1,'2014-01-02 04:30:45',NULL,NULL),(4601,2937,'TE','9372788345',0,'2013-12-25 20:16:08',NULL,NULL),(21317,13698,'EM','lmrfre2bme@sbcglobal.net',0,'2013-12-26 13:08:35',NULL,NULL),(38955,25755,'EM','wasserman.40@gmail.com',0,'2014-02-26 09:30:48',NULL,NULL),(40024,26526,'TE','4195682185',0,'2014-02-28 21:00:26',NULL,NULL),(30293,19625,'TE','6146008580',0,'2014-01-23 21:00:06',NULL,NULL),(28568,18418,'AP','5042148160',0,'2014-01-16 08:45:51',NULL,NULL),(2239,1374,'TE','5125544796',0,'2013-12-25 18:45:53',NULL,NULL),(12017,7830,'TE','4195479357',0,'2013-12-26 03:04:24',NULL,NULL),(27833,17933,'AP','9564552741',0,'2014-01-15 02:06:36',NULL,NULL),(26854,17282,'TE','3308541763',0,'2014-01-13 02:23:26',NULL,NULL),(27451,17685,'TE','8133910130',0,'2014-01-14 01:32:56',NULL,NULL),(39876,26382,'AP','6622310753',0,'2014-02-28 07:00:21',NULL,NULL),(20228,13030,'AP','2162001699',0,'2013-12-26 12:50:20',NULL,NULL),(7129,4652,'AP','5137203324',0,'2013-12-25 22:07:07',NULL,NULL),(7067,4614,'EM','ceruleandeb@yahoo.com',0,'2013-12-25 22:06:04',NULL,NULL),(13601,8866,'AP','2143567261',0,'2013-12-26 04:01:25',NULL,NULL),(30458,19746,'TE','4322694657',0,'2014-01-23 21:01:15',NULL,NULL),(27397,17641,'TE','5133746397',0,'2014-01-14 01:32:36',NULL,NULL),(36090,23736,'EM','annal.vyas@gmail.com',0,'2014-02-14 21:31:01',NULL,NULL),(36213,23837,'TE','5133250620',0,'2014-02-14 21:31:49',NULL,NULL),(37174,24471,'TE','4193997902',0,'2014-02-18 22:01:38',NULL,NULL),(39256,25969,'AP','3307887364',0,'2014-02-26 21:01:46',NULL,NULL),(26532,17069,'TE','2143742122',0,'2014-01-13 02:21:16',NULL,NULL),(24247,15664,'TE','2146139077',1,'2014-01-02 04:34:34',NULL,NULL),(9380,6140,'AP','5042015520',0,'2013-12-26 00:16:14',NULL,NULL),(10976,7132,'EM','nelsonenterpri@aol.com',0,'2013-12-26 01:51:39',NULL,NULL),(34759,22791,'TE','4194392783',0,'2014-02-11 21:01:49',NULL,NULL),(41013,27250,'AP','3612055397',0,'2014-03-03 21:31:53',NULL,NULL),(43935,29144,'AP','5132326242',0,'2014-03-10 21:02:45',NULL,NULL),(34331,22523,'TE','9375445535',0,'2014-02-10 21:31:27',NULL,NULL),(24925,16066,'TE','9375154148',0,'2014-01-04 02:03:41',NULL,NULL),(24403,15755,'AP','4324383728',0,'2014-01-03 02:01:19',NULL,NULL),(32783,21450,'TE','3306874252',0,'2014-02-04 21:01:28',NULL,NULL),(9839,6436,'TE','3372075405',0,'2013-12-26 00:49:18',NULL,NULL),(21678,13958,'TE','5133403437',0,'2013-12-26 13:15:04',NULL,NULL),(967,595,'TE','5138430651',0,'2013-12-25 18:00:11',NULL,NULL),(14068,9198,'TE','4199086527',0,'2013-12-26 04:09:33',NULL,NULL),(14459,9445,'AP','6143166572',0,'2013-12-26 04:33:48',NULL,NULL),(1451,885,'TE','4192383733',0,'2013-12-25 18:07:51',NULL,NULL),(37019,24374,'TE','3185593801',0,'2014-02-18 22:00:40',NULL,NULL),(40481,26866,'EM','jtorres19@miners.utep.edu',0,'2014-03-01 21:01:00',NULL,NULL),(41613,27666,'AP','2162185222',0,'2014-03-05 21:30:30',NULL,NULL),(32395,21167,'TE','5138441366',0,'2014-02-03 21:00:36',NULL,NULL),(31555,20568,'AP','4193481892',0,'2014-01-29 21:01:51',NULL,NULL),(21881,14097,'EM','KTITTLE3003@YAHOO.COM',0,'2013-12-27 02:01:29',NULL,NULL),(12119,7921,'EM','fiyahboy985@yahoo.com',0,'2013-12-26 03:06:20',NULL,NULL),(21355,13724,'EM','kustom442@yahoo.com',0,'2013-12-26 13:09:17',NULL,NULL),(21524,13837,'EM','JBONARRIGO@ZOOMINTERNET.NET',0,'2013-12-26 13:12:14',NULL,NULL),(21461,13792,'TE','9013026428',0,'2013-12-26 13:11:07',NULL,NULL),(9286,6081,'EM','reinlg@bright.net',0,'2013-12-26 00:02:29',NULL,NULL),(9583,6275,'TE','9374093578',0,'2013-12-26 00:45:13',NULL,NULL),(37454,24662,'TE','4192797137',0,'2014-02-20 04:25:37',NULL,NULL),(23310,15020,'TE','5048975443',0,'2014-01-01 12:02:18',NULL,NULL),(30586,19843,'EM','tim12204@hotmail.com',0,'2014-01-24 21:00:27',NULL,NULL),(11752,7650,'TE','2109130055',0,'2013-12-26 02:46:50',NULL,NULL),(30326,19646,'TE','6149330129',0,'2014-01-23 21:00:17',NULL,NULL),(12071,7881,'TE','4408455597',0,'2013-12-26 03:05:26',NULL,NULL),(12138,7930,'TE','3372328020',0,'2013-12-26 03:06:36',NULL,NULL),(10566,6878,'AP','5043521734',0,'2013-12-26 01:32:12',NULL,NULL),(28369,18278,'EM','preciousa1996@gmail.com',0,'2014-01-16 08:44:46',NULL,NULL),(23066,14877,'TE','9727571651',0,'2013-12-30 00:00:24',NULL,NULL),(3856,2454,'EM','josecitocardenas87@gmail.com',0,'2013-12-25 19:34:44',NULL,NULL),(7352,4779,'EM','jshemekisa@yahoo.com',0,'2013-12-25 22:16:04',NULL,NULL),(35442,23303,'AP','3124516900',0,'2014-02-13 22:00:16',NULL,NULL),(37816,24955,'TE','2069313081',0,'2014-02-20 22:00:14',NULL,NULL),(37986,25060,'TE','4192170332',0,'2014-02-20 22:01:23',NULL,NULL),(39450,26089,'EM','vertical869@gmail.com',0,'2014-02-28 06:30:08',NULL,NULL),(41483,27577,'TE','3185472260',0,'2014-03-04 21:30:23',NULL,NULL),(33358,21853,'TE','7402841003',0,'2014-02-06 21:01:17',NULL,NULL),(12390,8113,'AP','9853730088',0,'2013-12-26 03:15:05',NULL,NULL),(28651,18478,'EM','abby44312@aol.com',0,'2014-01-16 08:46:20',NULL,NULL),(14209,9297,'TE','3308774161',0,'2013-12-26 04:16:17',NULL,NULL),(11291,7358,'AP','3614011918',0,'2013-12-26 02:15:19',NULL,NULL),(3434,2155,'AP','2144910148',0,'2013-12-25 19:18:41',NULL,NULL),(2861,1749,'AP','2162107010',0,'2013-12-25 18:55:40',NULL,NULL),(39513,26138,'TE','6143576273',0,'2014-02-28 06:30:24',NULL,NULL),(13911,9068,'AP','9033881858',0,'2013-12-26 04:06:33',NULL,NULL),(10205,6669,'AP','4322227306',0,'2013-12-26 01:01:03',NULL,NULL),(34308,22511,'AP','9033351352',0,'2014-02-10 21:31:19',NULL,NULL),(10695,6952,'TE','4193316297',0,'2013-12-26 01:47:04',NULL,NULL),(10859,7049,'TE','7172090776',0,'2013-12-26 01:49:38',NULL,NULL),(29688,19187,'AP','4126075595',0,'2014-01-21 08:46:11',NULL,NULL),(13570,8848,'AP','4322604188',0,'2013-12-26 04:00:57',NULL,NULL),(27406,17648,'AP','3307301403',0,'2014-01-14 01:32:40',NULL,NULL),(28770,18563,'EM','sandlin45133@gmail.com',0,'2014-01-16 08:47:00',NULL,NULL),(35471,23328,'AP','5133024955',0,'2014-02-13 22:00:29',NULL,NULL),(30997,20164,'EM','anwar.matar@gmail.com',0,'2014-01-27 21:01:11',NULL,NULL),(30843,20049,'AP','3235402017',0,'2014-01-27 21:00:04',NULL,NULL),(836,519,'AP','4195130520',0,'2013-12-25 17:49:10',NULL,NULL),(22956,14807,'AP','2256033026',1,'2013-12-29 11:13:57',NULL,NULL),(11235,7316,'TE','8309281281',0,'2013-12-26 02:03:28',NULL,NULL),(889,550,'EM','marcus_bailey@mail.com',0,'2013-12-25 17:50:01',NULL,NULL),(21569,13870,'TE','3308079383',0,'2013-12-26 13:13:02',NULL,NULL),(37193,24482,'TE','5134440216',0,'2014-02-18 22:01:46',NULL,NULL),(38503,25444,'AP','9562508121',0,'2014-02-25 21:31:22',NULL,NULL),(166,98,'TE','9562034501',0,'2013-12-25 17:17:39',NULL,NULL),(25384,16371,'TE','8326613989',0,'2014-01-07 04:03:02',NULL,NULL),(14233,9312,'TE','2257787710',0,'2013-12-26 04:30:18',NULL,NULL),(33017,21632,'AP','9038758097',0,'2014-02-05 21:30:41',NULL,NULL),(14466,9449,'TE','4409263189',0,'2013-12-26 04:33:55',NULL,NULL),(30432,19728,'TE','9852490350',0,'2014-01-23 21:01:04',NULL,NULL),(2120,1307,'AP','5044013921',0,'2013-12-25 18:31:22',NULL,NULL),(7308,4755,'EM','mrrossodell@gmail.com',0,'2013-12-25 22:15:21',NULL,NULL),(7118,4648,'TE','3305091602',0,'2013-12-25 22:06:59',NULL,NULL),(5963,3827,'EM','Raefhster@gmail.com',0,'2013-12-25 21:35:07',NULL,NULL),(5920,3797,'TE','5135414459',0,'2013-12-25 21:34:24',NULL,NULL),(4985,3201,'TE','3308023158',0,'2013-12-25 20:45:10',NULL,NULL),(305,188,'EM','ddennison5@roadrunner.com',0,'2013-12-25 17:19:53',NULL,NULL),(28839,18620,'EM','cgreat414@yahoo.com',0,'2014-01-16 08:47:28',NULL,NULL),(10942,7112,'TE','3182073699',0,'2013-12-26 01:51:05',NULL,NULL),(2072,1282,'TE','5137682769',0,'2013-12-25 18:30:36',NULL,NULL),(12459,8158,'TE','2167805601',0,'2013-12-26 03:16:16',NULL,NULL),(14118,9233,'EM','barlowjerry68@yahoo.com',0,'2013-12-26 04:10:31',NULL,NULL),(35363,23235,'AP','6143955092',0,'2014-02-12 21:32:28',NULL,NULL),(35671,23461,'TE','9366420718',0,'2014-02-13 22:01:43',NULL,NULL),(36690,24158,'TE','4199663480',0,'2014-02-15 22:02:01',NULL,NULL),(42218,28047,'AP','5103239578',0,'2014-03-06 21:01:35',NULL,NULL),(30581,19841,'AP','5043433850',0,'2014-01-24 21:00:26',NULL,NULL),(770,481,'TE','9852469102',0,'2013-12-25 17:48:10',NULL,NULL),(6952,4533,'TE','2105357939',0,'2013-12-25 22:04:06',NULL,NULL),(7443,4849,'EM','alishabrewer04@yahoo.com',0,'2013-12-25 22:30:18',NULL,NULL),(36044,23709,'TE','9372627345',0,'2014-02-14 21:30:46',NULL,NULL),(37493,24687,'EM','david0685@gmail.com',0,'2014-02-20 04:31:58',NULL,NULL),(39646,26217,'TE','3306732234',0,'2014-02-28 06:30:55',NULL,NULL),(40579,26931,'AP','4192346045',0,'2014-03-03 01:00:20',NULL,NULL),(41189,27355,'AP','2169267060',0,'2014-03-04 21:01:08',NULL,NULL),(44000,29194,'TE','4146904684',0,'2014-03-10 21:30:07',NULL,NULL),(28303,18243,'TE','3252456733',0,'2014-01-16 08:44:26',NULL,NULL),(25771,16607,'AP','2256782192',0,'2014-01-08 18:24:06',NULL,NULL),(7355,4781,'TE','9012976859',0,'2013-12-25 22:16:07',NULL,NULL),(24933,16071,'AP','2162557100',0,'2014-01-04 02:03:49',NULL,NULL),(5980,3841,'EM','smithrd.esq@gmail.com',0,'2013-12-25 21:35:24',NULL,NULL),(21041,13537,'AP','2253644575',0,'2013-12-26 13:03:39',NULL,NULL),(8476,5576,'TE','4193812781',0,'2013-12-25 23:16:50',NULL,NULL),(2478,1519,'EM','dolf1189@yahoo.com',0,'2013-12-25 18:49:45',NULL,NULL),(5444,3487,'TE','9376686414',0,'2013-12-25 21:20:19',NULL,NULL),(13916,9073,'TE','5132600097',0,'2013-12-26 04:06:41',NULL,NULL),(5267,3381,'EM','hwheatonjr@att.net',0,'2013-12-25 21:17:32',NULL,NULL),(11913,7754,'AP','2169701724',0,'2013-12-26 03:02:36',NULL,NULL),(3182,1998,'TE','8176816774',0,'2013-12-25 19:02:08',NULL,NULL),(11529,7504,'AP','4403640311',0,'2013-12-26 02:31:55',NULL,NULL),(26857,17284,'EM','srace32@gmail.com',0,'2014-01-13 02:23:27',NULL,NULL),(37860,24976,'TE','2147148300',0,'2014-02-20 22:00:30',NULL,NULL),(34611,22695,'TE','8178631407',0,'2014-02-11 21:00:55',NULL,NULL),(23951,15452,'TE','9566226847',1,'2014-01-02 04:28:26',NULL,NULL),(7372,4795,'EM','renee_pendleton@roadrunner.com',0,'2013-12-25 22:16:24',NULL,NULL),(20713,13312,'AP','2817887881',0,'2013-12-26 12:58:09',NULL,NULL),(11511,7491,'TE','3309540311',0,'2013-12-26 02:31:37',NULL,NULL),(31036,20191,'TE','9376222504',0,'2014-01-27 21:01:27',NULL,NULL),(11642,7574,'TE','4193052849',0,'2013-12-26 02:33:48',NULL,NULL),(28589,18430,'TE','9857859442',0,'2014-01-16 08:45:57',NULL,NULL),(38713,25589,'TE','9853817079',0,'2014-02-26 08:00:42',NULL,NULL),(39170,25909,'AP','9156306832',0,'2014-02-26 21:01:13',NULL,NULL),(39873,26378,'AP','2253851630',0,'2014-02-28 07:00:18',NULL,NULL),(41319,27451,'TE','4356407738',0,'2014-03-04 21:01:59',NULL,NULL),(41712,27737,'TE','2542175402',0,'2014-03-05 21:31:07',NULL,NULL),(41896,27858,'TE','5129392283',0,'2014-03-05 21:32:17',NULL,NULL),(42038,27939,'TE','4095501840',0,'2014-03-06 21:00:30',NULL,NULL),(4029,2573,'TE','3303946343',0,'2013-12-25 19:37:44',NULL,NULL),(14918,9759,'AP','4403829830',0,'2013-12-26 05:00:11',NULL,NULL),(14876,9737,'AP','9363337640',0,'2013-12-26 04:45:50',NULL,NULL),(28972,18700,'TE','3183310077',0,'2014-01-17 03:35:28',NULL,NULL),(30104,19502,'EM','georgeandsue69@yahoo.com',0,'2014-01-23 03:02:11',NULL,NULL),(37545,24719,'TE','6142260708',0,'2014-02-20 04:37:46',NULL,NULL),(35488,23335,'AP','6143258196',0,'2014-02-13 22:00:34',NULL,NULL),(37060,24404,'EM','JOOMAN24@AOL.COM',0,'2014-02-18 22:00:57',NULL,NULL),(9667,6329,'AP','6142662252',0,'2013-12-26 00:46:34',NULL,NULL),(43190,28701,'TE','4196067262',0,'2014-03-08 21:31:09',NULL,NULL),(21514,13827,'EM','moseswilloughby@outlook.com',0,'2013-12-26 13:12:02',NULL,NULL),(21141,13592,'AP','2253851630',0,'2013-12-26 13:05:14',NULL,NULL),(13660,8906,'TE','3303470983',0,'2013-12-26 04:02:26',NULL,NULL),(12270,8026,'AP','6012143183',0,'2013-12-26 03:09:02',NULL,NULL),(7569,4927,'AP','5132630514',0,'2013-12-25 22:45:19',NULL,NULL),(8694,5706,'EM','Whisner2004@yahoo.com',0,'2013-12-25 23:33:05',NULL,NULL),(33452,21913,'TE','4127165040',0,'2014-02-06 21:30:04',NULL,NULL),(33831,22212,'AP','5049316556',0,'2014-02-09 19:00:21',NULL,NULL),(38153,25181,'TE','7409441039',0,'2014-02-21 22:00:34',NULL,NULL),(10970,7128,'AP','5136737147',0,'2013-12-26 01:51:33',NULL,NULL),(26027,16770,'EM','margaret_smith117@yahoo.com',0,'2014-01-08 18:25:01',NULL,NULL),(25454,16413,'EM','jkarlcsr@aol.com',0,'2014-01-07 04:04:17',NULL,NULL),(23604,15240,'AP','4192332468',0,'2014-01-01 12:08:35',NULL,NULL),(10697,6953,'TE','2163235232',0,'2013-12-26 01:47:06',NULL,NULL),(22452,14477,'AP','8323528547',0,'2013-12-28 03:33:12',NULL,NULL),(37413,24640,'TE','3373511617',0,'2014-02-20 04:19:55',NULL,NULL),(35912,23630,'TE','9523815807',0,'2014-02-14 21:30:03',NULL,NULL),(34908,22906,'TE','4199136458',0,'2014-02-11 21:02:45',NULL,NULL),(29202,18864,'EM','susan.nunez@hcahealth.com',0,'2014-01-17 03:36:21',NULL,NULL),(27671,17837,'TE','7405059694',0,'2014-01-15 02:06:02',NULL,NULL),(8528,5604,'AP','6145989975',0,'2013-12-25 23:30:21',NULL,NULL),(39369,26038,'TE','3306337710',0,'2014-02-26 21:02:25',NULL,NULL),(42189,28025,'EM','tinman630@yahoo.com',0,'2014-03-06 21:01:24',NULL,NULL),(42721,28416,'AP','5134843509',0,'2014-03-07 21:31:00',NULL,NULL),(2159,1328,'AP','7609022146',0,'2013-12-25 18:32:00',NULL,NULL),(8687,5703,'TE','6017017905',0,'2013-12-25 23:32:58',NULL,NULL),(24701,15934,'TE','4192051550',0,'2014-01-03 02:07:00',NULL,NULL),(34045,22324,'TE','5049317966',0,'2014-02-10 11:00:56',NULL,NULL),(6861,4450,'EM','svranich1@hotmail.com',0,'2013-12-25 22:02:23',NULL,NULL),(22802,14703,'TE','5672883978',1,'2013-12-29 11:09:08',NULL,NULL),(2511,1540,'TE','5138843420',0,'2013-12-25 18:50:16',NULL,NULL),(30887,20075,'EM','destiny198858@gmail.com',0,'2014-01-27 21:00:20',NULL,NULL),(3866,2458,'EM','smitty6961@ymail.com',0,'2013-12-25 19:34:51',NULL,NULL),(40492,26874,'AP','4196813872',0,'2014-03-01 21:01:05',NULL,NULL),(2888,1769,'TE','3306873549',0,'2013-12-25 18:56:06',NULL,NULL),(36410,23980,'TE','6512850740',0,'2014-02-15 22:00:20',NULL,NULL),(7079,4623,'AP','2252450254',0,'2013-12-25 22:06:18',NULL,NULL),(24969,16092,'AP','6019403909',0,'2014-01-04 02:04:29',NULL,NULL),(14795,9683,'AP','5134775516',0,'2013-12-26 04:39:31',NULL,NULL),(37754,24913,'TE','6145325048',0,'2014-02-20 21:30:09',NULL,NULL),(14860,9722,'EM','Mannaxra@gmail.com',0,'2013-12-26 04:45:30',NULL,NULL),(6916,4502,'AP','4695836873',0,'2013-12-25 22:03:25',NULL,NULL),(34366,22540,'AP','5049120813',0,'2014-02-10 21:31:39',NULL,NULL),(13573,8849,'AP','9035731596',0,'2013-12-26 04:00:59',NULL,NULL),(2697,1638,'EM','larryscheib@yahoo.com',0,'2013-12-25 18:53:01',NULL,NULL),(1847,1141,'EM','iampaulapaul@gmail.com',0,'2013-12-25 18:18:21',NULL,NULL),(2847,1729,'AP','4192020645',0,'2013-12-25 18:55:22',NULL,NULL),(28574,18420,'EM','CBreland@vetmail.lsu.edu',0,'2014-01-16 08:45:52',NULL,NULL),(32304,21098,'AP','4197082183',0,'2014-02-02 19:00:33',NULL,NULL),(31833,20782,'AP','9153095199',0,'2014-01-31 21:00:10',NULL,NULL),(36821,24252,'TE','3303288182',0,'2014-02-17 19:00:02',NULL,NULL),(35220,23133,'TE','3305629923',0,'2014-02-12 21:31:31',NULL,NULL),(3447,2160,'TE','3183221848',0,'2013-12-25 19:18:51',NULL,NULL),(2195,1350,'TE','5128031884',0,'2013-12-25 18:45:13',NULL,NULL),(40956,27215,'TE','6623031335',0,'2014-03-03 21:31:31',NULL,NULL),(3230,2030,'TE','3306459162',0,'2013-12-25 19:15:20',NULL,NULL),(7960,5190,'EM','catruffles2@hotmail.com',0,'2013-12-25 23:03:47',NULL,NULL),(29606,19130,'TE','5042088600',0,'2014-01-21 08:45:23',NULL,NULL),(30320,19641,'AP','3304691536',0,'2014-01-23 21:00:15',NULL,NULL),(6639,4301,'TE','9374814781',0,'2013-12-25 21:52:21',NULL,NULL),(35044,23015,'AP','5045356341',0,'2014-02-12 21:30:26',NULL,NULL),(11955,7787,'TE','4323452628',0,'2013-12-26 03:03:21',NULL,NULL),(38934,25741,'TE','2169051823',0,'2014-02-26 09:30:40',NULL,NULL),(2935,1805,'AP','5137029896',0,'2013-12-25 18:56:53',NULL,NULL),(9891,6469,'EM','belair.denise@yahoo.com',0,'2013-12-26 00:50:06',NULL,NULL),(4441,2831,'EM','caledoniatime@yahoo.com',0,'2013-12-25 20:00:46',NULL,NULL),(37838,24964,'EM','valrichard21@gmail.com',0,'2014-02-20 22:00:22',NULL,NULL),(23930,15442,'TE','6153018597',1,'2014-01-02 04:28:05',NULL,NULL),(11213,7293,'AP','3305547733',0,'2013-12-26 02:02:57',NULL,NULL),(6414,4140,'TE','6145357135',0,'2013-12-25 21:48:35',NULL,NULL),(7625,4968,'TE','3182377711',0,'2013-12-25 22:46:21',NULL,NULL),(25639,16535,'EM','TERESAJ727@AOL.COM',1,'2014-01-07 10:22:11',NULL,NULL),(20941,13467,'TE','5136738981',0,'2013-12-26 13:01:56',NULL,NULL),(28091,18107,'TE','9857097841',0,'2014-01-15 02:07:35',NULL,NULL),(30567,19833,'AP','3256601966',0,'2014-01-24 21:00:21',NULL,NULL),(32010,20896,'EM','streetglidejimmy@hotmail.com',0,'2014-01-31 21:01:18',NULL,NULL),(34200,22429,'AP','2149309327',0,'2014-02-10 21:30:35',NULL,NULL),(25713,16575,'TE','5707804711',1,'2014-01-07 10:23:28',NULL,NULL),(26003,16753,'TE','2142269188',0,'2014-01-08 18:24:55',NULL,NULL),(40384,26806,'TE','5133072688',0,'2014-03-01 21:00:26',NULL,NULL),(40745,27079,'TE','4404634709',0,'2014-03-03 21:30:10',NULL,NULL),(43398,28821,'EM','COLEYCATES@ATT.NET',0,'2014-03-09 21:01:00',NULL,NULL),(43616,28955,'TE','5047290565',0,'2014-03-10 21:00:53',NULL,NULL),(477,304,'TE','4198108153',0,'2013-12-25 17:30:52',NULL,NULL),(3166,1982,'TE','8176816774',0,'2013-12-25 19:01:45',NULL,NULL),(24221,15648,'EM','FELISSA.COLEMAN@YAHOO.COM',1,'2014-01-02 04:34:01',NULL,NULL),(21673,13953,'AP','5133654866',0,'2013-12-26 13:14:58',NULL,NULL),(21323,13701,'TE','3022940453',0,'2013-12-26 13:08:41',NULL,NULL),(7734,5048,'AP','9033878771',0,'2013-12-25 23:00:06',NULL,NULL),(29468,19050,'AP','5043770292',0,'2014-01-20 08:06:44',NULL,NULL),(34548,22659,'EM','puchelly@hotmail.com',0,'2014-02-11 21:00:34',NULL,NULL),(38967,25762,'EM','CWURGLER1@NEO.RR.COM',0,'2014-02-26 09:30:52',NULL,NULL),(42207,28040,'TE','9859741154',0,'2014-03-06 21:01:31',NULL,NULL),(7768,5069,'AP','4697139615',0,'2013-12-25 23:00:41',NULL,NULL),(5478,3506,'AP','3302895231',0,'2013-12-25 21:20:52',NULL,NULL),(35025,22998,'EM','wat85@live.com',0,'2014-02-12 21:30:18',NULL,NULL),(21670,13952,'TE','5134901485',0,'2013-12-26 13:14:56',NULL,NULL),(42995,28593,'EM','matt.harmon.08@gmail.com',0,'2014-03-08 21:30:04',NULL,NULL),(43060,28627,'EM','jaylerma1@hotmail.com',0,'2014-03-08 21:30:25',NULL,NULL),(23257,14985,'TE','5127994830',0,'2014-01-01 12:01:14',NULL,NULL),(38271,25268,'EM','lexk75@gmail.com',0,'2014-02-25 21:00:10',NULL,NULL),(1607,988,'EM','dermcincimr@gmail.com',0,'2013-12-25 18:10:32',NULL,NULL),(9348,6121,'TE','9564830763',0,'2013-12-26 00:15:44',NULL,NULL),(31878,20808,'TE','9032585474',0,'2014-01-31 21:00:26',NULL,NULL),(8709,5713,'EM','lewis14@hotmail.com',0,'2013-12-25 23:45:13',NULL,NULL),(29796,19271,'AP','2254454848',0,'2014-01-21 08:46:54',NULL,NULL),(3846,2448,'TE','5138718447',0,'2013-12-25 19:34:36',NULL,NULL),(6391,4116,'EM','quinn4qb@yahoo.com',0,'2013-12-25 21:48:08',NULL,NULL),(10486,6831,'TE','7402444198',0,'2013-12-26 01:30:48',NULL,NULL),(36999,24362,'TE','5044446120',0,'2014-02-18 22:00:33',NULL,NULL),(9909,6485,'EM','JMJANOVEC@GMAIL.COM',0,'2013-12-26 00:50:25',NULL,NULL),(32800,21458,'EM','matrixhaircare@aol.com',0,'2014-02-04 21:01:32',NULL,NULL),(30618,19871,'AP','7406801059',0,'2014-01-24 21:00:41',NULL,NULL),(23605,15240,'EM','jenn_dale.reynolds@hotmail.com',0,'2014-01-01 12:08:35',NULL,NULL),(22665,14614,'TE','6014541875',0,'2013-12-28 03:36:44',NULL,NULL),(21255,13660,'TE','3035504385',0,'2013-12-26 13:07:35',NULL,NULL),(32751,21427,'AP','5134001071',0,'2014-02-04 21:01:16',NULL,NULL),(32616,21326,'AP','9857892611',0,'2014-02-04 21:00:25',NULL,NULL),(6008,3859,'TE','3184762511',0,'2013-12-25 21:35:52',NULL,NULL),(11670,7598,'TE','5673438312',0,'2013-12-26 02:45:18',NULL,NULL),(30031,19451,'TE','5135423693',0,'2014-01-23 03:01:52',NULL,NULL),(20619,13262,'TE','9362950078',0,'2013-12-26 12:56:41',NULL,NULL),(20988,13507,'EM','binh.dao@la.gov',0,'2013-12-26 13:02:47',NULL,NULL),(39215,25934,'TE','4322940562',0,'2014-02-26 21:01:28',NULL,NULL),(5540,3540,'EM','priscilla.velasco@live.com',0,'2013-12-25 21:21:46',NULL,NULL),(38641,25538,'EM','Torrielovesyou@msn.com',0,'2014-02-26 08:00:09',NULL,NULL),(7297,4751,'AP','9188047599',0,'2013-12-25 22:15:13',NULL,NULL),(34378,22549,'AP','2257154798',0,'2014-02-10 21:31:44',NULL,NULL),(29110,18799,'TE','5135730387',0,'2014-01-17 03:35:59',NULL,NULL),(24695,15928,'TE','5137538368',0,'2014-01-03 02:06:51',NULL,NULL),(4221,2700,'AP','9033154178',0,'2013-12-25 19:47:42',NULL,NULL),(31101,20249,'TE','8302788928',0,'2014-01-28 21:00:12',NULL,NULL),(27399,17644,'TE','4405829626',0,'2014-01-14 01:32:38',NULL,NULL),(14169,9271,'AP','5134057986',0,'2013-12-26 04:15:40',NULL,NULL),(23154,14925,'EM','rhswartz@outlook.com',0,'2013-12-30 00:01:50',NULL,NULL),(23514,15169,'TE','5134177715',0,'2014-01-01 12:06:31',NULL,NULL),(39554,26168,'TE','6018918160',0,'2014-02-28 06:30:35',NULL,NULL),(24017,15510,'TE','5133899844',1,'2014-01-02 04:29:57',NULL,NULL),(9948,6509,'EM','verevey16@yahoo.com',0,'2013-12-26 00:51:05',NULL,NULL),(41865,27839,'TE','2108722773',0,'2014-03-05 21:32:06',NULL,NULL),(42133,27987,'EM','chris.w.breaux@gmail.com',0,'2014-03-06 21:01:01',NULL,NULL),(43076,28638,'AP','2544344151',0,'2014-03-08 21:30:31',NULL,NULL),(295,182,'AP','3307603196',0,'2013-12-25 17:19:43',NULL,NULL),(36871,24283,'TE','5044536224',0,'2014-02-18 21:30:08',NULL,NULL),(33505,21956,'AP','9377169182',0,'2014-02-07 19:00:24',NULL,NULL),(1638,1005,'TE','9036394547',0,'2013-12-25 18:11:05',NULL,NULL),(2615,1592,'TE','9152619583',0,'2013-12-25 18:51:47',NULL,NULL),(33415,21893,'TE','2285472935',0,'2014-02-06 21:01:40',NULL,NULL),(31714,20697,'TE','5137059596',0,'2014-01-30 21:01:01',NULL,NULL),(20233,13033,'EM','brentmkirby@aol.com',0,'2013-12-26 12:50:25',NULL,NULL),(20346,13107,'EM','Medmansvc@aol.com',0,'2013-12-26 12:52:21',NULL,NULL),(21622,13915,'EM','rocker01@bex.net',0,'2013-12-26 13:14:05',NULL,NULL),(30815,20035,'AP','4404172706',0,'2014-01-26 19:00:23',NULL,NULL),(25474,16426,'AP','5134039357',0,'2014-01-07 04:04:39',NULL,NULL),(26184,16856,'AP','9034970318',0,'2014-01-13 02:19:07',NULL,NULL),(43474,28871,'EM','monique.rodriguez21@gmail.com',0,'2014-03-10 21:00:03',NULL,NULL),(43524,28898,'AP','2144046959',0,'2014-03-10 21:00:19',NULL,NULL),(1881,1161,'AP','3185371733',0,'2013-12-25 18:18:54',NULL,NULL),(39139,25887,'TE','2813300681',0,'2014-02-26 21:01:01',NULL,NULL),(38437,25402,'EM','rhondaj308@aol.com',0,'2014-02-25 21:30:57',NULL,NULL),(3931,2492,'AP','5043003205',0,'2013-12-25 19:35:50',NULL,NULL),(24235,15657,'TE','4199796271',1,'2014-01-02 04:34:20',NULL,NULL),(21599,13901,'AP','4195099304',0,'2013-12-26 13:13:41',NULL,NULL),(21746,14008,'TE','5135204487',0,'2013-12-26 13:16:17',NULL,NULL),(40767,27091,'AP','4404742334',0,'2014-03-03 21:30:17',NULL,NULL),(41041,27267,'TE','2252057625',0,'2014-03-04 21:00:13',NULL,NULL),(41533,27618,'BN','9374412530',0,'2014-03-05 21:00:32',NULL,NULL),(38639,25538,'TE','5133000627',0,'2014-02-26 08:00:09',NULL,NULL),(30767,19998,'TE','6142904658',0,'2014-01-26 19:00:04',NULL,NULL),(29932,19372,'TE','3304164068',1,'2014-01-22 03:22:36',NULL,NULL),(7179,4680,'TE','3376619555',0,'2013-12-25 22:07:52',NULL,NULL),(10096,6595,'AP','6012594051',0,'2013-12-26 00:53:24',NULL,NULL),(28870,18640,'AP','9727621527',0,'2014-01-17 03:35:06',NULL,NULL),(41726,27746,'EM','neilandjill@bex.net',0,'2014-03-05 21:31:12',NULL,NULL),(244,150,'TE','3302412858',0,'2013-12-25 17:18:54',NULL,NULL),(37134,24445,'TE','5132274656',0,'2014-02-18 22:01:22',NULL,NULL),(33063,21657,'EM','frankiekeller1@gmail.com',0,'2014-02-05 21:30:53',NULL,NULL),(4146,2646,'EM','amanda.rosales726@gmail.com',0,'2013-12-25 19:46:29',NULL,NULL),(1390,849,'EM','annacoreen@gmail.com',0,'2013-12-25 18:06:51',NULL,NULL),(30602,19861,'AP','5136022126',0,'2014-01-24 21:00:36',NULL,NULL),(7502,4888,'AP','2813003679',0,'2013-12-25 22:31:26',NULL,NULL),(27323,17596,'TE','6015408984',0,'2014-01-14 01:32:13',NULL,NULL),(26837,17263,'AP','5183644741',0,'2014-01-13 02:23:18',NULL,NULL),(24413,15762,'TE','9562380744',0,'2014-01-03 02:01:32',NULL,NULL),(14906,9753,'EM','smccallum2d3@gmail.com',0,'2013-12-26 04:46:17',NULL,NULL),(21830,14063,'TE','6142357605',0,'2013-12-27 02:00:39',NULL,NULL),(21877,14094,'TE','5139216888',0,'2013-12-27 02:01:25',NULL,NULL),(22520,14521,'TE','2542890122',0,'2013-12-28 03:34:18',NULL,NULL),(41730,27748,'AP','8324740909',0,'2014-03-05 21:31:13',NULL,NULL),(43510,28889,'AP','9562468235',0,'2014-03-10 21:00:14',NULL,NULL),(43876,29113,'TE','5043573555',0,'2014-03-10 21:02:25',NULL,NULL),(31358,20436,'AP','3304109225',0,'2014-01-29 21:00:38',NULL,NULL),(26864,17287,'AP','8322928692',0,'2014-01-13 02:23:30',NULL,NULL),(25297,16312,'AP','3373401115',0,'2014-01-07 04:01:28',NULL,NULL),(2315,1413,'EM','pkwilliams0624@yahoo.com',0,'2013-12-25 18:47:00',NULL,NULL),(5211,3347,'AP','8063191596',0,'2013-12-25 21:16:39',NULL,NULL),(20875,13421,'TE','6143077577',0,'2013-12-26 13:00:50',NULL,NULL),(43795,29071,'AP','4195090959',0,'2014-03-10 21:01:57',NULL,NULL),(39470,26100,'TE','3377065675',0,'2014-02-28 06:30:12',NULL,NULL),(36335,23931,'TE','5133796661',0,'2014-02-15 21:00:04',NULL,NULL),(13777,8979,'EM','bast2000@aol.com',0,'2013-12-26 04:04:17',NULL,NULL),(11044,7171,'TE','2164103859',0,'2013-12-26 01:52:42',NULL,NULL),(33811,22199,'EM','nikki.godfreyathletics@gmail.com',0,'2014-02-09 19:00:14',NULL,NULL),(31692,20672,'AP','6013810438',0,'2014-01-30 21:00:50',NULL,NULL),(9368,6132,'AP','2814501462',0,'2013-12-26 00:16:02',NULL,NULL),(24598,15864,'TE','6624710972',0,'2014-01-03 02:04:53',NULL,NULL),(23461,15123,'EM','bjjones73@ymail.com',0,'2014-01-01 12:05:17',NULL,NULL),(9012,5914,'EM','sesmylie@gmail.com',0,'2013-12-25 23:50:06',NULL,NULL),(23460,15123,'AP','5135320540',0,'2014-01-01 12:05:17',NULL,NULL),(38349,25333,'AP','2255050429',0,'2014-02-25 21:30:19',NULL,NULL),(37959,25046,'AP','2163102803',0,'2014-02-20 22:01:14',NULL,NULL),(10698,6953,'AP','2163235232',0,'2013-12-26 01:47:06',NULL,NULL),(8181,5352,'TE','3306285225',0,'2013-12-25 23:07:40',NULL,NULL),(470,295,'EM','rkludwig49@gmail.com',0,'2013-12-25 17:30:41',NULL,NULL),(7119,4648,'AP','3305091602',0,'2013-12-25 22:06:59',NULL,NULL),(37652,24827,'TE','9376559763',0,'2014-02-20 04:51:18',NULL,NULL),(32643,21348,'AP','9364339406',0,'2014-02-04 21:00:36',NULL,NULL),(4430,2824,'EM','tim.congrove@live.com',0,'2013-12-25 20:00:35',NULL,NULL),(24372,15739,'TE','9156032532',0,'2014-01-03 02:00:46',NULL,NULL),(36812,24237,'AP','8593070089',0,'2014-02-16 19:00:37',NULL,NULL),(33867,22231,'TE','8065767496',0,'2014-02-09 19:00:32',NULL,NULL),(29497,19068,'TE','4192830457',0,'2014-01-21 08:44:18',NULL,NULL),(31576,20593,'AP','2166300212',0,'2014-01-30 21:00:09',NULL,NULL),(31701,20678,'AP','2102875058',0,'2014-01-30 21:00:54',NULL,NULL),(7641,4975,'TE','9035928490',0,'2013-12-25 22:46:34',NULL,NULL),(8558,5622,'TE','2163924999',0,'2013-12-25 23:30:49',NULL,NULL),(39608,26200,'TE','4409691861',0,'2014-02-28 06:30:48',NULL,NULL),(40621,26964,'TE','3308580251',0,'2014-03-03 01:00:31',NULL,NULL),(7188,4683,'EM','alexandra.stroud@gmail.com',0,'2013-12-25 22:07:58',NULL,NULL),(25499,16443,'TE','2283800493',0,'2014-01-07 04:05:10',NULL,NULL),(26922,17317,'AP','2103233261',0,'2014-01-13 02:23:48',NULL,NULL),(28572,18420,'TE','4796016881',0,'2014-01-16 08:45:52',NULL,NULL),(28773,18564,'EM','wendy.fetters32@gmail.com',0,'2014-01-16 08:47:01',NULL,NULL),(32944,21563,'EM','christiecrabiel@yahoo.com',0,'2014-02-05 21:30:19',NULL,NULL),(36880,24289,'AP','5133731838',0,'2014-02-18 21:30:12',NULL,NULL),(2335,1423,'TE','5043021778',0,'2013-12-25 18:47:18',NULL,NULL),(3358,2111,'EM','smkelby@outlook.com',0,'2013-12-25 19:17:27',NULL,NULL),(36809,24236,'TE','8593070089',0,'2014-02-16 19:00:37',NULL,NULL),(34584,22676,'EM','judyfaye@sbcglobal.net',0,'2014-02-11 21:00:45',NULL,NULL),(34614,22696,'TE','2103170817',0,'2014-02-11 21:00:56',NULL,NULL),(35528,23367,'AP','3306664811',0,'2014-02-13 22:00:49',NULL,NULL),(36552,24065,'AP','5135636862',0,'2014-02-15 22:01:12',NULL,NULL),(27057,17401,'TE','6017201251',0,'2014-01-13 03:00:16',NULL,NULL),(28524,18386,'AP','3307549090',0,'2014-01-16 08:45:37',NULL,NULL),(36239,23850,'EM','the_kilpatricks@hotmail.com',0,'2014-02-14 21:31:58',NULL,NULL),(29343,18960,'BN','8323326845',0,'2014-01-20 08:05:54',NULL,NULL),(29361,18971,'TE','4403436865',0,'2014-01-20 08:06:02',NULL,NULL),(30437,19731,'TE','3182534165',0,'2014-01-23 21:01:05',NULL,NULL),(32371,21150,'AP','5132128239',0,'2014-02-03 21:00:27',NULL,NULL),(9684,6345,'TE','7407721286',0,'2013-12-26 00:46:53',NULL,NULL),(7389,4807,'AP','6147532693',0,'2013-12-25 22:16:42',NULL,NULL),(6624,4278,'EM','dkramer@wcoil.com',0,'2013-12-25 21:51:58',NULL,NULL),(41076,27286,'EM','Blake.harris4@gmail.com',0,'2014-03-04 21:00:25',NULL,NULL),(36875,24286,'AP','5048581510',0,'2014-02-18 21:30:09',NULL,NULL),(25479,16429,'AP','3188011069',0,'2014-01-07 04:04:45',NULL,NULL),(23783,15338,'AP','3308124760',1,'2014-01-02 04:24:09',NULL,NULL),(36329,23927,'AP','3303522477',0,'2014-02-14 22:00:09',NULL,NULL),(7537,4910,'EM','cprzeslak@me.com',0,'2013-12-25 22:32:05',NULL,NULL),(33279,21792,'TE','6148065661',0,'2014-02-06 21:00:44',NULL,NULL),(32539,21276,'TE','3049897366',0,'2014-02-03 21:01:34',NULL,NULL),(11375,7408,'TE','2108377163',0,'2013-12-26 02:16:39',NULL,NULL),(2608,1589,'TE','9033962713',0,'2013-12-25 18:51:41',NULL,NULL),(31540,20555,'TE','4194075083',0,'2014-01-29 21:01:44',NULL,NULL),(38112,25157,'AP','3612127593',0,'2014-02-21 22:00:20',NULL,NULL),(22239,14332,'TE','4197070483',0,'2013-12-27 02:07:37',NULL,NULL),(23536,15190,'TE','3306440877',0,'2014-01-01 12:07:05',NULL,NULL),(35060,23022,'TE','9154722305',0,'2014-02-12 21:30:31',NULL,NULL),(3024,1884,'TE','4199736367',0,'2013-12-25 18:58:37',NULL,NULL),(1885,1163,'TE','5043907782',0,'2013-12-25 18:18:57',NULL,NULL),(40710,27049,'TE','6018566184',0,'2014-03-03 21:00:24',NULL,NULL),(8458,5563,'EM','briley3412@gmail.com',0,'2013-12-25 23:16:33',NULL,NULL),(195,117,'TE','8177186201',0,'2013-12-25 17:18:07',NULL,NULL),(11196,7281,'TE','8177159226',0,'2013-12-26 02:02:41',NULL,NULL),(1815,1124,'TE','4196293307',0,'2013-12-25 18:17:52',NULL,NULL),(10438,6804,'TE','3617282272',0,'2013-12-26 01:30:06',NULL,NULL),(38017,25078,'AP','9377981283',0,'2014-02-20 22:01:36',NULL,NULL),(14621,9558,'AP','3309806565',0,'2013-12-26 04:36:29',NULL,NULL),(12079,7888,'TE','4193859709',0,'2013-12-26 03:05:34',NULL,NULL),(29798,19272,'TE','3182494574',0,'2014-01-21 08:46:55',NULL,NULL),(37788,24939,'AP','6012913759',0,'2014-02-20 22:00:03',NULL,NULL),(38109,25156,'TE','8322298197',0,'2014-02-21 22:00:19',NULL,NULL),(43463,28863,'TE','2252442051',0,'2014-03-09 21:30:06',NULL,NULL),(43719,29022,'TE','4404207346',0,'2014-03-10 21:01:31',NULL,NULL),(43737,29035,'TE','5138468355',0,'2014-03-10 21:01:38',NULL,NULL),(20245,13041,'AP','9372412200',0,'2013-12-26 12:50:38',NULL,NULL),(3277,2062,'TE','5675256382',0,'2013-12-25 19:16:08',NULL,NULL),(20348,13109,'TE','2162582268',0,'2013-12-26 12:52:24',NULL,NULL),(14206,9295,'AP','5134107261',0,'2013-12-26 04:16:14',NULL,NULL),(30254,19596,'TE','2162996205',0,'2014-01-23 03:02:46',NULL,NULL),(3448,2160,'AP','3183662960',0,'2013-12-25 19:18:52',NULL,NULL),(30931,20116,'TE','7404060529',0,'2014-01-27 21:00:43',NULL,NULL),(31524,20542,'EM','michael.barhite@yahoo.com',0,'2014-01-29 21:01:36',NULL,NULL),(31863,20800,'AP','9036011203',0,'2014-01-31 21:00:21',NULL,NULL),(40054,26553,'EM','LWILLIAMSFITNESS@YAHOO.COM',0,'2014-02-28 21:30:15',NULL,NULL),(40094,26589,'TE','2162464631',0,'2014-02-28 21:30:35',NULL,NULL),(30487,19775,'TE','4196618821',0,'2014-01-23 21:01:31',NULL,NULL),(34699,22754,'TE','5044020777',0,'2014-02-11 21:01:28',NULL,NULL),(4405,2806,'AP','5748504009',0,'2013-12-25 20:00:06',NULL,NULL),(36769,24209,'AP','2257887882',0,'2014-02-16 19:00:22',NULL,NULL),(42315,28100,'TE','4194355214',0,'2014-03-06 21:02:09',NULL,NULL),(3648,2312,'TE','9363687129',0,'2013-12-25 19:31:12',NULL,NULL),(4303,2745,'EM','illini1978@yahoo.com',0,'2013-12-25 19:48:55',NULL,NULL),(28592,18431,'TE','3377181438',0,'2014-01-16 08:45:58',NULL,NULL),(30232,19583,'AP','5046168269',0,'2014-01-23 03:02:41',NULL,NULL),(4365,2782,'AP','4194103568',0,'2013-12-25 19:49:55',NULL,NULL),(4072,2598,'TE','6146196044',0,'2013-12-25 19:45:15',NULL,NULL),(12338,8070,'TE','4194789101',0,'2013-12-26 03:10:11',NULL,NULL),(38545,25470,'AP','7138550558',0,'2014-02-25 21:31:37',NULL,NULL),(39639,26211,'EM','julespetersen@hotmail.com',0,'2014-02-28 06:30:53',NULL,NULL),(40779,27101,'AP','3306344893',0,'2014-03-03 21:30:22',NULL,NULL),(139,83,'AP','4408299354',0,'2013-12-25 17:17:13',NULL,NULL),(25099,16181,'AP','2147700423',0,'2014-01-05 00:00:33',NULL,NULL),(8706,5711,'EM','joan.e.soskin@gmail.com',0,'2013-12-25 23:45:10',NULL,NULL),(24574,15852,'TE','4194966071',0,'2014-01-03 02:04:27',NULL,NULL),(23642,15267,'AP','4195757417',0,'2014-01-01 12:09:31',NULL,NULL),(23638,15264,'EM','diamond.ae@pg.com',0,'2014-01-01 12:09:24',NULL,NULL),(20889,13432,'AP','4402315707',0,'2013-12-26 13:01:04',NULL,NULL),(26809,17243,'TE','5138294656',0,'2014-01-13 02:22:46',NULL,NULL),(21510,13824,'TE','3307867698',0,'2013-12-26 13:11:57',NULL,NULL),(37770,24926,'TE','6015406683',0,'2014-02-20 21:30:17',NULL,NULL),(36455,24005,'AP','2168493686',0,'2014-02-15 22:00:36',NULL,NULL),(3924,2488,'AP','2253151707',0,'2013-12-25 19:35:44',NULL,NULL),(35167,23100,'TE','2162516481',0,'2014-02-12 21:31:11',NULL,NULL),(29323,18950,'TE','8172336679',0,'2014-01-20 08:05:49',NULL,NULL),(6175,3980,'AP','4193037428',0,'2013-12-25 21:38:48',NULL,NULL),(5419,3469,'TE','4193025069',0,'2013-12-25 21:19:55',NULL,NULL),(4446,2834,'AP','3378845779',0,'2013-12-25 20:00:51',NULL,NULL),(8953,5860,'EM','Harpshe@sbcglobal.net',0,'2013-12-25 23:49:01',NULL,NULL),(1653,1015,'TE','6012703270',0,'2013-12-25 18:15:06',NULL,NULL),(34989,22972,'AP','6015691788',0,'2014-02-12 21:00:17',NULL,NULL),(40089,26586,'EM','shawalbright@aol.com',0,'2014-02-28 21:30:33',NULL,NULL),(36427,23991,'AP','2252683211',0,'2014-02-15 22:00:26',NULL,NULL),(25442,16405,'AP','2142876584',0,'2014-01-07 04:04:03',NULL,NULL),(27916,17987,'AP','4402235758',0,'2014-01-15 02:06:55',NULL,NULL),(6238,4021,'TE','4196352399',0,'2013-12-25 21:45:40',NULL,NULL),(2513,1540,'EM','martinhaas79@gmail.com',0,'2013-12-25 18:50:17',NULL,NULL),(40588,26938,'EM','kaci.stearns@hotmail.com',0,'2014-03-03 01:00:23',NULL,NULL),(14815,9698,'TE','5135759082',0,'2013-12-26 04:39:54',NULL,NULL),(35418,23285,'TE','3373547775',0,'2014-02-13 21:30:18',NULL,NULL),(109,65,'EM','DeborahDevlin@aol.com',0,'2013-12-25 17:16:46',NULL,NULL),(5321,3411,'TE','9852853885',0,'2013-12-25 21:18:23',NULL,NULL),(25652,16542,'AP','4404793738',1,'2014-01-07 10:22:25',NULL,NULL),(25484,16432,'TE','4196906956',0,'2014-01-07 04:04:51',NULL,NULL),(34927,22919,'TE','9377632914',0,'2014-02-11 21:02:53',NULL,NULL),(24181,15622,'AP','6012120978',1,'2014-01-02 04:33:12',NULL,NULL),(30211,19571,'AP','3185604805',0,'2014-01-23 03:02:37',NULL,NULL),(7997,5219,'EM','rainier@theadauction.com',0,'2013-12-25 23:04:29',NULL,NULL),(38950,25750,'EM','Laergna@gmail.com',0,'2014-02-26 09:30:45',NULL,NULL),(39977,26469,'AP','6013825484',0,'2014-02-28 07:30:36',NULL,NULL),(1159,711,'AP','5672300396',0,'2013-12-25 18:03:12',NULL,NULL),(32939,21559,'AP','6144037758',0,'2014-02-05 21:30:18',NULL,NULL),(38177,25196,'AP','2256448294',0,'2014-02-21 22:00:43',NULL,NULL),(7819,5105,'AP','8324526755',0,'2013-12-25 23:01:32',NULL,NULL),(38738,25608,'TE','2549182428',0,'2014-02-26 08:30:07',NULL,NULL),(40501,26879,'AP','2165365533',0,'2014-03-01 21:01:08',NULL,NULL),(41916,27869,'AP','4193711226',0,'2014-03-05 21:32:24',NULL,NULL),(4808,3075,'AP','9857501850',0,'2013-12-25 20:19:34',NULL,NULL),(22679,14625,'TE','4198367908',0,'2013-12-28 03:37:02',NULL,NULL),(6042,3881,'TE','5047829256',0,'2013-12-25 21:36:27',NULL,NULL),(39395,26050,'EM','hcoull@yahoo.com',0,'2014-02-26 21:02:33',NULL,NULL),(41997,27912,'EM','gmsapp@comcast.net',0,'2014-03-06 21:00:16',NULL,NULL),(35772,23524,'TE','2252004229',0,'2014-02-13 22:02:22',NULL,NULL),(748,470,'TE','3307339070',0,'2013-12-25 17:47:50',NULL,NULL),(34449,22601,'AP','4193188787',0,'2014-02-10 21:32:15',NULL,NULL),(32700,21392,'TE','3303974706',0,'2014-02-04 21:00:57',NULL,NULL),(37469,24675,'AP','4192317429',0,'2014-02-20 04:28:38',NULL,NULL),(7328,4764,'TE','6142047722',0,'2013-12-25 22:15:39',NULL,NULL),(28630,18459,'TE','2254132664',0,'2014-01-16 08:46:12',NULL,NULL),(30116,19508,'TE','9726406451',0,'2014-01-23 03:02:13',NULL,NULL),(34578,22673,'TE','9365597098',0,'2014-02-11 21:00:43',NULL,NULL),(34610,22694,'EM','rob@storybookcommunity.com',0,'2014-02-11 21:00:54',NULL,NULL),(36140,23783,'EM','ohioscott@sbcglobal.net',0,'2014-02-14 21:31:21',NULL,NULL),(7478,4866,'EM','turtlejack@sbcglobal.net',0,'2013-12-25 22:30:51',NULL,NULL),(4115,2625,'TE','2164018177',0,'2013-12-25 19:45:59',NULL,NULL),(20779,13354,'TE','2107765181',0,'2013-12-26 12:59:16',NULL,NULL),(5840,3747,'TE','5126381849',0,'2013-12-25 21:33:04',NULL,NULL),(8040,5260,'EM','mhoyt@neo.rr.com',0,'2013-12-25 23:05:21',NULL,NULL),(21352,13720,'TE','3306677203',0,'2013-12-26 13:09:12',NULL,NULL),(39020,25801,'EM','Donxu1@gmail.com',0,'2014-02-26 21:00:17',NULL,NULL),(10747,6987,'AP','5136737147',0,'2013-12-26 01:47:53',NULL,NULL),(20458,13180,'AP','6825571773',0,'2013-12-26 12:54:18',NULL,NULL),(30404,19703,'TE','9403374859',0,'2014-01-23 21:00:49',NULL,NULL),(11219,7297,'AP','3308077710',0,'2013-12-26 02:03:03',NULL,NULL),(12148,7937,'TE','3184048242',0,'2013-12-26 03:06:46',NULL,NULL),(42857,28501,'EM','chloermallardi@gmail.com',0,'2014-03-07 21:31:49',NULL,NULL),(14281,9342,'TE','2257681345',0,'2013-12-26 04:31:02',NULL,NULL),(1112,681,'TE','3302417002',0,'2013-12-25 18:02:24',NULL,NULL),(25948,16715,'TE','3605163721',0,'2014-01-08 18:24:44',NULL,NULL),(14635,9570,'EM','phovangem73@yahoo.com',0,'2013-12-26 04:36:43',NULL,NULL),(33094,21678,'EM','sheenawagner17@gmail.com',0,'2014-02-05 21:31:01',NULL,NULL),(20730,13325,'TE','5124617807',0,'2013-12-26 12:58:28',NULL,NULL),(36290,23894,'TE','5139192455',0,'2014-02-14 21:32:20',NULL,NULL),(37029,24379,'BN','3307036534',0,'2014-02-18 22:00:44',NULL,NULL),(39289,25993,'EM','tydee7302003@yahoo.com',0,'2014-02-26 21:01:58',NULL,NULL),(43799,29077,'TE','9012395771',0,'2014-03-10 21:02:00',NULL,NULL),(5899,3784,'TE','3305351021',0,'2013-12-25 21:34:04',NULL,NULL),(23132,14912,'AP','5135033428',0,'2013-12-30 00:01:28',NULL,NULL),(3770,2391,'TE','6148823756',0,'2013-12-25 19:33:18',NULL,NULL),(37165,24463,'TE','3307049542',0,'2014-02-18 22:01:35',NULL,NULL),(29764,19245,'AP','6014974465',0,'2014-01-21 08:46:40',NULL,NULL),(30738,19972,'EM','luckeyg@roadrunner.com',0,'2014-01-25 19:00:12',NULL,NULL),(33468,21926,'TE','8325676258',0,'2014-02-07 19:00:08',NULL,NULL),(39023,25804,'TE','5137396067',0,'2014-02-26 21:00:18',NULL,NULL),(40142,26624,'AP','8322839318',0,'2014-02-28 21:30:53',NULL,NULL),(14863,9727,'TE','6147432106',0,'2013-12-26 04:45:36',NULL,NULL),(252,155,'TE','9158338333',0,'2013-12-25 17:19:01',NULL,NULL),(13791,8992,'EM','jrammel@univenture.com',0,'2013-12-26 04:04:36',NULL,NULL),(26410,16997,'TE','3308197283',0,'2014-01-13 02:20:28',NULL,NULL),(25105,16184,'EM','hschulte001@gmail.com',0,'2014-01-05 00:00:38',NULL,NULL),(2558,1562,'AP','8173687755',0,'2013-12-25 18:50:57',NULL,NULL),(5132,3289,'TE','4192616944',0,'2013-12-25 21:15:28',NULL,NULL),(8144,5329,'TE','7402641532',0,'2013-12-25 23:07:04',NULL,NULL),(8073,5285,'TE','3306771798',0,'2013-12-25 23:05:53',NULL,NULL),(24930,16068,'TE','9372380544',0,'2014-01-04 02:03:45',NULL,NULL),(76,47,'TE','6013950622',0,'2013-12-25 17:16:16',NULL,NULL),(499,316,'AP','3303223866',0,'2013-12-25 17:31:12',NULL,NULL),(667,417,'EM','adammrohio@yahoo.com',0,'2013-12-25 17:46:32',NULL,NULL),(36640,24120,'AP','8327032548',0,'2014-02-15 22:01:42',NULL,NULL),(22218,14322,'AP','3303091929',0,'2013-12-27 02:07:17',NULL,NULL),(24207,15637,'AP','3185720618',1,'2014-01-02 04:33:42',NULL,NULL),(2514,1541,'TE','5133350926',0,'2013-12-25 18:50:18',NULL,NULL),(4949,3176,'EM','hcfm2@yahoo.com',0,'2013-12-25 20:31:43',NULL,NULL),(30434,19730,'TE','5049943574',0,'2014-01-23 21:01:05',NULL,NULL),(28159,18150,'EM','DTRUFANT@GMAIL.COM',0,'2014-01-15 02:07:50',NULL,NULL),(22937,14798,'AP','4403812357',1,'2013-12-29 11:13:41',NULL,NULL),(41145,27329,'AP','2546611348',0,'2014-03-04 21:00:51',NULL,NULL),(41240,27390,'EM','Carolynmacneel@gmail.com',0,'2014-03-04 21:01:27',NULL,NULL),(33761,22154,'TE','5136770590',0,'2014-02-08 19:00:56',NULL,NULL),(21809,14052,'TE','5133444089',0,'2013-12-27 02:00:19',NULL,NULL),(3384,2128,'TE','3308479991',0,'2013-12-25 19:17:54',NULL,NULL),(7703,5030,'AP','4192367632',0,'2013-12-25 22:47:44',NULL,NULL),(3079,1920,'AP','3306343955',0,'2013-12-25 19:00:09',NULL,NULL),(4008,2548,'AP','3307306325',0,'2013-12-25 19:37:13',NULL,NULL),(1298,791,'TE','9407049647',0,'2013-12-25 18:05:19',NULL,NULL),(32879,21519,'TE','6622300938',0,'2014-02-05 21:00:06',NULL,NULL),(36231,23845,'TE','4196015347',0,'2014-02-14 21:31:55',NULL,NULL),(36482,24017,'EM','spweeks@firstprincipals.com',0,'2014-02-15 22:00:45',NULL,NULL),(37023,24376,'AP','4194385104',0,'2014-02-18 22:00:41',NULL,NULL),(42863,28505,'AP','6096312620',0,'2014-03-07 21:31:51',NULL,NULL),(43575,28937,'TE','3304311214',0,'2014-03-10 21:00:40',NULL,NULL),(37098,24423,'EM','Brittanymont@hotmail.com',0,'2014-02-18 22:01:09',NULL,NULL),(34441,22594,'TE','4197067331',0,'2014-02-10 21:32:11',NULL,NULL),(30891,20081,'TE','9158380037',0,'2014-01-27 21:00:23',NULL,NULL),(39035,25812,'AP','3302093770',0,'2014-02-26 21:00:22',NULL,NULL),(26839,17268,'TE','3302426965',0,'2014-01-13 02:23:20',NULL,NULL),(3743,2375,'TE','3303729572',0,'2013-12-25 19:32:51',NULL,NULL),(14771,9666,'TE','5135283837',0,'2013-12-26 04:39:06',NULL,NULL),(8432,5549,'TE','5184355074',0,'2013-12-25 23:16:05',NULL,NULL),(33700,22103,'AP','7247773860',0,'2014-02-08 19:00:31',NULL,NULL),(32033,20910,'TE','4197041148',0,'2014-01-31 21:01:27',NULL,NULL),(29867,19322,'TE','9156675227',1,'2014-01-22 03:22:12',NULL,NULL),(38908,25722,'TE','6018768111',0,'2014-02-26 09:30:29',NULL,NULL),(37524,24712,'TE','6142260708',0,'2014-02-20 04:36:13',NULL,NULL),(6174,3980,'TE','4193037428',0,'2013-12-25 21:38:47',NULL,NULL),(10613,6905,'AP','2255721623',0,'2013-12-26 01:45:45',NULL,NULL),(7269,4738,'TE','4192284235',0,'2013-12-25 22:09:22',NULL,NULL),(12315,8051,'EM','Jerrywat6831@aol.com',0,'2013-12-26 03:09:43',NULL,NULL),(13696,8929,'TE','7404121669',0,'2013-12-26 04:02:59',NULL,NULL),(25232,16269,'TE','9374076615',0,'2014-01-07 04:00:15',NULL,NULL),(36719,24177,'TE','3304670996',0,'2014-02-16 19:00:06',NULL,NULL),(27798,17916,'BN','3614929920',0,'2014-01-15 02:06:29',NULL,NULL),(27991,18042,'TE','2285967367',0,'2014-01-15 02:07:13',NULL,NULL),(34510,22636,'AP','8063004637',0,'2014-02-11 21:00:20',NULL,NULL),(32550,21280,'AP','4193502622',0,'2014-02-03 21:01:37',NULL,NULL),(31204,20320,'TE','3256605123',0,'2014-01-28 21:00:55',NULL,NULL),(42953,28562,'BN','9379998607',0,'2014-03-07 21:32:27',NULL,NULL),(4118,2626,'TE','4195593491',0,'2013-12-25 19:46:01',NULL,NULL),(10824,7029,'EM','a.walker@utexas.edu',0,'2013-12-26 01:49:05',NULL,NULL),(854,530,'AP','6017362192',0,'2013-12-25 17:49:27',NULL,NULL),(869,541,'AP','2343127647',0,'2013-12-25 17:49:44',NULL,NULL),(1913,1183,'AP','4193480532',0,'2013-12-25 18:19:26',NULL,NULL),(3034,1889,'TE','5174424838',0,'2013-12-25 18:58:47',NULL,NULL),(39301,26000,'TE','5049579403',0,'2014-02-26 21:02:03',NULL,NULL),(39056,25831,'EM','heatherlove18@hotmail.com',0,'2014-02-26 21:00:30',NULL,NULL),(2707,1644,'AP','4096797055',0,'2013-12-25 18:53:11',NULL,NULL),(7582,4936,'TE','5132521826',0,'2013-12-25 22:45:34',NULL,NULL),(2177,1339,'TE','7249775906',0,'2013-12-25 18:32:21',NULL,NULL),(7970,5201,'AP','2167022812',0,'2013-12-25 23:04:01',NULL,NULL),(21238,13651,'AP','2252260957',0,'2013-12-26 13:07:19',NULL,NULL),(31441,20493,'EM','jamaldontcare@yahoo.com',0,'2014-01-29 21:01:08',NULL,NULL),(41590,27653,'TE','7403381353',0,'2014-03-05 21:30:22',NULL,NULL),(42504,28267,'BN','3619443397',0,'2014-03-07 21:00:20',NULL,NULL),(40549,26911,'TE','2256872796',0,'2014-03-03 01:00:12',NULL,NULL),(40786,27106,'TE','6304869775',0,'2014-03-03 21:30:25',NULL,NULL),(42090,27965,'AP','2258196551',0,'2014-03-06 21:00:47',NULL,NULL),(14067,9195,'AP','3307044711',0,'2013-12-26 04:09:29',NULL,NULL),(11878,7731,'AP','2169704966',0,'2013-12-26 03:02:01',NULL,NULL),(10317,6730,'AP','5133059723',0,'2013-12-26 01:15:28',NULL,NULL),(31189,20311,'EM','centerpointhypnosis@gmail.com',0,'2014-01-28 21:00:49',NULL,NULL),(28999,18720,'AP','5132374863',0,'2014-01-17 03:35:34',NULL,NULL),(28412,18305,'EM','TINKERBELL198031@GMAIL.COM',0,'2014-01-16 08:44:59',NULL,NULL),(7657,4984,'TE','2816519757',0,'2013-12-25 22:46:49',NULL,NULL),(32540,21276,'AP','3049897366',0,'2014-02-03 21:01:34',NULL,NULL),(34157,22395,'AP','6102097632',0,'2014-02-10 21:30:17',NULL,NULL),(34271,22484,'EM','tdheadrick@aol.com',0,'2014-02-10 21:31:04',NULL,NULL),(34632,22708,'TE','9852870003',0,'2014-02-11 21:01:03',NULL,NULL),(35633,23433,'AP','8064418177',0,'2014-02-13 22:01:28',NULL,NULL),(25842,16659,'AP','3185125805',0,'2014-01-08 18:24:24',NULL,NULL),(24497,15803,'AP','3373500586',0,'2014-01-03 02:02:57',NULL,NULL),(14461,9446,'AP','5133900340',0,'2013-12-26 04:33:50',NULL,NULL),(4149,2647,'EM','marielee12@aol.com',0,'2013-12-25 19:46:31',NULL,NULL),(7653,4981,'EM','westmorelandviv24@gmail.com',0,'2013-12-25 22:46:44',NULL,NULL),(40193,26661,'TE','4408823461',0,'2014-02-28 21:31:12',NULL,NULL),(42141,27997,'TE','4409432145',0,'2014-03-06 21:01:06',NULL,NULL),(12331,8064,'TE','4196019223',0,'2013-12-26 03:10:02',NULL,NULL),(29961,19387,'AP','5133793196',1,'2014-01-22 03:22:46',NULL,NULL),(34194,22426,'AP','2543964962',0,'2014-02-10 21:30:34',NULL,NULL),(34862,22862,'EM','Barbara2007@bellsouth.net',0,'2014-02-11 21:02:26',NULL,NULL),(39011,25797,'AP','4406389090',0,'2014-02-26 21:00:14',NULL,NULL),(41092,27294,'TE','9034503943',0,'2014-03-04 21:00:31',NULL,NULL),(41150,27332,'EM','karenparker0306@yahoo.com',0,'2014-03-04 21:00:53',NULL,NULL),(42733,28422,'AP','7409740843',0,'2014-03-07 21:31:04',NULL,NULL),(38556,25477,'AP','4192966080',0,'2014-02-25 21:31:41',NULL,NULL),(7710,5034,'AP','9372183100',0,'2013-12-25 22:47:50',NULL,NULL),(5706,3663,'TE','5132926152',0,'2013-12-25 21:30:56',NULL,NULL),(832,517,'TE','6142049848',0,'2013-12-25 17:49:06',NULL,NULL),(26153,16838,'EM','janestclair1165@gmail.com',0,'2014-01-13 02:18:32',NULL,NULL),(6751,4382,'EM','rhende1@yahoo.com',0,'2013-12-25 22:00:39',NULL,NULL),(11546,7514,'EM','Jacksons1966@yahoo.com',0,'2013-12-26 02:32:12',NULL,NULL),(21176,13621,'AP','7033008277',0,'2013-12-26 13:05:52',NULL,NULL),(31596,20611,'AP','6148938908',0,'2014-01-30 21:00:18',NULL,NULL),(24453,15785,'AP','3375630910',0,'2014-01-03 02:02:18',NULL,NULL),(2684,1631,'TE','4325995312',0,'2013-12-25 18:52:49',NULL,NULL),(2751,1668,'TE','3617229611',0,'2013-12-25 18:53:49',NULL,NULL),(9604,6287,'TE','6143251529',0,'2013-12-26 00:45:32',NULL,NULL),(9530,6239,'TE','9372966135',0,'2013-12-26 00:31:38',NULL,NULL),(38207,25219,'TE','6018327385',0,'2014-02-21 22:00:55',NULL,NULL),(26329,16949,'TE','6016975726',0,'2014-01-13 02:19:59',NULL,NULL),(37645,24812,'AP','5133770116',0,'2014-02-20 04:50:13',NULL,NULL),(7715,5039,'TE','4193094778',0,'2013-12-25 22:47:57',NULL,NULL),(22425,14460,'AP','5044521102',0,'2013-12-28 03:32:46',NULL,NULL),(35493,23337,'TE','7247773860',0,'2014-02-13 22:00:35',NULL,NULL),(32041,20914,'AP','3303489192',0,'2014-01-31 21:01:29',NULL,NULL),(3484,2181,'EM','slaus@woh.rr.com',0,'2013-12-25 19:19:25',NULL,NULL),(6385,4112,'EM','nicholasdeanmoss@gmail.com',0,'2013-12-25 21:48:02',NULL,NULL),(3774,2395,'TE','5136525532',0,'2013-12-25 19:33:23',NULL,NULL),(14925,9766,'TE','9375644234',0,'2013-12-26 05:00:19',NULL,NULL),(11386,7413,'AP','5047820894',0,'2013-12-26 02:16:48',NULL,NULL),(31583,20599,'TE','3304929280',0,'2014-01-30 21:00:12',NULL,NULL),(39689,26248,'TE','2546523943',0,'2014-02-28 06:31:07',NULL,NULL),(33130,21700,'AP','6012122800',0,'2014-02-05 21:31:10',NULL,NULL),(13951,9097,'AP','5135329852',0,'2013-12-26 04:07:16',NULL,NULL),(24880,16042,'AP','9562354641',0,'2014-01-04 02:02:53',NULL,NULL),(2484,1525,'TE','5132330497',0,'2013-12-25 18:49:52',NULL,NULL),(23724,15308,'EM','chef_cain@yahoo.com',1,'2014-01-02 04:23:07',NULL,NULL),(23123,14905,'TE','4049734811',0,'2013-12-30 00:01:17',NULL,NULL),(30096,19497,'EM','kilesanford@yahoo.com',0,'2014-01-23 03:02:09',NULL,NULL),(31494,20523,'TE','9036793680',0,'2014-01-29 21:01:26',NULL,NULL),(36394,23970,'AP','2816870722',0,'2014-02-15 22:00:14',NULL,NULL),(41031,27261,'TE','5138670510',0,'2014-03-03 21:32:00',NULL,NULL),(42148,28001,'EM','jpsgirl43@gmail.com',0,'2014-03-06 21:01:09',NULL,NULL),(27224,17527,'AP','3302323771',0,'2014-01-13 03:01:40',NULL,NULL),(35214,23128,'TE','4402091271',0,'2014-02-12 21:31:28',NULL,NULL),(3276,2061,'TE','5132480704',0,'2013-12-25 19:16:07',NULL,NULL),(27223,17527,'TE','3302323771',0,'2014-01-13 03:01:40',NULL,NULL),(28421,18312,'TE','2165027174',0,'2014-01-16 08:45:03',NULL,NULL),(28951,18688,'AP','3189909107',0,'2014-01-17 03:35:23',NULL,NULL),(29725,19221,'EM','keggroup@yahoo.com',0,'2014-01-21 08:46:27',NULL,NULL),(12257,8015,'TE','9375097815',0,'2013-12-26 03:08:45',NULL,NULL),(30786,20017,'BN','8304830838',0,'2014-01-26 19:00:12',NULL,NULL),(35053,23018,'AP','3378877107',0,'2014-02-12 21:30:28',NULL,NULL),(42242,28060,'TE','5137776990',0,'2014-03-06 21:01:43',NULL,NULL),(43269,28747,'AP','2543389473',0,'2014-03-09 21:00:14',NULL,NULL),(22519,14520,'EM','feferae27@gmail.com',0,'2013-12-28 03:34:17',NULL,NULL),(26563,17087,'TE','2103286278',0,'2014-01-13 02:21:25',NULL,NULL),(10918,7095,'EM','filmaniac2001@gmail.com',0,'2013-12-26 01:50:38',NULL,NULL),(3669,2328,'EM','aherrera316@yahoo.com',0,'2013-12-25 19:31:36',NULL,NULL),(36414,23983,'AP','9853737950',0,'2014-02-15 22:00:22',NULL,NULL),(2337,1423,'EM','JVERDON05@YAHOO.COM',0,'2013-12-25 18:47:19',NULL,NULL),(35424,23287,'AP','7405868443',0,'2014-02-13 22:00:05',NULL,NULL),(24215,15644,'EM','duparker@juno.com',1,'2014-01-02 04:33:54',NULL,NULL),(4555,2899,'TE','3302311143',0,'2013-12-25 20:15:19',NULL,NULL),(11711,7625,'TE','6623636703',0,'2013-12-26 02:46:02',NULL,NULL),(9700,6352,'EM','LJANSON4522@GMAIL.COM',0,'2013-12-26 00:47:05',NULL,NULL),(40553,26915,'BN','5137959998',0,'2014-03-03 01:00:13',NULL,NULL),(233,142,'AP','3308070935',0,'2013-12-25 17:18:44',NULL,NULL),(11124,7232,'EM','gweaver594@gmail.com',0,'2013-12-26 02:01:25',NULL,NULL),(11021,7154,'AP','3305643434',0,'2013-12-26 01:52:17',NULL,NULL),(10740,6982,'TE','4198100264',0,'2013-12-26 01:47:45',NULL,NULL),(27472,17697,'AP','9856340392',0,'2014-01-14 01:33:02',NULL,NULL),(29205,18866,'EM','roche.carrie@gmail.com',0,'2014-01-17 03:36:22',NULL,NULL),(38871,25693,'AP','4323495431',0,'2014-02-26 09:30:13',NULL,NULL),(41056,27276,'AP','8302361263',0,'2014-03-04 21:00:19',NULL,NULL),(10509,6842,'EM','tystang2001@yahoo.com',0,'2013-12-26 01:31:10',NULL,NULL),(1325,810,'TE','6143746404',0,'2013-12-25 18:05:48',NULL,NULL),(26738,17197,'TE','9858513688',0,'2014-01-13 02:22:22',NULL,NULL),(33813,22201,'AP','5135350764',0,'2014-02-09 19:00:15',NULL,NULL),(30792,20020,'TE','4324488151',0,'2014-01-26 19:00:14',NULL,NULL),(25882,16686,'BN','9405808988',0,'2014-01-08 18:24:33',NULL,NULL),(929,572,'AP','9378252981',0,'2013-12-25 17:50:39',NULL,NULL),(986,608,'TE','6145011676',0,'2013-12-25 18:00:29',NULL,NULL),(10986,7136,'EM','bobschulte108@yahoo.com',0,'2013-12-26 01:51:47',NULL,NULL),(37123,24439,'TE','4195846774',0,'2014-02-18 22:01:18',NULL,NULL),(31308,20400,'AP','8324441717',0,'2014-01-29 21:00:20',NULL,NULL),(24414,15763,'TE','2543151395',0,'2014-01-03 02:01:33',NULL,NULL),(25083,16172,'AP','2252350434',0,'2014-01-05 00:00:16',NULL,NULL),(14612,9552,'TE','3305921163',0,'2013-12-26 04:36:19',NULL,NULL),(430,265,'TE','4192361740',0,'2013-12-25 17:21:56',NULL,NULL),(26499,17052,'AP','9378694881',0,'2014-01-13 02:20:59',NULL,NULL),(37689,24849,'TE','5137935469',0,'2014-02-20 04:55:15',NULL,NULL),(9747,6374,'TE','7402977998',0,'2013-12-26 00:47:45',NULL,NULL),(9555,6253,'AP','2253410230',0,'2013-12-26 00:32:02',NULL,NULL),(36014,23690,'TE','9374769860',0,'2014-02-14 21:30:37',NULL,NULL),(32602,21316,'AP','2252187704',0,'2014-02-04 21:00:20',NULL,NULL),(32771,21439,'TE','4149820375',0,'2014-02-04 21:01:23',NULL,NULL),(40988,27233,'AP','4407155019',0,'2014-03-03 21:31:42',NULL,NULL),(8844,5794,'TE','3308484604',0,'2013-12-25 23:47:20',NULL,NULL),(22667,14615,'TE','6625713258',0,'2013-12-28 03:36:46',NULL,NULL),(31190,20312,'TE','2147894892',0,'2014-01-28 21:00:50',NULL,NULL),(31607,20616,'TE','9858579336',0,'2014-01-30 21:00:21',NULL,NULL),(32320,21114,'TE','9039106481',0,'2014-02-03 21:00:09',NULL,NULL),(23151,14923,'EM','burnom@gmail.com',0,'2013-12-30 00:01:46',NULL,NULL),(24987,16102,'EM','chrisdlee@gmail.com',0,'2014-01-04 02:04:50',NULL,NULL),(2134,1314,'AP','5136735241',0,'2013-12-25 18:31:34',NULL,NULL),(7064,4612,'AP','9126634963',0,'2013-12-25 22:06:01',NULL,NULL),(10909,7089,'TE','3306717118',0,'2013-12-26 01:50:29',NULL,NULL),(7823,5106,'EM','stephen.foo@att.net',0,'2013-12-25 23:01:35',NULL,NULL),(8216,5378,'AP','5048127644',0,'2013-12-25 23:08:17',NULL,NULL),(36780,24216,'EM','prabin_bhatpuria@hotmail.com',0,'2014-02-16 19:00:26',NULL,NULL),(23821,15368,'EM','Evonnephilpot@me.com',1,'2014-01-02 04:25:00',NULL,NULL),(24818,16010,'AP','3182783483',0,'2014-01-04 02:01:48',NULL,NULL),(27373,17622,'TE','9034323652',0,'2014-01-14 01:32:28',NULL,NULL),(32045,20916,'TE','3306280788',0,'2014-01-31 21:01:31',NULL,NULL),(41811,27796,'AP','3303090121',0,'2014-03-05 21:31:43',NULL,NULL),(43693,29002,'BN','7193131865',0,'2014-03-10 21:01:20',NULL,NULL),(43992,29185,'AP','3303381185',0,'2014-03-10 21:30:01',NULL,NULL),(2524,1545,'TE','7403536388',0,'2013-12-25 18:50:26',NULL,NULL),(40961,27217,'AP','6012787215',0,'2014-03-03 21:31:32',NULL,NULL),(39482,26113,'AP','6142028760',0,'2014-02-28 06:30:16',NULL,NULL),(38612,25518,'EM','richelle.bradley@yahoo.com',0,'2014-02-25 21:32:05',NULL,NULL),(38328,25322,'TE','2254397575',0,'2014-02-25 21:30:10',NULL,NULL),(37178,24473,'TE','4197275710',0,'2014-02-18 22:01:40',NULL,NULL),(6478,4191,'TE','3308016682',0,'2013-12-25 21:49:39',NULL,NULL),(35039,23013,'TE','2252657991',0,'2014-02-12 21:30:25',NULL,NULL),(26023,16767,'AP','5132038480',0,'2014-01-08 18:25:00',NULL,NULL),(26313,16941,'AP','2259213169',0,'2014-01-13 02:19:54',NULL,NULL),(42334,28113,'AP','3306188618',0,'2014-03-06 21:02:16',NULL,NULL),(35933,23643,'TE','9568271728',0,'2014-02-14 21:30:10',NULL,NULL),(32961,21578,'AP','3303290304',0,'2014-02-05 21:30:24',NULL,NULL),(9781,6401,'AP','5138288282',0,'2013-12-26 00:48:21',NULL,NULL),(26395,16990,'TE','9157571791',0,'2014-01-13 02:20:24',NULL,NULL),(7656,4982,'EM','znismo911@gmail.com',0,'2013-12-25 22:46:46',NULL,NULL),(7489,4873,'AP','5122998574',0,'2013-12-25 22:31:05',NULL,NULL),(26298,16928,'TE','5045782709',0,'2014-01-13 02:19:47',NULL,NULL),(5609,3589,'AP','5132374722',0,'2013-12-25 21:22:59',NULL,NULL),(21964,14149,'EM','brandi.hopkins@mail.com',0,'2013-12-27 02:02:51',NULL,NULL),(5203,3343,'AP','9564994347',0,'2013-12-25 21:16:33',NULL,NULL),(915,564,'AP','4199081983',0,'2013-12-25 17:50:26',NULL,NULL),(38488,25435,'TE','2817422278',0,'2014-02-25 21:31:17',NULL,NULL),(35256,23154,'EM','bnawright@gmail.com',0,'2014-02-12 21:31:43',NULL,NULL),(9767,6386,'EM','irene_motto@yahoo.com',0,'2013-12-26 00:48:04',NULL,NULL),(34356,22536,'AP','2283131016',0,'2014-02-10 21:31:36',NULL,NULL),(33354,21850,'AP','3047302937',0,'2014-02-06 21:01:15',NULL,NULL),(6496,4201,'EM','trevortf@northtxbroadband.com',0,'2013-12-25 21:49:54',NULL,NULL),(3149,1966,'AP','8325387988',0,'2013-12-25 19:01:21',NULL,NULL),(26697,17174,'TE','3306992408',0,'2014-01-13 02:22:09',NULL,NULL),(14817,9701,'AP','5135202502',0,'2013-12-26 04:39:58',NULL,NULL),(41661,27694,'AP','3617520433',0,'2014-03-05 21:30:45',NULL,NULL),(41952,27888,'TE','3305023393',0,'2014-03-05 21:32:37',NULL,NULL),(42557,28318,'EM','katiemichellelong@yahoo.com',0,'2014-03-07 21:30:03',NULL,NULL),(42804,28465,'TE','3306711655',0,'2014-03-07 21:31:28',NULL,NULL),(43335,28787,'TE','9379358432',0,'2014-03-09 21:00:39',NULL,NULL),(33788,22180,'TE','5139178334',0,'2014-02-08 19:30:11',NULL,NULL),(24064,15535,'EM','khub627@gmail.com',1,'2014-01-02 04:30:48',NULL,NULL),(11172,7267,'TE','8312292909',0,'2013-12-26 02:02:18',NULL,NULL),(14665,9594,'TE','4408823552',0,'2013-12-26 04:37:15',NULL,NULL),(1851,1143,'AP','4106032905',0,'2013-12-25 18:18:24',NULL,NULL),(8452,5560,'AP','3305921448',0,'2013-12-25 23:16:26',NULL,NULL),(9522,6232,'TE','9038396108',0,'2013-12-26 00:31:29',NULL,NULL),(43092,28645,'AP','6015739608',0,'2014-03-08 21:30:35',NULL,NULL),(6283,4051,'AP','5133245261',0,'2013-12-25 21:46:24',NULL,NULL),(7920,5159,'EM','tajenben@yahoo.com',0,'2013-12-25 23:03:01',NULL,NULL),(4580,2924,'TE','3307221186',0,'2013-12-25 20:15:50',NULL,NULL),(2415,1472,'AP','9375299774',0,'2013-12-25 18:48:37',NULL,NULL),(14827,9706,'TE','3306506977',0,'2013-12-26 04:45:03',NULL,NULL),(22297,14371,'AP','2162568553',0,'2013-12-28 03:30:32',NULL,NULL),(25714,16575,'AP','5707804711',1,'2014-01-07 10:23:29',NULL,NULL),(27252,17544,'EM','viorel.rebrisorean@yahoo.com',0,'2014-01-13 03:01:51',NULL,NULL),(40908,27185,'TE','5127879479',0,'2014-03-03 21:31:12',NULL,NULL),(32130,20984,'TE','5044939499',0,'2014-02-01 19:00:21',NULL,NULL),(32302,21097,'EM','kathy.johns@mail.com',0,'2014-02-02 19:00:32',NULL,NULL),(40798,27113,'AP','9375727862',0,'2014-03-03 21:30:28',NULL,NULL),(34004,22305,'AP','6143072406',0,'2014-02-10 11:00:39',NULL,NULL),(34679,22740,'EM','radtec1111@yahoo.com',0,'2014-02-11 21:01:20',NULL,NULL),(40548,26910,'TE','5048973246',0,'2014-03-03 01:00:12',NULL,NULL),(35300,23187,'TE','4406685493',0,'2014-02-12 21:32:02',NULL,NULL),(43241,28733,'TE','2259933854',0,'2014-03-09 21:00:04',NULL,NULL),(141,84,'AP','2163769490',0,'2013-12-25 17:17:15',NULL,NULL),(6081,3914,'TE','2107107246',0,'2013-12-25 21:37:11',NULL,NULL),(40529,26901,'AP','8063009553',0,'2014-03-03 01:00:07',NULL,NULL),(38263,25259,'TE','3307184309',0,'2014-02-22 19:00:12',NULL,NULL),(4944,3174,'AP','3306080779',0,'2013-12-25 20:31:38',NULL,NULL),(8831,5781,'EM','eckk1@hotmail.com',0,'2013-12-25 23:47:04',NULL,NULL),(14780,9672,'TE','9377283383',0,'2013-12-26 04:39:16',NULL,NULL),(35984,23675,'BN','3143273381',0,'2014-02-14 21:30:27',NULL,NULL),(29404,19006,'TE','3183771153',0,'2014-01-20 08:06:18',NULL,NULL),(41860,27836,'AP','5135053714',0,'2014-03-05 21:32:04',NULL,NULL),(43969,29168,'EM','creamyc25@yahoo.com',0,'2014-03-10 21:02:58',NULL,NULL),(6269,4044,'AP','9377253352',0,'2013-12-25 21:46:12',NULL,NULL),(1372,835,'AP','5133008920',0,'2013-12-25 18:06:29',NULL,NULL),(40801,27115,'TE','3303431452',0,'2014-03-03 21:30:29',NULL,NULL),(5578,3563,'EM','bastien.sharon@yahoo.com',0,'2013-12-25 21:22:22',NULL,NULL),(35908,23626,'EM','hbburden@yahoo.com',0,'2014-02-13 22:03:20',NULL,NULL),(7130,4652,'EM','deweywarden@gmail.com',0,'2013-12-25 22:07:08',NULL,NULL),(4785,3061,'AP','3183649045',0,'2013-12-25 20:19:11',NULL,NULL),(14130,9255,'AP','9153738545',0,'2013-12-26 04:15:07',NULL,NULL),(31516,20538,'TE','2342490549',0,'2014-01-29 21:01:34',NULL,NULL),(27971,18033,'TE','2167021340',0,'2014-01-15 02:07:09',NULL,NULL),(25193,16242,'AP','5134708042',0,'2014-01-05 00:02:26',NULL,NULL),(26500,17052,'EM','adamcodybrammer@gmail.com',0,'2014-01-13 02:20:59',NULL,NULL),(41729,27748,'TE','8324740909',0,'2014-03-05 21:31:13',NULL,NULL),(210,127,'EM','cwbettsjr@yahoo.com',0,'2013-12-25 17:18:22',NULL,NULL),(39605,26198,'EM','freewheelin8@yahoo.com',0,'2014-02-28 06:30:47',NULL,NULL),(12377,8105,'AP','5613191627',0,'2013-12-26 03:10:57',NULL,NULL),(6373,4105,'EM','digginslupita@gmail.com',0,'2013-12-25 21:47:50',NULL,NULL),(32133,20985,'TE','9375504723',0,'2014-02-01 19:00:22',NULL,NULL),(4371,2785,'EM','ladymercuryrising@gmail.com',0,'2013-12-25 19:49:59',NULL,NULL),(26974,17349,'TE','9375592483',0,'2014-01-13 02:24:07',NULL,NULL),(20367,13120,'TE','5133375720',0,'2013-12-26 12:52:44',NULL,NULL),(42780,28452,'AP','5044153797',0,'2014-03-07 21:31:21',NULL,NULL),(4908,3152,'TE','6149375512',0,'2013-12-25 20:31:04',NULL,NULL),(33836,22214,'AP','4232550448',0,'2014-02-09 19:00:22',NULL,NULL),(4789,3064,'TE','2257571524',0,'2013-12-25 20:19:16',NULL,NULL),(29247,18890,'EM','jeb8799@hotmail.com',0,'2014-01-17 03:36:32',NULL,NULL),(11713,7626,'TE','4193082555',0,'2013-12-26 02:46:05',NULL,NULL),(8466,5571,'AP','5134736877',0,'2013-12-25 23:16:40',NULL,NULL),(29006,18724,'TE','4193108303',0,'2014-01-17 03:35:35',NULL,NULL),(23895,15416,'TE','3612195318',1,'2014-01-02 04:27:18',NULL,NULL),(27554,17757,'EM','awest4499@gmail.com',0,'2014-01-14 01:33:31',NULL,NULL),(27376,17624,'TE','9784001764',0,'2014-01-14 01:32:29',NULL,NULL),(8155,5338,'TE','9375208110',0,'2013-12-25 23:07:17',NULL,NULL),(7038,4596,'EM','DIANNE2560@YAHOO.COM',0,'2013-12-25 22:05:36',NULL,NULL),(26028,16771,'TE','4197989082',0,'2014-01-08 18:25:02',NULL,NULL),(21844,14070,'EM','ryan5769@sbcglobel.net',0,'2013-12-27 02:00:51',NULL,NULL),(454,284,'TE','9373824774',0,'2013-12-25 17:30:22',NULL,NULL),(32900,21537,'EM','tommac1962@hotmail.com',0,'2014-02-05 21:30:09',NULL,NULL),(28919,18668,'TE','9032926072',0,'2014-01-17 03:35:16',NULL,NULL),(1574,970,'EM','jjjdwright@juno.com',0,'2013-12-25 18:10:01',NULL,NULL),(8703,5710,'AP','3303280576',0,'2013-12-25 23:45:08',NULL,NULL),(25308,16320,'TE','2253248672',0,'2014-01-07 04:01:40',NULL,NULL),(2448,1501,'AP','5137037151',0,'2013-12-25 18:49:18',NULL,NULL),(24348,15726,'TE','6142582204',0,'2014-01-03 02:00:20',NULL,NULL),(22820,14716,'TE','6145607133',1,'2013-12-29 11:09:26',NULL,NULL),(261,160,'EM','jatsunrise@yahoo.com',0,'2013-12-25 17:19:10',NULL,NULL),(33309,21816,'TE','3308427160',0,'2014-02-06 21:00:56',NULL,NULL),(7303,4754,'TE','2148010322',0,'2013-12-25 22:15:18',NULL,NULL),(32477,21218,'EM','Jamesdavis267@gmail.com',0,'2014-02-03 21:01:03',NULL,NULL),(28291,18237,'AP','8063465026',0,'2014-01-16 08:44:23',NULL,NULL),(20643,13278,'TE','5122215397',0,'2013-12-26 12:57:06',NULL,NULL),(21812,14053,'AP','6143608460',0,'2013-12-27 02:00:22',NULL,NULL),(38919,25728,'TE','3183814086',0,'2014-02-26 09:30:33',NULL,NULL),(33514,21968,'TE','4199607136',0,'2014-02-07 19:00:29',NULL,NULL),(29378,18986,'TE','6469263372',0,'2014-01-20 08:06:09',NULL,NULL),(10706,6961,'TE','6145712824',0,'2013-12-26 01:47:15',NULL,NULL),(9760,6382,'AP','2165363724',0,'2013-12-26 00:47:58',NULL,NULL),(9607,6288,'TE','4403656697',0,'2013-12-26 00:45:35',NULL,NULL),(1058,652,'TE','4405335711',0,'2013-12-25 18:01:37',NULL,NULL),(43199,28708,'AP','7346254876',0,'2014-03-08 21:31:12',NULL,NULL),(40806,27117,'TE','4404742334',0,'2014-03-03 21:30:31',NULL,NULL),(674,421,'TE','9373696753',0,'2013-12-25 17:46:38',NULL,NULL),(40554,26917,'TE','9374225687',0,'2014-03-03 01:00:14',NULL,NULL),(34262,22474,'TE','2163738757',0,'2014-02-10 21:31:00',NULL,NULL),(28582,18426,'TE','3185177836',0,'2014-01-16 08:45:55',NULL,NULL),(21330,13704,'EM','semejoe@gmail.com',0,'2013-12-26 13:08:47',NULL,NULL),(22242,14333,'EM','bobwhan1@aol.com',0,'2013-12-27 02:07:39',NULL,NULL),(27778,17907,'EM','cheraine20@hotmail.com',0,'2014-01-15 02:06:26',NULL,NULL),(22515,14517,'AP','9564596251',0,'2013-12-28 03:34:13',NULL,NULL),(23511,15167,'EM','mrs.smith0723@gmail.com',0,'2014-01-01 12:06:28',NULL,NULL),(40220,26678,'AP','3187692969',0,'2014-02-28 21:31:22',NULL,NULL),(37716,24867,'EM','areniqua@yahoo.com',0,'2014-02-20 05:32:20',NULL,NULL),(2581,1574,'AP','9033305444',0,'2013-12-25 18:51:17',NULL,NULL),(3825,2432,'AP','3308153069',0,'2013-12-25 19:34:13',NULL,NULL),(27246,17542,'AP','4192282006',0,'2014-01-13 03:01:49',NULL,NULL),(24714,15945,'EM','bethany.dawn22@yahoo.com',0,'2014-01-03 02:07:19',NULL,NULL),(24833,16016,'EM','mzkismet@yahoo.com',0,'2014-01-04 02:02:01',NULL,NULL),(27066,17408,'AP','2106019331',0,'2014-01-13 03:00:20',NULL,NULL),(43871,29110,'TE','2252784551',0,'2014-03-10 21:02:23',NULL,NULL),(7378,4802,'TE','2252442040',0,'2013-12-25 22:16:32',NULL,NULL),(34145,22388,'EM','EAMJC66@YAHOO.COM',0,'2014-02-10 21:30:13',NULL,NULL),(884,548,'TE','2145540396',0,'2013-12-25 17:49:57',NULL,NULL),(28601,18435,'TE','2253023953',0,'2014-01-16 08:46:00',NULL,NULL),(25278,16298,'TE','5048269016',0,'2014-01-07 04:01:05',NULL,NULL),(4690,3000,'AP','4407242560',0,'2013-12-25 20:17:38',NULL,NULL),(9411,6160,'AP','5134654928',0,'2013-12-26 00:16:46',NULL,NULL),(8620,5662,'EM','stephen.marquart@gmail.com',0,'2013-12-25 23:31:49',NULL,NULL),(5158,3309,'AP','5134901048',0,'2013-12-25 21:15:51',NULL,NULL),(7319,4759,'AP','8067909437',0,'2013-12-25 22:15:30',NULL,NULL),(14379,9402,'AP','2813829451',0,'2013-12-26 04:32:38',NULL,NULL),(38903,25717,'TE','2545926870',0,'2014-02-26 09:30:26',NULL,NULL),(38467,25422,'EM','chestenebickle@yahoo.com',0,'2014-02-25 21:31:09',NULL,NULL),(3321,2089,'TE','9857503273',0,'2013-12-25 19:16:50',NULL,NULL),(33242,21770,'TE','6143306543',0,'2014-02-06 21:00:31',NULL,NULL),(21619,13914,'AP','4197880846',0,'2013-12-26 13:14:02',NULL,NULL),(33151,21714,'AP','5675252804',0,'2014-02-05 21:31:16',NULL,NULL),(32946,21570,'TE','3307856060',0,'2014-02-05 21:30:21',NULL,NULL),(25010,16116,'TE','3186139790',0,'2014-01-04 02:05:17',NULL,NULL),(26683,17164,'TE','5042764541',0,'2014-01-13 02:22:04',NULL,NULL),(27877,17964,'EM','e76971072@yahoo.com',0,'2014-01-15 02:06:47',NULL,NULL),(28351,18266,'EM','ptsmus@yahoo.com',0,'2014-01-16 08:44:40',NULL,NULL),(29973,19395,'TE','3308335323',1,'2014-01-22 03:22:50',NULL,NULL),(30240,19587,'TE','6013834357',0,'2014-01-23 03:02:43',NULL,NULL),(34214,22439,'TE','9404976067',0,'2014-02-10 21:30:41',NULL,NULL),(11925,7761,'EM','oblevins@cinci.rr.com',0,'2013-12-26 03:02:47',NULL,NULL),(1204,732,'EM','marystults85@hotmail.com',0,'2013-12-25 18:03:51',NULL,NULL),(30932,20116,'AP','7404060529',0,'2014-01-27 21:00:43',NULL,NULL),(30519,19797,'TE','6016721021',0,'2014-01-23 21:01:46',NULL,NULL),(27660,17831,'TE','6012124832',0,'2014-01-15 02:05:59',NULL,NULL),(42844,28493,'EM','lorie@impromptu.ms',0,'2014-03-07 21:31:43',NULL,NULL),(7501,4888,'TE','2813003679',0,'2013-12-25 22:31:26',NULL,NULL),(41996,27912,'AP','3184640048',0,'2014-03-06 21:00:16',NULL,NULL),(41407,27510,'AP','4197046493',0,'2014-03-04 21:02:32',NULL,NULL),(31274,20373,'TE','3182651051',0,'2014-01-29 21:00:07',NULL,NULL),(10911,7091,'TE','3303046733',0,'2013-12-26 01:50:33',NULL,NULL),(24991,16107,'TE','6014413482',0,'2014-01-04 02:04:57',NULL,NULL),(43004,28598,'EM','glazzy85@gmail.com',0,'2014-03-08 21:30:07',NULL,NULL),(40254,26704,'EM','vyenthor@yahoo.com',0,'2014-02-28 21:31:35',NULL,NULL),(5027,3225,'TE','5134466613',0,'2013-12-25 20:45:53',NULL,NULL),(13921,9078,'AP','2162586778',0,'2013-12-26 04:06:45',NULL,NULL),(26330,16949,'AP','6016975726',0,'2014-01-13 02:19:59',NULL,NULL),(3690,2340,'TE','9564601131',0,'2013-12-25 19:31:56',NULL,NULL),(3195,2007,'EM','tmyers@wcoil.com',0,'2013-12-25 19:02:23',NULL,NULL),(4495,2858,'EM','sdaffeh@student.cscc.edu',0,'2013-12-25 20:01:34',NULL,NULL),(36052,23714,'EM','MIRANDIAY@YAHOO.COM',0,'2014-02-14 21:30:49',NULL,NULL),(28777,18571,'TE','3304211859',0,'2014-01-16 08:47:04',NULL,NULL),(7868,5132,'AP','4692078849',0,'2013-12-25 23:02:16',NULL,NULL),(14115,9229,'AP','9376180149',0,'2013-12-26 04:10:26',NULL,NULL),(36951,24334,'EM','lmrfbg@yahoo.com',0,'2014-02-18 22:00:15',NULL,NULL),(34952,22945,'TE','5132644351',0,'2014-02-11 21:30:23',NULL,NULL),(3844,2444,'AP','5132758029',0,'2013-12-25 19:34:32',NULL,NULL),(33915,22260,'AP','2104732080',0,'2014-02-10 11:00:07',NULL,NULL),(24542,15829,'AP','3308586636',0,'2014-01-03 02:03:48',NULL,NULL),(20542,13224,'TE','2542457149',0,'2013-12-26 12:55:33',NULL,NULL),(11189,7275,'EM','rickmagee69@yahoo.com',0,'2013-12-26 02:02:33',NULL,NULL),(34507,22635,'TE','8067994539',0,'2014-02-11 21:00:20',NULL,NULL),(30338,19657,'TE','5134250477',0,'2014-01-23 21:00:23',NULL,NULL),(22751,14671,'EM','firefighter5340@hotmail.com',1,'2013-12-29 11:08:16',NULL,NULL),(40502,26879,'EM','hercik4@roadrunner.com',0,'2014-03-01 21:01:08',NULL,NULL),(6369,4102,'EM','elsa_decker@yahoo.com',0,'2013-12-25 21:47:46',NULL,NULL),(11082,7196,'TE','8593215015',0,'2013-12-26 02:00:34',NULL,NULL),(2316,1414,'TE','5044305508',0,'2013-12-25 18:47:02',NULL,NULL),(35995,23679,'EM','myrtleb3@gmail.com',0,'2014-02-14 21:30:30',NULL,NULL),(35873,23591,'TE','3306064277',0,'2014-02-13 22:03:02',NULL,NULL),(29450,19043,'TE','7133205831',0,'2014-01-20 08:06:38',NULL,NULL),(26890,17300,'TE','2147621933',0,'2014-01-13 02:23:38',NULL,NULL),(24892,16047,'TE','9797433923',0,'2014-01-04 02:03:05',NULL,NULL),(39778,26302,'EM','yost.juanita@yahoo.com',0,'2014-02-28 06:31:29',NULL,NULL),(5637,3616,'TE','4193064757',0,'2013-12-25 21:23:34',NULL,NULL),(37626,24797,'AP','6145569340',0,'2014-02-20 04:47:54',NULL,NULL),(28562,18416,'TE','3376549115',0,'2014-01-16 08:45:50',NULL,NULL),(4991,3204,'TE','2167893245',0,'2013-12-25 20:45:16',NULL,NULL),(26168,16848,'AP','9372120519',0,'2014-01-13 02:18:38',NULL,NULL),(25021,16124,'TE','3372767749',0,'2014-01-04 02:05:30',NULL,NULL),(110,66,'EM','mattie.reitman@gmail.com',0,'2013-12-25 17:16:47',NULL,NULL),(41806,27791,'AP','6019543728',0,'2014-03-05 21:31:41',NULL,NULL),(14515,9484,'EM','owlbhappy@gmail.com',0,'2013-12-26 04:34:44',NULL,NULL),(40069,26566,'TE','5133569446',0,'2014-02-28 21:30:23',NULL,NULL),(38588,25500,'EM','AMONAEK1@SBCGLOAL.NET',0,'2014-02-25 21:31:54',NULL,NULL),(34421,22580,'AP','4196155098',0,'2014-02-10 21:32:02',NULL,NULL),(32748,21426,'TE','5132589243',0,'2014-02-04 21:01:15',NULL,NULL),(31633,20637,'TE','9013048526',0,'2014-01-30 21:00:31',NULL,NULL),(23872,15405,'TE','4323527308',1,'2014-01-02 04:26:55',NULL,NULL),(36674,24149,'TE','5137975230',0,'2014-02-15 22:01:55',NULL,NULL),(35120,23068,'AP','5047173298',0,'2014-02-12 21:30:55',NULL,NULL),(34861,22862,'AP','6016683263',0,'2014-02-11 21:02:26',NULL,NULL),(34209,22435,'AP','2105403210',0,'2014-02-10 21:30:39',NULL,NULL),(33572,22011,'EM','memawshowalter@aol.com',0,'2014-02-07 19:00:51',NULL,NULL),(30604,19862,'TE','9377764425',0,'2014-01-24 21:00:36',NULL,NULL),(28060,18086,'AP','3184196946',0,'2014-01-15 02:07:28',NULL,NULL),(28376,18284,'TE','7405919818',0,'2014-01-16 08:44:48',NULL,NULL),(31850,20795,'TE','9157305978',0,'2014-01-31 21:00:17',NULL,NULL),(29593,19122,'AP','5673712549',0,'2014-01-21 08:45:18',NULL,NULL),(23137,14916,'AP','2169905792',0,'2013-12-30 00:01:33',NULL,NULL),(21017,13523,'TE','5042373210',0,'2013-12-26 13:03:15',NULL,NULL),(8913,5833,'EM','aggiegabecedillo@yahoo.com',0,'2013-12-25 23:48:22',NULL,NULL),(1945,1205,'TE','4192607434',0,'2013-12-25 18:19:58',NULL,NULL),(1909,1180,'TE','6147255962',0,'2013-12-25 18:19:22',NULL,NULL),(6002,3855,'AP','3187585314',0,'2013-12-25 21:35:46',NULL,NULL),(1775,1097,'TE','2167730746',0,'2013-12-25 18:17:10',NULL,NULL),(13607,8869,'TE','8328308526',0,'2013-12-26 04:01:31',NULL,NULL),(38431,25398,'AP','3303288844',0,'2014-02-25 21:30:55',NULL,NULL),(9213,6027,'TE','3615586040',0,'2013-12-26 00:01:03',NULL,NULL),(30834,20045,'TE','3303388915',0,'2014-01-26 19:00:30',NULL,NULL),(24452,15785,'TE','3375323929',0,'2014-01-03 02:02:17',NULL,NULL),(22696,14640,'TE','8327768249',1,'2013-12-29 11:07:24',NULL,NULL),(22721,14651,'AP','3618131555',1,'2013-12-29 11:07:45',NULL,NULL),(22739,14664,'EM','jeffabraham77@gmail.com',1,'2013-12-29 11:08:05',NULL,NULL),(23023,14850,'AP','3307141148',1,'2013-12-29 11:15:06',NULL,NULL),(43355,28797,'TE','3306344893',0,'2014-03-09 21:00:46',NULL,NULL),(20572,13238,'TE','3252159632',0,'2013-12-26 12:55:59',NULL,NULL),(41469,27558,'AP','2148616773',0,'2014-03-04 21:30:15',NULL,NULL),(37925,25025,'AP','9157405908',0,'2014-02-20 22:00:59',NULL,NULL),(2469,1515,'TE','9374896030',0,'2013-12-25 18:49:38',NULL,NULL),(35573,23393,'TE','3309409778',0,'2014-02-13 22:01:07',NULL,NULL),(6971,4545,'TE','9374780105',0,'2013-12-25 22:04:25',NULL,NULL),(10249,6699,'TE','5135985119',0,'2013-12-26 01:01:51',NULL,NULL),(34438,22593,'TE','3306961814',0,'2014-02-10 21:32:10',NULL,NULL),(32372,21150,'EM','AmandaMChecco@gmail.com',0,'2014-02-03 21:00:27',NULL,NULL),(27424,17661,'EM','warsameali92@hotmail.com',0,'2014-01-14 01:32:45',NULL,NULL),(25429,16400,'AP','2144054413',0,'2014-01-07 04:03:51',NULL,NULL),(26430,17005,'EM','lisamarie.lovetarot@gmail.com',0,'2014-01-13 02:20:33',NULL,NULL),(43045,28619,'TE','9403660278',0,'2014-03-08 21:30:20',NULL,NULL),(36687,24155,'TE','4197532163',0,'2014-02-15 22:01:59',NULL,NULL),(36309,23906,'TE','4194473042',0,'2014-02-14 21:32:27',NULL,NULL),(32123,20976,'AP','6018131925',0,'2014-02-01 19:00:18',NULL,NULL),(21614,13912,'TE','7345580632',0,'2013-12-26 13:13:58',NULL,NULL),(27121,17461,'AP','4199694682',0,'2014-01-13 03:00:42',NULL,NULL),(26205,16866,'TE','5126329341',0,'2014-01-13 02:19:13',NULL,NULL),(26673,17160,'AP','2252525065',0,'2014-01-13 02:22:01',NULL,NULL),(26816,17247,'AP','3302426965',0,'2014-01-13 02:23:10',NULL,NULL),(39098,25868,'AP','3377810337',0,'2014-02-26 21:00:49',NULL,NULL),(30181,19553,'AP','3378849900',0,'2014-01-23 03:02:30',NULL,NULL),(29021,18736,'TE','3306500220',0,'2014-01-17 03:35:38',NULL,NULL),(26841,17268,'EM','Mylisalynn@msn.com',0,'2014-01-13 02:23:20',NULL,NULL),(292,179,'EM','FORSILVIA41@YAHOO.COM',0,'2013-12-25 17:19:38',NULL,NULL),(41210,27371,'TE','6625153122',0,'2014-03-04 21:01:16',NULL,NULL),(3593,2256,'TE','2162874884',0,'2013-12-25 19:30:10',NULL,NULL),(39286,25992,'EM','mdouglas601@att.net',0,'2014-02-26 21:01:58',NULL,NULL),(37412,24639,'TE','3183871479',0,'2014-02-20 04:19:51',NULL,NULL),(33327,21830,'AP','2147792937',0,'2014-02-06 21:01:04',NULL,NULL),(29120,18805,'EM','camilleward1969@outlook.com',0,'2014-01-17 03:36:01',NULL,NULL),(29692,19190,'EM','richthig@embarqmail.com',0,'2014-01-21 08:46:12',NULL,NULL),(30371,19676,'AP','3254367103',0,'2014-01-23 21:00:35',NULL,NULL),(31275,20373,'AP','3182651051',0,'2014-01-29 21:00:07',NULL,NULL),(33273,21788,'AP','5133286144',0,'2014-02-06 21:00:42',NULL,NULL),(876,544,'TE','3309627125',0,'2013-12-25 17:49:50',NULL,NULL),(6980,4553,'EM','nada.alabakovski@yahoo.com',0,'2013-12-25 22:04:35',NULL,NULL),(2453,1507,'TE','5136489913',0,'2013-12-25 18:49:24',NULL,NULL),(4755,3045,'TE','8068725369',0,'2013-12-25 20:18:45',NULL,NULL),(39490,26120,'AP','7405137275',0,'2014-02-28 06:30:19',NULL,NULL),(23945,15450,'TE','5126563999',1,'2014-01-02 04:28:21',NULL,NULL),(24572,15850,'AP','4192362668',0,'2014-01-03 02:04:23',NULL,NULL),(39236,25953,'EM','DENIGRISLANDSCAPE@SBCGLOBAL.NET',0,'2014-02-26 21:01:38',NULL,NULL),(35329,23215,'TE','6019197205',0,'2014-02-12 21:32:15',NULL,NULL),(29845,19309,'AP','4326347618',1,'2014-01-22 03:22:05',NULL,NULL),(31985,20881,'EM','chainshaws@yahoo.com',0,'2014-01-31 21:01:09',NULL,NULL),(30796,20023,'BN','3188347065',0,'2014-01-26 19:00:16',NULL,NULL),(43948,29151,'EM','friend1@zoominternet.net',0,'2014-03-10 21:02:50',NULL,NULL),(8534,5606,'AP','5136801043',0,'2013-12-25 23:30:25',NULL,NULL),(8400,5528,'TE','4783355655',0,'2013-12-25 23:15:30',NULL,NULL),(14625,9559,'EM','tournoir1@gmail.com',0,'2013-12-26 04:36:32',NULL,NULL),(13582,8856,'TE','8309286086',0,'2013-12-26 04:01:09',NULL,NULL),(11106,7217,'TE','3309321036',0,'2013-12-26 02:01:04',NULL,NULL),(8245,5393,'AP','3183086370',0,'2013-12-25 23:08:44',NULL,NULL),(8123,5320,'AP','3306122882',0,'2013-12-25 23:06:47',NULL,NULL),(10444,6806,'AP','8063177261',0,'2013-12-26 01:30:09',NULL,NULL),(5583,3569,'TE','4193463100',0,'2013-12-25 21:22:30',NULL,NULL),(9988,6536,'TE','7139731357',0,'2013-12-26 00:51:48',NULL,NULL),(9519,6230,'AP','5138852566',0,'2013-12-26 00:31:25',NULL,NULL),(5431,3475,'EM','pkhammachone@gmail.com',0,'2013-12-25 21:20:04',NULL,NULL),(21700,13971,'EM','mcintosh_randy@yahoo.com',0,'2013-12-26 13:15:25',NULL,NULL),(22765,14679,'TE','6014474662',1,'2013-12-29 11:08:30',NULL,NULL),(28290,18237,'TE','8063465026',0,'2014-01-16 08:44:23',NULL,NULL),(30939,20118,'EM','allyssahixenbaugh@gmail.com',0,'2014-01-27 21:00:45',NULL,NULL),(31797,20754,'EM','henryhouse6@gmail.com',0,'2014-01-30 21:01:32',NULL,NULL),(32363,21146,'AP','4322137546',0,'2014-02-03 21:00:25',NULL,NULL),(35844,23568,'AP','6015400181',0,'2014-02-13 22:02:50',NULL,NULL),(36082,23733,'EM','ACSIMS0909@GMAIL.COM',0,'2014-02-14 21:30:59',NULL,NULL),(36102,23750,'EM','kellyjdahl@gmail.com',0,'2014-02-14 21:31:07',NULL,NULL),(43905,29128,'EM','joecookies@yahoo.com',0,'2014-03-10 21:02:35',NULL,NULL),(36862,24275,'EM','smkelby@outlook.com',0,'2014-02-18 21:30:03',NULL,NULL),(37338,24584,'AP','5133799521',0,'2014-02-20 04:09:14',NULL,NULL),(37410,24637,'AP','3373511617',0,'2014-02-20 04:19:30',NULL,NULL),(38257,25256,'AP','4196181258',0,'2014-02-21 22:01:17',NULL,NULL),(38580,25497,'TE','4197821478',0,'2014-02-25 21:31:52',NULL,NULL),(39785,26306,'AP','8178965626',0,'2014-02-28 06:31:31',NULL,NULL),(40053,26553,'AP','3309330092',0,'2014-02-28 21:30:15',NULL,NULL),(40105,26596,'BN','4322716877',0,'2014-02-28 21:30:39',NULL,NULL),(40117,26603,'BN','6823518882',0,'2014-02-28 21:30:43',NULL,NULL),(41732,27749,'TE','2255884243',0,'2014-03-05 21:31:14',NULL,NULL),(1804,1117,'TE','9378027153',0,'2013-12-25 18:17:42',NULL,NULL),(6859,4450,'TE','4406384574',0,'2013-12-25 22:02:22',NULL,NULL),(6824,4428,'EM','StanleyHill60@gmail.com',0,'2013-12-25 22:01:48',NULL,NULL),(13909,9067,'EM','conangelazul@gmail.com',0,'2013-12-26 04:06:31',NULL,NULL),(11532,7505,'EM','eifel1249@aol.com',0,'2013-12-26 02:31:58',NULL,NULL),(4586,2926,'EM','amjohnson@zoomtown.com',0,'2013-12-25 20:15:55',NULL,NULL),(4890,3135,'AP','2253373978',0,'2013-12-25 20:30:39',NULL,NULL),(23391,15066,'TE','3184762532',0,'2014-01-01 12:03:45',NULL,NULL),(24426,15768,'EM','cemagness89@att.net',0,'2014-01-03 02:01:45',NULL,NULL),(28452,18335,'TE','5139233164',0,'2014-01-16 08:45:14',NULL,NULL),(34024,22314,'EM','tigerrogers.kwr@gmail.com',0,'2014-02-10 11:00:48',NULL,NULL),(41377,27486,'TE','3308197455',0,'2014-03-04 21:02:21',NULL,NULL),(43894,29122,'EM','obamacare@bitninja.net',0,'2014-03-10 21:02:32',NULL,NULL),(8666,5690,'EM','maryann.brausch@gmail.com',0,'2013-12-25 23:32:36',NULL,NULL),(2468,1514,'TE','7575289665',0,'2013-12-25 18:49:37',NULL,NULL),(14311,9358,'AP','2252816454',0,'2013-12-26 04:31:28',NULL,NULL),(26551,17078,'TE','9366157337',0,'2014-01-13 02:21:21',NULL,NULL),(31834,20783,'EM','cornelsuciu52@yahoo.com',0,'2014-01-31 21:00:11',NULL,NULL),(28457,18338,'TE','4408290403',0,'2014-01-16 08:45:16',NULL,NULL),(27078,17415,'EM','avatar2011@gmail.com',0,'2014-01-13 03:00:24',NULL,NULL),(43495,28882,'TE','2544356283',0,'2014-03-10 21:00:09',NULL,NULL),(35255,23154,'AP','5134467040',0,'2014-02-12 21:31:43',NULL,NULL),(32923,21552,'AP','2166506815',0,'2014-02-05 21:30:14',NULL,NULL),(27155,17484,'EM','Danyeilhoy18@yahoo.com',0,'2014-01-13 03:01:15',NULL,NULL),(14644,9580,'EM','nancylignoski@hotmail.com',0,'2013-12-26 04:36:53',NULL,NULL),(24743,15964,'EM','philip@eggers.com',0,'2014-01-04 02:00:25',NULL,NULL),(25366,16358,'EM','paytonjoanie2001@gmail.com',0,'2014-01-07 04:02:41',NULL,NULL),(21890,14103,'TE','3305548225',0,'2013-12-27 02:01:39',NULL,NULL),(6543,4229,'EM','rexfalk@gmail.com',0,'2013-12-25 21:50:40',NULL,NULL),(23233,14971,'TE','8328766017',0,'2014-01-01 12:00:49',NULL,NULL),(24718,15947,'TE','4193414932',0,'2014-01-03 02:07:24',NULL,NULL),(2588,1579,'AP','5125635161',0,'2013-12-25 18:51:24',NULL,NULL),(42232,28054,'TE','6015402289',0,'2014-03-06 21:01:39',NULL,NULL),(42286,28081,'TE','2146767481',0,'2014-03-06 21:01:57',NULL,NULL),(383,235,'TE','4197260544',0,'2013-12-25 17:21:08',NULL,NULL),(28754,18557,'TE','5135035295',0,'2014-01-16 08:46:57',NULL,NULL),(10179,6652,'AP','2167986884',0,'2013-12-26 01:00:36',NULL,NULL),(26246,16892,'AP','8177162578',0,'2014-01-13 02:19:28',NULL,NULL),(2827,1708,'EM','danieldonkor1@yahoo.com',0,'2013-12-25 18:54:57',NULL,NULL),(25069,16163,'TE','7134599700',0,'2014-01-04 06:00:14',NULL,NULL),(8670,5692,'AP','5132521826',0,'2013-12-25 23:32:39',NULL,NULL),(38977,25772,'AP','4403424303',0,'2014-02-26 09:30:57',NULL,NULL),(42430,28182,'AP','4197053156',0,'2014-03-06 21:02:54',NULL,NULL),(35637,23435,'TE','9562437837',0,'2014-02-13 22:01:29',NULL,NULL),(14839,9712,'EM','codypowell85@gmail.com',0,'2013-12-26 04:45:14',NULL,NULL),(21042,13537,'EM','calloway.b3@gmail.com',0,'2013-12-26 13:03:39',NULL,NULL),(33441,21904,'TE','4197547145',0,'2014-02-06 21:01:49',NULL,NULL),(30668,19914,'EM','sabika.aziz@gmail.com',0,'2014-01-24 21:01:02',NULL,NULL),(26360,16965,'TE','3307620018',0,'2014-01-13 02:20:10',NULL,NULL),(1404,858,'TE','4196576940',0,'2013-12-25 18:07:05',NULL,NULL),(3722,2361,'AP','3303886461',0,'2013-12-25 19:32:30',NULL,NULL),(35477,23331,'AP','5133684590',0,'2014-02-13 22:00:31',NULL,NULL),(35114,23066,'TE','5047995952',0,'2014-02-12 21:30:54',NULL,NULL),(34529,22651,'TE','2816102150',0,'2014-02-11 21:00:28',NULL,NULL),(20407,13142,'TE','9372707902',0,'2013-12-26 12:53:20',NULL,NULL),(34127,22375,'AP','5133040572',0,'2014-02-10 21:30:05',NULL,NULL),(33746,22143,'BN','7404590231',0,'2014-02-08 19:00:50',NULL,NULL),(33331,21834,'TE','8174209161',0,'2014-02-06 21:01:06',NULL,NULL),(8226,5384,'EM','jvergesjr@gmail.com',0,'2013-12-25 23:08:27',NULL,NULL),(32472,21216,'AP','3185426418',0,'2014-02-03 21:01:01',NULL,NULL),(32454,21204,'EM','nhainugyen@aol.com',0,'2014-02-03 21:00:55',NULL,NULL),(32285,21088,'EM','kathy.johns@mail.com',0,'2014-02-02 19:00:26',NULL,NULL),(31900,20818,'EM','jdmohon@cocks.net',0,'2014-01-31 21:00:34',NULL,NULL),(903,559,'EM','richard_juhu@yahoo.com',0,'2013-12-25 17:50:15',NULL,NULL),(23738,15315,'EM','loribarrientos@hotmail.com',1,'2014-01-02 04:23:22',NULL,NULL),(4092,2610,'EM','jeannedavidbob@yahoo.com',0,'2013-12-25 19:45:35',NULL,NULL),(1088,669,'TE','6148559209',0,'2013-12-25 18:02:05',NULL,NULL),(3123,1945,'EM','angelaburnett@fuse.net',0,'2013-12-25 19:00:49',NULL,NULL),(37957,25045,'EM','cassygaul24@yahoo.com',0,'2014-02-20 22:01:13',NULL,NULL),(41660,27694,'TE','3617520433',0,'2014-03-05 21:30:45',NULL,NULL),(36829,24256,'TE','9152069515',0,'2014-02-17 19:00:07',NULL,NULL),(33594,22022,'EM','elisabeth.hubbell@yahoo.com',0,'2014-02-07 19:00:59',NULL,NULL),(8504,5593,'AP','6018740645',0,'2013-12-25 23:17:20',NULL,NULL),(5443,3486,'TE','5135501905',0,'2013-12-25 21:20:18',NULL,NULL),(5836,3745,'TE','9038751910',0,'2013-12-25 21:33:01',NULL,NULL),(29332,18954,'TE','8326337271',0,'2014-01-20 08:05:51',NULL,NULL),(27756,17896,'AP','6785764484',0,'2014-01-15 02:06:21',NULL,NULL),(40450,26854,'TE','6017509205',0,'2014-03-01 21:00:53',NULL,NULL),(1046,644,'EM','elidbates@yahoo.com',0,'2013-12-25 18:01:27',NULL,NULL),(35280,23169,'TE','9793393770',0,'2014-02-12 21:31:52',NULL,NULL),(31578,20594,'TE','4408717029',0,'2014-01-30 21:00:10',NULL,NULL),(2015,1248,'EM','steve.c.mcgarvey@gmail.com',0,'2013-12-25 18:21:08',NULL,NULL),(31295,20391,'TE','9038964927',0,'2014-01-29 21:00:16',NULL,NULL),(30603,19861,'EM','christy_mcmurry@yahoo.com',0,'2014-01-24 21:00:36',NULL,NULL),(26412,16997,'EM','BrianJamesPE@msn.com',0,'2014-01-13 02:20:28',NULL,NULL),(1501,922,'EM','jamesdwighthayes@gmail.com',0,'2013-12-25 18:08:54',NULL,NULL),(24510,15811,'TE','5049204680',0,'2014-01-03 02:03:11',NULL,NULL),(22921,14789,'AP','7403500202',1,'2013-12-29 11:13:27',NULL,NULL),(12341,8071,'AP','5132071794',0,'2013-12-26 03:10:14',NULL,NULL),(26424,17003,'EM','engmar1@hotmail.com',0,'2014-01-13 02:20:32',NULL,NULL),(12433,8145,'EM','TOM-BETTY@HOTMAIL.COM',0,'2013-12-26 03:15:52',NULL,NULL),(22800,14702,'TE','9373397452',1,'2013-12-29 11:09:06',NULL,NULL),(3246,2043,'TE','9154437918',0,'2013-12-25 19:15:39',NULL,NULL),(21895,14107,'TE','6142360412',0,'2013-12-27 02:01:45',NULL,NULL),(9221,6034,'EM','L.d.proc@sbcglobal.net',0,'2013-12-26 00:01:14',NULL,NULL),(10382,6765,'EM','1234yann@gmail.com',0,'2013-12-26 01:16:29',NULL,NULL),(30222,19577,'EM','3feetent@gmail.com',0,'2014-01-23 03:02:39',NULL,NULL),(12295,8042,'TE','4403206091',0,'2013-12-26 03:09:27',NULL,NULL),(40108,26598,'TE','5127888598',0,'2014-02-28 21:30:40',NULL,NULL),(43750,29045,'TE','4403548939',0,'2014-03-10 21:01:43',NULL,NULL),(36012,23689,'TE','3306203574',0,'2014-02-14 21:30:36',NULL,NULL),(34306,22510,'EM','blueeyedblack@gmail.com',0,'2014-02-10 21:31:18',NULL,NULL),(29534,19090,'TE','3305754007',0,'2014-01-21 08:44:31',NULL,NULL),(5025,3224,'TE','3307241529',0,'2013-12-25 20:45:51',NULL,NULL),(20325,13096,'AP','5133795914',0,'2013-12-26 12:52:02',NULL,NULL),(326,203,'AP','4192365783',0,'2013-12-25 17:20:15',NULL,NULL),(5718,3669,'TE','3309637170',0,'2013-12-25 21:31:07',NULL,NULL),(13865,9040,'EM','dvanke@neo.rr.com',0,'2013-12-26 04:05:48',NULL,NULL),(40931,27198,'AP','5128263489',0,'2014-03-03 21:31:20',NULL,NULL),(36895,24299,'AP','4093774360',0,'2014-02-18 21:30:18',NULL,NULL),(25996,16749,'AP','2148467027',0,'2014-01-08 18:24:54',NULL,NULL),(2487,1527,'TE','5133744850',0,'2013-12-25 18:49:55',NULL,NULL),(24142,15596,'TE','6145066844',1,'2014-01-02 04:32:31',NULL,NULL),(35725,23495,'TE','9152198199',0,'2014-02-13 22:02:05',NULL,NULL),(33678,22091,'TE','6017548550',0,'2014-02-08 19:00:24',NULL,NULL),(4961,3183,'AP','5048841608',0,'2013-12-25 20:31:55',NULL,NULL),(20192,13008,'TE','5133140487',0,'2013-12-26 12:49:44',NULL,NULL),(33599,22028,'TE','2162697595',0,'2014-02-07 19:01:02',NULL,NULL),(4550,2896,'TE','3303522477',0,'2013-12-25 20:15:15',NULL,NULL),(29830,19298,'AP','5044182143',1,'2014-01-22 03:21:59',NULL,NULL),(38059,25118,'TE','7403921002',0,'2014-02-21 21:30:20',NULL,NULL),(38775,25634,'EM','richard_w_lawrence@yahoo.com',0,'2014-02-26 08:30:26',NULL,NULL),(43592,28944,'AP','2488628365',0,'2014-03-10 21:00:45',NULL,NULL),(215,130,'TE','3306501021',0,'2013-12-25 17:18:27',NULL,NULL),(36189,23820,'AP','4198706330',0,'2014-02-14 21:31:40',NULL,NULL),(35021,22997,'TE','2162784523',0,'2014-02-12 21:30:17',NULL,NULL),(34139,22385,'EM','tmccauslin8@gmail.com',0,'2014-02-10 21:30:11',NULL,NULL),(32137,20987,'TE','5133881063',0,'2014-02-01 19:00:23',NULL,NULL),(14338,9374,'TE','5046387646',0,'2013-12-26 04:31:54',NULL,NULL),(14544,9502,'EM','HARRISNOEL2010@YAHOO.COM',0,'2013-12-26 04:35:12',NULL,NULL),(41462,27552,'TE','9564561808',0,'2014-03-04 21:30:12',NULL,NULL),(1756,1083,'AP','4405211621',0,'2013-12-25 18:16:50',NULL,NULL),(31920,20836,'TE','3306305645',0,'2014-01-31 21:00:44',NULL,NULL),(5649,3626,'EM','nikm1970@yahoo.com',0,'2013-12-25 21:23:47',NULL,NULL),(7623,4967,'TE','9566933817',0,'2013-12-25 22:46:20',NULL,NULL),(24170,15618,'AP','6015902317',1,'2014-01-02 04:33:03',NULL,NULL),(10615,6906,'AP','3182724473',0,'2013-12-26 01:45:47',NULL,NULL),(3040,1892,'TE','5138462130',0,'2013-12-25 18:58:52',NULL,NULL),(13842,9025,'EM','jdkd53@aol.com',0,'2013-12-26 04:05:26',NULL,NULL),(6710,4362,'EM','mrmeddock@gmail.com',0,'2013-12-25 22:00:04',NULL,NULL),(41668,27703,'TE','8174870216',0,'2014-03-05 21:30:49',NULL,NULL),(11273,7349,'TE','3134085601',0,'2013-12-26 02:15:03',NULL,NULL),(13691,8925,'TE','4407294397',0,'2013-12-26 04:02:54',NULL,NULL),(39799,26312,'TE','9375494680',0,'2014-02-28 06:31:34',NULL,NULL),(39811,26328,'TE','2282384076',0,'2014-02-28 06:31:39',NULL,NULL),(40431,26842,'TE','3184931261',0,'2014-03-01 21:00:45',NULL,NULL),(40637,26972,'TE','3306042402',0,'2014-03-03 01:00:35',NULL,NULL),(9059,5941,'TE','5098592723',0,'2013-12-25 23:50:49',NULL,NULL),(2716,1649,'TE','8324474082',0,'2013-12-25 18:53:19',NULL,NULL),(5147,3297,'EM','cmurph18@zoominternet.net',0,'2013-12-25 21:15:40',NULL,NULL),(31378,20453,'EM','jkirschy@gmail.com',0,'2014-01-29 21:00:46',NULL,NULL),(30270,19612,'EM','monikakcollins@gmail.com',0,'2014-01-23 03:02:51',NULL,NULL),(29494,19062,'AP','9563349057',0,'2014-01-21 08:44:16',NULL,NULL),(14946,9777,'TE','5135321072',0,'2013-12-26 05:00:39',NULL,NULL),(28468,18343,'AP','6149359027',0,'2014-01-16 08:45:18',NULL,NULL),(26754,17209,'EM','debloucks@att.net',0,'2014-01-13 02:22:28',NULL,NULL),(39628,26207,'AP','3307631370',0,'2014-02-28 06:30:52',NULL,NULL),(43317,28775,'EM','kstairs82@yahoo.com',0,'2014-03-09 21:00:32',NULL,NULL),(43630,28961,'TE','5042360583',0,'2014-03-10 21:00:57',NULL,NULL),(9516,6228,'AP','7405033997',0,'2013-12-26 00:31:23',NULL,NULL),(22398,14445,'EM','anitalevy76@yahoo.com',0,'2013-12-28 03:32:20',NULL,NULL),(35763,23520,'TE','3302892292',0,'2014-02-13 22:02:20',NULL,NULL),(1057,651,'TE','5134428445',0,'2013-12-25 18:01:36',NULL,NULL),(5018,3220,'EM','russellwgroves@yahoo.com',0,'2013-12-25 20:45:42',NULL,NULL),(27600,17793,'TE','9373693915',0,'2014-01-14 01:33:49',NULL,NULL),(8449,5559,'TE','9373043448',0,'2013-12-25 23:16:23',NULL,NULL),(30600,19859,'TE','2346005796',0,'2014-01-24 21:00:34',NULL,NULL),(31763,20730,'TE','3304004848',0,'2014-01-30 21:01:18',NULL,NULL),(34172,22409,'EM','magen.tardo.p19o@statefarm.com',0,'2014-02-10 21:30:25',NULL,NULL),(10122,6619,'EM','hollybaker@fuse.net',0,'2013-12-26 00:53:59',NULL,NULL),(13814,9001,'EM','Neuromitkit@aol.com',0,'2013-12-26 04:04:53',NULL,NULL),(24520,15815,'AP','6146033737',0,'2014-01-03 02:03:21',NULL,NULL),(20808,13368,'AP','6149375512',0,'2013-12-26 12:59:42',NULL,NULL),(36770,24209,'EM','ktw01@outlook.com',0,'2014-02-16 19:00:22',NULL,NULL),(14356,9384,'AP','3476660757',0,'2013-12-26 04:32:11',NULL,NULL),(14979,9800,'AP','4193440578',0,'2013-12-26 05:01:13',NULL,NULL),(24885,16044,'EM','yakk@juno.com',0,'2014-01-04 02:02:58',NULL,NULL),(14099,9219,'TE','5674547187',0,'2013-12-26 04:10:08',NULL,NULL),(23886,15412,'TE','9034519132',1,'2014-01-02 04:27:09',NULL,NULL),(43105,28654,'EM','torihsmith@ebscounseling.com',0,'2014-03-08 21:30:40',NULL,NULL),(34385,22554,'TE','3308976721',0,'2014-02-10 21:31:47',NULL,NULL),(8643,5678,'AP','9372188423',0,'2013-12-25 23:32:15',NULL,NULL),(31864,20800,'EM','danjteed28@hotmail.com',0,'2014-01-31 21:00:21',NULL,NULL),(10840,7038,'AP','3204939451',0,'2013-12-26 01:49:20',NULL,NULL),(21322,13700,'AP','3307874018',0,'2013-12-26 13:08:39',NULL,NULL),(21262,13663,'AP','5042373582',0,'2013-12-26 13:07:41',NULL,NULL),(28880,18645,'EM','egm55@yahoo.com',0,'2014-01-17 03:35:08',NULL,NULL),(37793,24941,'AP','6013766838',0,'2014-02-20 22:00:05',NULL,NULL),(43803,29079,'TE','9012365532',0,'2014-03-10 21:02:02',NULL,NULL),(33454,21916,'AP','4196355657',0,'2014-02-06 21:30:06',NULL,NULL),(32490,21229,'AP','3302121492',0,'2014-02-03 21:01:08',NULL,NULL),(24949,16082,'TE','5138289585',0,'2014-01-04 02:04:08',NULL,NULL),(24612,15871,'BN','6019425330',0,'2014-01-03 02:05:07',NULL,NULL),(1246,757,'AP','8179999282',0,'2013-12-25 18:04:28',NULL,NULL),(9068,5944,'TE','9377081636',0,'2013-12-25 23:50:56',NULL,NULL),(11891,7738,'TE','3308193470',0,'2013-12-26 03:02:12',NULL,NULL),(5334,3418,'TE','2253433011',0,'2013-12-25 21:18:34',NULL,NULL),(10086,6590,'AP','3614372362',0,'2013-12-26 00:53:15',NULL,NULL),(9876,6457,'EM','RPCONTROL@AOL.COM',0,'2013-12-26 00:49:50',NULL,NULL),(7898,5147,'TE','7405446026',0,'2013-12-25 23:02:43',NULL,NULL),(7871,5133,'AP','9792577063',0,'2013-12-25 23:02:18',NULL,NULL),(5553,3550,'TE','2346780781',0,'2013-12-25 21:22:00',NULL,NULL),(1010,622,'AP','6145791946',0,'2013-12-25 18:00:52',NULL,NULL),(25065,16157,'EM','jbloomfield01@gmail.com',0,'2014-01-04 06:00:07',NULL,NULL),(24853,16029,'TE','3182063775',0,'2014-01-04 02:02:25',NULL,NULL),(22916,14787,'TE','3303401509',1,'2013-12-29 11:13:23',NULL,NULL),(36369,23949,'EM','ashley.n.kemper@gmail.com',0,'2014-02-15 22:00:03',NULL,NULL),(3477,2179,'TE','4197227269',0,'2013-12-25 19:19:20',NULL,NULL),(33401,21886,'AP','5132604781',0,'2014-02-06 21:01:34',NULL,NULL),(30973,20146,'EM','JGILLS81@YAHOO.COM.SG',0,'2014-01-27 21:01:01',NULL,NULL),(9795,6408,'EM','karenells@hotmail.com',0,'2013-12-26 00:48:33',NULL,NULL),(43794,29071,'TE','4195090959',0,'2014-03-10 21:01:57',NULL,NULL),(945,581,'EM','jangee@bex.net',0,'2013-12-25 17:50:54',NULL,NULL),(11179,7270,'TE','2547443151',0,'2013-12-26 02:02:24',NULL,NULL),(12080,7890,'EM','brownb900@yahoo.com',0,'2013-12-26 03:05:37',NULL,NULL),(14812,9696,'TE','5132715711',0,'2013-12-26 04:39:51',NULL,NULL),(4842,3099,'TE','9374163085',0,'2013-12-25 20:20:13',NULL,NULL),(37913,25010,'EM','angel1950@glwb.net',0,'2014-02-20 22:00:51',NULL,NULL),(37390,24622,'AP','6019830020',0,'2014-02-20 04:16:20',NULL,NULL),(21924,14124,'EM','Djeby1@roadrunner.com',0,'2013-12-27 02:02:12',NULL,NULL),(32761,21431,'EM','saigemarie01@gmail.com',0,'2014-02-04 21:01:19',NULL,NULL),(14855,9720,'EM','debrabrosky@gmail.com',0,'2013-12-26 04:45:27',NULL,NULL),(31872,20805,'TE','4092254934',0,'2014-01-31 21:00:24',NULL,NULL),(14244,9318,'TE','3183454203',0,'2013-12-26 04:30:27',NULL,NULL),(11834,7700,'TE','5133534944',0,'2013-12-26 03:01:15',NULL,NULL),(27143,17478,'TE','9362396610',0,'2014-01-13 03:01:11',NULL,NULL),(29250,18892,'TE','4405967814',0,'2014-01-17 03:36:32',NULL,NULL),(29707,19207,'EM','johngussey@gmail.com',0,'2014-01-21 08:46:20',NULL,NULL),(31608,20616,'AP','9858559187',0,'2014-01-30 21:00:21',NULL,NULL),(29996,19423,'AP','2165263197',1,'2014-01-22 03:23:03',NULL,NULL),(42382,28148,'TE','4194764363',0,'2014-03-06 21:02:35',NULL,NULL),(36832,24257,'TE','9152069514',0,'2014-02-17 19:00:08',NULL,NULL),(25335,16336,'EM','reneemmoore40@hotmail.com',0,'2014-01-07 04:02:09',NULL,NULL),(6320,4076,'TE','9313601247',0,'2013-12-25 21:47:03',NULL,NULL),(23483,15144,'AP','5133404465',0,'2014-01-01 12:05:50',NULL,NULL),(35711,23485,'EM','josephrtoman@yahoo.com',0,'2014-02-13 22:01:58',NULL,NULL),(42100,27972,'AP','5043431651',0,'2014-03-06 21:00:51',NULL,NULL),(13778,8980,'TE','9377766967',0,'2013-12-26 04:04:19',NULL,NULL),(21557,13861,'EM','qball@nacs.net',0,'2013-12-26 13:12:50',NULL,NULL),(38988,25781,'AP','4406672608',0,'2014-02-26 09:31:03',NULL,NULL),(26765,17218,'TE','6019548042',0,'2014-01-13 02:22:33',NULL,NULL),(10170,6646,'TE','8068313536',0,'2013-12-26 01:00:28',NULL,NULL),(4228,2704,'EM','TuckerB16939@gmail.com',0,'2013-12-25 19:47:48',NULL,NULL),(7594,4944,'AP','4157139640',0,'2013-12-25 22:45:45',NULL,NULL),(39146,25893,'TE','2106559287',0,'2014-02-26 21:01:04',NULL,NULL),(25666,16548,'TE','5043618327',1,'2014-01-07 10:22:38',NULL,NULL),(32599,21315,'AP','3182801484',0,'2014-02-04 21:00:19',NULL,NULL),(11034,7161,'TE','4193316297',0,'2013-12-26 01:52:28',NULL,NULL),(43711,29018,'TE','3308084803',0,'2014-03-10 21:01:28',NULL,NULL),(43869,29109,'AP','9858077765',0,'2014-03-10 21:02:23',NULL,NULL),(26602,17112,'AP','3305030224',0,'2014-01-13 02:21:38',NULL,NULL),(6125,3942,'TE','4192418916',0,'2013-12-25 21:37:58',NULL,NULL),(14740,9641,'TE','5125678879',0,'2013-12-26 04:38:30',NULL,NULL),(25243,16279,'TE','2167414048',0,'2014-01-07 04:00:28',NULL,NULL),(28578,18422,'AP','5049750024',0,'2014-01-16 08:45:53',NULL,NULL),(32077,20947,'AP','4194260017',0,'2014-01-31 21:01:46',NULL,NULL),(32228,21049,'TE','8063004671',0,'2014-02-02 19:00:05',NULL,NULL),(36146,23787,'EM','HAIDEY@AOL.COM',0,'2014-02-14 21:31:23',NULL,NULL),(37130,24443,'TE','3305016154',0,'2014-02-18 22:01:20',NULL,NULL),(38512,25450,'AP','2817063871',0,'2014-02-25 21:31:25',NULL,NULL),(3405,2139,'AP','2246881198',0,'2013-12-25 19:18:12',NULL,NULL),(20813,13375,'TE','4403394917',0,'2013-12-26 12:59:49',NULL,NULL),(25963,16724,'TE','3304759800',0,'2014-01-08 18:24:47',NULL,NULL),(31973,20876,'AP','6014668285',0,'2014-01-31 21:01:05',NULL,NULL),(39440,26085,'AP','5043589779',0,'2014-02-28 06:30:06',NULL,NULL),(41227,27383,'EM','Schene26@yahoo.com',0,'2014-03-04 21:01:22',NULL,NULL),(38854,25683,'AP','6019662984',0,'2014-02-26 09:30:06',NULL,NULL),(36243,23853,'AP','4196282042',0,'2014-02-14 21:31:59',NULL,NULL),(31691,20672,'TE','6013810438',0,'2014-01-30 21:00:50',NULL,NULL),(29039,18751,'TE','4192600611',0,'2014-01-17 03:35:43',NULL,NULL),(23276,14997,'TE','3254231334',0,'2014-01-01 12:01:36',NULL,NULL),(20863,13415,'TE','3307150439',0,'2013-12-26 13:00:39',NULL,NULL),(28633,18461,'TE','3183295946',0,'2014-01-16 08:46:12',NULL,NULL),(10402,6780,'AP','4097673192',0,'2013-12-26 01:16:50',NULL,NULL),(9623,6299,'TE','9375264412',0,'2013-12-26 00:45:51',NULL,NULL),(32928,21555,'TE','4404287614',0,'2014-02-05 21:30:15',NULL,NULL),(30849,20052,'TE','2548136324',0,'2014-01-27 21:00:06',NULL,NULL),(4928,3163,'EM','DBECKETT@CENTURYLINK.NET',0,'2013-12-25 20:31:23',NULL,NULL),(29229,18879,'TE','3374143176',0,'2014-01-17 03:36:27',NULL,NULL),(20531,13214,'AP','8173719806',0,'2013-12-26 12:55:21',NULL,NULL),(38803,25654,'AP','9373042343',0,'2014-02-26 08:30:41',NULL,NULL),(40353,26781,'AP','9562713806',0,'2014-03-01 21:00:13',NULL,NULL),(41507,27593,'AP','5134709745',0,'2014-03-05 21:00:19',NULL,NULL),(41670,27704,'TE','3259283287',0,'2014-03-05 21:30:50',NULL,NULL),(42113,27978,'AP','2252843888',0,'2014-03-06 21:00:55',NULL,NULL),(32812,21469,'TE','8287312449',0,'2014-02-04 21:01:37',NULL,NULL),(9435,6176,'TE','3302128470',0,'2013-12-26 00:17:12',NULL,NULL),(6836,4435,'AP','7403142472',0,'2013-12-25 22:02:00',NULL,NULL),(38856,25684,'TE','9033120119',0,'2014-02-26 09:30:07',NULL,NULL),(42501,28265,'EM','davebk@pdq.net',0,'2014-03-07 21:00:19',NULL,NULL),(20629,13271,'AP','8324031675',0,'2013-12-26 12:56:54',NULL,NULL),(34250,22467,'AP','5132548081',0,'2014-02-10 21:30:56',NULL,NULL),(3700,2348,'TE','9039081462',0,'2013-12-25 19:32:09',NULL,NULL),(9153,5994,'AP','5043881700',0,'2013-12-26 00:00:10',NULL,NULL),(3625,2292,'EM','trotskywins@gmail.com',0,'2013-12-25 19:30:48',NULL,NULL),(33843,22217,'AP','3379362061',0,'2014-02-09 19:00:24',NULL,NULL),(7367,4793,'TE','3308690701',0,'2013-12-25 22:16:20',NULL,NULL),(11059,7181,'EM','vickiedittmer@yahoo.com',0,'2013-12-26 02:00:13',NULL,NULL),(6458,4172,'TE','9373318191',0,'2013-12-25 21:49:15',NULL,NULL),(36795,24226,'EM','mahaseth.kushagra@gmail.com',0,'2014-02-16 19:00:31',NULL,NULL),(38046,25108,'AP','8325331909',0,'2014-02-21 21:30:14',NULL,NULL),(38274,25272,'TE','3183934003',0,'2014-02-25 21:00:12',NULL,NULL),(38846,25679,'TE','4197383824',0,'2014-02-26 08:30:57',NULL,NULL),(40304,26736,'TE','5132760485',0,'2014-02-28 21:31:52',NULL,NULL),(41059,27278,'TE','9155874073',0,'2014-03-04 21:00:20',NULL,NULL),(825,513,'AP','5132525602',0,'2013-12-25 17:48:59',NULL,NULL),(1158,711,'TE','5672300396',0,'2013-12-25 18:03:12',NULL,NULL),(11619,7556,'EM','zzeaman@gmail.com',0,'2013-12-26 02:33:22',NULL,NULL),(8880,5818,'TE','4696563676',0,'2013-12-25 23:47:55',NULL,NULL),(21483,13804,'EM','stanleywesley89@yahoo.com',0,'2013-12-26 13:11:26',NULL,NULL),(1263,768,'TE','8707576991',0,'2013-12-25 18:04:44',NULL,NULL),(5164,3314,'EM','riesenberg4@aol.com',0,'2013-12-25 21:15:56',NULL,NULL),(38869,25689,'EM','dcooper@accesstoledo.com',0,'2014-02-26 09:30:11',NULL,NULL),(41186,27354,'TE','4406551869',0,'2014-03-04 21:01:07',NULL,NULL),(43624,28958,'AP','5047233921',0,'2014-03-10 21:00:55',NULL,NULL),(25172,16232,'TE','4199942039',0,'2014-01-05 00:02:05',NULL,NULL),(38007,25072,'EM','cherylmcdunnell@gmail.com',0,'2014-02-20 22:01:32',NULL,NULL),(43117,28665,'TE','5044216117',0,'2014-03-08 21:30:45',NULL,NULL),(35413,23281,'TE','9852100420',0,'2014-02-13 21:30:16',NULL,NULL),(29941,19376,'AP','6019273282',1,'2014-01-22 03:22:39',NULL,NULL),(23558,15205,'TE','6013840688',0,'2014-01-01 12:07:32',NULL,NULL),(24787,15989,'TE','9562921695',0,'2014-01-04 02:01:11',NULL,NULL),(10894,7079,'TE','7408512275',0,'2013-12-26 01:50:15',NULL,NULL),(28886,18651,'TE','9792044316',0,'2014-01-17 03:35:10',NULL,NULL),(25030,16131,'AP','3303890573',0,'2014-01-04 02:05:42',NULL,NULL),(40215,26673,'TE','2253023564',0,'2014-02-28 21:31:19',NULL,NULL),(22829,14724,'EM','Boalkelly@yahoo.com',1,'2013-12-29 11:09:38',NULL,NULL),(34957,22950,'AP','4403717126',0,'2014-02-11 21:30:28',NULL,NULL),(5421,3470,'TE','7408282235',0,'2013-12-25 21:19:56',NULL,NULL),(33485,21943,'TE','8062733205',0,'2014-02-07 19:00:16',NULL,NULL),(9789,6404,'TE','3306377584',0,'2013-12-26 00:48:27',NULL,NULL),(31987,20886,'TE','4199536030',0,'2014-01-31 21:01:11',NULL,NULL),(30726,19963,'TE','3306032370',0,'2014-01-25 19:00:08',NULL,NULL),(27251,17544,'TE','3307931128',0,'2014-01-13 03:01:51',NULL,NULL),(28610,18441,'EM','nettervilled@gmail.com',0,'2014-01-16 08:46:03',NULL,NULL),(36957,24337,'TE','8063925140',0,'2014-02-18 22:00:17',NULL,NULL),(39323,26010,'AP','4197062538',0,'2014-02-26 21:02:10',NULL,NULL),(42177,28016,'EM','neff916@aol.com',0,'2014-03-06 21:01:18',NULL,NULL),(42270,28073,'TE','2163766163',0,'2014-03-06 21:01:52',NULL,NULL),(1182,724,'TE','9039309332',0,'2013-12-25 18:03:34',NULL,NULL),(5389,3448,'EM','hopehammond@gmail.com',0,'2013-12-25 21:19:26',NULL,NULL),(11319,7375,'TE','5132842149',0,'2013-12-26 02:15:46',NULL,NULL),(2611,1590,'EM','jwilletts3@gmail.com',0,'2013-12-25 18:51:43',NULL,NULL),(2495,1531,'AP','6142901336',0,'2013-12-25 18:50:01',NULL,NULL),(13796,8994,'EM','dpham8907@gmail.com',0,'2013-12-26 04:04:40',NULL,NULL),(35269,23162,'EM','Alana_Aldredge@baylor.edu',0,'2014-02-12 21:31:48',NULL,NULL),(26230,16882,'TE','9362399456',0,'2014-01-13 02:19:22',NULL,NULL),(33500,21954,'AP','2162697595',0,'2014-02-07 19:00:22',NULL,NULL),(32336,21122,'EM','BETTY@GMAIL.COM',0,'2014-02-03 21:00:14',NULL,NULL),(38043,25107,'TE','8325331909',0,'2014-02-21 21:30:13',NULL,NULL),(38584,25499,'AP','7753783804',0,'2014-02-25 21:31:53',NULL,NULL),(27697,17852,'AP','2163080344',0,'2014-01-15 02:06:07',NULL,NULL),(22720,14651,'TE','3618131555',1,'2013-12-29 11:07:45',NULL,NULL),(5619,3599,'AP','4197065102',0,'2013-12-25 21:23:13',NULL,NULL),(13788,8986,'TE','5133720978',0,'2013-12-26 04:04:28',NULL,NULL),(4463,2842,'AP','3305540953',0,'2013-12-25 20:01:05',NULL,NULL),(5701,3660,'TE','5133798250',0,'2013-12-25 21:30:52',NULL,NULL),(38244,25250,'TE','6013653308',0,'2014-02-21 22:01:13',NULL,NULL),(38734,25603,'EM','drj4705@gmail.com',0,'2014-02-26 08:30:04',NULL,NULL),(41466,27556,'AP','2692622025',0,'2014-03-04 21:30:14',NULL,NULL),(41665,27696,'AP','9033905374',0,'2014-03-05 21:30:47',NULL,NULL),(32079,20950,'AP','9036543712',0,'2014-02-01 19:00:04',NULL,NULL),(6832,4434,'TE','6145610807',0,'2013-12-25 22:01:57',NULL,NULL),(8962,5870,'TE','9372704085',0,'2013-12-25 23:49:13',NULL,NULL),(23701,15299,'AP','2252020377',1,'2014-01-02 04:22:46',NULL,NULL),(21944,14136,'AP','5043824886',0,'2013-12-27 02:02:32',NULL,NULL),(6247,4027,'TE','7405519273',0,'2013-12-25 21:45:48',NULL,NULL),(22483,14497,'EM','floydiemoore@att.net',0,'2013-12-28 03:33:41',NULL,NULL),(41551,27628,'TE','3304654198',0,'2014-03-05 21:30:09',NULL,NULL),(418,255,'EM','aaron33063@mac.com',0,'2013-12-25 17:21:42',NULL,NULL),(35658,23452,'TE','5125175930',0,'2014-02-13 22:01:38',NULL,NULL),(32376,21154,'EM','Varche88@gmail.com',0,'2014-02-03 21:00:29',NULL,NULL),(20303,13086,'AP','6143579215',0,'2013-12-26 12:51:44',NULL,NULL),(36321,23922,'EM','lorine.totten@aol.com',0,'2014-02-14 22:00:06',NULL,NULL),(31815,20772,'TE','9373934727',0,'2014-01-30 21:01:41',NULL,NULL),(8507,5594,'EM','cheylonkwoods@att.net',0,'2013-12-25 23:30:04',NULL,NULL),(11109,7222,'TE','3308692896',0,'2013-12-26 02:01:09',NULL,NULL),(8318,5452,'AP','5134320261',0,'2013-12-25 23:10:13',NULL,NULL),(26920,17316,'AP','9792244781',0,'2014-01-13 02:23:47',NULL,NULL),(25490,16434,'TE','3309300382',0,'2014-01-07 04:04:56',NULL,NULL),(40143,26625,'TE','2105999409',0,'2014-02-28 21:30:54',NULL,NULL),(40829,27132,'EM','djc41@zips.uakron.edu',0,'2014-03-03 21:30:41',NULL,NULL),(31243,20348,'TE','5134102342',0,'2014-01-28 21:01:12',NULL,NULL),(4577,2919,'EM','shelleycurry32@yahoo.com',0,'2013-12-25 20:15:45',NULL,NULL),(30963,20140,'EM','richarddba1560@sbcglobal.net',0,'2014-01-27 21:00:58',NULL,NULL),(10709,6963,'TE','6144837296',0,'2013-12-26 01:47:18',NULL,NULL),(3139,1956,'AP','8176816774',0,'2013-12-25 19:01:07',NULL,NULL),(39875,26382,'TE','2253642678',0,'2014-02-28 07:00:20',NULL,NULL),(41207,27369,'AP','6013166455',0,'2014-03-04 21:01:15',NULL,NULL),(43073,28636,'AP','9034450304',0,'2014-03-08 21:30:29',NULL,NULL),(155,93,'EM','jrhealy99@yahoo.com',0,'2013-12-25 17:17:30',NULL,NULL),(30231,19583,'TE','5046168269',0,'2014-01-23 03:02:41',NULL,NULL),(22223,14325,'TE','3307694227',0,'2013-12-27 02:07:22',NULL,NULL),(3507,2191,'EM','jedwards44@woh.rr.com',0,'2013-12-25 19:19:46',NULL,NULL),(4150,2648,'TE','2107227270',0,'2013-12-25 19:46:32',NULL,NULL),(9827,6429,'TE','5044660551',0,'2013-12-26 00:49:07',NULL,NULL),(21081,13557,'TE','3182921313',0,'2013-12-26 13:04:16',NULL,NULL),(37179,24474,'TE','4197870347',0,'2014-02-18 22:01:40',NULL,NULL),(39607,26199,'EM','dan6670@live.com',0,'2014-02-28 06:30:48',NULL,NULL),(40546,26909,'TE','9852010681',0,'2014-03-03 01:00:11',NULL,NULL),(33642,22061,'TE','2545623401',0,'2014-02-08 19:00:10',NULL,NULL),(6772,4394,'TE','3308194867',0,'2013-12-25 22:00:58',NULL,NULL),(40518,26893,'TE','9373861140',0,'2014-03-03 01:00:04',NULL,NULL),(41673,27707,'EM','martinezs@ft.newyorklife.com',0,'2014-03-05 21:30:52',NULL,NULL),(25829,16652,'AP','2155208687',0,'2014-01-08 18:24:21',NULL,NULL),(36132,23780,'TE','2283265508',0,'2014-02-14 21:31:19',NULL,NULL),(6456,4170,'TE','9375920773',0,'2013-12-25 21:49:13',NULL,NULL),(12382,8109,'TE','9374443222',0,'2013-12-26 03:11:03',NULL,NULL),(23222,14965,'EM','delorestyler1951@hotmail.com',0,'2014-01-01 12:00:38',NULL,NULL),(3621,2290,'AP','6145310756',0,'2013-12-25 19:30:45',NULL,NULL),(37040,24392,'TE','4404093822',0,'2014-02-18 22:00:49',NULL,NULL),(40087,26585,'AP','6142078754',0,'2014-02-28 21:30:33',NULL,NULL),(42292,28083,'AP','9037527015',0,'2014-03-06 21:01:59',NULL,NULL),(34108,22360,'TE','2034177090',0,'2014-02-10 21:00:07',NULL,NULL),(30616,19870,'EM','longbooba1@yahoo.com',0,'2014-01-24 21:00:40',NULL,NULL),(3734,2371,'AP','3309908171',0,'2013-12-25 19:32:44',NULL,NULL),(41965,27897,'TE','5133041523',0,'2014-03-05 21:32:43',NULL,NULL),(438,272,'AP','6144391238',0,'2013-12-25 17:30:03',NULL,NULL),(12024,7840,'AP','5136230575',0,'2013-12-26 03:04:36',NULL,NULL),(36492,24025,'TE','4194744149',0,'2014-02-15 22:00:49',NULL,NULL),(35455,23313,'AP','5134977505',0,'2014-02-13 22:00:21',NULL,NULL),(4571,2916,'AP','5133791520',0,'2013-12-25 20:15:40',NULL,NULL),(32621,21328,'AP','2165772052',0,'2014-02-04 21:00:27',NULL,NULL),(3495,2185,'AP','3259771945',0,'2013-12-25 19:19:34',NULL,NULL),(29630,19145,'TE','2147183225',0,'2014-01-21 08:45:31',NULL,NULL),(23519,15172,'TE','3307947010',0,'2014-01-01 12:06:36',NULL,NULL),(924,569,'EM','Jennifer.hathaway2002@gmail.com',0,'2013-12-25 17:50:34',NULL,NULL),(830,516,'TE','3307948189',0,'2013-12-25 17:49:04',NULL,NULL),(7463,4858,'EM','jme5873@gmail.com',0,'2013-12-25 22:30:36',NULL,NULL),(30103,19501,'TE','3307331341',0,'2014-01-23 03:02:10',NULL,NULL),(1565,963,'AP','4792092671',0,'2013-12-25 18:09:51',NULL,NULL),(5913,3792,'EM','lake1frasier2@cinci.rr.com',0,'2013-12-25 21:34:17',NULL,NULL),(21258,13661,'TE','3186872077',0,'2013-12-26 13:07:37',NULL,NULL),(8547,5617,'TE','7402977931',0,'2013-12-25 23:30:40',NULL,NULL),(6754,4383,'EM','grier04@email.franklin.edu',0,'2013-12-25 22:00:41',NULL,NULL),(11634,7567,'TE','4192966842',0,'2013-12-26 02:33:40',NULL,NULL),(10272,6709,'TE','2282167028',0,'2013-12-26 01:02:11',NULL,NULL),(38373,25347,'AP','2257542375',0,'2014-02-25 21:30:29',NULL,NULL),(1384,846,'TE','5047225547',0,'2013-12-25 18:06:45',NULL,NULL),(4631,2953,'TE','9039525233',0,'2013-12-25 20:16:35',NULL,NULL),(36914,24312,'TE','9566392023',0,'2014-02-18 22:00:02',NULL,NULL),(33416,21893,'AP','2285472935',0,'2014-02-06 21:01:40',NULL,NULL),(23655,15275,'TE','7407979639',1,'2014-01-02 04:21:56',NULL,NULL),(23396,15069,'AP','6626108003',0,'2014-01-01 12:03:51',NULL,NULL),(27291,17572,'EM','saelabx@yahoo.com',0,'2014-01-14 01:32:02',NULL,NULL),(37566,24737,'AP','5134851656',0,'2014-02-20 04:40:22',NULL,NULL),(40295,26729,'AP','4194602209',0,'2014-02-28 21:31:49',NULL,NULL),(540,337,'AP','4407493008',0,'2013-12-25 17:31:53',NULL,NULL),(36451,24003,'TE','5136022781',0,'2014-02-15 22:00:34',NULL,NULL),(34745,22782,'AP','3308588762',0,'2014-02-11 21:01:44',NULL,NULL),(23885,15411,'EM','hanhdung55@yahoo.com',1,'2014-01-02 04:27:07',NULL,NULL),(32468,21213,'TE','2257733526',0,'2014-02-03 21:01:00',NULL,NULL),(21024,13526,'AP','5044811631',0,'2013-12-26 13:03:21',NULL,NULL),(31541,20558,'TE','4193454000',0,'2014-01-29 21:01:45',NULL,NULL),(7028,4589,'TE','3307146407',0,'2013-12-25 22:05:26',NULL,NULL),(6894,4482,'TE','6143858453',0,'2013-12-25 22:03:00',NULL,NULL),(6520,4213,'EM','ROSESAILS@HOTMAIL.COM',0,'2013-12-25 21:50:15',NULL,NULL),(43444,28851,'TE','4193947305',0,'2014-03-09 21:01:19',NULL,NULL),(8668,5691,'AP','5132058684',0,'2013-12-25 23:32:37',NULL,NULL),(24677,15912,'TE','9365813801',0,'2014-01-03 02:06:26',NULL,NULL),(37088,24419,'AP','2162998240',0,'2014-02-18 22:01:06',NULL,NULL),(22907,14781,'AP','5134298602',1,'2013-12-29 11:13:14',NULL,NULL),(30033,19453,'TE','7405037130',0,'2014-01-23 03:01:53',NULL,NULL),(21031,13532,'TE','3376543741',0,'2013-12-26 13:03:30',NULL,NULL),(14902,9749,'EM','kapa@reichoffice.com',0,'2013-12-26 04:46:12',NULL,NULL),(28927,18675,'AP','9109777600',0,'2014-01-17 03:35:18',NULL,NULL),(13860,9037,'AP','4406221862',0,'2013-12-26 04:05:44',NULL,NULL),(9413,6161,'TE','5137734297',0,'2013-12-26 00:16:48',NULL,NULL),(1747,1077,'TE','3304824758',0,'2013-12-25 18:16:40',NULL,NULL),(27240,17536,'EM','usnvc@yahoo.com',0,'2014-01-13 03:01:46',NULL,NULL),(8329,5461,'AP','2166332529',0,'2013-12-25 23:10:25',NULL,NULL),(3003,1856,'EM','JOJAMALACHI@GMAIL.COM',0,'2013-12-25 18:58:04',NULL,NULL),(36264,23868,'EM','gerrygermani@yahoo.com',0,'2014-02-14 21:32:08',NULL,NULL),(34138,22385,'AP','8649407163',0,'2014-02-10 21:30:11',NULL,NULL),(30259,19600,'EM','houstink@yahoo.com',0,'2014-01-23 03:02:48',NULL,NULL),(6814,4419,'EM','lorikg@hotmail.com',0,'2013-12-25 22:01:36',NULL,NULL),(10908,7088,'TE','3303763134',0,'2013-12-26 01:50:28',NULL,NULL),(37679,24845,'EM','TONIK81@YAHOO.COM',0,'2014-02-20 04:54:26',NULL,NULL),(42864,28506,'TE','4408861170',0,'2014-03-07 21:31:52',NULL,NULL),(159,95,'TE','2146920130',0,'2013-12-25 17:17:33',NULL,NULL),(37640,24808,'EM','jayz2slk@gmail.com',0,'2014-02-20 04:49:34',NULL,NULL),(26653,17146,'EM','skysonestop@yahoo.com',0,'2014-01-13 02:21:55',NULL,NULL),(22251,14340,'TE','4192038649',0,'2013-12-27 02:07:52',NULL,NULL),(21968,14151,'TE','5044435738',0,'2013-12-27 02:02:55',NULL,NULL),(14458,9445,'TE','6143166572',0,'2013-12-26 04:33:48',NULL,NULL),(14132,9256,'TE','9567751665',0,'2013-12-26 04:15:09',NULL,NULL),(13988,9126,'TE','6626890618',0,'2013-12-26 04:07:52',NULL,NULL),(10026,6558,'EM','Braddallas@me.com',0,'2013-12-26 00:52:22',NULL,NULL),(39148,25895,'TE','4098824585',0,'2014-02-26 21:01:05',NULL,NULL),(39819,26331,'TE','2605031597',0,'2014-02-28 06:31:40',NULL,NULL),(37166,24463,'AP','3307049542',0,'2014-02-18 22:01:35',NULL,NULL),(36532,24052,'TE','7409242274',0,'2014-02-15 22:01:05',NULL,NULL),(9108,5969,'TE','6014702304',0,'2013-12-25 23:51:35',NULL,NULL),(36092,23737,'EM','cumphenour@neo.rr.com',0,'2014-02-14 21:31:02',NULL,NULL),(4073,2598,'AP','6146196044',0,'2013-12-25 19:45:16',NULL,NULL),(7359,4783,'AP','3302122620',0,'2013-12-25 22:16:11',NULL,NULL),(33382,21874,'EM','Antwonb@hotmail.com',0,'2014-02-06 21:01:27',NULL,NULL),(33157,21717,'EM','jess_hoang@yahoo.com',0,'2014-02-05 21:31:18',NULL,NULL),(30850,20052,'AP','2548136324',0,'2014-01-27 21:00:06',NULL,NULL),(13566,8845,'TE','3258642448',0,'2013-12-26 04:00:52',NULL,NULL),(27776,17906,'EM','sheilaknott@gmail.com',0,'2014-01-15 02:06:25',NULL,NULL),(42298,28087,'TE','8174312920',0,'2014-03-06 21:02:01',NULL,NULL),(27107,17437,'EM','kevinlfifer@aol.com',0,'2014-01-13 03:00:34',NULL,NULL),(27520,17727,'AP','4405969141',0,'2014-01-14 01:33:18',NULL,NULL),(7829,5111,'TE','3373157744',0,'2013-12-25 23:01:41',NULL,NULL),(28631,18459,'AP','2254132664',0,'2014-01-16 08:46:12',NULL,NULL),(7015,4581,'AP','3307631181',0,'2013-12-25 22:05:13',NULL,NULL),(8903,5829,'AP','2143350748',0,'2013-12-25 23:48:14',NULL,NULL),(23166,14931,'TE','2107813055',0,'2013-12-30 00:02:01',NULL,NULL),(26560,17085,'TE','2103286278',0,'2014-01-13 02:21:24',NULL,NULL),(25766,16604,'AP','2252870388',0,'2014-01-08 18:24:05',NULL,NULL),(3062,1903,'EM','smcgill@woh.rr.com',0,'2013-12-25 18:59:13',NULL,NULL),(26421,17002,'AP','4408298658',0,'2014-01-13 02:20:31',NULL,NULL),(31446,20497,'TE','3183340664',0,'2014-01-29 21:01:10',NULL,NULL),(36115,23767,'AP','4408210525',0,'2014-02-14 21:31:12',NULL,NULL),(38169,25191,'AP','9166009072',0,'2014-02-21 22:00:40',NULL,NULL),(41027,27259,'TE','5672144115',0,'2014-03-03 21:31:58',NULL,NULL),(22084,14227,'AP','9038121714',0,'2013-12-27 02:04:52',NULL,NULL),(29673,19177,'TE','5126745889',0,'2014-01-21 08:46:05',NULL,NULL),(35915,23633,'AP','9038049852',0,'2014-02-14 21:30:04',NULL,NULL),(37205,24487,'EM','tashialov@yahoo.com',0,'2014-02-20 03:43:03',NULL,NULL),(42731,28421,'AP','6143817488',0,'2014-03-07 21:31:03',NULL,NULL),(43502,28885,'AP','6824591438',0,'2014-03-10 21:00:11',NULL,NULL),(1323,808,'EM','velezrene@hotmail.com',0,'2013-12-25 18:05:45',NULL,NULL),(5827,3740,'EM','steeghspeter@gmail.com',0,'2013-12-25 21:32:52',NULL,NULL),(26030,16771,'EM','sunshine7ireland@yahoo.com',0,'2014-01-08 18:25:02',NULL,NULL),(25437,16403,'TE','9039449766',0,'2014-01-07 04:03:58',NULL,NULL),(22889,14769,'AP','9402492580',1,'2013-12-29 11:12:53',NULL,NULL),(7121,4649,'AP','5132509464',0,'2013-12-25 22:07:01',NULL,NULL),(35950,23653,'TE','2812534503',0,'2014-02-14 21:30:15',NULL,NULL),(35666,23458,'AP','6789078717',0,'2014-02-13 22:01:41',NULL,NULL),(33664,22082,'AP','2259333513',0,'2014-02-08 19:00:19',NULL,NULL),(31206,20321,'TE','8065597896',0,'2014-01-28 21:00:56',NULL,NULL),(29604,19129,'TE','5049492962',0,'2014-01-21 08:45:22',NULL,NULL),(12307,8048,'TE','4198104555',0,'2013-12-26 03:09:37',NULL,NULL),(6654,4316,'EM','DEBBIE_2307@YAHOO.COM',0,'2013-12-25 21:52:41',NULL,NULL),(37208,24488,'EM','esalazar00@yahoo.com',0,'2014-02-20 03:43:38',NULL,NULL),(42391,28153,'EM','kperdew@ymail.com',0,'2014-03-06 21:02:38',NULL,NULL),(42490,28255,'AP','5133900340',0,'2014-03-07 21:00:15',NULL,NULL),(42861,28503,'EM','deborahblanton59@yahoo.com',0,'2014-03-07 21:31:50',NULL,NULL),(43018,28604,'AP','4404977608',0,'2014-03-08 21:30:11',NULL,NULL),(43919,29137,'TE','4192768197',0,'2014-03-10 21:02:40',NULL,NULL),(1508,929,'TE','4404947115',0,'2013-12-25 18:09:02',NULL,NULL),(12116,7920,'TE','3188726424',0,'2013-12-26 03:06:18',NULL,NULL),(14220,9303,'EM','prock1970@gmail.com',0,'2013-12-26 04:30:04',NULL,NULL),(32322,21116,'TE','4697655735',0,'2014-02-03 21:00:10',NULL,NULL),(29663,19165,'TE','4199661687',0,'2014-01-21 08:45:43',NULL,NULL),(1955,1212,'TE','9378482183',0,'2013-12-25 18:20:08',NULL,NULL),(3521,2202,'TE','9375264412',0,'2013-12-25 19:20:03',NULL,NULL),(2865,1751,'AP','4192314220',0,'2013-12-25 18:55:44',NULL,NULL),(38932,25736,'TE','2162875370',0,'2014-02-26 09:30:39',NULL,NULL),(43349,28793,'TE','2143619408',0,'2014-03-09 21:00:43',NULL,NULL),(31579,20594,'EM','bessfrags@yahoo.com',0,'2014-01-30 21:00:10',NULL,NULL),(12416,8133,'AP','6149898259',0,'2013-12-26 03:15:35',NULL,NULL),(30981,20153,'AP','5132880018',0,'2014-01-27 21:01:05',NULL,NULL),(7810,5098,'AP','3617650368',0,'2013-12-25 23:01:23',NULL,NULL),(4487,2853,'AP','2252216873',0,'2013-12-25 20:01:27',NULL,NULL),(37055,24403,'TE','5133129753',0,'2014-02-18 22:00:56',NULL,NULL),(24826,16014,'TE','3186877263',0,'2014-01-04 02:01:56',NULL,NULL),(36381,23961,'TE','5129094575',0,'2014-02-15 22:00:09',NULL,NULL),(32269,21079,'AP','5127366291',0,'2014-02-02 19:00:21',NULL,NULL),(27786,17912,'TE','5202414133',0,'2014-01-15 02:06:27',NULL,NULL),(8624,5665,'EM','spicerdw@gmail.com',0,'2013-12-25 23:31:53',NULL,NULL),(8267,5413,'AP','5133754425',0,'2013-12-25 23:09:11',NULL,NULL),(27175,17497,'AP','5044532166',0,'2014-01-13 03:01:23',NULL,NULL),(24020,15511,'TE','4192812888',1,'2014-01-02 04:30:00',NULL,NULL),(21664,13947,'TE','5134101174',0,'2013-12-26 13:14:50',NULL,NULL),(2834,1717,'AP','7403141604',0,'2013-12-25 18:55:07',NULL,NULL),(25745,16591,'AP','9188999299',0,'2014-01-08 18:24:01',NULL,NULL),(43839,29096,'TE','9725678406',0,'2014-03-10 21:02:13',NULL,NULL),(35805,23544,'TE','5043521605',0,'2014-02-13 22:02:35',NULL,NULL),(4839,3098,'TE','4406834045',0,'2013-12-25 20:20:11',NULL,NULL),(8356,5492,'EM','brownb900@yahoo.com',0,'2013-12-25 23:11:05',NULL,NULL),(34893,22898,'AP','3305032655',0,'2014-02-11 21:02:40',NULL,NULL),(33895,22247,'TE','4196661154',0,'2014-02-09 19:00:41',NULL,NULL),(9057,5940,'AP','9046108142',0,'2013-12-25 23:50:47',NULL,NULL),(6461,4173,'AP','9375380991',0,'2013-12-25 21:49:17',NULL,NULL),(30621,19873,'TE','2163390871',0,'2014-01-24 21:00:42',NULL,NULL),(40998,27238,'EM','andyblair22@gmail.com',0,'2014-03-03 21:31:46',NULL,NULL),(1225,748,'TE','5122990219',0,'2013-12-25 18:04:12',NULL,NULL),(25934,16709,'TE','2109000345',0,'2014-01-08 18:24:42',NULL,NULL),(20198,13013,'EM','tyronesmith04@gmail.com',0,'2013-12-26 12:49:51',NULL,NULL),(27359,17614,'TE','8322510962',0,'2014-01-14 01:32:23',NULL,NULL),(21027,13529,'TE','5049058563',0,'2013-12-26 13:03:25',NULL,NULL),(3577,2241,'TE','4199139225',0,'2013-12-25 19:21:02',NULL,NULL),(10866,7053,'TE','5133216271',0,'2013-12-26 01:49:45',NULL,NULL),(10809,7021,'EM','DEEN4041@AOL.COM',0,'2013-12-26 01:48:52',NULL,NULL),(10013,6551,'AP','2194879070',0,'2013-12-26 00:52:11',NULL,NULL),(21662,13945,'TE','4404495812',0,'2013-12-26 13:14:47',NULL,NULL),(9469,6196,'EM','melissagailstanley@gmail.com',0,'2013-12-26 00:30:28',NULL,NULL),(7687,5015,'TE','4192300466',0,'2013-12-25 22:47:23',NULL,NULL),(25635,16534,'AP','7692186890',1,'2014-01-07 10:22:07',NULL,NULL),(11432,7437,'TE','3308013014',0,'2013-12-26 02:30:19',NULL,NULL),(23710,15303,'TE','5044786010',1,'2014-01-02 04:22:54',NULL,NULL),(9297,6089,'EM','k3132@aol.com',0,'2013-12-26 00:02:41',NULL,NULL),(8395,5525,'TE','7402863559',0,'2013-12-25 23:15:26',NULL,NULL),(4018,2557,'TE','6622876734',0,'2013-12-25 19:37:25',NULL,NULL),(1677,1031,'TE','9563734107',0,'2013-12-25 18:15:31',NULL,NULL),(40935,27199,'EM','corneliusjolivette30@yahoo.com',0,'2014-03-03 21:31:21',NULL,NULL),(28667,18488,'EM','1calaurianti@windstream.net',0,'2014-01-16 08:46:24',NULL,NULL),(5753,3687,'TE','9379028810',0,'2013-12-25 21:31:37',NULL,NULL),(1655,1015,'EM','sethka63@hotmail.com',0,'2013-12-25 18:15:07',NULL,NULL),(7859,5128,'TE','2142153503',0,'2013-12-25 23:02:09',NULL,NULL),(20307,13087,'EM','clwho1@mac.com',0,'2013-12-26 12:51:46',NULL,NULL),(22972,14816,'TE','5139673682',1,'2013-12-29 11:14:13',NULL,NULL),(3492,2184,'AP','5129403211',0,'2013-12-25 19:19:32',NULL,NULL),(23268,14991,'AP','9032676640',0,'2014-01-01 12:01:25',NULL,NULL),(42208,28040,'AP','9859741154',0,'2014-03-06 21:01:31',NULL,NULL),(33961,22282,'TE','6147692452',0,'2014-02-10 11:00:23',NULL,NULL),(8304,5440,'TE','5042365934',0,'2013-12-25 23:09:55',NULL,NULL),(32428,21188,'EM','virgilmartin49@gmail.com',0,'2014-02-03 21:00:47',NULL,NULL),(26590,17107,'TE','9374662290',0,'2014-01-13 02:21:35',NULL,NULL),(20797,13364,'AP','4193660090',0,'2013-12-26 12:59:34',NULL,NULL),(22056,14204,'EM','D-R-CULVER@MSN.COM',0,'2013-12-27 02:04:20',NULL,NULL),(39766,26296,'EM','cheryl0764.cr@gmail.com',0,'2014-02-28 06:31:26',NULL,NULL),(33723,22120,'AP','9374084561',0,'2014-02-08 19:00:40',NULL,NULL),(32799,21458,'TE','3305623282',0,'2014-02-04 21:01:32',NULL,NULL),(20188,13007,'AP','5136676921',0,'2013-12-26 12:49:41',NULL,NULL),(31309,20401,'TE','2544212652',0,'2014-01-29 21:00:20',NULL,NULL),(5408,3465,'TE','6147627259',0,'2013-12-25 21:19:47',NULL,NULL),(4410,2809,'TE','9036754581',0,'2013-12-25 20:00:11',NULL,NULL),(41347,27468,'EM','cwsmithincincy@gmail.com',0,'2014-03-04 21:02:10',NULL,NULL),(42063,27952,'AP','8327246565',0,'2014-03-06 21:00:38',NULL,NULL),(25025,16126,'TE','5134444390',0,'2014-01-04 02:05:35',NULL,NULL),(13529,8821,'TE','9034866302',0,'2013-12-26 04:00:17',NULL,NULL),(32589,21308,'TE','5044539858',0,'2014-02-04 21:00:16',NULL,NULL),(29014,18729,'AP','9374089491',0,'2014-01-17 03:35:37',NULL,NULL),(8481,5579,'AP','4194389189',0,'2013-12-25 23:16:54',NULL,NULL),(8064,5281,'EM','EBAYMJT@GMAIL.COM',0,'2013-12-25 23:05:46',NULL,NULL),(42962,28570,'TE','5136927865',0,'2014-03-07 21:32:31',NULL,NULL),(43276,28752,'TE','8026830166',0,'2014-03-09 21:00:17',NULL,NULL),(36074,23727,'BN','2816601770',0,'2014-02-14 21:30:56',NULL,NULL),(30053,19469,'TE','3254363064',0,'2014-01-23 03:01:58',NULL,NULL),(28439,18323,'BN','5132380380',0,'2014-01-16 08:45:08',NULL,NULL),(27741,17884,'AP','2162251795',0,'2014-01-15 02:06:17',NULL,NULL),(9816,6421,'EM','katie.gravois@gmail.com',0,'2013-12-26 00:48:55',NULL,NULL),(37996,25066,'TE','2164810684',0,'2014-02-20 22:01:27',NULL,NULL),(40674,27006,'TE','3306125560',0,'2014-03-03 21:00:04',NULL,NULL),(28593,18431,'AP','3377181438',0,'2014-01-16 08:45:58',NULL,NULL),(27187,17504,'EM','lchrismomof3@sbcglobal.net',0,'2014-01-13 03:01:27',NULL,NULL),(4591,2929,'TE','3309584752',0,'2013-12-25 20:15:59',NULL,NULL),(8723,5722,'EM','byroncaplan@gmail.com',0,'2013-12-25 23:45:26',NULL,NULL),(1141,702,'TE','5043684716',0,'2013-12-25 18:02:56',NULL,NULL),(7480,4868,'TE','5132870295',0,'2013-12-25 22:30:55',NULL,NULL),(20218,13024,'EM','branford.d.brown@gmail.com',0,'2013-12-26 12:50:11',NULL,NULL),(7022,4586,'TE','3309457904',0,'2013-12-25 22:05:20',NULL,NULL),(7739,5050,'AP','5632494664',0,'2013-12-25 23:00:10',NULL,NULL),(34158,22397,'TE','3307849480',0,'2014-02-10 21:30:18',NULL,NULL),(5128,3285,'EM','crreid@gmail.com',0,'2013-12-25 21:15:22',NULL,NULL),(6699,4354,'AP','5135430642',0,'2013-12-25 21:53:33',NULL,NULL),(14479,9455,'TE','5134976040',0,'2013-12-26 04:34:05',NULL,NULL),(37963,25048,'TE','5132535115',0,'2014-02-20 22:01:15',NULL,NULL),(31707,20687,'AP','6149069969',0,'2014-01-30 21:00:57',NULL,NULL),(8376,5507,'AP','8173193050',0,'2013-12-25 23:15:04',NULL,NULL),(28906,18661,'TE','5125778209',0,'2014-01-17 03:35:14',NULL,NULL),(10217,6678,'TE','4196680762',0,'2013-12-26 01:01:18',NULL,NULL),(23021,14849,'EM','breakthroughdieteticservices@yahoo.com',1,'2013-12-29 11:15:03',NULL,NULL),(38630,25532,'EM','asmaaalasal@yahoo.com',0,'2014-02-26 08:00:06',NULL,NULL),(42235,28055,'TE','6018850880',0,'2014-03-06 21:01:40',NULL,NULL),(29902,19351,'TE','5136041132',1,'2014-01-22 03:22:26',NULL,NULL),(24615,15875,'TE','7879519978',0,'2014-01-03 02:05:13',NULL,NULL),(9470,6197,'TE','5133443629',0,'2013-12-26 00:30:30',NULL,NULL),(12145,7935,'TE','3373800800',0,'2013-12-26 03:06:44',NULL,NULL),(6390,4115,'EM','TYATES2397@GMAIL.COM',0,'2013-12-25 21:48:07',NULL,NULL),(39571,26179,'EM','melissaborror@yahoo.com',0,'2014-02-28 06:30:40',NULL,NULL),(39773,26300,'TE','4196352486',0,'2014-02-28 06:31:28',NULL,NULL),(41927,27875,'AP','9014123307',0,'2014-03-05 21:32:28',NULL,NULL),(331,207,'AP','2259217727',0,'2013-12-25 17:20:22',NULL,NULL),(37711,24863,'EM','hummerbird09@gmail.com',0,'2014-02-20 05:31:05',NULL,NULL),(29108,18798,'TE','2167211379',0,'2014-01-17 03:35:58',NULL,NULL),(27599,17791,'AP','3309402253',0,'2014-01-14 01:33:48',NULL,NULL),(21815,14054,'EM','ADEMITRYMARYKAY@GMAIL.COM',0,'2013-12-27 02:00:24',NULL,NULL),(21611,13910,'TE','4199343257',0,'2013-12-26 13:13:56',NULL,NULL),(10369,6758,'AP','2164096518',0,'2013-12-26 01:16:18',NULL,NULL),(42674,28387,'AP','3307943247',0,'2014-03-07 21:30:43',NULL,NULL),(43452,28856,'EM','alowens85@gmail.com',0,'2014-03-09 21:29:59',NULL,NULL),(43589,28943,'TE','9852103537',0,'2014-03-10 21:00:44',NULL,NULL),(11250,7325,'TE','3306222951',0,'2013-12-26 02:03:42',NULL,NULL),(11591,7542,'AP','5129147447',0,'2013-12-26 02:32:56',NULL,NULL),(25143,16208,'TE','2544341288',0,'2014-01-05 00:01:22',NULL,NULL),(25003,16113,'EM','techhealth68@gmail.com',0,'2014-01-04 02:05:10',NULL,NULL),(4213,2691,'AP','6824331272',0,'2013-12-25 19:47:32',NULL,NULL),(6949,4529,'TE','9362380393',0,'2013-12-25 22:04:01',NULL,NULL),(14423,9428,'AP','9363330862',0,'2013-12-26 04:33:19',NULL,NULL),(23367,15053,'TE','3379629049',0,'2014-01-01 12:03:19',NULL,NULL),(39145,25890,'EM','RIKROSZEL@GMAIL.COM',0,'2014-02-26 21:01:03',NULL,NULL),(39379,26044,'BN','3302892620',0,'2014-02-26 21:02:28',NULL,NULL),(43861,29105,'AP','4199536541',0,'2014-03-10 21:02:20',NULL,NULL),(23333,15033,'AP','3186805856',0,'2014-01-01 12:02:42',NULL,NULL),(9757,6380,'TE','4403490552',0,'2013-12-26 00:47:55',NULL,NULL),(27820,17928,'EM','omedina62@yahoo.com',0,'2014-01-15 02:06:34',NULL,NULL),(38389,25362,'TE','3302316708',0,'2014-02-25 21:30:37',NULL,NULL),(39652,26220,'TE','2143542586',0,'2014-02-28 06:30:57',NULL,NULL),(2216,1363,'TE','9157778767',0,'2013-12-25 18:45:33',NULL,NULL),(25927,16706,'TE','4693832180',0,'2014-01-08 18:24:41',NULL,NULL),(3067,1907,'EM','rcarter13@hotmail.com',0,'2013-12-25 18:59:19',NULL,NULL),(23027,14854,'AP','3306087346',1,'2013-12-29 11:15:10',NULL,NULL),(2813,1701,'AP','4193443866',0,'2013-12-25 18:54:44',NULL,NULL),(36490,24022,'TE','4194746378',0,'2014-02-15 22:00:48',NULL,NULL),(33058,21654,'EM','hudson71107@yahoo.com',0,'2014-02-05 21:30:51',NULL,NULL),(23030,14857,'TE','3306087346',1,'2013-12-29 11:15:14',NULL,NULL),(4032,2576,'TE','5136250772',0,'2013-12-25 19:37:50',NULL,NULL),(3539,2216,'TE','2342179008',0,'2013-12-25 19:20:24',NULL,NULL),(35860,23582,'EM','joeking4400@yahoo.com',0,'2014-02-13 22:02:57',NULL,NULL),(39552,26167,'TE','6018918160',0,'2014-02-28 06:30:35',NULL,NULL),(40702,27039,'TE','9727758700',0,'2014-03-03 21:00:20',NULL,NULL),(2428,1487,'TE','3306719767',0,'2013-12-25 18:48:56',NULL,NULL),(29488,19059,'TE','4322448410',0,'2014-01-21 08:44:14',NULL,NULL),(3213,2017,'AP','3302424660',0,'2013-12-25 19:15:04',NULL,NULL),(11504,7486,'AP','6145375124',0,'2013-12-26 02:31:30',NULL,NULL),(10834,7036,'TE','2148307946',0,'2013-12-26 01:49:16',NULL,NULL),(10191,6658,'AP','6145571775',0,'2013-12-26 01:00:48',NULL,NULL),(36659,24132,'BN','9014977309',0,'2014-02-15 22:01:48',NULL,NULL),(37642,24810,'TE','5139009025',0,'2014-02-20 04:49:43',NULL,NULL),(37784,24935,'AP','6016134736',0,'2014-02-20 21:30:22',NULL,NULL),(40730,27067,'BN','3187801559',0,'2014-03-03 21:30:03',NULL,NULL),(43735,29034,'TE','5132383973',0,'2014-03-10 21:01:37',NULL,NULL),(25844,16660,'AP','2254564619',0,'2014-01-08 18:24:24',NULL,NULL),(31286,20382,'EM','DAdreinne@gmail.com',0,'2014-01-29 21:00:12',NULL,NULL),(14929,9768,'EM','anthonymain@usa.com',0,'2013-12-26 05:00:23',NULL,NULL),(34497,22631,'TE','2142588748',0,'2014-02-11 21:00:17',NULL,NULL),(10558,6873,'EM','mikhail.khalil13@gmail.com',0,'2013-12-26 01:32:02',NULL,NULL),(2755,1670,'TE','9033681131',0,'2013-12-25 18:53:53',NULL,NULL),(41260,27420,'AP','5044054528',0,'2014-03-04 21:01:38',NULL,NULL),(267,164,'TE','5138236546',0,'2013-12-25 17:19:17',NULL,NULL),(1542,949,'TE','5132066430',0,'2013-12-25 18:09:31',NULL,NULL),(7253,4727,'TE','4194769078',0,'2013-12-25 22:09:05',NULL,NULL),(36883,24291,'AP','3307019455',0,'2014-02-18 21:30:13',NULL,NULL),(3804,2420,'TE','5135209019',0,'2013-12-25 19:33:56',NULL,NULL),(33981,22293,'TE','5134780082',0,'2014-02-10 11:00:30',NULL,NULL),(29232,18880,'AP','3377878791',0,'2014-01-17 03:36:28',NULL,NULL),(14436,9434,'TE','4196325518',0,'2013-12-26 04:33:29',NULL,NULL),(27023,17378,'TE','3302658969',0,'2014-01-13 03:00:04',NULL,NULL),(27569,17769,'TE','2105087088',0,'2014-01-14 01:33:37',NULL,NULL),(41185,27353,'AP','4405397360',0,'2014-03-04 21:01:06',NULL,NULL),(42986,28590,'AP','3305752522',0,'2014-03-08 21:30:02',NULL,NULL),(37567,24744,'TE','6143579513',0,'2014-02-20 04:40:52',NULL,NULL),(26025,16770,'TE','9374036408',0,'2014-01-08 18:25:01',NULL,NULL),(958,591,'TE','3309540070',0,'2013-12-25 18:00:03',NULL,NULL),(35724,23494,'TE','9373939141',0,'2014-02-13 22:02:04',NULL,NULL),(4929,3164,'TE','5137771991',0,'2013-12-25 20:31:24',NULL,NULL),(14773,9669,'TE','9374861000',0,'2013-12-26 04:39:11',NULL,NULL),(2988,1850,'AP','3303286007',0,'2013-12-25 18:57:53',NULL,NULL),(22271,14355,'TE','6149875470',0,'2013-12-28 03:30:08',NULL,NULL),(21894,14106,'EM','bernitaturner44@yahoo.com',0,'2013-12-27 02:01:44',NULL,NULL),(4542,2889,'TE','2345427548',0,'2013-12-25 20:15:08',NULL,NULL),(5999,3853,'AP','3373133444',0,'2013-12-25 21:35:42',NULL,NULL),(4051,2585,'AP','4192030134',0,'2013-12-25 19:38:07',NULL,NULL),(5483,3508,'AP','9372728903',0,'2013-12-25 21:20:55',NULL,NULL),(4016,2554,'AP','6625547584',0,'2013-12-25 19:37:22',NULL,NULL),(9845,6438,'EM','jwjcelestin@att.net',0,'2013-12-26 00:49:23',NULL,NULL),(4035,2577,'TE','4192300466',0,'2013-12-25 19:37:52',NULL,NULL),(7263,4735,'AP','4193480854',0,'2013-12-25 22:09:16',NULL,NULL),(31564,20577,'EM','sammshannawi@gmail.com',0,'2014-01-30 21:00:03',NULL,NULL),(36992,24354,'AP','3373315980',0,'2014-02-18 22:00:29',NULL,NULL),(20675,13295,'AP','7138588151',0,'2013-12-26 12:57:35',NULL,NULL),(29672,19175,'AP','7133826969',0,'2014-01-21 08:46:05',NULL,NULL),(14542,9500,'TE','3305333324',0,'2013-12-26 04:35:10',NULL,NULL),(35593,23408,'AP','4408133980',0,'2014-02-13 22:01:14',NULL,NULL),(38965,25762,'TE','3304167855',0,'2014-02-26 09:30:52',NULL,NULL),(39007,25794,'EM','teresaferguson55@yahoo.com',0,'2014-02-26 21:00:13',NULL,NULL),(24363,15733,'TE','3302127618',0,'2014-01-03 02:00:35',NULL,NULL),(24531,15822,'BN','4404876676',0,'2014-01-03 02:03:34',NULL,NULL),(1580,975,'AP','5044913683',0,'2013-12-25 18:10:07',NULL,NULL),(22019,14181,'EM','WENDYJOTAYLOR@YAHOO.COM',0,'2013-12-27 02:03:43',NULL,NULL),(23623,15252,'TE','4194487457',0,'2014-01-01 12:08:59',NULL,NULL),(4731,3028,'TE','4192978224',0,'2013-12-25 20:18:22',NULL,NULL),(4369,2784,'TE','4192691307',0,'2013-12-25 19:49:57',NULL,NULL),(27208,17521,'TE','7408155943',0,'2014-01-13 03:01:36',NULL,NULL),(4251,2720,'TE','2254445522',0,'2013-12-25 19:48:10',NULL,NULL),(28702,18521,'BN','8306131058',0,'2014-01-16 08:46:38',NULL,NULL),(6940,4522,'TE','9569683321',0,'2013-12-25 22:03:51',NULL,NULL),(35293,23182,'TE','6013311118',0,'2014-02-12 21:31:58',NULL,NULL),(28327,18256,'AP','8302558667',0,'2014-01-16 08:44:34',NULL,NULL),(22287,14364,'EM','velvetablue@bex.net',0,'2013-12-28 03:30:22',NULL,NULL),(6035,3876,'EM','Sluggybunbun@gmail.com',0,'2013-12-25 21:36:19',NULL,NULL),(33274,21788,'EM','brooks10k@gmail.com',0,'2014-02-06 21:00:42',NULL,NULL),(8781,5755,'TE','6143904406',0,'2013-12-25 23:46:20',NULL,NULL),(35712,23486,'TE','5049758227',0,'2014-02-13 22:01:59',NULL,NULL),(30934,20117,'TE','4192973734',0,'2014-01-27 21:00:44',NULL,NULL),(27228,17529,'EM','DWD71668@ATT.NET',0,'2014-01-13 03:01:42',NULL,NULL),(5302,3399,'AP','4405208832',0,'2013-12-25 21:18:04',NULL,NULL),(21778,14033,'EM','pink_day_care@yahoo.com',0,'2013-12-26 13:16:55',NULL,NULL),(25475,16427,'EM','toshia.hyatt@gmail.com',0,'2014-01-07 04:04:41',NULL,NULL),(3548,2222,'AP','4192832414',0,'2013-12-25 19:20:33',NULL,NULL),(10425,6797,'TE','4194105267',0,'2013-12-26 01:17:16',NULL,NULL),(23126,14906,'AP','2282337364',0,'2013-12-30 00:01:19',NULL,NULL),(35889,23609,'TE','5677124093',0,'2014-02-13 22:03:11',NULL,NULL),(36056,23716,'EM','awtroxell@aol.com',0,'2014-02-14 21:30:50',NULL,NULL),(980,603,'EM','Judisullivan@woh.rr.com',0,'2013-12-25 18:00:23',NULL,NULL),(9276,6073,'TE','4409922818',0,'2013-12-26 00:02:15',NULL,NULL),(13689,8924,'TE','4407294397',0,'2013-12-26 04:02:52',NULL,NULL),(29057,18763,'AP','5017662787',0,'2014-01-17 03:35:48',NULL,NULL),(26367,16973,'TE','6012011436',0,'2014-01-13 02:20:14',NULL,NULL),(21912,14117,'TE','3302056368',0,'2013-12-27 02:02:01',NULL,NULL),(6049,3885,'AP','3304313466',0,'2013-12-25 21:36:34',NULL,NULL),(41564,27635,'EM','uavince06@gmail.com',0,'2014-03-05 21:30:13',NULL,NULL),(258,157,'EM','robledoesther@hotmail.com',0,'2013-12-25 17:19:06',NULL,NULL),(24994,16109,'AP','9018598419',0,'2014-01-04 02:05:01',NULL,NULL),(9613,6291,'EM','belam1234@aol.com',0,'2013-12-26 00:45:39',NULL,NULL),(33717,22117,'TE','2145438666',0,'2014-02-08 19:00:38',NULL,NULL),(33533,21981,'EM','waynemcc1313@gmail.com',0,'2014-02-07 19:00:37',NULL,NULL),(36244,23854,'TE','5133149889',0,'2014-02-14 21:32:00',NULL,NULL),(28650,18478,'AP','3302128757',0,'2014-01-16 08:46:20',NULL,NULL),(27348,17609,'AP','2102157489',0,'2014-01-14 01:32:20',NULL,NULL),(26985,17355,'EM','SHELLEY.BRIGNAC@GMAIL.COM',0,'2014-01-13 02:24:11',NULL,NULL),(9403,6153,'AP','8325882229',0,'2013-12-26 00:16:35',NULL,NULL),(12199,7971,'AP','6628366241',0,'2013-12-26 03:07:41',NULL,NULL),(20391,13134,'EM','apoched1@kent.edu',0,'2013-12-26 12:53:07',NULL,NULL),(3766,2389,'AP','9376411267',0,'2013-12-25 19:33:14',NULL,NULL),(662,412,'TE','2165709608',0,'2013-12-25 17:46:27',NULL,NULL),(36060,23719,'TE','8057014328',0,'2014-02-14 21:30:51',NULL,NULL),(37293,24541,'TE','9152443276',0,'2014-02-20 04:02:25',NULL,NULL),(41649,27685,'EM','brianw.kirksey@gmail.com',0,'2014-03-05 21:30:41',NULL,NULL),(43790,29069,'TE','4194501766',0,'2014-03-10 21:01:56',NULL,NULL),(21752,14011,'TE','9374744557',0,'2013-12-26 13:16:23',NULL,NULL),(11090,7205,'TE','9373467293',0,'2013-12-26 02:00:45',NULL,NULL),(9552,6251,'AP','9372171554',0,'2013-12-26 00:31:58',NULL,NULL),(4130,2634,'TE','3304259302',0,'2013-12-25 19:46:12',NULL,NULL),(34388,22556,'EM','nick.goers@gmail.com',0,'2014-02-10 21:31:48',NULL,NULL),(14707,9623,'TE','4197050738',0,'2013-12-26 04:37:58',NULL,NULL),(5285,3390,'TE','3186403159',0,'2013-12-25 21:17:48',NULL,NULL),(31793,20750,'EM','xtremeunleashed@live.com',0,'2014-01-30 21:01:30',NULL,NULL),(3036,1889,'EM','jericmorse@roadrunner.com',0,'2013-12-25 18:58:48',NULL,NULL),(27553,17757,'AP','5132524444',0,'2014-01-14 01:33:31',NULL,NULL),(20952,13477,'TE','3307548378',0,'2013-12-26 13:02:09',NULL,NULL),(27445,17679,'TE','3187910216',0,'2014-01-14 01:32:53',NULL,NULL),(37709,24863,'TE','5129342895',0,'2014-02-20 05:30:57',NULL,NULL),(41017,27253,'AP','9373026791',0,'2014-03-03 21:31:55',NULL,NULL),(42082,27961,'TE','3182720406',0,'2014-03-06 21:00:45',NULL,NULL),(43378,28808,'EM','jpr2500@windstream.net',0,'2014-03-09 21:00:53',NULL,NULL),(32518,21257,'EM','neil.jacobsen1@gmail.com',0,'2014-02-03 21:01:21',NULL,NULL),(32337,21123,'EM','DRAMSEY@CONSOLIDATED.NET',0,'2014-02-03 21:00:14',NULL,NULL),(27812,17922,'EM','krpoun@hotmail.com',0,'2014-01-15 02:06:32',NULL,NULL),(26734,17195,'TE','5045054802',0,'2014-01-13 02:22:21',NULL,NULL),(7354,4780,'AP','6627197468',0,'2013-12-25 22:16:06',NULL,NULL),(13685,8922,'TE','9373375044',0,'2013-12-26 04:02:49',NULL,NULL),(14172,9272,'EM','jennifer.perusek@yahoo.com',0,'2013-12-26 04:15:42',NULL,NULL),(5116,3278,'AP','5132527622',0,'2013-12-25 21:15:12',NULL,NULL),(23909,15426,'TE','8176888339',1,'2014-01-02 04:27:36',NULL,NULL),(22395,14444,'AP','8646029574',0,'2013-12-28 03:32:17',NULL,NULL),(39728,26276,'TE','3188161741',0,'2014-02-28 06:31:18',NULL,NULL),(40458,26858,'TE','9372170522',0,'2014-03-01 21:00:55',NULL,NULL),(41218,27378,'AP','2284242303',0,'2014-03-04 21:01:19',NULL,NULL),(22138,14258,'AP','9857734793',0,'2013-12-27 02:05:44',NULL,NULL),(5630,3608,'TE','3307054789',0,'2013-12-25 21:23:25',NULL,NULL),(4347,2774,'AP','6013254823',0,'2013-12-25 19:49:38',NULL,NULL),(6438,4161,'AP','4402281047',0,'2013-12-25 21:48:59',NULL,NULL),(35485,23334,'AP','5133786391',0,'2014-02-13 22:00:33',NULL,NULL),(32037,20913,'TE','3303489192',0,'2014-01-31 21:01:29',NULL,NULL),(8510,5595,'EM','Getmoneyproductions82@gmail.com',0,'2013-12-25 23:30:06',NULL,NULL),(8691,5705,'TE','4193484381',0,'2013-12-25 23:33:03',NULL,NULL),(9944,6506,'EM','C.hoover@zoominternet.net',0,'2013-12-26 00:51:00',NULL,NULL),(35708,23484,'TE','5042969745',0,'2014-02-13 22:01:57',NULL,NULL),(38453,25410,'TE','5138892121',0,'2014-02-25 21:31:02',NULL,NULL),(38620,25523,'EM','footwwjd2@juno.com',0,'2014-02-25 21:32:08',NULL,NULL),(41329,27455,'AP','3303101920',0,'2014-03-04 21:02:02',NULL,NULL),(29993,19417,'TE','9374655029',1,'2014-01-22 03:23:01',NULL,NULL),(25302,16315,'TE','2252842773',0,'2014-01-07 04:01:33',NULL,NULL),(28064,18089,'TE','5043205607',0,'2014-01-15 02:07:29',NULL,NULL),(8807,5768,'AP','2163382597',0,'2013-12-25 23:46:43',NULL,NULL),(21094,13564,'AP','5043887800',0,'2013-12-26 13:04:27',NULL,NULL),(20838,13397,'TE','5139392211',0,'2013-12-26 13:00:15',NULL,NULL),(1403,857,'EM','ar@azzarellosrealty.com',0,'2013-12-25 18:07:04',NULL,NULL),(34773,22807,'TE','7406030115',0,'2014-02-11 21:01:55',NULL,NULL),(32542,21277,'AP','3049897366',0,'2014-02-03 21:01:34',NULL,NULL),(31914,20833,'TE','3308041951',0,'2014-01-31 21:00:42',NULL,NULL),(11303,7367,'AP','5049821701',0,'2013-12-26 02:15:34',NULL,NULL),(14153,9265,'TE','6017374880',0,'2013-12-26 04:15:27',NULL,NULL),(6240,4021,'EM','lrug@yahoo.com',0,'2013-12-25 21:45:41',NULL,NULL),(23034,14858,'AP','3304724861',1,'2013-12-29 11:15:17',NULL,NULL),(43728,29026,'AP','5137037963',0,'2014-03-10 21:01:34',NULL,NULL),(33332,21834,'AP','8175978734',0,'2014-02-06 21:01:06',NULL,NULL),(4358,2779,'AP','6013767628',0,'2013-12-25 19:49:48',NULL,NULL),(8919,5837,'EM','jameeltx@aol.com',0,'2013-12-25 23:48:28',NULL,NULL),(33243,21770,'AP','6143306543',0,'2014-02-06 21:00:31',NULL,NULL),(28876,18644,'AP','2104132180',0,'2014-01-17 03:35:07',NULL,NULL),(1302,792,'AP','9366727777',0,'2013-12-25 18:05:21',NULL,NULL),(21779,14034,'TE','4193764591',0,'2013-12-26 13:16:57',NULL,NULL),(36324,23923,'EM','Suhaila225@yahoo.com',0,'2014-02-14 22:00:07',NULL,NULL),(41121,27315,'AP','9565361331',0,'2014-03-04 21:00:42',NULL,NULL),(41525,27611,'TE','3373294777',0,'2014-03-05 21:00:28',NULL,NULL),(2979,1845,'AP','4404771358',0,'2013-12-25 18:57:45',NULL,NULL),(25514,16452,'TE','9012700247',0,'2014-01-07 04:05:27',NULL,NULL),(23502,15163,'TE','4405482930',0,'2014-01-01 12:06:19',NULL,NULL),(5830,3742,'EM','shane_rex@ymail.com',0,'2013-12-25 21:32:55',NULL,NULL),(6494,4201,'TE','8176919029',0,'2013-12-25 21:49:54',NULL,NULL),(5574,3560,'TE','3308670510',0,'2013-12-25 21:22:17',NULL,NULL),(5048,3239,'AP','8323295039',0,'2013-12-25 20:46:17',NULL,NULL),(35885,23599,'TE','4197027017',0,'2014-02-13 22:03:07',NULL,NULL),(36758,24204,'AP','3306716191',0,'2014-02-16 19:00:19',NULL,NULL),(43429,28841,'EM','dmessenger1@neo.rr.com',0,'2014-03-09 21:01:12',NULL,NULL),(23258,14985,'AP','5127994830',0,'2014-01-01 12:01:14',NULL,NULL),(11773,7660,'AP','3186231289',0,'2013-12-26 03:00:16',NULL,NULL),(32499,21239,'EM','arethasings2him@yahoo.com',0,'2014-02-03 21:01:12',NULL,NULL),(29748,19235,'TE','5134011208',0,'2014-01-21 08:46:35',NULL,NULL),(29740,19229,'AP','4198102622',0,'2014-01-21 08:46:32',NULL,NULL),(2571,1569,'TE','2143203114',0,'2013-12-25 18:51:08',NULL,NULL),(12123,7923,'AP','5042363437',0,'2013-12-26 03:06:23',NULL,NULL),(6397,4126,'EM','paharmon11@att.net',0,'2013-12-25 21:48:18',NULL,NULL),(21452,13788,'EM','fanchionk@gmail.com',0,'2013-12-26 13:10:59',NULL,NULL),(43944,29149,'AP','5133730075',0,'2014-03-10 21:02:48',NULL,NULL),(28914,18666,'TE','9165886712',0,'2014-01-17 03:35:15',NULL,NULL),(25943,16713,'TE','8062682627',0,'2014-01-08 18:24:43',NULL,NULL),(21650,13934,'TE','4198745514',0,'2013-12-26 13:14:34',NULL,NULL),(22142,14260,'AP','9855032517',0,'2013-12-27 02:05:47',NULL,NULL),(20685,13299,'AP','9729777224',0,'2013-12-26 12:57:44',NULL,NULL),(27085,17419,'AP','9378769432',0,'2014-01-13 03:00:26',NULL,NULL),(20604,13252,'AP','9562022462',0,'2013-12-26 12:56:26',NULL,NULL),(24322,15712,'TE','4197381786',1,'2014-01-02 04:36:06',NULL,NULL),(23938,15446,'TE','2547712329',1,'2014-01-02 04:28:13',NULL,NULL),(1027,633,'AP','5133071859',0,'2013-12-25 18:01:09',NULL,NULL),(4938,3172,'TE','2169265800',0,'2013-12-25 20:31:34',NULL,NULL),(33000,21615,'TE','9565196830',0,'2014-02-05 21:30:36',NULL,NULL),(32903,21543,'AP','3306878875',0,'2014-02-05 21:30:10',NULL,NULL),(20225,13028,'AP','7403508383',0,'2013-12-26 12:50:17',NULL,NULL),(7851,5124,'AP','9032929522',0,'2013-12-25 23:02:02',NULL,NULL),(29559,19102,'TE','3374065601',0,'2014-01-21 08:44:39',NULL,NULL),(28170,18157,'AP','4193881110',0,'2014-01-15 02:07:53',NULL,NULL),(39173,25912,'TE','5125379234',0,'2014-02-26 21:01:15',NULL,NULL),(41458,27549,'EM','mdkitcko@att.net',0,'2014-03-04 21:30:10',NULL,NULL),(14404,9419,'EM','Jlbrown1227@gmail.com',0,'2013-12-26 04:33:04',NULL,NULL),(30886,20075,'TE','9569269005',0,'2014-01-27 21:00:20',NULL,NULL),(14212,9300,'AP','4043379092',0,'2013-12-26 04:16:22',NULL,NULL),(33022,21634,'AP','9566241354',0,'2014-02-05 21:30:42',NULL,NULL),(14784,9673,'AP','5412171070',0,'2013-12-26 04:39:19',NULL,NULL),(31725,20704,'TE','9855266702',0,'2014-01-30 21:01:05',NULL,NULL),(20686,13299,'EM','staceyacol@aol.com',0,'2013-12-26 12:57:44',NULL,NULL),(27168,17492,'TE','3186459205',0,'2014-01-13 03:01:21',NULL,NULL),(12362,8091,'AP','5133700621',0,'2013-12-26 03:10:42',NULL,NULL),(21604,13903,'AP','4194603225',0,'2013-12-26 13:13:45',NULL,NULL),(1767,1090,'TE','4196293307',0,'2013-12-25 18:17:01',NULL,NULL),(4560,2900,'EM','tonyfjr1@gmail.com',0,'2013-12-25 20:15:22',NULL,NULL),(24635,15886,'TE','5042764361',0,'2014-01-03 02:05:33',NULL,NULL),(36866,24278,'AP','5136926091',0,'2014-02-18 21:30:05',NULL,NULL),(38632,25534,'AP','2542470034',0,'2014-02-26 08:00:06',NULL,NULL),(39411,26059,'AP','5136338288',0,'2014-02-26 21:02:38',NULL,NULL),(1538,947,'TE','2162143135',0,'2013-12-25 18:09:28',NULL,NULL),(25995,16749,'TE','2148467027',0,'2014-01-08 18:24:54',NULL,NULL),(11588,7541,'TE','5124131129',0,'2013-12-26 02:32:54',NULL,NULL),(20505,13202,'AP','2142359997',0,'2013-12-26 12:54:59',NULL,NULL),(10420,6794,'AP','3308062764',0,'2013-12-26 01:17:11',NULL,NULL),(9514,6227,'EM','Shawn_78643@hotmail.com',0,'2013-12-26 00:31:21',NULL,NULL),(32475,21218,'TE','3188161346',0,'2014-02-03 21:01:02',NULL,NULL),(22632,14594,'TE','3303109592',0,'2013-12-28 03:36:12',NULL,NULL),(30828,20043,'TE','4193051093',0,'2014-01-26 19:00:28',NULL,NULL),(30791,20019,'AP','4324488151',0,'2014-01-26 19:00:14',NULL,NULL),(27483,17703,'TE','5045782709',0,'2014-01-14 01:33:05',NULL,NULL),(8714,5718,'EM','ludwig.freemanii@yahoo.com',0,'2013-12-25 23:45:20',NULL,NULL),(11118,7230,'AP','5135022831',0,'2013-12-26 02:01:21',NULL,NULL),(23509,15167,'TE','5134448009',0,'2014-01-01 12:06:27',NULL,NULL),(11904,7745,'TE','2162290830',0,'2013-12-26 03:02:23',NULL,NULL),(7325,4763,'TE','9377895000',0,'2013-12-25 22:15:37',NULL,NULL),(4109,2620,'AP','3305468877',0,'2013-12-25 19:45:51',NULL,NULL),(37856,24973,'EM','d.lynn78@hotmail.com',0,'2014-02-20 22:00:28',NULL,NULL),(43272,28748,'AP','4086454057',0,'2014-03-09 21:00:15',NULL,NULL),(24250,15667,'TE','4197389407',1,'2014-01-02 04:34:40',NULL,NULL),(11837,7701,'EM','debbiemillerrobinson@gmail.com',0,'2013-12-26 03:01:17',NULL,NULL),(22441,14472,'EM','enrique.urquieta@hotmail.com',0,'2013-12-28 03:33:04',NULL,NULL),(10077,6587,'AP','5133242999',0,'2013-12-26 00:53:08',NULL,NULL),(31370,20445,'EM','alana.marie24@yahoo.com',0,'2014-01-29 21:00:42',NULL,NULL),(8757,5740,'EM','Misssandy25@yahoo.com',0,'2013-12-25 23:45:55',NULL,NULL),(27951,18009,'AP','6143144187',0,'2014-01-15 02:07:03',NULL,NULL),(36759,24204,'BN','3306716191',0,'2014-02-16 19:00:19',NULL,NULL),(41020,27255,'AP','5135157746',0,'2014-03-03 21:31:56',NULL,NULL),(41388,27495,'EM','DianaKemp@aol.com',0,'2014-03-04 21:02:25',NULL,NULL),(43726,29025,'EM','MHALLEZ@GMAIL.COM',0,'2014-03-10 21:01:33',NULL,NULL),(20709,13310,'EM','DEBBIEGARCIA17@GMAIL.COM',0,'2013-12-26 12:58:05',NULL,NULL),(25908,16696,'AP','9565151561',0,'2014-01-08 18:24:37',NULL,NULL),(36094,23738,'AP','2167025571',0,'2014-02-14 21:31:03',NULL,NULL),(1477,905,'TE','5133071859',0,'2013-12-25 18:08:23',NULL,NULL),(3366,2114,'EM','Cbjr1970@gmail.com',0,'2013-12-25 19:17:33',NULL,NULL),(35441,23303,'TE','3124516900',0,'2014-02-13 22:00:16',NULL,NULL),(34638,22711,'TE','5043439162',0,'2014-02-11 21:01:05',NULL,NULL),(6648,4311,'EM','jchristine627@gmail.com',0,'2013-12-25 21:52:34',NULL,NULL),(32967,21581,'AP','3309838932',0,'2014-02-05 21:30:25',NULL,NULL),(29877,19334,'EM','mtalkington1@aol.com',1,'2014-01-22 03:22:17',NULL,NULL),(14310,9358,'TE','2252816454',0,'2013-12-26 04:31:28',NULL,NULL),(37577,24755,'TE','7405027990',0,'2014-02-20 04:42:08',NULL,NULL),(42586,28335,'AP','2107241040',0,'2014-03-07 21:30:13',NULL,NULL),(42769,28446,'AP','5042963136',0,'2014-03-07 21:31:17',NULL,NULL),(42999,28595,'TE','7406020400',0,'2014-03-08 21:30:05',NULL,NULL),(21807,14051,'AP','5133447359',0,'2013-12-27 02:00:17',NULL,NULL),(30980,20153,'TE','5132880018',0,'2014-01-27 21:01:05',NULL,NULL),(10259,6703,'EM','cb1393@hotmail.com',0,'2013-12-26 01:01:59',NULL,NULL),(26247,16892,'EM','terifleming2013@gmail.com',0,'2014-01-13 02:19:28',NULL,NULL),(3515,2197,'TE','9377269334',0,'2013-12-25 19:19:56',NULL,NULL),(11653,7586,'TE','7133764146',0,'2013-12-26 02:34:05',NULL,NULL),(563,349,'TE','9374928024',0,'2013-12-25 17:32:13',NULL,NULL),(8561,5623,'EM','pkburrows@wowway.com',0,'2013-12-25 23:30:52',NULL,NULL),(10752,6989,'AP','5134770759',0,'2013-12-26 01:47:57',NULL,NULL),(8377,5507,'EM','estrick007@yahoo.com',0,'2013-12-25 23:15:05',NULL,NULL),(36966,24340,'AP','9156266114',0,'2014-02-18 22:00:20',NULL,NULL),(35317,23206,'TE','5672089601',0,'2014-02-12 21:32:10',NULL,NULL),(9546,6249,'TE','5044510380',0,'2013-12-26 00:31:54',NULL,NULL),(14585,9536,'TE','3302962033',0,'2013-12-26 04:35:55',NULL,NULL),(22163,14275,'TE','6015025961',0,'2013-12-27 02:06:12',NULL,NULL),(23733,15312,'TE','9033068807',1,'2014-01-02 04:23:16',NULL,NULL),(23877,15407,'AP','3258298165',1,'2014-01-02 04:27:00',NULL,NULL),(34358,22537,'AP','8503461735',0,'2014-02-10 21:31:36',NULL,NULL),(29170,18849,'TE','3303369364',0,'2014-01-17 03:36:15',NULL,NULL),(29333,18954,'AP','8326337271',0,'2014-01-20 08:05:51',NULL,NULL),(37435,24649,'TE','5046069323',0,'2014-02-20 04:22:22',NULL,NULL),(38398,25367,'TE','5134329401',0,'2014-02-25 21:30:39',NULL,NULL),(22861,14752,'AP','9375278500',1,'2013-12-29 11:10:21',NULL,NULL),(29715,19212,'AP','4408290403',0,'2014-01-21 08:46:22',NULL,NULL),(29215,18872,'TE','2259162490',0,'2014-01-17 03:36:24',NULL,NULL),(6226,4013,'AP','5133744742',0,'2013-12-25 21:45:29',NULL,NULL),(5426,3472,'TE','9372380373',0,'2013-12-25 21:20:00',NULL,NULL),(4556,2899,'AP','3302311143',0,'2013-12-25 20:15:19',NULL,NULL),(20851,13405,'AP','5133072971',0,'2013-12-26 13:00:27',NULL,NULL),(2980,1845,'EM','susan.walk@att.net',0,'2013-12-25 18:57:45',NULL,NULL),(14932,9770,'TE','9372371946',0,'2013-12-26 05:00:26',NULL,NULL),(38371,25345,'AP','2163258171',0,'2014-02-25 21:30:28',NULL,NULL),(38948,25750,'TE','6142561765',0,'2014-02-26 09:30:45',NULL,NULL),(39611,26201,'TE','3307042647',0,'2014-02-28 06:30:49',NULL,NULL),(40437,26845,'TE','3377831398',0,'2014-03-01 21:00:47',NULL,NULL),(1357,828,'EM','joelle2bwell@sbcglobal.net',0,'2013-12-25 18:06:16',NULL,NULL),(34362,22539,'TE','2254859649',0,'2014-02-10 21:31:38',NULL,NULL),(31387,20457,'TE','6146482757',0,'2014-01-29 21:00:49',NULL,NULL),(8003,5223,'TE','4194968555',0,'2013-12-25 23:04:35',NULL,NULL),(22620,14587,'EM','bruskch@gmail.com',0,'2013-12-28 03:36:01',NULL,NULL),(37806,24950,'TE','5043279301',0,'2014-02-20 22:00:11',NULL,NULL),(40393,26812,'TE','4192625322',0,'2014-03-01 21:00:29',NULL,NULL),(72,45,'EM','wevers@wmpr901.com',0,'2013-12-25 17:16:12',NULL,NULL),(33197,21738,'TE','8067819673',0,'2014-02-06 21:00:14',NULL,NULL),(30897,20087,'TE','8053006583',0,'2014-01-27 21:00:27',NULL,NULL),(27173,17495,'EM','adamjeanfreau@gmail.com',0,'2014-01-13 03:01:22',NULL,NULL),(22884,14766,'TE','3258647339',1,'2013-12-29 11:12:48',NULL,NULL),(11559,7522,'AP','5134734316',0,'2013-12-26 02:32:26',NULL,NULL),(10115,6613,'TE','5133857069',0,'2013-12-26 00:53:49',NULL,NULL),(36301,23900,'AP','9376686627',0,'2014-02-14 21:32:24',NULL,NULL),(964,594,'TE','3305015402',0,'2013-12-25 18:00:09',NULL,NULL),(32567,21296,'EM','carolyncannon173@yahoo.com',0,'2014-02-04 21:00:09',NULL,NULL),(26496,17051,'TE','4197019749',0,'2014-01-13 02:20:58',NULL,NULL),(26401,16992,'TE','5679387877',0,'2014-01-13 02:20:25',NULL,NULL),(10093,6594,'AP','6019687879',0,'2013-12-26 00:53:22',NULL,NULL),(31769,20736,'EM','amykoons75@yahoo.com',0,'2014-01-30 21:01:22',NULL,NULL),(6474,4188,'EM','karenybickerstaff@gmail.com',0,'2013-12-25 21:49:35',NULL,NULL),(21528,13841,'EM','jcrgaa@aol.com',0,'2013-12-26 13:12:19',NULL,NULL),(39095,25867,'TE','3373086208',0,'2014-02-26 21:00:48',NULL,NULL),(24085,15548,'AP','4155480038',1,'2014-01-02 04:31:12',NULL,NULL),(29495,19062,'EM','abelperez862@gmail.com',0,'2014-01-21 08:44:16',NULL,NULL),(25545,16479,'AP','3306280500',0,'2014-01-07 04:06:12',NULL,NULL),(27288,17570,'AP','5132840916',0,'2014-01-14 01:32:01',NULL,NULL),(41612,27666,'TE','2162185222',0,'2014-03-05 21:30:30',NULL,NULL),(36,25,'AP','9073422615',0,'2013-12-25 17:15:38',NULL,NULL),(13592,8861,'AP','9036440042',0,'2013-12-26 04:01:17',NULL,NULL),(38413,25381,'TE','6623033988',0,'2014-02-25 21:30:46',NULL,NULL),(10825,7030,'TE','2149371619',0,'2013-12-26 01:49:07',NULL,NULL),(1096,673,'AP','6142660889',0,'2013-12-25 18:02:12',NULL,NULL),(35598,23410,'TE','3612209726',0,'2014-02-13 22:01:16',NULL,NULL),(31563,20573,'AP','5132330229',0,'2014-01-29 21:01:54',NULL,NULL),(1529,940,'AP','5133733544',0,'2013-12-25 18:09:19',NULL,NULL),(6643,4305,'TE','5132260327',0,'2013-12-25 21:52:27',NULL,NULL),(27772,17905,'AP','2148025302',0,'2014-01-15 02:06:25',NULL,NULL),(3307,2080,'EM','jgtwhatley@bellsouth.net',0,'2013-12-25 19:16:36',NULL,NULL),(6561,4237,'EM','ROBGRACE2@JUNO.COM',0,'2013-12-25 21:50:55',NULL,NULL),(22852,14745,'AP','5132937603',1,'2013-12-29 11:10:10',NULL,NULL),(40921,27192,'AP','8322050650',0,'2014-03-03 21:31:17',NULL,NULL),(43817,29085,'TE','7139223205',0,'2014-03-10 21:02:06',NULL,NULL),(37087,24419,'TE','2162998240',0,'2014-02-18 22:01:06',NULL,NULL),(29762,19244,'EM','jeffrey.stout@hotmail.com',0,'2014-01-21 08:46:40',NULL,NULL),(12249,8009,'TE','8303673661',0,'2013-12-26 03:08:36',NULL,NULL),(14097,9217,'TE','4192695410',0,'2013-12-26 04:10:05',NULL,NULL),(14655,9586,'TE','6014083956',0,'2013-12-26 04:37:03',NULL,NULL),(21026,13528,'AP','5044733705',0,'2013-12-26 13:03:23',NULL,NULL),(5580,3566,'TE','4198252158',0,'2013-12-25 21:22:26',NULL,NULL),(34016,22312,'TE','6626643578',0,'2014-02-10 11:00:46',NULL,NULL),(3972,2520,'TE','3302857596',0,'2013-12-25 19:36:35',NULL,NULL),(10374,6762,'TE','9858679113',0,'2013-12-26 01:16:23',NULL,NULL),(8186,5356,'TE','3307841175',0,'2013-12-25 23:07:45',NULL,NULL),(33249,21772,'AP','6146255360',0,'2014-02-06 21:00:33',NULL,NULL),(30634,19880,'EM','jlvasey@neo.rr.com',0,'2014-01-24 21:00:46',NULL,NULL),(22542,14535,'AP','6016659458',0,'2013-12-28 03:34:40',NULL,NULL),(26983,17355,'TE','2253244548',0,'2014-01-13 02:24:11',NULL,NULL),(38757,25622,'TE','2544589227',0,'2014-02-26 08:30:17',NULL,NULL),(2577,1572,'AP','8174494328',0,'2013-12-25 18:51:13',NULL,NULL),(6769,4393,'TE','4195123935',0,'2013-12-25 22:00:56',NULL,NULL),(6413,4139,'EM','JOYZING@SBCGLOBAL.NET',0,'2013-12-25 21:48:33',NULL,NULL),(37774,24929,'TE','3307150439',0,'2014-02-20 21:30:19',NULL,NULL),(37011,24369,'AP','5048581510',0,'2014-02-18 22:00:37',NULL,NULL),(36874,24286,'TE','5048581510',0,'2014-02-18 21:30:09',NULL,NULL),(34298,22507,'TE','9374703796',0,'2014-02-10 21:31:16',NULL,NULL),(24672,15909,'TE','5132620754',0,'2014-01-03 02:06:19',NULL,NULL),(32960,21578,'TE','3303290304',0,'2014-02-05 21:30:24',NULL,NULL),(30284,19620,'TE','6145791914',0,'2014-01-23 21:00:03',NULL,NULL),(38853,25683,'TE','6019662984',0,'2014-02-26 09:30:06',NULL,NULL),(1682,1034,'TE','9797395769',0,'2013-12-25 18:15:36',NULL,NULL),(36601,24096,'AP','7864870511',0,'2014-02-15 22:01:28',NULL,NULL),(2360,1434,'TE','3377811269',0,'2013-12-25 18:47:39',NULL,NULL),(2393,1459,'TE','6142359691',0,'2013-12-25 18:48:16',NULL,NULL),(14219,9303,'AP','3185606845',0,'2013-12-26 04:30:04',NULL,NULL),(20410,13143,'AP','4402211485',0,'2013-12-26 12:53:23',NULL,NULL),(29346,18962,'TE','8172768710',0,'2014-01-20 08:05:56',NULL,NULL),(28621,18451,'AP','9855703580',0,'2014-01-16 08:46:08',NULL,NULL),(28023,18060,'AP','9372123914',0,'2014-01-15 02:07:20',NULL,NULL),(24793,15993,'EM','dcoleman3423@gmail.com',0,'2014-01-04 02:01:19',NULL,NULL),(37718,24869,'TE','9375208110',0,'2014-02-20 05:32:56',NULL,NULL),(5629,3607,'EM','nicholaskostoff@yahoo.com',0,'2013-12-25 21:23:23',NULL,NULL),(36176,23810,'AP','3303228889',0,'2014-02-14 21:31:34',NULL,NULL),(24155,15610,'AP','3308560715',1,'2014-01-02 04:32:48',NULL,NULL),(3798,2415,'TE','8592507501',0,'2013-12-25 19:33:49',NULL,NULL),(22331,14399,'EM','pmrider@fuse.net',0,'2013-12-28 03:31:09',NULL,NULL),(21073,13551,'TE','2253549139',0,'2013-12-26 13:04:06',NULL,NULL),(2642,1608,'TE','3615503199',0,'2013-12-25 18:52:13',NULL,NULL),(41167,27340,'AP','5137878622',0,'2014-03-04 21:00:58',NULL,NULL),(11552,7519,'AP','5042289119',0,'2013-12-26 02:32:20',NULL,NULL),(11112,7228,'TE','3309893182',0,'2013-12-26 02:01:17',NULL,NULL),(36650,24126,'EM','lauren685@hotmail.com',0,'2014-02-15 22:01:45',NULL,NULL),(10556,6871,'AP','5037530102',0,'2013-12-26 01:32:00',NULL,NULL),(21289,13679,'EM','julebrum@aol.com',0,'2013-12-26 13:08:07',NULL,NULL),(768,480,'TE','3375785010',0,'2013-12-25 17:48:08',NULL,NULL),(43294,28765,'TE','9033164316',0,'2014-03-09 21:00:25',NULL,NULL),(40559,26922,'TE','3303297070',0,'2014-03-03 01:00:15',NULL,NULL),(38829,25667,'EM','KATHY.HARRIS67@YAHOO.COM',0,'2014-02-26 08:30:49',NULL,NULL),(10415,6792,'TE','5125542975',0,'2013-12-26 01:17:06',NULL,NULL),(37569,24753,'TE','3304729927',0,'2014-02-20 04:41:26',NULL,NULL),(31241,20345,'EM','cheryl.stevens51@gmail.com',0,'2014-01-28 21:01:11',NULL,NULL),(21641,13930,'TE','2603104032',0,'2013-12-26 13:14:26',NULL,NULL),(1285,782,'AP','9366976789',0,'2013-12-25 18:05:05',NULL,NULL),(42599,28341,'EM','macedgar@comcast.net',0,'2014-03-07 21:30:17',NULL,NULL),(43916,29136,'TE','4192768197',0,'2014-03-10 21:02:40',NULL,NULL),(1729,1059,'EM','Ehopelopez@yahoo.com',0,'2013-12-25 18:16:16',NULL,NULL),(14701,9619,'EM','lukekess@gmail.com',0,'2013-12-26 04:37:52',NULL,NULL),(32989,21597,'AP','5135268318',0,'2014-02-05 21:30:31',NULL,NULL),(28538,18399,'TE','2169522583',0,'2014-01-16 08:45:42',NULL,NULL),(25730,16583,'AP','9857744969',0,'2014-01-08 18:23:58',NULL,NULL),(20945,13470,'AP','5138500350',0,'2013-12-26 13:02:01',NULL,NULL),(14747,9646,'TE','4093921901',0,'2013-12-26 04:38:38',NULL,NULL),(7361,4788,'AP','4404886537',0,'2013-12-25 22:16:15',NULL,NULL),(6740,4377,'AP','9374990910',0,'2013-12-25 22:00:30',NULL,NULL),(6950,4529,'AP','9362380393',0,'2013-12-25 22:04:01',NULL,NULL),(41678,27711,'AP','9564932734',0,'2014-03-05 21:30:53',NULL,NULL),(27480,17701,'AP','8593965716',0,'2014-01-14 01:33:04',NULL,NULL),(3223,2027,'TE','3303484466',0,'2013-12-25 19:15:15',NULL,NULL),(4954,3178,'AP','2165419604',0,'2013-12-25 20:31:48',NULL,NULL),(10461,6814,'EM','ashleysmas@gmail.com',0,'2013-12-26 01:30:25',NULL,NULL),(25024,16125,'EM','tishekam@yahoo.com',0,'2014-01-04 02:05:33',NULL,NULL),(43527,28899,'AP','9037484670',0,'2014-03-10 21:00:20',NULL,NULL),(14694,9615,'TE','5135183916',0,'2013-12-26 04:37:45',NULL,NULL),(21478,13799,'AP','2283438301',0,'2013-12-26 13:11:20',NULL,NULL),(23165,14930,'EM','armigoto@earthlink.net',0,'2013-12-30 00:02:00',NULL,NULL),(28100,18111,'TE','6785079941',0,'2014-01-15 02:07:37',NULL,NULL),(29635,19147,'TE','2108587204',0,'2014-01-21 08:45:33',NULL,NULL),(39576,26182,'TE','6145469153',0,'2014-02-28 06:30:41',NULL,NULL),(32710,21397,'TE','5138471918',0,'2014-02-04 21:01:00',NULL,NULL),(34069,22335,'TE','5127617772',0,'2014-02-10 11:01:04',NULL,NULL),(42252,28064,'AP','9374170481',0,'2014-03-06 21:01:46',NULL,NULL),(1555,957,'TE','4696988266',0,'2013-12-25 18:09:43',NULL,NULL),(39400,26053,'AP','8173722587',0,'2014-02-26 21:02:34',NULL,NULL),(8616,5661,'AP','5122178130',0,'2013-12-25 23:31:47',NULL,NULL),(9557,6254,'AP','9372194620',0,'2013-12-26 00:32:04',NULL,NULL),(33341,21841,'TE','9377797667',0,'2014-02-06 21:01:10',NULL,NULL),(28216,18189,'AP','9372072958',0,'2014-01-15 02:08:03',NULL,NULL),(358,220,'AP','3379403479',0,'2013-12-25 17:20:45',NULL,NULL),(39192,25922,'AP','4322548368',0,'2014-02-26 21:01:21',NULL,NULL),(7108,4642,'TE','2282381190',0,'2013-12-25 22:06:49',NULL,NULL),(5910,3791,'AP','4404978103',0,'2013-12-25 21:34:14',NULL,NULL),(4868,3115,'AP','7132545474',0,'2013-12-25 20:30:09',NULL,NULL),(4045,2582,'EM','CMCCOY@FUSE.NET',0,'2013-12-25 19:38:02',NULL,NULL),(4689,3000,'TE','4407242560',0,'2013-12-25 20:17:38',NULL,NULL),(32245,21059,'TE','5043557968',0,'2014-02-02 19:00:11',NULL,NULL),(29436,19033,'AP','2162534272',0,'2014-01-20 08:06:32',NULL,NULL),(40509,26885,'TE','4194748149',0,'2014-03-01 21:01:12',NULL,NULL),(12045,7861,'TE','9379742355',0,'2013-12-26 03:04:59',NULL,NULL),(39238,25955,'AP','5137871929',0,'2014-02-26 21:01:39',NULL,NULL),(35368,23238,'EM','sksweet@fuse.net',0,'2014-02-12 21:32:30',NULL,NULL),(32596,21314,'TE','3185198549',0,'2014-02-04 21:00:19',NULL,NULL),(20810,13370,'TE','9374190470',0,'2013-12-26 12:59:45',NULL,NULL),(31016,20179,'TE','4405416426',0,'2014-01-27 21:01:19',NULL,NULL),(24385,15747,'TE','2147798263',0,'2014-01-03 02:01:02',NULL,NULL),(30478,19762,'TE','9013830928',0,'2014-01-23 21:01:24',NULL,NULL),(28318,18252,'AP','9034950271',0,'2014-01-16 08:44:31',NULL,NULL),(86,52,'TE','2126410808',0,'2013-12-25 17:16:25',NULL,NULL),(14791,9679,'AP','4197045004',0,'2013-12-26 04:39:27',NULL,NULL),(11668,7597,'TE','9547890601',0,'2013-12-26 02:45:16',NULL,NULL),(1953,1210,'TE','4402852025',0,'2013-12-25 18:20:05',NULL,NULL),(40854,27147,'EM','SARAHTRIPS@YAHOO.COM',0,'2014-03-03 21:30:50',NULL,NULL),(8465,5571,'TE','5134736877',0,'2013-12-25 23:16:40',NULL,NULL),(40631,26970,'TE','4693869127',0,'2014-03-03 01:00:34',NULL,NULL),(4075,2599,'EM','wessizemore@yahoo.com',0,'2013-12-25 19:45:17',NULL,NULL),(2595,1583,'TE','9038455053',0,'2013-12-25 18:51:30',NULL,NULL),(29145,18828,'TE','8322294230',0,'2014-01-17 03:36:08',NULL,NULL),(23010,14841,'AP','9374415631',1,'2013-12-29 11:14:50',NULL,NULL),(43950,29153,'EM','fink2fink@aol.com',0,'2014-03-10 21:02:50',NULL,NULL),(29686,19186,'EM','bethanylconklin@aol.com',0,'2014-01-21 08:46:10',NULL,NULL),(27169,17494,'TE','2252185611',0,'2014-01-13 03:01:21',NULL,NULL),(1512,930,'EM','sdaffeh@student.cscc.edu',0,'2013-12-25 18:09:05',NULL,NULL),(11262,7339,'EM','dacollinge@yahoo.com',0,'2013-12-26 02:03:59',NULL,NULL),(8291,5432,'AP','5044396337',0,'2013-12-25 23:09:42',NULL,NULL),(23142,14920,'AP','7403172495',0,'2013-12-30 00:01:39',NULL,NULL),(43804,29079,'AP','9012365532',0,'2014-03-10 21:02:02',NULL,NULL),(1235,752,'TE','9037360229',0,'2013-12-25 18:04:19',NULL,NULL),(5242,3367,'EM','rahgirl@gmail.com',0,'2013-12-25 21:17:09',NULL,NULL),(13727,8946,'TE','4409791550',0,'2013-12-26 04:03:27',NULL,NULL),(23969,15470,'TE','5135151430',1,'2014-01-02 04:28:54',NULL,NULL),(41068,27283,'TE','8323398345',0,'2014-03-04 21:00:23',NULL,NULL),(39434,26082,'TE','2253120520',0,'2014-02-28 06:30:05',NULL,NULL),(35683,23471,'EM','eliottnes@aol.com',0,'2014-02-13 22:01:49',NULL,NULL),(34318,22515,'AP','2545419663',0,'2014-02-10 21:31:22',NULL,NULL),(34992,22973,'AP','6015691788',0,'2014-02-12 21:00:18',NULL,NULL),(35314,23201,'EM','tiffanybudzinski@hotmail.com',0,'2014-02-12 21:32:09',NULL,NULL),(442,274,'AP','5129632973',0,'2013-12-25 17:30:07',NULL,NULL),(1420,865,'EM','amber1315@gmail.com',0,'2013-12-25 18:07:18',NULL,NULL),(14456,9444,'AP','6143166572',0,'2013-12-26 04:33:47',NULL,NULL),(33863,22227,'EM','wright4152@att.net',0,'2014-02-09 19:00:30',NULL,NULL),(22589,14570,'TE','4194744195',0,'2013-12-28 03:35:31',NULL,NULL),(8332,5462,'AP','9372394324',0,'2013-12-25 23:10:28',NULL,NULL),(10849,7041,'AP','8172662672',0,'2013-12-26 01:49:26',NULL,NULL),(6668,4327,'EM','JGOULD3@NEO.RR.COM',0,'2013-12-25 21:52:57',NULL,NULL),(7581,4934,'TE','9372160064',0,'2013-12-25 22:45:31',NULL,NULL),(14377,9401,'EM','LORETTA_MCKENZIE11@YAHOO.COM',0,'2013-12-26 04:32:36',NULL,NULL),(13768,8975,'TE','4198893730',0,'2013-12-26 04:04:10',NULL,NULL),(35032,23007,'AP','5044441523',0,'2014-02-12 21:30:21',NULL,NULL),(41990,27910,'TE','9567758455',0,'2014-03-06 21:00:14',NULL,NULL),(24153,15609,'TE','9372682356',1,'2014-01-02 04:32:46',NULL,NULL),(24038,15520,'TE','3186039693',1,'2014-01-02 04:30:19',NULL,NULL),(22706,14643,'AP','9493717506',1,'2013-12-29 11:07:31',NULL,NULL),(23830,15374,'TE','2288264805',1,'2014-01-02 04:25:12',NULL,NULL),(43182,28695,'AP','3186806924',0,'2014-03-08 21:31:05',NULL,NULL),(8855,5802,'EM','toupstrio@aol.com',0,'2013-12-25 23:47:33',NULL,NULL),(24622,15878,'TE','5045128822',0,'2014-01-03 02:05:19',NULL,NULL),(7270,4738,'AP','4192332940',0,'2013-12-25 22:09:22',NULL,NULL),(24515,15813,'AP','6018076977',0,'2014-01-03 02:03:16',NULL,NULL),(24415,15763,'AP','2543151395',0,'2014-01-03 02:01:34',NULL,NULL),(21926,14126,'TE','5042960333',0,'2013-12-27 02:02:15',NULL,NULL),(42884,28520,'TE','4199121061',0,'2014-03-07 21:32:00',NULL,NULL),(39254,25968,'AP','7405253034',0,'2014-02-26 21:01:45',NULL,NULL),(487,311,'AP','9032794055',0,'2013-12-25 17:31:01',NULL,NULL),(536,335,'AP','9403901651',0,'2013-12-25 17:31:48',NULL,NULL),(6728,4372,'TE','9372193674',0,'2013-12-25 22:00:20',NULL,NULL),(5044,3237,'AP','9727410985',0,'2013-12-25 20:46:13',NULL,NULL),(23937,15445,'EM','Patsybean@hotmail.com',1,'2014-01-02 04:28:12',NULL,NULL),(27239,17536,'AP','3304162253',0,'2014-01-13 03:01:46',NULL,NULL),(43677,28988,'EM','rozzilgs@gmail.com',0,'2014-03-10 21:01:13',NULL,NULL),(43251,28739,'EM','rschultz33@cox.net',0,'2014-03-09 21:00:08',NULL,NULL),(8477,5576,'EM','robdanedy@yahoo.com',0,'2013-12-25 23:16:50',NULL,NULL),(1996,1232,'EM','margaret.mcgurk@gmail.com',0,'2013-12-25 18:20:45',NULL,NULL),(14605,9549,'TE','4196190466',0,'2013-12-26 04:36:14',NULL,NULL),(14511,9482,'AP','7404380914',0,'2013-12-26 04:34:40',NULL,NULL),(7678,5002,'EM','harend@uakron.edu',0,'2013-12-25 22:47:10',NULL,NULL),(36319,23922,'TE','9016260081',0,'2014-02-14 22:00:06',NULL,NULL),(11486,7469,'AP','5137929523',0,'2013-12-26 02:31:09',NULL,NULL),(34481,22623,'AP','6267312108',0,'2014-02-11 21:00:12',NULL,NULL),(32000,20891,'TE','7402800821',0,'2014-01-31 21:01:15',NULL,NULL),(29750,19235,'BN','5134011208',0,'2014-01-21 08:46:35',NULL,NULL),(3791,2409,'EM','2eagle@sbcglobal.net',0,'2013-12-25 19:33:43',NULL,NULL),(27757,17896,'EM','flashzach@gmail.com',0,'2014-01-15 02:06:21',NULL,NULL),(23962,15460,'AP','7139226649',1,'2014-01-02 04:28:39',NULL,NULL),(279,173,'TE','3308258874',0,'2013-12-25 17:19:28',NULL,NULL),(14381,9403,'TE','2814274512',0,'2013-12-26 04:32:40',NULL,NULL),(13724,8942,'EM','clarksark254@yahoo.com',0,'2013-12-26 04:03:22',NULL,NULL),(37382,24618,'TE','6012148221',0,'2014-02-20 04:15:25',NULL,NULL),(33520,21976,'TE','5043446088',0,'2014-02-07 19:00:34',NULL,NULL),(32807,21466,'AP','6015490922',0,'2014-02-04 21:01:35',NULL,NULL),(31755,20723,'EM','bcbshome@yahoo.com',0,'2014-01-30 21:01:15',NULL,NULL),(2093,1291,'EM','lgh@hudsonecon.com',0,'2013-12-25 18:30:54',NULL,NULL),(3562,2229,'EM','joeasi1@fuse.net',0,'2013-12-25 19:20:46',NULL,NULL),(31485,20517,'EM','ajwhitaker30@yahoo.com',0,'2014-01-29 21:01:22',NULL,NULL),(3270,2056,'AP','4407249719',0,'2013-12-25 19:16:01',NULL,NULL),(2832,1713,'TE','7408289139',0,'2013-12-25 18:55:04',NULL,NULL),(21318,13699,'TE','3307019823',0,'2013-12-26 13:08:37',NULL,NULL),(21460,13791,'AP','6627195432',0,'2013-12-26 13:11:05',NULL,NULL),(27290,17572,'AP','5132666858',0,'2014-01-14 01:32:02',NULL,NULL),(23823,15369,'AP','9372697678',1,'2014-01-02 04:25:01',NULL,NULL),(43054,28623,'BN','2812363416',0,'2014-03-08 21:30:23',NULL,NULL),(7061,4611,'TE','3304149700',0,'2013-12-25 22:05:59',NULL,NULL),(24530,15822,'AP','4404881428',0,'2014-01-03 02:03:34',NULL,NULL),(38631,25534,'TE','2542470034',0,'2014-02-26 08:00:06',NULL,NULL),(9352,6124,'TE','4696711496',0,'2013-12-26 00:15:48',NULL,NULL),(11457,7450,'TE','2167697165',0,'2013-12-26 02:30:42',NULL,NULL),(38332,25323,'AP','7137540338',0,'2014-02-25 21:30:11',NULL,NULL),(14779,9671,'AP','9377256841',0,'2013-12-26 04:39:14',NULL,NULL),(6596,4260,'TE','3303028149',0,'2013-12-25 21:51:31',NULL,NULL),(36149,23790,'EM','cunningham01@zoominternet.net',0,'2014-02-14 21:31:25',NULL,NULL),(25422,16396,'AP','4694635571',0,'2014-01-07 04:03:44',NULL,NULL),(34750,22784,'EM','maliy@aol.com',0,'2014-02-11 21:01:46',NULL,NULL),(39841,26353,'TE','5133170448',0,'2014-02-28 06:31:48',NULL,NULL),(993,612,'AP','4196158593',0,'2013-12-25 18:00:36',NULL,NULL),(36962,24339,'TE','5128271140',0,'2014-02-18 22:00:19',NULL,NULL),(29005,18723,'EM','cethansmith@yahoo.com',0,'2014-01-17 03:35:35',NULL,NULL),(28406,18303,'AP','6143160459',0,'2014-01-16 08:44:58',NULL,NULL),(26209,16871,'AP','2543867249',0,'2014-01-13 02:19:15',NULL,NULL),(23503,15163,'EM','advhomeinspection@windstream.net',0,'2014-01-01 12:06:20',NULL,NULL),(5523,3533,'AP','5123482976',0,'2013-12-25 21:21:33',NULL,NULL),(40080,26579,'EM','PSPAZ52@HOTMAIL.COM',0,'2014-02-28 21:30:29',NULL,NULL),(33315,21819,'TE','3302214929',0,'2014-02-06 21:00:58',NULL,NULL),(3530,2207,'EM','jsteph179@gmail.com',0,'2013-12-25 19:20:13',NULL,NULL),(14306,9356,'EM','carltoncorp3@aol.com',0,'2013-12-26 04:31:24',NULL,NULL),(32787,21452,'EM','nhagerty@neo.rr.com',0,'2014-02-04 21:01:29',NULL,NULL),(10865,7052,'EM','linda.kunkel@cbws.com',0,'2013-12-26 01:49:44',NULL,NULL),(9444,6182,'AP','9377286972',0,'2013-12-26 00:30:06',NULL,NULL),(22151,14270,'TE','2285962057',0,'2013-12-27 02:06:03',NULL,NULL),(22814,14711,'TE','6149811489',1,'2013-12-29 11:09:20',NULL,NULL),(24650,15894,'TE','3308586636',0,'2014-01-03 02:05:51',NULL,NULL),(33276,21790,'TE','2163318706',0,'2014-02-06 21:00:43',NULL,NULL),(10316,6730,'TE','5133059723',0,'2013-12-26 01:15:27',NULL,NULL),(34104,22354,'TE','9852100420',0,'2014-02-10 21:00:05',NULL,NULL),(31262,20366,'TE','4196781472',0,'2014-01-28 21:01:24',NULL,NULL),(28559,18413,'EM','abchao@gmail.com',0,'2014-01-16 08:45:48',NULL,NULL),(26979,17353,'TE','3184524368',0,'2014-01-13 02:24:10',NULL,NULL),(22672,14617,'TE','5137536355',0,'2013-12-28 03:36:51',NULL,NULL),(40885,27166,'TE','2104544057',0,'2014-03-03 21:31:02',NULL,NULL),(41549,27627,'AP','4192355099',0,'2014-03-05 21:30:08',NULL,NULL),(41686,27721,'AP','7136799843',0,'2014-03-05 21:30:58',NULL,NULL),(42683,28395,'AP','6143777740',0,'2014-03-07 21:30:47',NULL,NULL),(43363,28801,'TE','4196933313',0,'2014-03-09 21:00:48',NULL,NULL),(39526,26144,'AP','2052186070',0,'2014-02-28 06:30:27',NULL,NULL),(8165,5342,'AP','2164968674',0,'2013-12-25 23:07:23',NULL,NULL),(39382,26045,'EM','tlcreese02@gmail.com',0,'2014-02-26 21:02:29',NULL,NULL),(35958,23655,'EM','twutoo@yahoo.com',0,'2014-02-14 21:30:17',NULL,NULL),(35228,23136,'EM','rkkinsure@gmail.com',0,'2014-02-12 21:31:33',NULL,NULL),(33074,21662,'EM','partygalnisha@gmail.com',0,'2014-02-05 21:30:55',NULL,NULL),(3494,2185,'TE','3259771945',0,'2013-12-25 19:19:33',NULL,NULL),(32415,21181,'AP','9012887592',0,'2014-02-03 21:00:43',NULL,NULL),(11659,7588,'EM','maggi.williams2@gmail.com',0,'2013-12-26 02:45:04',NULL,NULL),(29913,19358,'TE','3308825816',1,'2014-01-22 03:22:29',NULL,NULL),(39384,26046,'AP','3306034767',0,'2014-02-26 21:02:30',NULL,NULL),(34216,22440,'TE','9404976067',0,'2014-02-10 21:30:41',NULL,NULL),(32952,21573,'AP','3306878875',0,'2014-02-05 21:30:22',NULL,NULL),(29533,19089,'EM','philborshell@gmail.com',0,'2014-01-21 08:44:31',NULL,NULL),(27897,17976,'TE','3308444453',0,'2014-01-15 02:06:51',NULL,NULL),(41317,27447,'BN','3306735819',0,'2014-03-04 21:01:57',NULL,NULL),(39674,26234,'TE','9104675440',0,'2014-02-28 06:31:02',NULL,NULL),(38519,25455,'EM','bonniereyes34@gmail.com',0,'2014-02-25 21:31:28',NULL,NULL),(34749,22784,'TE','3308322311',0,'2014-02-11 21:01:46',NULL,NULL),(9985,6534,'TE','7138222839',0,'2013-12-26 00:51:45',NULL,NULL),(8397,5526,'TE','5136681072',0,'2013-12-25 23:15:27',NULL,NULL),(5520,3532,'AP','8306601016',0,'2013-12-25 21:21:31',NULL,NULL),(12184,7959,'AP','6018109811',0,'2013-12-26 03:07:24',NULL,NULL),(27664,17832,'AP','6014798245',0,'2014-01-15 02:06:00',NULL,NULL),(27544,17751,'TE','6626070568',0,'2014-01-14 01:33:28',NULL,NULL),(41933,27877,'AP','4195163389',0,'2014-03-05 21:32:30',NULL,NULL),(39013,25798,'TE','4406389090',0,'2014-02-26 21:00:15',NULL,NULL),(3197,2009,'TE','5042432449',0,'2013-12-25 19:02:27',NULL,NULL),(37989,25061,'TE','2162510657',0,'2014-02-20 22:01:24',NULL,NULL),(22024,14184,'EM','jfry3@kent.edu',0,'2013-12-27 02:03:48',NULL,NULL),(22627,14591,'TE','3306880794',0,'2013-12-28 03:36:08',NULL,NULL),(24279,15689,'EM','Davecollier2013@gmail.com',1,'2014-01-02 04:35:18',NULL,NULL),(25354,16351,'TE','4406320582',0,'2014-01-07 04:02:30',NULL,NULL),(36145,23787,'AP','3306710624',0,'2014-02-14 21:31:23',NULL,NULL),(1132,695,'AP','2164708350',0,'2013-12-25 18:02:45',NULL,NULL),(3474,2177,'TE','4197227269',0,'2013-12-25 19:19:17',NULL,NULL),(35901,23618,'EM','annemzs@fuse.net',0,'2014-02-13 22:03:17',NULL,NULL),(10495,6837,'AP','5132849032',0,'2013-12-26 01:30:58',NULL,NULL),(6629,4286,'TE','3304074403',0,'2013-12-25 21:52:05',NULL,NULL),(23271,14993,'TE','9037243409',0,'2014-01-01 12:01:29',NULL,NULL),(33295,21803,'TE','4195234429',0,'2014-02-06 21:00:50',NULL,NULL),(41555,27629,'AP','5133794184',0,'2014-03-05 21:30:10',NULL,NULL),(43237,28731,'TE','2252393170',0,'2014-03-09 21:00:03',NULL,NULL),(7063,4612,'TE','9126634963',0,'2013-12-25 22:06:01',NULL,NULL),(39614,26202,'TE','3302174547',0,'2014-02-28 06:30:49',NULL,NULL),(11767,7657,'AP','2257542041',0,'2013-12-26 03:00:11',NULL,NULL),(11516,7495,'TE','7404955842',0,'2013-12-26 02:31:42',NULL,NULL),(13600,8866,'TE','9035696207',0,'2013-12-26 04:01:25',NULL,NULL),(37025,24377,'AP','5133491384',0,'2014-02-18 22:00:42',NULL,NULL),(23645,15270,'AP','6148050443',1,'2014-01-02 04:21:46',NULL,NULL),(34890,22895,'AP','3305032655',0,'2014-02-11 21:02:39',NULL,NULL),(32565,21295,'TE','5044968680',0,'2014-02-04 21:00:09',NULL,NULL),(32463,21210,'TE','3186806556',0,'2014-02-03 21:00:58',NULL,NULL),(26121,16819,'AP','8172436598',0,'2014-01-13 02:18:21',NULL,NULL),(27774,17906,'TE','2102043219',0,'2014-01-15 02:06:25',NULL,NULL),(30675,19918,'AP','5124617807',0,'2014-01-24 21:01:03',NULL,NULL),(42036,27938,'TE','4095501840',0,'2014-03-06 21:00:30',NULL,NULL),(42714,28410,'EM','shirleyfreeman42@gmail.com',0,'2014-03-07 21:30:56',NULL,NULL),(26666,17156,'TE','9856242586',0,'2014-01-13 02:21:59',NULL,NULL),(23743,15319,'TE','8065980581',1,'2014-01-02 04:23:29',NULL,NULL),(10110,6610,'TE','9374072470',0,'2013-12-26 00:53:44',NULL,NULL),(21947,14137,'AP','5042640529',0,'2013-12-27 02:02:34',NULL,NULL),(14730,9636,'EM','csmith1299@aol.com',0,'2013-12-26 04:38:21',NULL,NULL),(7248,4724,'TE','4193079081',0,'2013-12-25 22:09:01',NULL,NULL),(1125,691,'TE','7407490012',0,'2013-12-25 18:02:39',NULL,NULL),(11380,7410,'AP','8179753009',0,'2013-12-26 02:16:43',NULL,NULL),(38849,25681,'AP','9375411816',0,'2014-02-26 09:30:04',NULL,NULL),(4519,2873,'EM','Gfarias@westsachamber.org',0,'2013-12-25 20:02:00',NULL,NULL),(32579,21302,'TE','3379124805',0,'2014-02-04 21:00:12',NULL,NULL),(8035,5257,'TE','3308250329',0,'2013-12-25 23:05:16',NULL,NULL),(31361,20438,'EM','nessacjones@yahoo.com',0,'2014-01-29 21:00:39',NULL,NULL),(7018,4583,'EM','josephlordi48@gmail.com',0,'2013-12-25 22:05:16',NULL,NULL),(14024,9158,'TE','5136670628',0,'2013-12-26 04:08:39',NULL,NULL),(21655,13936,'TE','4198062957',0,'2013-12-26 13:14:38',NULL,NULL),(34892,22898,'TE','3305032655',0,'2014-02-11 21:02:39',NULL,NULL),(1423,867,'AP','3303127825',0,'2013-12-25 18:07:22',NULL,NULL),(31338,20421,'AP','9372101703',0,'2014-01-29 21:00:30',NULL,NULL),(20569,13236,'AP','5123001033',0,'2013-12-26 12:55:56',NULL,NULL),(29275,18907,'EM','raharrell@hotmail.com',0,'2014-01-17 03:36:39',NULL,NULL),(28626,18455,'TE','2257670606',0,'2014-01-16 08:46:10',NULL,NULL),(27417,17659,'TE','9375157480',0,'2014-01-14 01:32:44',NULL,NULL),(43485,28876,'EM','lalaladyg@gmail.com',0,'2014-03-10 21:00:06',NULL,NULL),(29472,19052,'AP','5137064691',0,'2014-01-20 08:06:45',NULL,NULL),(11758,7653,'TE','9855072467',0,'2013-12-26 03:00:03',NULL,NULL),(24432,15773,'EM','goodsheller@txcyber.com',0,'2014-01-03 02:01:53',NULL,NULL),(6407,4137,'TE','3303572586',0,'2013-12-25 21:48:30',NULL,NULL),(9510,6225,'AP','4197730331',0,'2013-12-26 00:31:16',NULL,NULL),(24256,15675,'TE','4193414773',1,'2014-01-02 04:34:49',NULL,NULL),(8091,5296,'TE','5134445961',0,'2013-12-25 23:06:11',NULL,NULL),(13888,9056,'TE','5124841674',0,'2013-12-26 04:06:12',NULL,NULL),(22016,14179,'TE','9036561998',0,'2013-12-27 02:03:41',NULL,NULL),(40914,27188,'TE','9563138844',0,'2014-03-03 21:31:14',NULL,NULL),(40283,26721,'TE','6019401098',0,'2014-02-28 21:31:45',NULL,NULL),(10972,7131,'AP','5139079466',0,'2013-12-26 01:51:36',NULL,NULL),(39641,26212,'AP','3303577582',0,'2014-02-28 06:30:54',NULL,NULL),(24681,15917,'TE','9596451417',0,'2014-01-03 02:06:31',NULL,NULL),(39004,25791,'TE','3304253584',0,'2014-02-26 21:00:12',NULL,NULL),(26474,17037,'EM','bradleymundell@gmail.com',0,'2014-01-13 02:20:49',NULL,NULL),(38016,25078,'TE','9377981283',0,'2014-02-20 22:01:35',NULL,NULL),(31854,20796,'AP','9729416613',0,'2014-01-31 21:00:18',NULL,NULL),(40214,26672,'EM','bbrow46.bb@gmail.com',0,'2014-02-28 21:31:19',NULL,NULL),(11496,7478,'EM','tscheetz70@yahoo.com',0,'2013-12-26 02:31:20',NULL,NULL),(35741,23505,'AP','5129224299',0,'2014-02-13 22:02:10',NULL,NULL),(31720,20700,'EM','charlesalphonceshropshireii@yahoo.com',0,'2014-01-30 21:01:03',NULL,NULL),(5195,3338,'EM','gelaagui@yahoo.com',0,'2013-12-25 21:16:26',NULL,NULL),(30878,20071,'TE','9158736231',0,'2014-01-27 21:00:17',NULL,NULL),(931,574,'TE','5133880254',0,'2013-12-25 17:50:40',NULL,NULL),(28338,18262,'TE','2816876591',0,'2014-01-16 08:44:37',NULL,NULL),(25594,16512,'TE','9722077909',1,'2014-01-07 10:21:23',NULL,NULL),(13705,8933,'AP','4407230638',0,'2013-12-26 04:03:06',NULL,NULL),(38129,25169,'TE','2165264746',0,'2014-02-21 22:00:27',NULL,NULL),(38045,25108,'TE','8325331909',0,'2014-02-21 21:30:14',NULL,NULL),(34097,22349,'EM','DSGRAHN@BEX.NET',0,'2014-02-10 11:01:14',NULL,NULL),(32340,21129,'TE','3612220553',0,'2014-02-03 21:00:17',NULL,NULL),(30358,19668,'BN','3183649282',0,'2014-01-23 21:00:30',NULL,NULL),(3943,2503,'EM','rpevey@aol.com',0,'2013-12-25 19:36:05',NULL,NULL),(14949,9781,'TE','2164033462',0,'2013-12-26 05:00:44',NULL,NULL),(41312,27446,'TE','3307452692',0,'2014-03-04 21:01:56',NULL,NULL),(41550,27627,'EM','lumberjane@woh.rr.com',0,'2014-03-05 21:30:08',NULL,NULL),(43698,29007,'TE','4198530064',0,'2014-03-10 21:01:22',NULL,NULL),(37099,24424,'TE','5132597731',0,'2014-02-18 22:01:10',NULL,NULL),(29661,19163,'TE','4199670160',0,'2014-01-21 08:45:43',NULL,NULL),(7092,4629,'TE','6014051529',0,'2013-12-25 22:06:30',NULL,NULL),(10395,6776,'AP','7409778111',0,'2013-12-26 01:16:44',NULL,NULL),(9932,6500,'AP','4405061107',0,'2013-12-26 00:50:49',NULL,NULL),(1494,918,'AP','5136040913',0,'2013-12-25 18:08:44',NULL,NULL),(7904,5150,'TE','5134221750',0,'2013-12-25 23:02:47',NULL,NULL),(29280,18912,'TE','9372125513',0,'2014-01-17 03:36:41',NULL,NULL),(25487,16433,'TE','3307306333',0,'2014-01-07 04:04:54',NULL,NULL),(2822,1706,'TE','5138469315',0,'2013-12-25 18:54:53',NULL,NULL),(4516,2872,'EM','GERWIN1101@GMAIL.COM',0,'2013-12-25 20:01:58',NULL,NULL),(24928,16067,'TE','9375154148',0,'2014-01-04 02:03:43',NULL,NULL),(22659,14609,'AP','3306052928',0,'2013-12-28 03:36:37',NULL,NULL),(7392,4809,'TE','3307592709',0,'2013-12-25 22:16:45',NULL,NULL),(33478,21936,'AP','3252270955',0,'2014-02-07 19:00:12',NULL,NULL),(5266,3381,'AP','2816717356',0,'2013-12-25 21:17:32',NULL,NULL),(11317,7374,'TE','5132829856',0,'2013-12-26 02:15:45',NULL,NULL),(31858,20798,'EM','Shackett85@yaho.com',0,'2014-01-31 21:00:20',NULL,NULL),(23767,15329,'AP','9726725637',1,'2014-01-02 04:23:52',NULL,NULL),(24926,16066,'AP','9375154148',0,'2014-01-04 02:03:42',NULL,NULL),(25431,16401,'TE','2143358274',0,'2014-01-07 04:03:53',NULL,NULL),(3852,2453,'AP','9367180613',0,'2013-12-25 19:34:42',NULL,NULL),(10819,7027,'EM','kebclmail@yahoo.com',0,'2013-12-26 01:49:01',NULL,NULL),(3684,2338,'TE','4322131242',0,'2013-12-25 19:31:52',NULL,NULL),(9375,6136,'TE','3379234853',0,'2013-12-26 00:16:09',NULL,NULL),(8389,5521,'TE','6149464985',0,'2013-12-25 23:15:20',NULL,NULL),(3214,2018,'TE','3308963967',0,'2013-12-25 19:15:05',NULL,NULL),(33806,22198,'TE','4404549454',0,'2014-02-09 19:00:13',NULL,NULL),(29082,18783,'TE','5133029763',0,'2014-01-17 03:35:53',NULL,NULL),(28891,18652,'EM','shawntelg3361@gmail.com',0,'2014-01-17 03:35:10',NULL,NULL),(26542,17074,'TE','4694780664',0,'2014-01-13 02:21:19',NULL,NULL),(24227,15652,'AP','9018484750',1,'2014-01-02 04:34:09',NULL,NULL),(25470,16424,'EM','leehendee@live.com',0,'2014-01-07 04:04:36',NULL,NULL),(40756,27084,'AP','2345428855',0,'2014-03-03 21:30:13',NULL,NULL),(12055,7867,'AP','3306209546',0,'2013-12-26 03:05:09',NULL,NULL),(9227,6037,'AP','3187916620',0,'2013-12-26 00:01:19',NULL,NULL),(14122,9242,'EM','triplebish@yahoo.com',0,'2013-12-26 04:10:41',NULL,NULL),(20467,13184,'TE','8324192299',0,'2013-12-26 12:54:26',NULL,NULL),(39315,26006,'TE','3188711044',0,'2014-02-26 21:02:07',NULL,NULL),(33083,21669,'AP','5042286487',0,'2014-02-05 21:30:58',NULL,NULL),(28011,18055,'AP','4193408632',0,'2014-01-15 02:07:18',NULL,NULL),(40831,27134,'TE','2168492705',0,'2014-03-03 21:30:42',NULL,NULL),(39344,26025,'AP','7692305390',0,'2014-02-26 21:02:18',NULL,NULL),(21481,13804,'TE','6019402504',0,'2013-12-26 13:11:26',NULL,NULL),(11166,7263,'AP','3253408992',0,'2013-12-26 02:02:12',NULL,NULL),(5823,3739,'TE','8326494656',0,'2013-12-25 21:32:50',NULL,NULL),(21086,13560,'TE','5019524534',0,'2013-12-26 13:04:20',NULL,NULL),(38290,25282,'EM','counselor.ams@gmail.com',0,'2014-02-25 21:00:18',NULL,NULL),(3469,2171,'TE','4195086270',0,'2013-12-25 19:19:10',NULL,NULL),(34846,22850,'TE','4196057609',0,'2014-02-11 21:02:20',NULL,NULL),(31030,20188,'AP','9724679122',0,'2014-01-27 21:01:24',NULL,NULL),(42092,27968,'AP','3183493388',0,'2014-03-06 21:00:48',NULL,NULL),(42653,28373,'AP','5037024372',0,'2014-03-07 21:30:36',NULL,NULL),(6977,4548,'TE','3308875226',0,'2013-12-25 22:04:31',NULL,NULL),(41380,27493,'TE','3306045399',0,'2014-03-04 21:02:23',NULL,NULL),(39064,25838,'AP','4195600441',0,'2014-02-26 21:00:33',NULL,NULL),(13583,8856,'AP','8309286086',0,'2013-12-26 04:01:09',NULL,NULL),(36860,24275,'TE','7405164681',0,'2014-02-18 21:30:03',NULL,NULL),(34912,22909,'TE','3308198876',0,'2014-02-11 21:02:47',NULL,NULL),(4548,2892,'TE','2163815268',0,'2013-12-25 20:15:12',NULL,NULL),(34744,22782,'TE','3308588762',0,'2014-02-11 21:01:44',NULL,NULL),(20915,13450,'AP','3306122882',0,'2013-12-26 13:01:28',NULL,NULL),(23893,15415,'AP','2148865909',1,'2014-01-02 04:27:16',NULL,NULL),(39936,26428,'TE','6822249280',0,'2014-02-28 07:30:14',NULL,NULL),(5650,3627,'TE','4196283324',0,'2013-12-25 21:23:49',NULL,NULL),(5496,3515,'TE','6628406136',0,'2013-12-25 21:21:07',NULL,NULL),(9875,6455,'EM','donnie514@msn.com',0,'2013-12-26 00:49:48',NULL,NULL),(30134,19517,'TE','2166871413',0,'2014-01-23 03:02:17',NULL,NULL),(27500,17714,'EM','andrewsteele52@gmail.com',0,'2014-01-14 01:33:11',NULL,NULL),(8487,5584,'TE','5048316723',0,'2013-12-25 23:17:02',NULL,NULL),(126,73,'EM','dorothymdaugherty@yahoo.com',0,'2013-12-25 17:17:00',NULL,NULL),(20284,13076,'TE','9374794333',0,'2013-12-26 12:51:26',NULL,NULL),(41421,27518,'AP','4197046493',0,'2014-03-04 21:02:38',NULL,NULL),(9515,6228,'TE','7405033997',0,'2013-12-26 00:31:22',NULL,NULL),(2705,1643,'EM','cdhollins1@gmail.com',0,'2013-12-25 18:53:09',NULL,NULL),(20229,13030,'EM','mrshawk28@yahoo.com',0,'2013-12-26 12:50:20',NULL,NULL),(36902,24302,'EM','heynanobot2000@hotmail.com',0,'2014-02-18 21:30:20',NULL,NULL),(10051,6574,'EM','pkbmd@me.com',0,'2013-12-26 00:52:46',NULL,NULL),(36581,24078,'TE','7172053514',0,'2014-02-15 22:01:21',NULL,NULL),(11826,7695,'EM','jrwood09@yahoo.com',0,'2013-12-26 03:01:07',NULL,NULL),(31848,20793,'TE','2542922563',0,'2014-01-31 21:00:17',NULL,NULL),(5950,3820,'TE','7408568369',0,'2013-12-25 21:34:55',NULL,NULL),(20770,13346,'TE','8479514716',0,'2013-12-26 12:59:05',NULL,NULL),(23398,15070,'AP','2286979502',0,'2014-01-01 12:03:53',NULL,NULL),(27385,17627,'AP','5129096880',0,'2014-01-14 01:32:31',NULL,NULL),(42471,28220,'EM','teresaferguson55@yahoo.com',0,'2014-03-06 21:30:19',NULL,NULL),(41276,27427,'TE','2257763441',0,'2014-03-04 21:01:43',NULL,NULL),(8050,5273,'TE','3309906159',0,'2013-12-25 23:05:34',NULL,NULL),(13557,8840,'AP','5122034778',0,'2013-12-26 04:00:44',NULL,NULL),(1924,1192,'AP','5167071206',0,'2013-12-25 18:19:38',NULL,NULL),(33937,22271,'TE','9039463615',0,'2014-02-10 11:00:14',NULL,NULL),(20663,13287,'EM','lilbirtie72@yahoo.com',0,'2013-12-26 12:57:23',NULL,NULL),(6815,4424,'TE','5136162405',0,'2013-12-25 22:01:41',NULL,NULL),(5951,3820,'AP','7408568369',0,'2013-12-25 21:34:56',NULL,NULL),(38231,25238,'AP','9372050581',0,'2014-02-21 22:01:06',NULL,NULL),(728,457,'TE','3308364336',0,'2013-12-25 17:47:31',NULL,NULL),(36811,24237,'TE','8593070089',0,'2014-02-16 19:00:37',NULL,NULL),(6006,3858,'TE','3184523990',0,'2013-12-25 21:35:51',NULL,NULL),(2346,1427,'TE','3375341716',0,'2013-12-25 18:47:27',NULL,NULL),(35553,23379,'TE','9375440134',0,'2014-02-13 22:00:58',NULL,NULL),(5781,3703,'TE','4403347768',0,'2013-12-25 21:32:02',NULL,NULL),(35520,23362,'TE','3303100781',0,'2014-02-13 22:00:47',NULL,NULL),(21758,14013,'AP','9372175875',0,'2013-12-26 13:16:26',NULL,NULL),(34882,22890,'TE','5672772995',0,'2014-02-11 21:02:36',NULL,NULL),(27696,17852,'TE','2163080344',0,'2014-01-15 02:06:07',NULL,NULL),(27813,17925,'TE','9036639767',0,'2014-01-15 02:06:32',NULL,NULL),(27989,18041,'AP','7696196920',0,'2014-01-15 02:07:12',NULL,NULL),(7936,5173,'EM','mlbspnc@aol.com',0,'2013-12-25 23:03:22',NULL,NULL),(40723,27064,'TE','3185507182',0,'2014-03-03 21:30:01',NULL,NULL),(2815,1703,'TE','5137041007',0,'2013-12-25 18:54:47',NULL,NULL),(35138,23077,'AP','5044732856',0,'2014-02-12 21:31:01',NULL,NULL),(6870,4457,'TE','4404131290',0,'2013-12-25 22:02:32',NULL,NULL),(30234,19584,'TE','6014335636',0,'2014-01-23 03:02:42',NULL,NULL),(28429,18317,'TE','6144405177',0,'2014-01-16 08:45:05',NULL,NULL),(41526,27611,'AP','3373294777',0,'2014-03-05 21:00:29',NULL,NULL),(38878,25696,'TE','3253202321',0,'2014-02-26 09:30:16',NULL,NULL),(10879,7062,'EM','jeff90028@gmail.com',0,'2013-12-26 01:49:59',NULL,NULL),(10886,7075,'AP','5713292048',0,'2013-12-26 01:50:09',NULL,NULL),(37266,24521,'AP','9562906204',0,'2014-02-20 03:57:32',NULL,NULL),(21351,13719,'EM','Tracijames@aol.com',0,'2013-12-26 13:09:11',NULL,NULL),(21729,14000,'EM','robint1452@gmail.com',0,'2013-12-26 13:16:02',NULL,NULL),(22262,14345,'TE','9376225817',0,'2013-12-27 02:08:01',NULL,NULL),(22815,14714,'TE','2165871764',1,'2013-12-29 11:09:23',NULL,NULL),(23583,15225,'TE','2253152414',0,'2014-01-01 12:08:08',NULL,NULL),(36873,24283,'EM','HPeaden681@cox.net',0,'2014-02-18 21:30:08',NULL,NULL),(43058,28627,'TE','9565428528',0,'2014-03-08 21:30:24',NULL,NULL),(4257,2723,'TE','5045541144',0,'2013-12-25 19:48:16',NULL,NULL),(13861,9037,'EM','kim@discoverstars.com',0,'2013-12-26 04:05:45',NULL,NULL),(39587,26188,'TE','4402242619',0,'2014-02-28 06:30:43',NULL,NULL),(8273,5419,'TE','6018566458',0,'2013-12-25 23:09:21',NULL,NULL),(23332,15033,'TE','3186805856',0,'2014-01-01 12:02:42',NULL,NULL),(27065,17408,'TE','2106019331',0,'2014-01-13 03:00:20',NULL,NULL),(38974,25771,'TE','4409675815',0,'2014-02-26 09:30:56',NULL,NULL),(36698,24161,'TE','3307150068',0,'2014-02-15 22:02:04',NULL,NULL),(36144,23787,'TE','3306710624',0,'2014-02-14 21:31:23',NULL,NULL),(43682,28993,'TE','9372170522',0,'2014-03-10 21:01:16',NULL,NULL),(92,55,'TE','4133076789',0,'2013-12-25 17:16:30',NULL,NULL),(40172,26643,'TE','4407890052',0,'2014-02-28 21:31:04',NULL,NULL),(38754,25619,'EM','brina_2109@yahoo.com',0,'2014-02-26 08:30:16',NULL,NULL),(8223,5382,'AP','3375784353',0,'2013-12-25 23:08:24',NULL,NULL),(3436,2156,'TE','3374804012',0,'2013-12-25 19:18:43',NULL,NULL),(32400,21169,'EM','allisonkytta@gmail.com',0,'2014-02-03 21:00:37',NULL,NULL),(21967,14150,'EM','mjmellymel@yahoo.com',0,'2013-12-27 02:02:53',NULL,NULL),(31207,20321,'AP','8065597896',0,'2014-01-28 21:00:56',NULL,NULL),(28223,18194,'EM','mkmurphy526@gmail.com',0,'2014-01-15 02:08:05',NULL,NULL),(43119,28665,'EM','asilia1206@yahoo.com',0,'2014-03-08 21:30:45',NULL,NULL),(40781,27102,'AP','5134851567',0,'2014-03-03 21:30:22',NULL,NULL),(13677,8915,'AP','5133350746',0,'2013-12-26 04:02:41',NULL,NULL),(40768,27091,'EM','blackdesk1222@yahoo.com',0,'2014-03-03 21:30:17',NULL,NULL),(35481,23333,'TE','2162888727',0,'2014-02-13 22:00:32',NULL,NULL),(9927,6498,'TE','3305337059',0,'2013-12-26 00:50:45',NULL,NULL),(34396,22563,'TE','5134393335',0,'2014-02-10 21:31:52',NULL,NULL),(30242,19590,'TE','6018746084',0,'2014-01-23 03:02:44',NULL,NULL),(5542,3541,'AP','5125892921',0,'2013-12-25 21:21:48',NULL,NULL),(42579,28333,'TE','2543382438',0,'2014-03-07 21:30:11',NULL,NULL),(5145,3297,'TE','3306356686',0,'2013-12-25 21:15:39',NULL,NULL),(40348,26778,'TE','2147942690',0,'2014-03-01 21:00:11',NULL,NULL),(27615,17803,'TE','4197060607',0,'2014-01-14 01:33:55',NULL,NULL),(3724,2362,'AP','4405211621',0,'2013-12-25 19:32:32',NULL,NULL),(1964,1216,'TE','9375365596',0,'2013-12-25 18:20:15',NULL,NULL),(5970,3835,'TE','3309806565',0,'2013-12-25 21:35:14',NULL,NULL),(2550,1558,'EM','mar23lisa10@gmail.com',0,'2013-12-25 18:50:49',NULL,NULL),(5155,3305,'AP','9372324888',0,'2013-12-25 21:15:48',NULL,NULL),(3030,1886,'EM','BOBBY918@AOL.COM',0,'2013-12-25 18:58:42',NULL,NULL),(32460,21208,'TE','5043474214',0,'2014-02-03 21:00:57',NULL,NULL),(31571,20590,'EM','tlemanh@gmail.com',0,'2014-01-30 21:00:08',NULL,NULL),(25233,16269,'EM','gofarmin@yahoo.com',0,'2014-01-07 04:00:15',NULL,NULL),(30895,20084,'TE','2253159716',0,'2014-01-27 21:00:25',NULL,NULL),(42424,28173,'EM','mkona@nowonline.net',0,'2014-03-06 21:02:51',NULL,NULL),(5632,3608,'EM','meyerlee@aol.com',0,'2013-12-25 21:23:26',NULL,NULL),(2629,1598,'AP','3252007241',0,'2013-12-25 18:51:59',NULL,NULL),(39321,26009,'AP','7406735172',0,'2014-02-26 21:02:09',NULL,NULL),(14727,9634,'TE','3307534799',0,'2013-12-26 04:38:18',NULL,NULL),(20193,13009,'EM','cswansiger@gmail.com',0,'2013-12-26 12:49:45',NULL,NULL),(25016,16121,'TE','9858557830',0,'2014-01-04 02:05:24',NULL,NULL),(36191,23822,'TE','5138823400',0,'2014-02-14 21:31:41',NULL,NULL),(42464,28211,'TE','9178609243',0,'2014-03-06 21:30:14',NULL,NULL),(29364,18974,'TE','5136802555',0,'2014-01-20 08:06:04',NULL,NULL),(14528,9491,'AP','6145788309',0,'2013-12-26 04:34:55',NULL,NULL),(28192,18171,'TE','4193504582',0,'2014-01-15 02:07:57',NULL,NULL),(27181,17502,'AP','4408659028',0,'2014-01-13 03:01:26',NULL,NULL),(9658,6322,'TE','5133888684',0,'2013-12-26 00:46:23',NULL,NULL),(43923,29139,'TE','7279926027',0,'2014-03-10 21:02:42',NULL,NULL),(37182,24476,'TE','4196061115',0,'2014-02-18 22:01:42',NULL,NULL),(34302,22509,'AP','5132135353',0,'2014-02-10 21:31:17',NULL,NULL),(25108,16185,'EM','wilkerson863@gmail.com',0,'2014-01-05 00:00:41',NULL,NULL),(6082,3914,'AP','2107107246',0,'2013-12-25 21:37:12',NULL,NULL),(10878,7061,'EM','dchunt1955@gmail.com',0,'2013-12-26 01:49:57',NULL,NULL),(9880,6461,'EM','kchannelcats@aol.com',0,'2013-12-26 00:49:54',NULL,NULL),(24237,15657,'EM','kup1986@yahoo.com',1,'2014-01-02 04:34:21',NULL,NULL),(23172,14933,'EM','sanders979@gmail.com',0,'2013-12-30 00:02:05',NULL,NULL),(22962,14811,'TE','5042309698',1,'2013-12-29 11:14:04',NULL,NULL),(8447,5558,'AP','5044421886',0,'2013-12-25 23:16:21',NULL,NULL),(5545,3542,'EM','neysajpowell@gmail.com',0,'2013-12-25 21:21:50',NULL,NULL),(22891,14771,'TE','2148085198',1,'2013-12-29 11:12:56',NULL,NULL),(246,152,'TE','2814433283',0,'2013-12-25 17:18:57',NULL,NULL),(14048,9179,'TE','4193714698',0,'2013-12-26 04:09:08',NULL,NULL),(37596,24771,'TE','7405027990',0,'2014-02-20 04:44:23',NULL,NULL),(33495,21948,'EM','TOPOFTHEMARKMOTEL@GMAIL.COM',0,'2014-02-07 19:00:20',NULL,NULL),(24581,15855,'TE','3236299061',0,'2014-01-03 02:04:33',NULL,NULL),(24517,15814,'TE','3186692163',0,'2014-01-03 02:03:18',NULL,NULL),(8076,5286,'AP','2164968674',0,'2013-12-25 23:05:55',NULL,NULL),(1630,1000,'EM','leathomas@gmail.com',0,'2013-12-25 18:10:56',NULL,NULL),(1392,851,'TE','3307948079',0,'2013-12-25 18:06:54',NULL,NULL),(43560,28928,'TE','6143061122',0,'2014-03-10 21:00:36',NULL,NULL),(243,146,'AP','3308153716',0,'2013-12-25 17:18:52',NULL,NULL),(40946,27209,'TE','5675250680',0,'2014-03-03 21:31:26',NULL,NULL),(10063,6580,'TE','2097703999',0,'2013-12-26 00:52:57',NULL,NULL),(8115,5312,'EM','CHILDOFBARB@HOTMAIL.COM',0,'2013-12-25 23:06:37',NULL,NULL),(40889,27168,'TE','9406920372',0,'2014-03-03 21:31:03',NULL,NULL),(40454,26856,'TE','9372170522',0,'2014-03-01 21:00:54',NULL,NULL),(32918,21549,'EM','mharmon1@woh.rr.com',0,'2014-02-05 21:30:13',NULL,NULL),(21123,13582,'TE','5042012709',0,'2013-12-26 13:04:56',NULL,NULL),(25503,16445,'AP','6013196157',0,'2014-01-07 04:05:14',NULL,NULL),(26726,17189,'EM','LISYGOMEZ@AOL.COM',0,'2014-01-13 02:22:18',NULL,NULL),(31037,20191,'AP','9376222504',0,'2014-01-27 21:01:27',NULL,NULL),(31901,20819,'TE','5045758990',0,'2014-01-31 21:00:34',NULL,NULL),(32149,21001,'TE','5136525913',0,'2014-02-01 19:00:28',NULL,NULL),(38379,25350,'EM','philipdelcambre@gmail.com',0,'2014-02-25 21:30:31',NULL,NULL),(616,379,'AP','8183833436',0,'2013-12-25 17:45:40',NULL,NULL),(3285,2067,'TE','2169064763',0,'2013-12-25 19:16:16',NULL,NULL),(37267,24522,'TE','9032237046',0,'2014-02-20 03:57:55',NULL,NULL),(24005,15493,'AP','9378301055',1,'2014-01-02 04:29:35',NULL,NULL),(20697,13305,'AP','8028812631',0,'2013-12-26 12:57:55',NULL,NULL),(20351,13110,'TE','9376746780',0,'2013-12-26 12:52:27',NULL,NULL),(43898,29126,'TE','4193417055',0,'2014-03-10 21:02:34',NULL,NULL),(88,52,'EM','mariagetz2003@yahoo.com',0,'2013-12-25 17:16:26',NULL,NULL),(14139,9258,'AP','8063410656',0,'2013-12-26 04:15:14',NULL,NULL),(12253,8011,'EM','cyndycatesbroadus@gmail.com',0,'2013-12-26 03:08:39',NULL,NULL),(12102,7910,'TE','5044783056',0,'2013-12-26 03:06:03',NULL,NULL),(40725,27065,'TE','3377946755',0,'2014-03-03 21:30:02',NULL,NULL),(29240,18887,'EM','vince8151@hotmail.com',0,'2014-01-17 03:36:30',NULL,NULL),(24204,15635,'EM','skangle@att.net',1,'2014-01-02 04:33:38',NULL,NULL),(21999,14169,'AP','9852551371',0,'2013-12-27 02:03:24',NULL,NULL),(1957,1212,'EM','LINDARBUN@AOL.COM',0,'2013-12-25 18:20:08',NULL,NULL),(40544,26908,'AP','3375195545',0,'2014-03-03 01:00:11',NULL,NULL),(21256,13660,'AP','3035504385',0,'2013-12-26 13:07:35',NULL,NULL),(39259,25973,'TE','7403333325',0,'2014-02-26 21:01:47',NULL,NULL),(25576,16499,'TE','5672041806',0,'2014-01-07 04:06:47',NULL,NULL),(37528,24711,'EM','jordan.conti@gmail.com',0,'2014-02-20 04:36:21',NULL,NULL),(37315,24555,'EM','jbarnette2@neo.rr.com',0,'2014-02-20 04:05:15',NULL,NULL),(33999,22300,'EM','cassie.screngi@gmail.com',0,'2014-02-10 11:00:37',NULL,NULL),(34031,22317,'EM','tyraloston@yahoo.com',0,'2014-02-10 11:00:51',NULL,NULL),(42719,28415,'AP','2163335983',0,'2014-03-07 21:30:59',NULL,NULL),(6519,4213,'AP','3252476574',0,'2013-12-25 21:50:15',NULL,NULL),(5225,3358,'TE','5128480760',0,'2013-12-25 21:16:55',NULL,NULL),(2252,1379,'TE','3372546025',0,'2013-12-25 18:46:03',NULL,NULL),(40630,26968,'AP','2144694529',0,'2014-03-03 01:00:33',NULL,NULL),(39817,26330,'TE','6625797431',0,'2014-02-28 06:31:40',NULL,NULL),(32012,20898,'TE','5134488951',0,'2014-01-31 21:01:19',NULL,NULL),(43034,28613,'TE','9408591542',0,'2014-03-08 21:30:17',NULL,NULL),(43872,29110,'AP','2252784551',0,'2014-03-10 21:02:23',NULL,NULL),(7612,4957,'EM','lobui56@yahoo.com',0,'2013-12-25 22:46:06',NULL,NULL),(37919,25014,'TE','4198678428',0,'2014-02-20 22:00:54',NULL,NULL),(27257,17551,'TE','4194768053',0,'2014-01-13 03:01:54',NULL,NULL),(2422,1479,'TE','3302894047',0,'2013-12-25 18:48:46',NULL,NULL),(26741,17198,'BN','3309078004',0,'2014-01-13 02:22:23',NULL,NULL),(22587,14568,'TE','5134073547',0,'2013-12-28 03:35:27',NULL,NULL),(490,312,'AP','5049152244',0,'2013-12-25 17:31:04',NULL,NULL),(41842,27821,'EM','almclaren2011@gmail.com',0,'2014-03-05 21:31:56',NULL,NULL),(14362,9388,'AP','3614803387',0,'2013-12-26 04:32:16',NULL,NULL),(40570,26927,'EM','smithstephanie13@yahoo.com',0,'2014-03-03 01:00:18',NULL,NULL),(32349,21133,'TE','7134088056',0,'2014-02-03 21:00:19',NULL,NULL),(32279,21086,'AP','5134760676',0,'2014-02-02 19:00:24',NULL,NULL),(11249,7324,'AP','6623034037',0,'2013-12-26 02:03:40',NULL,NULL),(32275,21084,'TE','2162952556',0,'2014-02-02 19:00:23',NULL,NULL),(22858,14750,'TE','7406491378',1,'2013-12-29 11:10:17',NULL,NULL),(8910,5831,'EM','griseldarodriguez_cheer@yahoo.com',0,'2013-12-25 23:48:19',NULL,NULL),(8338,5469,'EM','pamela@perrysburgattorney.com',0,'2013-12-25 23:10:37',NULL,NULL),(6171,3976,'TE','4192307329',0,'2013-12-25 21:38:44',NULL,NULL),(42854,28499,'EM','chloermallardi@gmail.com',0,'2014-03-07 21:31:47',NULL,NULL),(22635,14596,'TE','2346785324',0,'2013-12-28 03:36:15',NULL,NULL),(23096,14893,'EM','rlbell1643@gmail.com',0,'2013-12-30 00:00:53',NULL,NULL),(23527,15180,'AP','7402722409',0,'2014-01-01 12:06:49',NULL,NULL),(41008,27248,'TE','9209156473',0,'2014-03-03 21:31:51',NULL,NULL),(29475,19053,'AP','3305151051',0,'2014-01-20 08:06:46',NULL,NULL),(30280,19618,'TE','4199662089',0,'2014-01-23 03:02:54',NULL,NULL),(38560,25481,'EM','dbrandenburg57@yahoo.com',0,'2014-02-25 21:31:44',NULL,NULL),(37589,24764,'TE','3304729927',0,'2014-02-20 04:43:32',NULL,NULL),(782,489,'TE','3186445113',0,'2013-12-25 17:48:21',NULL,NULL),(1296,788,'AP','4302001255',0,'2013-12-25 18:05:15',NULL,NULL),(8421,5544,'TE','3304648199',0,'2013-12-25 23:15:55',NULL,NULL),(6513,4209,'TE','3617015611',0,'2013-12-25 21:50:09',NULL,NULL),(11115,7229,'TE','3309893182',0,'2013-12-26 02:01:19',NULL,NULL),(9554,6253,'TE','2253410230',0,'2013-12-26 00:32:01',NULL,NULL),(4047,2583,'AP','5132903857',0,'2013-12-25 19:38:04',NULL,NULL),(5467,3500,'AP','5136580167',0,'2013-12-25 21:20:41',NULL,NULL),(39721,26272,'AP','4193030810',0,'2014-02-28 06:31:16',NULL,NULL),(21057,13544,'TE','3184032956',0,'2013-12-26 13:03:53',NULL,NULL),(39171,25909,'EM','lithium_066@yahoo.com',0,'2014-02-26 21:01:13',NULL,NULL),(23660,15280,'TE','2168495076',1,'2014-01-02 04:22:05',NULL,NULL),(38536,25465,'BN','2819196568',0,'2014-02-25 21:31:34',NULL,NULL),(7686,5009,'EM','lehabsfan@aol.com',0,'2013-12-25 22:47:19',NULL,NULL),(40085,26584,'TE','2346787140',0,'2014-02-28 21:30:32',NULL,NULL),(36986,24349,'TE','9563585738',0,'2014-02-18 22:00:26',NULL,NULL),(28632,18459,'EM','tburtongroup@aim.com',0,'2014-01-16 08:46:12',NULL,NULL),(20644,13278,'AP','5122215397',0,'2013-12-26 12:57:06',NULL,NULL),(41128,27318,'AP','9038247951',0,'2014-03-04 21:00:44',NULL,NULL),(37437,24650,'TE','2253018261',0,'2014-02-20 04:22:35',NULL,NULL),(37214,24492,'TE','9722683946',0,'2014-02-20 03:45:05',NULL,NULL),(4821,3086,'EM','pje567@aol.com',0,'2013-12-25 20:19:52',NULL,NULL),(11839,7703,'AP','9372437034',0,'2013-12-26 03:01:19',NULL,NULL),(11533,7506,'TE','5044088218',0,'2013-12-26 02:31:59',NULL,NULL),(10222,6681,'AP','6145991196',0,'2013-12-26 01:01:24',NULL,NULL),(37047,24396,'TE','7403610928',0,'2014-02-18 22:00:52',NULL,NULL),(34688,22747,'AP','5134392250',0,'2014-02-11 21:01:24',NULL,NULL),(21071,13551,'TE','2253549139',0,'2013-12-26 13:04:05',NULL,NULL),(23105,14897,'EM','rjzuchow@gmail.com',0,'2013-12-30 00:01:00',NULL,NULL),(28743,18547,'AP','6013352339',0,'2014-01-16 08:46:52',NULL,NULL),(7281,4744,'TE','9373611848',0,'2013-12-25 22:09:34',NULL,NULL),(14673,9600,'TE','3304929220',0,'2013-12-26 04:37:23',NULL,NULL),(41250,27408,'TE','4403150641',0,'2014-03-04 21:01:34',NULL,NULL),(3647,2311,'EM','fionafan0809@gmail.com',0,'2013-12-25 19:31:11',NULL,NULL),(2906,1782,'TE','2162626795',0,'2013-12-25 18:56:22',NULL,NULL),(39247,25963,'EM','k_tweet99@hotmail.com',0,'2014-02-26 21:01:42',NULL,NULL),(24424,15768,'TE','9036547663',0,'2014-01-03 02:01:44',NULL,NULL),(24543,15830,'TE','9374502439',0,'2014-01-03 02:03:49',NULL,NULL),(39206,25929,'AP','3615621761',0,'2014-02-26 21:01:25',NULL,NULL),(36878,24288,'EM','charlotterobinson82@gmail.com',0,'2014-02-18 21:30:11',NULL,NULL),(27639,17817,'AP','6012740660',0,'2014-01-15 02:05:55',NULL,NULL),(32486,21228,'TE','9375465188',0,'2014-02-03 21:01:07',NULL,NULL),(1872,1155,'AP','5046101251',0,'2013-12-25 18:18:45',NULL,NULL),(14296,9352,'TE','5046552550',0,'2013-12-26 04:31:16',NULL,NULL),(11852,7714,'TE','4196293307',0,'2013-12-26 03:01:35',NULL,NULL),(11637,7570,'TE','2169780364',0,'2013-12-26 02:33:44',NULL,NULL),(43255,28741,'TE','5046284928',0,'2014-03-09 21:00:09',NULL,NULL),(9981,6532,'AP','3617397516',0,'2013-12-26 00:51:42',NULL,NULL),(35743,23506,'TE','8326178898',0,'2014-02-13 22:02:11',NULL,NULL),(34876,22876,'EM','mparis@fulfab.com',0,'2014-02-11 21:02:32',NULL,NULL),(34525,22649,'EM','philhollister@sbcglobal.net',0,'2014-02-11 21:00:27',NULL,NULL),(31550,20565,'AP','4197333551',0,'2014-01-29 21:01:49',NULL,NULL),(33255,21777,'TE','5133250620',0,'2014-02-06 21:00:36',NULL,NULL),(40904,27179,'TE','2102165542',0,'2014-03-03 21:31:09',NULL,NULL),(40705,27040,'TE','5044288603',0,'2014-03-03 21:00:21',NULL,NULL),(2025,1253,'TE','5134761970',0,'2013-12-25 18:21:19',NULL,NULL),(10815,7024,'AP','9363277933',0,'2013-12-26 01:48:56',NULL,NULL),(4373,2788,'TE','4198411041',0,'2013-12-25 19:50:03',NULL,NULL),(4797,3067,'EM','sissbiz@yahoo.com',0,'2013-12-25 20:19:23',NULL,NULL),(6583,4250,'TE','2542285282',0,'2013-12-25 21:51:15',NULL,NULL),(23327,15030,'TE','2256756750',0,'2014-01-01 12:02:36',NULL,NULL),(23345,15040,'TE','2818579145',0,'2014-01-01 12:02:56',NULL,NULL),(23494,15151,'TE','4406176510',0,'2014-01-01 12:06:04',NULL,NULL),(25848,16662,'TE','3185125805',0,'2014-01-08 18:24:25',NULL,NULL),(34486,22625,'TE','8329678026',0,'2014-02-11 21:00:13',NULL,NULL),(33619,22047,'TE','3372781367',0,'2014-02-07 19:30:04',NULL,NULL),(36706,24169,'TE','6019567927',0,'2014-02-15 22:02:08',NULL,NULL),(24824,16013,'AP','2252005058',0,'2014-01-04 02:01:54',NULL,NULL),(14523,9488,'EM','tstregl@att.net',0,'2013-12-26 04:34:51',NULL,NULL),(23446,15112,'TE','6148714833',0,'2014-01-01 12:05:00',NULL,NULL),(1326,810,'AP','6143746404',0,'2013-12-25 18:05:48',NULL,NULL),(3491,2184,'TE','5129403211',0,'2013-12-25 19:19:31',NULL,NULL),(2603,1586,'EM','jcowan36@gmail.com',0,'2013-12-25 18:51:36',NULL,NULL),(14869,9730,'AP','5132656685',0,'2013-12-26 04:45:40',NULL,NULL),(37527,24712,'AP','6142260708',0,'2014-02-20 04:36:20',NULL,NULL),(23928,15439,'TE','3613586149',1,'2014-01-02 04:28:00',NULL,NULL),(11539,7512,'AP','9853776752',0,'2013-12-26 02:32:07',NULL,NULL),(23299,15013,'TE','3304720640',0,'2014-01-01 12:02:06',NULL,NULL),(22176,14286,'TE','4193407706',0,'2013-12-27 02:06:27',NULL,NULL),(42,28,'TE','5134786081',0,'2013-12-25 17:15:43',NULL,NULL),(13669,8910,'TE','3309794668',0,'2013-12-26 04:02:34',NULL,NULL),(38497,25439,'EM','BAYLOR05AG@GMAIL.COM',0,'2014-02-25 21:31:20',NULL,NULL),(963,593,'EM','eifel1249@aol.com',0,'2013-12-25 18:00:07',NULL,NULL),(1136,698,'TE','9374021002',0,'2013-12-25 18:02:50',NULL,NULL),(1143,703,'AP','5042581293',0,'2013-12-25 18:02:58',NULL,NULL),(6454,4169,'AP','4192616944',0,'2013-12-25 21:49:11',NULL,NULL),(1612,991,'EM','dawnmdebord@gmail.com',0,'2013-12-25 18:10:38',NULL,NULL),(31988,20886,'AP','4199536030',0,'2014-01-31 21:01:11',NULL,NULL),(31684,20669,'AP','2282352961',0,'2014-01-30 21:00:48',NULL,NULL),(31533,20548,'EM','jrodriguez14@cinci.rr.com',0,'2014-01-29 21:01:40',NULL,NULL),(25434,16402,'TE','8066780244',0,'2014-01-07 04:03:56',NULL,NULL),(25602,16516,'TE','3098303118',1,'2014-01-07 10:21:31',NULL,NULL),(26046,16779,'AP','9374671730',0,'2014-01-08 18:25:05',NULL,NULL),(41107,27304,'EM','qkbrooks@gmail.com',0,'2014-03-04 21:00:36',NULL,NULL),(13947,9094,'AP','9372489968',0,'2013-12-26 04:07:11',NULL,NULL),(8512,5597,'TE','5048279765',0,'2013-12-25 23:30:09',NULL,NULL),(8057,5276,'TE','3307035325',0,'2013-12-25 23:05:39',NULL,NULL),(32345,21131,'EM','gaylekline@icloud.com',0,'2014-02-03 21:00:18',NULL,NULL),(28270,18227,'EM','mock7@ymail.com',0,'2014-01-16 08:44:17',NULL,NULL),(28939,18683,'AP','3256688877',0,'2014-01-17 03:35:21',NULL,NULL),(29960,19387,'TE','5133793196',1,'2014-01-22 03:22:46',NULL,NULL),(8758,5741,'TE','2258024321',0,'2013-12-25 23:45:57',NULL,NULL),(26694,17173,'TE','3305030224',0,'2014-01-13 02:22:08',NULL,NULL),(28150,18146,'TE','9855181159',0,'2014-01-15 02:07:48',NULL,NULL),(28894,18654,'TE','2102157293',0,'2014-01-17 03:35:11',NULL,NULL),(29038,18749,'EM','ed.zarnick@yahoo.com',0,'2014-01-17 03:35:43',NULL,NULL),(31017,20179,'AP','4405416426',0,'2014-01-27 21:01:19',NULL,NULL),(42352,28129,'TE','3308354557',0,'2014-03-06 21:02:24',NULL,NULL),(31319,20407,'EM','LAMARCUS_SCOTT@HOTMAIL.COM',0,'2014-01-29 21:00:23',NULL,NULL),(34269,22483,'TE','4194354748',0,'2014-02-10 21:31:04',NULL,NULL),(36931,24321,'TE','9035212890',0,'2014-02-18 22:00:08',NULL,NULL),(37722,24871,'AP','9372451250',0,'2014-02-20 05:33:22',NULL,NULL),(38055,25115,'EM','adriane.mccain@gmail.com',0,'2014-02-21 21:30:18',NULL,NULL),(38731,25601,'EM','kematay19@yahoo.com',0,'2014-02-26 08:00:51',NULL,NULL),(39783,26305,'AP','3614011799',0,'2014-02-28 06:31:31',NULL,NULL),(7731,5047,'AP','3615426830',0,'2013-12-25 23:00:04',NULL,NULL),(12126,7924,'AP','3374012228',0,'2013-12-26 03:06:26',NULL,NULL),(4710,3013,'TE','3307803939',0,'2013-12-25 20:17:59',NULL,NULL),(3630,2294,'AP','5132604190',0,'2013-12-25 19:30:52',NULL,NULL),(6228,4014,'TE','5133744742',0,'2013-12-25 21:45:30',NULL,NULL),(7070,4617,'AP','3309579752',0,'2013-12-25 22:06:08',NULL,NULL),(30587,19845,'TE','3182661471',0,'2014-01-24 21:00:28',NULL,NULL),(31841,20788,'TE','2812923427',0,'2014-01-31 21:00:14',NULL,NULL),(35096,23053,'AP','2266859959',0,'2014-02-12 21:30:47',NULL,NULL),(36219,23839,'AP','5133749517',0,'2014-02-14 21:31:51',NULL,NULL),(38765,25631,'TE','7404248439',0,'2014-02-26 08:30:23',NULL,NULL),(39623,26205,'BN','3302817052',0,'2014-02-28 06:30:51',NULL,NULL),(41735,27750,'TE','3378424161',0,'2014-03-05 21:31:15',NULL,NULL),(1180,723,'AP','9035212474',0,'2013-12-25 18:03:32',NULL,NULL),(24773,15981,'BN','7133035767',0,'2014-01-04 02:00:57',NULL,NULL),(23983,15483,'TE','6144195591',1,'2014-01-02 04:29:13',NULL,NULL),(22642,14599,'TE','3307199810',0,'2013-12-28 03:36:22',NULL,NULL),(5049,3240,'TE','9033895504',0,'2013-12-25 20:46:19',NULL,NULL),(7104,4638,'AP','6013455504',0,'2013-12-25 22:06:43',NULL,NULL),(2741,1662,'TE','3252347668',0,'2013-12-25 18:53:40',NULL,NULL),(2406,1466,'EM','Jbmjnes@earthlink.net',0,'2013-12-25 18:48:28',NULL,NULL),(28054,18080,'AP','3374120981',0,'2014-01-15 02:07:27',NULL,NULL),(28735,18541,'EM','sjdriskell69@yahoo.com',0,'2014-01-16 08:46:49',NULL,NULL),(30014,19435,'EM','ptalley1985@gmail.com',1,'2014-01-22 03:23:10',NULL,NULL),(33449,21910,'TE','9373640176',0,'2014-02-06 21:01:53',NULL,NULL),(34391,22559,'TE','4156800733',0,'2014-02-10 21:31:50',NULL,NULL),(35936,23645,'TE','9792030189',0,'2014-02-14 21:30:11',NULL,NULL),(38048,25111,'TE','2286239668',0,'2014-02-21 21:30:16',NULL,NULL),(42551,28316,'AP','2146463585',0,'2014-03-07 21:30:01',NULL,NULL),(336,210,'TE','2257754367',0,'2013-12-25 17:20:27',NULL,NULL),(2077,1284,'AP','6018508281',0,'2013-12-25 18:30:39',NULL,NULL),(20497,13198,'TE','8172811004',0,'2013-12-26 12:54:52',NULL,NULL),(2580,1574,'TE','9033305444',0,'2013-12-25 18:51:16',NULL,NULL),(6235,4018,'TE','5672041369',0,'2013-12-25 21:45:36',NULL,NULL),(3355,2110,'EM','don@daytoncomputerrecycling.com',0,'2013-12-25 19:17:24',NULL,NULL),(22785,14693,'TE','4193478570',1,'2013-12-29 11:08:52',NULL,NULL),(24065,15537,'TE','3186503037',1,'2014-01-02 04:30:51',NULL,NULL),(31141,20283,'TE','5139225343',0,'2014-01-28 21:00:30',NULL,NULL),(33815,22203,'TE','9375597903',0,'2014-02-09 19:00:16',NULL,NULL),(34264,22481,'TE','5136461621',0,'2014-02-10 21:31:02',NULL,NULL),(34671,22733,'EM','slocumta@yahoo.com',0,'2014-02-11 21:01:16',NULL,NULL),(39423,26070,'AP','5136337077',0,'2014-02-26 21:02:44',NULL,NULL),(40598,26950,'EM','Dancoyote@yahoo.com',0,'2014-03-03 01:00:26',NULL,NULL),(42191,28026,'AP','9374759173',0,'2014-03-06 21:01:24',NULL,NULL),(42201,28033,'AP','9373607772',0,'2014-03-06 21:01:29',NULL,NULL),(42915,28539,'TE','8325605676',0,'2014-03-07 21:32:13',NULL,NULL),(43851,29102,'TE','5138843060',0,'2014-03-10 21:02:17',NULL,NULL),(7376,4800,'EM','lynnchatham@att.net',0,'2013-12-25 22:16:29',NULL,NULL),(13550,8837,'AP','5127966088',0,'2013-12-26 04:00:39',NULL,NULL),(4326,2760,'EM','URPISSINMEOFF@AOL.COM',0,'2013-12-25 19:49:18',NULL,NULL),(11312,7371,'TE','5132829856',0,'2013-12-26 02:15:40',NULL,NULL),(4478,2850,'AP','9375649179',0,'2013-12-25 20:01:20',NULL,NULL),(4783,3060,'EM','sarahchifici@yahoo.com',0,'2013-12-25 20:19:09',NULL,NULL),(6533,4226,'TE','9792243207',0,'2013-12-25 21:50:33',NULL,NULL),(4784,3061,'TE','3186354197',0,'2013-12-25 20:19:11',NULL,NULL),(29133,18818,'EM','annointed.angel724@gmail.com',0,'2014-01-17 03:36:05',NULL,NULL),(29651,19156,'EM','jec1765@gmail.com',0,'2014-01-21 08:45:38',NULL,NULL),(31548,20564,'AP','5132238066',0,'2014-01-29 21:01:48',NULL,NULL),(34657,22724,'AP','2258065336',0,'2014-02-11 21:01:12',NULL,NULL),(35377,23248,'TE','2164752805',0,'2014-02-13 21:30:05',NULL,NULL),(39950,26442,'EM','mas3631@aol.com',0,'2014-02-28 07:30:22',NULL,NULL),(43157,28682,'AP','3305032266',0,'2014-03-08 21:30:57',NULL,NULL),(43238,28731,'AP','2252393170',0,'2014-03-09 21:00:03',NULL,NULL),(8669,5692,'TE','5132521826',0,'2013-12-25 23:32:38',NULL,NULL),(6052,3888,'AP','3307154809',0,'2013-12-25 21:36:37',NULL,NULL),(9723,6364,'TE','4405771014',0,'2013-12-26 00:47:27',NULL,NULL),(20370,13121,'TE','5133375720',0,'2013-12-26 12:52:45',NULL,NULL),(10877,7061,'AP','4197225891',0,'2013-12-26 01:49:57',NULL,NULL),(12272,8028,'TE','6622990901',0,'2013-12-26 03:09:04',NULL,NULL),(22888,14769,'TE','9402492580',1,'2013-12-29 11:12:53',NULL,NULL),(24777,15983,'AP','6022212610',0,'2014-01-04 02:01:01',NULL,NULL),(25081,16170,'TE','5044319447',0,'2014-01-05 00:00:13',NULL,NULL),(25832,16655,'TE','7692338227',0,'2014-01-08 18:24:22',NULL,NULL),(26640,17140,'TE','4199446623',0,'2014-01-13 02:21:51',NULL,NULL),(30714,19953,'AP','5042749759',0,'2014-01-25 19:00:04',NULL,NULL),(33199,21738,'EM','rachel2425@live.com',0,'2014-02-06 21:00:14',NULL,NULL),(36624,24111,'EM','ellielonutter@gmail.com',0,'2014-02-15 22:01:37',NULL,NULL),(39009,25796,'EM','dorianspeaks@gmail.com',0,'2014-02-26 21:00:14',NULL,NULL),(39092,25865,'TE','2254506636',0,'2014-02-26 21:00:47',NULL,NULL),(39211,25932,'AP','3257635125',0,'2014-02-26 21:01:27',NULL,NULL),(43792,29070,'TE','4198361600',0,'2014-03-10 21:01:57',NULL,NULL),(8279,5423,'TE','6019780402',0,'2013-12-25 23:09:27',NULL,NULL),(7549,4916,'EM','n.mcdonald11@me.com',0,'2013-12-25 22:32:17',NULL,NULL),(13524,8819,'AP','5133156344',0,'2013-12-26 04:00:13',NULL,NULL),(5299,3396,'EM','delias2@tigers.lsu.edu',0,'2013-12-25 21:18:00',NULL,NULL),(5449,3488,'EM','jeremyloveridge@gmail.com',0,'2013-12-25 21:20:22',NULL,NULL),(25582,16502,'TE','4196041782',0,'2014-01-07 04:06:53',NULL,NULL),(26111,16815,'TE','6015064271',0,'2014-01-13 02:18:19',NULL,NULL),(31476,20511,'TE','5049820964',0,'2014-01-29 21:01:19',NULL,NULL),(31582,20596,'EM','jrosier50@yahoo.com',0,'2014-01-30 21:00:11',NULL,NULL),(32827,21481,'TE','5135041274',0,'2014-02-04 21:01:43',NULL,NULL),(34689,22747,'EM','stankummer@gmail.com',0,'2014-02-11 21:01:24',NULL,NULL),(36603,24098,'TE','6015071444',0,'2014-02-15 22:01:29',NULL,NULL),(38529,25461,'TE','2546997352',0,'2014-02-25 21:31:32',NULL,NULL),(38873,25694,'AP','5124230035',0,'2014-02-26 09:30:14',NULL,NULL),(43918,29136,'EM','nischlaw@excite.com',0,'2014-03-10 21:02:40',NULL,NULL),(8008,5224,'EM','kris92750@gmail.com',0,'2013-12-25 23:04:38',NULL,NULL),(7767,5069,'TE','4697139615',0,'2013-12-25 23:00:41',NULL,NULL),(20445,13168,'AP','6143613919',0,'2013-12-26 12:54:01',NULL,NULL),(7637,4973,'AP','4093515357',0,'2013-12-25 22:46:31',NULL,NULL),(7518,4902,'TE','7406015550',0,'2013-12-25 22:31:48',NULL,NULL),(9664,6327,'TE','7403459654',0,'2013-12-26 00:46:31',NULL,NULL),(4701,3007,'EM','BMD071@ATT.NET',0,'2013-12-25 20:17:49',NULL,NULL),(5022,3222,'AP','3308023158',0,'2013-12-25 20:45:47',NULL,NULL),(3080,1921,'TE','4197755955',0,'2013-12-25 19:00:11',NULL,NULL),(23292,15008,'TE','3309298877',0,'2014-01-01 12:01:57',NULL,NULL),(26388,16985,'AP','2104098599',0,'2014-01-13 02:20:21',NULL,NULL),(28019,18058,'BN','9376909393',0,'2014-01-15 02:07:20',NULL,NULL),(34381,22551,'EM','andrew.hruska@gmail.com',0,'2014-02-10 21:31:45',NULL,NULL),(39086,25857,'AP','3187943686',0,'2014-02-26 21:00:43',NULL,NULL),(40825,27131,'AP','5137025754',0,'2014-03-03 21:30:40',NULL,NULL),(42997,28594,'AP','4199446109',0,'2014-03-08 21:30:05',NULL,NULL),(394,242,'TE','4193371507',0,'2013-12-25 17:21:21',NULL,NULL),(9597,6284,'AP','5139269927',0,'2013-12-26 00:45:27',NULL,NULL),(14877,9737,'EM','gsherry63@hotmail.com',0,'2013-12-26 04:45:50',NULL,NULL),(6714,4364,'EM','edhball@yahoo.com',0,'2013-12-25 22:00:07',NULL,NULL),(10962,7124,'EM','rcsmslisa@gmail.com',0,'2013-12-26 01:51:26',NULL,NULL),(4168,2663,'TE','5139410410',0,'2013-12-25 19:46:52',NULL,NULL),(5972,3835,'EM','sidneyhorner5111@yahoo.com',0,'2013-12-25 21:35:15',NULL,NULL),(3444,2159,'TE','3186232318',0,'2013-12-25 19:18:49',NULL,NULL),(25608,16518,'EM','bws53@msn.com',1,'2014-01-07 10:21:36',NULL,NULL),(26272,16910,'TE','5132524535',0,'2014-01-13 02:19:37',NULL,NULL),(26519,17062,'EM','pasulliv89@gmail.com',0,'2014-01-13 02:21:12',NULL,NULL),(27156,17485,'TE','8325428684',0,'2014-01-13 03:01:16',NULL,NULL),(36557,24067,'AP','2163741086',0,'2014-02-15 22:01:13',NULL,NULL),(37307,24548,'EM','djprismplus@aol.com',0,'2014-02-20 04:04:00',NULL,NULL),(37620,24793,'EM','jayz2slk@gmail.com',0,'2014-02-20 04:47:23',NULL,NULL),(42509,28271,'AP','9792245583',0,'2014-03-07 21:00:21',NULL,NULL),(43342,28790,'AP','2819053056',0,'2014-03-09 21:00:42',NULL,NULL),(7982,5206,'EM','anne@castonmassage.com',0,'2013-12-25 23:04:11',NULL,NULL),(25665,16547,'AP','4405033759',1,'2014-01-07 10:22:36',NULL,NULL),(23423,15087,'EM','timothyvalluzzi@gmail.com',0,'2014-01-01 12:04:23',NULL,NULL),(2838,1721,'TE','3306341069',0,'2013-12-25 18:55:12',NULL,NULL),(7387,4806,'EM','onlieone@earthlink.net',0,'2013-12-25 22:16:40',NULL,NULL),(4397,2801,'TE','9376582233',0,'2013-12-25 19:50:26',NULL,NULL),(6729,4372,'AP','9372193674',0,'2013-12-25 22:00:20',NULL,NULL),(5743,3681,'TE','4194617074',0,'2013-12-25 21:31:28',NULL,NULL),(5854,3757,'TE','3306273191',0,'2013-12-25 21:33:19',NULL,NULL),(22202,14302,'TE','4198195836',0,'2013-12-27 02:06:52',NULL,NULL),(27760,17898,'AP','7404633157',0,'2014-01-15 02:06:22',NULL,NULL),(30352,19666,'AP','9858693408',0,'2014-01-23 21:00:28',NULL,NULL),(32044,20915,'EM','jkimberlin3@hotmail.com',0,'2014-01-31 21:01:30',NULL,NULL),(32191,21025,'EM','draperathome@outlook.com',0,'2014-02-01 19:00:42',NULL,NULL),(32618,21327,'AP','3303294425',0,'2014-02-04 21:00:26',NULL,NULL),(33482,21942,'TE','4092391262',0,'2014-02-07 19:00:15',NULL,NULL),(33641,22059,'TE','2545623401',0,'2014-02-08 19:00:09',NULL,NULL),(39458,26094,'AP','4255051939',0,'2014-02-28 06:30:10',NULL,NULL),(40031,26535,'TE','5133510090',0,'2014-02-28 21:30:05',NULL,NULL),(42314,28099,'TE','8642096876',0,'2014-03-06 21:02:09',NULL,NULL),(42641,28365,'EM','annaculpepperinman@windstream.net',0,'2014-03-07 21:30:31',NULL,NULL),(2271,1391,'TE','5042480827',0,'2013-12-25 18:46:22',NULL,NULL),(24509,15810,'AP','5049204680',0,'2014-01-03 02:03:11',NULL,NULL),(5587,3570,'EM','franvg@aol.com',0,'2013-12-25 21:22:33',NULL,NULL),(5975,3839,'TE','3184171196',0,'2013-12-25 21:35:20',NULL,NULL),(4939,3172,'AP','2169265800',0,'2013-12-25 20:31:34',NULL,NULL),(4588,2928,'EM','info@pekacards.com',0,'2013-12-25 20:15:57',NULL,NULL),(12288,8037,'TE','2167129328',0,'2013-12-26 03:09:20',NULL,NULL),(13594,8863,'TE','8066763502',0,'2013-12-26 04:01:20',NULL,NULL),(2729,1656,'TE','9032292092',0,'2013-12-25 18:53:30',NULL,NULL),(21616,13912,'EM','sah7707@aol.com',0,'2013-12-26 13:13:59',NULL,NULL),(22122,14251,'TE','8322214842',0,'2013-12-27 02:05:30',NULL,NULL),(33993,22298,'TE','2162256086',0,'2014-02-10 11:00:35',NULL,NULL),(35792,23535,'EM','marlosolomon@hotmail.com',0,'2014-02-13 22:02:29',NULL,NULL),(37394,24624,'TE','2252442913',0,'2014-02-20 04:16:50',NULL,NULL),(38292,25283,'AP','9566246396',0,'2014-02-25 21:00:19',NULL,NULL),(2054,1272,'TE','9728043459',0,'2013-12-25 18:30:17',NULL,NULL),(7790,5086,'TE','9362642600',0,'2013-12-25 23:01:05',NULL,NULL),(2583,1575,'EM','herbalsales.global@gmail.com',0,'2013-12-25 18:51:19',NULL,NULL),(14026,9159,'TE','5133646610',0,'2013-12-26 04:08:40',NULL,NULL),(21311,13690,'TE','4406244254',0,'2013-12-26 13:08:27',NULL,NULL),(21848,14072,'AP','5135456781',0,'2013-12-27 02:00:54',NULL,NULL),(27482,17702,'AP','5045782709',0,'2014-01-14 01:33:05',NULL,NULL),(33100,21681,'TE','5138435936',0,'2014-02-05 21:31:03',NULL,NULL),(33510,21964,'TE','9377070358',0,'2014-02-07 19:00:27',NULL,NULL),(35379,23248,'EM','spayten@yahoo.com',0,'2014-02-13 21:30:05',NULL,NULL),(36574,24073,'EM','typin87@hotmail.com',0,'2014-02-15 22:01:18',NULL,NULL),(43396,28820,'AP','4194660834',0,'2014-03-09 21:00:59',NULL,NULL),(9824,6427,'TE','2253369139',0,'2013-12-26 00:49:04',NULL,NULL),(25648,16540,'AP','2142890299',1,'2014-01-07 10:22:20',NULL,NULL),(25111,16189,'TE','8309664221',0,'2014-01-05 00:00:46',NULL,NULL),(23451,15114,'AP','7404210978',0,'2014-01-01 12:05:05',NULL,NULL),(12237,8002,'EM','jessicawindham1@yahoo.com',0,'2013-12-26 03:08:24',NULL,NULL),(5417,3468,'AP','6146228148',0,'2013-12-25 21:19:53',NULL,NULL),(27710,17862,'TE','6145125823',0,'2014-01-15 02:06:10',NULL,NULL),(28817,18599,'AP','6018639076',0,'2014-01-16 08:47:18',NULL,NULL),(28866,18639,'TE','2144985588',0,'2014-01-17 03:35:05',NULL,NULL),(29075,18780,'TE','4198653163',0,'2014-01-17 03:35:52',NULL,NULL),(29147,18831,'TE','4194972100',0,'2014-01-17 03:36:09',NULL,NULL),(32378,21157,'EM','mark.dershimer@yahoo.com',0,'2014-02-03 21:00:30',NULL,NULL),(33175,21726,'TE','9797320940',0,'2014-02-06 21:00:06',NULL,NULL),(39575,26181,'EM','adams.april.72@gmail.com',0,'2014-02-28 06:30:40',NULL,NULL),(39637,26211,'TE','3303577582',0,'2014-02-28 06:30:53',NULL,NULL),(40569,26927,'AP','5138822209',0,'2014-03-03 01:00:18',NULL,NULL),(42940,28550,'TE','4198107433',0,'2014-03-07 21:32:20',NULL,NULL),(43197,28703,'EM','Krorrer@neo.rr.com',0,'2014-03-08 21:31:11',NULL,NULL),(717,445,'AP','9375246777',0,'2013-12-25 17:47:17',NULL,NULL),(10196,6662,'AP','9037677693',0,'2013-12-26 01:00:54',NULL,NULL),(20759,13341,'TE','2818075103',0,'2013-12-26 12:58:55',NULL,NULL),(2420,1478,'TE','6145631388',0,'2013-12-25 18:48:44',NULL,NULL),(3146,1965,'TE','8176816774',0,'2013-12-25 19:01:19',NULL,NULL),(3275,2060,'EM','joeasi1@fuse.net',0,'2013-12-25 19:16:06',NULL,NULL),(22946,14803,'EM','shawannasharee@gmail.com',1,'2013-12-29 11:13:49',NULL,NULL),(25267,16291,'AP','9372487583',0,'2014-01-07 04:00:51',NULL,NULL),(27787,17912,'AP','5202414133',0,'2014-01-15 02:06:27',NULL,NULL),(27913,17986,'TE','3304142434',0,'2014-01-15 02:06:55',NULL,NULL),(28006,18050,'TE','6623473602',0,'2014-01-15 02:07:16',NULL,NULL),(30646,19888,'EM','hingychan@outlook.com',0,'2014-01-24 21:00:50',NULL,NULL),(35002,22983,'TE','9378221336',0,'2014-02-12 21:30:09',NULL,NULL),(36355,23943,'TE','6143787701',0,'2014-02-15 21:00:10',NULL,NULL),(37715,24867,'AP','2146065110',0,'2014-02-20 05:32:15',NULL,NULL),(39500,26126,'TE','9372243300',0,'2014-02-28 06:30:21',NULL,NULL),(42959,28569,'TE','4194388188',0,'2014-03-07 21:32:30',NULL,NULL),(6760,4388,'AP','5133493433',0,'2013-12-25 22:00:49',NULL,NULL),(22429,14462,'TE','3303259038',0,'2013-12-28 03:32:50',NULL,NULL),(2844,1727,'AP','5133930571',0,'2013-12-25 18:55:19',NULL,NULL),(5199,3341,'EM','scottbutler@me.com',0,'2013-12-25 21:16:30',NULL,NULL),(11185,7273,'TE','2108600102',0,'2013-12-26 02:02:30',NULL,NULL),(13926,9080,'AP','3302067279',0,'2013-12-26 04:06:49',NULL,NULL),(12450,8154,'AP','5125571812',0,'2013-12-26 03:16:08',NULL,NULL),(11592,7542,'EM','floresfamily2010@gmail.com',0,'2013-12-26 02:32:57',NULL,NULL),(23595,15235,'TE','3309237857',0,'2014-01-01 12:08:25',NULL,NULL),(24776,15983,'TE','6022212610',0,'2014-01-04 02:01:01',NULL,NULL),(25368,16359,'AP','9378381785',0,'2014-01-07 04:02:42',NULL,NULL),(26476,17039,'AP','6013206413',0,'2014-01-13 02:20:50',NULL,NULL),(32406,21176,'TE','3306318044',0,'2014-02-03 21:00:41',NULL,NULL),(33056,21654,'TE','2256294865',0,'2014-02-05 21:30:51',NULL,NULL),(34115,22364,'EM','nrn5@roadrunner.com',0,'2014-02-10 21:00:10',NULL,NULL),(39284,25992,'TE','6019412119',0,'2014-02-26 21:01:57',NULL,NULL),(42105,27975,'AP','5043882419',0,'2014-03-06 21:00:53',NULL,NULL),(42183,28021,'EM','dyuellig@gmail.com',0,'2014-03-06 21:01:21',NULL,NULL),(1418,865,'TE','4192835080',0,'2013-12-25 18:07:17',NULL,NULL),(1837,1135,'EM','hunt458@yahoo.com',0,'2013-12-25 18:18:11',NULL,NULL),(22231,14329,'TE','4198661624',0,'2013-12-27 02:07:30',NULL,NULL),(21921,14123,'TE','3303296870',0,'2013-12-27 02:02:10',NULL,NULL),(2437,1494,'AP','7274498622',0,'2013-12-25 18:49:07',NULL,NULL),(20287,13077,'AP','6144775116',0,'2013-12-26 12:51:29',NULL,NULL),(20260,13056,'EM','dbucher@cinci.rr.com',0,'2013-12-26 12:50:58',NULL,NULL),(24296,15697,'AP','3302405426',1,'2014-01-02 04:35:36',NULL,NULL),(29103,18793,'TE','5132560196',0,'2014-01-17 03:35:57',NULL,NULL),(31733,20711,'TE','5049143748',0,'2014-01-30 21:01:08',NULL,NULL),(32734,21413,'BN','2162625825',0,'2014-02-04 21:01:09',NULL,NULL),(33781,22171,'TE','5137342151',0,'2014-02-08 19:30:04',NULL,NULL),(34555,22663,'TE','3616481038',0,'2014-02-11 21:00:36',NULL,NULL),(28404,18302,'EM','kjlnicholson@yahoo.com',0,'2014-01-16 08:44:57',NULL,NULL),(309,190,'TE','3309221760',0,'2013-12-25 17:19:56',NULL,NULL),(4696,3003,'AP','3308081808',0,'2013-12-25 20:17:43',NULL,NULL),(6809,4417,'AP','4406550053',0,'2013-12-25 22:01:32',NULL,NULL),(2367,1438,'AP','6625708848',0,'2013-12-25 18:47:47',NULL,NULL),(38336,25326,'TE','3182569255',0,'2014-02-25 21:30:13',NULL,NULL),(3678,2333,'TE','2023678765',0,'2013-12-25 19:31:45',NULL,NULL),(33898,22250,'AP','2162996205',0,'2014-02-09 19:00:42',NULL,NULL),(9161,5998,'EM','mjjoubert@icloud.com',0,'2013-12-26 00:00:17',NULL,NULL),(30635,19881,'TE','4193717360',0,'2014-01-24 21:00:46',NULL,NULL),(30040,19456,'EM','afshazi@hotmail.com',0,'2014-01-23 03:01:54',NULL,NULL),(20387,13131,'AP','5135831476',0,'2013-12-26 12:53:02',NULL,NULL),(8351,5484,'TE','5137332963',0,'2013-12-25 23:10:55',NULL,NULL),(10721,6973,'TE','5132630514',0,'2013-12-26 01:47:30',NULL,NULL),(27692,17850,'AP','9376264418',0,'2014-01-15 02:06:06',NULL,NULL),(40463,26860,'AP','9372170522',0,'2014-03-01 21:00:56',NULL,NULL),(27934,18001,'TE','4407968330',0,'2014-01-15 02:07:00',NULL,NULL),(38188,25205,'TE','3377805973',0,'2014-02-21 22:00:48',NULL,NULL),(12056,7867,'EM','tim_miller@portagechapel.com',0,'2013-12-26 03:05:09',NULL,NULL),(38990,25782,'TE','4193068063',0,'2014-02-26 09:31:03',NULL,NULL),(28852,18634,'TE','3252607377',0,'2014-01-17 03:35:03',NULL,NULL),(30513,19792,'EM','lodeman@ameritech.net',0,'2014-01-23 21:01:41',NULL,NULL),(32873,21515,'TE','2163223131',0,'2014-02-05 21:00:04',NULL,NULL),(34392,22559,'AP','4156800733',0,'2014-02-10 21:31:50',NULL,NULL),(35706,23483,'AP','6468722033',0,'2014-02-13 22:01:57',NULL,NULL),(40612,26959,'AP','7166018840',0,'2014-03-03 01:00:30',NULL,NULL),(38364,25341,'TE','2257721396',0,'2014-02-25 21:30:25',NULL,NULL),(476,301,'TE','3308727317',0,'2013-12-25 17:30:50',NULL,NULL),(10788,7011,'EM','rgindaltx@yahoo.com',0,'2013-12-26 01:48:33',NULL,NULL),(2014,1248,'AP','9372188423',0,'2013-12-25 18:21:08',NULL,NULL),(7177,4679,'TE','3182837964',0,'2013-12-25 22:07:50',NULL,NULL),(6911,4500,'AP','9565782050',0,'2013-12-25 22:03:21',NULL,NULL),(5902,3786,'TE','4406384630',0,'2013-12-25 21:34:07',NULL,NULL),(2286,1402,'TE','3378027818',0,'2013-12-25 18:46:38',NULL,NULL),(20659,13284,'TE','5122897788',0,'2013-12-26 12:57:19',NULL,NULL),(4663,2978,'EM','Johnisenbarger2@gmail.com',0,'2013-12-25 20:17:11',NULL,NULL),(25360,16353,'AP','4404541885',0,'2014-01-07 04:02:35',NULL,NULL),(35105,23057,'EM','donnaclarkm2001@yahoo.com',0,'2014-02-12 21:30:49',NULL,NULL),(28583,18426,'AP','3185177836',0,'2014-01-16 08:45:55',NULL,NULL),(40757,27084,'EM','jvon662@gmail.com',0,'2014-03-03 21:30:13',NULL,NULL),(41217,27378,'TE','2284242303',0,'2014-03-04 21:01:19',NULL,NULL),(42017,27928,'TE','9722730558',0,'2014-03-06 21:00:24',NULL,NULL),(43193,28702,'TE','3306594028',0,'2014-03-08 21:31:10',NULL,NULL),(28139,18140,'TE','8643954789',0,'2014-01-15 02:07:46',NULL,NULL),(28561,18415,'AP','5046382610',0,'2014-01-16 08:45:49',NULL,NULL),(36517,24041,'AP','8176090303',0,'2014-02-15 22:00:59',NULL,NULL),(39312,26004,'EM','kmwatkins09@gmail.com',0,'2014-02-26 21:02:06',NULL,NULL),(42052,27945,'AP','2542131934',0,'2014-03-06 21:00:35',NULL,NULL),(27161,17487,'AP','9567761260',0,'2014-01-13 03:01:17',NULL,NULL),(10585,6887,'AP','9852762043',0,'2013-12-26 01:45:17',NULL,NULL),(26747,17203,'TE','4194960495',0,'2014-01-13 02:22:25',NULL,NULL),(1589,981,'TE','2169732474',0,'2013-12-25 18:10:17',NULL,NULL),(26599,17111,'AP','5135518842',0,'2014-01-13 02:21:37',NULL,NULL),(7542,4913,'EM','Brinanicole1983@yahoo.com',0,'2013-12-25 22:32:10',NULL,NULL),(14538,9497,'AP','6144469892',0,'2013-12-26 04:35:05',NULL,NULL),(24707,15938,'TE','5132477077',0,'2014-01-03 02:07:09',NULL,NULL),(1615,994,'TE','9375805289',0,'2013-12-25 18:10:43',NULL,NULL),(2650,1611,'TE','2818444912',0,'2013-12-25 18:52:18',NULL,NULL),(23634,15263,'TE','4192505562',0,'2014-01-01 12:09:20',NULL,NULL),(3749,2378,'AP','4405678483',0,'2013-12-25 19:32:57',NULL,NULL),(29866,19321,'EM','bcox123@hot.rr.com',1,'2014-01-22 03:22:12',NULL,NULL),(410,252,'TE','3183661308',0,'2013-12-25 17:21:36',NULL,NULL),(8221,5381,'AP','5042611423',0,'2013-12-25 23:08:22',NULL,NULL),(5314,3406,'AP','5046552439',0,'2013-12-25 21:18:16',NULL,NULL),(8695,5707,'EM','bjbleichner@gmail.com',0,'2013-12-25 23:33:07',NULL,NULL),(40391,26809,'AP','3302568771',0,'2014-03-01 21:00:28',NULL,NULL),(38622,25524,'EM','TPLATTENBURG@WAVERLYPARTNERS.COM',0,'2014-02-25 21:32:09',NULL,NULL),(27992,18042,'AP','2285967367',0,'2014-01-15 02:07:13',NULL,NULL),(38254,25255,'AP','4196181258',0,'2014-02-21 22:01:17',NULL,NULL),(39296,25997,'TE','3188583547',0,'2014-02-26 21:02:01',NULL,NULL),(43961,29165,'TE','5675250164',0,'2014-03-10 21:02:56',NULL,NULL),(23390,15065,'AP','5043146050',0,'2014-01-01 12:03:44',NULL,NULL),(36408,23979,'AP','3108093805',0,'2014-02-15 22:00:19',NULL,NULL),(21229,13648,'TE','2257731054',0,'2013-12-26 13:07:13',NULL,NULL),(35583,23404,'AP','3306664811',0,'2014-02-13 22:01:11',NULL,NULL),(32136,20986,'EM','PGANTZ@GMAIL.COM',0,'2014-02-01 19:00:23',NULL,NULL),(4917,3158,'AP','5132076747',0,'2013-12-25 20:31:14',NULL,NULL),(6169,3975,'TE','5135414459',0,'2013-12-25 21:38:42',NULL,NULL),(9645,6311,'AP','5132825199',0,'2013-12-26 00:46:10',NULL,NULL),(9456,6188,'TE','3252807630',0,'2013-12-26 00:30:16',NULL,NULL),(8502,5592,'EM','muellert@cinci.rr.com',0,'2013-12-25 23:17:18',NULL,NULL),(5597,3583,'AP','5133142843',0,'2013-12-25 21:22:47',NULL,NULL),(11536,7508,'AP','5044132223',0,'2013-12-26 02:32:03',NULL,NULL),(34238,22456,'AP','9564007221',0,'2014-02-10 21:30:50',NULL,NULL),(1037,639,'TE','4406100191',0,'2013-12-25 18:01:19',NULL,NULL),(40322,26759,'TE','9035177741',0,'2014-03-01 19:00:07',NULL,NULL),(10696,6952,'EM','djcj1949@yahoo.com',0,'2013-12-26 01:47:04',NULL,NULL),(10466,6819,'TE','4405764926',0,'2013-12-26 01:30:30',NULL,NULL),(26767,17219,'TE','6015293514',0,'2014-01-13 02:22:33',NULL,NULL),(33146,21710,'AP','5137247077',0,'2014-02-05 21:31:15',NULL,NULL),(12164,7946,'TE','5045641760',0,'2013-12-26 03:07:02',NULL,NULL),(4920,3159,'AP','4193573185',0,'2013-12-25 20:31:16',NULL,NULL),(6690,4348,'EM','jm19502008@yahoo.com',0,'2013-12-25 21:53:24',NULL,NULL),(14183,9278,'TE','2169905934',0,'2013-12-26 04:15:53',NULL,NULL),(25195,16244,'AP','3303047571',0,'2014-01-05 00:02:29',NULL,NULL),(23585,15226,'TE','3187914829',0,'2014-01-01 12:08:11',NULL,NULL),(23155,14926,'TE','5133400705',0,'2013-12-30 00:01:50',NULL,NULL),(7586,4938,'TE','4405760180',0,'2013-12-25 22:45:37',NULL,NULL),(37938,25031,'EM','hodgeslawfirm@cox.net',0,'2014-02-20 22:01:04',NULL,NULL),(10555,6871,'TE','5037530102',0,'2013-12-26 01:32:00',NULL,NULL),(10035,6565,'TE','4328162473',0,'2013-12-26 00:52:31',NULL,NULL),(26690,17168,'TE','3188039386',0,'2014-01-13 02:22:06',NULL,NULL),(26429,17005,'AP','9378299244',0,'2014-01-13 02:20:33',NULL,NULL),(9035,5929,'AP','2819091110',0,'2013-12-25 23:50:28',NULL,NULL),(30381,19684,'TE','9038181137',0,'2014-01-23 21:00:39',NULL,NULL),(4295,2742,'TE','3306033903',0,'2013-12-25 19:48:49',NULL,NULL),(41313,27446,'AP','3305735552',0,'2014-03-04 21:01:56',NULL,NULL),(41645,27683,'AP','4322221489',0,'2014-03-05 21:30:40',NULL,NULL),(8586,5642,'EM','stox1994@comcast.net',0,'2013-12-25 23:31:17',NULL,NULL),(7987,5210,'AP','9375432174',0,'2013-12-25 23:04:17',NULL,NULL),(5182,3327,'TE','6176784793',0,'2013-12-25 21:16:12',NULL,NULL),(14632,9567,'TE','8312242411',0,'2013-12-26 04:36:40',NULL,NULL),(13889,9056,'AP','5124841674',0,'2013-12-26 04:06:12',NULL,NULL),(3780,2397,'EM','KWT_1950@Yahoo.com',0,'2013-12-25 19:33:27',NULL,NULL),(39046,25822,'AP','9376206515',0,'2014-02-26 21:00:27',NULL,NULL),(36389,23967,'BN','3619441199',0,'2014-02-15 22:00:12',NULL,NULL),(30401,19701,'TE','2692622025',0,'2014-01-23 21:00:48',NULL,NULL),(4237,2710,'TE','3304259302',0,'2013-12-25 19:47:56',NULL,NULL),(33889,22240,'AP','2162996205',0,'2014-02-09 19:00:38',NULL,NULL),(4437,2828,'EM','asshanti_s@yahoo.com',0,'2013-12-25 20:00:42',NULL,NULL),(42544,28307,'AP','6622300938',0,'2014-03-07 21:00:35',NULL,NULL),(245,150,'AP','3302412858',0,'2013-12-25 17:18:55',NULL,NULL),(10059,6577,'AP','5136167339',0,'2013-12-26 00:52:53',NULL,NULL),(13958,9099,'EM','meyeball@roadrunner.com',0,'2013-12-26 04:07:21',NULL,NULL),(2531,1549,'TE','6625497967',0,'2013-12-25 18:50:33',NULL,NULL),(528,331,'TE','9379381090',0,'2013-12-25 17:31:40',NULL,NULL),(40113,26602,'AP','9159260240',0,'2014-02-28 21:30:42',NULL,NULL),(29603,19128,'EM','evaterry07@hotmail.com',0,'2014-01-21 08:45:21',NULL,NULL),(28827,18610,'TE','4198364317',0,'2014-01-16 08:47:23',NULL,NULL),(27394,17633,'TE','4405278189',0,'2014-01-14 01:32:34',NULL,NULL),(9189,6015,'AP','2169520206',0,'2013-12-26 00:00:42',NULL,NULL),(27994,18043,'AP','2283427902',0,'2014-01-15 02:07:14',NULL,NULL),(28112,18118,'EM','mtkreddick@juno.com',0,'2014-01-15 02:07:40',NULL,NULL),(21300,13684,'TE','3304945036',0,'2013-12-26 13:08:17',NULL,NULL),(42515,28278,'AP','5135194705',0,'2014-03-07 21:00:24',NULL,NULL),(561,348,'AP','4403134847',0,'2013-12-25 17:32:11',NULL,NULL),(11584,7539,'TE','2542833186',0,'2013-12-26 02:32:51',NULL,NULL),(38534,25465,'TE','2818552799',0,'2014-02-25 21:31:34',NULL,NULL),(5922,3798,'TE','5134656482',0,'2013-12-25 21:34:26',NULL,NULL),(8739,5730,'AP','2254853123',0,'2013-12-25 23:45:40',NULL,NULL),(35644,23437,'EM','lizsieger2@gmail.com',0,'2014-02-13 22:01:31',NULL,NULL),(2396,1460,'TE','2164756544',0,'2013-12-25 18:48:18',NULL,NULL),(29180,18853,'EM','sullivanplace@yahoo.com',0,'2014-01-17 03:36:17',NULL,NULL),(11733,7636,'AP','5139399386',0,'2013-12-26 02:46:25',NULL,NULL),(26202,16864,'AP','9158437285',0,'2014-01-13 02:19:12',NULL,NULL),(22539,14531,'AP','2487053365',0,'2013-12-28 03:34:35',NULL,NULL),(43014,28602,'EM','thmarl@hotmail.com',0,'2014-03-08 21:30:10',NULL,NULL),(5530,3537,'AP','8307086725',0,'2013-12-25 21:21:39',NULL,NULL),(11131,7235,'AP','2162125154',0,'2013-12-26 02:01:31',NULL,NULL),(36938,24324,'EM','donnamillner@yahoo.com',0,'2014-02-18 22:00:10',NULL,NULL),(10199,6663,'AP','2547158096',0,'2013-12-26 01:00:57',NULL,NULL),(33793,22185,'TE','9857050874',0,'2014-02-09 19:00:06',NULL,NULL),(31880,20808,'EM','casmig1@yahoo.com',0,'2014-01-31 21:00:26',NULL,NULL),(31341,20422,'AP','9372101703',0,'2014-01-29 21:00:31',NULL,NULL),(26286,16919,'TE','2167219070',0,'2014-01-13 02:19:42',NULL,NULL),(21354,13724,'TE','3306677203',0,'2013-12-26 13:09:17',NULL,NULL),(39444,26087,'EM','thespannman@yahoo.com',0,'2014-02-28 06:30:07',NULL,NULL),(32632,21342,'TE','8308963511',0,'2014-02-04 21:00:33',NULL,NULL),(29345,18961,'AP','9564599231',0,'2014-01-20 08:05:55',NULL,NULL),(7643,4976,'AP','4695092588',0,'2013-12-25 22:46:36',NULL,NULL),(26439,17014,'TE','5183644741',0,'2014-01-13 02:20:37',NULL,NULL),(25432,16401,'AP','2143358274',0,'2014-01-07 04:03:54',NULL,NULL),(14303,9355,'TE','4093927747',0,'2013-12-26 04:31:22',NULL,NULL),(22839,14735,'AP','9377633680',1,'2013-12-29 11:09:53',NULL,NULL),(4950,3177,'TE','5045599958',0,'2013-12-25 20:31:45',NULL,NULL),(40337,26769,'EM','rmennen35@hotmail.com',0,'2014-03-01 19:00:14',NULL,NULL),(36882,24291,'TE','3307019455',0,'2014-02-18 21:30:13',NULL,NULL),(8909,5831,'AP','2108616627',0,'2013-12-25 23:48:19',NULL,NULL),(1621,996,'TE','9375805289',0,'2013-12-25 18:10:47',NULL,NULL),(34195,22426,'EM','GLORIALOCAS@SBCGLOBAL.NET',0,'2014-02-10 21:30:34',NULL,NULL),(1773,1096,'AP','2162535635',0,'2013-12-25 18:17:09',NULL,NULL),(12285,8035,'AP','4198891268',0,'2013-12-26 03:09:17',NULL,NULL),(25411,16392,'TE','9568020225',0,'2014-01-07 04:03:36',NULL,NULL),(26033,16773,'TE','6624044620',0,'2014-01-08 18:25:03',NULL,NULL),(29908,19355,'TE','2165542542',1,'2014-01-22 03:22:28',NULL,NULL),(42459,28207,'AP','9493717506',0,'2014-03-06 21:30:11',NULL,NULL),(1001,615,'TE','9376852758',0,'2013-12-25 18:00:42',NULL,NULL),(37681,24846,'AP','3304729927',0,'2014-02-20 04:54:31',NULL,NULL),(31082,20226,'EM','kingrooter@yahoo.com',0,'2014-01-27 21:01:48',NULL,NULL),(23734,15313,'TE','8069953232',1,'2014-01-02 04:23:18',NULL,NULL),(3528,2206,'AP','3309791324',0,'2013-12-25 19:20:11',NULL,NULL),(20695,13304,'EM','trey_goolsby@yahoo.com',0,'2013-12-26 12:57:53',NULL,NULL),(9379,6140,'TE','5042015520',0,'2013-12-26 00:16:14',NULL,NULL),(41286,27432,'AP','9365811978',0,'2014-03-04 21:01:47',NULL,NULL),(42865,28506,'EM','bonnie.finitzer@fatt.net',0,'2014-03-07 21:31:52',NULL,NULL),(40167,26639,'EM','javierterrazas11@yahoo.com',0,'2014-02-28 21:31:02',NULL,NULL),(6688,4348,'TE','4193945835',0,'2013-12-25 21:53:23',NULL,NULL),(9677,6341,'TE','4402369273',0,'2013-12-26 00:46:47',NULL,NULL),(7426,4829,'TE','5139220922',0,'2013-12-25 22:17:18',NULL,NULL),(35793,23536,'TE','5042357713',0,'2014-02-13 22:02:29',NULL,NULL),(23787,15341,'TE','3308586636',1,'2014-01-02 04:24:15',NULL,NULL),(29669,19174,'TE','8173080458',0,'2014-01-21 08:46:04',NULL,NULL),(31000,20166,'EM','dfreder6@emich.edu',0,'2014-01-27 21:01:12',NULL,NULL),(32841,21493,'AP','5672240189',0,'2014-02-04 21:01:48',NULL,NULL),(33024,21635,'AP','3617283411',0,'2014-02-05 21:30:43',NULL,NULL),(11491,7474,'TE','4403410731',0,'2013-12-26 02:31:15',NULL,NULL),(23775,15333,'AP','4199800237',1,'2014-01-02 04:24:00',NULL,NULL),(6350,4092,'TE','6016804241',0,'2013-12-25 21:47:29',NULL,NULL),(20645,13279,'TE','9723757856',0,'2013-12-26 12:57:08',NULL,NULL),(1427,870,'TE','3304285595',0,'2013-12-25 18:07:26',NULL,NULL),(39519,26140,'AP','6143576273',0,'2014-02-28 06:30:25',NULL,NULL),(11465,7457,'EM','maryannputman@fuse.net',0,'2013-12-26 02:30:49',NULL,NULL),(8774,5750,'AP','3375324159',0,'2013-12-25 23:46:12',NULL,NULL),(38463,25418,'TE','4407731089',0,'2014-02-25 21:31:07',NULL,NULL),(14415,9424,'TE','4253191438',0,'2013-12-26 04:33:13',NULL,NULL),(22322,14389,'AP','5132135471',0,'2013-12-28 03:30:59',NULL,NULL),(35378,23248,'AP','2169057567',0,'2014-02-13 21:30:05',NULL,NULL),(33902,22253,'TE','5137393766',0,'2014-02-09 19:00:44',NULL,NULL),(31296,20392,'TE','9038964927',0,'2014-01-29 21:00:16',NULL,NULL),(43183,28695,'EM','msbkirk1977@gmail.com',0,'2014-03-08 21:31:06',NULL,NULL),(27814,17926,'TE','9033883314',0,'2014-01-15 02:06:33',NULL,NULL),(25671,16550,'TE','3186585817',1,'2014-01-07 10:22:42',NULL,NULL),(8957,5865,'EM','alynn8503@gmail.com',0,'2013-12-25 23:49:06',NULL,NULL),(7548,4916,'AP','2169732474',0,'2013-12-25 22:32:16',NULL,NULL),(1816,1125,'EM','rbodiker1956@gmail.com',0,'2013-12-25 18:17:53',NULL,NULL),(23221,14965,'TE','2147094617',0,'2014-01-01 12:00:37',NULL,NULL),(22998,14835,'TE','4195615779',1,'2013-12-29 11:14:40',NULL,NULL),(32,22,'TE','3309321036',0,'2013-12-25 17:15:33',NULL,NULL),(6046,3884,'AP','2343127647',0,'2013-12-25 21:36:32',NULL,NULL),(11161,7259,'EM','TAZWAC@YAHOO.COM',0,'2013-12-26 02:02:06',NULL,NULL),(41261,27421,'TE','2282298089',0,'2014-03-04 21:01:39',NULL,NULL),(39212,25933,'TE','4322940562',0,'2014-02-26 21:01:27',NULL,NULL),(1026,633,'TE','5133071859',0,'2013-12-25 18:01:09',NULL,NULL),(37505,24695,'AP','5132655186',0,'2014-02-20 04:33:20',NULL,NULL),(35190,23113,'AP','5134076669',0,'2014-02-12 21:31:19',NULL,NULL),(34414,22576,'TE','5133077483',0,'2014-02-10 21:32:00',NULL,NULL),(2582,1575,'TE','8326982342',0,'2013-12-25 18:51:18',NULL,NULL),(32296,21094,'EM','MUNCHKIN4880@MSN.COM',0,'2014-02-02 19:00:30',NULL,NULL),(32003,20892,'AP','4192454702',0,'2014-01-31 21:01:15',NULL,NULL),(6241,4023,'TE','7177562141',0,'2013-12-25 21:45:43',NULL,NULL),(38520,25456,'TE','9564583172',0,'2014-02-25 21:31:28',NULL,NULL),(38205,25218,'TE','2166506915',0,'2014-02-21 22:00:54',NULL,NULL),(28095,18108,'AP','3187871618',0,'2014-01-15 02:07:36',NULL,NULL),(21593,13894,'EM','kdagg@sbcglobal.net',0,'2013-12-26 13:13:33',NULL,NULL),(21859,14081,'AP','5136930866',0,'2013-12-27 02:01:07',NULL,NULL),(26571,17092,'AP','5123942038',0,'2014-01-13 02:21:28',NULL,NULL),(23207,14954,'EM','cladio_adela@yahoo.com',0,'2014-01-01 12:00:19',NULL,NULL),(25981,16739,'AP','3306222290',0,'2014-01-08 18:24:51',NULL,NULL),(41685,27721,'TE','7136799843',0,'2014-03-05 21:30:58',NULL,NULL),(40120,26607,'TE','9566220492',0,'2014-02-28 21:30:45',NULL,NULL),(31005,20169,'EM','joan.mack10@yahoo.com',0,'2014-01-27 21:01:14',NULL,NULL),(4264,2727,'TE','2258026100',0,'2013-12-25 19:48:22',NULL,NULL),(7005,4576,'TE','9363328049',0,'2013-12-25 22:05:05',NULL,NULL),(7296,4751,'TE','9188047599',0,'2013-12-25 22:15:13',NULL,NULL),(12424,8136,'TE','9372684515',0,'2013-12-26 03:15:41',NULL,NULL),(30481,19764,'TE','9013830928',0,'2014-01-23 21:01:25',NULL,NULL),(32685,21380,'AP','5132958628',0,'2014-02-04 21:00:52',NULL,NULL),(30882,20072,'AP','8184150332',0,'2014-01-27 21:00:18',NULL,NULL),(9401,6152,'AP','7133732315',0,'2013-12-26 00:16:33',NULL,NULL),(816,507,'EM','adamsorkin@hotmail.com',0,'2013-12-25 17:48:51',NULL,NULL),(2338,1424,'TE','5044736409',0,'2013-12-25 18:47:21',NULL,NULL),(7225,4705,'TE','4193762976',0,'2013-12-25 22:08:33',NULL,NULL),(14911,9756,'AP','2107884108',0,'2013-12-26 05:00:05',NULL,NULL),(30073,19479,'EM','ARUNILN@MSN.COM',0,'2014-01-23 03:02:03',NULL,NULL),(36599,24095,'AP','4196513530',0,'2014-02-15 22:01:27',NULL,NULL),(36529,24051,'TE','4407591904',0,'2014-02-15 22:01:04',NULL,NULL),(37590,24765,'TE','4406542422',0,'2014-02-20 04:43:37',NULL,NULL),(25693,16563,'TE','2283800493',1,'2014-01-07 10:23:08',NULL,NULL),(24662,15900,'AP','5136811125',0,'2014-01-03 02:06:04',NULL,NULL),(32431,21192,'TE','2282541095',0,'2014-02-03 21:00:49',NULL,NULL),(3450,2161,'TE','3303105088',0,'2013-12-25 19:18:54',NULL,NULL),(20852,13405,'EM','skipscott27@aol.com',0,'2013-12-26 13:00:27',NULL,NULL),(11589,7541,'EM','slvanoverborg@gmail.com',0,'2013-12-26 02:32:55',NULL,NULL),(2084,1288,'AP','9374080384',0,'2013-12-25 18:30:47',NULL,NULL),(1352,826,'AP','2164708350',0,'2013-12-25 18:06:12',NULL,NULL),(29194,18862,'TE','2254446738',0,'2014-01-17 03:36:20',NULL,NULL),(32171,21015,'AP','3309582347',0,'2014-02-01 19:00:36',NULL,NULL),(43411,28828,'TE','4193899192',0,'2014-03-09 21:01:05',NULL,NULL),(24858,16030,'EM','Benniebibb53@yahoo.com',0,'2014-01-04 02:02:29',NULL,NULL),(29226,18877,'AP','3375233188',0,'2014-01-17 03:36:27',NULL,NULL),(12462,8159,'TE','4196193003',0,'2013-12-26 03:16:19',NULL,NULL),(268,164,'AP','5138236546',0,'2013-12-25 17:19:17',NULL,NULL),(11014,7150,'TE','7402973356',0,'2013-12-26 01:52:10',NULL,NULL),(20602,13251,'EM','simmonsdean4@aol.com',0,'2013-12-26 12:56:24',NULL,NULL),(24200,15634,'AP','3186788774',1,'2014-01-02 04:33:35',NULL,NULL),(36968,24341,'TE','5756404771',0,'2014-02-18 22:00:20',NULL,NULL),(30535,19807,'AP','2144229690',0,'2014-01-24 21:00:07',NULL,NULL),(29912,19357,'AP','4196027888',1,'2014-01-22 03:22:29',NULL,NULL),(30071,19479,'TE','5124875417',0,'2014-01-23 03:02:03',NULL,NULL),(40852,27147,'TE','5134353633',0,'2014-03-03 21:30:50',NULL,NULL),(1260,765,'TE','5125220363',0,'2013-12-25 18:04:41',NULL,NULL),(26676,17161,'AP','3185039399',0,'2014-01-13 02:22:02',NULL,NULL),(7811,5098,'EM','bartonrobinson@gmail.com',0,'2013-12-25 23:01:24',NULL,NULL),(7638,4973,'EM','tazwoman723@aol.com',0,'2013-12-25 22:46:31',NULL,NULL),(14270,9335,'TE','2253230603',0,'2013-12-26 04:30:51',NULL,NULL),(13824,9013,'EM','SALTYKALTY20@AOL.COM',0,'2013-12-26 04:05:09',NULL,NULL),(13523,8819,'TE','5133156344',0,'2013-12-26 04:00:12',NULL,NULL),(36646,24124,'AP','2255733394',0,'2014-02-15 22:01:44',NULL,NULL),(22531,14527,'TE','3615858692',0,'2013-12-28 03:34:28',NULL,NULL),(34341,22530,'TE','3307244944',0,'2014-02-10 21:31:31',NULL,NULL),(8129,5322,'AP','5137204727',0,'2013-12-25 23:06:51',NULL,NULL),(34211,22437,'TE','9033069535',0,'2014-02-10 21:30:40',NULL,NULL),(20500,13200,'TE','9039690096',0,'2013-12-26 12:54:55',NULL,NULL),(33531,21981,'TE','5044500034',0,'2014-02-07 19:00:37',NULL,NULL),(33156,21717,'AP','7144684852',0,'2014-02-05 21:31:18',NULL,NULL),(11568,7527,'TE','9402285544',0,'2013-12-26 02:32:35',NULL,NULL),(30008,19433,'TE','4193500218',1,'2014-01-22 03:23:09',NULL,NULL),(36469,24011,'TE','3305458219',0,'2014-02-15 22:00:40',NULL,NULL),(40305,26736,'AP','5132760485',0,'2014-02-28 21:31:52',NULL,NULL),(40669,27002,'TE','3305249333',0,'2014-03-03 21:00:02',NULL,NULL),(41397,27502,'TE','4193604463',0,'2014-03-04 21:02:28',NULL,NULL),(33369,21864,'AP','5136072731',0,'2014-02-06 21:01:22',NULL,NULL),(21090,13561,'AP','2252845545',0,'2013-12-26 13:04:23',NULL,NULL),(1690,1039,'AP','9563693466',0,'2013-12-25 18:15:43',NULL,NULL),(30740,19974,'TE','9405662767',0,'2014-01-25 19:00:12',NULL,NULL),(40056,26554,'AP','5132536725',0,'2014-02-28 21:30:16',NULL,NULL),(42866,28507,'TE','3303364836',0,'2014-03-07 21:31:52',NULL,NULL),(42938,28549,'AP','4196014962',0,'2014-03-07 21:32:20',NULL,NULL),(32701,21392,'AP','3303974706',0,'2014-02-04 21:00:57',NULL,NULL),(4207,2689,'AP','3612186281',0,'2013-12-25 19:47:28',NULL,NULL),(9173,6004,'TE','5135151221',0,'2013-12-26 00:00:27',NULL,NULL),(6073,3909,'TE','8309281281',0,'2013-12-25 21:37:03',NULL,NULL),(10017,6553,'EM','VTHOMPSON1111@GMAIL.COM',0,'2013-12-26 00:52:14',NULL,NULL),(29949,19381,'EM','drako0215@gmail.com',1,'2014-01-22 03:22:42',NULL,NULL),(26664,17155,'AP','3183934003',0,'2014-01-13 02:21:59',NULL,NULL),(21842,14070,'TE','2165346374',0,'2013-12-27 02:00:50',NULL,NULL),(43994,29186,'TE','3309239583',0,'2014-03-10 21:30:02',NULL,NULL),(26567,17089,'EM','shovonc@yahoo.com',0,'2014-01-13 02:21:27',NULL,NULL),(27680,17842,'TE','5135265768',0,'2014-01-15 02:06:04',NULL,NULL),(41233,27386,'AP','6018470188',0,'2014-03-04 21:01:25',NULL,NULL),(26454,17030,'AP','4198102634',0,'2014-01-13 02:20:44',NULL,NULL),(5037,3231,'TE','2164528521',0,'2013-12-25 20:46:03',NULL,NULL),(35661,23453,'TE','9722741213',0,'2014-02-13 22:01:39',NULL,NULL),(33155,21717,'TE','7144684852',0,'2014-02-05 21:31:18',NULL,NULL),(2408,1468,'TE','9372061498',0,'2013-12-25 18:48:30',NULL,NULL),(7529,4906,'TE','2256146816',0,'2013-12-25 22:31:57',NULL,NULL),(28884,18648,'EM','twmarsh99@yahoo.com',0,'2014-01-17 03:35:09',NULL,NULL),(29441,19035,'EM','BECKEYMACOY@GMAIL.COM',0,'2014-01-20 08:06:34',NULL,NULL),(29410,19012,'TE','3189926614',0,'2014-01-20 08:06:21',NULL,NULL),(8101,5304,'EM','eperkins2244@gmail.com',0,'2013-12-25 23:06:23',NULL,NULL),(21594,13896,'TE','4198226386',0,'2013-12-26 13:13:35',NULL,NULL),(7522,4903,'AP','2163102470',0,'2013-12-25 22:31:51',NULL,NULL),(3261,2051,'TE','8302755332',0,'2013-12-25 19:15:52',NULL,NULL),(41554,27629,'TE','5133794184',0,'2014-03-05 21:30:10',NULL,NULL),(41981,27905,'AP','2144358700',0,'2014-03-06 21:00:12',NULL,NULL),(30043,19457,'EM','ndfw1983@yahoo.com',0,'2014-01-23 03:01:55',NULL,NULL),(42910,28535,'TE','9372399211',0,'2014-03-07 21:32:11',NULL,NULL),(43548,28912,'EM','kolarcynthia@yahoo.com',0,'2014-03-10 21:00:28',NULL,NULL),(24811,16006,'AP','9199438950',0,'2014-01-04 02:01:39',NULL,NULL),(10491,6833,'EM','thedalaimama3@hotmail.com',0,'2013-12-26 01:30:52',NULL,NULL),(4771,3055,'AP','3374251835',0,'2013-12-25 20:19:00',NULL,NULL),(4112,2623,'TE','5135612543',0,'2013-12-25 19:45:55',NULL,NULL),(8156,5338,'AP','9372451250',0,'2013-12-25 23:07:17',NULL,NULL),(8063,5281,'AP','3307146599',0,'2013-12-25 23:05:45',NULL,NULL),(35335,23217,'EM','sheenaonisha@gmail.com',0,'2014-02-12 21:32:17',NULL,NULL),(14290,9349,'TE','2252762493',0,'2013-12-26 04:31:11',NULL,NULL),(1050,647,'TE','9372987338',0,'2013-12-25 18:01:31',NULL,NULL),(4805,3073,'TE','2252652586',0,'2013-12-25 20:19:31',NULL,NULL),(1785,1105,'AP','5676744071',0,'2013-12-25 18:17:23',NULL,NULL),(29642,19152,'TE','5672883337',0,'2014-01-21 08:45:36',NULL,NULL),(41259,27420,'TE','5044054528',0,'2014-03-04 21:01:38',NULL,NULL),(41410,27511,'AP','5133150924',0,'2014-03-04 21:02:33',NULL,NULL),(5639,3616,'EM','tool1real26@hotmail.com',0,'2013-12-25 21:23:35',NULL,NULL),(36943,24329,'AP','5126361802',0,'2014-02-18 22:00:13',NULL,NULL),(29348,18964,'TE','8062831743',0,'2014-01-20 08:05:57',NULL,NULL),(34998,22978,'TE','4408582663',0,'2014-02-12 21:30:07',NULL,NULL),(10848,7041,'TE','8172662672',0,'2013-12-26 01:49:26',NULL,NULL),(39376,26041,'EM','K.reagan724@gmail.com',0,'2014-02-26 21:02:27',NULL,NULL),(42830,28487,'AP','5135317666',0,'2014-03-07 21:31:39',NULL,NULL),(6357,4096,'TE','4195313885',0,'2013-12-25 21:47:36',NULL,NULL),(25458,16415,'EM','rfuda@msn.com',0,'2014-01-07 04:04:22',NULL,NULL),(10529,6857,'TE','9375810804',0,'2013-12-26 01:31:34',NULL,NULL),(8772,5749,'AP','5042504397',0,'2013-12-25 23:46:10',NULL,NULL),(14050,9180,'TE','5672598936',0,'2013-12-26 04:09:10',NULL,NULL),(5332,3417,'TE','3188379219',0,'2013-12-25 21:18:32',NULL,NULL),(5812,3733,'AP','9567421745',0,'2013-12-25 21:32:39',NULL,NULL),(30608,19864,'AP','4403097613',0,'2014-01-24 21:00:37',NULL,NULL),(32935,21557,'AP','9376230013',0,'2014-02-05 21:30:17',NULL,NULL),(42885,28520,'AP','4199121061',0,'2014-03-07 21:32:00',NULL,NULL),(733,460,'TE','2146827386',0,'2013-12-25 17:47:36',NULL,NULL),(38464,25420,'TE','2169704658',0,'2014-02-25 21:31:08',NULL,NULL),(35655,23448,'EM','LEECAROLSON@GMAIL.COM',0,'2014-02-13 22:01:36',NULL,NULL),(23961,15460,'TE','2813240430',1,'2014-01-02 04:28:39',NULL,NULL),(32105,20966,'AP','9562369604',0,'2014-02-01 19:00:12',NULL,NULL),(22246,14336,'TE','4198198161',0,'2013-12-27 02:07:45',NULL,NULL),(39612,26201,'AP','3307042647',0,'2014-02-28 06:30:49',NULL,NULL),(6252,4031,'TE','5134690161',0,'2013-12-25 21:45:54',NULL,NULL),(6022,3865,'TE','5042981503',0,'2013-12-25 21:36:04',NULL,NULL),(41654,27690,'TE','2542133197',0,'2014-03-05 21:30:43',NULL,NULL),(21088,13560,'EM','eden.y.liu@gmail.com',0,'2013-12-26 13:04:21',NULL,NULL),(5269,3383,'AP','9794827032',0,'2013-12-25 21:17:35',NULL,NULL),(14651,9583,'AP','7403815419',0,'2013-12-26 04:36:58',NULL,NULL),(11814,7685,'AP','5136331088',0,'2013-12-26 03:00:54',NULL,NULL),(11092,7205,'EM','kbdonaldson1@gmail.com',0,'2013-12-26 02:00:46',NULL,NULL),(1636,1004,'TE','5139425545',0,'2013-12-25 18:11:03',NULL,NULL),(10189,6657,'EM','taytayisme611@hotmail.com',0,'2013-12-26 01:00:46',NULL,NULL),(32548,21279,'EM','kjeziorowski@yahoo.com',0,'2014-02-03 21:01:37',NULL,NULL),(26680,17163,'TE','2257748508',0,'2014-01-13 02:22:03',NULL,NULL),(9114,5972,'AP','6626940593',0,'2013-12-25 23:51:40',NULL,NULL),(30506,19788,'TE','4408645261',0,'2014-01-23 21:01:39',NULL,NULL),(5903,3786,'AP','2163766002',0,'2013-12-25 21:34:07',NULL,NULL),(30013,19435,'AP','2162095601',1,'2014-01-22 03:23:10',NULL,NULL),(20510,13204,'AP','2144504769',0,'2013-12-26 12:55:04',NULL,NULL),(25941,16711,'EM','kbrodwick@gmail.com',0,'2014-01-08 18:24:43',NULL,NULL),(24731,15954,'EM','teenastambaugh@yahoo.com',0,'2014-01-04 02:00:12',NULL,NULL),(36708,24169,'EM','vip5741@comcast.net',0,'2014-02-15 22:02:08',NULL,NULL),(33852,22222,'AP','3302947817',0,'2014-02-09 19:00:27',NULL,NULL),(5679,3647,'TE','4692867636',0,'2013-12-25 21:30:33',NULL,NULL),(39981,26470,'EM','vanelovemykids@hotmail.com',0,'2014-02-28 07:30:37',NULL,NULL),(947,582,'AP','3304026823',0,'2013-12-25 17:50:56',NULL,NULL),(10863,7052,'TE','5134047115',0,'2013-12-26 01:49:43',NULL,NULL),(24332,15717,'AP','2162186997',0,'2014-01-03 02:00:05',NULL,NULL),(21006,13515,'TE','2252702388',0,'2013-12-26 13:03:03',NULL,NULL),(27272,17558,'AP','9562954262',0,'2014-01-13 03:01:59',NULL,NULL),(10893,7077,'EM','kyle06@gmail.com',0,'2013-12-26 01:50:14',NULL,NULL),(12113,7918,'TE','2252095162',0,'2013-12-26 03:06:15',NULL,NULL),(11810,7682,'AP','2162542522',0,'2013-12-26 03:00:50',NULL,NULL),(8579,5639,'EM','lovekwest2@yahoo.com',0,'2013-12-25 23:31:12',NULL,NULL),(24031,15515,'TE','3379816184',1,'2014-01-02 04:30:10',NULL,NULL),(7266,4736,'EM','christiefasick@gmail.com',0,'2013-12-25 22:09:18',NULL,NULL),(23648,15271,'AP','5133447426',1,'2014-01-02 04:21:49',NULL,NULL),(20522,13210,'TE','4095652757',0,'2013-12-26 12:55:14',NULL,NULL),(39203,25927,'AP','8172319129',0,'2014-02-26 21:01:24',NULL,NULL),(40628,26967,'EM','Creativeexpression@outlook.com',0,'2014-03-03 01:00:33',NULL,NULL),(25286,16304,'EM','JIMMIEMILLER9@GMAIL.COM',0,'2014-01-07 04:01:14',NULL,NULL),(7679,5003,'TE','3305237404',0,'2013-12-25 22:47:11',NULL,NULL),(30894,20083,'EM','jesswalker.nola@gmail.com',0,'2014-01-27 21:00:25',NULL,NULL),(14498,9471,'TE','5133516568',0,'2013-12-26 04:34:26',NULL,NULL),(38981,25778,'EM','jvbeverly@yahoo.com',0,'2014-02-26 09:30:59',NULL,NULL),(24801,16000,'AP','9792555310',0,'2014-01-04 02:01:29',NULL,NULL),(22533,14527,'EM','raphaelrko1977@aol.com',0,'2013-12-28 03:34:29',NULL,NULL),(31031,20188,'EM','texasma@icloud.com',0,'2014-01-27 21:01:24',NULL,NULL),(13845,9028,'TE','2162911407',0,'2013-12-26 04:05:30',NULL,NULL),(6348,4091,'AP','6016224220',0,'2013-12-25 21:47:27',NULL,NULL),(20401,13138,'AP','5132053384',0,'2013-12-26 12:53:14',NULL,NULL),(7373,4799,'TE','2253015039',0,'2013-12-25 22:16:27',NULL,NULL),(1553,956,'TE','2164664947',0,'2013-12-25 18:09:40',NULL,NULL),(27099,17431,'AP','3302596064',0,'2014-01-13 03:00:31',NULL,NULL),(37999,25067,'TE','5133004025',0,'2014-02-20 22:01:28',NULL,NULL),(24823,16013,'TE','2252005058',0,'2014-01-04 02:01:53',NULL,NULL),(14072,9199,'AP','4192130417',0,'2013-12-26 04:09:36',NULL,NULL),(22240,14333,'TE','4194236934',0,'2013-12-27 02:07:38',NULL,NULL),(5268,3383,'TE','9797982342',0,'2013-12-25 21:17:34',NULL,NULL),(26913,17312,'TE','7738377128',0,'2014-01-13 02:23:45',NULL,NULL),(24134,15578,'EM','info@marksservice.com',1,'2014-01-02 04:32:07',NULL,NULL),(38081,25138,'AP','8173080458',0,'2014-02-21 22:00:08',NULL,NULL),(34337,22527,'AP','3306063689',0,'2014-02-10 21:31:29',NULL,NULL),(36990,24353,'EM','jwelch2123@gmail.com',0,'2014-02-18 22:00:28',NULL,NULL),(41282,27430,'TE','2253858753',0,'2014-03-04 21:01:46',NULL,NULL),(43587,28942,'TE','3182597706',0,'2014-03-10 21:00:44',NULL,NULL),(8233,5387,'TE','3372789931',0,'2013-12-25 23:08:33',NULL,NULL),(3333,2096,'TE','3302062344',0,'2013-12-25 19:17:02',NULL,NULL),(10028,6560,'TE','8173719806',0,'2013-12-26 00:52:25',NULL,NULL),(21430,13777,'EM','jdscallions@cableone.net',0,'2013-12-26 13:10:40',NULL,NULL),(14077,9202,'TE','9373393461',0,'2013-12-26 04:09:42',NULL,NULL),(4906,3151,'TE','5129300350',0,'2013-12-25 20:31:02',NULL,NULL),(7256,4731,'TE','4192386281',0,'2013-12-25 22:09:10',NULL,NULL),(28634,18462,'TE','2254445551',0,'2014-01-16 08:46:13',NULL,NULL),(3460,2165,'TE','3306035837',0,'2013-12-25 19:19:02',NULL,NULL),(5215,3353,'TE','9035928490',0,'2013-12-25 21:16:46',NULL,NULL),(33170,21724,'TE','9034752006',0,'2014-02-06 21:00:05',NULL,NULL),(40650,26987,'TE','4199570822',0,'2014-03-03 01:00:40',NULL,NULL),(40917,27189,'AP','9563138844',0,'2014-03-03 21:31:15',NULL,NULL),(42585,28335,'TE','2107241040',0,'2014-03-07 21:30:13',NULL,NULL),(1705,1047,'TE','2813820620',0,'2013-12-25 18:15:56',NULL,NULL),(1822,1129,'TE','9566850241',0,'2013-12-25 18:18:00',NULL,NULL),(35205,23124,'TE','6142714204',0,'2014-02-12 21:31:25',NULL,NULL),(35038,23012,'EM','mdecker@lemoineinsurance.com',0,'2014-02-12 21:30:24',NULL,NULL),(33351,21848,'EM','nina.ater@icloud.com',0,'2014-02-06 21:01:14',NULL,NULL),(32958,21576,'TE','3304315879',0,'2014-02-05 21:30:23',NULL,NULL),(24127,15574,'TE','3304165910',1,'2014-01-02 04:32:00',NULL,NULL),(4874,3120,'TE','9199320642',0,'2013-12-25 20:30:16',NULL,NULL),(23208,14955,'TE','8503217338',0,'2014-01-01 12:00:20',NULL,NULL),(20947,13472,'AP','5138464187',0,'2013-12-26 13:02:03',NULL,NULL),(4245,2716,'AP','9855023072',0,'2013-12-25 19:48:05',NULL,NULL),(10602,6900,'EM','karencormier17@yahoo.com',0,'2013-12-26 01:45:36',NULL,NULL),(3297,2075,'TE','2253558121',0,'2013-12-25 19:16:28',NULL,NULL),(9204,6022,'EM','Christy.uribe@gmail.com',0,'2013-12-26 00:00:54',NULL,NULL),(32448,21202,'TE','5043433409',0,'2014-02-03 21:00:54',NULL,NULL),(30272,19613,'EM','cross4_me@yahoo.com',0,'2014-01-23 03:02:51',NULL,NULL),(21092,13563,'AP','5045200178',0,'2013-12-26 13:04:25',NULL,NULL),(21286,13677,'TE','3306677203',0,'2013-12-26 13:08:05',NULL,NULL),(42666,28383,'AP','3302831628',0,'2014-03-07 21:30:41',NULL,NULL),(43781,29062,'AP','4193205074',0,'2014-03-10 21:01:53',NULL,NULL),(34511,22637,'TE','8172049982',0,'2014-02-11 21:00:21',NULL,NULL),(6191,3990,'TE','4198610612',0,'2013-12-25 21:39:04',NULL,NULL),(22767,14680,'TE','6622951864',1,'2013-12-29 11:08:32',NULL,NULL),(23946,15450,'AP','5126563999',1,'2014-01-02 04:28:21',NULL,NULL),(27117,17457,'TE','5672270477',0,'2014-01-13 03:00:40',NULL,NULL),(29065,18769,'AP','4795309085',0,'2014-01-17 03:35:49',NULL,NULL),(29519,19082,'TE','5135208049',0,'2014-01-21 08:44:27',NULL,NULL),(43844,29098,'TE','5138509669',0,'2014-03-10 21:02:15',NULL,NULL),(31452,20500,'AP','9852373004',0,'2014-01-29 21:01:12',NULL,NULL),(42000,27913,'BN','2146743541',0,'2014-03-06 21:00:17',NULL,NULL),(43232,28726,'EM','alp7069@yahoo.com',0,'2014-03-09 21:00:00',NULL,NULL),(135,82,'TE','3306099029',0,'2013-12-25 17:17:10',NULL,NULL),(38299,25289,'AP','4406100829',0,'2014-02-25 21:00:22',NULL,NULL),(234,142,'EM','kkny51@aol.com',0,'2013-12-25 17:18:44',NULL,NULL),(6808,4417,'TE','4407482443',0,'2013-12-25 22:01:31',NULL,NULL),(6490,4199,'AP','4404761494',0,'2013-12-25 21:49:50',NULL,NULL),(29592,19122,'TE','5673712549',0,'2014-01-21 08:45:18',NULL,NULL),(2857,1744,'EM','robert.c.ivory@gmail.com',0,'2013-12-25 18:55:36',NULL,NULL),(14814,9697,'EM','boffette@fuse.net',0,'2013-12-26 04:39:53',NULL,NULL),(23265,14990,'TE','9032676640',0,'2014-01-01 12:01:24',NULL,NULL),(24843,16024,'TE','5046068936',0,'2014-01-04 02:02:15',NULL,NULL),(40634,26971,'TE','7137033300',0,'2014-03-03 01:00:35',NULL,NULL),(1281,779,'AP','9153075047',0,'2013-12-25 18:05:01',NULL,NULL),(34710,22757,'EM','jrileyturner4@yahoo.com',0,'2014-02-11 21:01:30',NULL,NULL),(14783,9673,'TE','5412171070',0,'2013-12-26 04:39:18',NULL,NULL),(20544,13225,'TE','2148743163',0,'2013-12-26 12:55:35',NULL,NULL),(24486,15799,'TE','2063558058',0,'2014-01-03 02:02:48',NULL,NULL),(27722,17869,'TE','9374848473',0,'2014-01-15 02:06:13',NULL,NULL),(25662,16546,'AP','3309490411',1,'2014-01-07 10:22:33',NULL,NULL),(43359,28798,'AP','3306344893',0,'2014-03-09 21:00:47',NULL,NULL),(33933,22269,'AP','4322229478',0,'2014-02-10 11:00:13',NULL,NULL),(11141,7244,'TE','5044524308',0,'2013-12-26 02:01:44',NULL,NULL),(10500,6839,'EM','jcox005@gmail.com',0,'2013-12-26 01:31:02',NULL,NULL),(31502,20527,'TE','4192064884',0,'2014-01-29 21:01:28',NULL,NULL),(23093,14892,'EM','Khm3rCandie@yahoo.com',0,'2013-12-30 00:00:51',NULL,NULL),(23295,15011,'EM','shaun2240@neo.rr.com',0,'2014-01-01 12:02:01',NULL,NULL),(28958,18691,'AP','2256109389',0,'2014-01-17 03:35:24',NULL,NULL),(28782,18573,'TE','3303100924',0,'2014-01-16 08:47:05',NULL,NULL),(28695,18518,'TE','4692747208',0,'2014-01-16 08:46:36',NULL,NULL),(38912,25723,'AP','5046550183',0,'2014-02-26 09:30:30',NULL,NULL),(41694,27725,'AP','9155405370',0,'2014-03-05 21:31:01',NULL,NULL),(41845,27822,'EM','mrhobbs25@yahoo.com',0,'2014-03-05 21:31:56',NULL,NULL),(32311,21109,'TE','2252403240',0,'2014-02-03 21:00:06',NULL,NULL),(26842,17269,'TE','3306451202',0,'2014-01-13 02:23:21',NULL,NULL),(6245,4024,'AP','2163467778',0,'2013-12-25 21:45:45',NULL,NULL),(24265,15682,'AP','4197695582',1,'2014-01-02 04:35:01',NULL,NULL),(8818,5775,'AP','6145788309',0,'2013-12-25 23:46:54',NULL,NULL),(849,528,'TE','3306282211',0,'2013-12-25 17:49:22',NULL,NULL),(11151,7251,'AP','2253970714',0,'2013-12-26 02:01:56',NULL,NULL),(14168,9271,'TE','5134057986',0,'2013-12-26 04:15:40',NULL,NULL),(8095,5297,'EM','lrusch@bright.net',0,'2013-12-25 23:06:13',NULL,NULL),(24428,15771,'TE','9562929807',0,'2014-01-03 02:01:49',NULL,NULL),(32439,21195,'TE','6017980208',0,'2014-02-03 21:00:50',NULL,NULL),(30785,20017,'AP','8304830838',0,'2014-01-26 19:00:12',NULL,NULL),(30198,19563,'AP','3187302646',0,'2014-01-23 03:02:34',NULL,NULL),(41587,27649,'TE','9372384989',0,'2014-03-05 21:30:21',NULL,NULL),(42789,28458,'TE','5047018964',0,'2014-03-07 21:31:24',NULL,NULL),(996,613,'AP','3304316411',0,'2013-12-25 18:00:38',NULL,NULL),(26572,17092,'EM','edoarre@eol.com',0,'2014-01-13 02:21:28',NULL,NULL),(33507,21960,'AP','7409011361',0,'2014-02-07 19:00:25',NULL,NULL),(10596,6895,'EM','chazk.cooper@gmail.com',0,'2013-12-26 01:45:29',NULL,NULL),(7745,5057,'TE','9048910808',0,'2013-12-25 23:00:20',NULL,NULL),(28800,18587,'TE','5136331088',0,'2014-01-16 08:47:12',NULL,NULL),(29216,18872,'AP','2259162490',0,'2014-01-17 03:36:24',NULL,NULL),(29522,19083,'TE','4197639068',0,'2014-01-21 08:44:28',NULL,NULL),(30202,19564,'BN','3187792546',0,'2014-01-23 03:02:34',NULL,NULL),(30291,19624,'AP','6146008580',0,'2014-01-23 21:00:05',NULL,NULL),(2202,1352,'AP','8063301473',0,'2013-12-25 18:45:18',NULL,NULL),(37746,24904,'EM','bevillglenna@yahoo.com',0,'2014-02-20 21:30:04',NULL,NULL),(22985,14825,'EM','ajparent87@gmail.com',1,'2013-12-29 11:14:26',NULL,NULL),(21684,13961,'EM','udhoops@yahoo.com',0,'2013-12-26 13:15:09',NULL,NULL),(28757,18558,'TE','5138018179',0,'2014-01-16 08:46:57',NULL,NULL),(5749,3685,'TE','5133894293',0,'2013-12-25 21:31:34',NULL,NULL),(26625,17131,'AP','9518706604',0,'2014-01-13 02:21:47',NULL,NULL),(30299,19628,'TE','3303307675',0,'2014-01-23 21:00:08',NULL,NULL),(31801,20760,'TE','4196027888',0,'2014-01-30 21:01:34',NULL,NULL),(12399,8120,'TE','9377370039',0,'2013-12-26 03:15:15',NULL,NULL),(41998,27913,'TE','2146743541',0,'2014-03-06 21:00:17',NULL,NULL),(42604,28344,'TE','9156949749',0,'2014-03-07 21:30:19',NULL,NULL),(43596,28945,'EM','reinauerm@yahoo.com',0,'2014-03-10 21:00:46',NULL,NULL),(8340,5470,'EM','arif_zafar58@hotmail.com',0,'2013-12-25 23:10:39',NULL,NULL),(25091,16177,'TE','3186230120',0,'2014-01-05 00:00:25',NULL,NULL),(13605,8868,'TE','2148090636',0,'2013-12-26 04:01:29',NULL,NULL),(37835,24963,'EM','LACISHAY62967@GMAIL.COM',0,'2014-02-20 22:00:21',NULL,NULL),(8417,5542,'TE','6018769564',0,'2013-12-25 23:15:51',NULL,NULL),(9636,6305,'AP','4192100842',0,'2013-12-26 00:46:02',NULL,NULL),(39920,26417,'EM','demetrarobertson@yahoo.com',0,'2014-02-28 07:30:05',NULL,NULL),(40166,26639,'AP','9154330420',0,'2014-02-28 21:31:02',NULL,NULL),(40309,26740,'EM','OUSLEYC@YMAIL.COM',0,'2014-02-28 21:31:54',NULL,NULL),(43567,28933,'AP','2162724458',0,'2014-03-10 21:00:38',NULL,NULL),(34654,22723,'TE','9853866391',0,'2014-02-11 21:01:11',NULL,NULL),(27602,17794,'EM','dougwoods.martialartsky@hotmail.com',0,'2014-01-14 01:33:50',NULL,NULL),(25760,16599,'AP','2258107760',0,'2014-01-08 18:24:04',NULL,NULL),(24603,15866,'AP','6014668084',0,'2014-01-03 02:04:57',NULL,NULL),(8483,5580,'EM','rburkett1@windstream.net',0,'2013-12-25 23:16:56',NULL,NULL),(39091,25864,'TE','2254506636',0,'2014-02-26 21:00:47',NULL,NULL),(41932,27877,'TE','4195163389',0,'2014-03-05 21:32:30',NULL,NULL),(43785,29064,'TE','4192830969',0,'2014-03-10 21:01:54',NULL,NULL),(5803,3725,'EM','vorheesmark@yahoo.com',0,'2013-12-25 21:32:28',NULL,NULL),(1150,707,'AP','5038161502',0,'2013-12-25 18:03:05',NULL,NULL),(39117,25876,'AP','5042749069',0,'2014-02-26 21:00:54',NULL,NULL),(11018,7152,'EM','johnna@zoominternet.net',0,'2013-12-26 01:52:14',NULL,NULL),(26099,16807,'TE','2542474459',0,'2014-01-13 02:18:14',NULL,NULL),(25778,16612,'TE','2163702690',0,'2014-01-08 18:24:08',NULL,NULL),(4169,2664,'TE','5136738802',0,'2013-12-25 19:46:54',NULL,NULL),(38105,25152,'BN','9156944276',0,'2014-02-21 22:00:17',NULL,NULL),(8406,5532,'AP','9373673226',0,'2013-12-25 23:15:37',NULL,NULL),(33169,21723,'BN','3373083217',0,'2014-02-06 21:00:05',NULL,NULL),(24208,15637,'EM','matoyasherman@gmail.com',1,'2014-01-02 04:33:42',NULL,NULL),(40812,27120,'TE','4404742334',0,'2014-03-03 21:30:33',NULL,NULL),(24114,15566,'EM','tpilz3642@gmail.com',1,'2014-01-02 04:31:45',NULL,NULL),(21077,13554,'AP','5043454422',0,'2013-12-26 13:04:11',NULL,NULL),(28715,18528,'EM','TecDrafting@hotmail.com',0,'2014-01-16 08:46:42',NULL,NULL),(36509,24038,'AP','4403195585',0,'2014-02-15 22:00:56',NULL,NULL),(32190,21025,'AP','2288615804',0,'2014-02-01 19:00:42',NULL,NULL),(32418,21183,'TE','6018421908',0,'2014-02-03 21:00:44',NULL,NULL),(35739,23504,'EM','pdvest@yahoo.com',0,'2014-02-13 22:02:10',NULL,NULL),(461,291,'TE','3184584340',0,'2013-12-25 17:30:32',NULL,NULL),(4088,2607,'AP','5137910594',0,'2013-12-25 19:45:30',NULL,NULL),(5814,3734,'TE','8064742480',0,'2013-12-25 21:32:41',NULL,NULL),(26441,17016,'TE','3309587662',0,'2014-01-13 02:20:38',NULL,NULL),(4846,3100,'AP','9374149931',0,'2013-12-25 20:20:16',NULL,NULL),(25492,16434,'EM','VSPOOKEY@AOL.COM',0,'2014-01-07 04:04:57',NULL,NULL),(41143,27327,'AP','9564587913',0,'2014-03-04 21:00:50',NULL,NULL),(42297,28086,'EM','m20031958@yahoo.com',0,'2014-03-06 21:02:01',NULL,NULL),(43361,28799,'EM','jpr2500@windstream.net',0,'2014-03-09 21:00:47',NULL,NULL),(38355,25336,'TE','3187944861',0,'2014-02-25 21:30:22',NULL,NULL),(35640,23436,'AP','8067908627',0,'2014-02-13 22:01:30',NULL,NULL),(23319,15025,'AP','3188346655',0,'2014-01-01 12:02:27',NULL,NULL),(20412,13144,'AP','9176237951',0,'2013-12-26 12:53:25',NULL,NULL),(14329,9368,'TE','2253549139',0,'2013-12-26 04:31:45',NULL,NULL),(35111,23063,'AP','5043882001',0,'2014-02-12 21:30:52',NULL,NULL),(6260,4037,'AP','6145657735',0,'2013-12-25 21:46:03',NULL,NULL),(9256,6056,'EM','ike_carr@yahoo.com',0,'2013-12-26 00:01:50',NULL,NULL),(30150,19535,'EM','intrblt@aol.com',0,'2014-01-23 03:02:22',NULL,NULL),(30667,19914,'AP','9729041696',0,'2014-01-24 21:01:02',NULL,NULL),(40864,27154,'AP','5135785333',0,'2014-03-03 21:30:54',NULL,NULL),(30548,19818,'TE','9565685786',0,'2014-01-24 21:00:13',NULL,NULL),(13640,8893,'AP','5125545755',0,'2013-12-26 04:02:05',NULL,NULL),(30723,19961,'EM','lisalisa18@att.net',0,'2014-01-25 19:00:07',NULL,NULL),(8019,5241,'TE','3306504165',0,'2013-12-25 23:04:55',NULL,NULL),(3222,2026,'TE','4407247921',0,'2013-12-25 19:15:13',NULL,NULL),(20827,13387,'TE','5133304247',0,'2013-12-26 13:00:03',NULL,NULL),(24730,15954,'TE','7405902994',0,'2014-01-04 02:00:11',NULL,NULL),(40636,26971,'EM','mgcraft1@gmail.com',0,'2014-03-03 01:00:35',NULL,NULL),(11063,7186,'EM','raduncan@ymail.com',0,'2013-12-26 02:00:18',NULL,NULL),(39018,25801,'TE','5132233055',0,'2014-02-26 21:00:17',NULL,NULL),(38417,25382,'EM','mathewfeller@msn.com',0,'2014-02-25 21:30:47',NULL,NULL),(11309,7370,'TE','5132829856',0,'2013-12-26 02:15:39',NULL,NULL),(26275,16911,'TE','4403208269',0,'2014-01-13 02:19:38',NULL,NULL),(5769,3696,'TE','4408853097',0,'2013-12-25 21:31:51',NULL,NULL),(31632,20634,'TE','2814467022',0,'2014-01-30 21:00:30',NULL,NULL),(8375,5507,'TE','2547292769',0,'2013-12-25 23:15:04',NULL,NULL),(6536,4227,'TE','2108150175',0,'2013-12-25 21:50:36',NULL,NULL),(7665,4989,'TE','5132232603',0,'2013-12-25 22:46:55',NULL,NULL),(14766,9659,'AP','9373367705',0,'2013-12-26 04:38:57',NULL,NULL),(2003,1240,'TE','5042510186',0,'2013-12-25 18:20:55',NULL,NULL),(9631,6303,'TE','9375264412',0,'2013-12-26 00:45:58',NULL,NULL),(11744,7643,'EM','estridgemd@gmail.com',0,'2013-12-26 02:46:39',NULL,NULL),(21847,14072,'TE','5135456781',0,'2013-12-27 02:00:54',NULL,NULL),(36460,24008,'TE','4402429019',0,'2014-02-15 22:00:38',NULL,NULL),(37488,24686,'AP','3612930628',0,'2014-02-20 04:31:41',NULL,NULL),(41322,27452,'EM','cfmommy96@gmail.com',0,'2014-03-04 21:01:59',NULL,NULL),(39036,25813,'TE','3302076728',0,'2014-02-26 21:00:23',NULL,NULL),(6560,4237,'TE','9039398813',0,'2013-12-25 21:50:54',NULL,NULL),(38784,25639,'EM','kckw14@yahoo.com',0,'2014-02-26 08:30:30',NULL,NULL),(14279,9341,'AP','3188015432',0,'2013-12-26 04:31:00',NULL,NULL),(34619,22699,'TE','2547283316',0,'2014-02-11 21:00:57',NULL,NULL),(24090,15551,'AP','2253948589',1,'2014-01-02 04:31:18',NULL,NULL),(33190,21734,'AP','9404528456',0,'2014-02-06 21:00:12',NULL,NULL),(31856,20798,'TE','9728247505',0,'2014-01-31 21:00:19',NULL,NULL),(31764,20732,'TE','4409430736',0,'2014-01-30 21:01:19',NULL,NULL),(41541,27623,'TE','5048007767',0,'2014-03-05 21:30:05',NULL,NULL),(25973,16729,'TE','3307019455',0,'2014-01-08 18:24:49',NULL,NULL),(10418,6793,'TE','9404682141',0,'2013-12-26 01:17:09',NULL,NULL),(25611,16519,'EM','MARJOHOUSEORG@AOL.COM',1,'2014-01-07 10:21:39',NULL,NULL),(23358,15047,'TE','2257611166',0,'2014-01-01 12:03:09',NULL,NULL),(914,564,'TE','4199081983',0,'2013-12-25 17:50:25',NULL,NULL),(22981,14824,'AP','9725676116',1,'2013-12-29 11:14:23',NULL,NULL),(1514,932,'AP','5137876524',0,'2013-12-25 18:09:07',NULL,NULL),(5141,3295,'AP','9546106909',0,'2013-12-25 21:15:35',NULL,NULL),(4926,3163,'TE','9372529003',0,'2013-12-25 20:31:22',NULL,NULL),(21444,13785,'TE','6016482640',0,'2013-12-26 13:10:52',NULL,NULL),(14232,9311,'AP','2253232958',0,'2013-12-26 04:30:16',NULL,NULL),(14450,9441,'AP','7408166783',0,'2013-12-26 04:33:42',NULL,NULL),(42513,28275,'AP','3305501589',0,'2014-03-07 21:00:23',NULL,NULL),(4250,2719,'AP','3379128949',0,'2013-12-25 19:48:09',NULL,NULL),(34116,22367,'TE','9852100420',0,'2014-02-10 21:00:11',NULL,NULL),(28414,18307,'AP','2163762795',0,'2014-01-16 08:45:00',NULL,NULL),(28081,18097,'TE','3183870929',0,'2014-01-15 02:07:33',NULL,NULL),(41199,27364,'TE','3309209736',0,'2014-03-04 21:01:13',NULL,NULL),(40202,26666,'TE','3182654017',0,'2014-02-28 21:31:15',NULL,NULL),(34921,22914,'EM','yelhsa036@gmail.com',0,'2014-02-11 21:02:50',NULL,NULL),(11113,7228,'AP','3304421529',0,'2013-12-26 02:01:18',NULL,NULL),(29905,19353,'AP','2166452261',1,'2014-01-22 03:22:27',NULL,NULL),(40455,26856,'AP','9372170522',0,'2014-03-01 21:00:54',NULL,NULL),(30351,19666,'TE','9858693408',0,'2014-01-23 21:00:28',NULL,NULL),(11785,7667,'TE','2257719987',0,'2013-12-26 03:00:27',NULL,NULL),(6835,4435,'TE','7403142472',0,'2013-12-25 22:02:00',NULL,NULL),(24939,16076,'AP','9373691492',0,'2014-01-04 02:03:57',NULL,NULL),(24029,15514,'AP','8175287709',1,'2014-01-02 04:30:08',NULL,NULL),(7878,5137,'TE','5127747804',0,'2013-12-25 23:02:24',NULL,NULL),(12464,8160,'TE','4196193003',0,'2013-12-26 03:16:20',NULL,NULL),(21822,14059,'TE','5135714067',0,'2013-12-27 02:00:31',NULL,NULL),(41542,27623,'AP','5048007767',0,'2014-03-05 21:30:05',NULL,NULL),(41953,27888,'AP','3305023393',0,'2014-03-05 21:32:37',NULL,NULL),(42296,28086,'AP','2146005591',0,'2014-03-06 21:02:01',NULL,NULL),(43386,28813,'AP','3308825478',0,'2014-03-09 21:00:56',NULL,NULL),(333,209,'TE','2257563550',0,'2013-12-25 17:20:25',NULL,NULL),(37022,24376,'TE','4194385104',0,'2014-02-18 22:00:41',NULL,NULL),(29644,19154,'TE','4403449475',0,'2014-01-21 08:45:37',NULL,NULL),(29568,19106,'TE','9852319369',0,'2014-01-21 08:44:41',NULL,NULL),(26618,17126,'TE','4405212842',0,'2014-01-13 02:21:44',NULL,NULL),(23944,15449,'TE','9405073176',1,'2014-01-02 04:28:19',NULL,NULL),(9907,6484,'EM','kbarriba@gmail.com',0,'2013-12-26 00:50:24',NULL,NULL),(3266,2054,'EM','Katie.Schneeberger@gmail.com',0,'2013-12-25 19:15:57',NULL,NULL),(13752,8964,'TE','8039799793',0,'2013-12-26 04:03:55',NULL,NULL),(2473,1516,'EM','foureor@gmail.com',0,'2013-12-25 18:49:41',NULL,NULL),(3479,2179,'EM','JLGDLG639@MSN.COM',0,'2013-12-25 19:19:21',NULL,NULL),(36235,23848,'TE','4195812935',0,'2014-02-14 21:31:57',NULL,NULL),(8632,5669,'TE','9373769083',0,'2013-12-25 23:32:01',NULL,NULL),(7606,4954,'TE','5044940674',0,'2013-12-25 22:46:00',NULL,NULL),(34812,22834,'TE','3302676004',0,'2014-02-11 21:02:09',NULL,NULL),(34660,22725,'AP','5047151862',0,'2014-02-11 21:01:12',NULL,NULL),(26144,16829,'EM','rusty7192@hotmail.com',0,'2014-01-13 02:18:28',NULL,NULL),(33377,21869,'AP','5042067550',0,'2014-02-06 21:01:25',NULL,NULL),(30102,19499,'EM','cbssupply@live.com',0,'2014-01-23 03:02:10',NULL,NULL),(30367,19674,'TE','4692658042',0,'2014-01-23 21:00:34',NULL,NULL),(33161,21720,'AP','5136525637',0,'2014-02-05 21:31:19',NULL,NULL),(43211,28714,'EM','katied01@hotmail.com',0,'2014-03-08 21:31:17',NULL,NULL),(38860,25685,'AP','6014542281',0,'2014-02-26 09:30:08',NULL,NULL),(10670,6933,'TE','2163702073',0,'2013-12-26 01:46:35',NULL,NULL),(607,375,'TE','2147275782',0,'2013-12-25 17:45:33',NULL,NULL),(3831,2437,'EM','heatherlee927@yahoo.com',0,'2013-12-25 19:34:20',NULL,NULL),(28122,18127,'TE','5136710022',0,'2014-01-15 02:07:42',NULL,NULL),(27860,17950,'TE','3616767371',0,'2014-01-15 02:06:42',NULL,NULL),(5512,3526,'EM','nate.shockey@gmail.com',0,'2013-12-25 21:21:24',NULL,NULL),(27721,17868,'TE','3307334943',0,'2014-01-15 02:06:13',NULL,NULL),(23919,15433,'TE','9404451494',1,'2014-01-02 04:27:48',NULL,NULL),(42877,28514,'EM','aryancunningham@gmail.com',0,'2014-03-07 21:31:56',NULL,NULL),(67,43,'AP','5134044660',0,'2013-12-25 17:16:08',NULL,NULL),(35268,23161,'AP','9034526391',0,'2014-02-12 21:31:47',NULL,NULL),(99,58,'TE','5174905840',0,'2013-12-25 17:16:35',NULL,NULL),(32050,20921,'EM','milesb69@yahoo.com',0,'2014-01-31 21:01:33',NULL,NULL),(1425,868,'TE','3303127825',0,'2013-12-25 18:07:23',NULL,NULL),(30389,19690,'EM','tanya_baker68@icloud.com',0,'2014-01-23 21:00:42',NULL,NULL),(29963,19388,'TE','3304799394',1,'2014-01-22 03:22:46',NULL,NULL),(27733,17881,'TE','4405704809',0,'2014-01-15 02:06:16',NULL,NULL),(41535,27620,'AP','5042370130',0,'2014-03-05 21:30:03',NULL,NULL),(36504,24033,'EM','AFFORDABLEPAINTT@AOL.COM',0,'2014-02-15 22:00:54',NULL,NULL),(34903,22903,'AP','4195836021',0,'2014-02-11 21:02:43',NULL,NULL),(34225,22449,'TE','8175623857',0,'2014-02-10 21:30:45',NULL,NULL),(31122,20267,'EM','DEBLACKSTONE@HOTMAIL.COM',0,'2014-01-28 21:00:21',NULL,NULL),(6934,4518,'TE','2145078737',0,'2013-12-25 22:03:46',NULL,NULL),(3183,1998,'AP','8176816774',0,'2013-12-25 19:02:08',NULL,NULL),(22312,14383,'EM','ericamdavis09@gmail.com',0,'2013-12-28 03:30:49',NULL,NULL),(22417,14456,'EM','downdaroad82@yahoo.com',0,'2013-12-28 03:32:38',NULL,NULL),(26291,16923,'TE','5047561151',0,'2014-01-13 02:19:45',NULL,NULL),(1201,731,'EM','chrisdealglass@gmail.com',0,'2013-12-25 18:03:49',NULL,NULL),(13621,8879,'EM','dora7708@sbcglobal.net',0,'2013-12-26 04:01:45',NULL,NULL),(33203,21743,'TE','9154229282',0,'2014-02-06 21:00:16',NULL,NULL),(32613,21324,'TE','5042202148',0,'2014-02-04 21:00:24',NULL,NULL),(30110,19505,'TE','2145806474',0,'2014-01-23 03:02:12',NULL,NULL),(23063,14876,'TE','9033125496',0,'2013-12-30 00:00:21',NULL,NULL),(43644,28969,'TE','3376543928',0,'2014-03-10 21:01:01',NULL,NULL),(40835,27135,'AP','7403901621',0,'2014-03-03 21:30:43',NULL,NULL),(36947,24333,'AP','8328185112',0,'2014-02-18 22:00:14',NULL,NULL),(3107,1939,'TE','2169038772',0,'2013-12-25 19:00:36',NULL,NULL),(14484,9457,'EM','snowykiitten@gmail.com',0,'2013-12-26 04:34:09',NULL,NULL),(14961,9789,'AP','2169252243',0,'2013-12-26 05:00:55',NULL,NULL),(21925,14125,'TE','3187941744',0,'2013-12-27 02:02:14',NULL,NULL),(31200,20318,'TE','4074083818',0,'2014-01-28 21:00:54',NULL,NULL),(24585,15857,'AP','3302127618',0,'2014-01-03 02:04:38',NULL,NULL),(30576,19839,'TE','3184981478',0,'2014-01-24 21:00:24',NULL,NULL),(41663,27695,'AP','9564339035',0,'2014-03-05 21:30:46',NULL,NULL),(41611,27664,'EM','wagnerlowell@gmail.com',0,'2014-03-05 21:30:29',NULL,NULL),(36313,23911,'TE','9372152915',0,'2014-02-14 21:32:29',NULL,NULL),(12444,8152,'TE','7138549555',0,'2013-12-26 03:16:04',NULL,NULL),(11840,7704,'TE','9372437034',0,'2013-12-26 03:01:20',NULL,NULL),(33099,21680,'EM','jeffkellerman@hotmail.com',0,'2014-02-05 21:31:02',NULL,NULL),(11415,7426,'EM','omar1369@aol.com',0,'2013-12-26 02:17:13',NULL,NULL),(30184,19555,'TE','9852592732',0,'2014-01-23 03:02:31',NULL,NULL),(14449,9441,'TE','7408166783',0,'2013-12-26 04:33:42',NULL,NULL),(26024,16767,'EM','sdavis_acct@yahoo.com',0,'2014-01-08 18:25:00',NULL,NULL),(42971,28576,'TE','5126600262',0,'2014-03-08 21:00:04',NULL,NULL),(6018,3863,'AP','3185475596',0,'2013-12-25 21:36:00',NULL,NULL),(1230,749,'EM','ouday_aljabbari@yahoo.com',0,'2013-12-25 18:04:15',NULL,NULL),(23571,15218,'AP','3187737356',0,'2014-01-01 12:07:55',NULL,NULL),(10830,7033,'AP','2145878437',0,'2013-12-26 01:49:11',NULL,NULL),(5457,3493,'EM','ronyer@aol.com',0,'2013-12-25 21:20:31',NULL,NULL),(22182,14289,'TE','4193683463',0,'2013-12-27 02:06:32',NULL,NULL),(42178,28017,'TE','6148666523',0,'2014-03-06 21:01:19',NULL,NULL),(26226,16880,'TE','7135263780',0,'2014-01-13 02:19:21',NULL,NULL),(26176,16852,'AP','5135059445',0,'2014-01-13 02:18:41',NULL,NULL),(33145,21710,'TE','5137247077',0,'2014-02-05 21:31:15',NULL,NULL),(32438,21194,'AP','6013476356',0,'2014-02-03 21:00:50',NULL,NULL),(8752,5737,'EM','bennyminden@yahoo.com',0,'2013-12-25 23:45:51',NULL,NULL),(2627,1597,'EM','mary.mcgee123@gmail.com',0,'2013-12-25 18:51:57',NULL,NULL),(31351,20429,'EM','nrn5@roadrunner.com',0,'2014-01-29 21:00:34',NULL,NULL),(31299,20394,'AP','8322774511',0,'2014-01-29 21:00:17',NULL,NULL),(7102,4635,'AP','6622300938',0,'2013-12-25 22:06:38',NULL,NULL),(29879,19336,'TE','5592698817',1,'2014-01-22 03:22:18',NULL,NULL),(26724,17188,'TE','2103914478',0,'2014-01-13 02:22:17',NULL,NULL),(25413,16392,'EM','idr8501@aol.com',0,'2014-01-07 04:03:37',NULL,NULL),(2761,1675,'TE','5138056950',0,'2013-12-25 18:53:58',NULL,NULL),(9079,5953,'AP','6012099814',0,'2013-12-25 23:51:08',NULL,NULL),(42896,28527,'AP','3303076531',0,'2014-03-07 21:32:05',NULL,NULL),(9785,6402,'EM','garysuniverse@comcast.net',0,'2013-12-26 00:48:23',NULL,NULL),(2986,1849,'TE','3308825402',0,'2013-12-25 18:57:51',NULL,NULL),(22305,14377,'TE','6143028359',0,'2013-12-28 03:30:42',NULL,NULL),(24312,15704,'EM','juliepies22@gmail.com',1,'2014-01-02 04:35:52',NULL,NULL),(41362,27479,'TE','2542262194',0,'2014-03-04 21:02:16',NULL,NULL),(31045,20196,'AP','9013830928',0,'2014-01-27 21:01:30',NULL,NULL),(32259,21071,'TE','4406687290',0,'2014-02-02 19:00:17',NULL,NULL),(32821,21476,'AP','5138076618',0,'2014-02-04 21:01:40',NULL,NULL),(36310,23906,'EM','rebecca44883@yahoo.com',0,'2014-02-14 21:32:27',NULL,NULL),(33215,21751,'AP','4693146714',0,'2014-02-06 21:00:21',NULL,NULL),(29922,19365,'AP','3305736946',1,'2014-01-22 03:22:33',NULL,NULL),(27681,17842,'AP','5135265768',0,'2014-01-15 02:06:04',NULL,NULL),(27186,17504,'AP','4404630105',0,'2014-01-13 03:01:27',NULL,NULL),(43757,29049,'TE','9706902735',0,'2014-03-10 21:01:45',NULL,NULL),(9529,6237,'AP','8065354909',0,'2013-12-26 00:31:36',NULL,NULL),(6968,4544,'TE','9728396831',0,'2013-12-25 22:04:22',NULL,NULL),(28877,18644,'EM','JEverett1113@gmail.com',0,'2014-01-17 03:35:07',NULL,NULL),(2995,1853,'TE','5133676597',0,'2013-12-25 18:57:59',NULL,NULL),(3824,2432,'TE','3306285966',0,'2013-12-25 19:34:13',NULL,NULL),(1513,932,'TE','5137876524',0,'2013-12-25 18:09:06',NULL,NULL),(6507,4206,'TE','9567026494',0,'2013-12-25 21:50:03',NULL,NULL),(9959,6518,'TE','5138506072',0,'2013-12-26 00:51:19',NULL,NULL),(42644,28368,'TE','2149147899',0,'2014-03-07 21:30:33',NULL,NULL),(38685,25567,'TE','3303472037',0,'2014-02-26 08:00:27',NULL,NULL),(22469,14488,'EM','kcheatham@zoho.com',0,'2013-12-28 03:33:28',NULL,NULL),(24639,15888,'TE','5136730657',0,'2014-01-03 02:05:39',NULL,NULL),(34996,22977,'TE','4405415076',0,'2014-02-12 21:30:06',NULL,NULL),(33605,22036,'EM','beyoung@core.com',0,'2014-02-07 19:01:06',NULL,NULL),(33469,21926,'AP','8325676258',0,'2014-02-07 19:00:09',NULL,NULL),(43102,28653,'AP','7408046051',0,'2014-03-08 21:30:39',NULL,NULL),(42536,28298,'EM','paul.morris@ccuniversity.edu',0,'2014-03-07 21:00:31',NULL,NULL),(40543,26908,'TE','3375195545',0,'2014-03-03 01:00:10',NULL,NULL),(38708,25585,'TE','2169128592',0,'2014-02-26 08:00:39',NULL,NULL),(34771,22806,'TE','5134073582',0,'2014-02-11 21:01:55',NULL,NULL),(32478,21220,'TE','9737684662',0,'2014-02-03 21:01:03',NULL,NULL),(31117,20260,'AP','9377185796',0,'2014-01-28 21:00:19',NULL,NULL),(277,172,'TE','3308933812',0,'2013-12-25 17:19:26',NULL,NULL),(23489,15147,'AP','2168466277',0,'2014-01-01 12:05:57',NULL,NULL),(22887,14768,'AP','4097828597',1,'2013-12-29 11:12:51',NULL,NULL),(6517,4212,'AP','8326469831',0,'2013-12-25 21:50:13',NULL,NULL),(40804,27116,'AP','4194503574',0,'2014-03-03 21:30:30',NULL,NULL),(3712,2354,'TE','8174532941',0,'2013-12-25 19:32:19',NULL,NULL),(39258,25970,'AP','3307887364',0,'2014-02-26 21:01:46',NULL,NULL),(32479,21221,'TE','9737684662',0,'2014-02-03 21:01:04',NULL,NULL),(9589,6277,'AP','3309584979',0,'2013-12-26 00:45:17',NULL,NULL),(10905,7085,'EM','kjd5146@aol.com',0,'2013-12-26 01:50:25',NULL,NULL),(31304,20399,'TE','2547178067',0,'2014-01-29 21:00:19',NULL,NULL),(30324,19644,'TE','9377489518',0,'2014-01-23 21:00:17',NULL,NULL),(27103,17436,'TE','5132957010',0,'2014-01-13 03:00:33',NULL,NULL),(25839,16658,'TE','3182685714',0,'2014-01-08 18:24:23',NULL,NULL),(43389,28817,'EM','ribboninfo@yahoo.com',0,'2014-03-09 21:00:57',NULL,NULL),(25204,16250,'EM','bob.citywide@gmail.com',0,'2014-01-05 00:02:38',NULL,NULL),(3728,2365,'EM','PCALCO@NEO.RR.COM',0,'2013-12-25 19:32:37',NULL,NULL),(6551,4234,'TE','2147141280',0,'2013-12-25 21:50:48',NULL,NULL),(2898,1774,'EM','mj_janpro@yahoo.com',0,'2013-12-25 18:56:13',NULL,NULL),(42788,28457,'EM','CHANTELHENDERSON25@GMAIL.COM',0,'2014-03-07 21:31:23',NULL,NULL),(31058,20206,'AP','5134619020',0,'2014-01-27 21:01:35',NULL,NULL),(30630,19879,'TE','6149463560',0,'2014-01-24 21:00:45',NULL,NULL),(29834,19300,'AP','3184706156',1,'2014-01-22 03:22:00',NULL,NULL),(7539,4911,'AP','9728417096',0,'2013-12-25 22:32:07',NULL,NULL),(29396,18998,'EM','dub1323@gmail.com',0,'2014-01-20 08:06:14',NULL,NULL),(22502,14507,'AP','3252071291',0,'2013-12-28 03:33:57',NULL,NULL),(23089,14891,'AP','2254392872',0,'2013-12-30 00:00:48',NULL,NULL),(28913,18665,'EM','kimbofox88@gmail.com',0,'2014-01-17 03:35:15',NULL,NULL),(42527,28293,'TE','5138856851',0,'2014-03-07 21:00:29',NULL,NULL),(14626,9561,'TE','9402060500',0,'2013-12-26 04:36:34',NULL,NULL),(39712,26261,'EM','mandy48954@gmail.com',0,'2014-02-28 06:31:13',NULL,NULL),(9178,6007,'TE','6143517959',0,'2013-12-26 00:00:32',NULL,NULL),(39453,26092,'AP','5043270402',0,'2014-02-28 06:30:09',NULL,NULL),(3867,2459,'TE','8173717538',0,'2013-12-25 19:34:53',NULL,NULL),(34655,22723,'AP','5044302161',0,'2014-02-11 21:01:11',NULL,NULL),(8239,5390,'TE','9857788582',0,'2013-12-25 23:08:38',NULL,NULL),(34259,22471,'EM','jgrosho@gmail.com',0,'2014-02-10 21:30:59',NULL,NULL),(23641,15267,'TE','4195757417',0,'2014-01-01 12:09:30',NULL,NULL),(23995,15488,'AP','9377980337',1,'2014-01-02 04:29:25',NULL,NULL),(32169,21014,'AP','7405009087',0,'2014-02-01 19:00:35',NULL,NULL),(25187,16240,'AP','5047103295',0,'2014-01-05 00:02:21',NULL,NULL),(26874,17292,'TE','3617797652',0,'2014-01-13 02:23:33',NULL,NULL),(37899,25000,'TE','3307335765',0,'2014-02-20 22:00:46',NULL,NULL),(21532,13844,'TE','3309254678',0,'2013-12-26 13:12:24',NULL,NULL),(37030,24381,'TE','5132274656',0,'2014-02-18 22:00:44',NULL,NULL),(2659,1614,'AP','9156139224',0,'2013-12-25 18:52:25',NULL,NULL),(35997,23682,'TE','4408210525',0,'2014-02-14 21:30:31',NULL,NULL),(14434,9433,'AP','4196325518',0,'2013-12-26 04:33:28',NULL,NULL),(35179,23106,'TE','3304004102',0,'2014-02-12 21:31:15',NULL,NULL),(13726,8945,'AP','3309790488',0,'2013-12-26 04:03:26',NULL,NULL),(11383,7411,'AP','2108857850',0,'2013-12-26 02:16:45',NULL,NULL),(29008,18725,'TE','7038510380',0,'2014-01-17 03:35:35',NULL,NULL),(43966,29167,'EM','rogerbates@wowway.com',0,'2014-03-10 21:02:58',NULL,NULL),(37539,24715,'EM','tkunsman@gmail.com',0,'2014-02-20 04:37:08',NULL,NULL),(30314,19639,'TE','3306122159',0,'2014-01-23 21:00:13',NULL,NULL),(29379,18986,'AP','6469263372',0,'2014-01-20 08:06:09',NULL,NULL),(9663,6326,'EM','edwardfirm@att.net',0,'2013-12-26 00:46:30',NULL,NULL),(3008,1869,'TE','2163712592',0,'2013-12-25 18:58:16',NULL,NULL),(27875,17964,'TE','5129948288',0,'2014-01-15 02:06:47',NULL,NULL),(26692,17168,'EM','rahimsrt8@gmail.com',0,'2014-01-13 02:22:07',NULL,NULL),(4300,2744,'TE','8089890329',0,'2013-12-25 19:48:53',NULL,NULL),(5196,3339,'TE','9568626890',0,'2013-12-25 21:16:27',NULL,NULL),(23593,15234,'AP','3309409146',0,'2014-01-01 12:08:23',NULL,NULL),(22993,14831,'AP','9374082765',1,'2013-12-29 11:14:35',NULL,NULL),(1448,883,'AP','9377286903',0,'2013-12-25 18:07:48',NULL,NULL),(20540,13221,'AP','9567634620',0,'2013-12-26 12:55:30',NULL,NULL),(37618,24793,'TE','5139811813',0,'2014-02-20 04:47:09',NULL,NULL),(37516,24705,'EM','jeanniesteelers@gmail.com',0,'2014-02-20 04:35:03',NULL,NULL),(10838,7037,'AP','2148307946',0,'2013-12-26 01:49:18',NULL,NULL),(8438,5551,'AP','2147272274',0,'2013-12-25 23:16:09',NULL,NULL),(36395,23970,'BN','2816870722',0,'2014-02-15 22:00:14',NULL,NULL),(3451,2161,'EM','sharmony15@yahoo.com',0,'2013-12-25 19:18:54',NULL,NULL),(7175,4678,'TE','2255886818',0,'2013-12-25 22:07:48',NULL,NULL),(34384,22553,'TE','5139290411',0,'2014-02-10 21:31:47',NULL,NULL),(24224,15650,'EM','weinteract@yahoo.com',1,'2014-01-02 04:34:05',NULL,NULL),(24690,15925,'TE','6015491183',0,'2014-01-03 02:06:46',NULL,NULL),(24922,16064,'EM','lelandzerbe@gmail.com',0,'2014-01-04 02:03:37',NULL,NULL),(26919,17316,'TE','9797765470',0,'2014-01-13 02:23:47',NULL,NULL),(43798,29076,'AP','9012395771',0,'2014-03-10 21:02:00',NULL,NULL),(27714,17863,'EM','mjohnson200@neo.rr.com',0,'2014-01-15 02:06:11',NULL,NULL),(28473,18345,'AP','5138845242',0,'2014-01-16 08:45:20',NULL,NULL),(3336,2097,'EM','Judisullivan@woh.rr.com',0,'2013-12-25 19:17:04',NULL,NULL),(42166,28010,'BN','5133199866',0,'2014-03-06 21:01:15',NULL,NULL),(8760,5741,'EM','gamatthews@gmail.com',0,'2013-12-25 23:45:58',NULL,NULL),(41428,27523,'EM','lauraharrington9@gmail.com',0,'2014-03-04 21:02:41',NULL,NULL),(8314,5449,'EM','mattrhille@gmail.com',0,'2013-12-25 23:10:08',NULL,NULL),(34464,22614,'TE','3615621866',0,'2014-02-11 21:00:07',NULL,NULL),(13610,8870,'TE','3615753277',0,'2013-12-26 04:01:33',NULL,NULL),(9388,6143,'AP','3302243582',0,'2013-12-26 00:16:21',NULL,NULL),(9425,6168,'AP','3154302976',0,'2013-12-26 00:16:59',NULL,NULL),(30620,19872,'AP','2162582687',0,'2014-01-24 21:00:41',NULL,NULL),(25271,16293,'TE','5132021772',0,'2014-01-07 04:00:55',NULL,NULL),(3610,2280,'TE','6145650225',0,'2013-12-25 19:30:33',NULL,NULL),(2170,1335,'TE','6147497701',0,'2013-12-25 18:32:14',NULL,NULL),(22607,14578,'AP','2252766306',0,'2013-12-28 03:35:46',NULL,NULL),(39746,26286,'AP','3375920061',0,'2014-02-28 06:31:22',NULL,NULL),(37281,24534,'TE','2252235809',0,'2014-02-20 04:01:00',NULL,NULL),(21904,14111,'AP','4407257882',0,'2013-12-27 02:01:52',NULL,NULL),(8013,5230,'AP','3308013395',0,'2013-12-25 23:04:47',NULL,NULL),(35604,23414,'AP','3259397426',0,'2014-02-13 22:01:18',NULL,NULL),(35075,23035,'EM','alicia.greenwood@sbcglobal.net',0,'2014-02-12 21:30:36',NULL,NULL),(14380,9402,'EM','r.cantu1970@gmail.com',0,'2013-12-26 04:32:38',NULL,NULL),(32806,21466,'TE','6015490922',0,'2014-02-04 21:01:35',NULL,NULL),(31088,20234,'EM','ginger.roberts19@gmail.com',0,'2014-01-28 21:00:04',NULL,NULL),(239,145,'TE','4406109901',0,'2013-12-25 17:18:49',NULL,NULL),(21428,13777,'TE','6623292211',0,'2013-12-26 13:10:39',NULL,NULL),(20512,13206,'TE','2818772115',0,'2013-12-26 12:55:06',NULL,NULL),(20297,13083,'TE','5138973751',0,'2013-12-26 12:51:38',NULL,NULL),(20250,13045,'EM','meredithmel@gmail.com',0,'2013-12-26 12:50:43',NULL,NULL),(323,200,'EM','dianeck1005@gmail.com',0,'2013-12-25 17:20:11',NULL,NULL),(8206,5372,'AP','5132920848',0,'2013-12-25 23:08:07',NULL,NULL),(4927,3163,'AP','9372694521',0,'2013-12-25 20:31:23',NULL,NULL),(11345,7389,'AP','4404543178',0,'2013-12-26 02:16:08',NULL,NULL),(11201,7283,'TE','3306446496',0,'2013-12-26 02:02:46',NULL,NULL),(27650,17824,'TE','6012916216',0,'2014-01-15 02:05:57',NULL,NULL),(28617,18449,'TE','9373080679',0,'2014-01-16 08:46:06',NULL,NULL),(30253,19595,'AP','3307302937',0,'2014-01-23 03:02:46',NULL,NULL),(33839,22215,'AP','9852336856',0,'2014-02-09 19:00:23',NULL,NULL),(41175,27346,'AP','4408559070',0,'2014-03-04 21:01:02',NULL,NULL),(42321,28104,'TE','3306873728',0,'2014-03-06 21:02:12',NULL,NULL),(42594,28339,'TE','9728163897',0,'2014-03-07 21:30:15',NULL,NULL),(43522,28897,'AP','9567960313',0,'2014-03-10 21:00:19',NULL,NULL),(40012,26505,'BN','5134976040',0,'2014-02-28 21:00:17',NULL,NULL),(1380,844,'EM','mgad1986@yahoo.com',0,'2013-12-25 18:06:42',NULL,NULL),(3580,2242,'TE','5137793947',0,'2013-12-25 19:21:05',NULL,NULL),(21419,13770,'AP','6622425561',0,'2013-12-26 13:10:30',NULL,NULL),(20551,13227,'EM','ggjjkk@yahoo.com',0,'2013-12-26 12:55:40',NULL,NULL),(4024,2570,'TE','4405391919',0,'2013-12-25 19:37:39',NULL,NULL),(26369,16974,'TE','2282141509',0,'2014-01-13 02:20:15',NULL,NULL),(28911,18665,'TE','9165886712',0,'2014-01-17 03:35:15',NULL,NULL),(29490,19059,'EM','ecko40zur@yahoo.com',0,'2014-01-21 08:44:14',NULL,NULL),(30049,19463,'AP','9178685888',0,'2014-01-23 03:01:57',NULL,NULL),(30735,19970,'TE','4406390312',0,'2014-01-25 19:00:11',NULL,NULL),(30883,20072,'BN','8184150332',0,'2014-01-27 21:00:18',NULL,NULL),(33673,22087,'AP','3054919987',0,'2014-02-08 19:00:22',NULL,NULL),(34776,22809,'TE','5138023311',0,'2014-02-11 21:01:56',NULL,NULL),(37562,24735,'AP','6146535499',0,'2014-02-20 04:39:53',NULL,NULL),(201,122,'EM','GREENFIELDWATER@LIVE.COM',0,'2013-12-25 17:18:14',NULL,NULL),(10396,6776,'EM','bf202105@live.com',0,'2013-12-26 01:16:44',NULL,NULL),(20415,13145,'AP','4404778231',0,'2013-12-26 12:53:27',NULL,NULL),(12165,7947,'TE','2253554312',0,'2013-12-26 03:07:03',NULL,NULL),(7301,4752,'TE','8174049098',0,'2013-12-25 22:15:15',NULL,NULL),(4674,2989,'TE','2165206390',0,'2013-12-25 20:17:24',NULL,NULL),(6133,3948,'TE','4193413302',0,'2013-12-25 21:38:06',NULL,NULL),(2251,1379,'AP','3372546025',0,'2013-12-25 18:46:03',NULL,NULL),(26795,17237,'AP','5672088075',0,'2014-01-13 02:22:43',NULL,NULL),(26911,17311,'TE','8302630749',0,'2014-01-13 02:23:45',NULL,NULL),(28619,18449,'EM','wnewnam@woh.rr.com',0,'2014-01-16 08:46:07',NULL,NULL),(31144,20284,'AP','5137530237',0,'2014-01-28 21:00:31',NULL,NULL),(31414,20479,'AP','4193418586',0,'2014-01-29 21:01:00',NULL,NULL),(32391,21164,'AP','2167982474',0,'2014-02-03 21:00:34',NULL,NULL),(33825,22209,'TE','9376719037',0,'2014-02-09 19:00:19',NULL,NULL),(35299,23185,'EM','CURTIS.AUSTIN76@GMAIL.COM',0,'2014-02-12 21:32:00',NULL,NULL),(37491,24687,'AP','9402229901',0,'2014-02-20 04:31:50',NULL,NULL),(39017,25800,'EM','mpeterson@homesbytpg.com',0,'2014-02-26 21:00:16',NULL,NULL),(7874,5135,'EM','olgaz@kw.com',0,'2013-12-25 23:02:20',NULL,NULL),(22267,14352,'TE','5134057793',0,'2013-12-28 03:30:03',NULL,NULL),(22111,14241,'EM','CALLAHAN_HENRIETTA@YAHOO.COM',0,'2013-12-27 02:05:15',NULL,NULL),(21587,13888,'AP','4199562760',0,'2013-12-26 13:13:24',NULL,NULL),(6880,4463,'EM','koosed@hotmail.com',0,'2013-12-25 22:02:41',NULL,NULL),(11719,7629,'EM','madboy45895@bright.net',0,'2013-12-26 02:46:10',NULL,NULL),(12262,8017,'TE','9374462236',0,'2013-12-26 03:08:49',NULL,NULL),(23099,14895,'EM','rlbell1643@gmail.com',0,'2013-12-30 00:00:56',NULL,NULL),(26612,17123,'TE','4403084470',0,'2014-01-13 02:21:43',NULL,NULL),(29751,19236,'EM','Lindseylp86@icloud.com',0,'2014-01-21 08:46:35',NULL,NULL),(35151,23083,'EM','theradioman@hotmail.com',0,'2014-02-12 21:31:04',NULL,NULL),(36174,23809,'TE','3308824389',0,'2014-02-14 21:31:34',NULL,NULL),(38482,25431,'TE','3616438212',0,'2014-02-25 21:31:15',NULL,NULL),(38968,25763,'TE','3304212051',0,'2014-02-26 09:30:53',NULL,NULL),(39640,26212,'TE','3303577582',0,'2014-02-28 06:30:54',NULL,NULL),(40981,27227,'EM','cnc2170438@yahoo.com',0,'2014-03-03 21:31:39',NULL,NULL),(270,167,'EM','bcast8411@gmail.com',0,'2013-12-25 17:19:21',NULL,NULL),(21329,13704,'AP','2162262268',0,'2013-12-26 13:08:46',NULL,NULL),(10383,6768,'TE','3378557665',0,'2013-12-26 01:16:32',NULL,NULL),(1696,1042,'TE','9792778650',0,'2013-12-25 18:15:48',NULL,NULL),(29907,19354,'EM','susanb50@gmail.com',1,'2014-01-22 03:22:27',NULL,NULL),(30529,19802,'TE','9566873896',0,'2014-01-24 21:00:05',NULL,NULL),(30839,20047,'EM','sharvavasavada@gmail.com',0,'2014-01-27 21:00:03',NULL,NULL),(35642,23437,'TE','9569407506',0,'2014-02-13 22:01:30',NULL,NULL),(36704,24165,'AP','4408237511',0,'2014-02-15 22:02:06',NULL,NULL),(36961,24338,'AP','9404560907',0,'2014-02-18 22:00:18',NULL,NULL),(10870,7055,'EM','Akoha7773@wowway.com',0,'2013-12-26 01:49:49',NULL,NULL),(8184,5355,'TE','3306872802',0,'2013-12-25 23:07:43',NULL,NULL),(13971,9110,'EM','jason1973.healthcare@gmail.com',0,'2013-12-26 04:07:34',NULL,NULL),(12174,7953,'TE','5043469946',0,'2013-12-26 03:07:13',NULL,NULL),(11973,7801,'TE','9794760238',0,'2013-12-26 03:03:41',NULL,NULL),(11595,7543,'EM','zainab_fazalbhoy@yahoo.com',0,'2013-12-26 02:32:59',NULL,NULL),(11136,7239,'TE','5046549119',0,'2013-12-26 02:01:38',NULL,NULL),(5396,3453,'EM','julieannaring@cinci.rr.com',0,'2013-12-25 21:19:34',NULL,NULL),(2597,1584,'TE','2545221126',0,'2013-12-25 18:51:32',NULL,NULL),(2311,1412,'TE','3187713105',0,'2013-12-25 18:46:58',NULL,NULL),(26677,17161,'EM','CARLOSWILSON93@YAHOO.COM',0,'2014-01-13 02:22:02',NULL,NULL),(27210,17521,'EM','gwarden@columbus.rr.com',0,'2014-01-13 03:01:36',NULL,NULL),(28419,18310,'AP','9379358153',0,'2014-01-16 08:45:02',NULL,NULL),(28523,18386,'TE','3307549090',0,'2014-01-16 08:45:37',NULL,NULL),(35888,23604,'TE','4192289375',0,'2014-02-13 22:03:09',NULL,NULL),(37110,24431,'AP','3307143571',0,'2014-02-18 22:01:14',NULL,NULL),(37968,25051,'TE','9373607772',0,'2014-02-20 22:01:16',NULL,NULL),(38469,25424,'TE','6787402716',0,'2014-02-25 21:31:10',NULL,NULL),(40310,26742,'TE','5132536725',0,'2014-02-28 21:31:56',NULL,NULL),(40974,27225,'TE','2255715393',0,'2014-03-03 21:31:38',NULL,NULL),(40977,27226,'AP','5043318439',0,'2014-03-03 21:31:38',NULL,NULL),(41691,27724,'AP','9155405370',0,'2014-03-05 21:31:00',NULL,NULL),(42303,28089,'AP','2104153795',0,'2014-03-06 21:02:03',NULL,NULL),(43888,29120,'EM','williamsgloria50@gmail.com',0,'2014-03-10 21:02:30',NULL,NULL),(933,575,'TE','5132317456',0,'2013-12-25 17:50:42',NULL,NULL),(4761,3050,'TE','3185643237',0,'2013-12-25 20:18:52',NULL,NULL),(24792,15992,'AP','4322144644',0,'2014-01-04 02:01:17',NULL,NULL),(34880,22886,'TE','5672772995',0,'2014-02-11 21:02:35',NULL,NULL),(42774,28448,'EM','Sbgilbert1@gmail.com',0,'2014-03-07 21:31:18',NULL,NULL),(39908,26410,'TE','8328163543',0,'2014-02-28 07:00:38',NULL,NULL),(7834,5113,'TE','9362570910',0,'2013-12-25 23:01:45',NULL,NULL),(27747,17890,'TE','6145603969',0,'2014-01-15 02:06:19',NULL,NULL),(25535,16472,'EM','maryrose333@windstream.net',0,'2014-01-07 04:06:00',NULL,NULL),(14465,9448,'EM','Kaywilczak@hotmail.com',0,'2013-12-26 04:33:54',NULL,NULL),(6071,3909,'TE','8309281281',0,'2013-12-25 21:37:02',NULL,NULL),(11931,7772,'TE','4696852580',0,'2013-12-26 03:02:57',NULL,NULL),(7154,4666,'AP','3183558258',0,'2013-12-25 22:07:30',NULL,NULL),(9460,6191,'EM','dlc7509@aol.com',0,'2013-12-26 00:30:20',NULL,NULL),(343,213,'TE','2258029226',0,'2013-12-25 17:20:32',NULL,NULL),(13636,8892,'TE','2542133391',0,'2013-12-26 04:02:03',NULL,NULL),(7193,4686,'EM','petsbyfive@yahoo.com',0,'2013-12-25 22:08:03',NULL,NULL),(2191,1348,'TE','8068316706',0,'2013-12-25 18:45:10',NULL,NULL),(39629,26207,'EM','besthousing@mbarqmail.com',0,'2014-02-28 06:30:52',NULL,NULL),(6058,3898,'TE','3307301030',0,'2013-12-25 21:36:47',NULL,NULL),(4575,2918,'EM','pje567@aol.com',0,'2013-12-25 20:15:43',NULL,NULL),(5638,3616,'AP','4193064757',0,'2013-12-25 21:23:34',NULL,NULL),(34402,22567,'TE','4194949351',0,'2014-02-10 21:31:54',NULL,NULL),(24737,15960,'AP','5132008226',0,'2014-01-04 02:00:19',NULL,NULL),(21874,14092,'TE','5137940028',0,'2013-12-27 02:01:22',NULL,NULL),(21935,14130,'TE','5042373521',0,'2013-12-27 02:02:22',NULL,NULL),(22419,14457,'AP','5043889537',0,'2013-12-28 03:32:40',NULL,NULL),(5488,3510,'EM','DGLUTZ@CINCI.RR.COM',0,'2013-12-25 21:20:59',NULL,NULL),(13744,8956,'EM','t.rich@email.com',0,'2013-12-26 04:03:44',NULL,NULL),(10795,7016,'EM','cab@consolidated.net',0,'2013-12-26 01:48:41',NULL,NULL),(10108,6606,'AP','9374171757',0,'2013-12-26 00:53:40',NULL,NULL),(921,568,'EM','ahronaccoo@yahoo.com',0,'2013-12-25 17:50:32',NULL,NULL),(3573,2238,'EM','acoates192@oh.rr.com',0,'2013-12-25 19:20:57',NULL,NULL),(40412,26825,'AP','6142097356',0,'2014-03-01 21:00:37',NULL,NULL),(38587,25500,'AP','9792574391',0,'2014-02-25 21:31:54',NULL,NULL),(3202,2011,'AP','5185673310',0,'2013-12-25 19:02:31',NULL,NULL),(20696,13305,'TE','8028812631',0,'2013-12-26 12:57:55',NULL,NULL),(23002,14836,'EM','DEA57ARMOUR@GMAIL.COM',1,'2013-12-29 11:14:43',NULL,NULL),(25455,16414,'EM','dexterdaugherty@yahoo.com',0,'2014-01-07 04:04:20',NULL,NULL),(34731,22773,'AP','9092547232',0,'2014-02-11 21:01:39',NULL,NULL),(31264,20367,'AP','5036896262',0,'2014-01-29 21:00:03',NULL,NULL),(42073,27957,'TE','2252647347',0,'2014-03-06 21:00:42',NULL,NULL),(31182,20308,'AP','8063670271',0,'2014-01-28 21:00:47',NULL,NULL),(30345,19663,'EM','bkilby81@gmail.com',0,'2014-01-23 21:00:26',NULL,NULL),(37186,24477,'EM','jmendel715@att.net',0,'2014-02-18 22:01:42',NULL,NULL),(33739,22137,'AP','7404590231',0,'2014-02-08 19:00:47',NULL,NULL),(22687,14633,'TE','5136830004',0,'2013-12-28 03:37:14',NULL,NULL),(22295,14368,'AP','9376264519',0,'2013-12-28 03:30:28',NULL,NULL),(37950,25040,'AP','4192961783',0,'2014-02-20 22:01:09',NULL,NULL),(37615,24790,'TE','5139811813',0,'2014-02-20 04:46:49',NULL,NULL),(1843,1140,'TE','5044552722',0,'2013-12-25 18:18:18',NULL,NULL),(28396,18296,'TE','5138271184',0,'2014-01-16 08:44:54',NULL,NULL),(11613,7552,'TE','3304130853',0,'2013-12-26 02:33:15',NULL,NULL),(24451,15784,'EM','Alexanderjnash@gmail.com',0,'2014-01-03 02:02:16',NULL,NULL),(9048,5934,'EM','beckyd765@yahoo.com',0,'2013-12-25 23:50:37',NULL,NULL),(4185,2677,'TE','4406398028',0,'2013-12-25 19:47:08',NULL,NULL),(20977,13503,'TE','3186369304',0,'2013-12-26 13:02:38',NULL,NULL),(3379,2123,'EM','fddickinson54@gmail.com',0,'2013-12-25 19:17:47',NULL,NULL),(1733,1065,'TE','2165514667',0,'2013-12-25 18:16:23',NULL,NULL),(5640,3617,'TE','4193034752',0,'2013-12-25 21:23:36',NULL,NULL),(2777,1682,'AP','3186176244',0,'2013-12-25 18:54:12',NULL,NULL),(2021,1251,'AP','4408647595',0,'2013-12-25 18:21:14',NULL,NULL),(38337,25327,'TE','3375819154',0,'2014-02-25 21:30:14',NULL,NULL),(24311,15704,'AP','4154079674',1,'2014-01-02 04:35:51',NULL,NULL),(26370,16974,'AP','9013048156',0,'2014-01-13 02:20:15',NULL,NULL),(35124,23069,'EM','rogerickd.wilson@gmail.com',0,'2014-02-12 21:30:56',NULL,NULL),(33629,22050,'EM','catherinajoshua@gmail.com',0,'2014-02-08 19:00:05',NULL,NULL),(31374,20451,'AP','7409351894',0,'2014-01-29 21:00:45',NULL,NULL),(21497,13815,'AP','8594681246',0,'2013-12-26 13:11:43',NULL,NULL),(3733,2371,'TE','3303589950',0,'2013-12-25 19:32:43',NULL,NULL),(14034,9168,'TE','4199056885',0,'2013-12-26 04:08:51',NULL,NULL),(12053,7866,'TE','6147492291',0,'2013-12-26 03:05:07',NULL,NULL),(9602,6286,'AP','2163554019',0,'2013-12-26 00:45:31',NULL,NULL),(4652,2973,'EM','hdperley@gmail.com',0,'2013-12-25 20:17:02',NULL,NULL),(682,424,'EM','CURITIAEMBRY@WILEDMALE.COM',0,'2013-12-25 17:46:44',NULL,NULL),(22614,14582,'TE','5043943714',0,'2013-12-28 03:35:53',NULL,NULL),(20581,13242,'TE','2146734693',0,'2013-12-26 12:56:07',NULL,NULL),(14308,9357,'AP','7874331023',0,'2013-12-26 04:31:26',NULL,NULL),(20781,13354,'EM','m.duke.fisher@gmail.com',0,'2013-12-26 12:59:17',NULL,NULL),(4330,2763,'EM','mcapple@sssnet.com',0,'2013-12-25 19:49:22',NULL,NULL),(40474,26864,'AP','2103247790',0,'2014-03-01 21:00:59',NULL,NULL),(38021,25080,'AP','4193573816',0,'2014-02-20 22:01:37',NULL,NULL),(20761,13341,'EM','meeksgw@aol.com',0,'2013-12-26 12:58:56',NULL,NULL),(14284,9345,'TE','9856437327',0,'2013-12-26 04:31:06',NULL,NULL),(6884,4468,'TE','4196568611',0,'2013-12-25 22:02:47',NULL,NULL),(37203,24487,'TE','2256299850',0,'2014-02-20 03:42:52',NULL,NULL),(35824,23557,'AP','4198108125',0,'2014-02-13 22:02:43',NULL,NULL),(35732,23500,'TE','9034972240',0,'2014-02-13 22:02:07',NULL,NULL),(30728,19964,'TE','3308585870',0,'2014-01-25 19:00:09',NULL,NULL),(24225,15651,'EM','dessie_hart@att.net',1,'2014-01-02 04:34:07',NULL,NULL),(43410,28827,'EM','bensprice@cinci.rr.com',0,'2014-03-09 21:01:04',NULL,NULL),(2911,1786,'TE','6142862898',0,'2013-12-25 18:56:27',NULL,NULL),(40183,26652,'TE','3307031525',0,'2014-02-28 21:31:08',NULL,NULL),(14385,9406,'TE','8324912686',0,'2013-12-26 04:32:44',NULL,NULL),(35249,23150,'EM','stephschiff32@gmail.com',0,'2014-02-12 21:31:41',NULL,NULL),(22316,14386,'AP','6145560045',0,'2013-12-28 03:30:53',NULL,NULL),(27409,17650,'EM','scadatech01@gmail.com',0,'2014-01-14 01:32:40',NULL,NULL),(23793,15346,'EM','Murphham1@aol.com',1,'2014-01-02 04:24:24',NULL,NULL),(24148,15598,'EM','djr@toast.net',1,'2014-01-02 04:32:36',NULL,NULL),(42808,28468,'AP','2167020696',0,'2014-03-07 21:31:30',NULL,NULL),(22951,14805,'EM','drujack1966@gmail.com',1,'2013-12-29 11:13:53',NULL,NULL),(22631,14593,'EM','headrickbecky@yahoo.com',0,'2013-12-28 03:36:11',NULL,NULL),(40607,26954,'BN','5678682613',0,'2014-03-03 01:00:28',NULL,NULL),(40231,26686,'TE','3185125142',0,'2014-02-28 21:31:26',NULL,NULL),(36465,24009,'EM','Jacques.mr@gmail.com',0,'2014-02-15 22:00:39',NULL,NULL),(36302,23903,'TE','4193678082',0,'2014-02-14 21:32:25',NULL,NULL),(35386,23257,'TE','2147141720',0,'2014-02-13 21:30:08',NULL,NULL),(28500,18370,'TE','7404046767',0,'2014-01-16 08:45:29',NULL,NULL),(43639,28965,'AP','3375785656',0,'2014-03-10 21:00:59',NULL,NULL),(8754,5738,'AP','2252781855',0,'2013-12-25 23:45:53',NULL,NULL),(24789,15990,'EM','navigatorsmithcounty@yahoo.com',0,'2014-01-04 02:01:13',NULL,NULL),(41552,27628,'AP','3304654198',0,'2014-03-05 21:30:09',NULL,NULL),(37833,24963,'TE','2253854076',0,'2014-02-20 22:00:21',NULL,NULL),(35564,23389,'TE','3304887454',0,'2014-02-13 22:01:04',NULL,NULL),(3048,1896,'EM','brendakummerer@yahoo.com',0,'2013-12-25 18:59:00',NULL,NULL),(1626,999,'TE','5124198645',0,'2013-12-25 18:10:53',NULL,NULL),(25834,16656,'AP','2283270201',0,'2014-01-08 18:24:22',NULL,NULL),(26516,17060,'EM','cedar2@univision.com',0,'2014-01-13 02:21:11',NULL,NULL),(35499,23339,'EM','sonanixon@gmail.com',0,'2014-02-13 22:00:37',NULL,NULL),(33371,21866,'TE','9855802634',0,'2014-02-06 21:01:23',NULL,NULL),(30591,19850,'AP','4194637579',0,'2014-01-24 21:00:30',NULL,NULL),(549,343,'TE','7405726676',0,'2013-12-25 17:32:01',NULL,NULL),(20683,13298,'TE','9037379908',0,'2013-12-26 12:57:42',NULL,NULL),(37158,24460,'TE','3016592203',0,'2014-02-18 22:01:32',NULL,NULL),(36573,24073,'TE','3303340495',0,'2014-02-15 22:01:18',NULL,NULL),(9448,6185,'AP','6145166443',0,'2013-12-26 00:30:10',NULL,NULL),(34732,22773,'EM','PATISTLB@AOL.COM',0,'2014-02-11 21:01:39',NULL,NULL),(22622,14588,'AP','3305241565',0,'2013-12-28 03:36:03',NULL,NULL),(22794,14699,'TE','2167413872',1,'2013-12-29 11:09:01',NULL,NULL),(22995,14832,'EM','dpolk@zoomtown.com',1,'2013-12-29 11:14:37',NULL,NULL),(23031,14857,'AP','3306087346',1,'2013-12-29 11:15:14',NULL,NULL),(34588,22678,'AP','9562831893',0,'2014-02-11 21:00:46',NULL,NULL),(29392,18996,'EM','prettyhateme@gmail.com',0,'2014-01-20 08:06:13',NULL,NULL),(349,217,'TE','5048106630',0,'2013-12-25 17:20:39',NULL,NULL),(40926,27196,'AP','8327586028',0,'2014-03-03 21:31:19',NULL,NULL),(1608,989,'TE','9373763431',0,'2013-12-25 18:10:34',NULL,NULL),(32504,21247,'EM','barbarajenkins@earthlink.net',0,'2014-02-03 21:01:15',NULL,NULL),(22747,14670,'TE','9153566996',1,'2013-12-29 11:08:14',NULL,NULL),(24852,16028,'EM','rpaille@mail.com',0,'2014-01-04 02:02:24',NULL,NULL),(27324,17596,'AP','6015408984',0,'2014-01-14 01:32:13',NULL,NULL),(8074,5285,'AP','2164968674',0,'2013-12-25 23:05:54',NULL,NULL),(1237,753,'AP','6824297848',0,'2013-12-25 18:04:21',NULL,NULL),(24988,16104,'TE','4195752104',0,'2014-01-04 02:04:53',NULL,NULL),(1535,943,'TE','2162143135',0,'2013-12-25 18:09:25',NULL,NULL),(3465,2169,'AP','4193761477',0,'2013-12-25 19:19:07',NULL,NULL),(1781,1101,'TE','2165911969',0,'2013-12-25 18:17:17',NULL,NULL),(9458,6191,'TE','9722355094',0,'2013-12-26 00:30:19',NULL,NULL),(41137,27323,'TE','9158437150',0,'2014-03-04 21:00:48',NULL,NULL),(39980,26470,'AP','2259935948',0,'2014-02-28 07:30:37',NULL,NULL),(24532,15823,'TE','3308586636',0,'2014-01-03 02:03:36',NULL,NULL),(28346,18265,'TE','9035133601',0,'2014-01-16 08:44:39',NULL,NULL),(38152,25180,'EM','kathynewburn@yahoo.com',0,'2014-02-21 22:00:34',NULL,NULL),(30108,19504,'TE','9362159606',0,'2014-01-23 03:02:12',NULL,NULL),(34410,22571,'EM','karajakubec@gmail.com',0,'2014-02-10 21:31:57',NULL,NULL),(36518,24041,'EM','deesoutendijk@gmail.com',0,'2014-02-15 22:00:59',NULL,NULL),(43628,28960,'AP','7187530601',0,'2014-03-10 21:00:56',NULL,NULL),(1899,1170,'EM','jrkulow@wadsnet.com',0,'2013-12-25 18:19:09',NULL,NULL),(42077,27958,'AP','2253296687',0,'2014-03-06 21:00:43',NULL,NULL),(20363,13117,'EM','karepko@windstream.net',0,'2013-12-26 12:52:39',NULL,NULL),(20309,13088,'EM','rleighton@cinci.rr.com',0,'2013-12-26 12:51:48',NULL,NULL),(14739,9640,'EM','pcscc1@sbcglobal.net',0,'2013-12-26 04:38:29',NULL,NULL),(14500,9472,'EM','jake@jchealthinsurance.com',0,'2013-12-26 04:34:28',NULL,NULL),(11129,7234,'EM','silvanaleone11@yahoo.com',0,'2013-12-26 02:01:29',NULL,NULL),(2132,1313,'EM','kroper327@earthlink.net',0,'2013-12-25 18:31:33',NULL,NULL),(7044,4600,'EM','brucelombardo@roadrunner.com',0,'2013-12-25 22:05:42',NULL,NULL),(8242,5391,'TE','2252022946',0,'2013-12-25 23:08:41',NULL,NULL),(3173,1989,'AP','8176816774',0,'2013-12-25 19:01:55',NULL,NULL),(9534,6242,'EM','garret@pmicincinnati.com',0,'2013-12-26 00:31:42',NULL,NULL),(28455,18336,'AP','3307935448',0,'2014-01-16 08:45:15',NULL,NULL),(25385,16371,'AP','8326613989',0,'2014-01-07 04:03:02',NULL,NULL),(8852,5801,'TE','4407294397',0,'2013-12-25 23:47:30',NULL,NULL),(20720,13318,'AP','7133848781',0,'2013-12-26 12:58:17',NULL,NULL),(41281,27429,'AP','5043159712',0,'2014-03-04 21:01:45',NULL,NULL),(8367,5498,'AP','4194968555',0,'2013-12-25 23:11:15',NULL,NULL),(10641,6920,'AP','7404910441',0,'2013-12-26 01:46:12',NULL,NULL),(36053,23715,'TE','3306173153',0,'2014-02-14 21:30:49',NULL,NULL),(22944,14801,'EM','jds0718@gmail.com',1,'2013-12-29 11:13:46',NULL,NULL),(23454,15117,'TE','9375546003',0,'2014-01-01 12:05:09',NULL,NULL),(35510,23351,'AP','3306180510',0,'2014-02-13 22:00:42',NULL,NULL),(6817,4425,'TE','2162724735',0,'2013-12-25 22:01:43',NULL,NULL),(24913,16059,'EM','pmurphy7@neo.rr.com',0,'2014-01-04 02:03:27',NULL,NULL),(1865,1151,'AP','5047829850',0,'2013-12-25 18:18:38',NULL,NULL),(20263,13058,'EM','jojo414@ameritech.net',0,'2013-12-26 12:51:01',NULL,NULL),(26949,17330,'AP','5049098881',0,'2014-01-13 02:23:57',NULL,NULL),(41014,27252,'TE','4195741828',0,'2014-03-03 21:31:54',NULL,NULL),(29925,19367,'TE','3306973531',1,'2014-01-22 03:22:34',NULL,NULL),(30105,19503,'TE','3306972909',0,'2014-01-23 03:02:11',NULL,NULL),(31311,20402,'TE','2544212652',0,'2014-01-29 21:00:21',NULL,NULL),(40691,27028,'TE','9032272343',0,'2014-03-03 21:00:15',NULL,NULL),(34373,22546,'AP','3184694452',0,'2014-02-10 21:31:42',NULL,NULL),(34461,22611,'TE','3188014186',0,'2014-02-11 21:00:05',NULL,NULL),(30918,20104,'AP','5049316712',0,'2014-01-27 21:00:37',NULL,NULL),(25862,16668,'EM','crysbangura@aol.com',0,'2014-01-08 18:24:27',NULL,NULL),(22088,14228,'TE','2547185751',0,'2013-12-27 02:04:54',NULL,NULL),(30000,19426,'EM','roxielee@zoomtown.com',1,'2014-01-22 03:23:05',NULL,NULL),(27050,17396,'BN','4404791413',0,'2014-01-13 03:00:14',NULL,NULL),(6120,3939,'TE','4196861888',0,'2013-12-25 21:37:52',NULL,NULL),(21382,13751,'TE','4195162895',0,'2013-12-26 13:09:56',NULL,NULL),(11936,7774,'TE','2148085198',0,'2013-12-26 03:03:01',NULL,NULL),(9512,6226,'AP','5132642264',0,'2013-12-26 00:31:19',NULL,NULL),(2903,1781,'TE','6147665497',0,'2013-12-25 18:56:20',NULL,NULL),(1719,1053,'AP','2145371011',0,'2013-12-25 18:16:07',NULL,NULL),(23254,14983,'EM','iharris369@yahoo.com',0,'2014-01-01 12:01:10',NULL,NULL),(23248,14981,'AP','2542279334',0,'2014-01-01 12:01:05',NULL,NULL),(7516,4898,'TE','4193082567',0,'2013-12-25 22:31:45',NULL,NULL),(11757,7651,'EM','kabata@aol.com',0,'2013-12-26 02:46:53',NULL,NULL),(11919,7759,'TE','5136592966',0,'2013-12-26 03:02:42',NULL,NULL),(7615,4962,'TE','3182001638',0,'2013-12-25 22:46:11',NULL,NULL),(4641,2962,'TE','3182377711',0,'2013-12-25 20:16:47',NULL,NULL),(12367,8093,'AP','3306209546',0,'2013-12-26 03:10:47',NULL,NULL),(3226,2028,'AP','2165519002',0,'2013-12-25 19:15:17',NULL,NULL),(7728,5046,'TE','6785755012',0,'2013-12-25 22:48:09',NULL,NULL),(26232,16884,'AP','5127990386',0,'2014-01-13 02:19:23',NULL,NULL),(26323,16947,'TE','6018354373',0,'2014-01-13 02:19:57',NULL,NULL),(29184,18855,'TE','5135282040',0,'2014-01-17 03:36:18',NULL,NULL),(31087,20234,'AP','6623164544',0,'2014-01-28 21:00:04',NULL,NULL),(40584,26935,'TE','7408243828',0,'2014-03-03 01:00:21',NULL,NULL),(32317,21113,'TE','9039106481',0,'2014-02-03 21:00:08',NULL,NULL),(33035,21642,'BN','2543175363',0,'2014-02-05 21:30:46',NULL,NULL),(34516,22642,'AP','8328596352',0,'2014-02-11 21:00:23',NULL,NULL),(34648,22718,'TE','3184030097',0,'2014-02-11 21:01:08',NULL,NULL),(36982,24347,'EM','vochoa46@yahoo.com',0,'2014-02-18 22:00:24',NULL,NULL),(37692,24849,'EM','dgaw@aol.com',0,'2014-02-20 04:55:25',NULL,NULL),(123,72,'AP','2167026085',0,'2013-12-25 17:16:58',NULL,NULL),(20704,13309,'TE','8066691268',0,'2013-12-26 12:58:02',NULL,NULL),(14813,9697,'TE','5135759082',0,'2013-12-26 04:39:53',NULL,NULL),(14670,9598,'TE','3302963251',0,'2013-12-26 04:37:21',NULL,NULL),(14649,9582,'AP','6148435979',0,'2013-12-26 04:36:56',NULL,NULL),(1701,1044,'AP','3252624455',0,'2013-12-25 18:15:52',NULL,NULL),(5218,3354,'TE','3619443397',0,'2013-12-25 21:16:49',NULL,NULL),(13595,8863,'AP','8066763502',0,'2013-12-26 04:01:21',NULL,NULL),(6415,4140,'AP','6145357135',0,'2013-12-25 21:48:35',NULL,NULL),(23150,14923,'AP','3186172077',0,'2013-12-30 00:01:46',NULL,NULL),(28378,18284,'EM','jtjakuszeit@gmail.com',0,'2014-01-16 08:44:49',NULL,NULL),(29023,18738,'AP','9376843525',0,'2014-01-17 03:35:39',NULL,NULL),(29128,18816,'TE','5138582658',0,'2014-01-17 03:36:04',NULL,NULL),(34642,22713,'EM','taylorarroyotabin@gmail.com',0,'2014-02-11 21:01:06',NULL,NULL),(40224,26683,'TE','2258105078',0,'2014-02-28 21:31:24',NULL,NULL),(40562,26924,'EM','terriem@gmail.com',0,'2014-03-03 01:00:16',NULL,NULL),(40839,27137,'TE','4192897262',0,'2014-03-03 21:30:44',NULL,NULL),(2040,1263,'AP','9564291003',0,'2013-12-25 18:30:03',NULL,NULL),(20746,13334,'TE','8326430437',0,'2013-12-26 12:58:43',NULL,NULL),(3053,1899,'AP','5405250368',0,'2013-12-25 18:59:05',NULL,NULL),(3802,2419,'AP','5133240570',0,'2013-12-25 19:33:55',NULL,NULL),(4662,2978,'AP','9376043293',0,'2013-12-25 20:17:11',NULL,NULL),(13603,8867,'AP','9728251814',0,'2013-12-26 04:01:27',NULL,NULL),(10822,7029,'TE','5129257669',0,'2013-12-26 01:49:05',NULL,NULL),(10048,6572,'EM','greatmre@aol.com',0,'2013-12-26 00:52:44',NULL,NULL),(24895,16048,'EM','bmor0789@hotmail.com',0,'2014-01-04 02:03:07',NULL,NULL),(25080,16168,'AP','2258198199',0,'2014-01-05 00:00:10',NULL,NULL),(26633,17137,'TE','5137976989',0,'2014-01-13 02:21:49',NULL,NULL),(31061,20207,'EM','keaneau1004@hotmail.com',0,'2014-01-27 21:01:36',NULL,NULL),(37809,24951,'AP','5043279301',0,'2014-02-20 22:00:11',NULL,NULL),(42362,28137,'TE','3308604433',0,'2014-03-06 21:02:28',NULL,NULL),(42561,28320,'AP','7132545257',0,'2014-03-07 21:30:04',NULL,NULL),(8521,5601,'EM','thangpham@hotmail.com',0,'2013-12-25 23:30:15',NULL,NULL),(1473,903,'AP','6016955628',0,'2013-12-25 18:08:20',NULL,NULL),(20702,13308,'TE','9722988874',0,'2013-12-26 12:58:00',NULL,NULL),(21417,13768,'EM','pbcshouse@comcast.net',0,'2013-12-26 13:10:27',NULL,NULL),(14723,9631,'EM','hhddss1@aol.com',0,'2013-12-26 04:38:13',NULL,NULL),(14452,9442,'AP','7408166783',0,'2013-12-26 04:33:43',NULL,NULL),(14252,9323,'EM','meghanmhooper@gmail.com',0,'2013-12-26 04:30:33',NULL,NULL),(11762,7655,'EM','kcsmith1@bellsouth.net',0,'2013-12-26 03:00:07',NULL,NULL),(10104,6601,'EM','JGOULD3@NEO.RR.COM',0,'2013-12-26 00:53:34',NULL,NULL),(9924,6495,'AP','3308076450',0,'2013-12-26 00:50:42',NULL,NULL),(9739,6371,'TE','3306654746',0,'2013-12-26 00:47:39',NULL,NULL),(180,106,'EM','steven.michael.elliott@gmail.com',0,'2013-12-25 17:17:51',NULL,NULL),(363,223,'AP','3372553293',0,'2013-12-25 17:20:49',NULL,NULL),(6996,4568,'AP','2145008862',0,'2013-12-25 22:04:54',NULL,NULL),(959,591,'AP','3309540070',0,'2013-12-25 18:00:03',NULL,NULL),(26190,16859,'TE','9154124525',0,'2014-01-13 02:19:09',NULL,NULL),(26647,17144,'TE','3186174160',0,'2014-01-13 02:21:53',NULL,NULL),(30426,19721,'AP','5045799980',0,'2014-01-23 21:00:59',NULL,NULL),(31407,20473,'AP','6142181469',0,'2014-01-29 21:00:57',NULL,NULL),(33794,22185,'AP','9857050874',0,'2014-02-09 19:00:06',NULL,NULL),(34713,22759,'TE','4195260079',0,'2014-02-11 21:01:32',NULL,NULL),(35359,23233,'TE','4194359114',0,'2014-02-12 21:32:27',NULL,NULL),(35566,23390,'TE','5138764101',0,'2014-02-13 22:01:04',NULL,NULL),(42421,28172,'AP','4194666651',0,'2014-03-06 21:02:50',NULL,NULL),(568,352,'TE','2257784870',0,'2013-12-25 17:32:19',NULL,NULL),(749,470,'EM','djknotts7@yahoo.com',0,'2013-12-25 17:47:51',NULL,NULL),(21606,13905,'TE','4197079492',0,'2013-12-26 13:13:48',NULL,NULL),(14287,9346,'TE','5042569053',0,'2013-12-26 04:31:08',NULL,NULL),(11497,7479,'EM','m.orecchio@mail.com',0,'2013-12-26 02:31:22',NULL,NULL),(9537,6244,'EM','toby@kelts.com',0,'2013-12-26 00:31:44',NULL,NULL),(9152,5994,'TE','5047388227',0,'2013-12-26 00:00:10',NULL,NULL),(9699,6352,'AP','2167805601',0,'2013-12-26 00:47:05',NULL,NULL),(7053,4607,'AP','3305818509',0,'2013-12-25 22:05:53',NULL,NULL),(7365,4791,'TE','3308690701',0,'2013-12-25 22:16:19',NULL,NULL),(4076,2600,'TE','5134511788',0,'2013-12-25 19:45:19',NULL,NULL),(3827,2436,'TE','3307846260',0,'2013-12-25 19:34:18',NULL,NULL),(3735,2371,'EM','woodswalker51@gmail.com',0,'2013-12-25 19:32:44',NULL,NULL),(1973,1220,'TE','2162535635',0,'2013-12-25 18:20:23',NULL,NULL),(25418,16394,'EM','d.penrod1987@gmail.com',0,'2014-01-07 04:03:41',NULL,NULL),(29891,19341,'EM','rollison05@gmail.com',1,'2014-01-22 03:22:21',NULL,NULL),(31065,20210,'AP','4404208513',0,'2014-01-27 21:01:38',NULL,NULL),(31520,20540,'EM','mk4homes@gmail.com',0,'2014-01-29 21:01:35',NULL,NULL),(34884,22891,'TE','4193201075',0,'2014-02-11 21:02:37',NULL,NULL),(35276,23167,'TE','4692378685',0,'2014-02-12 21:31:51',NULL,NULL),(37111,24431,'EM','rblack851@gmail.com',0,'2014-02-18 22:01:14',NULL,NULL),(38020,25080,'TE','4193573816',0,'2014-02-20 22:01:37',NULL,NULL),(41188,27355,'TE','2169267060',0,'2014-03-04 21:01:08',NULL,NULL),(41578,27645,'AP','3303215015',0,'2014-03-05 21:30:18',NULL,NULL),(42868,28509,'AP','3307018064',0,'2014-03-07 21:31:53',NULL,NULL),(818,510,'TE','7404745860',0,'2013-12-25 17:48:54',NULL,NULL),(21085,13559,'EM','angellpatricia876@yahoo.com',0,'2013-12-26 13:04:19',NULL,NULL),(1962,1214,'EM','judyhoy@woh.rr.com',0,'2013-12-25 18:20:12',NULL,NULL),(8708,5713,'AP','3305643107',0,'2013-12-25 23:45:13',NULL,NULL),(12252,8011,'AP','9033993749',0,'2013-12-26 03:08:39',NULL,NULL),(4193,2682,'EM','Proshoptom@yahoo.com',0,'2013-12-25 19:47:15',NULL,NULL),(7894,5144,'TE','3307554018',0,'2013-12-25 23:02:38',NULL,NULL),(9794,6408,'AP','6144249068',0,'2013-12-26 00:48:32',NULL,NULL),(24685,15920,'TE','6019552127',0,'2014-01-03 02:06:38',NULL,NULL),(25989,16746,'TE','9035740676',0,'2014-01-08 18:24:53',NULL,NULL),(31167,20298,'TE','3377062524',0,'2014-01-28 21:00:41',NULL,NULL),(33230,21760,'TE','8172195193',0,'2014-02-06 21:00:26',NULL,NULL),(34048,22325,'TE','5105071275',0,'2014-02-10 11:00:57',NULL,NULL),(36605,24100,'TE','8709952419',0,'2014-02-15 22:01:30',NULL,NULL),(37038,24390,'AP','3303233787',0,'2014-02-18 22:00:48',NULL,NULL),(37772,24927,'AP','3147570616',0,'2014-02-20 21:30:18',NULL,NULL),(43974,29171,'EM','christopherbann1980@gmail.com',0,'2014-03-10 21:03:00',NULL,NULL),(1416,864,'TE','5673956960',0,'2013-12-25 18:07:16',NULL,NULL),(2764,1676,'TE','9375442225',0,'2013-12-25 18:54:01',NULL,NULL),(8403,5531,'TE','7402430437',0,'2013-12-25 23:15:34',NULL,NULL),(20474,13188,'TE','7138185092',0,'2013-12-26 12:54:32',NULL,NULL),(13623,8882,'TE','9036032030',0,'2013-12-26 04:01:48',NULL,NULL),(7090,4629,'TE','6018562193',0,'2013-12-25 22:06:29',NULL,NULL),(3566,2233,'TE','5133759232',0,'2013-12-25 19:20:50',NULL,NULL),(26859,17285,'EM','michael78014@yahoo.com',0,'2014-01-13 02:23:28',NULL,NULL),(27212,17522,'AP','7408155943',0,'2014-01-13 03:01:37',NULL,NULL),(27986,18040,'TE','4192608785',0,'2014-01-15 02:07:12',NULL,NULL),(28973,18700,'AP','3183310077',0,'2014-01-17 03:35:28',NULL,NULL),(31420,20483,'TE','3306874815',0,'2014-01-29 21:01:02',NULL,NULL),(32791,21454,'AP','3302459905',0,'2014-02-04 21:01:30',NULL,NULL),(34833,22844,'TE','5174147516',0,'2014-02-11 21:02:16',NULL,NULL),(35275,23166,'AP','2542260749',0,'2014-02-12 21:31:50',NULL,NULL),(36425,23990,'EM','chad_barnhill@hotmail.com',0,'2014-02-15 22:00:26',NULL,NULL),(39937,26428,'AP','6822249280',0,'2014-02-28 07:30:14',NULL,NULL),(41803,27790,'TE','6627640042',0,'2014-03-05 21:31:40',NULL,NULL),(9457,6188,'AP','3252807630',0,'2013-12-26 00:30:17',NULL,NULL),(14577,9532,'AP','2166442046',0,'2013-12-26 04:35:49',NULL,NULL),(14178,9276,'TE','9373075491',0,'2013-12-26 04:15:48',NULL,NULL),(9295,6088,'EM','shilliard1130@StarkState.net',0,'2013-12-26 00:02:40',NULL,NULL),(5670,3642,'AP','6014803207',0,'2013-12-25 21:30:24',NULL,NULL),(2894,1773,'AP','9373972646',0,'2013-12-25 18:56:10',NULL,NULL),(10799,7018,'TE','2107255263',0,'2013-12-26 01:48:45',NULL,NULL),(25704,16570,'EM','hoot.samantha@gmail.com',1,'2014-01-07 10:23:19',NULL,NULL),(25775,16609,'AP','6143275627',0,'2014-01-08 18:24:07',NULL,NULL),(28664,18487,'EM','bdaywalt@windstream.net',0,'2014-01-16 08:46:24',NULL,NULL),(29525,19084,'TE','4197639068',0,'2014-01-21 08:44:28',NULL,NULL),(31043,20194,'TE','6016495141',0,'2014-01-27 21:01:29',NULL,NULL),(33186,21733,'TE','2818506953',0,'2014-02-06 21:00:11',NULL,NULL),(33268,21784,'AP','6149895348',0,'2014-02-06 21:00:40',NULL,NULL),(33662,22081,'AP','5043209267',0,'2014-02-08 19:00:18',NULL,NULL),(33920,22264,'TE','9402375340',0,'2014-02-10 11:00:09',NULL,NULL),(34482,22623,'BN','6267312108',0,'2014-02-11 21:00:12',NULL,NULL),(38596,25505,'AP','3309906699',0,'2014-02-25 21:31:58',NULL,NULL),(7207,4694,'EM','MORGAN5057@YAHOO.COM',0,'2013-12-25 22:08:17',NULL,NULL),(1918,1186,'TE','4409847475',0,'2013-12-25 18:19:31',NULL,NULL),(12301,8046,'TE','3306080398',0,'2013-12-26 03:09:32',NULL,NULL),(6428,4153,'EM','frozenman36@gmail.com',0,'2013-12-25 21:48:49',NULL,NULL),(24488,15799,'EM','krisshull@gmail.com',0,'2014-01-03 02:02:49',NULL,NULL),(24758,15974,'TE','9562715681',0,'2014-01-04 02:00:42',NULL,NULL),(26945,17329,'TE','5049098881',0,'2014-01-13 02:23:56',NULL,NULL),(29765,19246,'TE','5049064230',0,'2014-01-21 08:46:41',NULL,NULL),(30847,20051,'AP','9152742535',0,'2014-01-27 21:00:05',NULL,NULL),(40775,27096,'AP','3307801319',0,'2014-03-03 21:30:20',NULL,NULL),(40817,27123,'EM','phntm723@gmail.com',0,'2014-03-03 21:30:35',NULL,NULL),(42795,28460,'AP','3372581716',0,'2014-03-07 21:31:25',NULL,NULL),(43280,28756,'TE','2819007483',0,'2014-03-09 21:00:19',NULL,NULL),(774,483,'AP','9852760872',0,'2013-12-25 17:48:13',NULL,NULL),(21971,14154,'TE','6467869980',0,'2013-12-27 02:02:59',NULL,NULL),(26155,16840,'TE','3306064586',0,'2014-01-13 02:18:33',NULL,NULL),(26850,17277,'TE','3304006168',0,'2014-01-13 02:23:24',NULL,NULL),(27217,17524,'EM','s_shanahan29@yahoo.com',0,'2014-01-13 03:01:38',NULL,NULL),(30230,19582,'AP','5043432600',0,'2014-01-23 03:02:41',NULL,NULL),(31305,20399,'AP','2547178067',0,'2014-01-29 21:00:19',NULL,NULL),(35459,23318,'TE','5133191037',0,'2014-02-13 22:00:23',NULL,NULL),(35595,23409,'TE','2166181982',0,'2014-02-13 22:01:15',NULL,NULL),(41448,27535,'AP','3302096445',0,'2014-03-04 21:30:05',NULL,NULL),(41807,27793,'TE','6013628081',0,'2014-03-05 21:31:42',NULL,NULL),(42405,28164,'EM','markmerr73@yahoo.com',0,'2014-03-06 21:02:44',NULL,NULL),(240,145,'AP','4406109901',0,'2013-12-25 17:18:50',NULL,NULL),(952,585,'AP','6144466735',0,'2013-12-25 17:51:02',NULL,NULL),(10029,6560,'AP','8173719806',0,'2013-12-26 00:52:25',NULL,NULL),(1848,1142,'TE','3183400932',0,'2013-12-25 18:18:22',NULL,NULL),(20476,13188,'EM','xrae21@gmail.com',0,'2013-12-26 12:54:33',NULL,NULL),(12447,8153,'AP','5057105871',0,'2013-12-26 03:16:06',NULL,NULL),(11688,7609,'AP','8605598271',0,'2013-12-26 02:45:36',NULL,NULL),(11365,7403,'AP','3144829228',0,'2013-12-26 02:16:29',NULL,NULL),(11040,7164,'AP','7186124922',0,'2013-12-26 01:52:35',NULL,NULL),(23149,14923,'TE','3186365228',0,'2013-12-30 00:01:45',NULL,NULL),(25529,16468,'EM','shaun2240@neo.rr.com',0,'2014-01-07 04:05:52',NULL,NULL),(26293,16925,'TE','5046210515',0,'2014-01-13 02:19:45',NULL,NULL),(27072,17410,'EM','Brigmama45@yahoo.com',0,'2014-01-13 03:00:22',NULL,NULL),(28385,18287,'TE','4404528458',0,'2014-01-16 08:44:50',NULL,NULL),(31581,20596,'TE','7406761440',0,'2014-01-30 21:00:11',NULL,NULL),(32059,20933,'TE','4197719655',0,'2014-01-31 21:01:38',NULL,NULL),(32260,21071,'AP','4406687290',0,'2014-02-02 19:00:17',NULL,NULL),(43515,28894,'AP','9037361238',0,'2014-03-10 21:00:16',NULL,NULL),(32324,21117,'TE','8324125732',0,'2014-02-03 21:00:11',NULL,NULL),(32339,21127,'TE','4097198281',0,'2014-02-03 21:00:16',NULL,NULL),(33166,21722,'EM','ahmedzaitoun7@yahoo.com',0,'2014-02-06 21:00:04',NULL,NULL),(34849,22851,'TE','4193055513',0,'2014-02-11 21:02:21',NULL,NULL),(1190,727,'TE','5126692854',0,'2013-12-25 18:03:40',NULL,NULL),(21754,14011,'EM','Cozyyoung88@gmail.com',0,'2013-12-26 13:16:23',NULL,NULL),(21230,13648,'AP','2257731054',0,'2013-12-26 13:07:13',NULL,NULL),(4737,3034,'TE','4328166381',0,'2013-12-25 20:18:30',NULL,NULL),(14481,9456,'TE','7405984308',0,'2013-12-26 04:34:07',NULL,NULL),(11401,7420,'TE','7632189645',0,'2013-12-26 02:17:01',NULL,NULL),(11994,7813,'AP','8303052806',0,'2013-12-26 03:04:01',NULL,NULL),(23707,15301,'AP','3184369580',1,'2014-01-02 04:22:50',NULL,NULL),(24717,15946,'BN','9374412530',0,'2014-01-03 02:07:22',NULL,NULL),(25092,16177,'AP','3186230120',0,'2014-01-05 00:00:25',NULL,NULL),(27771,17905,'TE','2148025302',0,'2014-01-15 02:06:25',NULL,NULL),(28148,18145,'TE','9854462064',0,'2014-01-15 02:07:48',NULL,NULL),(31708,20687,'EM','junior.craig@gmail.com',0,'2014-01-30 21:00:57',NULL,NULL),(32455,21205,'TE','5046286188',0,'2014-02-03 21:00:56',NULL,NULL),(32662,21361,'TE','2818584478',0,'2014-02-04 21:00:43',NULL,NULL),(32762,21433,'TE','9362399052',0,'2014-02-04 21:01:20',NULL,NULL),(34077,22339,'TE','5134241755',0,'2014-02-10 11:01:07',NULL,NULL),(34266,22481,'EM','loglan353@yahoo.com',0,'2014-02-10 21:31:03',NULL,NULL),(36308,23905,'EM','cynthia0772@yahoo.com',0,'2014-02-14 21:32:27',NULL,NULL),(37547,24719,'EM','jordan.conti@gmail.com',0,'2014-02-20 04:37:58',NULL,NULL),(38462,25417,'EM','katiecat082@gmail.com',0,'2014-02-25 21:31:07',NULL,NULL),(38711,25586,'AP','9852498103',0,'2014-02-26 08:00:40',NULL,NULL),(43427,28838,'AP','5133066453',0,'2014-03-09 21:01:11',NULL,NULL),(574,355,'AP','4193228878',0,'2013-12-25 17:32:25',NULL,NULL),(1165,714,'AP','5672075556',0,'2013-12-25 18:03:17',NULL,NULL),(21379,13745,'AP','5138500350',0,'2013-12-26 13:09:49',NULL,NULL),(21059,13545,'TE','2203057148',0,'2013-12-26 13:03:55',NULL,NULL),(9788,6403,'EM','adonahue2008@live.com',0,'2013-12-26 00:48:26',NULL,NULL),(7035,4594,'AP','4252701984',0,'2013-12-25 22:05:33',NULL,NULL),(11862,7722,'EM','jess2665@yahoo.com',0,'2013-12-26 03:01:46',NULL,NULL),(6806,4416,'AP','6149898971',0,'2013-12-25 22:01:30',NULL,NULL),(23562,15207,'TE','6013659885',0,'2014-01-01 12:07:36',NULL,NULL),(26258,16899,'AP','9375324274',0,'2014-01-13 02:19:32',NULL,NULL),(27609,17798,'TE','3142585587',0,'2014-01-14 01:33:52',NULL,NULL),(29739,19229,'TE','4198102622',0,'2014-01-21 08:46:32',NULL,NULL),(31861,20799,'EM','raul.rodriguez370@yahoo.com',0,'2014-01-31 21:00:20',NULL,NULL),(32095,20961,'AP','3252071291',0,'2014-02-01 19:00:09',NULL,NULL),(33372,21866,'AP','9855802634',0,'2014-02-06 21:01:23',NULL,NULL),(33602,22034,'TE','5137775632',0,'2014-02-07 19:01:04',NULL,NULL),(34635,22710,'TE','9853817079',0,'2014-02-11 21:01:04',NULL,NULL),(36987,24352,'TE','8145049850',0,'2014-02-18 22:00:27',NULL,NULL),(38199,25214,'AP','4192033473',0,'2014-02-21 22:00:52',NULL,NULL),(38211,25221,'TE','6019822549',0,'2014-02-21 22:00:57',NULL,NULL),(39043,25820,'AP','5138241332',0,'2014-02-26 21:00:25',NULL,NULL),(41870,27841,'TE','9563830645',0,'2014-03-05 21:32:08',NULL,NULL),(43590,28943,'AP','9852103537',0,'2014-03-10 21:00:44',NULL,NULL),(117,69,'AP','5132257760',0,'2013-12-25 17:16:53',NULL,NULL),(9901,6479,'TE','4409970463',0,'2013-12-26 00:50:17',NULL,NULL),(20252,13046,'AP','5134607240',0,'2013-12-26 12:50:45',NULL,NULL),(10871,7057,'TE','5132333772',0,'2013-12-26 01:49:51',NULL,NULL),(3575,2239,'AP','4199085398',0,'2013-12-25 19:20:59',NULL,NULL),(7587,4941,'TE','2164088279',0,'2013-12-25 22:45:40',NULL,NULL),(24711,15944,'TE','5743837154',0,'2014-01-03 02:07:16',NULL,NULL),(25426,16399,'TE','8174513947',0,'2014-01-07 04:03:49',NULL,NULL),(27551,17755,'EM','cspann103@att.net',0,'2014-01-14 01:33:30',NULL,NULL),(31657,20652,'TE','9564629014',0,'2014-01-30 21:00:39',NULL,NULL),(32838,21488,'TE','4194083343',0,'2014-02-04 21:01:47',NULL,NULL),(33720,22118,'EM','marynka.z.marquez@gmail.com',0,'2014-02-08 19:00:38',NULL,NULL),(35797,23538,'AP','3182688820',0,'2014-02-13 22:02:31',NULL,NULL),(36591,24089,'TE','3303175326',0,'2014-02-15 22:01:25',NULL,NULL),(37355,24592,'AP','5133002623',0,'2014-02-20 04:11:07',NULL,NULL),(39394,26050,'AP','3308588977',0,'2014-02-26 21:02:33',NULL,NULL),(40239,26691,'TE','3183448015',0,'2014-02-28 21:31:29',NULL,NULL),(40404,26819,'EM','Tom.Reding@gmail.com',0,'2014-03-01 21:00:33',NULL,NULL),(41548,27627,'TE','4192355099',0,'2014-03-05 21:30:08',NULL,NULL),(43127,28669,'TE','3376392948',0,'2014-03-08 21:30:48',NULL,NULL),(393,241,'TE','4194784361',0,'2013-12-25 17:21:19',NULL,NULL),(21649,13933,'EM','jimburrington@aol.com',0,'2013-12-26 13:14:33',NULL,NULL),(1524,938,'AP','5134007013',0,'2013-12-25 18:09:16',NULL,NULL),(5930,3802,'AP','4403199660',0,'2013-12-25 21:34:34',NULL,NULL),(12086,7899,'TE','4193940191',0,'2013-12-26 03:05:46',NULL,NULL),(24306,15702,'AP','2052469517',1,'2014-01-02 04:35:46',NULL,NULL),(25186,16240,'TE','5047822015',0,'2014-01-05 00:02:21',NULL,NULL),(26669,17157,'EM','jadams@vaneatonromero.com',0,'2014-01-13 02:22:00',NULL,NULL),(27810,17922,'TE','5127314344',0,'2014-01-15 02:06:31',NULL,NULL),(29156,18837,'TE','3303290857',0,'2014-01-17 03:36:11',NULL,NULL),(31402,20470,'EM','mcefcu630@aol.com',0,'2014-01-29 21:00:55',NULL,NULL),(33911,22259,'TE','9567935448',0,'2014-02-10 11:00:06',NULL,NULL),(36788,24222,'TE','9794920567',0,'2014-02-16 19:00:29',NULL,NULL),(37588,24761,'EM','nmoore4035@yahoo.com',0,'2014-02-20 04:43:12',NULL,NULL),(37826,24960,'TE','2253013486',0,'2014-02-20 22:00:18',NULL,NULL),(38815,25662,'TE','3305694127',0,'2014-02-26 08:30:45',NULL,NULL),(39201,25925,'EM','searanchtexas@rgv.rr.com',0,'2014-02-26 21:01:23',NULL,NULL),(39267,25978,'AP','7404035993',0,'2014-02-26 21:01:50',NULL,NULL),(41264,27422,'TE','9854479667',0,'2014-03-04 21:01:40',NULL,NULL),(7742,5051,'EM','maritza_seco@hotmail.com',0,'2013-12-25 23:00:12',NULL,NULL),(20942,13469,'TE','9372310660',0,'2013-12-26 13:01:59',NULL,NULL),(20509,13204,'TE','9726254477',0,'2013-12-26 12:55:03',NULL,NULL),(5646,3622,'EM','alriegler@juno.com',0,'2013-12-25 21:23:44',NULL,NULL),(3188,2003,'AP','5133681522',0,'2013-12-25 19:02:16',NULL,NULL),(11998,7815,'AP','9033302352',0,'2013-12-26 03:04:05',NULL,NULL),(11737,7640,'TE','9375264412',0,'2013-12-26 02:46:33',NULL,NULL),(26130,16823,'AP','2253691716',0,'2014-01-13 02:18:24',NULL,NULL),(27275,17559,'EM','janetmb79@yahoo.com',0,'2014-01-13 03:02:00',NULL,NULL),(29375,18982,'EM','deblarprice@msn.com',0,'2014-01-20 08:06:07',NULL,NULL),(29641,19151,'TE','4193008336',0,'2014-01-21 08:45:35',NULL,NULL),(29955,19385,'TE','2164645068',1,'2014-01-22 03:22:44',NULL,NULL),(33353,21850,'TE','3047302937',0,'2014-02-06 21:01:15',NULL,NULL),(33522,21977,'TE','5043446088',0,'2014-02-07 19:00:34',NULL,NULL),(33734,22135,'AP','4408675961',0,'2014-02-08 19:00:45',NULL,NULL),(34089,22345,'AP','3306209445',0,'2014-02-10 11:01:12',NULL,NULL),(35991,23678,'AP','3377899679',0,'2014-02-14 21:30:29',NULL,NULL),(37335,24580,'EM','susanmarieczekansky@aol.com',0,'2014-02-20 04:08:44',NULL,NULL),(37607,24782,'TE','6145569340',0,'2014-02-20 04:45:35',NULL,NULL),(39874,26378,'BN','2253851630',0,'2014-02-28 07:00:18',NULL,NULL),(9660,6324,'TE','7405373738',0,'2013-12-26 00:46:26',NULL,NULL),(7796,5088,'EM','timw09@att.net',0,'2013-12-25 23:01:08',NULL,NULL),(7099,4634,'TE','6622300938',0,'2013-12-25 22:06:37',NULL,NULL),(12335,8068,'AP','3307044711',0,'2013-12-26 03:10:08',NULL,NULL),(2466,1512,'EM','nperkins04@gmail.com',0,'2013-12-25 18:49:34',NULL,NULL),(33132,21701,'TE','6018859497',0,'2014-02-05 21:31:11',NULL,NULL),(31064,20210,'TE','4404208513',0,'2014-01-27 21:01:38',NULL,NULL),(24533,15823,'AP','3308586636',0,'2014-01-03 02:03:36',NULL,NULL),(21133,13588,'AP','5049311099',0,'2013-12-26 13:05:06',NULL,NULL),(38064,25124,'EM','peterulrick@yahoo.com',0,'2014-02-21 21:30:22',NULL,NULL),(34609,22694,'AP','8323523895',0,'2014-02-11 21:00:54',NULL,NULL),(23315,15024,'TE','3374363557',0,'2014-01-01 12:02:24',NULL,NULL),(31542,20558,'AP','4193454000',0,'2014-01-29 21:01:45',NULL,NULL),(6989,4565,'AP','5672453259',0,'2013-12-25 22:04:48',NULL,NULL),(5890,3778,'TE','3305544246',0,'2013-12-25 21:33:55',NULL,NULL),(38729,25601,'TE','9853603828',0,'2014-02-26 08:00:51',NULL,NULL),(39671,26231,'TE','9158508757',0,'2014-02-28 06:31:01',NULL,NULL),(30832,20044,'AP','4193044894',0,'2014-01-26 19:00:29',NULL,NULL),(11860,7720,'TE','3307339127',0,'2013-12-26 03:01:44',NULL,NULL),(12290,8037,'EM','rhmoxl@gmail.com',0,'2013-12-26 03:09:20',NULL,NULL),(7725,5043,'AP','8325413915',0,'2013-12-25 22:48:05',NULL,NULL),(10524,6854,'AP','9374777363',0,'2013-12-26 01:31:29',NULL,NULL),(37378,24613,'TE','6015591201',0,'2014-02-20 04:14:35',NULL,NULL),(39551,26165,'TE','7692575348',0,'2014-02-28 06:30:34',NULL,NULL),(171,100,'TE','8307926769',0,'2013-12-25 17:17:43',NULL,NULL),(36122,23775,'TE','2069997234',0,'2014-02-14 21:31:15',NULL,NULL),(764,478,'AP','3058070569',0,'2013-12-25 17:48:05',NULL,NULL),(22544,14537,'AP','6015023478',0,'2013-12-28 03:34:43',NULL,NULL),(22415,14455,'AP','9319808803',0,'2013-12-28 03:32:37',NULL,NULL),(35946,23650,'EM','asiddig.mwi@gmail.com',0,'2014-02-14 21:30:14',NULL,NULL),(32990,21597,'EM','SHARIQSAMI@YAHOO.COM',0,'2014-02-05 21:30:31',NULL,NULL),(40656,26989,'AP','4199570822',0,'2014-03-03 01:00:41',NULL,NULL),(27153,17484,'TE','8325072089',0,'2014-01-13 03:01:15',NULL,NULL),(20262,13058,'AP','3304147918',0,'2013-12-26 12:51:01',NULL,NULL),(14926,9766,'AP','9375644234',0,'2013-12-26 05:00:20',NULL,NULL),(11178,7269,'AP','5712961716',0,'2013-12-26 02:02:23',NULL,NULL),(34857,22861,'TE','2283633657',0,'2014-02-11 21:02:25',NULL,NULL),(37885,24993,'AP','9727402171',0,'2014-02-20 22:00:41',NULL,NULL),(40269,26714,'AP','7692032051',0,'2014-02-28 21:31:40',NULL,NULL),(41044,27268,'TE','3183019001',0,'2014-03-04 21:00:14',NULL,NULL),(43800,29077,'AP','9012395771',0,'2014-03-10 21:02:01',NULL,NULL),(24107,15562,'TE','3305846615',1,'2014-01-02 04:31:38',NULL,NULL),(1968,1218,'TE','3308054169',0,'2013-12-25 18:20:19',NULL,NULL),(35426,23289,'TE','3304647962',0,'2014-02-13 22:00:06',NULL,NULL),(34962,22953,'TE','5134597369',0,'2014-02-12 21:00:04',NULL,NULL),(33260,21779,'EM','rsbengals@gmail.com',0,'2014-02-06 21:00:37',NULL,NULL),(24450,15784,'AP','9712852829',0,'2014-01-03 02:02:15',NULL,NULL),(12070,7880,'TE','2163981905',0,'2013-12-26 03:05:25',NULL,NULL),(2793,1690,'EM','wjnaz@yahoo.com',0,'2013-12-25 18:54:27',NULL,NULL),(23352,15043,'AP','3374521572',0,'2014-01-01 12:03:03',NULL,NULL),(11019,7153,'TE','4194960026',0,'2013-12-26 01:52:15',NULL,NULL),(31444,20495,'AP','7133922194',0,'2014-01-29 21:01:09',NULL,NULL),(36834,24257,'EM','myera79@gmail.com',0,'2014-02-17 19:00:08',NULL,NULL),(38717,25591,'AP','9853817079',0,'2014-02-26 08:00:43',NULL,NULL),(27403,17646,'EM','healthcare.gov@middens.com',0,'2014-01-14 01:32:39',NULL,NULL),(29935,19374,'TE','6623952231',1,'2014-01-22 03:22:38',NULL,NULL),(38478,25427,'AP','6142709931',0,'2014-02-25 21:31:13',NULL,NULL),(38787,25644,'TE','3302210493',0,'2014-02-26 08:30:33',NULL,NULL),(40424,26836,'TE','2165260187',0,'2014-03-01 21:00:42',NULL,NULL),(41306,27441,'AP','3187805106',0,'2014-03-04 21:01:53',NULL,NULL),(9139,5986,'TE','5672074765',0,'2013-12-25 23:52:05',NULL,NULL),(3813,2428,'TE','7404074919',0,'2013-12-25 19:34:05',NULL,NULL),(25999,16750,'AP','8065182872',0,'2014-01-08 18:24:54',NULL,NULL),(115,68,'AP','5135034270',0,'2013-12-25 17:16:51',NULL,NULL),(400,244,'EM','brunpat@yahoo.com',0,'2013-12-25 17:21:26',NULL,NULL),(11164,7262,'TE','8308950675',0,'2013-12-26 02:02:10',NULL,NULL),(7562,4925,'TE','2169323609',0,'2013-12-25 22:45:15',NULL,NULL),(21682,13961,'TE','9376579994',0,'2013-12-26 13:15:08',NULL,NULL),(21558,13862,'TE','3306711258',0,'2013-12-26 13:12:51',NULL,NULL),(14941,9774,'AP','5044914112',0,'2013-12-26 05:00:34',NULL,NULL),(28763,18560,'AP','9377799127',0,'2014-01-16 08:46:59',NULL,NULL),(32611,21323,'TE','3185022259',0,'2014-02-04 21:00:24',NULL,NULL),(33728,22129,'TE','6146709552',0,'2014-02-08 19:00:42',NULL,NULL),(38687,25567,'EM','tvizzo@yahoo.com',0,'2014-02-26 08:00:28',NULL,NULL),(43574,28936,'AP','7403173423',0,'2014-03-10 21:00:40',NULL,NULL),(14947,9777,'AP','5135321072',0,'2013-12-26 05:00:39',NULL,NULL),(34777,22809,'AP','5138023311',0,'2014-02-11 21:01:57',NULL,NULL),(33542,21990,'EM','bernitaT1950@gmail.com',0,'2014-02-07 19:00:42',NULL,NULL),(21292,13680,'EM','roseancla@aol.com',0,'2013-12-26 13:08:09',NULL,NULL),(28094,18108,'TE','3185288187',0,'2014-01-15 02:07:36',NULL,NULL),(30772,20006,'TE','4402270369',0,'2014-01-26 19:00:06',NULL,NULL),(38194,25208,'AP','3306218437',0,'2014-02-21 22:00:50',NULL,NULL),(40661,26992,'TE','6146071980',0,'2014-03-03 01:29:59',NULL,NULL),(42693,28400,'TE','4409434974',0,'2014-03-07 21:30:50',NULL,NULL),(11356,7398,'AP','2162885771',0,'2013-12-26 02:16:21',NULL,NULL),(26042,16777,'TE','9375488640',0,'2014-01-08 18:25:04',NULL,NULL),(6982,4555,'AP','3303106801',0,'2013-12-25 22:04:37',NULL,NULL),(25473,16426,'TE','5135761685',0,'2014-01-07 04:04:39',NULL,NULL),(25276,16297,'TE','3182298862',0,'2014-01-07 04:01:03',NULL,NULL),(564,349,'EM','caregivergal2002@gmail.com',0,'2013-12-25 17:32:13',NULL,NULL),(3129,1949,'EM','EmilyACampbell12@gmail.com',0,'2013-12-25 19:00:56',NULL,NULL),(25798,16625,'EM','mmills1954@yahoo.com',0,'2014-01-08 18:24:12',NULL,NULL),(25005,16114,'AP','6017957083',0,'2014-01-04 02:05:12',NULL,NULL),(2361,1434,'AP','3377811269',0,'2013-12-25 18:47:40',NULL,NULL),(13854,9033,'AP','3308023190',0,'2013-12-26 04:05:39',NULL,NULL),(21089,13561,'TE','2252845545',0,'2013-12-26 13:04:22',NULL,NULL),(31434,20490,'EM','ALWAYZSMILIN80@YAHOO.COM',0,'2014-01-29 21:01:06',NULL,NULL),(41191,27356,'TE','9377604128',0,'2014-03-04 21:01:09',NULL,NULL),(41505,27590,'EM','carrie@cmossphoto.com',0,'2014-03-05 21:00:17',NULL,NULL),(35780,23530,'AP','3374143176',0,'2014-02-13 22:02:25',NULL,NULL),(29809,19288,'AP','5042140869',1,'2014-01-22 03:21:53',NULL,NULL),(31678,20666,'AP','6018962025',0,'2014-01-30 21:00:46',NULL,NULL),(41783,27779,'TE','3303215015',0,'2014-03-05 21:31:32',NULL,NULL),(26656,17148,'TE','5042149762',0,'2014-01-13 02:21:55',NULL,NULL),(32158,21005,'EM','rkenard@yahoo.com',0,'2014-02-01 19:00:31',NULL,NULL),(11743,7643,'AP','5136802156',0,'2013-12-26 02:46:38',NULL,NULL),(9718,6361,'AP','6142030015',0,'2013-12-26 00:47:22',NULL,NULL),(4640,2961,'TE','2815927528',0,'2013-12-25 20:16:46',NULL,NULL),(11871,7727,'AP','4408295665',0,'2013-12-26 03:01:55',NULL,NULL),(8563,5627,'TE','3308073625',0,'2013-12-25 23:30:56',NULL,NULL),(12439,8149,'TE','8177829692',0,'2013-12-26 03:15:58',NULL,NULL),(34430,22586,'EM','mthobe@aol.com',0,'2014-02-10 21:32:06',NULL,NULL),(26128,16822,'EM','tonyst@foodsales.edu',0,'2014-01-13 02:18:23',NULL,NULL),(5341,3421,'EM','eotwsbayoupigeon@icloud.com',0,'2013-12-25 21:18:40',NULL,NULL),(9980,6532,'TE','3617397516',0,'2013-12-26 00:51:41',NULL,NULL),(8274,5419,'AP','6014977499',0,'2013-12-25 23:09:21',NULL,NULL),(14547,9503,'EM','kshimpo@gmail.com',0,'2013-12-26 04:35:15',NULL,NULL),(28923,18674,'TE','8063740033',0,'2014-01-17 03:35:18',NULL,NULL),(28609,18441,'AP','5042504143',0,'2014-01-16 08:46:03',NULL,NULL),(42838,28491,'AP','6016722180',0,'2014-03-07 21:31:42',NULL,NULL),(6401,4129,'EM','CRAIGTRANUM@GMAIL.COM',0,'2013-12-25 21:48:22',NULL,NULL),(29937,19375,'TE','6016222390',1,'2014-01-22 03:22:38',NULL,NULL),(30794,20023,'TE','3188347065',0,'2014-01-26 19:00:16',NULL,NULL),(22567,14552,'EM','yorkwhk3@yahoo.com',0,'2013-12-28 03:35:05',NULL,NULL),(40992,27235,'AP','6017380766',0,'2014-03-03 21:31:44',NULL,NULL),(26317,16943,'AP','9856376811',0,'2014-01-13 02:19:55',NULL,NULL),(2889,1769,'AP','3306873549',0,'2013-12-25 18:56:06',NULL,NULL),(34538,22655,'EM','yoliroblescasanova@gmail.com',0,'2014-02-11 21:00:31',NULL,NULL),(1238,753,'EM','jenniferminard195@yahoo.com',0,'2013-12-25 18:04:21',NULL,NULL),(1920,1191,'TE','2163722136',0,'2013-12-25 18:19:36',NULL,NULL),(24350,15727,'TE','5132541078',0,'2014-01-03 02:00:22',NULL,NULL),(6620,4277,'AP','9372054911',0,'2013-12-25 21:51:55',NULL,NULL),(5826,3740,'AP','8303778409',0,'2013-12-25 21:32:52',NULL,NULL),(4959,3182,'AP','5045595833',0,'2013-12-25 20:31:53',NULL,NULL),(43337,28787,'EM','jjslay@live.com',0,'2014-03-09 21:00:39',NULL,NULL),(43360,28799,'TE','3303424511',0,'2014-03-09 21:00:47',NULL,NULL),(36916,24313,'EM','lorita@flash.net',0,'2014-02-18 22:00:03',NULL,NULL),(34370,22543,'TE','2252442051',0,'2014-02-10 21:31:40',NULL,NULL),(30164,19544,'TE','6018597379',0,'2014-01-23 03:02:26',NULL,NULL),(40814,27120,'EM','blackdesk1222@yahoo.com',0,'2014-03-03 21:30:33',NULL,NULL),(41904,27863,'TE','2163467860',0,'2014-03-05 21:32:20',NULL,NULL),(14959,9788,'EM','tycho83@yahoo.com',0,'2013-12-26 05:00:53',NULL,NULL),(23501,15156,'EM','teedog@insight.rr.com',0,'2014-01-01 12:06:13',NULL,NULL),(6819,4427,'TE','6144048740',0,'2013-12-25 22:01:45',NULL,NULL),(10137,6625,'EM','steveshipley7@gmail.com',0,'2013-12-26 00:54:12',NULL,NULL),(1976,1221,'TE','4404740020',0,'2013-12-25 18:20:25',NULL,NULL),(5658,3632,'TE','9377800045',0,'2013-12-25 21:30:10',NULL,NULL),(3308,2082,'TE','3379623973',0,'2013-12-25 19:16:38',NULL,NULL),(25610,16519,'AP','7132051245',1,'2014-01-07 10:21:38',NULL,NULL),(25392,16376,'EM','OPPORTUNYEMPLOMENT@HOTMAIL.COM',0,'2014-01-07 04:03:11',NULL,NULL),(27038,17385,'AP','4125923082',0,'2014-01-13 03:00:08',NULL,NULL),(13517,8812,'EM','Sanrog123@cinci.rr.com',0,'2013-12-26 04:00:04',NULL,NULL),(6316,4073,'TE','6147079353',0,'2013-12-25 21:46:59',NULL,NULL),(22841,14737,'EM','Mitch.smith147@gmail.com',1,'2013-12-29 11:09:56',NULL,NULL),(34738,22778,'AP','7142648337',0,'2014-02-11 21:01:42',NULL,NULL),(31803,20761,'TE','4193482555',0,'2014-01-30 21:01:35',NULL,NULL),(31539,20554,'TE','4194075083',0,'2014-01-29 21:01:43',NULL,NULL),(42466,28215,'TE','5133835100',0,'2014-03-06 21:30:16',NULL,NULL),(34924,22917,'AP','9378221336',0,'2014-02-11 21:02:52',NULL,NULL),(28258,18221,'AP','9569498950',0,'2014-01-16 08:44:14',NULL,NULL),(28474,18345,'EM','ddamon1817@yahoo.com',0,'2014-01-16 08:45:20',NULL,NULL),(14846,9715,'AP','6144048001',0,'2013-12-26 04:45:19',NULL,NULL),(30346,19664,'TE','3303960078',0,'2014-01-23 21:00:26',NULL,NULL),(30441,19734,'TE','3184390271',0,'2014-01-23 21:01:07',NULL,NULL),(31142,20283,'AP','5134603003',0,'2014-01-28 21:00:31',NULL,NULL),(39248,25966,'TE','5134446590',0,'2014-02-26 21:01:43',NULL,NULL),(40387,26807,'TE','4409791413',0,'2014-03-01 21:00:27',NULL,NULL),(10176,6651,'TE','5133102064',0,'2013-12-26 01:00:33',NULL,NULL),(23478,15141,'AP','2166780999',0,'2014-01-01 12:05:45',NULL,NULL),(22422,14459,'AP','5044516008',0,'2013-12-28 03:32:43',NULL,NULL),(1654,1015,'AP','6012703270',0,'2013-12-25 18:15:06',NULL,NULL),(34059,22331,'TE','2108271733',0,'2014-02-10 11:01:01',NULL,NULL),(22030,14186,'EM','EHILLCHILL@GMAIL.COM',0,'2013-12-27 02:03:53',NULL,NULL),(33489,21944,'AP','7733922429',0,'2014-02-07 19:00:17',NULL,NULL),(33061,21657,'TE','9853203278',0,'2014-02-05 21:30:53',NULL,NULL),(21319,13699,'AP','3307019823',0,'2013-12-26 13:08:37',NULL,NULL),(11420,7430,'TE','4197871986',0,'2013-12-26 02:30:08',NULL,NULL),(4642,2962,'AP','3182377711',0,'2013-12-25 20:16:48',NULL,NULL),(27374,17623,'TE','8173230285',0,'2014-01-14 01:32:28',NULL,NULL),(29080,18782,'AP','2164081129',0,'2014-01-17 03:35:53',NULL,NULL),(39743,26284,'TE','9858920569',0,'2014-02-28 06:31:21',NULL,NULL),(40735,27071,'AP','2406014646',0,'2014-03-03 21:30:06',NULL,NULL),(41464,27552,'BN','9564561808',0,'2014-03-04 21:30:13',NULL,NULL),(2947,1816,'EM','bills@acsoutlet.com',0,'2013-12-25 18:57:07',NULL,NULL),(26307,16939,'TE','3189460808',0,'2014-01-13 02:19:52',NULL,NULL),(10022,6556,'EM','gdb1630@msn.com',0,'2013-12-26 00:52:18',NULL,NULL),(36683,24153,'AP','3308138488',0,'2014-02-15 22:01:58',NULL,NULL),(32732,21412,'TE','5133758968',0,'2014-02-04 21:01:09',NULL,NULL),(32111,20969,'AP','9565331431',0,'2014-02-01 19:00:14',NULL,NULL),(30644,19888,'TE','3472069613',0,'2014-01-24 21:00:50',NULL,NULL),(4259,2723,'EM','cherryadavenport@yahoo.com',0,'2013-12-25 19:48:16',NULL,NULL),(29759,19243,'EM','Calaway13660@aol.com',0,'2014-01-21 08:46:39',NULL,NULL),(5179,3326,'TE','5132603815',0,'2013-12-25 21:16:10',NULL,NULL),(37783,24935,'TE','6018450767',0,'2014-02-20 21:30:22',NULL,NULL),(11100,7209,'EM','matt-bliss@hotmail.com',0,'2013-12-26 02:00:53',NULL,NULL),(4153,2649,'TE','2107227270',0,'2013-12-25 19:46:34',NULL,NULL),(10812,7023,'AP','2817040105',0,'2013-12-26 01:48:54',NULL,NULL),(31907,20823,'EM','roberson12@centurytel.net',0,'2014-01-31 21:00:37',NULL,NULL),(31869,20804,'TE','7137960716',0,'2014-01-31 21:00:24',NULL,NULL),(9820,6425,'TE','2252215343',0,'2013-12-26 00:49:00',NULL,NULL),(30396,19698,'TE','3258000234',0,'2014-01-23 21:00:46',NULL,NULL),(6595,4258,'TE','3306555310',0,'2013-12-25 21:51:28',NULL,NULL),(3142,1961,'TE','8176816774',0,'2013-12-25 19:01:13',NULL,NULL),(27478,17700,'EM','Jamestown1993@msn.com',0,'2014-01-14 01:33:04',NULL,NULL),(21257,13660,'EM','kghanson56@gmail.com',0,'2013-12-26 13:07:36',NULL,NULL),(38465,25420,'AP','2169704658',0,'2014-02-25 21:31:08',NULL,NULL),(6570,4241,'TE','2146167763',0,'2013-12-25 21:51:02',NULL,NULL),(35209,23125,'AP','4086939483',0,'2014-02-12 21:31:26',NULL,NULL),(35206,23124,'AP','6142714204',0,'2014-02-12 21:31:25',NULL,NULL),(11793,7671,'TE','2252161240',0,'2013-12-26 03:00:34',NULL,NULL),(35047,23016,'AP','2252260191',0,'2014-02-12 21:30:27',NULL,NULL),(21795,14043,'EM','cmg45415@yahoo.com',0,'2013-12-27 02:00:05',NULL,NULL),(33613,22043,'AP','5618278491',0,'2014-02-07 19:01:10',NULL,NULL),(32246,21059,'AP','5043557968',0,'2014-02-02 19:00:11',NULL,NULL),(25428,16400,'TE','2144054413',0,'2014-01-07 04:03:51',NULL,NULL),(25627,16526,'EM','KATHYL53@YAHOO.COM',1,'2014-01-07 10:21:56',NULL,NULL),(33278,21791,'TE','9373640176',0,'2014-02-06 21:00:44',NULL,NULL),(31617,20624,'TE','9563509584',0,'2014-01-30 21:00:25',NULL,NULL),(28806,18592,'TE','4192246764',0,'2014-01-16 08:47:14',NULL,NULL),(28354,18271,'TE','9797583332',0,'2014-01-16 08:44:41',NULL,NULL),(20895,13436,'TE','6507145966',0,'2013-12-26 13:01:10',NULL,NULL),(25141,16206,'AP','9564388855',0,'2014-01-05 00:01:19',NULL,NULL),(39320,26009,'TE','7406735172',0,'2014-02-26 21:02:09',NULL,NULL),(41536,27621,'TE','2252769084',0,'2014-03-05 21:30:04',NULL,NULL),(42534,28298,'TE','5136009127',0,'2014-03-07 21:00:31',NULL,NULL),(43022,28606,'TE','6149375625',0,'2014-03-08 21:30:13',NULL,NULL),(4288,2738,'EM','carole799@yahoo.com',0,'2013-12-25 19:48:43',NULL,NULL),(25228,16266,'EM','mckees66@yahoo.com',0,'2014-01-07 04:00:10',NULL,NULL),(36847,24264,'AP','4693162371',0,'2014-02-17 19:00:13',NULL,NULL),(9686,6346,'TE','7407721286',0,'2013-12-26 00:46:54',NULL,NULL),(41776,27775,'EM','btf3eternal@gmail.com',0,'2014-03-05 21:31:30',NULL,NULL),(643,400,'TE','2146827386',0,'2013-12-25 17:46:08',NULL,NULL),(4767,3052,'TE','2253687755',0,'2013-12-25 20:18:56',NULL,NULL),(38779,25637,'TE','3377818004',0,'2014-02-26 08:30:28',NULL,NULL),(6213,4003,'TE','5137420862',0,'2013-12-25 21:45:14',NULL,NULL),(33792,22182,'AP','8063191174',0,'2014-02-09 19:00:04',NULL,NULL),(20829,13387,'EM','gabrielkmudd@gmail.com',0,'2013-12-26 13:00:03',NULL,NULL),(32397,21168,'TE','5138441366',0,'2014-02-03 21:00:36',NULL,NULL),(38033,25088,'TE','3189268081',0,'2014-02-21 21:30:04',NULL,NULL),(37428,24645,'EM','jvancol95@hotmail.com',0,'2014-02-20 04:21:30',NULL,NULL),(35723,23493,'BN','5136044829',0,'2014-02-13 22:02:03',NULL,NULL),(9440,6180,'TE','4192556198',0,'2013-12-26 00:17:18',NULL,NULL),(29310,18936,'AP','5133640256',0,'2014-01-20 08:05:42',NULL,NULL),(7984,5208,'TE','5136020127',0,'2013-12-25 23:04:14',NULL,NULL),(25772,16608,'TE','2253024356',0,'2014-01-08 18:24:07',NULL,NULL),(2646,1609,'AP','3615503199',0,'2013-12-25 18:52:15',NULL,NULL),(22719,14650,'TE','9366457697',1,'2013-12-29 11:07:43',NULL,NULL),(11673,7599,'TE','3306275467',0,'2013-12-26 02:45:20',NULL,NULL),(12448,8153,'EM','crulibarri@miners.utep.edu',0,'2013-12-26 03:16:06',NULL,NULL),(4922,3160,'AP','4405546379',0,'2013-12-25 20:31:18',NULL,NULL),(6994,4567,'EM','txtxbkirkland@prodigy.net',0,'2013-12-25 22:04:52',NULL,NULL),(38705,25578,'EM','polarjen@woh.rr.com',0,'2014-02-26 08:00:34',NULL,NULL),(13683,8921,'AP','9377188511',0,'2013-12-26 04:02:47',NULL,NULL),(36857,24273,'TE','9374690634',0,'2014-02-17 19:00:18',NULL,NULL),(36804,24233,'AP','6013474332',0,'2014-02-16 19:00:35',NULL,NULL),(22709,14644,'EM','rayandcandy@yahoo.com',1,'2013-12-29 11:07:33',NULL,NULL),(39397,26051,'AP','5672156452',0,'2014-02-26 21:02:33',NULL,NULL),(9647,6312,'TE','4198893730',0,'2013-12-26 00:46:12',NULL,NULL),(38126,25166,'TE','9375416238',0,'2014-02-21 22:00:25',NULL,NULL),(35682,23470,'AP','4696282097',0,'2014-02-13 22:01:48',NULL,NULL),(34151,22392,'TE','3309060413',0,'2014-02-10 21:30:16',NULL,NULL),(34973,22962,'TE','6013627371',0,'2014-02-12 21:00:10',NULL,NULL),(36720,24177,'EM','tomandbev@windstream.net',0,'2014-02-16 19:00:06',NULL,NULL),(41198,27363,'TE','7405445483',0,'2014-03-04 21:01:12',NULL,NULL),(94,56,'TE','3304052938',0,'2013-12-25 17:16:32',NULL,NULL),(23120,14904,'TE','6626094981',0,'2013-12-30 00:01:14',NULL,NULL),(21995,14167,'AP','5044307243',0,'2013-12-27 02:03:20',NULL,NULL),(216,130,'AP','2167049522',0,'2013-12-25 17:18:28',NULL,NULL),(8317,5452,'TE','5134320261',0,'2013-12-25 23:10:13',NULL,NULL),(624,383,'TE','9567891365',0,'2013-12-25 17:45:47',NULL,NULL),(7268,4737,'AP','4192301765',0,'2013-12-25 22:09:20',NULL,NULL),(12215,7981,'TE','2162729367',0,'2013-12-26 03:07:58',NULL,NULL),(6234,4017,'AP','5672041369',0,'2013-12-25 21:45:35',NULL,NULL),(4941,3173,'TE','4402480265',0,'2013-12-25 20:31:36',NULL,NULL),(5891,3778,'AP','3305544246',0,'2013-12-25 21:33:55',NULL,NULL),(29544,19094,'AP','4193020010',0,'2014-01-21 08:44:34',NULL,NULL),(29994,19420,'TE','4194726988',1,'2014-01-22 03:23:02',NULL,NULL),(30475,19761,'TE','7404266778',0,'2014-01-23 21:01:24',NULL,NULL),(31180,20305,'EM','kevinb2016@yahoo.com',0,'2014-01-28 21:00:46',NULL,NULL),(32085,20954,'AP','3235164041',0,'2014-02-01 19:00:06',NULL,NULL),(41979,27904,'TE','9722858790',0,'2014-03-06 21:00:11',NULL,NULL),(43466,28867,'AP','9796370450',0,'2014-03-10 21:00:00',NULL,NULL),(37953,25043,'EM','climax1969@gmail.com',0,'2014-02-20 22:01:11',NULL,NULL),(40459,26858,'AP','9372170522',0,'2014-03-01 21:00:55',NULL,NULL),(1140,701,'AP','5042929996',0,'2013-12-25 18:02:55',NULL,NULL),(9431,6173,'TE','5127969236',0,'2013-12-26 00:17:07',NULL,NULL),(22569,14553,'EM','martha.partin@yahoo.com',0,'2013-12-28 03:35:07',NULL,NULL),(2140,1320,'TE','7403521089',0,'2013-12-25 18:31:42',NULL,NULL),(7999,5220,'AP','5132644351',0,'2013-12-25 23:04:31',NULL,NULL),(14750,9647,'EM','gdrummer23@hotmail.com',0,'2013-12-26 04:38:40',NULL,NULL),(12376,8105,'TE','5613191627',0,'2013-12-26 03:10:57',NULL,NULL),(23590,15232,'AP','5136357237',0,'2014-01-01 12:08:18',NULL,NULL),(24081,15545,'AP','9852471485',1,'2014-01-02 04:31:07',NULL,NULL),(32379,21158,'TE','5138244845',0,'2014-02-03 21:00:31',NULL,NULL),(32676,21370,'TE','3255744636',0,'2014-02-04 21:00:48',NULL,NULL),(36430,23992,'AP','2252683211',0,'2014-02-15 22:00:27',NULL,NULL),(36604,24099,'TE','9032348437',0,'2014-02-15 22:01:29',NULL,NULL),(37509,24702,'TE','5132655186',0,'2014-02-20 04:34:32',NULL,NULL),(10498,6838,'AP','5137231330',0,'2013-12-26 01:31:00',NULL,NULL),(8783,5755,'EM','candacedford@yahoo.com',0,'2013-12-25 23:46:21',NULL,NULL),(13735,8950,'EM','tstill@roadrunner.com',0,'2013-12-26 04:03:34',NULL,NULL),(13868,9043,'AP','3303295351',0,'2013-12-26 04:05:52',NULL,NULL),(14403,9419,'AP','2545923110',0,'2013-12-26 04:33:04',NULL,NULL),(14910,9756,'TE','2107884108',0,'2013-12-26 05:00:05',NULL,NULL),(9436,6176,'AP','3302128470',0,'2013-12-26 00:17:12',NULL,NULL),(3065,1907,'TE','7407076751',0,'2013-12-25 18:59:18',NULL,NULL),(9701,6353,'TE','6144032000',0,'2013-12-26 00:47:07',NULL,NULL),(27868,17957,'TE','8066294427',0,'2014-01-15 02:06:44',NULL,NULL),(28653,18479,'AP','3308083496',0,'2014-01-16 08:46:21',NULL,NULL),(30162,19542,'AP','4194785669',0,'2014-01-23 03:02:25',NULL,NULL),(34329,22522,'AP','5139198101',0,'2014-02-10 21:31:26',NULL,NULL),(37368,24596,'EM','vexxed4412@gmail.com',0,'2014-02-20 04:12:27',NULL,NULL),(37612,24786,'EM','kkopis@hotmail.com',0,'2014-02-20 04:46:17',NULL,NULL),(40116,26603,'AP','6823518882',0,'2014-02-28 21:30:43',NULL,NULL),(40748,27081,'TE','3302414586',0,'2014-03-03 21:30:11',NULL,NULL),(48,30,'TE','4404372275',0,'2013-12-25 17:15:47',NULL,NULL),(2792,1690,'AP','5042599106',0,'2013-12-25 18:54:26',NULL,NULL),(7550,4917,'TE','4194961567',0,'2013-12-25 22:45:03',NULL,NULL),(5080,3261,'AP','5042370407',0,'2013-12-25 20:46:54',NULL,NULL),(4994,3205,'TE','4409339384',0,'2013-12-25 20:45:18',NULL,NULL),(9549,6250,'AP','9372171554',0,'2013-12-26 00:31:56',NULL,NULL),(227,139,'EM','stoneworkman.CW@gmail.com',0,'2013-12-25 17:18:38',NULL,NULL),(28612,18442,'AP','2253337727',0,'2014-01-16 08:46:04',NULL,NULL),(29909,19355,'AP','2165542542',1,'2014-01-22 03:22:28',NULL,NULL),(40855,27148,'TE','5134353633',0,'2014-03-03 21:30:51',NULL,NULL),(8746,5735,'TE','5047175116',0,'2013-12-25 23:45:47',NULL,NULL),(3032,1887,'AP','5135513064',0,'2013-12-25 18:58:44',NULL,NULL),(2965,1836,'TE','3308193701',0,'2013-12-25 18:57:32',NULL,NULL),(2929,1802,'TE','5133549946',0,'2013-12-25 18:56:47',NULL,NULL),(6421,4149,'EM','Smitty199@adelphia.net',0,'2013-12-25 21:48:43',NULL,NULL),(13828,9015,'TE','5672032879',0,'2013-12-26 04:05:12',NULL,NULL),(1329,811,'EM','tadrake53@yahoo.com',0,'2013-12-25 18:05:50',NULL,NULL),(32464,21210,'AP','3186806556',0,'2014-02-03 21:00:58',NULL,NULL),(35419,23285,'AP','3373547775',0,'2014-02-13 21:30:18',NULL,NULL),(35537,23371,'TE','6149408621',0,'2014-02-13 22:00:53',NULL,NULL),(35986,23676,'AP','7036252196',0,'2014-02-14 21:30:27',NULL,NULL),(39826,26340,'TE','4197271160',0,'2014-02-28 06:31:43',NULL,NULL),(40911,27186,'TE','9569904786',0,'2014-03-03 21:31:13',NULL,NULL),(40989,27234,'TE','6627861323',0,'2014-03-03 21:31:43',NULL,NULL),(43519,28896,'AP','2543157765',0,'2014-03-10 21:00:18',NULL,NULL),(5204,3343,'EM','JOEVALLE1957@YAHOO.COM',0,'2013-12-25 21:16:33',NULL,NULL),(25797,16625,'TE','7403975306',0,'2014-01-08 18:24:12',NULL,NULL),(24842,16022,'TE','2252025025',0,'2014-01-04 02:02:13',NULL,NULL),(14509,9480,'AP','3306089711',0,'2013-12-26 04:34:37',NULL,NULL),(20464,13183,'EM','bill.jurgensen@sbcglobal.net',0,'2013-12-26 12:54:24',NULL,NULL),(21934,14128,'EM','ernestgmorris@mac.com',0,'2013-12-27 02:02:20',NULL,NULL),(22646,14602,'TE','4192532048',0,'2013-12-28 03:36:26',NULL,NULL),(13666,8909,'TE','9492467176',0,'2013-12-26 04:02:31',NULL,NULL),(26437,17010,'TE','2163217862',0,'2014-01-13 02:20:36',NULL,NULL),(26709,17181,'TE','7409624015',0,'2014-01-13 02:22:13',NULL,NULL),(30835,20045,'AP','3303388915',0,'2014-01-26 19:00:30',NULL,NULL),(32198,21031,'TE','3309402128',0,'2014-02-01 19:00:44',NULL,NULL),(33583,22016,'EM','battles9512@aol.com',0,'2014-02-07 19:00:55',NULL,NULL),(33752,22147,'EM','fmusmur@outlook.com',0,'2014-02-08 19:00:52',NULL,NULL),(34094,22348,'AP','7865107128',0,'2014-02-10 11:01:13',NULL,NULL),(34274,22487,'EM','willowartswellness@gmail.com',0,'2014-02-10 21:31:06',NULL,NULL),(35278,23168,'TE','4692378685',0,'2014-02-12 21:31:51',NULL,NULL),(35529,23368,'TE','4146788128',0,'2014-02-13 22:00:50',NULL,NULL),(37517,24707,'TE','4695701993',0,'2014-02-20 04:35:26',NULL,NULL),(37592,24764,'AP','3304729927',0,'2014-02-20 04:43:44',NULL,NULL),(42144,27999,'AP','5132898753',0,'2014-03-06 21:01:08',NULL,NULL),(10521,6853,'TE','9377480060',0,'2013-12-26 01:31:27',NULL,NULL),(25902,16694,'TE','9159203724',0,'2014-01-08 18:24:36',NULL,NULL),(6903,4493,'TE','9563632061',0,'2013-12-25 22:03:11',NULL,NULL),(7287,4747,'TE','8176753856',0,'2013-12-25 22:15:05',NULL,NULL),(22188,14293,'AP','2164961838',0,'2013-12-27 02:06:38',NULL,NULL),(22566,14552,'AP','3307019823',0,'2013-12-28 03:35:05',NULL,NULL),(22584,14566,'TE','5133167778',0,'2013-12-28 03:35:24',NULL,NULL),(28909,18662,'AP','5125778209',0,'2014-01-17 03:35:14',NULL,NULL),(35554,23380,'EM','giggles1.julie@gmail.com',0,'2014-02-13 22:00:59',NULL,NULL),(41994,27911,'AP','8179968665',0,'2014-03-06 21:00:15',NULL,NULL),(4883,3130,'AP','5133154977',0,'2013-12-25 20:30:29',NULL,NULL),(8262,5407,'EM','Sonny@nplgs.com',0,'2013-12-25 23:09:06',NULL,NULL),(8837,5785,'EM','Saddison0902@gmail.com',0,'2013-12-25 23:47:10',NULL,NULL),(6792,4404,'AP','4197222333',0,'2013-12-25 22:01:15',NULL,NULL),(3023,1883,'AP','5672773275',0,'2013-12-25 18:58:36',NULL,NULL),(1946,1205,'AP','4192607434',0,'2013-12-25 18:19:58',NULL,NULL),(14975,9796,'AP','9155009906',0,'2013-12-26 05:01:08',NULL,NULL),(28129,18133,'AP','8592403883',0,'2014-01-15 02:07:44',NULL,NULL),(33419,21894,'EM','mayalllaura@yahoo.com',0,'2014-02-06 21:01:41',NULL,NULL),(36939,24327,'TE','4053349606',0,'2014-02-18 22:00:11',NULL,NULL),(38142,25176,'TE','9379973640',0,'2014-02-21 22:00:31',NULL,NULL),(39176,25913,'TE','9567875725',0,'2014-02-26 21:01:15',NULL,NULL),(40499,26877,'EM','kulow@yahoo.com',0,'2014-03-01 21:01:07',NULL,NULL),(41386,27495,'TE','3304212214',0,'2014-03-04 21:02:25',NULL,NULL),(41496,27584,'AP','9402325670',0,'2014-03-05 21:00:13',NULL,NULL),(41674,27709,'TE','7133852581',0,'2014-03-05 21:30:52',NULL,NULL),(41774,27775,'TE','3308640737',0,'2014-03-05 21:31:29',NULL,NULL),(43789,29068,'TE','4193951892',0,'2014-03-10 21:01:55',NULL,NULL),(273,168,'EM','bevbuchanan315@gmail.com',0,'2013-12-25 17:19:23',NULL,NULL),(11446,7444,'AP','4194611776',0,'2013-12-26 02:30:31',NULL,NULL),(4117,2625,'EM','sam.belden@gmail.com',0,'2013-12-25 19:45:59',NULL,NULL),(13995,9134,'AP','7406447267',0,'2013-12-26 04:08:04',NULL,NULL),(21290,13680,'TE','2345258773',0,'2013-12-26 13:08:09',NULL,NULL),(23237,14973,'AP','2149069724',0,'2014-01-01 12:00:53',NULL,NULL),(23608,15242,'TE','4194389189',0,'2014-01-01 12:08:39',NULL,NULL),(9605,6287,'AP','6143251529',0,'2013-12-26 00:45:33',NULL,NULL),(530,332,'AP','2814097223',0,'2013-12-25 17:31:42',NULL,NULL),(9266,6064,'TE','4409975648',0,'2013-12-26 00:02:02',NULL,NULL),(6794,4406,'TE','4193205012',0,'2013-12-25 22:01:17',NULL,NULL),(863,539,'TE','3308006582',0,'2013-12-25 17:49:40',NULL,NULL),(2074,1283,'TE','5137682769',0,'2013-12-25 18:30:37',NULL,NULL),(27368,17617,'EM','nevelynr@yahoo.com',0,'2014-01-14 01:32:25',NULL,NULL),(30957,20136,'AP','5132594238',0,'2014-01-27 21:00:55',NULL,NULL),(30960,20138,'AP','4198104361',0,'2014-01-27 21:00:56',NULL,NULL),(32591,21308,'EM','oscille_j@yahoo.com',0,'2014-02-04 21:00:16',NULL,NULL),(39484,26115,'TE','6147175760',0,'2014-02-28 06:30:17',NULL,NULL),(39849,26357,'TE','4404872165',0,'2014-02-28 07:00:04',NULL,NULL),(40640,26974,'TE','3308250756',0,'2014-03-03 01:00:36',NULL,NULL),(43049,28621,'TE','4695445638',0,'2014-03-08 21:30:21',NULL,NULL),(1189,726,'AP','8066763235',0,'2013-12-25 18:03:39',NULL,NULL),(11285,7355,'TE','9722836135',0,'2013-12-26 02:15:15',NULL,NULL),(11690,7610,'TE','3307036777',0,'2013-12-26 02:45:38',NULL,NULL),(3675,2331,'TE','9034656669',0,'2013-12-25 19:31:42',NULL,NULL),(14490,9466,'AP','9377768731',0,'2013-12-26 04:34:20',NULL,NULL),(5246,3369,'TE','8067312355',0,'2013-12-25 21:17:12',NULL,NULL),(2248,1377,'AP','9857078359',0,'2013-12-25 18:46:00',NULL,NULL),(23383,15062,'AP','3189572541',0,'2014-01-01 12:03:37',NULL,NULL),(23879,15408,'AP','7133762913',1,'2014-01-02 04:27:02',NULL,NULL),(27784,17911,'AP','8176755403',0,'2014-01-15 02:06:27',NULL,NULL),(28441,18324,'AP','7403486117',0,'2014-01-16 08:45:09',NULL,NULL),(29142,18825,'AP','6019535668',0,'2014-01-17 03:36:08',NULL,NULL),(29627,19144,'TE','9406319234',0,'2014-01-21 08:45:30',NULL,NULL),(30703,19947,'TE','3305343331',0,'2014-01-24 21:01:19',NULL,NULL),(31127,20272,'TE','7405680093',0,'2014-01-28 21:00:24',NULL,NULL),(32060,20933,'AP','4197719655',0,'2014-01-31 21:01:38',NULL,NULL),(32568,21297,'TE','3186173905',0,'2014-02-04 21:00:10',NULL,NULL),(32874,21515,'AP','2163223131',0,'2014-02-05 21:00:04',NULL,NULL),(32988,21597,'TE','5135268318',0,'2014-02-05 21:30:31',NULL,NULL),(33008,21622,'EM','latearria@yahoo.com',0,'2014-02-05 21:30:38',NULL,NULL),(33202,21741,'EM','allleggs531@yahoo.com',0,'2014-02-06 21:00:15',NULL,NULL),(34630,22707,'TE','3182833137',0,'2014-02-11 21:01:02',NULL,NULL),(35005,22984,'AP','4357572440',0,'2014-02-12 21:30:10',NULL,NULL),(42762,28443,'TE','5046692604',0,'2014-03-07 21:31:15',NULL,NULL),(43295,28765,'AP','9033164316',0,'2014-03-09 21:00:25',NULL,NULL),(148,88,'AP','8304560368',0,'2013-12-25 17:17:22',NULL,NULL),(25279,16298,'EM','ELAINEH1961@GMAIL.COM',0,'2014-01-07 04:01:05',NULL,NULL),(24469,15792,'AP','3187927481',0,'2014-01-03 02:02:32',NULL,NULL),(7505,4891,'TE','3302128470',0,'2013-12-25 22:31:31',NULL,NULL),(10169,6645,'AP','9037201835',0,'2013-12-26 01:00:27',NULL,NULL),(2551,1559,'TE','6012917818',0,'2013-12-25 18:50:51',NULL,NULL),(14254,9324,'AP','3377890442',0,'2013-12-26 04:30:35',NULL,NULL),(2395,1459,'EM','juan64roofforyou@hotmail.com',0,'2013-12-25 18:48:17',NULL,NULL),(20495,13196,'EM','martingd@msn.com',0,'2013-12-26 12:54:49',NULL,NULL),(20815,13377,'TE','2162105663',0,'2013-12-26 12:59:51',NULL,NULL),(21783,14036,'TE','9377286564',0,'2013-12-26 13:17:01',NULL,NULL),(22465,14487,'TE','8176589820',0,'2013-12-28 03:33:26',NULL,NULL),(27779,17908,'TE','9035043668',0,'2014-01-15 02:06:26',NULL,NULL),(30342,19662,'TE','9374311993',0,'2014-01-23 21:00:25',NULL,NULL),(30751,19981,'TE','3305422709',0,'2014-01-25 19:00:16',NULL,NULL),(34987,22971,'EM','dmajer@netzero.com',0,'2014-02-12 21:00:17',NULL,NULL),(37082,24416,'TE','5137487381',0,'2014-02-18 22:01:04',NULL,NULL),(1363,830,'EM','darsondurham@aol.com',0,'2013-12-25 18:06:21',NULL,NULL),(25595,16512,'AP','9722077909',1,'2014-01-07 10:21:24',NULL,NULL),(12276,8031,'EM','verkistap@gmail.com',0,'2013-12-26 03:09:09',NULL,NULL),(5065,3251,'AP','8477576654',0,'2013-12-25 20:46:38',NULL,NULL),(5256,3376,'TE','8066641570',0,'2013-12-25 21:17:23',NULL,NULL),(2063,1277,'TE','6148336312',0,'2013-12-25 18:30:27',NULL,NULL),(23557,15204,'AP','6019421661',0,'2014-01-01 12:07:31',NULL,NULL),(26973,17348,'TE','9374989095',0,'2014-01-13 02:24:07',NULL,NULL),(29029,18743,'TE','4404174525',0,'2014-01-17 03:35:41',NULL,NULL),(30318,19640,'AP','3305645933',0,'2014-01-23 21:00:14',NULL,NULL),(31130,20273,'AP','9377258551',0,'2014-01-28 21:00:25',NULL,NULL),(33858,22226,'TE','2148092722',0,'2014-02-09 19:00:29',NULL,NULL),(34460,22610,'EM','twitchx06@yahoo.com',0,'2014-02-11 21:00:04',NULL,NULL),(35835,23565,'AP','4196544958',0,'2014-02-13 22:02:47',NULL,NULL),(35909,23627,'TE','9376232084',0,'2014-02-13 22:03:21',NULL,NULL),(37002,24365,'AP','5049429397',0,'2014-02-18 22:00:34',NULL,NULL),(42752,28438,'AP','4197330182',0,'2014-03-07 21:31:11',NULL,NULL),(43951,29155,'TE','4193456911',0,'2014-03-10 21:02:51',NULL,NULL),(6098,3927,'AP','5134883600',0,'2013-12-25 21:37:31',NULL,NULL),(25922,16704,'AP','3252620905',0,'2014-01-08 18:24:40',NULL,NULL),(14895,9747,'TE','3183716897',0,'2013-12-26 04:46:07',NULL,NULL),(10890,7076,'EM','sabrinanguyen99@gmail.com',0,'2013-12-26 01:50:11',NULL,NULL),(3103,1935,'EM','wddm01@aol.com',0,'2013-12-25 19:00:31',NULL,NULL),(21291,13680,'AP','2345258773',0,'2013-12-26 13:08:09',NULL,NULL),(546,340,'AP','5134603728',0,'2013-12-25 17:31:58',NULL,NULL),(26399,16991,'AP','3254554292',0,'2014-01-13 02:20:25',NULL,NULL),(27355,17612,'AP','8064003363',0,'2014-01-14 01:32:22',NULL,NULL),(31109,20253,'AP','3303289784',0,'2014-01-28 21:00:15',NULL,NULL),(32011,20897,'EM','mordaa@bluffton.edu',0,'2014-01-31 21:01:19',NULL,NULL),(32253,21063,'EM','cowgirl42783@yahoo.com',0,'2014-02-02 19:00:13',NULL,NULL),(33904,22254,'TE','6014477002',0,'2014-02-09 19:00:45',NULL,NULL),(35259,23156,'TE','5135605977',0,'2014-02-12 21:31:44',NULL,NULL),(37924,25025,'TE','9157405908',0,'2014-02-20 22:00:59',NULL,NULL),(40062,26563,'TE','5137418099',0,'2014-02-28 21:30:21',NULL,NULL),(40505,26882,'TE','4193021688',0,'2014-03-01 21:01:10',NULL,NULL),(41258,27419,'AP','5674298139',0,'2014-03-04 21:01:37',NULL,NULL),(3764,2387,'EM','pjg3945@svcglobal.net',0,'2013-12-25 19:33:11',NULL,NULL),(24683,15919,'AP','4192507788',0,'2014-01-03 02:06:35',NULL,NULL),(9698,6352,'TE','2167805601',0,'2013-12-26 00:47:05',NULL,NULL),(11251,7325,'AP','3306222951',0,'2013-12-26 02:03:42',NULL,NULL),(8690,5704,'EM','plushie0806@gmail.com',0,'2013-12-25 23:33:01',NULL,NULL),(20247,13044,'EM','diamondcyndi@gmail.com',0,'2013-12-26 12:50:41',NULL,NULL),(21936,14130,'AP','5042373521',0,'2013-12-27 02:02:22',NULL,NULL),(22200,14299,'TE','4199296304',0,'2013-12-27 02:06:49',NULL,NULL),(6983,4556,'TE','3308544921',0,'2013-12-25 22:04:39',NULL,NULL),(22902,14775,'EM','billyreidy@yahoo.com',1,'2013-12-29 11:13:04',NULL,NULL),(23080,14884,'TE','6012596497',0,'2013-12-30 00:00:38',NULL,NULL),(3655,2316,'TE','8328453384',0,'2013-12-25 19:31:18',NULL,NULL),(23218,14961,'EM','Mineolaclinic@yahoo.com',0,'2014-01-01 12:00:32',NULL,NULL),(23421,15087,'TE','9404451518',0,'2014-01-01 12:04:22',NULL,NULL),(26415,16999,'TE','5132035995',0,'2014-01-13 02:20:29',NULL,NULL),(26418,17000,'TE','3308585023',0,'2014-01-13 02:20:30',NULL,NULL),(27661,17831,'AP','6012124832',0,'2014-01-15 02:05:59',NULL,NULL),(30552,19824,'EM','stedwardsgurl18@gmail.com',0,'2014-01-24 21:00:15',NULL,NULL),(30643,19886,'EM','dejablue88@hotmail.com',0,'2014-01-24 21:00:49',NULL,NULL),(33116,21693,'TE','4198412956',0,'2014-02-05 21:31:07',NULL,NULL),(36240,23851,'TE','4196282042',0,'2014-02-14 21:31:58',NULL,NULL),(37779,24932,'EM','DENISEANGERSTIEN@ROCKETMAIL.COM',0,'2014-02-20 21:30:20',NULL,NULL),(42111,27977,'EM','THUGHES70124@GMAIL.COM',0,'2014-03-06 21:00:54',NULL,NULL),(6178,3981,'EM','worldd66@hotmail.com',0,'2013-12-25 21:38:50',NULL,NULL),(25755,16597,'TE','5043339962',0,'2014-01-08 18:24:03',NULL,NULL),(7430,4833,'AP','2567363306',0,'2013-12-25 22:17:23',NULL,NULL),(10407,6783,'EM','bmbell77@mac.com',0,'2013-12-26 01:16:55',NULL,NULL),(10656,6927,'AP','5137281929',0,'2013-12-26 01:46:24',NULL,NULL),(11039,7164,'TE','7186124922',0,'2013-12-26 01:52:35',NULL,NULL),(7335,4767,'EM','HATSANDKATS@HOTMAIL.COM',0,'2013-12-25 22:15:45',NULL,NULL),(9416,6162,'TE','5672303977',0,'2013-12-26 00:16:50',NULL,NULL),(1903,1174,'EM','Don@rubberworld.com',0,'2013-12-25 18:19:13',NULL,NULL),(10803,7019,'AP','8062526676',0,'2013-12-26 01:48:47',NULL,NULL),(26466,17035,'TE','3189188811',0,'2014-01-13 02:20:47',NULL,NULL),(30239,19586,'AP','6013834357',0,'2014-01-23 03:02:43',NULL,NULL),(30614,19869,'AP','5134355053',0,'2014-01-24 21:00:40',NULL,NULL),(35077,23036,'AP','2148370037',0,'2014-02-12 21:30:37',NULL,NULL),(35252,23151,'EM','drew.drewbailey@yahoo.com',0,'2014-02-12 21:31:42',NULL,NULL),(42918,28540,'AP','3259393814',0,'2014-03-07 21:32:14',NULL,NULL),(1338,818,'TE','3302420092',0,'2013-12-25 18:06:00',NULL,NULL),(24999,16112,'AP','9015173153',0,'2014-01-04 02:05:07',NULL,NULL),(11351,7394,'EM','bobbyd01@att.net',0,'2013-12-26 02:16:16',NULL,NULL),(4083,2603,'EM','bigdennyb@msn.com',0,'2013-12-25 19:45:25',NULL,NULL),(5434,3477,'AP','5134768083',0,'2013-12-25 21:20:07',NULL,NULL),(3429,2151,'EM','cnelson1972@hotmail.com',0,'2013-12-25 19:18:36',NULL,NULL),(8171,5345,'EM','consza@yahoo.com',0,'2013-12-25 23:07:29',NULL,NULL),(7375,4800,'TE','3183711822',0,'2013-12-25 22:16:29',NULL,NULL),(11829,7697,'TE','9377326121',0,'2013-12-26 03:01:10',NULL,NULL),(2183,1341,'AP','8063003520',0,'2013-12-25 18:32:27',NULL,NULL),(14237,9315,'AP','3189534530',0,'2013-12-26 04:30:22',NULL,NULL),(20608,13254,'TE','9563695573',0,'2013-12-26 12:56:30',NULL,NULL),(22063,14208,'EM','jim@jarnold.me',0,'2013-12-27 02:04:26',NULL,NULL),(27059,17401,'EM','multicon@bellsouth.net',0,'2014-01-13 03:00:17',NULL,NULL),(30958,20136,'EM','nseip@cinci.rr.com',0,'2014-01-27 21:00:55',NULL,NULL),(31877,20807,'EM','shermanacoone@gmail.com',0,'2014-01-31 21:00:26',NULL,NULL),(33229,21759,'AP','8327278255',0,'2014-02-06 21:00:25',NULL,NULL),(33425,21897,'TE','3304663614',0,'2014-02-06 21:01:44',NULL,NULL),(34228,22452,'TE','9152526516',0,'2014-02-10 21:30:47',NULL,NULL),(34506,22634,'AP','9159999756',0,'2014-02-11 21:00:19',NULL,NULL),(34694,22749,'EM','mbeary1@gmail.com',0,'2014-02-11 21:01:25',NULL,NULL),(39435,26082,'AP','2253120520',0,'2014-02-28 06:30:05',NULL,NULL),(42751,28438,'TE','4197330182',0,'2014-03-07 21:31:11',NULL,NULL),(43717,29021,'AP','4055129859',0,'2014-03-10 21:01:30',NULL,NULL),(787,492,'TE','5043247667',0,'2013-12-25 17:48:26',NULL,NULL),(23442,15107,'EM','lazyunionguy@gmail.com',0,'2014-01-01 12:04:53',NULL,NULL),(8331,5462,'TE','9372394324',0,'2013-12-25 23:10:27',NULL,NULL),(4477,2850,'TE','9375649179',0,'2013-12-25 20:01:20',NULL,NULL),(8912,5833,'AP','3253748914',0,'2013-12-25 23:48:22',NULL,NULL),(3666,2327,'TE','4093849648',0,'2013-12-25 19:31:34',NULL,NULL),(3090,1930,'TE','8067772960',0,'2013-12-25 19:00:22',NULL,NULL),(21158,13605,'AP','4192041035',0,'2013-12-26 13:05:31',NULL,NULL),(27115,17448,'EM','wkennedy@hotmail.com',0,'2014-01-13 03:00:38',NULL,NULL),(29149,18831,'EM','TTJW9101@EMBARQ.COM',0,'2014-01-17 03:36:10',NULL,NULL),(29175,18852,'TE','3307244118',0,'2014-01-17 03:36:16',NULL,NULL),(30233,19583,'EM','johnoneil327@yahoo.com',0,'2014-01-23 03:02:41',NULL,NULL),(31474,20510,'AP','3183810679',0,'2014-01-29 21:01:18',NULL,NULL),(34080,22340,'EM','LARRY@APLUSAUTOSALES.NET',0,'2014-02-10 11:01:08',NULL,NULL),(35285,23173,'EM','paul.morris@ccuniversity.edu',0,'2014-02-12 21:31:54',NULL,NULL),(38197,25213,'EM','dmodica@lec.edu',0,'2014-02-21 22:00:52',NULL,NULL),(38283,25276,'EM','vickyg9940@yahoo.com',0,'2014-02-25 21:00:15',NULL,NULL),(40893,27171,'AP','8329646161',0,'2014-03-03 21:31:05',NULL,NULL),(41154,27334,'TE','2167012464',0,'2014-03-04 21:00:54',NULL,NULL),(42738,28426,'TE','7404855285',0,'2014-03-07 21:31:06',NULL,NULL),(40,27,'TE','3309238269',0,'2013-12-25 17:15:41',NULL,NULL),(517,325,'TE','5133403590',0,'2013-12-25 17:31:29',NULL,NULL),(14361,9388,'TE','3614803387',0,'2013-12-26 04:32:16',NULL,NULL),(966,594,'EM','deffenbaugh8081@yahoo.com',0,'2013-12-25 18:00:09',NULL,NULL),(1254,762,'TE','9724628589',0,'2013-12-25 18:04:35',NULL,NULL),(8655,5686,'EM','maryaridge@yahoo.com',0,'2013-12-25 23:32:28',NULL,NULL),(7153,4666,'TE','3183558258',0,'2013-12-25 22:07:30',NULL,NULL),(6662,4324,'AP','9377264284',0,'2013-12-25 21:52:51',NULL,NULL),(4452,2836,'AP','3304175838',0,'2013-12-25 20:00:55',NULL,NULL),(2002,1236,'EM','shalanevette@yahoo.com',0,'2013-12-25 18:20:52',NULL,NULL),(24023,15512,'AP','4193504294',1,'2014-01-02 04:30:02',NULL,NULL),(26092,16803,'EM','twisty1000@yahoo.com',0,'2014-01-13 02:18:12',NULL,NULL),(26707,17180,'AP','5136790305',0,'2014-01-13 02:22:12',NULL,NULL),(27021,17377,'AP','3302096445',0,'2014-01-13 03:00:04',NULL,NULL),(28587,18429,'TE','9854745206',0,'2014-01-16 08:45:57',NULL,NULL),(28657,18483,'TE','3306900345',0,'2014-01-16 08:46:22',NULL,NULL),(30605,19862,'EM','Sbistrek@aol.com',0,'2014-01-24 21:00:36',NULL,NULL),(33742,22140,'BN','3303545829',0,'2014-02-08 19:00:48',NULL,NULL),(40844,27141,'TE','5134811504',0,'2014-03-03 21:30:46',NULL,NULL),(41148,27331,'AP','6147499022',0,'2014-03-04 21:00:52',NULL,NULL),(41606,27662,'TE','2343805572',0,'2014-03-05 21:30:28',NULL,NULL),(41671,27704,'EM','ron@clearwire.net',0,'2014-03-05 21:30:50',NULL,NULL),(42860,28503,'TE','4199030515',0,'2014-03-07 21:31:50',NULL,NULL),(35224,23134,'AP','3302176660',0,'2014-02-12 21:31:32',NULL,NULL),(36220,23839,'BN','5133749517',0,'2014-02-14 21:31:51',NULL,NULL),(37931,25028,'AP','5126365967',0,'2014-02-20 22:01:01',NULL,NULL),(39460,26095,'AP','7194860057',0,'2014-02-28 06:30:10',NULL,NULL),(43393,28819,'AP','4195757353',0,'2014-03-09 21:00:58',NULL,NULL),(7318,4759,'TE','8067909437',0,'2013-12-25 22:15:30',NULL,NULL),(1772,1096,'TE','2162535635',0,'2013-12-25 18:17:08',NULL,NULL),(7156,4668,'AP','2259387326',0,'2013-12-25 22:07:33',NULL,NULL),(2538,1553,'TE','6014675858',0,'2013-12-25 18:50:40',NULL,NULL),(3414,2145,'TE','5133146684',0,'2013-12-25 19:18:23',NULL,NULL),(6061,3899,'TE','3303764442',0,'2013-12-25 21:36:49',NULL,NULL),(6259,4037,'TE','6145657735',0,'2013-12-25 21:46:03',NULL,NULL),(25249,16282,'AP','4192245256',0,'2014-01-07 04:00:34',NULL,NULL),(32178,21017,'EM','sid1284326@aol.com',0,'2014-02-01 19:00:38',NULL,NULL),(34229,22452,'AP','9152526516',0,'2014-02-10 21:30:47',NULL,NULL),(35715,23489,'TE','4192037749',0,'2014-02-13 22:02:01',NULL,NULL),(35939,23646,'AP','9723521763',0,'2014-02-14 21:30:11',NULL,NULL),(36387,23967,'TE','3615435432',0,'2014-02-15 22:00:12',NULL,NULL),(38819,25663,'AP','2255738301',0,'2014-02-26 08:30:47',NULL,NULL),(39014,25798,'AP','4406389090',0,'2014-02-26 21:00:15',NULL,NULL),(40932,27198,'EM','turellam@hotmail.com',0,'2014-03-03 21:31:20',NULL,NULL),(41493,27583,'TE','8067312355',0,'2014-03-05 21:00:12',NULL,NULL),(41614,27666,'EM','Jesshammond30@gmail.com',0,'2014-03-05 21:30:30',NULL,NULL),(41681,27717,'AP','9799431040',0,'2014-03-05 21:30:56',NULL,NULL),(4346,2774,'TE','6013254823',0,'2013-12-25 19:49:37',NULL,NULL),(4562,2904,'EM','edwardfirm@att.net',0,'2013-12-25 20:15:26',NULL,NULL),(22036,14191,'EM','tedeline@hughes.net',0,'2013-12-27 02:04:00',NULL,NULL),(6559,4236,'EM','paul73rod@gmail.com',0,'2013-12-25 21:50:53',NULL,NULL),(7486,4872,'TE','9562052050',0,'2013-12-25 22:31:02',NULL,NULL),(9424,6168,'TE','3154302976',0,'2013-12-26 00:16:59',NULL,NULL),(11800,7673,'AP','4196186339',0,'2013-12-26 03:00:38',NULL,NULL),(23831,15374,'AP','2282822500',1,'2014-01-02 04:25:12',NULL,NULL),(25637,16535,'TE','3303389796',1,'2014-01-07 10:22:10',NULL,NULL),(26529,17066,'AP','2147355189',0,'2014-01-13 02:21:15',NULL,NULL),(31663,20657,'EM','gopdamit@yahoo.com',0,'2014-01-30 21:00:42',NULL,NULL),(32396,21167,'EM','mcqueen.cathy@yahoo.com',0,'2014-02-03 21:00:36',NULL,NULL),(34520,22647,'TE','5127589845',0,'2014-02-11 21:00:25',NULL,NULL),(35283,23173,'TE','5136009127',0,'2014-02-12 21:31:54',NULL,NULL),(36501,24031,'AP','2252524144',0,'2014-02-15 22:00:53',NULL,NULL),(36963,24339,'AP','5128271140',0,'2014-02-18 22:00:19',NULL,NULL),(37341,24585,'EM','susanmarieczekansky@aol.com',0,'2014-02-20 04:09:31',NULL,NULL),(38576,25495,'AP','5672047843',0,'2014-02-25 21:31:50',NULL,NULL),(39516,26139,'TE','6143576273',0,'2014-02-28 06:30:25',NULL,NULL),(41688,27722,'AP','7134463607',0,'2014-03-05 21:30:59',NULL,NULL),(284,175,'TE','3304218590',0,'2013-12-25 17:19:32',NULL,NULL),(21612,13910,'AP','4199343257',0,'2013-12-26 13:13:56',NULL,NULL),(360,221,'AP','2255619232',0,'2013-12-25 17:20:47',NULL,NULL),(5598,3583,'TE','5133142843',0,'2013-12-25 21:22:48',NULL,NULL),(9600,6285,'EM','jerry1gman@gmail.com',0,'2013-12-26 00:45:29',NULL,NULL),(5380,3443,'AP','9378384755',0,'2013-12-25 21:19:18',NULL,NULL),(1518,936,'TE','6143361889',0,'2013-12-25 18:09:12',NULL,NULL),(7401,4814,'AP','5134779652',0,'2013-12-25 22:16:53',NULL,NULL),(25997,16749,'EM','EGUNSOLA@GMAIL.COM',0,'2014-01-08 18:24:54',NULL,NULL),(32234,21054,'AP','6789866254',0,'2014-02-02 19:00:07',NULL,NULL),(32793,21456,'TE','8436162708',0,'2014-02-04 21:01:31',NULL,NULL),(34487,22625,'AP','8329678026',0,'2014-02-11 21:00:13',NULL,NULL),(34504,22633,'AP','9159999756',0,'2014-02-11 21:00:19',NULL,NULL),(35910,23627,'AP','9376232084',0,'2014-02-13 22:03:21',NULL,NULL),(37797,24945,'TE','9014810564',0,'2014-02-20 22:00:07',NULL,NULL),(38611,25518,'AP','4192044488',0,'2014-02-25 21:32:05',NULL,NULL),(39910,26411,'TE','9406821700',0,'2014-02-28 07:00:39',NULL,NULL),(43720,29022,'AP','4404207346',0,'2014-03-10 21:01:31',NULL,NULL),(2455,1508,'TE','9376233664',0,'2013-12-25 18:49:26',NULL,NULL),(9933,6500,'EM','eeber1107@gmail.com',0,'2013-12-26 00:50:50',NULL,NULL),(10614,6906,'TE','3182724473',0,'2013-12-26 01:45:47',NULL,NULL),(10735,6980,'AP','6142707709',0,'2013-12-26 01:47:42',NULL,NULL),(10760,6995,'AP','2144580480',0,'2013-12-26 01:48:06',NULL,NULL),(11203,7285,'TE','3303263220',0,'2013-12-26 02:02:48',NULL,NULL),(9113,5972,'TE','6626940593',0,'2013-12-25 23:51:40',NULL,NULL),(13775,8979,'TE','9374692625',0,'2013-12-26 04:04:17',NULL,NULL),(14162,9269,'TE','5132950922',0,'2013-12-26 04:15:35',NULL,NULL),(9040,5932,'TE','2256037647',0,'2013-12-25 23:50:32',NULL,NULL),(7918,5159,'TE','4403661160',0,'2013-12-25 23:03:01',NULL,NULL),(23289,15006,'TE','3306205083',0,'2014-01-01 12:01:53',NULL,NULL),(31137,20280,'AP','4195610760',0,'2014-01-28 21:00:29',NULL,NULL),(32054,20928,'TE','2288315827',0,'2014-01-31 21:01:35',NULL,NULL),(32517,21257,'AP','3302121492',0,'2014-02-03 21:01:21',NULL,NULL),(40648,26985,'TE','5135187302',0,'2014-03-03 01:00:39',NULL,NULL),(4691,3000,'EM','swahl498@gmail.com',0,'2013-12-25 20:17:39',NULL,NULL),(24726,15951,'EM','Son.c.ton@gmail.com',0,'2014-01-04 02:00:07',NULL,NULL),(10423,6796,'TE','3307945661',0,'2013-12-26 01:17:13',NULL,NULL),(14215,9301,'EM','j-fall@hotmail.com',0,'2013-12-26 04:16:24',NULL,NULL),(14775,9669,'EM','rodweller@fuse.net',0,'2013-12-26 04:39:11',NULL,NULL),(20292,13081,'TE','4408970414',0,'2013-12-26 12:51:34',NULL,NULL),(8278,5422,'TE','6013822429',0,'2013-12-25 23:09:26',NULL,NULL),(7362,4788,'EM','hiltabidell@yahoo.com',0,'2013-12-25 22:16:15',NULL,NULL),(4561,2904,'TE','7405373738',0,'2013-12-25 20:15:25',NULL,NULL),(22475,14493,'TE','9037051050',0,'2013-12-28 03:33:34',NULL,NULL),(26807,17242,'TE','5133098954',0,'2014-01-13 02:22:46',NULL,NULL),(27659,17829,'AP','6019416219',0,'2014-01-15 02:05:59',NULL,NULL),(29387,18992,'AP','3306184395',0,'2014-01-20 08:06:12',NULL,NULL),(29972,19394,'TE','9376427803',1,'2014-01-22 03:22:49',NULL,NULL),(34752,22786,'TE','7852824836',0,'2014-02-11 21:01:47',NULL,NULL),(36323,23923,'AP','2259211786',0,'2014-02-14 22:00:07',NULL,NULL),(37231,24500,'EM','tinkerbelljones15@yahoo.com',0,'2014-02-20 03:49:07',NULL,NULL),(37617,24790,'EM','jayz2slk@gmail.com',0,'2014-02-20 04:47:02',NULL,NULL),(39540,26159,'AP','4404871157',0,'2014-02-28 06:30:32',NULL,NULL),(42407,28165,'AP','9374170481',0,'2014-03-06 21:02:45',NULL,NULL),(25,16,'TE','4196253817',0,'2013-12-25 17:15:25',NULL,NULL),(7956,5189,'AP','4408214694',0,'2013-12-25 23:03:44',NULL,NULL),(8339,5470,'TE','4193240143',0,'2013-12-25 23:10:39',NULL,NULL),(9806,6418,'AP','9377258505',0,'2013-12-26 00:48:48',NULL,NULL),(10337,6740,'TE','3302851972',0,'2013-12-26 01:15:46',NULL,NULL),(1942,1203,'TE','2163960222',0,'2013-12-25 18:19:55',NULL,NULL),(10604,6901,'AP','2255906339',0,'2013-12-26 01:45:38',NULL,NULL),(11495,7478,'AP','3302855868',0,'2013-12-26 02:31:20',NULL,NULL),(21826,14061,'EM','omari8099@hotmail.com',0,'2013-12-27 02:00:35',NULL,NULL),(22136,14257,'TE','5043077505',0,'2013-12-27 02:05:42',NULL,NULL),(23753,15323,'AP','8322573238',1,'2014-01-02 04:23:38',NULL,NULL),(6288,4053,'AP','9376544298',0,'2013-12-25 21:46:28',NULL,NULL),(28472,18345,'TE','5137798974',0,'2014-01-16 08:45:20',NULL,NULL),(28503,18371,'TE','5137228004',0,'2014-01-16 08:45:30',NULL,NULL),(32181,21018,'EM','bienerz4@gmail.com',0,'2014-02-01 19:00:38',NULL,NULL),(33800,22192,'TE','8324207333',0,'2014-02-09 19:00:10',NULL,NULL),(35980,23673,'TE','3372089305',0,'2014-02-14 21:30:26',NULL,NULL),(36887,24292,'EM','akronbell@yahoo.com',0,'2014-02-18 21:30:14',NULL,NULL),(38022,25081,'TE','5672077032',0,'2014-02-20 22:01:38',NULL,NULL),(38325,25320,'TE','2254922702',0,'2014-02-25 21:30:08',NULL,NULL),(39545,26161,'TE','7403622124',0,'2014-02-28 06:30:33',NULL,NULL),(41576,27642,'TE','4402376809',0,'2014-03-05 21:30:17',NULL,NULL),(41762,27768,'EM','LILELM6236@YAHOO.COM',0,'2014-03-05 21:31:25',NULL,NULL),(6426,4153,'TE','6142086059',0,'2013-12-25 21:48:49',NULL,NULL),(11081,7196,'AP','8593215015',0,'2013-12-26 02:00:33',NULL,NULL),(10212,6673,'TE','9378799599',0,'2013-12-26 01:01:11',NULL,NULL),(2893,1773,'TE','9373972646',0,'2013-12-25 18:56:10',NULL,NULL),(3425,2149,'AP','5133824128',0,'2013-12-25 19:18:32',NULL,NULL),(5185,3329,'AP','5132009782',0,'2013-12-25 21:16:15',NULL,NULL),(2283,1400,'AP','5043624336',0,'2013-12-25 18:46:35',NULL,NULL),(6363,4098,'AP','3257632679',0,'2013-12-25 21:47:41',NULL,NULL),(23430,15095,'EM','Jenniferelanser@gmail.com',0,'2014-01-01 12:04:34',NULL,NULL),(26559,17084,'TE','7139230855',0,'2014-01-13 02:21:24',NULL,NULL),(27585,17783,'TE','4192039514',0,'2014-01-14 01:33:44',NULL,NULL),(28484,18355,'EM','mkoloskee@gmail.com',0,'2014-01-16 08:45:24',NULL,NULL),(28981,18705,'BN','9375545405',0,'2014-01-17 03:35:30',NULL,NULL),(31895,20817,'TE','5042207902',0,'2014-01-31 21:00:33',NULL,NULL),(32778,21444,'TE','3309906718',0,'2014-02-04 21:01:26',NULL,NULL),(34789,22817,'TE','9374082656',0,'2014-02-11 21:02:01',NULL,NULL),(35281,23171,'TE','9375444412',0,'2014-02-12 21:31:53',NULL,NULL),(36446,24000,'TE','6147726261',0,'2014-02-15 22:00:33',NULL,NULL),(37139,24447,'AP','5044954809',0,'2014-02-18 22:01:24',NULL,NULL),(37690,24849,'AP','5132253858',0,'2014-02-20 04:55:20',NULL,NULL),(43771,29057,'TE','7406220802',0,'2014-03-10 21:01:50',NULL,NULL),(6453,4169,'TE','4192616944',0,'2013-12-25 21:49:11',NULL,NULL),(21147,13596,'TE','4192966255',0,'2013-12-26 13:05:20',NULL,NULL),(21667,13949,'TE','5134901485',0,'2013-12-26 13:14:54',NULL,NULL),(22795,14699,'AP','2162107411',1,'2013-12-29 11:09:01',NULL,NULL),(6032,3874,'AP','5043456045',0,'2013-12-25 21:36:16',NULL,NULL),(20473,13187,'EM','nichelle-jones@att.net',0,'2013-12-26 12:54:31',NULL,NULL),(6891,4480,'TE','7404258709',0,'2013-12-25 22:02:58',NULL,NULL),(10235,6691,'EM','aseguin95@sbcglobal.net',0,'2013-12-26 01:01:36',NULL,NULL),(9941,6505,'EM','gramnee52@gmail.com',0,'2013-12-26 00:50:58',NULL,NULL),(24967,16091,'EM','patsie8@yahoo.com',0,'2014-01-04 02:04:26',NULL,NULL),(25670,16549,'EM','triciatrish38@yahoo.com',1,'2014-01-07 10:22:41',NULL,NULL),(29071,18773,'EM','eswope21@yahoo.com',0,'2014-01-17 03:35:51',NULL,NULL),(29370,18976,'TE','7406052827',0,'2014-01-20 08:06:05',NULL,NULL),(34010,22309,'TE','7697987029',0,'2014-02-10 11:00:43',NULL,NULL),(35191,23113,'EM','cmgingras@gmail.com',0,'2014-02-12 21:31:19',NULL,NULL),(36363,23946,'TE','5049204867',0,'2014-02-15 21:00:12',NULL,NULL),(38107,25155,'AP','8322298197',0,'2014-02-21 22:00:19',NULL,NULL),(40500,26879,'TE','3304052981',0,'2014-03-01 21:01:08',NULL,NULL),(2253,1380,'EM','whdaume@aol.com',0,'2013-12-25 18:46:05',NULL,NULL),(23918,15432,'TE','9039209077',1,'2014-01-02 04:27:47',NULL,NULL),(3211,2016,'EM','dlowe838@yahoo.com',0,'2013-12-25 19:02:40',NULL,NULL),(23397,15070,'TE','2286979502',0,'2014-01-01 12:03:53',NULL,NULL),(2356,1432,'AP','3185420346',0,'2013-12-25 18:47:36',NULL,NULL),(9531,6239,'AP','9372966135',0,'2013-12-26 00:31:39',NULL,NULL),(12178,7954,'AP','6822093671',0,'2013-12-26 03:07:16',NULL,NULL),(10431,6799,'EM','JRBRAUN@BRIGHT.NET',0,'2013-12-26 01:17:21',NULL,NULL),(10973,7131,'EM','newangel43@aol.com',0,'2013-12-26 01:51:36',NULL,NULL),(24360,15731,'TE','5136791570',0,'2014-01-03 02:00:31',NULL,NULL),(30813,20034,'EM','robert@wnwventures.com',0,'2014-01-26 19:00:22',NULL,NULL),(33479,21940,'TE','2104207445',0,'2014-02-07 19:00:14',NULL,NULL),(33648,22067,'EM','x_man1998@yahoo.com',0,'2014-02-08 19:00:13',NULL,NULL),(40867,27156,'AP','2165435022',0,'2014-03-03 21:30:56',NULL,NULL),(41350,27469,'EM','fowldiane.Fowler@aol.com',0,'2014-03-04 21:02:11',NULL,NULL),(42230,28052,'EM','mrjohnkeyes@gmail.com',0,'2014-03-06 21:01:38',NULL,NULL),(42727,28419,'EM','otownsend@inpel1.com',0,'2014-03-07 21:31:02',NULL,NULL),(43350,28794,'TE','8178251608',0,'2014-03-09 21:00:44',NULL,NULL),(238,144,'EM','jjcorcodel@yahoo.com',0,'2013-12-25 17:18:48',NULL,NULL),(7098,4632,'EM','m1abramstanker@yahoo.com',0,'2013-12-25 22:06:34',NULL,NULL),(3361,2113,'TE','3304148213',0,'2013-12-25 19:17:30',NULL,NULL),(14158,9267,'AP','4402130488',0,'2013-12-26 04:15:31',NULL,NULL),(3836,2441,'TE','3307533423',0,'2013-12-25 19:34:27',NULL,NULL),(11223,7301,'AP','3303147909',0,'2013-12-26 02:03:09',NULL,NULL),(24551,15835,'EM','TINKERBELL198031@GMAIL.COM',0,'2014-01-03 02:03:59',NULL,NULL),(29543,19094,'TE','4193020010',0,'2014-01-21 08:44:34',NULL,NULL),(30909,20098,'TE','5042489911',0,'2014-01-27 21:00:33',NULL,NULL),(33476,21932,'TE','7137210947',0,'2014-02-07 19:00:11',NULL,NULL),(35577,23394,'EM','centaur1212@gmail.com',0,'2014-02-13 22:01:08',NULL,NULL),(37850,24971,'AP','9795783242',0,'2014-02-20 22:00:27',NULL,NULL),(38320,25316,'AP','5046216990',0,'2014-02-25 21:30:05',NULL,NULL),(43714,29020,'AP','6147474848',0,'2014-03-10 21:01:29',NULL,NULL),(705,438,'TE','6142967035',0,'2013-12-25 17:47:06',NULL,NULL),(21708,13980,'TE','5133867535',0,'2013-12-26 13:15:34',NULL,NULL),(14155,9266,'AP','4403397251',0,'2013-12-26 04:15:29',NULL,NULL),(8354,5487,'TE','9379817400',0,'2013-12-25 23:10:58',NULL,NULL),(1789,1111,'TE','5676742994',0,'2013-12-25 18:17:30',NULL,NULL),(6085,3916,'TE','2144138801',0,'2013-12-25 21:37:15',NULL,NULL),(3432,2154,'TE','9857487017',0,'2013-12-25 19:18:39',NULL,NULL),(6812,4419,'TE','4193712575',0,'2013-12-25 22:01:35',NULL,NULL),(23346,15040,'AP','2818579145',0,'2014-01-01 12:02:56',NULL,NULL),(27077,17415,'TE','5136830004',0,'2014-01-13 03:00:24',NULL,NULL),(28135,18137,'TE','2254391967',0,'2014-01-15 02:07:45',NULL,NULL),(31513,20535,'TE','2169041790',0,'2014-01-29 21:01:33',NULL,NULL),(34429,22586,'AP','5676442537',0,'2014-02-10 21:32:06',NULL,NULL),(36068,23723,'TE','2148753888',0,'2014-02-14 21:30:54',NULL,NULL),(37059,24404,'AP','9374225341',0,'2014-02-18 22:00:57',NULL,NULL),(39326,26011,'AP','5672597354',0,'2014-02-26 21:02:10',NULL,NULL),(41220,27379,'EM','MSCBARNES@HOTMAIL.COM',0,'2014-03-04 21:01:20',NULL,NULL),(41853,27833,'AP','6145889139',0,'2014-03-05 21:32:02',NULL,NULL),(648,403,'TE','6148060734',0,'2013-12-25 17:46:12',NULL,NULL),(2185,1344,'AP','5126800562',0,'2013-12-25 18:45:04',NULL,NULL),(4474,2848,'AP','8324430906',0,'2013-12-25 20:01:16',NULL,NULL),(5062,3249,'TE','4408779797',0,'2013-12-25 20:46:35',NULL,NULL),(7543,4914,'TE','6014028797',0,'2013-12-25 22:32:11',NULL,NULL),(7799,5089,'EM','tigerlily10212002@yahoo.com',0,'2013-12-25 23:01:10',NULL,NULL),(24968,16092,'TE','6019403909',0,'2014-01-04 02:04:28',NULL,NULL),(26355,16963,'TE','3303577808',0,'2014-01-13 02:20:09',NULL,NULL),(28363,18276,'AP','9034524915',0,'2014-01-16 08:44:44',NULL,NULL),(29430,19028,'AP','4405910381',0,'2014-01-20 08:06:30',NULL,NULL),(36091,23737,'TE','3306371034',0,'2014-02-14 21:31:02',NULL,NULL),(36401,23973,'TE','3183253147',0,'2014-02-15 22:00:16',NULL,NULL),(36974,24344,'AP','5128180881',0,'2014-02-18 22:00:22',NULL,NULL),(37058,24404,'TE','9374225341',0,'2014-02-18 22:00:57',NULL,NULL),(40504,26881,'AP','3306854659',0,'2014-03-01 21:01:09',NULL,NULL),(40884,27165,'AP','2104544057',0,'2014-03-03 21:31:02',NULL,NULL),(9371,6133,'EM','glenndougie@yahoo.com',0,'2013-12-26 00:16:05',NULL,NULL),(98,57,'EM','elizabeth.mahone@gmail.com',0,'2013-12-25 17:16:35',NULL,NULL),(844,523,'EM','ericmcrawford@gmail.com',0,'2013-12-25 17:49:16',NULL,NULL),(21369,13740,'EM','donolanterns@hotmail.com',0,'2013-12-26 13:09:40',NULL,NULL),(5692,3655,'AP','4408123871',0,'2013-12-25 21:30:44',NULL,NULL),(11654,7586,'AP','7133764146',0,'2013-12-26 02:34:05',NULL,NULL),(4866,3114,'AP','9034919126',0,'2013-12-25 20:30:07',NULL,NULL),(26278,16912,'TE','4402907463',0,'2014-01-13 02:19:39',NULL,NULL),(26670,17159,'TE','9857882070',0,'2014-01-13 02:22:00',NULL,NULL),(30923,20110,'TE','3302896086',0,'2014-01-27 21:00:40',NULL,NULL),(31250,20355,'AP','3302344751',0,'2014-01-28 21:01:17',NULL,NULL),(34831,22843,'AP','5672045273',0,'2014-02-11 21:02:15',NULL,NULL),(37727,24880,'TE','6507145966',0,'2014-02-20 05:36:00',NULL,NULL),(43893,29122,'AP','3148087930',0,'2014-03-10 21:02:31',NULL,NULL),(193,114,'EM','ernestojimenez915@yahoo.com',0,'2013-12-25 17:18:03',NULL,NULL),(25632,16530,'AP','9155002910',1,'2014-01-07 10:22:02',NULL,NULL),(24132,15577,'TE','4349428032',1,'2014-01-02 04:32:04',NULL,NULL),(23227,14969,'TE','6202491524',0,'2014-01-01 12:00:44',NULL,NULL),(5981,3842,'EM','GEOLLC@YAHOO.COM',0,'2013-12-25 21:35:25',NULL,NULL),(6090,3920,'AP','5672793627',0,'2013-12-25 21:37:21',NULL,NULL),(11183,7272,'AP','9034723275',0,'2013-12-26 02:02:28',NULL,NULL),(11359,7399,'AP','4199449523',0,'2013-12-26 02:16:23',NULL,NULL),(14080,9205,'TE','6625745023',0,'2013-12-26 04:09:47',NULL,NULL),(6749,4381,'TE','9378433740',0,'2013-12-25 22:00:37',NULL,NULL),(14536,9496,'EM','qzorp1@gmail.com',0,'2013-12-26 04:35:03',NULL,NULL),(14580,9533,'EM','COPOMD@HOTMAIL.COM',0,'2013-12-26 04:35:51',NULL,NULL),(7024,4587,'TE','3306060923',0,'2013-12-25 22:05:22',NULL,NULL),(20660,13286,'EM','mary.castillo113@gmail.com',0,'2013-12-26 12:57:21',NULL,NULL),(20913,13449,'TE','4402237167',0,'2013-12-26 13:01:26',NULL,NULL),(21717,13991,'TE','4196544411',0,'2013-12-26 13:15:47',NULL,NULL),(8599,5651,'AP','9156132729',0,'2013-12-25 23:31:30',NULL,NULL),(39807,26326,'TE','6624699903',0,'2014-02-28 06:31:38',NULL,NULL),(42932,28546,'AP','2164076078',0,'2014-03-07 21:32:17',NULL,NULL),(29968,19392,'TE','5136166523',1,'2014-01-22 03:22:48',NULL,NULL),(32229,21049,'AP','8063004671',0,'2014-02-02 19:00:05',NULL,NULL),(34257,22470,'TE','2103647116',0,'2014-02-10 21:30:58',NULL,NULL),(38739,25608,'EM','jeffowens1957@hotmail.com',0,'2014-02-26 08:30:07',NULL,NULL),(10421,6795,'TE','3306994893',0,'2013-12-26 01:17:11',NULL,NULL),(25380,16368,'EM','mudgett1@earthlink.net',0,'2014-01-07 04:02:58',NULL,NULL),(24890,16046,'AP','3102515068',0,'2014-01-04 02:03:03',NULL,NULL),(23633,15262,'TE','9372053900',0,'2014-01-01 12:09:18',NULL,NULL),(23198,14950,'EM','erik@eriklittle.com',0,'2014-01-01 12:00:10',NULL,NULL),(20599,13250,'EM','beesue10@hotmail.com',0,'2013-12-26 12:56:22',NULL,NULL),(10184,6656,'TE','4407856707',0,'2013-12-26 01:00:43',NULL,NULL),(26451,17028,'AP','3304215403',0,'2014-01-13 02:20:43',NULL,NULL),(37113,24435,'TE','3305540644',0,'2014-02-18 22:01:15',NULL,NULL),(9579,6273,'TE','3309276407',0,'2013-12-26 00:45:09',NULL,NULL),(11856,7717,'TE','9377781763',0,'2013-12-26 03:01:39',NULL,NULL),(2714,1648,'TE','4324453563',0,'2013-12-25 18:53:17',NULL,NULL),(2364,1435,'AP','5046160922',0,'2013-12-25 18:47:42',NULL,NULL),(9089,5956,'EM','Champntime@gmail.com',0,'2013-12-25 23:51:16',NULL,NULL),(28938,18683,'TE','3256688877',0,'2014-01-17 03:35:21',NULL,NULL),(29309,18936,'TE','5133640256',0,'2014-01-20 08:05:41',NULL,NULL),(30681,19928,'AP','6623178892',0,'2014-01-24 21:01:07',NULL,NULL),(32450,21203,'TE','3187524457',0,'2014-02-03 21:00:54',NULL,NULL),(33109,21689,'AP','2257733230',0,'2014-02-05 21:31:05',NULL,NULL),(38451,25409,'TE','4199467520',0,'2014-02-25 21:31:02',NULL,NULL),(39298,25997,'EM','kec118bmr@gmail.com',0,'2014-02-26 21:02:01',NULL,NULL),(39523,26143,'TE','5315083750',0,'2014-02-28 06:30:26',NULL,NULL),(40041,26543,'TE','4402863492',0,'2014-02-28 21:30:09',NULL,NULL),(40821,27125,'TE','4198623990',0,'2014-03-03 21:30:36',NULL,NULL),(41592,27653,'EM','tblanch007@gmail.com',0,'2014-03-05 21:30:23',NULL,NULL),(753,472,'TE','5672184443',0,'2013-12-25 17:47:54',NULL,NULL),(5210,3347,'TE','8063191596',0,'2013-12-25 21:16:39',NULL,NULL),(4094,2611,'AP','6142664283',0,'2013-12-25 19:45:37',NULL,NULL),(11342,7388,'TE','9372986375',0,'2013-12-26 02:16:05',NULL,NULL),(11849,7711,'AP','2165263952',0,'2013-12-26 03:01:30',NULL,NULL),(1241,755,'EM','oldpe76@yahoo.com',0,'2013-12-25 18:04:24',NULL,NULL),(21264,13664,'TE','5409316179',0,'2013-12-26 13:07:43',NULL,NULL),(21359,13729,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:23',NULL,NULL),(1078,664,'TE','7174718400',0,'2013-12-25 18:01:57',NULL,NULL),(9956,6515,'TE','4196489829',0,'2013-12-26 00:51:15',NULL,NULL),(6284,4052,'TE','4402130968',0,'2013-12-25 21:46:26',NULL,NULL),(8168,5344,'TE','3308477302',0,'2013-12-25 23:07:27',NULL,NULL),(3050,1897,'AP','4196771138',0,'2013-12-25 18:59:02',NULL,NULL),(25489,16433,'EM','Marco563@hotmail.com',0,'2014-01-07 04:04:55',NULL,NULL),(25906,16695,'EM','cronometria@gmail.com',0,'2014-01-08 18:24:37',NULL,NULL),(27576,17772,'AP','7133970884',0,'2014-01-14 01:33:39',NULL,NULL),(34046,22324,'AP','5049317966',0,'2014-02-10 11:00:56',NULL,NULL),(37550,24722,'AP','5134851656',0,'2014-02-20 04:38:23',NULL,NULL),(37742,24898,'AP','4194260017',0,'2014-02-20 05:41:05',NULL,NULL),(42712,28410,'TE','2168945754',0,'2014-03-07 21:30:56',NULL,NULL),(10069,6582,'EM','gabramsva@yahoo.com',0,'2013-12-26 00:53:01',NULL,NULL),(23061,14874,'AP','9035132060',0,'2013-12-30 00:00:19',NULL,NULL),(9021,5919,'EM','BethF1984@aol.com',0,'2013-12-25 23:50:14',NULL,NULL),(12207,7976,'EM','llehct@aol.com',0,'2013-12-26 03:07:50',NULL,NULL),(8677,5697,'TE','4409889611',0,'2013-12-25 23:32:48',NULL,NULL),(5009,3215,'AP','3309581610',0,'2013-12-25 20:45:33',NULL,NULL),(7835,5113,'AP','2816596401',0,'2013-12-25 23:01:46',NULL,NULL),(23320,15025,'TE','3188346655',0,'2014-01-01 12:02:27',NULL,NULL),(27634,17813,'TE','2103555519',0,'2014-01-15 02:05:53',NULL,NULL),(32898,21536,'AP','6149463601',0,'2014-02-05 21:30:08',NULL,NULL),(33040,21645,'TE','4199358842',0,'2014-02-05 21:30:47',NULL,NULL),(34100,22350,'BN','4199321586',0,'2014-02-10 21:00:03',NULL,NULL),(34267,22482,'TE','3305659455',0,'2014-02-10 21:31:03',NULL,NULL),(35680,23469,'EM','ayelli2000@yahoo.com',0,'2014-02-13 22:01:47',NULL,NULL),(37194,24482,'AP','5134440216',0,'2014-02-18 22:01:46',NULL,NULL),(38082,25139,'TE','9039171382',0,'2014-02-21 22:00:09',NULL,NULL),(2678,1625,'TE','9157304535',0,'2013-12-25 18:52:41',NULL,NULL),(21492,13812,'EM','dalejrfan32832001@yahoo.com',0,'2013-12-26 13:11:38',NULL,NULL),(21175,13621,'TE','7033008277',0,'2013-12-26 13:05:52',NULL,NULL),(5260,3378,'AP','8172011989',0,'2013-12-25 21:17:26',NULL,NULL),(14322,9365,'AP','4092739400',0,'2013-12-26 04:31:39',NULL,NULL),(14174,9273,'AP','7406452268',0,'2013-12-26 04:15:44',NULL,NULL),(11311,7370,'TE','5132829856',0,'2013-12-26 02:15:39',NULL,NULL),(6455,4169,'EM','JTCO1@BEX.NET',0,'2013-12-25 21:49:11',NULL,NULL),(24870,16037,'AP','5043279010',0,'2014-01-04 02:02:43',NULL,NULL),(25054,16152,'TE','4193031395',0,'2014-01-04 02:06:16',NULL,NULL),(26304,16932,'AP','5049099916',0,'2014-01-13 02:19:49',NULL,NULL),(27160,17487,'TE','9567761260',0,'2014-01-13 03:01:17',NULL,NULL),(29594,19123,'TE','4408362152',0,'2014-01-21 08:45:19',NULL,NULL),(32519,21259,'TE','5133413406',0,'2014-02-03 21:01:22',NULL,NULL),(36105,23755,'EM','falckamber@gmail.com',0,'2014-02-14 21:31:08',NULL,NULL),(37613,24788,'TE','5137312560',0,'2014-02-20 04:46:34',NULL,NULL),(38427,25396,'TE','3308585222',0,'2014-02-25 21:30:53',NULL,NULL),(40858,27150,'EM','cincyblaze44@gmail.com',0,'2014-03-03 21:30:52',NULL,NULL),(40861,27153,'TE','7409291054',0,'2014-03-03 21:30:54',NULL,NULL),(3082,1923,'EM','Tony452237@yahoo.com',0,'2013-12-25 19:00:13',NULL,NULL),(25919,16703,'AP','9568328860',0,'2014-01-08 18:24:39',NULL,NULL),(24525,15818,'TE','6148903378',0,'2014-01-03 02:03:27',NULL,NULL),(24212,15639,'EM','ronbuivan@gmail.com',1,'2014-01-02 04:33:47',NULL,NULL),(23725,15309,'TE','2084736474',1,'2014-01-02 04:23:08',NULL,NULL),(23696,15296,'AP','9854134520',1,'2014-01-02 04:22:40',NULL,NULL),(14022,9157,'TE','5135422336',0,'2013-12-26 04:08:36',NULL,NULL),(20552,13228,'TE','9039312556',0,'2013-12-26 12:55:41',NULL,NULL),(9840,6436,'AP','3372075405',0,'2013-12-26 00:49:19',NULL,NULL),(7555,4919,'EM','yvonnemclaughlin@gmail.com',0,'2013-12-25 22:45:07',NULL,NULL),(22320,14388,'EM','brenstevenson.BS@gmail.com',0,'2013-12-28 03:30:57',NULL,NULL),(3085,1924,'EM','kimonline99@yahoo.com',0,'2013-12-25 19:00:15',NULL,NULL),(30765,19995,'TE','7406592525',0,'2014-01-26 19:00:02',NULL,NULL),(30865,20062,'TE','9155880762',0,'2014-01-27 21:00:12',NULL,NULL),(37051,24399,'TE','5139417162',0,'2014-02-18 22:00:53',NULL,NULL),(37433,24648,'AP','2253018261',0,'2014-02-20 04:22:02',NULL,NULL),(39883,26389,'TE','4404767132',0,'2014-02-28 07:00:25',NULL,NULL),(40898,27176,'TE','8304210744',0,'2014-03-03 21:31:07',NULL,NULL),(41963,27894,'EM','darleneurich@frontier.com',0,'2014-03-05 21:32:41',NULL,NULL),(42984,28589,'AP','7408216018',0,'2014-03-08 21:30:01',NULL,NULL),(43086,28643,'AP','3255180414',0,'2014-03-08 21:30:33',NULL,NULL),(699,433,'TE','3308083763',0,'2013-12-25 17:46:59',NULL,NULL),(25047,16144,'EM','sheppardmorgan@yahoo.com',0,'2014-01-04 02:06:06',NULL,NULL),(9833,6434,'TE','2252763389',0,'2013-12-26 00:49:14',NULL,NULL),(8845,5794,'EM','nlange@neo.rr.com',0,'2013-12-25 23:47:21',NULL,NULL),(3206,2014,'TE','3309230451',0,'2013-12-25 19:02:36',NULL,NULL),(10992,7141,'TE','9035670844',0,'2013-12-26 01:51:53',NULL,NULL),(12471,8167,'EM','glbrtrt@aol.com',0,'2013-12-26 03:16:32',NULL,NULL),(14190,9285,'TE','3303402413',0,'2013-12-26 04:16:00',NULL,NULL),(20649,13281,'TE','9152150011',0,'2013-12-26 12:57:12',NULL,NULL),(29227,18878,'TE','3375649192',0,'2014-01-17 03:36:27',NULL,NULL),(29466,19049,'EM','kathrynhudson22@gmail.com',0,'2014-01-20 08:06:43',NULL,NULL),(30760,19989,'EM','bpete200336@gmail.com',0,'2014-01-25 19:00:19',NULL,NULL),(32508,21251,'TE','3307607153',0,'2014-02-03 21:01:17',NULL,NULL),(32896,21532,'EM','sbbass00@gmail.com',0,'2014-02-05 21:30:07',NULL,NULL),(34560,22665,'TE','9728396909',0,'2014-02-11 21:00:38',NULL,NULL),(35787,23534,'TE','3184934988',0,'2014-02-13 22:02:28',NULL,NULL),(40315,26750,'TE','7139230855',0,'2014-03-01 19:00:02',NULL,NULL),(42196,28029,'TE','4194100452',0,'2014-03-06 21:01:26',NULL,NULL),(200,122,'AP','9376614447',0,'2013-12-25 17:18:13',NULL,NULL),(25593,16510,'TE','4325273011',1,'2014-01-07 10:21:21',NULL,NULL),(25058,16153,'EM','amalshe@gmail.com',0,'2014-01-04 02:06:19',NULL,NULL),(24954,16083,'EM','Whorunit812@gmail.com',0,'2014-01-04 02:04:11',NULL,NULL),(4042,2580,'AP','9372188423',0,'2013-12-25 19:37:59',NULL,NULL),(4870,3116,'AP','3147996879',0,'2013-12-25 20:30:11',NULL,NULL),(9973,6524,'EM','nkftacnik@endurorunner.com',0,'2013-12-26 00:51:31',NULL,NULL),(10620,6909,'TE','2252570133',0,'2013-12-26 01:45:52',NULL,NULL),(618,380,'EM','vicfour@suddenlink.net',0,'2013-12-25 17:45:41',NULL,NULL),(5601,3586,'AP','5134974097',0,'2013-12-25 21:22:52',NULL,NULL),(5845,3751,'TE','2103204412',0,'2013-12-25 21:33:10',NULL,NULL),(26435,17008,'TE','5132563060',0,'2014-01-13 02:20:35',NULL,NULL),(31273,20372,'AP','2252681915',0,'2014-01-29 21:00:06',NULL,NULL),(32373,21151,'TE','2164859420',0,'2014-02-03 21:00:28',NULL,NULL),(36657,24132,'TE','9014977309',0,'2014-02-15 22:01:48',NULL,NULL),(37230,24500,'AP','7139602677',0,'2014-02-20 03:49:03',NULL,NULL),(37416,24641,'TE','3372968586',0,'2014-02-20 04:20:20',NULL,NULL),(40466,26861,'EM','2CHANGEYOURLIFE@SBCGLOBAL.NET',0,'2014-03-01 21:00:57',NULL,NULL),(41311,27444,'EM','linda.luttrell@sbcglobal.net',0,'2014-03-04 21:01:55',NULL,NULL),(43395,28820,'TE','4194660834',0,'2014-03-09 21:00:59',NULL,NULL),(43700,29009,'TE','3305272482',0,'2014-03-10 21:01:23',NULL,NULL),(2845,1728,'EM','rmzymler11@gmail.com',0,'2013-12-25 18:55:20',NULL,NULL),(25613,16520,'AP','2542890072',1,'2014-01-07 10:21:41',NULL,NULL),(24835,16018,'AP','5042109533',0,'2014-01-04 02:02:05',NULL,NULL),(4557,2899,'EM','vanessarastetter@gmail.com',0,'2013-12-25 20:15:20',NULL,NULL),(6210,4000,'AP','6144206565',0,'2013-12-25 21:45:11',NULL,NULL),(3865,2458,'AP','2142576425',0,'2013-12-25 19:34:51',NULL,NULL),(9284,6079,'EM','deansplace@peoplepc.com',0,'2013-12-26 00:02:25',NULL,NULL),(9603,6286,'EM','white4722@sbcglobal.net',0,'2013-12-26 00:45:31',NULL,NULL),(10977,7133,'TE','6622588656',0,'2013-12-26 01:51:40',NULL,NULL),(14085,9210,'AP','6018741928',0,'2013-12-26 04:09:53',NULL,NULL),(3691,2341,'TE','9795325902',0,'2013-12-25 19:31:58',NULL,NULL),(27668,17834,'EM','CDREVELS@HOTMAIL.COM',0,'2014-01-15 02:06:01',NULL,NULL),(30990,20159,'AP','3302409576',0,'2014-01-27 21:01:09',NULL,NULL),(32209,21036,'AP','4192301542',0,'2014-02-01 19:00:48',NULL,NULL),(32891,21531,'TE','9363660046',0,'2014-02-05 21:30:06',NULL,NULL),(33722,22120,'TE','9374084561',0,'2014-02-08 19:00:39',NULL,NULL),(35020,22995,'EM','teneshah@ymail.com',0,'2014-02-12 21:30:16',NULL,NULL),(35549,23376,'AP','7408194073',0,'2014-02-13 22:00:57',NULL,NULL),(35861,23583,'TE','9377635290',0,'2014-02-13 22:02:58',NULL,NULL),(41608,27663,'TE','3304184453',0,'2014-03-05 21:30:29',NULL,NULL),(392,239,'EM','taunda.terry@yahoo.com',0,'2013-12-25 17:21:16',NULL,NULL),(12287,8036,'AP','4198891268',0,'2013-12-26 03:09:18',NULL,NULL),(14160,9268,'TE','4404099049',0,'2013-12-26 04:15:33',NULL,NULL),(20209,13021,'TE','7248541031',0,'2013-12-26 12:50:04',NULL,NULL),(7147,4661,'TE','3182817847',0,'2013-12-25 22:07:23',NULL,NULL),(26211,16872,'TE','2543867249',0,'2014-01-13 02:19:16',NULL,NULL),(38613,25520,'EM','newtonmargaret1950@yahoo.com',0,'2014-02-25 21:32:06',NULL,NULL),(554,345,'TE','2169782843',0,'2013-12-25 17:32:05',NULL,NULL),(25650,16541,'TE','4086661107',1,'2014-01-07 10:22:22',NULL,NULL),(8320,5455,'TE','3306735957',0,'2013-12-25 23:10:17',NULL,NULL),(7845,5119,'AP','8065950331',0,'2013-12-25 23:01:54',NULL,NULL),(6197,3993,'AP','9377265243',0,'2013-12-25 21:39:10',NULL,NULL),(6139,3953,'TE','2097703999',0,'2013-12-25 21:38:13',NULL,NULL),(4233,2706,'EM','andres.mireles87@gmail.com',0,'2013-12-25 19:47:52',NULL,NULL),(5714,3667,'TE','5136164462',0,'2013-12-25 21:31:03',NULL,NULL),(5992,3849,'AP','3184171196',0,'2013-12-25 21:35:36',NULL,NULL),(23162,14929,'EM','TerrelleThomas@hotmail.com',0,'2013-12-30 00:01:57',NULL,NULL),(27754,17893,'TE','6147072555',0,'2014-01-15 02:06:21',NULL,NULL),(29206,18867,'TE','5042087227',0,'2014-01-17 03:36:22',NULL,NULL),(29566,19105,'TE','9852319369',0,'2014-01-21 08:44:41',NULL,NULL),(30512,19792,'TE','4405822202',0,'2014-01-23 21:01:41',NULL,NULL),(32176,21017,'TE','5135948249',0,'2014-02-01 19:00:37',NULL,NULL),(33403,21887,'TE','5139193175',0,'2014-02-06 21:01:35',NULL,NULL),(34038,22321,'TE','3375156715',0,'2014-02-10 11:00:54',NULL,NULL),(36935,24322,'AP','9564327977',0,'2014-02-18 22:00:09',NULL,NULL),(37911,25009,'TE','2162156936',0,'2014-02-20 22:00:51',NULL,NULL),(41292,27435,'TE','5045799144',0,'2014-03-04 21:01:49',NULL,NULL),(41367,27481,'BN','8328830907',0,'2014-03-04 21:02:17',NULL,NULL),(42839,28491,'EM','des3baby@yahoo.com',0,'2014-03-07 21:31:42',NULL,NULL),(6448,4165,'TE','3309048435',0,'2013-12-25 21:49:06',NULL,NULL),(21007,13515,'AP','2252702388',0,'2013-12-26 13:03:03',NULL,NULL),(5273,3385,'EM','hwheatonjr@att.net',0,'2013-12-25 21:17:38',NULL,NULL),(2247,1377,'TE','9857078359',0,'2013-12-25 18:45:59',NULL,NULL),(11037,7162,'AP','4197225891',0,'2013-12-26 01:52:31',NULL,NULL),(4488,2854,'TE','2254397000',0,'2013-12-25 20:01:29',NULL,NULL),(2655,1612,'EM','Oraliamunoz@rocketmail.com',0,'2013-12-25 18:52:21',NULL,NULL),(23078,14883,'AP','9857890007',0,'2013-12-30 00:00:36',NULL,NULL),(26580,17099,'EM','danzinal@yahoo.com',0,'2014-01-13 02:21:31',NULL,NULL),(28901,18657,'AP','9037801426',0,'2014-01-17 03:35:12',NULL,NULL),(29752,19238,'TE','9336633065',0,'2014-01-21 08:46:36',NULL,NULL),(31839,20786,'TE','9039322834',0,'2014-01-31 21:00:13',NULL,NULL),(32822,21477,'TE','6143401563',0,'2014-02-04 21:01:41',NULL,NULL),(33261,21781,'TE','4402636065',0,'2014-02-06 21:00:38',NULL,NULL),(40018,26515,'TE','4192039514',0,'2014-02-28 21:00:22',NULL,NULL),(7280,4743,'AP','9378768722',0,'2013-12-25 22:09:32',NULL,NULL),(20975,13499,'EM','ar304304@ohio.edu',0,'2013-12-26 13:02:34',NULL,NULL),(4750,3042,'TE','3307056303',0,'2013-12-25 20:18:40',NULL,NULL),(11353,7396,'AP','3302042165',0,'2013-12-26 02:16:18',NULL,NULL),(11521,7497,'TE','3309321036',0,'2013-12-26 02:31:46',NULL,NULL),(11550,7518,'AP','9852102203',0,'2013-12-26 02:32:18',NULL,NULL),(14965,9791,'TE','5042433052',0,'2013-12-26 05:00:59',NULL,NULL),(24203,15635,'AP','3185109710',1,'2014-01-02 04:33:37',NULL,NULL),(27031,17382,'TE','5136088993',0,'2014-01-13 03:00:07',NULL,NULL),(27151,17482,'AP','9033432526',0,'2014-01-13 03:01:14',NULL,NULL),(27745,17889,'TE','5134829436',0,'2014-01-15 02:06:19',NULL,NULL),(29571,19107,'EM','thomas.siebold@wright.edu',0,'2014-01-21 08:44:42',NULL,NULL),(29639,19149,'AP','9032597471',0,'2014-01-21 08:45:34',NULL,NULL),(39680,26237,'TE','5129706493',0,'2014-02-28 06:31:03',NULL,NULL),(205,125,'TE','5132489168',0,'2013-12-25 17:18:18',NULL,NULL),(8685,5702,'TE','4194230773',0,'2013-12-25 23:32:56',NULL,NULL),(1938,1199,'AP','4196568611',0,'2013-12-25 18:19:51',NULL,NULL),(7127,4651,'AP','5133770057',0,'2013-12-25 22:07:05',NULL,NULL),(14373,9399,'EM','askoogie@aol.com',0,'2013-12-26 04:32:32',NULL,NULL),(12384,8111,'AP','5132275130',0,'2013-12-26 03:11:06',NULL,NULL),(24644,15890,'TE','4196934461',0,'2014-01-03 02:05:44',NULL,NULL),(26775,17225,'AP','9378308291',0,'2014-01-13 02:22:36',NULL,NULL),(29225,18877,'TE','3375233188',0,'2014-01-17 03:36:27',NULL,NULL),(39539,26159,'TE','4404871157',0,'2014-02-28 06:30:31',NULL,NULL),(41106,27303,'AP','2543340328',0,'2014-03-04 21:00:36',NULL,NULL),(42725,28419,'TE','3304008895',0,'2014-03-07 21:31:01',NULL,NULL),(375,228,'AP','5045597046',0,'2013-12-25 17:20:59',NULL,NULL),(22908,14782,'TE','2162526193',1,'2013-12-29 11:13:15',NULL,NULL),(10820,7028,'TE','2144501906',0,'2013-12-26 01:49:03',NULL,NULL),(22451,14477,'TE','8323528547',0,'2013-12-28 03:33:12',NULL,NULL),(7547,4916,'TE','2169732474',0,'2013-12-25 22:32:16',NULL,NULL),(21358,13727,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:21',NULL,NULL),(5811,3733,'TE','9567421745',0,'2013-12-25 21:32:39',NULL,NULL),(12269,8026,'TE','6012143183',0,'2013-12-26 03:09:01',NULL,NULL),(24982,16100,'AP','5092027121',0,'2014-01-04 02:04:45',NULL,NULL),(25622,16524,'TE','9038093000',1,'2014-01-07 10:21:51',NULL,NULL),(25782,16613,'AP','4403464307',0,'2014-01-08 18:24:09',NULL,NULL),(27132,17467,'EM','lenandginatthehive@gmail.com',0,'2014-01-13 03:01:06',NULL,NULL),(32576,21300,'TE','2256653329',0,'2014-02-04 21:00:12',NULL,NULL),(32865,21509,'TE','5673560152',0,'2014-02-04 21:01:57',NULL,NULL),(33298,21806,'AP','3306206530',0,'2014-02-06 21:00:52',NULL,NULL),(35677,23467,'TE','9722203205',0,'2014-02-13 22:01:45',NULL,NULL),(39485,26115,'AP','6147175760',0,'2014-02-28 06:30:17',NULL,NULL),(41961,27893,'BN','5672781279',0,'2014-03-05 21:32:41',NULL,NULL),(1930,1195,'TE','4404766225',0,'2013-12-25 18:19:43',NULL,NULL),(23277,14997,'AP','3254231334',0,'2014-01-01 12:01:36',NULL,NULL),(21302,13685,'TE','2163144336',0,'2013-12-26 13:08:19',NULL,NULL),(9992,6538,'AP','2073129012',0,'2013-12-26 00:51:51',NULL,NULL),(12250,8009,'AP','8303776318',0,'2013-12-26 03:08:36',NULL,NULL),(12214,7980,'TE','3309282995',0,'2013-12-26 03:07:57',NULL,NULL),(11992,7811,'EM','HOUSTONBARB@YAHOO.COM',0,'2013-12-26 03:03:58',NULL,NULL),(7112,4645,'TE','6623874744',0,'2013-12-25 22:06:53',NULL,NULL),(5250,3370,'EM','hngreen411@gmail.com',0,'2013-12-25 21:17:15',NULL,NULL),(26681,17163,'AP','2255714120',0,'2014-01-13 02:22:03',NULL,NULL),(27237,17534,'EM','rchamplin1@hotmail.com',0,'2014-01-13 03:01:45',NULL,NULL),(28204,18178,'EM','sraftery2003@yahoo.com',0,'2014-01-15 02:08:00',NULL,NULL),(29104,18793,'AP','5132560196',0,'2014-01-17 03:35:57',NULL,NULL),(29408,19009,'TE','5043245167',0,'2014-01-20 08:06:20',NULL,NULL),(31919,20834,'EM','pampam1620@yahoo.com',0,'2014-01-31 21:00:43',NULL,NULL),(32258,21070,'TE','6142168687',0,'2014-02-02 19:00:16',NULL,NULL),(32600,21315,'EM','shannonjadesr@gmail.com',0,'2014-02-04 21:00:19',NULL,NULL),(33291,21800,'TE','5672598898',0,'2014-02-06 21:00:49',NULL,NULL),(35475,23330,'EM','ROTHENLAMBS@GMAIL.COM',0,'2014-02-13 22:00:30',NULL,NULL),(35525,23365,'TE','3307941114',0,'2014-02-13 22:00:48',NULL,NULL),(35955,23654,'EM','Debbienguyen1993@gmail.com',0,'2014-02-14 21:30:16',NULL,NULL),(38768,25632,'TE','7407452868',0,'2014-02-26 08:30:24',NULL,NULL),(40805,27116,'EM','taundraezell@sbcglobal.net',0,'2014-03-03 21:30:30',NULL,NULL),(895,554,'TE','2254486617',0,'2013-12-25 17:50:07',NULL,NULL),(10772,7002,'EM','SALLY.C.GLASS@GMAIL.COM',0,'2013-12-26 01:48:19',NULL,NULL),(14120,9237,'TE','4403088166',0,'2013-12-26 04:10:37',NULL,NULL),(12201,7972,'AP','3307037129',0,'2013-12-26 03:07:43',NULL,NULL),(12047,7863,'TE','3306782211',0,'2013-12-26 03:05:02',NULL,NULL),(3443,2158,'AP','2252239931',0,'2013-12-25 19:18:48',NULL,NULL),(9203,6022,'AP','9153739670',0,'2013-12-26 00:00:54',NULL,NULL),(23312,15021,'AP','2252356241',0,'2014-01-01 12:02:20',NULL,NULL),(27444,17678,'EM','rmproast1@att.net',0,'2014-01-14 01:32:53',NULL,NULL),(28321,18253,'BN','8327589468',0,'2014-01-16 08:44:32',NULL,NULL),(28804,18590,'TE','5675105405',0,'2014-01-16 08:47:13',NULL,NULL),(30077,19484,'EM','trayceelillie@aol.com',0,'2014-01-23 03:02:04',NULL,NULL),(30501,19784,'TE','3307178086',0,'2014-01-23 21:01:36',NULL,NULL),(30846,20051,'TE','9152742535',0,'2014-01-27 21:00:05',NULL,NULL),(31297,20393,'TE','9154873317',0,'2014-01-29 21:00:16',NULL,NULL),(33943,22274,'EM','gregharmison@att.net',0,'2014-02-10 11:00:16',NULL,NULL),(35354,23229,'AP','2169326645',0,'2014-02-12 21:32:24',NULL,NULL),(38342,25329,'TE','9853355855',0,'2014-02-25 21:30:16',NULL,NULL),(39741,26283,'AP','7137254618',0,'2014-02-28 06:31:21',NULL,NULL),(41029,27260,'AP','5132802580',0,'2014-03-03 21:31:59',NULL,NULL),(42654,28378,'TE','9373784219',0,'2014-03-07 21:30:37',NULL,NULL),(11558,7522,'TE','5136414223',0,'2013-12-26 02:32:25',NULL,NULL),(22912,14785,'TE','3308812064',1,'2013-12-29 11:13:20',NULL,NULL),(2175,1338,'AP','9379022240',0,'2013-12-25 18:32:19',NULL,NULL),(14052,9182,'TE','4198893730',0,'2013-12-26 04:09:12',NULL,NULL),(2752,1669,'TE','2145541751',0,'2013-12-25 18:53:50',NULL,NULL),(7975,5203,'TE','3049935597',0,'2013-12-25 23:04:05',NULL,NULL),(3113,1941,'TE','6144218823',0,'2013-12-25 19:00:41',NULL,NULL),(11473,7461,'AP','6017610930',0,'2013-12-26 02:30:56',NULL,NULL),(9702,6353,'AP','6144032000',0,'2013-12-26 00:47:07',NULL,NULL),(10543,6866,'AP','2815960800',0,'2013-12-26 01:31:50',NULL,NULL),(24555,15838,'TE','5133416905',0,'2014-01-03 02:04:05',NULL,NULL),(24948,16080,'EM','chazspopculture@yahoo.com',0,'2014-01-04 02:04:06',NULL,NULL),(26695,17173,'AP','3305030224',0,'2014-01-13 02:22:08',NULL,NULL),(28480,18354,'TE','4403152550',0,'2014-01-16 08:45:23',NULL,NULL),(29836,19301,'TE','2259534398',1,'2014-01-22 03:22:01',NULL,NULL),(31151,20288,'AP','3184048596',0,'2014-01-28 21:00:34',NULL,NULL),(31945,20851,'AP','4197331352',0,'2014-01-31 21:00:53',NULL,NULL),(32916,21548,'AP','7405072935',0,'2014-02-05 21:30:12',NULL,NULL),(38872,25694,'TE','5124230035',0,'2014-02-26 09:30:14',NULL,NULL),(39806,26324,'AP','6629028977',0,'2014-02-28 06:31:38',NULL,NULL),(572,354,'AP','4194198484',0,'2013-12-25 17:32:23',NULL,NULL),(1966,1216,'TE','9375365596',0,'2013-12-25 18:20:16',NULL,NULL),(10141,6627,'AP','9374227635',0,'2013-12-26 00:54:15',NULL,NULL),(6341,4087,'EM','katcan007@yahoo.com',0,'2013-12-25 21:47:20',NULL,NULL),(5518,3529,'EM','steve@steverokks.com',0,'2013-12-25 21:21:28',NULL,NULL),(24760,15975,'TE','9365725431',0,'2014-01-04 02:00:44',NULL,NULL),(26860,17286,'TE','9795753693',0,'2014-01-13 02:23:29',NULL,NULL),(27084,17419,'TE','9378769432',0,'2014-01-13 03:00:26',NULL,NULL),(27247,17542,'EM','s_shanahan29@yahoo.com',0,'2014-01-13 03:01:49',NULL,NULL),(27398,17643,'BN','3306069956',0,'2014-01-14 01:32:37',NULL,NULL),(27588,17785,'EM','reddengr@aol.com',0,'2014-01-14 01:33:45',NULL,NULL),(28262,18224,'TE','9034782270',0,'2014-01-16 08:44:15',NULL,NULL),(28389,18289,'EM','wheresanar@hotmail.com',0,'2014-01-16 08:44:51',NULL,NULL),(32770,21438,'TE','4149820375',0,'2014-02-04 21:01:23',NULL,NULL),(34285,22493,'EM','sheribesso@gmail.com',0,'2014-02-10 21:31:09',NULL,NULL),(35547,23374,'EM','mjs4x4@yahoo.com',0,'2014-02-13 22:00:56',NULL,NULL),(35639,23436,'TE','8067908627',0,'2014-02-13 22:01:30',NULL,NULL),(38166,25190,'AP','5045635947',0,'2014-02-21 22:00:39',NULL,NULL),(40997,27238,'AP','6018075826',0,'2014-03-03 21:31:46',NULL,NULL),(41830,27812,'AP','2165343949',0,'2014-03-05 21:31:51',NULL,NULL),(1939,1199,'TE','4196568611',0,'2013-12-25 18:19:51',NULL,NULL),(8285,5430,'AP','2252875233',0,'2013-12-25 23:09:37',NULL,NULL),(13780,8981,'TE','6149612324',0,'2013-12-26 04:04:21',NULL,NULL),(5303,3400,'TE','3186887021',0,'2013-12-25 21:18:06',NULL,NULL),(11725,7632,'AP','9723633849',0,'2013-12-26 02:46:17',NULL,NULL),(7753,5062,'AP','3615334800',0,'2013-12-25 23:00:28',NULL,NULL),(7772,5071,'AP','9792248153',0,'2013-12-25 23:00:44',NULL,NULL),(6446,4164,'AP','5133242717',0,'2013-12-25 21:49:04',NULL,NULL),(5929,3802,'TE','4403199660',0,'2013-12-25 21:34:33',NULL,NULL),(23864,15400,'TE','9034930111',1,'2014-01-02 04:26:46',NULL,NULL),(24667,15906,'TE','4192031518',0,'2014-01-03 02:06:14',NULL,NULL),(24828,16015,'TE','3375326445',0,'2014-01-04 02:01:58',NULL,NULL),(30419,19717,'AP','4192157829',0,'2014-01-23 21:00:56',NULL,NULL),(31636,20639,'TE','8173864686',0,'2014-01-30 21:00:32',NULL,NULL),(32103,20965,'EM','amyndang@hotmail.com',0,'2014-02-01 19:00:11',NULL,NULL),(32413,21179,'AP','5135194800',0,'2014-02-03 21:00:42',NULL,NULL),(34826,22841,'AP','4195604753',0,'2014-02-11 21:02:14',NULL,NULL),(34986,22971,'TE','4408453860',0,'2014-02-12 21:00:16',NULL,NULL),(35000,22982,'TE','9378221336',0,'2014-02-12 21:30:09',NULL,NULL),(41229,27384,'AP','6018597395',0,'2014-03-04 21:01:23',NULL,NULL),(43368,28804,'AP','5132655656',0,'2014-03-09 21:00:50',NULL,NULL),(10303,6722,'AP','5132645663',0,'2013-12-26 01:15:15',NULL,NULL),(1873,1155,'TE','5046101251',0,'2013-12-25 18:18:45',NULL,NULL),(2053,1270,'EM','gloria@sellscars.org',0,'2013-12-25 18:30:15',NULL,NULL),(14931,9769,'EM','renee.geib@att.net',0,'2013-12-26 05:00:25',NULL,NULL),(8932,5848,'EM','annachowdhury@gmail.com',0,'2013-12-25 23:48:43',NULL,NULL),(12000,7818,'EM','alttimreed@gmail.com',0,'2013-12-26 03:04:07',NULL,NULL),(26001,16752,'AP','9563308903',0,'2014-01-08 18:24:55',NULL,NULL),(27284,17568,'AP','6148054391',0,'2014-01-14 01:32:00',NULL,NULL),(28085,18102,'TE','3183311657',0,'2014-01-15 02:07:34',NULL,NULL),(29425,19025,'TE','9018467924',0,'2014-01-20 08:06:28',NULL,NULL),(32043,20915,'AP','3305738503',0,'2014-01-31 21:01:30',NULL,NULL),(32769,21437,'EM','pennzoilmcgee@bellsouth.net',0,'2014-02-04 21:01:22',NULL,NULL),(34794,22823,'AP','5804616416',0,'2014-02-11 21:02:03',NULL,NULL),(34823,22839,'AP','4195604753',0,'2014-02-11 21:02:13',NULL,NULL),(36981,24347,'AP','9155493478',0,'2014-02-18 22:00:24',NULL,NULL),(38925,25732,'AP','9858565134',0,'2014-02-26 09:30:36',NULL,NULL),(40979,27227,'TE','5043318439',0,'2014-03-03 21:31:39',NULL,NULL),(41079,27288,'TE','2542661941',0,'2014-03-04 21:00:27',NULL,NULL),(41243,27395,'EM','vkirkbride@hotmail.com',0,'2014-03-04 21:01:29',NULL,NULL),(41293,27435,'AP','5045799144',0,'2014-03-04 21:01:49',NULL,NULL),(42469,28218,'AP','5135054192',0,'2014-03-06 21:30:17',NULL,NULL),(42492,28260,'AP','9379742355',0,'2014-03-07 21:00:16',NULL,NULL),(11274,7349,'AP','3134085601',0,'2013-12-26 02:15:03',NULL,NULL),(23954,15457,'TE','9152445845',1,'2014-01-02 04:28:33',NULL,NULL),(8927,5844,'TE','3615527153',0,'2013-12-25 23:48:38',NULL,NULL),(21784,14036,'AP','9377286564',0,'2013-12-26 13:17:02',NULL,NULL),(4421,2818,'AP','7697984243',0,'2013-12-25 20:00:26',NULL,NULL),(11831,7699,'TE','9372799884',0,'2013-12-26 03:01:13',NULL,NULL),(4517,2873,'TE','2104610709',0,'2013-12-25 20:02:00',NULL,NULL),(7030,4589,'EM','gmille23@kent.edu',0,'2013-12-25 22:05:27',NULL,NULL),(4859,3111,'TE','9373445262',0,'2013-12-25 20:20:33',NULL,NULL),(25028,16130,'EM','pmurphy7@neo.rr.com',0,'2014-01-04 02:05:40',NULL,NULL),(25078,16167,'AP','2258198199',0,'2014-01-05 00:00:08',NULL,NULL),(26040,16776,'AP','5132930683',0,'2014-01-08 18:25:04',NULL,NULL),(28481,18354,'AP','4403152550',0,'2014-01-16 08:45:23',NULL,NULL),(33621,22048,'TE','4193052865',0,'2014-02-07 19:30:06',NULL,NULL),(38796,25650,'TE','7402489029',0,'2014-02-26 08:30:38',NULL,NULL),(40190,26658,'EM','LWILLIAMSFITNESS@YAHOO.COM',0,'2014-02-28 21:31:10',NULL,NULL),(42591,28338,'TE','9728163897',0,'2014-03-07 21:30:15',NULL,NULL),(42858,28502,'TE','3308648700',0,'2014-03-07 21:31:49',NULL,NULL),(42931,28546,'TE','3304835976',0,'2014-03-07 21:32:17',NULL,NULL),(11145,7248,'TE','5047389558',0,'2013-12-26 02:01:50',NULL,NULL),(785,490,'EM','reharb@yahoo.com',0,'2013-12-25 17:48:23',NULL,NULL),(1963,1215,'EM','hellodarlin53@outlook.com',0,'2013-12-25 18:20:13',NULL,NULL),(6160,3970,'TE','5136282675',0,'2013-12-25 21:38:33',NULL,NULL),(22009,14175,'AP','8069304884',0,'2013-12-27 02:03:34',NULL,NULL),(2648,1610,'AP','2146065110',0,'2013-12-25 18:52:16',NULL,NULL),(2671,1620,'EM','irishgirl867@yahoo.com',0,'2013-12-25 18:52:35',NULL,NULL),(4736,3033,'AP','5673163432',0,'2013-12-25 20:18:28',NULL,NULL),(24231,15655,'EM','BSHANK554@GMAIL.COM',1,'2014-01-02 04:34:16',NULL,NULL),(24866,16034,'EM','tshelia1710@yahoo.com',0,'2014-01-04 02:02:37',NULL,NULL),(28058,18085,'TE','6012596497',0,'2014-01-15 02:07:28',NULL,NULL),(28490,18358,'TE','4193920420',0,'2014-01-16 08:45:25',NULL,NULL),(33573,22012,'TE','4405250785',0,'2014-02-07 19:00:52',NULL,NULL),(35415,23283,'TE','5132481436',0,'2014-02-13 21:30:17',NULL,NULL),(37353,24592,'TE','5133002623',0,'2014-02-20 04:11:02',NULL,NULL),(40600,26951,'AP','4197069040',0,'2014-03-03 01:00:26',NULL,NULL),(41296,27437,'EM','lillianinlimbo@yahoo.com',0,'2014-03-04 21:01:50',NULL,NULL),(42194,28027,'AP','3303516822',0,'2014-03-06 21:01:25',NULL,NULL),(43063,28629,'TE','8307733161',0,'2014-03-08 21:30:26',NULL,NULL),(11499,7481,'EM','m450reb@aol.com',0,'2013-12-26 02:31:24',NULL,NULL),(1351,826,'TE','2164708350',0,'2013-12-25 18:06:12',NULL,NULL),(9248,6051,'TE','9375729949',0,'2013-12-26 00:01:42',NULL,NULL),(4728,3025,'TE','6012123941',0,'2013-12-25 20:18:17',NULL,NULL),(24571,15850,'TE','4192362668',0,'2014-01-03 02:04:22',NULL,NULL),(27740,17884,'TE','2162251795',0,'2014-01-15 02:06:17',NULL,NULL),(28281,18233,'EM','artbrainstorms@gmail.com',0,'2014-01-16 08:44:20',NULL,NULL),(30175,19549,'TE','4195312741',0,'2014-01-23 03:02:28',NULL,NULL),(31722,20701,'AP','3372559953',0,'2014-01-30 21:01:04',NULL,NULL),(31809,20769,'TE','4195167817',0,'2014-01-30 21:01:39',NULL,NULL),(31812,20770,'TE','3524282278',0,'2014-01-30 21:01:39',NULL,NULL),(38570,25492,'TE','6018923224',0,'2014-02-25 21:31:48',NULL,NULL),(43106,28655,'TE','6785968982',0,'2014-03-08 21:30:40',NULL,NULL),(4579,2923,'TE','9372286966',0,'2013-12-25 20:15:49',NULL,NULL),(23115,14902,'AP','4404872437',0,'2013-12-30 00:01:10',NULL,NULL),(30469,19754,'TE','6145577101',0,'2014-01-23 21:01:20',NULL,NULL),(23637,15264,'AP','4198606105',0,'2014-01-01 12:09:23',NULL,NULL),(42568,28324,'TE','2818214050',0,'2014-03-07 21:30:07',NULL,NULL),(40316,26752,'EM','dungle7@yahoo.com',0,'2014-03-01 19:00:03',NULL,NULL),(8055,5275,'AP','3307035325',0,'2013-12-25 23:05:38',NULL,NULL),(8822,5778,'TE','5135027363',0,'2013-12-25 23:46:58',NULL,NULL),(9524,6234,'EM','SALVAREZ86@GMAIL.COM',0,'2013-12-26 00:31:32',NULL,NULL),(29426,19025,'AP','9018467924',0,'2014-01-20 08:06:28',NULL,NULL),(20378,13125,'AP','9376212422',0,'2013-12-26 12:52:52',NULL,NULL),(20937,13466,'TE','3309837687',0,'2013-12-26 13:01:54',NULL,NULL),(25176,16234,'BN','2163742928',0,'2014-01-05 00:02:08',NULL,NULL),(7023,4586,'AP','3309079549',0,'2013-12-25 22:05:21',NULL,NULL),(13835,9021,'TE','3304756609',0,'2013-12-26 04:05:19',NULL,NULL),(37340,24585,'AP','3308067219',0,'2014-02-20 04:09:26',NULL,NULL),(30977,20149,'EM','cmcjra@comcast.net',0,'2014-01-27 21:01:03',NULL,NULL),(9502,6218,'TE','4192556198',0,'2013-12-26 00:31:05',NULL,NULL),(29499,19069,'TE','4197058843',0,'2014-01-21 08:44:19',NULL,NULL),(5618,3599,'TE','4232338583',0,'2013-12-25 21:23:13',NULL,NULL),(3532,2210,'TE','3306061957',0,'2013-12-25 19:20:16',NULL,NULL),(21110,13571,'TE','5045200065',0,'2013-12-26 13:04:41',NULL,NULL),(23512,15168,'TE','5134448009',0,'2014-01-01 12:06:28',NULL,NULL),(24725,15951,'TE','9372945041',0,'2014-01-04 02:00:06',NULL,NULL),(26149,16834,'AP','3304143055',0,'2014-01-13 02:18:30',NULL,NULL),(62,41,'TE','6146011213',0,'2013-12-25 17:16:04',NULL,NULL),(5775,3699,'TE','5137778930',0,'2013-12-25 21:31:57',NULL,NULL),(12149,7937,'AP','3184048242',0,'2013-12-26 03:06:47',NULL,NULL),(5694,3656,'AP','3107360452',0,'2013-12-25 21:30:46',NULL,NULL),(14460,9446,'TE','5133900340',0,'2013-12-26 04:33:50',NULL,NULL),(20506,13203,'TE','2104524800',0,'2013-12-26 12:55:01',NULL,NULL),(41977,27903,'AP','9157803269',0,'2014-03-06 21:00:10',NULL,NULL),(28251,18217,'AP','4196937280',0,'2014-01-15 02:08:12',NULL,NULL),(33003,21616,'AP','8322286929',0,'2014-02-05 21:30:36',NULL,NULL),(42427,28177,'TE','3305404234',0,'2014-03-06 21:02:53',NULL,NULL),(44004,29195,'AP','2165096868',0,'2014-03-10 21:30:08',NULL,NULL),(6883,4468,'AP','4196568611',0,'2013-12-25 22:02:47',NULL,NULL),(39714,26267,'TE','9799002847',0,'2014-02-28 06:31:14',NULL,NULL),(5507,3525,'TE','5043307608',0,'2013-12-25 21:21:20',NULL,NULL),(39420,26068,'AP','5137168252',0,'2014-02-26 21:02:42',NULL,NULL),(1400,855,'AP','4192343495',0,'2013-12-25 18:07:02',NULL,NULL),(5395,3451,'EM','hopehammond@gmail.com',0,'2013-12-25 21:19:32',NULL,NULL),(39137,25885,'AP','2543340328',0,'2014-02-26 21:01:00',NULL,NULL),(38782,25639,'TE','3372126286',0,'2014-02-26 08:30:29',NULL,NULL),(25596,16513,'TE','9152555845',1,'2014-01-07 10:21:25',NULL,NULL),(23556,15204,'TE','6019421661',0,'2014-01-01 12:07:30',NULL,NULL),(42945,28552,'TE','4198225037',0,'2014-03-07 21:32:22',NULL,NULL),(500,316,'EM','zduce8@neo.rr.com',0,'2013-12-25 17:31:12',NULL,NULL),(12007,7822,'EM','billtxgg@aol.com',0,'2013-12-26 03:04:13',NULL,NULL),(11854,7716,'AP','5133071006',0,'2013-12-26 03:01:37',NULL,NULL),(11759,7653,'AP','9855072467',0,'2013-12-26 03:00:04',NULL,NULL),(11512,7491,'AP','4407850158',0,'2013-12-26 02:31:37',NULL,NULL),(11487,7469,'EM','thomwspicer@me.com',0,'2013-12-26 02:31:09',NULL,NULL),(35923,23636,'EM','jmbouligny@gmail.com',0,'2014-02-14 21:30:06',NULL,NULL),(3351,2106,'TE','5133720978',0,'2013-12-25 19:17:19',NULL,NULL),(28720,18535,'TE','4194610414',0,'2014-01-16 08:46:45',NULL,NULL),(23408,15078,'AP','9032685268',0,'2014-01-01 12:04:05',NULL,NULL),(23357,15046,'EM','Msja07@yahoo.com',0,'2014-01-01 12:03:08',NULL,NULL),(21775,14029,'EM','ken_r_mer@yahoo.com',0,'2013-12-26 13:16:50',NULL,NULL),(29652,19157,'TE','3309836764',0,'2014-01-21 08:45:39',NULL,NULL),(21157,13605,'TE','4192041035',0,'2013-12-26 13:05:31',NULL,NULL),(21061,13545,'EM','clandry0143@GMAIL.COM',0,'2013-12-26 13:03:55',NULL,NULL),(20987,13506,'EM','lashell08@yahoo.com',0,'2013-12-26 13:02:46',NULL,NULL),(14330,9370,'TE','5043941304',0,'2013-12-26 04:31:47',NULL,NULL),(42893,28526,'AP','3303076531',0,'2014-03-07 21:32:04',NULL,NULL),(40609,26955,'EM','hamric_stacey@yahoo.com',0,'2014-03-03 01:00:29',NULL,NULL),(39688,26244,'AP','4054763716',0,'2014-02-28 06:31:06',NULL,NULL),(11148,7249,'EM','ms10peaches@yahoo.com',0,'2013-12-26 02:01:52',NULL,NULL),(10463,6817,'AP','3304142197',0,'2013-12-26 01:30:26',NULL,NULL),(27461,17691,'AP','9852102328',0,'2014-01-14 01:32:59',NULL,NULL),(25430,16400,'EM','stacienalls@gmail.com',0,'2014-01-07 04:03:51',NULL,NULL),(24206,15637,'TE','3185720618',1,'2014-01-02 04:33:41',NULL,NULL),(14889,9744,'EM','pedromargaret@msn.com',0,'2013-12-26 04:46:01',NULL,NULL),(42635,28361,'EM','amygail1979@yahoo.com',0,'2014-03-07 21:30:29',NULL,NULL),(40800,27114,'BN','6145984059',0,'2014-03-03 21:30:29',NULL,NULL),(36378,23957,'AP','4322941186',0,'2014-02-15 22:00:08',NULL,NULL),(8130,5322,'EM','dan.hizer@yahoo.com',0,'2013-12-25 23:06:52',NULL,NULL),(36153,23795,'TE','3308086994',0,'2014-02-14 21:31:27',NULL,NULL),(34960,22952,'AP','4403717126',0,'2014-02-11 21:30:30',NULL,NULL),(8745,5734,'EM','rmssilva@bellsouth.net',0,'2013-12-25 23:45:45',NULL,NULL),(31675,20664,'TE','9035061841',0,'2014-01-30 21:00:45',NULL,NULL),(33631,22053,'TE','9153070468',0,'2014-02-08 19:00:06',NULL,NULL),(3147,1965,'AP','8176816774',0,'2013-12-25 19:01:19',NULL,NULL),(30006,19432,'TE','4194380271',1,'2014-01-22 03:23:08',NULL,NULL),(8220,5381,'TE','5043284907',0,'2013-12-25 23:08:22',NULL,NULL),(12194,7968,'AP','6015736651',0,'2013-12-26 03:07:37',NULL,NULL),(35765,23520,'EM','michelletocchi@roadrunner.com',0,'2014-02-13 22:02:20',NULL,NULL),(4200,2685,'EM','mike.spencer01@gmail.com',0,'2013-12-25 19:47:21',NULL,NULL),(2609,1590,'TE','8323314855',0,'2013-12-25 18:51:43',NULL,NULL),(26098,16806,'AP','8302795070',0,'2014-01-13 02:18:14',NULL,NULL),(26797,17238,'TE','9173857841',0,'2014-01-13 02:22:44',NULL,NULL),(34184,22421,'TE','3182378945',0,'2014-02-10 21:30:30',NULL,NULL),(33411,21891,'AP','6013196134',0,'2014-02-06 21:01:38',NULL,NULL),(81,48,'EM','Mputerka@gmail.com',0,'2013-12-25 17:16:19',NULL,NULL),(7660,4985,'TE','7409273443',0,'2013-12-25 22:46:51',NULL,NULL),(41944,27883,'EM','jennellebeining@hotmail.com',0,'2014-03-05 21:32:34',NULL,NULL),(30573,19837,'TE','5047333932',0,'2014-01-24 21:00:23',NULL,NULL),(30133,19516,'AP','4402279612',0,'2014-01-23 03:02:17',NULL,NULL),(29810,19288,'EM','cwill116@gmail.com',1,'2014-01-22 03:21:53',NULL,NULL),(20377,13125,'TE','9376212422',0,'2013-12-26 12:52:52',NULL,NULL),(23,15,'AP','5133171569',0,'2013-12-25 17:15:23',NULL,NULL),(190,113,'TE','9033939088',0,'2013-12-25 17:18:01',NULL,NULL),(34019,22313,'TE','6629349928',0,'2014-02-10 11:00:47',NULL,NULL),(12351,8086,'AP','9373020120',0,'2013-12-26 03:10:32',NULL,NULL),(33987,22295,'TE','6144777982',0,'2014-02-10 11:00:32',NULL,NULL),(33330,21833,'TE','9153510079',0,'2014-02-06 21:01:06',NULL,NULL),(32520,21259,'AP','5133413406',0,'2014-02-03 21:01:22',NULL,NULL),(30848,20051,'EM','ELPASO1984HP@GMAIL.COM',0,'2014-01-27 21:00:05',NULL,NULL),(3980,2525,'AP','3302657162',0,'2013-12-25 19:36:42',NULL,NULL),(21076,13554,'TE','5043454422',0,'2013-12-26 13:04:10',NULL,NULL),(25773,16608,'AP','2253024356',0,'2014-01-08 18:24:07',NULL,NULL),(30572,19836,'TE','4197821064',0,'2014-01-24 21:00:22',NULL,NULL),(43346,28791,'BN','2817365448',0,'2014-03-09 21:00:42',NULL,NULL),(7093,4630,'TE','6622300938',0,'2013-12-25 22:06:31',NULL,NULL),(5664,3639,'TE','6018599360',0,'2013-12-25 21:30:19',NULL,NULL),(11606,7548,'EM','mcallahanjr@hotmail.com',0,'2013-12-26 02:33:08',NULL,NULL),(41392,27497,'AP','3304647254',0,'2014-03-04 21:02:26',NULL,NULL),(39916,26415,'TE','8323537918',0,'2014-02-28 07:30:03',NULL,NULL),(35924,23637,'TE','5042373633',0,'2014-02-14 21:30:06',NULL,NULL),(4530,2880,'AP','7134193013',0,'2013-12-25 20:02:12',NULL,NULL),(34607,22693,'EM','ifontenot@hillcollege.edu',0,'2014-02-11 21:00:54',NULL,NULL),(34443,22594,'EM','spencersigns@yahoo.com',0,'2014-02-10 21:32:12',NULL,NULL),(31789,20749,'TE','4193600289',0,'2014-01-30 21:01:29',NULL,NULL),(25683,16557,'AP','5043028884',1,'2014-01-07 10:22:56',NULL,NULL),(26072,16792,'AP','3302726484',0,'2014-01-13 02:18:07',NULL,NULL),(29339,18957,'AP','9723529259',0,'2014-01-20 08:05:53',NULL,NULL),(43129,28670,'TE','2256107749',0,'2014-03-08 21:30:49',NULL,NULL),(242,146,'TE','3308153716',0,'2013-12-25 17:18:51',NULL,NULL),(6578,4246,'AP','7135405165',0,'2013-12-25 21:51:10',NULL,NULL),(31186,20310,'AP','2147894892',0,'2014-01-28 21:00:49',NULL,NULL),(30808,20031,'AP','5046170617',0,'2014-01-26 19:00:20',NULL,NULL),(29685,19183,'TE','9155002910',0,'2014-01-21 08:46:09',NULL,NULL),(1065,656,'AP','9373080893',0,'2013-12-25 18:01:45',NULL,NULL),(35460,23318,'AP','5133191037',0,'2014-02-13 22:00:23',NULL,NULL),(30035,19453,'EM','hussongtiffany@yahoo.com',0,'2014-01-23 03:01:53',NULL,NULL),(25496,16439,'AP','3308586636',0,'2014-01-07 04:05:03',NULL,NULL),(20207,13020,'TE','3306909844',0,'2013-12-26 12:50:02',NULL,NULL),(12381,8108,'EM','DVRICE_1999@YAHOO.COM',0,'2013-12-26 03:11:02',NULL,NULL),(8937,5850,'AP','9153554178',0,'2013-12-25 23:48:47',NULL,NULL),(6598,4262,'TE','3302731522',0,'2013-12-25 21:51:33',NULL,NULL),(43392,28819,'TE','4195757353',0,'2014-03-09 21:00:58',NULL,NULL),(43415,28831,'TE','4195732860',0,'2014-03-09 21:01:07',NULL,NULL),(8125,5321,'TE','5134320717',0,'2013-12-25 23:06:49',NULL,NULL),(20345,13107,'AP','3303233079',0,'2013-12-26 12:52:21',NULL,NULL),(40586,26937,'TE','9373861140',0,'2014-03-03 01:00:22',NULL,NULL),(39185,25917,'TE','6824655524',0,'2014-02-26 21:01:18',NULL,NULL),(37304,24547,'TE','3307922762',0,'2014-02-20 04:03:52',NULL,NULL),(23601,15239,'TE','4197491808',0,'2014-01-01 12:08:32',NULL,NULL),(26118,16818,'TE','8172436598',0,'2014-01-13 02:18:20',NULL,NULL),(27295,17575,'TE','3306227137',0,'2014-01-14 01:32:04',NULL,NULL),(29329,18952,'AP','3612440199',0,'2014-01-20 08:05:50',NULL,NULL),(32941,21560,'TE','6462666585',0,'2014-02-05 21:30:18',NULL,NULL),(35840,23567,'TE','6628166639',0,'2014-02-13 22:02:49',NULL,NULL),(1187,725,'TE','2819170324',0,'2013-12-25 18:03:37',NULL,NULL),(42443,28188,'AP','4196815848',0,'2014-03-06 21:02:59',NULL,NULL),(37710,24863,'AP','5129342895',0,'2014-02-20 05:31:01',NULL,NULL),(11965,7796,'EM','Chssoftware@prodigy.net',0,'2013-12-26 03:03:33',NULL,NULL),(36791,24224,'TE','9722476657',0,'2014-02-16 19:00:30',NULL,NULL),(4844,3099,'EM','BECKY.KERSEY@COLDWELLBANKER.COM',0,'2013-12-25 20:20:14',NULL,NULL),(29167,18845,'EM','zachkissell@yahoo.com',0,'2014-01-17 03:36:14',NULL,NULL),(6189,3988,'TE','9377807349',0,'2013-12-25 21:39:01',NULL,NULL),(20854,13408,'TE','6782302344',0,'2013-12-26 13:00:30',NULL,NULL),(27205,17519,'TE','3304416466',0,'2014-01-13 03:01:35',NULL,NULL),(23846,15384,'EM','iluvmyxb@yahoo.com',1,'2014-01-02 04:25:32',NULL,NULL),(786,491,'TE','3187891606',0,'2013-12-25 17:48:25',NULL,NULL),(12216,7981,'AP','2162729367',0,'2013-12-26 03:07:59',NULL,NULL),(9319,6101,'AP','5134883944',0,'2013-12-26 00:15:13',NULL,NULL),(9689,6347,'AP','2164082985',0,'2013-12-26 00:46:56',NULL,NULL),(20668,13292,'TE','8179883653',0,'2013-12-26 12:57:30',NULL,NULL),(26574,17095,'AP','9566079550',0,'2014-01-13 02:21:29',NULL,NULL),(40895,27173,'TE','9362440693',0,'2014-03-03 21:31:06',NULL,NULL),(39563,26176,'TE','5133933226',0,'2014-02-28 06:30:38',NULL,NULL),(38140,25174,'AP','2168544826',0,'2014-02-21 22:00:30',NULL,NULL),(37988,25060,'EM','kissinfrogsagain@yahoo.com',0,'2014-02-20 22:01:23',NULL,NULL),(33743,22141,'TE','3302733552',0,'2014-02-08 19:00:49',NULL,NULL),(36926,24318,'TE','2816422348',0,'2014-02-18 22:00:07',NULL,NULL),(35061,23022,'AP','9154722305',0,'2014-02-12 21:30:31',NULL,NULL),(32325,21117,'AP','8324125732',0,'2014-02-03 21:00:11',NULL,NULL),(22351,14413,'AP','8322628076',0,'2013-12-28 03:31:31',NULL,NULL),(21659,13937,'EM','jpmaurer@embarqmail.com',0,'2013-12-26 13:14:41',NULL,NULL),(665,416,'TE','3307661185',0,'2013-12-25 17:46:30',NULL,NULL),(4345,2773,'EM','srowe83@yahoo.com',0,'2013-12-25 19:49:35',NULL,NULL),(42578,28332,'AP','2147973992',0,'2014-03-07 21:30:11',NULL,NULL),(2373,1440,'EM','randyphipps@hughes.net',0,'2013-12-25 18:47:51',NULL,NULL),(13841,9025,'TE','4402859716',0,'2013-12-26 04:05:26',NULL,NULL),(38053,25115,'TE','6157130126',0,'2014-02-21 21:30:18',NULL,NULL),(37275,24529,'TE','9156338180',0,'2014-02-20 04:00:07',NULL,NULL),(33649,22070,'TE','8172711441',0,'2014-02-08 19:00:14',NULL,NULL),(33611,22041,'TE','6623367408',0,'2014-02-07 19:01:09',NULL,NULL),(24317,15707,'EM','MindyRutkowski@yahoo.com',1,'2014-01-02 04:35:58',NULL,NULL),(31069,20212,'EM','mre1jamese122801@aol.com',0,'2014-01-27 21:01:39',NULL,NULL),(41625,27671,'EM','whitie052@sbcglobal.net',0,'2014-03-05 21:30:34',NULL,NULL),(1359,829,'AP','3302211979',0,'2013-12-25 18:06:18',NULL,NULL),(40697,27032,'EM','Chad_fancher2003@yahoo.com',0,'2014-03-03 21:00:17',NULL,NULL),(2056,1272,'EM','bgclfoods@hotmail.com',0,'2013-12-25 18:30:18',NULL,NULL),(2561,1564,'TE','2145384089',0,'2013-12-25 18:50:59',NULL,NULL),(40088,26585,'EM','ginamcgraner@yahoo.com',0,'2014-02-28 21:30:33',NULL,NULL),(39244,25962,'TE','9372545987',0,'2014-02-26 21:01:42',NULL,NULL),(33977,22288,'EM','chefmanusa@hotmail.com',0,'2014-02-10 11:00:28',NULL,NULL),(8789,5757,'EM','kassady618@gmail.com',0,'2013-12-25 23:46:25',NULL,NULL),(7029,4589,'AP','3307146407',0,'2013-12-25 22:05:26',NULL,NULL),(36686,24154,'EM','aldrum@nktelco.net',0,'2014-02-15 22:01:59',NULL,NULL),(30304,19633,'TE','2166959926',0,'2014-01-23 21:00:10',NULL,NULL),(23213,14957,'EM','STARGEAR@YAHOO.COM',0,'2014-01-01 12:00:25',NULL,NULL),(22957,14809,'TE','3373261668',1,'2013-12-29 11:14:00',NULL,NULL),(21805,14049,'TE','4195363590',0,'2013-12-27 02:00:15',NULL,NULL),(38692,25570,'AP','5136336897',0,'2014-02-26 08:00:30',NULL,NULL),(35979,23671,'EM','bbdevitt@gmail.com',0,'2014-02-14 21:30:25',NULL,NULL),(14133,9256,'AP','9567751665',0,'2013-12-26 04:15:09',NULL,NULL),(31111,20255,'AP','2169267428',0,'2014-01-28 21:00:16',NULL,NULL),(24820,16011,'TE','5043436583',0,'2014-01-04 02:01:50',NULL,NULL),(11395,7418,'TE','9375161430',0,'2013-12-26 02:16:56',NULL,NULL),(6211,4000,'EM','Jesse.Vroman@acreedaily.com',0,'2013-12-25 21:45:11',NULL,NULL),(39387,26047,'AP','3303276618',0,'2014-02-26 21:02:31',NULL,NULL),(1304,795,'TE','8177767630',0,'2013-12-25 18:05:24',NULL,NULL),(11331,7381,'TE','5132534286',0,'2013-12-26 02:15:56',NULL,NULL),(37907,25004,'TE','3302965782',0,'2014-02-20 22:00:48',NULL,NULL),(36789,24222,'AP','9794920567',0,'2014-02-16 19:00:29',NULL,NULL),(22807,14705,'AP','7034091450',1,'2013-12-29 11:09:12',NULL,NULL),(24025,15513,'TE','4405703261',1,'2014-01-02 04:30:05',NULL,NULL),(24462,15789,'AP','5043437941',0,'2014-01-03 02:02:26',NULL,NULL),(26331,16950,'TE','6628226149',0,'2014-01-13 02:20:00',NULL,NULL),(28707,18524,'EM','Kristalheaton@gmail.com',0,'2014-01-16 08:46:40',NULL,NULL),(36437,23995,'TE','5129938855',0,'2014-02-15 22:00:29',NULL,NULL),(34252,22468,'AP','8603152414',0,'2014-02-10 21:30:57',NULL,NULL),(298,184,'TE','3306991784',0,'2013-12-25 17:19:46',NULL,NULL),(1016,626,'TE','3303070337',0,'2013-12-25 18:00:59',NULL,NULL),(9023,5920,'AP','2145461277',0,'2013-12-25 23:50:16',NULL,NULL),(7552,4918,'TE','3304022263',0,'2013-12-25 22:45:05',NULL,NULL),(7910,5154,'TE','5136480034',0,'2013-12-25 23:02:53',NULL,NULL),(26802,17240,'TE','5672424394',0,'2014-01-13 02:22:45',NULL,NULL),(27955,18017,'AP','5138827183',0,'2014-01-15 02:07:04',NULL,NULL),(29619,19135,'AP','9158385289',0,'2014-01-21 08:45:27',NULL,NULL),(32429,21191,'TE','6015284221',0,'2014-02-03 21:00:48',NULL,NULL),(33179,21729,'TE','3619476339',0,'2014-02-06 21:00:08',NULL,NULL),(34850,22851,'AP','4193055513',0,'2014-02-11 21:02:21',NULL,NULL),(34942,22934,'AP','9376706451',0,'2014-02-11 21:30:13',NULL,NULL),(35042,23014,'EM','kathiesharon@gmail.com',0,'2014-02-12 21:30:25',NULL,NULL),(36298,23899,'TE','9379023187',0,'2014-02-14 21:32:23',NULL,NULL),(37167,24465,'TE','3305924347',0,'2014-02-18 22:01:35',NULL,NULL),(38179,25198,'TE','9855156067',0,'2014-02-21 22:00:44',NULL,NULL),(39029,25810,'TE','5132927782',0,'2014-02-26 21:00:21',NULL,NULL),(39944,26439,'TE','4196061510',0,'2014-02-28 07:30:19',NULL,NULL),(40538,26905,'TE','2254052008',0,'2014-03-03 01:00:09',NULL,NULL),(44002,29194,'EM','tomandpaula13@gmail.com',0,'2014-03-10 21:30:07',NULL,NULL),(8819,5775,'EM','Eckk1@hotmail.com',0,'2013-12-25 23:46:54',NULL,NULL),(7117,4647,'AP','6019548849',0,'2013-12-25 22:06:57',NULL,NULL),(6791,4404,'TE','4197222333',0,'2013-12-25 22:01:15',NULL,NULL),(11665,7591,'AP','5133681921',0,'2013-12-26 02:45:09',NULL,NULL),(10058,6577,'TE','5136167339',0,'2013-12-26 00:52:52',NULL,NULL),(26218,16876,'TE','3258534032',0,'2014-01-13 02:19:18',NULL,NULL),(31108,20253,'TE','3048108745',0,'2014-01-28 21:00:15',NULL,NULL),(35089,23047,'TE','5124966276',0,'2014-02-12 21:30:43',NULL,NULL),(37723,24876,'TE','5133330204',0,'2014-02-20 05:34:40',NULL,NULL),(42355,28131,'AP','3305501885',0,'2014-03-06 21:02:25',NULL,NULL),(39613,26201,'EM','sbaker2011@yahoo.com',0,'2014-02-28 06:30:49',NULL,NULL),(1047,645,'TE','9376846710',0,'2013-12-25 18:01:27',NULL,NULL),(7348,4776,'TE','9372169551',0,'2013-12-25 22:15:59',NULL,NULL),(5977,3839,'EM','smithrd.esq@gmail.com',0,'2013-12-25 21:35:21',NULL,NULL),(36139,23783,'AP','3306878875',0,'2014-02-14 21:31:21',NULL,NULL),(1291,785,'EM','scottmleavell@gmail.com',0,'2013-12-25 18:05:10',NULL,NULL),(32049,20921,'AP','4408645261',0,'2014-01-31 21:01:33',NULL,NULL),(2753,1669,'AP','2145541751',0,'2013-12-25 18:53:51',NULL,NULL),(29616,19134,'TE','6825519801',0,'2014-01-21 08:45:26',NULL,NULL),(26411,16997,'AP','3308197283',0,'2014-01-13 02:20:28',NULL,NULL),(21691,13967,'TE','9374676103',0,'2013-12-26 13:15:17',NULL,NULL),(6857,4447,'AP','6149479475',0,'2013-12-25 22:02:18',NULL,NULL),(20929,13462,'TE','9042197354',0,'2013-12-26 13:01:46',NULL,NULL),(42592,28338,'AP','9728163897',0,'2014-03-07 21:30:15',NULL,NULL),(3715,2356,'TE','9366525155',0,'2013-12-25 19:32:23',NULL,NULL),(25971,16728,'TE','3304171459',0,'2014-01-08 18:24:49',NULL,NULL),(14820,9703,'AP','4193057573',0,'2013-12-26 04:40:01',NULL,NULL),(10675,6936,'TE','9375694051',0,'2013-12-26 01:46:40',NULL,NULL),(8450,5559,'AP','9373043448',0,'2013-12-25 23:16:24',NULL,NULL),(41556,27630,'TE','3308640737',0,'2014-03-05 21:30:10',NULL,NULL),(1265,769,'TE','9563289727',0,'2013-12-25 18:04:46',NULL,NULL),(37314,24555,'TE','3308398021',0,'2014-02-20 04:05:09',NULL,NULL),(11281,7353,'AP','9039188219',0,'2013-12-26 02:15:11',NULL,NULL),(14216,9302,'TE','4196454278',0,'2013-12-26 04:16:26',NULL,NULL),(34152,22392,'AP','3309060413',0,'2014-02-10 21:30:16',NULL,NULL),(23985,15483,'EM','jeffhroy@gmail.com',1,'2014-01-02 04:29:14',NULL,NULL),(25811,16633,'EM','themeeks06@gmail.com',0,'2014-01-08 18:24:15',NULL,NULL),(6684,4339,'TE','9372882656',0,'2013-12-25 21:53:15',NULL,NULL),(36046,23710,'AP','6145962960',0,'2014-02-14 21:30:46',NULL,NULL),(22350,14413,'TE','2813030044',0,'2013-12-28 03:31:31',NULL,NULL),(10901,7084,'TE','7172090776',0,'2013-12-26 01:50:22',NULL,NULL),(12404,8123,'AP','2167805601',0,'2013-12-26 03:15:19',NULL,NULL),(42498,28263,'TE','6627399944',0,'2014-03-07 21:00:18',NULL,NULL),(44012,29209,'TE','9033533585',0,'2014-03-10 21:30:15',NULL,NULL),(40092,26588,'AP','4402313214',0,'2014-02-28 21:30:35',NULL,NULL),(7159,4670,'EM','drmurdoch@camtel.net',0,'2013-12-25 22:07:35',NULL,NULL),(2570,1568,'EM','osiel_cantu@yahoo.com',0,'2013-12-25 18:51:07',NULL,NULL),(3106,1938,'AP','3302849180',0,'2013-12-25 19:00:35',NULL,NULL),(10091,6593,'EM','pandco@earthlink.net',0,'2013-12-26 00:53:20',NULL,NULL),(9903,6482,'TE','4195540494',0,'2013-12-26 00:50:21',NULL,NULL),(33992,22297,'TE','5134444750',0,'2014-02-10 11:00:34',NULL,NULL),(31535,20549,'AP','5134100394',0,'2014-01-29 21:01:40',NULL,NULL),(25076,16166,'EM','Shannon0532@yahoo.com',0,'2014-01-05 00:00:06',NULL,NULL),(26243,16889,'EM','rosanalopez24@yahoo.com',0,'2014-01-13 02:19:26',NULL,NULL),(27985,18039,'AP','4192608785',0,'2014-01-15 02:07:12',NULL,NULL),(28661,18485,'EM','brent.e.ransom@gmail.com',0,'2014-01-16 08:46:23',NULL,NULL),(31221,20332,'EM','tchung800@sbcglobal.net',0,'2014-01-28 21:01:03',NULL,NULL),(41252,27410,'TE','4403172468',0,'2014-03-04 21:01:35',NULL,NULL),(1691,1039,'EM','rgvusar@me.com',0,'2013-12-25 18:15:43',NULL,NULL),(28897,18655,'AP','9033735721',0,'2014-01-17 03:35:12',NULL,NULL),(10162,6642,'EM','vallkyria99@gmail.com',0,'2013-12-26 01:00:21',NULL,NULL),(9817,6423,'TE','9853506090',0,'2013-12-26 00:48:58',NULL,NULL),(7006,4576,'AP','9363328049',0,'2013-12-25 22:05:06',NULL,NULL),(13784,8982,'EM','danac210@gmail.com',0,'2013-12-26 04:04:23',NULL,NULL),(26379,16979,'AP','6013319421',0,'2014-01-13 02:20:17',NULL,NULL),(26197,16862,'TE','8705577123',0,'2014-01-13 02:19:11',NULL,NULL),(24660,15899,'AP','4192356488',0,'2014-01-03 02:06:01',NULL,NULL),(36331,23928,'TE','3303522477',0,'2014-02-14 22:00:10',NULL,NULL),(3525,2204,'EM','melvinphipps335@yahoo.com',0,'2013-12-25 19:20:07',NULL,NULL),(35158,23092,'TE','2163017126',0,'2014-02-12 21:31:08',NULL,NULL),(11302,7367,'TE','5049821701',0,'2013-12-26 02:15:33',NULL,NULL),(34221,22445,'TE','8326290393',0,'2014-02-10 21:30:44',NULL,NULL),(8364,5497,'TE','4198368587',0,'2013-12-25 23:11:13',NULL,NULL),(4735,3033,'TE','5673163432',0,'2013-12-25 20:18:27',NULL,NULL),(30210,19571,'TE','3182100238',0,'2014-01-23 03:02:37',NULL,NULL),(25235,16272,'TE','9378251431',0,'2014-01-07 04:00:19',NULL,NULL),(27362,17615,'TE','8322510962',0,'2014-01-14 01:32:24',NULL,NULL),(39049,25825,'TE','7405811185',0,'2014-02-26 21:00:28',NULL,NULL),(31227,20338,'AP','3185580273',0,'2014-01-28 21:01:06',NULL,NULL),(21773,14028,'AP','2162725627',0,'2013-12-26 13:16:48',NULL,NULL),(6051,3888,'TE','3307154809',0,'2013-12-25 21:36:37',NULL,NULL),(27762,17899,'AP','4403155615',0,'2014-01-15 02:06:23',NULL,NULL),(10785,7010,'AP','2259392510',0,'2013-12-26 01:48:31',NULL,NULL),(10252,6700,'TE','7025962921',0,'2013-12-26 01:01:54',NULL,NULL),(2925,1797,'TE','9372914088',0,'2013-12-25 18:56:41',NULL,NULL),(26766,17218,'AP','6019548042',0,'2014-01-13 02:22:33',NULL,NULL),(22272,14355,'AP','6145567014',0,'2013-12-28 03:30:08',NULL,NULL),(4552,2896,'EM','fallstoolrental@yahoo.com',0,'2013-12-25 20:15:16',NULL,NULL),(3367,2115,'TE','5132507305',0,'2013-12-25 19:17:34',NULL,NULL),(35613,23420,'TE','7139922952',0,'2014-02-13 22:01:22',NULL,NULL),(34662,22727,'AP','5047151862',0,'2014-02-11 21:01:13',NULL,NULL),(4055,2587,'TE','9373824187',0,'2013-12-25 19:38:12',NULL,NULL),(33045,21648,'AP','5044957162',0,'2014-02-05 21:30:49',NULL,NULL),(22015,14178,'AP','9033533585',0,'2013-12-27 02:03:39',NULL,NULL),(32364,21146,'EM','angelhavensl@yahoo.com',0,'2014-02-03 21:00:25',NULL,NULL),(23989,15485,'TE','3306272528',1,'2014-01-02 04:29:18',NULL,NULL),(26796,17237,'EM','jimstahl@sbcglobal.net',0,'2014-01-13 02:22:43',NULL,NULL),(5843,3749,'EM','timothyandrew@gmail.com',0,'2013-12-25 21:33:07',NULL,NULL),(7889,5141,'TE','4407256995',0,'2013-12-25 23:02:33',NULL,NULL),(10229,6686,'TE','3176951146',0,'2013-12-26 01:01:31',NULL,NULL),(10531,6858,'TE','7404054067',0,'2013-12-26 01:31:36',NULL,NULL),(34828,22842,'AP','4192047312',0,'2014-02-11 21:02:14',NULL,NULL),(31416,20480,'TE','3306664274',0,'2014-01-29 21:01:01',NULL,NULL),(28024,18060,'EM','williams.am@hotmail.com',0,'2014-01-15 02:07:20',NULL,NULL),(41722,27742,'AP','4192612654',0,'2014-03-05 21:31:10',NULL,NULL),(34083,22342,'AP','2164069326',0,'2014-02-10 11:01:09',NULL,NULL),(10852,7044,'AP','9152176505',0,'2013-12-26 01:49:30',NULL,NULL),(4253,2721,'EM','rica@nolaunderwritersgroup.com',0,'2013-12-25 19:48:12',NULL,NULL),(33142,21708,'EM','bshadowlong@hotmail.com',0,'2014-02-05 21:31:14',NULL,NULL),(14816,9701,'TE','5138513310',0,'2013-12-26 04:39:58',NULL,NULL),(32855,21502,'TE','5135751863',0,'2014-02-04 21:01:53',NULL,NULL),(22012,14176,'AP','3614296834',0,'2013-12-27 02:03:36',NULL,NULL),(22054,14203,'EM','JUDIODAY1@GMAIL.COM',0,'2013-12-27 02:04:18',NULL,NULL),(27254,17547,'EM','eenterprise51@yahoo.com',0,'2014-01-13 03:01:52',NULL,NULL),(28253,18219,'AP','4196937280',0,'2014-01-15 02:08:13',NULL,NULL),(42243,28060,'AP','5132588031',0,'2014-03-06 21:01:43',NULL,NULL),(43688,29000,'AP','5672074636',0,'2014-03-10 21:01:18',NULL,NULL),(41406,27510,'TE','4197046493',0,'2014-03-04 21:02:32',NULL,NULL),(41136,27322,'AP','4093388753',0,'2014-03-04 21:00:47',NULL,NULL),(28970,18699,'TE','2259075924',0,'2014-01-17 03:35:27',NULL,NULL),(20901,13439,'TE','4405418563',0,'2013-12-26 13:01:15',NULL,NULL),(8434,5550,'TE','2546245024',0,'2013-12-25 23:16:07',NULL,NULL),(42220,28048,'AP','6018135832',0,'2014-03-06 21:01:35',NULL,NULL),(41025,27257,'TE','5672144115',0,'2014-03-03 21:31:58',NULL,NULL),(13844,9027,'AP','3306202018',0,'2013-12-26 04:05:28',NULL,NULL),(3574,2239,'TE','4199085398',0,'2013-12-25 19:20:58',NULL,NULL),(8045,5264,'EM','tyoungbl@gmail.com',0,'2013-12-25 23:05:26',NULL,NULL),(10960,7124,'TE','6623641124',0,'2013-12-26 01:51:25',NULL,NULL),(10645,6922,'AP','3305106426',0,'2013-12-26 01:46:15',NULL,NULL),(32217,21040,'AP','5133027992',0,'2014-02-01 19:00:50',NULL,NULL),(21285,13675,'EM','nancylignoski@hotmail.com',0,'2013-12-26 13:08:02',NULL,NULL),(31168,20298,'AP','3377062524',0,'2014-01-28 21:00:41',NULL,NULL),(27415,17658,'AP','9375157480',0,'2014-01-14 01:32:43',NULL,NULL),(28556,18412,'EM','emdbc@hotmail.com',0,'2014-01-16 08:45:48',NULL,NULL),(29601,19126,'AP','6145167497',0,'2014-01-21 08:45:20',NULL,NULL),(42831,28488,'TE','4193887729',0,'2014-03-07 21:31:40',NULL,NULL),(42942,28550,'EM','KEN29552@GAMIL.COM',0,'2014-03-07 21:32:20',NULL,NULL),(769,480,'AP','3375785010',0,'2013-12-25 17:48:08',NULL,NULL),(41689,27722,'BN','7134463607',0,'2014-03-05 21:30:59',NULL,NULL),(40407,26822,'TE','9379038084',0,'2014-03-01 21:00:35',NULL,NULL),(12245,8006,'EM','rpatel0954@yahoo.com',0,'2013-12-26 03:08:31',NULL,NULL),(39446,26088,'AP','5049522004',0,'2014-02-28 06:30:07',NULL,NULL),(34842,22848,'AP','4192037391',0,'2014-02-11 21:02:19',NULL,NULL),(10664,6930,'EM','lcolagross@aol.com',0,'2013-12-26 01:46:31',NULL,NULL),(25742,16590,'TE','5042652689',0,'2014-01-08 18:24:00',NULL,NULL),(9053,5937,'EM','dgturner3@yahoo.com',0,'2013-12-25 23:50:42',NULL,NULL),(6449,4165,'AP','3309048435',0,'2013-12-25 21:49:06',NULL,NULL),(4661,2978,'TE','9376043293',0,'2013-12-25 20:17:11',NULL,NULL),(24886,16045,'TE','9152278045',0,'2014-01-04 02:03:00',NULL,NULL),(14761,9654,'TE','5673711389',0,'2013-12-26 04:38:51',NULL,NULL),(559,347,'TE','8308950675',0,'2013-12-25 17:32:09',NULL,NULL),(14463,9448,'TE','4192175622',0,'2013-12-26 04:33:53',NULL,NULL),(33389,21877,'AP','2253150448',0,'2014-02-06 21:01:29',NULL,NULL),(33325,21828,'EM','jeremy.warren71@gmail.com',0,'2014-02-06 21:01:03',NULL,NULL),(6079,3913,'AP','8328659160',0,'2013-12-25 21:37:10',NULL,NULL),(10611,6904,'AP','5044521882',0,'2013-12-26 01:45:43',NULL,NULL),(29556,19100,'AP','3183540035',0,'2014-01-21 08:44:38',NULL,NULL),(10413,6791,'TE','8176839625',0,'2013-12-26 01:17:04',NULL,NULL),(3598,2267,'TE','4193048953',0,'2013-12-25 19:30:19',NULL,NULL),(42174,28015,'TE','7405061697',0,'2014-03-06 21:01:18',NULL,NULL),(10,6,'AP','9377637297',0,'2013-12-25 17:15:11',NULL,NULL),(41003,27243,'TE','5138760569',0,'2014-03-03 21:31:48',NULL,NULL),(37543,24717,'EM','k_tweet99@hotmail.com',0,'2014-02-20 04:37:35',NULL,NULL),(7978,5205,'TE','6147722718',0,'2013-12-25 23:04:09',NULL,NULL),(34272,22486,'TE','7408873728',0,'2014-02-10 21:31:05',NULL,NULL),(6229,4014,'AP','5133744742',0,'2013-12-25 21:45:31',NULL,NULL),(24367,15734,'AP','5138898485',0,'2014-01-03 02:00:38',NULL,NULL),(35568,23390,'EM','littleindianstudio@gmail.com',0,'2014-02-13 22:01:05',NULL,NULL),(14470,9451,'AP','6145897262',0,'2013-12-26 04:33:59',NULL,NULL),(2257,1384,'TE','9859745744',0,'2013-12-25 18:46:10',NULL,NULL),(10475,6824,'AP','3304142197',0,'2013-12-26 01:30:38',NULL,NULL),(21412,13766,'TE','7692040467',0,'2013-12-26 13:10:23',NULL,NULL),(30961,20140,'TE','4194642118',0,'2014-01-27 21:00:57',NULL,NULL),(43503,28885,'EM','carlamtzp@gmail.com',0,'2014-03-10 21:00:11',NULL,NULL),(6932,4516,'EM','joannacolwill@verizon.net',0,'2013-12-25 22:03:43',NULL,NULL),(3156,1972,'TE','8176816774',0,'2013-12-25 19:01:30',NULL,NULL),(5083,3262,'AP','2259552652',0,'2013-12-25 20:46:56',NULL,NULL),(42143,27999,'TE','5132898753',0,'2014-03-06 21:01:08',NULL,NULL),(43416,28831,'AP','4195732860',0,'2014-03-09 21:01:07',NULL,NULL),(40015,26513,'TE','4196010097',0,'2014-02-28 21:00:20',NULL,NULL),(617,380,'TE','8063520829',0,'2013-12-25 17:45:41',NULL,NULL),(20844,13400,'AP','2164966565',0,'2013-12-26 13:00:20',NULL,NULL),(2407,1467,'TE','3304779158',0,'2013-12-25 18:48:28',NULL,NULL),(5413,3466,'EM','BONNIEMOM@AMERITECH.NET',0,'2013-12-25 21:19:50',NULL,NULL),(4503,2865,'TE','6149409656',0,'2013-12-25 20:01:44',NULL,NULL),(42377,28143,'AP','4194100452',0,'2014-03-06 21:02:32',NULL,NULL),(7002,4571,'AP','4699648288',0,'2013-12-25 22:04:59',NULL,NULL),(41750,27763,'AP','2252402990',0,'2014-03-05 21:31:21',NULL,NULL),(9498,6214,'AP','7133634862',0,'2013-12-26 00:30:59',NULL,NULL),(34367,22540,'EM','laurajennings10@yahoo.com',0,'2014-02-10 21:31:39',NULL,NULL),(32086,20956,'TE','2545419663',0,'2014-02-01 19:00:07',NULL,NULL),(21799,14045,'TE','3309409084',0,'2013-12-27 02:00:09',NULL,NULL),(7981,5206,'TE','3306883392',0,'2013-12-25 23:04:11',NULL,NULL),(1101,677,'TE','2162407926',0,'2013-12-25 18:02:17',NULL,NULL),(1155,709,'TE','3376526372',0,'2013-12-25 18:03:09',NULL,NULL),(38222,25228,'AP','4196516886',0,'2014-02-21 22:01:01',NULL,NULL),(33823,22208,'TE','2707913064',0,'2014-02-09 19:00:18',NULL,NULL),(31886,20812,'AP','7329964777',0,'2014-01-31 21:00:29',NULL,NULL),(4752,3043,'TE','3308081808',0,'2013-12-25 20:18:42',NULL,NULL),(2826,1708,'AP','5133902274',0,'2013-12-25 18:54:57',NULL,NULL),(23135,14914,'EM','loganbeloit@yahoo.com',0,'2013-12-30 00:01:31',NULL,NULL),(26290,16922,'EM','gfherbert1988@gmail.com',0,'2014-01-13 02:19:44',NULL,NULL),(39548,26164,'TE','3306221743',0,'2014-02-28 06:30:33',NULL,NULL),(38931,25735,'EM','COIX66@GMAIL.COM',0,'2014-02-26 09:30:38',NULL,NULL),(38893,25709,'TE','8173430692',0,'2014-02-26 09:30:22',NULL,NULL),(12233,7996,'TE','2167327397',0,'2013-12-26 03:08:17',NULL,NULL),(32521,21260,'TE','5133413406',0,'2014-02-03 21:01:22',NULL,NULL),(32015,20900,'EM','jziegler4@gmail.com',0,'2014-01-31 21:01:20',NULL,NULL),(10577,6884,'EM','shantiskidmore@yahoo.com',0,'2013-12-26 01:45:10',NULL,NULL),(29077,18781,'AP','4193049640',0,'2014-01-17 03:35:52',NULL,NULL),(4512,2869,'AP','9157803474',0,'2013-12-25 20:01:54',NULL,NULL),(1750,1078,'EM','lizkusak@gmail.com',0,'2013-12-25 18:16:42',NULL,NULL),(21731,14001,'AP','3309788351',0,'2013-12-26 13:16:03',NULL,NULL),(22299,14372,'AP','5137040843',0,'2013-12-28 03:30:34',NULL,NULL),(43239,28732,'TE','2252413724',0,'2014-03-09 21:00:04',NULL,NULL),(7457,4855,'AP','9375805289',0,'2013-12-25 22:30:29',NULL,NULL),(20409,13143,'TE','4404988234',0,'2013-12-26 12:53:22',NULL,NULL),(39080,25848,'AP','3308010557',0,'2014-02-26 21:00:39',NULL,NULL),(36172,23808,'TE','3308824389',0,'2014-02-14 21:31:33',NULL,NULL),(26119,16818,'AP','8172436598',0,'2014-01-13 02:18:20',NULL,NULL),(29940,19376,'TE','6019273282',1,'2014-01-22 03:22:39',NULL,NULL),(29469,19051,'TE','3183729060',0,'2014-01-20 08:06:44',NULL,NULL),(42613,28349,'BN','3252453395',0,'2014-03-07 21:30:22',NULL,NULL),(37224,24496,'AP','3615220586',0,'2014-02-20 03:47:08',NULL,NULL),(10945,7113,'EM','graceandlight@gmail.com',0,'2013-12-26 01:51:07',NULL,NULL),(20860,13413,'TE','5132533702',0,'2013-12-26 13:00:36',NULL,NULL),(34454,22603,'EM','nicoleetaylor@hotmail.com',0,'2014-02-10 21:32:16',NULL,NULL),(31191,20312,'AP','2147894892',0,'2014-01-28 21:00:50',NULL,NULL),(23670,15283,'AP','6015660027',1,'2014-01-02 04:22:13',NULL,NULL),(42337,28115,'TE','3303028149',0,'2014-03-06 21:02:17',NULL,NULL),(38693,25570,'EM','limitlessskyes@Gmail.com',0,'2014-02-26 08:00:30',NULL,NULL),(31195,20316,'TE','8322266850',0,'2014-01-28 21:00:52',NULL,NULL),(27154,17484,'AP','8325072089',0,'2014-01-13 03:01:15',NULL,NULL),(11089,7204,'TE','5136207387',0,'2013-12-26 02:00:44',NULL,NULL),(21341,13715,'TE','7046826771',0,'2013-12-26 13:09:03',NULL,NULL),(6185,3985,'AP','5134870784',0,'2013-12-25 21:38:57',NULL,NULL),(41937,27880,'AP','4197717934',0,'2014-03-05 21:32:32',NULL,NULL),(10774,7003,'AP','9037694310',0,'2013-12-26 01:48:20',NULL,NULL),(41190,27355,'EM','cmorris219@roadwarner.com',0,'2014-03-04 21:01:08',NULL,NULL),(5381,3443,'EM','stephens0201@gmail.com',0,'2013-12-25 21:19:19',NULL,NULL),(38939,25743,'EM','papaberthughes@gmail.com',0,'2014-02-26 09:30:42',NULL,NULL),(26684,17164,'AP','5042764541',0,'2014-01-13 02:22:04',NULL,NULL),(37686,24847,'EM','wandas1128@aol.com',0,'2014-02-20 04:54:56',NULL,NULL),(28752,18555,'AP','4199663073',0,'2014-01-16 08:46:56',NULL,NULL),(31927,20841,'AP','4237873709',0,'2014-01-31 21:00:46',NULL,NULL),(904,560,'TE','5135057962',0,'2013-12-25 17:50:16',NULL,NULL),(925,570,'TE','5134906903',0,'2013-12-25 17:50:35',NULL,NULL),(40473,26864,'TE','2103247790',0,'2014-03-01 21:00:59',NULL,NULL),(1007,621,'TE','9373615915',0,'2013-12-25 18:00:50',NULL,NULL),(12385,8111,'EM','alanraycole@yahoo.com',0,'2013-12-26 03:11:07',NULL,NULL),(11354,7396,'EM','cdhoff@sbcglobal.net',0,'2013-12-26 02:16:19',NULL,NULL),(32202,21033,'AP','9376580953',0,'2014-02-01 19:00:46',NULL,NULL),(29888,19340,'AP','4695856631',1,'2014-01-22 03:22:21',NULL,NULL),(21043,13538,'TE','3183894783',0,'2013-12-26 13:03:41',NULL,NULL),(21312,13690,'EM','Caleb.Eckel@gmail.com',0,'2013-12-26 13:08:27',NULL,NULL),(28820,18600,'EM','angelariley92@yahoo.com',0,'2014-01-16 08:47:19',NULL,NULL),(28478,18353,'AP','4192600572',0,'2014-01-16 08:45:22',NULL,NULL),(24162,15614,'AP','6018508765',1,'2014-01-02 04:32:56',NULL,NULL),(23791,15344,'TE','3308586636',1,'2014-01-02 04:24:20',NULL,NULL),(41438,27528,'BN','4193410259',0,'2014-03-04 21:02:45',NULL,NULL),(7744,5053,'AP','9406311450',0,'2013-12-25 23:00:15',NULL,NULL),(917,565,'EM','starfish1292@yahoo.com',0,'2013-12-25 17:50:28',NULL,NULL),(9921,6494,'TE','3307255788',0,'2013-12-26 00:50:40',NULL,NULL),(9752,6376,'EM','WAHOO755@AOL.COM',0,'2013-12-26 00:47:49',NULL,NULL),(9670,6332,'TE','5134624316',0,'2013-12-26 00:46:38',NULL,NULL),(37385,24619,'AP','6012148221',0,'2014-02-20 04:15:54',NULL,NULL),(21858,14081,'TE','5136930866',0,'2013-12-27 02:01:06',NULL,NULL),(36579,24076,'AP','3308078321',0,'2014-02-15 22:01:20',NULL,NULL),(32529,21264,'AP','4403194352',0,'2014-02-03 21:01:26',NULL,NULL),(3120,1944,'EM','tapat@fuse.net',0,'2013-12-25 19:00:47',NULL,NULL),(5909,3791,'TE','4404978103',0,'2013-12-25 21:34:14',NULL,NULL),(22960,14810,'AP','2252683527',1,'2013-12-29 11:14:02',NULL,NULL),(32538,21273,'EM','nloving@sssnet.com',0,'2014-02-03 21:01:32',NULL,NULL),(24861,16032,'TE','5043170816',0,'2014-01-04 02:02:32',NULL,NULL),(23996,15489,'TE','5134841214',1,'2014-01-02 04:29:26',NULL,NULL),(43064,28629,'AP','8304219520',0,'2014-03-08 21:30:26',NULL,NULL),(5973,3836,'TE','5042650911',0,'2013-12-25 21:35:17',NULL,NULL),(1657,1016,'AP','6012703270',0,'2013-12-25 18:15:08',NULL,NULL),(37591,24766,'TE','4406542422',0,'2014-02-20 04:43:42',NULL,NULL),(11406,7423,'EM','edmondsonmp@hotmail.com',0,'2013-12-26 02:17:05',NULL,NULL),(9668,6329,'EM','candymcdowall7@gmail.com',0,'2013-12-26 00:46:34',NULL,NULL),(9107,5969,'AP','6014702304',0,'2013-12-25 23:51:34',NULL,NULL),(21392,13755,'EM','hpate514@gmail.com',0,'2013-12-26 13:10:04',NULL,NULL),(31732,20710,'TE','3375485015',0,'2014-01-30 21:01:08',NULL,NULL),(23339,15037,'TE','5415201465',0,'2014-01-01 12:02:49',NULL,NULL),(24123,15573,'TE','3307497816',1,'2014-01-02 04:31:57',NULL,NULL),(41851,27832,'TE','4196366855',0,'2014-03-05 21:32:01',NULL,NULL),(5448,3488,'AP','4405362027',0,'2013-12-25 21:20:22',NULL,NULL),(14643,9580,'AP','6025026262',0,'2013-12-26 04:36:52',NULL,NULL),(37903,25001,'EM','carbone.dianna@yahoo.com',0,'2014-02-20 22:00:47',NULL,NULL),(30039,19456,'AP','2816820230',0,'2014-01-23 03:01:54',NULL,NULL),(24105,15560,'EM','vdengg473@hotmail.com',1,'2014-01-02 04:31:34',NULL,NULL),(13812,9001,'TE','4403914575',0,'2013-12-26 04:04:53',NULL,NULL),(13602,8867,'TE','9728251814',0,'2013-12-26 04:01:27',NULL,NULL),(9535,6244,'TE','5139104244',0,'2013-12-26 00:31:44',NULL,NULL),(41334,27457,'AP','3302173649',0,'2014-03-04 21:02:04',NULL,NULL),(24905,16053,'AP','2342816906',0,'2014-01-04 02:03:17',NULL,NULL),(24314,15706,'TE','3305422400',1,'2014-01-02 04:35:55',NULL,NULL),(22348,14411,'EM','rashadjones100@gmail.com',0,'2013-12-28 03:31:28',NULL,NULL),(10003,6545,'TE','9563096136',0,'2013-12-26 00:52:02',NULL,NULL),(37320,24559,'TE','4199577465',0,'2014-02-20 04:06:02',NULL,NULL),(22467,14488,'TE','8176589820',0,'2013-12-28 03:33:27',NULL,NULL),(32526,21263,'AP','6012788934',0,'2014-02-03 21:01:25',NULL,NULL),(7730,5047,'TE','3615426830',0,'2013-12-25 23:00:03',NULL,NULL),(6988,4565,'TE','5672453259',0,'2013-12-25 22:04:48',NULL,NULL),(26366,16970,'BN','4405392734',0,'2014-01-13 02:20:13',NULL,NULL),(136,82,'AP','3306099029',0,'2013-12-25 17:17:11',NULL,NULL),(38272,25270,'TE','3186882158',0,'2014-02-25 21:00:11',NULL,NULL),(32605,21317,'EM','fwhuete@gmail.com',0,'2014-02-04 21:00:21',NULL,NULL),(26630,17135,'TE','5133796661',0,'2014-01-13 02:21:48',NULL,NULL),(23837,15380,'TE','5134076460',1,'2014-01-02 04:25:24',NULL,NULL),(4342,2772,'AP','3302127618',0,'2013-12-25 19:49:33',NULL,NULL),(289,178,'EM','carlb24@windstream.net',0,'2013-12-25 17:19:36',NULL,NULL),(36805,24233,'BN','6013474332',0,'2014-02-16 19:00:35',NULL,NULL),(11248,7324,'TE','6623034037',0,'2013-12-26 02:03:39',NULL,NULL),(24276,15687,'TE','5133447207',1,'2014-01-02 04:35:14',NULL,NULL),(22080,14220,'EM','xrod983@gmail.com',0,'2013-12-27 02:04:43',NULL,NULL),(41643,27682,'AP','3618348185',0,'2014-03-05 21:30:39',NULL,NULL),(42185,28023,'AP','4405419478',0,'2014-03-06 21:01:22',NULL,NULL),(39993,26487,'TE','5049204867',0,'2014-02-28 21:00:08',NULL,NULL),(31835,20784,'TE','8177186353',0,'2014-01-31 21:00:11',NULL,NULL),(22994,14831,'EM','rmr@roadrunner.com',1,'2013-12-29 11:14:36',NULL,NULL),(1008,621,'AP','9373615915',0,'2013-12-25 18:00:50',NULL,NULL),(38628,25532,'TE','2542470034',0,'2014-02-26 08:00:05',NULL,NULL),(6365,4100,'TE','8304597984',0,'2013-12-25 21:47:43',NULL,NULL),(8994,5903,'EM','sweetfate@msn.com',0,'2013-12-25 23:49:49',NULL,NULL),(29256,18895,'TE','3308140610',0,'2014-01-17 03:36:34',NULL,NULL),(27783,17911,'TE','8176755403',0,'2014-01-15 02:06:27',NULL,NULL),(24160,15613,'EM','jdlefty5@gmail.com',1,'2014-01-02 04:32:53',NULL,NULL),(24606,15869,'AP','6015170345',0,'2014-01-03 02:05:02',NULL,NULL),(25924,16705,'TE','4693832180',0,'2014-01-08 18:24:40',NULL,NULL),(42756,28440,'TE','3184596308',0,'2014-03-07 21:31:13',NULL,NULL),(45,29,'TE','5056994967',0,'2013-12-25 17:15:45',NULL,NULL),(31460,20503,'AP','3186740973',0,'2014-01-29 21:01:14',NULL,NULL),(9503,6220,'TE','4195732676',0,'2013-12-26 00:31:08',NULL,NULL),(9243,6049,'AP','9197248258',0,'2013-12-26 00:01:38',NULL,NULL),(1175,721,'EM','xchancex@hotmail.com',0,'2013-12-25 18:03:28',NULL,NULL),(1684,1034,'EM','whoiswookie@yahoo.com',0,'2013-12-25 18:15:36',NULL,NULL),(14094,9215,'EM','strikezonefitness@yahoo.com',0,'2013-12-26 04:10:02',NULL,NULL),(14640,9578,'TE','5138316069',0,'2013-12-26 04:36:49',NULL,NULL),(28179,18163,'EM','lanailsdsl123@frontier.com',0,'2014-01-15 02:07:55',NULL,NULL),(21766,14020,'AP','9372669259',0,'2013-12-26 13:16:37',NULL,NULL),(24456,15787,'TE','9852272426',0,'2014-01-03 02:02:21',NULL,NULL),(23338,15036,'EM','CASHMIRLAVIGNE@HOTMAIL.COM',0,'2014-01-01 12:02:48',NULL,NULL),(4881,3128,'AP','5135209104',0,'2013-12-25 20:30:26',NULL,NULL),(1051,647,'EM','spazz0002@hotmail.com',0,'2013-12-25 18:01:31',NULL,NULL),(10957,7122,'TE','6016248961',0,'2013-12-26 01:51:22',NULL,NULL),(39967,26461,'AP','5049136270',0,'2014-02-28 07:30:31',NULL,NULL),(38289,25282,'AP','8176002990',0,'2014-02-25 21:00:18',NULL,NULL),(31584,20599,'AP','3304929280',0,'2014-01-30 21:00:12',NULL,NULL),(4122,2628,'EM','cory.schleyer@gmail.com',0,'2013-12-25 19:46:04',NULL,NULL),(4204,2687,'EM','jessyh2002@gmail.com',0,'2013-12-25 19:47:25',NULL,NULL),(4563,2906,'EM','toniotchere@gmail.com',0,'2013-12-25 20:15:28',NULL,NULL),(14913,9757,'TE','3302446388',0,'2013-12-26 05:00:07',NULL,NULL),(27691,17850,'TE','9375287897',0,'2014-01-15 02:06:06',NULL,NULL),(637,395,'EM','rocky_evans19@yahoo.com',0,'2013-12-25 17:46:01',NULL,NULL),(25018,16122,'TE','5042840620',0,'2014-01-04 02:05:26',NULL,NULL),(23826,15371,'EM','queenothmadhouse@yahoo.com',1,'2014-01-02 04:25:06',NULL,NULL),(33115,21692,'TE','3183399218',0,'2014-02-05 21:31:07',NULL,NULL),(3862,2457,'TE','8325304117',0,'2013-12-25 19:34:49',NULL,NULL),(2505,1537,'TE','3174424417',0,'2013-12-25 18:50:11',NULL,NULL),(13978,9118,'AP','3304756609',0,'2013-12-26 04:07:43',NULL,NULL),(6206,3999,'TE','4194814224',0,'2013-12-25 21:45:08',NULL,NULL),(4190,2681,'AP','3309907936',0,'2013-12-25 19:47:13',NULL,NULL),(22068,14212,'AP','9563541898',0,'2013-12-27 02:04:32',NULL,NULL),(2441,1497,'TE','6148853376',0,'2013-12-25 18:49:12',NULL,NULL),(29784,19259,'AP','5042961263',0,'2014-01-21 08:46:48',NULL,NULL),(11371,7406,'AP','2255050341',0,'2013-12-26 02:16:36',NULL,NULL),(12222,7987,'TE','3308546853',0,'2013-12-26 03:08:06',NULL,NULL),(40856,27148,'AP','5134353633',0,'2014-03-03 21:30:51',NULL,NULL),(34707,22756,'EM','tiffany.johnson.0211@gmail.com',0,'2014-02-11 21:01:30',NULL,NULL),(11436,7440,'TE','3303517501',0,'2013-12-26 02:30:23',NULL,NULL),(7395,4811,'AP','9373057689',0,'2013-12-25 22:16:48',NULL,NULL),(11709,7623,'TE','9565640775',0,'2013-12-26 02:45:59',NULL,NULL),(33762,22154,'AP','5136770590',0,'2014-02-08 19:00:56',NULL,NULL),(28504,18371,'EM','Threeliljoys@yahoo.com',0,'2014-01-16 08:45:30',NULL,NULL),(7166,4674,'TE','3186093033',0,'2013-12-25 22:07:41',NULL,NULL),(23114,14902,'TE','4404872437',0,'2013-12-30 00:01:10',NULL,NULL),(4898,3145,'TE','8325774844',0,'2013-12-25 20:30:53',NULL,NULL),(21902,14110,'TE','5135084648',0,'2013-12-27 02:01:50',NULL,NULL),(237,144,'TE','3307859588',0,'2013-12-25 17:18:47',NULL,NULL),(37180,24475,'TE','4197260792',0,'2014-02-18 22:01:41',NULL,NULL),(34727,22771,'BN','9373041534',0,'2014-02-11 21:01:38',NULL,NULL),(34485,22624,'EM','romoroxu@gmail.com',0,'2014-02-11 21:00:13',NULL,NULL),(10319,6731,'AP','3303237134',0,'2013-12-26 01:15:29',NULL,NULL),(33430,21898,'EM','amber@kemppel.com',0,'2014-02-06 21:01:45',NULL,NULL),(29383,18987,'EM','sb830@aol.com',0,'2014-01-20 08:06:10',NULL,NULL),(8884,5820,'AP','2543154155',0,'2013-12-25 23:47:59',NULL,NULL),(28730,18540,'TE','6016705390',0,'2014-01-16 08:46:48',NULL,NULL),(27816,17926,'EM','kim.gordoa@yahoo.com',0,'2014-01-15 02:06:33',NULL,NULL),(42258,28067,'TE','3307848548',0,'2014-03-06 21:01:48',NULL,NULL),(43233,28727,'TE','5046827892',0,'2014-03-09 21:00:01',NULL,NULL),(39383,26046,'TE','3306034767',0,'2014-02-26 21:02:30',NULL,NULL),(39316,26007,'TE','4192350816',0,'2014-02-26 21:02:07',NULL,NULL),(10419,6794,'TE','3306994893',0,'2013-12-26 01:17:10',NULL,NULL),(34703,22755,'AP','9857788991',0,'2014-02-11 21:01:29',NULL,NULL),(30928,20115,'TE','5132276660',0,'2014-01-27 21:00:42',NULL,NULL),(29785,19260,'TE','2255730031',0,'2014-01-21 08:46:48',NULL,NULL),(20849,13404,'EM','lhorn350@gmail.com',0,'2013-12-26 13:00:25',NULL,NULL),(23229,14969,'EM','simpgirl87@hotmail.com',0,'2014-01-01 12:00:45',NULL,NULL),(24098,15554,'AP','9858174321',1,'2014-01-02 04:31:25',NULL,NULL),(27619,17805,'AP','2108445956',0,'2014-01-15 02:05:50',NULL,NULL),(43685,28998,'EM','heatherbpuckett@gmail.com',0,'2014-03-10 21:01:17',NULL,NULL),(39447,26088,'EM','thefinewoody@gmail.com',0,'2014-02-28 06:30:07',NULL,NULL),(5098,3270,'EM','Terrie.Milton@yahoo.com',0,'2013-12-25 20:47:11',NULL,NULL),(6615,4274,'EM','ghawkinshchs@yahoo.com',0,'2013-12-25 21:51:51',NULL,NULL),(10754,6990,'AP','2167991474',0,'2013-12-26 01:47:59',NULL,NULL),(39393,26050,'TE','3308588977',0,'2014-02-26 21:02:33',NULL,NULL),(12085,7897,'TE','4192293376',0,'2013-12-26 03:05:43',NULL,NULL),(37521,24707,'EM','RhondaKPhillips@aol.com',0,'2014-02-20 04:35:41',NULL,NULL),(31734,20711,'AP','5049143748',0,'2014-01-30 21:01:09',NULL,NULL),(30949,20128,'AP','5136490511',0,'2014-01-27 21:00:50',NULL,NULL),(23234,14971,'AP','8328766017',0,'2014-01-01 12:00:50',NULL,NULL),(9464,6194,'TE','8322769907',0,'2013-12-26 00:30:24',NULL,NULL),(34123,22374,'TE','5139678334',0,'2014-02-10 21:30:04',NULL,NULL),(29820,19293,'AP','5043439802',1,'2014-01-22 03:21:56',NULL,NULL),(20199,13014,'TE','5133140487',0,'2013-12-26 12:49:52',NULL,NULL),(8680,5699,'TE','6415023982',0,'2013-12-25 23:32:52',NULL,NULL),(1854,1146,'AP','4106032905',0,'2013-12-25 18:18:29',NULL,NULL),(28613,18444,'TE','3188010823',0,'2014-01-16 08:46:05',NULL,NULL),(14211,9300,'TE','4043379092',0,'2013-12-26 04:16:21',NULL,NULL),(14185,9283,'TE','4043379092',0,'2013-12-26 04:15:56',NULL,NULL),(866,540,'AP','3307779646',0,'2013-12-25 17:49:42',NULL,NULL),(36372,23952,'EM','unitedabc@gmail.com',0,'2014-02-15 22:00:05',NULL,NULL),(32294,21094,'TE','5672598987',0,'2014-02-02 19:00:30',NULL,NULL),(13994,9134,'TE','7406447267',0,'2013-12-26 04:08:03',NULL,NULL),(32074,20945,'TE','9032888600',0,'2014-01-31 21:01:45',NULL,NULL),(41784,27779,'AP','3303215015',0,'2014-03-05 21:31:32',NULL,NULL),(41284,27430,'EM','the.hecks@gmail.com',0,'2014-03-04 21:01:46',NULL,NULL),(25843,16660,'TE','2254564619',0,'2014-01-08 18:24:24',NULL,NULL),(24676,15911,'TE','3616766868',0,'2014-01-03 02:06:24',NULL,NULL),(10704,6957,'TE','9372480740',0,'2013-12-26 01:47:12',NULL,NULL),(6866,4454,'AP','7402217844',0,'2013-12-25 22:02:28',NULL,NULL),(5991,3849,'TE','3184171196',0,'2013-12-25 21:35:35',NULL,NULL),(40667,26999,'TE','7402438766',0,'2014-03-03 21:00:01',NULL,NULL),(38459,25414,'TE','6148996025',0,'2014-02-25 21:31:05',NULL,NULL),(20782,13355,'EM','btknueven23@gmail.com',0,'2013-12-26 12:59:19',NULL,NULL),(10453,6810,'AP','4694267451',0,'2013-12-26 01:30:18',NULL,NULL),(35696,23478,'EM','jsully244@yahoo.com',0,'2014-02-13 22:01:53',NULL,NULL),(11683,7604,'EM','sharisue.nelson@gmail.com',0,'2013-12-26 02:45:28',NULL,NULL),(14332,9371,'TE','5046572246',0,'2013-12-26 04:31:49',NULL,NULL),(34867,22866,'AP','6013838316',0,'2014-02-11 21:02:28',NULL,NULL),(34667,22731,'AP','5042067550',0,'2014-02-11 21:01:15',NULL,NULL),(25404,16384,'EM','ctn0033@gmail.com',0,'2014-01-07 04:03:25',NULL,NULL),(32842,21493,'EM','rwarren78@gmail.com',0,'2014-02-04 21:01:48',NULL,NULL),(30229,19582,'TE','5043432600',0,'2014-01-23 03:02:41',NULL,NULL),(31527,20544,'AP','4195092043',0,'2014-01-29 21:01:38',NULL,NULL),(31464,20506,'TE','2258032758',0,'2014-01-29 21:01:16',NULL,NULL),(42961,28569,'EM','wisemaw@hotmail.com',0,'2014-03-07 21:32:30',NULL,NULL),(35760,23517,'TE','6623233818',0,'2014-02-13 22:02:18',NULL,NULL),(14561,9514,'AP','4196899312',0,'2013-12-26 04:35:29',NULL,NULL),(31616,20622,'EM','azgadavi08@yahoo.com',0,'2014-01-30 21:00:24',NULL,NULL),(2073,1282,'AP','5137682769',0,'2013-12-25 18:30:36',NULL,NULL),(30130,19515,'AP','7273653778',0,'2014-01-23 03:02:16',NULL,NULL),(29198,18863,'AP','2252506266',0,'2014-01-17 03:36:21',NULL,NULL),(20891,13433,'EM','charlie_diana@yahoo.com',0,'2013-12-26 13:01:06',NULL,NULL),(28749,18553,'TE','2283552088',0,'2014-01-16 08:46:54',NULL,NULL),(27054,17398,'TE','4192366591',0,'2014-01-13 03:00:15',NULL,NULL),(43191,28701,'AP','4196067262',0,'2014-03-08 21:31:09',NULL,NULL),(43270,28747,'EM','bronze462003@yahoo.com',0,'2014-03-09 21:00:14',NULL,NULL),(112,67,'AP','2162124469',0,'2013-12-25 17:16:49',NULL,NULL),(38890,25707,'AP','6823658077',0,'2014-02-26 09:30:21',NULL,NULL),(27363,17615,'AP','8327745652',0,'2014-01-14 01:32:24',NULL,NULL),(27144,17478,'AP','9362396610',0,'2014-01-13 03:01:11',NULL,NULL),(25702,16570,'TE','4198788700',1,'2014-01-07 10:23:18',NULL,NULL),(21166,13615,'TE','5139217362',0,'2013-12-26 13:05:43',NULL,NULL),(8517,5600,'TE','5183310914',0,'2013-12-25 23:30:14',NULL,NULL),(36357,23944,'TE','4326873551',0,'2014-02-15 21:00:11',NULL,NULL),(33373,21868,'TE','7348127906',0,'2014-02-06 21:01:24',NULL,NULL),(4017,2555,'TE','9014120873',0,'2013-12-25 19:37:23',NULL,NULL),(12089,7901,'AP','5133600150',0,'2013-12-26 03:05:49',NULL,NULL),(28063,18088,'AP','5042344899',0,'2014-01-15 02:07:29',NULL,NULL),(24962,16089,'AP','6013765794',0,'2014-01-04 02:04:22',NULL,NULL),(3909,2481,'TE','5043003205',0,'2013-12-25 19:35:31',NULL,NULL),(9253,6055,'TE','7402237530',0,'2013-12-26 00:01:48',NULL,NULL),(38414,25381,'AP','6623033988',0,'2014-02-25 21:30:46',NULL,NULL),(31519,20539,'EM','m.winget@att.net',0,'2014-01-29 21:01:35',NULL,NULL),(14920,9762,'TE','7409225144',0,'2013-12-26 05:00:14',NULL,NULL),(24802,16000,'EM','djh.griffin@gmail.com',0,'2014-01-04 02:01:30',NULL,NULL),(3848,2448,'EM','Jslouffman@hotmail.com',0,'2013-12-25 19:34:37',NULL,NULL),(3378,2123,'TE','3306061957',0,'2013-12-25 19:17:47',NULL,NULL),(22959,14810,'TE','2252683527',1,'2013-12-29 11:14:02',NULL,NULL),(4000,2543,'TE','4196010348',0,'2013-12-25 19:37:05',NULL,NULL),(2226,1368,'AP','8323721411',0,'2013-12-25 18:45:42',NULL,NULL),(64,41,'EM','bobradford5702@gmail.com',0,'2013-12-25 17:16:05',NULL,NULL),(12373,8100,'AP','2342009887',0,'2013-12-26 03:10:53',NULL,NULL),(40051,26552,'EM','sheiridamichelledunn@yahoo.com',0,'2014-02-28 21:30:14',NULL,NULL),(39174,25912,'AP','5125379234',0,'2014-02-26 21:01:15',NULL,NULL),(37559,24734,'TE','6142958723',0,'2014-02-20 04:39:47',NULL,NULL),(34479,22622,'EM','vannbchau@gmail.com',0,'2014-02-11 21:00:11',NULL,NULL),(6951,4532,'EM','john@ansraudio.com',0,'2013-12-25 22:04:05',NULL,NULL),(32809,21467,'TE','6012150284',0,'2014-02-04 21:01:36',NULL,NULL),(32531,21266,'TE','8326060026',0,'2014-02-03 21:01:28',NULL,NULL),(24418,15764,'AP','7025262840',0,'2014-01-03 02:01:36',NULL,NULL),(42761,28442,'AP','5072927661',0,'2014-03-07 21:31:14',NULL,NULL),(43061,28628,'TE','8307733161',0,'2014-03-08 21:30:25',NULL,NULL),(37764,24918,'EM','donolanterns@hotmail.com',0,'2014-02-20 21:30:12',NULL,NULL),(34678,22740,'AP','9856874291',0,'2014-02-11 21:01:19',NULL,NULL),(30993,20161,'TE','4407170455',0,'2014-01-27 21:01:10',NULL,NULL),(22364,14424,'TE','9037872870',0,'2013-12-28 03:31:46',NULL,NULL),(5102,3272,'EM','mark1526@yahoo.com',0,'2013-12-25 20:47:15',NULL,NULL),(4657,2975,'EM','CHIN011251@aol.com',0,'2013-12-25 20:17:06',NULL,NULL),(2972,1842,'EM','melissarohrer55@gmail.com',0,'2013-12-25 18:57:40',NULL,NULL),(2186,1344,'EM','Jackievinsoncano@gmail.com',0,'2013-12-25 18:45:04',NULL,NULL),(6481,4192,'EM','hplatzr@hotmail.com',0,'2013-12-25 21:49:41',NULL,NULL),(37951,25042,'TE','9372156982',0,'2014-02-20 22:01:11',NULL,NULL),(37766,24921,'AP','3304735710',0,'2014-02-20 21:30:14',NULL,NULL),(24590,15860,'TE','6018597997',0,'2014-01-03 02:04:45',NULL,NULL),(32885,21524,'AP','8327192493',0,'2014-02-05 21:30:04',NULL,NULL),(27048,17395,'TE','5139311335',0,'2014-01-13 03:00:13',NULL,NULL),(9260,6059,'AP','5138843167',0,'2013-12-26 00:01:54',NULL,NULL),(10227,6683,'AP','2165131353',0,'2013-12-26 01:01:28',NULL,NULL),(2291,1404,'EM','sarahlynnbolton@gmail.com',0,'2013-12-25 18:46:42',NULL,NULL),(509,319,'EM','letharpe@gmail.com',0,'2013-12-25 17:31:19',NULL,NULL),(43995,29188,'TE','3308253026',0,'2014-03-10 21:30:04',NULL,NULL),(8730,5726,'TE','2253642678',0,'2013-12-25 23:45:33',NULL,NULL),(22014,14178,'TE','9033533585',0,'2013-12-27 02:03:39',NULL,NULL),(21637,13928,'EM','gadler@bex.net',0,'2013-12-26 13:14:23',NULL,NULL),(3018,1881,'TE','5672772534',0,'2013-12-25 18:58:32',NULL,NULL),(42237,28056,'TE','7403960635',0,'2014-03-06 21:01:41',NULL,NULL),(14832,9708,'AP','5049199933',0,'2013-12-26 04:45:07',NULL,NULL),(168,99,'TE','7139922081',0,'2013-12-25 17:17:41',NULL,NULL),(29058,18763,'EM','alveywillis@hotmail.com',0,'2014-01-17 03:35:48',NULL,NULL),(31964,20871,'AP','6013163209',0,'2014-01-31 21:01:02',NULL,NULL),(40809,27118,'TE','4404742334',0,'2014-03-03 21:30:32',NULL,NULL),(14127,9253,'AP','7245495798',0,'2013-12-26 04:15:04',NULL,NULL),(6885,4470,'TE','3302343669',0,'2013-12-25 22:02:50',NULL,NULL),(42081,27960,'AP','9852324053',0,'2014-03-06 21:00:44',NULL,NULL),(42933,28547,'TE','4192830716',0,'2014-03-07 21:32:18',NULL,NULL),(775,483,'EM','3dimensionalmindthink@gmail.com',0,'2013-12-25 17:48:13',NULL,NULL),(13755,8965,'TE','7405375312',0,'2013-12-26 04:03:57',NULL,NULL),(13741,8955,'EM','citrada@gmail.com',0,'2013-12-26 04:03:42',NULL,NULL),(38402,25369,'TE','9374031823',0,'2014-02-25 21:30:40',NULL,NULL),(4968,3187,'AP','3306070560',0,'2013-12-25 20:32:02',NULL,NULL),(4848,3103,'TE','4198820574',0,'2013-12-25 20:20:20',NULL,NULL),(34201,22429,'EM','davidalmaguer43@yahoo.com',0,'2014-02-10 21:30:36',NULL,NULL),(31611,20620,'TE','2256447155',0,'2014-01-30 21:00:23',NULL,NULL),(22786,14693,'EM','cbbrick1994@yahoo.com',1,'2013-12-29 11:08:52',NULL,NULL),(27235,17534,'TE','5137934740',0,'2014-01-13 03:01:44',NULL,NULL),(24274,15685,'AP','8594141611',1,'2014-01-02 04:35:10',NULL,NULL),(42325,28106,'TE','3306990272',0,'2014-03-06 21:02:13',NULL,NULL),(43424,28836,'TE','9374227368',0,'2014-03-09 21:01:10',NULL,NULL),(43606,28950,'AP','2057674522',0,'2014-03-10 21:00:49',NULL,NULL),(40184,26652,'AP','3307031525',0,'2014-02-28 21:31:08',NULL,NULL),(35449,23307,'AP','5135603298',0,'2014-02-13 22:00:19',NULL,NULL),(27846,17939,'AP','8325258441',0,'2014-01-15 02:06:39',NULL,NULL),(25852,16664,'AP','3185371514',0,'2014-01-08 18:24:26',NULL,NULL),(25373,16363,'TE','6016248176',0,'2014-01-07 04:02:50',NULL,NULL),(24877,16041,'TE','9366345426',0,'2014-01-04 02:02:51',NULL,NULL),(21378,13745,'TE','5138500350',0,'2013-12-26 13:09:49',NULL,NULL),(6759,4388,'TE','5133493433',0,'2013-12-25 22:00:49',NULL,NULL),(40122,26607,'EM','adrian13aguilar@gmail.com',0,'2014-02-28 21:30:45',NULL,NULL),(13850,9032,'TE','3306054272',0,'2013-12-26 04:05:36',NULL,NULL),(4044,2582,'TE','5134846356',0,'2013-12-25 19:38:01',NULL,NULL),(36128,23777,'AP','2283265508',0,'2014-02-14 21:31:17',NULL,NULL),(32845,21497,'TE','5138076618',0,'2014-02-04 21:01:50',NULL,NULL),(31603,20614,'TE','5045706651',0,'2014-01-30 21:00:20',NULL,NULL),(25615,16521,'TE','8067903657',1,'2014-01-07 10:21:43',NULL,NULL),(30623,19874,'EM','angieramirez1209@gmail.com',0,'2014-01-24 21:00:43',NULL,NULL),(29098,18791,'AP','3304100580',0,'2014-01-17 03:35:56',NULL,NULL),(1616,994,'AP','9375805289',0,'2013-12-25 18:10:43',NULL,NULL),(10041,6568,'EM','sylviaits@yahoo.com',0,'2013-12-26 00:52:36',NULL,NULL),(40052,26553,'TE','3309330092',0,'2014-02-28 21:30:15',NULL,NULL),(29843,19308,'EM','jkaugustin@miners.utep.edu',1,'2014-01-22 03:22:04',NULL,NULL),(4039,2579,'AP','9373088095',0,'2013-12-25 19:37:56',NULL,NULL),(22292,14367,'TE','9372459168',0,'2013-12-28 03:30:26',NULL,NULL),(5869,3766,'TE','3304143127',0,'2013-12-25 21:33:34',NULL,NULL),(41491,27582,'AP','8067312355',0,'2014-03-05 21:00:12',NULL,NULL),(36822,24252,'AP','3303288182',0,'2014-02-17 19:00:02',NULL,NULL),(30830,20043,'EM','lee.leekelly@gmail.com',0,'2014-01-26 19:00:28',NULL,NULL),(27780,17909,'TE','9035043668',0,'2014-01-15 02:06:26',NULL,NULL),(23711,15303,'AP','5044786010',1,'2014-01-02 04:22:55',NULL,NULL),(42525,28291,'AP','5138856851',0,'2014-03-07 21:00:28',NULL,NULL),(35208,23125,'TE','4086939483',0,'2014-02-12 21:31:26',NULL,NULL),(14088,9212,'AP','6016700179',0,'2013-12-26 04:09:56',NULL,NULL),(7106,4640,'EM','jbs2009@comcast.net',0,'2013-12-25 22:06:46',NULL,NULL),(6591,4256,'TE','3307844618',0,'2013-12-25 21:51:25',NULL,NULL),(34844,22849,'AP','4192039386',0,'2014-02-11 21:02:19',NULL,NULL),(5810,3732,'TE','9039272207',0,'2013-12-25 21:32:37',NULL,NULL),(9305,6095,'TE','4192300466',0,'2013-12-26 00:02:52',NULL,NULL),(34824,22839,'EM','greg@reichenbachlaw.com',0,'2014-02-11 21:02:13',NULL,NULL),(31120,20267,'TE','6144400265',0,'2014-01-28 21:00:21',NULL,NULL),(43865,29107,'AP','5046158892',0,'2014-03-10 21:02:21',NULL,NULL),(38110,25156,'AP','8322298197',0,'2014-02-21 22:00:20',NULL,NULL),(37358,24593,'EM','Donnie2330@me.com',0,'2014-02-20 04:11:16',NULL,NULL),(1394,853,'TE','4192220533',0,'2013-12-25 18:06:57',NULL,NULL),(1748,1078,'TE','3212002488',0,'2013-12-25 18:16:42',NULL,NULL),(21011,13518,'TE','9853450953',0,'2013-12-26 13:03:08',NULL,NULL),(35156,23091,'TE','4403878293',0,'2014-02-12 21:31:07',NULL,NULL),(33604,22036,'TE','9379275454',0,'2014-02-07 19:01:05',NULL,NULL),(26583,17102,'AP','2817345476',0,'2014-01-13 02:21:32',NULL,NULL),(31066,20210,'BN','4404208513',0,'2014-01-27 21:01:38',NULL,NULL),(40026,26530,'AP','5098592723',0,'2014-02-28 21:00:28',NULL,NULL),(11128,7234,'TE','9372530650',0,'2013-12-26 02:01:29',NULL,NULL),(38577,25496,'TE','5132848620',0,'2014-02-25 21:31:51',NULL,NULL),(37377,24612,'EM','THUMBSUPINC@AOL.COM',0,'2014-02-20 04:14:24',NULL,NULL),(12006,7822,'TE','9563587113',0,'2013-12-26 03:04:13',NULL,NULL),(11954,7786,'EM','dharris@h2pcons.com',0,'2013-12-26 03:03:20',NULL,NULL),(11651,7585,'AP','5122171099',0,'2013-12-26 02:34:03',NULL,NULL),(32938,21559,'TE','6144037758',0,'2014-02-05 21:30:17',NULL,NULL),(2470,1515,'AP','9374896030',0,'2013-12-25 18:49:39',NULL,NULL),(7096,4631,'AP','6622300938',0,'2013-12-25 22:06:33',NULL,NULL),(29774,19252,'EM','iampaulapaul@gmail.com',0,'2014-01-21 08:46:44',NULL,NULL),(27214,17523,'EM','cchoates2@aol.com',0,'2014-01-13 03:01:37',NULL,NULL),(26923,17317,'BN','2103233261',0,'2014-01-13 02:23:48',NULL,NULL),(4921,3160,'TE','4405546379',0,'2013-12-25 20:31:17',NULL,NULL),(22052,14203,'TE','5122764186',0,'2013-12-27 02:04:18',NULL,NULL),(189,112,'AP','9405358043',0,'2013-12-25 17:18:00',NULL,NULL),(13798,8995,'EM','MSBETTYBROCKMAN@AOL.COM',0,'2013-12-26 04:04:42',NULL,NULL),(228,140,'TE','3304459935',0,'2013-12-25 17:18:40',NULL,NULL),(41139,27323,'EM','ivan.dominguez.rjzu@statefarm.com',0,'2014-03-04 21:00:48',NULL,NULL),(7887,5140,'AP','5138071965',0,'2013-12-25 23:02:31',NULL,NULL),(7433,4835,'AP','4196771923',0,'2013-12-25 22:17:26',NULL,NULL),(5129,3287,'TE','2166811060',0,'2013-12-25 21:15:25',NULL,NULL),(7309,4756,'TE','8327626198',0,'2013-12-25 22:15:23',NULL,NULL),(7827,5110,'TE','3615274458',0,'2013-12-25 23:01:40',NULL,NULL),(21448,13787,'AP','2287315846',0,'2013-12-26 13:10:56',NULL,NULL),(40556,26918,'EM','cobbjl35@gmail.com',0,'2014-03-03 01:00:14',NULL,NULL),(31503,20528,'TE','6624027895',0,'2014-01-29 21:01:29',NULL,NULL),(25676,16552,'AP','9375970584',1,'2014-01-07 10:22:47',NULL,NULL),(23393,15067,'TE','3184762532',0,'2014-01-01 12:03:47',NULL,NULL),(14709,9624,'TE','3306501472',0,'2013-12-26 04:38:00',NULL,NULL),(23259,14986,'TE','2812220639',0,'2014-01-01 12:01:16',NULL,NULL),(4671,2987,'TE','6069226831',0,'2013-12-25 20:17:20',NULL,NULL),(5592,3576,'AP','4193025069',0,'2013-12-25 21:22:40',NULL,NULL),(42091,27968,'TE','3183493388',0,'2014-03-06 21:00:48',NULL,NULL),(14231,9311,'TE','2253232958',0,'2013-12-26 04:30:16',NULL,NULL),(39152,25898,'TE','9035975375',0,'2014-02-26 21:01:07',NULL,NULL),(5893,3779,'EM','miracle_cjf@hotmail.com',0,'2013-12-25 21:33:57',NULL,NULL),(38151,25180,'TE','7409441039',0,'2014-02-21 22:00:33',NULL,NULL),(5586,3570,'AP','4192701888',0,'2013-12-25 21:22:32',NULL,NULL),(4880,3128,'TE','5135209104',0,'2013-12-25 20:30:26',NULL,NULL),(22651,14604,'EM','jonathan@shiptheweb.com',0,'2013-12-28 03:36:30',NULL,NULL),(22697,14640,'AP','8328961462',1,'2013-12-29 11:07:25',NULL,NULL),(24586,15857,'EM','MADISONGHICKS@YAHOO.COM',0,'2014-01-03 02:04:38',NULL,NULL),(37555,24725,'TE','6143579513',0,'2014-02-20 04:38:51',NULL,NULL),(26090,16803,'TE','4092891023',0,'2014-01-13 02:18:12',NULL,NULL),(26596,17110,'AP','4196805061',0,'2014-01-13 02:21:37',NULL,NULL),(27279,17563,'AP','6147874995',0,'2014-01-14 01:31:58',NULL,NULL),(32023,20903,'AP','3302895170',0,'2014-01-31 21:01:23',NULL,NULL),(7622,4966,'AP','8326469831',0,'2013-12-25 22:46:18',NULL,NULL),(40843,27139,'AP','9524576945',0,'2014-03-03 21:30:46',NULL,NULL),(33885,22238,'EM','gail.shulko@century21.com',0,'2014-02-09 19:00:37',NULL,NULL),(26832,17259,'AP','6143715508',0,'2014-01-13 02:23:16',NULL,NULL),(1532,942,'TE','5137279693',0,'2013-12-25 18:09:23',NULL,NULL),(8876,5814,'AP','8178962101',0,'2013-12-25 23:47:52',NULL,NULL),(2540,1554,'TE','6013192728',0,'2013-12-25 18:50:42',NULL,NULL),(5126,3285,'TE','7349040378',0,'2013-12-25 21:15:21',NULL,NULL),(23131,14912,'TE','5135033428',0,'2013-12-30 00:01:27',NULL,NULL),(43736,29034,'AP','5132383973',0,'2014-03-10 21:01:37',NULL,NULL),(14,8,'TE','4408978449',0,'2013-12-25 17:15:14',NULL,NULL),(2380,1445,'AP','9375159369',0,'2013-12-25 18:47:58',NULL,NULL),(42899,28530,'TE','3376522955',0,'2014-03-07 21:32:07',NULL,NULL),(26150,16836,'EM','mbabcock62@yahoo.com',0,'2014-01-13 02:18:31',NULL,NULL),(31473,20510,'TE','3183810679',0,'2014-01-29 21:01:18',NULL,NULL),(34505,22634,'TE','9159999756',0,'2014-02-11 21:00:19',NULL,NULL),(36370,23952,'TE','9039690092',0,'2014-02-15 22:00:05',NULL,NULL),(37737,24892,'AP','9378316008',0,'2014-02-20 05:39:17',NULL,NULL),(43203,28711,'TE','9012375032',0,'2014-03-08 21:31:14',NULL,NULL),(14964,9790,'EM','rsteller@roadrunner.com',0,'2013-12-26 05:00:57',NULL,NULL),(38172,25194,'AP','2258037240',0,'2014-02-21 22:00:42',NULL,NULL),(10178,6652,'TE','2167986884',0,'2013-12-26 01:00:35',NULL,NULL),(24145,15597,'TE','5139216862',1,'2014-01-02 04:32:34',NULL,NULL),(36752,24196,'EM','Lschroederesq@gmail.com',0,'2014-02-16 19:00:16',NULL,NULL),(34817,22837,'AP','2342009978',0,'2014-02-11 21:02:11',NULL,NULL),(28780,18572,'AP','3309621987',0,'2014-01-16 08:47:05',NULL,NULL),(1164,714,'TE','5672075556',0,'2013-12-25 18:03:17',NULL,NULL),(8030,5253,'TE','3308251040',0,'2013-12-25 23:05:11',NULL,NULL),(41425,27520,'EM','qzheng.b@gmail.com',0,'2014-03-04 21:02:40',NULL,NULL),(34432,22588,'AP','4198606105',0,'2014-02-10 21:32:07',NULL,NULL),(32106,20966,'EM','erigonren@hotmail.com',0,'2014-02-01 19:00:12',NULL,NULL),(9255,6056,'AP','7404077612',0,'2013-12-26 00:01:50',NULL,NULL),(21474,13797,'EM','ruthietaylor92@yahoo.com',0,'2013-12-26 13:11:17',NULL,NULL),(43856,29103,'EM','solarcoreg@gmail.com',0,'2014-03-10 21:02:18',NULL,NULL),(41087,27291,'AP','8069282224',0,'2014-03-04 21:00:29',NULL,NULL),(20255,13049,'TE','5133150644',0,'2013-12-26 12:50:50',NULL,NULL),(2831,1712,'EM','kara.ayers@gmail.com',0,'2013-12-25 18:55:02',NULL,NULL),(10631,6916,'AP','9859665970',0,'2013-12-26 01:46:03',NULL,NULL),(10372,6761,'TE','3304123123',0,'2013-12-26 01:16:21',NULL,NULL),(9358,6126,'AP','9154336260',0,'2013-12-26 00:15:53',NULL,NULL),(8979,5885,'TE','7405692016',0,'2013-12-25 23:49:32',NULL,NULL),(32897,21536,'TE','6149463601',0,'2014-02-05 21:30:08',NULL,NULL),(29699,19201,'TE','4199386447',0,'2014-01-21 08:46:17',NULL,NULL),(13806,8998,'EM','jacobmattes2@aol.com',0,'2013-12-26 04:04:48',NULL,NULL),(14524,9490,'TE','6148644825',0,'2013-12-26 04:34:53',NULL,NULL),(20630,13271,'EM','marilyn.b.williams@sbcglobal.net',0,'2013-12-26 12:56:55',NULL,NULL),(41586,27648,'AP','3304315249',0,'2014-03-05 21:30:21',NULL,NULL),(20484,13192,'AP','8179663291',0,'2013-12-26 12:54:40',NULL,NULL),(41105,27303,'TE','2543340328',0,'2014-03-04 21:00:36',NULL,NULL),(14714,9627,'AP','4199613877',0,'2013-12-26 04:38:06',NULL,NULL),(3793,2411,'AP','5136008332',0,'2013-12-25 19:33:45',NULL,NULL),(37691,24850,'TE','5137935469',0,'2014-02-20 04:55:21',NULL,NULL),(23013,14842,'AP','9374415631',1,'2013-12-29 11:14:52',NULL,NULL),(11799,7673,'TE','4196186339',0,'2013-12-26 03:00:38',NULL,NULL),(42019,27928,'BN','9722730558',0,'2014-03-06 21:00:24',NULL,NULL),(14063,9193,'TE','4197877131',0,'2013-12-26 04:09:26',NULL,NULL),(872,542,'AP','3307304608',0,'2013-12-25 17:49:46',NULL,NULL),(39632,26208,'EM','autumn_terry2002@yahoo.com',0,'2014-02-28 06:30:52',NULL,NULL),(39314,26005,'AP','5108758831',0,'2014-02-26 21:02:06',NULL,NULL),(3546,2221,'EM','shelzone.sweetp@gmail.com',0,'2013-12-25 19:20:32',NULL,NULL),(36728,24183,'AP','3304739345',0,'2014-02-16 19:00:09',NULL,NULL),(33950,22277,'AP','9366155119',0,'2014-02-10 11:00:19',NULL,NULL),(21498,13815,'EM','dlewis75@cinci.rr.com',0,'2013-12-26 13:11:44',NULL,NULL),(33910,22258,'AP','9566481907',0,'2014-02-10 11:00:06',NULL,NULL),(25498,16441,'EM','lisadbeekman@gmail.com',0,'2014-01-07 04:05:07',NULL,NULL),(25590,16508,'TE','4195091606',1,'2014-01-07 10:21:17',NULL,NULL),(26877,17293,'AP','8325072089',0,'2014-01-13 02:23:34',NULL,NULL),(28257,18221,'TE','9569498950',0,'2014-01-16 08:44:13',NULL,NULL),(33725,22124,'EM','jratliff@piquachristian.com',0,'2014-02-08 19:00:41',NULL,NULL),(29512,19079,'TE','6143644144',0,'2014-01-21 08:44:25',NULL,NULL),(43758,29049,'AP','9706902735',0,'2014-03-10 21:01:45',NULL,NULL),(8188,5358,'AP','3308074232',0,'2013-12-25 23:07:47',NULL,NULL),(43772,29057,'EM','diannawhitt921@yahoo.com',0,'2014-03-10 21:01:50',NULL,NULL),(20532,13214,'EM','o.marina_h@yahoo.com',0,'2013-12-26 12:55:22',NULL,NULL),(36953,24335,'AP','5129939862',0,'2014-02-18 22:00:16',NULL,NULL),(30450,19741,'TE','2255051224',0,'2014-01-23 21:01:11',NULL,NULL),(12127,7926,'TE','3372782774',0,'2013-12-26 03:06:27',NULL,NULL),(26477,17040,'EM','simplyredami@yahoo.com',0,'2014-01-13 02:20:51',NULL,NULL),(22399,14446,'TE','5049755849',0,'2013-12-28 03:32:21',NULL,NULL),(21575,13876,'TE','9175544988',0,'2013-12-26 13:13:11',NULL,NULL),(42703,28405,'AP','4195650818',0,'2014-03-07 21:30:53',NULL,NULL),(38718,25591,'EM','rmbalcala@gmail.com',0,'2014-02-26 08:00:43',NULL,NULL),(12441,8151,'TE','9402563570',0,'2013-12-26 03:16:02',NULL,NULL),(8292,5433,'EM','deannarjh@eatel.net',0,'2013-12-25 23:09:43',NULL,NULL),(37892,24995,'EM','CHEJOMODESTO72@YAHOO.COM',0,'2014-02-20 22:00:43',NULL,NULL),(35698,23480,'AP','3372980103',0,'2014-02-13 22:01:54',NULL,NULL),(4320,2756,'AP','4404522498',0,'2013-12-25 19:49:12',NULL,NULL),(2462,1511,'TE','6142840510',0,'2013-12-25 18:49:31',NULL,NULL),(2720,1652,'TE','9792245583',0,'2013-12-25 18:53:23',NULL,NULL),(7968,5198,'EM','larissa.itomlenskis@gmail.com',0,'2013-12-25 23:03:57',NULL,NULL),(23671,15283,'EM','phesmith@yahoo.com',1,'2014-01-02 04:22:14',NULL,NULL),(6941,4522,'EM','mpt76q@yahoo.com',0,'2013-12-25 22:03:52',NULL,NULL),(42137,27991,'TE','4405645169',0,'2014-03-06 21:01:04',NULL,NULL),(37284,24535,'AP','9563400398',0,'2014-02-20 04:01:21',NULL,NULL),(4654,2974,'EM','withbrio@hotmail.com',0,'2013-12-25 20:17:03',NULL,NULL),(33963,22282,'EM','david_mcvey@hotmail.com',0,'2014-02-10 11:00:23',NULL,NULL),(43172,28689,'TE','3307338308',0,'2014-03-08 21:31:02',NULL,NULL),(2115,1305,'AP','9039161157',0,'2013-12-25 18:31:18',NULL,NULL),(9601,6286,'TE','2163554019',0,'2013-12-26 00:45:30',NULL,NULL),(35159,23092,'AP','2163017126',0,'2014-02-12 21:31:08',NULL,NULL),(4779,3059,'AP','8143353897',0,'2013-12-25 20:19:07',NULL,NULL),(9034,5929,'TE','2819091110',0,'2013-12-25 23:50:27',NULL,NULL),(24647,15891,'AP','4195748637',0,'2014-01-03 02:05:45',NULL,NULL),(26368,16973,'AP','6012011436',0,'2014-01-13 02:20:14',NULL,NULL),(34067,22334,'AP','3254554292',0,'2014-02-10 11:01:03',NULL,NULL),(33945,22275,'AP','3614919579',0,'2014-02-10 11:00:17',NULL,NULL),(9283,6079,'AP','4192022706',0,'2013-12-26 00:02:25',NULL,NULL),(7167,4674,'AP','3186093033',0,'2013-12-25 22:07:42',NULL,NULL),(28711,18526,'EM','T_LAVANE81@YAHOO.COM',0,'2014-01-16 08:46:41',NULL,NULL),(2533,1549,'EM','rudy_condor@yahoo.com',0,'2013-12-25 18:50:34',NULL,NULL),(24258,15675,'EM','jmilefchik@yahoo.com',1,'2014-01-02 04:34:50',NULL,NULL),(22158,14273,'TE','6016223208',0,'2013-12-27 02:06:08',NULL,NULL),(3812,2427,'TE','9374642012',0,'2013-12-25 19:34:04',NULL,NULL),(9367,6132,'TE','2814501462',0,'2013-12-26 00:16:02',NULL,NULL),(3423,2148,'EM','dittiacur@hotmail.com',0,'2013-12-25 19:18:30',NULL,NULL),(20740,13331,'TE','7738496250',0,'2013-12-26 12:58:37',NULL,NULL),(20669,13292,'AP','8179883653',0,'2013-12-26 12:57:31',NULL,NULL),(8060,5277,'AP','3308070915',0,'2013-12-25 23:05:41',NULL,NULL),(7994,5216,'TE','3308893787',0,'2013-12-25 23:04:26',NULL,NULL),(7659,4984,'EM','albuster@msn.com',0,'2013-12-25 22:46:50',NULL,NULL),(4931,3165,'TE','5133758602',0,'2013-12-25 20:31:26',NULL,NULL),(21828,14062,'AP','3307309805',0,'2013-12-27 02:00:37',NULL,NULL),(21960,14147,'TE','3183318962',0,'2013-12-27 02:02:47',NULL,NULL),(22680,14625,'EM','Jenniferkoester@yahoo.com',0,'2013-12-28 03:37:03',NULL,NULL),(25045,16140,'EM','bess1@uakron.edu',0,'2014-01-04 02:06:00',NULL,NULL),(27489,17707,'TE','9858470195',0,'2014-01-14 01:33:08',NULL,NULL),(30424,19720,'EM','AHAMMACK21@AOL.COM',0,'2014-01-23 21:00:58',NULL,NULL),(34095,22348,'BN','7865107128',0,'2014-02-10 11:01:14',NULL,NULL),(34988,22972,'TE','6015691788',0,'2014-02-12 21:00:17',NULL,NULL),(35199,23117,'AP','2167737060',0,'2014-02-12 21:31:22',NULL,NULL),(41957,27891,'AP','2167128003',0,'2014-03-05 21:32:39',NULL,NULL),(35555,23381,'TE','5136075545',0,'2014-02-13 22:00:59',NULL,NULL),(38073,25133,'TE','4328898135',0,'2014-02-21 22:00:05',NULL,NULL),(39430,26079,'EM','britknick@gmail.com',0,'2014-02-28 06:30:03',NULL,NULL),(8647,5681,'TE','5137342151',0,'2013-12-25 23:32:20',NULL,NULL),(20884,13430,'TE','5138514907',0,'2013-12-26 13:01:00',NULL,NULL),(2409,1468,'AP','9372061498',0,'2013-12-25 18:48:30',NULL,NULL),(20745,13333,'AP','8062183031',0,'2013-12-26 12:58:41',NULL,NULL),(4541,2888,'EM','11147richard@gmail.com',0,'2013-12-25 20:15:06',NULL,NULL),(4524,2877,'TE','6147781389',0,'2013-12-25 20:02:06',NULL,NULL),(4189,2681,'TE','3309907936',0,'2013-12-25 19:47:12',NULL,NULL),(11066,7187,'EM','elek00@yahoo.com',0,'2013-12-26 02:00:20',NULL,NULL),(6917,4503,'TE','9723427208',0,'2013-12-25 22:03:27',NULL,NULL),(1763,1086,'EM','esthercurtis559@gmail.com',0,'2013-12-25 18:16:56',NULL,NULL),(13933,9086,'AP','4194946433',0,'2013-12-26 04:06:58',NULL,NULL),(20717,13317,'TE','2819717967',0,'2013-12-26 12:58:14',NULL,NULL),(3235,2034,'TE','4325244967',0,'2013-12-25 19:15:26',NULL,NULL),(24400,15754,'TE','3254561003',0,'2014-01-03 02:01:16',NULL,NULL),(28821,18601,'EM','dede43072@msn.com',0,'2014-01-16 08:47:19',NULL,NULL),(29115,18803,'AP','2168488244',0,'2014-01-17 03:36:00',NULL,NULL),(29283,18913,'AP','9372125513',0,'2014-01-17 03:36:41',NULL,NULL),(30092,19496,'AP','8436162708',0,'2014-01-23 03:02:08',NULL,NULL),(31212,20328,'AP','3124809212',0,'2014-01-28 21:00:59',NULL,NULL),(32638,21345,'AP','2107446748',0,'2014-02-04 21:00:35',NULL,NULL),(33546,21992,'TE','2259386472',0,'2014-02-07 19:00:43',NULL,NULL),(43068,28633,'AP','9039443373',0,'2014-03-08 21:30:28',NULL,NULL),(942,580,'EM','wesley.frazier@gmail.com',0,'2013-12-25 17:50:52',NULL,NULL),(24762,15976,'TE','9157400104',0,'2014-01-04 02:00:46',NULL,NULL),(10208,6670,'AP','4408219067',0,'2013-12-26 01:01:06',NULL,NULL),(8440,5552,'EM','gramos5653@yahoo.com',0,'2013-12-25 23:16:11',NULL,NULL),(7394,4811,'TE','9372797456',0,'2013-12-25 22:16:47',NULL,NULL),(6778,4398,'AP','4342500529',0,'2013-12-25 22:01:04',NULL,NULL),(14835,9710,'EM','daniela.capistrano@gmail.com',0,'2013-12-26 04:45:10',NULL,NULL),(21034,13533,'AP','3184619668',0,'2013-12-26 13:03:32',NULL,NULL),(21849,14072,'EM','lloring100@gmail.com',0,'2013-12-27 02:00:55',NULL,NULL),(2983,1846,'EM','shopvac02@yahoo.com',0,'2013-12-25 18:57:48',NULL,NULL),(1749,1078,'AP','3212002488',0,'2013-12-25 18:16:42',NULL,NULL),(4318,2755,'AP','4408123597',0,'2013-12-25 19:49:10',NULL,NULL),(34865,22865,'EM','karole@happygolola.com',0,'2014-02-11 21:02:27',NULL,NULL),(35783,23532,'TE','3185422391',0,'2014-02-13 22:02:26',NULL,NULL),(38039,25098,'AP','8177136473',0,'2014-02-21 21:30:09',NULL,NULL),(1171,720,'TE','8173717538',0,'2013-12-25 18:03:26',NULL,NULL),(4467,2845,'AP','3614293057',0,'2013-12-25 20:01:11',NULL,NULL),(24476,15795,'TE','3185030155',0,'2014-01-03 02:02:39',NULL,NULL),(5703,3662,'TE','6146227536',0,'2013-12-25 21:30:54',NULL,NULL),(23695,15296,'TE','9854134520',1,'2014-01-02 04:22:40',NULL,NULL),(6787,4402,'TE','4199445574',0,'2013-12-25 22:01:12',NULL,NULL),(20858,13409,'AP','5133838130',0,'2013-12-26 13:00:33',NULL,NULL),(14984,9806,'TE','9375362711',0,'2013-12-26 05:01:22',NULL,NULL),(14743,9643,'AP','8179179794',0,'2013-12-26 04:38:33',NULL,NULL),(14596,9543,'EM','bkobistek@nationalphysics.com',0,'2013-12-26 04:36:05',NULL,NULL),(14402,9419,'TE','2545923110',0,'2013-12-26 04:33:03',NULL,NULL),(13901,9061,'EM','jsb1409@gmail.com',0,'2013-12-26 04:06:22',NULL,NULL),(9289,6085,'AP','3302040649',0,'2013-12-26 00:02:35',NULL,NULL),(8540,5609,'EM','JosephPKane@gmail.com',0,'2013-12-25 23:30:31',NULL,NULL),(7438,4845,'TE','3309321036',0,'2013-12-25 22:30:14',NULL,NULL),(25998,16750,'TE','8065182872',0,'2014-01-08 18:24:54',NULL,NULL),(28798,18586,'AP','4197074792',0,'2014-01-16 08:47:11',NULL,NULL),(29760,19244,'TE','5049523139',0,'2014-01-21 08:46:39',NULL,NULL),(36582,24078,'AP','7172053514',0,'2014-02-15 22:01:21',NULL,NULL),(37150,24454,'AP','6014736411',0,'2014-02-18 22:01:28',NULL,NULL),(38088,25142,'AP','5127189667',0,'2014-02-21 22:00:11',NULL,NULL),(40663,26997,'TE','3308006582',0,'2014-03-03 01:30:00',NULL,NULL),(42342,28119,'AP','4194944624',0,'2014-03-06 21:02:19',NULL,NULL),(6121,3939,'EM','blbens@wcnet.org',0,'2013-12-25 21:37:53',NULL,NULL),(25224,16264,'AP','3304959165',0,'2014-01-07 04:00:06',NULL,NULL),(5391,3450,'AP','4405069319',0,'2013-12-25 21:19:29',NULL,NULL),(13991,9128,'TE','3372075405',0,'2013-12-26 04:07:55',NULL,NULL),(5051,3241,'TE','3306302295',0,'2013-12-25 20:46:21',NULL,NULL),(21948,14137,'EM','mhassanjalili@gmail.com',0,'2013-12-27 02:02:34',NULL,NULL),(29885,19339,'AP','4695856631',1,'2014-01-22 03:22:20',NULL,NULL),(30176,19549,'EM','2kitties@mail.com',0,'2014-01-23 03:02:28',NULL,NULL),(6850,4444,'EM','theheartsofbeauty@yahoo.com',0,'2013-12-25 22:02:13',NULL,NULL),(25219,16261,'TE','3304757759',0,'2014-01-05 00:02:57',NULL,NULL),(12355,8087,'EM','loriacreed@yahoo.com',0,'2013-12-26 03:10:35',NULL,NULL),(3807,2424,'TE','3307452318',0,'2013-12-25 19:34:00',NULL,NULL),(21385,13753,'TE','6013721313',0,'2013-12-26 13:09:59',NULL,NULL),(24037,15519,'AP','5043460574',1,'2014-01-02 04:30:17',NULL,NULL),(2662,1616,'TE','8328592789',0,'2013-12-25 18:52:28',NULL,NULL),(5428,3472,'EM','phillipsutherland13@yahoo.com',0,'2013-12-25 21:20:01',NULL,NULL),(26319,16945,'TE','2252841191',0,'2014-01-13 02:19:56',NULL,NULL),(29690,19189,'TE','9032587644',0,'2014-01-21 08:46:12',NULL,NULL),(33213,21749,'BN','9407336891',0,'2014-02-06 21:00:20',NULL,NULL),(34651,22719,'AP','5047562532',0,'2014-02-11 21:01:09',NULL,NULL),(36073,23727,'AP','2816601770',0,'2014-02-14 21:30:55',NULL,NULL),(36845,24262,'AP','5127400079',0,'2014-02-17 19:00:11',NULL,NULL),(37812,24952,'BN','5042348970',0,'2014-02-20 22:00:12',NULL,NULL),(40957,27215,'AP','6623031335',0,'2014-03-03 21:31:31',NULL,NULL),(41083,27290,'TE','3617279883',0,'2014-03-04 21:00:28',NULL,NULL),(42422,28173,'TE','4402475346',0,'2014-03-06 21:02:51',NULL,NULL),(630,393,'TE','9376741020',0,'2013-12-25 17:45:57',NULL,NULL),(24640,15888,'AP','5136730657',0,'2014-01-03 02:05:39',NULL,NULL),(2330,1421,'TE','4697139521',0,'2013-12-25 18:47:15',NULL,NULL),(9082,5954,'AP','6012488937',0,'2013-12-25 23:51:11',NULL,NULL),(2790,1689,'AP','2258034112',0,'2013-12-25 18:54:24',NULL,NULL),(11310,7370,'AP','5132829856',0,'2013-12-26 02:15:39',NULL,NULL),(11838,7703,'TE','9372437034',0,'2013-12-26 03:01:19',NULL,NULL),(2810,1700,'AP','2606155770',0,'2013-12-25 18:54:42',NULL,NULL),(14282,9342,'AP','2252057614',0,'2013-12-26 04:31:02',NULL,NULL),(3421,2148,'TE','9378303238',0,'2013-12-25 19:18:29',NULL,NULL),(21565,13868,'EM','DENISEANGERSTIEN@ROCKETMAIL.COM',0,'2013-12-26 13:12:58',NULL,NULL),(3881,2467,'TE','3186445119',0,'2013-12-25 19:35:06',NULL,NULL),(1459,893,'TE','9379198260',0,'2013-12-25 18:08:03',NULL,NULL),(985,607,'AP','6142647451',0,'2013-12-25 18:00:29',NULL,NULL),(5410,3465,'EM','mizzlizz18@gmail.com',0,'2013-12-25 21:19:48',NULL,NULL),(24477,15795,'AP','3185030155',0,'2014-01-03 02:02:40',NULL,NULL),(29865,19321,'AP','2542915461',1,'2014-01-22 03:22:12',NULL,NULL),(30045,19459,'TE','9032391066',0,'2014-01-23 03:01:56',NULL,NULL),(30079,19486,'AP','9033537813',0,'2014-01-23 03:02:05',NULL,NULL),(30310,19635,'EM','SAM@PRESSF1.INFO',0,'2014-01-23 21:00:12',NULL,NULL),(33057,21654,'AP','3182723530',0,'2014-02-05 21:30:51',NULL,NULL),(34806,22831,'EM','lidfromkid@yahoo.com',0,'2014-02-11 21:02:07',NULL,NULL),(35688,23474,'AP','2108311166',0,'2014-02-13 22:01:50',NULL,NULL),(38973,25770,'AP','4197044309',0,'2014-02-26 09:30:55',NULL,NULL),(39794,26310,'AP','8325638978',0,'2014-02-28 06:31:33',NULL,NULL),(43175,28691,'TE','3308822702',0,'2014-03-08 21:31:03',NULL,NULL),(43558,28926,'AP','5673153968',0,'2014-03-10 21:00:34',NULL,NULL),(133,77,'TE','5132489168',0,'2013-12-25 17:17:06',NULL,NULL),(25357,16352,'AP','5014168529',0,'2014-01-07 04:02:32',NULL,NULL),(24664,15903,'TE','5134518430',0,'2014-01-03 02:06:08',NULL,NULL),(2238,1373,'AP','2143847732',0,'2013-12-25 18:45:51',NULL,NULL),(1318,804,'EM','ojm753@gmail.com',0,'2013-12-25 18:05:39',NULL,NULL),(5114,3277,'EM','lecdayton@aol.com',0,'2013-12-25 21:15:09',NULL,NULL),(8399,5526,'TE','5136681072',0,'2013-12-25 23:15:28',NULL,NULL),(5779,3703,'TE','4408460007',0,'2013-12-25 21:32:01',NULL,NULL),(6194,3992,'TE','9377788345',0,'2013-12-25 21:39:07',NULL,NULL),(14973,9795,'EM','kcottonlago@gmail.com',0,'2013-12-26 05:01:06',NULL,NULL),(22216,14321,'AP','4196514927',0,'2013-12-27 02:07:15',NULL,NULL),(22895,14772,'AP','5126771190',1,'2013-12-29 11:12:59',NULL,NULL),(142,85,'TE','7406412204',0,'2013-12-25 17:17:16',NULL,NULL),(24484,15798,'AP','2257760809',0,'2014-01-03 02:02:46',NULL,NULL),(26932,17323,'AP','2542266370',0,'2014-01-13 02:23:52',NULL,NULL),(30159,19541,'TE','4197898309',0,'2014-01-23 03:02:25',NULL,NULL),(30518,19796,'TE','6625880069',0,'2014-01-23 21:01:45',NULL,NULL),(30574,19838,'TE','2253022733',0,'2014-01-24 21:00:24',NULL,NULL),(30761,19990,'TE','9858671386',0,'2014-01-25 19:00:19',NULL,NULL),(34810,22833,'AP','3302676004',0,'2014-02-11 21:02:09',NULL,NULL),(36040,23704,'EM','sushicafe@hotmail.com',0,'2014-02-14 21:30:44',NULL,NULL),(37026,24377,'EM','grier58@yahoo.com',0,'2014-02-18 22:00:42',NULL,NULL),(40536,26904,'TE','5132770470',0,'2014-03-03 01:00:09',NULL,NULL),(41697,27726,'EM','asksteph@imsteph.com',0,'2014-03-05 21:31:01',NULL,NULL),(43626,28959,'AP','2252268177',0,'2014-03-10 21:00:55',NULL,NULL),(1936,1198,'TE','6147470117',0,'2013-12-25 18:19:49',NULL,NULL),(11984,7808,'AP','5129544755',0,'2013-12-26 03:03:52',NULL,NULL),(21791,14040,'AP','5305103153',0,'2013-12-26 13:17:10',NULL,NULL),(21922,14123,'AP','3303296870',0,'2013-12-27 02:02:10',NULL,NULL),(23378,15060,'TE','3184619668',0,'2014-01-01 12:03:32',NULL,NULL),(9277,6073,'EM','david.moody@oswego.edu',0,'2013-12-26 00:02:16',NULL,NULL),(26644,17141,'EM','reallydabackbone12@gmail.com',0,'2014-01-13 02:21:52',NULL,NULL),(27663,17832,'TE','6014798245',0,'2014-01-15 02:06:00',NULL,NULL),(27708,17857,'EM','THEGUARD13@HOTMAIL.COM',0,'2014-01-15 02:06:09',NULL,NULL),(30683,19932,'TE','3309904484',0,'2014-01-24 21:01:09',NULL,NULL),(30759,19988,'EM','bundegast@gmail.com',0,'2014-01-25 19:00:18',NULL,NULL),(30837,20046,'TE','6624400454',0,'2014-01-26 19:00:31',NULL,NULL),(32650,21355,'AP','2542399133',0,'2014-02-04 21:00:40',NULL,NULL),(33757,22151,'AP','3306711714',0,'2014-02-08 19:00:54',NULL,NULL),(40719,27062,'TE','5612679404',0,'2014-03-03 21:30:00',NULL,NULL),(709,442,'TE','2166507328',0,'2013-12-25 17:47:11',NULL,NULL),(10552,6870,'TE','2162368464',0,'2013-12-26 01:31:58',NULL,NULL),(9813,6420,'EM','katie.gravois@gmail.com',0,'2013-12-26 00:48:53',NULL,NULL),(3985,2532,'TE','9374891389',0,'2013-12-25 19:36:49',NULL,NULL),(12025,7840,'EM','dave@davehawkins.com',0,'2013-12-26 03:04:36',NULL,NULL),(3689,2339,'TE','9562378983',0,'2013-12-25 19:31:55',NULL,NULL),(4292,2740,'EM','jim_n9@hotmail.com',0,'2013-12-25 19:48:47',NULL,NULL),(14600,9545,'AP','5134762274',0,'2013-12-26 04:36:08',NULL,NULL),(5958,3823,'EM','luke4dia49@hotmail.com',0,'2013-12-25 21:35:01',NULL,NULL),(21661,13940,'EM','poshedley7@gmail.com',0,'2013-12-26 13:14:44',NULL,NULL),(22585,14566,'AP','5133167778',0,'2013-12-28 03:35:24',NULL,NULL),(26518,17062,'AP','8055588059',0,'2014-01-13 02:21:12',NULL,NULL),(31068,20212,'AP','3303282448',0,'2014-01-27 21:01:39',NULL,NULL),(31229,20339,'TE','9856418308',0,'2014-01-28 21:01:07',NULL,NULL),(33515,21968,'EM','katieg.role@yahoo.com',0,'2014-02-07 19:00:29',NULL,NULL),(34013,22311,'TE','6019830788',0,'2014-02-10 11:00:45',NULL,NULL),(36489,24021,'EM','dbark1@me.com',0,'2014-02-15 22:00:47',NULL,NULL),(39275,25988,'TE','6016686535',0,'2014-02-26 21:01:55',NULL,NULL),(39566,26177,'AP','3303481476',0,'2014-02-28 06:30:39',NULL,NULL),(40118,26606,'TE','9368752198',0,'2014-02-28 21:30:44',NULL,NULL),(40201,26665,'EM','RLSHAW68@GMAIL.COM',0,'2014-02-28 21:31:14',NULL,NULL),(40978,27226,'EM','cnc2170438@yahoo.com',0,'2014-03-03 21:31:39',NULL,NULL),(43459,28861,'TE','3374362889',0,'2014-03-09 21:30:04',NULL,NULL),(43942,29148,'EM','nancy.smyth@globeagency.com',0,'2014-03-10 21:02:47',NULL,NULL),(39,26,'EM','fireeaglex17@yahoo.com',0,'2013-12-25 17:15:40',NULL,NULL),(10971,7131,'TE','5139079466',0,'2013-12-26 01:51:36',NULL,NULL),(2529,1548,'AP','6018181254',0,'2013-12-25 18:50:32',NULL,NULL),(13863,9039,'AP','4406221862',0,'2013-12-26 04:05:46',NULL,NULL),(21511,13825,'EM','candy31385@yahoo.com',0,'2013-12-26 13:11:59',NULL,NULL),(4407,2807,'AP','5748504009',0,'2013-12-25 20:00:07',NULL,NULL),(22541,14535,'TE','6017153782',0,'2013-12-28 03:34:40',NULL,NULL),(1510,930,'TE','6145569262',0,'2013-12-25 18:09:04',NULL,NULL),(23649,15272,'TE','3309276600',1,'2014-01-02 04:21:50',NULL,NULL),(219,133,'TE','2163425239',0,'2013-12-25 17:18:31',NULL,NULL),(26705,17178,'EM','jptrow@sbcglobal.net',0,'2014-01-13 02:22:11',NULL,NULL),(28700,18521,'TE','8306131058',0,'2014-01-16 08:46:38',NULL,NULL),(30300,19628,'AP','3303307675',0,'2014-01-23 21:00:08',NULL,NULL),(32610,21321,'EM','Jamesdavis267@gmail.com',0,'2014-02-04 21:00:23',NULL,NULL),(36500,24031,'TE','2252524144',0,'2014-02-15 22:00:53',NULL,NULL),(36767,24208,'EM','DUCOTE.2020@GMAIL.COM',0,'2014-02-16 19:00:22',NULL,NULL),(40966,27220,'AP','6012913125',0,'2014-03-03 21:31:34',NULL,NULL),(41471,27561,'TE','6148634977',0,'2014-03-04 21:30:17',NULL,NULL),(43752,29046,'TE','4403548939',0,'2014-03-10 21:01:43',NULL,NULL),(715,444,'EM','gephart.michael@yahoo.com',0,'2013-12-25 17:47:15',NULL,NULL),(1156,709,'AP','3376526372',0,'2013-12-25 18:03:09',NULL,NULL),(1890,1165,'TE','2259393572',0,'2013-12-25 18:19:01',NULL,NULL),(21487,13807,'AP','5133140487',0,'2013-12-26 13:11:31',NULL,NULL),(3243,2041,'AP','9154437918',0,'2013-12-25 19:15:35',NULL,NULL),(14131,9255,'EM','adesantiago52@gmail.com',0,'2013-12-26 04:15:07',NULL,NULL),(25577,16499,'AP','5672041806',0,'2014-01-07 04:06:47',NULL,NULL),(26084,16799,'EM','YVON_NAN69@YAHOO.COM',0,'2014-01-13 02:18:10',NULL,NULL),(29248,18891,'TE','3307947155',0,'2014-01-17 03:36:32',NULL,NULL),(31321,20410,'AP','2149911577',0,'2014-01-29 21:00:24',NULL,NULL),(32742,21421,'TE','5134064009',0,'2014-02-04 21:01:13',NULL,NULL),(34918,22912,'EM','truthordarelucy_99@yahoo.com',0,'2014-02-11 21:02:49',NULL,NULL),(37247,24510,'AP','3615639868',0,'2014-02-20 03:53:10',NULL,NULL),(39509,26134,'AP','6143167646',0,'2014-02-28 06:30:23',NULL,NULL),(7272,4739,'AP','7633704190',0,'2013-12-25 22:09:24',NULL,NULL),(25786,16615,'AP','3309802182',0,'2014-01-08 18:24:09',NULL,NULL),(11915,7756,'AP','2169701724',0,'2013-12-26 03:02:38',NULL,NULL),(14662,9592,'EM','dedolan@sbcglobal.net',0,'2013-12-26 04:37:11',NULL,NULL),(22115,14243,'TE','3617726780',0,'2013-12-27 02:05:19',NULL,NULL),(11132,7235,'EM','kheprakareamenteanu@yahoo.com',0,'2013-12-26 02:01:31',NULL,NULL),(31922,20838,'TE','4407733754',0,'2014-01-31 21:00:45',NULL,NULL),(42101,27972,'EM','MAKEITFUNKY@GMAIL.COM',0,'2014-03-06 21:00:51',NULL,NULL),(1582,976,'EM','c_k_frantz@yahoo.com',0,'2013-12-25 18:10:09',NULL,NULL),(3959,2514,'TE','2283434182',0,'2013-12-25 19:36:23',NULL,NULL),(8141,5328,'TE','3305736946',0,'2013-12-25 23:07:02',NULL,NULL),(8343,5478,'TE','4192412254',0,'2013-12-25 23:10:46',NULL,NULL),(5181,3326,'TE','5132603815',0,'2013-12-25 21:16:10',NULL,NULL),(2804,1698,'AP','6789066780',0,'2013-12-25 18:54:37',NULL,NULL),(10705,6957,'EM','dallas1c@yahoo.com',0,'2013-12-26 01:47:12',NULL,NULL),(6078,3913,'TE','8328659160',0,'2013-12-25 21:37:09',NULL,NULL),(14345,9376,'EM','Christenamarsland@gmail.com',0,'2013-12-26 04:31:58',NULL,NULL),(14366,9391,'TE','7138228143',0,'2013-12-26 04:32:21',NULL,NULL),(6510,4207,'EM','vahid.jamei@yahoo.com',0,'2013-12-25 21:50:05',NULL,NULL),(27179,17501,'TE','4199865180',0,'2014-01-13 03:01:25',NULL,NULL),(29583,19114,'TE','4196735429',0,'2014-01-21 08:44:47',NULL,NULL),(31804,20761,'AP','4193482555',0,'2014-01-30 21:01:35',NULL,NULL),(33434,21900,'TE','4192364134',0,'2014-02-06 21:01:46',NULL,NULL),(34202,22430,'TE','2149309327',0,'2014-02-10 21:30:36',NULL,NULL),(34631,22707,'AP','3186693606',0,'2014-02-11 21:01:02',NULL,NULL),(39821,26333,'TE','3308674369',0,'2014-02-28 06:31:41',NULL,NULL),(43738,29035,'AP','5138468355',0,'2014-03-10 21:01:38',NULL,NULL),(43896,29123,'AP','3148087930',0,'2014-03-10 21:02:32',NULL,NULL),(541,338,'TE','4407493008',0,'2013-12-25 17:31:54',NULL,NULL),(26054,16783,'AP','4197044506',0,'2014-01-08 18:25:06',NULL,NULL),(25604,16517,'TE','2542052335',1,'2014-01-07 10:21:33',NULL,NULL),(13954,9098,'AP','3306206267',0,'2013-12-26 04:07:18',NULL,NULL),(13984,9120,'AP','5132575290',0,'2013-12-26 04:07:47',NULL,NULL),(21699,13971,'AP','5135238549',0,'2013-12-26 13:15:25',NULL,NULL),(4408,2808,'TE','6014545564',0,'2013-12-25 20:00:09',NULL,NULL),(6319,4075,'EM','timaylward@yahoo.com',0,'2013-12-25 21:47:01',NULL,NULL),(2695,1637,'AP','7138993769',0,'2013-12-25 18:52:59',NULL,NULL),(23075,14882,'TE','9152521048',0,'2013-12-30 00:00:34',NULL,NULL),(2090,1290,'EM','jsolari99@yahoo.com',0,'2013-12-25 18:30:51',NULL,NULL),(25209,16256,'TE','6015305129',0,'2014-01-05 00:02:45',NULL,NULL),(26253,16896,'TE','6147438350',0,'2014-01-13 02:19:30',NULL,NULL),(27598,17791,'TE','3309402253',0,'2014-01-14 01:33:48',NULL,NULL),(31073,20214,'EM','meg.abbott@fuse.net',0,'2014-01-27 21:01:40',NULL,NULL),(31894,20816,'EM','Crowekeith@hotmail.com',0,'2014-01-31 21:00:32',NULL,NULL),(32081,20951,'TE','2819232291',0,'2014-02-01 19:00:04',NULL,NULL),(35970,23666,'AP','9152762265',0,'2014-02-14 21:30:22',NULL,NULL),(36374,23956,'TE','9726422239',0,'2014-02-15 22:00:07',NULL,NULL),(38995,25786,'TE','3307017504',0,'2014-02-26 09:31:06',NULL,NULL),(40897,27175,'TE','9565091575',0,'2014-03-03 21:31:07',NULL,NULL),(42262,28069,'EM','wweimer@neo.rr.com',0,'2014-03-06 21:01:49',NULL,NULL),(42724,28418,'AP','3304184317',0,'2014-03-07 21:31:01',NULL,NULL),(43131,28670,'BN','2256107749',0,'2014-03-08 21:30:49',NULL,NULL),(50,31,'EM','jjcorcodel@yahoo.com',0,'2013-12-25 17:15:49',NULL,NULL),(20631,13272,'TE','8173263665',0,'2013-12-26 12:56:56',NULL,NULL),(13957,9099,'AP','5133904399',0,'2013-12-26 04:07:20',NULL,NULL),(11656,7587,'TE','7135205513',0,'2013-12-26 02:34:07',NULL,NULL),(10120,6619,'TE','5132848620',0,'2013-12-26 00:53:59',NULL,NULL),(1278,777,'TE','8063645996',0,'2013-12-25 18:04:59',NULL,NULL),(8087,5292,'AP','2057463319',0,'2013-12-25 23:06:05',NULL,NULL),(7716,5039,'AP','4193094778',0,'2013-12-25 22:47:57',NULL,NULL),(2968,1837,'EM','jparr1977@gmail.com',0,'2013-12-25 18:57:35',NULL,NULL),(1629,1000,'AP','5136330255',0,'2013-12-25 18:10:56',NULL,NULL),(24666,15904,'AP','4192046204',0,'2014-01-03 02:06:11',NULL,NULL),(26643,17141,'TE','5045706427',0,'2014-01-13 02:21:52',NULL,NULL),(28022,18060,'TE','9372123914',0,'2014-01-15 02:07:20',NULL,NULL),(29341,18960,'TE','8323326845',0,'2014-01-20 08:05:54',NULL,NULL),(35107,23058,'AP','2252904706',0,'2014-02-12 21:30:50',NULL,NULL),(36429,23992,'TE','2252683211',0,'2014-02-15 22:00:27',NULL,NULL),(37969,25051,'AP','9373607772',0,'2014-02-20 22:01:17',NULL,NULL),(2397,1460,'AP','9512143296',0,'2013-12-25 18:48:19',NULL,NULL),(22705,14643,'TE','9493717506',1,'2013-12-29 11:07:30',NULL,NULL),(5187,3330,'TE','5133687944',0,'2013-12-25 21:16:17',NULL,NULL),(21364,13738,'TE','3308587268',0,'2013-12-26 13:09:35',NULL,NULL),(14272,9335,'EM','wilbertdavis2001@yahoo.com',0,'2013-12-26 04:30:52',NULL,NULL),(13534,8825,'EM','asusiette@yahoo.com',0,'2013-12-26 04:00:23',NULL,NULL),(7671,4995,'TE','5137421671',0,'2013-12-25 22:47:02',NULL,NULL),(9182,6011,'TE','5139410410',0,'2013-12-26 00:00:36',NULL,NULL),(10786,7011,'TE','3253561745',0,'2013-12-26 01:48:32',NULL,NULL),(26450,17028,'TE','3304215403',0,'2014-01-13 02:20:42',NULL,NULL),(31910,20826,'TE','9856406489',0,'2014-01-31 21:00:38',NULL,NULL),(32211,21038,'TE','3303515918',0,'2014-02-01 19:00:48',NULL,NULL),(32514,21255,'TE','4409495663',0,'2014-02-03 21:01:20',NULL,NULL),(35868,23588,'TE','3307536335',0,'2014-02-13 22:03:00',NULL,NULL),(37395,24625,'TE','2252442913',0,'2014-02-20 04:17:06',NULL,NULL),(39094,25866,'EM','SHEILA.MALBREW@YAHOO.COM',0,'2014-02-26 21:00:47',NULL,NULL),(40021,26519,'TE','4192039514',0,'2014-02-28 21:00:23',NULL,NULL),(40078,26579,'TE','9892434880',0,'2014-02-28 21:30:29',NULL,NULL),(40943,27205,'TE','9406653205',0,'2014-03-03 21:31:24',NULL,NULL),(41848,27827,'EM','johnjolopez@gmail.com',0,'2014-03-05 21:31:59',NULL,NULL),(42550,28316,'TE','9036892987',0,'2014-03-07 21:30:01',NULL,NULL),(510,321,'TE','3372395979',0,'2013-12-25 17:31:21',NULL,NULL),(24970,16092,'EM','lindarester@ymail.com',0,'2014-01-04 02:04:29',NULL,NULL),(3228,2029,'AP','3307156631',0,'2013-12-25 19:15:19',NULL,NULL),(8786,5756,'EM','cbuzz83@yahoo.com',0,'2013-12-25 23:46:23',NULL,NULL),(9311,6097,'TE','2165631275',0,'2013-12-26 00:15:06',NULL,NULL),(3869,2459,'EM','louiethelou@aol.com',0,'2013-12-25 19:34:54',NULL,NULL),(2289,1403,'AP','9857885822',0,'2013-12-25 18:46:40',NULL,NULL),(4705,3009,'TE','3306201141',0,'2013-12-25 20:17:53',NULL,NULL),(1823,1129,'AP','9566850241',0,'2013-12-25 18:18:00',NULL,NULL),(5127,3285,'AP','7349040378',0,'2013-12-25 21:15:22',NULL,NULL),(13983,9120,'TE','5138913994',0,'2013-12-26 04:07:47',NULL,NULL),(5161,3313,'AP','5134901048',0,'2013-12-25 21:15:53',NULL,NULL),(984,607,'TE','6145011676',0,'2013-12-25 18:00:28',NULL,NULL),(22784,14692,'TE','7246744761',1,'2013-12-29 11:08:50',NULL,NULL),(973,598,'AP','6142078672',0,'2013-12-25 18:00:15',NULL,NULL),(26076,16794,'EM','latoya_mitchell@sbcglobal.net',0,'2014-01-13 02:18:08',NULL,NULL),(28021,18059,'AP','9376909393',0,'2014-01-15 02:07:20',NULL,NULL),(31421,20483,'AP','3306874815',0,'2014-01-29 21:01:02',NULL,NULL),(32327,21118,'TE','8324125732',0,'2014-02-03 21:00:11',NULL,NULL),(43617,28955,'AP','5047290565',0,'2014-03-10 21:00:53',NULL,NULL),(28,18,'AP','4193892046',0,'2013-12-25 17:15:28',NULL,NULL),(26045,16779,'TE','9375488640',0,'2014-01-08 18:25:05',NULL,NULL),(25528,16466,'EM','shaun2240@neo.rr.com',0,'2014-01-07 04:05:49',NULL,NULL),(13530,8821,'EM','SHARONHAYNES@CABLEONE.NET',0,'2013-12-26 04:00:17',NULL,NULL),(2326,1418,'TE','2259283663',0,'2013-12-25 18:47:10',NULL,NULL),(1849,1142,'AP','3186142258',0,'2013-12-25 18:18:23',NULL,NULL),(609,375,'EM','al-odum@tx.rr.com',0,'2013-12-25 17:45:33',NULL,NULL),(6462,4174,'TE','2343805675',0,'2013-12-25 21:49:19',NULL,NULL),(24179,15621,'TE','6623471619',1,'2014-01-02 04:33:10',NULL,NULL),(26384,16983,'AP','5135047074',0,'2014-01-13 02:20:19',NULL,NULL),(27082,17418,'TE','9374444193',0,'2014-01-13 03:00:25',NULL,NULL),(28566,18417,'BN','5042148160',0,'2014-01-16 08:45:50',NULL,NULL),(28662,18487,'TE','4402240803',0,'2014-01-16 08:46:23',NULL,NULL),(30722,19961,'AP','7192371287',0,'2014-01-25 19:00:07',NULL,NULL),(41310,27444,'TE','3306996281',0,'2014-03-04 21:01:55',NULL,NULL),(6112,3933,'TE','4194903708',0,'2013-12-25 21:37:43',NULL,NULL),(12427,8138,'EM','bestnumberonemom@yahoo.com',0,'2013-12-26 03:15:45',NULL,NULL),(9442,6181,'AP','5132385859',0,'2013-12-26 00:30:04',NULL,NULL),(8989,5895,'EM','pakclark@gmail.com',0,'2013-12-25 23:49:43',NULL,NULL),(21391,13755,'AP','6308908002',0,'2013-12-26 13:10:04',NULL,NULL),(21871,14090,'AP','2163241021',0,'2013-12-27 02:01:20',NULL,NULL),(8718,5720,'TE','5043770892',0,'2013-12-25 23:45:23',NULL,NULL),(8501,5591,'TE','9376535729',0,'2013-12-25 23:17:16',NULL,NULL),(26755,17210,'TE','3306285387',0,'2014-01-13 02:22:29',NULL,NULL),(27914,17986,'AP','3304142434',0,'2014-01-15 02:06:55',NULL,NULL),(30816,20035,'EM','tinawyatt17@gmail.com',0,'2014-01-26 19:00:23',NULL,NULL),(32122,20976,'TE','6018131925',0,'2014-02-01 19:00:17',NULL,NULL),(35703,23482,'TE','5042670513',0,'2014-02-13 22:01:56',NULL,NULL),(40267,26713,'AP','6016659131',0,'2014-02-28 21:31:39',NULL,NULL),(40672,27005,'TE','8186358958',0,'2014-03-03 21:00:04',NULL,NULL),(42146,28001,'TE','6143488570',0,'2014-03-06 21:01:08',NULL,NULL),(43653,28972,'EM','mquiroz@vetattend.com',0,'2014-03-10 21:01:03',NULL,NULL),(43975,29173,'TE','2165093092',0,'2014-03-10 21:03:01',NULL,NULL),(8553,5619,'EM','mharris2511@sbcglobal.net',0,'2013-12-25 23:30:44',NULL,NULL),(25502,16445,'TE','6013196157',0,'2014-01-07 04:05:13',NULL,NULL),(24373,15739,'AP','9156032532',0,'2014-01-03 02:00:46',NULL,NULL),(11704,7619,'EM','warrded@yahoo.com',0,'2013-12-26 02:45:52',NULL,NULL),(11703,7619,'AP','5133289917',0,'2013-12-26 02:45:52',NULL,NULL),(10851,7044,'TE','9152176505',0,'2013-12-26 01:49:30',NULL,NULL),(20223,13026,'EM','michael@bright.net',0,'2013-12-26 12:50:15',NULL,NULL),(10496,6837,'EM','jsnavely@regis.edu',0,'2013-12-26 01:30:58',NULL,NULL),(8954,5864,'TE','3303542278',0,'2013-12-25 23:49:04',NULL,NULL),(21992,14165,'EM','slu2006@yahoo.com',0,'2013-12-27 02:03:17',NULL,NULL),(22535,14528,'AP','9155326829',0,'2013-12-28 03:34:30',NULL,NULL),(26446,17021,'TE','3306102063',0,'2014-01-13 02:20:40',NULL,NULL),(26972,17347,'AP','5136154487',0,'2014-01-13 02:24:06',NULL,NULL),(27341,17606,'TE','8069952874',0,'2014-01-14 01:32:18',NULL,NULL),(29876,19334,'AP','2144577859',1,'2014-01-22 03:22:17',NULL,NULL),(33983,22293,'EM','lucinda.wolford@gmail.com',0,'2014-02-10 11:00:31',NULL,NULL),(38303,25293,'TE','9373232619',0,'2014-02-25 21:00:24',NULL,NULL),(40378,26802,'EM','rmccants@live.com',0,'2014-03-01 21:00:23',NULL,NULL),(43679,28989,'EM','maparhodes@att.net',0,'2014-03-10 21:01:13',NULL,NULL),(2424,1482,'AP','6142043742',0,'2013-12-25 18:48:50',NULL,NULL),(8053,5274,'AP','3302558747',0,'2013-12-25 23:05:36',NULL,NULL),(5683,3650,'EM','bcampcnor@aol.com',0,'2013-12-25 21:30:37',NULL,NULL),(6921,4510,'TE','3253384029',0,'2013-12-25 22:03:34',NULL,NULL),(14406,9420,'AP','2545923110',0,'2013-12-26 04:33:05',NULL,NULL),(25376,16364,'EM','bartont@bellsouth.net',0,'2014-01-07 04:02:52',NULL,NULL),(27674,17838,'TE','3309288504',0,'2014-01-15 02:06:02',NULL,NULL),(28691,18516,'AP','4196055393',0,'2014-01-16 08:46:35',NULL,NULL),(35925,23637,'AP','5042373633',0,'2014-02-14 21:30:06',NULL,NULL),(37829,24961,'TE','3183416457',0,'2014-02-20 22:00:19',NULL,NULL),(38411,25379,'TE','3306318527',0,'2014-02-25 21:30:45',NULL,NULL),(39106,25871,'AP','3374000189',0,'2014-02-26 21:00:51',NULL,NULL),(2799,1696,'TE','4198411758',0,'2013-12-25 18:54:33',NULL,NULL),(24441,15778,'AP','9565704810',0,'2014-01-03 02:02:03',NULL,NULL),(5013,3218,'TE','2163902111',0,'2013-12-25 20:45:38',NULL,NULL),(24336,15718,'EM','KIMBERLYMARTIN50@YAHOO.COM',0,'2014-01-03 02:00:08',NULL,NULL),(7765,5068,'AP','8304692403',0,'2013-12-25 23:00:39',NULL,NULL),(8767,5747,'AP','3609090037',0,'2013-12-25 23:46:06',NULL,NULL),(11610,7550,'TE','5043556022',0,'2013-12-26 02:33:12',NULL,NULL),(26097,16806,'TE','8302795070',0,'2014-01-13 02:18:14',NULL,NULL),(30375,19677,'EM','LINDA_BARRIOS@COMCAST.NET',0,'2014-01-23 21:00:36',NULL,NULL),(30406,19704,'TE','8303520674',0,'2014-01-23 21:00:49',NULL,NULL),(30545,19814,'EM','binbo_kyky2006@yahoo.com',0,'2014-01-24 21:00:11',NULL,NULL),(31651,20649,'AP','8176967347',0,'2014-01-30 21:00:37',NULL,NULL),(34419,22579,'EM','gerrygermani@yahoo.com',0,'2014-02-10 21:32:02',NULL,NULL),(35175,23104,'AP','3305917720',0,'2014-02-12 21:31:14',NULL,NULL),(39217,25935,'TE','8324809351',0,'2014-02-26 21:01:28',NULL,NULL),(41116,27313,'TE','9565907670',0,'2014-03-04 21:00:41',NULL,NULL),(41470,27558,'EM','KATRD350@GMAIL.COM',0,'2014-03-04 21:30:16',NULL,NULL),(41690,27724,'TE','9157576626',0,'2014-03-05 21:31:00',NULL,NULL),(6239,4021,'AP','4199670026',0,'2013-12-25 21:45:40',NULL,NULL),(24596,15863,'AP','6624710972',0,'2014-01-03 02:04:51',NULL,NULL),(21560,13862,'EM','ddavis.apsllc@yahoo.com',0,'2013-12-26 13:12:52',NULL,NULL),(20757,13340,'TE','2814987380',0,'2013-12-26 12:58:53',NULL,NULL),(1450,884,'TE','9373278200',0,'2013-12-25 18:07:49',NULL,NULL),(11200,7282,'EM','mbrungs04@gmail.com',0,'2013-12-26 02:02:44',NULL,NULL),(10732,6979,'AP','6143302872',0,'2013-12-26 01:47:40',NULL,NULL),(7601,4947,'EM','Kimberrudo@yahoo.com',0,'2013-12-25 22:45:51',NULL,NULL),(10101,6598,'EM','brent@brentbourland.com',0,'2013-12-26 00:53:29',NULL,NULL),(8000,5220,'EM','Seemachellath@yahoo.com',0,'2013-12-25 23:04:31',NULL,NULL),(7636,4973,'TE','4093515357',0,'2013-12-25 22:46:31',NULL,NULL),(25132,16202,'TE','2545419809',0,'2014-01-05 00:01:10',NULL,NULL),(29747,19234,'AP','3309333515',0,'2014-01-21 08:46:34',NULL,NULL),(30058,19471,'AP','3237120654',0,'2014-01-23 03:01:59',NULL,NULL),(30114,19507,'AP','2146723934',0,'2014-01-23 03:02:13',NULL,NULL),(30309,19635,'AP','9377103683',0,'2014-01-23 21:00:11',NULL,NULL),(30625,19876,'TE','2167992500',0,'2014-01-24 21:00:44',NULL,NULL),(34106,22355,'TE','4403054355',0,'2014-02-10 21:00:06',NULL,NULL),(35109,23062,'TE','2254057628',0,'2014-02-12 21:30:51',NULL,NULL),(39815,26329,'AP','6625797431',0,'2014-02-28 06:31:39',NULL,NULL),(43163,28685,'AP','8327545120',0,'2014-03-08 21:30:59',NULL,NULL),(43188,28700,'TE','5135367253',0,'2014-03-08 21:31:08',NULL,NULL),(6635,4295,'AP','6625072239',0,'2013-12-25 21:52:15',NULL,NULL),(5634,3609,'AP','3307601387',0,'2013-12-25 21:23:27',NULL,NULL),(5261,3378,'EM','sdmoran67@gmail.com',0,'2013-12-25 21:17:27',NULL,NULL),(14033,9166,'AP','4193025069',0,'2013-12-26 04:08:49',NULL,NULL),(1038,639,'AP','4406100191',0,'2013-12-25 18:01:19',NULL,NULL),(9332,6112,'AP','3306075448',0,'2013-12-26 00:15:29',NULL,NULL),(4638,2960,'TE','3256583037',0,'2013-12-25 20:16:44',NULL,NULL),(1040,640,'AP','5133645102',0,'2013-12-25 18:01:21',NULL,NULL),(25953,16718,'TE','9562229350',0,'2014-01-08 18:24:45',NULL,NULL),(29295,18929,'TE','3202863039',0,'2014-01-20 08:05:37',NULL,NULL),(29398,18999,'EM','raymondritter@yahoo.com',0,'2014-01-20 08:06:15',NULL,NULL),(31552,20566,'AP','4199577043',0,'2014-01-29 21:01:50',NULL,NULL),(31808,20768,'TE','4199197036',0,'2014-01-30 21:01:38',NULL,NULL),(32394,21165,'EM','REDBONE1957@YAHOO.COM',0,'2014-02-03 21:00:35',NULL,NULL),(33071,21661,'EM','sourmilk413@hotmail.com',0,'2014-02-05 21:30:55',NULL,NULL),(33760,22152,'AP','4196511994',0,'2014-02-08 19:00:55',NULL,NULL),(35141,23078,'AP','3304726819',0,'2014-02-12 21:31:01',NULL,NULL),(36078,23732,'TE','4402258300',0,'2014-02-14 21:30:58',NULL,NULL),(36423,23990,'TE','3184523619',0,'2014-02-15 22:00:25',NULL,NULL),(37823,24958,'TE','2252052592',0,'2014-02-20 22:00:17',NULL,NULL),(4052,2586,'TE','2162560066',0,'2013-12-25 19:38:09',NULL,NULL),(22031,14187,'TE','9793247838',0,'2013-12-27 02:03:54',NULL,NULL),(21399,13759,'TE','5634956254',0,'2013-12-26 13:10:10',NULL,NULL),(21254,13658,'TE','9852260112',0,'2013-12-26 13:07:33',NULL,NULL),(4960,3183,'TE','5048841608',0,'2013-12-25 20:31:55',NULL,NULL),(12154,7939,'EM','mhwhittington@gmail.com',0,'2013-12-26 03:06:51',NULL,NULL),(11958,7791,'TE','9034744398',0,'2013-12-26 03:03:25',NULL,NULL),(5042,3236,'AP','2162805783',0,'2013-12-25 20:46:11',NULL,NULL),(11517,7495,'AP','7404665977',0,'2013-12-26 02:31:43',NULL,NULL),(9696,6350,'AP','5132546376',0,'2013-12-26 00:47:02',NULL,NULL),(8556,5621,'AP','2163464683',0,'2013-12-25 23:30:48',NULL,NULL),(25321,16328,'AP','2258032475',0,'2014-01-07 04:01:55',NULL,NULL),(26899,17304,'AP','2547346046',0,'2014-01-13 02:23:40',NULL,NULL),(27603,17795,'TE','4192780365',0,'2014-01-14 01:33:50',NULL,NULL),(27830,17932,'AP','8173235889',0,'2014-01-15 02:06:36',NULL,NULL),(30550,19824,'TE','9565775232',0,'2014-01-24 21:00:15',NULL,NULL),(30840,20048,'TE','2814954570',0,'2014-01-27 21:00:03',NULL,NULL),(31784,20747,'AP','4197795212',0,'2014-01-30 21:01:27',NULL,NULL),(33916,22260,'BN','2104732080',0,'2014-02-10 11:00:07',NULL,NULL),(37189,24479,'TE','4192147214',0,'2014-02-18 22:01:44',NULL,NULL),(41102,27302,'TE','2543340328',0,'2014-03-04 21:00:35',NULL,NULL),(41640,27681,'TE','9565922096',0,'2014-03-05 21:30:38',NULL,NULL),(43097,28651,'TE','3134670133',0,'2014-03-08 21:30:38',NULL,NULL),(2963,1834,'TE','4192810767',0,'2013-12-25 18:57:30',NULL,NULL),(23784,15338,'EM','anjl214@yahoo.com',1,'2014-01-02 04:24:10',NULL,NULL),(9351,6122,'EM','y1usa@yahoo.com',0,'2013-12-26 00:15:46',NULL,NULL),(22508,14512,'TE','6124818452',0,'2013-12-28 03:34:05',NULL,NULL),(21686,13962,'AP','9376579994',0,'2013-12-26 13:15:10',NULL,NULL),(11978,7804,'EM','bobgrayson@sbcglobal.net',0,'2013-12-26 03:03:46',NULL,NULL),(26162,16844,'EM','holliduh@gmail.com',0,'2014-01-13 02:18:35',NULL,NULL),(26282,16915,'EM','leann.riggs.ihnn@statefarm.com',0,'2014-01-13 02:19:40',NULL,NULL),(31559,20571,'BN','5672776096',0,'2014-01-29 21:01:53',NULL,NULL),(31639,20640,'EM','cmlinda3@yahoo.com',0,'2014-01-30 21:00:33',NULL,NULL),(32740,21418,'AP','4192423522',0,'2014-02-04 21:01:12',NULL,NULL),(36575,24074,'TE','3308078321',0,'2014-02-15 22:01:19',NULL,NULL),(37258,24517,'AP','9152528696',0,'2014-02-20 03:55:53',NULL,NULL),(39854,26364,'TE','3303545829',0,'2014-02-28 07:00:07',NULL,NULL),(42095,27969,'AP','3372982432',0,'2014-03-06 21:00:49',NULL,NULL),(8024,5246,'EM','tbiclenorm@aol.com',0,'2013-12-25 23:05:02',NULL,NULL),(14023,9157,'EM','rkhamilton@zoomitown.com',0,'2013-12-26 04:08:37',NULL,NULL),(20792,13362,'AP','2163384473',0,'2013-12-26 12:59:30',NULL,NULL),(8488,5584,'EM','pat7289@earthlink.net',0,'2013-12-25 23:17:02',NULL,NULL),(25004,16114,'TE','6017957083',0,'2014-01-04 02:05:12',NULL,NULL),(3745,2376,'TE','5134607057',0,'2013-12-25 19:32:53',NULL,NULL),(30268,19611,'EM','jquilty3@gmail.com',0,'2014-01-23 03:02:50',NULL,NULL),(30695,19940,'AP','4199051726',0,'2014-01-24 21:01:14',NULL,NULL),(34015,22311,'BN','6019830788',0,'2014-02-10 11:00:45',NULL,NULL),(34132,22378,'TE','3308676779',0,'2014-02-10 21:30:08',NULL,NULL),(35414,23281,'AP','9852100420',0,'2014-02-13 21:30:16',NULL,NULL),(36546,24063,'TE','5133155280',0,'2014-02-15 22:01:10',NULL,NULL),(37753,24910,'EM','fmccarver@gmail.com',0,'2014-02-20 21:30:07',NULL,NULL),(38068,25129,'TE','4192441559',0,'2014-02-21 21:30:25',NULL,NULL),(40130,26616,'TE','8063723526',0,'2014-02-28 21:30:49',NULL,NULL),(42749,28436,'TE','4196492037',0,'2014-03-07 21:31:10',NULL,NULL),(8346,5480,'TE','4198368587',0,'2013-12-25 23:10:49',NULL,NULL),(22754,14674,'TE','5047569739',1,'2013-12-29 11:08:21',NULL,NULL),(24030,15514,'EM','wlemmond@yahoo.com',1,'2014-01-02 04:30:08',NULL,NULL),(14433,9433,'TE','4196325518',0,'2013-12-26 04:33:28',NULL,NULL),(8815,5772,'AP','2164033049',0,'2013-12-25 23:46:49',NULL,NULL),(25179,16237,'TE','5043093973',0,'2014-01-05 00:02:14',NULL,NULL),(25220,16261,'EM','burlingamecharles@gmail.com',0,'2014-01-05 00:02:57',NULL,NULL),(32442,21196,'EM','WGoodine@aol.com',0,'2014-02-03 21:00:51',NULL,NULL),(33159,21719,'TE','9377834075',0,'2014-02-05 21:31:19',NULL,NULL),(35365,23236,'TE','5132641496',0,'2014-02-12 21:32:29',NULL,NULL),(36263,23867,'EM','NIRWIN900@HOTMAIL.COM',0,'2014-02-14 21:32:08',NULL,NULL),(37790,24940,'AP','6015594667',0,'2014-02-20 22:00:04',NULL,NULL),(41359,27477,'EM','MSugar02@gmail.com',0,'2014-03-04 21:02:15',NULL,NULL),(41501,27589,'TE','9563714952',0,'2014-03-05 21:00:16',NULL,NULL),(253,155,'AP','9152522701',0,'2013-12-25 17:19:02',NULL,NULL),(10702,6956,'TE','6148245582',0,'2013-12-26 01:47:10',NULL,NULL),(9634,6304,'EM','sellenterprises@frontier.com',0,'2013-12-26 00:46:00',NULL,NULL),(21580,13878,'TE','3306995388',0,'2013-12-26 13:13:15',NULL,NULL),(21845,14071,'TE','6145802793',0,'2013-12-27 02:00:52',NULL,NULL),(427,261,'EM','marcia_cloud@yahoo.com',0,'2013-12-25 17:21:51',NULL,NULL),(23279,14999,'AP','9158435558',0,'2014-01-01 12:01:40',NULL,NULL),(21345,13716,'AP','3306083487',0,'2013-12-26 13:09:05',NULL,NULL),(21726,13998,'AP','4193035078',0,'2013-12-26 13:15:59',NULL,NULL),(22497,14504,'TE','8063363030',0,'2013-12-28 03:33:53',NULL,NULL),(919,568,'TE','9379441614',0,'2013-12-25 17:50:31',NULL,NULL),(4827,3089,'AP','9379015764',0,'2013-12-25 20:19:58',NULL,NULL),(27273,17559,'TE','4192346254',0,'2014-01-13 03:02:00',NULL,NULL),(27589,17787,'TE','4195363659',0,'2014-01-14 01:33:45',NULL,NULL),(29561,19102,'EM','ragincajun89@hotmail.com',0,'2014-01-21 08:44:39',NULL,NULL),(32039,20913,'EM','kmeyer23@hotmail.com',0,'2014-01-31 21:01:29',NULL,NULL),(33626,22049,'BN','3252009635',0,'2014-02-08 19:00:04',NULL,NULL),(34719,22765,'TE','6143753646',0,'2014-02-11 21:01:35',NULL,NULL),(37352,24590,'EM','Donnie2330@me.com',0,'2014-02-20 04:10:40',NULL,NULL),(38875,25695,'TE','9565894711',0,'2014-02-26 09:30:15',NULL,NULL),(41514,27600,'EM','amberkemch@gmail.com',0,'2014-03-05 21:00:23',NULL,NULL),(42247,28061,'EM','myothetsan@gmail.com',0,'2014-03-06 21:01:44',NULL,NULL),(43418,28832,'TE','6013717219',0,'2014-03-09 21:01:08',NULL,NULL),(1105,678,'AP','3303239950',0,'2013-12-25 18:02:19',NULL,NULL),(23618,15247,'TE','4409354657',0,'2014-01-01 12:08:51',NULL,NULL),(22333,14400,'AP','9372699987',0,'2013-12-28 03:31:11',NULL,NULL),(22058,14206,'TE','2143508060',0,'2013-12-27 02:04:22',NULL,NULL),(5590,3574,'TE','9378791148',0,'2013-12-25 21:22:37',NULL,NULL),(20359,13113,'TE','4404286410',0,'2013-12-26 12:52:33',NULL,NULL),(13544,8831,'EM','tstot20@yahoo.com',0,'2013-12-26 04:00:32',NULL,NULL),(5177,3322,'EM','alriegler@juno.com',0,'2013-12-25 21:16:07',NULL,NULL),(10561,6875,'AP','5138501811',0,'2013-12-26 01:32:06',NULL,NULL),(4261,2724,'AP','3189553440',0,'2013-12-25 19:48:18',NULL,NULL),(1639,1006,'TE','9036394547',0,'2013-12-25 18:11:06',NULL,NULL),(7250,4726,'TE','5673950650',0,'2013-12-25 22:09:03',NULL,NULL),(8494,5587,'EM','iannrobinson@gmail.com',0,'2013-12-25 23:17:08',NULL,NULL),(27642,17818,'AP','6018424775',0,'2014-01-15 02:05:55',NULL,NULL),(28600,18434,'AP','3185030615',0,'2014-01-16 08:46:00',NULL,NULL),(32500,21240,'TE','4405933258',0,'2014-02-03 21:01:12',NULL,NULL),(33676,22090,'TE','6626332752',0,'2014-02-08 19:00:24',NULL,NULL),(34587,22678,'TE','9562831893',0,'2014-02-11 21:00:46',NULL,NULL),(36569,24071,'EM','likearock@mail.com',0,'2014-02-15 22:01:17',NULL,NULL),(39166,25907,'TE','5802121296',0,'2014-02-26 21:01:12',NULL,NULL),(40778,27101,'TE','3306344893',0,'2014-03-03 21:30:22',NULL,NULL),(42309,28093,'TE','6017204171',0,'2014-03-06 21:02:06',NULL,NULL),(997,613,'EM','evorev1978@yahoo.com',0,'2013-12-25 18:00:39',NULL,NULL),(23573,15219,'TE','3375631643',0,'2014-01-01 12:07:57',NULL,NULL),(22416,14456,'TE','5043205315',0,'2013-12-28 03:32:38',NULL,NULL),(5622,3601,'TE','4198062347',0,'2013-12-25 21:23:16',NULL,NULL),(21878,14094,'AP','5132607421',0,'2013-12-27 02:01:25',NULL,NULL),(4403,2805,'AP','8325575588',0,'2013-12-25 20:00:04',NULL,NULL),(7902,5149,'AP','6142641084',0,'2013-12-25 23:02:45',NULL,NULL),(9825,6427,'AP','2252522597',0,'2013-12-26 00:49:04',NULL,NULL),(11194,7278,'TE','9154223551',0,'2013-12-26 02:02:38',NULL,NULL),(24449,15784,'TE','9712852829',0,'2014-01-03 02:02:15',NULL,NULL),(32691,21382,'AP','4407816057',0,'2014-02-04 21:00:54',NULL,NULL),(34905,22904,'TE','4195836021',0,'2014-02-11 21:02:43',NULL,NULL),(35237,23140,'EM','conniealberico@yahoo.com',0,'2014-02-12 21:31:36',NULL,NULL),(35597,23409,'EM','s.jaworski@yahoo.com',0,'2014-02-13 22:01:15',NULL,NULL),(38224,25233,'TE','3306737515',0,'2014-02-21 22:01:03',NULL,NULL),(38688,25568,'TE','2169218081',0,'2014-02-26 08:00:28',NULL,NULL),(40377,26802,'TE','5132215253',0,'2014-03-01 21:00:23',NULL,NULL),(42851,28498,'AP','6019429938',0,'2014-03-07 21:31:46',NULL,NULL),(1891,1165,'AP','2259393572',0,'2013-12-25 18:19:02',NULL,NULL),(24300,15700,'TE','4194661928',1,'2014-01-02 04:35:41',NULL,NULL),(4925,3161,'AP','9376725350',0,'2013-12-25 20:31:20',NULL,NULL),(5354,3430,'AP','3373814609',0,'2013-12-25 21:18:54',NULL,NULL),(7400,4814,'TE','5134779652',0,'2013-12-25 22:16:53',NULL,NULL),(9454,6187,'AP','2544338247',0,'2013-12-26 00:30:14',NULL,NULL),(5552,3545,'EM','advancecollisioninc@gmail.com',0,'2013-12-25 21:21:56',NULL,NULL),(11315,7373,'AP','5132829856',0,'2013-12-26 02:15:43',NULL,NULL),(2706,1644,'TE','4098426579',0,'2013-12-25 18:53:10',NULL,NULL),(2227,1368,'EM','andrewmounir@hotmail.com',0,'2013-12-25 18:45:42',NULL,NULL),(13698,8929,'EM','rickserpette@gmail.com',0,'2013-12-26 04:03:00',NULL,NULL),(5782,3704,'TE','7404382237',0,'2013-12-25 21:32:03',NULL,NULL),(5864,3763,'TE','3308150052',0,'2013-12-25 21:33:29',NULL,NULL),(23067,14877,'AP','9727571651',0,'2013-12-30 00:00:24',NULL,NULL),(26530,17068,'TE','2143742122',0,'2014-01-13 02:21:15',NULL,NULL),(35250,23151,'TE','5138454278',0,'2014-02-12 21:31:42',NULL,NULL),(35286,23174,'EM','krystlecook07@gmail.com',0,'2014-02-12 21:31:55',NULL,NULL),(36823,24252,'EM','jcg420@aol.com',0,'2014-02-17 19:00:03',NULL,NULL),(39598,26196,'TE','3303297070',0,'2014-02-28 06:30:46',NULL,NULL),(42623,28355,'AP','9038188285',0,'2014-03-07 21:30:25',NULL,NULL),(217,131,'TE','2165137732',0,'2013-12-25 17:18:29',NULL,NULL),(25317,16327,'TE','5047237439',0,'2014-01-07 04:01:52',NULL,NULL),(11224,7301,'EM','veronicafoster@yahoo.com',0,'2013-12-26 02:03:09',NULL,NULL),(10713,6964,'AP','8165004878',0,'2013-12-26 01:47:21',NULL,NULL),(10560,6875,'TE','5138501811',0,'2013-12-26 01:32:06',NULL,NULL),(21161,13611,'TE','5135934523',0,'2013-12-26 13:05:37',NULL,NULL),(21602,13902,'AP','4195099304',0,'2013-12-26 13:13:43',NULL,NULL),(8970,5882,'TE','4407854412',0,'2013-12-25 23:49:26',NULL,NULL),(2657,1613,'AP','8302991256',0,'2013-12-25 18:52:23',NULL,NULL),(1413,861,'EM','lmberry@neo.rr.com',0,'2013-12-25 18:07:12',NULL,NULL),(26102,16809,'AP','8632322183',0,'2014-01-13 02:18:15',NULL,NULL),(27086,17420,'TE','3306998834',0,'2014-01-13 03:00:27',NULL,NULL),(30687,19934,'BN','4194968352',0,'2014-01-24 21:01:11',NULL,NULL),(32367,21147,'EM','jvalenzuelaios@gmail.com',0,'2014-02-03 21:00:26',NULL,NULL),(34467,22615,'EM','brucele770@gmail.com',0,'2014-02-11 21:00:07',NULL,NULL),(35634,23433,'BN','8064418177',0,'2014-02-13 22:01:28',NULL,NULL),(40877,27160,'AP','8066202740',0,'2014-03-03 21:30:59',NULL,NULL),(42188,28025,'TE','7407655215',0,'2014-03-06 21:01:23',NULL,NULL),(1650,1013,'TE','5042356923',0,'2013-12-25 18:15:03',NULL,NULL),(24447,15783,'TE','9366974963',0,'2014-01-03 02:02:12',NULL,NULL),(23967,15469,'AP','3303911488',1,'2014-01-02 04:28:52',NULL,NULL),(4095,2611,'EM','olyeller21@aol.com',0,'2013-12-25 19:45:37',NULL,NULL),(3309,2082,'AP','3379623973',0,'2013-12-25 19:16:39',NULL,NULL),(2111,1304,'TE','9039161157',0,'2013-12-25 18:31:16',NULL,NULL),(6105,3930,'EM','miracle_cjf@hotmail.com',0,'2013-12-25 21:37:37',NULL,NULL),(10930,7107,'TE','2145005790',0,'2013-12-26 01:50:55',NULL,NULL),(11615,7553,'TE','3306284116',0,'2013-12-26 02:33:18',NULL,NULL),(13764,8970,'AP','8122491521',0,'2013-12-26 04:04:05',NULL,NULL),(14510,9482,'TE','7404380914',0,'2013-12-26 04:34:40',NULL,NULL),(21570,13870,'AP','3308079383',0,'2013-12-26 13:13:02',NULL,NULL),(1887,1163,'EM','marieharney@ymail.com',0,'2013-12-25 18:18:58',NULL,NULL),(26325,16947,'EM','darleneharveston22@yahoo.com',0,'2014-01-13 02:19:58',NULL,NULL),(27538,17746,'AP','3304735710',0,'2014-01-14 01:33:25',NULL,NULL),(27817,17927,'TE','9032680537',0,'2014-01-15 02:06:33',NULL,NULL),(27893,17974,'AP','3306671611',0,'2014-01-15 02:06:50',NULL,NULL),(28146,18144,'TE','9852646557',0,'2014-01-15 02:07:48',NULL,NULL),(28928,18676,'TE','9155911344',0,'2014-01-17 03:35:19',NULL,NULL),(28946,18686,'AP','5045631875',0,'2014-01-17 03:35:22',NULL,NULL),(29251,18892,'AP','4405967814',0,'2014-01-17 03:36:32',NULL,NULL),(31160,20292,'AP','3183080718',0,'2014-01-28 21:00:37',NULL,NULL),(32420,21183,'EM','SHENIKALOFTON46@GMAIL.COM',0,'2014-02-03 21:00:44',NULL,NULL),(32651,21355,'EM','fas815@yahoo.com',0,'2014-02-04 21:00:40',NULL,NULL),(39207,25929,'EM','ROBERTO_ACC@HOTMAIL.COM',0,'2014-02-26 21:01:25',NULL,NULL),(39343,26025,'TE','7692305390',0,'2014-02-26 21:02:18',NULL,NULL),(153,92,'AP','3616589033',0,'2013-12-25 17:17:28',NULL,NULL),(22910,14785,'TE','3308812064',1,'2013-12-29 11:13:19',NULL,NULL),(13805,8998,'AP','3303470983',0,'2013-12-26 04:04:48',NULL,NULL),(12234,7997,'TE','4409759746',0,'2013-12-26 03:08:18',NULL,NULL),(1177,722,'AP','8304882729',0,'2013-12-25 18:03:30',NULL,NULL),(29920,19363,'EM','Zjohnson697@hotmail.com',1,'2014-01-22 03:22:32',NULL,NULL),(31614,20621,'TE','2256447155',0,'2014-01-30 21:00:24',NULL,NULL),(35643,23437,'AP','9569407506',0,'2014-02-13 22:01:30',NULL,NULL),(36725,24182,'AP','3304739345',0,'2014-02-16 19:00:08',NULL,NULL),(39124,25879,'TE','3373972293',0,'2014-02-26 21:00:56',NULL,NULL),(41082,27289,'AP','2542661941',0,'2014-03-04 21:00:27',NULL,NULL),(41379,27489,'TE','3306655061',0,'2014-03-04 21:02:22',NULL,NULL),(42273,28074,'TE','5024087982',0,'2014-03-06 21:01:53',NULL,NULL),(43267,28746,'AP','4097909077',0,'2014-03-09 21:00:13',NULL,NULL),(77,47,'AP','6013950622',0,'2013-12-25 17:16:16',NULL,NULL),(26049,16780,'EM','brent_franz@yahoo.com',0,'2014-01-08 18:25:05',NULL,NULL),(25813,16641,'TE','5135084648',0,'2014-01-08 18:24:17',NULL,NULL),(25712,16574,'AP','5707804711',1,'2014-01-07 10:23:28',NULL,NULL),(25507,16449,'TE','6628434891',0,'2014-01-07 04:05:20',NULL,NULL),(9949,6510,'TE','3306786168',0,'2013-12-26 00:51:07',NULL,NULL),(7084,4627,'TE','6015068925',0,'2013-12-25 22:06:25',NULL,NULL),(11669,7597,'AP','9547890601',0,'2013-12-26 02:45:17',NULL,NULL),(13902,9063,'TE','9402321948',0,'2013-12-26 04:06:24',NULL,NULL),(4984,3200,'EM','visceralreaction@gmail.com',0,'2013-12-25 20:45:09',NULL,NULL),(5741,3680,'TE','3306072315',0,'2013-12-25 21:31:26',NULL,NULL),(21162,13612,'TE','5136758350',0,'2013-12-26 13:05:39',NULL,NULL),(22606,14578,'TE','2252766306',0,'2013-12-28 03:35:46',NULL,NULL),(6546,4231,'AP','2817857362',0,'2013-12-25 21:50:43',NULL,NULL),(24547,15833,'TE','9372748844',0,'2014-01-03 02:03:55',NULL,NULL),(24579,15854,'AP','3304666406',0,'2014-01-03 02:04:31',NULL,NULL),(26265,16903,'EM','donnahuber307@yahoo.com',0,'2014-01-13 02:19:34',NULL,NULL),(26743,17200,'TE','3306993279',0,'2014-01-13 02:22:24',NULL,NULL),(26785,17231,'AP','6019413219',0,'2014-01-13 02:22:40',NULL,NULL),(30559,19829,'TE','2103926993',0,'2014-01-24 21:00:18',NULL,NULL),(33995,22299,'TE','3308543063',0,'2014-02-10 11:00:35',NULL,NULL),(4214,2691,'EM','SUMOINVESTMENT@GMAIL.COM',0,'2013-12-25 19:47:33',NULL,NULL),(14238,9315,'EM','auldshome@ymail.com',0,'2013-12-26 04:30:22',NULL,NULL),(5648,3626,'TE','9376533254',0,'2013-12-25 21:23:47',NULL,NULL),(6084,3915,'AP','8327638128',0,'2013-12-25 21:37:14',NULL,NULL),(21915,14118,'TE','5139321147',0,'2013-12-27 02:02:03',NULL,NULL),(7664,4989,'AP','5132232603',0,'2013-12-25 22:46:55',NULL,NULL),(13728,8948,'TE','5136596814',0,'2013-12-26 04:03:30',NULL,NULL),(7743,5053,'TE','9406311450',0,'2013-12-25 23:00:15',NULL,NULL),(7939,5178,'TE','5133073268',0,'2013-12-25 23:03:29',NULL,NULL),(10099,6598,'TE','6018077777',0,'2013-12-26 00:53:28',NULL,NULL),(10959,7122,'EM','eray_bernard@yahoo.com',0,'2013-12-26 01:51:22',NULL,NULL),(29273,18907,'TE','6013643608',0,'2014-01-17 03:36:39',NULL,NULL),(29698,19200,'EM','dejablue88@hotmail.com',0,'2014-01-21 08:46:16',NULL,NULL),(29976,19396,'EM','marycegelski100@hotmail.com',1,'2014-01-22 03:22:51',NULL,NULL),(32849,21498,'EM','maithao171@yahoo.com',0,'2014-02-04 21:01:51',NULL,NULL),(34450,22602,'TE','4193188787',0,'2014-02-10 21:32:15',NULL,NULL),(34681,22741,'AP','5043121561',0,'2014-02-11 21:01:20',NULL,NULL),(37821,24957,'TE','3184508120',0,'2014-02-20 22:00:16',NULL,NULL),(39184,25916,'AP','9033409870',0,'2014-02-26 21:01:18',NULL,NULL),(41040,27266,'TE','9852317339',0,'2014-03-04 21:00:13',NULL,NULL),(1203,732,'AP','2813844378',0,'2013-12-25 18:03:50',NULL,NULL),(24288,15693,'AP','4193508629',1,'2014-01-02 04:35:27',NULL,NULL),(21833,14066,'TE','5132911269',0,'2013-12-27 02:00:42',NULL,NULL),(5500,3518,'TE','4199670351',0,'2013-12-25 21:21:11',NULL,NULL),(14650,9583,'TE','7403815419',0,'2013-12-26 04:36:57',NULL,NULL),(13960,9100,'AP','5133904399',0,'2013-12-26 04:07:22',NULL,NULL),(12337,8069,'AP','4199738283',0,'2013-12-26 03:10:10',NULL,NULL),(2565,1565,'EM','fenton_rebecca@hotmail.com',0,'2013-12-25 18:51:02',NULL,NULL),(8841,5791,'EM','nlange@neo.rr.com',0,'2013-12-25 23:47:16',NULL,NULL),(24973,16093,'EM','pastortoussaint@aol.com',0,'2014-01-04 02:04:31',NULL,NULL),(31078,20220,'AP','5132594238',0,'2014-01-27 21:01:44',NULL,NULL),(34210,22436,'TE','9792530889',0,'2014-02-10 21:30:39',NULL,NULL),(35534,23369,'EM','tiger_l2@yahoo.com',0,'2014-02-13 22:00:52',NULL,NULL),(40664,26997,'AP','3308006582',0,'2014-03-03 01:30:00',NULL,NULL),(41289,27433,'AP','9365811978',0,'2014-03-04 21:01:48',NULL,NULL),(42508,28271,'TE','9792245583',0,'2014-03-07 21:00:21',NULL,NULL),(6612,4271,'AP','4192330432',0,'2013-12-25 21:51:46',NULL,NULL),(4733,3030,'TE','4198684659',0,'2013-12-25 20:18:24',NULL,NULL),(5315,3406,'EM','tyrannieap@gmail.com',0,'2013-12-25 21:18:16',NULL,NULL),(7600,4947,'TE','2167382503',0,'2013-12-25 22:45:51',NULL,NULL),(20639,13276,'TE','9035621450',0,'2013-12-26 12:57:02',NULL,NULL),(11631,7566,'EM','ristjohn66@gmail.com',0,'2013-12-26 02:33:38',NULL,NULL),(24720,15947,'EM','grammyj3151@yahoo.com',0,'2014-01-03 02:07:25',NULL,NULL),(26964,17340,'AP','6019468975',0,'2014-01-13 02:24:02',NULL,NULL),(27490,17708,'TE','5046572147',0,'2014-01-14 01:33:08',NULL,NULL),(27751,17891,'AP','4195605464',0,'2014-01-15 02:06:20',NULL,NULL),(28047,18076,'TE','3186356703',0,'2014-01-15 02:07:25',NULL,NULL),(30568,19833,'EM','Gayle.kline@yahoo.com',0,'2014-01-24 21:00:21',NULL,NULL),(31001,20167,'TE','4195149570',0,'2014-01-27 21:01:13',NULL,NULL),(32412,21179,'TE','5135194800',0,'2014-02-03 21:00:42',NULL,NULL),(33941,22273,'TE','3253723135',0,'2014-02-10 11:00:16',NULL,NULL),(34863,22865,'TE','6019545154',0,'2014-02-11 21:02:27',NULL,NULL),(39697,26252,'TE','9155991291',0,'2014-02-28 06:31:09',NULL,NULL),(41602,27660,'TE','3306921148',0,'2014-03-05 21:30:27',NULL,NULL),(42192,28026,'BN','9374759173',0,'2014-03-06 21:01:24',NULL,NULL),(714,444,'AP','9375246777',0,'2013-12-25 17:47:15',NULL,NULL),(22611,14581,'TE','5044871848',0,'2013-12-28 03:35:51',NULL,NULL),(22484,14498,'TE','7135342066',0,'2013-12-28 03:33:42',NULL,NULL),(1959,1213,'AP','9375726338',0,'2013-12-25 18:20:10',NULL,NULL),(20471,13187,'TE','9179756538',0,'2013-12-26 12:54:30',NULL,NULL),(14028,9159,'EM','bakinggirl@hotmail.com',0,'2013-12-26 04:08:41',NULL,NULL),(12210,7978,'AP','3305921276',0,'2013-12-26 03:07:53',NULL,NULL),(9061,5941,'EM','jacobcmills@gmail.com',0,'2013-12-25 23:50:50',NULL,NULL),(2016,1249,'EM','jgsibberson@aol.com',0,'2013-12-25 18:21:10',NULL,NULL),(3126,1948,'EM','mcollins960608@outlook.com',0,'2013-12-25 19:00:53',NULL,NULL),(28579,18423,'TE','5043603094',0,'2014-01-16 08:45:54',NULL,NULL),(29152,18835,'EM','buford1530@gmail.com',0,'2014-01-17 03:36:11',NULL,NULL),(29786,19260,'AP','2255730031',0,'2014-01-21 08:46:49',NULL,NULL),(31574,20592,'EM','reinhardins@windstream.net',0,'2014-01-30 21:00:09',NULL,NULL),(32102,20965,'AP','4693868463',0,'2014-02-01 19:00:11',NULL,NULL),(33191,21734,'EM','mesurfin2000@yahoo.com',0,'2014-02-06 21:00:12',NULL,NULL),(33519,21973,'TE','3304128690',0,'2014-02-07 19:00:32',NULL,NULL),(33553,21996,'TE','5049941495',0,'2014-02-07 19:00:45',NULL,NULL),(34879,22880,'BN','3302563654',0,'2014-02-11 21:02:33',NULL,NULL),(37294,24541,'AP','9152443276',0,'2014-02-20 04:02:29',NULL,NULL),(37565,24737,'TE','5134851656',0,'2014-02-20 04:40:15',NULL,NULL),(38100,25148,'AP','9784950686',0,'2014-02-21 22:00:15',NULL,NULL),(42700,28403,'TE','6142765739',0,'2014-03-07 21:30:52',NULL,NULL),(446,276,'AP','5129702465',0,'2013-12-25 17:30:11',NULL,NULL),(25685,16559,'AP','5042361746',1,'2014-01-07 10:23:00',NULL,NULL),(8906,5830,'AP','9722590007',0,'2013-12-25 23:48:16',NULL,NULL),(3601,2270,'TE','4192580293',0,'2013-12-25 19:30:22',NULL,NULL),(2297,1407,'AP','5042754965',0,'2013-12-25 18:46:48',NULL,NULL),(6606,4266,'AP','5672041369',0,'2013-12-25 21:51:39',NULL,NULL),(6913,4501,'AP','9086729147',0,'2013-12-25 22:03:23',NULL,NULL),(26344,16956,'EM','samarajenkins@yahoo.com',0,'2014-01-13 02:20:04',NULL,NULL),(32759,21431,'TE','9033314871',0,'2014-02-04 21:01:18',NULL,NULL),(35616,23421,'TE','8179170171',0,'2014-02-13 22:01:22',NULL,NULL),(38937,25743,'TE','5132938757',0,'2014-02-26 09:30:41',NULL,NULL),(40777,27100,'AP','3306344893',0,'2014-03-03 21:30:21',NULL,NULL),(42869,28509,'EM','bbooth12324@gmail.com',0,'2014-03-07 21:31:53',NULL,NULL),(43940,29148,'TE','5139216376',0,'2014-03-10 21:02:47',NULL,NULL),(1375,840,'TE','9376549005',0,'2013-12-25 18:06:35',NULL,NULL),(25826,16650,'EM','hcsopb66@yahoo.com',0,'2014-01-08 18:24:20',NULL,NULL),(7789,5085,'AP','8063191174',0,'2013-12-25 23:01:03',NULL,NULL),(4448,2835,'TE','5047017898',0,'2013-12-25 20:00:52',NULL,NULL),(3225,2028,'TE','2165519002',0,'2013-12-25 19:15:17',NULL,NULL),(21764,14019,'EM','dean.cobb1973@att.net',0,'2013-12-26 13:16:35',NULL,NULL),(22402,14447,'TE','5042920580',0,'2013-12-28 03:32:23',NULL,NULL),(5615,3595,'EM','wch@fuse.net',0,'2013-12-25 21:23:07',NULL,NULL),(7384,4804,'TE','3185279761',0,'2013-12-25 22:16:36',NULL,NULL),(5644,3618,'AP','9374781979',0,'2013-12-25 21:23:39',NULL,NULL),(22988,14828,'EM','leannabrtltt@sbcglobal.net',1,'2013-12-29 11:14:29',NULL,NULL),(22568,14553,'TE','3308829460',0,'2013-12-28 03:35:07',NULL,NULL),(20905,13445,'AP','9377460798',0,'2013-12-26 13:01:20',NULL,NULL),(20266,13062,'TE','6148827609',0,'2013-12-26 12:51:05',NULL,NULL),(8920,5839,'TE','9562300201',0,'2013-12-25 23:48:31',NULL,NULL),(13961,9101,'TE','5133242999',0,'2013-12-26 04:07:23',NULL,NULL),(13540,8829,'AP','9564593908',0,'2013-12-26 04:00:29',NULL,NULL),(24194,15631,'AP','5042373821',1,'2014-01-02 04:33:28',NULL,NULL),(27796,17916,'TE','3614929587',0,'2014-01-15 02:06:29',NULL,NULL),(28205,18179,'TE','4192631332',0,'2014-01-15 02:08:00',NULL,NULL),(31828,20780,'TE','9152438579',0,'2014-01-31 21:00:09',NULL,NULL),(35635,23434,'TE','9562437837',0,'2014-02-13 22:01:28',NULL,NULL),(36051,23714,'TE','3306173153',0,'2014-02-14 21:30:48',NULL,NULL),(37667,24833,'AP','6019419363',0,'2014-02-20 04:52:47',NULL,NULL),(41834,27814,'AP','3302172798',0,'2014-03-05 21:31:52',NULL,NULL),(42946,28553,'TE','9377678444',0,'2014-03-07 21:32:22',NULL,NULL),(4470,2847,'TE','8324430906',0,'2013-12-25 20:01:14',NULL,NULL),(6253,4032,'TE','9374292995',0,'2013-12-25 21:45:56',NULL,NULL),(10633,6917,'TE','2166780731',0,'2013-12-26 01:46:06',NULL,NULL),(20329,13098,'TE','9376487985',0,'2013-12-26 12:52:06',NULL,NULL),(25273,16294,'TE','2253050972',0,'2014-01-07 04:00:58',NULL,NULL),(25945,16714,'TE','8324993055',0,'2014-01-08 18:24:44',NULL,NULL),(29800,19274,'TE','5672087736',0,'2014-01-21 08:46:56',NULL,NULL),(29942,19376,'EM','andrew@endusergroup.com',1,'2014-01-22 03:22:39',NULL,NULL),(30936,20117,'EM','bkd914@yahoo.com',0,'2014-01-27 21:00:44',NULL,NULL),(31829,20780,'AP','9152438579',0,'2014-01-31 21:00:09',NULL,NULL),(32940,21559,'BN','6144037758',0,'2014-02-05 21:30:18',NULL,NULL),(35265,23160,'TE','8323664506',0,'2014-02-12 21:31:46',NULL,NULL),(35309,23195,'EM','lisa@ljwriting.com',0,'2014-02-12 21:32:06',NULL,NULL),(39836,26348,'TE','4409734117',0,'2014-02-28 06:31:46',NULL,NULL),(182,107,'AP','8326865251',0,'2013-12-25 17:17:53',NULL,NULL),(24251,15671,'TE','4197389407',1,'2014-01-02 04:34:42',NULL,NULL),(9857,6445,'TE','4195759110',0,'2013-12-26 00:49:33',NULL,NULL),(6945,4526,'AP','9566472563',0,'2013-12-25 22:03:57',NULL,NULL),(5423,3470,'EM','bebout@columbus.rr.com',0,'2013-12-25 21:19:57',NULL,NULL),(29503,19071,'AP','2259937018',0,'2014-01-21 08:44:20',NULL,NULL),(35945,23650,'AP','4694717041',0,'2014-02-14 21:30:13',NULL,NULL),(42655,28378,'EM','ww4508@hotmail.com',0,'2014-03-07 21:30:37',NULL,NULL),(43088,28644,'TE','6626302724',0,'2014-03-08 21:30:34',NULL,NULL),(43278,28754,'TE','9157750052',0,'2014-03-09 21:00:18',NULL,NULL),(203,124,'TE','5132489168',0,'2013-12-25 17:18:17',NULL,NULL),(24834,16018,'TE','5042109533',0,'2014-01-04 02:02:04',NULL,NULL),(24573,15851,'TE','9373057874',0,'2014-01-03 02:04:25',NULL,NULL),(6574,4243,'AP','5125852017',0,'2013-12-25 21:51:06',NULL,NULL),(8983,5890,'EM','fordmanmax@yahoo.com',0,'2013-12-25 23:49:36',NULL,NULL),(1317,804,'TE','9797744470',0,'2013-12-25 18:05:39',NULL,NULL),(22075,14218,'EM','bigchunties@yahoo.com',0,'2013-12-27 02:04:39',NULL,NULL),(5270,3383,'EM','kendragoolsby@hotmail.com',0,'2013-12-25 21:17:35',NULL,NULL),(26856,17284,'TE','5122171141',0,'2014-01-13 02:23:27',NULL,NULL),(31208,20322,'TE','9158868805',0,'2014-01-28 21:00:56',NULL,NULL),(33180,21729,'AP','3619476339',0,'2014-02-06 21:00:08',NULL,NULL),(33450,21911,'TE','9378765015',0,'2014-02-06 21:01:54',NULL,NULL),(39745,26286,'TE','3375662201',0,'2014-02-28 06:31:22',NULL,NULL),(40583,26934,'AP','4403202491',0,'2014-03-03 01:00:21',NULL,NULL),(41005,27245,'TE','9375440261',0,'2014-03-03 21:31:49',NULL,NULL),(43158,28683,'TE','4095948390',0,'2014-03-08 21:30:58',NULL,NULL),(43621,28957,'TE','3373239216',0,'2014-03-10 21:00:54',NULL,NULL),(43952,29155,'AP','4193456911',0,'2014-03-10 21:02:51',NULL,NULL),(3799,2415,'AP','8592507501',0,'2013-12-25 19:33:50',NULL,NULL),(5404,3457,'EM','loribaldwinhall@gmail.com',0,'2013-12-25 21:19:41',NULL,NULL),(24198,15633,'TE','2252472791',1,'2014-01-02 04:33:33',NULL,NULL),(24427,15770,'TE','9158863057',0,'2014-01-03 02:01:47',NULL,NULL),(4558,2900,'TE','3303883414',0,'2013-12-25 20:15:21',NULL,NULL),(7036,4594,'EM','nbabyak@hotmail.com',0,'2013-12-25 22:05:33',NULL,NULL),(10247,6698,'AP','5134014181',0,'2013-12-26 01:01:49',NULL,NULL),(11519,7496,'TE','7404955842',0,'2013-12-26 02:31:44',NULL,NULL),(11186,7274,'TE','2108600102',0,'2013-12-26 02:02:30',NULL,NULL),(10349,6746,'AP','4403717126',0,'2013-12-26 01:15:56',NULL,NULL),(24727,15952,'TE','2405388660',0,'2014-01-04 02:00:08',NULL,NULL),(25873,16674,'EM','brent_franz@yahoo.com',0,'2014-01-08 18:24:30',NULL,NULL),(28001,18048,'AP','6016248509',0,'2014-01-15 02:07:15',NULL,NULL),(30328,19648,'TE','7408142497',0,'2014-01-23 21:00:18',NULL,NULL),(35663,23456,'TE','2143348258',0,'2014-02-13 22:01:40',NULL,NULL),(37752,24910,'AP','6145166443',0,'2014-02-20 21:30:07',NULL,NULL),(38395,25366,'TE','5134329401',0,'2014-02-25 21:30:39',NULL,NULL),(40123,26608,'TE','6023292709',0,'2014-02-28 21:30:45',NULL,NULL),(3809,2426,'TE','4192300466',0,'2013-12-25 19:34:02',NULL,NULL),(23825,15371,'TE','6014533604',1,'2014-01-02 04:25:06',NULL,NULL),(4384,2794,'EM','lighthousejilly@aol.com',0,'2013-12-25 19:50:14',NULL,NULL),(12167,7949,'TE','5043286457',0,'2013-12-26 03:07:06',NULL,NULL),(7559,4921,'EM','dcreates@zoominternet.net',0,'2013-12-25 22:45:11',NULL,NULL),(10088,6591,'AP','3614430707',0,'2013-12-26 00:53:17',NULL,NULL),(7755,5063,'AP','9034013200',0,'2013-12-25 23:00:30',NULL,NULL),(25709,16572,'AP','9372323105',1,'2014-01-07 10:23:24',NULL,NULL),(26675,17161,'TE','3185039399',0,'2014-01-13 02:22:02',NULL,NULL),(27096,17427,'TE','5138967807',0,'2014-01-13 03:00:30',NULL,NULL),(28714,18528,'AP','5132891812',0,'2014-01-16 08:46:42',NULL,NULL),(34181,22415,'TE','5043614224',0,'2014-02-10 21:30:28',NULL,NULL),(41910,27866,'TE','5136521150',0,'2014-03-05 21:32:22',NULL,NULL),(42898,28529,'AP','3184185087',0,'2014-03-07 21:32:06',NULL,NULL),(43414,28830,'TE','4192867822',0,'2014-03-09 21:01:06',NULL,NULL),(43732,29032,'EM','mag@ctcn.net',0,'2014-03-10 21:01:36',NULL,NULL),(865,540,'TE','3307779646',0,'2013-12-25 17:49:41',NULL,NULL),(6137,3950,'TE','4193413302',0,'2013-12-25 21:38:09',NULL,NULL),(21654,13935,'EM','azaboro02@yahoo.com',0,'2013-12-26 13:14:37',NULL,NULL),(21012,13518,'EM','davidmichaelhyde@gmail.com',0,'2013-12-26 13:03:08',NULL,NULL),(7595,4944,'EM','aletaarora@yahoo.com',0,'2013-12-25 22:45:46',NULL,NULL),(11485,7469,'TE','5137929523',0,'2013-12-26 02:31:09',NULL,NULL),(8169,5345,'TE','3307538604',0,'2013-12-25 23:07:28',NULL,NULL),(28061,18087,'TE','2256152842',0,'2014-01-15 02:07:29',NULL,NULL),(29807,19283,'TE','4194475074',0,'2014-01-21 08:47:01',NULL,NULL),(39998,26489,'EM','tressturner@gmail.com',0,'2014-02-28 21:00:09',NULL,NULL),(40721,27063,'TE','3372510003',0,'2014-03-03 21:30:00',NULL,NULL),(6552,4234,'AP','2147141280',0,'2013-12-25 21:50:48',NULL,NULL),(22162,14274,'AP','6015025961',0,'2013-12-27 02:06:11',NULL,NULL),(4349,2775,'TE','6018135548',0,'2013-12-25 19:49:39',NULL,NULL);
INSERT INTO `EdiParticipantContact` VALUES (11125,7233,'TE','4193442648',0,'2013-12-26 02:01:27',NULL,NULL),(25268,16291,'EM','mabrugger@hotmail.com',0,'2014-01-07 04:00:52',NULL,NULL),(25870,16673,'EM','engyehabahmed@gmail.com',0,'2014-01-08 18:24:29',NULL,NULL),(26260,16900,'AP','7402740115',0,'2014-01-13 02:19:32',NULL,NULL),(28107,18115,'TE','2165700093',0,'2014-01-15 02:07:38',NULL,NULL),(28328,18256,'EM','mrfinch11@gmail.com',0,'2014-01-16 08:44:34',NULL,NULL),(29109,18798,'AP','2162252776',0,'2014-01-17 03:35:58',NULL,NULL),(37506,24697,'TE','9567401351',0,'2014-02-20 04:33:40',NULL,NULL),(39515,26138,'EM','cbsouthendgirl@gmail.com',0,'2014-02-28 06:30:24',NULL,NULL),(40422,26834,'TE','3304540275',0,'2014-03-01 21:00:41',NULL,NULL),(41939,27881,'TE','4193716251',0,'2014-03-05 21:32:33',NULL,NULL),(42074,27957,'AP','2252647347',0,'2014-03-06 21:00:42',NULL,NULL),(620,381,'AP','9797774782',0,'2013-12-25 17:45:43',NULL,NULL),(845,524,'TE','5132250528',0,'2013-12-25 17:49:17',NULL,NULL),(22983,14825,'TE','4197376427',1,'2013-12-29 11:14:25',NULL,NULL),(22836,14730,'TE','3309297644',1,'2013-12-29 11:09:48',NULL,NULL),(3946,2506,'EM','rpevey@aol.com',0,'2013-12-25 19:36:09',NULL,NULL),(20870,13418,'TE','4196043036',0,'2013-12-26 13:00:45',NULL,NULL),(4206,2689,'TE','3612186281',0,'2013-12-25 19:47:27',NULL,NULL),(8998,5906,'TE','4844106286',0,'2013-12-25 23:49:54',NULL,NULL),(8190,5359,'AP','3306030562',0,'2013-12-25 23:07:49',NULL,NULL),(7530,4906,'AP','2256146816',0,'2013-12-25 22:31:57',NULL,NULL),(25017,16121,'EM','scheramie@comcast.net',0,'2014-01-04 02:05:25',NULL,NULL),(27046,17393,'TE','5133153454',0,'2014-01-13 03:00:12',NULL,NULL),(31825,20779,'TE','8066705407',0,'2014-01-31 21:00:08',NULL,NULL),(34613,22695,'EM','curtisbell72@yahoo.com',0,'2014-02-11 21:00:55',NULL,NULL),(37479,24679,'AP','9402229901',0,'2014-02-20 04:30:08',NULL,NULL),(39852,26361,'TE','4403181278',0,'2014-02-28 07:00:05',NULL,NULL),(231,141,'TE','3304723123',0,'2013-12-25 17:18:42',NULL,NULL),(7374,4799,'AP','2253015039',0,'2013-12-25 22:16:27',NULL,NULL),(7909,5153,'EM','mlbspnc@aol.com',0,'2013-12-25 23:02:52',NULL,NULL),(7976,5203,'AP','3049935597',0,'2013-12-25 23:04:06',NULL,NULL),(6897,4488,'AP','3303238214',0,'2013-12-25 22:03:05',NULL,NULL),(2418,1474,'EM','gus@bright.net',0,'2013-12-25 18:48:40',NULL,NULL),(2061,1275,'AP','6145991075',0,'2013-12-25 18:30:24',NULL,NULL),(4982,3200,'TE','6148003366',0,'2013-12-25 20:45:08',NULL,NULL),(27866,17955,'EM','gmframe@gmail.com',0,'2014-01-15 02:06:44',NULL,NULL),(33582,22016,'TE','9379253664',0,'2014-02-07 19:00:55',NULL,NULL),(34219,22442,'EM','eosikpa1@aol.com',0,'2014-02-10 21:30:42',NULL,NULL),(37549,24723,'TE','5134851656',0,'2014-02-20 04:38:18',NULL,NULL),(42589,28336,'AP','4093928188',0,'2014-03-07 21:30:14',NULL,NULL),(42672,28386,'AP','3307943247',0,'2014-03-07 21:30:43',NULL,NULL),(916,564,'EM','Aiden.h.huynh@gmail.com',0,'2013-12-25 17:50:26',NULL,NULL),(11622,7559,'TE','4194611776',0,'2013-12-26 02:33:27',NULL,NULL),(10127,6622,'TE','6628405598',0,'2013-12-26 00:54:05',NULL,NULL),(8327,5460,'EM','brandonhoskinson@yahoo.com',0,'2013-12-25 23:10:23',NULL,NULL),(7876,5136,'AP','7138420940',0,'2013-12-25 23:02:22',NULL,NULL),(2215,1361,'EM','cjmorgan54@yahoo.com',0,'2013-12-25 18:45:31',NULL,NULL),(6582,4248,'EM','chrisygina@sbcglobal.net',0,'2013-12-25 21:51:13',NULL,NULL),(27120,17461,'TE','4199694682',0,'2014-01-13 03:00:42',NULL,NULL),(33731,22130,'TE','3302733552',0,'2014-02-08 19:00:43',NULL,NULL),(36206,23832,'EM','1234cjelinek@gmail.com',0,'2014-02-14 21:31:47',NULL,NULL),(36959,24337,'BN','8063925140',0,'2014-02-18 22:00:17',NULL,NULL),(40028,26532,'TE','6146261146',0,'2014-02-28 21:30:03',NULL,NULL),(41314,27446,'EM','mikedropmn@aol.com',0,'2014-03-04 21:01:56',NULL,NULL),(6460,4173,'TE','9376933104',0,'2013-12-25 21:49:17',NULL,NULL),(14214,9301,'AP','4198893581',0,'2013-12-26 04:16:24',NULL,NULL),(13633,8889,'AP','5249794229',0,'2013-12-26 04:01:58',NULL,NULL),(3612,2285,'TE','7343010089',0,'2013-12-25 19:30:37',NULL,NULL),(21626,13918,'TE','4192441559',0,'2013-12-26 13:14:08',NULL,NULL),(2953,1820,'TE','4198196762',0,'2013-12-25 18:57:14',NULL,NULL),(2681,1627,'AP','5124701854',0,'2013-12-25 18:52:44',NULL,NULL),(23148,14922,'EM','alicepetties1954@gmail.com',0,'2013-12-30 00:01:44',NULL,NULL),(23467,15134,'AP','7347885308',0,'2014-01-01 12:05:32',NULL,NULL),(25077,16167,'TE','2258198199',0,'2014-01-05 00:00:08',NULL,NULL),(28320,18253,'AP','8327589468',0,'2014-01-16 08:44:32',NULL,NULL),(28614,18444,'EM','MCMILLMA57@YAHOO.COM',0,'2014-01-16 08:46:05',NULL,NULL),(28709,18526,'TE','8327444902',0,'2014-01-16 08:46:41',NULL,NULL),(30390,19691,'TE','9039388728',0,'2014-01-23 21:00:43',NULL,NULL),(31276,20374,'TE','3372560874',0,'2014-01-29 21:00:07',NULL,NULL),(32644,21353,'TE','3616558371',0,'2014-02-04 21:00:38',NULL,NULL),(34040,22322,'TE','3187246331',0,'2014-02-10 11:00:54',NULL,NULL),(36680,24151,'EM','Jacques.mr@gmail.com',0,'2014-02-15 22:01:57',NULL,NULL),(36693,24159,'TE','4198755859',0,'2014-02-15 22:02:02',NULL,NULL),(39667,26228,'AP','7727776155',0,'2014-02-28 06:31:00',NULL,NULL),(40034,26537,'TE','7404467217',0,'2014-02-28 21:30:06',NULL,NULL),(1144,703,'EM','kathrynnathan3@gmail.com',0,'2013-12-25 18:02:58',NULL,NULL),(9885,6465,'TE','3307533319',0,'2013-12-26 00:50:00',NULL,NULL),(20908,13447,'AP','9372721622',0,'2013-12-26 13:01:22',NULL,NULL),(8805,5767,'EM','stephra@rocketmail.com',0,'2013-12-25 23:46:41',NULL,NULL),(22928,14793,'AP','2169057567',1,'2013-12-29 11:13:34',NULL,NULL),(5414,3467,'TE','2167511949',0,'2013-12-25 21:19:51',NULL,NULL),(23741,15318,'TE','2143925424',1,'2014-01-02 04:23:27',NULL,NULL),(2429,1487,'AP','3306719767',0,'2013-12-25 18:48:56',NULL,NULL),(6099,3927,'EM','lisa.berryman@lhh.com',0,'2013-12-25 21:37:32',NULL,NULL),(27418,17659,'AP','9375157480',0,'2014-01-14 01:32:44',NULL,NULL),(31194,20314,'EM','heartofgold7166@yaho.com',0,'2014-01-28 21:00:51',NULL,NULL),(31389,20457,'EM','drhillmcclary@att.net',0,'2014-01-29 21:00:49',NULL,NULL),(34658,22724,'EM','ravencfoster@cox.net',0,'2014-02-11 21:01:12',NULL,NULL),(36684,24153,'EM','dianemullins72@gmail.com',0,'2014-02-15 22:01:58',NULL,NULL),(36709,24170,'TE','6015664465',0,'2014-02-15 22:02:08',NULL,NULL),(40149,26628,'TE','2145480752',0,'2014-02-28 21:30:56',NULL,NULL),(42193,28027,'TE','3303516822',0,'2014-03-06 21:01:25',NULL,NULL),(43826,29090,'TE','2102901428',0,'2014-03-10 21:02:09',NULL,NULL),(1240,754,'AP','6824297848',0,'2013-12-25 18:04:22',NULL,NULL),(14041,9173,'AP','5139678964',0,'2013-12-26 04:09:00',NULL,NULL),(14292,9349,'EM','robinson999@bellsouth.net',0,'2013-12-26 04:31:12',NULL,NULL),(14599,9545,'TE','5134762274',0,'2013-12-26 04:36:08',NULL,NULL),(3632,2299,'TE','3302657162',0,'2013-12-25 19:30:56',NULL,NULL),(3205,2013,'EM','lstubbs@cinci.rr.com',0,'2013-12-25 19:02:34',NULL,NULL),(2507,1537,'EM','nathanj.tandy@gmail.com',0,'2013-12-25 18:50:11',NULL,NULL),(24261,15679,'TE','9377282369',1,'2014-01-02 04:34:55',NULL,NULL),(1670,1025,'AP','3303291872',0,'2013-12-25 18:15:22',NULL,NULL),(24600,15865,'TE','6012970064',0,'2014-01-03 02:04:55',NULL,NULL),(11889,7736,'AP','4198891268',0,'2013-12-26 03:02:09',NULL,NULL),(7951,5187,'AP','4194665242',0,'2013-12-25 23:03:41',NULL,NULL),(9500,6216,'AP','6018628845',0,'2013-12-26 00:31:01',NULL,NULL),(8412,5539,'TE','5133899868',0,'2013-12-25 23:15:46',NULL,NULL),(9025,5921,'TE','2105574133',0,'2013-12-25 23:50:17',NULL,NULL),(25416,16394,'TE','2108836426',0,'2014-01-07 04:03:40',NULL,NULL),(29803,19280,'TE','9373996662',0,'2014-01-21 08:46:59',NULL,NULL),(30362,19670,'AP','3612072671',0,'2014-01-23 21:00:32',NULL,NULL),(31800,20758,'EM','lambertKL2@aol.com',0,'2014-01-30 21:01:33',NULL,NULL),(34532,22653,'TE','2542203913',0,'2014-02-11 21:00:29',NULL,NULL),(36484,24019,'AP','2162469779',0,'2014-02-15 22:00:45',NULL,NULL),(42186,28024,'TE','4405419478',0,'2014-03-06 21:01:23',NULL,NULL),(42396,28159,'TE','4192340182',0,'2014-03-06 21:02:41',NULL,NULL),(6920,4507,'TE','8327442761',0,'2013-12-25 22:03:31',NULL,NULL),(6837,4435,'EM','mhanzel@live.com',0,'2013-12-25 22:02:00',NULL,NULL),(2537,1552,'TE','6625631880',0,'2013-12-25 18:50:39',NULL,NULL),(2654,1612,'AP','9153556568',0,'2013-12-25 18:52:21',NULL,NULL),(23314,15023,'AP','7185640095',0,'2014-01-01 12:02:22',NULL,NULL),(3056,1900,'EM','steve.pack@gmail.com',0,'2013-12-25 18:59:07',NULL,NULL),(3828,2436,'AP','3305242846',0,'2013-12-25 19:34:18',NULL,NULL),(8118,5314,'EM','CHILDOFBARB@HOTMAIL.COM',0,'2013-12-25 23:06:40',NULL,NULL),(10388,6770,'AP','2252769943',0,'2013-12-26 01:16:36',NULL,NULL),(10344,6744,'TE','3309483238',0,'2013-12-26 01:15:52',NULL,NULL),(8839,5786,'EM','Harpshe@sbcglobal.net',0,'2013-12-25 23:47:12',NULL,NULL),(25328,16333,'TE','9859910236',0,'2014-01-07 04:02:02',NULL,NULL),(27321,17595,'AP','2285478735',0,'2014-01-14 01:32:12',NULL,NULL),(27563,17764,'TE','9374834423',0,'2014-01-14 01:33:35',NULL,NULL),(27744,17887,'TE','5133767044',0,'2014-01-15 02:06:18',NULL,NULL),(28830,18611,'AP','4197709347',0,'2014-01-16 08:47:23',NULL,NULL),(32141,20988,'EM','sammshannawi@gmail.com',0,'2014-02-01 19:00:24',NULL,NULL),(32289,21091,'AP','3185184030',0,'2014-02-02 19:00:28',NULL,NULL),(32688,21381,'AP','3302459905',0,'2014-02-04 21:00:53',NULL,NULL),(34398,22564,'TE','4192423522',0,'2014-02-10 21:31:53',NULL,NULL),(35478,23331,'EM','RichardWE13@gmail.com',0,'2014-02-13 22:00:31',NULL,NULL),(38425,25390,'TE','4403270276',0,'2014-02-25 21:30:52',NULL,NULL),(39582,26184,'AP','4199176427',0,'2014-02-28 06:30:42',NULL,NULL),(40079,26579,'AP','9892434880',0,'2014-02-28 21:30:29',NULL,NULL),(40578,26931,'TE','4192225252',0,'2014-03-03 01:00:20',NULL,NULL),(1309,798,'EM','jdanmason@gmail.com',0,'2013-12-25 18:05:29',NULL,NULL),(23481,15143,'TE','5133535732',0,'2014-01-01 12:05:48',NULL,NULL),(4454,2837,'TE','3306054272',0,'2013-12-25 20:00:57',NULL,NULL),(21928,14126,'EM','alittlenutty@hotmail.com',0,'2013-12-27 02:02:16',NULL,NULL),(8997,5905,'EM','glangel007@hotmail.com',0,'2013-12-25 23:49:53',NULL,NULL),(2336,1423,'AP','5043779864',0,'2013-12-25 18:47:19',NULL,NULL),(7642,4976,'TE','4695092588',0,'2013-12-25 22:46:35',NULL,NULL),(14058,9186,'EM','yangren123@yahoo.com',0,'2013-12-26 04:09:19',NULL,NULL),(14002,9141,'TE','3306749312',0,'2013-12-26 04:08:12',NULL,NULL),(9674,6339,'TE','5135018384',0,'2013-12-26 00:46:43',NULL,NULL),(22043,14196,'TE','8062725578',0,'2013-12-27 02:04:08',NULL,NULL),(22577,14561,'TE','3306990893',0,'2013-12-28 03:35:16',NULL,NULL),(23418,15084,'AP','2107876067',0,'2014-01-01 12:04:17',NULL,NULL),(25500,16443,'AP','2283800493',0,'2014-01-07 04:05:10',NULL,NULL),(28062,18088,'TE','9857642882',0,'2014-01-15 02:07:29',NULL,NULL),(32840,21493,'TE','5672240189',0,'2014-02-04 21:01:48',NULL,NULL),(34673,22737,'AP','3373486229',0,'2014-02-11 21:01:18',NULL,NULL),(39772,26299,'EM','r.lanum@yahoo.com',0,'2014-02-28 06:31:28',NULL,NULL),(39972,26465,'TE','3302892620',0,'2014-02-28 07:30:34',NULL,NULL),(40720,27062,'AP','5612679404',0,'2014-03-03 21:30:00',NULL,NULL),(41273,27426,'TE','3189906112',0,'2014-03-04 21:01:43',NULL,NULL),(43010,28601,'AP','5133178448',0,'2014-03-08 21:30:09',NULL,NULL),(1014,624,'TE','3302831201',0,'2013-12-25 18:00:56',NULL,NULL),(8010,5229,'TE','3308829702',0,'2013-12-25 23:04:44',NULL,NULL),(11990,7811,'TE','2818891600',0,'2013-12-26 03:03:57',NULL,NULL),(7682,5005,'AP','6143061611',0,'2013-12-25 22:47:14',NULL,NULL),(6293,4055,'TE','4409922550',0,'2013-12-25 21:46:32',NULL,NULL),(6716,4365,'AP','5109189929',0,'2013-12-25 22:00:09',NULL,NULL),(24561,15843,'EM','tracker878@gmail.com',0,'2014-01-03 02:04:13',NULL,NULL),(25719,16577,'AP','4195916614',1,'2014-01-07 10:23:34',NULL,NULL),(27458,17690,'TE','3372460976',0,'2014-01-14 01:32:59',NULL,NULL),(27581,17776,'EM','clayfloors@yahoo.com',0,'2014-01-14 01:33:41',NULL,NULL),(28776,18567,'TE','3307846310',0,'2014-01-16 08:47:03',NULL,NULL),(28962,18694,'TE','5045631875',0,'2014-01-17 03:35:26',NULL,NULL),(30165,19544,'AP','6015193481',0,'2014-01-23 03:02:26',NULL,NULL),(30624,19875,'TE','4192882456',0,'2014-01-24 21:00:43',NULL,NULL),(34489,22627,'TE','3046857757',0,'2014-02-11 21:00:15',NULL,NULL),(37049,24397,'TE','7403610928',0,'2014-02-18 22:00:52',NULL,NULL),(2214,1361,'AP','9033662669',0,'2013-12-25 18:45:30',NULL,NULL),(2370,1439,'AP','6622075489',0,'2013-12-25 18:47:49',NULL,NULL),(10541,6865,'EM','garyasolomon@gmail.com',0,'2013-12-26 01:31:48',NULL,NULL),(6874,4459,'TE','5132595194',0,'2013-12-25 22:02:36',NULL,NULL),(6188,3987,'EM','gls49@aol.com',0,'2013-12-25 21:39:00',NULL,NULL),(6202,3995,'EM','capheresy@gmail.com',0,'2013-12-25 21:39:15',NULL,NULL),(9198,6019,'TE','4408620050',0,'2013-12-26 00:00:49',NULL,NULL),(23309,15019,'AP','5133799887',0,'2014-01-01 12:02:16',NULL,NULL),(23545,15196,'TE','6625498262',0,'2014-01-01 12:07:16',NULL,NULL),(24918,16062,'EM','Lhemmig@bex.net',0,'2014-01-04 02:03:33',NULL,NULL),(27464,17693,'TE','5042756480',0,'2014-01-14 01:33:00',NULL,NULL),(27558,17761,'TE','5135532232',0,'2014-01-14 01:33:33',NULL,NULL),(41332,27456,'AP','3309030870',0,'2014-03-04 21:02:03',NULL,NULL),(42696,28401,'EM','rquinn19@gmail.com',0,'2014-03-07 21:30:51',NULL,NULL),(9585,6276,'TE','5135090387',0,'2013-12-26 00:45:14',NULL,NULL),(14488,9464,'TE','4196833878',0,'2013-12-26 04:34:17',NULL,NULL),(8475,5575,'TE','9376535729',0,'2013-12-25 23:16:48',NULL,NULL),(8470,5573,'AP','3048120595',0,'2013-12-25 23:16:44',NULL,NULL),(11450,7446,'TE','5137229228',0,'2013-12-26 02:30:35',NULL,NULL),(4415,2813,'EM','chris7hoo@yahoo.com',0,'2013-12-25 20:00:19',NULL,NULL),(10606,6902,'AP','5044586058',0,'2013-12-26 01:45:40',NULL,NULL),(5948,3818,'TE','7408568369',0,'2013-12-25 21:34:52',NULL,NULL),(22160,14273,'EM','crystal.harris@msdh.state.ms.us',0,'2013-12-27 02:06:09',NULL,NULL),(24481,15797,'TE','9858470999',0,'2014-01-03 02:02:43',NULL,NULL),(28813,18598,'TE','9013599512',0,'2014-01-16 08:47:17',NULL,NULL),(31449,20498,'TE','3372518040',0,'2014-01-29 21:01:11',NULL,NULL),(34801,22829,'AP','3304663749',0,'2014-02-11 21:02:06',NULL,NULL),(38954,25755,'AP','4406676183',0,'2014-02-26 09:30:48',NULL,NULL),(40020,26518,'TE','4192039514',0,'2014-02-28 21:00:23',NULL,NULL),(41086,27291,'TE','8069282224',0,'2014-03-04 21:00:29',NULL,NULL),(43629,28960,'EM','keithburstein@yahoo.com',0,'2014-03-10 21:00:56',NULL,NULL),(9020,5919,'AP','9728801588',0,'2013-12-25 23:50:13',NULL,NULL),(21718,13991,'AP','4196544411',0,'2013-12-26 13:15:48',NULL,NULL),(14683,9609,'TE','3304143127',0,'2013-12-26 04:37:35',NULL,NULL),(1052,649,'TE','7403866115',0,'2013-12-25 18:01:33',NULL,NULL),(6405,4133,'TE','4405522498',0,'2013-12-25 21:48:27',NULL,NULL),(3741,2374,'TE','2169910760',0,'2013-12-25 19:32:50',NULL,NULL),(4782,3060,'AP','5042582956',0,'2013-12-25 20:19:09',NULL,NULL),(5756,3688,'AP','3045597892',0,'2013-12-25 21:31:39',NULL,NULL),(22941,14799,'EM','mah712rn@gmail.com',1,'2013-12-29 11:13:43',NULL,NULL),(27411,17655,'TE','7404183875',0,'2014-01-14 01:32:42',NULL,NULL),(31882,20809,'AP','8065440515',0,'2014-01-31 21:00:27',NULL,NULL),(32984,21595,'TE','9378441723',0,'2014-02-05 21:30:30',NULL,NULL),(33733,22135,'TE','4408675961',0,'2014-02-08 19:00:45',NULL,NULL),(35776,23527,'TE','3377949880',0,'2014-02-13 22:02:24',NULL,NULL),(36442,23998,'TE','4192382302',0,'2014-02-15 22:00:31',NULL,NULL),(41734,27749,'EM','debbiegarrene@gmail.com',0,'2014-03-05 21:31:14',NULL,NULL),(5342,3422,'TE','2255459054',0,'2013-12-25 21:18:41',NULL,NULL),(13678,8915,'TE','5133350746',0,'2013-12-26 04:02:42',NULL,NULL),(11545,7514,'AP','2252353046',0,'2013-12-26 02:32:12',NULL,NULL),(10000,6542,'AP','8173004173',0,'2013-12-26 00:51:57',NULL,NULL),(23551,15202,'TE','6018636841',0,'2014-01-01 12:07:26',NULL,NULL),(24808,16005,'TE','9199438950',0,'2014-01-04 02:01:38',NULL,NULL),(26537,17071,'TE','9035833595',0,'2014-01-13 02:21:17',NULL,NULL),(29269,18903,'AP','5672083521',0,'2014-01-17 03:36:37',NULL,NULL),(32556,21289,'TE','2253058414',0,'2014-02-04 21:00:06',NULL,NULL),(33413,21892,'AP','6015663370',0,'2014-02-06 21:01:39',NULL,NULL),(35807,23545,'TE','9855427315',0,'2014-02-13 22:02:35',NULL,NULL),(37402,24632,'TE','9034525671',0,'2014-02-20 04:18:09',NULL,NULL),(37798,24945,'AP','9014810564',0,'2014-02-20 22:00:07',NULL,NULL),(38737,25607,'EM','abdulhaziz786@gmail.com',0,'2014-02-26 08:30:06',NULL,NULL),(39366,26036,'EM','zorness@yahoo.com',0,'2014-02-26 21:02:24',NULL,NULL),(3296,2073,'EM','scottbodie8161@icloud.com',0,'2013-12-25 19:16:26',NULL,NULL),(9349,6121,'AP','9564830763',0,'2013-12-26 00:15:45',NULL,NULL),(21409,13765,'TE','6012185217',0,'2013-12-26 13:10:20',NULL,NULL),(7221,4703,'AP','4194601532',0,'2013-12-25 22:08:30',NULL,NULL),(10361,6755,'TE','3307945774',0,'2013-12-26 01:16:12',NULL,NULL),(14416,9424,'AP','4253191438',0,'2013-12-26 04:33:13',NULL,NULL),(10699,6955,'TE','6148245582',0,'2013-12-26 01:47:09',NULL,NULL),(10508,6842,'AP','7403523714',0,'2013-12-26 01:31:09',NULL,NULL),(22077,14219,'EM','lanitasue1965@gmail.com',0,'2013-12-27 02:04:41',NULL,NULL),(24086,15549,'TE','6019519161',1,'2014-01-02 04:31:13',NULL,NULL),(24742,15964,'AP','6148324456',0,'2014-01-04 02:00:25',NULL,NULL),(32811,21468,'TE','6019775307',0,'2014-02-04 21:01:37',NULL,NULL),(35935,23643,'EM','cat00a@hotmail.com',0,'2014-02-14 21:30:10',NULL,NULL),(35966,23665,'TE','8324210671',0,'2014-02-14 21:30:21',NULL,NULL),(36368,23949,'AP','2145482813',0,'2014-02-15 22:00:03',NULL,NULL),(36844,24262,'TE','5127400079',0,'2014-02-17 19:00:11',NULL,NULL),(38014,25077,'TE','3307808940',0,'2014-02-20 22:01:35',NULL,NULL),(38375,25348,'TE','3186072638',0,'2014-02-25 21:30:30',NULL,NULL),(40063,26563,'AP','5133837129',0,'2014-02-28 21:30:21',NULL,NULL),(42099,27972,'TE','5044850636',0,'2014-03-06 21:00:51',NULL,NULL),(42622,28355,'TE','9038188285',0,'2014-03-07 21:30:25',NULL,NULL),(43205,28711,'EM','bppi99@gmail.com',0,'2014-03-08 21:31:15',NULL,NULL),(842,523,'TE','5132250528',0,'2013-12-25 17:49:16',NULL,NULL),(14260,9327,'AP','5044281160',0,'2013-12-26 04:30:40',NULL,NULL),(13645,8897,'AP','2107815349',0,'2013-12-26 04:02:11',NULL,NULL),(13624,8882,'AP','9036032030',0,'2013-12-26 04:01:49',NULL,NULL),(13604,8867,'EM','baritonebaxter92@gmail.com',0,'2013-12-26 04:01:27',NULL,NULL),(1830,1133,'AP','2252889807',0,'2013-12-25 18:18:07',NULL,NULL),(9117,5973,'AP','5133350683',0,'2013-12-25 23:51:42',NULL,NULL),(8878,5815,'AP','4699512349',0,'2013-12-25 23:47:54',NULL,NULL),(3127,1949,'TE','3308643375',0,'2013-12-25 19:00:55',NULL,NULL),(5671,3644,'TE','3306313464',0,'2013-12-25 21:30:27',NULL,NULL),(9296,6089,'TE','3306783132',0,'2013-12-26 00:02:41',NULL,NULL),(9392,6147,'TE','6145979356',0,'2013-12-26 00:16:26',NULL,NULL),(22347,14410,'EM','darrenololi@gmail.com',0,'2013-12-28 03:31:26',NULL,NULL),(23128,14907,'EM','jacktowncane@aol.com',0,'2013-12-30 00:01:21',NULL,NULL),(23170,14932,'AP','9727426028',0,'2013-12-30 00:02:04',NULL,NULL),(27135,17474,'TE','9035492658',0,'2014-01-13 03:01:08',NULL,NULL),(27770,17904,'AP','8173600815',0,'2014-01-15 02:06:24',NULL,NULL),(30684,19932,'AP','3309904484',0,'2014-01-24 21:01:10',NULL,NULL),(34372,22546,'TE','3184694452',0,'2014-02-10 21:31:42',NULL,NULL),(34916,22910,'EM','Diana29@roadrunner.com',0,'2014-02-11 21:02:48',NULL,NULL),(34935,22926,'AP','5132527432',0,'2014-02-11 21:30:07',NULL,NULL),(39311,26004,'AP','5108758831',0,'2014-02-26 21:02:06',NULL,NULL),(39427,26076,'TE','5138363039',0,'2014-02-26 21:02:47',NULL,NULL),(39557,26172,'TE','6625888310',0,'2014-02-28 06:30:36',NULL,NULL),(42649,28371,'AP','9377253796',0,'2014-03-07 21:30:35',NULL,NULL),(9293,6088,'TE','3306907266',0,'2013-12-26 00:02:39',NULL,NULL),(20817,13380,'TE','2162105663',0,'2013-12-26 12:59:53',NULL,NULL),(3657,2317,'EM','codykwitt@gmail.com',0,'2013-12-25 19:31:20',NULL,NULL),(13542,8830,'TE','9565444768',0,'2013-12-26 04:00:30',NULL,NULL),(12051,7866,'TE','6147492291',0,'2013-12-26 03:05:06',NULL,NULL),(11718,7628,'EM','Lancair62@gmail.com',0,'2013-12-26 02:46:08',NULL,NULL),(8874,5812,'TE','9039106802',0,'2013-12-25 23:47:50',NULL,NULL),(10954,7121,'TE','6013355689',0,'2013-12-26 01:51:19',NULL,NULL),(8485,5581,'AP','9035633096',0,'2013-12-25 23:16:58',NULL,NULL),(6221,4011,'EM','deblaw@fuse.net',0,'2013-12-25 21:45:25',NULL,NULL),(6030,3872,'TE','2253552860',0,'2013-12-25 21:36:13',NULL,NULL),(5625,3602,'EM','BBDCOWELL@AMPLEX.NET',0,'2013-12-25 21:23:18',NULL,NULL),(6962,4540,'EM','Vickespinoza@yahoo.com',0,'2013-12-25 22:04:16',NULL,NULL),(6978,4548,'EM','mrkevind@yahoo.com',0,'2013-12-25 22:04:31',NULL,NULL),(9649,6313,'TE','3302381773',0,'2013-12-26 00:46:14',NULL,NULL),(7492,4878,'TE','9723427208',0,'2013-12-25 22:31:11',NULL,NULL),(22034,14191,'TE','2817964183',0,'2013-12-27 02:03:59',NULL,NULL),(22710,14646,'TE','3612073302',1,'2013-12-29 11:07:36',NULL,NULL),(23433,15099,'TE','6148003610',0,'2014-01-01 12:04:39',NULL,NULL),(27301,17579,'AP','5132500046',0,'2014-01-14 01:32:06',NULL,NULL),(29112,18800,'AP','5132124062',0,'2014-01-17 03:35:59',NULL,NULL),(30295,19626,'TE','6148002084',0,'2014-01-23 21:00:07',NULL,NULL),(30654,19896,'EM','nanny.daycare06@yahoo.com',0,'2014-01-24 21:00:54',NULL,NULL),(30921,20106,'EM','kultured@hotmail.com',0,'2014-01-27 21:00:38',NULL,NULL),(34313,22513,'AP','2146685263',0,'2014-02-10 21:31:20',NULL,NULL),(34365,22540,'TE','5049120813',0,'2014-02-10 21:31:38',NULL,NULL),(35104,23057,'AP','5047232355',0,'2014-02-12 21:30:49',NULL,NULL),(36891,24296,'EM','Tamaratrapnell@yahoo.com',0,'2014-02-18 21:30:17',NULL,NULL),(40150,26628,'AP','2145480752',0,'2014-02-28 21:30:56',NULL,NULL),(41271,27425,'TE','5045537038',0,'2014-03-04 21:01:42',NULL,NULL),(41852,27833,'TE','6145889139',0,'2014-03-05 21:32:02',NULL,NULL),(42127,27985,'TE','3183122851',0,'2014-03-06 21:01:00',NULL,NULL),(42367,28138,'BN','4193740525',0,'2014-03-06 21:02:29',NULL,NULL),(1561,962,'TE','9407049647',0,'2013-12-25 18:09:49',NULL,NULL),(1836,1135,'AP','9852857884',0,'2013-12-25 18:18:11',NULL,NULL),(1961,1214,'AP','9372062505',0,'2013-12-25 18:20:11',NULL,NULL),(11771,7659,'EM','theila.hayes@att.net',0,'2013-12-26 03:00:14',NULL,NULL),(29728,19225,'TE','4194945664',0,'2014-01-21 08:46:29',NULL,NULL),(30773,20006,'AP','4402270369',0,'2014-01-26 19:00:06',NULL,NULL),(32679,21372,'TE','9092616284',0,'2014-02-04 21:00:49',NULL,NULL),(34859,22861,'EM','tigerlinebullies@gmail.com',0,'2014-02-11 21:02:25',NULL,NULL),(35245,23149,'TE','3302963350',0,'2014-02-12 21:31:40',NULL,NULL),(36681,24152,'EM','hdarlene044@gmail.com',0,'2014-02-15 22:01:57',NULL,NULL),(39310,26004,'TE','5108758831',0,'2014-02-26 21:02:05',NULL,NULL),(39733,26280,'TE','8322707444',0,'2014-02-28 06:31:19',NULL,NULL),(42701,28404,'TE','4403524254',0,'2014-03-07 21:30:53',NULL,NULL),(42812,28471,'TE','3302340929',0,'2014-03-07 21:31:31',NULL,NULL),(10275,6710,'TE','3305654223',0,'2013-12-26 01:02:13',NULL,NULL),(20671,13294,'TE','9037828183',0,'2013-12-26 12:57:33',NULL,NULL),(14175,9273,'EM','stover@jbnets.net',0,'2013-12-26 04:15:44',NULL,NULL),(7961,5191,'TE','4409791550',0,'2013-12-25 23:03:48',NULL,NULL),(4699,3006,'TE','5672247050',0,'2013-12-25 20:17:47',NULL,NULL),(2772,1680,'TE','5048106428',0,'2013-12-25 18:54:08',NULL,NULL),(3635,2300,'TE','3304216277',0,'2013-12-25 19:30:59',NULL,NULL),(3363,2113,'EM','dockery.deb@gmail.com',0,'2013-12-25 19:17:31',NULL,NULL),(3140,1959,'TE','8176816774',0,'2013-12-25 19:01:10',NULL,NULL),(22524,14523,'AP','3614428822',0,'2013-12-28 03:34:22',NULL,NULL),(25891,16689,'EM','rbpmsen@yahoo.com',0,'2014-01-08 18:24:34',NULL,NULL),(27147,17480,'TE','8173436357',0,'2014-01-13 03:01:12',NULL,NULL),(28072,18092,'AP','3187175371',0,'2014-01-15 02:07:31',NULL,NULL),(29833,19300,'TE','3184706156',1,'2014-01-22 03:22:00',NULL,NULL),(30046,19461,'TE','5129344974',0,'2014-01-23 03:01:56',NULL,NULL),(30298,19627,'AP','3303307675',0,'2014-01-23 21:00:07',NULL,NULL),(33019,21633,'TE','3613899319',0,'2014-02-05 21:30:42',NULL,NULL),(34770,22805,'EM','christinashampton@comcast.net',0,'2014-02-11 21:01:54',NULL,NULL),(39754,26290,'TE','3182651296',0,'2014-02-28 06:31:24',NULL,NULL),(39983,26472,'EM','beatricepmitchell@yahoo.com',0,'2014-02-28 07:30:38',NULL,NULL),(40381,26805,'TE','6148040572',0,'2014-03-01 21:00:25',NULL,NULL),(9369,6132,'EM','pswebber@hotmail.com',0,'2013-12-26 00:16:02',NULL,NULL),(23094,14893,'TE','2253566521',0,'2013-12-30 00:00:52',NULL,NULL),(25393,16377,'TE','4322902570',0,'2014-01-07 04:03:13',NULL,NULL),(25681,16556,'AP','5043028884',1,'2014-01-07 10:22:54',NULL,NULL),(27987,18040,'AP','4192608785',0,'2014-01-15 02:07:12',NULL,NULL),(30329,19648,'AP','7408142497',0,'2014-01-23 21:00:18',NULL,NULL),(32093,20959,'BN','9153280768',0,'2014-02-01 19:00:08',NULL,NULL),(43573,28936,'TE','7403173423',0,'2014-03-10 21:00:40',NULL,NULL),(38170,25193,'EM','walexa78174@gmail.com',0,'2014-02-21 22:00:41',NULL,NULL),(40165,26639,'TE','9158510316',0,'2014-02-28 21:31:02',NULL,NULL),(40933,27199,'TE','2814607277',0,'2014-03-03 21:31:21',NULL,NULL),(42661,28381,'TE','3307455125',0,'2014-03-07 21:30:39',NULL,NULL),(9936,6502,'EM','gtaliano@centurytel.net',0,'2013-12-26 00:50:53',NULL,NULL),(22479,14495,'TE','9158573197',0,'2013-12-28 03:33:37',NULL,NULL),(8699,5709,'TE','6032649631',0,'2013-12-25 23:45:05',NULL,NULL),(4729,3026,'TE','6015192543',0,'2013-12-25 20:18:19',NULL,NULL),(20208,13020,'AP','3306909844',0,'2013-12-26 12:50:02',NULL,NULL),(7012,4580,'TE','3307631181',0,'2013-12-25 22:05:12',NULL,NULL),(6757,4385,'AP','2166188779',0,'2013-12-25 22:00:45',NULL,NULL),(30613,19869,'TE','5138435751',0,'2014-01-24 21:00:39',NULL,NULL),(31637,20640,'TE','2144918508',0,'2014-01-30 21:00:33',NULL,NULL),(33340,21839,'EM','isaacquaye1@gmail.com',0,'2014-02-06 21:01:09',NULL,NULL),(37096,24423,'TE','3307873653',0,'2014-02-18 22:01:09',NULL,NULL),(37323,24559,'EM','ruggersarge@yahoo.com',0,'2014-02-20 04:06:17',NULL,NULL),(39870,26376,'AP','2165981642',0,'2014-02-28 07:00:16',NULL,NULL),(40258,26708,'AP','5133143655',0,'2014-02-28 21:31:37',NULL,NULL),(41356,27474,'AP','4197079178',0,'2014-03-04 21:02:13',NULL,NULL),(486,311,'TE','9032794055',0,'2013-12-25 17:31:01',NULL,NULL),(20986,13506,'AP','3185103083',0,'2013-12-26 13:02:45',NULL,NULL),(14274,9336,'AP','3184991819',0,'2013-12-26 04:30:54',NULL,NULL),(873,542,'EM','jwest76@ymail.com',0,'2013-12-25 17:49:46',NULL,NULL),(8941,5852,'TE','8174663421',0,'2013-12-25 23:48:50',NULL,NULL),(22493,14502,'AP','4324136216',0,'2013-12-28 03:33:49',NULL,NULL),(4511,2869,'TE','9157803474',0,'2013-12-25 20:01:54',NULL,NULL),(4619,2945,'AP','3303070337',0,'2013-12-25 20:16:22',NULL,NULL),(5209,3346,'AP','9364433679',0,'2013-12-25 21:16:37',NULL,NULL),(24216,15645,'TE','6016224948',1,'2014-01-02 04:33:55',NULL,NULL),(26022,16767,'TE','5132038480',0,'2014-01-08 18:25:00',NULL,NULL),(26966,17341,'AP','6015002906',0,'2014-01-13 02:24:03',NULL,NULL),(30200,19564,'TE','3187792546',0,'2014-01-23 03:02:34',NULL,NULL),(33623,22048,'EM','amfish88@gmail.com',0,'2014-02-07 19:30:06',NULL,NULL),(35380,23251,'TE','3307443885',0,'2014-02-13 21:30:06',NULL,NULL),(35659,23452,'AP','5125175930',0,'2014-02-13 22:01:38',NULL,NULL),(36533,24052,'EM','ivyosborne@aol.com',0,'2014-02-15 22:01:05',NULL,NULL),(36638,24118,'AP','9155912891',0,'2014-02-15 22:01:41',NULL,NULL),(7233,4710,'TE','4192225965',0,'2013-12-25 22:08:42',NULL,NULL),(22540,14532,'TE','6012188789',0,'2013-12-28 03:34:36',NULL,NULL),(5762,3691,'TE','4193413302',0,'2013-12-25 21:31:44',NULL,NULL),(39396,26051,'TE','5672156452',0,'2014-02-26 21:02:33',NULL,NULL),(37369,24597,'AP','4197074981',0,'2014-02-20 04:12:30',NULL,NULL),(43316,28775,'AP','4199895469',0,'2014-03-09 21:00:32',NULL,NULL),(40590,26939,'EM','gjchmura@cox.net',0,'2014-03-03 01:00:23',NULL,NULL),(42282,28079,'TE','2102770802',0,'2014-03-06 21:01:56',NULL,NULL),(1569,967,'EM','helen_knits@yahoo.com',0,'2013-12-25 18:09:56',NULL,NULL),(7458,4855,'EM','dawnmdebord@gmail.com',0,'2013-12-25 22:30:30',NULL,NULL),(11455,7448,'TE','9376715957',0,'2013-12-26 02:30:39',NULL,NULL),(37085,24418,'TE','9374776776',0,'2014-02-18 22:01:05',NULL,NULL),(28807,18595,'TE','5137021536',0,'2014-01-16 08:47:15',NULL,NULL),(26268,16904,'BN','6143156796',0,'2014-01-13 02:19:34',NULL,NULL),(5205,3345,'TE','9364433679',0,'2013-12-25 21:16:36',NULL,NULL),(593,365,'EM','rskay@sbcglobal.net',0,'2013-12-25 17:45:18',NULL,NULL),(3820,2430,'EM','mjpcarolina@yahoo.com',0,'2013-12-25 19:34:10',NULL,NULL),(42639,28365,'TE','9036672894',0,'2014-03-07 21:30:31',NULL,NULL),(13702,8932,'AP','2169730614',0,'2013-12-26 04:03:04',NULL,NULL),(10939,7111,'AP','2253231369',0,'2013-12-26 01:51:03',NULL,NULL),(20865,13415,'EM','DENISEANGERSTIEN@ROCKETMAIL.COM',0,'2013-12-26 13:00:40',NULL,NULL),(20897,13437,'TE','5135453653',0,'2013-12-26 13:01:12',NULL,NULL),(22791,14695,'EM','hessjosh@rocketmail.com',1,'2013-12-29 11:08:56',NULL,NULL),(36111,23761,'EM','pauldimuzio@zoomtown.com',0,'2014-02-14 21:31:10',NULL,NULL),(24353,15728,'TE','7408778077',0,'2014-01-03 02:00:24',NULL,NULL),(32118,20972,'EM','alexisfrausto1990@gmail.com',0,'2014-02-01 19:00:15',NULL,NULL),(33864,22228,'TE','3187289757',0,'2014-02-09 19:00:30',NULL,NULL),(1256,762,'EM','trishawatches@yahoo.com',0,'2013-12-25 18:04:36',NULL,NULL),(7324,4762,'AP','5134978337',0,'2013-12-25 22:15:35',NULL,NULL),(11782,7666,'TE','5043299923',0,'2013-12-26 03:00:25',NULL,NULL),(39914,26412,'AP','9406821700',0,'2014-02-28 07:00:40',NULL,NULL),(37185,24477,'TE','2163214160',0,'2014-02-18 22:01:42',NULL,NULL),(32426,21188,'TE','6014350792',0,'2014-02-03 21:00:47',NULL,NULL),(27799,17917,'TE','9368762197',0,'2014-01-15 02:06:30',NULL,NULL),(3102,1934,'EM','angel.12007@yahoo.com',0,'2013-12-25 19:00:30',NULL,NULL),(4865,3114,'TE','9034919126',0,'2013-12-25 20:30:07',NULL,NULL),(3721,2361,'TE','3306449727',0,'2013-12-25 19:32:30',NULL,NULL),(8092,5296,'EM','NLBAILEY89@GMAIL.COM',0,'2013-12-25 23:06:11',NULL,NULL),(41129,27318,'BN','9038247951',0,'2014-03-04 21:00:44',NULL,NULL),(40602,26953,'TE','7078798242',0,'2014-03-03 01:00:27',NULL,NULL),(10432,6800,'EM','earth.angelpozo@gmail.com',0,'2013-12-26 01:17:23',NULL,NULL),(7431,4833,'EM','stevesuevegas@yahoo.com',0,'2013-12-25 22:17:24',NULL,NULL),(38339,25328,'TE','5049099877',0,'2014-02-25 21:30:15',NULL,NULL),(30987,20158,'TE','4405320633',0,'2014-01-27 21:01:08',NULL,NULL),(26235,16885,'AP','7132057273',0,'2014-01-13 02:19:24',NULL,NULL),(27939,18003,'TE','5132330239',0,'2014-01-15 02:07:00',NULL,NULL),(43921,29138,'TE','4192768197',0,'2014-03-10 21:02:41',NULL,NULL),(37530,24712,'EM','jordan.conti@gmail.com',0,'2014-02-20 04:36:27',NULL,NULL),(37235,24504,'TE','8329001172',0,'2014-02-20 03:50:17',NULL,NULL),(23518,15170,'EM','scdarby@ameritech.net',0,'2014-01-01 12:06:34',NULL,NULL),(4620,2945,'EM','edwardfreeman743@yahoo.com',0,'2013-12-25 20:16:22',NULL,NULL),(32826,21480,'EM','adam.grindler@gmail.com',0,'2014-02-04 21:01:42',NULL,NULL),(28534,18391,'AP','7402756035',0,'2014-01-16 08:45:40',NULL,NULL),(10724,6975,'TE','3308332639',0,'2013-12-26 01:47:33',NULL,NULL),(11038,7162,'EM','dchunt1955@gmail.com',0,'2013-12-26 01:52:31',NULL,NULL),(27548,17753,'EM','Telishagoree@yahoo.com',0,'2014-01-14 01:33:29',NULL,NULL),(322,200,'AP','4199798053',0,'2013-12-25 17:20:11',NULL,NULL),(5693,3656,'TE','3107360452',0,'2013-12-25 21:30:46',NULL,NULL),(9406,6158,'TE','2285398237',0,'2013-12-26 00:16:41',NULL,NULL),(38461,25416,'AP','3304316892',0,'2014-02-25 21:31:06',NULL,NULL),(1774,1096,'EM','urpissinmeoff@aol.com',0,'2013-12-25 18:17:09',NULL,NULL),(2038,1261,'EM','cwolfelt@gmail.com',0,'2013-12-25 18:21:33',NULL,NULL),(7759,5064,'EM','wilsone1956@wildblue.net',0,'2013-12-25 23:00:32',NULL,NULL),(7000,4570,'AP','9033713502',0,'2013-12-25 22:04:58',NULL,NULL),(36835,24258,'EM','yingychau2@gmail.com',0,'2014-02-17 19:00:08',NULL,NULL),(6114,3933,'EM','vlmoore@bex.net',0,'2013-12-25 21:37:43',NULL,NULL),(8598,5651,'TE','9156132729',0,'2013-12-25 23:31:30',NULL,NULL),(10525,6855,'TE','3305739094',0,'2013-12-26 01:31:31',NULL,NULL),(12255,8012,'AP','5136331088',0,'2013-12-26 03:08:41',NULL,NULL),(20777,13352,'TE','7138822519',0,'2013-12-26 12:59:13',NULL,NULL),(26115,16817,'TE','7137058263',0,'2014-01-13 02:18:20',NULL,NULL),(35695,23478,'AP','5132251336',0,'2014-02-13 22:01:53',NULL,NULL),(33504,21956,'TE','9377169182',0,'2014-02-07 19:00:24',NULL,NULL),(41839,27820,'TE','7408048028',0,'2014-03-05 21:31:55',NULL,NULL),(23726,15309,'AP','2084736474',1,'2014-01-02 04:23:09',NULL,NULL),(35729,23496,'AP','4692230249',0,'2014-02-13 22:02:06',NULL,NULL),(33305,21811,'TE','3307456403',0,'2014-02-06 21:00:54',NULL,NULL),(10299,6721,'TE','5133159980',0,'2013-12-26 01:15:13',NULL,NULL),(28196,18172,'AP','4193504582',0,'2014-01-15 02:07:58',NULL,NULL),(26164,16846,'AP','3305405914',0,'2014-01-13 02:18:36',NULL,NULL),(26095,16805,'TE','9155490347',0,'2014-01-13 02:18:13',NULL,NULL),(9476,6202,'AP','5132888641',0,'2013-12-26 00:30:39',NULL,NULL),(24139,15586,'TE','5133484108',1,'2014-01-02 04:32:20',NULL,NULL),(39657,26223,'TE','9566479740',0,'2014-02-28 06:30:58',NULL,NULL),(30741,19974,'AP','2145789367',0,'2014-01-25 19:00:13',NULL,NULL),(30530,19805,'TE','8306837200',0,'2014-01-24 21:00:06',NULL,NULL),(29903,19351,'AP','5136041132',1,'2014-01-22 03:22:26',NULL,NULL),(13811,9000,'AP','3307303575',0,'2013-12-26 04:04:51',NULL,NULL),(26805,17241,'AP','5133098954',0,'2014-01-13 02:22:45',NULL,NULL),(1200,730,'EM','genahammonds@gmail.com',0,'2013-12-25 18:03:47',NULL,NULL),(20812,13374,'TE','9374190470',0,'2013-12-26 12:59:48',NULL,NULL),(26444,17018,'EM','flaugg@hotmail.com',0,'2014-01-13 02:20:39',NULL,NULL),(1414,862,'TE','3305595203',0,'2013-12-25 18:07:12',NULL,NULL),(37637,24808,'TE','5139811813',0,'2014-02-20 04:49:22',NULL,NULL),(34085,22344,'TE','4197543119',0,'2014-02-10 11:01:10',NULL,NULL),(6627,4283,'AP','4193037462',0,'2013-12-25 21:52:02',NULL,NULL),(3273,2058,'AP','4405069911',0,'2013-12-25 19:16:04',NULL,NULL),(2515,1541,'AP','5133350926',0,'2013-12-25 18:50:19',NULL,NULL),(27465,17693,'AP','5042756480',0,'2014-01-14 01:33:00',NULL,NULL),(23778,15334,'TE','4192626301',1,'2014-01-02 04:24:03',NULL,NULL),(14972,9795,'TE','5122675879',0,'2013-12-26 05:01:05',NULL,NULL),(1431,873,'AP','9375649179',0,'2013-12-25 18:07:30',NULL,NULL),(3859,2455,'EM','geb@beelineservices.com',0,'2013-12-25 19:34:46',NULL,NULL),(23525,15179,'TE','2165664420',0,'2014-01-01 12:06:46',NULL,NULL),(22996,14834,'TE','4195615779',1,'2013-12-29 11:14:39',NULL,NULL),(2266,1388,'AP','2068906372',0,'2013-12-25 18:46:18',NULL,NULL),(30402,19701,'AP','2692622025',0,'2014-01-23 21:00:48',NULL,NULL),(12171,7952,'TE','2252474688',0,'2013-12-26 03:07:11',NULL,NULL),(3857,2455,'TE','9723333846',0,'2013-12-25 19:34:46',NULL,NULL),(30388,19690,'TE','9039388728',0,'2014-01-23 21:00:42',NULL,NULL),(23840,15381,'AP','3305907418',1,'2014-01-02 04:25:27',NULL,NULL),(28819,18600,'AP','6013460643',0,'2014-01-16 08:47:18',NULL,NULL),(9968,6523,'TE','4199020774',0,'2013-12-26 00:51:28',NULL,NULL),(20917,13451,'TE','6142165785',0,'2013-12-26 13:01:30',NULL,NULL),(38012,25076,'AP','3307159132',0,'2014-02-20 22:01:34',NULL,NULL),(20582,13242,'AP','2146734693',0,'2013-12-26 12:56:07',NULL,NULL),(9183,6013,'TE','8598149354',0,'2013-12-26 00:00:38',NULL,NULL),(36011,23688,'AP','2058074992',0,'2014-02-14 21:30:35',NULL,NULL),(41352,27471,'AP','5133351376',0,'2014-03-04 21:02:12',NULL,NULL),(41201,27365,'TE','9378388672',0,'2014-03-04 21:01:13',NULL,NULL),(6801,4413,'TE','2162033794',0,'2013-12-25 22:01:25',NULL,NULL),(25822,16646,'TE','8324959990',0,'2014-01-08 18:24:19',NULL,NULL),(10708,6961,'EM','jackson.771@osu.edu',0,'2013-12-26 01:47:16',NULL,NULL),(3233,2031,'AP','2169057629',0,'2013-12-25 19:15:22',NULL,NULL),(5227,3360,'TE','8066641570',0,'2013-12-25 21:16:58',NULL,NULL),(43723,29024,'AP','5136809317',0,'2014-03-10 21:01:32',NULL,NULL),(235,143,'TE','3308481125',0,'2013-12-25 17:18:46',NULL,NULL),(1517,933,'EM','jandmharr@gmail.com',0,'2013-12-25 18:09:09',NULL,NULL),(14405,9420,'TE','2545923110',0,'2013-12-26 04:33:05',NULL,NULL),(39511,26137,'TE','6143167646',0,'2014-02-28 06:30:24',NULL,NULL),(13563,8843,'AP','2147143555',0,'2013-12-26 04:00:49',NULL,NULL),(36741,24188,'AP','8324099350',0,'2014-02-16 19:00:12',NULL,NULL),(11741,7642,'TE','4409513930',0,'2013-12-26 02:46:37',NULL,NULL),(35093,23051,'TE','2142457874',0,'2014-02-12 21:30:46',NULL,NULL),(4398,2801,'AP','9376582233',0,'2013-12-25 19:50:26',NULL,NULL),(31442,20494,'TE','3186519285',0,'2014-01-29 21:01:09',NULL,NULL),(29105,18793,'BN','5132560196',0,'2014-01-17 03:35:57',NULL,NULL),(24473,15793,'EM','tlwillis33@yahoo.com',0,'2014-01-03 02:02:35',NULL,NULL),(382,234,'AP','5132562650',0,'2013-12-25 17:21:06',NULL,NULL),(25090,16175,'EM','comnetllc@yahoo.com',0,'2014-01-05 00:00:22',NULL,NULL),(34540,22656,'AP','4325990802',0,'2014-02-11 21:00:31',NULL,NULL),(4140,2642,'TE','3308481632',0,'2013-12-25 19:46:22',NULL,NULL),(9080,5953,'EM','kathydbryant@yahoo.com',0,'2013-12-25 23:51:09',NULL,NULL),(1622,996,'AP','9375805289',0,'2013-12-25 18:10:48',NULL,NULL),(13894,9058,'TE','2103222396',0,'2013-12-26 04:06:16',NULL,NULL),(34527,22650,'AP','2398516283',0,'2014-02-11 21:00:27',NULL,NULL),(9499,6216,'TE','6018628845',0,'2013-12-26 00:31:01',NULL,NULL),(32527,21263,'EM','nicholasmallard@rocketmail.com',0,'2014-02-03 21:01:25',NULL,NULL),(28845,18630,'TE','9366370414',0,'2014-01-17 03:35:01',NULL,NULL),(31554,20568,'TE','4193481892',0,'2014-01-29 21:01:51',NULL,NULL),(41384,27494,'AP','4402258647',0,'2014-03-04 21:02:24',NULL,NULL),(25600,16514,'AP','9158611787',1,'2014-01-07 10:21:28',NULL,NULL),(38186,25203,'TE','5042187905',0,'2014-02-21 22:00:47',NULL,NULL),(24174,15620,'TE','6628912497',1,'2014-01-02 04:33:07',NULL,NULL),(36515,24040,'AP','3305596938',0,'2014-02-15 22:00:58',NULL,NULL),(34070,22335,'AP','5127617772',0,'2014-02-10 11:01:04',NULL,NULL),(12305,8047,'AP','4194663079',0,'2013-12-26 03:09:35',NULL,NULL),(31054,20202,'AP','5135187423',0,'2014-01-27 21:01:33',NULL,NULL),(31039,20192,'AP','9376222504',0,'2014-01-27 21:01:27',NULL,NULL),(2673,1622,'AP','9792572018',0,'2013-12-25 18:52:37',NULL,NULL),(9504,6220,'AP','4195732676',0,'2013-12-26 00:31:08',NULL,NULL),(42684,28395,'EM','zeddazomb@gmail.com',0,'2014-03-07 21:30:47',NULL,NULL),(36241,23851,'AP','4196282042',0,'2014-02-14 21:31:59',NULL,NULL),(23980,15482,'TE','5132810636',1,'2014-01-02 04:29:10',NULL,NULL),(22327,14392,'AP','6144465014',0,'2013-12-28 03:31:03',NULL,NULL),(5468,3501,'TE','4407737075',0,'2013-12-25 21:20:43',NULL,NULL),(10065,6580,'EM','dantuel@frontiernet.net',0,'2013-12-26 00:52:57',NULL,NULL),(10286,6714,'EM','TWILSON926@AOL.COM',0,'2013-12-26 01:02:23',NULL,NULL),(35030,23001,'EM','tvandusen@neo.rr.com',0,'2014-02-12 21:30:19',NULL,NULL),(32522,21260,'AP','5133413406',0,'2014-02-03 21:01:23',NULL,NULL),(12360,8090,'AP','4193084532',0,'2013-12-26 03:10:40',NULL,NULL),(28392,18291,'EM','sylviasservices@sbcglobal.net',0,'2014-01-16 08:44:52',NULL,NULL),(10153,6636,'TE','8478777760',0,'2013-12-26 01:00:10',NULL,NULL),(25720,16577,'EM','jgerken92@yahoo.com',1,'2014-01-07 10:23:34',NULL,NULL),(40677,27011,'TE','5133194102',0,'2014-03-03 21:00:07',NULL,NULL),(32287,21090,'AP','9016261326',0,'2014-02-02 19:00:27',NULL,NULL),(22897,14773,'TE','9156370355',1,'2013-12-29 11:13:00',NULL,NULL),(7043,4600,'AP','9373651489',0,'2013-12-25 22:05:41',NULL,NULL),(14658,9590,'AP','2283277409',0,'2013-12-26 04:37:08',NULL,NULL),(4360,2780,'TE','5135152886',0,'2013-12-25 19:49:50',NULL,NULL),(27033,17382,'EM','aljones0206@gmail.com',0,'2014-01-13 03:00:07',NULL,NULL),(27299,17578,'TE','9376215007',0,'2014-01-14 01:32:05',NULL,NULL),(32026,20904,'BN','5135353181',0,'2014-01-31 21:01:23',NULL,NULL),(10536,6860,'AP','7404443291',0,'2013-12-26 01:31:39',NULL,NULL),(11204,7285,'AP','3303485877',0,'2013-12-26 02:02:48',NULL,NULL),(4612,2942,'TE','4197220838',0,'2013-12-25 20:16:16',NULL,NULL),(835,519,'TE','4195130520',0,'2013-12-25 17:49:09',NULL,NULL),(3639,2302,'EM','kafcsak@aol.com',0,'2013-12-25 19:31:01',NULL,NULL),(3953,2510,'TE','4194652360',0,'2013-12-25 19:36:16',NULL,NULL),(2803,1698,'TE','6789066780',0,'2013-12-25 18:54:37',NULL,NULL),(22700,14641,'AP','2102942010',1,'2013-12-29 11:07:27',NULL,NULL),(23039,14861,'AP','4192352564',1,'2013-12-29 11:15:22',NULL,NULL),(23532,15186,'TE','4198613136',0,'2014-01-01 12:06:57',NULL,NULL),(27305,17585,'TE','4407251111',0,'2014-01-14 01:32:07',NULL,NULL),(29422,19021,'AP','6014979227',0,'2014-01-20 08:06:26',NULL,NULL),(29557,19101,'TE','9787984689',0,'2014-01-21 08:44:38',NULL,NULL),(30851,20053,'TE','8328943471',0,'2014-01-27 21:00:06',NULL,NULL),(36428,23991,'EM','cmac4u@cox.net',0,'2014-02-15 22:00:26',NULL,NULL),(39087,25859,'TE','3182068452',0,'2014-02-26 21:00:44',NULL,NULL),(39887,26393,'AP','4404767132',0,'2014-02-28 07:00:27',NULL,NULL),(40451,26854,'AP','6017509205',0,'2014-03-01 21:00:53',NULL,NULL),(42383,28150,'TE','4193032634',0,'2014-03-06 21:02:36',NULL,NULL),(43218,28719,'AP','9376577729',0,'2014-03-08 21:31:20',NULL,NULL),(524,328,'TE','2168328499',0,'2013-12-25 17:31:36',NULL,NULL),(21671,13952,'AP','5134901485',0,'2013-12-26 13:14:56',NULL,NULL),(10134,6624,'EM','carol8ann@aol.com',0,'2013-12-26 00:54:09',NULL,NULL),(20778,13352,'AP','7138822519',0,'2013-12-26 12:59:14',NULL,NULL),(12091,7903,'TE','5138256065',0,'2013-12-26 03:05:51',NULL,NULL),(11016,7151,'TE','4193754083',0,'2013-12-26 01:52:12',NULL,NULL),(7578,4931,'EM','jrcjive227@fuse.net',0,'2013-12-25 22:45:27',NULL,NULL),(6958,4536,'AP','9366150921',0,'2013-12-25 22:04:11',NULL,NULL),(3759,2384,'AP','7403577858',0,'2013-12-25 19:33:06',NULL,NULL),(9517,6228,'EM','pfreeland4@gmail.com',0,'2013-12-26 00:31:23',NULL,NULL),(9427,6171,'TE','9853281010',0,'2013-12-26 00:17:03',NULL,NULL),(24187,15626,'EM','nabarfield@yahoo.com',1,'2014-01-02 04:33:21',NULL,NULL),(25879,16683,'AP','3304219807',0,'2014-01-08 18:24:32',NULL,NULL),(31710,20695,'TE','3303548593',0,'2014-01-30 21:01:00',NULL,NULL),(35350,23228,'TE','2162516481',0,'2014-02-12 21:32:23',NULL,NULL),(41567,27638,'EM','marlajones68@yahoo.com',0,'2014-03-05 21:30:14',NULL,NULL),(35749,23511,'TE','2287313017',0,'2014-02-13 22:02:14',NULL,NULL),(37160,24460,'EM','ramona@ramonacreel.com',0,'2014-02-18 22:01:33',NULL,NULL),(37434,24648,'EM','marcycarney@yahoo.com',0,'2014-02-20 04:22:09',NULL,NULL),(38237,25245,'TE','4192283194',0,'2014-02-21 22:01:10',NULL,NULL),(38264,25259,'AP','3307184309',0,'2014-02-22 19:00:12',NULL,NULL),(38586,25500,'TE','9792574391',0,'2014-02-25 21:31:54',NULL,NULL),(40901,27177,'AP','9364144463',0,'2014-03-03 21:31:08',NULL,NULL),(10456,6811,'EM','rcin76426@yahoo.com',0,'2013-12-26 01:30:20',NULL,NULL),(22621,14588,'TE','3305241565',0,'2013-12-28 03:36:03',NULL,NULL),(21884,14100,'EM','suzannehartwick@gmail.com',0,'2013-12-27 02:01:33',NULL,NULL),(21137,13590,'TE','5043053195',0,'2013-12-26 13:05:10',NULL,NULL),(8934,5849,'AP','4693608909',0,'2013-12-25 23:48:44',NULL,NULL),(8743,5734,'TE','9858019540',0,'2013-12-25 23:45:45',NULL,NULL),(11403,7420,'EM','schwinndanupe@gmail.com',0,'2013-12-26 02:17:02',NULL,NULL),(6360,4097,'TE','9026347056',0,'2013-12-25 21:47:38',NULL,NULL),(23471,15135,'EM','kreeves919@gmail.com',0,'2014-01-01 12:05:35',NULL,NULL),(25116,16192,'TE','2147835623',0,'2014-01-05 00:00:51',NULL,NULL),(25213,16258,'AP','2282494452',0,'2014-01-05 00:02:50',NULL,NULL),(26406,16993,'BN','4192174195',0,'2014-01-13 02:20:26',NULL,NULL),(27297,17576,'AP','6145706264',0,'2014-01-14 01:32:04',NULL,NULL),(28682,18506,'EM','rbourn2429@att.net',0,'2014-01-16 08:46:32',NULL,NULL),(29773,19252,'AP','2252880881',0,'2014-01-21 08:46:44',NULL,NULL),(31413,20479,'TE','4193418586',0,'2014-01-29 21:01:00',NULL,NULL),(34566,22667,'TE','8176086187',0,'2014-02-11 21:00:39',NULL,NULL),(35742,23505,'EM','baldwin11sandy@yahoo.com',0,'2014-02-13 22:02:10',NULL,NULL),(10014,6551,'EM','kenneth.pitts@rocketmail.com',0,'2013-12-26 00:52:11',NULL,NULL),(1024,632,'TE','5133071859',0,'2013-12-25 18:01:08',NULL,NULL),(13810,9000,'TE','3308676062',0,'2013-12-26 04:04:51',NULL,NULL),(21609,13907,'TE','4199834132',0,'2013-12-26 13:13:52',NULL,NULL),(1852,1143,'EM','rlaurie6592@gmail.com',0,'2013-12-25 18:18:25',NULL,NULL),(13760,8968,'AP','8644040402',0,'2013-12-26 04:04:02',NULL,NULL),(13734,8950,'AP','3308272372',0,'2013-12-26 04:03:34',NULL,NULL),(11553,7519,'EM','henderson.joshua1974@gmail.com',0,'2013-12-26 02:32:20',NULL,NULL),(6888,4479,'TE','4196843000',0,'2013-12-25 22:02:56',NULL,NULL),(8097,5302,'EM','KGC1015@AOL.COM',0,'2013-12-25 23:06:19',NULL,NULL),(10310,6725,'TE','5138250774',0,'2013-12-26 01:15:21',NULL,NULL),(24398,15753,'TE','9722727389',0,'2014-01-03 02:01:14',NULL,NULL),(24609,15870,'EM','gerrifrazier@aol.com',0,'2014-01-03 02:05:05',NULL,NULL),(30551,19824,'AP','9565775232',0,'2014-01-24 21:00:15',NULL,NULL),(31350,20429,'TE','3302207700',0,'2014-01-29 21:00:34',NULL,NULL),(27318,17594,'TE','6013731101',0,'2014-01-14 01:32:12',NULL,NULL),(28088,18104,'AP','3183311657',0,'2014-01-15 02:07:35',NULL,NULL),(43118,28665,'AP','5044216117',0,'2014-03-08 21:30:45',NULL,NULL),(38750,25618,'AP','9727653376',0,'2014-02-26 08:30:14',NULL,NULL),(36898,24301,'TE','8173460630',0,'2014-02-18 21:30:19',NULL,NULL),(12309,8048,'EM','PHOENIXCD1@GMAIL.COM',0,'2013-12-26 03:09:37',NULL,NULL),(32922,21552,'TE','2166506815',0,'2014-02-05 21:30:14',NULL,NULL),(2241,1374,'EM','jeff@neonandmore.com',0,'2013-12-25 18:45:53',NULL,NULL),(22920,14789,'TE','7404345156',1,'2013-12-29 11:13:27',NULL,NULL),(752,471,'EM','cooperslady5@aol.com',0,'2013-12-25 17:47:53',NULL,NULL),(41745,27761,'TE','2252784729',0,'2014-03-05 21:31:20',NULL,NULL),(14663,9593,'TE','3306878328',0,'2013-12-26 04:37:13',NULL,NULL),(30701,19942,'BN','9377269233',0,'2014-01-24 21:01:16',NULL,NULL),(28138,18139,'TE','3373945558',0,'2014-01-15 02:07:46',NULL,NULL),(24239,15659,'AP','4193310524',1,'2014-01-02 04:34:23',NULL,NULL),(23958,15459,'TE','2813240430',1,'2014-01-02 04:28:37',NULL,NULL),(4581,2924,'AP','3304610318',0,'2013-12-25 20:15:51',NULL,NULL),(5194,3338,'TE','8067679535',0,'2013-12-25 21:16:26',NULL,NULL),(5778,3700,'EM','nlakwilliams@zoomtown.com',0,'2013-12-25 21:31:59',NULL,NULL),(221,134,'TE','2162179394',0,'2013-12-25 17:18:33',NULL,NULL),(14161,9268,'AP','4404099049',0,'2013-12-26 04:15:34',NULL,NULL),(38108,25155,'EM','teresagordon52@yahoo.com',0,'2014-02-21 22:00:19',NULL,NULL),(31409,20477,'TE','6148593648',0,'2014-01-29 21:00:58',NULL,NULL),(43760,29050,'TE','5132175611',0,'2014-03-10 21:01:46',NULL,NULL),(75,46,'EM','dhunter1564@yahoo.com',0,'2013-12-25 17:16:14',NULL,NULL),(21146,13595,'AP','4074216994',0,'2013-12-26 13:05:18',NULL,NULL),(202,123,'TE','9377250580',0,'2013-12-25 17:18:15',NULL,NULL),(9304,6093,'EM','pfhfdf@hotmail.com',0,'2013-12-26 00:02:50',NULL,NULL),(14165,9270,'TE','2163086759',0,'2013-12-26 04:15:37',NULL,NULL),(13825,9014,'TE','5672032879',0,'2013-12-26 04:05:10',NULL,NULL),(8166,5343,'TE','3302887926',0,'2013-12-25 23:07:25',NULL,NULL),(28996,18717,'AP','3306076869',0,'2014-01-17 03:35:33',NULL,NULL),(8028,5249,'EM','yentruoc183@hotmail.com',0,'2013-12-25 23:05:06',NULL,NULL),(28531,18390,'AP','4408656996',0,'2014-01-16 08:45:39',NULL,NULL),(9639,6307,'EM','bjordray@windstream.net',0,'2013-12-26 00:46:05',NULL,NULL),(28434,18320,'TE','4407251111',0,'2014-01-16 08:45:07',NULL,NULL),(27336,17603,'TE','5122926032',0,'2014-01-14 01:32:17',NULL,NULL),(21543,13849,'TE','4193670523',0,'2013-12-26 13:12:34',NULL,NULL),(38291,25283,'TE','9566246396',0,'2014-02-25 21:00:19',NULL,NULL),(20967,13490,'AP','4402213935',0,'2013-12-26 13:02:24',NULL,NULL),(14341,9375,'TE','2253852747',0,'2013-12-26 04:31:56',NULL,NULL),(13870,9044,'TE','3302414598',0,'2013-12-26 04:05:54',NULL,NULL),(13818,9004,'AP','2167807439',0,'2013-12-26 04:04:58',NULL,NULL),(8042,5263,'TE','3305736946',0,'2013-12-25 23:05:24',NULL,NULL),(10128,6622,'AP','6623466805',0,'2013-12-26 00:54:05',NULL,NULL),(32711,21397,'EM','PADMAJAPAPKAR@YAHOO.COM',0,'2014-02-04 21:01:00',NULL,NULL),(27220,17526,'TE','5139811135',0,'2014-01-13 03:01:39',NULL,NULL),(29717,19215,'TE','6145979579',0,'2014-01-21 08:46:24',NULL,NULL),(31063,20209,'AP','6015731298',0,'2014-01-27 21:01:37',NULL,NULL),(972,598,'TE','6142078672',0,'2013-12-25 18:00:15',NULL,NULL),(1648,1012,'TE','5136806024',0,'2013-12-25 18:11:19',NULL,NULL),(2884,1765,'AP','3103467943',0,'2013-12-25 18:56:01',NULL,NULL),(11292,7359,'TE','9038066560',0,'2013-12-26 02:15:21',NULL,NULL),(36476,24014,'AP','5134065853',0,'2014-02-15 22:00:42',NULL,NULL),(36411,23980,'AP','6512850740',0,'2014-02-15 22:00:20',NULL,NULL),(474,298,'AP','7405073493',0,'2013-12-25 17:30:46',NULL,NULL),(42937,28549,'TE','4196014962',0,'2014-03-07 21:32:19',NULL,NULL),(14696,9618,'TE','5613191627',0,'2013-12-26 04:37:49',NULL,NULL),(1279,777,'EM','gncpastord1210@att.net',0,'2013-12-25 18:04:59',NULL,NULL),(39891,26397,'BN','3302420092',0,'2014-02-28 07:00:29',NULL,NULL),(36929,24320,'TE','9728768197',0,'2014-02-18 22:00:07',NULL,NULL),(11679,7603,'AP','5673711217',0,'2013-12-26 02:45:26',NULL,NULL),(36584,24081,'TE','3302813070',0,'2014-02-15 22:01:22',NULL,NULL),(31830,20781,'TE','2542897777',0,'2014-01-31 21:00:09',NULL,NULL),(4107,2619,'TE','5133869618',0,'2013-12-25 19:45:49',NULL,NULL),(9796,6409,'TE','2167892790',0,'2013-12-26 00:48:35',NULL,NULL),(26652,17146,'AP','2252358147',0,'2014-01-13 02:21:55',NULL,NULL),(28499,18367,'TE','3307920455',0,'2014-01-16 08:45:29',NULL,NULL),(14744,9644,'TE','8324232304',0,'2013-12-26 04:38:34',NULL,NULL),(14862,9724,'EM','Chuckfritsch49@yahoo.com',0,'2013-12-26 04:45:33',NULL,NULL),(4148,2647,'AP','5126270719',0,'2013-12-25 19:46:30',NULL,NULL),(28200,18175,'TE','4194488310',0,'2014-01-15 02:07:59',NULL,NULL),(26688,17165,'EM','daranise@gmail.com',0,'2014-01-13 02:22:05',NULL,NULL),(2007,1242,'TE','3302422474',0,'2013-12-25 18:20:59',NULL,NULL),(11293,7359,'AP','9038066560',0,'2013-12-26 02:15:21',NULL,NULL),(21932,14128,'TE','2259334868',0,'2013-12-27 02:02:19',NULL,NULL),(23899,15417,'AP','9365813224',1,'2014-01-02 04:27:21',NULL,NULL),(282,174,'AP','3307037526',0,'2013-12-25 17:19:30',NULL,NULL),(5361,3433,'TE','5044442852',0,'2013-12-25 21:19:00',NULL,NULL),(29743,19232,'EM','rfcollett@yahoo.com',0,'2014-01-21 08:46:33',NULL,NULL),(10765,6998,'AP','2813522168',0,'2013-12-26 01:48:12',NULL,NULL),(4896,3144,'TE','6824380702',0,'2013-12-25 20:30:52',NULL,NULL),(4572,2916,'EM','jessicahensley23@gmail.com',0,'2013-12-25 20:15:40',NULL,NULL),(6258,4036,'TE','7409844010',0,'2013-12-25 21:46:01',NULL,NULL),(42338,28116,'TE','3307942691',0,'2014-03-06 21:02:18',NULL,NULL),(37068,24408,'AP','2168565404',0,'2014-02-18 22:00:59',NULL,NULL),(36317,23914,'EM','timber-ridge@neo.rr.com',0,'2014-02-14 22:00:04',NULL,NULL),(27570,17769,'AP','2105087088',0,'2014-01-14 01:33:37',NULL,NULL),(26631,17135,'AP','5133796661',0,'2014-01-13 02:21:49',NULL,NULL),(24900,16051,'AP','5136041685',0,'2014-01-04 02:03:13',NULL,NULL),(183,107,'TE','8326865251',0,'2013-12-25 17:17:53',NULL,NULL),(21406,13762,'EM','dennisdaquin@yahoo.com',0,'2013-12-26 13:10:16',NULL,NULL),(14676,9602,'TE','3308999595',0,'2013-12-26 04:37:27',NULL,NULL),(42384,28150,'AP','4193032634',0,'2014-03-06 21:02:36',NULL,NULL),(7283,4745,'EM','cherokee@fuse.net',0,'2013-12-25 22:09:36',NULL,NULL),(41631,27674,'EM','UB@BGPRODUCTIONS.US',0,'2014-03-05 21:30:35',NULL,NULL),(39726,26274,'AP','3184554078',0,'2014-02-28 06:31:17',NULL,NULL),(35664,23456,'EM','tkarreras@hotmail.com',0,'2014-02-13 22:01:40',NULL,NULL),(10105,6603,'TE','9375264412',0,'2013-12-26 00:53:36',NULL,NULL),(31046,20196,'EM','wperkins2@comcast.net',0,'2014-01-27 21:01:30',NULL,NULL),(2176,1338,'EM','susan.liller@gmail.com',0,'2013-12-25 18:32:19',NULL,NULL),(27034,17383,'TE','4194672270',0,'2014-01-13 03:00:08',NULL,NULL),(5873,3767,'AP','2165099707',0,'2013-12-25 21:33:36',NULL,NULL),(25089,16175,'AP','2252056562',0,'2014-01-05 00:00:21',NULL,NULL),(5162,3314,'TE','5134768083',0,'2013-12-25 21:15:55',NULL,NULL),(24935,16074,'TE','7402442480',0,'2014-01-04 02:03:54',NULL,NULL),(22818,14715,'TE','2165871764',1,'2013-12-29 11:09:24',NULL,NULL),(24544,15830,'AP','9374502439',0,'2014-01-03 02:03:50',NULL,NULL),(1176,722,'TE','8304882729',0,'2013-12-25 18:03:30',NULL,NULL),(14318,9362,'AP','5046662403',0,'2013-12-26 04:31:35',NULL,NULL),(7836,5115,'TE','9402285538',0,'2013-12-25 23:01:48',NULL,NULL),(11981,7807,'TE','3259491880',0,'2013-12-26 03:03:50',NULL,NULL),(22167,14276,'TE','6015033044',0,'2013-12-27 02:06:14',NULL,NULL),(23780,15337,'AP','4193025688',1,'2014-01-02 04:24:06',NULL,NULL),(25815,16641,'BN','5135084648',0,'2014-01-08 18:24:17',NULL,NULL),(26601,17112,'TE','3305030224',0,'2014-01-13 02:21:38',NULL,NULL),(27396,17639,'EM','poolguy812@aol.com',0,'2014-01-14 01:32:36',NULL,NULL),(30257,19598,'AP','3307309446',0,'2014-01-23 03:02:47',NULL,NULL),(31089,20237,'TE','7697983622',0,'2014-01-28 21:00:06',NULL,NULL),(32562,21293,'TE','2252722116',0,'2014-02-04 21:00:07',NULL,NULL),(34345,22532,'TE','6012917734',0,'2014-02-10 21:31:32',NULL,NULL),(35270,23163,'EM','jnklandscapes@gmail.com',0,'2014-02-12 21:31:48',NULL,NULL),(37290,24539,'AP','9152443276',0,'2014-02-20 04:02:06',NULL,NULL),(41941,27881,'EM','Jenniferscott_76@yahoo.com',0,'2014-03-05 21:32:33',NULL,NULL),(43384,28811,'EM','coffee_pot2003@yahoo.com',0,'2014-03-09 21:00:55',NULL,NULL),(791,493,'EM','vallerianna@aol.com',0,'2013-12-25 17:48:29',NULL,NULL),(21456,13790,'TE','6019888220',0,'2013-12-26 13:11:03',NULL,NULL),(10792,7015,'AP','8172018102',0,'2013-12-26 01:48:39',NULL,NULL),(10928,7106,'TE','3186145019',0,'2013-12-26 01:50:53',NULL,NULL),(12220,7986,'AP','3309315916',0,'2013-12-26 03:08:04',NULL,NULL),(22638,14597,'TE','9376570261',0,'2013-12-28 03:36:18',NULL,NULL),(22689,14635,'TE','4193710697',0,'2013-12-28 03:37:17',NULL,NULL),(23959,15459,'AP','7139226649',1,'2014-01-02 04:28:37',NULL,NULL),(25734,16585,'EM','psbruhnke@aol.com',0,'2014-01-08 18:23:59',NULL,NULL),(26735,17195,'AP','5045054802',0,'2014-01-13 02:22:21',NULL,NULL),(30885,20073,'AP','2035510922',0,'2014-01-27 21:00:19',NULL,NULL),(32110,20969,'TE','9565331431',0,'2014-02-01 19:00:14',NULL,NULL),(36009,23686,'EM','ccoppins@kent.edu',0,'2014-02-14 21:30:34',NULL,NULL),(36059,23718,'EM','ljester0524@gmail.com',0,'2014-02-14 21:30:50',NULL,NULL),(36754,24197,'AP','5133440653',0,'2014-02-16 19:00:17',NULL,NULL),(37721,24871,'TE','9375208110',0,'2014-02-20 05:33:17',NULL,NULL),(42465,28211,'AP','9178609243',0,'2014-03-06 21:30:14',NULL,NULL),(42920,28541,'AP','2542920522',0,'2014-03-07 21:32:14',NULL,NULL),(43532,28902,'EM','kcrumley2360@myhc.us',0,'2014-03-10 21:00:22',NULL,NULL),(8031,5253,'AP','3309062616',0,'2013-12-25 23:05:12',NULL,NULL),(1466,899,'EM','lindsayp1989@yahoo.com',0,'2013-12-25 18:08:14',NULL,NULL),(13939,9090,'EM','leyhsail@msn.com',0,'2013-12-26 04:07:04',NULL,NULL),(12018,7833,'TE','7408910356',0,'2013-12-26 03:04:27',NULL,NULL),(5807,3728,'EM','abeisaac21@yahoo.com',0,'2013-12-25 21:32:32',NULL,NULL),(4222,2700,'EM','Kbaker0718@gmail.com',0,'2013-12-25 19:47:42',NULL,NULL),(8349,5481,'AP','4197730314',0,'2013-12-25 23:10:51',NULL,NULL),(24754,15972,'TE','8065442146',0,'2014-01-04 02:00:39',NULL,NULL),(30378,19679,'EM','buddyboyd87@hotmail.com',0,'2014-01-23 21:00:37',NULL,NULL),(32014,20898,'EM','meghan.miller14@yahoo.com',0,'2014-01-31 21:01:19',NULL,NULL),(32753,21428,'AP','4194299136',0,'2014-02-04 21:01:16',NULL,NULL),(33067,21659,'TE','3183410175',0,'2014-02-05 21:30:54',NULL,NULL),(36594,24090,'TE','3302742404',0,'2014-02-15 22:01:26',NULL,NULL),(37457,24664,'TE','4195379346',0,'2014-02-20 04:26:14',NULL,NULL),(37915,25012,'AP','6145921031',0,'2014-02-20 22:00:53',NULL,NULL),(38217,25225,'AP','3307152701',0,'2014-02-21 22:00:59',NULL,NULL),(39398,26051,'EM','pastorbilljohnson@gmail.com',0,'2014-02-26 21:02:34',NULL,NULL),(908,561,'AP','9376614447',0,'2013-12-25 17:50:19',NULL,NULL),(3805,2420,'AP','5135209019',0,'2013-12-25 19:33:57',NULL,NULL),(9397,6151,'TE','7138622015',0,'2013-12-26 00:16:31',NULL,NULL),(14089,9213,'TE','6018239161',0,'2013-12-26 04:09:57',NULL,NULL),(14656,9588,'TE','6628517305',0,'2013-12-26 04:37:05',NULL,NULL),(20732,13325,'EM','Christina.wreyford@gmail.com',0,'2013-12-26 12:58:28',NULL,NULL),(22098,14232,'TE','5137915854',0,'2013-12-27 02:05:03',NULL,NULL),(26742,17199,'TE','3306993279',0,'2014-01-13 02:22:23',NULL,NULL),(27459,17690,'AP','3372460976',0,'2014-01-14 01:32:59',NULL,NULL),(27597,17790,'EM','susanmv@cinci.rr.com',0,'2014-01-14 01:33:47',NULL,NULL),(33104,21683,'AP','9376615415',0,'2014-02-05 21:31:03',NULL,NULL),(33786,22175,'EM','autovinyls@yahoo.com',0,'2014-02-08 19:30:08',NULL,NULL),(33919,22263,'EM','floresmaricar@hotmail.com',0,'2014-02-10 11:00:09',NULL,NULL),(35602,23412,'EM','ricardohrivera@yahoo.com',0,'2014-02-13 22:01:17',NULL,NULL),(42316,28101,'TE','3307302794',0,'2014-03-06 21:02:10',NULL,NULL),(42484,28245,'TE','4406542422',0,'2014-03-07 21:00:11',NULL,NULL),(10260,6704,'TE','4192695410',0,'2013-12-26 01:02:01',NULL,NULL),(25547,16480,'AP','5135510267',0,'2014-01-07 04:06:14',NULL,NULL),(3388,2130,'EM','bseifert@fuse.net',0,'2013-12-25 19:17:57',NULL,NULL),(3257,2050,'AP','8177707797',0,'2013-12-25 19:15:50',NULL,NULL),(3699,2346,'TE','9032494279',0,'2013-12-25 19:32:06',NULL,NULL),(27136,17475,'TE','9037805976',0,'2014-01-13 03:01:09',NULL,NULL),(27892,17974,'TE','3306671611',0,'2014-01-15 02:06:50',NULL,NULL),(33845,22218,'AP','2409943415',0,'2014-02-09 19:00:25',NULL,NULL),(1486,913,'TE','4198434561',0,'2013-12-25 18:08:36',NULL,NULL),(2261,1386,'TE','3182207430',0,'2013-12-25 18:46:14',NULL,NULL),(22001,14171,'TE','7145889943',0,'2013-12-27 02:03:27',NULL,NULL),(4070,2597,'AP','9372702265',0,'2013-12-25 19:45:13',NULL,NULL),(6450,4167,'TE','6145650673',0,'2013-12-25 21:49:08',NULL,NULL),(10066,6581,'TE','5138044391',0,'2013-12-26 00:52:59',NULL,NULL),(10458,6812,'EM','pitfan920@netzero.net',0,'2013-12-26 01:30:22',NULL,NULL),(11120,7231,'TE','5132813442',0,'2013-12-26 02:01:23',NULL,NULL),(24112,15566,'TE','3305244993',1,'2014-01-02 04:31:44',NULL,NULL),(29984,19408,'EM','msgruich@yahoo.com',1,'2014-01-22 03:22:57',NULL,NULL),(30663,19905,'AP','6146336516',0,'2014-01-24 21:00:57',NULL,NULL),(31163,20293,'AP','9855148863',0,'2014-01-28 21:00:38',NULL,NULL),(31715,20699,'TE','2259210557',0,'2014-01-30 21:01:02',NULL,NULL),(32474,21217,'AP','5048129425',0,'2014-02-03 21:01:02',NULL,NULL),(32843,21494,'TE','5138076618',0,'2014-02-04 21:01:49',NULL,NULL),(36224,23842,'AP','4193457128',0,'2014-02-14 21:31:53',NULL,NULL),(36859,24273,'EM','mark@bambergerlaw.com',0,'2014-02-17 19:00:18',NULL,NULL),(36949,24334,'TE','5129939862',0,'2014-02-18 22:00:15',NULL,NULL),(42284,28080,'TE','2102770802',0,'2014-03-06 21:01:57',NULL,NULL),(646,402,'TE','7403421104',0,'2013-12-25 17:46:11',NULL,NULL),(9234,6044,'EM','heskamp.josh@gmail.com',0,'2013-12-26 00:01:30',NULL,NULL),(1299,791,'AP','9407049647',0,'2013-12-25 18:05:19',NULL,NULL),(2066,1278,'EM','crlemke@gmail.com',0,'2013-12-25 18:30:29',NULL,NULL),(5921,3797,'EM','j.mark.milano@gmail.com',0,'2013-12-25 21:34:25',NULL,NULL),(6209,4000,'TE','6144206565',0,'2013-12-25 21:45:11',NULL,NULL),(8955,5864,'AP','3303542278',0,'2013-12-25 23:49:05',NULL,NULL),(2612,1591,'TE','8322367444',0,'2013-12-25 18:51:45',NULL,NULL),(2731,1657,'TE','2542051596',0,'2013-12-25 18:53:31',NULL,NULL),(4151,2648,'AP','2107227270',0,'2013-12-25 19:46:33',NULL,NULL),(2811,1700,'EM','pam_d_holley@yahoo.com',0,'2013-12-25 18:54:42',NULL,NULL),(3009,1869,'EM','obarnett@sbcglobal.net',0,'2013-12-25 18:58:16',NULL,NULL),(27426,17665,'AP','5132755620',0,'2014-01-14 01:32:47',NULL,NULL),(30844,20050,'TE','3235402017',0,'2014-01-27 21:00:04',NULL,NULL),(31152,20289,'TE','9042390524',0,'2014-01-28 21:00:35',NULL,NULL),(34786,22816,'TE','2342009978',0,'2014-02-11 21:02:00',NULL,NULL),(35829,23562,'AP','4199802203',0,'2014-02-13 22:02:44',NULL,NULL),(36711,24170,'EM','dwilliams113@comcast.net',0,'2014-02-15 22:02:09',NULL,NULL),(38362,25340,'TE','3183817798',0,'2014-02-25 21:30:24',NULL,NULL),(43651,28972,'TE','9852318050',0,'2014-03-10 21:01:03',NULL,NULL),(9911,6486,'AP','3303973066',0,'2013-12-26 00:50:27',NULL,NULL),(22499,14506,'TE','8017191660',0,'2013-12-28 03:33:55',NULL,NULL),(21301,13684,'EM','terrieshaheen@yahoo.com',0,'2013-12-26 13:08:17',NULL,NULL),(1557,959,'TE','9728388762',0,'2013-12-25 18:09:45',NULL,NULL),(3165,1981,'AP','8176816774',0,'2013-12-25 19:01:43',NULL,NULL),(7746,5057,'AP','9048910808',0,'2013-12-25 23:00:20',NULL,NULL),(4745,3039,'AP','4199613877',0,'2013-12-25 20:18:36',NULL,NULL),(23321,15026,'TE','3188346655',0,'2014-01-01 12:02:28',NULL,NULL),(23344,15039,'EM','jme5873@gmail.com',0,'2014-01-01 12:02:54',NULL,NULL),(23479,15141,'EM','shonziasanders@gmail.com',0,'2014-01-01 12:05:46',NULL,NULL),(25112,16189,'EM','redtxn2@gmail.com',0,'2014-01-05 00:00:47',NULL,NULL),(27347,17609,'TE','8306655668',0,'2014-01-14 01:32:20',NULL,NULL),(28337,18260,'EM','LOUISCONSTANCIO@GMAIL.COM',0,'2014-01-16 08:44:36',NULL,NULL),(29484,19057,'AP','6017096957',0,'2014-01-21 08:44:13',NULL,NULL),(35327,23213,'TE','9373833664',0,'2014-02-12 21:32:14',NULL,NULL),(36956,24336,'EM','vguzman@recruitveterans.com',0,'2014-02-18 22:00:17',NULL,NULL),(37291,24539,'EM','esalazar00@yahoo.com',0,'2014-02-20 04:02:14',NULL,NULL),(43986,29182,'TE','9372161690',0,'2014-03-10 21:29:58',NULL,NULL),(38094,25145,'AP','9729891283',0,'2014-02-21 22:00:13',NULL,NULL),(39893,26400,'AP','3304648849',0,'2014-02-28 07:00:31',NULL,NULL),(278,172,'AP','3302311311',0,'2013-12-25 17:19:27',NULL,NULL),(10746,6987,'TE','5136737147',0,'2013-12-26 01:47:52',NULL,NULL),(21929,14127,'TE','2253154699',0,'2013-12-27 02:02:17',NULL,NULL),(4924,3161,'TE','9372287635',0,'2013-12-25 20:31:19',NULL,NULL),(20640,13276,'AP','9032383473',0,'2013-12-26 12:57:03',NULL,NULL),(14213,9301,'TE','4198893581',0,'2013-12-26 04:16:23',NULL,NULL),(25972,16728,'AP','3304171459',0,'2014-01-08 18:24:49',NULL,NULL),(26312,16941,'TE','2259213169',0,'2014-01-13 02:19:54',NULL,NULL),(38943,25746,'AP','4193068063',0,'2014-02-26 09:30:43',NULL,NULL),(1347,822,'EM','BIKERMAXIMUS@YAHOO.COM',0,'2013-12-25 18:06:07',NULL,NULL),(8538,5607,'EM','teerosa12@yahoo.com',0,'2013-12-25 23:30:28',NULL,NULL),(5724,3672,'TE','5134744521',0,'2013-12-25 21:31:12',NULL,NULL),(6349,4091,'EM','justin.edens@websmart.com',0,'2013-12-25 21:47:27',NULL,NULL),(4003,2545,'TE','3306861342',0,'2013-12-25 19:37:08',NULL,NULL),(21905,14111,'EM','lizmathews@me.com',0,'2013-12-27 02:01:52',NULL,NULL),(23817,15365,'EM','ss.sejdic@yahoo.com',1,'2014-01-02 04:24:55',NULL,NULL),(24388,15748,'TE','3256601966',0,'2014-01-03 02:01:04',NULL,NULL),(25835,16656,'EM','angelabilbo33@gmail.com',0,'2014-01-08 18:24:22',NULL,NULL),(29026,18740,'AP','9373291991',0,'2014-01-17 03:35:40',NULL,NULL),(29654,19157,'BN','3309836764',0,'2014-01-21 08:45:39',NULL,NULL),(30737,19972,'TE','4198337455',0,'2014-01-25 19:00:12',NULL,NULL),(41546,27625,'AP','6145157938',0,'2014-03-05 21:30:07',NULL,NULL),(8785,5756,'AP','7407045473',0,'2013-12-25 23:46:23',NULL,NULL),(1786,1106,'TE','4409743285',0,'2013-12-25 18:17:24',NULL,NULL),(13969,9106,'EM','programs@meigsseniors.com',0,'2013-12-26 04:07:31',NULL,NULL),(8276,5420,'TE','6014701838',0,'2013-12-25 23:09:23',NULL,NULL),(5213,3349,'TE','5128077169',0,'2013-12-25 21:16:41',NULL,NULL),(11628,7563,'EM','hattarray@yahoo.com',0,'2013-12-26 02:33:34',NULL,NULL),(11482,7467,'TE','5133607640',0,'2013-12-26 02:31:06',NULL,NULL),(26492,17049,'TE','7403414041',0,'2014-01-13 02:20:56',NULL,NULL),(27719,17866,'EM','lynnejj@yahoo.com',0,'2014-01-15 02:06:12',NULL,NULL),(29756,19241,'EM','272easy@gmail.com',0,'2014-01-21 08:46:38',NULL,NULL),(31326,20415,'TE','4193413104',0,'2014-01-29 21:00:27',NULL,NULL),(36257,23859,'EM','sillywilly4d@aol.com',0,'2014-02-14 21:32:04',NULL,NULL),(39226,25947,'EM','MOREYTOM@YAHOO.COM',0,'2014-02-26 21:01:34',NULL,NULL),(40382,26805,'AP','6148040572',0,'2014-03-01 21:00:25',NULL,NULL),(41337,27461,'TE','3306335688',0,'2014-03-04 21:02:06',NULL,NULL),(43946,29150,'AP','5136586803',0,'2014-03-10 21:02:49',NULL,NULL),(9463,6192,'EM','dlc7509@aol.com',0,'2013-12-26 00:30:22',NULL,NULL),(1358,829,'TE','3308823707',0,'2013-12-25 18:06:18',NULL,NULL),(7494,4882,'TE','4139490300',0,'2013-12-25 22:31:15',NULL,NULL),(10588,6890,'TE','5043622129',0,'2013-12-26 01:45:21',NULL,NULL),(22017,14179,'EM','jim@frienergy.com',0,'2013-12-27 02:03:41',NULL,NULL),(22901,14775,'AP','2145178397',1,'2013-12-29 11:13:04',NULL,NULL),(26169,16848,'EM','doliver1654@yahoo.com',0,'2014-01-13 02:18:38',NULL,NULL),(27337,17603,'AP','5122879705',0,'2014-01-14 01:32:17',NULL,NULL),(28466,18342,'EM','KENNETHRBROWNING@GMAIL.COM',0,'2014-01-16 08:45:18',NULL,NULL),(31050,20199,'AP','6018320622',0,'2014-01-27 21:01:31',NULL,NULL),(32255,21068,'EM','jenniferyaegel31@gmail.com',0,'2014-02-02 19:00:15',NULL,NULL),(33960,22281,'EM','ashakisharp@rocketmail.com',0,'2014-02-10 11:00:22',NULL,NULL),(33994,22298,'AP','2162256086',0,'2014-02-10 11:00:35',NULL,NULL),(36030,23697,'EM','jwentzel575@gmail.com',0,'2014-02-14 21:30:41',NULL,NULL),(37425,24646,'TE','3182642812',0,'2014-02-20 04:21:21',NULL,NULL),(39828,26343,'TE','4192704704',0,'2014-02-28 06:31:44',NULL,NULL),(40394,26812,'AP','4192625322',0,'2014-03-01 21:00:29',NULL,NULL),(839,520,'EM','rursetti@carlislecbf.com',0,'2013-12-25 17:49:12',NULL,NULL),(8083,5291,'TE','2057463319',0,'2013-12-25 23:06:03',NULL,NULL),(5674,3645,'AP','2343127647',0,'2013-12-25 21:30:29',NULL,NULL),(14410,9422,'TE','5757061888',0,'2013-12-26 04:33:09',NULL,NULL),(11419,7428,'AP','3302241607',0,'2013-12-26 02:30:05',NULL,NULL),(5057,3247,'TE','6147173797',0,'2013-12-25 20:46:31',NULL,NULL),(4424,2819,'EM','sharonredmond66@gmail.com',0,'2013-12-25 20:00:28',NULL,NULL),(23822,15369,'TE','9372697678',1,'2014-01-02 04:25:01',NULL,NULL),(25383,16369,'EM','susannahooper@mac.com',0,'2014-01-07 04:03:01',NULL,NULL),(30199,19563,'EM','cadess33@hotmail.com',0,'2014-01-23 03:02:34',NULL,NULL),(30941,20119,'AP','6143711786',0,'2014-01-27 21:00:45',NULL,NULL),(32165,21011,'EM','tlemanh@gmail.com',0,'2014-02-01 19:00:34',NULL,NULL),(36045,23710,'TE','6145962960',0,'2014-02-14 21:30:46',NULL,NULL),(37100,24424,'AP','5132597731',0,'2014-02-18 22:01:10',NULL,NULL),(38517,25455,'TE','9564583172',0,'2014-02-25 21:31:28',NULL,NULL),(39842,26353,'AP','5133170448',0,'2014-02-28 06:31:48',NULL,NULL),(41758,27767,'TE','5043676457',0,'2014-03-05 21:31:24',NULL,NULL),(42259,28068,'TE','5676744078',0,'2014-03-06 21:01:48',NULL,NULL),(7579,4934,'TE','9372160064',0,'2013-12-25 22:45:30',NULL,NULL),(25679,16554,'AP','3373036581',1,'2014-01-07 10:22:51',NULL,NULL),(22051,14202,'TE','9792569525',0,'2013-12-27 02:04:16',NULL,NULL),(4111,2622,'AP','2163754944',0,'2013-12-25 19:45:54',NULL,NULL),(2641,1606,'EM','tonycollins50@msn.com',0,'2013-12-25 18:52:11',NULL,NULL),(21251,13657,'AP','5044273005',0,'2013-12-26 13:07:31',NULL,NULL),(1583,977,'TE','9372183946',0,'2013-12-25 18:10:11',NULL,NULL),(28837,18615,'EM','mac050@hotmail.com',0,'2014-01-16 08:47:25',NULL,NULL),(30347,19664,'AP','3303960078',0,'2014-01-23 21:00:27',NULL,NULL),(30537,19809,'AP','2542279334',0,'2014-01-24 21:00:08',NULL,NULL),(31498,20524,'AP','4193103272',0,'2014-01-29 21:01:27',NULL,NULL),(32163,21008,'AP','9377251262',0,'2014-02-01 19:00:33',NULL,NULL),(32603,21317,'TE','5047376338',0,'2014-02-04 21:00:21',NULL,NULL),(39197,25924,'AP','9032407689',0,'2014-02-26 21:01:22',NULL,NULL),(256,157,'TE','2104277673',0,'2013-12-25 17:19:05',NULL,NULL),(23199,14952,'TE','9566395295',0,'2014-01-01 12:00:13',NULL,NULL),(23084,14889,'EM','jasminecapers90@gmail.com',0,'2013-12-30 00:00:44',NULL,NULL),(22119,14249,'TE','9566836260',0,'2013-12-27 02:05:27',NULL,NULL),(4585,2926,'TE','5132514664',0,'2013-12-25 20:15:54',NULL,NULL),(21882,14100,'TE','7407077558',0,'2013-12-27 02:01:33',NULL,NULL),(23722,15308,'TE','3186234214',1,'2014-01-02 04:23:06',NULL,NULL),(25851,16664,'TE','3185371514',0,'2014-01-08 18:24:26',NULL,NULL),(28086,18102,'AP','3183311657',0,'2014-01-15 02:07:34',NULL,NULL),(28344,18264,'AP','3614827263',0,'2014-01-16 08:44:38',NULL,NULL),(28705,18522,'EM','aubreyzeppa@gmail.com',0,'2014-01-16 08:46:39',NULL,NULL),(31956,20867,'AP','4193469485',0,'2014-01-31 21:00:59',NULL,NULL),(35004,22984,'TE','4357572440',0,'2014-02-12 21:30:10',NULL,NULL),(35216,23130,'AP','5137676045',0,'2014-02-12 21:31:29',NULL,NULL),(36312,23907,'AP','9372152915',0,'2014-02-14 21:32:28',NULL,NULL),(39786,26306,'BN','8178965626',0,'2014-02-28 06:31:31',NULL,NULL),(8663,5689,'EM','drmustain3@gmail.com',0,'2013-12-25 23:32:33',NULL,NULL),(5105,3274,'TE','5132527622',0,'2013-12-25 21:15:03',NULL,NULL),(11724,7632,'TE','9723633849',0,'2013-12-26 02:46:17',NULL,NULL),(23984,15483,'AP','6144195591',1,'2014-01-02 04:29:13',NULL,NULL),(24259,15678,'TE','9377980337',1,'2014-01-02 04:34:53',NULL,NULL),(25237,16274,'TE','9377768537',0,'2014-01-07 04:00:22',NULL,NULL),(26660,17150,'EM','daniboudreau@gmail.com',0,'2014-01-13 02:21:56',NULL,NULL),(27170,17494,'EM','terrklin436@hotmail.com',0,'2014-01-13 03:01:21',NULL,NULL),(28039,18070,'TE','3183902034',0,'2014-01-15 02:07:23',NULL,NULL),(31285,20381,'TE','9565219341',0,'2014-01-29 21:00:11',NULL,NULL),(36282,23889,'TE','5137341122',0,'2014-02-14 21:32:17',NULL,NULL),(36814,24238,'AP','5672049424',0,'2014-02-16 19:00:38',NULL,NULL),(39250,25966,'EM','CENGLE2@CINCI.RR.COM',0,'2014-02-26 21:01:44',NULL,NULL),(40596,26948,'AP','9378305215',0,'2014-03-03 01:00:25',NULL,NULL),(42145,27999,'EM','RMEarhart@gmail.com',0,'2014-03-06 21:01:08',NULL,NULL),(43065,28631,'TE','9567875725',0,'2014-03-08 21:30:27',NULL,NULL),(9617,6293,'EM','agnusdei191@gmail.com',0,'2013-12-26 00:45:43',NULL,NULL),(20833,13391,'AP','5132922861',0,'2013-12-26 13:00:09',NULL,NULL),(20718,13317,'AP','2819717967',0,'2013-12-26 12:58:15',NULL,NULL),(14227,9309,'EM','ttalbot1@bellsouth.net',0,'2013-12-26 04:30:12',NULL,NULL),(7989,5213,'EM','bmcnulty12@gmail.com',0,'2013-12-25 23:04:21',NULL,NULL),(2922,1795,'TE','2126410808',0,'2013-12-25 18:56:38',NULL,NULL),(3875,2463,'AP','5044818688',0,'2013-12-25 19:35:00',NULL,NULL),(4132,2634,'EM','jtoth10570@msn.com',0,'2013-12-25 19:46:13',NULL,NULL),(24405,15758,'TE','9722272789',0,'2014-01-03 02:01:23',NULL,NULL),(24619,15876,'AP','6095669668',0,'2014-01-03 02:05:16',NULL,NULL),(26138,16826,'EM','bmcgin1841@aol.com',0,'2014-01-13 02:18:26',NULL,NULL),(26564,17087,'AP','2103286278',0,'2014-01-13 02:21:26',NULL,NULL),(26637,17139,'TE','4197891192',0,'2014-01-13 02:21:51',NULL,NULL),(26889,17299,'AP','9562663751',0,'2014-01-13 02:23:37',NULL,NULL),(28417,18309,'TE','5136623039',0,'2014-01-16 08:45:01',NULL,NULL),(31287,20383,'TE','2548332483',0,'2014-01-29 21:00:12',NULL,NULL),(31501,20526,'EM','tiffanybuzinski@gmail.com',0,'2014-01-29 21:01:28',NULL,NULL),(31810,20769,'AP','4195167817',0,'2014-01-30 21:01:39',NULL,NULL),(32709,21396,'TE','4193498118',0,'2014-02-04 21:01:00',NULL,NULL),(32795,21456,'EM','ralyttle54@gmail.com',0,'2014-02-04 21:01:31',NULL,NULL),(33923,22265,'TE','9152587859',0,'2014-02-10 11:00:10',NULL,NULL),(34255,22469,'AP','6628093667',0,'2014-02-10 21:30:57',NULL,NULL),(37747,24905,'TE','5628320418',0,'2014-02-20 21:30:04',NULL,NULL),(38440,25403,'EM','treshabunce@hotmail.com',0,'2014-02-25 21:30:58',NULL,NULL),(41300,27439,'TE','2257882772',0,'2014-03-04 21:01:52',NULL,NULL),(41519,27604,'EM','krmjohnson@gmail.com',0,'2014-03-05 21:00:25',NULL,NULL),(42431,28182,'EM','rioschica51@yahoo.com',0,'2014-03-06 21:02:55',NULL,NULL),(6638,4299,'AP','4192176370',0,'2013-12-25 21:52:19',NULL,NULL),(22071,14213,'EM','Cd0677@att.net',0,'2013-12-27 02:04:34',NULL,NULL),(4195,2683,'AP','7407013835',0,'2013-12-25 19:47:17',NULL,NULL),(10516,6848,'AP','9564590067',0,'2013-12-26 01:31:20',NULL,NULL),(6380,4110,'TE','7404350012',0,'2013-12-25 21:47:59',NULL,NULL),(23528,15180,'EM','jahinds57@gmail.com',0,'2014-01-01 12:06:49',NULL,NULL),(26926,17319,'EM','richard.polylepis@gmail.com',0,'2014-01-13 02:23:49',NULL,NULL),(31115,20258,'EM','chefmjm15@gmail.com',0,'2014-01-28 21:00:17',NULL,NULL),(34169,22408,'TE','5047102914',0,'2014-02-10 21:30:24',NULL,NULL),(35393,23262,'TE','3306664274',0,'2014-02-13 21:30:10',NULL,NULL),(40892,27171,'TE','8329646161',0,'2014-03-03 21:31:05',NULL,NULL),(42753,28439,'TE','4193060645',0,'2014-03-07 21:31:12',NULL,NULL),(43273,28748,'EM','ddh2755@gmail.com',0,'2014-03-09 21:00:15',NULL,NULL),(43835,29094,'EM','dflem_42@yahoo.com',0,'2014-03-10 21:02:12',NULL,NULL),(810,504,'EM','williswhill1@gmail.com',0,'2013-12-25 17:48:46',NULL,NULL),(1970,1218,'EM','FORSILVIA41@YAHOO.COM',0,'2013-12-25 18:20:20',NULL,NULL),(20980,13504,'TE','2253562510',0,'2013-12-26 13:02:41',NULL,NULL),(14079,9203,'AP','3309790488',0,'2013-12-26 04:09:44',NULL,NULL),(2371,1439,'EM','orteness@yahoo.com',0,'2013-12-25 18:47:49',NULL,NULL),(3004,1860,'TE','3306073344',0,'2013-12-25 18:58:08',NULL,NULL),(12260,8016,'TE','7242885533',0,'2013-12-26 03:08:47',NULL,NULL),(4475,2849,'TE','2169398533',0,'2013-12-25 20:01:18',NULL,NULL),(5690,3654,'EM','alicabosch@yahoo.com',0,'2013-12-25 21:30:43',NULL,NULL),(22753,14673,'AP','6018076585',1,'2013-12-29 11:08:19',NULL,NULL),(24359,15730,'EM','ucm@case.edu',0,'2014-01-03 02:00:29',NULL,NULL),(32116,20971,'AP','9152530638',0,'2014-02-01 19:00:15',NULL,NULL),(35070,23030,'BN','7139924779',0,'2014-02-12 21:30:34',NULL,NULL),(36559,24068,'TE','3303105760',0,'2014-02-15 22:01:14',NULL,NULL),(36757,24204,'TE','3306716191',0,'2014-02-16 19:00:19',NULL,NULL),(37053,24402,'TE','4403277632',0,'2014-02-18 22:00:55',NULL,NULL),(37366,24596,'AP','3304161204',0,'2014-02-20 04:12:21',NULL,NULL),(40970,27223,'TE','6018852397',0,'2014-03-03 21:31:36',NULL,NULL),(42558,28319,'TE','2103911739',0,'2014-03-07 21:30:04',NULL,NULL),(125,73,'TE','4195299917',0,'2013-12-25 17:17:00',NULL,NULL),(1053,649,'EM','rchartman@roadrunner.com',0,'2013-12-25 18:01:33',NULL,NULL),(8959,5868,'AP','4402319513',0,'2013-12-25 23:49:09',NULL,NULL),(3130,1950,'TE','4405482715',0,'2013-12-25 19:00:57',NULL,NULL),(4412,2811,'TE','5132568954',0,'2013-12-25 20:00:14',NULL,NULL),(11209,7292,'TE','4404208513',0,'2013-12-26 02:02:54',NULL,NULL),(6516,4212,'TE','8326469831',0,'2013-12-25 21:50:13',NULL,NULL),(23843,15383,'EM','iluvmyxb@yahoo.com',1,'2014-01-02 04:25:30',NULL,NULL),(25748,16594,'TE','5047013529',0,'2014-01-08 18:24:02',NULL,NULL),(27612,17802,'TE','4199800565',0,'2014-01-14 01:33:54',NULL,NULL),(28765,18561,'AP','9375159782',0,'2014-01-16 08:46:59',NULL,NULL),(31659,20652,'EM','nancycarlosgarcia89@gmail.com',0,'2014-01-30 21:00:39',NULL,NULL),(33935,22270,'TE','8305963635',0,'2014-02-10 11:00:14',NULL,NULL),(34787,22816,'AP','2342009978',0,'2014-02-11 21:02:00',NULL,NULL),(36651,24127,'TE','3182431010',0,'2014-02-15 22:01:46',NULL,NULL),(39970,26462,'EM','paulaleboeuf@bellsouth.net',0,'2014-02-28 07:30:32',NULL,NULL),(42080,27960,'TE','9852324053',0,'2014-03-06 21:00:44',NULL,NULL),(9637,6305,'EM','BoondocksDaddy@yahoo.com',0,'2013-12-26 00:46:02',NULL,NULL),(7217,4702,'TE','3217957720',0,'2013-12-25 22:08:27',NULL,NULL),(14247,9320,'AP','2253244086',0,'2013-12-26 04:30:29',NULL,NULL),(4287,2738,'AP','5672083127',0,'2013-12-25 19:48:42',NULL,NULL),(3329,2093,'TE','3375153050',0,'2013-12-25 19:16:57',NULL,NULL),(5728,3674,'TE','5139261369',0,'2013-12-25 21:31:16',NULL,NULL),(6151,3961,'TE','3306509474',0,'2013-12-25 21:38:24',NULL,NULL),(25486,16432,'EM','pw2314@gmail.com',0,'2014-01-07 04:04:52',NULL,NULL),(31780,20745,'EM','SLaub91487@gmail.com',0,'2014-01-30 21:01:26',NULL,NULL),(36397,23971,'AP','2259545110',0,'2014-02-15 22:00:14',NULL,NULL),(37773,24927,'EM','jpc@uakron.edu',0,'2014-02-20 21:30:18',NULL,NULL),(39939,26429,'AP','6148879079',0,'2014-02-28 07:30:15',NULL,NULL),(8827,5780,'TE','5135463609',0,'2013-12-25 23:47:02',NULL,NULL),(25424,16397,'AP','8474069269',0,'2014-01-07 04:03:46',NULL,NULL),(23635,15263,'AP','4192505562',0,'2014-01-01 12:09:21',NULL,NULL),(23450,15114,'TE','7404210978',0,'2014-01-01 12:05:04',NULL,NULL),(22844,14740,'EM','mb242027@yahoo.com',1,'2013-12-29 11:10:01',NULL,NULL),(3060,1903,'TE','9376385707',0,'2013-12-25 18:59:12',NULL,NULL),(8234,5387,'AP','3372789931',0,'2013-12-25 23:08:33',NULL,NULL),(8514,5598,'TE','2257186978',0,'2013-12-25 23:30:11',NULL,NULL),(13584,8857,'TE','9729614136',0,'2013-12-26 04:01:11',NULL,NULL),(14340,9374,'EM','lbrustie@gmail.com',0,'2013-12-26 04:31:54',NULL,NULL),(20972,13498,'AP','5132574801',0,'2013-12-26 13:02:32',NULL,NULL),(1079,664,'AP','7174718400',0,'2013-12-25 18:01:57',NULL,NULL),(21047,13539,'AP','5044286949',0,'2013-12-26 13:03:43',NULL,NULL),(26953,17335,'TE','5047103749',0,'2014-01-13 02:23:59',NULL,NULL),(28676,18500,'TE','3303365196',0,'2014-01-16 08:46:29',NULL,NULL),(31943,20850,'EM','eriemechllc@aol.com',0,'2014-01-31 21:00:52',NULL,NULL),(31959,20868,'AP','6018327849',0,'2014-01-31 21:01:00',NULL,NULL),(33589,22020,'AP','2813822686',0,'2014-02-07 19:00:58',NULL,NULL),(33893,22245,'TE','9012186212',0,'2014-02-09 19:00:40',NULL,NULL),(42026,27933,'TE','9567241036',0,'2014-03-06 21:00:27',NULL,NULL),(35512,23355,'TE','3308147887',0,'2014-02-13 22:00:43',NULL,NULL),(37513,24705,'TE','6143269323',0,'2014-02-20 04:34:52',NULL,NULL),(39324,26010,'EM','cybergtw@gmail.com',0,'2014-02-26 21:02:10',NULL,NULL),(40061,26562,'TE','5137294653',0,'2014-02-28 21:30:20',NULL,NULL),(10680,6938,'EM','tammyselick@gmail.com',0,'2013-12-26 01:46:44',NULL,NULL),(23202,14953,'TE','2102622229',0,'2014-01-01 12:00:15',NULL,NULL),(22828,14722,'AP','3373687656',1,'2013-12-29 11:09:36',NULL,NULL),(9071,5947,'AP','8597538555',0,'2013-12-25 23:51:01',NULL,NULL),(7105,4640,'TE','6012593436',0,'2013-12-25 22:06:46',NULL,NULL),(11001,7144,'TE','7189306357',0,'2013-12-26 01:51:59',NULL,NULL),(12175,7953,'AP','5043469946',0,'2013-12-26 03:07:14',NULL,NULL),(12436,8147,'AP','4699648288',0,'2013-12-26 03:15:55',NULL,NULL),(9657,6321,'TE','6147361100',0,'2013-12-26 00:46:22',NULL,NULL),(13794,8994,'TE','9378300732',0,'2013-12-26 04:04:39',NULL,NULL),(2500,1534,'AP','6145632195',0,'2013-12-25 18:50:06',NULL,NULL),(29873,19328,'AP','2144229690',1,'2014-01-22 03:22:15',NULL,NULL),(35898,23616,'AP','4199445934',0,'2014-02-13 22:03:15',NULL,NULL),(37696,24854,'TE','9373227216',0,'2014-02-20 04:55:53',NULL,NULL),(40335,26769,'TE','2252471631',0,'2014-03-01 19:00:13',NULL,NULL),(43215,28718,'AP','5133351223',0,'2014-03-08 21:31:19',NULL,NULL),(43713,29020,'TE','6147474848',0,'2014-03-10 21:01:29',NULL,NULL),(114,68,'TE','5135034270',0,'2013-12-25 17:16:51',NULL,NULL),(25181,16238,'TE','9858695005',0,'2014-01-05 00:02:16',NULL,NULL),(24011,15504,'AP','6146790453',1,'2014-01-02 04:29:50',NULL,NULL),(1860,1149,'TE','2259785167',0,'2013-12-25 18:18:34',NULL,NULL),(1761,1086,'TE','4408583641',0,'2013-12-25 18:16:55',NULL,NULL),(352,218,'TE','9089064813',0,'2013-12-25 17:20:41',NULL,NULL),(26525,17064,'EM','frenchy.mckenzie@gmail.com',0,'2014-01-13 02:21:14',NULL,NULL),(28751,18555,'TE','4195990293',0,'2014-01-16 08:46:55',NULL,NULL),(28954,18690,'TE','3186259928',0,'2014-01-17 03:35:24',NULL,NULL),(30016,19437,'EM','melrayn@yahoo.com',1,'2014-01-22 03:23:11',NULL,NULL),(31303,20398,'TE','2145210734',0,'2014-01-29 21:00:18',NULL,NULL),(32561,21292,'EM','cynthia7611@att.net',0,'2014-02-04 21:00:07',NULL,NULL),(34668,22731,'EM','zwatson@bchsnola.org',0,'2014-02-11 21:01:15',NULL,NULL),(36548,24064,'TE','3303175326',0,'2014-02-15 22:01:11',NULL,NULL),(38543,25469,'EM','resourceatm@sbcglobal.net',0,'2014-02-25 21:31:36',NULL,NULL),(40959,27216,'AP','6012872978',0,'2014-03-03 21:31:32',NULL,NULL),(41646,27683,'EM','ITZYLEYVA@GMAIL.COM',0,'2014-03-05 21:30:40',NULL,NULL),(9620,6294,'EM','johnyhotrod@sbcglobal.net',0,'2013-12-26 00:45:45',NULL,NULL),(22358,14419,'AP','8322358299',0,'2013-12-28 03:31:39',NULL,NULL),(2913,1787,'TE','6142726003',0,'2013-12-25 18:56:29',NULL,NULL),(4951,3177,'AP','5045599958',0,'2013-12-25 20:31:45',NULL,NULL),(6297,4059,'TE','5132881477',0,'2013-12-25 21:46:37',NULL,NULL),(2318,1414,'EM','dylwil42@gmail.com',0,'2013-12-25 18:47:03',NULL,NULL),(12016,7828,'EM','Crawbuick@yahoo.com',0,'2013-12-26 03:04:22',NULL,NULL),(14861,9723,'TE','5137937685',0,'2013-12-26 04:45:32',NULL,NULL),(20221,13025,'TE','2165981642',0,'2013-12-26 12:50:13',NULL,NULL),(20382,13127,'TE','4402882303',0,'2013-12-26 12:52:56',NULL,NULL),(6558,4236,'AP','5129989257',0,'2013-12-25 21:50:52',NULL,NULL),(21151,13600,'TE','4196438189',0,'2013-12-26 13:05:24',NULL,NULL),(6756,4385,'TE','2162613198',0,'2013-12-25 22:00:44',NULL,NULL),(27904,17980,'AP','2342231922',0,'2014-01-15 02:06:53',NULL,NULL),(31995,20889,'TE','5135198509',0,'2014-01-31 21:01:13',NULL,NULL),(37140,24448,'TE','2255058712',0,'2014-02-18 22:01:24',NULL,NULL),(40717,27060,'AP','5045081985',0,'2014-03-03 21:29:59',NULL,NULL),(2556,1561,'AP','6015072147',0,'2013-12-25 18:50:55',NULL,NULL),(3934,2495,'AP','5042526546',0,'2013-12-25 19:35:54',NULL,NULL),(3823,2431,'EM','imsimage@aol.com',0,'2013-12-25 19:34:12',NULL,NULL),(7949,5186,'EM','emailamyv@gmail.com',0,'2013-12-25 23:03:39',NULL,NULL),(4296,2742,'AP','3306033903',0,'2013-12-25 19:48:50',NULL,NULL),(8776,5751,'AP','2252661457',0,'2013-12-25 23:46:14',NULL,NULL),(13927,9080,'EM','Mcilvainbri@yahoo.com',0,'2013-12-26 04:06:50',NULL,NULL),(14755,9650,'EM','tierrejr@yahoo.com',0,'2013-12-26 04:38:45',NULL,NULL),(3397,2135,'AP','7202716650',0,'2013-12-25 19:18:05',NULL,NULL),(2732,1657,'AP','2542051596',0,'2013-12-25 18:53:32',NULL,NULL),(30959,20138,'TE','4198104361',0,'2014-01-27 21:00:56',NULL,NULL),(34066,22334,'TE','3254554292',0,'2014-02-10 11:01:03',NULL,NULL),(34872,22868,'EM','youngstowno@yahoo.com',0,'2014-02-11 21:02:29',NULL,NULL),(40091,26588,'TE','4402313214',0,'2014-02-28 21:30:35',NULL,NULL),(1692,1040,'TE','9564043511',0,'2013-12-25 18:15:45',NULL,NULL),(11847,7710,'TE','4404617597',0,'2013-12-26 03:01:28',NULL,NULL),(13531,8823,'EM','snhrr@aol.com',0,'2013-12-26 04:00:20',NULL,NULL),(13703,8932,'TE','2169730614',0,'2013-12-26 04:03:04',NULL,NULL),(10401,6780,'TE','4097673192',0,'2013-12-26 01:16:50',NULL,NULL),(14845,9715,'TE','6142357779',0,'2013-12-26 04:45:18',NULL,NULL),(20373,13123,'TE','4407300890',0,'2013-12-26 12:52:48',NULL,NULL),(20589,13244,'EM','calliemae07@ymail.com',0,'2013-12-26 12:56:12',NULL,NULL),(8678,5697,'AP','4409850021',0,'2013-12-25 23:32:48',NULL,NULL),(21078,13554,'EM','albert.vazquez112@yahoo.com',0,'2013-12-26 13:04:11',NULL,NULL),(8052,5274,'TE','3302558747',0,'2013-12-25 23:05:36',NULL,NULL),(2971,1842,'TE','3307693776',0,'2013-12-25 18:57:40',NULL,NULL),(2446,1499,'EM','mrsd01@gmail.com',0,'2013-12-25 18:49:15',NULL,NULL),(31491,20522,'TE','8328912892',0,'2014-01-29 21:01:25',NULL,NULL),(32237,21055,'AP','5168575180',0,'2014-02-02 19:00:08',NULL,NULL),(33796,22188,'TE','3305621694',0,'2014-02-09 19:00:07',NULL,NULL),(34009,22308,'AP','6019133288',0,'2014-02-10 11:00:42',NULL,NULL),(36448,24001,'TE','5132922388',0,'2014-02-15 22:00:33',NULL,NULL),(38403,25370,'TE','3305548025',0,'2014-02-25 21:30:41',NULL,NULL),(43580,28939,'TE','4192768197',0,'2014-03-10 21:00:42',NULL,NULL),(1160,711,'EM','debthemom2003@yahoo.com',0,'2013-12-25 18:03:13',NULL,NULL),(1803,1116,'EM','deestaten64@gmail.com',0,'2013-12-25 18:17:40',NULL,NULL),(3234,2033,'TE','2816909544',0,'2013-12-25 19:15:24',NULL,NULL),(8398,5526,'AP','5136681072',0,'2013-12-25 23:15:28',NULL,NULL),(9257,6058,'TE','5138872755',0,'2013-12-26 00:01:52',NULL,NULL),(9618,6294,'TE','4405211621',0,'2013-12-26 00:45:44',NULL,NULL),(9847,6440,'TE','5042587929',0,'2013-12-26 00:49:25',NULL,NULL),(10025,6558,'AP','4697590262',0,'2013-12-26 00:52:21',NULL,NULL),(1290,785,'TE','9406963476',0,'2013-12-25 18:05:09',NULL,NULL),(12219,7986,'TE','3309315916',0,'2013-12-26 03:08:04',NULL,NULL),(13827,9014,'EM','garling76@gmail.com',0,'2013-12-26 04:05:11',NULL,NULL),(14763,9656,'TE','9378645996',0,'2013-12-26 04:38:54',NULL,NULL),(20511,13204,'EM','terry@channelmatch.com',0,'2013-12-26 12:55:04',NULL,NULL),(21899,14109,'AP','9376682294',0,'2013-12-27 02:01:48',NULL,NULL),(5818,3735,'EM','landmlwl@sbcglobal.net',0,'2013-12-25 21:32:44',NULL,NULL),(25355,16351,'EM','kuhent@yahoo.com',0,'2014-01-07 04:02:30',NULL,NULL),(26511,17058,'AP','5037156065',0,'2014-01-13 02:21:10',NULL,NULL),(30693,19939,'AP','9373029230',0,'2014-01-24 21:01:13',NULL,NULL),(30898,20087,'AP','8053006583',0,'2014-01-27 21:00:27',NULL,NULL),(35204,23123,'EM','valeriefrances7768@yahoo.com',0,'2014-02-12 21:31:24',NULL,NULL),(40700,27036,'AP','3252124161',0,'2014-03-03 21:00:19',NULL,NULL),(42878,28516,'TE','4194943562',0,'2014-03-07 21:31:57',NULL,NULL),(851,528,'EM','burtschermike@hotmail.com',0,'2013-12-25 17:49:23',NULL,NULL),(6486,4197,'TE','3304724801',0,'2013-12-25 21:49:46',NULL,NULL),(24728,15952,'AP','2405388660',0,'2014-01-04 02:00:09',NULL,NULL),(20508,13203,'EM','Janessa.brown88@gmail.com',0,'2013-12-26 12:55:02',NULL,NULL),(1699,1043,'EM','tjptrsat@usermail.com',0,'2013-12-25 18:15:51',NULL,NULL),(3326,2092,'TE','3186237742',0,'2013-12-25 19:16:55',NULL,NULL),(11068,7188,'AP','6143543021',0,'2013-12-26 02:00:21',NULL,NULL),(3461,2165,'AP','3306035837',0,'2013-12-25 19:19:02',NULL,NULL),(8566,5632,'AP','5133242385',0,'2013-12-25 23:31:00',NULL,NULL),(10350,6746,'EM','patti_roller@yahoo.com',0,'2013-12-26 01:15:56',NULL,NULL),(9800,6411,'AP','4405378970',0,'2013-12-26 00:48:38',NULL,NULL),(27556,17758,'AP','5132840916',0,'2014-01-14 01:33:32',NULL,NULL),(27797,17916,'AP','3614929587',0,'2014-01-15 02:06:29',NULL,NULL),(28778,18571,'AP','3304211859',0,'2014-01-16 08:47:04',NULL,NULL),(29674,19177,'AP','5126745889',0,'2014-01-21 08:46:06',NULL,NULL),(30677,19922,'AP','6625886280',0,'2014-01-24 21:01:05',NULL,NULL),(30901,20090,'TE','2252350647',0,'2014-01-27 21:00:29',NULL,NULL),(32080,20950,'EM','closeupanna@yahoo.com',0,'2014-02-01 19:00:04',NULL,NULL),(36270,23873,'EM','simmonskathy20@yahoo.com',0,'2014-02-14 21:32:11',NULL,NULL),(43440,28849,'TE','4199321208',0,'2014-03-09 21:01:17',NULL,NULL),(43824,29089,'AP','2108520517',0,'2014-03-10 21:02:09',NULL,NULL),(1902,1174,'TE','3306868941',0,'2013-12-25 18:19:13',NULL,NULL),(10964,7125,'AP','6019533775',0,'2013-12-26 01:51:27',NULL,NULL),(4893,3137,'EM','pancho78666@gmail.com',0,'2013-12-25 20:30:43',NULL,NULL),(5576,3561,'TE','3306782211',0,'2013-12-25 21:22:19',NULL,NULL),(12054,7867,'TE','3302976171',0,'2013-12-26 03:05:08',NULL,NULL),(14343,9376,'TE','5049753177',0,'2013-12-26 04:31:58',NULL,NULL),(20294,13081,'EM','dklemencic@advancingecoag.com',0,'2013-12-26 12:51:35',NULL,NULL),(5657,3631,'TE','9373932498',0,'2013-12-25 21:30:08',NULL,NULL),(23241,14975,'AP','2812878820',0,'2014-01-01 12:00:58',NULL,NULL),(23400,15072,'TE','2144152927',0,'2014-01-01 12:03:56',NULL,NULL),(6028,3870,'AP','9857050874',0,'2013-12-25 21:36:11',NULL,NULL),(6972,4545,'AP','9374780105',0,'2013-12-25 22:04:25',NULL,NULL),(29646,19154,'EM','freecrazyrose@yahoo.com',0,'2014-01-21 08:45:37',NULL,NULL),(32155,21003,'EM','EMAILREX@YAHOO.COM',0,'2014-02-01 19:00:30',NULL,NULL),(33414,21892,'EM','Ladelrio35@gmail.com',0,'2014-02-06 21:01:39',NULL,NULL),(34030,22317,'TE','3372553255',0,'2014-02-10 11:00:51',NULL,NULL),(35323,23209,'AP','5134901485',0,'2014-02-12 21:32:13',NULL,NULL),(35341,23224,'TE','6144773193',0,'2014-02-12 21:32:21',NULL,NULL),(36376,23956,'EM','sylviago110@yahoo.com',0,'2014-02-15 22:00:07',NULL,NULL),(37622,24796,'AP','7403363602',0,'2014-02-20 04:47:40',NULL,NULL),(38714,25589,'AP','9853817079',0,'2014-02-26 08:00:42',NULL,NULL),(39441,26085,'EM','namslawncareandlandscape@gmail.com',0,'2014-02-28 06:30:06',NULL,NULL),(39622,26205,'AP','3302817052',0,'2014-02-28 06:30:51',NULL,NULL),(41205,27368,'AP','9378388672',0,'2014-03-04 21:01:14',NULL,NULL),(6522,4218,'AP','9562073968',0,'2013-12-25 21:50:21',NULL,NULL),(25994,16748,'BN','9793328958',0,'2014-01-08 18:24:54',NULL,NULL),(2036,1261,'TE','4194199762',0,'2013-12-25 18:21:32',NULL,NULL),(2394,1459,'AP','6142359691',0,'2013-12-25 18:48:16',NULL,NULL),(10910,7089,'AP','3306717118',0,'2013-12-26 01:50:30',NULL,NULL),(2567,1567,'TE','4325564696',0,'2013-12-25 18:51:05',NULL,NULL),(2699,1641,'TE','3617276524',0,'2013-12-25 18:53:05',NULL,NULL),(3614,2285,'EM','slippery@alum.mit.edu',0,'2013-12-25 19:30:38',NULL,NULL),(3800,2417,'EM','angyp@prodigy.net',0,'2013-12-25 19:33:52',NULL,NULL),(22914,14786,'AP','6144466321',1,'2013-12-29 11:13:22',NULL,NULL),(23505,15165,'AP','2167015790',0,'2014-01-01 12:06:22',NULL,NULL),(24245,15663,'AP','8183193054',1,'2014-01-02 04:34:31',NULL,NULL),(24329,15716,'AP','4196185872',1,'2014-01-02 04:36:15',NULL,NULL),(6158,3969,'TE','5136282675',0,'2013-12-25 21:38:32',NULL,NULL),(27027,17380,'TE','6149069012',0,'2014-01-13 03:00:06',NULL,NULL),(27201,17515,'EM','rwmitchelljr@att.net',0,'2014-01-13 03:01:33',NULL,NULL),(28636,18464,'TE','9855101232',0,'2014-01-16 08:46:14',NULL,NULL),(29936,19374,'AP','6623952231',1,'2014-01-22 03:22:38',NULL,NULL),(31145,20286,'TE','2163741359',0,'2014-01-28 21:00:32',NULL,NULL),(33028,21639,'TE','4328897451',0,'2014-02-05 21:30:44',NULL,NULL),(33972,22287,'TE','9372132815',0,'2014-02-10 11:00:27',NULL,NULL),(35949,23652,'EM','gustavopena13@gmail.com',0,'2014-02-14 21:30:14',NULL,NULL),(36180,23813,'TE','3308829438',0,'2014-02-14 21:31:36',NULL,NULL),(36247,23855,'AP','7183160703',0,'2014-02-14 21:32:01',NULL,NULL),(38780,25637,'AP','3377818004',0,'2014-02-26 08:30:28',NULL,NULL),(42199,28030,'AP','7403332066',0,'2014-03-06 21:01:27',NULL,NULL),(42956,28566,'TE','5136013629',0,'2014-03-07 21:32:28',NULL,NULL),(2263,1387,'TE','2252393196',0,'2013-12-25 18:46:16',NULL,NULL),(3723,2362,'TE','4405211621',0,'2013-12-25 19:32:32',NULL,NULL),(2526,1547,'TE','6015030905',0,'2013-12-25 18:50:29',NULL,NULL),(9799,6411,'TE','4402775180',0,'2013-12-26 00:48:37',NULL,NULL),(6483,4194,'TE','3304724801',0,'2013-12-25 21:49:44',NULL,NULL),(2314,1413,'AP','2258922321',0,'2013-12-25 18:47:00',NULL,NULL),(7912,5155,'EM','mlbspnc@aol.com',0,'2013-12-25 23:02:55',NULL,NULL),(20912,13448,'EM','jyarshen@gmail.com',0,'2013-12-26 13:01:25',NULL,NULL),(23018,14848,'TE','5137352826',1,'2013-12-29 11:15:01',NULL,NULL),(27818,17927,'AP','9032680537',0,'2014-01-15 02:06:33',NULL,NULL),(27908,17982,'EM','SEBASTIAN_1@SBCGLOBAL.NET',0,'2014-01-15 02:06:53',NULL,NULL),(29428,19026,'TE','4194476269',0,'2014-01-20 08:06:29',NULL,NULL),(32876,21516,'TE','2149863494',0,'2014-02-05 21:00:04',NULL,NULL),(37865,24979,'TE','3614859675',0,'2014-02-20 22:00:32',NULL,NULL),(42180,28018,'AP','7408020560',0,'2014-03-06 21:01:20',NULL,NULL),(7209,4697,'AP','9375103138',0,'2013-12-25 22:08:20',NULL,NULL),(4850,3105,'TE','4194654070',0,'2013-12-25 20:20:23',NULL,NULL),(4399,2801,'TE','9376582233',0,'2013-12-25 19:50:26',NULL,NULL),(21951,14140,'TE','3186864650',0,'2013-12-27 02:02:38',NULL,NULL),(22165,14276,'TE','6015033044',0,'2013-12-27 02:06:14',NULL,NULL),(22199,14298,'AP','4194170016',0,'2013-12-27 02:06:47',NULL,NULL),(22375,14430,'EM','jonathon.sarmento@gmail.com',0,'2013-12-28 03:31:56',NULL,NULL),(7183,4681,'AP','3376619555',0,'2013-12-25 22:07:54',NULL,NULL),(26236,16886,'TE','3617423746',0,'2014-01-13 02:19:24',NULL,NULL),(41936,27880,'TE','4197717934',0,'2014-03-05 21:32:32',NULL,NULL),(42681,28392,'AP','3302129507',0,'2014-03-07 21:30:45',NULL,NULL),(42694,28401,'TE','6095567231',0,'2014-03-07 21:30:51',NULL,NULL),(43151,28680,'TE','9288309020',0,'2014-03-08 21:30:55',NULL,NULL),(23731,15311,'AP','4692154914',1,'2014-01-02 04:23:14',NULL,NULL),(879,546,'TE','3307948189',0,'2013-12-25 17:49:53',NULL,NULL),(8310,5446,'TE','4198418727',0,'2013-12-25 23:10:03',NULL,NULL),(6484,4194,'AP','3304724801',0,'2013-12-25 21:49:44',NULL,NULL),(2004,1240,'AP','5042510186',0,'2013-12-25 18:20:55',NULL,NULL),(2246,1376,'TE','9585023962',0,'2013-12-25 18:45:58',NULL,NULL),(2598,1584,'AP','2545221126',0,'2013-12-25 18:51:32',NULL,NULL),(3499,2187,'TE','6623921844',0,'2013-12-25 19:19:38',NULL,NULL),(26362,16967,'AP','3306188152',0,'2014-01-13 02:20:11',NULL,NULL),(26700,17176,'AP','2166181671',0,'2014-01-13 02:22:10',NULL,NULL),(27884,17968,'AP','2165263101',0,'2014-01-15 02:06:48',NULL,NULL),(29389,18993,'TE','3306538973',0,'2014-01-20 08:06:12',NULL,NULL),(30867,20063,'TE','9158518595',0,'2014-01-27 21:00:12',NULL,NULL),(40328,26765,'TE','4407319052',0,'2014-03-01 19:00:10',NULL,NULL),(655,408,'EM','protitlebarb@yahoo.com',0,'2013-12-25 17:46:20',NULL,NULL),(8027,5249,'TE','3306775797',0,'2013-12-25 23:05:06',NULL,NULL),(21674,13954,'TE','5137539327',0,'2013-12-26 13:15:00',NULL,NULL),(7464,4859,'TE','3373519748',0,'2013-12-25 22:30:37',NULL,NULL),(25488,16433,'AP','3307306333',0,'2014-01-07 04:04:54',NULL,NULL),(1507,926,'AP','2164072748',0,'2013-12-25 18:09:01',NULL,NULL),(25468,16424,'TE','9375272725',0,'2014-01-07 04:04:35',NULL,NULL),(25374,16364,'TE','6012670319',0,'2014-01-07 04:02:51',NULL,NULL),(9478,6203,'AP','3303412624',0,'2013-12-26 00:30:41',NULL,NULL),(9002,5909,'AP','5137738004',0,'2013-12-25 23:49:58',NULL,NULL),(5150,3302,'TE','3304681458',0,'2013-12-25 21:15:43',NULL,NULL),(4311,2750,'EM','MHOLTON@FUSE.NET',0,'2013-12-25 19:49:04',NULL,NULL),(26831,17259,'TE','6143715508',0,'2014-01-13 02:23:16',NULL,NULL),(26873,17291,'EM','gr8cut@gmail.com',0,'2014-01-13 02:23:33',NULL,NULL),(31591,20607,'TE','5132377763',0,'2014-01-30 21:00:16',NULL,NULL),(33131,21700,'EM','murrellkatherines@gmail.com',0,'2014-02-05 21:31:10',NULL,NULL),(33357,21852,'AP','7402841003',0,'2014-02-06 21:01:16',NULL,NULL),(37044,24395,'TE','4196061115',0,'2014-02-18 22:00:51',NULL,NULL),(37117,24437,'TE','3309310646',0,'2014-02-18 22:01:16',NULL,NULL),(42102,27973,'TE','2256736738',0,'2014-03-06 21:00:52',NULL,NULL),(43155,28681,'EM','LDF2488@YAHOO.COM',0,'2014-03-08 21:30:56',NULL,NULL),(23712,15303,'EM','dcoleman190@gmail.com',1,'2014-01-02 04:22:55',NULL,NULL),(7996,5218,'AP','5137711983',0,'2013-12-25 23:04:28',NULL,NULL),(3810,2426,'AP','4192300466',0,'2013-12-25 19:34:02',NULL,NULL),(21136,13589,'TE','2253685577',0,'2013-12-26 13:05:08',NULL,NULL),(14315,9360,'EM','diver_dan_maui@yahoo.com',0,'2013-12-26 04:31:32',NULL,NULL),(11344,7389,'TE','4404543178',0,'2013-12-26 02:16:07',NULL,NULL),(26942,17328,'TE','9012779304',0,'2014-01-13 02:23:55',NULL,NULL),(27178,17500,'EM','patty.coker@aol.com',0,'2014-01-13 03:01:24',NULL,NULL),(27507,17722,'EM','sector563@gmail.com',0,'2014-01-14 01:33:14',NULL,NULL),(27695,17851,'EM','cathylpcc@hotmail.com',0,'2014-01-15 02:06:07',NULL,NULL),(28489,18357,'AP','4193920420',0,'2014-01-16 08:45:25',NULL,NULL),(28869,18640,'TE','9727621527',0,'2014-01-17 03:35:06',NULL,NULL),(29969,19392,'AP','5136166523',1,'2014-01-22 03:22:49',NULL,NULL),(34979,22964,'AP','3309968610',0,'2014-02-12 21:00:12',NULL,NULL),(36344,23935,'TE','2163968303',0,'2014-02-15 21:00:06',NULL,NULL),(37246,24510,'TE','3618822750',0,'2014-02-20 03:53:03',NULL,NULL),(40140,26622,'AP','8322839318',0,'2014-02-28 21:30:53',NULL,NULL),(40349,26778,'AP','2147942690',0,'2014-03-01 21:00:12',NULL,NULL),(41063,27280,'AP','9564457698',0,'2014-03-04 21:00:22',NULL,NULL),(43055,28624,'TE','8302788061',0,'2014-03-08 21:30:23',NULL,NULL),(43716,29021,'TE','4055129859',0,'2014-03-10 21:01:30',NULL,NULL),(24678,15912,'AP','9365813801',0,'2014-01-03 02:06:26',NULL,NULL),(26336,16953,'TE','6623341046',0,'2014-01-13 02:20:01',NULL,NULL),(7584,4936,'EM','klb8711@yahoo.com',0,'2013-12-25 22:45:34',NULL,NULL),(7553,4918,'AP','3304022263',0,'2013-12-25 22:45:05',NULL,NULL),(7172,4676,'AP','3374592811',0,'2013-12-25 22:07:46',NULL,NULL),(6961,4538,'AP','9033728005',0,'2013-12-25 22:04:14',NULL,NULL),(21942,14134,'AP','5048813213',0,'2013-12-27 02:02:29',NULL,NULL),(11951,7785,'TE','9563342247',0,'2013-12-26 03:03:17',NULL,NULL),(3779,2396,'TE','5134624316',0,'2013-12-25 19:33:26',NULL,NULL),(3456,2163,'AP','3307607305',0,'2013-12-25 19:18:58',NULL,NULL),(27319,17594,'EM','treysuttle78@aol.com',0,'2014-01-14 01:32:12',NULL,NULL),(27485,17705,'TE','3186548620',0,'2014-01-14 01:33:06',NULL,NULL),(29406,19007,'AP','3374592436',0,'2014-01-20 08:06:19',NULL,NULL),(30093,19496,'EM','ralyttle54@gmail.com',0,'2014-01-23 03:02:08',NULL,NULL),(32218,21041,'EM','Cgott@mac.com',0,'2014-02-01 19:00:50',NULL,NULL),(35948,23652,'AP','9562852621',0,'2014-02-14 21:30:14',NULL,NULL),(37035,24386,'AP','5133280480',0,'2014-02-18 22:00:47',NULL,NULL),(37093,24422,'TE','2163862405',0,'2014-02-18 22:01:08',NULL,NULL),(39931,26424,'EM','celestemarie17@gmail.com',0,'2014-02-28 07:30:11',NULL,NULL),(41947,27884,'EM','mfaylpn@hotmail.com',0,'2014-03-05 21:32:35',NULL,NULL),(23619,15247,'AP','4409354657',0,'2014-01-01 12:08:52',NULL,NULL),(23334,15033,'EM','brandon.smith589@yahoo.com',0,'2014-01-01 12:02:43',NULL,NULL),(20339,13104,'AP','4196355298',0,'2013-12-26 12:52:15',NULL,NULL),(14890,9745,'TE','9725303829',0,'2013-12-26 04:46:02',NULL,NULL),(26041,16776,'EM','Brandi3434@roadrunner.com',0,'2014-01-08 18:25:04',NULL,NULL),(13579,8854,'TE','9568005042',0,'2013-12-26 04:01:07',NULL,NULL),(29432,19029,'EM','theboxergirl@att.net',0,'2014-01-20 08:06:30',NULL,NULL),(29640,19149,'EM','sonya_gatewood2005@live.com',0,'2014-01-21 08:45:34',NULL,NULL),(32383,21159,'AP','4193412580',0,'2014-02-03 21:00:32',NULL,NULL),(24735,15957,'AP','5134763644',0,'2014-01-04 02:00:16',NULL,NULL),(2840,1723,'TE','3308364186',0,'2013-12-25 18:55:15',NULL,NULL),(6336,4085,'AP','3305928884',0,'2013-12-25 21:47:16',NULL,NULL),(27525,17730,'BN','3306069956',0,'2014-01-14 01:33:19',NULL,NULL),(27648,17823,'TE','6016065987',0,'2014-01-15 02:05:57',NULL,NULL),(32569,21297,'AP','3186173905',0,'2014-02-04 21:00:10',NULL,NULL),(32832,21484,'EM','weigandjason@yahoo.com',0,'2014-02-04 21:01:44',NULL,NULL),(32929,21555,'AP','4402236988',0,'2014-02-05 21:30:16',NULL,NULL),(36272,23879,'TE','4404421354',0,'2014-02-14 21:32:13',NULL,NULL),(36888,24294,'TE','5133549946',0,'2014-02-18 21:30:15',NULL,NULL),(37633,24802,'EM','kkopis@hotmail.com',0,'2014-02-20 04:48:32',NULL,NULL),(161,95,'EM','jmceowen@clbpartners.com',0,'2013-12-25 17:17:34',NULL,NULL),(3493,2184,'EM','culolover@gmail.com',0,'2013-12-25 19:19:32',NULL,NULL),(4367,2783,'TE','4194103568',0,'2013-12-25 19:49:56',NULL,NULL),(949,583,'AP','4195130520',0,'2013-12-25 17:50:58',NULL,NULL),(10426,6797,'AP','4194105267',0,'2013-12-26 01:17:16',NULL,NULL),(10701,6955,'EM','tzp2007@gmail.com',0,'2013-12-26 01:47:09',NULL,NULL),(11252,7328,'TE','5135283780',0,'2013-12-26 02:03:46',NULL,NULL),(11787,7667,'TE','2257719987',0,'2013-12-26 03:00:28',NULL,NULL),(396,243,'TE','9377601391',0,'2013-12-25 17:21:23',NULL,NULL),(12456,8157,'TE','2282550925',0,'2013-12-26 03:16:14',NULL,NULL),(8135,5325,'EM','yentruoc183@hotmail.com',0,'2013-12-25 23:06:57',NULL,NULL),(24461,15789,'TE','5043437941',0,'2014-01-03 02:02:25',NULL,NULL),(20408,13142,'AP','9372707902',0,'2013-12-26 12:53:21',NULL,NULL),(21704,13976,'AP','5132533702',0,'2013-12-26 13:15:30',NULL,NULL),(22241,14333,'AP','5675259280',0,'2013-12-27 02:07:39',NULL,NULL),(22361,14421,'AP','2105356156',0,'2013-12-28 03:31:42',NULL,NULL),(23059,14873,'AP','9365810520',0,'2013-12-30 00:00:18',NULL,NULL),(29099,18791,'EM','vince8151@hotmail.com',0,'2014-01-17 03:35:56',NULL,NULL),(34162,22405,'TE','5044212716',0,'2014-02-10 21:30:22',NULL,NULL),(34405,22569,'TE','5139175037',0,'2014-02-10 21:31:55',NULL,NULL),(34807,22832,'TE','3309271115',0,'2014-02-11 21:02:08',NULL,NULL),(34948,22940,'TE','4198911286',0,'2014-02-11 21:30:19',NULL,NULL),(36295,23898,'TE','4192047412',0,'2014-02-14 21:32:22',NULL,NULL),(37990,25062,'TE','7405343559',0,'2014-02-20 22:01:24',NULL,NULL),(38253,25255,'TE','4194488971',0,'2014-02-21 22:01:17',NULL,NULL),(38897,25713,'TE','4327559889',0,'2014-02-26 09:30:24',NULL,NULL),(41118,27314,'TE','9565361331',0,'2014-03-04 21:00:41',NULL,NULL),(42418,28170,'AP','5133176951',0,'2014-03-06 21:02:49',NULL,NULL),(42982,28585,'AP','7406449664',0,'2014-03-08 21:30:00',NULL,NULL),(43307,28770,'AP','7406246095',0,'2014-03-09 21:00:29',NULL,NULL),(1195,729,'TE','7346784866',0,'2013-12-25 18:03:44',NULL,NULL),(25700,16569,'TE','5672496586',1,'2014-01-07 10:23:16',NULL,NULL),(25568,16495,'AP','7403045261',0,'2014-01-07 04:06:38',NULL,NULL),(25555,16484,'AP','4404541885',0,'2014-01-07 04:06:22',NULL,NULL),(6257,4035,'EM','bushmanml@gmail.com',0,'2013-12-25 21:46:00',NULL,NULL),(6839,4436,'AP','4192713458',0,'2013-12-25 22:02:02',NULL,NULL),(9065,5943,'TE','3185729941',0,'2013-12-25 23:50:53',NULL,NULL),(10346,6745,'TE','4405941947',0,'2013-12-26 01:15:54',NULL,NULL),(3117,1942,'EM','jennifer.dolejs@gmail.com',0,'2013-12-25 19:00:43',NULL,NULL),(11692,7611,'EM','wqs@sitestar.net',0,'2013-12-26 02:45:40',NULL,NULL),(13935,9089,'TE','9372877600',0,'2013-12-26 04:07:02',NULL,NULL),(14382,9403,'AP','7136287295',0,'2013-12-26 04:32:40',NULL,NULL),(1444,879,'AP','6017575154',0,'2013-12-25 18:07:42',NULL,NULL),(20334,13102,'TE','5138461636',0,'2013-12-26 12:52:11',NULL,NULL),(22279,14359,'TE','4406694691',0,'2013-12-28 03:30:14',NULL,NULL),(23043,14863,'EM','dixieaw22@gmail.com',1,'2013-12-29 11:15:27',NULL,NULL),(24602,15866,'TE','6014668084',0,'2014-01-03 02:04:57',NULL,NULL),(24626,15881,'TE','3185473274',0,'2014-01-03 02:05:25',NULL,NULL),(26183,16856,'TE','9034970318',0,'2014-01-13 02:19:07',NULL,NULL),(26844,17270,'TE','3306890421',0,'2014-01-13 02:23:21',NULL,NULL),(27959,18021,'EM','henrylj@ucmail.uc.edu',0,'2014-01-15 02:07:05',NULL,NULL),(32584,21304,'TE','3186768797',0,'2014-02-04 21:00:14',NULL,NULL),(32755,21429,'TE','2144634160',0,'2014-02-04 21:01:17',NULL,NULL),(35003,22983,'AP','9378221336',0,'2014-02-12 21:30:09',NULL,NULL),(36864,24277,'EM','Hhaggard3@cinci.rr.com',0,'2014-02-18 21:30:05',NULL,NULL),(38485,25434,'TE','2817422278',0,'2014-02-25 21:31:16',NULL,NULL),(38896,25711,'AP','4327559889',0,'2014-02-26 09:30:23',NULL,NULL),(39198,25924,'EM','crystalvictoria.0885@yahoo.com',0,'2014-02-26 21:01:23',NULL,NULL),(41512,27600,'TE','3304661092',0,'2014-03-05 21:00:22',NULL,NULL),(10499,6838,'EM','tapat@fuse.net',0,'2013-12-26 01:31:01',NULL,NULL),(21547,13854,'EM','msdb00@zoho.com',0,'2013-12-26 13:12:39',NULL,NULL),(22374,14430,'AP','9857140901',0,'2013-12-28 03:31:55',NULL,NULL),(22591,14571,'AP','4193454534',0,'2013-12-28 03:35:32',NULL,NULL),(22668,14615,'AP','6625713258',0,'2013-12-28 03:36:47',NULL,NULL),(23579,15221,'EM','jclark2832@gmail.com',0,'2014-01-01 12:08:02',NULL,NULL),(11774,7660,'EM','stompbox59@aol.com',0,'2013-12-26 03:00:16',NULL,NULL),(13866,9041,'TE','3309282463',0,'2013-12-26 04:05:49',NULL,NULL),(20573,13238,'AP','3252159632',0,'2013-12-26 12:55:59',NULL,NULL),(27709,17861,'TE','3306221545',0,'2014-01-15 02:06:10',NULL,NULL),(28453,18335,'EM','karenkempf@hotmail.com',0,'2014-01-16 08:45:14',NULL,NULL),(32140,20988,'AP','4407735666',0,'2014-02-01 19:00:24',NULL,NULL),(32920,21550,'EM','trudy@trudyjas.net',0,'2014-02-05 21:30:13',NULL,NULL),(33223,21755,'EM','vicky9940g@gmail.com',0,'2014-02-06 21:00:23',NULL,NULL),(33394,21882,'TE','5042013231',0,'2014-02-06 21:01:32',NULL,NULL),(34120,22371,'EM','sabika.aziz@gmail.com',0,'2014-02-10 21:00:13',NULL,NULL),(34561,22665,'AP','9728396909',0,'2014-02-11 21:00:38',NULL,NULL),(37213,24491,'AP','8323537477',0,'2014-02-20 03:44:44',NULL,NULL),(37842,24967,'TE','9363966767',0,'2014-02-20 22:00:24',NULL,NULL),(38054,25115,'AP','6157130126',0,'2014-02-21 21:30:18',NULL,NULL),(38644,25540,'EM','beckncall2007@gmail.com',0,'2014-02-26 08:00:11',NULL,NULL),(38797,25650,'AP','7402489029',0,'2014-02-26 08:30:38',NULL,NULL),(40360,26787,'TE','9034230733',0,'2014-03-01 21:00:16',NULL,NULL),(42587,28335,'EM','Crystalhbarnes@gmail.com',0,'2014-03-07 21:30:13',NULL,NULL),(42790,28458,'AP','5047018964',0,'2014-03-07 21:31:24',NULL,NULL),(43038,28615,'TE','9727043299',0,'2014-03-08 21:30:18',NULL,NULL),(250,154,'TE','2102732601',0,'2013-12-25 17:19:00',NULL,NULL),(2620,1593,'EM','texassongbird81@yahoo.com',0,'2013-12-25 18:51:50',NULL,NULL),(5696,3657,'TE','9377280525',0,'2013-12-25 21:30:48',NULL,NULL),(6918,4503,'AP','9723427208',0,'2013-12-25 22:03:27',NULL,NULL),(23040,14861,'EM','NOV.JC.84@HOTMAIL.COM',1,'2013-12-29 11:15:23',NULL,NULL),(8515,5598,'AP','2257186978',0,'2013-12-25 23:30:11',NULL,NULL),(14037,9171,'TE','5137929458',0,'2013-12-26 04:08:56',NULL,NULL),(20691,13302,'TE','4696844931',0,'2013-12-26 12:57:49',NULL,NULL),(25607,16518,'AP','8173084606',1,'2014-01-07 10:21:35',NULL,NULL),(27366,17617,'TE','8177103739',0,'2014-01-14 01:32:25',NULL,NULL),(35968,23665,'EM','usman.vaid@gmail.com',0,'2014-02-14 21:30:21',NULL,NULL),(36029,23697,'AP','6143231608',0,'2014-02-14 21:30:41',NULL,NULL),(38821,25665,'TE','3379367644',0,'2014-02-26 08:30:47',NULL,NULL),(38999,25787,'AP','4193442969',0,'2014-02-26 09:31:07',NULL,NULL),(41400,27503,'AP','4199801332',0,'2014-03-04 21:02:29',NULL,NULL),(1334,816,'AP','3304147594',0,'2013-12-25 18:05:57',NULL,NULL),(14517,9485,'AP','2165758776',0,'2013-12-26 04:34:46',NULL,NULL),(23513,15168,'AP','5134448009',0,'2014-01-01 12:06:29',NULL,NULL),(13802,8997,'AP','4403761951',0,'2013-12-26 04:04:46',NULL,NULL),(24071,15540,'TE','3183414398',1,'2014-01-02 04:30:57',NULL,NULL),(12321,8055,'EM','kelton.mote@gmail.com',0,'2013-12-26 03:09:50',NULL,NULL),(10485,6830,'EM','skeomany@wowway.com',0,'2013-12-26 01:30:47',NULL,NULL),(25242,16278,'AP','2167414048',0,'2014-01-07 04:00:27',NULL,NULL),(26404,16993,'TE','4192174195',0,'2014-01-13 02:20:26',NULL,NULL),(28666,18488,'AP','2165700115',0,'2014-01-16 08:46:24',NULL,NULL),(30967,20143,'TE','9378302735',0,'2014-01-27 21:00:59',NULL,NULL),(32172,21015,'EM','krystian.hall@gmail.com',0,'2014-02-01 19:00:36',NULL,NULL),(32872,21512,'TE','3307623047',0,'2014-02-04 21:30:03',NULL,NULL),(33953,22278,'AP','5126266517',0,'2014-02-10 11:00:19',NULL,NULL),(35731,23498,'TE','8327867697',0,'2014-02-13 22:02:07',NULL,NULL),(37153,24457,'TE','6013352615',0,'2014-02-18 22:01:30',NULL,NULL),(37958,25046,'TE','2163102803',0,'2014-02-20 22:01:14',NULL,NULL),(39418,26065,'TE','4199575451',0,'2014-02-26 21:02:41',NULL,NULL),(42139,27992,'AP','2163856042',0,'2014-03-06 21:01:04',NULL,NULL),(7812,5100,'TE','9038825511',0,'2013-12-25 23:01:25',NULL,NULL),(20843,13400,'TE','2164966565',0,'2013-12-26 13:00:19',NULL,NULL),(9247,6050,'EM','bulletwalla@gmail.com',0,'2013-12-26 00:01:40',NULL,NULL),(8960,5868,'EM','kevinmcgrvy@yahoo.com',0,'2013-12-25 23:49:09',NULL,NULL),(24384,15745,'TE','9562380744',0,'2014-01-03 02:00:59',NULL,NULL),(8552,5619,'TE','3306761909',0,'2013-12-25 23:30:44',NULL,NULL),(3238,2038,'TE','9034459928',0,'2013-12-25 19:15:30',NULL,NULL),(26147,16832,'TE','5137553264',0,'2014-01-13 02:18:29',NULL,NULL),(29656,19159,'TE','4199670160',0,'2014-01-21 08:45:41',NULL,NULL),(33344,21842,'EM','stu@w8an.net',0,'2014-02-06 21:01:11',NULL,NULL),(33364,21862,'AP','4404760530',0,'2014-02-06 21:01:20',NULL,NULL),(35127,23071,'TE','3373962271',0,'2014-02-12 21:30:57',NULL,NULL),(35174,23104,'TE','3303024309',0,'2014-02-12 21:31:13',NULL,NULL),(39338,26021,'AP','2144996288',0,'2014-02-26 21:02:15',NULL,NULL),(39360,26034,'TE','6016353529',0,'2014-02-26 21:02:23',NULL,NULL),(41699,27727,'AP','9038063209',0,'2014-03-05 21:31:02',NULL,NULL),(3744,2375,'EM','ruthchurchill@embarqmail.com',0,'2013-12-25 19:32:52',NULL,NULL),(6440,4162,'TE','5134460522',0,'2013-12-25 21:49:01',NULL,NULL),(14266,9332,'EM','jonretz@fuse.net',0,'2013-12-26 04:30:46',NULL,NULL),(3796,2412,'AP','5134846536',0,'2013-12-25 19:33:47',NULL,NULL),(20628,13271,'TE','8324031675',0,'2013-12-26 12:56:54',NULL,NULL),(21344,13716,'TE','3306083487',0,'2013-12-26 13:09:05',NULL,NULL),(23812,15363,'TE','7406127525',1,'2014-01-02 04:24:51',NULL,NULL),(23968,15469,'EM','cbddvm@aol.com',1,'2014-01-02 04:28:52',NULL,NULL),(26299,16928,'AP','5045782709',0,'2014-01-13 02:19:47',NULL,NULL),(27180,17502,'TE','4408659028',0,'2014-01-13 03:01:26',NULL,NULL),(27387,17629,'TE','5128482859',0,'2014-01-14 01:32:32',NULL,NULL),(27647,17821,'EM','rbriggs@mde.k12.ms.us',0,'2014-01-15 02:05:56',NULL,NULL),(32854,21500,'BN','4199321586',0,'2014-02-04 21:01:52',NULL,NULL),(33342,21841,'AP','9377797667',0,'2014-02-06 21:01:10',NULL,NULL),(33832,22213,'TE','5043932686',0,'2014-02-09 19:00:21',NULL,NULL),(34149,22390,'AP','3304142000',0,'2014-02-10 21:30:15',NULL,NULL),(34235,22455,'TE','7137245752',0,'2014-02-10 21:30:49',NULL,NULL),(38052,25113,'AP','9018484750',0,'2014-02-21 21:30:17',NULL,NULL),(41051,27274,'TE','8179378761',0,'2014-03-04 21:00:17',NULL,NULL),(1547,951,'AP','2164072748',0,'2013-12-25 18:09:35',NULL,NULL),(25777,16611,'EM','LOCH1965@YAHOO.COM',0,'2014-01-08 18:24:08',NULL,NULL),(5323,3411,'EM','VirginCav@yahoo.com',0,'2013-12-25 21:18:24',NULL,NULL),(4324,2760,'TE','2162535635',0,'2013-12-25 19:49:17',NULL,NULL),(9093,5958,'TE','4198433674',0,'2013-12-25 23:51:20',NULL,NULL),(8306,5443,'EM','indirachakravarty@hotmail.com',0,'2013-12-25 23:09:58',NULL,NULL),(8433,5549,'AP','5184355074',0,'2013-12-25 23:16:05',NULL,NULL),(20211,13021,'EM','djyez@hotmail.com',0,'2013-12-26 12:50:05',NULL,NULL),(20256,13052,'TE','2164966565',0,'2013-12-26 12:50:53',NULL,NULL),(20349,13109,'AP','2162582268',0,'2013-12-26 12:52:25',NULL,NULL),(21713,13983,'EM','gtcornette@hotmail.com',0,'2013-12-26 13:15:39',NULL,NULL),(22336,14403,'EM','joycemwhitehead@yahoo.com',0,'2013-12-28 03:31:15',NULL,NULL),(22431,14465,'TE','3308066263',0,'2013-12-28 03:32:54',NULL,NULL),(25556,16484,'EM','nbader29@yahoo.com',0,'2014-01-07 04:06:23',NULL,NULL),(29721,19218,'AP','9376815310',0,'2014-01-21 08:46:25',NULL,NULL),(31222,20333,'TE','3307995321',0,'2014-01-28 21:01:03',NULL,NULL),(32437,21194,'TE','6017980208',0,'2014-02-03 21:00:50',NULL,NULL),(33187,21733,'AP','2818506953',0,'2014-02-06 21:00:11',NULL,NULL),(34339,22529,'TE','3309991963',0,'2014-02-10 21:31:30',NULL,NULL),(36016,23690,'EM','amanda.roselli@yahoo.com',0,'2014-02-14 21:30:37',NULL,NULL),(38972,25770,'TE','4197044309',0,'2014-02-26 09:30:55',NULL,NULL),(39759,26293,'EM','kristymckee71@live.com',0,'2014-02-28 06:31:25',NULL,NULL),(42060,27951,'TE','9364888286',0,'2014-03-06 21:00:38',NULL,NULL),(7685,5009,'TE','3303253251',0,'2013-12-25 22:47:18',NULL,NULL),(22046,14199,'TE','5129585585',0,'2013-12-27 02:04:12',NULL,NULL),(22029,14186,'AP','2146417177',0,'2013-12-27 02:03:52',NULL,NULL),(11792,7669,'EM','donnieshaffer@yahoo.com',0,'2013-12-26 03:00:32',NULL,NULL),(11095,7207,'EM','carole.niedzialkowski@yahoo.com',0,'2013-12-26 02:00:49',NULL,NULL),(24641,15888,'EM','gramma.debbie@fuse.net',0,'2014-01-03 02:05:39',NULL,NULL),(7626,4968,'AP','3182377711',0,'2013-12-25 22:46:22',NULL,NULL),(25236,16272,'EM','LEO_SOFTBALL@YAHOO.COM',0,'2014-01-07 04:00:19',NULL,NULL),(25339,16342,'EM','dexterdaugherty@yahoo.com',0,'2014-01-07 04:02:15',NULL,NULL),(25521,16455,'EM','thdglenn@gmail.com',0,'2014-01-07 04:05:34',NULL,NULL),(28848,18631,'AP','9723425697',0,'2014-01-17 03:35:02',NULL,NULL),(30571,19834,'EM','STEPH_MARTINEZ831@YAHOO.COM',0,'2014-01-24 21:00:21',NULL,NULL),(37801,24947,'TE','3372582538',0,'2014-02-20 22:00:09',NULL,NULL),(43476,28872,'AP','9033682282',0,'2014-03-10 21:00:03',NULL,NULL),(8897,5827,'AP','9564514310',0,'2013-12-25 23:48:10',NULL,NULL),(10103,6601,'TE','3305445149',0,'2013-12-26 00:53:33',NULL,NULL),(10719,6972,'AP','5132630514',0,'2013-12-26 01:47:29',NULL,NULL),(9186,6014,'TE','8598149354',0,'2013-12-26 00:00:40',NULL,NULL),(13920,9078,'TE','2162586778',0,'2013-12-26 04:06:45',NULL,NULL),(2568,1568,'TE','5612942092',0,'2013-12-25 18:51:06',NULL,NULL),(21555,13859,'EM','psi1226@rrbiznet.com',0,'2013-12-26 13:12:47',NULL,NULL),(5607,3588,'EM','amne.orra@gmail.com',0,'2013-12-25 21:22:57',NULL,NULL),(26708,17180,'EM','ovenfriedbeads@fuse.net',0,'2014-01-13 02:22:12',NULL,NULL),(30798,20024,'AP','5042552906',0,'2014-01-26 19:00:17',NULL,NULL),(35864,23584,'TE','5136091455',0,'2014-02-13 22:02:59',NULL,NULL),(36475,24014,'TE','5134065853',0,'2014-02-15 22:00:42',NULL,NULL),(37327,24564,'EM','cerra.wingo@gmail.com',0,'2014-02-20 04:06:49',NULL,NULL),(37346,24587,'AP','5133799521',0,'2014-02-20 04:10:00',NULL,NULL),(42088,27964,'AP','5042088186',0,'2014-03-06 21:00:46',NULL,NULL),(43035,28613,'AP','9408591542',0,'2014-03-08 21:30:17',NULL,NULL),(1269,772,'TE','5125220363',0,'2013-12-25 18:04:51',NULL,NULL),(9149,5993,'TE','5089511750',0,'2013-12-26 00:00:07',NULL,NULL),(5954,3822,'TE','7405020998',0,'2013-12-25 21:34:58',NULL,NULL),(5288,3392,'TE','5044520210',0,'2013-12-25 21:17:52',NULL,NULL),(10277,6710,'EM','Bags4202@gmail.com',0,'2013-12-26 01:02:14',NULL,NULL),(4286,2738,'TE','5672083127',0,'2013-12-25 19:48:42',NULL,NULL),(20421,13150,'TE','7048196050',0,'2013-12-26 12:53:35',NULL,NULL),(21386,13753,'AP','4046437021',0,'2013-12-26 13:10:00',NULL,NULL),(3391,2132,'TE','4199898940',0,'2013-12-25 19:18:00',NULL,NULL),(24094,15552,'EM','malloryprevost@gmail.com',1,'2014-01-02 04:31:21',NULL,NULL),(3218,2024,'AP','3303510283',0,'2013-12-25 19:15:11',NULL,NULL),(2635,1602,'EM','bsandoval@sleepdrs.net',0,'2013-12-25 18:52:05',NULL,NULL),(25155,16216,'EM','aglassner1974@gmail.com',0,'2014-01-05 00:01:39',NULL,NULL),(25283,16301,'EM','dpalmisano2@cox.net',0,'2014-01-07 04:01:10',NULL,NULL),(28643,18469,'AP','2257153592',0,'2014-01-16 08:46:16',NULL,NULL),(32607,21320,'AP','5044329340',0,'2014-02-04 21:00:22',NULL,NULL),(33614,22044,'TE','4195361710',0,'2014-02-07 19:01:11',NULL,NULL),(33751,22147,'AP','2164214403',0,'2014-02-08 19:00:52',NULL,NULL),(34173,22410,'TE','5042286487',0,'2014-02-10 21:30:25',NULL,NULL),(35487,23335,'TE','6143258196',0,'2014-02-13 22:00:33',NULL,NULL),(39514,26138,'AP','6143576273',0,'2014-02-28 06:30:24',NULL,NULL),(42876,28513,'EM','adamsal27@hotmail.com',0,'2014-03-07 21:31:56',NULL,NULL),(1273,774,'TE','5129638761',0,'2013-12-25 18:04:54',NULL,NULL),(23045,14864,'AP','2149571010',0,'2013-12-30 00:00:03',NULL,NULL),(23374,15058,'AP','2258925411',0,'2014-01-01 12:03:28',NULL,NULL),(1792,1112,'TE','9374362311',0,'2013-12-25 18:17:32',NULL,NULL),(3399,2136,'AP','9542240619',0,'2013-12-25 19:18:07',NULL,NULL),(20716,13315,'EM','thebrowns25@yahoo.com',0,'2013-12-26 12:58:13',NULL,NULL),(3806,2420,'EM','ken@yabcom.com',0,'2013-12-25 19:33:57',NULL,NULL),(11526,7501,'AP','5139190865',0,'2013-12-26 02:31:51',NULL,NULL),(6506,4205,'AP','3252343139',0,'2013-12-25 21:50:02',NULL,NULL),(5800,3724,'TE','2162911407',0,'2013-12-25 21:32:25',NULL,NULL),(4443,2832,'AP','3378845779',0,'2013-12-25 20:00:47',NULL,NULL),(26314,16942,'TE','5049069498',0,'2014-01-13 02:19:55',NULL,NULL),(26729,17193,'TE','9377633092',0,'2014-01-13 02:22:19',NULL,NULL),(30732,19965,'EM','nickgivens55@gmail.com',0,'2014-01-25 19:00:09',NULL,NULL),(31121,20267,'AP','6144400265',0,'2014-01-28 21:00:21',NULL,NULL),(35059,23021,'EM','mrscwg@hotmail.com',0,'2014-02-12 21:30:30',NULL,NULL),(27206,17519,'AP','3304416466',0,'2014-01-13 03:01:35',NULL,NULL),(29052,18758,'AP','8327668052',0,'2014-01-17 03:35:46',NULL,NULL),(32196,21030,'AP','2392293757',0,'2014-02-01 19:00:44',NULL,NULL),(35458,23314,'EM','Oviahnosa@aol.com',0,'2014-02-13 22:00:22',NULL,NULL),(35851,23573,'AP','4193510689',0,'2014-02-13 22:02:53',NULL,NULL),(36632,24115,'TE','9562211892',0,'2014-02-15 22:01:39',NULL,NULL),(36730,24184,'AP','4194603661',0,'2014-02-16 19:00:09',NULL,NULL),(38850,25682,'TE','5103637344',0,'2014-02-26 09:30:05',NULL,NULL),(41838,27817,'BN','7408048028',0,'2014-03-05 21:31:54',NULL,NULL),(41945,27884,'TE','4198934308',0,'2014-03-05 21:32:34',NULL,NULL),(43446,28851,'EM','dpeterson10@woh.rr.com',0,'2014-03-09 21:01:19',NULL,NULL),(7052,4607,'TE','3305818509',0,'2013-12-25 22:05:52',NULL,NULL),(25647,16540,'TE','4693665839',1,'2014-01-07 10:22:20',NULL,NULL),(9665,6327,'EM','RWOLFORD@ROADRUNNER.COM',0,'2013-12-26 00:46:31',NULL,NULL),(1683,1034,'AP','9797395769',0,'2013-12-25 18:15:36',NULL,NULL),(2747,1666,'AP','4092873979',0,'2013-12-25 18:53:45',NULL,NULL),(3522,2202,'AP','9374171757',0,'2013-12-25 19:20:04',NULL,NULL),(685,425,'EM','c1maker@yahoo.com',0,'2013-12-25 17:46:46',NULL,NULL),(4510,2868,'EM','ramseyo@comcast.net',0,'2013-12-25 20:01:51',NULL,NULL),(4879,3123,'AP','9377081426',0,'2013-12-25 20:30:22',NULL,NULL),(14822,9704,'TE','4196552616',0,'2013-12-26 04:40:03',NULL,NULL),(20326,13097,'TE','5137024016',0,'2013-12-26 12:52:03',NULL,NULL),(20523,13210,'EM','scott.mount@yahoo.com',0,'2013-12-26 12:55:15',NULL,NULL),(21719,13991,'EM','raygentile@outlook.com',0,'2013-12-26 13:15:48',NULL,NULL),(6976,4547,'EM','kewarden@earthlink.net',0,'2013-12-25 22:04:29',NULL,NULL),(32682,21378,'TE','4408672956',0,'2014-02-04 21:00:51',NULL,NULL),(33830,22212,'TE','5049316556',0,'2014-02-09 19:00:21',NULL,NULL),(34233,22454,'AP','3615717959',0,'2014-02-10 21:30:48',NULL,NULL),(35008,22985,'AP','3305502106',0,'2014-02-12 21:30:11',NULL,NULL),(36421,23989,'AP','2257739469',0,'2014-02-15 22:00:25',NULL,NULL),(39342,26024,'AP','6014805898',0,'2014-02-26 21:02:17',NULL,NULL),(42058,27950,'TE','9364393700',0,'2014-03-06 21:00:37',NULL,NULL),(2340,1424,'EM','epg13@hotmail.com',0,'2013-12-25 18:47:21',NULL,NULL),(9201,6021,'EM','terrimacleod@yahoo.com',0,'2013-12-26 00:00:52',NULL,NULL),(11812,7684,'EM','timwoyan@gmail.com',0,'2013-12-26 03:00:53',NULL,NULL),(8686,5702,'AP','5673280746',0,'2013-12-25 23:32:57',NULL,NULL),(5464,3499,'AP','4193034752',0,'2013-12-25 21:20:39',NULL,NULL),(3485,2182,'TE','2547180631',0,'2013-12-25 19:19:27',NULL,NULL),(28119,18124,'TE','3304004194',0,'2014-01-15 02:07:41',NULL,NULL),(29602,19126,'EM','ahmedhassan00@yahoo.com',0,'2014-01-21 08:45:21',NULL,NULL),(31418,20482,'TE','3306787276',0,'2014-01-29 21:01:01',NULL,NULL),(33616,22046,'TE','3372781367',0,'2014-02-07 19:30:04',NULL,NULL),(34107,22355,'AP','4403054355',0,'2014-02-10 21:00:06',NULL,NULL),(37515,24705,'AP','6143269323',0,'2014-02-20 04:34:56',NULL,NULL),(43083,28641,'AP','5126083699',0,'2014-03-08 21:30:33',NULL,NULL),(2045,1266,'EM','petercaceres@yahoo.com',0,'2013-12-25 18:30:08',NULL,NULL),(25338,16341,'TE','5133360635',0,'2014-01-07 04:02:13',NULL,NULL),(13876,9051,'TE','3307257253',0,'2013-12-26 04:06:02',NULL,NULL),(20705,13309,'AP','8066642255',0,'2013-12-26 12:58:02',NULL,NULL),(9027,5921,'EM','jav.vic@hotmail.com',0,'2013-12-25 23:50:18',NULL,NULL),(7897,5146,'TE','9373393461',0,'2013-12-25 23:02:41',NULL,NULL),(21615,13912,'AP','7345580632',0,'2013-12-26 13:13:59',NULL,NULL),(2691,1635,'TE','9035398662',0,'2013-12-25 18:52:56',NULL,NULL),(4048,2584,'TE','5132903857',0,'2013-12-25 19:38:05',NULL,NULL),(23507,15166,'TE','2163176605',0,'2014-01-01 12:06:25',NULL,NULL),(24657,15898,'AP','4196190029',0,'2014-01-03 02:05:59',NULL,NULL),(4667,2986,'TE','5136926018',0,'2013-12-25 20:17:18',NULL,NULL),(27044,17392,'AP','9375366406',0,'2014-01-13 03:00:11',NULL,NULL),(28302,18242,'AP','8173080458',0,'2014-01-16 08:44:26',NULL,NULL),(28540,18401,'TE','3308640411',0,'2014-01-16 08:45:43',NULL,NULL),(29117,18804,'EM','krice@bigsill.com',0,'2014-01-17 03:36:01',NULL,NULL),(29531,19089,'TE','2167020566',0,'2014-01-21 08:44:31',NULL,NULL),(30821,20039,'TE','5133931680',0,'2014-01-26 19:00:25',NULL,NULL),(32480,21222,'TE','3185505960',0,'2014-02-03 21:01:04',NULL,NULL),(39147,25893,'EM','livesabbath@sbcglobal.net',0,'2014-02-26 21:01:04',NULL,NULL),(39906,26409,'TE','5136499129',0,'2014-02-28 07:00:37',NULL,NULL),(40075,26574,'TE','4192283890',0,'2014-02-28 21:30:27',NULL,NULL),(42766,28445,'AP','5042963136',0,'2014-03-07 21:31:16',NULL,NULL),(829,515,'EM','jpinbay@aol.com',0,'2013-12-25 17:49:03',NULL,NULL),(6900,4490,'AP','4197877387',0,'2013-12-25 22:03:08',NULL,NULL),(21821,14058,'AP','9375739656',0,'2013-12-27 02:00:30',NULL,NULL),(1300,791,'EM','sissy9647@gmail.com',0,'2013-12-25 18:05:19',NULL,NULL),(21503,13818,'EM','aidenscott27@gmail.com',0,'2013-12-26 13:11:49',NULL,NULL),(20701,13307,'EM','buttercupz180@yahoo.com',0,'2013-12-26 12:57:59',NULL,NULL),(6233,4017,'TE','5672041369',0,'2013-12-25 21:45:35',NULL,NULL),(2098,1297,'TE','9282667521',0,'2013-12-25 18:31:02',NULL,NULL),(4455,2837,'AP','3306054272',0,'2013-12-25 20:00:57',NULL,NULL),(3437,2156,'AP','3372490826',0,'2013-12-25 19:18:43',NULL,NULL),(8312,5447,'TE','4198418727',0,'2013-12-25 23:10:05',NULL,NULL),(29197,18863,'TE','2252506266',0,'2014-01-17 03:36:21',NULL,NULL),(29199,18863,'EM','naquinideas25@gmail.com',0,'2014-01-17 03:36:21',NULL,NULL),(31048,20198,'AP','9013830928',0,'2014-01-27 21:01:30',NULL,NULL),(33160,21720,'TE','5136525637',0,'2014-02-05 21:31:19',NULL,NULL),(34299,22507,'AP','9374703796',0,'2014-02-10 21:31:16',NULL,NULL),(39340,26023,'AP','3615581033',0,'2014-02-26 21:02:16',NULL,NULL),(41390,27496,'AP','3304212214',0,'2014-03-04 21:02:25',NULL,NULL),(6721,4367,'TE','2162566487',0,'2013-12-25 22:00:13',NULL,NULL),(10575,6884,'TE','2253855669',0,'2013-12-26 01:45:10',NULL,NULL),(25000,16112,'EM','ACGONZO88@YAHOO.COM',0,'2014-01-04 02:05:08',NULL,NULL),(28917,18667,'AP','8172171322',0,'2014-01-17 03:35:16',NULL,NULL),(34189,22424,'TE','5042595090',0,'2014-02-10 21:30:32',NULL,NULL),(34724,22768,'AP','3302684930',0,'2014-02-11 21:01:36',NULL,NULL),(41791,27784,'TE','2282979179',0,'2014-03-05 21:31:36',NULL,NULL),(43293,28763,'AP','8322744185',0,'2014-03-09 21:00:24',NULL,NULL),(1019,627,'TE','4408850346',0,'2013-12-25 18:01:01',NULL,NULL),(25988,16744,'EM','dougsupholstery@gmail.com',0,'2014-01-08 18:24:52',NULL,NULL),(25633,16532,'TE','6019061590',1,'2014-01-07 10:22:05',NULL,NULL),(8646,5680,'EM','carterb6@email.uc.edu',0,'2013-12-25 23:32:18',NULL,NULL),(9274,6070,'TE','4196128109',0,'2013-12-26 00:02:11',NULL,NULL),(10748,6988,'TE','5136154365',0,'2013-12-26 01:47:54',NULL,NULL),(8590,5645,'EM','mitzleplick@gmail.com',0,'2013-12-25 23:31:21',NULL,NULL),(5326,3413,'EM','bradmcmorris12@gmail.com',0,'2013-12-25 21:18:27',NULL,NULL),(5330,3416,'AP','5046063499',0,'2013-12-25 21:18:31',NULL,NULL),(2621,1594,'TE','9037805979',0,'2013-12-25 18:51:51',NULL,NULL),(14762,9654,'AP','5673711389',0,'2013-12-26 04:38:52',NULL,NULL),(21122,13580,'TE','2255731534',0,'2013-12-26 13:04:54',NULL,NULL),(22196,14297,'TE','4194170016',0,'2013-12-27 02:06:46',NULL,NULL),(2557,1562,'TE','8173687755',0,'2013-12-25 18:50:56',NULL,NULL),(7500,4887,'AP','2254361225',0,'2013-12-25 22:31:24',NULL,NULL),(28982,18707,'TE','6143097778',0,'2014-01-17 03:35:30',NULL,NULL),(29011,18727,'AP','6157156445',0,'2014-01-17 03:35:36',NULL,NULL),(30991,20159,'EM','ryanmartini411@gmail.com',0,'2014-01-27 21:01:09',NULL,NULL),(32207,21035,'EM','dbluvmygerry@roadrunner.com',0,'2014-02-01 19:00:47',NULL,NULL),(32699,21391,'AP','4194083343',0,'2014-02-04 21:00:57',NULL,NULL),(34811,22833,'EM','williamzanella@aol.com',0,'2014-02-11 21:02:09',NULL,NULL),(36585,24081,'AP','3302813070',0,'2014-02-15 22:01:22',NULL,NULL),(39108,25872,'AP','9852154034',0,'2014-02-26 21:00:52',NULL,NULL),(39467,26098,'AP','5043439896',0,'2014-02-28 06:30:11',NULL,NULL),(39997,26489,'AP','5049204867',0,'2014-02-28 21:00:09',NULL,NULL),(40945,27207,'EM','rkuohn56@yahoo.com',0,'2014-03-03 21:31:26',NULL,NULL),(41309,27443,'EM','r3rdkill1@aol.com',0,'2014-03-04 21:01:54',NULL,NULL),(355,219,'TE','3182889671',0,'2013-12-25 17:20:43',NULL,NULL),(25936,16710,'TE','2144992925',0,'2014-01-08 18:24:42',NULL,NULL),(25692,16562,'AP','4193051926',1,'2014-01-07 10:23:06',NULL,NULL),(11691,7610,'AP','3307036777',0,'2013-12-26 02:45:38',NULL,NULL),(2189,1345,'EM','cynthia.hennig@gmail.com',0,'2013-12-25 18:45:06',NULL,NULL),(14316,9361,'TE','2257675404',0,'2013-12-26 04:31:33',NULL,NULL),(4079,2601,'AP','4405709144',0,'2013-12-25 19:45:21',NULL,NULL),(4483,2852,'TE','4199089073',0,'2013-12-25 20:01:24',NULL,NULL),(5955,3822,'AP','7405020998',0,'2013-12-25 21:34:58',NULL,NULL),(24507,15809,'TE','3183521731',0,'2014-01-03 02:03:09',NULL,NULL),(6296,4058,'TE','5134104189',0,'2013-12-25 21:46:36',NULL,NULL),(27688,17847,'AP','4405962546',0,'2014-01-15 02:06:05',NULL,NULL),(27988,18041,'TE','6016803016',0,'2014-01-15 02:07:12',NULL,NULL),(28132,18134,'AP','8592403883',0,'2014-01-15 02:07:44',NULL,NULL),(28294,18238,'AP','8063192918',0,'2014-01-16 08:44:24',NULL,NULL),(28656,18482,'AP','3308083496',0,'2014-01-16 08:46:21',NULL,NULL),(31888,20813,'TE','4195755546',0,'2014-01-31 21:00:30',NULL,NULL),(33609,22039,'AP','6013258298',0,'2014-02-07 19:01:08',NULL,NULL),(34014,22311,'AP','6019830788',0,'2014-02-10 11:00:45',NULL,NULL),(36160,23800,'TE','3309986367',0,'2014-02-14 21:31:29',NULL,NULL),(43228,28724,'AP','2259938282',0,'2014-03-09 20:59:59',NULL,NULL),(2942,1811,'EM','natasha.niklas@yahoo.com',0,'2013-12-25 18:57:02',NULL,NULL),(12363,8092,'TE','5133836815',0,'2013-12-26 03:10:44',NULL,NULL),(14078,9203,'TE','3309790488',0,'2013-12-26 04:09:44',NULL,NULL),(21705,13977,'TE','5136177800',0,'2013-12-26 13:15:31',NULL,NULL),(21839,14069,'TE','2165414458',0,'2013-12-27 02:00:48',NULL,NULL),(22072,14215,'TE','7134783327',0,'2013-12-27 02:04:35',NULL,NULL),(22408,14451,'TE','9858761866',0,'2013-12-28 03:32:30',NULL,NULL),(11540,7512,'EM','ALISHADAVIS1990@GMAIL.COM',0,'2013-12-26 02:32:08',NULL,NULL),(6227,4013,'EM','SPENCEJ4@ME.COM',0,'2013-12-25 21:45:30',NULL,NULL),(23134,14913,'EM','mark.t@thompsonhub.com',0,'2013-12-30 00:01:30',NULL,NULL),(26624,17131,'TE','9518706604',0,'2014-01-13 02:21:46',NULL,NULL),(31634,20637,'AP','9013048526',0,'2014-01-30 21:00:31',NULL,NULL),(32720,21405,'TE','7405890064',0,'2014-02-04 21:01:05',NULL,NULL),(33592,22021,'AP','9402561869',0,'2014-02-07 19:00:59',NULL,NULL),(35681,23470,'TE','4696282097',0,'2014-02-13 22:01:48',NULL,NULL),(39459,26095,'TE','7194860057',0,'2014-02-28 06:30:10',NULL,NULL),(837,519,'TE','4195130520',0,'2013-12-25 17:49:10',NULL,NULL),(4781,3060,'TE','5042582956',0,'2013-12-25 20:19:08',NULL,NULL),(9314,6099,'TE','9375240780',0,'2013-12-26 00:15:10',NULL,NULL),(9372,6135,'TE','3378845779',0,'2013-12-26 00:16:06',NULL,NULL),(11006,7146,'TE','2145372770',0,'2013-12-26 01:52:03',NULL,NULL),(11556,7521,'AP','4053655992',0,'2013-12-26 02:32:24',NULL,NULL),(12406,8124,'TE','9375932815',0,'2013-12-26 03:15:21',NULL,NULL),(13881,9053,'EM','LeeBCGfx@gmail.com',0,'2013-12-26 04:06:06',NULL,NULL),(4267,2729,'TE','9852861125',0,'2013-12-25 19:48:25',NULL,NULL),(21818,14057,'AP','4195643297',0,'2013-12-27 02:00:27',NULL,NULL),(7288,4747,'AP','8176753856',0,'2013-12-25 22:15:05',NULL,NULL),(7448,4851,'AP','5138465353',0,'2013-12-25 22:30:22',NULL,NULL),(2975,1843,'EM','ch.triola@gmail.com',0,'2013-12-25 18:57:42',NULL,NULL),(28153,18147,'AP','9855181159',0,'2014-01-15 02:07:49',NULL,NULL),(35163,23095,'TE','6145930146',0,'2014-02-12 21:31:09',NULL,NULL),(36126,23776,'EM','rmcleaves@yahoo.com',0,'2014-02-14 21:31:16',NULL,NULL),(36543,24061,'AP','2166825104',0,'2014-02-15 22:01:09',NULL,NULL),(37201,24486,'TE','2252235809',0,'2014-02-20 03:42:27',NULL,NULL),(38719,25593,'TE','9853281415',0,'2014-02-26 08:00:44',NULL,NULL),(39271,25984,'AP','2169261801',0,'2014-02-26 21:01:53',NULL,NULL),(40174,26643,'EM','milano530@ymail.com',0,'2014-02-28 21:31:04',NULL,NULL),(41162,27337,'AP','5135509445',0,'2014-03-04 21:00:56',NULL,NULL),(42032,27936,'AP','3616943845',0,'2014-03-06 21:00:29',NULL,NULL),(42514,28278,'TE','5135194705',0,'2014-03-07 21:00:24',NULL,NULL),(317,194,'AP','4197690547',0,'2013-12-25 17:20:03',NULL,NULL),(8492,5586,'AP','5134532531',0,'2013-12-25 23:17:06',NULL,NULL),(12063,7876,'AP','5136161593',0,'2013-12-26 03:05:18',NULL,NULL),(4184,2672,'AP','9373607613',0,'2013-12-25 19:47:05',NULL,NULL),(14887,9744,'TE','9725303829',0,'2013-12-26 04:46:00',NULL,NULL),(21281,13673,'TE','3306450446',0,'2013-12-26 13:07:59',NULL,NULL),(6180,3983,'TE','5134057775',0,'2013-12-25 21:38:52',NULL,NULL),(23629,15255,'EM','rleemobley@gmail.com',0,'2014-01-01 12:09:06',NULL,NULL),(7525,4904,'EM','raincheck606@gmail.com',0,'2013-12-25 22:31:53',NULL,NULL),(2057,1273,'TE','5042583367',0,'2013-12-25 18:30:20',NULL,NULL),(26715,17184,'EM','mcdchick08@hotmail.com',0,'2014-01-13 02:22:14',NULL,NULL),(28266,18226,'TE','9153282775',0,'2014-01-16 08:44:16',NULL,NULL),(33069,21661,'TE','5042568638',0,'2014-02-05 21:30:55',NULL,NULL),(39626,26206,'EM','rcharlie9199@gmail.com',0,'2014-02-28 06:30:51',NULL,NULL),(40941,27203,'AP','5128046100',0,'2014-03-03 21:31:24',NULL,NULL),(41473,27563,'TE','2165026878',0,'2014-03-04 21:30:18',NULL,NULL),(43291,28761,'BN','8062237108',0,'2014-03-09 21:00:23',NULL,NULL),(639,396,'AP','3304212258',0,'2013-12-25 17:46:03',NULL,NULL),(10821,7028,'AP','2144501906',0,'2013-12-26 01:49:03',NULL,NULL),(10780,7008,'AP','8323053517',0,'2013-12-26 01:48:27',NULL,NULL),(10683,6941,'EM','toprunnerlogistic@gmail.com',0,'2013-12-26 01:46:49',NULL,NULL),(9972,6524,'AP','5133682594',0,'2013-12-26 00:51:31',NULL,NULL),(21236,13650,'EM','randi8001@gmail.com',0,'2013-12-26 13:07:17',NULL,NULL),(9188,6015,'TE','2169520206',0,'2013-12-26 00:00:42',NULL,NULL),(4077,2600,'EM','timanderson513@aol.com',0,'2013-12-25 19:45:19',NULL,NULL),(7089,4628,'EM','JORDANKAWANDA@YAHOO.COM',0,'2013-12-25 22:06:28',NULL,NULL),(29799,19272,'EM','joeknight4@centurylink.net',0,'2014-01-21 08:46:55',NULL,NULL),(31508,20531,'TE','6622660884',0,'2014-01-29 21:01:30',NULL,NULL),(32291,21093,'TE','4195167649',0,'2014-02-02 19:00:29',NULL,NULL),(32547,21279,'AP','4193457126',0,'2014-02-03 21:01:36',NULL,NULL),(39330,26015,'TE','2107713220',0,'2014-02-26 21:02:12',NULL,NULL),(41042,27267,'AP','2252057625',0,'2014-03-04 21:00:13',NULL,NULL),(42912,28536,'TE','9376208152',0,'2014-03-07 21:32:11',NULL,NULL),(43836,29095,'TE','9725678406',0,'2014-03-10 21:02:12',NULL,NULL),(7289,4747,'EM','rayvonhollins@yahoo.com',0,'2013-12-25 22:15:06',NULL,NULL),(6249,4029,'TE','4194685880',0,'2013-12-25 21:45:51',NULL,NULL),(21425,13775,'EM','braud.meta@gmail.com',0,'2013-12-26 13:10:36',NULL,NULL),(22219,14323,'TE','4402573248',0,'2013-12-27 02:07:18',NULL,NULL),(689,428,'AP','6144249609',0,'2013-12-25 17:46:50',NULL,NULL),(25130,16200,'AP','4074564332',0,'2014-01-05 00:01:07',NULL,NULL),(6168,3974,'EM','jbroberts44@sbcglobal.net',0,'2013-12-25 21:38:40',NULL,NULL),(3039,1891,'EM','walleyke89@gmail.com',0,'2013-12-25 18:58:52',NULL,NULL),(13945,9093,'EM','ericj613@gmail.com',0,'2013-12-26 04:07:09',NULL,NULL),(4144,2645,'AP','2142801579',0,'2013-12-25 19:46:27',NULL,NULL),(9157,5997,'TE','2253558121',0,'2013-12-26 00:00:14',NULL,NULL),(3280,2063,'TE','5675256382',0,'2013-12-25 19:16:09',NULL,NULL),(3929,2490,'AP','5042233620',0,'2013-12-25 19:35:48',NULL,NULL),(4121,2628,'AP','7402587100',0,'2013-12-25 19:46:03',NULL,NULL),(29459,19047,'TE','4194507822',0,'2014-01-20 08:06:41',NULL,NULL),(29637,19148,'TE','2108587204',0,'2014-01-21 08:45:33',NULL,NULL),(32456,21205,'AP','5046286188',0,'2014-02-03 21:00:56',NULL,NULL),(33087,21671,'EM','aleary1@cox.net',0,'2014-02-05 21:30:59',NULL,NULL),(33220,21754,'AP','2145580189',0,'2014-02-06 21:00:22',NULL,NULL),(35747,23508,'AP','5127445912',0,'2014-02-13 22:02:12',NULL,NULL),(42324,28105,'AP','3309901764',0,'2014-03-06 21:02:13',NULL,NULL),(592,365,'TE','9724904327',0,'2013-12-25 17:45:17',NULL,NULL),(6077,3911,'EM','rblanca4@gmail.com',0,'2013-12-25 21:37:07',NULL,NULL),(2703,1643,'TE','9034311562',0,'2013-12-25 18:53:08',NULL,NULL),(2837,1719,'EM','funneeval@gmail.com',0,'2013-12-25 18:55:10',NULL,NULL),(1021,630,'TE','5138441038',0,'2013-12-25 18:01:05',NULL,NULL),(3531,2208,'TE','3306731063',0,'2013-12-25 19:20:14',NULL,NULL),(8365,5497,'EM','madbeaup@aol.com',0,'2013-12-25 23:11:13',NULL,NULL),(7603,4949,'TE','3308965659',0,'2013-12-25 22:45:54',NULL,NULL),(20593,13247,'TE','8324099799',0,'2013-12-26 12:56:17',NULL,NULL),(20722,13319,'TE','2103554606',0,'2013-12-26 12:58:19',NULL,NULL),(663,412,'AP','2165709608',0,'2013-12-25 17:46:27',NULL,NULL),(23380,15061,'TE','3372788918',0,'2014-01-01 12:03:34',NULL,NULL),(23917,15432,'AP','9039209077',1,'2014-01-02 04:27:46',NULL,NULL),(7837,5116,'TE','7135053717',0,'2013-12-25 23:01:49',NULL,NULL),(25584,16503,'TE','4403444421',0,'2014-01-07 04:06:55',NULL,NULL),(26285,16918,'TE','7403621346',0,'2014-01-13 02:19:42',NULL,NULL),(28687,18511,'EM','beckywrightrd@hotmail.com',0,'2014-01-16 08:46:34',NULL,NULL),(28918,18667,'EM','seabiscuit19382002@yahoo.com',0,'2014-01-17 03:35:16',NULL,NULL),(31892,20816,'TE','6463464742',0,'2014-01-31 21:00:32',NULL,NULL),(27259,17552,'AP','9014826034',0,'2014-01-13 03:01:55',NULL,NULL),(27683,17844,'AP','6149621686',0,'2014-01-15 02:06:04',NULL,NULL),(28418,18310,'TE','9379358153',0,'2014-01-16 08:45:01',NULL,NULL),(31172,20300,'AP','3374058145',0,'2014-01-28 21:00:43',NULL,NULL),(33976,22288,'AP','6144412959',0,'2014-02-10 11:00:28',NULL,NULL),(34278,22491,'TE','6148600630',0,'2014-02-10 21:31:07',NULL,NULL),(38312,25310,'TE','5672089601',0,'2014-02-25 21:00:31',NULL,NULL),(39578,26182,'EM','mzfowler@yahoo.com',0,'2014-02-28 06:30:41',NULL,NULL),(41698,27727,'TE','9038063209',0,'2014-03-05 21:31:02',NULL,NULL),(41883,27850,'EM','sabuw@hotmail.com',0,'2014-03-05 21:32:12',NULL,NULL),(43646,28970,'TE','2256352370',0,'2014-03-10 21:01:02',NULL,NULL),(43727,29026,'TE','5137037963',0,'2014-03-10 21:01:33',NULL,NULL),(803,499,'EM','mschleppi75@gmail.com',0,'2013-12-25 17:48:39',NULL,NULL),(8976,5884,'TE','2163382597',0,'2013-12-25 23:49:30',NULL,NULL),(9651,6313,'EM','RJStrait1255@yahoo.com',0,'2013-12-26 00:46:15',NULL,NULL),(26956,17336,'AP','2026797005',0,'2014-01-13 02:24:00',NULL,NULL),(31369,20445,'AP','2282193428',0,'2014-01-29 21:00:42',NULL,NULL),(31693,20673,'TE','6019461962',0,'2014-01-30 21:00:51',NULL,NULL),(34920,22914,'AP','4193763987',0,'2014-02-11 21:02:50',NULL,NULL),(38709,25585,'EM','tomlegan1951@yahoo.com',0,'2014-02-26 08:00:39',NULL,NULL),(40920,27192,'TE','8322050650',0,'2014-03-03 21:31:17',NULL,NULL),(41504,27590,'AP','5124234190',0,'2014-03-05 21:00:17',NULL,NULL),(43744,29038,'AP','5132052432',0,'2014-03-10 21:01:40',NULL,NULL),(224,135,'EM','kvmushrooms@hotmail.com',0,'2013-12-25 17:18:35',NULL,NULL),(25167,16226,'TE','9379018325',0,'2014-01-05 00:01:56',NULL,NULL),(22612,14581,'AP','5044871848',0,'2013-12-28 03:35:51',NULL,NULL),(14346,9378,'TE','5043684716',0,'2013-12-26 04:32:01',NULL,NULL),(25344,16346,'TE','4196798186',0,'2014-01-07 04:02:21',NULL,NULL),(28168,18156,'EM','joshua.kunar@gmail.com',0,'2014-01-15 02:07:52',NULL,NULL),(30187,19556,'AP','2255882471',0,'2014-01-23 03:02:31',NULL,NULL),(32705,21394,'AP','5136418704',0,'2014-02-04 21:00:58',NULL,NULL),(33975,22288,'TE','6144412959',0,'2014-02-10 11:00:27',NULL,NULL),(39580,26183,'AP','6145986203',0,'2014-02-28 06:30:41',NULL,NULL),(39903,26408,'TE','5136499129',0,'2014-02-28 07:00:37',NULL,NULL),(41354,27473,'AP','9015961666',0,'2014-03-04 21:02:12',NULL,NULL),(3508,2192,'TE','5132481118',0,'2013-12-25 19:19:47',NULL,NULL),(12280,8033,'TE','6019412540',0,'2013-12-26 03:09:12',NULL,NULL),(5130,3287,'EM','twsmith@ymail.com',0,'2013-12-25 21:15:25',NULL,NULL),(14793,9680,'AP','8124304464',0,'2013-12-26 04:39:29',NULL,NULL),(21237,13651,'TE','2252260957',0,'2013-12-26 13:07:19',NULL,NULL),(21786,14038,'TE','5139009828',0,'2013-12-26 13:17:05',NULL,NULL),(26210,16871,'BN','2543867249',0,'2014-01-13 02:19:16',NULL,NULL),(28742,18547,'TE','6013352339',0,'2014-01-16 08:46:52',NULL,NULL),(31021,20182,'AP','7178757469',0,'2014-01-27 21:01:21',NULL,NULL),(35154,23090,'TE','3305191871',0,'2014-02-12 21:31:06',NULL,NULL),(36677,24150,'EM','kspray04@yahoo.com',0,'2014-02-15 22:01:56',NULL,NULL),(39907,26409,'AP','5136499129',0,'2014-02-28 07:00:38',NULL,NULL),(41545,27625,'TE','6145157938',0,'2014-03-05 21:30:07',NULL,NULL),(41878,27847,'TE','9563138844',0,'2014-03-05 21:32:11',NULL,NULL),(43090,28644,'EM','bucknancy88@gmail.com',0,'2014-03-08 21:30:35',NULL,NULL),(43566,28933,'TE','2162724458',0,'2014-03-10 21:00:38',NULL,NULL),(745,466,'TE','4403873177',0,'2013-12-25 17:47:46',NULL,NULL),(6406,4133,'EM','rncater@sbcglobal.net',0,'2013-12-25 21:48:27',NULL,NULL),(22619,14586,'EM','tammyteman@centurylink.net',0,'2013-12-28 03:36:00',NULL,NULL),(22872,14758,'EM','contrerasimcool@gmail.com',1,'2013-12-29 11:12:37',NULL,NULL),(940,580,'TE','4193675488',0,'2013-12-25 17:50:51',NULL,NULL),(4007,2548,'TE','3308963456',0,'2013-12-25 19:37:13',NULL,NULL),(3767,2390,'TE','9376235094',0,'2013-12-25 19:33:16',NULL,NULL),(9560,6256,'TE','6019239866',0,'2013-12-26 00:32:08',NULL,NULL),(1429,870,'EM','twinoaks730@netzero.com',0,'2013-12-25 18:07:26',NULL,NULL),(28125,18128,'EM','tmker2@gmail.com',0,'2014-01-15 02:07:43',NULL,NULL),(28307,18245,'EM','nfodell@gmail.com',0,'2014-01-16 08:44:27',NULL,NULL),(28527,18387,'EM','jackson.rebeccam@gmail.com',0,'2014-01-16 08:45:38',NULL,NULL),(28721,18535,'AP','4194610414',0,'2014-01-16 08:46:45',NULL,NULL),(32831,21483,'EM','tobygrove123@gmail.com',0,'2014-02-04 21:01:44',NULL,NULL),(37253,24515,'AP','8322039668',0,'2014-02-20 03:54:52',NULL,NULL),(37305,24548,'TE','3304847107',0,'2014-02-20 04:03:54',NULL,NULL),(37704,24860,'TE','3304210660',0,'2014-02-20 04:56:51',NULL,NULL),(38960,25758,'EM','budlehman@zoomtown.com',0,'2014-02-26 09:30:50',NULL,NULL),(39684,26238,'AP','5129706493',0,'2014-02-28 06:31:04',NULL,NULL),(41230,27385,'TE','6012183265',0,'2014-03-04 21:01:24',NULL,NULL),(7748,5059,'EM','chickenfoot79852@yahoo.com',0,'2013-12-25 23:00:23',NULL,NULL),(1708,1049,'AP','9403373259',0,'2013-12-25 18:15:59',NULL,NULL),(7423,4828,'TE','5672806135',0,'2013-12-25 22:17:16',NULL,NULL),(3517,2199,'TE','9377269334',0,'2013-12-25 19:19:59',NULL,NULL),(21393,13757,'TE','6012912205',0,'2013-12-26 13:10:06',NULL,NULL),(3470,2171,'AP','4195086270',0,'2013-12-25 19:19:11',NULL,NULL),(14616,9556,'EM','evaiksno@kent.edu',0,'2013-12-26 04:36:25',NULL,NULL),(13914,9072,'AP','5133774734',0,'2013-12-26 04:06:39',NULL,NULL),(12349,8083,'TE','5138966428',0,'2013-12-26 03:10:28',NULL,NULL),(2028,1255,'TE','9372194620',0,'2013-12-25 18:21:22',NULL,NULL),(8898,5827,'EM','donaldopadilla@att.net',0,'2013-12-25 23:48:10',NULL,NULL),(27540,17749,'TE','3302566114',0,'2014-01-14 01:33:27',NULL,NULL),(29779,19255,'TE','2257724681',0,'2014-01-21 08:46:46',NULL,NULL),(33820,22207,'TE','9374697564',0,'2014-02-09 19:00:18',NULL,NULL),(34502,22632,'EM','itsonlymedani@livingston.net',0,'2014-02-11 21:00:18',NULL,NULL),(37206,24488,'TE','9152443276',0,'2014-02-20 03:43:26',NULL,NULL),(39349,26027,'AP','6013450966',0,'2014-02-26 21:02:19',NULL,NULL),(41308,27443,'TE','3185560408',0,'2014-03-04 21:01:54',NULL,NULL),(42112,27978,'TE','2256736738',0,'2014-03-06 21:00:55',NULL,NULL),(8217,5378,'EM','clayman601@aol.com',0,'2013-12-25 23:08:17',NULL,NULL),(3278,2062,'AP','5675256382',0,'2013-12-25 19:16:08',NULL,NULL),(5040,3235,'AP','7406293396',0,'2013-12-25 20:46:09',NULL,NULL),(10488,6832,'EM','ksingleton101@live.com',0,'2013-12-26 01:30:50',NULL,NULL),(12042,7856,'TE','9379742355',0,'2013-12-26 03:04:56',NULL,NULL),(14021,9156,'EM','a.douglasfamily@yahoo.com',0,'2013-12-26 04:08:35',NULL,NULL),(14824,9704,'EM','maria_sidiq@hotmail.com',0,'2013-12-26 04:40:04',NULL,NULL),(6243,4023,'EM','kblakemo3@gmail.com',0,'2013-12-25 21:45:43',NULL,NULL),(22647,14602,'AP','4197681522',0,'2013-12-28 03:36:27',NULL,NULL),(22873,14759,'TE','9796933689',1,'2013-12-29 11:12:38',NULL,NULL),(23694,15295,'EM','TPOWE1983@GMAIL.COM',1,'2014-01-02 04:22:38',NULL,NULL),(6828,4431,'EM','sp@neo.rr.com',0,'2013-12-25 22:01:53',NULL,NULL),(24940,16076,'EM','paradoarify@gmail.com',0,'2014-01-04 02:03:58',NULL,NULL),(40430,26838,'EM','QUEENKEII22@GMAIL.COM',0,'2014-03-01 21:00:44',NULL,NULL),(43150,28679,'EM','jboe145@gmail.com',0,'2014-03-08 21:30:55',NULL,NULL),(43480,28875,'TE','2147580813',0,'2014-03-10 21:00:05',NULL,NULL),(43665,28979,'EM','LDF2488@YAHOO.COM',0,'2014-03-10 21:01:08',NULL,NULL),(3340,2101,'EM','bruce.vanvelzel@owenscorning.com',0,'2013-12-25 19:17:10',NULL,NULL),(24269,15683,'EM','Royboop14@hotmail.com',1,'2014-01-02 04:35:05',NULL,NULL),(20959,13484,'AP','6788952018',0,'2013-12-26 13:02:18',NULL,NULL),(6356,4094,'TE','5676983226',0,'2013-12-25 21:47:33',NULL,NULL),(26659,17150,'AP','3107227662',0,'2014-01-13 02:21:56',NULL,NULL),(26725,17188,'AP','2103914478',0,'2014-01-13 02:22:17',NULL,NULL),(28989,18713,'TE','4402212816',0,'2014-01-17 03:35:32',NULL,NULL),(30186,19556,'TE','2255882471',0,'2014-01-23 03:02:31',NULL,NULL),(30267,19611,'AP','4409419636',0,'2014-01-23 03:02:50',NULL,NULL),(30698,19941,'AP','4198520704',0,'2014-01-24 21:01:15',NULL,NULL),(33070,21661,'AP','5042568638',0,'2014-02-05 21:30:55',NULL,NULL),(33693,22100,'AP','5136759880',0,'2014-02-08 19:00:29',NULL,NULL),(36669,24142,'EM','DANIISHOME@AOL.COM',0,'2014-02-15 22:01:53',NULL,NULL),(36766,24207,'EM','keller.s.adam@gmail.com',0,'2014-02-16 19:00:21',NULL,NULL),(41874,27844,'TE','9563138844',0,'2014-03-05 21:32:09',NULL,NULL),(475,298,'EM','r.vmail@yahoo.com',0,'2013-12-25 17:30:46',NULL,NULL),(8662,5689,'AP','5134600782',0,'2013-12-25 23:32:33',NULL,NULL),(9779,6399,'TE','6144887970',0,'2013-12-26 00:48:18',NULL,NULL),(3192,2006,'AP','5136030445',0,'2013-12-25 19:02:21',NULL,NULL),(13981,9119,'AP','3307045604',0,'2013-12-26 04:07:45',NULL,NULL),(1337,817,'EM','tsigel@hotmail.com',0,'2013-12-25 18:05:59',NULL,NULL),(1242,756,'TE','3252624455',0,'2013-12-25 18:04:25',NULL,NULL),(21579,13877,'EM','sgb3@zips.uakron.edu',0,'2013-12-26 13:13:14',NULL,NULL),(727,456,'EM','dianemuntz65@roadrunner.com',0,'2013-12-25 17:47:29',NULL,NULL),(24489,15800,'TE','3185358104',0,'2014-01-03 02:02:50',NULL,NULL),(24492,15801,'AP','2252870388',0,'2014-01-03 02:02:53',NULL,NULL),(24902,16052,'AP','6145815043',0,'2014-01-04 02:03:15',NULL,NULL),(6999,4570,'TE','9033713502',0,'2013-12-25 22:04:57',NULL,NULL),(28994,18715,'EM','tigers856@aol.com',0,'2014-01-17 03:35:32',NULL,NULL),(35425,23287,'EM','gabrielle.onder@yahoo.com',0,'2014-02-13 22:00:05',NULL,NULL),(42248,28063,'TE','2165135474',0,'2014-03-06 21:01:45',NULL,NULL),(42743,28430,'TE','3307943247',0,'2014-03-07 21:31:08',NULL,NULL),(43212,28715,'TE','5137342821',0,'2014-03-08 21:31:17',NULL,NULL),(370,225,'EM','danielle_leboeuf@yahoo.com',0,'2013-12-25 17:20:54',NULL,NULL),(7048,4604,'EM','Joanldrake@gmail.com',0,'2013-12-25 22:05:48',NULL,NULL),(27193,17512,'TE','3304416466',0,'2014-01-13 03:01:30',NULL,NULL),(28025,18061,'TE','5132545871',0,'2014-01-15 02:07:21',NULL,NULL),(28528,18388,'TE','3307335443',0,'2014-01-16 08:45:39',NULL,NULL),(29318,18945,'EM','bishopljefferson@gmail.com',0,'2014-01-20 08:05:46',NULL,NULL),(37125,24440,'TE','4197718476',0,'2014-02-18 22:01:19',NULL,NULL),(37649,24821,'AP','9372189001',0,'2014-02-20 04:50:50',NULL,NULL),(39777,26302,'AP','4196312133',0,'2014-02-28 06:31:29',NULL,NULL),(1250,759,'AP','8176891383',0,'2013-12-25 18:04:31',NULL,NULL),(10756,6994,'TE','2144580480',0,'2013-12-26 01:48:05',NULL,NULL),(9315,6099,'EM','Arzola.Family@yahoo.com',0,'2013-12-26 00:15:10',NULL,NULL),(6144,3955,'EM','granny.cyndi@yahoo.com',0,'2013-12-25 21:38:17',NULL,NULL),(3556,2226,'EM','jschank@ymail.com',0,'2013-12-25 19:20:40',NULL,NULL),(7873,5134,'AP','9792577063',0,'2013-12-25 23:02:19',NULL,NULL),(25845,16661,'TE','2252450292',0,'2014-01-08 18:24:24',NULL,NULL),(26893,17302,'AP','9032638071',0,'2014-01-13 02:23:39',NULL,NULL),(28883,18648,'AP','8322263500',0,'2014-01-17 03:35:09',NULL,NULL),(32925,21553,'AP','6149354861',0,'2014-02-05 21:30:15',NULL,NULL),(32975,21584,'AP','3307147196',0,'2014-02-05 21:30:27',NULL,NULL),(34338,22527,'EM','smithsr185@gmail.com',0,'2014-02-10 21:31:29',NULL,NULL),(34947,22938,'EM','kbauer613@yahoo.com',0,'2014-02-11 21:30:17',NULL,NULL),(38266,25267,'TE','6143525610',0,'2014-02-22 19:00:16',NULL,NULL),(42415,28169,'AP','3379626667',0,'2014-03-06 21:02:48',NULL,NULL),(1364,831,'EM','bswanson228@yahoo.com',0,'2013-12-25 18:06:22',NULL,NULL),(9355,6125,'AP','8172533117',0,'2013-12-26 00:15:50',NULL,NULL),(2302,1409,'TE','6508681737',0,'2013-12-25 18:46:51',NULL,NULL),(14253,9324,'TE','3377890442',0,'2013-12-26 04:30:34',NULL,NULL),(20366,13119,'AP','6145309888',0,'2013-12-26 12:52:42',NULL,NULL),(22010,14175,'EM','hinkatcher@yahoo.com',0,'2013-12-27 02:03:34',NULL,NULL),(23190,14945,'TE','4198525160',0,'2013-12-30 00:02:27',NULL,NULL),(1784,1105,'TE','5676744071',0,'2013-12-25 18:17:22',NULL,NULL),(8443,5555,'EM','working4results@aol.com',0,'2013-12-25 23:16:16',NULL,NULL),(28341,18263,'AP','8304597612',0,'2014-01-16 08:44:37',NULL,NULL),(29564,19104,'TE','2257151252',0,'2014-01-21 08:44:40',NULL,NULL),(38210,25220,'AP','6622070290',0,'2014-02-21 22:00:56',NULL,NULL),(41074,27285,'AP','8329219737',0,'2014-03-04 21:00:25',NULL,NULL),(3252,2047,'AP','9156919872',0,'2013-12-25 19:15:45',NULL,NULL),(3310,2082,'EM','ebc_hcare@yahoo.com',0,'2013-12-25 19:16:39',NULL,NULL),(4033,2576,'AP','5135466788',0,'2013-12-25 19:37:50',NULL,NULL),(7408,4817,'EM','tpaparodis@ymail.com',0,'2013-12-25 22:16:59',NULL,NULL),(4643,2962,'EM','J.jernigan65@yahoo.com',0,'2013-12-25 20:16:48',NULL,NULL),(5146,3297,'AP','3306356686',0,'2013-12-25 21:15:39',NULL,NULL),(20219,13025,'TE','2165981642',0,'2013-12-26 12:50:12',NULL,NULL),(30562,19830,'TE','8179642045',0,'2014-01-24 21:00:19',NULL,NULL),(36000,23683,'TE','3306878875',0,'2014-02-14 21:30:32',NULL,NULL),(37807,24950,'AP','5043279301',0,'2014-02-20 22:00:11',NULL,NULL),(39332,26017,'EM','rhammack1008@charter.net',0,'2014-02-26 21:02:13',NULL,NULL),(23857,15391,'TE','3304870545',1,'2014-01-02 04:25:46',NULL,NULL),(763,478,'TE','3058070569',0,'2013-12-25 17:48:04',NULL,NULL),(22712,14647,'TE','9038265641',1,'2013-12-29 11:07:37',NULL,NULL),(21298,13683,'AP','3302562633',0,'2013-12-26 13:08:15',NULL,NULL),(2946,1816,'TE','3309662744',0,'2013-12-25 18:57:07',NULL,NULL),(20493,13195,'AP','8323816131',0,'2013-12-26 12:54:47',NULL,NULL),(2969,1839,'TE','3306677203',0,'2013-12-25 18:57:36',NULL,NULL),(3026,1885,'AP','4192064045',0,'2013-12-25 18:58:39',NULL,NULL),(3927,2489,'AP','2252769943',0,'2013-12-25 19:35:46',NULL,NULL),(3620,2290,'TE','6145310756',0,'2013-12-25 19:30:44',NULL,NULL),(3506,2191,'AP','4192343240',0,'2013-12-25 19:19:45',NULL,NULL),(3229,2029,'EM','warreneww@sbcglobal.net',0,'2013-12-25 19:15:19',NULL,NULL),(3209,2016,'TE','3309077060',0,'2013-12-25 19:02:39',NULL,NULL),(13993,9133,'TE','3132128149',0,'2013-12-26 04:08:01',NULL,NULL),(10572,6882,'EM','treed002@gmail.com',0,'2013-12-26 01:45:06',NULL,NULL),(13613,8871,'AP','9156941266',0,'2013-12-26 04:01:35',NULL,NULL),(26372,16975,'AP','9013048156',0,'2014-01-13 02:20:15',NULL,NULL),(28367,18278,'TE','8068319882',0,'2014-01-16 08:44:45',NULL,NULL),(29539,19092,'TE','6147437174',0,'2014-01-21 08:44:33',NULL,NULL),(34470,22616,'EM','TANHOACHAU@GMAIL.COM',0,'2014-02-11 21:00:08',NULL,NULL),(40486,26869,'TE','2168323699',0,'2014-03-01 21:01:03',NULL,NULL),(41924,27874,'TE','6012146540',0,'2014-03-05 21:32:27',NULL,NULL),(42888,28524,'TE','5672958759',0,'2014-03-07 21:32:03',NULL,NULL),(43540,28908,'TE','3306993387',0,'2014-03-10 21:00:25',NULL,NULL),(311,191,'TE','4196982676',0,'2013-12-25 17:19:58',NULL,NULL),(8787,5757,'TE','4405391544',0,'2013-12-25 23:46:24',NULL,NULL),(8531,5605,'AP','4404291242',0,'2013-12-25 23:30:23',NULL,NULL),(419,256,'TE','2253610441',0,'2013-12-25 17:21:43',NULL,NULL),(7344,4773,'EM','trokan@zoomtown.com',0,'2013-12-25 22:15:54',NULL,NULL),(6131,3947,'TE','4193413302',0,'2013-12-25 21:38:05',NULL,NULL),(2585,1577,'AP','8064017932',0,'2013-12-25 18:51:21',NULL,NULL),(25561,16489,'TE','4192245256',0,'2014-01-07 04:06:30',NULL,NULL),(4843,3099,'AP','9374163085',0,'2013-12-25 20:20:14',NULL,NULL),(21321,13700,'TE','3307874018',0,'2013-12-26 13:08:39',NULL,NULL),(4187,2679,'TE','6149204455',0,'2013-12-25 19:47:10',NULL,NULL),(20795,13363,'EM','guthrie728@yahoo.com',0,'2013-12-26 12:59:32',NULL,NULL),(9446,6183,'AP','2162333067',0,'2013-12-26 00:30:07',NULL,NULL),(9822,6426,'TE','2252689725',0,'2013-12-26 00:49:02',NULL,NULL),(14788,9678,'TE','4198226245',0,'2013-12-26 04:39:24',NULL,NULL),(10902,7084,'AP','7172090776',0,'2013-12-26 01:50:23',NULL,NULL),(29987,19413,'EM','elyjordan@yahoo.com',1,'2014-01-22 03:22:58',NULL,NULL),(31223,20335,'TE','3305252012',0,'2014-01-28 21:01:04',NULL,NULL),(32962,21578,'EM','cindyfahey30@gmail.com',0,'2014-02-05 21:30:24',NULL,NULL),(34843,22849,'TE','4192039386',0,'2014-02-11 21:02:19',NULL,NULL),(35611,23417,'TE','9034568312',0,'2014-02-13 22:01:20',NULL,NULL),(36818,24246,'AP','3303987896',0,'2014-02-16 19:00:41',NULL,NULL),(40709,27044,'EM','r.t.drees@sbcglobal.net',0,'2014-03-03 21:00:23',NULL,NULL),(42037,27938,'AP','4095501840',0,'2014-03-06 21:00:30',NULL,NULL),(42570,28327,'AP','2147973992',0,'2014-03-07 21:30:09',NULL,NULL),(25952,16717,'AP','9032445693',0,'2014-01-08 18:24:45',NULL,NULL),(26250,16894,'TE','9378257480',0,'2014-01-13 02:19:29',NULL,NULL),(23552,15202,'AP','6018636841',0,'2014-01-01 12:07:27',NULL,NULL),(22478,14494,'TE','9158573197',0,'2013-12-28 03:33:37',NULL,NULL),(11123,7232,'AP','7402851792',0,'2013-12-26 02:01:25',NULL,NULL),(6109,3932,'TE','4192503495',0,'2013-12-25 21:37:41',NULL,NULL),(10001,6543,'TE','4327419512',0,'2013-12-26 00:51:59',NULL,NULL),(1483,911,'TE','4193511557',0,'2013-12-25 18:08:33',NULL,NULL),(9525,6235,'TE','9035886056',0,'2013-12-26 00:31:33',NULL,NULL),(2930,1803,'TE','5132844030',0,'2013-12-25 18:56:49',NULL,NULL),(34799,22828,'EM','kcoste01@yahoo.com',0,'2014-02-11 21:02:05',NULL,NULL),(39391,26048,'EM','CYNTHIAFORGACS@GMAIL.COM',0,'2014-02-26 21:02:32',NULL,NULL),(43901,29127,'TE','4198614170',0,'2014-03-10 21:02:34',NULL,NULL),(3386,2130,'TE','5137069596',0,'2013-12-25 19:17:56',NULL,NULL),(22644,14601,'AP','9373697607',0,'2013-12-28 03:36:24',NULL,NULL),(21505,13819,'AP','3309070192',0,'2013-12-26 13:11:51',NULL,NULL),(6771,4393,'EM','ojstevo@aol.com',0,'2013-12-25 22:00:57',NULL,NULL),(3814,2428,'AP','7404074919',0,'2013-12-25 19:34:06',NULL,NULL),(14030,9163,'TE','9374848922',0,'2013-12-26 04:08:45',NULL,NULL),(32444,21198,'EM','keyklutz@yahoo.com',0,'2014-02-03 21:00:52',NULL,NULL),(32657,21359,'TE','4695866851',0,'2014-02-04 21:00:42',NULL,NULL),(32955,21574,'EM','DNEHLEN@AOL.COM',0,'2014-02-05 21:30:22',NULL,NULL),(33288,21797,'TE','5676445553',0,'2014-02-06 21:00:48',NULL,NULL),(34956,22950,'TE','4403717126',0,'2014-02-11 21:30:27',NULL,NULL),(37478,24679,'TE','9402229901',0,'2014-02-20 04:30:00',NULL,NULL),(38241,25248,'TE','9379973640',0,'2014-02-21 22:01:12',NULL,NULL),(38477,25427,'TE','6148707449',0,'2014-02-25 21:31:12',NULL,NULL),(42996,28594,'TE','4199446109',0,'2014-03-08 21:30:04',NULL,NULL),(43501,28885,'TE','6824591438',0,'2014-03-10 21:00:11',NULL,NULL),(25687,16560,'AP','3373306290',1,'2014-01-07 10:23:02',NULL,NULL),(8915,5834,'AP','2103166611',0,'2013-12-25 23:48:24',NULL,NULL),(22394,14444,'TE','8646029574',0,'2013-12-28 03:32:17',NULL,NULL),(729,457,'AP','3307304215',0,'2013-12-25 17:47:32',NULL,NULL),(21750,14009,'AP','5135204487',0,'2013-12-26 13:16:19',NULL,NULL),(2596,1583,'AP','9189043877',0,'2013-12-25 18:51:30',NULL,NULL),(6626,4283,'TE','4193037462',0,'2013-12-25 21:52:02',NULL,NULL),(26744,17202,'TE','3308360791',0,'2014-01-13 02:22:25',NULL,NULL),(31983,20881,'TE','9377630490',0,'2014-01-31 21:01:09',NULL,NULL),(32631,21337,'EM','tiffgiger@hotmail.com',0,'2014-02-04 21:00:31',NULL,NULL),(33855,22223,'EM','SOWELLJO@GMAIL.COM',0,'2014-02-09 19:00:28',NULL,NULL),(36131,23778,'AP','6624549469',0,'2014-02-14 21:31:18',NULL,NULL),(38712,25586,'BN','9852498103',0,'2014-02-26 08:00:40',NULL,NULL),(39742,26283,'EM','jmatlock21087@gmail.com',0,'2014-02-28 06:31:21',NULL,NULL),(40684,27018,'TE','4404490244',0,'2014-03-03 21:00:11',NULL,NULL),(42329,28111,'TE','3305240989',0,'2014-03-06 21:02:15',NULL,NULL),(198,121,'TE','3255736604',0,'2013-12-25 17:18:11',NULL,NULL),(26333,16951,'TE','6013422686',0,'2014-01-13 02:20:00',NULL,NULL),(26181,16855,'TE','4199290227',0,'2014-01-13 02:18:43',NULL,NULL),(3294,2073,'TE','5044300175',0,'2013-12-25 19:16:25',NULL,NULL),(25823,16646,'AP','8324959990',0,'2014-01-08 18:24:19',NULL,NULL),(8513,5597,'AP','5042750736',0,'2013-12-25 23:30:09',NULL,NULL),(25160,16218,'BN','5135825103',0,'2014-01-05 00:01:44',NULL,NULL),(4986,3201,'AP','3308023158',0,'2013-12-25 20:45:11',NULL,NULL),(21228,13647,'AP','2252413724',0,'2013-12-26 13:07:11',NULL,NULL),(20459,13180,'TE','6825571773',0,'2013-12-26 12:54:18',NULL,NULL),(9811,6420,'TE','2252659876',0,'2013-12-26 00:48:52',NULL,NULL),(9419,6164,'AP','9374231147',0,'2013-12-26 00:16:53',NULL,NULL),(26849,17272,'EM','kkilpatrick10@neo.rr.com',0,'2014-01-13 02:23:22',NULL,NULL),(31384,20456,'TE','6146495742',0,'2014-01-29 21:00:48',NULL,NULL),(33316,21819,'AP','3302214929',0,'2014-02-06 21:00:59',NULL,NULL),(33355,21850,'EM','faithwhitacre@gmail.com',0,'2014-02-06 21:01:15',NULL,NULL),(33922,22264,'EM','trevontfields@aol.com',0,'2014-02-10 11:00:10',NULL,NULL),(34042,22322,'EM','Elesterb1234@yahoo.com',0,'2014-02-10 11:00:54',NULL,NULL),(35133,23074,'TE','3185759114',0,'2014-02-12 21:30:59',NULL,NULL),(36048,23711,'TE','3304671470',0,'2014-02-14 21:30:47',NULL,NULL),(37141,24448,'AP','2255058712',0,'2014-02-18 22:01:24',NULL,NULL),(38150,25179,'EM','SJHOBERG@GMAIL.COM',0,'2014-02-21 22:00:33',NULL,NULL),(40622,26964,'AP','3308580251',0,'2014-03-03 01:00:32',NULL,NULL),(41351,27471,'TE','5133351376',0,'2014-03-04 21:02:11',NULL,NULL),(43185,28697,'TE','5043209447',0,'2014-03-08 21:31:07',NULL,NULL),(20785,13357,'TE','4408640048',0,'2013-12-26 12:59:22',NULL,NULL),(26094,16804,'AP','4092891023',0,'2014-01-13 02:18:13',NULL,NULL),(1988,1228,'TE','3303178613',0,'2013-12-25 18:20:37',NULL,NULL),(3042,1893,'TE','4195840292',0,'2013-12-25 18:58:55',NULL,NULL),(8162,5341,'TE','3306771798',0,'2013-12-25 23:07:22',NULL,NULL),(13972,9114,'TE','4407798469',0,'2013-12-26 04:07:37',NULL,NULL),(3512,2194,'EM','brownb900@yahoo.com',0,'2013-12-25 19:19:51',NULL,NULL),(7074,4621,'EM','LOURIC51@YAHOO.COM',0,'2013-12-25 22:06:14',NULL,NULL),(12306,8047,'EM','brianrjohns56@gmail.com',0,'2013-12-26 03:09:35',NULL,NULL),(38885,25703,'TE','8176456875',0,'2014-02-26 09:30:19',NULL,NULL),(25320,16328,'TE','2258032475',0,'2014-01-07 04:01:54',NULL,NULL),(26534,17070,'TE','9033871721',0,'2014-01-13 02:21:16',NULL,NULL),(8871,5811,'EM','jesusms1@gmail.com',0,'2013-12-25 23:47:47',NULL,NULL),(8836,5785,'AP','6147460985',0,'2013-12-25 23:47:10',NULL,NULL),(11278,7352,'TE','9515817519',0,'2013-12-26 02:15:09',NULL,NULL),(1036,638,'EM','kaylielee1010@yahoo.com',0,'2013-12-25 18:01:18',NULL,NULL),(9873,6455,'TE','3305716530',0,'2013-12-26 00:49:48',NULL,NULL),(6691,4349,'TE','4192246913',0,'2013-12-25 21:53:25',NULL,NULL),(35316,23205,'EM','kim_ellis448542002@yahoo.com',0,'2014-02-12 21:32:10',NULL,NULL),(37713,24865,'AP','9723521763',0,'2014-02-20 05:31:39',NULL,NULL),(39216,25934,'AP','4322940562',0,'2014-02-26 21:01:28',NULL,NULL),(41915,27869,'TE','4196486242',0,'2014-03-05 21:32:24',NULL,NULL),(346,215,'TE','5048106630',0,'2013-12-25 17:20:36',NULL,NULL),(13629,8887,'EM','rjordon1@elp.rr.com',0,'2013-12-26 04:01:55',NULL,NULL),(423,258,'TE','9374082703',0,'2013-12-25 17:21:47',NULL,NULL),(12289,8037,'AP','2167129328',0,'2013-12-26 03:09:20',NULL,NULL),(11290,7358,'TE','3614011918',0,'2013-12-26 02:15:19',NULL,NULL),(11098,7208,'EM','sonyareneajones131@gmail.com',0,'2013-12-26 02:00:51',NULL,NULL),(5539,3540,'AP','9152490494',0,'2013-12-25 21:21:46',NULL,NULL),(4102,2616,'EM','PBGIRLCITY@GMAIL.COM',0,'2013-12-25 19:45:45',NULL,NULL),(28814,18598,'AP','9013599512',0,'2014-01-16 08:47:17',NULL,NULL),(29360,18970,'EM','RISA1295@YAHOO.COM',0,'2014-01-20 08:06:02',NULL,NULL),(31666,20659,'AP','8308795510',0,'2014-01-30 21:00:43',NULL,NULL),(32574,21299,'TE','9853518305',0,'2014-02-04 21:00:11',NULL,NULL),(36085,23735,'TE','7405909252',0,'2014-02-14 21:31:00',NULL,NULL),(36797,24228,'EM','mlraine30@yahoo.com',0,'2014-02-16 19:00:32',NULL,NULL),(37756,24913,'EM','wmfowlkes3@live.com',0,'2014-02-20 21:30:09',NULL,NULL),(37824,24958,'AP','2252052592',0,'2014-02-20 22:00:17',NULL,NULL),(38227,25235,'TE','3308065915',0,'2014-02-21 22:01:04',NULL,NULL),(41562,27634,'AP','9372707599',0,'2014-03-05 21:30:12',NULL,NULL),(41999,27913,'AP','2146743541',0,'2014-03-06 21:00:17',NULL,NULL),(42401,28163,'TE','4194648126',0,'2014-03-06 21:02:43',NULL,NULL),(43763,29052,'AP','4196997558',0,'2014-03-10 21:01:47',NULL,NULL),(21388,13754,'TE','7692576739',0,'2013-12-26 13:10:01',NULL,NULL),(9533,6242,'AP','5136233828',0,'2013-12-26 00:31:41',NULL,NULL),(6379,4107,'EM','htoliver188@aol.com',0,'2013-12-25 21:47:55',NULL,NULL),(7315,4758,'TE','2817961969',0,'2013-12-25 22:15:27',NULL,NULL),(8564,5627,'AP','3308073625',0,'2013-12-25 23:30:56',NULL,NULL),(28140,18141,'TE','3373470210',0,'2014-01-15 02:07:46',NULL,NULL),(28398,18298,'EM','firefotock@gmail.com',0,'2014-01-16 08:44:55',NULL,NULL),(31011,20174,'TE','4403192078',0,'2014-01-27 21:01:16',NULL,NULL),(31210,20322,'EM','TRESRANAS7@GMAIL.COM',0,'2014-01-28 21:00:57',NULL,NULL),(31628,20631,'TE','5127916671',0,'2014-01-30 21:00:29',NULL,NULL),(32494,21233,'EM','themattgreek@gmail.com',0,'2014-02-03 21:01:10',NULL,NULL),(33988,22295,'AP','6144777982',0,'2014-02-10 11:00:32',NULL,NULL),(36940,24327,'AP','4053349606',0,'2014-02-18 22:00:12',NULL,NULL),(37471,24676,'AP','4192317429',0,'2014-02-20 04:28:47',NULL,NULL),(37934,25030,'TE','8323387482',0,'2014-02-20 22:01:03',NULL,NULL),(39502,26128,'TE','3307631370',0,'2014-02-28 06:30:22',NULL,NULL),(39620,26204,'AP','4403433331',0,'2014-02-28 06:30:50',NULL,NULL),(40480,26866,'AP','9154906965',0,'2014-03-01 21:01:00',NULL,NULL),(43976,29173,'AP','2165093092',0,'2014-03-10 21:03:01',NULL,NULL),(24389,15748,'AP','3256601966',0,'2014-01-03 02:01:05',NULL,NULL),(1788,1110,'EM','annecatherineharvey@gmail.com',0,'2013-12-25 18:17:28',NULL,NULL),(3274,2060,'TE','5132480704',0,'2013-12-25 19:16:05',NULL,NULL),(3971,2519,'EM','ricklaslo@yahoo.com',0,'2013-12-25 19:36:33',NULL,NULL),(7825,5107,'AP','9155884374',0,'2013-12-25 23:01:36',NULL,NULL),(21709,13981,'TE','5133867535',0,'2013-12-26 13:15:35',NULL,NULL),(6959,4536,'EM','DLSPIES55@GMAIL.COM',0,'2013-12-25 22:04:12',NULL,NULL),(20922,13452,'EM','Cozyyoung88@gmail.com',0,'2013-12-26 13:01:33',NULL,NULL),(20862,13414,'EM','daniel.kozdron@gmail.com',0,'2013-12-26 13:00:38',NULL,NULL),(11753,7650,'AP','2109130055',0,'2013-12-26 02:46:50',NULL,NULL),(30696,19940,'EM','lawanda1@exeed.net',0,'2014-01-24 21:01:14',NULL,NULL),(31318,20407,'AP','9037546678',0,'2014-01-29 21:00:23',NULL,NULL),(32432,21192,'AP','2283635155',0,'2014-02-03 21:00:49',NULL,NULL),(33955,22279,'TE','9158503921',0,'2014-02-10 11:00:20',NULL,NULL),(40321,26756,'AP','4093515357',0,'2014-03-01 19:00:05',NULL,NULL),(42409,28166,'AP','2252889807',0,'2014-03-06 21:02:46',NULL,NULL),(42901,28531,'TE','9857744638',0,'2014-03-07 21:32:08',NULL,NULL),(22137,14258,'TE','9857734793',0,'2013-12-27 02:05:43',NULL,NULL),(26730,17193,'AP','9377633092',0,'2014-01-13 02:22:19',NULL,NULL),(26552,17078,'AP','9366157337',0,'2014-01-13 02:21:21',NULL,NULL),(9415,6161,'EM','msizelove@cinci.rr.com',0,'2013-12-26 00:16:49',NULL,NULL),(20215,13023,'TE','5138460613',0,'2013-12-26 12:50:08',NULL,NULL),(13684,8921,'EM','eliobruni@yahoo.com',0,'2013-12-26 04:02:47',NULL,NULL),(1584,977,'AP','9372183946',0,'2013-12-25 18:10:11',NULL,NULL),(1736,1068,'EM','brian@48hourfilm.com',0,'2013-12-25 18:16:27',NULL,NULL),(10417,6792,'EM','swclark1@gmail.com',0,'2013-12-26 01:17:07',NULL,NULL),(10228,6683,'EM','dsimbeck@ymail.com',0,'2013-12-26 01:01:28',NULL,NULL),(5033,3227,'AP','3309573056',0,'2013-12-25 20:45:58',NULL,NULL),(4916,3158,'TE','5132076747',0,'2013-12-25 20:31:13',NULL,NULL),(5566,3556,'TE','3304681458',0,'2013-12-25 21:22:11',NULL,NULL),(28788,18579,'TE','4199624032',0,'2014-01-16 08:47:08',NULL,NULL),(28967,18697,'TE','3183310077',0,'2014-01-17 03:35:27',NULL,NULL),(31773,20740,'AP','5135153904',0,'2014-01-30 21:01:23',NULL,NULL),(33062,21657,'AP','9853203278',0,'2014-02-05 21:30:53',NULL,NULL),(35405,23275,'EM','wb1965@comcast.net',0,'2014-02-13 21:30:14',NULL,NULL),(38851,25682,'AP','5103637344',0,'2014-02-26 09:30:05',NULL,NULL),(40944,27206,'TE','4199130817',0,'2014-03-03 21:31:25',NULL,NULL),(42375,28141,'EM','rkaur19@yahoo.com',0,'2014-03-06 21:02:31',NULL,NULL),(1229,749,'AP','8322747545',0,'2013-12-25 18:04:15',NULL,NULL),(23324,15027,'AP','2252886055',0,'2014-01-01 12:02:31',NULL,NULL),(21996,14167,'EM','jeffdmcrae@gmail.com',0,'2013-12-27 02:03:21',NULL,NULL),(5595,3581,'TE','9374024292',0,'2013-12-25 21:22:44',NULL,NULL),(5716,3667,'EM','eaf363@gmail.com',0,'2013-12-25 21:31:04',NULL,NULL),(6724,4370,'AP','6142862357',0,'2013-12-25 22:00:17',NULL,NULL),(28235,18208,'EM','thebryankc@gmail.com',0,'2014-01-15 02:08:09',NULL,NULL),(28336,18260,'AP','8069285535',0,'2014-01-16 08:44:36',NULL,NULL),(28926,18675,'TE','9109777600',0,'2014-01-17 03:35:18',NULL,NULL),(30288,19622,'TE','3302413697',0,'2014-01-23 21:00:04',NULL,NULL),(31256,20361,'TE','4199660301',0,'2014-01-28 21:01:20',NULL,NULL),(33336,21837,'TE','5132313633',0,'2014-02-06 21:01:08',NULL,NULL),(33913,22259,'BN','9567935448',0,'2014-02-10 11:00:07',NULL,NULL),(35128,23071,'AP','3373962271',0,'2014-02-12 21:30:57',NULL,NULL),(35431,23291,'AP','6143787052',0,'2014-02-13 22:00:08',NULL,NULL),(38204,25217,'EM','rfcollett@yahoo.com',0,'2014-02-21 22:00:54',NULL,NULL),(39346,26026,'TE','6013450966',0,'2014-02-26 21:02:18',NULL,NULL),(40413,26826,'TE','2167896771',0,'2014-03-01 21:00:37',NULL,NULL),(40896,27173,'AP','9362440693',0,'2014-03-03 21:31:06',NULL,NULL),(25601,16514,'EM','fuentes0357@yahoo.com',1,'2014-01-07 10:21:29',NULL,NULL),(25229,16268,'TE','3309300382',0,'2014-01-07 04:00:12',NULL,NULL),(24856,16030,'TE','3184172444',0,'2014-01-04 02:02:28',NULL,NULL),(24339,15719,'EM','tivans@isolate.net',0,'2014-01-03 02:00:10',NULL,NULL),(2479,1520,'TE','2164966565',0,'2013-12-25 18:49:46',NULL,NULL),(22663,14613,'AP','6014541875',0,'2013-12-28 03:36:43',NULL,NULL),(14951,9782,'TE','2166731089',0,'2013-12-26 05:00:45',NULL,NULL),(14051,9180,'AP','5672598936',0,'2013-12-26 04:09:10',NULL,NULL),(7903,5149,'EM','billyg5678@yahoo.com',0,'2013-12-25 23:02:46',NULL,NULL),(3863,2457,'EM','alicia@kenmooreinsurance.com',0,'2013-12-25 19:34:49',NULL,NULL),(5243,3368,'TE','8067312355',0,'2013-12-25 21:17:11',NULL,NULL),(4766,3051,'EM','bickford.cole@gmail.com',0,'2013-12-25 20:18:55',NULL,NULL),(13862,9039,'TE','4406221862',0,'2013-12-26 04:05:46',NULL,NULL),(28454,18336,'TE','3307935448',0,'2014-01-16 08:45:15',NULL,NULL),(29711,19210,'TE','4197097823',0,'2014-01-21 08:46:21',NULL,NULL),(31950,20855,'AP','2152152899',0,'2014-01-31 21:00:55',NULL,NULL),(36170,23805,'TE','3305739514',0,'2014-02-14 21:31:32',NULL,NULL),(36292,23895,'TE','5139192455',0,'2014-02-14 21:32:20',NULL,NULL),(40356,26785,'TE','9562516760',0,'2014-03-01 21:00:15',NULL,NULL),(40440,26846,'AP','2255887435',0,'2014-03-01 21:00:48',NULL,NULL),(40507,26884,'TE','5134045419',0,'2014-03-01 21:01:11',NULL,NULL),(40726,27065,'AP','3377946755',0,'2014-03-03 21:30:02',NULL,NULL),(24095,15553,'TE','9856872293',1,'2014-01-02 04:31:22',NULL,NULL),(8744,5734,'AP','9858019540',0,'2013-12-25 23:45:45',NULL,NULL),(3385,2128,'AP','3308479991',0,'2013-12-25 19:17:54',NULL,NULL),(27356,17612,'EM','JESSICAMALDONADO86@GMAIL.COM',0,'2014-01-14 01:32:22',NULL,NULL),(14840,9713,'TE','3305395585',0,'2013-12-26 04:45:15',NULL,NULL),(6969,4544,'AP','9728396831',0,'2013-12-25 22:04:23',NULL,NULL),(10665,6931,'TE','3304216429',0,'2013-12-26 01:46:32',NULL,NULL),(29307,18935,'TE','7403312370',0,'2014-01-20 08:05:41',NULL,NULL),(32333,21121,'TE','2109121590',0,'2014-02-03 21:00:13',NULL,NULL),(34078,22340,'TE','3302891776',0,'2014-02-10 11:01:08',NULL,NULL),(37708,24862,'EM','jcast1@mindspring.com',0,'2014-02-20 05:30:41',NULL,NULL),(38666,25552,'AP','9856628899',0,'2014-02-26 08:00:19',NULL,NULL),(41934,27878,'TE','4196042190',0,'2014-03-05 21:32:31',NULL,NULL),(42361,28136,'AP','3306710258',0,'2014-03-06 21:02:27',NULL,NULL),(15,9,'TE','3308153716',0,'2013-12-25 17:15:16',NULL,NULL),(25840,16658,'AP','3182685714',0,'2014-01-08 18:24:23',NULL,NULL),(2522,1544,'AP','4128749395',0,'2013-12-25 18:50:24',NULL,NULL),(23493,15150,'TE','4193885713',0,'2014-01-01 12:06:02',NULL,NULL),(7952,5187,'EM','rosemariemorris0517@gmail.com',0,'2013-12-25 23:03:41',NULL,NULL),(7821,5106,'TE','2149238722',0,'2013-12-25 23:01:34',NULL,NULL),(20499,13198,'EM','zubeccas@gmail.com',0,'2013-12-26 12:54:53',NULL,NULL),(4290,2739,'AP','3303225611',0,'2013-12-25 19:48:45',NULL,NULL),(5139,3294,'TE','9374024292',0,'2013-12-25 21:15:34',NULL,NULL),(4220,2700,'TE','9033154178',0,'2013-12-25 19:47:42',NULL,NULL),(28229,18203,'TE','4198895176',0,'2014-01-15 02:08:07',NULL,NULL),(29724,19221,'TE','3306962169',0,'2014-01-21 08:46:27',NULL,NULL),(32868,21510,'AP','9374512880',0,'2014-02-04 21:01:58',NULL,NULL),(33246,21771,'AP','6146255360',0,'2014-02-06 21:00:32',NULL,NULL),(35601,23411,'TE','9792800203',0,'2014-02-13 22:01:16',NULL,NULL),(37585,24760,'AP','9377257737',0,'2014-02-20 04:42:58',NULL,NULL),(38219,25226,'AP','4408137608',0,'2014-02-21 22:01:00',NULL,NULL),(38370,25345,'TE','2165414313',0,'2014-02-25 21:30:28',NULL,NULL),(42056,27948,'AP','4105706560',0,'2014-03-06 21:00:36',NULL,NULL),(42117,27980,'AP','3184333252',0,'2014-03-06 21:00:56',NULL,NULL),(24911,16059,'TE','3303388713',0,'2014-01-04 02:03:27',NULL,NULL),(9928,6498,'EM','queeniepurr@zoominternet.net',0,'2013-12-26 00:50:46',NULL,NULL),(4438,2829,'TE','9852652237',0,'2013-12-25 20:00:43',NULL,NULL),(5178,3325,'TE','3306866026',0,'2013-12-25 21:16:08',NULL,NULL),(962,593,'AP','5132568354',0,'2013-12-25 18:00:07',NULL,NULL),(31266,20368,'TE','8504965274',0,'2014-01-29 21:00:04',NULL,NULL),(32353,21140,'TE','9408557999',0,'2014-02-03 21:00:22',NULL,NULL),(33133,21701,'AP','6015066605',0,'2014-02-05 21:31:11',NULL,NULL),(33184,21732,'TE','3258232189',0,'2014-02-06 21:00:10',NULL,NULL),(35400,23266,'AP','5136738802',0,'2014-02-13 21:30:12',NULL,NULL),(37252,24515,'TE','8322039668',0,'2014-02-20 03:54:46',NULL,NULL),(38694,25571,'TE','4197208931',0,'2014-02-26 08:00:31',NULL,NULL),(39052,25827,'TE','5135153320',0,'2014-02-26 21:00:29',NULL,NULL),(39150,25895,'EM','seanandalexw@gmail.com',0,'2014-02-26 21:01:05',NULL,NULL),(40739,27072,'EM','gailthebaker@hotmail.com',0,'2014-03-03 21:30:07',NULL,NULL),(40752,27082,'AP','3306344893',0,'2014-03-03 21:30:12',NULL,NULL),(24674,15910,'AP','5126624547',0,'2014-01-03 02:06:22',NULL,NULL),(469,295,'TE','3307220068',0,'2013-12-25 17:30:41',NULL,NULL),(24417,15764,'TE','7025262840',0,'2014-01-03 02:01:36',NULL,NULL),(22906,14781,'TE','5134298602',1,'2013-12-29 11:13:13',NULL,NULL),(21468,13795,'AP','6623926257',0,'2013-12-26 13:11:13',NULL,NULL),(8442,5555,'AP','2162589151',0,'2013-12-25 23:16:15',NULL,NULL),(8374,5503,'AP','3308838385',0,'2013-12-25 23:11:24',NULL,NULL),(1439,877,'AP','8122199371',0,'2013-12-25 18:07:37',NULL,NULL),(14691,9612,'AP','3308604523',0,'2013-12-26 04:37:41',NULL,NULL),(14504,9475,'EM','rbarakakos@yahoo.com',0,'2013-12-26 04:34:32',NULL,NULL),(10548,6868,'AP','9405671526',0,'2013-12-26 01:31:54',NULL,NULL),(10098,6597,'AP','6627060062',0,'2013-12-26 00:53:27',NULL,NULL),(28563,18416,'AP','3376549115',0,'2014-01-16 08:45:50',NULL,NULL),(29573,19108,'AP','5082098335',0,'2014-01-21 08:44:43',NULL,NULL),(37465,24673,'EM','ruggersarge@yahoo.com',0,'2014-02-20 04:27:59',NULL,NULL),(40744,27078,'TE','3306586811',0,'2014-03-03 21:30:09',NULL,NULL),(41585,27648,'TE','3304315249',0,'2014-03-05 21:30:21',NULL,NULL),(542,338,'AP','4407493008',0,'2013-12-25 17:31:54',NULL,NULL),(5621,3600,'AP','4193081072',0,'2013-12-25 21:23:15',NULL,NULL),(6352,4093,'TE','6012788934',0,'2013-12-25 21:47:31',NULL,NULL),(3948,2507,'AP','4192364151',0,'2013-12-25 19:36:11',NULL,NULL),(2807,1699,'AP','4193436544',0,'2013-12-25 18:54:39',NULL,NULL),(22045,14197,'TE','2033561700',0,'2013-12-27 02:04:10',NULL,NULL),(673,419,'EM','pdf123217@aol.com',0,'2013-12-25 17:46:36',NULL,NULL),(24907,16054,'TE','6146382115',0,'2014-01-04 02:03:19',NULL,NULL),(28638,18464,'BN','9855101232',0,'2014-01-16 08:46:14',NULL,NULL),(29135,18821,'TE','6014478606',0,'2014-01-17 03:36:06',NULL,NULL),(29532,19089,'AP','2167020566',0,'2014-01-21 08:44:31',NULL,NULL),(30205,19566,'EM','cwilly12@gmail.com',0,'2014-01-23 03:02:35',NULL,NULL),(32183,21020,'TE','5672401119',0,'2014-02-01 19:00:39',NULL,NULL),(33085,21670,'AP','3187192828',0,'2014-02-05 21:30:58',NULL,NULL),(38256,25256,'TE','4194488971',0,'2014-02-21 22:01:17',NULL,NULL),(41628,27672,'EM','manuelaguilar0625@gmail.com',0,'2014-03-05 21:30:34',NULL,NULL),(4,3,'AP','5133192721',0,'2013-12-25 17:15:05',NULL,NULL),(1591,981,'EM','n.mcdonald11@me.com',0,'2013-12-25 18:10:18',NULL,NULL),(25386,16372,'TE','2104148738',0,'2014-01-07 04:03:04',NULL,NULL),(7683,5005,'EM','captainrushin@gmail.com',0,'2013-12-25 22:47:14',NULL,NULL),(2068,1279,'AP','4405323581',0,'2013-12-25 18:30:31',NULL,NULL),(23377,15059,'EM','PPOWELL575@GMAIL.COM',0,'2014-01-01 12:03:30',NULL,NULL),(23231,14970,'AP','9562120661',0,'2014-01-01 12:00:47',NULL,NULL),(13893,9057,'EM','brenda.pangelinan@gmail.com',0,'2013-12-26 04:06:15',NULL,NULL),(10917,7095,'AP','3302124648',0,'2013-12-26 01:50:38',NULL,NULL),(27901,17978,'TE','3304880574',0,'2014-01-15 02:06:52',NULL,NULL),(32663,21362,'TE','9036036271',0,'2014-02-04 21:00:44',NULL,NULL),(33453,21916,'TE','4196355657',0,'2014-02-06 21:30:06',NULL,NULL),(36738,24187,'AP','8174372827',0,'2014-02-16 19:00:12',NULL,NULL),(40128,26612,'TE','3473318825',0,'2014-02-28 21:30:48',NULL,NULL),(41877,27846,'AP','9563138844',0,'2014-03-05 21:32:10',NULL,NULL),(823,512,'AP','5134906903',0,'2013-12-25 17:48:58',NULL,NULL),(8592,5646,'AP','2146321665',0,'2013-12-25 23:31:23',NULL,NULL),(8353,5486,'EM','Wrightsplumbing@yahoo.com',0,'2013-12-25 23:10:57',NULL,NULL),(7985,5208,'AP','5136020127',0,'2013-12-25 23:04:14',NULL,NULL),(7605,4951,'AP','2254361225',0,'2013-12-25 22:45:57',NULL,NULL),(24189,15627,'AP','5049065612',1,'2014-01-02 04:33:23',NULL,NULL),(24048,15528,'TE','3374470008',1,'2014-01-02 04:30:32',NULL,NULL),(7184,4682,'TE','5044192411',0,'2013-12-25 22:07:55',NULL,NULL),(23141,14920,'TE','7403172495',0,'2013-12-30 00:01:39',NULL,NULL),(22722,14651,'EM','Carolinablue25@gmail.com',1,'2013-12-29 11:07:45',NULL,NULL),(28539,18399,'AP','2169522583',0,'2014-01-16 08:45:42',NULL,NULL),(29826,19297,'TE','5044182143',1,'2014-01-22 03:21:58',NULL,NULL),(31133,20276,'TE','3305022201',0,'2014-01-28 21:00:27',NULL,NULL),(34705,22756,'TE','5043381633',0,'2014-02-11 21:01:29',NULL,NULL),(35452,23312,'AP','2169241398',0,'2014-02-13 22:00:21',NULL,NULL),(36066,23722,'TE','8326558941',0,'2014-02-14 21:30:53',NULL,NULL),(37188,24478,'AP','3309589105',0,'2014-02-18 22:01:43',NULL,NULL),(40670,27002,'AP','3305249333',0,'2014-03-03 21:00:02',NULL,NULL),(41328,27455,'TE','3303101920',0,'2014-03-04 21:02:02',NULL,NULL),(41571,27640,'AP','5133886465',0,'2014-03-05 21:30:15',NULL,NULL),(42553,28317,'AP','2816502933',0,'2014-03-07 21:30:02',NULL,NULL),(43219,28720,'TE','4049853352',0,'2014-03-08 21:31:20',NULL,NULL),(43829,29091,'AP','7133666927',0,'2014-03-10 21:02:10',NULL,NULL),(25425,16397,'EM','dabondurant@gmail.com',0,'2014-01-07 04:03:47',NULL,NULL),(2145,1322,'TE','4196040622',0,'2013-12-25 18:31:46',NULL,NULL),(2212,1360,'EM','susanfree2b44@yahoo.com',0,'2013-12-25 18:45:29',NULL,NULL),(2899,1776,'EM','soccerscott922@gmail.com',0,'2013-12-25 18:56:15',NULL,NULL),(20575,13239,'AP','5128004647',0,'2013-12-26 12:56:01',NULL,NULL),(20383,13127,'EM','timhiser@roadrunner.com',0,'2013-12-26 12:52:56',NULL,NULL),(14565,9516,'TE','4402560440',0,'2013-12-26 04:35:32',NULL,NULL),(10605,6902,'TE','5048665766',0,'2013-12-26 01:45:40',NULL,NULL),(9682,6344,'TE','7405881886',0,'2013-12-26 00:46:51',NULL,NULL),(26598,17111,'TE','5138290762',0,'2014-01-13 02:21:37',NULL,NULL),(34670,22733,'AP','2253159713',0,'2014-02-11 21:01:16',NULL,NULL),(38629,25532,'AP','2542470034',0,'2014-02-26 08:00:06',NULL,NULL),(39844,26355,'TE','5139478487',0,'2014-02-28 06:31:49',NULL,NULL),(42249,28063,'AP','2165135474',0,'2014-03-06 21:01:45',NULL,NULL),(43171,28688,'AP','3306239778',0,'2014-03-08 21:31:02',NULL,NULL),(43526,28899,'TE','9037484670',0,'2014-03-10 21:00:20',NULL,NULL),(43692,29002,'AP','7193131865',0,'2014-03-10 21:01:19',NULL,NULL),(43963,29166,'AP','4192969421',0,'2014-03-10 21:02:57',NULL,NULL),(107,64,'AP','2166475041',0,'2013-12-25 17:16:44',NULL,NULL),(25715,16576,'TE','4408133773',1,'2014-01-07 10:23:30',NULL,NULL),(2780,1683,'EM','deandriawilson2@gmail.com',0,'2013-12-25 18:54:14',NULL,NULL),(9292,6087,'TE','3304146127',0,'2013-12-26 00:02:37',NULL,NULL),(11605,7548,'AP','9858049791',0,'2013-12-26 02:33:08',NULL,NULL),(7911,5155,'TE','6142842195',0,'2013-12-25 23:02:55',NULL,NULL),(5386,3446,'EM','hopehammond@gmail.com',0,'2013-12-25 21:19:23',NULL,NULL),(7152,4663,'EM','toomhammond@aol.com',0,'2013-12-25 22:07:27',NULL,NULL),(27354,17612,'TE','8064003363',0,'2014-01-14 01:32:22',NULL,NULL),(32714,21401,'TE','9374981978',0,'2014-02-04 21:01:02',NULL,NULL),(33460,21919,'AP','8303709594',0,'2014-02-07 19:00:05',NULL,NULL),(39968,26462,'TE','9858708726',0,'2014-02-28 07:30:32',NULL,NULL),(41132,27320,'AP','2144423404',0,'2014-03-04 21:00:46',NULL,NULL),(24278,15689,'TE','3309686178',1,'2014-01-02 04:35:18',NULL,NULL),(1282,779,'EM','hvac_bueno@yahoo.com',0,'2013-12-25 18:05:02',NULL,NULL),(9001,5909,'TE','5138297437',0,'2013-12-25 23:49:57',NULL,NULL),(8122,5320,'TE','3306122882',0,'2013-12-25 23:06:47',NULL,NULL),(7807,5095,'TE','9565295003',0,'2013-12-25 23:01:20',NULL,NULL),(7673,4997,'TE','4408991916',0,'2013-12-25 22:47:04',NULL,NULL),(6758,4386,'TE','7405224239',0,'2013-12-25 22:00:46',NULL,NULL),(24036,15519,'TE','5043460574',1,'2014-01-02 04:30:17',NULL,NULL),(5635,3610,'EM','buffy6767@gmail.com',0,'2013-12-25 21:23:29',NULL,NULL),(2510,1539,'EM','tomlegan1951@yahoo.com',0,'2013-12-25 18:50:15',NULL,NULL),(3893,2473,'TE','3182889671',0,'2013-12-25 19:35:17',NULL,NULL),(3731,2369,'AP','4073610387',0,'2013-12-25 19:32:41',NULL,NULL),(11244,7319,'TE','2283264509',0,'2013-12-26 02:03:35',NULL,NULL),(23777,15334,'AP','4192626301',1,'2014-01-02 04:24:02',NULL,NULL),(22821,14717,'TE','5132250246',1,'2013-12-29 11:09:28',NULL,NULL),(22105,14238,'EM','GEOLIH@GMAIL.COM',0,'2013-12-27 02:05:11',NULL,NULL),(26663,17155,'TE','3183934003',0,'2014-01-13 02:21:58',NULL,NULL),(27848,17940,'AP','2146072158',0,'2014-01-15 02:06:39',NULL,NULL),(28242,18212,'TE','5137411744',0,'2014-01-15 02:08:10',NULL,NULL),(37574,24754,'TE','6142958723',0,'2014-02-20 04:41:49',NULL,NULL),(39295,25996,'BN','6014971976',0,'2014-02-26 21:02:00',NULL,NULL),(40242,26695,'TE','5043013503',0,'2014-02-28 21:31:30',NULL,NULL),(43187,28697,'EM','LINDAMICHELLE@MAIL.COM',0,'2014-03-08 21:31:07',NULL,NULL),(22174,14283,'AP','6015064130',0,'2013-12-27 02:06:23',NULL,NULL),(1191,727,'AP','5126692854',0,'2013-12-25 18:03:40',NULL,NULL),(8439,5551,'TE','2147272274',0,'2013-12-25 23:16:10',NULL,NULL),(1219,742,'TE','2546447930',0,'2013-12-25 18:04:06',NULL,NULL),(7259,4733,'EM','lorikg@hotmail.com',0,'2013-12-25 22:09:13',NULL,NULL),(2966,1836,'AP','3308193701',0,'2013-12-25 18:57:33',NULL,NULL),(14829,9706,'EM','arla@kajnbrown.net',0,'2013-12-26 04:45:04',NULL,NULL),(4515,2872,'TE','9035002002',0,'2013-12-25 20:01:58',NULL,NULL),(5687,3652,'AP','9376812014',0,'2013-12-25 21:30:41',NULL,NULL),(14236,9315,'TE','3188555113',0,'2013-12-26 04:30:21',NULL,NULL),(12323,8056,'EM','SWARSAW2004@HOTMAIL.COM',0,'2013-12-26 03:09:51',NULL,NULL),(28552,18407,'EM','ladytribefan@yahoo.com',0,'2014-01-16 08:45:46',NULL,NULL),(28588,18429,'AP','9854745206',0,'2014-01-16 08:45:57',NULL,NULL),(32162,21008,'TE','9377251262',0,'2014-02-01 19:00:33',NULL,NULL),(32525,21263,'TE','6012788934',0,'2014-02-03 21:01:25',NULL,NULL),(39699,26253,'TE','5126732301',0,'2014-02-28 06:31:09',NULL,NULL),(39820,26331,'AP','2605031597',0,'2014-02-28 06:31:40',NULL,NULL),(42357,28132,'AP','4194969688',0,'2014-03-06 21:02:25',NULL,NULL),(43884,29118,'AP','6013833541',0,'2014-03-10 21:02:28',NULL,NULL),(4993,3204,'EM','wmhollins@gmail.com',0,'2013-12-25 20:45:17',NULL,NULL),(8700,5709,'AP','6032649631',0,'2013-12-25 23:45:06',NULL,NULL),(8559,5623,'TE','6143841576',0,'2013-12-25 23:30:51',NULL,NULL),(14042,9173,'EM','matthew.roy.mcgrath@gmail.com',0,'2013-12-26 04:09:00',NULL,NULL),(11993,7813,'TE','8303052806',0,'2013-12-26 03:04:01',NULL,NULL),(11126,7233,'AP','4193442648',0,'2013-12-26 02:01:27',NULL,NULL),(6569,4240,'AP','9564585796',0,'2013-12-25 21:51:01',NULL,NULL),(6100,3928,'TE','4194234679',0,'2013-12-25 21:37:33',NULL,NULL),(10112,6610,'EM','cmcgui1460@att.net',0,'2013-12-26 00:53:44',NULL,NULL),(27845,17939,'TE','8325258441',0,'2014-01-15 02:06:39',NULL,NULL),(29621,19137,'TE','3252276739',0,'2014-01-21 08:45:27',NULL,NULL),(29815,19290,'AP','9854457693',1,'2014-01-22 03:21:54',NULL,NULL),(31750,20720,'BN','9377799008',0,'2014-01-30 21:01:14',NULL,NULL),(32186,21023,'AP','3302948447',0,'2014-02-01 19:00:40',NULL,NULL),(21572,13873,'TE','3308581920',0,'2013-12-26 13:13:07',NULL,NULL),(21423,13775,'TE','2514903691',0,'2013-12-26 13:10:35',NULL,NULL),(24464,15790,'AP','2022575502',0,'2014-01-03 02:02:28',NULL,NULL),(9622,6296,'AP','2164022567',0,'2013-12-26 00:45:48',NULL,NULL),(26026,16770,'AP','9374036408',0,'2014-01-08 18:25:01',NULL,NULL),(5006,3214,'TE','2142137138',0,'2013-12-25 20:45:30',NULL,NULL),(2475,1518,'TE','3305278017',0,'2013-12-25 18:49:43',NULL,NULL),(2967,1836,'EM','jcarper03@msn.com',0,'2013-12-25 18:57:33',NULL,NULL),(6860,4450,'AP','5616328647',0,'2013-12-25 22:02:23',NULL,NULL),(31314,20403,'AP','8177265873',0,'2014-01-29 21:00:21',NULL,NULL),(34417,22578,'AP','4192621661',0,'2014-02-10 21:32:01',NULL,NULL),(35557,23383,'TE','5133072112',0,'2014-02-13 22:01:01',NULL,NULL),(39465,26097,'AP','5046067491',0,'2014-02-28 06:30:11',NULL,NULL),(39633,26209,'TE','4407963970',0,'2014-02-28 06:30:52',NULL,NULL),(20606,13253,'TE','2142563205',0,'2013-12-26 12:56:28',NULL,NULL),(1059,652,'AP','4405335711',0,'2013-12-25 18:01:38',NULL,NULL),(1272,773,'EM','jasoarmour@gmail.com',0,'2013-12-25 18:04:53',NULL,NULL),(8580,5640,'TE','9728043459',0,'2013-12-25 23:31:13',NULL,NULL),(2660,1614,'EM','ame.villalobos@outlook.com',0,'2013-12-25 18:52:25',NULL,NULL),(25125,16195,'AP','9152526622',0,'2014-01-05 00:00:59',NULL,NULL),(4639,2960,'AP','3252128854',0,'2013-12-25 20:16:44',NULL,NULL),(7134,4654,'AP','5042893733',0,'2013-12-25 22:07:12',NULL,NULL),(3488,2183,'TE','3612581557',0,'2013-12-25 19:19:29',NULL,NULL),(28590,18430,'AP','5044175383',0,'2014-01-16 08:45:57',NULL,NULL),(29626,19143,'AP','9153569515',0,'2014-01-21 08:45:30',NULL,NULL),(35015,22992,'EM','loganberry1104@yahoo.com',0,'2014-02-12 21:30:14',NULL,NULL),(36077,23730,'EM','TAMMYLW_316@YAHOO.COM',0,'2014-02-14 21:30:57',NULL,NULL),(39823,26335,'EM','brock.inc@bright.net',0,'2014-02-28 06:31:42',NULL,NULL),(39824,26338,'TE','4197271160',0,'2014-02-28 06:31:43',NULL,NULL),(41285,27432,'TE','9365811978',0,'2014-03-04 21:01:47',NULL,NULL),(24608,15870,'AP','9013782923',0,'2014-01-03 02:05:05',NULL,NULL),(26402,16992,'AP','5679387877',0,'2014-01-13 02:20:25',NULL,NULL),(24513,15812,'AP','3183668989',0,'2014-01-03 02:03:14',NULL,NULL),(23653,15273,'AP','3309581000',1,'2014-01-02 04:21:53',NULL,NULL),(23547,15198,'TE','6622376676',0,'2014-01-01 12:07:20',NULL,NULL),(23290,15006,'AP','3306205083',0,'2014-01-01 12:01:54',NULL,NULL),(21507,13822,'TE','3309636063',0,'2013-12-26 13:11:54',NULL,NULL),(2327,1420,'TE','2543668201',0,'2013-12-25 18:47:12',NULL,NULL),(6317,4073,'AP','6147079353',0,'2013-12-25 21:46:59',NULL,NULL),(6307,4065,'TE','5138311796',0,'2013-12-25 21:46:47',NULL,NULL),(12057,7872,'TE','4253271474',0,'2013-12-26 03:05:12',NULL,NULL),(5617,3597,'EM','marystacy2612@outlook.com',0,'2013-12-25 21:23:09',NULL,NULL),(27574,17771,'EM','aleem.jaffer@yahoo.com',0,'2014-01-14 01:33:38',NULL,NULL),(29190,18858,'TE','5042375994',0,'2014-01-17 03:36:19',NULL,NULL),(33959,22281,'AP','3304754135',0,'2014-02-10 11:00:22',NULL,NULL),(34967,22957,'TE','5049059596',0,'2014-02-12 21:00:06',NULL,NULL),(36166,23803,'EM','mepccduffy@wowway.com',0,'2014-02-14 21:31:31',NULL,NULL),(38991,25782,'AP','4193068063',0,'2014-02-26 09:31:04',NULL,NULL),(287,177,'EM','Katgb4@yahoo.com',0,'2013-12-25 17:19:35',NULL,NULL),(26220,16876,'EM','jeffery.hibbitts1@verizon.net',0,'2014-01-13 02:19:19',NULL,NULL),(24002,15492,'AP','9374176225',1,'2014-01-02 04:29:33',NULL,NULL),(9268,6066,'EM','drgjicama@aol.com',0,'2013-12-26 00:02:04',NULL,NULL),(10507,6842,'TE','7403523714',0,'2013-12-26 01:31:09',NULL,NULL),(6149,3958,'AP','3306081020',0,'2013-12-25 21:38:22',NULL,NULL),(4507,2867,'AP','9375649179',0,'2013-12-25 20:01:49',NULL,NULL),(4099,2614,'TE','5133106827',0,'2013-12-25 19:45:42',NULL,NULL),(27339,17605,'AP','3616521608',0,'2014-01-14 01:32:18',NULL,NULL),(35417,23283,'EM','lhazelwood@fuse.net',0,'2014-02-13 21:30:17',NULL,NULL),(2173,1336,'EM','marlo@marlosilver.com',0,'2013-12-25 18:32:17',NULL,NULL),(2203,1353,'TE','2145345845',0,'2013-12-25 18:45:19',NULL,NULL),(2282,1400,'TE','5043624336',0,'2013-12-25 18:46:35',NULL,NULL),(2377,1444,'AP','9377634922',0,'2013-12-25 18:47:56',NULL,NULL),(23611,15243,'AP','4196190750',0,'2014-01-01 12:08:42',NULL,NULL),(8895,5825,'AP','7134175008',0,'2013-12-25 23:48:08',NULL,NULL),(6783,4400,'TE','7403192000',0,'2013-12-25 22:01:08',NULL,NULL),(25728,16582,'BN','9857744969',0,'2014-01-08 18:23:58',NULL,NULL),(6845,4442,'TE','2166623231',0,'2013-12-25 22:02:09',NULL,NULL),(22205,14304,'TE','4195864822',0,'2013-12-27 02:06:56',NULL,NULL),(8104,5306,'TE','9018329167',0,'2013-12-25 23:06:26',NULL,NULL),(10489,6833,'TE','4402518375',0,'2013-12-26 01:30:51',NULL,NULL),(14859,9722,'AP','5132255710',0,'2013-12-26 04:45:30',NULL,NULL),(28296,18239,'AP','8063192918',0,'2014-01-16 08:44:24',NULL,NULL),(30540,19812,'TE','7148031193',0,'2014-01-24 21:00:10',NULL,NULL),(31025,20183,'EM','fitrjw@yahoo.com',0,'2014-01-27 21:01:22',NULL,NULL),(31232,20340,'AP','5048744564',0,'2014-01-28 21:01:07',NULL,NULL),(32513,21254,'TE','3307623047',0,'2014-02-03 21:01:19',NULL,NULL),(34134,22379,'TE','3309232752',0,'2014-02-10 21:30:08',NULL,NULL),(36057,23718,'TE','5133491088',0,'2014-02-14 21:30:50',NULL,NULL),(37265,24521,'TE','9562678500',0,'2014-02-20 03:57:25',NULL,NULL),(43104,28654,'AP','6782218494',0,'2014-03-08 21:30:40',NULL,NULL),(43674,28985,'AP','3307458204',0,'2014-03-10 21:01:11',NULL,NULL),(1430,873,'TE','9375649179',0,'2013-12-25 18:07:30',NULL,NULL),(14753,9648,'TE','7652771361',0,'2013-12-26 04:38:42',NULL,NULL),(12032,7849,'TE','3309798761',0,'2013-12-26 03:04:46',NULL,NULL),(3006,1867,'EM','sitzm1@aol.com',0,'2013-12-25 18:58:13',NULL,NULL),(7455,4854,'EM','pyrostuff@aol.com',0,'2013-12-25 22:30:27',NULL,NULL),(7609,4955,'EM','ybetty88@gmail.com',0,'2013-12-25 22:46:03',NULL,NULL),(27276,17561,'TE','9852223900',0,'2014-01-13 03:02:01',NULL,NULL),(29177,18852,'EM','Igroit1963@yahoo.com',0,'2014-01-17 03:36:16',NULL,NULL),(31852,20795,'EM','Ernielee0823@gmail.com',0,'2014-01-31 21:00:18',NULL,NULL),(33306,21814,'TE','3307017044',0,'2014-02-06 21:00:55',NULL,NULL),(35614,23420,'AP','7139922952',0,'2014-02-13 22:01:22',NULL,NULL),(39861,26370,'TE','6144789986',0,'2014-02-28 07:00:11',NULL,NULL),(40555,26917,'AP','9374225687',0,'2014-03-03 01:00:14',NULL,NULL),(41144,27329,'TE','2546611348',0,'2014-03-04 21:00:51',NULL,NULL),(43980,29176,'TE','3304310156',0,'2014-03-10 21:03:02',NULL,NULL),(647,402,'EM','JPFINK60@HUGHES.NET',0,'2013-12-25 17:46:11',NULL,NULL),(8187,5358,'TE','3308074232',0,'2013-12-25 23:07:47',NULL,NULL),(1340,818,'TE','3302420092',0,'2013-12-25 18:06:01',NULL,NULL),(2932,1803,'TE','5132844030',0,'2013-12-25 18:56:49',NULL,NULL),(3283,2065,'EM','tlperryman@gmail.com',0,'2013-12-25 19:16:13',NULL,NULL),(22894,14772,'TE','5126771190',1,'2013-12-29 11:12:58',NULL,NULL),(11694,7613,'AP','7632426257',0,'2013-12-26 02:45:42',NULL,NULL),(6670,4330,'AP','9375645597',0,'2013-12-25 21:53:00',NULL,NULL),(27271,17558,'TE','9562954262',0,'2014-01-13 03:01:59',NULL,NULL),(31347,20427,'TE','5132900594',0,'2014-01-29 21:00:33',NULL,NULL),(33547,21992,'EM','boancadumitru@gmail.com',0,'2014-02-07 19:00:43',NULL,NULL),(37508,24697,'BN','9567401351',0,'2014-02-20 04:33:53',NULL,NULL),(38986,25780,'EM','ssauer@kent.edu',0,'2014-02-26 09:31:02',NULL,NULL),(39643,26214,'TE','3305628162',0,'2014-02-28 06:30:54',NULL,NULL),(43053,28623,'AP','2812363416',0,'2014-03-08 21:30:22',NULL,NULL),(1505,925,'AP','3307412101',0,'2013-12-25 18:08:59',NULL,NULL),(37863,24977,'TE','8326201633',0,'2014-02-20 22:00:31',NULL,NULL),(38245,25251,'TE','6628871152',0,'2014-02-21 22:01:14',NULL,NULL),(39487,26117,'EM','Jacob.Mattes@yahoo.com',0,'2014-02-28 06:30:18',NULL,NULL),(42004,27916,'TE','9033303460',0,'2014-03-06 21:00:18',NULL,NULL),(2520,1543,'EM','nbooks@embarqmail.com',0,'2013-12-25 18:50:23',NULL,NULL),(20943,13469,'AP','9372310660',0,'2013-12-26 13:01:59',NULL,NULL),(11770,7659,'AP','2257162060',0,'2013-12-26 03:00:13',NULL,NULL),(11751,7649,'EM','qpham855412000@yahoo.com',0,'2013-12-26 02:46:49',NULL,NULL),(8763,5742,'EM','jominor@bellsouth.net',0,'2013-12-25 23:46:00',NULL,NULL),(23966,15469,'TE','3302392302',1,'2014-01-02 04:28:51',NULL,NULL),(24316,15707,'AP','3308560715',1,'2014-01-02 04:35:58',NULL,NULL),(6170,3975,'EM','j.mark.milano@gmail.com',0,'2013-12-25 21:38:42',NULL,NULL),(30171,19547,'EM','adriannebooker@aol.com',0,'2014-01-23 03:02:27',NULL,NULL),(30951,20132,'EM','ebethanna@gmail.com',0,'2014-01-27 21:00:52',NULL,NULL),(34044,22323,'EM','mrsergioperez999@gmail.com',0,'2014-02-10 11:00:55',NULL,NULL),(34218,22441,'EM','LUPITAGARZA.LG75@GMAIL.COM',0,'2014-02-10 21:30:42',NULL,NULL),(34940,22932,'AP','5132527432',0,'2014-02-11 21:30:11',NULL,NULL),(35082,23041,'TE','3615637801',0,'2014-02-12 21:30:40',NULL,NULL),(35685,23473,'AP','3252628967',0,'2014-02-13 22:01:49',NULL,NULL),(36937,24324,'AP','5126361802',0,'2014-02-18 22:00:10',NULL,NULL),(39030,25810,'AP','5132927782',0,'2014-02-26 21:00:21',NULL,NULL),(40962,27218,'TE','6014218044',0,'2014-03-03 21:31:33',NULL,NULL),(42059,27950,'AP','9364393700',0,'2014-03-06 21:00:37',NULL,NULL),(42257,28066,'EM','nbtchorz@yahoo.com',0,'2014-03-06 21:01:47',NULL,NULL),(43648,28970,'EM','joycelyn.landrum@yahoo.com',0,'2014-03-10 21:01:02',NULL,NULL),(43987,29182,'AP','9372161690',0,'2014-03-10 21:29:58',NULL,NULL),(6290,4054,'TE','5133280590',0,'2013-12-25 21:46:30',NULL,NULL),(8737,5728,'EM','tpham16@hotmail.com',0,'2013-12-25 23:45:37',NULL,NULL),(10847,7040,'EM','bratintx@yahoo.com',0,'2013-12-26 01:49:24',NULL,NULL),(4768,3052,'AP','2253687755',0,'2013-12-25 20:18:57',NULL,NULL),(2363,1435,'TE','5048975263',0,'2013-12-25 18:47:41',NULL,NULL),(859,536,'EM','sugarpeopledeb@aol.com',0,'2013-12-25 17:49:34',NULL,NULL),(5668,3641,'TE','6019570230',0,'2013-12-25 21:30:22',NULL,NULL),(5770,3696,'EM','frankotj54@gmail.com',0,'2013-12-25 21:31:52',NULL,NULL),(24693,15927,'AP','6016130356',0,'2014-01-03 02:06:49',NULL,NULL),(25153,16214,'TE','6044374822',0,'2014-01-05 00:01:35',NULL,NULL),(28071,18092,'TE','3182952002',0,'2014-01-15 02:07:31',NULL,NULL),(32096,20962,'TE','3613966815',0,'2014-02-01 19:00:10',NULL,NULL),(35267,23161,'TE','9034526391',0,'2014-02-12 21:31:47',NULL,NULL),(38642,25539,'TE','5133641467',0,'2014-02-26 08:00:10',NULL,NULL),(38764,25626,'EM','christopher.tucker1@yahoo.com',0,'2014-02-26 08:30:21',NULL,NULL),(40572,26928,'AP','2169031533',0,'2014-03-03 01:00:18',NULL,NULL),(41632,27676,'TE','9044420238',0,'2014-03-05 21:30:36',NULL,NULL),(41973,27901,'AP','4327411499',0,'2014-03-06 21:00:09',NULL,NULL),(710,442,'AP','2166507328',0,'2013-12-25 17:47:12',NULL,NULL),(14428,9430,'AP','7208918951',0,'2013-12-26 04:33:23',NULL,NULL),(12200,7972,'TE','3307037129',0,'2013-12-26 03:07:43',NULL,NULL),(11067,7188,'TE','6143543021',0,'2013-12-26 02:00:21',NULL,NULL),(20948,13472,'EM','kristenhunt1@yahoo.com',0,'2013-12-26 13:02:04',NULL,NULL),(2303,1409,'AP','6508681737',0,'2013-12-25 18:46:52',NULL,NULL),(5202,3343,'TE','9564994347',0,'2013-12-25 21:16:32',NULL,NULL),(22000,14169,'EM','julia_castle@aol.com',0,'2013-12-27 02:03:24',NULL,NULL),(1465,898,'TE','4196187610',0,'2013-12-25 18:08:12',NULL,NULL),(26222,16878,'AP','9366311285',0,'2014-01-13 02:19:19',NULL,NULL),(26351,16960,'EM','arrozack@googlemail.com',0,'2014-01-13 02:20:06',NULL,NULL),(34808,22832,'EM','TLPARK1119@aol.com',0,'2014-02-11 21:02:08',NULL,NULL),(35223,23134,'TE','3302176660',0,'2014-02-12 21:31:32',NULL,NULL),(35444,23304,'BN','3302895853',0,'2014-02-13 22:00:17',NULL,NULL),(36007,23686,'TE','4405707483',0,'2014-02-14 21:30:34',NULL,NULL),(38163,25189,'TE','8016808942',0,'2014-02-21 22:00:38',NULL,NULL),(39368,26037,'EM','LmomL2@aol.com',0,'2014-02-26 21:02:25',NULL,NULL),(39624,26206,'TE','2167731774',0,'2014-02-28 06:30:51',NULL,NULL),(39925,26421,'TE','5122929904',0,'2014-02-28 07:30:08',NULL,NULL),(40168,26641,'TE','9366622732',0,'2014-02-28 21:31:03',NULL,NULL),(43078,28639,'TE','9569704802',0,'2014-03-08 21:30:31',NULL,NULL),(43473,28871,'AP','9155401293',0,'2014-03-10 21:00:02',NULL,NULL),(25895,16691,'TE','3105294834',0,'2014-01-08 18:24:35',NULL,NULL),(25749,16594,'AP','5047013529',0,'2014-01-08 18:24:02',NULL,NULL),(22505,14511,'TE','2106061441',0,'2013-12-28 03:34:03',NULL,NULL),(11596,7544,'TE','5124222338',0,'2013-12-26 02:33:00',NULL,NULL),(27898,17976,'AP','3308444453',0,'2014-01-15 02:06:51',NULL,NULL),(28758,18558,'AP','5138018179',0,'2014-01-16 08:46:57',NULL,NULL),(30556,19828,'TE','9727650292',0,'2014-01-24 21:00:17',NULL,NULL),(33037,21643,'AP','6823004198',0,'2014-02-05 21:30:46',NULL,NULL),(34968,22957,'AP','5049059596',0,'2014-02-12 21:00:06',NULL,NULL),(35672,23462,'TE','9035676903',0,'2014-02-13 22:01:44',NULL,NULL),(36181,23814,'TE','3307494618',0,'2014-02-14 21:31:37',NULL,NULL),(37732,24884,'AP','5134843500',0,'2014-02-20 05:37:25',NULL,NULL),(40244,26695,'EM','caddmaxxinc@aol.com',0,'2014-02-28 21:31:30',NULL,NULL),(40996,27238,'TE','6018075826',0,'2014-03-03 21:31:46',NULL,NULL),(41894,27855,'BN','5127553143',0,'2014-03-05 21:32:15',NULL,NULL),(42456,28204,'TE','9493717506',0,'2014-03-06 21:30:11',NULL,NULL),(25571,16497,'TE','9374096728',0,'2014-01-07 04:06:41',NULL,NULL),(13553,8838,'AP','5127966088',0,'2013-12-26 04:00:40',NULL,NULL),(7962,5193,'TE','3309902772',0,'2013-12-25 23:03:51',NULL,NULL),(12144,7934,'TE','3372758196',0,'2013-12-26 03:06:42',NULL,NULL),(9126,5976,'AP','3305750409',0,'2013-12-25 23:51:49',NULL,NULL),(1892,1166,'TE','2259393572',0,'2013-12-25 18:19:02',NULL,NULL),(7097,4632,'TE','6624231412',0,'2013-12-25 22:06:34',NULL,NULL),(2167,1332,'EM','chandler.john3@gmail.com',0,'2013-12-25 18:32:09',NULL,NULL),(5397,3454,'TE','5132254569',0,'2013-12-25 21:19:36',NULL,NULL),(28893,18653,'AP','3616960581',0,'2014-01-17 03:35:11',NULL,NULL),(30992,20160,'TE','5135414193',0,'2014-01-27 21:01:09',NULL,NULL),(32293,21093,'EM','gnishim@gmail.com',0,'2014-02-02 19:00:29',NULL,NULL),(32419,21183,'AP','6018421908',0,'2014-02-03 21:00:44',NULL,NULL),(36850,24266,'EM','Wilkinson777@aol.com',0,'2014-02-17 19:00:14',NULL,NULL),(37217,24493,'TE','5123633330',0,'2014-02-20 03:45:45',NULL,NULL),(38830,25668,'TE','6018268218',0,'2014-02-26 08:30:50',NULL,NULL),(40402,26818,'TE','5132386103',0,'2014-03-01 21:00:33',NULL,NULL),(40807,27117,'AP','4404742334',0,'2014-03-03 21:30:31',NULL,NULL),(41435,27526,'TE','4192801129',0,'2014-03-04 21:02:44',NULL,NULL),(1888,1164,'TE','3182019800',0,'2013-12-25 18:19:00',NULL,NULL),(2295,1406,'TE','2259382453',0,'2013-12-25 18:46:46',NULL,NULL),(25785,16615,'TE','3309802182',0,'2014-01-08 18:24:09',NULL,NULL),(22073,14215,'AP','7134783327',0,'2013-12-27 02:04:35',NULL,NULL),(21981,14158,'EM','LETITIACOTTON@GMAIL.COM',0,'2013-12-27 02:03:06',NULL,NULL),(21656,13936,'AP','4198062957',0,'2013-12-26 13:14:39',NULL,NULL),(4037,2577,'EM','pjw2005yes@yahoo.com',0,'2013-12-25 19:37:53',NULL,NULL),(4216,2694,'EM','mohamed.habib51@gmail.com',0,'2013-12-25 19:47:36',NULL,NULL),(20747,13334,'AP','8326430437',0,'2013-12-26 12:58:43',NULL,NULL),(10544,6867,'TE','8069306122',0,'2013-12-26 01:31:52',NULL,NULL),(14777,9670,'AP','9373026824',0,'2013-12-26 04:39:13',NULL,NULL),(26833,17261,'TE','9374088957',0,'2014-01-13 02:23:17',NULL,NULL),(36885,24292,'TE','3304007103',0,'2014-02-18 21:30:14',NULL,NULL),(38322,25318,'AP','5046100739',0,'2014-02-25 21:30:07',NULL,NULL),(39290,25995,'TE','6627010138',0,'2014-02-26 21:01:59',NULL,NULL),(43583,28940,'AP','4192768197',0,'2014-03-10 21:00:42',NULL,NULL),(43689,29001,'TE','3306993387',0,'2014-03-10 21:01:19',NULL,NULL),(694,431,'TE','7406015550',0,'2013-12-25 17:46:55',NULL,NULL),(1411,861,'TE','3305595203',0,'2013-12-25 18:07:11',NULL,NULL),(24458,15787,'BN','9852272426',0,'2014-01-03 02:02:22',NULL,NULL),(22108,14240,'EM','lyonstabatha@yahoo.com',0,'2013-12-27 02:05:13',NULL,NULL),(4979,3197,'AP','5133442789',0,'2013-12-25 20:45:04',NULL,NULL),(20831,13390,'EM','cvadakinsalvati@gmail.com',0,'2013-12-26 13:00:08',NULL,NULL),(20727,13322,'TE','8323686829',0,'2013-12-26 12:58:24',NULL,NULL),(10239,6695,'TE','5126775288',0,'2013-12-26 01:01:42',NULL,NULL),(31310,20401,'AP','2544212652',0,'2014-01-29 21:00:20',NULL,NULL),(31624,20629,'TE','3613432442',0,'2014-01-30 21:00:27',NULL,NULL),(31857,20798,'AP','9728247505',0,'2014-01-31 21:00:19',NULL,NULL),(32489,21229,'TE','3302121492',0,'2014-02-03 21:01:08',NULL,NULL),(34002,22301,'BN','3303090862',0,'2014-02-10 11:00:38',NULL,NULL),(34277,22488,'EM','rmcowen@woh.rr.com',0,'2014-02-10 21:31:07',NULL,NULL),(41342,27464,'EM','leri007@zoominternet.net',0,'2014-03-04 21:02:07',NULL,NULL),(42720,28416,'TE','5134843509',0,'2014-03-07 21:30:59',NULL,NULL),(43365,28802,'AP','4404066222',0,'2014-03-09 21:00:49',NULL,NULL),(25211,16257,'TE','6016720699',0,'2014-01-05 00:02:47',NULL,NULL),(24010,15504,'TE','6144918253',1,'2014-01-02 04:29:49',NULL,NULL),(1771,1095,'AP','4407850343',0,'2013-12-25 18:17:07',NULL,NULL),(2768,1678,'TE','2253579329',0,'2013-12-25 18:54:05',NULL,NULL),(6432,4155,'TE','2163147791',0,'2013-12-25 21:48:52',NULL,NULL),(23274,14995,'TE','9365989826',0,'2014-01-01 12:01:33',NULL,NULL),(3729,2366,'EM','toniotchere@gmail.com',0,'2013-12-25 19:32:38',NULL,NULL),(4391,2798,'TE','3305595203',0,'2013-12-25 19:50:21',NULL,NULL),(4087,2607,'TE','5137910594',0,'2013-12-25 19:45:30',NULL,NULL),(8991,5902,'TE','4408881843',0,'2013-12-25 23:49:47',NULL,NULL),(11945,7778,'AP','9362549084',0,'2013-12-26 03:03:08',NULL,NULL),(9872,6454,'EM','lab4kids@aol.com',0,'2013-12-26 00:49:46',NULL,NULL),(29400,19001,'TE','5042106596',0,'2014-01-20 08:06:16',NULL,NULL),(30011,19434,'AP','4193500218',1,'2014-01-22 03:23:09',NULL,NULL),(32637,21345,'TE','2104346404',0,'2014-02-04 21:00:35',NULL,NULL),(33217,21753,'AP','2145580189',0,'2014-02-06 21:00:22',NULL,NULL),(33237,21764,'AP','8322770625',0,'2014-02-06 21:00:28',NULL,NULL),(33934,22269,'EM','berzoz82@gmail.com',0,'2014-02-10 11:00:13',NULL,NULL),(38777,25635,'AP','5042286782',0,'2014-02-26 08:30:27',NULL,NULL),(41147,27331,'TE','6147499022',0,'2014-03-04 21:00:52',NULL,NULL),(42109,27977,'TE','5043431770',0,'2014-03-06 21:00:54',NULL,NULL),(22927,14793,'TE','2164752805',1,'2013-12-29 11:13:33',NULL,NULL),(7697,5022,'AP','3378498109',0,'2013-12-25 22:47:34',NULL,NULL),(21022,13525,'TE','5044507077',0,'2013-12-26 13:03:19',NULL,NULL),(11866,7725,'TE','6145316050',0,'2013-12-26 03:01:51',NULL,NULL),(7068,4615,'EM','pastorjoefrank@sbcglobal.net',0,'2013-12-25 22:06:06',NULL,NULL),(9821,6425,'AP','2252215343',0,'2013-12-26 00:49:01',NULL,NULL),(26553,17078,'EM','rosichavez2002@yahoo.com',0,'2014-01-13 02:21:21',NULL,NULL),(30331,19649,'TE','4192100885',0,'2014-01-23 21:00:19',NULL,NULL),(36186,23817,'AP','4199343257',0,'2014-02-14 21:31:38',NULL,NULL),(38208,25219,'AP','6018327385',0,'2014-02-21 22:00:55',NULL,NULL),(39654,26221,'TE','7133012530',0,'2014-02-28 06:30:57',NULL,NULL),(602,371,'EM','dacaran@gmail.com',0,'2013-12-25 17:45:27',NULL,NULL),(1181,723,'EM','wilkersonjana@yahoo.com',0,'2013-12-25 18:03:33',NULL,NULL),(25256,16285,'AP','8598932180',0,'2014-01-07 04:00:40',NULL,NULL),(24919,16063,'TE','7403726741',0,'2014-01-04 02:03:35',NULL,NULL),(23572,15218,'EM','theresaremble@gmail.com',0,'2014-01-01 12:07:56',NULL,NULL),(5473,3503,'AP','9373608898',0,'2013-12-25 21:20:47',NULL,NULL),(4820,3086,'AP','5136009701',0,'2013-12-25 20:19:52',NULL,NULL),(4210,2690,'AP','8062750302',0,'2013-12-25 19:47:30',NULL,NULL),(21857,14079,'TE','7404231724',0,'2013-12-27 02:01:04',NULL,NULL),(9861,6447,'TE','4196865464',0,'2013-12-26 00:49:36',NULL,NULL),(11827,7696,'TE','9377326121',0,'2013-12-26 03:01:09',NULL,NULL),(21316,13696,'AP','4408126711',0,'2013-12-26 13:08:33',NULL,NULL),(30942,20120,'TE','5624189008',0,'2014-01-27 21:00:46',NULL,NULL),(34163,22405,'AP','5044212716',0,'2014-02-10 21:30:22',NULL,NULL),(35678,23468,'TE','2542655449',0,'2014-02-13 22:01:46',NULL,NULL),(37685,24848,'TE','5676940879',0,'2014-02-20 04:54:54',NULL,NULL),(41177,27347,'TE','9378847005',0,'2014-03-04 21:01:03',NULL,NULL),(43694,29004,'TE','3309511349',0,'2014-03-10 21:01:21',NULL,NULL),(452,283,'TE','4192212469',0,'2013-12-25 17:30:20',NULL,NULL),(8062,5281,'TE','3309260860',0,'2013-12-25 23:05:45',NULL,NULL),(22427,14461,'AP','3302835367',0,'2013-12-28 03:32:48',NULL,NULL),(11493,7475,'EM','hattarray@yahoo.com',0,'2013-12-26 02:31:17',NULL,NULL),(943,581,'TE','4196667858',0,'2013-12-25 17:50:53',NULL,NULL),(2147,1323,'EM','helen_calderone@hotmail.com',0,'2013-12-25 18:31:49',NULL,NULL),(5239,3366,'AP','9567467149',0,'2013-12-25 21:17:07',NULL,NULL),(4429,2823,'EM','awschneider24276@cincinnatistate.edu',0,'2013-12-25 20:00:33',NULL,NULL),(1598,984,'AP','3308081032',0,'2013-12-25 18:10:25',NULL,NULL),(28681,18506,'AP','3303190742',0,'2014-01-16 08:46:32',NULL,NULL),(29914,19358,'EM','blacksmith044@hotmail.com',1,'2014-01-22 03:22:29',NULL,NULL),(34191,22425,'TE','5044819829',0,'2014-02-10 21:30:33',NULL,NULL),(35029,23001,'AP','3304136776',0,'2014-02-12 21:30:19',NULL,NULL),(36415,23983,'EM','robinnelson2@gmail.com',0,'2014-02-15 22:00:22',NULL,NULL),(38474,25426,'TE','6148707449',0,'2014-02-25 21:31:12',NULL,NULL),(39961,26457,'TE','4193304206',0,'2014-02-28 07:30:28',NULL,NULL),(42987,28590,'EM','tyrrellanthony81@yahoo.com',0,'2014-03-08 21:30:02',NULL,NULL),(20588,13244,'AP','2147323925',0,'2013-12-26 12:56:12',NULL,NULL),(26112,16815,'AP','6015064271',0,'2014-01-13 02:18:19',NULL,NULL),(20217,13024,'AP','5135184988',0,'2013-12-26 12:50:10',NULL,NULL),(9461,6192,'TE','9722355094',0,'2013-12-26 00:30:21',NULL,NULL),(2237,1373,'TE','2143847732',0,'2013-12-25 18:45:51',NULL,NULL),(8862,5807,'TE','6128072658',0,'2013-12-25 23:47:40',NULL,NULL),(13878,9052,'AP','3302092751',0,'2013-12-26 04:06:03',NULL,NULL),(10173,6647,'AP','8068313536',0,'2013-12-26 01:00:30',NULL,NULL),(9935,6502,'AP','9895280682',0,'2013-12-26 00:50:53',NULL,NULL),(4449,2835,'AP','5047017898',0,'2013-12-25 20:00:53',NULL,NULL),(9765,6386,'TE','4402775180',0,'2013-12-26 00:48:03',NULL,NULL),(27070,17410,'TE','9036510002',0,'2014-01-13 03:00:21',NULL,NULL),(27835,17934,'AP','5122229233',0,'2014-01-15 02:06:36',NULL,NULL),(28834,18614,'TE','6164436176',0,'2014-01-16 08:47:25',NULL,NULL),(29385,18991,'AP','2165380195',0,'2014-01-20 08:06:11',NULL,NULL),(34436,22591,'TE','4192501780',0,'2014-02-10 21:32:09',NULL,NULL),(34515,22642,'TE','8328596352',0,'2014-02-11 21:00:23',NULL,NULL),(35236,23140,'TE','3309617556',0,'2014-02-12 21:31:36',NULL,NULL),(36333,23929,'BN','5136144491',0,'2014-02-15 21:00:03',NULL,NULL),(37063,24405,'EM','unibilthomes.zanesville@gmail.com',0,'2014-02-18 22:00:58',NULL,NULL),(37146,24453,'TE','6014560879',0,'2014-02-18 22:01:27',NULL,NULL),(37148,24453,'EM','mcbarefieldlaw@gmail.com',0,'2014-02-18 22:01:28',NULL,NULL),(40511,26886,'TE','5677126230',0,'2014-03-03 01:00:01',NULL,NULL),(26846,17271,'TE','3306890421',0,'2014-01-13 02:23:22',NULL,NULL),(26540,17073,'AP','2547212334',0,'2014-01-13 02:21:18',NULL,NULL),(26134,16825,'TE','3183647823',0,'2014-01-13 02:18:25',NULL,NULL),(9565,6264,'AP','8323174853',0,'2013-12-26 00:32:20',NULL,NULL),(9441,6181,'TE','5132385859',0,'2013-12-26 00:30:04',NULL,NULL),(8875,5814,'TE','8174981967',0,'2013-12-25 23:47:51',NULL,NULL),(257,157,'AP','2104277673',0,'2013-12-25 17:19:05',NULL,NULL),(24819,16010,'EM','ginakaye33@hotmail.com',0,'2014-01-04 02:01:48',NULL,NULL),(24321,15711,'TE','4406674647',1,'2014-01-02 04:36:04',NULL,NULL),(23819,15368,'TE','9372697678',1,'2014-01-02 04:24:59',NULL,NULL),(2874,1762,'TE','5135749621',0,'2013-12-25 18:55:55',NULL,NULL),(4596,2932,'EM','kimash78@gmail.com',0,'2013-12-25 20:16:02',NULL,NULL),(3545,2221,'AP','4192832414',0,'2013-12-25 19:20:32',NULL,NULL),(3483,2181,'AP','4193031148',0,'2013-12-25 19:19:25',NULL,NULL),(23370,15055,'TE','3185353582',0,'2014-01-01 12:03:22',NULL,NULL),(2891,1772,'TE','3306873549',0,'2013-12-25 18:56:08',NULL,NULL),(9851,6441,'AP','2252262120',0,'2013-12-26 00:49:27',NULL,NULL),(21854,14076,'TE','2346788631',0,'2013-12-27 02:01:01',NULL,NULL),(12298,8044,'TE','3306782211',0,'2013-12-26 03:09:29',NULL,NULL),(27535,17743,'EM','dhorneck1@gmail.com',0,'2014-01-14 01:33:24',NULL,NULL),(30590,19850,'TE','4194637579',0,'2014-01-24 21:00:30',NULL,NULL),(30704,19947,'EM','jlvasey@neo.rr.com',0,'2014-01-24 21:01:19',NULL,NULL),(30800,20028,'TE','5048586558',0,'2014-01-26 19:00:18',NULL,NULL),(35097,23054,'TE','3379817936',0,'2014-02-12 21:30:48',NULL,NULL),(36567,24070,'EM','gjrehs@yahoo.com',0,'2014-02-15 22:01:16',NULL,NULL),(37526,24713,'TE','6143269323',0,'2014-02-20 04:36:15',NULL,NULL),(42224,28050,'TE','6018317325',0,'2014-03-06 21:01:37',NULL,NULL),(43506,28887,'AP','2145331904',0,'2014-03-10 21:00:13',NULL,NULL),(29,18,'EM','alicedusseau@yahoo.com',0,'2013-12-25 17:15:28',NULL,NULL),(26528,17066,'TE','2143742122',0,'2014-01-13 02:21:14',NULL,NULL),(22581,14564,'TE','2163712592',0,'2013-12-28 03:35:20',NULL,NULL),(4005,2546,'TE','3308257414',0,'2013-12-25 19:37:10',NULL,NULL),(14370,9397,'EM','hector531@yahoo.com',0,'2013-12-26 04:32:29',NULL,NULL),(13753,8964,'AP','8039799793',0,'2013-12-26 04:03:55',NULL,NULL),(13533,8825,'TE','2816479377',0,'2013-12-26 04:00:23',NULL,NULL),(4742,3036,'EM','marthamae@neo.rr.com',0,'2013-12-25 20:18:33',NULL,NULL),(10884,7069,'EM','blairjmfamily@gmail.com',0,'2013-12-26 01:50:05',NULL,NULL),(24116,15568,'TE','3304945036',1,'2014-01-02 04:31:49',NULL,NULL),(25472,16425,'AP','9375272725',0,'2014-01-07 04:04:37',NULL,NULL),(31562,20573,'TE','5132330229',0,'2014-01-29 21:01:54',NULL,NULL),(32128,20983,'TE','3378424128',0,'2014-02-01 19:00:21',NULL,NULL),(36907,24305,'TE','3306067567',0,'2014-02-18 21:30:22',NULL,NULL),(41302,27439,'EM','rcourtney2@hotmail.com',0,'2014-03-04 21:01:52',NULL,NULL),(41318,27450,'TE','3305354362',0,'2014-03-04 21:01:58',NULL,NULL),(1005,619,'TE','9374409580',0,'2013-12-25 18:00:47',NULL,NULL),(21275,13670,'TE','9012701125',0,'2013-12-26 13:07:53',NULL,NULL),(7347,4774,'EM','scorpioredd1@gmail.com',0,'2013-12-25 22:15:56',NULL,NULL),(20832,13391,'TE','5132922861',0,'2013-12-26 13:00:09',NULL,NULL),(14728,9635,'TE','8307735913',0,'2013-12-26 04:38:20',NULL,NULL),(2896,1774,'TE','4404531866',0,'2013-12-25 18:56:12',NULL,NULL),(4247,2718,'TE','3379128949',0,'2013-12-25 19:48:07',NULL,NULL),(4409,2808,'AP','6014545564',0,'2013-12-25 20:00:09',NULL,NULL),(22922,14789,'EM','sallym1958@yahoo.com',1,'2013-12-29 11:13:28',NULL,NULL),(24478,15795,'EM','martharyan59@aol.com',0,'2014-01-03 02:02:40',NULL,NULL),(24541,15829,'TE','3308586636',0,'2014-01-03 02:03:47',NULL,NULL),(27675,17839,'TE','6144029139',0,'2014-01-15 02:06:03',NULL,NULL),(31150,20288,'TE','3184048596',0,'2014-01-28 21:00:34',NULL,NULL),(31354,20434,'TE','6147957274',0,'2014-01-29 21:00:37',NULL,NULL),(32861,21505,'EM','LLb26@zips.uakron.edu',0,'2014-02-04 21:01:54',NULL,NULL),(33185,21732,'EM','flyingmchris@yahoo.com',0,'2014-02-06 21:00:10',NULL,NULL),(39542,26160,'TE','2163382802',0,'2014-02-28 06:30:32',NULL,NULL),(43059,28627,'AP','9563716639',0,'2014-03-08 21:30:25',NULL,NULL),(9969,6523,'AP','4199020774',0,'2013-12-26 00:51:28',NULL,NULL),(21723,13994,'TE','4199535165',0,'2013-12-26 13:15:54',NULL,NULL),(6882,4468,'TE','4196843000',0,'2013-12-25 22:02:47',NULL,NULL),(13966,9102,'TE','4402255137',0,'2013-12-26 04:07:26',NULL,NULL),(11607,7549,'TE','2254546457',0,'2013-12-26 02:33:10',NULL,NULL),(6017,3863,'TE','3183972664',0,'2013-12-25 21:36:00',NULL,NULL),(25063,16156,'EM','john.gatiss@gmail.com',0,'2014-01-04 06:00:05',NULL,NULL),(25200,16249,'TE','9374073479',0,'2014-01-05 00:02:35',NULL,NULL),(25885,16687,'BN','2129458094',0,'2014-01-08 18:24:33',NULL,NULL),(28014,18056,'AP','4192153682',0,'2014-01-15 02:07:19',NULL,NULL),(28835,18615,'TE','9376315462',0,'2014-01-16 08:47:25',NULL,NULL),(29829,19298,'TE','5044182143',1,'2014-01-22 03:21:59',NULL,NULL),(30334,19654,'TE','9375265005',0,'2014-01-23 21:00:20',NULL,NULL),(32594,21313,'AP','3185501128',0,'2014-02-04 21:00:18',NULL,NULL),(35064,23025,'EM','lps.plastering@gmail.com',0,'2014-02-12 21:30:32',NULL,NULL),(35334,23217,'AP','6013987545',0,'2014-02-12 21:32:17',NULL,NULL),(35505,23348,'TE','6146686880',0,'2014-02-13 22:00:40',NULL,NULL),(38979,25776,'TE','2252468179',0,'2014-02-26 09:30:58',NULL,NULL),(39218,25935,'AP','8324809351',0,'2014-02-26 21:01:28',NULL,NULL),(39765,26296,'AP','4196303913',0,'2014-02-28 06:31:26',NULL,NULL),(40366,26792,'EM','monamour61567@msn.com',0,'2014-03-01 21:00:19',NULL,NULL),(42001,27914,'TE','7137252409',0,'2014-03-06 21:00:17',NULL,NULL),(42311,28094,'AP','6012384469',0,'2014-03-06 21:02:06',NULL,NULL),(1301,792,'TE','9366727777',0,'2013-12-25 18:05:21',NULL,NULL),(3428,2151,'AP','2253121523',0,'2013-12-25 19:18:35',NULL,NULL),(21883,14100,'AP','7407077558',0,'2013-12-27 02:01:33',NULL,NULL),(21613,13910,'EM','bmsengines@hughes.net',0,'2013-12-26 13:13:56',NULL,NULL),(5978,3841,'TE','3184171196',0,'2013-12-25 21:35:23',NULL,NULL),(8581,5640,'AP','9728043459',0,'2013-12-25 23:31:13',NULL,NULL),(23697,15297,'TE','2252005058',1,'2014-01-02 04:22:42',NULL,NULL),(27207,17519,'EM','rwmitchelljr@att.net',0,'2014-01-13 03:01:35',NULL,NULL),(28529,18389,'TE','3307335443',0,'2014-01-16 08:45:39',NULL,NULL),(29956,19385,'AP','2163762669',1,'2014-01-22 03:22:44',NULL,NULL),(30333,19649,'EM','mbowman@anchorpreservations.com',0,'2014-01-23 21:00:19',NULL,NULL),(31012,20174,'AP','4403192078',0,'2014-01-27 21:01:16',NULL,NULL),(32221,21044,'TE','9362399052',0,'2014-02-01 19:00:52',NULL,NULL),(34363,22539,'AP','2254859649',0,'2014-02-10 21:31:38',NULL,NULL),(38383,25357,'AP','2163258171',0,'2014-02-25 21:30:34',NULL,NULL),(43904,29128,'TE','2168627139',0,'2014-03-10 21:02:35',NULL,NULL),(8843,5792,'EM','nlange@neo.rr.com',0,'2013-12-25 23:47:18',NULL,NULL),(21549,13856,'AP','5137200602',0,'2013-12-26 13:12:41',NULL,NULL),(14203,9294,'TE','5134057986',0,'2013-12-26 04:16:11',NULL,NULL),(2350,1429,'TE','3184399141',0,'2013-12-25 18:47:30',NULL,NULL),(6907,4498,'TE','9362389640',0,'2013-12-25 22:03:18',NULL,NULL),(2517,1542,'AP','4402418452',0,'2013-12-25 18:50:20',NULL,NULL),(23341,15037,'TE','5415201465',0,'2014-01-01 12:02:50',NULL,NULL),(25189,16241,'TE','5135748042',0,'2014-01-05 00:02:24',NULL,NULL),(27053,17397,'EM','torreytyler23@yahoo.com',0,'2014-01-13 03:00:14',NULL,NULL),(27172,17495,'AP','5049149170',0,'2014-01-13 03:01:22',NULL,NULL),(32315,21111,'TE','4023489351',0,'2014-02-03 21:00:07',NULL,NULL),(33365,21863,'TE','4199343263',0,'2014-02-06 21:01:21',NULL,NULL),(36790,24222,'EM','NBkidman1@gmail.com',0,'2014-02-16 19:00:29',NULL,NULL),(39419,26068,'TE','5137168252',0,'2014-02-26 21:02:42',NULL,NULL),(40059,26561,'TE','5132626927',0,'2014-02-28 21:30:19',NULL,NULL),(40311,26742,'AP','5132536725',0,'2014-02-28 21:31:56',NULL,NULL),(40329,26765,'AP','4407319052',0,'2014-03-01 19:00:10',NULL,NULL),(41446,27533,'AP','6149610532',0,'2014-03-04 21:02:48',NULL,NULL),(43929,29142,'AP','4196997558',0,'2014-03-10 21:02:43',NULL,NULL),(73,46,'TE','6013170148',0,'2013-12-25 17:16:14',NULL,NULL),(8017,5237,'TE','3302963901',0,'2013-12-25 23:04:51',NULL,NULL),(976,600,'AP','6146782390',0,'2013-12-25 18:00:18',NULL,NULL),(12435,8147,'TE','4699648288',0,'2013-12-26 03:15:55',NULL,NULL),(7602,4948,'TE','5136489292',0,'2013-12-25 22:45:52',NULL,NULL),(2427,1485,'TE','3308893371',0,'2013-12-25 18:48:54',NULL,NULL),(3169,1985,'AP','8176816774',0,'2013-12-25 19:01:49',NULL,NULL),(5606,3588,'AP','2162724528',0,'2013-12-25 21:22:56',NULL,NULL),(4125,2630,'EM','grollins4@gmail.com',0,'2013-12-25 19:46:06',NULL,NULL),(28199,18173,'EM','Mike.peiples@gmail.com',0,'2014-01-15 02:07:58',NULL,NULL),(29337,18956,'AP','9032293737',0,'2014-01-20 08:05:52',NULL,NULL),(32689,21381,'EM','crysford865@gmail.com',0,'2014-02-04 21:00:53',NULL,NULL),(33596,22026,'TE','9375443607',0,'2014-02-07 19:01:00',NULL,NULL),(36819,24246,'EM','howardkat@msn.com',0,'2014-02-16 19:00:41',NULL,NULL),(42253,28065,'TE','4404172912',0,'2014-03-06 21:01:46',NULL,NULL),(696,431,'EM','farmall400@live.com',0,'2013-12-25 17:46:56',NULL,NULL),(22616,14584,'EM','bellagentesaloneofbr@gmail.com',0,'2013-12-28 03:35:56',NULL,NULL),(21167,13616,'TE','5132053384',0,'2013-12-26 13:05:44',NULL,NULL),(14314,9359,'EM','Laci_hayes88@yahoo.com',0,'2013-12-26 04:31:30',NULL,NULL),(13693,8928,'TE','9372415193',0,'2013-12-26 04:02:57',NULL,NULL),(12162,7945,'AP','3184044719',0,'2013-12-26 03:07:00',NULL,NULL),(11027,7158,'AP','4194870366',0,'2013-12-26 01:52:23',NULL,NULL),(941,580,'AP','4193675488',0,'2013-12-25 17:50:51',NULL,NULL),(3932,2494,'TE','3132128149',0,'2013-12-25 19:35:53',NULL,NULL),(3563,2230,'TE','5132480704',0,'2013-12-25 19:20:47',NULL,NULL),(3420,2147,'EM','mikeharvey49@hotmail.com',0,'2013-12-25 19:18:28',NULL,NULL),(10175,6648,'AP','5133102064',0,'2013-12-26 01:00:32',NULL,NULL),(6138,3950,'AP','4193413302',0,'2013-12-25 21:38:09',NULL,NULL),(7007,4578,'TE','7136652205',0,'2013-12-25 22:05:07',NULL,NULL),(1703,1046,'AP','2145373451',0,'2013-12-25 18:15:55',NULL,NULL),(27806,17920,'AP','5125072976',0,'2014-01-15 02:06:31',NULL,NULL),(29127,18812,'TE','7407725001',0,'2014-01-17 03:36:03',NULL,NULL),(30799,20026,'TE','9856521181',0,'2014-01-26 19:00:17',NULL,NULL),(31711,20695,'AP','3303548593',0,'2014-01-30 21:01:00',NULL,NULL),(36221,23841,'TE','5132272498',0,'2014-02-14 21:31:52',NULL,NULL),(37259,24518,'TE','9152528696',0,'2014-02-20 03:56:03',NULL,NULL),(37444,24653,'TE','4196809902',0,'2014-02-20 04:23:48',NULL,NULL),(39881,26385,'AP','4404767132',0,'2014-02-28 07:00:23',NULL,NULL),(41195,27360,'TE','3306860020',0,'2014-03-04 21:01:10',NULL,NULL),(41773,27774,'EM','ktuma@dsbweb.com',0,'2014-03-05 21:31:29',NULL,NULL),(6427,4153,'AP','6142086059',0,'2013-12-25 21:48:49',NULL,NULL),(5689,3654,'AP','4408123871',0,'2013-12-25 21:30:43',NULL,NULL),(11269,7347,'AP','3309845223',0,'2013-12-26 02:04:08',NULL,NULL),(20938,13466,'AP','3309837687',0,'2013-12-26 13:01:54',NULL,NULL),(14039,9172,'TE','9376959976',0,'2013-12-26 04:08:58',NULL,NULL),(14499,9472,'TE','5135821377',0,'2013-12-26 04:34:28',NULL,NULL),(14319,9362,'EM','benjamin.rongey@gmail.com',0,'2013-12-26 04:31:35',NULL,NULL),(24266,15682,'EM','skleibold@weanerlawoffice.com',1,'2014-01-02 04:35:02',NULL,NULL),(26959,17338,'TE','3376923233',0,'2014-01-13 02:24:01',NULL,NULL),(27718,17866,'AP','4409849757',0,'2014-01-15 02:06:12',NULL,NULL),(35125,23070,'TE','3185793117',0,'2014-02-12 21:30:56',NULL,NULL),(36350,23940,'AP','5133063730',0,'2014-02-15 21:00:08',NULL,NULL),(37073,24410,'AP','5132950737',0,'2014-02-18 22:01:01',NULL,NULL),(37890,24995,'TE','4326345687',0,'2014-02-20 22:00:43',NULL,NULL),(42318,28102,'TE','4405910380',0,'2014-03-06 21:02:11',NULL,NULL),(42793,28459,'EM','abatjourllcbr@att.net',0,'2014-03-07 21:31:25',NULL,NULL),(43690,29001,'AP','3307039895',0,'2014-03-10 21:01:19',NULL,NULL),(9052,5937,'TE','3183253567',0,'2013-12-25 23:50:42',NULL,NULL),(21363,13737,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:34',NULL,NULL),(20468,13186,'TE','8323607000',0,'2013-12-26 12:54:28',NULL,NULL),(13950,9097,'TE','5135329852',0,'2013-12-26 04:07:16',NULL,NULL),(1163,712,'EM','waltperkins@yahoo.com',0,'2013-12-25 18:03:15',NULL,NULL),(12186,7962,'AP','6012918101',0,'2013-12-26 03:07:28',NULL,NULL),(26884,17296,'EM','jenniferdobbels@yahoo.com',0,'2014-01-13 02:23:36',NULL,NULL),(27782,17910,'AP','9563697515',0,'2014-01-15 02:06:26',NULL,NULL),(32735,21414,'TE','4192934050',0,'2014-02-04 21:01:10',NULL,NULL),(36578,24076,'TE','3308078321',0,'2014-02-15 22:01:20',NULL,NULL),(38845,25678,'EM','lucasjgroh@gmail.com',0,'2014-02-26 08:30:57',NULL,NULL),(42668,28385,'TE','3307018932',0,'2014-03-07 21:30:42',NULL,NULL),(57,37,'EM','farmall400@live.com',0,'2013-12-25 17:15:58',NULL,NULL),(8548,5617,'AP','7407042348',0,'2013-12-25 23:30:40',NULL,NULL),(14543,9502,'TE','2164061895',0,'2013-12-26 04:35:12',NULL,NULL),(14312,9359,'TE','3375324158',0,'2013-12-26 04:31:29',NULL,NULL),(3253,2048,'TE','9156919872',0,'2013-12-25 19:15:46',NULL,NULL),(7033,4593,'EM','bmitchell906@yahoo.com',0,'2013-12-25 22:05:31',NULL,NULL),(6946,4527,'TE','2812906668',0,'2013-12-25 22:03:58',NULL,NULL),(4799,3068,'AP','9856348504',0,'2013-12-25 20:19:25',NULL,NULL),(6024,3868,'TE','3183555318',0,'2013-12-25 21:36:07',NULL,NULL),(7200,4691,'TE','9375649179',0,'2013-12-25 22:08:11',NULL,NULL),(30274,19614,'AP','3303961497',0,'2014-01-23 03:02:52',NULL,NULL),(34838,22846,'TE','4195862779',0,'2014-02-11 21:02:18',NULL,NULL),(36230,23844,'EM','brown9676@gmail.com',0,'2014-02-14 21:31:54',NULL,NULL),(37979,25056,'TE','5132134978',0,'2014-02-20 22:01:20',NULL,NULL),(42728,28420,'TE','2169387458',0,'2014-03-07 21:31:02',NULL,NULL),(43164,28686,'TE','4407795069',0,'2014-03-08 21:31:00',NULL,NULL),(2034,1259,'TE','9372164595',0,'2013-12-25 18:21:29',NULL,NULL),(2092,1291,'AP','3307805914',0,'2013-12-25 18:30:53',NULL,NULL),(20711,13311,'AP','8176148601',0,'2013-12-26 12:58:07',NULL,NULL),(2308,1411,'TE','2258928798',0,'2013-12-25 18:46:56',NULL,NULL),(14746,9644,'EM','MARC.BRUBAKER@GMAIL.COM',0,'2013-12-26 04:38:35',NULL,NULL),(9163,5999,'AP','3103101996',0,'2013-12-26 00:00:19',NULL,NULL),(10657,6927,'EM','jmshalbert@yahoo.com',0,'2013-12-26 01:46:25',NULL,NULL),(11314,7373,'TE','5132829856',0,'2013-12-26 02:15:43',NULL,NULL),(24158,15611,'AP','5672793881',1,'2014-01-02 04:32:50',NULL,NULL),(25394,16377,'AP','4322902570',0,'2014-01-07 04:03:13',NULL,NULL),(25794,16622,'TE','9548018213',0,'2014-01-08 18:24:11',NULL,NULL),(28512,18379,'TE','6812036216',0,'2014-01-16 08:45:34',NULL,NULL),(29204,18866,'AP','2259363032',0,'2014-01-17 03:36:22',NULL,NULL),(30477,19761,'EM','mitchellcadams@msn.com',0,'2014-01-23 21:01:24',NULL,NULL),(32630,21335,'AP','8322081041',0,'2014-02-04 21:00:30',NULL,NULL),(37115,24436,'TE','3305540644',0,'2014-02-18 22:01:16',NULL,NULL),(40296,26729,'EM','princessshellyl@aol.com',0,'2014-02-28 21:31:49',NULL,NULL),(40618,26963,'TE','3302171113',0,'2014-03-03 01:00:31',NULL,NULL),(41717,27739,'AP','9568671608',0,'2014-03-05 21:31:09',NULL,NULL),(41790,27783,'TE','6622468279',0,'2014-03-05 21:31:35',NULL,NULL),(340,212,'EM','sbmarie2002@yahoo.com',0,'2013-12-25 17:20:30',NULL,NULL),(24280,15690,'EM','CYNDY_PEPPEL_1999@YAHOO.COM',1,'2014-01-02 04:35:20',NULL,NULL),(2414,1472,'TE','9375299774',0,'2013-12-25 18:48:36',NULL,NULL),(10519,6852,'TE','6143723959',0,'2013-12-26 01:31:25',NULL,NULL),(3817,2429,'AP','7404074919',0,'2013-12-25 19:34:07',NULL,NULL),(2114,1305,'TE','9039161157',0,'2013-12-25 18:31:18',NULL,NULL),(11036,7162,'TE','4197225891',0,'2013-12-26 01:52:31',NULL,NULL),(5685,3651,'EM','susie522@hotmail.com',0,'2013-12-25 21:30:39',NULL,NULL),(14719,9629,'TE','3308483597',0,'2013-12-26 04:38:09',NULL,NULL),(20925,13454,'EM','amyjoarps@gmail.com',0,'2013-12-26 13:01:36',NULL,NULL),(23197,14950,'TE','9725303667',0,'2014-01-01 12:00:09',NULL,NULL),(23272,14993,'AP','9037243409',0,'2014-01-01 12:01:30',NULL,NULL),(26788,17233,'AP','6627191519',0,'2014-01-13 02:22:41',NULL,NULL),(28145,18143,'TE','3187922361',0,'2014-01-15 02:07:47',NULL,NULL),(29562,19103,'TE','2259361565',0,'2014-01-21 08:44:40',NULL,NULL),(30801,20028,'AP','5048586558',0,'2014-01-26 19:00:18',NULL,NULL),(31157,20291,'AP','5047106792',0,'2014-01-28 21:00:36',NULL,NULL),(31960,20868,'BN','6018327849',0,'2014-01-31 21:01:00',NULL,NULL),(37795,24944,'TE','6019412856',0,'2014-02-20 22:00:06',NULL,NULL),(39292,25995,'EM','bre_jeremy@yahoo.com',0,'2014-02-26 21:02:00',NULL,NULL),(41752,27764,'TE','6155138955',0,'2014-03-05 21:31:22',NULL,NULL),(5987,3847,'TE','2259104902',0,'2013-12-25 21:35:32',NULL,NULL),(10201,6664,'AP','2547158096',0,'2013-12-26 01:00:58',NULL,NULL),(7856,5126,'AP','2108600102',0,'2013-12-25 23:02:06',NULL,NULL),(7003,4571,'EM','hap4ever21@yahoo.com',0,'2013-12-25 22:05:00',NULL,NULL),(23709,15302,'AP','9855023962',1,'2014-01-02 04:22:52',NULL,NULL),(23800,15352,'TE','3309071705',1,'2014-01-02 04:24:35',NULL,NULL),(21033,13533,'TE','3184619668',0,'2013-12-26 13:03:32',NULL,NULL),(20291,13079,'AP','7404443291',0,'2013-12-26 12:51:32',NULL,NULL),(25770,16607,'TE','2256782192',0,'2014-01-08 18:24:06',NULL,NULL),(33300,21807,'AP','3306717952',0,'2014-02-06 21:00:52',NULL,NULL),(33527,21979,'AP','3182670729',0,'2014-02-07 19:00:35',NULL,NULL),(35037,23012,'TE','3375806816',0,'2014-02-12 21:30:24',NULL,NULL),(38996,25786,'AP','3307017504',0,'2014-02-26 09:31:06',NULL,NULL),(40872,27158,'AP','5135157746',0,'2014-03-03 21:30:57',NULL,NULL),(41422,27518,'BN','4197046493',0,'2014-03-04 21:02:38',NULL,NULL),(315,193,'EM','debbev@frontier.com',0,'2013-12-25 17:20:02',NULL,NULL),(23673,15284,'AP','6019189868',1,'2014-01-02 04:22:16',NULL,NULL),(22558,14549,'AP','6015720032',0,'2013-12-28 03:34:58',NULL,NULL),(22476,14493,'AP','9035044530',0,'2013-12-28 03:33:35',NULL,NULL),(21734,14002,'AP','9375586453',0,'2013-12-26 13:16:06',NULL,NULL),(5240,3367,'TE','7132561368',0,'2013-12-25 21:17:08',NULL,NULL),(11867,7725,'AP','6145316050',0,'2013-12-26 03:01:51',NULL,NULL),(11207,7286,'AP','3303485877',0,'2013-12-26 02:02:50',NULL,NULL),(1539,947,'AP','2162143135',0,'2013-12-25 18:09:28',NULL,NULL),(4889,3135,'TE','2253373978',0,'2013-12-25 20:30:38',NULL,NULL),(8170,5345,'AP','3306183835',0,'2013-12-25 23:07:29',NULL,NULL),(4305,2747,'AP','9375093701',0,'2013-12-25 19:48:58',NULL,NULL),(26044,16777,'BN','9374671730',0,'2014-01-08 18:25:04',NULL,NULL),(27029,17381,'AP','6143157816',0,'2014-01-13 03:00:06',NULL,NULL),(32796,21457,'TE','2168350123',0,'2014-02-04 21:01:32',NULL,NULL),(35657,23450,'AP','8324656448',0,'2014-02-13 22:01:37',NULL,NULL),(36039,23704,'AP','9373694568',0,'2014-02-14 21:30:44',NULL,NULL),(37277,24532,'TE','9854454155',0,'2014-02-20 04:00:35',NULL,NULL),(38369,25343,'AP','2163258171',0,'2014-02-25 21:30:27',NULL,NULL),(39660,26225,'TE','5125797320',0,'2014-02-28 06:30:59',NULL,NULL),(40320,26756,'TE','4093515357',0,'2014-03-01 19:00:05',NULL,NULL),(41249,27404,'BN','2167856615',0,'2014-03-04 21:01:33',NULL,NULL),(41472,27561,'EM','Lmspencer29@earthlink.net',0,'2014-03-04 21:30:17',NULL,NULL),(41862,27838,'TE','5672302208',0,'2014-03-05 21:32:05',NULL,NULL),(7445,4850,'AP','3307609385',0,'2013-12-25 22:30:20',NULL,NULL),(23182,14940,'AP','4195144603',0,'2013-12-30 00:02:18',NULL,NULL),(31627,20630,'AP','4329408862',0,'2014-01-30 21:00:28',NULL,NULL),(31923,20840,'TE','3303484075',0,'2014-01-31 21:00:45',NULL,NULL),(33012,21630,'TE','9039491971',0,'2014-02-05 21:30:40',NULL,NULL),(41659,27693,'EM','jess_estrada26@hotmail.com',0,'2014-03-05 21:30:45',NULL,NULL),(41710,27735,'BN','9152471187',0,'2014-03-05 21:31:06',NULL,NULL),(42380,28146,'TE','4194741059',0,'2014-03-06 21:02:34',NULL,NULL),(42505,28269,'TE','3253560091',0,'2014-03-07 21:00:20',NULL,NULL),(413,254,'TE','5047082650',0,'2013-12-25 17:21:39',NULL,NULL),(1678,1031,'AP','9563734107',0,'2013-12-25 18:15:31',NULL,NULL),(3628,2293,'EM','kevin11mcgovern@gmail.com',0,'2013-12-25 19:30:51',NULL,NULL),(5589,3571,'EM','teresamariegross@yahoo.com',0,'2013-12-25 21:22:35',NULL,NULL),(20845,13400,'EM','ddanner3320@outlook.com',0,'2013-12-26 13:00:20',NULL,NULL),(10984,7136,'TE','2148930152',0,'2013-12-26 01:51:47',NULL,NULL),(11586,7540,'AP','3252349692',0,'2013-12-26 02:32:52',NULL,NULL),(22695,14639,'EM','Missmichelle100@gmail.com',1,'2013-12-29 11:07:23',NULL,NULL),(23070,14879,'TE','8326921184',0,'2013-12-30 00:00:28',NULL,NULL),(28497,18362,'EM','LAYERS@SUPERIORCAREPLUS.COM',0,'2014-01-16 08:45:27',NULL,NULL),(30269,19612,'TE','3304757201',0,'2014-01-23 03:02:51',NULL,NULL),(32664,21362,'AP','9036036271',0,'2014-02-04 21:00:44',NULL,NULL),(36008,23686,'AP','4405707483',0,'2014-02-14 21:30:34',NULL,NULL),(38324,25319,'AP','2257183965',0,'2014-02-25 21:30:08',NULL,NULL),(38969,25764,'TE','3304212051',0,'2014-02-26 09:30:53',NULL,NULL),(42914,28537,'TE','8063644975',0,'2014-03-07 21:32:12',NULL,NULL),(26,17,'TE','5135091363',0,'2013-12-25 17:15:26',NULL,NULL),(23005,14837,'EM','neurocare1@yahoo.com',1,'2013-12-29 11:14:45',NULL,NULL),(1297,789,'EM','kmiles2003@yahoo.com',0,'2013-12-25 18:05:16',NULL,NULL),(8654,5686,'AP','4193484381',0,'2013-12-25 23:32:28',NULL,NULL),(2555,1561,'TE','6015363699',0,'2013-12-25 18:50:54',NULL,NULL),(2560,1563,'AP','8173687755',0,'2013-12-25 18:50:58',NULL,NULL),(7446,4850,'EM','mbh8807@gmail.com',0,'2013-12-25 22:30:21',NULL,NULL),(3373,2120,'TE','3307600310',0,'2013-12-25 19:17:42',NULL,NULL),(4712,3013,'EM','bobbyd01@att.net',0,'2013-12-25 20:18:00',NULL,NULL),(11071,7189,'EM','zoolady@gmail.com',0,'2013-12-26 02:00:23',NULL,NULL),(11205,7285,'EM','WERTKC@YAHOO.COM',0,'2013-12-26 02:02:49',NULL,NULL),(11906,7748,'TE','2346501712',0,'2013-12-26 03:02:27',NULL,NULL),(1091,671,'EM','ssnone69@yahoo.com',0,'2013-12-25 18:02:08',NULL,NULL),(20766,13343,'AP','7138822519',0,'2013-12-26 12:59:00',NULL,NULL),(21887,14101,'EM','latriciaelliott@gmail.com',0,'2013-12-27 02:01:36',NULL,NULL),(30004,19430,'TE','4196027888',1,'2014-01-22 03:23:07',NULL,NULL),(34925,22918,'TE','9378221336',0,'2014-02-11 21:02:53',NULL,NULL),(36163,23801,'EM','gcraddock@neo.rr.com',0,'2014-02-14 21:31:30',NULL,NULL),(41120,27315,'TE','9565361331',0,'2014-03-04 21:00:42',NULL,NULL),(43026,28608,'EM','scothafler@gmail.com',0,'2014-03-08 21:30:14',NULL,NULL),(43165,28686,'AP','2165433972',0,'2014-03-08 21:31:00',NULL,NULL),(262,161,'TE','2814434507',0,'2013-12-25 17:19:11',NULL,NULL),(26036,16775,'TE','6019064019',0,'2014-01-08 18:25:03',NULL,NULL),(22886,14768,'TE','4097828597',1,'2013-12-29 11:12:51',NULL,NULL),(2569,1568,'AP','5612942092',0,'2013-12-25 18:51:07',NULL,NULL),(7440,4847,'TE','5135502174',0,'2013-12-25 22:30:16',NULL,NULL),(2477,1519,'AP','4403910090',0,'2013-12-25 18:49:45',NULL,NULL),(10328,6735,'AP','5137874168',0,'2013-12-26 01:15:36',NULL,NULL),(747,469,'EM','gzink117@gmail.com',0,'2013-12-25 17:47:49',NULL,NULL),(11015,7150,'AP','7402973356',0,'2013-12-26 01:52:10',NULL,NULL),(12125,7924,'TE','3374012228',0,'2013-12-26 03:06:25',NULL,NULL),(12294,8041,'AP','2168543579',0,'2013-12-26 03:09:25',NULL,NULL),(14069,9198,'AP','4199086527',0,'2013-12-26 04:09:34',NULL,NULL),(580,359,'AP','9372321567',0,'2013-12-25 17:45:06',NULL,NULL),(21350,13719,'AP','2158739333',0,'2013-12-26 13:09:10',NULL,NULL),(21898,14109,'TE','9376682294',0,'2013-12-27 02:01:47',NULL,NULL),(26135,16825,'AP','3183647823',0,'2014-01-13 02:18:25',NULL,NULL),(26217,16874,'AP','9037206887',0,'2014-01-13 02:19:18',NULL,NULL),(26465,17034,'EM','jhawkins@nbalawfirm.com',0,'2014-01-13 02:20:47',NULL,NULL),(26682,17163,'EM','wcooper8124@gmail.com',0,'2014-01-13 02:22:03',NULL,NULL),(28505,18374,'TE','4195655953',0,'2014-01-16 08:45:31',NULL,NULL),(29471,19052,'TE','5137064691',0,'2014-01-20 08:06:45',NULL,NULL),(29479,19055,'TE','6629027186',0,'2014-01-21 08:44:11',NULL,NULL),(31940,20849,'EM','dreamsofsolace314@gmail.com',0,'2014-01-31 21:00:51',NULL,NULL),(34922,22915,'TE','4193853029',0,'2014-02-11 21:02:51',NULL,NULL),(38559,25481,'AP','9374743456',0,'2014-02-25 21:31:43',NULL,NULL),(38615,25522,'TE','5135444519',0,'2014-02-25 21:32:07',NULL,NULL),(10340,6742,'TE','4404653423',0,'2013-12-26 01:15:48',NULL,NULL),(13656,8904,'EM','brendachaffinphillips@gmail.com',0,'2013-12-26 04:02:22',NULL,NULL),(4036,2577,'AP','4192300466',0,'2013-12-25 19:37:52',NULL,NULL),(1526,939,'TE','5134007013',0,'2013-12-25 18:09:17',NULL,NULL),(14349,9380,'TE','2255676731',0,'2013-12-26 04:32:04',NULL,NULL),(21339,13712,'EM','joytoyou@sbcglobal.net',0,'2013-12-26 13:08:58',NULL,NULL),(13644,8897,'TE','8306726062',0,'2013-12-26 04:02:11',NULL,NULL),(12413,8131,'AP','6145991605',0,'2013-12-26 03:15:31',NULL,NULL),(11566,7525,'AP','4407850158',0,'2013-12-26 02:32:32',NULL,NULL),(3215,2019,'TE','3308963967',0,'2013-12-25 19:15:06',NULL,NULL),(23732,15311,'EM','rdbagwell@hotmail.com',1,'2014-01-02 04:23:14',NULL,NULL),(24845,16025,'EM','twilighttp@att.net',0,'2014-01-04 02:02:17',NULL,NULL),(24934,16072,'TE','5139335210',0,'2014-01-04 02:03:51',NULL,NULL),(26416,16999,'AP','5132035995',0,'2014-01-13 02:20:30',NULL,NULL),(30409,19707,'TE','5127361402',0,'2014-01-23 21:00:51',NULL,NULL),(31610,20619,'TE','9858765099',0,'2014-01-30 21:00:23',NULL,NULL),(31667,20661,'TE','9035061841',0,'2014-01-30 21:00:44',NULL,NULL),(35662,23455,'TE','9366395527',0,'2014-02-13 22:01:40',NULL,NULL),(35673,23462,'AP','9035676903',0,'2014-02-13 22:01:44',NULL,NULL),(40278,26717,'EM','hazelkelly56@gmail.com',0,'2014-02-28 21:31:42',NULL,NULL),(41809,27794,'EM','lisacrf@yahoo.com',0,'2014-03-05 21:31:42',NULL,NULL),(42115,27979,'AP','2259397107',0,'2014-03-06 21:00:56',NULL,NULL),(43712,29018,'AP','3308084803',0,'2014-03-10 21:01:28',NULL,NULL),(38004,25070,'EM','annettekeltner633@yahoo.com',0,'2014-02-20 22:01:30',NULL,NULL),(1275,774,'EM','rmaestas@mac.com',0,'2013-12-25 18:04:55',NULL,NULL),(22318,14387,'EM','stephenmckean@yahoo.com',0,'2013-12-28 03:30:55',NULL,NULL),(21765,14020,'TE','9372669259',0,'2013-12-26 13:16:37',NULL,NULL),(10331,6737,'TE','9376545547',0,'2013-12-26 01:15:40',NULL,NULL),(3555,2226,'AP','4196184740',0,'2013-12-25 19:20:40',NULL,NULL),(4038,2579,'TE','9373088095',0,'2013-12-25 19:37:56',NULL,NULL),(23630,15257,'TE','9377672856',0,'2014-01-01 12:09:09',NULL,NULL),(24046,15526,'EM','lindadedon@att.net',1,'2014-01-02 04:30:29',NULL,NULL),(24977,16096,'TE','4193899456',0,'2014-01-04 02:04:38',NULL,NULL),(27564,17764,'EM','babymypitbull@yahoo.com',0,'2014-01-14 01:33:35',NULL,NULL),(27838,17935,'AP','5122229233',0,'2014-01-15 02:06:37',NULL,NULL),(29858,19317,'TE','9567171078',1,'2014-01-22 03:22:09',NULL,NULL),(34910,22907,'TE','5674549642',0,'2014-02-11 21:02:46',NULL,NULL),(35651,23442,'EM','sgreenfield71@gmail.com',0,'2014-02-13 22:01:34',NULL,NULL),(39969,26462,'AP','9858708726',0,'2014-02-28 07:30:32',NULL,NULL),(2610,1590,'AP','8323314855',0,'2013-12-25 18:51:43',NULL,NULL),(22363,14422,'EM','benayers0728@hotmail.com',0,'2013-12-28 03:31:44',NULL,NULL),(22256,14342,'TE','4195369635',0,'2013-12-27 02:07:56',NULL,NULL),(21692,13967,'AP','9374676103',0,'2013-12-26 13:15:17',NULL,NULL),(2917,1788,'AP','6144969390',0,'2013-12-25 18:56:31',NULL,NULL),(11623,7559,'AP','4194611776',0,'2013-12-26 02:33:27',NULL,NULL),(12115,7919,'TE','3188726424',0,'2013-12-26 03:06:17',NULL,NULL),(3537,2213,'TE','3308481859',0,'2013-12-25 19:20:21',NULL,NULL),(33601,22029,'EM','simmonskathy20@yahoo.com',0,'2014-02-07 19:01:03',NULL,NULL),(34790,22817,'AP','9374082656',0,'2014-02-11 21:02:01',NULL,NULL),(35972,23669,'AP','4303422560',0,'2014-02-14 21:30:23',NULL,NULL),(42271,28073,'AP','2163766163',0,'2014-03-06 21:01:52',NULL,NULL),(42913,28536,'AP','9376208152',0,'2014-03-07 21:32:12',NULL,NULL),(43627,28960,'TE','7187530601',0,'2014-03-10 21:00:56',NULL,NULL),(314,193,'AP','4197690547',0,'2013-12-25 17:20:02',NULL,NULL),(22057,14205,'TE','2143508060',0,'2013-12-27 02:04:22',NULL,NULL),(4338,2768,'EM','jtoth10570@msn.com',0,'2013-12-25 19:49:30',NULL,NULL),(11256,7330,'EM','raaronmaus@yahoo.com',0,'2013-12-26 02:03:49',NULL,NULL),(11153,7252,'TE','9852120480',0,'2013-12-26 02:01:58',NULL,NULL),(3553,2225,'AP','4192832409',0,'2013-12-25 19:20:38',NULL,NULL),(10467,6819,'EM','grannybooboots@yahoo.com',0,'2013-12-26 01:30:30',NULL,NULL),(10204,6669,'TE','4322227306',0,'2013-12-26 01:01:03',NULL,NULL),(9508,6224,'AP','4197730331',0,'2013-12-26 00:31:15',NULL,NULL),(3489,2183,'AP','3612581557',0,'2013-12-25 19:19:29',NULL,NULL),(6393,4121,'AP','6145829234',0,'2013-12-25 21:48:12',NULL,NULL),(25663,16546,'EM','suejon927@aol.com',1,'2014-01-07 10:22:34',NULL,NULL),(27768,17903,'EM','wherryranch@yahoo.com',0,'2014-01-15 02:06:24',NULL,NULL),(28124,18128,'AP','5134618749',0,'2014-01-15 02:07:43',NULL,NULL),(30650,19893,'AP','5677123698',0,'2014-01-24 21:00:52',NULL,NULL),(33567,22008,'EM','mikemoroski@gmail.com',0,'2014-02-07 19:00:50',NULL,NULL),(36107,23758,'AP','5132371316',0,'2014-02-14 21:31:09',NULL,NULL),(41560,27631,'AP','9372388661',0,'2014-03-05 21:30:11',NULL,NULL),(4885,3131,'AP','3302218778',0,'2013-12-25 20:30:31',NULL,NULL),(22977,14820,'TE','8323020162',1,'2013-12-29 11:14:19',NULL,NULL),(22211,14314,'AP','4192024404',0,'2013-12-27 02:07:06',NULL,NULL),(20428,13156,'TE','9372723870',0,'2013-12-26 12:53:43',NULL,NULL),(2956,1826,'EM','hollandohiomark@yahoo.com',0,'2013-12-25 18:57:19',NULL,NULL),(3637,2300,'EM','eskelley@zoominternet.net',0,'2013-12-25 19:30:59',NULL,NULL),(4339,2771,'TE','3304259302',0,'2013-12-25 19:49:31',NULL,NULL),(11788,7668,'TE','2253412939',0,'2013-12-26 03:00:30',NULL,NULL),(11343,7388,'EM','pemanney@yahoo.com',0,'2013-12-26 02:16:06',NULL,NULL),(10433,6801,'TE','9376060344',0,'2013-12-26 01:17:24',NULL,NULL),(6842,4437,'AP','7403142472',0,'2013-12-25 22:02:04',NULL,NULL),(23662,15280,'EM','nelhern@sbcglobal.net',1,'2014-01-02 04:22:05',NULL,NULL),(27203,17517,'AP','3304416466',0,'2014-01-13 03:01:34',NULL,NULL),(27723,17870,'TE','5134701321',0,'2014-01-15 02:06:13',NULL,NULL),(28273,18231,'TE','5128220604',0,'2014-01-16 08:44:19',NULL,NULL),(29555,19100,'TE','3183540035',0,'2014-01-21 08:44:38',NULL,NULL),(32403,21173,'AP','6143150669',0,'2014-02-03 21:00:39',NULL,NULL),(34845,22849,'EM','awatkins54@gmail.com',0,'2014-02-11 21:02:19',NULL,NULL),(35856,23576,'EM','Julie@swankmartini.com',0,'2014-02-13 22:02:55',NULL,NULL),(36655,24128,'AP','5044009168',0,'2014-02-15 22:01:47',NULL,NULL),(37702,24859,'AP','3304210660',0,'2014-02-20 04:56:45',NULL,NULL),(38593,25503,'AP','9032441221',0,'2014-02-25 21:31:56',NULL,NULL),(40212,26672,'TE','9857785900',0,'2014-02-28 21:31:19',NULL,NULL),(40531,26902,'AP','9152533263',0,'2014-03-03 01:00:08',NULL,NULL),(3100,1934,'TE','2142779065',0,'2013-12-25 19:00:29',NULL,NULL),(8369,5499,'TE','4199215278',0,'2013-12-25 23:11:17',NULL,NULL),(7869,5132,'EM','sai@electriqueboutique.com',0,'2013-12-25 23:02:16',NULL,NULL),(11818,7689,'EM','griffsgarage@gmail.com',0,'2013-12-26 03:01:00',NULL,NULL),(7332,4766,'TE','2164705042',0,'2013-12-25 22:15:43',NULL,NULL),(5868,3764,'AP','2165133447',0,'2013-12-25 21:33:31',NULL,NULL),(22280,14362,'TE','6145782100',0,'2013-12-28 03:30:17',NULL,NULL),(26828,17255,'AP','3306714819',0,'2014-01-13 02:23:14',NULL,NULL),(28515,18381,'TE','4192041764',0,'2014-01-16 08:45:35',NULL,NULL),(31683,20669,'TE','2282352961',0,'2014-01-30 21:00:48',NULL,NULL),(34785,22815,'AP','9372694639',0,'2014-02-11 21:02:00',NULL,NULL),(35559,23383,'EM','zecher2112@gmail.com',0,'2014-02-13 22:01:01',NULL,NULL),(37008,24368,'AP','2252460268',0,'2014-02-18 22:00:36',NULL,NULL),(38894,25709,'AP','8173430692',0,'2014-02-26 09:30:23',NULL,NULL),(39079,25848,'TE','3308010557',0,'2014-02-26 21:00:39',NULL,NULL),(39175,25912,'EM','long.amelia@gmail.com',0,'2014-02-26 21:01:15',NULL,NULL),(40927,27196,'EM','hiennguyen2574@yahoo.com',0,'2014-03-03 21:31:19',NULL,NULL),(41709,27735,'AP','9152471187',0,'2014-03-05 21:31:06',NULL,NULL),(965,594,'AP','3305015402',0,'2013-12-25 18:00:09',NULL,NULL),(24340,15720,'TE','9376575699',0,'2014-01-03 02:00:12',NULL,NULL),(3757,2382,'AP','6148435765',0,'2013-12-25 19:33:04',NULL,NULL),(2854,1739,'EM','tppaworkacct@gmail.com',0,'2013-12-25 18:55:30',NULL,NULL),(4179,2669,'AP','3305595203',0,'2013-12-25 19:47:01',NULL,NULL),(4491,2856,'AP','2253018141',0,'2013-12-25 20:01:31',NULL,NULL),(968,595,'EM','dmomper@cinci.rr.com',0,'2013-12-25 18:00:11',NULL,NULL),(5438,3482,'EM','teresa.rivers@gmail.com',0,'2013-12-25 21:20:13',NULL,NULL),(26951,17332,'TE','3185901818',0,'2014-01-13 02:23:57',NULL,NULL),(27333,17601,'TE','2147739109',0,'2014-01-14 01:32:16',NULL,NULL),(31682,20667,'EM','suttonval@ymail.com',0,'2014-01-30 21:00:47',NULL,NULL),(32250,21062,'TE','5049491028',0,'2014-02-02 19:00:12',NULL,NULL),(35897,23616,'TE','4199445934',0,'2014-02-13 22:03:15',NULL,NULL),(37859,24975,'TE','3255293687',0,'2014-02-20 22:00:30',NULL,NULL),(39431,26081,'TE','2259784703',0,'2014-02-28 06:30:04',NULL,NULL),(40046,26550,'AP','5134880298',0,'2014-02-28 21:30:12',NULL,NULL),(6986,4561,'AP','3306399797',0,'2013-12-25 22:04:43',NULL,NULL),(25857,16667,'TE','5134606335',0,'2014-01-08 18:24:27',NULL,NULL),(25630,16528,'TE','9365909520',1,'2014-01-07 10:21:59',NULL,NULL),(25377,16366,'TE','6627413326',0,'2014-01-07 04:02:54',NULL,NULL),(24498,15803,'EM','twanc86@yahoo.com',0,'2014-01-03 02:02:58',NULL,NULL),(11035,7161,'EM','djcj1949@yahoo.com',0,'2013-12-26 01:52:29',NULL,NULL),(14733,9637,'EM','cwillman57@yahoo.com',0,'2013-12-26 04:38:24',NULL,NULL),(9008,5911,'AP','2146755359',0,'2013-12-25 23:50:03',NULL,NULL),(22883,14765,'AP','7138822519',1,'2013-12-29 11:12:47',NULL,NULL),(23091,14892,'TE','5042147444',0,'2013-12-30 00:00:50',NULL,NULL),(23144,14921,'TE','7408561334',0,'2013-12-30 00:01:41',NULL,NULL),(27055,17398,'AP','4192366591',0,'2014-01-13 03:00:15',NULL,NULL),(28755,18557,'AP','5135035295',0,'2014-01-16 08:46:57',NULL,NULL),(29141,18825,'TE','6019535668',0,'2014-01-17 03:36:08',NULL,NULL),(32639,21347,'TE','2107485014',0,'2014-02-04 21:00:36',NULL,NULL),(33106,21688,'TE','5046445385',0,'2014-02-05 21:31:05',NULL,NULL),(33586,22018,'TE','6014252851',0,'2014-02-07 19:00:56',NULL,NULL),(34991,22973,'TE','6015691788',0,'2014-02-12 21:00:18',NULL,NULL),(40131,26618,'TE','4086368780',0,'2014-02-28 21:30:50',NULL,NULL),(40879,27161,'AP','9036030071',0,'2014-03-03 21:31:00',NULL,NULL),(40993,27235,'EM','codes82520@yahoo.com',0,'2014-03-03 21:31:44',NULL,NULL),(42170,28013,'EM','christinem@nktelco.net',0,'2014-03-06 21:01:16',NULL,NULL),(43802,29078,'AP','6625883373',0,'2014-03-10 21:02:01',NULL,NULL),(1558,959,'AP','9728388762',0,'2013-12-25 18:09:45',NULL,NULL),(7647,4978,'TE','9037878253',0,'2013-12-25 22:46:39',NULL,NULL),(2382,1448,'AP','6145974057',0,'2013-12-25 18:48:02',NULL,NULL),(10607,6902,'EM','bakinmommy@aol.com',0,'2013-12-26 01:45:41',NULL,NULL),(13536,8827,'TE','5628320418',0,'2013-12-26 04:00:26',NULL,NULL),(13716,8937,'TE','5133720978',0,'2013-12-26 04:03:14',NULL,NULL),(14348,9379,'AP','5042312335',0,'2013-12-26 04:32:03',NULL,NULL),(5149,3301,'AP','3306356686',0,'2013-12-25 21:15:42',NULL,NULL),(6012,3860,'AP','4106032905',0,'2013-12-25 21:35:55',NULL,NULL),(22783,14691,'EM','tracy.palagyi@yahoo.com',1,'2013-12-29 11:08:49',NULL,NULL),(4787,3063,'TE','2256873407',0,'2013-12-25 20:19:14',NULL,NULL),(23901,15418,'TE','8303192910',1,'2014-01-02 04:27:23',NULL,NULL),(24490,15800,'AP','3185358104',0,'2014-01-03 02:02:51',NULL,NULL),(26345,16958,'TE','3308197283',0,'2014-01-13 02:20:05',NULL,NULL),(26687,17165,'AP','2253301302',0,'2014-01-13 02:22:05',NULL,NULL),(29597,19125,'TE','4403449475',0,'2014-01-21 08:45:20',NULL,NULL),(31080,20223,'TE','4198104361',0,'2014-01-27 21:01:46',NULL,NULL),(38412,25379,'AP','3306318527',0,'2014-02-25 21:30:45',NULL,NULL),(41943,27883,'AP','4192963640',0,'2014-03-05 21:32:34',NULL,NULL),(42003,27914,'EM','minervamimiguerra@gmail.com',0,'2014-03-06 21:00:18',NULL,NULL),(42336,28114,'TE','3303028149',0,'2014-03-06 21:02:17',NULL,NULL),(43842,29097,'AP','5133043805',0,'2014-03-10 21:02:14',NULL,NULL),(1234,752,'AP','9037360229',0,'2013-12-25 18:04:19',NULL,NULL),(22980,14824,'TE','9725676116',1,'2013-12-29 11:14:23',NULL,NULL),(1597,984,'TE','3308081032',0,'2013-12-25 18:10:25',NULL,NULL),(21114,13575,'TE','5042591652',0,'2013-12-26 13:04:46',NULL,NULL),(20751,13337,'TE','9409370077',0,'2013-12-26 12:58:47',NULL,NULL),(14754,9650,'TE','4192246913',0,'2013-12-26 04:38:45',NULL,NULL),(14025,9158,'AP','5136670628',0,'2013-12-26 04:08:39',NULL,NULL),(12110,7915,'TE','5047825193',0,'2013-12-26 03:06:11',NULL,NULL),(2458,1509,'TE','3305757554',0,'2013-12-25 18:49:28',NULL,NULL),(10439,6804,'AP','3617282272',0,'2013-12-26 01:30:06',NULL,NULL),(7371,4795,'TE','2163825793',0,'2013-12-25 22:16:24',NULL,NULL),(26613,17123,'AP','4403084470',0,'2014-01-13 02:21:43',NULL,NULL),(24810,16006,'TE','9199438950',0,'2014-01-04 02:01:39',NULL,NULL),(25497,16441,'TE','9373994757',0,'2014-01-07 04:05:07',NULL,NULL),(25764,16601,'AP','3182298862',0,'2014-01-08 18:24:04',NULL,NULL),(27091,17422,'EM','jenruby1971@gmail.com',0,'2014-01-13 03:00:28',NULL,NULL),(28825,18609,'TE','9376575206',0,'2014-01-16 08:47:22',NULL,NULL),(30275,19615,'TE','2164507724',0,'2014-01-23 03:02:52',NULL,NULL),(32069,20939,'EM','patelstacy@hotmail.com',0,'2014-01-31 21:01:42',NULL,NULL),(33559,21999,'AP','5043525209',0,'2014-02-07 19:00:47',NULL,NULL),(35230,23137,'AP','3306972542',0,'2014-02-12 21:31:34',NULL,NULL),(38301,25292,'TE','4192030072',0,'2014-02-25 21:00:23',NULL,NULL),(40125,26608,'BN','6023292709',0,'2014-02-28 21:30:46',NULL,NULL),(42387,28152,'TE','4195361924',0,'2014-03-06 21:02:37',NULL,NULL),(42957,28567,'TE','4196490364',0,'2014-03-07 21:32:29',NULL,NULL),(43518,28896,'TE','2543157765',0,'2014-03-10 21:00:18',NULL,NULL),(43917,29136,'AP','4192768197',0,'2014-03-10 21:02:40',NULL,NULL),(33,24,'TE','3308824407',0,'2013-12-25 17:15:35',NULL,NULL),(22898,14773,'AP','9156370355',1,'2013-12-29 11:13:01',NULL,NULL),(10154,6636,'AP','8478777760',0,'2013-12-26 01:00:10',NULL,NULL),(12411,8127,'TE','5137326466',0,'2013-12-26 03:15:26',NULL,NULL),(8096,5302,'TE','4193486319',0,'2013-12-25 23:06:18',NULL,NULL),(6930,4514,'AP','9562925366',0,'2013-12-25 22:03:41',NULL,NULL),(3124,1946,'TE','2166815298',0,'2013-12-25 19:00:50',NULL,NULL),(3476,2177,'EM','JLGDLG639@MSN.COM',0,'2013-12-25 19:19:18',NULL,NULL),(11032,7160,'AP','9374789356',0,'2013-12-26 01:52:26',NULL,NULL),(25123,16194,'EM','lindakayek@yahoo.com',0,'2014-01-05 00:00:57',NULL,NULL),(26238,16886,'EM','mdflores23@aol.com',0,'2014-01-13 02:19:25',NULL,NULL),(31866,20801,'AP','9154784221',0,'2014-01-31 21:00:22',NULL,NULL),(33463,21923,'TE','2817239842',0,'2014-02-07 19:00:07',NULL,NULL),(34964,22955,'TE','5134597369',0,'2014-02-12 21:00:04',NULL,NULL),(35676,23464,'EM','ABIRUBIO@HOTMAIL.COM',0,'2014-02-13 22:01:45',NULL,NULL),(40603,26953,'AP','7078798242',0,'2014-03-03 01:00:27',NULL,NULL),(41168,27341,'TE','5137422408',0,'2014-03-04 21:00:59',NULL,NULL),(41705,27732,'TE','9158218232',0,'2014-03-05 21:31:04',NULL,NULL),(42062,27952,'TE','8327246565',0,'2014-03-06 21:00:38',NULL,NULL),(8551,5618,'AP','5137034560',0,'2013-12-25 23:30:43',NULL,NULL),(7950,5187,'TE','4194665242',0,'2013-12-25 23:03:40',NULL,NULL),(21698,13971,'TE','5135238549',0,'2013-12-26 13:15:24',NULL,NULL),(21526,13838,'EM','COOLJAYLIN@HOTMAIL.COM',0,'2013-12-26 13:12:15',NULL,NULL),(11939,7775,'TE','8322838634',0,'2013-12-26 03:03:03',NULL,NULL),(11162,7260,'TE','3615002250',0,'2013-12-26 02:02:08',NULL,NULL),(3645,2311,'TE','6266790175',0,'2013-12-25 19:31:10',NULL,NULL),(5092,3267,'AP','5044160081',0,'2013-12-25 20:47:06',NULL,NULL),(4793,3065,'AP','9012887592',0,'2013-12-25 20:19:18',NULL,NULL),(29236,18886,'TE','5135264180',0,'2014-01-17 03:36:30',NULL,NULL),(31249,20355,'TE','3302344751',0,'2014-01-28 21:01:17',NULL,NULL),(31419,20482,'AP','3306185725',0,'2014-01-29 21:01:01',NULL,NULL),(36265,23869,'TE','4193038352',0,'2014-02-14 21:32:09',NULL,NULL),(37009,24368,'EM','jsd45@att.net',0,'2014-02-18 22:00:36',NULL,NULL),(37884,24993,'TE','9727402171',0,'2014-02-20 22:00:41',NULL,NULL),(37977,25055,'TE','5132134978',0,'2014-02-20 22:01:20',NULL,NULL),(39386,26047,'TE','3303276618',0,'2014-02-26 21:02:30',NULL,NULL),(42064,27953,'TE','9723718419',0,'2014-03-06 21:00:39',NULL,NULL),(42679,28389,'EM','nclantz@gmail.com',0,'2014-03-07 21:30:44',NULL,NULL),(10190,6658,'TE','6142197181',0,'2013-12-26 01:00:47',NULL,NULL),(25883,16687,'TE','2129458094',0,'2014-01-08 18:24:33',NULL,NULL),(25716,16576,'AP','4408133773',1,'2014-01-07 10:23:31',NULL,NULL),(6807,4416,'EM','wwjordan7@hotmail.com',0,'2013-12-25 22:01:30',NULL,NULL),(3834,2439,'AP','3304728891',0,'2013-12-25 19:34:24',NULL,NULL),(20491,13194,'EM','sandrun@hotmail.com',0,'2013-12-26 12:54:45',NULL,NULL),(3408,2140,'TE','2282812092',0,'2013-12-25 19:18:15',NULL,NULL),(26073,16793,'TE','9565858235',0,'2014-01-13 02:18:07',NULL,NULL),(28871,18640,'EM','lamphan.oudomvilay9@gmail.com',0,'2014-01-17 03:35:06',NULL,NULL),(32713,21399,'AP','6142189163',0,'2014-02-04 21:01:01',NULL,NULL),(34049,22325,'AP','5105071275',0,'2014-02-10 11:00:57',NULL,NULL),(34170,22409,'TE','5042286487',0,'2014-02-10 21:30:24',NULL,NULL),(40073,26573,'TE','6148861509',0,'2014-02-28 21:30:27',NULL,NULL),(40173,26643,'AP','4407890052',0,'2014-02-28 21:31:04',NULL,NULL),(43027,28609,'TE','3308822702',0,'2014-03-08 21:30:14',NULL,NULL),(43797,29076,'TE','9012395771',0,'2014-03-10 21:02:00',NULL,NULL),(10054,6575,'EM','morrisdelaney@rocketmail.com',0,'2013-12-26 00:52:48',NULL,NULL),(25309,16320,'AP','2253248672',0,'2014-01-07 04:01:41',NULL,NULL),(12107,7912,'AP','8633938698',0,'2013-12-26 03:06:07',NULL,NULL),(12329,8063,'TE','4192662691',0,'2013-12-26 03:10:00',NULL,NULL),(5572,3559,'TE','3308823224',0,'2013-12-25 21:22:15',NULL,NULL),(6975,4547,'TE','4407292896',0,'2013-12-25 22:04:29',NULL,NULL),(3305,2080,'TE','5043120292',0,'2013-12-25 19:16:36',NULL,NULL),(21635,13927,'EM','hollyforgette@gmail.com',0,'2013-12-26 13:14:20',NULL,NULL),(22404,14448,'TE','2256202373',0,'2013-12-28 03:32:25',NULL,NULL),(8437,5551,'TE','2147272274',0,'2013-12-25 23:16:09',NULL,NULL),(30391,19692,'TE','9366329860',0,'2014-01-23 21:00:43',NULL,NULL),(31159,20292,'TE','3183080718',0,'2014-01-28 21:00:37',NULL,NULL),(31247,20349,'EM','augman321@gmail.com',0,'2014-01-28 21:01:13',NULL,NULL),(32131,20984,'AP','5044939499',0,'2014-02-01 19:00:22',NULL,NULL),(34058,22330,'EM','sandrag78045@yahoo.com',0,'2014-02-10 11:01:00',NULL,NULL),(35086,23042,'EM','james@sadler57.com',0,'2014-02-12 21:30:41',NULL,NULL),(36778,24216,'TE','5126806048',0,'2014-02-16 19:00:26',NULL,NULL),(37880,24988,'TE','8328775070',0,'2014-02-20 22:00:38',NULL,NULL),(40442,26848,'EM','sexydonna973@gmail.com',0,'2014-03-01 21:00:49',NULL,NULL),(41383,27494,'TE','4402258647',0,'2014-03-04 21:02:24',NULL,NULL),(10481,6829,'AP','7402522875',0,'2013-12-26 01:30:44',NULL,NULL),(8249,5396,'AP','3184044719',0,'2013-12-25 23:08:48',NULL,NULL),(8829,5781,'TE','6145788309',0,'2013-12-25 23:47:04',NULL,NULL),(7787,5083,'AP','8303343828',0,'2013-12-25 23:01:00',NULL,NULL),(2937,1806,'TE','3306456898',0,'2013-12-25 18:56:55',NULL,NULL),(14371,9399,'TE','7132634497',0,'2013-12-26 04:32:32',NULL,NULL),(2636,1603,'TE','8173722338',0,'2013-12-25 18:52:07',NULL,NULL),(2035,1260,'EM','kozyman1@gmail.com',0,'2013-12-25 18:21:31',NULL,NULL),(22763,14677,'EM','lemichal.drake@eagles.usm.edu',1,'2013-12-29 11:08:27',NULL,NULL),(23232,14970,'EM','gemoncivais@gmail.com',0,'2014-01-01 12:00:47',NULL,NULL),(27277,17561,'AP','9852223900',0,'2014-01-13 03:02:01',NULL,NULL),(28128,18133,'TE','8592403883',0,'2014-01-15 02:07:44',NULL,NULL),(28420,18311,'TE','2163080528',0,'2014-01-16 08:45:02',NULL,NULL),(32157,21005,'AP','5047820558',0,'2014-02-01 19:00:31',NULL,NULL),(33480,21941,'TE','9567560758',0,'2014-02-07 19:00:15',NULL,NULL),(36205,23832,'AP','6012150085',0,'2014-02-14 21:31:47',NULL,NULL),(36919,24314,'BN','2542287787',0,'2014-02-18 22:00:04',NULL,NULL),(38295,25286,'EM','hollybaker@fuse.net',0,'2014-02-25 21:00:21',NULL,NULL),(42890,28524,'EM','jvking46@gmail.com',0,'2014-03-07 21:32:03',NULL,NULL),(43523,28898,'TE','2144046959',0,'2014-03-10 21:00:19',NULL,NULL),(43659,28976,'TE','3188651933',0,'2014-03-10 21:01:06',NULL,NULL),(11439,7441,'TE','4197871986',0,'2013-12-26 02:30:25',NULL,NULL),(20324,13096,'TE','5133795914',0,'2013-12-26 12:52:01',NULL,NULL),(20734,13326,'AP','5124617807',0,'2013-12-26 12:58:29',NULL,NULL),(21246,13655,'TE','3183961669',0,'2013-12-26 13:07:27',NULL,NULL),(22443,14474,'AP','9722685162',0,'2013-12-28 03:33:06',NULL,NULL),(22628,14591,'EM','charlie@rigbymedical.com',0,'2013-12-28 03:36:09',NULL,NULL),(22755,14674,'AP','5047569739',1,'2013-12-29 11:08:21',NULL,NULL),(11288,7357,'AP','8327756849',0,'2013-12-26 02:15:17',NULL,NULL),(14437,9434,'AP','4196325518',0,'2013-12-26 04:33:30',NULL,NULL),(10366,6756,'EM','athens1955@att.net',0,'2013-12-26 01:16:15',NULL,NULL),(6342,4089,'TE','4195767235',0,'2013-12-25 21:47:22',NULL,NULL),(24836,16018,'EM','lawguy310@gmail.com',0,'2014-01-04 02:02:05',NULL,NULL),(32264,21076,'TE','7408593414',0,'2014-02-02 19:00:19',NULL,NULL),(32535,21271,'TE','3303317245',0,'2014-02-03 21:01:31',NULL,NULL),(33503,21955,'EM','pswood7@yahoo.com',0,'2014-02-07 19:00:23',NULL,NULL),(33536,21982,'EM','MOONY7TOC@AOL.COM',0,'2014-02-07 19:00:38',NULL,NULL),(34351,22534,'TE','6019428946',0,'2014-02-10 21:31:34',NULL,NULL),(34376,22548,'EM','EJ_mommi49@yahoo.com',0,'2014-02-10 21:31:43',NULL,NULL),(36236,23848,'AP','4195812935',0,'2014-02-14 21:31:57',NULL,NULL),(37535,24716,'TE','4695701993',0,'2014-02-20 04:36:58',NULL,NULL),(43813,29083,'TE','9012688773',0,'2014-03-10 21:02:05',NULL,NULL),(1382,845,'AP','2259556328',0,'2013-12-25 18:06:43',NULL,NULL),(22762,14677,'AP','6019944647',1,'2013-12-29 11:08:27',NULL,NULL),(14679,9604,'EM','jbtwilde@sbcglobal.net',0,'2013-12-26 04:37:30',NULL,NULL),(5374,3440,'AP','9378676077',0,'2013-12-25 21:19:13',NULL,NULL),(9231,6040,'EM','zachary.domke@gmail.com',0,'2013-12-26 00:01:23',NULL,NULL),(3239,2039,'TE','3182377711',0,'2013-12-25 19:15:32',NULL,NULL),(1665,1022,'EM','kparsons@brightdsl.net',0,'2013-12-25 18:15:17',NULL,NULL),(2781,1684,'TE','5043096544',0,'2013-12-25 18:54:16',NULL,NULL),(2592,1582,'TE','9154720358',0,'2013-12-25 18:51:28',NULL,NULL),(10302,6722,'TE','5132645663',0,'2013-12-26 01:15:15',NULL,NULL),(24798,15999,'TE','2812027408',0,'2014-01-04 02:01:27',NULL,NULL),(25296,16312,'TE','3375646109',0,'2014-01-07 04:01:27',NULL,NULL),(25743,16590,'AP','5042652689',0,'2014-01-08 18:24:00',NULL,NULL),(25825,16647,'AP','2283657766',0,'2014-01-08 18:24:19',NULL,NULL),(27593,17789,'TE','9375157480',0,'2014-01-14 01:33:46',NULL,NULL),(28027,18061,'EM','jsboone1513@yahoo.com',0,'2014-01-15 02:07:21',NULL,NULL),(28786,18578,'TE','4405912731',0,'2014-01-16 08:47:07',NULL,NULL),(29374,18982,'TE','7404993242',0,'2014-01-20 08:06:07',NULL,NULL),(43204,28711,'AP','9012375032',0,'2014-03-08 21:31:14',NULL,NULL),(32880,21519,'AP','6622300938',0,'2014-02-05 21:00:06',NULL,NULL),(33136,21705,'AP','4404093411',0,'2014-02-05 21:31:12',NULL,NULL),(34941,22934,'TE','9376706451',0,'2014-02-11 21:30:13',NULL,NULL),(35558,23383,'AP','5133072112',0,'2014-02-13 22:01:01',NULL,NULL),(36851,24267,'TE','4402135724',0,'2014-02-17 19:00:14',NULL,NULL),(37306,24547,'AP','3306512960',0,'2014-02-20 04:03:57',NULL,NULL),(41203,27365,'EM','poteettim@gmail.com',0,'2014-03-04 21:01:14',NULL,NULL),(11612,7550,'EM','MOODYPL16@YAHOO.COM',0,'2013-12-26 02:33:13',NULL,NULL),(22437,14470,'AP','2073129012',0,'2013-12-28 03:33:01',NULL,NULL),(20867,13416,'EM','sasems@juno.com',0,'2013-12-26 13:00:42',NULL,NULL),(23409,15080,'TE','8179833443',0,'2014-01-01 12:04:08',NULL,NULL),(25874,16675,'TE','3306332691',0,'2014-01-08 18:24:30',NULL,NULL),(27701,17854,'EM','ash.poynter@gmail.com',0,'2014-01-15 02:06:08',NULL,NULL),(30449,19740,'TE','2254050070',0,'2014-01-23 21:01:10',NULL,NULL),(31445,20495,'EM','thuyhang.dinh@gmail.com',0,'2014-01-29 21:01:10',NULL,NULL),(32006,20894,'TE','9374927393',0,'2014-01-31 21:01:17',NULL,NULL),(33437,21902,'TE','4253299776',0,'2014-02-06 21:01:48',NULL,NULL),(39005,25791,'EM','spatzroth@yahoo.com',0,'2014-02-26 21:00:12',NULL,NULL),(39630,26208,'TE','4407963970',0,'2014-02-28 06:30:52',NULL,NULL),(41222,27381,'AP','6013467113',0,'2014-03-04 21:01:21',NULL,NULL),(42002,27914,'AP','7137252409',0,'2014-03-06 21:00:18',NULL,NULL),(43561,28928,'AP','6143061122',0,'2014-03-10 21:00:36',NULL,NULL),(660,410,'AP','6145967429',0,'2013-12-25 17:46:24',NULL,NULL),(23283,15002,'AP','2818654438',0,'2014-01-01 12:01:45',NULL,NULL),(23177,14938,'EM','dee1957c@bellsouth.net',0,'2013-12-30 00:02:13',NULL,NULL),(23109,14899,'TE','3306459535',0,'2013-12-30 00:01:04',NULL,NULL),(21465,13793,'AP','7697987804',0,'2013-12-26 13:11:09',NULL,NULL),(843,523,'AP','5132250528',0,'2013-12-25 17:49:16',NULL,NULL),(4981,3199,'AP','3308023127',0,'2013-12-25 20:45:07',NULL,NULL),(13642,8896,'TE','8178967854',0,'2013-12-26 04:02:09',NULL,NULL),(12034,7850,'TE','4199056577',0,'2013-12-26 03:04:48',NULL,NULL),(12011,7825,'TE','6267577443',0,'2013-12-26 03:04:18',NULL,NULL),(3591,2251,'TE','5135830198',0,'2013-12-25 19:30:07',NULL,NULL),(9626,6300,'AP','4193414015',0,'2013-12-26 00:45:53',NULL,NULL),(26120,16819,'TE','8172436598',0,'2014-01-13 02:18:21',NULL,NULL),(28066,18090,'TE','3189928985',0,'2014-01-15 02:07:30',NULL,NULL),(29321,18948,'EM','b.franklin2007@gamil.com',0,'2014-01-20 08:05:47',NULL,NULL),(31041,20193,'AP','9012120439',0,'2014-01-27 21:01:28',NULL,NULL),(32884,21524,'TE','8327192493',0,'2014-02-05 21:30:04',NULL,NULL),(37725,24877,'TE','5139311706',0,'2014-02-20 05:35:05',NULL,NULL),(38706,25582,'TE','8329695416',0,'2014-02-26 08:00:37',NULL,NULL),(42819,28477,'EM','dwa307@sbcglobal.net',0,'2014-03-07 21:31:34',NULL,NULL),(3045,1895,'TE','4196186721',0,'2013-12-25 18:58:58',NULL,NULL),(25917,16702,'TE','2142955707',0,'2014-01-08 18:24:39',NULL,NULL),(25827,16651,'TE','6014545938',0,'2014-01-08 18:24:20',NULL,NULL),(5490,3511,'AP','9012832216',0,'2013-12-25 21:21:01',NULL,NULL),(8288,5431,'AP','3373547775',0,'2013-12-25 23:09:40',NULL,NULL),(10330,6736,'AP','2164694364',0,'2013-12-26 01:15:38',NULL,NULL),(10925,7103,'TE','5134295642',0,'2013-12-26 01:50:49',NULL,NULL),(11791,7669,'AP','2252416675',0,'2013-12-26 03:00:32',NULL,NULL),(5550,3544,'AP','7138057997',0,'2013-12-25 21:21:54',NULL,NULL),(21093,13564,'TE','5043887800',0,'2013-12-26 13:04:26',NULL,NULL),(22868,14756,'TE','4198899540',1,'2013-12-29 11:10:28',NULL,NULL),(23336,15036,'TE','5042143286',0,'2014-01-01 12:02:47',NULL,NULL),(23438,15104,'EM','jwcourtney@mail.com',0,'2014-01-01 12:04:47',NULL,NULL),(23708,15302,'TE','9855023962',1,'2014-01-02 04:22:52',NULL,NULL),(23786,15339,'AP','3308586636',1,'2014-01-02 04:24:12',NULL,NULL),(27869,17957,'EM','lolacattlecompany@yahoo.com',0,'2014-01-15 02:06:45',NULL,NULL),(29200,18864,'TE','5044811631',0,'2014-01-17 03:36:21',NULL,NULL),(30090,19495,'EM','erika@hammerdata.com',0,'2014-01-23 03:02:08',NULL,NULL),(33032,21640,'AP','9033150153',0,'2014-02-05 21:30:45',NULL,NULL),(33410,21891,'TE','6013196134',0,'2014-02-06 21:01:38',NULL,NULL),(37939,25032,'TE','2256861725',0,'2014-02-20 22:01:04',NULL,NULL),(39417,26062,'EM','ralsept@aol.com',0,'2014-02-26 21:02:40',NULL,NULL),(40107,26597,'AP','5127888598',0,'2014-02-28 21:30:40',NULL,NULL),(40862,27153,'AP','7409291054',0,'2014-03-03 21:30:54',NULL,NULL),(1619,995,'AP','9379034808',0,'2013-12-25 18:10:46',NULL,NULL),(25800,16627,'TE','6145179034',0,'2014-01-08 18:24:13',NULL,NULL),(8793,5760,'EM','shanns5678@yahoo.com',0,'2013-12-25 23:46:30',NULL,NULL),(22716,14649,'TE','9158581317',1,'2013-12-29 11:07:41',NULL,NULL),(27651,17824,'AP','6012916216',0,'2014-01-15 02:05:57',NULL,NULL),(29034,18745,'TE','6142676225',0,'2014-01-17 03:35:41',NULL,NULL),(30905,20091,'EM','DONNALACIURA@YAHOO.COM',0,'2014-01-27 21:00:30',NULL,NULL),(31032,20189,'TE','2147385348',0,'2014-01-27 21:01:25',NULL,NULL),(33804,22195,'AP','8065591643',0,'2014-02-09 19:00:12',NULL,NULL),(39930,26424,'AP','5129276289',0,'2014-02-28 07:30:10',NULL,NULL),(40848,27143,'TE','5138864646',0,'2014-03-03 21:30:48',NULL,NULL),(5393,3451,'TE','4405069319',0,'2013-12-25 21:19:31',NULL,NULL),(24854,16029,'AP','3182063775',0,'2014-01-04 02:02:26',NULL,NULL),(6502,4203,'EM','kldvlambert@bigbend.net',0,'2013-12-25 21:49:59',NULL,NULL),(21245,13654,'EM','chrisriggleman@gmail.com',0,'2013-12-26 13:07:25',NULL,NULL),(6281,4050,'AP','5137037674',0,'2013-12-25 21:46:23',NULL,NULL),(21966,14150,'AP','3187510158',0,'2013-12-27 02:02:53',NULL,NULL),(23316,15024,'AP','3373021735',0,'2014-01-01 12:02:24',NULL,NULL),(23351,15043,'TE','3374521572',0,'2014-01-01 12:03:02',NULL,NULL),(29330,18953,'TE','8326337271',0,'2014-01-20 08:05:50',NULL,NULL),(29657,19159,'AP','4199670160',0,'2014-01-21 08:45:41',NULL,NULL),(30282,19618,'EM','dianemuntz65@roadrunner.com',0,'2014-01-23 03:02:54',NULL,NULL),(30756,19987,'EM','don-ratliff@sbcglobal.net',0,'2014-01-25 19:00:18',NULL,NULL),(31107,20252,'EM','webbalanwright@yahoo.com',0,'2014-01-28 21:00:14',NULL,NULL),(33982,22293,'AP','5134780082',0,'2014-02-10 11:00:31',NULL,NULL),(34734,22776,'TE','4408453860',0,'2014-02-11 21:01:41',NULL,NULL),(40336,26769,'AP','2252471631',0,'2014-03-01 19:00:13',NULL,NULL),(40655,26989,'TE','4199570822',0,'2014-03-03 01:00:41',NULL,NULL),(40749,27081,'AP','3306909306',0,'2014-03-03 21:30:11',NULL,NULL),(5732,3675,'AP','6785243107',0,'2013-12-25 21:31:18',NULL,NULL),(25858,16667,'AP','5134606335',0,'2014-01-08 18:24:27',NULL,NULL),(8623,5665,'TE','3307246802',0,'2013-12-25 23:31:53',NULL,NULL),(9087,5956,'TE','4193670914',0,'2013-12-25 23:51:15',NULL,NULL),(6937,4519,'TE','2145078737',0,'2013-12-25 22:03:48',NULL,NULL),(6746,4380,'TE','2163336182',0,'2013-12-25 22:00:35',NULL,NULL),(888,550,'TE','9036693563',0,'2013-12-25 17:50:01',NULL,NULL),(4414,2812,'AP','9159749265',0,'2013-12-25 20:00:17',NULL,NULL),(14210,9299,'TE','4198195836',0,'2013-12-26 04:16:19',NULL,NULL),(23510,15167,'AP','5134448009',0,'2014-01-01 12:06:27',NULL,NULL),(26585,17105,'TE','9729518838',0,'2014-01-13 02:21:34',NULL,NULL),(21940,14133,'AP','3375784639',0,'2013-12-27 02:02:27',NULL,NULL),(5362,3433,'AP','5044442852',0,'2013-12-25 21:19:01',NULL,NULL),(14525,9490,'AP','6145788309',0,'2013-12-26 04:34:53',NULL,NULL),(25836,16657,'TE','5043826040',0,'2014-01-08 18:24:23',NULL,NULL),(26906,17309,'AP','9034367148',0,'2014-01-13 02:23:43',NULL,NULL),(28525,18387,'TE','5134786043',0,'2014-01-16 08:45:38',NULL,NULL),(32580,21302,'AP','3379124805',0,'2014-02-04 21:00:13',NULL,NULL),(33477,21936,'TE','3252270955',0,'2014-02-07 19:00:12',NULL,NULL),(34829,22842,'EM','wnicholsjr@gmail.com',0,'2014-02-11 21:02:14',NULL,NULL),(34899,22901,'TE','4192330475',0,'2014-02-11 21:02:42',NULL,NULL),(35116,23066,'EM','rodneyjr12@yahoo.com',0,'2014-02-12 21:30:54',NULL,NULL),(37295,24540,'AP','3305071041',0,'2014-02-20 04:02:29',NULL,NULL),(39975,26467,'TE','4404666007',0,'2014-02-28 07:30:35',NULL,NULL),(42616,28350,'EM','bang@kobeaustin.com',0,'2014-03-07 21:30:22',NULL,NULL),(43437,28848,'TE','4199569848',0,'2014-03-09 21:01:16',NULL,NULL),(43691,29002,'TE','7193131865',0,'2014-03-10 21:01:19',NULL,NULL),(10354,6748,'TE','4197824251',0,'2013-12-26 01:16:01',NULL,NULL),(260,158,'AP','5122977257',0,'2013-12-25 17:19:07',NULL,NULL),(8194,5362,'AP','9376946458',0,'2013-12-25 23:07:54',NULL,NULL),(21139,13591,'TE','9854192389',0,'2013-12-26 13:05:12',NULL,NULL),(20890,13433,'TE','5134241753',0,'2013-12-26 13:01:06',NULL,NULL),(20398,13137,'AP','5132053384',0,'2013-12-26 12:53:12',NULL,NULL),(2682,1627,'EM','mel66@austin.rr.com',0,'2013-12-25 18:52:45',NULL,NULL),(3440,2157,'AP','3182358368',0,'2013-12-25 19:18:46',NULL,NULL),(14506,9476,'EM','rbitonte@insight.rr.com',0,'2013-12-26 04:34:34',NULL,NULL),(13985,9120,'EM','ttorres@cinci.rr.com',0,'2013-12-26 04:07:47',NULL,NULL),(23884,15411,'AP','6824593366',1,'2014-01-02 04:27:07',NULL,NULL),(28571,18419,'BN','5042364824',0,'2014-01-16 08:45:52',NULL,NULL),(34636,22710,'AP','9853817079',0,'2014-02-11 21:01:04',NULL,NULL),(36667,24138,'EM','stefanieraper@rocketmail.com',0,'2014-02-15 22:01:52',NULL,NULL),(37183,24476,'AP','4196061115',0,'2014-02-18 22:01:42',NULL,NULL),(42087,27964,'TE','5042088186',0,'2014-03-06 21:00:46',NULL,NULL),(42400,28162,'TE','4192352593',0,'2014-03-06 21:02:42',NULL,NULL),(1161,712,'TE','5673516124',0,'2013-12-25 18:03:14',NULL,NULL),(22148,14265,'TE','5132911269',0,'2013-12-27 02:05:56',NULL,NULL),(21328,13704,'TE','3306444892',0,'2013-12-26 13:08:46',NULL,NULL),(13820,9010,'TE','3309522271',0,'2013-12-26 04:05:04',NULL,NULL),(8484,5581,'TE','9035633096',0,'2013-12-25 23:16:57',NULL,NULL),(2976,1844,'TE','3302836353',0,'2013-12-25 18:57:43',NULL,NULL),(4613,2942,'AP','4197220838',0,'2013-12-25 20:16:17',NULL,NULL),(25520,16455,'AP','4193403066',0,'2014-01-07 04:05:34',NULL,NULL),(29540,19092,'AP','6147437174',0,'2014-01-21 08:44:33',NULL,NULL),(32138,20987,'AP','5133881063',0,'2014-02-01 19:00:24',NULL,NULL),(38802,25654,'TE','9373042343',0,'2014-02-26 08:30:41',NULL,NULL),(39757,26293,'TE','4194943763',0,'2014-02-28 06:31:25',NULL,NULL),(42440,28187,'AP','5133131842',0,'2014-03-06 21:02:58',NULL,NULL),(42491,28260,'TE','9379742355',0,'2014-03-07 21:00:16',NULL,NULL),(9467,6195,'TE','8322769907',0,'2013-12-26 00:30:26',NULL,NULL),(22654,14607,'EM','ecrummy@yahoo.com',0,'2013-12-28 03:36:33',NULL,NULL),(7504,4890,'AP','2813003679',0,'2013-12-25 22:31:29',NULL,NULL),(4074,2598,'EM','Ageneralpest@yahoo.com',0,'2013-12-25 19:45:16',NULL,NULL),(12325,8058,'EM','SWARSAW2004@HOTMAIL.COM',0,'2013-12-26 03:09:54',NULL,NULL),(12099,7907,'TE','6018707411',0,'2013-12-26 03:05:59',NULL,NULL),(4183,2672,'TE','9373607613',0,'2013-12-25 19:47:05',NULL,NULL),(25758,16598,'EM','zilcho748@gmail.com',0,'2014-01-08 18:24:03',NULL,NULL),(30373,19677,'TE','8326206201',0,'2014-01-23 21:00:36',NULL,NULL),(31899,20818,'AP','2256031934',0,'2014-01-31 21:00:33',NULL,NULL),(32948,21570,'EM','botr297@gmail.com',0,'2014-02-05 21:30:21',NULL,NULL),(36154,23795,'AP','3308086994',0,'2014-02-14 21:31:27',NULL,NULL),(37895,24998,'TE','2817286328',0,'2014-02-20 22:00:44',NULL,NULL),(38098,25146,'EM','lupewar@att.net',0,'2014-02-21 22:00:14',NULL,NULL),(42821,28478,'AP','5708777846',0,'2014-03-07 21:31:35',NULL,NULL),(266,163,'AP','5133890495',0,'2013-12-25 17:19:15',NULL,NULL),(23201,14952,'EM','marioei1608@gmail.com',0,'2014-01-01 12:00:14',NULL,NULL),(9462,6192,'AP','9728417972',0,'2013-12-26 00:30:22',NULL,NULL),(21856,14078,'TE','2346788631',0,'2013-12-27 02:01:02',NULL,NULL),(21620,13914,'EM','KYLEHILL0846a@GMAIL.COM',0,'2013-12-26 13:14:03',NULL,NULL),(21477,13799,'TE','2283438301',0,'2013-12-26 13:11:20',NULL,NULL),(14960,9789,'TE','2169252243',0,'2013-12-26 05:00:54',NULL,NULL),(2388,1455,'AP','4405390392',0,'2013-12-25 18:48:11',NULL,NULL),(3754,2381,'TE','5138840218',0,'2013-12-25 19:33:02',NULL,NULL),(26353,16961,'AP','3303222275',0,'2014-01-13 02:20:07',NULL,NULL),(26494,17049,'EM','dawn77murr@yahoo.com',0,'2014-01-13 02:20:56',NULL,NULL),(28766,18561,'EM','douglaseheyne@yahoo.com',0,'2014-01-16 08:46:59',NULL,NULL),(28767,18562,'TE','9375875265',0,'2014-01-16 08:47:00',NULL,NULL),(31077,20220,'TE','5132594238',0,'2014-01-27 21:01:44',NULL,NULL),(34628,22706,'TE','3183489914',0,'2014-02-11 21:01:02',NULL,NULL),(36562,24069,'TE','3302838999',0,'2014-02-15 22:01:15',NULL,NULL),(38051,25113,'TE','9018484750',0,'2014-02-21 21:30:17',NULL,NULL),(40233,26687,'EM','w.randall.thomas@gmail.com',0,'2014-02-28 21:31:27',NULL,NULL),(40284,26721,'AP','6019401098',0,'2014-02-28 21:31:45',NULL,NULL),(5656,3630,'TE','9376182480',0,'2013-12-25 21:30:07',NULL,NULL),(23705,15300,'EM','escott184@gmail.com',1,'2014-01-02 04:22:49',NULL,NULL),(5384,3446,'TE','4405069319',0,'2013-12-25 21:19:22',NULL,NULL),(4383,2794,'AP','7725294736',0,'2013-12-25 19:50:13',NULL,NULL),(2150,1325,'TE','2343128575',0,'2013-12-25 18:31:53',NULL,NULL),(2017,1250,'TE','4408851298',0,'2013-12-25 18:21:12',NULL,NULL),(22749,14671,'TE','9038491958',1,'2013-12-29 11:08:16',NULL,NULL),(27419,17660,'TE','9372774161',0,'2014-01-14 01:32:44',NULL,NULL),(27481,17702,'TE','5045782709',0,'2014-01-14 01:33:05',NULL,NULL),(28560,18415,'TE','5046382610',0,'2014-01-16 08:45:49',NULL,NULL),(30153,19537,'TE','5676941928',0,'2014-01-23 03:02:23',NULL,NULL),(32316,21111,'AP','4023489351',0,'2014-02-03 21:00:07',NULL,NULL),(36570,24072,'TE','3308619997',0,'2014-02-15 22:01:17',NULL,NULL),(39251,25967,'TE','6148706398',0,'2014-02-26 21:01:44',NULL,NULL),(42299,28087,'EM','ELNEGOTIATOR@GMAIL.COM',0,'2014-03-06 21:02:02',NULL,NULL),(42442,28188,'TE','4196815848',0,'2014-03-06 21:02:59',NULL,NULL),(43112,28657,'EM','hmbylaceyedrice@gmail.com',0,'2014-03-08 21:30:42',NULL,NULL),(3089,1929,'EM','mastersml@sbcglobal.net',0,'2013-12-25 19:00:20',NULL,NULL),(14007,9147,'TE','2164085250',0,'2013-12-26 04:08:20',NULL,NULL),(22293,14367,'AP','9372459168',0,'2013-12-28 03:30:26',NULL,NULL),(22474,14491,'EM','patricascott@yahoo.com',0,'2013-12-28 03:33:33',NULL,NULL),(26699,17176,'TE','2166181671',0,'2014-01-13 02:22:10',NULL,NULL),(28041,18070,'BN','3187074537',0,'2014-01-15 02:07:24',NULL,NULL),(28356,18271,'EM','sunshineuserid@yahoo.com',0,'2014-01-16 08:44:42',NULL,NULL),(28641,18466,'AP','5044188736',0,'2014-01-16 08:46:15',NULL,NULL),(29596,19123,'EM','chuwang6@gmail.com',0,'2014-01-21 08:45:19',NULL,NULL),(30812,20034,'AP','4404886747',0,'2014-01-26 19:00:22',NULL,NULL),(33879,22235,'EM','mmuriegas@sbcglobal.net',0,'2014-02-09 19:00:35',NULL,NULL),(11009,7147,'TE','4099399852',0,'2013-12-26 01:52:06',NULL,NULL),(26061,16787,'TE','3303344568',0,'2014-01-08 18:25:08',NULL,NULL),(8530,5605,'TE','4404291242',0,'2013-12-25 23:30:23',NULL,NULL),(14393,9411,'TE','9155394135',0,'2013-12-26 04:32:53',NULL,NULL),(14447,9439,'AP','5137666321',0,'2013-12-26 04:33:38',NULL,NULL),(10020,6556,'TE','2547449297',0,'2013-12-26 00:52:17',NULL,NULL),(20432,13159,'TE','3306061382',0,'2013-12-26 12:53:47',NULL,NULL),(20811,13370,'EM','nathalieszmd@yahoo.com',0,'2013-12-26 12:59:46',NULL,NULL),(2921,1794,'TE','9372417000',0,'2013-12-25 18:56:36',NULL,NULL),(353,218,'AP','9089064813',0,'2013-12-25 17:20:41',NULL,NULL),(22171,14281,'TE','2282224205',0,'2013-12-27 02:06:20',NULL,NULL),(22521,14521,'AP','2542890122',0,'2013-12-28 03:34:19',NULL,NULL),(26737,17196,'EM','santresa6@yahoo.com',0,'2014-01-13 02:22:21',NULL,NULL),(29783,19259,'TE','5042961263',0,'2014-01-21 08:46:48',NULL,NULL),(33433,21899,'EM','cmhole98@yahoo.com',0,'2014-02-06 21:01:46',NULL,NULL),(33558,21999,'TE','5042737835',0,'2014-02-07 19:00:46',NULL,NULL),(33918,22263,'AP','7133578644',0,'2014-02-10 11:00:09',NULL,NULL),(35592,23408,'TE','4408133980',0,'2014-02-13 22:01:14',NULL,NULL),(38392,25364,'TE','5132170685',0,'2014-02-25 21:30:38',NULL,NULL),(40038,26539,'TE','4196219051',0,'2014-02-28 21:30:07',NULL,NULL),(40704,27039,'EM','tvalenta1@att.net',0,'2014-03-03 21:00:20',NULL,NULL),(41912,27868,'TE','5132272110',0,'2014-03-05 21:32:23',NULL,NULL),(43426,28838,'TE','5133066453',0,'2014-03-09 21:01:11',NULL,NULL),(6498,4202,'AP','9568000802',0,'2013-12-25 21:49:56',NULL,NULL),(20878,13423,'AP','5133838130',0,'2013-12-26 13:00:53',NULL,NULL),(21005,13514,'EM','Deirdre_mac_smith@yahoo.com',0,'2013-12-26 13:03:01',NULL,NULL),(20400,13138,'TE','5132053384',0,'2013-12-26 12:53:13',NULL,NULL),(26428,17005,'TE','9378299244',0,'2014-01-13 02:20:33',NULL,NULL),(26812,17244,'TE','4196688422',0,'2014-01-13 02:22:47',NULL,NULL),(26885,17297,'EM','lkr1982r@yahoo.com',0,'2014-01-13 02:23:36',NULL,NULL),(28070,18091,'EM','mistynicole25@gmail.com',0,'2014-01-15 02:07:30',NULL,NULL),(32803,21461,'AP','3309907247',0,'2014-02-04 21:01:34',NULL,NULL),(33289,21797,'AP','5676445553',0,'2014-02-06 21:00:48',NULL,NULL),(35411,23279,'TE','5048127496',0,'2014-02-13 21:30:15',NULL,NULL),(35973,23669,'EM','melissaherrington1980@gmail.com',0,'2014-02-14 21:30:23',NULL,NULL),(95,56,'EM','cynthiax@roadrunner.com',0,'2013-12-25 17:16:32',NULL,NULL),(6608,4268,'AP','5672041369',0,'2013-12-25 21:51:42',NULL,NULL),(8926,5842,'AP','8305561680',0,'2013-12-25 23:48:36',NULL,NULL),(5784,3704,'EM','swygum@yahoo.com',0,'2013-12-25 21:32:04',NULL,NULL),(1944,1203,'EM','Bennythehandyman@aol.com',0,'2013-12-25 18:19:56',NULL,NULL),(1908,1179,'TE','3307180829',0,'2013-12-25 18:19:20',NULL,NULL),(9606,6287,'EM','rifflepam@yahoo.com',0,'2013-12-26 00:45:33',NULL,NULL),(10155,6637,'EM','Decon1344@hotmail.com',0,'2013-12-26 01:00:12',NULL,NULL),(22277,14357,'AP','7406012175',0,'2013-12-28 03:30:12',NULL,NULL),(22880,14761,'AP','2147357939',1,'2013-12-29 11:12:43',NULL,NULL),(1017,626,'AP','3303070337',0,'2013-12-25 18:00:59',NULL,NULL),(26696,17173,'EM','robertneiman@outlook.com',0,'2014-01-13 02:22:09',NULL,NULL),(28245,18214,'TE','4193027695',0,'2014-01-15 02:08:11',NULL,NULL),(30256,19598,'TE','3307309446',0,'2014-01-23 03:02:47',NULL,NULL),(31423,20484,'TE','3308585870',0,'2014-01-29 21:01:03',NULL,NULL),(31613,20620,'EM','wbboyet@gmail.com',0,'2014-01-30 21:00:23',NULL,NULL),(32677,21370,'AP','3255744636',0,'2014-02-04 21:00:48',NULL,NULL),(34623,22701,'TE','9724965247',0,'2014-02-11 21:00:59',NULL,NULL),(36047,23710,'EM','efiba6@gmail.com',0,'2014-02-14 21:30:46',NULL,NULL),(36441,23996,'EM','yanashani@gmail.com',0,'2014-02-15 22:00:30',NULL,NULL),(39803,26321,'TE','6628081813',0,'2014-02-28 06:31:36',NULL,NULL),(40439,26846,'TE','2255887435',0,'2014-03-01 21:00:48',NULL,NULL),(40662,26992,'AP','6146071980',0,'2014-03-03 01:29:59',NULL,NULL),(1412,861,'AP','3305595203',0,'2013-12-25 18:07:11',NULL,NULL),(9895,6473,'TE','4406450484',0,'2013-12-26 00:50:10',NULL,NULL),(8747,5735,'AP','5047175116',0,'2013-12-25 23:45:47',NULL,NULL),(20385,13130,'EM','vermont@bex.net',0,'2013-12-26 12:53:00',NULL,NULL),(6770,4393,'AP','4195123935',0,'2013-12-25 22:00:57',NULL,NULL),(20951,13476,'EM','egcincy@gmail.com',0,'2013-12-26 13:02:08',NULL,NULL),(21082,13557,'EM','christinascakes11@yahoo.com',0,'2013-12-26 13:04:16',NULL,NULL),(4307,2749,'AP','5132659156',0,'2013-12-25 19:49:01',NULL,NULL),(21586,13888,'TE','4199562760',0,'2013-12-26 13:13:24',NULL,NULL),(32886,21524,'EM','nancytchu@juno.com',0,'2014-02-05 21:30:04',NULL,NULL),(34706,22756,'AP','5043381633',0,'2014-02-11 21:01:29',NULL,NULL),(36993,24356,'EM','ferd@hackensawboys.com',0,'2014-02-18 22:00:30',NULL,NULL),(37279,24532,'AP','9854454155',0,'2014-02-20 04:00:40',NULL,NULL),(37844,24968,'AP','8176961674',0,'2014-02-20 22:00:24',NULL,NULL),(39593,26192,'TE','3308751270',0,'2014-02-28 06:30:45',NULL,NULL),(40682,27014,'TE','2817619666',0,'2014-03-03 21:00:09',NULL,NULL),(41744,27760,'TE','2252784729',0,'2014-03-05 21:31:20',NULL,NULL),(42419,28170,'EM','pschwartz4@cinci.rr.com',0,'2014-03-06 21:02:49',NULL,NULL),(5795,3715,'TE','5137312560',0,'2013-12-25 21:32:18',NULL,NULL),(23305,15018,'TE','5133799887',0,'2014-01-01 12:02:13',NULL,NULL),(1577,973,'TE','9853866123',0,'2013-12-25 18:10:04',NULL,NULL),(21640,13929,'EM','HEATHER.10.MICHELLE@GMAIL.COM',0,'2013-12-26 13:14:25',NULL,NULL),(1732,1062,'EM','holybucki@gmail.com',0,'2013-12-25 18:16:20',NULL,NULL),(2270,1389,'EM','deniselondon31@yahoo.com',0,'2013-12-25 18:46:20',NULL,NULL),(20519,13208,'EM','idelacr17@gmail.com',0,'2013-12-26 12:55:11',NULL,NULL),(14770,9662,'TE','4194765968',0,'2013-12-26 04:39:02',NULL,NULL),(4730,3027,'TE','6623797303',0,'2013-12-25 20:18:20',NULL,NULL),(2740,1662,'AP','3252347668',0,'2013-12-25 18:53:39',NULL,NULL),(2775,1681,'TE','9857101479',0,'2013-12-25 18:54:10',NULL,NULL),(10320,6731,'EM','clwaltz@live.com',0,'2013-12-26 01:15:30',NULL,NULL),(24617,15875,'EM','lielos10@gmail.com',0,'2014-01-03 02:05:14',NULL,NULL),(29860,19319,'AP','9562575136',1,'2014-01-22 03:22:10',NULL,NULL),(31635,20637,'EM','fnuno81@gmail.com',0,'2014-01-30 21:00:32',NULL,NULL),(34102,22351,'AP','5043521734',0,'2014-02-10 21:00:04',NULL,NULL),(38493,25438,'TE','2816427919',0,'2014-02-25 21:31:19',NULL,NULL),(39919,26417,'AP','4693247440',0,'2014-02-28 07:30:05',NULL,NULL),(42853,28499,'AP','3306711655',0,'2014-03-07 21:31:47',NULL,NULL),(898,556,'AP','9856647170',0,'2013-12-25 17:50:10',NULL,NULL),(14055,9184,'AP','4198893730',0,'2013-12-26 04:09:16',NULL,NULL),(8661,5689,'TE','5134600782',0,'2013-12-25 23:32:33',NULL,NULL),(20466,13184,'AP','8324192299',0,'2013-12-26 12:54:25',NULL,NULL),(20946,13472,'TE','5138464187',0,'2013-12-26 13:02:03',NULL,NULL),(7410,4819,'AP','5133787802',0,'2013-12-25 22:17:02',NULL,NULL),(22121,14249,'EM','candelariovgutierrez@yahoo.com',0,'2013-12-27 02:05:28',NULL,NULL),(22945,14802,'EM','ryanmhohman@gmail.com',1,'2013-12-29 11:13:47',NULL,NULL),(23251,14982,'EM','marilynnobles@ymail.com',0,'2014-01-01 12:01:08',NULL,NULL),(32238,21055,'EM','jenniferjoycethomas@gmail.com',0,'2014-02-02 19:00:08',NULL,NULL),(38103,25152,'TE','9156944276',0,'2014-02-21 22:00:17',NULL,NULL),(38381,25353,'AP','5133355855',0,'2014-02-25 21:30:33',NULL,NULL),(698,432,'EM','bamonroe2@gmail.com',0,'2013-12-25 17:46:58',NULL,NULL),(25188,16240,'EM','whitneyc06@yahoo.com',0,'2014-01-05 00:02:22',NULL,NULL),(25013,16119,'TE','5043907107',0,'2014-01-04 02:05:21',NULL,NULL),(24774,15982,'TE','9035759730',0,'2014-01-04 02:00:59',NULL,NULL),(7758,5064,'AP','9404561504',0,'2013-12-25 23:00:32',NULL,NULL),(9994,6540,'TE','9406963476',0,'2013-12-26 00:51:54',NULL,NULL),(7251,4726,'AP','5673950650',0,'2013-12-25 22:09:03',NULL,NULL),(14857,9721,'AP','4405033663',0,'2013-12-26 04:45:28',NULL,NULL),(20674,13295,'TE','7138588151',0,'2013-12-26 12:57:35',NULL,NULL),(1845,1141,'TE','2252880881',0,'2013-12-25 18:18:20',NULL,NULL),(6604,4265,'AP','5672041369',0,'2013-12-25 21:51:38',NULL,NULL),(28850,18632,'TE','9153559448',0,'2014-01-17 03:35:02',NULL,NULL),(29380,18986,'BN','6469263372',0,'2014-01-20 08:06:09',NULL,NULL),(30101,19499,'AP','3304640656',0,'2014-01-23 03:02:10',NULL,NULL),(30447,19739,'TE','3375781094',0,'2014-01-23 21:01:10',NULL,NULL),(34725,22771,'TE','9373041534',0,'2014-02-11 21:01:38',NULL,NULL),(36032,23698,'EM','danmccarthy1965@gmail.com',0,'2014-02-14 21:30:41',NULL,NULL),(39339,26023,'TE','3615581033',0,'2014-02-26 21:02:16',NULL,NULL),(40494,26875,'AP','4192303345',0,'2014-03-01 21:01:06',NULL,NULL),(6642,4303,'EM','tomdmartin@ymail.com',0,'2013-12-25 21:52:25',NULL,NULL),(25536,16473,'TE','3306010343',0,'2014-01-07 04:06:01',NULL,NULL),(9043,5933,'TE','2257568702',0,'2013-12-25 23:50:34',NULL,NULL),(9220,6034,'AP','7135917052',0,'2013-12-26 00:01:13',NULL,NULL),(7794,5087,'AP','9363910588',0,'2013-12-25 23:01:06',NULL,NULL),(6094,3924,'TE','9373932124',0,'2013-12-25 21:37:27',NULL,NULL),(9923,6495,'TE','3308076450',0,'2013-12-26 00:50:41',NULL,NULL),(10274,6709,'EM','beinsobad@live.com',0,'2013-12-26 01:02:11',NULL,NULL),(10763,6997,'EM','dml532003@yahoo.com',0,'2013-12-26 01:48:10',NULL,NULL),(6327,4079,'EM','mike@gogingo.com',0,'2013-12-25 21:47:09',NULL,NULL),(20885,13430,'AP','5136083512',0,'2013-12-26 13:01:01',NULL,NULL),(23801,15352,'AP','3309071705',1,'2014-01-02 04:24:35',NULL,NULL),(29089,18786,'AP','4199537841',0,'2014-01-17 03:35:55',NULL,NULL),(29130,18816,'EM','jgc19832009@hotmail.com',0,'2014-01-17 03:36:04',NULL,NULL),(33379,21871,'TE','4192963063',0,'2014-02-06 21:01:25',NULL,NULL),(34007,22307,'AP','7696106997',0,'2014-02-10 11:00:41',NULL,NULL),(34286,22494,'TE','4193188787',0,'2014-02-10 21:31:10',NULL,NULL),(34498,22631,'AP','2142588748',0,'2014-02-11 21:00:17',NULL,NULL),(34975,22963,'TE','6143525610',0,'2014-02-12 21:00:11',NULL,NULL),(36506,24034,'AP','5138857967',0,'2014-02-15 22:00:55',NULL,NULL),(36816,24241,'EM','sextonj1@hotmail.com',0,'2014-02-16 19:00:40',NULL,NULL),(9564,6264,'TE','8323174853',0,'2013-12-26 00:32:20',NULL,NULL),(9731,6368,'AP','5136495868',0,'2013-12-26 00:47:34',NULL,NULL),(13561,8842,'TE','5127759875',0,'2013-12-26 04:00:47',NULL,NULL),(11985,7808,'TE','5129544755',0,'2013-12-26 03:03:52',NULL,NULL),(27530,17738,'TE','3303251861',0,'2014-01-14 01:33:22',NULL,NULL),(31736,20712,'TE','2256158195',0,'2014-01-30 21:01:09',NULL,NULL),(33258,21779,'TE','5136803309',0,'2014-02-06 21:00:37',NULL,NULL),(33842,22217,'TE','3379362061',0,'2014-02-09 19:00:24',NULL,NULL),(34258,22470,'AP','2103647116',0,'2014-02-10 21:30:58',NULL,NULL),(37375,24606,'AP','5135041274',0,'2014-02-20 04:13:35',NULL,NULL),(41073,27285,'TE','8329219737',0,'2014-03-04 21:00:25',NULL,NULL),(42176,28015,'EM','aewinans8@gmail.com',0,'2014-03-06 21:01:18',NULL,NULL),(42320,28103,'TE','3307848548',0,'2014-03-06 21:02:11',NULL,NULL),(26010,16755,'EM','janiceprevost@gmail.com',0,'2014-01-08 18:24:56',NULL,NULL),(25816,16642,'TE','3306047774',0,'2014-01-08 18:24:18',NULL,NULL),(21901,14110,'AP','5135084648',0,'2013-12-27 02:01:50',NULL,NULL),(21170,13617,'TE','5132053384',0,'2013-12-26 13:05:46',NULL,NULL),(4014,2553,'EM','johnpk_99@yahoo.com',0,'2013-12-25 19:37:20',NULL,NULL),(4682,2994,'TE','9376043293',0,'2013-12-25 20:17:31',NULL,NULL),(8056,5275,'EM','MBORES1266@GMAIL.COM',0,'2013-12-25 23:05:39',NULL,NULL),(7948,5186,'AP','5132362968',0,'2013-12-25 23:03:39',NULL,NULL),(8944,5855,'TE','9795617489',0,'2013-12-25 23:48:54',NULL,NULL),(12003,7820,'TE','8066624848',0,'2013-12-26 03:04:10',NULL,NULL),(12238,8003,'TE','5127318463',0,'2013-12-26 03:08:25',NULL,NULL),(33075,21663,'TE','5044870632',0,'2014-02-05 21:30:56',NULL,NULL),(33076,21666,'TE','3186641308',0,'2014-02-05 21:30:57',NULL,NULL),(35196,23116,'AP','3133003336',0,'2014-02-12 21:31:21',NULL,NULL),(35872,23590,'EM','sarahthomas3699@hotmail.com',0,'2014-02-13 22:03:02',NULL,NULL),(38450,25408,'EM','BACARI4@HOTMAIL.COM',0,'2014-02-25 21:31:01',NULL,NULL),(38643,25539,'AP','5133641467',0,'2014-02-26 08:00:10',NULL,NULL),(39798,26311,'EM','marci_garza91@yahoo.com',0,'2014-02-28 06:31:34',NULL,NULL),(39890,26397,'AP','3302420092',0,'2014-02-28 07:00:29',NULL,NULL),(41441,27531,'BN','3305923026',0,'2014-03-04 21:02:47',NULL,NULL),(23770,15330,'AP','9155002910',1,'2014-01-02 04:23:55',NULL,NULL),(23453,15115,'EM','joey101751@att.net',0,'2014-01-01 12:05:07',NULL,NULL),(1594,983,'TE','2165389675',0,'2013-12-25 18:10:22',NULL,NULL),(9483,6206,'TE','4197730331',0,'2013-12-26 00:30:45',NULL,NULL),(23273,14993,'EM','kspruiell@gmail.com',0,'2014-01-01 12:01:30',NULL,NULL),(2985,1847,'EM','JDKLINESMITH@GMAIL.COM',0,'2013-12-25 18:57:49',NULL,NULL),(22999,14835,'AP','4195615779',1,'2013-12-29 11:14:41',NULL,NULL),(13564,8844,'TE','9155986524',0,'2013-12-26 04:00:50',NULL,NULL),(13695,8928,'EM','Ksonek@woh.rr.com',0,'2013-12-26 04:02:57',NULL,NULL),(28461,18339,'EM','rbourn2429@att.net',0,'2014-01-16 08:45:17',NULL,NULL),(30084,19490,'TE','4403611545',0,'2014-01-23 03:02:06',NULL,NULL),(30435,19730,'AP','5049943574',0,'2014-01-23 21:01:05',NULL,NULL),(32154,21003,'TE','9858671386',0,'2014-02-01 19:00:30',NULL,NULL),(35369,23240,'TE','4197889534',0,'2014-02-12 21:32:31',NULL,NULL),(35521,23362,'AP','3303100781',0,'2014-02-13 22:00:47',NULL,NULL),(35801,23541,'AP','5046067704',0,'2014-02-13 22:02:33',NULL,NULL),(39625,26206,'AP','2167731774',0,'2014-02-28 06:30:51',NULL,NULL),(39700,26254,'TE','9565021221',0,'2014-02-28 06:31:10',NULL,NULL),(42190,28026,'TE','9374759173',0,'2014-03-06 21:01:24',NULL,NULL),(43775,29059,'EM','gwatson667@gmail.com',0,'2014-03-10 21:01:51',NULL,NULL),(691,429,'TE','2164088279',0,'2013-12-25 17:46:52',NULL,NULL),(21582,13880,'AP','4406675405',0,'2013-12-26 13:13:17',NULL,NULL),(26154,16839,'TE','3308364240',0,'2014-01-13 02:18:32',NULL,NULL),(7161,4671,'AP','3377895545',0,'2013-12-25 22:07:37',NULL,NULL),(1167,717,'TE','4196058629',0,'2013-12-25 18:03:21',NULL,NULL),(21227,13647,'TE','2252413724',0,'2013-12-26 13:07:11',NULL,NULL),(1579,975,'TE','5044913683',0,'2013-12-25 18:10:07',NULL,NULL),(2481,1520,'EM','ddanner3320@outlook.com',0,'2013-12-25 18:49:47',NULL,NULL),(10618,6908,'TE','5044865186',0,'2013-12-26 01:45:50',NULL,NULL),(21048,13540,'TE','3183472608',0,'2013-12-26 13:03:45',NULL,NULL),(21000,13513,'TE','9047188734',0,'2013-12-26 13:02:58',NULL,NULL),(11843,7705,'AP','9372183402',0,'2013-12-26 03:01:22',NULL,NULL),(20736,13328,'TE','9565141177',0,'2013-12-26 12:58:32',NULL,NULL),(12235,7998,'TE','3303658843',0,'2013-12-26 03:08:20',NULL,NULL),(12401,8121,'TE','9377370039',0,'2013-12-26 03:15:16',NULL,NULL),(13936,9089,'AP','9372877600',0,'2013-12-26 04:07:02',NULL,NULL),(29228,18878,'AP','3375649192',0,'2014-01-17 03:36:27',NULL,NULL),(30207,19567,'AP','5043456792',0,'2014-01-23 03:02:36',NULL,NULL),(31724,20703,'TE','2256544404',0,'2014-01-30 21:01:05',NULL,NULL),(32726,21409,'TE','3304799394',0,'2014-02-04 21:01:07',NULL,NULL),(38515,25453,'TE','8066475592',0,'2014-02-25 21:31:27',NULL,NULL),(40338,26770,'TE','9374784081',0,'2014-03-01 21:00:08',NULL,NULL),(13970,9110,'TE','9374321954',0,'2013-12-26 04:07:34',NULL,NULL),(20825,13385,'EM','artemis.the.hunter16@gmail.com',0,'2013-12-26 13:00:00',NULL,NULL),(22576,14559,'AP','3309491219',0,'2013-12-28 03:35:15',NULL,NULL),(23054,14871,'TE','8062444092',0,'2013-12-30 00:00:14',NULL,NULL),(24869,16037,'TE','5043279010',0,'2014-01-04 02:02:42',NULL,NULL),(13751,8962,'AP','9372662135',0,'2013-12-26 04:03:53',NULL,NULL),(10036,6566,'TE','5126671069',0,'2013-12-26 00:52:32',NULL,NULL),(757,475,'AP','3182682039',0,'2013-12-25 17:48:00',NULL,NULL),(6735,4374,'EM','hmasonmd@hushmail.com',0,'2013-12-25 22:00:25',NULL,NULL),(4723,3023,'TE','3307019374',0,'2013-12-25 20:18:13',NULL,NULL),(3957,2513,'TE','9016287228',0,'2013-12-25 19:36:21',NULL,NULL),(8316,5450,'EM','JJMartin424@yahoo.com',0,'2013-12-25 23:10:10',NULL,NULL),(30678,19926,'TE','6018545294',0,'2014-01-24 21:01:06',NULL,NULL),(32170,21015,'TE','3309582347',0,'2014-02-01 19:00:36',NULL,NULL),(32658,21359,'AP','4695866851',0,'2014-02-04 21:00:42',NULL,NULL),(34052,22326,'AP','9855079757',0,'2014-02-10 11:00:57',NULL,NULL),(37126,24440,'AP','4197718476',0,'2014-02-18 22:01:19',NULL,NULL),(38650,25543,'TE','2163333596',0,'2014-02-26 08:00:13',NULL,NULL),(41067,27282,'TE','9727816825',0,'2014-03-04 21:00:23',NULL,NULL),(41619,27668,'AP','2545926823',0,'2014-03-05 21:30:32',NULL,NULL),(43385,28813,'TE','3308825478',0,'2014-03-09 21:00:55',NULL,NULL),(23776,15334,'TE','4198821710',1,'2014-01-02 04:24:02',NULL,NULL),(7428,4829,'EM','trokan@zoomtown.com',0,'2013-12-25 22:17:19',NULL,NULL),(9115,5972,'EM','jacoquynrasco@gmail.com',0,'2013-12-25 23:51:40',NULL,NULL),(7541,4913,'AP','6623578518',0,'2013-12-25 22:32:10',NULL,NULL),(5792,3712,'EM','vicki@vickijcarey.com',0,'2013-12-25 21:32:14',NULL,NULL),(6053,3888,'EM','dzel42@yahoo.com',0,'2013-12-25 21:36:38',NULL,NULL),(31575,20593,'TE','2166300212',0,'2014-01-30 21:00:09',NULL,NULL),(33324,21828,'AP','2105198150',0,'2014-02-06 21:01:03',NULL,NULL),(34234,22454,'EM','richarddeleon74@gmail.com',0,'2014-02-10 21:30:48',NULL,NULL),(43680,28991,'TE','3308150706',0,'2014-03-10 21:01:14',NULL,NULL),(22461,14485,'TE','3614496680',0,'2013-12-28 03:33:22',NULL,NULL),(26886,17298,'TE','9562663751',0,'2014-01-13 02:23:37',NULL,NULL),(26721,17187,'TE','4694501374',0,'2014-01-13 02:22:16',NULL,NULL),(22418,14457,'TE','5043910079',0,'2013-12-28 03:32:40',NULL,NULL),(8866,5809,'AP','4695836873',0,'2013-12-25 23:47:44',NULL,NULL),(8833,5782,'AP','6145788309',0,'2013-12-25 23:47:05',NULL,NULL),(21023,13526,'TE','5044811631',0,'2013-12-26 13:03:21',NULL,NULL),(13675,8913,'EM','ryanjnj@gmail.com',0,'2013-12-26 04:02:38',NULL,NULL),(953,585,'EM','Aundre.Howard@yahoo.com',0,'2013-12-25 17:51:03',NULL,NULL),(12391,8114,'TE','3184471308',0,'2013-12-26 03:15:07',NULL,NULL),(5198,3341,'AP','5129471047',0,'2013-12-25 21:16:30',NULL,NULL),(5394,3451,'AP','4405069319',0,'2013-12-25 21:19:31',NULL,NULL),(28795,18583,'TE','5132817741',0,'2014-01-16 08:47:10',NULL,NULL),(30716,19957,'TE','9566246396',0,'2014-01-25 19:00:05',NULL,NULL),(40742,27074,'TE','3308658034',0,'2014-03-03 21:30:08',NULL,NULL),(42344,28121,'EM','mapark4@aol.com',0,'2014-03-06 21:02:20',NULL,NULL),(27126,17464,'TE','4196739451',0,'2014-01-13 03:01:05',NULL,NULL),(1812,1120,'EM','jwinegardner@woh.rr.com',0,'2013-12-25 18:17:48',NULL,NULL),(2892,1772,'AP','3306873549',0,'2013-12-25 18:56:08',NULL,NULL),(24379,15742,'BN','9567405543',0,'2014-01-03 02:00:53',NULL,NULL),(8293,5434,'TE','5044681881',0,'2013-12-25 23:09:45',NULL,NULL),(14745,9644,'AP','8324232304',0,'2013-12-26 04:38:35',NULL,NULL),(12454,8156,'TE','3309233643',0,'2013-12-26 03:16:11',NULL,NULL),(6181,3983,'AP','5134057775',0,'2013-12-25 21:38:53',NULL,NULL),(11077,7194,'EM','jonesm44221@gmail.com',0,'2013-12-26 02:00:30',NULL,NULL),(27804,17919,'EM','michellearaiza@gmail.com',0,'2014-01-15 02:06:30',NULL,NULL),(28595,18432,'AP','5042925330',0,'2014-01-16 08:45:59',NULL,NULL),(35855,23576,'AP','4195096968',0,'2014-02-13 22:02:54',NULL,NULL),(35976,23670,'EM','sarah.lynn.mendoza@gmail.com',0,'2014-02-14 21:30:24',NULL,NULL),(38736,25607,'AP','8326816280',0,'2014-02-26 08:30:06',NULL,NULL),(38867,25688,'EM','jsingleton043@gmail.com',0,'2014-02-26 09:30:10',NULL,NULL),(39274,25985,'EM','jsm@mcknightla.com',0,'2014-02-26 21:01:54',NULL,NULL),(40259,26708,'EM','JERRYLESLIE3@FUSE.NET',0,'2014-02-28 21:31:37',NULL,NULL),(40701,27037,'TE','9034662784',0,'2014-03-03 21:00:19',NULL,NULL),(41369,27482,'AP','8179381792',0,'2014-03-04 21:02:18',NULL,NULL),(42209,28040,'EM','dcstepteau@yahoo.com',0,'2014-03-06 21:01:31',NULL,NULL),(42784,28454,'TE','2252437328',0,'2014-03-07 21:31:22',NULL,NULL),(23854,15390,'TE','3306440019',1,'2014-01-02 04:25:43',NULL,NULL),(25969,16726,'AP','3302618463',0,'2014-01-08 18:24:48',NULL,NULL),(23806,15354,'TE','3307385662',1,'2014-01-02 04:24:40',NULL,NULL),(9434,6175,'TE','9374425707',0,'2013-12-26 00:17:10',NULL,NULL),(9177,6006,'AP','4197331046',0,'2013-12-26 00:00:30',NULL,NULL),(8764,5744,'TE','2259363831',0,'2013-12-25 23:46:02',NULL,NULL),(3054,1899,'EM','rockygb61@gmail.com',0,'2013-12-25 18:59:05',NULL,NULL),(8657,5687,'AP','4403828256',0,'2013-12-25 23:32:30',NULL,NULL),(8468,5572,'AP','9372588571',0,'2013-12-25 23:16:42',NULL,NULL),(8401,5529,'TE','3306717566',0,'2013-12-25 23:15:31',NULL,NULL),(4869,3116,'TE','3147996879',0,'2013-12-25 20:30:11',NULL,NULL),(21539,13847,'AP','3303287603',0,'2013-12-26 13:12:30',NULL,NULL),(11863,7723,'TE','9392182932',0,'2013-12-26 03:01:47',NULL,NULL),(11060,7182,'TE','9372841549',0,'2013-12-26 02:00:15',NULL,NULL),(29482,19056,'TE','6019425406',0,'2014-01-21 08:44:12',NULL,NULL),(31487,20518,'AP','8179130533',0,'2014-01-29 21:01:23',NULL,NULL),(31991,20887,'AP','5133767751',0,'2014-01-31 21:01:12',NULL,NULL),(32147,20996,'TE','7402130521',0,'2014-02-01 19:00:27',NULL,NULL),(32301,21097,'AP','9375201108',0,'2014-02-02 19:00:32',NULL,NULL),(33958,22281,'TE','3304754135',0,'2014-02-10 11:00:22',NULL,NULL),(37244,24508,'TE','8328837945',0,'2014-02-20 03:52:18',NULL,NULL),(37519,24707,'AP','4695701993',0,'2014-02-20 04:35:33',NULL,NULL),(38624,25529,'TE','2283663427',0,'2014-02-26 08:00:04',NULL,NULL),(39015,25799,'TE','5134219367',0,'2014-02-26 21:00:15',NULL,NULL),(42255,28066,'TE','5133156270',0,'2014-03-06 21:01:47',NULL,NULL),(43431,28844,'TE','3306343856',0,'2014-03-09 21:01:14',NULL,NULL),(3210,2016,'AP','3309077060',0,'2013-12-25 19:02:39',NULL,NULL),(26382,16981,'EM','g1denny@gmail.com',0,'2014-01-13 02:20:19',NULL,NULL),(25605,16517,'AP','2542052335',1,'2014-01-07 10:21:33',NULL,NULL),(25056,16153,'TE','4133012424',0,'2014-01-04 02:06:19',NULL,NULL),(8404,5531,'EM','333bulls@gmail.com',0,'2013-12-25 23:15:35',NULL,NULL),(23646,15270,'EM','wmfowlkes3@live.com',1,'2014-01-02 04:21:47',NULL,NULL),(23472,15137,'TE','5136252584',0,'2014-01-01 12:05:38',NULL,NULL),(3016,1876,'TE','3307731134',0,'2013-12-25 18:58:25',NULL,NULL),(20313,13091,'TE','3308054373',0,'2013-12-26 12:51:52',NULL,NULL),(11394,7417,'AP','5136681694',0,'2013-12-26 02:16:54',NULL,NULL),(5846,3752,'TE','9569298695',0,'2013-12-25 21:33:11',NULL,NULL),(5283,3389,'AP','7185018682',0,'2013-12-25 21:17:47',NULL,NULL),(40281,26719,'EM','roshandas78@gmail.com',0,'2014-02-28 21:31:43',NULL,NULL),(42083,27961,'AP','3182720406',0,'2014-03-06 21:00:45',NULL,NULL),(42214,28045,'TE','9859741154',0,'2014-03-06 21:01:34',NULL,NULL),(43179,28694,'TE','2253850685',0,'2014-03-08 21:31:05',NULL,NULL),(26012,16757,'TE','4195180816',0,'2014-01-08 18:24:57',NULL,NULL),(10148,6634,'TE','5133286413',0,'2013-12-26 01:00:06',NULL,NULL),(1199,730,'AP','5129218444',0,'2013-12-25 18:03:47',NULL,NULL),(1859,1148,'AP','2254853905',0,'2013-12-25 18:18:33',NULL,NULL),(1985,1226,'EM','N2RIG@AOL.COM',0,'2013-12-25 18:20:34',NULL,NULL),(8638,5674,'TE','4404291242',0,'2013-12-25 23:32:08',NULL,NULL),(22774,14683,'AP','6143708858',1,'2013-12-29 11:08:38',NULL,NULL),(21695,13969,'TE','4193490245',0,'2013-12-26 13:15:21',NULL,NULL),(24565,15845,'TE','6143576764',0,'2014-01-03 02:04:17',NULL,NULL),(6609,4269,'TE','5672041369',0,'2013-12-25 21:51:43',NULL,NULL),(24446,15782,'TE','9797740709',0,'2014-01-03 02:02:10',NULL,NULL),(2843,1727,'TE','5133930571',0,'2013-12-25 18:55:18',NULL,NULL),(12247,8007,'AP','8067909437',0,'2013-12-26 03:08:33',NULL,NULL),(29620,19135,'EM','jkpe3000@yahoo.com',0,'2014-01-21 08:45:27',NULL,NULL),(31599,20612,'EM','reneechiles@yahoo.com',0,'2014-01-30 21:00:18',NULL,NULL),(32332,21120,'AP','9152041558',0,'2014-02-03 21:00:12',NULL,NULL),(34133,22378,'EM','NEILLKL11@GMAIL.COM',0,'2014-02-10 21:30:08',NULL,NULL),(34280,22491,'EM','VLFREEMAN03@ATT.NET',0,'2014-02-10 21:31:08',NULL,NULL),(35484,23334,'TE','5133786391',0,'2014-02-13 22:00:33',NULL,NULL),(36422,23989,'EM','jmonk306@hotmail.com',0,'2014-02-15 22:00:25',NULL,NULL),(40565,26926,'TE','7402746222',0,'2014-03-03 01:00:17',NULL,NULL),(40795,27112,'AP','6145586374',0,'2014-03-03 21:30:27',NULL,NULL),(41837,27817,'AP','7408048028',0,'2014-03-05 21:31:54',NULL,NULL),(21520,13835,'TE','3305294433',0,'2013-12-26 13:12:10',NULL,NULL),(26938,17325,'EM','Cmizblue@yahoo.com',0,'2014-01-13 02:23:54',NULL,NULL),(555,345,'AP','2169782843',0,'2013-12-25 17:32:05',NULL,NULL),(1236,753,'TE','6824297848',0,'2013-12-25 18:04:21',NULL,NULL),(21060,13545,'AP','2203057148',0,'2013-12-26 13:03:55',NULL,NULL),(7896,5145,'TE','9374370333',0,'2013-12-25 23:02:40',NULL,NULL),(1760,1085,'EM','rctidinoh@gmail.com',0,'2013-12-25 18:16:53',NULL,NULL),(20337,13103,'EM','timhiser@roadrunner.com',0,'2013-12-26 12:52:13',NULL,NULL),(14758,9651,'EM','rharsh1968@yahoo.com',0,'2013-12-26 04:38:48',NULL,NULL),(2992,1851,'EM','kristigooch@yahoo.com',0,'2013-12-25 18:57:56',NULL,NULL),(12449,8154,'TE','5125571812',0,'2013-12-26 03:16:08',NULL,NULL),(11995,7813,'EM','SCOTT@SCOTTBIRAM.COM',0,'2013-12-26 03:04:01',NULL,NULL),(5338,3420,'EM','brownatural@me.com',0,'2013-12-25 21:18:38',NULL,NULL),(10599,6898,'TE','9852646444',0,'2013-12-26 01:45:33',NULL,NULL),(29541,19092,'EM','jjcook92@yahoo.com',0,'2014-01-21 08:44:33',NULL,NULL),(34612,22695,'AP','8178631407',0,'2014-02-11 21:00:55',NULL,NULL),(34767,22801,'EM','beshah@ohio.edu',0,'2014-02-11 21:01:53',NULL,NULL),(34816,22837,'TE','2342009978',0,'2014-02-11 21:02:11',NULL,NULL),(42433,28183,'AP','5135461992',0,'2014-03-06 21:02:55',NULL,NULL),(23062,14874,'EM','spyresa@msn.com',0,'2013-12-30 00:00:20',NULL,NULL),(26192,16859,'EM','olvera_jonathan25@yahoo.com',0,'2014-01-13 02:19:09',NULL,NULL),(21908,14114,'EM','ainfos@aol.com',0,'2013-12-27 02:01:56',NULL,NULL),(11053,7177,'EM','ericadingus@att.net',0,'2013-12-26 02:00:07',NULL,NULL),(5989,3848,'TE','3187949980',0,'2013-12-25 21:35:33',NULL,NULL),(24651,15894,'AP','3308586636',0,'2014-01-03 02:05:51',NULL,NULL),(6277,4049,'TE','4407141821',0,'2013-12-25 21:46:20',NULL,NULL),(23844,15384,'TE','3304143243',1,'2014-01-02 04:25:32',NULL,NULL),(23719,15306,'TE','3185729278',1,'2014-01-02 04:23:02',NULL,NULL),(23138,14919,'TE','2346000651',0,'2013-12-30 00:01:37',NULL,NULL),(8021,5242,'AP','3302895231',0,'2013-12-25 23:04:57',NULL,NULL),(3687,2339,'TE','9562378983',0,'2013-12-25 19:31:54',NULL,NULL),(27560,17762,'TE','5135532232',0,'2014-01-14 01:33:34',NULL,NULL),(29137,18822,'TE','6014478606',0,'2014-01-17 03:36:06',NULL,NULL),(30966,20141,'EM','jadeus13@yahoo.com',0,'2014-01-27 21:00:59',NULL,NULL),(32950,21572,'AP','3307856060',0,'2014-02-05 21:30:21',NULL,NULL),(32957,21575,'AP','3304315879',0,'2014-02-05 21:30:23',NULL,NULL),(34231,22453,'AP','9152526516',0,'2014-02-10 21:30:48',NULL,NULL),(38670,25558,'EM','pondman1023@aol.com',0,'2014-02-26 08:00:22',NULL,NULL),(40208,26669,'AP','2255724425',0,'2014-02-28 21:31:17',NULL,NULL),(42009,27923,'AP','8062817938',0,'2014-03-06 21:00:21',NULL,NULL),(42261,28069,'TE','3305455178',0,'2014-03-06 21:01:49',NULL,NULL),(43604,28949,'TE','9852292428',0,'2014-03-10 21:00:49',NULL,NULL),(1401,857,'TE','4196576940',0,'2013-12-25 18:07:03',NULL,NULL),(23720,15307,'TE','8323734673',1,'2014-01-02 04:23:04',NULL,NULL),(1407,859,'AP','4193020851',0,'2013-12-25 18:07:07',NULL,NULL),(21785,14037,'TE','9373862910',0,'2013-12-26 13:17:04',NULL,NULL),(12312,8050,'EM','PHOENIXCD1@GMAIL.COM',0,'2013-12-26 03:09:41',NULL,NULL),(8974,5883,'AP','4404877868',0,'2013-12-25 23:49:29',NULL,NULL),(29795,19271,'TE','2254454848',0,'2014-01-21 08:46:54',NULL,NULL),(30427,19725,'TE','7082184431',0,'2014-01-23 21:01:00',NULL,NULL),(31132,20274,'TE','3307995321',0,'2014-01-28 21:00:26',NULL,NULL),(31149,20287,'AP','9853819004',0,'2014-01-28 21:00:33',NULL,NULL),(32433,21192,'BN','2283635155',0,'2014-02-03 21:00:49',NULL,NULL),(35185,23111,'AP','4158191968',0,'2014-02-12 21:31:17',NULL,NULL),(35960,23656,'AP','3253389217',0,'2014-02-14 21:30:17',NULL,NULL),(40221,26679,'TE','2253310639',0,'2014-02-28 21:31:22',NULL,NULL),(43344,28791,'TE','2817365448',0,'2014-03-09 21:00:42',NULL,NULL),(13,8,'AP','4408978449',0,'2013-12-25 17:15:14',NULL,NULL),(27863,17954,'EM','clperez8541@yahoo.com',0,'2014-01-15 02:06:43',NULL,NULL),(8358,5494,'AP','4194107048',0,'2013-12-25 23:11:07',NULL,NULL),(24953,16083,'AP','3305091758',0,'2014-01-04 02:04:11',NULL,NULL),(23997,15489,'AP','5134841214',1,'2014-01-02 04:29:27',NULL,NULL),(23768,15329,'EM','AECAGLIA@AOL.COM',1,'2014-01-02 04:23:52',NULL,NULL),(8650,5682,'EM','Antwon.whitaker33@gmail.com',0,'2013-12-25 23:32:22',NULL,NULL),(9094,5959,'TE','4198433674',0,'2013-12-25 23:51:21',NULL,NULL),(14878,9738,'TE','9369674295',0,'2013-12-26 04:45:51',NULL,NULL),(11476,7465,'TE','6013913058',0,'2013-12-26 02:31:01',NULL,NULL),(1157,709,'EM','badams@kaplantel.net',0,'2013-12-25 18:03:09',NULL,NULL),(10287,6715,'TE','5672252080',0,'2013-12-26 01:02:24',NULL,NULL),(2274,1394,'TE','5043515582',0,'2013-12-25 18:46:27',NULL,NULL),(6067,3904,'EM','RCDAMOOMEY@ROADRUNNER.COM',0,'2013-12-25 21:36:56',NULL,NULL),(6093,3922,'AP','9377280525',0,'2013-12-25 21:37:25',NULL,NULL),(28152,18147,'TE','9855181159',0,'2014-01-15 02:07:49',NULL,NULL),(29134,18819,'TE','5137932152',0,'2014-01-17 03:36:05',NULL,NULL),(30095,19497,'AP','3309044907',0,'2014-01-23 03:02:09',NULL,NULL),(34119,22371,'AP','9729041696',0,'2014-02-10 21:00:13',NULL,NULL),(34131,22377,'EM','athomas2058@gmail.com',0,'2014-02-10 21:30:07',NULL,NULL),(36905,24304,'TE','3306067567',0,'2014-02-18 21:30:22',NULL,NULL),(37991,25062,'AP','7405343559',0,'2014-02-20 22:01:24',NULL,NULL),(41748,27762,'EM','dpopovich19@gmail.com',0,'2014-03-05 21:31:21',NULL,NULL),(3170,1987,'TE','8176816774',0,'2013-12-25 19:01:52',NULL,NULL),(26448,17022,'EM','cmiddlecoop66@yahoo.com',0,'2014-01-13 02:20:41',NULL,NULL),(23024,14851,'TE','3307141148',1,'2013-12-29 11:15:06',NULL,NULL),(22969,14814,'EM','jarrodhebert90@gmail.com',1,'2013-12-29 11:14:10',NULL,NULL),(4167,2658,'EM','ellinakhramova@gmail.com',0,'2013-12-25 19:46:48',NULL,NULL),(10367,6757,'TE','3308991681',0,'2013-12-26 01:16:16',NULL,NULL),(21314,13692,'TE','3308565740',0,'2013-12-26 13:08:30',NULL,NULL),(20774,13349,'TE','2104830832',0,'2013-12-26 12:59:09',NULL,NULL),(11535,7508,'TE','5044132223',0,'2013-12-26 02:32:02',NULL,NULL),(14399,9414,'AP','8176737938',0,'2013-12-26 04:32:57',NULL,NULL),(29552,19097,'AP','4408656885',0,'2014-01-21 08:44:36',NULL,NULL),(29980,19401,'EM','ebethanna@gmail.com',1,'2014-01-22 03:22:53',NULL,NULL),(30261,19601,'EM','thesporleders@toast.net',0,'2014-01-23 03:02:48',NULL,NULL),(32628,21331,'BN','9402300093',0,'2014-02-04 21:00:29',NULL,NULL),(36226,23843,'TE','4194471212',0,'2014-02-14 21:31:53',NULL,NULL),(84,49,'EM','Mputerka@gmail.com',0,'2013-12-25 17:16:21',NULL,NULL),(26921,17317,'TE','2103233261',0,'2014-01-13 02:23:48',NULL,NULL),(10265,6706,'AP','6065842041',0,'2013-12-26 01:02:04',NULL,NULL),(2047,1268,'AP','2103070664',0,'2013-12-25 18:30:10',NULL,NULL),(27672,17837,'AP','7405059694',0,'2014-01-15 02:06:02',NULL,NULL),(5966,3830,'AP','3302086027',0,'2013-12-25 21:35:10',NULL,NULL),(25678,16554,'TE','3373036581',1,'2014-01-07 10:22:50',NULL,NULL),(25300,16313,'EM','chazzleefontenot@gmail.com',0,'2014-01-07 04:01:30',NULL,NULL),(23565,15212,'EM','arquinter1@hotmail.com',0,'2014-01-01 12:07:44',NULL,NULL),(22924,14791,'TE','2165136699',1,'2013-12-29 11:13:31',NULL,NULL),(11647,7581,'TE','4197547166',0,'2013-12-26 02:33:56',NULL,NULL),(21030,13531,'TE','5043019708',0,'2013-12-26 13:03:28',NULL,NULL),(28448,18331,'TE','4403273649',0,'2014-01-16 08:45:12',NULL,NULL),(30088,19494,'TE','4409699836',0,'2014-01-23 03:02:07',NULL,NULL),(30707,19948,'EM','RohrerMaryEllen@gmail.com',0,'2014-01-24 21:01:20',NULL,NULL),(30789,20018,'EM','karenlsteeves@yahoo.com',0,'2014-01-26 19:00:13',NULL,NULL),(33118,21693,'EM','jlgoblue@bex.net',0,'2014-02-05 21:31:07',NULL,NULL),(36287,23891,'AP','9374811597',0,'2014-02-14 21:32:18',NULL,NULL),(38769,25632,'EM','GILLJL1@HOTMAIL.COM',0,'2014-02-26 08:30:24',NULL,NULL),(40498,26877,'TE','3307228304',0,'2014-03-01 21:01:07',NULL,NULL),(41740,27755,'AP','5042488703',0,'2014-03-05 21:31:18',NULL,NULL),(42582,28334,'TE','3107707153',0,'2014-03-07 21:30:12',NULL,NULL),(2041,1264,'TE','2542051106',0,'2013-12-25 18:30:05',NULL,NULL),(3323,2090,'TE','2252768135',0,'2013-12-25 19:16:52',NULL,NULL),(23130,14908,'AP','2163856019',0,'2013-12-30 00:01:23',NULL,NULL),(25462,16418,'AP','9372072955',0,'2014-01-07 04:04:27',NULL,NULL),(8721,5722,'TE','4123433775',0,'2013-12-25 23:45:26',NULL,NULL),(11462,7456,'TE','4402591889',0,'2013-12-26 02:30:46',NULL,NULL),(28603,18436,'TE','5042670227',0,'2014-01-16 08:46:01',NULL,NULL),(29819,19293,'TE','5043439802',1,'2014-01-22 03:21:56',NULL,NULL),(30191,19558,'TE','9855163434',0,'2014-01-23 03:02:32',NULL,NULL),(32225,21047,'EM','gilbert.gil@zianet.com',0,'2014-02-02 19:00:04',NULL,NULL),(34340,22529,'AP','3309991963',0,'2014-02-10 21:31:30',NULL,NULL),(34685,22746,'TE','5132550816',0,'2014-02-11 21:01:23',NULL,NULL),(37242,24506,'EM','tjs6677@gmail.com',0,'2014-02-20 03:51:24',NULL,NULL),(37831,24962,'TE','3187247367',0,'2014-02-20 22:00:20',NULL,NULL),(39627,26207,'TE','3307631370',0,'2014-02-28 06:30:52',NULL,NULL),(39885,26389,'EM','K.reagan724@gmail.com',0,'2014-02-28 07:00:25',NULL,NULL),(42289,28082,'TE','9037527015',0,'2014-03-06 21:01:58',NULL,NULL),(23426,15093,'TE','9375461204',0,'2014-01-01 12:04:30',NULL,NULL),(23111,14900,'AP','3308055684',0,'2013-12-30 00:01:06',NULL,NULL),(22670,14616,'AP','5674298580',0,'2013-12-28 03:36:49',NULL,NULL),(14107,9224,'EM','Joellacarolgrove@icloud.com',0,'2013-12-26 04:10:18',NULL,NULL),(13869,9043,'EM','mflower15@aim.com',0,'2013-12-26 04:05:53',NULL,NULL),(4258,2723,'AP','5045541144',0,'2013-12-25 19:48:16',NULL,NULL),(9376,6136,'EM','honey1bear2@yahoo.com',0,'2013-12-26 00:16:09',NULL,NULL),(6788,4402,'AP','4192904693',0,'2013-12-25 22:01:12',NULL,NULL),(2802,1697,'AP','4192836039',0,'2013-12-25 18:54:36',NULL,NULL),(30955,20135,'BN','2168545176',0,'2014-01-27 21:00:54',NULL,NULL),(31807,20767,'EM','Revquincy@aol.com',0,'2014-01-30 21:01:38',NULL,NULL),(35561,23384,'AP','3205753393',0,'2014-02-13 22:01:02',NULL,NULL),(38842,25677,'TE','5124611421',0,'2014-02-26 08:30:56',NULL,NULL),(39595,26193,'AP','4196315888',0,'2014-02-28 06:30:45',NULL,NULL),(39722,26272,'EM','kimcat_99@yahoo.com',0,'2014-02-28 06:31:16',NULL,NULL),(41680,27717,'TE','9799431040',0,'2014-03-05 21:30:56',NULL,NULL),(43135,28672,'AP','4194871183',0,'2014-03-08 21:30:50',NULL,NULL),(754,472,'AP','5672184443',0,'2013-12-25 17:47:55',NULL,NULL),(22303,14374,'TE','2169418964',0,'2013-12-28 03:30:38',NULL,NULL),(24100,15556,'TE','6615449596',1,'2014-01-02 04:31:29',NULL,NULL),(23516,15170,'TE','3306449115',0,'2014-01-01 12:06:33',NULL,NULL),(1886,1163,'AP','5043907782',0,'2013-12-25 18:18:58',NULL,NULL),(20456,13179,'TE','2818275498',0,'2013-12-26 12:54:16',NULL,NULL),(9240,6048,'AP','5133007644',0,'2013-12-26 00:01:36',NULL,NULL),(13800,8996,'EM','greg@1goal.net',0,'2013-12-26 04:04:43',NULL,NULL),(7971,5201,'EM','meier88@embarqmail.com',0,'2013-12-25 23:04:02',NULL,NULL),(11304,7367,'EM','Natyskef@hotmail.com',0,'2013-12-26 02:15:34',NULL,NULL),(6603,4265,'TE','5672041369',0,'2013-12-25 21:51:38',NULL,NULL),(30439,19732,'EM','lanettecrump@yahoo.com',0,'2014-01-23 21:01:06',NULL,NULL),(31871,20804,'EM','nnolimb@yahoo.com',0,'2014-01-31 21:00:24',NULL,NULL),(32189,21025,'TE','2288615804',0,'2014-02-01 19:00:42',NULL,NULL),(32458,21206,'AP','2252064582',0,'2014-02-03 21:00:56',NULL,NULL),(32956,21575,'TE','3304315879',0,'2014-02-05 21:30:23',NULL,NULL),(33386,21876,'TE','5043437941',0,'2014-02-06 21:01:28',NULL,NULL),(34961,22952,'EM','patti_roller@yahoo.com',0,'2014-02-11 21:30:30',NULL,NULL),(35541,23372,'AP','8132400504',0,'2014-02-13 22:00:54',NULL,NULL),(40438,26845,'AP','3377819601',0,'2014-03-01 21:00:47',NULL,NULL),(42121,27983,'TE','3373099419',0,'2014-03-06 21:00:58',NULL,NULL),(42541,28303,'AP','9375091339',0,'2014-03-07 21:00:33',NULL,NULL),(43512,28892,'TE','2542131934',0,'2014-03-10 21:00:15',NULL,NULL),(43570,28934,'AP','2162724458',0,'2014-03-10 21:00:39',NULL,NULL),(9646,6311,'EM','vanamy29@yahoo.com',0,'2013-12-26 00:46:11',NULL,NULL),(951,585,'TE','2163815816',0,'2013-12-25 17:51:02',NULL,NULL),(27073,17412,'TE','9374073060',0,'2014-01-13 03:00:22',NULL,NULL),(21914,14117,'EM','TLELLIOTT03@YAHOO.COM',0,'2013-12-27 02:02:01',NULL,NULL),(21751,14010,'TE','9379441997',0,'2013-12-26 13:16:21',NULL,NULL),(21527,13839,'TE','3302062498',0,'2013-12-26 13:12:17',NULL,NULL),(21280,13672,'TE','3188721608',0,'2013-12-26 13:07:57',NULL,NULL),(1447,883,'TE','9376254350',0,'2013-12-25 18:07:47',NULL,NULL),(5750,3685,'EM','lindasaflac@yahoo.com',0,'2013-12-25 21:31:35',NULL,NULL),(6338,4086,'TE','4194814224',0,'2013-12-25 21:47:18',NULL,NULL),(28922,18673,'EM','NOEMISRIVERA@YAHOO.COM',0,'2014-01-17 03:35:17',NULL,NULL),(29290,18926,'EM','jules3639@yahoo.com',0,'2014-01-20 08:05:35',NULL,NULL),(32441,21196,'TE','6017077914',0,'2014-02-03 21:00:51',NULL,NULL),(32907,21545,'TE','3308662415',0,'2014-02-05 21:30:11',NULL,NULL),(37364,24595,'EM','TIMESCAPEMASS@HOTMAIL.COM',0,'2014-02-20 04:11:57',NULL,NULL),(39696,26251,'TE','3253004597',0,'2014-02-28 06:31:09',NULL,NULL),(39698,26252,'AP','9155991291',0,'2014-02-28 06:31:09',NULL,NULL),(40724,27064,'AP','3185507182',0,'2014-03-03 21:30:01',NULL,NULL),(41765,27771,'TE','5044738439',0,'2014-03-05 21:31:26',NULL,NULL),(43297,28766,'AP','3054944130',0,'2014-03-09 21:00:26',NULL,NULL),(4534,2882,'AP','8325701069',0,'2013-12-25 20:02:16',NULL,NULL),(27739,17883,'EM','crjohnson0311@gmail.com',0,'2014-01-15 02:06:17',NULL,NULL),(5429,3475,'TE','6144937953',0,'2013-12-25 21:20:03',NULL,NULL),(26110,16814,'EM','jandj8@comcast.net',0,'2014-01-13 02:18:18',NULL,NULL),(25044,16140,'AP','3306874193',0,'2014-01-04 02:05:59',NULL,NULL),(6110,3932,'AP','4192503495',0,'2013-12-25 21:37:41',NULL,NULL),(6306,4063,'AP','2163923958',0,'2013-12-25 21:46:45',NULL,NULL),(23716,15305,'EM','davidmossey@gmail.com',1,'2014-01-02 04:22:59',NULL,NULL),(21516,13828,'AP','3304147918',0,'2013-12-26 13:12:04',NULL,NULL),(21367,13740,'TE','3305927161',0,'2013-12-26 13:09:39',NULL,NULL),(21333,13707,'TE','3306202761',0,'2013-12-26 13:08:51',NULL,NULL),(14368,9391,'EM','fezmonkey@hotmail.com',0,'2013-12-26 04:32:22',NULL,NULL),(7751,5060,'EM','mwhite34.mw@gmail.com',0,'2013-12-25 23:00:25',NULL,NULL),(9119,5974,'TE','5134706274',0,'2013-12-25 23:51:45',NULL,NULL),(30462,19749,'TE','8179965170',0,'2014-01-23 21:01:16',NULL,NULL),(34714,22760,'EM','dinahemant@yahoo.com',0,'2014-02-11 21:01:32',NULL,NULL),(38722,25594,'AP','2818023008',0,'2014-02-26 08:00:45',NULL,NULL),(39905,26408,'EM','hirahmd260@gmail.com',0,'2014-02-28 07:00:37',NULL,NULL),(39926,26421,'EM','XCLOEX@AUSTIN.RR.COM',0,'2014-02-28 07:30:08',NULL,NULL),(40780,27102,'TE','5137370629',0,'2014-03-03 21:30:22',NULL,NULL),(28213,18187,'AP','9370844098',0,'2014-01-15 02:08:02',NULL,NULL),(27421,17660,'EM','jrbraz@att.net',0,'2014-01-14 01:32:45',NULL,NULL),(713,444,'TE','9375246777',0,'2013-12-25 17:47:15',NULL,NULL),(1662,1021,'TE','3307849762',0,'2013-12-25 18:15:15',NULL,NULL),(22023,14184,'TE','3306188930',0,'2013-12-27 02:03:48',NULL,NULL),(20530,13214,'TE','8173719806',0,'2013-12-26 12:55:21',NULL,NULL),(6425,4152,'TE','4193859360',0,'2013-12-25 21:48:47',NULL,NULL),(20216,13024,'TE','5135184988',0,'2013-12-26 12:50:10',NULL,NULL),(4224,2702,'TE','8309979575',0,'2013-12-25 19:47:44',NULL,NULL),(11959,7792,'TE','2545638519',0,'2013-12-26 03:03:26',NULL,NULL),(4660,2977,'TE','4198946778',0,'2013-12-25 20:17:09',NULL,NULL),(31601,20613,'AP','3178404011',0,'2014-01-30 21:00:19',NULL,NULL),(35700,23481,'TE','7046073996',0,'2014-02-13 22:01:55',NULL,NULL),(37928,25026,'AP','4253191438',0,'2014-02-20 22:01:00',NULL,NULL),(40716,27060,'TE','5047378427',0,'2014-03-03 21:29:59',NULL,NULL),(43133,28671,'AP','2256107749',0,'2014-03-08 21:30:49',NULL,NULL),(43751,29045,'EM','DMO012365@AOL.COM',0,'2014-03-10 21:01:43',NULL,NULL),(28463,18341,'AP','3303190742',0,'2014-01-16 08:45:17',NULL,NULL),(27839,17935,'EM','andrew@denpg.com',0,'2014-01-15 02:06:37',NULL,NULL),(10831,7033,'TE','2145878437',0,'2013-12-26 01:49:12',NULL,NULL),(9878,6459,'AP','2165363724',0,'2013-12-26 00:49:52',NULL,NULL),(23654,15273,'EM','rvf1@zips.uakron.edu',1,'2014-01-02 04:21:54',NULL,NULL),(23569,15216,'TE','9373254540',0,'2014-01-01 12:07:51',NULL,NULL),(2504,1535,'EM','BHARPER2@CINCI.RR.COM',0,'2013-12-25 18:50:08',NULL,NULL),(22413,14454,'EM','downdaroad82@yahoo.com',0,'2013-12-28 03:32:35',NULL,NULL),(21568,13869,'EM','jan@habitatofportage.org',0,'2013-12-26 13:13:00',NULL,NULL),(20706,13309,'EM','peggyalice@cableone.net',0,'2013-12-26 12:58:03',NULL,NULL),(12263,8019,'TE','9374440355',0,'2013-12-26 03:08:52',NULL,NULL),(11421,7430,'AP','4197871986',0,'2013-12-26 02:30:08',NULL,NULL),(3104,1936,'TE','3254366800',0,'2013-12-25 19:00:33',NULL,NULL),(29742,19232,'AP','2166506915',0,'2014-01-21 08:46:33',NULL,NULL),(30523,19799,'TE','9036176434',0,'2014-01-24 21:00:03',NULL,NULL),(35187,23112,'AP','6094125801',0,'2014-02-12 21:31:18',NULL,NULL),(36494,24026,'AP','4195098042',0,'2014-02-15 22:00:50',NULL,NULL),(38192,25207,'TE','2167516136',0,'2014-02-21 22:00:49',NULL,NULL),(38762,25624,'AP','2168544730',0,'2014-02-26 08:30:20',NULL,NULL),(39371,26039,'AP','3308085517',0,'2014-02-26 21:02:26',NULL,NULL),(42767,28445,'EM','jeanea.bandi@gmail.com',0,'2014-03-07 21:31:16',NULL,NULL),(1641,1008,'TE','4197226649',0,'2013-12-25 18:11:10',NULL,NULL),(6107,3931,'AP','4198227399',0,'2013-12-25 21:37:39',NULL,NULL),(6923,4510,'EM','turnerstella8@gmail.com',0,'2013-12-25 22:03:35',NULL,NULL),(26252,16895,'AP','9376380844',0,'2014-01-13 02:19:30',NULL,NULL),(24629,15882,'AP','3185643436',0,'2014-01-03 02:05:27',NULL,NULL),(23575,15219,'EM','nalanismama@hotmail.com',0,'2014-01-01 12:07:58',NULL,NULL),(20919,13451,'EM','Tford64@me.com',0,'2013-12-26 13:01:31',NULL,NULL),(29855,19316,'TE','8303132171',1,'2014-01-22 03:22:09',NULL,NULL),(32963,21579,'EM','Lesterak1@neo.rr.com',0,'2014-02-05 21:30:24',NULL,NULL),(35192,23114,'TE','6144773193',0,'2014-02-12 21:31:20',NULL,NULL),(37636,24806,'AP','6143138857',0,'2014-02-20 04:49:09',NULL,NULL),(38913,25724,'TE','5047230704',0,'2014-02-26 09:30:30',NULL,NULL),(40397,26814,'TE','9374928784',0,'2014-03-01 21:00:30',NULL,NULL),(10612,6905,'TE','2255721623',0,'2013-12-26 01:45:45',NULL,NULL),(24703,15935,'AP','6142600728',0,'2014-01-03 02:07:02',NULL,NULL),(1986,1227,'TE','3309473684',0,'2013-12-25 18:20:35',NULL,NULL),(2157,1327,'EM','AmieNEOH@aol.com',0,'2013-12-25 18:31:58',NULL,NULL),(21338,13711,'EM','maryolambert@sbcglobal.net',0,'2013-12-26 13:08:57',NULL,NULL),(14781,9672,'AP','9377283383',0,'2013-12-26 04:39:16',NULL,NULL),(14218,9303,'TE','3189381506',0,'2013-12-26 04:30:03',NULL,NULL),(12182,7958,'TE','6013711939',0,'2013-12-26 03:07:22',NULL,NULL),(3313,2084,'EM','ebc_hcare@yahoo.com',0,'2013-12-25 19:16:42',NULL,NULL),(5822,3738,'EM','mariorullan2@yahoo.com',0,'2013-12-25 21:32:48',NULL,NULL),(11326,7377,'EM','Luljeta33@hotmail.com',0,'2013-12-26 02:15:51',NULL,NULL),(28209,18181,'EM','rjohnwmoores@woh.rr.com',0,'2014-01-15 02:08:01',NULL,NULL),(28554,18412,'TE','5042517063',0,'2014-01-16 08:45:47',NULL,NULL),(30879,20071,'AP','9158736231',0,'2014-01-27 21:00:17',NULL,NULL),(37170,24468,'AP','9375413693',0,'2014-02-18 22:01:37',NULL,NULL),(38049,25111,'AP','2286239668',0,'2014-02-21 21:30:16',NULL,NULL),(39164,25904,'EM','jeremiahdunn14@gmail.com',0,'2014-02-26 21:01:10',NULL,NULL),(42922,28542,'TE','3304283539',0,'2014-03-07 21:32:15',NULL,NULL),(249,153,'EM','jisaac711@yahoo.com',0,'2013-12-25 17:18:59',NULL,NULL),(1274,774,'AP','5129638761',0,'2013-12-25 18:04:55',NULL,NULL),(8382,5517,'EM','nixonandrewj@aol.com',0,'2013-12-25 23:15:13',NULL,NULL),(6480,4192,'TE','4404288194',0,'2013-12-25 21:49:41',NULL,NULL),(11760,7655,'TE','5046218593',0,'2013-12-26 03:00:06',NULL,NULL),(13609,8869,'EM','garian1@msn.com',0,'2013-12-26 04:01:31',NULL,NULL),(12279,8032,'EM','lwinportis@hotmail.com',0,'2013-12-26 03:09:11',NULL,NULL),(12243,8006,'TE','9039462157',0,'2013-12-26 03:08:30',NULL,NULL),(29163,18840,'AP','3304141852',0,'2014-01-17 03:36:13',NULL,NULL),(29292,18927,'AP','3302711996',0,'2014-01-20 08:05:36',NULL,NULL),(30757,19988,'TE','4193062673',0,'2014-01-25 19:00:18',NULL,NULL),(33634,22055,'TE','2818777546',0,'2014-02-08 19:00:07',NULL,NULL),(33735,22136,'TE','4405220267',0,'2014-02-08 19:00:46',NULL,NULL),(34105,22354,'AP','9852100420',0,'2014-02-10 21:00:05',NULL,NULL),(35752,23513,'EM','HERBERTANDREW4@WILDBLUE.NET',0,'2014-02-13 22:02:15',NULL,NULL),(36783,24218,'TE','5023011989',0,'2014-02-16 19:00:27',NULL,NULL),(40972,27224,'TE','9857465008',0,'2014-03-03 21:31:37',NULL,NULL),(41988,27909,'AP','8066554049',0,'2014-03-06 21:00:14',NULL,NULL),(43729,29031,'TE','3308434728',0,'2014-03-10 21:01:35',NULL,NULL),(10673,6935,'TE','9373978301',0,'2013-12-26 01:46:39',NULL,NULL),(8929,5845,'TE','3615527153',0,'2013-12-25 23:48:39',NULL,NULL),(23158,14928,'AP','4193566959',0,'2013-12-30 00:01:54',NULL,NULL),(20657,13284,'TE','5125356603',0,'2013-12-26 12:57:18',NULL,NULL),(20426,13154,'EM','teresacolbert@aol.com',0,'2013-12-26 12:53:40',NULL,NULL),(1841,1139,'AP','3378845779',0,'2013-12-25 18:18:16',NULL,NULL),(14713,9627,'TE','4196512932',0,'2013-12-26 04:38:05',NULL,NULL),(13837,9021,'EM','CHILDOFBARB@HOTMAIL.COM',0,'2013-12-26 04:05:20',NULL,NULL),(11105,7216,'TE','3309321036',0,'2013-12-26 02:01:03',NULL,NULL),(5276,3386,'EM','mb242027@yahoo.com',0,'2013-12-25 21:17:41',NULL,NULL),(3960,2514,'AP','2283434182',0,'2013-12-25 19:36:24',NULL,NULL),(28980,18705,'AP','9375545405',0,'2014-01-17 03:35:30',NULL,NULL),(29402,19002,'TE','5043245167',0,'2014-01-20 08:06:17',NULL,NULL),(29438,19034,'AP','6016043930',0,'2014-01-20 08:06:33',NULL,NULL),(30429,19725,'EM','JAMES@JAMESHARDAWAY.COM',0,'2014-01-23 21:01:01',NULL,NULL),(34469,22616,'AP','6267312108',0,'2014-02-11 21:00:08',NULL,NULL),(36315,23913,'TE','2107238784',0,'2014-02-14 22:00:03',NULL,NULL),(39454,26092,'EM','jsilcio@yahoo.com',0,'2014-02-28 06:30:09',NULL,NULL),(42704,28405,'EM','nick@clearforkvalleyelectric.com',0,'2014-03-07 21:30:53',NULL,NULL),(43226,28723,'AP','4197440744',0,'2014-03-08 21:31:22',NULL,NULL),(43324,28779,'AP','5133060624',0,'2014-03-09 21:00:35',NULL,NULL),(4593,2931,'AP','3309584752',0,'2013-12-25 20:16:00',NULL,NULL),(25423,16397,'TE','8474069269',0,'2014-01-07 04:03:46',NULL,NULL),(5532,3538,'TE','9726793599',0,'2013-12-25 21:21:41',NULL,NULL),(23520,15172,'AP','5672049972',0,'2014-01-01 12:06:36',NULL,NULL),(6215,4008,'AP','2165263952',0,'2013-12-25 21:45:21',NULL,NULL),(6286,4052,'EM','david.beck@becktechlive.com',0,'2013-12-25 21:46:26',NULL,NULL),(20238,13036,'EM','KADYFOUR@YAHOO.COM',0,'2013-12-26 12:50:30',NULL,NULL),(8888,5822,'TE','7135043074',0,'2013-12-25 23:48:03',NULL,NULL),(12394,8115,'TE','3184471308',0,'2013-12-26 03:15:08',NULL,NULL),(29537,19091,'TE','2166712711',0,'2014-01-21 08:44:32',NULL,NULL),(30649,19893,'TE','5677123698',0,'2014-01-24 21:00:52',NULL,NULL),(35078,23036,'BN','2148370037',0,'2014-02-12 21:30:37',NULL,NULL),(35361,23233,'EM','tgwiner@woh.rr.com',0,'2014-02-12 21:32:27',NULL,NULL),(37532,24714,'TE','4405037555',0,'2014-02-20 04:36:46',NULL,NULL),(39276,25988,'AP','6016686535',0,'2014-02-26 21:01:55',NULL,NULL),(39679,26236,'EM','izzie1951@yahoo.com',0,'2014-02-28 06:31:03',NULL,NULL),(39835,26347,'EM','smcgarvey6@gmail.com',0,'2014-02-28 06:31:46',NULL,NULL),(40718,27060,'EM','Sara.highstreet@gmail.com',0,'2014-03-03 21:29:59',NULL,NULL),(40760,27086,'TE','4192897262',0,'2014-03-03 21:30:14',NULL,NULL),(40860,27152,'TE','3309282780',0,'2014-03-03 21:30:53',NULL,NULL),(14732,9637,'AP','9032418809',0,'2013-12-26 04:38:23',NULL,NULL),(25381,16369,'TE','8326613989',0,'2014-01-07 04:03:00',NULL,NULL),(24912,16059,'AP','3303388713',0,'2014-01-04 02:03:27',NULL,NULL),(23861,15398,'AP','4694508157',1,'2014-01-02 04:26:42',NULL,NULL),(21725,13998,'TE','4196043036',0,'2013-12-26 13:15:58',NULL,NULL),(6358,4096,'AP','4199022411',0,'2013-12-25 21:47:36',NULL,NULL),(4855,3109,'TE','4192747915',0,'2013-12-25 20:20:28',NULL,NULL),(20281,13072,'TE','2162246522',0,'2013-12-26 12:51:21',NULL,NULL),(32188,21024,'TE','2287313513',0,'2014-02-01 19:00:41',NULL,NULL),(33657,22075,'TE','3184597668',0,'2014-02-08 19:00:16',NULL,NULL),(36360,23945,'TE','5042567369',0,'2014-02-15 21:00:12',NULL,NULL),(36837,24259,'AP','9158733602',0,'2014-02-17 19:00:09',NULL,NULL),(37751,24910,'TE','6145166443',0,'2014-02-20 21:30:07',NULL,NULL),(40141,26624,'TE','8322839318',0,'2014-02-28 21:30:53',NULL,NULL),(40873,27158,'EM','bettyboom_13@yahoo.com',0,'2014-03-03 21:30:57',NULL,NULL),(41475,27563,'EM','landowlaw@att.net',0,'2014-03-04 21:30:18',NULL,NULL),(42369,28139,'AP','4199364466',0,'2014-03-06 21:02:30',NULL,NULL),(42447,28194,'TE','8067623582',0,'2014-03-06 21:30:05',NULL,NULL),(348,215,'EM','tators11@me.com',0,'2013-12-25 17:20:36',NULL,NULL),(23291,15006,'EM','JIMBODAMBIT@YAHOO.COM',0,'2014-01-01 12:01:54',NULL,NULL),(633,394,'TE','5133513768',0,'2013-12-25 17:45:59',NULL,NULL),(21064,13547,'EM','cmontgomerylaw@aol.com',0,'2013-12-26 13:03:59',NULL,NULL),(8394,5524,'EM','revkareithi@gmail.com',0,'2013-12-25 23:15:24',NULL,NULL),(20556,13229,'AP','8176791737',0,'2013-12-26 12:55:44',NULL,NULL),(20352,13110,'AP','9376746780',0,'2013-12-26 12:52:27',NULL,NULL),(5233,3363,'AP','5127879347',0,'2013-12-25 21:17:02',NULL,NULL),(11975,7802,'TE','8069288401',0,'2013-12-26 03:03:43',NULL,NULL),(32619,21327,'EM','chinadollrae@hotmail.com',0,'2014-02-04 21:00:26',NULL,NULL),(35705,23483,'TE','6468722033',0,'2014-02-13 22:01:57',NULL,NULL),(39959,26456,'TE','6015294788',0,'2014-02-28 07:30:28',NULL,NULL),(40275,26716,'EM','braceyk27@yahoo.com',0,'2014-02-28 21:31:42',NULL,NULL),(41926,27875,'TE','9014123307',0,'2014-03-05 21:32:28',NULL,NULL),(43514,28894,'TE','9037361238',0,'2014-03-10 21:00:16',NULL,NULL),(24,15,'EM','Dtoney1113@aol.com',0,'2013-12-25 17:15:23',NULL,NULL),(26485,17046,'TE','4404794825',0,'2014-01-13 02:20:54',NULL,NULL),(26259,16900,'TE','7402740115',0,'2014-01-13 02:19:32',NULL,NULL),(20790,13361,'EM','nancylignoski@hotmail.com',0,'2013-12-26 12:59:28',NULL,NULL),(27226,17529,'TE','3304309280',0,'2014-01-13 03:01:41',NULL,NULL),(27286,17569,'TE','4195620321',0,'2014-01-14 01:32:00',NULL,NULL),(2578,1573,'TE','9366618729',0,'2013-12-25 18:51:15',NULL,NULL),(31658,20652,'AP','9564629014',0,'2014-01-30 21:00:39',NULL,NULL),(32380,21158,'AP','5138244845',0,'2014-02-03 21:00:31',NULL,NULL),(36524,24046,'EM','deesoutendijk@gmail.com',0,'2014-02-15 22:01:02',NULL,NULL),(36613,24105,'AP','8177293283',0,'2014-02-15 22:01:33',NULL,NULL),(37448,24655,'TE','4195379346',0,'2014-02-20 04:24:25',NULL,NULL),(38287,25281,'EM','pennykervin@yahoo.com',0,'2014-02-25 21:00:17',NULL,NULL),(38811,25659,'EM','DOUG3849@HOTMAIL.COM',0,'2014-02-26 08:30:44',NULL,NULL),(41336,27459,'EM','MARSHALLFRANKLIN@AOL.COM',0,'2014-03-04 21:02:05',NULL,NULL),(41368,27482,'TE','8179381792',0,'2014-03-04 21:02:18',NULL,NULL),(43988,29182,'EM','MAGOUBEAUX@GMAIL.COM',0,'2014-03-10 21:29:59',NULL,NULL),(25225,16264,'EM','mt213204@gmail.com',0,'2014-01-07 04:00:06',NULL,NULL),(26592,17109,'TE','9377250521',0,'2014-01-13 02:21:36',NULL,NULL),(2232,1371,'TE','6467340426',0,'2013-12-25 18:45:47',NULL,NULL),(9733,6369,'TE','5132355214',0,'2013-12-26 00:47:35',NULL,NULL),(9251,6052,'TE','6148244356',0,'2013-12-26 00:01:44',NULL,NULL),(23011,14841,'EM','cedwards0325@gmail.com',1,'2013-12-29 11:14:51',NULL,NULL),(8254,5398,'EM','nealspencer@hotmail.com',0,'2013-12-25 23:08:53',NULL,NULL),(2293,1406,'TE','2259382453',0,'2013-12-25 18:46:45',NULL,NULL),(7246,4722,'TE','4198788835',0,'2013-12-25 22:08:59',NULL,NULL),(27402,17646,'TE','7407755209',0,'2014-01-14 01:32:38',NULL,NULL),(22677,14623,'TE','4199290942',0,'2013-12-28 03:37:00',NULL,NULL),(22261,14345,'AP','9376225817',0,'2013-12-27 02:08:01',NULL,NULL),(2668,1619,'AP','8065775814',0,'2013-12-25 18:52:33',NULL,NULL),(5874,3767,'EM','johnsontej@sbcglobal.net',0,'2013-12-25 21:33:37',NULL,NULL),(20688,13300,'AP','3252124161',0,'2013-12-26 12:57:46',NULL,NULL),(5122,3281,'EM','sturat86@gmail.com',0,'2013-12-25 21:15:17',NULL,NULL),(14899,9748,'EM','matthewstephens83@hotmail.com',0,'2013-12-26 04:46:09',NULL,NULL),(4644,2966,'TE','9562022301',0,'2013-12-25 20:16:53',NULL,NULL),(30536,19809,'TE','2542279334',0,'2014-01-24 21:00:08',NULL,NULL),(34788,22816,'EM','drichmond4@att.net',0,'2014-02-11 21:02:00',NULL,NULL),(35239,23143,'TE','3306082923',0,'2014-02-12 21:31:37',NULL,NULL),(35480,23332,'AP','5133684590',0,'2014-02-13 22:00:31',NULL,NULL),(35572,23392,'EM','Kmbihr@yahoo.com',0,'2014-02-13 22:01:06',NULL,NULL),(37789,24940,'TE','6015594667',0,'2014-02-20 22:00:04',NULL,NULL),(42687,28397,'AP','6147495197',0,'2014-03-07 21:30:48',NULL,NULL),(42848,28496,'TE','6019429938',0,'2014-03-07 21:31:45',NULL,NULL),(11738,7640,'AP','9374171757',0,'2013-12-26 02:46:33',NULL,NULL),(6515,4210,'TE','3613189070',0,'2013-12-25 21:50:10',NULL,NULL),(14868,9730,'TE','5134246446',0,'2013-12-26 04:45:40',NULL,NULL),(8297,5436,'TE','5049759777',0,'2013-12-25 23:09:48',NULL,NULL),(9453,6187,'TE','2544338247',0,'2013-12-26 00:30:14',NULL,NULL),(1738,1069,'AP','2162247341',0,'2013-12-25 18:16:28',NULL,NULL),(28332,18258,'EM','tanya3785@msn.com',0,'2014-01-16 08:44:35',NULL,NULL),(29114,18803,'TE','2168488244',0,'2014-01-17 03:36:00',NULL,NULL),(29979,19401,'TE','5133748080',1,'2014-01-22 03:22:53',NULL,NULL),(34546,22659,'TE','8067879563',0,'2014-02-11 21:00:33',NULL,NULL),(36010,23688,'TE','2058074992',0,'2014-02-14 21:30:35',NULL,NULL),(37489,24687,'TE','9402229901',0,'2014-02-20 04:31:42',NULL,NULL),(39776,26302,'TE','4196312133',0,'2014-02-28 06:31:29',NULL,NULL),(896,554,'AP','2254486617',0,'2013-12-25 17:50:07',NULL,NULL),(1166,715,'TE','4199124022',0,'2013-12-25 18:03:19',NULL,NULL),(24345,15725,'TE','2162153579',0,'2014-01-03 02:00:17',NULL,NULL),(22877,14760,'AP','8178328199',1,'2013-12-29 11:12:41',NULL,NULL),(20857,13409,'TE','5133838130',0,'2013-12-26 13:00:33',NULL,NULL),(4823,3087,'EM','dclark25@cinci.rr.com',0,'2013-12-25 20:19:54',NULL,NULL),(14534,9494,'EM','radfords1013@gmail.com',0,'2013-12-26 04:35:00',NULL,NULL),(14426,9429,'AP','2147349927',0,'2013-12-26 04:33:21',NULL,NULL),(13665,8908,'TE','7407380408',0,'2013-12-26 04:02:30',NULL,NULL),(4336,2768,'TE','3304259302',0,'2013-12-25 19:49:29',NULL,NULL),(2381,1448,'TE','6145974057',0,'2013-12-25 18:48:02',NULL,NULL),(29067,18770,'TE','2813308343',0,'2014-01-17 03:35:50',NULL,NULL),(30107,19503,'EM','intrblt@aol.com',0,'2014-01-23 03:02:11',NULL,NULL),(32894,21532,'TE','5138471764',0,'2014-02-05 21:30:07',NULL,NULL),(38008,25075,'TE','6014153189',0,'2014-02-20 22:01:33',NULL,NULL),(40043,26546,'TE','3307031525',0,'2014-02-28 21:30:11',NULL,NULL),(40070,26566,'AP','5133569446',0,'2014-02-28 21:30:23',NULL,NULL),(42231,28053,'TE','6012383052',0,'2014-03-06 21:01:39',NULL,NULL),(43189,28700,'AP','5134071729',0,'2014-03-08 21:31:08',NULL,NULL),(922,569,'TE','5134906903',0,'2013-12-25 17:50:34',NULL,NULL),(938,579,'AP','5133101466',0,'2013-12-25 17:50:49',NULL,NULL),(24772,15981,'AP','7133035767',0,'2014-01-04 02:00:57',NULL,NULL),(24553,15836,'AP','3303232578',0,'2014-01-03 02:04:01',NULL,NULL),(24338,15719,'AP','4403581235',0,'2014-01-03 02:00:10',NULL,NULL),(23168,14931,'EM','manthony62@yahoo.com',0,'2013-12-30 00:02:02',NULL,NULL),(1720,1053,'EM','patsysw@hotmail.com',0,'2013-12-25 18:16:08',NULL,NULL),(7843,5118,'AP','8065950331',0,'2013-12-25 23:01:53',NULL,NULL),(14257,9325,'AP','4047518397',0,'2013-12-26 04:30:37',NULL,NULL),(13857,9034,'EM','mschmidt@sssnet.com',0,'2013-12-26 04:05:41',NULL,NULL),(6997,4569,'TE','9407045241',0,'2013-12-25 22:04:55',NULL,NULL),(4953,3178,'TE','2164413060',0,'2013-12-25 20:31:47',NULL,NULL),(3418,2147,'TE','5137346792',0,'2013-12-25 19:18:27',NULL,NULL),(28260,18222,'AP','9792167638',0,'2014-01-16 08:44:14',NULL,NULL),(28526,18387,'AP','5134786043',0,'2014-01-16 08:45:38',NULL,NULL),(29647,19155,'TE','2163146811',0,'2014-01-21 08:45:37',NULL,NULL),(29821,19294,'TE','9855175130',1,'2014-01-22 03:21:57',NULL,NULL),(30204,19565,'AP','7702659300',0,'2014-01-23 03:02:35',NULL,NULL),(32993,21605,'TE','5137522929',0,'2014-02-05 21:30:33',NULL,NULL),(37650,24826,'TE','9376559763',0,'2014-02-20 04:51:08',NULL,NULL),(37840,24965,'AP','6316729511',0,'2014-02-20 22:00:23',NULL,NULL),(40290,26724,'EM','moesamaha@yahoo.com',0,'2014-02-28 21:31:46',NULL,NULL),(41172,27344,'TE','3304534826',0,'2014-03-04 21:01:01',NULL,NULL),(41629,27674,'TE','9157277999',0,'2014-03-05 21:30:35',NULL,NULL),(41831,27813,'TE','3306680022',0,'2014-03-05 21:31:52',NULL,NULL),(43169,28687,'EM','kraissplant121@gmail.com',0,'2014-03-08 21:31:01',NULL,NULL),(43927,29140,'EM','killionjoseph195106@aol.com',0,'2014-03-10 21:02:43',NULL,NULL),(28207,18181,'TE','4193032905',0,'2014-01-15 02:08:01',NULL,NULL),(957,590,'AP','6463699590',0,'2013-12-25 17:51:11',NULL,NULL),(25872,16674,'AP','7025725002',0,'2014-01-08 18:24:30',NULL,NULL),(10868,7054,'TE','5136009113',0,'2013-12-26 01:49:47',NULL,NULL),(23490,15148,'TE','6142362737',0,'2014-01-01 12:05:58',NULL,NULL),(10629,6915,'TE','5044279568',0,'2013-12-26 01:46:01',NULL,NULL),(20521,13209,'EM','nandham.rama@gmail.com',0,'2013-12-26 12:55:12',NULL,NULL),(8951,5858,'AP','4194600479',0,'2013-12-25 23:48:59',NULL,NULL),(13699,8931,'TE','3306880734',0,'2013-12-26 04:03:01',NULL,NULL),(8869,5811,'TE','9155980032',0,'2013-12-25 23:47:47',NULL,NULL),(8750,5736,'AP','5042569540',0,'2013-12-25 23:45:49',NULL,NULL),(28248,18215,'AP','4193027695',0,'2014-01-15 02:08:11',NULL,NULL),(29294,18928,'TE','5133212602',0,'2014-01-20 08:05:36',NULL,NULL),(38181,25201,'TE','5045052021',0,'2014-02-21 22:00:46',NULL,NULL),(39283,25991,'EM','bre_jeremy@yahoo.com',0,'2014-02-26 21:01:57',NULL,NULL),(42041,27940,'AP','9404454188',0,'2014-03-06 21:00:31',NULL,NULL),(43461,28862,'AP','5043018988',0,'2014-03-09 21:30:04',NULL,NULL),(24096,15553,'AP','9856872293',1,'2014-01-02 04:31:23',NULL,NULL),(21931,14127,'EM','derek851113@aol.com',0,'2013-12-27 02:02:18',NULL,NULL),(14977,9797,'AP','2544582329',0,'2013-12-26 05:01:09',NULL,NULL),(7435,4842,'TE','5137591505',0,'2013-12-25 22:30:09',NULL,NULL),(25658,16544,'AP','2163701910',1,'2014-01-07 10:22:30',NULL,NULL),(4822,3087,'TE','5137322052',0,'2013-12-25 20:19:53',NULL,NULL),(25443,16405,'EM','tmaceiunas@hotmail.com',0,'2014-01-07 04:04:03',NULL,NULL),(30504,19786,'TE','3308121600',0,'2014-01-23 21:01:37',NULL,NULL),(32649,21355,'TE','2542399133',0,'2014-02-04 21:00:40',NULL,NULL),(32851,21499,'AP','5174886566',0,'2014-02-04 21:01:51',NULL,NULL),(33685,22095,'TE','5138895193',0,'2014-02-08 19:00:27',NULL,NULL),(33856,22224,'TE','3306084463',0,'2014-02-09 19:00:28',NULL,NULL),(34011,22309,'AP','7697987029',0,'2014-02-10 11:00:43',NULL,NULL),(35336,23218,'TE','6014153889',0,'2014-02-12 21:32:18',NULL,NULL),(38567,25487,'AP','6014162077',0,'2014-02-25 21:31:46',NULL,NULL),(39909,26410,'AP','8328163543',0,'2014-02-28 07:00:39',NULL,NULL),(40306,26736,'EM','cappelsi@gmail.com',0,'2014-02-28 21:31:52',NULL,NULL),(11163,7260,'AP','3615002250',0,'2013-12-26 02:02:08',NULL,NULL),(24521,15816,'TE','8134350636',0,'2014-01-03 02:03:23',NULL,NULL),(24445,15781,'TE','4042824740',0,'2014-01-03 02:02:09',NULL,NULL),(9898,6477,'TE','3307944408',0,'2013-12-26 00:50:14',NULL,NULL),(4282,2736,'TE','3183479069',0,'2013-12-25 19:48:38',NULL,NULL),(5082,3262,'TE','2259552652',0,'2013-12-25 20:46:56',NULL,NULL),(14246,9320,'TE','2253244086',0,'2013-12-26 04:30:29',NULL,NULL),(11666,7595,'TE','5134811715',0,'2013-12-26 02:45:13',NULL,NULL),(6521,4218,'TE','9566824272',0,'2013-12-25 21:50:20',NULL,NULL),(7085,4627,'AP','6015068925',0,'2013-12-25 22:06:25',NULL,NULL),(8861,5806,'AP','8067867900',0,'2013-12-25 23:47:38',NULL,NULL),(7924,5164,'TE','4403661160',0,'2013-12-25 23:03:08',NULL,NULL),(29501,19069,'BN','4197058843',0,'2014-01-21 08:44:19',NULL,NULL),(30787,20018,'TE','3612290317',0,'2014-01-26 19:00:13',NULL,NULL),(35849,23571,'AP','4193890832',0,'2014-02-13 22:02:52',NULL,NULL),(39114,25875,'TE','5042749069',0,'2014-02-26 21:00:54',NULL,NULL),(39232,25951,'AP','6145723146',0,'2014-02-26 21:01:36',NULL,NULL),(39901,26406,'AP','3303545829',0,'2014-02-28 07:00:35',NULL,NULL),(1862,1150,'TE','2253159278',0,'2013-12-25 18:18:36',NULL,NULL),(26201,16864,'TE','9158437285',0,'2014-01-13 02:19:12',NULL,NULL),(23628,15255,'AP','9373045788',0,'2014-01-01 12:09:06',NULL,NULL),(11259,7336,'TE','9377805101',0,'2013-12-26 02:03:55',NULL,NULL),(14867,9729,'EM','TOMJR608@HOTMAIL.COM',0,'2013-12-26 04:45:39',NULL,NULL),(12443,8151,'EM','rbtx0816@yahoo.com',0,'2013-12-26 03:16:02',NULL,NULL),(4457,2838,'AP','5134793528',0,'2013-12-25 20:01:00',NULL,NULL),(30606,19863,'TE','4434239947',0,'2014-01-24 21:00:37',NULL,NULL),(32164,21008,'EM','brudduck@gmail.com',0,'2014-02-01 19:00:33',NULL,NULL),(38113,25157,'EM','barbara@saatp.com',0,'2014-02-21 22:00:20',NULL,NULL),(41695,27726,'TE','7144965916',0,'2014-03-05 21:31:01',NULL,NULL),(43192,28701,'EM','vflory@zoominternet.net',0,'2014-03-08 21:31:09',NULL,NULL),(265,163,'TE','5133890495',0,'2013-12-25 17:19:15',NULL,NULL),(26507,17055,'AP','9379262500',0,'2014-01-13 02:21:01',NULL,NULL),(26214,16873,'AP','5126188708',0,'2014-01-13 02:19:17',NULL,NULL),(25207,16255,'TE','6015305129',0,'2014-01-05 00:02:44',NULL,NULL),(25135,16204,'TE','3252457847',0,'2014-01-05 00:01:14',NULL,NULL),(10224,6682,'TE','6145991196',0,'2013-12-26 01:01:25',NULL,NULL),(22190,14294,'TE','2163907507',0,'2013-12-27 02:06:40',NULL,NULL),(13549,8837,'TE','5127966088',0,'2013-12-26 04:00:39',NULL,NULL),(8489,5585,'TE','5042289810',0,'2013-12-25 23:17:04',NULL,NULL),(1632,1001,'AP','6019189868',0,'2013-12-25 18:10:58',NULL,NULL),(2398,1460,'EM','MUMP@LIVE.COM',0,'2013-12-25 18:48:19',NULL,NULL),(3203,2012,'EM','susangrem@yahoo.com',0,'2013-12-25 19:02:32',NULL,NULL),(28193,18171,'AP','4193504582',0,'2014-01-15 02:07:57',NULL,NULL),(28087,18104,'TE','3183311657',0,'2014-01-15 02:07:34',NULL,NULL),(41443,27532,'AP','6149610532',0,'2014-03-04 21:02:48',NULL,NULL),(41888,27853,'AP','9563585457',0,'2014-03-05 21:32:14',NULL,NULL),(42246,28061,'AP','2604186993',0,'2014-03-06 21:01:44',NULL,NULL),(471,296,'EM','rob.bermingham@gmail.com',0,'2013-12-25 17:30:42',NULL,NULL),(7164,4672,'AP','3186501290',0,'2013-12-25 22:07:39',NULL,NULL),(8820,5776,'TE','6148644825',0,'2013-12-25 23:46:55',NULL,NULL),(1778,1098,'TE','6146709430',0,'2013-12-25 18:17:13',NULL,NULL),(6673,4332,'AP','4199730207',0,'2013-12-25 21:53:03',NULL,NULL),(20749,13336,'AP','9795958452',0,'2013-12-26 12:58:45',NULL,NULL),(5808,3730,'EM','laurentyrone@yahoo.com',0,'2013-12-25 21:32:35',NULL,NULL),(11819,7690,'TE','5135204635',0,'2013-12-26 03:01:00',NULL,NULL),(3098,1933,'TE','9794798080',0,'2013-12-25 19:00:27',NULL,NULL),(9899,6478,'TE','3307246131',0,'2013-12-26 00:50:15',NULL,NULL),(27081,17417,'BN','9374836076',0,'2014-01-13 03:00:25',NULL,NULL),(27977,18036,'TE','4192605674',0,'2014-01-15 02:07:10',NULL,NULL),(29066,18769,'EM','mollycrispinlong@gmail.com',0,'2014-01-17 03:35:49',NULL,NULL),(29745,19233,'AP','2166506915',0,'2014-01-21 08:46:34',NULL,NULL),(30113,19507,'TE','9726406451',0,'2014-01-23 03:02:13',NULL,NULL),(31430,20489,'AP','3302895790',0,'2014-01-29 21:01:05',NULL,NULL),(31648,20647,'EM','patriciadavisjmp57@yahoo.com',0,'2014-01-30 21:00:37',NULL,NULL),(32200,21032,'TE','4197274922',0,'2014-02-01 19:00:45',NULL,NULL),(33502,21955,'AP','9372090555',0,'2014-02-07 19:00:23',NULL,NULL),(33738,22137,'TE','7404590231',0,'2014-02-08 19:00:47',NULL,NULL),(41355,27474,'TE','4197079178',0,'2014-03-04 21:02:13',NULL,NULL),(25151,16212,'TE','4199532369',0,'2014-01-05 00:01:31',NULL,NULL),(20842,13399,'EM','ctodd7100@gmail.com',0,'2013-12-26 13:00:18',NULL,NULL),(20748,13336,'TE','9795958452',0,'2013-12-26 12:58:45',NULL,NULL),(20698,13305,'EM','cvanripe@tamu.edu',0,'2013-12-26 12:57:55',NULL,NULL),(6528,4221,'EM','cfranklin@ellisconsultants.com',0,'2013-12-25 21:50:26',NULL,NULL),(20504,13202,'TE','2142359997',0,'2013-12-26 12:54:59',NULL,NULL),(4321,2757,'TE','3308483693',0,'2013-12-25 19:49:14',NULL,NULL),(10906,7087,'TE','3304193619',0,'2013-12-26 01:50:26',NULL,NULL),(11078,7195,'TE','3307179376',0,'2013-12-26 02:00:31',NULL,NULL),(28353,18270,'EM','RLABURDA@CABLEONE.NET',0,'2014-01-16 08:44:41',NULL,NULL),(28935,18682,'TE','8323159335',0,'2014-01-17 03:35:20',NULL,NULL),(30219,19576,'AP','2254392694',0,'2014-01-23 03:02:38',NULL,NULL),(39008,25795,'TE','7402749338',0,'2014-02-26 21:00:13',NULL,NULL),(41876,27846,'TE','9563138844',0,'2014-03-05 21:32:10',NULL,NULL),(42012,27926,'TE','2142089776',0,'2014-03-06 21:00:22',NULL,NULL),(3383,2127,'AP','9374171757',0,'2013-12-25 19:17:52',NULL,NULL),(24028,15514,'TE','3183778832',1,'2014-01-02 04:30:08',NULL,NULL),(23687,15292,'EM','cathycastle68@yahoo.com',1,'2014-01-02 04:22:31',NULL,NULL),(23488,15147,'TE','2168466277',0,'2014-01-01 12:05:56',NULL,NULL),(4343,2772,'EM','madisonghicks@yahoo.com',0,'2013-12-25 19:49:34',NULL,NULL),(6701,4357,'TE','4197328871',0,'2013-12-25 21:53:38',NULL,NULL),(4633,2956,'TE','3259982594',0,'2013-12-25 20:16:39',NULL,NULL),(14545,9503,'TE','3304145743',0,'2013-12-26 04:35:14',NULL,NULL),(28977,18703,'TE','7405772912',0,'2014-01-17 03:35:29',NULL,NULL),(30385,19685,'AP','9038181137',0,'2014-01-23 21:00:40',NULL,NULL),(32951,21573,'TE','3306878875',0,'2014-02-05 21:30:22',NULL,NULL),(34309,22511,'EM','gmgleason@live.com',0,'2014-02-10 21:31:19',NULL,NULL),(35890,23609,'AP','5677124093',0,'2014-02-13 22:03:11',NULL,NULL),(23444,15108,'EM','DIPUCCIOFAMILY@SBCGLOBAL.NET',0,'2014-01-01 12:04:55',NULL,NULL),(26851,17277,'AP','3304006168',0,'2014-01-13 02:23:24',NULL,NULL),(21703,13976,'TE','5132533702',0,'2013-12-26 13:15:29',NULL,NULL),(20744,13333,'TE','8067471045',0,'2013-12-26 12:58:41',NULL,NULL),(9511,6226,'TE','5138294806',0,'2013-12-26 00:31:19',NULL,NULL),(9501,6217,'TE','4192556198',0,'2013-12-26 00:31:03',NULL,NULL),(14615,9555,'EM','john.a.garey@gmail.com',0,'2013-12-26 04:36:24',NULL,NULL),(25409,16391,'TE','9564632464',0,'2014-01-07 04:03:34',NULL,NULL),(10174,6648,'TE','5133102064',0,'2013-12-26 01:00:31',NULL,NULL),(5938,3807,'AP','3303535045',0,'2013-12-25 21:34:40',NULL,NULL),(7528,4905,'EM','Beaudingler@gmail.com',0,'2013-12-25 22:31:55',NULL,NULL),(5837,3745,'AP','7138236975',0,'2013-12-25 21:33:01',NULL,NULL),(30665,19909,'EM','gsturm001@att.net',0,'2014-01-24 21:00:59',NULL,NULL),(31265,20367,'EM','antleytrac@aol.com',0,'2014-01-29 21:00:03',NULL,NULL),(34756,22787,'EM','tevans625@yahoo.com',0,'2014-02-11 21:01:48',NULL,NULL),(34963,22953,'EM','cbraig25@yahoo.com',0,'2014-02-12 21:00:04',NULL,NULL),(35253,23153,'EM','iltrms@yahoo.com',0,'2014-02-12 21:31:42',NULL,NULL),(37741,24898,'TE','4194260017',0,'2014-02-20 05:41:01',NULL,NULL),(37908,25006,'TE','3305507878',0,'2014-02-20 22:00:49',NULL,NULL),(40006,26498,'EM','BRETT_PODOLL@YAHOO.COM',0,'2014-02-28 21:00:14',NULL,NULL),(41895,27856,'TE','8309643463',0,'2014-03-05 21:32:16',NULL,NULL),(43046,28619,'AP','9403660278',0,'2014-03-08 21:30:20',NULL,NULL),(537,336,'TE','4193088174',0,'2013-12-25 17:31:50',NULL,NULL),(26825,17254,'TE','9378769432',0,'2014-01-13 02:23:14',NULL,NULL),(2194,1349,'EM','tjoiner73@msn.com',0,'2013-12-25 18:45:12',NULL,NULL),(25142,16206,'EM','vmluna88@yahoo.com',0,'2014-01-05 00:01:19',NULL,NULL),(3711,2353,'TE','9564238101',0,'2013-12-25 19:32:18',NULL,NULL),(13998,9138,'TE','4197532386',0,'2013-12-26 04:08:07',NULL,NULL),(13904,9063,'EM','malayon73@aol.com',0,'2013-12-26 04:06:25',NULL,NULL),(11254,7329,'TE','5135283780',0,'2013-12-26 02:03:47',NULL,NULL),(4138,2639,'TE','5139321353',0,'2013-12-25 19:46:18',NULL,NULL),(9865,6451,'AP','4193511557',0,'2013-12-26 00:49:40',NULL,NULL),(5780,3703,'AP','4403347768',0,'2013-12-25 21:32:01',NULL,NULL),(7628,4970,'TE','9366452685',0,'2013-12-25 22:46:25',NULL,NULL),(1344,820,'TE','3307537462',0,'2013-12-25 18:06:05',NULL,NULL),(6553,4234,'TE','2147141280',0,'2013-12-25 21:50:49',NULL,NULL),(28672,18494,'TE','3307921321',0,'2014-01-16 08:46:27',NULL,NULL),(28732,18540,'EM','joelleknight@icloud.com',0,'2014-01-16 08:46:48',NULL,NULL),(29191,18858,'AP','5042375994',0,'2014-01-17 03:36:19',NULL,NULL),(30970,20145,'AP','2162462380',0,'2014-01-27 21:01:00',NULL,NULL),(33617,22046,'AP','3372781367',0,'2014-02-07 19:30:04',NULL,NULL),(39133,25883,'EM','RWINBOURN@HOTMAIL.COM',0,'2014-02-26 21:00:59',NULL,NULL),(39358,26032,'TE','6016006450',0,'2014-02-26 21:02:22',NULL,NULL),(39879,26383,'AP','6622310753',0,'2014-02-28 07:00:21',NULL,NULL),(40270,26715,'TE','6019185333',0,'2014-02-28 21:31:41',NULL,NULL),(40731,27068,'TE','2255702614',0,'2014-03-03 21:30:04',NULL,NULL),(43417,28831,'EM','rslonern@gmail.com',0,'2014-03-09 21:01:07',NULL,NULL),(27267,17555,'EM','oregonian@hotmail.com',0,'2014-01-13 03:01:57',NULL,NULL),(25263,16288,'TE','3308631179',0,'2014-01-07 04:00:46',NULL,NULL),(27378,17624,'EM','ansousa1161@yahoo.com',0,'2014-01-14 01:32:29',NULL,NULL),(5677,3646,'AP','7405918360',0,'2013-12-25 21:30:31',NULL,NULL),(2070,1281,'TE','9374097294',0,'2013-12-25 18:30:34',NULL,NULL),(6302,4062,'TE','2163552293',0,'2013-12-25 21:46:42',NULL,NULL),(4845,3100,'TE','9374149931',0,'2013-12-25 20:20:16',NULL,NULL),(27543,17750,'TE','4194430924',0,'2014-01-14 01:33:28',NULL,NULL),(28423,18313,'TE','5134518430',0,'2014-01-16 08:45:03',NULL,NULL),(28908,18662,'TE','5125778209',0,'2014-01-17 03:35:14',NULL,NULL),(30221,19577,'AP','3185813928',0,'2014-01-23 03:02:39',NULL,NULL),(31218,20331,'EM','csr@emediaink.com',0,'2014-01-28 21:01:02',NULL,NULL),(31422,20483,'EM','Stacybechtel@hotmail.com',0,'2014-01-29 21:01:02',NULL,NULL),(33212,21749,'AP','9407336891',0,'2014-02-06 21:00:20',NULL,NULL),(36200,23829,'TE','6012126548',0,'2014-02-14 21:31:45',NULL,NULL),(37129,24442,'AP','3305016154',0,'2014-02-18 22:01:20',NULL,NULL),(37954,25044,'TE','6147020651',0,'2014-02-20 22:01:12',NULL,NULL),(39112,25874,'TE','5049154781',0,'2014-02-26 21:00:53',NULL,NULL),(43754,29048,'TE','4408231147',0,'2014-03-10 21:01:44',NULL,NULL),(532,333,'AP','2814097223',0,'2013-12-25 17:31:44',NULL,NULL),(10151,6635,'AP','2167986884',0,'2013-12-26 01:00:08',NULL,NULL),(25684,16559,'TE','5042361746',1,'2014-01-07 10:22:59',NULL,NULL),(10009,6548,'AP','2104102445',0,'2013-12-26 00:52:07',NULL,NULL),(2108,1303,'TE','2542490026',0,'2013-12-25 18:31:14',NULL,NULL),(25061,16156,'TE','6147950232',0,'2014-01-04 06:00:04',NULL,NULL),(5459,3497,'TE','4403460653',0,'2013-12-25 21:20:35',NULL,NULL),(23464,15125,'TE','5134175560',0,'2014-01-01 12:05:21',NULL,NULL),(14678,9604,'TE','3302740132',0,'2013-12-26 04:37:29',NULL,NULL),(13918,9077,'TE','2162586778',0,'2013-12-26 04:06:44',NULL,NULL),(7393,4809,'EM','klowther@cisnet.com',0,'2013-12-25 22:16:45',NULL,NULL),(30729,19964,'AP','3308585870',0,'2014-01-25 19:00:09',NULL,NULL),(30884,20073,'TE','2035510922',0,'2014-01-27 21:00:19',NULL,NULL),(32945,21568,'EM','Lynw318@neo.rr.com',0,'2014-02-05 21:30:20',NULL,NULL),(33954,22278,'EM','oshea_g@yahoo.com',0,'2014-02-10 11:00:20',NULL,NULL),(34552,22662,'TE','2144031008',0,'2014-02-11 21:00:35',NULL,NULL),(37611,24783,'TE','4406542422',0,'2014-02-20 04:45:58',NULL,NULL),(39300,25999,'AP','3184333666',0,'2014-02-26 21:02:02',NULL,NULL),(42494,28261,'TE','9379742355',0,'2014-03-07 21:00:17',NULL,NULL),(23506,15165,'EM','druland3017@gmail.com',0,'2014-01-01 12:06:23',NULL,NULL),(22702,14642,'TE','9493717506',1,'2013-12-29 11:07:29',NULL,NULL),(22365,14425,'TE','3618844049',0,'2013-12-28 03:31:47',NULL,NULL),(5036,3229,'TE','2164528521',0,'2013-12-25 20:46:01',NULL,NULL),(8009,5227,'TE','5132644351',0,'2013-12-25 23:04:42',NULL,NULL),(7380,4803,'TE','2252442040',0,'2013-12-25 22:16:33',NULL,NULL),(6232,4015,'EM','RISINGMOSES@YAHOO.COM',0,'2013-12-25 21:45:33',NULL,NULL),(11897,7740,'TE','5135423808',0,'2013-12-26 03:02:16',NULL,NULL),(12286,8036,'TE','4198891268',0,'2013-12-26 03:09:17',NULL,NULL),(11971,7800,'AP','9793243935',0,'2013-12-26 03:03:39',NULL,NULL),(12012,7825,'AP','6267577443',0,'2013-12-26 03:04:18',NULL,NULL),(28165,18154,'EM','gschubert200@gmail.com',0,'2014-01-15 02:07:52',NULL,NULL),(31110,20255,'TE','2167210742',0,'2014-01-28 21:00:16',NULL,NULL),(34672,22737,'TE','3373486229',0,'2014-02-11 21:01:18',NULL,NULL),(35812,23549,'TE','8325731388',0,'2014-02-13 22:02:37',NULL,NULL),(35880,23594,'TE','9375440134',0,'2014-02-13 22:03:04',NULL,NULL),(37820,24956,'EM','laurel.pang@gmail.com',0,'2014-02-20 22:00:15',NULL,NULL),(38114,25158,'TE','3619722890',0,'2014-02-21 22:00:21',NULL,NULL),(41064,27280,'EM','dorav2115@gmail.com',0,'2014-03-04 21:00:22',NULL,NULL),(42799,28462,'AP','9373048522',0,'2014-03-07 21:31:26',NULL,NULL),(43879,29114,'AP','6019063884',0,'2014-03-10 21:02:26',NULL,NULL),(5282,3389,'TE','7185018682',0,'2013-12-25 21:17:46',NULL,NULL),(26895,17303,'TE','2547346046',0,'2014-01-13 02:23:40',NULL,NULL),(10198,6663,'TE','2547158096',0,'2013-12-26 01:00:56',NULL,NULL),(25212,16258,'TE','2282494452',0,'2014-01-05 00:02:49',NULL,NULL),(13803,8997,'EM','atty.johnporter@yahoo.com',0,'2013-12-26 04:04:46',NULL,NULL),(8402,5529,'AP','3306717566',0,'2013-12-25 23:15:32',NULL,NULL),(10898,7081,'TE','2163210729',0,'2013-12-26 01:50:18',NULL,NULL),(6715,4365,'TE','5109189929',0,'2013-12-25 22:00:09',NULL,NULL),(27025,17379,'TE','3305737678',0,'2014-01-13 03:00:05',NULL,NULL),(27628,17810,'TE','2818806445',0,'2014-01-15 02:05:52',NULL,NULL),(27285,17568,'EM','jilani245@gmail.com',0,'2014-01-14 01:32:00',NULL,NULL),(28278,18232,'EM','hah06@hotmail.com',0,'2014-01-16 08:44:20',NULL,NULL),(29085,18784,'AP','4404792925',0,'2014-01-17 03:35:54',NULL,NULL),(30044,19458,'TE','8174120872',0,'2014-01-23 03:01:55',NULL,NULL),(32860,21505,'AP','3308582216',0,'2014-02-04 21:01:54',NULL,NULL),(32888,21525,'AP','9032888600',0,'2014-02-05 21:30:04',NULL,NULL),(33308,21814,'EM','Tastefullyjul@aol.com',0,'2014-02-06 21:00:56',NULL,NULL),(36618,24108,'AP','9563071941',0,'2014-02-15 22:01:35',NULL,NULL),(43268,28747,'TE','2546993804',0,'2014-03-09 21:00:14',NULL,NULL),(27526,17732,'TE','3309392050',0,'2014-01-14 01:33:20',NULL,NULL),(5748,3684,'EM','DonDurbin@neo.rr.com',0,'2013-12-25 21:31:33',NULL,NULL),(25337,16338,'EM','LAURELSCONRAD@GMAIL.COM',0,'2014-01-07 04:02:12',NULL,NULL),(24782,15985,'AP','9404358560',0,'2014-01-04 02:01:06',NULL,NULL),(24621,15877,'AP','5045128822',0,'2014-01-03 02:05:19',NULL,NULL),(6083,3915,'TE','8327638128',0,'2013-12-25 21:37:13',NULL,NULL),(6948,4527,'EM','LLOYDLEE2@YAHOO.COM',0,'2013-12-25 22:03:59',NULL,NULL),(8305,5443,'TE','5048854793',0,'2013-12-25 23:09:58',NULL,NULL),(1883,1162,'AP','2252232383',0,'2013-12-25 18:18:56',NULL,NULL),(20200,13014,'AP','5133140487',0,'2013-12-26 12:49:53',NULL,NULL),(10165,6643,'EM','amigacarol2002@yahoo.com',0,'2013-12-26 01:00:23',NULL,NULL),(12124,7923,'EM','EEDWAR23@YAHOO.COM',0,'2013-12-26 03:06:24',NULL,NULL),(11805,7676,'EM','dejager.paul@gmail.com',0,'2013-12-26 03:00:44',NULL,NULL),(11772,7660,'TE','3186231289',0,'2013-12-26 03:00:15',NULL,NULL),(28215,18189,'TE','9372072958',0,'2014-01-15 02:08:03',NULL,NULL),(29252,18892,'EM','mit_asika@hotmail.com',0,'2014-01-17 03:36:32',NULL,NULL),(29851,19314,'TE','4692362773',1,'2014-01-22 03:22:07',NULL,NULL),(30507,19788,'AP','4408645261',0,'2014-01-23 21:01:39',NULL,NULL),(31849,20793,'EM','brianle999@gmail.com',0,'2014-01-31 21:00:17',NULL,NULL),(35129,23072,'TE','9858929322',0,'2014-02-12 21:30:58',NULL,NULL),(37380,24616,'TE','6626475464',0,'2014-02-20 04:14:57',NULL,NULL),(38050,25111,'EM','trachellehill@ymail.com',0,'2014-02-21 21:30:16',NULL,NULL),(39122,25878,'AP','5043397070',0,'2014-02-26 21:00:56',NULL,NULL),(39940,26431,'TE','7402442480',0,'2014-02-28 07:30:16',NULL,NULL),(42008,27923,'TE','8062817938',0,'2014-03-06 21:00:20',NULL,NULL),(43475,28872,'TE','9033682282',0,'2014-03-10 21:00:03',NULL,NULL),(9072,5947,'EM','rwarren23@yahoo.com',0,'2013-12-25 23:51:01',NULL,NULL),(27504,17718,'TE','3303281753',0,'2014-01-14 01:33:13',NULL,NULL),(25597,16513,'AP','9152555845',1,'2014-01-07 10:21:26',NULL,NULL),(2319,1415,'EM','mahenton@yahoo.com',0,'2013-12-25 18:47:04',NULL,NULL),(8167,5343,'AP','3307037294',0,'2013-12-25 23:07:25',NULL,NULL),(6939,4520,'EM','Mojoecourtney@gmail.com',0,'2013-12-25 22:03:49',NULL,NULL),(6747,4380,'AP','2163336182',0,'2013-12-25 22:00:36',NULL,NULL),(13982,9119,'EM','blandford126@aol.com',0,'2013-12-26 04:07:45',NULL,NULL),(21679,13958,'AP','5133403437',0,'2013-12-26 13:15:04',NULL,NULL),(33405,21887,'EM','barrettburdick@gmail.com',0,'2014-02-06 21:01:35',NULL,NULL),(36038,23704,'TE','9373694568',0,'2014-02-14 21:30:44',NULL,NULL),(36337,23932,'TE','5133796661',0,'2014-02-15 21:00:04',NULL,NULL),(37339,24585,'TE','3307687293',0,'2014-02-20 04:09:20',NULL,NULL),(38282,25276,'AP','9032887163',0,'2014-02-25 21:00:15',NULL,NULL),(40811,27118,'EM','blackdesk1222@yahoo.com',0,'2014-03-03 21:30:32',NULL,NULL),(1361,830,'TE','3302352856',0,'2013-12-25 18:06:20',NULL,NULL),(5280,3388,'TE','2253896343',0,'2013-12-25 21:17:45',NULL,NULL),(25035,16133,'TE','3306389979',0,'2014-01-04 02:05:47',NULL,NULL),(6091,3921,'EM','findlaytubman@aol.com',0,'2013-12-25 21:37:23',NULL,NULL),(7855,5126,'TE','2108600102',0,'2013-12-25 23:02:05',NULL,NULL),(29613,19133,'TE','5672040531',0,'2014-01-21 08:45:25',NULL,NULL),(29848,19312,'TE','9569994586',1,'2014-01-22 03:22:06',NULL,NULL),(31677,20666,'TE','6018962025',0,'2014-01-30 21:00:46',NULL,NULL),(31697,20676,'EM','MARY_REED95@AOL.COM',0,'2014-01-30 21:00:52',NULL,NULL),(31925,20840,'EM','jreichen@apk.net',0,'2014-01-31 21:00:46',NULL,NULL),(36398,23971,'EM','jessicabanks29@ymail.com',0,'2014-02-15 22:00:14',NULL,NULL),(36511,24039,'TE','8176090303',0,'2014-02-15 22:00:57',NULL,NULL),(38029,25083,'EM','FROGGIRL7721@YAHOO.COM',0,'2014-02-20 22:01:40',NULL,NULL),(38258,25257,'TE','4194871066',0,'2014-02-21 22:01:18',NULL,NULL),(43504,28886,'TE','9036845148',0,'2014-03-10 21:00:12',NULL,NULL),(43,28,'AP','5134786081',0,'2013-12-25 17:15:43',NULL,NULL),(10726,6977,'AP','5135825504',0,'2013-12-26 01:47:36',NULL,NULL),(21340,13714,'EM','joytoyou@sbcglobal.net',0,'2013-12-26 13:09:01',NULL,NULL),(8048,5268,'AP','3309906159',0,'2013-12-25 23:05:32',NULL,NULL),(14427,9430,'TE','7208918951',0,'2013-12-26 04:33:23',NULL,NULL),(8015,5236,'TE','3302963901',0,'2013-12-25 23:04:50',NULL,NULL),(11599,7545,'TE','2145923731',0,'2013-12-26 02:33:03',NULL,NULL),(11374,7407,'AP','2108377163',0,'2013-12-26 02:16:38',NULL,NULL),(1342,819,'AP','3307156630',0,'2013-12-25 18:06:03',NULL,NULL),(3713,2355,'TE','9033079277',0,'2013-12-25 19:32:21',NULL,NULL),(5475,3504,'TE','7403043679',0,'2013-12-25 21:20:48',NULL,NULL),(1764,1089,'TE','6142676966',0,'2013-12-25 18:16:59',NULL,NULL),(28105,18114,'TE','3304164214',0,'2014-01-15 02:07:38',NULL,NULL),(6208,3999,'EM','kcron22@hotmail.com',0,'2013-12-25 21:45:09',NULL,NULL),(6820,4427,'AP','6144048740',0,'2013-12-25 22:01:46',NULL,NULL),(23761,15326,'TE','4322104015',1,'2014-01-02 04:23:46',NULL,NULL),(31325,20413,'EM','ruski_lo@yahoo.com',0,'2014-01-29 21:00:26',NULL,NULL),(32722,21405,'EM','mlprovider@yahoo.com',0,'2014-02-04 21:01:05',NULL,NULL),(33016,21632,'TE','9727758700',0,'2014-02-05 21:30:41',NULL,NULL),(33524,21978,'TE','5044288603',0,'2014-02-07 19:00:35',NULL,NULL),(35490,23336,'TE','5133926896',0,'2014-02-13 22:00:34',NULL,NULL),(36512,24039,'AP','8176090303',0,'2014-02-15 22:00:57',NULL,NULL),(37000,24362,'AP','5044446120',0,'2014-02-18 22:00:33',NULL,NULL),(37538,24716,'AP','4695701993',0,'2014-02-20 04:37:06',NULL,NULL),(38277,25273,'TE','9564285637',0,'2014-02-25 21:00:13',NULL,NULL),(43507,28888,'TE','4153786581',0,'2014-03-10 21:00:13',NULL,NULL),(10315,6729,'TE','5133059723',0,'2013-12-26 01:15:26',NULL,NULL),(4574,2918,'AP','5136009701',0,'2013-12-25 20:15:43',NULL,NULL),(32546,21279,'TE','4193457126',0,'2014-02-03 21:01:36',NULL,NULL),(33914,22260,'TE','2109275528',0,'2014-02-10 11:00:07',NULL,NULL),(37255,24516,'AP','7065931139',0,'2014-02-20 03:55:20',NULL,NULL),(39747,26286,'BN','3375920061',0,'2014-02-28 06:31:22',NULL,NULL),(40597,26948,'BN','9378305215',0,'2014-03-03 01:00:25',NULL,NULL),(41374,27484,'EM','hughes.ian.02@gmail.com',0,'2014-03-04 21:02:20',NULL,NULL),(42040,27940,'TE','9404454188',0,'2014-03-06 21:00:31',NULL,NULL),(42250,28063,'EM','annettemay1127@yahoo.com',0,'2014-03-06 21:01:45',NULL,NULL),(1520,937,'TE','6147497701',0,'2013-12-25 18:09:13',NULL,NULL),(22308,14378,'TE','9377258466',0,'2013-12-28 03:30:44',NULL,NULL),(21451,13788,'AP','2694457365',0,'2013-12-26 13:10:58',NULL,NULL),(27854,17944,'AP','2106859341',0,'2014-01-15 02:06:41',NULL,NULL),(4143,2645,'TE','2142801579',0,'2013-12-25 19:46:26',NULL,NULL),(20866,13416,'TE','3307533737',0,'2013-12-26 13:00:42',NULL,NULL),(4182,2671,'TE','4402376290',0,'2013-12-25 19:47:03',NULL,NULL),(14431,9431,'AP','4192654006',0,'2013-12-26 04:33:26',NULL,NULL),(11639,7570,'EM','Pibgirl@rocketmail.com',0,'2013-12-26 02:33:45',NULL,NULL),(28375,18282,'EM','ACHARYACHAKRESHWAR@YAHOO.COM',0,'2014-01-16 08:44:48',NULL,NULL),(28961,18692,'AP','5047177079',0,'2014-01-17 03:35:25',NULL,NULL),(32343,21131,'TE','3256601966',0,'2014-02-03 21:00:18',NULL,NULL),(35820,23554,'TE','5133391320',0,'2014-02-13 22:02:41',NULL,NULL),(38165,25190,'TE','5045635947',0,'2014-02-21 22:00:39',NULL,NULL),(38168,25191,'TE','9166009072',0,'2014-02-21 22:00:40',NULL,NULL),(41295,27437,'AP','5044275143',0,'2014-03-04 21:01:50',NULL,NULL),(1783,1104,'AP','9377792897',0,'2013-12-25 18:17:21',NULL,NULL),(25314,16325,'TE','3189460808',0,'2014-01-07 04:01:48',NULL,NULL),(23797,15350,'TE','2163653123',1,'2014-01-02 04:24:31',NULL,NULL),(22154,14271,'TE','6019497571',0,'2013-12-27 02:06:05',NULL,NULL),(9621,6296,'TE','2164022567',0,'2013-12-26 00:45:48',NULL,NULL),(21595,13896,'AP','4198226386',0,'2013-12-26 13:13:36',NULL,NULL),(8378,5513,'TE','7409736230',0,'2013-12-25 23:15:09',NULL,NULL),(21168,13616,'AP','5132053384',0,'2013-12-26 13:05:45',NULL,NULL),(6074,3910,'TE','9368973117',0,'2013-12-25 21:37:05',NULL,NULL),(6730,4372,'EM','taulkat@gmail.com',0,'2013-12-25 22:00:21',NULL,NULL),(11135,7237,'TE','2144489430',0,'2013-12-26 02:01:35',NULL,NULL),(13830,9016,'TE','3306190148',0,'2013-12-26 04:05:14',NULL,NULL),(14396,9413,'AP','9727422607',0,'2013-12-26 04:32:55',NULL,NULL),(34407,22569,'EM','dsirisumana@yahoo.com',0,'2014-02-10 21:31:56',NULL,NULL),(35981,23673,'AP','3372089305',0,'2014-02-14 21:30:26',NULL,NULL),(43029,28611,'TE','4049853352',0,'2014-03-08 21:30:15',NULL,NULL),(10671,6933,'AP','2163702073',0,'2013-12-26 01:46:36',NULL,NULL),(6375,4106,'AP','5103840788',0,'2013-12-25 21:47:52',NULL,NULL),(8923,5840,'TE','9033528646',0,'2013-12-25 23:48:33',NULL,NULL),(27915,17987,'TE','4402235758',0,'2014-01-15 02:06:55',NULL,NULL),(29182,18854,'AP','8284215716',0,'2014-01-17 03:36:17',NULL,NULL),(38882,25699,'TE','3256433248',0,'2014-02-26 09:30:18',NULL,NULL),(42963,28570,'AP','5136927865',0,'2014-03-07 21:32:31',NULL,NULL),(27618,17805,'TE','2108445956',0,'2014-01-15 02:05:50',NULL,NULL),(5367,3437,'TE','9857074021',0,'2013-12-25 21:19:07',NULL,NULL),(9915,6489,'AP','3306901107',0,'2013-12-26 00:50:32',NULL,NULL),(6776,4395,'EM','c.mendez1@yahoo.com',0,'2013-12-25 22:01:01',NULL,NULL),(11469,7459,'TE','9372525526',0,'2013-12-26 02:30:52',NULL,NULL),(14575,9531,'TE','4196611507',0,'2013-12-26 04:35:47',NULL,NULL),(32461,21208,'AP','5047822428',0,'2014-02-03 21:00:57',NULL,NULL),(33226,21758,'TE','9038313851',0,'2014-02-06 21:00:24',NULL,NULL),(33473,21928,'AP','9153735929',0,'2014-02-07 19:00:10',NULL,NULL),(33850,22221,'TE','9852370379',0,'2014-02-09 19:00:26',NULL,NULL),(34496,22629,'EM','ccdc79@sbcglobal.net',0,'2014-02-11 21:00:16',NULL,NULL),(39868,26374,'EM','tinamarie12671@gmail.com',0,'2014-02-28 07:00:15',NULL,NULL),(497,315,'AP','9852853220',0,'2013-12-25 17:31:10',NULL,NULL),(1432,873,'EM','ssnone69@yahoo.com',0,'2013-12-25 18:07:30',NULL,NULL),(25621,16523,'AP','8066269900',1,'2014-01-07 10:21:49',NULL,NULL),(10690,6949,'TE','5135213312',0,'2013-12-26 01:47:00',NULL,NULL),(9468,6195,'AP','8322769907',0,'2013-12-26 00:30:26',NULL,NULL),(2369,1439,'TE','6622075489',0,'2013-12-25 18:47:48',NULL,NULL),(23750,15322,'AP','3239193391',1,'2014-01-02 04:23:36',NULL,NULL),(23118,14903,'AP','4402630483',0,'2013-12-30 00:01:12',NULL,NULL),(7662,4988,'TE','7409273443',0,'2013-12-25 22:46:53',NULL,NULL),(6493,4200,'EM','mesurfin2000@yahoo.com',0,'2013-12-25 21:49:52',NULL,NULL),(6452,4167,'EM','workflash@aol.com',0,'2013-12-25 21:49:09',NULL,NULL),(11477,7465,'AP','6013913058',0,'2013-12-26 02:31:01',NULL,NULL),(2536,1551,'EM','cheriannpray247@aol.com',0,'2013-12-25 18:50:37',NULL,NULL),(30152,19536,'AP','4194785669',0,'2014-01-23 03:02:23',NULL,NULL),(30739,19973,'TE','4198337455',0,'2014-01-25 19:00:12',NULL,NULL),(31038,20192,'TE','9376222504',0,'2014-01-27 21:01:27',NULL,NULL),(32104,20966,'TE','9562369604',0,'2014-02-01 19:00:12',NULL,NULL),(32493,21232,'TE','4408923603',0,'2014-02-03 21:01:09',NULL,NULL),(35410,23278,'EM','cle.torres@gmail.com',0,'2014-02-13 21:30:15',NULL,NULL),(35845,23569,'TE','5133711228',0,'2014-02-13 22:02:50',NULL,NULL),(37052,24399,'EM','tacolowen1@fuse.net',0,'2014-02-18 22:00:54',NULL,NULL),(41418,27516,'AP','5133443417',0,'2014-03-04 21:02:37',NULL,NULL),(42973,28576,'EM','s.hoshimiya@gmail.com',0,'2014-03-08 21:00:05',NULL,NULL),(435,269,'TE','5137326466',0,'2013-12-25 17:22:02',NULL,NULL),(21965,14150,'TE','3187510158',0,'2013-12-27 02:02:52',NULL,NULL),(8842,5792,'TE','3308484604',0,'2013-12-25 23:47:17',NULL,NULL),(10102,6600,'TE','6017945455',0,'2013-12-26 00:53:32',NULL,NULL),(5175,3321,'EM','klf1224@att.net',0,'2013-12-25 21:16:05',NULL,NULL),(3964,2516,'TE','6012094902',0,'2013-12-25 19:36:27',NULL,NULL),(3565,2231,'AP','5133835100',0,'2013-12-25 19:20:49',NULL,NULL),(32072,20943,'AP','2142648165',0,'2014-01-31 21:01:44',NULL,NULL),(32642,21348,'TE','9364339406',0,'2014-02-04 21:00:36',NULL,NULL),(34930,22921,'AP','7158920805',0,'2014-02-11 21:02:55',NULL,NULL),(36904,24303,'AP','4194390912',0,'2014-02-18 21:30:21',NULL,NULL),(38578,25496,'AP','5132848620',0,'2014-02-25 21:31:51',NULL,NULL),(42779,28452,'TE','5044153797',0,'2014-03-07 21:31:20',NULL,NULL),(43455,28858,'AP','5133024955',0,'2014-03-09 21:30:01',NULL,NULL),(169,99,'AP','7139922081',0,'2013-12-25 17:17:41',NULL,NULL),(27234,17533,'TE','6016876570',0,'2014-01-13 03:01:44',NULL,NULL),(1454,888,'AP','5132071682',0,'2013-12-25 18:07:56',NULL,NULL),(25779,16612,'AP','2163702690',0,'2014-01-08 18:24:08',NULL,NULL),(8049,5268,'TE','3309906159',0,'2013-12-25 23:05:32',NULL,NULL),(6467,4183,'TE','3306583429',0,'2013-12-25 21:49:28',NULL,NULL),(21685,13962,'TE','9376579994',0,'2013-12-26 13:15:10',NULL,NULL),(21252,13658,'TE','9852260112',0,'2013-12-26 13:07:32',NULL,NULL),(1879,1159,'EM','rcharters87@gmail.com',0,'2013-12-25 18:18:51',NULL,NULL),(13545,8833,'EM','Eduardoribeiro1@mac.com',0,'2013-12-26 04:00:34',NULL,NULL),(11191,7277,'TE','2812220970',0,'2013-12-26 02:02:35',NULL,NULL),(6310,4066,'TE','6147911715',0,'2013-12-25 21:46:49',NULL,NULL),(1916,1184,'EM','rrutan6244@gmail.com',0,'2013-12-25 18:19:29',NULL,NULL),(6097,3927,'TE','5134883600',0,'2013-12-25 21:37:31',NULL,NULL),(28416,18308,'TE','5136623039',0,'2014-01-16 08:45:01',NULL,NULL),(31650,20649,'TE','8176967347',0,'2014-01-30 21:00:37',NULL,NULL),(32091,20959,'TE','9153280768',0,'2014-02-01 19:00:08',NULL,NULL),(32166,21013,'TE','6146482484',0,'2014-02-01 19:00:35',NULL,NULL),(32177,21017,'AP','5135948249',0,'2014-02-01 19:00:37',NULL,NULL),(33580,22014,'AP','5133498264',0,'2014-02-07 19:00:54',NULL,NULL),(33584,22017,'TE','6628090939',0,'2014-02-07 19:00:56',NULL,NULL),(38350,25333,'EM','emjackson78@yahoo.com',0,'2014-02-25 21:30:20',NULL,NULL),(39976,26469,'TE','6013825484',0,'2014-02-28 07:30:36',NULL,NULL),(42263,28070,'TE','3309748865',0,'2014-03-06 21:01:50',NULL,NULL),(3761,2385,'EM','AHONECK@NEO.RR.COM',0,'2013-12-25 19:33:08',NULL,NULL),(10616,6907,'TE','9852122535',0,'2013-12-26 01:45:49',NULL,NULL),(27026,17379,'AP','3305737678',0,'2014-01-13 03:00:05',NULL,NULL),(25752,16595,'AP','3373498174',0,'2014-01-08 18:24:02',NULL,NULL),(25405,16387,'EM','marciaprovence@gmail.com',0,'2014-01-07 04:03:28',NULL,NULL),(25071,16163,'BN','7134599700',0,'2014-01-04 06:00:15',NULL,NULL),(10518,6851,'AP','8324773366',0,'2013-12-26 01:31:23',NULL,NULL),(13905,9064,'TE','4326990720',0,'2013-12-26 04:06:27',NULL,NULL),(28688,18514,'TE','4193581530',0,'2014-01-16 08:46:34',NULL,NULL),(37767,24925,'TE','6013474332',0,'2014-02-20 21:30:16',NULL,NULL),(40762,27087,'TE','3306077559',0,'2014-03-03 21:30:15',NULL,NULL),(42302,28089,'TE','2104153795',0,'2014-03-06 21:02:03',NULL,NULL),(27962,18023,'AP','3303973732',0,'2014-01-15 02:07:06',NULL,NULL),(27079,17417,'TE','9374444193',0,'2014-01-13 03:00:25',NULL,NULL),(25008,16115,'AP','3375911777',0,'2014-01-04 02:05:15',NULL,NULL),(21824,14061,'TE','2162551124',0,'2013-12-27 02:00:34',NULL,NULL),(9710,6356,'EM','DBDREETY@SBCGLOBAL.NET',0,'2013-12-26 00:47:13',NULL,NULL),(5439,3483,'TE','4403464401',0,'2013-12-25 21:20:14',NULL,NULL),(9708,6356,'TE','9376439855',0,'2013-12-26 00:47:13',NULL,NULL),(3619,2289,'TE','9377672155',0,'2013-12-25 19:30:43',NULL,NULL),(7714,5037,'EM','dan@ergodesktop.com',0,'2013-12-25 22:47:55',NULL,NULL),(29901,19348,'EM','kmccoy2010@hotmail.com',1,'2014-01-22 03:22:25',NULL,NULL),(30082,19489,'TE','5052154172',0,'2014-01-23 03:02:06',NULL,NULL),(33758,22151,'EM','nyyankees66@sbcglobal.net',0,'2014-02-08 19:00:54',NULL,NULL),(35707,23483,'EM','stephaniebrewer@alumni.lsu.edu',0,'2014-02-13 22:01:57',NULL,NULL),(35769,23523,'TE','3306057787',0,'2014-02-13 22:02:22',NULL,NULL),(37328,24568,'TE','6142183307',0,'2014-02-20 04:07:12',NULL,NULL),(40420,26832,'TE','6147940146',0,'2014-03-01 21:00:41',NULL,NULL),(164,96,'EM','hmsnine@gmail.com',0,'2013-12-25 17:17:36',NULL,NULL),(1940,1200,'TE','7402961517',0,'2013-12-25 18:19:52',NULL,NULL),(8725,5723,'AP','3187300341',0,'2013-12-25 23:45:28',NULL,NULL),(25558,16487,'EM','kcorne.oh@gmail.com',0,'2014-01-07 04:06:26',NULL,NULL),(27792,17914,'TE','5124668369',0,'2014-01-15 02:06:28',NULL,NULL),(24570,15846,'EM','Karenmichele79@hotmail.com',0,'2014-01-03 02:04:20',NULL,NULL),(7666,4990,'TE','5138501717',0,'2013-12-25 22:46:57',NULL,NULL),(23808,15359,'AP','3302070370',1,'2014-01-02 04:24:44',NULL,NULL),(7556,4920,'TE','2343127200',0,'2013-12-25 22:45:09',NULL,NULL),(7473,4865,'TE','6147954359',0,'2013-12-25 22:30:48',NULL,NULL),(2310,1411,'EM','kls1751@yahoo.com',0,'2013-12-25 18:46:57',NULL,NULL),(28895,18654,'AP','2102157293',0,'2014-01-17 03:35:11',NULL,NULL),(31114,20258,'AP','5136751654',0,'2014-01-28 21:00:17',NULL,NULL),(32449,21202,'AP','5043433409',0,'2014-02-03 21:00:54',NULL,NULL),(35183,23107,'EM','a1dreamworks@gmail.com',0,'2014-02-12 21:31:16',NULL,NULL),(36727,24183,'TE','3304739345',0,'2014-02-16 19:00:08',NULL,NULL),(36868,24280,'TE','3306125560',0,'2014-02-18 21:30:06',NULL,NULL),(37003,24366,'TE','5044730074',0,'2014-02-18 22:00:34',NULL,NULL),(38494,25438,'AP','2816427919',0,'2014-02-25 21:31:19',NULL,NULL),(40707,27044,'TE','4194752950',0,'2014-03-03 21:00:23',NULL,NULL),(41884,27851,'TE','9563585457',0,'2014-03-05 21:32:13',NULL,NULL),(43926,29140,'TE','4199561684',0,'2014-03-10 21:02:42',NULL,NULL),(8381,5517,'AP','7406038877',0,'2013-12-25 23:15:13',NULL,NULL),(3304,2078,'EM','cdevillier@prohook.com',0,'2013-12-25 19:16:34',NULL,NULL),(27112,17439,'BN','4194387621',0,'2014-01-13 03:00:35',NULL,NULL),(7738,5050,'TE','5632494664',0,'2013-12-25 23:00:10',NULL,NULL),(7477,4866,'AP','4193452959',0,'2013-12-25 22:30:51',NULL,NULL),(25248,16282,'TE','4192245256',0,'2014-01-07 04:00:33',NULL,NULL),(22865,14754,'EM','namgoodie22@yahoo.com',1,'2013-12-29 11:10:24',NULL,NULL),(22699,14641,'TE','2102942010',1,'2013-12-29 11:07:27',NULL,NULL),(7451,4852,'AP','9377659953',0,'2013-12-25 22:30:25',NULL,NULL),(20861,13413,'AP','5132533702',0,'2013-12-26 13:00:36',NULL,NULL),(3776,2395,'TE','5136525532',0,'2013-12-25 19:33:24',NULL,NULL),(29161,18839,'EM','nazolder1@yahoo.com',0,'2014-01-17 03:36:12',NULL,NULL),(30893,20083,'TE','5046673337',0,'2014-01-27 21:00:24',NULL,NULL),(33073,21662,'AP','9859920471',0,'2014-02-05 21:30:55',NULL,NULL),(35263,23158,'AP','2813189377',0,'2014-02-12 21:31:46',NULL,NULL),(37623,24797,'TE','6145569340',0,'2014-02-20 04:47:47',NULL,NULL),(38083,25139,'AP','9039171382',0,'2014-02-21 22:00:09',NULL,NULL),(40913,27186,'EM','rudge-fraga@hotmail.com',0,'2014-03-03 21:31:13',NULL,NULL),(40952,27212,'AP','4192034451',0,'2014-03-03 21:31:29',NULL,NULL),(42879,28516,'AP','4194943562',0,'2014-03-07 21:31:57',NULL,NULL),(43213,28716,'TE','9372893149',0,'2014-03-08 21:31:18',NULL,NULL),(1308,798,'TE','8179216139',0,'2013-12-25 18:05:29',NULL,NULL),(26569,17091,'AP','3257620137',0,'2014-01-13 02:21:28',NULL,NULL),(11518,7495,'EM','JOHNSAXOUR@YAHOO.COM',0,'2013-12-26 02:31:43',NULL,NULL),(10974,7132,'TE','6016842922',0,'2013-12-26 01:51:38',NULL,NULL),(28167,18156,'AP','4193881110',0,'2014-01-15 02:07:52',NULL,NULL),(24294,15696,'EM','RODNEYMESSER@GMAIL.COM',1,'2014-01-02 04:35:34',NULL,NULL),(28233,18208,'TE','9372156423',0,'2014-01-15 02:08:08',NULL,NULL),(23462,15124,'TE','7404252609',0,'2014-01-01 12:05:19',NULL,NULL),(23226,14968,'EM','jmo8538@yahoo.com',0,'2014-01-01 12:00:42',NULL,NULL),(7314,4757,'EM','racox59@yahoo.com',0,'2013-12-25 22:15:26',NULL,NULL),(5878,3771,'EM','spamboxfull@aol.com',0,'2013-12-25 21:33:42',NULL,NULL),(25962,16723,'EM','LOCH1965@YAHOO.COM',0,'2014-01-08 18:24:47',NULL,NULL),(30822,20039,'AP','5133931680',0,'2014-01-26 19:00:25',NULL,NULL),(30956,20136,'TE','5132594238',0,'2014-01-27 21:00:55',NULL,NULL),(33965,22283,'AP','5135602756',0,'2014-02-10 11:00:24',NULL,NULL),(34018,22312,'EM','melvinwalker1960@gmail.com',0,'2014-02-10 11:00:46',NULL,NULL),(35952,23653,'EM','MIREYAZUNIGA1237@GMAIL.COM',0,'2014-02-14 21:30:15',NULL,NULL),(37474,24677,'AP','9365911036',0,'2014-02-20 04:29:24',NULL,NULL),(40007,26504,'TE','5132768121',0,'2014-02-28 21:00:16',NULL,NULL),(42335,28113,'EM','stacfish2005@gmail.com',0,'2014-03-06 21:02:16',NULL,NULL),(43715,29020,'EM','bos3kids@gmail.com',0,'2014-03-10 21:01:29',NULL,NULL),(1604,987,'EM','paul.egli3@gmail.com',0,'2013-12-25 18:10:29',NULL,NULL),(28184,18166,'AP','9377284326',0,'2014-01-15 02:07:56',NULL,NULL),(3417,2146,'TE','9375445429',0,'2013-12-25 19:18:25',NULL,NULL),(6224,4012,'EM','cdfennimo@yahoo.com',0,'2013-12-25 21:45:27',NULL,NULL),(8282,5427,'TE','6622750843',0,'2013-12-25 23:09:33',NULL,NULL),(21958,14144,'TE','5046829282',0,'2013-12-27 02:02:44',NULL,NULL),(21852,14075,'TE','6144723839',0,'2013-12-27 02:00:59',NULL,NULL),(21466,13793,'EM','charlotterobinson82@gmail.com',0,'2013-12-26 13:11:10',NULL,NULL),(21050,13540,'TE','3183472608',0,'2013-12-26 13:03:46',NULL,NULL),(14891,9745,'AP','2149302724',0,'2013-12-26 04:46:02',NULL,NULL),(14242,9317,'AP','5055042988',0,'2013-12-26 04:30:25',NULL,NULL),(28997,18718,'EM','jervinsifu@att.net',0,'2014-01-17 03:35:33',NULL,NULL),(30498,19782,'EM','gmealka@gmail.com',0,'2014-01-23 21:01:35',NULL,NULL),(31099,20248,'TE','7133054022',0,'2014-01-28 21:00:11',NULL,NULL),(31432,20490,'TE','5045541151',0,'2014-01-29 21:01:06',NULL,NULL),(33139,21707,'EM','multiconelec@comcast.net',0,'2014-02-05 21:31:13',NULL,NULL),(34076,22338,'EM','buchholzlaura@yahoo.com',0,'2014-02-10 11:01:06',NULL,NULL),(37750,24908,'EM','onlieone@earthlink.net',0,'2014-02-20 21:30:06',NULL,NULL),(38696,25572,'TE','4197208931',0,'2014-02-26 08:00:31',NULL,NULL),(41071,27284,'TE','8323398345',0,'2014-03-04 21:00:24',NULL,NULL),(10889,7076,'AP','9379015783',0,'2013-12-26 01:50:11',NULL,NULL),(27307,17587,'TE','3308823622',0,'2014-01-14 01:32:08',NULL,NULL),(3349,2105,'AP','5133824128',0,'2013-12-25 19:17:18',NULL,NULL),(10111,6610,'AP','9374072470',0,'2013-12-26 00:53:44',NULL,NULL),(21571,13871,'TE','3307459530',0,'2013-12-26 13:13:04',NULL,NULL),(7144,4659,'AP','2253178528',0,'2013-12-25 22:07:20',NULL,NULL),(20914,13450,'TE','3306122882',0,'2013-12-26 13:01:28',NULL,NULL),(6784,4400,'AP','7403192000',0,'2013-12-25 22:01:09',NULL,NULL),(6745,4379,'EM','reyhan.hoq@gmail.com',0,'2013-12-25 22:00:34',NULL,NULL),(12340,8071,'TE','5132071794',0,'2013-12-26 03:10:14',NULL,NULL),(11798,7672,'EM','pastorrexking@agchurches.org',0,'2013-12-26 03:00:37',NULL,NULL),(5935,3805,'AP','4402512222',0,'2013-12-25 21:34:38',NULL,NULL),(4506,2867,'TE','9375649179',0,'2013-12-25 20:01:48',NULL,NULL),(32864,21507,'EM','tom.rowley@ymail.com',0,'2014-02-04 21:01:56',NULL,NULL),(36497,24029,'AP','4193085329',0,'2014-02-15 22:00:52',NULL,NULL),(36817,24246,'TE','3303987896',0,'2014-02-16 19:00:41',NULL,NULL),(37706,24860,'EM','gswing14@hotmail.com',0,'2014-02-20 04:56:57',NULL,NULL),(38279,25274,'TE','2102796852',0,'2014-02-25 21:00:14',NULL,NULL),(1695,1041,'AP','9564348422',0,'2013-12-25 18:15:47',NULL,NULL),(1990,1229,'TE','3308357358',0,'2013-12-25 18:20:39',NULL,NULL),(11608,7549,'AP','2252875233',0,'2013-12-26 02:33:10',NULL,NULL),(25886,16688,'TE','2148081962',0,'2014-01-08 18:24:33',NULL,NULL),(7857,5127,'TE','5129169636',0,'2013-12-25 23:02:07',NULL,NULL),(21644,13931,'TE','4195357178',0,'2013-12-26 13:14:29',NULL,NULL),(11440,7441,'AP','4197871986',0,'2013-12-26 02:30:26',NULL,NULL),(24855,16029,'BN','3182063775',0,'2014-01-04 02:02:26',NULL,NULL),(30258,19600,'TE','4196904867',0,'2014-01-23 03:02:48',NULL,NULL),(34860,22862,'TE','6016683263',0,'2014-02-11 21:02:25',NULL,NULL),(35932,23641,'AP','9034568312',0,'2014-02-14 21:30:09',NULL,NULL),(39736,26281,'TE','9852329861',0,'2014-02-28 06:31:20',NULL,NULL),(42236,28055,'AP','6014155876',0,'2014-03-06 21:01:40',NULL,NULL),(173,103,'TE','9033311776',0,'2013-12-25 17:17:46',NULL,NULL),(1002,617,'EM','tdcapuano@aol.com',0,'2013-12-25 18:00:44',NULL,NULL),(22517,14520,'TE','8328002485',0,'2013-12-28 03:34:16',NULL,NULL),(14924,9765,'AP','4405204152',0,'2013-12-26 05:00:18',NULL,NULL),(22005,14172,'EM','kurtsimmons@mac.com',0,'2013-12-27 02:03:30',NULL,NULL),(21759,14015,'TE','5138762851',0,'2013-12-26 13:16:29',NULL,NULL),(23772,15332,'AP','8309980492',1,'2014-01-02 04:23:57',NULL,NULL),(24070,15539,'EM','CANDYFRED616@YAHOO.COM',1,'2014-01-02 04:30:55',NULL,NULL),(27331,17599,'EM','rbriggs523@yahoo.com',0,'2014-01-14 01:32:15',NULL,NULL),(28818,18600,'TE','6013460643',0,'2014-01-16 08:47:18',NULL,NULL),(30374,19677,'AP','8326206201',0,'2014-01-23 21:00:36',NULL,NULL),(31197,20317,'TE','2814384805',0,'2014-01-28 21:00:53',NULL,NULL),(34307,22511,'TE','9033351352',0,'2014-02-10 21:31:19',NULL,NULL),(34437,22591,'AP','4192501780',0,'2014-02-10 21:32:09',NULL,NULL),(35142,23078,'EM','kkossick@me.com',0,'2014-02-12 21:31:02',NULL,NULL),(35390,23258,'AP','4322718750',0,'2014-02-13 21:30:09',NULL,NULL),(38805,25657,'TE','4195890061',0,'2014-02-26 08:30:42',NULL,NULL),(39749,26287,'AP','5044816712',0,'2014-02-28 06:31:22',NULL,NULL),(40343,26775,'EM','larryfitzsimmons54@yahoo.com',0,'2014-03-01 21:00:10',NULL,NULL),(42225,28050,'AP','6018317325',0,'2014-03-06 21:01:37',NULL,NULL),(432,265,'TE','4192361740',0,'2013-12-25 17:21:57',NULL,NULL),(23947,15450,'EM','daniel.cohen1970@gmail.com',1,'2014-01-02 04:28:22',NULL,NULL),(5513,3528,'TE','4325538325',0,'2013-12-25 21:21:25',NULL,NULL),(2249,1377,'EM','kimjdavidson1@gmail.com',0,'2013-12-25 18:46:00',NULL,NULL),(20721,13318,'EM','bmileyko@yahoo.com',0,'2013-12-26 12:58:17',NULL,NULL),(20480,13191,'TE','8187318162',0,'2013-12-26 12:54:38',NULL,NULL),(10617,6907,'AP','9852122535',0,'2013-12-26 01:45:49',NULL,NULL),(10368,6758,'TE','2164096518',0,'2013-12-26 01:16:18',NULL,NULL),(5290,3392,'EM','Susiegreenwell@att.net',0,'2013-12-25 21:17:52',NULL,NULL),(7329,4764,'AP','6142047722',0,'2013-12-25 22:15:39',NULL,NULL),(3075,1919,'TE','2163164086',0,'2013-12-25 19:00:07',NULL,NULL),(2933,1804,'TE','5133798642',0,'2013-12-25 18:56:51',NULL,NULL),(27067,17409,'TE','5126530714',0,'2014-01-13 03:00:21',NULL,NULL),(29189,18857,'EM','Vdiva35@aol.com',0,'2014-01-17 03:36:19',NULL,NULL),(29287,18918,'EM','kurtandfam@aol.com',0,'2014-01-17 03:36:42',NULL,NULL),(32814,21470,'TE','6012094066',0,'2014-02-04 21:01:38',NULL,NULL),(32970,21582,'EM','amiller0364@sbcglobal.net',0,'2014-02-05 21:30:26',NULL,NULL),(33874,22234,'TE','2106694395',0,'2014-02-09 19:00:34',NULL,NULL),(35570,23392,'TE','5138855394',0,'2014-02-13 22:01:06',NULL,NULL),(38533,25462,'EM','willie.parrott@aol.com',0,'2014-02-25 21:31:33',NULL,NULL),(39186,25918,'TE','9795622469',0,'2014-02-26 21:01:19',NULL,NULL),(39462,26096,'TE','7194860057',0,'2014-02-28 06:30:10',NULL,NULL),(40261,26710,'AP','5133143655',0,'2014-02-28 21:31:38',NULL,NULL),(41575,27641,'EM','patrick.whiteIII@gmail.com',0,'2014-03-05 21:30:16',NULL,NULL),(4351,2775,'EM','donna.l.northrop@gmail.com',0,'2013-12-25 19:49:40',NULL,NULL),(23587,15226,'EM','porter.cynthia73@yahoo.com',0,'2014-01-01 12:08:11',NULL,NULL),(10860,7049,'AP','7172090776',0,'2013-12-26 01:49:39',NULL,NULL),(20574,13239,'TE','5128004647',0,'2013-12-26 12:56:01',NULL,NULL),(14748,9646,'AP','4093921901',0,'2013-12-26 04:38:38',NULL,NULL),(24454,15785,'EM','michaeljvandyke@icloud.com',0,'2014-01-03 02:02:18',NULL,NULL),(27020,17377,'TE','3302658969',0,'2014-01-13 03:00:04',NULL,NULL),(28836,18615,'AP','9376315462',0,'2014-01-16 08:47:25',NULL,NULL),(30585,19843,'AP','2254442948',0,'2014-01-24 21:00:27',NULL,NULL),(36881,24289,'EM','amandamcneal2@gmail.com',0,'2014-02-18 21:30:12',NULL,NULL),(37575,24754,'AP','6146535499',0,'2014-02-20 04:41:57',NULL,NULL),(38226,25234,'EM','joshfath@gmail.com',0,'2014-02-21 22:01:04',NULL,NULL),(42880,28516,'EM','matthew.william.browne@gmail.com',0,'2014-03-07 21:31:57',NULL,NULL),(6294,4056,'TE','3307479551',0,'2013-12-25 21:46:34',NULL,NULL),(1244,756,'EM','tjptrsat@usermail.com',0,'2013-12-25 18:04:26',NULL,NULL),(23466,15134,'TE','7347885308',0,'2014-01-01 12:05:31',NULL,NULL),(3727,2365,'TE','3305717761',0,'2013-12-25 19:32:36',NULL,NULL),(21831,14064,'TE','6144171909',0,'2013-12-27 02:00:40',NULL,NULL),(7180,4680,'AP','3376619555',0,'2013-12-25 22:07:52',NULL,NULL),(14128,9254,'TE','4097873166',0,'2013-12-26 04:15:05',NULL,NULL),(7750,5060,'AP','8177077614',0,'2013-12-25 23:00:25',NULL,NULL),(25767,16604,'BN','2252870388',0,'2014-01-08 18:24:05',NULL,NULL),(26347,16958,'EM','BrianJamesPE@msn.com',0,'2014-01-13 02:20:05',NULL,NULL),(29696,19199,'AP','2817481800',0,'2014-01-21 08:46:15',NULL,NULL),(33079,21668,'TE','5042286487',0,'2014-02-05 21:30:57',NULL,NULL),(38778,25635,'EM','jonniquelewis1@gmail.com',0,'2014-02-26 08:30:27',NULL,NULL),(41206,27369,'TE','6013166455',0,'2014-03-04 21:01:15',NULL,NULL),(41404,27507,'AP','4192903672',0,'2014-03-04 21:02:31',NULL,NULL),(43207,28712,'EM','Ariebogan_1978@yahoo.com',0,'2014-03-08 21:31:15',NULL,NULL),(852,529,'TE','2282076783',0,'2013-12-25 17:49:25',NULL,NULL),(24097,15554,'TE','9852248383',1,'2014-01-02 04:31:24',NULL,NULL),(20956,13481,'AP','5136088540',0,'2013-12-26 13:02:13',NULL,NULL),(20596,13248,'TE','9565603170',0,'2013-12-26 12:56:19',NULL,NULL),(23515,15169,'AP','5134177715',0,'2014-01-01 12:06:31',NULL,NULL),(23546,15197,'TE','6019810527',0,'2014-01-01 12:07:18',NULL,NULL),(28324,18255,'AP','9036584519',0,'2014-01-16 08:44:33',NULL,NULL),(29934,19373,'TE','3307845810',1,'2014-01-22 03:22:37',NULL,NULL),(31874,20805,'EM','raypadia@gmail.com',0,'2014-01-31 21:00:25',NULL,NULL),(32129,20983,'AP','3378424128',0,'2014-02-01 19:00:21',NULL,NULL),(34473,22619,'EM','cnrnorma@1starnet.com',0,'2014-02-11 21:00:09',NULL,NULL),(36749,24195,'EM','bgal231@gmail.com',0,'2014-02-16 19:00:15',NULL,NULL),(41500,27588,'AP','2818275075',0,'2014-03-05 21:00:16',NULL,NULL),(43177,28693,'TE','3184228606',0,'2014-03-08 21:31:04',NULL,NULL),(3334,2096,'AP','3302062344',0,'2013-12-25 19:17:02',NULL,NULL),(24944,16079,'TE','4403656114',0,'2014-01-04 02:04:03',NULL,NULL),(9015,5915,'EM','CLICK2DARK@AOL.COM',0,'2013-12-25 23:50:09',NULL,NULL),(9378,6137,'EM','glenndougie@yahoo.com',0,'2013-12-26 00:16:11',NULL,NULL),(8275,5419,'EM','walker856@att.net',0,'2013-12-25 23:09:22',NULL,NULL),(11438,7440,'EM','ehaiflich@neo.rr.com',0,'2013-12-26 02:30:24',NULL,NULL),(12432,8145,'TE','3307947419',0,'2013-12-26 03:15:51',NULL,NULL),(12469,8165,'TE','4409866985',0,'2013-12-26 03:16:28',NULL,NULL),(8119,5316,'TE','6142742091',0,'2013-12-25 23:06:43',NULL,NULL),(7298,4751,'EM','theresa.rothschild@gmail.com',0,'2013-12-25 22:15:13',NULL,NULL),(5163,3314,'AP','5134768083',0,'2013-12-25 21:15:55',NULL,NULL),(26440,17014,'AP','5183644741',0,'2014-01-13 02:20:37',NULL,NULL),(26779,17227,'EM','aca.hbailey@outlook.com',0,'2014-01-13 02:22:37',NULL,NULL),(27982,18038,'AP','4197047307',0,'2014-01-15 02:07:11',NULL,NULL),(28322,18254,'TE','9158570660',0,'2014-01-16 08:44:32',NULL,NULL),(28826,18609,'AP','9376575206',0,'2014-01-16 08:47:22',NULL,NULL),(29952,19383,'TE','9562673416',1,'2014-01-22 03:22:43',NULL,NULL),(30661,19903,'AP','4197792004',0,'2014-01-24 21:00:56',NULL,NULL),(30814,20035,'TE','4404172706',0,'2014-01-26 19:00:23',NULL,NULL),(32227,21048,'AP','4694711615',0,'2014-02-02 19:00:05',NULL,NULL),(32852,21500,'TE','4199321586',0,'2014-02-04 21:01:51',NULL,NULL),(36061,23719,'AP','8057014328',0,'2014-02-14 21:30:51',NULL,NULL),(37234,24502,'EM','rricardo85@yahoo.com',0,'2014-02-20 03:49:48',NULL,NULL),(37264,24520,'AP','9159229979',0,'2014-02-20 03:57:00',NULL,NULL),(37300,24544,'TE','3304847107',0,'2014-02-20 04:03:20',NULL,NULL),(37406,24633,'AP','9034525671',0,'2014-02-20 04:18:37',NULL,NULL),(37665,24833,'TE','6019419363',0,'2014-02-20 04:52:41',NULL,NULL),(1805,1117,'AP','9378027153',0,'2013-12-25 18:17:42',NULL,NULL),(11263,7340,'TE','3306067567',0,'2013-12-26 02:04:01',NULL,NULL),(6328,4080,'TE','3302341069',0,'2013-12-25 21:47:10',NULL,NULL),(21954,14142,'TE','3187330188',0,'2013-12-27 02:02:41',NULL,NULL),(2737,1659,'TE','5122897788',0,'2013-12-25 18:53:36',NULL,NULL),(28670,18492,'TE','3303225983',0,'2014-01-16 08:46:26',NULL,NULL),(33857,22224,'AP','3306084463',0,'2014-02-09 19:00:28',NULL,NULL),(34534,22654,'TE','9033123742',0,'2014-02-11 21:00:30',NULL,NULL),(35100,23055,'AP','5042967858',0,'2014-02-12 21:30:48',NULL,NULL),(36479,24015,'EM','weddingflorist13@gmail.com',0,'2014-02-15 22:00:43',NULL,NULL),(36890,24296,'TE','9373827461',0,'2014-02-18 21:30:16',NULL,NULL),(37274,24528,'TE','3618527663',0,'2014-02-20 03:59:45',NULL,NULL),(43448,28854,'AP','5133351223',0,'2014-03-09 21:01:21',NULL,NULL),(2050,1269,'EM','grade_it@yahoo.com',0,'2013-12-25 18:30:13',NULL,NULL),(22798,14701,'TE','7203942216',1,'2013-12-29 11:09:04',NULL,NULL),(22816,14714,'AP','2164963787',1,'2013-12-29 11:09:23',NULL,NULL),(2236,1372,'AP','4695103399',0,'2013-12-25 18:45:49',NULL,NULL),(23676,15288,'TE','6013767628',1,'2014-01-02 04:22:21',NULL,NULL),(6925,4511,'AP','8172967832',0,'2013-12-25 22:03:37',NULL,NULL),(8004,5223,'AP','4194968555',0,'2013-12-25 23:04:35',NULL,NULL),(21395,13757,'TE','6012912205',0,'2013-12-26 13:10:07',NULL,NULL),(8602,5652,'AP','9154439316',0,'2013-12-25 23:31:33',NULL,NULL),(13654,8904,'TE','6144996691',0,'2013-12-26 04:02:22',NULL,NULL),(8973,5883,'TE','4404877868',0,'2013-12-25 23:49:28',NULL,NULL),(10955,7121,'AP','6013355689',0,'2013-12-26 01:51:20',NULL,NULL),(9238,6046,'EM','toniotchere@gmail.com',0,'2013-12-26 00:01:34',NULL,NULL),(9202,6022,'TE','9153739670',0,'2013-12-26 00:00:54',NULL,NULL),(24867,16036,'TE','3373159950',0,'2014-01-04 02:02:40',NULL,NULL),(25991,16746,'EM','ebaristot@yahoo.com',0,'2014-01-08 18:24:53',NULL,NULL),(27448,17680,'EM','rick-tti@comcast.net',0,'2014-01-14 01:32:54',NULL,NULL),(28762,18560,'TE','9377799127',0,'2014-01-16 08:46:58',NULL,NULL),(34093,22348,'TE','4199600220',0,'2014-02-10 11:01:13',NULL,NULL),(35439,23301,'EM','ihchernoff@alumni.unc.edu',0,'2014-02-13 22:00:14',NULL,NULL),(36648,24126,'TE','3183326369',0,'2014-02-15 22:01:45',NULL,NULL),(37142,24448,'EM','ROMAX02@YAHOO.COM',0,'2014-02-18 22:01:25',NULL,NULL),(42552,28317,'TE','2816502933',0,'2014-03-07 21:30:02',NULL,NULL),(3136,1955,'TE','8176816774',0,'2013-12-25 19:01:05',NULL,NULL),(23492,15149,'TE','5133934215',0,'2014-01-01 12:06:01',NULL,NULL),(23287,15004,'TE','8327791871',0,'2014-01-01 12:01:49',NULL,NULL),(7946,5185,'EM','jasongearin@gmail.com',0,'2013-12-25 23:03:37',NULL,NULL),(8235,5388,'TE','5043444289',0,'2013-12-25 23:08:35',NULL,NULL),(21434,13780,'AP','9372602407',0,'2013-12-26 13:10:43',NULL,NULL),(21741,14004,'EM','mtbecker@gmail.com',0,'2013-12-26 13:16:11',NULL,NULL),(25695,16567,'TE','5672496586',1,'2014-01-07 10:23:13',NULL,NULL),(26256,16897,'AP','9375324274',0,'2014-01-13 02:19:31',NULL,NULL),(29217,18873,'TE','5042207540',0,'2014-01-17 03:36:25',NULL,NULL),(34830,22843,'TE','5672045273',0,'2014-02-11 21:02:15',NULL,NULL),(35384,23254,'TE','3306717566',0,'2014-02-13 21:30:07',NULL,NULL),(36906,24304,'AP','3306067567',0,'2014-02-18 21:30:22',NULL,NULL),(41731,27748,'EM','chey_walk@yahoo.com',0,'2014-03-05 21:31:13',NULL,NULL),(43569,28934,'TE','2162724458',0,'2014-03-10 21:00:38',NULL,NULL),(308,189,'EM','ttgleghorn@aol.com',0,'2013-12-25 17:19:55',NULL,NULL),(7343,4773,'AP','5133653806',0,'2013-12-25 22:15:53',NULL,NULL),(4854,3107,'EM','murrayace@embarqmail.com',0,'2013-12-25 20:20:26',NULL,NULL),(11449,7445,'EM','danneile_lagace@yahoo.com',0,'2013-12-26 02:30:33',NULL,NULL),(20527,13213,'TE','8324191494',0,'2013-12-26 12:55:19',NULL,NULL),(11620,7557,'TE','9379359669',0,'2013-12-26 02:33:23',NULL,NULL),(14249,9322,'AP','2253244086',0,'2013-12-26 04:30:31',NULL,NULL),(25359,16353,'TE','4404541885',0,'2014-01-07 04:02:34',NULL,NULL),(29666,19169,'EM','davebk@pdq.net',0,'2014-01-21 08:46:02',NULL,NULL),(34574,22671,'TE','2107201631',0,'2014-02-11 21:00:42',NULL,NULL),(37943,25035,'EM','Brandoncarriveau@yahoo.com',0,'2014-02-20 22:01:06',NULL,NULL),(39204,25927,'EM','dora.trevizo@yahoo.com',0,'2014-02-26 21:01:24',NULL,NULL),(39214,25933,'EM','lizdbeam@gmail.com',0,'2014-02-26 21:01:27',NULL,NULL),(40484,26867,'EM','marykirk384@yahoo.com',0,'2014-03-01 21:01:01',NULL,NULL),(40528,26901,'TE','8068945975',0,'2014-03-03 01:00:07',NULL,NULL),(318,198,'TE','3306782298',0,'2013-12-25 17:20:07',NULL,NULL),(22869,14756,'AP','4198899540',1,'2013-12-29 11:10:28',NULL,NULL),(21675,13954,'AP','5133483505',0,'2013-12-26 13:15:00',NULL,NULL),(6359,4096,'EM','dchalwick@bex.net',0,'2013-12-25 21:47:37',NULL,NULL),(14578,9533,'TE','4253010168',0,'2013-12-26 04:35:50',NULL,NULL),(13877,9052,'TE','3302092751',0,'2013-12-26 04:06:03',NULL,NULL),(9998,6541,'EM','JP9641@verizon.net',0,'2013-12-26 00:51:56',NULL,NULL),(10397,6778,'TE','3309483238',0,'2013-12-26 01:16:46',NULL,NULL),(27809,17921,'AP','5125072976',0,'2014-01-15 02:06:31',NULL,NULL),(30279,19616,'AP','4196193090',0,'2014-01-23 03:02:53',NULL,NULL),(30829,20043,'AP','4193051093',0,'2014-01-26 19:00:28',NULL,NULL),(31594,20610,'EM','marycegelski100@hotmail.com',0,'2014-01-30 21:00:17',NULL,NULL),(32757,21430,'TE','8062520577',0,'2014-02-04 21:01:18',NULL,NULL),(35266,23160,'AP','8323664506',0,'2014-02-12 21:31:47',NULL,NULL),(37921,25015,'TE','9373234911',0,'2014-02-20 22:00:54',NULL,NULL),(38902,25715,'EM','karla.dingman@hotmail.com',0,'2014-02-26 09:30:25',NULL,NULL),(39503,26128,'AP','3307631370',0,'2014-02-28 06:30:22',NULL,NULL),(40794,27112,'TE','6145586374',0,'2014-03-03 21:30:27',NULL,NULL),(42413,28168,'AP','8172475392',0,'2014-03-06 21:02:47',NULL,NULL),(42627,28356,'EM','lawana.adger@yahoo.com',0,'2014-03-07 21:30:26',NULL,NULL),(740,463,'EM','gdewing2000@yahoo.com',0,'2013-12-25 17:47:41',NULL,NULL),(5876,3769,'TE','3307843667',0,'2013-12-25 21:33:39',NULL,NULL),(21820,14058,'TE','9375739656',0,'2013-12-27 02:00:30',NULL,NULL),(9357,6126,'TE','9154336260',0,'2013-12-26 00:15:52',NULL,NULL),(21305,13687,'TE','3308071445',0,'2013-12-26 13:08:21',NULL,NULL),(10002,6543,'AP','4327419512',0,'2013-12-26 00:51:59',NULL,NULL),(10163,6643,'TE','4327411532',0,'2013-12-26 01:00:22',NULL,NULL),(10862,7051,'TE','7402666714',0,'2013-12-26 01:49:42',NULL,NULL),(32533,21270,'TE','8064412459',0,'2014-02-03 21:01:30',NULL,NULL),(34871,22868,'AP','3304233196',0,'2014-02-11 21:02:29',NULL,NULL),(443,275,'TE','8309925183',0,'2013-12-25 17:30:09',NULL,NULL),(5480,3507,'AP','9372728903',0,'2013-12-25 21:20:53',NULL,NULL),(3311,2084,'TE','3379623973',0,'2013-12-25 19:16:42',NULL,NULL),(5287,3391,'AP','4405208832',0,'2013-12-25 21:17:50',NULL,NULL),(4810,3076,'AP','5049577472',0,'2013-12-25 20:19:35',NULL,NULL),(20993,13509,'EM','bdao@uno.edu',0,'2013-12-26 13:02:51',NULL,NULL),(20840,13399,'TE','6142032660',0,'2013-12-26 13:00:17',NULL,NULL),(12291,8039,'TE','3306775233',0,'2013-12-26 03:09:23',NULL,NULL),(4315,2753,'TE','4409640083',0,'2013-12-25 19:49:09',NULL,NULL),(7572,4929,'TE','5135264447',0,'2013-12-25 22:45:22',NULL,NULL),(10659,6929,'TE','7407072050',0,'2013-12-26 01:46:28',NULL,NULL),(8893,5824,'EM','skip_mccoy@hotmail.com',0,'2013-12-25 23:48:06',NULL,NULL),(26823,17250,'EM','jeffjanovyak@yahoo.com',0,'2014-01-13 02:23:12',NULL,NULL),(31903,20821,'TE','3189926905',0,'2014-01-31 21:00:35',NULL,NULL),(37361,24594,'AP','4197074981',0,'2014-02-20 04:11:41',NULL,NULL),(37582,24756,'EM','bigben9578@hotmail.com',0,'2014-02-20 04:42:31',NULL,NULL),(37762,24918,'TE','3305927161',0,'2014-02-20 21:30:12',NULL,NULL),(39322,26010,'TE','4197062538',0,'2014-02-26 21:02:09',NULL,NULL),(6469,4186,'TE','2167610760',0,'2013-12-25 21:49:31',NULL,NULL),(9062,5942,'TE','2252843481',0,'2013-12-25 23:50:51',NULL,NULL),(8928,5844,'EM','Jingxue21@yahoo.com',0,'2013-12-25 23:48:38',NULL,NULL),(14075,9200,'AP','5132003957',0,'2013-12-26 04:09:39',NULL,NULL),(5235,3364,'TE','8066726039',0,'2013-12-25 21:17:04',NULL,NULL),(4043,2580,'EM','steve.c.mcgarvey@gmail.com',0,'2013-12-25 19:37:59',NULL,NULL),(22004,14172,'AP','4699390885',0,'2013-12-27 02:03:29',NULL,NULL),(31353,20432,'AP','9376072988',0,'2014-01-29 21:00:36',NULL,NULL),(32731,21411,'EM','T.Mirtallo@gmail.com',0,'2014-02-04 21:01:08',NULL,NULL),(33732,22133,'TE','4408135948',0,'2014-02-08 19:00:44',NULL,NULL),(35050,23017,'AP','3183343454',0,'2014-02-12 21:30:28',NULL,NULL),(35823,23557,'TE','4198108125',0,'2014-02-13 22:02:42',NULL,NULL),(36477,24015,'TE','4402388223',0,'2014-02-15 22:00:43',NULL,NULL),(38313,25310,'AP','5672089601',0,'2014-02-25 21:00:32',NULL,NULL),(43441,28849,'AP','4199321208',0,'2014-03-09 21:01:17',NULL,NULL),(7526,4905,'TE','3375401450',0,'2013-12-25 22:31:55',NULL,NULL),(20379,13125,'EM','progressivesatellite@gmail.com',0,'2013-12-26 12:52:52',NULL,NULL),(22490,14501,'TE','8062237698',0,'2013-12-28 03:33:47',NULL,NULL),(6902,4491,'TE','2103064284',0,'2013-12-25 22:03:10',NULL,NULL),(28912,18665,'AP','9165886712',0,'2014-01-17 03:35:15',NULL,NULL),(32593,21313,'TE','3185501128',0,'2014-02-04 21:00:18',NULL,NULL),(34035,22320,'TE','2253237226',0,'2014-02-10 11:00:53',NULL,NULL),(37015,24371,'TE','9853281415',0,'2014-02-18 22:00:38',NULL,NULL),(37765,24921,'TE','3306742402',0,'2014-02-20 21:30:14',NULL,NULL),(39243,25959,'EM','RENEEBTAY@YAHOO.COM',0,'2014-02-26 21:01:41',NULL,NULL),(3128,1949,'AP','3304754095',0,'2013-12-25 19:00:56',NULL,NULL),(4242,2715,'TE','3309907936',0,'2013-12-25 19:48:03',NULL,NULL),(7341,4772,'EM','avellana63@yahoo.com',0,'2013-12-25 22:15:52',NULL,NULL),(12118,7921,'AP','9855153732',0,'2013-12-26 03:06:19',NULL,NULL),(11488,7471,'EM','t_lugene@hotmail.com',0,'2013-12-26 02:31:11',NULL,NULL),(10483,6830,'TE','6145355602',0,'2013-12-26 01:30:46',NULL,NULL),(25546,16480,'TE','3302970595',0,'2014-01-07 04:06:14',NULL,NULL),(28393,18293,'TE','9378375406',0,'2014-01-16 08:44:53',NULL,NULL),(29059,18764,'TE','8327588783',0,'2014-01-17 03:35:48',NULL,NULL),(30679,19927,'TE','6019824651',0,'2014-01-24 21:01:07',NULL,NULL),(31355,20434,'EM','SILWANIpropertys@yahoo.com',0,'2014-01-29 21:00:37',NULL,NULL),(32004,20893,'TE','9546484000',0,'2014-01-31 21:01:16',NULL,NULL),(35215,23130,'TE','5137676045',0,'2014-02-12 21:31:29',NULL,NULL),(38101,25148,'EM','dianamalkemus@gmail.com',0,'2014-02-21 22:00:15',NULL,NULL),(39280,25990,'AP','6018137556',0,'2014-02-26 21:01:56',NULL,NULL),(39501,26126,'AP','9372243300',0,'2014-02-28 06:30:21',NULL,NULL),(40551,26915,'TE','5137959998',0,'2014-03-03 01:00:13',NULL,NULL),(5297,3396,'TE','2252840790',0,'2013-12-25 21:17:59',NULL,NULL),(21538,13847,'TE','3303287603',0,'2013-12-26 13:12:29',NULL,NULL),(14693,9614,'EM','TOMOB5396@GMAIL.COM',0,'2013-12-26 04:37:44',NULL,NULL),(14666,9594,'EM','JJMartin424@yahoo.com',0,'2013-12-26 04:37:15',NULL,NULL),(11875,7730,'AP','2165488950',0,'2013-12-26 03:01:59',NULL,NULL),(11023,7156,'TE','4193516600',0,'2013-12-26 01:52:20',NULL,NULL),(3962,2515,'TE','6017165032',0,'2013-12-25 19:36:25',NULL,NULL),(7574,4929,'EM','twhitis@cinci.rr.com',0,'2013-12-25 22:45:23',NULL,NULL),(24168,15617,'AP','6012141387',1,'2014-01-02 04:33:00',NULL,NULL),(27174,17497,'TE','5044532166',0,'2014-01-13 03:01:23',NULL,NULL),(30617,19871,'TE','7406801059',0,'2014-01-24 21:00:41',NULL,NULL),(36188,23820,'TE','4198706330',0,'2014-02-14 21:31:40',NULL,NULL),(36786,24221,'TE','7136799843',0,'2014-02-16 19:00:28',NULL,NULL),(38921,25730,'TE','3375770432',0,'2014-02-26 09:30:34',NULL,NULL),(39588,26189,'TE','2162552025',0,'2014-02-28 06:30:44',NULL,NULL),(40830,27133,'TE','5139225885',0,'2014-03-03 21:30:41',NULL,NULL),(43087,28643,'BN','3255180414',0,'2014-03-08 21:30:34',NULL,NULL),(43362,28800,'TE','3303424511',0,'2014-03-09 21:00:48',NULL,NULL),(6451,4167,'AP','6145650673',0,'2013-12-25 21:49:08',NULL,NULL),(25040,16139,'TE','2108601315',0,'2014-01-04 02:05:56',NULL,NULL),(13627,8886,'TE','9037829712',0,'2013-12-26 04:01:53',NULL,NULL),(9671,6332,'AP','5134624316',0,'2013-12-26 00:46:38',NULL,NULL),(7237,4713,'TE','4193480854',0,'2013-12-25 22:08:47',NULL,NULL),(14806,9690,'EM','rharsh1968@yahoo.com',0,'2013-12-26 04:39:42',NULL,NULL),(2607,1588,'EM','SUSANMCGUIRE2003@YAHOO.COM',0,'2013-12-25 18:51:40',NULL,NULL),(4817,3083,'EM','dcpost46@gmail.com',0,'2013-12-25 20:19:48',NULL,NULL),(21838,14068,'AP','2162889175',0,'2013-12-27 02:00:46',NULL,NULL),(22067,14212,'TE','9563541898',0,'2013-12-27 02:04:31',NULL,NULL),(22323,14389,'EM','probinson00158738@cinci.rr.com',0,'2013-12-28 03:30:59',NULL,NULL),(802,499,'AP','6144460535',0,'2013-12-25 17:48:39',NULL,NULL),(23607,15241,'AP','4194389189',0,'2014-01-01 12:08:38',NULL,NULL),(23833,15375,'AP','4193502409',1,'2014-01-02 04:25:15',NULL,NULL),(32587,21307,'TE','9857090262',0,'2014-02-04 21:00:15',NULL,NULL),(32626,21331,'TE','9402300093',0,'2014-02-04 21:00:28',NULL,NULL),(33007,21622,'AP','9363660046',0,'2014-02-05 21:30:38',NULL,NULL),(38034,25094,'TE','9379385483',0,'2014-02-21 21:30:06',NULL,NULL),(38489,25435,'AP','7132615722',0,'2014-02-25 21:31:17',NULL,NULL),(39971,26464,'TE','3308011747',0,'2014-02-28 07:30:33',NULL,NULL),(40327,26763,'EM','CPOKORNY158@GMAIL.COM',0,'2014-03-01 19:00:10',NULL,NULL),(42045,27942,'TE','8302995648',0,'2014-03-06 21:00:33',NULL,NULL),(42927,28544,'TE','3308772825',0,'2014-03-07 21:32:16',NULL,NULL),(4433,2826,'TE','4403441240',0,'2013-12-25 20:00:38',NULL,NULL),(25951,16717,'TE','9032445693',0,'2014-01-08 18:24:45',NULL,NULL),(11855,7716,'EM','joel.roewer@gmail.com',0,'2013-12-26 03:01:38',NULL,NULL),(10230,6686,'AP','3176951146',0,'2013-12-26 01:01:31',NULL,NULL),(8058,5276,'AP','3307035325',0,'2013-12-25 23:05:40',NULL,NULL),(6960,4538,'TE','9033728005',0,'2013-12-25 22:04:14',NULL,NULL),(27791,17913,'EM','aldevlin4@gmail.com',0,'2014-01-15 02:06:28',NULL,NULL),(30560,19829,'AP','2103926993',0,'2014-01-24 21:00:18',NULL,NULL),(32581,21302,'EM','shelley.duran@gmail.com',0,'2014-02-04 21:00:13',NULL,NULL),(35063,23025,'AP','8063003202',0,'2014-02-12 21:30:32',NULL,NULL),(35632,23433,'TE','8064418177',0,'2014-02-13 22:01:28',NULL,NULL),(42039,27939,'AP','4095501840',0,'2014-03-06 21:00:31',NULL,NULL),(42542,28303,'EM','kspray04@yahoo.com',0,'2014-03-07 21:00:33',NULL,NULL),(42643,28367,'EM','tmartin2@elp.rr.com',0,'2014-03-07 21:30:32',NULL,NULL),(42943,28551,'TE','4198255303',0,'2014-03-07 21:32:21',NULL,NULL),(56,37,'AP','7406015550',0,'2013-12-25 17:15:57',NULL,NULL),(11298,7362,'EM','eaknig@bellsouth.net',0,'2013-12-26 02:15:26',NULL,NULL),(14392,9410,'EM','chrisdealglass@gmail.com',0,'2013-12-26 04:32:51',NULL,NULL),(10707,6961,'AP','6145712824',0,'2013-12-26 01:47:15',NULL,NULL),(8907,5830,'EM','Yuri_flores@yahoo.com',0,'2013-12-25 23:48:17',NULL,NULL),(8535,5606,'EM','macke1516@gmail.com',0,'2013-12-25 23:30:26',NULL,NULL),(22714,14648,'TE','9032048078',1,'2013-12-29 11:07:39',NULL,NULL),(7858,5127,'EM','dpiper8866@att.net',0,'2013-12-25 23:02:07',NULL,NULL),(1222,743,'AP','9724679206',0,'2013-12-25 18:04:08',NULL,NULL),(27296,17576,'TE','6145250081',0,'2014-01-14 01:32:04',NULL,NULL),(29304,18933,'BN','2162123312',0,'2014-01-20 08:05:40',NULL,NULL),(30974,20148,'TE','9373906348',0,'2014-01-27 21:01:02',NULL,NULL),(35800,23541,'TE','5046067704',0,'2014-02-13 22:02:33',NULL,NULL),(37694,24850,'EM','dgaw@aol.com',0,'2014-02-20 04:55:29',NULL,NULL),(631,393,'AP','9376741020',0,'2013-12-25 17:45:57',NULL,NULL),(24755,15972,'AP','8065442146',0,'2014-01-04 02:00:39',NULL,NULL),(12181,7955,'TE','3182008906',0,'2013-12-26 03:07:18',NULL,NULL),(11858,7718,'AP','6144249609',0,'2013-12-26 03:01:41',NULL,NULL),(14527,9491,'TE','6148644825',0,'2013-12-26 04:34:54',NULL,NULL),(14900,9749,'TE','3306993005',0,'2013-12-26 04:46:11',NULL,NULL),(20448,13173,'EM','cathiewestcott@gmail.com',0,'2013-12-26 12:54:06',NULL,NULL),(2087,1289,'EM','gslice@zoomtown.com',0,'2013-12-25 18:30:49',NULL,NULL),(22459,14484,'TE','8063950399',0,'2013-12-28 03:33:20',NULL,NULL),(28744,18547,'EM','uyendo110@hotmail.com',0,'2014-01-16 08:46:52',NULL,NULL),(31183,20309,'TE','2109005084',0,'2014-01-28 21:00:48',NULL,NULL),(33497,21951,'AP','3308062894',0,'2014-02-07 19:00:20',NULL,NULL),(37104,24428,'TE','3304671007',0,'2014-02-18 22:01:12',NULL,NULL),(40191,26659,'TE','3306061706',0,'2014-02-28 21:31:11',NULL,NULL),(40230,26685,'AP','5044425917',0,'2014-02-28 21:31:25',NULL,NULL),(40561,26924,'AP','7078798242',0,'2014-03-03 01:00:16',NULL,NULL),(42034,27937,'AP','3253560091',0,'2014-03-06 21:00:29',NULL,NULL),(1428,870,'AP','3304285595',0,'2013-12-25 18:07:26',NULL,NULL),(24568,15846,'TE','4192362668',0,'2014-01-03 02:04:19',NULL,NULL),(7618,4964,'TE','5042593968',0,'2013-12-25 22:46:14',NULL,NULL),(5914,3794,'TE','4193324584',0,'2013-12-25 21:34:19',NULL,NULL),(3982,2526,'TE','3306061471',0,'2013-12-25 19:36:43',NULL,NULL),(6796,4407,'AP','3302681707',0,'2013-12-25 22:01:19',NULL,NULL),(20822,13383,'AP','4193490245',0,'2013-12-26 12:59:58',NULL,NULL),(23813,15363,'AP','7406127525',1,'2014-01-02 04:24:51',NULL,NULL),(23907,15423,'AP','4695836873',1,'2014-01-02 04:27:31',NULL,NULL),(26904,17308,'EM','jbeard0789@yahoo.com',0,'2014-01-13 02:23:42',NULL,NULL),(30659,19899,'AP','4197792004',0,'2014-01-24 21:00:56',NULL,NULL),(31796,20752,'TE','9373831543',0,'2014-01-30 21:01:31',NULL,NULL),(33110,21690,'TE','5042013231',0,'2014-02-05 21:31:05',NULL,NULL),(33829,22211,'AP','6149488019',0,'2014-02-09 19:00:20',NULL,NULL),(35117,23067,'TE','2254445812',0,'2014-02-12 21:30:54',NULL,NULL),(36277,23886,'TE','5133177755',0,'2014-02-14 21:32:15',NULL,NULL),(737,461,'EM','mmyerson@kent.edu',0,'2013-12-25 17:47:38',NULL,NULL),(2058,1273,'AP','5042583367',0,'2013-12-25 18:30:20',NULL,NULL),(14915,9758,'TE','4408870693',0,'2013-12-26 05:00:09',NULL,NULL),(3271,2056,'EM','info@remodelmetoday.com',0,'2013-12-25 19:16:01',NULL,NULL),(22376,14431,'TE','7082184431',0,'2013-12-28 03:31:57',NULL,NULL),(3888,2471,'TE','2253624164',0,'2013-12-25 19:35:13',NULL,NULL),(5974,3836,'EM','deariedeoliveira@hotmail.com',0,'2013-12-25 21:35:17',NULL,NULL),(10345,6744,'EM','Jkeltz9162@msn.com',0,'2013-12-26 01:15:52',NULL,NULL),(2994,1852,'EM','deserts2you@yahoo.com',0,'2013-12-25 18:57:58',NULL,NULL),(8516,5598,'EM','gumbojo1@att.net',0,'2013-12-25 23:30:11',NULL,NULL),(25976,16730,'TE','3304350250',0,'2014-01-08 18:24:50',NULL,NULL),(26279,16913,'TE','9374185638',0,'2014-01-13 02:19:39',NULL,NULL),(28658,18483,'AP','3306900345',0,'2014-01-16 08:46:22',NULL,NULL),(30075,19481,'AP','8326618787',0,'2014-01-23 03:02:03',NULL,NULL),(31211,20328,'TE','3124809212',0,'2014-01-28 21:00:59',NULL,NULL),(33231,21760,'AP','8172195193',0,'2014-02-06 21:00:26',NULL,NULL),(33638,22057,'EM','philipboccuto@gmail.com',0,'2014-02-08 19:00:08',NULL,NULL),(36101,23750,'AP','6143650483',0,'2014-02-14 21:31:07',NULL,NULL),(36406,23978,'AP','4153502141',0,'2014-02-15 22:00:18',NULL,NULL),(36436,23994,'EM','nataciabrown@yahoo.com',0,'2014-02-15 22:00:29',NULL,NULL),(37510,24704,'TE','6143269323',0,'2014-02-20 04:34:40',NULL,NULL),(37632,24801,'TE','9372426542',0,'2014-02-20 04:48:27',NULL,NULL),(41194,27358,'EM','PEPA@VALLMAR.COM',0,'2014-03-04 21:01:10',NULL,NULL),(2499,1534,'TE','6145632195',0,'2013-12-25 18:50:05',NULL,NULL),(3012,1873,'EM','Dpseric8@yahoo.com',0,'2013-12-25 18:58:21',NULL,NULL),(23849,15386,'EM','afoxservices@yahoo.com',1,'2014-01-02 04:25:36',NULL,NULL),(7840,5117,'TE','5128592542',0,'2013-12-25 23:01:51',NULL,NULL),(22857,14749,'EM','pell.suzanne@gmail.com',1,'2013-12-29 11:10:15',NULL,NULL),(8067,5282,'EM','kynthiamiryam@gmail.com',0,'2013-12-25 23:05:48',NULL,NULL),(27700,17854,'AP','5137206384',0,'2014-01-15 02:06:08',NULL,NULL),(29675,19177,'EM','drako0215@gmail.com',0,'2014-01-21 08:46:06',NULL,NULL),(30405,19703,'AP','9403374859',0,'2014-01-23 21:00:49',NULL,NULL),(30953,20135,'TE','2168545176',0,'2014-01-27 21:00:54',NULL,NULL),(31630,20633,'TE','2818366168',0,'2014-01-30 21:00:30',NULL,NULL),(37960,25046,'BN','2163102803',0,'2014-02-20 22:01:14',NULL,NULL),(39129,25881,'AP','5092224586',0,'2014-02-26 21:00:58',NULL,NULL),(39701,26254,'AP','9565021221',0,'2014-02-28 06:31:10',NULL,NULL),(40470,26863,'TE','4692743680',0,'2014-03-01 21:00:58',NULL,NULL),(40984,27231,'EM','dedee1602@ymail.com',0,'2014-03-03 21:31:42',NULL,NULL),(2149,1324,'AP','3182074590',0,'2013-12-25 18:31:52',NULL,NULL),(22315,14386,'TE','6147626325',0,'2013-12-28 03:30:53',NULL,NULL),(7282,4744,'EM','buford_cynthia@yahoo.com',0,'2013-12-25 22:09:34',NULL,NULL),(10728,6978,'TE','5133712933',0,'2013-12-26 01:47:37',NULL,NULL),(11097,7208,'AP','2166475766',0,'2013-12-26 02:00:51',NULL,NULL),(11337,7385,'AP','7404044100',0,'2013-12-26 02:16:01',NULL,NULL),(23979,15480,'AP','5136028643',1,'2014-01-02 04:29:07',NULL,NULL),(24552,15836,'TE','3303232578',0,'2014-01-03 02:04:01',NULL,NULL),(25585,16503,'AP','4403444421',0,'2014-01-07 04:06:56',NULL,NULL),(25837,16657,'AP','5043826040',0,'2014-01-08 18:24:23',NULL,NULL),(28411,18305,'AP','2168829862',0,'2014-01-16 08:44:59',NULL,NULL),(29111,18800,'TE','5132124062',0,'2014-01-17 03:35:59',NULL,NULL),(32180,21018,'AP','5134798388',0,'2014-02-01 19:00:38',NULL,NULL),(33044,21648,'TE','5044957162',0,'2014-02-05 21:30:48',NULL,NULL),(33194,21736,'EM','deby4avon@verizon.net',0,'2014-02-06 21:00:13',NULL,NULL),(33769,22164,'TE','5139394618',0,'2014-02-08 19:00:59',NULL,NULL),(34834,22844,'AP','5174147516',0,'2014-02-11 21:02:16',NULL,NULL),(36796,24228,'TE','5132428092',0,'2014-02-16 19:00:32',NULL,NULL),(36976,24345,'TE','3614376989',0,'2014-02-18 22:00:23',NULL,NULL),(37372,24602,'AP','3304161204',0,'2014-02-20 04:13:05',NULL,NULL),(38783,25639,'AP','3372126286',0,'2014-02-26 08:30:29',NULL,NULL),(40564,26925,'EM','mkersh1@woh.rr.com',0,'2014-03-03 01:00:17',NULL,NULL),(42900,28530,'AP','3376522955',0,'2014-03-07 21:32:07',NULL,NULL),(642,399,'AP','3302898340',0,'2013-12-25 17:46:07',NULL,NULL),(6782,4399,'EM','alysonflynn@earthlink.net',0,'2013-12-25 22:01:07',NULL,NULL),(12339,8070,'AP','4194789101',0,'2013-12-26 03:10:12',NULL,NULL),(10494,6837,'TE','5132849032',0,'2013-12-26 01:30:58',NULL,NULL),(10140,6627,'TE','9374227635',0,'2013-12-26 00:54:14',NULL,NULL),(9593,6280,'TE','3303339600',0,'2013-12-26 00:45:22',NULL,NULL),(2851,1733,'EM','mandy@presselconsulting.com',0,'2013-12-25 18:55:26',NULL,NULL),(1525,938,'EM','billmeans1@fuse.net',0,'2013-12-25 18:09:16',NULL,NULL),(3706,2351,'TE','2146219116',0,'2013-12-25 19:32:14',NULL,NULL),(1267,769,'EM','sweetnsour@rgv.rr.com',0,'2013-12-25 18:04:47',NULL,NULL),(27716,17864,'EM','brooksjd@roadrunner.com',0,'2014-01-15 02:06:11',NULL,NULL),(27731,17880,'TE','4405704809',0,'2014-01-15 02:06:16',NULL,NULL),(29565,19104,'AP','2257151252',0,'2014-01-21 08:44:40',NULL,NULL),(29816,19290,'EM','jleehooge@gmail.com',1,'2014-01-22 03:21:55',NULL,NULL),(31832,20782,'TE','9153095199',0,'2014-01-31 21:00:10',NULL,NULL),(31885,20812,'TE','7329964777',0,'2014-01-31 21:00:29',NULL,NULL),(37678,24845,'AP','3304729927',0,'2014-02-20 04:54:23',NULL,NULL),(40163,26637,'AP','8329166053',0,'2014-02-28 21:31:01',NULL,NULL),(40802,27115,'AP','3303431452',0,'2014-03-03 21:30:29',NULL,NULL),(40845,27141,'EM','normadaniels@peoplepc.com',0,'2014-03-03 21:30:47',NULL,NULL),(42629,28359,'AP','9363351108',0,'2014-03-07 21:30:27',NULL,NULL),(43007,28600,'AP','4407732590',0,'2014-03-08 21:30:08',NULL,NULL),(43143,28677,'TE','4195750729',0,'2014-03-08 21:30:53',NULL,NULL),(407,249,'AP','3186140525',0,'2013-12-25 17:21:32',NULL,NULL),(25804,16629,'AP','5132930683',0,'2014-01-08 18:24:14',NULL,NULL),(25553,16483,'AP','2162969693',0,'2014-01-07 04:06:20',NULL,NULL),(10465,6818,'EM','evas864@yahoo.com',0,'2013-12-26 01:30:28',NULL,NULL),(11390,7416,'TE','3302085182',0,'2013-12-26 02:16:52',NULL,NULL),(14248,9322,'TE','2253244086',0,'2013-12-26 04:30:30',NULL,NULL),(3725,2362,'EM','johnyhotrod@sbcglobal.net',0,'2013-12-25 19:32:32',NULL,NULL),(4578,2921,'TE','3309801472',0,'2013-12-25 20:15:47',NULL,NULL),(3372,2119,'EM','johndoreynew@gmail.com',0,'2013-12-25 19:17:40',NULL,NULL),(878,545,'TE','3309686684',0,'2013-12-25 17:49:51',NULL,NULL),(7076,4622,'AP','7708800896',0,'2013-12-25 22:06:16',NULL,NULL),(24039,15523,'TE','3188556185',1,'2014-01-02 04:30:22',NULL,NULL),(26952,17333,'EM','jlight7@tigers.lsu.edu',0,'2014-01-13 02:23:58',NULL,NULL),(27653,17827,'TE','2283269495',0,'2014-01-15 02:05:58',NULL,NULL),(30946,20127,'AP','3305539616',0,'2014-01-27 21:00:49',NULL,NULL),(32071,20943,'TE','9723291769',0,'2014-01-31 21:01:44',NULL,NULL),(33817,22204,'AP','2164108058',0,'2014-02-09 19:00:16',NULL,NULL),(34249,22467,'TE','5132548081',0,'2014-02-10 21:30:56',NULL,NULL),(36015,23690,'AP','9374769860',0,'2014-02-14 21:30:37',NULL,NULL),(38993,25785,'AP','3307030143',0,'2014-02-26 09:31:05',NULL,NULL),(39520,26140,'EM','cbsouthendgirl@gmail.com',0,'2014-02-28 06:30:25',NULL,NULL),(40042,26543,'EM','CPOKORNY158@GMAIL.COM',0,'2014-02-28 21:30:09',NULL,NULL),(42765,28445,'TE','5042963136',0,'2014-03-07 21:31:16',NULL,NULL),(43551,28917,'EM','bbhllr@aol.com',0,'2014-03-10 21:00:29',NULL,NULL),(5543,3542,'TE','9726072490',0,'2013-12-25 21:21:49',NULL,NULL),(10628,6915,'AP','5044279568',0,'2013-12-26 01:46:01',NULL,NULL),(8626,5666,'AP','3306070855',0,'2013-12-25 23:31:55',NULL,NULL),(13929,9082,'AP','5136670628',0,'2013-12-26 04:06:52',NULL,NULL),(7698,5022,'EM','LindyMan49@Gmail.Com',0,'2013-12-25 22:47:35',NULL,NULL),(22021,14183,'AP','9034723275',0,'2013-12-27 02:03:46',NULL,NULL),(29535,19090,'AP','3305754007',0,'2014-01-21 08:44:32',NULL,NULL),(31818,20774,'TE','9035061841',0,'2014-01-31 21:00:05',NULL,NULL),(33428,21898,'TE','3307039116',0,'2014-02-06 21:01:45',NULL,NULL),(37190,24479,'AP','4192147214',0,'2014-02-18 22:01:44',NULL,NULL),(38468,25423,'TE','5134257009',0,'2014-02-25 21:31:10',NULL,NULL),(274,169,'TE','3308933812',0,'2013-12-25 17:19:24',NULL,NULL),(7932,5170,'EM','creatura05@yahoo.com',0,'2013-12-25 23:03:18',NULL,NULL),(21853,14075,'EM','kimgambel231@yahoo.com',0,'2013-12-27 02:00:59',NULL,NULL),(23347,15041,'TE','5043043436',0,'2014-01-01 12:02:58',NULL,NULL),(26820,17248,'EM','kdkwelding@gmail.com',0,'2014-01-13 02:23:11',NULL,NULL),(27322,17595,'BN','2285478735',0,'2014-01-14 01:32:13',NULL,NULL),(29485,19058,'TE','6015357792',0,'2014-01-21 08:44:13',NULL,NULL),(29854,19315,'BN','3614423955',1,'2014-01-22 03:22:08',NULL,NULL),(33431,21899,'TE','4195846176',0,'2014-02-06 21:01:46',NULL,NULL),(36281,23887,'EM','sandyljackson1959@gmail.com',0,'2014-02-14 21:32:16',NULL,NULL),(27704,17855,'EM','lee.duckworth@yahoo.com',0,'2014-01-15 02:06:08',NULL,NULL),(29517,19081,'AP','5136091303',0,'2014-01-21 08:44:26',NULL,NULL),(29632,19146,'TE','5123740280',0,'2014-01-21 08:45:32',NULL,NULL),(29824,19295,'EM','MIKEWHITE20139@GMAIL.COM',1,'2014-01-22 03:21:57',NULL,NULL),(30407,19704,'AP','8303520674',0,'2014-01-23 21:00:50',NULL,NULL),(31188,20311,'AP','6825560480',0,'2014-01-28 21:00:49',NULL,NULL),(32729,21411,'TE','6143543615',0,'2014-02-04 21:01:08',NULL,NULL),(33001,21615,'AP','9565196830',0,'2014-02-05 21:30:36',NULL,NULL),(34003,22305,'TE','6143072406',0,'2014-02-10 11:00:39',NULL,NULL),(36227,23843,'AP','4194471212',0,'2014-02-14 21:31:54',NULL,NULL),(38657,25548,'TE','9372660097',0,'2014-02-26 08:00:16',NULL,NULL),(40256,26705,'AP','5672240101',0,'2014-02-28 21:31:36',NULL,NULL),(43608,28951,'AP','3374996765',0,'2014-03-10 21:00:50',NULL,NULL),(1031,637,'TE','6143547423',0,'2013-12-25 18:01:15',NULL,NULL),(8414,5541,'TE','3308332486',0,'2013-12-25 23:15:48',NULL,NULL),(6488,4198,'TE','3309239917',0,'2013-12-25 21:49:48',NULL,NULL),(2763,1675,'EM','Meg.groh@gmail.com',0,'2013-12-25 18:53:59',NULL,NULL),(26106,16811,'EM','skymaxfield83@yahoo.com',0,'2014-01-13 02:18:16',NULL,NULL),(28905,18660,'TE','3615926291',0,'2014-01-17 03:35:13',NULL,NULL),(30072,19479,'AP','5129096880',0,'2014-01-23 03:02:03',NULL,NULL),(30085,19490,'AP','4403611545',0,'2014-01-23 03:02:06',NULL,NULL),(33705,22105,'AP','5133791739',0,'2014-02-08 19:00:32',NULL,NULL),(37296,24542,'TE','3308619059',0,'2014-02-20 04:02:57',NULL,NULL),(41427,27523,'AP','5135352443',0,'2014-03-04 21:02:41',NULL,NULL),(3,3,'TE','5136418985',0,'2013-12-25 17:15:05',NULL,NULL),(25572,16497,'AP','9374096728',0,'2014-01-07 04:06:42',NULL,NULL),(10737,6981,'TE','4198100264',0,'2013-12-26 01:47:44',NULL,NULL),(7069,4617,'TE','3304347833',0,'2013-12-25 22:06:08',NULL,NULL),(4137,2638,'EM','palange0315@cox.net',0,'2013-12-25 19:46:17',NULL,NULL),(4656,2975,'AP','9037465949',0,'2013-12-25 20:17:05',NULL,NULL),(5623,3601,'AP','4193081072',0,'2013-12-25 21:23:16',NULL,NULL),(27100,17435,'TE','5132957010',0,'2014-01-13 03:00:33',NULL,NULL),(27730,17874,'TE','5138279379',0,'2014-01-15 02:06:15',NULL,NULL),(29678,19179,'TE','8066560012',0,'2014-01-21 08:46:07',NULL,NULL),(30809,20031,'EM','hcrescioni@gmail.com',0,'2014-01-26 19:00:20',NULL,NULL),(38998,25787,'TE','4193442969',0,'2014-02-26 09:31:07',NULL,NULL),(2109,1303,'AP','2547806305',0,'2013-12-25 18:31:14',NULL,NULL),(6150,3958,'EM','cdhd@windstream.net',0,'2013-12-25 21:38:23',NULL,NULL),(21470,13796,'AP','6019277568',0,'2013-12-26 13:11:15',NULL,NULL),(2368,1438,'EM','mikewhatley1@netzero.com',0,'2013-12-25 18:47:47',NULL,NULL),(4096,2613,'TE','5133219443',0,'2013-12-25 19:45:39',NULL,NULL),(8532,5605,'EM','netcab12@yahoo.com',0,'2013-12-25 23:30:24',NULL,NULL),(12407,8124,'EM','ajccsc@colubus.rr.com',0,'2013-12-26 03:15:22',NULL,NULL),(9581,6274,'AP','5132524648',0,'2013-12-26 00:45:11',NULL,NULL),(25526,16464,'TE','9376181999',0,'2014-01-07 04:05:46',NULL,NULL),(28787,18578,'AP','4405912731',0,'2014-01-16 08:47:07',NULL,NULL),(28984,18707,'EM','robert.macmichael.ctr@dfas.mil',0,'2014-01-17 03:35:30',NULL,NULL),(31125,20270,'EM','gabrielkmudd@gmail.com',0,'2014-01-28 21:00:23',NULL,NULL),(35631,23432,'EM','blue.birdsx2@gmail.com',0,'2014-02-13 22:01:27',NULL,NULL),(35679,23468,'AP','2542655449',0,'2014-02-13 22:01:46',NULL,NULL),(36135,23782,'TE','9379355445',0,'2014-02-14 21:31:20',NULL,NULL),(38825,25666,'AP','3183825034',0,'2014-02-26 08:30:48',NULL,NULL),(39158,25901,'EM','b.nicholson0228@YAHOO.com',0,'2014-02-26 21:01:09',NULL,NULL),(41911,27866,'AP','5136521150',0,'2014-03-05 21:32:22',NULL,NULL),(6542,4229,'AP','2545824832',0,'2013-12-25 21:50:40',NULL,NULL),(2821,1705,'TE','5136620350',0,'2013-12-25 18:54:52',NULL,NULL),(22678,14624,'TE','4199290942',0,'2013-12-28 03:37:00',NULL,NULL),(20880,13427,'TE','4197532357',0,'2013-12-26 13:00:56',NULL,NULL),(10938,7111,'TE','2253231369',0,'2013-12-26 01:51:02',NULL,NULL),(9940,6505,'TE','3309289202',0,'2013-12-26 00:50:58',NULL,NULL),(9687,6346,'AP','7407011867',0,'2013-12-26 00:46:54',NULL,NULL),(5511,3526,'AP','5125858929',0,'2013-12-25 21:21:23',NULL,NULL),(4244,2716,'TE','9855023072',0,'2013-12-25 19:48:05',NULL,NULL),(5106,3274,'AP','5132527622',0,'2013-12-25 21:15:03',NULL,NULL),(3626,2293,'TE','6142027919',0,'2013-12-25 19:30:50',NULL,NULL),(27041,17389,'TE','3302273129',0,'2014-01-13 03:00:10',NULL,NULL),(27097,17427,'EM','ruby_digonno@yahoo.com',0,'2014-01-13 03:00:30',NULL,NULL),(27502,17716,'AP','3304416466',0,'2014-01-14 01:33:12',NULL,NULL),(30122,19511,'AP','8178293275',0,'2014-01-23 03:02:14',NULL,NULL),(41511,27599,'TE','5133720978',0,'2014-03-05 21:00:22',NULL,NULL),(42572,28328,'TE','2147973992',0,'2014-03-07 21:30:09',NULL,NULL),(42597,28340,'AP','7135041888',0,'2014-03-07 21:30:16',NULL,NULL),(2774,1680,'EM','beauchamprealty@aol.com',0,'2013-12-25 18:54:09',NULL,NULL),(24768,15979,'TE','9722248815',0,'2014-01-04 02:00:52',NULL,NULL),(21693,13967,'EM','nicoleetaylor@hotmail.com',0,'2013-12-26 13:15:18',NULL,NULL),(8795,5761,'AP','6145577002',0,'2013-12-25 23:46:32',NULL,NULL),(8319,5453,'TE','5134221750',0,'2013-12-25 23:10:15',NULL,NULL),(7749,5060,'TE','8177077614',0,'2013-12-25 23:00:24',NULL,NULL),(27357,17613,'TE','9156917122',0,'2014-01-14 01:32:23',NULL,NULL),(27446,17679,'AP','3187910216',0,'2014-01-14 01:32:53',NULL,NULL),(28733,18541,'TE','6625941556',0,'2014-01-16 08:46:49',NULL,NULL),(32978,21586,'AP','7405849210',0,'2014-02-05 21:30:28',NULL,NULL),(33137,21707,'TE','6015408134',0,'2014-02-05 21:31:13',NULL,NULL),(38724,25598,'TE','4192774684',0,'2014-02-26 08:00:48',NULL,NULL),(40375,26800,'AP','4195753275',0,'2014-03-01 21:00:23',NULL,NULL),(40649,26985,'AP','5135187302',0,'2014-03-03 01:00:40',NULL,NULL),(42605,28344,'AP','9156949749',0,'2014-03-07 21:30:19',NULL,NULL),(43703,29015,'TE','9738668512',0,'2014-03-10 21:01:26',NULL,NULL),(5011,3216,'AP','3303282630',0,'2013-12-25 20:45:35',NULL,NULL),(25763,16601,'TE','3182298862',0,'2014-01-08 18:24:04',NULL,NULL),(11107,7219,'TE','3309321036',0,'2013-12-26 02:01:06',NULL,NULL),(11883,7733,'TE','6147385369',0,'2013-12-26 03:02:05',NULL,NULL),(3263,2052,'AP','6143528229',0,'2013-12-25 19:15:54',NULL,NULL),(20235,13035,'AP','5133685194',0,'2013-12-26 12:50:28',NULL,NULL),(20490,13194,'AP','2149185363',0,'2013-12-26 12:54:45',NULL,NULL),(23730,15311,'TE','4692154914',1,'2014-01-02 04:23:13',NULL,NULL),(4337,2768,'AP','3309980303',0,'2013-12-25 19:49:29',NULL,NULL),(26940,17327,'AP','5043834109',0,'2014-01-13 02:23:55',NULL,NULL),(34043,22323,'TE','9852654642',0,'2014-02-10 11:00:55',NULL,NULL),(37212,24491,'TE','8323537477',0,'2014-02-20 03:44:38',NULL,NULL),(37439,24650,'EM','marcycarney@yahoo.com',0,'2014-02-20 04:22:47',NULL,NULL),(37473,24678,'TE','9363682240',0,'2014-02-20 04:29:22',NULL,NULL),(39775,26301,'TE','4196630642',0,'2014-02-28 06:31:29',NULL,NULL),(40493,26875,'TE','4192220674',0,'2014-03-01 21:01:06',NULL,NULL),(42919,28541,'TE','2542920522',0,'2014-03-07 21:32:14',NULL,NULL),(241,145,'EM','janet2613@hotmail.com',0,'2013-12-25 17:18:50',NULL,NULL),(25371,16362,'TE','6013353543',0,'2014-01-07 04:02:48',NULL,NULL),(10220,6680,'AP','4197060923',0,'2013-12-26 01:01:21',NULL,NULL),(10149,6634,'AP','5133286413',0,'2013-12-26 01:00:06',NULL,NULL),(8846,5797,'TE','3308484604',0,'2013-12-25 23:47:24',NULL,NULL),(8782,5755,'AP','6143904406',0,'2013-12-25 23:46:20',NULL,NULL),(8536,5607,'TE','2168490820',0,'2013-12-25 23:30:27',NULL,NULL),(4947,3176,'TE','2283425628',0,'2013-12-25 20:31:42',NULL,NULL),(21567,13869,'AP','3305543029',0,'2013-12-26 13:13:00',NULL,NULL),(23022,14850,'TE','3307141148',1,'2013-12-29 11:15:05',NULL,NULL),(23747,15321,'TE','8177841511',1,'2014-01-02 04:23:33',NULL,NULL),(4269,2729,'EM','aca2346@gmail.com',0,'2013-12-25 19:48:26',NULL,NULL),(24242,15661,'TE','9033307962',1,'2014-01-02 04:34:28',NULL,NULL),(760,476,'AP','3182682039',0,'2013-12-25 17:48:01',NULL,NULL),(6827,4430,'TE','6149211781',0,'2013-12-25 22:01:52',NULL,NULL),(26419,17000,'AP','3308585023',0,'2014-01-13 02:20:30',NULL,NULL),(29684,19182,'TE','8062525511',0,'2014-01-21 08:46:08',NULL,NULL),(32678,21370,'EM','jessjo4321@att.net',0,'2014-02-04 21:00:48',NULL,NULL),(35297,23185,'TE','9016549388',0,'2014-02-12 21:32:00',NULL,NULL),(35850,23573,'TE','4193510689',0,'2014-02-13 22:02:53',NULL,NULL),(36697,24160,'EM','jason271@live.com',0,'2014-02-15 22:02:03',NULL,NULL),(37777,24932,'TE','3307150439',0,'2014-02-20 21:30:20',NULL,NULL),(39476,26107,'AP','7404859109',0,'2014-02-28 06:30:15',NULL,NULL),(42818,28477,'AP','3303076162',0,'2014-03-07 21:31:34',NULL,NULL),(780,486,'AP','4106032905',0,'2013-12-25 17:48:17',NULL,NULL),(24897,16050,'TE','5136041685',0,'2014-01-04 02:03:11',NULL,NULL),(7798,5089,'AP','8324521664',0,'2013-12-25 23:01:10',NULL,NULL),(20882,13428,'TE','4408126711',0,'2013-12-26 13:00:58',NULL,NULL),(7592,4942,'EM','miguel.reyes_95@yahoo.com',0,'2013-12-25 22:45:43',NULL,NULL),(7411,4819,'EM','Cincycats@aol.com',0,'2013-12-25 22:17:02',NULL,NULL),(27225,17527,'EM','westonheights@sssnet.com',0,'2014-01-13 03:01:40',NULL,NULL),(31944,20851,'TE','4197331352',0,'2014-01-31 21:00:53',NULL,NULL),(32208,21036,'TE','4192301542',0,'2014-02-01 19:00:48',NULL,NULL),(34400,22565,'AP','3309060413',0,'2014-02-10 21:31:53',NULL,NULL),(37862,24976,'EM','bri.mcgregor89@gmail.com',0,'2014-02-20 22:00:31',NULL,NULL),(41948,27885,'TE','4197872264',0,'2014-03-05 21:32:35',NULL,NULL),(2169,1334,'AP','5135717164',0,'2013-12-25 18:32:11',NULL,NULL),(25157,16217,'EM','dscott@fioptics.com',0,'2014-01-05 00:01:41',NULL,NULL),(24993,16109,'TE','9018598419',0,'2014-01-04 02:05:01',NULL,NULL),(14365,9389,'EM','jralexander008@yahoo.com',0,'2013-12-26 04:32:19',NULL,NULL),(13729,8948,'EM','DONHBRAND@GMAIL.COM',0,'2013-12-26 04:03:30',NULL,NULL),(2758,1671,'AP','5135827626',0,'2013-12-25 18:53:55',NULL,NULL),(22356,14416,'EM','dmirelez@hotmail.com',0,'2013-12-28 03:31:36',NULL,NULL),(27049,17395,'AP','5137201820',0,'2014-01-13 03:00:13',NULL,NULL),(27456,17687,'EM','Kennedyjustinb@gmail.com',0,'2014-01-14 01:32:57',NULL,NULL),(28155,18148,'AP','5044523749',0,'2014-01-15 02:07:49',NULL,NULL),(28403,18302,'AP','6143160459',0,'2014-01-16 08:44:57',NULL,NULL),(28929,18676,'EM','atilanola@aol.com',0,'2014-01-17 03:35:19',NULL,NULL),(29300,18932,'AP','5133498341',0,'2014-01-20 08:05:39',NULL,NULL),(31436,20491,'AP','9855101283',0,'2014-01-29 21:01:07',NULL,NULL),(32604,21317,'AP','5042588304',0,'2014-02-04 21:00:21',NULL,NULL),(33082,21669,'TE','5042286487',0,'2014-02-05 21:30:58',NULL,NULL),(35058,23021,'AP','3615713454',0,'2014-02-12 21:30:30',NULL,NULL),(39756,26292,'TE','4194728927',0,'2014-02-28 06:31:24',NULL,NULL),(41737,27754,'TE','2257887262',0,'2014-03-05 21:31:17',NULL,NULL),(43320,28778,'TE','2167049902',0,'2014-03-09 21:00:34',NULL,NULL),(2814,1702,'TE','4194711636',0,'2013-12-25 18:54:46',NULL,NULL),(25051,16150,'TE','4192852740',0,'2014-01-04 02:06:13',NULL,NULL),(8265,5409,'EM','carimidd@yahoo.com',0,'2013-12-25 23:09:08',NULL,NULL),(9786,6403,'TE','9374227635',0,'2013-12-26 00:48:25',NULL,NULL),(10342,6742,'EM','mdbs1@cox.net',0,'2013-12-26 01:15:49',NULL,NULL),(10923,7101,'EM','bmcmahon32@gmail.com',0,'2013-12-26 01:50:46',NULL,NULL),(22381,14436,'AP','3186172412',0,'2013-12-28 03:32:04',NULL,NULL),(4164,2655,'EM','soprano111@yahoo.com',0,'2013-12-25 19:46:44',NULL,NULL),(27592,17788,'EM','feesburgfertilizer1@yahoo.com',0,'2014-01-14 01:33:46',NULL,NULL),(29804,19280,'AP','9374080256',0,'2014-01-21 08:46:59',NULL,NULL),(31026,20184,'TE','9727932685',0,'2014-01-27 21:01:23',NULL,NULL),(32712,21399,'TE','6142189163',0,'2014-02-04 21:01:01',NULL,NULL),(38001,25069,'TE','2166314526',0,'2014-02-20 22:01:29',NULL,NULL),(40827,27132,'TE','3303047679',0,'2014-03-03 21:30:40',NULL,NULL),(43632,28961,'EM','angelahebert61@yahoo.com',0,'2014-03-10 21:00:57',NULL,NULL),(531,333,'TE','2814097223',0,'2013-12-25 17:31:43',NULL,NULL),(3701,2348,'AP','9039081462',0,'2013-12-25 19:32:09',NULL,NULL),(3335,2096,'EM','shoaley@yahoo.com',0,'2013-12-25 19:17:03',NULL,NULL),(4626,2949,'TE','2162292772',0,'2013-12-25 20:16:29',NULL,NULL),(4679,2991,'AP','6143594959',0,'2013-12-25 20:17:28',NULL,NULL),(11768,7657,'EM','DANNYVU0525@YAHOO.COM',0,'2013-12-26 03:00:11',NULL,NULL),(14049,9179,'AP','4193714698',0,'2013-12-26 04:09:08',NULL,NULL),(14768,9661,'AP','4194812978',0,'2013-12-26 04:39:00',NULL,NULL),(1215,740,'EM','pvtovar31@gmail.com',0,'2013-12-25 18:04:02',NULL,NULL),(22083,14227,'TE','9038346098',0,'2013-12-27 02:04:51',NULL,NULL),(23412,15082,'TE','9729669874',0,'2014-01-01 12:04:11',NULL,NULL),(23621,15251,'TE','5672241563',0,'2014-01-01 12:08:57',NULL,NULL),(23639,15265,'TE','4196773324',0,'2014-01-01 12:09:26',NULL,NULL),(24016,15509,'AP','6143525678',1,'2014-01-02 04:29:56',NULL,NULL),(26762,17216,'AP','6013234917',0,'2014-01-13 02:22:31',NULL,NULL),(29243,18889,'AP','3303091545',0,'2014-01-17 03:36:31',NULL,NULL),(31477,20511,'AP','5049820964',0,'2014-01-29 21:01:19',NULL,NULL),(32119,20973,'TE','2058374412',0,'2014-02-01 19:00:16',NULL,NULL),(37152,24456,'TE','5023011989',0,'2014-02-18 22:01:30',NULL,NULL),(2275,1396,'TE','2253136522',0,'2013-12-25 18:46:28',NULL,NULL),(25406,16389,'EM','susanasuciu2@yahoo.com',0,'2014-01-07 04:03:30',NULL,NULL),(10416,6792,'AP','5125542975',0,'2013-12-26 01:17:07',NULL,NULL),(14040,9173,'TE','5139678964',0,'2013-12-26 04:08:59',NULL,NULL),(10281,6713,'TE','7138252887',0,'2013-12-26 01:02:19',NULL,NULL),(4100,2614,'AP','5133106827',0,'2013-12-25 19:45:42',NULL,NULL),(23308,15019,'TE','5133799887',0,'2014-01-01 12:02:15',NULL,NULL),(28992,18714,'TE','4192733333',0,'2014-01-17 03:35:32',NULL,NULL),(30278,19616,'TE','4196193090',0,'2014-01-23 03:02:53',NULL,NULL),(33206,21745,'TE','5123129724',0,'2014-02-06 21:00:17',NULL,NULL),(33541,21989,'AP','7189154033',0,'2014-02-07 19:00:41',NULL,NULL),(36168,23804,'AP','3305739514',0,'2014-02-14 21:31:31',NULL,NULL),(37666,24832,'EM','jthomas_ent@yahoo.com',0,'2014-02-20 04:52:43',NULL,NULL),(38067,25127,'EM','slocumta@yahoo.com',0,'2014-02-21 21:30:24',NULL,NULL),(41006,27246,'TE','4098667424',0,'2014-03-03 21:31:50',NULL,NULL),(41320,27451,'AP','4356407738',0,'2014-03-04 21:01:59',NULL,NULL),(42688,28398,'TE','9372054310',0,'2014-03-07 21:30:49',NULL,NULL),(43195,28703,'TE','3304725394',0,'2014-03-08 21:31:10',NULL,NULL),(1055,651,'TE','5134428445',0,'2013-12-25 18:01:35',NULL,NULL),(26019,16764,'AP','4135303284',0,'2014-01-08 18:24:59',NULL,NULL),(13922,9079,'TE','7406243535',0,'2013-12-26 04:06:47',NULL,NULL),(9728,6367,'AP','2164696038',0,'2013-12-26 00:47:31',NULL,NULL),(21067,13549,'AP','3104359109',0,'2013-12-26 13:04:02',NULL,NULL),(21308,13688,'EM','Alpineone@aol.com',0,'2013-12-26 13:08:24',NULL,NULL),(8902,5829,'TE','2143350748',0,'2013-12-25 23:48:14',NULL,NULL),(3063,1906,'TE','4192047446',0,'2013-12-25 18:59:16',NULL,NULL),(23264,14989,'TE','4326848040',0,'2014-01-01 12:01:22',NULL,NULL),(2083,1288,'TE','9374080384',0,'2013-12-25 18:30:47',NULL,NULL),(4435,2827,'TE','2342311084',0,'2013-12-25 20:00:39',NULL,NULL),(5611,3590,'AP','5134044007',0,'2013-12-25 21:23:01',NULL,NULL),(26377,16977,'AP','6013106684',0,'2014-01-13 02:20:16',NULL,NULL),(27093,17426,'TE','3307016920',0,'2014-01-13 03:00:29',NULL,NULL),(32694,21383,'AP','4407816057',0,'2014-02-04 21:00:54',NULL,NULL),(38608,25515,'EM','freelands@cinci.rr.com',0,'2014-02-25 21:32:03',NULL,NULL),(39016,25799,'AP','5132232088',0,'2014-02-26 21:00:16',NULL,NULL),(39564,26176,'AP','5133933226',0,'2014-02-28 06:30:38',NULL,NULL),(39878,26383,'TE','2253642678',0,'2014-02-28 07:00:21',NULL,NULL),(39884,26389,'AP','4404767132',0,'2014-02-28 07:00:25',NULL,NULL),(42025,27932,'AP','2147973992',0,'2014-03-06 21:00:26',NULL,NULL),(8263,5409,'TE','9373824955',0,'2013-12-25 23:09:08',NULL,NULL),(20658,13284,'AP','5122897788',0,'2013-12-26 12:57:18',NULL,NULL),(12418,8134,'TE','9372694407',0,'2013-12-26 03:15:37',NULL,NULL),(24528,15821,'TE','7402258095',0,'2014-01-03 02:03:31',NULL,NULL),(11802,7675,'TE','2164098874',0,'2013-12-26 03:00:41',NULL,NULL),(11138,7239,'TE','5046549119',0,'2013-12-26 02:01:38',NULL,NULL),(26777,17226,'TE','4193609025',0,'2014-01-13 02:22:37',NULL,NULL),(27694,17851,'AP','5132900334',0,'2014-01-15 02:06:07',NULL,NULL),(28726,18538,'TE','6015172897',0,'2014-01-16 08:46:47',NULL,NULL),(29212,18871,'TE','9857890709',0,'2014-01-17 03:36:24',NULL,NULL),(30237,19585,'AP','6019641472',0,'2014-01-23 03:02:42',NULL,NULL),(35846,23570,'TE','4193504300',0,'2014-02-13 22:02:51',NULL,NULL),(37222,24495,'AP','3615220586',0,'2014-02-20 03:46:48',NULL,NULL),(39071,25841,'EM','scline611@gmail.com',0,'2014-02-26 21:00:35',NULL,NULL),(39707,26259,'TE','9158863635',0,'2014-02-28 06:31:12',NULL,NULL),(40211,26671,'TE','3374426147',0,'2014-02-28 21:31:18',NULL,NULL),(893,553,'TE','8176050939',0,'2013-12-25 17:50:05',NULL,NULL),(25706,16571,'AP','4195091606',1,'2014-01-07 10:23:21',NULL,NULL),(5188,3331,'TE','3305246526',0,'2013-12-25 21:16:18',NULL,NULL),(7763,5066,'TE','9034029893',0,'2013-12-25 23:00:36',NULL,NULL),(4127,2632,'TE','6142149109',0,'2013-12-25 19:46:09',NULL,NULL),(9563,6262,'TE','3304486765',0,'2013-12-26 00:32:17',NULL,NULL),(2372,1440,'TE','9375882013',0,'2013-12-25 18:47:51',NULL,NULL),(9758,6380,'AP','4404764408',0,'2013-12-26 00:47:55',NULL,NULL),(24137,15583,'EM','sevendust1@sbcglobal.net',1,'2014-01-02 04:32:15',NULL,NULL),(9294,6088,'AP','3306907266',0,'2013-12-26 00:02:39',NULL,NULL),(9042,5932,'EM','parismichael@outlook.com',0,'2013-12-25 23:50:33',NULL,NULL),(21342,13715,'AP','7046826771',0,'2013-12-26 13:09:03',NULL,NULL),(8085,5291,'EM','crowderbev@yahoo.com',0,'2013-12-25 23:06:03',NULL,NULL),(8070,5283,'EM','mtpowers79@gmail.com',0,'2013-12-25 23:05:50',NULL,NULL),(6871,4457,'AP','4404131290',0,'2013-12-25 22:02:33',NULL,NULL),(14843,9714,'AP','6144048001',0,'2013-12-26 04:45:17',NULL,NULL),(6322,4076,'EM','mischiefacres@hotmail.com',0,'2013-12-25 21:47:04',NULL,NULL),(11335,7384,'AP','5132534286',0,'2013-12-26 02:15:59',NULL,NULL),(35326,23212,'AP','5134901485',0,'2014-02-12 21:32:14',NULL,NULL),(38735,25607,'TE','2813472595',0,'2014-02-26 08:30:06',NULL,NULL),(40032,26536,'TE','7404467217',0,'2014-02-28 21:30:05',NULL,NULL),(40268,26714,'TE','7692032051',0,'2014-02-28 21:31:40',NULL,NULL),(40923,27193,'AP','5123005654',0,'2014-03-03 21:31:17',NULL,NULL),(43047,28620,'TE','9157750052',0,'2014-03-08 21:30:21',NULL,NULL),(28822,18603,'TE','5135605839',0,'2014-01-16 08:47:20',NULL,NULL),(948,583,'TE','4195130520',0,'2013-12-25 17:50:58',NULL,NULL),(8478,5578,'TE','4194389189',0,'2013-12-25 23:16:52',NULL,NULL),(26654,17147,'TE','2257774284',0,'2014-01-13 02:21:55',NULL,NULL),(25152,16212,'AP','4199532369',0,'2014-01-05 00:01:32',NULL,NULL),(25043,16140,'TE','3306874193',0,'2014-01-04 02:05:59',NULL,NULL),(24910,16055,'EM','advhomeinspection@windstream.net',0,'2014-01-04 02:03:22',NULL,NULL),(1712,1051,'TE','9564077795',0,'2013-12-25 18:16:03',NULL,NULL),(4031,2575,'EM','jog693-dog@yahoo.com',0,'2013-12-25 19:37:48',NULL,NULL),(20615,13257,'AP','2818401599',0,'2013-12-26 12:56:35',NULL,NULL),(24260,15678,'AP','9377980337',1,'2014-01-02 04:34:53',NULL,NULL),(20707,13310,'TE','3614449431',0,'2013-12-26 12:58:04',NULL,NULL),(32401,21172,'TE','4405066901',0,'2014-02-03 21:00:38',NULL,NULL),(32858,21503,'AP','5134176280',0,'2014-02-04 21:01:53',NULL,NULL),(33117,21693,'AP','4193045450',0,'2014-02-05 21:31:07',NULL,NULL),(35122,23069,'TE','2252745021',0,'2014-02-12 21:30:56',NULL,NULL),(35930,23639,'EM','fvega89@yahoo.com',0,'2014-02-14 21:30:08',NULL,NULL),(37393,24623,'AP','6019830020',0,'2014-02-20 04:16:37',NULL,NULL),(42911,28535,'AP','9372399211',0,'2014-03-07 21:32:11',NULL,NULL),(3505,2191,'TE','4192343240',0,'2013-12-25 19:19:45',NULL,NULL),(11769,7659,'TE','2257162060',0,'2013-12-26 03:00:13',NULL,NULL),(37995,25064,'AP','5133649107',0,'2014-02-20 22:01:26',NULL,NULL),(40859,27151,'TE','5134811504',0,'2014-03-03 21:30:52',NULL,NULL),(10114,6612,'EM','tmw2835@hotmail.com',0,'2013-12-26 00:53:47',NULL,NULL),(11734,7637,'TE','2545631161',0,'2013-12-26 02:46:27',NULL,NULL),(34177,22413,'TE','3183251816',0,'2014-02-10 21:30:27',NULL,NULL),(39600,26196,'EM','hamric_stacey@yahoo.com',0,'2014-02-28 06:30:46',NULL,NULL),(482,306,'AP','9157262600',0,'2013-12-25 17:30:56',NULL,NULL),(846,524,'AP','5132250528',0,'2013-12-25 17:49:17',NULL,NULL),(10018,6554,'TE','9366626833',0,'2013-12-26 00:52:15',NULL,NULL),(5312,3404,'TE','5043388966',0,'2013-12-25 21:18:13',NULL,NULL),(6343,4089,'AP','4195767235',0,'2013-12-25 21:47:23',NULL,NULL),(29446,19038,'AP','6013164092',0,'2014-01-20 08:06:36',NULL,NULL),(35994,23679,'AP','2252908454',0,'2014-02-14 21:30:30',NULL,NULL),(39527,26144,'EM','rider@live.com',0,'2014-02-28 06:30:27',NULL,NULL),(43661,28977,'TE','4405542196',0,'2014-03-10 21:01:06',NULL,NULL),(2690,1634,'EM','shalondace07@yahoo.com',0,'2013-12-25 18:52:55',NULL,NULL),(8471,5573,'EM','fpainter3733@gmail.com',0,'2013-12-25 23:16:45',NULL,NULL),(27043,17392,'TE','9375366406',0,'2014-01-13 03:00:11',NULL,NULL),(1303,792,'EM','bmbell77@mac.com',0,'2013-12-25 18:05:22',NULL,NULL),(14047,9178,'AP','4193714698',0,'2013-12-26 04:09:07',NULL,NULL),(6630,4286,'AP','3304074403',0,'2013-12-25 21:52:05',NULL,NULL),(7771,5071,'TE','9792248153',0,'2013-12-25 23:00:44',NULL,NULL),(34182,22419,'TE','5045799980',0,'2014-02-10 21:30:29',NULL,NULL),(41257,27419,'TE','5674298139',0,'2014-03-04 21:01:37',NULL,NULL),(11336,7385,'TE','7403450414',0,'2013-12-26 02:16:00',NULL,NULL),(28976,18701,'AP','3184700443',0,'2014-01-17 03:35:28',NULL,NULL),(9429,6172,'TE','5127969236',0,'2013-12-26 00:17:05',NULL,NULL),(23159,14928,'EM','bumrrr@gmail.com',0,'2013-12-30 00:01:55',NULL,NULL),(7882,5138,'AP','7027431407',0,'2013-12-25 23:02:27',NULL,NULL),(4508,2867,'EM','ssnone69@yahoo.com',0,'2013-12-25 20:01:49',NULL,NULL),(20310,13090,'TE','2163265115',0,'2013-12-26 12:51:50',NULL,NULL),(7058,4610,'TE','3304149700',0,'2013-12-25 22:05:58',NULL,NULL),(3592,2251,'EM','JMESONES@LIVE.COM',0,'2013-12-25 19:30:07',NULL,NULL),(29919,19363,'TE','3308696190',1,'2014-01-22 03:22:32',NULL,NULL),(36347,23936,'AP','6149403226',0,'2014-02-15 21:00:07',NULL,NULL),(40632,26970,'AP','4693869127',0,'2014-03-03 01:00:34',NULL,NULL),(41869,27840,'AP','8322795824',0,'2014-03-05 21:32:07',NULL,NULL),(10937,7110,'EM','jcv432@yahoo.com',0,'2013-12-26 01:51:01',NULL,NULL),(23875,15406,'EM','dispatch246@gmail.com',1,'2014-01-02 04:26:57',NULL,NULL),(21793,14042,'TE','3309410091',0,'2013-12-27 02:00:03',NULL,NULL),(14432,9431,'EM','sgv66@yahoo.com',0,'2013-12-26 04:33:26',NULL,NULL),(14108,9225,'TE','4195988485',0,'2013-12-26 04:10:19',NULL,NULL),(12438,8148,'TE','2815778303',0,'2013-12-26 03:15:57',NULL,NULL),(1904,1177,'EM','bjackpot@roadrunner.com',0,'2013-12-25 18:19:16',NULL,NULL),(7427,4829,'AP','5133653806',0,'2013-12-25 22:17:19',NULL,NULL),(7661,4985,'EM','chnmiller@yahoo.com',0,'2013-12-25 22:46:52',NULL,NULL),(9127,5977,'TE','3477122298',0,'2013-12-25 23:51:50',NULL,NULL),(35690,23475,'TE','9037583650',0,'2014-02-13 22:01:51',NULL,NULL),(39738,26281,'EM','JESSLETTE@GMAIL.COM',0,'2014-02-28 06:31:20',NULL,NULL),(40433,26842,'EM','latonyawalker24@yahoo.com',0,'2014-03-01 21:00:45',NULL,NULL),(43374,28806,'EM','eeyrkell@hotmail.com',0,'2014-03-09 21:00:52',NULL,NULL),(9447,6185,'TE','6145166443',0,'2013-12-26 00:30:09',NULL,NULL),(24007,15495,'TE','3302681707',1,'2014-01-02 04:29:39',NULL,NULL),(1590,981,'AP','2169732474',0,'2013-12-25 18:10:18',NULL,NULL),(22116,14244,'TE','9037931456',0,'2013-12-27 02:05:21',NULL,NULL),(40530,26902,'TE','9152533263',0,'2014-03-03 01:00:08',NULL,NULL),(2923,1795,'AP','2126410808',0,'2013-12-25 18:56:38',NULL,NULL),(27654,17827,'AP','2283269495',0,'2014-01-15 02:05:58',NULL,NULL),(26606,17115,'TE','5135150865',0,'2014-01-13 02:21:40',NULL,NULL),(11425,7434,'TE','3308698898',0,'2013-12-26 02:30:13',NULL,NULL),(21138,13590,'AP','2144159101',0,'2013-12-26 13:05:10',NULL,NULL),(30999,20166,'AP','4197798332',0,'2014-01-27 21:01:12',NULL,NULL),(5216,3354,'TE','3619443397',0,'2013-12-25 21:16:48',NULL,NULL),(29476,19053,'EM','RLOVE@LOVENDP.COM',0,'2014-01-20 08:06:46',NULL,NULL),(26861,17286,'AP','9795753693',0,'2014-01-13 02:23:30',NULL,NULL),(33381,21871,'EM','BERLINBL2@YAHOO.COM',0,'2014-02-06 21:01:26',NULL,NULL),(41216,27374,'AP','2284242303',0,'2014-03-04 21:01:18',NULL,NULL),(41349,27469,'AP','5673712384',0,'2014-03-04 21:02:11',NULL,NULL),(5839,3746,'EM','HALEYTIFFANY@AOL.COM',0,'2013-12-25 21:33:03',NULL,NULL),(4999,3208,'EM','bbzkuehn@gmail.com',0,'2013-12-25 20:45:22',NULL,NULL),(27369,17619,'TE','8063742961',0,'2014-01-14 01:32:26',NULL,NULL),(20868,13417,'TE','6149758393',0,'2013-12-26 13:00:43',NULL,NULL),(25899,16692,'AP','9566245888',0,'2014-01-08 18:24:35',NULL,NULL),(25888,16688,'EM','adam.rosenfield.ar@gmail.com',0,'2014-01-08 18:24:34',NULL,NULL),(32235,21054,'EM','rachael.johnson77@yahoo.com',0,'2014-02-02 19:00:08',NULL,NULL),(38352,25334,'AP','5044519181',0,'2014-02-25 21:30:20',NULL,NULL),(2999,1855,'AP','5134064009',0,'2013-12-25 18:58:02',NULL,NULL),(30115,19507,'EM','SANDRAELIZABETHDIAZ@HOTMAIL.COM',0,'2014-01-23 03:02:13',NULL,NULL),(3121,1945,'TE','8594095919',0,'2013-12-25 19:00:48',NULL,NULL),(28616,18445,'AP','9374183101',0,'2014-01-16 08:46:06',NULL,NULL),(27899,17976,'BN','3308444453',0,'2014-01-15 02:06:51',NULL,NULL),(27414,17658,'TE','9375157480',0,'2014-01-14 01:32:43',NULL,NULL),(23253,14983,'AP','2818489368',0,'2014-01-01 12:01:10',NULL,NULL),(23542,15194,'TE','6012642044',0,'2014-01-01 12:07:12',NULL,NULL),(8961,5869,'EM','Plowguy2@yahoo.com',0,'2013-12-25 23:49:11',NULL,NULL),(29274,18907,'AP','6016135010',0,'2014-01-17 03:36:39',NULL,NULL),(28437,18323,'TE','5132380380',0,'2014-01-16 08:45:08',NULL,NULL),(25288,16307,'TE','5049081967',0,'2014-01-07 04:01:19',NULL,NULL),(26641,17140,'AP','4199446623',0,'2014-01-13 02:21:51',NULL,NULL),(38091,25143,'AP','7135385523',0,'2014-02-21 22:00:12',NULL,NULL),(40753,27083,'TE','3306344893',0,'2014-03-03 21:30:12',NULL,NULL),(11283,7354,'TE','8178740647',0,'2013-12-26 02:15:13',NULL,NULL),(29365,18974,'AP','5136802555',0,'2014-01-20 08:06:04',NULL,NULL),(28738,18545,'TE','3096781866',0,'2014-01-16 08:46:51',NULL,NULL),(10085,6590,'TE','3613641154',0,'2013-12-26 00:53:15',NULL,NULL),(25875,16677,'TE','3305947020',0,'2014-01-08 18:24:31',NULL,NULL),(2928,1799,'EM','harleyflh01@sbcglobal.net',0,'2013-12-25 18:56:44',NULL,NULL),(22396,14445,'TE','3373852319',0,'2013-12-28 03:32:19',NULL,NULL),(2876,1762,'EM','chris_sisson@yahoo.com',0,'2013-12-25 18:55:55',NULL,NULL),(14397,9413,'EM','swoodruff404@yahoo.com',0,'2013-12-26 04:32:56',NULL,NULL),(7122,4649,'EM','markangelva@yahoo.com',0,'2013-12-25 22:07:01',NULL,NULL),(31790,20749,'AP','4193600289',0,'2014-01-30 21:01:29',NULL,NULL),(35748,23510,'TE','6016711120',0,'2014-02-13 22:02:14',NULL,NULL),(39202,25927,'TE','8172319129',0,'2014-02-26 21:01:24',NULL,NULL),(342,213,'AP','2258029226',0,'2013-12-25 17:20:32',NULL,NULL),(24694,15927,'EM','jrcampb2@yahoo.com',0,'2014-01-03 02:06:49',NULL,NULL),(8493,5586,'EM','loud0927@live.sscc.edu',0,'2013-12-25 23:17:07',NULL,NULL),(23180,14939,'EM','stacylewis@alumni.stanford.edu',0,'2013-12-30 00:02:15',NULL,NULL),(22896,14772,'EM','robertpsaldana@gmail.com',1,'2013-12-29 11:12:59',NULL,NULL),(33183,21731,'AP','9402820573',0,'2014-02-06 21:00:09',NULL,NULL),(34923,22917,'TE','9378221336',0,'2014-02-11 21:02:52',NULL,NULL),(36714,24172,'AP','4199447453',0,'2014-02-15 22:02:10',NULL,NULL),(41077,27287,'TE','8327257915',0,'2014-03-04 21:00:26',NULL,NULL),(41476,27567,'TE','4402512222',0,'2014-03-04 21:30:19',NULL,NULL),(41913,27868,'AP','5132272110',0,'2014-03-05 21:32:23',NULL,NULL),(11,6,'EM','lapawdogs@yahoo.com',0,'2013-12-25 17:15:11',NULL,NULL),(10482,6829,'EM','crhightower@gmail.com',0,'2013-12-26 01:30:44',NULL,NULL),(7125,4650,'EM','rstewart@rdimarketing.com',0,'2013-12-25 22:07:04',NULL,NULL),(10037,6566,'AP','5126671069',0,'2013-12-26 00:52:33',NULL,NULL),(9217,6032,'EM','rmyers@proofrock.com',0,'2013-12-26 00:01:10',NULL,NULL),(1754,1082,'TE','9373526145',0,'2013-12-25 18:16:48',NULL,NULL),(11379,7410,'TE','8179753009',0,'2013-12-26 02:16:42',NULL,NULL),(9855,6443,'TE','4193491086',0,'2013-12-26 00:49:31',NULL,NULL),(12005,7820,'TE','8066624848',0,'2013-12-26 03:04:11',NULL,NULL),(31467,20507,'TE','5042593911',0,'2014-01-29 21:01:17',NULL,NULL),(38198,25214,'TE','4192033473',0,'2014-02-21 22:00:52',NULL,NULL),(38804,25655,'TE','7405226609',0,'2014-02-26 08:30:41',NULL,NULL),(40928,27197,'TE','8327586028',0,'2014-03-03 21:31:20',NULL,NULL),(10818,7026,'AP','9792576829',0,'2013-12-26 01:49:00',NULL,NULL),(932,574,'AP','9378252981',0,'2013-12-25 17:50:40',NULL,NULL),(22997,14834,'AP','4195615779',1,'2013-12-29 11:14:40',NULL,NULL),(8180,5351,'AP','3303791017',0,'2013-12-25 23:07:38',NULL,NULL),(2048,1269,'TE','9512884294',0,'2013-12-25 18:30:12',NULL,NULL),(35073,23034,'TE','9152404350',0,'2014-02-12 21:30:35',NULL,NULL),(6793,4404,'TE','4197222333',0,'2013-12-25 22:01:15',NULL,NULL),(29415,19017,'TE','4196511009',0,'2014-01-20 08:06:23',NULL,NULL),(11803,7675,'EM','trobinson1586@yahoo.com',0,'2013-12-26 03:00:42',NULL,NULL),(27952,18009,'EM','rosesrem78@aol.com',0,'2014-01-15 02:07:03',NULL,NULL),(22525,14523,'EM','samfar94566@yahoo.com',0,'2013-12-28 03:34:22',NULL,NULL),(22120,14249,'AP','9565376859',0,'2013-12-27 02:05:28',NULL,NULL),(22038,14193,'AP','9153094026',0,'2013-12-27 02:04:03',NULL,NULL),(5074,3259,'AP','9406343868',0,'2013-12-25 20:46:49',NULL,NULL),(1319,805,'TE','9797744470',0,'2013-12-25 18:05:40',NULL,NULL),(3898,2475,'TE','2253354221',0,'2013-12-25 19:35:21',NULL,NULL),(3911,2482,'TE','2258698430',0,'2013-12-25 19:35:33',NULL,NULL),(30686,19933,'EM','stacbear39@yahoo.com',0,'2014-01-24 21:01:10',NULL,NULL),(1935,1198,'AP','6147470117',0,'2013-12-25 18:19:49',NULL,NULL),(1831,1133,'EM','lakittam@gmail.com',0,'2013-12-25 18:18:07',NULL,NULL),(32048,20921,'TE','4408645261',0,'2014-01-31 21:01:33',NULL,NULL),(37578,24755,'AP','7405027990',0,'2014-02-20 04:42:12',NULL,NULL),(38490,25437,'TE','3617460646',0,'2014-02-25 21:31:18',NULL,NULL),(12160,7943,'EM','nancylanders21@hotmail.com',0,'2013-12-26 03:06:57',NULL,NULL),(2688,1633,'AP','9037015095',0,'2013-12-25 18:52:53',NULL,NULL),(28331,18258,'AP','9154122915',0,'2014-01-16 08:44:35',NULL,NULL),(9970,6523,'EM','kdwerne@yahoo.com',0,'2013-12-26 00:51:29',NULL,NULL),(10464,6818,'TE','3302969029',0,'2013-12-26 01:30:28',NULL,NULL),(11429,7436,'TE','3305920675',0,'2013-12-26 02:30:17',NULL,NULL),(23035,14858,'TE','3304724861',1,'2013-12-29 11:15:17',NULL,NULL),(30892,20081,'AP','9158380037',0,'2014-01-27 21:00:23',NULL,NULL),(35578,23395,'TE','7407469405',0,'2014-02-13 22:01:08',NULL,NULL),(35587,23406,'TE','6143768174',0,'2014-02-13 22:01:12',NULL,NULL),(41786,27780,'TE','3306281735',0,'2014-03-05 21:31:33',NULL,NULL),(43089,28644,'AP','6626302724',0,'2014-03-08 21:30:34',NULL,NULL),(1610,991,'TE','9375805289',0,'2013-12-25 18:10:38',NULL,NULL),(30155,19537,'EM','ladysasha1957@hotmail.com',0,'2014-01-23 03:02:23',NULL,NULL),(5134,3289,'EM','JTCO1@BAX.NET',0,'2013-12-25 21:15:29',NULL,NULL),(5744,3682,'TE','6143300564',0,'2013-12-25 21:31:29',NULL,NULL),(20648,13280,'TE','9565296817',0,'2013-12-26 12:57:10',NULL,NULL),(21100,13567,'TE','5048388573',0,'2013-12-26 13:04:32',NULL,NULL),(38429,25397,'EM','rgreeneas@aol.com',0,'2014-02-25 21:30:54',NULL,NULL),(42954,28565,'TE','9379998607',0,'2014-03-07 21:32:27',NULL,NULL),(483,310,'TE','3253725191',0,'2013-12-25 17:30:59',NULL,NULL),(12131,7927,'EM','M.A.Gurievsky@gmail.com',0,'2013-12-26 03:06:30',NULL,NULL),(23908,15424,'TE','9039209077',1,'2014-01-02 04:27:33',NULL,NULL),(11977,7803,'TE','8069288401',0,'2013-12-26 03:03:44',NULL,NULL),(3529,2207,'TE','4193685020',0,'2013-12-25 19:20:12',NULL,NULL),(8102,5305,'TE','6019820944',0,'2013-12-25 23:06:24',NULL,NULL),(33537,21984,'TE','9852411810',0,'2014-02-07 19:00:39',NULL,NULL),(34563,22666,'TE','9038064981',0,'2014-02-11 21:00:38',NULL,NULL),(36199,23828,'EM','cl8050@gmail.com',0,'2014-02-14 21:31:44',NULL,NULL),(42154,28004,'AP','2163159512',0,'2014-03-06 21:01:11',NULL,NULL),(527,329,'AP','6149758461',0,'2013-12-25 17:31:38',NULL,NULL),(5153,3304,'EM','sevendust1@sbcglobal.net',0,'2013-12-25 21:15:46',NULL,NULL),(25762,16600,'AP','2258107760',0,'2014-01-08 18:24:04',NULL,NULL),(11881,7732,'AP','9373020120',0,'2013-12-26 03:02:03',NULL,NULL),(32612,21323,'AP','3185022259',0,'2014-02-04 21:00:24',NULL,NULL),(42992,28592,'EM','ANDREWILLIAMS32@GMAIL.COM',0,'2014-03-08 21:30:03',NULL,NULL),(11341,7387,'TE','6147361100',0,'2013-12-26 02:16:04',NULL,NULL),(954,589,'TE','4193396963',0,'2013-12-25 17:51:08',NULL,NULL),(25324,16329,'AP','2253331861',0,'2014-01-07 04:01:57',NULL,NULL),(10072,6584,'TE','5134624316',0,'2013-12-26 00:53:04',NULL,NULL),(20962,13485,'AP','9376742684',0,'2013-12-26 13:02:20',NULL,NULL),(33736,22136,'AP','4405220267',0,'2014-02-08 19:00:46',NULL,NULL),(34839,22847,'TE','4192037391',0,'2014-02-11 21:02:18',NULL,NULL),(28008,18052,'TE','6623989888',0,'2014-01-15 02:07:17',NULL,NULL),(30549,19818,'AP','9567444285',0,'2014-01-24 21:00:13',NULL,NULL),(30070,19477,'BN','2542453825',0,'2014-01-23 03:02:02',NULL,NULL),(29347,18963,'EM','yanettharvey151@hotmail.com',0,'2014-01-20 08:05:56',NULL,NULL),(34650,22719,'TE','5047562532',0,'2014-02-11 21:01:09',NULL,NULL),(41434,27525,'EM','jte3655@gmail.com',0,'2014-03-04 21:02:43',NULL,NULL),(42676,28388,'AP','8156036058',0,'2014-03-07 21:30:44',NULL,NULL),(10445,6807,'TE','8066761585',0,'2013-12-26 01:30:11',NULL,NULL),(24733,15955,'EM','advhomeinspection@windstream.net',0,'2014-01-04 02:00:14',NULL,NULL),(23890,15414,'TE','9035781291',1,'2014-01-02 04:27:13',NULL,NULL),(7632,4971,'AP','9728352275',0,'2013-12-25 22:46:27',NULL,NULL),(2280,1398,'AP','3184859860',0,'2013-12-25 18:46:32',NULL,NULL),(23463,15124,'AP','7402382685',0,'2014-01-01 12:05:19',NULL,NULL),(36886,24292,'AP','3304007103',0,'2014-02-18 21:30:14',NULL,NULL),(39426,26071,'AP','3305501589',0,'2014-02-26 21:02:45',NULL,NULL),(39445,26088,'TE','5049522004',0,'2014-02-28 06:30:07',NULL,NULL),(41510,27597,'TE','5138211940',0,'2014-03-05 21:00:21',NULL,NULL),(11643,7574,'AP','4193052849',0,'2013-12-26 02:33:49',NULL,NULL),(4486,2853,'TE','2252216873',0,'2013-12-25 20:01:27',NULL,NULL),(2863,1750,'AP','3305469220',0,'2013-12-25 18:55:42',NULL,NULL),(4230,2705,'AP','9032159255',0,'2013-12-25 19:47:50',NULL,NULL),(28858,18636,'TE','8303529482',0,'2014-01-17 03:35:04',NULL,NULL),(8112,5311,'EM','yosh6148@yahoo.com',0,'2013-12-25 23:06:35',NULL,NULL),(2508,1538,'TE','4128749395',0,'2013-12-25 18:50:13',NULL,NULL),(3808,2424,'EM','FAITHORC@YAHOO.COM',0,'2013-12-25 19:34:00',NULL,NULL),(5433,3477,'TE','5134768083',0,'2013-12-25 21:20:07',NULL,NULL),(12152,7939,'TE','9176284761',0,'2013-12-26 03:06:50',NULL,NULL),(22128,14253,'AP','9853814633',0,'2013-12-27 02:05:35',NULL,NULL),(21810,14052,'AP','5133444089',0,'2013-12-27 02:00:20',NULL,NULL),(20201,13014,'TE','5133140487',0,'2013-12-26 12:49:53',NULL,NULL),(13650,8901,'TE','3104866200',0,'2013-12-26 04:02:17',NULL,NULL),(31979,20879,'AP','4193480008',0,'2014-01-31 21:01:07',NULL,NULL),(34931,22924,'TE','5124234190',0,'2014-02-11 21:30:04',NULL,NULL),(42463,28209,'AP','6013971376',0,'2014-03-06 21:30:13',NULL,NULL),(43299,28767,'AP','8324473892',0,'2014-03-09 21:00:27',NULL,NULL),(22144,14262,'TE','3183767017',0,'2013-12-27 02:05:50',NULL,NULL),(27794,17915,'TE','3617761672',0,'2014-01-15 02:06:29',NULL,NULL),(26925,17318,'EM','pvargas1951@yahoo.com',0,'2014-01-13 02:23:49',NULL,NULL),(25992,16748,'TE','9793328958',0,'2014-01-08 18:24:53',NULL,NULL),(24185,15625,'TE','6013950896',1,'2014-01-02 04:33:18',NULL,NULL),(37540,24716,'EM','RhondaKPhillips@aol.com',0,'2014-02-20 04:37:13',NULL,NULL),(10469,6821,'TE','6622538078',0,'2013-12-26 01:30:33',NULL,NULL),(855,530,'TE','6014026808',0,'2013-12-25 17:49:27',NULL,NULL),(27749,17890,'EM','sunniedistelhorst@yahoo.com',0,'2014-01-15 02:06:19',NULL,NULL),(26486,17046,'AP','4404794825',0,'2014-01-13 02:20:54',NULL,NULL),(1474,903,'EM','javall.williams@gmail.com',0,'2013-12-25 18:08:20',NULL,NULL),(4670,2987,'AP','6069226831',0,'2013-12-25 20:17:20',NULL,NULL),(14357,9384,'EM','ramonakaisar803@hotmail.com',0,'2013-12-26 04:32:12',NULL,NULL),(13617,8874,'TE','2817045916',0,'2013-12-26 04:01:39',NULL,NULL),(31097,20244,'AP','8324414232',0,'2014-01-28 21:00:09',NULL,NULL),(31293,20390,'TE','4322509083',0,'2014-01-29 21:00:15',NULL,NULL),(32407,21176,'AP','3306318044',0,'2014-02-03 21:00:41',NULL,NULL),(38838,25673,'TE','9378341087',0,'2014-02-26 08:30:54',NULL,NULL),(4623,2946,'EM','mbutz52@gmail.com',0,'2013-12-25 20:16:24',NULL,NULL),(8197,5365,'AP','9376946458',0,'2013-12-25 23:07:57',NULL,NULL),(20253,13048,'TE','4198702318',0,'2013-12-26 12:50:48',NULL,NULL),(21259,13662,'TE','5045799672',0,'2013-12-26 13:07:39',NULL,NULL),(33980,22289,'EM','robinsonstegard@rocketmail.com',0,'2014-02-10 11:00:29',NULL,NULL),(34600,22688,'AP','2104215731',0,'2014-02-11 21:00:51',NULL,NULL),(35013,22992,'TE','9374790356',0,'2014-02-12 21:30:14',NULL,NULL),(39437,26084,'TE','5043425498',0,'2014-02-28 06:30:05',NULL,NULL),(39834,26347,'AP','9372188423',0,'2014-02-28 06:31:46',NULL,NULL),(40013,26508,'TE','5138940441',0,'2014-02-28 21:00:18',NULL,NULL),(40099,26593,'AP','4407252796',0,'2014-02-28 21:30:37',NULL,NULL),(40971,27223,'AP','6019547819',0,'2014-03-03 21:31:36',NULL,NULL),(42567,28323,'AP','9406415068',0,'2014-03-07 21:30:06',NULL,NULL),(6821,4427,'TE','6144048740',0,'2013-12-25 22:01:46',NULL,NULL),(27735,17882,'TE','7407271503',0,'2014-01-15 02:06:16',NULL,NULL),(26361,16967,'TE','3306188152',0,'2014-01-13 02:20:11',NULL,NULL),(12251,8011,'TE','9032382196',0,'2013-12-26 03:08:39',NULL,NULL),(14469,9451,'TE','6145897262',0,'2013-12-26 04:33:59',NULL,NULL),(9893,6471,'AP','4404298559',0,'2013-12-26 00:50:08',NULL,NULL),(33442,21905,'TE','9016549381',0,'2014-02-06 21:01:50',NULL,NULL),(36071,23725,'EM','debcorbett@gmail.com',0,'2014-02-14 21:30:55',NULL,NULL),(37605,24779,'EM','nmoore4035@yahoo.com',0,'2014-02-20 04:45:27',NULL,NULL),(40419,26831,'EM','frankcivitaresejr@yahoo.com',0,'2014-03-01 21:00:40',NULL,NULL),(40568,26927,'TE','5138822209',0,'2014-03-03 01:00:18',NULL,NULL),(7762,5065,'EM','angelzales0820@gmail.com',0,'2013-12-25 23:00:35',NULL,NULL),(2143,1321,'AP','7147159078',0,'2013-12-25 18:31:44',NULL,NULL),(23795,15349,'TE','3308586636',1,'2014-01-02 04:24:29',NULL,NULL),(36815,24238,'EM','brianmatthewclutter@gmail.com',0,'2014-02-16 19:00:38',NULL,NULL),(2576,1572,'TE','8174494328',0,'2013-12-25 18:51:13',NULL,NULL),(9886,6465,'EM','YARDGNOME55@SBCGLOBAL.NET',0,'2013-12-26 00:50:01',NULL,NULL),(24124,15573,'AP','3307497816',1,'2014-01-02 04:31:58',NULL,NULL),(8068,5283,'TE','4403336177',0,'2013-12-25 23:05:49',NULL,NULL),(4540,2888,'TE','3306285285',0,'2013-12-25 20:15:06',NULL,NULL),(31544,20560,'TE','5135468175',0,'2014-01-29 21:01:46',NULL,NULL),(34669,22733,'TE','2253159713',0,'2014-02-11 21:01:16',NULL,NULL),(36341,23933,'EM','dldwilcox@gmail.com',0,'2014-02-15 21:00:05',NULL,NULL),(42386,28151,'EM','dstachowiak69@yahoo.com',0,'2014-03-06 21:02:37',NULL,NULL),(43202,28710,'EM','radiovoyr@gmail.com',0,'2014-03-08 21:31:14',NULL,NULL),(43823,29089,'TE','2108520517',0,'2014-03-10 21:02:08',NULL,NULL),(11882,7732,'EM','LBROOKS1@FRONTIER.COM',0,'2013-12-26 03:02:03',NULL,NULL),(5643,3618,'TE','9374781979',0,'2013-12-25 21:23:39',NULL,NULL),(10887,7075,'EM','Krasinskih@yahoo.com',0,'2013-12-26 01:50:09',NULL,NULL),(22746,14669,'AP','8307762328',1,'2013-12-29 11:08:12',NULL,NULL),(22159,14273,'AP','6016223208',0,'2013-12-27 02:06:09',NULL,NULL),(21326,13703,'TE','3307195690',0,'2013-12-26 13:08:44',NULL,NULL),(1258,763,'AP','9037152197',0,'2013-12-25 18:04:38',NULL,NULL),(1531,941,'AP','4402631713',0,'2013-12-25 18:09:21',NULL,NULL),(7651,4981,'TE','8178846459',0,'2013-12-25 22:46:43',NULL,NULL),(34446,22599,'TE','9374032505',0,'2014-02-10 21:32:14',NULL,NULL),(35806,23544,'AP','5043521605',0,'2014-02-13 22:02:35',NULL,NULL),(39268,25980,'TE','9376674134',0,'2014-02-26 21:01:51',NULL,NULL),(5170,3319,'TE','7403442486',0,'2013-12-25 21:16:01',NULL,NULL),(24196,15633,'TE','2252472791',1,'2014-01-02 04:33:32',NULL,NULL),(23225,14968,'AP','9728147226',0,'2014-01-01 12:00:42',NULL,NULL),(20765,13343,'TE','7138822519',0,'2013-12-26 12:58:59',NULL,NULL),(8109,5307,'EM','darrylhoop@gmail.com',0,'2013-12-25 23:06:29',NULL,NULL),(7629,4970,'AP','9366452685',0,'2013-12-25 22:46:25',NULL,NULL),(411,252,'AP','3183661308',0,'2013-12-25 17:21:36',NULL,NULL),(31397,20463,'AP','3308585870',0,'2014-01-29 21:00:52',NULL,NULL),(36279,23887,'TE','5132258662',0,'2014-02-14 21:32:16',NULL,NULL),(41338,27461,'EM','thomsemailsite@yahoo.com',0,'2014-03-04 21:02:06',NULL,NULL),(43252,28740,'TE','5044507457',0,'2014-03-09 21:00:09',NULL,NULL),(7930,5169,'EM','JEFFREYHINRICHS@ROCKETMAIL.COM',0,'2013-12-25 23:03:16',NULL,NULL),(28391,18291,'AP','9374165891',0,'2014-01-16 08:44:52',NULL,NULL),(20212,13022,'TE','3309048926',0,'2013-12-26 12:50:06',NULL,NULL),(14409,9421,'EM','lilly.olima@gmail.com',0,'2013-12-26 04:33:07',NULL,NULL),(13551,8837,'EM','azigol79@yahoo.com',0,'2013-12-26 04:00:39',NULL,NULL),(5896,3780,'EM','debbph0731@aol.com',0,'2013-12-25 21:33:59',NULL,NULL),(34815,22835,'EM','dmajer@netzero.com',0,'2014-02-11 21:02:10',NULL,NULL),(35434,23296,'TE','7404645527',0,'2014-02-13 22:00:11',NULL,NULL),(41724,27745,'AP','4195918540',0,'2014-03-05 21:31:11',NULL,NULL),(6196,3993,'TE','9377265243',0,'2013-12-25 21:39:10',NULL,NULL),(5347,3425,'AP','3304021658',0,'2013-12-25 21:18:47',NULL,NULL),(27542,17749,'EM','mennell72@gmail.com',0,'2014-01-14 01:33:27',NULL,NULL),(25928,16706,'AP','4693832180',0,'2014-01-08 18:24:41',NULL,NULL),(4987,3202,'TE','2169059331',0,'2013-12-25 20:45:12',NULL,NULL),(9965,6521,'EM','jjennison4446@att.net',0,'2013-12-26 00:51:25',NULL,NULL),(20236,13036,'TE','9372011045',0,'2013-12-26 12:50:29',NULL,NULL),(9074,5951,'TE','9375493286',0,'2013-12-25 23:51:04',NULL,NULL),(9103,5967,'TE','4193085453',0,'2013-12-25 23:51:30',NULL,NULL),(2209,1358,'TE','2817396604',0,'2013-12-25 18:45:25',NULL,NULL),(29671,19175,'TE','7133826969',0,'2014-01-21 08:46:04',NULL,NULL),(31177,20304,'TE','9563534348',0,'2014-01-28 21:00:45',NULL,NULL),(31239,20345,'TE','2283839628',0,'2014-01-28 21:01:10',NULL,NULL),(32113,20970,'TE','9565331431',0,'2014-02-01 19:00:14',NULL,NULL),(32185,21023,'TE','3302948447',0,'2014-02-01 19:00:40',NULL,NULL),(33399,21885,'EM','lkeber@gmail.com',0,'2014-02-06 21:01:33',NULL,NULL),(33840,22216,'TE','5043433164',0,'2014-02-09 19:00:23',NULL,NULL),(35145,23080,'TE','4404730771',0,'2014-02-12 21:31:02',NULL,NULL),(13923,9079,'AP','7406243535',0,'2013-12-26 04:06:47',NULL,NULL),(28326,18256,'TE','8302558667',0,'2014-01-16 08:44:34',NULL,NULL),(1949,1206,'AP','3304955014',0,'2013-12-25 18:20:00',NULL,NULL),(14182,9277,'AP','5174148530',0,'2013-12-26 04:15:51',NULL,NULL),(39475,26107,'TE','7404859109',0,'2014-02-28 06:30:15',NULL,NULL),(8858,5804,'EM','dangime@gmail.com',0,'2013-12-25 23:47:35',NULL,NULL),(27885,17968,'EM','ghasrouni1@roadrunner.com',0,'2014-01-15 02:06:48',NULL,NULL),(26581,17100,'EM','pearsonpatricia49@yahoo.com',0,'2014-01-13 02:21:32',NULL,NULL),(440,273,'AP','5139269927',0,'2013-12-25 17:30:05',NULL,NULL),(24799,15999,'AP','2812027408',0,'2014-01-04 02:01:27',NULL,NULL),(24099,15555,'TE','5043391859',1,'2014-01-02 04:31:27',NULL,NULL),(4666,2983,'EM','silkrebs@gmail.com',0,'2013-12-25 20:17:16',NULL,NULL),(21506,13819,'EM','mason500@neo.rr.com',0,'2013-12-26 13:11:52',NULL,NULL),(31776,20742,'AP','3305598989',0,'2014-01-30 21:01:24',NULL,NULL),(37861,24976,'AP','2147148300',0,'2014-02-20 22:00:31',NULL,NULL),(43669,28981,'AP','3303887848',0,'2014-03-10 21:01:09',NULL,NULL),(7680,5003,'AP','4405902531',0,'2013-12-25 22:47:12',NULL,NULL),(26449,17023,'TE','3308254153',0,'2014-01-13 02:20:41',NULL,NULL),(25029,16131,'TE','3303890573',0,'2014-01-04 02:05:42',NULL,NULL),(31085,20233,'BN','6016088679',0,'2014-01-28 21:00:03',NULL,NULL),(33946,22276,'TE','9157601400',0,'2014-02-10 11:00:18',NULL,NULL),(34412,22572,'AP','2162151795',0,'2014-02-10 21:31:57',NULL,NULL),(35656,23450,'TE','8324656448',0,'2014-02-13 22:01:37',NULL,NULL),(38344,25330,'TE','2256505107',0,'2014-02-25 21:30:17',NULL,NULL),(40110,26599,'TE','9154088157',0,'2014-02-28 21:30:40',NULL,NULL),(41898,27858,'EM','marilynconner01@yahoo.com',0,'2014-03-05 21:32:17',NULL,NULL),(7429,4833,'TE','2567363306',0,'2013-12-25 22:17:23',NULL,NULL),(7087,4628,'TE','6015739270',0,'2013-12-25 22:06:27',NULL,NULL),(12142,7931,'AP','3372553087',0,'2013-12-26 03:06:38',NULL,NULL),(26674,17160,'EM','bessiemag@yahoo.com',0,'2014-01-13 02:22:01',NULL,NULL),(25259,16286,'AP','8598932180',0,'2014-01-07 04:00:42',NULL,NULL),(4615,2943,'TE','5139849550',0,'2013-12-25 20:16:18',NULL,NULL),(24315,15707,'TE','3308560715',1,'2014-01-02 04:35:57',NULL,NULL),(20376,13124,'EM','julieguilfoyle@outlook.com',0,'2013-12-26 12:52:50',NULL,NULL),(30377,19679,'AP','3254367103',0,'2014-01-23 21:00:37',NULL,NULL),(35733,23500,'EM','GECKO1287@YAHOO.COM',0,'2014-02-13 22:02:07',NULL,NULL),(41465,27556,'TE','2692622025',0,'2014-03-04 21:30:14',NULL,NULL),(10666,6931,'AP','3304216429',0,'2013-12-26 01:46:32',NULL,NULL),(10080,6588,'AP','8646162187',0,'2013-12-26 00:53:11',NULL,NULL),(28370,18279,'TE','8066261822',0,'2014-01-16 08:44:46',NULL,NULL),(28173,18159,'AP','9372078115',0,'2014-01-15 02:07:53',NULL,NULL),(27937,18002,'TE','4402280510',0,'2014-01-15 02:07:00',NULL,NULL),(14264,9331,'TE','5134048598',0,'2013-12-26 04:30:44',NULL,NULL),(33672,22087,'TE','3054919987',0,'2014-02-08 19:00:22',NULL,NULL),(37714,24867,'TE','2146065110',0,'2014-02-20 05:32:09',NULL,NULL),(41225,27383,'TE','6019534041',0,'2014-03-04 21:01:22',NULL,NULL),(13833,9019,'TE','3307849480',0,'2013-12-26 04:05:17',NULL,NULL),(4046,2583,'TE','5132903857',0,'2013-12-25 19:38:04',NULL,NULL),(9884,6464,'EM','info@intensivejournal.org',0,'2013-12-26 00:49:58',NULL,NULL),(23640,15265,'AP','4196773324',0,'2014-01-01 12:09:26',NULL,NULL),(22319,14388,'TE','8175996110',0,'2013-12-28 03:30:56',NULL,NULL),(21642,13930,'AP','2603104032',0,'2013-12-26 13:14:27',NULL,NULL),(2721,1652,'AP','9792245583',0,'2013-12-25 18:53:23',NULL,NULL),(34281,22492,'TE','6102097632',0,'2014-02-10 21:31:08',NULL,NULL),(11076,7194,'TE','3309287604',0,'2013-12-26 02:00:29',NULL,NULL),(27315,17590,'EM','geniseeve@yahoo.com',0,'2014-01-14 01:32:10',NULL,NULL),(10362,6755,'AP','3309836573',0,'2013-12-26 01:16:12',NULL,NULL),(2130,1312,'EM','robert.warner@ymail.com',0,'2013-12-25 18:31:31',NULL,NULL),(14729,9636,'TE','2817785414',0,'2013-12-26 04:38:21',NULL,NULL),(24623,15878,'AP','5045128822',0,'2014-01-03 02:05:20',NULL,NULL),(23675,15286,'TE','6622374407',1,'2014-01-02 04:22:18',NULL,NULL),(35067,23029,'TE','9363559074',0,'2014-02-12 21:30:33',NULL,NULL),(35494,23337,'AP','7247773860',0,'2014-02-13 22:00:35',NULL,NULL),(36201,23829,'AP','6012126548',0,'2014-02-14 21:31:45',NULL,NULL),(41638,27680,'AP','9565922096',0,'2014-03-05 21:30:38',NULL,NULL),(43107,28655,'AP','6785968982',0,'2014-03-08 21:30:40',NULL,NULL),(10770,7002,'TE','2145350453',0,'2013-12-26 01:48:18',NULL,NULL),(3618,2288,'TE','9377672155',0,'2013-12-25 19:30:42',NULL,NULL),(27706,17857,'TE','4195123195',0,'2014-01-15 02:06:09',NULL,NULL),(27484,17703,'AP','5045782709',0,'2014-01-14 01:33:05',NULL,NULL),(25846,16661,'AP','2252450292',0,'2014-01-08 18:24:24',NULL,NULL),(3317,2087,'AP','2252843492',0,'2013-12-25 19:16:46',NULL,NULL),(33359,21853,'AP','7402841003',0,'2014-02-06 21:01:17',NULL,NULL),(34977,22963,'EM','snealaabco@woh.rr.com',0,'2014-02-12 21:00:11',NULL,NULL),(54,35,'TE','4404873060',0,'2013-12-25 17:15:55',NULL,NULL),(29863,19320,'EM','mikestone316@gmail.com',1,'2014-01-22 03:22:11',NULL,NULL),(29293,18927,'BN','3302711996',0,'2014-01-20 08:05:36',NULL,NULL),(28577,18422,'TE','5042860447',0,'2014-01-16 08:45:53',NULL,NULL),(4176,2668,'AP','3305595203',0,'2013-12-25 19:46:59',NULL,NULL),(7299,4752,'TE','2544356021',0,'2013-12-25 22:15:15',NULL,NULL),(6545,4231,'TE','2817857362',0,'2013-12-25 21:50:43',NULL,NULL),(30226,19579,'TE','2259218351',0,'2014-01-23 03:02:40',NULL,NULL),(32243,21058,'AP','3183444721',0,'2014-02-02 19:00:10',NULL,NULL),(41867,27839,'EM','kerid.fish@yahoo.com',0,'2014-03-05 21:32:06',NULL,NULL),(10143,6629,'TE','4192661516',0,'2013-12-26 00:54:18',NULL,NULL),(29840,19306,'TE','3183236775',1,'2014-01-22 03:22:03',NULL,NULL),(4529,2880,'TE','7134193013',0,'2013-12-25 20:02:12',NULL,NULL),(6895,4482,'EM','mfoster81805@gmail.com',0,'2013-12-25 22:03:01',NULL,NULL),(26536,17070,'EM','phamt90@gmail.com',0,'2014-01-13 02:21:17',NULL,NULL),(20469,13186,'AP','8323607000',0,'2013-12-26 12:54:28',NULL,NULL),(41323,27453,'TE','5137520661',0,'2014-03-04 21:02:00',NULL,NULL),(43791,29069,'AP','4194501766',0,'2014-03-10 21:01:56',NULL,NULL),(14485,9458,'TE','5138363065',0,'2013-12-26 04:34:10',NULL,NULL),(1410,860,'AP','4196055004',0,'2013-12-25 18:07:09',NULL,NULL),(13906,9064,'AP','4329788262',0,'2013-12-26 04:06:27',NULL,NULL),(5877,3769,'EM','luke4dia49@hotmail.com',0,'2013-12-25 21:33:40',NULL,NULL),(12278,8032,'AP','6622994701',0,'2013-12-26 03:09:10',NULL,NULL),(9804,6414,'EM','ct10harmonb@yahoo.com',0,'2013-12-26 00:48:43',NULL,NULL),(35702,23481,'EM','lmkrn28@gmail.com',0,'2014-02-13 22:01:55',NULL,NULL),(38859,25685,'TE','6017131061',0,'2014-02-26 09:30:07',NULL,NULL),(10570,6882,'TE','3185633103',0,'2013-12-26 01:45:06',NULL,NULL),(28479,18353,'EM','koreymishel_06@yahoo.com',0,'2014-01-16 08:45:22',NULL,NULL),(26123,16820,'AP','8177365376',0,'2014-01-13 02:18:21',NULL,NULL),(21174,13619,'EM','rsseibert@fuse.net',0,'2013-12-26 13:05:49',NULL,NULL),(10899,7082,'TE','2163210729',0,'2013-12-26 01:50:19',NULL,NULL),(25113,16190,'TE','9158524363',0,'2014-01-05 00:00:48',NULL,NULL),(14271,9335,'AP','2253230603',0,'2013-12-26 04:30:51',NULL,NULL),(32833,21485,'TE','4194387060',0,'2014-02-04 21:01:45',NULL,NULL),(33310,21816,'EM','Rpapczun@kent.edu',0,'2014-02-06 21:00:57',NULL,NULL),(34716,22762,'AP','5132362991',0,'2014-02-11 21:01:33',NULL,NULL),(36242,23853,'TE','4196282042',0,'2014-02-14 21:31:59',NULL,NULL),(41061,27278,'EM','CARVALOPEZ@MSN.COM',0,'2014-03-04 21:00:21',NULL,NULL),(2848,1729,'EM','mmalinar23@hotmail.com',0,'2013-12-25 18:55:22',NULL,NULL),(29423,19022,'TE','6017393841',0,'2014-01-20 08:06:26',NULL,NULL),(27292,17573,'TE','5133677006',0,'2014-01-14 01:32:03',NULL,NULL),(13687,8923,'AP','5138072099',0,'2013-12-26 04:02:51',NULL,NULL),(11764,7656,'AP','6789949922',0,'2013-12-26 03:00:09',NULL,NULL),(32313,21110,'TE','5049755545',0,'2014-02-03 21:00:07',NULL,NULL),(34483,22624,'TE','3619042675',0,'2014-02-11 21:00:12',NULL,NULL),(36165,23803,'TE','2167517969',0,'2014-02-14 21:31:31',NULL,NULL),(36842,24261,'AP','2252530309',0,'2014-02-17 19:00:11',NULL,NULL),(38275,25272,'AP','3183934003',0,'2014-02-25 21:00:12',NULL,NULL),(38575,25495,'TE','5672047843',0,'2014-02-25 21:31:50',NULL,NULL),(38876,25695,'AP','9565894711',0,'2014-02-26 09:30:15',NULL,NULL),(8889,5822,'AP','7135043074',0,'2013-12-25 23:48:03',NULL,NULL),(4695,3003,'TE','3308081808',0,'2013-12-25 20:17:43',NULL,NULL),(34982,22966,'EM','lannyndeb@yahoo.com',0,'2014-02-12 21:00:14',NULL,NULL),(36439,23995,'EM','gorey.peter@yahoo.com',0,'2014-02-15 22:00:29',NULL,NULL),(38820,25663,'EM','cymzuleta@yahoo.com',0,'2014-02-26 08:30:47',NULL,NULL),(38857,25684,'AP','9033120119',0,'2014-02-26 09:30:07',NULL,NULL),(43201,28709,'AP','4193565301',0,'2014-03-08 21:31:13',NULL,NULL),(263,161,'AP','2812178524',0,'2013-12-25 17:19:12',NULL,NULL),(28680,18506,'TE','3303190742',0,'2014-01-16 08:46:31',NULL,NULL),(813,505,'EM','svranich1@hotmail.com',0,'2013-12-25 17:48:49',NULL,NULL),(11367,7404,'EM','Stickman1950@yahoo.com',0,'2013-12-26 02:16:31',NULL,NULL),(8591,5646,'TE','2146321665',0,'2013-12-25 23:31:23',NULL,NULL),(3622,2291,'TE','4405942988',0,'2013-12-25 19:30:46',NULL,NULL),(1794,1112,'EM','MAFGOLD52@YAHOO.COM',0,'2013-12-25 18:17:33',NULL,NULL),(10309,6724,'TE','6149464985',0,'2013-12-26 01:15:20',NULL,NULL),(3074,1915,'EM','alleekat512@yahoo.com',0,'2013-12-25 19:00:04',NULL,NULL),(24589,15858,'EM','namgoodie22@yahoo.com',0,'2014-01-03 02:04:41',NULL,NULL),(9233,6044,'AP','3302422474',0,'2013-12-26 00:01:29',NULL,NULL),(5757,3688,'EM','jasontroyan@gmail.com',0,'2013-12-25 21:31:40',NULL,NULL),(7132,4653,'AP','5132261020',0,'2013-12-25 22:07:10',NULL,NULL),(21706,13977,'AP','5136177800',0,'2013-12-26 13:15:32',NULL,NULL),(13758,8967,'TE','4403543490',0,'2013-12-26 04:04:00',NULL,NULL),(14027,9159,'AP','5133646610',0,'2013-12-26 04:08:41',NULL,NULL),(28678,18502,'TE','3307753822',0,'2014-01-16 08:46:30',NULL,NULL),(30903,20091,'TE','5044537954',0,'2014-01-27 21:00:30',NULL,NULL),(31716,20699,'AP','2259210557',0,'2014-01-30 21:01:02',NULL,NULL),(32775,21442,'AP','3302459905',0,'2014-02-04 21:01:25',NULL,NULL),(33440,21903,'TE','4198376010',0,'2014-02-06 21:01:48',NULL,NULL),(37658,24830,'TE','5133025862',0,'2014-02-20 04:52:01',NULL,NULL),(40472,26863,'EM','morivera86@gmail.com',0,'2014-03-01 21:00:58',NULL,NULL),(41155,27334,'AP','2167012464',0,'2014-03-04 21:00:54',NULL,NULL),(42715,28412,'TE','4409518548',0,'2014-03-07 21:30:57',NULL,NULL),(27607,17796,'AP','5136738338',0,'2014-01-14 01:33:51',NULL,NULL),(702,434,'EM','smtmonebay@yahoo.com',0,'2013-12-25 17:47:01',NULL,NULL),(1482,909,'EM','mark.brosee@fivesgroup.com',0,'2013-12-25 18:08:30',NULL,NULL),(26397,16990,'EM','vnkondo@yahoo.com',0,'2014-01-13 02:20:24',NULL,NULL),(25519,16455,'TE','4193403066',0,'2014-01-07 04:05:34',NULL,NULL),(5804,3727,'TE','9152402117',0,'2013-12-25 21:32:30',NULL,NULL),(20888,13432,'TE','4402315707',0,'2013-12-26 13:01:04',NULL,NULL),(21274,13669,'AP','9012701125',0,'2013-12-26 13:07:52',NULL,NULL),(22645,14601,'TE','9373697607',0,'2013-12-28 03:36:25',NULL,NULL),(22420,14457,'EM','jrdot504@gmail.com',0,'2013-12-28 03:32:41',NULL,NULL),(22103,14235,'EM','footworks601@hotmail.com',0,'2013-12-27 02:05:08',NULL,NULL),(21610,13909,'EM','JoanMSambora@yahoo.com',0,'2013-12-26 13:13:54',NULL,NULL),(29096,18790,'EM','stmssls@sbcglobal.net',0,'2014-01-17 03:35:56',NULL,NULL),(29916,19360,'AP','3307602542',1,'2014-01-22 03:22:30',NULL,NULL),(40064,26563,'EM','tmurphy24@fuse.net',0,'2014-02-28 21:30:21',NULL,NULL),(40093,26588,'EM','lad30@uakron.edu',0,'2014-02-28 21:30:35',NULL,NULL),(41125,27317,'TE','9364141135',0,'2014-03-04 21:00:43',NULL,NULL),(9475,6202,'TE','5132888641',0,'2013-12-26 00:30:38',NULL,NULL),(9275,6071,'TE','5135753855',0,'2013-12-26 00:02:12',NULL,NULL),(26903,17308,'AP','8327297272',0,'2014-01-13 02:23:42',NULL,NULL),(26635,17138,'AP','4193505145',0,'2014-01-13 02:21:50',NULL,NULL),(26498,17052,'TE','9378694881',0,'2014-01-13 02:20:58',NULL,NULL),(24604,15867,'EM','Tweet38829@yahoo.com',0,'2014-01-03 02:04:59',NULL,NULL),(4265,2727,'AP','2258026100',0,'2013-12-25 19:48:22',NULL,NULL),(28374,18282,'TE','5135280901',0,'2014-01-16 08:44:48',NULL,NULL),(7460,4856,'AP','5678256107',0,'2013-12-25 22:30:32',NULL,NULL),(6192,3991,'TE','4197892499',0,'2013-12-25 21:39:05',NULL,NULL),(31585,20601,'TE','5132255772',0,'2014-01-30 21:00:13',NULL,NULL),(33158,21718,'TE','9377834075',0,'2014-02-05 21:31:18',NULL,NULL),(36596,24094,'AP','4196513530',0,'2014-02-15 22:01:27',NULL,NULL),(37405,24634,'TE','5044812867',0,'2014-02-20 04:18:36',NULL,NULL),(40614,26960,'TE','3304596742',0,'2014-03-03 01:00:30',NULL,NULL),(41265,27423,'TE','2254543016',0,'2014-03-04 21:01:40',NULL,NULL),(42446,28192,'AP','7133666927',0,'2014-03-06 21:30:04',NULL,NULL),(42573,28328,'AP','2147973992',0,'2014-03-07 21:30:09',NULL,NULL),(43650,28971,'AP','5049314344',0,'2014-03-10 21:01:03',NULL,NULL),(1295,788,'TE','4302001255',0,'2013-12-25 18:05:14',NULL,NULL),(10835,7036,'AP','2148307946',0,'2013-12-26 01:49:16',NULL,NULL),(9330,6111,'EM','srtussing@gmail.com',0,'2013-12-26 00:15:27',NULL,NULL),(13692,8926,'TE','6143381955',0,'2013-12-26 04:02:55',NULL,NULL),(12058,7872,'AP','4253271474',0,'2013-12-26 03:05:12',NULL,NULL),(8231,5386,'AP','5044917671',0,'2013-12-25 23:08:31',NULL,NULL),(1588,979,'AP','4194392156',0,'2013-12-25 18:10:15',NULL,NULL),(3347,2104,'EM','hbug1987@aol.com',0,'2013-12-25 19:17:16',NULL,NULL),(6364,4098,'EM','sconcho@live.com',0,'2013-12-25 21:47:41',NULL,NULL),(34448,22601,'TE','4193188787',0,'2014-02-10 21:32:15',NULL,NULL),(36830,24256,'AP','9152069515',0,'2014-02-17 19:00:07',NULL,NULL),(41366,27481,'AP','8328830907',0,'2014-03-04 21:02:17',NULL,NULL),(2168,1334,'TE','5135717164',0,'2013-12-25 18:32:11',NULL,NULL),(2349,1428,'AP','9852014576',0,'2013-12-25 18:47:29',NULL,NULL),(26213,16873,'TE','5126188708',0,'2014-01-13 02:19:17',NULL,NULL),(23796,15349,'AP','3308586636',1,'2014-01-02 04:24:29',NULL,NULL),(21836,14067,'AP','9373217267',0,'2013-12-27 02:00:44',NULL,NULL),(3524,2204,'AP','4199051000',0,'2013-12-25 19:20:07',NULL,NULL),(21121,13579,'EM','eveabrams@gmail.com',0,'2013-12-26 13:04:52',NULL,NULL),(3643,2309,'TE','3302888574',0,'2013-12-25 19:31:08',NULL,NULL),(14441,9436,'AP','5132215451',0,'2013-12-26 04:33:33',NULL,NULL),(14188,9284,'AP','9375817138',0,'2013-12-26 04:15:58',NULL,NULL),(12346,8075,'TE','4193948474',0,'2013-12-26 03:10:20',NULL,NULL),(11908,7749,'TE','9375854523',0,'2013-12-26 03:02:29',NULL,NULL),(8546,5616,'EM','tnhaley@gmail.com',0,'2013-12-25 23:30:39',NULL,NULL),(34451,22602,'AP','4193188787',0,'2014-02-10 21:32:15',NULL,NULL),(36116,23767,'EM','dorianspeaks@gmail.com',0,'2014-02-14 21:31:12',NULL,NULL),(38079,25136,'AP','3252174810',0,'2014-02-21 22:00:07',NULL,NULL),(39415,26062,'TE','4192354145',0,'2014-02-26 21:02:40',NULL,NULL),(42029,27934,'AP','8062923445',0,'2014-03-06 21:00:27',NULL,NULL),(43937,29145,'AP','3145567080',0,'2014-03-10 21:02:45',NULL,NULL),(6707,4360,'EM','mam478@bex.net',0,'2013-12-25 21:53:44',NULL,NULL),(33173,21725,'AP','8303852831',0,'2014-02-06 21:00:06',NULL,NULL),(35011,22987,'EM','jrohr80@gmail.com',0,'2014-02-12 21:30:12',NULL,NULL),(42283,28079,'AP','2104122170',0,'2014-03-06 21:01:56',NULL,NULL),(1704,1046,'EM','stanwhisenant@yahoo.com',0,'2013-12-25 18:15:55',NULL,NULL),(24689,15921,'AP','6019512572',0,'2014-01-03 02:06:41',NULL,NULL),(21424,13775,'AP','2514903691',0,'2013-12-26 13:10:36',NULL,NULL),(10779,7008,'TE','8323053517',0,'2013-12-26 01:48:26',NULL,NULL),(4795,3067,'TE','5104595149',0,'2013-12-25 20:19:22',NULL,NULL),(10172,6647,'TE','8068313536',0,'2013-12-26 01:00:29',NULL,NULL),(33302,21808,'AP','3304193112',0,'2014-02-06 21:00:53',NULL,NULL),(37318,24556,'EM','ruggersarge@yahoo.com',0,'2014-02-20 04:05:37',NULL,NULL),(778,484,'EM','mlggg@aol.com',0,'2013-12-25 17:48:15',NULL,NULL),(13588,8860,'TE','2146634282',0,'2013-12-26 04:01:15',NULL,NULL),(13709,8934,'EM','arleneblessing@gmail.com',0,'2013-12-26 04:03:08',NULL,NULL),(26804,17241,'TE','5133098954',0,'2014-01-13 02:22:45',NULL,NULL),(26478,17041,'TE','5133931680',0,'2014-01-13 02:20:51',NULL,NULL),(25726,16582,'TE','9857744969',0,'2014-01-08 18:23:58',NULL,NULL),(22681,14626,'TE','4198367908',0,'2013-12-28 03:37:03',NULL,NULL),(24482,15797,'AP','9858470999',0,'2014-01-03 02:02:43',NULL,NULL),(32247,21059,'EM','benjaminswhaley@gmail.com',0,'2014-02-02 19:00:11',NULL,NULL),(35709,23485,'TE','5043557148',0,'2014-02-13 22:01:58',NULL,NULL),(36289,23893,'AP','9379872864',0,'2014-02-14 21:32:19',NULL,NULL),(41123,27316,'AP','9034040298',0,'2014-03-04 21:00:43',NULL,NULL),(5377,3442,'AP','3303286235',0,'2013-12-25 21:19:16',NULL,NULL),(9569,6267,'AP','4408583035',0,'2013-12-26 00:32:25',NULL,NULL),(27092,17423,'EM','jpitz64@aol.com',0,'2014-01-13 03:00:28',NULL,NULL),(604,372,'EM','alyssasettles@gmail.com',0,'2013-12-25 17:45:29',NULL,NULL),(9485,6207,'TE','4197730331',0,'2013-12-26 00:30:46',NULL,NULL),(22964,14812,'TE','3379675251',1,'2013-12-29 11:14:06',NULL,NULL),(22127,14253,'TE','9853814633',0,'2013-12-27 02:05:34',NULL,NULL),(7120,4649,'TE','5132509464',0,'2013-12-25 22:07:01',NULL,NULL),(8956,5864,'EM','woody75@sbcglobal.net',0,'2013-12-25 23:49:05',NULL,NULL),(31817,20773,'AP','9033532061',0,'2014-01-31 21:00:05',NULL,NULL),(34190,22424,'AP','5042595090',0,'2014-02-10 21:30:32',NULL,NULL),(37225,24498,'TE','8178745982',0,'2014-02-20 03:47:55',NULL,NULL),(37946,25038,'EM','sweetsusie772000@hotmail.com',0,'2014-02-20 22:01:08',NULL,NULL),(40076,26577,'TE','6142549579',0,'2014-02-28 21:30:28',NULL,NULL),(42011,27924,'AP','3023391116',0,'2014-03-06 21:00:21',NULL,NULL),(42782,28453,'TE','9858395237',0,'2014-03-07 21:31:21',NULL,NULL),(9312,6097,'AP','2163018803',0,'2013-12-26 00:15:07',NULL,NULL),(24287,15693,'TE','4198362912',1,'2014-01-02 04:35:26',NULL,NULL),(21052,13541,'AP','3184233507',0,'2013-12-26 13:03:48',NULL,NULL),(14467,9450,'TE','7403850798',0,'2013-12-26 04:33:57',NULL,NULL),(13590,8860,'EM','Mdwoodward88@gmail.com',0,'2013-12-26 04:01:16',NULL,NULL),(2435,1493,'TE','6142566217',0,'2013-12-25 18:49:05',NULL,NULL),(3880,2465,'AP','3377948927',0,'2013-12-25 19:35:04',NULL,NULL),(31437,20492,'TE','3184044561',0,'2014-01-29 21:01:07',NULL,NULL),(34822,22839,'TE','4195604753',0,'2014-02-11 21:02:13',NULL,NULL),(38880,25697,'TE','9035692661',0,'2014-02-26 09:30:17',NULL,NULL),(5351,3428,'AP','3374125390',0,'2013-12-25 21:18:51',NULL,NULL),(29000,18720,'EM','ginamj@yahoo.com',0,'2014-01-17 03:35:34',NULL,NULL),(28988,18709,'EM','henryhouse6@gmail.com',0,'2014-01-17 03:35:31',NULL,NULL),(28815,18598,'EM','wshirley915@gmail.com',0,'2014-01-16 08:47:17',NULL,NULL),(26824,17252,'TE','5136412499',0,'2014-01-13 02:23:12',NULL,NULL),(1479,906,'TE','5133560838',0,'2013-12-25 18:08:25',NULL,NULL),(3659,2320,'EM','codykwitt@gmail.com',0,'2013-12-25 19:31:24',NULL,NULL),(30124,19512,'TE','8144875791',0,'2014-01-23 03:02:15',NULL,NULL),(32878,21516,'EM','info@zumbarocks.org',0,'2014-02-05 21:00:05',NULL,NULL),(38056,25117,'TE','6148343907',0,'2014-02-21 21:30:19',NULL,NULL),(38928,25734,'AP','3373294777',0,'2014-02-26 09:30:37',NULL,NULL),(41906,27863,'EM','Ohzacc@gmail.com',0,'2014-03-05 21:32:20',NULL,NULL),(357,220,'TE','3379403479',0,'2013-12-25 17:20:45',NULL,NULL),(27956,18018,'TE','9372986898',0,'2014-01-15 02:07:05',NULL,NULL),(10092,6594,'TE','6019687879',0,'2013-12-26 00:53:21',NULL,NULL),(6833,4434,'AP','6145610807',0,'2013-12-25 22:01:58',NULL,NULL),(14514,9484,'TE','3304916972',0,'2013-12-26 04:34:43',NULL,NULL),(14429,9430,'EM','lyc3426@live.com',0,'2013-12-26 04:33:23',NULL,NULL),(13779,8980,'AP','9377766967',0,'2013-12-26 04:04:19',NULL,NULL),(2841,1723,'AP','2162624375',0,'2013-12-25 18:55:16',NULL,NULL),(37647,24814,'AP','5133770116',0,'2014-02-20 04:50:22',NULL,NULL),(40090,26587,'EM','dlrusher38@yahoo.com',0,'2014-02-28 21:30:34',NULL,NULL),(2809,1700,'TE','4192372364',0,'2013-12-25 18:54:42',NULL,NULL),(3403,2138,'EM','arht1309@gmail.com',0,'2013-12-25 19:18:11',NULL,NULL),(27643,17818,'EM','Natalierking@yahoo.com',0,'2014-01-15 02:05:55',NULL,NULL),(21365,13738,'AP','3308587268',0,'2013-12-26 13:09:36',NULL,NULL),(35337,23218,'AP','6014153889',0,'2014-02-12 21:32:18',NULL,NULL),(37730,24882,'TE','4403719555',0,'2014-02-20 05:36:39',NULL,NULL),(38553,25473,'EM','erickalanderos@msn.com',0,'2014-02-25 21:31:39',NULL,NULL),(39302,26001,'TE','2252725842',0,'2014-02-26 21:02:03',NULL,NULL),(39864,26373,'AP','6145962960',0,'2014-02-28 07:00:14',NULL,NULL),(40732,27070,'TE','3373446701',0,'2014-03-03 21:30:05',NULL,NULL),(11874,7730,'TE','2164640560',0,'2013-12-26 03:01:58',NULL,NULL),(28323,18255,'TE','9036584519',0,'2014-01-16 08:44:33',NULL,NULL),(27852,17943,'EM','vanessa.polanco52@gmail.com',0,'2014-01-15 02:06:40',NULL,NULL),(27298,17577,'TE','9376215007',0,'2014-01-14 01:32:05',NULL,NULL),(10364,6756,'TE','3304978014',0,'2013-12-26 01:16:14',NULL,NULL),(25347,16347,'AP','7246506670',0,'2014-01-07 04:02:24',NULL,NULL),(21988,14163,'AP','5049136270',0,'2013-12-27 02:03:13',NULL,NULL),(7757,5064,'TE','9404561504',0,'2013-12-25 23:00:32',NULL,NULL),(10087,6591,'TE','3614430707',0,'2013-12-26 00:53:17',NULL,NULL),(30322,19642,'AP','3304691536',0,'2014-01-23 21:00:15',NULL,NULL),(32820,21476,'TE','5138076618',0,'2014-02-04 21:01:40',NULL,NULL),(32986,21596,'TE','3308361129',0,'2014-02-05 21:30:30',NULL,NULL),(39428,26076,'EM','MRSURTON@GMAIL.COM',0,'2014-02-26 21:02:47',NULL,NULL),(5735,3676,'AP','5136580147',0,'2013-12-25 21:31:20',NULL,NULL),(5691,3655,'TE','4405931684',0,'2013-12-25 21:30:44',NULL,NULL),(24341,15720,'AP','9376575699',0,'2014-01-03 02:00:12',NULL,NULL),(4840,3098,'AP','2162966801',0,'2013-12-25 20:20:11',NULL,NULL),(20634,13273,'AP','7138753961',0,'2013-12-26 12:56:59',NULL,NULL),(29953,19383,'AP','9562673416',1,'2014-01-22 03:22:43',NULL,NULL),(30190,19557,'AP','2253244288',0,'2014-01-23 03:02:32',NULL,NULL),(36662,24136,'TE','9373421949',0,'2014-02-15 22:01:50',NULL,NULL),(40249,26697,'AP','3185279444',0,'2014-02-28 21:31:31',NULL,NULL),(42783,28453,'AP','9857102031',0,'2014-03-07 21:31:21',NULL,NULL),(5915,3794,'AP','4195593074',0,'2013-12-25 21:34:19',NULL,NULL),(28741,18546,'AP','6016245839',0,'2014-01-16 08:46:52',NULL,NULL),(7908,5153,'TE','6142842195',0,'2013-12-25 23:02:51',NULL,NULL),(21368,13740,'AP','3305927161',0,'2013-12-26 13:09:39',NULL,NULL),(29624,19141,'AP','9153569515',0,'2014-01-21 08:45:29',NULL,NULL),(32375,21152,'TE','6144287618',0,'2014-02-03 21:00:28',NULL,NULL),(35437,23301,'TE','6144042307',0,'2014-02-13 22:00:14',NULL,NULL),(38433,25399,'TE','4196517560',0,'2014-02-25 21:30:55',NULL,NULL),(43857,29104,'TE','9547343642',0,'2014-03-10 21:02:19',NULL,NULL),(6909,4499,'TE','4324455584',0,'2013-12-25 22:03:19',NULL,NULL),(28163,18153,'TE','4193392798',0,'2014-01-15 02:07:51',NULL,NULL),(23999,15490,'EM','katiecat082@gmail.com',1,'2014-01-02 04:29:29',NULL,NULL),(3945,2506,'TE','9857484039',0,'2013-12-25 19:36:08',NULL,NULL),(20528,13213,'AP','8324191494',0,'2013-12-26 12:55:19',NULL,NULL),(32283,21088,'TE','9376871130',0,'2014-02-02 19:00:25',NULL,NULL),(33025,21635,'EM','crmilligan@gmail.com',0,'2014-02-05 21:30:43',NULL,NULL),(37494,24689,'TE','9567401351',0,'2014-02-20 04:32:08',NULL,NULL),(4837,3097,'TE','2163968318',0,'2013-12-25 20:20:09',NULL,NULL),(28708,18525,'TE','2107238784',0,'2014-01-16 08:46:40',NULL,NULL),(25876,16677,'EM','kank3634@aol.com',0,'2014-01-08 18:24:31',NULL,NULL),(3950,2508,'AP','5672045902',0,'2013-12-25 19:36:12',NULL,NULL),(12332,8064,'AP','4196019223',0,'2013-12-26 03:10:02',NULL,NULL),(34037,22320,'EM','sarahleblanc21@gmail.com',0,'2014-02-10 11:00:53',NULL,NULL),(34541,22657,'TE','9152021249',0,'2014-02-11 21:00:32',NULL,NULL),(34544,22658,'TE','8064002352',0,'2014-02-11 21:00:33',NULL,NULL),(41097,27297,'EM','MEG1359@GMAIL.COM',0,'2014-03-04 21:00:32',NULL,NULL),(5238,3366,'TE','9567467149',0,'2013-12-25 21:17:07',NULL,NULL),(395,242,'EM','fitim12@embarqmail.com',0,'2013-12-25 17:21:21',NULL,NULL),(11888,7736,'TE','4198891268',0,'2013-12-26 03:02:08',NULL,NULL),(1095,673,'TE','6142660889',0,'2013-12-25 18:02:11',NULL,NULL),(11870,7727,'TE','4408854457',0,'2013-12-26 03:01:54',NULL,NULL),(11868,7726,'TE','7409923259',0,'2013-12-26 03:01:53',NULL,NULL),(4417,2814,'AP','5123187247',0,'2013-12-25 20:00:21',NULL,NULL),(33286,21796,'AP','9374501485',0,'2014-02-06 21:00:47',NULL,NULL),(35562,23387,'TE','6148377436',0,'2014-02-13 22:01:03',NULL,NULL),(35963,23660,'TE','2145788438',0,'2014-02-14 21:30:19',NULL,NULL),(36884,24291,'EM','girlmello15@yahoo.com',0,'2014-02-18 21:30:13',NULL,NULL),(37171,24469,'TE','4194741443',0,'2014-02-18 22:01:37',NULL,NULL),(37240,24506,'TE','3123436269',0,'2014-02-20 03:51:14',NULL,NULL),(11700,7618,'TE','5135618193',0,'2013-12-26 02:45:49',NULL,NULL),(11684,7606,'TE','4402242247',0,'2013-12-26 02:45:32',NULL,NULL),(24504,15807,'TE','3373054059',0,'2014-01-03 02:03:05',NULL,NULL),(5548,3543,'EM','grantaustindickey@outlook.com',0,'2013-12-25 21:21:52',NULL,NULL),(22468,14488,'AP','8176589820',0,'2013-12-28 03:33:27',NULL,NULL),(21727,14000,'TE','3305012093',0,'2013-12-26 13:16:01',NULL,NULL),(5494,3514,'TE','6014778169',0,'2013-12-25 21:21:05',NULL,NULL),(9098,5965,'AP','5678686413',0,'2013-12-25 23:51:27',NULL,NULL),(5058,3247,'AP','6147173797',0,'2013-12-25 20:46:31',NULL,NULL),(33348,21844,'EM','ekgaglione@earthlink.net',0,'2014-02-06 21:01:13',NULL,NULL),(41224,27382,'AP','6622133288',0,'2014-03-04 21:01:21',NULL,NULL),(7422,4826,'AP','9375707641',0,'2013-12-25 22:17:14',NULL,NULL),(2027,1253,'EM','cernbasher@gmail.com',0,'2013-12-25 18:21:19',NULL,NULL),(5450,3489,'TE','4406362432',0,'2013-12-25 21:20:24',NULL,NULL),(26066,16790,'TE','5136231187',0,'2014-01-13 02:18:05',NULL,NULL),(2375,1442,'AP','9377281725',0,'2013-12-25 18:47:53',NULL,NULL),(3965,2517,'TE','6629100801',0,'2013-12-25 19:36:29',NULL,NULL),(24587,15858,'TE','3309803868',0,'2014-01-03 02:04:40',NULL,NULL),(2625,1597,'TE','4693636325',0,'2013-12-25 18:51:56',NULL,NULL),(22789,14695,'TE','5133058067',1,'2013-12-29 11:08:55',NULL,NULL),(14562,9514,'EM','jkorner@columbus.rr.com',0,'2013-12-26 04:35:29',NULL,NULL),(43477,28872,'EM','djoslin99@yahoo.com',0,'2014-03-10 21:00:03',NULL,NULL),(539,337,'TE','4407493008',0,'2013-12-25 17:31:53',NULL,NULL),(5493,3512,'AP','9012832216',0,'2013-12-25 21:21:03',NULL,NULL),(29727,19223,'TE','4409304360',0,'2014-01-21 08:46:28',NULL,NULL),(21107,13569,'AP','3183499137',0,'2013-12-26 13:04:37',NULL,NULL),(38206,25218,'AP','2166506915',0,'2014-02-21 22:00:55',NULL,NULL),(38500,25442,'TE','9568310465',0,'2014-02-25 21:31:21',NULL,NULL),(40888,27167,'EM','rebekka.berry@att.net',0,'2014-03-03 21:31:03',NULL,NULL),(5666,3640,'AP','7696102778',0,'2013-12-25 21:30:20',NULL,NULL),(24817,16010,'TE','3182783483',0,'2014-01-04 02:01:47',NULL,NULL),(7439,4846,'TE','3309321036',0,'2013-12-25 22:30:14',NULL,NULL),(3137,1955,'AP','8176816774',0,'2013-12-25 19:01:05',NULL,NULL),(13815,9002,'TE','3302894228',0,'2013-12-26 04:04:55',NULL,NULL),(14204,9294,'AP','5134057986',0,'2013-12-26 04:16:11',NULL,NULL),(28264,18225,'AP','9727416288',0,'2014-01-16 08:44:16',NULL,NULL),(28903,18659,'AP','8177090750',0,'2014-01-17 03:35:13',NULL,NULL),(29004,18723,'AP','5137020043',0,'2014-01-17 03:35:35',NULL,NULL),(30596,19852,'EM','theresa.latimore@sbcglobal.net',0,'2014-01-24 21:00:32',NULL,NULL),(31185,20310,'TE','2147894892',0,'2014-01-28 21:00:48',NULL,NULL),(31447,20497,'AP','3183340664',0,'2014-01-29 21:01:10',NULL,NULL),(31490,20520,'EM','nroberts05@gmail.com',0,'2014-01-29 21:01:24',NULL,NULL),(31958,20868,'TE','6018595741',0,'2014-01-31 21:01:00',NULL,NULL),(32058,20932,'TE','9373903426',0,'2014-01-31 21:01:38',NULL,NULL),(35694,23478,'TE','5132251336',0,'2014-02-13 22:01:53',NULL,NULL),(35727,23495,'EM','kris2181@yahoo.com',0,'2014-02-13 22:02:05',NULL,NULL),(36960,24338,'TE','9404560907',0,'2014-02-18 22:00:18',NULL,NULL),(37064,24406,'TE','7408197187',0,'2014-02-18 22:00:58',NULL,NULL),(40676,27006,'EM','rgay001@neo.rr.com',0,'2014-03-03 21:00:05',NULL,NULL),(6443,4163,'TE','5134460522',0,'2013-12-25 21:49:02',NULL,NULL),(25741,16589,'TE','2259261761',0,'2014-01-08 18:24:00',NULL,NULL),(8651,5685,'TE','5132128353',0,'2013-12-25 23:32:25',NULL,NULL),(8462,5569,'TE','5134736877',0,'2013-12-25 23:16:38',NULL,NULL),(10326,6734,'EM','TThiVo3737@yahoo.com',0,'2013-12-26 01:15:35',NULL,NULL),(8257,5401,'EM','rbnhsr@gmail.com',0,'2013-12-25 23:08:57',NULL,NULL),(21018,13523,'AP','5042373210',0,'2013-12-26 13:03:15',NULL,NULL),(6927,4513,'AP','3148249793',0,'2013-12-25 22:03:39',NULL,NULL),(21636,13928,'TE','4194759682',0,'2013-12-26 13:14:22',NULL,NULL),(4538,2884,'AP','6143167948',0,'2013-12-25 20:02:20',NULL,NULL),(3829,2437,'TE','4405439526',0,'2013-12-25 19:34:20',NULL,NULL),(22507,14511,'EM','vpena1@aol.com',0,'2013-12-28 03:34:03',NULL,NULL),(3646,2311,'AP','6266790175',0,'2013-12-25 19:31:10',NULL,NULL),(3131,1950,'EM','dads440@yahoo.com',0,'2013-12-25 19:00:58',NULL,NULL),(23792,15344,'AP','3308586636',1,'2014-01-02 04:24:21',NULL,NULL),(27183,17503,'TE','4408659028',0,'2014-01-13 03:01:26',NULL,NULL),(27851,17942,'AP','2104383755',0,'2014-01-15 02:06:40',NULL,NULL),(28408,18304,'AP','2166961060',0,'2014-01-16 08:44:58',NULL,NULL),(30853,20056,'TE','9034319929',0,'2014-01-27 21:00:08',NULL,NULL),(31344,20424,'TE','3046338011',0,'2014-01-29 21:00:32',NULL,NULL),(38120,25161,'TE','9792575409',0,'2014-02-21 22:00:22',NULL,NULL),(40788,27106,'EM','victormendoza94@yahoo.com',0,'2014-03-03 21:30:25',NULL,NULL),(41490,27582,'TE','8067312355',0,'2014-03-05 21:00:12',NULL,NULL),(41656,27691,'TE','3614621756',0,'2014-03-05 21:30:44',NULL,NULL),(42203,28035,'TE','9373607772',0,'2014-03-06 21:01:29',NULL,NULL),(42631,28360,'AP','9156670797',0,'2014-03-07 21:30:28',NULL,NULL),(42786,28457,'TE','2253970864',0,'2014-03-07 21:31:23',NULL,NULL),(44005,29198,'TE','9378905998',0,'2014-03-10 21:30:09',NULL,NULL),(218,131,'AP','2165137732',0,'2013-12-25 17:18:30',NULL,NULL),(12046,7861,'AP','9379742355',0,'2013-12-26 03:05:00',NULL,NULL),(10882,7068,'TE','7405907458',0,'2013-12-26 01:50:03',NULL,NULL),(23329,15032,'TE','9852214967',0,'2014-01-01 12:02:39',NULL,NULL),(7496,4883,'TE','4192556198',0,'2013-12-25 22:31:18',NULL,NULL),(24210,15638,'AP','5045789276',1,'2014-01-02 04:33:44',NULL,NULL),(24524,15817,'TE','7407633848',0,'2014-01-03 02:03:26',NULL,NULL),(33140,21708,'TE','5137376016',0,'2014-02-05 21:31:14',NULL,NULL),(34328,22522,'TE','5139198101',0,'2014-02-10 21:31:26',NULL,NULL),(38589,25502,'TE','9157814473',0,'2014-02-25 21:31:55',NULL,NULL),(39361,26034,'AP','6016923093',0,'2014-02-26 21:02:23',NULL,NULL),(39720,26272,'TE','4193030810',0,'2014-02-28 06:31:16',NULL,NULL),(43101,28653,'TE','7408046051',0,'2014-03-08 21:30:39',NULL,NULL),(6694,4351,'TE','9377632790',0,'2013-12-25 21:53:29',NULL,NULL),(3579,2241,'EM','firstlady.perryman@gmail.com',0,'2013-12-25 19:21:03',NULL,NULL),(3160,1977,'TE','8176816774',0,'2013-12-25 19:01:37',NULL,NULL),(5591,3576,'TE','4193025069',0,'2013-12-25 21:22:40',NULL,NULL),(10764,6998,'TE','2813522168',0,'2013-12-26 01:48:11',NULL,NULL),(12004,7820,'AP','8066624848',0,'2013-12-26 03:04:11',NULL,NULL),(12134,7928,'EM','MNGUYEN83@GMAIL.COM',0,'2013-12-26 03:06:32',NULL,NULL),(12463,8159,'AP','4196193003',0,'2013-12-26 03:16:19',NULL,NULL),(1624,998,'TE','8326557956',0,'2013-12-25 18:10:51',NULL,NULL),(21584,13883,'TE','2162950420',0,'2013-12-26 13:13:20',NULL,NULL),(23330,15032,'AP','9855185666',0,'2014-01-01 12:02:40',NULL,NULL),(24248,15664,'AP','9402067071',1,'2014-01-02 04:34:34',NULL,NULL),(24715,15946,'TE','9374412530',0,'2014-01-03 02:07:21',NULL,NULL),(24927,16066,'EM','REBECCADANELSPERIN@YAHOO.COM',0,'2014-01-04 02:03:42',NULL,NULL),(24964,16090,'AP','6015949316',0,'2014-01-04 02:04:24',NULL,NULL),(29605,19129,'AP','5044157294',0,'2014-01-21 08:45:22',NULL,NULL),(34622,22700,'AP','9036415555',0,'2014-02-11 21:00:58',NULL,NULL),(35119,23068,'TE','5047173298',0,'2014-02-12 21:30:55',NULL,NULL),(36499,24030,'TE','4192572899',0,'2014-02-15 22:00:53',NULL,NULL),(38726,25598,'EM','santiaea@miamioh.edu',0,'2014-02-26 08:00:48',NULL,NULL),(38841,25674,'EM','KhabazelaD@hotmail.com',0,'2014-02-26 08:30:55',NULL,NULL),(40368,26793,'EM','robert.light2009@gmail.com',0,'2014-03-01 21:00:20',NULL,NULL),(41886,27851,'EM','twojanda@aol.com',0,'2014-03-05 21:32:13',NULL,NULL),(42669,28385,'AP','3307018932',0,'2014-03-07 21:30:42',NULL,NULL),(6166,3974,'TE','9374032971',0,'2013-12-25 21:38:39',NULL,NULL),(5255,3374,'AP','7025860346',0,'2013-12-25 21:17:21',NULL,NULL),(23348,15042,'TE','2253248362',0,'2014-01-01 12:03:00',NULL,NULL),(4594,2932,'TE','9379023941',0,'2013-12-25 20:16:02',NULL,NULL),(7943,5184,'TE','5137291437',0,'2013-12-25 23:03:35',NULL,NULL),(14738,9640,'AP','5125678879',0,'2013-12-26 04:38:29',NULL,NULL),(9146,5992,'TE','4195422034',0,'2013-12-26 00:00:05',NULL,NULL),(13718,8940,'TE','5136000476',0,'2013-12-26 04:03:18',NULL,NULL),(10161,6642,'AP','3616483805',0,'2013-12-26 01:00:21',NULL,NULL),(9176,6006,'TE','4197331046',0,'2013-12-26 00:00:30',NULL,NULL),(25293,16310,'TE','3186133296',0,'2014-01-07 04:01:23',NULL,NULL),(25860,16668,'TE','6148043562',0,'2014-01-08 18:24:27',NULL,NULL),(26297,16927,'AP','3185358104',0,'2014-01-13 02:19:47',NULL,NULL),(27058,17401,'AP','6017201251',0,'2014-01-13 03:00:17',NULL,NULL),(36080,23732,'EM','Srodirg55@gmail.com',0,'2014-02-14 21:30:58',NULL,NULL),(3148,1966,'TE','8325387988',0,'2013-12-25 19:01:21',NULL,NULL),(10123,6620,'TE','3307030667',0,'2013-12-26 00:54:01',NULL,NULL),(21127,13585,'AP','9857680010',0,'2013-12-26 13:05:00',NULL,NULL),(9790,6405,'TE','4194677945',0,'2013-12-26 00:48:28',NULL,NULL),(23978,15480,'TE','5136028643',1,'2014-01-02 04:29:07',NULL,NULL),(27381,17626,'TE','5129171071',0,'2014-01-14 01:32:30',NULL,NULL),(29231,18880,'TE','3377878791',0,'2014-01-17 03:36:28',NULL,NULL),(31622,20627,'EM','ANNETERIVERA@YMAIL.COM',0,'2014-01-30 21:00:27',NULL,NULL),(32421,21184,'TE','6018421908',0,'2014-02-03 21:00:45',NULL,NULL),(33153,21715,'TE','9372331149',0,'2014-02-05 21:31:17',NULL,NULL),(35518,23361,'TE','3306446943',0,'2014-02-13 22:00:46',NULL,NULL),(37825,24959,'TE','3183522690',0,'2014-02-20 22:00:18',NULL,NULL),(38209,25220,'TE','6622070290',0,'2014-02-21 22:00:56',NULL,NULL),(40245,26696,'TE','3183523894',0,'2014-02-28 21:31:31',NULL,NULL),(43668,28981,'TE','3303887848',0,'2014-03-10 21:01:09',NULL,NULL),(2984,1847,'TE','3307702075',0,'2013-12-25 18:57:49',NULL,NULL),(25557,16487,'TE','4198741207',0,'2014-01-07 04:06:26',NULL,NULL),(24699,15932,'TE','5674016037',0,'2014-01-03 02:06:56',NULL,NULL),(11013,7148,'EM','renglish26@yahoo.com',0,'2013-12-26 01:52:08',NULL,NULL),(10991,7140,'AP','2812827669',0,'2013-12-26 01:51:51',NULL,NULL),(8936,5850,'TE','9153554178',0,'2013-12-25 23:48:46',NULL,NULL),(14647,9581,'EM','sacha.tadros@gmail.com',0,'2013-12-26 04:36:55',NULL,NULL),(20275,13067,'EM','kiddfletch@yahoo.com',0,'2013-12-26 12:51:13',NULL,NULL),(20662,13287,'AP','9564341072',0,'2013-12-26 12:57:22',NULL,NULL),(20692,13302,'AP','4696844931',0,'2013-12-26 12:57:50',NULL,NULL),(21552,13858,'AP','3476334014',0,'2013-12-26 13:12:45',NULL,NULL),(21879,14097,'TE','6147836683',0,'2013-12-27 02:01:28',NULL,NULL),(22756,14674,'TE','5047587065',1,'2013-12-29 11:08:21',NULL,NULL),(8589,5645,'AP','9032586510',0,'2013-12-25 23:31:21',NULL,NULL),(23788,15341,'AP','3308586636',1,'2014-01-02 04:24:15',NULL,NULL),(8361,5495,'AP','9376051025',0,'2013-12-25 23:11:09',NULL,NULL),(27759,17898,'TE','7404633157',0,'2014-01-15 02:06:22',NULL,NULL),(29276,18908,'EM','marywright727@yahoo.com',0,'2014-01-17 03:36:39',NULL,NULL),(29455,19044,'EM','Ashleyannclayton@gmail.com',0,'2014-01-20 08:06:39',NULL,NULL),(30510,19789,'AP','3303520435',0,'2014-01-23 21:01:40',NULL,NULL),(31902,20819,'AP','5045758990',0,'2014-01-31 21:00:34',NULL,NULL),(33753,22148,'EM','bvittoria@aol.com',0,'2014-02-08 19:00:53',NULL,NULL),(38149,25179,'AP','7406442960',0,'2014-02-21 22:00:33',NULL,NULL),(38372,25347,'TE','2257542375',0,'2014-02-25 21:30:29',NULL,NULL),(39364,26035,'EM','dfarag@ctcincy.com',0,'2014-02-26 21:02:24',NULL,NULL),(42813,28471,'AP','3302340929',0,'2014-03-07 21:31:32',NULL,NULL),(43301,28768,'TE','4192467197',0,'2014-03-09 21:00:27',NULL,NULL),(43423,28835,'TE','9374227368',0,'2014-03-09 21:01:10',NULL,NULL),(7713,5037,'AP','7657179160',0,'2013-12-25 22:47:54',NULL,NULL),(25765,16604,'TE','2252870388',0,'2014-01-08 18:24:05',NULL,NULL),(22624,14589,'TE','2166336614',0,'2013-12-28 03:36:05',NULL,NULL),(20342,13105,'EM','jayjordyjac3@gmail.com',0,'2013-12-26 12:52:18',NULL,NULL),(9967,6522,'AP','4194810648',0,'2013-12-26 00:51:26',NULL,NULL),(26716,17185,'TE','8328132157',0,'2014-01-13 02:22:15',NULL,NULL),(27185,17504,'TE','4409747938',0,'2014-01-13 03:01:27',NULL,NULL),(27519,17727,'TE','4405969141',0,'2014-01-14 01:33:18',NULL,NULL),(27766,17903,'TE','8173600815',0,'2014-01-15 02:06:24',NULL,NULL),(28771,18564,'TE','9377287522',0,'2014-01-16 08:47:01',NULL,NULL),(29355,18968,'TE','4404882399',0,'2014-01-20 08:06:00',NULL,NULL),(30060,19472,'TE','9564852363',0,'2014-01-23 03:02:00',NULL,NULL),(30192,19558,'AP','9855163434',0,'2014-01-23 03:02:32',NULL,NULL),(32808,21466,'EM','sandra.a.mixon@gmail.com',0,'2014-02-04 21:01:35',NULL,NULL),(33238,21764,'EM','junett@hotmail.com',0,'2014-02-06 21:00:28',NULL,NULL),(38565,25486,'EM','joscelynjohnson156@gmail.com',0,'2014-02-25 21:31:46',NULL,NULL),(39781,26303,'EM','snoop.daniels@gmail.com',0,'2014-02-28 06:31:30',NULL,NULL),(40331,26767,'TE','4404288194',0,'2014-03-01 19:00:12',NULL,NULL),(40415,26827,'TE','2166095347',0,'2014-03-01 21:00:38',NULL,NULL),(40953,27212,'EM','tangyfawn@gmail.com',0,'2014-03-03 21:31:29',NULL,NULL),(43451,28856,'AP','5132668466',0,'2014-03-09 21:29:59',NULL,NULL),(567,351,'EM','jkupchurch@ymail.com',0,'2013-12-25 17:32:17',NULL,NULL),(3047,1896,'TE','4194484333',0,'2013-12-25 18:59:00',NULL,NULL),(8287,5431,'TE','3373547775',0,'2013-12-25 23:09:39',NULL,NULL),(9407,6159,'TE','6012642400',0,'2013-12-26 00:16:43',NULL,NULL),(3928,2490,'TE','5042986721',0,'2013-12-25 19:35:48',NULL,NULL),(11301,7365,'EM','Tamaries38@yahoo.com',0,'2013-12-26 02:15:31',NULL,NULL),(5289,3392,'AP','5044520210',0,'2013-12-25 21:17:52',NULL,NULL),(22372,14429,'AP','5049152422',0,'2013-12-28 03:31:54',NULL,NULL),(23281,15000,'EM','BADBOYSROD@LIVE.COM',0,'2014-01-01 12:01:42',NULL,NULL),(1889,1164,'AP','3182019800',0,'2013-12-25 18:19:00',NULL,NULL),(867,540,'EM','lbrooker03@hotmail.com',0,'2013-12-25 17:49:42',NULL,NULL),(26706,17180,'TE','5136790305',0,'2014-01-13 02:22:12',NULL,NULL),(28627,18455,'EM','Lennyd2@cox.net',0,'2014-01-16 08:46:10',NULL,NULL),(31270,20371,'TE','5049754802',0,'2014-01-29 21:00:05',NULL,NULL),(31509,20531,'AP','6622660884',0,'2014-01-29 21:01:30',NULL,NULL),(34906,22904,'AP','4195836021',0,'2014-02-11 21:02:44',NULL,NULL),(35346,23225,'EM','dollalyse@aol.com',0,'2014-02-12 21:32:22',NULL,NULL),(37935,25030,'AP','8323387482',0,'2014-02-20 22:01:03',NULL,NULL),(38583,25499,'TE','7753783804',0,'2014-02-25 21:31:53',NULL,NULL),(43425,28837,'TE','9374227368',0,'2014-03-09 21:01:10',NULL,NULL),(2638,1605,'TE','9406745555',0,'2013-12-25 18:52:09',NULL,NULL),(25481,16431,'TE','4197795212',0,'2014-01-07 04:04:48',NULL,NULL),(9690,6347,'EM','nsrubin1@gmail.com',0,'2013-12-26 00:46:56',NULL,NULL),(10805,7020,'TE','3618274648',0,'2013-12-26 01:48:49',NULL,NULL),(14507,9479,'TE','6148343233',0,'2013-12-26 04:34:35',NULL,NULL),(9532,6242,'TE','5136233828',0,'2013-12-26 00:31:41',NULL,NULL),(21009,13517,'TE','3375585940',0,'2013-12-26 13:03:06',NULL,NULL),(9003,5909,'EM','ljsmith@fuse.net',0,'2013-12-25 23:49:58',NULL,NULL),(8308,5444,'AP','2259073323',0,'2013-12-25 23:10:00',NULL,NULL),(5820,3736,'AP','8173601723',0,'2013-12-25 21:32:45',NULL,NULL),(28380,18285,'AP','5135498366',0,'2014-01-16 08:44:49',NULL,NULL),(33345,21843,'TE','4194873083',0,'2014-02-06 21:01:12',NULL,NULL),(34589,22679,'TE','9562831893',0,'2014-02-11 21:00:46',NULL,NULL),(35516,23359,'AP','3306972528',0,'2014-02-13 22:00:45',NULL,NULL),(38139,25174,'TE','2168544826',0,'2014-02-21 22:00:30',NULL,NULL),(42637,28364,'TE','9568258326',0,'2014-03-07 21:30:30',NULL,NULL),(1139,701,'TE','5042929996',0,'2013-12-25 18:02:54',NULL,NULL),(3583,2245,'TE','5137793947',0,'2013-12-25 19:21:07',NULL,NULL),(7766,5068,'EM','joshua.rather74@gmail.com',0,'2013-12-25 23:00:39',NULL,NULL),(4888,3133,'TE','4197532804',0,'2013-12-25 20:30:35',NULL,NULL),(3041,1892,'AP','5138462130',0,'2013-12-25 18:58:53',NULL,NULL),(2856,1744,'AP','2163249154',0,'2013-12-25 18:55:36',NULL,NULL),(7519,4902,'AP','7406015550',0,'2013-12-25 22:31:49',NULL,NULL),(11033,7160,'EM','apizzalady@aol.com',0,'2013-12-26 01:52:27',NULL,NULL),(11953,7786,'AP','9037852518',0,'2013-12-26 03:03:19',NULL,NULL),(12402,8122,'TE','7407337678',0,'2013-12-26 03:15:18',NULL,NULL),(13975,9117,'TE','6145972951',0,'2013-12-26 04:07:40',NULL,NULL),(20375,13124,'AP','5132623409',0,'2013-12-26 12:52:50',NULL,NULL),(22864,14754,'AP','3309803868',1,'2013-12-29 11:10:23',NULL,NULL),(23235,14971,'EM','thw1406@hotmail.com',0,'2014-01-01 12:00:50',NULL,NULL),(26287,16921,'EM','apercy77@yahoo.com',0,'2014-01-13 02:19:43',NULL,NULL),(28381,18285,'EM','early.teresa@gmail.com',0,'2014-01-16 08:44:49',NULL,NULL),(37805,24949,'AP','5044584860',0,'2014-02-20 22:00:10',NULL,NULL),(37858,24974,'EM','shirleymagness@yahoo.com',0,'2014-02-20 22:00:29',NULL,NULL),(39702,26255,'TE','9565021221',0,'2014-02-28 06:31:10',NULL,NULL),(40482,26867,'TE','2144028720',0,'2014-03-01 21:01:01',NULL,NULL),(463,292,'TE','3303223866',0,'2013-12-25 17:30:35',NULL,NULL),(2491,1529,'TE','3307240530',0,'2013-12-25 18:49:58',NULL,NULL),(1646,1011,'TE','4198770372',0,'2013-12-25 18:11:16',NULL,NULL),(13910,9068,'TE','9033895504',0,'2013-12-26 04:06:33',NULL,NULL),(23364,15051,'TE','2257780482',0,'2014-01-01 12:03:15',NULL,NULL),(24613,15874,'TE','6017500876',0,'2014-01-03 02:05:11',NULL,NULL),(24846,16026,'TE','2255883891',0,'2014-01-04 02:02:19',NULL,NULL),(25149,16211,'TE','9726894187',0,'2014-01-05 00:01:29',NULL,NULL),(8201,5367,'EM','pgsoap@gmail.com',0,'2013-12-25 23:08:00',NULL,NULL),(2680,1627,'TE','5124701854',0,'2013-12-25 18:52:44',NULL,NULL),(27973,18033,'EM','bethkilbane@yahoo.com',0,'2014-01-15 02:07:09',NULL,NULL),(28118,18123,'AP','4403764929',0,'2014-01-15 02:07:41',NULL,NULL),(28564,18417,'TE','5042148160',0,'2014-01-16 08:45:50',NULL,NULL),(28608,18441,'TE','5042504143',0,'2014-01-16 08:46:03',NULL,NULL),(29356,18968,'AP','4404882399',0,'2014-01-20 08:06:00',NULL,NULL),(30546,19816,'TE','2814217042',0,'2014-01-24 21:00:12',NULL,NULL),(30860,20059,'AP','9795510786',0,'2014-01-27 21:00:10',NULL,NULL),(34452,22603,'TE','9374676103',0,'2014-02-10 21:32:16',NULL,NULL),(35874,23591,'AP','3306064277',0,'2014-02-13 22:03:02',NULL,NULL),(37551,24723,'AP','5134851656',0,'2014-02-20 04:38:23',NULL,NULL),(38434,25400,'TE','4196517560',0,'2014-02-25 21:30:56',NULL,NULL),(21,14,'AP','5133047346',0,'2013-12-25 17:15:21',NULL,NULL),(1644,1010,'TE','5124419250',0,'2013-12-25 18:11:14',NULL,NULL),(25255,16285,'TE','8598932180',0,'2014-01-07 04:00:40',NULL,NULL),(12246,8007,'TE','8067909437',0,'2013-12-26 03:08:32',NULL,NULL),(11956,7787,'EM','dvalles66@yahoo.com',0,'2013-12-26 03:03:21',NULL,NULL),(10686,6946,'TE','9377166872',0,'2013-12-26 01:46:55',NULL,NULL),(6339,4086,'AP','4194814224',0,'2013-12-25 21:47:19',NULL,NULL),(10351,6747,'TE','9033729721',0,'2013-12-26 01:15:58',NULL,NULL),(9754,6377,'AP','4195540494',0,'2013-12-26 00:47:51',NULL,NULL),(9706,6355,'TE','2162213529',0,'2013-12-26 00:47:11',NULL,NULL),(4616,2943,'EM','CHAMILTON2011@YAHOO.COM',0,'2013-12-25 20:16:19',NULL,NULL),(2868,1754,'TE','2164642004',0,'2013-12-25 18:55:47',NULL,NULL),(25609,16519,'TE','7132051245',1,'2014-01-07 10:21:38',NULL,NULL),(20396,13136,'EM','BOLLERREMODELING@GMAIL.COM',0,'2013-12-26 12:53:10',NULL,NULL),(14731,9637,'TE','9032418809',0,'2013-12-26 04:38:23',NULL,NULL),(14109,9227,'TE','5135532371',0,'2013-12-26 04:10:23',NULL,NULL),(10797,7017,'AP','9564720017',0,'2013-12-26 01:48:43',NULL,NULL),(10339,6740,'EM','gary.vestal645@gmail.com',0,'2013-12-26 01:15:46',NULL,NULL),(9465,6194,'AP','8322769907',0,'2013-12-26 00:30:25',NULL,NULL),(6136,3949,'AP','4193413302',0,'2013-12-25 21:38:08',NULL,NULL),(2915,1787,'TE','6144969390',0,'2013-12-25 18:56:30',NULL,NULL),(32121,20973,'EM','richard_conville@hotmail.com',0,'2014-02-01 19:00:16',NULL,NULL),(32816,21471,'TE','4233123684',0,'2014-02-04 21:01:38',NULL,NULL),(34246,22461,'AP','5127993649',0,'2014-02-10 21:30:53',NULL,NULL),(37763,24918,'AP','3305927161',0,'2014-02-20 21:30:12',NULL,NULL),(39103,25870,'TE','3187629744',0,'2014-02-26 21:00:50',NULL,NULL),(42979,28584,'TE','9372892608',0,'2014-03-08 21:00:09',NULL,NULL),(10623,6911,'EM','jawatts313@att.net',0,'2013-12-26 01:45:56',NULL,NULL),(2198,1351,'TE','8323610545',0,'2013-12-25 18:45:15',NULL,NULL),(9459,6191,'AP','9728417972',0,'2013-12-26 00:30:19',NULL,NULL),(11830,7698,'TE','7405434068',0,'2013-12-26 03:01:11',NULL,NULL),(14177,9274,'EM','LORIMUNDY@HOTMAIL.COM',0,'2013-12-26 04:15:46',NULL,NULL),(14533,9494,'AP','9373214790',0,'2013-12-26 04:35:00',NULL,NULL),(31435,20491,'TE','9855424151',0,'2014-01-29 21:01:07',NULL,NULL),(33713,22114,'AP','8322361486',0,'2014-02-08 19:00:36',NULL,NULL),(35402,23268,'AP','2146740215',0,'2014-02-13 21:30:12',NULL,NULL),(37268,24522,'AP','9033808219',0,'2014-02-20 03:58:00',NULL,NULL),(40180,26651,'TE','3309580093',0,'2014-02-28 21:31:07',NULL,NULL),(9382,6141,'AP','6142037527',0,'2013-12-26 00:16:16',NULL,NULL),(4970,3189,'EM','crazycricket@rocketmail.com',0,'2013-12-25 20:32:05',NULL,NULL),(28000,18048,'TE','6016248509',0,'2014-01-15 02:07:15',NULL,NULL),(8901,5828,'EM','jamesr_kornegay@yahoo.com',0,'2013-12-25 23:48:12',NULL,NULL),(25128,16197,'EM','vicki.crawford@me.com',0,'2014-01-05 00:01:02',NULL,NULL),(22943,14801,'AP','3302073738',1,'2013-12-29 11:13:45',NULL,NULL),(31198,20317,'AP','2812530738',0,'2014-01-28 21:00:53',NULL,NULL),(32595,21313,'EM','CLTHOMAS7779311@GMAIL.COM',0,'2014-02-04 21:00:18',NULL,NULL),(33006,21622,'TE','9363660046',0,'2014-02-05 21:30:38',NULL,NULL),(35186,23112,'TE','6094125801',0,'2014-02-12 21:31:18',NULL,NULL),(38144,25176,'EM','GLORIABOHN.2013@GMAIL.COM',0,'2014-02-21 22:00:31',NULL,NULL),(39927,26422,'TE','9562792694',0,'2014-02-28 07:30:09',NULL,NULL),(40865,27154,'BN','5135785333',0,'2014-03-03 21:30:55',NULL,NULL),(41824,27810,'TE','4196851573',0,'2014-03-05 21:31:50',NULL,NULL),(10055,6576,'TE','5043010375',0,'2013-12-26 00:52:50',NULL,NULL),(27958,18020,'TE','9372986898',0,'2014-01-15 02:07:05',NULL,NULL),(28114,18120,'EM','SHAMROCKCW@AOL.COM',0,'2014-01-15 02:07:40',NULL,NULL),(6737,4375,'EM','susiebella11@gmail.com',0,'2013-12-25 22:00:27',NULL,NULL),(24305,15702,'TE','2052469517',1,'2014-01-02 04:35:45',NULL,NULL),(24049,15528,'AP','3374470008',1,'2014-01-02 04:30:32',NULL,NULL),(23058,14873,'TE','9365810520',0,'2013-12-30 00:00:17',NULL,NULL),(4853,3107,'TE','4198255648',0,'2013-12-25 20:20:26',NULL,NULL),(11893,7738,'EM','kwn8251@gmail.com',0,'2013-12-26 03:02:12',NULL,NULL),(25107,16185,'AP','4093823430',0,'2014-01-05 00:00:40',NULL,NULL),(24663,15902,'EM','mebolan@ipdimensions.com',0,'2014-01-03 02:06:07',NULL,NULL),(21429,13777,'AP','6625741477',0,'2013-12-26 13:10:40',NULL,NULL),(30360,19669,'AP','8322318781',0,'2014-01-23 21:00:30',NULL,NULL),(32173,21016,'TE','7406546654',0,'2014-02-01 19:00:37',NULL,NULL),(35581,23403,'TE','5138753057',0,'2014-02-13 22:01:10',NULL,NULL),(37810,24952,'TE','5042348970',0,'2014-02-20 22:00:12',NULL,NULL),(38317,25315,'TE','5044968660',0,'2014-02-25 21:30:04',NULL,NULL),(39341,26024,'TE','6017745161',0,'2014-02-26 21:02:17',NULL,NULL),(40471,26863,'AP','4692743680',0,'2014-03-01 21:00:58',NULL,NULL),(40706,27040,'AP','5044288603',0,'2014-03-03 21:00:21',NULL,NULL),(42212,28043,'TE','6626070879',0,'2014-03-06 21:01:33',NULL,NULL),(43489,28879,'AP','9032793680',0,'2014-03-10 21:00:07',NULL,NULL),(744,465,'EM','lbab@roadrunner.com',0,'2013-12-25 17:47:45',NULL,NULL),(1606,988,'AP','5135088019',0,'2013-12-25 18:10:31',NULL,NULL),(9719,6361,'EM','hemanthajb@gmail.com',0,'2013-12-26 00:47:22',NULL,NULL),(6665,4326,'AP','9372196167',0,'2013-12-25 21:52:54',NULL,NULL),(14584,9535,'EM','cmhayes3135@gmail.com',0,'2013-12-26 04:35:54',NULL,NULL),(24809,16005,'AP','9199438950',0,'2014-01-04 02:01:38',NULL,NULL),(33095,21679,'TE','9856510732',0,'2014-02-05 21:31:01',NULL,NULL),(37568,24752,'TE','3304729927',0,'2014-02-20 04:41:25',NULL,NULL),(5115,3278,'TE','5132527622',0,'2013-12-25 21:15:11',NULL,NULL),(8380,5517,'TE','7406038877',0,'2013-12-25 23:15:13',NULL,NULL),(24696,15928,'EM','mingjiahe38@yahoo.com',0,'2014-01-03 02:06:52',NULL,NULL),(22929,14793,'EM','spayten@yahoo.com',1,'2013-12-29 11:13:34',NULL,NULL),(20642,13277,'EM','dogs@pawsofaustin.org',0,'2013-12-26 12:57:05',NULL,NULL),(7247,4722,'EM','koosed@hotmail.com',0,'2013-12-25 22:08:59',NULL,NULL),(31281,20378,'AP','4697666729',0,'2014-01-29 21:00:10',NULL,NULL),(31753,20722,'TE','4195818807',0,'2014-01-30 21:01:15',NULL,NULL),(42495,28261,'AP','9379742355',0,'2014-03-07 21:00:17',NULL,NULL),(1415,862,'AP','3305595203',0,'2013-12-25 18:07:13',NULL,NULL),(28237,18209,'AP','5137859455',0,'2014-01-15 02:08:09',NULL,NULL),(25266,16291,'TE','9372487583',0,'2014-01-07 04:00:51',NULL,NULL),(11705,7620,'TE','5134811715',0,'2013-12-26 02:45:54',NULL,NULL),(22301,14373,'TE','4409834579',0,'2013-12-28 03:30:36',NULL,NULL),(10953,7120,'AP','9377283472',0,'2013-12-26 01:51:18',NULL,NULL),(6844,4439,'TE','4403316949',0,'2013-12-25 22:02:07',NULL,NULL),(32262,21072,'AP','4195770414',0,'2014-02-02 19:00:18',NULL,NULL),(32906,21544,'AP','2163133858',0,'2014-02-05 21:30:10',NULL,NULL),(35296,23184,'AP','6014520688',0,'2014-02-12 21:32:00',NULL,NULL),(36386,23965,'EM','cdr.tahirahmed@gmail.com',0,'2014-02-15 22:00:11',NULL,NULL),(39882,26385,'EM','K.reagan724@gmail.com',0,'2014-02-28 07:00:23',NULL,NULL),(41395,27499,'TE','4193604463',0,'2014-03-04 21:02:27',NULL,NULL),(10406,6783,'AP','9366727777',0,'2013-12-26 01:16:54',NULL,NULL),(26897,17303,'EM','mlj4ever69@gmail.com',0,'2014-01-13 02:23:40',NULL,NULL),(13652,8902,'AP','6144996691',0,'2013-12-26 04:02:19',NULL,NULL),(24190,15627,'EM','jhsiebold2@hotmail.com',1,'2014-01-02 04:33:23',NULL,NULL),(22450,14476,'EM','martinbebout@gmail.com',0,'2013-12-28 03:33:11',NULL,NULL),(33049,21651,'AP','5043425109',0,'2014-02-05 21:30:50',NULL,NULL),(41114,27312,'AP','4693964157',0,'2014-03-04 21:00:40',NULL,NULL),(42086,27963,'AP','5042088186',0,'2014-03-06 21:00:46',NULL,NULL),(43718,29021,'EM','kennedyfelecia@aim.com',0,'2014-03-10 21:01:30',NULL,NULL),(4492,2856,'EM','meskridge78@aol.com',0,'2013-12-25 20:01:32',NULL,NULL),(26207,16868,'TE','8068286140',0,'2014-01-13 02:19:14',NULL,NULL),(25574,16498,'TE','9378316516',0,'2014-01-07 04:06:44',NULL,NULL),(3232,2031,'TE','2167650556',0,'2013-12-25 19:15:22',NULL,NULL),(30430,19726,'TE','5042920997',0,'2014-01-23 21:01:01',NULL,NULL),(30943,20124,'TE','5136140751',0,'2014-01-27 21:00:48',NULL,NULL),(9889,6466,'EM','dimar886@aol.com',0,'2013-12-26 00:50:03',NULL,NULL),(7563,4925,'AP','2163144389',0,'2013-12-25 22:45:16',NULL,NULL),(26898,17304,'TE','2547346046',0,'2014-01-13 02:23:40',NULL,NULL),(23000,14836,'TE','3306968511',1,'2013-12-29 11:14:42',NULL,NULL),(22618,14585,'AP','9377267008',0,'2013-12-28 03:35:58',NULL,NULL),(32224,21047,'AP','9156943247',0,'2014-02-02 19:00:04',NULL,NULL),(36018,23691,'AP','3306710624',0,'2014-02-14 21:30:37',NULL,NULL),(514,322,'EM','peterkim75@yahoo.com',0,'2013-12-25 17:31:24',NULL,NULL),(28342,18263,'EM','aorona51@gmail.com',0,'2014-01-16 08:44:38',NULL,NULL),(1710,1050,'TE','9724904327',0,'2013-12-25 18:16:01',NULL,NULL),(2067,1279,'TE','4405323581',0,'2013-12-25 18:30:31',NULL,NULL),(22329,14393,'EM','LWALDROP@COLUMBUS.RR.COM',0,'2013-12-28 03:31:05',NULL,NULL),(20442,13163,'EM','halliemarkowitz@gmail.com',0,'2013-12-26 12:53:55',NULL,NULL),(31998,20890,'AP','5139109773',0,'2014-01-31 21:01:14',NULL,NULL),(35383,23253,'EM','Tim@sentrygroup1.com',0,'2014-02-13 21:30:06',NULL,NULL),(43906,29129,'TE','9373903046',0,'2014-03-10 21:02:36',NULL,NULL),(11682,7604,'AP','3303165908',0,'2013-12-26 02:45:28',NULL,NULL),(1714,1051,'EM','nzamora0977@gmail.com',0,'2013-12-25 18:16:03',NULL,NULL),(29429,19028,'TE','4405910381',0,'2014-01-20 08:06:29',NULL,NULL),(26791,17235,'TE','2163765622',0,'2014-01-13 02:22:42',NULL,NULL),(9032,5925,'EM','vlsanchez8@yahoo.com',0,'2013-12-25 23:50:24',NULL,NULL),(22684,14629,'TE','9377796701',0,'2013-12-28 03:37:08',NULL,NULL),(42948,28559,'TE','6018667552',0,'2014-03-07 21:32:25',NULL,NULL),(43536,28904,'AP','2147240948',0,'2014-03-10 21:00:23',NULL,NULL),(9896,6474,'TE','3307944408',0,'2013-12-26 00:50:12',NULL,NULL),(7888,5140,'EM','jdnailon@fuse.net',0,'2013-12-25 23:02:31',NULL,NULL),(29658,19161,'TE','4195591520',0,'2014-01-21 08:45:41',NULL,NULL),(5004,3213,'AP','2142137138',0,'2013-12-25 20:45:29',NULL,NULL),(23804,15353,'AP','5133005243',1,'2014-01-02 04:24:38',NULL,NULL),(31600,20613,'TE','3178404011',0,'2014-01-30 21:00:19',NULL,NULL),(36488,24021,'AP','6146486171',0,'2014-02-15 22:00:47',NULL,NULL),(10242,6696,'AP','5134014181',0,'2013-12-26 01:01:45',NULL,NULL),(28890,18652,'AP','3616960581',0,'2014-01-17 03:35:10',NULL,NULL),(6173,3976,'EM','sheldonchadking@gmail.com',0,'2013-12-25 21:38:45',NULL,NULL),(27517,17726,'AP','5132755620',0,'2014-01-14 01:33:17',NULL,NULL),(6156,3965,'TE','4408861195',0,'2013-12-25 21:38:29',NULL,NULL),(3258,2050,'TE','8177707797',0,'2013-12-25 19:15:50',NULL,NULL),(2951,1819,'AP','4193445456',0,'2013-12-25 18:57:13',NULL,NULL),(9326,6110,'TE','6143297780',0,'2013-12-26 00:15:24',NULL,NULL),(8522,5602,'TE','4408329234',0,'2013-12-25 23:30:17',NULL,NULL),(40178,26648,'AP','3307056517',0,'2014-02-28 21:31:06',NULL,NULL),(6346,4090,'EM','intimidatormvl@aol.com',0,'2013-12-25 21:47:25',NULL,NULL),(6041,3880,'AP','5046100270',0,'2013-12-25 21:36:26',NULL,NULL),(13598,8865,'TE','9035696207',0,'2013-12-26 04:01:24',NULL,NULL),(4605,2939,'AP','5137202257',0,'2013-12-25 20:16:10',NULL,NULL),(20237,13036,'AP','9372011045',0,'2013-12-26 12:50:30',NULL,NULL),(41814,27798,'EM','bubblegal461@gmail.com',0,'2014-03-05 21:31:44',NULL,NULL),(10856,7046,'EM','thorbahn3@yahoo.com',0,'2013-12-26 01:49:34',NULL,NULL),(29116,18804,'TE','9374390767',0,'2014-01-17 03:36:01',NULL,NULL),(28305,18245,'TE','2146207357',0,'2014-01-16 08:44:27',NULL,NULL),(3843,2444,'TE','5138931228',0,'2013-12-25 19:34:32',NULL,NULL),(22582,14565,'TE','8109418227',0,'2013-12-28 03:35:22',NULL,NULL),(20976,13501,'TE','9413484031',0,'2013-12-26 13:02:36',NULL,NULL),(20595,13247,'EM','hleighmayes@yahoo.com',0,'2013-12-26 12:56:18',NULL,NULL),(14326,9367,'TE','3185358104',0,'2013-12-26 04:31:42',NULL,NULL),(2161,1329,'TE','5135465528',0,'2013-12-25 18:32:02',NULL,NULL),(31439,20493,'TE','2542200583',0,'2014-01-29 21:01:08',NULL,NULL),(34652,22722,'TE','5049098626',0,'2014-02-11 21:01:10',NULL,NULL),(41607,27662,'EM','pspilker@yahoo.com',0,'2014-03-05 21:30:28',NULL,NULL),(41893,27855,'AP','5127553143',0,'2014-03-05 21:32:15',NULL,NULL),(11238,7317,'TE','8324050658',0,'2013-12-26 02:03:30',NULL,NULL),(27108,17438,'TE','4199730977',0,'2014-01-13 03:00:34',NULL,NULL),(10197,6662,'EM','jennmmassey@gmail.com',0,'2013-12-26 01:00:55',NULL,NULL),(23269,14992,'TE','9566356005',0,'2014-01-01 12:01:27',NULL,NULL),(22578,14561,'EM','carolynlclement@yahoo.com',0,'2013-12-28 03:35:17',NULL,NULL),(21957,14143,'AP','3187330188',0,'2013-12-27 02:02:43',NULL,NULL),(35034,23010,'TE','3376684010',0,'2014-02-12 21:30:23',NULL,NULL),(36641,24121,'TE','9036297053',0,'2014-02-15 22:01:42',NULL,NULL),(37533,24714,'AP','4405037555',0,'2014-02-20 04:36:53',NULL,NULL),(37625,24798,'TE','7403363602',0,'2014-02-20 04:47:53',NULL,NULL),(10256,6701,'AP','7025962921',0,'2013-12-26 01:01:56',NULL,NULL),(29303,18933,'AP','2162123312',0,'2014-01-20 08:05:40',NULL,NULL),(5964,3828,'TE','9373932124',0,'2013-12-25 21:35:08',NULL,NULL),(4974,3191,'AP','5125766068',0,'2013-12-25 20:32:10',NULL,NULL),(2217,1363,'AP','9157778767',0,'2013-12-25 18:45:34',NULL,NULL),(2778,1683,'TE','5042367522',0,'2013-12-25 18:54:14',NULL,NULL),(33200,21739,'TE','8067819673',0,'2014-02-06 21:00:14',NULL,NULL),(39353,26029,'TE','6015732290',0,'2014-02-26 21:02:20',NULL,NULL),(41844,27822,'AP','9375723069',0,'2014-03-05 21:31:56',NULL,NULL),(43313,28774,'AP','4194602819',0,'2014-03-09 21:00:31',NULL,NULL),(146,87,'EM','kingdianne57@aol.com',0,'2013-12-25 17:17:20',NULL,NULL),(10755,6991,'EM','cecenow2014@yahoo.com',0,'2013-12-26 01:48:01',NULL,NULL),(8499,5589,'EM','letharpe@gmail.com',0,'2013-12-25 23:17:13',NULL,NULL),(3694,2342,'AP','3129339414',0,'2013-12-25 19:32:00',NULL,NULL),(34603,22691,'AP','9797391779',0,'2014-02-11 21:00:52',NULL,NULL),(34674,22738,'TE','3373486229',0,'2014-02-11 21:01:18',NULL,NULL),(35362,23235,'TE','6143955092',0,'2014-02-12 21:32:28',NULL,NULL),(3401,2138,'TE','5132553458',0,'2013-12-25 19:18:10',NULL,NULL),(27604,17795,'AP','4192658148',0,'2014-01-14 01:33:50',NULL,NULL),(27474,17698,'AP','3377077988',0,'2014-01-14 01:33:03',NULL,NULL),(25139,16205,'EM','hymel.ashley@gmail.com',0,'2014-01-05 00:01:17',NULL,NULL),(30972,20146,'AP','6145654238',0,'2014-01-27 21:01:01',NULL,NULL),(34795,22823,'EM','TONGSATE@GMAIL.COM',0,'2014-02-11 21:02:03',NULL,NULL),(36867,24279,'TE','9372237432',0,'2014-02-18 21:30:06',NULL,NULL),(14657,9590,'TE','2283277409',0,'2013-12-26 04:37:07',NULL,NULL),(27571,17769,'EM','naylajaf@gmail.com',0,'2014-01-14 01:33:37',NULL,NULL),(26473,17037,'AP','5049142982',0,'2014-01-13 02:20:49',NULL,NULL),(22161,14274,'TE','6015025961',0,'2013-12-27 02:06:11',NULL,NULL),(20989,13508,'TE','2256425318',0,'2013-12-26 13:02:49',NULL,NULL),(11011,7147,'EM','emailing.meni@gmail.com',0,'2013-12-26 01:52:06',NULL,NULL),(627,384,'EM','mmarg1520@sbcglobal.net',0,'2013-12-25 17:45:49',NULL,NULL),(9174,6004,'AP','5135151221',0,'2013-12-26 00:00:28',NULL,NULL),(31673,20663,'AP','9035061841',0,'2014-01-30 21:00:45',NULL,NULL),(34166,22406,'EM','gjwhite2@gmail.com',0,'2014-02-10 21:30:23',NULL,NULL),(34594,22682,'TE','8174048942',0,'2014-02-11 21:00:48',NULL,NULL),(40144,26625,'AP','2108570023',0,'2014-02-28 21:30:54',NULL,NULL),(1044,644,'TE','9376846710',0,'2013-12-25 18:01:26',NULL,NULL),(3653,2314,'AP','9799973300',0,'2013-12-25 19:31:16',NULL,NULL),(8740,5731,'TE','2257267901',0,'2013-12-25 23:45:40',NULL,NULL),(26746,17202,'EM','michaellitt@yahoo.com',0,'2014-01-13 02:22:25',NULL,NULL),(26438,17010,'EM','hurleyjp@mindspring.com',0,'2014-01-13 02:20:36',NULL,NULL),(25074,16166,'TE','9867103202',0,'2014-01-05 00:00:05',NULL,NULL),(9216,6032,'AP','2148501475',0,'2013-12-26 00:01:10',NULL,NULL),(31220,20332,'AP','3302560310',0,'2014-01-28 21:01:03',NULL,NULL),(33890,22244,'TE','4193461980',0,'2014-02-09 19:00:39',NULL,NULL),(35500,23340,'TE','3306683052',0,'2014-02-13 22:00:37',NULL,NULL),(39033,25811,'EM','rwrcake90@gmail.com',0,'2014-02-26 21:00:22',NULL,NULL),(40758,27085,'TE','3306285678',0,'2014-03-03 21:30:14',NULL,NULL),(41433,27525,'AP','4197049694',0,'2014-03-04 21:02:43',NULL,NULL),(11823,7692,'TE','2163201185',0,'2013-12-26 03:01:04',NULL,NULL),(30166,19545,'TE','6628325978',0,'2014-01-23 03:02:26',NULL,NULL),(21160,13606,'EM','mbearrocks@yahoo.com',0,'2013-12-26 13:05:33',NULL,NULL),(22213,14315,'AP','4192024404',0,'2013-12-27 02:07:08',NULL,NULL),(24684,15919,'EM','manhattantraveler@gmail.com',0,'2014-01-03 02:06:36',NULL,NULL),(23975,15478,'TE','5138435657',1,'2014-01-02 04:29:03',NULL,NULL),(23278,14999,'TE','9158435558',0,'2014-01-01 12:01:39',NULL,NULL),(31932,20844,'TE','4193709481',0,'2014-01-31 21:00:49',NULL,NULL),(33684,22093,'EM','lynnlawrence92@gmail.com',0,'2014-02-08 19:00:26',NULL,NULL),(34442,22594,'AP','4197067331',0,'2014-02-10 21:32:12',NULL,NULL),(38740,25609,'TE','8062746875',0,'2014-02-26 08:30:08',NULL,NULL),(10833,7034,'EM','sargentmiller@gmail.com',0,'2013-12-26 01:49:13',NULL,NULL),(30611,19867,'TE','6148711503',0,'2014-01-24 21:00:39',NULL,NULL),(1129,693,'AP','7078158061',0,'2013-12-25 18:02:42',NULL,NULL),(26555,17081,'AP','3615481351',0,'2014-01-13 02:21:23',NULL,NULL),(21589,13891,'TE','4197081967',0,'2013-12-26 13:13:28',NULL,NULL),(22008,14175,'TE','8069304884',0,'2013-12-27 02:03:33',NULL,NULL),(33211,21749,'TE','9407336891',0,'2014-02-06 21:00:20',NULL,NULL),(38936,25742,'TE','3303437250',0,'2014-02-26 09:30:41',NULL,NULL),(39837,26349,'TE','4192176488',0,'2014-02-28 06:31:47',NULL,NULL),(40785,27105,'AP','5133829111',0,'2014-03-03 21:30:24',NULL,NULL),(42206,28039,'TE','2162613709',0,'2014-03-06 21:01:30',NULL,NULL),(1769,1091,'EM','jpwills_99@yahoo.com',0,'2013-12-25 18:17:03',NULL,NULL),(30330,19648,'EM','bcookseylpn@outlook.com',0,'2014-01-23 21:00:18',NULL,NULL),(27158,17485,'EM','bonjovigirl@live.com',0,'2014-01-13 03:01:16',NULL,NULL),(1069,657,'EM','michellefurlong1@hotmail.com',0,'2013-12-25 18:01:47',NULL,NULL),(35826,23561,'TE','4193850014',0,'2014-02-13 22:02:44',NULL,NULL),(35922,23636,'AP','5042373633',0,'2014-02-14 21:30:06',NULL,NULL),(40853,27147,'AP','5134353633',0,'2014-03-03 21:30:50',NULL,NULL),(41357,27477,'TE','9403008347',0,'2014-03-04 21:02:14',NULL,NULL),(24648,15892,'TE','3302739164',0,'2014-01-03 02:05:47',NULL,NULL),(14451,9442,'TE','7408166783',0,'2013-12-26 04:33:43',NULL,NULL),(6621,4277,'EM','fife.bill@yahoo.com',0,'2013-12-25 21:51:55',NULL,NULL),(6271,4045,'EM','capitalcoil@yahoo.com',0,'2013-12-25 21:46:14',NULL,NULL),(11972,7800,'TE','9793243935',0,'2013-12-26 03:03:40',NULL,NULL),(11454,7447,'AP','9376715957',0,'2013-12-26 02:30:37',NULL,NULL),(11210,7292,'AP','4404208513',0,'2013-12-26 02:02:55',NULL,NULL),(4664,2983,'TE','4405902740',0,'2013-12-25 20:17:15',NULL,NULL),(10700,6955,'AP','6142828494',0,'2013-12-26 01:47:09',NULL,NULL),(4420,2818,'TE','7697984243',0,'2013-12-25 20:00:26',NULL,NULL),(3254,2048,'AP','9156919872',0,'2013-12-25 19:15:46',NULL,NULL),(7906,5152,'AP','3309062616',0,'2013-12-25 23:02:49',NULL,NULL),(27028,17381,'TE','6143157816',0,'2014-01-13 03:00:06',NULL,NULL),(27128,17466,'TE','3309530416',0,'2014-01-13 03:01:05',NULL,NULL),(28382,18286,'TE','3308361367',0,'2014-01-16 08:44:50',NULL,NULL),(29817,19291,'TE','3188752851',1,'2014-01-22 03:21:55',NULL,NULL),(29978,19398,'EM','shoultc@yahoo.com',1,'2014-01-22 03:22:52',NULL,NULL),(31845,20791,'AP','9035567194',0,'2014-01-31 21:00:15',NULL,NULL),(34440,22593,'EM','BENDERGIRL3@GMAIL.COM',0,'2014-02-10 21:32:11',NULL,NULL),(34748,22783,'EM','adahlin@bgsu.edu',0,'2014-02-11 21:01:45',NULL,NULL),(35227,23136,'AP','3304159287',0,'2014-02-12 21:31:33',NULL,NULL),(36466,24010,'TE','7406379423',0,'2014-02-15 22:00:39',NULL,NULL),(38248,25253,'AP','2167733032',0,'2014-02-21 22:01:15',NULL,NULL),(5939,3807,'EM','sdkirby71@hotmail.com',0,'2013-12-25 21:34:41',NULL,NULL),(23175,14936,'TE','3307946514',0,'2013-12-30 00:02:10',NULL,NULL),(22598,14574,'AP','2399610651',0,'2013-12-28 03:35:38',NULL,NULL),(22486,14499,'AP','2818445080',0,'2013-12-28 03:33:44',NULL,NULL),(3952,2509,'AP','4196196626',0,'2013-12-25 19:36:15',NULL,NULL),(14952,9782,'AP','2166731089',0,'2013-12-26 05:00:46',NULL,NULL),(3925,2488,'EM','treasure.tolliver@gmail.com',0,'2013-12-25 19:35:44',NULL,NULL),(13567,8845,'AP','3258642448',0,'2013-12-26 04:00:52',NULL,NULL),(10333,6738,'AP','3306855454',0,'2013-12-26 01:15:41',NULL,NULL),(11996,7814,'TE','2543863438',0,'2013-12-26 03:04:03',NULL,NULL),(27670,17835,'AP','9376546111',0,'2014-01-15 02:06:01',NULL,NULL),(28372,18281,'TE','5129376848',0,'2014-01-16 08:44:47',NULL,NULL),(29985,19413,'TE','4198613136',1,'2014-01-22 03:22:58',NULL,NULL),(30277,19615,'EM','dwaynejordan56@yahoo.com',0,'2014-01-23 03:02:52',NULL,NULL),(30964,20141,'TE','5133620623',0,'2014-01-27 21:00:58',NULL,NULL),(34712,22758,'EM','RCASEY@FIOPTICS.COM',0,'2014-02-11 21:01:31',NULL,NULL),(35102,23056,'AP','5042967858',0,'2014-02-12 21:30:49',NULL,NULL),(39245,25962,'AP','9372545987',0,'2014-02-26 21:01:42',NULL,NULL),(39915,26413,'TE','9373932498',0,'2014-02-28 07:00:41',NULL,NULL),(41055,27276,'TE','8302361263',0,'2014-03-04 21:00:19',NULL,NULL),(41419,27517,'EM','bronsonmock@yahoo.com',0,'2014-03-04 21:02:37',NULL,NULL),(42614,28350,'TE','5125768200',0,'2014-03-07 21:30:22',NULL,NULL),(43322,28778,'EM','Marie.katrina12@gmail.com',0,'2014-03-09 21:00:34',NULL,NULL),(7305,4754,'EM','liannepereira@sbcglobal.net',0,'2013-12-25 22:15:19',NULL,NULL),(5271,3385,'TE','2816717356',0,'2013-12-25 21:17:38',NULL,NULL),(14170,9272,'TE','5132901897',0,'2013-12-26 04:15:41',NULL,NULL),(23799,15351,'TE','7403272201',1,'2014-01-02 04:24:33',NULL,NULL),(22595,14573,'AP','4199730760',0,'2013-12-28 03:35:36',NULL,NULL),(21253,13658,'AP','9852260112',0,'2013-12-26 13:07:33',NULL,NULL),(26006,16754,'TE','2107876067',0,'2014-01-08 18:24:56',NULL,NULL),(449,279,'TE','2148091289',0,'2013-12-25 17:30:14',NULL,NULL),(7349,4776,'AP','9372169551',0,'2013-12-25 22:15:59',NULL,NULL),(3298,2075,'AP','2253296855',0,'2013-12-25 19:16:29',NULL,NULL),(13630,8888,'TE','5249794229',0,'2013-12-26 04:01:57',NULL,NULL),(25336,16338,'TE','5133360635',0,'2014-01-07 04:02:11',NULL,NULL),(27960,18022,'TE','4404577528',0,'2014-01-15 02:07:06',NULL,NULL),(29340,18957,'EM','199402@163.com',0,'2014-01-20 08:05:53',NULL,NULL),(32046,20918,'TE','3306280788',0,'2014-01-31 21:01:31',NULL,NULL),(32090,20957,'AP','2545419663',0,'2014-02-01 19:00:07',NULL,NULL),(32240,21057,'TE','2253134064',0,'2014-02-02 19:00:09',NULL,NULL),(36413,23983,'TE','9853737950',0,'2014-02-15 22:00:21',NULL,NULL),(39213,25933,'AP','4322940562',0,'2014-02-26 21:01:27',NULL,NULL),(40421,26832,'EM','al8764@gmail.com',0,'2014-03-01 21:00:41',NULL,NULL),(991,611,'EM','dbucher@cinci.rr.com',0,'2013-12-25 18:00:34',NULL,NULL),(25990,16746,'AP','9035740676',0,'2014-01-08 18:24:53',NULL,NULL),(4829,3090,'TE','9372788345',0,'2013-12-25 20:20:00',NULL,NULL),(20437,13160,'EM','cathy.eastlakeinsurance@gmail.com',0,'2013-12-26 12:53:50',NULL,NULL),(20513,13206,'AP','2818772115',0,'2013-12-26 12:55:06',NULL,NULL),(23745,15320,'TE','9032807921',1,'2014-01-02 04:23:31',NULL,NULL),(24479,15796,'TE','9858470999',0,'2014-01-03 02:02:42',NULL,NULL),(6050,3885,'EM','jmheat124@aol.com',0,'2013-12-25 21:36:35',NULL,NULL),(27434,17672,'TE','2257670606',0,'2014-01-14 01:32:50',NULL,NULL),(28756,18557,'EM','levitrent@gmail.com',0,'2014-01-16 08:46:57',NULL,NULL),(31379,20454,'TE','4193669643',0,'2014-01-29 21:00:47',NULL,NULL),(32265,21077,'TE','5135157379',0,'2014-02-02 19:00:20',NULL,NULL),(32435,21193,'AP','6628339092',0,'2014-02-03 21:00:49',NULL,NULL),(33562,22000,'AP','5043525209',0,'2014-02-07 19:00:47',NULL,NULL),(34130,22377,'AP','2343803636',0,'2014-02-10 21:30:07',NULL,NULL),(36458,24006,'AP','5137487539',0,'2014-02-15 22:00:37',NULL,NULL),(38080,25138,'TE','8173080458',0,'2014-02-21 22:00:08',NULL,NULL),(39546,26162,'TE','3305623127',0,'2014-02-28 06:30:33',NULL,NULL),(40103,26596,'TE','4322716877',0,'2014-02-28 21:30:39',NULL,NULL),(41439,27531,'TE','3305923026',0,'2014-03-04 21:02:47',NULL,NULL),(42363,28137,'AP','3308604433',0,'2014-03-06 21:02:28',NULL,NULL),(42529,28295,'TE','5138856851',0,'2014-03-07 21:00:29',NULL,NULL),(43402,28823,'TE','4196933313',0,'2014-03-09 21:01:02',NULL,NULL),(687,427,'TE','6144216826',0,'2013-12-25 17:46:49',NULL,NULL),(4739,3035,'TE','4328166381',0,'2013-12-25 20:18:31',NULL,NULL),(4722,3022,'EM','patriciasmth28@gmail.com',0,'2013-12-25 20:18:12',NULL,NULL),(3714,2355,'AP','9033079277',0,'2013-12-25 19:32:21',NULL,NULL),(3679,2333,'AP','2023678765',0,'2013-12-25 19:31:45',NULL,NULL),(5979,3841,'AP','3184171196',0,'2013-12-25 21:35:24',NULL,NULL),(9945,6508,'TE','2345427257',0,'2013-12-26 00:51:03',NULL,NULL),(6579,4247,'TE','8174039646',0,'2013-12-25 21:51:11',NULL,NULL),(11712,7625,'AP','6626131033',0,'2013-12-26 02:46:03',NULL,NULL),(13611,8870,'AP','3618942298',0,'2013-12-26 04:01:33',NULL,NULL),(13871,9044,'AP','9196373046',0,'2013-12-26 04:05:54',NULL,NULL),(2602,1586,'AP','8065490133',0,'2013-12-25 18:51:36',NULL,NULL),(24354,15728,'AP','7408778077',0,'2014-01-03 02:00:25',NULL,NULL),(27910,17984,'TE','4406667764',0,'2014-01-15 02:06:54',NULL,NULL),(27990,18041,'BN','7696196920',0,'2014-01-15 02:07:12',NULL,NULL),(28195,18172,'TE','4193504582',0,'2014-01-15 02:07:58',NULL,NULL),(28231,18204,'TE','4193031099',0,'2014-01-15 02:08:07',NULL,NULL),(30048,19463,'TE','9178685888',0,'2014-01-23 03:01:57',NULL,NULL),(30100,19499,'TE','3304640656',0,'2014-01-23 03:02:10',NULL,NULL),(32203,21034,'TE','9376580953',0,'2014-02-01 19:00:46',NULL,NULL),(36645,24124,'TE','2257611952',0,'2014-02-15 22:01:44',NULL,NULL),(39195,25923,'AP','5127346904',0,'2014-02-26 21:01:22',NULL,NULL),(43572,28935,'AP','5132250726',0,'2014-03-10 21:00:39',NULL,NULL),(8183,5354,'TE','4402241676',0,'2013-12-25 23:07:42',NULL,NULL),(21083,13559,'TE','5046554574',0,'2013-12-26 13:04:18',NULL,NULL),(14255,9324,'TE','3377890442',0,'2013-12-26 04:30:35',NULL,NULL),(21523,13837,'TE','3307258735',0,'2013-12-26 13:12:13',NULL,NULL),(11581,7535,'EM','lzander@verizon.net',0,'2013-12-26 02:32:47',NULL,NULL),(9841,6437,'TE','3376269467',0,'2013-12-26 00:49:20',NULL,NULL),(24073,15542,'TE','3182226846',1,'2014-01-02 04:31:00',NULL,NULL),(3739,2373,'AP','9374786614',0,'2013-12-25 19:32:48',NULL,NULL),(30651,19895,'EM','glennmosley21@gmail.com',0,'2014-01-24 21:00:53',NULL,NULL),(34836,22845,'TE','4196910892',0,'2014-02-11 21:02:17',NULL,NULL),(36824,24253,'TE','3308582056',0,'2014-02-17 19:00:04',NULL,NULL),(38013,25076,'EM','REBECCAJACKSON54@YAHOO.COM',0,'2014-02-20 22:01:34',NULL,NULL),(41642,27682,'TE','3618348185',0,'2014-03-05 21:30:39',NULL,NULL),(42909,28534,'AP','9376076790',0,'2014-03-07 21:32:10',NULL,NULL),(890,551,'EM','igy05@sbcglobal.net',0,'2013-12-25 17:50:02',NULL,NULL),(22379,14434,'EM','bobgregory@cox.net',0,'2013-12-28 03:32:02',NULL,NULL),(10914,7092,'TE','3308300642',0,'2013-12-26 01:50:35',NULL,NULL),(28157,18149,'EM','donald.george31@aol.com',0,'2014-01-15 02:07:49',NULL,NULL),(28395,18295,'EM','mcloughlin.t@gmail.com',0,'2014-01-16 08:44:54',NULL,NULL),(31403,20471,'TE','7377230335',0,'2014-01-29 21:00:55',NULL,NULL),(32505,21248,'TE','6142966163',0,'2014-02-03 21:01:16',NULL,NULL),(34148,22390,'TE','3305356846',0,'2014-02-10 21:30:15',NULL,NULL),(35971,23669,'TE','4303422560',0,'2014-02-14 21:30:23',NULL,NULL),(38855,25683,'EM','SHEPHERDWINSTON@GMAIL.COM',0,'2014-02-26 09:30:06',NULL,NULL),(39002,25789,'EM','s.ostenkamp8@gmail.com',0,'2014-02-26 09:31:09',NULL,NULL),(40611,26959,'TE','7166018840',0,'2014-03-03 01:00:29',NULL,NULL),(43943,29149,'TE','5133730075',0,'2014-03-10 21:02:48',NULL,NULL),(1362,830,'AP','3302352856',0,'2013-12-25 18:06:20',NULL,NULL),(4278,2734,'TE','9852375927',0,'2013-12-25 19:48:34',NULL,NULL),(6135,3949,'TE','4193413302',0,'2013-12-25 21:38:07',NULL,NULL),(2182,1341,'TE','8063003520',0,'2013-12-25 18:32:27',NULL,NULL),(9836,6435,'TE','5049092396',0,'2013-12-26 00:49:16',NULL,NULL),(1637,1004,'EM','ameliaraimey@gmail.com',0,'2013-12-25 18:11:04',NULL,NULL),(11480,7466,'AP','9723337216',0,'2013-12-26 02:31:04',NULL,NULL),(13736,8952,'TE','6142679778',0,'2013-12-26 04:03:37',NULL,NULL),(14968,9792,'TE','2252818115',0,'2013-12-26 05:01:01',NULL,NULL),(21080,13556,'EM','dougdaigle@gmail.com',0,'2013-12-26 13:04:14',NULL,NULL),(7654,4982,'TE','9152535151',0,'2013-12-25 22:46:46',NULL,NULL),(22662,14613,'TE','6014541875',0,'2013-12-28 03:36:43',NULL,NULL),(24516,15813,'EM','griggselnora@yahoo.com',0,'2014-01-03 02:03:17',NULL,NULL),(24990,16106,'EM','HZNOE@BELLSOUTH.NET',0,'2014-01-04 02:04:56',NULL,NULL),(27075,17412,'EM','rgrigg2@woh.rr.com',0,'2014-01-13 03:00:23',NULL,NULL),(27687,17847,'TE','4405962546',0,'2014-01-15 02:06:05',NULL,NULL),(34692,22749,'TE','9858599907',0,'2014-02-11 21:01:25',NULL,NULL),(36653,24127,'EM','marshahammons1975@yahoo.com',0,'2014-02-15 22:01:46',NULL,NULL),(38881,25697,'EM','RAJU546@YAHOO.COM',0,'2014-02-26 09:30:17',NULL,NULL),(42781,28452,'EM','esk67@hotmail.com',0,'2014-03-07 21:31:21',NULL,NULL),(4802,3069,'EM','mindy.rothstein@gmail.com',0,'2013-12-25 20:19:27',NULL,NULL),(9862,6447,'EM','Duane@LMARIES.com',0,'2013-12-26 00:49:37',NULL,NULL),(9047,5934,'AP','3372980103',0,'2013-12-25 23:50:37',NULL,NULL),(8762,5742,'AP','5617156348',0,'2013-12-25 23:45:59',NULL,NULL),(4988,3202,'AP','2169059331',0,'2013-12-25 20:45:12',NULL,NULL),(11276,7350,'EM','mamahiggins@gmail.com',0,'2013-12-26 02:15:05',NULL,NULL),(28470,18344,'AP','9376578097',0,'2014-01-16 08:45:19',NULL,NULL),(32914,21547,'BN','7405072935',0,'2014-02-05 21:30:12',NULL,NULL),(33590,22020,'EM','tishharmon@yahoo.com',0,'2014-02-07 19:00:58',NULL,NULL),(35257,23155,'TE','5137676045',0,'2014-02-12 21:31:44',NULL,NULL),(35875,23592,'TE','3309886397',0,'2014-02-13 22:03:03',NULL,NULL),(36148,23790,'AP','3308130186',0,'2014-02-14 21:31:25',NULL,NULL),(39104,25870,'AP','3187629744',0,'2014-02-26 21:00:50',NULL,NULL),(39780,26303,'AP','4193713631',0,'2014-02-28 06:31:30',NULL,NULL),(41242,27395,'AP','7408192466',0,'2014-03-04 21:01:29',NULL,NULL),(2853,1739,'TE','4197293050',0,'2013-12-25 18:55:30',NULL,NULL),(7425,4828,'TE','5672806135',0,'2013-12-25 22:17:16',NULL,NULL),(6065,3903,'AP','6625922903',0,'2013-12-25 21:36:54',NULL,NULL),(6037,3878,'TE','3184438424',0,'2013-12-25 21:36:22',NULL,NULL),(5088,3265,'TE','5049577727',0,'2013-12-25 20:47:02',NULL,NULL),(4709,3012,'TE','3302748911',0,'2013-12-25 20:17:57',NULL,NULL),(3752,2379,'EM','zardikh@gmail.com',0,'2013-12-25 19:32:59',NULL,NULL),(8621,5663,'TE','3308482456',0,'2013-12-25 23:31:51',NULL,NULL),(27200,17515,'AP','3304416466',0,'2014-01-13 03:01:33',NULL,NULL),(27264,17554,'TE','5139811135',0,'2014-01-13 03:01:56',NULL,NULL),(27831,17932,'EM','rosariorayala@hotmail.com',0,'2014-01-15 02:06:36',NULL,NULL),(34183,22419,'AP','5045799980',0,'2014-02-10 21:30:29',NULL,NULL),(35796,23538,'TE','3189872087',0,'2014-02-13 22:02:31',NULL,NULL),(43124,28667,'AP','5046718004',0,'2014-03-08 21:30:47',NULL,NULL),(2133,1314,'TE','5136735241',0,'2013-12-25 18:31:34',NULL,NULL),(14293,9350,'TE','3183368499',0,'2013-12-26 04:31:14',NULL,NULL),(14372,9399,'AP','7132634497',0,'2013-12-26 04:32:32',NULL,NULL),(12437,8147,'EM','hap4ever21@yahoo.com',0,'2013-12-26 03:15:56',NULL,NULL),(22421,14459,'TE','5044516008',0,'2013-12-28 03:32:43',NULL,NULL),(11941,7776,'TE','8062040509',0,'2013-12-26 03:03:05',NULL,NULL),(2243,1375,'AP','2146412128',0,'2013-12-25 18:45:55',NULL,NULL),(25042,16139,'EM','VMF214GE@YAHOO.COM',0,'2014-01-04 02:05:57',NULL,NULL),(7786,5083,'TE','8303343828',0,'2013-12-25 23:01:00',NULL,NULL),(32120,20973,'AP','2058374412',0,'2014-02-01 19:00:16',NULL,NULL),(34099,22350,'AP','4199321586',0,'2014-02-10 21:00:03',NULL,NULL),(34176,22412,'AP','5046212563',0,'2014-02-10 21:30:26',NULL,NULL),(35524,23364,'TE','3307941114',0,'2014-02-13 22:00:48',NULL,NULL),(35777,23527,'AP','3377949880',0,'2014-02-13 22:02:24',NULL,NULL),(38448,25408,'TE','6154233660',0,'2014-02-25 21:31:01',NULL,NULL),(42842,28493,'TE','6013975355',0,'2014-03-07 21:31:43',NULL,NULL),(43345,28791,'AP','2817365448',0,'2014-03-09 21:00:42',NULL,NULL),(885,548,'EM','KEM.ROWE01@GMAIL.COM',0,'2013-12-25 17:49:57',NULL,NULL),(22341,14405,'AP','3309841143',0,'2013-12-28 03:31:18',NULL,NULL),(10621,6909,'AP','2252683307',0,'2013-12-26 01:45:53',NULL,NULL),(22648,14602,'EM','horses@sgstables.com',0,'2013-12-28 03:36:27',NULL,NULL),(7456,4855,'TE','9375805289',0,'2013-12-25 22:30:29',NULL,NULL),(4379,2793,'TE','5044278184',0,'2013-12-25 19:50:11',NULL,NULL),(28635,18462,'AP','3375296633',0,'2014-01-16 08:46:13',NULL,NULL),(31668,20661,'AP','9035061841',0,'2014-01-30 21:00:44',NULL,NULL),(34874,22873,'TE','6622136345',0,'2014-02-11 21:02:31',NULL,NULL),(43028,28609,'AP','3308822702',0,'2014-03-08 21:30:15',NULL,NULL),(43598,28946,'AP','9855187958',0,'2014-03-10 21:00:47',NULL,NULL),(43968,29168,'AP','5704197178',0,'2014-03-10 21:02:58',NULL,NULL),(1811,1120,'AP','5673711888',0,'2013-12-25 18:17:48',NULL,NULL),(11779,7663,'EM','dctfreak2000@yahoo.com',0,'2013-12-26 03:00:21',NULL,NULL),(10139,6626,'AP','4193203254',0,'2013-12-26 00:54:13',NULL,NULL),(22771,14682,'AP','9373075001',1,'2013-12-29 11:08:36',NULL,NULL),(23001,14836,'AP','3306968511',1,'2013-12-29 11:14:43',NULL,NULL),(6152,3961,'AP','3306081020',0,'2013-12-25 21:38:24',NULL,NULL),(2137,1318,'EM','j_toppel@yahoo.com',0,'2013-12-25 18:31:38',NULL,NULL),(25448,16411,'TE','4099824349',0,'2014-01-07 04:04:12',NULL,NULL),(26960,17338,'AP','3376923233',0,'2014-01-13 02:24:01',NULL,NULL),(27422,17661,'TE','6147078874',0,'2014-01-14 01:32:45',NULL,NULL),(27623,17807,'AP','5205593630',0,'2014-01-15 02:05:51',NULL,NULL),(30479,19762,'AP','9013830928',0,'2014-01-23 21:01:25',NULL,NULL),(32143,20994,'EM','plhighfield@aol.com',0,'2014-02-01 19:00:26',NULL,NULL),(32825,21480,'AP','7035993022',0,'2014-02-04 21:01:42',NULL,NULL),(35713,23486,'AP','5049758227',0,'2014-02-13 22:01:59',NULL,NULL),(38225,25233,'EM','kickinsixty@aol.com',0,'2014-02-21 22:01:03',NULL,NULL),(38720,25593,'AP','9853281415',0,'2014-02-26 08:00:44',NULL,NULL),(39716,26267,'EM','DEBBIEAMONROE@YAHOO.COM',0,'2014-02-28 06:31:14',NULL,NULL),(40417,26831,'TE','4196061115',0,'2014-03-01 21:00:40',NULL,NULL),(41487,27578,'EM','chris120360@att.net',0,'2014-03-04 21:30:24',NULL,NULL),(42211,28042,'AP','6626075059',0,'2014-03-06 21:01:32',NULL,NULL),(23692,15295,'TE','5046001731',1,'2014-01-02 04:22:37',NULL,NULL),(23113,14901,'TE','5138253338',0,'2013-12-30 00:01:08',NULL,NULL),(20290,13079,'TE','7404225004',0,'2013-12-26 12:51:31',NULL,NULL),(9420,6164,'EM','Angmcferran@yahoo.com',0,'2013-12-26 00:16:54',NULL,NULL),(3547,2222,'TE','4195368211',0,'2013-12-25 19:20:33',NULL,NULL),(5798,3720,'EM','scarletcg@hotmail.com',0,'2013-12-25 21:32:21',NULL,NULL),(4608,2940,'EM','bolynconaway@gmail.com',0,'2013-12-25 20:16:13',NULL,NULL),(2525,1546,'TE','2165910905',0,'2013-12-25 18:50:28',NULL,NULL),(29706,19207,'AP','3309904932',0,'2014-01-21 08:46:20',NULL,NULL),(29839,19303,'EM','bradhemenway@yahoo.com',1,'2014-01-22 03:22:02',NULL,NULL),(31013,20175,'TE','3307335914',0,'2014-01-27 21:01:17',NULL,NULL),(32146,20995,'EM','justin.stacy08@gmail.com',0,'2014-02-01 19:00:26',NULL,NULL),(33393,21880,'TE','9855420182',0,'2014-02-06 21:01:30',NULL,NULL),(33966,22284,'TE','3309667824',0,'2014-02-10 11:00:24',NULL,NULL),(35522,23363,'TE','3306734587',0,'2014-02-13 22:00:47',NULL,NULL),(36913,24311,'AP','9852328958',0,'2014-02-18 21:30:25',NULL,NULL),(37455,24662,'AP','4192797137',0,'2014-02-20 04:25:47',NULL,NULL),(37646,24814,'TE','5139009025',0,'2014-02-20 04:50:16',NULL,NULL),(37156,24458,'EM','Aggienerd11@gmail.com',0,'2014-02-18 22:01:31',NULL,NULL),(40082,26582,'TE','5139846722',0,'2014-02-28 21:30:31',NULL,NULL),(7450,4852,'TE','9377659953',0,'2013-12-25 22:30:24',NULL,NULL),(11885,7733,'EM','GLAMDIVAS@GMAIL.COM',0,'2013-12-26 03:02:06',NULL,NULL),(8949,5856,'TE','2604151048',0,'2013-12-25 23:48:57',NULL,NULL),(12422,8135,'AP','4124822916',0,'2013-12-26 03:15:39',NULL,NULL),(4380,2793,'AP','5044278184',0,'2013-12-25 19:50:11',NULL,NULL),(20301,13085,'AP','6143234405',0,'2013-12-26 12:51:42',NULL,NULL),(3596,2263,'TE','7409656877',0,'2013-12-25 19:30:16',NULL,NULL),(6798,4411,'AP','5135040016',0,'2013-12-25 22:01:22',NULL,NULL),(23124,14905,'AP','4049734811',0,'2013-12-30 00:01:17',NULL,NULL),(27616,17803,'AP','4197060607',0,'2014-01-14 01:33:55',NULL,NULL),(29219,18873,'EM','Bambipenton@gmail.com',0,'2014-01-17 03:36:25',NULL,NULL),(29473,19052,'EM','Lchownin@its.jnj.com',0,'2014-01-20 08:06:45',NULL,NULL),(30508,19788,'EM','milesb69@yahoo.com',0,'2014-01-23 21:01:39',NULL,NULL),(35282,23171,'AP','9375444412',0,'2014-02-12 21:31:53',NULL,NULL),(36062,23719,'EM','Uriahkanderson@gmail.com',0,'2014-02-14 21:30:51',NULL,NULL),(39010,25797,'TE','4406389090',0,'2014-02-26 21:00:14',NULL,NULL),(42331,28112,'TE','3303516822',0,'2014-03-06 21:02:15',NULL,NULL),(2686,1631,'EM','chenscott74@yahoo.com',0,'2013-12-25 18:52:50',NULL,NULL),(6214,4008,'TE','2165263952',0,'2013-12-25 21:45:20',NULL,NULL),(7412,4820,'TE','3302898921',0,'2013-12-25 22:17:04',NULL,NULL),(22097,14231,'EM','blittle1963@yahoo.com',0,'2013-12-27 02:05:01',NULL,NULL),(23302,15016,'AP','3302312938',0,'2014-01-01 12:02:10',NULL,NULL),(24236,15657,'AP','4199796271',1,'2014-01-02 04:34:20',NULL,NULL),(20327,13097,'AP','5137024016',0,'2013-12-26 12:52:04',NULL,NULL),(3581,2242,'AP','5138334796',0,'2013-12-25 19:21:05',NULL,NULL),(9633,6304,'TE','4408395223',0,'2013-12-26 00:46:00',NULL,NULL),(14288,9346,'EM','CETHWATSON@GMAIL.COM',0,'2013-12-26 04:31:08',NULL,NULL),(13748,8958,'EM','ajccsc@columbus.rr.com',0,'2013-12-26 04:03:48',NULL,NULL),(25032,16132,'TE','3303889821',0,'2014-01-04 02:05:44',NULL,NULL),(26597,17110,'EM','michaelwscully1972@yahoo.com',0,'2014-01-13 02:21:37',NULL,NULL),(27926,17992,'TE','3309459502',0,'2014-01-15 02:06:57',NULL,NULL),(28109,18116,'EM','M3davis2001@yahoo.com',0,'2014-01-15 02:07:39',NULL,NULL),(28169,18157,'TE','4193881110',0,'2014-01-15 02:07:52',NULL,NULL),(29169,18847,'EM','DAVIS44281@NEO.RR.COM',0,'2014-01-17 03:36:15',NULL,NULL),(29315,18943,'EM','gerwin1101@gmail.com',0,'2014-01-20 08:05:44',NULL,NULL),(29859,19319,'TE','9568474404',1,'2014-01-22 03:22:10',NULL,NULL),(31100,20248,'AP','7133054022',0,'2014-01-28 21:00:12',NULL,NULL),(33998,22300,'AP','2167804426',0,'2014-02-10 11:00:37',NULL,NULL),(35764,23520,'AP','3302892292',0,'2014-02-13 22:02:20',NULL,NULL),(38945,25748,'AP','6144461229',0,'2014-02-26 09:30:44',NULL,NULL),(40100,26594,'TE','3309834945',0,'2014-02-28 21:30:37',NULL,NULL),(41004,27244,'TE','9375440261',0,'2014-03-03 21:31:49',NULL,NULL),(137,82,'EM','twhite1250@gmail.com',0,'2013-12-25 17:17:11',NULL,NULL),(25464,16419,'TE','9374274515',0,'2014-01-07 04:04:29',NULL,NULL),(11306,7368,'AP','5049821701',0,'2013-12-26 02:15:35',NULL,NULL),(7846,5121,'EM','susannahlipsey@gmail.com',0,'2013-12-25 23:01:57',NULL,NULL),(5089,3265,'AP','5049577727',0,'2013-12-25 20:47:02',NULL,NULL),(1367,833,'EM','alhicksconstruction@aol.com',0,'2013-12-25 18:06:25',NULL,NULL),(23871,15403,'EM','John_scheidt@msn.com',1,'2014-01-02 04:26:53',NULL,NULL),(981,605,'TE','2165712289',0,'2013-12-25 18:00:25',NULL,NULL),(7041,4599,'TE','3307989489',0,'2013-12-25 22:05:39',NULL,NULL),(27370,17619,'EM','ALLEND9TX@YAHOO.COM',0,'2014-01-14 01:32:26',NULL,NULL),(30126,19513,'TE','7273653778',0,'2014-01-23 03:02:15',NULL,NULL),(31092,20239,'TE','6016450383',0,'2014-01-28 21:00:07',NULL,NULL),(31098,20244,'EM','hamm2322@gmail.com',0,'2014-01-28 21:00:10',NULL,NULL),(35916,23634,'TE','9038049852',0,'2014-02-14 21:30:04',NULL,NULL),(36043,23708,'EM','lucasdillingham@gmail.com',0,'2014-02-14 21:30:45',NULL,NULL),(37196,24483,'TE','5134440216',0,'2014-02-18 22:01:46',NULL,NULL),(43453,28857,'TE','7403926299',0,'2014-03-09 21:30:00',NULL,NULL),(636,395,'AP','6145600501',0,'2013-12-25 17:46:01',NULL,NULL),(25964,16724,'EM','lclark3120@neo.rr.com',0,'2014-01-08 18:24:47',NULL,NULL),(25246,16281,'TE','4192245256',0,'2014-01-07 04:00:32',NULL,NULL),(5357,3431,'AP','3235944868',0,'2013-12-25 21:18:57',NULL,NULL),(5343,3422,'AP','2254131922',0,'2013-12-25 21:18:42',NULL,NULL),(3961,2514,'EM','bonniechristine11@yahoo.com',0,'2013-12-25 19:36:24',NULL,NULL),(5725,3672,'AP','5132189982',0,'2013-12-25 21:31:12',NULL,NULL),(3413,2143,'EM','brent@brentbourland.com',0,'2013-12-25 19:18:20',NULL,NULL),(1087,668,'EM','KDRACING01@ATT.NET',0,'2013-12-25 18:02:04',NULL,NULL),(6853,4445,'EM','shannonmi.chaelsanta@gmail.com',0,'2013-12-25 22:02:15',NULL,NULL),(11735,7637,'AP','2545631161',0,'2013-12-26 02:46:27',NULL,NULL),(11949,7784,'TE','9368552608',0,'2013-12-26 03:03:16',NULL,NULL),(21263,13663,'TE','5042373582',0,'2013-12-26 13:07:41',NULL,NULL),(21866,14085,'TE','4409643068',0,'2013-12-27 02:01:13',NULL,NULL),(7358,4783,'TE','3302122620',0,'2013-12-25 22:16:11',NULL,NULL),(23929,15440,'EM','jrackley30@gmail.com',1,'2014-01-02 04:28:02',NULL,NULL),(26503,17054,'TE','5132524535',0,'2014-01-13 02:21:00',NULL,NULL),(28557,18413,'TE','3185120437',0,'2014-01-16 08:45:48',NULL,NULL),(29132,18818,'AP','5135127011',0,'2014-01-17 03:36:05',NULL,NULL),(30597,19855,'TE','7402645337',0,'2014-01-24 21:00:33',NULL,NULL),(31033,20189,'AP','2147385348',0,'2014-01-27 21:01:25',NULL,NULL),(32870,21511,'AP','4194387060',0,'2014-02-04 21:01:58',NULL,NULL),(34809,22833,'TE','3302676004',0,'2014-02-11 21:02:09',NULL,NULL),(34944,22935,'AP','2257154798',0,'2014-02-11 21:30:14',NULL,NULL),(35652,23446,'TE','3252279599',0,'2014-02-13 22:01:35',NULL,NULL),(39752,26289,'TE','5044589607',0,'2014-02-28 06:31:23',NULL,NULL),(7880,5137,'EM','lidika.ex@att.net',0,'2013-12-25 23:02:25',NULL,NULL),(25511,16450,'EM','brianna.german@yahoo.com',0,'2014-01-07 04:05:23',NULL,NULL),(11917,7757,'AP','6146345319',0,'2013-12-26 03:02:40',NULL,NULL),(13829,9015,'AP','5672032879',0,'2013-12-26 04:05:12',NULL,NULL),(14369,9395,'TE','9564516724',0,'2013-12-26 04:32:27',NULL,NULL),(8790,5759,'TE','6145801373',0,'2013-12-25 23:46:28',NULL,NULL),(4131,2634,'AP','3309980303',0,'2013-12-25 19:46:13',NULL,NULL),(21869,14088,'TE','5133306766',0,'2013-12-27 02:01:17',NULL,NULL),(5365,3435,'EM','DOTTYLOGAN@CHARTER.NET',0,'2013-12-25 21:19:04',NULL,NULL),(23755,15324,'TE','8064667947',1,'2014-01-02 04:23:40',NULL,NULL),(24165,15615,'AP','6012141387',1,'2014-01-02 04:32:58',NULL,NULL),(5559,3552,'TE','2346788329',0,'2013-12-25 21:22:04',NULL,NULL),(29433,19032,'TE','4199452980',0,'2014-01-20 08:06:32',NULL,NULL),(31556,20570,'TE','5138051888',0,'2014-01-29 21:01:52',NULL,NULL),(34406,22569,'AP','5139175037',0,'2014-02-10 21:31:55',NULL,NULL),(35404,23273,'EM','wb1965@comcast.net',0,'2014-02-13 21:30:13',NULL,NULL),(37415,24640,'AP','3373511617',0,'2014-02-20 04:20:02',NULL,NULL),(38087,25142,'TE','5127189667',0,'2014-02-21 22:00:11',NULL,NULL),(39795,26310,'EM','gwenstax87@aol.com',0,'2014-02-28 06:31:33',NULL,NULL),(42349,28125,'AP','3307801564',0,'2014-03-06 21:02:22',NULL,NULL),(42972,28576,'AP','5126600262',0,'2014-03-08 21:00:05',NULL,NULL),(7404,4816,'TE','5672041369',0,'2013-12-25 22:16:56',NULL,NULL),(25457,16415,'AP','8144907788',0,'2014-01-07 04:04:22',NULL,NULL),(9672,6332,'TE','5134624316',0,'2013-12-26 00:46:39',NULL,NULL),(9860,6446,'AP','4195759110',0,'2013-12-26 00:49:35',NULL,NULL),(9104,5967,'AP','4193085453',0,'2013-12-25 23:51:31',NULL,NULL),(5654,3630,'TE','9376182480',0,'2013-12-25 21:30:06',NULL,NULL),(1718,1053,'TE','2145371011',0,'2013-12-25 18:16:07',NULL,NULL),(20277,13070,'TE','2164108431',0,'2013-12-26 12:51:17',NULL,NULL),(20641,13277,'TE','5122889856',0,'2013-12-26 12:57:04',NULL,NULL),(24111,15564,'TE','2169906709',1,'2014-01-02 04:31:41',NULL,NULL),(6823,4428,'AP','5133645102',0,'2013-12-25 22:01:48',NULL,NULL),(21518,13831,'TE','3304147918',0,'2013-12-26 13:12:06',NULL,NULL),(22062,14208,'AP','2108595005',0,'2013-12-27 02:04:26',NULL,NULL),(6829,4433,'TE','2165095240',0,'2013-12-25 22:01:55',NULL,NULL),(7368,4794,'TE','3309624369',0,'2013-12-25 22:16:22',NULL,NULL),(31777,20743,'TE','4192420519',0,'2014-01-30 21:01:25',NULL,NULL),(33385,21875,'EM','rebeccashettlesworth@gmail.com',0,'2014-02-06 21:01:27',NULL,NULL),(34751,22785,'TE','3308322311',0,'2014-02-11 21:01:46',NULL,NULL),(35036,23011,'AP','3184615305',0,'2014-02-12 21:30:23',NULL,NULL),(35552,23378,'EM','chowgirl9@yahoo.com',0,'2014-02-13 22:00:58',NULL,NULL),(36275,23883,'TE','5133177755',0,'2014-02-14 21:32:15',NULL,NULL),(36634,24117,'TE','9798484424',0,'2014-02-15 22:01:40',NULL,NULL),(37836,24964,'TE','5044212431',0,'2014-02-20 22:00:22',NULL,NULL),(38795,25649,'EM','jrunyon618@aol.com',0,'2014-02-26 08:30:37',NULL,NULL),(43122,28666,'BN','3183449443',0,'2014-03-08 21:30:46',NULL,NULL),(8114,5312,'AP','3304756609',0,'2013-12-25 23:06:37',NULL,NULL),(4627,2949,'AP','2167734429',0,'2013-12-25 20:16:29',NULL,NULL),(8341,5476,'TE','4192572156',0,'2013-12-25 23:10:43',NULL,NULL),(3542,2218,'TE','3302122061',0,'2013-12-25 19:20:27',NULL,NULL),(9846,6439,'TE','3375776496',0,'2013-12-26 00:49:23',NULL,NULL),(10279,6711,'AP','2694140603',0,'2013-12-26 01:02:16',NULL,NULL),(5986,3845,'EM','nolakara@gmail.com',0,'2013-12-25 21:35:30',NULL,NULL),(6588,4253,'EM','kms17@zips.uakron.edu',0,'2013-12-25 21:51:21',NULL,NULL),(14487,9461,'EM','LAINESALAMODE@HOTMAIL.COM',0,'2013-12-26 04:34:14',NULL,NULL),(21045,13538,'EM','Russellhenry123@yahoo.com',0,'2013-12-26 13:03:42',NULL,NULL),(6622,4278,'TE','4196921136',0,'2013-12-25 21:51:57',NULL,NULL),(6722,4368,'TE','2169386050',0,'2013-12-25 22:00:14',NULL,NULL),(22845,14741,'TE','3372764282',1,'2013-12-29 11:10:02',NULL,NULL),(23174,14934,'EM','garyjjacobs@yahoo.com',0,'2013-12-30 00:02:07',NULL,NULL),(24459,15788,'TE','9852272426',0,'2014-01-03 02:02:23',NULL,NULL),(26941,17327,'EM','erikwahl@gmail.com',0,'2014-01-13 02:23:55',NULL,NULL),(33189,21734,'TE','9404528456',0,'2014-02-06 21:00:11',NULL,NULL),(35965,23660,'BN','2145788438',0,'2014-02-14 21:30:19',NULL,NULL),(36592,24089,'AP','3303175326',0,'2014-02-15 22:01:25',NULL,NULL),(621,381,'EM','massiveapocolypse@yahoo.com',0,'2013-12-25 17:45:43',NULL,NULL),(11264,7340,'AP','3306067567',0,'2013-12-26 02:04:01',NULL,NULL),(4700,3007,'TE','3307737768',0,'2013-12-25 20:17:49',NULL,NULL),(24230,15655,'AP','2602239067',1,'2014-01-02 04:34:15',NULL,NULL),(8232,5386,'EM','ashnash13@gmail.com',0,'2013-12-25 23:08:32',NULL,NULL),(27238,17536,'TE','3304162253',0,'2014-01-13 03:01:45',NULL,NULL),(28211,18182,'EM','kpliska1863@frontier.com',0,'2014-01-15 02:08:01',NULL,NULL),(31184,20309,'AP','2109005084',0,'2014-01-28 21:00:48',NULL,NULL),(31525,20543,'TE','4198379331',0,'2014-01-29 21:01:37',NULL,NULL),(35615,23420,'EM','edwinaguevara@yahoo.com',0,'2014-02-13 22:01:22',NULL,NULL),(37507,24697,'AP','9567401351',0,'2014-02-20 04:33:46',NULL,NULL),(38668,25557,'TE','9374445027',0,'2014-02-26 08:00:21',NULL,NULL),(38703,25578,'TE','9379744900',0,'2014-02-26 08:00:34',NULL,NULL),(38930,25735,'AP','5184289806',0,'2014-02-26 09:30:38',NULL,NULL),(40266,26713,'TE','6016659131',0,'2014-02-28 21:31:39',NULL,NULL),(43254,28740,'EM','timmyhuntin270@gmail.com',0,'2014-03-09 21:00:09',NULL,NULL),(80,48,'AP','2673034299',0,'2013-12-25 17:16:18',NULL,NULL),(12206,7975,'TE','3305422933',0,'2013-12-26 03:07:48',NULL,NULL),(13809,8999,'EM','haroldwnt@yahoo.com',0,'2013-12-26 04:04:50',NULL,NULL),(6072,3909,'AP','8309281281',0,'2013-12-25 21:37:03',NULL,NULL),(22657,14608,'EM','bmwhaus62@yahoo.com',0,'2013-12-28 03:36:35',NULL,NULL),(1540,948,'TE','4192901862',0,'2013-12-25 18:09:29',NULL,NULL),(5715,3667,'AP','5136164462',0,'2013-12-25 21:31:03',NULL,NULL),(9175,6004,'EM','ryan@ryanhelms.com',0,'2013-12-26 00:00:28',NULL,NULL),(9632,6303,'AP','9374171757',0,'2013-12-26 00:45:58',NULL,NULL),(11155,7252,'EM','kbauer613@yahoo.com',0,'2013-12-26 02:01:58',NULL,NULL),(10012,6551,'TE','2194879070',0,'2013-12-26 00:52:11',NULL,NULL),(26879,17294,'TE','2812011383',0,'2014-01-13 02:23:35',NULL,NULL),(29461,19047,'EM','ferrisrentals@yahoo.com',0,'2014-01-20 08:06:41',NULL,NULL),(30912,20099,'AP','5043140857',0,'2014-01-27 21:00:34',NULL,NULL),(43318,28777,'TE','3304792585',0,'2014-03-09 21:00:33',NULL,NULL),(43620,28956,'AP','3373239216',0,'2014-03-10 21:00:53',NULL,NULL),(43881,29117,'TE','6016689251',0,'2014-03-10 21:02:28',NULL,NULL),(3658,2318,'EM','codykwitt@gmail.com',0,'2013-12-25 19:31:22',NULL,NULL),(24903,16052,'EM','kelliejoboyer@live.com',0,'2014-01-04 02:03:15',NULL,NULL),(24326,15715,'AP','7657175916',1,'2014-01-02 04:36:12',NULL,NULL),(9197,6019,'AP','4408620050',0,'2013-12-26 00:00:49',NULL,NULL),(11562,7523,'EM','rbboling60@gmail.com',0,'2013-12-26 02:32:28',NULL,NULL),(21360,13731,'EM','shanns5678@yahoo.com',0,'2013-12-26 13:09:26',NULL,NULL),(21559,13862,'AP','3306711258',0,'2013-12-26 13:12:51',NULL,NULL),(26658,17150,'TE','3107227662',0,'2014-01-13 02:21:56',NULL,NULL),(27325,17597,'TE','6013668334',0,'2014-01-14 01:32:14',NULL,NULL),(27819,17927,'BN','9032680537',0,'2014-01-15 02:06:33',NULL,NULL),(30290,19624,'TE','6146008580',0,'2014-01-23 21:00:05',NULL,NULL),(31696,20676,'AP','6628098690',0,'2014-01-30 21:00:52',NULL,NULL),(33418,21894,'AP','4192364828',0,'2014-02-06 21:01:41',NULL,NULL),(33808,22198,'BN','4404549454',0,'2014-02-09 19:00:13',NULL,NULL),(35789,23534,'EM','brittany_cobbs210@yahoo.com',0,'2014-02-13 22:02:28',NULL,NULL),(35978,23671,'AP','5042965524',0,'2014-02-14 21:30:25',NULL,NULL),(37223,24496,'TE','3615220586',0,'2014-02-20 03:47:03',NULL,NULL),(37343,24586,'AP','2167121160',0,'2014-02-20 04:09:50',NULL,NULL),(41723,27745,'TE','4195918540',0,'2014-03-05 21:31:11',NULL,NULL),(42198,28030,'TE','7403332066',0,'2014-03-06 21:01:27',NULL,NULL),(8248,5396,'TE','3184044719',0,'2013-12-25 23:08:48',NULL,NULL),(7065,4612,'EM','whimworks@gmail.com',0,'2013-12-25 22:06:02',NULL,NULL),(9422,6165,'AP','9374231147',0,'2013-12-26 00:16:55',NULL,NULL),(11368,7405,'TE','2145137670',0,'2013-12-26 02:16:33',NULL,NULL),(2509,1539,'TE','2169128592',0,'2013-12-25 18:50:14',NULL,NULL),(14148,9262,'TE','5049205703',0,'2013-12-26 04:15:22',NULL,NULL),(1496,920,'TE','9374021002',0,'2013-12-25 18:08:47',NULL,NULL),(21178,13622,'AP','4192305155',0,'2013-12-26 13:05:54',NULL,NULL),(1084,666,'TE','3305595203',0,'2013-12-25 18:02:01',NULL,NULL),(23242,14975,'EM','suzimin@yahoo.com',0,'2014-01-01 12:00:58',NULL,NULL),(28208,18181,'AP','4193032905',0,'2014-01-15 02:08:01',NULL,NULL),(29363,18973,'TE','7408852018',0,'2014-01-20 08:06:03',NULL,NULL),(30774,20006,'EM','sarabeckrest@gmail.com',0,'2014-01-26 19:00:06',NULL,NULL),(37952,25042,'AP','9372156982',0,'2014-02-20 22:01:11',NULL,NULL),(40761,27086,'AP','4196518524',0,'2014-03-03 21:30:14',NULL,NULL),(43634,28963,'TE','5042569282',0,'2014-03-10 21:00:58',NULL,NULL),(131,76,'TE','5132489168',0,'2013-12-25 17:17:05',NULL,NULL),(6043,3881,'AP','5047829256',0,'2013-12-25 21:36:27',NULL,NULL),(6033,3876,'TE','2254397024',0,'2013-12-25 21:36:18',NULL,NULL),(1765,1089,'AP','6142676966',0,'2013-12-25 18:17:00',NULL,NULL),(5097,3270,'AP','6012810051',0,'2013-12-25 20:47:11',NULL,NULL),(1599,984,'EM','cmykpro@gmail.com',0,'2013-12-25 18:10:25',NULL,NULL),(3158,1974,'TE','8176816774',0,'2013-12-25 19:01:33',NULL,NULL),(9727,6367,'TE','2164696038',0,'2013-12-26 00:47:31',NULL,NULL),(10535,6860,'TE','7404225004',0,'2013-12-26 01:31:39',NULL,NULL),(936,578,'AP','5133173474',0,'2013-12-25 17:50:47',NULL,NULL),(8887,5821,'EM','lululuvsu2005@yahoo.com',0,'2013-12-25 23:48:01',NULL,NULL),(22114,14243,'AP','3617726780',0,'2013-12-27 02:05:19',NULL,NULL),(22276,14357,'TE','7406012175',0,'2013-12-28 03:30:12',NULL,NULL),(22434,14466,'AP','2103095139',0,'2013-12-28 03:32:56',NULL,NULL),(27524,17729,'TE','3307847622',0,'2014-01-14 01:33:19',NULL,NULL),(30854,20056,'AP','9034319929',0,'2014-01-27 21:00:08',NULL,NULL),(31975,20878,'TE','7134087858',0,'2014-01-31 21:01:06',NULL,NULL),(32609,21321,'AP','3188161346',0,'2014-02-04 21:00:23',NULL,NULL),(35385,23254,'AP','3306717566',0,'2014-02-13 21:30:07',NULL,NULL),(35497,23338,'AP','7247773860',0,'2014-02-13 22:00:36',NULL,NULL),(36467,24010,'AP','7406379423',0,'2014-02-15 22:00:39',NULL,NULL),(38659,25549,'TE','4199452035',0,'2014-02-26 08:00:17',NULL,NULL),(39414,26061,'TE','9373924627',0,'2014-02-26 21:02:39',NULL,NULL),(41364,27480,'TE','2542262194',0,'2014-03-04 21:02:16',NULL,NULL),(43329,28785,'TE','5133351223',0,'2014-03-09 21:00:37',NULL,NULL),(2287,1402,'AP','3378027818',0,'2013-12-25 18:46:38',NULL,NULL),(20807,13368,'TE','6149375512',0,'2013-12-26 12:59:42',NULL,NULL),(14263,9328,'EM','laury_arkus@yahoo.com',0,'2013-12-26 04:30:43',NULL,NULL),(13839,9023,'AP','3303224661',0,'2013-12-26 04:05:23',NULL,NULL),(23700,15299,'TE','2252020377',1,'2014-01-02 04:22:46',NULL,NULL),(23728,15310,'TE','4695850082',1,'2014-01-02 04:23:11',NULL,NULL),(24131,15577,'AP','4349428032',1,'2014-01-02 04:32:04',NULL,NULL),(11541,7513,'TE','3185058651',0,'2013-12-26 02:32:09',NULL,NULL),(24950,16082,'AP','5138289585',0,'2014-01-04 02:04:08',NULL,NULL),(33227,21758,'AP','4302001541',0,'2014-02-06 21:00:25',NULL,NULL),(3174,1991,'TE','8176816774',0,'2013-12-25 19:01:57',NULL,NULL),(21797,14044,'AP','9374174660',0,'2013-12-27 02:00:07',NULL,NULL),(21909,14115,'TE','4407257882',0,'2013-12-27 02:01:57',NULL,NULL),(3017,1876,'EM','Beatricecoffee13@gmail.com',0,'2013-12-25 18:58:26',NULL,NULL),(7566,4926,'AP','5132630514',0,'2013-12-25 22:45:18',NULL,NULL),(24027,15513,'EM','poodlechew@wowway.com',1,'2014-01-02 04:30:05',NULL,NULL),(24522,15816,'AP','8134350636',0,'2014-01-03 02:03:23',NULL,NULL),(27961,18023,'TE','3303973732',0,'2014-01-15 02:07:06',NULL,NULL),(30569,19834,'TE','8178816605',0,'2014-01-24 21:00:21',NULL,NULL),(31669,20661,'EM','Haileymaleik6@aol.com',0,'2014-01-30 21:00:44',NULL,NULL),(34185,22421,'AP','3182378945',0,'2014-02-10 21:30:30',NULL,NULL),(34317,22515,'TE','2545419663',0,'2014-02-10 21:31:22',NULL,NULL),(36256,23859,'AP','9852553218',0,'2014-02-14 21:32:04',NULL,NULL),(38678,25563,'EM','charlottewill133@gmail.com',0,'2014-02-26 08:00:25',NULL,NULL),(39327,26011,'EM','Schlechty511@roadrunner.com',0,'2014-02-26 21:02:11',NULL,NULL),(1731,1061,'EM','breeden@bex.net',0,'2013-12-25 18:16:18',NULL,NULL),(25581,16500,'EM','Packsandmoves@woh.rr.com',0,'2014-01-07 04:06:50',NULL,NULL),(3797,2412,'EM','markvoptions@aol.com',0,'2013-12-25 19:33:47',NULL,NULL),(3773,2392,'EM','brown4707@sbcglobal.net',0,'2013-12-25 19:33:20',NULL,NULL),(22554,14546,'AP','6015635184',0,'2013-12-28 03:34:54',NULL,NULL),(7972,5202,'TE','3309589224',0,'2013-12-25 23:04:03',NULL,NULL),(27384,17627,'TE','5124875417',0,'2014-01-14 01:32:31',NULL,NULL),(27938,18002,'EM','sara.tackett@cune.org',0,'2014-01-15 02:07:00',NULL,NULL),(30631,19879,'AP','6149463560',0,'2014-01-24 21:00:45',NULL,NULL),(30770,20005,'TE','5132402563',0,'2014-01-26 19:00:05',NULL,NULL),(31408,20473,'EM','nstolb@yahoo.com',0,'2014-01-29 21:00:57',NULL,NULL),(33214,21751,'TE','4693146714',0,'2014-02-06 21:00:21',NULL,NULL),(33467,21925,'EM','cflores0785@yahoo.com',0,'2014-02-07 19:00:08',NULL,NULL),(33790,22180,'EM','isaacquaye1@gmail.com',0,'2014-02-08 19:30:11',NULL,NULL),(34457,22608,'EM','chuckie190@yahoo.com',0,'2014-02-10 21:32:19',NULL,NULL),(36067,23722,'AP','8326558941',0,'2014-02-14 21:30:53',NULL,NULL),(37272,24526,'AP','9723452929',0,'2014-02-20 03:59:12',NULL,NULL),(40077,26577,'EM','ISEIDU@GMAIL.COM',0,'2014-02-28 21:30:28',NULL,NULL),(40743,27074,'EM','ms.douglas3@yahoo.com',0,'2014-03-03 21:30:08',NULL,NULL),(43216,28718,'EM','joneste72@gmail.com',0,'2014-03-08 21:31:19',NULL,NULL),(2117,1306,'AP','3616483805',0,'2013-12-25 18:31:20',NULL,NULL),(9773,6389,'EM','barryrobison74@gmail.com',0,'2013-12-26 00:48:09',NULL,NULL),(10857,7048,'TE','9039174305',0,'2013-12-26 01:49:36',NULL,NULL),(9013,5915,'TE','5756498887',0,'2013-12-25 23:50:08',NULL,NULL),(13599,8865,'AP','2143567261',0,'2013-12-26 04:01:24',NULL,NULL),(5400,3455,'TE','6142046360',0,'2013-12-25 21:19:38',NULL,NULL),(20961,13485,'TE','9376742684',0,'2013-12-26 13:02:19',NULL,NULL),(25636,16534,'EM','andrea_branch1@yahoo.com',1,'2014-01-07 10:22:08',NULL,NULL),(5759,3689,'AP','4193413302',0,'2013-12-25 21:31:41',NULL,NULL),(4317,2755,'TE','4409640083',0,'2013-12-25 19:49:10',NULL,NULL),(27953,18011,'EM','tedandwendymanning@gmail.com',0,'2014-01-15 02:07:03',NULL,NULL),(29849,19312,'AP','9569994586',1,'2014-01-22 03:22:07',NULL,NULL),(31226,20338,'TE','3185580273',0,'2014-01-28 21:01:06',NULL,NULL),(31366,20440,'AP','6625881068',0,'2014-01-29 21:00:40',NULL,NULL),(31488,20518,'EM','dgtldesigner@gmail.com',0,'2014-01-29 21:01:23',NULL,NULL),(33168,21723,'AP','3373083217',0,'2014-02-06 21:00:05',NULL,NULL),(33420,21895,'TE','3306140621',0,'2014-02-06 21:01:42',NULL,NULL),(35416,23283,'AP','5132481436',0,'2014-02-13 21:30:17',NULL,NULL),(37978,25055,'EM','kachema@yahoo.fr',0,'2014-02-20 22:01:20',NULL,NULL),(39352,26028,'EM','CHARLESTONJAMAND@ATT.NET',0,'2014-02-26 21:02:20',NULL,NULL),(40764,27087,'EM','lauri.cook@att.net',0,'2014-03-03 21:30:15',NULL,NULL),(2211,1358,'EM','Brandijohnson13@gmail.com',0,'2013-12-25 18:45:26',NULL,NULL),(13635,8891,'AP','8066766431',0,'2013-12-26 04:02:01',NULL,NULL),(14611,9551,'AP','9373026824',0,'2013-12-26 04:36:18',NULL,NULL),(10210,6672,'TE','5136922354',0,'2013-12-26 01:01:09',NULL,NULL),(5214,3349,'EM','rlambard@hotmail.com',0,'2013-12-25 21:16:42',NULL,NULL),(5420,3469,'AP','4193025069',0,'2013-12-25 21:19:55',NULL,NULL),(4105,2618,'AP','2162535635',0,'2013-12-25 19:45:47',NULL,NULL),(23318,15025,'TE','3188346655',0,'2014-01-01 12:02:27',NULL,NULL),(5729,3674,'AP','5139261369',0,'2013-12-25 21:31:16',NULL,NULL),(24736,15960,'TE','5132008226',0,'2014-01-04 02:00:19',NULL,NULL),(25326,16331,'AP','9859910236',0,'2014-01-07 04:02:01',NULL,NULL),(6649,4312,'TE','4145540744',0,'2013-12-25 21:52:35',NULL,NULL),(25478,16429,'TE','3183987252',0,'2014-01-07 04:04:44',NULL,NULL),(26523,17064,'TE','8179758473',0,'2014-01-13 02:21:13',NULL,NULL),(27098,17431,'TE','3307598613',0,'2014-01-13 03:00:31',NULL,NULL),(27605,17795,'EM','CSLPMILLER@GMAIL.COM',0,'2014-01-14 01:33:50',NULL,NULL),(29088,18786,'TE','4199537841',0,'2014-01-17 03:35:55',NULL,NULL),(31187,20311,'TE','6825560480',0,'2014-01-28 21:00:49',NULL,NULL),(34294,22500,'AP','5135268888',0,'2014-02-10 21:31:13',NULL,NULL),(39948,26442,'TE','2169388008',0,'2014-02-28 07:30:21',NULL,NULL),(41126,27317,'AP','9364141135',0,'2014-03-04 21:00:43',NULL,NULL),(43000,28595,'AP','7406020400',0,'2014-03-08 21:30:05',NULL,NULL),(7959,5190,'AP','2162141398',0,'2013-12-25 23:03:46',NULL,NULL),(8567,5633,'TE','3306761909',0,'2013-12-25 23:31:01',NULL,NULL),(9553,6252,'TE','2163815160',0,'2013-12-26 00:31:59',NULL,NULL),(5937,3807,'TE','3303535045',0,'2013-12-25 21:34:40',NULL,NULL),(10081,6588,'EM','smitty514oh@yahoo.com',0,'2013-12-26 00:53:11',NULL,NULL),(6119,3938,'TE','4193767391',0,'2013-12-25 21:37:51',NULL,NULL),(14401,9415,'AP','8308541800',0,'2013-12-26 04:32:59',NULL,NULL),(3220,2025,'TE','3303510283',0,'2013-12-25 19:15:12',NULL,NULL),(6479,4191,'AP','3308016682',0,'2013-12-25 21:49:39',NULL,NULL),(22653,14607,'AP','4195775992',0,'2013-12-28 03:36:33',NULL,NULL),(840,521,'TE','7406535809',0,'2013-12-25 17:49:13',NULL,NULL),(746,466,'AP','4403873177',0,'2013-12-25 17:47:47',NULL,NULL),(24390,15748,'EM','Gayle.kline@yahoo.com',0,'2014-01-03 02:01:05',NULL,NULL),(27559,17761,'EM','hayes553@roadrunner.com',0,'2014-01-14 01:33:33',NULL,NULL),(34371,22543,'AP','2252442051',0,'2014-02-10 21:31:41',NULL,NULL),(35503,23346,'TE','3302567742',0,'2014-02-13 22:00:39',NULL,NULL),(7599,4946,'EM','suekasch@yahoo.com',0,'2013-12-25 22:45:49',NULL,NULL),(25790,16620,'TE','4404947076',0,'2014-01-08 18:24:11',NULL,NULL),(11000,7143,'EM','annesully412@gmail.com',0,'2013-12-26 01:51:58',NULL,NULL),(9097,5965,'TE','5678686413',0,'2013-12-25 23:51:27',NULL,NULL),(8324,5458,'EM','lcsengstock@yahoo.com',0,'2013-12-25 23:10:21',NULL,NULL),(25038,16136,'TE','2346789168',0,'2014-01-04 02:05:50',NULL,NULL),(3466,2170,'TE','4196629865',0,'2013-12-25 19:19:08',NULL,NULL),(28250,18217,'TE','4196937280',0,'2014-01-15 02:08:12',NULL,NULL),(29367,18975,'TE','4152542744',0,'2014-01-20 08:06:04',NULL,NULL),(33078,21666,'EM','missyisrael@hotmail.com',0,'2014-02-05 21:30:57',NULL,NULL),(36288,23893,'TE','9379872864',0,'2014-02-14 21:32:19',NULL,NULL),(36619,24109,'TE','9563071941',0,'2014-02-15 22:01:35',NULL,NULL),(38476,25426,'EM','gjaynesparks@yahoo.com',0,'2014-02-25 21:31:12',NULL,NULL),(40370,26794,'AP','4197874558',0,'2014-03-01 21:00:20',NULL,NULL),(41065,27281,'TE','9727816825',0,'2014-03-04 21:00:22',NULL,NULL),(41605,27661,'AP','2165540255',0,'2014-03-05 21:30:27',NULL,NULL),(90,54,'TE','5132290212',0,'2013-12-25 17:16:29',NULL,NULL),(25787,16616,'TE','9373298956',0,'2014-01-08 18:24:10',NULL,NULL),(4411,2810,'TE','5132568954',0,'2013-12-25 20:00:13',NULL,NULL),(4997,3206,'EM','tmahone@gmail.com',0,'2013-12-25 20:45:20',NULL,NULL),(3381,2125,'EM','tanvirfarooq@gmail.com',0,'2013-12-25 19:17:50',NULL,NULL),(848,525,'EM','sherch33@yahoo.com',0,'2013-12-25 17:49:19',NULL,NULL),(3011,1872,'EM','alonna.adams@yahoo.com',0,'2013-12-25 18:58:19',NULL,NULL),(2401,1463,'TE','3307590617',0,'2013-12-25 18:48:23',NULL,NULL),(6132,3947,'AP','4193413302',0,'2013-12-25 21:38:05',NULL,NULL),(6674,4334,'TE','4198236346',0,'2013-12-25 21:53:06',NULL,NULL),(683,425,'TE','3308395479',0,'2013-12-25 17:46:45',NULL,NULL),(13639,8893,'TE','5125545755',0,'2013-12-26 04:02:05',NULL,NULL),(21053,13542,'TE','3183340906',0,'2013-12-26 13:03:49',NULL,NULL),(24234,15656,'EM','dwnlxndr81@gmail.com',1,'2014-01-02 04:34:18',NULL,NULL),(24342,15720,'EM','misha3733@yahoo.com',0,'2014-01-03 02:00:13',NULL,NULL),(24814,16008,'TE','9725397964',0,'2014-01-04 02:01:43',NULL,NULL),(25165,16224,'EM','Rquinichett@aol.com',0,'2014-01-05 00:01:53',NULL,NULL),(26081,16797,'TE','2104974164',0,'2014-01-13 02:18:09',NULL,NULL),(29362,18971,'AP','4403436865',0,'2014-01-20 08:06:02',NULL,NULL),(29393,18997,'TE','3303453741',0,'2014-01-20 08:06:14',NULL,NULL),(29964,19388,'AP','3304799394',1,'2014-01-22 03:22:46',NULL,NULL),(30097,19498,'TE','4402418606',0,'2014-01-23 03:02:09',NULL,NULL),(34098,22350,'TE','4199321586',0,'2014-02-10 21:00:03',NULL,NULL),(34265,22481,'AP','5136461621',0,'2014-02-10 21:31:02',NULL,NULL),(38281,25276,'TE','9032887163',0,'2014-02-25 21:00:15',NULL,NULL),(41361,27478,'AP','8173334287',0,'2014-03-04 21:02:15',NULL,NULL),(42680,28392,'TE','3302129507',0,'2014-03-07 21:30:45',NULL,NULL),(42815,28474,'TE','4192063486',0,'2014-03-07 21:31:33',NULL,NULL),(1232,750,'EM','ondabeach@yahoo.com',0,'2013-12-25 18:04:17',NULL,NULL),(11300,7365,'TE','9858391031',0,'2013-12-26 02:15:30',NULL,NULL),(10049,6574,'TE','8285065337',0,'2013-12-26 00:52:45',NULL,NULL),(13913,9072,'TE','5133774734',0,'2013-12-26 04:06:39',NULL,NULL),(14046,9178,'TE','4193714698',0,'2013-12-26 04:09:07',NULL,NULL),(14229,9310,'AP','5042321355',0,'2013-12-26 04:30:14',NULL,NULL),(9974,6525,'EM','mschneder@gmail.com',0,'2013-12-26 00:51:33',NULL,NULL),(9922,6494,'AP','3305917585',0,'2013-12-26 00:50:40',NULL,NULL),(8366,5498,'TE','4194968555',0,'2013-12-25 23:11:15',NULL,NULL),(4361,2780,'AP','5135152886',0,'2013-12-25 19:49:50',NULL,NULL),(23203,14953,'AP','2102622229',0,'2014-01-01 12:00:16',NULL,NULL),(23382,15062,'TE','3189572541',0,'2014-01-01 12:03:36',NULL,NULL),(6267,4043,'EM','kris92750@gmail.com',0,'2013-12-25 21:46:10',NULL,NULL),(31999,20890,'EM','jenniferyaegel31@gmail.com',0,'2014-01-31 21:01:14',NULL,NULL),(32721,21405,'AP','7405890064',0,'2014-02-04 21:01:05',NULL,NULL),(32743,21421,'AP','5134064009',0,'2014-02-04 21:01:14',NULL,NULL),(34626,22705,'TE','5043685011',0,'2014-02-11 21:01:01',NULL,NULL),(40010,26505,'TE','5138940441',0,'2014-02-28 21:00:17',NULL,NULL),(42800,28462,'EM','aalsept@gmail.com',0,'2014-03-07 21:31:27',NULL,NULL),(43457,28859,'TE','5133024955',0,'2014-03-09 21:30:02',NULL,NULL),(35,25,'TE','9073422615',0,'2013-12-25 17:15:37',NULL,NULL),(2936,1805,'EM','trehbaum@hotmail.com',0,'2013-12-25 18:56:53',NULL,NULL),(3240,2039,'AP','3182377711',0,'2013-12-25 19:15:32',NULL,NULL),(5971,3835,'AP','3309806565',0,'2013-12-25 21:35:15',NULL,NULL),(9866,6451,'EM','matthewsjanice98@yahoo.com',0,'2013-12-26 00:49:40',NULL,NULL),(11299,7364,'EM','Edith.howard2010@yahoo.com',0,'2013-12-26 02:15:29',NULL,NULL),(1897,1169,'EM','mteer1@yahoo.com',0,'2013-12-25 18:19:07',NULL,NULL),(23392,15066,'EM','beckysmith2010@gmail.com',0,'2014-01-01 12:03:46',NULL,NULL),(6667,4327,'TE','3305445149',0,'2013-12-25 21:52:56',NULL,NULL),(695,431,'AP','7406015550',0,'2013-12-25 17:46:56',NULL,NULL),(24868,16036,'AP','3373159950',0,'2014-01-04 02:02:40',NULL,NULL),(28849,18631,'BN','9723425697',0,'2014-01-17 03:35:02',NULL,NULL),(31451,20500,'TE','9852373004',0,'2014-01-29 21:01:12',NULL,NULL),(36936,24324,'TE','5126361802',0,'2014-02-18 22:00:10',NULL,NULL),(37238,24505,'TE','8329001172',0,'2014-02-20 03:50:43',NULL,NULL),(40973,27224,'EM','viking91890@gmail.com',0,'2014-03-03 21:31:37',NULL,NULL),(118,69,'EM','catp1952@yahoo.com',0,'2013-12-25 17:16:53',NULL,NULL),(20423,13151,'TE','4406546196',0,'2013-12-26 12:53:36',NULL,NULL),(20632,13272,'EM','KSWDESIGNINC@YAHOO.COM',0,'2013-12-26 12:56:57',NULL,NULL),(21403,13761,'EM','dahlinwisc@gmail.com',0,'2013-12-26 13:10:14',NULL,NULL),(22481,14496,'AP','9565695921',0,'2013-12-28 03:33:39',NULL,NULL),(14710,9624,'AP','3307035206',0,'2013-12-26 04:38:00',NULL,NULL),(24638,15887,'AP','9377182076',0,'2014-01-03 02:05:36',NULL,NULL),(25788,16618,'TE','9377508294',0,'2014-01-08 18:24:10',NULL,NULL),(3357,2111,'AP','7405164681',0,'2013-12-25 19:17:26',NULL,NULL),(26289,16922,'AP','9854001100',0,'2014-01-13 02:19:44',NULL,NULL),(26302,16930,'TE','5042847973',0,'2014-01-13 02:19:48',NULL,NULL),(28183,18166,'TE','9377284326',0,'2014-01-15 02:07:56',NULL,NULL),(28464,18342,'TE','6149359027',0,'2014-01-16 08:45:18',NULL,NULL),(28746,18549,'AP','2282338843',0,'2014-01-16 08:46:53',NULL,NULL),(29319,18948,'TE','8327816015',0,'2014-01-20 08:05:47',NULL,NULL),(31086,20234,'TE','6623164544',0,'2014-01-28 21:00:04',NULL,NULL),(32919,21550,'TE','5138530995',0,'2014-02-05 21:30:13',NULL,NULL),(37010,24369,'TE','5048581510',0,'2014-02-18 22:00:37',NULL,NULL),(39365,26036,'TE','2346787578',0,'2014-02-26 21:02:24',NULL,NULL),(2079,1285,'AP','4192973783',0,'2013-12-25 18:30:41',NULL,NULL),(5382,3444,'TE','5133742380',0,'2013-12-25 21:19:20',NULL,NULL),(5251,3372,'TE','2149911427',0,'2013-12-25 21:17:17',NULL,NULL),(5663,3638,'TE','6018599360',0,'2013-12-25 21:30:18',NULL,NULL),(7300,4752,'AP','8174049098',0,'2013-12-25 22:15:15',NULL,NULL),(10011,6550,'TE','2106798547',0,'2013-12-26 00:52:09',NULL,NULL),(11763,7656,'TE','6789949922',0,'2013-12-26 03:00:08',NULL,NULL),(13787,8985,'AP','8632931580',0,'2013-12-26 04:04:27',NULL,NULL),(14486,9461,'TE','5134238828',0,'2013-12-26 04:34:13',NULL,NULL),(14555,9511,'TE','6143143000',0,'2013-12-26 04:35:24',NULL,NULL),(20934,13464,'EM','aquanut_99@yahoo.com',0,'2013-12-26 13:01:50',NULL,NULL),(3660,2323,'EM','codykwitt@gmail.com',0,'2013-12-25 19:31:28',NULL,NULL),(25485,16432,'AP','4196906956',0,'2014-01-07 04:04:51',NULL,NULL),(27133,17469,'TE','3306542611',0,'2014-01-13 03:01:07',NULL,NULL),(29033,18744,'EM','wchose@gmail.com',0,'2014-01-17 03:35:41',NULL,NULL),(29327,18951,'AP','8172336679',0,'2014-01-20 08:05:49',NULL,NULL),(30528,19801,'AP','9157313150',0,'2014-01-24 21:00:04',NULL,NULL),(33529,21980,'TE','3378520789',0,'2014-02-07 19:00:36',NULL,NULL),(33784,22175,'TE','4192709442',0,'2014-02-08 19:30:07',NULL,NULL),(34028,22316,'AP','5132135353',0,'2014-02-10 11:00:50',NULL,NULL),(34325,22521,'TE','5133171177',0,'2014-02-10 21:31:25',NULL,NULL),(35920,23635,'EM','texkat74@aol.com',0,'2014-02-14 21:30:05',NULL,NULL),(37542,24718,'TE','3308631538',0,'2014-02-20 04:37:34',NULL,NULL),(43292,28763,'TE','8322744185',0,'2014-03-09 21:00:24',NULL,NULL),(2301,1408,'EM','VINPRO1@AOL.COM',0,'2013-12-25 18:46:50',NULL,NULL),(11130,7235,'TE','2162125154',0,'2013-12-26 02:01:31',NULL,NULL),(11048,7173,'EM','Bryan.gase@gmail.com',0,'2013-12-26 01:52:47',NULL,NULL),(20308,13088,'TE','5135619743',0,'2013-12-26 12:51:48',NULL,NULL),(10814,7024,'TE','9363277933',0,'2013-12-26 01:48:56',NULL,NULL),(7483,4869,'AP','3187324338',0,'2013-12-25 22:30:58',NULL,NULL),(22040,14194,'TE','9159204064',0,'2013-12-27 02:04:05',NULL,NULL),(22354,14416,'TE','8322358299',0,'2013-12-28 03:31:35',NULL,NULL),(7988,5213,'TE','2163331172',0,'2013-12-25 23:04:21',NULL,NULL),(24643,15889,'AP','5133096913',0,'2014-01-03 02:05:42',NULL,NULL),(27862,17954,'TE','2105331337',0,'2014-01-15 02:06:43',NULL,NULL),(29270,18904,'TE','4192176527',0,'2014-01-17 03:36:37',NULL,NULL),(30476,19761,'AP','8145212594',0,'2014-01-23 21:01:24',NULL,NULL),(33427,21897,'EM','jmwidmer1@gmail.com',0,'2014-02-06 21:01:44',NULL,NULL),(36846,24264,'TE','4693162371',0,'2014-02-17 19:00:12',NULL,NULL),(38590,25502,'AP','9157814473',0,'2014-02-25 21:31:55',NULL,NULL),(38667,25554,'TE','9374445027',0,'2014-02-26 08:00:20',NULL,NULL),(42264,28070,'AP','3309748865',0,'2014-03-06 21:01:50',NULL,NULL),(43156,28682,'TE','3305032266',0,'2014-03-08 21:30:57',NULL,NULL),(43288,28759,'AP','9794923908',0,'2014-03-09 21:00:21',NULL,NULL),(43456,28858,'EM','kgilles7@live.com',0,'2014-03-09 21:30:02',NULL,NULL),(657,409,'AP','5044954260',0,'2013-12-25 17:46:22',NULL,NULL),(7635,4972,'EM','lopezanna12@yahoo.com',0,'2013-12-25 22:46:29',NULL,NULL),(25494,16438,'TE','3308631179',0,'2014-01-07 04:05:01',NULL,NULL),(12455,8156,'AP','3304142490',0,'2013-12-26 03:16:12',NULL,NULL),(4545,2891,'TE','3303477374',0,'2013-12-25 20:15:10',NULL,NULL),(2298,1407,'EM','kisha.calix@me.com',0,'2013-12-25 18:46:48',NULL,NULL),(5510,3526,'TE','5125858929',0,'2013-12-25 21:21:23',NULL,NULL),(28082,18098,'TE','3183873204',0,'2014-01-15 02:07:33',NULL,NULL),(30493,19780,'AP','4199137997',0,'2014-01-23 21:01:33',NULL,NULL),(31252,20356,'TE','2346787425',0,'2014-01-28 21:01:17',NULL,NULL),(34763,22795,'AP','2166452261',0,'2014-02-11 21:01:51',NULL,NULL),(40137,26620,'TE','9366624856',0,'2014-02-28 21:30:52',NULL,NULL),(25664,16547,'TE','4405033759',1,'2014-01-07 10:22:35',NULL,NULL),(8174,5346,'EM','lmthornton3@gmail.com',0,'2013-12-25 23:07:31',NULL,NULL),(7820,5105,'EM','robertwmelton@gmail.com',0,'2013-12-25 23:01:32',NULL,NULL),(1858,1148,'TE','2254853905',0,'2013-12-25 18:18:32',NULL,NULL),(7517,4898,'AP','4193082567',0,'2013-12-25 22:31:46',NULL,NULL),(6741,4377,'EM','datkins6@woh.rr.com',0,'2013-12-25 22:00:30',NULL,NULL),(8467,5572,'TE','9372588571',0,'2013-12-25 23:16:42',NULL,NULL),(9125,5976,'TE','3305750409',0,'2013-12-25 23:51:49',NULL,NULL),(25935,16709,'AP','2109000345',0,'2014-01-08 18:24:42',NULL,NULL),(9298,6090,'TE','9372743305',0,'2013-12-26 00:02:43',NULL,NULL),(9946,6509,'TE','3306066342',0,'2013-12-26 00:51:04',NULL,NULL),(32622,21328,'EM','glenmarie55@gmail.com',0,'2014-02-04 21:00:27',NULL,NULL),(36183,23815,'TE','3307494618',0,'2014-02-14 21:31:37',NULL,NULL),(11330,7379,'TE','4196922596',0,'2013-12-26 02:15:55',NULL,NULL),(22604,14577,'TE','5046214535',0,'2013-12-28 03:35:44',NULL,NULL),(7775,5072,'AP','2103732430',0,'2013-12-25 23:00:46',NULL,NULL),(9344,6117,'EM','andrea.davis90@gmail.com',0,'2013-12-26 00:15:39',NULL,NULL),(31819,20774,'AP','9035061841',0,'2014-01-31 21:00:06',NULL,NULL),(42470,28220,'TE','7402749338',0,'2014-03-06 21:30:19',NULL,NULL),(42709,28407,'EM','shannon@thehesketts.com',0,'2014-03-07 21:30:55',NULL,NULL),(9058,5940,'TE','9046108142',0,'2013-12-25 23:50:47',NULL,NULL),(31143,20284,'TE','5137530237',0,'2014-01-28 21:00:31',NULL,NULL),(29933,19372,'AP','3304164068',1,'2014-01-22 03:22:37',NULL,NULL),(10896,7080,'TE','7408512275',0,'2013-12-26 01:50:17',NULL,NULL),(34883,22890,'AP','5672772995',0,'2014-02-11 21:02:36',NULL,NULL),(38599,25506,'AP','3302248979',0,'2014-02-25 21:31:59',NULL,NULL),(7933,5171,'TE','3303577343',0,'2013-12-25 23:03:19',NULL,NULL),(24960,16086,'TE','9378793336',0,'2014-01-04 02:04:18',NULL,NULL),(24264,15682,'TE','4197695582',1,'2014-01-02 04:35:01',NULL,NULL),(856,534,'EM','zipdog98@hotmail.com',0,'2013-12-25 17:49:31',NULL,NULL),(21864,14084,'AP','4403710083',0,'2013-12-27 02:01:12',NULL,NULL),(3348,2105,'TE','5134854795',0,'2013-12-25 19:17:17',NULL,NULL),(14682,9608,'AP','3307156146',0,'2013-12-26 04:37:34',NULL,NULL),(40416,26827,'AP','2166095347',0,'2014-03-01 21:00:38',NULL,NULL),(42895,28527,'TE','3306370342',0,'2014-03-07 21:32:05',NULL,NULL),(24740,15963,'TE','7408358661',0,'2014-01-04 02:00:23',NULL,NULL),(28723,18536,'TE','4197050165',0,'2014-01-16 08:46:46',NULL,NULL),(27516,17726,'TE','5132755620',0,'2014-01-14 01:33:17',NULL,NULL),(34484,22624,'AP','3619042675',0,'2014-02-11 21:00:13',NULL,NULL),(35182,23107,'AP','4158191968',0,'2014-02-12 21:31:16',NULL,NULL),(39063,25838,'TE','4195600441',0,'2014-02-26 21:00:33',NULL,NULL),(40192,26659,'AP','3306061706',0,'2014-02-28 21:31:11',NULL,NULL),(41335,27459,'TE','3306686686',0,'2014-03-04 21:02:05',NULL,NULL),(42600,28342,'TE','4144917419',0,'2014-03-07 21:30:18',NULL,NULL),(20441,13163,'TE','2167510050',0,'2013-12-26 12:53:54',NULL,NULL),(473,298,'TE','7405073493',0,'2013-12-25 17:30:45',NULL,NULL),(26665,17155,'EM','obgogal@aol.com',0,'2014-01-13 02:21:59',NULL,NULL),(13783,8982,'AP','5137069339',0,'2013-12-26 04:04:23',NULL,NULL),(12100,7907,'AP','6018707411',0,'2013-12-26 03:05:59',NULL,NULL),(20841,13399,'AP','6142032660',0,'2013-12-26 13:00:18',NULL,NULL),(4505,2865,'EM','pucketbw@gmail.com',0,'2013-12-25 20:01:45',NULL,NULL),(39678,26236,'AP','9366618006',0,'2014-02-28 06:31:03',NULL,NULL),(42276,28077,'TE','7739549636',0,'2014-03-06 21:01:55',NULL,NULL),(516,324,'AP','4194388694',0,'2013-12-25 17:31:27',NULL,NULL),(2564,1565,'AP','9366155172',0,'2013-12-25 18:51:02',NULL,NULL),(31116,20260,'TE','9377185796',0,'2014-01-28 21:00:18',NULL,NULL),(22932,14796,'EM','kaufmash@mail.uc.edu',1,'2013-12-29 11:13:37',NULL,NULL),(29107,18794,'AP','6148862076',0,'2014-01-17 03:35:58',NULL,NULL),(26083,16799,'AP','9155889727',0,'2014-01-13 02:18:10',NULL,NULL),(36361,23945,'AP','5042567369',0,'2014-02-15 21:00:12',NULL,NULL),(39796,26311,'TE','9562813392',0,'2014-02-28 06:31:33',NULL,NULL),(41426,27523,'TE','5135352443',0,'2014-03-04 21:02:41',NULL,NULL),(11102,7210,'AP','6145378624',0,'2013-12-26 02:00:55',NULL,NULL),(5705,3662,'EM','kimgrier22@yahoo.com',0,'2013-12-25 21:30:55',NULL,NULL),(28885,18650,'TE','5129654306',0,'2014-01-17 03:35:09',NULL,NULL),(3629,2294,'TE','5132604190',0,'2013-12-25 19:30:52',NULL,NULL),(7383,4804,'AP','3185279761',0,'2013-12-25 22:16:35',NULL,NULL),(25292,16308,'AP','3182823142',0,'2014-01-07 04:01:21',NULL,NULL),(25085,16173,'AP','2253615221',0,'2014-01-05 00:00:18',NULL,NULL),(2304,1409,'TE','6508681737',0,'2013-12-25 18:46:52',NULL,NULL),(43481,28875,'AP','9726797612',0,'2014-03-10 21:00:05',NULL,NULL),(11551,7519,'TE','5042289119',0,'2013-12-26 02:32:19',NULL,NULL),(5192,3336,'TE','4402882777',0,'2013-12-25 21:16:22',NULL,NULL),(26341,16955,'TE','9376380844',0,'2014-01-13 02:20:03',NULL,NULL),(4090,2609,'AP','2163396529',0,'2013-12-25 19:45:33',NULL,NULL),(23921,15434,'AP','3615711051',1,'2014-01-02 04:27:51',NULL,NULL),(20981,13504,'AP','2259361579',0,'2013-12-26 13:02:41',NULL,NULL),(9584,6275,'EM','regina.alino97@gmail.com',0,'2013-12-26 00:45:13',NULL,NULL),(3832,2438,'TE','3305947027',0,'2013-12-25 19:34:22',NULL,NULL),(4056,2588,'TE','9375882306',0,'2013-12-25 19:38:13',NULL,NULL),(32881,21520,'TE','6622300938',0,'2014-02-05 21:00:06',NULL,NULL),(34323,22520,'TE','9374662453',0,'2014-02-10 21:31:24',NULL,NULL),(35610,23416,'AP','3613188102',0,'2014-02-13 22:01:19',NULL,NULL),(38848,25681,'TE','9375411816',0,'2014-02-26 09:30:04',NULL,NULL),(42593,28338,'EM','joebryce@hotmail.com',0,'2014-03-07 21:30:15',NULL,NULL),(11886,7735,'TE','4198891268',0,'2013-12-26 03:02:07',NULL,NULL),(1471,902,'TE','6623949447',0,'2013-12-25 18:08:18',NULL,NULL),(2958,1829,'TE','4199727109',0,'2013-12-25 18:57:23',NULL,NULL),(23563,15207,'AP','6013659885',0,'2014-01-01 12:07:36',NULL,NULL),(21331,13705,'TE','3303274776',0,'2013-12-26 13:08:48',NULL,NULL),(20591,13245,'TE','4636586402',0,'2013-12-26 12:56:14',NULL,NULL),(4573,2918,'TE','5136009701',0,'2013-12-25 20:15:43',NULL,NULL),(6964,4541,'AP','9562512028',0,'2013-12-25 22:04:18',NULL,NULL),(4957,3181,'AP','3185078376',0,'2013-12-25 20:31:52',NULL,NULL),(37204,24487,'AP','2252847130',0,'2014-02-20 03:42:58',NULL,NULL),(14241,9317,'TE','5055042988',0,'2013-12-26 04:30:25',NULL,NULL),(25915,16701,'AP','9152521048',0,'2014-01-08 18:24:39',NULL,NULL),(6309,4065,'EM','lindavuotto@yahoo.com',0,'2013-12-25 21:46:47',NULL,NULL),(22745,14669,'TE','8307731446',1,'2013-12-29 11:08:12',NULL,NULL),(4718,3020,'AP','3302892352',0,'2013-12-25 20:18:08',NULL,NULL),(36237,23850,'TE','9193444197',0,'2014-02-14 21:31:58',NULL,NULL),(40751,27082,'TE','3306344893',0,'2014-03-03 21:30:12',NULL,NULL),(41995,27912,'TE','9036872357',0,'2014-03-06 21:00:16',NULL,NULL),(13851,9032,'AP','3306054272',0,'2013-12-26 04:05:36',NULL,NULL),(32184,21021,'EM','Cgott@mac.com',0,'2014-02-01 19:00:40',NULL,NULL),(31802,20760,'AP','4196027888',0,'2014-01-30 21:01:34',NULL,NULL),(27389,17629,'EM','JS.CHAPMAN@VERISON.NET',0,'2014-01-14 01:32:32',NULL,NULL),(23994,15488,'TE','9377980337',1,'2014-01-02 04:29:24',NULL,NULL),(2127,1311,'TE','6145848804',0,'2013-12-25 18:31:29',NULL,NULL),(2593,1582,'AP','9154720358',0,'2013-12-25 18:51:28',NULL,NULL),(13682,8921,'TE','9377188511',0,'2013-12-26 04:02:47',NULL,NULL),(3849,2449,'TE','2814995631',0,'2013-12-25 19:34:38',NULL,NULL),(20780,13354,'AP','2107765181',0,'2013-12-26 12:59:17',NULL,NULL),(36471,24012,'TE','5135831498',0,'2014-02-15 22:00:41',NULL,NULL),(42744,28430,'AP','3307943247',0,'2014-03-07 21:31:08',NULL,NULL),(43057,28626,'EM','BLUBERRIKISSEZ@GMAIL.COM',0,'2014-03-08 21:30:24',NULL,NULL),(8479,5578,'AP','4194389189',0,'2013-12-25 23:16:53',NULL,NULL),(7613,4959,'EM','daniel.melia@mail.com',0,'2013-12-25 22:46:08',NULL,NULL),(22867,14755,'EM','lgibson7@frontier.com',1,'2013-12-29 11:10:26',NULL,NULL),(4232,2706,'AP','4325178236',0,'2013-12-25 19:47:52',NULL,NULL),(30713,19953,'TE','5042749759',0,'2014-01-25 19:00:04',NULL,NULL),(24884,16044,'AP','5124660341',0,'2014-01-04 02:02:58',NULL,NULL),(23090,14891,'EM','jmsmith6773@gmail.com',0,'2013-12-30 00:00:48',NULL,NULL),(33598,22027,'AP','4197883466',0,'2014-02-07 19:01:01',NULL,NULL),(40712,27053,'TE','9376630352',0,'2014-03-03 21:00:26',NULL,NULL),(8639,5674,'AP','4404291242',0,'2013-12-25 23:32:08',NULL,NULL),(10515,6848,'TE','9564590067',0,'2013-12-26 01:31:19',NULL,NULL),(27198,17514,'EM','rwmitchelljr@att.net',0,'2014-01-13 03:01:32',NULL,NULL),(10159,6640,'TE','8063535731',0,'2013-12-26 01:00:18',NULL,NULL),(7201,4691,'AP','9375649179',0,'2013-12-25 22:08:11',NULL,NULL),(34513,22638,'TE','6823235009',0,'2014-02-11 21:00:21',NULL,NULL),(42983,28589,'TE','7408216018',0,'2014-03-08 21:30:01',NULL,NULL),(14265,9331,'AP','5134048598',0,'2013-12-26 04:30:45',NULL,NULL),(5477,3506,'TE','3302895231',0,'2013-12-25 21:20:51',NULL,NULL),(4815,3080,'EM','johnrorty@gmail.com',0,'2013-12-25 20:19:43',NULL,NULL),(28319,18253,'TE','8327589468',0,'2014-01-16 08:44:32',NULL,NULL),(28026,18061,'AP','5132545871',0,'2014-01-15 02:07:21',NULL,NULL),(26086,16800,'AP','2148753355',0,'2014-01-13 02:18:11',NULL,NULL),(4818,3085,'EM','mos_eisly0023@yahoo.com',0,'2013-12-25 20:19:49',NULL,NULL),(36534,24053,'TE','5133210167',0,'2014-02-15 22:01:06',NULL,NULL),(38019,25079,'EM','kcorne.oh@gmail.com',0,'2014-02-20 22:01:37',NULL,NULL),(38870,25693,'TE','4323495431',0,'2014-02-26 09:30:13',NULL,NULL),(39867,26374,'AP','9374083552',0,'2014-02-28 07:00:15',NULL,NULL),(21279,13671,'EM','kat.mcconnell@gmail.com',0,'2013-12-26 13:07:56',NULL,NULL),(27644,17820,'TE','6625412547',0,'2014-01-15 02:05:56',NULL,NULL),(24665,15904,'TE','4192046204',0,'2014-01-03 02:06:10',NULL,NULL),(20876,13421,'AP','6143077577',0,'2013-12-26 13:00:50',NULL,NULL),(22076,14219,'TE','9406344795',0,'2013-12-27 02:04:41',NULL,NULL),(2544,1556,'TE','6014333066',0,'2013-12-25 18:50:45',NULL,NULL),(3433,2155,'TE','2144910148',0,'2013-12-25 19:18:41',NULL,NULL),(21445,13785,'AP','6014106774',0,'2013-12-26 13:10:53',NULL,NULL),(7718,5040,'TE','6019239602',0,'2013-12-25 22:47:59',NULL,NULL),(14971,9794,'AP','3616589033',0,'2013-12-26 05:01:04',NULL,NULL),(14439,9435,'AP','5132215451',0,'2013-12-26 04:33:32',NULL,NULL),(5697,3657,'AP','9377280525',0,'2013-12-25 21:30:48',NULL,NULL),(33942,22273,'EM','drscraze@gmail.com',0,'2014-02-10 11:00:16',NULL,NULL),(9301,6091,'EM','tonyschalk8@gmail.com',0,'2013-12-26 00:02:46',NULL,NULL),(32410,21178,'AP','4193038068',0,'2014-02-03 21:00:41',NULL,NULL),(30689,19935,'AP','4198102000',0,'2014-01-24 21:01:11',NULL,NULL),(28177,18163,'TE','9377283222',0,'2014-01-15 02:07:55',NULL,NULL),(10589,6891,'TE','3189256095',0,'2013-12-26 01:45:22',NULL,NULL),(2665,1617,'AP','4329430103',0,'2013-12-25 18:52:30',NULL,NULL),(10335,6739,'AP','3304006036',0,'2013-12-26 01:15:44',NULL,NULL),(22055,14204,'TE','9035707954',0,'2013-12-27 02:04:20',NULL,NULL),(978,601,'AP','5135467371',0,'2013-12-25 18:00:20',NULL,NULL),(32780,21444,'EM','bevans326@sbcglobal.net',0,'2014-02-04 21:01:26',NULL,NULL),(27514,17725,'AP','5134850468',0,'2014-01-14 01:33:16',NULL,NULL),(1262,766,'EM','and@aciglobal.com',0,'2013-12-25 18:04:42',NULL,NULL),(8409,5538,'TE','7402290543',0,'2013-12-25 23:15:43',NULL,NULL),(24680,15916,'AP','9564596948',0,'2014-01-03 02:06:30',NULL,NULL),(4551,2896,'AP','3303522477',0,'2013-12-25 20:15:16',NULL,NULL),(8299,5437,'TE','2255713654',0,'2013-12-25 23:09:50',NULL,NULL),(5190,3332,'TE','4402882777',0,'2013-12-25 21:16:20',NULL,NULL),(33532,21981,'AP','5044500034',0,'2014-02-07 19:00:37',NULL,NULL),(38831,25668,'AP','6018268218',0,'2014-02-26 08:30:50',NULL,NULL),(39762,26294,'EM','jphillips001@defiance.edu',0,'2014-02-28 06:31:25',NULL,NULL),(42894,28526,'EM','ericdelung@gmail.com',0,'2014-03-07 21:32:04',NULL,NULL),(43472,28871,'TE','9155401293',0,'2014-03-10 21:00:02',NULL,NULL),(43552,28920,'TE','4196366855',0,'2014-03-10 21:00:31',NULL,NULL),(43780,29062,'TE','4193205074',0,'2014-03-10 21:01:53',NULL,NULL),(960,591,'EM','bretpalmer73@yahoo.com',0,'2013-12-25 18:00:04',NULL,NULL),(1576,972,'AP','2255053149',0,'2013-12-25 18:10:03',NULL,NULL),(29546,19095,'TE','9372101703',0,'2014-01-21 08:44:35',NULL,NULL),(25949,16715,'AP','3605163721',0,'2014-01-08 18:24:44',NULL,NULL),(6254,4033,'TE','9374292995',0,'2013-12-25 21:45:57',NULL,NULL),(11766,7657,'TE','2257542041',0,'2013-12-26 03:00:10',NULL,NULL),(43883,29118,'TE','6013833541',0,'2014-03-10 21:02:28',NULL,NULL),(21851,14073,'AP','2163241021',0,'2013-12-27 02:00:56',NULL,NULL),(10568,6880,'TE','5048754906',0,'2013-12-26 01:45:03',NULL,NULL),(29480,19055,'AP','6629027186',0,'2014-01-21 08:44:11',NULL,NULL),(27769,17904,'TE','8173600815',0,'2014-01-15 02:06:24',NULL,NULL),(26817,17247,'EM','Mylisalynn@msn.com',0,'2014-01-13 02:23:10',NULL,NULL),(27045,17392,'BN','9375366406',0,'2014-01-13 03:00:12',NULL,NULL),(30823,20040,'TE','2165775359',0,'2014-01-26 19:00:26',NULL,NULL),(34439,22593,'AP','3306961814',0,'2014-02-10 21:32:11',NULL,NULL),(39521,26141,'TE','6143576273',0,'2014-02-28 06:30:25',NULL,NULL),(40009,26504,'EM','Tim@sentrygroup1.com',0,'2014-02-28 21:00:16',NULL,NULL),(43400,28822,'AP','4198069427',0,'2014-03-09 21:01:01',NULL,NULL),(8751,5736,'EM','mbatterman@wanadoo.fr',0,'2013-12-25 23:45:50',NULL,NULL),(28930,18678,'TE','9563133994',0,'2014-01-17 03:35:19',NULL,NULL),(10209,6671,'EM','scarlatti35@hotmail.com',0,'2013-12-26 01:01:07',NULL,NULL),(9867,6452,'TE','2164702366',0,'2013-12-26 00:49:42',NULL,NULL),(1575,972,'TE','2255053149',0,'2013-12-25 18:10:03',NULL,NULL),(4231,2706,'TE','4325178236',0,'2013-12-25 19:47:51',NULL,NULL),(23240,14975,'TE','8326855527',0,'2014-01-01 12:00:57',NULL,NULL),(3997,2539,'EM','rps3iii@yahoo.com',0,'2013-12-25 19:37:00',NULL,NULL),(38554,25474,'EM','jeffrollfing@gmail.com',0,'2014-02-25 21:31:39',NULL,NULL),(39946,26440,'TE','6149612324',0,'2014-02-28 07:30:20',NULL,NULL),(7893,5143,'TE','9374370333',0,'2013-12-25 23:02:36',NULL,NULL),(21404,13762,'TE','2282977077',0,'2013-12-26 13:10:16',NULL,NULL),(11873,7728,'EM','rbkb7252@yahoo.com',0,'2013-12-26 03:01:56',NULL,NULL),(4188,2679,'EM','art.gray09@gmail.com',0,'2013-12-25 19:47:11',NULL,NULL),(27189,17510,'AP','3303736622',0,'2014-01-13 03:01:29',NULL,NULL),(3692,2341,'AP','9794531775',0,'2013-12-25 19:31:58',NULL,NULL),(22863,14754,'TE','3309803868',1,'2013-12-29 11:10:23',NULL,NULL),(5079,3261,'TE','5042370407',0,'2013-12-25 20:46:53',NULL,NULL),(34434,22590,'TE','2487051007',0,'2014-02-10 21:32:09',NULL,NULL),(39413,26060,'AP','5136338288',0,'2014-02-26 21:02:39',NULL,NULL),(42173,28014,'EM','brouillard.sarah@yahoo.com',0,'2014-03-06 21:01:17',NULL,NULL),(43206,28712,'TE','6019907276',0,'2014-03-08 21:31:15',NULL,NULL),(7564,4925,'EM','lilliecistrunk@yahoo.com',0,'2013-12-25 22:45:16',NULL,NULL),(584,360,'EM','lori.hendrix.rn@gmail.com',0,'2013-12-25 17:45:09',NULL,NULL),(28811,18597,'TE','5137374514',0,'2014-01-16 08:47:16',NULL,NULL),(27925,17991,'EM','sheilacaynor@yahoo.com',0,'2014-01-15 02:06:57',NULL,NULL),(27232,17531,'TE','6015739039',0,'2014-01-13 03:01:43',NULL,NULL),(1086,668,'TE','6148559209',0,'2013-12-25 18:02:04',NULL,NULL),(23904,15419,'TE','8306442040',1,'2014-01-02 04:27:26',NULL,NULL),(36894,24299,'TE','4093774360',0,'2014-02-18 21:30:18',NULL,NULL),(8593,5646,'EM','minus_three@yahoo.com',0,'2013-12-25 23:31:23',NULL,NULL),(31004,20169,'AP','3307306366',0,'2014-01-27 21:01:14',NULL,NULL),(30410,19710,'TE','8309804626',0,'2014-01-23 21:00:52',NULL,NULL),(6985,4561,'TE','3306399797',0,'2013-12-25 22:04:42',NULL,NULL),(26604,17113,'TE','4199669051',0,'2014-01-13 02:21:39',NULL,NULL),(26515,17060,'AP','9722684710',0,'2014-01-13 02:21:11',NULL,NULL),(6548,4233,'TE','7134338274',0,'2013-12-25 21:50:46',NULL,NULL),(24349,15726,'EM','ptakach@earthlink.net',0,'2014-01-03 02:00:20',NULL,NULL),(5988,3847,'AP','2259104902',0,'2013-12-25 21:35:32',NULL,NULL),(12218,7983,'EM','bbrown8006@yahoo.com',0,'2013-12-26 03:08:02',NULL,NULL),(36950,24334,'AP','5129939862',0,'2014-02-18 22:00:15',NULL,NULL),(37584,24761,'TE','9377257737',0,'2014-02-20 04:42:55',NULL,NULL),(41993,27911,'TE','8179968665',0,'2014-03-06 21:00:15',NULL,NULL),(42376,28143,'TE','4194100452',0,'2014-03-06 21:02:32',NULL,NULL),(9147,5992,'AP','4194870088',0,'2013-12-26 00:00:06',NULL,NULL),(5140,3295,'TE','9546106909',0,'2013-12-25 21:15:35',NULL,NULL),(22810,14707,'TE','4196427405',1,'2013-12-29 11:09:15',NULL,NULL),(27847,17940,'TE','2146072158',0,'2014-01-15 02:06:39',NULL,NULL),(34224,22446,'EM','lotterin29@yahoo.com',0,'2014-02-10 21:30:45',NULL,NULL),(36130,23778,'TE','6624549469',0,'2014-02-14 21:31:18',NULL,NULL),(36912,24311,'TE','9858578594',0,'2014-02-18 21:30:25',NULL,NULL),(41135,27322,'TE','4098830424',0,'2014-03-04 21:00:47',NULL,NULL),(43070,28635,'TE','5129430953',0,'2014-03-08 21:30:29',NULL,NULL),(22378,14434,'AP','2256202343',0,'2013-12-28 03:32:01',NULL,NULL),(1373,835,'EM','j.kuhn@caringpartners.org',0,'2013-12-25 18:06:29',NULL,NULL),(22766,14679,'AP','6014474662',1,'2013-12-29 11:08:30',NULL,NULL),(24708,15938,'AP','5132477077',0,'2014-01-03 02:07:09',NULL,NULL),(27134,17469,'EM','asaxton@neo.rr.com',0,'2014-01-13 03:01:07',NULL,NULL),(33912,22259,'AP','9567935448',0,'2014-02-10 11:00:06',NULL,NULL),(36474,24013,'AP','6142308984',0,'2014-02-15 22:00:42',NULL,NULL),(42285,28080,'AP','2104122170',0,'2014-03-06 21:01:57',NULL,NULL),(14053,9182,'AP','4198893730',0,'2013-12-26 04:09:13',NULL,NULL),(10158,6639,'TE','2167218311',0,'2013-12-26 01:00:16',NULL,NULL),(10692,6949,'TE','5136179586',0,'2013-12-26 01:47:00',NULL,NULL),(3001,1856,'TE','5132717375',0,'2013-12-25 18:58:04',NULL,NULL),(1476,904,'AP','5133071859',0,'2013-12-25 18:08:22',NULL,NULL),(2105,1301,'TE','8504509501',0,'2013-12-25 18:31:11',NULL,NULL),(31154,20290,'TE','3186403313',0,'2014-01-28 21:00:35',NULL,NULL),(32549,21280,'TE','4193502622',0,'2014-02-03 21:01:37',NULL,NULL),(35579,23396,'TE','2165095550',0,'2014-02-13 22:01:09',NULL,NULL),(36099,23745,'EM','midambafatuma@gmail.com',0,'2014-02-14 21:31:05',NULL,NULL),(42975,28579,'TE','9795430233',0,'2014-03-08 21:00:06',NULL,NULL),(9010,5913,'TE','9036132215',0,'2013-12-25 23:50:05',NULL,NULL),(32451,21203,'AP','3182303950',0,'2014-02-03 21:00:54',NULL,NULL),(32633,21343,'TE','8308963511',0,'2014-02-04 21:00:34',NULL,NULL),(39351,26028,'AP','6015732290',0,'2014-02-26 21:02:20',NULL,NULL),(39669,26229,'AP','7136144412',0,'2014-02-28 06:31:00',NULL,NULL),(42120,27981,'EM','heatherhutto938@yahoo.com',0,'2014-03-06 21:00:57',NULL,NULL),(11754,7650,'EM','josephinecaceres@gmail.com',0,'2013-12-26 02:46:51',NULL,NULL),(9742,6372,'AP','4193072572',0,'2013-12-26 00:47:41',NULL,NULL),(6529,4222,'TE','2813672041',0,'2013-12-25 21:50:28',NULL,NULL),(27215,17524,'TE','4192282006',0,'2014-01-13 03:01:38',NULL,NULL),(3114,1941,'AP','6144218823',0,'2013-12-25 19:00:41',NULL,NULL),(22990,14829,'AP','6019463857',1,'2013-12-29 11:14:32',NULL,NULL),(21467,13795,'TE','6622549682',0,'2013-12-26 13:11:12',NULL,NULL),(4059,2591,'TE','3304259302',0,'2013-12-25 19:45:05',NULL,NULL),(33512,21965,'TE','9377070358',0,'2014-02-07 19:00:28',NULL,NULL),(34393,22559,'EM','evensont@gmail.com',0,'2014-02-10 21:31:50',NULL,NULL),(41706,27734,'TE','9156916275',0,'2014-03-05 21:31:05',NULL,NULL),(41755,27765,'AP','5043191593',0,'2014-03-05 21:31:23',NULL,NULL),(14521,9487,'EM','djdermody@gmail.com',0,'2013-12-26 04:34:49',NULL,NULL),(29009,18725,'AP','7038510380',0,'2014-01-17 03:35:36',NULL,NULL),(28699,18519,'AP','2144407097',0,'2014-01-16 08:46:37',NULL,NULL),(27743,17886,'TE','5134274314',0,'2014-01-15 02:06:18',NULL,NULL),(27541,17749,'AP','3302566114',0,'2014-01-14 01:33:27',NULL,NULL),(26403,16992,'EM','mcmglassmaker@gmail.com',0,'2014-01-13 02:20:26',NULL,NULL),(24724,15949,'AP','4406702017',0,'2014-01-04 02:00:04',NULL,NULL),(5371,3439,'TE','2259329275',0,'2013-12-25 21:19:10',NULL,NULL),(3821,2431,'TE','3306285966',0,'2013-12-25 19:34:11',NULL,NULL),(37869,24981,'EM','MMGUERRA50@YAHOO.COM',0,'2014-02-20 22:00:34',NULL,NULL),(40379,26804,'TE','6142123039',0,'2014-03-01 21:00:24',NULL,NULL),(1170,718,'EM','j.maryhelen@yahoo.com',0,'2013-12-25 18:03:23',NULL,NULL),(11208,7287,'EM','desperadoranch@frontier.com',0,'2013-12-26 02:02:51',NULL,NULL),(9111,5971,'AP','6625498065',0,'2013-12-25 23:51:38',NULL,NULL),(28007,18051,'TE','2285963919',0,'2014-01-15 02:07:17',NULL,NULL),(33236,21764,'TE','8322770625',0,'2014-02-06 21:00:28',NULL,NULL),(38251,25254,'AP','3304103651',0,'2014-02-21 22:01:16',NULL,NULL),(11531,7505,'AP','5132568354',0,'2013-12-26 02:31:57',NULL,NULL),(29162,18840,'TE','3304141852',0,'2014-01-17 03:36:13',NULL,NULL),(22492,14502,'TE','4324136216',0,'2013-12-28 03:33:49',NULL,NULL),(5053,3244,'TE','9378371734',0,'2013-12-25 20:46:26',NULL,NULL),(39407,26056,'EM','cassiecsw@yahoo.com',0,'2014-02-26 21:02:37',NULL,NULL),(1307,797,'EM','bilindra@yahoo.com',0,'2013-12-25 18:05:28',NULL,NULL),(14129,9255,'TE','9153738545',0,'2013-12-26 04:15:07',NULL,NULL),(3585,2246,'TE','3308981085',0,'2013-12-25 19:21:09',NULL,NULL),(6625,4279,'EM','lanceghostetler@gmail.com',0,'2013-12-25 21:51:59',NULL,NULL),(26761,17216,'TE','6013234917',0,'2014-01-13 02:22:31',NULL,NULL),(32750,21427,'TE','5134001071',0,'2014-02-04 21:01:16',NULL,NULL),(34303,22509,'EM','cam6113@yahoo.com',0,'2014-02-10 21:31:17',NULL,NULL),(34933,22924,'EM','carrie@cmossphoto.com',0,'2014-02-11 21:30:05',NULL,NULL),(35161,23094,'AP','5136756931',0,'2014-02-12 21:31:08',NULL,NULL),(36636,24117,'EM','whiteheadwork@gmail.com',0,'2014-02-15 22:01:40',NULL,NULL),(37512,24704,'AP','6143269323',0,'2014-02-20 04:34:48',NULL,NULL),(38652,25544,'EM','atoth@maschecks.com',0,'2014-02-26 08:00:14',NULL,NULL),(38794,25649,'AP','9372180946',0,'2014-02-26 08:30:37',NULL,NULL),(42580,28333,'AP','2543382438',0,'2014-03-07 21:30:11',NULL,NULL),(20288,13078,'TE','7404225004',0,'2013-12-26 12:51:30',NULL,NULL),(10446,6807,'AP','8066761585',0,'2013-12-26 01:30:12',NULL,NULL),(29234,18881,'TE','3187192946',0,'2014-01-17 03:36:28',NULL,NULL),(9588,6277,'TE','3309584979',0,'2013-12-26 00:45:17',NULL,NULL),(8995,5905,'TE','5132950299',0,'2013-12-25 23:49:52',NULL,NULL),(4504,2865,'AP','6149409656',0,'2013-12-25 20:01:45',NULL,NULL),(1659,1018,'AP','6019535437',0,'2013-12-25 18:15:11',NULL,NULL),(21366,13739,'TE','3306582060',0,'2013-12-26 13:09:37',NULL,NULL),(32693,21383,'TE','4407816057',0,'2014-02-04 21:00:54',NULL,NULL),(35830,23563,'TE','4192302707',0,'2014-02-13 22:02:45',NULL,NULL),(35886,23600,'BN','4195411705',0,'2014-02-13 22:03:08',NULL,NULL),(7700,5023,'AP','9372160064',0,'2013-12-25 22:47:37',NULL,NULL),(29713,19210,'EM','ptricksmith1965@gmail.com',0,'2014-01-21 08:46:21',NULL,NULL),(20677,13296,'TE','9035274280',0,'2013-12-26 12:57:37',NULL,NULL),(28629,18456,'EM','vijjones09@yahoo.com',0,'2014-01-16 08:46:10',NULL,NULL),(32210,21036,'EM','chriswatson777@hotmail.com',0,'2014-02-01 19:00:48',NULL,NULL),(41182,27351,'AP','3306061382',0,'2014-03-04 21:01:05',NULL,NULL),(43555,28924,'EM','matt@mosaiccincinnati.com',0,'2014-03-10 21:00:33',NULL,NULL),(6705,4360,'TE','4194781723',0,'2013-12-25 21:53:44',NULL,NULL),(31269,20369,'TE','3182494574',0,'2014-01-29 21:00:05',NULL,NULL),(30748,19979,'TE','3307845130',0,'2014-01-25 19:00:15',NULL,NULL),(22637,14596,'EM','askoblar@aol.com',0,'2013-12-28 03:36:16',NULL,NULL),(26769,17222,'AP','4193760043',0,'2014-01-13 02:22:34',NULL,NULL),(25913,16699,'AP','8303250495',0,'2014-01-08 18:24:38',NULL,NULL),(24421,15765,'EM','lawrentos3@yahoo.com',0,'2014-01-03 02:01:39',NULL,NULL),(33900,22252,'AP','4193664944',0,'2014-02-09 19:00:43',NULL,NULL),(39989,26483,'EM','rahgirl@gmail.com',0,'2014-02-28 21:00:05',NULL,NULL),(8105,5306,'AP','9018329167',0,'2013-12-25 23:06:27',NULL,NULL),(29554,19098,'TE','2252400482',0,'2014-01-21 08:44:37',NULL,NULL),(11699,7616,'EM','looneytoonhouse@aol.com',0,'2013-12-26 02:45:48',NULL,NULL),(2996,1853,'AP','5136386595',0,'2013-12-25 18:57:59',NULL,NULL),(9810,6419,'EM','sapatter4@yahoo.com',0,'2013-12-26 00:48:51',NULL,NULL),(36035,23702,'EM','mlbridgeford@fuse.net',0,'2014-02-14 21:30:43',NULL,NULL),(14407,9421,'TE','9366713264',0,'2013-12-26 04:33:06',NULL,NULL),(31538,20552,'EM','MATTHEW.C.TRENT@GMAIL.COM',0,'2014-01-29 21:01:42',NULL,NULL),(30109,19504,'AP','9368993184',0,'2014-01-23 03:02:12',NULL,NULL),(6767,4391,'AP','4405033511',0,'2013-12-25 22:00:54',NULL,NULL),(21621,13915,'TE','4192920206',0,'2013-12-26 13:14:05',NULL,NULL),(6020,3864,'TE','9855268749',0,'2013-12-25 21:36:02',NULL,NULL),(36328,23927,'TE','3303522477',0,'2014-02-14 22:00:09',NULL,NULL),(42359,28134,'TE','3306886052',0,'2014-03-06 21:02:26',NULL,NULL),(43568,28933,'EM','pjnovel@aol.com',0,'2014-03-10 21:00:38',NULL,NULL),(20246,13041,'EM','foluaong@yahoo.com',0,'2013-12-26 12:50:39',NULL,NULL),(28459,18339,'TE','3303190742',0,'2014-01-16 08:45:16',NULL,NULL),(14549,9506,'AP','3304145743',0,'2013-12-26 04:35:16',NULL,NULL),(23567,15213,'EM','eric.biggs1@yahoo.com',0,'2014-01-01 12:07:47',NULL,NULL),(3826,2433,'EM','markgiorgianni@gmail.com',0,'2013-12-25 19:34:14',NULL,NULL),(3835,2440,'EM','pamsrebernak@rocketmail.com',0,'2013-12-25 19:34:25',NULL,NULL),(5368,3437,'AP','9857074021',0,'2013-12-25 21:19:07',NULL,NULL),(38377,25349,'TE','9852509169',0,'2014-02-25 21:30:30',NULL,NULL),(42969,28575,'TE','8307733161',0,'2014-03-08 21:00:04',NULL,NULL),(5941,3809,'AP','5672318709',0,'2013-12-25 21:34:43',NULL,NULL),(30141,19531,'AP','6146324487',0,'2014-01-23 03:02:21',NULL,NULL),(2129,1312,'TE','2169044153',0,'2013-12-25 18:31:31',NULL,NULL),(26763,17217,'TE','6018546318',0,'2014-01-13 02:22:32',NULL,NULL),(23139,14919,'AP','2346000651',0,'2013-12-30 00:01:37',NULL,NULL),(7338,4770,'EM','Mas4u88@hotmail.com',0,'2013-12-25 22:15:48',NULL,NULL),(5461,3497,'EM','Terry_Moore@NetZero.Net',0,'2013-12-25 21:20:36',NULL,NULL),(33944,22275,'TE','3614919579',0,'2014-02-10 11:00:17',NULL,NULL),(35106,23058,'TE','2252904706',0,'2014-02-12 21:30:50',NULL,NULL),(9374,6135,'EM','pdalafayette@pdaorg.net',0,'2013-12-26 00:16:07',NULL,NULL),(29617,19134,'AP','4326348167',0,'2014-01-21 08:45:26',NULL,NULL),(23900,15417,'EM','EMBLARA@YAHOO.COM',1,'2014-01-02 04:27:21',NULL,NULL),(23713,15304,'TE','3379671870',1,'2014-01-02 04:22:57',NULL,NULL),(23365,15052,'TE','5043481594',0,'2014-01-01 12:03:17',NULL,NULL),(20728,13322,'AP','8323686829',0,'2013-12-26 12:58:24',NULL,NULL),(2901,1780,'AP','4193412181',0,'2013-12-25 18:56:18',NULL,NULL),(39291,25995,'AP','6627010138',0,'2014-02-26 21:01:59',NULL,NULL),(41905,27863,'AP','2163467860',0,'2014-03-05 21:32:20',NULL,NULL),(14942,9775,'TE','5044914112',0,'2013-12-26 05:00:35',NULL,NULL),(26736,17196,'TE','2255452515',0,'2014-01-13 02:22:21',NULL,NULL),(12421,8135,'TE','4124822916',0,'2013-12-26 03:15:39',NULL,NULL),(34617,22697,'TE','2144353138',0,'2014-02-11 21:00:57',NULL,NULL),(35028,23001,'TE','3304945859',0,'2014-02-12 21:30:19',NULL,NULL),(35247,23150,'TE','4403464172',0,'2014-02-12 21:31:41',NULL,NULL),(37616,24790,'AP','5139811813',0,'2014-02-20 04:46:55',NULL,NULL),(42705,28406,'TE','6147253582',0,'2014-03-07 21:30:54',NULL,NULL),(20755,13339,'AP','9158203903',0,'2013-12-26 12:58:51',NULL,NULL),(1664,1022,'TE','3302995284',0,'2013-12-25 18:15:17',NULL,NULL),(30584,19843,'TE','2254442948',0,'2014-01-24 21:00:27',NULL,NULL),(6291,4054,'AP','5133280590',0,'2013-12-25 21:46:30',NULL,NULL),(26971,17347,'TE','5136154487',0,'2014-01-13 02:24:06',NULL,NULL),(12073,7882,'TE','4408455597',0,'2013-12-26 03:05:27',NULL,NULL),(24277,15687,'AP','5133447207',1,'2014-01-02 04:35:14',NULL,NULL),(11508,7489,'TE','7408292268',0,'2013-12-26 02:31:34',NULL,NULL),(32534,21270,'AP','8064412459',0,'2014-02-03 21:01:30',NULL,NULL),(33835,22214,'TE','4232550448',0,'2014-02-09 19:00:22',NULL,NULL),(34585,22677,'TE','8323124190',0,'2014-02-11 21:00:45',NULL,NULL),(36217,23838,'AP','5133167999',0,'2014-02-14 21:31:50',NULL,NULL),(37573,24753,'EM','TONIK81@YAHOO.COM',0,'2014-02-20 04:41:40',NULL,NULL),(38394,25364,'EM','nathanmelissa@yahoo.com',0,'2014-02-25 21:30:38',NULL,NULL),(40695,27031,'EM','TRESRANAS7@GMAIL.COM',0,'2014-03-03 21:00:17',NULL,NULL),(821,511,'EM','Jennifer.hathaway2002@gmail.com',0,'2013-12-25 17:48:57',NULL,NULL),(3490,2183,'EM','gmvahalik@hotmail.com',0,'2013-12-25 19:19:30',NULL,NULL),(4677,2990,'EM','lschmidtbauer@gmail.com',0,'2013-12-25 20:17:26',NULL,NULL),(27993,18043,'TE','2283427902',0,'2014-01-15 02:07:14',NULL,NULL),(7203,4692,'AP','9376542966',0,'2013-12-25 22:08:13',NULL,NULL),(25667,16548,'AP','5045770295',1,'2014-01-07 10:22:38',NULL,NULL),(10997,7142,'EM','jane@lavenderridgefarms.com',0,'2013-12-26 01:51:56',NULL,NULL),(23366,15052,'EM','chazgoins42@gmail.com',0,'2014-01-01 12:03:18',NULL,NULL),(5859,3759,'AP','3306072315',0,'2013-12-25 21:33:23',NULL,NULL),(32640,21347,'AP','2107485014',0,'2014-02-04 21:00:36',NULL,NULL),(37191,24481,'TE','5138311299',0,'2014-02-18 22:01:45',NULL,NULL),(37792,24941,'TE','6013766838',0,'2014-02-20 22:00:05',NULL,NULL),(41531,27618,'TE','9374412530',0,'2014-03-05 21:00:32',NULL,NULL),(42991,28592,'AP','5133837387',0,'2014-03-08 21:30:03',NULL,NULL),(1402,857,'AP','4192306033',0,'2013-12-25 18:07:04',NULL,NULL),(30357,19668,'AP','3183649282',0,'2014-01-23 21:00:30',NULL,NULL),(28102,18113,'TE','3304164214',0,'2014-01-15 02:07:38',NULL,NULL),(2341,1425,'TE','3373852944',0,'2013-12-25 18:47:23',NULL,NULL),(8363,5496,'EM','roger_l.smith@yahoo.com',0,'2013-12-25 23:11:12',NULL,NULL),(32352,21139,'TE','2818619819',0,'2014-02-03 21:00:21',NULL,NULL),(36911,24307,'BN','9852328958',0,'2014-02-18 21:30:24',NULL,NULL),(39390,26048,'AP','3308010948',0,'2014-02-26 21:02:31',NULL,NULL),(41221,27381,'TE','6013467113',0,'2014-03-04 21:01:21',NULL,NULL),(10476,6824,'EM','ashleysmas@gmail.com',0,'2013-12-26 01:30:38',NULL,NULL),(6014,3862,'TE','2256032158',0,'2013-12-25 21:35:58',NULL,NULL),(29864,19321,'TE','2542915461',1,'2014-01-22 03:22:11',NULL,NULL),(9100,5966,'TE','4193085453',0,'2013-12-25 23:51:29',NULL,NULL),(1077,662,'EM','afineran42@gmail.com',0,'2013-12-25 18:01:55',NULL,NULL),(1813,1123,'TE','5673711888',0,'2013-12-25 18:17:50',NULL,NULL),(8152,5337,'TE','7405910523',0,'2013-12-25 23:07:15',NULL,NULL),(25290,16307,'BN','5049081967',0,'2014-01-07 04:01:19',NULL,NULL),(22409,14451,'AP','9858040685',0,'2013-12-28 03:32:30',NULL,NULL),(41133,27321,'TE','9369339897',0,'2014-03-04 21:00:46',NULL,NULL),(4570,2916,'TE','5133791520',0,'2013-12-25 20:15:39',NULL,NULL),(30361,19670,'TE','3612072671',0,'2014-01-23 21:00:31',NULL,NULL),(29284,18914,'TE','3303175363',0,'2014-01-17 03:36:41',NULL,NULL),(29048,18756,'TE','8322358299',0,'2014-01-17 03:35:45',NULL,NULL),(27900,17977,'TE','3304880574',0,'2014-01-15 02:06:52',NULL,NULL),(5430,3475,'AP','6144937953',0,'2013-12-25 21:20:04',NULL,NULL),(23950,15452,'AP','9566226847',1,'2014-01-02 04:28:25',NULL,NULL),(2726,1654,'EM','jessemonsivaisjr@gmail.com',0,'2013-12-25 18:53:27',NULL,NULL),(22471,14489,'EM','ANGELA.L@SBCGLOBAL.NET',0,'2013-12-28 03:33:29',NULL,NULL),(22334,14400,'EM','vickiearrone@aol.com',0,'2013-12-28 03:31:11',NULL,NULL),(33585,22017,'AP','6628090939',0,'2014-02-07 19:00:56',NULL,NULL),(35854,23576,'TE','4195096968',0,'2014-02-13 22:02:54',NULL,NULL),(43443,28850,'TE','5672494043',0,'2014-03-09 21:01:18',NULL,NULL),(672,419,'AP','5132903966',0,'2013-12-25 17:46:36',NULL,NULL),(20626,13269,'AP','8063825904',0,'2013-12-26 12:56:51',NULL,NULL),(6371,4105,'TE','8179628585',0,'2013-12-25 21:47:50',NULL,NULL),(3681,2337,'TE','3617418385',0,'2013-12-25 19:31:50',NULL,NULL),(33135,21705,'TE','4404093411',0,'2014-02-05 21:31:12',NULL,NULL),(42281,28078,'EM','erica.diaz1022@gmail.com',0,'2014-03-06 21:01:56',NULL,NULL),(42646,28369,'TE','8178056366',0,'2014-03-07 21:30:33',NULL,NULL),(9449,6185,'EM','fmccarver@gmail.com',0,'2013-12-26 00:30:10',NULL,NULL),(32002,20892,'TE','4192454702',0,'2014-01-31 21:01:15',NULL,NULL),(11621,7557,'AP','9379359669',0,'2013-12-26 02:33:24',NULL,NULL),(9060,5941,'AP','5098592723',0,'2013-12-25 23:50:49',NULL,NULL),(24356,15729,'TE','3306048712',0,'2014-01-03 02:00:27',NULL,NULL),(8741,5731,'AP','2254853123',0,'2013-12-25 23:45:41',NULL,NULL),(10932,7109,'TE','4079234951',0,'2013-12-26 01:50:58',NULL,NULL),(9011,5913,'EM','mcpeek6276@yahoo.com',0,'2013-12-25 23:50:05',NULL,NULL),(11116,7229,'AP','3304421529',0,'2013-12-26 02:01:19',NULL,NULL),(3070,1910,'AP','5133821230',0,'2013-12-25 18:59:24',NULL,NULL),(33501,21955,'TE','9372090555',0,'2014-02-07 19:00:23',NULL,NULL),(37456,24663,'TE','4195379346',0,'2014-02-20 04:26:00',NULL,NULL),(40234,26688,'TE','3372549723',0,'2014-02-28 21:31:27',NULL,NULL),(41768,27773,'TE','3375709336',0,'2014-03-05 21:31:28',NULL,NULL),(42921,28541,'EM','allysonsjohnson@gmail.com',0,'2014-03-07 21:32:14',NULL,NULL),(43588,28942,'EM','khorten014@gmail.com',0,'2014-03-10 21:00:44',NULL,NULL),(20864,13415,'AP','3307150439',0,'2013-12-26 13:00:40',NULL,NULL),(31480,20514,'TE','7377230335',0,'2014-01-29 21:01:21',NULL,NULL),(10236,6693,'TE','3309269282',0,'2013-12-26 01:01:38',NULL,NULL),(29477,19054,'TE','4194783558',0,'2014-01-20 08:06:47',NULL,NULL),(13942,9091,'EM','LISAPICKLELP@HOTMAIL.COM',0,'2013-12-26 04:07:06',NULL,NULL),(25708,16572,'TE','9378554822',1,'2014-01-07 10:23:24',NULL,NULL),(25322,16328,'EM','JULIOH02@YAHOO.COM',0,'2014-01-07 04:01:55',NULL,NULL),(25102,16183,'AP','9156910557',0,'2014-01-05 00:00:36',NULL,NULL),(8886,5821,'AP','4326382346',0,'2013-12-25 23:48:01',NULL,NULL),(10004,6546,'TE','2108975019',0,'2013-12-26 00:52:03',NULL,NULL),(34647,22715,'AP','3373198818',0,'2014-02-11 21:01:07',NULL,NULL),(35043,23015,'TE','5045356341',0,'2014-02-12 21:30:26',NULL,NULL),(35172,23102,'AP','2167023368',0,'2014-02-12 21:31:12',NULL,NULL),(14537,9497,'TE','6144469892',0,'2013-12-26 04:35:04',NULL,NULL),(32655,21357,'AP','8175287206',0,'2014-02-04 21:00:41',NULL,NULL),(28860,18636,'EM','jackyv0608@yahoo.com',0,'2014-01-17 03:35:04',NULL,NULL),(1984,1226,'TE','3306588105',0,'2013-12-25 18:20:34',NULL,NULL),(14313,9359,'AP','3375324158',0,'2013-12-26 04:31:30',NULL,NULL),(11294,7359,'EM','gmoma7362@yahoo.com',0,'2013-12-26 02:15:21',NULL,NULL),(24067,15538,'TE','2257916822',1,'2014-01-02 04:30:53',NULL,NULL),(22686,14630,'AP','9374080256',0,'2013-12-28 03:37:11',NULL,NULL),(11279,7352,'AP','9515817519',0,'2013-12-26 02:15:09',NULL,NULL),(8587,5644,'EM','yesenia0825@yahoo.com',0,'2013-12-25 23:31:19',NULL,NULL),(32829,21482,'TE','5134811636',0,'2014-02-04 21:01:43',NULL,NULL),(33667,22085,'TE','3183964641',0,'2014-02-08 19:00:21',NULL,NULL),(34878,22880,'AP','3302563654',0,'2014-02-11 21:02:33',NULL,NULL),(37695,24853,'TE','9373227216',0,'2014-02-20 04:55:46',NULL,NULL),(38011,25076,'TE','3307159132',0,'2014-02-20 22:01:34',NULL,NULL),(39664,26227,'AP','6823518882',0,'2014-02-28 06:30:59',NULL,NULL),(40774,27096,'TE','3308489448',0,'2014-03-03 21:30:20',NULL,NULL),(4071,2597,'EM','jsnide101@gmail.com',0,'2013-12-25 19:45:14',NULL,NULL),(6231,4015,'AP','6142961726',0,'2013-12-25 21:45:32',NULL,NULL),(26315,16942,'AP','5049069498',0,'2014-01-13 02:19:55',NULL,NULL),(1083,665,'EM','lmberry@neo.rr.com',0,'2013-12-25 18:02:00',NULL,NULL),(13591,8861,'TE','9036440042',0,'2013-12-26 04:01:17',NULL,NULL),(6637,4299,'TE','4192176370',0,'2013-12-25 21:52:19',NULL,NULL),(3198,2010,'TE','5044536930',0,'2013-12-25 19:02:28',NULL,NULL),(40289,26724,'AP','9727932685',0,'2014-02-28 21:31:46',NULL,NULL),(211,128,'TE','6015805758',0,'2013-12-25 17:18:23',NULL,NULL),(7010,4579,'AP','5109189929',0,'2013-12-25 22:05:10',NULL,NULL),(24790,15991,'TE','4322904714',0,'2014-01-04 02:01:15',NULL,NULL),(31547,20564,'TE','5132238066',0,'2014-01-29 21:01:48',NULL,NULL),(33663,22082,'TE','2259333513',0,'2014-02-08 19:00:19',NULL,NULL),(33686,22095,'AP','5138895193',0,'2014-02-08 19:00:27',NULL,NULL),(35862,23583,'AP','9377635290',0,'2014-02-13 22:02:58',NULL,NULL),(11786,7667,'AP','2257719987',0,'2013-12-26 03:00:28',NULL,NULL),(7109,4642,'AP','2282381190',0,'2013-12-25 22:06:49',NULL,NULL),(26160,16844,'TE','3308081587',0,'2014-01-13 02:18:35',NULL,NULL),(1268,770,'TE','9035762191',0,'2013-12-25 18:04:48',NULL,NULL),(2941,1809,'EM','ceruleandeb@yahoo.com',0,'2013-12-25 18:57:00',NULL,NULL),(1780,1100,'AP','9376455403',0,'2013-12-25 18:17:15',NULL,NULL),(33801,22192,'AP','8324207333',0,'2014-02-09 19:00:10',NULL,NULL),(37554,24724,'EM','tkunsman@gmail.com',0,'2014-02-20 04:38:45',NULL,NULL),(42843,28493,'AP','6013975355',0,'2014-03-07 21:31:43',NULL,NULL),(762,477,'AP','2252025063',0,'2013-12-25 17:48:03',NULL,NULL),(28334,18259,'AP','9154122915',0,'2014-01-16 08:44:35',NULL,NULL),(11350,7394,'AP','3307803939',0,'2013-12-26 02:16:15',NULL,NULL),(9832,6433,'AP','3376611332',0,'2013-12-26 00:49:13',NULL,NULL),(8200,5367,'AP','5134041534',0,'2013-12-25 23:08:00',NULL,NULL),(31690,20671,'EM','morris100jackson@outlook.com',0,'2014-01-30 21:00:50',NULL,NULL),(32070,20942,'TE','5137350453',0,'2014-01-31 21:01:43',NULL,NULL),(35648,23439,'TE','2815360395',0,'2014-02-13 22:01:32',NULL,NULL),(37419,24642,'AP','8323969446',0,'2014-02-20 04:20:31',NULL,NULL),(43902,29127,'AP','4198614170',0,'2014-03-10 21:02:35',NULL,NULL),(7740,5051,'TE','9567717018',0,'2013-12-25 23:00:11',NULL,NULL),(21148,13596,'AP','4192966255',0,'2013-12-26 13:05:20',NULL,NULL),(22552,14545,'EM','derouenwillis@yahoo.com',0,'2013-12-28 03:34:53',NULL,NULL),(31106,20252,'AP','9035177741',0,'2014-01-28 21:00:14',NULL,NULL),(9026,5921,'AP','2105574133',0,'2013-12-25 23:50:18',NULL,NULL),(21159,13605,'TE','4192041035',0,'2013-12-26 13:05:31',NULL,NULL),(25620,16523,'TE','8066269900',1,'2014-01-07 10:21:48',NULL,NULL),(5154,3305,'TE','9378385459',0,'2013-12-25 21:15:47',NULL,NULL),(23851,15388,'AP','4407498666',1,'2014-01-02 04:25:39',NULL,NULL),(35355,23230,'TE','3304683822',0,'2014-02-12 21:32:25',NULL,NULL),(35514,23356,'AP','9178609243',0,'2014-02-13 22:00:44',NULL,NULL),(35571,23392,'AP','5138855394',0,'2014-02-13 22:01:06',NULL,NULL),(37905,25002,'AP','3305507878',0,'2014-02-20 22:00:47',NULL,NULL),(39659,26224,'AP','2544935005',0,'2014-02-28 06:30:58',NULL,NULL),(40101,26594,'EM','karonklein58@gmail.com',0,'2014-02-28 21:30:38',NULL,NULL),(41682,27718,'EM','lorita@flash.net',0,'2014-03-05 21:30:57',NULL,NULL),(987,608,'AP','6142647451',0,'2013-12-25 18:00:30',NULL,NULL),(30423,19720,'TE','4195149570',0,'2014-01-23 21:00:58',NULL,NULL),(6047,3884,'EM','rlanderson1954@gmail.com',0,'2013-12-25 21:36:32',NULL,NULL),(14704,9622,'TE','4193490699',0,'2013-12-26 04:37:56',NULL,NULL),(21476,13798,'AP','6015069342',0,'2013-12-26 13:11:18',NULL,NULL),(20601,13251,'AP','9564346548',0,'2013-12-26 12:56:24',NULL,NULL),(40055,26554,'TE','5132536725',0,'2014-02-28 21:30:16',NULL,NULL),(4147,2647,'TE','5126270719',0,'2013-12-25 19:46:30',NULL,NULL),(29623,19141,'TE','9153569515',0,'2014-01-21 08:45:29',NULL,NULL),(10308,6724,'AP','6149464985',0,'2013-12-26 01:15:19',NULL,NULL),(27148,17480,'AP','8173436357',0,'2014-01-13 03:01:12',NULL,NULL),(20750,13336,'EM','RIOS784@YAHOO.COM',0,'2013-12-26 12:58:46',NULL,NULL),(10008,6548,'TE','2104102445',0,'2013-12-26 00:52:07',NULL,NULL),(8153,5337,'AP','7405910523',0,'2013-12-25 23:07:15',NULL,NULL),(35041,23014,'AP','2253138452',0,'2014-02-12 21:30:25',NULL,NULL),(8179,5351,'TE','3303791017',0,'2013-12-25 23:07:38',NULL,NULL),(30343,19663,'TE','5134044660',0,'2014-01-23 21:00:26',NULL,NULL),(23122,14904,'EM','ricnguyen@yahoo.com',0,'2013-12-30 00:01:15',NULL,NULL),(23702,15299,'EM','lousid8@gmail.com',1,'2014-01-02 04:22:46',NULL,NULL),(25539,16474,'EM','rclee1220@yahoo.com',0,'2014-01-07 04:06:04',NULL,NULL),(30864,20060,'EM','james@sadler57.com',0,'2014-01-27 21:00:11',NULL,NULL),(32968,21582,'TE','3307016226',0,'2014-02-05 21:30:26',NULL,NULL),(33802,22194,'EM','alviningram@ymail.com',0,'2014-02-09 19:00:11',NULL,NULL),(36365,23946,'EM','tressturner@gmail.com',0,'2014-02-15 21:00:13',NULL,NULL),(36813,24238,'TE','5672049424',0,'2014-02-16 19:00:38',NULL,NULL),(39028,25808,'EM','eucapnic@earthlink.net',0,'2014-02-26 21:00:20',NULL,NULL),(40686,27019,'TE','6149059232',0,'2014-03-03 21:00:12',NULL,NULL),(41843,27822,'TE','9375723069',0,'2014-03-05 21:31:56',NULL,NULL),(14457,9444,'EM','UWIKA@YAHOO.COM',0,'2013-12-26 04:33:47',NULL,NULL),(26308,16939,'AP','3189460808',0,'2014-01-13 02:19:53',NULL,NULL),(24620,15877,'TE','5045128822',0,'2014-01-03 02:05:18',NULL,NULL),(6858,4447,'EM','profbond@yahoo.com',0,'2013-12-25 22:02:19',NULL,NULL),(7927,5166,'TE','2162058295',0,'2013-12-25 23:03:12',NULL,NULL),(8509,5595,'AP','5049090942',0,'2013-12-25 23:30:06',NULL,NULL),(6305,4063,'TE','2163923958',0,'2013-12-25 21:46:44',NULL,NULL),(9917,6490,'EM','larring1@yahoo.com',0,'2013-12-26 00:50:34',NULL,NULL),(41891,27854,'EM','marilynconner01@yahoo.com',0,'2014-03-05 21:32:14',NULL,NULL),(11775,7661,'TE','5042319863',0,'2013-12-26 03:00:17',NULL,NULL),(2532,1549,'AP','6625497967',0,'2013-12-25 18:50:34',NULL,NULL),(29838,19303,'TE','2256878719',1,'2014-01-22 03:22:02',NULL,NULL),(24582,15855,'AP','3236299061',0,'2014-01-03 02:04:34',NULL,NULL),(40715,27055,'TE','4192170251',0,'2014-03-03 21:00:27',NULL,NULL),(41616,27667,'AP','6142608378',0,'2014-03-05 21:30:31',NULL,NULL),(838,520,'TE','4403467108',0,'2013-12-25 17:49:12',NULL,NULL),(13849,9031,'EM','a-healy@att.net',0,'2013-12-26 04:05:35',NULL,NULL),(29709,19209,'AP','2163190152',0,'2014-01-21 08:46:21',NULL,NULL),(6200,3995,'TE','5133650387',0,'2013-12-25 21:39:14',NULL,NULL),(5241,3367,'AP','7132561368',0,'2013-12-25 21:17:09',NULL,NULL),(21798,14044,'EM','blittle1963@yahoo.com',0,'2013-12-27 02:00:07',NULL,NULL),(22881,14761,'EM','lydia.chen27@yahoo.com',1,'2013-12-29 11:12:43',NULL,NULL),(36505,24034,'TE','5138857967',0,'2014-02-15 22:00:55',NULL,NULL),(1003,618,'TE','4193066159',0,'2013-12-25 18:00:45',NULL,NULL),(6015,3862,'AP','2256032158',0,'2013-12-25 21:35:58',NULL,NULL),(6672,4332,'TE','4199730207',0,'2013-12-25 21:53:03',NULL,NULL),(20799,13365,'TE','6144465265',0,'2013-12-26 12:59:36',NULL,NULL),(22265,14351,'TE','9373791333',0,'2013-12-27 02:08:06',NULL,NULL),(22233,14330,'TE','3305548225',0,'2013-12-27 02:07:32',NULL,NULL),(32937,21558,'TE','9374642134',0,'2014-02-05 21:30:17',NULL,NULL),(33046,21648,'EM','murselcarter0924@gmail.com',0,'2014-02-05 21:30:49',NULL,NULL),(36836,24259,'TE','9158733602',0,'2014-02-17 19:00:09',NULL,NULL),(37800,24946,'AP','9014810564',0,'2014-02-20 22:00:08',NULL,NULL),(9971,6524,'TE','5133682594',0,'2013-12-26 00:51:30',NULL,NULL),(5952,3821,'TE','7408568369',0,'2013-12-25 21:34:56',NULL,NULL),(4464,2842,'EM','slenczew@gmail.com',0,'2013-12-25 20:01:06',NULL,NULL),(28639,18465,'TE','2252619575',0,'2014-01-16 08:46:15',NULL,NULL),(28067,18090,'AP','3184477964',0,'2014-01-15 02:07:30',NULL,NULL),(26814,17246,'TE','5137247857',0,'2014-01-13 02:22:48',NULL,NULL),(24437,15775,'AP','2142447888',0,'2014-01-03 02:01:58',NULL,NULL),(25269,16292,'TE','4406841231',0,'2014-01-07 04:00:53',NULL,NULL),(33810,22199,'AP','6143784251',0,'2014-02-09 19:00:14',NULL,NULL),(35092,23050,'AP','8178964560',0,'2014-02-12 21:30:45',NULL,NULL),(51,33,'TE','7406015550',0,'2013-12-25 17:15:51',NULL,NULL),(14123,9249,'TE','4197226932',0,'2013-12-26 04:10:45',NULL,NULL),(724,455,'AP','4199730207',0,'2013-12-25 17:47:27',NULL,NULL),(7803,5092,'AP','2108626340',0,'2013-12-25 23:01:15',NULL,NULL),(22650,14604,'AP','9738647634',0,'2013-12-28 03:36:29',NULL,NULL),(2256,1383,'TE','3186652757',0,'2013-12-25 18:46:09',NULL,NULL),(4312,2751,'TE','5136778282',0,'2013-12-25 19:49:06',NULL,NULL),(8689,5704,'AP','3618169757',0,'2013-12-25 23:33:01',NULL,NULL),(9395,6149,'TE','3304758441',0,'2013-12-26 00:16:29',NULL,NULL),(39134,25884,'TE','2543340328',0,'2014-02-26 21:01:00',NULL,NULL),(42814,28472,'EM','kcross24@gmail.com',0,'2014-03-07 21:31:32',NULL,NULL),(14076,9201,'TE','9374444333',0,'2013-12-26 04:09:40',NULL,NULL),(6019,3863,'EM','dunlapsethj@gmail.com',0,'2013-12-25 21:36:01',NULL,NULL),(5785,3705,'EM','kiaskianthony@yahoo.com',0,'2013-12-25 21:32:05',NULL,NULL),(10989,7137,'EM','cage06@earthlink.net',0,'2013-12-26 01:51:49',NULL,NULL),(20460,13181,'TE','8176910267',0,'2013-12-26 12:54:20',NULL,NULL),(35798,23539,'TE','3373091909',0,'2014-02-13 22:02:31',NULL,NULL),(20486,13193,'TE','9722277884',0,'2013-12-26 12:54:42',NULL,NULL),(29778,19254,'AP','2256367979',0,'2014-01-21 08:46:45',NULL,NULL),(4597,2933,'TE','9379023941',0,'2013-12-25 20:16:03',NULL,NULL),(3299,2076,'TE','9852469488',0,'2013-12-25 19:16:30',NULL,NULL),(39695,26250,'AP','8302643446',0,'2014-02-28 06:31:08',NULL,NULL),(40698,27034,'TE','8326898505',0,'2014-03-03 21:00:18',NULL,NULL),(43048,28620,'AP','9153428209',0,'2014-03-08 21:30:21',NULL,NULL),(12392,8114,'AP','3184471308',0,'2013-12-26 03:15:07',NULL,NULL),(27060,17402,'TE','6013426388',0,'2014-01-13 03:00:17',NULL,NULL),(1220,742,'AP','2546447930',0,'2013-12-25 18:04:06',NULL,NULL),(24222,15650,'TE','5044270835',1,'2014-01-02 04:34:04',NULL,NULL),(22037,14193,'TE','9153094026',0,'2013-12-27 02:04:03',NULL,NULL),(1602,987,'TE','5136175363',0,'2013-12-25 18:10:29',NULL,NULL),(8964,5870,'EM','jdavis2@wu.wilberforce.edu',0,'2013-12-25 23:49:13',NULL,NULL),(32959,21576,'AP','3304315879',0,'2014-02-05 21:30:23',NULL,NULL),(8348,5481,'TE','4197730314',0,'2013-12-25 23:10:51',NULL,NULL),(26464,17034,'AP','3185420618',0,'2014-01-13 02:20:47',NULL,NULL),(25784,16614,'AP','3309802182',0,'2014-01-08 18:24:09',NULL,NULL),(34509,22636,'TE','8067994539',0,'2014-02-11 21:00:20',NULL,NULL),(704,436,'TE','4403388281',0,'2013-12-25 17:47:04',NULL,NULL),(8947,5856,'TE','2604151048',0,'2013-12-25 23:48:56',NULL,NULL),(31783,20747,'TE','4197795212',0,'2014-01-30 21:01:27',NULL,NULL),(35149,23082,'TE','3302532538',0,'2014-02-12 21:31:04',NULL,NULL),(35491,23336,'AP','5133926896',0,'2014-02-13 22:00:34',NULL,NULL),(41509,27596,'TE','6148377436',0,'2014-03-05 21:00:20',NULL,NULL),(5633,3609,'TE','3307601387',0,'2013-12-25 21:23:27',NULL,NULL),(11661,7589,'AP','3305731132',0,'2013-12-26 02:45:06',NULL,NULL),(27146,17479,'AP','8173436357',0,'2014-01-13 03:01:12',NULL,NULL),(31890,20815,'TE','9859748857',0,'2014-01-31 21:00:31',NULL,NULL),(34854,22853,'TE','4199798468',0,'2014-02-11 21:02:22',NULL,NULL),(38733,25603,'AP','5129475003',0,'2014-02-26 08:30:04',NULL,NULL),(22166,14276,'AP','6015033044',0,'2013-12-27 02:06:14',NULL,NULL),(31146,20286,'AP','2163741359',0,'2014-01-28 21:00:32',NULL,NULL),(28230,18203,'AP','4198895176',0,'2014-01-15 02:08:07',NULL,NULL),(29687,19187,'TE','4126075595',0,'2014-01-21 08:46:11',NULL,NULL),(29454,19044,'AP','4193204226',0,'2014-01-20 08:06:39',NULL,NULL),(33234,21763,'TE','5127554624',0,'2014-02-06 21:00:28',NULL,NULL),(37608,24782,'AP','6145569340',0,'2014-02-20 04:45:41',NULL,NULL),(42350,28127,'TE','3306563813',0,'2014-03-06 21:02:23',NULL,NULL),(1926,1193,'TE','5135192650',0,'2013-12-25 18:19:40',NULL,NULL),(30607,19864,'TE','4403097613',0,'2014-01-24 21:00:37',NULL,NULL),(6706,4360,'AP','4194907794',0,'2013-12-25 21:53:44',NULL,NULL),(5427,3472,'AP','9372380373',0,'2013-12-25 21:20:01',NULL,NULL),(34618,22697,'AP','2144353138',0,'2014-02-11 21:00:57',NULL,NULL),(40138,26620,'AP','9366624856',0,'2014-02-28 21:30:52',NULL,NULL),(42603,28343,'AP','8179664378',0,'2014-03-07 21:30:18',NULL,NULL),(14645,9581,'TE','6148435979',0,'2013-12-26 04:36:54',NULL,NULL),(8582,5640,'EM','bgclfoods@hotmail.com',0,'2013-12-25 23:31:14',NULL,NULL),(25048,16145,'TE','9377801045',0,'2014-01-04 02:06:07',NULL,NULL),(23736,15315,'TE','2149953337',1,'2014-01-02 04:23:21',NULL,NULL),(11181,7271,'AP','2102510120',0,'2013-12-26 02:02:26',NULL,NULL),(7964,5195,'AP','2566510249',0,'2013-12-25 23:03:53',NULL,NULL),(4774,3056,'AP','5045796513',0,'2013-12-25 20:19:02',NULL,NULL),(9154,5995,'TE','3183255290',0,'2013-12-26 00:00:12',NULL,NULL),(4063,2594,'AP','3309980303',0,'2013-12-25 19:45:08',NULL,NULL),(7965,5196,'TE','5137035410',0,'2013-12-25 23:03:54',NULL,NULL),(42611,28349,'TE','3252453395',0,'2014-03-07 21:30:21',NULL,NULL),(367,224,'EM','lduffer0409@yahoo.com',0,'2013-12-25 17:20:52',NULL,NULL),(11632,7567,'TE','4192966842',0,'2013-12-26 02:33:39',NULL,NULL),(1912,1183,'TE','4193480532',0,'2013-12-25 18:19:26',NULL,NULL),(27150,17482,'TE','9033432526',0,'2014-01-13 03:01:13',NULL,NULL),(27024,17378,'AP','3302096445',0,'2014-01-13 03:00:04',NULL,NULL),(5774,3698,'TE','3306747071',0,'2013-12-25 21:31:55',NULL,NULL),(26626,17132,'TE','3302244244',0,'2014-01-13 02:21:47',NULL,NULL),(9926,6497,'TE','3309282463',0,'2013-12-26 00:50:44',NULL,NULL),(22760,14676,'AP','6018992421',1,'2013-12-29 11:08:25',NULL,NULL),(33172,21725,'TE','8303852831',0,'2014-02-06 21:00:06',NULL,NULL),(20189,13007,'TE','5136676921',0,'2013-12-26 12:49:41',NULL,NULL),(4708,3011,'TE','3366302295',0,'2013-12-25 20:17:56',NULL,NULL),(30852,20053,'AP','8328943471',0,'2014-01-27 21:00:07',NULL,NULL),(30641,19885,'TE','3304684760',0,'2014-01-24 21:00:48',NULL,NULL),(9989,6536,'AP','8326618743',0,'2013-12-26 00:51:48',NULL,NULL),(26423,17003,'AP','5024323310',0,'2014-01-13 02:20:32',NULL,NULL),(27655,17828,'TE','2283269459',0,'2014-01-15 02:05:58',NULL,NULL),(36732,24185,'TE','5135157945',0,'2014-02-16 19:00:10',NULL,NULL),(374,228,'TE','5045597046',0,'2013-12-25 17:20:59',NULL,NULL),(31079,20220,'EM','nseip@cinci.rr.com',0,'2014-01-27 21:01:44',NULL,NULL),(1114,683,'AP','9375649179',0,'2013-12-25 18:02:27',NULL,NULL),(37084,24417,'TE','4402544217',0,'2014-02-18 22:01:05',NULL,NULL),(20881,13427,'EM','hoveyware@nktelco.net',0,'2013-12-26 13:00:56',NULL,NULL),(4589,2929,'TE','3309584752',0,'2013-12-25 20:15:58',NULL,NULL),(30030,19449,'TE','4409888108',0,'2014-01-23 03:01:52',NULL,NULL),(4390,2797,'AP','9373029230',0,'2013-12-25 19:50:19',NULL,NULL),(24829,16015,'AP','3375326445',0,'2014-01-04 02:01:59',NULL,NULL),(24592,15862,'TE','6014521616',0,'2014-01-03 02:04:48',NULL,NULL),(12111,7915,'AP','5047825193',0,'2013-12-26 03:06:12',NULL,NULL),(32969,21582,'AP','3307016226',0,'2014-02-05 21:30:26',NULL,NULL),(42496,28262,'TE','9372713226',0,'2014-03-07 21:00:17',NULL,NULL),(197,120,'AP','3617394288',0,'2013-12-25 17:18:10',NULL,NULL),(5471,3502,'TE','3309081582',0,'2013-12-25 21:20:45',NULL,NULL),(34178,22414,'TE','2255716371',0,'2014-02-10 21:30:27',NULL,NULL),(8726,5724,'TE','9852621670',0,'2013-12-25 23:45:30',NULL,NULL),(23762,15327,'TE','3254361587',1,'2014-01-02 04:23:47',NULL,NULL),(7565,4926,'TE','5132630514',0,'2013-12-25 22:45:17',NULL,NULL),(31936,20848,'TE','3307251573',0,'2014-01-31 21:00:50',NULL,NULL),(8724,5723,'TE','3187300341',0,'2013-12-25 23:45:28',NULL,NULL),(27353,17611,'AP','9562818355',0,'2014-01-14 01:32:22',NULL,NULL),(1453,888,'TE','5132071682',0,'2013-12-25 18:07:55',NULL,NULL),(6027,3870,'TE','9857050874',0,'2013-12-25 21:36:10',NULL,NULL),(25724,16581,'TE','2252239822',0,'2014-01-08 18:23:57',NULL,NULL),(35126,23070,'AP','3185793117',0,'2014-02-12 21:30:57',NULL,NULL),(35691,23475,'AP','9032208293',0,'2014-02-13 22:01:51',NULL,NULL),(43641,28967,'AP','5044353968',0,'2014-03-10 21:01:00',NULL,NULL),(1000,614,'EM','Melissawink@gmail.com',0,'2013-12-25 18:00:41',NULL,NULL),(1324,809,'TE','4404378984',0,'2013-12-25 18:05:46',NULL,NULL),(1406,859,'TE','4193020851',0,'2013-12-25 18:07:07',NULL,NULL),(13941,9091,'AP','7409819019',0,'2013-12-26 04:07:06',NULL,NULL),(28261,18223,'TE','3253889285',0,'2014-01-16 08:44:15',NULL,NULL),(26568,17091,'TE','3257620137',0,'2014-01-13 02:21:27',NULL,NULL),(10185,6656,'AP','4407856707',0,'2013-12-26 01:00:43',NULL,NULL),(24455,15786,'TE','5043245601',0,'2014-01-03 02:02:20',NULL,NULL),(35351,23228,'AP','2167023368',0,'2014-02-12 21:32:23',NULL,NULL),(3407,2140,'AP','2282812092',0,'2013-12-25 19:18:15',NULL,NULL),(26295,16925,'EM','tyrione.sd@gmail.com',0,'2014-01-13 02:19:46',NULL,NULL),(35219,23131,'EM','dollalyse@aol.com',0,'2014-02-12 21:31:30',NULL,NULL),(36351,23940,'EM','SINDYROBBINS01@GMAIL.COM',0,'2014-02-15 21:00:08',NULL,NULL),(40541,26907,'AP','2504699293',0,'2014-03-03 01:00:10',NULL,NULL),(42977,28581,'TE','9372892608',0,'2014-03-08 21:00:08',NULL,NULL),(43222,28721,'TE','9375243745',0,'2014-03-08 21:31:21',NULL,NULL),(43949,29153,'TE','3307583907',0,'2014-03-10 21:02:50',NULL,NULL),(6886,4470,'AP','3302343669',0,'2013-12-25 22:02:50',NULL,NULL),(27260,17552,'EM','capricorn10@prodigy.net',0,'2014-01-13 03:01:55',NULL,NULL),(30656,19897,'AP','9859817362',0,'2014-01-24 21:00:54',NULL,NULL),(31700,20678,'TE','2102875058',0,'2014-01-30 21:00:54',NULL,NULL),(31719,20700,'AP','2252441907',0,'2014-01-30 21:01:03',NULL,NULL),(33392,21878,'AP','2259078272',0,'2014-02-06 21:01:29',NULL,NULL),(34389,22557,'TE','5136782747',0,'2014-02-10 21:31:49',NULL,NULL),(34526,22650,'TE','2398516283',0,'2014-02-11 21:00:27',NULL,NULL),(35482,23333,'AP','2162888727',0,'2014-02-13 22:00:32',NULL,NULL),(38353,25335,'TE','3187944861',0,'2014-02-25 21:30:21',NULL,NULL),(38354,25335,'AP','3187944861',0,'2014-02-25 21:30:21',NULL,NULL),(38889,25707,'TE','6823658077',0,'2014-02-26 09:30:21',NULL,NULL),(42118,27981,'TE','3186692374',0,'2014-03-06 21:00:57',NULL,NULL),(42486,28251,'TE','5139212260',0,'2014-03-07 21:00:13',NULL,NULL),(2723,1653,'AP','9156268707',0,'2013-12-25 18:53:25',NULL,NULL),(11192,7277,'AP','2812220970',0,'2013-12-26 02:02:36',NULL,NULL),(20994,13511,'TE','2259935723',0,'2013-12-26 13:02:54',NULL,NULL),(23098,14895,'AP','2252760012',0,'2013-12-30 00:00:56',NULL,NULL),(3944,2505,'TE','2257752864',0,'2013-12-25 19:36:07',NULL,NULL),(24630,15882,'EM','Gbunny73@hotmail.com',0,'2014-01-03 02:05:28',NULL,NULL),(26481,17042,'AP','5133931680',0,'2014-01-13 02:20:52',NULL,NULL),(27705,17856,'EM','bonnie.watkins54@aol.com',0,'2014-01-15 02:06:09',NULL,NULL),(28551,18405,'EM','joe.packobuilders@gmail.com',0,'2014-01-16 08:45:45',NULL,NULL),(32425,21186,'AP','6014989593',0,'2014-02-03 21:00:46',NULL,NULL),(33346,21843,'AP','4194873083',0,'2014-02-06 21:01:12',NULL,NULL),(33737,22136,'EM','annfrancesgilmore@gmail.com',0,'2014-02-08 19:00:46',NULL,NULL),(37740,24896,'TE','9567266352',0,'2014-02-20 05:40:22',NULL,NULL),(4622,2946,'AP','5133764120',0,'2013-12-25 20:16:24',NULL,NULL),(9267,6066,'TE','6142971907',0,'2013-12-26 00:02:04',NULL,NULL),(9223,6036,'TE','5049201740',0,'2013-12-26 00:01:17',NULL,NULL),(14159,9267,'EM','zaninpz@gmail.com',0,'2013-12-26 04:15:32',NULL,NULL),(5339,3421,'TE','2255459054',0,'2013-12-25 21:18:39',NULL,NULL),(14842,9714,'TE','6142357779',0,'2013-12-26 04:45:17',NULL,NULL),(5237,3364,'EM','wmanes06@gmail.com',0,'2013-12-25 21:17:05',NULL,NULL),(7490,4876,'TE','9723427208',0,'2013-12-25 22:31:09',NULL,NULL),(23613,15245,'AP','9374753742',0,'2014-01-01 12:08:46',NULL,NULL),(23616,15246,'AP','9802137607',0,'2014-01-01 12:08:49',NULL,NULL),(26274,16910,'EM','s.c.fout@gmail.com',0,'2014-01-13 02:19:37',NULL,NULL),(26522,17063,'EM','lam1000@yahoo.com',0,'2014-01-13 02:21:13',NULL,NULL),(26639,17139,'EM','osboda1@me.com',0,'2014-01-13 02:21:51',NULL,NULL),(33339,21839,'AP','5139178334',0,'2014-02-06 21:01:09',NULL,NULL),(33566,22008,'AP','5132188111',0,'2014-02-07 19:00:50',NULL,NULL),(34887,22894,'TE','4193765781',0,'2014-02-11 21:02:38',NULL,NULL),(34898,22900,'EM','draws4@roadrunner.com',0,'2014-02-11 21:02:41',NULL,NULL),(36621,24110,'TE','2143276653',0,'2014-02-15 22:01:36',NULL,NULL),(39126,25880,'TE','5047229049',0,'2014-02-26 21:00:57',NULL,NULL),(43160,28683,'BN','4095948390',0,'2014-03-08 21:30:58',NULL,NULL),(6686,4342,'AP','4192361740',0,'2013-12-25 21:53:18',NULL,NULL),(11111,7224,'AP','4194205880',0,'2013-12-26 02:01:12',NULL,NULL),(9883,6462,'EM','STEVEDOESWORK@HOTMAIL.COM',0,'2013-12-26 00:49:57',NULL,NULL),(6557,4236,'TE','5129989257',0,'2013-12-25 21:50:52',NULL,NULL),(20411,13144,'TE','9372479994',0,'2013-12-26 12:53:24',NULL,NULL),(20609,13254,'AP','9563695573',0,'2013-12-26 12:56:30',NULL,NULL),(5960,3825,'TE','6149284677',0,'2013-12-25 21:35:03',NULL,NULL),(26662,17154,'EM','morseclairesse@yahoo.com',0,'2014-01-13 02:21:58',NULL,NULL),(29558,19101,'AP','9787984689',0,'2014-01-21 08:44:38',NULL,NULL),(31008,20171,'EM','MSLudwig59@yahoo.com',0,'2014-01-27 21:01:15',NULL,NULL),(31731,20708,'TE','2255736327',0,'2014-01-30 21:01:07',NULL,NULL),(32915,21548,'TE','7405072935',0,'2014-02-05 21:30:12',NULL,NULL),(36002,23683,'EM','ohioscott@sbcglobal.net',0,'2014-02-14 21:30:32',NULL,NULL),(36400,23972,'EM','maiden.brenda@yahoo.com',0,'2014-02-15 22:00:15',NULL,NULL),(38498,25441,'TE','4696988266',0,'2014-02-25 21:31:20',NULL,NULL),(1366,833,'AP','3306206732',0,'2013-12-25 18:06:24',NULL,NULL),(25631,16530,'TE','9155002910',1,'2014-01-07 10:22:02',NULL,NULL),(2959,1832,'TE','4409461318',0,'2013-12-25 18:57:27',NULL,NULL),(8448,5558,'EM','whitley.smith@rocketmail.com',0,'2013-12-25 23:16:21',NULL,NULL),(8803,5767,'TE','7404417451',0,'2013-12-25 23:46:40',NULL,NULL),(9650,6313,'AP','3302061007',0,'2013-12-26 00:46:14',NULL,NULL),(2052,1270,'AP','9569097356',0,'2013-12-25 18:30:14',NULL,NULL),(14692,9614,'TE','5136814485',0,'2013-12-26 04:37:44',NULL,NULL),(14724,9632,'TE','9402060500',0,'2013-12-26 04:38:15',NULL,NULL),(21278,13671,'AP','5124262077',0,'2013-12-26 13:07:55',NULL,NULL),(24691,15925,'AP','6015491183',0,'2014-01-03 02:06:46',NULL,NULL),(25182,16238,'AP','9858695005',0,'2014-01-05 00:02:17',NULL,NULL),(21735,14002,'EM','reruhlman@gmail.com',0,'2013-12-26 13:16:07',NULL,NULL),(1998,1235,'TE','3184171196',0,'2013-12-25 18:20:50',NULL,NULL),(1838,1137,'TE','3182559674',0,'2013-12-25 18:18:13',NULL,NULL),(23017,14844,'EM','argsplash@yahoo.com',1,'2013-12-29 11:14:56',NULL,NULL),(28460,18339,'AP','3303190742',0,'2014-01-16 08:45:17',NULL,NULL),(30781,20013,'TE','9157275113',0,'2014-01-26 19:00:10',NULL,NULL),(34545,22658,'AP','8064002352',0,'2014-02-11 21:00:33',NULL,NULL),(37602,24781,'TE','6145569340',0,'2014-02-20 04:45:12',NULL,NULL),(39408,26058,'TE','5136338288',0,'2014-02-26 21:02:38',NULL,NULL),(40317,26755,'TE','4093515357',0,'2014-03-01 19:00:05',NULL,NULL),(41639,27680,'EM','fortunajorge@yahoo.com',0,'2014-03-05 21:30:38',NULL,NULL),(43724,29024,'EM','michelle.stephens0@gmail.com',0,'2014-03-10 21:01:32',NULL,NULL),(7839,5116,'EM','lealex16@yahoo.com',0,'2013-12-25 23:01:50',NULL,NULL),(20872,13420,'TE','5132312755',0,'2013-12-26 13:00:47',NULL,NULL),(21808,14051,'EM','nessacjones@yahoo.com',0,'2013-12-27 02:00:18',NULL,NULL),(8968,5877,'AP','7403103917',0,'2013-12-25 23:49:21',NULL,NULL),(4054,2586,'EM','KillBalmer@aim.com',0,'2013-12-25 19:38:10',NULL,NULL),(22243,14334,'TE','9375489617',0,'2013-12-27 02:07:41',NULL,NULL),(22330,14399,'TE','5136252584',0,'2013-12-28 03:31:09',NULL,NULL),(6409,4137,'EM','cjr2006@gmail.com',0,'2013-12-25 21:48:30',NULL,NULL),(6773,4394,'AP','3308194867',0,'2013-12-25 22:00:59',NULL,NULL),(3815,2428,'TE','7404074919',0,'2013-12-25 19:34:06',NULL,NULL),(28537,18395,'AP','2169522583',0,'2014-01-16 08:45:41',NULL,NULL),(31448,20497,'EM','norris.joyce939@gmail.com',0,'2014-01-29 21:01:10',NULL,NULL),(32306,21100,'TE','5674556043',0,'2014-02-03 21:00:04',NULL,NULL),(38135,25171,'AP','5134038989',0,'2014-02-21 22:00:28',NULL,NULL),(38363,25340,'AP','3183817798',0,'2014-02-25 21:30:24',NULL,NULL),(38922,25730,'AP','3375770432',0,'2014-02-26 09:30:35',NULL,NULL),(40400,26817,'AP','2488854786',0,'2014-03-01 21:00:32',NULL,NULL),(41461,27550,'EM','Delilahdav@yahoo.com',0,'2014-03-04 21:30:11',NULL,NULL),(41976,27903,'TE','9157803269',0,'2014-03-06 21:00:10',NULL,NULL),(42771,28447,'AP','5042893656',0,'2014-03-07 21:31:17',NULL,NULL),(42807,28468,'TE','2167020696',0,'2014-03-07 21:31:30',NULL,NULL),(2323,1417,'TE','9706313748',0,'2013-12-25 18:47:08',NULL,NULL),(26016,16760,'EM','corfmandwc@aol.com',0,'2014-01-08 18:24:58',NULL,NULL),(14830,9707,'EM','ph23il@hotmail.com',0,'2013-12-26 04:45:05',NULL,NULL),(9086,5955,'EM','maryjaneerard@yahoo.com',0,'2013-12-25 23:51:14',NULL,NULL),(21075,13552,'AP','3185730006',0,'2013-12-26 13:04:08',NULL,NULL),(22266,14351,'EM','TODDdwelly543@YAHOO.COM',0,'2013-12-27 02:08:07',NULL,NULL),(6088,3919,'TE','4194209620',0,'2013-12-25 21:37:20',NULL,NULL),(23220,14963,'EM','bddgea@sbcglobal.net',0,'2014-01-01 12:00:35',NULL,NULL),(24327,15715,'EM','DOUGKELLER2007@YAHOO.COM',1,'2014-01-02 04:36:12',NULL,NULL),(24765,15978,'TE','4322710493',0,'2014-01-04 02:00:50',NULL,NULL),(4316,2753,'AP','4408123597',0,'2013-12-25 19:49:09',NULL,NULL),(3633,2299,'AP','3302657162',0,'2013-12-25 19:30:57',NULL,NULL),(28093,18107,'EM','Momcanwe2003@yahoo.com',0,'2014-01-15 02:07:36',NULL,NULL),(28900,18657,'TE','9037801426',0,'2014-01-17 03:35:12',NULL,NULL),(35878,23593,'AP','3302899696',0,'2014-02-13 22:03:03',NULL,NULL),(36897,24300,'AP','4093774360',0,'2014-02-18 21:30:19',NULL,NULL),(38393,25364,'AP','5136336619',0,'2014-02-25 21:30:38',NULL,NULL),(40645,26979,'AP','5135153543',0,'2014-03-03 01:00:38',NULL,NULL),(40850,27146,'TE','2167896771',0,'2014-03-03 21:30:49',NULL,NULL),(41909,27864,'EM','katie.mullins52@gmail.com',0,'2014-03-05 21:32:21',NULL,NULL),(43308,28771,'TE','7409744868',0,'2014-03-09 21:00:29',NULL,NULL),(1102,677,'AP','2162407926',0,'2013-12-25 18:02:17',NULL,NULL),(11663,7590,'EM','Rshope5963@aol.com',0,'2013-12-26 02:45:08',NULL,NULL),(22186,14292,'TE','2346789168',0,'2013-12-27 02:06:36',NULL,NULL),(9038,5931,'AP','2146973296',0,'2013-12-25 23:50:30',NULL,NULL),(23214,14959,'TE','9037940724',0,'2014-01-01 12:00:27',NULL,NULL),(4826,3089,'TE','9379015764',0,'2013-12-25 20:19:57',NULL,NULL),(24284,15692,'TE','4198362912',1,'2014-01-02 04:35:25',NULL,NULL),(30555,19825,'EM','jesbatres@gmail.com',0,'2014-01-24 21:00:16',NULL,NULL),(30731,19965,'AP','7404669205',0,'2014-01-25 19:00:09',NULL,NULL),(32719,21403,'EM','mlprovider@yahoo.com',0,'2014-02-04 21:01:04',NULL,NULL),(36197,23828,'TE','6015730792',0,'2014-02-14 21:31:44',NULL,NULL),(37635,24806,'TE','6143138857',0,'2014-02-20 04:49:02',NULL,NULL),(39488,26119,'EM','Jacob.Mattes@yahoo.com',0,'2014-02-28 06:30:18',NULL,NULL),(39866,26374,'TE','9374083552',0,'2014-02-28 07:00:15',NULL,NULL),(40411,26825,'TE','6142097356',0,'2014-03-01 21:00:37',NULL,NULL),(42330,28111,'AP','3305240989',0,'2014-03-06 21:02:15',NULL,NULL),(43899,29126,'AP','4193417055',0,'2014-03-10 21:02:34',NULL,NULL),(1734,1065,'AP','2165514667',0,'2013-12-25 18:16:23',NULL,NULL),(12266,8022,'EM','budwells2001@yahoo.com',0,'2013-12-26 03:08:56',NULL,NULL),(9316,6100,'TE','4406454527',0,'2013-12-26 00:15:11',NULL,NULL),(9006,5910,'TE','4693371243',0,'2013-12-25 23:50:01',NULL,NULL),(22601,14575,'AP','2253850267',0,'2013-12-28 03:35:41',NULL,NULL),(24149,15602,'TE','5136782363',1,'2014-01-02 04:32:39',NULL,NULL),(14711,9625,'TE','3307883580',0,'2013-12-26 04:38:02',NULL,NULL),(29060,18764,'AP','8327588783',0,'2014-01-17 03:35:48',NULL,NULL),(29610,19131,'EM','JAMESDANIELS2858@GMAIL.COM',0,'2014-01-21 08:45:23',NULL,NULL),(29878,19335,'TE','3613968198',1,'2014-01-22 03:22:18',NULL,NULL),(29927,19367,'EM','nixiehusky@yahoo.com',1,'2014-01-22 03:22:34',NULL,NULL),(35035,23011,'TE','3184615305',0,'2014-02-12 21:30:23',NULL,NULL),(36034,23702,'AP','5133250620',0,'2014-02-14 21:30:42',NULL,NULL),(37501,24694,'TE','3612930628',0,'2014-02-20 04:33:07',NULL,NULL),(40629,26968,'TE','2144694529',0,'2014-03-03 01:00:33',NULL,NULL),(41583,27647,'TE','4403399596',0,'2014-03-05 21:30:20',NULL,NULL),(43371,28805,'AP','3304651524',0,'2014-03-09 21:00:51',NULL,NULL),(288,178,'TE','3304687733',0,'2013-12-25 17:19:36',NULL,NULL),(13720,8940,'TE','5136000476',0,'2013-12-26 04:03:19',NULL,NULL),(14934,9771,'TE','2255883823',0,'2013-12-26 05:00:28',NULL,NULL),(4196,2684,'TE','8063567451',0,'2013-12-25 19:47:18',NULL,NULL),(1978,1223,'TE','2343805675',0,'2013-12-25 18:20:28',NULL,NULL),(24499,15804,'TE','2253268805',0,'2014-01-03 02:03:00',NULL,NULL),(7696,5022,'TE','3378498109',0,'2013-12-25 22:47:34',NULL,NULL),(26764,17217,'AP','5102901430',0,'2014-01-13 02:22:32',NULL,NULL),(29259,18897,'TE','9375727135',0,'2014-01-17 03:36:35',NULL,NULL),(30368,19674,'AP','4692658042',0,'2014-01-23 21:00:34',NULL,NULL),(32502,21242,'AP','2165261925',0,'2014-02-03 21:01:13',NULL,NULL),(33015,21631,'AP','9038220286',0,'2014-02-05 21:30:41',NULL,NULL),(33424,21896,'AP','4196518215',0,'2014-02-06 21:01:43',NULL,NULL),(34926,22918,'AP','9378221336',0,'2014-02-11 21:02:53',NULL,NULL),(35469,23327,'EM','BWOYSHVILLE@HOTMAIL.COM',0,'2014-02-13 22:00:28',NULL,NULL),(36268,23870,'TE','4192765946',0,'2014-02-14 21:32:10',NULL,NULL),(36876,24288,'TE','7697987804',0,'2014-02-18 21:30:10',NULL,NULL),(38376,25348,'AP','3186072638',0,'2014-02-25 21:30:30',NULL,NULL),(40222,26679,'AP','2253310639',0,'2014-02-28 21:31:22',NULL,NULL),(40616,26962,'TE','3304596742',0,'2014-03-03 01:00:30',NULL,NULL),(41213,27373,'AP','6628099332',0,'2014-03-04 21:01:17',NULL,NULL),(7304,4754,'AP','2148010322',0,'2013-12-25 22:15:19',NULL,NULL),(9169,6002,'AP','3379401244',0,'2013-12-26 00:00:23',NULL,NULL),(3897,2474,'EM','pinky823@cox.net',0,'2013-12-25 19:35:20',NULL,NULL),(14104,9221,'EM','crazz44108@yahoo.com',0,'2013-12-26 04:10:13',NULL,NULL),(14589,9540,'TE','3306586147',0,'2013-12-26 04:35:59',NULL,NULL),(22204,14303,'AP','4193051258',0,'2013-12-27 02:06:54',NULL,NULL),(22260,14345,'TE','9376225817',0,'2013-12-27 02:08:00',NULL,NULL),(22369,14427,'EM','rafaeldelaflor@hotmail.com',0,'2013-12-28 03:31:50',NULL,NULL),(24493,15801,'BN','2252870388',0,'2014-01-03 02:02:53',NULL,NULL),(841,521,'EM','gary.shonebarger@att.net',0,'2013-12-25 17:49:14',NULL,NULL),(26156,16840,'AP','3306064586',0,'2014-01-13 02:18:33',NULL,NULL),(26632,17136,'TE','5137976989',0,'2014-01-13 02:21:49',NULL,NULL),(30311,19636,'TE','6142910106',0,'2014-01-23 21:00:12',NULL,NULL),(31515,20537,'TE','3309662362',0,'2014-01-29 21:01:33',NULL,NULL),(34904,22903,'EM','LYNETTESTEPHENS688@GMAIL.COM',0,'2014-02-11 21:02:43',NULL,NULL),(38441,25405,'TE','3608785083',0,'2014-02-25 21:30:59',NULL,NULL),(39524,26143,'AP','5315083750',0,'2014-02-28 06:30:26',NULL,NULL),(8247,5394,'EM','patricia_ringo@yahoo.com',0,'2013-12-25 23:08:46',NULL,NULL),(1707,1049,'TE','9403373259',0,'2013-12-25 18:15:59',NULL,NULL),(11177,7269,'TE','5712961716',0,'2013-12-26 02:02:22',NULL,NULL),(11357,7398,'EM','MELINDASOLOMON@GMAIL.COM',0,'2013-12-26 02:16:21',NULL,NULL),(3382,2127,'TE','9375264412',0,'2013-12-25 19:17:52',NULL,NULL),(4252,2720,'EM','denisedobbins@gmail.com',0,'2013-12-25 19:48:11',NULL,NULL),(24175,15620,'AP','6628912497',1,'2014-01-02 04:33:07',NULL,NULL),(24335,15718,'AP','6144778992',0,'2014-01-03 02:00:07',NULL,NULL),(6540,4228,'EM','jacqueline.wisner1@gmail.com',0,'2013-12-25 21:50:38',NULL,NULL),(7339,4771,'TE','5138295736',0,'2013-12-25 22:15:50',NULL,NULL),(25412,16392,'AP','9568020225',0,'2014-01-07 04:03:37',NULL,NULL),(30517,19795,'EM','roxy_nicole219@hotmail.com',0,'2014-01-23 21:01:44',NULL,NULL),(30736,19970,'BN','4402271741',0,'2014-01-25 19:00:11',NULL,NULL),(32357,21142,'AP','5127043382',0,'2014-02-03 21:00:23',NULL,NULL),(32747,21422,'EM','L3haddad@gmail.com',0,'2014-02-04 21:01:14',NULL,NULL),(38006,25072,'AP','4192354101',0,'2014-02-20 22:01:31',NULL,NULL),(38673,25562,'TE','2143649092',0,'2014-02-26 08:00:23',NULL,NULL),(39466,26098,'TE','5043439896',0,'2014-02-28 06:30:11',NULL,NULL),(41647,27684,'TE','4322221489',0,'2014-03-05 21:30:40',NULL,NULL),(43709,29017,'AP','9375421569',0,'2014-03-10 21:01:27',NULL,NULL),(1186,725,'AP','2819170324',0,'2013-12-25 18:03:36',NULL,NULL),(12317,8053,'TE','5672770447',0,'2013-12-26 03:09:46',NULL,NULL),(9934,6502,'TE','4409341730',0,'2013-12-26 00:50:52',NULL,NULL),(21394,13757,'AP','6012912205',0,'2013-12-26 13:10:06',NULL,NULL),(9539,6245,'AP','4195156180',0,'2013-12-26 00:31:46',NULL,NULL),(3656,2316,'AP','8328453384',0,'2013-12-25 19:31:19',NULL,NULL),(3651,2313,'EM','jenne@jaeb.net',0,'2013-12-25 19:31:14',NULL,NULL),(22564,14551,'AP','2168565611',0,'2013-12-28 03:35:03',NULL,NULL),(7169,4675,'AP','3373499411',0,'2013-12-25 22:07:44',NULL,NULL),(2639,1605,'AP','9406745555',0,'2013-12-25 18:52:09',NULL,NULL),(1853,1146,'TE','4106032905',0,'2013-12-25 18:18:28',NULL,NULL),(1348,823,'TE','7078158061',0,'2013-12-25 18:06:09',NULL,NULL),(23100,14896,'TE','3185358104',0,'2013-12-30 00:00:57',NULL,NULL),(24704,15935,'EM','dlhumm@gmail.com',0,'2014-01-03 02:07:03',NULL,NULL),(24744,15966,'TE','9033098550',0,'2014-01-04 02:00:28',NULL,NULL),(25070,16163,'AP','7134599700',0,'2014-01-04 06:00:14',NULL,NULL),(28779,18572,'TE','3309621987',0,'2014-01-16 08:47:05',NULL,NULL),(28892,18653,'TE','3616960581',0,'2014-01-17 03:35:11',NULL,NULL),(29106,18794,'TE','6148862097',0,'2014-01-17 03:35:58',NULL,NULL),(29263,18899,'TE','4194900883',0,'2014-01-17 03:36:36',NULL,NULL),(30810,20032,'EM','msjazz73@yahoo.com',0,'2014-01-26 19:00:21',NULL,NULL),(31687,20670,'EM','kimkimburbrough@gmail.com',0,'2014-01-30 21:00:49',NULL,NULL),(34971,22958,'AP','5049059596',0,'2014-02-12 21:00:07',NULL,NULL),(38061,25120,'TE','7402527741',0,'2014-02-21 21:30:21',NULL,NULL),(43663,28977,'EM','johnny.smatana@gmail.com',0,'2014-03-10 21:01:07',NULL,NULL),(2926,1797,'EM','remington.merry@gmail.com',0,'2013-12-25 18:56:41',NULL,NULL),(3576,2240,'EM','tlperryman@gmail.com',0,'2013-12-25 19:21:01',NULL,NULL),(24963,16090,'TE','6015949316',0,'2014-01-04 02:04:23',NULL,NULL),(22855,14748,'TE','5135530030',1,'2013-12-29 11:10:13',NULL,NULL),(21813,14053,'EM','maitredaubergine@outlook.com',0,'2013-12-27 02:00:22',NULL,NULL),(21270,13667,'TE','3184456019',0,'2013-12-26 13:07:49',NULL,NULL),(11846,7706,'EM','topofmygamez@gmail.com',0,'2013-12-26 03:01:24',NULL,NULL),(13875,9050,'EM','DOUGLAS-LUCAK@SBCGLOBAL.NET',0,'2013-12-26 04:06:00',NULL,NULL),(30061,19472,'AP','9562405572',0,'2014-01-23 03:02:00',NULL,NULL),(31565,20583,'EM','lgsusman@gmail.com',0,'2014-01-30 21:00:05',NULL,NULL),(32236,21055,'TE','5168575180',0,'2014-02-02 19:00:08',NULL,NULL),(38003,25070,'AP','5133055805',0,'2014-02-20 22:01:30',NULL,NULL),(11930,7771,'TE','9409234361',0,'2013-12-26 03:02:55',NULL,NULL),(31164,20294,'TE','5044536153',0,'2014-01-28 21:00:39',NULL,NULL),(29312,18938,'AP','5133687611',0,'2014-01-20 08:05:43',NULL,NULL),(27872,17960,'AP','9035194060',0,'2014-01-15 02:06:46',NULL,NULL),(7524,4904,'AP','5135501146',0,'2013-12-25 22:31:53',NULL,NULL),(23523,15175,'TE','6145890208',0,'2014-01-01 12:06:41',NULL,NULL),(33439,21902,'EM','mooremallory13@gmail.com',0,'2014-02-06 21:01:48',NULL,NULL),(34068,22334,'EM','dalejrlvr2005@aol.com',0,'2014-02-10 11:01:03',NULL,NULL),(36075,23730,'TE','4193097907',0,'2014-02-14 21:30:57',NULL,NULL),(36391,23968,'AP','3619441199',0,'2014-02-15 22:00:12',NULL,NULL),(36419,23986,'BN','3373492733',0,'2014-02-15 22:00:23',NULL,NULL),(41453,27546,'AP','6149007039',0,'2014-03-04 21:30:09',NULL,NULL),(22392,14442,'EM','toyalbrown@yahoo.com',0,'2013-12-28 03:32:14',NULL,NULL),(28648,18476,'TE','3302524662',0,'2014-01-16 08:46:19',NULL,NULL),(32511,21252,'AP','3306181969',0,'2014-02-03 21:01:18',NULL,NULL),(32706,21394,'BN','5136418704',0,'2014-02-04 21:00:59',NULL,NULL),(40364,26791,'TE','3186584370',0,'2014-03-01 21:00:18',NULL,NULL),(3038,1891,'AP','5138462130',0,'2013-12-25 18:58:51',NULL,NULL),(30902,20090,'AP','2252350647',0,'2014-01-27 21:00:29',NULL,NULL),(30091,19496,'TE','8436162708',0,'2014-01-23 03:02:08',NULL,NULL),(29261,18897,'EM','judyhoward1977@yahoo.com',0,'2014-01-17 03:36:35',NULL,NULL),(25129,16200,'TE','4074564332',0,'2014-01-05 00:01:06',NULL,NULL),(24263,15681,'AP','4194942498',1,'2014-01-02 04:34:59',NULL,NULL),(23769,15330,'TE','9155002910',1,'2014-01-02 04:23:54',NULL,NULL),(10749,6988,'AP','5136154365',0,'2013-12-26 01:47:55',NULL,NULL),(9085,5955,'AP','5672185244',0,'2013-12-25 23:51:13',NULL,NULL),(38892,25708,'AP','9568258326',0,'2014-02-26 09:30:22',NULL,NULL),(13786,8985,'TE','8632931580',0,'2013-12-26 04:04:26',NULL,NULL),(5879,3772,'TE','2346780781',0,'2013-12-25 21:33:44',NULL,NULL),(28985,18708,'TE','5139240425',0,'2014-01-17 03:35:31',NULL,NULL),(28637,18464,'AP','9855101232',0,'2014-01-16 08:46:14',NULL,NULL),(5527,3535,'TE','9726913202',0,'2013-12-25 21:21:37',NULL,NULL),(11069,7189,'TE','5138892606',0,'2013-12-26 02:00:23',NULL,NULL),(1797,1114,'AP','5133384305',0,'2013-12-25 18:17:36',NULL,NULL),(32027,20906,'TE','5137838839',0,'2014-01-31 21:01:24',NULL,NULL),(32516,21257,'TE','3302121492',0,'2014-02-03 21:01:21',NULL,NULL),(41664,27696,'TE','9033905374',0,'2014-03-05 21:30:47',NULL,NULL),(42595,28339,'AP','9728163897',0,'2014-03-07 21:30:16',NULL,NULL),(42699,28402,'EM','mz.booba@yahoo.com',0,'2014-03-07 21:30:52',NULL,NULL),(43153,28680,'EM','lisampeters34@yahoo.com',0,'2014-03-08 21:30:56',NULL,NULL),(269,165,'EM','shy16kev@yahoo.com',0,'2013-12-25 17:19:18',NULL,NULL),(30721,19961,'TE','7192371287',0,'2014-01-25 19:00:07',NULL,NULL),(28964,18694,'EM','dannel07@gmail.com',0,'2014-01-17 03:35:26',NULL,NULL),(11795,7671,'EM','watkinsstucco@hotmail.com',0,'2013-12-26 03:00:35',NULL,NULL),(22257,14342,'EM','johnsfrance@gmail.com',0,'2013-12-27 02:07:56',NULL,NULL),(4298,2743,'AP','3304648589',0,'2013-12-25 19:48:51',NULL,NULL),(4026,2570,'EM','adventurebound24@gmail.com',0,'2013-12-25 19:37:40',NULL,NULL),(3416,2145,'EM','musicgiver@gmail.com',0,'2013-12-25 19:18:24',NULL,NULL),(11580,7535,'TE','9728676439',0,'2013-12-26 02:32:47',NULL,NULL),(33323,21828,'TE','2105198150',0,'2014-02-06 21:01:03',NULL,NULL),(42182,28020,'AP','2165540255',0,'2014-03-06 21:01:21',NULL,NULL),(776,484,'TE','9854671034',0,'2013-12-25 17:48:15',NULL,NULL),(30750,19980,'TE','4407779146',0,'2014-01-25 19:00:15',NULL,NULL),(28774,18566,'TE','3302975237',0,'2014-01-16 08:47:02',NULL,NULL),(12209,7978,'TE','3305921276',0,'2013-12-26 03:07:53',NULL,NULL),(22770,14682,'TE','9373075001',1,'2013-12-29 11:08:36',NULL,NULL),(8410,5538,'AP','7402290543',0,'2013-12-25 23:15:44',NULL,NULL),(7536,4910,'AP','8062817531',0,'2013-12-25 22:32:05',NULL,NULL),(11714,7626,'AP','4193082555',0,'2013-12-26 02:46:05',NULL,NULL),(4266,2728,'EM','stacimbruce@gmail.com',0,'2013-12-25 19:48:24',NULL,NULL),(33192,21736,'TE','9797776107',0,'2014-02-06 21:00:12',NULL,NULL),(42028,27934,'TE','8062923445',0,'2014-03-06 21:00:27',NULL,NULL),(7865,5131,'AP','2108655469',0,'2013-12-25 23:02:14',NULL,NULL),(28147,18144,'AP','9852646557',0,'2014-01-15 02:07:48',NULL,NULL),(7690,5016,'TE','4194763267',0,'2013-12-25 22:47:26',NULL,NULL),(23083,14889,'AP','3186143980',0,'2013-12-30 00:00:44',NULL,NULL),(22923,14790,'TE','9374291832',1,'2013-12-29 11:13:29',NULL,NULL),(10948,7116,'TE','9373781820',0,'2013-12-26 01:51:12',NULL,NULL),(4599,2934,'TE','4193683831',0,'2013-12-25 20:16:05',NULL,NULL),(37031,24381,'AP','5132274656',0,'2014-02-18 22:00:44',NULL,NULL),(39039,25814,'AP','4402544129',0,'2014-02-26 21:00:24',NULL,NULL),(2012,1246,'EM','gary_grooms_45616@yahoo.com',0,'2013-12-25 18:21:05',NULL,NULL),(28312,18249,'AP','4694505851',0,'2014-01-16 08:44:29',NULL,NULL),(9496,6212,'AP','2088597860',0,'2013-12-26 00:30:56',NULL,NULL),(4790,3064,'AP','2258923985',0,'2013-12-25 20:19:16',NULL,NULL),(34701,22754,'EM','mbrown3049@aol.com',0,'2014-02-11 21:01:28',NULL,NULL),(35033,23008,'TE','3184730904',0,'2014-02-12 21:30:22',NULL,NULL),(7777,5073,'AP','5127719436',0,'2013-12-25 23:00:48',NULL,NULL),(10592,6892,'TE','2259216449',0,'2013-12-26 01:45:25',NULL,NULL),(27118,17457,'AP','5672270477',0,'2014-01-13 03:00:40',NULL,NULL),(2221,1366,'AP','8304778289',0,'2013-12-25 18:45:38',NULL,NULL),(5918,3796,'TE','7248549029',0,'2013-12-25 21:34:23',NULL,NULL),(4496,2860,'EM','amylee06@gmail.com',0,'2013-12-25 20:01:36',NULL,NULL),(35233,23138,'AP','3305191871',0,'2014-02-12 21:31:35',NULL,NULL),(43972,29171,'TE','9494441306',0,'2014-03-10 21:02:59',NULL,NULL),(12230,7995,'TE','3303045712',0,'2013-12-26 03:08:15',NULL,NULL),(2693,1635,'EM','treesqu@aol.com',0,'2013-12-25 18:52:57',NULL,NULL),(9897,6474,'EM','adamnora@juno.com',0,'2013-12-26 00:50:12',NULL,NULL),(1997,1233,'EM','fheuer@bellsouth.net',0,'2013-12-25 18:20:47',NULL,NULL),(11918,7757,'TE','6146345319',0,'2013-12-26 03:02:41',NULL,NULL),(36001,23683,'AP','3306878875',0,'2014-02-14 21:30:32',NULL,NULL),(11184,7272,'TE','9034723275',0,'2013-12-26 02:02:28',NULL,NULL),(29093,18789,'BN','8284215716',0,'2014-01-17 03:35:55',NULL,NULL),(10934,7109,'EM','Mendezm67@gmail.com',0,'2013-12-26 01:50:59',NULL,NULL),(21473,13797,'AP','6015069342',0,'2013-12-26 13:11:17',NULL,NULL),(21763,14019,'AP','6782302344',0,'2013-12-26 13:16:35',NULL,NULL),(40517,26892,'BN','9372123914',0,'2014-03-03 01:00:03',NULL,NULL),(983,606,'TE','4407255168',0,'2013-12-25 18:00:27',NULL,NULL),(32230,21051,'TE','7407771365',0,'2014-02-02 19:00:06',NULL,NULL),(29253,18893,'TE','3308255252',0,'2014-01-17 03:36:33',NULL,NULL),(10057,6576,'EM','hattielewis@hotmail.com',0,'2013-12-26 00:52:50',NULL,NULL),(26002,16752,'EM','keller365@aol.com',0,'2014-01-08 18:24:55',NULL,NULL),(35744,23506,'AP','2818023008',0,'2014-02-13 22:02:11',NULL,NULL),(36620,24109,'AP','9563071941',0,'2014-02-15 22:01:35',NULL,NULL),(8867,5810,'TE','2816858912',0,'2013-12-25 23:47:45',NULL,NULL),(28916,18667,'TE','8172171322',0,'2014-01-17 03:35:16',NULL,NULL),(22232,14329,'AP','4192831595',0,'2013-12-27 02:07:30',NULL,NULL),(21556,13861,'TE','3306262046',0,'2013-12-26 13:12:49',NULL,NULL),(6666,4326,'TE','9372196167',0,'2013-12-25 21:52:55',NULL,NULL),(7482,4869,'TE','3187324338',0,'2013-12-25 22:30:57',NULL,NULL),(10390,6771,'AP','3309836573',0,'2013-12-26 01:16:39',NULL,NULL),(8597,5650,'EM','floridajim54@gmail.com',0,'2013-12-25 23:31:29',NULL,NULL),(3784,2401,'TE','5132534594',0,'2013-12-25 19:33:33',NULL,NULL),(3072,1915,'TE','4195699644',0,'2013-12-25 19:00:03',NULL,NULL),(35893,23611,'TE','9374074091',0,'2014-02-13 22:03:12',NULL,NULL),(38360,25338,'EM','Fowlersheating@yahoo.com',0,'2014-02-25 21:30:23',NULL,NULL),(755,474,'TE','2257575296',0,'2013-12-25 17:47:58',NULL,NULL),(861,537,'AP','6014970950',0,'2013-12-25 17:49:36',NULL,NULL),(31230,20339,'AP','5048744564',0,'2014-01-28 21:01:07',NULL,NULL),(30467,19752,'TE','5677127899',0,'2014-01-23 21:01:18',NULL,NULL),(3236,2034,'EM','jobeth.plummer@yahoo.com',0,'2013-12-25 19:15:26',NULL,NULL),(4830,3091,'TE','9372788345',0,'2013-12-25 20:20:01',NULL,NULL),(23311,15021,'TE','2252356241',0,'2014-01-01 12:02:19',NULL,NULL),(41540,27622,'AP','3377393639',0,'2014-03-05 21:30:05',NULL,NULL),(42378,28145,'TE','5138517922',0,'2014-03-06 21:02:33',NULL,NULL),(14359,9386,'EM','G6MARTIN@SUNLINK.NET',0,'2013-12-26 04:32:14',NULL,NULL),(28306,18245,'AP','2146207357',0,'2014-01-16 08:44:27',NULL,NULL),(24791,15992,'TE','4322144644',0,'2014-01-04 02:01:17',NULL,NULL),(11414,7426,'AP','3302194211',0,'2013-12-26 02:17:13',NULL,NULL),(12225,7989,'AP','3303389676',0,'2013-12-26 03:08:08',NULL,NULL),(36854,24268,'AP','3372249671',0,'2014-02-17 19:00:15',NULL,NULL),(11534,7507,'EM','susannahritter@yahoo.com',0,'2013-12-26 02:32:01',NULL,NULL),(293,181,'EM','kmcmaho3@kent.edu',0,'2013-12-25 17:19:41',NULL,NULL),(24151,15607,'AP','5135058189',1,'2014-01-02 04:32:43',NULL,NULL),(10651,6924,'EM','ggivens80@gmail.com',0,'2013-12-26 01:46:19',NULL,NULL),(4919,3159,'TE','4193573185',0,'2013-12-25 20:31:15',NULL,NULL),(21632,13925,'EM','amyjoarps@gmail.com',0,'2013-12-26 13:14:17',NULL,NULL),(6995,4568,'TE','9729071906',0,'2013-12-25 22:04:54',NULL,NULL),(2698,1640,'EM','Vickespinoza@yahoo.com',0,'2013-12-25 18:53:03',NULL,NULL),(1243,756,'AP','3252624455',0,'2013-12-25 18:04:26',NULL,NULL),(35795,23537,'AP','3184163367',0,'2014-02-13 22:02:30',NULL,NULL),(37136,24445,'EM','keichert@cinci.rr.com',0,'2014-02-18 22:01:22',NULL,NULL),(37755,24913,'AP','6148050443',0,'2014-02-20 21:30:09',NULL,NULL),(1006,619,'EM','francistps@aol.com',0,'2013-12-25 18:00:48',NULL,NULL),(23779,15337,'TE','4193025688',1,'2014-01-02 04:24:06',NULL,NULL),(26594,17109,'EM','edillion@yahoo.com',0,'2014-01-13 02:21:36',NULL,NULL),(24238,15659,'TE','4193310524',1,'2014-01-02 04:34:23',NULL,NULL),(4971,3190,'TE','4194260874',0,'2013-12-25 20:32:07',NULL,NULL),(30340,19661,'TE','9372124146',0,'2014-01-23 21:00:24',NULL,NULL),(28769,18562,'EM','kwaynesmalley@gmail.com',0,'2014-01-16 08:47:00',NULL,NULL),(27728,17872,'AP','9375523111',0,'2014-01-15 02:06:14',NULL,NULL),(2276,1396,'AP','2254029282',0,'2013-12-25 18:46:29',NULL,NULL),(25398,16380,'AP','3617228144',0,'2014-01-07 04:03:18',NULL,NULL),(23465,15133,'EM','wilburdoughty@gmail.com',0,'2014-01-01 12:05:29',NULL,NULL),(7721,5042,'TE','9038256611',0,'2013-12-25 22:48:02',NULL,NULL),(7493,4878,'AP','9723427208',0,'2013-12-25 22:31:11',NULL,NULL),(1227,748,'EM','patrickhartrington75@yahoo.com',0,'2013-12-25 18:04:13',NULL,NULL),(38409,25378,'TE','5134776484',0,'2014-02-25 21:30:44',NULL,NULL),(43479,28873,'AP','9033682282',0,'2014-03-10 21:00:04',NULL,NULL),(20361,13117,'TE','3304676675',0,'2013-12-26 12:52:38',NULL,NULL),(10202,6665,'EM','junglau@live.com',0,'2013-12-26 01:00:59',NULL,NULL),(8126,5321,'AP','5134320717',0,'2013-12-25 23:06:49',NULL,NULL),(10045,6571,'TE','9857050856',0,'2013-12-26 00:52:41',NULL,NULL),(42049,27944,'TE','2145073830',0,'2014-03-06 21:00:34',NULL,NULL),(21065,13548,'EM','evilene248@gmail.com',0,'2013-12-26 13:04:00',NULL,NULL),(1004,618,'AP','4193066159',0,'2013-12-25 18:00:46',NULL,NULL),(26233,16884,'EM','calliehudson@gmail.com',0,'2014-01-13 02:19:23',NULL,NULL),(8385,5519,'AP','5134784383',0,'2013-12-25 23:15:17',NULL,NULL),(10718,6972,'TE','5132630514',0,'2013-12-26 01:47:29',NULL,NULL),(10038,6567,'TE','2548982017',0,'2013-12-26 00:52:34',NULL,NULL),(33930,22267,'AP','7137828896',0,'2014-02-10 11:00:12',NULL,NULL),(34295,22500,'EM','jasonlin988@gmail.com',0,'2014-02-10 21:31:13',NULL,NULL),(34573,22670,'AP','9362012187',0,'2014-02-11 21:00:41',NULL,NULL),(36069,23723,'AP','2148753888',0,'2014-02-14 21:30:54',NULL,NULL),(38542,25468,'AP','8304566523',0,'2014-02-25 21:31:35',NULL,NULL),(41835,27815,'TE','3303745305',0,'2014-03-05 21:31:53',NULL,NULL),(21762,14019,'TE','6782302344',0,'2013-12-26 13:16:34',NULL,NULL),(4355,2778,'AP','6625781627',0,'2013-12-25 19:49:46',NULL,NULL),(29439,19035,'TE','6018967369',0,'2014-01-20 08:06:34',NULL,NULL),(27945,18007,'TE','7406304718',0,'2014-01-15 02:07:02',NULL,NULL),(8103,5305,'EM','ZAKIASIMPSON@GMAIL.COM',0,'2013-12-25 23:06:25',NULL,NULL),(37276,24531,'TE','9562517685',0,'2014-02-20 04:00:35',NULL,NULL),(38123,25164,'TE','3302726492',0,'2014-02-21 22:00:24',NULL,NULL),(38695,25571,'EM','jamesdickerson4192000@yahoo.com',0,'2014-02-26 08:00:31',NULL,NULL),(41621,27669,'TE','9569698088',0,'2014-03-05 21:30:33',NULL,NULL),(34,24,'AP','9106851867',0,'2013-12-25 17:15:36',NULL,NULL),(9130,5978,'TE','5135821094',0,'2013-12-25 23:51:53',NULL,NULL),(29391,18996,'TE','3303453741',0,'2014-01-20 08:06:13',NULL,NULL),(27256,17549,'TE','9375442062',0,'2014-01-13 03:01:53',NULL,NULL),(5447,3488,'TE','4405362027',0,'2013-12-25 21:20:22',NULL,NULL),(11227,7304,'TE','3308822412',0,'2013-12-26 02:03:13',NULL,NULL),(33362,21857,'TE','4197255461',0,'2014-02-06 21:01:18',NULL,NULL),(35929,23639,'AP','5126278299',0,'2014-02-14 21:30:08',NULL,NULL),(9387,6143,'TE','3302243582',0,'2013-12-26 00:16:20',NULL,NULL),(1658,1018,'TE','6014076080',0,'2013-12-25 18:15:10',NULL,NULL),(3345,2103,'AP','6148066472',0,'2013-12-25 19:17:14',NULL,NULL),(33511,21964,'AP','9377070358',0,'2014-02-07 19:00:27',NULL,NULL),(34521,22647,'AP','5127589845',0,'2014-02-11 21:00:25',NULL,NULL),(35785,23533,'TE','5049130952',0,'2014-02-13 22:02:27',NULL,NULL),(36208,23833,'AP','2283265508',0,'2014-02-14 21:31:47',NULL,NULL),(42540,28303,'TE','9375091339',0,'2014-03-07 21:00:33',NULL,NULL),(43434,28846,'EM','jeffjones626@gmail.com',0,'2014-03-09 21:01:15',NULL,NULL),(21377,13744,'AP','5132662833',0,'2013-12-26 13:09:48',NULL,NULL),(21079,13556,'TE','2257513960',0,'2013-12-26 13:04:14',NULL,NULL),(21102,13567,'TE','5043122336',0,'2013-12-26 13:04:33',NULL,NULL),(28936,18682,'AP','8323159335',0,'2014-01-17 03:35:21',NULL,NULL),(25375,16364,'AP','6015042092',0,'2014-01-07 04:02:52',NULL,NULL),(27141,17476,'EM','airandwaters@gmail.com',0,'2014-01-13 03:01:10',NULL,NULL),(39429,26078,'TE','3184428271',0,'2014-02-28 06:30:03',NULL,NULL),(43116,28663,'EM','megancomo@gmail.com',0,'2014-03-08 21:30:44',NULL,NULL),(20516,13207,'AP','2146816452',0,'2013-12-26 12:55:08',NULL,NULL),(32470,21215,'AP','2252356479',0,'2014-02-03 21:01:01',NULL,NULL),(9151,5993,'EM','opicana@gmail.com',0,'2013-12-26 00:00:08',NULL,NULL),(1905,1178,'TE','5135201677',0,'2013-12-25 18:19:18',NULL,NULL),(27197,17514,'AP','3304416466',0,'2014-01-13 03:01:32',NULL,NULL),(25694,16563,'AP','2283800493',1,'2014-01-07 10:23:08',NULL,NULL),(7254,4730,'TE','4196010248',0,'2013-12-25 22:09:09',NULL,NULL),(2974,1843,'AP','3302836353',0,'2013-12-25 18:57:42',NULL,NULL),(36480,24016,'TE','9374799812',0,'2014-02-15 22:00:44',NULL,NULL),(37536,24714,'EM','tkunsman@gmail.com',0,'2014-02-20 04:37:00',NULL,NULL),(39178,25914,'AP','9037140341',0,'2014-02-26 21:01:16',NULL,NULL),(10802,7019,'TE','8062526676',0,'2013-12-26 01:48:47',NULL,NULL),(30480,19762,'EM','wperkins2@comcast.net',0,'2014-01-23 21:01:25',NULL,NULL),(28745,18549,'TE','2282338843',0,'2014-01-16 08:46:53',NULL,NULL),(25084,16173,'TE','2253615221',0,'2014-01-05 00:00:18',NULL,NULL),(26434,17007,'TE','3308892216',0,'2014-01-13 02:20:35',NULL,NULL),(37845,24969,'TE','4096989390',0,'2014-02-20 22:00:25',NULL,NULL),(39853,26361,'EM','bjbowling500@yahoo.com',0,'2014-02-28 07:00:05',NULL,NULL),(40127,26610,'AP','9034136140',0,'2014-02-28 21:30:47',NULL,NULL),(40916,27189,'TE','9563138844',0,'2014-03-03 21:31:15',NULL,NULL),(30069,19476,'AP','4692376352',0,'2014-01-23 03:02:02',NULL,NULL),(30252,19595,'TE','3307302937',0,'2014-01-23 03:02:46',NULL,NULL),(34101,22351,'TE','5043521734',0,'2014-02-10 21:00:03',NULL,NULL),(34954,22947,'AP','6018260504',0,'2014-02-11 21:30:25',NULL,NULL),(37664,24832,'AP','6019419363',0,'2014-02-20 04:52:37',NULL,NULL),(406,249,'TE','3183239907',0,'2013-12-25 17:21:32',NULL,NULL),(31619,20625,'TE','9563509584',0,'2014-01-30 21:00:25',NULL,NULL),(1312,801,'TE','9562203752',0,'2013-12-25 18:05:34',NULL,NULL),(29735,19227,'AP','4192178846',0,'2014-01-21 08:46:30',NULL,NULL),(6013,3860,'EM','rlaurie6592@gmail.com',0,'2013-12-25 21:35:55',NULL,NULL),(3680,2334,'EM','cmb4626@yahoo.com',0,'2013-12-25 19:31:47',NULL,NULL),(8252,5397,'AP','3187379994',0,'2013-12-25 23:08:51',NULL,NULL),(34476,22621,'TE','5128180309',0,'2014-02-11 21:00:10',NULL,NULL),(35735,23503,'AP','9032385220',0,'2014-02-13 22:02:09',NULL,NULL),(43810,29081,'BN','6629029118',0,'2014-03-10 21:02:04',NULL,NULL),(21118,13578,'AP','3373094808',0,'2013-12-26 13:04:50',NULL,NULL),(30063,19473,'AP','9562405572',0,'2014-01-23 03:02:00',NULL,NULL),(29463,19048,'AP','5044512210',0,'2014-01-20 08:06:42',NULL,NULL),(20607,13253,'AP','9728499028',0,'2013-12-26 12:56:28',NULL,NULL),(7782,5079,'TE','3256461035',0,'2013-12-25 23:00:55',NULL,NULL),(13976,9117,'EM','AMOSELLIS88@GMAIL.COM',0,'2013-12-26 04:07:41',NULL,NULL),(27493,17710,'TE','2257237231',0,'2014-01-14 01:33:09',NULL,NULL),(27371,17621,'TE','8172285287',0,'2014-01-14 01:32:27',NULL,NULL),(12135,7929,'TE','2256208215',0,'2013-12-26 03:06:34',NULL,NULL),(8821,5776,'AP','6145788309',0,'2013-12-25 23:46:55',NULL,NULL),(1185,725,'TE','2819170324',0,'2013-12-25 18:03:36',NULL,NULL),(37855,24973,'AP','9799974088',0,'2014-02-20 22:00:28',NULL,NULL),(38191,25206,'AP','3377805973',0,'2014-02-21 22:00:49',NULL,NULL),(39377,26044,'TE','3302892620',0,'2014-02-26 21:02:28',NULL,NULL),(43286,28758,'AP','9795873204',0,'2014-03-09 21:00:21',NULL,NULL),(1336,817,'TE','3307222541',0,'2013-12-25 18:05:59',NULL,NULL),(1455,891,'TE','9374862050',0,'2013-12-25 18:07:59',NULL,NULL),(23933,15443,'AP','7132317713',1,'2014-01-02 04:28:07',NULL,NULL),(14102,9221,'TE','2162491517',0,'2013-12-26 04:10:12',NULL,NULL),(3306,2080,'AP','5043120292',0,'2013-12-25 19:16:36',NULL,NULL),(5335,3419,'TE','5044443142',0,'2013-12-25 21:18:36',NULL,NULL),(4020,2566,'TE','4192046015',0,'2013-12-25 19:37:34',NULL,NULL),(4915,3157,'AP','2163014801',0,'2013-12-25 20:31:12',NULL,NULL),(3171,1987,'AP','8176816774',0,'2013-12-25 19:01:52',NULL,NULL),(27190,17510,'EM','davis.david.t@gmail.com',0,'2014-01-13 03:01:29',NULL,NULL),(28164,18153,'EM','cgood35@woh.rr.com',0,'2014-01-15 02:07:51',NULL,NULL),(28673,18497,'TE','4403273649',0,'2014-01-16 08:46:28',NULL,NULL),(33368,21864,'TE','5137222492',0,'2014-02-06 21:01:22',NULL,NULL),(36664,24137,'AP','4194941874',0,'2014-02-15 22:01:51',NULL,NULL),(38863,25686,'AP','4049084069',0,'2014-02-26 09:30:09',NULL,NULL),(43614,28953,'AP','5047290565',0,'2014-03-10 21:00:51',NULL,NULL),(25327,16331,'EM','deatra_jones@yahoo.com',0,'2014-01-07 04:02:01',NULL,NULL),(675,421,'AP','9373696753',0,'2013-12-25 17:46:39',NULL,NULL),(25310,16321,'TE','2252356241',0,'2014-01-07 04:01:42',NULL,NULL),(8330,5461,'EM','lbonem@gmail.com',0,'2013-12-25 23:10:25',NULL,NULL),(930,572,'EM','kwagner@709design.com',0,'2013-12-25 17:50:39',NULL,NULL),(6700,4354,'EM','pastor@wocchurch.org',0,'2013-12-25 21:53:34',NULL,NULL),(1979,1224,'TE','2345212972',0,'2013-12-25 18:20:30',NULL,NULL),(2043,1266,'TE','9563462843',0,'2013-12-25 18:30:07',NULL,NULL),(5730,3674,'EM','HWANGINAE73@GMAIL.COM',0,'2013-12-25 21:31:16',NULL,NULL),(24491,15801,'TE','2252870388',0,'2014-01-03 02:02:52',NULL,NULL),(5014,3218,'AP','2163902111',0,'2013-12-25 20:45:38',NULL,NULL),(4901,3146,'AP','9565697381',0,'2013-12-25 20:30:56',NULL,NULL),(4628,2950,'TE','6147787955',0,'2013-12-25 20:16:31',NULL,NULL),(21983,14159,'AP','5105418330',0,'2013-12-27 02:03:08',NULL,NULL),(10958,7122,'AP','6016248961',0,'2013-12-26 01:51:22',NULL,NULL),(20971,13498,'TE','5137429996',0,'2013-12-26 13:02:32',NULL,NULL),(20964,13486,'AP','4402213935',0,'2013-12-26 13:02:22',NULL,NULL),(29578,19111,'AP','9377078597',0,'2014-01-21 08:44:45',NULL,NULL),(32459,21207,'TE','3189926905',0,'2014-02-03 21:00:57',NULL,NULL),(32670,21367,'TE','5123129724',0,'2014-02-04 21:00:46',NULL,NULL),(33065,21658,'AP','3375798229',0,'2014-02-05 21:30:53',NULL,NULL),(37024,24377,'TE','5133491384',0,'2014-02-18 22:00:42',NULL,NULL),(40599,26951,'TE','4197527432',0,'2014-03-03 01:00:26',NULL,NULL),(40836,27135,'EM','patf_79@yahoo.com',0,'2014-03-03 21:30:43',NULL,NULL),(41524,27609,'EM','noemibucalan@yahoo.com',0,'2014-03-05 21:00:27',NULL,NULL),(42794,28460,'TE','3372581716',0,'2014-03-07 21:31:25',NULL,NULL),(24122,15572,'EM','stp3r@sssnet.com',1,'2014-01-02 04:31:56',NULL,NULL),(23943,15449,'AP','9405073176',1,'2014-01-02 04:28:19',NULL,NULL),(22192,14295,'TE','3308824023',0,'2013-12-27 02:06:42',NULL,NULL),(6398,4127,'TE','9372783836',0,'2013-12-25 21:48:18',NULL,NULL),(10940,7112,'TE','3188652672',0,'2013-12-26 01:51:04',NULL,NULL),(5021,3222,'TE','3308023158',0,'2013-12-25 20:45:46',NULL,NULL),(4617,2944,'TE','3307509406',0,'2013-12-25 20:16:20',NULL,NULL),(32356,21142,'TE','5127043382',0,'2014-02-03 21:00:22',NULL,NULL),(33337,21838,'TE','5132313633',0,'2014-02-06 21:01:08',NULL,NULL),(34022,22314,'TE','3378027834',0,'2014-02-10 11:00:48',NULL,NULL),(34474,22620,'TE','5052352666',0,'2014-02-11 21:00:10',NULL,NULL),(38786,25642,'TE','3306586446',0,'2014-02-26 08:30:32',NULL,NULL),(39169,25909,'TE','9156306832',0,'2014-02-26 21:01:13',NULL,NULL),(39279,25990,'TE','6018457094',0,'2014-02-26 21:01:56',NULL,NULL),(40277,26717,'AP','7692334050',0,'2014-02-28 21:31:42',NULL,NULL),(41508,27593,'EM','curvaceouswomanstore@gmail.com',0,'2014-03-05 21:00:19',NULL,NULL),(42239,28058,'TE','7403792853',0,'2014-03-06 21:01:42',NULL,NULL),(42487,28253,'TE','4193478570',0,'2014-03-07 21:00:14',NULL,NULL),(25408,16390,'AP','3612151447',0,'2014-01-07 04:03:33',NULL,NULL),(8386,5519,'EM','bvalley@fuse.net',0,'2013-12-25 23:15:17',NULL,NULL),(24914,16060,'EM','aljones0206@gmail.com',0,'2014-01-04 02:03:29',NULL,NULL),(10132,6624,'TE','4194601465',0,'2013-12-26 00:54:09',NULL,NULL),(3755,2381,'AP','5138840218',0,'2013-12-25 19:33:02',NULL,NULL),(3208,2015,'TE','3309230451',0,'2013-12-25 19:02:37',NULL,NULL),(30185,19555,'AP','9852592732',0,'2014-01-23 03:02:31',NULL,NULL),(34792,22821,'AP','3302897295',0,'2014-02-11 21:02:02',NULL,NULL),(37061,24405,'TE','7408197187',0,'2014-02-18 22:00:57',NULL,NULL),(39831,26344,'EM','KDAVIS5916@GMAIL.COM',0,'2014-02-28 06:31:45',NULL,NULL),(41010,27248,'EM','chicoinetom@yahoo.com',0,'2014-03-03 21:31:51',NULL,NULL),(41130,27319,'TE','9155003655',0,'2014-03-04 21:00:45',NULL,NULL),(41529,27612,'EM','laurierjones@gmail.com',0,'2014-03-05 21:00:29',NULL,NULL),(42532,28297,'TE','5138856851',0,'2014-03-07 21:00:30',NULL,NULL),(25504,16445,'EM','lovnrocks@yahoo.com',0,'2014-01-07 04:05:14',NULL,NULL),(2344,1426,'TE','2253550601',0,'2013-12-25 18:47:25',NULL,NULL),(24916,16062,'TE','4194785548',0,'2014-01-04 02:03:32',NULL,NULL),(3975,2521,'AP','3302857596',0,'2013-12-25 19:36:36',NULL,NULL),(3991,2537,'TE','5134600189',0,'2013-12-25 19:36:55',NULL,NULL),(21994,14167,'TE','5044307243',0,'2013-12-27 02:03:20',NULL,NULL),(14091,9214,'EM','brendacole2385@bellsouth.net',0,'2013-12-26 04:09:59',NULL,NULL),(31709,20691,'EM','henryhouse6@gmail.com',0,'2014-01-30 21:00:59',NULL,NULL),(34983,22968,'TE','4408453860',0,'2014-02-12 21:00:14',NULL,NULL),(37233,24502,'AP','9564598149',0,'2014-02-20 03:49:40',NULL,NULL),(39165,25906,'EM','holmescarlette@gmail.com',0,'2014-02-26 21:01:11',NULL,NULL),(44003,29195,'TE','2167216767',0,'2014-03-10 21:30:08',NULL,NULL),(25550,16481,'AP','2162443341',0,'2014-01-07 04:06:17',NULL,NULL),(24430,15771,'EM','whycue@aol.com',0,'2014-01-03 02:01:50',NULL,NULL),(22041,14194,'AP','9159204064',0,'2013-12-27 02:04:05',NULL,NULL),(3412,2143,'AP','6018077777',0,'2013-12-25 19:18:20',NULL,NULL),(21843,14070,'AP','2165346374',0,'2013-12-27 02:00:50',NULL,NULL),(6912,4501,'TE','9086729147',0,'2013-12-25 22:03:23',NULL,NULL),(4012,2550,'EM','rhondahovan@aol.com',0,'2013-12-25 19:37:16',NULL,NULL),(21771,14027,'EM','hodsona1110@hotmail.com',0,'2013-12-26 13:16:46',NULL,NULL),(4650,2971,'TE','8064019648',0,'2013-12-25 20:16:59',NULL,NULL),(6219,4011,'TE','5135161412',0,'2013-12-25 21:45:25',NULL,NULL),(10447,6807,'EM','suzanneyaws@hotmail.com',0,'2013-12-26 01:30:12',NULL,NULL),(27340,17605,'EM','1953mosley@gmail.com',0,'2014-01-14 01:32:18',NULL,NULL),(27547,17753,'AP','6014544588',0,'2014-01-14 01:33:29',NULL,NULL),(28671,18492,'AP','3303225983',0,'2014-01-16 08:46:26',NULL,NULL),(29394,18998,'TE','3304727128',0,'2014-01-20 08:06:14',NULL,NULL),(39433,26081,'EM','juanhrz2010@hotmail.com',0,'2014-02-28 06:30:04',NULL,NULL),(39602,26197,'AP','3303297070',0,'2014-02-28 06:30:47',NULL,NULL),(39790,26308,'TE','3614740637',0,'2014-02-28 06:31:32',NULL,NULL),(41214,27373,'EM','ncrowder3@gmail.com',0,'2014-03-04 21:01:18',NULL,NULL),(41321,27452,'TE','3309209736',0,'2014-03-04 21:01:59',NULL,NULL),(1138,699,'TE','4405942988',0,'2013-12-25 18:02:51',NULL,NULL),(10753,6990,'TE','2164810351',0,'2013-12-26 01:47:58',NULL,NULL),(2835,1719,'TE','2162547770',0,'2013-12-25 18:55:09',NULL,NULL),(8637,5672,'EM','mtaylor508@yahoo.com',0,'2013-12-25 23:32:05',NULL,NULL),(10119,6618,'TE','4199334383',0,'2013-12-26 00:53:57',NULL,NULL),(26853,17278,'EM','rita@concept4ins.com',0,'2014-01-13 02:23:25',NULL,NULL),(4526,2877,'EM','ward107@hotmail.com',0,'2013-12-25 20:02:07',NULL,NULL),(7016,4582,'TE','3306331922',0,'2013-12-25 22:05:15',NULL,NULL),(6068,3906,'TE','4198623382',0,'2013-12-25 21:36:57',NULL,NULL),(5931,3802,'EM','cdidonato1@hotmail.com',0,'2013-12-25 21:34:34',NULL,NULL),(5833,3743,'EM','MELISSAGONZALES835@GMAIL.COM',0,'2013-12-25 21:32:58',NULL,NULL),(27947,18008,'TE','5135286257',0,'2014-01-15 02:07:02',NULL,NULL),(32715,21401,'EM','jreiss@nktelco.net',0,'2014-02-04 21:01:02',NULL,NULL),(32887,21525,'TE','9032888600',0,'2014-02-05 21:30:04',NULL,NULL),(34179,22414,'AP','2255716371',0,'2014-02-10 21:30:27',NULL,NULL),(35456,23314,'TE','4198108125',0,'2014-02-13 22:00:22',NULL,NULL),(36525,24048,'TE','8176090303',0,'2014-02-15 22:01:03',NULL,NULL),(37624,24799,'TE','7403363602',0,'2014-02-20 04:47:53',NULL,NULL),(13903,9063,'AP','9402321948',0,'2013-12-26 04:06:25',NULL,NULL),(8496,5588,'AP','5042408728',0,'2013-12-25 23:17:10',NULL,NULL),(8463,5569,'AP','5134736877',0,'2013-12-25 23:16:39',NULL,NULL),(10817,7026,'TE','9792576829',0,'2013-12-26 01:48:59',NULL,NULL),(3895,2473,'EM','DPRESLEY86@YMAIL.COM',0,'2013-12-25 19:35:18',NULL,NULL),(9028,5922,'TE','8328939825',0,'2013-12-25 23:50:20',NULL,NULL),(9209,6025,'AP','3612076792',0,'2013-12-26 00:00:59',NULL,NULL),(27895,17975,'TE','3307847985',0,'2014-01-15 02:06:51',NULL,NULL),(30660,19903,'TE','4197792004',0,'2014-01-24 21:00:56',NULL,NULL),(31909,20825,'TE','9856406489',0,'2014-01-31 21:00:38',NULL,NULL),(33265,21782,'AP','6147175760',0,'2014-02-06 21:00:39',NULL,NULL),(35095,23053,'TE','2266859959',0,'2014-02-12 21:30:47',NULL,NULL),(38551,25473,'TE','9155024050',0,'2014-02-25 21:31:39',NULL,NULL),(40968,27221,'TE','7692262303',0,'2014-03-03 21:31:35',NULL,NULL),(42493,28260,'EM','benjalo@gmail.com',0,'2014-03-07 21:00:17',NULL,NULL),(42503,28267,'AP','3619443397',0,'2014-03-07 21:00:20',NULL,NULL),(43181,28695,'TE','3186806924',0,'2014-03-08 21:31:05',NULL,NULL),(43852,29102,'AP','5138843060',0,'2014-03-10 21:02:17',NULL,NULL),(14882,9739,'EM','afevang@hotmail.com',0,'2013-12-26 04:45:53',NULL,NULL),(26408,16995,'AP','3308145779',0,'2014-01-13 02:20:27',NULL,NULL),(9586,6276,'AP','5135090387',0,'2013-12-26 00:45:15',NULL,NULL),(8196,5365,'TE','9376946458',0,'2013-12-25 23:07:57',NULL,NULL),(8164,5342,'TE','3306771798',0,'2013-12-25 23:07:23',NULL,NULL),(7791,5086,'AP','9363910588',0,'2013-12-25 23:01:05',NULL,NULL),(7163,4672,'TE','3186501290',0,'2013-12-25 22:07:39',NULL,NULL),(7059,4610,'AP','3304149700',0,'2013-12-25 22:05:58',NULL,NULL),(6936,4518,'EM','LISALAROCCA41@YAHOO.COM',0,'2013-12-25 22:03:47',NULL,NULL),(6395,4123,'EM','afineran42@gmail.com',0,'2013-12-25 21:48:14',NULL,NULL),(10167,6644,'AP','8309978809',0,'2013-12-26 01:00:25',NULL,NULL),(14852,9719,'AP','4128679950',0,'2013-12-26 04:45:25',NULL,NULL),(14502,9475,'TE','7327575378',0,'2013-12-26 04:34:32',NULL,NULL),(27572,17771,'TE','2105086468',0,'2014-01-14 01:33:38',NULL,NULL),(28550,18405,'TE','3304824500',0,'2014-01-16 08:45:45',NULL,NULL),(29513,19080,'TE','4406237185',0,'2014-01-21 08:44:25',NULL,NULL),(29705,19207,'TE','3309904932',0,'2014-01-21 08:46:19',NULL,NULL),(31280,20378,'TE','4697666729',0,'2014-01-29 21:00:10',NULL,NULL),(35395,23262,'EM','klip1300@gmail.com',0,'2014-02-13 21:30:10',NULL,NULL),(35446,23306,'AP','9709019209',0,'2014-02-13 22:00:18',NULL,NULL),(36556,24067,'TE','2163741086',0,'2014-02-15 22:01:13',NULL,NULL),(41593,27654,'TE','4407816031',0,'2014-03-05 21:30:23',NULL,NULL),(42393,28157,'AP','4194093947',0,'2014-03-06 21:02:39',NULL,NULL),(43759,29049,'EM','feliciajsmith10@yahoo.com',0,'2014-03-10 21:01:45',NULL,NULL),(562,348,'EM','GodsDotr@gmail.com',0,'2013-12-25 17:32:11',NULL,NULL),(826,513,'TE','5132525602',0,'2013-12-25 17:49:00',NULL,NULL),(2059,1274,'EM','johnherrjdh@aol.com',0,'2013-12-25 18:30:22',NULL,NULL),(22183,14289,'EM','fslouis2169@yahoo.com',0,'2013-12-27 02:06:33',NULL,NULL),(3705,2350,'EM','axeljr2004@gmail.com',0,'2013-12-25 19:32:12',NULL,NULL),(7291,4748,'AP','9309464310',0,'2013-12-25 22:15:08',NULL,NULL),(4520,2875,'TE','4435622545',0,'2013-12-25 20:02:02',NULL,NULL),(21668,13949,'AP','5134901485',0,'2013-12-26 13:14:54',NULL,NULL),(20553,13228,'AP','9039312556',0,'2013-12-26 12:55:42',NULL,NULL),(13967,9103,'TE','3302735694',0,'2013-12-26 04:07:28',NULL,NULL),(31244,20348,'AP','5134102342',0,'2014-01-28 21:01:12',NULL,NULL),(32571,21298,'TE','9853518305',0,'2014-02-04 21:00:11',NULL,NULL),(35714,23487,'EM','walexa78174@gmail.com',0,'2014-02-13 22:01:59',NULL,NULL),(37128,24442,'TE','3305016154',0,'2014-02-18 22:01:20',NULL,NULL),(37656,24829,'TE','5133025862',0,'2014-02-20 04:51:48',NULL,NULL),(43708,29017,'TE','9375421569',0,'2014-03-10 21:01:27',NULL,NULL),(24764,15977,'EM','meronye@yahoo.com',0,'2014-01-04 02:00:48',NULL,NULL),(9208,6025,'TE','3616686840',0,'2013-12-26 00:00:59',NULL,NULL),(9142,5989,'TE','4195777888',0,'2013-12-25 23:52:10',NULL,NULL),(22674,14620,'TE','5672071349',0,'2013-12-28 03:36:55',NULL,NULL),(22433,14466,'TE','2103095139',0,'2013-12-28 03:32:56',NULL,NULL),(1817,1126,'TE','2145356472',0,'2013-12-25 18:17:55',NULL,NULL),(22217,14322,'TE','3303091929',0,'2013-12-27 02:07:16',NULL,NULL),(3533,2210,'EM','fddickinson54@gmail.com',0,'2013-12-25 19:20:16',NULL,NULL),(4937,3171,'EM','pawscott1213@aol.com',0,'2013-12-25 20:31:32',NULL,NULL),(20712,13312,'TE','2817887881',0,'2013-12-26 12:58:08',NULL,NULL),(4226,2704,'TE','9034713638',0,'2013-12-25 19:47:47',NULL,NULL),(4239,2711,'TE','2162191121',0,'2013-12-25 19:47:58',NULL,NULL),(20230,13032,'TE','2162351054',0,'2013-12-26 12:50:23',NULL,NULL),(14400,9415,'TE','8308541800',0,'2013-12-26 04:32:59',NULL,NULL),(13616,8872,'TE','9564561808',0,'2013-12-26 04:01:37',NULL,NULL),(32585,21304,'AP','3186768797',0,'2014-02-04 21:00:14',NULL,NULL),(36565,24070,'TE','2345429846',0,'2014-02-15 22:01:16',NULL,NULL),(42742,28429,'AP','3307943247',0,'2014-03-07 21:31:08',NULL,NULL),(43707,29016,'EM','dakristeph@yahoo.com',0,'2014-03-10 21:01:27',NULL,NULL),(140,84,'TE','2163769490',0,'2013-12-25 17:17:14',NULL,NULL),(25904,16695,'TE','9565151561',0,'2014-01-08 18:24:36',NULL,NULL),(8868,5810,'TE','2819897350',0,'2013-12-25 23:47:45',NULL,NULL),(8425,5545,'AP','3306717566',0,'2013-12-25 23:15:58',NULL,NULL),(7356,4781,'AP','9012976859',0,'2013-12-25 22:16:08',NULL,NULL),(7185,4682,'EM','REYNACANIZALES55@GMAIL.COM',0,'2013-12-25 22:07:55',NULL,NULL),(24041,15524,'AP','2703070339',1,'2014-01-02 04:30:24',NULL,NULL),(22156,14272,'TE','6623420727',0,'2013-12-27 02:06:07',NULL,NULL),(21681,13959,'EM','Aimcgma@gmail.com',0,'2013-12-26 13:15:06',NULL,NULL),(4381,2793,'EM','jfulcher8@yahoo.com',0,'2013-12-25 19:50:12',NULL,NULL),(989,610,'TE','4192275844',0,'2013-12-25 18:00:33',NULL,NULL),(14137,9257,'EM','znismo911@gmail.com',0,'2013-12-26 04:15:12',NULL,NULL),(1042,642,'TE','4407936326',0,'2013-12-25 18:01:24',NULL,NULL),(30068,19476,'TE','4692376352',0,'2014-01-23 03:02:02',NULL,NULL),(30710,19951,'TE','8608065390',0,'2014-01-25 19:00:03',NULL,NULL),(31846,20792,'TE','9567972868',0,'2014-01-31 21:00:16',NULL,NULL),(39219,25939,'TE','9792009037',0,'2014-02-26 21:01:30',NULL,NULL),(41677,27711,'TE','9564932734',0,'2014-03-05 21:30:53',NULL,NULL),(25740,16588,'EM','jessebrooksmusic@gmail.com',0,'2014-01-08 18:24:00',NULL,NULL),(24470,15792,'EM','seanadixon@yahoo.com',0,'2014-01-03 02:02:33',NULL,NULL),(12369,8098,'TE','3308583030',0,'2013-12-26 03:10:50',NULL,NULL),(9155,5995,'AP','3183557901',0,'2013-12-26 00:00:12',NULL,NULL),(12021,7835,'TE','4195479357',0,'2013-12-26 03:04:31',NULL,NULL),(10183,6655,'TE','9378799599',0,'2013-12-26 01:00:41',NULL,NULL),(6547,4231,'EM','edward_edr15@yahoo.com',0,'2013-12-25 21:50:44',NULL,NULL),(7215,4701,'AP','2167013426',0,'2013-12-25 22:08:25',NULL,NULL),(6904,4493,'AP','9563632061',0,'2013-12-25 22:03:12',NULL,NULL),(30128,19513,'EM','tinavotre@yahoo.com',0,'2014-01-23 03:02:16',NULL,NULL),(30533,19806,'AP','8306837200',0,'2014-01-24 21:00:07',NULL,NULL),(32501,21242,'TE','2165261925',0,'2014-02-03 21:01:13',NULL,NULL),(34645,22714,'EM','julia.lemense@gmail.com',0,'2014-02-11 21:01:07',NULL,NULL),(35305,23192,'TE','3307332490',0,'2014-02-12 21:32:04',NULL,NULL),(37075,24411,'AP','3305016154',0,'2014-02-18 22:01:02',NULL,NULL),(37386,24620,'TE','6019830020',0,'2014-02-20 04:15:57',NULL,NULL),(38647,25541,'EM','mlocker4@woh.rr.com',0,'2014-02-26 08:00:12',NULL,NULL),(39468,26099,'TE','2259394197',0,'2014-02-28 06:30:12',NULL,NULL),(39601,26197,'TE','3303297070',0,'2014-02-28 06:30:47',NULL,NULL),(40025,26530,'TE','5098592723',0,'2014-02-28 21:00:28',NULL,NULL),(41604,27661,'TE','2165540255',0,'2014-03-05 21:30:27',NULL,NULL),(43761,29051,'TE','4402574949',0,'2014-03-10 21:01:46',NULL,NULL),(27432,17668,'TE','5137343136',0,'2014-01-14 01:32:48',NULL,NULL),(26471,17036,'EM','latashacoffee@gmail.com',0,'2014-01-13 02:20:48',NULL,NULL),(25540,16475,'EM','shaun2240@neo.rr.com',0,'2014-01-07 04:06:05',NULL,NULL),(9976,6526,'EM','bo5w@aol.com',0,'2013-12-26 00:51:34',NULL,NULL),(4521,2875,'AP','4435622545',0,'2013-12-25 20:02:02',NULL,NULL),(23704,15300,'AP','3184369580',1,'2014-01-02 04:22:49',NULL,NULL),(23553,15203,'TE','6019421661',0,'2014-01-01 12:07:29',NULL,NULL),(14623,9559,'TE','9377187431',0,'2013-12-26 04:36:31',NULL,NULL),(23402,15072,'EM','SUSAN.HOEFER@YAHOO.COM',0,'2014-01-01 12:03:57',NULL,NULL),(21169,13616,'EM','couchc11@aol.com',0,'2013-12-26 13:05:45',NULL,NULL),(20973,13499,'TE','7407077188',0,'2013-12-26 13:02:34',NULL,NULL),(33772,22165,'TE','5133107790',0,'2014-02-08 19:01:00',NULL,NULL),(37522,24708,'EM','RhondaKPhillips@aol.com',0,'2014-02-20 04:35:43',NULL,NULL),(38401,25368,'EM','JENIBONENI@YAHOO.COM',0,'2014-02-25 21:30:40',NULL,NULL),(38509,25449,'TE','2817063871',0,'2014-02-25 21:31:25',NULL,NULL),(41146,27329,'EM','doth02@yahoo.com',0,'2014-03-04 21:00:51',NULL,NULL),(43162,28685,'TE','8327545120',0,'2014-03-08 21:30:59',NULL,NULL),(2492,1529,'AP','3305240222',0,'2013-12-25 18:49:59',NULL,NULL),(25967,16725,'EM','mlcormell27@gmail.com',0,'2014-01-08 18:24:48',NULL,NULL),(14639,9577,'TE','5138316069',0,'2013-12-26 04:36:48',NULL,NULL),(11649,7582,'AP','9374199416',0,'2013-12-26 02:33:58',NULL,NULL),(21029,13529,'EM','GregGunther@Razooli.com',0,'2013-12-26 13:03:26',NULL,NULL),(11557,7521,'EM','rajendran@cinci.rr.com',0,'2013-12-26 02:32:24',NULL,NULL),(23508,15166,'AP','2163176605',0,'2014-01-01 12:06:25',NULL,NULL),(23517,15170,'AP','3306449115',0,'2014-01-01 12:06:33',NULL,NULL),(28254,18220,'TE','5125525631',0,'2014-01-16 08:44:13',NULL,NULL),(31685,20670,'TE','6623920638',0,'2014-01-30 21:00:49',NULL,NULL),(32066,20938,'TE','9379265053',0,'2014-01-31 21:01:41',NULL,NULL),(33708,22112,'EM','myzoomzoom6@yahoo.com',0,'2014-02-08 19:00:35',NULL,NULL),(34945,22938,'TE','9852120480',0,'2014-02-11 21:30:17',NULL,NULL),(35298,23185,'AP','9016549388',0,'2014-02-12 21:32:00',NULL,NULL),(36343,23934,'AP','6148731696',0,'2014-02-15 21:00:05',NULL,NULL),(36843,24261,'EM','jclmartinez1978@gmail.com',0,'2014-02-17 19:00:11',NULL,NULL),(1633,1003,'TE','6018741872',0,'2013-12-25 18:11:00',NULL,NULL),(20289,13078,'AP','7404443291',0,'2013-12-26 12:51:30',NULL,NULL),(10517,6851,'TE','8324773366',0,'2013-12-26 01:31:22',NULL,NULL),(22495,14503,'AP','9158508561',0,'2013-12-28 03:33:51',NULL,NULL),(22500,14506,'AP','8017191660',0,'2013-12-28 03:33:55',NULL,NULL),(22536,14530,'TE','9565703110',0,'2013-12-28 03:34:32',NULL,NULL),(9957,6515,'EM','joanna.hirt@yahoo.com',0,'2013-12-26 00:51:15',NULL,NULL),(8972,5882,'EM','eawoods511@gmail.com',0,'2013-12-25 23:49:27',NULL,NULL),(29265,18901,'AP','9377254918',0,'2014-01-17 03:36:36',NULL,NULL),(29811,19289,'TE','2254732681',1,'2014-01-22 03:21:54',NULL,NULL),(30532,19806,'TE','8306837200',0,'2014-01-24 21:00:06',NULL,NULL),(31506,20530,'TE','6019069675',0,'2014-01-29 21:01:30',NULL,NULL),(31921,20837,'TE','3306305645',0,'2014-01-31 21:00:44',NULL,NULL),(34616,22696,'EM','ariel.adames@gmail.com',0,'2014-02-11 21:00:56',NULL,NULL),(36802,24231,'EM','RGWELLS60@LIVE.COM',0,'2014-02-16 19:00:34',NULL,NULL),(40711,27049,'EM','footworks601@hotmail.com',0,'2014-03-03 21:00:25',NULL,NULL),(40947,27209,'AP','5675250680',0,'2014-03-03 21:31:27',NULL,NULL),(40983,27231,'AP','4407155019',0,'2014-03-03 21:31:41',NULL,NULL),(765,478,'EM','ckkheel@yahoo.com',0,'2013-12-25 17:48:05',NULL,NULL),(12261,8016,'AP','7242885533',0,'2013-12-26 03:08:48',NULL,NULL),(14275,9338,'TE','9852296443',0,'2013-12-26 04:30:56',NULL,NULL),(14885,9743,'TE','9364889008',0,'2013-12-26 04:45:59',NULL,NULL),(21757,14013,'TE','9377793139',0,'2013-12-26 13:16:26',NULL,NULL),(11909,7751,'TE','7405077619',0,'2013-12-26 03:02:31',NULL,NULL),(10693,6950,'TE','7403230650',0,'2013-12-26 01:47:02',NULL,NULL),(23127,14906,'TE','2282337364',0,'2013-12-30 00:01:19',NULL,NULL),(1914,1183,'EM','rwgill_2000@yahoo.com',0,'2013-12-25 18:19:27',NULL,NULL),(33939,22272,'TE','9562317036',0,'2014-02-10 11:00:15',NULL,NULL),(34503,22633,'TE','9159999756',0,'2014-02-11 21:00:19',NULL,NULL),(36157,23796,'AP','3308086994',0,'2014-02-14 21:31:27',NULL,NULL),(37162,24461,'AP','8016808942',0,'2014-02-18 22:01:33',NULL,NULL),(37719,24869,'AP','9372451250',0,'2014-02-20 05:33:00',NULL,NULL),(43056,28626,'TE','8326901237',0,'2014-03-08 21:30:24',NULL,NULL),(20,14,'TE','5133047346',0,'2013-12-25 17:15:21',NULL,NULL),(25854,16665,'AP','5046555982',0,'2014-01-08 18:24:26',NULL,NULL),(6045,3884,'TE','2343127647',0,'2013-12-25 21:36:32',NULL,NULL),(10052,6575,'TE','2253174595',0,'2013-12-26 00:52:48',NULL,NULL),(6103,3929,'TE','4194234679',0,'2013-12-25 21:37:35',NULL,NULL),(6831,4433,'EM','matt.odonnell.22@gmail.com',0,'2013-12-25 22:01:56',NULL,NULL),(24661,15900,'TE','5136811125',0,'2014-01-03 02:06:03',NULL,NULL),(7733,5048,'TE','9033878771',0,'2013-12-25 23:00:06',NULL,NULL),(13963,9101,'EM','barlowjerry68@yahoo.com',0,'2013-12-26 04:07:24',NULL,NULL),(8539,5608,'EM','Whisner2004@yahoo.com',0,'2013-12-25 23:30:29',NULL,NULL),(1270,773,'TE','8176903277',0,'2013-12-25 18:04:52',NULL,NULL),(21495,13814,'EM','stedwards@fuse.net',0,'2013-12-26 13:11:41',NULL,NULL),(22264,14346,'AP','9376225817',0,'2013-12-27 02:08:02',NULL,NULL),(27266,17554,'EM','lsimes@yahoo.com',0,'2014-01-13 03:01:56',NULL,NULL),(27302,17580,'TE','3303251861',0,'2014-01-14 01:32:06',NULL,NULL),(35526,23366,'TE','4402938218',0,'2014-02-13 22:00:49',NULL,NULL),(35957,23655,'AP','9729891283',0,'2014-02-14 21:30:17',NULL,NULL),(38268,25267,'EM','snealaabco@woh.rr.com',0,'2014-02-22 19:00:16',NULL,NULL),(42563,28322,'TE','9158871513',0,'2014-03-07 21:30:05',NULL,NULL),(43978,29175,'TE','2165093092',0,'2014-03-10 21:03:01',NULL,NULL),(18,13,'AP','3304723123',0,'2013-12-25 17:15:19',NULL,NULL),(3747,2377,'TE','4196753467',0,'2013-12-25 19:32:55',NULL,NULL),(4501,2864,'TE','4403436326',0,'2013-12-25 20:01:42',NULL,NULL),(3794,2411,'EM','rmcdermo@amfam.com',0,'2013-12-25 19:33:45',NULL,NULL),(5857,3758,'EM','prairiestater@yahoo.com',0,'2013-12-25 21:33:21',NULL,NULL),(5911,3791,'EM','krakorajohn@yahoo.com',0,'2013-12-25 21:34:15',NULL,NULL),(7523,4904,'TE','5135501146',0,'2013-12-25 22:31:52',NULL,NULL),(758,475,'EM','kiwanareliford@gmail.com',0,'2013-12-25 17:48:00',NULL,NULL),(9408,6159,'AP','6014340849',0,'2013-12-26 00:16:43',NULL,NULL),(24807,16003,'EM','rk45130@hotmail.com',0,'2014-01-04 02:01:35',NULL,NULL),(25483,16431,'EM','Debbiespalmtree@sbcglobal.net',0,'2014-01-07 04:04:49',NULL,NULL),(27765,17902,'TE','7204227159',0,'2014-01-15 02:06:23',NULL,NULL),(29002,18722,'AP','5132374863',0,'2014-01-17 03:35:34',NULL,NULL),(29897,19347,'AP','3305736946',1,'2014-01-22 03:22:24',NULL,NULL),(30131,19515,'EM','tinavotre@yahoo.com',0,'2014-01-23 03:02:16',NULL,NULL),(30521,19797,'EM','imond@aol.com',0,'2014-01-23 21:01:46',NULL,NULL),(31395,20461,'AP','5132353401',0,'2014-01-29 21:00:51',NULL,NULL),(32597,21314,'AP','3185198549',0,'2014-02-04 21:00:19',NULL,NULL),(33936,22270,'AP','8305963635',0,'2014-02-10 11:00:14',NULL,NULL),(35080,23038,'AP','2146768846',0,'2014-02-12 21:30:38',NULL,NULL),(35406,23276,'TE','9378316008',0,'2014-02-13 21:30:14',NULL,NULL),(39066,25839,'AP','4194385110',0,'2014-02-26 21:00:34',NULL,NULL),(39224,25945,'TE','9372940135',0,'2014-02-26 21:01:33',NULL,NULL),(39606,26199,'TE','3309283600',0,'2014-02-28 06:30:48',NULL,NULL),(41387,27495,'AP','3304212214',0,'2014-03-04 21:02:25',NULL,NULL),(41728,27747,'EM','tamakicadorsey09@yahoo.com',0,'2014-03-05 21:31:13',NULL,NULL),(42356,28132,'TE','4194969688',0,'2014-03-06 21:02:25',NULL,NULL),(42787,28457,'AP','2253970864',0,'2014-03-07 21:31:23',NULL,NULL),(43200,28709,'TE','4198743696',0,'2014-03-08 21:31:13',NULL,NULL),(43697,29006,'AP','3304661468',0,'2014-03-10 21:01:22',NULL,NULL),(677,422,'TE','7406961273',0,'2013-12-25 17:46:40',NULL,NULL),(10079,6588,'TE','8646162187',0,'2013-12-26 00:53:10',NULL,NULL),(11373,7407,'TE','2108377163',0,'2013-12-26 02:16:37',NULL,NULL),(13804,8998,'TE','3303470983',0,'2013-12-26 04:04:47',NULL,NULL),(9033,5926,'EM','sling@beresonusa.com',0,'2013-12-25 23:50:25',NULL,NULL),(9548,6250,'TE','9372171555',0,'2013-12-26 00:31:56',NULL,NULL),(23260,14986,'AP','2812220639',0,'2014-01-01 12:01:17',NULL,NULL),(8357,5494,'TE','4194107048',0,'2013-12-25 23:11:07',NULL,NULL),(5616,3597,'TE','4405824579',0,'2013-12-25 21:23:09',NULL,NULL),(23880,15409,'TE','9402286573',1,'2014-01-02 04:27:03',NULL,NULL),(24270,15684,'TE','4192620332',1,'2014-01-02 04:35:07',NULL,NULL),(24784,15987,'TE','8303773616',0,'2014-01-04 02:01:08',NULL,NULL),(24882,16043,'TE','9567266352',0,'2014-01-04 02:02:56',NULL,NULL),(3157,1972,'AP','8176816774',0,'2013-12-25 19:01:31',NULL,NULL),(25379,16368,'AP','6014548684',0,'2014-01-07 04:02:57',NULL,NULL),(28056,18081,'TE','3373702538',0,'2014-01-15 02:07:27',NULL,NULL),(28238,18209,'EM','mkuwatch@cinci.rr.com',0,'2014-01-15 02:08:09',NULL,NULL),(28689,18514,'AP','4199577128',0,'2014-01-16 08:46:34',NULL,NULL),(30657,19898,'TE','5046565147',0,'2014-01-24 21:00:55',NULL,NULL),(34247,22466,'TE','6176862706',0,'2014-02-10 21:30:55',NULL,NULL),(35620,23423,'AP','9566396202',0,'2014-02-13 22:01:23',NULL,NULL),(36392,23969,'EM','bealsaustin@aol.com',0,'2014-02-15 22:00:13',NULL,NULL),(36536,24054,'TE','9374260068',0,'2014-02-15 22:01:06',NULL,NULL),(38458,25412,'AP','5138289323',0,'2014-02-25 21:31:04',NULL,NULL),(40987,27233,'TE','4407155019',0,'2014-03-03 21:31:42',NULL,NULL),(41580,27646,'TE','4403347584',0,'2014-03-05 21:30:19',NULL,NULL),(41899,27859,'TE','3309802061',0,'2014-03-05 21:32:18',NULL,NULL),(42776,28451,'TE','2258196551',0,'2014-03-07 21:31:20',NULL,NULL),(1533,942,'AP','5134653675',0,'2013-12-25 18:09:23',NULL,NULL),(14422,9428,'TE','9363330862',0,'2013-12-26 04:33:19',NULL,NULL),(11284,7354,'AP','8178740647',0,'2013-12-26 02:15:13',NULL,NULL),(7717,5039,'EM','suekasch@yahoo.com',0,'2013-12-25 22:47:57',NULL,NULL),(21715,13988,'TE','4198720033',0,'2013-12-26 13:15:44',NULL,NULL),(2229,1369,'EM','justellerealty@gmail.com',0,'2013-12-25 18:45:44',NULL,NULL),(25680,16556,'TE','5043028884',1,'2014-01-07 10:22:54',NULL,NULL),(26810,17243,'AP','5134766960',0,'2014-01-13 02:22:47',NULL,NULL),(29847,19311,'EM','chrissytle@gmail.com',1,'2014-01-22 03:22:06',NULL,NULL),(32724,21406,'AP','2162442389',0,'2014-02-04 21:01:05',NULL,NULL),(34332,22523,'EM','ww9102@yahoo.com',0,'2014-02-10 21:31:27',NULL,NULL),(35745,23506,'EM','kidwillis1980@gmail.com',0,'2014-02-13 22:02:11',NULL,NULL),(40929,27197,'AP','8327586028',0,'2014-03-03 21:31:20',NULL,NULL),(41703,27730,'TE','9567425913',0,'2014-03-05 21:31:03',NULL,NULL),(42850,28498,'TE','6019429938',0,'2014-03-07 21:31:46',NULL,NULL),(1468,900,'AP','6012481667',0,'2013-12-25 18:08:16',NULL,NULL),(14516,9485,'TE','2165758776',0,'2013-12-26 04:34:45',NULL,NULL),(11624,7561,'TE','4198227399',0,'2013-12-26 02:33:30',NULL,NULL),(21426,13776,'TE','6013372463',0,'2013-12-26 13:10:37',NULL,NULL),(5412,3466,'AP','2162554306',0,'2013-12-25 21:19:50',NULL,NULL),(22866,14755,'TE','9374400999',1,'2013-12-29 11:10:26',NULL,NULL),(25699,16568,'AP','5672496586',1,'2014-01-07 10:23:15',NULL,NULL),(26224,16879,'AP','5128035573',0,'2014-01-13 02:19:20',NULL,NULL),(26649,17145,'TE','3186174160',0,'2014-01-13 02:21:54',NULL,NULL),(30742,19975,'EM','jaguarxfire@yahoo.com',0,'2014-01-25 19:00:13',NULL,NULL),(31896,20817,'AP','5042207902',0,'2014-01-31 21:00:33',NULL,NULL),(32728,21409,'EM','Devignos@gmail.com',0,'2014-02-04 21:01:07',NULL,NULL),(34938,22928,'TE','3307225444',0,'2014-02-11 21:30:08',NULL,NULL),(38725,25598,'AP','4192774684',0,'2014-02-26 08:00:48',NULL,NULL),(41138,27323,'AP','9156912041',0,'2014-03-04 21:00:48',NULL,NULL),(42478,28235,'TE','3305736766',0,'2014-03-06 21:30:25',NULL,NULL),(25866,16670,'EM','themeeks06@gmail.com',0,'2014-01-08 18:24:28',NULL,NULL),(25239,16276,'AP','5132001893',0,'2014-01-07 04:00:25',NULL,NULL),(23082,14889,'TE','3186143980',0,'2013-12-30 00:00:43',NULL,NULL),(1556,958,'TE','4696988266',0,'2013-12-25 18:09:43',NULL,NULL),(7702,5030,'TE','4192367632',0,'2013-12-25 22:47:44',NULL,NULL),(5754,3687,'AP','9379028810',0,'2013-12-25 21:31:38',NULL,NULL),(22826,14720,'AP','3184394257',1,'2013-12-29 11:09:33',NULL,NULL),(22510,14512,'EM','iftiim@hotmail.com',0,'2013-12-28 03:34:06',NULL,NULL),(4123,2630,'TE','5139794353',0,'2013-12-25 19:46:05',NULL,NULL),(3073,1915,'AP','4195699644',0,'2013-12-25 19:00:03',NULL,NULL),(21796,14044,'TE','9374174660',0,'2013-12-27 02:00:07',NULL,NULL),(11121,7231,'EM','jsparkin@cincinnatistate.edu',0,'2013-12-26 02:01:23',NULL,NULL),(21736,14003,'TE','9375814325',0,'2013-12-26 13:16:08',NULL,NULL),(11686,7606,'EM','DENNIS.DEITZ@YAHOO.COM',0,'2013-12-26 02:45:32',NULL,NULL),(21608,13905,'EM','buckeyesnider@yahoo.com',0,'2013-12-26 13:13:49',NULL,NULL),(21066,13549,'TE','5043019136',0,'2013-12-26 13:04:02',NULL,NULL),(33661,22081,'TE','5043209267',0,'2014-02-08 19:00:18',NULL,NULL),(34570,22668,'AP','2108239515',0,'2014-02-11 21:00:40',NULL,NULL),(39825,26338,'BN','4193490287',0,'2014-02-28 06:31:43',NULL,NULL),(42476,28232,'TE','4198379266',0,'2014-03-06 21:30:23',NULL,NULL),(43126,28668,'AP','5047108939',0,'2014-03-08 21:30:48',NULL,NULL),(236,143,'EM','sbittinger@sbcglobal.net',0,'2013-12-25 17:18:46',NULL,NULL),(25733,16585,'TE','3189653306',0,'2014-01-08 18:23:59',NULL,NULL),(25079,16168,'TE','2258198199',0,'2014-01-05 00:00:09',NULL,NULL),(1355,828,'TE','3303389392',0,'2013-12-25 18:06:16',NULL,NULL),(2088,1290,'TE','6142618419',0,'2013-12-25 18:30:51',NULL,NULL),(8147,5331,'TE','9388903800',0,'2013-12-25 23:07:06',NULL,NULL),(4328,2761,'EM','kwgriggs@yahoo.com',0,'2013-12-25 19:49:20',NULL,NULL),(11437,7440,'AP','3303517501',0,'2013-12-26 02:30:23',NULL,NULL),(10961,7124,'AP','6623641124',0,'2013-12-26 01:51:25',NULL,NULL),(6984,4556,'EM','sabcvb@yahoo.com',0,'2013-12-25 22:04:39',NULL,NULL),(6775,4395,'AP','4402220226',0,'2013-12-25 22:01:01',NULL,NULL),(26470,17036,'AP','2253056276',0,'2014-01-13 02:20:48',NULL,NULL),(29462,19048,'TE','5044512210',0,'2014-01-20 08:06:42',NULL,NULL),(32416,21182,'TE','9012887592',0,'2014-02-03 21:00:43',NULL,NULL),(34695,22752,'TE','3184169118',0,'2014-02-11 21:01:26',NULL,NULL),(36838,24259,'EM','elviranavaroo132@yahoo.com',0,'2014-02-17 19:00:09',NULL,NULL),(37159,24460,'AP','3016592203',0,'2014-02-18 22:01:32',NULL,NULL),(39768,26297,'EM','njslovak@bex.net',0,'2014-02-28 06:31:27',NULL,NULL),(102,59,'EM','jcox36@live.com',0,'2013-12-25 17:16:37',NULL,NULL),(8600,5651,'EM','ayphone@gmail.com',0,'2013-12-25 23:31:31',NULL,NULL),(26037,16775,'AP','6019064019',0,'2014-01-08 18:25:03',NULL,NULL),(8136,5326,'TE','5133744742',0,'2013-12-25 23:06:58',NULL,NULL),(23057,14872,'EM','michelle961@hotmail.com',0,'2013-12-30 00:00:16',NULL,NULL),(12117,7921,'TE','9855153732',0,'2013-12-26 03:06:19',NULL,NULL),(5882,3773,'TE','3307458666',0,'2013-12-25 21:33:46',NULL,NULL),(3051,1897,'TE','4196771138',0,'2013-12-25 18:59:03',NULL,NULL),(11851,7713,'TE','3305344530',0,'2013-12-26 03:01:33',NULL,NULL),(28016,18057,'AP','4192153682',0,'2014-01-15 02:07:19',NULL,NULL),(29047,18753,'EM','keithgalbraith@live.com',0,'2014-01-17 03:35:44',NULL,NULL),(29946,19380,'AP','6014106332',1,'2014-01-22 03:22:41',NULL,NULL),(30224,19578,'AP','3184397810',0,'2014-01-23 03:02:39',NULL,NULL),(31891,20815,'AP','9859748857',0,'2014-01-31 21:00:31',NULL,NULL),(33248,21772,'TE','6146255360',0,'2014-02-06 21:00:33',NULL,NULL),(41581,27646,'AP','4403347584',0,'2014-03-05 21:30:19',NULL,NULL),(41772,27774,'AP','2165447757',0,'2014-03-05 21:31:29',NULL,NULL),(147,88,'TE','8304560368',0,'2013-12-25 17:17:21',NULL,NULL),(347,215,'AP','5048106630',0,'2013-12-25 17:20:36',NULL,NULL),(654,407,'AP','4197681235',0,'2013-12-25 17:46:19',NULL,NULL),(25980,16739,'TE','3306222290',0,'2014-01-08 18:24:51',NULL,NULL),(5008,3215,'TE','3302252386',0,'2013-12-25 20:45:33',NULL,NULL),(6594,4257,'TE','3306555310',0,'2013-12-25 21:51:27',NULL,NULL),(14417,9424,'EM','MCVNUS@GMAIL.COM',0,'2013-12-26 04:33:13',NULL,NULL),(27821,17929,'TE','2105620156',0,'2014-01-15 02:06:34',NULL,NULL),(28506,18374,'AP','4195655953',0,'2014-01-16 08:45:31',NULL,NULL),(28649,18478,'TE','3302128757',0,'2014-01-16 08:46:20',NULL,NULL),(28792,18581,'EM','al_manassa@yahoo.com',0,'2014-01-16 08:47:09',NULL,NULL),(30129,19515,'TE','7273653778',0,'2014-01-23 03:02:16',NULL,NULL),(33528,21979,'BN','3182670729',0,'2014-02-07 19:00:36',NULL,NULL),(35315,23205,'TE','5672206158',0,'2014-02-12 21:32:10',NULL,NULL),(36558,24067,'EM','fitrjw@yahoo.com',0,'2014-02-15 22:01:14',NULL,NULL),(36965,24340,'TE','9156266114',0,'2014-02-18 22:00:19',NULL,NULL),(37748,24908,'TE','5138912709',0,'2014-02-20 21:30:06',NULL,NULL),(38063,25120,'EM','bobbi_spofford@hotmail.com',0,'2014-02-21 21:30:21',NULL,NULL),(43372,28806,'TE','3306344893',0,'2014-03-09 21:00:52',NULL,NULL),(3795,2412,'TE','5134846536',0,'2013-12-25 19:33:47',NULL,NULL),(22371,14429,'TE','5049152422',0,'2013-12-28 03:31:53',NULL,NULL),(21044,13538,'AP','3185319191',0,'2013-12-26 13:03:41',NULL,NULL),(5403,3457,'TE','7409836652',0,'2013-12-25 21:19:40',NULL,NULL),(20935,13465,'TE','5132121647',0,'2013-12-26 13:01:52',NULL,NULL),(6956,4534,'EM','billypettis72@yahoo.com',0,'2013-12-25 22:04:09',NULL,NULL),(14870,9731,'TE','4408552183',0,'2013-12-26 04:45:42',NULL,NULL),(11921,7759,'EM','ALMOSTBMW@GMAIL.COM',0,'2013-12-26 03:02:43',NULL,NULL),(34222,22445,'AP','8326290393',0,'2014-02-10 21:30:44',NULL,NULL),(35803,23542,'TE','3374593278',0,'2014-02-13 22:02:33',NULL,NULL),(26056,16784,'TE','4197044506',0,'2014-01-08 18:25:07',NULL,NULL),(3035,1889,'AP','5174424838',0,'2013-12-25 18:58:48',NULL,NULL),(24365,15733,'EM','MADISONGHICKS@YAHOO.COM',0,'2014-01-03 02:00:36',NULL,NULL),(8835,5785,'TE','6147460985',0,'2013-12-25 23:47:09',NULL,NULL),(22061,14208,'TE','2108595005',0,'2013-12-27 02:04:26',NULL,NULL),(14294,9350,'AP','6018701955',0,'2013-12-26 04:31:14',NULL,NULL),(11085,7201,'TE','9375446877',0,'2013-12-26 02:00:40',NULL,NULL),(5790,3712,'TE','4196052409',0,'2013-12-25 21:32:13',NULL,NULL),(24716,15946,'AP','9374412530',0,'2014-01-03 02:07:21',NULL,NULL),(1915,1184,'TE','3303688817',0,'2013-12-25 18:19:28',NULL,NULL),(3442,2158,'TE','2252239931',0,'2013-12-25 19:18:47',NULL,NULL),(3143,1961,'AP','8176816774',0,'2013-12-25 19:01:14',NULL,NULL),(23774,15333,'TE','4199800237',1,'2014-01-02 04:24:00',NULL,NULL),(9612,6291,'AP','9379741775',0,'2013-12-26 00:45:39',NULL,NULL),(9858,6445,'AP','4195759110',0,'2013-12-26 00:49:34',NULL,NULL),(10313,6729,'TE','5133059723',0,'2013-12-26 01:15:26',NULL,NULL),(23574,15219,'AP','3375631643',0,'2014-01-01 12:07:58',NULL,NULL),(13990,9127,'TE','6017836516',0,'2013-12-26 04:07:53',NULL,NULL),(29192,18858,'EM','mskineta@yahoo.com',0,'2014-01-17 03:36:19',NULL,NULL),(29434,19032,'EM','JACQBERRY@GMAIL.COM',0,'2014-01-20 08:06:32',NULL,NULL),(32286,21090,'TE','9016261326',0,'2014-02-02 19:00:27',NULL,NULL),(32488,21228,'EM','Qcquigg@gmail.com',0,'2014-02-03 21:01:08',NULL,NULL),(32672,21367,'EM','bodan5188@yahoo.com',0,'2014-02-04 21:00:46',NULL,NULL),(32697,21386,'EM','emason@alink.com',0,'2014-02-04 21:00:56',NULL,NULL),(33432,21899,'AP','4195846176',0,'2014-02-06 21:01:46',NULL,NULL),(33488,21944,'TE','7733922429',0,'2014-02-07 19:00:17',NULL,NULL),(35232,23138,'TE','3305191871',0,'2014-02-12 21:31:34',NULL,NULL),(37243,24507,'BN','3252800867',0,'2014-02-20 03:51:59',NULL,NULL),(39234,25952,'TE','7406414551',0,'2014-02-26 21:01:37',NULL,NULL),(39451,26090,'TE','2062799334',0,'2014-02-28 06:30:08',NULL,NULL),(40124,26608,'AP','6023292709',0,'2014-02-28 21:30:46',NULL,NULL),(40181,26651,'AP','3309580093',0,'2014-02-28 21:31:07',NULL,NULL),(40841,27138,'EM','fbl12689@gmail.com',0,'2014-03-03 21:30:45',NULL,NULL),(41232,27386,'TE','6018470188',0,'2014-03-04 21:01:24',NULL,NULL),(24625,15879,'EM','alvinstutts1@cox.net',0,'2014-01-03 02:05:22',NULL,NULL),(14044,9176,'TE','9373757021',0,'2013-12-26 04:09:03',NULL,NULL),(8588,5645,'TE','9032586510',0,'2013-12-25 23:31:21',NULL,NULL),(13754,8964,'EM','cngoclynn72@gmail.com',0,'2013-12-26 04:03:56',NULL,NULL),(9489,6209,'TE','9727461748',0,'2013-12-26 00:30:50',NULL,NULL),(9170,6002,'EM','kayjackson_20@yahoo.com',0,'2013-12-26 00:00:24',NULL,NULL),(4861,3111,'EM','User1204@aol.com',0,'2013-12-25 20:20:33',NULL,NULL),(5535,3539,'TE','8325189166',0,'2013-12-25 21:21:43',NULL,NULL),(29171,18850,'TE','3307604671',0,'2014-01-17 03:36:15',NULL,NULL),(29904,19353,'TE','2166452261',1,'2014-01-22 03:22:26',NULL,NULL),(29989,19414,'AP','2283696540',1,'2014-01-22 03:22:59',NULL,NULL),(32201,21033,'TE','9376580953',0,'2014-02-01 19:00:46',NULL,NULL),(35530,23368,'AP','4146788128',0,'2014-02-13 22:00:50',NULL,NULL),(39570,26179,'AP','4406680861',0,'2014-02-28 06:30:39',NULL,NULL),(39986,26480,'EM','lindakayek@yahoo.com',0,'2014-02-28 21:00:04',NULL,NULL),(478,304,'AP','4198108153',0,'2013-12-25 17:30:52',NULL,NULL),(24550,15835,'AP','2168829862',0,'2014-01-03 02:03:59',NULL,NULL),(8635,5672,'TE','4192362019',0,'2013-12-25 23:32:05',NULL,NULL),(1613,992,'TE','6143297780',0,'2013-12-25 18:10:40',NULL,NULL),(8016,5236,'EM','BJONES0950@YAHOO.COM',0,'2013-12-25 23:04:51',NULL,NULL),(26745,17202,'AP','3302837574',0,'2014-01-13 02:22:25',NULL,NULL),(27040,17387,'EM','aljones0206@gmail.com',0,'2014-01-13 03:00:09',NULL,NULL),(29755,19241,'AP','3304285446',0,'2014-01-21 08:46:38',NULL,NULL),(32422,21184,'AP','6018421908',0,'2014-02-03 21:00:45',NULL,NULL),(34128,22375,'EM','davesurnbrock@cincinnaticomm.com',0,'2014-02-10 21:30:05',NULL,NULL),(40432,26842,'AP','3184931261',0,'2014-03-01 21:00:45',NULL,NULL),(40703,27039,'AP','9038758097',0,'2014-03-03 21:00:20',NULL,NULL),(43351,28794,'AP','8178251608',0,'2014-03-09 21:00:44',NULL,NULL),(43521,28897,'TE','9569496496',0,'2014-03-10 21:00:18',NULL,NULL),(2254,1381,'TE','9857780917',0,'2013-12-25 18:46:06',NULL,NULL),(25939,16711,'TE','5124131088',0,'2014-01-08 18:24:43',NULL,NULL),(24062,15535,'TE','3379625493',1,'2014-01-02 04:30:47',NULL,NULL),(14166,9270,'AP','2163086759',0,'2013-12-26 04:15:38',NULL,NULL),(7892,5142,'AP','3302895231',0,'2013-12-25 23:02:35',NULL,NULL),(11804,7676,'TE','5317372567',0,'2013-12-26 03:00:43',NULL,NULL),(6437,4161,'TE','4402281047',0,'2013-12-25 21:48:58',NULL,NULL),(11400,7419,'EM','TAllenohh1@NicheVision.com',0,'2013-12-26 02:16:59',NULL,NULL),(11017,7152,'TE','4194960026',0,'2013-12-26 01:52:14',NULL,NULL),(26948,17330,'TE','5049098881',0,'2014-01-13 02:23:56',NULL,NULL),(32912,21547,'TE','7405072935',0,'2014-02-05 21:30:12',NULL,NULL),(32927,21554,'EM','rgabriel4566@gmail.com',0,'2014-02-05 21:30:15',NULL,NULL),(32992,21604,'AP','3304315879',0,'2014-02-05 21:30:32',NULL,NULL),(34766,22801,'AP','2406871592',0,'2014-02-11 21:01:53',NULL,NULL),(35349,23227,'EM','adamshame31@yahoo.com',0,'2014-02-12 21:32:23',NULL,NULL),(37391,24621,'AP','6019830020',0,'2014-02-20 04:16:21',NULL,NULL),(39584,26185,'AP','4403364687',0,'2014-02-28 06:30:42',NULL,NULL),(40361,26787,'AP','9034230733',0,'2014-03-01 21:00:16',NULL,NULL),(43300,28767,'EM','ashton.jackson2010@gmail.com',0,'2014-03-09 21:00:27',NULL,NULL),(23892,15415,'TE','2148865909',1,'2014-01-02 04:27:15',NULL,NULL),(23369,15053,'EM','tymeg04@gmail.com',0,'2014-01-01 12:03:20',NULL,NULL),(13721,8941,'TE','5138844187',0,'2013-12-26 04:03:20',NULL,NULL),(2031,1258,'TE','4192701888',0,'2013-12-25 18:21:26',NULL,NULL),(4676,2990,'AP','5136526760',0,'2013-12-25 20:17:25',NULL,NULL),(8722,5722,'AP','4123433775',0,'2013-12-25 23:45:26',NULL,NULL),(11600,7545,'AP','2145923731',0,'2013-12-26 02:33:03',NULL,NULL),(4754,3043,'EM','ntsquirel@icloud.com',0,'2013-12-25 20:18:42',NULL,NULL),(6816,4424,'AP','5136162405',0,'2013-12-25 22:01:41',NULL,NULL),(5295,3394,'AP','5049084566',0,'2013-12-25 21:17:56',NULL,NULL),(10924,7102,'TE','5132320930',0,'2013-12-26 01:50:48',NULL,NULL),(10295,6719,'AP','3302558368',0,'2013-12-26 01:15:09',NULL,NULL),(27047,17393,'EM','bob.manleyjr@ymail.com',0,'2014-01-13 03:00:12',NULL,NULL),(27738,17883,'AP','9375030010',0,'2014-01-15 02:06:17',NULL,NULL),(32835,21485,'EM','jyoun2@mail.com',0,'2014-02-04 21:01:45',NULL,NULL),(34913,22909,'EM','TerryTrump@aol.com',0,'2014-02-11 21:02:47',NULL,NULL),(36291,23894,'AP','5139192455',0,'2014-02-14 21:32:20',NULL,NULL),(39686,26240,'AP','9567940839',0,'2014-02-28 06:31:04',NULL,NULL),(40014,26508,'AP','5138940441',0,'2014-02-28 21:00:18',NULL,NULL),(40401,26817,'EM','RAJESH_MAMIDI@YAHOO.COM',0,'2014-03-01 21:00:32',NULL,NULL),(40868,27156,'EM','dankorgan@gmail.com',0,'2014-03-03 21:30:56',NULL,NULL),(42583,28334,'AP','3107707153',0,'2014-03-07 21:30:12',NULL,NULL),(43895,29123,'TE','3148087930',0,'2014-03-10 21:02:32',NULL,NULL),(22950,14805,'AP','3186234805',1,'2013-12-29 11:13:53',NULL,NULL),(26242,16889,'TE','9154879045',0,'2014-01-13 02:19:26',NULL,NULL),(22095,14231,'TE','9374174660',0,'2013-12-27 02:05:01',NULL,NULL),(21607,13905,'AP','4197079492',0,'2013-12-26 13:13:49',NULL,NULL),(9083,5954,'EM','Mtickjones@msn.com',0,'2013-12-25 23:51:11',NULL,NULL),(8883,5820,'TE','2543154155',0,'2013-12-25 23:47:59',NULL,NULL),(2724,1654,'TE','8176584491',0,'2013-12-25 18:53:26',NULL,NULL),(3190,2005,'AP','5133681522',0,'2013-12-25 19:02:19',NULL,NULL),(21239,13652,'EM','thecbar@gmail.com',0,'2013-12-26 13:07:21',NULL,NULL),(4964,3184,'AP','5048841608',0,'2013-12-25 20:31:57',NULL,NULL),(7784,5082,'TE','8303343828',0,'2013-12-25 23:00:59',NULL,NULL),(7644,4976,'EM','miyeshaj@yahoo.com',0,'2013-12-25 22:46:36',NULL,NULL),(5186,3329,'EM','e.bartley@fuse.net',0,'2013-12-25 21:16:15',NULL,NULL),(20805,13367,'AP','5138074202',0,'2013-12-26 12:59:40',NULL,NULL),(14957,9784,'AP','6149378305',0,'2013-12-26 05:00:50',NULL,NULL),(6223,4012,'AP','5132260327',0,'2013-12-25 21:45:27',NULL,NULL),(13832,9017,'EM','dank1267@sdcglobal.net',0,'2013-12-26 04:05:15',NULL,NULL),(9792,6407,'AP','4192030566',0,'2013-12-26 00:48:31',NULL,NULL),(10257,6703,'TE','4194669729',0,'2013-12-26 01:01:58',NULL,NULL),(25793,16621,'AP','9548018213',0,'2014-01-08 18:24:11',NULL,NULL),(24352,15727,'EM','lyons.sean.robert@gmail.com',0,'2014-01-03 02:00:23',NULL,NULL),(24138,15585,'EM','sevendust1@sbcglobal.net',1,'2014-01-02 04:32:18',NULL,NULL),(26756,17210,'EM','debloucks@att.net',0,'2014-01-13 02:22:29',NULL,NULL),(28299,18241,'TE','9565023259',0,'2014-01-16 08:44:25',NULL,NULL),(31382,20455,'AP','5132609632',0,'2014-01-29 21:00:48',NULL,NULL),(33134,21704,'TE','6012065754',0,'2014-02-05 21:31:12',NULL,NULL),(33356,21852,'TE','7402841003',0,'2014-02-06 21:01:16',NULL,NULL),(36297,23898,'EM','amyloucherry@gmail.com',0,'2014-02-14 21:32:22',NULL,NULL),(38424,25388,'EM','wielanda1964@yahoo.com',0,'2014-02-25 21:30:51',NULL,NULL),(38604,25512,'TE','9379275612',0,'2014-02-25 21:32:01',NULL,NULL),(39111,25873,'AP','5044444633',0,'2014-02-26 21:00:52',NULL,NULL),(39149,25895,'AP','4098824585',0,'2014-02-26 21:01:05',NULL,NULL),(864,539,'AP','3308006582',0,'2013-12-25 17:49:40',NULL,NULL),(23300,15014,'TE','3304994889',0,'2014-01-01 12:02:07',NULL,NULL),(26513,17059,'AP','9153091494',0,'2014-01-13 02:21:11',NULL,NULL),(26320,16945,'AP','2252841191',0,'2014-01-13 02:19:56',NULL,NULL),(26078,16795,'AP','2142930739',0,'2014-01-13 02:18:08',NULL,NULL),(21106,13569,'TE','3183499137',0,'2013-12-26 13:04:37',NULL,NULL),(7754,5063,'TE','9039827044',0,'2013-12-25 23:00:29',NULL,NULL),(8856,5804,'TE','9797337763',0,'2013-12-25 23:47:34',NULL,NULL),(3789,2406,'TE','3305947027',0,'2013-12-25 19:33:39',NULL,NULL),(4653,2974,'TE','8174812114',0,'2013-12-25 20:17:03',NULL,NULL),(28285,18235,'TE','8326963895',0,'2014-01-16 08:44:22',NULL,NULL),(30466,19750,'AP','4193446438',0,'2014-01-23 21:01:17',NULL,NULL),(32300,21097,'TE','9376871130',0,'2014-02-02 19:00:32',NULL,NULL),(33709,22113,'TE','7132778013',0,'2014-02-08 19:00:35',NULL,NULL),(35917,23634,'AP','9038049852',0,'2014-02-14 21:30:04',NULL,NULL),(384,235,'EM','mpmeehan@ameritech.net',0,'2013-12-25 17:21:08',NULL,NULL),(25710,16572,'EM','AHONDAMAN3@AOL.COM',1,'2014-01-07 10:23:25',NULL,NULL),(9262,6061,'AP','2163922707',0,'2013-12-26 00:01:57',NULL,NULL),(4757,3045,'EM','pastortimwhite@gmail.com',0,'2013-12-25 20:18:45',NULL,NULL),(11748,7648,'TE','4407147551',0,'2013-12-26 02:46:46',NULL,NULL),(12082,7892,'AP','4198909682',0,'2013-12-26 03:05:39',NULL,NULL),(20417,13146,'TE','2167859778',0,'2013-12-26 12:53:29',NULL,NULL),(25606,16518,'TE','8174675707',1,'2014-01-07 10:21:35',NULL,NULL),(23564,15210,'EM','arquinter1@hotmail.com',0,'2014-01-01 12:07:41',NULL,NULL),(23133,14912,'EM','Samhaddix09@yahoo.com',0,'2013-12-30 00:01:28',NULL,NULL),(27138,17475,'EM','ericathornton12014@yahoo.com',0,'2014-01-13 03:01:09',NULL,NULL),(34841,22848,'TE','4192037391',0,'2014-02-11 21:02:18',NULL,NULL),(36325,23924,'TE','3306125560',0,'2014-02-14 22:00:08',NULL,NULL),(37120,24438,'TE','3309060832',0,'2014-02-18 22:01:17',NULL,NULL),(39239,25957,'TE','4402480495',0,'2014-02-26 21:01:40',NULL,NULL),(39307,26002,'EM','dlm0419@gmail.com',0,'2014-02-26 21:02:04',NULL,NULL),(43528,28900,'TE','9563303552',0,'2014-03-10 21:00:20',NULL,NULL),(26032,16772,'AP','2283481972',0,'2014-01-08 18:25:02',NULL,NULL),(10854,7045,'EM','riverhawkgus@yahoo.com',0,'2013-12-26 01:49:32',NULL,NULL),(2095,1294,'TE','9282667521',0,'2013-12-25 18:30:58',NULL,NULL),(7684,5007,'EM','kareemwsmith@yahoo.com',0,'2013-12-25 22:47:17',NULL,NULL),(2715,1648,'AP','4324483367',0,'2013-12-25 18:53:17',NULL,NULL),(4930,3164,'EM','krtsalx3@aol.com',0,'2013-12-25 20:31:25',NULL,NULL),(6748,4380,'EM','halloweentown1313@gmail.com',0,'2013-12-25 22:00:36',NULL,NULL),(3352,2107,'TE','2343805001',0,'2013-12-25 19:17:21',NULL,NULL),(27064,17407,'AP','9568620687',0,'2014-01-13 03:00:20',NULL,NULL),(30023,19443,'AP','3304378650',0,'2014-01-23 03:01:50',NULL,NULL),(31758,20725,'AP','4197093386',0,'2014-01-30 21:01:16',NULL,NULL),(33051,21652,'TE','5048587013',0,'2014-02-05 21:30:50',NULL,NULL),(33869,22232,'TE','8065767496',0,'2014-02-09 19:00:32',NULL,NULL),(35600,23410,'EM','Delilahdav@yahoo.com',0,'2014-02-13 22:01:16',NULL,NULL),(35710,23485,'AP','5043557148',0,'2014-02-13 22:01:58',NULL,NULL),(35954,23654,'AP','6825600363',0,'2014-02-14 21:30:16',NULL,NULL),(36399,23972,'TE','3189256488',0,'2014-02-15 22:00:15',NULL,NULL),(36772,24212,'EM','Joanheuer@yahoo.com',0,'2014-02-16 19:00:24',NULL,NULL),(36792,24224,'EM','madssanatic099@gmail.com',0,'2014-02-16 19:00:30',NULL,NULL),(37676,24842,'EM','k_tweet99@hotmail.com',0,'2014-02-20 04:54:09',NULL,NULL),(37930,25028,'TE','5126365967',0,'2014-02-20 22:01:01',NULL,NULL),(38173,25195,'TE','2253021804',0,'2014-02-21 22:00:42',NULL,NULL),(43886,29119,'AP','6012129684',0,'2014-03-10 21:02:29',NULL,NULL),(22986,14826,'TE','4193454000',1,'2013-12-29 11:14:27',NULL,NULL),(26561,17085,'AP','2103286278',0,'2014-01-13 02:21:24',NULL,NULL),(20731,13325,'AP','5124617807',0,'2013-12-26 12:58:28',NULL,NULL),(20617,13258,'EM','drrickpipkin@verizon.net',0,'2013-12-26 12:56:37',NULL,NULL),(8605,5653,'AP','9154439316',0,'2013-12-25 23:31:34',NULL,NULL),(20465,13184,'TE','2818978340',0,'2013-12-26 12:54:25',NULL,NULL),(5337,3420,'AP','2252845053',0,'2013-12-25 21:18:37',NULL,NULL),(20336,13103,'TE','4402882303',0,'2013-12-26 12:52:13',NULL,NULL),(4416,2814,'TE','5123187247',0,'2013-12-25 20:00:20',NULL,NULL),(14541,9499,'TE','5136624325',0,'2013-12-26 04:35:08',NULL,NULL),(4238,2710,'AP','3309980303',0,'2013-12-25 19:47:56',NULL,NULL),(13641,8893,'EM','hanna.alan@gmail.com',0,'2013-12-26 04:02:05',NULL,NULL),(9850,6441,'TE','2252262120',0,'2013-12-26 00:49:27',NULL,NULL),(9755,6379,'TE','5139850010',0,'2013-12-26 00:47:53',NULL,NULL),(2908,1782,'TE','2162626795',0,'2013-12-25 18:56:23',NULL,NULL),(28384,18286,'EM','lmazur404@gmail.com',0,'2014-01-16 08:44:50',NULL,NULL),(31398,20469,'TE','4405935930',0,'2014-01-29 21:00:54',NULL,NULL),(33878,22235,'AP','7133067144',0,'2014-02-09 19:00:35',NULL,NULL),(35290,23180,'TE','6017200546',0,'2014-02-12 21:31:57',NULL,NULL),(36284,23890,'TE','9374811597',0,'2014-02-14 21:32:18',NULL,NULL),(36978,24345,'EM','hmreyna77@gmail.com',0,'2014-02-18 22:00:23',NULL,NULL),(37597,24770,'TE','5137312560',0,'2014-02-20 04:44:24',NULL,NULL),(38544,25470,'TE','7138550558',0,'2014-02-25 21:31:36',NULL,NULL),(39895,26403,'TE','4193029638',0,'2014-02-28 07:00:32',NULL,NULL),(41070,27283,'EM','pastorswhite@yahoo.com',0,'2014-03-04 21:00:24',NULL,NULL),(26947,17329,'EM','bellabe@consultant.com',0,'2014-01-13 02:23:56',NULL,NULL),(3955,2511,'TE','4405066582',0,'2013-12-25 19:36:18',NULL,NULL),(3010,1870,'TE','2163712592',0,'2013-12-25 18:58:17',NULL,NULL),(21789,14039,'AP','5138885538',0,'2013-12-26 13:17:07',NULL,NULL),(2887,1766,'EM','RYAN.RUTAN@GMAIL.COM',0,'2013-12-25 18:56:03',NULL,NULL),(9120,5974,'AP','5134706274',0,'2013-12-25 23:51:45',NULL,NULL),(11399,7419,'AP','3302085182',0,'2013-12-26 02:16:59',NULL,NULL),(12327,8062,'TE','4192662691',0,'2013-12-26 03:09:59',NULL,NULL),(27702,17855,'TE','5135209275',0,'2014-01-15 02:06:08',NULL,NULL),(31035,20190,'EM','jackgibson74@yahoo.com',0,'2014-01-27 21:01:26',NULL,NULL),(34353,22535,'TE','6018621303',0,'2014-02-10 21:31:35',NULL,NULL),(37791,24940,'EM','grahamnakeshia@gmail.com',0,'2014-02-20 22:00:04',NULL,NULL),(42980,28584,'EM','nllewis45@yahoo.com',0,'2014-03-08 21:00:09',NULL,NULL),(43012,28602,'TE','6144195487',0,'2014-03-08 21:30:10',NULL,NULL),(23896,15416,'AP','3612195318',1,'2014-01-02 04:27:18',NULL,NULL),(23239,14974,'TE','8302859535',0,'2014-01-01 12:00:56',NULL,NULL),(8900,5828,'AP','9567925068',0,'2013-12-25 23:48:12',NULL,NULL),(21542,13848,'EM','mgf7684@yahoo.com',0,'2013-12-26 13:12:32',NULL,NULL),(2670,1620,'AP','3015292940',0,'2013-12-25 18:52:34',NULL,NULL),(12314,8051,'AP','4198439349',0,'2013-12-26 03:09:42',NULL,NULL),(10324,6734,'TE','5137874168',0,'2013-12-26 01:15:34',NULL,NULL),(8424,5545,'TE','3306717566',0,'2013-12-25 23:15:57',NULL,NULL),(5655,3630,'AP','9376182480',0,'2013-12-25 21:30:07',NULL,NULL),(27329,17598,'EM','lathon_bruce_leonon@yahoo.com',0,'2014-01-14 01:32:14',NULL,NULL),(30029,19448,'EM','jmontalvo0809@gmail.com',0,'2014-01-23 03:01:52',NULL,NULL),(30217,19575,'EM','angiefuselier3@gmail.com',0,'2014-01-23 03:02:38',NULL,NULL),(31588,20603,'AP','3305195367',0,'2014-01-30 21:00:14',NULL,NULL),(31679,20666,'EM','t_rashard_b@yahoo.com',0,'2014-01-30 21:00:47',NULL,NULL),(39918,26417,'TE','4693247440',0,'2014-02-28 07:30:05',NULL,NULL),(42425,28174,'TE','4404764351',0,'2014-03-06 21:02:52',NULL,NULL),(43529,28900,'AP','9563303552',0,'2014-03-10 21:00:21',NULL,NULL),(408,250,'TE','2256275313',0,'2013-12-25 17:21:33',NULL,NULL),(1122,690,'TE','7404057886',0,'2013-12-25 18:02:37',NULL,NULL),(22193,14295,'EM','wewilly3@att.net',0,'2013-12-27 02:06:42',NULL,NULL),(21631,13924,'EM','dqphan@yahoo.com',0,'2013-12-26 13:14:16',NULL,NULL),(14912,9756,'EM','MonicaMonaye@gmail.com',0,'2013-12-26 05:00:06',NULL,NULL),(2008,1242,'AP','3302422474',0,'2013-12-25 18:20:59',NULL,NULL),(14720,9629,'AP','3303224018',0,'2013-12-26 04:38:10',NULL,NULL),(6408,4137,'AP','3303572586',0,'2013-12-25 21:48:30',NULL,NULL),(30394,19696,'TE','9792792289',0,'2014-01-23 21:00:45',NULL,NULL),(30755,19987,'AP','4199023101',0,'2014-01-25 19:00:18',NULL,NULL),(35289,23179,'EM','ITSADAMWEST@GMAIL.COM',0,'2014-02-12 21:31:57',NULL,NULL),(38658,25548,'AP','9372660097',0,'2014-02-26 08:00:16',NULL,NULL),(43854,29103,'TE','4192621693',0,'2014-03-10 21:02:18',NULL,NULL),(416,255,'TE','5043294532',0,'2013-12-25 17:21:41',NULL,NULL),(26422,17003,'TE','9378852256',0,'2014-01-13 02:20:32',NULL,NULL),(31028,20184,'EM','moesamaha@yahoo.com',0,'2014-01-27 21:01:23',NULL,NULL),(29353,18966,'TE','3612431147',0,'2014-01-20 08:05:59',NULL,NULL),(28949,18687,'AP','5045631875',0,'2014-01-17 03:35:23',NULL,NULL),(28076,18094,'TE','3373804592',0,'2014-01-15 02:07:32',NULL,NULL),(7966,5197,'TE','9376051025',0,'2013-12-25 23:03:56',NULL,NULL),(4084,2604,'TE','3305249333',0,'2013-12-25 19:45:25',NULL,NULL),(7607,4955,'TE','5044579555',0,'2013-12-25 22:46:02',NULL,NULL),(2523,1544,'TE','4128749395',0,'2013-12-25 18:50:25',NULL,NULL),(34117,22367,'AP','9852100420',0,'2014-02-10 21:00:11',NULL,NULL),(35799,23539,'AP','3373091909',0,'2014-02-13 22:02:32',NULL,NULL),(39616,26203,'TE','3304087686',0,'2014-02-28 06:30:50',NULL,NULL),(43454,28858,'TE','5133024955',0,'2014-03-09 21:30:01',NULL,NULL),(9720,6362,'EM','seth@sethkbrown.com',0,'2013-12-26 00:47:24',NULL,NULL),(8407,5533,'TE','4404666007',0,'2013-12-25 23:15:38',NULL,NULL),(7235,4712,'TE','4199682122',0,'2013-12-25 22:08:45',NULL,NULL),(31367,20442,'TE','6019413298',0,'2014-01-29 21:00:41',NULL,NULL),(30463,19749,'AP','8179965170',0,'2014-01-23 21:01:16',NULL,NULL),(6765,4390,'EM','DONHBRAND@GMAIL.COM',0,'2013-12-25 22:00:52',NULL,NULL),(27717,17866,'TE','4409849757',0,'2014-01-15 02:06:12',NULL,NULL),(14261,9328,'TE','5134048598',0,'2013-12-26 04:30:42',NULL,NULL),(13949,9095,'TE','4402908274',0,'2013-12-26 04:07:13',NULL,NULL),(5039,3235,'TE','7406293396',0,'2013-12-25 20:46:09',NULL,NULL),(3227,2029,'TE','3306459162',0,'2013-12-25 19:15:18',NULL,NULL),(14256,9325,'TE','4047518397',0,'2013-12-26 04:30:37',NULL,NULL),(2231,1370,'AP','2542478521',0,'2013-12-25 18:45:46',NULL,NULL),(22528,14525,'EM','moses_ortiz10@yahoo.com',0,'2013-12-28 03:34:25',NULL,NULL),(33147,21711,'TE','9377255185',0,'2014-02-05 21:31:15',NULL,NULL),(32125,20977,'AP','6015191165',0,'2014-02-01 19:00:18',NULL,NULL),(31306,20399,'EM','juneputman@yahoo.com',0,'2014-01-29 21:00:19',NULL,NULL),(21020,13525,'TE','5044507077',0,'2013-12-26 13:03:18',NULL,NULL),(13817,9004,'TE','2167807439',0,'2013-12-26 04:04:58',NULL,NULL),(9340,6115,'TE','3302243582',0,'2013-12-26 00:15:35',NULL,NULL),(7540,4913,'TE','6623578518',0,'2013-12-25 22:32:09',NULL,NULL),(5409,3465,'AP','6145566304',0,'2013-12-25 21:19:47',NULL,NULL),(36918,24314,'AP','2542287787',0,'2014-02-18 22:00:04',NULL,NULL),(43231,28726,'AP','3376921704',0,'2014-03-09 21:00:00',NULL,NULL),(20318,13093,'TE','5132604991',0,'2013-12-26 12:51:57',NULL,NULL),(14581,9534,'TE','3304929220',0,'2013-12-26 04:35:52',NULL,NULL),(5307,3402,'AP','3182724065',0,'2013-12-25 21:18:09',NULL,NULL),(14269,9334,'AP','5136158633',0,'2013-12-26 04:30:49',NULL,NULL),(13518,8817,'TE','5135607196',0,'2013-12-26 04:00:08',NULL,NULL),(42159,28007,'TE','6146782073',0,'2014-03-06 21:01:13',NULL,NULL),(23029,14855,'TE','3304004848',1,'2013-12-29 11:15:12',NULL,NULL),(31104,20251,'EM','ashley.n.kemper@gmail.com',0,'2014-01-28 21:00:13',NULL,NULL),(21603,13903,'TE','4194603225',0,'2013-12-26 13:13:45',NULL,NULL),(11964,7796,'AP','5129711069',0,'2013-12-26 03:03:33',NULL,NULL),(20268,13064,'TE','6147079353',0,'2013-12-26 12:51:08',NULL,NULL),(12173,7952,'EM','patinj22@yahoo.com',0,'2013-12-26 03:07:12',NULL,NULL),(7998,5220,'TE','5132644351',0,'2013-12-25 23:04:31',NULL,NULL),(35132,23073,'TE','2256342941',0,'2014-02-12 21:30:58',NULL,NULL),(36629,24114,'TE','9156138049',0,'2014-02-15 22:01:38',NULL,NULL),(38607,25515,'AP','9372058603',0,'2014-02-25 21:32:03',NULL,NULL),(42601,28342,'AP','4144917419',0,'2014-03-07 21:30:18',NULL,NULL),(10563,6876,'AP','5136926018',0,'2013-12-26 01:32:08',NULL,NULL),(22220,14324,'TE','3302042803',0,'2013-12-27 02:07:20',NULL,NULL),(21745,14007,'TE','6144411223',0,'2013-12-26 13:16:16',NULL,NULL),(30505,19786,'EM','ettahamilton@netzero.net',0,'2014-01-23 21:01:37',NULL,NULL),(31166,20296,'AP','3188055654',0,'2014-01-28 21:00:40',NULL,NULL),(30842,20049,'TE','3235402017',0,'2014-01-27 21:00:04',NULL,NULL),(41769,27773,'AP','3375709336',0,'2014-03-05 21:31:28',NULL,NULL),(43831,29093,'AP','2105771491',0,'2014-03-10 21:02:11',NULL,NULL),(14586,9536,'AP','3302843135',0,'2013-12-26 04:35:55',NULL,NULL),(33329,21831,'TE','4699649149',0,'2014-02-06 21:01:05',NULL,NULL),(28226,18197,'EM','saksguy@aol.com',0,'2014-01-15 02:08:06',NULL,NULL),(28045,18073,'TE','3183458873',0,'2014-01-15 02:07:24',NULL,NULL),(10290,6716,'AP','3304006036',0,'2013-12-26 01:15:04',NULL,NULL),(2907,1782,'AP','2162626795',0,'2013-12-25 18:56:22',NULL,NULL),(2082,1287,'EM','pjcjc1342@aol.com',0,'2013-12-25 18:30:45',NULL,NULL),(8679,5698,'TE','5135220266',0,'2013-12-25 23:32:50',NULL,NULL),(36849,24266,'TE','2162109212',0,'2014-02-17 19:00:14',NULL,NULL),(40960,27217,'TE','6012787215',0,'2014-03-03 21:31:32',NULL,NULL),(43248,28738,'AP','5042220724',0,'2014-03-09 21:00:07',NULL,NULL),(361,221,'EM','janice.prine@lpsb.org',0,'2013-12-25 17:20:47',NULL,NULL),(33257,21777,'EM','mlbridgeford@fuse.net',0,'2014-02-06 21:00:36',NULL,NULL),(13704,8933,'TE','4403661160',0,'2013-12-26 04:03:05',NULL,NULL),(29718,19217,'TE','9377288207',0,'2014-01-21 08:46:24',NULL,NULL),(29581,19113,'AP','9375540535',0,'2014-01-21 08:44:46',NULL,NULL),(7510,4893,'AP','2108728703',0,'2013-12-25 22:31:35',NULL,NULL),(11583,7539,'AP','2542833186',0,'2013-12-26 02:32:50',NULL,NULL),(5156,3305,'EM','christian.manansala@fusionatics.com',0,'2013-12-25 21:15:48',NULL,NULL),(35684,23473,'TE','3252628967',0,'2014-02-13 22:01:49',NULL,NULL),(40189,26658,'AP','3309330092',0,'2014-02-28 21:31:10',NULL,NULL),(10442,6805,'EM','kenyon.andrews@yahoo.com',0,'2013-12-26 01:30:08',NULL,NULL),(23038,14861,'TE','4192352564',1,'2013-12-29 11:15:22',NULL,NULL),(28979,18705,'TE','9375545405',0,'2014-01-17 03:35:29',NULL,NULL),(4309,2750,'TE','5132021552',0,'2013-12-25 19:49:03',NULL,NULL),(4500,2863,'EM','skipandcaroline@yahoo.com',0,'2013-12-25 20:01:41',NULL,NULL),(43079,28639,'AP','9569704802',0,'2014-03-08 21:30:32',NULL,NULL),(14522,9488,'TE','4409745055',0,'2013-12-26 04:34:51',NULL,NULL),(31203,20319,'AP','9568547081',0,'2014-01-28 21:00:55',NULL,NULL),(29645,19154,'AP','4403449475',0,'2014-01-21 08:45:37',NULL,NULL),(5788,3711,'TE','5138610324',0,'2013-12-25 21:32:11',NULL,NULL),(35975,23670,'AP','5123638343',0,'2014-02-14 21:30:24',NULL,NULL),(37504,24694,'AP','3612930628',0,'2014-02-20 04:33:13',NULL,NULL),(37580,24755,'EM','bigben9578@hotmail.com',0,'2014-02-20 04:42:22',NULL,NULL),(37891,24995,'AP','4326345687',0,'2014-02-20 22:00:43',NULL,NULL),(37965,25049,'TE','9373607772',0,'2014-02-20 22:01:16',NULL,NULL),(38058,25117,'EM','robert.lantz@outlook.com',0,'2014-02-21 21:30:19',NULL,NULL),(38115,25158,'AP','3612127593',0,'2014-02-21 22:00:21',NULL,NULL),(42089,27965,'TE','2258196551',0,'2014-03-06 21:00:47',NULL,NULL),(1257,763,'TE','9037152197',0,'2013-12-25 18:04:37',NULL,NULL),(24821,16011,'AP','5043436583',0,'2014-01-04 02:01:50',NULL,NULL),(29178,18853,'TE','3304340226',0,'2014-01-17 03:36:17',NULL,NULL),(5316,3408,'TE','5043194241',0,'2013-12-25 21:18:18',NULL,NULL),(10952,7120,'TE','9377283472',0,'2013-12-26 01:51:17',NULL,NULL),(2960,1833,'TE','3306719767',0,'2013-12-25 18:57:28',NULL,NULL),(37351,24589,'EM','buterflyze02@att.net',0,'2014-02-20 04:10:35',NULL,NULL),(37356,24593,'AP','3305502750',0,'2014-02-20 04:11:11',NULL,NULL),(11933,7773,'TE','9563346399',0,'2013-12-26 03:02:59',NULL,NULL),(34327,22521,'EM','dbmillman@fuse.net',0,'2014-02-10 21:31:25',NULL,NULL),(25806,16630,'TE','4406542444',0,'2014-01-08 18:24:14',NULL,NULL),(1571,969,'TE','6016022400',0,'2013-12-25 18:09:58',NULL,NULL),(33775,22166,'EM','lhazelwood@fuse.net',0,'2014-02-08 19:01:01',NULL,NULL),(33361,21854,'EM','columbuslei@yahoo.com',0,'2014-02-06 21:01:17',NULL,NULL),(37102,24425,'TE','3308253026',0,'2014-02-18 22:01:11',NULL,NULL),(38866,25688,'AP','6018136314',0,'2014-02-26 09:30:10',NULL,NULL),(41940,27881,'AP','4193716251',0,'2014-03-05 21:32:33',NULL,NULL),(417,255,'AP','5043294532',0,'2013-12-25 17:21:41',NULL,NULL),(31592,20607,'AP','5132377763',0,'2014-01-30 21:00:16',NULL,NULL),(30954,20135,'AP','2168545176',0,'2014-01-27 21:00:54',NULL,NULL),(30225,19578,'EM','garyandmom12@yahoo.com',0,'2014-01-23 03:02:39',NULL,NULL),(27871,17960,'TE','9034983334',0,'2014-01-15 02:06:45',NULL,NULL),(8150,5336,'TE','3303791017',0,'2013-12-25 23:07:13',NULL,NULL),(2331,1421,'AP','4697139521',0,'2013-12-25 18:47:15',NULL,NULL),(20911,13448,'AP','4123524039',0,'2013-12-26 13:01:24',NULL,NULL),(38907,25720,'EM','tattit@suddenlink.net',0,'2014-02-26 09:30:28',NULL,NULL),(39142,25889,'AP','9792009333',0,'2014-02-26 21:01:02',NULL,NULL),(9394,6147,'EM','victoriastrickland@yahoo.com',0,'2013-12-26 00:16:26',NULL,NULL),(11988,7810,'TE','2819804646',0,'2013-12-26 03:03:56',NULL,NULL),(5676,3646,'TE','7405918360',0,'2013-12-25 21:30:31',NULL,NULL),(27471,17697,'TE','9856340392',0,'2014-01-14 01:33:02',NULL,NULL),(13873,9045,'TE','4404284594',0,'2013-12-26 04:05:56',NULL,NULL),(34675,22738,'AP','3373486229',0,'2014-02-11 21:01:18',NULL,NULL),(10131,6623,'AP','6623466805',0,'2013-12-26 00:54:07',NULL,NULL),(33798,22190,'TE','3182670071',0,'2014-02-09 19:00:08',NULL,NULL),(10078,6587,'EM','barlowjerry68@yahoo.com',0,'2013-12-26 00:53:08',NULL,NULL),(6852,4445,'AP','3306967989',0,'2013-12-25 22:02:14',NULL,NULL),(22708,14644,'AP','5127996622',1,'2013-12-29 11:07:32',NULL,NULL),(37114,24435,'AP','3305540644',0,'2014-02-18 22:01:15',NULL,NULL),(40352,26781,'TE','9562713806',0,'2014-03-01 21:00:13',NULL,NULL),(8026,5248,'EM','tym5@att.net',0,'2013-12-25 23:05:04',NULL,NULL),(21019,13524,'TE','3184101617',0,'2013-12-26 13:03:17',NULL,NULL),(23064,14876,'AP','9033125496',0,'2013-12-30 00:00:22',NULL,NULL),(39455,26093,'TE','9852552880',0,'2014-02-28 06:30:09',NULL,NULL),(39880,26385,'TE','4404767132',0,'2014-02-28 07:00:23',NULL,NULL),(43571,28935,'TE','5132250726',0,'2014-03-10 21:00:39',NULL,NULL),(820,511,'AP','5134906903',0,'2013-12-25 17:48:56',NULL,NULL),(32281,21087,'AP','3305463646',0,'2014-02-02 19:00:25',NULL,NULL),(25206,16254,'EM','bud7@aol.com',0,'2014-01-05 00:02:42',NULL,NULL),(7561,4923,'TE','3309668112',0,'2013-12-25 22:45:13',NULL,NULL),(1093,672,'AP','5132586570',0,'2013-12-25 18:02:10',NULL,NULL),(1349,823,'AP','7078158061',0,'2013-12-25 18:06:09',NULL,NULL),(40759,27085,'EM','hinckleyds@earthlink.net',0,'2014-03-03 21:30:14',NULL,NULL),(7240,4714,'AP','4193480854',0,'2013-12-25 22:08:48',NULL,NULL),(33787,22177,'EM','jessicalandrum8706@gmail.com',0,'2014-02-08 19:30:09',NULL,NULL),(32776,21442,'EM','crysford865@gmail.com',0,'2014-02-04 21:01:25',NULL,NULL),(13879,9053,'TE','5125969715',0,'2013-12-26 04:06:05',NULL,NULL),(21036,13534,'AP','5042729341',0,'2013-12-26 13:03:34',NULL,NULL),(26636,17138,'EM','alyssa.hoot14@gmail.com',0,'2014-01-13 02:21:50',NULL,NULL),(38516,25454,'TE','8066475592',0,'2014-02-25 21:31:27',NULL,NULL),(39193,25922,'EM','ELENACASTILLO66@YAHOO.COM',0,'2014-02-26 21:01:21',NULL,NULL),(40838,27136,'EM','sherridoty@aol.com',0,'2014-03-03 21:30:44',NULL,NULL),(43282,28757,'TE','2817961344',0,'2014-03-09 21:00:20',NULL,NULL),(101,59,'TE','5134458145',0,'2013-12-25 17:16:37',NULL,NULL),(34621,22700,'TE','9036415555',0,'2014-02-11 21:00:58',NULL,NULL),(28068,18091,'TE','3182674046',0,'2014-01-15 02:07:30',NULL,NULL),(21963,14149,'AP','9856341435',0,'2013-12-27 02:02:51',NULL,NULL),(969,596,'TE','7033141598',0,'2013-12-25 18:00:12',NULL,NULL),(33163,21721,'TE','4197874238',0,'2014-02-05 21:31:20',NULL,NULL),(421,256,'EM','yvetterhyde@gmail.com',0,'2013-12-25 17:21:44',NULL,NULL),(30862,20060,'TE','2143922898',0,'2014-01-27 21:00:11',NULL,NULL),(37552,24724,'TE','4405037555',0,'2014-02-20 04:38:33',NULL,NULL),(7414,4820,'EM','rhummakron@netscape.com',0,'2013-12-25 22:17:04',NULL,NULL),(31288,20383,'AP','2548332483',0,'2014-01-29 21:00:12',NULL,NULL),(27522,17728,'TE','3307847622',0,'2014-01-14 01:33:18',NULL,NULL),(6590,4254,'EM','sewspider@aol.com',0,'2013-12-25 21:51:22',NULL,NULL),(24416,15763,'EM','dcolman3851@gmail.com',0,'2014-01-03 02:01:34',NULL,NULL),(22026,14185,'AP','9159207590',0,'2013-12-27 02:03:50',NULL,NULL),(36462,24008,'EM','jada3h@yahoo.com',0,'2014-02-15 22:00:38',NULL,NULL),(39021,25803,'TE','6142044263',0,'2014-02-26 21:00:18',NULL,NULL),(41823,27809,'EM','maggiemcc2005@yahoo.com',0,'2014-03-05 21:31:49',NULL,NULL),(42035,27937,'EM','esbc1office@verizon.net',0,'2014-03-06 21:00:30',NULL,NULL),(8326,5460,'AP','3304190535',0,'2013-12-25 23:10:23',NULL,NULL),(5522,3533,'TE','5123482976',0,'2013-12-25 21:21:33',NULL,NULL),(35226,23136,'TE','3304159287',0,'2014-02-12 21:31:33',NULL,NULL),(14017,9154,'EM','mcginnkr@mail.uc.edu',0,'2013-12-26 04:08:31',NULL,NULL),(1730,1061,'TE','4198299964',0,'2013-12-25 18:16:18',NULL,NULL),(31752,20721,'AP','9377799008',0,'2014-01-30 21:01:14',NULL,NULL),(26943,17328,'AP','9012779304',0,'2014-01-13 02:23:55',NULL,NULL),(38195,25208,'EM','jamescagney57@yahoo.com',0,'2014-02-21 22:00:50',NULL,NULL),(4444,2832,'EM','pdalafayette@pdaorg.net',0,'2013-12-25 20:00:48',NULL,NULL),(2796,1691,'EM','lincanchu@yahoo.com',0,'2013-12-25 18:54:29',NULL,NULL),(32661,21360,'EM','tyraniqua.payton@gmail.com',0,'2014-02-04 21:00:43',NULL,NULL),(24253,15672,'TE','5675105527',1,'2014-01-02 04:34:44',NULL,NULL),(28937,18682,'EM','lllandry88@yahoo.com',0,'2014-01-17 03:35:21',NULL,NULL),(38456,25411,'AP','3307808867',0,'2014-02-25 21:31:03',NULL,NULL),(39151,25896,'TE','2106473023',0,'2014-02-26 21:01:06',NULL,NULL),(41180,27350,'TE','2164214956',0,'2014-03-04 21:01:04',NULL,NULL),(25450,16412,'TE','8068318010',0,'2014-01-07 04:04:15',NULL,NULL),(35498,23339,'TE','3306962094',0,'2014-02-13 22:00:37',NULL,NULL),(33412,21892,'TE','6015663370',0,'2014-02-06 21:01:39',NULL,NULL),(24980,16099,'AP','4193491605',0,'2014-01-04 02:04:43',NULL,NULL),(14125,9250,'EM','jrammel@univenture.com',0,'2013-12-26 04:10:47',NULL,NULL),(29655,19158,'TE','2167722185',0,'2014-01-21 08:45:40',NULL,NULL),(3609,2279,'AP','4406690460',0,'2013-12-25 19:30:32',NULL,NULL),(6177,3981,'TE','4193062071',0,'2013-12-25 21:38:49',NULL,NULL),(24103,15560,'TE','3306682321',1,'2014-01-02 04:31:33',NULL,NULL),(23092,14892,'AP','5042147444',0,'2013-12-30 00:00:50',NULL,NULL),(22288,14365,'TE','4192393641',0,'2013-12-28 03:30:22',NULL,NULL),(36652,24127,'AP','3182431010',0,'2014-02-15 22:01:46',NULL,NULL),(37503,24695,'TE','5132655186',0,'2014-02-20 04:33:12',NULL,NULL),(38076,25135,'TE','9725138745',0,'2014-02-21 22:00:06',NULL,NULL),(40832,27134,'AP','2168492705',0,'2014-03-03 21:30:42',NULL,NULL),(22933,14797,'TE','2167021303',1,'2013-12-29 11:13:38',NULL,NULL),(7168,4675,'TE','3373499411',0,'2013-12-25 22:07:43',NULL,NULL),(8007,5224,'AP','4253271474',0,'2013-12-25 23:04:38',NULL,NULL),(6766,4391,'TE','4408432369',0,'2013-12-25 22:00:54',NULL,NULL),(6244,4024,'TE','2163467778',0,'2013-12-25 21:45:45',NULL,NULL),(779,486,'TE','4106032905',0,'2013-12-25 17:48:17',NULL,NULL),(34268,22482,'AP','3305659455',0,'2014-02-10 21:31:03',NULL,NULL),(25918,16703,'TE','9568328860',0,'2014-01-08 18:24:39',NULL,NULL),(25294,16310,'AP','3186133296',0,'2014-01-07 04:01:24',NULL,NULL),(9386,6142,'EM','rarledg3@columbus.rr.com',0,'2013-12-26 00:16:19',NULL,NULL),(2081,1286,'TE','3306280178',0,'2013-12-25 18:30:44',NULL,NULL),(24053,15531,'TE','5043128760',1,'2014-01-02 04:30:38',NULL,NULL),(680,424,'TE','2168200824',0,'2013-12-25 17:46:43',NULL,NULL),(25659,16545,'TE','2163701910',1,'2014-01-07 10:22:31',NULL,NULL),(30925,20110,'EM','sandilanza@aol.com',0,'2014-01-27 21:00:40',NULL,NULL),(9624,6299,'AP','9374171757',0,'2013-12-26 00:45:51',NULL,NULL),(7026,4588,'TE','3303883667',0,'2013-12-25 22:05:24',NULL,NULL),(13537,8827,'EM','DNLGOMEZ@MSN.COM',0,'2013-12-26 04:00:26',NULL,NULL),(10837,7037,'TE','2148307946',0,'2013-12-26 01:49:17',NULL,NULL),(4800,3069,'TE','6468725598',0,'2013-12-25 20:19:26',NULL,NULL),(2060,1275,'TE','6145991075',0,'2013-12-25 18:30:24',NULL,NULL),(12188,7965,'TE','6019247901',0,'2013-12-26 03:07:32',NULL,NULL),(36793,24226,'TE','6144200940',0,'2014-02-16 19:00:31',NULL,NULL),(38454,25410,'AP','5137394290',0,'2014-02-25 21:31:03',NULL,NULL),(43860,29105,'TE','4199536541',0,'2014-03-10 21:02:20',NULL,NULL),(24591,15861,'EM','feds1095@yahoo.com',0,'2014-01-03 02:04:47',NULL,NULL),(34775,22807,'EM','davebarrett50@yahoo.com',0,'2014-02-11 21:01:56',NULL,NULL),(686,426,'EM','connie9413@yahoo.com',0,'2013-12-25 17:46:47',NULL,NULL),(34260,22472,'EM','stephanie.knoth@gmail.com',0,'2014-02-10 21:30:59',NULL,NULL),(32440,21195,'AP','6013476356',0,'2014-02-03 21:00:50',NULL,NULL),(32013,20898,'AP','5134488951',0,'2014-01-31 21:01:19',NULL,NULL),(23375,15059,'TE','3185506007',0,'2014-01-01 12:03:30',NULL,NULL),(38663,25551,'TE','5044025046',0,'2014-02-26 08:00:18',NULL,NULL),(41651,27686,'AP','9034753759',0,'2014-03-05 21:30:41',NULL,NULL),(13715,8936,'EM','theresarich11@yahoo.com',0,'2013-12-26 04:03:13',NULL,NULL),(21433,13780,'TE','9372602407',0,'2013-12-26 13:10:43',NULL,NULL),(30754,19987,'TE','4199023101',0,'2014-01-25 19:00:18',NULL,NULL),(27966,18030,'TE','2163160017',0,'2014-01-15 02:07:08',NULL,NULL),(22187,14293,'TE','2164961838',0,'2013-12-27 02:06:38',NULL,NULL),(40002,26493,'AP','9855191082',0,'2014-02-28 21:00:12',NULL,NULL),(40592,26945,'EM','neffsters@aol.com',0,'2014-03-03 01:00:24',NULL,NULL),(23555,15203,'EM','andylou20@gmail.com',0,'2014-01-01 12:07:29',NULL,NULL),(4704,3008,'EM','RobertMiller311@gmail.com',0,'2013-12-25 20:17:51',NULL,NULL),(25525,16459,'TE','5138315417',0,'2014-01-07 04:05:41',NULL,NULL),(7312,4757,'TE','2148037695',0,'2013-12-25 22:15:25',NULL,NULL),(34604,22691,'EM','LINDA_LATSON51@YAHOO.COM',0,'2014-02-11 21:00:52',NULL,NULL),(35139,23077,'EM','marin2324@gmail.com',0,'2014-02-12 21:31:01',NULL,NULL),(36930,24320,'AP','9728768197',0,'2014-02-18 22:00:08',NULL,NULL),(22370,14428,'TE','3188752289',0,'2013-12-28 03:31:52',NULL,NULL),(31139,20281,'TE','5136172339',0,'2014-01-28 21:00:29',NULL,NULL),(30724,19962,'TE','9563732011',0,'2014-01-25 19:00:07',NULL,NULL),(27352,17611,'TE','9562818355',0,'2014-01-14 01:32:21',NULL,NULL),(25477,16428,'AP','3188011069',0,'2014-01-07 04:04:43',NULL,NULL),(20517,13208,'TE','5126807882',0,'2013-12-26 12:55:10',NULL,NULL),(23581,15224,'TE','2253152414',0,'2014-01-01 12:08:07',NULL,NULL),(5111,3276,'TE','5132254569',0,'2013-12-25 21:15:07',NULL,NULL),(7831,5111,'EM','gdoucet51@gmail.com',0,'2013-12-25 23:01:42',NULL,NULL),(14962,9790,'TE','4405724331',0,'2013-12-26 05:00:56',NULL,NULL),(14847,9716,'TE','5136818509',0,'2013-12-26 04:45:20',NULL,NULL),(41012,27250,'TE','3612055397',0,'2014-03-03 21:31:52',NULL,NULL),(21496,13815,'TE','8594681246',0,'2013-12-26 13:11:43',NULL,NULL),(4175,2668,'TE','3305595203',0,'2013-12-25 19:46:59',NULL,NULL),(31138,20280,'EM','LEONBERGER@WAVELINC.COM',0,'2014-01-28 21:00:29',NULL,NULL),(28166,18156,'TE','4193881110',0,'2014-01-15 02:07:52',NULL,NULL),(25884,16687,'AP','2129458094',0,'2014-01-08 18:24:33',NULL,NULL),(23437,15104,'AP','5135261409',0,'2014-01-01 12:04:47',NULL,NULL),(8159,5339,'AP','9372451250',0,'2013-12-25 23:07:19',NULL,NULL),(14398,9414,'TE','8176737938',0,'2013-12-26 04:32:57',NULL,NULL),(34522,22647,'EM','cfriday88@gmail.com',0,'2014-02-11 21:00:25',NULL,NULL),(36589,24085,'TE','3304314848',0,'2014-02-15 22:01:24',NULL,NULL),(37227,24499,'TE','9724927472',0,'2014-02-20 03:48:25',NULL,NULL),(40452,26854,'EM','Jillianfharper@gmail.com',0,'2014-03-01 21:00:53',NULL,NULL),(41305,27441,'TE','3187805106',0,'2014-03-04 21:01:53',NULL,NULL),(14503,9475,'AP','7327575378',0,'2013-12-26 04:34:32',NULL,NULL),(13749,8959,'TE','2168622098',0,'2013-12-26 04:03:49',NULL,NULL),(30195,19562,'TE','3183433895',0,'2014-01-23 03:02:33',NULL,NULL),(9561,6257,'TE','3304486765',0,'2013-12-26 00:32:11',NULL,NULL),(33866,22230,'EM','jess.briseno@hotmail.com',0,'2014-02-09 19:00:32',NULL,NULL),(37074,24411,'TE','3305016154',0,'2014-02-18 22:01:01',NULL,NULL),(39507,26133,'TE','5134791443',0,'2014-02-28 06:30:23',NULL,NULL),(41246,27396,'BN','7407512901',0,'2014-03-04 21:01:30',NULL,NULL),(10370,6760,'TE','2164096518',0,'2013-12-26 01:16:19',NULL,NULL),(8864,5807,'TE','6128072658',0,'2013-12-25 23:47:41',NULL,NULL),(28316,18251,'AP','9035705660',0,'2014-01-16 08:44:31',NULL,NULL),(523,327,'EM','ricglss@aol.com',0,'2013-12-25 17:31:34',NULL,NULL),(24806,16003,'AP','5127873860',0,'2014-01-04 02:01:34',NULL,NULL),(22107,14240,'AP','7697983745',0,'2013-12-27 02:05:13',NULL,NULL),(14196,9287,'AP','2164037941',0,'2013-12-26 04:16:03',NULL,NULL),(3904,2478,'AP','5044628623',0,'2013-12-25 19:35:26',NULL,NULL),(37043,24393,'AP','4196061510',0,'2014-02-18 22:00:50',NULL,NULL),(39512,26137,'AP','6143167646',0,'2014-02-28 06:30:24',NULL,NULL),(20570,13236,'EM','chris@duncan.cd',0,'2013-12-26 12:55:56',NULL,NULL),(33360,21854,'TE','5132624900',0,'2014-02-06 21:01:17',NULL,NULL),(1551,955,'AP','5134656482',0,'2013-12-25 18:09:39',NULL,NULL),(6664,4326,'TE','9372196167',0,'2013-12-25 21:52:54',NULL,NULL),(24597,15863,'BN','6624710972',0,'2014-01-03 02:04:52',NULL,NULL),(25192,16242,'TE','5135748042',0,'2014-01-05 00:02:25',NULL,NULL),(35324,23209,'EM','skipperbt@yahoo.com',0,'2014-02-12 21:32:13',NULL,NULL),(7822,5106,'AP','2149238722',0,'2013-12-25 23:01:34',NULL,NULL),(31573,20592,'AP','7408142207',0,'2014-01-30 21:00:09',NULL,NULL),(28295,18239,'TE','8063192918',0,'2014-01-16 08:44:24',NULL,NULL),(27316,17593,'TE','9372868304',0,'2014-01-14 01:32:11',NULL,NULL),(27164,17488,'AP','8305132580',0,'2014-01-13 03:01:18',NULL,NULL),(27074,17412,'AP','9374073060',0,'2014-01-13 03:00:22',NULL,NULL),(14725,9632,'AP','9402060500',0,'2013-12-26 04:38:15',NULL,NULL),(24066,15537,'AP','3186503037',1,'2014-01-02 04:30:51',NULL,NULL),(23658,15279,'TE','4409985073',1,'2014-01-02 04:22:02',NULL,NULL),(5871,3766,'EM','tinwzrdslady@aol.com',0,'2013-12-25 21:33:34',NULL,NULL),(3905,2479,'TE','5043198787',0,'2013-12-25 19:35:27',NULL,NULL),(39084,25856,'AP','5044153078',0,'2014-02-26 21:00:42',NULL,NULL),(12453,8155,'AP','3304142490',0,'2013-12-26 03:16:11',NULL,NULL),(30335,19656,'TE','5134298602',0,'2014-01-23 21:00:22',NULL,NULL),(28647,18474,'EM','sehmneal@bfusa.com',0,'2014-01-16 08:46:18',NULL,NULL),(27935,18001,'AP','4407968330',0,'2014-01-15 02:07:00',NULL,NULL),(3742,2374,'AP','2164962982',0,'2013-12-25 19:32:50',NULL,NULL),(4093,2611,'TE','6142664283',0,'2013-12-25 19:45:36',NULL,NULL),(33699,22103,'TE','7247773860',0,'2014-02-08 19:00:31',NULL,NULL),(36561,24068,'EM','mollyanddeb@gmail.com',0,'2014-02-15 22:01:14',NULL,NULL),(43140,28675,'AP','5672771572',0,'2014-03-08 21:30:52',NULL,NULL),(21416,13768,'AP','6014805192',0,'2013-12-26 13:10:26',NULL,NULL),(31102,20251,'TE','9726254477',0,'2014-01-28 21:00:13',NULL,NULL),(29268,18903,'TE','5672083521',0,'2014-01-17 03:36:37',NULL,NULL),(29081,18782,'EM','margejacobs13@yahoo.com',0,'2014-01-17 03:35:53',NULL,NULL),(1478,905,'AP','5133071859',0,'2013-12-25 18:08:24',NULL,NULL),(5463,3499,'TE','4193034752',0,'2013-12-25 21:20:39',NULL,NULL),(35180,23106,'EM','ssandy5020@yahoo.com',0,'2014-02-12 21:31:15',NULL,NULL),(43833,29094,'TE','2144518789',0,'2014-03-10 21:02:12',NULL,NULL),(22560,14550,'TE','6017204671',0,'2013-12-28 03:35:00',NULL,NULL),(4262,2725,'TE','2259782777',0,'2013-12-25 19:48:20',NULL,NULL),(31993,20888,'AP','2167732490',0,'2014-01-31 21:01:13',NULL,NULL),(28983,18707,'AP','6143097778',0,'2014-01-17 03:35:30',NULL,NULL),(26089,16801,'EM','coliver3@patriots.uttyler.edu',0,'2014-01-13 02:18:11',NULL,NULL),(41204,27368,'TE','9378388672',0,'2014-03-04 21:01:14',NULL,NULL),(12347,8075,'EM','aring001@woh.rr.com',0,'2013-12-26 03:10:20',NULL,NULL),(33702,22104,'TE','7247773860',0,'2014-02-08 19:00:31',NULL,NULL),(29983,19408,'TE','3308368561',1,'2014-01-22 03:22:57',NULL,NULL),(10248,6698,'EM','cwilliams0708@gmail.com',0,'2013-12-26 01:01:50',NULL,NULL),(42538,28301,'EM','SALTYKALTY20@AOL.COM',0,'2014-03-07 21:00:32',NULL,NULL),(21069,13550,'TE','5043019136',0,'2013-12-26 13:04:03',NULL,NULL),(5555,3550,'EM','klm5632@aol.com',0,'2013-12-25 21:22:00',NULL,NULL),(31123,20270,'TE','5133304247',0,'2014-01-28 21:00:23',NULL,NULL),(6641,4303,'TE','5137321030',0,'2013-12-25 21:52:24',NULL,NULL),(29054,18760,'TE','6315747868',0,'2014-01-17 03:35:47',NULL,NULL),(28624,18454,'AP','5044003429',0,'2014-01-16 08:46:09',NULL,NULL),(5387,3448,'TE','4405069319',0,'2013-12-25 21:19:25',NULL,NULL),(23927,15437,'AP','8063380838',1,'2014-01-02 04:27:57',NULL,NULL),(37424,24645,'TE','5043449068',0,'2014-02-20 04:21:15',NULL,NULL),(42449,28195,'AP','3253334582',0,'2014-03-06 21:30:06',NULL,NULL),(14958,9784,'EM','sthompson1019@att.net',0,'2013-12-26 05:00:50',NULL,NULL),(526,329,'TE','6149758461',0,'2013-12-25 17:31:38',NULL,NULL),(31572,20592,'TE','7403667756',0,'2014-01-30 21:00:09',NULL,NULL),(14015,9151,'TE','3307945661',0,'2013-12-26 04:08:27',NULL,NULL),(9937,6503,'TE','2162911407',0,'2013-12-26 00:50:54',NULL,NULL),(28495,18362,'TE','5136331088',0,'2014-01-16 08:45:27',NULL,NULL),(35019,22995,'AP','6143274176',0,'2014-02-12 21:30:16',NULL,NULL),(38230,25238,'TE','9372050581',0,'2014-02-21 22:01:06',NULL,NULL),(40824,27131,'TE','5137025754',0,'2014-03-03 21:30:40',NULL,NULL),(42054,27947,'EM','MADMAYHA1111@YAHOO.COM',0,'2014-03-06 21:00:36',NULL,NULL),(7813,5102,'TE','8177152490',0,'2013-12-25 23:01:27',NULL,NULL),(30106,19503,'AP','3306972909',0,'2014-01-23 03:02:11',NULL,NULL),(29884,19339,'TE','4695856631',1,'2014-01-22 03:22:20',NULL,NULL),(28668,18490,'TE','3306992408',0,'2014-01-16 08:46:25',NULL,NULL),(28348,18265,'EM','nonisuli@gmail.com',0,'2014-01-16 08:44:39',NULL,NULL),(13757,8966,'TE','7405375312',0,'2013-12-26 04:03:58',NULL,NULL),(26009,16755,'AP','8322175101',0,'2014-01-08 18:24:56',NULL,NULL),(5109,3276,'TE','5132254569',0,'2013-12-25 21:15:07',NULL,NULL),(38475,25426,'AP','6142709931',0,'2014-02-25 21:31:12',NULL,NULL),(39269,25981,'TE','9376674134',0,'2014-02-26 21:01:51',NULL,NULL),(40741,27073,'AP','3304214991',0,'2014-03-03 21:30:07',NULL,NULL),(1674,1028,'TE','8327583674',0,'2013-12-25 18:15:27',NULL,NULL),(25033,16132,'AP','3303889821',0,'2014-01-04 02:05:44',NULL,NULL),(32725,21406,'EM','joefink714@yahoo.com',0,'2014-02-04 21:01:06',NULL,NULL),(23803,15353,'TE','5133005243',1,'2014-01-02 04:24:37',NULL,NULL),(30582,19842,'TE','5042298045',0,'2014-01-24 21:00:26',NULL,NULL),(11522,7498,'TE','3309321036',0,'2013-12-26 02:31:46',NULL,NULL),(10639,6919,'TE','6144040315',0,'2013-12-26 01:46:10',NULL,NULL),(5593,3578,'TE','9374024292',0,'2013-12-25 21:22:42',NULL,NULL),(20197,13013,'AP','9373608898',0,'2013-12-26 12:49:50',NULL,NULL),(39541,26159,'EM','fletcherj66@gmail.com',0,'2014-02-28 06:30:32',NULL,NULL),(42245,28061,'TE','2604186993',0,'2014-03-06 21:01:44',NULL,NULL),(25169,16226,'EM','AMYARNETT67@GMAIL.COM',0,'2014-01-05 00:01:57',NULL,NULL),(33506,21960,'TE','7406546654',0,'2014-02-07 19:00:25',NULL,NULL),(32335,21122,'TE','9032177865',0,'2014-02-03 21:00:13',NULL,NULL),(29986,19413,'AP','4194181023',1,'2014-01-22 03:22:58',NULL,NULL),(25039,16137,'EM','Bdon888@yahoo.com',0,'2014-01-04 02:05:52',NULL,NULL),(2324,1417,'AP','9706313748',0,'2013-12-25 18:47:08',NULL,NULL),(14974,9796,'TE','9155009906',0,'2013-12-26 05:01:07',NULL,NULL),(8253,5398,'TE','4193752881',0,'2013-12-25 23:08:52',NULL,NULL),(4702,3008,'TE','3309968610',0,'2013-12-25 20:17:51',NULL,NULL),(37236,24504,'AP','8322731147',0,'2014-02-20 03:50:23',NULL,NULL),(40426,26836,'EM','mechellewatts13@gmail.com',0,'2014-03-01 21:00:43',NULL,NULL),(41923,27873,'AP','6013346111',0,'2014-03-05 21:32:27',NULL,NULL),(43908,29131,'TE','9379253641',0,'2014-03-10 21:02:37',NULL,NULL),(11364,7403,'TE','3144829228',0,'2013-12-26 02:16:28',NULL,NULL),(8080,5289,'EM','beckimeers@yahoo.com',0,'2013-12-25 23:05:59',NULL,NULL),(30776,20007,'AP','3309621952',0,'2014-01-26 19:00:07',NULL,NULL),(30637,19881,'EM','DEBBIEJAMISON56@GMAIL.COM',0,'2014-01-24 21:00:47',NULL,NULL),(7020,4584,'EM','CHAMER1026@GMAIL.COM',0,'2013-12-25 22:05:18',NULL,NULL),(26271,16909,'EM','Pmessac@gmail.com',0,'2014-01-13 02:19:37',NULL,NULL),(3992,2537,'AP','5134600189',0,'2013-12-25 19:36:56',NULL,NULL),(34501,22632,'AP','9362005361',0,'2014-02-11 21:00:18',NULL,NULL),(35022,22997,'AP','2162784523',0,'2014-02-12 21:30:17',NULL,NULL),(37308,24547,'EM','cjm3378@att.net',0,'2014-02-20 04:04:02',NULL,NULL),(40209,26669,'EM','justinrendell@yahoo.com',0,'2014-02-28 21:31:17',NULL,NULL),(2378,1444,'EM','BHARPER2@CINCI.RR.COM',0,'2013-12-25 18:47:56',NULL,NULL),(33789,22180,'AP','5139178334',0,'2014-02-08 19:30:11',NULL,NULL),(25686,16560,'TE','3373306290',1,'2014-01-07 10:23:01',NULL,NULL),(29943,19378,'TE','6013412768',1,'2014-01-22 03:22:40',NULL,NULL),(29634,19146,'EM','wittylauri@earthlink.net',0,'2014-01-21 08:45:32',NULL,NULL),(25156,16217,'TE','5137294840',0,'2014-01-05 00:01:41',NULL,NULL),(24989,16106,'TE','6018982050',0,'2014-01-04 02:04:55',NULL,NULL),(22426,14461,'TE','3306665322',0,'2013-12-28 03:32:47',NULL,NULL),(2910,1785,'AP','4409410530',0,'2013-12-25 18:56:26',NULL,NULL),(24732,15955,'TE','4405482930',0,'2014-01-04 02:00:13',NULL,NULL),(20787,13358,'TE','5133078300',0,'2013-12-26 12:59:24',NULL,NULL),(38308,25300,'TE','5137450334',0,'2014-02-25 21:00:28',NULL,NULL),(23942,15449,'TE','9405073176',1,'2014-01-02 04:28:18',NULL,NULL),(33688,22096,'EM','myzoomzoom6@yahoo.com',0,'2014-02-08 19:00:27',NULL,NULL),(3634,2299,'EM','Anmaghiar@gmail.com',0,'2013-12-25 19:30:57',NULL,NULL),(6399,4128,'TE','4403154427',0,'2013-12-25 21:48:20',NULL,NULL),(38547,25471,'AP','8303859575',0,'2014-02-25 21:31:37',NULL,NULL),(1341,819,'TE','3307156630',0,'2013-12-25 18:06:02',NULL,NULL),(33267,21784,'TE','6149895348',0,'2014-02-06 21:00:40',NULL,NULL),(32756,21429,'AP','2144634160',0,'2014-02-04 21:01:17',NULL,NULL),(24837,16019,'TE','3184801352',0,'2014-01-04 02:02:07',NULL,NULL),(9892,6471,'TE','4404298559',0,'2013-12-26 00:50:08',NULL,NULL),(8692,5705,'AP','4193484381',0,'2013-12-25 23:33:03',NULL,NULL),(30201,19564,'AP','3187792546',0,'2014-01-23 03:02:34',NULL,NULL),(6663,4325,'TE','9375483193',0,'2013-12-25 21:52:52',NULL,NULL),(11363,7401,'TE','4196922596',0,'2013-12-26 02:16:26',NULL,NULL),(3395,2134,'TE','7408595097',0,'2013-12-25 19:18:03',NULL,NULL),(5041,3236,'TE','2162805783',0,'2013-12-25 20:46:11',NULL,NULL),(34718,22764,'TE','3308065227',0,'2014-02-11 21:01:34',NULL,NULL),(34994,22975,'AP','6149490064',0,'2014-02-12 21:30:05',NULL,NULL),(36771,24210,'EM','eduardo197035@yahoo.com',0,'2014-02-16 19:00:23',NULL,NULL),(43743,29038,'TE','5132052432',0,'2014-03-10 21:01:40',NULL,NULL),(2574,1570,'AP','4692798892',0,'2013-12-25 18:51:11',NULL,NULL),(34593,22681,'EM','derekplate@gmail.com',0,'2014-02-11 21:00:48',NULL,NULL),(33927,22266,'AP','4322716877',0,'2014-02-10 11:00:11',NULL,NULL),(25453,16413,'AP','3619356615',0,'2014-01-07 04:04:17',NULL,NULL),(31868,20803,'AP','9564668417',0,'2014-01-31 21:00:23',NULL,NULL),(31323,20411,'EM','arrivingflame616@gmail.com',0,'2014-01-29 21:00:25',NULL,NULL),(24110,15563,'EM','bockatie@gmail.com',1,'2014-01-02 04:31:40',NULL,NULL),(6786,4401,'TE','5133794901',0,'2013-12-25 22:01:10',NULL,NULL),(10681,6941,'TE','6145303700',0,'2013-12-26 01:46:48',NULL,NULL),(20998,13512,'AP','5042893733',0,'2013-12-26 13:02:56',NULL,NULL),(36932,24321,'AP','9035212890',0,'2014-02-18 22:00:08',NULL,NULL),(37310,24552,'TE','3308398021',0,'2014-02-20 04:04:32',NULL,NULL),(40496,26876,'TE','4192220674',0,'2014-03-01 21:01:06',NULL,NULL),(8138,5326,'EM','SPENCEJ4@ME.COM',0,'2013-12-25 23:06:59',NULL,NULL),(5329,3416,'TE','5046063499',0,'2013-12-25 21:18:30',NULL,NULL),(380,231,'EM','reiser415@gmail.com',0,'2013-12-25 17:21:05',NULL,NULL),(41517,27602,'EM','mtuuri@aol.com',0,'2014-03-05 21:00:24',NULL,NULL),(41655,27690,'EM','MZMONROE77@GMAIL.COM',0,'2014-03-05 21:30:43',NULL,NULL),(9121,5974,'EM','beweaver@fuse.net',0,'2013-12-25 23:51:45',NULL,NULL),(34330,22522,'EM','mickeyd4266@gmail.com',0,'2014-02-10 21:31:26',NULL,NULL),(25471,16425,'TE','9375272725',0,'2014-01-07 04:04:37',NULL,NULL),(31779,20744,'TE','4196970517',0,'2014-01-30 21:01:26',NULL,NULL),(31059,20207,'TE','2282977310',0,'2014-01-27 21:01:35',NULL,NULL),(24778,15983,'EM','moninae4@hotmail.com',0,'2014-01-04 02:01:02',NULL,NULL),(35895,23614,'TE','4197854725',0,'2014-02-13 22:03:14',NULL,NULL),(41037,27265,'TE','2255728391',0,'2014-03-04 21:00:12',NULL,NULL),(12379,8107,'EM','MaryC5902@aol.com',0,'2013-12-26 03:11:00',NULL,NULL),(2846,1729,'TE','4192020645',0,'2013-12-25 18:55:22',NULL,NULL),(33639,22058,'TE','4322887695',0,'2014-02-08 19:00:09',NULL,NULL),(26718,17185,'EM','kieuquach24@yahoo.com',0,'2014-01-13 02:22:15',NULL,NULL),(38773,25634,'TE','2076515860',0,'2014-02-26 08:30:25',NULL,NULL),(38844,25678,'AP','4192301935',0,'2014-02-26 08:30:56',NULL,NULL),(24634,15885,'AP','3375505086',0,'2014-01-03 02:05:32',NULL,NULL),(2548,1558,'TE','6019462987',0,'2013-12-25 18:50:49',NULL,NULL),(8418,5543,'TE','3309689050',0,'2013-12-25 23:15:53',NULL,NULL),(33587,22018,'AP','6015775243',0,'2014-02-07 19:00:57',NULL,NULL),(32321,21114,'AP','9039106481',0,'2014-02-03 21:00:09',NULL,NULL),(4532,2881,'AP','8172260067',0,'2013-12-25 20:02:14',NULL,NULL),(28493,18359,'TE','5132817741',0,'2014-01-16 08:45:26',NULL,NULL),(6509,4207,'AP','2143851624',0,'2013-12-25 21:50:05',NULL,NULL),(22109,14241,'TE','6013766872',0,'2013-12-27 02:05:15',NULL,NULL),(5861,3762,'TE','3302834630',0,'2013-12-25 21:33:26',NULL,NULL),(11635,7568,'TE','4194198033',0,'2013-12-26 02:33:41',NULL,NULL),(12361,8091,'TE','5133700621',0,'2013-12-26 03:10:42',NULL,NULL),(38090,25143,'TE','7135385523',0,'2014-02-21 22:00:12',NULL,NULL),(43370,28805,'TE','3304651524',0,'2014-03-09 21:00:51',NULL,NULL),(20689,13301,'TE','2818577621',0,'2013-12-26 12:57:47',NULL,NULL),(20850,13405,'TE','5133072971',0,'2013-12-26 13:00:26',NULL,NULL),(29792,19268,'TE','4192445180',0,'2014-01-21 08:46:53',NULL,NULL),(26281,16915,'AP','7404075342',0,'2014-01-13 02:19:40',NULL,NULL),(20887,13431,'TE','4408880526',0,'2013-12-26 13:01:02',NULL,NULL),(5231,3362,'AP','7023274576',0,'2013-12-25 21:17:01',NULL,NULL),(39026,25807,'AP','3305504500',0,'2014-02-26 21:00:19',NULL,NULL),(9310,6096,'EM','ELSENEG@YAHOO.COM',0,'2013-12-26 00:15:04',NULL,NULL),(14874,9736,'TE','8327442761',0,'2013-12-26 04:45:48',NULL,NULL),(26512,17059,'TE','9153091494',0,'2014-01-13 02:21:10',NULL,NULL),(26277,16911,'EM','wjones2@oh.rr.com',0,'2014-01-13 02:19:38',NULL,NULL),(3189,2005,'TE','5135750352',0,'2013-12-25 19:02:19',NULL,NULL),(5700,3659,'EM','will_brandstetter04@yahoo.com',0,'2013-12-25 21:30:51',NULL,NULL),(23238,14973,'TE','2149069724',0,'2014-01-01 12:00:54',NULL,NULL),(24223,15650,'AP','5044270835',1,'2014-01-02 04:34:05',NULL,NULL),(41716,27739,'TE','9568671608',0,'2014-03-05 21:31:08',NULL,NULL),(43956,29158,'AP','9372446326',0,'2014-03-10 21:02:53',NULL,NULL),(27453,17686,'TE','9857788359',0,'2014-01-14 01:32:56',NULL,NULL),(34324,22520,'EM','cherokeeman70@gmail.com',0,'2014-02-10 21:31:25',NULL,NULL),(34456,22608,'TE','4199295252',0,'2014-02-10 21:32:19',NULL,NULL),(35841,23567,'AP','6628166639',0,'2014-02-13 22:02:49',NULL,NULL),(11980,7805,'AP','2546690291',0,'2013-12-26 03:03:47',NULL,NULL),(1152,708,'TE','9852498103',0,'2013-12-25 18:03:06',NULL,NULL),(29158,18838,'TE','3306281735',0,'2014-01-17 03:36:12',NULL,NULL),(5642,3617,'TE','4193034752',0,'2013-12-25 21:23:37',NULL,NULL),(24396,15752,'TE','9565872437',0,'2014-01-03 02:01:12',NULL,NULL),(2545,1557,'TE','6624175950',0,'2013-12-25 18:50:46',NULL,NULL),(43955,29158,'TE','9372446326',0,'2014-03-10 21:02:53',NULL,NULL),(13631,8888,'AP','5249794229',0,'2013-12-26 04:01:57',NULL,NULL),(30244,19591,'TE','6014106332',0,'2014-01-23 03:02:44',NULL,NULL),(29515,19080,'EM','TBERRYII@HOTMAIL.COM',0,'2014-01-21 08:44:26',NULL,NULL),(13565,8844,'AP','9154911801',0,'2013-12-26 04:00:51',NULL,NULL),(11246,7320,'TE','6015911777',0,'2013-12-26 02:03:37',NULL,NULL),(27401,17644,'EM','chiuch2@aol.com',0,'2014-01-14 01:32:38',NULL,NULL),(23981,15482,'AP','5144487637',1,'2014-01-02 04:29:11',NULL,NULL),(39706,26258,'TE','9158496242',0,'2014-02-28 06:31:11',NULL,NULL),(41134,27321,'AP','9369339897',0,'2014-03-04 21:00:46',NULL,NULL),(41599,27658,'EM','wilson@nclsales.com',0,'2014-03-05 21:30:25',NULL,NULL),(42596,28340,'TE','7135041888',0,'2014-03-07 21:30:16',NULL,NULL),(9744,6373,'TE','2164086017',0,'2013-12-26 00:47:43',NULL,NULL),(32739,21418,'TE','4192423522',0,'2014-02-04 21:01:12',NULL,NULL),(30968,20143,'AP','9378302735',0,'2014-01-27 21:00:59',NULL,NULL),(29631,19145,'AP','2147183225',0,'2014-01-21 08:45:31',NULL,NULL),(21306,13687,'AP','3308071445',0,'2013-12-26 13:08:22',NULL,NULL),(22070,14213,'AP','7134783327',0,'2013-12-27 02:04:34',NULL,NULL),(13799,8996,'TE','5137278210',0,'2013-12-26 04:04:43',NULL,NULL),(12075,7886,'AP','4199666293',0,'2013-12-26 03:05:31',NULL,NULL),(41080,27288,'AP','2542661941',0,'2014-03-04 21:00:27',NULL,NULL),(41521,27605,'AP','2162729683',0,'2014-03-05 21:00:26',NULL,NULL),(42353,28129,'EM','smwwlk@sbcglobal.net',0,'2014-03-06 21:02:24',NULL,NULL),(43649,28971,'TE','5049314344',0,'2014-03-10 21:01:03',NULL,NULL),(43741,29037,'AP','4405394883',0,'2014-03-10 21:01:39',NULL,NULL),(8307,5444,'TE','2259073323',0,'2013-12-25 23:10:00',NULL,NULL),(444,275,'AP','8309925183',0,'2013-12-25 17:30:09',NULL,NULL),(26091,16803,'AP','4092891023',0,'2014-01-13 02:18:12',NULL,NULL),(23350,15042,'EM','Gail.Hurst10@yahoo.com',0,'2014-01-01 12:03:00',NULL,NULL),(13823,9013,'TE','3306775373',0,'2013-12-26 04:05:08',NULL,NULL),(22317,14387,'TE','5132135677',0,'2013-12-28 03:30:55',NULL,NULL),(12227,7994,'TE','3308193470',0,'2013-12-26 03:08:12',NULL,NULL),(5118,3279,'TE','4806210880',0,'2013-12-25 21:15:13',NULL,NULL),(7294,4750,'AP','9152522924',0,'2013-12-25 22:15:11',NULL,NULL),(3154,1970,'TE','8176816774',0,'2013-12-25 19:01:27',NULL,NULL),(35457,23314,'AP','4198108125',0,'2014-02-13 22:00:22',NULL,NULL),(37654,24827,'AP','9372189001',0,'2014-02-20 04:51:25',NULL,NULL),(20331,13098,'EM','sunshine58m@aol.com',0,'2013-12-26 12:52:06',NULL,NULL),(29668,19172,'EM','christian.mixon@gmail.com',0,'2014-01-21 08:46:03',NULL,NULL),(39421,26068,'EM','eelizabeth84@gmail.com',0,'2014-02-26 21:02:43',NULL,NULL),(39715,26267,'AP','9799002847',0,'2014-02-28 06:31:14',NULL,NULL),(40161,26636,'TE','3618885077',0,'2014-02-28 21:31:00',NULL,NULL),(42360,28136,'TE','3306710258',0,'2014-03-06 21:02:27',NULL,NULL),(9625,6300,'TE','4193414015',0,'2013-12-26 00:45:53',NULL,NULL),(21551,13858,'TE','3476334014',0,'2013-12-26 13:12:45',NULL,NULL),(32680,21372,'AP','9092616284',0,'2014-02-04 21:00:49',NULL,NULL),(20492,13195,'TE','8323816131',0,'2013-12-26 12:54:47',NULL,NULL),(4378,2791,'EM','lauraharolds@ymail.com',0,'2013-12-25 19:50:08',NULL,NULL),(8350,5483,'TE','4199254634',0,'2013-12-25 23:10:53',NULL,NULL),(20478,13190,'AP','9726394400',0,'2013-12-26 12:54:36',NULL,NULL),(8161,5340,'EM','terrill.angie@gmail.com',0,'2013-12-25 23:07:20',NULL,NULL),(2553,1560,'TE','6012500198',0,'2013-12-25 18:50:53',NULL,NULL),(43011,28601,'EM','djkeith60@gmail.com',0,'2014-03-08 21:30:09',NULL,NULL),(4400,2803,'EM','robertcaudill18@yahoo.com',0,'2013-12-25 19:50:28',NULL,NULL),(1528,940,'TE','5133733544',0,'2013-12-25 18:09:19',NULL,NULL),(32404,21173,'EM','coreylcaputo@gmail.com',0,'2014-02-03 21:00:39',NULL,NULL),(3046,1895,'EM','judybender4444@yahoo.com',0,'2013-12-25 18:58:59',NULL,NULL),(22752,14673,'TE','6012257517',1,'2013-12-29 11:08:19',NULL,NULL),(36120,23774,'TE','7695247984',0,'2014-02-14 21:31:15',NULL,NULL),(38093,25145,'TE','9729891283',0,'2014-02-21 22:00:13',NULL,NULL),(42167,28012,'TE','3306375968',0,'2014-03-06 21:01:15',NULL,NULL),(21977,14157,'AP','9852900905',0,'2013-12-27 02:03:04',NULL,NULL),(25050,16146,'EM','wallbrit1@yahoo.com',0,'2014-01-04 02:06:09',NULL,NULL),(6678,4337,'TE','9377253352',0,'2013-12-25 21:53:10',NULL,NULL),(1669,1025,'TE','3303291872',0,'2013-12-25 18:15:22',NULL,NULL),(5805,3728,'TE','5128500592',0,'2013-12-25 21:32:31',NULL,NULL),(9067,5943,'EM','bossierbud@gmail.com',0,'2013-12-25 23:50:54',NULL,NULL),(7081,4624,'TE','5043614949',0,'2013-12-25 22:06:20',NULL,NULL),(20621,13266,'TE','2546982422',0,'2013-12-26 12:56:47',NULL,NULL),(21525,13838,'TE','3308054373',0,'2013-12-26 13:12:15',NULL,NULL),(32996,21611,'TE','3307947240',0,'2014-02-05 21:30:34',NULL,NULL),(32409,21178,'TE','4193038068',0,'2014-02-03 21:00:41',NULL,NULL),(6957,4536,'TE','9366150921',0,'2013-12-25 22:04:11',NULL,NULL),(3974,2521,'TE','3302857596',0,'2013-12-25 19:36:36',NULL,NULL),(1709,1049,'EM','larrydang2003@yahoo.com',0,'2013-12-25 18:15:59',NULL,NULL),(24682,15919,'TE','4192507788',0,'2014-01-03 02:06:35',NULL,NULL),(25087,16174,'AP','2253615221',0,'2014-01-05 00:00:19',NULL,NULL),(34256,22469,'EM','winterwilliam60@yahoo.com',0,'2014-02-10 21:30:58',NULL,NULL),(38041,25101,'TE','2547231669',0,'2014-02-21 21:30:10',NULL,NULL),(42479,28242,'TE','5134804380',0,'2014-03-07 21:00:10',NULL,NULL),(10766,6998,'EM','twwstowell@yahoo.com',0,'2013-12-26 01:48:12',NULL,NULL),(29352,18965,'EM','lr@itsheavenllc.com',0,'2014-01-20 08:05:58',NULL,NULL),(29164,18841,'EM','mlekoal@neo.rr.com',0,'2014-01-17 03:36:13',NULL,NULL),(9523,6232,'AP','9036174523',0,'2013-12-26 00:31:29',NULL,NULL),(26493,17049,'AP','7403414041',0,'2014-01-13 02:20:56',NULL,NULL),(14921,9764,'TE','2053560173',0,'2013-12-26 05:00:16',NULL,NULL),(26013,16757,'AP','4195180816',0,'2014-01-08 18:24:57',NULL,NULL),(23852,15389,'TE','4402123098',1,'2014-01-02 04:25:41',NULL,NULL),(34804,22831,'TE','3303211285',0,'2014-02-11 21:02:07',NULL,NULL),(35511,23351,'EM','mariesmith@smithshouseofcarpet.com',0,'2014-02-13 22:00:42',NULL,NULL),(10758,6994,'EM','Cedral2007@yahoo.com',0,'2013-12-26 01:48:05',NULL,NULL),(32309,21108,'TE','3188161346',0,'2014-02-03 21:00:05',NULL,NULL),(30028,19448,'AP','2165262381',0,'2014-01-23 03:01:52',NULL,NULL),(22002,14171,'AP','7145889943',0,'2013-12-27 02:03:28',NULL,NULL),(9997,6541,'AP','8173004173',0,'2013-12-26 00:51:56',NULL,NULL),(1328,811,'AP','7405035545',0,'2013-12-25 18:05:50',NULL,NULL),(1500,922,'AP','2165704303',0,'2013-12-25 18:08:54',NULL,NULL),(13962,9101,'AP','5133242999',0,'2013-12-26 04:07:24',NULL,NULL),(5324,3413,'TE','2253280848',0,'2013-12-25 21:18:26',NULL,NULL),(40260,26710,'TE','5137534424',0,'2014-02-28 21:31:37',NULL,NULL),(20571,13237,'TE','9032363768',0,'2013-12-26 12:55:58',NULL,NULL),(33952,22278,'TE','5126266517',0,'2014-02-10 11:00:19',NULL,NULL),(28333,18259,'TE','9154122915',0,'2014-01-16 08:44:35',NULL,NULL),(2549,1558,'AP','6019462987',0,'2013-12-25 18:50:49',NULL,NULL),(25277,16297,'AP','3182298862',0,'2014-01-07 04:01:03',NULL,NULL),(7624,4967,'AP','9566933160',0,'2013-12-25 22:46:20',NULL,NULL),(7850,5124,'TE','9032929522',0,'2013-12-25 23:02:02',NULL,NULL),(34408,22571,'TE','3123715272',0,'2014-02-10 21:31:57',NULL,NULL),(34955,22947,'EM','ashleyireneking@gmail.com',0,'2014-02-11 21:30:25',NULL,NULL),(36810,24236,'AP','8593070089',0,'2014-02-16 19:00:37',NULL,NULL),(41693,27725,'TE','9157576626',0,'2014-03-05 21:31:00',NULL,NULL),(42822,28480,'TE','7409175237',0,'2014-03-07 21:31:35',NULL,NULL),(42891,28525,'TE','4194472920',0,'2014-03-07 21:32:04',NULL,NULL),(2819,1704,'AP','5134707751',0,'2013-12-25 18:54:50',NULL,NULL),(30111,19505,'AP','2145806474',0,'2014-01-23 03:02:12',NULL,NULL),(29917,19360,'EM','sbenc2020@gmail.com',1,'2014-01-22 03:22:30',NULL,NULL),(8041,5262,'TE','3306884345',0,'2013-12-25 23:05:23',NULL,NULL),(38760,25623,'AP','9152417843',0,'2014-02-26 08:30:19',NULL,NULL),(39617,26203,'AP','3303274736',0,'2014-02-28 06:30:50',NULL,NULL),(42150,28003,'TE','3302174133',0,'2014-03-06 21:01:10',NULL,NULL),(1383,845,'TE','2259556328',0,'2013-12-25 18:06:44',NULL,NULL),(11463,7457,'TE','5133833501',0,'2013-12-26 02:30:48',NULL,NULL),(32089,20957,'TE','2545419663',0,'2014-02-01 19:00:07',NULL,NULL),(25138,16205,'AP','4074564332',0,'2014-01-05 00:01:16',NULL,NULL),(35871,23590,'AP','3306064277',0,'2014-02-13 22:03:01',NULL,NULL),(35967,23665,'AP','8324210671',0,'2014-02-14 21:30:21',NULL,NULL),(40936,27200,'TE','2144052741',0,'2014-03-03 21:31:22',NULL,NULL),(42171,28014,'TE','9374791630',0,'2014-03-06 21:01:17',NULL,NULL),(42268,28072,'AP','5132187640',0,'2014-03-06 21:01:51',NULL,NULL),(24125,15574,'TE','3304165910',1,'2014-01-02 04:31:59',NULL,NULL),(7818,5105,'TE','8324526755',0,'2013-12-25 23:01:32',NULL,NULL),(7075,4622,'TE','7708800896',0,'2013-12-25 22:06:16',NULL,NULL),(10936,7110,'AP','3373663434',0,'2013-12-26 01:51:01',NULL,NULL),(10214,6674,'AP','9857050874',0,'2013-12-26 01:01:13',NULL,NULL),(34495,22629,'AP','8322796660',0,'2014-02-11 21:00:16',NULL,NULL),(40535,26903,'EM','CAROLINGLEE@GMAIL.COM',0,'2014-03-03 01:00:08',NULL,NULL),(41738,27754,'AP','2257887262',0,'2014-03-05 21:31:17',NULL,NULL),(41808,27794,'TE','6014208373',0,'2014-03-05 21:31:42',NULL,NULL),(42119,27981,'AP','3186692374',0,'2014-03-06 21:00:57',NULL,NULL),(2006,1241,'AP','5046166067',0,'2013-12-25 18:20:57',NULL,NULL),(12254,8012,'TE','5136331088',0,'2013-12-26 03:08:41',NULL,NULL),(30708,19950,'TE','3184872003',0,'2014-01-25 19:00:03',NULL,NULL),(12302,8046,'AP','3306080398',0,'2013-12-26 03:09:32',NULL,NULL),(8429,5547,'EM','cwalterk@yahoo.com',0,'2013-12-25 23:16:01',NULL,NULL),(21491,13811,'EM','john@concoursdates.com',0,'2013-12-26 13:11:36',NULL,NULL),(21768,14022,'AP','9374089201',0,'2013-12-26 13:16:41',NULL,NULL),(6703,4359,'AP','4194103833',0,'2013-12-25 21:53:41',NULL,NULL),(7181,4680,'EM','bret859@bellsouth.net',0,'2013-12-25 22:07:53',NULL,NULL),(38707,25582,'AP','8329695416',0,'2014-02-26 08:00:37',NULL,NULL),(10738,6981,'AP','4198100264',0,'2013-12-26 01:47:44',NULL,NULL),(33127,21699,'AP','3307779796',0,'2014-02-05 21:31:10',NULL,NULL),(7800,5090,'TE','3616875409',0,'2013-12-25 23:01:12',NULL,NULL),(30413,19711,'AP','7135029809',0,'2014-01-23 21:00:53',NULL,NULL),(7760,5065,'TE','5128220856',0,'2013-12-25 23:00:34',NULL,NULL),(10630,6916,'TE','9859665970',0,'2013-12-26 01:46:03',NULL,NULL),(3839,2442,'AP','3302241607',0,'2013-12-25 19:34:28',NULL,NULL),(1127,691,'EM','cbyers49@wildblue.net',0,'2013-12-25 18:02:39',NULL,NULL),(36722,24180,'EM','akrishen@sbcglobal.net',0,'2014-02-16 19:00:07',NULL,NULL),(37079,24413,'EM','mizannacala@yahoo.com',0,'2014-02-18 22:01:03',NULL,NULL),(38816,25662,'AP','3305694127',0,'2014-02-26 08:30:46',NULL,NULL),(22516,14517,'EM','urquietaautos@att.net',0,'2013-12-28 03:34:13',NULL,NULL),(795,496,'TE','4437165788',0,'2013-12-25 17:48:33',NULL,NULL),(11887,7735,'AP','4198891268',0,'2013-12-26 03:02:08',NULL,NULL),(20341,13105,'AP','6143122030',0,'2013-12-26 12:52:17',NULL,NULL),(35629,23426,'EM','shahalatippett@gmail.com',0,'2014-02-13 22:01:26',NULL,NULL),(35847,23570,'AP','4193504300',0,'2014-02-13 22:02:51',NULL,NULL),(37980,25057,'TE','9377766874',0,'2014-02-20 22:01:21',NULL,NULL),(39130,25881,'EM','San_solis@att.net',0,'2014-02-26 21:00:58',NULL,NULL),(41617,27667,'EM','Ashleyj1105@gmail.com',0,'2014-03-05 21:30:31',NULL,NULL),(43989,29183,'TE','7404501592',0,'2014-03-10 21:29:59',NULL,NULL),(4173,2665,'AP','5136738802',0,'2013-12-25 19:46:56',NULL,NULL),(31859,20799,'TE','3612272837',0,'2014-01-31 21:00:20',NULL,NULL),(29768,19249,'TE','6624030381',0,'2014-01-21 08:46:42',NULL,NULL),(26642,17140,'EM','baynebyrd3@aol.com',0,'2014-01-13 02:21:52',NULL,NULL),(36106,23758,'TE','5132371316',0,'2014-02-14 21:31:09',NULL,NULL),(41268,27424,'TE','5042920371',0,'2014-03-04 21:01:41',NULL,NULL),(20557,13232,'TE','5126996768',0,'2013-12-26 12:55:47',NULL,NULL),(9393,6147,'AP','6145979356',0,'2013-12-26 00:16:26',NULL,NULL),(7983,5207,'TE','6148057608',0,'2013-12-25 23:04:13',NULL,NULL),(32859,21505,'TE','3308582216',0,'2014-02-04 21:01:54',NULL,NULL),(31385,20456,'AP','6146495742',0,'2014-01-29 21:00:48',NULL,NULL),(27056,17399,'EM','carlk@findlay.edu',0,'2014-01-13 03:00:15',NULL,NULL),(2744,1663,'EM','cbward@aol.com',0,'2013-12-25 18:53:42',NULL,NULL),(9990,6536,'EM','hjk8743@gmail.com',0,'2013-12-26 00:51:49',NULL,NULL),(6572,4241,'EM','whitneydmw@yahoo.com',0,'2013-12-25 21:51:03',NULL,NULL),(34791,22821,'TE','3307948273',0,'2014-02-11 21:02:02',NULL,NULL),(22698,14640,'EM','young.de44@yahoo.com',1,'2013-12-29 11:07:25',NULL,NULL),(34147,22389,'AP','3304663343',0,'2014-02-10 21:30:14',NULL,NULL),(11190,7276,'EM','rarnwine@hotmail.com',0,'2013-12-26 02:02:34',NULL,NULL),(20295,13082,'TE','3307258735',0,'2013-12-26 12:51:36',NULL,NULL),(32623,21329,'EM','kmusleve@gmail.com',0,'2014-02-04 21:00:27',NULL,NULL),(2649,1610,'TE','2146065110',0,'2013-12-25 18:52:17',NULL,NULL),(20543,13224,'AP','2542457149',0,'2013-12-26 12:55:33',NULL,NULL),(22574,14558,'TE','3302593040',0,'2013-12-28 03:35:13',NULL,NULL),(4499,2862,'TE','9376884545',0,'2013-12-25 20:01:39',NULL,NULL),(35754,23514,'AP','6015732246',0,'2014-02-13 22:02:16',NULL,NULL),(38229,25237,'EM','barloop23@yahoo.com',0,'2014-02-21 22:01:05',NULL,NULL),(10243,6696,'EM','cwilliams0708@gmail.com',0,'2013-12-26 01:01:45',NULL,NULL),(33483,21942,'AP','4092391262',0,'2014-02-07 19:00:16',NULL,NULL),(33421,21895,'AP','3306140621',0,'2014-02-06 21:01:42',NULL,NULL),(32537,21273,'AP','3306412700',0,'2014-02-03 21:01:32',NULL,NULL),(1506,926,'TE','4404947115',0,'2013-12-25 18:09:00',NULL,NULL),(11828,7696,'EM','risden57@yahoo.com',0,'2013-12-26 03:01:09',NULL,NULL),(29874,19329,'TE','9157644477',1,'2014-01-22 03:22:15',NULL,NULL),(21956,14143,'TE','3187330188',0,'2013-12-27 02:02:42',NULL,NULL),(30306,19634,'TE','4192731345',0,'2014-01-23 21:00:10',NULL,NULL),(10166,6644,'TE','8309978809',0,'2013-12-26 01:00:25',NULL,NULL),(11271,7348,'AP','8188078202',0,'2013-12-26 02:04:10',NULL,NULL),(9383,6141,'EM','Wyndfire@hotmail.com',0,'2013-12-26 00:16:17',NULL,NULL),(21296,13682,'EM','flinda@aol.com',0,'2013-12-26 13:08:13',NULL,NULL),(11398,7419,'TE','3302085182',0,'2013-12-26 02:16:58',NULL,NULL),(2347,1427,'AP','3375341716',0,'2013-12-25 18:47:27',NULL,NULL),(38387,25360,'AP','5133072282',0,'2014-02-25 21:30:36',NULL,NULL),(39740,26283,'TE','7137254618',0,'2014-02-28 06:31:21',NULL,NULL),(40469,26862,'EM','eve_917_am@yahoo.com',0,'2014-03-01 21:00:57',NULL,NULL),(43478,28873,'TE','9033682282',0,'2014-03-10 21:00:04',NULL,NULL),(4086,2606,'TE','3304824758',0,'2013-12-25 19:45:28',NULL,NULL),(34928,22919,'AP','9377632914',0,'2014-02-11 21:02:53',NULL,NULL),(32965,21580,'AP','3308589095',0,'2014-02-05 21:30:25',NULL,NULL),(31216,20331,'TE','5138872794',0,'2014-01-28 21:01:01',NULL,NULL),(30995,20164,'TE','3306719773',0,'2014-01-27 21:01:11',NULL,NULL),(29702,19203,'EM','Karolsable@yahoo.com',0,'2014-01-21 08:46:18',NULL,NULL),(10429,6799,'TE','4195867351',0,'2013-12-26 01:17:20',NULL,NULL),(12268,8024,'EM','billmyers1950@yahoo.com',0,'2013-12-26 03:08:59',NULL,NULL),(11323,7376,'EM','CVCROSBY4@AOL.COM',0,'2013-12-26 02:15:49',NULL,NULL),(35248,23150,'AP','4403464172',0,'2014-02-12 21:31:41',NULL,NULL),(35759,23516,'AP','2282132073',0,'2014-02-13 22:02:17',NULL,NULL),(35790,23535,'TE','5049570306',0,'2014-02-13 22:02:29',NULL,NULL),(41394,27498,'AP','4199307781',0,'2014-03-04 21:02:27',NULL,NULL),(22626,14589,'TE','2166336614',0,'2013-12-28 03:36:06',NULL,NULL),(1991,1229,'AP','3308357358',0,'2013-12-25 18:20:39',NULL,NULL),(29520,19082,'AP','5135208049',0,'2014-01-21 08:44:27',NULL,NULL),(29409,19009,'EM','aleary1@cox.net',0,'2014-01-20 08:06:20',NULL,NULL),(22464,14486,'EM','JOSHUADHOLLY@GMAIL.COM',0,'2013-12-28 03:33:24',NULL,NULL),(27184,17503,'AP','4408659028',0,'2014-01-13 03:01:26',NULL,NULL),(24873,16039,'AP','4097818668',0,'2014-01-04 02:02:47',NULL,NULL),(24080,15545,'TE','9852471485',1,'2014-01-02 04:31:06',NULL,NULL),(10152,6635,'EM','douglaswilhelm@ymail.com',0,'2013-12-26 01:00:09',NULL,NULL),(28189,18169,'EM','debraroy824@gmail.com',0,'2014-01-15 02:07:57',NULL,NULL),(27130,17467,'TE','4403659543',0,'2014-01-13 03:01:06',NULL,NULL),(26883,17296,'AP','9032270952',0,'2014-01-13 02:23:36',NULL,NULL),(39160,25902,'AP','9568271728',0,'2014-02-26 21:01:09',NULL,NULL),(11784,7666,'EM','Jtells201@gmail.com',0,'2013-12-26 03:00:26',NULL,NULL),(35178,23105,'AP','5137676045',0,'2014-02-12 21:31:15',NULL,NULL),(34911,22908,'TE','4408453860',0,'2014-02-11 21:02:46',NULL,NULL),(31105,20252,'TE','9035177741',0,'2014-01-28 21:00:14',NULL,NULL),(31481,20515,'TE','8328848464',0,'2014-01-29 21:01:21',NULL,NULL),(28240,18210,'AP','5136809761',0,'2014-01-15 02:08:10',NULL,NULL),(20293,13081,'AP','4408970414',0,'2013-12-26 12:51:35',NULL,NULL),(14917,9759,'TE','4408870693',0,'2013-12-26 05:00:10',NULL,NULL),(3500,2187,'AP','6623921844',0,'2013-12-25 19:19:38',NULL,NULL),(24996,16111,'TE','2282062424',0,'2014-01-04 02:05:05',NULL,NULL),(26620,17126,'BN','4405212842',0,'2014-01-13 02:21:45',NULL,NULL),(27431,17667,'AP','5135038070',0,'2014-01-14 01:32:48',NULL,NULL),(35556,23381,'AP','5136075545',0,'2014-02-13 22:01:00',NULL,NULL),(41046,27269,'TE','3373392186',0,'2014-03-04 21:00:15',NULL,NULL),(10343,6743,'TE','3304721290',0,'2013-12-26 01:15:50',NULL,NULL),(33774,22165,'EM','rxpssr@gmail.com',0,'2014-02-08 19:01:00',NULL,NULL),(280,173,'AP','3303101357',0,'2013-12-25 17:19:28',NULL,NULL),(33176,21726,'AP','9797320940',0,'2014-02-06 21:00:07',NULL,NULL),(33167,21723,'TE','9034752006',0,'2014-02-06 21:00:04',NULL,NULL),(5084,3262,'EM','hwill0725@hotmail.com',0,'2013-12-25 20:46:56',NULL,NULL),(30598,19855,'AP','7402645337',0,'2014-01-24 21:00:33',NULL,NULL),(26910,17310,'EM','glk5964@yahoo.com',0,'2014-01-13 02:23:44',NULL,NULL),(27195,17512,'EM','rwmitchelljr@att.net',0,'2014-01-13 03:01:30',NULL,NULL),(37949,25040,'TE','4192961783',0,'2014-02-20 22:01:09',NULL,NULL),(38062,25120,'AP','7402527741',0,'2014-02-21 21:30:21',NULL,NULL),(176,105,'TE','9726807895',0,'2013-12-25 17:17:48',NULL,NULL),(22725,14655,'TE','9565996680',1,'2013-12-29 11:07:50',NULL,NULL),(32272,21082,'TE','9379197057',0,'2014-02-02 19:00:22',NULL,NULL),(30768,20000,'TE','2166958600',0,'2014-01-26 19:00:04',NULL,NULL),(20614,13257,'TE','2818401599',0,'2013-12-26 12:56:35',NULL,NULL),(28175,18160,'TE','9372146235',0,'2014-01-15 02:07:54',NULL,NULL),(34820,22838,'AP','3306082423',0,'2014-02-11 21:02:12',NULL,NULL),(37342,24586,'TE','2167121160',0,'2014-02-20 04:09:45',NULL,NULL),(38024,25082,'TE','4192170332',0,'2014-02-20 22:01:39',NULL,NULL),(38422,25388,'TE','3308199262',0,'2014-02-25 21:30:50',NULL,NULL),(40643,26977,'EM','jbales@columbus.rr.com',0,'2014-03-03 01:00:37',NULL,NULL),(41597,27658,'TE','9376542662',0,'2014-03-05 21:30:25',NULL,NULL),(41615,27667,'TE','6142608378',0,'2014-03-05 21:30:31',NULL,NULL),(10582,6886,'AP','3182680823',0,'2013-12-26 01:45:14',NULL,NULL),(32195,21030,'TE','2392293757',0,'2014-02-01 19:00:44',NULL,NULL),(992,612,'TE','4195234205',0,'2013-12-25 18:00:36',NULL,NULL),(27428,17666,'TE','5135038070',0,'2014-01-14 01:32:47',NULL,NULL),(27192,17511,'AP','3303736622',0,'2014-01-13 03:01:29',NULL,NULL),(2151,1325,'AP','2343128575',0,'2013-12-25 18:31:54',NULL,NULL),(11275,7349,'EM','gedwards971@yahoo.com',0,'2013-12-26 02:15:04',NULL,NULL),(7806,5094,'EM','TuckerB16939@gmail.com',0,'2013-12-25 23:01:18',NULL,NULL),(40044,26546,'AP','3307031525',0,'2014-02-28 21:30:11',NULL,NULL),(41635,27678,'TE','8302493273',0,'2014-03-05 21:30:37',NULL,NULL),(43468,28868,'TE','7864472228',0,'2014-03-10 21:00:01',NULL,NULL),(22563,14551,'TE','2168565611',0,'2013-12-28 03:35:03',NULL,NULL),(21961,14147,'AP','3183318962',0,'2013-12-27 02:02:48',NULL,NULL),(33350,21848,'TE','7403424739',0,'2014-02-06 21:01:14',NULL,NULL),(1530,941,'TE','4402631713',0,'2013-12-25 18:09:21',NULL,NULL),(1787,1108,'EM','tcdeter@gmail.com',0,'2013-12-25 18:17:27',NULL,NULL),(14134,9256,'EM','t.paty26@gmail.com',0,'2013-12-26 04:15:10',NULL,NULL),(12033,7849,'AP','3309798761',0,'2013-12-26 03:04:46',NULL,NULL),(25410,16391,'AP','9564632464',0,'2014-01-07 04:03:35',NULL,NULL),(23977,15479,'AP','6143156243',1,'2014-01-02 04:29:05',NULL,NULL),(37586,24761,'AP','9377257737',0,'2014-02-20 04:43:04',NULL,NULL),(350,217,'AP','5048106630',0,'2013-12-25 17:20:39',NULL,NULL),(20982,13505,'TE','5049059573',0,'2013-12-26 13:02:43',NULL,NULL),(11277,7351,'TE','9857927368',0,'2013-12-26 02:15:07',NULL,NULL),(3597,2263,'EM','tom.blank8@gmail.com',0,'2013-12-25 19:30:16',NULL,NULL),(25573,16497,'EM','jbz524@aol.com',0,'2014-01-07 04:06:42',NULL,NULL),(24409,15760,'TE','9568545087',0,'2014-01-03 02:01:27',NULL,NULL),(5916,3794,'EM','capttv2@gmail.com',0,'2013-12-25 21:34:20',NULL,NULL),(37782,24934,'BN','7083743567',0,'2014-02-20 21:30:21',NULL,NULL),(40206,26668,'EM','amandawhitley1990@outlook.com',0,'2014-02-28 21:31:16',NULL,NULL),(41378,27486,'AP','3308197455',0,'2014-03-04 21:02:21',NULL,NULL),(21645,13931,'AP','4193509148',0,'2013-12-26 13:14:29',NULL,NULL),(32573,21298,'BN','9853518305',0,'2014-02-04 21:00:11',NULL,NULL),(29317,18945,'AP','2145172462',0,'2014-01-20 08:05:45',NULL,NULL),(28300,18241,'AP','9565023259',0,'2014-01-16 08:44:25',NULL,NULL),(5174,3321,'TE','3306782211',0,'2013-12-25 21:16:05',NULL,NULL),(1436,876,'AP','8122199371',0,'2013-12-25 18:07:35',NULL,NULL),(21389,13754,'EM','Lsmad0399@gmail.com',0,'2013-12-26 13:10:02',NULL,NULL),(7360,4788,'TE','4404886537',0,'2013-12-25 22:16:14',NULL,NULL),(2277,1397,'TE','5043220954',0,'2013-12-25 18:46:30',NULL,NULL),(2543,1555,'EM','EMBOURGE424@GMAIL.COM',0,'2013-12-25 18:50:44',NULL,NULL),(30319,19641,'TE','3304691536',0,'2014-01-23 21:00:15',NULL,NULL),(9656,6321,'AP','6147361100',0,'2013-12-26 00:46:22',NULL,NULL),(29125,18809,'AP','3307866893',0,'2014-01-17 03:36:02',NULL,NULL),(10064,6580,'AP','2097703999',0,'2013-12-26 00:52:57',NULL,NULL),(26239,16887,'TE','3617423746',0,'2014-01-13 02:19:25',NULL,NULL),(480,305,'EM','suepatrick724@sbcglobal.net',0,'2013-12-25 17:30:54',NULL,NULL),(33091,21677,'AP','9852493204',0,'2014-02-05 21:31:00',NULL,NULL),(587,361,'EM','piersonfd@yahoo.com',0,'2013-12-25 17:45:11',NULL,NULL),(25088,16175,'TE','2252056562',0,'2014-01-05 00:00:21',NULL,NULL),(12095,7905,'AP','5042203574',0,'2013-12-26 03:05:55',NULL,NULL),(36764,24206,'AP','5044501386',0,'2014-02-16 19:00:20',NULL,NULL),(40205,26668,'AP','5042366428',0,'2014-02-28 21:31:16',NULL,NULL),(9353,6124,'AP','4696711496',0,'2013-12-26 00:15:49',NULL,NULL),(28015,18057,'TE','4192153682',0,'2014-01-15 02:07:19',NULL,NULL),(8328,5461,'TE','2166332529',0,'2013-12-25 23:10:25',NULL,NULL),(8172,5346,'TE','3302037552',0,'2013-12-25 23:07:30',NULL,NULL),(6108,3931,'EM','tyfoust@hotmail.com',0,'2013-12-25 21:37:39',NULL,NULL),(35913,23630,'AP','9523815807',0,'2014-02-14 21:30:03',NULL,NULL),(37432,24647,'EM','jvancol95@hotmail.com',0,'2014-02-20 04:22:02',NULL,NULL),(42397,28160,'TE','4192311464',0,'2014-03-06 21:02:41',NULL,NULL),(42608,28347,'TE','9724964575',0,'2014-03-07 21:30:20',NULL,NULL),(3256,2050,'TE','8179265106',0,'2013-12-25 19:15:49',NULL,NULL),(32497,21235,'EM','paeri@hotmail.com',0,'2014-02-03 21:01:11',NULL,NULL),(4439,2829,'AP','9852652237',0,'2013-12-25 20:00:43',NULL,NULL),(28797,18586,'TE','4197074792',0,'2014-01-16 08:47:11',NULL,NULL),(14181,9277,'TE','5174148530',0,'2013-12-26 04:15:50',NULL,NULL),(25100,16181,'EM','jholt83@gmail.com',0,'2014-01-05 00:00:33',NULL,NULL),(6676,4335,'TE','4192962664',0,'2013-12-25 21:53:08',NULL,NULL),(41951,27886,'AP','4192708282',0,'2014-03-05 21:32:36',NULL,NULL),(42066,27954,'TE','4323868239',0,'2014-03-06 21:00:40',NULL,NULL),(42147,28001,'AP','6143488570',0,'2014-03-06 21:01:09',NULL,NULL),(43706,29016,'AP','4402211778',0,'2014-03-10 21:01:27',NULL,NULL),(22915,14786,'TE','6144466321',1,'2013-12-29 11:13:22',NULL,NULL),(10255,6701,'TE','7025962921',0,'2013-12-26 01:01:55',NULL,NULL),(2519,1543,'TE','4195921778',0,'2013-12-25 18:50:22',NULL,NULL),(31279,20377,'TE','2543836613',0,'2014-01-29 21:00:09',NULL,NULL),(29444,19037,'TE','6013945148',0,'2014-01-20 08:06:35',NULL,NULL),(21233,13649,'EM','cranstonvalentine@yahoo.com',0,'2013-12-26 13:07:15',NULL,NULL),(5797,3720,'TE','7406382370',0,'2013-12-25 21:32:21',NULL,NULL),(34995,22975,'EM','ascherr@rgtfoods.com',0,'2014-02-12 21:30:05',NULL,NULL),(37228,24499,'AP','4699959287',0,'2014-02-20 03:48:33',NULL,NULL),(40427,26837,'TE','2252533521',0,'2014-03-01 21:00:43',NULL,NULL),(27,18,'TE','4196901771',0,'2013-12-25 17:15:27',NULL,NULL),(23698,15297,'AP','2252005058',1,'2014-01-02 04:22:42',NULL,NULL),(23625,15253,'AP','5672040859',0,'2014-01-01 12:09:02',NULL,NULL),(10855,7046,'TE','9033928735',0,'2013-12-26 01:49:33',NULL,NULL),(3803,2419,'EM','Jslouffman@hotmail.com',0,'2013-12-25 19:33:55',NULL,NULL),(20347,13108,'EM','colecottrill@gmail.com',0,'2013-12-26 12:52:23',NULL,NULL),(37970,25052,'TE','5133822924',0,'2014-02-20 22:01:17',NULL,NULL),(39648,26218,'AP','3306221743',0,'2014-02-28 06:30:56',NULL,NULL),(11602,7547,'TE','4194488382',0,'2013-12-26 02:33:05',NULL,NULL),(13556,8840,'TE','5122034778',0,'2013-12-26 04:00:44',NULL,NULL),(30037,19454,'BN','4402271741',0,'2014-01-23 03:01:53',NULL,NULL),(29491,19060,'TE','9154497671',0,'2014-01-21 08:44:15',NULL,NULL),(6318,4073,'EM','Elihudi@hotmail.com',0,'2013-12-25 21:46:59',NULL,NULL),(25640,16537,'TE','3302847216',1,'2014-01-07 10:22:13',NULL,NULL),(11444,7442,'EM','mhurlow@email.com',0,'2013-12-26 02:30:28',NULL,NULL),(6154,3962,'AP','2164969332',0,'2013-12-25 21:38:26',NULL,NULL),(2163,1331,'TE','4196184046',0,'2013-12-25 18:32:06',NULL,NULL),(41984,27907,'AP','2144358700',0,'2014-03-06 21:00:12',NULL,NULL),(13546,8835,'TE','9365560740',0,'2013-12-26 04:00:35',NULL,NULL),(6512,4208,'AP','3614455851',0,'2013-12-25 21:50:07',NULL,NULL),(33031,21640,'TE','9033150153',0,'2014-02-05 21:30:45',NULL,NULL),(30664,19909,'TE','3307944910',0,'2014-01-24 21:00:59',NULL,NULL),(27537,17746,'TE','3306742402',0,'2014-01-14 01:33:25',NULL,NULL),(27829,17932,'TE','8173235889',0,'2014-01-15 02:06:36',NULL,NULL),(35839,23566,'EM','lenjo426@hotmail.com',0,'2014-02-13 22:02:48',NULL,NULL),(36689,24157,'AP','9374232484',0,'2014-02-15 22:02:01',NULL,NULL),(3708,2351,'EM','alridge5@gmail.com',0,'2013-12-25 19:32:15',NULL,NULL),(34781,22812,'TE','5135942240',0,'2014-02-11 21:01:58',NULL,NULL),(32798,21457,'EM','fairydust53182@yahoo.com',0,'2014-02-04 21:01:32',NULL,NULL),(30817,20036,'TE','7404905493',0,'2014-01-26 19:00:23',NULL,NULL),(21410,13765,'AP','6012185217',0,'2013-12-26 13:10:21',NULL,NULL),(9738,6370,'EM','Larrybecker2900@yahoo.com',0,'2013-12-26 00:47:38',NULL,NULL),(35527,23367,'TE','3306664811',0,'2014-02-13 22:00:49',NULL,NULL),(36658,24132,'AP','9014977309',0,'2014-02-15 22:01:48',NULL,NULL),(39958,26451,'BN','6017503733',0,'2014-02-28 07:30:26',NULL,NULL),(40808,27117,'EM','blackdesk1222@yahoo.com',0,'2014-03-03 21:30:31',NULL,NULL),(23041,14863,'TE','5138891094',1,'2013-12-29 11:15:26',NULL,NULL),(33698,22102,'AP','7247773860',0,'2014-02-08 19:00:30',NULL,NULL),(33239,21765,'TE','9036171809',0,'2014-02-06 21:00:29',NULL,NULL),(25318,16327,'AP','5047237439',0,'2014-01-07 04:01:52',NULL,NULL),(13880,9053,'AP','5122969715',0,'2013-12-26 04:06:06',NULL,NULL),(14938,9773,'TE','3184970878',0,'2013-12-26 05:00:32',NULL,NULL),(35479,23332,'TE','5138879759',0,'2014-02-13 22:00:31',NULL,NULL),(36538,24054,'EM','BEFTSRVCS@AOL.COM',0,'2014-02-15 22:01:07',NULL,NULL),(41173,27345,'TE','3308443183',0,'2014-03-04 21:01:01',NULL,NULL),(22221,14324,'AP','3302042803',0,'2013-12-27 02:07:20',NULL,NULL),(8925,5842,'TE','8305561680',0,'2013-12-25 23:48:36',NULL,NULL),(29037,18746,'EM','llmarini3@gmail.com',0,'2014-01-17 03:35:42',NULL,NULL),(794,495,'EM','Dominic20052003@yahoo.com',0,'2013-12-25 17:48:31',NULL,NULL),(28521,18384,'EM','F.FREDERICK.W@GMAIL.COM',0,'2014-01-16 08:45:36',NULL,NULL),(35641,23436,'EM','Dranj124@yahoo.com',0,'2014-02-13 22:01:30',NULL,NULL),(36644,24123,'EM','brittneyhawkins1@yahoo.com',0,'2014-02-15 22:01:43',NULL,NULL),(38134,25171,'TE','5134038989',0,'2014-02-21 22:00:28',NULL,NULL),(40558,26919,'EM','hamric_stacey@yahoo.com',0,'2014-03-03 01:00:15',NULL,NULL),(42506,28269,'AP','3253560091',0,'2014-03-07 21:00:21',NULL,NULL),(42697,28402,'TE','2163014790',0,'2014-03-07 21:30:51',NULL,NULL),(14251,9323,'AP','8319176893',0,'2013-12-26 04:30:33',NULL,NULL),(21374,13743,'AP','5133140487',0,'2013-12-26 13:09:45',NULL,NULL),(6616,4275,'TE','5137246254',0,'2013-12-25 21:51:52',NULL,NULL),(28247,18215,'TE','4193027695',0,'2014-01-15 02:08:11',NULL,NULL),(35734,23503,'TE','9032385220',0,'2014-02-13 22:02:09',NULL,NULL),(36346,23936,'TE','6149403226',0,'2014-02-15 21:00:07',NULL,NULL),(41727,27747,'TE','2252399946',0,'2014-03-05 21:31:13',NULL,NULL),(43922,29138,'AP','4192768197',0,'2014-03-10 21:02:41',NULL,NULL),(7953,5188,'TE','4194665242',0,'2013-12-25 23:03:42',NULL,NULL),(10180,6652,'EM','douglaswilhelm@ymail.com',0,'2013-12-26 01:00:36',NULL,NULL),(31838,20785,'EM','alanisv81@icloud.com',0,'2014-01-31 21:00:12',NULL,NULL),(31400,20469,'EM','ERICPOWER1968@YAHOO.COM',0,'2014-01-29 21:00:54',NULL,NULL),(28185,18167,'TE','9377796620',0,'2014-01-15 02:07:56',NULL,NULL),(26349,16959,'AP','3308197283',0,'2014-01-13 02:20:06',NULL,NULL),(13773,8978,'AP','3303295351',0,'2013-12-26 04:04:15',NULL,NULL),(3902,2477,'AP','5044628623',0,'2013-12-25 19:35:25',NULL,NULL),(40693,27031,'TE','9158868805',0,'2014-03-03 21:00:16',NULL,NULL),(42797,28461,'AP','3372581716',0,'2014-03-07 21:31:26',NULL,NULL),(24252,15671,'EM','jeremy.ayers@steemer.com',1,'2014-01-02 04:34:42',NULL,NULL),(4543,2889,'AP','2345427548',0,'2013-12-25 20:15:08',NULL,NULL),(28642,18469,'TE','2257153592',0,'2014-01-16 08:46:16',NULL,NULL),(28565,18417,'AP','5042148160',0,'2014-01-16 08:45:50',NULL,NULL),(26129,16823,'TE','2253691716',0,'2014-01-13 02:18:24',NULL,NULL),(1842,1139,'EM','pdalafayette@pdaorg.net',0,'2013-12-25 18:18:17',NULL,NULL),(36531,24051,'EM','albertaholbert@sbcglobal.net',0,'2014-02-15 22:01:04',NULL,NULL),(39096,25867,'AP','3373086208',0,'2014-02-26 21:00:48',NULL,NULL),(42061,27951,'AP','9364888286',0,'2014-03-06 21:00:38',NULL,NULL),(25358,16352,'EM','peggieblunt@yahoo.com',0,'2014-01-07 04:02:33',NULL,NULL),(33105,21684,'EM','tommac1962@hotmail.com',0,'2014-02-05 21:31:04',NULL,NULL),(32598,21315,'TE','3182801484',0,'2014-02-04 21:00:19',NULL,NULL),(31870,20804,'AP','7137960716',0,'2014-01-31 21:00:24',NULL,NULL),(31805,20767,'TE','7186124922',0,'2014-01-30 21:01:37',NULL,NULL),(30622,19873,'AP','2163390871',0,'2014-01-24 21:00:42',NULL,NULL),(28298,18240,'AP','9792030710',0,'2014-01-16 08:44:25',NULL,NULL),(11149,7250,'TE','2259369874',0,'2013-12-26 02:01:54',NULL,NULL),(6723,4370,'TE','6142862357',0,'2013-12-25 22:00:17',NULL,NULL),(6675,4334,'EM','debbieopaz@gmail.com',0,'2013-12-25 21:53:06',NULL,NULL),(9384,6142,'TE','6145066844',0,'2013-12-26 00:16:18',NULL,NULL),(6095,3926,'TE','5134671088',0,'2013-12-25 21:37:29',NULL,NULL),(36031,23698,'TE','5133712933',0,'2014-02-14 21:30:41',NULL,NULL),(38075,25134,'TE','9797323534',0,'2014-02-21 22:00:05',NULL,NULL),(41684,27720,'AP','7136799843',0,'2014-03-05 21:30:58',NULL,NULL),(42485,28249,'TE','4402480495',0,'2014-03-07 21:00:12',NULL,NULL),(43121,28666,'AP','3183449443',0,'2014-03-08 21:30:46',NULL,NULL),(7275,4740,'AP','7633704190',0,'2013-12-25 22:09:26',NULL,NULL),(28772,18564,'AP','9377287522',0,'2014-01-16 08:47:01',NULL,NULL),(27608,17796,'EM','pammbaker@zoomtown.com',0,'2014-01-14 01:33:51',NULL,NULL),(27509,17723,'AP','3307035121',0,'2014-01-14 01:33:15',NULL,NULL),(14154,9266,'TE','4403397251',0,'2013-12-26 04:15:29',NULL,NULL),(2599,1584,'EM','50dan@att.net',0,'2013-12-25 18:51:33',NULL,NULL),(41761,27768,'AP','3184696498',0,'2014-03-05 21:31:25',NULL,NULL),(43353,28795,'AP','8178251608',0,'2014-03-09 21:00:45',NULL,NULL),(26043,16777,'AP','9374671730',0,'2014-01-08 18:25:04',NULL,NULL),(3984,2526,'EM','lance.awdt@yahoo.com',0,'2013-12-25 19:36:44',NULL,NULL),(28187,18169,'TE','5132369923',0,'2014-01-15 02:07:56',NULL,NULL),(26789,17234,'TE','6017200637',0,'2014-01-13 02:22:41',NULL,NULL),(6867,4454,'EM','cbyers49@wildblue.net',0,'2013-12-25 22:02:28',NULL,NULL),(13730,8949,'TE','5135443437',0,'2013-12-26 04:03:31',NULL,NULL),(20354,13111,'AP','5137023752',0,'2013-12-26 12:52:29',NULL,NULL),(36064,23720,'AP','2163852047',0,'2014-02-14 21:30:52',NULL,NULL),(41864,27838,'EM','adlib205@yahoo.com',0,'2014-03-05 21:32:05',NULL,NULL),(11514,7492,'AP','9372511555',0,'2013-12-26 02:31:39',NULL,NULL),(33701,22103,'EM','randydodie@hotmail.com',0,'2014-02-08 19:00:31',NULL,NULL),(13516,8812,'AP','5132380301',0,'2013-12-26 04:00:04',NULL,NULL),(23626,15254,'TE','4192255084',0,'2014-01-01 12:09:03',NULL,NULL),(5936,3805,'EM','btupaz@jcu.edu',0,'2013-12-25 21:34:38',NULL,NULL),(14003,9142,'TE','3307736357',0,'2013-12-26 04:08:14',NULL,NULL),(7290,4748,'TE','9309464310',0,'2013-12-25 22:15:07',NULL,NULL),(2351,1429,'AP','6122816559',0,'2013-12-25 18:47:31',NULL,NULL),(39153,25898,'EM','rfbanks82@suddenlink.net',0,'2014-02-26 21:01:07',NULL,NULL),(40126,26610,'TE','9034136140',0,'2014-02-28 21:30:47',NULL,NULL),(41982,27905,'EM','vfitzlarry@yahoo.com',0,'2014-03-06 21:00:12',NULL,NULL),(585,361,'TE','5125771612',0,'2013-12-25 17:45:11',NULL,NULL),(34153,22392,'EM','allant30@hotmail.com',0,'2014-02-10 21:30:16',NULL,NULL),(33971,22286,'EM','Petershanes@aol.com',0,'2014-02-10 11:00:26',NULL,NULL),(8705,5711,'AP','9523348795',0,'2013-12-25 23:45:10',NULL,NULL),(28040,18070,'AP','3187074537',0,'2014-01-15 02:07:23',NULL,NULL),(22835,14728,'EM','hyoung75@gmail.com',1,'2013-12-29 11:09:45',NULL,NULL),(5259,3378,'TE','8172011989',0,'2013-12-25 21:17:26',NULL,NULL),(40690,27021,'TE','4192170251',0,'2014-03-03 21:00:13',NULL,NULL),(42410,28166,'EM','lakittam@gmail.com',0,'2014-03-06 21:02:46',NULL,NULL),(42638,28364,'AP','9568258326',0,'2014-03-07 21:30:30',NULL,NULL),(25060,16155,'AP','2162122535',0,'2014-01-04 02:06:24',NULL,NULL),(14803,9689,'AP','4196190466',0,'2013-12-26 04:39:40',NULL,NULL),(9272,6068,'EM','alanaraewood@cinci.rr.com',0,'2013-12-26 00:02:08',NULL,NULL),(9022,5920,'TE','9722216339',0,'2013-12-25 23:50:15',NULL,NULL),(11050,7175,'TE','3306316896',0,'2013-12-26 02:00:05',NULL,NULL),(4191,2682,'TE','5136046777',0,'2013-12-25 19:47:14',NULL,NULL),(10829,7033,'TE','2145878437',0,'2013-12-26 01:49:11',NULL,NULL),(27827,17931,'AP','9406821783',0,'2014-01-15 02:06:35',NULL,NULL),(28485,18356,'TE','5134171258',0,'2014-01-16 08:45:24',NULL,NULL),(29892,19342,'EM','matthewbrandon@gmail.com',1,'2014-01-22 03:22:22',NULL,NULL),(32007,20895,'TE','5136521671',0,'2014-01-31 21:01:17',NULL,NULL),(32284,21088,'AP','9375201108',0,'2014-02-02 19:00:26',NULL,NULL),(33680,22092,'TE','6018429145',0,'2014-02-08 19:00:25',NULL,NULL),(34279,22491,'AP','6144412904',0,'2014-02-10 21:31:08',NULL,NULL),(35065,23026,'TE','8063003202',0,'2014-02-12 21:30:32',NULL,NULL),(37982,25058,'TE','4198741207',0,'2014-02-20 22:01:21',NULL,NULL),(39517,26139,'AP','6143576273',0,'2014-02-28 06:30:25',NULL,NULL),(39535,26152,'AP','5134656347',0,'2014-02-28 06:30:29',NULL,NULL),(41502,27589,'AP','9563714952',0,'2014-03-05 21:00:16',NULL,NULL),(20690,13301,'AP','2818577621',0,'2013-12-26 12:57:48',NULL,NULL),(11934,7773,'AP','9563346399',0,'2013-12-26 03:02:59',NULL,NULL),(11614,7552,'AP','3304130853',0,'2013-12-26 02:33:16',NULL,NULL),(6134,3948,'AP','4193413302',0,'2013-12-25 21:38:06',NULL,NULL),(26305,16937,'TE','2252813540',0,'2014-01-13 02:19:51',NULL,NULL),(8173,5346,'AP','3302037552',0,'2013-12-25 23:07:31',NULL,NULL),(27978,18036,'AP','4192605674',0,'2014-01-15 02:07:10',NULL,NULL),(31340,20422,'TE','9372101703',0,'2014-01-29 21:00:31',NULL,NULL),(33281,21793,'TE','5138074751',0,'2014-02-06 21:00:45',NULL,NULL),(33710,22113,'AP','7132778013',0,'2014-02-08 19:00:35',NULL,NULL),(34207,22434,'AP','2105403210',0,'2014-02-10 21:30:38',NULL,NULL),(35508,23350,'AP','3306072991',0,'2014-02-13 22:00:41',NULL,NULL),(35758,23516,'TE','2282132073',0,'2014-02-13 22:02:17',NULL,NULL),(36112,23766,'TE','3309363581',0,'2014-02-14 21:31:11',NULL,NULL),(36761,24205,'AP','2255887844',0,'2014-02-16 19:00:20',NULL,NULL),(27282,17567,'TE','6143892449',0,'2014-01-14 01:31:59',NULL,NULL),(2244,1376,'TE','9585023962',0,'2013-12-25 18:45:57',NULL,NULL),(6145,3957,'TE','3306222919',0,'2013-12-25 21:38:20',NULL,NULL),(6600,4263,'TE','3308671168',0,'2013-12-25 21:51:35',NULL,NULL),(21728,14000,'AP','3305012093',0,'2013-12-26 13:16:01',NULL,NULL),(20932,13464,'TE','6147710620',0,'2013-12-26 13:01:50',NULL,NULL),(4998,3208,'TE','4408240199',0,'2013-12-25 20:45:22',NULL,NULL),(13527,8820,'AP','5132829556',0,'2013-12-26 04:00:15',NULL,NULL),(9987,6534,'EM','evelyn.tsoi@gmail.com',0,'2013-12-26 00:51:46',NULL,NULL),(8775,5751,'TE','2252661457',0,'2013-12-25 23:46:13',NULL,NULL),(8930,5848,'TE','9796907206',0,'2013-12-25 23:48:42',NULL,NULL),(28037,18068,'TE','2253042730',0,'2014-01-15 02:07:23',NULL,NULL),(28110,18117,'TE','3308505145',0,'2014-01-15 02:07:39',NULL,NULL),(29788,19263,'AP','4194390247',0,'2014-01-21 08:46:50',NULL,NULL),(32850,21499,'TE','5174886566',0,'2014-02-04 21:01:51',NULL,NULL),(37311,24551,'AP','3306512960',0,'2014-02-20 04:04:32',NULL,NULL),(40216,26675,'TE','2253240638',0,'2014-02-28 21:31:20',NULL,NULL),(41799,27788,'TE','2707799503',0,'2014-03-05 21:31:38',NULL,NULL),(313,193,'TE','4195427894',0,'2013-12-25 17:20:01',NULL,NULL),(606,374,'EM','bilindra@yahoo.com',0,'2013-12-25 17:45:31',NULL,NULL),(25201,16249,'AP','9374073479',0,'2014-01-05 00:02:36',NULL,NULL),(23751,15322,'EM','shovonc@yahoo.com',1,'2014-01-02 04:23:36',NULL,NULL),(23718,15306,'AP','3185729278',1,'2014-01-02 04:23:01',NULL,NULL),(22773,14683,'TE','6143708858',1,'2013-12-29 11:08:38',NULL,NULL),(1231,750,'TE','3618087020',0,'2013-12-25 18:04:16',NULL,NULL),(21420,13771,'TE','6018576088',0,'2013-12-26 13:10:31',NULL,NULL),(2696,1637,'TE','7138993769',0,'2013-12-25 18:52:59',NULL,NULL),(11932,7772,'AP','4696852580',0,'2013-12-26 03:02:57',NULL,NULL),(3438,2156,'EM','barryw.realtor4u@gmail.com',0,'2013-12-25 19:18:44',NULL,NULL),(3409,2142,'TE','6019821991',0,'2013-12-25 19:18:17',NULL,NULL),(27360,17614,'AP','8327745652',0,'2014-01-14 01:32:24',NULL,NULL),(29369,18975,'EM','mhhummerinv@msn.com',0,'2014-01-20 08:06:05',NULL,NULL),(39567,26177,'EM','freewheelin8@yahoo.com',0,'2014-02-28 06:30:39',NULL,NULL),(41935,27878,'AP','4196042190',0,'2014-03-05 21:32:31',NULL,NULL),(3078,1920,'TE','3306343955',0,'2013-12-25 19:00:09',NULL,NULL),(10060,6577,'EM','ltnordi@netscape.net',0,'2013-12-26 00:52:53',NULL,NULL),(12139,7930,'AP','3377899516',0,'2013-12-26 03:06:36',NULL,NULL),(23746,15320,'EM','chamicahamilton@yahoo.com',1,'2014-01-02 04:23:31',NULL,NULL),(23715,15305,'AP','2259332429',1,'2014-01-02 04:22:59',NULL,NULL),(22961,14810,'EM','quin_lebouf@yahoo.com',1,'2013-12-29 11:14:03',NULL,NULL),(22013,14176,'EM','superstar911313@gmail.com',0,'2013-12-27 02:03:36',NULL,NULL),(31721,20701,'TE','3372559953',0,'2014-01-30 21:01:04',NULL,NULL),(36643,24123,'TE','5043093200',0,'2014-02-15 22:01:43',NULL,NULL),(43445,28851,'AP','4193947305',0,'2014-03-09 21:01:19',NULL,NULL),(43960,29163,'TE','4402887281',0,'2014-03-10 21:02:55',NULL,NULL),(9324,6107,'TE','6143297780',0,'2013-12-26 00:15:20',NULL,NULL),(26543,17074,'AP','4694780664',0,'2014-01-13 02:21:19',NULL,NULL),(26356,16963,'AP','3303577808',0,'2014-01-13 02:20:09',NULL,NULL),(26031,16772,'TE','2283481972',0,'2014-01-08 18:25:02',NULL,NULL),(25898,16692,'TE','9566245888',0,'2014-01-08 18:24:35',NULL,NULL),(25560,16488,'AP','4192604539',0,'2014-01-07 04:06:28',NULL,NULL),(25198,16246,'AP','2162565988',0,'2014-01-05 00:02:32',NULL,NULL),(23173,14934,'TE','9374391607',0,'2013-12-30 00:02:07',NULL,NULL),(1807,1118,'TE','6627217043',0,'2013-12-25 18:17:44',NULL,NULL),(21450,13788,'TE','2694457365',0,'2013-12-26 13:10:58',NULL,NULL),(20549,13227,'TE','3612076165',0,'2013-12-26 12:55:39',NULL,NULL),(4423,2819,'AP','6623392544',0,'2013-12-25 20:00:28',NULL,NULL),(14430,9431,'TE','4192654006',0,'2013-12-26 04:33:25',NULL,NULL),(28191,18170,'EM','theresaherbst@fuse.net',0,'2014-01-15 02:07:57',NULL,NULL),(28581,18424,'BN','5044329776',0,'2014-01-16 08:45:55',NULL,NULL),(29732,19226,'AP','4195089080',0,'2014-01-21 08:46:29',NULL,NULL),(31147,20286,'EM','hronekesq@yahoo.com',0,'2014-01-28 21:00:33',NULL,NULL),(35815,23550,'AP','3376542997',0,'2014-02-13 22:02:38',NULL,NULL),(38259,25257,'AP','4194871066',0,'2014-02-21 22:01:18',NULL,NULL),(39708,26260,'TE','9563369484',0,'2014-02-28 06:31:12',NULL,NULL),(42394,28157,'EM','jodi.haas@aol.com',0,'2014-03-06 21:02:40',NULL,NULL),(5940,3809,'TE','5672318709',0,'2013-12-25 21:34:43',NULL,NULL),(5993,3849,'EM','smithrd.esq@gmail.com',0,'2013-12-25 21:35:36',NULL,NULL),(14718,9628,'EM','countryclubmama@yahoo.com',0,'2013-12-26 04:38:08',NULL,NULL),(22742,14668,'TE','3252364169',1,'2013-12-29 11:08:10',NULL,NULL),(20627,13270,'TE','3252140404',0,'2013-12-26 12:56:53',NULL,NULL),(29496,19067,'EM','dianabuk@gmail.com',0,'2014-01-21 08:44:18',NULL,NULL),(31307,20400,'TE','8324441717',0,'2014-01-29 21:00:20',NULL,NULL),(31551,20566,'TE','4199577043',0,'2014-01-29 21:01:49',NULL,NULL),(31788,20748,'EM','nitalucke@rocketmail.com',0,'2014-01-30 21:01:28',NULL,NULL),(33570,22010,'EM','bonierockwell@aol.com',0,'2014-02-07 19:00:51',NULL,NULL),(34418,22578,'EM','davewilson81@gmail.com',0,'2014-02-10 21:32:01',NULL,NULL),(36103,23755,'TE','5132371316',0,'2014-02-14 21:31:08',NULL,NULL),(41701,27728,'TE','9366618951',0,'2014-03-05 21:31:03',NULL,NULL),(43878,29114,'TE','6019063884',0,'2014-03-10 21:02:26',NULL,NULL),(6863,4452,'EM','Lmspencer29@earthlink.net',0,'2013-12-25 22:02:25',NULL,NULL),(26070,16791,'AP','5136231187',0,'2014-01-13 02:18:06',NULL,NULL),(5085,3263,'TE','3306346896',0,'2013-12-25 20:46:58',NULL,NULL),(1032,637,'AP','6143547423',0,'2013-12-25 18:01:16',NULL,NULL),(12398,8119,'TE','5138752120',0,'2013-12-26 03:15:14',NULL,NULL),(14147,9261,'AP','5044525037',0,'2013-12-26 04:15:20',NULL,NULL),(28271,18229,'TE','4694508157',0,'2014-01-16 08:44:18',NULL,NULL),(31312,20402,'AP','2544212652',0,'2014-01-29 21:00:21',NULL,NULL),(31426,20486,'TE','3308585429',0,'2014-01-29 21:01:04',NULL,NULL),(31729,20706,'AP','3183519493',0,'2014-01-30 21:01:07',NULL,NULL),(33293,21801,'TE','4195234429',0,'2014-02-06 21:00:50',NULL,NULL),(34629,22706,'AP','3183489914',0,'2014-02-11 21:01:02',NULL,NULL),(34698,22753,'EM','Amysalteration@gmail.com',0,'2014-02-11 21:01:27',NULL,NULL),(35675,23464,'TE','9722203205',0,'2014-02-13 22:01:45',NULL,NULL),(36036,23703,'TE','9377260397',0,'2014-02-14 21:30:43',NULL,NULL),(38505,25446,'AP','2544349164',0,'2014-02-25 21:31:23',NULL,NULL),(38532,25462,'AP','9137026124',0,'2014-02-25 21:31:32',NULL,NULL),(41131,27320,'TE','2144423404',0,'2014-03-04 21:00:45',NULL,NULL),(41489,27580,'AP','8066263638',0,'2014-03-05 21:00:11',NULL,NULL),(41756,27766,'TE','5044358685',0,'2014-03-05 21:31:23',NULL,NULL),(42988,28591,'TE','3309261541',0,'2014-03-08 21:30:02',NULL,NULL),(1085,666,'AP','3305595203',0,'2013-12-25 18:02:01',NULL,NULL),(9049,5935,'TE','3182831398',0,'2013-12-25 23:50:39',NULL,NULL),(3775,2395,'AP','5136525532',0,'2013-12-25 19:33:23',NULL,NULL),(5602,3587,'TE','2604026808',0,'2013-12-25 21:22:54',NULL,NULL),(11629,7566,'TE','4192031733',0,'2013-12-26 02:33:37',NULL,NULL),(21733,14002,'TE','9375586453',0,'2013-12-26 13:16:06',NULL,NULL),(23982,15482,'EM','rabartsc@gmail.com',1,'2014-01-02 04:29:11',NULL,NULL),(24710,15941,'AP','9374037906',0,'2014-01-03 02:07:12',NULL,NULL),(28142,18142,'TE','9852248867',0,'2014-01-15 02:07:47',NULL,NULL),(28573,18420,'AP','4796016881',0,'2014-01-16 08:45:52',NULL,NULL),(28596,18433,'TE','3185030615',0,'2014-01-16 08:45:59',NULL,NULL),(29563,19103,'AP','2259361565',0,'2014-01-21 08:44:40',NULL,NULL),(29975,19396,'AP','2165362864',1,'2014-01-22 03:22:51',NULL,NULL),(30024,19446,'TE','5132662706',0,'2014-01-23 03:01:51',NULL,NULL),(30451,19741,'AP','2255051224',0,'2014-01-23 21:01:11',NULL,NULL),(33043,21646,'AP','5132911257',0,'2014-02-05 21:30:48',NULL,NULL),(35704,23482,'EM','mhleppala@gmail.com',0,'2014-02-13 22:01:56',NULL,NULL),(36086,23735,'AP','7405909252',0,'2014-02-14 21:31:00',NULL,NULL),(37621,24796,'TE','7403363602',0,'2014-02-20 04:47:33',NULL,NULL),(37707,24862,'TE','7138692190',0,'2014-02-20 05:30:39',NULL,NULL),(38270,25268,'AP','3609090037',0,'2014-02-25 21:00:10',NULL,NULL),(40308,26739,'AP','5672309900',0,'2014-02-28 21:31:54',NULL,NULL),(42181,28020,'TE','2165540255',0,'2014-03-06 21:01:21',NULL,NULL),(42549,28312,'EM','tystang2001@yahoo.com',0,'2014-03-07 21:00:37',NULL,NULL),(566,350,'EM','dmarie_1995@yahoo.com',0,'2013-12-25 17:32:15',NULL,NULL),(23343,15039,'AP','3185477759',0,'2014-01-01 12:02:54',NULL,NULL),(23326,15029,'EM','tepainthouse@yahoo.com',0,'2014-01-01 12:02:34',NULL,NULL),(21906,14112,'TE','4407257882',0,'2013-12-27 02:01:53',NULL,NULL),(21747,14008,'AP','5135204487',0,'2013-12-26 13:16:18',NULL,NULL),(2452,1505,'EM','meredith.amann@gmail.com',0,'2013-12-25 18:49:21',NULL,NULL),(10583,6886,'EM','apoole437@gmail.com',0,'2013-12-26 01:45:15',NULL,NULL),(13836,9021,'AP','3304756609',0,'2013-12-26 04:05:20',NULL,NULL),(13813,9001,'AP','4403914575',0,'2013-12-26 04:04:53',NULL,NULL),(13710,8935,'TE','4196068267',0,'2013-12-26 04:03:10',NULL,NULL),(12092,7904,'TE','5044308895',0,'2013-12-26 03:05:53',NULL,NULL),(9132,5978,'EM','lacimati@roadrunner.com',0,'2013-12-25 23:51:54',NULL,NULL),(8938,5851,'TE','2102907400',0,'2013-12-25 23:48:48',NULL,NULL),(8295,5435,'AP','2252704507',0,'2013-12-25 23:09:47',NULL,NULL),(25180,16237,'EM','someone40_70@msn.com',0,'2014-01-05 00:02:14',NULL,NULL),(29399,19000,'TE','3306281064',0,'2014-01-20 08:06:15',NULL,NULL),(29584,19114,'AP','4196735429',0,'2014-01-21 08:44:47',NULL,NULL),(32114,20970,'AP','9565331431',0,'2014-02-01 19:00:14',NULL,NULL),(38562,25482,'AP','5133159929',0,'2014-02-25 21:31:44',NULL,NULL),(38862,25686,'TE','6012017556',0,'2014-02-26 09:30:08',NULL,NULL),(41327,27454,'EM','tam727@yahoo.com',0,'2014-03-04 21:02:01',NULL,NULL),(42254,28065,'AP','4404172912',0,'2014-03-06 21:01:46',NULL,NULL),(2033,1258,'EM','franvg@aol.com',0,'2013-12-25 18:21:27',NULL,NULL),(27575,17772,'TE','7133970884',0,'2014-01-14 01:33:39',NULL,NULL),(3753,2380,'TE','6142053318',0,'2013-12-25 19:33:00',NULL,NULL),(26383,16983,'TE','5135047074',0,'2014-01-13 02:20:19',NULL,NULL),(21660,13940,'TE','4408439849',0,'2013-12-26 13:14:44',NULL,NULL),(31847,20792,'EM','gradyball29@aol.com',0,'2014-01-31 21:00:16',NULL,NULL),(33917,22263,'TE','7138567359',0,'2014-02-10 11:00:08',NULL,NULL),(36703,24165,'TE','4408237511',0,'2014-02-15 22:02:06',NULL,NULL),(36903,24303,'TE','4194390912',0,'2014-02-18 21:30:21',NULL,NULL),(39373,26040,'AP','3308074776',0,'2014-02-26 21:02:27',NULL,NULL),(39912,26411,'EM','rachelram@yahoo.com',0,'2014-02-28 07:00:40',NULL,NULL),(60,40,'AP','2162178230',0,'2013-12-25 17:16:02',NULL,NULL),(27311,17588,'AP','3307035121',0,'2014-01-14 01:32:09',NULL,NULL),(26463,17034,'TE','3185420618',0,'2014-01-13 02:20:47',NULL,NULL),(251,154,'AP','2102732601',0,'2013-12-25 17:19:00',NULL,NULL),(10216,6676,'EM','crew.of.akellg1@gmail.com',0,'2013-12-26 01:01:15',NULL,NULL),(22314,14384,'EM','avatar2011@gmail.com',0,'2013-12-28 03:30:51',NULL,NULL),(1306,797,'TE','9725240040',0,'2013-12-25 18:05:27',NULL,NULL),(20539,13221,'TE','9567915330',0,'2013-12-26 12:55:29',NULL,NULL),(6470,4186,'AP','2166504663',0,'2013-12-25 21:49:31',NULL,NULL),(25824,16647,'TE','2283657766',0,'2014-01-08 18:24:19',NULL,NULL),(5624,3602,'TE','4193765472',0,'2013-12-25 21:23:18',NULL,NULL),(2600,1585,'EM','ANNETT49WILL@YAHOOL.COM',0,'2013-12-25 18:51:34',NULL,NULL),(30595,19852,'TE','3307826092',0,'2014-01-24 21:00:31',NULL,NULL),(31392,20459,'TE','2163214039',0,'2014-01-29 21:00:50',NULL,NULL),(33894,22245,'AP','9012186212',0,'2014-02-09 19:00:40',NULL,NULL),(34717,22763,'TE','5138296195',0,'2014-02-11 21:01:34',NULL,NULL),(34835,22844,'EM','adahlin@bgsu.edu',0,'2014-02-11 21:02:16',NULL,NULL),(35353,23229,'TE','2169326645',0,'2014-02-12 21:32:24',NULL,NULL),(38141,25174,'EM','bowdenk14@yahoo.com',0,'2014-02-21 22:00:30',NULL,NULL),(41393,27498,'TE','4199307781',0,'2014-03-04 21:02:27',NULL,NULL),(43221,28720,'EM','sharon_shafer@yahoo.com',0,'2014-03-08 21:31:20',NULL,NULL),(944,581,'AP','4193517894',0,'2013-12-25 17:50:54',NULL,NULL),(10211,6672,'EM','napier.m36@gmail.com',0,'2013-12-26 01:01:09',NULL,NULL),(1620,995,'EM','samdesigns1@gmail.com',0,'2013-12-25 18:10:46',NULL,NULL),(26152,16838,'TE','3309281278',0,'2014-01-13 02:18:32',NULL,NULL),(1672,1026,'TE','9155913726',0,'2013-12-25 18:15:24',NULL,NULL),(24075,15543,'TE','3378736570',1,'2014-01-02 04:31:02',NULL,NULL),(4389,2797,'TE','9373029230',0,'2013-12-25 19:50:18',NULL,NULL),(5485,3509,'AP','5133839789',0,'2013-12-25 21:20:57',NULL,NULL),(7701,5023,'TE','9372160064',0,'2013-12-25 22:47:37',NULL,NULL),(21911,14115,'EM','lizmathews@me.com',0,'2013-12-27 02:01:58',NULL,NULL),(11431,7436,'EM','heidibeane@sbcglobal.net',0,'2013-12-26 02:30:17',NULL,NULL),(13808,8999,'AP','3307303575',0,'2013-12-26 04:04:50',NULL,NULL),(31019,20181,'AP','3307159367',0,'2014-01-27 21:01:20',NULL,NULL),(31458,20502,'EM','marisha.lirette1@yahoo.com',0,'2014-01-29 21:01:14',NULL,NULL),(31824,20777,'AP','9159229670',0,'2014-01-31 21:00:07',NULL,NULL),(36210,23834,'TE','5135086200',0,'2014-02-14 21:31:48',NULL,NULL),(37660,24830,'AP','5133025862',0,'2014-02-20 04:52:09',NULL,NULL),(40406,26821,'TE','7404417016',0,'2014-03-01 21:00:34',NULL,NULL),(27929,17994,'TE','5137717998',0,'2014-01-15 02:06:58',NULL,NULL),(26980,17353,'AP','3184524368',0,'2014-01-13 02:24:10',NULL,NULL),(2123,1309,'EM','fdpsports@gmail.com',0,'2013-12-25 18:31:25',NULL,NULL),(10872,7057,'EM','among3roses@icloud.com',0,'2013-12-26 01:49:51',NULL,NULL),(24729,15952,'EM','chrisdlee@gmail.com',0,'2014-01-04 02:00:09',NULL,NULL),(9288,6085,'TE','3302040649',0,'2013-12-26 00:02:35',NULL,NULL),(21872,14091,'TE','5137940028',0,'2013-12-27 02:01:21',NULL,NULL),(14737,9640,'TE','5125678879',0,'2013-12-26 04:38:28',NULL,NULL),(12423,8135,'EM','siborkovic@gmail.com',0,'2013-12-26 03:15:40',NULL,NULL),(28597,18433,'AP','3185030615',0,'2014-01-16 08:45:59',NULL,NULL),(29118,18805,'TE','6142056662',0,'2014-01-17 03:36:01',NULL,NULL),(31006,20171,'TE','3305539616',0,'2014-01-27 21:01:15',NULL,NULL),(31984,20881,'AP','9377630490',0,'2014-01-31 21:01:09',NULL,NULL),(33182,21731,'TE','9402820573',0,'2014-02-06 21:00:09',NULL,NULL),(37579,24756,'TE','7405027990',0,'2014-02-20 04:42:12',NULL,NULL),(38470,25424,'AP','6787402716',0,'2014-02-25 21:31:11',NULL,NULL),(9807,6418,'EM','eames23@yahoo.com',0,'2013-12-26 00:48:48',NULL,NULL),(27441,17677,'AP','5042522765',0,'2014-01-14 01:32:52',NULL,NULL),(8727,5725,'TE','2253642678',0,'2013-12-25 23:45:31',NULL,NULL),(5537,3539,'EM','waynelowe@reagan.com',0,'2013-12-25 21:21:44',NULL,NULL),(20638,13275,'AP','9032383473',0,'2013-12-26 12:57:02',NULL,NULL),(6179,3982,'TE','4193062071',0,'2013-12-25 21:38:51',NULL,NULL),(14888,9744,'AP','2149302724',0,'2013-12-26 04:46:01',NULL,NULL),(14277,9339,'EM','whitney.ellsworth@yahoo.com',0,'2013-12-26 04:30:58',NULL,NULL),(29944,19378,'AP','6013412768',1,'2014-01-22 03:22:40',NULL,NULL),(30802,20029,'TE','5044109745',0,'2014-01-26 19:00:19',NULL,NULL),(12168,7949,'AP','5049391254',0,'2013-12-26 03:07:07',NULL,NULL),(28256,18220,'EM','angelofthefortunate@gmail.com',0,'2014-01-16 08:44:13',NULL,NULL),(34514,22641,'TE','9363980048',0,'2014-02-11 21:00:23',NULL,NULL),(35198,23117,'TE','2167737060',0,'2014-02-12 21:31:22',NULL,NULL),(38799,25652,'TE','5136751832',0,'2014-02-26 08:30:39',NULL,NULL),(40326,26763,'TE','4402863492',0,'2014-03-01 19:00:09',NULL,NULL),(41928,27875,'EM','Genamcghee@bellsouth.net',0,'2014-03-05 21:32:28',NULL,NULL),(23095,14893,'AP','2252760012',0,'2013-12-30 00:00:52',NULL,NULL),(22652,14607,'TE','4195775992',0,'2013-12-28 03:36:32',NULL,NULL),(9782,6401,'EM','GI-KI@cinci.rr.com',0,'2013-12-26 00:48:21',NULL,NULL),(9679,6341,'EM','twincam88@windstream.net',0,'2013-12-26 00:46:47',NULL,NULL),(14001,9140,'EM','sarajcompton@gmail.com',0,'2013-12-26 04:08:10',NULL,NULL),(13714,8936,'AP','9373717143',0,'2013-12-26 04:03:12',NULL,NULL),(6970,4544,'EM','cindy.rogers1119@gmail.com',0,'2013-12-25 22:04:23',NULL,NULL),(784,490,'AP','8322061430',0,'2013-12-25 17:48:23',NULL,NULL),(6711,4363,'TE','3303260129',0,'2013-12-25 22:00:05',NULL,NULL),(994,612,'EM','hondojon@msn.com',0,'2013-12-25 18:00:37',NULL,NULL),(13712,8935,'EM','TRJMole@hotmail.com',0,'2013-12-26 04:03:11',NULL,NULL),(3876,2463,'EM','mrdj14@bellsouth.net',0,'2013-12-25 19:35:01',NULL,NULL),(1395,853,'AP','4192343848',0,'2013-12-25 18:06:58',NULL,NULL),(3217,2024,'TE','3303510283',0,'2013-12-25 19:15:10',NULL,NULL),(28358,18274,'EM','robjaskula@aol.com',0,'2014-01-16 08:44:43',NULL,NULL),(29453,19044,'TE','4193204226',0,'2014-01-20 08:06:39',NULL,NULL),(30492,19780,'TE','4199137997',0,'2014-01-23 21:01:33',NULL,NULL),(33077,21666,'AP','3186641308',0,'2014-02-05 21:30:57',NULL,NULL),(33513,21965,'AP','9377070358',0,'2014-02-07 19:00:28',NULL,NULL),(34894,22899,'TE','5672304299',0,'2014-02-11 21:02:40',NULL,NULL),(35542,23373,'TE','5134850560',0,'2014-02-13 22:00:55',NULL,NULL),(35782,23531,'AP','3185422391',0,'2014-02-13 22:02:26',NULL,NULL),(36299,23899,'AP','9379023187',0,'2014-02-14 21:32:23',NULL,NULL),(41692,27724,'BN','9155405370',0,'2014-03-05 21:31:00',NULL,NULL),(42692,28399,'EM','archiekaren@gmail.com',0,'2014-03-07 21:30:49',NULL,NULL),(43098,28651,'AP','3134670133',0,'2014-03-08 21:30:38',NULL,NULL),(43303,28768,'BN','4192467197',0,'2014-03-09 21:00:28',NULL,NULL),(43612,28952,'BN','9852652474',0,'2014-03-10 21:00:51',NULL,NULL),(25739,16588,'AP','9856346280',0,'2014-01-08 18:24:00',NULL,NULL),(26357,16964,'TE','4405525286',0,'2014-01-13 02:20:09',NULL,NULL),(23685,15292,'TE','9858568297',1,'2014-01-02 04:22:30',NULL,NULL),(2333,1422,'TE','5048992026',0,'2013-12-25 18:47:17',NULL,NULL),(4098,2613,'EM','rgdale16@yahoo.com',0,'2013-12-25 19:45:40',NULL,NULL),(6422,4151,'TE','7403982305',0,'2013-12-25 21:48:45',NULL,NULL),(22513,14515,'EM','hjones1259@gmail.com',0,'2013-12-28 03:34:10',NULL,NULL),(21990,14164,'AP','3372876713',0,'2013-12-27 02:03:15',NULL,NULL),(26907,17309,'EM','dawnmick@yahoo.com',0,'2014-01-13 02:23:43',NULL,NULL),(31020,20182,'TE','7178757469',0,'2014-01-27 21:01:21',NULL,NULL),(31260,20365,'AP','4193418760',0,'2014-01-28 21:01:23',NULL,NULL),(33660,22079,'AP','5046386393',0,'2014-02-08 19:00:18',NULL,NULL),(35996,23680,'TE','2256342941',0,'2014-02-14 21:30:30',NULL,NULL),(36127,23777,'TE','2283265508',0,'2014-02-14 21:31:17',NULL,NULL),(36314,23911,'AP','9372152915',0,'2014-02-14 21:32:29',NULL,NULL),(37475,24678,'AP','9365911036',0,'2014-02-20 04:29:30',NULL,NULL),(38791,25645,'AP','5136751832',0,'2014-02-26 08:30:34',NULL,NULL),(39308,26003,'TE','3189943023',0,'2014-02-26 21:02:05',NULL,NULL),(43412,28829,'TE','4192867822',0,'2014-03-09 21:01:06',NULL,NULL),(25890,16689,'AP','8174581487',0,'2014-01-08 18:24:34',NULL,NULL),(25307,16319,'AP','2253248672',0,'2014-01-07 04:01:40',NULL,NULL),(24377,15742,'TE','9567405543',0,'2014-01-03 02:00:52',NULL,NULL),(1492,917,'AP','5136040913',0,'2013-12-25 18:08:43',NULL,NULL),(24120,15572,'TE','3307497816',1,'2014-01-02 04:31:55',NULL,NULL),(7436,4843,'TE','4196605722',0,'2013-12-25 22:30:10',NULL,NULL),(10434,6801,'AP','9376060344',0,'2013-12-26 01:17:25',NULL,NULL),(10610,6904,'TE','5044521882',0,'2013-12-26 01:45:43',NULL,NULL),(14006,9145,'AP','3304148868',0,'2013-12-26 04:08:17',NULL,NULL),(13772,8978,'TE','3307241074',0,'2013-12-26 04:04:14',NULL,NULL),(27476,17700,'TE','8593965716',0,'2014-01-14 01:33:04',NULL,NULL),(28104,18113,'EM','drtim@rockwoodcrewing.tv',0,'2014-01-15 02:07:38',NULL,NULL),(28519,18384,'TE','8596638335',0,'2014-01-16 08:45:36',NULL,NULL),(30577,19839,'AP','3184981478',0,'2014-01-24 21:00:24',NULL,NULL),(32150,21001,'AP','5136525913',0,'2014-02-01 19:00:29',NULL,NULL),(32980,21590,'AP','4194181289',0,'2014-02-05 21:30:29',NULL,NULL),(36861,24275,'AP','7405164681',0,'2014-02-18 21:30:03',NULL,NULL),(37041,24392,'AP','4404093822',0,'2014-02-18 22:00:50',NULL,NULL),(39797,26311,'AP','9562813392',0,'2014-02-28 06:31:33',NULL,NULL),(41244,27396,'TE','7407512901',0,'2014-03-04 21:01:29',NULL,NULL),(41985,27908,'TE','8179649286',0,'2014-03-06 21:00:13',NULL,NULL),(1397,854,'TE','4193066159',0,'2013-12-25 18:07:00',NULL,NULL),(26161,16844,'AP','3308081587',0,'2014-01-13 02:18:35',NULL,NULL),(22639,14597,'AP','9376570261',0,'2013-12-28 03:36:18',NULL,NULL),(9842,6437,'AP','3372870940',0,'2013-12-26 00:49:21',NULL,NULL),(3838,2442,'TE','3307533423',0,'2013-12-25 19:34:28',NULL,NULL),(5765,3692,'AP','4193413302',0,'2013-12-25 21:31:45',NULL,NULL),(9136,5984,'TE','9373240382',0,'2013-12-25 23:52:01',NULL,NULL),(8160,5340,'TE','4194829852',0,'2013-12-25 23:07:20',NULL,NULL),(8047,5268,'TE','3309906159',0,'2013-12-25 23:05:31',NULL,NULL),(27729,17872,'EM','kushner@mail.com',0,'2014-01-15 02:06:14',NULL,NULL),(32498,21239,'TE','5138251441',0,'2014-02-03 21:01:12',NULL,NULL),(32913,21547,'AP','7405072935',0,'2014-02-05 21:30:12',NULL,NULL),(33154,21715,'EM','mharmon1@woh.rr.com',0,'2014-02-05 21:31:17',NULL,NULL),(35320,23208,'TE','9373822874',0,'2014-02-12 21:32:12',NULL,NULL),(35670,23460,'TE','9565685866',0,'2014-02-13 22:01:42',NULL,NULL),(35720,23491,'TE','4197383129',0,'2014-02-13 22:02:02',NULL,NULL),(35811,23548,'AP','8325731388',0,'2014-02-13 22:02:37',NULL,NULL),(36193,23823,'TE','4199174360',0,'2014-02-14 21:31:42',NULL,NULL),(36997,24358,'TE','5045123024',0,'2014-02-18 22:00:31',NULL,NULL),(37036,24389,'EM','sarahmolloy81@gmail.com',0,'2014-02-18 22:00:48',NULL,NULL),(24985,16102,'TE','2405388660',0,'2014-01-04 02:04:50',NULL,NULL),(21917,14120,'TE','2163907507',0,'2013-12-27 02:02:05',NULL,NULL),(1261,766,'TE','2547644290',0,'2013-12-25 18:04:42',NULL,NULL),(2166,1332,'TE','9373935578',0,'2013-12-25 18:32:09',NULL,NULL),(21834,14066,'AP','5132911269',0,'2013-12-27 02:00:43',NULL,NULL),(5481,3507,'EM','dmsik@aol.com',0,'2013-12-25 21:20:54',NULL,NULL),(5806,3728,'AP','5128500592',0,'2013-12-25 21:32:32',NULL,NULL),(5961,3826,'EM','julieerudd@gmail.com',0,'2013-12-25 21:35:05',NULL,NULL),(5440,3483,'AP','4403464401',0,'2013-12-25 21:20:14',NULL,NULL),(27968,18031,'TE','2167021340',0,'2014-01-15 02:07:08',NULL,NULL),(31933,20844,'AP','4193709481',0,'2014-01-31 21:00:49',NULL,NULL),(35507,23350,'TE','3306072991',0,'2014-02-13 22:00:41',NULL,NULL),(37414,24639,'AP','8323969446',0,'2014-02-20 04:19:57',NULL,NULL),(41919,27870,'AP','4199574062',0,'2014-03-05 21:32:25',NULL,NULL),(43108,28655,'EM','ironcityinc@yahoo.com',0,'2014-03-08 21:30:41',NULL,NULL),(690,428,'TE','6144249609',0,'2013-12-25 17:46:51',NULL,NULL),(26526,17065,'TE','2143742122',0,'2014-01-13 02:21:14',NULL,NULL),(26219,16876,'AP','3252777845',0,'2014-01-13 02:19:19',NULL,NULL),(25625,16525,'AP','4105624782',1,'2014-01-07 10:21:53',NULL,NULL),(23250,14982,'AP','8176029368',0,'2014-01-01 12:01:07',NULL,NULL),(9844,6438,'TE','3375776496',0,'2013-12-26 00:49:22',NULL,NULL),(22885,14766,'AP','3258647339',1,'2013-12-29 11:12:49',NULL,NULL),(10579,6885,'AP','6127083995',0,'2013-12-26 01:45:12',NULL,NULL),(22230,14327,'EM','latriciaelliott@gmail.com',0,'2013-12-27 02:07:27',NULL,NULL),(11361,7400,'AP','4199449523',0,'2013-12-26 02:16:24',NULL,NULL),(13672,8912,'EM','pat.sherman@att.net',0,'2013-12-26 04:02:36',NULL,NULL),(14339,9374,'AP','5046387646',0,'2013-12-26 04:31:54',NULL,NULL),(14642,9580,'TE','3303759731',0,'2013-12-26 04:36:52',NULL,NULL),(20414,13145,'TE','4404778231',0,'2013-12-26 12:53:26',NULL,NULL),(28197,18173,'TE','4195411379',0,'2014-01-15 02:07:58',NULL,NULL),(28832,18613,'TE','4196199227',0,'2014-01-16 08:47:24',NULL,NULL),(29146,18829,'TE','6018137679',0,'2014-01-17 03:36:09',NULL,NULL),(30292,19624,'EM','djd3970@gmail.com',0,'2014-01-23 21:00:06',NULL,NULL),(31093,20241,'TE','6628089697',0,'2014-01-28 21:00:08',NULL,NULL),(38538,25466,'AP','2819196568',0,'2014-02-25 21:31:34',NULL,NULL),(40147,26627,'AP','9729891283',0,'2014-02-28 21:30:55',NULL,NULL),(41081,27289,'TE','2542661941',0,'2014-03-04 21:00:27',NULL,NULL),(23436,15104,'TE','5132442601',0,'2014-01-01 12:04:46',NULL,NULL),(23424,15089,'TE','3174453843',0,'2014-01-01 12:04:25',NULL,NULL),(13662,8906,'EM','jacobmattes2@aol.com',0,'2013-12-26 04:02:27',NULL,NULL),(11083,7200,'TE','5042655610',0,'2013-12-26 02:00:37',NULL,NULL),(1398,854,'AP','4193066159',0,'2013-12-25 18:07:00',NULL,NULL),(9405,6156,'EM','sbutorsky@comcast.net',0,'2013-12-26 00:16:39',NULL,NULL),(8362,5496,'TE','4194767943',0,'2013-12-25 23:11:11',NULL,NULL),(2135,1318,'TE','2165771692',0,'2013-12-25 18:31:37',NULL,NULL),(3586,2247,'TE','3308981085',0,'2013-12-25 19:21:10',NULL,NULL),(4160,2654,'TE','6143123823',0,'2013-12-25 19:46:42',NULL,NULL),(5907,3790,'TE','5136832715',0,'2013-12-25 21:34:12',NULL,NULL),(4194,2683,'TE','7407013835',0,'2013-12-25 19:47:16',NULL,NULL),(27328,17598,'TE','6018456305',0,'2014-01-14 01:32:14',NULL,NULL),(30692,19939,'TE','9373029230',0,'2014-01-24 21:01:13',NULL,NULL),(33962,22282,'AP','6147692452',0,'2014-02-10 11:00:23',NULL,NULL),(34557,22663,'EM','jjstock@sbcglobal.net',0,'2014-02-11 21:00:36',NULL,NULL),(36472,24012,'EM','nparish86@gmail.com',0,'2014-02-15 22:00:41',NULL,NULL),(36553,24065,'EM','joy5262@fuse.net',0,'2014-02-15 22:01:12',NULL,NULL),(38162,25186,'EM','shapiraialimi@yahoo.com',0,'2014-02-21 22:00:37',NULL,NULL),(42903,28532,'TE','5138711438',0,'2014-03-07 21:32:08',NULL,NULL),(2528,1548,'TE','6018181254',0,'2013-12-25 18:50:31',NULL,NULL),(25159,16218,'AP','5135825103',0,'2014-01-05 00:01:43',NULL,NULL),(3587,2249,'TE','5132380232',0,'2013-12-25 19:30:03',NULL,NULL),(3662,2325,'EM','scott.slaughter17@outlook.com',0,'2013-12-25 19:31:31',NULL,NULL),(4089,2609,'TE','2163396529',0,'2013-12-25 19:45:33',NULL,NULL),(10071,6584,'AP','5134624316',0,'2013-12-26 00:53:03',NULL,NULL),(22289,14365,'AP','4192393641',0,'2013-12-28 03:30:23',NULL,NULL),(22094,14230,'EM','kylepritchett915@gmail.com',0,'2013-12-27 02:04:59',NULL,NULL),(25897,16691,'EM','suznardi@yahoo.com',0,'2014-01-08 18:24:35',NULL,NULL),(4681,2992,'AP','6143594959',0,'2013-12-25 20:17:29',NULL,NULL),(20965,13486,'TE','4402213935',0,'2013-12-26 13:02:22',NULL,NULL),(4864,3113,'TE','9729183435',0,'2013-12-25 20:30:05',NULL,NULL),(7546,4915,'EM','ltshdent@yahoo.com',0,'2013-12-25 22:32:14',NULL,NULL),(31930,20843,'AP','4404786457',0,'2014-01-31 21:00:48',NULL,NULL),(34142,22387,'EM','nb626@rocketmail.com',0,'2014-02-10 21:30:12',NULL,NULL),(35774,23525,'TE','3377949880',0,'2014-02-13 22:02:23',NULL,NULL),(36447,24000,'AP','6147726261',0,'2014-02-15 22:00:33',NULL,NULL),(38594,25504,'TE','3307339766',0,'2014-02-25 21:31:57',NULL,NULL),(39001,25789,'TE','5137422127',0,'2014-02-26 09:31:08',NULL,NULL),(40542,26907,'EM','TIMLUWIS906@GMAIL.COM',0,'2014-03-03 01:00:10',NULL,NULL),(40626,26967,'TE','9562454395',0,'2014-03-03 01:00:33',NULL,NULL),(43159,28683,'AP','4095948390',0,'2014-03-08 21:30:58',NULL,NULL),(25419,16395,'TE','2108836426',0,'2014-01-07 04:03:42',NULL,NULL),(22307,14377,'EM','analogueracket@gmail.com',0,'2013-12-28 03:30:42',NULL,NULL),(10223,6681,'EM','Mryanfisher@gmail.com',0,'2013-12-26 01:01:25',NULL,NULL),(5682,3648,'EM','wsawatsky76@netzero.net',0,'2013-12-25 21:30:35',NULL,NULL),(10762,6997,'TE','9799683416',0,'2013-12-26 01:48:09',NULL,NULL),(6262,4042,'TE','4198606105',0,'2013-12-25 21:46:07',NULL,NULL),(8988,5895,'AP','5132844521',0,'2013-12-25 23:49:43',NULL,NULL),(5538,3540,'TE','9152490494',0,'2013-12-25 21:21:45',NULL,NULL),(5491,3511,'EM','jbs2184@aol.com',0,'2013-12-25 21:21:02',NULL,NULL),(31496,20523,'EM','snaustin2@yahoo.com',0,'2014-01-29 21:01:26',NULL,NULL),(33107,21688,'AP','5046445385',0,'2014-02-05 21:31:05',NULL,NULL),(35427,23289,'AP','3304647962',0,'2014-02-13 22:00:06',NULL,NULL),(35753,23514,'TE','6015732246',0,'2014-02-13 22:02:16',NULL,NULL),(35827,23561,'EM','mpark6868@bex.net',0,'2014-02-13 22:02:44',NULL,NULL),(36865,24278,'TE','5136926091',0,'2014-02-18 21:30:05',NULL,NULL),(39242,25959,'AP','9372545987',0,'2014-02-26 21:01:41',NULL,NULL),(39463,26096,'AP','7194860057',0,'2014-02-28 06:30:11',NULL,NULL),(41743,27757,'EM','danielle.billon@gmail.com',0,'2014-03-05 21:31:18',NULL,NULL),(43678,28989,'TE','3304920487',0,'2014-03-10 21:01:13',NULL,NULL),(9158,5997,'AP','2253296855',0,'2013-12-26 00:00:15',NULL,NULL),(2204,1353,'AP','2145345845',0,'2013-12-25 18:45:20',NULL,NULL),(24176,15620,'EM','vallerie1@aol.com',1,'2014-01-02 04:33:08',NULL,NULL),(22748,14670,'AP','9153566996',1,'2013-12-29 11:08:14',NULL,NULL),(1108,679,'AP','3303127825',0,'2013-12-25 18:02:21',NULL,NULL),(21629,13924,'TE','4085137354',0,'2013-12-26 13:14:15',NULL,NULL),(14240,9316,'AP','3189534530',0,'2013-12-26 04:30:23',NULL,NULL),(29414,19016,'EM','rlavene@bellsouth.net',0,'2014-01-20 08:06:22',NULL,NULL),(30671,19917,'TE','5124617807',0,'2014-01-24 21:01:03',NULL,NULL),(30836,20045,'EM','thomasadale@yahoo.com',0,'2014-01-26 19:00:30',NULL,NULL),(31193,20314,'AP','8322842506',0,'2014-01-28 21:00:51',NULL,NULL),(33097,21680,'TE','5133073829',0,'2014-02-05 21:31:02',NULL,NULL),(34601,22688,'EM','ron@iceloungesa.com',0,'2014-02-11 21:00:51',NULL,NULL),(35993,23679,'TE','2252908454',0,'2014-02-14 21:30:29',NULL,NULL),(39375,26041,'TE','4404767132',0,'2014-02-26 21:02:27',NULL,NULL),(42108,27976,'AP','5045353173',0,'2014-03-06 21:00:53',NULL,NULL),(7357,4781,'EM','adra08@live.com',0,'2013-12-25 22:16:08',NULL,NULL),(3544,2221,'TE','4195368211',0,'2013-12-25 19:20:31',NULL,NULL),(22462,14486,'TE','4094895605',0,'2013-12-28 03:33:24',NULL,NULL),(20299,13084,'TE','7403599350',0,'2013-12-26 12:51:40',NULL,NULL),(11997,7815,'TE','9035092391',0,'2013-12-26 03:04:04',NULL,NULL),(11503,7486,'TE','6145375124',0,'2013-12-26 02:31:29',NULL,NULL),(11042,7165,'TE','9175175611',0,'2013-12-26 01:52:37',NULL,NULL),(27684,17844,'EM','carmaw3738@att.net',0,'2014-01-15 02:06:04',NULL,NULL),(31705,20685,'AP','4323609313',0,'2014-01-30 21:00:56',NULL,NULL),(37218,24493,'AP','5123633330',0,'2014-02-20 03:45:48',NULL,NULL),(37733,24884,'EM','kkontout@cinci.rr.com',0,'2014-02-20 05:37:30',NULL,NULL),(38356,25336,'AP','3187944861',0,'2014-02-25 21:30:22',NULL,NULL),(9756,6379,'EM','lynn.frank3@gmail.com',0,'2013-12-26 00:47:53',NULL,NULL),(9638,6307,'TE','7405873115',0,'2013-12-26 00:46:04',NULL,NULL),(26126,16822,'TE','9857892506',0,'2014-01-13 02:18:23',NULL,NULL),(9069,5944,'AP','9377081636',0,'2013-12-25 23:50:56',NULL,NULL),(6725,4370,'EM','alliebgolden@yahoo.com',0,'2013-12-25 22:00:18',NULL,NULL),(25110,16188,'AP','2105772409',0,'2014-01-05 00:00:45',NULL,NULL),(23650,15272,'AP','3308124760',1,'2014-01-02 04:21:51',NULL,NULL),(11137,7239,'AP','5046549119',0,'2013-12-26 02:01:38',NULL,NULL),(11811,7684,'TE','5134745694',0,'2013-12-26 03:00:52',NULL,NULL),(22197,14297,'AP','4194170016',0,'2013-12-27 02:06:46',NULL,NULL),(35638,23435,'AP','9562437837',0,'2014-02-13 22:01:29',NULL,NULL),(37367,24597,'TE','4197074981',0,'2014-02-20 04:12:24',NULL,NULL),(37815,24954,'AP','3373094243',0,'2014-02-20 22:00:14',NULL,NULL),(42609,28347,'EM','hairgeek1988@sbcglobal.net',0,'2014-03-07 21:30:20',NULL,NULL),(43442,28849,'EM','dude41@att.net',0,'2014-03-09 21:01:18',NULL,NULL),(1128,693,'TE','7078158061',0,'2013-12-25 18:02:42',NULL,NULL),(23577,15221,'TE','2255058109',0,'2014-01-01 12:08:02',NULL,NULL),(10842,7039,'TE','2813810318',0,'2013-12-26 01:49:21',NULL,NULL),(2563,1565,'TE','9366155172',0,'2013-12-25 18:51:01',NULL,NULL),(20203,13017,'TE','2169387697',0,'2013-12-26 12:49:57',NULL,NULL),(5234,3363,'TE','5127879347',0,'2013-12-25 21:17:03',NULL,NULL),(5482,3508,'TE','9372728903',0,'2013-12-25 21:20:54',NULL,NULL),(13908,9067,'AP','5129199061',0,'2013-12-26 04:06:31',NULL,NULL),(12380,8108,'TE','9374443222',0,'2013-12-26 03:11:02',NULL,NULL),(11347,7390,'AP','3303077707',0,'2013-12-26 02:16:09',NULL,NULL),(11587,7540,'EM','s.hollingsworth77@gmail.com',0,'2013-12-26 02:32:53',NULL,NULL),(29051,18758,'TE','8327668052',0,'2014-01-17 03:35:46',NULL,NULL),(29677,19178,'AP','5126745889',0,'2014-01-21 08:46:06',NULL,NULL),(32857,21503,'TE','5138437097',0,'2014-02-04 21:01:53',NULL,NULL),(37560,24735,'TE','6142958723',0,'2014-02-20 04:39:48',NULL,NULL),(38435,25401,'TE','3306318527',0,'2014-02-25 21:30:56',NULL,NULL),(43013,28602,'AP','6144195487',0,'2014-03-08 21:30:10',NULL,NULL),(20633,13273,'TE','2814033470',0,'2013-12-26 12:56:58',NULL,NULL),(10540,6865,'AP','2167026085',0,'2013-12-26 01:31:48',NULL,NULL),(1559,961,'TE','9092828155',0,'2013-12-25 18:09:47',NULL,NULL),(39116,25876,'TE','5042749069',0,'2014-02-26 21:00:54',NULL,NULL),(39565,26177,'TE','3303481476',0,'2014-02-28 06:30:38',NULL,NULL),(41278,27427,'EM','LATOMRED@YAHOO.COM',0,'2014-03-04 21:01:44',NULL,NULL),(108,64,'TE','2166475041',0,'2013-12-25 17:16:44',NULL,NULL),(8656,5687,'TE','4403828256',0,'2013-12-25 23:32:29',NULL,NULL),(8390,5521,'AP','6149464985',0,'2013-12-25 23:15:20',NULL,NULL),(14883,9740,'TE','8175006172',0,'2013-12-26 04:45:55',NULL,NULL),(10537,6861,'TE','3305444983',0,'2013-12-26 01:31:41',NULL,NULL),(6979,4551,'TE','3308875226',0,'2013-12-25 22:04:32',NULL,NULL),(2457,1508,'TE','9376233664',0,'2013-12-25 18:49:26',NULL,NULL),(6378,4107,'AP','2812169191',0,'2013-12-25 21:47:54',NULL,NULL),(26871,17291,'TE','3617797652',0,'2014-01-13 02:23:33',NULL,NULL),(29880,19336,'AP','5592698817',1,'2014-01-22 03:22:19',NULL,NULL),(30880,20071,'EM','gracie_montes2007@yahoo.com',0,'2014-01-27 21:00:18',NULL,NULL),(35403,23268,'EM','tnwanne1@gmail.com',0,'2014-02-13 21:30:13',NULL,NULL),(35466,23326,'TE','4406938090',0,'2014-02-13 22:00:27',NULL,NULL),(36251,23856,'EM','Matthiashelfen@gmail.com',0,'2014-02-14 21:32:02',NULL,NULL),(37445,24653,'AP','4196809902',0,'2014-02-20 04:23:54',NULL,NULL),(25022,16125,'TE','2253485774',0,'2014-01-04 02:05:32',NULL,NULL),(798,497,'TE','3184232280',0,'2013-12-25 17:48:35',NULL,NULL),(20214,13022,'EM','davidgraham341@gmail.com',0,'2013-12-26 12:50:07',NULL,NULL),(2616,1592,'AP','9152619583',0,'2013-12-25 18:51:47',NULL,NULL),(3150,1967,'TE','8177829692',0,'2013-12-25 19:01:23',NULL,NULL),(14969,9792,'AP','2252818115',0,'2013-12-26 05:01:01',NULL,NULL),(4683,2994,'AP','9376043293',0,'2013-12-25 20:17:32',NULL,NULL),(13638,8892,'EM','alambert020881@gmail.com',0,'2013-12-26 04:02:03',NULL,NULL),(9466,6194,'EM','coree.corbin@yahoo.com',0,'2013-12-26 00:30:25',NULL,NULL),(3853,2453,'EM','PEREZBRE.BP@GMAIL.COM',0,'2013-12-25 19:34:42',NULL,NULL),(29507,19075,'TE','3183234906',0,'2014-01-21 08:44:23',NULL,NULL),(29523,19083,'AP','4197639068',0,'2014-01-21 08:44:28',NULL,NULL),(33299,21807,'TE','3306717952',0,'2014-02-06 21:00:52',NULL,NULL),(33726,22128,'TE','5137487645',0,'2014-02-08 19:00:42',NULL,NULL),(20514,13206,'EM','Tranthacht@gmail.com',0,'2013-12-26 12:55:06',NULL,NULL),(793,494,'AP','3372775766',0,'2013-12-25 17:48:30',NULL,NULL),(13770,8977,'TE','4198893730',0,'2013-12-26 04:04:13',NULL,NULL),(8195,5362,'EM','jim4355@prodigy.net',0,'2013-12-25 23:07:54',NULL,NULL),(3176,1993,'TE','8176816774',0,'2013-12-25 19:02:00',NULL,NULL),(7171,4676,'TE','3374592811',0,'2013-12-25 22:07:45',NULL,NULL),(13769,8975,'AP','4198893730',0,'2013-12-26 04:04:10',NULL,NULL),(28878,18645,'TE','9565427844',0,'2014-01-17 03:35:08',NULL,NULL),(31786,20748,'TE','2394501641',0,'2014-01-30 21:01:28',NULL,NULL),(33388,21877,'TE','2253150448',0,'2014-02-06 21:01:29',NULL,NULL),(36150,23794,'TE','3304672845',0,'2014-02-14 21:31:26',NULL,NULL),(37785,24938,'TE','5048586558',0,'2014-02-20 21:30:24',NULL,NULL),(39157,25901,'TE','9722282687',0,'2014-02-26 21:01:08',NULL,NULL),(39227,25948,'TE','4409542680',0,'2014-02-26 21:01:35',NULL,NULL),(41859,27836,'TE','5139845898',0,'2014-03-05 21:32:04',NULL,NULL),(42892,28526,'TE','3306370342',0,'2014-03-07 21:32:04',NULL,NULL),(25722,16579,'AP','3183763196',0,'2014-01-08 18:23:57',NULL,NULL),(2748,1667,'TE','9729006354',0,'2013-12-25 18:53:47',NULL,NULL),(25641,16537,'AP','3302847216',1,'2014-01-07 10:22:13',NULL,NULL),(24548,15834,'TE','3302535132',0,'2014-01-03 02:03:57',NULL,NULL),(20317,13092,'TE','8594090497',0,'2013-12-26 12:51:55',NULL,NULL),(7498,4885,'AP','9378304154',0,'2013-12-25 22:31:22',NULL,NULL),(14872,9732,'TE','9377175706',0,'2013-12-26 04:45:44',NULL,NULL),(14351,9381,'AP','5043355904',0,'2013-12-26 04:32:06',NULL,NULL),(9363,6129,'TE','8063525850',0,'2013-12-26 00:15:58',NULL,NULL),(4060,2591,'AP','3309980303',0,'2013-12-25 19:45:06',NULL,NULL),(5247,3369,'AP','8067312355',0,'2013-12-25 21:17:12',NULL,NULL),(3760,2385,'TE','3305976112',0,'2013-12-25 19:33:08',NULL,NULL),(27641,17818,'TE','6018424775',0,'2014-01-15 02:05:55',NULL,NULL),(28683,18508,'TE','3303190742',0,'2014-01-16 08:46:32',NULL,NULL),(29079,18782,'TE','2164081129',0,'2014-01-17 03:35:53',NULL,NULL),(29224,18875,'EM','T_BONNET1@COX.NET',0,'2014-01-17 03:36:26',NULL,NULL),(29447,19038,'EM','prakashagra@gmail.com',0,'2014-01-20 08:06:36',NULL,NULL),(29720,19218,'TE','9376815310',0,'2014-01-21 08:46:25',NULL,NULL),(30135,19517,'EM','mralonzopagebrat5@gmail.com',0,'2014-01-23 03:02:17',NULL,NULL),(30397,19699,'TE','4694749597',0,'2014-01-23 21:00:46',NULL,NULL),(30417,19716,'AP','4192157829',0,'2014-01-23 21:00:55',NULL,NULL),(30699,19942,'TE','9377269233',0,'2014-01-24 21:01:16',NULL,NULL),(37975,25054,'TE','3306078638',0,'2014-02-20 22:01:19',NULL,NULL),(38038,25098,'TE','8176562553',0,'2014-02-21 21:30:09',NULL,NULL),(38418,25384,'TE','2346787578',0,'2014-02-25 21:30:48',NULL,NULL),(39140,25887,'EM','eveliopeterbilt@yahoo.com',0,'2014-02-26 21:01:01',NULL,NULL),(41460,27550,'AP','3612209726',0,'2014-03-04 21:30:11',NULL,NULL),(78,47,'EM','whitneyfmcdowell@yahoo.com',0,'2013-12-25 17:16:16',NULL,NULL),(1818,1126,'AP','2145356472',0,'2013-12-25 18:17:55',NULL,NULL),(25721,16579,'TE','3183763196',0,'2014-01-08 18:23:56',NULL,NULL),(7485,4871,'AP','3187324338',0,'2013-12-25 22:31:01',NULL,NULL),(23925,15435,'EM','missi_t1965@yahoo.com',1,'2014-01-02 04:27:54',NULL,NULL),(8436,5550,'TE','2546245024',0,'2013-12-25 23:16:08',NULL,NULL),(23304,15017,'AP','3302312938',0,'2014-01-01 12:02:11',NULL,NULL),(22793,14697,'AP','2162107411',1,'2013-12-29 11:08:58',NULL,NULL),(14152,9264,'AP','6019555838',0,'2013-12-26 04:15:25',NULL,NULL),(13743,8956,'AP','5136494573',0,'2013-12-26 04:03:44',NULL,NULL),(10580,6885,'EM','tedpope3000@gmail.com',0,'2013-12-26 01:45:13',NULL,NULL),(10206,6669,'EM','nicphillips1972@gmail.com',0,'2013-12-26 01:01:04',NULL,NULL),(27919,17988,'AP','2347884654',0,'2014-01-15 02:06:56',NULL,NULL),(29301,18932,'EM','amikaletcher@gmail.com',0,'2014-01-20 08:05:39',NULL,NULL),(29636,19147,'EM','sandovalaura8@hotmail.com',0,'2014-01-21 08:45:33',NULL,NULL),(36756,24198,'EM','DrewA@cinci.rr.com',0,'2014-02-16 19:00:17',NULL,NULL),(40660,26991,'AP','6019512299',0,'2014-03-03 01:00:42',NULL,NULL),(42134,27988,'TE','3184503742',0,'2014-03-06 21:01:02',NULL,NULL),(2235,1372,'TE','4695103399',0,'2013-12-25 18:45:49',NULL,NULL),(6505,4205,'TE','3259491880',0,'2013-12-25 21:50:01',NULL,NULL),(7704,5030,'EM','zachharmon@gmail.com',0,'2013-12-25 22:47:44',NULL,NULL),(10571,6882,'AP','3185633103',0,'2013-12-26 01:45:06',NULL,NULL),(25353,16350,'TE','3305440322',0,'2014-01-07 04:02:28',NULL,NULL),(24741,15964,'TE','7409853731',0,'2014-01-04 02:00:24',NULL,NULL),(14197,9288,'TE','3306440668',0,'2013-12-26 04:16:05',NULL,NULL),(23902,15418,'AP','8303192910',1,'2014-01-02 04:27:24',NULL,NULL),(21919,14122,'TE','6149622862',0,'2013-12-27 02:02:08',NULL,NULL),(20869,13417,'AP','6149758393',0,'2013-12-26 13:00:44',NULL,NULL),(21016,13522,'AP','3378534014',0,'2013-12-26 13:03:14',NULL,NULL),(26667,17157,'TE','3372964125',0,'2014-01-13 02:22:00',NULL,NULL),(27750,17891,'TE','4195605464',0,'2014-01-15 02:06:20',NULL,NULL),(27808,17921,'TE','5125072976',0,'2014-01-15 02:06:31',NULL,NULL),(31517,20539,'TE','3303147262',0,'2014-01-29 21:01:34',NULL,NULL),(33335,21835,'AP','2109957304',0,'2014-02-06 21:01:07',NULL,NULL),(34661,22727,'TE','5047151862',0,'2014-02-11 21:01:13',NULL,NULL),(34800,22829,'TE','3304854144',0,'2014-02-11 21:02:06',NULL,NULL),(35594,23408,'EM','rlhanna32@yahoo.com',0,'2014-02-13 22:01:14',NULL,NULL),(35867,23587,'TE','3307536335',0,'2014-02-13 22:03:00',NULL,NULL),(36438,23995,'AP','5129938855',0,'2014-02-15 22:00:29',NULL,NULL),(42215,28045,'AP','9859741154',0,'2014-03-06 21:01:34',NULL,NULL),(707,438,'EM','mark.pavich@gmail.com',0,'2013-12-25 17:47:07',NULL,NULL),(21415,13768,'TE','6014805192',0,'2013-12-26 13:10:26',NULL,NULL),(20847,13404,'TE','7405075221',0,'2013-12-26 13:00:24',NULL,NULL),(11289,7357,'EM','EARLRAYTHOMPSON@GMAIL.COM',0,'2013-12-26 02:15:17',NULL,NULL),(10168,6645,'TE','9037201835',0,'2013-12-26 01:00:26',NULL,NULL),(7577,4931,'AP','5122361833',0,'2013-12-25 22:45:26',NULL,NULL),(32902,21543,'TE','3306878875',0,'2014-02-05 21:30:10',NULL,NULL),(35476,23331,'TE','5138879759',0,'2014-02-13 22:00:31',NULL,NULL),(37333,24580,'TE','3307687293',0,'2014-02-20 04:08:30',NULL,NULL),(41900,27859,'AP','3309802061',0,'2014-03-05 21:32:18',NULL,NULL),(42240,28059,'TE','5133864317',0,'2014-03-06 21:01:42',NULL,NULL),(25053,16151,'TE','4192852740',0,'2014-01-04 02:06:14',NULL,NULL),(11740,7641,'EM','brad_hart@sbcglobal.net',0,'2013-12-26 02:46:36',NULL,NULL),(9793,6408,'TE','6144249068',0,'2013-12-26 00:48:32',NULL,NULL),(5613,3595,'TE','5134775516',0,'2013-12-25 21:23:06',NULL,NULL),(3703,2350,'TE','2148866342',0,'2013-12-25 19:32:12',NULL,NULL),(4387,2796,'AP','9373029230',0,'2013-12-25 19:50:17',NULL,NULL),(26967,17343,'TE','2283131798',0,'2014-01-13 02:24:04',NULL,NULL),(27965,18029,'AP','5136809761',0,'2014-01-15 02:07:07',NULL,NULL),(31346,20426,'TE','4407779146',0,'2014-01-29 21:00:33',NULL,NULL),(32785,21452,'TE','3308084306',0,'2014-02-04 21:01:29',NULL,NULL),(33347,21844,'TE','9372982072',0,'2014-02-06 21:01:13',NULL,NULL),(43401,28822,'EM','babcock500@roadrunner.com',0,'2014-03-09 21:01:01',NULL,NULL),(17,13,'TE','3304723123',0,'2013-12-25 17:15:19',NULL,NULL),(1870,1154,'TE','2147938030',0,'2013-12-25 18:18:43',NULL,NULL),(26038,16775,'EM','regenia.torrey@yahoo.com',0,'2014-01-08 18:25:03',NULL,NULL),(24292,15696,'TE','5133043630',1,'2014-01-02 04:35:33',NULL,NULL),(22444,14474,'EM','mamas0822@yahoo.com',0,'2013-12-28 03:33:06',NULL,NULL),(21283,13675,'TE','3303759731',0,'2013-12-26 13:08:01',NULL,NULL),(26880,17294,'AP','8457090284',0,'2014-01-13 02:23:35',NULL,NULL),(27905,17981,'TE','3309633993',0,'2014-01-15 02:06:53',NULL,NULL),(29277,18910,'TE','4195145462',0,'2014-01-17 03:36:40',NULL,NULL),(30392,19694,'TE','2146768846',0,'2014-01-23 21:00:44',NULL,NULL),(30676,19922,'TE','6625886280',0,'2014-01-24 21:01:04',NULL,NULL),(34236,22455,'AP','7137245752',0,'2014-02-10 21:30:49',NULL,NULL),(39888,26393,'EM','K.reagan724@gmail.com',0,'2014-02-28 07:00:27',NULL,NULL),(40011,26505,'AP','5138940441',0,'2014-02-28 21:00:17',NULL,NULL),(40036,26538,'AP','5136583530',0,'2014-02-28 21:30:07',NULL,NULL),(24748,15969,'TE','8062446551',0,'2014-01-04 02:00:32',NULL,NULL),(9473,6200,'TE','5136004621',0,'2013-12-26 00:30:35',NULL,NULL),(9226,6037,'TE','3187916620',0,'2013-12-26 00:01:19',NULL,NULL),(3654,2314,'EM','loriechappy@hotmail.com',0,'2013-12-25 19:31:17',NULL,NULL),(24392,15750,'TE','9365601646',0,'2014-01-03 02:01:08',NULL,NULL),(8641,5675,'EM','Whisner2004@yahoo.com',0,'2013-12-25 23:32:10',NULL,NULL),(4607,2940,'AP','4157430979',0,'2013-12-25 20:16:12',NULL,NULL),(8213,5377,'TE','3182943064',0,'2013-12-25 23:08:15',NULL,NULL),(21663,13946,'EM','jamcn123@aol.com',0,'2013-12-26 13:14:49',NULL,NULL),(7369,4794,'AP','3309624369',0,'2013-12-25 22:16:22',NULL,NULL),(10146,6633,'TE','6149461457',0,'2013-12-26 01:00:04',NULL,NULL),(20853,13406,'TE','9372486792',0,'2013-12-26 13:00:28',NULL,NULL),(20655,13283,'AP','9153293972',0,'2013-12-26 12:57:16',NULL,NULL),(14280,9341,'EM','yg_daniel@comcast.net',0,'2013-12-26 04:31:00',NULL,NULL),(30022,19443,'TE','3304378650',0,'2014-01-23 03:01:50',NULL,NULL),(34150,22390,'EM','tpillitiere@yahoo.com',0,'2014-02-10 21:30:15',NULL,NULL),(38614,25521,'TE','4193890832',0,'2014-02-25 21:32:06',NULL,NULL),(38623,25528,'EM','intensifymail@yahoo.com',0,'2014-02-25 21:32:10',NULL,NULL),(39911,26411,'AP','9406821700',0,'2014-02-28 07:00:40',NULL,NULL),(43747,29039,'AP','9372446326',0,'2014-03-10 21:01:41',NULL,NULL),(22152,14270,'AP','2285962057',0,'2013-12-27 02:06:03',NULL,NULL),(13801,8997,'TE','4403761951',0,'2013-12-26 04:04:45',NULL,NULL),(2606,1588,'AP','8065773650',0,'2013-12-25 18:51:39',NULL,NULL),(8370,5499,'AP','4199215278',0,'2013-12-25 23:11:18',NULL,NULL),(28514,18380,'TE','6148598344',0,'2014-01-16 08:45:34',NULL,NULL),(32482,21223,'TE','3187927020',0,'2014-02-03 21:01:05',NULL,NULL),(33679,22091,'AP','6017548550',0,'2014-02-08 19:00:24',NULL,NULL),(34902,22903,'TE','4195836021',0,'2014-02-11 21:02:43',NULL,NULL),(35472,23328,'EM','kgilles7@live.com',0,'2014-02-13 22:00:29',NULL,NULL),(35964,23660,'AP','2145788438',0,'2014-02-14 21:30:19',NULL,NULL),(36800,24229,'EM','renalbeginnings@yahoo.com',0,'2014-02-16 19:00:33',NULL,NULL),(40512,26887,'TE','5672598391',0,'2014-03-03 01:00:02',NULL,NULL),(41882,27849,'TE','9364394543',0,'2014-03-05 21:32:12',NULL,NULL),(42475,28231,'TE','4196971548',0,'2014-03-06 21:30:23',NULL,NULL),(22311,14383,'AP','6145841742',0,'2013-12-28 03:30:49',NULL,NULL),(21054,13542,'AP','3183340906',0,'2013-12-26 13:03:49',NULL,NULL),(26556,17081,'EM','robins32@rocketmail.com',0,'2014-01-13 02:21:23',NULL,NULL),(8149,5335,'TE','7407973432',0,'2013-12-25 23:07:11',NULL,NULL),(1067,657,'TE','9178039644',0,'2013-12-25 18:01:46',NULL,NULL),(7497,4885,'TE','9378304154',0,'2013-12-25 22:31:21',NULL,NULL),(2743,1663,'AP','9032805494',0,'2013-12-25 18:53:41',NULL,NULL),(14614,9554,'AP','9376715957',0,'2013-12-26 04:36:22',NULL,NULL),(12097,7906,'AP','5042326235',0,'2013-12-26 03:05:57',NULL,NULL),(9849,6440,'EM','roland@doubledayfinancial.com',0,'2013-12-26 00:49:26',NULL,NULL),(27447,17680,'TE','9856524456',0,'2014-01-14 01:32:54',NULL,NULL),(27637,17816,'TE','6019533955',0,'2014-01-15 02:05:54',NULL,NULL),(30062,19473,'TE','9564852363',0,'2014-01-23 03:02:00',NULL,NULL),(30383,19684,'EM','ROBINLGRANT76@GMAIL.COM',0,'2014-01-23 21:00:40',NULL,NULL),(35983,23675,'AP','3143273381',0,'2014-02-14 21:30:27',NULL,NULL),(36566,24070,'AP','2345429846',0,'2014-02-15 22:01:16',NULL,NULL),(36977,24345,'AP','3614376989',0,'2014-02-18 22:00:23',NULL,NULL),(37286,24536,'AP','2252847130',0,'2014-02-20 04:01:32',NULL,NULL),(39331,26015,'AP','2107713220',0,'2014-02-26 21:02:12',NULL,NULL),(39561,26175,'TE','7696107429',0,'2014-02-28 06:30:38',NULL,NULL),(543,339,'TE','5135456291',0,'2013-12-25 17:31:56',NULL,NULL),(23915,15431,'TE','2814582453',1,'2014-01-02 04:27:44',NULL,NULL),(8576,5638,'AP','8068936526',0,'2013-12-25 23:31:09',NULL,NULL),(894,553,'AP','8177148147',0,'2013-12-25 17:50:05',NULL,NULL),(7370,4794,'TE','3309624369',0,'2013-12-25 22:16:22',NULL,NULL),(7182,4681,'TE','3376619555',0,'2013-12-25 22:07:53',NULL,NULL),(10322,6732,'AP','4402286581',0,'2013-12-26 01:15:32',NULL,NULL),(6587,4251,'EM','limpert-conrad@roadrunner.com',0,'2013-12-25 21:51:18',NULL,NULL),(5904,3788,'TE','6148634977',0,'2013-12-25 21:34:10',NULL,NULL),(6005,3857,'AP','2252529604',0,'2013-12-25 21:35:49',NULL,NULL),(27840,17937,'TE','9152441740',0,'2014-01-15 02:06:38',NULL,NULL),(29542,19093,'TE','3308632810',0,'2014-01-21 08:44:34',NULL,NULL),(39863,26373,'TE','6145962960',0,'2014-02-28 07:00:13',NULL,NULL),(40605,26954,'TE','5678682613',0,'2014-03-03 01:00:28',NULL,NULL),(41447,27535,'TE','3302658969',0,'2014-03-04 21:30:05',NULL,NULL),(42773,28448,'AP','2252296194',0,'2014-03-07 21:31:18',NULL,NULL),(43420,28833,'AP','6014212203',0,'2014-03-09 21:01:09',NULL,NULL),(43565,28932,'TE','9372742860',0,'2014-03-10 21:00:37',NULL,NULL),(2392,1458,'EM','gbv4me@yahoo.com',0,'2013-12-25 18:48:15',NULL,NULL),(26672,17160,'TE','2252720658',0,'2014-01-13 02:22:01',NULL,NULL),(8683,5700,'AP','6019428065',0,'2013-12-25 23:32:54',NULL,NULL),(3282,2064,'TE','5138516917',0,'2013-12-25 19:16:11',NULL,NULL),(20886,13430,'EM','oceanblue87@yahoo.com',0,'2013-12-26 13:01:01',NULL,NULL),(5947,3817,'AP','7408568369',0,'2013-12-25 21:34:52',NULL,NULL),(14836,9711,'TE','5132917096',0,'2013-12-26 04:45:12',NULL,NULL),(26792,17235,'AP','2163765622',0,'2014-01-13 02:22:42',NULL,NULL),(10378,6764,'AP','3376526372',0,'2013-12-26 01:16:26',NULL,NULL),(11645,7576,'TE','4193007373',0,'2013-12-26 02:33:52',NULL,NULL),(28151,18146,'AP','9855181159',0,'2014-01-15 02:07:48',NULL,NULL),(33124,21698,'AP','3302560310',0,'2014-02-05 21:31:09',NULL,NULL),(34747,22783,'AP','5174147516',0,'2014-02-11 21:01:45',NULL,NULL),(35692,23477,'TE','9374031494',0,'2014-02-13 22:01:52',NULL,NULL),(23592,15234,'TE','3309409146',0,'2014-01-01 12:08:22',NULL,NULL),(21643,13930,'EM','johnkaszowski@gmail.com',0,'2013-12-26 13:14:27',NULL,NULL),(9102,5966,'EM','dodgequeen96@gmail.com',0,'2013-12-25 23:51:29',NULL,NULL),(4272,2730,'EM','fazangelo@aol.com',0,'2013-12-25 19:48:28',NULL,NULL),(11146,7249,'TE','9853201275',0,'2013-12-26 02:01:52',NULL,NULL),(7864,5131,'TE','2108655469',0,'2013-12-25 23:02:13',NULL,NULL),(7658,4984,'AP','8326719757',0,'2013-12-25 22:46:49',NULL,NULL),(4786,3062,'TE','3184733718',0,'2013-12-25 20:19:12',NULL,NULL),(11008,7146,'EM','janwalters4950@hotmail.com',0,'2013-12-26 01:52:04',NULL,NULL),(5137,3291,'TE','9374024292',0,'2013-12-25 21:15:32',NULL,NULL),(32298,21096,'TE','4402320209',0,'2014-02-02 19:00:31',NULL,NULL),(32427,21188,'AP','6014350792',0,'2014-02-03 21:00:47',NULL,NULL),(35396,23265,'TE','5136738802',0,'2014-02-13 21:30:11',NULL,NULL),(37830,24961,'AP','3183416457',0,'2014-02-20 22:00:19',NULL,NULL),(40769,27093,'TE','3303045712',0,'2014-03-03 21:30:18',NULL,NULL),(41413,27514,'AP','5133099125',0,'2014-03-04 21:02:35',NULL,NULL),(41754,27765,'TE','5043191593',0,'2014-03-05 21:31:23',NULL,NULL),(37302,24544,'EM','djprismplus@aol.com',0,'2014-02-20 04:03:25',NULL,NULL),(38595,25505,'TE','3309906699',0,'2014-02-25 21:31:58',NULL,NULL),(38702,25574,'EM','dhirn@icloud.com',0,'2014-02-26 08:00:33',NULL,NULL),(38852,25682,'EM','cp3080@gmail.com',0,'2014-02-26 09:30:05',NULL,NULL),(40733,27070,'AP','3373446701',0,'2014-03-03 21:30:05',NULL,NULL),(3468,2170,'EM','bruce.vanvelzel@owenscorning.com',0,'2013-12-25 19:19:09',NULL,NULL),(9711,6357,'TE','6147453001',0,'2013-12-26 00:47:15',NULL,NULL),(9961,6519,'TE','5134854408',0,'2013-12-26 00:51:21',NULL,NULL),(26811,17243,'EM','mamasbrown@gmail.com',0,'2014-01-13 02:22:47',NULL,NULL),(11378,7409,'AP','6013837742',0,'2013-12-26 02:16:41',NULL,NULL),(36831,24256,'EM','Hazel29f@yahoo.com',0,'2014-02-17 19:00:07',NULL,NULL),(38408,25376,'AP','5134776484',0,'2014-02-25 21:30:44',NULL,NULL),(38649,25542,'EM','oldtime_@hotmail.com',0,'2014-02-26 08:00:12',NULL,NULL),(25751,16595,'TE','3373498174',0,'2014-01-08 18:24:02',NULL,NULL),(32524,21262,'AP','6627197214',0,'2014-02-03 21:01:24',NULL,NULL),(31459,20503,'TE','3186740973',0,'2014-01-29 21:01:14',NULL,NULL),(8454,5561,'TE','3308372592',0,'2013-12-25 23:16:28',NULL,NULL),(8441,5555,'TE','2167693439',0,'2013-12-25 23:16:15',NULL,NULL),(22214,14320,'EM','shaun2240@neo.rr.com',0,'2013-12-27 02:07:13',NULL,NULL),(7709,5034,'TE','9372183100',0,'2013-12-25 22:47:50',NULL,NULL),(12267,8024,'TE','5139885057',0,'2013-12-26 03:08:58',NULL,NULL),(38127,25167,'TE','2165264746',0,'2014-02-21 22:00:25',NULL,NULL),(38626,25531,'TE','9036682570',0,'2014-02-26 08:00:05',NULL,NULL),(40891,27169,'AP','9155431079',0,'2014-03-03 21:31:04',NULL,NULL),(41666,27696,'EM','cliffordwiley@ymail.com',0,'2014-03-05 21:30:47',NULL,NULL),(41903,27862,'TE','2166819533',0,'2014-03-05 21:32:19',NULL,NULL),(43397,28821,'TE','6016656284',0,'2014-03-09 21:01:00',NULL,NULL),(26020,16764,'EM','nellygiannini@gmail.com',0,'2014-01-08 18:24:59',NULL,NULL),(33552,21995,'AP','3183814086',0,'2014-02-07 19:00:44',NULL,NULL),(32686,21380,'EM','dajohnson317@gmail.com',0,'2014-02-04 21:00:52',NULL,NULL),(8134,5325,'TE','3306775797',0,'2013-12-25 23:06:57',NULL,NULL),(30753,19984,'AP','6146228128',0,'2014-01-25 19:00:16',NULL,NULL),(28854,18634,'EM','Evertonpaige@hotmail.com',0,'2014-01-17 03:35:03',NULL,NULL),(10006,6547,'AP','8323721058',0,'2013-12-26 00:52:05',NULL,NULL),(42018,27928,'AP','9722730558',0,'2014-03-06 21:00:24',NULL,NULL),(21867,14086,'TE','4193683463',0,'2013-12-27 02:01:15',NULL,NULL),(36600,24096,'TE','4406176021',0,'2014-02-15 22:01:28',NULL,NULL),(32467,21212,'EM','jstewa26@gmail.com',0,'2014-02-03 21:00:59',NULL,NULL),(30443,19735,'TE','3183218960',0,'2014-01-23 21:01:08',NULL,NULL),(6840,4436,'EM','dam5775@yahoo.com',0,'2013-12-25 22:02:02',NULL,NULL),(26648,17144,'AP','3186174160',0,'2014-01-13 02:21:54',NULL,NULL),(38918,25727,'EM','cyndibw@yahoo.com',0,'2014-02-26 09:30:33',NULL,NULL),(24101,15556,'AP','6615449596',1,'2014-01-02 04:31:29',NULL,NULL),(11530,7505,'TE','5132568354',0,'2013-12-26 02:31:57',NULL,NULL),(14526,9490,'EM','Eckk1@hotmail.com',0,'2013-12-26 04:34:54',NULL,NULL),(23184,14942,'AP','2169055041',0,'2013-12-30 00:02:21',NULL,NULL),(24083,15547,'EM','Anitahart1996@gmail.com',1,'2014-01-02 04:31:09',NULL,NULL),(37917,25013,'TE','6145921031',0,'2014-02-20 22:00:53',NULL,NULL),(42859,28502,'EM','clindsay1950@hotmail.com',0,'2014-03-07 21:31:49',NULL,NULL),(43618,28955,'EM','stephenphillips10@yahoo.com',0,'2014-03-10 21:00:53',NULL,NULL),(4875,3120,'AP','9199320642',0,'2013-12-25 20:30:17',NULL,NULL),(36602,24096,'EM','cdit2005@gmail.com',0,'2014-02-15 22:01:28',NULL,NULL),(33470,21927,'TE','9362086743',0,'2014-02-07 19:00:09',NULL,NULL),(7124,4650,'AP','5134971902',0,'2013-12-25 22:07:03',NULL,NULL),(24931,16069,'TE','9372380544',0,'2014-01-04 02:03:46',NULL,NULL),(31235,20342,'TE','2162991254',0,'2014-01-28 21:01:08',NULL,NULL),(41459,27550,'TE','3612209726',0,'2014-03-04 21:30:11',NULL,NULL),(41746,27762,'TE','5043385515',0,'2014-03-05 21:31:20',NULL,NULL),(4254,2722,'TE','3372926786',0,'2013-12-25 19:48:13',NULL,NULL),(10658,6928,'EM','ash6@151flat.com',0,'2013-12-26 01:46:26',NULL,NULL),(14421,9427,'AP','3256505626',0,'2013-12-26 04:33:17',NULL,NULL),(42366,28138,'AP','4193740525',0,'2014-03-06 21:02:29',NULL,NULL),(42667,28383,'EM','RJRAMSEY711@AOL.COM',0,'2014-03-07 21:30:41',NULL,NULL),(4891,3136,'TE','3612377941',0,'2013-12-25 20:30:41',NULL,NULL),(10297,6720,'TE','9375100919',0,'2013-12-26 01:15:11',NULL,NULL),(11416,7427,'TE','3307533423',0,'2013-12-26 02:30:04',NULL,NULL),(11435,7439,'TE','2346785111',0,'2013-12-26 02:30:21',NULL,NULL),(7926,5164,'EM','tajenben@yahoo.com',0,'2013-12-25 23:03:09',NULL,NULL),(1063,655,'EM','abigailsheard2@gmail.com',0,'2013-12-25 18:01:43',NULL,NULL),(24901,16052,'TE','6145815043',0,'2014-01-04 02:03:14',NULL,NULL),(24407,15759,'AP','4324381455',0,'2014-01-03 02:01:25',NULL,NULL),(43274,28750,'TE','9564045629',0,'2014-03-09 21:00:16',NULL,NULL),(708,440,'TE','3309483142',0,'2013-12-25 17:47:09',NULL,NULL),(2009,1242,'EM','heskamp.josh@gmail.com',0,'2013-12-25 18:20:59',NULL,NULL),(1566,965,'TE','9724155299',0,'2013-12-25 18:09:53',NULL,NULL),(12472,8168,'EM','rodneykmckinley@yahoo.com',0,'2013-12-26 03:16:34',NULL,NULL),(31365,20440,'TE','6625881068',0,'2014-01-29 21:00:40',NULL,NULL),(27488,17706,'EM','DADDY4289@YAHOO.COM',0,'2014-01-14 01:33:07',NULL,NULL),(8061,5278,'EM','CSK29@ROADRUNNER.COM',0,'2013-12-25 23:05:43',NULL,NULL),(6597,4261,'TE','3303028149',0,'2013-12-25 21:51:32',NULL,NULL),(4362,2780,'EM','prhof14@gmail.com',0,'2013-12-25 19:49:51',NULL,NULL),(13834,9020,'TE','3308892291',0,'2013-12-26 04:05:18',NULL,NULL),(37404,24633,'TE','9034525671',0,'2014-02-20 04:18:29',NULL,NULL),(41052,27274,'AP','8179378761',0,'2014-03-04 21:00:18',NULL,NULL),(220,133,'EM','bennieupton@yahoo.com',0,'2013-12-25 17:18:32',NULL,NULL),(30826,20042,'TE','4193942130',0,'2014-01-26 19:00:27',NULL,NULL),(8987,5895,'TE','5132844521',0,'2013-12-25 23:49:43',NULL,NULL),(7004,4573,'EM','fr.medrano@hotmail.com',0,'2013-12-25 22:05:02',NULL,NULL),(11658,7588,'AP','9372171838',0,'2013-12-26 02:45:03',NULL,NULL),(10642,6921,'TE','3308543332',0,'2013-12-26 01:46:13',NULL,NULL),(38847,25680,'TE','9373934339',0,'2014-02-26 09:30:03',NULL,NULL),(39058,25834,'AP','2343800277',0,'2014-02-26 21:00:31',NULL,NULL),(40219,26678,'TE','3187692969',0,'2014-02-28 21:31:22',NULL,NULL),(42862,28505,'TE','6096312620',0,'2014-03-07 21:31:51',NULL,NULL),(553,344,'EM','cspowers11@gmail.com',0,'2013-12-25 17:32:03',NULL,NULL),(8498,5589,'AP','3372127216',0,'2013-12-25 23:17:12',NULL,NULL),(4828,3089,'EM','jonesk64@woh.rr.com',0,'2013-12-25 20:19:58',NULL,NULL),(12431,8140,'EM','leis_lori@yahoo.com',0,'2013-12-26 03:15:48',NULL,NULL),(23866,15402,'TE','2142893300',1,'2014-01-02 04:26:49',NULL,NULL),(801,499,'TE','6144460535',0,'2013-12-25 17:48:39',NULL,NULL),(38947,25749,'AP','4193430409',0,'2014-02-26 09:30:44',NULL,NULL),(792,494,'TE','3372775766',0,'2013-12-25 17:48:30',NULL,NULL),(37639,24808,'AP','5139811813',0,'2014-02-20 04:49:27',NULL,NULL),(36718,24176,'AP','6019421907',0,'2014-02-16 19:00:05',NULL,NULL),(36225,23842,'EM','Mal5alday@gmail.com',0,'2014-02-14 21:31:53',NULL,NULL),(25343,16344,'EM','angelmom2005@sbcglobal.net',0,'2014-01-07 04:02:19',NULL,NULL),(31181,20308,'TE','8063670271',0,'2014-01-28 21:00:47',NULL,NULL),(10929,7106,'AP','3186145019',0,'2013-12-26 01:50:54',NULL,NULL),(14576,9532,'TE','2162310662',0,'2013-12-26 04:35:48',NULL,NULL),(22590,14571,'TE','4193454534',0,'2013-12-28 03:35:32',NULL,NULL),(40247,26696,'EM','chereemoffett@gmail.com',0,'2014-02-28 21:31:31',NULL,NULL),(40293,26728,'EM','letitiawilliams04@gmail.com',0,'2014-02-28 21:31:48',NULL,NULL),(7650,4980,'AP','3613896849',0,'2013-12-25 22:46:42',NULL,NULL),(22096,14231,'AP','9374174660',0,'2013-12-27 02:05:01',NULL,NULL),(28176,18160,'AP','9372146235',0,'2014-01-15 02:07:54',NULL,NULL),(26436,17009,'TE','5132563060',0,'2014-01-13 02:20:35',NULL,NULL),(7397,4812,'AP','6143168550',0,'2013-12-25 22:16:49',NULL,NULL),(5318,3409,'EM','dalewilliams0506@yahoo.com',0,'2013-12-25 21:18:20',NULL,NULL),(12319,8055,'TE','9374175510',0,'2013-12-26 03:09:49',NULL,NULL),(24072,15540,'AP','3183414398',1,'2014-01-02 04:30:57',NULL,NULL),(6304,4062,'EM','ja2nn@aol.com',0,'2013-12-25 21:46:43',NULL,NULL),(6534,4226,'AP','9792243207',0,'2013-12-25 21:50:34',NULL,NULL),(2867,1753,'TE','5138519005',0,'2013-12-25 18:55:46',NULL,NULL),(21647,13932,'EM','jmcarr1975@yahoo.com',0,'2013-12-26 13:14:31',NULL,NULL),(37910,25006,'EM','drgio28@hotmail.com',0,'2014-02-20 22:00:49',NULL,NULL),(3115,1942,'TE','3309985578',0,'2013-12-25 19:00:43',NULL,NULL),(4249,2719,'TE','3379128949',0,'2013-12-25 19:48:08',NULL,NULL),(31680,20667,'TE','6017206781',0,'2014-01-30 21:00:47',NULL,NULL),(30499,19783,'TE','3309292176',0,'2014-01-23 21:01:36',NULL,NULL),(23331,15032,'EM','davehorn230@gmail.com',0,'2014-01-01 12:02:40',NULL,NULL),(5752,3686,'AP','9379028810',0,'2013-12-25 21:31:36',NULL,NULL),(14446,9439,'TE','5137666321',0,'2013-12-26 04:33:38',NULL,NULL),(37875,24985,'TE','9405691885',0,'2014-02-20 22:00:36',NULL,NULL),(40999,27241,'TE','5133005394',0,'2014-03-03 21:31:47',NULL,NULL),(1810,1120,'TE','5673711888',0,'2013-12-25 18:17:48',NULL,NULL),(36246,23855,'TE','7183160703',0,'2014-02-14 21:32:01',NULL,NULL),(6680,4337,'EM','LINDA402@AOL.COM',0,'2013-12-25 21:53:11',NULL,NULL),(4952,3177,'EM','Ltrejo060812@yahoo.com',0,'2013-12-25 20:31:45',NULL,NULL),(29338,18957,'TE','9723529259',0,'2014-01-20 08:05:53',NULL,NULL),(26595,17110,'TE','4196805061',0,'2014-01-13 02:21:37',NULL,NULL),(1929,1194,'TE','7402566507',0,'2013-12-25 18:19:42',NULL,NULL),(43557,28926,'TE','5673153968',0,'2014-03-10 21:00:34',NULL,NULL),(508,319,'AP','3372127216',0,'2013-12-25 17:31:19',NULL,NULL),(37014,24370,'EM','loraf1234@yahoo.com',0,'2014-02-18 22:00:38',NULL,NULL),(22342,14409,'TE','6825571773',0,'2013-12-28 03:31:24',NULL,NULL),(33750,22147,'TE','2164214403',0,'2014-02-08 19:00:52',NULL,NULL),(32295,21094,'AP','5672598987',0,'2014-02-02 19:00:30',NULL,NULL),(31456,20502,'TE','9858709939',0,'2014-01-29 21:01:13',NULL,NULL),(30824,20040,'AP','2165775359',0,'2014-01-26 19:00:26',NULL,NULL),(30246,19592,'TE','6016619187',0,'2014-01-23 03:02:45',NULL,NULL),(10712,6964,'TE','8165004878',0,'2013-12-26 01:47:20',NULL,NULL),(11433,7437,'AP','3308013014',0,'2013-12-26 02:30:19',NULL,NULL),(38031,25086,'TE','3378497970',0,'2014-02-21 21:30:03',NULL,NULL),(38530,25461,'EM','cdgreen2007@gmail.com',0,'2014-02-25 21:31:32',NULL,NULL),(42223,28049,'AP','6015734274',0,'2014-03-06 21:01:36',NULL,NULL),(8771,5749,'TE','5042504397',0,'2013-12-25 23:46:10',NULL,NULL),(35203,23122,'TE','5137450334',0,'2014-02-12 21:31:24',NULL,NULL),(32334,21121,'AP','2109121590',0,'2014-02-03 21:00:13',NULL,NULL),(31258,20363,'EM','tbearmi30@yahoo.com',0,'2014-01-28 21:01:22',NULL,NULL),(4068,2596,'EM','fraunfelter@yahoo.com',0,'2013-12-25 19:45:12',NULL,NULL),(4748,3040,'AP','3307056303',0,'2013-12-25 20:18:39',NULL,NULL),(2193,1348,'TE','8068316706',0,'2013-12-25 18:45:10',NULL,NULL),(5388,3448,'AP','4405069319',0,'2013-12-25 21:19:26',NULL,NULL),(43520,28896,'EM','clcarrifee@gmail.com',0,'2014-03-10 21:00:18',NULL,NULL),(4040,2579,'EM','mkoopman97@yahoo.com',0,'2013-12-25 19:37:56',NULL,NULL),(36925,24317,'AP','9564074776',0,'2014-02-18 22:00:06',NULL,NULL),(33782,22172,'TE','9038947361',0,'2014-02-08 19:30:05',NULL,NULL),(5180,3326,'AP','5132603815',0,'2013-12-25 21:16:10',NULL,NULL),(28103,18113,'AP','3304164214',0,'2014-01-15 02:07:38',NULL,NULL),(5584,3569,'AP','4193463100',0,'2013-12-25 21:22:31',NULL,NULL),(20775,13349,'AP','2104830832',0,'2013-12-26 12:59:10',NULL,NULL),(39057,25834,'TE','2343800277',0,'2014-02-26 21:00:31',NULL,NULL),(40580,26933,'TE','9374077861',0,'2014-03-03 01:00:21',NULL,NULL),(43652,28972,'AP','9852318050',0,'2014-03-10 21:01:03',NULL,NULL),(23363,15050,'TE','2257780482',0,'2014-01-01 12:03:15',NULL,NULL),(21753,14011,'AP','9374744557',0,'2013-12-26 13:16:23',NULL,NULL),(30431,19726,'AP','5042920997',0,'2014-01-23 21:01:03',NULL,NULL),(3523,2204,'TE','4199051000',0,'2013-12-25 19:20:07',NULL,NULL),(11243,7318,'EM','tmckinney@raymondleon.com',0,'2013-12-26 02:03:33',NULL,NULL),(39141,25889,'TE','9795677085',0,'2014-02-26 21:01:02',NULL,NULL),(42221,28048,'EM','jangreenfield11@yahoo.com',0,'2014-03-06 21:01:36',NULL,NULL),(213,128,'EM','ldearman5@gmail.com',0,'2013-12-25 17:18:24',NULL,NULL),(23805,15353,'EM','lucybawa@gmail.com',1,'2014-01-02 04:24:38',NULL,NULL),(33174,21725,'EM','bgrounds92@gmail.com',0,'2014-02-06 21:00:06',NULL,NULL),(30627,19876,'EM','frey.tricia@yahoo.com',0,'2014-01-24 21:00:44',NULL,NULL),(29407,19007,'EM','velldaboss@yahoo.com',0,'2014-01-20 08:06:19',NULL,NULL),(38111,25157,'TE','3619722890',0,'2014-02-21 22:00:20',NULL,NULL),(22555,14547,'TE','2282223269',0,'2013-12-28 03:34:55',NULL,NULL),(22255,14341,'AP','4192038649',0,'2013-12-27 02:07:54',NULL,NULL),(2842,1723,'EM','emcmaistolynch@sbcglobal.net',0,'2013-12-25 18:55:16',NULL,NULL),(21013,13520,'TE','3184526071',0,'2013-12-26 13:03:11',NULL,NULL),(25587,16505,'TE','2166817733',1,'2014-01-07 10:21:13',NULL,NULL),(9982,6533,'TE','3256723778',0,'2013-12-26 00:51:43',NULL,NULL),(7817,5103,'AP','4322518315',0,'2013-12-25 23:01:30',NULL,NULL),(23816,15364,'EM','sommerskytime@live.com',1,'2014-01-02 04:24:54',NULL,NULL),(38176,25196,'TE','2256448294',0,'2014-02-21 22:00:43',NULL,NULL),(2535,1551,'AP','6013197663',0,'2013-12-25 18:50:37',NULL,NULL),(37873,24983,'AP','8302377948',0,'2014-02-20 22:00:35',NULL,NULL),(11197,7281,'AP','8177159226',0,'2013-12-26 02:02:41',NULL,NULL),(29207,18867,'AP','5042087227',0,'2014-01-17 03:36:23',NULL,NULL),(6849,4444,'AP','6147356526',0,'2013-12-25 22:02:12',NULL,NULL),(41978,27903,'EM','mmiranda87@yahoo.com',0,'2014-03-06 21:00:11',NULL,NULL),(25727,16582,'AP','9857744969',0,'2014-01-08 18:23:58',NULL,NULL),(7756,5063,'EM','tony.elmi@yahoo.com',0,'2013-12-25 23:00:30',NULL,NULL),(23361,15049,'TE','9852246877',0,'2014-01-01 12:03:12',NULL,NULL),(27837,17935,'TE','5122229233',0,'2014-01-15 02:06:37',NULL,NULL),(29812,19289,'AP','2254732681',1,'2014-01-22 03:21:54',NULL,NULL),(32062,20936,'TE','4195758075',0,'2014-01-31 21:01:40',NULL,NULL),(5554,3550,'AP','8036064401',0,'2013-12-25 21:22:00',NULL,NULL),(26472,17037,'TE','5049142982',0,'2014-01-13 02:20:49',NULL,NULL),(33865,22228,'AP','3182787904',0,'2014-02-09 19:00:30',NULL,NULL),(13593,8862,'EM','belindalstewart@yahoo.com',0,'2013-12-26 04:01:19',NULL,NULL),(33877,22235,'TE','2814864213',0,'2014-02-09 19:00:35',NULL,NULL),(29793,19270,'TE','4192434333',0,'2014-01-21 08:46:53',NULL,NULL),(37464,24674,'TE','4199577465',0,'2014-02-20 04:27:55',NULL,NULL),(38598,25506,'TE','3308754889',0,'2014-02-25 21:31:58',NULL,NULL),(37037,24390,'TE','3303233787',0,'2014-02-18 22:00:48',NULL,NULL),(37006,24367,'AP','9856348630',0,'2014-02-18 22:00:35',NULL,NULL),(1741,1071,'TE','3304526624',0,'2013-12-25 18:16:32',NULL,NULL),(4201,2686,'EM','bhbhall1286@yahoo.com',0,'2013-12-25 19:47:22',NULL,NULL),(22736,14662,'TE','2147979494',1,'2013-12-29 11:08:02',NULL,NULL),(29997,19423,'EM','danburger216@gmail.com',1,'2014-01-22 03:23:03',NULL,NULL),(10219,6680,'TE','4197060923',0,'2013-12-26 01:01:21',NULL,NULL),(41228,27384,'TE','6018597395',0,'2014-03-04 21:01:23',NULL,NULL),(42021,27931,'TE','2147973992',0,'2014-03-06 21:00:26',NULL,NULL),(42545,28308,'TE','6622300938',0,'2014-03-07 21:00:35',NULL,NULL),(27278,17563,'TE','6147874995',0,'2014-01-14 01:31:58',NULL,NULL),(37688,24848,'EM','wandas1128@aol.com',0,'2014-02-20 04:55:01',NULL,NULL),(33851,22222,'TE','3302947817',0,'2014-02-09 19:00:27',NULL,NULL),(26062,16787,'AP','3306076955',0,'2014-01-08 18:25:08',NULL,NULL),(11701,7618,'AP','5136028120',0,'2013-12-26 02:45:50',NULL,NULL),(3110,1940,'TE','9373670122',0,'2013-12-25 19:00:39',NULL,NULL),(459,290,'TE','2147185978',0,'2013-12-25 17:30:30',NULL,NULL),(7941,5183,'TE','4198414945',0,'2013-12-25 23:03:33',NULL,NULL),(23957,15458,'EM','davidtega@gmail.com',1,'2014-01-02 04:28:35',NULL,NULL),(42618,28351,'AP','7135142287',0,'2014-03-07 21:30:23',NULL,NULL),(9329,6111,'AP','3303106840',0,'2013-12-26 00:15:27',NULL,NULL),(14930,9769,'TE','9372371946',0,'2013-12-26 05:00:24',NULL,NULL),(13756,8965,'EM','mkladydmf@yahoo.com',0,'2013-12-26 04:03:58',NULL,NULL),(12037,7851,'TE','4403276912',0,'2013-12-26 03:04:50',NULL,NULL),(31255,20360,'AP','4193762560',0,'2014-01-28 21:01:20',NULL,NULL),(11096,7208,'TE','2169128476',0,'2013-12-26 02:00:51',NULL,NULL),(42051,27945,'TE','2542131934',0,'2014-03-06 21:00:35',NULL,NULL),(42371,28140,'TE','2148665496',0,'2014-03-06 21:02:30',NULL,NULL),(27737,17883,'TE','9375030010',0,'2014-01-15 02:06:17',NULL,NULL),(25397,16380,'TE','3617228144',0,'2014-01-07 04:03:17',NULL,NULL),(36138,23783,'TE','3306878875',0,'2014-02-14 21:31:21',NULL,NULL),(11417,7427,'AP','3302241607',0,'2013-12-26 02:30:04',NULL,NULL),(9133,5981,'EM','dna.latta@gmail.com',0,'2013-12-25 23:51:56',NULL,NULL),(22485,14499,'TE','2818445080',0,'2013-12-28 03:33:44',NULL,NULL),(40374,26800,'TE','4195753275',0,'2014-03-01 21:00:22',NULL,NULL),(40521,26894,'EM','warde.jaber@hotmail.com',0,'2014-03-03 01:00:04',NULL,NULL),(43783,29063,'AP','4194642721',0,'2014-03-10 21:01:54',NULL,NULL),(23425,15089,'AP','3174453843',0,'2014-01-01 12:04:26',NULL,NULL),(5745,3683,'TE','4408462097',0,'2013-12-25 21:31:31',NULL,NULL),(25513,16451,'AP','9168974214',0,'2014-01-07 04:05:25',NULL,NULL),(25812,16638,'TE','4403448555',0,'2014-01-08 18:24:16',NULL,NULL),(23417,15084,'TE','2107876067',0,'2014-01-01 12:04:16',NULL,NULL),(14235,9314,'EM','urbandogma@gmail.com',0,'2013-12-26 04:30:20',NULL,NULL),(14267,9333,'TE','5137221674',0,'2013-12-26 04:30:47',NULL,NULL),(14871,9731,'AP','4408552183',0,'2013-12-26 04:45:42',NULL,NULL),(5517,3529,'AP','8177268450',0,'2013-12-25 21:21:28',NULL,NULL),(14005,9145,'TE','3304148868',0,'2013-12-26 04:08:17',NULL,NULL),(35048,23016,'EM','zion83.ac@gmail.com',0,'2014-02-12 21:30:27',NULL,NULL),(34583,22676,'AP','8323419491',0,'2014-02-11 21:00:45',NULL,NULL),(33809,22199,'TE','6143784251',0,'2014-02-09 19:00:14',NULL,NULL),(33270,21785,'AP','9374088720',0,'2014-02-06 21:00:40',NULL,NULL),(12128,7926,'AP','3372782774',0,'2013-12-26 03:06:28',NULL,NULL),(32268,21079,'TE','5127366291',0,'2014-02-02 19:00:21',NULL,NULL),(28924,18674,'AP','5756933123',0,'2014-01-17 03:35:18',NULL,NULL),(8905,5830,'TE','4692718364',0,'2013-12-25 23:48:16',NULL,NULL),(20338,13104,'TE','4196355298',0,'2013-12-26 12:52:15',NULL,NULL),(38378,25349,'EM','glendon63@msn.com',0,'2014-02-25 21:30:30',NULL,NULL),(39634,26209,'AP','4407963970',0,'2014-02-28 06:30:52',NULL,NULL),(43428,28841,'TE','3307456709',0,'2014-03-09 21:01:12',NULL,NULL),(43915,29134,'EM','petersontrucking12@yahoo.com',0,'2014-03-10 21:02:39',NULL,NULL),(12212,7979,'TE','4403388282',0,'2013-12-26 03:07:55',NULL,NULL),(34535,22654,'AP','9033123742',0,'2014-02-11 21:00:30',NULL,NULL),(3936,2496,'TE','5043249998',0,'2013-12-25 19:35:56',NULL,NULL),(33090,21677,'TE','9852493204',0,'2014-02-05 21:31:00',NULL,NULL),(24376,15741,'AP','2547604791',0,'2014-01-03 02:00:50',NULL,NULL),(10460,6814,'AP','3304142197',0,'2013-12-26 01:30:24',NULL,NULL),(29780,19255,'AP','2257724681',0,'2014-01-21 08:46:46',NULL,NULL),(29012,18727,'EM','cmoseley1118@gmail.com',0,'2014-01-17 03:35:36',NULL,NULL),(6412,4139,'TE','3304935468',0,'2013-12-25 21:48:33',NULL,NULL),(4291,2739,'EM','coffeelady555@aol.com',0,'2013-12-25 19:48:45',NULL,NULL),(4812,3079,'TE','2162280682',0,'2013-12-25 20:19:40',NULL,NULL),(39154,25899,'TE','4326318209',0,'2014-02-26 21:01:07',NULL,NULL),(39869,26376,'TE','3308407162',0,'2014-02-28 07:00:16',NULL,NULL),(40699,27036,'TE','3252124161',0,'2014-03-03 21:00:19',NULL,NULL),(7692,5019,'AP','3182188627',0,'2013-12-25 22:47:30',NULL,NULL),(619,381,'TE','9797774782',0,'2013-12-25 17:45:43',NULL,NULL),(33178,21727,'TE','6823235009',0,'2014-02-06 21:00:07',NULL,NULL),(181,107,'TE','8326865251',0,'2013-12-25 17:17:52',NULL,NULL),(23359,15047,'AP','2252525624',0,'2014-01-01 12:03:10',NULL,NULL),(28113,18120,'TE','4406539095',0,'2014-01-15 02:07:40',NULL,NULL),(27503,17716,'EM','rwmitchelljr@att.net',0,'2014-01-14 01:33:13',NULL,NULL),(35804,23543,'TE','5044370897',0,'2014-02-13 22:02:34',NULL,NULL),(35982,23675,'TE','3143273381',0,'2014-02-14 21:30:26',NULL,NULL),(37083,24416,'AP','5137487381',0,'2014-02-18 22:01:04',NULL,NULL),(40816,27122,'EM','ian@klintproducions.com',0,'2014-03-03 21:30:34',NULL,NULL),(14853,9720,'TE','4402309747',0,'2013-12-26 04:45:26',NULL,NULL),(26182,16855,'AP','4197065161',0,'2014-01-13 02:18:43',NULL,NULL),(31961,20869,'TE','6013530845',0,'2014-01-31 21:01:01',NULL,NULL),(43990,29184,'TE','6145001438',0,'2014-03-10 21:30:00',NULL,NULL),(14687,9610,'EM','Lauressmorris@yahoo.com',0,'2013-12-26 04:37:38',NULL,NULL),(32856,21502,'EM','LKSPIRITS@YAHOO.COM',0,'2014-02-04 21:01:53',NULL,NULL),(20577,13240,'AP','9034077019',0,'2013-12-26 12:56:03',NULL,NULL),(6386,4114,'TE','9374353822',0,'2013-12-25 21:48:04',NULL,NULL),(3482,2181,'TE','4193392253',0,'2013-12-25 19:19:24',NULL,NULL),(3365,2114,'AP','2163741569',0,'2013-12-25 19:17:32',NULL,NULL),(7138,4655,'EM','davcaraway@cox.net',0,'2013-12-25 22:07:14',NULL,NULL),(10655,6927,'TE','5137281929',0,'2013-12-26 01:46:24',NULL,NULL),(5556,3551,'TE','3302834009',0,'2013-12-25 21:22:02',NULL,NULL),(31602,20613,'EM','shsbgeek@gmail.com',0,'2014-01-30 21:00:19',NULL,NULL),(31096,20244,'TE','8324414232',0,'2014-01-28 21:00:09',NULL,NULL),(3685,2338,'AP','4322131242',0,'2013-12-25 19:31:52',NULL,NULL),(2730,1656,'AP','9032292092',0,'2013-12-25 18:53:30',NULL,NULL),(26338,16953,'EM','brenda4154@att.net',0,'2014-01-13 02:20:02',NULL,NULL),(26365,16970,'AP','4405392734',0,'2014-01-13 02:20:13',NULL,NULL),(41644,27683,'TE','4322221489',0,'2014-03-05 21:30:40',NULL,NULL),(20594,13247,'AP','8324099799',0,'2013-12-26 12:56:17',NULL,NULL),(23570,15218,'TE','3187737356',0,'2014-01-01 12:07:55',NULL,NULL),(34026,22315,'AP','5049408074',0,'2014-02-10 11:00:49',NULL,NULL),(11943,7777,'AP','9362549084',0,'2013-12-26 03:03:07',NULL,NULL),(28963,18694,'AP','5045631875',0,'2014-01-17 03:35:26',NULL,NULL),(24974,16095,'TE','4197040144',0,'2014-01-04 02:04:35',NULL,NULL),(8139,5327,'TE','5133744742',0,'2013-12-25 23:07:00',NULL,NULL),(36503,24033,'TE','9372785150',0,'2014-02-15 22:00:54',NULL,NULL),(38877,25695,'EM','riveraguillermo21@gmail.com',0,'2014-02-26 09:30:15',NULL,NULL),(8615,5661,'TE','5122178130',0,'2013-12-25 23:31:46',NULL,NULL),(21273,13669,'TE','9012701125',0,'2013-12-26 13:07:52',NULL,NULL),(22792,14697,'TE','2167413872',1,'2013-12-29 11:08:58',NULL,NULL),(29643,19152,'AP','5672883337',0,'2014-01-21 08:45:36',NULL,NULL),(29187,18857,'TE','5043398206',0,'2014-01-17 03:36:18',NULL,NULL),(24753,15971,'EM','COVEJO1960@GMAIL.COM',0,'2014-01-04 02:00:37',NULL,NULL),(7226,4705,'AP','4193762976',0,'2013-12-25 22:08:33',NULL,NULL),(38472,25425,'TE','6142030130',0,'2014-02-25 21:31:11',NULL,NULL),(41382,27493,'EM','MLFRYE22@GMAIL.COM',0,'2014-03-04 21:02:23',NULL,NULL),(25869,16672,'EM','fred.veauthier@gmail.com',0,'2014-01-08 18:24:29',NULL,NULL),(4758,3047,'TE','3258354583',0,'2013-12-25 20:18:47',NULL,NULL),(34950,22943,'AP','5672049972',0,'2014-02-11 21:30:21',NULL,NULL),(34319,22518,'TE','2109957304',0,'2014-02-10 21:31:23',NULL,NULL),(32532,21266,'AP','8326060026',0,'2014-02-03 21:01:28',NULL,NULL),(28719,18532,'EM','sales@perrysburgmattress.com',0,'2014-01-16 08:46:44',NULL,NULL),(2312,1412,'AP','3187713105',0,'2013-12-25 18:46:58',NULL,NULL),(8154,5337,'EM','jgellermann@hotmail.com',0,'2013-12-25 23:07:15',NULL,NULL),(12027,7841,'AP','5136230575',0,'2013-12-26 03:04:37',NULL,NULL),(2431,1490,'TE','2162540258',0,'2013-12-25 18:49:00',NULL,NULL),(37360,24595,'TE','5133002623',0,'2014-02-20 04:11:41',NULL,NULL),(38180,25199,'EM','margodenisemarshall1964@yahoo.com',0,'2014-02-21 22:00:45',NULL,NULL),(14690,9612,'TE','3308604523',0,'2013-12-26 04:37:40',NULL,NULL),(26917,17314,'TE','9406369376',0,'2014-01-13 02:23:46',NULL,NULL),(27764,17901,'EM','jaw1958@cnonline.com',0,'2014-01-15 02:06:23',NULL,NULL),(25643,16538,'TE','3305357075',1,'2014-01-07 10:22:15',NULL,NULL),(30005,19430,'AP','4196027888',1,'2014-01-22 03:23:07',NULL,NULL),(21266,13664,'EM','bvillebink@yahoo.com',0,'2013-12-26 13:07:44',NULL,NULL),(24904,16053,'TE','2342816906',0,'2014-01-04 02:03:17',NULL,NULL),(10858,7048,'AP','9039174305',0,'2013-12-26 01:49:37',NULL,NULL),(21268,13665,'AP','5042512506',0,'2013-12-26 13:07:46',NULL,NULL),(40540,26907,'TE','2504699293',0,'2014-03-03 01:00:10',NULL,NULL),(42664,28382,'EM','cjk1029@hotmail.com',0,'2014-03-07 21:30:40',NULL,NULL),(25073,16165,'AP','3372745285',0,'2014-01-05 00:00:04',NULL,NULL),(29930,19371,'TE','3304164068',1,'2014-01-22 03:22:36',NULL,NULL),(13688,8923,'EM','msdfisher@hotmail.com',0,'2013-12-26 04:02:51',NULL,NULL),(21177,13622,'TE','4192305155',0,'2013-12-26 13:05:53',NULL,NULL),(27137,17475,'AP','9037805976',0,'2014-01-13 03:01:09',NULL,NULL),(6265,4043,'TE','4253271474',0,'2013-12-25 21:46:09',NULL,NULL),(6838,4436,'TE','4196846060',0,'2013-12-25 22:02:02',NULL,NULL),(21800,14045,'AP','3309409084',0,'2013-12-27 02:00:09',NULL,NULL),(5249,3370,'AP','2149911427',0,'2013-12-25 21:17:14',NULL,NULL),(23432,15098,'EM','on2victory@att.net',0,'2014-01-01 12:04:38',NULL,NULL),(36807,24234,'EM','david.little@att.net',0,'2014-02-16 19:00:36',NULL,NULL),(41702,27728,'AP','9366618951',0,'2014-03-05 21:31:03',NULL,NULL),(22343,14409,'AP','6825571773',0,'2013-12-28 03:31:24',NULL,NULL),(35576,23394,'TE','7407469405',0,'2014-02-13 22:01:08',NULL,NULL),(34512,22637,'AP','8172049982',0,'2014-02-11 21:00:21',NULL,NULL),(31646,20646,'BN','9155034005',0,'2014-01-30 21:00:36',NULL,NULL),(14726,9632,'EM','danbuller@gmail.com',0,'2013-12-26 04:38:15',NULL,NULL),(23055,14872,'TE','9404530810',0,'2013-12-30 00:00:15',NULL,NULL),(30002,19427,'AP','5675250592',1,'2014-01-22 03:23:05',NULL,NULL),(24556,15838,'AP','5133416905',0,'2014-01-03 02:04:05',NULL,NULL),(24540,15827,'TE','5138345933',0,'2014-01-03 02:03:44',NULL,NULL),(3346,2104,'TE','9372586056',0,'2013-12-25 19:17:15',NULL,NULL),(41303,27440,'TE','3177537058',0,'2014-03-04 21:01:53',NULL,NULL),(2268,1389,'TE','2257177758',0,'2013-12-25 18:46:20',NULL,NULL),(14529,9492,'TE','5132715711',0,'2013-12-26 04:34:56',NULL,NULL),(34143,22388,'TE','3306204254',0,'2014-02-10 21:30:13',NULL,NULL),(11369,7405,'EM','k.poyant@verizon.net',0,'2013-12-26 02:16:34',NULL,NULL),(26257,16899,'TE','9375324274',0,'2014-01-13 02:19:31',NULL,NULL),(26114,16816,'AP','6015064271',0,'2014-01-13 02:18:19',NULL,NULL),(25095,16179,'EM','tchamness@att.net',0,'2014-01-05 00:00:29',NULL,NULL),(7366,4791,'EM','limbonner@gmail.com',0,'2013-12-25 22:16:19',NULL,NULL),(20769,13344,'EM','dvirborik@gmail.com',0,'2013-12-26 12:59:02',NULL,NULL),(7231,4709,'AP','4198332020',0,'2013-12-25 22:08:40',NULL,NULL),(21128,13586,'TE','9856462508',0,'2013-12-26 13:05:02',NULL,NULL),(21562,13867,'TE','3309297222',0,'2013-12-26 13:12:56',NULL,NULL),(14637,9572,'AP','2167734510',0,'2013-12-26 04:36:45',NULL,NULL),(27209,17521,'AP','7408155943',0,'2014-01-13 03:01:36',NULL,NULL),(27582,17780,'TE','7132057273',0,'2014-01-14 01:33:42',NULL,NULL),(29506,19074,'EM','cjbechstein@yahoo.com',0,'2014-01-21 08:44:22',NULL,NULL),(41637,27680,'TE','9565922096',0,'2014-03-05 21:30:38',NULL,NULL),(42341,28119,'TE','4197488553',0,'2014-03-06 21:02:19',NULL,NULL),(43465,28867,'TE','9792822592',0,'2014-03-10 21:00:00',NULL,NULL),(4069,2597,'TE','9372702265',0,'2013-12-25 19:45:13',NULL,NULL),(34868,22866,'EM','michelle_widener@hotmail.com',0,'2014-02-11 21:02:28',NULL,NULL),(11127,7233,'TE','4193442648',0,'2013-12-26 02:01:27',NULL,NULL),(32124,20977,'TE','6018662428',0,'2014-02-01 19:00:18',NULL,NULL),(26867,17288,'EM','cateaton1714@gmail.com',0,'2014-01-13 02:23:31',NULL,NULL),(37500,24693,'TE','5132655186',0,'2014-02-20 04:33:01',NULL,NULL),(39609,26200,'AP','4409691861',0,'2014-02-28 06:30:48',NULL,NULL),(41495,27584,'TE','9402325670',0,'2014-03-05 21:00:13',NULL,NULL),(21003,13514,'TE','7145829236',0,'2013-12-26 13:03:01',NULL,NULL),(33490,21945,'TE','4199607136',0,'2014-02-07 19:00:18',NULL,NULL),(22809,14706,'TE','3307554563',1,'2013-12-29 11:09:13',NULL,NULL),(29510,19078,'AP','3185471606',0,'2014-01-21 08:44:24',NULL,NULL),(10452,6810,'TE','4694267451',0,'2013-12-26 01:30:17',NULL,NULL),(5608,3589,'TE','5132374722',0,'2013-12-25 21:22:59',NULL,NULL),(37107,24429,'EM','wsmith21@neo.rr.com',0,'2014-02-18 22:01:13',NULL,NULL),(40532,26902,'EM','chersmagichands@aol.com',0,'2014-03-03 01:00:08',NULL,NULL),(47,29,'EM','jean_mcgreevy@yahoo.com',0,'2013-12-25 17:15:46',NULL,NULL),(36304,23903,'EM','regor17@aol.com',0,'2014-02-14 21:32:25',NULL,NULL),(25985,16742,'AP','3306047774',0,'2014-01-08 18:24:52',NULL,NULL),(23306,15018,'AP','5133799887',0,'2014-01-01 12:02:14',NULL,NULL),(10574,6883,'AP','3373510509',0,'2013-12-26 01:45:08',NULL,NULL),(12408,8125,'TE','5135415129',0,'2013-12-26 03:15:23',NULL,NULL),(14850,9718,'EM','smccallum2d3@gmail.com',0,'2013-12-26 04:45:23',NULL,NULL),(1321,807,'EM','mjz17@juno.com',0,'2013-12-25 18:05:43',NULL,NULL),(6300,4060,'TE','4408290684',0,'2013-12-25 21:46:39',NULL,NULL),(39055,25831,'AP','7408772139',0,'2014-02-26 21:00:30',NULL,NULL),(39229,25948,'EM','hesser.cyle@gmail.com',0,'2014-02-26 21:01:35',NULL,NULL),(122,72,'TE','2162368464',0,'2013-12-25 17:16:58',NULL,NULL),(9628,6301,'TE','9378434539',0,'2013-12-26 00:45:55',NULL,NULL),(34637,22710,'EM','rmbalcala@gmail.com',0,'2014-02-11 21:01:04',NULL,NULL),(6592,4256,'AP','3305244409',0,'2013-12-25 21:51:25',NULL,NULL),(29123,18808,'EM','jeb8799@hotmail.com',0,'2014-01-17 03:36:02',NULL,NULL),(10053,6575,'AP','2253174595',0,'2013-12-26 00:52:48',NULL,NULL),(7469,4862,'EM','SALVAREZ86@GMAIL.COM',0,'2013-12-25 22:30:43',NULL,NULL),(25127,16197,'TE','3612261064',0,'2014-01-05 00:01:02',NULL,NULL),(24402,15755,'TE','4324383728',0,'2014-01-03 02:01:18',NULL,NULL),(42067,27954,'AP','4323868239',0,'2014-03-06 21:00:40',NULL,NULL),(24172,15619,'TE','6623279085',1,'2014-01-02 04:33:05',NULL,NULL),(4697,3003,'EM','ntsquirel@icloud.com',0,'2013-12-25 20:17:43',NULL,NULL),(35646,23438,'AP','2059037148',0,'2014-02-13 22:01:31',NULL,NULL),(11324,7377,'TE','4405253667',0,'2013-12-26 02:15:50',NULL,NULL),(30243,19590,'AP','6018746084',0,'2014-01-23 03:02:44',NULL,NULL),(6953,4533,'AP','2105357939',0,'2013-12-25 22:04:06',NULL,NULL),(38499,25441,'AP','9728416263',0,'2014-02-25 21:31:21',NULL,NULL),(39929,26424,'TE','5129276289',0,'2014-02-28 07:30:10',NULL,NULL),(41800,27788,'AP','2707799503',0,'2014-03-05 21:31:39',NULL,NULL),(4720,3022,'TE','3306000583',0,'2013-12-25 20:18:11',NULL,NULL),(35612,23417,'AP','9034568312',0,'2014-02-13 22:01:20',NULL,NULL),(11937,7774,'AP','2148085198',0,'2013-12-26 03:03:01',NULL,NULL),(30484,19765,'AP','6018321075',0,'2014-01-23 21:01:26',NULL,NULL),(1688,1038,'TE','2813320037',0,'2013-12-25 18:15:41',NULL,NULL),(27928,17993,'TE','3309459502',0,'2014-01-15 02:06:58',NULL,NULL),(21720,13993,'EM','vanderveldeab@woh.rr.com',0,'2013-12-26 13:15:51',NULL,NULL),(38924,25732,'TE','9858565134',0,'2014-02-26 09:30:36',NULL,NULL),(2032,1258,'AP','4192701888',0,'2013-12-25 18:21:27',NULL,NULL),(4217,2696,'TE','9723935815',0,'2013-12-25 19:47:38',NULL,NULL),(32818,21473,'TE','5138076618',0,'2014-02-04 21:01:40',NULL,NULL),(28957,18691,'TE','2256109389',0,'2014-01-17 03:35:24',NULL,NULL),(28116,18121,'EM','dmeyers1@neo.rr.com',0,'2014-01-15 02:07:40',NULL,NULL),(5772,3697,'AP','6199852569',0,'2013-12-25 21:31:53',NULL,NULL),(27596,17790,'AP','5137038540',0,'2014-01-14 01:33:47',NULL,NULL),(14489,9466,'TE','9372222245',0,'2013-12-26 04:34:19',NULL,NULL),(10546,6867,'EM','crazychick_86_04@yahoo.com',0,'2013-12-26 01:31:52',NULL,NULL),(4466,2845,'TE','3614293057',0,'2013-12-25 20:01:10',NULL,NULL),(2530,1548,'EM','michael.parmenio@gmail.com',0,'2013-12-25 18:50:32',NULL,NULL),(33715,22115,'AP','5127209087',0,'2014-02-08 19:00:37',NULL,NULL),(4610,2941,'AP','9373216187',0,'2013-12-25 20:16:14',NULL,NULL),(3847,2448,'AP','5133240570',0,'2013-12-25 19:34:36',NULL,NULL),(11134,7236,'AP','3183057810',0,'2013-12-26 02:01:34',NULL,NULL),(11355,7398,'TE','2162885771',0,'2013-12-26 02:16:20',NULL,NULL),(12172,7952,'AP','2252474688',0,'2013-12-26 03:07:11',NULL,NULL),(20800,13365,'AP','6144465265',0,'2013-12-26 12:59:36',NULL,NULL),(37738,24894,'TE','3309296766',0,'2014-02-20 05:39:45',NULL,NULL),(39966,26461,'TE','5049136270',0,'2014-02-28 07:30:31',NULL,NULL),(25508,16449,'AP','6627191058',0,'2014-01-07 04:05:21',NULL,NULL),(32528,21264,'TE','4403194352',0,'2014-02-03 21:01:26',NULL,NULL),(3472,2172,'AP','4197892499',0,'2013-12-25 19:19:13',NULL,NULL),(7323,4762,'TE','5132426877',0,'2013-12-25 22:15:35',NULL,NULL),(12096,7906,'TE','5042326235',0,'2013-12-26 03:05:57',NULL,NULL),(7285,4746,'AP','2147918457',0,'2013-12-25 22:15:03',NULL,NULL),(10554,6870,'EM','garyasolomon@gmail.com',0,'2013-12-26 01:31:58',NULL,NULL),(38273,25270,'EM','shopcat25@bellsouth.net',0,'2014-02-25 21:00:11',NULL,NULL),(42949,28560,'TE','4196896890',0,'2014-03-07 21:32:25',NULL,NULL),(2442,1497,'EM','desimae1@sbcglobal.net',0,'2013-12-25 18:49:12',NULL,NULL),(37251,24512,'EM','judy@prescottair.com',0,'2014-02-20 03:54:13',NULL,NULL),(20561,13233,'EM','fezmonkey@hotmail.com',0,'2013-12-26 12:55:49',NULL,NULL),(7379,4802,'AP','2252442040',0,'2013-12-25 22:16:32',NULL,NULL),(30730,19965,'TE','7404669205',0,'2014-01-25 19:00:09',NULL,NULL),(28611,18442,'TE','2253337727',0,'2014-01-16 08:46:04',NULL,NULL),(42489,28255,'TE','5133900340',0,'2014-03-07 21:00:15',NULL,NULL),(43584,28941,'TE','4406105565',0,'2014-03-10 21:00:43',NULL,NULL),(1153,708,'AP','9852498103',0,'2013-12-25 18:03:07',NULL,NULL),(25202,16250,'TE','2166441481',0,'2014-01-05 00:02:37',NULL,NULL),(30933,20116,'BN','7404060529',0,'2014-01-27 21:00:44',NULL,NULL),(1617,994,'EM','dawnmdebord@gmail.com',0,'2013-12-25 18:10:43',NULL,NULL),(38102,25149,'EM','mlongbotham27@gmail.com',0,'2014-02-21 22:00:16',NULL,NULL),(38501,25443,'TE','9568310465',0,'2014-02-25 21:31:21',NULL,NULL),(25476,16428,'TE','3183987252',0,'2014-01-07 04:04:43',NULL,NULL),(37441,24651,'AP','6143987629',0,'2014-02-20 04:23:15',NULL,NULL),(37241,24506,'AP','3123436269',0,'2014-02-20 03:51:18',NULL,NULL),(25020,16122,'EM','1234tracie28@gmail.com',0,'2014-01-04 02:05:27',NULL,NULL),(23863,15399,'EM','tamaranwilson@yahoo.com',1,'2014-01-02 04:26:44',NULL,NULL),(22603,14576,'AP','2253847714',0,'2013-12-28 03:35:43',NULL,NULL),(6677,4335,'EM','jbensman@statewideford.coM',0,'2013-12-25 21:53:08',NULL,NULL),(29988,19414,'TE','2283696540',1,'2014-01-22 03:22:59',NULL,NULL),(11727,7633,'AP','4403170498',0,'2013-12-26 02:46:20',NULL,NULL),(39574,26180,'EM','kei.velez1@gmail.com',0,'2014-02-28 06:30:40',NULL,NULL),(41795,27785,'AP','6014971129',0,'2014-03-05 21:31:37',NULL,NULL),(24169,15618,'TE','6015902317',1,'2014-01-02 04:33:02',NULL,NULL),(26385,16983,'EM','paulinecoffey@yahoo.com',0,'2014-01-13 02:20:19',NULL,NULL),(43019,28604,'EM','doug.libman@yahoo.com',0,'2014-03-08 21:30:11',NULL,NULL),(24512,15812,'TE','3183668989',0,'2014-01-03 02:03:14',NULL,NULL),(34605,22693,'TE','2255733392',0,'2014-02-11 21:00:53',NULL,NULL),(29306,18934,'AP','4405413532',0,'2014-01-20 08:05:40',NULL,NULL),(14760,9653,'TE','4196455020',0,'2013-12-26 04:38:50',NULL,NULL),(5108,3275,'EM','julieannaring@cinci.rr.com',0,'2013-12-25 21:15:05',NULL,NULL),(14652,9584,'TE','6012591046',0,'2013-12-26 04:37:00',NULL,NULL),(42455,28202,'EM','sam.i.am22@gmail.com',0,'2014-03-06 21:30:10',NULL,NULL),(43145,28678,'TE','4199173402',0,'2014-03-08 21:30:54',NULL,NULL),(43234,28730,'TE','5186691888',0,'2014-03-09 21:00:02',NULL,NULL),(481,306,'TE','9157262600',0,'2013-12-25 17:30:56',NULL,NULL),(25465,16423,'TE','5156815473',0,'2014-01-07 04:04:33',NULL,NULL),(35221,23133,'AP','2163945976',0,'2014-02-12 21:31:31',NULL,NULL),(9751,6376,'TE','3306682468',0,'2013-12-26 00:47:49',NULL,NULL),(11080,7196,'TE','8593215015',0,'2013-12-26 02:00:33',NULL,NULL),(3627,2293,'AP','6142027919',0,'2013-12-25 19:30:50',NULL,NULL),(20963,13486,'TE','4402213935',0,'2013-12-26 13:02:21',NULL,NULL),(43306,28770,'TE','7406246095',0,'2014-03-09 21:00:29',NULL,NULL),(20859,13409,'EM','emecklenborg@yahoo.com',0,'2013-12-26 13:00:33',NULL,NULL),(8916,5836,'EM','kodamd04@att.net',0,'2013-12-25 23:48:26',NULL,NULL),(10576,6884,'AP','2253855669',0,'2013-12-26 01:45:10',NULL,NULL),(3057,1901,'TE','4406474668',0,'2013-12-25 18:59:08',NULL,NULL),(30601,19861,'TE','5136022126',0,'2014-01-24 21:00:35',NULL,NULL),(3055,1900,'TE','4406474668',0,'2013-12-25 18:59:07',NULL,NULL),(12204,7973,'EM','nsehm@neo.rr.com',0,'2013-12-26 03:07:46',NULL,NULL),(36753,24197,'TE','5133440653',0,'2014-02-16 19:00:17',NULL,NULL),(40369,26794,'TE','4197874558',0,'2014-03-01 21:00:20',NULL,NULL),(7645,4977,'TE','2403942970',0,'2013-12-25 22:46:38',NULL,NULL),(34869,22867,'TE','6012687208',0,'2014-02-11 21:02:28',NULL,NULL),(4528,2878,'AP','3617999046',0,'2013-12-25 20:02:10',NULL,NULL),(26586,17105,'AP','9729518838',0,'2014-01-13 02:21:34',NULL,NULL),(21438,13781,'EM','AALWHITE107@AOL.COM',0,'2013-12-26 13:10:46',NULL,NULL),(35318,23206,'AP','5672089601',0,'2014-02-12 21:32:11',NULL,NULL),(4080,2601,'EM','drr3rob@gmail.com',0,'2013-12-25 19:45:21',NULL,NULL),(1900,1172,'TE','3308991828',0,'2013-12-25 18:19:11',NULL,NULL),(7484,4871,'TE','3187324338',0,'2013-12-25 22:31:00',NULL,NULL),(36426,23991,'TE','2252683211',0,'2014-02-15 22:00:26',NULL,NULL),(37292,24540,'TE','3305071041',0,'2014-02-20 04:02:22',NULL,NULL),(38405,25373,'TE','5137613192',0,'2014-02-25 21:30:42',NULL,NULL),(40179,26648,'EM','greg@paulkrohtherapy.com',0,'2014-02-28 21:31:06',NULL,NULL),(40772,27094,'TE','2163417705',0,'2014-03-03 21:30:19',NULL,NULL),(25164,16222,'TE','5132181864',0,'2014-01-05 00:01:50',NULL,NULL),(31645,20645,'TE','9037314628',0,'2014-01-30 21:00:35',NULL,NULL),(13968,9103,'AP','2162245723',0,'2013-12-26 04:07:28',NULL,NULL),(1022,630,'EM','pawscott1213@aol.com',0,'2013-12-25 18:01:05',NULL,NULL),(2055,1272,'AP','9728043459',0,'2013-12-25 18:30:18',NULL,NULL),(5905,3788,'EM','Lmspencer29@earthlink.net',0,'2013-12-25 21:34:10',NULL,NULL),(14496,9470,'TE','5133516568',0,'2013-12-26 04:34:25',NULL,NULL),(40685,27018,'AP','4405673862',0,'2014-03-03 21:00:11',NULL,NULL),(43957,29158,'EM','smitchell6@woh.rr.com',0,'2014-03-10 21:02:53',NULL,NULL),(1206,735,'TE','8064380744',0,'2013-12-25 18:03:54',NULL,NULL),(35066,23026,'AP','8063003202',0,'2014-02-12 21:30:32',NULL,NULL),(28966,18695,'AP','5045631875',0,'2014-01-17 03:35:26',NULL,NULL),(10348,6746,'TE','4403717126',0,'2013-12-26 01:15:55',NULL,NULL),(12001,7819,'TE','8062207300',0,'2013-12-26 03:04:09',NULL,NULL),(21232,13649,'AP','5042316601',0,'2013-12-26 13:07:15',NULL,NULL),(20243,13040,'EM','patriciacrook@yahoo.com',0,'2013-12-26 12:50:36',NULL,NULL),(43230,28726,'TE','3376921704',0,'2014-03-09 21:00:00',NULL,NULL),(31,21,'TE','3309321036',0,'2013-12-25 17:15:32',NULL,NULL),(9192,6017,'AP','2162442393',0,'2013-12-26 00:00:45',NULL,NULL),(32572,21298,'AP','9853518305',0,'2014-02-04 21:00:11',NULL,NULL),(35617,23421,'AP','8179170171',0,'2014-02-13 22:01:22',NULL,NULL),(31567,20586,'TE','5134768337',0,'2014-01-30 21:00:06',NULL,NULL),(1735,1066,'TE','2162262909',0,'2013-12-25 18:16:25',NULL,NULL),(10403,6781,'TE','9567658459',0,'2013-12-26 01:16:52',NULL,NULL),(10484,6830,'AP','6145355602',0,'2013-12-26 01:30:46',NULL,NULL),(2784,1686,'EM','mjrimes@yahoo.com',0,'2013-12-25 18:54:19',NULL,NULL),(1434,875,'AP','9375649179',0,'2013-12-25 18:07:33',NULL,NULL),(21918,14120,'EM','jasplin@aol.com',0,'2013-12-27 02:02:05',NULL,NULL),(12156,7941,'TE','3188948354',0,'2013-12-26 03:06:54',NULL,NULL),(6599,4262,'AP','4406664259',0,'2013-12-25 21:51:34',NULL,NULL),(11418,7428,'TE','3307533423',0,'2013-12-26 02:30:05',NULL,NULL),(448,277,'AP','7139075904',0,'2013-12-25 17:30:13',NULL,NULL),(12112,7917,'TE','5049491891',0,'2013-12-26 03:06:14',NULL,NULL),(36109,23759,'EM','kahlyaalessia@yahoo.com',0,'2014-02-14 21:31:10',NULL,NULL),(36606,24100,'AP','8709952419',0,'2014-02-15 22:01:30',NULL,NULL),(39135,25884,'AP','2543340328',0,'2014-02-26 21:01:00',NULL,NULL),(39943,26436,'TE','4404666007',0,'2014-02-28 07:30:18',NULL,NULL),(24024,15512,'EM','julieljones10@yahoo.com',1,'2014-01-02 04:30:03',NULL,NULL),(33080,21668,'AP','5042286487',0,'2014-02-05 21:30:58',NULL,NULL),(10725,6977,'TE','5135825504',0,'2013-12-26 01:47:35',NULL,NULL),(30924,20110,'AP','3302896086',0,'2014-01-27 21:00:40',NULL,NULL),(22851,14745,'TE','5132937603',1,'2013-12-29 11:10:10',NULL,NULL),(40585,26935,'EM','tmkettler@aol.com',0,'2014-03-03 01:00:22',NULL,NULL),(1867,1153,'TE','3183327199',0,'2013-12-25 18:18:41',NULL,NULL),(13700,8931,'EM','gweber8094@gmail.com',0,'2013-12-26 04:03:02',NULL,NULL),(34472,22619,'AP','5052352666',0,'2014-02-11 21:00:09',NULL,NULL),(30658,19899,'TE','4197792004',0,'2014-01-24 21:00:55',NULL,NULL),(10951,7118,'EM','bartsharkey@gmail.com',0,'2013-12-26 01:51:15',NULL,NULL),(10808,7021,'TE','9726905975',0,'2013-12-26 01:48:51',NULL,NULL),(29297,18931,'TE','4407995758',0,'2014-01-20 08:05:38',NULL,NULL),(26887,17298,'AP','9562663751',0,'2014-01-13 02:23:37',NULL,NULL),(1934,1198,'TE','6147470117',0,'2013-12-25 18:19:48',NULL,NULL),(21309,13689,'TE','3306886108',0,'2013-12-26 13:08:25',NULL,NULL),(2633,1602,'TE','9565328256',0,'2013-12-25 18:52:04',NULL,NULL),(21737,14003,'AP','9375814325',0,'2013-12-26 13:16:08',NULL,NULL),(4162,2655,'TE','6148040490',0,'2013-12-25 19:46:44',NULL,NULL),(39489,26120,'TE','7405137275',0,'2014-02-28 06:30:19',NULL,NULL),(43556,28925,'EM','Lclarke70@hotmail.com',0,'2014-03-10 21:00:33',NULL,NULL),(8044,5263,'EM','bartsu@gmail.com',0,'2013-12-25 23:05:25',NULL,NULL),(33610,22040,'TE','6623367408',0,'2014-02-07 19:01:08',NULL,NULL),(31703,20683,'TE','9038313520',0,'2014-01-30 21:00:55',NULL,NULL),(8981,5890,'TE','9374523253',0,'2013-12-25 23:49:36',NULL,NULL),(14323,9366,'TE','5044915048',0,'2013-12-26 04:31:40',NULL,NULL),(20381,13126,'AP','4194814953',0,'2013-12-26 12:52:54',NULL,NULL),(36151,23794,'AP','4404782821',0,'2014-02-14 21:31:26',NULL,NULL),(42521,28283,'AP','5049821701',0,'2014-03-07 21:00:26',NULL,NULL),(43136,28674,'TE','4199446109',0,'2014-03-08 21:30:51',NULL,NULL),(956,590,'TE','6463699590',0,'2013-12-25 17:51:10',NULL,NULL),(25299,16313,'AP','3372747439',0,'2014-01-07 04:01:30',NULL,NULL),(32904,21543,'EM','OHIOSCOTT@SBCGLOBAL.NET',0,'2014-02-05 21:30:10',NULL,NULL),(31939,20849,'AP','6144461483',0,'2014-01-31 21:00:51',NULL,NULL),(22952,14806,'TE','5049527009',1,'2013-12-29 11:13:55',NULL,NULL),(23403,15073,'TE','2144152927',0,'2014-01-01 12:03:58',NULL,NULL),(5709,3664,'AP','9373049992',0,'2013-12-25 21:30:59',NULL,NULL),(6963,4541,'TE','9562512028',0,'2013-12-25 22:04:17',NULL,NULL),(2309,1411,'AP','2258922658',0,'2013-12-25 18:46:56',NULL,NULL),(36340,23933,'AP','6148731696',0,'2014-02-15 21:00:05',NULL,NULL),(43801,29078,'TE','6625883373',0,'2014-03-10 21:02:01',NULL,NULL),(24952,16083,'TE','3305091758',0,'2014-01-04 02:04:11',NULL,NULL),(31759,20726,'TE','3303263703',0,'2014-01-30 21:01:17',NULL,NULL),(29377,18984,'EM','manleysrecycling@suddenlinkmail.com',0,'2014-01-20 08:06:08',NULL,NULL),(3400,2136,'EM','rf@fcon.com',0,'2013-12-25 19:18:07',NULL,NULL),(24382,15744,'TE','2543941376',0,'2014-01-03 02:00:56',NULL,NULL),(11049,7175,'TE','3306446496',0,'2013-12-26 02:00:04',NULL,NULL),(1726,1058,'TE','2108317457',0,'2013-12-25 18:16:14',NULL,NULL),(14610,9551,'TE','9374861000',0,'2013-12-26 04:36:18',NULL,NULL),(37144,24451,'BN','4403171639',0,'2014-02-18 22:01:26',NULL,NULL),(41855,27834,'TE','3308741374',0,'2014-03-05 21:32:03',NULL,NULL),(299,185,'TE','9126634963',0,'2013-12-25 17:19:47',NULL,NULL),(11794,7671,'AP','2259786148',0,'2013-12-26 03:00:34',NULL,NULL),(4458,2838,'EM','couchelectric@hotmail.com',0,'2013-12-25 20:01:00',NULL,NULL),(34113,22363,'TE','4408455597',0,'2014-02-10 21:00:09',NULL,NULL),(25295,16311,'TE','5042616866',0,'2014-01-07 04:01:26',NULL,NULL),(26929,17322,'AP','9784001764',0,'2014-01-13 02:23:51',NULL,NULL),(37683,24847,'TE','5676940879',0,'2014-02-20 04:54:46',NULL,NULL),(13586,8857,'EM','ehowlett2013@outlook.com',0,'2013-12-26 04:01:12',NULL,NULL),(4181,2670,'EM','rrbrandt@outlook.com',0,'2013-12-25 19:47:03',NULL,NULL),(22778,14689,'TE','7405908033',1,'2013-12-29 11:08:45',NULL,NULL),(26391,16988,'AP','8322669657',0,'2014-01-13 02:20:22',NULL,NULL),(29213,18871,'AP','9857890709',0,'2014-01-17 03:36:24',NULL,NULL),(38906,25720,'TE','9032921230',0,'2014-02-26 09:30:27',NULL,NULL),(8824,5778,'EM','joeshupe14@gmail.com',0,'2013-12-25 23:46:59',NULL,NULL),(22661,14612,'TE','5132645684',0,'2013-12-28 03:36:41',NULL,NULL),(35246,23149,'AP','3302963350',0,'2014-02-12 21:31:40',NULL,NULL),(28309,18247,'AP','9562238285',0,'2014-01-16 08:44:28',NULL,NULL),(33259,21779,'AP','5136803309',0,'2014-02-06 21:00:37',NULL,NULL),(28339,18262,'AP','2816876591',0,'2014-01-16 08:44:37',NULL,NULL),(28314,18250,'EM','healthcare@imagegard.com',0,'2014-01-16 08:44:30',NULL,NULL),(37700,24856,'AP','5139230015',0,'2014-02-20 04:56:16',NULL,NULL),(42333,28113,'TE','3306188618',0,'2014-03-06 21:02:16',NULL,NULL),(5349,3427,'AP','3307075425',0,'2013-12-25 21:18:49',NULL,NULL),(3454,2162,'EM','SMKMKM@MSM.COM',0,'2013-12-25 19:18:56',NULL,NULL),(12419,8134,'AP','9372694407',0,'2013-12-26 03:15:37',NULL,NULL),(24719,15947,'AP','4193414932',0,'2014-01-03 02:07:24',NULL,NULL),(505,318,'AP','3377396468',0,'2013-12-25 17:31:16',NULL,NULL),(38617,25522,'EM','xpnsv.taste@hotmail.com',0,'2014-02-25 21:32:07',NULL,NULL),(38976,25772,'TE','4403424303',0,'2014-02-26 09:30:57',NULL,NULL),(25603,16516,'AP','3098303118',1,'2014-01-07 10:21:31',NULL,NULL),(36195,23825,'TE','6014084211',0,'2014-02-14 21:31:43',NULL,NULL),(34289,22495,'AP','4193188787',0,'2014-02-10 21:31:10',NULL,NULL),(31580,20595,'TE','4408717029',0,'2014-01-30 21:00:10',NULL,NULL),(11662,7590,'TE','9372352289',0,'2013-12-26 02:45:07',NULL,NULL),(11460,7451,'TE','4402591889',0,'2013-12-26 02:30:44',NULL,NULL),(11755,7651,'TE','8174750297',0,'2013-12-26 02:46:52',NULL,NULL),(3293,2071,'TE','2252099950',0,'2013-12-25 19:16:23',NULL,NULL),(7302,4753,'EM','landreneauewell@gmail.com',0,'2013-12-25 22:15:17',NULL,NULL),(14769,9661,'EM','doc2dc@yahoo.com',0,'2013-12-26 04:39:00',NULL,NULL),(10097,6597,'TE','6627060062',0,'2013-12-26 00:53:26',NULL,NULL),(20821,13383,'TE','4193490245',0,'2013-12-26 12:59:57',NULL,NULL),(41208,27369,'EM','aemimb@gmail.com',0,'2014-03-04 21:01:15',NULL,NULL),(961,593,'TE','5132568354',0,'2013-12-25 18:00:06',NULL,NULL),(892,552,'AP','8177148147',0,'2013-12-25 17:50:04',NULL,NULL),(33521,21976,'AP','5043446088',0,'2014-02-07 19:00:34',NULL,NULL),(31997,20890,'TE','5139109773',0,'2014-01-31 21:01:14',NULL,NULL),(26482,17043,'EM','andrewdavidson118@yahoo.com',0,'2014-01-13 02:20:53',NULL,NULL),(8038,5260,'TE','3304728307',0,'2013-12-25 23:05:20',NULL,NULL),(20477,13190,'TE','9726394400',0,'2013-12-26 12:54:36',NULL,NULL),(21096,13565,'AP','3182141345',0,'2013-12-26 13:04:29',NULL,NULL),(20560,13233,'AP','7138228143',0,'2013-12-26 12:55:49',NULL,NULL),(37699,24856,'TE','5139230015',0,'2014-02-20 04:56:11',NULL,NULL),(25284,16304,'TE','5044101052',0,'2014-01-07 04:01:13',NULL,NULL),(36212,23834,'BN','5135086200',0,'2014-02-14 21:31:48',NULL,NULL),(2391,1456,'AP','4405390392',0,'2013-12-25 18:48:12',NULL,NULL),(31094,20241,'AP','6628089697',0,'2014-01-28 21:00:08',NULL,NULL),(5853,3755,'AP','4403813897',0,'2013-12-25 21:33:17',NULL,NULL),(39847,26356,'AP','5132528066',0,'2014-02-28 06:31:49',NULL,NULL),(21247,13655,'AP','3183814116',0,'2013-12-26 13:07:27',NULL,NULL),(9494,6211,'AP','9727461748',0,'2013-12-26 00:30:54',NULL,NULL),(4751,3042,'AP','3307056303',0,'2013-12-25 20:18:40',NULL,NULL),(26834,17261,'AP','9374088957',0,'2014-01-13 02:23:17',NULL,NULL),(24965,16091,'TE','2282060098',0,'2014-01-04 02:04:26',NULL,NULL),(23680,15290,'TE','3183528483',1,'2014-01-02 04:22:26',NULL,NULL),(37918,25013,'AP','6145921031',0,'2014-02-20 22:00:53',NULL,NULL),(40133,26618,'EM','kiaahmed92@gmail.com',0,'2014-02-28 21:30:50',NULL,NULL),(42226,28051,'TE','6019181442',0,'2014-03-06 21:01:37',NULL,NULL),(458,288,'AP','3255130271',0,'2013-12-25 17:30:28',NULL,NULL),(34972,22961,'TE','9798360677',0,'2014-02-12 21:00:09',NULL,NULL),(8676,5696,'EM','mharris2511@sbcglobal.net',0,'2013-12-25 23:32:46',NULL,NULL),(10150,6635,'TE','2167986884',0,'2013-12-26 01:00:08',NULL,NULL),(32671,21367,'AP','5127508605',0,'2014-02-04 21:00:46',NULL,NULL),(31339,20421,'EM','vance.brenda@yahoo.com',0,'2014-01-29 21:00:30',NULL,NULL),(7886,5140,'TE','5135427005',0,'2013-12-25 23:02:31',NULL,NULL),(14785,9673,'EM','linde841@hotmail.com',0,'2013-12-26 04:39:19',NULL,NULL),(7148,4661,'AP','3182825496',0,'2013-12-25 22:07:24',NULL,NULL),(42805,28465,'AP','3306711655',0,'2014-03-07 21:31:28',NULL,NULL),(43662,28977,'AP','4405542196',0,'2014-03-10 21:01:07',NULL,NULL),(22655,14608,'TE','4199730760',0,'2013-12-28 03:36:35',NULL,NULL),(31823,20777,'TE','9159229670',0,'2014-01-31 21:00:07',NULL,NULL),(11674,7599,'EM','kickincountry5@gmail.com',0,'2013-12-26 02:45:21',NULL,NULL),(1030,636,'EM','ruthchurchill@embarqmail.com',0,'2013-12-25 18:01:14',NULL,NULL),(1094,672,'EM','Brownkd07@gmail.com',0,'2013-12-25 18:02:10',NULL,NULL),(9016,5916,'TE','7135780031',0,'2013-12-25 23:50:10',NULL,NULL),(21327,13703,'AP','3307195690',0,'2013-12-26 13:08:45',NULL,NULL),(2436,1494,'TE','7274498622',0,'2013-12-25 18:49:06',NULL,NULL),(42502,28267,'TE','3619443397',0,'2014-03-07 21:00:20',NULL,NULL),(3941,2499,'EM','rpevey@aol.com',0,'2013-12-25 19:36:01',NULL,NULL),(36129,23777,'EM','wiggins.tiffany@gmail.com',0,'2014-02-14 21:31:17',NULL,NULL),(24399,15753,'EM','DORAVONG@YAHOO.COM',0,'2014-01-03 02:01:14',NULL,NULL),(5212,3347,'EM','maltabaa@yahoo.com',0,'2013-12-25 21:16:40',NULL,NULL),(20239,13039,'TE','4195898814',0,'2013-12-26 12:50:34',NULL,NULL),(26288,16922,'TE','9854001100',0,'2014-01-13 02:19:44',NULL,NULL),(31717,20699,'EM','david@davidgaines.net',0,'2014-01-30 21:01:02',NULL,NULL),(30412,19711,'TE','7135029809',0,'2014-01-23 21:00:53',NULL,NULL),(37403,24632,'AP','9034525671',0,'2014-02-20 04:18:15',NULL,NULL),(37923,25024,'BN','3614599308',0,'2014-02-20 22:00:58',NULL,NULL),(38633,25536,'TE','7022865020',0,'2014-02-26 08:00:07',NULL,NULL),(41275,27426,'EM','ERNESTMCJR@GMAIL.COM',0,'2014-03-04 21:01:43',NULL,NULL),(1041,640,'EM','StanleyHill60@gmail.com',0,'2013-12-25 18:01:21',NULL,NULL),(33010,21626,'EM','azmina1212@hotmail.com',0,'2014-02-05 21:30:39',NULL,NULL),(30495,19781,'AP','4196066714',0,'2014-01-23 21:01:34',NULL,NULL),(20364,13118,'TE','9373936788',0,'2013-12-26 12:52:40',NULL,NULL),(2879,1763,'EM','smcgill@woh.rr.com',0,'2013-12-25 18:55:57',NULL,NULL),(2124,1310,'TE','6147497701',0,'2013-12-25 18:31:27',NULL,NULL),(14648,9582,'TE','6148435979',0,'2013-12-26 04:36:56',NULL,NULL),(3224,2027,'AP','3303484466',0,'2013-12-25 19:15:15',NULL,NULL),(9212,6026,'AP','9153739916',0,'2013-12-26 00:01:02',NULL,NULL),(1951,1207,'AP','2169738350',0,'2013-12-25 18:20:02',NULL,NULL),(39495,26123,'AP','5132425866',0,'2014-02-28 06:30:20',NULL,NULL),(6361,4097,'AP','9026347056',0,'2013-12-25 21:47:39',NULL,NULL),(34468,22616,'TE','6267312108',0,'2014-02-11 21:00:08',NULL,NULL),(6205,3996,'EM','catheyphillips@yahoo.com',0,'2013-12-25 21:45:04',NULL,NULL),(3939,2497,'EM','rpevey@aol.com',0,'2013-12-25 19:35:58',NULL,NULL),(10033,6564,'TE','8178973590',0,'2013-12-26 00:52:29',NULL,NULL),(11702,7619,'TE','5133289917',0,'2013-12-26 02:45:51',NULL,NULL),(43367,28804,'TE','5132655656',0,'2014-03-09 21:00:50',NULL,NULL),(2160,1328,'EM','koalabear21@gmail.com',0,'2013-12-25 18:32:01',NULL,NULL),(5579,3565,'TE','4194727169',0,'2013-12-25 21:22:24',NULL,NULL),(10846,7040,'AP','3257269775',0,'2013-12-26 01:49:24',NULL,NULL),(14200,9289,'TE','5132122288',0,'2013-12-26 04:16:07',NULL,NULL),(20248,13045,'TE','6144515838',0,'2013-12-26 12:50:42',NULL,NULL),(723,455,'TE','4199730207',0,'2013-12-25 17:47:27',NULL,NULL),(24366,15734,'TE','5139424022',0,'2014-01-03 02:00:37',NULL,NULL),(24301,15700,'AP','4194661928',1,'2014-01-02 04:35:42',NULL,NULL),(35605,23414,'EM','RAMIREZ.VERO82@GMAIL.COM',0,'2014-02-13 22:01:18',NULL,NULL),(43062,28628,'AP','8304219520',0,'2014-03-08 21:30:25',NULL,NULL),(43240,28732,'AP','2252413724',0,'2014-03-09 21:00:04',NULL,NULL),(14448,9439,'EM','barbaratucker4@gmail.com',0,'2013-12-26 04:33:39',NULL,NULL),(26739,17198,'TE','3309078004',0,'2014-01-13 02:22:22',NULL,NULL),(26719,17186,'TE','5128766936',0,'2014-01-13 02:22:16',NULL,NULL),(25638,16535,'AP','3303389796',1,'2014-01-07 10:22:10',NULL,NULL),(25289,16307,'AP','5049081967',0,'2014-01-07 04:01:19',NULL,NULL),(10933,7109,'AP','4079234951',0,'2013-12-26 01:50:58',NULL,NULL),(2788,1688,'TE','3182814151',0,'2013-12-25 18:54:23',NULL,NULL),(5176,3322,'TE','3306866026',0,'2013-12-25 21:16:06',NULL,NULL),(7206,4693,'EM','cynthialincoln@yahoo.com',0,'2013-12-25 22:08:15',NULL,NULL),(7476,4866,'TE','4193452959',0,'2013-12-25 22:30:50',NULL,NULL),(7929,5169,'AP','3305315361',0,'2013-12-25 23:03:16',NULL,NULL),(28360,18275,'AP','9039268528',0,'2014-01-16 08:44:44',NULL,NULL),(28812,18597,'AP','5135058830',0,'2014-01-16 08:47:16',NULL,NULL),(29320,18948,'AP','8327816015',0,'2014-01-20 08:05:47',NULL,NULL),(31253,20358,'TE','3302731539',0,'2014-01-28 21:01:18',NULL,NULL),(39237,25955,'TE','5137871929',0,'2014-02-26 21:01:39',NULL,NULL),(40958,27216,'TE','6012872978',0,'2014-03-03 21:31:31',NULL,NULL),(41405,27507,'EM','guptasunny21@gmail.com',0,'2014-03-04 21:02:31',NULL,NULL),(42511,28274,'AP','3612440199',0,'2014-03-07 21:00:23',NULL,NULL),(8921,5839,'AP','9565367841',0,'2013-12-25 23:48:31',NULL,NULL),(26495,17050,'TE','4194260045',0,'2014-01-13 02:20:57',NULL,NULL),(23298,15012,'EM','mercades@hartney.name',0,'2014-01-01 12:02:04',NULL,NULL),(23245,14980,'TE','3614805683',0,'2014-01-01 12:01:02',NULL,NULL),(6795,4407,'TE','3302681707',0,'2013-12-25 22:01:19',NULL,NULL),(22339,14404,'EM','dkay5882@aol.com',0,'2013-12-28 03:31:17',NULL,NULL),(11233,7314,'AP','5125164244',0,'2013-12-26 02:03:25',NULL,NULL),(21577,13876,'EM','jennifergoodson@gmail.com',0,'2013-12-26 13:13:12',NULL,NULL),(21332,13705,'AP','3303274776',0,'2013-12-26 13:08:49',NULL,NULL),(32047,20919,'EM','bill@billmccarthyandassociates.com',0,'2014-01-31 21:01:32',NULL,NULL),(35188,23112,'EM','fio915@aol.com',0,'2014-02-12 21:31:18',NULL,NULL),(40523,26897,'TE','8329646161',0,'2014-03-03 01:00:06',NULL,NULL),(40646,26982,'EM','oldboymatt@yahoo.com',0,'2014-03-03 01:00:38',NULL,NULL),(42094,27969,'TE','3372982432',0,'2014-03-06 21:00:49',NULL,NULL),(43862,29106,'TE','4197382540',0,'2014-03-10 21:02:20',NULL,NULL),(130,75,'EM','jclegy@me.com',0,'2013-12-25 17:17:03',NULL,NULL),(466,294,'TE','5134040554',0,'2013-12-25 17:30:38',NULL,NULL),(1294,787,'EM','gloria.cv1953@gmail.com',0,'2013-12-25 18:05:13',NULL,NULL),(6419,4144,'TE','9375093801',0,'2013-12-25 21:48:39',NULL,NULL),(11084,7200,'EM','catherineaburke@gmail.com',0,'2013-12-26 02:00:38',NULL,NULL),(26058,16784,'EM','donald606@sbcglobal.net',0,'2014-01-08 18:25:07',NULL,NULL),(14411,9422,'AP','5757061888',0,'2013-12-26 04:33:09',NULL,NULL),(29041,18751,'EM','Lisagarrison10@yahoo.com',0,'2014-01-17 03:35:43',NULL,NULL),(34390,22557,'AP','5136782747',0,'2014-02-10 21:31:49',NULL,NULL),(35596,23409,'AP','2166181982',0,'2014-02-13 22:01:15',NULL,NULL),(38104,25152,'AP','9156944276',0,'2014-02-21 22:00:17',NULL,NULL),(39748,26287,'TE','5044816712',0,'2014-02-28 06:31:22',NULL,NULL),(27452,17685,'AP','8133910130',0,'2014-01-14 01:32:56',NULL,NULL),(23206,14954,'AP','8303532201',0,'2014-01-01 12:00:18',NULL,NULL),(25892,16690,'TE','8067777582',0,'2014-01-08 18:24:34',NULL,NULL),(25331,16334,'AP','2254543885',0,'2014-01-07 04:02:05',NULL,NULL),(9481,6205,'TE','4197730331',0,'2013-12-26 00:30:43',NULL,NULL),(21276,13670,'AP','9012701125',0,'2013-12-26 13:07:53',NULL,NULL),(1757,1083,'EM','johnyhotrod@sbcglobal.net',0,'2013-12-25 18:16:50',NULL,NULL),(632,393,'EM','s3patmccreary@yahoo.com',0,'2013-12-25 17:45:57',NULL,NULL),(2011,1244,'EM','kliana.oatman@gmail.com',0,'2013-12-25 18:21:02',NULL,NULL),(6128,3944,'EM','lucklady01@hotmail.com',0,'2013-12-25 21:38:01',NULL,NULL),(4749,3040,'EM','colleen@mansfieldtickets.com',0,'2013-12-25 20:18:39',NULL,NULL),(4600,2936,'TE','9372788345',0,'2013-12-25 20:16:07',NULL,NULL),(38899,25714,'TE','9363982118',0,'2014-02-26 09:30:24',NULL,NULL),(40755,27084,'TE','2345428855',0,'2014-03-03 21:30:13',NULL,NULL),(41053,27275,'TE','3255549236',0,'2014-03-04 21:00:18',NULL,NULL),(41192,27356,'EM','ANDREW.WOOD8792@GMAIL.COM',0,'2014-03-04 21:01:09',NULL,NULL),(41822,27809,'AP','4403347584',0,'2014-03-05 21:31:49',NULL,NULL),(97,57,'AP','5174905840',0,'2013-12-25 17:16:34',NULL,NULL),(27222,17526,'EM','lsimes@yahoo.com',0,'2014-01-13 03:01:40',NULL,NULL),(9753,6377,'TE','4195540494',0,'2013-12-26 00:47:51',NULL,NULL),(3738,2373,'TE','9374786614',0,'2013-12-25 19:32:47',NULL,NULL),(23429,15095,'AP','5132843332',0,'2014-01-01 12:04:33',NULL,NULL),(21601,13902,'TE','4195099304',0,'2013-12-26 13:13:43',NULL,NULL),(4490,2856,'TE','2255708161',0,'2013-12-25 20:01:31',NULL,NULL),(5055,3245,'TE','6147173797',0,'2013-12-25 20:46:28',NULL,NULL),(5789,3711,'EM','creatura05@yahoo.com',0,'2013-12-25 21:32:12',NULL,NULL),(11332,7381,'AP','5132534286',0,'2013-12-26 02:15:57',NULL,NULL),(6981,4555,'TE','3303106801',0,'2013-12-25 22:04:37',NULL,NULL),(28292,18237,'EM','bluetal525@gmail.com',0,'2014-01-16 08:44:23',NULL,NULL),(33042,21646,'TE','5134075580',0,'2014-02-05 21:30:48',NULL,NULL),(35072,23031,'AP','8324730103',0,'2014-02-12 21:30:35',NULL,NULL),(39572,26180,'TE','2169249426',0,'2014-02-28 06:30:40',NULL,NULL),(41283,27430,'AP','2253858753',0,'2014-03-04 21:01:46',NULL,NULL),(43042,28617,'BN','8307435099',0,'2014-03-08 21:30:19',NULL,NULL),(43043,28618,'TE','8307435099',0,'2014-03-08 21:30:19',NULL,NULL),(43611,28952,'AP','9852652474',0,'2014-03-10 21:00:51',NULL,NULL),(1491,917,'TE','5138931442',0,'2013-12-25 18:08:42',NULL,NULL),(14438,9435,'TE','5132215451',0,'2013-12-26 04:33:31',NULL,NULL),(13895,9059,'TE','2106832877',0,'2013-12-26 04:06:18',NULL,NULL),(12467,8163,'TE','2259553660',0,'2013-12-26 03:16:25',NULL,NULL),(9778,6398,'AP','5132360803',0,'2013-12-26 00:48:17',NULL,NULL),(26340,16954,'AP','4196183341',0,'2014-01-13 02:20:02',NULL,NULL),(24487,15799,'AP','2063558058',0,'2014-01-03 02:02:48',NULL,NULL),(23603,15240,'TE','4192332468',0,'2014-01-01 12:08:35',NULL,NULL),(22917,14787,'AP','3303401509',1,'2013-12-29 11:13:24',NULL,NULL),(29122,18808,'AP','3307866893',0,'2014-01-17 03:36:02',NULL,NULL),(31161,20292,'BN','3183080718',0,'2014-01-28 21:00:37',NULL,NULL),(35303,23189,'TE','3303283645',0,'2014-02-12 21:32:03',NULL,NULL),(35560,23384,'TE','3205753393',0,'2014-02-13 22:01:01',NULL,NULL),(37998,25066,'EM','kambre15@yahoo.com',0,'2014-02-20 22:01:27',NULL,NULL),(42288,28081,'EM','ssmithl3131@gmail.com',0,'2014-03-06 21:01:58',NULL,NULL),(42777,28451,'AP','2258196551',0,'2014-03-07 21:31:20',NULL,NULL),(5436,3482,'TE','5137393460',0,'2013-12-25 21:20:12',NULL,NULL),(26262,16901,'TE','6232620595',0,'2014-01-13 02:19:33',NULL,NULL),(25367,16359,'TE','9373740630',0,'2014-01-07 04:02:42',NULL,NULL),(23026,14854,'TE','3306087346',1,'2013-12-29 11:15:10',NULL,NULL),(22955,14807,'TE','2253558464',1,'2013-12-29 11:13:57',NULL,NULL),(22909,14783,'TE','3303346597',1,'2013-12-29 11:13:16',NULL,NULL),(21097,13566,'TE','2256157178',0,'2013-12-26 13:04:30',NULL,NULL),(29350,18965,'TE','7135010103',0,'2014-01-20 08:05:57',NULL,NULL),(29954,19384,'BN','9563268932',1,'2014-01-22 03:22:43',NULL,NULL),(36502,24031,'EM','eureco19@gmail.com',0,'2014-02-15 22:00:53',NULL,NULL),(37520,24708,'AP','4695701993',0,'2014-02-20 04:35:38',NULL,NULL),(37531,24713,'EM','jeanniesteelers@gmail.com',0,'2014-02-20 04:36:31',NULL,NULL),(38410,25378,'AP','5134776484',0,'2014-02-25 21:30:44',NULL,NULL),(38421,25387,'EM','jenbeers@neo.rr.com',0,'2014-02-25 21:30:50',NULL,NULL),(38874,25694,'EM','eorcutt23@gmail.com',0,'2014-02-26 09:30:14',NULL,NULL),(2018,1250,'AP','2165025817',0,'2013-12-25 18:21:12',NULL,NULL),(9776,6397,'EM','larring1@yahoo.com',0,'2013-12-26 00:48:15',NULL,NULL),(23714,15305,'TE','2257787079',1,'2014-01-02 04:22:58',NULL,NULL),(22629,14593,'TE','3303109592',0,'2013-12-28 03:36:11',NULL,NULL),(22172,14281,'EM','Claveau@cableone.net',0,'2013-12-27 02:06:21',NULL,NULL),(8840,5791,'TE','3308484604',0,'2013-12-25 23:47:16',NULL,NULL),(4914,3157,'TE','2163514620',0,'2013-12-25 20:31:11',NULL,NULL),(20798,13364,'TE','4193660090',0,'2013-12-26 12:59:34',NULL,NULL),(4334,2767,'TE','3306456292',0,'2013-12-25 19:49:27',NULL,NULL),(27281,17566,'EM','ROBOT1972@MAIL.RU',0,'2014-01-14 01:31:59',NULL,NULL),(12158,7943,'TE','9856305493',0,'2013-12-26 03:06:56',NULL,NULL),(12136,7929,'AP','2256208215',0,'2013-12-26 03:06:34',NULL,NULL),(29173,18850,'EM','PPSTJ007@LIVE.COM',0,'2014-01-17 03:36:15',NULL,NULL),(29551,19097,'TE','4406237185',0,'2014-01-21 08:44:36',NULL,NULL),(29553,19097,'EM','TBERRYII@HOTMAIL.COM',0,'2014-01-21 08:44:36',NULL,NULL),(30486,19768,'AP','9015987927',0,'2014-01-23 21:01:27',NULL,NULL),(36473,24013,'TE','6142308984',0,'2014-02-15 22:00:42',NULL,NULL),(39282,25991,'AP','6627010138',0,'2014-02-26 21:01:57',NULL,NULL),(40373,26795,'AP','4193228433',0,'2014-03-01 21:00:21',NULL,NULL),(43769,29055,'AP','6149897753',0,'2014-03-10 21:01:49',NULL,NULL),(1074,660,'EM','landpfrey2@yahoo.com',0,'2013-12-25 18:01:52',NULL,NULL),(10021,6556,'AP','2547449297',0,'2013-12-26 00:52:18',NULL,NULL),(8633,5669,'AP','9375276363',0,'2013-12-25 23:32:01',NULL,NULL),(7310,4756,'AP','8327626198',0,'2013-12-25 22:15:23',NULL,NULL),(7019,4584,'TE','3306880599',0,'2013-12-25 22:05:18',NULL,NULL),(25880,16683,'EM','TTD777@PEOPLEPC.COM',0,'2014-01-08 18:24:32',NULL,NULL),(3707,2351,'AP','2146219116',0,'2013-12-25 19:32:14',NULL,NULL),(23752,15323,'TE','8322573238',1,'2014-01-02 04:23:38',NULL,NULL),(5492,3512,'TE','9012832216',0,'2013-12-25 21:21:02',NULL,NULL),(21164,13612,'EM','darlene@HRPIInc.com',0,'2013-12-26 13:05:39',NULL,NULL),(11947,7782,'AP','2103961777',0,'2013-12-26 03:03:13',NULL,NULL),(20267,13062,'AP','6147749398',0,'2013-12-26 12:51:05',NULL,NULL),(30988,20158,'AP','4405320633',0,'2014-01-27 21:01:08',NULL,NULL),(31989,20886,'EM','lzaerr@bright.net',0,'2014-01-31 21:01:11',NULL,NULL),(33020,21633,'AP','3613899319',0,'2014-02-05 21:30:42',NULL,NULL),(33269,21785,'TE','9374088720',0,'2014-02-06 21:00:40',NULL,NULL),(33303,21808,'EM','Carriecroskey@yahoo.com',0,'2014-02-06 21:00:53',NULL,NULL),(34914,22910,'TE','5137526453',0,'2014-02-11 21:02:48',NULL,NULL),(40476,26865,'TE','5129949733',0,'2014-03-01 21:00:59',NULL,NULL),(42925,28543,'TE','3304283539',0,'2014-03-07 21:32:16',NULL,NULL),(42994,28593,'AP','9376991245',0,'2014-03-08 21:30:04',NULL,NULL),(22,15,'TE','5133171569',0,'2013-12-25 17:15:22',NULL,NULL),(5777,3699,'EM','whododrums@yahoo.com',0,'2013-12-25 21:31:57',NULL,NULL),(21804,14048,'AP','5132256680',0,'2013-12-27 02:00:13',NULL,NULL),(20332,13100,'TE','4193683463',0,'2013-12-26 12:52:09',NULL,NULL),(12365,8092,'TE','5133836815',0,'2013-12-26 03:10:44',NULL,NULL),(24205,15636,'TE','5046001028',1,'2014-01-02 04:33:39',NULL,NULL),(7292,4748,'EM','shinobimusashi@yahoo.com',0,'2013-12-25 22:15:08',NULL,NULL),(5894,3780,'TE','5132355214',0,'2013-12-25 21:33:58',NULL,NULL),(29898,19347,'EM','bartsu@gmail.com',1,'2014-01-22 03:22:24',NULL,NULL),(32142,20994,'TE','7403353549',0,'2014-02-01 19:00:25',NULL,NULL),(32408,21176,'EM','kathleen@outlook.com',0,'2014-02-03 21:00:41',NULL,NULL),(42718,28415,'TE','2163335983',0,'2014-03-07 21:30:59',NULL,NULL),(42967,28574,'TE','8307733161',0,'2014-03-08 21:00:03',NULL,NULL),(27826,17931,'TE','9406821783',0,'2014-01-15 02:06:35',NULL,NULL),(338,211,'EM','walkermystic@aol.com',0,'2013-12-25 17:20:28',NULL,NULL),(25954,16718,'AP','9562229350',0,'2014-01-08 18:24:45',NULL,NULL),(25315,16325,'AP','3189460808',0,'2014-01-07 04:01:49',NULL,NULL),(24401,15754,'AP','3254561003',0,'2014-01-03 02:01:16',NULL,NULL),(23913,15428,'AP','9037808985',1,'2014-01-02 04:27:40',NULL,NULL),(1723,1056,'TE','2102518301',0,'2013-12-25 18:16:10',NULL,NULL),(22456,14481,'AP','3615584380',0,'2013-12-28 03:33:17',NULL,NULL),(21402,13761,'TE','6019961310',0,'2013-12-26 13:10:14',NULL,NULL),(8825,5779,'TE','6149449056',0,'2013-12-25 23:47:00',NULL,NULL),(20806,13367,'EM','veca@cinci.rr.com',0,'2013-12-26 12:59:40',NULL,NULL),(2208,1355,'EM','craig.biddle@gmail.com',0,'2013-12-25 18:45:23',NULL,NULL),(2613,1591,'AP','8322367444',0,'2013-12-25 18:51:45',NULL,NULL),(7472,4864,'TE','4197821870',0,'2013-12-25 22:30:46',NULL,NULL),(8018,5238,'TE','2164090098',0,'2013-12-25 23:04:53',NULL,NULL),(2735,1659,'TE','5125356603',0,'2013-12-25 18:53:35',NULL,NULL),(32971,21583,'TE','3307147196',0,'2014-02-05 21:30:26',NULL,NULL),(36097,23741,'EM','DERANKINS2150@CINCI.RR.COM',0,'2014-02-14 21:31:04',NULL,NULL),(36445,23999,'EM','m.aziz@sbcglobal.net',0,'2014-02-15 22:00:32',NULL,NULL),(37021,24375,'EM','flashattack81@yahoo.com',0,'2014-02-18 22:00:41',NULL,NULL),(40488,26871,'EM','resistor1k@yahoo.com',0,'2014-03-01 21:01:03',NULL,NULL),(10282,6713,'AP','7138252887',0,'2013-12-26 01:02:20',NULL,NULL),(918,567,'EM','rodrippie@yahoo.com',0,'2013-12-25 17:50:29',NULL,NULL),(7923,5163,'EM','mlbspnc@aol.com',0,'2013-12-25 23:03:07',NULL,NULL),(23435,15099,'EM','Trisha2oo3@aol.com',0,'2014-01-01 12:04:40',NULL,NULL),(7828,5110,'AP','3612071733',0,'2013-12-25 23:01:40',NULL,NULL),(20224,13028,'TE','7403508383',0,'2013-12-26 12:50:17',NULL,NULL),(13733,8950,'TE','3308272372',0,'2013-12-26 04:03:34',NULL,NULL),(12274,8031,'TE','6622990901',0,'2013-12-26 03:09:08',NULL,NULL),(7776,5073,'TE','5122495786',0,'2013-12-25 23:00:48',NULL,NULL),(7646,4977,'EM','m_rachey1069@hotmail.com',0,'2013-12-25 22:46:38',NULL,NULL),(29210,18870,'TE','9856285715',0,'2014-01-17 03:36:24',NULL,NULL),(30580,19841,'TE','5043618163',0,'2014-01-24 21:00:25',NULL,NULL),(32964,21580,'TE','3308589095',0,'2014-02-05 21:30:25',NULL,NULL),(33121,21695,'EM','vajchorvang51@hotmail.com',0,'2014-02-05 21:31:08',NULL,NULL),(33472,21928,'TE','9158558866',0,'2014-02-07 19:00:10',NULL,NULL),(37794,24941,'EM','CAROLINEHUGHES149@GMAIL.COM',0,'2014-02-20 22:00:05',NULL,NULL),(41026,27258,'TE','5672144115',0,'2014-03-03 21:31:58',NULL,NULL),(41251,27408,'AP','4403150641',0,'2014-03-04 21:01:34',NULL,NULL),(41463,27552,'AP','9564561808',0,'2014-03-04 21:30:12',NULL,NULL),(43832,29093,'EM','jeremesanders@gmail.com',0,'2014-03-10 21:02:11',NULL,NULL),(27732,17880,'AP','4405704809',0,'2014-01-15 02:06:16',NULL,NULL),(1391,850,'TE','2169389189',0,'2013-12-25 18:06:53',NULL,NULL),(25531,16469,'EM','karenmcgrady@hotmail.com',0,'2014-01-07 04:05:54',NULL,NULL),(1676,1028,'EM','gary@ttwusa.com',0,'2013-12-25 18:15:28',NULL,NULL),(1835,1135,'TE','9852857884',0,'2013-12-25 18:18:11',NULL,NULL),(2440,1495,'TE','9373698579',0,'2013-12-25 18:49:09',NULL,NULL),(8075,5286,'TE','3306771798',0,'2013-12-25 23:05:54',NULL,NULL),(2630,1601,'TE','9567922754',0,'2013-12-25 18:52:02',NULL,NULL),(10042,6569,'TE','8064719728',0,'2013-12-26 00:52:38',NULL,NULL),(6915,4502,'TE','9727529968',0,'2013-12-25 22:03:25',NULL,NULL),(20187,13007,'TE','5136676921',0,'2013-12-26 12:49:41',NULL,NULL),(32648,21354,'EM','mrsbrantley0511@gmail.com',0,'2014-02-04 21:00:39',NULL,NULL),(34005,22306,'EM','connorkabbes@gmail.com',0,'2014-02-10 11:00:40',NULL,NULL),(35292,23181,'EM','adambarnett22@yahoo.com',0,'2014-02-12 21:31:58',NULL,NULL),(38243,25248,'EM','GLORIABOHN.2013@GMAIL.COM',0,'2014-02-21 22:01:12',NULL,NULL),(38891,25708,'TE','9568258326',0,'2014-02-26 09:30:22',NULL,NULL),(40771,27093,'EM','lorilitvin@yahoo.com',0,'2014-03-03 21:30:18',NULL,NULL),(808,501,'AP','6147691381',0,'2013-12-25 17:48:43',NULL,NULL),(2718,1651,'TE','8474396442',0,'2013-12-25 18:53:21',NULL,NULL),(26646,17142,'EM','munsonmichelle@att.net',0,'2014-01-13 02:21:53',NULL,NULL),(7223,4704,'TE','4194601532',0,'2013-12-25 22:08:31',NULL,NULL),(2742,1663,'TE','9032805494',0,'2013-12-25 18:53:41',NULL,NULL),(21454,13789,'AP','6019067139',0,'2013-12-26 13:11:01',NULL,NULL),(21010,13517,'EM','Fredorlon123@gmail.com',0,'2013-12-26 13:03:07',NULL,NULL),(6423,4151,'AP','7403982305',0,'2013-12-25 21:48:45',NULL,NULL),(14564,9515,'AP','5133258075',0,'2013-12-26 04:35:31',NULL,NULL),(3606,2277,'TE','5134044002',0,'2013-12-25 19:30:29',NULL,NULL),(12132,7928,'TE','5046553895',0,'2013-12-26 03:06:31',NULL,NULL),(11884,7733,'AP','6147385369',0,'2013-12-26 03:02:05',NULL,NULL),(11626,7561,'EM','tyfoust@hotmail.com',0,'2013-12-26 02:33:30',NULL,NULL),(5985,3845,'AP','5045831118',0,'2013-12-25 21:35:29',NULL,NULL),(31972,20876,'TE','6012683217',0,'2014-01-31 21:01:05',NULL,NULL),(32738,21417,'EM','coreyaustin@ymail.com',0,'2014-02-04 21:01:11',NULL,NULL),(33321,21827,'TE','8325120667',0,'2014-02-06 21:01:02',NULL,NULL),(42057,27948,'EM','vguad@outlook.com',0,'2014-03-06 21:00:36',NULL,NULL),(42142,27998,'EM','Desirae.robinson@yahoo.com',0,'2014-03-06 21:01:07',NULL,NULL),(27853,17944,'TE','2106859341',0,'2014-01-15 02:06:40',NULL,NULL),(10441,6805,'AP','8063177261',0,'2013-12-26 01:30:08',NULL,NULL),(1972,1219,'EM','RebCon11@yopmail.com',0,'2013-12-25 18:20:22',NULL,NULL),(7499,4887,'TE','2252455010',0,'2013-12-25 22:31:24',NULL,NULL),(24056,15532,'AP','2253646893',1,'2014-01-02 04:30:40',NULL,NULL),(2587,1579,'TE','5122552507',0,'2013-12-25 18:51:24',NULL,NULL),(5739,3677,'EM','denergy55@yahoo.com',0,'2013-12-25 21:31:23',NULL,NULL),(21055,13543,'TE','5042205135',0,'2013-12-26 13:03:51',NULL,NULL),(2685,1631,'AP','4325995312',0,'2013-12-25 18:52:50',NULL,NULL),(34562,22665,'EM','amyrn1972@gmail.com',0,'2014-02-11 21:00:38',NULL,NULL),(14297,9352,'AP','5046552550',0,'2013-12-26 04:31:16',NULL,NULL),(14106,9223,'EM','smith44857@yahoo.com',0,'2013-12-26 04:10:16',NULL,NULL),(31770,20739,'TE','9376214672',0,'2014-01-30 21:01:22',NULL,NULL),(30143,19532,'AP','4197640545',0,'2014-01-23 03:02:21',NULL,NULL),(21134,13589,'TE','2253685577',0,'2013-12-26 13:05:08',NULL,NULL),(23028,14854,'EM','quitenicely@gmail.com',1,'2013-12-29 11:15:11',NULL,NULL),(39374,26040,'EM','jringler61@yahoo.com',0,'2014-02-26 21:02:27',NULL,NULL),(39990,26485,'TE','2257186978',0,'2014-02-28 21:00:07',NULL,NULL),(41547,27625,'BN','6145157938',0,'2014-03-05 21:30:07',NULL,NULL),(42312,28096,'TE','6017300179',0,'2014-03-06 21:02:07',NULL,NULL),(10024,6558,'TE','4697590262',0,'2013-12-26 00:52:21',NULL,NULL),(34226,22450,'TE','2146299224',0,'2014-02-10 21:30:46',NULL,NULL),(20443,13167,'EM','jeremy.burne@gmail.com',0,'2013-12-26 12:53:59',NULL,NULL),(22693,14637,'TE','5136252584',0,'2013-12-28 03:37:20',NULL,NULL),(28960,18692,'TE','5047177079',0,'2014-01-17 03:35:25',NULL,NULL),(23764,15328,'TE','9157579581',1,'2014-01-02 04:23:49',NULL,NULL),(1609,989,'EM','mtperdue1951@yahoo.com',0,'2013-12-25 18:10:34',NULL,NULL),(26067,16790,'AP','5136231187',0,'2014-01-13 02:18:05',NULL,NULL),(36485,24019,'EM','hard-2-forget@hotmail.com',0,'2014-02-15 22:00:46',NULL,NULL),(36799,24229,'AP','7576751585',0,'2014-02-16 19:00:33',NULL,NULL),(4308,2749,'EM','jackman.sk@hotmail.com',0,'2013-12-25 19:49:02',NULL,NULL),(35103,23057,'TE','5047232355',0,'2014-02-12 21:30:49',NULL,NULL),(12211,7978,'EM','thecker1@kent.edu',0,'2013-12-26 03:07:54',NULL,NULL),(13956,9099,'TE','5135532371',0,'2013-12-26 04:07:20',NULL,NULL),(23693,15295,'AP','5046001731',1,'2014-01-02 04:22:37',NULL,NULL),(23935,15445,'TE','7132317713',1,'2014-01-02 04:28:11',NULL,NULL),(38770,25633,'TE','6149621354',0,'2014-02-26 08:30:24',NULL,NULL),(40265,26712,'AP','9377258956',0,'2014-02-28 21:31:39',NULL,NULL),(354,218,'TE','9089064813',0,'2013-12-25 17:20:42',NULL,NULL),(22448,14476,'TE','5128282675',0,'2013-12-28 03:33:10',NULL,NULL),(7276,4741,'TE','5136622703',0,'2013-12-25 22:09:28',NULL,NULL),(29945,19380,'TE','6014106332',1,'2014-01-22 03:22:41',NULL,NULL),(29153,18836,'TE','4403619820',0,'2014-01-17 03:36:11',NULL,NULL),(27881,17967,'TE','3307606069',0,'2014-01-15 02:06:48',NULL,NULL),(27707,17857,'AP','4195123195',0,'2014-01-15 02:06:09',NULL,NULL),(26096,16805,'AP','9155490347',0,'2014-01-13 02:18:13',NULL,NULL),(40729,27067,'AP','3187801559',0,'2014-03-03 21:30:03',NULL,NULL),(43005,28599,'TE','4404577545',0,'2014-03-08 21:30:07',NULL,NULL),(43110,28657,'TE','3185601436',0,'2014-03-08 21:30:42',NULL,NULL),(790,493,'AP','3372775766',0,'2013-12-25 17:48:29',NULL,NULL),(34465,22614,'AP','3615621866',0,'2014-02-11 21:00:07',NULL,NULL),(27470,17696,'AP','5042170151',0,'2014-01-14 01:33:02',NULL,NULL),(25554,16484,'TE','4404541885',0,'2014-01-07 04:06:22',NULL,NULL),(10881,7063,'AP','9175175611',0,'2013-12-26 01:50:00',NULL,NULL),(1111,680,'AP','3303127825',0,'2013-12-25 18:02:23',NULL,NULL),(3377,2122,'TE','6145959798',0,'2013-12-25 19:17:45',NULL,NULL),(38492,25437,'BN','3617460646',0,'2014-02-25 21:31:18',NULL,NULL),(41345,27466,'EM','mrs_t.ranck@yahoo.com',0,'2014-03-04 21:02:09',NULL,NULL),(20678,13296,'AP','9034089929',0,'2013-12-26 12:57:38',NULL,NULL),(35887,23603,'TE','4192289375',0,'2014-02-13 22:03:09',NULL,NULL),(4635,2957,'AP','9035214786',0,'2013-12-25 20:16:40',NULL,NULL),(2713,1647,'AP','9039161157',0,'2013-12-25 18:53:15',NULL,NULL),(29958,19386,'TE','4194241182',1,'2014-01-22 03:22:45',NULL,NULL),(37027,24378,'TE','5135820663',0,'2014-02-18 22:00:43',NULL,NULL),(40226,26683,'EM','dmyles2001@yahoo.com',0,'2014-02-28 21:31:24',NULL,NULL),(43338,28788,'TE','4193403963',0,'2014-03-09 21:00:40',NULL,NULL),(14056,9186,'TE','4197331988',0,'2013-12-26 04:09:18',NULL,NULL),(36152,23794,'EM','augie37@aol.com',0,'2014-02-14 21:31:26',NULL,NULL),(29900,19348,'AP','5136041132',1,'2014-01-22 03:22:25',NULL,NULL),(10796,7017,'TE','9566475428',0,'2013-12-26 01:48:42',NULL,NULL),(27486,17706,'TE','2253159598',0,'2014-01-14 01:33:07',NULL,NULL),(9320,6102,'TE','4409673924',0,'2013-12-26 00:15:15',NULL,NULL),(6497,4202,'TE','9568000802',0,'2013-12-25 21:49:56',NULL,NULL),(37514,24704,'EM','jeanniesteelers@gmail.com',0,'2014-02-20 04:34:55',NULL,NULL),(10669,6932,'AP','3304216429',0,'2013-12-26 01:46:34',NULL,NULL),(14590,9540,'AP','3306120977',0,'2013-12-26 04:36:00',NULL,NULL),(34186,22423,'TE','5042962424',0,'2014-02-10 21:30:31',NULL,NULL),(28955,18690,'AP','3186259928',0,'2014-01-17 03:35:24',NULL,NULL),(26283,16916,'TE','9374179553',0,'2014-01-13 02:19:41',NULL,NULL),(26087,16800,'EM','creshas_pinky@yahoo.com',0,'2014-01-13 02:18:11',NULL,NULL),(23679,15289,'TE','9859913337',1,'2014-01-02 04:22:24',NULL,NULL),(39132,25883,'AP','9406319458',0,'2014-02-26 21:00:59',NULL,NULL),(10745,6986,'TE','6142799048',0,'2013-12-26 01:47:51',NULL,NULL),(20991,13509,'TE','5044327584',0,'2013-12-26 13:02:50',NULL,NULL),(35699,23480,'EM','beckyd765@yahoo.com',0,'2014-02-13 22:01:54',NULL,NULL),(22913,14786,'TE','6144466321',1,'2013-12-29 11:13:21',NULL,NULL),(27957,18018,'EM','susank76@aol.com',0,'2014-01-15 02:07:05',NULL,NULL),(35137,23077,'TE','5044732856',0,'2014-02-12 21:31:00',NULL,NULL),(31620,20627,'TE','8302550697',0,'2014-01-30 21:00:26',NULL,NULL),(29509,19078,'TE','3183963848',0,'2014-01-21 08:44:24',NULL,NULL),(39196,25924,'TE','9032407689',0,'2014-02-26 21:01:22',NULL,NULL),(39401,26054,'TE','3308618602',0,'2014-02-26 21:02:35',NULL,NULL),(6060,3898,'EM','lindseybarta@yahoo.com',0,'2013-12-25 21:36:48',NULL,NULL),(36354,23942,'EM','snealaabco@woh.rr.com',0,'2014-02-15 21:00:09',NULL,NULL),(2675,1624,'TE','9157304535',0,'2013-12-25 18:52:40',NULL,NULL),(30296,19626,'EM','smechling@thlandscapegroup.net',0,'2014-01-23 21:00:07',NULL,NULL),(24381,15743,'EM','T.EDWARDS1908@GMAIL.COM',0,'2014-01-03 02:00:55',NULL,NULL),(20438,13161,'TE','7407033151',0,'2013-12-26 12:53:52',NULL,NULL),(22498,14504,'AP','8063363030',0,'2013-12-28 03:33:53',NULL,NULL),(35621,23423,'EM','terlopez56@gmail.com',0,'2014-02-13 22:01:24',NULL,NULL),(14136,9257,'AP','9152535151',0,'2013-12-26 04:15:11',NULL,NULL),(10634,6917,'AP','2166780731',0,'2013-12-26 01:46:06',NULL,NULL),(9014,5915,'AP','5756498887',0,'2013-12-25 23:50:08',NULL,NULL),(3921,2487,'AP','5042967009',0,'2013-12-25 19:35:42',NULL,NULL),(8851,5800,'EM','landfeld@sbcglobal.net',0,'2013-12-25 23:47:29',NULL,NULL),(24713,15945,'AP','3045504671',0,'2014-01-03 02:07:18',NULL,NULL),(37411,24638,'TE','9856624518',0,'2014-02-20 04:19:30',NULL,NULL),(42872,28512,'TE','3306774001',0,'2014-03-07 21:31:55',NULL,NULL),(1693,1040,'AP','9564043511',0,'2013-12-25 18:15:45',NULL,NULL),(34475,22620,'AP','5052352666',0,'2014-02-11 21:00:10',NULL,NULL),(11232,7314,'TE','5125164244',0,'2013-12-26 02:03:24',NULL,NULL),(14043,9175,'TE','9373938212',0,'2013-12-26 04:09:02',NULL,NULL),(20306,13087,'AP','3303919186',0,'2013-12-26 12:51:46',NULL,NULL),(26843,17269,'EM','IRBFISH2@YAHOO.COM',0,'2014-01-13 02:23:21',NULL,NULL),(38606,25515,'TE','9372058603',0,'2014-02-25 21:32:03',NULL,NULL),(42482,28243,'TE','5134804380',0,'2014-03-07 21:00:11',NULL,NULL),(14114,9229,'TE','9376180149',0,'2013-12-26 04:10:26',NULL,NULL),(14093,9215,'AP','5136673696',0,'2013-12-26 04:10:01',NULL,NULL),(23602,15239,'AP','4199101095',0,'2014-01-01 12:08:33',NULL,NULL),(11905,7745,'EM','LSCHOFFNER@GMAIL.COM',0,'2013-12-26 03:02:24',NULL,NULL),(10457,6812,'TE','3307249657',0,'2013-12-26 01:30:22',NULL,NULL),(40624,26965,'TE','3306552465',0,'2014-03-03 01:00:32',NULL,NULL),(40796,27112,'EM','discordiandreamer@gmail.com',0,'2014-03-03 21:30:27',NULL,NULL),(41672,27707,'TE','7133852581',0,'2014-03-05 21:30:51',NULL,NULL),(41983,27907,'TE','2144358700',0,'2014-03-06 21:00:12',NULL,NULL),(43298,28767,'TE','8324473892',0,'2014-03-09 21:00:26',NULL,NULL),(22900,14775,'TE','2145178397',1,'2013-12-29 11:13:04',NULL,NULL),(28212,18187,'TE','9370844098',0,'2014-01-15 02:08:02',NULL,NULL),(40340,26770,'EM','reskim21@gmail.com',0,'2014-03-01 21:00:08',NULL,NULL),(9582,6274,'EM','bostice@fuse.net',0,'2013-12-26 00:45:11',NULL,NULL),(36539,24059,'EM','amber.marq@gmail.com',0,'2014-02-15 22:01:08',NULL,NULL),(26686,17165,'TE','5042728862',0,'2014-01-13 02:22:05',NULL,NULL),(32773,21441,'AP','6015294788',0,'2014-02-04 21:01:24',NULL,NULL),(38549,25472,'AP','9047043120',0,'2014-02-25 21:31:38',NULL,NULL),(38827,25667,'TE','6623868880',0,'2014-02-26 08:30:49',NULL,NULL),(39348,26027,'TE','6013450966',0,'2014-02-26 21:02:19',NULL,NULL),(39410,26059,'TE','5136338288',0,'2014-02-26 21:02:38',NULL,NULL),(41767,27772,'AP','2255055181',0,'2014-03-05 21:31:27',NULL,NULL),(43681,28991,'AP','3308150706',0,'2014-03-10 21:01:14',NULL,NULL),(13663,8907,'TE','3303429413',0,'2013-12-26 04:02:28',NULL,NULL),(29894,19343,'EM','blacksmith044@hotmail.com',1,'2014-01-22 03:22:23',NULL,NULL),(29911,19357,'TE','4196027888',1,'2014-01-22 03:22:29',NULL,NULL),(38310,25304,'TE','6148066019',0,'2014-02-25 21:00:29',NULL,NULL),(41518,27604,'TE','4403170019',0,'2014-03-05 21:00:25',NULL,NULL),(42450,28198,'TE','8062724991',0,'2014-03-06 21:30:07',NULL,NULL),(492,313,'AP','2253337997',0,'2013-12-25 17:31:06',NULL,NULL),(36765,24206,'EM','DARNELLVIS@GMAIL.COM',0,'2014-02-16 19:00:20',NULL,NULL),(36303,23903,'AP','4193678082',0,'2014-02-14 21:32:25',NULL,NULL),(24839,16021,'TE','3185729778',0,'2014-01-04 02:02:10',NULL,NULL),(2710,1646,'AP','9039161157',0,'2013-12-25 18:53:14',NULL,NULL),(4903,3149,'TE','8309975424',0,'2013-12-25 20:30:59',NULL,NULL),(13937,9089,'EM','ericjohnson63005@aol.com',0,'2013-12-26 04:07:02',NULL,NULL),(40160,26635,'AP','9152384185',0,'2014-02-28 21:31:00',NULL,NULL),(40248,26697,'TE','3183523894',0,'2014-02-28 21:31:31',NULL,NULL),(41970,27900,'TE','9373718806',0,'2014-03-05 21:32:45',NULL,NULL),(5263,3380,'AP','4174835673',0,'2013-12-25 21:17:29',NULL,NULL),(2739,1662,'TE','3252347668',0,'2013-12-25 18:53:39',NULL,NULL),(21991,14165,'TE','9857302248',0,'2013-12-27 02:03:17',NULL,NULL),(26691,17168,'AP','3188039386',0,'2014-01-13 02:22:06',NULL,NULL),(12434,8146,'TE','3304087333',0,'2013-12-26 03:15:53',NULL,NULL),(11182,7272,'TE','9036936881',0,'2013-12-26 02:02:27',NULL,NULL),(2961,1833,'AP','3306719767',0,'2013-12-25 18:57:28',NULL,NULL),(39812,26328,'AP','2282384076',0,'2014-02-28 06:31:39',NULL,NULL),(39956,26451,'TE','6017503733',0,'2014-02-28 07:30:26',NULL,NULL),(41291,27434,'AP','5045799144',0,'2014-03-04 21:01:48',NULL,NULL),(41553,27628,'EM','PPPULJIC@YAHOO.COM',0,'2014-03-05 21:30:09',NULL,NULL),(8133,5324,'EM','Loan.nguyen45@yahoo.com',0,'2013-12-25 23:06:55',NULL,NULL),(31530,20547,'AP','5132353401',0,'2014-01-29 21:01:39',NULL,NULL),(31431,20489,'EM','bwestfall1@neo.rr.com',0,'2014-01-29 21:01:05',NULL,NULL),(8037,5259,'TE','3306010461',0,'2013-12-25 23:05:19',NULL,NULL),(28517,18382,'AP','4403825189',0,'2014-01-16 08:45:35',NULL,NULL),(9077,5952,'EM','morrrosalyn9@aol.com',0,'2013-12-25 23:51:07',NULL,NULL),(22935,14797,'TE','2167021303',1,'2013-12-29 11:13:39',NULL,NULL),(529,332,'TE','2814097223',0,'2013-12-25 17:31:42',NULL,NULL),(21293,13681,'EM','david.lawmoore@gmail.com',0,'2013-12-26 13:08:11',NULL,NULL),(4418,2815,'EM','Ashley05_03@yahoo.com',0,'2013-12-25 20:00:22',NULL,NULL),(38864,25687,'TE','6018299101',0,'2014-02-26 09:30:09',NULL,NULL),(9112,5971,'EM','baatkinson01@my.iccms.edu',0,'2013-12-25 23:51:38',NULL,NULL),(21446,13786,'TE','7692511950',0,'2013-12-26 13:10:54',NULL,NULL),(11726,7633,'TE','4403170498',0,'2013-12-26 02:46:19',NULL,NULL),(40866,27156,'TE','2165435022',0,'2014-03-03 21:30:56',NULL,NULL),(312,192,'TE','4198361154',0,'2013-12-25 17:20:00',NULL,NULL),(26616,17125,'AP','9378308291',0,'2014-01-13 02:21:44',NULL,NULL),(37564,24735,'EM','msswiger@yahoo.com',0,'2014-02-20 04:40:00',NULL,NULL),(26420,17002,'TE','4408298658',0,'2014-01-13 02:20:31',NULL,NULL),(21891,14104,'TE','9372433805',0,'2013-12-27 02:01:40',NULL,NULL),(21297,13683,'TE','3302562633',0,'2013-12-26 13:08:15',NULL,NULL),(29538,19091,'EM','thomasmurach@sbcglobal.net',0,'2014-01-21 08:44:32',NULL,NULL),(28343,18264,'TE','3614827263',0,'2014-01-16 08:44:38',NULL,NULL),(362,223,'TE','3372553293',0,'2013-12-25 17:20:49',NULL,NULL),(34492,22628,'AP','9156333426',0,'2014-02-11 21:00:15',NULL,NULL),(20494,13195,'EM','pvailduff@aol.com',0,'2013-12-26 12:54:47',NULL,NULL),(22294,14368,'TE','9376264519',0,'2013-12-28 03:30:28',NULL,NULL),(32552,21282,'EM','terri92061@yahoo.com',0,'2014-02-03 21:01:38',NULL,NULL),(20910,13448,'TE','4123524039',0,'2013-12-26 13:01:24',NULL,NULL),(20771,13346,'EM','pwbarbosa@gmail.com',0,'2013-12-26 12:59:05',NULL,NULL),(25810,16633,'TE','6148610779',0,'2014-01-08 18:24:15',NULL,NULL),(40057,26554,'EM','kjsupe@gmail.com',0,'2014-02-28 21:30:16',NULL,NULL),(42729,28420,'EM','tganttt@gmail.com',0,'2014-03-07 21:31:02',NULL,NULL),(4388,2796,'TE','9373029230',0,'2013-12-25 19:50:18',NULL,NULL),(10626,6914,'EM','ch398600@yahoo.com',0,'2013-12-26 01:45:59',NULL,NULL),(36373,23955,'EM','artistjrock@aol.com',0,'2014-02-15 22:00:06',NULL,NULL),(35240,23143,'AP','3306082923',0,'2014-02-12 21:31:37',NULL,NULL),(10768,7000,'TE','2148814328',0,'2013-12-26 01:48:15',NULL,NULL),(31518,20539,'AP','3303147262',0,'2014-01-29 21:01:34',NULL,NULL),(12226,7990,'EM','steve@hockstra.com',0,'2013-12-26 03:08:10',NULL,NULL),(43721,29022,'BN','4404207346',0,'2014-03-10 21:01:31',NULL,NULL),(27204,17517,'EM','rwmitchelljr@att.net',0,'2014-01-13 03:01:34',NULL,NULL),(30297,19627,'TE','3303307675',0,'2014-01-23 21:00:07',NULL,NULL),(11220,7298,'EM','j58g@aol.com',0,'2013-12-26 02:03:05',NULL,NULL),(6368,4102,'AP','5127716831',0,'2013-12-25 21:47:46',NULL,NULL),(9653,6314,'AP','9377258915',0,'2013-12-26 00:46:17',NULL,NULL),(38585,25499,'EM','evelyn_sharp2006@yahoo.com',0,'2014-02-25 21:31:54',NULL,NULL),(33264,21782,'TE','6147175760',0,'2014-02-06 21:00:39',NULL,NULL),(8642,5678,'TE','9372188423',0,'2013-12-25 23:32:15',NULL,NULL),(5758,3689,'TE','4193413302',0,'2013-12-25 21:31:41',NULL,NULL),(25403,16383,'TE','9564898797',0,'2014-01-07 04:03:23',NULL,NULL),(20723,13319,'AP','2103554606',0,'2013-12-26 12:58:19',NULL,NULL),(41009,27248,'AP','9209156473',0,'2014-03-03 21:31:51',NULL,NULL),(42531,28295,'EM','bengalcincy05@gmail.com',0,'2014-03-07 21:00:30',NULL,NULL),(138,83,'TE','4409332433',0,'2013-12-25 17:17:12',NULL,NULL),(25831,16654,'AP','6622302117',0,'2014-01-08 18:24:21',NULL,NULL),(22822,14717,'AP','5132250246',1,'2013-12-29 11:09:28',NULL,NULL),(33462,21921,'TE','9155956753',0,'2014-02-07 19:00:06',NULL,NULL),(6434,4157,'TE','6145357135',0,'2013-12-25 21:48:55',NULL,NULL),(1064,656,'TE','9373080893',0,'2013-12-25 18:01:44',NULL,NULL),(13946,9094,'TE','9372489968',0,'2013-12-26 04:07:11',NULL,NULL),(35382,23253,'AP','5132768121',0,'2014-02-13 21:30:06',NULL,NULL),(35903,23623,'AP','4402019567',0,'2014-02-13 22:03:18',NULL,NULL),(43244,28734,'AP','2257731054',0,'2014-03-09 21:00:05',NULL,NULL),(1446,882,'TE','6016346981',0,'2013-12-25 18:07:45',NULL,NULL),(34397,22563,'AP','5134393335',0,'2014-02-10 21:31:52',NULL,NULL),(32954,21574,'TE','3308772060',0,'2014-02-05 21:30:22',NULL,NULL),(24467,15791,'EM','chursey68@gmail.com',0,'2014-01-03 02:02:30',NULL,NULL),(32152,21002,'TE','9016840346',0,'2014-02-01 19:00:29',NULL,NULL),(4992,3204,'AP','2167893245',0,'2013-12-25 20:45:16',NULL,NULL),(28352,18270,'TE','9035832492',0,'2014-01-16 08:44:41',NULL,NULL),(13589,8860,'AP','2146634282',0,'2013-12-26 04:01:15',NULL,NULL),(6176,3980,'TE','4193037428',0,'2013-12-25 21:38:48',NULL,NULL),(14774,9669,'AP','9373026824',0,'2013-12-26 04:39:11',NULL,NULL),(2259,1384,'TE','9859745744',0,'2013-12-25 18:46:11',NULL,NULL),(26722,17187,'AP','4694501374',0,'2014-01-13 02:22:16',NULL,NULL),(26609,17119,'TE','9376041761',0,'2014-01-13 02:21:41',NULL,NULL),(9704,6354,'TE','5137536842',0,'2013-12-26 00:47:09',NULL,NULL),(6967,4543,'TE','9566273804',0,'2013-12-25 22:04:21',NULL,NULL),(13731,8949,'AP','5135443437',0,'2013-12-26 04:03:32',NULL,NULL),(37648,24821,'TE','9376559763',0,'2014-02-20 04:50:43',NULL,NULL),(23275,14995,'EM','zolleymolley@yahoo.com',0,'2014-01-01 12:01:34',NULL,NULL),(32869,21511,'TE','4194387060',0,'2014-02-04 21:01:58',NULL,NULL),(14184,9282,'TE','2169905934',0,'2013-12-26 04:15:54',NULL,NULL),(39995,26487,'EM','tressturner@gmail.com',0,'2014-02-28 21:00:08',NULL,NULL),(31071,20213,'AP','4194663080',0,'2014-01-27 21:01:40',NULL,NULL),(36716,24174,'AP','4194907148',0,'2014-02-15 22:02:11',NULL,NULL),(12221,7986,'EM','keith@northcoastlawn.com',0,'2013-12-26 03:08:04',NULL,NULL),(6153,3962,'TE','2163715778',0,'2013-12-25 21:38:26',NULL,NULL),(34958,22950,'EM','patti_roller@yahoo.com',0,'2014-02-11 21:30:28',NULL,NULL),(8526,5603,'AP','6143533893',0,'2013-12-25 23:30:19',NULL,NULL),(4772,3055,'EM','bobrichard1952@yahoo.com',0,'2013-12-25 20:19:00',NULL,NULL),(43271,28748,'TE','4086454057',0,'2014-03-09 21:00:15',NULL,NULL),(23922,15434,'EM','debracummings57@yahoo.com',1,'2014-01-02 04:27:51',NULL,NULL),(28357,18272,'TE','9158570660',0,'2014-01-16 08:44:42',NULL,NULL),(12064,7876,'EM','maury_lee@outlook.com',0,'2013-12-26 03:05:19',NULL,NULL),(31904,20822,'TE','3376611332',0,'2014-01-31 21:00:36',NULL,NULL),(3588,2249,'AP','5132380232',0,'2013-12-25 19:30:04',NULL,NULL),(5813,3733,'EM','efgomez1952@gmail.com',0,'2013-12-25 21:32:40',NULL,NULL),(25524,16457,'EM','scooterschack@gmail.com',0,'2014-01-07 04:05:39',NULL,NULL),(5669,3642,'TE','6014803207',0,'2013-12-25 21:30:24',NULL,NULL),(14619,9557,'EM','gcharlier@cinci.rr.com',0,'2013-12-26 04:36:27',NULL,NULL),(12396,8116,'TE','9377701356',0,'2013-12-26 03:15:10',NULL,NULL),(27972,18033,'AP','2167021340',0,'2014-01-15 02:07:09',NULL,NULL),(28202,18178,'TE','4196683822',0,'2014-01-15 02:08:00',NULL,NULL),(29334,18955,'TE','2812458883',0,'2014-01-20 08:05:51',NULL,NULL),(34168,22407,'AP','2257885885',0,'2014-02-10 21:30:23',NULL,NULL),(34684,22745,'EM','kathyt5678@yahoo.com',0,'2014-02-11 21:01:22',NULL,NULL),(36164,23802,'TE','3307227493',0,'2014-02-14 21:31:30',NULL,NULL),(36803,24233,'TE','6013474332',0,'2014-02-16 19:00:35',NULL,NULL),(37254,24516,'TE','7065931139',0,'2014-02-20 03:55:14',NULL,NULL),(38840,25674,'AP','9252853915',0,'2014-02-26 08:30:54',NULL,NULL),(40169,26641,'AP','9366622732',0,'2014-02-28 21:31:03',NULL,NULL),(40342,26775,'AP','2147159540',0,'2014-03-01 21:00:10',NULL,NULL),(3077,1919,'EM','bsublime86@gmail.com',0,'2013-12-25 19:00:08',NULL,NULL),(27261,17553,'TE','9018265466',0,'2014-01-13 03:01:55',NULL,NULL),(25894,16690,'EM','christopher.sellers@wayland.wbu.edu',0,'2014-01-08 18:24:35',NULL,NULL),(25109,16188,'TE','2105772409',0,'2014-01-05 00:00:44',NULL,NULL),(3870,2461,'TE','3185484560',0,'2013-12-25 19:34:56',NULL,NULL),(22203,14303,'TE','4193051258',0,'2013-12-27 02:06:54',NULL,NULL),(9571,6268,'AP','9854980736',0,'2013-12-26 00:32:28',NULL,NULL),(21630,13924,'AP','4085137354',0,'2013-12-26 13:14:15',NULL,NULL),(8384,5519,'TE','5139845994',0,'2013-12-25 23:15:16',NULL,NULL),(7783,5081,'TE','2103204412',0,'2013-12-25 23:00:57',NULL,NULL),(21099,13566,'EM','rmackgd@yahoo.com',0,'2013-12-26 13:04:31',NULL,NULL),(21062,13547,'TE','5047826584',0,'2013-12-26 13:03:58',NULL,NULL),(20791,13362,'TE','2163384473',0,'2013-12-26 12:59:29',NULL,NULL),(6394,4121,'EM','btpmcol@aol.com',0,'2013-12-25 21:48:12',NULL,NULL),(5489,3511,'TE','9012832216',0,'2013-12-25 21:21:01',NULL,NULL),(30003,19427,'BN','5675250592',1,'2014-01-22 03:23:06',NULL,NULL),(30021,19442,'AP','5137873948',0,'2014-01-23 03:01:50',NULL,NULL),(33458,21918,'EM','hedayk@yahoo.com',0,'2014-02-07 19:00:04',NULL,NULL),(36367,23949,'TE','9726254477',0,'2014-02-15 22:00:03',NULL,NULL),(38213,25223,'TE','3303369332',0,'2014-02-21 22:00:58',NULL,NULL),(39318,26008,'TE','9123084597',0,'2014-02-26 21:02:08',NULL,NULL),(39556,26170,'TE','6626475464',0,'2014-02-28 06:30:36',NULL,NULL),(4229,2705,'TE','9032159255',0,'2013-12-25 19:47:49',NULL,NULL),(8984,5892,'EM','jwministries@aol.com',0,'2013-12-25 23:49:39',NULL,NULL),(7243,4721,'TE','5136148859',0,'2013-12-25 22:08:56',NULL,NULL),(24653,15895,'AP','3303883862',0,'2014-01-03 02:05:53',NULL,NULL),(7027,4588,'AP','3303883667',0,'2013-12-25 22:05:24',NULL,NULL),(20682,13297,'EM','maggiepolo@gmail.com',0,'2013-12-26 12:57:40',NULL,NULL),(6337,4085,'EM','sbll1616@yahoo.com',0,'2013-12-25 21:47:17',NULL,NULL),(14856,9721,'TE','4402309747',0,'2013-12-26 04:45:27',NULL,NULL),(12129,7927,'TE','9855020423',0,'2013-12-26 03:06:29',NULL,NULL),(30468,19753,'TE','4193800002',0,'2014-01-23 21:01:19',NULL,NULL),(32839,21488,'AP','4194083343',0,'2014-02-04 21:01:47',NULL,NULL),(37926,25025,'EM','desert.lotus@hotmail.com',0,'2014-02-20 22:00:59',NULL,NULL),(40023,26522,'TE','4192039514',0,'2014-02-28 21:00:24',NULL,NULL),(42278,28077,'EM','Mejia.vero@gmail.com',0,'2014-03-06 21:01:55',NULL,NULL),(43030,28611,'AP','4049853352',0,'2014-03-08 21:30:15',NULL,NULL),(43541,28908,'AP','3307039895',0,'2014-03-10 21:00:25',NULL,NULL),(303,188,'TE','3303282630',0,'2013-12-25 17:19:52',NULL,NULL),(14698,9618,'TE','5613191627',0,'2013-12-26 04:37:50',NULL,NULL),(29730,19225,'EM','crystalmhenry@gmail.com',0,'2014-01-21 08:46:29',NULL,NULL),(34326,22521,'AP','5133171177',0,'2014-02-10 21:31:25',NULL,NULL),(39727,26274,'BN','3184554078',0,'2014-02-28 06:31:17',NULL,NULL),(42022,27931,'AP','2147973992',0,'2014-03-06 21:00:26',NULL,NULL),(42806,28465,'EM','chloermallardi@gmail.com',0,'2014-03-07 21:31:29',NULL,NULL),(10679,6938,'AP','2164016085',0,'2013-12-26 01:46:44',NULL,NULL),(28029,18064,'AP','5132545871',0,'2014-01-15 02:07:21',NULL,NULL),(4473,2848,'TE','8324430906',0,'2013-12-25 20:01:16',NULL,NULL),(6797,4411,'TE','5135040016',0,'2013-12-25 22:01:22',NULL,NULL),(22823,14718,'TE','9375614369',1,'2013-12-29 11:09:30',NULL,NULL),(6800,4412,'TE','5132213839',0,'2013-12-25 22:01:24',NULL,NULL),(14453,9443,'TE','3308530388',0,'2013-12-26 04:33:45',NULL,NULL),(7954,5188,'AP','4194665242',0,'2013-12-25 23:03:42',NULL,NULL),(6892,4480,'EM','roberwen9@aol.com',0,'2013-12-25 22:02:58',NULL,NULL),(28737,18544,'TE','6016687493',0,'2014-01-16 08:46:50',NULL,NULL),(30393,19694,'AP','2146768846',0,'2014-01-23 21:00:44',NULL,NULL),(31772,20740,'TE','5135153904',0,'2014-01-30 21:01:23',NULL,NULL),(35307,23195,'TE','3306967031',0,'2014-02-12 21:32:05',NULL,NULL),(38522,25457,'TE','2546909673',0,'2014-02-25 21:31:29',NULL,NULL),(304,188,'AP','3303282630',0,'2013-12-25 17:19:52',NULL,NULL),(24889,16046,'TE','3102515068',0,'2014-01-04 02:03:02',NULL,NULL),(24325,15715,'TE','7657175916',1,'2014-01-02 04:36:11',NULL,NULL),(22562,14550,'EM','eddie0205@hughes.net',0,'2013-12-28 03:35:01',NULL,NULL),(12183,7959,'TE','6018109811',0,'2013-12-26 03:07:24',NULL,NULL),(12273,8028,'EM','verkistap@gmail.com',0,'2013-12-26 03:09:04',NULL,NULL),(39119,25877,'AP','5044536366',0,'2014-02-26 21:00:55',NULL,NULL),(4899,3145,'AP','8325774844',0,'2013-12-25 20:30:54',NULL,NULL),(26409,16995,'BN','3308145779',0,'2014-01-13 02:20:28',NULL,NULL),(26300,16929,'TE','5045782709',0,'2014-01-13 02:19:48',NULL,NULL),(3923,2488,'TE','2253151707',0,'2013-12-25 19:35:44',NULL,NULL),(20472,13187,'AP','9179756538',0,'2013-12-26 12:54:30',NULL,NULL),(28510,18377,'TE','3306992408',0,'2014-01-16 08:45:33',NULL,NULL),(43997,29191,'TE','4192572039',0,'2014-03-10 21:30:05',NULL,NULL),(7506,4891,'AP','3302128470',0,'2013-12-25 22:31:31',NULL,NULL),(5101,3272,'AP','4197891521',0,'2013-12-25 20:47:15',NULL,NULL),(27624,17807,'EM','beckyd33@yahoo.com',0,'2014-01-15 02:05:51',NULL,NULL),(3987,2532,'EM','Jrickey@me.com',0,'2013-12-25 19:36:50',NULL,NULL),(25592,16508,'EM','josh3133@live.com',1,'2014-01-07 10:21:18',NULL,NULL),(25117,16192,'AP','2147835623',0,'2014-01-05 00:00:52',NULL,NULL),(11865,7724,'EM','a74banchek@aol.com',0,'2013-12-26 03:01:49',NULL,NULL),(21903,14111,'TE','4407257882',0,'2013-12-27 02:01:51',NULL,NULL),(21113,13572,'EM','button1257@aol.com',0,'2013-12-26 13:04:43',NULL,NULL),(30317,19640,'TE','3305645933',0,'2014-01-23 21:00:14',NULL,NULL),(34640,22713,'TE','5043044146',0,'2014-02-11 21:01:06',NULL,NULL),(34659,22725,'TE','5047151862',0,'2014-02-11 21:01:12',NULL,NULL),(40965,27220,'TE','6012913125',0,'2014-03-03 21:31:34',NULL,NULL),(582,360,'TE','2104644474',0,'2013-12-25 17:45:08',NULL,NULL),(14681,9608,'TE','3307156146',0,'2013-12-26 04:37:33',NULL,NULL),(21494,13814,'AP','5137064792',0,'2013-12-26 13:11:41',NULL,NULL),(23742,15318,'AP','2143925424',1,'2014-01-02 04:23:27',NULL,NULL),(32151,21001,'EM','reneewallace46@gmail.com',0,'2014-02-01 19:00:29',NULL,NULL),(42929,28545,'AP','2164076078',0,'2014-03-07 21:32:17',NULL,NULL),(819,511,'TE','5134906903',0,'2013-12-25 17:48:56',NULL,NULL),(10084,6589,'EM','sara@pomhouse.com',0,'2013-12-26 00:53:14',NULL,NULL),(27171,17495,'TE','5049149170',0,'2014-01-13 03:01:22',NULL,NULL),(4809,3076,'TE','5049577472',0,'2013-12-25 20:19:35',NULL,NULL),(11845,7706,'TE','5135317276',0,'2013-12-26 03:01:24',NULL,NULL),(1932,1196,'AP','9415181033',0,'2013-12-25 18:19:45',NULL,NULL),(7879,5137,'AP','5127747804',0,'2013-12-25 23:02:24',NULL,NULL),(35054,23019,'TE','5044518889',0,'2014-02-12 21:30:29',NULL,NULL),(40882,27163,'BN','8329646161',0,'2014-03-03 21:31:01',NULL,NULL),(41956,27891,'TE','2167128003',0,'2014-03-05 21:32:39',NULL,NULL),(275,169,'AP','3302311311',0,'2013-12-25 17:19:25',NULL,NULL),(24310,15704,'TE','4154079674',1,'2014-01-02 04:35:51',NULL,NULL),(22175,14283,'EM','dorseyones@yahoo.com',0,'2013-12-27 02:06:23',NULL,NULL),(5953,3821,'AP','7408568369',0,'2013-12-25 21:34:57',NULL,NULL),(7066,4613,'EM','kacsing@yahoo.com',0,'2013-12-25 22:06:03',NULL,NULL),(5095,3269,'EM','bigster396@aol.com',0,'2013-12-25 20:47:09',NULL,NULL),(29814,19290,'TE','9854457693',1,'2014-01-22 03:21:54',NULL,NULL),(32389,21163,'BN','3303225234',0,'2014-02-03 21:00:34',NULL,NULL),(39662,26226,'TE','5126262834',0,'2014-02-28 06:30:59',NULL,NULL),(41038,27265,'AP','2255728391',0,'2014-03-04 21:00:12',NULL,NULL),(41901,27861,'TE','2166349077',0,'2014-03-05 21:32:19',NULL,NULL),(42730,28421,'TE','6143817488',0,'2014-03-07 21:31:03',NULL,NULL),(43656,28975,'TE','3186641320',0,'2014-03-10 21:01:05',NULL,NULL),(12122,7923,'TE','5042363437',0,'2013-12-26 03:06:23',NULL,NULL),(28509,18375,'EM','karmenohio@me.com',0,'2014-01-16 08:45:32',NULL,NULL),(1952,1208,'TE','4409422331',0,'2013-12-25 18:20:03',NULL,NULL),(21401,13759,'EM','alon_johnson@yahoo.com',0,'2013-12-26 13:10:11',NULL,NULL),(37013,24370,'AP','6018076532',0,'2014-02-18 22:00:38',NULL,NULL),(37438,24650,'AP','2253018261',0,'2014-02-20 04:22:42',NULL,NULL),(10010,6548,'EM','drlahaye@lahayegroup.com',0,'2013-12-26 00:52:07',NULL,NULL),(28520,18384,'AP','8596638335',0,'2014-01-16 08:45:36',NULL,NULL),(26698,17175,'TE','3306992408',0,'2014-01-13 02:22:09',NULL,NULL),(25970,16727,'EM','blackbirdart53@yahoo.com',0,'2014-01-08 18:24:48',NULL,NULL),(1570,968,'TE','8306291506',0,'2013-12-25 18:09:56',NULL,NULL),(8117,5314,'AP','3304756609',0,'2013-12-25 23:06:40',NULL,NULL),(30720,19958,'EM','agaytha@aol.com',0,'2014-01-25 19:00:06',NULL,NULL),(38278,25273,'AP','9569704837',0,'2014-02-25 21:00:13',NULL,NULL),(39718,26270,'TE','9156332771',0,'2014-02-28 06:31:15',NULL,NULL),(63,41,'AP','6146011213',0,'2013-12-25 17:16:04',NULL,NULL),(1287,784,'TE','5124269120',0,'2013-12-25 18:05:07',NULL,NULL),(25717,16576,'EM','doubleb0302@yahoo.com',1,'2014-01-07 10:23:31',NULL,NULL),(2640,1606,'TE','2147048831',0,'2013-12-25 18:52:11',NULL,NULL),(10435,6803,'TE','2162831383',0,'2013-12-26 01:30:03',NULL,NULL),(21597,13898,'EM','kraphtsman@yahoo.com',0,'2013-12-26 13:13:38',NULL,NULL),(12375,8104,'AP','5613191627',0,'2013-12-26 03:10:56',NULL,NULL),(12342,8071,'EM','mflahe9732@hotmail.com',0,'2013-12-26 03:10:14',NULL,NULL),(37967,25049,'BN','9373607772',0,'2014-02-20 22:01:16',NULL,NULL),(38361,25339,'TE','3186456252',0,'2014-02-25 21:30:23',NULL,NULL),(39941,26431,'AP','7402442480',0,'2014-02-28 07:30:16',NULL,NULL),(40341,26775,'TE','2147159540',0,'2014-03-01 21:00:10',NULL,NULL),(43132,28671,'TE','2256107749',0,'2014-03-08 21:30:49',NULL,NULL),(4451,2836,'TE','3308969435',0,'2013-12-25 20:00:55',NULL,NULL),(28544,18402,'EM','danielle.goren1@gmail.com',0,'2014-01-16 08:45:44',NULL,NULL),(10512,6845,'EM','cynthiaann59@hotmail.com',0,'2013-12-26 01:31:13',NULL,NULL),(20355,13111,'EM','fran0837@yahoo.com',0,'2013-12-26 12:52:29',NULL,NULL),(1752,1081,'TE','4409461454',0,'2013-12-25 18:16:46',NULL,NULL),(1856,1147,'TE','3352878596',0,'2013-12-25 18:18:30',NULL,NULL),(8977,5884,'AP','2163382597',0,'2013-12-25 23:49:31',NULL,NULL),(9900,6478,'AP','3309064411',0,'2013-12-26 00:50:15',NULL,NULL),(30610,19866,'TE','9375443729',0,'2014-01-24 21:00:38',NULL,NULL),(9497,6214,'TE','7133634862',0,'2013-12-26 00:30:59',NULL,NULL),(21517,13828,'EM','jojo414@ameritech.net',0,'2013-12-26 13:12:05',NULL,NULL),(1965,1216,'AP','9375365596',0,'2013-12-25 18:20:16',NULL,NULL),(3320,2088,'EM','lisalgipson24@yahoo.com',0,'2013-12-25 19:16:48',NULL,NULL),(31957,20867,'EM','hellokitty145@ameritech.net',0,'2014-01-31 21:00:59',NULL,NULL),(35474,23330,'AP','5133134900',0,'2014-02-13 22:00:30',NULL,NULL),(35934,23643,'AP','9568271728',0,'2014-02-14 21:30:10',NULL,NULL),(36692,24158,'BN','4199663480',0,'2014-02-15 22:02:02',NULL,NULL),(36923,24316,'AP','8063411701',0,'2014-02-18 22:00:05',NULL,NULL),(42775,28449,'TE','3375826366',0,'2014-03-07 21:31:19',NULL,NULL),(12105,7911,'TE','5046551597',0,'2013-12-26 03:06:05',NULL,NULL),(27167,17490,'AP','9857897129',0,'2014-01-13 03:01:20',NULL,NULL),(817,508,'TE','4192423748',0,'2013-12-25 17:48:53',NULL,NULL),(23659,15279,'AP','4403813248',1,'2014-01-02 04:22:03',NULL,NULL),(11510,7490,'TE','7408292268',0,'2013-12-26 02:31:35',NULL,NULL),(1893,1166,'AP','2259393572',0,'2013-12-25 18:19:03',NULL,NULL),(8719,5720,'AP','5043770892',0,'2013-12-25 23:45:24',NULL,NULL),(32312,21109,'AP','2252403240',0,'2014-02-03 21:00:06',NULL,NULL),(35899,23617,'TE','4194838631',0,'2014-02-13 22:03:16',NULL,NULL),(6332,4081,'EM','lchesmar@aol.com',0,'2013-12-25 21:47:13',NULL,NULL),(3940,2499,'TE','9857484039',0,'2013-12-25 19:36:00',NULL,NULL),(23404,15073,'AP','2144152927',0,'2014-01-01 12:03:58',NULL,NULL),(8873,5812,'AP','9039106802',0,'2013-12-25 23:47:49',NULL,NULL),(3249,2046,'TE','4322584776',0,'2013-12-25 19:15:43',NULL,NULL),(31479,20513,'EM','Monnin3593@aol.com',0,'2014-01-29 21:01:20',NULL,NULL),(39850,26357,'AP','4404872165',0,'2014-02-28 07:00:04',NULL,NULL),(11391,7416,'AP','3302085182',0,'2013-12-26 02:16:52',NULL,NULL),(26840,17268,'AP','3302426965',0,'2014-01-13 02:23:20',NULL,NULL),(26215,16873,'EM','pg1091@txstate.edu',0,'2014-01-13 02:19:17',NULL,NULL),(26127,16822,'AP','9857892506',0,'2014-01-13 02:18:23',NULL,NULL),(22726,14655,'AP','9565996680',1,'2013-12-29 11:07:51',NULL,NULL),(6311,4067,'TE','3305928884',0,'2013-12-25 21:46:50',NULL,NULL),(10321,6732,'TE','4405941947',0,'2013-12-26 01:15:31',NULL,NULL),(4067,2596,'TE','4194204306',0,'2013-12-25 19:45:11',NULL,NULL),(40318,26755,'AP','4093515357',0,'2014-03-01 19:00:05',NULL,NULL),(41416,27515,'EM','ptrice31@yahoo.com',0,'2014-03-04 21:02:36',NULL,NULL),(9337,6114,'TE','3307805171',0,'2013-12-26 00:15:33',NULL,NULL),(14305,9356,'TE','5042184055',0,'2013-12-26 04:31:24',NULL,NULL),(22226,14326,'TE','3303296870',0,'2013-12-27 02:07:24',NULL,NULL),(26622,17128,'EM','annasee0812@yahoo.com',0,'2014-01-13 02:21:45',NULL,NULL),(26480,17042,'TE','5133931680',0,'2014-01-13 02:20:52',NULL,NULL),(29659,19161,'EM','kurtwaggoner@gmail.com',0,'2014-01-21 08:45:42',NULL,NULL),(33334,21835,'TE','2109957304',0,'2014-02-06 21:01:07',NULL,NULL),(39205,25929,'TE','3615621761',0,'2014-02-26 21:01:25',NULL,NULL),(40148,26627,'EM','twutoo@yahoo.com',0,'2014-02-28 21:30:55',NULL,NULL),(8796,5762,'TE','5132925079',0,'2013-12-25 23:46:33',NULL,NULL),(28547,18403,'EM','shannon@zoomtown.com',0,'2014-01-16 08:45:44',NULL,NULL),(3452,2162,'TE','3306596314',0,'2013-12-25 19:18:56',NULL,NULL),(26188,16858,'TE','9155951287',0,'2014-01-13 02:19:08',NULL,NULL),(31328,20415,'EM','JOHNRITT@AOL.COM',0,'2014-01-29 21:00:27',NULL,NULL),(33050,21651,'EM','lemydo29@gmail.com',0,'2014-02-05 21:30:50',NULL,NULL),(33659,22079,'TE','5046386393',0,'2014-02-08 19:00:17',NULL,NULL),(36349,23940,'TE','5133063730',0,'2014-02-15 21:00:08',NULL,NULL),(39809,26327,'TE','6013651809',0,'2014-02-28 06:31:38',NULL,NULL),(39962,26457,'EM','drice94@gmail.com',0,'2014-02-28 07:30:28',NULL,NULL),(43469,28868,'AP','7864472228',0,'2014-03-10 21:00:01',NULL,NULL),(6581,4248,'AP','5126299757',0,'2013-12-25 21:51:13',NULL,NULL),(11043,7165,'AP','9175175611',0,'2013-12-26 01:52:38',NULL,NULL),(3551,2223,'EM','hthanh641@yahoo.com',0,'2013-12-25 19:20:35',NULL,NULL),(26303,16932,'TE','5049099916',0,'2014-01-13 02:19:49',NULL,NULL),(29712,19210,'AP','4197097823',0,'2014-01-21 08:46:21',NULL,NULL),(33216,21753,'TE','2145580189',0,'2014-02-06 21:00:22',NULL,NULL),(34853,22852,'AP','4193055513',0,'2014-02-11 21:02:21',NULL,NULL),(38346,25331,'TE','3372307621',0,'2014-02-25 21:30:18',NULL,NULL),(39225,25947,'TE','3306712915',0,'2014-02-26 21:01:34',NULL,NULL),(8784,5756,'TE','7407045473',0,'2013-12-25 23:46:22',NULL,NULL),(28407,18304,'TE','4406950253',0,'2014-01-16 08:44:58',NULL,NULL),(14935,9771,'AP','2255883823',0,'2013-12-26 05:00:29',NULL,NULL),(23252,14983,'TE','2814314262',0,'2014-01-01 12:01:09',NULL,NULL),(20729,13324,'TE','4329234638',0,'2013-12-26 12:58:26',NULL,NULL),(34855,22853,'AP','4199798468',0,'2014-02-11 21:02:22',NULL,NULL),(37571,24752,'AP','3304729927',0,'2014-02-20 04:41:32',NULL,NULL),(5866,3763,'EM','krwright49@live.com',0,'2013-12-25 21:33:29',NULL,NULL),(2927,1799,'TE','7406746846',0,'2013-12-25 18:56:44',NULL,NULL),(21282,13673,'EM','bdemoman345@att.net',0,'2013-12-26 13:07:59',NULL,NULL),(42434,28183,'EM','brandy.garcia@probizservices.com',0,'2014-03-06 21:02:56',NULL,NULL),(11708,7622,'EM','tychesiacb@yahoo.com',0,'2013-12-26 02:45:57',NULL,NULL),(27244,17540,'AP','3307800757',0,'2014-01-13 03:01:48',NULL,NULL),(332,208,'EM','pham19062@hotmail.com',0,'2013-12-25 17:20:23',NULL,NULL),(23379,15060,'AP','3184619668',0,'2014-01-01 12:03:32',NULL,NULL),(11295,7360,'TE','3308963456',0,'2013-12-26 02:15:23',NULL,NULL),(14858,9722,'TE','5132255710',0,'2013-12-26 04:45:29',NULL,NULL),(4604,2939,'TE','5137202257',0,'2013-12-25 20:16:10',NULL,NULL),(10067,6581,'AP','5138044391',0,'2013-12-26 00:52:59',NULL,NULL),(10963,7125,'TE','6019533775',0,'2013-12-26 01:51:27',NULL,NULL),(11058,7180,'TE','3305224403',0,'2013-12-26 02:00:12',NULL,NULL),(31298,20394,'TE','2813512509',0,'2014-01-29 21:00:17',NULL,NULL),(33233,21762,'TE','8069445423',0,'2014-02-06 21:00:27',NULL,NULL),(36420,23989,'TE','2257739469',0,'2014-02-15 22:00:25',NULL,NULL),(33744,22143,'TE','7404590231',0,'2014-02-08 19:00:50',NULL,NULL),(33905,22254,'AP','6014477002',0,'2014-02-09 19:00:45',NULL,NULL),(34873,22872,'TE','6623681725',0,'2014-02-11 21:02:31',NULL,NULL),(35162,23094,'EM','foster388@aol.com',0,'2014-02-12 21:31:09',NULL,NULL),(38745,25615,'TE','3618534135',0,'2014-02-26 08:30:12',NULL,NULL),(40390,26809,'TE','3302568771',0,'2014-03-01 21:00:28',NULL,NULL),(42468,28218,'TE','5133532713',0,'2014-03-06 21:30:17',NULL,NULL),(42827,28486,'TE','7405171263',0,'2014-03-07 21:31:38',NULL,NULL),(10643,6921,'AP','3305106426',0,'2013-12-26 01:46:14',NULL,NULL),(2527,1547,'AP','6015030905',0,'2013-12-25 18:50:30',NULL,NULL),(5661,3634,'AP','6016183330',0,'2013-12-25 21:30:13',NULL,NULL),(22435,14466,'EM','DEBROD65@YAHOO.COM',0,'2013-12-28 03:32:57',NULL,NULL),(6410,4138,'TE','3303572586',0,'2013-12-25 21:48:31',NULL,NULL),(27811,17922,'AP','5127314344',0,'2014-01-15 02:06:32',NULL,NULL),(29042,18752,'TE','4193859333',0,'2014-01-17 03:35:44',NULL,NULL),(30026,19446,'EM','Kevinmoeller82@hotmail.com',0,'2014-01-23 03:01:51',NULL,NULL),(31399,20469,'AP','4402651616',0,'2014-01-29 21:00:54',NULL,NULL),(31811,20769,'BN','4195167817',0,'2014-01-30 21:01:39',NULL,NULL),(33247,21771,'EM','greenearthfarm@yahoo.com',0,'2014-02-06 21:00:32',NULL,NULL),(37420,24643,'TE','3182642812',0,'2014-02-20 04:20:47',NULL,NULL),(28050,18077,'EM','brierleyjanell@yahoo.com',0,'2014-01-15 02:07:25',NULL,NULL),(27614,17802,'EM','XRAYMAN1987@YAHOO.COM',0,'2014-01-14 01:33:54',NULL,NULL),(27515,17725,'EM','joeyogden66@yahoo.com',0,'2014-01-14 01:33:16',NULL,NULL),(28106,18114,'AP','3304164214',0,'2014-01-15 02:07:38',NULL,NULL),(26570,17092,'TE','5127320453',0,'2014-01-13 02:21:28',NULL,NULL),(25559,16488,'TE','4192604539',0,'2014-01-07 04:06:28',NULL,NULL),(1210,739,'TE','9157796775',0,'2013-12-25 18:03:59',NULL,NULL),(22423,14459,'EM','kenyad2006@yahoo.com',0,'2013-12-28 03:32:44',NULL,NULL),(10440,6805,'TE','8063177261',0,'2013-12-26 01:30:08',NULL,NULL),(4006,2547,'TE','3307244944',0,'2013-12-25 19:37:11',NULL,NULL),(21315,13696,'TE','4408126711',0,'2013-12-26 13:08:33',NULL,NULL),(7667,4990,'AP','5138501717',0,'2013-12-25 22:46:57',NULL,NULL),(5348,3427,'TE','3307075425',0,'2013-12-25 21:18:49',NULL,NULL),(31454,20501,'AP','9852493878',0,'2014-01-29 21:01:13',NULL,NULL),(32390,21164,'TE','2167982474',0,'2014-02-03 21:00:34',NULL,NULL),(34140,22387,'TE','3306717704',0,'2014-02-10 21:30:12',NULL,NULL),(36318,23918,'EM','jasonbarr@hotmail.com',0,'2014-02-14 22:00:05',NULL,NULL),(36676,24150,'AP','9375091339',0,'2014-02-15 22:01:56',NULL,NULL),(42096,27970,'TE','3183488610',0,'2014-03-06 21:00:50',NULL,NULL),(43277,28752,'AP','8026830166',0,'2014-03-09 21:00:17',NULL,NULL),(43597,28946,'TE','9855187958',0,'2014-03-10 21:00:46',NULL,NULL),(1802,1116,'AP','4196124424',0,'2013-12-25 18:17:40',NULL,NULL),(26386,16984,'TE','9039635655',0,'2014-01-13 02:20:20',NULL,NULL),(22244,14334,'AP','9375489617',0,'2013-12-27 02:07:41',NULL,NULL),(21782,14035,'EM','dancincrazy@ymail.com',0,'2013-12-26 13:17:00',NULL,NULL),(3201,2011,'TE','5185673310',0,'2013-12-25 19:02:30',NULL,NULL),(20893,13435,'AP','6507145966',0,'2013-12-26 13:01:09',NULL,NULL),(7402,4815,'TE','5672041369',0,'2013-12-25 22:16:55',NULL,NULL),(3966,2517,'AP','6629100801',0,'2013-12-25 19:36:29',NULL,NULL),(4884,3131,'TE','3302218778',0,'2013-12-25 20:30:31',NULL,NULL),(10117,6615,'AP','4198893730',0,'2013-12-26 00:53:52',NULL,NULL),(3497,2186,'TE','6015725243',0,'2013-12-25 19:19:36',NULL,NULL),(9215,6032,'TE','2148501475',0,'2013-12-26 00:01:09',NULL,NULL),(3918,2486,'TE','5048134131',0,'2013-12-25 19:35:40',NULL,NULL),(29714,19212,'TE','4408290403',0,'2014-01-21 08:46:22',NULL,NULL),(31905,20822,'AP','3376611332',0,'2014-01-31 21:00:36',NULL,NULL),(34539,22656,'TE','4325990802',0,'2014-02-11 21:00:31',NULL,NULL),(40065,26564,'TE','2162831189',0,'2014-02-28 21:30:22',NULL,NULL),(93,55,'AP','4133076789',0,'2013-12-25 17:16:31',NULL,NULL),(28057,18083,'TE','5045715385',0,'2014-01-15 02:07:27',NULL,NULL),(25871,16674,'TE','7025725002',0,'2014-01-08 18:24:29',NULL,NULL),(538,336,'AP','4193088174',0,'2013-12-25 17:31:50',NULL,NULL),(6023,3865,'AP','5044500032',0,'2013-12-25 21:36:04',NULL,NULL),(21334,13708,'TE','3302703630',0,'2013-12-26 13:08:52',NULL,NULL),(31465,20506,'AP','2258032758',0,'2014-01-29 21:01:16',NULL,NULL),(33363,21862,'TE','4404760530',0,'2014-02-06 21:01:20',NULL,NULL),(33909,22258,'TE','9566481907',0,'2014-02-10 11:00:05',NULL,NULL),(40967,27220,'EM','sujag4fun@yahoo.com',0,'2014-03-03 21:31:34',NULL,NULL),(595,366,'AP','3258641410',0,'2013-12-25 17:45:19',NULL,NULL),(5888,3777,'TE','5135463331',0,'2013-12-25 21:33:53',NULL,NULL),(10392,6772,'TE','5133852347',0,'2013-12-26 01:16:40',NULL,NULL),(8508,5595,'TE','5049090942',0,'2013-12-25 23:30:05',NULL,NULL),(31219,20332,'TE','3308359450',0,'2014-01-28 21:01:02',NULL,NULL),(33429,21898,'AP','3307039116',0,'2014-02-06 21:01:45',NULL,NULL),(34742,22781,'AP','3308588762',0,'2014-02-11 21:01:44',NULL,NULL),(38385,25359,'AP','5134907824',0,'2014-02-25 21:30:35',NULL,NULL),(39723,26273,'TE','4192229960',0,'2014-02-28 06:31:17',NULL,NULL),(40803,27116,'TE','4192440707',0,'2014-03-03 21:30:30',NULL,NULL),(41468,27558,'TE','2148616773',0,'2014-03-04 21:30:15',NULL,NULL),(5794,3713,'EM','brucebigham@gmail.com',0,'2013-12-25 21:32:16',NULL,NULL),(3718,2357,'AP','4193410013',0,'2013-12-25 19:32:25',NULL,NULL),(7230,4709,'TE','4198332020',0,'2013-12-25 22:08:40',NULL,NULL),(14071,9199,'TE','4192130417',0,'2013-12-26 04:09:36',NULL,NULL),(8636,5672,'AP','4192362019',0,'2013-12-25 23:32:05',NULL,NULL),(34174,22410,'AP','5042286487',0,'2014-02-10 21:30:25',NULL,NULL),(35311,23198,'TE','5133772996',0,'2014-02-12 21:32:07',NULL,NULL),(35412,23279,'AP','5048127496',0,'2014-02-13 21:30:15',NULL,NULL),(38676,25563,'TE','9364330289',0,'2014-02-26 08:00:24',NULL,NULL),(39857,26365,'TE','6143300936',0,'2014-02-28 07:00:08',NULL,NULL),(40196,26663,'AP','5042185557',0,'2014-02-28 21:31:13',NULL,NULL),(43725,29025,'TE','5132608245',0,'2014-03-10 21:01:33',NULL,NULL),(7032,4593,'TE','4403222333',0,'2013-12-25 22:05:31',NULL,NULL),(28728,18539,'TE','2283272601',0,'2014-01-16 08:46:48',NULL,NULL),(12372,8100,'TE','2342009887',0,'2013-12-26 03:10:52',NULL,NULL),(11923,7760,'EM','t92r88@aol.com',0,'2013-12-26 03:02:45',NULL,NULL),(31913,20830,'EM','summersuleiman1@gmail.com',0,'2014-01-31 21:00:40',NULL,NULL),(34793,22823,'TE','5804616416',0,'2014-02-11 21:02:03',NULL,NULL),(35585,23405,'AP','5132679902',0,'2014-02-13 22:01:12',NULL,NULL),(38182,25201,'EM','GHAAALY2@YAHOO.COM',0,'2014-02-21 22:00:46',NULL,NULL),(38677,25563,'AP','9364330289',0,'2014-02-26 08:00:24',NULL,NULL),(42435,28184,'TE','3308011530',0,'2014-03-06 21:02:56',NULL,NULL),(43194,28702,'EM','LDF2488@YAHOO.COM',0,'2014-03-08 21:31:10',NULL,NULL),(2399,1461,'TE','3308484604',0,'2013-12-25 18:48:20',NULL,NULL),(29019,18735,'AP','7404072590',0,'2014-01-17 03:35:38',NULL,NULL),(25002,16113,'AP','6623850101',0,'2014-01-04 02:05:10',NULL,NULL),(24908,16054,'AP','6146382115',0,'2014-01-04 02:03:20',NULL,NULL),(22454,14478,'EM','EdoArre@aol.com',0,'2013-12-28 03:33:14',NULL,NULL),(30336,19656,'AP','5134298602',0,'2014-01-23 21:00:22',NULL,NULL),(38305,25293,'EM','Debnana5@woh.rr.com',0,'2014-02-25 21:00:25',NULL,NULL),(7770,5070,'AP','4697139615',0,'2013-12-25 23:00:42',NULL,NULL),(9225,6036,'EM','terrellnesbitt@msn.com',0,'2013-12-26 00:01:18',NULL,NULL),(8870,5811,'AP','9154221249',0,'2013-12-25 23:47:47',NULL,NULL),(26005,16753,'BN','2142269188',0,'2014-01-08 18:24:56',NULL,NULL),(30927,20112,'EM','davidjusko@sbcglobal.net',0,'2014-01-27 21:00:41',NULL,NULL),(33250,21773,'EM','kalb8688@gmail.com',0,'2014-02-06 21:00:33',NULL,NULL),(33773,22165,'AP','5133107790',0,'2014-02-08 19:01:00',NULL,NULL),(37199,24485,'TE','9854454155',0,'2014-02-20 03:42:03',NULL,NULL),(38143,25176,'AP','9379973640',0,'2014-02-21 22:00:31',NULL,NULL),(8228,5385,'AP','6196062686',0,'2013-12-25 23:08:29',NULL,NULL),(13673,8913,'TE','7404044725',0,'2013-12-26 04:02:38',NULL,NULL),(27849,17940,'BN','2146072158',0,'2014-01-15 02:06:39',NULL,NULL),(22738,14664,'AP','8326512333',1,'2013-12-29 11:08:05',NULL,NULL),(23087,14890,'EM','chaugialinh1011@yahoo.com',0,'2013-12-30 00:00:46',NULL,NULL),(31735,20711,'EM','teeta116@aol.com',0,'2014-01-30 21:01:09',NULL,NULL),(34060,22331,'AP','2108271733',0,'2014-02-10 11:01:01',NULL,NULL),(39862,26370,'AP','6146782390',0,'2014-02-28 07:00:12',NULL,NULL),(43920,29137,'AP','4192768197',0,'2014-03-10 21:02:41',NULL,NULL),(23480,15142,'TE','5133535732',0,'2014-01-01 12:05:47',NULL,NULL),(8405,5532,'TE','9373673226',0,'2013-12-25 23:15:36',NULL,NULL),(12473,8171,'TE','5133850880',0,'2013-12-26 03:16:37',NULL,NULL),(26358,16964,'AP','4405525286',0,'2014-01-13 02:20:10',NULL,NULL),(13575,8851,'TE','9037253370',0,'2013-12-26 04:01:02',NULL,NULL),(30674,19918,'TE','5124617807',0,'2014-01-24 21:01:03',NULL,NULL),(32366,21147,'AP','9154089010',0,'2014-02-03 21:00:25',NULL,NULL),(34620,22699,'EM','mijones1960@aol.com',0,'2014-02-11 21:00:57',NULL,NULL),(43052,28623,'TE','2812363416',0,'2014-03-08 21:30:22',NULL,NULL),(1800,1115,'EM','jpyntr782@aol.com',0,'2013-12-25 18:17:38',NULL,NULL),(28379,18285,'TE','5135498366',0,'2014-01-16 08:44:49',NULL,NULL),(4801,3069,'AP','6468725598',0,'2013-12-25 20:19:27',NULL,NULL),(13746,8958,'TE','9375932815',0,'2013-12-26 04:03:47',NULL,NULL),(20434,13159,'EM','cricephoto@gmail.com',0,'2013-12-26 12:53:48',NULL,NULL),(30051,19464,'AP','9178685888',0,'2014-01-23 03:01:57',NULL,NULL),(36285,23890,'AP','9374811597',0,'2014-02-14 21:32:18',NULL,NULL),(732,458,'EM','zacharylawrence@gmail.com',0,'2013-12-25 17:47:34',NULL,NULL),(2653,1612,'TE','9153556568',0,'2013-12-25 18:52:20',NULL,NULL),(5962,3827,'TE','5134702286',0,'2013-12-25 21:35:06',NULL,NULL),(22613,14581,'TE','5044871848',0,'2013-12-28 03:35:52',NULL,NULL),(5392,3450,'EM','hopehammond@gmail.com',0,'2013-12-25 21:19:29',NULL,NULL),(8765,5744,'EM','pinky823@cox.net',0,'2013-12-25 23:46:03',NULL,NULL),(32767,21436,'TE','6627696492',0,'2014-02-04 21:01:21',NULL,NULL),(35565,23389,'AP','3304887454',0,'2014-02-13 22:01:04',NULL,NULL),(35838,23566,'AP','4193430812',0,'2014-02-13 22:02:48',NULL,NULL),(39422,26070,'TE','5136337077',0,'2014-02-26 21:02:44',NULL,NULL),(12275,8031,'AP','6622990901',0,'2013-12-26 03:09:08',NULL,NULL),(420,256,'AP','2257470493',0,'2013-12-25 17:21:43',NULL,NULL),(9162,5999,'TE','3103101996',0,'2013-12-26 00:00:18',NULL,NULL),(20365,13119,'TE','6145309888',0,'2013-12-26 12:52:42',NULL,NULL),(30712,19951,'EM','lindsey.coons@gmail.com',0,'2014-01-25 19:00:03',NULL,NULL),(43144,28677,'AP','4195750729',0,'2014-03-08 21:30:53',NULL,NULL),(43748,29039,'EM','smitchell6@woh.rr.com',0,'2014-03-10 21:01:41',NULL,NULL),(935,578,'TE','5133173474',0,'2013-12-25 17:50:46',NULL,NULL),(29258,18895,'BN','3308140610',0,'2014-01-17 03:36:34',NULL,NULL),(28701,18521,'AP','8306131058',0,'2014-01-16 08:46:38',NULL,NULL),(3894,2473,'AP','3182889671',0,'2013-12-25 19:35:18',NULL,NULL),(35453,23312,'EM','GeorgetteElias@roadrunner.com',0,'2014-02-13 22:00:21',NULL,NULL),(42136,27989,'TE','2103238131',0,'2014-03-06 21:01:03',NULL,NULL),(42673,28387,'TE','3307943247',0,'2014-03-07 21:30:43',NULL,NULL),(13899,9061,'TE','8176157711',0,'2013-12-26 04:06:21',NULL,NULL),(29825,19296,'EM','rpavon518@gmail.com',1,'2014-01-22 03:21:58',NULL,NULL),(6565,4239,'TE','7136287739',0,'2013-12-25 21:50:58',NULL,NULL),(7403,4815,'AP','5672041369',0,'2013-12-25 22:16:55',NULL,NULL),(20394,13136,'TE','5135158959',0,'2013-12-26 12:53:10',NULL,NULL),(35291,23180,'AP','6018134016',0,'2014-02-12 21:31:57',NULL,NULL),(36013,23689,'AP','3306203574',0,'2014-02-14 21:30:36',NULL,NULL),(41226,27383,'AP','6019534041',0,'2014-03-04 21:01:22',NULL,NULL),(11352,7396,'TE','7402544433',0,'2013-12-26 02:16:18',NULL,NULL),(28488,18357,'TE','4193920420',0,'2014-01-16 08:45:25',NULL,NULL),(22388,14441,'TE','5043622427',0,'2013-12-28 03:32:12',NULL,NULL),(30182,19553,'EM','JNTFONTENOT@YAHOO.COM',0,'2014-01-23 03:02:30',NULL,NULL),(32512,21253,'TE','3305634207',0,'2014-02-03 21:01:19',NULL,NULL),(34664,22728,'AP','9857732797',0,'2014-02-11 21:01:14',NULL,NULL),(43773,29059,'TE','3306769588',0,'2014-03-10 21:01:50',NULL,NULL),(8863,5807,'AP','6128072658',0,'2013-12-25 23:47:40',NULL,NULL),(27550,17755,'AP','6019189868',0,'2014-01-14 01:33:30',NULL,NULL),(26650,17145,'AP','3186174160',0,'2014-01-13 02:21:54',NULL,NULL),(5933,3803,'AP','4197065163',0,'2013-12-25 21:34:36',NULL,NULL),(24518,15814,'AP','3186692163',0,'2014-01-03 02:03:19',NULL,NULL),(4479,2850,'EM','ssnone69@yahoo.com',0,'2013-12-25 20:01:20',NULL,NULL),(4156,2651,'AP','8174544683',0,'2013-12-25 19:46:37',NULL,NULL),(31662,20657,'TE','3615262634',0,'2014-01-30 21:00:42',NULL,NULL),(39510,26134,'EM','manal7646@gmail.com',0,'2014-02-28 06:30:24',NULL,NULL),(39978,26469,'EM','mispriss2017@gmail.com',0,'2014-02-28 07:30:36',NULL,NULL),(40728,27067,'TE','3187801559',0,'2014-03-03 21:30:03',NULL,NULL),(42381,28147,'TE','4194764363',0,'2014-03-06 21:02:35',NULL,NULL),(7382,4804,'TE','3185279761',0,'2013-12-25 22:16:35',NULL,NULL),(7334,4767,'AP','6143485529',0,'2013-12-25 22:15:44',NULL,NULL),(20213,13022,'AP','3309048926',0,'2013-12-26 12:50:06',NULL,NULL),(6159,3969,'AP','5136282675',0,'2013-12-25 21:38:32',NULL,NULL),(37653,24828,'TE','5133025862',0,'2014-02-20 04:51:25',NULL,NULL),(38800,25652,'AP','5136751832',0,'2014-02-26 08:30:39',NULL,NULL),(40346,26777,'TE','9033436836',0,'2014-03-01 21:00:11',NULL,NULL),(40750,27081,'EM','iahang50@gmail.com',0,'2014-03-03 21:30:11',NULL,NULL),(42072,27956,'AP','3373712804',0,'2014-03-06 21:00:41',NULL,NULL),(12318,8053,'AP','5672770447',0,'2013-12-26 03:09:46',NULL,NULL),(5684,3651,'TE','5137291510',0,'2013-12-25 21:30:38',NULL,NULL),(4235,2707,'AP','3309980303',0,'2013-12-25 19:47:54',NULL,NULL),(24534,15824,'TE','7403600954',0,'2014-01-03 02:03:38',NULL,NULL),(23219,14963,'TE','9727366640',0,'2014-01-01 12:00:35',NULL,NULL),(20680,13297,'TE','8324920995',0,'2013-12-26 12:57:40',NULL,NULL),(14440,9436,'TE','5132215451',0,'2013-12-26 04:33:32',NULL,NULL),(14070,9198,'EM','pluck88keys@yahoo.com',0,'2013-12-26 04:09:34',NULL,NULL),(10638,6919,'AP','6144040315',0,'2013-12-26 01:46:10',NULL,NULL),(32666,21364,'AP','9092616284',0,'2014-02-04 21:00:45',NULL,NULL),(39230,25950,'TE','6144192697',0,'2014-02-26 21:01:36',NULL,NULL),(39663,26227,'TE','6822241644',0,'2014-02-28 06:30:59',NULL,NULL),(40084,26583,'AP','6148327682',0,'2014-02-28 21:30:32',NULL,NULL),(40982,27231,'TE','4407155019',0,'2014-03-03 21:31:41',NULL,NULL),(43290,28761,'AP','8062237108',0,'2014-03-09 21:00:23',NULL,NULL),(11061,7182,'AP','9372841549',0,'2013-12-26 02:00:15',NULL,NULL),(10990,7140,'TE','2812827669',0,'2013-12-26 01:51:51',NULL,NULL),(7993,5215,'EM','lynn45217@yahoo.com',0,'2013-12-25 23:04:24',NULL,NULL),(8717,5719,'EM','conradshelby@gmail.com',0,'2013-12-25 23:45:22',NULL,NULL),(36119,23772,'TE','5133511420',0,'2014-02-14 21:31:14',NULL,NULL),(37209,24489,'TE','9152443276',0,'2014-02-20 03:43:46',NULL,NULL),(38137,25172,'TE','7405455238',0,'2014-02-21 22:00:29',NULL,NULL),(42537,28301,'TE','3306775373',0,'2014-03-07 21:00:32',NULL,NULL),(43096,28649,'EM','na.surin@aol.com',0,'2014-03-08 21:30:37',NULL,NULL),(3328,2092,'EM','joelle66@suddenlink.net',0,'2013-12-25 19:16:56',NULL,NULL),(8495,5588,'TE','5042408728',0,'2013-12-25 23:17:10',NULL,NULL),(27665,17833,'TE','6012097172',0,'2014-01-15 02:06:00',NULL,NULL),(38202,25217,'TE','2166506915',0,'2014-02-21 22:00:54',NULL,NULL),(38701,25574,'AP','4192047267',0,'2014-02-26 08:00:33',NULL,NULL),(11640,7573,'TE','2169780364',0,'2013-12-26 02:33:46',NULL,NULL),(23410,15080,'AP','8179833443',0,'2014-01-01 12:04:08',NULL,NULL),(23427,15093,'AP','9375461204',0,'2014-01-01 12:04:31',NULL,NULL),(33366,21863,'AP','4199343263',0,'2014-02-06 21:01:21',NULL,NULL),(850,528,'AP','3302127069',0,'2013-12-25 17:49:23',NULL,NULL),(27102,17435,'EM','babcockx4@cinci.rr.com',0,'2014-01-13 03:00:33',NULL,NULL),(12176,7953,'TE','5043469946',0,'2013-12-26 03:07:14',NULL,NULL),(26047,16780,'TE','7025725002',0,'2014-01-08 18:25:05',NULL,NULL),(21509,13823,'EM','caveman282@neo.rr.com',0,'2013-12-26 13:11:56',NULL,NULL),(14759,9652,'TE','4196455020',0,'2013-12-26 04:38:49',NULL,NULL),(5850,3754,'TE','3306313464',0,'2013-12-25 21:33:15',NULL,NULL),(5620,3600,'TE','4198062347',0,'2013-12-25 21:23:15',NULL,NULL),(34165,22406,'AP','3019803757',0,'2014-02-10 21:30:22',NULL,NULL),(36207,23833,'TE','2283265508',0,'2014-02-14 21:31:47',NULL,NULL),(1433,875,'TE','9375649179',0,'2013-12-25 18:07:33',NULL,NULL),(29808,19288,'TE','5042140869',1,'2014-01-22 03:21:53',NULL,NULL),(9236,6045,'AP','3302422474',0,'2013-12-26 00:01:32',NULL,NULL),(29222,18874,'EM','TANYACAMPBELL232@GMAIL.COM',0,'2014-01-17 03:36:25',NULL,NULL),(5096,3270,'TE','6012810051',0,'2013-12-25 20:47:10',NULL,NULL),(26733,17194,'AP','2253628313',0,'2014-01-13 02:22:20',NULL,NULL),(25937,16710,'AP','2144992925',0,'2014-01-08 18:24:42',NULL,NULL),(5301,3399,'TE','4405208832',0,'2013-12-25 21:18:04',NULL,NULL),(32216,21040,'TE','5133027992',0,'2014-02-01 19:00:50',NULL,NULL),(36366,23947,'TE','5673954957',0,'2014-02-15 21:00:13',NULL,NULL),(42934,28547,'AP','4192830716',0,'2014-03-07 21:32:18',NULL,NULL),(27638,17817,'TE','6012740660',0,'2014-01-15 02:05:54',NULL,NULL),(731,458,'AP','7078158061',0,'2013-12-25 17:47:33',NULL,NULL),(25332,16335,'TE','9732343010',0,'2014-01-07 04:02:06',NULL,NULL),(25325,16331,'TE','9859910236',0,'2014-01-07 04:02:00',NULL,NULL),(2450,1505,'TE','4156372412',0,'2013-12-25 18:49:21',NULL,NULL),(4212,2691,'TE','6824331272',0,'2013-12-25 19:47:32',NULL,NULL),(7847,5122,'EM','belabobee@yahoo.com',0,'2013-12-25 23:01:58',NULL,NULL),(24166,15615,'EM','bross78@bellsouth.net',1,'2014-01-02 04:32:59',NULL,NULL),(4867,3115,'TE','7132545474',0,'2013-12-25 20:30:09',NULL,NULL),(23974,15475,'TE','2165443536',1,'2014-01-02 04:29:00',NULL,NULL),(6216,4008,'EM','chris.alvarado@alumni.nd.edu',0,'2013-12-25 21:45:21',NULL,NULL),(5086,3263,'AP','3306346896',0,'2013-12-25 20:46:58',NULL,NULL),(21475,13798,'TE','6015069342',0,'2013-12-26 13:11:18',NULL,NULL),(21414,13767,'AP','6622425561',0,'2013-12-26 13:10:24',NULL,NULL),(14140,9258,'EM','QUEENB6469@YAHOO.COM',0,'2013-12-26 04:15:14',NULL,NULL),(13822,9012,'AP','3306042137',0,'2013-12-26 04:05:07',NULL,NULL),(27954,18017,'TE','5138827183',0,'2014-01-15 02:07:04',NULL,NULL),(28077,18094,'AP','3373804592',0,'2014-01-15 02:07:32',NULL,NULL),(29418,19018,'EM','deanlaurich@yahoo.com',0,'2014-01-20 08:06:24',NULL,NULL),(31694,20673,'AP','6019461962',0,'2014-01-30 21:00:51',NULL,NULL),(32028,20906,'AP','8598027287',0,'2014-01-31 21:01:24',NULL,NULL),(32690,21382,'TE','4407816057',0,'2014-02-04 21:00:53',NULL,NULL),(40633,26970,'EM','qphovn@yahoo.com',0,'2014-03-03 01:00:34',NULL,NULL),(43882,29117,'AP','6016689251',0,'2014-03-10 21:02:28',NULL,NULL),(24001,15492,'TE','9374176225',1,'2014-01-02 04:29:32',NULL,NULL),(10126,6621,'TE','6014023349',0,'2013-12-26 00:54:04',NULL,NULL),(971,596,'EM','rlwiley1@frontier.com',0,'2013-12-25 18:00:13',NULL,NULL),(4172,2665,'TE','5136738802',0,'2013-12-25 19:46:55',NULL,NULL),(4353,2777,'AP','6627060783',0,'2013-12-25 19:49:44',NULL,NULL),(10947,7114,'AP','8506028769',0,'2013-12-26 01:51:09',NULL,NULL),(28941,18684,'AP','2814606815',0,'2014-01-17 03:35:21',NULL,NULL),(30408,19705,'TE','9037964332',0,'2014-01-23 21:00:50',NULL,NULL),(34959,22952,'TE','4403717126',0,'2014-02-11 21:30:29',NULL,NULL),(35118,23067,'AP','2252024600',0,'2014-02-12 21:30:54',NULL,NULL),(36615,24106,'TE','7245573782',0,'2014-02-15 22:01:34',NULL,NULL),(36642,24122,'TE','9036297053',0,'2014-02-15 22:01:43',NULL,NULL),(37195,24482,'EM','pastorfarwell@aol.com',0,'2014-02-18 22:01:46',NULL,NULL),(39827,26342,'TE','4192874119',0,'2014-02-28 06:31:44',NULL,NULL),(41779,27777,'TE','3308079200',0,'2014-03-05 21:31:31',NULL,NULL),(4274,2732,'AP','3185727589',0,'2013-12-25 19:48:31',NULL,NULL),(20694,13304,'AP','9793089916',0,'2013-12-26 12:57:53',NULL,NULL),(7487,4872,'AP','9568744078',0,'2013-12-25 22:31:03',NULL,NULL),(5883,3773,'EM','ralphseverance@gmail.com',0,'2013-12-25 21:33:46',NULL,NULL),(6634,4295,'TE','6625072239',0,'2013-12-25 21:52:15',NULL,NULL),(14603,9548,'TE','9372140406',0,'2013-12-26 04:36:13',NULL,NULL),(10983,7135,'AP','6623923083',0,'2013-12-26 01:51:45',NULL,NULL),(11638,7570,'AP','2169780364',0,'2013-12-26 02:33:44',NULL,NULL),(11672,7598,'EM','lloydbruce54@yahoo.com',0,'2013-12-26 02:45:19',NULL,NULL),(11966,7798,'TE','3257213811',0,'2013-12-26 03:03:35',NULL,NULL),(14301,9354,'TE','3374783582',0,'2013-12-26 04:31:20',NULL,NULL),(13767,8973,'AP','8122491521',0,'2013-12-26 04:04:07',NULL,NULL),(28127,18132,'EM','bowteep@msn.com',0,'2014-01-15 02:07:43',NULL,NULL),(32469,21215,'TE','2252356479',0,'2014-02-03 21:01:01',NULL,NULL),(32813,21469,'AP','8287312449',0,'2014-02-04 21:01:37',NULL,NULL),(35926,23638,'TE','9794796361',0,'2014-02-14 21:30:07',NULL,NULL),(37828,24960,'EM','jeromecarney14@yahoo.com',0,'2014-02-20 22:00:18',NULL,NULL),(41520,27605,'TE','2162729683',0,'2014-03-05 21:00:26',NULL,NULL),(6530,4224,'TE','5132185098',0,'2013-12-25 21:50:30',NULL,NULL),(26661,17151,'TE','5044585858',0,'2014-01-13 02:21:57',NULL,NULL),(27335,17601,'EM','vaibhav_1002@yahoo.co.in',0,'2014-01-14 01:32:16',NULL,NULL),(24240,15659,'EM','MLau449125@aol.com',1,'2014-01-02 04:34:24',NULL,NULL),(23014,14843,'TE','9374291832',1,'2013-12-29 11:14:53',NULL,NULL),(6887,4470,'EM','alandail@me.com',0,'2013-12-25 22:02:51',NULL,NULL),(22270,14354,'TE','3303259038',0,'2013-12-28 03:30:06',NULL,NULL),(22180,14288,'AP','3304313636',0,'2013-12-27 02:06:31',NULL,NULL),(4806,3073,'EM','joshuapriestley@charter.net',0,'2013-12-25 20:19:31',NULL,NULL),(7580,4934,'AP','9372160064',0,'2013-12-25 22:45:31',NULL,NULL),(12303,8046,'EM','nicholaskostoff@yahoo.com',0,'2013-12-26 03:09:33',NULL,NULL),(30870,20064,'AP','3254508543',0,'2014-01-27 21:00:13',NULL,NULL),(32704,21394,'TE','5136418704',0,'2014-02-04 21:00:58',NULL,NULL),(33828,22211,'TE','6149488019',0,'2014-02-09 19:00:20',NULL,NULL),(38471,25424,'EM','ARIELDELLINGER@YAHOO.COM',0,'2014-02-25 21:31:11',NULL,NULL),(42575,28330,'AP','2147973992',0,'2014-03-07 21:30:10',NULL,NULL),(2,1,'EM','jrobinson57@rocketmail.com',0,'2013-12-25 17:15:03',NULL,NULL),(3019,1881,'AP','5672772534',0,'2013-12-25 18:58:32',NULL,NULL),(3350,2105,'EM','williolacomme31@gmail.com',0,'2013-12-25 19:17:18',NULL,NULL),(27243,17540,'TE','3307800757',0,'2014-01-13 03:01:47',NULL,NULL),(23766,15329,'TE','9726725637',1,'2014-01-02 04:23:52',NULL,NULL),(27669,17835,'TE','9372784452',0,'2014-01-15 02:06:01',NULL,NULL),(3446,2159,'EM','mscheron@gmail.com',0,'2013-12-25 19:18:50',NULL,NULL),(5870,3766,'AP','3304143127',0,'2013-12-25 21:33:34',NULL,NULL),(28206,18180,'TE','4192631332',0,'2014-01-15 02:08:00',NULL,NULL),(30251,19594,'EM','mralonzopagebrat5@gmail.com',0,'2014-01-23 03:02:46',NULL,NULL),(30446,19737,'TE','3183878193',0,'2014-01-23 21:01:09',NULL,NULL),(31214,20329,'TE','4197968480',0,'2014-01-28 21:01:00',NULL,NULL),(32098,20963,'TE','9152695280',0,'2014-02-01 19:00:10',NULL,NULL),(33899,22252,'TE','4193664944',0,'2014-02-09 19:00:43',NULL,NULL),(35261,23156,'EM','jfishinlou@aol.com',0,'2014-02-12 21:31:45',NULL,NULL),(37145,24452,'TE','2284528587',0,'2014-02-18 22:01:27',NULL,NULL),(38698,25573,'AP','4197333508',0,'2014-02-26 08:00:32',NULL,NULL),(39840,26350,'AP','4192176488',0,'2014-02-28 06:31:47',NULL,NULL),(39999,26491,'TE','9858761866',0,'2014-02-28 21:00:10',NULL,NULL),(43828,29091,'TE','7133666927',0,'2014-03-10 21:02:10',NULL,NULL),(10234,6691,'AP','2166300727',0,'2013-12-26 01:01:35',NULL,NULL),(9627,6300,'EM','pamvogel@ymail.com',0,'2013-12-26 00:45:53',NULL,NULL),(25166,16225,'TE','4199234605',0,'2014-01-05 00:01:55',NULL,NULL),(886,549,'TE','5122984226',0,'2013-12-25 17:49:59',NULL,NULL),(1198,730,'TE','5129218444',0,'2013-12-25 18:03:46',NULL,NULL),(24115,15567,'TE','4407731760',1,'2014-01-02 04:31:47',NULL,NULL),(21832,14064,'EM','hans@hrasmussen.com',0,'2013-12-27 02:00:40',NULL,NULL),(6636,4297,'EM','edflechas@aol.com',0,'2013-12-25 21:52:17',NULL,NULL),(6495,4201,'AP','8176919029',0,'2013-12-25 21:49:54',NULL,NULL),(5508,3525,'AP','5043307608',0,'2013-12-25 21:21:21',NULL,NULL),(30370,19676,'TE','3254367103',0,'2014-01-23 21:00:35',NULL,NULL),(31791,20750,'TE','3022569548',0,'2014-01-30 21:01:30',NULL,NULL),(35429,23290,'TE','9376795088',0,'2014-02-13 22:00:07',NULL,NULL),(39325,26011,'TE','5672597354',0,'2014-02-26 21:02:10',NULL,NULL),(2044,1266,'AP','9563462843',0,'2013-12-25 18:30:07',NULL,NULL),(26965,17341,'TE','6015002906',0,'2014-01-13 02:24:03',NULL,NULL),(3132,1951,'TE','4698655673',0,'2013-12-25 19:01:00',NULL,NULL),(26173,16850,'EM','shanwhitelaw@gmail.com',0,'2014-01-13 02:18:40',NULL,NULL),(9595,6282,'AP','5134854408',0,'2013-12-26 00:45:24',NULL,NULL),(24545,15830,'EM','punkin_pie_head@yahoo.com',0,'2014-01-03 02:03:50',NULL,NULL),(27967,18030,'AP','2163160017',0,'2014-01-15 02:07:08',NULL,NULL),(28097,18109,'AP','2253435736',0,'2014-01-15 02:07:36',NULL,NULL),(6718,4366,'TE','5133206656',0,'2013-12-25 22:00:11',NULL,NULL),(21889,14102,'AP','2165712781',0,'2013-12-27 02:01:37',NULL,NULL),(20296,13082,'EM','JBONARRIGO@ZOOMINTERNET.NET',0,'2013-12-26 12:51:37',NULL,NULL),(20285,13076,'AP','9374794333',0,'2013-12-26 12:51:27',NULL,NULL),(6753,4383,'AP','6146220086',0,'2013-12-25 22:00:41',NULL,NULL),(28716,18530,'TE','5134518430',0,'2014-01-16 08:46:43',NULL,NULL),(33756,22151,'TE','3306711714',0,'2014-02-08 19:00:54',NULL,NULL),(34355,22536,'TE','2283131016',0,'2014-02-10 21:31:35',NULL,NULL),(37870,24982,'TE','3612180168',0,'2014-02-20 22:00:34',NULL,NULL),(38929,25735,'TE','5184289806',0,'2014-02-26 09:30:38',NULL,NULL),(41409,27511,'TE','5138470234',0,'2014-03-04 21:02:33',NULL,NULL),(43287,28759,'TE','9794923908',0,'2014-03-09 21:00:21',NULL,NULL),(24273,15685,'TE','8594141611',1,'2014-01-02 04:35:10',NULL,NULL),(27713,17863,'TE','3302813020',0,'2014-01-15 02:06:11',NULL,NULL),(28004,18049,'AP','6019405641',0,'2014-01-15 02:07:16',NULL,NULL),(24209,15638,'TE','5045789276',1,'2014-01-02 04:33:44',NULL,NULL),(20620,13263,'TE','9036295303',0,'2013-12-26 12:56:43',NULL,NULL),(2725,1654,'AP','8176584491',0,'2013-12-25 18:53:27',NULL,NULL),(8753,5738,'TE','2252781855',0,'2013-12-25 23:45:53',NULL,NULL),(13706,8933,'EM','tajenben@yahoo.com',0,'2013-12-26 04:03:06',NULL,NULL),(5881,3772,'EM','klm5632@aol.com',0,'2013-12-25 21:33:44',NULL,NULL),(6567,4239,'EM','daddysgirl0057@aol.com',0,'2013-12-25 21:50:59',NULL,NULL),(32159,21007,'TE','5047820558',0,'2014-02-01 19:00:32',NULL,NULL),(32627,21331,'AP','9402300093',0,'2014-02-04 21:00:29',NULL,NULL),(32837,21487,'EM','susanb50@gmail.com',0,'2014-02-04 21:01:46',NULL,NULL),(40647,26984,'TE','5132316720',0,'2014-03-03 01:00:39',NULL,NULL),(405,248,'AP','4194389189',0,'2013-12-25 17:21:30',NULL,NULL),(1534,942,'EM','karenmoore918@att.net',0,'2013-12-25 18:09:24',NULL,NULL),(3302,2078,'TE','3372987960',0,'2013-12-25 19:16:33',NULL,NULL),(23526,15180,'TE','7402722409',0,'2014-01-01 12:06:48',NULL,NULL),(11513,7492,'TE','9372511555',0,'2013-12-26 02:31:39',NULL,NULL),(26892,17302,'TE','9032630208',0,'2014-01-13 02:23:39',NULL,NULL),(32931,21556,'TE','5136525637',0,'2014-02-05 21:30:16',NULL,NULL),(33461,21919,'EM','willibyrd@yahoo.com',0,'2014-02-07 19:00:05',NULL,NULL),(33624,22049,'TE','3252009635',0,'2014-02-08 19:00:04',NULL,NULL),(35822,23556,'TE','4199667781',0,'2014-02-13 22:02:42',NULL,NULL),(43377,28808,'TE','3303424511',0,'2014-03-09 21:00:53',NULL,NULL),(248,153,'AP','2102732601',0,'2013-12-25 17:18:58',NULL,NULL),(24523,15816,'EM','birt47@yahoo.com',0,'2014-01-03 02:03:24',NULL,NULL),(10264,6706,'TE','9377955023',0,'2013-12-26 01:02:04',NULL,NULL),(24330,15716,'EM','bdunlap8@woh.rr.com',1,'2014-01-02 04:36:15',NULL,NULL),(2255,1382,'TE','2555051440',0,'2013-12-25 18:46:07',NULL,NULL),(20776,13350,'EM','stristan1978@yahoo.com',0,'2013-12-26 12:59:11',NULL,NULL),(13785,8984,'TE','5137410077',0,'2013-12-26 04:04:25',NULL,NULL),(3181,1997,'AP','8176816774',0,'2013-12-25 19:02:06',NULL,NULL),(5405,3458,'TE','7409836652',0,'2013-12-25 21:19:41',NULL,NULL),(7977,5204,'TE','5132328557',0,'2013-12-25 23:04:07',NULL,NULL),(6076,3911,'AP','8328659160',0,'2013-12-25 21:37:06',NULL,NULL),(29526,19084,'AP','4197639068',0,'2014-01-21 08:44:28',NULL,NULL),(31483,20517,'TE','8064747727',0,'2014-01-29 21:01:22',NULL,NULL),(36117,23768,'TE','2147971344',0,'2014-02-14 21:31:13',NULL,NULL),(40834,27135,'TE','7403901621',0,'2014-03-03 21:30:43',NULL,NULL),(27979,18037,'TE','9376238469',0,'2014-01-15 02:07:11',NULL,NULL),(26376,16977,'TE','6013106684',0,'2014-01-13 02:20:16',NULL,NULL),(28330,18258,'TE','9154122915',0,'2014-01-16 08:44:35',NULL,NULL),(26065,16788,'AP','5133311737',0,'2014-01-08 18:25:08',NULL,NULL),(24331,15717,'TE','2162186997',0,'2014-01-03 02:00:04',NULL,NULL),(9570,6268,'TE','9854980736',0,'2013-12-26 00:32:27',NULL,NULL),(11648,7582,'TE','9374199416',0,'2013-12-26 02:33:57',NULL,NULL),(6593,4256,'EM','nvickroy63@yahoo.com',0,'2013-12-25 21:51:26',NULL,NULL),(5432,3476,'TE','6142593498',0,'2013-12-25 21:20:05',NULL,NULL),(29249,18891,'AP','3307866893',0,'2014-01-17 03:36:32',NULL,NULL),(30148,19535,'TE','3306972909',0,'2014-01-23 03:02:22',NULL,NULL),(30496,19782,'TE','3306122159',0,'2014-01-23 21:01:35',NULL,NULL),(30497,19782,'AP','3306122159',0,'2014-01-23 21:01:35',NULL,NULL),(31655,20651,'AP','9158735996',0,'2014-01-30 21:00:39',NULL,NULL),(32692,21382,'EM','vegamichelle81@yahoo.com',0,'2014-02-04 21:00:54',NULL,NULL),(34597,22685,'AP','9366466519',0,'2014-02-11 21:00:50',NULL,NULL),(35155,23090,'AP','3305191871',0,'2014-02-12 21:31:06',NULL,NULL),(37878,24987,'TE','9159207795',0,'2014-02-20 22:00:38',NULL,NULL),(40894,27171,'BN','8329646161',0,'2014-03-03 21:31:05',NULL,NULL),(42517,28282,'TE','5049821701',0,'2014-03-07 21:00:25',NULL,NULL),(488,311,'EM','ETXEMS@GMAIL.COM',0,'2013-12-25 17:31:02',NULL,NULL),(27949,18008,'BN','5136333270',0,'2014-01-15 02:07:03',NULL,NULL),(26981,17354,'TE','9858397994',0,'2014-01-13 02:24:10',NULL,NULL),(28304,18243,'AP','3252456733',0,'2014-01-16 08:44:26',NULL,NULL),(9578,6272,'TE','3309276407',0,'2013-12-26 00:45:08',NULL,NULL),(21234,13650,'TE','5048135955',0,'2013-12-26 13:07:17',NULL,NULL),(9239,6048,'TE','5133007644',0,'2013-12-26 00:01:35',NULL,NULL),(20538,13220,'EM','redmagnoliarose@aol.com',0,'2013-12-26 12:55:28',NULL,NULL),(8460,5564,'EM','kkcdcdc@netzero.net',0,'2013-12-25 23:16:35',NULL,NULL),(4445,2834,'TE','3378845779',0,'2013-12-25 20:00:50',NULL,NULL),(30321,19642,'TE','3304691536',0,'2014-01-23 21:00:15',NULL,NULL),(38368,25343,'TE','2165414313',0,'2014-02-25 21:30:26',NULL,NULL),(38546,25471,'TE','8303859575',0,'2014-02-25 21:31:37',NULL,NULL),(40479,26866,'TE','9158491968',0,'2014-03-01 21:01:00',NULL,NULL),(41324,27453,'EM','drmress@gmail.com',0,'2014-03-04 21:02:00',NULL,NULL),(43161,28684,'EM','monica.r.foster@gmail.com',0,'2014-03-08 21:30:59',NULL,NULL),(43675,28986,'EM','coachhouse@sssnet.com',0,'2014-03-10 21:01:12',NULL,NULL),(43777,29060,'AP','3306316312',0,'2014-03-10 21:01:51',NULL,NULL),(10523,6854,'TE','9372763017',0,'2013-12-26 01:31:28',NULL,NULL),(26975,17349,'AP','9375592483',0,'2014-01-13 02:24:08',NULL,NULL),(9963,6521,'TE','4196544446',0,'2013-12-26 00:51:24',NULL,NULL),(9123,5975,'AP','3305750409',0,'2013-12-25 23:51:48',NULL,NULL),(7073,4621,'TE','3372496902',0,'2013-12-25 22:06:14',NULL,NULL),(6901,4490,'EM','mberger1@bex.net',0,'2013-12-25 22:03:08',NULL,NULL),(6009,3859,'AP','3183152511',0,'2013-12-25 21:35:53',NULL,NULL),(23580,15222,'TE','2252613882',0,'2014-01-01 12:08:04',NULL,NULL),(13928,9082,'TE','5136670628',0,'2013-12-26 04:06:51',NULL,NULL),(20453,13178,'EM','texasriggs@yahoo.com',0,'2013-12-26 12:54:14',NULL,NULL),(31090,20237,'AP','7697983622',0,'2014-01-28 21:00:06',NULL,NULL),(34531,22652,'TE','8063507758',0,'2014-02-11 21:00:29',NULL,NULL),(37663,24832,'TE','6019419363',0,'2014-02-20 04:52:30',NULL,NULL),(38146,25177,'AP','5137065119',0,'2014-02-21 22:00:32',NULL,NULL),(38732,25603,'TE','5123884705',0,'2014-02-26 08:30:03',NULL,NULL),(38910,25722,'BN','6018768111',0,'2014-02-26 09:30:29',NULL,NULL),(42785,28456,'TE','2252437328',0,'2014-03-07 21:31:22',NULL,NULL),(9242,6049,'TE','9197248258',0,'2013-12-26 00:01:38',NULL,NULL),(506,318,'EM','astramodernmarket@gmail.com',0,'2013-12-25 17:31:17',NULL,NULL),(697,432,'TE','4404299541',0,'2013-12-25 17:46:58',NULL,NULL),(25654,16543,'TE','9403129696',1,'2014-01-07 10:22:27',NULL,NULL),(6256,4035,'AP','5132507305',0,'2013-12-25 21:45:59',NULL,NULL),(24979,16099,'TE','4193491605',0,'2014-01-04 02:04:42',NULL,NULL),(24706,15937,'TE','9376557352',0,'2014-01-03 02:07:07',NULL,NULL),(23622,15251,'AP','5672241563',0,'2014-01-01 12:08:57',NULL,NULL),(23121,14904,'AP','6626094981',0,'2013-12-30 00:01:15',NULL,NULL),(2873,1756,'AP','6145301032',0,'2013-12-25 18:55:51',NULL,NULL),(3473,2173,'EM','bloughridge@roadrunner.com',0,'2013-12-25 19:19:14',NULL,NULL),(3510,2192,'EM','debi.crosby@fuse.net',0,'2013-12-25 19:19:48',NULL,NULL),(29063,18768,'TE','2147526756',0,'2014-01-17 03:35:49',NULL,NULL),(31284,20380,'EM','fcar28@gmail.com',0,'2014-01-29 21:00:11',NULL,NULL),(33322,21827,'AP','8325120667',0,'2014-02-06 21:01:02',NULL,NULL),(33565,22008,'TE','5132188111',0,'2014-02-07 19:00:50',NULL,NULL),(34480,22623,'TE','6267312108',0,'2014-02-11 21:00:12',NULL,NULL),(35766,23522,'TE','9544941310',0,'2014-02-13 22:02:21',NULL,NULL),(37054,24402,'AP','4405030461',0,'2014-02-18 22:00:55',NULL,NULL),(41346,27468,'TE','5137221873',0,'2014-03-04 21:02:10',NULL,NULL),(53,33,'EM','farmall400@live.com',0,'2013-12-25 17:15:52',NULL,NULL),(24272,15684,'EM','blueskyholiday247@yahoo.com',1,'2014-01-02 04:35:08',NULL,NULL),(8584,5641,'AP','3615850052',0,'2013-12-25 23:31:15',NULL,NULL),(8392,5524,'TE','6145982219',0,'2013-12-25 23:15:23',NULL,NULL),(7142,4658,'EM','kah0613@aol.com',0,'2013-12-25 22:07:18',NULL,NULL),(11490,7473,'AP','5136047094',0,'2013-12-26 02:31:13',NULL,NULL),(9472,6198,'TE','4402592368',0,'2013-12-26 00:30:32',NULL,NULL),(12457,8157,'AP','5049529877',0,'2013-12-26 03:16:14',NULL,NULL),(5994,3851,'TE','3377394628',0,'2013-12-25 21:35:38',NULL,NULL),(4814,3080,'TE','2163988787',0,'2013-12-25 20:19:42',NULL,NULL),(31986,20885,'TE','9374034485',0,'2014-01-31 21:01:10',NULL,NULL),(33320,21822,'EM','jblackmon02@hotmail.com',0,'2014-02-06 21:01:01',NULL,NULL),(33484,21942,'BN','4092391262',0,'2014-02-07 19:00:16',NULL,NULL),(13606,8868,'AP','2148090636',0,'2013-12-26 04:01:29',NULL,NULL),(43327,28784,'TE','2167983036',0,'2014-03-09 21:00:37',NULL,NULL),(9278,6075,'TE','3307721023',0,'2013-12-26 00:02:19',NULL,NULL),(4825,3088,'AP','9373213405',0,'2013-12-25 20:19:56',NULL,NULL),(9740,6371,'AP','3306966709',0,'2013-12-26 00:47:39',NULL,NULL),(3410,2142,'EM','donegdorf@ymail.com',0,'2013-12-25 19:18:18',NULL,NULL),(11218,7297,'TE','3308077710',0,'2013-12-26 02:03:03',NULL,NULL),(11927,7768,'TE','9565195181',0,'2013-12-26 03:02:53',NULL,NULL),(5142,3295,'TE','9546106909',0,'2013-12-25 21:15:36',NULL,NULL),(24383,15744,'AP','2543941376',0,'2014-01-03 02:00:57',NULL,NULL),(24217,15646,'TE','6018578426',1,'2014-01-02 04:33:57',NULL,NULL),(36416,23984,'EM','dorechwa@gmail.com',0,'2014-02-15 22:00:22',NULL,NULL),(29183,18854,'BN','8284215716',0,'2014-01-17 03:36:17',NULL,NULL),(27715,17864,'TE','3304258775',0,'2014-01-15 02:06:11',NULL,NULL),(23910,15426,'AP','8176888339',1,'2014-01-02 04:27:36',NULL,NULL),(27693,17851,'TE','5132900334',0,'2014-01-15 02:06:07',NULL,NULL),(37912,25009,'AP','2162156936',0,'2014-02-20 22:00:51',NULL,NULL),(33534,21982,'TE','5042317897',0,'2014-02-07 19:00:38',NULL,NULL),(13973,9114,'EM','jgsand49@aol.com',0,'2013-12-26 04:07:37',NULL,NULL),(28948,18687,'TE','5045631875',0,'2014-01-17 03:35:23',NULL,NULL),(28111,18118,'TE','3306275841',0,'2014-01-15 02:07:39',NULL,NULL),(11716,7628,'TE','9378309904',0,'2013-12-26 02:46:07',NULL,NULL),(10428,6798,'AP','4196562442',0,'2013-12-26 01:17:18',NULL,NULL),(27129,17466,'EM','oldladie501950@yahoo.com',0,'2014-01-13 03:01:05',NULL,NULL),(9881,6462,'TE','2345427548',0,'2013-12-26 00:49:56',NULL,NULL),(42626,28356,'AP','9727408246',0,'2014-03-07 21:30:26',NULL,NULL),(36245,23854,'AP','5133149889',0,'2014-02-14 21:32:00',NULL,NULL),(4386,2796,'TE','9373029230',0,'2013-12-25 19:50:17',NULL,NULL),(38621,25524,'TE','5137615940',0,'2014-02-25 21:32:09',NULL,NULL),(212,128,'AP','6015805758',0,'2013-12-25 17:18:24',NULL,NULL),(9096,5960,'EM','apaint41@gmail.com',0,'2013-12-25 23:51:23',NULL,NULL),(5278,3387,'AP','3376606476',0,'2013-12-25 21:17:43',NULL,NULL),(7196,4688,'TE','5135087200',0,'2013-12-25 22:08:07',NULL,NULL),(3772,2392,'AP','4407856281',0,'2013-12-25 19:33:20',NULL,NULL),(2141,1320,'AP','7403521089',0,'2013-12-25 18:31:42',NULL,NULL),(21952,14140,'AP','3183496734',0,'2013-12-27 02:02:38',NULL,NULL),(9091,5957,'AP','4197045087',0,'2013-12-25 23:51:18',NULL,NULL),(28975,18701,'TE','3184700443',0,'2014-01-17 03:35:28',NULL,NULL),(37303,24545,'EM','cerra.wingo@gmail.com',0,'2014-02-20 04:03:31',NULL,NULL),(31994,20888,'EM','wincommail@yahoo.com',0,'2014-01-31 21:01:13',NULL,NULL),(9722,6363,'AP','2164702366',0,'2013-12-26 00:47:26',NULL,NULL),(2667,1619,'TE','8065775814',0,'2013-12-25 18:52:32',NULL,NULL),(4141,2642,'EM','josephlordi48@gmail.com',0,'2013-12-25 19:46:22',NULL,NULL),(21989,14164,'TE','3372876713',0,'2013-12-27 02:03:15',NULL,NULL),(34422,22580,'EM','wilbur37@hotmail.com',0,'2014-02-10 21:32:03',NULL,NULL),(7694,5020,'EM','CURRYT99@YAHOO.COM',0,'2013-12-25 22:47:32',NULL,NULL),(36863,24277,'TE','5138258903',0,'2014-02-18 21:30:04',NULL,NULL),(41479,27571,'AP','7343954635',0,'2014-03-04 21:30:20',NULL,NULL),(28760,18559,'TE','9377799127',0,'2014-01-16 08:46:58',NULL,NULL),(453,283,'AP','7068176076',0,'2013-12-25 17:30:20',NULL,NULL),(30976,20149,'TE','7403148888',0,'2014-01-27 21:01:03',NULL,NULL),(8569,5635,'TE','9037440469',0,'2013-12-25 23:31:04',NULL,NULL),(20298,13083,'EM','kcconsult@embarqmail.com',0,'2013-12-26 12:51:39',NULL,NULL),(4909,3152,'AP','6149375512',0,'2013-12-25 20:31:05',NULL,NULL),(21489,13809,'TE','4403394917',0,'2013-12-26 13:11:34',NULL,NULL),(21969,14151,'AP','5043199262',0,'2013-12-27 02:02:55',NULL,NULL),(26760,17215,'EM','eisenhower.durr@gmail.com',0,'2014-01-13 02:22:31',NULL,NULL),(1884,1162,'EM','kathyalbert73@gmail.com',0,'2013-12-25 18:18:56',NULL,NULL),(12035,7850,'AP','4199056577',0,'2013-12-26 03:04:48',NULL,NULL),(25801,16627,'AP','6145179034',0,'2014-01-08 18:24:13',NULL,NULL),(10777,7005,'AP','3617747558',0,'2013-12-26 01:48:23',NULL,NULL),(22191,14294,'EM','jasplin@aol.com',0,'2013-12-27 02:06:40',NULL,NULL),(33396,21884,'TE','2252946409',0,'2014-02-06 21:01:33',NULL,NULL),(35338,23219,'TE','9016065827',0,'2014-02-12 21:32:18',NULL,NULL),(37400,24630,'TE','3187691160',0,'2014-02-20 04:17:47',NULL,NULL),(2078,1285,'TE','4193828640',0,'2013-12-25 18:30:41',NULL,NULL),(39739,26282,'TE','2253837447',0,'2014-02-28 06:31:20',NULL,NULL),(41163,27337,'EM','elijahroo24@gmail.com',0,'2014-03-04 21:00:57',NULL,NULL),(43701,29009,'EM','victoreena@aol.com',0,'2014-03-10 21:01:23',NULL,NULL),(2024,1252,'EM','qest@fuse.net',0,'2013-12-25 18:21:17',NULL,NULL),(24675,15910,'EM','acat824@gmail.com',0,'2014-01-03 02:06:22',NULL,NULL),(38664,25551,'AP','5044025046',0,'2014-02-26 08:00:18',NULL,NULL),(36647,24124,'EM','raymoton@cox.net',0,'2014-02-15 22:01:44',NULL,NULL),(35859,23580,'EM','kbucher1@zoomtown.com',0,'2014-02-13 22:02:57',NULL,NULL),(21923,14124,'TE','7403537552',0,'2013-12-27 02:02:11',NULL,NULL),(5300,3397,'EM','bollandrea1@gmail.com',0,'2013-12-25 21:18:01',NULL,NULL),(32368,21148,'TE','2145784561',0,'2014-02-03 21:00:26',NULL,NULL),(31766,20735,'EM','tartman@neo.rr.com',0,'2014-01-30 21:01:21',NULL,NULL),(6445,4164,'TE','5133242717',0,'2013-12-25 21:49:04',NULL,NULL),(14145,9260,'EM','crfalllc@gmail.com',0,'2013-12-26 04:15:18',NULL,NULL),(41591,27653,'AP','7403381353',0,'2014-03-05 21:30:23',NULL,NULL),(42500,28265,'TE','2813391616',0,'2014-03-07 21:00:19',NULL,NULL),(42625,28356,'TE','9727408246',0,'2014-03-07 21:30:26',NULL,NULL),(43545,28910,'BN','3305546885',0,'2014-03-10 21:00:27',NULL,NULL),(27274,17559,'AP','4192346254',0,'2014-01-13 03:02:00',NULL,NULL),(34261,22473,'EM','lashunjohnson137@yahoo.com',0,'2014-02-10 21:31:00',NULL,NULL),(33668,22085,'EM','labrneyedgirl@yahoo.com',0,'2014-02-08 19:00:21',NULL,NULL),(27152,17482,'EM','Sabrinaaddyson@gmail.com',0,'2014-01-13 03:01:14',NULL,NULL),(14194,9286,'EM','shortnsassy36@msn.com',0,'2013-12-26 04:16:02',NULL,NULL),(26978,17352,'EM','ozwest1@yahoo.com',0,'2014-01-13 02:24:09',NULL,NULL),(26445,17020,'TE','3309260383',0,'2014-01-13 02:20:40',NULL,NULL),(28162,18152,'EM','neff_phil@yahoo.com',0,'2014-01-15 02:07:51',NULL,NULL),(2626,1597,'AP','4693636325',0,'2013-12-25 18:51:56',NULL,NULL),(33887,22239,'AP','7407043147',0,'2014-02-09 19:00:37',NULL,NULL),(22126,14252,'AP','9035662440',0,'2013-12-27 02:05:32',NULL,NULL),(6525,4220,'EM','scottmleavell@gmail.com',0,'2013-12-25 21:50:24',NULL,NULL),(14390,9408,'AP','3615586670',0,'2013-12-26 04:32:48',NULL,NULL),(14573,9530,'TE','4196611507',0,'2013-12-26 04:35:46',NULL,NULL),(3668,2328,'AP','9562372333',0,'2013-12-25 19:31:36',NULL,NULL),(43085,28643,'TE','3255180414',0,'2014-03-08 21:30:33',NULL,NULL),(43623,28958,'TE','5047233921',0,'2014-03-10 21:00:54',NULL,NULL),(38942,25746,'TE','4193068063',0,'2014-02-26 09:30:43',NULL,NULL),(640,397,'EM','MrsU06@aol.com',0,'2013-12-25 17:46:05',NULL,NULL),(14195,9287,'TE','3302734951',0,'2013-12-26 04:16:03',NULL,NULL),(1987,1227,'EM','js@neo.rr.com',0,'2013-12-25 18:20:36',NULL,NULL),(14239,9316,'TE','3188555113',0,'2013-12-26 04:30:23',NULL,NULL),(21049,13540,'AP','3183472608',0,'2013-12-26 13:03:45',NULL,NULL),(1060,652,'EM','CHEN69968@GMAIL.COM',0,'2013-12-25 18:01:38',NULL,NULL),(40617,26962,'AP','3304596742',0,'2014-03-03 01:00:30',NULL,NULL),(42565,28322,'EM','ivonne_552@hotmail.com',0,'2014-03-07 21:30:06',NULL,NULL),(26970,17345,'EM','bengalsfan65@yahoo.com',0,'2014-01-13 02:24:05',NULL,NULL),(24812,16007,'TE','5127994830',0,'2014-01-04 02:01:41',NULL,NULL),(34160,22400,'TE','3308362018',0,'2014-02-10 21:30:19',NULL,NULL),(24618,15876,'TE','6095669668',0,'2014-01-03 02:05:16',NULL,NULL),(31134,20277,'TE','3308054112',0,'2014-01-28 21:00:27',NULL,NULL),(43264,28745,'TE','3375324709',0,'2014-03-09 21:00:12',NULL,NULL),(40022,26519,'EM','keithdietrich@hotmail.com',0,'2014-02-28 21:00:23',NULL,NULL),(10685,6945,'TE','2164867062',0,'2013-12-26 01:46:53',NULL,NULL),(34985,22969,'TE','3307339082',0,'2014-02-12 21:00:15',NULL,NULL),(33471,21927,'AP','9362086743',0,'2014-02-07 19:00:09',NULL,NULL),(6922,4510,'AP','3253384029',0,'2013-12-25 22:03:35',NULL,NULL),(31237,20343,'TE','3308684541',0,'2014-01-28 21:01:09',NULL,NULL),(4836,3095,'AP','4197061226',0,'2013-12-25 20:20:07',NULL,NULL),(11056,7179,'TE','7405321800',0,'2013-12-26 02:00:10',NULL,NULL),(42726,28419,'AP','3304008895',0,'2014-03-07 21:31:01',NULL,NULL),(32656,21357,'EM','crider1313@hotmail.com',0,'2014-02-04 21:00:41',NULL,NULL),(36300,23900,'TE','9376686627',0,'2014-02-14 21:32:24',NULL,NULL),(36526,24048,'AP','8176090303',0,'2014-02-15 22:01:03',NULL,NULL),(7560,4922,'TE','3307237432',0,'2013-12-25 22:45:12',NULL,NULL),(23101,14896,'AP','3185358104',0,'2013-12-30 00:00:58',NULL,NULL),(8309,5444,'EM','jeffrey@jeffreydupuis.com',0,'2013-12-25 23:10:01',NULL,NULL),(8081,5290,'TE','3302887926',0,'2013-12-25 23:06:01',NULL,NULL),(40478,26865,'BN','5129949733',0,'2014-03-01 21:01:00',NULL,NULL),(29186,18855,'EM','Karenlee.weber@gmail.com',0,'2014-01-17 03:36:18',NULL,NULL),(35837,23566,'TE','4193430812',0,'2014-02-13 22:02:48',NULL,NULL),(34217,22441,'TE','9566852884',0,'2014-02-10 21:30:42',NULL,NULL),(30715,19956,'TE','8174120872',0,'2014-01-25 19:00:05',NULL,NULL),(34126,22375,'TE','5133040572',0,'2014-02-10 21:30:05',NULL,NULL),(22504,14508,'AP','3616552800',0,'2013-12-28 03:33:59',NULL,NULL),(20568,13236,'TE','5123001033',0,'2013-12-26 12:55:55',NULL,NULL),(14105,9223,'TE','4196630784',0,'2013-12-26 04:10:16',NULL,NULL),(4746,3039,'EM','jones.2800@gmail.com',0,'2013-12-25 20:18:37',NULL,NULL),(26514,17060,'TE','9722930784',0,'2014-01-13 02:21:11',NULL,NULL),(24283,15691,'EM','baumanfarms@zoominternet.net',1,'2014-01-02 04:35:22',NULL,NULL),(39167,25907,'AP','5802121296',0,'2014-02-26 21:01:12',NULL,NULL),(38300,25289,'EM','erickvonahn@yahoo.com',0,'2014-02-25 21:00:22',NULL,NULL),(22300,14372,'EM','heather.nixy7@gmail.com',0,'2013-12-28 03:30:34',NULL,NULL),(11366,7403,'EM','kimlynnsharp@gmail.com',0,'2013-12-26 02:16:29',NULL,NULL),(5360,3432,'AP','3182188627',0,'2013-12-25 21:18:59',NULL,NULL),(42856,28501,'AP','3306711655',0,'2014-03-07 21:31:48',NULL,NULL),(43381,28810,'AP','4408129771',0,'2014-03-09 21:00:54',NULL,NULL),(10005,6547,'TE','8323721058',0,'2013-12-26 00:52:04',NULL,NULL),(1426,868,'AP','3303127825',0,'2013-12-25 18:07:23',NULL,NULL),(37734,24885,'TE','5134843500',0,'2014-02-20 05:37:38',NULL,NULL),(20592,13246,'TE','4096251496',0,'2013-12-26 12:56:16',NULL,NULL),(2808,1699,'EM','cynthiaecorwin@gmail.com',0,'2013-12-25 18:54:40',NULL,NULL),(4658,2976,'TE','4099863949',0,'2013-12-25 20:17:07',NULL,NULL),(4202,2687,'TE','2544983624',0,'2013-12-25 19:47:24',NULL,NULL),(1766,1089,'EM','CBRATKA@SBCGLOBAL.NET',0,'2013-12-25 18:17:00',NULL,NULL),(38397,25366,'EM','KatieWilson45226@gmail.com',0,'2014-02-25 21:30:39',NULL,NULL),(35461,23320,'TE','5132310192',0,'2014-02-13 22:00:24',NULL,NULL),(27631,17812,'TE','5127208310',0,'2014-01-15 02:05:53',NULL,NULL),(11835,7701,'TE','6148557830',0,'2013-12-26 03:01:16',NULL,NULL),(13917,9073,'AP','5132600097',0,'2013-12-26 04:06:41',NULL,NULL),(26280,16915,'TE','7404075342',0,'2014-01-13 02:19:40',NULL,NULL),(23104,14897,'AP','8507124093',0,'2013-12-30 00:01:00',NULL,NULL),(20479,13190,'EM','lelaco@peoplepc.com',0,'2013-12-26 12:54:36',NULL,NULL),(3204,2013,'TE','9373820280',0,'2013-12-25 19:02:34',NULL,NULL),(3607,2277,'AP','5134044002',0,'2013-12-25 19:30:29',NULL,NULL),(21294,13682,'TE','3306774216',0,'2013-12-26 13:08:12',NULL,NULL),(28444,18325,'BN','3306877759',0,'2014-01-16 08:45:10',NULL,NULL),(42836,28490,'TE','6147077769',0,'2014-03-07 21:31:41',NULL,NULL),(1481,906,'EM','miaT968@gmail.com',0,'2013-12-25 18:08:26',NULL,NULL),(9252,6053,'TE','2168891721',0,'2013-12-26 00:01:46',NULL,NULL),(31969,20874,'AP','2252849728',0,'2014-01-31 21:01:04',NULL,NULL),(21135,13589,'AP','2253685577',0,'2013-12-26 13:05:08',NULL,NULL),(14985,9806,'AP','9375362711',0,'2013-12-26 05:01:22',NULL,NULL),(1573,970,'TE','4196680762',0,'2013-12-25 18:10:00',NULL,NULL),(3716,2356,'AP','9366525155',0,'2013-12-25 19:32:23',NULL,NULL),(24825,16013,'EM','triciatrish38@yahoo.com',0,'2014-01-04 02:01:54',NULL,NULL),(41763,27770,'TE','5044944301',0,'2014-03-05 21:31:26',NULL,NULL),(43655,28973,'AP','2256203091',0,'2014-03-10 21:01:04',NULL,NULL),(1025,632,'AP','5133071859',0,'2013-12-25 18:01:08',NULL,NULL),(11026,7158,'TE','4194870366',0,'2013-12-26 01:52:22',NULL,NULL),(23007,14839,'EM','tracygolden12@gmail.com',1,'2013-12-29 11:14:47',NULL,NULL),(24577,15853,'EM','bhimmelright@yahoo.com',0,'2014-01-03 02:04:29',NULL,NULL),(29638,19149,'TE','9032597471',0,'2014-01-21 08:45:33',NULL,NULL),(33508,21960,'EM','kasm1@att.net',0,'2014-02-07 19:00:25',NULL,NULL),(281,174,'TE','3307037526',0,'2013-12-25 17:19:30',NULL,NULL),(7925,5164,'AP','4407230638',0,'2013-12-25 23:03:09',NULL,NULL),(13649,8900,'EM','atty.johnporter@yahoo.com',0,'2013-12-26 04:02:16',NULL,NULL),(30214,19574,'AP','3185604805',0,'2014-01-23 03:02:37',NULL,NULL),(35143,23079,'TE','3302532538',0,'2014-02-12 21:31:02',NULL,NULL),(34352,22534,'AP','6019428946',0,'2014-02-10 21:31:34',NULL,NULL),(30819,20038,'TE','5133931680',0,'2014-01-26 19:00:24',NULL,NULL),(43051,28621,'EM','AVALOSTOCA@YAHOO.COM',0,'2014-03-08 21:30:22',NULL,NULL),(10733,6979,'TE','6143302872',0,'2013-12-26 01:47:40',NULL,NULL),(9443,6182,'TE','9377286972',0,'2013-12-26 00:30:05',NULL,NULL),(2305,1410,'TE','5044435738',0,'2013-12-25 18:46:54',NULL,NULL),(36123,23775,'EM','MANDIEMBARNES@GMAIL.COM',0,'2014-02-14 21:31:16',NULL,NULL),(23368,15053,'AP','3379629049',0,'2014-01-01 12:03:20',NULL,NULL),(42184,28023,'TE','4405419478',0,'2014-03-06 21:01:22',NULL,NULL),(557,346,'AP','5012496592',0,'2013-12-25 17:32:07',NULL,NULL),(10813,7023,'EM','raoshaun10@gmail.com',0,'2013-12-26 01:48:55',NULL,NULL),(39469,26099,'AP','2259394197',0,'2014-02-28 06:30:12',NULL,NULL),(38749,25618,'TE','9727653376',0,'2014-02-26 08:30:14',NULL,NULL),(37523,24711,'TE','6142260708',0,'2014-02-20 04:36:08',NULL,NULL),(10578,6885,'TE','6127083995',0,'2013-12-26 01:45:12',NULL,NULL),(6830,4433,'AP','2165095240',0,'2013-12-25 22:01:55',NULL,NULL),(24723,15949,'TE','4402827587',0,'2014-01-04 02:00:04',NULL,NULL),(8294,5435,'TE','2252704507',0,'2013-12-25 23:09:46',NULL,NULL),(22360,14421,'TE','2105356156',0,'2013-12-28 03:31:42',NULL,NULL),(14059,9190,'TE','4194227091',0,'2013-12-26 04:09:21',NULL,NULL),(9171,6003,'TE','5048852684',0,'2013-12-26 00:00:25',NULL,NULL),(5998,3853,'TE','3373133444',0,'2013-12-25 21:35:42',NULL,NULL),(38010,25075,'EM','mellyoung@aol.com',0,'2014-02-20 22:01:33',NULL,NULL),(1018,626,'EM','edwardfreeman743@yahoo.com',0,'2013-12-25 18:00:59',NULL,NULL),(8573,5637,'TE','8068936526',0,'2013-12-25 23:31:08',NULL,NULL),(33603,22035,'TE','4193816638',0,'2014-02-07 19:01:05',NULL,NULL),(30996,20164,'AP','3306719773',0,'2014-01-27 21:01:11',NULL,NULL),(28268,18226,'EM','ARGUTIERREZ11@GMAIL.COM',0,'2014-01-16 08:44:16',NULL,NULL),(27233,17531,'AP','6015739039',0,'2014-01-13 03:01:43',NULL,NULL),(26151,16837,'EM','andybabcock537@yahoo.com',0,'2014-01-13 02:18:31',NULL,NULL),(24021,15511,'EM','info@marksservice.com',1,'2014-01-02 04:30:00',NULL,NULL),(20590,13245,'TE','4696586482',0,'2013-12-26 12:56:14',NULL,NULL),(6007,3858,'AP','3184523990',0,'2013-12-25 21:35:51',NULL,NULL),(40668,27000,'TE','7402438766',0,'2014-03-03 21:00:01',NULL,NULL),(4973,3191,'TE','5125766068',0,'2013-12-25 20:32:10',NULL,NULL),(4776,3058,'AP','2253081233',0,'2013-12-25 20:19:04',NULL,NULL),(38015,25077,'AP','3307808940',0,'2014-02-20 22:01:35',NULL,NULL),(23663,15281,'TE','7409700854',1,'2014-01-02 04:22:07',NULL,NULL),(36380,23959,'EM','rob.rousey@icloud.com',0,'2014-02-15 22:00:08',NULL,NULL),(34779,22811,'AP','5135942240',0,'2014-02-11 21:01:57',NULL,NULL),(4756,3045,'AP','8067597878',0,'2013-12-25 20:18:45',NULL,NULL),(39162,25904,'TE','2546240995',0,'2014-02-26 21:01:10',NULL,NULL),(8814,5772,'TE','2164033049',0,'2013-12-25 23:46:49',NULL,NULL),(34518,22645,'TE','8328596352',0,'2014-02-11 21:00:24',NULL,NULL),(3672,2329,'EM','dcbarc@yahoo.com',0,'2013-12-25 19:31:39',NULL,NULL),(3332,2095,'EM','Judisullivan@woh.rr.com',0,'2013-12-25 19:17:01',NULL,NULL),(30984,20154,'AP','5137878576',0,'2014-01-27 21:01:06',NULL,NULL),(24291,15695,'AP','4193502409',1,'2014-01-02 04:35:31',NULL,NULL),(28809,18596,'TE','5137374514',0,'2014-01-16 08:47:16',NULL,NULL),(24614,15874,'AP','6017500876',0,'2014-01-03 02:05:11',NULL,NULL),(2818,1704,'TE','5134707751',0,'2013-12-25 18:54:50',NULL,NULL),(22250,14339,'EM','karon@watchtv.net',0,'2013-12-27 02:07:50',NULL,NULL),(40380,26804,'AP','6142123039',0,'2014-03-01 21:00:25',NULL,NULL),(26141,16828,'AP','2163965165',0,'2014-01-13 02:18:27',NULL,NULL),(39006,25794,'TE','7402749338',0,'2014-02-26 21:00:13',NULL,NULL),(36535,24053,'EM','MIZANNACALA@YAHOO.COM',0,'2014-02-15 22:01:06',NULL,NULL),(29772,19252,'TE','2252880881',0,'2014-01-21 08:46:44',NULL,NULL),(35473,23330,'TE','5133134900',0,'2014-02-13 22:00:30',NULL,NULL),(34386,22556,'TE','4402416892',0,'2014-02-10 21:31:48',NULL,NULL),(31234,20341,'AP','2162991254',0,'2014-01-28 21:01:08',NULL,NULL),(9081,5954,'TE','6017832151',0,'2013-12-25 23:51:10',NULL,NULL),(8720,5720,'EM','gguy@loyno.edu',0,'2013-12-25 23:45:24',NULL,NULL),(7173,4677,'TE','3374592811',0,'2013-12-25 22:07:46',NULL,NULL),(8094,5297,'AP','4192340550',0,'2013-12-25 23:06:13',NULL,NULL),(24150,15607,'TE','5135058189',1,'2014-01-02 04:32:43',NULL,NULL),(10251,6699,'EM','GI-KI@cinci.rr.com',0,'2013-12-26 01:01:52',NULL,NULL),(6268,4044,'TE','9377253352',0,'2013-12-25 21:46:11',NULL,NULL),(5165,3317,'TE','5137031154',0,'2013-12-25 21:15:58',NULL,NULL),(5099,3271,'EM','derbydpo@bellsouth.net',0,'2013-12-25 20:47:13',NULL,NULL),(14535,9495,'TE','4409851292',0,'2013-12-26 04:35:02',NULL,NULL),(20537,13220,'AP','7138051773',0,'2013-12-26 12:55:27',NULL,NULL),(22253,14340,'EM','my31byabbeymoore@yahoo.com',0,'2013-12-27 02:07:53',NULL,NULL),(21459,13791,'TE','6627195432',0,'2013-12-26 13:11:05',NULL,NULL),(26759,17215,'TE','6018493392',0,'2014-01-13 02:22:31',NULL,NULL),(28750,18553,'AP','2283552088',0,'2014-01-16 08:46:55',NULL,NULL),(22803,14703,'AP','5672883978',1,'2013-12-29 11:09:09',NULL,NULL),(21985,14162,'AP','3187899718',0,'2013-12-27 02:03:11',NULL,NULL),(14286,9345,'EM','kjay5555@aol.com',0,'2013-12-26 04:31:06',NULL,NULL),(806,500,'EM','keeney@kenyon.edu',0,'2013-12-25 17:48:41',NULL,NULL),(36798,24229,'TE','7576751585',0,'2014-02-16 19:00:33',NULL,NULL),(8333,5462,'EM','gracesgrooming@yahoo.com',0,'2013-12-25 23:10:28',NULL,NULL),(3241,2039,'EM','J.jernigan65@yahoo.com',0,'2013-12-25 19:15:33',NULL,NULL),(25303,16316,'TE','2138247128',0,'2014-01-07 04:01:35',NULL,NULL),(10931,7107,'AP','2145005790',0,'2013-12-26 01:50:55',NULL,NULL),(29043,18752,'AP','4193402364',0,'2014-01-17 03:35:44',NULL,NULL),(24652,15895,'TE','3303883862',0,'2014-01-03 02:05:53',NULL,NULL),(30193,19559,'TE','3183712576',0,'2014-01-23 03:02:32',NULL,NULL),(32730,21411,'AP','6143543615',0,'2014-02-04 21:01:08',NULL,NULL),(40218,26676,'TE','3188554840',0,'2014-02-28 21:31:21',NULL,NULL),(42110,27977,'AP','5043431770',0,'2014-03-06 21:00:54',NULL,NULL),(28136,18137,'AP','2254391967',0,'2014-01-15 02:07:45',NULL,NULL),(35736,23503,'BN','9032385220',0,'2014-02-13 22:02:09',NULL,NULL),(29298,18931,'AP','4407995758',0,'2014-01-20 08:05:38',NULL,NULL),(8113,5312,'TE','3304756609',0,'2013-12-25 23:06:36',NULL,NULL),(33122,21696,'TE','3307947240',0,'2014-02-05 21:31:08',NULL,NULL),(1266,769,'AP','9563289727',0,'2013-12-25 18:04:46',NULL,NULL),(1635,1003,'EM','morey.jackie@yahoo.com',0,'2013-12-25 18:11:01',NULL,NULL),(10644,6922,'TE','3308543332',0,'2013-12-26 01:46:14',NULL,NULL),(39040,25814,'EM','ktmiklos@sbcglobal.net',0,'2014-02-26 21:00:24',NULL,NULL),(40784,27105,'TE','5133829111',0,'2014-03-03 21:30:24',NULL,NULL),(10187,6657,'TE','2165019521',0,'2013-12-26 01:00:45',NULL,NULL),(36948,24333,'EM','lufborough1953@yahoo.com',0,'2014-02-18 22:00:15',NULL,NULL),(36663,24137,'TE','4194941874',0,'2014-02-15 22:01:50',NULL,NULL),(24319,15711,'TE','4406674647',1,'2014-01-02 04:36:03',NULL,NULL),(457,288,'TE','3255130271',0,'2013-12-25 17:30:28',NULL,NULL),(23074,14881,'TE','9567921703',0,'2013-12-30 00:00:32',NULL,NULL),(11099,7209,'TE','4409340333',0,'2013-12-26 02:00:53',NULL,NULL),(8917,5837,'TE','2546529761',0,'2013-12-25 23:48:27',NULL,NULL),(31076,20219,'TE','9379443295',0,'2014-01-27 21:01:43',NULL,NULL),(41810,27796,'TE','3308962994',0,'2014-03-05 21:31:43',NULL,NULL),(35545,23374,'TE','2167012020',0,'2014-02-13 22:00:56',NULL,NULL),(3093,1931,'AP','8322596610',0,'2013-12-25 19:00:24',NULL,NULL),(21244,13654,'AP','5047589779',0,'2013-12-26 13:07:25',NULL,NULL),(8084,5291,'AP','2057463319',0,'2013-12-25 23:06:03',NULL,NULL),(40251,26703,'AP','2163947785',0,'2014-02-28 21:31:34',NULL,NULL),(42849,28496,'AP','6019429938',0,'2014-03-07 21:31:45',NULL,NULL),(26017,16762,'TE','3309287367',0,'2014-01-08 18:24:59',NULL,NULL),(35961,23657,'TE','4966821508',0,'2014-02-14 21:30:18',NULL,NULL),(32355,21141,'AP','5127043382',0,'2014-02-03 21:00:22',NULL,NULL),(30399,19700,'TE','9155924939',0,'2014-01-23 21:00:47',NULL,NULL),(2046,1268,'TE','2103070664',0,'2013-12-25 18:30:10',NULL,NULL),(10118,6616,'EM','dewiec419@aol.com',0,'2013-12-26 00:53:53',NULL,NULL),(37417,24641,'AP','3372968586',0,'2014-02-20 04:20:25',NULL,NULL),(8128,5322,'TE','5137204727',0,'2013-12-25 23:06:51',NULL,NULL),(6659,4322,'TE','2164868546',0,'2013-12-25 21:52:47',NULL,NULL),(40464,26861,'TE','8174800389',0,'2014-03-01 21:00:56',NULL,NULL),(43339,28788,'AP','4193403963',0,'2014-03-09 21:00:40',NULL,NULL),(4165,2656,'TE','8172661965',0,'2013-12-25 19:46:46',NULL,NULL),(37627,24799,'AP','7403363602',0,'2014-02-20 04:47:58',NULL,NULL),(36444,23998,'EM','DEBORAHKINKLE@YMAIL.COM',0,'2014-02-15 22:00:31',NULL,NULL),(22879,14761,'TE','2147357939',1,'2013-12-29 11:12:42',NULL,NULL),(35277,23167,'AP','4692378685',0,'2014-02-12 21:31:51',NULL,NULL),(13528,8820,'EM','wyatt_a2ez@hotmail.com',0,'2013-12-26 04:00:15',NULL,NULL),(10528,6856,'AP','7409702043',0,'2013-12-26 01:31:33',NULL,NULL),(10778,7007,'TE','9036949629',0,'2013-12-26 01:48:25',NULL,NULL),(29981,19404,'TE','4194241182',1,'2014-01-22 03:22:54',NULL,NULL),(27855,17944,'EM','Vicsautotech@aol.com',0,'2014-01-15 02:06:41',NULL,NULL),(38444,25406,'EM','desirae_taylor@hotmail.com',0,'2014-02-25 21:31:00',NULL,NULL),(39181,25915,'AP','9402070998',0,'2014-02-26 21:01:17',NULL,NULL),(42883,28519,'TE','9373650250',0,'2014-03-07 21:31:59',NULL,NULL),(1522,937,'EM','drwillbashor@gmail.com',0,'2013-12-25 18:09:14',NULL,NULL),(3155,1970,'AP','8176816774',0,'2013-12-25 19:01:28',NULL,NULL),(7802,5092,'TE','2104639846',0,'2013-12-25 23:01:15',NULL,NULL),(6207,3999,'AP','4194814224',0,'2013-12-25 21:45:09',NULL,NULL),(11630,7566,'AP','4192031733',0,'2013-12-26 02:33:38',NULL,NULL),(43845,29098,'AP','5138509669',0,'2014-03-10 21:02:15',NULL,NULL),(9812,6420,'AP','9858595542',0,'2013-12-26 00:48:53',NULL,NULL),(37966,25049,'AP','9373607772',0,'2014-02-20 22:01:16',NULL,NULL),(24188,15627,'TE','5049065612',1,'2014-01-02 04:33:22',NULL,NULL),(36496,24029,'TE','4193085329',0,'2014-02-15 22:00:52',NULL,NULL),(12451,8154,'EM','lcmg1951@gmail.com',0,'2013-12-26 03:16:09',NULL,NULL),(27404,17647,'TE','4192509227',0,'2014-01-14 01:32:39',NULL,NULL),(27657,17828,'EM','Loinguyen0012@yahoo.com',0,'2014-01-15 02:05:59',NULL,NULL),(40789,27110,'TE','6304869775',0,'2014-03-03 21:30:25',NULL,NULL),(40924,27195,'TE','3257634936',0,'2014-03-03 21:31:18',NULL,NULL),(43008,28600,'EM','dkolesar94@gmail.com',0,'2014-03-08 21:30:08',NULL,NULL),(35423,23287,'TE','7405868443',0,'2014-02-13 22:00:04',NULL,NULL),(38026,25082,'EM','kissinfrogsagain@yahoo.com',0,'2014-02-20 22:01:39',NULL,NULL),(37080,24414,'TE','7407682632',0,'2014-02-18 22:01:03',NULL,NULL),(9828,6430,'TE','3183411982',0,'2013-12-26 00:49:09',NULL,NULL),(4603,2938,'AP','5137202257',0,'2013-12-25 20:16:09',NULL,NULL),(8985,5893,'TE','7406255531',0,'2013-12-25 23:49:40',NULL,NULL),(38905,25718,'TE','9035173880',0,'2014-02-26 09:30:26',NULL,NULL),(27391,17632,'TE','2147939519',0,'2014-01-14 01:32:33',NULL,NULL),(27867,17956,'TE','7134501158',0,'2014-01-15 02:06:44',NULL,NULL),(29951,19382,'AP','5126745889',1,'2014-01-22 03:22:42',NULL,NULL),(20547,13226,'TE','5122498863',0,'2013-12-26 12:55:37',NULL,NULL),(30566,19833,'TE','3256601966',0,'2014-01-24 21:00:20',NULL,NULL),(20898,13437,'AP','5135453653',0,'2013-12-26 13:01:13',NULL,NULL),(1271,773,'AP','8176903277',0,'2013-12-25 18:04:53',NULL,NULL),(24109,15563,'TE','2169906709',1,'2014-01-02 04:31:40',NULL,NULL),(41610,27664,'AP','9376540441',0,'2014-03-05 21:30:29',NULL,NULL),(177,105,'EM','dsmtech@tx.rr.com',0,'2013-12-25 17:17:49',NULL,NULL),(14721,9630,'EM','appyheart1@yahoo.com',0,'2013-12-26 04:38:11',NULL,NULL),(6161,3970,'AP','5136282675',0,'2013-12-25 21:38:33',NULL,NULL),(11879,7731,'EM','liplin@aol.com',0,'2013-12-26 03:02:01',NULL,NULL),(4129,2632,'EM','mary_wood@outlook.com',0,'2013-12-25 19:46:10',NULL,NULL),(626,383,'EM','jgalvanz7@broncs.utpa.edu',0,'2013-12-25 17:45:47',NULL,NULL),(23559,15205,'AP','6013840688',0,'2014-01-01 12:07:33',NULL,NULL),(30083,19489,'AP','5052154172',0,'2014-01-23 03:02:06',NULL,NULL),(32042,20915,'TE','3305738503',0,'2014-01-31 21:01:30',NULL,NULL),(30782,20013,'AP','9157275113',0,'2014-01-26 19:00:11',NULL,NULL),(6403,4132,'TE','5133328450',0,'2013-12-25 21:48:25',NULL,NULL),(11641,7573,'AP','2169780364',0,'2013-12-26 02:33:47',NULL,NULL),(3341,2102,'TE','5133169033',0,'2013-12-25 19:17:11',NULL,NULL),(5499,3516,'AP','2282238943',0,'2013-12-25 21:21:09',NULL,NULL),(43285,28758,'TE','9795873204',0,'2014-03-09 21:00:21',NULL,NULL),(43991,29185,'TE','3303381185',0,'2014-03-10 21:30:01',NULL,NULL),(28158,18150,'TE','5044939862',0,'2014-01-15 02:07:50',NULL,NULL),(398,243,'EM','j.tippie@hotmail.com',0,'2013-12-25 17:21:23',NULL,NULL),(30922,20108,'TE','5044915048',0,'2014-01-27 21:00:39',NULL,NULL),(12400,8120,'EM','bestnumberonemom@yahoo.com',0,'2013-12-26 03:15:15',NULL,NULL),(2486,1525,'EM','xinalfred@hotmail.com',0,'2013-12-25 18:49:53',NULL,NULL),(2604,1587,'TE','9158514059',0,'2013-12-25 18:51:38',NULL,NULL),(3674,2330,'AP','4327419512',0,'2013-12-25 19:31:40',NULL,NULL),(5516,3529,'TE','8177268450',0,'2013-12-25 21:21:28',NULL,NULL),(24850,16028,'TE','5043392493',0,'2014-01-04 02:02:23',NULL,NULL),(5865,3763,'AP','3308150052',0,'2013-12-25 21:33:29',NULL,NULL),(37078,24413,'TE','5133210167',0,'2014-02-18 22:01:03',NULL,NULL),(27326,17597,'AP','6019469870',0,'2014-01-14 01:32:14',NULL,NULL),(34036,22320,'AP','2253237226',0,'2014-02-10 11:00:53',NULL,NULL),(32737,21417,'AP','4195143981',0,'2014-02-04 21:01:11',NULL,NULL),(2433,1491,'AP','3302407888',0,'2013-12-25 18:49:02',NULL,NULL),(3892,2472,'AP','3372581969',0,'2013-12-25 19:35:16',NULL,NULL),(31371,20447,'TE','2144998883',0,'2014-01-29 21:00:43',NULL,NULL),(25103,16184,'TE','2816900189',0,'2014-01-05 00:00:38',NULL,NULL),(37936,25030,'EM','jayskillzthedj@gmail.com',0,'2014-02-20 22:01:03',NULL,NULL),(23136,14916,'TE','2162659034',0,'2013-12-30 00:01:33',NULL,NULL),(20758,13340,'AP','2814987380',0,'2013-12-26 12:58:53',NULL,NULL),(30863,20060,'AP','2143922898',0,'2014-01-27 21:00:11',NULL,NULL),(11567,7526,'TE','7136351448',0,'2013-12-26 02:32:34',NULL,NULL),(43753,29047,'TE','5133094632',0,'2014-03-10 21:01:43',NULL,NULL),(26143,16829,'TE','7407760665',0,'2014-01-13 02:18:27',NULL,NULL),(28591,18430,'EM','emily.price824@gmail.com',0,'2014-01-16 08:45:58',NULL,NULL),(34232,22454,'TE','3615717959',0,'2014-02-10 21:30:48',NULL,NULL),(36326,23924,'AP','3306125560',0,'2014-02-14 22:00:08',NULL,NULL),(3663,2326,'TE','5596965201',0,'2013-12-25 19:31:32',NULL,NULL),(24042,15524,'EM','jjr_626@yahoo.com',1,'2014-01-02 04:30:25',NULL,NULL),(3175,1991,'AP','8176816774',0,'2013-12-25 19:01:58',NULL,NULL),(21987,14163,'TE','5049136270',0,'2013-12-27 02:03:13',NULL,NULL),(2062,1276,'EM','Outbreak2005@gmail.com',0,'2013-12-25 18:30:26',NULL,NULL),(10538,6863,'TE','3305444983',0,'2013-12-26 01:31:43',NULL,NULL),(14057,9186,'AP','4197331988',0,'2013-12-26 04:09:19',NULL,NULL),(42390,28153,'AP','4193884071',0,'2014-03-06 21:02:38',NULL,NULL),(27163,17488,'TE','8305132580',0,'2014-01-13 03:01:18',NULL,NULL),(22892,14771,'AP','2148085198',1,'2013-12-29 11:12:56',NULL,NULL),(37147,24453,'AP','6014560879',0,'2014-02-18 22:01:28',NULL,NULL),(34466,22614,'EM','vabigail34@yahoo.com',0,'2014-02-11 21:00:07',NULL,NULL),(22224,14325,'AP','3305917870',0,'2013-12-27 02:07:22',NULL,NULL),(27124,17462,'AP','5677129151',0,'2014-01-13 03:00:43',NULL,NULL),(8240,5390,'AP','9857788582',0,'2013-12-25 23:08:39',NULL,NULL),(6929,4514,'TE','9563135220',0,'2013-12-25 22:03:41',NULL,NULL),(21108,13569,'EM','jrwagnon16@gmail.com',0,'2013-12-26 13:04:38',NULL,NULL),(42048,27943,'AP','8309652463',0,'2014-03-06 21:00:33',NULL,NULL),(42817,28477,'TE','3303076162',0,'2014-03-07 21:31:34',NULL,NULL),(41623,27669,'EM','wendy2lalogarza@yahoo.com',0,'2014-03-05 21:30:33',NULL,NULL),(42123,27983,'EM','kmdejean@suddenlink.net',0,'2014-03-06 21:00:58',NULL,NULL),(42260,28068,'AP','5676744078',0,'2014-03-06 21:01:48',NULL,NULL),(31357,20436,'TE','3304109225',0,'2014-01-29 21:00:38',NULL,NULL),(2180,1340,'TE','6143294295',0,'2013-12-25 18:32:25',NULL,NULL),(4422,2819,'TE','6623392544',0,'2013-12-25 20:00:27',NULL,NULL),(1795,1113,'TE','7408289214',0,'2013-12-25 18:17:34',NULL,NULL),(8838,5786,'TE','4193354363',0,'2013-12-25 23:47:12',NULL,NULL),(43768,29055,'TE','6149897753',0,'2014-03-10 21:01:48',NULL,NULL),(4788,3063,'AP','2257763352',0,'2013-12-25 20:19:14',NULL,NULL),(39370,26039,'TE','3308085517',0,'2014-02-26 21:02:26',NULL,NULL),(9232,6044,'TE','3302422474',0,'2013-12-26 00:01:29',NULL,NULL),(33654,22072,'TE','9039230207',0,'2014-02-08 19:00:15',NULL,NULL),(4061,2591,'EM','jtoth10570@msn.com',0,'2013-12-25 19:45:06',NULL,NULL),(3330,2093,'AP','3375153050',0,'2013-12-25 19:16:57',NULL,NULL),(40666,26998,'EM','cmb5775@aol.com',0,'2014-03-03 21:00:00',NULL,NULL),(43642,28968,'TE','3376543928',0,'2014-03-10 21:01:01',NULL,NULL),(9958,6516,'TE','4193714874',0,'2013-12-26 00:51:17',NULL,NULL),(38793,25649,'TE','9372180946',0,'2014-02-26 08:30:37',NULL,NULL),(9629,6301,'AP','9378434539',0,'2013-12-26 00:45:55',NULL,NULL),(34109,22360,'AP','2034177090',0,'2014-02-10 21:00:07',NULL,NULL),(8891,5824,'TE','9722306142',0,'2013-12-25 23:48:05',NULL,NULL),(8823,5778,'AP','5135027363',0,'2013-12-25 23:46:58',NULL,NULL),(25363,16356,'EM','timbo2324@gmail.com',0,'2014-01-07 04:02:38',NULL,NULL),(23723,15308,'AP','3186234214',1,'2014-01-02 04:23:06',NULL,NULL),(23681,15290,'AP','3186521158',1,'2014-01-02 04:22:26',NULL,NULL),(12229,7994,'EM','kwn8251@gmail.com',0,'2013-12-26 03:08:13',NULL,NULL),(21748,14008,'EM','melissaboitnott@yahoo.com',0,'2013-12-26 13:16:18',NULL,NULL),(208,127,'TE','6622849654',0,'2013-12-25 17:18:21',NULL,NULL),(36110,23761,'TE','5134671772',0,'2014-02-14 21:31:10',NULL,NULL),(33690,22098,'AP','9374325869',0,'2014-02-08 19:00:28',NULL,NULL),(33177,21726,'BN','9797320940',0,'2014-02-06 21:00:07',NULL,NULL),(10062,6579,'AP','9377980383',0,'2013-12-26 00:52:55',NULL,NULL),(12009,7823,'AP','2148616773',0,'2013-12-26 03:04:15',NULL,NULL),(31593,20610,'TE','2162526640',0,'2014-01-30 21:00:17',NULL,NULL),(22436,14470,'TE','2073129012',0,'2013-12-28 03:33:00',NULL,NULL),(12,8,'TE','4408978449',0,'2013-12-25 17:15:14',NULL,NULL),(2852,1737,'TE','4402794466',0,'2013-12-25 18:55:28',NULL,NULL),(5504,3521,'EM','optictron@hotmail.com',0,'2013-12-25 21:21:16',NULL,NULL),(4554,2898,'AP','3303522477',0,'2013-12-25 20:15:17',NULL,NULL),(14073,9199,'EM','rcbiggert@yahoo.com',0,'2013-12-26 04:09:37',NULL,NULL),(28625,18454,'EM','mgaille@yahoo.com',0,'2014-01-16 08:46:09',NULL,NULL),(27095,17426,'EM','sonal_pakvasa@msn.com',0,'2014-01-13 03:00:29',NULL,NULL),(20624,13268,'EM','Jamesperez563@yahoo.com',0,'2013-12-26 12:56:49',NULL,NULL),(22247,14337,'TE','9372892360',0,'2013-12-27 02:07:46',NULL,NULL),(21149,13599,'TE','4194952686',0,'2013-12-26 13:05:23',NULL,NULL),(41436,27526,'AP','4192801129',0,'2014-03-04 21:02:44',NULL,NULL),(43671,28982,'EM','jpr2500@windstream.net',0,'2014-03-10 21:01:10',NULL,NULL),(10504,6841,'TE','5042588697',0,'2013-12-26 01:31:06',NULL,NULL),(34463,22613,'TE','2143716963',0,'2014-02-11 21:00:06',NULL,NULL),(34041,22322,'AP','3184172761',0,'2014-02-10 11:00:54',NULL,NULL),(8659,5688,'TE','4403828256',0,'2013-12-25 23:32:31',NULL,NULL),(30520,19797,'AP','6016721021',0,'2014-01-23 21:01:46',NULL,NULL),(27921,17989,'EM','embardes@gmail.com',0,'2014-01-15 02:06:56',NULL,NULL),(24756,15973,'TE','8065442146',0,'2014-01-04 02:00:40',NULL,NULL),(26578,17099,'TE','4098931682',0,'2014-01-13 02:21:31',NULL,NULL),(5514,3528,'AP','4325538325',0,'2013-12-25 21:21:26',NULL,NULL),(3720,2360,'TE','2162818905',0,'2013-12-25 19:32:28',NULL,NULL),(28947,18686,'EM','dannel07@gmail.com',0,'2014-01-17 03:35:23',NULL,NULL),(27300,17579,'TE','5133426059',0,'2014-01-14 01:32:05',NULL,NULL),(24536,15824,'EM','ohiomystery@gmail.com',0,'2014-01-03 02:03:39',NULL,NULL),(22958,14809,'AP','3373261668',1,'2013-12-29 11:14:00',NULL,NULL),(23019,14849,'TE','5135226004',1,'2013-12-29 11:15:03',NULL,NULL),(12223,7988,'TE','3308546853',0,'2013-12-26 03:08:07',NULL,NULL),(39228,25948,'AP','4409542680',0,'2014-02-26 21:01:35',NULL,NULL),(10793,7015,'EM','ali.ashton@yahoo.com',0,'2013-12-26 01:48:39',NULL,NULL),(7675,4997,'EM','kontosharry@yahoo.com',0,'2013-12-25 22:47:05',NULL,NULL),(6992,4567,'TE','5129407298',0,'2013-12-25 22:04:52',NULL,NULL),(23102,14896,'TE','3185358104',0,'2013-12-30 00:00:58',NULL,NULL),(41171,27343,'EM','dmi1604841@aol.com',0,'2014-03-04 21:01:00',NULL,NULL),(5322,3411,'AP','9852853885',0,'2013-12-25 21:18:24',NULL,NULL),(4569,2915,'AP','5135919599',0,'2013-12-25 20:15:38',NULL,NULL),(38483,25431,'AP','3616331711',0,'2014-02-25 21:31:15',NULL,NULL),(9526,6235,'AP','9035886056',0,'2013-12-26 00:31:34',NULL,NULL),(29245,18890,'TE','3307947155',0,'2014-01-17 03:36:32',NULL,NULL),(29097,18791,'TE','3304100580',0,'2014-01-17 03:35:56',NULL,NULL),(22840,14735,'EM','knorris5@cinci.rr.com',1,'2013-12-29 11:09:53',NULL,NULL),(24128,15576,'TE','3304165910',1,'2014-01-02 04:32:01',NULL,NULL),(40171,26642,'AP','2166738118',0,'2014-02-28 21:31:04',NULL,NULL),(40594,26947,'AP','9374225687',0,'2014-03-03 01:00:25',NULL,NULL),(6261,4041,'TE','3306555310',0,'2013-12-25 21:46:06',NULL,NULL),(833,517,'AP','6142049848',0,'2013-12-25 17:49:07',NULL,NULL),(37849,24971,'TE','9795783242',0,'2014-02-20 22:00:27',NULL,NULL),(2410,1468,'EM','ggivens80@gmail.com',0,'2013-12-25 18:48:30',NULL,NULL),(32231,21051,'EM','shilton1@roadrunner.com',0,'2014-02-02 19:00:06',NULL,NULL),(30400,19700,'EM','misfit12_36@hotmail.com',0,'2014-01-23 21:00:47',NULL,NULL),(6044,3882,'TE','5048958866',0,'2013-12-25 21:36:29',NULL,NULL),(29238,18887,'TE','3304100580',0,'2014-01-17 03:36:30',NULL,NULL),(21004,13514,'AP','7145829236',0,'2013-12-26 13:03:01',NULL,NULL),(25910,16698,'TE','9567569968',0,'2014-01-08 18:24:37',NULL,NULL),(26758,17213,'TE','3303361325',0,'2014-01-13 02:22:30',NULL,NULL),(10922,7101,'AP','5136283723',0,'2013-12-26 01:50:46',NULL,NULL),(14675,9601,'EM','CMANTEGHI@AOL.COM',0,'2013-12-26 04:37:25',NULL,NULL),(14492,9467,'TE','6148771130',0,'2013-12-26 04:34:21',NULL,NULL),(10245,6697,'AP','3305711389',0,'2013-12-26 01:01:47',NULL,NULL),(38069,25129,'EM','kathymasters@bex.net',0,'2014-02-21 21:30:25',NULL,NULL),(40195,26663,'TE','5042185557',0,'2014-02-28 21:31:13',NULL,NULL),(8707,5713,'TE','3305643107',0,'2013-12-25 23:45:13',NULL,NULL),(27912,17985,'TE','3309577352',0,'2014-01-15 02:06:54',NULL,NULL),(35900,23617,'EM','alspoerr@frontier.com',0,'2014-02-13 22:03:16',NULL,NULL),(34399,22565,'TE','3309060413',0,'2014-02-10 21:31:53',NULL,NULL),(33111,21690,'AP','5042013231',0,'2014-02-05 21:31:06',NULL,NULL),(33754,22150,'TE','3305362242',0,'2014-02-08 19:00:53',NULL,NULL),(11896,7739,'EM','lorilitvin@yahoo.com',0,'2013-12-26 03:02:15',NULL,NULL),(20323,13095,'EM','albertam@roadrunner.com',0,'2013-12-26 12:52:00',NULL,NULL),(39461,26095,'EM','NIPPERPOM@YAHOO.COM',0,'2014-02-28 06:30:10',NULL,NULL),(32947,21570,'AP','3307856060',0,'2014-02-05 21:30:21',NULL,NULL),(3567,2233,'AP','5133759232',0,'2013-12-25 19:20:51',NULL,NULL),(43178,28693,'AP','3184228606',0,'2014-03-08 21:31:04',NULL,NULL),(28968,18697,'AP','3183310077',0,'2014-01-17 03:35:27',NULL,NULL),(37270,24523,'AP','9792192926',0,'2014-02-20 03:58:28',NULL,NULL),(32608,21321,'TE','3188161346',0,'2014-02-04 21:00:23',NULL,NULL),(35767,23522,'AP','9544941310',0,'2014-02-13 22:02:21',NULL,NULL),(35574,23393,'AP','3309409778',0,'2014-02-13 22:01:07',NULL,NULL),(4904,3149,'EM','lesterrode987@outlook.com',0,'2013-12-25 20:30:59',NULL,NULL),(3561,2229,'TE','5132480704',0,'2013-12-25 19:20:45',NULL,NULL),(9680,6343,'TE','7403355299',0,'2013-12-26 00:46:49',NULL,NULL),(8648,5682,'TE','4199176602',0,'2013-12-25 23:32:21',NULL,NULL),(10637,6919,'TE','6144040315',0,'2013-12-26 01:46:09',NULL,NULL),(38157,25184,'AP','5135784368',0,'2014-02-21 22:00:36',NULL,NULL),(1687,1036,'TE','9152527049',0,'2013-12-25 18:15:40',NULL,NULL),(9608,6289,'TE','2164409000',0,'2013-12-26 00:45:36',NULL,NULL),(2385,1450,'EM','chuckdebault@gmail.com',0,'2013-12-25 18:48:06',NULL,NULL),(33827,22209,'EM','tdirish2@yahoo.com',0,'2014-02-09 19:00:19',NULL,NULL),(11489,7473,'TE','5136047094',0,'2013-12-26 02:31:13',NULL,NULL),(32659,21360,'TE','5047150668',0,'2014-02-04 21:00:43',NULL,NULL),(26818,17248,'TE','4408557044',0,'2014-01-13 02:23:10',NULL,NULL),(31263,20367,'TE','5036896262',0,'2014-01-29 21:00:03',NULL,NULL),(38185,25202,'EM','ROBNY5@NETZERO.NET',0,'2014-02-21 22:00:47',NULL,NULL),(38307,25298,'TE','4409791550',0,'2014-02-25 21:00:27',NULL,NULL),(38938,25743,'AP','5132938757',0,'2014-02-26 09:30:41',NULL,NULL),(39932,26425,'TE','5122756683',0,'2014-02-28 07:30:11',NULL,NULL),(26645,17142,'TE','5043499173',0,'2014-01-13 02:21:53',NULL,NULL),(1869,1153,'EM','j_music18@yahoo.com',0,'2013-12-25 18:18:42',NULL,NULL),(10716,6969,'TE','5134295642',0,'2013-12-26 01:47:25',NULL,NULL),(35153,23089,'AP','6142668751',0,'2014-02-12 21:31:06',NULL,NULL),(37841,24966,'TE','9363966767',0,'2014-02-20 22:00:23',NULL,NULL),(24909,16055,'TE','4405482930',0,'2014-01-04 02:03:22',NULL,NULL),(8157,5338,'EM','tenola.oliver@yahoo.com',0,'2013-12-25 23:07:18',NULL,NULL),(39934,26427,'TE','9365900729',0,'2014-02-28 07:30:13',NULL,NULL),(41035,27264,'TE','2259168278',0,'2014-03-04 21:00:11',NULL,NULL),(23205,14954,'TE','8303532201',0,'2014-01-01 12:00:18',NULL,NULL),(2482,1524,'TE','2169044153',0,'2013-12-25 18:49:50',NULL,NULL),(14944,9776,'TE','5139074511',0,'2013-12-26 05:00:37',NULL,NULL),(12010,7823,'EM','KATRD350@GMAIL.COM',0,'2013-12-26 03:04:15',NULL,NULL),(33034,21642,'AP','2543175363',0,'2014-02-05 21:30:46',NULL,NULL),(37070,24409,'AP','5132597731',0,'2014-02-18 22:01:00',NULL,NULL),(3186,2002,'TE','4196085002',0,'2013-12-25 19:02:14',NULL,NULL),(36715,24174,'TE','5672882025',0,'2014-02-15 22:02:11',NULL,NULL),(26902,17308,'TE','8327297272',0,'2014-01-13 02:23:42',NULL,NULL),(30019,19441,'EM','mikemay44@hotmail.com',1,'2014-01-22 03:23:13',NULL,NULL),(20369,13120,'EM','sirjamed@fuse.net',0,'2013-12-26 12:52:44',NULL,NULL),(30778,20008,'TE','4402377867',0,'2014-01-26 19:00:08',NULL,NULL),(5305,3400,'EM','caebja3@bellsouth.net',0,'2013-12-25 21:18:07',NULL,NULL),(37245,24508,'AP','8328837945',0,'2014-02-20 03:52:23',NULL,NULL),(8660,5688,'AP','4403828256',0,'2013-12-25 23:32:31',NULL,NULL),(38119,25160,'AP','9562626622',0,'2014-02-21 22:00:22',NULL,NULL),(38949,25750,'AP','6142561765',0,'2014-02-26 09:30:45',NULL,NULL),(39661,26225,'AP','5125797320',0,'2014-02-28 06:30:59',NULL,NULL),(41415,27515,'AP','2166826724',0,'2014-03-04 21:02:36',NULL,NULL),(35942,23648,'TE','8068935935',0,'2014-02-14 21:30:13',NULL,NULL),(9318,6101,'TE','5134883944',0,'2013-12-26 00:15:13',NULL,NULL),(39235,25952,'AP','7406414551',0,'2014-02-26 21:01:37',NULL,NULL),(30790,20019,'TE','4324488151',0,'2014-01-26 19:00:14',NULL,NULL),(36054,23716,'TE','9377517770',0,'2014-02-14 21:30:49',NULL,NULL),(30820,20038,'AP','5133931680',0,'2014-01-26 19:00:24',NULL,NULL),(32802,21461,'TE','3309907247',0,'2014-02-04 21:01:34',NULL,NULL),(3370,2116,'TE','5137773368',0,'2013-12-25 19:17:36',NULL,NULL),(25007,16115,'TE','3375911777',0,'2014-01-04 02:05:15',NULL,NULL),(13681,8917,'EM','nturner40@att.net',0,'2013-12-26 04:02:44',NULL,NULL),(26467,17035,'AP','3189188811',0,'2014-01-13 02:20:47',NULL,NULL),(185,110,'TE','9037922170',0,'2013-12-25 17:17:57',NULL,NULL),(14646,9581,'AP','6148435979',0,'2013-12-26 04:36:54',NULL,NULL),(9437,6177,'TE','9374425707',0,'2013-12-26 00:17:14',NULL,NULL),(9611,6291,'TE','9372764094',0,'2013-12-26 00:45:39',NULL,NULL),(38366,25341,'EM','lisascurley@gmail.com',0,'2014-02-25 21:30:25',NULL,NULL),(39979,26470,'TE','2259935948',0,'2014-02-28 07:30:37',NULL,NULL),(42678,28389,'AP','3302129507',0,'2014-03-07 21:30:44',NULL,NULL),(3337,2099,'EM','Judisullivan@woh.rr.com',0,'2013-12-25 19:17:07',NULL,NULL),(10293,6718,'EM','rkludwig49@gmail.com',0,'2013-12-26 01:15:07',NULL,NULL),(37028,24378,'AP','5135820663',0,'2014-02-18 22:00:43',NULL,NULL),(8596,5650,'TE','4073264394',0,'2013-12-25 23:31:28',NULL,NULL),(5596,3583,'TE','5133142843',0,'2013-12-25 21:22:47',NULL,NULL),(30154,19537,'AP','5676941928',0,'2014-01-23 03:02:23',NULL,NULL),(1808,1118,'AP','6627217043',0,'2013-12-25 18:17:44',NULL,NULL),(41573,27641,'TE','9372696309',0,'2014-03-05 21:30:16',NULL,NULL),(12383,8111,'TE','5132275130',0,'2013-12-26 03:11:06',NULL,NULL),(2089,1290,'AP','6142618419',0,'2013-12-25 18:30:51',NULL,NULL),(29018,18735,'TE','7404072590',0,'2014-01-17 03:35:38',NULL,NULL),(30255,19596,'AP','2162996205',0,'2014-01-23 03:02:46',NULL,NULL),(6661,4324,'TE','9374984926',0,'2013-12-25 21:52:51',NULL,NULL),(7190,4684,'EM','BRIDGES1213522@YAHOO.COM',0,'2013-12-25 22:07:59',NULL,NULL),(31074,20217,'TE','9375493640',0,'2014-01-27 21:01:42',NULL,NULL),(31928,20841,'EM','joe723@usip.net',0,'2014-01-31 21:00:47',NULL,NULL),(49,31,'TE','3307859588',0,'2013-12-25 17:15:49',NULL,NULL),(33068,21659,'AP','3183410175',0,'2014-02-05 21:30:54',NULL,NULL),(40560,26924,'TE','7078798242',0,'2014-03-03 01:00:16',NULL,NULL),(41971,27900,'AP','9373718806',0,'2014-03-05 21:32:45',NULL,NULL),(42881,28518,'TE','9372054310',0,'2014-03-07 21:31:58',NULL,NULL),(26311,16940,'EM','andyjohnson1967@gmail.com',0,'2014-01-13 02:19:53',NULL,NULL),(25258,16286,'TE','8598932180',0,'2014-01-07 04:00:41',NULL,NULL),(34292,22499,'AP','9376683050',0,'2014-02-10 21:31:12',NULL,NULL),(30727,19963,'AP','3306032370',0,'2014-01-25 19:00:08',NULL,NULL),(27924,17990,'EM','Jamieforsch1@gmail.com',0,'2014-01-15 02:06:57',NULL,NULL),(2064,1277,'AP','6143064339',0,'2013-12-25 18:30:27',NULL,NULL),(23963,15464,'TE','9374318874',1,'2014-01-02 04:28:46',NULL,NULL),(13856,9034,'TE','3302010665',0,'2013-12-26 04:05:40',NULL,NULL),(42345,28122,'TE','4198411863',0,'2014-03-06 21:02:21',NULL,NULL),(42457,28204,'AP','9493717506',0,'2014-03-06 21:30:11',NULL,NULL),(33402,21886,'EM','robjac71@hotmail.com',0,'2014-02-06 21:01:34',NULL,NULL),(25759,16599,'TE','2258107760',0,'2014-01-08 18:24:04',NULL,NULL),(20794,13363,'AP','2162873083',0,'2013-12-26 12:59:32',NULL,NULL),(21672,13953,'TE','5133654866',0,'2013-12-26 13:14:58',NULL,NULL),(11920,7759,'AP','5136592966',0,'2013-12-26 03:02:43',NULL,NULL),(26678,17162,'TE','5042310043',0,'2014-01-13 02:22:03',NULL,NULL),(23004,14837,'AP','5132640033',1,'2013-12-29 11:14:45',NULL,NULL),(26912,17311,'AP','8302630749',0,'2014-01-13 02:23:45',NULL,NULL),(39105,25871,'TE','3374000189',0,'2014-02-26 21:00:51',NULL,NULL),(40177,26648,'TE','3307056517',0,'2014-02-28 21:31:06',NULL,NULL),(43006,28600,'TE','4407732590',0,'2014-03-08 21:30:08',NULL,NULL),(6998,4569,'EM','nkatlynn45@yahoo.com',0,'2013-12-25 22:04:56',NULL,NULL),(37811,24952,'AP','5042348970',0,'2014-02-20 22:00:12',NULL,NULL),(22403,14447,'EM','GAILMD47@GMAIL.COM',0,'2013-12-28 03:32:24',NULL,NULL),(33422,21895,'EM','gafont@msn.com',0,'2014-02-06 21:01:42',NULL,NULL),(7515,4897,'AP','5137041770',0,'2013-12-25 22:31:44',NULL,NULL),(28925,18674,'EM','RCORDOVA2@YAHOO.COM',0,'2014-01-17 03:35:18',NULL,NULL),(40227,26684,'TE','5043431590',0,'2014-02-28 21:31:24',NULL,NULL),(42152,28003,'BN','3302174133',0,'2014-03-06 21:01:10',NULL,NULL),(26204,16865,'EM','TXMEXC@GMAIL.COM',0,'2014-01-13 02:19:13',NULL,NULL),(38523,25458,'TE','2815127772',0,'2014-02-25 21:31:29',NULL,NULL),(8619,5662,'AP','6143021666',0,'2013-12-25 23:31:49',NULL,NULL),(14062,9191,'EM','j.alan.payne@gmail.com',0,'2013-12-26 04:09:24',NULL,NULL),(2708,1644,'EM','gfharris12@yahoo.com',0,'2013-12-25 18:53:11',NULL,NULL),(20637,13275,'TE','9035621450',0,'2013-12-26 12:57:01',NULL,NULL),(2919,1789,'AP','5755209679',0,'2013-12-25 18:56:33',NULL,NULL),(334,209,'AP','2258068466',0,'2013-12-25 17:20:25',NULL,NULL),(7634,4972,'AP','8327218219',0,'2013-12-25 22:46:29',NULL,NULL),(7271,4739,'TE','7633704190',0,'2013-12-25 22:09:24',NULL,NULL),(24281,15691,'TE','3302083289',1,'2014-01-02 04:35:22',NULL,NULL),(23926,15437,'TE','8063380398',1,'2014-01-02 04:27:57',NULL,NULL),(6444,4163,'AP','5134460522',0,'2013-12-25 21:49:02',NULL,NULL),(105,62,'EM','jenniferroberts@horizonview.net',0,'2013-12-25 17:16:41',NULL,NULL),(24942,16078,'AP','2163245251',0,'2014-01-04 02:04:01',NULL,NULL),(24876,16040,'AP','4697663216',0,'2014-01-04 02:02:49',NULL,NULL),(24087,15550,'TE','2256360940',1,'2014-01-02 04:31:15',NULL,NULL),(30325,19644,'EM','MINAMYER@AOL.COM',0,'2014-01-23 21:00:17',NULL,NULL),(5045,3238,'TE','9727410985',0,'2013-12-25 20:46:15',NULL,NULL),(5849,3753,'EM','millsap@me.com',0,'2013-12-25 21:33:13',NULL,NULL),(3792,2411,'TE','5136008332',0,'2013-12-25 19:33:44',NULL,NULL),(22530,14526,'AP','9793248151',0,'2013-12-28 03:34:26',NULL,NULL),(3688,2339,'AP','9562378983',0,'2013-12-25 19:31:54',NULL,NULL),(22797,14700,'EM','COFFEETIME4444@YAHOO.COM',1,'2013-12-29 11:09:03',NULL,NULL),(39858,26365,'AP','6143300936',0,'2014-02-28 07:00:08',NULL,NULL),(34624,22702,'TE','9563987293',0,'2014-02-11 21:00:59',NULL,NULL),(26458,17032,'TE','4194817672',0,'2014-01-13 02:20:45',NULL,NULL),(11287,7357,'TE','8323214401',0,'2013-12-26 02:15:17',NULL,NULL),(23973,15471,'EM','DD349304@GMAIL.COM',1,'2014-01-02 04:28:57',NULL,NULL),(9044,5933,'AP','2253269538',0,'2013-12-25 23:50:35',NULL,NULL),(41733,27749,'AP','2255884243',0,'2014-03-05 21:31:14',NULL,NULL),(25940,16711,'AP','5124131088',0,'2014-01-08 18:24:43',NULL,NULL),(1335,816,'EM','islandlizard@roadrunner.com',0,'2013-12-25 18:05:57',NULL,NULL),(24503,15806,'EM','charlesbreaux25@yahoo.com',0,'2014-01-03 02:03:04',NULL,NULL),(36454,24005,'TE','2168493686',0,'2014-02-15 22:00:36',NULL,NULL),(33581,22014,'EM','catherine.cipollone@gmail.com',0,'2014-02-07 19:00:54',NULL,NULL),(9024,5920,'EM','lorawashington@aol.com',0,'2013-12-25 23:50:16',NULL,NULL),(25661,16546,'TE','3309490411',1,'2014-01-07 10:22:33',NULL,NULL),(5829,3741,'AP','4322132924',0,'2013-12-25 21:32:54',NULL,NULL),(39261,25975,'EM','fitzdman@aol.com',0,'2014-02-26 21:01:48',NULL,NULL),(40253,26704,'AP','4402404678',0,'2014-02-28 21:31:35',NULL,NULL),(41594,27654,'AP','4407816031',0,'2014-03-05 21:30:23',NULL,NULL),(805,500,'AP','7404274077',0,'2013-12-25 17:48:41',NULL,NULL),(32101,20965,'TE','4693868463',0,'2014-02-01 19:00:11',NULL,NULL),(35081,23040,'TE','8063833734',0,'2014-02-12 21:30:39',NULL,NULL),(10532,6858,'AP','7404054067',0,'2013-12-26 01:31:36',NULL,NULL),(25342,16344,'TE','3302965759',0,'2014-01-07 04:02:19',NULL,NULL),(21243,13654,'TE','5047589779',0,'2013-12-26 13:07:25',NULL,NULL),(8022,5245,'TE','4407345180',0,'2013-12-25 23:05:00',NULL,NULL),(8051,5273,'AP','3309906159',0,'2013-12-25 23:05:35',NULL,NULL),(22772,14682,'EM','DWHIRLS57@GMAIL.COM',1,'2013-12-29 11:08:36',NULL,NULL),(23790,15342,'AP','3308586636',1,'2014-01-02 04:24:17',NULL,NULL),(3504,2190,'TE','5135753855',0,'2013-12-25 19:19:43',NULL,NULL),(27375,17623,'AP','8173230285',0,'2014-01-14 01:32:28',NULL,NULL),(37720,24869,'EM','tenola.oliver@yahoo.com',0,'2014-02-20 05:33:05',NULL,NULL),(33188,21733,'EM','tuyet1975phan@yahoo.com',0,'2014-02-06 21:00:11',NULL,NULL),(179,106,'AP','6178003094',0,'2013-12-25 17:17:51',NULL,NULL),(21471,13796,'EM','cwheatley917@gmail.com',0,'2013-12-26 13:11:15',NULL,NULL),(24780,15984,'AP','9037679637',0,'2014-01-04 02:01:04',NULL,NULL),(272,168,'AP','3303287000',0,'2013-12-25 17:19:22',NULL,NULL),(6503,4204,'TE','4323642449',0,'2013-12-25 21:50:00',NULL,NULL),(42546,28308,'AP','6622300938',0,'2014-03-07 21:00:35',NULL,NULL),(1137,698,'AP','9374021002',0,'2013-12-25 18:02:50',NULL,NULL),(36808,24235,'TE','9372882825',0,'2014-02-16 19:00:36',NULL,NULL),(27162,17487,'EM','d.pope005@gmail.com',0,'2014-01-13 03:01:17',NULL,NULL),(14950,9781,'AP','2164033462',0,'2013-12-26 05:00:44',NULL,NULL),(3778,2396,'AP','5134624316',0,'2013-12-25 19:33:25',NULL,NULL),(23534,15186,'EM','elyjordan@yahoo.com',0,'2014-01-01 12:06:58',NULL,NULL),(39957,26451,'AP','6017503733',0,'2014-02-28 07:30:26',NULL,NULL),(42126,27984,'EM','ams4685@yahoo.com',0,'2014-03-06 21:00:59',NULL,NULL),(24560,15843,'TE','3305366527',0,'2014-01-03 02:04:12',NULL,NULL),(10487,6831,'AP','7402444198',0,'2013-12-26 01:30:48',NULL,NULL),(27635,17813,'AP','2103555519',0,'2014-01-15 02:05:53',NULL,NULL),(29335,18955,'AP','2812458883',0,'2014-01-20 08:05:52',NULL,NULL),(29703,19205,'TE','2163210064',0,'2014-01-21 08:46:18',NULL,NULL),(3790,2407,'TE','3303339600',0,'2013-12-25 19:33:41',NULL,NULL),(5369,3437,'EM','KEITHHOGAN.ART@GMAIL.COM',0,'2013-12-25 21:19:07',NULL,NULL),(30588,19845,'AP','3182661471',0,'2014-01-24 21:00:28',NULL,NULL),(41603,27660,'AP','3306921148',0,'2014-03-05 21:30:27',NULL,NULL),(41711,27736,'EM','dwooldridge04@gmail.com',0,'2014-03-05 21:31:06',NULL,NULL),(27998,18047,'TE','9014878772',0,'2014-01-15 02:07:15',NULL,NULL),(28736,18542,'TE','6016687493',0,'2014-01-16 08:46:50',NULL,NULL),(36744,24189,'EM','TURNERMICKEY15@YAHOO.COM',0,'2014-02-16 19:00:13',NULL,NULL),(35624,23425,'TE','9034972156',0,'2014-02-13 22:01:25',NULL,NULL),(29351,18965,'AP','7135010103',0,'2014-01-20 08:05:57',NULL,NULL),(21376,13744,'TE','5138965040',0,'2013-12-26 13:09:47',NULL,NULL),(4108,2620,'TE','3305468877',0,'2013-12-25 19:45:51',NULL,NULL),(7838,5116,'AP','7135053717',0,'2013-12-25 23:01:49',NULL,NULL),(5835,3744,'AP','4323521073',0,'2013-12-25 21:32:59',NULL,NULL),(119,70,'TE','5136087159',0,'2013-12-25 17:16:55',NULL,NULL),(38898,25713,'AP','4327559889',0,'2014-02-26 09:30:24',NULL,NULL),(34813,22834,'AP','3302676004',0,'2014-02-11 21:02:09',NULL,NULL),(8237,5389,'TE','9856377989',0,'2013-12-25 23:08:37',NULL,NULL),(33054,21653,'TE','2258101478',0,'2014-02-05 21:30:51',NULL,NULL),(7769,5070,'TE','4697139615',0,'2013-12-25 23:00:42',NULL,NULL),(5291,3393,'TE','5042923039',0,'2013-12-25 21:17:54',NULL,NULL),(29516,19081,'TE','5136091303',0,'2014-01-21 08:44:26',NULL,NULL),(29336,18956,'TE','9032293737',0,'2014-01-20 08:05:52',NULL,NULL),(27907,17982,'TE','2169399147',0,'2014-01-15 02:06:53',NULL,NULL),(11822,7691,'AP','2166181025',0,'2013-12-26 03:01:02',NULL,NULL),(4965,3186,'TE','3303294695',0,'2013-12-25 20:31:59',NULL,NULL),(39553,26167,'EM','tanyalong02@comcast.net',0,'2014-02-28 06:30:35',NULL,NULL),(11393,7417,'TE','5138964343',0,'2013-12-26 02:16:54',NULL,NULL),(38265,25259,'BN','3307184309',0,'2014-02-22 19:00:12',NULL,NULL),(27462,17692,'TE','5044275064',0,'2014-01-14 01:33:00',NULL,NULL),(30694,19940,'TE','4199051726',0,'2014-01-24 21:01:14',NULL,NULL),(36108,23759,'TE','4408453621',0,'2014-02-14 21:31:09',NULL,NULL),(30769,20000,'AP','2166958600',0,'2014-01-26 19:00:04',NULL,NULL),(33509,21963,'TE','3309139206',0,'2014-02-07 19:00:27',NULL,NULL),(9507,6224,'TE','4197730331',0,'2013-12-26 00:31:14',NULL,NULL),(38288,25282,'TE','8176002990',0,'2014-02-25 21:00:18',NULL,NULL),(36825,24253,'AP','3308582056',0,'2014-02-17 19:00:05',NULL,NULL),(37781,24934,'AP','7083743567',0,'2014-02-20 21:30:21',NULL,NULL),(39317,26007,'AP','4192350816',0,'2014-02-26 21:02:07',NULL,NULL),(39362,26035,'TE','5132070500',0,'2014-02-26 21:02:23',NULL,NULL),(40240,26691,'AP','3183448015',0,'2014-02-28 21:31:29',NULL,NULL),(27894,17974,'EM','Barbara.Nemeth@yahoo.com',0,'2014-01-15 02:06:50',NULL,NULL),(37097,24423,'AP','3307873653',0,'2014-02-18 22:01:09',NULL,NULL),(35969,23666,'TE','9152762265',0,'2014-02-14 21:30:22',NULL,NULL),(30457,19743,'EM','bkilby81@gmail.com',0,'2014-01-23 21:01:13',NULL,NULL),(31713,20696,'AP','4196027888',0,'2014-01-30 21:01:01',NULL,NULL),(307,189,'AP','3302857736',0,'2013-12-25 17:19:55',NULL,NULL),(24069,15539,'AP','5044526971',1,'2014-01-02 04:30:55',NULL,NULL),(23834,15377,'TE','5137425863',1,'2014-01-02 04:25:18',NULL,NULL),(6811,4418,'AP','2164001029',0,'2013-12-25 22:01:33',NULL,NULL),(4114,2624,'AP','5137910594',0,'2013-12-25 19:45:57',NULL,NULL),(39859,26365,'EM','sugerkitty@gmail.com',0,'2014-02-28 07:00:08',NULL,NULL),(25134,16203,'TE','9565695921',0,'2014-01-05 00:01:12',NULL,NULL),(39127,25880,'AP','5047229049',0,'2014-02-26 21:00:57',NULL,NULL),(37687,24848,'AP','5676940879',0,'2014-02-20 04:54:57',NULL,NULL),(36364,23946,'AP','5049204867',0,'2014-02-15 21:00:12',NULL,NULL),(21755,14012,'TE','9374744557',0,'2013-12-26 13:16:24',NULL,NULL),(2859,1745,'AP','2162107010',0,'2013-12-25 18:55:38',NULL,NULL),(11809,7682,'TE','2162542522',0,'2013-12-26 03:00:49',NULL,NULL),(7915,5157,'EM','pattibetts@gmail.com',0,'2013-12-25 23:02:58',NULL,NULL),(24957,16085,'TE','6145079318',0,'2014-01-04 02:04:15',NULL,NULL),(29388,18992,'BN','3306184395',0,'2014-01-20 08:06:12',NULL,NULL),(5317,3408,'AP','5043194241',0,'2013-12-25 21:18:19',NULL,NULL),(27746,17889,'AP','5134829436',0,'2014-01-15 02:06:19',NULL,NULL),(38686,25567,'AP','3303472037',0,'2014-02-26 08:00:27',NULL,NULL),(7128,4652,'TE','5138436874',0,'2013-12-25 22:07:07',NULL,NULL),(3221,2025,'AP','3303510283',0,'2013-12-25 19:15:12',NULL,NULL),(35974,23670,'TE','5123638343',0,'2014-02-14 21:30:24',NULL,NULL),(26963,17340,'TE','6019468975',0,'2014-01-13 02:24:02',NULL,NULL),(9691,6348,'EM','laddrodh@gmail.com',0,'2013-12-26 00:46:58',NULL,NULL),(20824,13385,'TE','3307225444',0,'2013-12-26 13:00:00',NULL,NULL),(20846,13403,'TE','4405902120',0,'2013-12-26 13:00:22',NULL,NULL),(25440,16404,'AP','9568578412',0,'2014-01-07 04:04:01',NULL,NULL),(23827,15373,'TE','6014661152',1,'2014-01-02 04:25:09',NULL,NULL),(23307,15018,'TE','5133799887',0,'2014-01-01 12:02:14',NULL,NULL),(8352,5486,'TE','9379817400',0,'2013-12-25 23:10:57',NULL,NULL),(27380,17625,'AP','5129233472',0,'2014-01-14 01:32:30',NULL,NULL),(40942,27203,'EM','spalmadvocate@gmail.com',0,'2014-03-03 21:31:24',NULL,NULL),(27521,17727,'EM','EHerbell@aol.com',0,'2014-01-14 01:33:18',NULL,NULL),(25150,16211,'AP','9726894187',0,'2014-01-05 00:01:29',NULL,NULL),(3094,1931,'EM','julialtaylor@aol.com',0,'2013-12-25 19:00:24',NULL,NULL),(9281,6077,'EM','azprintng@aol.com',0,'2013-12-26 00:02:23',NULL,NULL),(23050,14867,'AP','4097305717',0,'2013-12-30 00:00:08',NULL,NULL),(24358,15730,'AP','3012190444',0,'2014-01-03 02:00:29',NULL,NULL),(4426,2822,'TE','2166514150',0,'2013-12-25 20:00:31',NULL,NULL),(14811,9694,'EM','djwilsonoh@yahoo.com',0,'2013-12-26 04:39:49',NULL,NULL),(7681,5005,'TE','6143061611',0,'2013-12-25 22:47:13',NULL,NULL),(26489,17048,'TE','9378852256',0,'2014-01-13 02:20:55',NULL,NULL),(31775,20742,'TE','3305598989',0,'2014-01-30 21:01:24',NULL,NULL),(31935,20845,'AP','4407736286',0,'2014-01-31 21:00:49',NULL,NULL),(34881,22886,'AP','5672772995',0,'2014-02-11 21:02:35',NULL,NULL),(39003,25790,'TE','4194489754',0,'2014-02-26 21:00:11',NULL,NULL),(27686,17845,'AP','3135663679',0,'2014-01-15 02:06:05',NULL,NULL),(38699,25573,'EM','mlocker4@woh.rr.com',0,'2014-02-26 08:00:32',NULL,NULL),(38681,25565,'TE','3309882762',0,'2014-02-26 08:00:26',NULL,NULL),(38318,25315,'AP','5044968660',0,'2014-02-25 21:30:04',NULL,NULL),(28734,18541,'AP','6626438516',0,'2014-01-16 08:46:49',NULL,NULL),(34625,22703,'TE','9725633603',0,'2014-02-11 21:01:00',NULL,NULL),(21742,14005,'TE','3305441985',0,'2013-12-26 13:16:13',NULL,NULL),(26908,17310,'TE','9032630208',0,'2014-01-13 02:23:44',NULL,NULL),(21156,13603,'EM','tsmith00@woh.rr.com',0,'2013-12-26 13:05:29',NULL,NULL),(14627,9561,'AP','9402060500',0,'2013-12-26 04:36:35',NULL,NULL),(26815,17247,'TE','3302426965',0,'2014-01-13 02:23:10',NULL,NULL),(14556,9511,'AP','6143143000',0,'2013-12-26 04:35:24',NULL,NULL),(14163,9269,'AP','5132950922',0,'2013-12-26 04:15:36',NULL,NULL),(6877,4462,'TE','4403222333',0,'2013-12-25 22:02:39',NULL,NULL),(25341,16343,'AP','4196735451',0,'2014-01-07 04:02:17',NULL,NULL),(25947,16714,'BN','8324993055',0,'2014-01-08 18:24:44',NULL,NULL),(43464,28863,'AP','2252442051',0,'2014-03-09 21:30:06',NULL,NULL),(26178,16854,'TE','4193602655',0,'2014-01-13 02:18:42',NULL,NULL),(25580,16500,'AP','9377760690',0,'2014-01-07 04:06:50',NULL,NULL),(11502,7483,'EM','jsadiq.pak@gmail.com',0,'2013-12-26 02:31:27',NULL,NULL),(25210,16256,'AP','6015305129',0,'2014-01-05 00:02:46',NULL,NULL),(28491,18358,'AP','4193920420',0,'2014-01-16 08:45:25',NULL,NULL),(22496,14503,'TE','9158508561',0,'2013-12-28 03:33:51',NULL,NULL),(24722,15948,'EM','ssg1952@att.net',0,'2014-01-03 02:07:27',NULL,NULL),(39615,26202,'AP','3302174547',0,'2014-02-28 06:30:49',NULL,NULL),(31566,20585,'TE','6148633818',0,'2014-01-30 21:00:05',NULL,NULL),(43354,28796,'TE','6148339650',0,'2014-03-09 21:00:45',NULL,NULL),(43778,29060,'EM','aimeekoosh3@gmail.com',0,'2014-03-10 21:01:52',NULL,NULL),(2939,1809,'TE','4403191453',0,'2013-12-25 18:56:59',NULL,NULL),(31228,20338,'BN','3185580273',0,'2014-01-28 21:01:06',NULL,NULL),(1110,680,'TE','3303127825',0,'2013-12-25 18:02:22',NULL,NULL),(1313,802,'TE','8325803031',0,'2013-12-25 18:05:35',NULL,NULL),(2689,1633,'EM','pond.liquor@gmail.com',0,'2013-12-25 18:52:53',NULL,NULL),(37289,24539,'TE','9152443276',0,'2014-02-20 04:02:00',NULL,NULL),(40557,26919,'TE','3303297070',0,'2014-03-03 01:00:15',NULL,NULL),(42588,28336,'TE','4093928188',0,'2014-03-07 21:30:14',NULL,NULL),(29092,18789,'AP','8284215716',0,'2014-01-17 03:35:55',NULL,NULL),(2736,1659,'AP','5122897788',0,'2013-12-25 18:53:35',NULL,NULL),(20752,13338,'TE','2815688942',0,'2013-12-26 12:58:49',NULL,NULL),(24501,15806,'TE','3373054059',0,'2014-01-03 02:03:03',NULL,NULL),(27390,17630,'EM','ssassy92@aol.com',0,'2014-01-14 01:32:33',NULL,NULL),(38914,25724,'AP','5047230704',0,'2014-02-26 09:30:31',NULL,NULL),(33837,22214,'BN','4232550448',0,'2014-02-09 19:00:22',NULL,NULL),(29889,19341,'TE','8067873410',1,'2014-01-22 03:22:21',NULL,NULL),(8413,5540,'EM','rickpost57@yahoo.com',0,'2013-12-25 23:15:47',NULL,NULL),(20273,13067,'TE','6144047809',0,'2013-12-26 12:51:12',NULL,NULL),(6696,4353,'AP','5134762333',0,'2013-12-25 21:53:31',NULL,NULL),(23853,15389,'AP','4402123098',1,'2014-01-02 04:25:41',NULL,NULL),(27753,17892,'AP','3306908022',0,'2014-01-15 02:06:20',NULL,NULL),(43333,28786,'AP','5133740668',0,'2014-03-09 21:00:38',NULL,NULL),(43490,28879,'EM','jrenee7962@aol.com',0,'2014-03-10 21:00:07',NULL,NULL),(35273,23165,'EM','dlynn77@mail.com',0,'2014-02-12 21:31:49',NULL,NULL),(934,577,'EM','mikiemilcon@aol.com',0,'2013-12-25 17:50:45',NULL,NULL),(1168,717,'AP','4196058629',0,'2013-12-25 18:03:21',NULL,NULL),(4460,2840,'AP','3305192292',0,'2013-12-25 20:01:02',NULL,NULL),(5075,3259,'EM','shelleekotschwar@gmail.com',0,'2013-12-25 20:46:49',NULL,NULL),(41263,27421,'EM','fishfood247@aol.com',0,'2014-03-04 21:01:39',NULL,NULL),(41683,27720,'TE','7136799843',0,'2014-03-05 21:30:58',NULL,NULL),(27342,17606,'AP','8062921319',0,'2014-01-14 01:32:19',NULL,NULL),(39761,26294,'AP','4194510111',0,'2014-02-28 06:31:25',NULL,NULL),(32417,21182,'AP','9012887592',0,'2014-02-03 21:00:43',NULL,NULL),(9871,6453,'EM','tracydardenne@gmail.com',0,'2013-12-26 00:49:45',NULL,NULL),(2490,1528,'AP','5138944070',0,'2013-12-25 18:49:57',NULL,NULL),(24797,15997,'EM','txcox@att.net',0,'2014-01-04 02:01:24',NULL,NULL),(8497,5589,'TE','3372127216',0,'2013-12-25 23:17:12',NULL,NULL),(2019,1250,'EM','nawkawllw@gmail.com',0,'2013-12-25 18:21:13',NULL,NULL),(7669,4993,'TE','5138501717',0,'2013-12-25 22:46:59',NULL,NULL),(22690,14635,'AP','4193710697',0,'2013-12-28 03:37:17',NULL,NULL),(29502,19071,'TE','6014424656',0,'2014-01-21 08:44:20',NULL,NULL),(31302,20396,'AP','9794060242',0,'2014-01-29 21:00:18',NULL,NULL),(29794,19270,'EM','captsavva@att.net',0,'2014-01-21 08:46:54',NULL,NULL),(42905,28532,'EM','debdegeer@aol.com',0,'2014-03-07 21:32:09',NULL,NULL),(28098,18110,'TE','2253435736',0,'2014-01-15 02:07:37',NULL,NULL),(38404,25370,'AP','3305548025',0,'2014-02-25 21:30:41',NULL,NULL),(25668,16549,'TE','2252005058',1,'2014-01-07 10:22:40',NULL,NULL),(20257,13052,'AP','2164966565',0,'2013-12-26 12:50:54',NULL,NULL),(7176,4678,'AP','2255886818',0,'2013-12-25 22:07:49',NULL,NULL),(35486,23334,'EM','jckellydmf@yahoo.com',0,'2014-02-13 22:00:33',NULL,NULL),(29995,19423,'TE','2165263197',1,'2014-01-22 03:23:03',NULL,NULL),(40840,27137,'AP','4196518524',0,'2014-03-03 21:30:44',NULL,NULL),(25241,16278,'TE','2167414048',0,'2014-01-07 04:00:27',NULL,NULL),(11564,7524,'AP','4404544508',0,'2013-12-26 02:32:30',NULL,NULL),(24929,16067,'AP','9375154148',0,'2014-01-04 02:03:43',NULL,NULL),(38638,25537,'EM','crystalgresham@ymail.com',0,'2014-02-26 08:00:09',NULL,NULL),(23072,14879,'EM','christy.ang@gmail.com',0,'2013-12-30 00:00:29',NULL,NULL),(3314,2085,'TE','5047825193',0,'2013-12-25 19:16:44',NULL,NULL),(9732,6368,'EM','thebinary@gmail.com',0,'2013-12-26 00:47:34',NULL,NULL),(39156,25899,'EM','krigby@grandecom.net',0,'2014-02-26 21:01:07',NULL,NULL),(2820,1704,'EM','citywiderm@gmail.com',0,'2013-12-25 18:54:50',NULL,NULL),(38025,25082,'AP','4192170332',0,'2014-02-20 22:01:39',NULL,NULL),(30719,19958,'AP','2543155100',0,'2014-01-25 19:00:06',NULL,NULL),(9303,6093,'TE','4198789517',0,'2013-12-26 00:02:49',NULL,NULL),(14367,9391,'AP','7138228143',0,'2013-12-26 04:32:22',NULL,NULL),(3958,2513,'AP','9016287228',0,'2013-12-25 19:36:22',NULL,NULL),(4468,2846,'TE','8307199040',0,'2013-12-25 20:01:12',NULL,NULL),(41151,27333,'TE','2163226485',0,'2014-03-04 21:00:53',NULL,NULL),(29875,19334,'TE','2144577859',1,'2014-01-22 03:22:17',NULL,NULL),(37803,24948,'AP','3376587627',0,'2014-02-20 22:00:09',NULL,NULL),(33312,21817,'EM','xxsillyboobooxx@gmail.com',0,'2014-02-06 21:00:57',NULL,NULL),(5376,3442,'TE','3303286235',0,'2013-12-25 21:19:16',NULL,NULL),(13948,9094,'EM','tammie.maiden@myemail.indwes.edu',0,'2013-12-26 04:07:12',NULL,NULL),(14539,9497,'EM','robinja56@yahoo.com',0,'2013-12-26 04:35:05',NULL,NULL),(21180,13624,'TE','4192290458',0,'2013-12-26 13:05:57',NULL,NULL),(22580,14563,'EM','obarnett@sbcglobal.net',0,'2013-12-28 03:35:20',NULL,NULL),(25505,16447,'TE','6015063054',0,'2014-01-07 04:05:17',NULL,NULL),(11501,7483,'AP','6145890104',0,'2013-12-26 02:31:27',NULL,NULL),(40679,27012,'TE','4193488794',0,'2014-03-03 21:00:08',NULL,NULL),(42690,28399,'TE','9372310623',0,'2014-03-07 21:30:49',NULL,NULL),(21046,13539,'TE','5044286949',0,'2013-12-26 13:03:43',NULL,NULL),(9360,6127,'EM','debra5254@aol.com',0,'2013-12-26 00:15:54',NULL,NULL),(33205,21743,'EM','gatormanlcnm@aol.com',0,'2014-02-06 21:00:16',NULL,NULL),(9630,6301,'EM','buckeyelocalguy@gmail.com',0,'2013-12-26 00:45:56',NULL,NULL),(11494,7478,'TE','3302855868',0,'2013-12-26 02:31:20',NULL,NULL),(7100,4634,'AP','6622300938',0,'2013-12-25 22:06:37',NULL,NULL),(7590,4942,'TE','5132408986',0,'2013-12-25 22:45:42',NULL,NULL),(42746,28432,'TE','4197336700',0,'2014-03-07 21:31:09',NULL,NULL),(40408,26822,'AP','9379038084',0,'2014-03-01 21:00:35',NULL,NULL),(9830,6431,'AP','3375173258',0,'2013-12-26 00:49:10',NULL,NULL),(35046,23016,'TE','2252260191',0,'2014-02-12 21:30:27',NULL,NULL),(4734,3032,'TE','4196010348',0,'2013-12-25 20:18:26',NULL,NULL),(26136,16825,'EM','NinbabeC@aol.com',0,'2014-01-13 02:18:25',NULL,NULL),(21998,14169,'TE','9852551371',0,'2013-12-27 02:03:24',NULL,NULL),(20699,13307,'TE','9033916977',0,'2013-12-26 12:57:58',NULL,NULL),(22711,14646,'AP','3612073302',1,'2013-12-29 11:07:36',NULL,NULL),(25532,16470,'TE','3308696190',0,'2014-01-07 04:05:56',NULL,NULL),(6312,4067,'AP','3305928884',0,'2013-12-25 21:46:51',NULL,NULL),(3554,2226,'TE','4196184740',0,'2013-12-25 19:20:39',NULL,NULL),(37893,24997,'TE','2817286328',0,'2014-02-20 22:00:44',NULL,NULL),(28889,18652,'TE','3616960581',0,'2014-01-17 03:35:10',NULL,NULL),(25925,16705,'AP','4693832180',0,'2014-01-08 18:24:40',NULL,NULL),(6034,3876,'AP','2254397024',0,'2013-12-25 21:36:19',NULL,NULL),(22597,14574,'TE','2399610651',0,'2013-12-28 03:35:38',NULL,NULL),(20320,13093,'EM','krprsnow@yahoo.com',0,'2013-12-26 12:51:57',NULL,NULL),(41492,27582,'EM','Lautriv6@hotmail.com',0,'2014-03-05 21:00:12',NULL,NULL),(756,475,'TE','3182682039',0,'2013-12-25 17:47:59',NULL,NULL),(39569,26179,'TE','4406680861',0,'2014-02-28 06:30:39',NULL,NULL),(38989,25781,'EM','john_scardino@yahoo.com',0,'2014-02-26 09:31:03',NULL,NULL),(24308,15703,'TE','3309234514',1,'2014-01-02 04:35:48',NULL,NULL),(8713,5716,'TE','3304643233',0,'2013-12-25 23:45:17',NULL,NULL),(34783,22814,'TE','5137536870',0,'2014-02-11 21:01:59',NULL,NULL),(34103,22353,'EM','bobbybass105@gmail.com',0,'2014-02-10 21:00:04',NULL,NULL),(21347,13717,'TE','4192899192',0,'2013-12-26 13:09:07',NULL,NULL),(11824,7692,'AP','2164016041',0,'2013-12-26 03:01:04',NULL,NULL),(22281,14362,'AP','6145782100',0,'2013-12-28 03:30:17',NULL,NULL),(4863,3112,'AP','2144138801',0,'2013-12-25 20:30:04',NULL,NULL),(3671,2329,'AP','8063671095',0,'2013-12-25 19:31:38',NULL,NULL),(1126,691,'AP','7402217844',0,'2013-12-25 18:02:39',NULL,NULL),(2489,1528,'TE','5138944070',0,'2013-12-25 18:49:57',NULL,NULL),(34401,22565,'EM','allant30@hotmail.com',0,'2014-02-10 21:31:53',NULL,NULL),(38035,25094,'AP','9375108339',0,'2014-02-21 21:30:07',NULL,NULL),(20321,13095,'TE','4403911228',0,'2013-12-26 12:51:59',NULL,NULL),(35325,23212,'TE','5134901485',0,'2014-02-12 21:32:13',NULL,NULL),(14299,9353,'AP','3379981468',0,'2013-12-26 04:31:18',NULL,NULL),(36076,23730,'AP','4193097907',0,'2014-02-14 21:30:57',NULL,NULL),(6282,4051,'TE','5137914393',0,'2013-12-25 21:46:24',NULL,NULL),(3912,2483,'TE','2253230560',0,'2013-12-25 19:35:34',NULL,NULL),(3841,2443,'AP','3306087479',0,'2013-12-25 19:34:30',NULL,NULL),(27349,17609,'EM','mepundt@sbcglobal.net',0,'2014-01-14 01:32:20',NULL,NULL),(25543,16477,'EM','musky634494@att.net',0,'2014-01-07 04:06:09',NULL,NULL),(11169,7266,'TE','9798308285',0,'2013-12-26 02:02:16',NULL,NULL),(1663,1021,'EM','jmcgaffi@neo.rr.com',0,'2013-12-25 18:15:15',NULL,NULL),(26390,16988,'TE','8322669657',0,'2014-01-13 02:20:22',NULL,NULL),(1280,779,'TE','9153075047',0,'2013-12-25 18:05:01',NULL,NULL),(22069,14213,'TE','7134783327',0,'2013-12-27 02:04:33',NULL,NULL),(40102,26595,'TE','2346787140',0,'2014-02-28 21:30:38',NULL,NULL),(37901,25001,'TE','3307948745',0,'2014-02-20 22:00:46',NULL,NULL),(37033,24384,'TE','3307694225',0,'2014-02-18 22:00:46',NULL,NULL),(34746,22783,'TE','5174147516',0,'2014-02-11 21:01:45',NULL,NULL),(36682,24153,'TE','3308138488',0,'2014-02-15 22:01:58',NULL,NULL),(35619,23423,'TE','9566396202',0,'2014-02-13 22:01:23',NULL,NULL),(41370,27483,'TE','9724802998',0,'2014-03-04 21:02:18',NULL,NULL),(6001,3855,'TE','3187585314',0,'2013-12-25 21:35:46',NULL,NULL),(4174,2667,'EM','debscharrer@gmail.com',0,'2013-12-25 19:46:58',NULL,NULL),(4646,2968,'TE','9795490234',0,'2013-12-25 20:16:56',NULL,NULL),(38751,25618,'EM','jcmcc5@verizon.net',0,'2014-02-26 08:30:14',NULL,NULL),(9109,5970,'EM','coatis@aol.com',0,'2013-12-25 23:51:36',NULL,NULL),(6910,4500,'TE','9564859154',0,'2013-12-25 22:03:21',NULL,NULL),(12364,8092,'AP','5133836815',0,'2013-12-26 03:10:44',NULL,NULL),(32541,21277,'TE','3049897366',0,'2014-02-03 21:01:34',NULL,NULL),(43535,28904,'TE','9724955266',0,'2014-03-10 21:00:23',NULL,NULL),(43853,29102,'EM','tamvance@yahoo.com',0,'2014-03-10 21:02:17',NULL,NULL),(1,1,'TE','4199080099',0,'2013-12-25 17:15:03',NULL,NULL),(40475,26864,'EM','Michael.lucero13@gmail.com',0,'2014-03-01 21:00:59',NULL,NULL),(37326,24563,'AP','2169904376',0,'2014-02-20 04:06:45',NULL,NULL),(5796,3715,'EM','mkennedya@gmail.com',0,'2013-12-25 21:32:18',NULL,NULL),(35884,23598,'TE','4194488441',0,'2014-02-13 22:03:07',NULL,NULL),(34039,22321,'AP','3375156715',0,'2014-02-10 11:00:54',NULL,NULL),(8630,5668,'AP','3309575181',0,'2013-12-25 23:31:59',NULL,NULL),(3578,2241,'AP','4199139225',0,'2013-12-25 19:21:02',NULL,NULL),(5066,3251,'EM','fsooz@aol.com',0,'2013-12-25 20:46:39',NULL,NULL),(21462,13792,'AP','9013026428',0,'2013-12-26 13:11:07',NULL,NULL),(1100,674,'EM','dbarlage@fuse.net',0,'2013-12-25 18:02:14',NULL,NULL),(10801,7018,'TE','2107255263',0,'2013-12-26 01:48:45',NULL,NULL),(37937,25031,'TE','2253830487',0,'2014-02-20 22:01:03',NULL,NULL),(9285,6080,'TE','5132657535',0,'2013-12-26 00:02:27',NULL,NULL),(6734,4374,'AP','2163380136',0,'2013-12-25 22:00:24',NULL,NULL),(14100,9219,'AP','5674547187',0,'2013-12-26 04:10:09',NULL,NULL),(32974,21584,'TE','3307147196',0,'2014-02-05 21:30:27',NULL,NULL),(28084,18101,'TE','9858791817',0,'2014-01-15 02:07:34',NULL,NULL),(25244,16279,'AP','2167414048',0,'2014-01-07 04:00:29',NULL,NULL),(58,38,'TE','5137326466',0,'2013-12-25 17:15:59',NULL,NULL),(39024,25804,'AP','5137396067',0,'2014-02-26 21:00:19',NULL,NULL),(39328,26012,'TE','4192382020',0,'2014-02-26 21:02:11',NULL,NULL),(40129,26612,'AP','3473318825',0,'2014-02-28 21:30:48',NULL,NULL),(14276,9339,'TE','5043662436',0,'2013-12-26 04:30:58',NULL,NULL),(484,310,'AP','3253728787',0,'2013-12-25 17:30:59',NULL,NULL),(13898,9060,'AP','8133334841',0,'2013-12-26 04:06:20',NULL,NULL),(23323,15027,'TE','2252886055',0,'2014-01-01 12:02:30',NULL,NULL),(6640,4302,'TE','9374033600',0,'2013-12-25 21:52:23',NULL,NULL),(22954,14806,'EM','poodlejoel@aol.com',1,'2013-12-29 11:13:55',NULL,NULL),(4302,2744,'EM','htaeh_2000@yahoo.com',0,'2013-12-25 19:48:54',NULL,NULL),(8322,5458,'TE','3308889459',0,'2013-12-25 23:10:20',NULL,NULL),(32001,20891,'AP','7406073329',0,'2014-01-31 21:01:15',NULL,NULL),(37090,24421,'TE','3309060832',0,'2014-02-18 22:01:07',NULL,NULL),(42939,28549,'EM','djrks13@gmail.com',0,'2014-03-07 21:32:20',NULL,NULL),(1740,1070,'EM','collaredcougar@gmail.com',0,'2013-12-25 18:16:30',NULL,NULL),(30485,19768,'TE','9015987927',0,'2014-01-23 21:01:27',NULL,NULL),(14096,9216,'AP','5137042581',0,'2013-12-26 04:10:04',NULL,NULL),(10844,7039,'EM','rjaivalis@yahoo.com',0,'2013-12-26 01:49:22',NULL,NULL),(3988,2533,'TE','9374891389',0,'2013-12-25 19:36:50',NULL,NULL),(14741,9641,'AP','5125678879',0,'2013-12-26 04:38:30',NULL,NULL),(20576,13240,'TE','9034077019',0,'2013-12-26 12:56:03',NULL,NULL),(31140,20281,'AP','5136172339',0,'2014-01-28 21:00:30',NULL,NULL),(31785,20747,'EM','dr490168@gmail.com',0,'2014-01-30 21:01:27',NULL,NULL),(37972,25052,'EM','rburnette528@gmail.com',0,'2014-02-20 22:01:17',NULL,NULL),(8759,5741,'AP','2258024321',0,'2013-12-25 23:45:57',NULL,NULL),(6779,4398,'EM','cincyheart@gmail.com',0,'2013-12-25 22:01:05',NULL,NULL),(6345,4090,'AP','4193493617',0,'2013-12-25 21:47:24',NULL,NULL),(26053,16783,'TE','4197044506',0,'2014-01-08 18:25:06',NULL,NULL),(41523,27609,'AP','5042567369',0,'2014-03-05 21:00:27',NULL,NULL),(43421,28833,'EM','RENAWILLIAMS6@GMAIL.COM',0,'2014-03-09 21:01:09',NULL,NULL),(14712,9625,'EM','sparis23@spcglobal.net',0,'2013-12-26 04:38:02',NULL,NULL),(30123,19511,'BN','8178293275',0,'2014-01-23 03:02:15',NULL,NULL),(30098,19498,'AP','4402418606',0,'2014-01-23 03:02:09',NULL,NULL),(13930,9084,'TE','9374891970',0,'2013-12-26 04:06:54',NULL,NULL),(26749,17205,'TE','3306992408',0,'2014-01-13 02:22:27',NULL,NULL),(1130,693,'EM','zacharylawrence@gmail.com',0,'2013-12-25 18:02:43',NULL,NULL),(5585,3570,'TE','4192701888',0,'2013-12-25 21:22:32',NULL,NULL),(23614,15245,'EM','lxemm26@yahoo.com',0,'2014-01-01 12:08:46',NULL,NULL),(5327,3414,'TE','5042591652',0,'2013-12-25 21:18:28',NULL,NULL),(23211,14957,'TE','8064770459',0,'2014-01-01 12:00:24',NULL,NULL),(4256,2722,'EM','ecker_joe@yahoo.com',0,'2013-12-25 19:48:14',NULL,NULL),(20420,13149,'TE','3303960374',0,'2013-12-26 12:53:33',NULL,NULL),(31598,20612,'TE','3304283406',0,'2014-01-30 21:00:18',NULL,NULL),(33448,21909,'EM','jytrubee56@gmail.com',0,'2014-02-06 21:01:52',NULL,NULL),(34122,22373,'AP','9729041696',0,'2014-02-10 21:00:14',NULL,NULL),(36342,23934,'TE','6148731696',0,'2014-02-15 21:00:05',NULL,NULL),(41294,27437,'TE','5044275143',0,'2014-03-04 21:01:50',NULL,NULL),(13707,8934,'TE','3307664108',0,'2013-12-26 04:03:08',NULL,NULL),(328,205,'AP','2167026085',0,'2013-12-25 17:20:18',NULL,NULL),(5026,3224,'AP','3309074054',0,'2013-12-25 20:45:51',NULL,NULL),(2912,1786,'AP','6142862898',0,'2013-12-25 18:56:28',NULL,NULL),(27601,17793,'AP','9373693915',0,'2014-01-14 01:33:49',NULL,NULL),(13664,8907,'EM','almaharing@roadrunner.com',0,'2013-12-26 04:02:29',NULL,NULL),(2488,1527,'EM','kmvonh@yahoo.com',0,'2013-12-25 18:49:55',NULL,NULL),(11475,7464,'TE','9014938626',0,'2013-12-26 02:30:59',NULL,NULL),(23065,14876,'EM','kessaowens@aol.com',0,'2013-12-30 00:00:22',NULL,NULL),(10373,6761,'AP','3304123123',0,'2013-12-26 01:16:21',NULL,NULL),(31760,20727,'TE','3303263703',0,'2014-01-30 21:01:17',NULL,NULL),(33333,21834,'BN','8175978734',0,'2014-02-06 21:01:06',NULL,NULL),(36443,23998,'AP','4192382302',0,'2014-02-15 22:00:31',NULL,NULL),(37237,24504,'EM','acsmanny1970@att.net',0,'2014-02-20 03:50:30',NULL,NULL),(37529,24713,'AP','6143269323',0,'2014-02-20 04:36:22',NULL,NULL),(40176,26644,'AP','3304724647',0,'2014-02-28 21:31:05',NULL,NULL),(40229,26685,'TE','5046825916',0,'2014-02-28 21:31:25',NULL,NULL),(518,325,'AP','5133403590',0,'2013-12-25 17:31:29',NULL,NULL),(29179,18853,'AP','3308124608',0,'2014-01-17 03:36:17',NULL,NULL),(24092,15552,'TE','2252237568',1,'2014-01-02 04:31:20',NULL,NULL),(20999,13512,'EM','lavis.william@gmail.com',0,'2013-12-26 13:02:57',NULL,NULL),(1045,644,'AP','9376846710',0,'2013-12-25 18:01:26',NULL,NULL),(32882,21520,'AP','6622300938',0,'2014-02-05 21:00:06',NULL,NULL),(34164,22406,'TE','2024664444',0,'2014-02-10 21:30:22',NULL,NULL),(8142,5328,'AP','3305736946',0,'2013-12-25 23:07:02',NULL,NULL),(28447,18329,'EM','katiecat082@gmail.com',0,'2014-01-16 08:45:11',NULL,NULL),(10912,7091,'AP','3303046733',0,'2013-12-26 01:50:33',NULL,NULL),(2770,1679,'TE','5046025021',0,'2013-12-25 18:54:06',NULL,NULL),(6250,4030,'TE','9379263401',0,'2013-12-25 21:45:53',NULL,NULL),(5469,3501,'AP','4407737075',0,'2013-12-25 21:20:43',NULL,NULL),(31461,20505,'TE','5042088928',0,'2014-01-29 21:01:15',NULL,NULL),(33027,21636,'AP','2103620875',0,'2014-02-05 21:30:43',NULL,NULL),(38262,25258,'EM','RChamb52@gmail.com',0,'2014-02-22 19:00:11',NULL,NULL),(38684,25566,'TE','4192256029',0,'2014-02-26 08:00:27',NULL,NULL),(41713,27737,'AP','2542175402',0,'2014-03-05 21:31:07',NULL,NULL),(41753,27764,'AP','6155138955',0,'2014-03-05 21:31:22',NULL,NULL),(373,227,'TE','5046150137',0,'2013-12-25 17:20:57',NULL,NULL),(31322,20410,'EM','philhollister@sbcglobal.net',0,'2014-01-29 21:00:24',NULL,NULL),(2920,1789,'EM','jamesal@nmsu.edu',0,'2013-12-25 18:56:33',NULL,NULL),(8945,5855,'AP','9795617489',0,'2013-12-25 23:48:54',NULL,NULL),(22728,14656,'EM','wolverine25@icloud.com',1,'2013-12-29 11:07:52',NULL,NULL),(25690,16561,'EM','AUHRICK@EARTHLINK.NET',1,'2014-01-07 10:23:05',NULL,NULL),(23499,15156,'TE','6142645285',0,'2014-01-01 12:06:13',NULL,NULL),(9495,6212,'TE','2088597860',0,'2013-12-26 00:30:55',NULL,NULL),(31529,20547,'TE','5132228361',0,'2014-01-29 21:01:39',NULL,NULL),(41749,27763,'TE','2252402990',0,'2014-03-05 21:31:21',NULL,NULL),(2412,1470,'TE','2169249676',0,'2013-12-25 18:48:33',NULL,NULL),(30648,19891,'AP','4192965608',0,'2014-01-24 21:00:51',NULL,NULL),(13816,9002,'AP','3302894228',0,'2013-12-26 04:04:55',NULL,NULL),(22843,14740,'AP','2257185756',1,'2013-12-29 11:10:00',NULL,NULL),(33636,22057,'TE','9156911727',0,'2014-02-08 19:00:08',NULL,NULL),(35848,23571,'TE','4193890832',0,'2014-02-13 22:02:52',NULL,NULL),(39372,26040,'TE','3308074776',0,'2014-02-26 21:02:26',NULL,NULL),(42340,28118,'AP','4195338011',0,'2014-03-06 21:02:19',NULL,NULL),(5768,3695,'AP','4196514265',0,'2013-12-25 21:31:50',NULL,NULL),(30538,19810,'TE','9039150008',0,'2014-01-24 21:00:09',NULL,NULL),(29416,19017,'AP','4196511009',0,'2014-01-20 08:06:23',NULL,NULL),(7140,4657,'AP','3184611910',0,'2013-12-25 22:07:17',NULL,NULL),(25660,16545,'AP','2163701910',1,'2014-01-07 10:22:31',NULL,NULL),(3362,2113,'AP','3304148213',0,'2013-12-25 19:17:30',NULL,NULL),(21749,14009,'TE','5135204487',0,'2013-12-26 13:16:19',NULL,NULL),(22488,14500,'TE','8062237698',0,'2013-12-28 03:33:46',NULL,NULL),(35831,23563,'AP','4192302707',0,'2014-02-13 22:02:45',NULL,NULL),(36670,24143,'TE','5132059273',0,'2014-02-15 22:01:53',NULL,NULL),(40487,26869,'AP','2168323699',0,'2014-03-01 21:01:03',NULL,NULL),(43223,28722,'TE','4193068518',0,'2014-03-08 21:31:22',NULL,NULL),(264,162,'TE','8062180814',0,'2013-12-25 17:19:13',NULL,NULL),(31075,20218,'TE','9375493640',0,'2014-01-27 21:01:42',NULL,NULL),(25737,16586,'EM','savannameekins@gmail.com',0,'2014-01-08 18:23:59',NULL,NULL),(24494,15802,'TE','9853188130',0,'2014-01-03 02:02:55',NULL,NULL),(3112,1940,'EM','maryfillmore26@yahoo.com',0,'2013-12-25 19:00:39',NULL,NULL),(22734,14662,'TE','2147979494',1,'2013-12-29 11:08:01',NULL,NULL),(2116,1306,'TE','3616483805',0,'2013-12-25 18:31:19',NULL,NULL),(2343,1425,'EM','frogman290@yahoo.com',0,'2013-12-25 18:47:23',NULL,NULL),(40017,26513,'EM','steveknape@hotmail.com',0,'2014-02-28 21:00:21',NULL,NULL),(40040,26541,'EM','mikegailcu@yahoo.com',0,'2014-02-28 21:30:08',NULL,NULL),(20554,13228,'EM','davemetal0069@gmail.com',0,'2013-12-26 12:55:42',NULL,NULL),(31044,20196,'TE','9013830928',0,'2014-01-27 21:01:30',NULL,NULL),(27531,17738,'EM','ss_hindel@hotmail.com',0,'2014-01-14 01:33:22',NULL,NULL),(27382,17626,'AP','5129171071',0,'2014-01-14 01:32:30',NULL,NULL),(1910,1180,'TE','6143481184',0,'2013-12-25 18:19:22',NULL,NULL),(25510,16450,'AP','6627929280',0,'2014-01-07 04:05:23',NULL,NULL),(24182,15622,'EM','dafinaskinner@yahoo.com',1,'2014-01-02 04:33:13',NULL,NULL),(20650,13281,'AP','9152150011',0,'2013-12-26 12:57:12',NULL,NULL),(32949,21572,'TE','3307856060',0,'2014-02-05 21:30:21',NULL,NULL),(36100,23750,'TE','6143650483',0,'2014-02-14 21:31:06',NULL,NULL),(38487,25434,'EM','fongmay2715@gmail.com',0,'2014-02-25 21:31:17',NULL,NULL),(10823,7029,'AP','5129257669',0,'2013-12-26 01:49:05',NULL,NULL),(10694,6951,'TE','7403230650',0,'2013-12-26 01:47:02',NULL,NULL),(27933,17998,'EM','survivers8@gmail.com',0,'2014-01-15 02:06:59',NULL,NULL),(3765,2389,'TE','9376411267',0,'2013-12-25 19:33:14',NULL,NULL),(1980,1224,'AP','2345212972',0,'2013-12-25 18:20:30',NULL,NULL),(32405,21175,'TE','7404539446',0,'2014-02-03 21:00:40',NULL,NULL),(32765,21435,'AP','8324540140',0,'2014-02-04 21:01:21',NULL,NULL),(35808,23547,'TE','3187981942',0,'2014-02-13 22:02:36',NULL,NULL),(36508,24038,'TE','4403195585',0,'2014-02-15 22:00:56',NULL,NULL),(8368,5498,'EM','peggy@ericguilliod.com',0,'2013-12-25 23:11:16',NULL,NULL),(30206,19567,'TE','5043456792',0,'2014-01-23 03:02:35',NULL,NULL),(30179,19551,'AP','4193670972',0,'2014-01-23 03:02:29',NULL,NULL),(28210,18182,'TE','4198553868',0,'2014-01-15 02:08:01',NULL,NULL),(27793,17914,'AP','5124668369',0,'2014-01-15 02:06:28',NULL,NULL),(25280,16299,'TE','5048269016',0,'2014-01-07 04:01:06',NULL,NULL),(10782,7009,'AP','9565431465',0,'2013-12-26 01:48:29',NULL,NULL),(32566,21295,'AP','5044968680',0,'2014-02-04 21:00:09',NULL,NULL),(36550,24064,'EM','eaver.3@hotmail.com',0,'2014-02-15 22:01:11',NULL,NULL),(41330,27455,'EM','marciaberry84@gmail.com',0,'2014-03-04 21:02:02',NULL,NULL),(42840,28492,'TE','6016722180',0,'2014-03-07 21:31:42',NULL,NULL),(68,43,'EM','bkilby81@gmail.com',0,'2013-12-25 17:16:08',NULL,NULL),(31158,20291,'EM','niaphill@yahoo.com',0,'2014-01-28 21:00:36',NULL,NULL),(5573,3559,'EM','mikejo65@yahoo.com',0,'2013-12-25 21:22:16',NULL,NULL),(26407,16995,'TE','3308145779',0,'2014-01-13 02:20:27',NULL,NULL),(8208,5374,'AP','5049751766',0,'2013-12-25 23:08:10',NULL,NULL),(6182,3983,'EM','steventsims@yahoo.com',0,'2013-12-25 21:38:53',NULL,NULL),(5110,3276,'AP','5132254569',0,'2013-12-25 21:15:07',NULL,NULL),(6660,4322,'EM','whitehead4cleve@att.net',0,'2013-12-25 21:52:48',NULL,NULL),(6657,4321,'TE','5134172220',0,'2013-12-25 21:52:45',NULL,NULL),(5363,3434,'EM','rdozier2@msn.com',0,'2013-12-25 21:19:02',NULL,NULL),(36121,23774,'AP','6625280896',0,'2014-02-14 21:31:15',NULL,NULL),(37215,24492,'AP','9722683946',0,'2014-02-20 03:45:11',NULL,NULL),(21756,14012,'AP','9374744557',0,'2013-12-26 13:16:25',NULL,NULL),(28428,18315,'EM','mslynn44127@yahoo.com',0,'2014-01-16 08:45:05',NULL,NULL),(34124,22374,'AP','5139678334',0,'2014-02-10 21:30:04',NULL,NULL),(35771,23523,'EM','justintcoulter@gmail.com',0,'2014-02-13 22:02:22',NULL,NULL),(38721,25594,'TE','8326178898',0,'2014-02-26 08:00:45',NULL,NULL),(39438,26084,'AP','5043425498',0,'2014-02-28 06:30:05',NULL,NULL),(26608,17118,'TE','3305736766',0,'2014-01-13 02:21:41',NULL,NULL),(40692,27028,'AP','9032272343',0,'2014-03-03 21:00:15',NULL,NULL),(42686,28397,'TE','6147495197',0,'2014-03-07 21:30:48',NULL,NULL),(43099,28652,'TE','7408046051',0,'2014-03-08 21:30:38',NULL,NULL),(8966,5875,'EM','gshell@fuse.net',0,'2013-12-25 23:49:19',NULL,NULL),(28541,18401,'EM','acommarata@gmx.com',0,'2014-01-16 08:45:43',NULL,NULL),(25960,16722,'EM','joehkohn@yahoo.com',0,'2014-01-08 18:24:46',NULL,NULL),(23407,15078,'TE','9032685268',0,'2014-01-01 12:04:05',NULL,NULL),(7573,4929,'AP','5135264447',0,'2013-12-25 22:45:23',NULL,NULL),(22025,14185,'TE','9159207590',0,'2013-12-27 02:03:50',NULL,NULL),(6124,3941,'EM','ddrowne@prodigy.net',0,'2013-12-25 21:37:56',NULL,NULL),(35464,23324,'TE','5138910122',0,'2014-02-13 22:00:26',NULL,NULL),(37039,24391,'EM','jamielynn0206@gmail.com',0,'2014-02-18 22:00:49',NULL,NULL),(38260,25258,'TE','3307361490',0,'2014-02-22 19:00:11',NULL,NULL),(8881,5818,'AP','4699512349',0,'2013-12-25 23:47:56',NULL,NULL),(13762,8969,'AP','9376577200',0,'2013-12-26 04:04:03',NULL,NULL),(8430,5548,'TE','4194722033',0,'2013-12-25 23:16:03',NULL,NULL),(26548,17077,'TE','8063172028',0,'2014-01-13 02:21:21',NULL,NULL),(32924,21553,'TE','6149354861',0,'2014-02-05 21:30:15',NULL,NULL),(36338,23932,'AP','5133796661',0,'2014-02-15 21:00:04',NULL,NULL),(10075,6586,'TE','5138772174',0,'2013-12-26 00:53:06',NULL,NULL),(8682,5700,'TE','7692510815',0,'2013-12-25 23:32:53',NULL,NULL),(7639,4974,'TE','4093515357',0,'2013-12-25 22:46:32',NULL,NULL),(30871,20066,'EM','erinnicely@yahoo.com',0,'2014-01-27 21:00:14',NULL,NULL),(30629,19877,'AP','4403096313',0,'2014-01-24 21:00:44',NULL,NULL),(3269,2056,'TE','4407249719',0,'2013-12-25 19:16:01',NULL,NULL),(4476,2849,'EM','teresaandmary@yahoo.com',0,'2013-12-25 20:01:18',NULL,NULL),(23936,15445,'AP','7132317713',1,'2014-01-02 04:28:11',NULL,NULL),(4590,2929,'AP','3309584752',0,'2013-12-25 20:15:59',NULL,NULL),(33475,21929,'AP','9153735929',0,'2014-02-07 19:00:10',NULL,NULL),(39363,26035,'AP','5132070500',0,'2014-02-26 21:02:23',NULL,NULL),(39985,26480,'AP','9037071568',0,'2014-02-28 21:00:04',NULL,NULL),(14881,9739,'AP','8176818664',0,'2013-12-26 04:45:53',NULL,NULL),(31053,20202,'TE','5135187423',0,'2014-01-27 21:01:33',NULL,NULL),(2285,1401,'AP','7655058493',0,'2013-12-25 18:46:37',NULL,NULL),(26352,16961,'TE','3303222275',0,'2014-01-13 02:20:07',NULL,NULL);
INSERT INTO `EdiParticipantContact` VALUES (33544,21991,'AP','5047582252',0,'2014-02-07 19:00:42',NULL,NULL),(38933,25740,'TE','2162875370',0,'2014-02-26 09:30:39',NULL,NULL),(43670,28982,'TE','3303424511',0,'2014-03-10 21:01:10',NULL,NULL),(7116,4647,'TE','6019548849',0,'2013-12-25 22:06:56',NULL,NULL),(28644,18469,'BN','2257153592',0,'2014-01-16 08:46:17',NULL,NULL),(14548,9506,'TE','3304145743',0,'2013-12-26 04:35:16',NULL,NULL),(3514,2196,'EM','don@daytoncomputerrecycling.com',0,'2013-12-25 19:19:54',NULL,NULL),(23631,15260,'TE','9373827461',0,'2014-01-01 12:09:15',NULL,NULL),(22215,14321,'TE','4196514927',0,'2013-12-27 02:07:14',NULL,NULL),(3364,2114,'TE','2163741569',0,'2013-12-25 19:17:32',NULL,NULL),(37945,25038,'AP','4199100371',0,'2014-02-20 22:01:08',NULL,NULL),(1925,1192,'EM','donleyb1@udayton.edu',0,'2013-12-25 18:19:38',NULL,NULL),(31368,20445,'TE','2282193428',0,'2014-01-29 21:00:42',NULL,NULL),(4531,2881,'TE','8172260067',0,'2013-12-25 20:02:13',NULL,NULL),(26497,17051,'AP','4197019749',0,'2014-01-13 02:20:58',NULL,NULL),(14217,9302,'EM','ernestt@bright.net',0,'2013-12-26 04:16:26',NULL,NULL),(12101,7909,'EM','ojongernest@yahoo.fr',0,'2013-12-26 03:06:02',NULL,NULL),(20503,13201,'AP','9036038856',0,'2013-12-26 12:54:58',NULL,NULL),(38868,25689,'TE','4197541580',0,'2014-02-26 09:30:11',NULL,NULL),(40508,26884,'AP','5134045419',0,'2014-03-01 21:01:11',NULL,NULL),(41255,27413,'TE','4402898213',0,'2014-03-04 21:01:36',NULL,NULL),(42889,28524,'AP','5672958759',0,'2014-03-07 21:32:03',NULL,NULL),(10031,6562,'TE','8065842220',0,'2013-12-26 00:52:27',NULL,NULL),(31996,20889,'AP','5135198509',0,'2014-01-31 21:01:13',NULL,NULL),(11222,7301,'TE','3303147909',0,'2013-12-26 02:03:09',NULL,NULL),(27191,17511,'TE','3303736622',0,'2014-01-13 03:01:29',NULL,NULL),(26627,17132,'AP','3302244244',0,'2014-01-13 02:21:47',NULL,NULL),(1878,1158,'EM','kenvic11@cox.net',0,'2013-12-25 18:18:50',NULL,NULL),(26375,16976,'EM','kem.barrera@gmail.com',0,'2014-01-13 02:20:16',NULL,NULL),(6106,3931,'TE','4198227399',0,'2013-12-25 21:37:38',NULL,NULL),(6457,4170,'EM','pjssas82@embarqmail.com',0,'2013-12-25 21:49:13',NULL,NULL),(3376,2122,'AP','6145959798',0,'2013-12-25 19:17:45',NULL,NULL),(40871,27158,'TE','9373734415',0,'2014-03-03 21:30:57',NULL,NULL),(43340,28789,'EM','christigriffin@hotmail.com',0,'2014-03-09 21:00:41',NULL,NULL),(20725,13320,'EM','alirzarghouni@yahoo.com',0,'2013-12-26 12:58:21',NULL,NULL),(32453,21204,'AP','9855191082',0,'2014-02-03 21:00:55',NULL,NULL),(7249,4724,'AP','4193079081',0,'2013-12-25 22:09:01',NULL,NULL),(29948,19381,'AP','5126745889',1,'2014-01-22 03:22:42',NULL,NULL),(28685,18511,'TE','4193581530',0,'2014-01-16 08:46:33',NULL,NULL),(22682,14628,'TE','5138313571',0,'2013-12-28 03:37:07',NULL,NULL),(34553,22662,'AP','2144031008',0,'2014-02-11 21:00:35',NULL,NULL),(13680,8917,'AP','3305243819',0,'2013-12-26 04:02:44',NULL,NULL),(30158,19539,'EM','nathan.wehrmeister@gmail.com',0,'2014-01-23 03:02:24',NULL,NULL),(1876,1158,'TE','3373946924',0,'2013-12-25 18:18:49',NULL,NULL),(28402,18302,'TE','6143160459',0,'2014-01-16 08:44:57',NULL,NULL),(24457,15787,'AP','9852272426',0,'2014-01-03 02:02:22',NULL,NULL),(23624,15253,'TE','5672040859',0,'2014-01-01 12:09:01',NULL,NULL),(23428,15095,'TE','5132843332',0,'2014-01-01 12:04:33',NULL,NULL),(36327,23924,'EM','rgay001@neo.rr.com',0,'2014-02-14 22:00:08',NULL,NULL),(39681,26237,'AP','5129706493',0,'2014-02-28 06:31:03',NULL,NULL),(41381,27493,'AP','3306045399',0,'2014-03-04 21:02:23',NULL,NULL),(10996,7142,'AP','8176375594',0,'2013-12-26 01:51:55',NULL,NULL),(10473,6822,'AP','9375613803',0,'2013-12-26 01:30:36',NULL,NULL),(9046,5934,'TE','3372980103',0,'2013-12-25 23:50:37',NULL,NULL),(26878,17293,'EM','Danyeilhoy18@yahoo.com',0,'2014-01-13 02:23:34',NULL,NULL),(1048,645,'AP','9376846710',0,'2013-12-25 18:01:28',NULL,NULL),(7922,5163,'TE','6142842195',0,'2013-12-25 23:03:06',NULL,NULL),(7034,4594,'TE','4252701984',0,'2013-12-25 22:05:33',NULL,NULL),(4824,3088,'TE','9373213405',0,'2013-12-25 20:19:56',NULL,NULL),(27629,17810,'AP','7147877170',0,'2014-01-15 02:05:52',NULL,NULL),(29421,19021,'TE','6014979227',0,'2014-01-20 08:06:26',NULL,NULL),(29448,19041,'TE','5134810523',0,'2014-01-20 08:06:37',NULL,NULL),(31855,20796,'EM','ekercado51@verizon.net',0,'2014-01-31 21:00:18',NULL,NULL),(33689,22098,'TE','9374325869',0,'2014-02-08 19:00:28',NULL,NULL),(34500,22632,'TE','9362005361',0,'2014-02-11 21:00:18',NULL,NULL),(35241,23143,'EM','larmsey33@yahoo.com',0,'2014-02-12 21:31:37',NULL,NULL),(41245,27396,'AP','7407512901',0,'2014-03-04 21:01:30',NULL,NULL),(6872,4457,'EM','Kcscrapsforyou@yahoo.com',0,'2013-12-25 22:02:33',NULL,NULL),(1933,1197,'TE','7407954527',0,'2013-12-25 18:19:47',NULL,NULL),(25703,16570,'AP','4194100667',1,'2014-01-07 10:23:19',NULL,NULL),(24229,15655,'TE','2602239067',1,'2014-01-02 04:34:15',NULL,NULL),(20483,13192,'TE','8179663291',0,'2013-12-26 12:54:40',NULL,NULL),(32570,21297,'EM','77afine@gmail.com',0,'2014-02-04 21:00:10',NULL,NULL),(33280,21792,'AP','6148065661',0,'2014-02-06 21:00:45',NULL,NULL),(34293,22500,'TE','5135268888',0,'2014-02-10 21:31:13',NULL,NULL),(36984,24348,'AP','5129397078',0,'2014-02-18 22:00:25',NULL,NULL),(42313,28097,'TE','6016616387',0,'2014-03-06 21:02:08',NULL,NULL),(42682,28395,'TE','6143777740',0,'2014-03-07 21:30:47',NULL,NULL),(669,418,'AP','5134629353',0,'2013-12-25 17:46:34',NULL,NULL),(27176,17498,'EM','hpickett40@yahoo.com',0,'2014-01-13 03:01:24',NULL,NULL),(811,505,'TE','4406384574',0,'2013-12-25 17:48:48',NULL,NULL),(14202,9289,'EM','mailjasonsmith@gmail.com',0,'2013-12-26 04:16:08',NULL,NULL),(24655,15896,'EM','bgeef560sl@frontier.com',0,'2014-01-03 02:05:56',NULL,NULL),(29710,19209,'EM','jgchop@att.net',0,'2014-01-21 08:46:21',NULL,NULL),(42740,28426,'EM','Bchaffin14@yahoo.com',0,'2014-03-07 21:31:06',NULL,NULL),(8046,5265,'TE','3305643504',0,'2013-12-25 23:05:28',NULL,NULL),(6991,4566,'AP','4095270575',0,'2013-12-25 22:04:50',NULL,NULL),(13846,9028,'EM','karenjacob1407@gmail.com',0,'2013-12-26 04:05:30',NULL,NULL),(26957,17337,'TE','5042360180',0,'2014-01-13 02:24:00',NULL,NULL),(25019,16122,'AP','5042840620',0,'2014-01-04 02:05:27',NULL,NULL),(24961,16089,'TE','6013765794',0,'2014-01-04 02:04:21',NULL,NULL),(14092,9215,'TE','5136673696',0,'2013-12-26 04:10:01',NULL,NULL),(38833,25669,'TE','6018268218',0,'2014-02-26 08:30:51',NULL,NULL),(39816,26329,'EM','astronus85@gmail.com',0,'2014-02-28 06:31:40',NULL,NULL),(42122,27983,'AP','3373099419',0,'2014-03-06 21:00:58',NULL,NULL),(1354,827,'AP','3302035925',0,'2013-12-25 18:06:14',NULL,NULL),(21927,14126,'AP','5042960333',0,'2013-12-27 02:02:15',NULL,NULL),(29382,18987,'AP','2165380195',0,'2014-01-20 08:06:10',NULL,NULL),(30117,19508,'AP','2146723934',0,'2014-01-23 03:02:13',NULL,NULL),(32905,21544,'TE','2163133858',0,'2014-02-05 21:30:10',NULL,NULL),(35843,23568,'TE','6015400181',0,'2014-02-13 22:02:49',NULL,NULL),(38814,25660,'EM','DHAMIGS@GMAIL.COM',0,'2014-02-26 08:30:45',NULL,NULL),(39692,26249,'TE','4095945922',0,'2014-02-28 06:31:08',NULL,NULL),(8622,5663,'AP','3307302612',0,'2013-12-25 23:31:51',NULL,NULL),(11158,7254,'TE','9373861942',0,'2013-12-26 02:02:02',NULL,NULL),(5032,3227,'TE','3309573056',0,'2013-12-25 20:45:57',NULL,NULL),(14328,9368,'AP','2253549139',0,'2013-12-26 04:31:44',NULL,NULL),(12258,8015,'AP','9375097815',0,'2013-12-26 03:08:45',NULL,NULL),(32212,21038,'AP','3303515918',0,'2014-02-01 19:00:49',NULL,NULL),(33655,22074,'TE','5044349798',0,'2014-02-08 19:00:15',NULL,NULL),(34082,22342,'TE','4402326757',0,'2014-02-10 11:01:09',NULL,NULL),(34404,22567,'EM','NewCamus2@yahoo.com',0,'2014-02-10 21:31:54',NULL,NULL),(38689,25568,'AP','2162585972',0,'2014-02-26 08:00:28',NULL,NULL),(41815,27799,'TE','3306663876',0,'2014-03-05 21:31:45',NULL,NULL),(42581,28333,'EM','chaimebreaux84@gmail.com',0,'2014-03-07 21:30:12',NULL,NULL),(43603,28948,'AP','3373083851',0,'2014-03-10 21:00:48',NULL,NULL),(111,67,'TE','2162124469',0,'2013-12-25 17:16:48',NULL,NULL),(29025,18740,'TE','9373291991',0,'2014-01-17 03:35:40',NULL,NULL),(10285,6714,'AP','9017862039',0,'2013-12-26 01:02:22',NULL,NULL),(8537,5607,'AP','2168490820',0,'2013-12-25 23:30:28',NULL,NULL),(21387,13753,'EM','angela.l.kelly26@gmail.com',0,'2013-12-26 13:10:00',NULL,NULL),(24395,15751,'EM','IGOTBREAD2@AOL.COM',0,'2014-01-03 02:01:11',NULL,NULL),(23782,15338,'TE','3309276600',1,'2014-01-02 04:24:09',NULL,NULL),(22310,14383,'TE','6145841742',0,'2013-12-28 03:30:48',NULL,NULL),(36345,23935,'AP','2163968303',0,'2014-02-15 21:00:06',NULL,NULL),(37867,24980,'AP','8325331909',0,'2014-02-20 22:00:33',NULL,NULL),(37992,25062,'EM','thoganhaas@aol.com',0,'2014-02-20 22:01:25',NULL,NULL),(43965,29167,'AP','4402253062',0,'2014-03-10 21:02:57',NULL,NULL),(2464,1512,'TE','6147324733',0,'2013-12-25 18:49:33',NULL,NULL),(11689,7609,'EM','bharvey@huntzingerstaffing.com',0,'2013-12-26 02:45:36',NULL,NULL),(12310,8050,'TE','4198104555',0,'2013-12-26 03:09:40',NULL,NULL),(22245,14335,'TE','9375480930',0,'2013-12-27 02:07:43',NULL,NULL),(22089,14229,'TE','8179963237',0,'2013-12-27 02:04:56',NULL,NULL),(22044,14196,'AP','8065188679',0,'2013-12-27 02:04:09',NULL,NULL),(13559,8842,'TE','5127759875',0,'2013-12-26 04:00:46',NULL,NULL),(34110,22360,'EM','jessamyn.farkas@gmail.com',0,'2014-02-10 21:00:07',NULL,NULL),(41057,27277,'TE','2107766416',0,'2014-03-04 21:00:20',NULL,NULL),(42439,28187,'TE','5133131842',0,'2014-03-06 21:02:58',NULL,NULL),(43636,28964,'TE','8326470939',0,'2014-03-10 21:00:58',NULL,NULL),(12311,8050,'AP','4198104555',0,'2013-12-26 03:09:40',NULL,NULL),(28388,18289,'AP','2165710638',0,'2014-01-16 08:44:51',NULL,NULL),(9005,5910,'AP','4693371243',0,'2013-12-25 23:50:00',NULL,NULL),(29729,19225,'AP','4194945664',0,'2014-01-21 08:46:29',NULL,NULL),(41700,27727,'EM','lisacoots87@yahoo.com',0,'2014-03-05 21:31:02',NULL,NULL),(23839,15381,'TE','3305907418',1,'2014-01-02 04:25:26',NULL,NULL),(29895,19345,'BN','3305099687',1,'2014-01-22 03:22:23',NULL,NULL),(31359,20438,'TE','5133867370',0,'2014-01-29 21:00:39',NULL,NULL),(33928,22266,'BN','4322716877',0,'2014-02-10 11:00:11',NULL,NULL),(34350,22533,'EM','Qdo178@gmail.com',0,'2014-02-10 21:31:34',NULL,NULL),(35166,23098,'EM','JROCKETSP@AOL.COM',0,'2014-02-12 21:31:10',NULL,NULL),(36375,23956,'AP','9728340409',0,'2014-02-15 22:00:07',NULL,NULL),(39032,25811,'AP','9375591658',0,'2014-02-26 21:00:22',NULL,NULL),(40045,26550,'TE','5139794292',0,'2014-02-28 21:30:12',NULL,NULL),(40587,26937,'AP','5135185732',0,'2014-03-03 01:00:22',NULL,NULL),(42429,28182,'TE','4197053156',0,'2014-03-06 21:02:54',NULL,NULL),(43999,29192,'AP','5043432299',0,'2014-03-10 21:30:06',NULL,NULL),(464,292,'AP','3303223866',0,'2013-12-25 17:30:36',NULL,NULL),(9484,6206,'AP','4197730331',0,'2013-12-26 00:30:45',NULL,NULL),(3109,1939,'EM','sinera.mccoy@yahoo.com',0,'2013-12-25 19:00:37',NULL,NULL),(5445,3487,'AP','9376686414',0,'2013-12-25 21:20:20',NULL,NULL),(37670,24838,'TE','6017204171',0,'2014-02-20 04:53:28',NULL,NULL),(39586,26187,'TE','5135536345',0,'2014-02-28 06:30:43',NULL,NULL),(31331,20416,'EM','SINDYROBBINS01@GMAIL.COM',0,'2014-01-29 21:00:28',NULL,NULL),(32075,20945,'AP','9032888600',0,'2014-01-31 21:01:45',NULL,NULL),(32182,21019,'TE','3306593244',0,'2014-02-01 19:00:39',NULL,NULL),(33872,22233,'AP','2814135750',0,'2014-02-09 19:00:33',NULL,NULL),(42428,28178,'TE','5137341425',0,'2014-03-06 21:02:53',NULL,NULL),(8631,5668,'EM','l-rockett@hotmail.com',0,'2013-12-25 23:31:59',NULL,NULL),(24607,15870,'TE','6624699668',0,'2014-01-03 02:05:04',NULL,NULL),(6303,4062,'AP','2163552293',0,'2013-12-25 21:46:43',NULL,NULL),(8205,5372,'TE','5132920848',0,'2013-12-25 23:08:06',NULL,NULL),(43550,28915,'AP','5135157325',0,'2014-03-10 21:00:28',NULL,NULL),(7511,4894,'TE','2284472824',0,'2013-12-25 22:31:37',NULL,NULL),(27927,17992,'EM','DEBRA_1775@SBCGLOBAL.NET',0,'2014-01-15 02:06:57',NULL,NULL),(22737,14664,'TE','2812659140',1,'2013-12-29 11:08:04',NULL,NULL),(6576,4245,'TE','2812424761',0,'2013-12-25 21:51:08',NULL,NULL),(13738,8953,'EM','cmbs1234@ohiohills.com',0,'2013-12-26 04:03:39',NULL,NULL),(35618,23421,'EM','herberthughes@sbcglobal.net',0,'2014-02-13 22:01:23',NULL,NULL),(39896,26403,'AP','4193029638',0,'2014-02-28 07:00:32',NULL,NULL),(41890,27854,'AP','5129392283',0,'2014-03-05 21:32:14',NULL,NULL),(42307,28091,'TE','6624199554',0,'2014-03-06 21:02:05',NULL,NULL),(43498,28883,'AP','2546330885',0,'2014-03-10 21:00:10',NULL,NULL),(11143,7245,'TE','2253309190',0,'2013-12-26 02:01:46',NULL,NULL),(22209,14313,'EM','sweet_thing0799@yahoo.com',0,'2013-12-27 02:07:05',NULL,NULL),(35211,23126,'TE','3303131206',0,'2014-02-12 21:31:27',NULL,NULL),(38228,25236,'TE','5672037597',0,'2014-02-21 22:01:05',NULL,NULL),(41805,27791,'TE','6019492763',0,'2014-03-05 21:31:40',NULL,NULL),(7419,4822,'EM','rpoint96@yahoo.com',0,'2013-12-25 22:17:09',NULL,NULL),(27122,17461,'BN','4199694682',0,'2014-01-13 03:00:43',NULL,NULL),(4393,2798,'EM','lmberry@neo.rr.com',0,'2013-12-25 19:50:21',NULL,NULL),(20753,13338,'EM','MARCY_FERNANDEZ@YAHOO.COM',0,'2013-12-26 12:58:49',NULL,NULL),(14592,9542,'TE','9373196319',0,'2013-12-26 04:36:03',NULL,NULL),(1544,949,'EM','marimbaman01@gmail.com',0,'2013-12-25 18:09:32',NULL,NULL),(10323,6733,'TE','2163968218',0,'2013-12-26 01:15:33',NULL,NULL),(11625,7561,'AP','4198227399',0,'2013-12-26 02:33:30',NULL,NULL),(12281,8033,'EM','maryjo1953@hotmail.com',0,'2013-12-26 03:09:13',NULL,NULL),(12426,8138,'TE','9377370039',0,'2013-12-26 03:15:44',NULL,NULL),(3502,2189,'AP','9376614447',0,'2013-12-25 19:19:41',NULL,NULL),(35821,23554,'EM','bgilene@cinci.rr.com',0,'2014-02-13 22:02:41',NULL,NULL),(37112,24432,'EM','gnt333@neohio.twcbc.com',0,'2014-02-18 22:01:14',NULL,NULL),(40302,26735,'TE','5138293508',0,'2014-02-28 21:31:51',NULL,NULL),(43858,29104,'AP','9547343642',0,'2014-03-10 21:02:19',NULL,NULL),(11339,7387,'TE','6147361100',0,'2013-12-26 02:16:03',NULL,NULL),(489,312,'TE','5049152244',0,'2013-12-25 17:31:04',NULL,NULL),(27248,17543,'TE','3302686163',0,'2014-01-13 03:01:50',NULL,NULL),(25541,16477,'TE','3308961797',0,'2014-01-07 04:06:08',NULL,NULL),(5901,3785,'AP','9375649179',0,'2013-12-25 21:34:05',NULL,NULL),(5546,3543,'TE','9729861471',0,'2013-12-25 21:21:51',NULL,NULL),(32099,20963,'AP','9152695280',0,'2014-02-01 19:00:10',NULL,NULL),(38473,25425,'AP','6142030130',0,'2014-02-25 21:31:11',NULL,NULL),(39222,25944,'TE','6142030130',0,'2014-02-26 21:01:32',NULL,NULL),(7699,5023,'TE','9372160064',0,'2013-12-25 22:47:36',NULL,NULL),(27725,17871,'TE','9378966150',0,'2014-01-15 02:06:14',NULL,NULL),(29524,19083,'EM','udpatel2@gmail.com',0,'2014-01-21 08:44:28',NULL,NULL),(31842,20788,'AP','2817934380',0,'2014-01-31 21:00:14',NULL,NULL),(31876,20807,'AP','8325428012',0,'2014-01-31 21:00:25',NULL,NULL),(31992,20888,'TE','2167732490',0,'2014-01-31 21:01:12',NULL,NULL),(34057,22329,'EM','greco310@gmail.com',0,'2014-02-10 11:01:00',NULL,NULL),(37065,24406,'AP','7408197187',0,'2014-02-18 22:00:58',NULL,NULL),(9264,6063,'TE','3308477768',0,'2013-12-26 00:02:00',NULL,NULL),(29040,18751,'AP','4193358901',0,'2014-01-17 03:35:43',NULL,NULL),(28121,18126,'AP','3302649051',0,'2014-01-15 02:07:42',NULL,NULL),(35999,23682,'EM','dorianspeaks@gmail.com',0,'2014-02-14 21:30:32',NULL,NULL),(37347,24589,'TE','2167121160',0,'2014-02-20 04:10:24',NULL,NULL),(41770,27773,'EM','davand1979@gmail.com',0,'2014-03-05 21:31:28',NULL,NULL),(8071,5284,'TE','3306883392',0,'2013-12-25 23:05:52',NULL,NULL),(4763,3050,'EM','chsarc5@bellsouth.net',0,'2013-12-25 20:18:53',NULL,NULL),(28623,18454,'TE','5044003429',0,'2014-01-16 08:46:09',NULL,NULL),(26607,17117,'EM','hunt0921@gmail.com',0,'2014-01-13 02:21:40',NULL,NULL),(25977,16734,'TE','3304350250',0,'2014-01-08 18:24:50',NULL,NULL),(25769,16605,'AP','5043388812',0,'2014-01-08 18:24:06',NULL,NULL),(22018,14181,'TE','5125549826',0,'2013-12-27 02:03:43',NULL,NULL),(14722,9631,'TE','4195156274',0,'2013-12-26 04:38:13',NULL,NULL),(5577,3561,'EM','klf1224@att.net',0,'2013-12-25 21:22:19',NULL,NULL),(34433,22588,'EM','diamond.ae@pg.com',0,'2014-02-10 21:32:07',NULL,NULL),(37739,24894,'AP','3309296766',0,'2014-02-20 05:39:48',NULL,NULL),(38327,25321,'EM','DUCOTE.2020@GMAIL.COM',0,'2014-02-25 21:30:09',NULL,NULL),(2521,1544,'TE','4128749395',0,'2013-12-25 18:50:24',NULL,NULL),(30382,19684,'AP','9038181137',0,'2014-01-23 21:00:39',NULL,NULL),(2113,1304,'EM','crystal_standokes@yahoo.com',0,'2013-12-25 18:31:17',NULL,NULL),(25346,16347,'TE','7246506670',0,'2014-01-07 04:02:23',NULL,NULL),(9978,6531,'AP','2542052894',0,'2013-12-26 00:51:39',NULL,NULL),(14630,9562,'EM','Suepushkaran@yahoo.com',0,'2013-12-26 04:36:37',NULL,NULL),(32392,21165,'TE','4403194352',0,'2014-02-03 21:00:35',NULL,NULL),(34273,22486,'EM','chipgraf@yahoo.com',0,'2014-02-10 21:31:05',NULL,NULL),(42630,28360,'TE','9156670797',0,'2014-03-07 21:30:28',NULL,NULL),(877,544,'AP','3309627125',0,'2013-12-25 17:49:50',NULL,NULL),(10246,6698,'TE','5134014181',0,'2013-12-26 01:01:49',NULL,NULL),(25691,16562,'TE','4197954281',1,'2014-01-07 10:23:05',NULL,NULL),(31605,20615,'TE','3376851523',0,'2014-01-30 21:00:20',NULL,NULL),(434,267,'EM','mikecole51@oh.rr.com',0,'2013-12-25 17:22:00',NULL,NULL),(29590,19119,'AP','9853512608',0,'2014-01-21 08:45:16',NULL,NULL),(13759,8968,'TE','8644040402',0,'2013-12-26 04:04:01',NULL,NULL),(26538,17072,'TE','3615754308',0,'2014-01-13 02:21:18',NULL,NULL),(1322,808,'TE','4409987980',0,'2013-12-25 18:05:45',NULL,NULL),(11041,7164,'EM','Revquincy@aol.com',0,'2013-12-26 01:52:35',NULL,NULL),(24658,15898,'EM','thines242003@yahoo.com',0,'2014-01-03 02:05:59',NULL,NULL),(24108,15562,'EM','scavenger08@embarqmail.com',1,'2014-01-02 04:31:38',NULL,NULL),(9160,5998,'AP','2149987144',0,'2013-12-26 00:00:16',NULL,NULL),(8243,5391,'EM','bmb108@yahoo.com',0,'2013-12-25 23:08:41',NULL,NULL),(35689,23474,'EM','gon4ward@sbcglobal.net',0,'2014-02-13 22:01:50',NULL,NULL),(40539,26905,'AP','2254052008',0,'2014-03-03 01:00:09',NULL,NULL),(42287,28081,'AP','2146767481',0,'2014-03-06 21:01:57',NULL,NULL),(43684,28998,'TE','4195771906',0,'2014-03-10 21:01:17',NULL,NULL),(2010,1244,'TE','2163713101',0,'2013-12-25 18:21:02',NULL,NULL),(11543,7513,'EM','JLUKEBROWN@GMAIL.COM',0,'2013-12-26 02:32:10',NULL,NULL),(27752,17892,'TE','3306908022',0,'2014-01-15 02:06:20',NULL,NULL),(26301,16929,'AP','5045782709',0,'2014-01-13 02:19:48',NULL,NULL),(25036,16133,'AP','3306389979',0,'2014-01-04 02:05:47',NULL,NULL),(4655,2975,'TE','9037465949',0,'2013-12-25 20:17:05',NULL,NULL),(20985,13506,'TE','3185103083',0,'2013-12-26 13:02:45',NULL,NULL),(10032,6562,'AP','8065842220',0,'2013-12-26 00:52:27',NULL,NULL),(9261,6061,'TE','2162675058',0,'2013-12-26 00:01:57',NULL,NULL),(31521,20541,'TE','4195369028',0,'2014-01-29 21:01:36',NULL,NULL),(38984,25780,'TE','3306184099',0,'2014-02-26 09:31:01',NULL,NULL),(39675,26234,'AP','9104675440',0,'2014-02-28 06:31:02',NULL,NULL),(40678,27011,'EM','trustplus1@icloud.com',0,'2014-03-03 21:00:07',NULL,NULL),(6031,3874,'TE','5043456045',0,'2013-12-25 21:36:16',NULL,NULL),(2387,1455,'TE','4405390392',0,'2013-12-25 18:48:10',NULL,NULL),(28315,18251,'TE','9035705660',0,'2014-01-16 08:44:31',NULL,NULL),(2782,1685,'EM','chapman_theodora@yahoo.com',0,'2013-12-25 18:54:17',NULL,NULL),(21039,13536,'TE','3182834485',0,'2013-12-26 13:03:37',NULL,NULL),(4113,2624,'TE','5137910594',0,'2013-12-25 19:45:57',NULL,NULL),(31242,20346,'TE','6628340159',0,'2014-01-28 21:01:11',NULL,NULL),(41414,27515,'TE','2166826724',0,'2014-03-04 21:02:35',NULL,NULL),(43166,28686,'EM','nathanlee493@gmail.com',0,'2014-03-08 21:31:00',NULL,NULL),(43260,28743,'AP','5635031050',0,'2014-03-09 21:00:11',NULL,NULL),(13979,9118,'EM','CHILDOFBARB@HOTMAIL.COM',0,'2013-12-26 04:07:43',NULL,NULL),(116,69,'TE','5138513152',0,'2013-12-25 17:16:52',NULL,NULL),(11890,7737,'EM','barbaramasonva@yahoo.com',0,'2013-12-26 03:02:10',NULL,NULL),(10888,7076,'TE','9379015783',0,'2013-12-26 01:50:11',NULL,NULL),(5736,3676,'EM','rwoolum@earthlink.net',0,'2013-12-25 21:31:21',NULL,NULL),(5286,3391,'TE','4405208832',0,'2013-12-25 21:17:50',NULL,NULL),(36985,24348,'EM','thomasblair81@yahoo.com',0,'2014-02-18 22:00:25',NULL,NULL),(37768,24925,'AP','6013474332',0,'2014-02-20 21:30:16',NULL,NULL),(43315,28775,'TE','4199895469',0,'2014-03-09 21:00:32',NULL,NULL),(13585,8857,'AP','2146821692',0,'2013-12-26 04:01:11',NULL,NULL),(6487,4197,'AP','3304724801',0,'2013-12-25 21:49:47',NULL,NULL),(1643,1008,'EM','magnum1321@aol.com',0,'2013-12-25 18:11:10',NULL,NULL),(24262,15681,'TE','4194942498',1,'2014-01-02 04:34:59',NULL,NULL),(23003,14837,'TE','5132640033',1,'2013-12-29 11:14:44',NULL,NULL),(2498,1533,'TE','3306672923',0,'2013-12-25 18:50:04',NULL,NULL),(2389,1455,'EM','annamariepam@gmail.com',0,'2013-12-25 18:48:11',NULL,NULL),(34711,22758,'TE','5139316564',0,'2014-02-11 21:01:31',NULL,NULL),(38980,25778,'TE','5043046704',0,'2014-02-26 09:30:59',NULL,NULL),(42663,28382,'AP','2162256840',0,'2014-03-07 21:30:40',NULL,NULL),(43695,29004,'AP','3309511349',0,'2014-03-10 21:01:21',NULL,NULL),(143,85,'EM','dkukielski@roadrunner.com',0,'2013-12-25 17:17:16',NULL,NULL),(9996,6541,'TE','8173373898',0,'2013-12-26 00:51:55',NULL,NULL),(28910,18663,'TE','9563552312',0,'2014-01-17 03:35:14',NULL,NULL),(5885,3774,'EM','karenjacob1407@gmail.com',0,'2013-12-25 21:33:48',NULL,NULL),(24144,15596,'EM','rarledg3@columbus.rr.com',1,'2014-01-02 04:32:32',NULL,NULL),(33651,22070,'BN','8172711441',0,'2014-02-08 19:00:14',NULL,NULL),(35319,23206,'EM','maciasg74@gmail.com',0,'2014-02-12 21:32:11',NULL,NULL),(37273,24527,'TE','3618527663',0,'2014-02-20 03:59:33',NULL,NULL),(6544,4230,'TE','9036437243',0,'2013-12-25 21:50:42',NULL,NULL),(29020,18735,'EM','LFORAKER001@COLUMBUS.RR.COM',0,'2014-01-17 03:35:38',NULL,NULL),(28881,18646,'EM','Josh.barker@yahoo.com',0,'2014-01-17 03:35:08',NULL,NULL),(2869,1754,'EM','jluft7@sbcglobal.net',0,'2013-12-25 18:55:48',NULL,NULL),(25984,16742,'TE','3306047774',0,'2014-01-08 18:24:52',NULL,NULL),(25780,16612,'EM','jpautex@hotmail.com',0,'2014-01-08 18:24:08',NULL,NULL),(25285,16304,'AP','5044101052',0,'2014-01-07 04:01:14',NULL,NULL),(20475,13188,'AP','7138185092',0,'2013-12-26 12:54:33',NULL,NULL),(31475,20510,'EM','ltedeton@gmail.com',0,'2014-01-29 21:01:19',NULL,NULL),(32492,21230,'TE','4408923603',0,'2014-02-03 21:01:09',NULL,NULL),(34455,22604,'TE','5133511150',0,'2014-02-10 21:32:17',NULL,NULL),(35905,23625,'TE','3307279204',0,'2014-02-13 22:03:19',NULL,NULL),(7633,4972,'TE','8327218219',0,'2013-12-25 22:46:29',NULL,NULL),(30042,19457,'AP','2147700487',0,'2014-01-23 03:01:55',NULL,NULL),(29974,19396,'TE','2162526640',1,'2014-01-22 03:22:50',NULL,NULL),(23531,15184,'EM','bersee_utz@yahoo.com',0,'2014-01-01 12:06:55',NULL,NULL),(6704,4359,'EM','patq8767@yahoo.com',0,'2013-12-25 21:53:42',NULL,NULL),(6172,3976,'AP','4192307329',0,'2013-12-25 21:38:44',NULL,NULL),(2539,1553,'EM','s_cubley@yahoo.com',0,'2013-12-25 18:50:41',NULL,NULL),(3989,2533,'AP','9374891389',0,'2013-12-25 19:36:51',NULL,NULL),(30944,20125,'TE','9372780775',0,'2014-01-27 21:00:48',NULL,NULL),(32297,21095,'TE','5138363775',0,'2014-02-02 19:00:31',NULL,NULL),(32936,21557,'EM','nose78@yahoo.com',0,'2014-02-05 21:30:17',NULL,NULL),(33120,21695,'AP','3309070379',0,'2014-02-05 21:31:08',NULL,NULL),(41797,27786,'AP','6624021292',0,'2014-03-05 21:31:37',NULL,NULL),(6500,4203,'TE','4323642449',0,'2013-12-25 21:49:58',NULL,NULL),(3052,1899,'TE','5405250368',0,'2013-12-25 18:59:05',NULL,NULL),(26702,17177,'TE','6149990535',0,'2014-01-13 02:22:11',NULL,NULL),(9244,6049,'EM','spartahill1@gmail.com',0,'2013-12-26 00:01:38',NULL,NULL),(20837,13392,'TE','7405914287',0,'2013-12-26 13:00:12',NULL,NULL),(23664,15281,'AP','7409700854',1,'2014-01-02 04:22:08',NULL,NULL),(40081,26581,'EM','OUSLEYC@YMAIL.COM',0,'2014-02-28 21:30:30',NULL,NULL),(41889,27854,'TE','5129392283',0,'2014-03-05 21:32:14',NULL,NULL),(42734,28422,'EM','tsb8@hotmail.com',0,'2014-03-07 21:31:04',NULL,NULL),(14668,9596,'AP','4403194436',0,'2013-12-26 04:37:18',NULL,NULL),(12359,8090,'TE','4193084532',0,'2013-12-26 03:10:40',NULL,NULL),(3478,2179,'AP','4197227269',0,'2013-12-25 19:19:20',NULL,NULL),(14983,9804,'AP','9375644234',0,'2013-12-26 05:01:19',NULL,NULL),(25624,16525,'TE','4105624782',1,'2014-01-07 10:21:53',NULL,NULL),(21953,14140,'EM','taugust51@aol.com',0,'2013-12-27 02:02:39',NULL,NULL),(35588,23406,'AP','6143768174',0,'2014-02-13 22:01:12',NULL,NULL),(36608,24101,'AP','3613188106',0,'2014-02-15 22:01:31',NULL,NULL),(37137,24446,'EM','sheila99@fuse.net',0,'2014-02-18 22:01:23',NULL,NULL),(39097,25868,'TE','3377810337',0,'2014-02-26 21:00:49',NULL,NULL),(447,277,'TE','2813859621',0,'2013-12-25 17:30:12',NULL,NULL),(27229,17530,'TE','6012580014',0,'2014-01-13 03:01:42',NULL,NULL),(25527,16464,'AP','9376181999',0,'2014-01-07 04:05:46',NULL,NULL),(6763,4389,'AP','5133493433',0,'2013-12-25 22:00:50',NULL,NULL),(3101,1934,'AP','2142779065',0,'2013-12-25 19:00:29',NULL,NULL),(20700,13307,'AP','9033916977',0,'2013-12-26 12:57:58',NULL,NULL),(4727,3024,'EM','khasley@sbcglobal.net',0,'2013-12-25 20:18:15',NULL,NULL),(32206,21035,'AP','5132848773',0,'2014-02-01 19:00:47',NULL,NULL),(32249,21061,'EM','whitton_40@yahoo.com',0,'2014-02-02 19:00:12',NULL,NULL),(32252,21063,'AP','4193089015',0,'2014-02-02 19:00:13',NULL,NULL),(34943,22935,'TE','2257154798',0,'2014-02-11 21:30:14',NULL,NULL),(38600,25506,'EM','wjmeeks@att.net',0,'2014-02-25 21:31:59',NULL,NULL),(41582,27646,'EM','maggiemcc2005@yahoo.com',0,'2014-03-05 21:30:19',NULL,NULL),(8524,5602,'TE','4408329234',0,'2013-12-25 23:30:18',NULL,NULL),(28286,18235,'AP','8326963895',0,'2014-01-16 08:44:22',NULL,NULL),(1422,867,'TE','3303127825',0,'2013-12-25 18:07:21',NULL,NULL),(27825,17930,'AP','2147345383',0,'2014-01-15 02:06:35',NULL,NULL),(31532,20548,'AP','5134100394',0,'2014-01-29 21:01:40',NULL,NULL),(35881,23595,'EM','tlnsandmrp@aol.com',0,'2014-02-13 22:03:05',NULL,NULL),(37775,24929,'AP','3307150439',0,'2014-02-20 21:30:19',NULL,NULL),(43847,29099,'AP','5134036830',0,'2014-03-10 21:02:15',NULL,NULL),(14689,9611,'AP','3308604523',0,'2013-12-26 04:37:40',NULL,NULL),(25644,16538,'EM','thequeenbabs@neo.rr.com',1,'2014-01-07 10:22:16',NULL,NULL),(8175,5347,'TE','3302625459',0,'2013-12-25 23:07:33',NULL,NULL),(23758,15325,'TE','7134106030',1,'2014-01-02 04:23:43',NULL,NULL),(7149,4661,'EM','joyce9994@att.net',0,'2013-12-25 22:07:24',NULL,NULL),(20936,13465,'AP','5132121647',0,'2013-12-26 13:01:52',NULL,NULL),(3695,2342,'EM','texasartboy@aol.com',0,'2013-12-25 19:32:00',NULL,NULL),(34136,22380,'EM','aecassiday@att.net',0,'2014-02-10 21:30:09',NULL,NULL),(34765,22801,'TE','2346878423',0,'2014-02-11 21:01:53',NULL,NULL),(37388,24622,'TE','6019830020',0,'2014-02-20 04:16:16',NULL,NULL),(9962,6519,'AP','5134854408',0,'2013-12-26 00:51:21',NULL,NULL),(27920,17988,'EM','burtonrashaad@yahoo.com',0,'2014-01-15 02:06:56',NULL,NULL),(27698,17852,'BN','2163080344',0,'2014-01-15 02:06:07',NULL,NULL),(27346,17608,'TE','9036853005',0,'2014-01-14 01:32:20',NULL,NULL),(8472,5574,'TE','3048120595',0,'2013-12-25 23:16:46',NULL,NULL),(6617,4275,'EM','ecollier@fuse.net',0,'2013-12-25 21:51:53',NULL,NULL),(4227,2704,'AP','9034713638',0,'2013-12-25 19:47:48',NULL,NULL),(32273,21082,'EM','klaas@roadrunner.com',0,'2014-02-02 19:00:23',NULL,NULL),(35301,23187,'AP','4406685493',0,'2014-02-12 21:32:02',NULL,NULL),(6040,3880,'TE','5046100270',0,'2013-12-25 21:36:25',NULL,NULL),(27213,17523,'TE','5132420124',0,'2014-01-13 03:01:37',NULL,NULL),(3951,2509,'TE','4196196626',0,'2013-12-25 19:36:14',NULL,NULL),(31209,20322,'AP','9158868805',0,'2014-01-28 21:00:57',NULL,NULL),(34580,22675,'AP','2542142151',0,'2014-02-11 21:00:44',NULL,NULL),(39804,26321,'AP','6628081813',0,'2014-02-28 06:31:37',NULL,NULL),(43892,29122,'TE','3148087930',0,'2014-03-10 21:02:31',NULL,NULL),(6843,4437,'EM','mhanzel@live.com',0,'2013-12-25 22:02:05',NULL,NULL),(29266,18901,'EM','sandy71649@hotmail.com',0,'2014-01-17 03:36:36',NULL,NULL),(28052,18078,'EM','Brierleyjanell@yahoo.com',0,'2014-01-15 02:07:26',NULL,NULL),(26203,16865,'TE','3617423217',0,'2014-01-13 02:19:13',NULL,NULL),(14801,9687,'EM','beam@bright.net',0,'2013-12-26 04:39:37',NULL,NULL),(9321,6102,'EM','ddbreest@hotmail.com',0,'2013-12-26 00:15:15',NULL,NULL),(2883,1765,'TE','3103467943',0,'2013-12-25 18:56:00',NULL,NULL),(2619,1593,'AP','2546243723',0,'2013-12-25 18:51:50',NULL,NULL),(31897,20817,'EM','Brenthalomew@hotmail.com',0,'2014-01-31 21:00:33',NULL,NULL),(40828,27132,'AP','3303047679',0,'2014-03-03 21:30:41',NULL,NULL),(41618,27668,'TE','2545926823',0,'2014-03-05 21:30:32',NULL,NULL),(41914,27868,'EM','rdierking@sibcycline.com',0,'2014-03-05 21:32:23',NULL,NULL),(1581,975,'EM','countrybear050@bellsouth.net',0,'2013-12-25 18:10:07',NULL,NULL),(28445,18326,'EM','amy1476@hotmail.com',0,'2014-01-16 08:45:10',NULL,NULL),(26704,17177,'EM','SLDAVIS3332@YAHOO.COM',0,'2014-01-13 02:22:11',NULL,NULL),(21945,14136,'TE','5043824886',0,'2013-12-27 02:02:32',NULL,NULL),(33892,22244,'EM','jan.hair4u@gmail.com',0,'2014-02-09 19:00:39',NULL,NULL),(35540,23372,'TE','8132400504',0,'2014-02-13 22:00:54',NULL,NULL),(39416,26062,'AP','4192354145',0,'2014-02-26 21:02:40',NULL,NULL),(40615,26960,'AP','3304596742',0,'2014-03-03 01:00:30',NULL,NULL),(4219,2697,'AP','3253408677',0,'2013-12-25 19:47:39',NULL,NULL),(29649,19156,'TE','4195758075',0,'2014-01-21 08:45:38',NULL,NULL),(1009,622,'TE','6148552737',0,'2013-12-25 18:00:52',NULL,NULL),(24554,15836,'EM','moriah.stutler@gmail.com',0,'2014-01-03 02:04:02',NULL,NULL),(37929,25026,'EM','MCVNUS@GMAIL.COM',0,'2014-02-20 22:01:00',NULL,NULL),(42924,28542,'EM','ssimmons0723@starkstate.net',0,'2014-03-07 21:32:15',NULL,NULL),(3947,2507,'TE','4192364151',0,'2013-12-25 19:36:10',NULL,NULL),(28879,18645,'AP','9565799029',0,'2014-01-17 03:35:08',NULL,NULL),(25912,16699,'TE','8303250495',0,'2014-01-08 18:24:38',NULL,NULL),(7568,4927,'TE','5132630514',0,'2013-12-25 22:45:19',NULL,NULL),(25240,16276,'EM','WSHILL74@GMAIL.COM',0,'2014-01-07 04:00:25',NULL,NULL),(3441,2157,'TE','3182358368',0,'2013-12-25 19:18:46',NULL,NULL),(6993,4567,'AP','5129407298',0,'2013-12-25 22:04:52',NULL,NULL),(35779,23530,'TE','3374143176',0,'2014-02-13 22:02:25',NULL,NULL),(36233,23846,'TE','4195082009',0,'2014-02-14 21:31:56',NULL,NULL),(40857,27149,'TE','2162003128',0,'2014-03-03 21:30:51',NULL,NULL),(11389,7415,'EM','pattynerone@att.net',0,'2013-12-26 02:16:51',NULL,NULL),(6096,3926,'EM','valerie1@zoomtown.com',0,'2013-12-25 21:37:29',NULL,NULL),(29608,19131,'TE','9852869076',0,'2014-01-21 08:45:23',NULL,NULL),(28864,18638,'TE','9567469827',0,'2014-01-17 03:35:05',NULL,NULL),(23582,15224,'AP','2253152414',0,'2014-01-01 12:08:08',NULL,NULL),(25011,16116,'AP','3186139790',0,'2014-01-04 02:05:18',NULL,NULL),(36141,23785,'TE','3307300500',0,'2014-02-14 21:31:22',NULL,NULL),(37317,24556,'AP','4199577465',0,'2014-02-20 04:05:32',NULL,NULL),(37483,24680,'EM','david0685@gmail.com',0,'2014-02-20 04:30:25',NULL,NULL),(38675,25562,'BN','2143649092',0,'2014-02-26 08:00:24',NULL,NULL),(41298,27438,'AP','2257763441',0,'2014-03-04 21:01:51',NULL,NULL),(14981,9802,'AP','5136380617',0,'2013-12-26 05:01:15',NULL,NULL),(13795,8994,'AP','9378300732',0,'2013-12-26 04:04:39',NULL,NULL),(635,395,'TE','6148662654',0,'2013-12-25 17:46:01',NULL,NULL),(5487,3510,'AP','5132547123',0,'2013-12-25 21:20:59',NULL,NULL),(9916,6489,'EM','j.marochino@yahoo.com',0,'2013-12-26 00:50:32',NULL,NULL),(11385,7413,'TE','5047820894',0,'2013-12-26 02:16:47',NULL,NULL),(36723,24181,'TE','9378308481',0,'2014-02-16 19:00:07',NULL,NULL),(42098,27971,'TE','5044432897',0,'2014-03-06 21:00:50',NULL,NULL),(43891,29121,'EM','klotzy68@hotmail.com',0,'2014-03-10 21:02:31',NULL,NULL),(10667,6931,'EM','eamyers34@yahoo.com',0,'2013-12-26 01:46:33',NULL,NULL),(31052,20200,'AP','6018263451',0,'2014-01-27 21:01:32',NULL,NULL),(7474,4865,'AP','6147954359',0,'2013-12-25 22:30:48',NULL,NULL),(10375,6762,'EM','mckarl@bellsouth.net',0,'2013-12-26 01:16:23',NULL,NULL),(3873,2462,'AP','3185728700',0,'2013-12-25 19:34:59',NULL,NULL),(4139,2641,'EM','mhglopez@hotmail.com',0,'2013-12-25 19:46:20',NULL,NULL),(23384,15062,'TE','3189572541',0,'2014-01-01 12:03:37',NULL,NULL),(27703,17855,'AP','5135209275',0,'2014-01-15 02:06:08',NULL,NULL),(24632,15884,'AP','3375505086',0,'2014-01-03 02:05:30',NULL,NULL),(31941,20850,'TE','4406679232',0,'2014-01-31 21:00:52',NULL,NULL),(40388,26807,'EM','NAZEK.ALLAN@YAHOO.COM',0,'2014-03-01 21:00:27',NULL,NULL),(20585,13243,'AP','8062396090',0,'2013-12-26 12:56:10',NULL,NULL),(29384,18991,'TE','2163828268',0,'2014-01-20 08:06:11',NULL,NULL),(7146,4660,'TE','3182534767',0,'2013-12-25 22:07:22',NULL,NULL),(28604,18437,'TE','5046572147',0,'2014-01-16 08:46:01',NULL,NULL),(28576,18421,'AP','5042849945',0,'2014-01-16 08:45:53',NULL,NULL),(24783,15985,'EM','texasgurl@gmail.com',0,'2014-01-04 02:01:06',NULL,NULL),(13934,9086,'EM','j.alan.payne@gmail.com',0,'2013-12-26 04:06:58',NULL,NULL),(10474,6824,'TE','3304142197',0,'2013-12-26 01:30:38',NULL,NULL),(21669,13949,'EM','skipperbt@yahoo.com',0,'2013-12-26 13:14:55',NULL,NULL),(21618,13914,'TE','4193967555',0,'2013-12-26 13:14:02',NULL,NULL),(10389,6771,'TE','3307945774',0,'2013-12-26 01:16:38',NULL,NULL),(33579,22014,'TE','5133498264',0,'2014-02-07 19:00:54',NULL,NULL),(34523,22649,'TE','9038732674',0,'2014-02-11 21:00:26',NULL,NULL),(35366,23236,'AP','5132641496',0,'2014-02-12 21:32:29',NULL,NULL),(36234,23846,'AP','4195082009',0,'2014-02-14 21:31:56',NULL,NULL),(39631,26208,'AP','4407963970',0,'2014-02-28 06:30:52',NULL,NULL),(42023,27931,'EM','jaynamaz@me.com',0,'2014-03-06 21:00:26',NULL,NULL),(8151,5336,'AP','3303791017',0,'2013-12-25 23:07:13',NULL,NULL),(5296,3394,'EM','keshagsimmons@outlook.com',0,'2013-12-25 21:17:57',NULL,NULL),(26732,17194,'TE','2253628313',0,'2014-01-13 02:22:20',NULL,NULL),(22931,14796,'AP','5136580269',1,'2013-12-29 11:13:36',NULL,NULL),(31706,20687,'TE','6149069969',0,'2014-01-30 21:00:57',NULL,NULL),(38388,25360,'EM','jdinoj_1992@hotmail.com',0,'2014-02-25 21:30:36',NULL,NULL),(1103,677,'EM','shemsath59@yahoo.com',0,'2013-12-25 18:02:17',NULL,NULL),(28907,18661,'AP','5125778209',0,'2014-01-17 03:35:14',NULL,NULL),(27658,17829,'TE','6019416219',0,'2014-01-15 02:05:59',NULL,NULL),(25523,16457,'AP','5132536620',0,'2014-01-07 04:05:39',NULL,NULL),(23594,15234,'EM','lterilla@hotmail.com',0,'2014-01-01 12:08:23',NULL,NULL),(7727,5044,'EM','carl@hwarf.com',0,'2013-12-25 22:48:07',NULL,NULL),(7187,4683,'AP','2027316766',0,'2013-12-25 22:07:57',NULL,NULL),(1958,1213,'TE','9378482183',0,'2013-12-25 18:20:09',NULL,NULL),(11214,7293,'EM','mi4ken4dra@aol.com',0,'2013-12-26 02:02:57',NULL,NULL),(37042,24393,'TE','4196061510',0,'2014-02-18 22:00:50',NULL,NULL),(38541,25468,'TE','8304566523',0,'2014-02-25 21:31:35',NULL,NULL),(39933,26425,'AP','5126449870',0,'2014-02-28 07:30:12',NULL,NULL),(20565,13235,'TE','5125547423',0,'2013-12-26 12:55:53',NULL,NULL),(31018,20181,'TE','3307159367',0,'2014-01-27 21:01:20',NULL,NULL),(29939,19375,'EM','zer2trell2005@yahoo.com',1,'2014-01-22 03:22:39',NULL,NULL),(27377,17624,'AP','9784001764',0,'2014-01-14 01:32:29',NULL,NULL),(26916,17313,'AP','7738377128',0,'2014-01-13 02:23:46',NULL,NULL),(25312,16324,'TE','9853609752',0,'2014-01-07 04:01:46',NULL,NULL),(35451,23312,'TE','4407400276',0,'2014-02-13 22:00:20',NULL,NULL),(6695,4353,'TE','5134762333',0,'2013-12-25 21:53:31',NULL,NULL),(4972,3190,'EM','normaj51@frontier.com',0,'2013-12-25 20:32:07',NULL,NULL),(31915,20833,'AP','3308041951',0,'2014-01-31 21:00:42',NULL,NULL),(35599,23410,'AP','3612209726',0,'2014-02-13 22:01:16',NULL,NULL),(37221,24495,'TE','3615220586',0,'2014-02-20 03:46:43',NULL,NULL),(37261,24519,'TE','8172691667',0,'2014-02-20 03:56:28',NULL,NULL),(14546,9503,'AP','3304145743',0,'2013-12-26 04:35:14',NULL,NULL),(2590,1581,'TE','3345689955',0,'2013-12-25 18:51:26',NULL,NULL),(23955,15457,'AP','9152445845',1,'2014-01-02 04:28:33',NULL,NULL),(22553,14546,'TE','6015635184',0,'2013-12-28 03:34:53',NULL,NULL),(39499,26125,'EM','kfasbury1@hotmail.com',0,'2014-02-28 06:30:21',NULL,NULL),(41279,27428,'TE','9852909175',0,'2014-03-04 21:01:44',NULL,NULL),(14821,9703,'EM','dpostlaw@bright.net',0,'2013-12-26 04:40:01',NULL,NULL),(27975,18034,'AP','3302412846',0,'2014-01-15 02:07:09',NULL,NULL),(26836,17263,'TE','5183644741',0,'2014-01-13 02:23:18',NULL,NULL),(8778,5752,'AP','2144188492',0,'2013-12-25 23:46:15',NULL,NULL),(1106,678,'EM','MALLOY2222@AOL.COM',0,'2013-12-25 18:02:19',NULL,NULL),(6744,4379,'AP','6142043331',0,'2013-12-25 22:00:34',NULL,NULL),(2317,1414,'AP','5044305508',0,'2013-12-25 18:47:02',NULL,NULL),(10916,7095,'TE','3302124648',0,'2013-12-26 01:50:38',NULL,NULL),(11154,7252,'AP','9852120480',0,'2013-12-26 02:01:58',NULL,NULL),(7986,5210,'TE','9375432174',0,'2013-12-25 23:04:17',NULL,NULL),(34447,22600,'TE','9374032505',0,'2014-02-10 21:32:14',NULL,NULL),(40185,26656,'EM','mbrannon77@yahoo.com',0,'2014-02-28 21:31:09',NULL,NULL),(42530,28295,'AP','5138856851',0,'2014-03-07 21:00:30',NULL,NULL),(43356,28797,'AP','3306344893',0,'2014-03-09 21:00:46',NULL,NULL),(10478,6827,'AP','3304142197',0,'2013-12-26 01:30:40',NULL,NULL),(6163,3971,'AP','9372188423',0,'2013-12-25 21:38:35',NULL,NULL),(29923,19365,'EM','bartsu@gmail.com',1,'2014-01-22 03:22:33',NULL,NULL),(5441,3484,'TE','9374289636',0,'2013-12-25 21:20:16',NULL,NULL),(9084,5955,'TE','4193890385',0,'2013-12-25 23:51:13',NULL,NULL),(36544,24062,'TE','2166825104',0,'2014-02-15 22:01:09',NULL,NULL),(36998,24360,'EM','ALLEN393@AOL.COM',0,'2014-02-18 22:00:32',NULL,NULL),(39131,25883,'TE','9406319458',0,'2014-02-26 21:00:59',NULL,NULL),(659,410,'TE','6145967429',0,'2013-12-25 17:46:24',NULL,NULL),(31851,20795,'AP','9157305978',0,'2014-01-31 21:00:17',NULL,NULL),(28310,18248,'TE','8174463399',0,'2014-01-16 08:44:29',NULL,NULL),(28133,18136,'TE','9852628516',0,'2014-01-15 02:07:45',NULL,NULL),(27313,17590,'TE','9373616612',0,'2014-01-14 01:32:10',NULL,NULL),(13826,9014,'AP','5672032879',0,'2013-12-26 04:05:11',NULL,NULL),(23440,15107,'TE','4406104467',0,'2014-01-01 12:04:52',NULL,NULL),(23106,14898,'TE','3183021544',0,'2013-12-30 00:01:02',NULL,NULL),(6366,4100,'EM','balmirab@aol.com',0,'2013-12-25 21:47:43',NULL,NULL),(3084,1924,'AP','6143307111',0,'2013-12-25 19:00:15',NULL,NULL),(8992,5903,'TE','7405901877',0,'2013-12-25 23:49:49',NULL,NULL),(33812,22201,'TE','5135350764',0,'2014-02-09 19:00:15',NULL,NULL),(35340,23221,'EM','Clwhitti@hotmail.com',0,'2014-02-12 21:32:19',NULL,NULL),(39898,26404,'TE','4193029638',0,'2014-02-28 07:00:33',NULL,NULL),(40300,26734,'TE','4195810862',0,'2014-02-28 21:31:51',NULL,NULL),(42354,28131,'TE','3305501885',0,'2014-03-06 21:02:25',NULL,NULL),(172,101,'TE','9569824460',0,'2013-12-25 17:17:44',NULL,NULL),(27379,17625,'TE','5129233472',0,'2014-01-14 01:32:30',NULL,NULL),(2991,1851,'AP','5134791955',0,'2013-12-25 18:57:55',NULL,NULL),(25333,16335,'AP','9732343010',0,'2014-01-07 04:02:07',NULL,NULL),(3207,2014,'EM','bbaldwin1334@gmail.com',0,'2013-12-25 19:02:36',NULL,NULL),(23688,15293,'TE','3185641533',1,'2014-01-02 04:22:32',NULL,NULL),(8830,5781,'AP','6145788309',0,'2013-12-25 23:47:04',NULL,NULL),(7025,4587,'AP','3306060923',0,'2013-12-25 22:05:23',NULL,NULL),(14478,9454,'TE','5134976040',0,'2013-12-26 04:34:04',NULL,NULL),(11970,7800,'TE','9792796786',0,'2013-12-26 03:03:39',NULL,NULL),(36453,24004,'TE','6148365998',0,'2014-02-15 22:00:35',NULL,NULL),(36784,24220,'TE','7136799843',0,'2014-02-16 19:00:28',NULL,NULL),(39038,25814,'TE','4402544129',0,'2014-02-26 21:00:23',NULL,NULL),(42847,28495,'AP','6019405221',0,'2014-03-07 21:31:44',NULL,NULL),(11411,7425,'AP','4199343997',0,'2013-12-26 02:17:10',NULL,NULL),(4270,2730,'TE','5044192691',0,'2013-12-25 19:48:27',NULL,NULL),(6334,4084,'AP','3308823997',0,'2013-12-25 21:47:14',NULL,NULL),(11677,7601,'EM','tyler28@yahoo.com',0,'2013-12-26 02:45:24',NULL,NULL),(22819,14715,'AP','2164963787',1,'2013-12-29 11:09:25',NULL,NULL),(22007,14173,'AP','8327607996',0,'2013-12-27 02:03:32',NULL,NULL),(30174,19548,'EM','ajagod88@live.com',0,'2014-01-23 03:02:28',NULL,NULL),(30422,19718,'EM','ohiosandy54@yahoo.com',0,'2014-01-23 21:00:57',NULL,NULL),(31272,20372,'TE','2252681915',0,'2014-01-29 21:00:06',NULL,NULL),(31977,20878,'EM','JONASLAURENT@GMAIL.COM',0,'2014-01-31 21:01:07',NULL,NULL),(32107,20968,'TE','9568677328',0,'2014-02-01 19:00:13',NULL,NULL),(33906,22254,'EM','rmc12222@comcast.net',0,'2014-02-09 19:00:45',NULL,NULL),(35010,22986,'TE','3307339082',0,'2014-02-12 21:30:12',NULL,NULL),(1214,740,'AP','9565772278',0,'2013-12-25 18:04:02',NULL,NULL),(27080,17417,'AP','9374836076',0,'2014-01-13 03:00:25',NULL,NULL),(24601,15865,'AP','6012970064',0,'2014-01-03 02:04:55',NULL,NULL),(11987,7809,'EM','valeriegurl92@yahoo.com',0,'2013-12-26 03:03:54',NULL,NULL),(23422,15087,'AP','9404451518',0,'2014-01-01 12:04:22',NULL,NULL),(11962,7794,'TE','9032751053',0,'2013-12-26 03:03:30',NULL,NULL),(22732,14660,'AP','9152027431',1,'2013-12-29 11:07:58',NULL,NULL),(22592,14571,'TE','4193454534',0,'2013-12-28 03:35:33',NULL,NULL),(1758,1085,'TE','4405202807',0,'2013-12-25 18:16:53',NULL,NULL),(2281,1398,'EM','vilaysacktoun@gmail.com',0,'2013-12-25 18:46:33',NULL,NULL),(7234,4711,'TE','4195681569',0,'2013-12-25 22:08:44',NULL,NULL),(6230,4015,'TE','6142961726',0,'2013-12-25 21:45:32',NULL,NULL),(5264,3380,'EM','Housecalls@cableone.net',0,'2013-12-25 21:17:30',NULL,NULL),(8387,5520,'TE','5139845994',0,'2013-12-25 23:15:18',NULL,NULL),(33138,21707,'AP','6015408134',0,'2014-02-05 21:31:13',NULL,NULL),(33492,21946,'EM','williammason@hotmail.com',0,'2014-02-07 19:00:19',NULL,NULL),(33986,22294,'EM','jordan.behr90@gmail.com',0,'2014-02-10 11:00:32',NULL,NULL),(35339,23219,'AP','9016065827',0,'2014-02-12 21:32:19',NULL,NULL),(41847,27827,'TE','3305981057',0,'2014-03-05 21:31:59',NULL,NULL),(588,362,'TE','3252629290',0,'2013-12-25 17:45:13',NULL,NULL),(9717,6361,'TE','6142030015',0,'2013-12-26 00:47:21',NULL,NULL),(9148,5992,'EM','charles.miller@mchsi.com',0,'2013-12-26 00:00:06',NULL,NULL),(975,600,'TE','6144789986',0,'2013-12-25 18:00:17',NULL,NULL),(7688,5015,'AP','4192300466',0,'2013-12-25 22:47:24',NULL,NULL),(6129,3946,'TE','9372140598',0,'2013-12-25 21:38:02',NULL,NULL),(12062,7876,'TE','5138435473',0,'2013-12-26 03:05:18',NULL,NULL),(11578,7533,'AP','4077905835',0,'2013-12-26 02:32:45',NULL,NULL),(5479,3507,'TE','9372728903',0,'2013-12-25 21:20:53',NULL,NULL),(32365,21147,'TE','9154089010',0,'2014-02-03 21:00:25',NULL,NULL),(35719,23490,'EM','doddsen@gmail.com',0,'2014-02-13 22:02:02',NULL,NULL),(43699,29007,'EM','geejoguy1@yahoo.com',0,'2014-03-10 21:01:22',NULL,NULL),(12187,7962,'EM','amclincy@yahoo.com',0,'2013-12-26 03:07:28',NULL,NULL),(503,317,'EM','williamjenkin@gmail.com',0,'2013-12-25 17:31:14',NULL,NULL),(23600,15238,'EM','hm_arts@hotmail.com',0,'2014-01-01 12:08:32',NULL,NULL),(6693,4350,'TE','9377640443',0,'2013-12-25 21:53:27',NULL,NULL),(14609,9550,'EM','rodweller@fuse.net',0,'2013-12-26 04:36:17',NULL,NULL),(3877,2464,'TE','5042309817',0,'2013-12-25 19:35:02',NULL,NULL),(4632,2954,'TE','8062828744',0,'2013-12-25 20:16:37',NULL,NULL),(30287,19621,'TE','3308236724',0,'2014-01-23 21:00:04',NULL,NULL),(31178,20305,'TE','9039825353',0,'2014-01-28 21:00:46',NULL,NULL),(34054,22327,'TE','9375448097',0,'2014-02-10 11:00:58',NULL,NULL),(38159,25185,'TE','3307673835',0,'2014-02-21 22:00:36',NULL,NULL),(43931,29143,'TE','5132326242',0,'2014-03-10 21:02:44',NULL,NULL),(134,81,'TE','4194784361',0,'2013-12-25 17:17:09',NULL,NULL),(28462,18341,'TE','3303190742',0,'2014-01-16 08:45:17',NULL,NULL),(12044,7856,'EM','benjalo@gmail.com',0,'2013-12-26 03:04:57',NULL,NULL),(7712,5037,'TE','7657179160',0,'2013-12-25 22:47:54',NULL,NULL),(25931,16707,'BN','7193342320',0,'2014-01-08 18:24:41',NULL,NULL),(14628,9561,'EM','danbuller@gmail.com',0,'2013-12-26 04:36:35',NULL,NULL),(6647,4306,'AP','5138058813',0,'2013-12-25 21:52:29',NULL,NULL),(7017,4582,'EM','carmen.r@my1hr.com',0,'2013-12-25 22:05:15',NULL,NULL),(35863,23583,'EM','jworley73@yahoo.com',0,'2014-02-13 22:02:58',NULL,NULL),(36988,24352,'AP','8145049850',0,'2014-02-18 22:00:27',NULL,NULL),(37154,24458,'TE','9729510337',0,'2014-02-18 22:01:31',NULL,NULL),(37381,24617,'TE','6626475464',0,'2014-02-20 04:15:23',NULL,NULL),(38526,25460,'TE','8062238123',0,'2014-02-25 21:31:31',NULL,NULL),(6780,4399,'TE','3304884126',0,'2013-12-25 22:01:06',NULL,NULL),(29585,19117,'TE','5137242959',0,'2014-01-21 08:44:48',NULL,NULL),(11853,7716,'TE','5133071006',0,'2013-12-26 03:01:37',NULL,NULL),(22352,14415,'TE','2813030044',0,'2013-12-28 03:31:34',NULL,NULL),(3393,2133,'AP','9542240619',0,'2013-12-25 19:18:02',NULL,NULL),(14035,9168,'AP','4199056885',0,'2013-12-26 04:08:51',NULL,NULL),(33779,22168,'AP','4192035892',0,'2014-02-08 19:01:03',NULL,NULL),(35207,23124,'EM','ALCHAFFIN@AOL.COM',0,'2014-02-12 21:31:25',NULL,NULL),(37149,24454,'TE','6014736411',0,'2014-02-18 22:01:28',NULL,NULL),(40159,26635,'TE','9152384185',0,'2014-02-28 21:30:59',NULL,NULL),(40524,26897,'AP','8329646161',0,'2014-03-03 01:00:06',NULL,NULL),(11749,7648,'AP','4407147551',0,'2013-12-26 02:46:46',NULL,NULL),(8982,5890,'AP','5133350683',0,'2013-12-25 23:49:36',NULL,NULL),(743,465,'TE','3302735431',0,'2013-12-25 17:47:44',NULL,NULL),(2146,1322,'AP','4196040622',0,'2013-12-25 18:31:47',NULL,NULL),(20319,13093,'AP','5132604991',0,'2013-12-26 12:51:57',NULL,NULL),(38645,25541,'TE','4197333508',0,'2014-02-26 08:00:11',NULL,NULL),(42645,28368,'AP','2149147899',0,'2014-03-07 21:30:33',NULL,NULL),(43040,28617,'TE','8307435099',0,'2014-03-08 21:30:19',NULL,NULL),(10600,6898,'EM','Deryl.wicks@gmail.com',0,'2013-12-26 01:45:34',NULL,NULL),(29850,19312,'EM','ANGULO_RAMON@HOTMAIL.COM',1,'2014-01-22 03:22:07',NULL,NULL),(1385,846,'AP','5047225547',0,'2013-12-25 18:06:45',NULL,NULL),(24896,16049,'TE','9378374539',0,'2014-01-04 02:03:09',NULL,NULL),(23850,15388,'TE','4407498666',1,'2014-01-02 04:25:38',NULL,NULL),(23845,15384,'AP','3304143243',1,'2014-01-02 04:25:32',NULL,NULL),(1438,877,'TE','9376920132',0,'2013-12-25 18:07:37',NULL,NULL),(8163,5341,'AP','2164968674',0,'2013-12-25 23:07:22',NULL,NULL),(5017,3219,'EM','babyjala2004@aol.com',0,'2013-12-25 20:45:41',NULL,NULL),(7101,4635,'TE','6622300938',0,'2013-12-25 22:06:38',NULL,NULL),(37697,24855,'TE','5139230015',0,'2014-02-20 04:56:06',NULL,NULL),(6585,4250,'EM','llgillis1124@gmail.com',0,'2013-12-25 21:51:16',NULL,NULL),(25146,16209,'TE','9036177965',0,'2014-01-05 00:01:25',NULL,NULL),(24628,15882,'TE','3185643436',0,'2014-01-03 02:05:27',NULL,NULL),(1689,1039,'TE','9563693466',0,'2013-12-25 18:15:43',NULL,NULL),(10550,6869,'TE','9405671526',0,'2013-12-26 01:31:55',NULL,NULL),(6280,4050,'TE','5137037674',0,'2013-12-25 21:46:22',NULL,NULL),(4402,2805,'TE','2812461131',0,'2013-12-25 20:00:03',NULL,NULL),(4359,2779,'EM','susanrainwater@live.com',0,'2013-12-25 19:49:48',NULL,NULL),(10399,6779,'TE','3304123123',0,'2013-12-26 01:16:48',NULL,NULL),(6931,4514,'TE','9562925366',0,'2013-12-25 22:03:41',NULL,NULL),(38276,25272,'EM','obgogal@aol.com',0,'2014-02-25 21:00:12',NULL,NULL),(40194,26661,'EM','MLT0722@YAHOO.COM',0,'2014-02-28 21:31:12',NULL,NULL),(10329,6736,'TE','2164694364',0,'2013-12-26 01:15:38',NULL,NULL),(254,155,'EM','rj_othman@yahoo.com',0,'2013-12-25 17:19:02',NULL,NULL),(26396,16990,'AP','9155491023',0,'2014-01-13 02:20:24',NULL,NULL),(25723,16579,'EM','Heckardc@yahoo.com',0,'2014-01-08 18:23:57',NULL,NULL),(3871,2461,'EM','LILLIANJENKINS59@YAHOO.COM',0,'2013-12-25 19:34:57',NULL,NULL),(35017,22993,'AP','7409724714',0,'2014-02-12 21:30:15',NULL,NULL),(6535,4226,'EM','KGREEN902@YAHOO.COM',0,'2013-12-25 21:50:34',NULL,NULL),(25493,16435,'TE','3309473825',0,'2014-01-07 04:04:59',NULL,NULL),(24443,15780,'AP','3103820755',0,'2014-01-03 02:02:07',NULL,NULL),(21767,14022,'TE','9374089201',0,'2013-12-26 13:16:41',NULL,NULL),(8749,5736,'TE','5042569540',0,'2013-12-25 23:45:49',NULL,NULL),(3584,2245,'AP','5138334796',0,'2013-12-25 19:21:07',NULL,NULL),(7890,5141,'AP','4407256995',0,'2013-12-25 23:02:33',NULL,NULL),(30526,19800,'AP','9157313150',0,'2014-01-24 21:00:04',NULL,NULL),(30612,19867,'EM','ccho52@outlook.com',0,'2014-01-24 21:00:39',NULL,NULL),(30876,20070,'TE','9364399637',0,'2014-01-27 21:00:17',NULL,NULL),(33973,22287,'AP','9372132815',0,'2014-02-10 11:00:27',NULL,NULL),(42323,28105,'TE','3307331536',0,'2014-03-06 21:02:13',NULL,NULL),(43815,29084,'TE','9012688773',0,'2014-03-10 21:02:05',NULL,NULL),(10506,6841,'EM','gillumisiah@yahoo.com',0,'2013-12-26 01:31:07',NULL,NULL),(6201,3995,'AP','5133650387',0,'2013-12-25 21:39:14',NULL,NULL),(26075,16794,'AP','2142930739',0,'2014-01-13 02:18:08',NULL,NULL),(25509,16450,'TE','6622893012',0,'2014-01-07 04:05:22',NULL,NULL),(5771,3697,'TE','6199852569',0,'2013-12-25 21:31:53',NULL,NULL),(24177,15621,'TE','6623357036',1,'2014-01-02 04:33:09',NULL,NULL),(21140,13592,'TE','2253851630',0,'2013-12-26 13:05:13',NULL,NULL),(34627,22705,'EM','JARRETTJJ@HOTMAIL.COM',0,'2014-02-11 21:01:01',NULL,NULL),(43419,28833,'TE','6014212203',0,'2014-03-09 21:01:08',NULL,NULL),(772,481,'EM','dmpits@gmail.com',0,'2013-12-25 17:48:11',NULL,NULL),(29405,19007,'TE','3374592436',0,'2014-01-20 08:06:18',NULL,NULL),(26550,17077,'EM','kcocchiaro@gmail.com',0,'2014-01-13 02:21:21',NULL,NULL),(9245,6050,'TE','6142522502',0,'2013-12-26 00:01:40',NULL,NULL),(23652,15273,'TE','3309581000',1,'2014-01-02 04:21:53',NULL,NULL),(22890,14769,'EM','orkainthefalls@gmail.com',1,'2013-12-29 11:12:54',NULL,NULL),(22673,14617,'EM','jlkutz@cinci.rr.com',0,'2013-12-28 03:36:51',NULL,NULL),(32084,20954,'TE','3235164041',0,'2014-02-01 19:00:06',NULL,NULL),(32635,21344,'AP','8066625784',0,'2014-02-04 21:00:34',NULL,NULL),(38809,25659,'TE','4196513824',0,'2014-02-26 08:30:44',NULL,NULL),(4851,3105,'EM','RANEE39STEELE@YAHOO.COM',0,'2013-12-25 20:20:24',NULL,NULL),(21814,14054,'TE','4194820682',0,'2013-12-27 02:00:23',NULL,NULL),(29679,19179,'AP','8068817635',0,'2014-01-21 08:46:07',NULL,NULL),(24881,16042,'EM','jgarcia2018@hotmail.com',0,'2014-01-04 02:02:54',NULL,NULL),(25905,16695,'AP','9565151561',0,'2014-01-08 18:24:37',NULL,NULL),(35110,23063,'TE','5043882001',0,'2014-02-12 21:30:52',NULL,NULL),(35202,23119,'EM','ECLARKEVA@GMAIL.COM',0,'2014-02-12 21:31:23',NULL,NULL),(37534,24715,'TE','4405037555',0,'2014-02-20 04:36:53',NULL,NULL),(38201,25215,'AP','9373465494',0,'2014-02-21 22:00:53',NULL,NULL),(43582,28940,'TE','4192768197',0,'2014-03-10 21:00:42',NULL,NULL),(551,344,'TE','8146030636',0,'2013-12-25 17:32:02',NULL,NULL),(684,425,'AP','3308395479',0,'2013-12-25 17:46:45',NULL,NULL),(11215,7295,'TE','4404423488',0,'2013-12-26 02:02:59',NULL,NULL),(9559,6255,'TE','9373876020',0,'2013-12-26 00:32:06',NULL,NULL),(23847,15386,'TE','4192071122',1,'2014-01-02 04:25:35',NULL,NULL),(31906,20823,'TE','3182924284',0,'2014-01-31 21:00:37',NULL,NULL),(38351,25334,'TE','5044519181',0,'2014-02-25 21:30:20',NULL,NULL),(38951,25753,'TE','4196827989',0,'2014-02-26 09:30:47',NULL,NULL),(10384,6769,'TE','5042506502',0,'2013-12-26 01:16:34',NULL,NULL),(9172,6003,'EM','glwilson_us@yahoo.com',0,'2013-12-26 00:00:25',NULL,NULL),(25391,16376,'AP','9565456531',0,'2014-01-07 04:03:11',NULL,NULL),(37260,24518,'AP','9152528696',0,'2014-02-20 03:56:08',NULL,NULL),(39483,26113,'EM','carascox@gmail.com',0,'2014-02-28 06:30:16',NULL,NULL),(42228,28052,'TE','6016653685',0,'2014-03-06 21:01:38',NULL,NULL),(8914,5834,'TE','2105270377',0,'2013-12-25 23:48:24',NULL,NULL),(23842,15383,'AP','3304143243',1,'2014-01-02 04:25:29',NULL,NULL),(3917,2485,'AP','2257769489',0,'2013-12-25 19:35:38',NULL,NULL),(23394,15068,'TE','9852509504',0,'2014-01-01 12:03:48',NULL,NULL),(20724,13319,'EM','kjsaeger@yahoo.com',0,'2013-12-26 12:58:19',NULL,NULL),(31971,20875,'AP','2252213600',0,'2014-01-31 21:01:05',NULL,NULL),(42951,28562,'TE','9379998607',0,'2014-03-07 21:32:27',NULL,NULL),(610,377,'TE','9032585003',0,'2013-12-25 17:45:36',NULL,NULL),(10258,6703,'AP','4194669729',0,'2013-12-26 01:01:59',NULL,NULL),(26712,17183,'TE','3306730474',0,'2014-01-13 02:22:14',NULL,NULL),(20280,13071,'EM','jsimmons2356@yahoo.com',0,'2013-12-26 12:51:19',NULL,NULL),(9426,6168,'EM','joecrem@hotmail.com',0,'2013-12-26 00:16:59',NULL,NULL),(9241,6048,'EM','michaelteggart@gmail.com',0,'2013-12-26 00:01:36',NULL,NULL),(33041,21645,'EM','jeansandy103@gmail.com',0,'2014-02-05 21:30:47',NULL,NULL),(35313,23198,'EM','adamteutsch@hotmail.com',0,'2014-02-12 21:32:07',NULL,NULL),(38060,25118,'EM','wilhelmgas@yahoo.com',0,'2014-02-21 21:30:20',NULL,NULL),(6351,4092,'AP','7692040077',0,'2013-12-25 21:47:29',NULL,NULL),(10904,7085,'AP','3304193619',0,'2013-12-26 01:50:25',NULL,NULL),(8025,5248,'TE','4403310323',0,'2013-12-25 23:05:04',NULL,NULL),(26228,16881,'TE','4323851931',0,'2014-01-13 02:19:21',NULL,NULL),(24624,15879,'TE','3372565464',0,'2014-01-03 02:05:22',NULL,NULL),(31022,20182,'EM','randallmoate@gmail.com',0,'2014-01-27 21:01:21',NULL,NULL),(33036,21643,'TE','8174681228',0,'2014-02-05 21:30:46',NULL,NULL),(37012,24370,'TE','6018076532',0,'2014-02-18 22:00:37',NULL,NULL),(37871,24982,'AP','3612180168',0,'2014-02-20 22:00:34',NULL,NULL),(39022,25803,'AP','6142044263',0,'2014-02-26 21:00:18',NULL,NULL),(2503,1535,'AP','9377634922',0,'2013-12-25 18:50:08',NULL,NULL),(1374,839,'EM','earth.angelpozo@gmail.com',0,'2013-12-25 18:06:34',NULL,NULL),(22899,14773,'EM','iliemep@gmail.com',1,'2013-12-29 11:13:01',NULL,NULL),(22222,14324,'TE','3302042803',0,'2013-12-27 02:07:20',NULL,NULL),(35517,23359,'EM','nadamaroun678@yahoo.com',0,'2014-02-13 22:00:45',NULL,NULL),(35569,23391,'TE','7406228320',0,'2014-02-13 22:01:05',NULL,NULL),(37131,24443,'AP','3305016154',0,'2014-02-18 22:01:21',NULL,NULL),(41058,27277,'AP','2107766416',0,'2014-03-04 21:00:20',NULL,NULL),(41820,27808,'TE','3304974362',0,'2014-03-05 21:31:48',NULL,NULL),(43938,29145,'EM','burns.j@live.com',0,'2014-03-10 21:02:46',NULL,NULL),(1504,925,'TE','3307412101',0,'2013-12-25 18:08:58',NULL,NULL),(7245,4721,'EM','rdavis_art@fuse.net',0,'2013-12-25 22:08:57',NULL,NULL),(7009,4579,'TE','5109189929',0,'2013-12-25 22:05:10',NULL,NULL),(26487,17046,'EM','bucklanb@yahoo.com',0,'2014-01-13 02:20:54',NULL,NULL),(5121,3281,'TE','2166911220',0,'2013-12-25 21:15:17',NULL,NULL),(31118,20263,'BN','3303380734',0,'2014-01-28 21:00:19',NULL,NULL),(34029,22316,'EM','cam6113@yahoo.com',0,'2014-02-10 11:00:50',NULL,NULL),(34554,22662,'EM','sham4110@gmail.com',0,'2014-02-11 21:00:35',NULL,NULL),(35147,23081,'AP','3304726819',0,'2014-02-12 21:31:03',NULL,NULL),(39590,26190,'TE','6143167646',0,'2014-02-28 06:30:44',NULL,NULL),(1409,860,'TE','4196055004',0,'2013-12-25 18:07:09',NULL,NULL),(3973,2520,'AP','3302857596',0,'2013-12-25 19:36:35',NULL,NULL),(38460,25416,'TE','3304316892',0,'2014-02-25 21:31:06',NULL,NULL),(39924,26420,'TE','9152438788',0,'2014-02-28 07:30:07',NULL,NULL),(41675,27710,'TE','9405495295',0,'2014-03-05 21:30:53',NULL,NULL),(12108,7912,'EM','d.ocasio@live.com',0,'2013-12-26 03:06:07',NULL,NULL),(28549,18404,'AP','5137025258',0,'2014-01-16 08:45:45',NULL,NULL),(32703,21393,'EM','kings2450@gmail.com',0,'2014-02-04 21:00:58',NULL,NULL),(40483,26867,'AP','2144028720',0,'2014-03-01 21:01:01',NULL,NULL),(43658,28975,'BN','3186641320',0,'2014-03-10 21:01:05',NULL,NULL),(167,98,'EM','zandra1170@gmail.com',0,'2013-12-25 17:17:39',NULL,NULL),(822,512,'TE','5134906903',0,'2013-12-25 17:48:57',NULL,NULL),(27263,17553,'EM','ZAMAHOWELL83@GMAIL.COM',0,'2014-01-13 03:01:56',NULL,NULL),(23912,15428,'TE','9037808985',1,'2014-01-02 04:27:40',NULL,NULL),(21829,14062,'EM','leslwood@hotmail.com',0,'2013-12-27 02:00:37',NULL,NULL),(21126,13585,'TE','9857680010',0,'2013-12-26 13:05:00',NULL,NULL),(9805,6418,'TE','9377258505',0,'2013-12-26 00:48:47',NULL,NULL),(6905,4497,'TE','9033939088',0,'2013-12-25 22:03:16',NULL,NULL),(2020,1251,'TE','4408647595',0,'2013-12-25 18:21:14',NULL,NULL),(23119,14903,'EM','shokoynot@gmail.com',0,'2013-12-30 00:01:13',NULL,NULL),(29823,19295,'AP','3184390467',1,'2014-01-22 03:21:57',NULL,NULL),(379,231,'AP','5132562650',0,'2013-12-25 17:21:04',NULL,NULL),(3781,2398,'TE','6148488357',0,'2013-12-25 19:33:29',NULL,NULL),(10472,6822,'TE','9377175706',0,'2013-12-26 01:30:35',NULL,NULL),(31478,20512,'TE','3183871325',0,'2014-01-29 21:01:20',NULL,NULL),(3983,2526,'AP','3306061471',0,'2013-12-25 19:36:44',NULL,NULL),(28080,18095,'EM','Ermaj12345@yahoo.com',0,'2014-01-15 02:07:32',NULL,NULL),(7110,4642,'EM','feliciadc@yahoo.com',0,'2013-12-25 22:06:50',NULL,NULL),(22453,14477,'EM','tdoll528@yahoo.com',0,'2013-12-28 03:33:13',NULL,NULL),(12358,8089,'EM','cfdance7@aol.com',0,'2013-12-26 03:10:39',NULL,NULL),(6195,3992,'EM','joejoyce12054@yahoo.com',0,'2013-12-25 21:39:08',NULL,NULL),(41196,27361,'TE','4407791697',0,'2014-03-04 21:01:11',NULL,NULL),(41062,27280,'TE','9564457698',0,'2014-03-04 21:00:21',NULL,NULL),(4778,3059,'TE','8143353897',0,'2013-12-25 20:19:06',NULL,NULL),(38935,25741,'AP','2169051823',0,'2014-02-26 09:30:40',NULL,NULL),(2162,1329,'AP','5135465528',0,'2013-12-25 18:32:03',NULL,NULL),(28594,18432,'TE','5042925330',0,'2014-01-16 08:45:59',NULL,NULL),(14222,9305,'TE','3375755765',0,'2013-12-26 04:30:07',NULL,NULL),(27400,17644,'AP','4407594202',0,'2014-01-14 01:32:38',NULL,NULL),(27883,17968,'TE','2165263101',0,'2014-01-15 02:06:48',NULL,NULL),(27450,17683,'EM','dianewampler@hotmail.com',0,'2014-01-14 01:32:55',NULL,NULL),(11974,7801,'AP','9794760238',0,'2013-12-26 03:03:42',NULL,NULL),(9669,6330,'TE','5138999035',0,'2013-12-26 00:46:35',NULL,NULL),(13722,8941,'AP','5138844187',0,'2013-12-26 04:03:21',NULL,NULL),(14391,9408,'EM','bblee143@hotmail.com',0,'2013-12-26 04:32:49',NULL,NULL),(25566,16491,'AP','4192256245',0,'2014-01-07 04:06:34',NULL,NULL),(27479,17701,'TE','8593965716',0,'2014-01-14 01:33:04',NULL,NULL),(42346,28124,'TE','3303421435',0,'2014-03-06 21:02:21',NULL,NULL),(4777,3058,'EM','COMPUTERWORXS@GMAIL.COM',0,'2013-12-25 20:19:05',NULL,NULL),(41626,27672,'TE','9152820055',0,'2014-03-05 21:30:34',NULL,NULL),(1791,1111,'EM','skearnslpn@hotmail.com',0,'2013-12-25 18:17:30',NULL,NULL),(40552,26915,'AP','5137959998',0,'2014-03-03 01:00:13',NULL,NULL),(35135,23076,'TE','2252907818',0,'2014-02-12 21:31:00',NULL,NULL),(7054,4607,'EM','mcmasterchristopher@hotmail.com',0,'2013-12-25 22:05:53',NULL,NULL),(32782,21449,'TE','3306771115',0,'2014-02-04 21:01:27',NULL,NULL),(14029,9162,'TE','9373375044',0,'2013-12-26 04:08:44',NULL,NULL),(22942,14801,'TE','3302073738',1,'2013-12-29 11:13:45',NULL,NULL),(29359,18970,'AP','4403436865',0,'2014-01-20 08:06:01',NULL,NULL),(23077,14883,'TE','9857890007',0,'2013-12-30 00:00:36',NULL,NULL),(28598,18433,'EM','french@mtpleasantcdc.org',0,'2014-01-16 08:46:00',NULL,NULL),(42005,27916,'AP','9033303460',0,'2014-03-06 21:00:19',NULL,NULL),(11911,7751,'EM','jdrcowman43080@yahoo.com',0,'2013-12-26 03:02:32',NULL,NULL),(41023,27256,'AP','4198707524',0,'2014-03-03 21:31:57',NULL,NULL),(10530,6857,'AP','9375810804',0,'2013-12-26 01:31:35',NULL,NULL),(14376,9401,'TE','2147348913',0,'2013-12-26 04:32:36',NULL,NULL),(24173,15619,'AP','6622423039',1,'2014-01-02 04:33:05',NULL,NULL),(27469,17696,'TE','5042170151',0,'2014-01-14 01:33:02',NULL,NULL),(27113,17441,'TE','4196915384',0,'2014-01-13 03:00:36',NULL,NULL),(26961,17339,'TE','4192830457',0,'2014-01-13 02:24:01',NULL,NULL),(42014,27927,'TE','3615710189',0,'2014-03-06 21:00:23',NULL,NULL),(42935,28548,'TE','4198108589',0,'2014-03-07 21:32:19',NULL,NULL),(10347,6745,'AP','4402286581',0,'2013-12-26 01:15:54',NULL,NULL),(10160,6642,'TE','3616483805',0,'2013-12-26 01:00:20',NULL,NULL),(41488,27580,'TE','8063837684',0,'2014-03-05 21:00:11',NULL,NULL),(38579,25496,'EM','HOLLYBAKER@FUSE.NET',0,'2014-02-25 21:31:51',NULL,NULL),(5531,3537,'EM','miller.amberm@gmail.com',0,'2013-12-25 21:21:40',NULL,NULL),(9775,6393,'TE','6145076195',0,'2013-12-26 00:48:12',NULL,NULL),(36782,24217,'AP','5126806048',0,'2014-02-16 19:00:27',NULL,NULL),(36493,24026,'TE','4194105442',0,'2014-02-15 22:00:50',NULL,NULL),(11571,7529,'AP','2542145182',0,'2013-12-26 02:32:38',NULL,NULL),(34663,22728,'TE','9857732797',0,'2014-02-11 21:01:14',NULL,NULL),(32824,21480,'TE','7035993022',0,'2014-02-04 21:01:42',NULL,NULL),(2245,1376,'AP','9585023962',0,'2013-12-25 18:45:57',NULL,NULL),(14074,9200,'TE','5137241839',0,'2013-12-26 04:09:38',NULL,NULL),(30209,19568,'AP','5045700473',0,'2014-01-23 03:02:36',NULL,NULL),(22366,14426,'TE','3618844049',0,'2013-12-28 03:31:48',NULL,NULL),(25867,16672,'TE','3305187404',0,'2014-01-08 18:24:29',NULL,NULL),(24370,15737,'TE','3303296904',0,'2014-01-03 02:00:42',NULL,NULL),(13931,9084,'AP','9374891970',0,'2013-12-26 04:06:55',NULL,NULL),(37834,24963,'AP','2253852819',0,'2014-02-20 22:00:21',NULL,NULL),(35495,23337,'EM','randydodie@hotmail.com',0,'2014-02-13 22:00:35',NULL,NULL),(4497,2861,'TE','5133782791',0,'2013-12-25 20:01:38',NULL,NULL),(31363,20439,'AP','5132818346',0,'2014-01-29 21:00:40',NULL,NULL),(29124,18809,'TE','3307947155',0,'2014-01-17 03:36:02',NULL,NULL),(4050,2585,'TE','4192030134',0,'2013-12-25 19:38:07',NULL,NULL),(27443,17678,'AP','5048583191',0,'2014-01-14 01:32:53',NULL,NULL),(21482,13804,'AP','6019402504',0,'2013-12-26 13:11:26',NULL,NULL),(43793,29070,'AP','4194602984',0,'2014-03-10 21:01:57',NULL,NULL),(11907,7748,'AP','3308333929',0,'2013-12-26 03:02:28',NULL,NULL),(41256,27413,'AP','4402898213',0,'2014-03-04 21:01:36',NULL,NULL),(39381,26045,'AP','3306038346',0,'2014-02-26 21:02:29',NULL,NULL),(7875,5136,'TE','2819209798',0,'2013-12-25 23:02:22',NULL,NULL),(20416,13145,'EM','ccreagh19@roadrunner.com',0,'2013-12-26 12:53:27',NULL,NULL),(26927,17320,'EM','profjohnaking@yahoo.com',0,'2014-01-13 02:23:50',NULL,NULL),(6499,4202,'EM','ccancel77@gmail.com',0,'2013-12-25 21:49:57',NULL,NULL),(13885,9055,'TE','5124198846',0,'2013-12-26 04:06:10',NULL,NULL),(35818,23553,'AP','4199538623',0,'2014-02-13 22:02:40',NULL,NULL),(35099,23055,'TE','5042967858',0,'2014-02-12 21:30:48',NULL,NULL),(11895,7739,'AP','3303045712',0,'2013-12-26 03:02:14',NULL,NULL),(32326,21117,'EM','alisarandolph@hotmail.com',0,'2014-02-03 21:00:11',NULL,NULL),(31749,20720,'AP','9377799008',0,'2014-01-30 21:01:14',NULL,NULL),(30433,19728,'AP','9852490350',0,'2014-01-23 21:01:04',NULL,NULL),(8948,5856,'AP','2604151048',0,'2013-12-25 23:48:57',NULL,NULL),(26116,16817,'AP','7137058263',0,'2014-01-13 02:18:20',NULL,NULL),(24082,15547,'TE','5042188537',1,'2014-01-02 04:31:09',NULL,NULL),(21876,14093,'AP','5132607421',0,'2013-12-27 02:01:24',NULL,NULL),(14805,9690,'AP','4192040926',0,'2013-12-26 04:39:41',NULL,NULL),(4456,2838,'TE','5133859445',0,'2013-12-25 20:00:59',NULL,NULL),(4066,2595,'EM','gray.annette21@yahoo.com',0,'2013-12-25 19:45:10',NULL,NULL),(8255,5399,'TE','4193945835',0,'2013-12-25 23:08:54',NULL,NULL),(2153,1326,'TE','4402370837',0,'2013-12-25 18:31:56',NULL,NULL),(2877,1763,'TE','9376385707',0,'2013-12-25 18:55:57',NULL,NULL),(43149,28679,'AP','4402135980',0,'2014-03-08 21:30:55',NULL,NULL),(43305,28769,'AP','6146190390',0,'2014-03-09 21:00:28',NULL,NULL),(3901,2477,'TE','5044628623',0,'2013-12-25 19:35:25',NULL,NULL),(41569,27639,'AP','3306631667',0,'2014-03-05 21:30:15',NULL,NULL),(3696,2344,'TE','8306253537',0,'2013-12-25 19:32:03',NULL,NULL),(14283,9342,'EM','siegen.conc3@sunriseseniorliving.com',0,'2013-12-26 04:31:03',NULL,NULL),(20873,13420,'AP','5134849106',0,'2013-12-26 13:00:48',NULL,NULL),(34064,22333,'AP','2105609863',0,'2014-02-10 11:01:02',NULL,NULL),(32187,21023,'EM','ikeg32@hotmail.com',0,'2014-02-01 19:00:41',NULL,NULL),(29083,18783,'AP','5133029763',0,'2014-01-17 03:35:53',NULL,NULL),(22344,14409,'TE','6825571773',0,'2013-12-28 03:31:24',NULL,NULL),(28340,18263,'TE','8304597612',0,'2014-01-16 08:44:37',NULL,NULL),(25761,16600,'TE','2258107760',0,'2014-01-08 18:24:04',NULL,NULL),(26443,17018,'TE','3309260383',0,'2014-01-13 02:20:39',NULL,NULL),(402,247,'AP','4194389189',0,'2013-12-25 17:21:28',NULL,NULL),(6586,4251,'TE','7046518553',0,'2013-12-25 21:51:17',NULL,NULL),(21348,13718,'TE','3305533155',0,'2013-12-26 13:09:08',NULL,NULL),(13996,9135,'TE','7406447267',0,'2013-12-26 04:08:04',NULL,NULL),(41048,27270,'AP','5203313498',0,'2014-03-04 21:00:16',NULL,NULL),(1443,879,'TE','6017575154',0,'2013-12-25 18:07:41',NULL,NULL),(32564,21294,'AP','9186079943',0,'2014-02-04 21:00:08',NULL,NULL),(11396,7418,'AP','9375161430',0,'2013-12-26 02:16:56',NULL,NULL),(26273,16910,'AP','5132524535',0,'2014-01-13 02:19:37',NULL,NULL),(25850,16663,'AP','5047828976',0,'2014-01-08 18:24:25',NULL,NULL),(6738,4376,'TE','4196373185',0,'2013-12-25 22:00:28',NULL,NULL),(14560,9514,'TE','4195629748',0,'2013-12-26 04:35:28',NULL,NULL),(43796,29073,'TE','4194477963',0,'2014-03-10 21:01:59',NULL,NULL),(14142,9259,'AP','5756023811',0,'2013-12-26 04:15:16',NULL,NULL),(5131,3288,'EM','abbi_koon@yahoo.com',0,'2013-12-25 21:15:26',NULL,NULL),(3872,2462,'TE','3185728700',0,'2013-12-25 19:34:58',NULL,NULL),(38158,25184,'EM','ianillustrates@gmail.com',0,'2014-02-21 22:00:36',NULL,NULL),(35896,23615,'TE','4197854725',0,'2014-02-13 22:03:14',NULL,NULL),(35016,22993,'TE','7409724714',0,'2014-02-12 21:30:15',NULL,NULL),(23855,15390,'AP','3306876126',1,'2014-01-02 04:25:44',NULL,NULL),(24249,15666,'TE','9373828297',1,'2014-01-02 04:34:38',NULL,NULL),(30917,20104,'TE','5049316712',0,'2014-01-27 21:00:37',NULL,NULL),(31644,20644,'EM','mudatherali@yahoo.com',0,'2014-01-30 21:00:35',NULL,NULL),(43877,29113,'AP','5043573555',0,'2014-03-10 21:02:25',NULL,NULL),(415,254,'EM','rondle.hall@live.com',0,'2013-12-25 17:21:40',NULL,NULL),(41141,27325,'AP','8326476330',0,'2014-03-04 21:00:49',NULL,NULL),(39913,26412,'TE','9406821700',0,'2014-02-28 07:00:40',NULL,NULL),(38879,25696,'AP','3253202321',0,'2014-02-26 09:30:16',NULL,NULL),(34590,22679,'AP','9562831893',0,'2014-02-11 21:00:47',NULL,NULL),(34283,22493,'TE','5134045817',0,'2014-02-10 21:31:09',NULL,NULL),(1495,919,'TE','3307920481',0,'2013-12-25 18:08:45',NULL,NULL),(34034,22319,'TE','3374362889',0,'2014-02-10 11:00:52',NULL,NULL),(3922,2487,'EM','smsark54@aol.com',0,'2013-12-25 19:35:42',NULL,NULL),(8300,5437,'EM','cynthia.williams20@gmail.com',0,'2013-12-25 23:09:50',NULL,NULL),(22878,14760,'TE','8178328199',1,'2013-12-29 11:12:41',NULL,NULL),(14477,9454,'AP','5134976040',0,'2013-12-26 04:34:04',NULL,NULL),(4673,2988,'AP','5133246048',0,'2013-12-25 20:17:22',NULL,NULL),(10355,6749,'TE','4198992857',0,'2013-12-26 01:16:02',NULL,NULL),(32772,21441,'TE','6015294788',0,'2014-02-04 21:01:24',NULL,NULL),(23810,15362,'AP','9373212846',1,'2014-01-02 04:24:49',NULL,NULL),(31176,20303,'TE','9563534348',0,'2014-01-28 21:00:45',NULL,NULL),(30223,19578,'TE','3184352020',0,'2014-01-23 03:02:39',NULL,NULL),(28387,18289,'TE','2165710638',0,'2014-01-16 08:44:51',NULL,NULL),(27583,17780,'AP','7132057273',0,'2014-01-14 01:33:42',NULL,NULL),(26577,17098,'AP','2102687470',0,'2014-01-13 02:21:31',NULL,NULL),(25194,16244,'TE','3303047571',0,'2014-01-05 00:02:29',NULL,NULL),(42882,28518,'AP','9372054310',0,'2014-03-07 21:31:59',NULL,NULL),(5221,3355,'EM','haile.gelila@yahoo.com',0,'2013-12-25 21:16:51',NULL,NULL),(4582,2925,'TE','5133126673',0,'2013-12-25 20:15:52',NULL,NULL),(39402,26054,'AP','3308618602',0,'2014-02-26 21:02:35',NULL,NULL),(38911,25723,'TE','5046550183',0,'2014-02-26 09:30:30',NULL,NULL),(31879,20808,'AP','9032585474',0,'2014-01-31 21:00:26',NULL,NULL),(29015,18733,'TE','9374089491',0,'2014-01-17 03:35:37',NULL,NULL),(8302,5439,'TE','5048854793',0,'2013-12-25 23:09:53',NULL,NULL),(42826,28483,'EM','beckncall2007@gmail.com',0,'2014-03-07 21:31:37',NULL,NULL),(9960,6518,'AP','5138506072',0,'2013-12-26 00:51:19',NULL,NULL),(42204,28035,'AP','9373607772',0,'2014-03-06 21:01:29',NULL,NULL),(40467,26862,'TE','8322641182',0,'2014-03-01 21:00:57',NULL,NULL),(37818,24956,'TE','2287317705',0,'2014-02-20 22:00:15',NULL,NULL),(24161,15614,'TE','6018508765',1,'2014-01-02 04:32:55',NULL,NULL),(25401,16382,'TE','2147621933',0,'2014-01-07 04:03:21',NULL,NULL),(25456,16415,'TE','8144907788',0,'2014-01-07 04:04:22',NULL,NULL),(6057,3897,'TE','3303299321',0,'2013-12-25 21:36:46',NULL,NULL),(40783,27104,'AP','5135468804',0,'2014-03-03 21:30:23',NULL,NULL),(39921,26418,'TE','9158339266',0,'2014-02-28 07:30:06',NULL,NULL),(9913,6488,'EM','saber9944@aol.com',0,'2013-12-26 00:50:30',NULL,NULL),(9486,6207,'AP','4197730331',0,'2013-12-26 00:30:46',NULL,NULL),(20485,13192,'EM','lilj713@msn.com',0,'2013-12-26 12:54:41',NULL,NULL),(31205,20320,'AP','3256605123',0,'2014-01-28 21:00:55',NULL,NULL),(43016,28603,'AP','3309627013',0,'2014-03-08 21:30:11',NULL,NULL),(11627,7562,'EM','bjpowers@go.olemiss.edu',0,'2013-12-26 02:33:32',NULL,NULL),(39763,26295,'EM','plsilcoxdc@sbcglobal.net',0,'2014-02-28 06:31:26',NULL,NULL),(39471,26100,'AP','3377065675',0,'2014-02-28 06:30:12',NULL,NULL),(36739,24187,'EM','srivas2310@gmail.com',0,'2014-02-16 19:00:12',NULL,NULL),(34825,22841,'TE','4195604753',0,'2014-02-11 21:02:13',NULL,NULL),(14886,9743,'AP','9364889008',0,'2013-12-26 04:45:59',NULL,NULL),(32052,20923,'TE','3306975537',0,'2014-01-31 21:01:34',NULL,NULL),(22501,14507,'TE','3254360120',0,'2013-12-28 03:33:57',NULL,NULL),(29595,19123,'AP','4408362152',0,'2014-01-21 08:45:19',NULL,NULL),(24333,15717,'EM','bknowok@att.net',0,'2014-01-03 02:00:05',NULL,NULL),(22512,14515,'AP','7605229485',0,'2013-12-28 03:34:09',NULL,NULL),(43909,29131,'AP','9379253641',0,'2014-03-10 21:02:37',NULL,NULL),(1864,1151,'TE','5047829850',0,'2013-12-25 18:18:38',NULL,NULL),(5815,3734,'AP','8064742480',0,'2013-12-25 21:32:41',NULL,NULL),(39594,26193,'TE','4196315888',0,'2014-02-28 06:30:45',NULL,NULL),(2943,1815,'TE','3472069613',0,'2013-12-25 18:57:05',NULL,NULL),(21970,14151,'EM','sean27483@gmail.com',0,'2013-12-27 02:02:55',NULL,NULL),(35738,23504,'AP','9405976046',0,'2014-02-13 22:02:10',NULL,NULL),(31929,20843,'TE','4404786457',0,'2014-01-31 21:00:48',NULL,NULL),(22575,14559,'TE','3309491219',0,'2013-12-28 03:35:14',NULL,NULL),(25382,16369,'AP','8326613989',0,'2014-01-07 04:03:00',NULL,NULL),(7719,5040,'AP','6019239602',0,'2013-12-25 22:48:00',NULL,NULL),(41601,27659,'AP','4196851573',0,'2014-03-05 21:30:26',NULL,NULL),(40985,27232,'TE','4407155019',0,'2014-03-03 21:31:42',NULL,NULL),(10405,6783,'TE','9366727777',0,'2013-12-26 01:16:54',NULL,NULL),(38915,25725,'TE','2254482482',0,'2014-02-26 09:30:31',NULL,NULL),(37643,24810,'AP','5133770116',0,'2014-02-20 04:49:50',NULL,NULL),(4294,2741,'AP','3306033903',0,'2013-12-25 19:48:48',NULL,NULL),(29862,19320,'AP','9792000469',1,'2014-01-22 03:22:11',NULL,NULL),(21373,13743,'TE','5133140487',0,'2013-12-26 13:09:45',NULL,NULL),(23706,15301,'TE','3184369580',1,'2014-01-02 04:22:50',NULL,NULL),(5761,3690,'AP','4193413302',0,'2013-12-25 21:31:43',NULL,NULL),(14378,9402,'TE','2813829451',0,'2013-12-26 04:32:37',NULL,NULL),(5173,3320,'AP','4197883957',0,'2013-12-25 21:16:03',NULL,NULL),(2885,1766,'TE','6146380216',0,'2013-12-25 18:56:02',NULL,NULL),(9951,6511,'EM','dcochoy@neo.rr.com',0,'2013-12-26 00:51:08',NULL,NULL),(8935,5849,'EM','gerrencorprew01@yahoo.com',0,'2013-12-25 23:48:45',NULL,NULL),(27358,17613,'AP','9156917122',0,'2014-01-14 01:32:23',NULL,NULL),(31034,20190,'TE','2547992485',0,'2014-01-27 21:01:26',NULL,NULL),(43275,28750,'AP','9564045629',0,'2014-03-09 21:00:16',NULL,NULL),(7160,4671,'TE','3377895545',0,'2013-12-25 22:07:37',NULL,NULL),(3387,2130,'AP','5137069596',0,'2013-12-25 19:17:56',NULL,NULL),(36588,24084,'EM','jenniferlynn.jassem@yahoo.com',0,'2014-02-15 22:01:23',NULL,NULL),(4431,2825,'TE','4403441240',0,'2013-12-25 20:00:37',NULL,NULL),(21072,13551,'AP','2253549139',0,'2013-12-26 13:04:06',NULL,NULL),(34676,22739,'TE','3187282044',0,'2014-02-11 21:01:19',NULL,NULL),(34643,22714,'TE','9174567350',0,'2014-02-11 21:01:06',NULL,NULL),(26533,17069,'AP','2147355189',0,'2014-01-13 02:21:16',NULL,NULL),(26776,17225,'EM','therese_watkins@yahoo.com',0,'2014-01-13 02:22:36',NULL,NULL),(29977,19398,'TE','7407753028',1,'2014-01-22 03:22:52',NULL,NULL),(232,142,'TE','3306664113',0,'2013-12-25 17:18:43',NULL,NULL),(42229,28052,'AP','6016653685',0,'2014-03-06 21:01:38',NULL,NULL),(36593,24089,'EM','eaver.3@hotmail.com',0,'2014-02-15 22:01:25',NULL,NULL),(13515,8812,'TE','5132380301',0,'2013-12-26 04:00:03',NULL,NULL),(977,601,'TE','5135467371',0,'2013-12-25 18:00:19',NULL,NULL),(8990,5901,'TE','4408881843',0,'2013-12-25 23:49:47',NULL,NULL),(4461,2841,'EM','josephc@cinci.rr.com',0,'2013-12-25 20:01:04',NULL,NULL),(1356,828,'AP','3303389392',0,'2013-12-25 18:06:16',NULL,NULL),(3558,2227,'AP','4197440187',0,'2013-12-25 19:20:42',NULL,NULL),(4354,2778,'TE','6625781627',0,'2013-12-25 19:49:45',NULL,NULL),(42293,28085,'TE','7134094416',0,'2014-03-06 21:02:00',NULL,NULL),(40039,26540,'TE','4196219051',0,'2014-02-28 21:30:08',NULL,NULL),(38834,25669,'AP','6018268218',0,'2014-02-26 08:30:51',NULL,NULL),(10497,6838,'TE','5137231330',0,'2013-12-26 01:31:00',NULL,NULL),(36457,24006,'TE','5137487539',0,'2014-02-15 22:00:37',NULL,NULL),(31549,20565,'TE','4197333551',0,'2014-01-29 21:01:49',NULL,NULL),(21690,13965,'EM','lndenison@gmail.com',0,'2013-12-26 13:15:15',NULL,NULL),(30,19,'TE','3306593447',0,'2013-12-25 17:15:30',NULL,NULL),(7861,5128,'TE','2142153503',0,'2013-12-25 23:02:10',NULL,NULL),(29599,19125,'EM','freecrazyrose@yahoo.com',0,'2014-01-21 08:45:20',NULL,NULL),(29545,19094,'EM','bonniehasty67@yahoo.com',0,'2014-01-21 08:44:34',NULL,NULL),(26944,17328,'EM','jonathanclester@gmail.com',0,'2014-01-13 02:23:55',NULL,NULL),(41485,27578,'TE','3302121415',0,'2014-03-04 21:30:24',NULL,NULL),(43776,29060,'TE','3306316312',0,'2014-03-10 21:01:51',NULL,NULL),(10124,6620,'AP','3307030667',0,'2013-12-26 00:54:01',NULL,NULL),(8296,5435,'EM','elisenthompson@yahoo.com',0,'2013-12-25 23:09:47',NULL,NULL),(3899,2475,'AP','2253354221',0,'2013-12-25 19:35:22',NULL,NULL),(2139,1319,'EM','tjones_southerncompliance@yahoo.com',0,'2013-12-25 18:31:40',NULL,NULL),(30461,19748,'EM','brigittedfw@yahoo.com',0,'2014-01-23 21:01:16',NULL,NULL),(13577,8852,'TE','9038755904',0,'2013-12-26 04:01:04',NULL,NULL),(14309,9357,'EM','elias_12@yahoo.com',0,'2013-12-26 04:31:26',NULL,NULL),(25853,16665,'TE','5046555982',0,'2014-01-08 18:24:26',NULL,NULL),(22790,14695,'AP','5133058067',1,'2013-12-29 11:08:56',NULL,NULL),(23152,14925,'TE','5133400705',0,'2013-12-30 00:01:49',NULL,NULL),(7,5,'TE','5137736264',0,'2013-12-25 17:15:09',NULL,NULL),(39249,25966,'AP','5134446590',0,'2014-02-26 21:01:44',NULL,NULL),(34121,22373,'TE','9729041696',0,'2014-02-10 21:00:14',NULL,NULL),(11170,7266,'AP','9796613718',0,'2013-12-26 02:02:16',NULL,NULL),(31315,20403,'BN','8177265873',0,'2014-01-29 21:00:21',NULL,NULL),(29614,19133,'AP','5672040531',0,'2014-01-21 08:45:25',NULL,NULL),(8258,5402,'TE','5136816589',0,'2013-12-25 23:08:59',NULL,NULL),(24298,15699,'TE','3305333324',1,'2014-01-02 04:35:39',NULL,NULL),(43114,28660,'TE','3374597602',0,'2014-03-08 21:30:43',NULL,NULL),(1755,1083,'TE','4405211621',0,'2013-12-25 18:16:50',NULL,NULL),(13793,8993,'AP','4197226932',0,'2013-12-26 04:04:38',NULL,NULL),(38164,25189,'AP','8016808942',0,'2014-02-21 22:00:39',NULL,NULL),(4178,2669,'TE','3305595203',0,'2013-12-25 19:47:00',NULL,NULL),(33957,22280,'TE','5132422494',0,'2014-02-10 11:00:21',NULL,NULL),(9493,6211,'TE','9727461748',0,'2013-12-26 00:30:54',NULL,NULL),(1999,1235,'AP','3184171196',0,'2013-12-25 18:20:50',NULL,NULL),(9328,6111,'TE','3303106840',0,'2013-12-26 00:15:27',NULL,NULL),(69,44,'TE','5133195679',0,'2013-12-25 17:16:10',NULL,NULL),(230,141,'AP','3304723123',0,'2013-12-25 17:18:42',NULL,NULL),(6965,4542,'TE','8067293963',0,'2013-12-25 22:04:19',NULL,NULL),(6955,4534,'TE','9795678485',0,'2013-12-25 22:04:08',NULL,NULL),(37634,24804,'TE','9372426542',0,'2014-02-20 04:48:50',NULL,NULL),(34687,22747,'TE','5134392250',0,'2014-02-11 21:01:24',NULL,NULL),(24164,15615,'TE','6012141387',1,'2014-01-02 04:32:58',NULL,NULL),(28234,18208,'AP','9372156423',0,'2014-01-15 02:08:08',NULL,NULL),(29208,18868,'EM','guyheno@gmail.com',0,'2014-01-17 03:36:23',NULL,NULL),(12028,7842,'TE','4403170019',0,'2013-12-26 03:04:38',NULL,NULL),(8143,5328,'EM','bartsu@gmail.com',0,'2013-12-25 23:07:02',NULL,NULL),(36253,23857,'AP','2148092722',0,'2014-02-14 21:32:02',NULL,NULL),(1123,690,'AP','7404057886',0,'2013-12-25 18:02:37',NULL,NULL),(2628,1598,'TE','3252007241',0,'2013-12-25 18:51:58',NULL,NULL),(31290,20384,'AP','9129803208',0,'2014-01-29 21:00:13',NULL,NULL),(3135,1953,'AP','8176816774',0,'2013-12-25 19:01:02',NULL,NULL),(23060,14874,'TE','9035132060',0,'2013-12-30 00:00:19',NULL,NULL),(20834,13391,'EM','speak2sweet@yahoo.com',0,'2013-12-26 13:00:10',NULL,NULL),(6655,4318,'TE','5132396554',0,'2013-12-25 21:52:42',NULL,NULL),(39060,25835,'EM','hookjamie69@yahoo.com',0,'2014-02-26 21:00:32',NULL,NULL),(9078,5953,'TE','6012099814',0,'2013-12-25 23:51:08',NULL,NULL),(32727,21409,'AP','3304799394',0,'2014-02-04 21:01:07',NULL,NULL),(31947,20854,'TE','9373619040',0,'2014-01-31 21:00:54',NULL,NULL),(31277,20376,'TE','9032466287',0,'2014-01-29 21:00:08',NULL,NULL),(24309,15703,'EM','larry@motortech.us',1,'2014-01-02 04:35:49',NULL,NULL),(29437,19034,'TE','6016043930',0,'2014-01-20 08:06:33',NULL,NULL),(25316,16326,'TE','3182223947',0,'2014-01-07 04:01:50',NULL,NULL),(25046,16144,'TE','9377801045',0,'2014-01-04 02:06:06',NULL,NULL),(41223,27382,'TE','6622133288',0,'2014-03-04 21:01:21',NULL,NULL),(41568,27639,'TE','3306631667',0,'2014-03-05 21:30:15',NULL,NULL),(13543,8830,'AP','9564593908',0,'2013-12-26 04:00:30',NULL,NULL),(38442,25405,'AP','3608785083',0,'2014-02-25 21:30:59',NULL,NULL),(38386,25360,'TE','5133072282',0,'2014-02-25 21:30:35',NULL,NULL),(37089,24420,'TE','3302253006',0,'2014-02-18 22:01:07',NULL,NULL),(14442,9437,'TE','5132215451',0,'2013-12-26 04:33:34',NULL,NULL),(20995,13511,'AP','2259935723',0,'2013-12-26 13:02:54',NULL,NULL),(42364,28137,'EM','manda.rose4320@gmail.com',0,'2014-03-06 21:02:28',NULL,NULL),(2242,1375,'TE','2146412128',0,'2013-12-25 18:45:55',NULL,NULL),(40243,26695,'AP','5049577812',0,'2014-02-28 21:31:30',NULL,NULL),(5063,3249,'EM','bblack10@cox.net',0,'2013-12-25 20:46:35',NULL,NULL),(5722,3671,'AP','4192622632',0,'2013-12-25 21:31:10',NULL,NULL),(4010,2550,'TE','3306680044',0,'2013-12-25 19:37:15',NULL,NULL),(22283,14363,'TE','5134047071',0,'2013-12-28 03:30:19',NULL,NULL),(36729,24184,'TE','4194603661',0,'2014-02-16 19:00:09',NULL,NULL),(29221,18874,'AP','5047018964',0,'2014-01-17 03:36:25',NULL,NULL),(31396,20463,'TE','3308585870',0,'2014-01-29 21:00:52',NULL,NULL),(31470,20509,'TE','3187800577',0,'2014-01-29 21:01:18',NULL,NULL),(41739,27755,'TE','5042488703',0,'2014-03-05 21:31:17',NULL,NULL),(831,516,'EM','R_Compton43@hotmail.com',0,'2013-12-25 17:49:05',NULL,NULL),(11585,7540,'TE','3252349692',0,'2013-12-26 02:32:52',NULL,NULL),(38502,25444,'TE','9562508121',0,'2014-02-25 21:31:22',NULL,NULL),(38341,25328,'EM','mark@markrosenbohm.com',0,'2014-02-25 21:30:15',NULL,NULL),(20536,13220,'TE','7138051773',0,'2013-12-26 12:55:27',NULL,NULL),(31926,20841,'TE','4237873709',0,'2014-01-31 21:00:46',NULL,NULL),(20970,13497,'TE','3307845957',0,'2013-12-26 13:02:30',NULL,NULL),(21624,13917,'TE','4192441559',0,'2013-12-26 13:14:07',NULL,NULL),(22572,14555,'EM','martha.partin@yahoo.com',0,'2013-12-28 03:35:10',NULL,NULL),(27343,17607,'TE','9035038805',0,'2014-01-14 01:32:19',NULL,NULL),(23727,15309,'EM','Jfazende5683@gmail.com',1,'2014-01-02 04:23:09',NULL,NULL),(6164,3971,'EM','steve.c.mcgarvey@gmail.com',0,'2013-12-25 21:38:35',NULL,NULL),(38756,25620,'AP','7132593458',0,'2014-02-26 08:30:17',NULL,NULL),(4598,2933,'AP','9379023941',0,'2013-12-25 20:16:04',NULL,NULL),(11880,7732,'TE','9373020120',0,'2013-12-26 03:02:03',NULL,NULL),(32758,21430,'AP','8062520577',0,'2014-02-04 21:01:18',NULL,NULL),(30125,19512,'AP','8144875791',0,'2014-01-23 03:02:15',NULL,NULL),(29835,19300,'EM','ames6196@outlook.com',1,'2014-01-22 03:22:01',NULL,NULL),(27632,17812,'AP','5127208310',0,'2014-01-15 02:05:53',NULL,NULL),(1255,762,'AP','2145647236',0,'2013-12-25 18:04:36',NULL,NULL),(22588,14569,'TE','5132645684',0,'2013-12-28 03:35:29',NULL,NULL),(7706,5031,'AP','4192367632',0,'2013-12-25 22:47:46',NULL,NULL),(14685,9609,'EM','tinwzrdslady@aol.com',0,'2013-12-26 04:37:36',NULL,NULL),(20990,13508,'EM','videaut@aol.com',0,'2013-12-26 13:02:49',NULL,NULL),(20906,13445,'TE','9377460798',0,'2013-12-26 13:01:20',NULL,NULL),(43585,28941,'AP','4406105565',0,'2014-03-10 21:00:43',NULL,NULL),(157,94,'AP','3253206093',0,'2013-12-25 17:17:31',NULL,NULL),(666,416,'AP','3307661185',0,'2013-12-25 17:46:31',NULL,NULL),(39304,26001,'EM','voycell86@yahoo.com',0,'2014-02-26 21:02:03',NULL,NULL),(37211,24490,'TE','9794791813',0,'2014-02-20 03:44:16',NULL,NULL),(8617,5661,'EM','brian.gallagher@austin.utexas.edu',0,'2013-12-25 23:31:47',NULL,NULL),(34949,22943,'TE','3307947010',0,'2014-02-11 21:30:21',NULL,NULL),(29056,18763,'TE','5017662787',0,'2014-01-17 03:35:47',NULL,NULL),(24871,16038,'TE','3256983836',0,'2014-01-04 02:02:45',NULL,NULL),(22556,14547,'EM','fid@freddymond.com',0,'2013-12-28 03:34:55',NULL,NULL),(3915,2484,'AP','3373510054',0,'2013-12-25 19:35:36',NULL,NULL),(369,225,'AP','9857094325',0,'2013-12-25 17:20:54',NULL,NULL),(11509,7489,'EM','rhondablair2@gmail.com',0,'2013-12-26 02:31:35',NULL,NULL),(40297,26733,'TE','4195810862',0,'2014-02-28 21:31:50',NULL,NULL),(39498,26125,'AP','9372243300',0,'2014-02-28 06:30:21',NULL,NULL),(9746,6373,'TE','2164086017',0,'2013-12-26 00:47:44',NULL,NULL),(1073,660,'TE','9372608247',0,'2013-12-25 18:01:52',NULL,NULL),(36702,24164,'AP','3307150068',0,'2014-02-15 22:02:05',NULL,NULL),(31963,20871,'TE','6013163209',0,'2014-01-31 21:01:02',NULL,NULL),(4877,3122,'AP','3304160948',0,'2013-12-25 20:30:20',NULL,NULL),(28620,18451,'TE','9855703580',0,'2014-01-16 08:46:07',NULL,NULL),(28386,18287,'AP','4404528458',0,'2014-01-16 08:44:51',NULL,NULL),(26343,16956,'TE','4402656017',0,'2014-01-13 02:20:04',NULL,NULL),(24945,16079,'EM','ROBERT_TRENT2003@YAHOO.COM',0,'2014-01-04 02:04:03',NULL,NULL),(22274,14356,'TE','7404072871',0,'2013-12-28 03:30:10',NULL,NULL),(3389,2132,'TE','4199898940',0,'2013-12-25 19:17:59',NULL,NULL),(21623,13916,'TE','4192920206',0,'2013-12-26 13:14:06',NULL,NULL),(2687,1633,'TE','9037015095',0,'2013-12-25 18:52:52',NULL,NULL),(11575,7532,'AP','3148249793',0,'2013-12-26 02:32:43',NULL,NULL),(36424,23990,'AP','3184523619',0,'2014-02-15 22:00:26',NULL,NULL),(36283,23889,'AP','5134767099',0,'2014-02-14 21:32:17',NULL,NULL),(33763,22154,'EM','jaykuhn40@gmail.com',0,'2014-02-08 19:00:56',NULL,NULL),(7452,4852,'EM','wrstout@ioyouth.org',0,'2013-12-25 22:30:25',NULL,NULL),(30007,19432,'AP','4194380271',1,'2014-01-22 03:23:08',NULL,NULL),(9347,6119,'EM','kking21@hotmail.com',0,'2013-12-26 00:15:42',NULL,NULL),(9230,6040,'AP','9852372989',0,'2013-12-26 00:01:23',NULL,NULL),(25649,16540,'EM','KANTHIR@YAHOO.COM',1,'2014-01-07 10:22:21',NULL,NULL),(22236,14331,'EM','gholeton@neo.rr.com',0,'2013-12-27 02:07:34',NULL,NULL),(21515,13828,'TE','3304147918',0,'2013-12-26 13:12:04',NULL,NULL),(21040,13537,'TE','2253644575',0,'2013-12-26 13:03:39',NULL,NULL),(8444,5556,'TE','3308271332',0,'2013-12-25 23:16:17',NULL,NULL),(156,94,'TE','3253206093',0,'2013-12-25 17:17:31',NULL,NULL),(10789,7014,'TE','8062836595',0,'2013-12-26 01:48:37',NULL,NULL),(23691,15294,'EM','WRIG4008@GMAIL.COM',1,'2014-01-02 04:22:35',NULL,NULL),(43825,29089,'EM','ijimenez7@yahoo.com',0,'2014-03-10 21:02:09',NULL,NULL),(32087,20956,'AP','2545419663',0,'2014-02-01 19:00:07',NULL,NULL),(35988,23677,'TE','3184194859',0,'2014-02-14 21:30:28',NULL,NULL),(2039,1263,'TE','9564291003',0,'2013-12-25 18:30:03',NULL,NULL),(14986,9806,'EM','dustybodenmiller@gmail.com',0,'2013-12-26 05:01:23',NULL,NULL),(38286,25281,'TE','8177186201',0,'2014-02-25 21:00:17',NULL,NULL),(35381,23253,'TE','5132768121',0,'2014-02-13 21:30:06',NULL,NULL),(34017,22312,'AP','6626643578',0,'2014-02-10 11:00:46',NULL,NULL),(33694,22101,'TE','7247773860',0,'2014-02-08 19:00:30',NULL,NULL),(23858,15392,'EM','pmc78lov@aol.com',1,'2014-01-02 04:25:47',NULL,NULL),(32652,21356,'TE','2542399133',0,'2014-02-04 21:00:40',NULL,NULL),(29143,18826,'TE','6018550353',0,'2014-01-17 03:36:08',NULL,NULL),(42233,28054,'AP','6015402289',0,'2014-03-06 21:01:40',NULL,NULL),(7261,4734,'AP','4193480854',0,'2013-12-25 22:09:15',NULL,NULL),(41403,27507,'TE','4192903672',0,'2014-03-04 21:02:31',NULL,NULL),(25986,16744,'TE','3307145168',0,'2014-01-08 18:24:52',NULL,NULL),(36625,24112,'TE','8067780782',0,'2014-02-15 22:01:37',NULL,NULL),(26958,17337,'AP','5042360180',0,'2014-01-13 02:24:00',NULL,NULL),(27427,17665,'EM','dave@answerglobal.com',0,'2014-01-14 01:32:47',NULL,NULL),(1071,658,'AP','5672257240',0,'2013-12-25 18:01:49',NULL,NULL),(5793,3713,'TE','6144042246',0,'2013-12-25 21:32:15',NULL,NULL),(39619,26204,'TE','4403433331',0,'2014-02-28 06:30:50',NULL,NULL),(10729,6978,'AP','5133712933',0,'2013-12-26 01:47:38',NULL,NULL),(36461,24008,'AP','4402429019',0,'2014-02-15 22:00:38',NULL,NULL),(6270,4044,'EM','LINDA402@AOL.COM',0,'2013-12-25 21:46:12',NULL,NULL),(22131,14256,'TE','2259102917',0,'2013-12-27 02:05:39',NULL,NULL),(32248,21061,'TE','2257552054',0,'2014-02-02 19:00:12',NULL,NULL),(31965,20871,'EM','dfapotts@yahoo.com',0,'2014-01-31 21:01:02',NULL,NULL),(25170,16228,'EM','jgross8@neo.rr.com',0,'2014-01-05 00:02:00',NULL,NULL),(25792,16621,'TE','9548018213',0,'2014-01-08 18:24:11',NULL,NULL),(26829,17256,'TE','4408928733',0,'2014-01-13 02:23:15',NULL,NULL),(2423,1482,'TE','6142043742',0,'2013-12-25 18:48:50',NULL,NULL),(7155,4668,'TE','2259387326',0,'2013-12-25 22:07:32',NULL,NULL),(21546,13854,'TE','5137059529',0,'2013-12-26 13:12:39',NULL,NULL),(36218,23839,'TE','5133749517',0,'2014-02-14 21:31:51',NULL,NULL),(36026,23695,'AP','3308130186',0,'2014-02-14 21:30:40',NULL,NULL),(35076,23036,'TE','2147829965',0,'2014-02-12 21:30:37',NULL,NULL),(43954,29156,'AP','4193456911',0,'2014-03-10 21:02:52',NULL,NULL),(7123,4650,'TE','5134971902',0,'2013-12-25 22:07:03',NULL,NULL),(2379,1445,'TE','9375159369',0,'2013-12-25 18:47:57',NULL,NULL),(21349,13719,'TE','2158739333',0,'2013-12-26 13:09:10',NULL,NULL),(26398,16991,'TE','3254554292',0,'2014-01-13 02:20:24',NULL,NULL),(25933,16708,'AP','7193342320',0,'2014-01-08 18:24:41',NULL,NULL),(32174,21016,'AP','7409011361',0,'2014-02-01 19:00:37',NULL,NULL),(32483,21226,'TE','4193412580',0,'2014-02-03 21:01:06',NULL,NULL),(33395,21882,'AP','5042013231',0,'2014-02-06 21:01:32',NULL,NULL),(39209,25931,'TE','9036677836',0,'2014-02-26 21:01:26',NULL,NULL),(35502,23341,'AP','4406559466',0,'2014-02-13 22:00:38',NULL,NULL),(11636,7568,'AP','4194198033',0,'2013-12-26 02:33:42',NULL,NULL),(39725,26274,'TE','3184554078',0,'2014-02-28 06:31:17',NULL,NULL),(36070,23725,'TE','2813922316',0,'2014-02-14 21:30:55',NULL,NULL),(35074,23034,'AP','9152404350',0,'2014-02-12 21:30:36',NULL,NULL),(7980,5205,'EM','lhhlvslrh@yahoo.com',0,'2013-12-25 23:04:09',NULL,NULL),(33669,22086,'TE','9852711204',0,'2014-02-08 19:00:21',NULL,NULL),(30503,19784,'EM','jamesjlaplant@yahoo.com',0,'2014-01-23 21:01:37',NULL,NULL),(28959,18691,'EM','conooboo@cox.net',0,'2014-01-17 03:35:25',NULL,NULL),(28149,18145,'EM','freemanmts@charter.net',0,'2014-01-15 02:07:48',NULL,NULL),(23419,15085,'TE','3256729364',0,'2014-01-01 12:04:18',NULL,NULL),(5356,3431,'TE','3235944868',0,'2013-12-25 21:18:56',NULL,NULL),(10094,6594,'EM','elizag217@gmail.com',0,'2013-12-26 00:53:22',NULL,NULL),(42481,28242,'EM','t.kingsland@aol.com',0,'2014-03-07 21:00:10',NULL,NULL),(1796,1114,'TE','5133384305',0,'2013-12-25 18:17:36',NULL,NULL),(37813,24953,'TE','3186062917',0,'2014-02-20 22:00:13',NULL,NULL),(35919,23635,'AP','9523039147',0,'2014-02-14 21:30:05',NULL,NULL),(10915,7092,'EM','timandtinab@yahoo.com',0,'2013-12-26 01:50:35',NULL,NULL),(34602,22691,'TE','9797391779',0,'2014-02-11 21:00:52',NULL,NULL),(9036,5929,'EM','sailors.anchor@gmail.com',0,'2013-12-25 23:50:28',NULL,NULL),(24937,16074,'EM','rbender1981@gmail.com',0,'2014-01-04 02:03:55',NULL,NULL),(24228,15653,'EM','c_mack526@yahoo.com',1,'2014-01-02 04:34:11',NULL,NULL),(4268,2729,'AP','9852861125',0,'2013-12-25 19:48:25',NULL,NULL),(14149,9262,'AP','5049205703',0,'2013-12-26 04:15:22',NULL,NULL),(35523,23363,'EM','drbethdawson@yahoo.com',0,'2014-02-13 22:00:47',NULL,NULL),(32848,21498,'AP','5174886566',0,'2014-02-04 21:01:50',NULL,NULL),(29013,18729,'TE','9374089491',0,'2014-01-17 03:35:37',NULL,NULL),(11948,7782,'TE','2103961777',0,'2013-12-26 03:03:13',NULL,NULL),(9009,5911,'TE','2146755359',0,'2013-12-25 23:50:03',NULL,NULL),(20726,13321,'TE','9566904098',0,'2013-12-26 12:58:22',NULL,NULL),(22675,14620,'EM','JROLL1993@GMAIL.COM',0,'2013-12-28 03:36:55',NULL,NULL),(7521,4903,'TE','2163102470',0,'2013-12-25 22:31:50',NULL,NULL),(28993,18714,'EM','dhoehn@marathonpetroleum.com',0,'2014-01-17 03:35:32',NULL,NULL),(37066,24407,'TE','5132420001',0,'2014-02-18 22:00:59',NULL,NULL),(32485,21226,'EM','mark_smith206@outlook.com',0,'2014-02-03 21:01:06',NULL,NULL),(31745,20718,'TE','9372186188',0,'2014-01-30 21:01:12',NULL,NULL),(30149,19535,'AP','3306972909',0,'2014-01-23 03:02:22',NULL,NULL),(42437,28186,'TE','7248562145',0,'2014-03-06 21:02:57',NULL,NULL),(11790,7669,'TE','2252615401',0,'2013-12-26 03:00:31',NULL,NULL),(41624,27671,'TE','9567230320',0,'2014-03-05 21:30:33',NULL,NULL),(40905,27179,'AP','2102165542',0,'2014-03-03 21:31:10',NULL,NULL),(40687,27019,'AP','6149059232',0,'2014-03-03 21:00:12',NULL,NULL),(39599,26196,'AP','3303297070',0,'2014-02-28 06:30:46',NULL,NULL),(38715,25589,'EM','rmbalcala@gmail.com',0,'2014-02-26 08:00:42',NULL,NULL),(6855,4446,'AP','7402216235',0,'2013-12-25 22:02:17',NULL,NULL),(11031,7160,'TE','9374789356',0,'2013-12-26 01:52:26',NULL,NULL),(5819,3736,'TE','8173601723',0,'2013-12-25 21:32:45',NULL,NULL),(31898,20818,'TE','2256031934',0,'2014-01-31 21:00:33',NULL,NULL),(23262,14987,'AP','3616524781',0,'2014-01-01 12:01:19',NULL,NULL),(24337,15719,'TE','4403581235',0,'2014-01-03 02:00:09',NULL,NULL),(26405,16993,'AP','4192174195',0,'2014-01-13 02:20:26',NULL,NULL),(12147,7935,'EM','mrsgalleyboss@cox.net',0,'2013-12-26 03:06:44',NULL,NULL),(39947,26440,'AP','6149612324',0,'2014-02-28 07:30:20',NULL,NULL),(9299,6090,'AP','9376132377',0,'2013-12-26 00:02:44',NULL,NULL),(4892,3136,'AP','3612377941',0,'2013-12-25 20:30:42',NULL,NULL),(8210,5376,'TE','2256367684',0,'2013-12-25 23:08:13',NULL,NULL),(2733,1658,'TE','5743609771',0,'2013-12-25 18:53:33',NULL,NULL),(31531,20548,'TE','5133305537',0,'2014-01-29 21:01:40',NULL,NULL),(21634,13926,'TE','4194385227',0,'2013-12-26 13:14:19',NULL,NULL),(34423,22581,'TE','9373947517',0,'2014-02-10 21:32:03',NULL,NULL),(31712,20696,'TE','4196027888',0,'2014-01-30 21:01:00',NULL,NULL),(29722,19218,'EM','trisharowland0867@yahoo.com',0,'2014-01-21 08:46:25',NULL,NULL),(26651,17146,'TE','2257774284',0,'2014-01-13 02:21:54',NULL,NULL),(25537,16474,'TE','3303885969',0,'2014-01-07 04:06:03',NULL,NULL),(23439,15105,'EM','shaun2240@neo.rr.com',0,'2014-01-01 12:04:49',NULL,NULL),(21375,13743,'TE','5133140487',0,'2013-12-26 13:09:46',NULL,NULL),(207,126,'AP','2282184686',0,'2013-12-25 17:18:20',NULL,NULL),(414,254,'AP','3182351810',0,'2013-12-25 17:21:39',NULL,NULL),(1661,1020,'AP','6628580380',0,'2013-12-25 18:15:13',NULL,NULL),(38563,25486,'TE','7692166137',0,'2014-02-25 21:31:45',NULL,NULL),(35509,23351,'TE','3306180510',0,'2014-02-13 22:00:42',NULL,NULL),(9308,6096,'TE','3375504275',0,'2013-12-26 00:15:04',NULL,NULL),(33571,22011,'TE','3306381007',0,'2014-02-07 19:00:51',NULL,NULL),(32871,21511,'EM','jyoun2@mail.com',0,'2014-02-04 21:01:59',NULL,NULL),(31440,20493,'AP','2542200583',0,'2014-01-29 21:01:08',NULL,NULL),(11729,7634,'AP','5139675614',0,'2013-12-26 02:46:21',NULL,NULL),(13925,9080,'TE','3302067279',0,'2013-12-26 04:06:49',NULL,NULL),(21508,13822,'AP','2163756063',0,'2013-12-26 13:11:54',NULL,NULL),(25417,16394,'AP','2108836426',0,'2014-01-07 04:03:40',NULL,NULL),(42076,27958,'TE','2253296687',0,'2014-03-06 21:00:43',NULL,NULL),(42634,28361,'AP','7136143770',0,'2014-03-07 21:30:29',NULL,NULL),(160,95,'AP','2143543606',0,'2013-12-25 17:17:33',NULL,NULL),(4672,2988,'TE','5133477080',0,'2013-12-25 20:17:22',NULL,NULL),(39083,25856,'TE','5044153078',0,'2014-02-26 21:00:42',NULL,NULL),(28842,18625,'EM','drroyscott@gmail.com',0,'2014-01-16 08:47:30',NULL,NULL),(22600,14575,'TE','2253850267',0,'2013-12-28 03:35:40',NULL,NULL),(41975,27902,'AP','4327411499',0,'2014-03-06 21:00:10',NULL,NULL),(42084,27961,'EM','lm8648@yahoo.com',0,'2014-03-06 21:00:45',NULL,NULL),(42555,28318,'TE','9723758650',0,'2014-03-07 21:30:03',NULL,NULL),(1178,722,'EM','alcalaralph4@gmail.com',0,'2013-12-25 18:03:30',NULL,NULL),(1652,1014,'TE','2282842014',0,'2013-12-25 18:15:05',NULL,NULL),(38808,25658,'TE','3302450955',0,'2014-02-26 08:30:43',NULL,NULL),(2260,1385,'TE','3187675949',0,'2013-12-25 18:46:13',NULL,NULL),(4611,2941,'EM','rmstacy57@yahoo.com',0,'2013-12-25 20:16:15',NULL,NULL),(3430,2152,'TE','2256032075',0,'2013-12-25 19:18:37',NULL,NULL),(11820,7690,'AP','5135204635',0,'2013-12-26 03:01:01',NULL,NULL),(14617,9557,'TE','5137747911',0,'2013-12-26 04:36:27',NULL,NULL),(43633,28962,'TE','5049159083',0,'2014-03-10 21:00:57',NULL,NULL),(1066,656,'EM','anangle8@yahoo.com',0,'2013-12-25 18:01:45',NULL,NULL),(1174,721,'TE','4098924725',0,'2013-12-25 18:03:28',NULL,NULL),(37442,24652,'TE','6143987629',0,'2014-02-20 04:23:20',NULL,NULL),(35538,23371,'AP','6149408621',0,'2014-02-13 22:00:53',NULL,NULL),(7877,5136,'EM','CommrclDiver@aol.com',0,'2013-12-25 23:02:23',NULL,NULL),(2022,1251,'EM','randymel@roadrunner.com',0,'2013-12-25 18:21:15',NULL,NULL),(31425,20485,'TE','4192816462',0,'2014-01-29 21:01:03',NULL,NULL),(14671,9598,'EM','Morrisg@neo.rr.com',0,'2013-12-26 04:37:21',NULL,NULL),(23485,15146,'TE','3476612082',0,'2014-01-01 12:05:54',NULL,NULL),(26483,17044,'TE','3308585023',0,'2014-01-13 02:20:53',NULL,NULL),(41785,27779,'EM','girlsthreeboysone@yahoo.com',0,'2014-03-05 21:31:33',NULL,NULL),(766,479,'TE','5043280771',0,'2013-12-25 17:48:06',NULL,NULL),(11005,7145,'EM','athinas1220@yahoo.com',0,'2013-12-26 01:52:02',NULL,NULL),(10357,6750,'TE','5672046991',0,'2013-12-26 01:16:04',NULL,NULL),(37034,24386,'TE','5133280480',0,'2014-02-18 22:00:47',NULL,NULL),(25674,16551,'EM','milous56@yahoo.com',1,'2014-01-07 10:22:45',NULL,NULL),(33218,21753,'EM','frankmira24@yahoo.com',0,'2014-02-06 21:00:22',NULL,NULL),(27555,17758,'TE','5132840916',0,'2014-01-14 01:33:32',NULL,NULL),(4009,2548,'EM','Skyside2@hotmail.com',0,'2013-12-25 19:37:14',NULL,NULL),(39810,26327,'AP','6013651809',0,'2014-02-28 06:31:38',NULL,NULL),(39180,25915,'TE','9407424140',0,'2014-02-26 21:01:17',NULL,NULL),(21533,13845,'TE','3304594649',0,'2013-12-26 13:12:25',NULL,NULL),(35347,23227,'TE','2165515360',0,'2014-02-12 21:32:23',NULL,NULL),(35430,23291,'TE','6142581489',0,'2014-02-13 22:00:08',NULL,NULL),(41669,27703,'AP','8174870216',0,'2014-03-05 21:30:49',NULL,NULL),(6383,4112,'TE','9378383220',0,'2013-12-25 21:48:01',NULL,NULL),(37492,24688,'AP','3612930628',0,'2014-02-20 04:31:55',NULL,NULL),(31324,20412,'TE','3252174808',0,'2014-01-29 21:00:25',NULL,NULL),(34343,22531,'AP','8014483934',0,'2014-02-10 21:31:32',NULL,NULL),(43326,28780,'TE','5136464550',0,'2014-03-09 21:00:35',NULL,NULL),(43379,28809,'TE','3303424511',0,'2014-03-09 21:00:53',NULL,NULL),(10492,6835,'TE','5136526374',0,'2013-12-26 01:30:55',NULL,NULL),(14838,9712,'TE','5135232363',0,'2013-12-26 04:45:13',NULL,NULL),(37883,24992,'AP','4322500741',0,'2014-02-20 22:00:40',NULL,NULL),(24320,15711,'AP','4406674647',1,'2014-01-02 04:36:04',NULL,NULL),(24984,16101,'EM','yvonne1958@earthlink.net',0,'2014-01-04 02:04:48',NULL,NULL),(25634,16534,'TE','7692186890',1,'2014-01-07 10:22:07',NULL,NULL),(29445,19038,'TE','6013164092',0,'2014-01-20 08:06:36',NULL,NULL),(6580,4248,'TE','5122929434',0,'2013-12-25 21:51:13',NULL,NULL),(38700,25574,'TE','4192047267',0,'2014-02-26 08:00:33',NULL,NULL),(38601,25508,'TE','9378768029',0,'2014-02-25 21:31:59',NULL,NULL),(37192,24481,'EM','ctoft@krmlawyers.com',0,'2014-02-18 22:01:45',NULL,NULL),(31162,20293,'TE','9855148863',0,'2014-01-28 21:00:38',NULL,NULL),(2179,1339,'EM','Ztexley@me.com',0,'2013-12-25 18:32:22',NULL,NULL),(23814,15364,'TE','5136791570',1,'2014-01-02 04:24:53',NULL,NULL),(9562,6259,'TE','3304486765',0,'2013-12-26 00:32:13',NULL,NULL),(8583,5641,'TE','3615850052',0,'2013-12-25 23:31:15',NULL,NULL),(7337,4769,'AP','6144393760',0,'2013-12-25 22:15:47',NULL,NULL),(40696,27032,'TE','8326898505',0,'2014-03-03 21:00:17',NULL,NULL),(41039,27265,'EM','mlw70706@yahoo.com',0,'2014-03-04 21:00:12',NULL,NULL),(42523,28288,'TE','3303364836',0,'2014-03-07 21:00:27',NULL,NULL),(43837,29095,'AP','9725678406',0,'2014-03-10 21:02:12',NULL,NULL),(10449,6808,'AP','2818577143',0,'2013-12-26 01:30:14',NULL,NULL),(39988,26483,'AP','7132561368',0,'2014-02-28 21:00:05',NULL,NULL),(39687,26244,'TE','4054763716',0,'2014-02-28 06:31:06',NULL,NULL),(39031,25811,'TE','9375591658',0,'2014-02-26 21:00:21',NULL,NULL),(3091,1930,'AP','8067772960',0,'2013-12-25 19:00:22',NULL,NULL),(36839,24260,'TE','7137759093',0,'2014-02-17 19:00:10',NULL,NULL),(35773,23524,'AP','2252004229',0,'2014-02-13 22:02:23',NULL,NULL),(34021,22313,'EM','sspencer63273@gmail.com',0,'2014-02-10 11:00:47',NULL,NULL),(4333,2765,'TE','4405764926',0,'2013-12-25 19:49:25',NULL,NULL),(31951,20857,'TE','3308250639',0,'2014-01-31 21:00:56',NULL,NULL),(23006,14839,'TE','6148988191',1,'2013-12-29 11:14:47',NULL,NULL),(664,412,'TE','2165709608',0,'2013-12-25 17:46:28',NULL,NULL),(39529,26147,'TE','3307885033',0,'2014-02-28 06:30:27',NULL,NULL),(38767,25631,'EM','jeremyrobertthompson@gmail.com',0,'2014-02-26 08:30:23',NULL,NULL),(37007,24368,'TE','2253596711',0,'2014-02-18 22:00:36',NULL,NULL),(7805,5094,'AP','9034713638',0,'2013-12-25 23:01:18',NULL,NULL),(32471,21216,'TE','3185426418',0,'2014-02-03 21:01:01',NULL,NULL),(20647,13279,'TE','9723757856',0,'2013-12-26 12:57:09',NULL,NULL),(25174,16234,'TE','2168510990',0,'2014-01-05 00:02:07',NULL,NULL),(27388,17629,'AP','5124977803',0,'2014-01-14 01:32:32',NULL,NULL),(345,214,'AP','3183411062',0,'2013-12-25 17:20:34',NULL,NULL),(36607,24101,'TE','3613188106',0,'2014-02-15 22:01:31',NULL,NULL),(29683,19181,'EM','mcerros51@live.com',0,'2014-01-21 08:46:08',NULL,NULL),(671,419,'TE','5132903966',0,'2013-12-25 17:46:36',NULL,NULL),(27969,18031,'AP','2167021340',0,'2014-01-15 02:07:08',NULL,NULL),(6943,4524,'TE','3617296928',0,'2013-12-25 22:03:54',NULL,NULL),(23677,15288,'AP','6013767628',1,'2014-01-02 04:22:22',NULL,NULL),(24040,15524,'TE','2703070339',1,'2014-01-02 04:30:24',NULL,NULL),(6059,3898,'AP','3307301030',0,'2013-12-25 21:36:48',NULL,NULL),(40286,26722,'TE','6019401098',0,'2014-02-28 21:31:45',NULL,NULL),(2001,1236,'TE','2257164044',0,'2013-12-25 18:20:52',NULL,NULL),(25698,16568,'TE','5672496586',1,'2014-01-07 10:23:15',NULL,NULL),(39543,26160,'AP','2163382802',0,'2014-02-28 06:30:32',NULL,NULL),(27364,17616,'TE','5124840254',0,'2014-01-14 01:32:24',NULL,NULL),(30387,19688,'AP','9564377529',0,'2014-01-23 21:00:41',NULL,NULL),(32257,21069,'AP','4409541397',0,'2014-02-02 19:00:16',NULL,NULL),(42902,28531,'AP','9857744638',0,'2014-03-07 21:32:08',NULL,NULL),(734,460,'AP','2146827386',0,'2013-12-25 17:47:36',NULL,NULL),(7219,4702,'EM','Njlavelle@yahoo.com',0,'2013-12-25 22:08:28',NULL,NULL),(7202,4692,'TE','9378485857',0,'2013-12-25 22:08:13',NULL,NULL),(4798,3068,'TE','9856348504',0,'2013-12-25 20:19:25',NULL,NULL),(4062,2594,'TE','3304259302',0,'2013-12-25 19:45:07',NULL,NULL),(4263,2725,'EM','tommdeb@aol.com',0,'2013-12-25 19:48:20',NULL,NULL),(25861,16668,'AP','6148043562',0,'2014-01-08 18:24:27',NULL,NULL),(21396,13758,'TE','2288616780',0,'2013-12-26 13:10:08',NULL,NULL),(22466,14487,'AP','8176589820',0,'2013-12-28 03:33:26',NULL,NULL),(21997,14168,'TE','9852159158',0,'2013-12-27 02:03:22',NULL,NULL),(1218,741,'EM','klaspk1@yahoo.com',0,'2013-12-25 18:04:04',NULL,NULL),(39705,26257,'TE','9158496242',0,'2014-02-28 06:31:11',NULL,NULL),(38923,25731,'EM','ferdinandpatrix@yahoo.com',0,'2014-02-26 09:30:35',NULL,NULL),(9521,6231,'AP','2107235660',0,'2013-12-26 00:31:27',NULL,NULL),(9307,6095,'EM','pjw2005yes@yahoo.com',0,'2013-12-26 00:02:53',NULL,NULL),(7008,4578,'EM','hzlgnz@yahoo.com',0,'2013-12-25 22:05:08',NULL,NULL),(4602,2938,'TE','5137202257',0,'2013-12-25 20:16:09',NULL,NULL),(20482,13191,'TE','8187318162',0,'2013-12-26 12:54:38',NULL,NULL),(27980,18037,'AP','9376238469',0,'2014-01-15 02:07:11',NULL,NULL),(192,114,'TE','9155040073',0,'2013-12-25 17:18:03',NULL,NULL),(38491,25437,'AP','3617460646',0,'2014-02-25 21:31:18',NULL,NULL),(12474,8171,'EM','papa.jeep7@hotmail.com',0,'2013-12-26 03:16:38',NULL,NULL),(36147,23790,'TE','3308130186',0,'2014-02-14 21:31:24',NULL,NULL),(35201,23119,'TE','5137450334',0,'2014-02-12 21:31:23',NULL,NULL),(32035,20911,'TE','4199081202',0,'2014-01-31 21:01:27',NULL,NULL),(30636,19881,'AP','4193717360',0,'2014-01-24 21:00:47',NULL,NULL),(30308,19635,'TE','9377103683',0,'2014-01-23 21:00:11',NULL,NULL),(6127,3944,'AP','9372140598',0,'2013-12-25 21:38:01',NULL,NULL),(2872,1756,'TE','6145301032',0,'2013-12-25 18:55:51',NULL,NULL),(22534,14528,'TE','9155326829',0,'2013-12-28 03:34:30',NULL,NULL),(24275,15686,'TE','5137425863',1,'2014-01-02 04:35:12',NULL,NULL),(12106,7912,'TE','8633938698',0,'2013-12-26 03:06:07',NULL,NULL),(40434,26843,'TE','5043478397',0,'2014-03-01 21:00:46',NULL,NULL),(34230,22453,'TE','9152526516',0,'2014-02-10 21:30:48',NULL,NULL),(9306,6095,'AP','4192300466',0,'2013-12-26 00:02:52',NULL,NULL),(32801,21459,'EM','jenniferyasin@hotmail.com',0,'2014-02-04 21:01:33',NULL,NULL),(26264,16903,'TE','7407655094',0,'2014-01-13 02:19:34',NULL,NULL),(14408,9421,'AP','9366713264',0,'2013-12-26 04:33:07',NULL,NULL),(35717,23489,'EM','SPUT2010@HOTMAIL.COM',0,'2014-02-13 22:02:01',NULL,NULL),(34061,22331,'EM','curtisf3@hotmail.com',0,'2014-02-10 11:01:01',NULL,NULL),(20836,13392,'AP','7405914287',0,'2013-12-26 13:00:12',NULL,NULL),(21592,13894,'TE','4196611601',0,'2013-12-26 13:13:33',NULL,NULL),(21697,13969,'EM','brianghomer@gmail.com',0,'2013-12-26 13:15:22',NULL,NULL),(42432,28183,'TE','5135461992',0,'2014-03-06 21:02:55',NULL,NULL),(5575,3560,'EM','TheLizardKing10@gmail.com',0,'2013-12-25 21:22:18',NULL,NULL),(22259,14344,'AP','3303012605',0,'2013-12-27 02:07:58',NULL,NULL),(23386,15063,'AP','3186804870',0,'2014-01-01 12:03:39',NULL,NULL),(37250,24511,'EM','mmtrott7@gmail.com',0,'2014-02-20 03:53:48',NULL,NULL),(34073,22337,'TE','4194758899',0,'2014-02-10 11:01:05',NULL,NULL),(25023,16125,'AP','2253485774',0,'2014-01-04 02:05:32',NULL,NULL),(30118,19510,'TE','9365819592',0,'2014-01-23 03:02:14',NULL,NULL),(26339,16954,'TE','4196183341',0,'2014-01-13 02:20:02',NULL,NULL),(26603,17112,'EM','robertneiman@outlook.com',0,'2014-01-13 02:21:38',NULL,NULL),(1587,979,'TE','4198992505',0,'2013-12-25 18:10:14',NULL,NULL),(11667,7596,'TE','4194236737',0,'2013-12-26 02:45:15',NULL,NULL),(11405,7422,'EM','Wmantonya@gmail.com',0,'2013-12-26 02:17:04',NULL,NULL),(38018,25079,'TE','4198741207',0,'2014-02-20 22:01:36',NULL,NULL),(37556,24726,'TE','6143579513',0,'2014-02-20 04:38:53',NULL,NULL),(34932,22924,'AP','5124234190',0,'2014-02-11 21:30:04',NULL,NULL),(33195,21737,'TE','9797776107',0,'2014-02-06 21:00:13',NULL,NULL),(32399,21169,'AP','3306359081',0,'2014-02-03 21:00:37',NULL,NULL),(10625,6912,'EM','kdsmithjones1@yahoo.com',0,'2013-12-26 01:45:57',NULL,NULL),(14193,9286,'AP','2164037941',0,'2013-12-26 04:16:02',NULL,NULL),(1717,1052,'TE','8304566079',0,'2013-12-25 18:16:05',NULL,NULL),(40938,27201,'TE','2143742122',0,'2014-03-03 21:31:23',NULL,NULL),(38602,25508,'AP','9378768029',0,'2014-02-25 21:32:00',NULL,NULL),(9568,6267,'TE','4408582644',0,'2013-12-26 00:32:25',NULL,NULL),(37091,24421,'AP','3309060832',0,'2014-02-18 22:01:07',NULL,NULL),(35728,23496,'TE','4692230249',0,'2014-02-13 22:02:06',NULL,NULL),(22338,14404,'AP','3309841143',0,'2013-12-28 03:31:17',NULL,NULL),(29091,18789,'TE','8284215716',0,'2014-01-17 03:35:55',NULL,NULL),(9768,6387,'TE','9379129968',0,'2013-12-26 00:48:05',NULL,NULL),(41595,27654,'EM','geralddhetrick@aol.com',0,'2014-03-05 21:30:23',NULL,NULL),(13974,9116,'TE','7402641539',0,'2013-12-26 04:07:39',NULL,NULL),(8456,5563,'TE','8172974406',0,'2013-12-25 23:16:32',NULL,NULL),(8260,5404,'TE','5135634825',0,'2013-12-25 23:09:01',NULL,NULL),(3887,2470,'TE','3185499465',0,'2013-12-25 19:35:12',NULL,NULL),(23964,15464,'EM','tuanamy4307@yahoo.com',1,'2014-01-02 04:28:46',NULL,NULL),(28978,18703,'AP','7405772912',0,'2014-01-17 03:35:29',NULL,NULL),(27289,17572,'TE','5132666858',0,'2014-01-14 01:32:02',NULL,NULL),(43208,28713,'EM','jay_lightning@yahoo.com',0,'2014-03-08 21:31:16',NULL,NULL),(43364,28802,'TE','4404066222',0,'2014-03-09 21:00:49',NULL,NULL),(6869,4456,'AP','4408299354',0,'2013-12-25 22:02:31',NULL,NULL),(41522,27609,'TE','5042567369',0,'2014-03-05 21:00:27',NULL,NULL),(8800,5765,'TE','9375454407',0,'2013-12-25 23:46:38',NULL,NULL),(33435,21900,'AP','4192364134',0,'2014-02-06 21:01:46',NULL,NULL),(30428,19725,'AP','7082184431',0,'2014-01-23 21:01:00',NULL,NULL),(30283,19619,'TE','5138683512',0,'2014-01-23 03:02:54',NULL,NULL),(7841,5117,'EM','rnaiz@yahoo.com',0,'2013-12-25 23:01:52',NULL,NULL),(29697,19199,'EM','jamadorable@gmail.com',0,'2014-01-21 08:46:15',NULL,NULL),(21596,13896,'EM','larry@schoolhouseelectronics.com',0,'2013-12-26 13:13:36',NULL,NULL),(27338,17605,'TE','3616521608',0,'2014-01-14 01:32:18',NULL,NULL),(1369,834,'AP','7404580236',0,'2013-12-25 18:06:26',NULL,NULL),(2101,1298,'AP','9082406949',0,'2013-12-25 18:31:04',NULL,NULL),(33556,21998,'AP','3372585696',0,'2014-02-07 19:00:46',NULL,NULL),(31826,20779,'AP','8066705407',0,'2014-01-31 21:00:08',NULL,NULL),(30494,19781,'TE','4196066714',0,'2014-01-23 21:01:34',NULL,NULL),(27997,18046,'AP','8327188460',0,'2014-01-15 02:07:15',NULL,NULL),(6326,4078,'TE','3309258118',0,'2013-12-25 21:47:07',NULL,NULL),(14818,9701,'EM','rsseibert@fuse.net',0,'2013-12-26 04:39:58',NULL,NULL),(10569,6880,'AP','5043779780',0,'2013-12-26 01:45:04',NULL,NULL),(12130,7927,'AP','9855020423',0,'2013-12-26 03:06:30',NULL,NULL),(26350,16960,'TE','3302739164',0,'2014-01-13 02:20:06',NULL,NULL),(29237,18886,'AP','5135264180',0,'2014-01-17 03:36:30',NULL,NULL),(28502,18370,'EM','angelaw740@gmail.com',0,'2014-01-16 08:45:30',NULL,NULL),(679,422,'EM','soundtherapy2@gmail.com',0,'2013-12-25 17:46:41',NULL,NULL),(41372,27484,'TE','5673719752',0,'2014-03-04 21:02:19',NULL,NULL),(2622,1594,'EM','blainethompson@ymail.com',0,'2013-12-25 18:51:52',NULL,NULL),(34304,22510,'TE','4407875539',0,'2014-02-10 21:31:18',NULL,NULL),(8606,5654,'TE','9035396279',0,'2013-12-25 23:31:35',NULL,NULL),(31411,20478,'TE','5672077665',0,'2014-01-29 21:00:59',NULL,NULL),(30638,19883,'TE','3304170518',0,'2014-01-24 21:00:47',NULL,NULL),(26547,17076,'AP','9562460016',0,'2014-01-13 02:21:20',NULL,NULL),(26475,17039,'TE','6013206413',0,'2014-01-13 02:20:50',NULL,NULL),(23657,15277,'AP','5132370701',1,'2014-01-02 04:21:59',NULL,NULL),(23244,14979,'AP','3614805683',0,'2014-01-01 12:01:02',NULL,NULL),(21794,14042,'AP','3309410091',0,'2013-12-27 02:00:04',NULL,NULL),(21687,13963,'TE','9374678690',0,'2013-12-26 13:15:11',NULL,NULL),(43066,28632,'TE','2813375859',0,'2014-03-08 21:30:27',NULL,NULL),(7870,5133,'TE','9792577063',0,'2013-12-25 23:02:18',NULL,NULL),(41344,27466,'AP','5132577729',0,'2014-03-04 21:02:09',NULL,NULL),(39085,25857,'TE','3187943686',0,'2014-02-26 21:00:43',NULL,NULL),(10307,6724,'TE','6149464985',0,'2013-12-26 01:15:19',NULL,NULL),(2952,1819,'EM','temo01@yahoo.com',0,'2013-12-25 18:57:13',NULL,NULL),(5834,3744,'TE','4323521073',0,'2013-12-25 21:32:59',NULL,NULL),(27202,17517,'TE','3304416466',0,'2014-01-13 03:01:34',NULL,NULL),(32647,21354,'AP','4096172140',0,'2014-02-04 21:00:39',NULL,NULL),(34237,22456,'TE','9564007221',0,'2014-02-10 21:30:50',NULL,NULL),(34188,22423,'EM','jaycoxisdead@gmail.com',0,'2014-02-10 21:30:32',NULL,NULL),(6396,4126,'TE','9372783836',0,'2013-12-25 21:48:17',NULL,NULL),(31129,20273,'TE','9377258551',0,'2014-01-28 21:00:25',NULL,NULL),(27677,17840,'TE','7407011338',0,'2014-01-15 02:06:03',NULL,NULL),(25449,16411,'EM','LEWISPN7@AOL.COM',0,'2014-01-07 04:04:13',NULL,NULL),(1039,640,'TE','5133645102',0,'2013-12-25 18:01:21',NULL,NULL),(9887,6466,'TE','3307536772',0,'2013-12-26 00:50:02',NULL,NULL),(14187,9284,'TE','9375817138',0,'2013-12-26 04:15:58',NULL,NULL),(9716,6360,'EM','rlsaxton1@gmail.com',0,'2013-12-26 00:47:20',NULL,NULL),(8697,5708,'AP','3304139954',0,'2013-12-25 23:45:04',NULL,NULL),(3435,2155,'TE','2144910148',0,'2013-12-25 19:18:42',NULL,NULL),(30260,19601,'TE','4198852481',0,'2014-01-23 03:02:48',NULL,NULL),(33407,21889,'TE','4199053039',0,'2014-02-06 21:01:37',NULL,NULL),(35083,23041,'AP','3615637801',0,'2014-02-12 21:30:40',NULL,NULL),(37776,24929,'EM','DENISEANGERSTIEN@ROCKETMAIL.COM',0,'2014-02-20 21:30:19',NULL,NULL),(5052,3243,'TE','4192556198',0,'2013-12-25 20:46:24',NULL,NULL),(10573,6883,'TE','3373510509',0,'2013-12-26 01:45:08',NULL,NULL),(20393,13135,'AP','3302219997',0,'2013-12-26 12:53:08',NULL,NULL),(22862,14752,'EM','crystalcreech@netzero.com',1,'2013-12-29 11:10:21',NULL,NULL),(34296,22503,'TE','4404490244',0,'2014-02-10 21:31:14',NULL,NULL),(33615,22045,'TE','4195361710',0,'2014-02-07 19:01:11',NULL,NULL),(32385,21160,'TE','5133563722',0,'2014-02-03 21:00:32',NULL,NULL),(31853,20796,'TE','9729416613',0,'2014-01-31 21:00:18',NULL,NULL),(29419,19020,'TE','9015987927',0,'2014-01-20 08:06:25',NULL,NULL),(24627,15881,'AP','3185473274',0,'2014-01-03 02:05:25',NULL,NULL),(42624,28355,'EM','buggirl66502@gmail.com',0,'2014-03-07 21:30:25',NULL,NULL),(5997,3852,'AP','3373085082',0,'2013-12-25 21:35:41',NULL,NULL),(41197,27361,'EM','max3215@att.net',0,'2014-03-04 21:01:11',NULL,NULL),(7317,4758,'EM','greysonhawe@gmail.com',0,'2013-12-25 22:15:28',NULL,NULL),(36928,24318,'EM','jessedean@weststardrywall.com',0,'2014-02-18 22:00:07',NULL,NULL),(22428,14461,'TE','3302835367',0,'2013-12-28 03:32:48',NULL,NULL),(23737,15315,'AP','2149953337',1,'2014-01-02 04:23:22',NULL,NULL),(31103,20251,'AP','2144504769',0,'2014-01-28 21:00:13',NULL,NULL),(13761,8969,'TE','9376577200',0,'2013-12-26 04:04:03',NULL,NULL),(1751,1079,'TE','3304824758',0,'2013-12-25 18:16:44',NULL,NULL),(34348,22533,'TE','9014851106',0,'2014-02-10 21:31:33',NULL,NULL),(2940,1809,'AP','4403191453',0,'2013-12-25 18:56:59',NULL,NULL),(31756,20724,'TE','4408888334',0,'2014-01-30 21:01:16',NULL,NULL),(20340,13105,'TE','6143122030',0,'2013-12-26 12:52:17',NULL,NULL),(25319,16327,'EM','leatricehollis@peoplescommunityla.org',0,'2014-01-07 04:01:53',NULL,NULL),(22948,14804,'AP','5044919829',1,'2013-12-29 11:13:51',NULL,NULL),(14019,9155,'AP','5133681971',0,'2013-12-26 04:08:33',NULL,NULL),(38078,25136,'TE','3252174810',0,'2014-02-21 22:00:07',NULL,NULL),(6926,4513,'TE','3148249793',0,'2013-12-25 22:03:39',NULL,NULL),(33627,22050,'TE','8174669819',0,'2014-02-08 19:00:04',NULL,NULL),(31688,20671,'TE','7692202545',0,'2014-01-30 21:00:50',NULL,NULL),(14828,9706,'AP','3306874947',0,'2013-12-26 04:45:03',NULL,NULL),(26801,17239,'AP','9173857841',0,'2014-01-13 02:22:44',NULL,NULL),(27594,17789,'AP','9375157480',0,'2014-01-14 01:33:46',NULL,NULL),(13548,8835,'EM','gjorkels@gmail.com',0,'2013-12-26 04:00:36',NULL,NULL),(29966,19391,'TE','9378433740',1,'2014-01-22 03:22:48',NULL,NULL),(39065,25839,'TE','4194385110',0,'2014-02-26 21:00:33',NULL,NULL),(31695,20676,'TE','6628098690',0,'2014-01-30 21:00:52',NULL,NULL),(37906,25002,'EM','drgio28@hotmail.com',0,'2014-02-20 22:00:48',NULL,NULL),(33464,21923,'AP','2817239842',0,'2014-02-07 19:00:07',NULL,NULL),(36124,23776,'TE','7039450156',0,'2014-02-14 21:31:16',NULL,NULL),(2094,1293,'EM','Bclayton@cinci.rr.com',0,'2013-12-25 18:30:56',NULL,NULL),(41455,27548,'AP','3309981247',0,'2014-03-04 21:30:10',NULL,NULL),(40522,26895,'TE','3617907344',0,'2014-03-03 01:00:05',NULL,NULL),(4871,3118,'TE','2146183323',0,'2013-12-25 20:30:13',NULL,NULL),(14826,9705,'AP','4192800209',0,'2013-12-26 04:40:06',NULL,NULL),(36274,23879,'EM','pfioritto@att.net',0,'2014-02-14 21:32:13',NULL,NULL),(34282,22492,'AP','6102097632',0,'2014-02-10 21:31:08',NULL,NULL),(22837,14730,'EM','lisajundi@gmail.com',1,'2013-12-29 11:09:48',NULL,NULL),(32214,21039,'TE','5133027992',0,'2014-02-01 19:00:49',NULL,NULL),(24043,15525,'TE','2256445972',1,'2014-01-02 04:30:27',NULL,NULL),(1133,696,'EM','GeralynHuntRN@gmail.com',0,'2013-12-25 18:02:46',NULL,NULL),(12078,7887,'EM','jekhoury@bex.net',0,'2013-12-26 03:05:33',NULL,NULL),(1470,901,'TE','6623949447',0,'2013-12-25 18:08:17',NULL,NULL),(38297,25287,'AP','4196066157',0,'2014-02-25 21:00:21',NULL,NULL),(36710,24170,'AP','6015664465',0,'2014-02-15 22:02:08',NULL,NULL),(9575,6270,'TE','2167892790',0,'2013-12-26 00:45:06',NULL,NULL),(8610,5658,'TE','3304980192',0,'2013-12-25 23:31:41',NULL,NULL),(7737,5049,'EM','lenkaah@aol.com',0,'2013-12-25 23:00:08',NULL,NULL),(25185,16239,'EM','lindamv61@yahoo.com',0,'2014-01-05 00:02:19',NULL,NULL),(20855,13408,'AP','6782302344',0,'2013-12-26 13:00:31',NULL,NULL),(14530,9493,'TE','4404206034',0,'2013-12-26 04:34:58',NULL,NULL),(2916,1788,'TE','6142726003',0,'2013-12-25 18:56:31',NULL,NULL),(2224,1367,'AP','9032753354',0,'2013-12-25 18:45:40',NULL,NULL),(1310,799,'TE','5127990348',0,'2013-12-25 18:05:31',NULL,NULL),(40737,27072,'TE','3307150321',0,'2014-03-03 21:30:06',NULL,NULL),(9167,6001,'EM','KATRESEGASPER@GMAIL.COM',0,'2013-12-26 00:00:21',NULL,NULL),(33697,22102,'TE','7247773860',0,'2014-02-08 19:00:30',NULL,NULL),(29289,18926,'TE','5136620044',0,'2014-01-20 08:05:35',NULL,NULL),(3878,2464,'AP','5042309817',0,'2013-12-25 19:35:03',NULL,NULL),(26133,16824,'EM','venegas649@yahoo.com',0,'2014-01-13 02:18:25',NULL,NULL),(22812,14710,'TE','5137538743',1,'2013-12-29 11:09:18',NULL,NULL),(21863,14084,'TE','4403710083',0,'2013-12-27 02:01:11',NULL,NULL),(21850,14073,'TE','2163241021',0,'2013-12-27 02:00:56',NULL,NULL),(2325,1417,'EM','sampsohm@gmail.com',0,'2013-12-25 18:47:08',NULL,NULL),(4807,3075,'TE','9857501850',0,'2013-12-25 20:19:33',NULL,NULL),(38926,25733,'TE','3185250042',0,'2014-02-26 09:30:37',NULL,NULL),(33404,21887,'AP','5139193175',0,'2014-02-06 21:01:35',NULL,NULL),(14735,9639,'AP','7137037436',0,'2013-12-26 04:38:26',NULL,NULL),(32254,21067,'EM','klatzenhoefer@yahoo.com',0,'2014-02-02 19:00:15',NULL,NULL),(43647,28970,'AP','2257212360',0,'2014-03-10 21:01:02',NULL,NULL),(43840,29096,'AP','9725678406',0,'2014-03-10 21:02:13',NULL,NULL),(13766,8973,'TE','8122491521',0,'2013-12-26 04:04:07',NULL,NULL),(30803,20029,'AP','5044109745',0,'2014-01-26 19:00:19',NULL,NULL),(38656,25547,'EM','nodalcin@gmail.com',0,'2014-02-26 08:00:16',NULL,NULL),(38036,25096,'TE','5138344078',0,'2014-02-21 21:30:08',NULL,NULL),(36768,24209,'TE','2257887882',0,'2014-02-16 19:00:22',NULL,NULL),(7399,4813,'AP','5134978337',0,'2013-12-25 22:16:51',NULL,NULL),(38637,25537,'AP','5138467697',0,'2014-02-26 08:00:08',NULL,NULL),(32351,21137,'EM','rockywann4@yahoo.com',0,'2014-02-03 21:00:20',NULL,NULL),(31040,20193,'TE','9012120439',0,'2014-01-27 21:01:28',NULL,NULL),(6237,4020,'TE','4194685880',0,'2013-12-25 21:45:39',NULL,NULL),(11789,7668,'EM','Nicolealleman@gmail.com',0,'2013-12-26 03:00:30',NULL,NULL),(5313,3406,'TE','5046552439',0,'2013-12-25 21:18:15',NULL,NULL),(26866,17288,'AP','7747225089',0,'2014-01-13 02:23:31',NULL,NULL),(25623,16524,'AP','9038093000',1,'2014-01-07 10:21:51',NULL,NULL),(14831,9708,'TE','5049199933',0,'2013-12-26 04:45:07',NULL,NULL),(4341,2772,'TE','3302127618',0,'2013-12-25 19:49:33',NULL,NULL),(43319,28777,'EM','stevebrisbine@yahoo.com',0,'2014-03-09 21:00:33',NULL,NULL),(204,124,'EM','mlauer@cinci.rr.com',0,'2013-12-25 17:18:17',NULL,NULL),(41921,27872,'AP','2284939013',0,'2014-03-05 21:32:26',NULL,NULL),(41457,27549,'TE','4408537450',0,'2014-03-04 21:30:10',NULL,NULL),(40347,26777,'AP','9033436836',0,'2014-03-01 21:00:11',NULL,NULL),(37459,24665,'EM','andybecky@bright.net',0,'2014-02-20 04:26:42',NULL,NULL),(37282,24534,'AP','2252235809',0,'2014-02-20 04:01:07',NULL,NULL),(14221,9304,'EM','jim@jkubik.net',0,'2013-12-26 04:30:05',NULL,NULL),(36870,24280,'EM','rgay001@neo.rr.com',0,'2014-02-18 21:30:07',NULL,NULL),(1666,1023,'EM','kdoherty4253@gmail.com',0,'2013-12-25 18:15:18',NULL,NULL),(30557,19828,'AP','9727650292',0,'2014-01-24 21:00:17',NULL,NULL),(9399,6151,'EM','mkuliska@yahoo.com',0,'2013-12-26 00:16:32',NULL,NULL),(25031,16131,'EM','drgnslayer1953@yahoo.com',0,'2014-01-04 02:05:42',NULL,NULL),(9088,5956,'AP','4193670914',0,'2013-12-25 23:51:15',NULL,NULL),(8712,5716,'AP','3304643233',0,'2013-12-25 23:45:17',NULL,NULL),(3462,2165,'EM','ejksufld@aol.com',0,'2013-12-25 19:19:02',NULL,NULL),(12466,8161,'TE','5677122141',0,'2013-12-26 03:16:22',NULL,NULL),(815,507,'AP','9372394726',0,'2013-12-25 17:48:51',NULL,NULL),(5610,3590,'TE','5132215760',0,'2013-12-25 21:23:00',NULL,NULL),(30979,20151,'AP','5132603766',0,'2014-01-27 21:01:04',NULL,NULL),(25828,16652,'TE','2155208687',0,'2014-01-08 18:24:21',NULL,NULL),(5614,3595,'AP','5134775516',0,'2013-12-25 21:23:07',NULL,NULL),(3288,2068,'TE','5134157570',0,'2013-12-25 19:16:18',NULL,NULL),(24012,15506,'TE','6143525678',1,'2014-01-02 04:29:53',NULL,NULL),(22615,14583,'TE','9854461950',0,'2013-12-28 03:35:55',NULL,NULL),(22446,14475,'AP','5128282604',0,'2013-12-28 03:33:08',NULL,NULL),(21074,13552,'TE','3185730006',0,'2013-12-26 13:04:07',NULL,NULL),(2895,1773,'EM','freedomcdc@hotmail.com',0,'2013-12-25 18:56:10',NULL,NULL),(42441,28187,'BN','5133131842',0,'2014-03-06 21:02:58',NULL,NULL),(439,273,'TE','5132452595',0,'2013-12-25 17:30:05',NULL,NULL),(8345,5478,'EM','LYDIELATTE@SBCGLOBAL.NET',0,'2013-12-25 23:10:46',NULL,NULL),(7077,4622,'EM','bettybettybobetty@yahoo.com',0,'2013-12-25 22:06:16',NULL,NULL),(3516,2197,'AP','9377269334',0,'2013-12-25 19:19:56',NULL,NULL),(37072,24410,'TE','5132950737',0,'2014-02-18 22:01:01',NULL,NULL),(35832,23564,'TE','4196192922',0,'2014-02-13 22:02:46',NULL,NULL),(601,371,'AP','9032151343',0,'2013-12-25 17:45:27',NULL,NULL),(39047,25822,'EM','hartymid@gmail.com',0,'2014-02-26 21:00:27',NULL,NULL),(11842,7705,'TE','9372183402',0,'2013-12-26 03:01:22',NULL,NULL),(38190,25206,'TE','3377805973',0,'2014-02-21 22:00:48',NULL,NULL),(14636,9572,'TE','2167734510',0,'2013-12-26 04:36:45',NULL,NULL),(36975,24344,'EM','Pamela4700@hotmail.com',0,'2014-02-18 22:00:22',NULL,NULL),(34508,22635,'AP','8063004637',0,'2014-02-11 21:00:20',NULL,NULL),(26679,17162,'AP','5042310043',0,'2014-01-13 02:22:03',NULL,NULL),(24429,15771,'AP','9562929807',0,'2014-01-03 02:01:49',NULL,NULL),(10284,6714,'TE','9017862039',0,'2013-12-26 01:02:22',NULL,NULL),(10314,6729,'AP','5133059723',0,'2013-12-26 01:15:26',NULL,NULL),(12019,7833,'AP','7408910356',0,'2013-12-26 03:04:28',NULL,NULL),(41166,27340,'TE','5137878622',0,'2014-03-04 21:00:58',NULL,NULL),(2771,1679,'AP','5046025021',0,'2013-12-25 18:54:07',NULL,NULL),(40497,26876,'AP','4192303345',0,'2014-03-01 21:01:06',NULL,NULL),(39984,26480,'TE','9038962069',0,'2014-02-28 21:00:03',NULL,NULL),(37956,25044,'EM','dylan.stewart18@yahoo.com',0,'2014-02-20 22:01:12',NULL,NULL),(35436,23296,'EM','retro852@msn.com',0,'2014-02-13 22:00:11',NULL,NULL),(31352,20432,'TE','9376072988',0,'2014-01-29 21:00:35',NULL,NULL),(8578,5639,'AP','3059234178',0,'2013-12-25 23:31:11',NULL,NULL),(4996,3206,'AP','6163083135',0,'2013-12-25 20:45:20',NULL,NULL),(24057,15532,'EM','smile4monie@yahoo.com',1,'2014-01-02 04:30:41',NULL,NULL),(4434,2826,'AP','4403441240',0,'2013-12-25 20:00:38',NULL,NULL),(25349,16348,'TE','7246506670',0,'2014-01-07 04:02:25',NULL,NULL),(26826,17254,'AP','9378769432',0,'2014-01-13 02:23:14',NULL,NULL),(38982,25779,'TE','4195173971',0,'2014-02-26 09:31:00',NULL,NULL),(38296,25287,'TE','4196066157',0,'2014-02-25 21:00:21',NULL,NULL),(32213,21038,'EM','sheltk68@gmail.com',0,'2014-02-01 19:00:49',NULL,NULL),(42518,28282,'AP','5049821701',0,'2014-03-07 21:00:25',NULL,NULL),(21235,13650,'AP','5048135955',0,'2013-12-26 13:07:17',NULL,NULL),(22676,14622,'TE','4196918427',0,'2013-12-28 03:36:58',NULL,NULL),(26835,17261,'BN','9374088957',0,'2014-01-13 02:23:17',NULL,NULL),(32117,20971,'BN','9152530638',0,'2014-02-01 19:00:15',NULL,NULL),(1217,741,'AP','9723584831',0,'2013-12-25 18:04:04',NULL,NULL),(42379,28145,'EM','CHARLESMASTIN@FUSE.NET',0,'2014-03-06 21:02:33',NULL,NULL),(41846,27824,'TE','4196366855',0,'2014-03-05 21:31:57',NULL,NULL),(13655,8904,'AP','6144996691',0,'2013-12-26 04:02:22',NULL,NULL),(36388,23967,'AP','3619441199',0,'2014-02-15 22:00:12',NULL,NULL),(32132,20984,'EM','voltar0227@gmail.com',0,'2014-02-01 19:00:22',NULL,NULL),(5070,3258,'TE','3306077220',0,'2013-12-25 20:46:46',NULL,NULL),(8777,5752,'TE','2144188492',0,'2013-12-25 23:46:15',NULL,NULL),(42483,28243,'AP','5137041261',0,'2014-03-07 21:00:11',NULL,NULL),(14273,9336,'TE','3184991819',0,'2013-12-26 04:30:53',NULL,NULL),(41633,27676,'AP','9044420238',0,'2014-03-05 21:30:36',NULL,NULL),(4218,2697,'TE','3253408677',0,'2013-12-25 19:47:39',NULL,NULL),(36276,23883,'AP','5133177755',0,'2014-02-14 21:32:15',NULL,NULL),(32555,21284,'EM','CHIQUITA0281@HOTMAIL.COM',0,'2014-02-04 21:00:04',NULL,NULL),(4485,2852,'EM','hh69bb@gmail.com',0,'2013-12-25 20:01:25',NULL,NULL),(4804,3071,'AP','6468725598',0,'2013-12-25 20:19:29',NULL,NULL),(22349,14412,'TE','9722665568',0,'2013-12-28 03:31:29',NULL,NULL),(27620,17805,'EM','gregoryedgar@ymail.com',0,'2014-01-15 02:05:50',NULL,NULL),(2322,1416,'EM','summersuleiman1@gmail.com',0,'2013-12-25 18:47:06',NULL,NULL),(26510,17058,'TE','5037156065',0,'2014-01-13 02:21:10',NULL,NULL),(30564,19831,'TE','2147328177',0,'2014-01-24 21:00:19',NULL,NULL),(33272,21788,'TE','5133286144',0,'2014-02-06 21:00:42',NULL,NULL),(34187,22423,'AP','5042962424',0,'2014-02-10 21:30:31',NULL,NULL),(6056,3895,'EM','sp@neo.rr.com',0,'2013-12-25 21:36:44',NULL,NULL),(22491,14501,'AP','8062237698',0,'2013-12-28 03:33:47',NULL,NULL),(39182,25915,'EM','tinal12345@yahoo.com',0,'2014-02-26 21:01:17',NULL,NULL),(26740,17198,'AP','3309078004',0,'2014-01-13 02:22:23',NULL,NULL),(12002,7819,'AP','8062207300',0,'2013-12-26 03:04:09',NULL,NULL),(42075,27957,'EM','nakeitria_joseph@yahoo.com',0,'2014-03-06 21:00:42',NULL,NULL),(7060,4610,'EM','d_stoll@mac.com',0,'2013-12-25 22:05:58',NULL,NULL),(38302,25292,'EM','caatgerdeman@bright.net',0,'2014-02-25 21:00:23',NULL,NULL),(2181,1340,'AP','6143294295',0,'2013-12-25 18:32:25',NULL,NULL),(9874,6455,'AP','3305716530',0,'2013-12-26 00:49:48',NULL,NULL),(8457,5563,'AP','8175866610',0,'2013-12-25 23:16:32',NULL,NULL),(20374,13124,'TE','5132623409',0,'2013-12-26 12:52:49',NULL,NULL),(38367,25342,'TE','4199350453',0,'2014-02-25 21:30:26',NULL,NULL),(1686,1036,'AP','9152527049',0,'2013-12-25 18:15:39',NULL,NULL),(3159,1974,'AP','8176816774',0,'2013-12-25 19:01:34',NULL,NULL),(8965,5872,'EM','aggtree@gmail.com',0,'2013-12-25 23:49:16',NULL,NULL),(36700,24161,'EM','lmhamrich@neo.rr.com',0,'2014-02-15 22:02:04',NULL,NULL),(24539,15826,'EM','michellesiwierka@gmail.com',0,'2014-01-03 02:03:43',NULL,NULL),(33221,21755,'TE','9032887163',0,'2014-02-06 21:00:23',NULL,NULL),(25567,16495,'TE','7403045261',0,'2014-01-07 04:06:38',NULL,NULL),(25655,16543,'AP','9403129696',1,'2014-01-07 10:22:27',NULL,NULL),(12322,8056,'TE','6165700647',0,'2013-12-26 03:09:51',NULL,NULL),(42328,28107,'BN','3305240989',0,'2014-03-06 21:02:14',NULL,NULL),(1675,1028,'AP','8327583674',0,'2013-12-25 18:15:27',NULL,NULL),(26417,16999,'EM','jackee8850@yahoo.com',0,'2014-01-13 02:20:30',NULL,NULL),(27580,17776,'TE','2147723897',0,'2014-01-14 01:33:41',NULL,NULL),(28791,18581,'AP','3303350708',0,'2014-01-16 08:47:09',NULL,NULL),(2205,1354,'TE','5122536902',0,'2013-12-25 18:45:21',NULL,NULL),(2944,1815,'AP','3472069613',0,'2013-12-25 18:57:05',NULL,NULL),(40170,26642,'TE','2166738118',0,'2014-02-28 21:31:04',NULL,NULL),(39102,25869,'EM','toananhnguyen701@gmail.com',0,'2014-02-26 21:00:50',NULL,NULL),(22683,14628,'EM','cathystift@zoomtown.com',0,'2013-12-28 03:37:07',NULL,NULL),(26393,16989,'TE','2102687470',0,'2014-01-13 02:20:23',NULL,NULL),(381,234,'TE','5132562650',0,'2013-12-25 17:21:06',NULL,NULL),(988,609,'TE','4194682664',0,'2013-12-25 18:00:31',NULL,NULL),(30522,19798,'TE','4197397020',0,'2014-01-23 21:01:47',NULL,NULL),(38518,25455,'AP','9564583172',0,'2014-02-25 21:31:28',NULL,NULL),(9616,6292,'EM','peregrine1800@gmail.com',0,'2013-12-26 00:45:41',NULL,NULL),(42906,28533,'TE','5139411545',0,'2014-03-07 21:32:09',NULL,NULL),(20312,13090,'EM','rabriani185@yahoo.com',0,'2013-12-26 12:51:51',NULL,NULL),(36431,23993,'TE','5042733758',0,'2014-02-15 22:00:27',NULL,NULL),(34275,22488,'TE','4192369710',0,'2014-02-10 21:31:06',NULL,NULL),(33696,22101,'EM','randydodie@hotmail.com',0,'2014-02-08 19:00:30',NULL,NULL),(32506,21248,'AP','6142966163',0,'2014-02-03 21:01:16',NULL,NULL),(29918,19361,'EM','wildgillis@yahoo.com',1,'2014-01-22 03:22:31',NULL,NULL),(29650,19156,'AP','4195758075',0,'2014-01-21 08:45:38',NULL,NULL),(14358,9386,'TE','9032921016',0,'2013-12-26 04:32:14',NULL,NULL),(21605,13903,'EM','nprice2@lsu.edu',0,'2013-12-26 13:13:46',NULL,NULL),(14601,9546,'EM','tnaomid50@yahoo.com',0,'2013-12-26 04:36:10',NULL,NULL),(41827,27811,'AP','3305643272',0,'2014-03-05 21:31:50',NULL,NULL),(1485,911,'EM','matthewsjanice98@yahoo.com',0,'2013-12-25 18:08:34',NULL,NULL),(33144,21709,'AP','5134798443',0,'2014-02-05 21:31:14',NULL,NULL),(33096,21679,'EM','slimbattie@yahoo.com',0,'2014-02-05 21:31:01',NULL,NULL),(34550,22660,'AP','9563192284',0,'2014-02-11 21:00:34',NULL,NULL),(34832,22843,'EM','mandy23262002@gmail.com',0,'2014-02-11 21:02:15',NULL,NULL),(39973,26465,'AP','3302892620',0,'2014-02-28 07:30:34',NULL,NULL),(11664,7591,'TE','5133681921',0,'2013-12-26 02:45:09',NULL,NULL),(30094,19497,'TE','3309044907',0,'2014-01-23 03:02:09',NULL,NULL),(27917,17987,'EM','lisasteffan@yahoo.com',0,'2014-01-15 02:06:55',NULL,NULL),(35231,23137,'EM','DSTOUGH426@GMAIL.COM',0,'2014-02-12 21:31:34',NULL,NULL),(39183,25916,'TE','9033409870',0,'2014-02-26 21:01:17',NULL,NULL),(21486,13807,'TE','5133140487',0,'2013-12-26 13:11:31',NULL,NULL),(29201,18864,'AP','5044811631',0,'2014-01-17 03:36:21',NULL,NULL),(23178,14939,'TE','9375443934',0,'2013-12-30 00:02:15',NULL,NULL),(25057,16153,'AP','4133012424',0,'2014-01-04 02:06:19',NULL,NULL),(33749,22146,'AP','4408640421',0,'2014-02-08 19:00:51',NULL,NULL),(36250,23856,'AP','8162239657',0,'2014-02-14 21:32:02',NULL,NULL),(37606,24781,'EM','carlye.myka@gmail.com',0,'2014-02-20 04:45:28',NULL,NULL),(38280,25274,'AP','2102796852',0,'2014-02-25 21:00:14',NULL,NULL),(926,570,'AP','5134906903',0,'2013-12-25 17:50:35',NULL,NULL),(9193,6018,'TE','5089511750',0,'2013-12-26 00:00:46',NULL,NULL),(12293,8041,'TE','2168543579',0,'2013-12-26 03:09:25',NULL,NULL),(24862,16032,'AP','5043170816',0,'2014-01-04 02:02:33',NULL,NULL),(24088,15550,'AP','2256360940',1,'2014-01-02 04:31:15',NULL,NULL),(23434,15099,'AP','6148003610',0,'2014-01-01 12:04:40',NULL,NULL),(11554,7520,'TE','5137331968',0,'2013-12-26 02:32:22',NULL,NULL),(2904,1781,'AP','6149371351',0,'2013-12-25 18:56:20',NULL,NULL),(6732,4373,'EM','BUCKEYEJOJO1@YAHOO.COM',0,'2013-12-25 22:00:23',NULL,NULL),(32953,21573,'EM','OHIOSCOTT@SBCGLOBAL.NET',0,'2014-02-05 21:30:22',NULL,NULL),(33846,22218,'EM','emzametkin@gmail.com',0,'2014-02-09 19:00:25',NULL,NULL),(36334,23930,'TE','5135730387',0,'2014-02-15 21:00:03',NULL,NULL),(36530,24051,'AP','4407591904',0,'2014-02-15 22:01:04',NULL,NULL),(42936,28548,'AP','4198108589',0,'2014-03-07 21:32:19',NULL,NULL),(1834,1134,'EM','rlaurie6592@gmail.com',0,'2013-12-25 18:18:09',NULL,NULL),(7095,4631,'TE','6622300938',0,'2013-12-25 22:06:32',NULL,NULL),(27679,17840,'EM','sherry.gassaway@yahoo.com',0,'2014-01-15 02:06:03',NULL,NULL),(23683,15291,'TE','3183528483',1,'2014-01-02 04:22:28',NULL,NULL),(21422,13773,'TE','6019271192',0,'2013-12-26 13:10:33',NULL,NULL),(14224,9306,'TE','9857487017',0,'2013-12-26 04:30:09',NULL,NULL),(33964,22283,'TE','5135602756',0,'2014-02-10 11:00:24',NULL,NULL),(35177,23105,'TE','5137676045',0,'2014-02-12 21:31:14',NULL,NULL),(20316,13092,'AP','8594090497',0,'2013-12-26 12:51:55',NULL,NULL),(30619,19872,'TE','2162582687',0,'2014-01-24 21:00:41',NULL,NULL),(29151,18833,'AP','3306772435',0,'2014-01-17 03:36:10',NULL,NULL),(28703,18522,'TE','2142081068',0,'2014-01-16 08:46:39',NULL,NULL),(26628,17134,'TE','5133796661',0,'2014-01-13 02:21:48',NULL,NULL),(9390,6145,'TE','7406492939',0,'2013-12-26 00:16:24',NULL,NULL),(22130,14255,'TE','3182594938',0,'2013-12-27 02:05:38',NULL,NULL),(11547,7515,'TE','3372448619',0,'2013-12-26 02:32:13',NULL,NULL),(6404,4132,'EM','2000.diamond@gmail.com',0,'2013-12-25 21:48:25',NULL,NULL),(8729,5725,'EM','fouratonce@gmail.com',0,'2013-12-25 23:45:32',NULL,NULL),(11174,7267,'EM','kukki_dreams@yahoo.co.in',0,'2013-12-26 02:02:19',NULL,NULL),(38066,25127,'AP','2253159713',0,'2014-02-21 21:30:24',NULL,NULL),(39061,25837,'TE','4195600441',0,'2014-02-26 21:00:32',NULL,NULL),(20526,13212,'EM','therealjohndeuel@gmail.com',0,'2013-12-26 12:55:17',NULL,NULL),(3673,2330,'TE','4327419512',0,'2013-12-25 19:31:40',NULL,NULL),(3976,2522,'TE','3304142349',0,'2013-12-25 19:36:38',NULL,NULL),(29938,19375,'AP','6016222390',1,'2014-01-22 03:22:38',NULL,NULL),(27350,17610,'TE','3257213811',0,'2014-01-14 01:32:21',NULL,NULL),(4049,2584,'AP','5132903857',0,'2013-12-25 19:38:05',NULL,NULL),(5626,3603,'EM','leh2294@aol.com',0,'2013-12-25 21:23:20',NULL,NULL),(5942,3815,'TE','4042549954',0,'2013-12-25 21:34:48',NULL,NULL),(6601,4263,'AP','3307156353',0,'2013-12-25 21:51:35',NULL,NULL),(39191,25922,'TE','4322548368',0,'2014-02-26 21:01:21',NULL,NULL),(21269,13665,'EM','glepurple23@gmail.com',0,'2013-12-26 13:07:46',NULL,NULL),(30873,20068,'AP','9725892763',0,'2014-01-27 21:00:15',NULL,NULL),(30142,19532,'TE','4197640545',0,'2014-01-23 03:02:21',NULL,NULL),(28570,18419,'AP','5042364824',0,'2014-01-16 08:45:51',NULL,NULL),(26614,17123,'EM','msdwash2000@yahoo.com',0,'2014-01-13 02:21:43',NULL,NULL),(24014,15506,'EM','lgcleveland@gmail.com',1,'2014-01-02 04:29:53',NULL,NULL),(9823,6426,'AP','2252689725',0,'2013-12-26 00:49:02',NULL,NULL),(22198,14298,'TE','4194170016',0,'2013-12-27 02:06:47',NULL,NULL),(6382,4110,'EM','rbarr1951@netzero.net',0,'2013-12-25 21:47:59',NULL,NULL),(34821,22838,'EM','dianedmc2@msn.com',0,'2014-02-11 21:02:12',NULL,NULL),(34953,22947,'TE','6018260504',0,'2014-02-11 21:30:24',NULL,NULL),(35197,23116,'EM','loislukens1@gmail.com',0,'2014-02-12 21:31:22',NULL,NULL),(21145,13595,'TE','4074216994',0,'2013-12-26 13:05:18',NULL,NULL),(31388,20457,'AP','6146482757',0,'2014-01-29 21:00:49',NULL,NULL),(4946,3175,'AP','4194204231',0,'2013-12-25 20:31:40',NULL,NULL),(25427,16399,'AP','8179191689',0,'2014-01-07 04:03:49',NULL,NULL),(24295,15697,'TE','3302405426',1,'2014-01-02 04:35:36',NULL,NULL),(23597,15236,'EM','pmrider@fuse.net',0,'2014-01-01 12:08:27',NULL,NULL),(7672,4995,'EM','dakshashah52@yahoo.com',0,'2013-12-25 22:47:02',NULL,NULL),(8812,5770,'TE','6148644825',0,'2013-12-25 23:46:46',NULL,NULL),(4711,3013,'AP','3307803939',0,'2013-12-25 20:17:59',NULL,NULL),(37248,24511,'TE','2146491712',0,'2014-02-20 03:53:38',NULL,NULL),(38537,25466,'TE','2818552799',0,'2014-02-25 21:31:34',NULL,NULL),(39263,25976,'AP','4194385110',0,'2014-02-26 21:01:49',NULL,NULL),(42053,27947,'TE','8065844852',0,'2014-03-06 21:00:35',NULL,NULL),(144,86,'TE','3309221760',0,'2013-12-25 17:17:18',NULL,NULL),(14919,9760,'TE','7409225144',0,'2013-12-26 05:00:12',NULL,NULL),(27435,17673,'TE','5042467333',0,'2014-01-14 01:32:50',NULL,NULL),(4301,2744,'AP','8089890329',0,'2013-12-25 19:48:53',NULL,NULL),(24857,16030,'AP','3184172444',0,'2014-01-04 02:02:28',NULL,NULL),(5534,3538,'EM','Judymcnicol101@gmail.com',0,'2013-12-25 21:21:42',NULL,NULL),(8523,5602,'AP','4408329234',0,'2013-12-25 23:30:17',NULL,NULL),(34895,22899,'AP','5672304299',0,'2014-02-11 21:02:40',NULL,NULL),(39711,26261,'AP','9159227186',0,'2014-02-28 06:31:12',NULL,NULL),(41630,27674,'AP','9157277999',0,'2014-03-05 21:30:35',NULL,NULL),(14786,9675,'TE','4194968855',0,'2013-12-26 04:39:22',NULL,NULL),(21530,13843,'AP','3307801058',0,'2013-12-26 13:12:22',NULL,NULL),(27413,17657,'AP','7404123613',0,'2014-01-14 01:32:43',NULL,NULL),(24334,15718,'TE','6144778992',0,'2014-01-03 02:00:07',NULL,NULL),(24183,15623,'TE','6018450767',1,'2014-01-02 04:33:15',NULL,NULL),(23765,15328,'AP','9154940534',1,'2014-01-02 04:23:50',NULL,NULL),(2589,1579,'EM','terry.leija@sbcglobal.net',0,'2013-12-25 18:51:24',NULL,NULL),(2460,1509,'EM','JEFFSEEMANN@YAHOO.COM',0,'2013-12-25 18:49:28',NULL,NULL),(1894,1167,'TE','2256738980',0,'2013-12-25 18:19:04',NULL,NULL),(34074,22338,'TE','4195762141',0,'2014-02-10 11:01:06',NULL,NULL),(35746,23508,'TE','5127445912',0,'2014-02-13 22:02:12',NULL,NULL),(387,236,'EM','kimnguyen3228@yahoo.com',0,'2013-12-25 17:21:11',NULL,NULL),(32695,21386,'TE','6142062270',0,'2014-02-04 21:00:55',NULL,NULL),(31746,20718,'AP','9372186188',0,'2014-01-30 21:01:13',NULL,NULL),(30203,19565,'TE','7702659300',0,'2014-01-23 03:02:35',NULL,NULL),(21702,13973,'EM','huxtables@aol.com',0,'2013-12-26 13:15:27',NULL,NULL),(596,367,'EM','Ashlchamb10@gmail.com',0,'2013-12-25 17:45:21',NULL,NULL),(20515,13207,'TE','2146816452',0,'2013-12-26 12:55:08',NULL,NULL),(8849,5798,'AP','4197066814',0,'2013-12-25 23:47:26',NULL,NULL),(20892,13435,'TE','6507145966',0,'2013-12-26 13:01:09',NULL,NULL),(6321,4076,'AP','9313601247',0,'2013-12-25 21:47:03',NULL,NULL),(38326,25320,'AP','2257183965',0,'2014-02-25 21:30:08',NULL,NULL),(38330,25322,'EM','lajerrika@yahoo.com',0,'2014-02-25 21:30:10',NULL,NULL),(70,45,'TE','6018262442',0,'2013-12-25 17:16:11',NULL,NULL),(24535,15824,'AP','7403600954',0,'2014-01-03 02:03:38',NULL,NULL),(24781,15985,'TE','9404358560',0,'2014-01-04 02:01:05',NULL,NULL),(3740,2373,'EM','LBROADVIEWHTS@AOL.COM',0,'2013-12-25 19:32:48',NULL,NULL),(33030,21639,'BN','4328897451',0,'2014-02-05 21:30:44',NULL,NULL),(31741,20714,'TE','5042309431',0,'2014-01-30 21:01:10',NULL,NULL),(30899,20087,'EM','lcashillcmp@yahoo.com',0,'2014-01-27 21:00:27',NULL,NULL),(30363,19670,'EM','JUANANTONIO_CUBAS@YAHOO.COM',0,'2014-01-23 21:00:32',NULL,NULL),(7174,4677,'AP','3374592811',0,'2013-12-25 22:07:47',NULL,NULL),(28425,18314,'EM','holtkamp.karen@gmail.com',0,'2014-01-16 08:45:04',NULL,NULL),(24686,15920,'AP','6019552127',0,'2014-01-03 02:06:38',NULL,NULL),(2594,1582,'EM','lopez_emilia10024@yahoo.com',0,'2013-12-25 18:51:29',NULL,NULL),(3167,1982,'AP','8176816774',0,'2013-12-25 19:01:45',NULL,NULL),(39951,26445,'TE','5132595194',0,'2014-02-28 07:30:23',NULL,NULL),(41095,27297,'TE','9795513375',0,'2014-03-04 21:00:32',NULL,NULL),(14112,9228,'TE','5135532371',0,'2013-12-26 04:10:24',NULL,NULL),(27562,17763,'AP','9377834323',0,'2014-01-14 01:33:34',NULL,NULL),(25238,16276,'TE','5132001893',0,'2014-01-07 04:00:24',NULL,NULL),(403,247,'TE','4194389189',0,'2013-12-25 17:21:29',NULL,NULL),(13847,9031,'TE','3303299860',0,'2013-12-26 04:05:34',NULL,NULL),(3833,2439,'TE','3304728891',0,'2013-12-25 19:34:23',NULL,NULL),(35023,22998,'TE','3305194655',0,'2014-02-12 21:30:17',NULL,NULL),(36528,24049,'TE','2169258569',0,'2014-02-15 22:01:03',NULL,NULL),(39118,25877,'TE','5044536366',0,'2014-02-26 21:00:55',NULL,NULL),(40004,26496,'TE','3308011747',0,'2014-02-28 21:00:13',NULL,NULL),(9942,6506,'TE','4194963545',0,'2013-12-26 00:51:00',NULL,NULL),(33718,22117,'AP','2145438666',0,'2014-02-08 19:00:38',NULL,NULL),(34571,22668,'EM','larryc2001@gmail.com',0,'2014-02-11 21:00:40',NULL,NULL),(42548,28312,'AP','7403523714',0,'2014-03-07 21:00:37',NULL,NULL),(1937,1199,'TE','4196843000',0,'2013-12-25 18:19:50',NULL,NULL),(32018,20901,'EM','kag610@aol.com',0,'2014-01-31 21:01:21',NULL,NULL),(14956,9784,'TE','6149378305',0,'2013-12-26 05:00:49',NULL,NULL),(13632,8889,'TE','5249794229',0,'2013-12-26 04:01:58',NULL,NULL),(25093,16179,'TE','2813438555',0,'2014-01-05 00:00:29',NULL,NULL),(6818,4425,'EM','SALLY.MONCOL@GMAIL.COM',0,'2013-12-25 22:01:43',NULL,NULL),(32097,20962,'AP','3613966815',0,'2014-02-01 19:00:10',NULL,NULL),(1850,1143,'TE','4106032905',0,'2013-12-25 18:18:24',NULL,NULL),(14472,9452,'TE','5132585300',0,'2013-12-26 04:34:01',NULL,NULL),(11074,7193,'AP','4405203667',0,'2013-12-26 02:00:27',NULL,NULL),(552,344,'AP','8146030636',0,'2013-12-25 17:32:03',NULL,NULL),(1197,729,'EM','michelleaangus@gmail.com',0,'2013-12-25 18:03:45',NULL,NULL),(3247,2043,'AP','9154437918',0,'2013-12-25 19:15:39',NULL,NULL),(8127,5321,'EM','tenerinasearles@yahoo.com',0,'2013-12-25 23:06:50',NULL,NULL),(34349,22533,'AP','9014851106',0,'2014-02-10 21:31:33',NULL,NULL),(36167,23804,'TE','3305739514',0,'2014-02-14 21:31:31',NULL,NULL),(24233,15656,'AP','5673560476',1,'2014-01-02 04:34:18',NULL,NULL),(32930,21555,'EM','JPAVLINAK@yahoo.COM',0,'2014-02-05 21:30:16',NULL,NULL),(24009,15495,'EM','DD349304@GMAIL.COM',1,'2014-01-02 04:29:40',NULL,NULL),(6764,4390,'TE','5136596814',0,'2013-12-25 22:00:52',NULL,NULL),(14101,9220,'TE','3307728195',0,'2013-12-26 04:10:10',NULL,NULL),(11935,7773,'EM','esquivelrobert@aol.com',0,'2013-12-26 03:02:59',NULL,NULL),(41072,27284,'AP','8323398345',0,'2014-03-04 21:00:24',NULL,NULL),(42636,28362,'TE','8064219883',0,'2014-03-07 21:30:29',NULL,NULL),(1595,983,'AP','2165389675',0,'2013-12-25 18:10:22',NULL,NULL),(7944,5185,'TE','3302778990',0,'2013-12-25 23:03:36',NULL,NULL),(11459,7450,'EM','revjrg@hotmail.com',0,'2013-12-26 02:30:42',NULL,NULL),(4553,2898,'TE','3303522477',0,'2013-12-25 20:15:17',NULL,NULL),(5043,3237,'TE','9727410985',0,'2013-12-25 20:46:13',NULL,NULL),(42423,28173,'AP','4407850190',0,'2014-03-06 21:02:51',NULL,NULL),(11999,7815,'TE','9033302352',0,'2013-12-26 03:04:05',NULL,NULL),(32696,21386,'AP','6142062270',0,'2014-02-04 21:00:55',NULL,NULL),(31704,20685,'TE','4323609313',0,'2014-01-30 21:00:56',NULL,NULL),(6141,3953,'EM','dantuel@frontiernet.net',0,'2013-12-25 21:38:14',NULL,NULL),(29442,19036,'TE','6016725980',0,'2014-01-20 08:06:34',NULL,NULL),(27876,17964,'AP','5129948288',0,'2014-01-15 02:06:47',NULL,NULL),(28575,18421,'TE','5042849945',0,'2014-01-16 08:45:53',NULL,NULL),(28543,18402,'AP','4407813412',0,'2014-01-16 08:45:43',NULL,NULL),(40285,26721,'EM','acoleman1021@yahoo.com',0,'2014-02-28 21:31:45',NULL,NULL),(25926,16705,'EM','meme_80@yahoo.com',0,'2014-01-08 18:24:40',NULL,NULL),(14703,9621,'AP','4199800250',0,'2013-12-26 04:37:54',NULL,NULL),(7571,4928,'EM','caren@insight.rr.com',0,'2013-12-25 22:45:21',NULL,NULL),(6841,4437,'TE','7403142472',0,'2013-12-25 22:02:04',NULL,NULL),(41530,27616,'TE','2815574344',0,'2014-03-05 21:00:31',NULL,NULL),(2787,1687,'TE','5045089916',0,'2013-12-25 18:54:21',NULL,NULL),(9906,6484,'AP','2165136533',0,'2013-12-26 00:50:23',NULL,NULL),(34965,22956,'TE','5044581495',0,'2014-02-12 21:00:05',NULL,NULL),(36495,24026,'BN','4195098042',0,'2014-02-15 22:00:50',NULL,NULL),(37431,24648,'TE','2253018261',0,'2014-02-20 04:21:57',NULL,NULL),(40050,26552,'TE','2024466956',0,'2014-02-28 21:30:14',NULL,NULL),(41902,27861,'EM','cgrubb1018@gmail.com',0,'2014-03-05 21:32:19',NULL,NULL),(43638,28965,'TE','3375785656',0,'2014-03-10 21:00:59',NULL,NULL),(1202,732,'TE','2813844378',0,'2013-12-25 18:03:50',NULL,NULL),(8544,5616,'TE','5135026460',0,'2013-12-25 23:30:38',NULL,NULL),(22740,14665,'TE','9038878591',1,'2013-12-29 11:08:06',NULL,NULL),(35989,23677,'AP','3184194859',0,'2014-02-14 21:30:28',NULL,NULL),(40740,27073,'TE','3304214991',0,'2014-03-03 21:30:07',NULL,NULL),(40833,27134,'EM','only4himiwill@gmail.com',0,'2014-03-03 21:30:42',NULL,NULL),(5943,3815,'AP','4042549954',0,'2013-12-25 21:34:48',NULL,NULL),(3816,2429,'TE','7404074919',0,'2013-12-25 19:34:07',NULL,NULL),(28449,18333,'TE','5138313804',0,'2014-01-16 08:45:13',NULL,NULL),(27109,17438,'AP','4199730977',0,'2014-01-13 03:00:34',NULL,NULL),(42453,28202,'TE','9727432265',0,'2014-03-06 21:30:09',NULL,NULL),(511,321,'AP','3373536174',0,'2013-12-25 17:31:22',NULL,NULL),(10668,6932,'TE','3304216429',0,'2013-12-26 01:46:33',NULL,NULL),(1061,653,'TE','7405592675',0,'2013-12-25 18:01:40',NULL,NULL),(36671,24143,'AP','5132059273',0,'2014-02-15 22:01:53',NULL,NULL),(39953,26445,'EM','edwarren77@yahoo.com',0,'2014-02-28 07:30:23',NULL,NULL),(42301,28088,'EM','eva2arise@yahoo.com',0,'2014-03-06 21:02:02',NULL,NULL),(378,231,'TE','5132562650',0,'2013-12-25 17:21:04',NULL,NULL),(26267,16904,'AP','6143156796',0,'2014-01-13 02:19:34',NULL,NULL),(24211,15639,'TE','2288723541',1,'2014-01-02 04:33:46',NULL,NULL),(13659,8905,'EM','amers8707@yahoo.com',0,'2013-12-26 04:02:25',NULL,NULL),(31153,20289,'AP','9042390524',0,'2014-01-28 21:00:35',NULL,NULL),(22477,14493,'EM','olgamizzles@yahoo.com',0,'2013-12-28 03:33:35',NULL,NULL),(9063,5942,'AP','2252843481',0,'2013-12-25 23:50:51',NULL,NULL),(21130,13587,'TE','3182729101',0,'2013-12-26 13:05:04',NULL,NULL),(43266,28746,'TE','4097909077',0,'2014-03-09 21:00:13',NULL,NULL),(23247,14981,'TE','2542279334',0,'2014-01-01 12:01:05',NULL,NULL),(33625,22049,'AP','3252009635',0,'2014-02-08 19:00:04',NULL,NULL),(33375,21868,'EM','jessedogden@yahoo.com',0,'2014-02-06 21:01:24',NULL,NULL),(25718,16577,'TE','4195916614',1,'2014-01-07 10:23:33',NULL,NULL),(25214,16258,'EM','sjdavis_39530@yahoo.com',0,'2014-01-05 00:02:50',NULL,NULL),(29695,19199,'TE','2817481800',0,'2014-01-21 08:46:15',NULL,NULL),(6508,4207,'TE','2143851624',0,'2013-12-25 21:50:05',NULL,NULL),(5995,3851,'AP','3377394628',0,'2013-12-25 21:35:39',NULL,NULL),(11139,7240,'TE','3196711020',0,'2013-12-26 02:01:40',NULL,NULL),(10218,6678,'EM','jjjdwright@yahoo.com',0,'2013-12-26 01:01:19',NULL,NULL),(24526,15818,'AP','6143252513',0,'2014-01-03 02:03:28',NULL,NULL),(27211,17522,'TE','7408155943',0,'2014-01-13 03:01:37',NULL,NULL),(26292,16923,'AP','5047561151',0,'2014-01-13 02:19:45',NULL,NULL),(11452,7446,'EM','amy@haroldthecomputerguy.com',0,'2013-12-26 02:30:36',NULL,NULL),(20563,13234,'AP','2816877461',0,'2013-12-26 12:55:51',NULL,NULL),(22074,14216,'TE','9565230191',0,'2013-12-27 02:04:37',NULL,NULL),(22269,14353,'TE','4404206163',0,'2013-12-28 03:30:05',NULL,NULL),(37486,24682,'EM','shellymavrick@hotmail.com',0,'2014-02-20 04:31:08',NULL,NULL),(39449,26089,'AP','3373220100',0,'2014-02-28 06:30:08',NULL,NULL),(21973,14154,'EM','s434674627@yahoo.com',0,'2013-12-27 02:03:00',NULL,NULL),(11817,7689,'AP','5135204635',0,'2013-12-26 03:00:59',NULL,NULL),(11441,7441,'EM','mwb45@zips.uakron.edu',0,'2013-12-26 02:30:26',NULL,NULL),(10353,6747,'EM','julia_brdgs@yahoo.com',0,'2013-12-26 01:15:59',NULL,NULL),(3300,2076,'AP','9852469488',0,'2013-12-25 19:16:30',NULL,NULL),(38466,25420,'BN','2169704658',0,'2014-02-25 21:31:09',NULL,NULL),(43686,28999,'TE','4195771906',0,'2014-03-10 21:01:17',NULL,NULL),(5892,3778,'EM','aknight4246@neo.rr.com',0,'2013-12-25 21:33:55',NULL,NULL),(34477,22621,'AP','5128180309',0,'2014-02-11 21:00:10',NULL,NULL),(2192,1348,'AP','8068316706',0,'2013-12-25 18:45:10',NULL,NULL),(1861,1149,'AP','2259785167',0,'2013-12-25 18:18:34',NULL,NULL),(35322,23209,'TE','5134901485',0,'2014-02-12 21:32:13',NULL,NULL),(39293,25996,'TE','6014971976',0,'2014-02-26 21:02:00',NULL,NULL),(40799,27113,'BN','9375727862',0,'2014-03-03 21:30:28',NULL,NULL),(42852,28499,'TE','3306711655',0,'2014-03-07 21:31:47',NULL,NULL),(1082,665,'AP','3305595203',0,'2013-12-25 18:02:00',NULL,NULL),(9952,6512,'EM','paulamarsh33@live.com',0,'2013-12-26 00:51:10',NULL,NULL),(30653,19896,'AP','9852100420',0,'2014-01-24 21:00:54',NULL,NULL),(26158,16842,'TE','3307985436',0,'2014-01-13 02:18:34',NULL,NULL),(25564,16490,'AP','4192245256',0,'2014-01-07 04:06:32',NULL,NULL),(7364,4789,'EM','mchebra@att.net',0,'2013-12-25 22:16:17',NULL,NULL),(2924,1795,'EM','mariagetz2003@yahoo.com',0,'2013-12-25 18:56:38',NULL,NULL),(31415,20479,'EM','adamsjustinr@gmail.com',0,'2014-01-29 21:01:00',NULL,NULL),(37680,24846,'TE','3304729927',0,'2014-02-20 04:54:26',NULL,NULL),(43309,28771,'AP','7409744868',0,'2014-03-09 21:00:30',NULL,NULL),(13651,8902,'TE','6144996691',0,'2013-12-26 04:02:18',NULL,NULL),(28542,18402,'TE','4407813412',0,'2014-01-16 08:45:43',NULL,NULL),(26587,17106,'TE','9372174681',0,'2014-01-13 02:21:34',NULL,NULL),(9159,5998,'TE','2149987144',0,'2013-12-26 00:00:16',NULL,NULL),(24688,15921,'TE','6019512572',0,'2014-01-03 02:06:41',NULL,NULL),(23371,15055,'AP','3185353582',0,'2014-01-01 12:03:23',NULL,NULL),(5437,3482,'AP','5137393460',0,'2013-12-25 21:20:12',NULL,NULL),(1700,1044,'TE','3252624455',0,'2013-12-25 18:15:51',NULL,NULL),(3237,2036,'EM','eugenefranklin@aol.com',0,'2013-12-25 19:15:28',NULL,NULL),(5558,3551,'EM','Mandylittle828@gmail.com',0,'2013-12-25 21:22:03',NULL,NULL),(33282,21793,'AP','5138074751',0,'2014-02-06 21:00:45',NULL,NULL),(33328,21830,'BN','2147792937',0,'2014-02-06 21:01:04',NULL,NULL),(41103,27302,'AP','2543340328',0,'2014-03-04 21:00:35',NULL,NULL),(571,354,'TE','4192572156',0,'2013-12-25 17:32:23',NULL,NULL),(14278,9341,'TE','3183434024',0,'2013-12-26 04:31:00',NULL,NULL),(30055,19470,'AP','8173339377',0,'2014-01-23 03:01:59',NULL,NULL),(27196,17514,'TE','3304416466',0,'2014-01-13 03:01:32',NULL,NULL),(12313,8051,'TE','4194225055',0,'2013-12-26 03:09:42',NULL,NULL),(25026,16130,'TE','3303388713',0,'2014-01-04 02:05:39',NULL,NULL),(3394,2133,'EM','rf@fcon.com',0,'2013-12-25 19:18:02',NULL,NULL),(9567,6266,'TE','3302096076',0,'2013-12-26 00:32:24',NULL,NULL),(31739,20713,'AP','5042309431',0,'2014-01-30 21:01:10',NULL,NULL),(32636,21344,'BN','8066625784',0,'2014-02-04 21:00:34',NULL,NULL),(34129,22377,'TE','2343803636',0,'2014-02-10 21:30:07',NULL,NULL),(38343,25329,'AP','9853355855',0,'2014-02-25 21:30:16',NULL,NULL),(41016,27253,'TE','9373026791',0,'2014-03-03 21:31:55',NULL,NULL),(42294,28085,'AP','7134094416',0,'2014-03-06 21:02:00',NULL,NULL),(28801,18587,'AP','5136331088',0,'2014-01-16 08:47:12',NULL,NULL),(30470,19754,'AP','6145577101',0,'2014-01-23 21:01:20',NULL,NULL),(39838,26349,'AP','4192176488',0,'2014-02-28 06:31:47',NULL,NULL),(41992,27910,'EM','castilloeddie52@att.net',0,'2014-03-06 21:00:15',NULL,NULL),(10386,6769,'EM','tarnona@gmail.com',0,'2013-12-26 01:16:35',NULL,NULL),(30948,20128,'TE','5136490511',0,'2014-01-27 21:00:50',NULL,NULL),(6650,4313,'TE','5138058813',0,'2013-12-25 21:52:37',NULL,NULL),(24496,15803,'TE','3373500586',0,'2014-01-03 02:02:57',NULL,NULL),(38148,25179,'TE','7406442960',0,'2014-02-21 22:00:33',NULL,NULL),(41588,27649,'AP','9372384989',0,'2014-03-05 21:30:21',NULL,NULL),(42031,27936,'TE','3616943845',0,'2014-03-06 21:00:29',NULL,NULL),(10873,7060,'TE','6149755942',0,'2013-12-26 01:49:54',NULL,NULL),(6947,4527,'AP','2815366045',0,'2013-12-25 22:03:58',NULL,NULL),(34023,22314,'AP','3378027834',0,'2014-02-10 11:00:48',NULL,NULL),(37301,24545,'TE','3308619059',0,'2014-02-20 04:03:25',NULL,NULL),(38133,25170,'EM','CLARAMCFEE@HOTMAIL.COM',0,'2014-02-21 22:00:27',NULL,NULL),(41113,27312,'TE','4693964157',0,'2014-03-04 21:00:40',NULL,NULL),(14413,9423,'TE','9564331128',0,'2013-12-26 04:33:11',NULL,NULL),(21105,13568,'EM','shanwoles@gmail.com',0,'2013-12-26 13:04:35',NULL,NULL),(31245,20349,'TE','9376029934',0,'2014-01-28 21:01:13',NULL,NULL),(29931,19371,'AP','3304164068',1,'2014-01-22 03:22:36',NULL,NULL),(20258,13052,'EM','ddanner3320@outlook.com',0,'2013-12-26 12:50:54',NULL,NULL),(1464,898,'TE','9378579788',0,'2013-12-25 18:08:12',NULL,NULL),(22561,14550,'AP','6017204671',0,'2013-12-28 03:35:00',NULL,NULL),(22538,14531,'TE','2487053365',0,'2013-12-28 03:34:34',NULL,NULL),(7363,4789,'TE','3306770125',0,'2013-12-25 22:16:16',NULL,NULL),(10595,6894,'AP','2252881054',0,'2013-12-26 01:45:28',NULL,NULL),(10646,6923,'TE','5133156165',0,'2013-12-26 01:46:16',NULL,NULL),(42520,28283,'TE','5049821701',0,'2014-03-07 21:00:26',NULL,NULL),(43594,28945,'TE','3372921352',0,'2014-03-10 21:00:46',NULL,NULL),(11195,7278,'AP','9154223551',0,'2013-12-26 02:02:38',NULL,NULL),(860,537,'TE','6014970950',0,'2013-12-25 17:49:36',NULL,NULL),(27327,17597,'EM','jeanbridges@bellsouth.net',0,'2014-01-14 01:32:14',NULL,NULL),(2757,1671,'TE','5135827626',0,'2013-12-25 18:53:55',NULL,NULL),(14837,9711,'AP','5132917096',0,'2013-12-26 04:45:12',NULL,NULL),(31954,20866,'EM','jermaine.curry@utoledo.edu',0,'2014-01-31 21:00:59',NULL,NULL),(34595,22682,'AP','8174048942',0,'2014-02-11 21:00:48',NULL,NULL),(36187,23817,'EM','bmsengines@hughes.net',0,'2014-02-14 21:31:39',NULL,NULL),(39294,25996,'AP','6014971976',0,'2014-02-26 21:02:00',NULL,NULL),(20344,13107,'TE','3304844792',0,'2013-12-26 12:52:21',NULL,NULL),(30483,19765,'TE','6018321075',0,'2014-01-23 21:01:26',NULL,NULL),(6974,4546,'EM','edhball@yahoo.com',0,'2013-12-25 22:04:27',NULL,NULL),(1056,651,'AP','5134428445',0,'2013-12-25 18:01:36',NULL,NULL),(4522,2875,'EM','benjamingreene1604@gmail.com',0,'2013-12-25 20:02:03',NULL,NULL),(3996,2539,'TE','4198855120',0,'2013-12-25 19:37:00',NULL,NULL),(42153,28004,'TE','2163159512',0,'2014-03-06 21:01:11',NULL,NULL),(3404,2139,'TE','2246881198',0,'2013-12-25 19:18:12',NULL,NULL),(3255,2049,'EM','maryann0320@gmail.com',0,'2013-12-25 19:15:48',NULL,NULL),(30066,19475,'TE','9158756067',0,'2014-01-23 03:02:01',NULL,NULL),(2171,1335,'AP','6147497701',0,'2013-12-25 18:32:14',NULL,NULL),(37896,24998,'AP','2817286328',0,'2014-02-20 22:00:44',NULL,NULL),(43134,28672,'TE','4194871183',0,'2014-03-08 21:30:50',NULL,NULL),(187,110,'EM','bill_le@hotmail.com',0,'2013-12-25 17:17:58',NULL,NULL),(31768,20736,'AP','9376214672',0,'2014-01-30 21:01:22',NULL,NULL),(8500,5590,'TE','4192556198',0,'2013-12-25 23:17:14',NULL,NULL),(13964,9102,'TE','4402255137',0,'2013-12-26 04:07:25',NULL,NULL),(25950,16715,'EM','jcudi85@gmail.com',0,'2014-01-08 18:24:44',NULL,NULL),(4064,2595,'TE','9377187504',0,'2013-12-25 19:45:09',NULL,NULL),(43947,29151,'TE','3307573152',0,'2014-03-10 21:02:49',NULL,NULL),(11268,7347,'TE','3309243965',0,'2013-12-26 02:04:08',NULL,NULL),(10493,6835,'AP','5136526374',0,'2013-12-26 01:30:55',NULL,NULL),(3623,2292,'TE','2168623013',0,'2013-12-25 19:30:48',NULL,NULL),(28586,18427,'AP','9855183408',0,'2014-01-16 08:45:56',NULL,NULL),(21313,13691,'TE','4406244254',0,'2013-12-26 13:08:28',NULL,NULL),(2756,1670,'EM','christianbyheart456@yahoo.com',0,'2013-12-25 18:53:53',NULL,NULL),(2745,1664,'TE','5122801966',0,'2013-12-25 18:53:43',NULL,NULL),(6862,4452,'TE','6148634977',0,'2013-12-25 22:02:25',NULL,NULL),(33029,21639,'AP','4328897451',0,'2014-02-05 21:30:44',NULL,NULL),(34336,22527,'TE','3306063689',0,'2014-02-10 21:31:29',NULL,NULL),(34690,22748,'TE','5134392250',0,'2014-02-11 21:01:24',NULL,NULL),(38028,25083,'AP','4199089336',0,'2014-02-20 22:01:40',NULL,NULL),(40589,26939,'TE','2165201231',0,'2014-03-03 01:00:23',NULL,NULL),(41181,27351,'TE','3306061382',0,'2014-03-04 21:01:05',NULL,NULL),(41887,27853,'TE','9563585457',0,'2014-03-05 21:32:13',NULL,NULL),(41972,27901,'TE','4327411499',0,'2014-03-06 21:00:09',NULL,NULL),(9364,6130,'TE','8063525850',0,'2013-12-26 00:15:58',NULL,NULL),(20679,13296,'TE','9034089929',0,'2013-12-26 12:57:38',NULL,NULL),(20481,13191,'AP','8187318162',0,'2013-12-26 12:54:38',NULL,NULL),(11305,7368,'TE','5049821701',0,'2013-12-26 02:15:35',NULL,NULL),(2905,1781,'EM','a4lena@gmail.com',0,'2013-12-25 18:56:21',NULL,NULL),(22147,14263,'AP','5133930614',0,'2013-12-27 02:05:53',NULL,NULL),(5160,3313,'TE','5134901048',0,'2013-12-25 21:15:53',NULL,NULL),(3463,2167,'EM','bdshrock@me.com',0,'2013-12-25 19:19:04',NULL,NULL),(33888,22240,'TE','2162996205',0,'2014-02-09 19:00:38',NULL,NULL),(35892,23610,'AP','9374074091',0,'2014-02-13 22:03:12',NULL,NULL),(37219,24493,'EM','alexandria567@hotmail.com',0,'2014-02-20 03:45:53',NULL,NULL),(39902,26406,'BN','3303545829',0,'2014-02-28 07:00:35',NULL,NULL),(41174,27346,'TE','4404813593',0,'2014-03-04 21:01:02',NULL,NULL),(41652,27686,'BN','9034753759',0,'2014-03-05 21:30:42',NULL,NULL),(43554,28924,'AP','4408120447',0,'2014-03-10 21:00:32',NULL,NULL),(20920,13452,'TE','9374744557',0,'2013-12-26 13:01:32',NULL,NULL),(30857,20057,'AP','4095430454',0,'2014-01-27 21:00:09',NULL,NULL),(6879,4463,'TE','4198788835',0,'2013-12-25 22:02:41',NULL,NULL),(28297,18240,'TE','9792030710',0,'2014-01-16 08:44:24',NULL,NULL),(23986,15484,'TE','2162721343',1,'2014-01-02 04:29:16',NULL,NULL),(36194,23823,'AP','4199174360',0,'2014-02-14 21:31:42',NULL,NULL),(41950,27886,'TE','4192708282',0,'2014-03-05 21:32:36',NULL,NULL),(14444,9438,'TE','5134102342',0,'2013-12-26 04:33:36',NULL,NULL),(14113,9228,'AP','5133904399',0,'2013-12-26 04:10:24',NULL,NULL),(29670,19174,'AP','8173080458',0,'2014-01-21 08:46:04',NULL,NULL),(29574,19108,'EM','MarkMMcAulay@gmail.com',0,'2014-01-21 08:44:43',NULL,NULL),(28846,18630,'EM','Dianna_Hendrix2009@hotmail.com',0,'2014-01-17 03:35:02',NULL,NULL),(28214,18187,'EM','badluck50@msn.com',0,'2014-01-15 02:08:03',NULL,NULL),(5236,3364,'AP','8066726039',0,'2013-12-25 21:17:05',NULL,NULL),(25701,16569,'AP','5672496586',1,'2014-01-07 10:23:16',NULL,NULL),(23953,15456,'EM','gillian.thorne@gmail.com',1,'2014-01-02 04:28:31',NULL,NULL),(34708,22757,'TE','3188683296',0,'2014-02-11 21:01:30',NULL,NULL),(121,70,'EM','kristy.koerner@gmail.com',0,'2013-12-25 17:16:55',NULL,NULL),(565,350,'TE','9375500153',0,'2013-12-25 17:32:15',NULL,NULL),(24375,15741,'TE','2547604791',0,'2014-01-03 02:00:50',NULL,NULL),(23458,15118,'EM','kgranneman24@gmail.com',0,'2014-01-01 12:05:12',NULL,NULL),(6743,4379,'TE','6142043331',0,'2013-12-25 22:00:33',NULL,NULL),(1332,815,'TE','3307248259',0,'2013-12-25 18:05:55',NULL,NULL),(1992,1229,'EM','kyndalleighanne@gmail.com',0,'2013-12-25 18:20:40',NULL,NULL),(3284,2066,'TE','5133173700',0,'2013-12-25 19:16:14',NULL,NULL),(11528,7504,'TE','4403640311',0,'2013-12-26 02:31:55',NULL,NULL),(36666,24138,'TE','5135285413',0,'2014-02-15 22:01:51',NULL,NULL),(36801,24231,'TE','9375244197',0,'2014-02-16 19:00:34',NULL,NULL),(38646,25541,'AP','4197333508',0,'2014-02-26 08:00:11',NULL,NULL),(41184,27353,'TE','4405397360',0,'2014-03-04 21:01:06',NULL,NULL),(42389,28153,'TE','5674545006',0,'2014-03-06 21:02:38',NULL,NULL),(42764,28443,'EM','mcozad13@gmail.com',0,'2014-03-07 21:31:15',NULL,NULL),(43436,28847,'AP','4192503455',0,'2014-03-09 21:01:16',NULL,NULL),(20796,13364,'TE','4193660090',0,'2013-12-26 12:59:33',NULL,NULL),(30986,20157,'TE','5132715522',0,'2014-01-27 21:01:07',NULL,NULL),(30838,20046,'AP','6624400454',0,'2014-01-26 19:00:31',NULL,NULL),(30089,19494,'AP','4408128775',0,'2014-01-23 03:02:07',NULL,NULL),(29770,19250,'TE','5135188160',0,'2014-01-21 08:46:43',NULL,NULL),(27392,17632,'AP','2147939519',0,'2014-01-14 01:32:33',NULL,NULL),(25957,16721,'TE','4095495352',0,'2014-01-08 18:24:46',NULL,NULL),(25282,16301,'TE','5043499454',0,'2014-01-07 04:01:09',NULL,NULL),(4587,2928,'TE','4402301364',0,'2013-12-25 20:15:56',NULL,NULL),(2769,1678,'AP','2253843055',0,'2013-12-25 18:54:05',NULL,NULL),(33193,21736,'AP','9797776107',0,'2014-02-06 21:00:13',NULL,NULL),(34288,22495,'TE','4193188787',0,'2014-02-10 21:31:10',NULL,NULL),(12430,8140,'AP','5672242358',0,'2013-12-26 03:15:48',NULL,NULL),(32219,21043,'TE','9362399052',0,'2014-02-01 19:00:51',NULL,NULL),(30516,19795,'AP','9378695723',0,'2014-01-23 21:01:44',NULL,NULL),(29349,18964,'EM','blessed_2713@yahoo.com',0,'2014-01-20 08:05:57',NULL,NULL),(6702,4359,'TE','4194103833',0,'2013-12-25 21:53:41',NULL,NULL),(7720,5040,'EM','rileyernest@bellsouth.net',0,'2013-12-25 22:48:00',NULL,NULL),(38496,25439,'AP','4322012046',0,'2014-02-25 21:31:20',NULL,NULL),(41183,27351,'EM','cricephoto@gmail.com',0,'2014-03-04 21:01:05',NULL,NULL),(42562,28320,'EM','sbarry197@gmail.com',0,'2014-03-07 21:30:04',NULL,NULL),(21617,13913,'TE','4194472026',0,'2013-12-26 13:14:01',NULL,NULL),(9106,5969,'TE','6014702304',0,'2013-12-25 23:51:34',NULL,NULL),(31640,20643,'TE','8329695416',0,'2014-01-30 21:00:34',NULL,NULL),(30825,20040,'EM','amandahill00@gmail.com',0,'2014-01-26 19:00:26',NULL,NULL),(30534,19807,'TE','2144229690',0,'2014-01-24 21:00:07',NULL,NULL),(23406,15076,'AP','9032353834',0,'2014-01-01 12:04:03',NULL,NULL),(22511,14515,'TE','7605229485',0,'2013-12-28 03:34:09',NULL,NULL),(13989,9126,'AP','6626890618',0,'2013-12-26 04:07:52',NULL,NULL),(1515,933,'TE','7407100280',0,'2013-12-25 18:09:08',NULL,NULL),(2998,1855,'TE','5134064009',0,'2013-12-25 18:58:02',NULL,NULL),(3879,2465,'TE','3377948927',0,'2013-12-25 19:35:04',NULL,NULL),(283,174,'EM','djhatch57@yahoo.com',0,'2013-12-25 17:19:31',NULL,NULL),(21144,13594,'AP','2252200927',0,'2013-12-26 13:05:16',NULL,NULL),(28051,18078,'TE','9857206225',0,'2014-01-15 02:07:26',NULL,NULL),(25619,16522,'AP','8067903657',1,'2014-01-07 10:21:47',NULL,NULL),(20440,13161,'EM','prsn@horizonview.net',0,'2013-12-26 12:53:53',NULL,NULL),(24578,15854,'TE','3304666406',0,'2014-01-03 02:04:31',NULL,NULL),(1283,781,'EM','val96112@yahoo.com',0,'2013-12-25 18:05:03',NULL,NULL),(24104,15560,'AP','3307017796',1,'2014-01-02 04:31:34',NULL,NULL),(5529,3537,'TE','8307086725',0,'2013-12-25 21:21:39',NULL,NULL),(33770,22164,'AP','5139394618',0,'2014-02-08 19:00:59',NULL,NULL),(41032,27263,'TE','3183663240',0,'2014-03-04 21:00:10',NULL,NULL),(21862,14083,'EM','rarcher53@frontier.com',0,'2013-12-27 02:01:10',NULL,NULL),(6436,4157,'EM','cnakkag@gmail.com',0,'2013-12-25 21:48:56',NULL,NULL),(24433,15774,'TE','2547426475',0,'2014-01-03 02:01:55',NULL,NULL),(13900,9061,'AP','8176157711',0,'2013-12-26 04:06:21',NULL,NULL),(5927,3801,'TE','5139794292',0,'2013-12-25 21:34:31',NULL,NULL),(20924,13453,'AP','9374744557',0,'2013-12-26 13:01:34',NULL,NULL),(14593,9542,'AP','9373713596',0,'2013-12-26 04:36:03',NULL,NULL),(3267,2055,'TE','2162641036',0,'2013-12-25 19:15:59',NULL,NULL),(37337,24584,'TE','5133799521',0,'2014-02-20 04:09:09',NULL,NULL),(38384,25359,'TE','5134907824',0,'2014-02-25 21:30:35',NULL,NULL),(43405,28825,'AP','4193464777',0,'2014-03-09 21:01:03',NULL,NULL),(2617,1592,'EM','andrujoseph@gmail.com',0,'2013-12-25 18:51:48',NULL,NULL),(4011,2550,'AP','3303384236',0,'2013-12-25 19:37:16',NULL,NULL),(7532,4909,'TE','5134510946',0,'2013-12-25 22:32:02',NULL,NULL),(5734,3676,'TE','5136580147',0,'2013-12-25 21:31:20',NULL,NULL),(40232,26686,'AP','3185125142',0,'2014-02-28 21:31:26',NULL,NULL),(41099,27299,'AP','2549816517',0,'2014-03-04 21:00:33',NULL,NULL),(10262,6705,'TE','9377955023',0,'2013-12-26 01:02:03',NULL,NULL),(27294,17574,'EM','lmoore@moorebuildingsolutions.com',0,'2014-01-14 01:32:03',NULL,NULL),(11286,7356,'TE','9722836135',0,'2013-12-26 02:15:15',NULL,NULL),(13625,8882,'EM','sonyaperdue82@yahoo.com',0,'2013-12-26 04:01:49',NULL,NULL),(38771,25633,'AP','6149621354',0,'2014-02-26 08:30:25',NULL,NULL),(38832,25668,'EM','charleytart85@yahoo.com',0,'2014-02-26 08:30:50',NULL,NULL),(39846,26356,'TE','5132528066',0,'2014-02-28 06:31:49',NULL,NULL),(41600,27659,'TE','4196851573',0,'2014-03-05 21:30:26',NULL,NULL),(5742,3680,'AP','3306072315',0,'2013-12-25 21:31:26',NULL,NULL),(7157,4668,'EM','laurierjones@gmail.com',0,'2013-12-25 22:07:33',NULL,NULL),(30978,20151,'TE','5132603766',0,'2014-01-27 21:01:04',NULL,NULL),(26984,17355,'AP','2253244548',0,'2014-01-13 02:24:11',NULL,NULL),(34970,22958,'TE','5049059596',0,'2014-02-12 21:00:07',NULL,NULL),(36523,24046,'AP','8176090303',0,'2014-02-15 22:01:01',NULL,NULL),(36551,24065,'TE','5135636862',0,'2014-02-15 22:01:12',NULL,NULL),(36564,24069,'EM','charla@charlafrank.com',0,'2014-02-15 22:01:15',NULL,NULL),(40372,26795,'TE','4196935728',0,'2014-03-01 21:00:21',NULL,NULL),(9538,6245,'TE','4195156180',0,'2013-12-26 00:31:46',NULL,NULL),(590,363,'TE','6012137208',0,'2013-12-25 17:45:14',NULL,NULL),(31836,20785,'TE','9152613515',0,'2014-01-31 21:00:12',NULL,NULL),(31647,20647,'TE','9157511393',0,'2014-01-30 21:00:36',NULL,NULL),(29689,19187,'EM','silverplatter@hotmail.com',0,'2014-01-21 08:46:11',NULL,NULL),(9362,6128,'AP','9728911662',0,'2013-12-26 00:15:56',NULL,NULL),(23052,14870,'TE','9033638813',0,'2013-12-30 00:00:12',NULL,NULL),(11742,7643,'TE','5136802156',0,'2013-12-26 02:46:38',NULL,NULL),(38130,25169,'AP','2165264746',0,'2014-02-21 22:00:27',NULL,NULL),(40462,26860,'TE','9372170522',0,'2014-03-01 21:00:56',NULL,NULL),(570,353,'EM','tsayre1955@netzero.net',0,'2013-12-25 17:32:21',NULL,NULL),(1386,846,'EM','michael_x_ha@hotmail.com',0,'2013-12-25 18:06:46',NULL,NULL),(31918,20834,'AP','4402288031',0,'2014-01-31 21:00:43',NULL,NULL),(13932,9086,'TE','4194946433',0,'2013-12-26 04:06:57',NULL,NULL),(23303,15017,'TE','3302312938',0,'2014-01-01 12:02:11',NULL,NULL),(6651,4313,'AP','5138058813',0,'2013-12-25 21:52:38',NULL,NULL),(5294,3394,'TE','5049084566',0,'2013-12-25 21:17:56',NULL,NULL),(3380,2124,'TE','5136811596',0,'2013-12-25 19:17:49',NULL,NULL),(4091,2610,'TE','3309565550',0,'2013-12-25 19:45:34',NULL,NULL),(35171,23102,'TE','2162516481',0,'2014-02-12 21:31:12',NULL,NULL),(14879,9738,'AP','9363337640',0,'2013-12-26 04:45:51',NULL,NULL),(31821,20775,'TE','9035061841',0,'2014-01-31 21:00:06',NULL,NULL),(31642,20644,'TE','7182000327',0,'2014-01-30 21:00:35',NULL,NULL),(9528,6237,'TE','8067441524',0,'2013-12-26 00:31:36',NULL,NULL),(24213,15642,'TE','6019412130',1,'2014-01-02 04:33:51',NULL,NULL),(30057,19471,'TE','3237120654',0,'2014-01-23 03:01:59',NULL,NULL),(24378,15742,'AP','9567405543',0,'2014-01-03 02:00:52',NULL,NULL),(34569,22668,'TE','2108239515',0,'2014-02-11 21:00:40',NULL,NULL),(38193,25208,'TE','3306218437',0,'2014-02-21 22:00:50',NULL,NULL),(41778,27776,'EM','joysoc1@frontier.com',0,'2014-03-05 21:31:30',NULL,NULL),(21109,13570,'TE','3182357733',0,'2013-12-26 13:04:39',NULL,NULL),(32606,21320,'TE','5044329340',0,'2014-02-04 21:00:22',NULL,NULL),(8999,5906,'AP','4844106286',0,'2013-12-25 23:49:55',NULL,NULL),(3994,2538,'TE','9373831750',0,'2013-12-25 19:36:57',NULL,NULL),(22527,14525,'AP','8064016650',0,'2013-12-28 03:34:24',NULL,NULL),(6851,4445,'TE','3307531659',0,'2013-12-25 22:02:14',NULL,NULL),(7405,4816,'AP','5672041369',0,'2013-12-25 22:16:57',NULL,NULL),(3840,2443,'TE','3306990043',0,'2013-12-25 19:34:29',NULL,NULL),(8671,5692,'EM','klb8711@yahoo.com',0,'2013-12-25 23:32:39',NULL,NULL),(2306,1410,'AP','5043199262',0,'2013-12-25 18:46:54',NULL,NULL),(1578,973,'EM','jam4425@yahoo.com',0,'2013-12-25 18:10:05',NULL,NULL),(35761,23517,'AP','6626849291',0,'2014-02-13 22:02:18',NULL,NULL),(37169,24468,'TE','9375413693',0,'2014-02-18 22:01:36',NULL,NULL),(39277,25989,'TE','2282358259',0,'2014-02-26 21:01:55',NULL,NULL),(41532,27618,'AP','9374412530',0,'2014-03-05 21:00:32',NULL,NULL),(1405,858,'AP','4192306033',0,'2013-12-25 18:07:05',NULL,NULL),(31486,20518,'TE','8179130533',0,'2014-01-29 21:01:23',NULL,NULL),(30593,19851,'TE','2162280527',0,'2014-01-24 21:00:31',NULL,NULL),(23266,14990,'AP','9032676640',0,'2014-01-01 12:01:24',NULL,NULL),(43091,28645,'TE','6015739608',0,'2014-03-08 21:30:35',NULL,NULL),(22401,14446,'EM','naeemmusicnow@gmail.com',0,'2013-12-28 03:32:22',NULL,NULL),(9577,6270,'EM','eric_m_wheeler@yahoo.com',0,'2013-12-26 00:45:06',NULL,NULL),(7295,4750,'EM','jc3160@yahoo.com',0,'2013-12-25 22:15:11',NULL,NULL),(21001,13513,'AP','9047188734',0,'2013-12-26 13:02:59',NULL,NULL),(20422,13150,'AP','7048196050',0,'2013-12-26 12:53:35',NULL,NULL),(36853,24268,'TE','3372249671',0,'2014-02-17 19:00:15',NULL,NULL),(14937,9772,'AP','2259552337',0,'2013-12-26 05:00:31',NULL,NULL),(14778,9671,'TE','9373820136',0,'2013-12-26 04:39:14',NULL,NULL),(13737,8953,'TE','7405944033',0,'2013-12-26 04:03:38',NULL,NULL),(11783,7666,'AP','5043299923',0,'2013-12-26 03:00:26',NULL,NULL),(24091,15551,'EM','dewanda18@yahoo.com',1,'2014-01-02 04:31:18',NULL,NULL),(21811,14053,'TE','6148769282',0,'2013-12-27 02:00:21',NULL,NULL),(28518,18382,'EM','ashley.kirsch1220@yahoo.com',0,'2014-01-16 08:45:35',NULL,NULL),(35168,23100,'AP','2167023368',0,'2014-02-12 21:31:11',NULL,NULL),(37757,24914,'TE','7408844634',0,'2014-02-20 21:30:10',NULL,NULL),(38634,25536,'AP','7022865020',0,'2014-02-26 08:00:07',NULL,NULL),(39949,26442,'AP','2169388008',0,'2014-02-28 07:30:21',NULL,NULL),(41179,27348,'AP','7408169181',0,'2014-03-04 21:01:03',NULL,NULL),(43003,28598,'AP','3303212172',0,'2014-03-08 21:30:07',NULL,NULL),(43348,28792,'EM','MARIANTJ@JUNO.COM',0,'2014-03-09 21:00:43',NULL,NULL),(467,294,'AP','5134040554',0,'2013-12-25 17:30:39',NULL,NULL),(1028,634,'TE','6143858499',0,'2013-12-25 18:01:11',NULL,NULL),(6468,4185,'TE','3309298754',0,'2013-12-25 21:49:30',NULL,NULL),(22838,14735,'TE','9373939934',1,'2013-12-29 11:09:52',NULL,NULL),(4396,2800,'TE','9378597494',0,'2013-12-25 19:50:24',NULL,NULL),(38314,25310,'EM','maciasg74@gmail.com',0,'2014-02-25 21:00:32',NULL,NULL),(43805,29080,'TE','6012128270',0,'2014-03-10 21:02:02',NULL,NULL),(19,13,'TE','3304723123',0,'2013-12-25 17:15:19',NULL,NULL),(22506,14511,'AP','2106061441',0,'2013-12-28 03:34:03',NULL,NULL),(20818,13381,'TE','3306442621',0,'2013-12-26 12:59:55',NULL,NULL),(10720,6972,'EM','melisa242@yahoo.com',0,'2013-12-26 01:47:29',NULL,NULL),(8505,5594,'TE','3182184962',0,'2013-12-25 23:30:03',NULL,NULL),(34012,22310,'TE','2286696162',0,'2014-02-10 11:00:44',NULL,NULL),(37668,24833,'EM','jthomas_ent@yahoo.com',0,'2014-02-20 04:52:55',NULL,NULL),(21447,13787,'TE','2287315846',0,'2013-12-26 13:10:56',NULL,NULL),(28345,18264,'EM','sandy0083@hotmail.com',0,'2014-01-16 08:44:38',NULL,NULL),(26263,16901,'AP','6232620595',0,'2014-01-13 02:19:33',NULL,NULL),(25396,16379,'TE','8178518011',0,'2014-01-07 04:03:16',NULL,NULL),(24246,15663,'EM','maryannclark@me.com',1,'2014-01-02 04:34:32',NULL,NULL),(24135,15580,'TE','5132512920',1,'2014-01-02 04:32:10',NULL,NULL),(35586,23405,'EM','seslonedz@gmail.com',0,'2014-02-13 22:01:12',NULL,NULL),(36519,24044,'TE','8176090303',0,'2014-02-15 22:01:00',NULL,NULL),(36858,24273,'AP','9374690634',0,'2014-02-17 19:00:18',NULL,NULL),(37163,24462,'TE','3252459811',0,'2014-02-18 22:01:34',NULL,NULL),(42078,27958,'EM','marthalawson52@gmail.com',0,'2014-03-06 21:00:43',NULL,NULL),(22391,14442,'AP','5043199598',0,'2013-12-28 03:32:14',NULL,NULL),(502,317,'AP','3302681789',0,'2013-12-25 17:31:14',NULL,NULL),(11230,7310,'EM','cjstech@yahoo.com',0,'2013-12-26 02:03:20',NULL,NULL),(1824,1129,'EM','ymemdoza0326@gmail.com',0,'2013-12-25 18:18:01',NULL,NULL),(24468,15792,'TE','3187927481',0,'2014-01-03 02:02:32',NULL,NULL),(23548,15198,'AP','6623921103',0,'2014-01-01 12:07:20',NULL,NULL),(5281,3388,'AP','2253037460',0,'2013-12-25 21:17:45',NULL,NULL),(3260,2051,'AP','8302755332',0,'2013-12-25 19:15:52',NULL,NULL),(4803,3071,'TE','6468725598',0,'2013-12-25 20:19:28',NULL,NULL),(36033,23702,'TE','5133250620',0,'2014-02-14 21:30:42',NULL,NULL),(39559,26172,'EM','a2toedmonkey@gmail.com',0,'2014-02-28 06:30:37',NULL,NULL),(40272,26715,'EM','carolyn26mama@gmail.com',0,'2014-02-28 21:31:41',NULL,NULL),(7056,4609,'TE','3305848509',0,'2013-12-25 22:05:56',NULL,NULL),(2850,1733,'AP','9377506744',0,'2013-12-25 18:55:25',NULL,NULL),(32797,21457,'AP','2168350123',0,'2014-02-04 21:01:32',NULL,NULL),(32717,21403,'TE','7405890064',0,'2014-02-04 21:01:03',NULL,NULL),(26479,17041,'AP','5133931680',0,'2014-01-13 02:20:51',NULL,NULL),(36945,24331,'TE','8309952065',0,'2014-02-18 22:00:14',NULL,NULL),(37005,24367,'TE','9856348630',0,'2014-02-18 22:00:35',NULL,NULL),(37731,24884,'TE','5134843500',0,'2014-02-20 05:37:20',NULL,NULL),(43438,28848,'AP','4199569848',0,'2014-03-09 21:01:16',NULL,NULL),(43962,29166,'TE','4192969421',0,'2014-03-10 21:02:56',NULL,NULL),(170,99,'EM','sharara_maria@yahoo.com',0,'2013-12-25 17:17:41',NULL,NULL),(29155,18836,'BN','4403619820',0,'2014-01-17 03:36:11',NULL,NULL),(512,322,'TE','5132271328',0,'2013-12-25 17:31:24',NULL,NULL),(20930,13462,'AP','9042197354',0,'2013-12-26 13:01:47',NULL,NULL),(6938,4519,'AP','2145078737',0,'2013-12-25 22:03:48',NULL,NULL),(42652,28373,'TE','5136252062',0,'2014-03-07 21:30:36',NULL,NULL),(43864,29107,'TE','5046158892',0,'2014-03-10 21:02:21',NULL,NULL),(10601,6899,'EM','ChaMarOli@aol.com',0,'2013-12-26 01:45:35',NULL,NULL),(22974,14819,'TE','9032938145',1,'2013-12-29 11:14:17',NULL,NULL),(30145,19534,'TE','5132074010',0,'2014-01-23 03:02:21',NULL,NULL),(28793,18582,'TE','3308641873',0,'2014-01-16 08:47:09',NULL,NULL),(21563,13868,'TE','3307150439',0,'2013-12-26 13:12:57',NULL,NULL),(26029,16771,'AP','4197989082',0,'2014-01-08 18:25:02',NULL,NULL),(21287,13677,'EM','kustom442@yahoo.com',0,'2013-12-26 13:08:05',NULL,NULL),(23389,15065,'TE','5043146050',0,'2014-01-01 12:03:43',NULL,NULL),(34740,22779,'TE','2403082255',0,'2014-02-11 21:01:43',NULL,NULL),(39672,26231,'AP','9158508757',0,'2014-02-28 06:31:01',NULL,NULL),(1365,833,'TE','3306206732',0,'2013-12-25 18:06:24',NULL,NULL),(34081,22341,'EM','darkseed_10@hotmail.com',0,'2014-02-10 11:01:08',NULL,NULL),(24575,15852,'AP','4194966071',0,'2014-01-03 02:04:27',NULL,NULL),(21171,13617,'AP','5132053384',0,'2013-12-26 13:05:46',NULL,NULL),(9986,6534,'AP','7138222839',0,'2013-12-26 00:51:46',NULL,NULL),(1989,1228,'AP','3303178613',0,'2013-12-25 18:20:38',NULL,NULL),(8131,5324,'TE','5133854428',0,'2013-12-25 23:06:54',NULL,NULL),(14570,9520,'EM','lukekess@gmail.com',0,'2013-12-26 04:35:38',NULL,NULL),(34730,22773,'TE','9092547232',0,'2014-02-11 21:01:39',NULL,NULL),(40654,26988,'AP','4199570822',0,'2014-03-03 01:00:41',NULL,NULL),(41584,27647,'AP','4403399596',0,'2014-03-05 21:30:20',NULL,NULL),(6212,4002,'TE','5137291674',0,'2013-12-25 21:45:13',NULL,NULL),(32976,21585,'TE','7402881626',0,'2014-02-05 21:30:27',NULL,NULL),(25106,16185,'TE','4093823430',0,'2014-01-05 00:00:40',NULL,NULL),(29791,19267,'TE','4192445180',0,'2014-01-21 08:46:52',NULL,NULL),(37138,24447,'TE','5043942293',0,'2014-02-18 22:01:24',NULL,NULL),(9370,6133,'TE','9852349393',0,'2013-12-26 00:16:04',NULL,NULL),(32156,21005,'TE','5047820558',0,'2014-02-01 19:00:31',NULL,NULL),(29465,19049,'TE','2256128905',0,'2014-01-20 08:06:43',NULL,NULL),(29787,19263,'TE','4194390247',0,'2014-01-21 08:46:50',NULL,NULL),(42093,27968,'EM','toniking86@yahoo.com',0,'2014-03-06 21:00:49',NULL,NULL),(14789,9678,'AP','4198226245',0,'2013-12-26 04:39:24',NULL,NULL),(22049,14200,'TE','5129585585',0,'2013-12-27 02:04:13',NULL,NULL),(8604,5653,'TE','9154439316',0,'2013-12-25 23:31:34',NULL,NULL),(4419,2816,'EM','mvomacka@gmail.com',0,'2013-12-25 20:00:24',NULL,NULL),(37745,24904,'AP','8067900857',0,'2014-02-20 21:30:03',NULL,NULL),(9784,6402,'AP','3175860548',0,'2013-12-26 00:48:23',NULL,NULL),(3151,1967,'EM','lupitadiggins@gmail.com',0,'2013-12-25 19:01:23',NULL,NULL),(11680,7603,'EM','missgracie63@yahoo.com',0,'2013-12-26 02:45:26',NULL,NULL),(27676,17839,'AP','6144029139',0,'2014-01-15 02:06:03',NULL,NULL),(27036,17383,'EM','nissencon@sbcglobal.net',0,'2014-01-13 03:00:08',NULL,NULL),(26342,16955,'AP','9376380844',0,'2014-01-13 02:20:03',NULL,NULL),(14742,9643,'TE','8179179794',0,'2013-12-26 04:38:33',NULL,NULL),(36971,24343,'AP','2146977124',0,'2014-02-18 22:00:21',NULL,NULL),(38358,25337,'AP','5049121771',0,'2014-02-25 21:30:23',NULL,NULL),(23992,15487,'TE','5138274282',1,'2014-01-02 04:29:22',NULL,NULL),(3999,2541,'EM','daniel_j_mccormick@hotmail.com',0,'2013-12-25 19:37:03',NULL,NULL),(20835,13392,'TE','7405914287',0,'2013-12-26 13:00:11',NULL,NULL),(2746,1666,'TE','4092873979',0,'2013-12-25 18:53:45',NULL,NULL),(26891,17300,'AP','2147621933',0,'2014-01-13 02:23:38',NULL,NULL),(27386,17627,'EM','ARUNILN@MSN.COM',0,'2014-01-14 01:32:31',NULL,NULL),(37743,24903,'TE','9564238101',0,'2014-02-20 21:30:03',NULL,NULL),(38138,25173,'TE','7405455238',0,'2014-02-21 22:00:29',NULL,NULL),(42499,28263,'BN','6627399944',0,'2014-03-07 21:00:18',NULL,NULL),(296,182,'EM','towpathenterprise@gmail.com',0,'2013-12-25 17:19:43',NULL,NULL),(25260,16287,'TE','9375438243',0,'2014-01-07 04:00:43',NULL,NULL),(28012,18055,'BN','4193408632',0,'2014-01-15 02:07:18',NULL,NULL),(11159,7259,'TE','9373028069',0,'2013-12-26 02:02:05',NULL,NULL),(27736,17882,'AP','7407271503',0,'2014-01-15 02:06:16',NULL,NULL),(10867,7053,'EM','norriskathleen@hotmail.com',0,'2013-12-26 01:49:46',NULL,NULL),(22442,14474,'TE','9722685162',0,'2013-12-28 03:33:06',NULL,NULL),(1898,1170,'TE','3303362824',0,'2013-12-25 18:19:09',NULL,NULL),(9705,6354,'EM','lastminute@fuse.net',0,'2013-12-26 00:47:09',NULL,NULL),(6628,4283,'EM','rdhalker@netscape.net',0,'2013-12-25 21:52:03',NULL,NULL),(9635,6305,'TE','4192100842',0,'2013-12-26 00:46:02',NULL,NULL),(36712,24171,'EM','kbut1128@hotmail.com',0,'2014-02-15 22:02:09',NULL,NULL),(42044,27941,'AP','9154877557',0,'2014-03-06 21:00:32',NULL,NULL),(43430,28842,'TE','3307456709',0,'2014-03-09 21:01:13',NULL,NULL),(188,112,'TE','9405358043',0,'2013-12-25 17:17:59',NULL,NULL),(24771,15981,'TE','7133035767',0,'2014-01-04 02:00:56',NULL,NULL),(31884,20810,'AP','8322077280',0,'2014-01-31 21:00:28',NULL,NULL),(10363,6755,'EM','cam011782@aol.com',0,'2013-12-26 01:16:12',NULL,NULL),(20533,13216,'TE','2104164935',0,'2013-12-26 12:55:24',NULL,NULL),(5599,3585,'TE','5137715087',0,'2013-12-25 21:22:50',NULL,NULL),(21738,14003,'EM','ryantarpley@gmail.com',0,'2013-12-26 13:16:09',NULL,NULL),(2839,1721,'EM','dmyers88@att.net',0,'2013-12-25 18:55:13',NULL,NULL),(36155,23795,'EM','nm@cnecpp.com',0,'2014-02-14 21:31:27',NULL,NULL),(39872,26378,'TE','2253851630',0,'2014-02-28 07:00:18',NULL,NULL),(40276,26717,'TE','7692334050',0,'2014-02-28 21:31:42',NULL,NULL),(759,476,'TE','3182682039',0,'2013-12-25 17:48:01',NULL,NULL),(3605,2273,'TE','9377044406',0,'2013-12-25 19:30:26',NULL,NULL),(34220,22443,'TE','9407044982',0,'2014-02-10 21:30:43',NULL,NULL),(13634,8891,'TE','8066766431',0,'2013-12-26 04:02:01',NULL,NULL),(4936,3171,'TE','5138441038',0,'2013-12-25 20:31:32',NULL,NULL),(13661,8906,'AP','3303470983',0,'2013-12-26 04:02:26',NULL,NULL),(26781,17228,'AP','6625883439',0,'2014-01-13 02:22:38',NULL,NULL),(38605,25513,'EM','m.shumway@zoomtown.com',0,'2014-02-25 21:32:02',NULL,NULL),(39019,25801,'AP','5132233055',0,'2014-02-26 21:00:17',NULL,NULL),(25938,16710,'EM','amy.shuffield@gmail.com',0,'2014-01-08 18:24:42',NULL,NULL),(34087,22344,'EM','petnurse05@yahoo.com',0,'2014-02-10 11:01:11',NULL,NULL),(30491,19779,'EM','lindykaemming@gmail.com',0,'2014-01-23 21:01:33',NULL,NULL),(24436,15775,'TE','2142447888',0,'2014-01-03 02:01:57',NULL,NULL),(26870,17289,'BN','8062022525',0,'2014-01-13 02:23:32',NULL,NULL),(22032,14187,'AP','9793247838',0,'2013-12-27 02:03:54',NULL,NULL),(5844,3750,'TE','9038384093',0,'2013-12-25 21:33:08',NULL,NULL),(4625,2948,'TE','5132265813',0,'2013-12-25 20:16:27',NULL,NULL),(11944,7778,'TE','9362549084',0,'2013-12-26 03:03:07',NULL,NULL),(1923,1192,'TE','5167071206',0,'2013-12-25 18:19:38',NULL,NULL),(21802,14047,'AP','5133642775',0,'2013-12-27 02:00:11',NULL,NULL),(21502,13818,'AP','3307545500',0,'2013-12-26 13:11:49',NULL,NULL),(38640,25538,'AP','5133000627',0,'2014-02-26 08:00:09',NULL,NULL),(39534,26152,'TE','5134656347',0,'2014-02-28 06:30:29',NULL,NULL),(41557,27630,'AP','3304144626',0,'2014-03-05 21:30:10',NULL,NULL),(42445,28192,'TE','7133666927',0,'2014-03-06 21:30:04',NULL,NULL),(23668,15282,'EM','v_mccord@yahoo.com',1,'2014-01-02 04:22:11',NULL,NULL),(33674,22087,'EM','ivancardentey@yahoo.com',0,'2014-02-08 19:00:22',NULL,NULL),(31728,20706,'TE','3183519493',0,'2014-01-30 21:01:06',NULL,NULL),(7780,5076,'EM','twilliams79@sbcglobal.net',0,'2013-12-25 23:00:51',NULL,NULL),(22846,14743,'TE','2256732120',1,'2013-12-29 11:10:05',NULL,NULL),(2223,1367,'TE','9038871945',0,'2013-12-25 18:45:39',NULL,NULL),(11707,7622,'AP','9366452484',0,'2013-12-26 02:45:57',NULL,NULL),(20826,13386,'TE','3307225444',0,'2013-12-26 13:00:01',NULL,NULL),(38761,25624,'TE','2168544730',0,'2014-02-26 08:30:19',NULL,NULL),(40207,26669,'TE','2255724425',0,'2014-02-28 21:31:17',NULL,NULL),(40627,26967,'AP','9562454395',0,'2014-03-03 01:00:33',NULL,NULL),(41209,27370,'TE','6622897313',0,'2014-03-04 21:01:16',NULL,NULL),(44010,29206,'AP','4194903708',0,'2014-03-10 21:30:13',NULL,NULL),(9750,6375,'TE','9372763017',0,'2013-12-26 00:47:47',NULL,NULL),(33868,22231,'AP','8065767496',0,'2014-02-09 19:00:32',NULL,NULL),(31966,20872,'TE','6013163209',0,'2014-01-31 21:01:02',NULL,NULL),(28232,18205,'EM','rosebird2792@gmail.com',0,'2014-01-15 02:08:08',NULL,NULL),(26113,16816,'TE','6015064271',0,'2014-01-13 02:18:19',NULL,NULL),(8826,5779,'EM','avilescarlos009@gmail.com',0,'2013-12-25 23:47:00',NULL,NULL),(6086,3916,'AP','2144138801',0,'2013-12-25 21:37:15',NULL,NULL),(2950,1819,'TE','4193445456',0,'2013-12-25 18:57:12',NULL,NULL),(40683,27014,'AP','2817619666',0,'2014-03-03 21:00:09',NULL,NULL),(42370,28139,'EM','srwalkerjamarr@gmail.com',0,'2014-03-06 21:02:30',NULL,NULL),(3059,1902,'EM','brneyes412002@yahoo.com',0,'2013-12-25 18:59:10',NULL,NULL),(7466,4860,'TE','9034693929',0,'2013-12-25 22:30:39',NULL,NULL),(2201,1352,'TE','8064188828',0,'2013-12-25 18:45:17',NULL,NULL),(37076,24412,'TE','3305016154',0,'2014-02-18 22:01:02',NULL,NULL),(39579,26183,'TE','6145986203',0,'2014-02-28 06:30:41',NULL,NULL),(41343,27466,'TE','5132577729',0,'2014-03-04 21:02:08',NULL,NULL),(14606,9549,'AP','4196190466',0,'2013-12-26 04:36:15',NULL,NULL),(35213,23127,'AP','3302963350',0,'2014-02-12 21:31:27',NULL,NULL),(21724,13996,'EM','ldealey@frontier.com',0,'2013-12-26 13:15:56',NULL,NULL),(30349,19665,'AP','5042409432',0,'2014-01-23 21:00:27',NULL,NULL),(27886,17970,'TE','4407968330',0,'2014-01-15 02:06:49',NULL,NULL),(27795,17915,'EM','SHIRLEY_MISTY@YAHOO.COM',0,'2014-01-15 02:06:29',NULL,NULL),(22669,14616,'TE','5674298580',0,'2013-12-28 03:36:48',NULL,NULL),(40948,27210,'TE','4193482351',0,'2014-03-03 21:31:27',NULL,NULL),(43508,28888,'EM','judy@manza.com',0,'2014-03-10 21:00:13',NULL,NULL),(3513,2196,'TE','9374400915',0,'2013-12-25 19:19:54',NULL,NULL),(24147,15598,'AP','4192394360',1,'2014-01-02 04:32:36',NULL,NULL),(6736,4375,'TE','7403422654',0,'2013-12-25 22:00:26',NULL,NULL),(30460,19747,'AP','9562072624',0,'2014-01-23 21:01:15',NULL,NULL),(40787,27106,'AP','6304869775',0,'2014-03-03 21:30:25',NULL,NULL),(41881,27848,'EM','michele0840@sbcglobal.net',0,'2014-03-05 21:32:11',NULL,NULL),(43009,28601,'TE','5133178448',0,'2014-03-08 21:30:09',NULL,NULL),(14532,9494,'TE','9373214790',0,'2013-12-26 04:34:59',NULL,NULL),(3501,2189,'TE','9373655041',0,'2013-12-25 19:19:41',NULL,NULL),(38920,25728,'AP','3183814086',0,'2014-02-26 09:30:33',NULL,NULL),(40162,26637,'TE','8329166053',0,'2014-02-28 21:31:01',NULL,NULL),(10832,7034,'TE','5123350561',0,'2013-12-26 01:49:13',NULL,NULL),(1563,962,'EM','sissy9647@gmail.com',0,'2013-12-25 18:09:49',NULL,NULL),(26170,16849,'TE','3303369186',0,'2014-01-13 02:18:39',NULL,NULL),(21431,13779,'TE','6623292211',0,'2013-12-26 13:10:41',NULL,NULL),(20302,13086,'TE','6144871770',0,'2013-12-26 12:51:44',NULL,NULL),(33451,21912,'TE','4127165040',0,'2014-02-06 21:30:03',NULL,NULL),(35519,23361,'EM','moparguy1943@yahoo.com',0,'2014-02-13 22:00:46',NULL,NULL),(38785,25640,'TE','5044868183',0,'2014-02-26 08:30:30',NULL,NULL),(1233,752,'TE','9036634598',0,'2013-12-25 18:04:18',NULL,NULL),(7080,4623,'EM','REDINBLACK10@AOL.COM',0,'2013-12-25 22:06:18',NULL,NULL),(24214,15642,'AP','6019412130',1,'2014-01-02 04:33:51',NULL,NULL),(23756,15324,'AP','8064667947',1,'2014-01-02 04:23:41',NULL,NULL),(23617,15246,'EM','nortonja@mail.uc.edu',0,'2014-01-01 12:08:49',NULL,NULL),(22290,14366,'TE','2166440814',0,'2013-12-28 03:30:24',NULL,NULL),(2292,1405,'TE','5042822029',0,'2013-12-25 18:46:44',NULL,NULL),(9187,6014,'AP','8598149354',0,'2013-12-26 00:00:40',NULL,NULL),(10850,7041,'TE','8172662672',0,'2013-12-26 01:49:27',NULL,NULL),(31778,20743,'EM','bbrodbeck@bex.net',0,'2014-01-30 21:01:25',NULL,NULL),(35376,23245,'AP','3306717566',0,'2014-02-13 21:30:04',NULL,NULL),(36852,24267,'AP','4402135724',0,'2014-02-17 19:00:15',NULL,NULL),(40111,26600,'TE','9798465489',0,'2014-02-28 21:30:41',NULL,NULL),(1239,754,'TE','6824297848',0,'2013-12-25 18:04:22',NULL,NULL),(1259,764,'TE','8063735850',0,'2013-12-25 18:04:39',NULL,NULL),(25974,16729,'AP','3307019455',0,'2014-01-08 18:24:49',NULL,NULL),(3642,2304,'EM','Johnisenbarger2@gmail.com',0,'2013-12-25 19:31:04',NULL,NULL),(23459,15123,'TE','5135320540',0,'2014-01-01 12:05:16',NULL,NULL),(22965,14812,'AP','3379675251',1,'2013-12-29 11:14:06',NULL,NULL),(22282,14362,'EM','teresabecker22@yahoo.com',0,'2013-12-28 03:30:18',NULL,NULL),(10410,6786,'AP','9792569525',0,'2013-12-26 01:16:59',NULL,NULL),(33644,22062,'AP','7138261776',0,'2014-02-08 19:00:11',NULL,NULL),(41396,27499,'AP','4193604463',0,'2014-03-04 21:02:28',NULL,NULL),(43705,29016,'TE','4402211778',0,'2014-03-10 21:01:26',NULL,NULL),(43964,29167,'TE','4402253062',0,'2014-03-10 21:02:57',NULL,NULL),(14307,9357,'TE','7874331023',0,'2013-12-26 04:31:25',NULL,NULL),(30177,19550,'TE','4199132329',0,'2014-01-23 03:02:28',NULL,NULL),(29308,18935,'AP','7403312370',0,'2014-01-20 08:05:41',NULL,NULL),(24750,15970,'AP','9153568914',0,'2014-01-04 02:00:34',NULL,NULL),(20814,13375,'AP','4403394917',0,'2013-12-26 12:59:49',NULL,NULL),(1536,943,'AP','2162143135',0,'2013-12-25 18:09:25',NULL,NULL),(7640,4974,'AP','4093515357',0,'2013-12-25 22:46:33',NULL,NULL),(37379,24615,'TE','6015591201',0,'2014-02-20 04:14:56',NULL,NULL),(12192,7967,'EM','adriane.mccain@gmail.com',0,'2013-12-26 03:07:35',NULL,NULL),(8658,5687,'EM','dion197997@gmail.com',0,'2013-12-25 23:32:30',NULL,NULL),(3013,1874,'TE','3306446043',0,'2013-12-25 18:58:22',NULL,NULL),(26048,16780,'AP','7025725002',0,'2014-01-08 18:25:05',NULL,NULL),(23998,15489,'EM','angsto63@yahoo.com',1,'2014-01-02 04:29:27',NULL,NULL),(23620,15247,'EM','scottwormell@gmail.com',0,'2014-01-01 12:08:52',NULL,NULL),(8473,5574,'AP','3048120595',0,'2013-12-25 23:16:47',NULL,NULL),(6802,4413,'EM','Rmburger17@gmail.com',0,'2013-12-25 22:01:26',NULL,NULL),(9610,6289,'EM','Rassad84@gmail.com',0,'2013-12-26 00:45:37',NULL,NULL),(43050,28621,'AP','4695445638',0,'2014-03-08 21:30:22',NULL,NULL),(43082,28641,'TE','5126083699',0,'2014-03-08 21:30:32',NULL,NULL),(804,500,'TE','7404274077',0,'2013-12-25 17:48:41',NULL,NULL),(8568,5633,'EM','mharris2511@sbcglobal.net',0,'2013-12-25 23:31:01',NULL,NULL),(11372,7406,'EM','aliciarae1217@outlook.com',0,'2013-12-26 02:16:36',NULL,NULL),(7729,5046,'AP','6785755012',0,'2013-12-25 22:48:09',NULL,NULL),(26799,17238,'EM','dongzhihang@yahoo.com',0,'2014-01-13 02:22:44',NULL,NULL),(24702,15935,'TE','6142600728',0,'2014-01-03 02:07:02',NULL,NULL),(23699,15297,'EM','triciatrish38@yahoo.com',1,'2014-01-02 04:22:43',NULL,NULL),(33956,22279,'AP','9158503921',0,'2014-02-10 11:00:20',NULL,NULL),(33978,22289,'TE','4196106927',0,'2014-02-10 11:00:29',NULL,NULL),(37384,24619,'TE','6012148221',0,'2014-02-20 04:15:47',NULL,NULL),(38946,25749,'TE','4193430409',0,'2014-02-26 09:30:44',NULL,NULL),(42993,28593,'TE','9376991245',0,'2014-03-08 21:30:04',NULL,NULL),(20384,13130,'TE','4193574455',0,'2013-12-26 12:53:00',NULL,NULL),(8072,5284,'EM','anne@castonmassage.com',0,'2013-12-25 23:05:52',NULL,NULL),(28645,18470,'EM','Seashel0029@netscape.net',0,'2014-01-16 08:46:17',NULL,NULL),(26371,16975,'TE','2282141509',0,'2014-01-13 02:20:15',NULL,NULL),(14849,9718,'TE','3308292929',0,'2013-12-26 04:45:22',NULL,NULL),(11841,7704,'AP','9372437034',0,'2013-12-26 03:01:20',NULL,NULL),(11382,7411,'TE','2108857850',0,'2013-12-26 02:16:44',NULL,NULL),(21962,14149,'TE','9856341435',0,'2013-12-27 02:02:50',NULL,NULL),(21774,14029,'TE','2165242006',0,'2013-12-26 13:16:50',NULL,NULL),(9659,6322,'EM','mylesmildred84@yahoo.com',0,'2013-12-26 00:46:24',NULL,NULL),(32233,21054,'TE','6789866254',0,'2014-02-02 19:00:07',NULL,NULL),(32277,21084,'EM','d.burstion-donbraye@att.net',0,'2014-02-02 19:00:24',NULL,NULL),(33108,21689,'TE','2257733230',0,'2014-02-05 21:31:05',NULL,NULL),(36142,23786,'TE','3308659922',0,'2014-02-14 21:31:23',NULL,NULL),(39128,25881,'TE','5092224586',0,'2014-02-26 21:00:58',NULL,NULL),(42841,28492,'AP','6016722180',0,'2014-03-07 21:31:42',NULL,NULL),(12446,8153,'TE','5057105871',0,'2013-12-26 03:16:06',NULL,NULL),(12074,7886,'TE','4199666293',0,'2013-12-26 03:05:31',NULL,NULL),(33740,22137,'BN','7404590231',0,'2014-02-08 19:00:47',NULL,NULL),(43067,28633,'TE','9039631046',0,'2014-03-08 21:30:28',NULL,NULL),(4284,2737,'TE','4194204306',0,'2013-12-25 19:48:40',NULL,NULL),(32205,21035,'TE','5132848773',0,'2014-02-01 19:00:47',NULL,NULL),(32034,20910,'AP','4197041148',0,'2014-01-31 21:01:27',NULL,NULL),(30015,19437,'TE','5137970951',1,'2014-01-22 03:23:11',NULL,NULL),(3509,2192,'AP','5135052950',0,'2013-12-25 19:19:48',NULL,NULL),(27221,17526,'AP','5139811135',0,'2014-01-13 03:01:40',NULL,NULL),(33296,21805,'EM','cormeacru@gmail.com',0,'2014-02-06 21:00:51',NULL,NULL),(37458,24665,'TE','4192862223',0,'2014-02-20 04:26:37',NULL,NULL),(40880,27163,'TE','8329646161',0,'2014-03-03 21:31:01',NULL,NULL),(11397,7418,'EM','webe9323@aol.com',0,'2013-12-26 02:16:57',NULL,NULL),(10254,6700,'EM','alkit6@aol.com',0,'2013-12-26 01:01:54',NULL,NULL),(29267,18902,'TE','4194835546',0,'2014-01-17 03:36:37',NULL,NULL),(28003,18049,'TE','6019405641',0,'2014-01-15 02:07:16',NULL,NULL),(27308,17587,'AP','3307035121',0,'2014-01-14 01:32:08',NULL,NULL),(26266,16904,'TE','6143156796',0,'2014-01-13 02:19:34',NULL,NULL),(10237,6694,'TE','9402299283',0,'2013-12-26 01:01:40',NULL,NULL),(5064,3251,'TE','8477576654',0,'2013-12-25 20:46:38',NULL,NULL),(33013,21630,'AP','9039491971',0,'2014-02-05 21:30:40',NULL,NULL),(36699,24161,'AP','3307150068',0,'2014-02-15 22:02:04',NULL,NULL),(37365,24596,'TE','3304161204',0,'2014-02-20 04:12:13',NULL,NULL),(40491,26874,'TE','5674594066',0,'2014-03-01 21:01:05',NULL,NULL),(42606,28345,'TE','4324254035',0,'2014-03-07 21:30:20',NULL,NULL),(43849,29101,'TE','5133714021',0,'2014-03-10 21:02:16',NULL,NULL),(4152,2648,'EM','pparsons51@aol.com',0,'2013-12-25 19:46:33',NULL,NULL),(3457,2163,'EM','jfinley08@yahoo.com',0,'2013-12-25 19:18:59',NULL,NULL),(23612,15245,'TE','9375871215',0,'2014-01-01 12:08:45',NULL,NULL),(26229,16881,'EM','karlaingram@att.net',0,'2014-01-13 02:19:22',NULL,NULL),(24102,15558,'TE','2165443536',1,'2014-01-02 04:31:31',NULL,NULL),(33622,22048,'AP','4193052865',0,'2014-02-07 19:30:06',NULL,NULL),(34072,22336,'TE','4194724174',0,'2014-02-10 11:01:05',NULL,NULL),(35904,23623,'EM','mike.vayda@gmail.com',0,'2014-02-13 22:03:18',NULL,NULL),(37962,25047,'AP','5132535115',0,'2014-02-20 22:01:15',NULL,NULL),(27395,17634,'EM','shmuelkessler@hotmail.com',0,'2014-01-14 01:32:35',NULL,NULL),(27487,17706,'AP','2253159598',0,'2014-01-14 01:33:07',NULL,NULL),(36549,24064,'AP','3303175326',0,'2014-02-15 22:01:11',NULL,NULL),(37701,24859,'TE','3304210660',0,'2014-02-20 04:56:42',NULL,NULL),(41452,27546,'TE','6149007039',0,'2014-03-04 21:30:09',NULL,NULL),(722,449,'EM','szymek20@yahoo.com',0,'2013-12-25 17:47:23',NULL,NULL),(30276,19615,'AP','2164507724',0,'2014-01-23 03:02:52',NULL,NULL),(28748,18551,'AP','6627197875',0,'2014-01-16 08:46:54',NULL,NULL),(26039,16776,'TE','5132930683',0,'2014-01-08 18:25:04',NULL,NULL),(24425,15768,'AP','9036547663',0,'2014-01-03 02:01:44',NULL,NULL),(20793,13363,'TE','2162873083',0,'2013-12-26 12:59:31',NULL,NULL),(6251,4030,'AP','9379263401',0,'2013-12-25 21:45:53',NULL,NULL),(12440,8149,'EM','lupitadiggins@allstate.com',0,'2013-12-26 03:15:59',NULL,NULL),(3595,2257,'TE','6148714833',0,'2013-12-25 19:30:12',NULL,NULL),(20240,13039,'EM','kathycrowe@usa.net',0,'2013-12-26 12:50:34',NULL,NULL),(8788,5757,'AP','4405391544',0,'2013-12-25 23:46:25',NULL,NULL),(30482,19764,'AP','9013830928',0,'2014-01-23 21:01:25',NULL,NULL),(11458,7450,'AP','2164015666',0,'2013-12-26 02:30:42',NULL,NULL),(25272,16293,'EM','jwarren23@cinci.rr.com',0,'2014-01-07 04:00:56',NULL,NULL),(22039,14193,'EM','connieg99@yahoo.com',0,'2013-12-27 02:04:03',NULL,NULL),(11228,7304,'EM','gjdeiters@att.net',0,'2013-12-26 02:03:13',NULL,NULL),(31665,20659,'TE','8308795510',0,'2014-01-30 21:00:43',NULL,NULL),(31377,20453,'AP','7409351894',0,'2014-01-29 21:00:46',NULL,NULL),(23322,15026,'AP','3188346655',0,'2014-01-01 12:02:29',NULL,NULL),(28283,18234,'AP','9407821736',0,'2014-01-16 08:44:21',NULL,NULL),(25820,16645,'TE','9378553117',0,'2014-01-08 18:24:19',NULL,NULL),(25196,16244,'EM','j_patel22@yahoo.com',0,'2014-01-05 00:02:30',NULL,NULL),(43499,28884,'TE','5126353197',0,'2014-03-10 21:00:11',NULL,NULL),(2717,1649,'EM','RoderickLRogers@aol.com',0,'2013-12-25 18:53:19',NULL,NULL),(4459,2840,'TE','3305192292',0,'2013-12-25 20:01:02',NULL,NULL),(5680,3648,'TE','2168496368',0,'2013-12-25 21:30:34',NULL,NULL),(21823,14059,'AP','5135714067',0,'2013-12-27 02:00:32',NULL,NULL),(29030,18743,'AP','4404174525',0,'2014-01-17 03:35:41',NULL,NULL),(26414,16998,'AP','3308197283',0,'2014-01-13 02:20:29',NULL,NULL),(39048,25824,'EM','desirae_taylor@hotmail.com',0,'2014-02-26 21:00:27',NULL,NULL),(40359,26786,'AP','3614531314',0,'2014-03-01 21:00:15',NULL,NULL),(11470,7460,'TE','4402258300',0,'2013-12-26 02:30:54',NULL,NULL),(31291,20385,'TE','8176006785',0,'2014-01-29 21:00:13',NULL,NULL),(7320,4759,'TE','8067909437',0,'2013-12-25 22:15:30',NULL,NULL),(9709,6356,'AP','9372864086',0,'2013-12-26 00:47:13',NULL,NULL),(24815,16008,'EM','joeysmom20@msn.com',0,'2014-01-04 02:01:43',NULL,NULL),(22235,14331,'AP','5672038450',0,'2013-12-27 02:07:34',NULL,NULL),(33620,22047,'AP','3372781367',0,'2014-02-07 19:30:05',NULL,NULL),(35068,23030,'TE','7139924779',0,'2014-02-12 21:30:34',NULL,NULL),(38603,25511,'TE','9379275612',0,'2014-02-25 21:32:01',NULL,NULL),(38975,25771,'EM','kimmyp509@gmail.com',0,'2014-02-26 09:30:56',NULL,NULL),(10511,6845,'AP','4193814908',0,'2013-12-26 01:31:13',NULL,NULL),(32308,21107,'EM','delimantoo@aol.com',0,'2014-02-03 21:00:05',NULL,NULL),(4401,2804,'EM','heat_1987@yahoo.com',0,'2013-12-25 19:50:30',NULL,NULL),(30911,20099,'TE','5043140857',0,'2014-01-27 21:00:34',NULL,NULL),(1264,768,'AP','8303527280',0,'2013-12-25 18:04:45',NULL,NULL),(1840,1139,'TE','3378845779',0,'2013-12-25 18:18:16',NULL,NULL),(25012,16116,'EM','hhemani59@gmail.com',0,'2014-01-04 02:05:18',NULL,NULL),(25469,16424,'AP','9375272725',0,'2014-01-07 04:04:36',NULL,NULL),(33319,21822,'AP','9039484532',0,'2014-02-06 21:01:00',NULL,NULL),(34359,22537,'EM','pinchthetail@hotmail.com',0,'2014-02-10 21:31:36',NULL,NULL),(2154,1326,'AP','4407255670',0,'2013-12-25 18:31:56',NULL,NULL),(27822,17929,'AP','2105620156',0,'2014-01-15 02:06:34',NULL,NULL),(28498,18364,'TE','4405439670',0,'2014-01-16 08:45:27',NULL,NULL),(29086,18785,'TE','9373367804',0,'2014-01-17 03:35:54',NULL,NULL),(28867,18639,'AP','2144985588',0,'2014-01-17 03:35:05',NULL,NULL),(40851,27146,'AP','2167896771',0,'2014-03-03 21:30:50',NULL,NULL),(42976,28579,'AP','9795430233',0,'2014-03-08 21:00:06',NULL,NULL),(9910,6486,'TE','3302863045',0,'2013-12-26 00:50:27',NULL,NULL),(32344,21131,'AP','3256601966',0,'2014-02-03 21:00:18',NULL,NULL),(27497,17713,'EM','ellenderveal1@yahoo.com',0,'2014-01-14 01:33:11',NULL,NULL),(29417,19017,'EM','czemrock731@gmail.com',0,'2014-01-20 08:06:23',NULL,NULL),(33241,21769,'TE','6148997046',0,'2014-02-06 21:00:31',NULL,NULL),(36545,24062,'AP','2166825104',0,'2014-02-15 22:01:10',NULL,NULL),(39538,26158,'AP','5137067295',0,'2014-02-28 06:30:31',NULL,NULL),(40153,26629,'AP','9155198655',0,'2014-02-28 21:30:57',NULL,NULL),(40303,26735,'EM','rossrick@yahoo.com',0,'2014-02-28 21:31:52',NULL,NULL),(41481,27572,'AP','6017133600',0,'2014-03-04 21:30:21',NULL,NULL),(43020,28605,'TE','2526704961',0,'2014-03-08 21:30:12',NULL,NULL),(11574,7532,'TE','3148249793',0,'2013-12-26 02:32:42',NULL,NULL),(30266,19611,'TE','4409419636',0,'2014-01-23 03:02:50',NULL,NULL),(29550,19096,'AP','9372101703',0,'2014-01-21 08:44:35',NULL,NULL),(23212,14957,'AP','8064770459',0,'2014-01-01 12:00:25',NULL,NULL),(23829,15373,'EM','alonzopollard@yahoo.com',1,'2014-01-02 04:25:10',NULL,NULL),(34050,22325,'EM','damonicintentions@gmail.com',0,'2014-02-10 11:00:57',NULL,NULL),(36377,23957,'TE','4322941186',0,'2014-02-15 22:00:07',NULL,NULL),(39025,25807,'TE','3305504500',0,'2014-02-26 21:00:19',NULL,NULL),(2679,1625,'AP','9157304535',0,'2013-12-25 18:52:42',NULL,NULL),(11165,7263,'TE','3256535158',0,'2013-12-26 02:02:12',NULL,NULL),(31337,20421,'TE','9372101703',0,'2014-01-29 21:00:30',NULL,NULL),(29653,19157,'AP','3309836764',0,'2014-01-21 08:45:39',NULL,NULL),(27606,17796,'TE','5136738338',0,'2014-01-14 01:33:51',NULL,NULL),(25618,16522,'TE','8067903657',1,'2014-01-07 10:21:46',NULL,NULL),(8189,5359,'TE','3306456777',0,'2013-12-25 23:07:49',NULL,NULL),(4493,2858,'TE','6145569262',0,'2013-12-25 20:01:34',NULL,NULL),(10539,6865,'TE','2162368464',0,'2013-12-26 01:31:47',NULL,NULL),(42829,28487,'TE','5135317666',0,'2014-03-07 21:31:39',NULL,NULL),(43637,28964,'AP','8326470939',0,'2014-03-10 21:00:59',NULL,NULL),(8980,5885,'EM','golf@pumpkinvinegolf.com',0,'2013-12-25 23:49:33',NULL,NULL),(8325,5460,'TE','3304190535',0,'2013-12-25 23:10:23',NULL,NULL),(29193,18860,'EM','bmshivers@att.net',0,'2014-01-17 03:36:20',NULL,NULL),(4831,3092,'TE','4197526838',0,'2013-12-25 20:20:02',NULL,NULL),(26918,17314,'AP','9406369376',0,'2014-01-13 02:23:46',NULL,NULL),(23773,15332,'EM','ebsmith75@gmail.com',1,'2014-01-02 04:23:58',NULL,NULL),(7208,4697,'TE','9375103138',0,'2013-12-25 22:08:20',NULL,NULL),(8250,5396,'EM','gulfstate2001@yahoo.com',0,'2013-12-25 23:08:49',NULL,NULL),(34333,22524,'EM','klwaits2040@gmail.com',0,'2014-02-10 21:31:28',NULL,NULL),(38430,25398,'TE','3303288844',0,'2014-02-25 21:30:54',NULL,NULL),(43167,28687,'TE','3303890714',0,'2014-03-08 21:31:01',NULL,NULL),(10278,6711,'TE','2694140603',0,'2013-12-26 01:02:16',NULL,NULL),(29782,19257,'EM','ron@preservationhall.com',0,'2014-01-21 08:46:47',NULL,NULL),(4665,2983,'AP','4405902740',0,'2013-12-25 20:17:15',NULL,NULL),(27194,17512,'AP','3304416466',0,'2014-01-13 03:01:30',NULL,NULL),(9423,6166,'TE','5137350188',0,'2013-12-26 00:16:57',NULL,NULL),(36751,24196,'AP','5135096642',0,'2014-02-16 19:00:16',NULL,NULL),(20969,13496,'TE','4403173566',0,'2013-12-26 13:02:29',NULL,NULL),(32266,21077,'AP','5135157379',0,'2014-02-02 19:00:20',NULL,NULL),(608,375,'AP','2147275782',0,'2013-12-25 17:45:33',NULL,NULL),(26668,17157,'AP','3372964125',0,'2014-01-13 02:22:00',NULL,NULL),(24380,15743,'TE','2144760354',0,'2014-01-03 02:00:54',NULL,NULL),(11833,7699,'EM','emoose1950@gmail.com',0,'2013-12-26 03:01:14',NULL,NULL),(8259,5402,'EM','Tom@spacepainter.com',0,'2013-12-25 23:08:59',NULL,NULL),(1068,657,'AP','9178039644',0,'2013-12-25 18:01:47',NULL,NULL),(4706,3009,'AP','3306201141',0,'2013-12-25 20:17:53',NULL,NULL),(33921,22264,'AP','9402375340',0,'2014-02-10 11:00:09',NULL,NULL),(35737,23504,'TE','9405976046',0,'2014-02-13 22:02:09',NULL,NULL),(43539,28905,'EM','conor@conormac.com',0,'2014-03-10 21:00:24',NULL,NULL),(6607,4268,'TE','5672041369',0,'2013-12-25 21:51:42',NULL,NULL),(30971,20146,'TE','6145654238',0,'2014-01-27 21:01:01',NULL,NULL),(29910,19355,'BN','2165542542',1,'2014-01-22 03:22:28',NULL,NULL),(25096,16180,'TE','2813438555',0,'2014-01-05 00:00:30',NULL,NULL),(27477,17700,'AP','8593965716',0,'2014-01-14 01:33:04',NULL,NULL),(34596,22685,'TE','9366466519',0,'2014-02-11 21:00:49',NULL,NULL),(36003,23684,'TE','8453802313',0,'2014-02-14 21:30:33',NULL,NULL),(38347,25331,'AP','3372307621',0,'2014-02-25 21:30:18',NULL,NULL),(39231,25951,'TE','6145723146',0,'2014-02-26 21:01:36',NULL,NULL),(41579,27645,'EM','girlsthreeboysone@yahoo.com',0,'2014-03-05 21:30:19',NULL,NULL),(206,126,'TE','2282184686',0,'2013-12-25 17:18:20',NULL,NULL),(14955,9783,'AP','7403141604',0,'2013-12-26 05:00:48',NULL,NULL),(8264,5409,'AP','9372181413',0,'2013-12-25 23:09:08',NULL,NULL),(7995,5218,'TE','5137711983',0,'2013-12-25 23:04:27',NULL,NULL),(37468,24675,'TE','4192317429',0,'2014-02-20 04:28:32',NULL,NULL),(21405,13762,'AP','2282977077',0,'2013-12-26 13:10:16',NULL,NULL),(21888,14102,'TE','2165712781',0,'2013-12-27 02:01:37',NULL,NULL),(33671,22086,'EM','geminii_dragon@hotmail.com',0,'2014-02-08 19:00:22',NULL,NULL),(24978,16097,'TE','4194911524',0,'2014-01-04 02:04:39',NULL,NULL),(31174,20302,'AP','8176290722',0,'2014-01-28 21:00:44',NULL,NULL),(28615,18445,'TE','9374183101',0,'2014-01-16 08:46:05',NULL,NULL),(8612,5659,'TE','3304980192',0,'2013-12-25 23:31:43',NULL,NULL),(20507,13203,'AP','2104524800',0,'2013-12-26 12:55:01',NULL,NULL),(38457,25412,'TE','5138289323',0,'2014-02-25 21:31:04',NULL,NULL),(14336,9373,'AP','3188344564',0,'2013-12-26 04:31:52',NULL,NULL),(9452,6186,'EM','robinson.moses@ymail.com',0,'2013-12-26 00:30:13',NULL,NULL),(33847,22219,'TE','3186281171',0,'2014-02-09 19:00:25',NULL,NULL),(24981,16100,'TE','5092027121',0,'2014-01-04 02:04:45',NULL,NULL),(29211,18870,'AP','9856285715',0,'2014-01-17 03:36:24',NULL,NULL),(28276,18232,'TE','8062022525',0,'2014-01-16 08:44:19',NULL,NULL),(1866,1151,'EM','gclondon1@gmail.com',0,'2013-12-25 18:18:38',NULL,NULL),(43471,28869,'EM','mlharris53@yahoo.com',0,'2014-03-10 21:00:01',NULL,NULL),(42046,27942,'AP','8302995648',0,'2014-03-06 21:00:33',NULL,NULL),(41486,27578,'AP','3302121415',0,'2014-03-04 21:30:24',NULL,NULL),(2677,1624,'EM','studiokalimba@gmail.com',0,'2013-12-25 18:52:41',NULL,NULL),(37744,24904,'TE','8067900857',0,'2014-02-20 21:30:03',NULL,NULL),(36089,23736,'AP','3303228889',0,'2014-02-14 21:31:01',NULL,NULL),(35550,23378,'TE','3305737953',0,'2014-02-13 22:00:57',NULL,NULL),(33072,21662,'TE','9859920471',0,'2014-02-05 21:30:55',NULL,NULL),(7340,4772,'TE','3306664212',0,'2013-12-25 22:15:51',NULL,NULL),(7046,4602,'AP','4197796133',0,'2013-12-25 22:05:45',NULL,NULL),(27330,17599,'TE','6018454177',0,'2014-01-14 01:32:15',NULL,NULL),(6685,4342,'TE','4192361740',0,'2013-12-25 21:53:18',NULL,NULL),(8423,5544,'EM','lshall42@gmail.com',0,'2013-12-25 23:15:56',NULL,NULL),(5219,3355,'TE','2406453464',0,'2013-12-25 21:16:50',NULL,NULL),(5497,3515,'EM','optictron@hotmail.com',0,'2013-12-25 21:21:07',NULL,NULL),(2230,1370,'TE','2542478521',0,'2013-12-25 18:45:45',NULL,NULL),(22275,14356,'AP','7404072871',0,'2013-12-28 03:30:10',NULL,NULL),(43543,28910,'TE','3305546885',0,'2014-03-10 21:00:26',NULL,NULL),(27999,18047,'AP','9014878772',0,'2014-01-15 02:07:15',NULL,NULL),(28694,18517,'EM','lenajim2003@yahoo.com',0,'2014-01-16 08:46:36',NULL,NULL),(30747,19977,'EM','staufferd@hotmail.com',0,'2014-01-25 19:00:14',NULL,NULL),(34591,22680,'TE','9035061624',0,'2014-02-11 21:00:47',NULL,NULL),(31484,20517,'AP','8064747727',0,'2014-01-29 21:01:22',NULL,NULL),(24932,16071,'TE','2162557100',0,'2014-01-04 02:03:49',NULL,NULL),(25838,16657,'EM','RMCONST1@BELLSOUTH.NET',0,'2014-01-08 18:24:23',NULL,NULL),(25612,16520,'TE','2542890072',1,'2014-01-07 10:21:40',NULL,NULL),(23729,15310,'AP','4695850082',1,'2014-01-02 04:23:12',NULL,NULL),(39367,26037,'TE','3306337710',0,'2014-02-26 21:02:25',NULL,NULL),(4472,2847,'EM','shamshaknoorani@aol.com',0,'2013-12-25 20:01:15',NULL,NULL),(38334,25325,'TE','2253615239',0,'2014-02-25 21:30:12',NULL,NULL),(24631,15884,'TE','3375505086',0,'2014-01-03 02:05:30',NULL,NULL),(37197,24483,'AP','5134440216',0,'2014-02-18 22:01:47',NULL,NULL),(34764,22797,'EM','Mswisher@amplex.net',0,'2014-02-11 21:01:52',NULL,NULL),(8311,5446,'EM','JIENNY2003@YAHOO.COM',0,'2013-12-25 23:10:04',NULL,NULL),(1316,803,'EM','AlexGSchwenke@gmail.com',0,'2013-12-25 18:05:37',NULL,NULL),(14598,9544,'AP','4404637879',0,'2013-12-26 04:36:06',NULL,NULL),(36927,24318,'AP','2816422348',0,'2014-02-18 22:00:07',NULL,NULL),(34993,22975,'TE','6149490064',0,'2014-02-12 21:30:05',NULL,NULL),(34939,22932,'TE','5132527432',0,'2014-02-11 21:30:11',NULL,NULL),(33545,21991,'EM','funkietom@gmail.com',0,'2014-02-07 19:00:42',NULL,NULL),(42735,28424,'TE','3305657809',0,'2014-03-07 21:31:05',NULL,NULL),(29962,19387,'EM','jonbsaul@gmail.com',1,'2014-01-22 03:22:46',NULL,NULL),(8065,5282,'TE','3308960226',0,'2013-12-25 23:05:47',NULL,NULL),(2207,1354,'EM','paulschroeder_001@msn.com',0,'2013-12-25 18:45:22',NULL,NULL),(28227,18200,'TE','4198895176',0,'2014-01-15 02:08:06',NULL,NULL),(12296,8042,'AP','4403206091',0,'2013-12-26 03:09:27',NULL,NULL),(2734,1658,'EM','hilliajf@gmail.com',0,'2013-12-25 18:53:33',NULL,NULL),(4171,2664,'EM','mcarnes74@yahoo.com',0,'2013-12-25 19:46:55',NULL,NULL),(43399,28822,'TE','4198742003',0,'2014-03-09 21:01:01',NULL,NULL),(214,129,'TE','6014421750',0,'2013-12-25 17:18:26',NULL,NULL),(7205,4693,'AP','9375458501',0,'2013-12-25 22:08:15',NULL,NULL),(35809,23547,'AP','3182184048',0,'2014-02-13 22:02:36',NULL,NULL),(12324,8058,'TE','6165700647',0,'2013-12-26 03:09:54',NULL,NULL),(26566,17089,'AP','3239193391',0,'2014-01-13 02:21:26',NULL,NULL),(30315,19639,'AP','3306122159',0,'2014-01-23 21:00:14',NULL,NULL),(9291,6086,'AP','3302040649',0,'2013-12-26 00:02:36',NULL,NULL),(42420,28172,'TE','4194666651',0,'2014-03-06 21:02:50',NULL,NULL),(42210,28042,'TE','6626075059',0,'2014-03-06 21:01:32',NULL,NULL),(39163,25904,'AP','2546240995',0,'2014-02-26 21:01:10',NULL,NULL),(35778,23529,'TE','9858174740',0,'2014-02-13 22:02:25',NULL,NULL),(34686,22746,'AP','5132550816',0,'2014-02-11 21:01:23',NULL,NULL),(21288,13679,'TE','3306505232',0,'2013-12-26 13:08:07',NULL,NULL),(12093,7904,'AP','5044308895',0,'2013-12-26 03:05:53',NULL,NULL),(5462,3498,'TE','4193567836',0,'2013-12-25 21:20:37',NULL,NULL),(3144,1962,'TE','8176816774',0,'2013-12-25 19:01:15',NULL,NULL),(24361,15731,'AP','5136791570',0,'2014-01-03 02:00:31',NULL,NULL),(24460,15788,'AP','9852272426',0,'2014-01-03 02:02:24',NULL,NULL),(43500,28884,'AP','5126353197',0,'2014-03-10 21:00:11',NULL,NULL),(12425,8137,'TE','9372987061',0,'2013-12-26 03:15:43',NULL,NULL),(25735,16586,'TE','5044447657',0,'2014-01-08 18:23:59',NULL,NULL),(35623,23424,'AP','9566396202',0,'2014-02-13 22:01:24',NULL,NULL),(39090,25863,'TE','2253945414',0,'2014-02-26 21:00:46',NULL,NULL),(6614,4274,'AP','9374031797',0,'2013-12-25 21:51:50',NULL,NULL),(38097,25146,'AP','3614636471',0,'2014-02-21 22:00:14',NULL,NULL),(3993,2537,'EM','terrimacleod@yahoo.com',0,'2013-12-25 19:36:56',NULL,NULL),(30456,19743,'AP','5134044660',0,'2014-01-23 21:01:13',NULL,NULL),(22939,14799,'TE','4403917830',1,'2013-12-29 11:13:43',NULL,NULL),(23228,14969,'AP','6202491524',0,'2014-01-01 12:00:44',NULL,NULL),(24500,15805,'EM','marthaepperson@gmail.com',0,'2014-01-03 02:03:01',NULL,NULL),(20896,13436,'AP','6507145966',0,'2013-12-26 13:01:11',NULL,NULL),(42408,28166,'TE','2252889807',0,'2014-03-06 21:02:45',NULL,NULL),(34020,22313,'AP','6629349928',0,'2014-02-10 11:00:47',NULL,NULL),(20603,13252,'TE','9567972899',0,'2013-12-26 12:56:26',NULL,NULL),(21683,13961,'AP','9376579994',0,'2013-12-26 13:15:08',NULL,NULL),(5059,3248,'TE','9377710001',0,'2013-12-25 20:46:33',NULL,NULL),(4106,2618,'EM','URPISSINMEOFF@AOL.COM',0,'2013-12-25 19:45:48',NULL,NULL),(11618,7556,'TE','3308073345',0,'2013-12-26 02:33:21',NULL,NULL),(10451,6809,'AP','3252775585',0,'2013-12-26 01:30:16',NULL,NULL),(22003,14172,'TE','4699390885',0,'2013-12-27 02:03:29',NULL,NULL),(42140,27995,'TE','7405226609',0,'2014-03-06 21:01:06',NULL,NULL),(25796,16624,'TE','9374349969',0,'2014-01-08 18:24:12',NULL,NULL),(38267,25267,'AP','6143525610',0,'2014-02-22 19:00:16',NULL,NULL),(37122,24438,'EM','CHRISCORNELIUS67@YAHOO.COM',0,'2014-02-18 22:01:17',NULL,NULL),(36869,24280,'AP','3306125560',0,'2014-02-18 21:30:07',NULL,NULL),(36540,24060,'TE','4193328883',0,'2014-02-15 22:01:08',NULL,NULL),(26544,17075,'TE','9158563009',0,'2014-01-13 02:21:19',NULL,NULL),(30138,19523,'TE','9372413749',0,'2014-01-23 03:02:19',NULL,NULL),(31334,20417,'EM','bjcolbow@yahoo.com',0,'2014-01-29 21:00:28',NULL,NULL),(31472,20509,'EM','marilyn_b727@yahoo.com',0,'2014-01-29 21:01:18',NULL,NULL),(11307,7369,'TE','3214439026',0,'2013-12-26 02:15:37',NULL,NULL),(25944,16713,'AP','8062682627',0,'2014-01-08 18:24:43',NULL,NULL),(24268,15683,'AP','4199057202',1,'2014-01-02 04:35:04',NULL,NULL),(41513,27600,'AP','3304661092',0,'2014-03-05 21:00:22',NULL,NULL),(40671,27002,'EM','bigdennyb@msn.com',0,'2014-03-03 21:00:03',NULL,NULL),(20848,13404,'AP','7405075221',0,'2013-12-26 13:00:24',NULL,NULL),(39081,25848,'EM','KFORGACS09@YAHOO.COM',0,'2014-02-26 21:00:39',NULL,NULL),(21056,13543,'AP','5042205135',0,'2013-12-26 13:03:51',NULL,NULL),(35271,23165,'TE','8322296484',0,'2014-02-12 21:31:49',NULL,NULL),(29781,19255,'EM','jimapollonio@gmail.com',0,'2014-01-21 08:46:46',NULL,NULL),(34704,22755,'EM','mege5454@gmail.com',0,'2014-02-11 21:01:29',NULL,NULL),(34212,22437,'AP','9033069535',0,'2014-02-10 21:30:40',NULL,NULL),(33098,21680,'AP','5133073829',0,'2014-02-05 21:31:02',NULL,NULL),(6847,4443,'TE','2166623231',0,'2013-12-25 22:02:10',NULL,NULL),(4285,2737,'EM','fraunfelter@yahoo.com',0,'2013-12-25 19:48:40',NULL,NULL),(4395,2799,'AP','3305595203',0,'2013-12-25 19:50:22',NULL,NULL),(37407,24635,'TE','9856624518',0,'2014-02-20 04:18:56',NULL,NULL),(35218,23131,'AP','2167023368',0,'2014-02-12 21:31:30',NULL,NULL),(20328,13097,'EM','bplusfilms@gmail.com',0,'2013-12-26 12:52:04',NULL,NULL),(650,405,'TE','2167696182',0,'2013-12-25 17:46:15',NULL,NULL),(20714,13315,'TE','8172792937',0,'2013-12-26 12:58:12',NULL,NULL),(43125,28668,'TE','5047108939',0,'2014-03-08 21:30:47',NULL,NULL),(21501,13818,'TE','3307545500',0,'2013-12-26 13:11:48',NULL,NULL),(330,207,'TE','2259217727',0,'2013-12-25 17:20:21',NULL,NULL),(43413,28829,'EM','natemail76@gmail.com',0,'2014-03-09 21:01:06',NULL,NULL),(43242,28733,'AP','2259933854',0,'2014-03-09 21:00:04',NULL,NULL),(41157,27335,'TE','4403877951',0,'2014-03-04 21:00:55',NULL,NULL),(38000,25067,'AP','5133004025',0,'2014-02-20 22:01:28',NULL,NULL),(36922,24316,'TE','8063411701',0,'2014-02-18 22:00:05',NULL,NULL),(29575,19110,'TE','3306370814',0,'2014-01-21 08:44:44',NULL,NULL),(28476,18352,'TE','4406556490',0,'2014-01-16 08:45:22',NULL,NULL),(27656,17828,'AP','2283269459',0,'2014-01-15 02:05:58',NULL,NULL),(10806,7020,'AP','3618274648',0,'2013-12-26 01:48:49',NULL,NULL),(22685,14630,'TE','9373996662',0,'2013-12-28 03:37:10',NULL,NULL),(5900,3785,'TE','9375649179',0,'2013-12-25 21:34:05',NULL,NULL),(9666,6329,'TE','6142662252',0,'2013-12-26 00:46:33',NULL,NULL),(901,559,'TE','9174767638',0,'2013-12-25 17:50:14',NULL,NULL),(3242,2041,'TE','9154437918',0,'2013-12-25 19:15:35',NULL,NULL),(20372,13122,'TE','4407300890',0,'2013-12-26 12:52:47',NULL,NULL),(39285,25992,'AP','6019412119',0,'2014-02-26 21:01:57',NULL,NULL),(38183,25202,'TE','6465297117',0,'2014-02-21 22:00:46',NULL,NULL),(35254,23154,'TE','5134467040',0,'2014-02-12 21:31:43',NULL,NULL),(5717,3668,'TE','7402821107',0,'2013-12-25 21:31:05',NULL,NULL),(5841,3747,'AP','5126381849',0,'2013-12-25 21:33:05',NULL,NULL),(22337,14404,'TE','3309841143',0,'2013-12-28 03:31:17',NULL,NULL),(29736,19228,'TE','5136319292',0,'2014-01-21 08:46:31',NULL,NULL),(23185,14942,'EM','mzaff@aol.com',0,'2013-12-30 00:02:21',NULL,NULL),(25304,16316,'EM','cadillac2003@yahoo.com',0,'2014-01-07 04:01:35',NULL,NULL),(28426,18315,'TE','2346785071',0,'2014-01-16 08:45:04',NULL,NULL),(26506,17055,'TE','9379262500',0,'2014-01-13 02:21:01',NULL,NULL),(43866,29108,'TE','3375199514',0,'2014-03-10 21:02:22',NULL,NULL),(44008,29202,'AP','9012395771',0,'2014-03-10 21:30:11',NULL,NULL),(1977,1222,'EM','gwendolynkundtz@att.net',0,'2013-12-25 18:20:27',NULL,NULL),(11808,7677,'EM','nturner40@att.net',0,'2013-12-26 03:00:46',NULL,NULL),(41718,27739,'EM','rocker22cute@yahoo.com',0,'2014-03-05 21:31:09',NULL,NULL),(8806,5768,'TE','2163382597',0,'2013-12-25 23:46:43',NULL,NULL),(5446,3487,'EM','pcarneyjr@yahoo.com',0,'2013-12-25 21:20:20',NULL,NULL),(38963,25761,'TE','3303768569',0,'2014-02-26 09:30:51',NULL,NULL),(37319,24558,'TE','2169904376',0,'2014-02-20 04:05:59',NULL,NULL),(22775,14683,'EM','jessquem73@gmail.com',1,'2013-12-29 11:08:39',NULL,NULL),(24770,15980,'AP','5127154378',0,'2014-01-04 02:00:54',NULL,NULL),(578,357,'TE','9372222482',0,'2013-12-25 17:45:03',NULL,NULL),(39860,26368,'TE','2166623960',0,'2014-02-28 07:00:10',NULL,NULL),(39159,25902,'TE','9568271728',0,'2014-02-26 21:01:09',NULL,NULL),(21522,13835,'EM','nanaonthgo@yahoo.com',0,'2013-12-26 13:12:11',NULL,NULL),(14624,9559,'AP','9377187431',0,'2013-12-26 04:36:31',NULL,NULL),(36305,23904,'TE','5676940940',0,'2014-02-14 21:32:26',NULL,NULL),(7928,5169,'TE','3305315361',0,'2013-12-25 23:03:15',NULL,NULL),(6834,4434,'EM','Mb4364@aol.com',0,'2013-12-25 22:01:58',NULL,NULL),(34897,22900,'AP','7852824836',0,'2014-02-11 21:02:41',NULL,NULL),(33729,22129,'AP','6146709552',0,'2014-02-08 19:00:43',NULL,NULL),(31577,20593,'BN','2166300212',0,'2014-01-30 21:00:10',NULL,NULL),(23596,15236,'TE','5136252584',0,'2014-01-01 12:08:27',NULL,NULL),(43859,29104,'BN','9547343642',0,'2014-03-10 21:02:19',NULL,NULL),(10231,6690,'TE','3176951146',0,'2013-12-26 01:01:33',NULL,NULL),(39694,26250,'TE','8302643446',0,'2014-02-28 06:31:08',NULL,NULL),(38495,25439,'TE','4322012046',0,'2014-02-25 21:31:19',NULL,NULL),(2142,1321,'TE','7147159078',0,'2013-12-25 18:31:44',NULL,NULL),(2783,1686,'TE','2252616090',0,'2013-12-25 18:54:19',NULL,NULL),(7091,4629,'AP','6014051529',0,'2013-12-25 22:06:29',NULL,NULL),(29061,18764,'EM','yeni329@gmail.com',0,'2014-01-17 03:35:48',NULL,NULL),(28872,18643,'TE','5125679389',0,'2014-01-17 03:35:07',NULL,NULL),(10757,6994,'AP','2144580480',0,'2013-12-26 01:48:05',NULL,NULL),(4714,3016,'AP','7405035545',0,'2013-12-25 20:18:03',NULL,NULL),(23484,15145,'EM','beckyzink@aol.com',0,'2014-01-01 12:05:52',NULL,NULL),(8525,5603,'TE','6143533893',0,'2013-12-25 23:30:19',NULL,NULL),(14716,9628,'TE','3308671625',0,'2013-12-26 04:38:07',NULL,NULL),(1975,1220,'EM','urpissinmeoff@aol.com',0,'2013-12-25 18:20:24',NULL,NULL),(36402,23973,'EM','NEILLWICKER@JUNO.COM',0,'2014-02-15 22:00:16',NULL,NULL),(22449,14476,'AP','5128282675',0,'2013-12-28 03:33:10',NULL,NULL),(27068,17409,'AP','5126530714',0,'2014-01-13 03:00:21',NULL,NULL),(29140,18824,'EM','brendawilson946@yahoo.com',0,'2014-01-17 03:36:07',NULL,NULL),(42871,28510,'AP','3306712007',0,'2014-03-07 21:31:54',NULL,NULL),(31737,20712,'AP','5042285576',0,'2014-01-30 21:01:09',NULL,NULL),(31681,20667,'AP','7692187334',0,'2014-01-30 21:00:47',NULL,NULL),(30262,19607,'TE','4409741597',0,'2014-01-23 03:02:49',NULL,NULL),(24113,15566,'AP','3305244993',1,'2014-01-02 04:31:45',NULL,NULL),(6924,4511,'TE','8172967832',0,'2013-12-25 22:03:36',NULL,NULL),(9184,6013,'AP','8598149354',0,'2013-12-26 00:00:39',NULL,NULL),(36685,24154,'TE','4197532163',0,'2014-02-15 22:01:59',NULL,NULL),(5455,3492,'TE','6144303338',0,'2013-12-25 21:20:29',NULL,NULL),(4819,3086,'TE','5136009701',0,'2013-12-25 20:19:51',NULL,NULL),(3375,2122,'TE','6143854795',0,'2013-12-25 19:17:45',NULL,NULL),(22509,14512,'AP','6124818452',0,'2013-12-28 03:34:05',NULL,NULL),(40876,27160,'TE','8066202740',0,'2014-03-03 21:30:59',NULL,NULL),(40581,26933,'AP','9374077861',0,'2014-03-03 01:00:21',NULL,NULL),(40158,26634,'AP','8179954871',0,'2014-02-28 21:30:59',NULL,NULL),(21986,14162,'EM','tonybjacobs74@hotmail.com',0,'2013-12-27 02:03:12',NULL,NULL),(37344,24587,'TE','5133799521',0,'2014-02-20 04:09:52',NULL,NULL),(14757,9651,'AP','4192040926',0,'2013-12-26 04:38:47',NULL,NULL),(11055,7178,'AP','9376722738',0,'2013-12-26 02:00:08',NULL,NULL),(13882,9054,'TE','2813515500',0,'2013-12-26 04:06:07',NULL,NULL),(34159,22397,'EM','gkaye1209@sbcglobal.net',0,'2014-02-10 21:30:19',NULL,NULL),(25231,16268,'EM','VSPOOKEY@AOL.COM',0,'2014-01-07 04:00:13',NULL,NULL),(31148,20287,'TE','9852624508',0,'2014-01-28 21:00:33',NULL,NULL),(28553,18410,'EM','Krazy1ne@gmail.com',0,'2014-01-16 08:45:47',NULL,NULL),(645,401,'TE','7403421104',0,'2013-12-25 17:46:10',NULL,NULL),(12060,7874,'TE','3306682468',0,'2013-12-26 03:05:15',NULL,NULL),(39899,26404,'AP','4193029638',0,'2014-02-28 07:00:33',NULL,NULL),(38234,25240,'TE','4193003080',0,'2014-02-21 22:01:08',NULL,NULL),(37511,24702,'AP','5132655186',0,'2014-02-20 04:34:40',NULL,NULL),(36994,24357,'TE','3372588639',0,'2014-02-18 22:00:30',NULL,NULL),(4933,3165,'EM','mchale_taylor@msn.com',0,'2013-12-25 20:31:27',NULL,NULL),(33897,22250,'TE','2162996205',0,'2014-02-09 19:00:42',NULL,NULL),(20232,13033,'AP','2168326586',0,'2013-12-26 12:50:24',NULL,NULL),(29530,19088,'EM','pburley@columbus.rr.com',0,'2014-01-21 08:44:30',NULL,NULL),(22750,14671,'AP','9033600702',1,'2013-12-29 11:08:16',NULL,NULL),(24074,15542,'AP','3185628825',1,'2014-01-02 04:31:00',NULL,NULL),(6087,3918,'EM','barbarac51@verizon.net',0,'2013-12-25 21:37:18',NULL,NULL),(9803,6414,'AP','5132565258',0,'2013-12-26 00:48:42',NULL,NULL),(10897,7080,'AP','7408512275',0,'2013-12-26 01:50:17',NULL,NULL),(24480,15796,'AP','9858470999',0,'2014-01-03 02:02:42',NULL,NULL),(34364,22539,'EM','Danvytruong@yahoo.com',0,'2014-02-10 21:31:38',NULL,NULL),(35852,23574,'TE','4198253778',0,'2014-02-13 22:02:53',NULL,NULL),(319,199,'TE','9374394667',0,'2013-12-25 17:20:08',NULL,NULL),(20304,13086,'EM','FANTICOST@GMAIL.COM',0,'2013-12-26 12:51:44',NULL,NULL),(33283,21795,'TE','3308299588',0,'2014-02-06 21:00:46',NULL,NULL),(31300,20394,'EM','rosespice@gmail.com',0,'2014-01-29 21:00:17',NULL,NULL),(612,377,'EM','dlondoff@aol.com',0,'2013-12-25 17:45:37',NULL,NULL),(12334,8068,'TE','3307044711',0,'2013-12-26 03:10:08',NULL,NULL),(4225,2703,'EM','leahisrawson@gmail.com',0,'2013-12-25 19:47:46',NULL,NULL),(11720,7630,'TE','5139399386',0,'2013-12-26 02:46:13',NULL,NULL),(4713,3016,'TE','7405035545',0,'2013-12-25 20:18:03',NULL,NULL),(37881,24988,'AP','8328775070',0,'2014-02-20 22:00:39',NULL,NULL),(21837,14068,'TE','2162889175',0,'2013-12-27 02:00:46',NULL,NULL),(29681,19181,'TE','9152749612',0,'2014-01-21 08:46:08',NULL,NULL),(26976,17349,'EM','NURSETSA@AOL.COM',0,'2014-01-13 02:24:08',NULL,NULL),(23117,14903,'TE','4402630483',0,'2013-12-30 00:01:12',NULL,NULL),(43601,28947,'AP','9855174336',0,'2014-03-10 21:00:47',NULL,NULL),(3162,1978,'TE','8176816774',0,'2013-12-25 19:01:39',NULL,NULL),(3769,2390,'EM','gillenwater2280@yahoo.com',0,'2013-12-25 19:33:16',NULL,NULL),(26771,17223,'TE','4198654979',0,'2014-01-13 02:22:35',NULL,NULL),(28974,18700,'BN','3183310077',0,'2014-01-17 03:35:28',NULL,NULL),(29609,19131,'AP','9852869076',0,'2014-01-21 08:45:23',NULL,NULL),(42801,28463,'TE','3306711655',0,'2014-03-07 21:31:27',NULL,NULL),(8266,5413,'TE','5133754425',0,'2013-12-25 23:09:11',NULL,NULL),(40132,26618,'AP','4086368780',0,'2014-02-28 21:30:50',NULL,NULL),(3704,2350,'AP','2148866342',0,'2013-12-25 19:32:12',NULL,NULL),(11903,7743,'AP','5133733544',0,'2013-12-26 03:02:21',NULL,NULL),(32836,21487,'TE','3302647841',0,'2014-02-04 21:01:46',NULL,NULL),(32736,21417,'TE','4195143981',0,'2014-02-04 21:01:11',NULL,NULL),(28221,18194,'TE','3308140379',0,'2014-01-15 02:08:05',NULL,NULL),(25518,16454,'EM','chefstan@bex.net',0,'2014-01-07 04:05:32',NULL,NULL),(24972,16093,'AP','2282166206',0,'2014-01-04 02:04:31',NULL,NULL),(5838,3746,'TE','7139880127',0,'2013-12-25 21:33:03',NULL,NULL),(3411,2143,'TE','6018077777',0,'2013-12-25 19:18:19',NULL,NULL),(42651,28372,'AP','5132271358',0,'2014-03-07 21:30:35',NULL,NULL),(5675,3645,'EM','rlanderson1954@gmail.com',0,'2013-12-25 21:30:29',NULL,NULL),(40991,27235,'TE','6017380766',0,'2014-03-03 21:31:44',NULL,NULL),(39492,26121,'TE','3306012835',0,'2014-02-28 06:30:19',NULL,NULL),(38571,25493,'TE','6622740781',0,'2014-02-25 21:31:49',NULL,NULL),(12153,7939,'AP','9176284761',0,'2013-12-26 03:06:50',NULL,NULL),(2390,1456,'TE','4405390392',0,'2013-12-25 18:48:12',NULL,NULL),(30666,19914,'TE','9729041696',0,'2014-01-24 21:01:01',NULL,NULL),(9309,6096,'AP','3375504275',0,'2013-12-26 00:15:04',NULL,NULL),(5061,3248,'EM','lhcagents@gmail.com',0,'2013-12-25 20:46:34',NULL,NULL),(21865,14084,'EM','rarcher53@frontier.com',0,'2013-12-27 02:01:12',NULL,NULL),(42319,28102,'AP','4405910380',0,'2014-03-06 21:02:11',NULL,NULL),(28857,18635,'EM','s_gonzales_e@yahoo.com',0,'2014-01-17 03:35:04',NULL,NULL),(30034,19453,'AP','7405037130',0,'2014-01-23 03:01:53',NULL,NULL),(30197,19563,'TE','3187302646',0,'2014-01-23 03:02:34',NULL,NULL),(1679,1031,'EM','saldana416@sbcglobal.net',0,'2013-12-25 18:15:31',NULL,NULL),(36737,24187,'TE','8174372827',0,'2014-02-16 19:00:11',NULL,NULL),(34818,22837,'EM','drichmond4@att.net',0,'2014-02-11 21:02:11',NULL,NULL),(34634,22708,'EM','Kevinmccann@cox.net',0,'2014-02-11 21:01:03',NULL,NULL),(20251,13046,'TE','5134607240',0,'2013-12-26 12:50:45',NULL,NULL),(22092,14230,'TE','9154911841',0,'2013-12-27 02:04:58',NULL,NULL),(43497,28883,'TE','2546330885',0,'2014-03-10 21:00:10',NULL,NULL),(8215,5378,'TE','5044840452',0,'2013-12-25 23:08:17',NULL,NULL),(28120,18126,'TE','3302649051',0,'2014-01-15 02:07:42',NULL,NULL),(26163,16846,'TE','3305405914',0,'2014-01-13 02:18:36',NULL,NULL),(25583,16502,'AP','4196041782',0,'2014-01-07 04:06:53',NULL,NULL),(25435,16402,'AP','8066780244',0,'2014-01-07 04:03:56',NULL,NULL),(25205,16254,'TE','5138951577',0,'2014-01-05 00:02:41',NULL,NULL),(13943,9092,'TE','7404394527',0,'2013-12-26 04:07:08',NULL,NULL),(22340,14405,'TE','3309841143',0,'2013-12-28 03:31:18',NULL,NULL),(22085,14227,'EM','kilgoresam2@aol.com',0,'2013-12-27 02:04:52',NULL,NULL),(11245,7319,'AP','2283264509',0,'2013-12-26 02:03:35',NULL,NULL),(5498,3516,'TE','2282238943',0,'2013-12-25 21:21:09',NULL,NULL),(8132,5324,'AP','5133280648',0,'2013-12-25 23:06:55',NULL,NULL),(9815,6421,'AP','9858595542',0,'2013-12-26 00:48:55',NULL,NULL),(3316,2087,'TE','2253565522',0,'2013-12-25 19:16:46',NULL,NULL),(194,115,'TE','8177186201',0,'2013-12-25 17:18:05',NULL,NULL),(40593,26947,'TE','9374225687',0,'2014-03-03 01:00:25',NULL,NULL),(21249,13656,'AP','2252053433',0,'2013-12-26 13:07:29',NULL,NULL),(2727,1655,'TE','8176584491',0,'2013-12-25 18:53:28',NULL,NULL),(9181,6008,'EM','emilyyrose@gmail.com',0,'2013-12-26 00:00:34',NULL,NULL),(21920,14122,'AP','6149622862',0,'2013-12-27 02:02:08',NULL,NULL),(23431,15098,'TE','7406547085',0,'2014-01-01 12:04:37',NULL,NULL),(28065,18089,'AP','5043205607',0,'2014-01-15 02:07:29',NULL,NULL),(3043,1893,'AP','4193056459',0,'2013-12-25 18:58:55',NULL,NULL),(11321,7375,'EM','pbagadion@zoomtown.com',0,'2013-12-26 02:15:47',NULL,NULL),(35539,23371,'EM','jodibricker@insight.rr.com',0,'2014-02-13 22:00:54',NULL,NULL),(22545,14537,'EM','janesmiller55@gmail.com',0,'2013-12-28 03:34:43',NULL,NULL),(31631,20633,'AP','8327152953',0,'2014-01-30 21:00:30',NULL,NULL),(28413,18307,'TE','2163762795',0,'2014-01-16 08:45:00',NULL,NULL),(24508,15810,'TE','5049204680',0,'2014-01-03 02:03:10',NULL,NULL),(6750,4381,'EM','dkipker@yahoo.com',0,'2013-12-25 22:00:38',NULL,NULL),(2870,1755,'TE','9373285789',0,'2013-12-25 18:55:49',NULL,NULL),(41955,27889,'AP','4196779948',0,'2014-03-05 21:32:38',NULL,NULL),(2342,1425,'AP','3375228023',0,'2013-12-25 18:47:23',NULL,NULL),(40334,26768,'AP','3306960612',0,'2014-03-01 19:00:13',NULL,NULL),(11320,7375,'AP','5132842149',0,'2013-12-26 02:15:47',NULL,NULL),(36705,24165,'EM','skeedog@sbcglobal.net',0,'2014-02-15 22:02:06',NULL,NULL),(20226,13028,'EM','shaynes983@yahoo.com',0,'2013-12-26 12:50:17',NULL,NULL),(5855,3757,'EM','kordann@yahoo.com',0,'2013-12-25 21:33:20',NULL,NULL),(26198,16862,'AP','8705577123',0,'2014-01-13 02:19:11',NULL,NULL),(34375,22548,'AP','9852273915',0,'2014-02-10 21:31:43',NULL,NULL),(24058,15533,'EM','Kitcarleton@yahoo.com',1,'2014-01-02 04:30:42',NULL,NULL),(42217,28047,'TE','5103239578',0,'2014-03-06 21:01:35',NULL,NULL),(23539,15192,'TE','7657175461',0,'2014-01-01 12:07:08',NULL,NULL),(40273,26716,'TE','6015730910',0,'2014-02-28 21:31:41',NULL,NULL),(39791,26308,'AP','3614740637',0,'2014-02-28 06:31:32',NULL,NULL),(39240,25958,'TE','5139212260',0,'2014-02-26 21:01:40',NULL,NULL),(12069,7878,'EM','ebl@cinci.rr.com',0,'2013-12-26 03:05:22',NULL,NULL),(27566,17767,'TE','8322983265',0,'2014-01-14 01:33:36',NULL,NULL),(28069,18091,'AP','3182674046',0,'2014-01-15 02:07:30',NULL,NULL),(33645,22063,'TE','9792333272',0,'2014-02-08 19:00:11',NULL,NULL),(31686,20670,'AP','6623920638',0,'2014-01-30 21:00:49',NULL,NULL),(33235,21763,'AP','5127554624',0,'2014-02-06 21:00:28',NULL,NULL),(2631,1601,'AP','9567922754',0,'2013-12-25 18:52:03',NULL,NULL),(39125,25879,'AP','3373972293',0,'2014-02-26 21:00:56',NULL,NULL),(4547,2891,'EM','lmswoody@hotmail.com',0,'2013-12-25 20:15:11',NULL,NULL),(43094,28649,'TE','6628125497',0,'2014-03-08 21:30:36',NULL,NULL),(22179,14288,'TE','3304313636',0,'2013-12-27 02:06:30',NULL,NULL),(23876,15407,'TE','3258298165',1,'2014-01-02 04:26:59',NULL,NULL),(27682,17844,'TE','6145779613',0,'2014-01-15 02:06:04',NULL,NULL),(33818,22204,'EM','yjlindberg@gmail.com',0,'2014-02-09 19:00:16',NULL,NULL),(11348,7391,'EM','daycompton22@outlook.com',0,'2013-12-26 02:16:11',NULL,NULL),(5737,3677,'TE','6146576608',0,'2013-12-25 21:31:22',NULL,NULL),(39136,25885,'TE','2543340328',0,'2014-02-26 21:01:00',NULL,NULL),(34431,22588,'TE','4198606105',0,'2014-02-10 21:32:07',NULL,NULL),(33474,21929,'TE','9158558866',0,'2014-02-07 19:00:10',NULL,NULL),(43958,29162,'TE','9372155416',0,'2014-03-10 21:02:54',NULL,NULL),(10501,6840,'TE','3189968294',0,'2013-12-26 01:31:04',NULL,NULL),(42275,28074,'EM','lisa.gavin.ross@gmail.com',0,'2014-03-06 21:01:53',NULL,NULL),(41679,27714,'TE','2814890250',0,'2014-03-05 21:30:55',NULL,NULL),(33901,22252,'EM','Stiltnt@bgsu.edu',0,'2014-02-09 19:00:43',NULL,NULL),(31792,20750,'AP','3022569548',0,'2014-01-30 21:01:30',NULL,NULL),(1896,1169,'AP','3186173178',0,'2013-12-25 18:19:06',NULL,NULL),(14823,9704,'AP','4194943973',0,'2013-12-26 04:40:03',NULL,NULL),(8284,5430,'TE','2254546457',0,'2013-12-25 23:09:37',NULL,NULL),(29411,19013,'EM','tajshackelford@gmail.com',0,'2014-01-20 08:06:21',NULL,NULL),(35721,23493,'TE','5136044829',0,'2014-02-13 22:02:03',NULL,NULL),(36661,24134,'EM','pjones@lagoscentral.com',0,'2014-02-15 22:01:49',NULL,NULL),(20944,13470,'TE','5138500350',0,'2013-12-26 13:02:01',NULL,NULL),(25183,16238,'EM','cwilkins81@gmail.com',0,'2014-01-05 00:02:17',NULL,NULL),(40106,26597,'TE','5127888598',0,'2014-02-28 21:30:39',NULL,NULL),(35134,23074,'AP','3185759114',0,'2014-02-12 21:30:59',NULL,NULL),(33204,21743,'AP','9154229282',0,'2014-02-06 21:00:16',NULL,NULL),(33004,21616,'EM','nick8738@gmail.com',0,'2014-02-05 21:30:36',NULL,NULL),(30169,19547,'TE','6627018310',0,'2014-01-23 03:02:27',NULL,NULL),(30041,19457,'TE','2147700487',0,'2014-01-23 03:01:55',NULL,NULL),(29857,19316,'EM','angelcarrazco1950@yahoo.com',1,'2014-01-22 03:22:09',NULL,NULL),(20413,13144,'EM','msmi31@amfam.com',0,'2013-12-26 12:53:25',NULL,NULL),(7197,4688,'AP','5135087200',0,'2013-12-25 22:08:07',NULL,NULL),(38655,25547,'AP','2147349899',0,'2014-02-26 08:00:15',NULL,NULL),(30139,19523,'AP','9372413749',0,'2014-01-23 03:02:19',NULL,NULL),(31119,20265,'TE','3307853598',0,'2014-01-28 21:00:20',NULL,NULL),(35009,22985,'EM','tsanata@yahoo.com',0,'2014-02-12 21:30:11',NULL,NULL),(34722,22767,'TE','5133306678',0,'2014-02-11 21:01:36',NULL,NULL),(31466,20506,'EM','jennifer@sanserve.net',0,'2014-01-29 21:01:16',NULL,NULL),(29386,18992,'TE','3306184395',0,'2014-01-20 08:06:11',NULL,NULL),(43493,28881,'TE','2814910282',0,'2014-03-10 21:00:09',NULL,NULL),(36731,24184,'EM','chellecole84@gmail.com',0,'2014-02-16 19:00:09',NULL,NULL),(38009,25075,'AP','6014153189',0,'2014-02-20 22:01:33',NULL,NULL),(9712,6358,'TE','9377701502',0,'2013-12-26 00:47:16',NULL,NULL),(43080,28640,'TE','9569704802',0,'2014-03-08 21:30:32',NULL,NULL),(36665,24137,'EM','shed_builder1@yahoo.com',0,'2014-02-15 22:01:51',NULL,NULL),(3864,2458,'TE','9722900958',0,'2013-12-25 19:34:51',NULL,NULL),(2945,1815,'EM','hingychan@outlook.com',0,'2013-12-25 18:57:05',NULL,NULL),(29527,19085,'TE','4192770038',0,'2014-01-21 08:44:29',NULL,NULL),(5390,3450,'TE','4405069319',0,'2013-12-25 21:19:29',NULL,NULL),(7621,4966,'TE','8326469831',0,'2013-12-25 22:46:18',NULL,NULL),(5415,3467,'AP','2162554306',0,'2013-12-25 21:19:51',NULL,NULL),(5932,3803,'TE','4197065163',0,'2013-12-25 21:34:35',NULL,NULL),(5727,3673,'EM','d.slifka@roadrunner.com',0,'2013-12-25 21:31:14',NULL,NULL),(30858,20057,'EM','layneluther@yahoo.com',0,'2014-01-27 21:00:09',NULL,NULL),(26109,16812,'EM','Miguel78537@live.com',0,'2014-01-13 02:18:17',NULL,NULL),(25262,16287,'EM','bentley.christy21@gmail.com',0,'2014-01-07 04:00:44',NULL,NULL),(21880,14097,'AP','6147836683',0,'2013-12-27 02:01:29',NULL,NULL),(23566,15213,'TE','9374561122',0,'2014-01-01 12:07:46',NULL,NULL),(13554,8839,'TE','3613181058',0,'2013-12-26 04:00:42',NULL,NULL),(42820,28478,'TE','5708777846',0,'2014-03-07 21:31:35',NULL,NULL),(42610,28348,'TE','9724964575',0,'2014-03-07 21:30:21',NULL,NULL),(41316,27447,'AP','3306735819',0,'2014-03-04 21:01:57',NULL,NULL),(39406,26056,'AP','4199215158',0,'2014-02-26 21:02:37',NULL,NULL),(8203,5370,'TE','5132450533',0,'2013-12-25 23:08:04',NULL,NULL),(36826,24253,'EM','larissak535@yahoo.com',0,'2014-02-17 19:00:05',NULL,NULL),(21324,13701,'EM','estyle1@aol.com',0,'2013-12-26 13:08:41',NULL,NULL),(31862,20800,'TE','9036011203',0,'2014-01-31 21:00:21',NULL,NULL),(23495,15151,'AP','4407248070',0,'2014-01-01 12:06:04',NULL,NULL),(4180,2670,'TE','4402376290',0,'2013-12-25 19:47:02',NULL,NULL),(23293,15008,'AP','3306084463',0,'2014-01-01 12:01:58',NULL,NULL),(34253,22468,'EM','todderrick@yahoo.com',0,'2014-02-10 21:30:57',NULL,NULL),(33824,22208,'AP','2707913064',0,'2014-02-09 19:00:18',NULL,NULL),(30137,19521,'AP','6146222709',0,'2014-01-23 03:02:18',NULL,NULL),(30670,19916,'AP','9729041696',0,'2014-01-24 21:01:02',NULL,NULL),(36322,23923,'TE','2259211786',0,'2014-02-14 22:00:07',NULL,NULL),(36980,24347,'TE','9155493478',0,'2014-02-18 22:00:24',NULL,NULL),(37447,24654,'AP','4196809902',0,'2014-02-20 04:24:04',NULL,NULL),(38218,25226,'TE','4408137608',0,'2014-02-21 22:00:59',NULL,NULL),(10653,6926,'AP','5138844449',0,'2013-12-26 01:46:22',NULL,NULL),(9991,6538,'TE','2073129012',0,'2013-12-26 00:51:51',NULL,NULL),(11176,7268,'AP','2543173374',0,'2013-12-26 02:02:21',NULL,NULL),(28032,18065,'EM','fgeo_98@yahoo.com',0,'2014-01-15 02:07:22',NULL,NULL),(11360,7400,'TE','4195786065',0,'2013-12-26 02:16:24',NULL,NULL),(24054,15531,'AP','5043128760',1,'2014-01-02 04:30:38',NULL,NULL),(21095,13565,'TE','3182141345',0,'2013-12-26 13:04:28',NULL,NULL),(14180,9276,'TE','9373075491',0,'2013-12-26 04:15:49',NULL,NULL),(6973,4545,'EM','dhoefler60@aol.com',0,'2013-12-25 22:04:26',NULL,NULL),(42875,28513,'AP','3305024898',0,'2014-03-07 21:31:56',NULL,NULL),(42950,28560,'AP','4196896890',0,'2014-03-07 21:32:25',NULL,NULL),(44011,29206,'EM','vlmoore@bex.net',0,'2014-03-10 21:30:13',NULL,NULL),(24220,15648,'TE','6014671290',1,'2014-01-02 04:34:01',NULL,NULL),(25753,16596,'TE','3373498174',0,'2014-01-08 18:24:02',NULL,NULL),(8482,5580,'TE','8173261415',0,'2013-12-25 23:16:56',NULL,NULL),(8137,5326,'AP','5133744742',0,'2013-12-25 23:06:59',NULL,NULL),(6618,4276,'TE','5137246254',0,'2013-12-25 21:51:53',NULL,NULL),(13781,8981,'AP','6149612324',0,'2013-12-26 04:04:21',NULL,NULL),(3560,2228,'TE','4197328871',0,'2013-12-25 19:20:44',NULL,NULL),(1631,1001,'TE','6019189868',0,'2013-12-25 18:10:58',NULL,NULL),(4537,2884,'TE','6145229260',0,'2013-12-25 20:02:20',NULL,NULL),(8107,5307,'TE','6628098897',0,'2013-12-25 23:06:28',NULL,NULL),(7585,4937,'TE','4405760180',0,'2013-12-25 22:45:36',NULL,NULL),(31489,20520,'TE','2812772690',0,'2014-01-29 21:01:24',NULL,NULL),(3811,2426,'EM','pjw2005yes@yahoo.com',0,'2013-12-25 19:34:02',NULL,NULL),(3617,2287,'TE','3305322813',0,'2013-12-25 19:30:41',NULL,NULL),(27218,17525,'TE','6145000699',0,'2014-01-13 03:01:39',NULL,NULL),(6325,4077,'EM','mystro965@aol.com',0,'2013-12-25 21:47:06',NULL,NULL),(36081,23733,'TE','2162950015',0,'2014-02-14 21:30:59',NULL,NULL),(41929,27876,'TE','4197837157',0,'2014-03-05 21:32:29',NULL,NULL),(42310,28094,'TE','6018664303',0,'2014-03-06 21:02:06',NULL,NULL),(43625,28959,'TE','2252268177',0,'2014-03-10 21:00:55',NULL,NULL),(576,356,'TE','2282171378',0,'2013-12-25 17:32:27',NULL,NULL),(4211,2690,'EM','clkerr75@yahoo.com',0,'2013-12-25 19:47:30',NULL,NULL),(28508,18375,'TE','7408167272',0,'2014-01-16 08:45:32',NULL,NULL),(28203,18178,'AP','4196779109',0,'2014-01-15 02:08:00',NULL,NULL),(1377,840,'TE','9376549005',0,'2013-12-25 18:06:36',NULL,NULL),(1656,1016,'TE','6012703270',0,'2013-12-25 18:15:08',NULL,NULL),(7162,4671,'TE','3377895545',0,'2013-12-25 22:07:37',NULL,NULL),(23898,15417,'TE','9365813224',1,'2014-01-02 04:27:21',NULL,NULL),(36617,24108,'TE','9563071941',0,'2014-02-15 22:01:35',NULL,NULL),(38766,25631,'AP','7404248439',0,'2014-02-26 08:30:23',NULL,NULL),(39053,25827,'AP','5135153320',0,'2014-02-26 21:00:29',NULL,NULL),(40610,26958,'TE','3303297070',0,'2014-03-03 01:00:29',NULL,NULL),(8225,5384,'AP','5048137169',0,'2013-12-25 23:08:27',NULL,NULL),(34696,22752,'AP','3184169118',0,'2014-02-11 21:01:26',NULL,NULL),(9931,6500,'TE','4405061107',0,'2013-12-26 00:50:49',NULL,NULL),(10913,7091,'EM','lopezr001@aol.com',0,'2013-12-26 01:50:33',NULL,NULL),(27726,17871,'AP','9378966150',0,'2014-01-15 02:06:14',NULL,NULL),(29131,18818,'TE','5135127011',0,'2014-01-17 03:36:05',NULL,NULL),(2438,1495,'TE','9373698579',0,'2013-12-25 18:49:08',NULL,NULL),(6878,4462,'EM','bmitchell906@yahoo.com',0,'2013-12-25 22:02:39',NULL,NULL),(11144,7246,'TE','9858630016',0,'2013-12-26 02:01:48',NULL,NULL),(39737,26281,'AP','9852329861',0,'2014-02-28 06:31:20',NULL,NULL),(11333,7381,'TE','5132534286',0,'2013-12-26 02:15:57',NULL,NULL),(35628,23426,'AP','4326147331',0,'2014-02-13 22:01:25',NULL,NULL),(27320,17595,'TE','2285478735',0,'2014-01-14 01:32:12',NULL,NULL),(21581,13880,'TE','4403560586',0,'2013-12-26 13:13:17',NULL,NULL),(6377,4107,'TE','8324911630',0,'2013-12-25 21:47:54',NULL,NULL),(20399,13137,'EM','couchc11@aol.com',0,'2013-12-26 12:53:13',NULL,NULL),(34739,22778,'BN','7142648337',0,'2014-02-11 21:01:42',NULL,NULL),(26671,17159,'AP','9857882070',0,'2014-01-13 02:22:01',NULL,NULL),(1660,1020,'TE','6628580380',0,'2013-12-25 18:15:13',NULL,NULL),(5956,3822,'EM','paradise_lost_51@msn.com',0,'2013-12-25 21:34:59',NULL,NULL),(24995,16109,'EM','TMTBATTL@AOL.COM',0,'2014-01-04 02:05:02',NULL,NULL),(24313,15705,'EM','marinbodyworker@yahoo.com',1,'2014-01-02 04:35:53',NULL,NULL),(23025,14851,'AP','3307141148',1,'2013-12-29 11:15:07',NULL,NULL),(22321,14389,'TE','5132135471',0,'2013-12-28 03:30:58',NULL,NULL),(41001,27241,'BN','5133005394',0,'2014-03-03 21:31:47',NULL,NULL),(2332,1421,'TE','4697139521',0,'2013-12-25 18:47:15',NULL,NULL),(35422,23286,'EM','sonanixon@gmail.com',0,'2014-02-13 22:00:04',NULL,NULL),(21129,13586,'AP','9857746525',0,'2013-12-26 13:05:02',NULL,NULL),(32620,21328,'TE','2165772052',0,'2014-02-04 21:00:26',NULL,NULL),(31345,20424,'AP','3046338011',0,'2014-01-29 21:00:32',NULL,NULL),(31329,20416,'TE','5133063730',0,'2014-01-29 21:00:28',NULL,NULL),(9859,6446,'TE','4195759110',0,'2013-12-26 00:49:35',NULL,NULL),(29094,18790,'TE','9374166462',0,'2014-01-17 03:35:56',NULL,NULL),(9609,6289,'AP','2164409000',0,'2013-12-26 00:45:36',NULL,NULL),(3611,2280,'EM','ames.deborah@gmail.com',0,'2013-12-25 19:30:33',NULL,NULL),(9039,5931,'EM','dg3291@yahoo.com',0,'2013-12-25 23:50:30',NULL,NULL),(36893,24298,'AP','4695441911',0,'2014-02-18 21:30:18',NULL,NULL),(39172,25911,'TE','2548653262',0,'2014-02-26 21:01:14',NULL,NULL),(42277,28077,'AP','7739549636',0,'2014-03-06 21:01:55',NULL,NULL),(4539,2885,'TE','3308779439',0,'2013-12-25 20:15:04',NULL,NULL),(8952,5860,'TE','4193354363',0,'2013-12-25 23:49:01',NULL,NULL),(34001,22301,'AP','3303090862',0,'2014-02-10 11:00:38',NULL,NULL),(2776,1682,'TE','3186176244',0,'2013-12-25 18:54:12',NULL,NULL),(32020,20902,'AP','6143780992',0,'2014-01-31 21:01:22',NULL,NULL),(22110,14241,'AP','6013766872',0,'2013-12-27 02:05:15',NULL,NULL),(28853,18634,'AP','3252607377',0,'2014-01-17 03:35:03',NULL,NULL),(29474,19053,'TE','3305151051',0,'2014-01-20 08:06:46',NULL,NULL),(37581,24756,'AP','7405027990',0,'2014-02-20 04:42:24',NULL,NULL),(39356,26030,'AP','6019278318',0,'2014-02-26 21:02:21',NULL,NULL),(43209,28714,'TE','4193025688',0,'2014-03-08 21:31:16',NULL,NULL),(24698,15931,'TE','5674016037',0,'2014-01-03 02:06:55',NULL,NULL),(31604,20614,'EM','danyell_dsexy1@yahoo.com',0,'2014-01-30 21:00:20',NULL,NULL),(38345,25330,'AP','2256505107',0,'2014-02-25 21:30:17',NULL,NULL),(38788,25644,'AP','3302210493',0,'2014-02-26 08:30:33',NULL,NULL),(1685,1036,'TE','9152527049',0,'2013-12-25 18:15:39',NULL,NULL),(30438,19731,'AP','3183059650',0,'2014-01-23 21:01:06',NULL,NULL),(28660,18485,'TE','3304331992',0,'2014-01-16 08:46:23',NULL,NULL),(11938,7774,'EM','miranda6099@gmail.com',0,'2013-12-26 03:03:02',NULL,NULL),(23887,15413,'TE','2108236250',1,'2014-01-02 04:27:11',NULL,NULL),(7921,5161,'TE','3306804824',0,'2013-12-25 23:03:04',NULL,NULL),(4124,2630,'AP','8597435558',0,'2013-12-25 19:46:06',NULL,NULL),(5311,3403,'EM','Amy@indesalon.co',0,'2013-12-25 21:18:11',NULL,NULL),(37728,24880,'AP','6507145966',0,'2014-02-20 05:36:07',NULL,NULL),(38311,25304,'AP','6148066019',0,'2014-02-25 21:00:29',NULL,NULL),(25441,16405,'TE','2142876584',0,'2014-01-07 04:04:02',NULL,NULL),(36158,23797,'TE','3308050613',0,'2014-02-14 21:31:28',NULL,NULL),(9361,6128,'TE','9728911662',0,'2013-12-26 00:15:56',NULL,NULL),(30766,19995,'EM','db_slone@yahoo.com',0,'2014-01-26 19:00:03',NULL,NULL),(27242,17538,'EM','obewonknabe@neo.rr.com',0,'2014-01-13 03:01:47',NULL,NULL),(2240,1374,'AP','5125544796',0,'2013-12-25 18:45:53',NULL,NULL),(14767,9661,'TE','5674556542',0,'2013-12-26 04:39:00',NULL,NULL),(22048,14199,'EM','usa2rock@yahoo.com',0,'2013-12-27 02:04:13',NULL,NULL),(6532,4225,'TE','9033433709',0,'2013-12-25 21:50:32',NULL,NULL),(39045,25822,'TE','9376206515',0,'2014-02-26 21:00:26',NULL,NULL),(39313,26005,'TE','5108758831',0,'2014-02-26 21:02:06',NULL,NULL),(41007,27247,'TE','4096814705',0,'2014-03-03 21:31:50',NULL,NULL),(41391,27497,'TE','3304647254',0,'2014-03-04 21:02:26',NULL,NULL),(9101,5966,'AP','4193085453',0,'2013-12-25 23:51:29',NULL,NULL),(36456,24005,'EM','charles.lenix74@gmail.com',0,'2014-02-15 22:00:36',NULL,NULL),(36352,23942,'TE','6143525610',0,'2014-02-15 21:00:09',NULL,NULL),(36087,23735,'EM','finsterwald.emily@gmail.com',0,'2014-02-14 21:31:00',NULL,NULL),(10056,6576,'AP','5042378838',0,'2013-12-26 00:52:50',NULL,NULL),(35513,23356,'TE','9178609243',0,'2014-02-13 22:00:44',NULL,NULL),(13732,8949,'EM','harlandd0710@hotmail.com',0,'2013-12-26 04:03:32',NULL,NULL),(28350,18266,'AP','8326838546',0,'2014-01-16 08:44:40',NULL,NULL),(24006,15493,'EM','nathandwindow@aol.com',1,'2014-01-02 04:29:36',NULL,NULL),(23163,14930,'TE','8324551719',0,'2013-12-30 00:01:59',NULL,NULL),(21173,13619,'AP','5135202502',0,'2013-12-26 13:05:49',NULL,NULL),(1742,1071,'AP','3305463573',0,'2013-12-25 18:16:32',NULL,NULL),(9513,6226,'EM','pj_riley2003@yahoo.com',0,'2013-12-26 00:31:19',NULL,NULL),(33326,21830,'TE','2147792937',0,'2014-02-06 21:01:04',NULL,NULL),(32577,21300,'EM','lesliesadati@gmail.com',0,'2014-02-04 21:00:12',NULL,NULL),(32319,21113,'EM','kingger54@gmail.com',0,'2014-02-03 21:00:09',NULL,NULL),(24511,15811,'AP','5049204680',0,'2014-01-03 02:03:12',NULL,NULL),(5627,3607,'TE','3306080398',0,'2013-12-25 21:23:23',NULL,NULL),(3327,2092,'AP','3186237742',0,'2013-12-25 19:16:55',NULL,NULL),(7113,4646,'TE','6019548849',0,'2013-12-25 22:06:55',NULL,NULL),(7260,4734,'TE','4193480854',0,'2013-12-25 22:09:14',NULL,NULL),(37121,24438,'AP','3309060832',0,'2014-02-18 22:01:17',NULL,NULL),(11989,7810,'AP','7138055092',0,'2013-12-26 03:03:56',NULL,NULL),(1147,705,'EM','kathrynnathan3@gmail.com',0,'2013-12-25 18:03:01',NULL,NULL),(3978,2524,'TE','3307252912',0,'2013-12-25 19:36:40',NULL,NULL),(6554,4235,'TE','2547158757',0,'2013-12-25 21:50:50',NULL,NULL),(6908,4498,'AP','9362389640',0,'2013-12-25 22:03:18',NULL,NULL),(9269,6067,'TE','6142971907',0,'2013-12-26 00:02:05',NULL,NULL),(36973,24344,'TE','5128180881',0,'2014-02-18 22:00:22',NULL,NULL),(42845,28494,'TE','6623907143',0,'2014-03-07 21:31:44',NULL,NULL),(11506,7488,'TE','9378375183',0,'2013-12-26 02:31:33',NULL,NULL),(33989,22296,'TE','6148343907',0,'2014-02-10 11:00:33',NULL,NULL),(32530,21264,'EM','REDBONE1957@YAHOO.COM',0,'2014-02-03 21:01:26',NULL,NULL),(11538,7512,'TE','9856220167',0,'2013-12-26 02:32:07',NULL,NULL),(25614,16520,'EM','bradly1972@hotmail.com',1,'2014-01-07 10:21:41',NULL,NULL),(7321,4760,'EM','Ksmith1848@aol.com',0,'2013-12-25 22:15:32',NULL,NULL),(12031,7848,'EM','cmkowalski@wowway.com',0,'2013-12-26 03:04:45',NULL,NULL),(4923,3160,'EM','Jesikel@aol.com',0,'2013-12-25 20:31:18',NULL,NULL),(20676,13295,'EM','jmhenrikson@yahoo.com',0,'2013-12-26 12:57:36',NULL,NULL),(9031,5925,'TE','8066370420',0,'2013-12-25 23:50:23',NULL,NULL),(20907,13447,'TE','9372721622',0,'2013-12-26 13:01:22',NULL,NULL),(40067,26565,'AP','4192023136',0,'2014-02-28 21:30:23',NULL,NULL),(42528,28293,'AP','5138856851',0,'2014-03-07 21:00:29',NULL,NULL),(43932,29143,'AP','5132326242',0,'2014-03-10 21:02:44',NULL,NULL),(23606,15241,'TE','4194389189',0,'2014-01-01 12:08:38',NULL,NULL),(3083,1924,'TE','6143307111',0,'2013-12-25 19:00:15',NULL,NULL),(23598,15238,'TE','4197491808',0,'2014-01-01 12:08:31',NULL,NULL),(2573,1570,'TE','4692798892',0,'2013-12-25 18:51:10',NULL,NULL),(21993,14166,'TE','5042895788',0,'2013-12-27 02:03:18',NULL,NULL),(8797,5762,'AP','5132925079',0,'2013-12-25 23:46:34',NULL,NULL),(37287,24536,'EM','tashialov@yahoo.com',0,'2014-02-20 04:01:37',NULL,NULL),(37418,24642,'TE','3183871479',0,'2014-02-20 04:20:26',NULL,NULL),(37817,24955,'EM','JVHENSLEY@GMAIL.COM',0,'2014-02-20 22:00:14',NULL,NULL),(38171,25194,'TE','2252393309',0,'2014-02-21 22:00:42',NULL,NULL),(38772,25633,'BN','6149621354',0,'2014-02-26 08:30:25',NULL,NULL),(38826,25666,'EM','sracameron@gmail.com',0,'2014-02-26 08:30:48',NULL,NULL),(14574,9530,'EM','cmkr1956@sdbglobal.net',0,'2013-12-26 04:35:46',NULL,NULL),(13821,9012,'TE','3306042137',0,'2013-12-26 04:05:06',NULL,NULL),(30733,19967,'TE','4409883386',0,'2014-01-25 19:00:10',NULL,NULL),(28532,18390,'EM','jajp7@yahoo.com',0,'2014-01-16 08:45:39',NULL,NULL),(26244,16890,'EM','ahickman27@hotmail.com',0,'2014-01-13 02:19:27',NULL,NULL),(8716,5719,'AP','5049054669',0,'2013-12-25 23:45:21',NULL,NULL),(2977,1844,'AP','3302836353',0,'2013-12-25 18:57:43',NULL,NULL),(3406,2140,'TE','2282812092',0,'2013-12-25 19:18:14',NULL,NULL),(6323,4077,'TE','3304004054',0,'2013-12-25 21:47:05',NULL,NULL),(39830,26344,'TE','5134791443',0,'2014-02-28 06:31:45',NULL,NULL),(21553,13858,'EM','Lindsay.marrone@gmail.com',0,'2013-12-26 13:12:45',NULL,NULL),(6679,4337,'AP','9377253352',0,'2013-12-25 21:53:11',NULL,NULL),(5230,3362,'TE','7023274576',0,'2013-12-25 21:17:00',NULL,NULL),(40263,26711,'AP','9377258956',0,'2014-02-28 21:31:38',NULL,NULL),(43369,28804,'EM','carenhall90@gmail.com',0,'2014-03-09 21:00:50',NULL,NULL),(13874,9050,'TE','2163913612',0,'2013-12-26 04:06:00',NULL,NULL),(6417,4144,'TE','9375093801',0,'2013-12-25 21:48:38',NULL,NULL),(20916,13450,'EM','nxtlbron07@gmail.com',0,'2013-12-26 13:01:29',NULL,NULL),(35014,22992,'AP','9374790356',0,'2014-02-12 21:30:14',NULL,NULL),(21688,13965,'TE','9374181295',0,'2013-12-26 13:15:14',NULL,NULL),(39144,25890,'AP','3615374336',0,'2014-02-26 21:01:03',NULL,NULL),(41450,27538,'TE','3302658969',0,'2014-03-04 21:30:06',NULL,NULL),(41544,27624,'AP','4196899465',0,'2014-03-05 21:30:06',NULL,NULL),(43109,28656,'TE','5047083775',0,'2014-03-08 21:30:41',NULL,NULL),(25859,16667,'EM','jschatzel79@yahoo.com',0,'2014-01-08 18:24:27',NULL,NULL),(7198,4689,'TE','5135087200',0,'2013-12-25 22:08:08',NULL,NULL),(28160,18152,'TE','4197222618',0,'2014-01-15 02:07:51',NULL,NULL),(22306,14377,'AP','6143028359',0,'2013-12-28 03:30:42',NULL,NULL),(20265,13061,'AP','3304147918',0,'2013-12-26 12:51:03',NULL,NULL),(6805,4416,'TE','6149898971',0,'2013-12-25 22:01:29',NULL,NULL),(4648,2970,'TE','9362396847',0,'2013-12-25 20:16:58',NULL,NULL),(11527,7502,'EM','Mattsanders777@gmail.com',0,'2013-12-26 02:31:52',NULL,NULL),(8996,5905,'AP','5132950299',0,'2013-12-25 23:49:52',NULL,NULL),(9713,6359,'TE','5134940315',0,'2013-12-26 00:47:18',NULL,NULL),(9852,6441,'EM','elcaminogreen@hotmail.com',0,'2013-12-26 00:49:28',NULL,NULL),(39070,25841,'TE','3303267003',0,'2014-02-26 21:00:35',NULL,NULL),(41922,27873,'TE','6013346111',0,'2014-03-05 21:32:27',NULL,NULL),(42169,28013,'TE','4197334341',0,'2014-03-06 21:01:16',NULL,NULL),(42576,28330,'EM','jaynamaz@me.com',0,'2014-03-07 21:30:10',NULL,NULL),(9396,6149,'AP','3302838945',0,'2013-12-26 00:16:29',NULL,NULL),(11409,7424,'EM','raysaviciunas@yahoo.com',0,'2013-12-26 02:17:08',NULL,NULL),(33563,22001,'TE','4193379131',0,'2014-02-07 19:00:48',NULL,NULL),(26296,16927,'TE','3185358104',0,'2014-01-13 02:19:47',NULL,NULL),(33002,21616,'TE','8322286929',0,'2014-02-05 21:30:36',NULL,NULL),(27590,17788,'TE','9375157480',0,'2014-01-14 01:33:46',NULL,NULL),(43321,28778,'AP','2167049902',0,'2014-03-09 21:00:34',NULL,NULL),(25920,16703,'BN','9568328860',0,'2014-01-08 18:24:39',NULL,NULL),(8810,5769,'AP','6145788309',0,'2013-12-25 23:46:45',NULL,NULL),(22715,14648,'AP','9032048078',1,'2013-12-29 11:07:40',NULL,NULL),(3324,2091,'TE','3372514225',0,'2013-12-25 19:16:53',NULL,NULL),(6698,4354,'TE','5135430642',0,'2013-12-25 21:53:33',NULL,NULL),(28443,18325,'AP','3306877759',0,'2014-01-16 08:45:09',NULL,NULL),(28043,18071,'AP','3182359292',0,'2014-01-15 02:07:24',NULL,NULL),(4649,2970,'AP','9362396847',0,'2013-12-25 20:16:58',NULL,NULL),(37799,24946,'TE','9014810564',0,'2014-02-20 22:00:08',NULL,NULL),(43868,29109,'TE','9858077765',0,'2014-03-10 21:02:23',NULL,NULL),(4726,3024,'TE','3309220872',0,'2013-12-25 20:18:15',NULL,NULL),(22523,14523,'TE','3614428822',0,'2013-12-28 03:34:21',NULL,NULL),(36872,24283,'AP','5044536224',0,'2014-02-18 21:30:08',NULL,NULL),(35308,23195,'AP','3306967031',0,'2014-02-12 21:32:06',NULL,NULL),(30067,19475,'AP','9158756067',0,'2014-01-23 03:02:01',NULL,NULL),(14008,9147,'AP','2164085250',0,'2013-12-26 04:08:20',NULL,NULL),(40030,26532,'EM','thelsherr@yahoo.com',0,'2014-02-28 21:30:03',NULL,NULL),(3122,1945,'AP','8594095919',0,'2013-12-25 19:00:48',NULL,NULL),(36688,24157,'TE','9374232484',0,'2014-02-15 22:02:01',NULL,NULL),(4849,3103,'AP','4194501503',0,'2013-12-25 20:20:20',NULL,NULL),(11807,7677,'AP','3305243819',0,'2013-12-26 03:00:45',NULL,NULL),(10195,6662,'TE','9037677693',0,'2013-12-26 01:00:54',NULL,NULL),(29371,18976,'AP','7406052827',0,'2014-01-20 08:06:05',NULL,NULL),(38484,25433,'TE','9158571026',0,'2014-02-25 21:31:16',NULL,NULL),(39603,26198,'TE','3303481476',0,'2014-02-28 06:30:47',NULL,NULL),(41989,27909,'EM','jonesandblondie@hotmail.com',0,'2014-03-06 21:00:14',NULL,NULL),(43577,28938,'TE','4192768197',0,'2014-03-10 21:00:41',NULL,NULL),(26146,16831,'AP','5136926721',0,'2014-01-13 02:18:28',NULL,NULL),(35786,23533,'AP','5049130952',0,'2014-02-13 22:02:27',NULL,NULL),(37094,24422,'AP','2163862405',0,'2014-02-18 22:01:08',NULL,NULL),(23809,15362,'TE','9373212846',1,'2014-01-02 04:24:48',NULL,NULL),(25145,16208,'EM','a_cooke@live.com',0,'2014-01-05 00:01:23',NULL,NULL),(2871,1755,'EM','revlindastampley9@yahoo.com',0,'2013-12-25 18:55:50',NULL,NULL),(30691,19938,'AP','9373029230',0,'2014-01-24 21:01:13',NULL,NULL),(9764,6385,'EM','emily.knueven@gmail.com',0,'2013-12-26 00:48:02',NULL,NULL),(1253,761,'EM','rskay@sbcglobal.net',0,'2013-12-25 18:04:34',NULL,NULL),(3319,2088,'AP','2256108905',0,'2013-12-25 19:16:48',NULL,NULL),(3338,2101,'TE','4196629865',0,'2013-12-25 19:17:09',NULL,NULL),(43491,28880,'TE','9798360503',0,'2014-03-10 21:00:08',NULL,NULL),(10691,6949,'AP','5136179586',0,'2013-12-26 01:47:00',NULL,NULL),(33033,21642,'TE','2543175363',0,'2014-02-05 21:30:46',NULL,NULL),(20773,13348,'EM','kaybaby1377@gmail.com',0,'2013-12-26 12:59:08',NULL,NULL),(7735,5049,'TE','7135012267',0,'2013-12-25 23:00:07',NULL,NULL),(927,571,'EM','randyc_@msn.com',0,'2013-12-25 17:50:37',NULL,NULL),(4027,2571,'TE','4196689306',0,'2013-12-25 19:37:42',NULL,NULL),(2459,1509,'AP','3305757554',0,'2013-12-25 18:49:28',NULL,NULL),(23924,15435,'AP','2543944310',1,'2014-01-02 04:27:53',NULL,NULL),(2982,1846,'AP','3306904087',0,'2013-12-25 18:57:47',NULL,NULL),(22992,14831,'TE','9377174636',1,'2013-12-29 11:14:35',NULL,NULL),(5672,3644,'AP','3304318100',0,'2013-12-25 21:30:27',NULL,NULL),(24559,15840,'EM','trustplus1@icloud.com',0,'2014-01-03 02:04:09',NULL,NULL),(12316,8052,'TE','4195991552',0,'2013-12-26 03:09:44',NULL,NULL),(35730,23496,'EM','maskta@gmail.com',0,'2014-02-13 22:02:06',NULL,NULL),(42792,28459,'AP','2253170845',0,'2014-03-07 21:31:24',NULL,NULL),(43390,28818,'TE','3306303643',0,'2014-03-09 21:00:57',NULL,NULL),(22178,14287,'TE','4198067432',0,'2013-12-27 02:06:28',NULL,NULL),(34575,22671,'AP','2107201631',0,'2014-02-11 21:00:42',NULL,NULL),(33549,21994,'AP','3183814086',0,'2014-02-07 19:00:44',NULL,NULL),(32777,21443,'TE','3304635680',0,'2014-02-04 21:01:25',NULL,NULL),(35450,23307,'BN','5135603298',0,'2014-02-13 22:00:19',NULL,NULL),(42974,28578,'TE','2813375859',0,'2014-03-08 21:00:06',NULL,NULL),(23916,15432,'TE','9039209077',1,'2014-01-02 04:27:46',NULL,NULL),(31522,20541,'EM','DSHORTER@ATT.NET',0,'2014-01-29 21:01:36',NULL,NULL),(25675,16552,'TE','9376630352',1,'2014-01-07 10:22:46',NULL,NULL),(7917,5158,'AP','6145805632',0,'2013-12-25 23:02:59',NULL,NULL),(10526,6855,'AP','3305739094',0,'2013-12-26 01:31:31',NULL,NULL),(22473,14490,'AP','2544823706',0,'2013-12-28 03:33:31',NULL,NULL),(5945,3816,'EM','max5031@zoomtown.com',0,'2013-12-25 21:34:50',NULL,NULL),(21529,13843,'TE','3307801058',0,'2013-12-26 13:12:21',NULL,NULL),(20406,13141,'EM','oneyzgod@sbcglobal.net',0,'2013-12-26 12:53:19',NULL,NULL),(13924,9079,'TE','7406243535',0,'2013-12-26 04:06:47',NULL,NULL),(34245,22461,'TE','5127993649',0,'2014-02-10 21:30:53',NULL,NULL),(30797,20024,'TE','5042552906',0,'2014-01-26 19:00:16',NULL,NULL),(30561,19829,'EM','dteneyuca@msn.com',0,'2014-01-24 21:00:18',NULL,NULL),(4255,2722,'AP','3372926786',0,'2013-12-25 19:48:14',NULL,NULL),(29045,18753,'TE','4193455184',0,'2014-01-17 03:35:44',NULL,NULL),(3559,2227,'EM','KATBISH8684@YAHOO.COM',0,'2013-12-25 19:20:42',NULL,NULL),(2080,1285,'EM','jritson@bex.net',0,'2013-12-25 18:30:42',NULL,NULL),(38704,25578,'AP','9379744900',0,'2014-02-26 08:00:34',NULL,NULL),(39963,26459,'TE','5049092396',0,'2014-02-28 07:30:30',NULL,NULL),(40527,26899,'AP','2145740586',0,'2014-03-03 01:00:06',NULL,NULL),(10186,6656,'EM','FLEXTJT@AOL.COM',0,'2013-12-26 01:00:44',NULL,NULL),(35045,23015,'EM','dacp28@me.com',0,'2014-02-12 21:30:26',NULL,NULL),(3445,2159,'AP','3186232318',0,'2013-12-25 19:18:50',NULL,NULL),(5024,3223,'AP','4194390433',0,'2013-12-25 20:45:49',NULL,NULL),(31510,20532,'TE','6019373316',0,'2014-01-29 21:01:31',NULL,NULL),(30628,19877,'TE','4403096313',0,'2014-01-24 21:00:44',NULL,NULL),(27649,17823,'AP','6016065987',0,'2014-01-15 02:05:57',NULL,NULL),(27393,17632,'EM','shawnharrison09@yahoo.com',0,'2014-01-14 01:32:34',NULL,NULL),(26346,16958,'AP','3308197283',0,'2014-01-13 02:20:05',NULL,NULL),(11537,7508,'EM','KATRESEGASPER@GMAIL.COM',0,'2013-12-26 02:32:03',NULL,NULL),(35563,23388,'TE','6142379108',0,'2014-02-13 22:01:03',NULL,NULL),(36910,24307,'AP','9852328958',0,'2014-02-18 21:30:24',NULL,NULL),(43563,28931,'TE','6143061122',0,'2014-03-10 21:00:37',NULL,NULL),(66,43,'TE','5134044660',0,'2013-12-25 17:16:07',NULL,NULL),(29648,19155,'AP','2163146811',0,'2014-01-21 08:45:38',NULL,NULL),(29255,18894,'TE','3309835163',0,'2014-01-17 03:36:33',NULL,NULL),(29176,18852,'AP','3306896834',0,'2014-01-17 03:36:16',NULL,NULL),(10192,6661,'TE','4092833068',0,'2013-12-26 01:00:52',NULL,NULL),(9615,6292,'AP','7083737223',0,'2013-12-26 00:45:41',NULL,NULL),(12328,8062,'AP','4192662691',0,'2013-12-26 03:09:59',NULL,NULL),(525,328,'AP','2168328499',0,'2013-12-25 17:31:37',NULL,NULL),(14418,9426,'TE','9155842899',0,'2013-12-26 04:33:15',NULL,NULL),(20390,13134,'AP','3302219997',0,'2013-12-26 12:53:07',NULL,NULL),(2421,1478,'EM','tim.gilchrist@live.com',0,'2013-12-25 18:48:44',NULL,NULL),(7115,4646,'EM','lhenry959701@yahoo.com',0,'2013-12-25 22:06:56',NULL,NULL),(38521,25456,'AP','9564583172',0,'2014-02-25 21:31:28',NULL,NULL),(40457,26857,'AP','9372170522',0,'2014-03-01 21:00:54',NULL,NULL),(41119,27314,'AP','9565361331',0,'2014-03-04 21:00:42',NULL,NULL),(41577,27645,'TE','3303215015',0,'2014-03-05 21:30:18',NULL,NULL),(41836,27817,'TE','7408048028',0,'2014-03-05 21:31:54',NULL,NULL),(43409,28827,'AP','5135056248',0,'2014-03-09 21:01:04',NULL,NULL),(43808,29081,'TE','6629029118',0,'2014-03-10 21:02:03',NULL,NULL),(3914,2484,'TE','3373510054',0,'2013-12-25 19:35:36',NULL,NULL),(5787,3709,'TE','3305394352',0,'2013-12-25 21:32:10',NULL,NULL),(14903,9751,'TE','3302887790',0,'2013-12-26 04:46:13',NULL,NULL),(41777,27776,'TE','3306672082',0,'2014-03-05 21:31:30',NULL,NULL),(24152,15607,'EM','DarrenArmstrong1@gmail.com',1,'2014-01-02 04:32:44',NULL,NULL),(34263,22480,'TE','9372786324',0,'2014-02-10 21:31:02',NULL,NULL),(25217,16260,'TE','3302740329',0,'2014-01-05 00:02:55',NULL,NULL),(11412,7425,'EM','SHANNON.HARTZELL@REALLLIVING.COM',0,'2013-12-26 02:17:10',NULL,NULL),(9918,6491,'TE','4404668762',0,'2013-12-26 00:50:35',NULL,NULL),(27529,17736,'EM','bbevans1950@yahoo.com',0,'2014-01-14 01:33:21',NULL,NULL),(9912,6488,'TE','3306280826',0,'2013-12-26 00:50:30',NULL,NULL),(21463,13792,'EM','carlos.sotelo1997@yahoo.com',0,'2013-12-26 13:11:08',NULL,NULL),(36679,24151,'AP','5133687818',0,'2014-02-15 22:01:57',NULL,NULL),(37657,24829,'AP','5133025862',0,'2014-02-20 04:51:56',NULL,NULL),(40653,26988,'TE','4199570822',0,'2014-03-03 01:00:41',NULL,NULL),(2897,1774,'AP','4404531866',0,'2013-12-25 18:56:12',NULL,NULL),(1461,894,'AP','9373669113',0,'2013-12-25 18:08:05',NULL,NULL),(31320,20410,'TE','9038732674',0,'2014-01-29 21:00:24',NULL,NULL),(40262,26711,'TE','9377258956',0,'2014-02-28 21:31:38',NULL,NULL),(41793,27784,'EM','bathsheba.cole@yahoo.com',0,'2014-03-05 21:31:36',NULL,NULL),(1509,929,'AP','2164072748',0,'2013-12-25 18:09:02',NULL,NULL),(31534,20549,'TE','5133305537',0,'2014-01-29 21:01:40',NULL,NULL),(10371,6760,'AP','2164096518',0,'2013-12-26 01:16:19',NULL,NULL),(11877,7731,'TE','2169704966',0,'2013-12-26 03:02:00',NULL,NULL),(27595,17790,'TE','5137038540',0,'2014-01-14 01:33:47',NULL,NULL),(24440,15778,'TE','9565704810',0,'2014-01-03 02:02:03',NULL,NULL),(7503,4890,'TE','2813003679',0,'2013-12-25 22:31:29',NULL,NULL),(2825,1708,'TE','5133902274',0,'2013-12-25 18:54:56',NULL,NULL),(6101,3928,'AP','4197223089',0,'2013-12-25 21:37:34',NULL,NULL),(22636,14596,'AP','2346785324',0,'2013-12-28 03:36:16',NULL,NULL),(5547,3543,'AP','2142074857',0,'2013-12-25 21:21:52',NULL,NULL),(5208,3346,'TE','9364433679',0,'2013-12-25 21:16:37',NULL,NULL),(40606,26954,'AP','5678682613',0,'2014-03-03 01:00:28',NULL,NULL),(42564,28322,'AP','9158871513',0,'2014-03-07 21:30:06',NULL,NULL),(42648,28371,'TE','9377253796',0,'2014-03-07 21:30:35',NULL,NULL),(4480,2851,'TE','4199089073',0,'2013-12-25 20:01:22',NULL,NULL),(2700,1641,'AP','3617276524',0,'2013-12-25 18:53:05',NULL,NULL),(4796,3067,'AP','5104595149',0,'2013-12-25 20:19:22',NULL,NULL),(14591,9540,'EM','robin.holcomb@yahoo.com',0,'2013-12-26 04:36:00',NULL,NULL),(31514,20536,'TE','3309662362',0,'2014-01-29 21:01:33',NULL,NULL),(31156,20291,'TE','5047106792',0,'2014-01-28 21:00:36',NULL,NULL),(29291,18927,'TE','3302711996',0,'2014-01-20 08:05:36',NULL,NULL),(20939,13467,'TE','5136738981',0,'2013-12-26 13:01:55',NULL,NULL),(22729,14658,'TE','3614455851',1,'2013-12-29 11:07:55',NULL,NULL),(7037,4596,'TE','3308825593',0,'2013-12-25 22:05:35',NULL,NULL),(41596,27657,'TE','3302087464',0,'2014-03-05 21:30:25',NULL,NULL),(42944,28551,'EM','Shramey42@aol.com',0,'2014-03-07 21:32:21',NULL,NULL),(807,501,'TE','6147691381',0,'2013-12-25 17:48:43',NULL,NULL),(34543,22657,'EM','gracieherrera@icloud.com',0,'2014-02-11 21:00:32',NULL,NULL),(33423,21896,'TE','4196518215',0,'2014-02-06 21:01:43',NULL,NULL),(6184,3985,'TE','5134870784',0,'2013-12-25 21:38:56',NULL,NULL),(10876,7061,'TE','4197225891',0,'2013-12-26 01:49:56',NULL,NULL),(32241,21057,'AP','2252532863',0,'2014-02-02 19:00:09',NULL,NULL),(13997,9135,'AP','7406447267',0,'2013-12-26 04:08:05',NULL,NULL),(21840,14069,'AP','2165130921',0,'2013-12-27 02:00:48',NULL,NULL),(37071,24409,'EM','ragonesilaw@gmail.com',0,'2014-02-18 22:01:00',NULL,NULL),(38027,25083,'TE','4199089336',0,'2014-02-20 22:01:40',NULL,NULL),(38839,25674,'TE','5675255141',0,'2014-02-26 08:30:54',NULL,NULL),(25055,16152,'AP','4193031395',0,'2014-01-04 02:06:16',NULL,NULL),(31112,20256,'TE','6147618106',0,'2014-01-28 21:00:17',NULL,NULL),(29856,19316,'AP','8303132171',1,'2014-01-22 03:22:09',NULL,NULL),(23878,15408,'TE','7133762913',1,'2014-01-02 04:27:01',NULL,NULL),(20978,13503,'AP','3188204359',0,'2013-12-26 13:02:39',NULL,NULL),(36701,24164,'TE','3307150068',0,'2014-02-15 22:02:05',NULL,NULL),(39051,25825,'EM','DAVIDANN4674@MSN.COM',0,'2014-02-26 21:00:28',NULL,NULL),(40714,27054,'TE','9376630352',0,'2014-03-03 21:00:26',NULL,NULL),(12120,7922,'TE','3374997170',0,'2013-12-26 03:06:21',NULL,NULL),(4314,2751,'EM','schnav@gmail.com',0,'2013-12-25 19:49:07',NULL,NULL),(31072,20214,'TE','5139470967',0,'2014-01-27 21:01:40',NULL,NULL),(29758,19243,'AP','3306900866',0,'2014-01-21 08:46:39',NULL,NULL),(3526,2205,'TE','3308011514',0,'2013-12-25 19:20:09',NULL,NULL),(26071,16792,'TE','3302726484',0,'2014-01-13 02:18:06',NULL,NULL),(36917,24314,'TE','2542287787',0,'2014-02-18 22:00:04',NULL,NULL),(38511,25450,'TE','2817063871',0,'2014-02-25 21:31:25',NULL,NULL),(656,409,'TE','5044954260',0,'2013-12-25 17:46:22',NULL,NULL),(33606,22037,'TE','9374926226',0,'2014-02-07 19:01:06',NULL,NULL),(30444,19735,'AP','3183218960',0,'2014-01-23 21:01:08',NULL,NULL),(20651,13281,'EM','robert.ceballos615@gmail.com',0,'2013-12-26 12:57:12',NULL,NULL),(23537,15190,'AP','3306440877',0,'2014-01-01 12:07:05',NULL,NULL),(26234,16885,'TE','7132057273',0,'2014-01-13 02:19:24',NULL,NULL),(767,479,'AP','5043280771',0,'2013-12-25 17:48:07',NULL,NULL),(2439,1495,'AP','9373698579',0,'2013-12-25 18:49:09',NULL,NULL),(9551,6251,'TE','9372171555',0,'2013-12-26 00:31:57',NULL,NULL),(36967,24340,'EM','CARRILLO_URKIDI@HOTMAIL.COM',0,'2014-02-18 22:00:20',NULL,NULL),(43875,29111,'AP','2154073513',0,'2014-03-10 21:02:24',NULL,NULL),(5166,3317,'AP','5137031154',0,'2013-12-25 21:15:58',NULL,NULL),(11563,7524,'TE','4404544508',0,'2013-12-26 02:32:30',NULL,NULL),(22229,14327,'AP','9375910728',0,'2013-12-27 02:07:26',NULL,NULL),(32645,21353,'AP','3616558371',0,'2014-02-04 21:00:39',NULL,NULL),(30472,19756,'TE','4408882839',0,'2014-01-23 21:01:21',NULL,NULL),(30307,19634,'AP','4194637721',0,'2014-01-23 21:00:11',NULL,NULL),(27512,17724,'AP','3307035121',0,'2014-01-14 01:33:15',NULL,NULL),(37046,24395,'EM','frankcivitaresejr@yahoo.com',0,'2014-02-18 22:00:51',NULL,NULL),(41122,27316,'TE','9038982966',0,'2014-03-04 21:00:42',NULL,NULL),(7479,4867,'TE','3306866433',0,'2013-12-25 22:30:54',NULL,NULL),(4977,3196,'TE','4192556198',0,'2013-12-25 20:32:17',NULL,NULL),(291,179,'AP','3302088182',0,'2013-12-25 17:19:38',NULL,NULL),(14674,9601,'TE','2164075417',0,'2013-12-26 04:37:25',NULL,NULL),(20997,13512,'TE','5042893733',0,'2013-12-26 13:02:56',NULL,NULL),(30889,20078,'TE','7133666927',0,'2014-01-27 21:00:22',NULL,NULL),(2749,1667,'AP','9729006354',0,'2013-12-25 18:53:47',NULL,NULL),(1435,876,'TE','9376920132',0,'2013-12-25 18:07:35',NULL,NULL),(5862,3762,'AP','3302834630',0,'2013-12-25 21:33:27',NULL,NULL),(5886,3776,'TE','9378905393',0,'2013-12-25 21:33:51',NULL,NULL),(35084,23042,'TE','2143922898',0,'2014-02-12 21:30:40',NULL,NULL),(8594,5649,'TE','9362543967',0,'2013-12-25 23:31:26',NULL,NULL),(30264,19610,'TE','3306872654',0,'2014-01-23 03:02:50',NULL,NULL),(37920,25014,'AP','4193508065',0,'2014-02-20 22:00:54',NULL,NULL),(39221,25941,'AP','9565256024',0,'2014-02-26 21:01:31',NULL,NULL),(1146,705,'AP','5042581293',0,'2013-12-25 18:03:01',NULL,NULL),(35432,23292,'TE','7343472112',0,'2014-02-13 22:00:09',NULL,NULL),(33301,21808,'TE','3304193112',0,'2014-02-06 21:00:53',NULL,NULL),(29853,19315,'AP','3614423955',1,'2014-01-22 03:22:08',NULL,NULL),(28009,18053,'TE','6627562018',0,'2014-01-15 02:07:17',NULL,NULL),(11467,7458,'AP','6167453898',0,'2013-12-26 02:30:50',NULL,NULL),(10640,6920,'TE','7404910441',0,'2013-12-26 01:46:11',NULL,NULL),(22155,14271,'EM','VONMOA@YAHOO.COM',0,'2013-12-27 02:06:05',NULL,NULL),(1875,1157,'TE','2254506195',0,'2013-12-25 18:18:47',NULL,NULL),(7558,4921,'TE','3307237432',0,'2013-12-25 22:45:11',NULL,NULL),(9265,6063,'AP','3308477768',0,'2013-12-26 00:02:00',NULL,NULL),(23167,14931,'AP','2107813055',0,'2013-12-30 00:02:01',NULL,NULL),(39107,25872,'TE','9852154034',0,'2014-02-26 21:00:52',NULL,NULL),(40575,26929,'BN','4403432384',0,'2014-03-03 01:00:19',NULL,NULL),(41858,27835,'EM','adlib205@yahoo.com',0,'2014-03-05 21:32:03',NULL,NULL),(22847,14743,'AP','2252811449',1,'2013-12-29 11:10:05',NULL,NULL),(35234,23139,'TE','3305684166',0,'2014-02-12 21:31:35',NULL,NULL),(35194,23114,'EM','cakunne@gmail.com',0,'2014-02-12 21:31:20',NULL,NULL),(31391,20458,'AP','2163238699',0,'2014-01-29 21:00:50',NULL,NULL),(41420,27518,'TE','4197046493',0,'2014-03-04 21:02:38',NULL,NULL),(43358,28798,'TE','3306344893',0,'2014-03-09 21:00:46',NULL,NULL),(25847,16661,'EM','soraya.a.gallegos@gmail.com',0,'2014-01-08 18:24:24',NULL,NULL),(9105,5968,'EM','scomo63@hotmail.com',0,'2013-12-25 23:51:32',NULL,NULL),(6329,4080,'AP','3302341069',0,'2013-12-25 21:47:10',NULL,NULL),(13864,9040,'TE','3308250315',0,'2013-12-26 04:05:48',NULL,NULL),(24063,15535,'AP','3379625493',1,'2014-01-02 04:30:47',NULL,NULL),(32094,20961,'TE','3252071291',0,'2014-02-01 19:00:09',NULL,NULL),(25052,16150,'EM','WALLEYETT1955@YAHOO.COM',0,'2014-01-04 02:06:13',NULL,NULL),(38648,25542,'TE','7404481030',0,'2014-02-26 08:00:12',NULL,NULL),(42241,28059,'AP','5133864317',0,'2014-03-06 21:01:43',NULL,NULL),(5012,3216,'EM','ddennison5@roadrunner.com',0,'2013-12-25 20:45:35',NULL,NULL),(34646,22715,'TE','3377858290',0,'2014-02-11 21:01:07',NULL,NULL),(6435,4157,'AP','6145357135',0,'2013-12-25 21:48:55',NULL,NULL),(27646,17821,'TE','6018454177',0,'2014-01-15 02:05:56',NULL,NULL),(7418,4822,'AP','4194489544',0,'2013-12-25 22:17:08',NULL,NULL),(2265,1388,'TE','2068906372',0,'2013-12-25 18:46:18',NULL,NULL),(1456,891,'AP','9374862050',0,'2013-12-25 18:08:00',NULL,NULL),(11376,7408,'AP','2108377163',0,'2013-12-26 02:16:39',NULL,NULL),(8148,5334,'TE','3306377584',0,'2013-12-25 23:07:10',NULL,NULL),(40339,26770,'AP','9374784081',0,'2014-03-01 21:00:08',NULL,NULL),(41687,27722,'TE','7134463607',0,'2014-03-05 21:30:59',NULL,NULL),(25178,16236,'EM','MARLIESAN@HOTMAIL.COM',0,'2014-01-05 00:02:12',NULL,NULL),(36404,23976,'AP','4153502141',0,'2014-02-15 22:00:17',NULL,NULL),(28259,18222,'TE','9792167638',0,'2014-01-16 08:44:14',NULL,NULL),(34683,22745,'AP','3187199680',0,'2014-02-11 21:01:22',NULL,NULL),(43170,28688,'TE','3306239778',0,'2014-03-08 21:31:02',NULL,NULL),(12098,7906,'TE','5042326235',0,'2013-12-26 03:05:57',NULL,NULL),(35504,23346,'AP','3307014363',0,'2014-02-13 22:00:39',NULL,NULL),(35001,22982,'AP','9378221336',0,'2014-02-12 21:30:09',NULL,NULL),(10244,6697,'TE','3305711389',0,'2013-12-26 01:01:47',NULL,NULL),(4462,2842,'TE','3305540953',0,'2013-12-25 20:01:05',NULL,NULL),(29148,18831,'AP','4194382306',0,'2014-01-17 03:36:10',NULL,NULL),(38160,25185,'EM','rapadow@ssnet.com',0,'2014-02-21 22:00:36',NULL,NULL),(43619,28956,'TE','3373239216',0,'2014-03-10 21:00:53',NULL,NULL),(20819,13381,'EM','hp@aviarts.com',0,'2013-12-26 12:59:55',NULL,NULL),(2516,1542,'TE','4402418452',0,'2013-12-25 18:50:20',NULL,NULL),(31702,20678,'EM','punjnud@gmail.com',0,'2014-01-30 21:00:54',NULL,NULL),(8731,5726,'AP','6622310753',0,'2013-12-25 23:45:33',NULL,NULL),(31170,20299,'TE','2256758414',0,'2014-01-28 21:00:42',NULL,NULL),(26638,17139,'AP','4197891192',0,'2014-01-13 02:21:51',NULL,NULL),(37558,24732,'EM','k_tweet99@hotmail.com',0,'2014-02-20 04:39:37',NULL,NULL),(26068,16790,'EM','ksr60@embarqmail.com',0,'2014-01-13 02:18:06',NULL,NULL),(13658,8905,'AP','9376132601',0,'2013-12-26 04:02:24',NULL,NULL),(10995,7142,'TE','8176375594',0,'2013-12-26 01:51:55',NULL,NULL),(26212,16872,'AP','2543867249',0,'2014-01-13 02:19:16',NULL,NULL),(5123,3283,'TE','6145634377',0,'2013-12-25 21:15:19',NULL,NULL),(7191,4685,'TE','2168480774',0,'2013-12-25 22:08:01',NULL,NULL),(36306,23905,'TE','8597600127',0,'2014-02-14 21:32:26',NULL,NULL),(37904,25002,'TE','3305507878',0,'2014-02-20 22:00:47',NULL,NULL),(38118,25160,'TE','9562626622',0,'2014-02-21 22:00:22',NULL,NULL),(38755,25620,'TE','7132593458',0,'2014-02-26 08:30:16',NULL,NULL),(22117,14245,'EM','richardt-events@usa.net',0,'2013-12-27 02:05:22',NULL,NULL),(12157,7941,'EM','ra.brucewatkins@gmail.com',0,'2013-12-26 03:06:54',NULL,NULL),(32909,21546,'TE','6142713596',0,'2014-02-05 21:30:11',NULL,NULL),(25118,16192,'EM','cindy.hernandez98@yahoo.com',0,'2014-01-05 00:00:52',NULL,NULL),(26105,16811,'AP','3258293258',0,'2014-01-13 02:18:16',NULL,NULL),(37889,24994,'EM','chosenbythe1@yahoo.com',0,'2014-02-20 22:00:42',NULL,NULL),(40203,26666,'AP','3182654017',0,'2014-02-28 21:31:15',NULL,NULL),(40910,27185,'EM','rnietojr@hotmail.com',0,'2014-03-03 21:31:13',NULL,NULL),(1277,775,'AP','5129638761',0,'2013-12-25 18:04:56',NULL,NULL),(25265,16290,'AP','3308586636',0,'2014-01-07 04:00:49',NULL,NULL),(30806,20030,'BN','2253616212',0,'2014-01-26 19:00:20',NULL,NULL),(32554,21284,'AP','5045592689',0,'2014-02-04 21:00:04',NULL,NULL),(31873,20805,'AP','4092254934',0,'2014-01-31 21:00:24',NULL,NULL),(43907,29129,'EM','chloeestep@aol.com',0,'2014-03-10 21:02:36',NULL,NULL),(5375,3440,'EM','trang.thuy.tran937@gmail.com',0,'2013-12-25 21:19:13',NULL,NULL),(31126,20271,'TE','9377531080',0,'2014-01-28 21:00:24',NULL,NULL),(29521,19082,'BN','5135208049',0,'2014-01-21 08:44:27',NULL,NULL),(29326,18951,'TE','8172336679',0,'2014-01-20 08:05:49',NULL,NULL),(34144,22388,'AP','3306204254',0,'2014-02-10 21:30:13',NULL,NULL),(34499,22631,'BN','2142588748',0,'2014-02-11 21:00:17',NULL,NULL),(42560,28320,'TE','7135244614',0,'2014-03-07 21:30:04',NULL,NULL),(10564,6876,'EM','sastidham@hotmail.com',0,'2013-12-26 01:32:08',NULL,NULL),(27834,17934,'TE','5122229233',0,'2014-01-15 02:06:36',NULL,NULL),(7051,4606,'EM','wagner712@att.net',0,'2013-12-25 22:05:51',NULL,NULL),(22724,14652,'AP','8327139153',1,'2013-12-29 11:07:47',NULL,NULL),(40573,26929,'TE','4403432384',0,'2014-03-03 01:00:19',NULL,NULL),(41084,27290,'AP','3617902918',0,'2014-03-04 21:00:28',NULL,NULL),(43867,29108,'AP','3375199514',0,'2014-03-10 21:02:22',NULL,NULL),(12208,7977,'EM','jkessen@live.com',0,'2013-12-26 03:07:51',NULL,NULL),(11801,7674,'TE','2346789968',0,'2013-12-26 03:00:40',NULL,NULL),(30395,19696,'AP','9792792289',0,'2014-01-23 21:00:45',NULL,NULL),(1919,1188,'EM','lcmorris11@yahoo.com',0,'2013-12-25 18:19:33',NULL,NULL),(9808,6419,'TE','4197336344',0,'2013-12-26 00:48:50',NULL,NULL),(35866,23586,'TE','3307536335',0,'2014-02-13 22:03:00',NULL,NULL),(37181,24475,'EM','PRECIOUS.ALLEN@SCTODAY.EDU',0,'2014-02-18 22:01:41',NULL,NULL),(43911,29133,'TE','4194834613',0,'2014-03-10 21:02:38',NULL,NULL),(9095,5960,'TE','5137775404',0,'2013-12-25 23:51:23',NULL,NULL),(2812,1701,'TE','4193443866',0,'2013-12-25 18:54:44',NULL,NULL),(7973,5202,'AP','3309589224',0,'2013-12-25 23:04:04',NULL,NULL),(26504,17054,'AP','5132524535',0,'2014-01-13 02:21:00',NULL,NULL),(24645,15890,'AP','4195748637',0,'2014-01-03 02:05:44',NULL,NULL),(23815,15364,'AP','5136791570',1,'2014-01-02 04:24:53',NULL,NULL),(21418,13770,'TE','6622425561',0,'2013-12-26 13:10:29',NULL,NULL),(5544,3542,'AP','2145052835',0,'2013-12-25 21:21:50',NULL,NULL),(3667,2328,'TE','9562372333',0,'2013-12-25 19:31:36',NULL,NULL),(38212,25221,'AP','6019065121',0,'2014-02-21 22:00:57',NULL,NULL),(21499,13816,'TE','2162815517',0,'2013-12-26 13:11:45',NULL,NULL),(13555,8839,'AP','3613181058',0,'2013-12-26 04:00:42',NULL,NULL),(4223,2701,'TE','8309979575',0,'2013-12-25 19:47:44',NULL,NULL),(4990,3203,'AP','5672887318',0,'2013-12-25 20:45:15',NULL,NULL),(24805,16003,'TE','5127873860',0,'2014-01-04 02:01:34',NULL,NULL),(37257,24517,'TE','9152528696',0,'2014-02-20 03:55:48',NULL,NULL),(37593,24764,'EM','TONIK81@YAHOO.COM',0,'2014-02-20 04:43:52',NULL,NULL),(43025,28608,'AP','6143153618',0,'2014-03-08 21:30:14',NULL,NULL),(23270,14992,'AP','9566356005',0,'2014-01-01 12:01:28',NULL,NULL),(10743,6983,'AP','9373053034',0,'2013-12-26 01:47:48',NULL,NULL),(7852,5125,'TE','2108600102',0,'2013-12-25 23:02:04',NULL,NULL),(7862,5129,'TE','8172634116',0,'2013-12-25 23:02:11',NULL,NULL),(38085,25140,'AP','2103098177',0,'2014-02-21 22:00:10',NULL,NULL),(38901,25715,'AP','2545926870',0,'2014-02-26 09:30:25',NULL,NULL),(39199,25925,'TE','9564331745',0,'2014-02-26 21:01:23',NULL,NULL),(39504,26128,'EM','besthousing@mbarqmail.com',0,'2014-02-28 06:30:22',NULL,NULL),(39935,26427,'AP','9365900729',0,'2014-02-28 07:30:13',NULL,NULL),(41280,27429,'TE','5043159712',0,'2014-03-04 21:01:45',NULL,NULL),(20205,13019,'AP','4193062877',0,'2013-12-26 12:50:00',NULL,NULL),(31497,20524,'TE','4193103272',0,'2014-01-29 21:01:27',NULL,NULL),(14150,9262,'EM','bret.gervais@yahoo.com',0,'2013-12-26 04:15:22',NULL,NULL),(24143,15596,'AP','6145066844',1,'2014-01-02 04:32:32',NULL,NULL),(23987,15484,'AP','2162721343',1,'2014-01-02 04:29:16',NULL,NULL),(6669,4330,'TE','9375645597',0,'2013-12-25 21:53:00',NULL,NULL),(37827,24960,'AP','2253013486',0,'2014-02-20 22:00:18',NULL,NULL),(23036,14860,'TE','2288314633',1,'2013-12-29 11:15:20',NULL,NULL),(33848,22219,'AP','3184130266',0,'2014-02-09 19:00:26',NULL,NULL),(4453,2836,'EM','philcarman@neo.rr.com',0,'2013-12-25 20:00:56',NULL,NULL),(32789,21453,'AP','3308084306',0,'2014-02-04 21:01:29',NULL,NULL),(1154,708,'TE','9852498103',0,'2013-12-25 18:03:07',NULL,NULL),(1603,987,'AP','5136175363',0,'2013-12-25 18:10:29',NULL,NULL),(3541,2217,'EM','spamboxfull@aol.com',0,'2013-12-25 19:20:26',NULL,NULL),(41653,27688,'EM','Blake.harris4@gmail.com',0,'2014-03-05 21:30:42',NULL,NULL),(42660,28380,'EM','dshilinski@gmail.com',0,'2014-03-07 21:30:39',NULL,NULL),(426,261,'TE','9372066399',0,'2013-12-25 17:21:50',NULL,NULL),(32303,21098,'TE','4197082183',0,'2014-02-02 19:00:33',NULL,NULL),(7554,4919,'TE','3306441308',0,'2013-12-25 22:45:07',NULL,NULL),(30632,19879,'EM','wk692912@gmail.com',0,'2014-01-24 21:00:45',NULL,NULL),(20487,13193,'AP','4692222817',0,'2013-12-26 12:54:43',NULL,NULL),(5005,3213,'EM','bhargrave1@aol.com',0,'2013-12-25 20:45:30',NULL,NULL),(5506,3523,'AP','6013173108',0,'2013-12-25 21:21:19',NULL,NULL),(35212,23127,'TE','3302963350',0,'2014-02-12 21:31:27',NULL,NULL),(36079,23732,'AP','4402258300',0,'2014-02-14 21:30:58',NULL,NULL),(36336,23931,'AP','5133796661',0,'2014-02-15 21:00:04',NULL,NULL),(40881,27163,'AP','8329646161',0,'2014-03-03 21:31:01',NULL,NULL),(2849,1733,'TE','9377506744',0,'2013-12-25 18:55:25',NULL,NULL),(33692,22100,'TE','5136759880',0,'2014-02-08 19:00:29',NULL,NULL),(12410,8126,'TE','6144577027',0,'2013-12-26 03:15:25',NULL,NULL),(26432,17006,'AP','2169048435',0,'2014-01-13 02:20:34',NULL,NULL),(31813,20770,'AP','3524282278',0,'2014-01-30 21:01:39',NULL,NULL),(37172,24469,'EM','tinknocker052349@aol.com',0,'2014-02-18 22:01:37',NULL,NULL),(39518,26140,'TE','6143576273',0,'2014-02-28 06:30:25',NULL,NULL),(42291,28083,'TE','9037527015',0,'2014-03-06 21:01:59',NULL,NULL),(21657,13936,'EM','strangeconnie922@gmail.com',0,'2013-12-26 13:14:39',NULL,NULL),(34735,22776,'EM','dmajer@netzero.com',0,'2014-02-11 21:01:41',NULL,NULL),(24986,16102,'AP','2405388660',0,'2014-01-04 02:04:50',NULL,NULL),(1906,1178,'AP','5135201677',0,'2013-12-25 18:19:18',NULL,NULL),(34493,22628,'EM','jacquelinefigueroa54@yahoo.com',0,'2014-02-11 21:00:15',NULL,NULL),(33997,22300,'TE','2167804426',0,'2014-02-10 11:00:36',NULL,NULL),(33724,22120,'EM','closecall1994@yahoo.com',0,'2014-02-08 19:00:40',NULL,NULL),(7131,4653,'TE','5132261020',0,'2013-12-25 22:07:09',NULL,NULL),(29579,19112,'TE','3307985436',0,'2014-01-21 08:44:45',NULL,NULL),(29168,18847,'TE','3303369364',0,'2014-01-17 03:36:15',NULL,NULL),(28861,18637,'TE','8065591407',0,'2014-01-17 03:35:04',NULL,NULL),(27785,17911,'EM','tonia_bingham@yahoo.com',0,'2014-01-15 02:06:27',NULL,NULL),(12072,7881,'EM','cthornton7@cox.net',0,'2013-12-26 03:05:26',NULL,NULL),(14608,9550,'AP','9373026824',0,'2013-12-26 04:36:16',NULL,NULL),(12090,7901,'EM','gary44fd@hotmail.com',0,'2013-12-26 03:05:49',NULL,NULL),(21982,14159,'TE','5105418330',0,'2013-12-27 02:03:08',NULL,NULL),(9748,6374,'AP','2407793181',0,'2013-12-26 00:47:45',NULL,NULL),(26935,17324,'AP','9404477162',0,'2014-01-13 02:23:53',NULL,NULL),(26321,16946,'TE','2257267083',0,'2014-01-13 02:19:57',NULL,NULL),(3044,1893,'EM','revdocbug@gmail.com',0,'2013-12-25 18:58:55',NULL,NULL),(3152,1969,'TE','8176816774',0,'2013-12-25 19:01:26',NULL,NULL),(3906,2479,'AP','5043198787',0,'2013-12-25 19:35:28',NULL,NULL),(37313,24551,'EM','cjm3378@att.net',0,'2014-02-20 04:04:39',NULL,NULL),(21267,13665,'TE','5042512506',0,'2013-12-26 13:07:45',NULL,NULL),(34888,22894,'AP','4193765781',0,'2014-02-11 21:02:38',NULL,NULL),(20772,13347,'TE','9039606083',0,'2013-12-26 12:59:06',NULL,NULL),(6646,4306,'TE','5138058813',0,'2013-12-25 21:52:29',NULL,NULL),(13647,8900,'TE','4403761951',0,'2013-12-26 04:02:15',NULL,NULL),(38535,25465,'AP','2819196568',0,'2014-02-25 21:31:34',NULL,NULL),(42633,28361,'TE','7136143770',0,'2014-03-07 21:30:28',NULL,NULL),(12297,8042,'EM','shanni_4@yahoo.com',0,'2013-12-26 03:09:28',NULL,NULL),(33841,22216,'AP','5043433164',0,'2014-02-09 19:00:24',NULL,NULL),(32972,21583,'AP','3307147196',0,'2014-02-05 21:30:26',NULL,NULL),(32323,21116,'AP','4697655735',0,'2014-02-03 21:00:10',NULL,NULL),(13614,8872,'TE','9564561808',0,'2013-12-26 04:01:37',NULL,NULL),(14337,9373,'EM','lamonicajohnson@outlook.com',0,'2013-12-26 04:31:52',NULL,NULL),(20902,13439,'EM','awsdeb@icloud.com',0,'2013-12-26 13:01:16',NULL,NULL),(28108,18115,'AP','2165700093',0,'2014-01-15 02:07:38',NULL,NULL),(21976,14157,'TE','9856417252',0,'2013-12-27 02:03:03',NULL,NULL),(36017,23691,'TE','3306710624',0,'2014-02-14 21:30:37',NULL,NULL),(38284,25278,'TE','8172634116',0,'2014-02-25 21:00:16',NULL,NULL),(41234,27387,'TE','6019492763',0,'2014-03-04 21:01:25',NULL,NULL),(259,158,'TE','5122977257',0,'2013-12-25 17:19:07',NULL,NULL),(29664,19166,'TE','5129712376',0,'2014-01-21 08:46:01',NULL,NULL),(11119,7230,'EM','lynn45217@yahoo.com',0,'2013-12-26 02:01:21',NULL,NULL),(27405,17648,'TE','3304977215',0,'2014-01-14 01:32:39',NULL,NULL),(7616,4962,'AP','3182001638',0,'2013-12-25 22:46:11',NULL,NULL),(21943,14136,'TE','5043824886',0,'2013-12-27 02:02:31',NULL,NULL),(3402,2138,'AP','5132553458',0,'2013-12-25 19:18:10',NULL,NULL),(14065,9193,'EM','starfish1292@yahoo.com',0,'2013-12-26 04:09:27',NULL,NULL),(24796,15997,'TE','9368942030',0,'2014-01-04 02:01:23',NULL,NULL),(24576,15852,'EM','brightview2003@yahoo.com',0,'2014-01-03 02:04:28',NULL,NULL),(34572,22670,'TE','9362012187',0,'2014-02-11 21:00:41',NULL,NULL),(14677,9602,'AP','3306089711',0,'2013-12-26 04:37:27',NULL,NULL),(28618,18449,'AP','9373080679',0,'2014-01-16 08:46:07',NULL,NULL),(35374,23243,'EM','annettesaccount@yahoo.com',0,'2014-02-13 21:30:03',NULL,NULL),(7088,4628,'AP','6015739270',0,'2013-12-25 22:06:27',NULL,NULL),(33777,22167,'EM','hmkittle@yahoo.com',0,'2014-02-08 19:01:02',NULL,NULL),(30777,20007,'EM','grantantwon@yahoo.com',0,'2014-01-26 19:00:07',NULL,NULL),(12370,8098,'AP','3308583030',0,'2013-12-26 03:10:50',NULL,NULL),(25154,16215,'TE','6027316489',0,'2014-01-05 00:01:37',NULL,NULL),(4780,3059,'EM','pontious22@gmail.com',0,'2013-12-25 20:19:07',NULL,NULL),(10907,7087,'AP','3304193619',0,'2013-12-26 01:50:26',NULL,NULL),(2644,1608,'EM','LCCAMACHO74@YAHOO.COM',0,'2013-12-25 18:52:13',NULL,NULL),(12143,7932,'TE','5042619109',0,'2013-12-26 03:06:40',NULL,NULL),(38436,25401,'AP','3306318527',0,'2014-02-25 21:30:56',NULL,NULL),(42452,28200,'AP','8305137562',0,'2014-03-06 21:30:08',NULL,NULL),(26055,16783,'EM','donald606@sbcglobal.net',0,'2014-01-08 18:25:06',NULL,NULL),(32204,21034,'AP','9376580953',0,'2014-02-01 19:00:46',NULL,NULL),(1248,758,'AP','9792184769',0,'2013-12-25 18:04:30',NULL,NULL),(7213,4700,'AP','9373081184',0,'2013-12-25 22:08:23',NULL,NULL),(4680,2992,'TE','6143594959',0,'2013-12-25 20:17:28',NULL,NULL),(22124,14251,'EM','padams85@gmail.com',0,'2013-12-27 02:05:31',NULL,NULL),(41075,27285,'EM','maryleen@iglesiasegura.com',0,'2014-03-04 21:00:25',NULL,NULL),(41812,27798,'TE','3309201389',0,'2014-03-05 21:31:44',NULL,NULL),(10490,6833,'AP','4402518375',0,'2013-12-26 01:30:52',NULL,NULL),(23016,14844,'AP','4192068344',1,'2013-12-29 11:14:56',NULL,NULL),(5197,3341,'TE','5122191741',0,'2013-12-25 21:16:29',NULL,NULL),(30609,19864,'EM','johnbodeker@yahoo.com',0,'2014-01-24 21:00:38',NULL,NULL),(37362,24594,'EM','laksmith1@aol.com',0,'2014-02-20 04:11:46',NULL,NULL),(14350,9381,'TE','5043355904',0,'2013-12-26 04:32:06',NULL,NULL),(27903,17980,'TE','2342231922',0,'2014-01-15 02:06:52',NULL,NULL),(36750,24196,'TE','5135096642',0,'2014-02-16 19:00:16',NULL,NULL),(37449,24656,'TE','4195379346',0,'2014-02-20 04:24:30',NULL,NULL),(1131,695,'TE','2164708350',0,'2013-12-25 18:02:44',NULL,NULL),(25551,16481,'EM','claurianti@hotmail.com',0,'2014-01-07 04:06:17',NULL,NULL),(20661,13287,'TE','9564341072',0,'2013-12-26 12:57:22',NULL,NULL),(24129,15576,'AP','3304165910',1,'2014-01-02 04:32:02',NULL,NULL),(3145,1962,'AP','8176816774',0,'2013-12-25 19:01:15',NULL,NULL),(10562,6876,'TE','5136926018',0,'2013-12-26 01:32:08',NULL,NULL),(34208,22435,'TE','2105403210',0,'2014-02-10 21:30:38',NULL,NULL),(29413,19016,'TE','9857783909',0,'2014-01-20 08:06:22',NULL,NULL),(29223,18875,'TE','3378866027',0,'2014-01-17 03:36:26',NULL,NULL),(12151,7938,'AP','5042347304',0,'2013-12-26 03:06:48',NULL,NULL),(3603,2271,'EM','jzimmer9@icloud.com',0,'2013-12-25 19:30:24',NULL,NULL),(82,49,'TE','2673034299',0,'2013-12-25 17:16:20',NULL,NULL),(25516,16452,'EM','kdhpen@gmail.com',0,'2014-01-07 04:05:28',NULL,NULL),(24956,16084,'EM','jmforcier@gmail.com',0,'2014-01-04 02:04:13',NULL,NULL),(31428,20488,'TE','3305059404',0,'2014-01-29 21:01:05',NULL,NULL),(9323,6104,'EM','etacaroleharteis@att.net',0,'2013-12-26 00:15:17',NULL,NULL),(29694,19197,'TE','2147526736',0,'2014-01-21 08:46:14',NULL,NULL),(28239,18210,'TE','5136809761',0,'2014-01-15 02:08:09',NULL,NULL),(9224,6036,'AP','5049201740',0,'2013-12-26 00:01:17',NULL,NULL),(23905,15420,'TE','8306442040',1,'2014-01-02 04:27:27',NULL,NULL),(4128,2632,'AP','6142149109',0,'2013-12-25 19:46:09',NULL,NULL),(7050,4606,'AP','3306071173',0,'2013-12-25 22:05:50',NULL,NULL),(11505,7487,'TE','5133607430',0,'2013-12-26 02:31:31',NULL,NULL),(23491,15148,'AP','6145929616',0,'2014-01-01 12:05:59',NULL,NULL),(6140,3953,'AP','2097703999',0,'2013-12-25 21:38:13',NULL,NULL),(26374,16976,'AP','6013106684',0,'2014-01-13 02:20:16',NULL,NULL),(35630,23432,'TE','9796905135',0,'2014-02-13 22:01:27',NULL,NULL),(35049,23017,'TE','3183343454',0,'2014-02-12 21:30:27',NULL,NULL),(28943,18685,'TE','3182942584',0,'2014-01-17 03:35:22',NULL,NULL),(25006,16114,'EM','monahseals@gmail.com',0,'2014-01-04 02:05:13',NULL,NULL),(8355,5488,'EM','judyrichardsvisitingangels@yahoo.com',0,'2013-12-25 23:11:00',NULL,NULL),(9541,6246,'TE','6628036716',0,'2013-12-26 00:31:48',NULL,NULL),(24351,15727,'AP','5132541078',0,'2014-01-03 02:00:22',NULL,NULL),(11188,7275,'AP','9363320406',0,'2013-12-26 02:02:32',NULL,NULL),(11693,7613,'TE','7632426257',0,'2013-12-26 02:45:42',NULL,NULL),(20534,13216,'AP','2104164935',0,'2013-12-26 12:55:24',NULL,NULL),(14569,9520,'AP','4199663314',0,'2013-12-26 04:35:38',NULL,NULL),(21600,13901,'EM','cindyderian@yahoo.com',0,'2013-12-26 13:13:42',NULL,NULL),(39442,26087,'TE','9197247867',0,'2014-02-28 06:30:06',NULL,NULL),(24519,15815,'TE','6146033737',0,'2014-01-03 02:03:21',NULL,NULL),(10479,6828,'TE','2163820156',0,'2013-12-26 01:30:42',NULL,NULL),(23903,15418,'TE','8303192910',1,'2014-01-02 04:27:24',NULL,NULL),(28655,18482,'TE','3306706197',0,'2014-01-16 08:46:21',NULL,NULL),(36848,24264,'EM','charles.nelson2112@gmail.com',0,'2014-02-17 19:00:13',NULL,NULL),(38125,25165,'TE','9375416238',0,'2014-02-21 22:00:25',NULL,NULL),(43302,28768,'AP','4192467197',0,'2014-03-09 21:00:27',NULL,NULL),(22439,14472,'TE','9564558514',0,'2013-12-28 03:33:03',NULL,NULL),(6890,4479,'TE','4196568611',0,'2013-12-25 22:02:56',NULL,NULL),(34395,22562,'AP','5134393335',0,'2014-02-10 21:31:52',NULL,NULL),(5206,3345,'AP','9364433679',0,'2013-12-25 21:16:36',NULL,NULL),(29704,19205,'EM','joeymcskweeb@yahoo.com',0,'2014-01-21 08:46:18',NULL,NULL),(28383,18286,'AP','3306221391',0,'2014-01-16 08:44:50',NULL,NULL),(37614,24788,'AP','5132844411',0,'2014-02-20 04:46:42',NULL,NULL),(41804,27790,'AP','6627640042',0,'2014-03-05 21:31:40',NULL,NULL),(8193,5362,'TE','9376946458',0,'2013-12-25 23:07:53',NULL,NULL),(5119,3279,'AP','4806210880',0,'2013-12-25 21:15:14',NULL,NULL),(6039,3879,'AP','8325631044',0,'2013-12-25 21:36:24',NULL,NULL),(8702,5710,'TE','3303280576',0,'2013-12-25 23:45:08',NULL,NULL),(31545,20561,'TE','2063712112',0,'2014-01-29 21:01:46',NULL,NULL),(30172,19548,'TE','4192157661',0,'2014-01-23 03:02:28',NULL,NULL),(28117,18123,'TE','4403764929',0,'2014-01-15 02:07:41',NULL,NULL),(12343,8072,'TE','4196293307',0,'2013-12-26 03:10:16',NULL,NULL),(25433,16401,'EM','zgolman@gmail.com',0,'2014-01-07 04:03:54',NULL,NULL),(721,448,'TE','5134046948',0,'2013-12-25 17:47:21',NULL,NULL),(2358,1433,'AP','5049313982',0,'2013-12-25 18:47:38',NULL,NULL),(30332,19649,'AP','4192100885',0,'2014-01-23 21:00:19',NULL,NULL),(8922,5839,'EM','blubecky@yahoo.com',0,'2013-12-25 23:48:31',NULL,NULL),(24475,15794,'AP','5048354833',0,'2014-01-03 02:02:38',NULL,NULL),(39168,25908,'TE','8069972173',0,'2014-02-26 21:01:12',NULL,NULL),(22145,14262,'EM','micahbeach99@yahoo.com',0,'2013-12-27 02:05:51',NULL,NULL),(32875,21515,'EM','washock.joseph9@gmail.com',0,'2014-02-05 21:00:04',NULL,NULL),(28824,18605,'TE','5138315417',0,'2014-01-16 08:47:21',NULL,NULL),(1124,690,'EM','EZ2LUVMK@YAHOO.COM',0,'2013-12-25 18:02:37',NULL,NULL),(24201,15634,'EM','carrierobideaux@myway.com',1,'2014-01-02 04:33:35',NULL,NULL),(4811,3076,'EM','Lisa4368@gmail.com',0,'2013-12-25 20:19:36',NULL,NULL),(36041,23708,'TE','5134847251',0,'2014-02-14 21:30:45',NULL,NULL),(36726,24182,'EM','dollarbill56@roadrunner.com',0,'2014-02-16 19:00:08',NULL,NULL),(39525,26144,'TE','2052186070',0,'2014-02-28 06:30:27',NULL,NULL),(40826,27131,'EM','bstewart0988@gmail.com',0,'2014-03-03 21:30:40',NULL,NULL),(1169,717,'EM','amber_thatcher07@yahoo.com',0,'2013-12-25 18:03:21',NULL,NULL),(1288,784,'AP','5124269120',0,'2013-12-25 18:05:08',NULL,NULL),(22850,14744,'AP','3309513774',1,'2013-12-29 11:10:08',NULL,NULL),(23081,14887,'EM','alexandermackfleming1974@gmail.com',0,'2013-12-30 00:00:41',NULL,NULL),(28456,18337,'EM','sandlin45133@gmail.com',0,'2014-01-16 08:45:15',NULL,NULL),(28055,18080,'EM','lenettecharles@yahoo.com',0,'2014-01-15 02:07:27',NULL,NULL),(25629,16527,'EM','agclarkrn@gmail.com',1,'2014-01-07 10:21:58',NULL,NULL),(23530,15184,'TE','4198783615',0,'2014-01-01 12:06:55',NULL,NULL),(40152,26629,'TE','9155198655',0,'2014-02-28 21:30:56',NULL,NULL),(40846,27142,'TE','5137246030',0,'2014-03-03 21:30:47',NULL,NULL),(20613,13256,'AP','9033882281',0,'2013-12-26 12:56:33',NULL,NULL),(31974,20877,'TE','3183509572',0,'2014-01-31 21:01:06',NULL,NULL),(29861,19320,'TE','9792000469',1,'2014-01-22 03:22:11',NULL,NULL),(3371,2117,'TE','9374642012',0,'2013-12-25 19:17:38',NULL,NULL),(26623,17129,'TE','2163280944',0,'2014-01-13 02:21:46',NULL,NULL),(25881,16684,'EM','b00psie1@aol.com',0,'2014-01-08 18:24:32',NULL,NULL),(23860,15398,'TE','4694508157',1,'2014-01-02 04:26:42',NULL,NULL),(6054,3889,'TE','3309669717',0,'2013-12-25 21:36:39',NULL,NULL),(1628,1000,'TE','5136330255',0,'2013-12-25 18:10:55',NULL,NULL),(38156,25184,'TE','5135784368',0,'2014-02-21 22:00:36',NULL,NULL),(10007,6547,'EM','beth@edlerlawoffice.com',0,'2013-12-26 00:52:05',NULL,NULL),(22035,14191,'AP','2817964183',0,'2013-12-27 02:04:00',NULL,NULL),(33486,21943,'AP','8062750302',0,'2014-02-07 19:00:16',NULL,NULL),(32901,21541,'TE','2163200958',0,'2014-02-05 21:30:09',NULL,NULL),(2188,1345,'AP','2148934640',0,'2013-12-25 18:45:06',NULL,NULL),(8931,5848,'AP','9792200503',0,'2013-12-25 23:48:42',NULL,NULL),(27844,17938,'AP','2146428639',0,'2014-01-15 02:06:38',NULL,NULL),(7195,4687,'EM','Mitchell002@frontier.com',0,'2013-12-25 22:08:05',NULL,NULL),(43517,28895,'EM','d-sei@hotmail.com',0,'2014-03-10 21:00:17',NULL,NULL),(11864,7724,'TE','2169321571',0,'2013-12-26 03:01:49',NULL,NULL),(30779,20009,'EM','ashkate1953@gmail.com',0,'2014-01-26 19:00:08',NULL,NULL),(7385,4806,'TE','5138912709',0,'2013-12-25 22:16:39',NULL,NULL),(29331,18953,'AP','8326337271',0,'2014-01-20 08:05:51',NULL,NULL),(3640,2304,'TE','9376043293',0,'2013-12-25 19:31:03',NULL,NULL),(24406,15759,'TE','4324381455',0,'2014-01-03 02:01:25',NULL,NULL),(24721,15948,'TE','9378453329',0,'2014-01-03 02:07:27',NULL,NULL),(40048,26551,'TE','6148799609',0,'2014-02-28 21:30:13',NULL,NULL),(43404,28825,'TE','4193464777',0,'2014-03-09 21:01:03',NULL,NULL),(21455,13789,'EM','smithcasenna@gmail.com',0,'2013-12-26 13:11:01',NULL,NULL),(33780,22168,'BN','4192035892',0,'2014-02-08 19:01:03',NULL,NULL),(472,297,'TE','2169415331',0,'2013-12-25 17:30:44',NULL,NULL),(5100,3272,'TE','4197891521',0,'2013-12-25 20:47:14',NULL,NULL),(1221,743,'TE','9724679206',0,'2013-12-25 18:04:07',NULL,NULL),(25222,16263,'EM','dcaddell2@cinci.rr.com',0,'2014-01-07 04:00:04',NULL,NULL),(5224,3356,'EM','amyharless25@yahoo.com',0,'2013-12-25 21:16:53',NULL,NULL),(4471,2847,'AP','8324430906',0,'2013-12-25 20:01:15',NULL,NULL),(41802,27789,'TE','6017224362',0,'2014-03-05 21:31:39',NULL,NULL),(43281,28756,'AP','2819007483',0,'2014-03-09 21:00:19',NULL,NULL),(43325,28779,'EM','samuelgyampo.ayete1@gmail.com',0,'2014-03-09 21:00:35',NULL,NULL),(368,225,'TE','9857094325',0,'2013-12-25 17:20:53',NULL,NULL),(3822,2431,'AP','3308153069',0,'2013-12-25 19:34:11',NULL,NULL),(33047,21650,'TE','9852050448',0,'2014-02-05 21:30:49',NULL,NULL),(3029,1886,'AP','2163371531',0,'2013-12-25 18:58:42',NULL,NULL),(32223,21047,'TE','9156943247',0,'2014-02-02 19:00:04',NULL,NULL),(31511,20532,'AP','6016658383',0,'2014-01-29 21:01:31',NULL,NULL),(1627,999,'AP','5124198645',0,'2013-12-25 18:10:53',NULL,NULL),(8372,5502,'TE','9375842874',0,'2013-12-25 23:11:22',NULL,NULL),(37226,24498,'AP','8178745982',0,'2014-02-20 03:48:03',NULL,NULL),(37717,24868,'TE','6149211523',0,'2014-02-20 05:32:41',NULL,NULL),(39774,26300,'EM','aplummer24@live.com',0,'2014-02-28 06:31:28',NULL,NULL),(42451,28200,'TE','8305137562',0,'2014-03-06 21:30:08',NULL,NULL),(600,371,'TE','9032151343',0,'2013-12-25 17:45:27',NULL,NULL),(34462,22611,'EM','NHOQUELLC@YAHOO.COM',0,'2014-02-11 21:00:05',NULL,NULL),(9092,5957,'EM','alanronda0351@gmail.com',0,'2013-12-25 23:51:18',NULL,NULL),(1585,978,'TE','4198992505',0,'2013-12-25 18:10:13',NULL,NULL),(23387,15063,'TE','3186804870',0,'2014-01-01 12:03:40',NULL,NULL),(20259,13056,'TE','5138631481',0,'2013-12-26 12:50:57',NULL,NULL),(36228,23844,'TE','4196779676',0,'2014-02-14 21:31:54',NULL,NULL),(41482,27575,'EM','lovivo@live.com',0,'2014-03-04 21:30:22',NULL,NULL),(12193,7968,'TE','6015736651',0,'2013-12-26 03:07:36',NULL,NULL),(31765,20735,'TE','3304790609',0,'2014-01-30 21:01:21',NULL,NULL),(7257,4733,'TE','4193712575',0,'2013-12-25 22:09:12',NULL,NULL),(27611,17800,'BN','9372189155',0,'2014-01-14 01:33:53',NULL,NULL),(27455,17686,'EM','kimmiesmithmakeup@yahoo.com',0,'2014-01-14 01:32:57',NULL,NULL),(26269,16905,'TE','5132070946',0,'2014-01-13 02:19:35',NULL,NULL),(26018,16764,'TE','4135303284',0,'2014-01-08 18:24:59',NULL,NULL),(4703,3008,'AP','3309968610',0,'2013-12-25 20:17:51',NULL,NULL),(35328,23213,'EM','looknaroundus@yahoo.com',0,'2014-02-12 21:32:14',NULL,NULL),(1855,1146,'EM','rlaurie6592@gmail.com',0,'2013-12-25 18:18:29',NULL,NULL),(34528,22650,'EM','anniebez@aol.com',0,'2014-02-11 21:00:27',NULL,NULL),(31990,20887,'TE','5133767751',0,'2014-01-31 21:01:12',NULL,NULL),(31433,20490,'AP','5045541151',0,'2014-01-29 21:01:06',NULL,NULL),(29536,19090,'EM','ARTLANFLORIST@YAHOO.COM',0,'2014-01-21 08:44:32',NULL,NULL),(35343,23224,'EM','cakunne@gmail.com',0,'2014-02-12 21:32:21',NULL,NULL),(36095,23740,'EM','sugarinccupcakes@yahoo.com',0,'2014-02-14 21:31:03',NULL,NULL),(38569,25491,'EM','crimestopperlady@comcast.net',0,'2014-02-25 21:31:47',NULL,NULL),(10943,7113,'TE','2254540126',0,'2013-12-26 01:51:07',NULL,NULL),(12242,8004,'EM','kahroleenah@aol.com',0,'2013-12-26 03:08:28',NULL,NULL),(9661,6324,'EM','edwardfirm@att.net',0,'2013-12-26 00:46:27',NULL,NULL),(14352,9381,'EM','writing@bridgetcoila.com',0,'2013-12-26 04:32:06',NULL,NULL),(8735,5728,'TE','2252357417',0,'2013-12-25 23:45:37',NULL,NULL),(20953,13477,'AP','3307548378',0,'2013-12-26 13:02:10',NULL,NULL),(14583,9535,'AP','3302843135',0,'2013-12-26 04:35:54',NULL,NULL),(4134,2637,'AP','3309980303',0,'2013-12-25 19:46:15',NULL,NULL),(36353,23942,'AP','6143525610',0,'2014-02-15 21:00:09',NULL,NULL),(38084,25140,'TE','2103098177',0,'2014-02-21 22:00:10',NULL,NULL),(38959,25758,'TE','5136249743',0,'2014-02-26 09:30:50',NULL,NULL),(40376,26800,'EM','MEBERLE1@WOH.RR.COM',0,'2014-03-01 21:00:23',NULL,NULL),(7232,4709,'EM','tephrosia@hotmail.com',0,'2013-12-25 22:08:40',NULL,NULL),(34284,22493,'AP','5134045817',0,'2014-02-10 21:31:09',NULL,NULL),(31543,20558,'EM','CJJ.Pburg@Gmail.Com',0,'2014-01-29 21:01:45',NULL,NULL),(26455,17031,'TE','4193467456',0,'2014-01-13 02:20:44',NULL,NULL),(10980,7134,'AP','7033035994',0,'2013-12-26 01:51:42',NULL,NULL),(1527,939,'AP','5134007013',0,'2013-12-25 18:09:17',NULL,NULL),(5277,3387,'TE','3373486992',0,'2013-12-25 21:17:42',NULL,NULL),(10144,6631,'TE','9377701502',0,'2013-12-26 00:54:21',NULL,NULL),(37854,24973,'TE','9799974088',0,'2014-02-20 22:00:28',NULL,NULL),(3758,2384,'TE','7403577858',0,'2013-12-25 19:33:06',NULL,NULL),(29615,19133,'EM','j.m.barnes@live.com',0,'2014-01-21 08:45:25',NULL,NULL),(25781,16613,'TE','4403464307',0,'2014-01-08 18:24:09',NULL,NULL),(22658,14609,'TE','3306052928',0,'2013-12-28 03:36:37',NULL,NULL),(25390,16376,'TE','9565456531',0,'2014-01-07 04:03:10',NULL,NULL),(7135,4654,'EM','lavis.william@gmail.com',0,'2013-12-25 22:07:12',NULL,NULL),(21490,13809,'AP','4403394917',0,'2013-12-26 13:11:35',NULL,NULL),(20666,13288,'EM','rf_lewis@yahoo.com',0,'2013-12-26 12:57:25',NULL,NULL),(24506,15808,'TE','2259630560',0,'2014-01-03 02:03:07',NULL,NULL),(36098,23743,'TE','3152819253',0,'2014-02-14 21:31:05',NULL,NULL),(38527,25460,'AP','8062238123',0,'2014-02-25 21:31:31',NULL,NULL),(1543,949,'AP','5132066430',0,'2013-12-25 18:09:31',NULL,NULL),(26200,16863,'AP','8705577123',0,'2014-01-13 02:19:11',NULL,NULL),(6429,4154,'TE','2163147791',0,'2013-12-25 21:48:51',NULL,NULL),(32763,21433,'AP','9362399052',0,'2014-02-04 21:01:20',NULL,NULL),(31978,20879,'TE','4193480008',0,'2014-01-31 21:01:07',NULL,NULL),(10559,6874,'EM','laquivia08@gmail.com',0,'2013-12-26 01:32:04',NULL,NULL),(10710,6963,'AP','6144837296',0,'2013-12-26 01:47:19',NULL,NULL),(43044,28618,'AP','8307435099',0,'2014-03-08 21:30:19',NULL,NULL),(11122,7232,'TE','7402851792',0,'2013-12-26 02:01:24',NULL,NULL),(11916,7757,'TE','6146345319',0,'2013-12-26 03:02:40',NULL,NULL),(41907,27864,'TE','3303224227',0,'2014-03-05 21:32:21',NULL,NULL),(21707,13977,'EM','hmfic@fuse.net',0,'2013-12-26 13:15:32',NULL,NULL),(33646,22067,'TE','4045474579',0,'2014-02-08 19:00:12',NULL,NULL),(33612,22043,'TE','5618278491',0,'2014-02-07 19:01:10',NULL,NULL),(10129,6622,'EM','colemanr88@gmail.com',0,'2013-12-26 00:54:06',NULL,NULL),(31718,20700,'TE','2252441907',0,'2014-01-30 21:01:03',NULL,NULL),(8986,5893,'EM','lance@vcc.tv',0,'2013-12-25 23:49:41',NULL,NULL),(1943,1203,'AP','2163960222',0,'2013-12-25 18:19:55',NULL,NULL),(390,237,'EM','riec6279@hotmail.com',0,'2013-12-25 17:21:13',NULL,NULL),(1921,1191,'AP','2163722136',0,'2013-12-25 18:19:36',NULL,NULL),(3250,2046,'AP','4322584776',0,'2013-12-25 19:15:43',NULL,NULL),(22383,14438,'AP','3373086300',0,'2013-12-28 03:32:07',NULL,NULL),(36249,23856,'TE','8162239657',0,'2014-02-14 21:32:01',NULL,NULL),(36773,24213,'EM','lizagarcia_09@yahoo.com',0,'2014-02-16 19:00:25',NULL,NULL),(37001,24365,'TE','5049429397',0,'2014-02-18 22:00:34',NULL,NULL),(42103,27973,'AP','2254853693',0,'2014-03-06 21:00:52',NULL,NULL),(43505,28887,'TE','2145331904',0,'2014-03-10 21:00:13',NULL,NULL),(24649,15892,'EM','arrozack@googlemail.com',0,'2014-01-03 02:05:48',NULL,NULL),(29487,19058,'EM','lawandarylas@gmail.com',0,'2014-01-21 08:44:13',NULL,NULL),(29483,19057,'TE','6017096957',0,'2014-01-21 08:44:12',NULL,NULL),(29460,19047,'AP','4194507822',0,'2014-01-20 08:06:41',NULL,NULL),(3726,2364,'TE','7402649753',0,'2013-12-25 19:32:35',NULL,NULL),(3088,1929,'AP','5127397728',0,'2013-12-25 19:00:20',NULL,NULL),(36198,23828,'AP','6015730792',0,'2014-02-14 21:31:44',NULL,NULL),(40436,26843,'EM','pattytrice@cox.net',0,'2014-03-01 21:00:46',NULL,NULL),(25562,16489,'AP','4192245256',0,'2014-01-07 04:06:31',NULL,NULL),(31463,20505,'EM','reuben110@hotmail.com',0,'2014-01-29 21:01:15',NULL,NULL),(30647,19891,'TE','4192965608',0,'2014-01-24 21:00:51',NULL,NULL),(11024,7156,'AP','4193516600',0,'2013-12-26 01:52:20',NULL,NULL),(11062,7182,'EM','kinyoabdo@gmail.com',0,'2013-12-26 02:00:15',NULL,NULL),(21716,13988,'AP','4198720033',0,'2013-12-26 13:15:44',NULL,NULL),(40922,27193,'TE','5123005654',0,'2014-03-03 21:31:17',NULL,NULL),(43072,28636,'TE','9034450304',0,'2014-03-08 21:30:29',NULL,NULL),(409,250,'EM','belleslane@aol.com',0,'2013-12-25 17:21:34',NULL,NULL),(24299,15699,'EM','LEM54@YAHOO.COM',1,'2014-01-02 04:35:39',NULL,NULL),(8214,5377,'EM','ramonametts@yahoo.com',0,'2013-12-25 23:08:15',NULL,NULL),(9619,6294,'AP','4405211621',0,'2013-12-26 00:45:45',NULL,NULL),(3930,2492,'TE','5043003205',0,'2013-12-25 19:35:50',NULL,NULL),(14324,9366,'AP','5044915048',0,'2013-12-26 04:31:41',NULL,NULL),(41385,27494,'EM','bigmac58rm@gmail.com',0,'2014-03-04 21:02:24',NULL,NULL),(43740,29037,'TE','4405394883',0,'2014-03-10 21:01:39',NULL,NULL),(43993,29185,'EM','cat3kids@yahoo.com',0,'2014-03-10 21:30:01',NULL,NULL),(21544,13849,'AP','4193670523',0,'2013-12-26 13:12:34',NULL,NULL),(12022,7838,'EM','missyandtonyt@gmail.com',0,'2013-12-26 03:04:33',NULL,NULL),(10687,6946,'AP','9377166872',0,'2013-12-26 01:46:55',NULL,NULL),(30682,19931,'TE','9375443729',0,'2014-01-24 21:01:09',NULL,NULL),(9783,6402,'TE','3175860548',0,'2013-12-26 00:48:23',NULL,NULL),(9249,6051,'AP','9375729949',0,'2013-12-26 00:01:42',NULL,NULL),(8808,5768,'EM','kareemw908@gmail.com',0,'2013-12-25 23:46:43',NULL,NULL),(2233,1371,'AP','6467340426',0,'2013-12-25 18:45:47',NULL,NULL),(2645,1609,'TE','3615503199',0,'2013-12-25 18:52:14',NULL,NULL),(35877,23593,'TE','3302899696',0,'2014-02-13 22:03:03',NULL,NULL),(38331,25323,'TE','7137540338',0,'2014-02-25 21:30:11',NULL,NULL),(43388,28817,'AP','3304313747',0,'2014-03-09 21:00:57',NULL,NULL),(2483,1524,'EM','robert.warner@ymail.com',0,'2013-12-25 18:49:51',NULL,NULL),(9505,6221,'TE','5135199270',0,'2013-12-26 00:31:10',NULL,NULL),(34856,22857,'EM','Mswisher@amplex.net',0,'2014-02-11 21:02:24',NULL,NULL),(5605,3588,'TE','4408358394',0,'2013-12-25 21:22:56',NULL,NULL),(33397,21885,'TE','5045794839',0,'2014-02-06 21:01:33',NULL,NULL),(43654,28973,'TE','2256203091',0,'2014-03-10 21:01:04',NULL,NULL),(22060,14207,'AP','4325287773',0,'2013-12-27 02:04:24',NULL,NULL),(25522,16457,'TE','5132536620',0,'2014-01-07 04:05:38',NULL,NULL),(14121,9237,'AP','4403088166',0,'2013-12-26 04:10:37',NULL,NULL),(29324,18950,'AP','8172336679',0,'2014-01-20 08:05:49',NULL,NULL),(33294,21801,'EM','peterulrick@yahoo.com',0,'2014-02-06 21:00:50',NULL,NULL),(36542,24061,'TE','2166825104',0,'2014-02-15 22:01:09',NULL,NULL),(25807,16632,'TE','9377184340',0,'2014-01-08 18:24:15',NULL,NULL),(35636,23434,'AP','9562437837',0,'2014-02-13 22:01:29',NULL,NULL),(20220,13025,'AP','2165981642',0,'2013-12-26 12:50:12',NULL,NULL),(21710,13982,'TE','6309450152',0,'2013-12-26 13:15:36',NULL,NULL),(28161,18152,'AP','4197222618',0,'2014-01-15 02:07:51',NULL,NULL),(21937,14131,'TE','3182403848',0,'2013-12-27 02:02:24',NULL,NULL),(5135,3290,'TE','4409541033',0,'2013-12-25 21:15:30',NULL,NULL),(40516,26892,'AP','9372123914',0,'2014-03-03 01:00:03',NULL,NULL),(310,190,'EM','dallen555@att.net',0,'2013-12-25 17:19:57',NULL,NULL),(20715,13315,'AP','8172792937',0,'2013-12-26 12:58:12',NULL,NULL),(31217,20331,'AP','5136082443',0,'2014-01-28 21:01:02',NULL,NULL),(26108,16812,'AP','9562159876',0,'2014-01-13 02:18:17',NULL,NULL),(28174,18159,'BN','9372078115',0,'2014-01-15 02:07:53',NULL,NULL),(38552,25473,'AP','9155024050',0,'2014-02-25 21:31:39',NULL,NULL),(23869,15403,'TE','4147912843',1,'2014-01-02 04:26:52',NULL,NULL),(25388,16375,'AP','4322026328',0,'2014-01-07 04:03:08',NULL,NULL),(34357,22537,'TE','8503461735',0,'2014-02-10 21:31:36',NULL,NULL),(20356,13112,'TE','2162804938',0,'2013-12-26 12:52:31',NULL,NULL),(9122,5975,'TE','3305750409',0,'2013-12-25 23:51:47',NULL,NULL),(725,456,'TE','4199662089',0,'2013-12-25 17:47:29',NULL,NULL),(8054,5275,'TE','3307035325',0,'2013-12-25 23:05:38',NULL,NULL),(20992,13509,'AP','5044327584',0,'2013-12-26 13:02:51',NULL,NULL),(3518,2199,'AP','9377269334',0,'2013-12-25 19:19:59',NULL,NULL),(3027,1885,'EM','davidsartin.sartin@gmail.com',0,'2013-12-25 18:58:39',NULL,NULL),(39062,25837,'AP','4195600441',0,'2014-02-26 21:00:33',NULL,NULL),(40456,26857,'TE','9372170522',0,'2014-03-01 21:00:54',NULL,NULL),(20529,13213,'EM','mares-1992@hotmail.com',0,'2013-12-26 12:55:20',NULL,NULL),(33093,21678,'AP','2252889935',0,'2014-02-05 21:31:01',NULL,NULL),(8176,5348,'TE','3307230070',0,'2013-12-25 23:07:34',NULL,NULL),(29607,19130,'AP','5042088600',0,'2014-01-21 08:45:23',NULL,NULL),(29076,18781,'TE','4193049640',0,'2014-01-17 03:35:52',NULL,NULL),(5551,3544,'EM','wolcottsmith@yahoo.com',0,'2013-12-25 21:21:54',NULL,NULL),(27586,17783,'EM','keithdietrich@hotmail.com',0,'2014-01-14 01:33:44',NULL,NULL),(26830,17256,'EM','hls121457@gmail.com',0,'2014-01-13 02:23:15',NULL,NULL),(40396,26813,'TE','4198748473',0,'2014-03-01 21:00:30',NULL,NULL),(25168,16226,'AP','9379018325',0,'2014-01-05 00:01:57',NULL,NULL),(34558,22664,'TE','9722016039',0,'2014-02-11 21:00:37',NULL,NULL),(25049,16146,'TE','5133017835',0,'2014-01-04 02:06:09',NULL,NULL),(11025,7156,'EM','jh-glass@att.net',0,'2013-12-26 01:52:20',NULL,NULL),(799,497,'AP','3184232280',0,'2013-12-25 17:48:35',NULL,NULL),(9770,6387,'EM','snommitmot@aol.com',0,'2013-12-26 00:48:06',NULL,NULL),(12059,7872,'EM','kris92750@gmail.com',0,'2013-12-26 03:05:13',NULL,NULL),(11687,7609,'TE','8605598271',0,'2013-12-26 02:45:36',NULL,NULL),(21825,14061,'AP','2162551124',0,'2013-12-27 02:00:35',NULL,NULL),(34244,22460,'TE','9035690131',0,'2014-02-10 21:30:52',NULL,NULL),(33666,22083,'TE','3184654387',0,'2014-02-08 19:00:20',NULL,NULL),(26185,16856,'EM','carolyngreen64@ymail.com',0,'2014-01-13 02:19:07',NULL,NULL),(9558,6254,'EM','SHIRSCHFELD@ONEHOMEFINDER.COM',0,'2013-12-26 00:32:04',NULL,NULL),(36252,23857,'TE','2148092722',0,'2014-02-14 21:32:02',NULL,NULL),(36125,23776,'AP','7039450156',0,'2014-02-14 21:31:16',NULL,NULL),(28397,18296,'AP','5138271184',0,'2014-01-16 08:44:55',NULL,NULL),(28317,18252,'TE','9034950271',0,'2014-01-16 08:44:31',NULL,NULL),(27532,17742,'TE','3303251861',0,'2014-01-14 01:33:23',NULL,NULL),(8634,5669,'EM','vickijowilson2002@yahoo.com',0,'2013-12-25 23:32:02',NULL,NULL),(11577,7533,'TE','4077905835',0,'2013-12-26 02:32:44',NULL,NULL),(11579,7533,'EM','islam.sharmin@austincc.edu',0,'2013-12-26 02:32:45',NULL,NULL),(507,319,'TE','3372127216',0,'2013-12-25 17:31:18',NULL,NULL),(1546,951,'TE','4404947115',0,'2013-12-25 18:09:35',NULL,NULL),(21855,14076,'EM','dionnepope1@gmail.com',0,'2013-12-27 02:01:01',NULL,NULL),(21165,13614,'EM','ginahuffman@gmail.com',0,'2013-12-26 13:05:41',NULL,NULL),(5858,3759,'TE','3306072315',0,'2013-12-25 21:33:23',NULL,NULL),(6146,3957,'AP','3306222919',0,'2013-12-25 21:38:20',NULL,NULL),(27506,17722,'TE','3307306333',0,'2014-01-14 01:33:14',NULL,NULL),(29746,19234,'TE','3309333515',0,'2014-01-21 08:46:34',NULL,NULL),(12348,8079,'TE','5133851533',0,'2013-12-26 03:10:25',NULL,NULL),(28335,18260,'TE','8069285535',0,'2014-01-16 08:44:36',NULL,NULL),(31924,20840,'AP','3303484075',0,'2014-01-31 21:00:46',NULL,NULL),(34494,22629,'TE','8325004694',0,'2014-02-11 21:00:16',NULL,NULL),(13697,8929,'AP','7404121669',0,'2013-12-26 04:02:59',NULL,NULL),(35697,23480,'TE','3372980103',0,'2014-02-13 22:01:54',NULL,NULL),(24938,16076,'TE','9373691492',0,'2014-01-04 02:03:57',NULL,NULL),(39473,26102,'AP','5044002458',0,'2014-02-28 06:30:13',NULL,NULL),(21548,13856,'TE','5137200602',0,'2013-12-26 13:12:41',NULL,NULL),(22042,14195,'TE','2548833343',0,'2013-12-27 02:04:07',NULL,NULL),(38423,25388,'AP','3308199262',0,'2014-02-25 21:30:50',NULL,NULL),(39113,25874,'AP','5049154781',0,'2014-02-26 21:00:53',NULL,NULL),(8736,5728,'AP','2252357417',0,'2013-12-25 23:45:37',NULL,NULL),(20210,13021,'AP','7248541031',0,'2013-12-26 12:50:04',NULL,NULL),(43762,29052,'TE','4196997558',0,'2014-03-10 21:01:47',NULL,NULL),(106,64,'TE','2166475041',0,'2013-12-25 17:16:43',NULL,NULL),(9520,6231,'TE','2107235660',0,'2013-12-26 00:31:27',NULL,NULL),(35718,23490,'TE','4197383129',0,'2014-02-13 22:02:02',NULL,NULL),(35055,23019,'AP','5044518889',0,'2014-02-12 21:30:29',NULL,NULL),(21835,14067,'TE','9373217267',0,'2013-12-27 02:00:44',NULL,NULL),(8779,5752,'EM','duanejohnson02@yahoo.com',0,'2013-12-25 23:46:16',NULL,NULL),(10394,6776,'TE','7409778111',0,'2013-12-26 01:16:43',NULL,NULL),(11266,7341,'AP','3306067567',0,'2013-12-26 02:04:02',NULL,NULL),(5571,3558,'EM','sallred10@mail.bw.edu',0,'2013-12-25 21:22:14',NULL,NULL),(2411,1469,'TE','5312219035',0,'2013-12-25 18:48:32',NULL,NULL),(999,614,'AP','5137450358',0,'2013-12-25 18:00:40',NULL,NULL),(14558,9512,'EM','caroline.thompson.oh@gmail.com',0,'2013-12-26 04:35:26',NULL,NULL),(29241,18888,'TE','3308964316',0,'2014-01-17 03:36:31',NULL,NULL),(43137,28674,'AP','4199446109',0,'2014-03-08 21:30:51',NULL,NULL),(30745,19977,'TE','4195624362',0,'2014-01-25 19:00:14',NULL,NULL),(10769,7001,'EM','rcruz.87@live.com',0,'2013-12-26 01:48:16',NULL,NULL),(13622,8880,'EM','connierc22@yahoo.com',0,'2013-12-26 04:01:47',NULL,NULL),(13626,8885,'EM','bet1515.bt@gmail.com',0,'2013-12-26 04:01:52',NULL,NULL),(14013,9149,'EM','wyantsmiling@gmail.com',0,'2013-12-26 04:08:24',NULL,NULL),(5723,3671,'EM','kjustin@live.com',0,'2013-12-25 21:31:10',NULL,NULL),(38747,25617,'TE','8325746299',0,'2014-02-26 08:30:13',NULL,NULL),(40930,27198,'TE','5128263489',0,'2014-03-03 21:31:20',NULL,NULL),(41398,27502,'AP','4193604463',0,'2014-03-04 21:02:28',NULL,NULL),(28442,18325,'TE','3306877759',0,'2014-01-16 08:45:09',NULL,NULL),(28546,18403,'AP','5137025258',0,'2014-01-16 08:45:44',NULL,NULL),(34915,22910,'AP','5136586453',0,'2014-02-11 21:02:48',NULL,NULL),(32977,21586,'TE','7406856566',0,'2014-02-05 21:30:28',NULL,NULL),(32817,21471,'AP','4233123684',0,'2014-02-04 21:01:39',NULL,NULL),(7204,4693,'TE','9375458501',0,'2013-12-25 22:08:15',NULL,NULL),(6186,3987,'TE','4192274377',0,'2013-12-25 21:38:59',NULL,NULL),(4791,3064,'EM','viviancole4@aol.com',0,'2013-12-25 20:19:16',NULL,NULL),(42685,28396,'EM','khatfield27@yahoo.com',0,'2014-03-07 21:30:47',NULL,NULL),(42760,28442,'TE','5072927661',0,'2014-03-07 21:31:14',NULL,NULL),(9802,6414,'TE','5132565258',0,'2013-12-26 00:48:42',NULL,NULL),(8204,5370,'EM','zerocost@roadrunner.com',0,'2013-12-25 23:08:04',NULL,NULL),(20605,13252,'EM','vrq353@peoplepc.com',0,'2013-12-26 12:56:26',NULL,NULL),(4428,2823,'AP','5136072829',0,'2013-12-25 20:00:33',NULL,NULL),(33834,22213,'EM','RENATE.B@AOL.COM',0,'2014-02-09 19:00:22',NULL,NULL),(4862,3112,'TE','2144138801',0,'2013-12-25 20:30:03',NULL,NULL),(27781,17910,'TE','9563697515',0,'2014-01-15 02:06:26',NULL,NULL),(6731,4373,'TE','4407298028',0,'2013-12-25 22:00:22',NULL,NULL),(35440,23302,'TE','5138437755',0,'2014-02-13 22:00:15',NULL,NULL),(38904,25717,'AP','2545926870',0,'2014-02-26 09:30:26',NULL,NULL),(40489,26873,'TE','3306641656',0,'2014-03-01 21:01:04',NULL,NULL),(41725,27746,'TE','4198933619',0,'2014-03-05 21:31:12',NULL,NULL),(43848,29100,'TE','9374422049',0,'2014-03-10 21:02:16',NULL,NULL),(27125,17462,'EM','slglick04@gmail.com',0,'2014-01-13 03:00:43',NULL,NULL),(28432,18318,'TE','7406072359',0,'2014-01-16 08:45:06',NULL,NULL),(11168,7265,'TE','5128592542',0,'2013-12-26 02:02:14',NULL,NULL),(12224,7989,'TE','3303389676',0,'2013-12-26 03:08:08',NULL,NULL),(8034,5254,'EM','haffnerjf@aol.com',0,'2013-12-25 23:05:14',NULL,NULL),(30673,19917,'EM','Christina.wreyford@gmail.com',0,'2014-01-24 21:01:03',NULL,NULL),(24785,15987,'AP','8303773616',0,'2014-01-04 02:01:09',NULL,NULL),(41720,27741,'AP','3615421213',0,'2014-03-05 21:31:09',NULL,NULL),(351,217,'EM','tators11@me.com',0,'2013-12-25 17:20:40',NULL,NULL),(35372,23243,'TE','3307011289',0,'2014-02-13 21:30:03',NULL,NULL),(22335,14403,'TE','2164007455',0,'2013-12-28 03:31:15',NULL,NULL),(28083,18100,'TE','5042675958',0,'2014-01-15 02:07:33',NULL,NULL),(29121,18808,'TE','3307947155',0,'2014-01-17 03:36:02',NULL,NULL),(29741,19232,'TE','2166506915',0,'2014-01-21 08:46:33',NULL,NULL),(31660,20656,'TE','8179027212',0,'2014-01-30 21:00:41',NULL,NULL),(6611,4271,'TE','4197399725',0,'2013-12-25 21:51:46',NULL,NULL),(26501,17053,'TE','2607975827',0,'2014-01-13 02:20:59',NULL,NULL),(32465,21211,'TE','9858829258',0,'2014-02-03 21:00:59',NULL,NULL),(14595,9543,'AP','4404637879',0,'2013-12-26 04:36:05',NULL,NULL),(26845,17270,'EM','shana_rn10@hotmail.com',0,'2014-01-13 02:23:21',NULL,NULL),(21666,13948,'EM','rjohnson1100@hotmail.com',0,'2013-12-26 13:14:52',NULL,NULL),(32544,21278,'AP','4193038068',0,'2014-02-03 21:01:35',NULL,NULL),(38285,25278,'EM','aidan@earthsta.com',0,'2014-02-25 21:00:16',NULL,NULL),(41879,27847,'AP','9563138844',0,'2014-03-05 21:32:11',NULL,NULL),(42990,28592,'TE','5133211184',0,'2014-03-08 21:30:03',NULL,NULL),(22362,14421,'TE','2105356156',0,'2013-12-28 03:31:42',NULL,NULL),(14706,9622,'EM','dansmail@bex.net',0,'2013-12-26 04:37:57',NULL,NULL),(30793,20020,'AP','4324488151',0,'2014-01-26 19:00:14',NULL,NULL),(26052,16781,'EM','lrgilliland3@gmail.com',0,'2014-01-08 18:25:06',NULL,NULL),(30018,19441,'AP','4196057315',1,'2014-01-22 03:23:12',NULL,NULL),(20622,13268,'TE','9564665468',0,'2013-12-26 12:56:48',NULL,NULL),(39337,26021,'TE','2144996288',0,'2014-02-26 21:02:15',NULL,NULL),(39942,26431,'EM','rbender1981@gmail.com',0,'2014-02-28 07:30:16',NULL,NULL),(40576,26930,'TE','4403432384',0,'2014-03-03 01:00:19',NULL,NULL),(41304,27440,'AP','3177537058',0,'2014-03-04 21:01:53',NULL,NULL),(43660,28976,'AP','3185075669',0,'2014-03-10 21:01:06',NULL,NULL),(24004,15493,'TE','9378301055',1,'2014-01-02 04:29:35',NULL,NULL),(34063,22333,'TE','2105609863',0,'2014-02-10 11:01:02',NULL,NULL),(30539,19810,'AP','9039150008',0,'2014-01-24 21:00:09',NULL,NULL),(3179,1995,'AP','8176816774',0,'2013-12-25 19:02:03',NULL,NULL),(43168,28687,'AP','3303890714',0,'2014-03-08 21:31:01',NULL,NULL),(162,96,'TE','9168449521',0,'2013-12-25 17:17:35',NULL,NULL),(36486,24020,'TE','6145259355',0,'2014-02-15 22:00:46',NULL,NULL),(35392,23261,'EM','MARCIEPURIFOY@ICLOUD.COM',0,'2014-02-13 21:30:10',NULL,NULL),(544,339,'AP','5135456291',0,'2013-12-25 17:31:56',NULL,NULL),(33149,21712,'TE','4195682185',0,'2014-02-05 21:31:16',NULL,NULL),(22430,14463,'EM','Mitch.smith147@gmail.com',0,'2013-12-28 03:32:51',NULL,NULL),(14567,9518,'AP','9378302286',0,'2013-12-26 04:35:36',NULL,NULL),(14620,9558,'TE','3309806565',0,'2013-12-26 04:36:29',NULL,NULL),(29036,18745,'EM','missumom04@aol.com',0,'2014-01-17 03:35:42',NULL,NULL),(29285,18914,'EM','kurtandfam@aol.com',0,'2014-01-17 03:36:41',NULL,NULL),(39120,25877,'EM','spenceredwards73@gmail.com',0,'2014-02-26 21:00:55',NULL,NULL),(26166,16847,'TE','9373828711',0,'2014-01-13 02:18:37',NULL,NULL),(31883,20810,'TE','8322077280',0,'2014-01-31 21:00:28',NULL,NULL),(34641,22713,'AP','6198716374',0,'2014-02-11 21:01:06',NULL,NULL),(14494,9469,'TE','5133176986',0,'2013-12-26 04:34:24',NULL,NULL),(13892,9057,'AP','8082260393',0,'2013-12-26 04:06:14',NULL,NULL),(8879,5815,'EM','sghneim@clear.net',0,'2013-12-25 23:47:54',NULL,NULL),(28362,18276,'TE','9034524915',0,'2014-01-16 08:44:44',NULL,NULL),(35358,23231,'EM','amanda.rybak@yahoo.com',0,'2014-02-12 21:32:26',NULL,NULL),(35150,23082,'AP','3304726819',0,'2014-02-12 21:31:04',NULL,NULL),(28622,18453,'TE','2257670606',0,'2014-01-16 08:46:08',NULL,NULL),(11257,7335,'TE','5134742959',0,'2013-12-26 02:03:52',NULL,NULL),(22949,14805,'TE','3186234805',1,'2013-12-29 11:13:52',NULL,NULL),(9366,6131,'AP','9039339157',0,'2013-12-26 00:16:00',NULL,NULL),(24921,16064,'AP','5132388370',0,'2014-01-04 02:03:37',NULL,NULL),(29412,19014,'TE','2252070705',0,'2014-01-20 08:06:22',NULL,NULL),(7833,5112,'AP','9564590203',0,'2013-12-25 23:01:44',NULL,NULL),(25868,16672,'AP','3305187404',0,'2014-01-08 18:24:29',NULL,NULL),(39068,25840,'AP','3307491287',0,'2014-02-26 21:00:34',NULL,NULL),(39077,25844,'EM','fredweaver409@aol.com',0,'2014-02-26 21:00:37',NULL,NULL),(41657,27693,'TE','9569295021',0,'2014-03-05 21:30:45',NULL,NULL),(25414,16393,'TE','9568020225',0,'2014-01-07 04:03:38',NULL,NULL),(3248,2045,'EM','gaylerlewis@yahoo.com',0,'2013-12-25 19:15:42',NULL,NULL),(36572,24072,'EM','grabski312@gmail.com',0,'2014-02-15 22:01:18',NULL,NULL),(22979,14820,'EM','marjoeqb@yahoo.com',1,'2013-12-29 11:14:20',NULL,NULL),(34368,22541,'TE','2252902199',0,'2014-02-10 21:31:39',NULL,NULL),(22893,14771,'EM','miranda6099@gmail.com',1,'2013-12-29 11:12:57',NULL,NULL),(24527,15820,'TE','4404666058',0,'2014-01-03 02:03:30',NULL,NULL),(27946,18007,'AP','7406304718',0,'2014-01-15 02:07:02',NULL,NULL),(25407,16390,'TE','3612151447',0,'2014-01-07 04:03:32',NULL,NULL),(11187,7275,'TE','9363682800',0,'2013-12-26 02:02:32',NULL,NULL),(27494,17710,'EM','crenaefriedley@gmail.com',0,'2014-01-14 01:33:09',NULL,NULL),(35496,23338,'TE','7247773860',0,'2014-02-13 22:00:36',NULL,NULL),(33719,22117,'EM','doddsj@mindspring.com',0,'2014-02-08 19:00:38',NULL,NULL),(33652,22071,'TE','8172711441',0,'2014-02-08 19:00:14',NULL,NULL),(33367,21863,'BN','4199343263',0,'2014-02-06 21:01:21',NULL,NULL),(32160,21007,'AP','5047820558',0,'2014-02-01 19:00:32',NULL,NULL),(32022,20903,'TE','3302895170',0,'2014-01-31 21:01:22',NULL,NULL),(39189,25920,'AP','7132641935',0,'2014-02-26 21:01:20',NULL,NULL),(1493,918,'TE','5138931442',0,'2013-12-25 18:08:43',NULL,NULL),(3244,2042,'TE','2143547035',0,'2013-12-25 19:15:37',NULL,NULL),(8918,5837,'AP','2546529761',0,'2013-12-25 23:48:28',NULL,NULL),(9300,6091,'TE','5139430898',0,'2013-12-26 00:02:45',NULL,NULL),(9428,6171,'AP','9853281010',0,'2013-12-26 00:17:03',NULL,NULL),(33721,22119,'TE','9374607374',0,'2014-02-08 19:00:39',NULL,NULL),(33408,21890,'TE','6012871660',0,'2014-02-06 21:01:37',NULL,NULL),(2419,1477,'TE','6144751623',0,'2013-12-25 18:48:43',NULL,NULL),(30509,19789,'TE','3303520435',0,'2014-01-23 21:01:39',NULL,NULL),(26191,16859,'AP','9154124525',0,'2014-01-13 02:19:09',NULL,NULL),(27527,17735,'TE','3309230591',0,'2014-01-14 01:33:21',NULL,NULL),(34239,22457,'TE','9727758700',0,'2014-02-10 21:30:50',NULL,NULL),(30047,19461,'EM','cbtroutman@outlook.com',0,'2014-01-23 03:01:56',NULL,NULL),(5133,3289,'AP','4192616944',0,'2013-12-25 21:15:28',NULL,NULL),(26034,16773,'AP','6624044620',0,'2014-01-08 18:25:03',NULL,NULL),(5028,3225,'AP','5134466613',0,'2013-12-25 20:45:53',NULL,NULL),(2402,1464,'TE','3307590617',0,'2013-12-25 18:48:24',NULL,NULL),(3005,1867,'TE','7042690238',0,'2013-12-25 18:58:12',NULL,NULL),(8798,5762,'EM','eldridge1225@hotmail.com',0,'2013-12-25 23:46:34',NULL,NULL),(10414,6791,'AP','8176839625',0,'2013-12-26 01:17:05',NULL,NULL),(40964,27219,'AP','6016221460',0,'2014-03-03 21:31:34',NULL,NULL),(42205,28036,'TE','2162613709',0,'2014-03-06 21:01:30',NULL,NULL),(43246,28735,'AP','4197332950',0,'2014-03-09 21:00:06',NULL,NULL),(26400,16991,'BN','3254554292',0,'2014-01-13 02:20:25',NULL,NULL),(30690,19938,'TE','9373029230',0,'2014-01-24 21:01:13',NULL,NULL),(24419,15765,'TE','9562923348',0,'2014-01-03 02:01:38',NULL,NULL),(23686,15292,'AP','9858568297',1,'2014-01-02 04:22:30',NULL,NULL),(13628,8887,'TE','9152393398',0,'2013-12-26 04:01:55',NULL,NULL),(34966,22956,'AP','5044581495',0,'2014-02-12 21:00:05',NULL,NULL),(36554,24066,'TE','5136558540',0,'2014-02-15 22:01:12',NULL,NULL),(40950,27210,'EM','hairstylinsteph@aol.com',0,'2014-03-03 21:31:28',NULL,NULL),(29172,18850,'AP','3307604671',0,'2014-01-17 03:36:15',NULL,NULL),(36915,24312,'AP','9566392023',0,'2014-02-18 22:00:03',NULL,NULL),(7860,5128,'AP','2142153503',0,'2013-12-25 23:02:09',NULL,NULL),(2218,1365,'TE','4696582696',0,'2013-12-25 18:45:35',NULL,NULL),(43513,28892,'AP','2542131934',0,'2014-03-10 21:00:16',NULL,NULL),(32543,21278,'TE','4193038068',0,'2014-02-03 21:01:35',NULL,NULL),(35243,23145,'EM','vickyandbogey@gmail.com',0,'2014-02-12 21:31:38',NULL,NULL),(39347,26026,'AP','6013450966',0,'2014-02-26 21:02:19',NULL,NULL),(325,203,'TE','4196463495',0,'2013-12-25 17:20:15',NULL,NULL),(1223,743,'EM','JohnIbekweHealth2014@outlook.com',0,'2013-12-25 18:04:08',NULL,NULL),(22832,14727,'TE','3372763772',1,'2013-12-29 11:09:43',NULL,NULL),(4377,2791,'AP','4054120980',0,'2013-12-25 19:50:08',NULL,NULL),(2786,1687,'AP','5045089916',0,'2013-12-25 18:54:21',NULL,NULL),(40151,26628,'EM','soloriddlerx@yahoo.com',0,'2014-02-28 21:30:56',NULL,NULL),(1521,937,'AP','6147497701',0,'2013-12-25 18:09:14',NULL,NULL),(32557,21289,'AP','2253058414',0,'2014-02-04 21:00:06',NULL,NULL),(30890,20078,'AP','7133666927',0,'2014-01-27 21:00:22',NULL,NULL),(23125,14906,'TE','2282337364',0,'2013-12-30 00:01:18',NULL,NULL),(35536,23370,'AP','2163128653',0,'2014-02-13 22:00:53',NULL,NULL),(6605,4266,'TE','5672041369',0,'2013-12-25 21:51:39',NULL,NULL),(4450,2835,'TE','5047017898',0,'2013-12-25 20:00:53',NULL,NULL),(4518,2873,'AP','2104610709',0,'2013-12-25 20:02:00',NULL,NULL),(4775,3058,'TE','2253081233',0,'2013-12-25 20:19:04',NULL,NULL),(41088,27291,'EM','N8421P@aol.com',0,'2014-03-04 21:00:29',NULL,NULL),(41634,27676,'EM','poncey61@yahoo.com',0,'2014-03-05 21:30:36',NULL,NULL),(41918,27870,'TE','4199574062',0,'2014-03-05 21:32:25',NULL,NULL),(42402,28163,'AP','4194648126',0,'2014-03-06 21:02:43',NULL,NULL),(43041,28617,'AP','8307435099',0,'2014-03-08 21:30:19',NULL,NULL),(32310,21108,'AP','3188161346',0,'2014-02-03 21:00:06',NULL,NULL),(22081,14221,'TE','9032185341',0,'2013-12-27 02:04:45',NULL,NULL),(13896,9059,'AP','2106832877',0,'2013-12-26 04:06:18',NULL,NULL),(3970,2519,'AP','3303102650',0,'2013-12-25 19:36:33',NULL,NULL),(21437,13781,'AP','6018260424',0,'2013-12-26 13:10:46',NULL,NULL),(14012,9148,'EM','douglasdanes3@yahoo.com',0,'2013-12-26 04:08:23',NULL,NULL),(41389,27496,'TE','3304212214',0,'2014-03-04 21:02:25',NULL,NULL),(37081,24414,'EM','lindagriffith537@yahoo.com',0,'2014-02-18 22:01:03',NULL,NULL),(43834,29094,'AP','2144518789',0,'2014-03-10 21:02:12',NULL,NULL),(10784,7010,'TE','2259392510',0,'2013-12-26 01:48:30',NULL,NULL),(39952,26445,'AP','5132595194',0,'2014-02-28 07:30:23',NULL,NULL),(37598,24771,'AP','7405027990',0,'2014-02-20 04:44:30',NULL,NULL),(8388,5520,'AP','5134784383',0,'2013-12-25 23:15:18',NULL,NULL),(7273,4739,'EM','randyr388@yahoo.com',0,'2013-12-25 22:09:25',NULL,NULL),(7170,4675,'EM','lamonaluna@aol.com',0,'2013-12-25 22:07:44',NULL,NULL),(4732,3028,'AP','4192978224',0,'2013-12-25 20:18:22',NULL,NULL),(29776,19253,'AP','2256367979',0,'2014-01-21 08:46:45',NULL,NULL),(24558,15840,'TE','5133194102',0,'2014-01-03 02:04:08',NULL,NULL),(14164,9269,'EM','coreyryan83@yahoo.com',0,'2013-12-26 04:15:36',NULL,NULL),(14389,9408,'TE','3619920321',0,'2013-12-26 04:32:48',NULL,NULL),(6514,4209,'AP','3617015611',0,'2013-12-25 21:50:09',NULL,NULL),(13667,8909,'AP','9492467176',0,'2013-12-26 04:02:32',NULL,NULL),(247,153,'TE','2102732601',0,'2013-12-25 17:18:58',NULL,NULL),(41091,27293,'EM','GLORIAFANG11@GMAIL.COM',0,'2014-03-04 21:00:30',NULL,NULL),(165,97,'TE','3252359962',0,'2013-12-25 17:17:37',NULL,NULL),(5078,3260,'EM','buckeyecd28@sbcglobal.net',0,'2013-12-25 20:46:52',NULL,NULL),(38092,25143,'EM','erickat4@hotmail.com',0,'2014-02-21 22:00:12',NULL,NULL),(37256,24516,'EM','marnieoates@yahoo.com',0,'2014-02-20 03:55:26',NULL,NULL),(23541,15192,'EM','ktipton217@gmail.com',0,'2014-01-01 12:07:09',NULL,NULL),(33947,22276,'AP','9157601400',0,'2014-02-10 11:00:18',NULL,NULL),(1537,943,'EM','lancebundy@gmail.com',0,'2013-12-25 18:09:26',NULL,NULL),(32625,21330,'AP','3306344003',0,'2014-02-04 21:00:28',NULL,NULL),(2225,1368,'TE','8323721411',0,'2013-12-25 18:45:41',NULL,NULL),(3058,1902,'TE','5136612103',0,'2013-12-25 18:59:10',NULL,NULL),(24975,16095,'AP','4197040144',0,'2014-01-04 02:04:36',NULL,NULL),(21119,13579,'TE','5049458918',0,'2013-12-26 13:04:52',NULL,NULL),(24891,16046,'EM','LUMPKIN.SHERYL@GMAIL.COM',0,'2014-01-04 02:03:03',NULL,NULL),(14875,9737,'TE','9369674295',0,'2013-12-26 04:45:49',NULL,NULL),(22546,14538,'TE','6625642861',0,'2013-12-28 03:34:45',NULL,NULL),(39208,25930,'TE','9036677836',0,'2014-02-26 21:01:26',NULL,NULL),(26142,16828,'BN','2163965165',0,'2014-01-13 02:18:27',NULL,NULL),(7736,5049,'AP','7135012267',0,'2013-12-25 23:00:08',NULL,NULL),(33628,22050,'AP','8172352120',0,'2014-02-08 19:00:04',NULL,NULL),(6335,4085,'TE','3305928884',0,'2013-12-25 21:47:16',NULL,NULL),(30945,20127,'TE','3305539616',0,'2014-01-27 21:00:49',NULL,NULL),(27836,17934,'EM','andrew@denpg.com',0,'2014-01-15 02:06:37',NULL,NULL),(11234,7314,'EM','khinlt@gmail.com',0,'2013-12-26 02:03:25',NULL,NULL),(6873,4458,'TE','5135350880',0,'2013-12-25 22:02:35',NULL,NULL),(38070,25130,'EM','lisathy319@yahoo.com',0,'2014-02-21 22:00:03',NULL,NULL),(8283,5428,'TE','2285475323',0,'2013-12-25 23:09:34',NULL,NULL),(36934,24322,'TE','9564327977',0,'2014-02-18 22:00:09',NULL,NULL),(33873,22233,'EM','ashleylinboone@yahoo.com',0,'2014-02-09 19:00:33',NULL,NULL),(33228,21759,'TE','8327278255',0,'2014-02-06 21:00:25',NULL,NULL),(24404,15756,'BN','3058349859',0,'2014-01-03 02:01:20',NULL,NULL),(31002,20167,'EM','AHAMMACK21@AOL.COM',0,'2014-01-27 21:01:13',NULL,NULL),(29478,19054,'EM','SAGENEWCOMB@YAHOO.COM',0,'2014-01-20 08:06:47',NULL,NULL),(10608,6903,'TE','5048665766',0,'2013-12-26 01:45:41',NULL,NULL),(13771,8977,'AP','4198893730',0,'2013-12-26 04:04:13',NULL,NULL),(20300,13085,'TE','6149914955',0,'2013-12-26 12:51:42',NULL,NULL),(20646,13279,'AP','9723757856',0,'2013-12-26 12:57:08',NULL,NULL),(344,214,'TE','3185741955',0,'2013-12-25 17:20:34',NULL,NULL),(1550,955,'TE','5134656482',0,'2013-12-25 18:09:38',NULL,NULL),(12180,7955,'AP','3182008906',0,'2013-12-26 03:07:18',NULL,NULL),(31271,20371,'AP','5049754802',0,'2014-01-29 21:00:06',NULL,NULL),(21776,14030,'TE','2167218140',0,'2013-12-26 13:16:52',NULL,NULL),(29235,18884,'EM','t.cvicknair@gmail.com',0,'2014-01-17 03:36:29',NULL,NULL),(27508,17723,'TE','3308823622',0,'2014-01-14 01:33:15',NULL,NULL),(20305,13087,'TE','3303919186',0,'2013-12-26 12:51:46',NULL,NULL),(20820,13382,'TE','3306442621',0,'2013-12-26 12:59:56',NULL,NULL),(37398,24628,'TE','2257177758',0,'2014-02-20 04:17:30',NULL,NULL),(9947,6509,'AP','3306066342',0,'2013-12-26 00:51:05',NULL,NULL),(35332,23216,'TE','2284752105',0,'2014-02-12 21:32:16',NULL,NULL),(23261,14987,'TE','3614850216',0,'2014-01-01 12:01:18',NULL,NULL),(3937,2496,'EM','erinejax@gmail.com',0,'2013-12-25 19:35:57',NULL,NULL),(27083,17418,'AP','9374836076',0,'2014-01-13 03:00:25',NULL,NULL),(10352,6747,'AP','9033729721',0,'2013-12-26 01:15:58',NULL,NULL),(20918,13451,'AP','6142165785',0,'2013-12-26 13:01:30',NULL,NULL),(42834,28489,'TE','4194421620',0,'2014-03-07 21:31:40',NULL,NULL),(1702,1046,'TE','2145373451',0,'2013-12-25 18:15:54',NULL,NULL),(32667,21364,'EM','bcortega@aol.com',0,'2014-02-04 21:00:45',NULL,NULL),(3942,2503,'TE','9857484039',0,'2013-12-25 19:36:05',NULL,NULL),(25114,16190,'EM','BUNGNGUYEN9982H@ATT.NET',0,'2014-01-05 00:00:49',NULL,NULL),(22806,14705,'TE','7034091450',1,'2013-12-29 11:09:11',NULL,NULL),(14103,9221,'AP','2165710561',0,'2013-12-26 04:10:13',NULL,NULL),(11825,7692,'EM','marlafleischer@sbcglobal.net',0,'2013-12-26 03:01:05',NULL,NULL),(22393,14443,'TE','3189329578',0,'2013-12-28 03:32:16',NULL,NULL),(40591,26945,'TE','7408723049',0,'2014-03-03 01:00:24',NULL,NULL),(40635,26971,'AP','7137033300',0,'2014-03-03 01:00:35',NULL,NULL),(42739,28426,'AP','7404855285',0,'2014-03-07 21:31:06',NULL,NULL),(738,463,'TE','3304316249',0,'2013-12-25 17:47:41',NULL,NULL),(3896,2474,'TE','2259363831',0,'2013-12-25 19:35:20',NULL,NULL),(8453,5560,'EM','ddelmoro@aol.com',0,'2013-12-25 23:16:26',NULL,NULL),(21343,13715,'EM','mdwalder84@gmail.com',0,'2013-12-26 13:09:03',NULL,NULL),(32784,21450,'AP','3306874252',0,'2014-02-04 21:01:28',NULL,NULL),(28013,18056,'TE','4192153682',0,'2014-01-15 02:07:19',NULL,NULL),(32551,21282,'TE','5136250508',0,'2014-02-03 21:01:38',NULL,NULL),(33225,21756,'AP','9032887163',0,'2014-02-06 21:00:24',NULL,NULL),(22170,14280,'EM','lisaybld@gmail.com',0,'2013-12-27 02:06:19',NULL,NULL),(573,355,'TE','4193228878',0,'2013-12-25 17:32:24',NULL,NULL),(22610,14580,'TE','2253289110',0,'2013-12-28 03:35:50',NULL,NULL),(5860,3760,'EM','smschuck@aol.com',0,'2013-12-25 21:33:25',NULL,NULL),(25731,16584,'TE','5043408880',0,'2014-01-08 18:23:58',NULL,NULL),(38189,25205,'AP','3377805973',0,'2014-02-21 22:00:48',NULL,NULL),(38238,25245,'AP','4192283194',0,'2014-02-21 22:01:10',NULL,NULL),(1489,916,'AP','5136040913',0,'2013-12-25 18:08:41',NULL,NULL),(10135,6625,'TE','4193203254',0,'2013-12-26 00:54:11',NULL,NULL),(10100,6598,'AP','6018077777',0,'2013-12-26 00:53:29',NULL,NULL),(24387,15747,'EM','ROBERTJONES816@GMAIL.COM',0,'2014-01-03 02:01:02',NULL,NULL),(32590,21308,'AP','5044539858',0,'2014-02-04 21:00:16',NULL,NULL),(24154,15610,'TE','3308560715',1,'2014-01-02 04:32:47',NULL,NULL),(14896,9747,'AP','3184693230',0,'2013-12-26 04:46:07',NULL,NULL),(20254,13048,'AP','4198702318',0,'2013-12-26 12:50:48',NULL,NULL),(30908,20094,'AP','9855132891',0,'2014-01-27 21:00:32',NULL,NULL),(23883,15411,'TE','6824593366',1,'2014-01-02 04:27:06',NULL,NULL),(24019,15510,'EM','theresajones2020@yahoo.com',1,'2014-01-02 04:29:58',NULL,NULL),(35951,23653,'AP','2812534503',0,'2014-02-14 21:30:15',NULL,NULL),(9843,6437,'EM','pwrmd4@aol.com',0,'2013-12-26 00:49:21',NULL,NULL),(2501,1534,'EM','heathertayse@yahoo.com',0,'2013-12-25 18:50:06',NULL,NULL),(7274,4740,'TE','7633704190',0,'2013-12-25 22:09:25',NULL,NULL),(23143,14920,'EM','LORI8111958@YAHOO.COM',0,'2013-12-30 00:01:40',NULL,NULL),(2222,1366,'EM','lland565@gmail.com',0,'2013-12-25 18:45:38',NULL,NULL),(3164,1981,'TE','8176816774',0,'2013-12-25 19:01:43',NULL,NULL),(39456,26093,'AP','9852552880',0,'2014-02-28 06:30:09',NULL,NULL),(41863,27838,'AP','5672302208',0,'2014-03-05 21:32:05',NULL,NULL),(2797,1695,'TE','5672881614',0,'2013-12-25 18:54:32',NULL,NULL),(5002,3212,'TE','9569034219',0,'2013-12-25 20:45:28',NULL,NULL),(4770,3055,'TE','3374362261',0,'2013-12-25 20:19:00',NULL,NULL),(3002,1856,'AP','5132717375',0,'2013-12-25 18:58:04',NULL,NULL),(20447,13171,'EM','JUSTICE8139@GMAIL.COM',0,'2013-12-26 12:54:04',NULL,NULL),(40385,26806,'AP','5133072688',0,'2014-03-01 21:00:26',NULL,NULL),(26977,17352,'TE','2253560502',0,'2014-01-13 02:24:09',NULL,NULL),(36452,24003,'AP','5136022781',0,'2014-02-15 22:00:35',NULL,NULL),(27076,17413,'EM','fleetwoodsdm@hotmail.com',0,'2014-01-13 03:00:23',NULL,NULL),(34248,22466,'AP','6176862706',0,'2014-02-10 21:30:55',NULL,NULL),(27407,17650,'TE','6149757802',0,'2014-01-14 01:32:40',NULL,NULL),(32073,20943,'EM','gjlearningcenter14@yahoo.com',0,'2014-01-31 21:01:44',NULL,NULL),(31010,20172,'AP','4403192078',0,'2014-01-27 21:01:16',NULL,NULL),(1315,803,'AP','7138420102',0,'2013-12-25 18:05:37',NULL,NULL),(5189,3331,'AP','3305246526',0,'2013-12-25 21:16:19',NULL,NULL),(26035,16773,'EM','mbichon@aol.com',0,'2014-01-08 18:25:03',NULL,NULL),(26794,17237,'TE','4194243949',0,'2014-01-13 02:22:43',NULL,NULL),(6102,3928,'EM','doogee5550@aol.com',0,'2013-12-25 21:37:34',NULL,NULL),(1098,674,'TE','5136078358',0,'2013-12-25 18:02:14',NULL,NULL),(10068,6581,'EM','stacysteinspring@yahoo.com',0,'2013-12-26 00:53:00',NULL,NULL),(36114,23767,'TE','4408210525',0,'2014-02-14 21:31:12',NULL,NULL),(29723,19220,'TE','5136047871',0,'2014-01-21 08:46:26',NULL,NULL),(9774,6390,'TE','5137225098',0,'2013-12-26 00:48:10',NULL,NULL),(35625,23425,'AP','9034972156',0,'2014-02-13 22:01:25',NULL,NULL),(23544,15195,'TE','6013541070',0,'2014-01-01 12:07:14',NULL,NULL),(7583,4936,'AP','5132521826',0,'2013-12-25 22:45:34',NULL,NULL),(8904,5829,'EM','evmoreno@gmail.com',0,'2013-12-25 23:48:15',NULL,NULL),(11961,7794,'AP','9032751053',0,'2013-12-26 03:03:29',NULL,NULL),(38763,25625,'TE','3304339310',0,'2014-02-26 08:30:20',NULL,NULL),(339,212,'TE','3373656608',0,'2013-12-25 17:20:30',NULL,NULL),(24671,15907,'EM','afrowine@gmail.com',0,'2014-01-03 02:06:17',NULL,NULL),(14571,9524,'EM','NEIL@AGARWALLAW.COM',0,'2013-12-26 04:35:41',NULL,NULL),(1080,664,'EM','Katie.DiBiagio@gmail.com',0,'2013-12-25 18:01:58',NULL,NULL),(5112,3277,'TE','5133981882',0,'2013-12-25 21:15:09',NULL,NULL),(5067,3253,'TE','4405327304',0,'2013-12-25 20:46:42',NULL,NULL),(34344,22531,'BN','8014483934',0,'2014-02-10 21:31:32',NULL,NULL),(29570,19107,'TE','9377679966',0,'2014-01-21 08:44:42',NULL,NULL),(28038,18068,'AP','2253042730',0,'2014-01-15 02:07:23',NULL,NULL),(38940,25745,'TE','5133484143',0,'2014-02-26 09:30:42',NULL,NULL),(27287,17570,'TE','5132840916',0,'2014-01-14 01:32:01',NULL,NULL),(33903,22253,'AP','5137393766',0,'2014-02-09 19:00:44',NULL,NULL),(783,490,'TE','5042662975',0,'2013-12-25 17:48:23',NULL,NULL),(376,230,'TE','5132212807',0,'2013-12-25 17:21:02',NULL,NULL),(5319,3410,'TE','3375276116',0,'2013-12-25 21:18:22',NULL,NULL),(33637,22057,'AP','9156911727',0,'2014-02-08 19:00:08',NULL,NULL),(30452,19741,'EM','csigle2@lsu.edu',0,'2014-01-23 21:01:11',NULL,NULL),(28435,18321,'TE','4407251111',0,'2014-01-16 08:45:07',NULL,NULL),(29967,19391,'EM','dkipker@yahoo.com',1,'2014-01-22 03:22:48',NULL,NULL),(1012,623,'TE','7068895620',0,'2013-12-25 18:00:54',NULL,NULL),(33691,22099,'BN','3303545829',0,'2014-02-08 19:00:29',NULL,NULL),(21743,14005,'EM','dottieinpink@zoominternet.net',0,'2013-12-26 13:16:13',NULL,NULL),(21307,13687,'EM','h8uction@earthlink.net',0,'2013-12-26 13:08:22',NULL,NULL),(10334,6739,'TE','3304006036',0,'2013-12-26 01:15:43',NULL,NULL),(14317,9362,'TE','5046662403',0,'2013-12-26 04:31:34',NULL,NULL),(22411,14454,'TE','5043205315',0,'2013-12-28 03:32:34',NULL,NULL),(22777,14684,'EM','advhomeinspection@windstream.net',1,'2013-12-29 11:08:40',NULL,NULL),(10261,6704,'AP','4192695410',0,'2013-12-26 01:02:01',NULL,NULL),(27139,17476,'TE','4692232306',0,'2014-01-13 03:01:10',NULL,NULL),(9729,6367,'EM','dswingate@roadrunner.com',0,'2013-12-26 00:47:32',NULL,NULL),(9270,6068,'TE','5133766674',0,'2013-12-26 00:02:07',NULL,NULL),(24549,15835,'TE','4404618715',0,'2014-01-03 02:03:58',NULL,NULL),(37600,24771,'EM','bigben9578@hotmail.com',0,'2014-02-20 04:44:37',NULL,NULL),(37202,24486,'AP','2252235809',0,'2014-02-20 03:42:34',NULL,NULL),(36118,23769,'TE','5133511420',0,'2014-02-14 21:31:13',NULL,NULL),(35173,23102,'EM','dollalyse@aol.com',0,'2014-02-12 21:31:13',NULL,NULL),(12197,7970,'TE','2283552951',0,'2013-12-26 03:07:39',NULL,NULL),(3582,2242,'EM','schriml74@yahoo.com',0,'2013-12-25 19:21:05',NULL,NULL),(5848,3753,'AP','9039003252',0,'2013-12-25 21:33:13',NULL,NULL),(23301,15016,'TE','3302312938',0,'2014-01-01 12:02:10',NULL,NULL),(28017,18058,'TE','9376909393',0,'2014-01-15 02:07:20',NULL,NULL),(28424,18314,'TE','5132711104',0,'2014-01-16 08:45:04',NULL,NULL),(33870,22232,'AP','8065767496',0,'2014-02-09 19:00:33',NULL,NULL),(32361,21145,'BN','4322138828',0,'2014-02-03 21:00:24',NULL,NULL),(28438,18323,'AP','5132380380',0,'2014-01-16 08:45:08',NULL,NULL),(27423,17661,'AP','6147078874',0,'2014-01-14 01:32:45',NULL,NULL),(29046,18753,'AP','4193455184',0,'2014-01-17 03:35:44',NULL,NULL),(34347,22532,'EM','Ecb62@msstate.edu',0,'2014-02-10 21:31:33',NULL,NULL),(61,40,'EM','cityview88@yahoo.com',0,'2013-12-25 17:16:02',NULL,NULL),(25438,16403,'AP','9039449766',0,'2014-01-07 04:03:58',NULL,NULL),(3786,2404,'TE','5133140487',0,'2013-12-25 19:33:36',NULL,NULL),(21712,13983,'TE','5138446915',0,'2013-12-26 13:15:38',NULL,NULL),(38956,25757,'TE','8322210978',0,'2014-02-26 09:30:49',NULL,NULL),(41043,27267,'EM','mmitc15@gmail.com',0,'2014-03-04 21:00:13',NULL,NULL),(25097,16180,'AP','2817707083',0,'2014-01-05 00:00:31',NULL,NULL),(38122,25162,'EM','deckerpm@gmail.com',0,'2014-02-21 22:00:23',NULL,NULL),(21372,13742,'AP','3308006040',0,'2013-12-26 13:09:43',NULL,NULL),(9482,6205,'AP','4197730331',0,'2013-12-26 00:30:43',NULL,NULL),(13568,8845,'TE','3258642448',0,'2013-12-26 04:00:53',NULL,NULL),(28366,18277,'AP','4695346796',0,'2014-01-16 08:44:45',NULL,NULL),(30418,19717,'TE','4192157829',0,'2014-01-23 21:00:56',NULL,NULL),(25955,16720,'TE','9568443975',0,'2014-01-08 18:24:46',NULL,NULL),(7722,5042,'AP','9035390761',0,'2013-12-25 22:48:02',NULL,NULL),(36660,24134,'TE','9373421949',0,'2014-02-15 22:01:49',NULL,NULL),(35387,23257,'AP','2147141720',0,'2014-02-13 21:30:08',NULL,NULL),(34929,22921,'TE','7158920805',0,'2014-02-11 21:02:55',NULL,NULL),(34760,22791,'AP','4194392783',0,'2014-02-11 21:01:50',NULL,NULL),(24003,15492,'TE','9374176225',1,'2014-01-02 04:29:33',NULL,NULL),(20548,13226,'EM','austinpianotuner@yahoo.com',0,'2013-12-26 12:55:37',NULL,NULL),(29612,19132,'AP','2252366803',0,'2014-01-21 08:45:24',NULL,NULL),(11239,7317,'AP','8324050658',0,'2013-12-26 02:03:30',NULL,NULL),(10711,6963,'EM','charrandalee@yahoo.com',0,'2013-12-26 01:47:19',NULL,NULL),(36879,24289,'TE','5133731838',0,'2014-02-18 21:30:11',NULL,NULL),(34780,22811,'EM','etter0510@yahoo.com',0,'2014-02-11 21:01:58',NULL,NULL),(34413,22574,'BN','4407310090',0,'2014-02-10 21:31:59',NULL,NULL),(32766,21435,'EM','timbroadhead@comcast.net',0,'2014-02-04 21:01:21',NULL,NULL),(10437,6803,'EM','barbaraeady@ameritech.net',0,'2013-12-26 01:30:04',NULL,NULL),(9715,6360,'AP','3306220968',0,'2013-12-26 00:47:19',NULL,NULL),(30448,19739,'AP','3375781094',0,'2014-01-23 21:01:10',NULL,NULL),(14976,9797,'TE','2547426041',0,'2013-12-26 05:01:09',NULL,NULL),(30188,19556,'EM','MEDINEDEBORAH@YAHOO.COM',0,'2014-01-23 03:02:31',NULL,NULL),(28987,18708,'EM','afrazier55@hotmail.com',0,'2014-01-17 03:35:31',NULL,NULL),(23990,15485,'EM','dknott1983@aol.com',1,'2014-01-02 04:29:19',NULL,NULL),(25251,16283,'AP','9374096728',0,'2014-01-07 04:00:36',NULL,NULL),(24943,16078,'EM','sdbhm1001@gmail.com',0,'2014-01-04 02:04:01',NULL,NULL),(40441,26848,'TE','3182007114',0,'2014-03-01 21:00:49',NULL,NULL),(41474,27563,'AP','2165026878',0,'2014-03-04 21:30:18',NULL,NULL),(43077,28638,'EM','diana-fr-mtz@outlook.com',0,'2014-03-08 21:30:31',NULL,NULL),(1396,853,'EM','MIRON0533@YAHOO.COM',0,'2013-12-25 18:06:58',NULL,NULL),(9141,5987,'AP','4403411795',0,'2013-12-25 23:52:07',NULL,NULL),(38161,25186,'TE','9727272432',0,'2014-02-21 22:00:37',NULL,NULL),(36434,23994,'TE','9854133488',0,'2014-02-15 22:00:28',NULL,NULL),(7535,4910,'TE','8062817531',0,'2013-12-25 22:32:05',NULL,NULL),(14036,9169,'TE','4194359166',0,'2013-12-26 04:08:53',NULL,NULL),(22324,14391,'TE','6145816545',0,'2013-12-28 03:31:01',NULL,NULL),(22723,14652,'TE','2816764457',1,'2013-12-29 11:07:47',NULL,NULL),(26223,16879,'TE','5128035573',0,'2014-01-13 02:19:20',NULL,NULL),(30547,19816,'EM','CGALLEN44@YAHOO.COM',0,'2014-01-24 21:00:12',NULL,NULL),(4357,2779,'TE','6013767628',0,'2013-12-25 19:49:47',NULL,NULL),(38298,25289,'TE','4406100829',0,'2014-02-25 21:00:22',NULL,NULL),(35294,23182,'EM','dgandzhon@att.net',0,'2014-02-12 21:31:59',NULL,NULL),(6287,4053,'TE','9376544298',0,'2013-12-25 21:46:28',NULL,NULL),(32030,20907,'TE','2166323466',0,'2014-01-31 21:01:25',NULL,NULL),(31743,20715,'TE','3184038406',0,'2014-01-30 21:01:11',NULL,NULL),(6584,4250,'AP','5127795421',0,'2013-12-25 21:51:16',NULL,NULL),(20392,13135,'TE','3302219997',0,'2013-12-26 12:53:08',NULL,NULL),(22086,14228,'TE','2547185751',0,'2013-12-27 02:04:54',NULL,NULL),(23971,15471,'TE','3302681707',1,'2014-01-02 04:28:56',NULL,NULL),(39109,25872,'EM','Kingbp79@yahoo.com',0,'2014-02-26 21:00:52',NULL,NULL),(41373,27484,'AP','5673719752',0,'2014-03-04 21:02:19',NULL,NULL),(41480,27572,'TE','6017133600',0,'2014-03-04 21:30:21',NULL,NULL),(23195,14949,'AP','5123505357',0,'2014-01-01 12:00:07',NULL,NULL),(37472,24677,'TE','9363682240',0,'2014-02-20 04:29:17',NULL,NULL),(21464,13793,'TE','7697987804',0,'2013-12-26 13:11:09',NULL,NULL),(33577,22013,'AP','6143385772',0,'2014-02-07 19:00:53',NULL,NULL),(29569,19106,'AP','9852319369',0,'2014-01-21 08:44:41',NULL,NULL),(28154,18148,'TE','5044523749',0,'2014-01-15 02:07:49',NULL,NULL),(20983,13505,'AP','5049059573',0,'2013-12-26 13:02:43',NULL,NULL),(3422,2148,'AP','9378303238',0,'2013-12-25 19:18:30',NULL,NULL),(2957,1828,'TE','4192566536',0,'2013-12-25 18:57:22',NULL,NULL),(12282,8034,'TE','4193489641',0,'2013-12-26 03:09:14',NULL,NULL),(14363,9389,'TE','8064072177',0,'2013-12-26 04:32:18',NULL,NULL),(7471,4863,'AP','8322941632',0,'2013-12-25 22:30:44',NULL,NULL),(12397,8116,'EM','FISHERS1951@AOL.COM',0,'2013-12-26 03:15:11',NULL,NULL),(29682,19181,'AP','9152749612',0,'2014-01-21 08:46:08',NULL,NULL),(41149,27332,'TE','5138434122',0,'2014-03-04 21:00:53',NULL,NULL),(4963,3184,'TE','5048841608',0,'2013-12-25 20:31:56',NULL,NULL),(10826,7032,'TE','2817253013',0,'2013-12-26 01:49:09',NULL,NULL),(4025,2570,'AP','4405391919',0,'2013-12-25 19:37:40',NULL,NULL),(8106,5306,'EM','CELESTEJACKSON12@COMCAST.NET',0,'2013-12-25 23:06:27',NULL,NULL),(35115,23066,'AP','5047995952',0,'2014-02-12 21:30:54',NULL,NULL),(7331,4766,'AP','2164705042',0,'2013-12-25 22:15:42',NULL,NULL),(42708,28407,'AP','7405755380',0,'2014-03-07 21:30:55',NULL,NULL),(23781,15337,'EM','katied01@hotmail.com',1,'2014-01-02 04:24:07',NULL,NULL),(36412,23980,'EM','Dmlauf@gmail.com',0,'2014-02-15 22:00:20',NULL,NULL),(33859,22226,'AP','2148092722',0,'2014-02-09 19:00:29',NULL,NULL),(5495,3514,'EM','jeromewyattjr@gmail.com',0,'2013-12-25 21:21:06',NULL,NULL),(30554,19825,'AP','2105893669',0,'2014-01-24 21:00:16',NULL,NULL),(10565,6878,'TE','5043521734',0,'2013-12-26 01:32:11',NULL,NULL),(7218,4702,'AP','3217957720',0,'2013-12-25 22:08:28',NULL,NULL),(38340,25328,'AP','5049099877',0,'2014-02-25 21:30:15',NULL,NULL),(24018,15510,'AP','5135505445',1,'2014-01-02 04:29:58',NULL,NULL),(36611,24104,'EM','salina.roman@yahoo.com',0,'2014-02-15 22:01:33',NULL,NULL),(14551,9507,'AP','5135451378',0,'2013-12-26 04:35:18',NULL,NULL),(33703,22104,'AP','7247773860',0,'2014-02-08 19:00:32',NULL,NULL),(28368,18278,'AP','8068319882',0,'2014-01-16 08:44:46',NULL,NULL),(39735,26280,'EM','ceanes4@gmail.com',0,'2014-02-28 06:31:19',NULL,NULL),(40362,26789,'TE','2253839007',0,'2014-03-01 21:00:17',NULL,NULL),(847,525,'TE','3307946804',0,'2013-12-25 17:49:19',NULL,NULL),(25729,16583,'TE','9857744969',0,'2014-01-08 18:23:58',NULL,NULL),(10741,6982,'AP','4198100264',0,'2013-12-26 01:47:46',NULL,NULL),(9190,6015,'EM','bob@perkoski.com',0,'2013-12-26 00:00:42',NULL,NULL),(21803,14048,'TE','5132256680',0,'2013-12-27 02:00:13',NULL,NULL),(4942,3173,'EM','hawkparker@yahoo.com',0,'2013-12-25 20:31:36',NULL,NULL),(14320,9364,'EM','scottlandia1234@gmail.com',0,'2013-12-26 04:31:37',NULL,NULL),(11003,7145,'TE','8326083806',0,'2013-12-26 01:52:01',NULL,NULL),(36969,24341,'AP','5756404771',0,'2014-02-18 22:00:20',NULL,NULL),(37135,24445,'AP','5132274656',0,'2014-02-18 22:01:22',NULL,NULL),(40307,26739,'TE','5672309900',0,'2014-02-28 21:31:54',NULL,NULL),(41627,27672,'AP','9152820055',0,'2014-03-05 21:30:34',NULL,NULL),(43767,29054,'TE','4196261954',0,'2014-03-10 21:01:48',NULL,NULL),(827,514,'TE','5133173474',0,'2013-12-25 17:49:01',NULL,NULL),(34762,22795,'TE','2166452261',0,'2014-02-11 21:01:51',NULL,NULL),(10106,6603,'AP','9374171757',0,'2013-12-26 00:53:36',NULL,NULL),(34205,22431,'EM','thelma7861@hotmail.com',0,'2014-02-10 21:30:37',NULL,NULL),(22173,14283,'TE','6015064130',0,'2013-12-27 02:06:23',NULL,NULL),(6804,4414,'AP','5134516490',0,'2013-12-25 22:01:27',NULL,NULL),(27436,17674,'TE','2259395683',0,'2014-01-14 01:32:51',NULL,NULL),(7979,5205,'AP','6147722718',0,'2013-12-25 23:04:09',NULL,NULL),(38136,25171,'EM','ea.pennington@gmail.com',0,'2014-02-21 22:00:28',NULL,NULL),(38558,25481,'TE','9374743456',0,'2014-02-25 21:31:43',NULL,NULL),(22860,14752,'TE','9375278500',1,'2013-12-29 11:10:20',NULL,NULL),(11968,7799,'TE','9152691794',0,'2013-12-26 03:03:37',NULL,NULL),(33968,22285,'TE','2167214484',0,'2014-02-10 11:00:25',NULL,NULL),(21974,14156,'TE','2254395277',0,'2013-12-27 02:03:01',NULL,NULL),(7597,4946,'TE','4193094778',0,'2013-12-25 22:45:48',NULL,NULL),(27283,17568,'TE','6148054391',0,'2014-01-14 01:32:00',NULL,NULL),(37981,25057,'AP','9377766874',0,'2014-02-20 22:01:21',NULL,NULL),(39472,26102,'TE','5044002458',0,'2014-02-28 06:30:13',NULL,NULL),(1475,904,'TE','5133071859',0,'2013-12-25 18:08:22',NULL,NULL),(35788,23534,'AP','3184934988',0,'2014-02-13 22:02:28',NULL,NULL),(10864,7052,'AP','5134047115',0,'2013-12-26 01:49:43',NULL,NULL),(9894,6472,'TE','4406450484',0,'2013-12-26 00:50:10',NULL,NULL),(30220,19577,'TE','3188689006',0,'2014-01-23 03:02:39',NULL,NULL),(4186,2677,'EM','lkadlub89@gmail.com',0,'2013-12-25 19:47:08',NULL,NULL),(26453,17030,'TE','4198102634',0,'2014-01-13 02:20:44',NULL,NULL),(7815,5102,'EM','OWINO10@YAHOO.COM',0,'2013-12-25 23:01:28',NULL,NULL),(12203,7973,'TE','3306441158',0,'2013-12-26 03:07:45',NULL,NULL),(33251,21774,'TE','6145981649',0,'2014-02-06 21:00:34',NULL,NULL),(9930,6499,'EM','jafannin@earthlink.net',0,'2013-12-26 00:50:48',NULL,NULL),(9194,6018,'AP','5089511750',0,'2013-12-26 00:00:46',NULL,NULL),(485,310,'EM','karanedmondson@yahoo.com',0,'2013-12-25 17:31:00',NULL,NULL),(25563,16490,'TE','4192245256',0,'2014-01-07 04:06:31',NULL,NULL),(14353,9383,'TE','2144788619',0,'2013-12-26 04:32:09',NULL,NULL),(7316,4758,'AP','2817961969',0,'2013-12-25 22:15:28',NULL,NULL),(8967,5877,'TE','7403103917',0,'2013-12-25 23:49:21',NULL,NULL),(23147,14922,'AP','2257725465',0,'2013-12-30 00:01:44',NULL,NULL),(5068,3253,'EM','C2scott@yahoo.com',0,'2013-12-25 20:46:42',NULL,NULL),(20429,13156,'AP','9372723870',0,'2013-12-26 12:53:44',NULL,NULL),(8334,5464,'EM','shaneray12@hotmail.com',0,'2013-12-25 23:10:30',NULL,NULL),(8672,5693,'TE','3308361697',0,'2013-12-25 23:32:41',NULL,NULL),(37297,24543,'TE','3305071041',0,'2014-02-20 04:03:00',NULL,NULL),(40423,26834,'AP','3306854659',0,'2014-03-01 21:00:41',NULL,NULL),(24045,15526,'TE','9858395457',1,'2014-01-02 04:30:29',NULL,NULL),(10880,7063,'TE','9175175611',0,'2013-12-26 01:50:00',NULL,NULL),(34586,22677,'AP','8323124190',0,'2014-02-11 21:00:45',NULL,NULL),(33759,22152,'TE','4196511994',0,'2014-02-08 19:00:55',NULL,NULL),(10723,6974,'TE','4403823008',0,'2013-12-26 01:47:32',NULL,NULL),(30827,20042,'BN','4197334441',0,'2014-01-26 19:00:27',NULL,NULL),(10225,6682,'AP','6145991196',0,'2013-12-26 01:01:26',NULL,NULL),(28545,18403,'TE','5137025258',0,'2014-01-16 08:45:44',NULL,NULL),(21860,14083,'TE','4403710083',0,'2013-12-27 02:01:09',NULL,NULL),(8251,5397,'TE','3187379994',0,'2013-12-25 23:08:50',NULL,NULL),(5200,3342,'TE','5122191741',0,'2013-12-25 21:16:31',NULL,NULL),(23116,14902,'EM','PATELSETU2003@YAHOO.COM',0,'2013-12-30 00:01:10',NULL,NULL),(37324,24563,'TE','2169904376',0,'2014-02-20 04:06:39',NULL,NULL),(21980,14158,'AP','2256787902',0,'2013-12-27 02:03:06',NULL,NULL),(25961,16723,'TE','4409987448',0,'2014-01-08 18:24:47',NULL,NULL),(9572,6269,'TE','5132381161',0,'2013-12-26 00:45:04',NULL,NULL),(21628,13921,'TE','4194726603',0,'2013-12-26 13:14:12',NULL,NULL),(5104,3273,'AP','4197891521',0,'2013-12-25 20:47:16',NULL,NULL),(4375,2790,'EM','nhemmel@yahoo.com',0,'2013-12-25 19:50:06',NULL,NULL),(43546,28912,'TE','5135157325',0,'2014-03-10 21:00:27',NULL,NULL),(43959,29162,'AP','9372155416',0,'2014-03-10 21:02:54',NULL,NULL),(24712,15945,'TE','3045504671',0,'2014-01-03 02:07:18',NULL,NULL),(11377,7409,'TE','6013837742',0,'2013-12-26 02:16:40',NULL,NULL),(26079,16796,'TE','7145889943',0,'2014-01-13 02:18:09',NULL,NULL),(10427,6798,'TE','4196562442',0,'2013-12-26 01:17:18',NULL,NULL),(9797,6409,'AP','2167892790',0,'2013-12-26 00:48:35',NULL,NULL),(4583,2925,'AP','5133126673',0,'2013-12-25 20:15:52',NULL,NULL),(14908,9755,'TE','4326147331',0,'2013-12-26 05:00:03',NULL,NULL),(6344,4090,'TE','4193564517',0,'2013-12-25 21:47:24',NULL,NULL),(2210,1358,'AP','2817396604',0,'2013-12-25 18:45:26',NULL,NULL),(21063,13547,'AP','5047826584',0,'2013-12-26 13:03:58',NULL,NULL),(750,471,'TE','4196512032',0,'2013-12-25 17:47:52',NULL,NULL),(2334,1422,'EM','donnast405@live.com',0,'2013-12-25 18:47:17',NULL,NULL),(10839,7038,'TE','3204939451',0,'2013-12-26 01:49:19',NULL,NULL),(33165,21721,'EM','JELLYROLLLIEE28@YAHOO.COM',0,'2014-02-05 21:31:20',NULL,NULL),(24567,15845,'EM','topherbucks@yahoo.com',0,'2014-01-03 02:04:18',NULL,NULL),(2425,1482,'EM','ericowens365@gmail.com',0,'2013-12-25 18:48:50',NULL,NULL),(37490,24688,'TE','3612930628',0,'2014-02-20 04:31:48',NULL,NULL),(2485,1525,'AP','5132848598',0,'2013-12-25 18:49:53',NULL,NULL),(32558,21289,'EM','TASHA_HARTFIELD@YAHOO.COM',0,'2014-02-04 21:00:06',NULL,NULL),(32040,20914,'TE','3303489192',0,'2014-01-31 21:01:29',NULL,NULL),(10156,6638,'TE','3309629987',0,'2013-12-26 01:00:14',NULL,NULL),(36774,24214,'TE','5127888598',0,'2014-02-16 19:00:25',NULL,NULL),(3631,2298,'EM','robin@wyandottewinery.com',0,'2013-12-25 19:30:55',NULL,NULL),(21091,13563,'TE','5045200178',0,'2013-12-26 13:04:25',NULL,NULL),(29074,18777,'BN','5136254325',0,'2014-01-17 03:35:51',NULL,NULL),(26505,17054,'EM','s.c.fout@gmail.com',0,'2014-01-13 02:21:00',NULL,NULL),(5524,3533,'EM','c.graham4231@gmail.com',0,'2013-12-25 21:21:33',NULL,NULL),(26394,16989,'AP','2102687470',0,'2014-01-13 02:20:23',NULL,NULL),(24966,16091,'AP','2283437559',0,'2014-01-04 02:04:26',NULL,NULL),(21453,13789,'TE','6019067139',0,'2013-12-26 13:11:00',NULL,NULL),(12405,8123,'EM','LJANSON4522@GMAIL.COM',0,'2013-12-26 03:15:20',NULL,NULL),(33530,21980,'AP','3378520789',0,'2014-02-07 19:00:36',NULL,NULL),(21537,13846,'EM','JACKGAR@ROADRUNNER.COM',0,'2013-12-26 13:12:28',NULL,NULL),(22903,14776,'TE','3306968511',1,'2013-12-29 11:13:06',NULL,NULL),(6242,4023,'AP','7177562141',0,'2013-12-25 21:45:43',NULL,NULL),(22694,14637,'EM','pmrider@fuse.net',0,'2013-12-28 03:37:20',NULL,NULL),(7723,5042,'EM','bluesky7@embarqmail.com',0,'2013-12-25 22:48:03',NULL,NULL),(21744,14006,'TE','3305441985',0,'2013-12-26 13:16:14',NULL,NULL),(39889,26397,'TE','3302420092',0,'2014-02-28 07:00:29',NULL,NULL),(43408,28827,'TE','5135056248',0,'2014-03-09 21:01:04',NULL,NULL),(23690,15294,'AP','2259100150',1,'2014-01-02 04:22:35',NULL,NULL),(37408,24636,'TE','5044812867',0,'2014-02-20 04:19:02',NULL,NULL),(36513,24039,'EM','deesoutendijk@gmail.com',0,'2014-02-15 22:00:57',NULL,NULL),(10597,6896,'TE','2253282842',0,'2013-12-26 01:45:31',NULL,NULL),(14936,9772,'TE','2259552337',0,'2013-12-26 05:00:30',NULL,NULL),(20249,13045,'AP','6144775929',0,'2013-12-26 12:50:43',NULL,NULL),(11237,7316,'TE','8309281281',0,'2013-12-26 02:03:28',NULL,NULL),(42571,28327,'EM','jaynamaz@me.com',0,'2014-03-07 21:30:09',NULL,NULL),(8090,5294,'EM','JJMartin424@yahoo.com',0,'2013-12-25 23:06:08',NULL,NULL),(23561,15206,'AP','6013840688',0,'2014-01-01 12:07:34',NULL,NULL),(23538,15190,'EM','jon@hartney.name',0,'2014-01-01 12:07:06',NULL,NULL),(34156,22395,'TE','6102097632',0,'2014-02-10 21:30:17',NULL,NULL),(33543,21991,'TE','5047582252',0,'2014-02-07 19:00:42',NULL,NULL),(30725,19962,'AP','9563732011',0,'2014-01-25 19:00:08',NULL,NULL),(22503,14508,'TE','3616552800',0,'2013-12-28 03:33:59',NULL,NULL),(27613,17802,'AP','4199800565',0,'2014-01-14 01:33:54',NULL,NULL),(27383,17626,'EM','miguel.alvarezmba@gmail.com',0,'2014-01-14 01:32:30',NULL,NULL),(26593,17109,'AP','9377250521',0,'2014-01-13 02:21:36',NULL,NULL),(14386,9406,'AP','8324912686',0,'2013-12-26 04:32:45',NULL,NULL),(2605,1588,'TE','8065773650',0,'2013-12-25 18:51:39',NULL,NULL),(11736,7639,'TE','4196076011',0,'2013-12-26 02:46:31',NULL,NULL),(39703,26255,'AP','9565021221',0,'2014-02-28 06:31:10',NULL,NULL),(42810,28469,'TE','5137594586',0,'2014-03-07 21:31:31',NULL,NULL),(386,236,'AP','4084603506',0,'2013-12-25 17:21:10',NULL,NULL),(23475,15140,'TE','5132524128',0,'2014-01-01 12:05:43',NULL,NULL),(21154,13602,'TE','4192034113',0,'2013-12-26 13:05:27',NULL,NULL),(35152,23089,'TE','6142668751',0,'2014-02-12 21:31:06',NULL,NULL),(34427,22584,'AP','9375612967',0,'2014-02-10 21:32:05',NULL,NULL),(33948,22276,'EM','adan.garcia908@gmail.com',0,'2014-02-10 11:00:18',NULL,NULL),(4647,2969,'TE','9795490234',0,'2013-12-25 20:16:56',NULL,NULL),(28440,18324,'TE','7403485757',0,'2014-01-16 08:45:09',NULL,NULL),(29514,19080,'AP','4408656885',0,'2014-01-21 08:44:25',NULL,NULL),(25802,16627,'EM','scott37@columbus.rr.com',0,'2014-01-08 18:24:13',NULL,NULL),(36944,24329,'EM','donnamillner@yahoo.com',0,'2014-02-18 22:00:13',NULL,NULL),(36760,24205,'TE','2255887844',0,'2014-02-16 19:00:19',NULL,NULL),(25009,16115,'EM','rita_mtthws@yahoo.com',0,'2014-01-04 02:05:16',NULL,NULL),(23360,15047,'EM','LGALLOWAY2@COX.NET',0,'2014-01-01 12:03:10',NULL,NULL),(20788,13361,'TE','3303759731',0,'2013-12-26 12:59:27',NULL,NULL),(1033,637,'EM','tom@tjresearch.com',0,'2013-12-25 18:01:16',NULL,NULL),(10203,6667,'EM','patricksduffy@gmail.com',0,'2013-12-26 01:01:01',NULL,NULL),(38610,25518,'TE','4192044488',0,'2014-02-25 21:32:04',NULL,NULL),(40902,27177,'EM','smithwanda6@gmail.com',0,'2014-03-03 21:31:08',NULL,NULL),(8219,5380,'TE','5049758692',0,'2013-12-25 23:08:20',NULL,NULL),(32819,21473,'AP','5138076618',0,'2014-02-04 21:01:40',NULL,NULL),(2794,1691,'TE','4194941656',0,'2013-12-25 18:54:28',NULL,NULL),(28717,18532,'TE','4193080590',0,'2014-01-16 08:46:44',NULL,NULL),(28361,18275,'EM','laurachance14@yahoo.com',0,'2014-01-16 08:44:44',NULL,NULL),(7078,4623,'TE','2256355921',0,'2013-12-25 22:06:18',NULL,NULL),(9599,6285,'AP','5135455854',0,'2013-12-26 00:45:28',NULL,NULL),(14424,9428,'EM','melodyrice55@yahoo.com',0,'2013-12-26 04:33:19',NULL,NULL),(38390,25362,'AP','3302316708',0,'2014-02-25 21:30:37',NULL,NULL),(34729,22772,'AP','9373041534',0,'2014-02-11 21:01:38',NULL,NULL),(35816,23551,'TE','8327221663',0,'2014-02-13 22:02:38',NULL,NULL),(11777,7661,'EM','JoshuaBlanton@my.dcc.edu',0,'2013-12-26 03:00:18',NULL,NULL),(25552,16483,'TE','2162969693',0,'2014-01-07 04:06:20',NULL,NULL),(24121,15572,'AP','3307497816',1,'2014-01-02 04:31:56',NULL,NULL),(3487,2182,'TE','2547180631',0,'2013-12-25 19:19:28',NULL,NULL),(21711,13982,'AP','6309450152',0,'2013-12-26 13:15:37',NULL,NULL),(21896,14107,'EM','TOBYCAMBRON@GMAIL.COM',0,'2013-12-27 02:01:45',NULL,NULL),(5612,3590,'EM','connywarren@fuse.net',0,'2013-12-25 21:23:01',NULL,NULL),(2902,1780,'EM','maggie_beckford@yahoo.com',0,'2013-12-25 18:56:18',NULL,NULL),(23748,15321,'EM','gracie.harris@att.net',1,'2014-01-02 04:23:34',NULL,NULL),(8111,5311,'TE','4198775658',0,'2013-12-25 23:06:34',NULL,NULL),(43973,29171,'AP','9494441306',0,'2014-03-10 21:03:00',NULL,NULL),(12350,8086,'TE','9373020120',0,'2013-12-26 03:10:32',NULL,NULL),(33797,22188,'AP','3303226523',0,'2014-02-09 19:00:07',NULL,NULL),(12374,8104,'TE','5613191627',0,'2013-12-26 03:10:56',NULL,NULL),(31336,20419,'AP','5135433637',0,'2014-01-29 21:00:29',NULL,NULL),(30758,19988,'AP','4193062673',0,'2014-01-25 19:00:18',NULL,NULL),(14792,9680,'TE','8124304464',0,'2013-12-26 04:39:28',NULL,NULL),(29508,19076,'TE','3183234906',0,'2014-01-21 08:44:23',NULL,NULL),(22112,14242,'EM','red84529@aol.com',0,'2013-12-27 02:05:17',NULL,NULL),(28829,18611,'TE','4197709347',0,'2014-01-16 08:47:23',NULL,NULL),(26793,17235,'EM','Flogey1@yahoo.com',0,'2014-01-13 02:22:42',NULL,NULL),(39187,25918,'AP','9795622469',0,'2014-02-26 21:01:19',NULL,NULL),(9339,6114,'EM','howard@doubledashcreative.com',0,'2013-12-26 00:15:34',NULL,NULL),(9235,6045,'TE','3302422474',0,'2013-12-26 00:01:31',NULL,NULL),(32844,21494,'AP','5138076618',0,'2014-02-04 21:01:49',NULL,NULL),(30904,20091,'AP','5044537954',0,'2014-01-27 21:00:30',NULL,NULL),(27492,17709,'EM','dlafield@gmail.com',0,'2014-01-14 01:33:09',NULL,NULL),(9831,6433,'TE','3376611332',0,'2013-12-26 00:49:12',NULL,NULL),(10448,6808,'TE','7137289271',0,'2013-12-26 01:30:13',NULL,NULL),(38994,25785,'EM','fauxfabulousinteriors@yahoo.com',0,'2014-02-26 09:31:05',NULL,NULL),(41237,27388,'AP','5134602289',0,'2014-03-04 21:01:26',NULL,NULL),(28475,18349,'EM','dspence100@hotmail.com',0,'2014-01-16 08:45:21',NULL,NULL),(7774,5072,'TE','2103732430',0,'2013-12-25 23:00:46',NULL,NULL),(132,76,'EM','mlauer@cinci.rr.com',0,'2013-12-25 17:17:05',NULL,NULL),(3570,2237,'AP','5134157570',0,'2013-12-25 19:20:54',NULL,NULL),(8542,5610,'AP','5132521826',0,'2013-12-25 23:30:33',NULL,NULL),(24394,15751,'AP','9565872437',0,'2014-01-03 02:01:10',NULL,NULL),(41880,27848,'TE','9364394543',0,'2014-03-05 21:32:11',NULL,NULL),(41960,27893,'AP','5672781279',0,'2014-03-05 21:32:40',NULL,NULL),(42473,28226,'TE','6143167646',0,'2014-03-06 21:30:21',NULL,NULL),(43111,28657,'AP','3185601436',0,'2014-03-08 21:30:42',NULL,NULL),(3783,2400,'TE','5137852898',0,'2013-12-25 19:33:31',NULL,NULL),(4101,2616,'TE','6148712855',0,'2013-12-25 19:45:45',NULL,NULL),(35701,23481,'AP','7046073996',0,'2014-02-13 22:01:55',NULL,NULL),(34978,22964,'TE','3309968610',0,'2014-02-12 21:00:12',NULL,NULL),(33198,21738,'AP','8067819673',0,'2014-02-06 21:00:14',NULL,NULL),(25323,16329,'TE','2253331861',0,'2014-01-07 04:01:57',NULL,NULL),(6187,3987,'AP','4193039390',0,'2013-12-25 21:38:59',NULL,NULL),(32135,20986,'TE','5133330204',0,'2014-02-01 19:00:23',NULL,NULL),(28522,18385,'TE','7406222851',0,'2014-01-16 08:45:37',NULL,NULL),(11094,7206,'EM','jmccarty4@neo.rr.com',0,'2013-12-26 02:00:48',NULL,NULL),(21124,13582,'EM','assistant9223@gmail.com',0,'2013-12-26 13:04:56',NULL,NULL),(12217,7981,'EM','ross1851@att.net',0,'2013-12-26 03:07:59',NULL,NULL),(1488,916,'TE','5138931442',0,'2013-12-25 18:08:41',NULL,NULL),(37216,24492,'EM','atutton@yahoo.com',0,'2014-02-20 03:45:18',NULL,NULL),(34721,22765,'EM','bakarygalledou@yahoo.com',0,'2014-02-11 21:01:35',NULL,NULL),(6384,4112,'AP','9378383220',0,'2013-12-25 21:48:02',NULL,NULL),(33748,22146,'TE','4408640421',0,'2014-02-08 19:00:51',NULL,NULL),(33021,21634,'TE','9564335519',0,'2014-02-05 21:30:42',NULL,NULL),(11258,7335,'AP','5138272771',0,'2013-12-26 02:03:53',NULL,NULL),(30639,19883,'EM','brian.ferguson18@yahoo.com',0,'2014-01-24 21:00:48',NULL,NULL),(39528,26146,'TE','3307885033',0,'2014-02-28 06:30:27',NULL,NULL),(39793,26310,'TE','7136735057',0,'2014-02-28 06:31:33',NULL,NULL),(40060,26561,'AP','5132626927',0,'2014-02-28 21:30:19',NULL,NULL),(31412,20478,'AP','5672077665',0,'2014-01-29 21:00:59',NULL,NULL),(814,507,'TE','9372394726',0,'2013-12-25 17:48:50',NULL,NULL),(35391,23261,'TE','3345689955',0,'2014-02-13 21:30:09',NULL,NULL),(25946,16714,'AP','8324993055',0,'2014-01-08 18:24:44',NULL,NULL),(11117,7230,'TE','5135022831',0,'2013-12-26 02:01:20',NULL,NULL),(5721,3671,'TE','4192622632',0,'2013-12-25 21:31:10',NULL,NULL),(3193,2006,'EM','dottielee@cheerful.com',0,'2013-12-25 19:02:21',NULL,NULL),(27879,17965,'EM','DEBRA_1775@SBCGLOBAL.NET',0,'2014-01-15 02:06:47',NULL,NULL),(40252,26704,'TE','4402404678',0,'2014-02-28 21:31:35',NULL,NULL),(1116,684,'AP','2487091547',0,'2013-12-25 18:02:29',NULL,NULL),(10356,6749,'EM','ford88_jarrett@yahoo.com',0,'2013-12-26 01:16:02',NULL,NULL),(11160,7259,'AP','9373028069',0,'2013-12-26 02:02:05',NULL,NULL),(12104,7910,'EM','nicholasfortuna1981@yahoo.com',0,'2013-12-26 03:06:04',NULL,NULL),(20330,13098,'AP','9376084868',0,'2013-12-26 12:52:06',NULL,NULL),(5898,3782,'EM','mgs_42476@yahoo.com',0,'2013-12-25 21:34:02',NULL,NULL),(6116,3937,'AP','9375649179',0,'2013-12-25 21:37:48',NULL,NULL),(37383,24618,'AP','6012148221',0,'2014-02-20 04:15:32',NULL,NULL),(37900,25000,'EM','jbrankine@sbcglobal.net',0,'2014-02-20 22:00:46',NULL,NULL),(38095,25145,'EM','TWUTOO@YAHOO.COM',0,'2014-02-21 22:00:13',NULL,NULL),(4241,2711,'EM','Kdouglaskorber@yahoo.com',0,'2013-12-25 19:47:59',NULL,NULL),(8371,5499,'EM','briand3180@gmail.com',0,'2013-12-25 23:11:18',NULL,NULL),(10136,6625,'AP','4193203254',0,'2013-12-26 00:54:11',NULL,NULL),(35210,23125,'EM','ponce_teo@yahoo.com',0,'2014-02-12 21:31:26',NULL,NULL),(1753,1081,'EM','greywolf44062@yahoo.com',0,'2013-12-25 18:16:47',NULL,NULL),(11157,7253,'EM','scootmike@aol.com',0,'2013-12-26 02:02:01',NULL,NULL),(13653,8902,'EM','brendachaffinphillips@gmail.com',0,'2013-12-26 04:02:19',NULL,NULL),(23353,15043,'TE','3374521572',0,'2014-01-01 12:03:03',NULL,NULL),(39050,25825,'AP','7405811185',0,'2014-02-26 21:00:28',NULL,NULL),(42015,27927,'AP','3615710189',0,'2014-03-06 21:00:23',NULL,NULL),(42621,28354,'TE','8307580534',0,'2014-03-07 21:30:24',NULL,NULL),(42647,28370,'TE','3258852131',0,'2014-03-07 21:30:34',NULL,NULL),(4544,2889,'EM','stevedoeswork@hotmail.com',0,'2013-12-25 20:15:08',NULL,NULL),(32614,21324,'AP','5042202148',0,'2014-02-04 21:00:24',NULL,NULL),(3599,2267,'AP','4193048953',0,'2013-12-25 19:30:19',NULL,NULL),(32029,20906,'EM','Cmas85krl@gmail.com',0,'2014-01-31 21:01:24',NULL,NULL),(20202,13016,'EM','klbowman@icloud.com',0,'2013-12-26 12:49:56',NULL,NULL),(28986,18708,'AP','5132054586',0,'2014-01-17 03:35:31',NULL,NULL),(27828,17931,'EM','H_K_G_@HOTMAIL.COM',0,'2014-01-15 02:06:35',NULL,NULL),(40870,27157,'AP','9375973099',0,'2014-03-03 21:30:57',NULL,NULL),(42339,28118,'TE','4195338011',0,'2014-03-06 21:02:19',NULL,NULL),(520,326,'AP','2516441222',0,'2013-12-25 17:31:31',NULL,NULL),(9290,6086,'TE','3302040649',0,'2013-12-26 00:02:36',NULL,NULL),(23988,15484,'EM','nagentile@aol.com',1,'2014-01-02 04:29:16',NULL,NULL),(28606,18439,'TE','2253370055',0,'2014-01-16 08:46:02',NULL,NULL),(1193,728,'TE','9722333402',0,'2013-12-25 18:03:42',NULL,NULL),(25148,16210,'TE','9403869097',0,'2014-01-05 00:01:27',NULL,NULL),(1960,1214,'TE','9372062505',0,'2013-12-25 18:20:11',NULL,NULL),(42033,27937,'TE','3253560091',0,'2014-03-06 21:00:29',NULL,NULL),(14894,9746,'EM','NKanney@yahoo.com',0,'2013-12-26 04:46:05',NULL,NULL),(14970,9794,'TE','3616589033',0,'2013-12-26 05:01:04',NULL,NULL),(34666,22731,'TE','5042067550',0,'2014-02-11 21:01:15',NULL,NULL),(9741,6372,'TE','4193072572',0,'2013-12-26 00:47:41',NULL,NULL),(31606,20615,'AP','3374926611',0,'2014-01-30 21:00:21',NULL,NULL),(31561,20572,'EM','rapitler@sbcglobo.net',0,'2014-01-29 21:01:53',NULL,NULL),(28739,18545,'AP','3096781866',0,'2014-01-16 08:46:51',NULL,NULL),(7808,5096,'TE','9565295003',0,'2013-12-25 23:01:20',NULL,NULL),(27303,17580,'EM','ss_hindel@hotmail.com',0,'2014-01-14 01:32:06',NULL,NULL),(5809,3731,'TE','2107878044',0,'2013-12-25 21:32:36',NULL,NULL),(38817,25662,'BN','3305694127',0,'2014-02-26 08:30:46',NULL,NULL),(38824,25666,'TE','3183825034',0,'2014-02-26 08:30:48',NULL,NULL),(25512,16451,'TE','9168974214',0,'2014-01-07 04:05:25',NULL,NULL),(36776,24215,'TE','5127888598',0,'2014-02-16 19:00:25',NULL,NULL),(28969,18697,'BN','3183310077',0,'2014-01-17 03:35:27',NULL,NULL),(1458,892,'EM','ruth_louderback@yahoo.com',0,'2013-12-25 18:08:02',NULL,NULL),(8043,5263,'AP','3305736946',0,'2013-12-25 23:05:24',NULL,NULL),(10895,7079,'AP','7408512275',0,'2013-12-26 01:50:16',NULL,NULL),(2480,1520,'AP','2164966565',0,'2013-12-25 18:49:47',NULL,NULL),(10050,6574,'AP','8285065337',0,'2013-12-26 00:52:46',NULL,NULL),(4299,2743,'EM','jthompson175@neo.rr.com',0,'2013-12-25 19:48:52',NULL,NULL),(41341,27464,'TE','3307752969',0,'2014-03-04 21:02:07',NULL,NULL),(21370,13741,'TE','3307845957',0,'2013-12-26 13:09:41',NULL,NULL),(36254,23857,'EM','epegan2006@gmail.com',0,'2014-02-14 21:32:02',NULL,NULL),(5567,3556,'EM','dcb4459@gmail.com',0,'2013-12-25 21:22:11',NULL,NULL),(8791,5759,'AP','6145801373',0,'2013-12-25 23:46:28',NULL,NULL),(9432,6173,'AP','5127969236',0,'2013-12-26 00:17:07',NULL,NULL),(10632,6916,'EM','kenw.cooper@yahoo.com',0,'2013-12-26 01:46:04',NULL,NULL),(27685,17845,'TE','3135663679',0,'2014-01-15 02:06:05',NULL,NULL),(26954,17335,'AP','5047103749',0,'2014-01-13 02:23:59',NULL,NULL),(1379,844,'TE','3186442285',0,'2013-12-25 18:06:41',NULL,NULL),(42322,28104,'AP','3306873728',0,'2014-03-06 21:02:12',NULL,NULL),(43534,28903,'AP','9156916129',0,'2014-03-10 21:00:22',NULL,NULL),(14298,9353,'TE','3374124765',0,'2013-12-26 04:31:18',NULL,NULL),(21488,13807,'TE','5133140487',0,'2013-12-26 13:11:32',NULL,NULL),(25444,16407,'TE','2542175447',0,'2014-01-07 04:04:06',NULL,NULL),(6777,4398,'TE','4342500529',0,'2013-12-25 22:01:04',NULL,NULL),(1330,813,'TE','4408126711',0,'2013-12-25 18:05:53',NULL,NULL),(21545,13849,'EM','AAichaelC@yahoo.com',0,'2013-12-26 13:12:35',NULL,NULL),(4525,2877,'AP','6147781389',0,'2013-12-25 20:02:06',NULL,NULL),(3594,2256,'AP','2162874884',0,'2013-12-25 19:30:11',NULL,NULL),(37655,24828,'AP','5133025862',0,'2014-02-20 04:51:31',NULL,NULL),(42706,28406,'AP','7404081691',0,'2014-03-07 21:30:54',NULL,NULL),(43225,28723,'TE','4197440744',0,'2014-03-08 21:31:22',NULL,NULL),(548,342,'AP','7405726676',0,'2013-12-25 17:32:00',NULL,NULL),(34847,22850,'AP','4196057609',0,'2014-02-11 21:02:20',NULL,NULL),(32341,21129,'AP','3612220553',0,'2014-02-03 21:00:17',NULL,NULL),(28768,18562,'AP','9375875265',0,'2014-01-16 08:47:00',NULL,NULL),(27533,17743,'TE','2165434277',0,'2014-01-14 01:33:23',NULL,NULL),(14198,9288,'AP','3308198480',0,'2013-12-26 04:16:05',NULL,NULL),(38746,25615,'AP','3615104122',0,'2014-02-26 08:30:12',NULL,NULL),(43382,28811,'TE','4196060981',0,'2014-03-09 21:00:55',NULL,NULL),(43666,28980,'TE','3306896324',0,'2014-03-10 21:01:08',NULL,NULL),(21885,14101,'TE','9375910728',0,'2013-12-27 02:01:35',NULL,NULL),(31055,20204,'TE','4197335383',0,'2014-01-27 21:01:34',NULL,NULL),(1844,1140,'EM','jonnielm@aol.com',0,'2013-12-25 18:18:19',NULL,NULL),(10121,6619,'AP','5132848620',0,'2013-12-26 00:53:59',NULL,NULL),(2614,1591,'EM','ercgrvs63@yahoo.com',0,'2013-12-25 18:51:46',NULL,NULL),(10377,6764,'TE','3376526372',0,'2013-12-26 01:16:26',NULL,NULL),(36280,23887,'AP','5132258662',0,'2014-02-14 21:32:16',NULL,NULL),(34091,22347,'TE','6143072406',0,'2014-02-10 11:01:13',NULL,NULL),(32624,21330,'TE','3306344003',0,'2014-02-04 21:00:28',NULL,NULL),(30916,20103,'EM','nicholeruffin11@gmail.com',0,'2014-01-27 21:00:36',NULL,NULL),(30356,19668,'TE','3183649282',0,'2014-01-23 21:00:30',NULL,NULL),(8323,5458,'AP','3308889459',0,'2013-12-25 23:10:20',NULL,NULL),(25402,16382,'AP','2147621933',0,'2014-01-07 04:03:22',NULL,NULL),(39767,26297,'TE','4196936187',0,'2014-02-28 06:31:27',NULL,NULL),(862,537,'EM','jtpreach@bellstaff.net',0,'2013-12-25 17:49:37',NULL,NULL),(35990,23678,'TE','3377899679',0,'2014-02-14 21:30:29',NULL,NULL),(9398,6151,'AP','7133732315',0,'2013-12-26 00:16:31',NULL,NULL),(12013,7825,'EM','dieptuan75@yahoo.com',0,'2013-12-26 03:04:18',NULL,NULL),(30642,19885,'EM','mrw092009@aol.com',0,'2014-01-24 21:00:48',NULL,NULL),(30249,19593,'BN','6012094699',0,'2014-01-23 03:02:45',NULL,NULL),(28585,18427,'TE','9855183408',0,'2014-01-16 08:45:56',NULL,NULL),(22286,14364,'AP','4192393641',0,'2013-12-28 03:30:21',NULL,NULL),(25447,16409,'TE','8308768966',0,'2014-01-07 04:04:10',NULL,NULL),(22518,14520,'AP','8328002485',0,'2013-12-28 03:34:16',NULL,NULL),(40225,26683,'AP','2258105078',0,'2014-02-28 21:31:24',NULL,NULL),(43984,29179,'AP','5136098138',0,'2014-03-10 21:03:04',NULL,NULL),(1216,741,'TE','9723584831',0,'2013-12-25 18:04:03',NULL,NULL),(36463,24009,'TE','5133687818',0,'2014-02-15 22:00:39',NULL,NULL),(13596,8864,'TE','9722249968',0,'2013-12-26 04:01:22',NULL,NULL),(10318,6731,'TE','3303237134',0,'2013-12-26 01:15:29',NULL,NULL),(6063,3902,'TE','3303253408',0,'2013-12-25 21:36:52',NULL,NULL),(8710,5715,'EM','tompott1@aol.com',0,'2013-12-25 23:45:15',NULL,NULL),(25911,16698,'AP','9567569968',0,'2014-01-08 18:24:38',NULL,NULL),(23651,15272,'EM','anjl214@yahoo.com',1,'2014-01-02 04:21:51',NULL,NULL),(22579,14563,'TE','2163712592',0,'2013-12-28 03:35:19',NULL,NULL),(2591,1581,'EM','MARCIEPURIFOY@ICLOUD.COM',0,'2013-12-25 18:51:26',NULL,NULL),(38789,25644,'BN','3302210493',0,'2014-02-26 08:30:33',NULL,NULL),(39658,26224,'TE','2544935005',0,'2014-02-28 06:30:58',NULL,NULL),(12213,7979,'EM','agelessmountain@yahoo.com',0,'2013-12-26 03:07:55',NULL,NULL),(36468,24010,'EM','marydee_47@hotmail.com',0,'2014-02-15 22:00:40',NULL,NULL),(34135,22380,'TE','3306865985',0,'2014-02-10 21:30:09',NULL,NULL),(10811,7023,'TE','2817040105',0,'2013-12-26 01:48:54',NULL,NULL),(29181,18854,'TE','8284215716',0,'2014-01-17 03:36:17',NULL,NULL),(21722,13994,'AP','4199535165',0,'2013-12-26 13:15:53',NULL,NULL),(4348,2774,'EM','kgsmith54@gmail.com',0,'2013-12-25 19:49:38',NULL,NULL),(9675,6339,'AP','5135018384',0,'2013-12-26 00:46:44',NULL,NULL),(24047,15527,'TE','9858395457',1,'2014-01-02 04:30:30',NULL,NULL),(7031,4591,'TE','3306452447',0,'2013-12-25 22:05:29',NULL,NULL),(22634,14595,'TE','3305928708',0,'2013-12-28 03:36:14',NULL,NULL),(37888,24994,'AP','2143349988',0,'2014-02-20 22:00:42',NULL,NULL),(39621,26205,'TE','3302817052',0,'2014-02-28 06:30:50',NULL,NULL),(41821,27809,'TE','4403347584',0,'2014-03-05 21:31:49',NULL,NULL),(23868,15402,'EM','flexxy_r@yahoo.com',1,'2014-01-02 04:26:50',NULL,NULL),(14414,9423,'AP','9564331128',0,'2013-12-26 04:33:11',NULL,NULL),(34577,22672,'AP','9406136650',0,'2014-02-11 21:00:42',NULL,NULL),(33114,21691,'EM','Ja225ke@yahoo.com',0,'2014-02-05 21:31:06',NULL,NULL),(10241,6696,'TE','5134014181',0,'2013-12-26 01:01:44',NULL,NULL),(14980,9802,'TE','5136380617',0,'2013-12-26 05:01:15',NULL,NULL),(9688,6347,'TE','2164082985',0,'2013-12-26 00:46:56',NULL,NULL),(27255,17548,'TE','9375442062',0,'2014-01-13 03:01:52',NULL,NULL),(23399,15070,'EM','rsantibanez0127@gmail.com',0,'2014-01-01 12:03:53',NULL,NULL),(20636,13274,'AP','7138753961',0,'2013-12-26 12:57:00',NULL,NULL),(7507,4892,'TE','9154749955',0,'2013-12-25 22:31:33',NULL,NULL),(7708,5032,'EM','meerkat1@zoomtown.com',0,'2013-12-25 22:47:48',NULL,NULL),(1072,658,'EM','carolyn.sanders57@yahoo.com',0,'2013-12-25 18:01:49',NULL,NULL),(37198,24484,'TE','5135753380',0,'2014-02-18 22:01:47',NULL,NULL),(35914,23633,'TE','9038049852',0,'2014-02-14 21:30:04',NULL,NULL),(32815,21470,'AP','6012094066',0,'2014-02-04 21:01:38',NULL,NULL),(29882,19338,'AP','8325150645',1,'2014-01-22 03:22:19',NULL,NULL),(25579,16500,'TE','9377760690',0,'2014-01-07 04:06:50',NULL,NULL),(24163,15614,'EM','jw712msu@gmail.com',1,'2014-01-02 04:32:56',NULL,NULL),(2165,1331,'EM','chad@chadkirchner.com',0,'2013-12-25 18:32:07',NULL,NULL),(12198,7971,'TE','6628366241',0,'2013-12-26 03:07:41',NULL,NULL),(25725,16581,'AP','2252239822',0,'2014-01-08 18:23:57',NULL,NULL),(37004,24366,'AP','5044730074',0,'2014-02-18 22:00:35',NULL,NULL),(7544,4914,'AP','6014028797',0,'2013-12-25 22:32:12',NULL,NULL),(29998,19425,'TE','5136028392',1,'2014-01-22 03:23:04',NULL,NULL),(22854,14746,'TE','5135530030',1,'2013-12-29 11:10:12',NULL,NULL),(9377,6137,'TE','9852349393',0,'2013-12-26 00:16:10',NULL,NULL),(10542,6866,'TE','2815960800',0,'2013-12-26 01:31:50',NULL,NULL),(14471,9451,'EM','mattyham61@gmail.com',0,'2013-12-26 04:33:59',NULL,NULL),(41248,27404,'AP','2167856615',0,'2014-03-04 21:01:33',NULL,NULL),(42763,28443,'AP','5046692604',0,'2014-03-07 21:31:15',NULL,NULL),(324,201,'EM','edlhanson@earthlink.net',0,'2013-12-25 17:20:13',NULL,NULL),(37673,24841,'TE','3308631538',0,'2014-02-20 04:53:57',NULL,NULL),(37271,24526,'TE','9723452929',0,'2014-02-20 03:59:05',NULL,NULL),(36450,24001,'EM','waters.kristi@gmail.com',0,'2014-02-15 22:00:33',NULL,NULL),(34803,22830,'AP','3303100462',0,'2014-02-11 21:02:07',NULL,NULL),(2855,1744,'TE','2163249154',0,'2013-12-25 18:55:35',NULL,NULL),(30038,19456,'TE','2816820230',0,'2014-01-23 03:01:54',NULL,NULL),(13912,9070,'EM','drtrudybond@gmail.com',0,'2013-12-26 04:06:36',NULL,NULL),(20693,13304,'TE','9793089916',0,'2013-12-26 12:57:52',NULL,NULL),(43970,29170,'TE','5704197178',0,'2014-03-10 21:02:59',NULL,NULL),(450,279,'AP','2148091289',0,'2013-12-25 17:30:15',NULL,NULL),(36560,24068,'AP','3303105760',0,'2014-02-15 22:01:14',NULL,NULL),(34090,22345,'EM','doublexs18@yahoo.com',0,'2014-02-10 11:01:12',NULL,NULL),(33991,22296,'EM','robert.lantz@outlook.com',0,'2014-02-10 11:00:33',NULL,NULL),(32890,21529,'EM','randi_batts2000@yahoo.com',0,'2014-02-05 21:30:06',NULL,NULL),(31837,20785,'AP','9152613515',0,'2014-01-31 21:00:12',NULL,NULL),(8379,5515,'EM','walshpjw@gmail.com',0,'2013-12-25 23:15:11',NULL,NULL),(27948,18008,'AP','5136333270',0,'2014-01-15 02:07:02',NULL,NULL),(5379,3443,'TE','9378384755',0,'2013-12-25 21:19:18',NULL,NULL),(2918,1789,'TE','5755209679',0,'2013-12-25 18:56:32',NULL,NULL),(3374,2120,'AP','3307600310',0,'2013-12-25 19:17:42',NULL,NULL),(14474,9453,'TE','5132585300',0,'2013-12-26 04:34:02',NULL,NULL),(7773,5071,'EM','katiebaby327@yahoo.com',0,'2013-12-25 23:00:44',NULL,NULL),(7307,4755,'AP','9036914140',0,'2013-12-25 22:15:21',NULL,NULL),(34919,22914,'TE','4193763987',0,'2014-02-11 21:02:50',NULL,NULL),(34582,22676,'TE','8174539129',0,'2014-02-11 21:00:44',NULL,NULL),(29154,18836,'AP','4403619820',0,'2014-01-17 03:36:11',NULL,NULL),(24697,15930,'TE','5137538368',0,'2014-01-03 02:06:53',NULL,NULL),(20439,13161,'AP','7407033151',0,'2013-12-26 12:53:52',NULL,NULL),(3763,2387,'AP','7405160182',0,'2013-12-25 19:33:11',NULL,NULL),(613,378,'TE','9032585003',0,'2013-12-25 17:45:37',NULL,NULL),(38654,25547,'TE','2147349899',0,'2014-02-26 08:00:15',NULL,NULL),(43486,28877,'TE','9569437965',0,'2014-03-10 21:00:06',NULL,NULL),(1770,1095,'TE','4407850343',0,'2013-12-25 18:17:06',NULL,NULL),(33113,21691,'AP','2252411344',0,'2014-02-05 21:31:06',NULL,NULL),(32917,21549,'TE','9372331149',0,'2014-02-05 21:30:13',NULL,NULL),(31723,20702,'TE','5049487451',0,'2014-01-30 21:01:04',NULL,NULL),(8673,5694,'TE','3306761909',0,'2013-12-25 23:32:42',NULL,NULL),(24863,16032,'BN','5043170816',0,'2014-01-04 02:02:33',NULL,NULL),(12465,8160,'AP','4196193003',0,'2013-12-26 03:16:20',NULL,NULL),(23802,15352,'EM','keni333.jk@gmail.com',1,'2014-01-02 04:24:36',NULL,NULL),(6285,4052,'AP','4402130968',0,'2013-12-25 21:46:26',NULL,NULL),(20856,13408,'EM','dean.cobb1973@att.net',0,'2013-12-26 13:00:31',NULL,NULL),(38443,25405,'EM','jaamac144@hot.mail',0,'2014-02-25 21:30:59',NULL,NULL),(42151,28003,'AP','3302174133',0,'2014-03-06 21:01:10',NULL,NULL),(42707,28407,'TE','7405755380',0,'2014-03-07 21:30:55',NULL,NULL),(27545,17751,'AP','6626070568',0,'2014-01-14 01:33:28',NULL,NULL),(37587,24760,'EM','nmoore4035@yahoo.com',0,'2014-02-20 04:43:07',NULL,NULL),(8817,5775,'TE','6148644825',0,'2013-12-25 23:46:53',NULL,NULL),(21356,13726,'TE','3309060192',0,'2013-12-26 13:09:19',NULL,NULL),(5678,3646,'TE','7405918360',0,'2013-12-25 21:30:32',NULL,NULL),(6549,4233,'AP','7134106924',0,'2013-12-25 21:50:46',NULL,NULL),(3920,2487,'TE','5045257329',0,'2013-12-25 19:35:42',NULL,NULL),(22406,14449,'EM','ADLAMBERT01@GMAIL.COM',0,'2013-12-28 03:32:27',NULL,NULL),(39069,25840,'BN','3307491287',0,'2014-02-26 21:00:35',NULL,NULL),(39954,26448,'TE','3303174657',0,'2014-02-28 07:30:24',NULL,NULL),(25966,16725,'AP','3302618463',0,'2014-01-08 18:24:48',NULL,NULL),(25865,16670,'TE','6148610779',0,'2014-01-08 18:24:28',NULL,NULL),(34215,22439,'EM','excelloclan@aol.com',0,'2014-02-10 21:30:41',NULL,NULL),(21390,13755,'TE','6308908002',0,'2013-12-26 13:10:03',NULL,NULL),(31014,20178,'TE','4192890723',0,'2014-01-27 21:01:18',NULL,NULL),(4614,2942,'EM','datzbach@columbus.rr.com',0,'2013-12-25 20:16:17',NULL,NULL),(10759,6995,'TE','2144580480',0,'2013-12-26 01:48:06',NULL,NULL),(2881,1764,'AP','3103467943',0,'2013-12-25 18:55:59',NULL,NULL),(8207,5374,'TE','2253133397',0,'2013-12-25 23:08:09',NULL,NULL),(3315,2085,'AP','5047825193',0,'2013-12-25 19:16:44',NULL,NULL),(2858,1745,'TE','2165211452',0,'2013-12-25 18:55:38',NULL,NULL),(7881,5138,'TE','7027431407',0,'2013-12-25 23:02:27',NULL,NULL),(10240,6695,'AP','5126775288',0,'2013-12-26 01:01:42',NULL,NULL),(41449,27535,'EM','hhtohio@sssnet.com',0,'2014-03-04 21:30:05',NULL,NULL),(28724,18536,'AP','4197050165',0,'2014-01-16 08:46:46',NULL,NULL),(36675,24150,'TE','9375091339',0,'2014-02-15 22:01:55',NULL,NULL),(24832,16016,'AP','5042965557',0,'2014-01-04 02:02:01',NULL,NULL),(24079,15544,'EM','lisa.m.bourgeois.iqhy@statefarm.com',1,'2014-01-02 04:31:05',NULL,NULL),(8969,5881,'TE','4406854206',0,'2013-12-25 23:49:25',NULL,NULL),(10044,6570,'TE','3179101600',0,'2013-12-26 00:52:40',NULL,NULL),(10424,6796,'EM','mbarker@neo.rr.com',0,'2013-12-26 01:17:14',NULL,NULL),(5411,3466,'TE','2167511949',0,'2013-12-25 21:19:49',NULL,NULL),(12403,8123,'TE','2167805601',0,'2013-12-26 03:15:19',NULL,NULL),(2541,1554,'AP','6013192728',0,'2013-12-25 18:50:42',NULL,NULL),(21588,13889,'TE','4195174803',0,'2013-12-26 13:13:26',NULL,NULL),(39464,26097,'TE','5046067491',0,'2014-02-28 06:30:11',NULL,NULL),(41339,27463,'TE','3308371353',0,'2014-03-04 21:02:06',NULL,NULL),(42416,28169,'EM','monamontet@yahoo.com',0,'2014-03-06 21:02:48',NULL,NULL),(13597,8864,'EM','wrobinson656@gmail.com',0,'2013-12-26 04:01:22',NULL,NULL),(39350,26028,'TE','6015732290',0,'2014-02-26 21:02:19',NULL,NULL),(14800,9687,'AP','4193056218',0,'2013-12-26 04:39:36',NULL,NULL),(37874,24984,'EM','dswoboda323@yahoo.com',0,'2014-02-20 22:00:36',NULL,NULL),(37644,24812,'TE','5139009025',0,'2014-02-20 04:50:07',NULL,NULL),(21346,13716,'EM','attybobbo@yahoo.com',0,'2013-12-26 13:09:06',NULL,NULL),(27304,17584,'TE','3303251861',0,'2014-01-14 01:32:07',NULL,NULL),(36169,23804,'EM','last692@yahoo.com',0,'2014-02-14 21:31:31',NULL,NULL),(35668,23459,'TE','9564881090',0,'2014-02-13 22:01:42',NULL,NULL),(34322,22519,'AP','2144188315',0,'2014-02-10 21:31:24',NULL,NULL),(1070,658,'TE','5672257240',0,'2013-12-25 18:01:49',NULL,NULL),(8140,5327,'AP','5133744742',0,'2013-12-25 23:07:00',NULL,NULL),(38962,25760,'AP','4403447749',0,'2014-02-26 09:30:51',NULL,NULL),(1857,1147,'AP','3352878596',0,'2013-12-25 18:18:31',NULL,NULL),(2262,1386,'AP','3189906512',0,'2013-12-25 18:46:14',NULL,NULL),(23107,14898,'AP','3183021544',0,'2013-12-30 00:01:02',NULL,NULL),(23717,15306,'TE','3185729278',1,'2014-01-02 04:23:01',NULL,NULL),(28496,18362,'AP','5136331088',0,'2014-01-16 08:45:27',NULL,NULL),(26132,16824,'AP','5442203216',0,'2014-01-13 02:18:25',NULL,NULL),(25082,16172,'TE','2252350434',0,'2014-01-05 00:00:16',NULL,NULL),(12065,7877,'TE','5138435473',0,'2013-12-26 03:05:20',NULL,NULL),(38957,25757,'AP','8322210978',0,'2014-02-26 09:30:49',NULL,NULL),(23256,14984,'EM','bjlogan11@yahoo.com',0,'2014-01-01 12:01:12',NULL,NULL),(32270,21079,'EM','toddjbruder@gmail.com',0,'2014-02-02 19:00:21',NULL,NULL),(26327,16948,'AP','6019540574',0,'2014-01-13 02:19:58',NULL,NULL),(20996,13511,'EM','mrmikel@yahoo.com',0,'2013-12-26 13:02:55',NULL,NULL),(24438,15775,'EM','zuritaz@888gmail.com',0,'2014-01-03 02:01:58',NULL,NULL),(37541,24717,'TE','3308631538',0,'2014-02-20 04:37:27',NULL,NULL),(36516,24041,'TE','8176090303',0,'2014-02-15 22:00:58',NULL,NULL),(30001,19427,'TE','5675250592',1,'2014-01-22 03:23:05',NULL,NULL),(28131,18134,'TE','8592403883',0,'2014-01-15 02:07:44',NULL,NULL),(41954,27889,'TE','4197440533',0,'2014-03-05 21:32:38',NULL,NULL),(43912,29133,'AP','4192023107',0,'2014-03-10 21:02:38',NULL,NULL),(100,58,'AP','5174905840',0,'2013-12-25 17:16:36',NULL,NULL),(37278,24531,'AP','9562517685',0,'2014-02-20 04:00:40',NULL,NULL),(36507,24034,'EM','ginger@courts4sports.com',0,'2014-02-15 22:00:55',NULL,NULL),(4166,2656,'AP','8172661965',0,'2013-12-25 19:46:46',NULL,NULL),(29486,19058,'AP','6017381888',0,'2014-01-21 08:44:13',NULL,NULL),(28143,18142,'AP','5047222053',0,'2014-01-15 02:07:47',NULL,NULL),(24355,15728,'EM','d.rine_069@hotmail.com',0,'2014-01-03 02:00:25',NULL,NULL),(11110,7224,'TE','4194205880',0,'2013-12-26 02:01:12',NULL,NULL),(22087,14228,'AP','2547185751',0,'2013-12-27 02:04:54',NULL,NULL),(21519,13831,'AP','3304147918',0,'2013-12-26 13:12:06',NULL,NULL),(20270,13064,'EM','Elihudi@hotmail.com',0,'2013-12-26 12:51:08',NULL,NULL),(5265,3381,'TE','2816717356',0,'2013-12-25 21:17:31',NULL,NULL),(9737,6370,'AP','3306966709',0,'2013-12-26 00:47:38',NULL,NULL),(911,562,'AP','4196033052',0,'2013-12-25 17:50:22',NULL,NULL),(38591,25502,'EM','ahuscroft@yahoo.com',0,'2014-02-25 21:31:56',NULL,NULL),(30359,19669,'TE','8322318781',0,'2014-01-23 21:00:30',NULL,NULL),(29254,18893,'AP','3304147061',0,'2014-01-17 03:36:33',NULL,NULL),(11384,7411,'EM','jeremytarver1@gmail.com',0,'2013-12-26 02:16:45',NULL,NULL),(8601,5652,'TE','9154439316',0,'2013-12-25 23:31:32',NULL,NULL),(12344,8073,'TE','4195841808',0,'2013-12-26 03:10:18',NULL,NULL),(22006,14173,'TE','8327607996',0,'2013-12-27 02:03:31',NULL,NULL),(21521,13835,'AP','5082747522',0,'2013-12-26 13:12:10',NULL,NULL),(20903,13444,'TE','4405418563',0,'2013-12-26 13:01:18',NULL,NULL),(14473,9452,'AP','5132585300',0,'2013-12-26 04:34:01',NULL,NULL),(519,326,'TE','2516441222',0,'2013-12-25 17:31:31',NULL,NULL),(38985,25780,'AP','3306184099',0,'2014-02-26 09:31:01',NULL,NULL),(21480,13803,'EM','randyskolnik@hotmail.com',0,'2013-12-26 13:11:24',NULL,NULL),(36964,24339,'EM','ampcjv317@aol.com',0,'2014-02-18 22:00:19',NULL,NULL),(27440,17677,'TE','5042522765',0,'2014-01-14 01:32:52',NULL,NULL),(29691,19189,'AP','9032587644',0,'2014-01-21 08:46:12',NULL,NULL),(28399,18300,'TE','7403846518',0,'2014-01-16 08:44:56',NULL,NULL),(40537,26904,'EM','tprovosty@gmail.com',0,'2014-03-03 01:00:09',NULL,NULL),(42835,28489,'AP','4194421620',0,'2014-03-07 21:31:40',NULL,NULL),(43257,28741,'EM','shaun_111@icloud.com',0,'2014-03-09 21:00:10',NULL,NULL),(6610,4269,'AP','5672041369',0,'2013-12-25 21:51:43',NULL,NULL),(39536,26157,'TE','9378454127',0,'2014-02-28 06:30:31',NULL,NULL),(38895,25711,'TE','4327559889',0,'2014-02-26 09:30:23',NULL,NULL),(6026,3868,'EM','info@maguireplasticsurgery.com',0,'2013-12-25 21:36:08',NULL,NULL),(34568,22667,'EM','BARNGUY54@GMAIL.COM',0,'2014-02-11 21:00:39',NULL,NULL),(2762,1675,'AP','5138056950',0,'2013-12-25 18:53:59',NULL,NULL),(30592,19850,'EM','bluizztoo@gmail.com',0,'2014-01-24 21:00:30',NULL,NULL),(29887,19340,'TE','4695856631',1,'2014-01-22 03:22:20',NULL,NULL),(3116,1942,'AP','3309985578',0,'2013-12-25 19:00:43',NULL,NULL),(7468,4861,'EM','bowie1215@aol.com',0,'2013-12-25 22:30:41',NULL,NULL),(22447,14475,'TE','5128282604',0,'2013-12-28 03:33:08',NULL,NULL),(42574,28330,'TE','2147973992',0,'2014-03-07 21:30:10',NULL,NULL),(371,226,'TE','3185392891',0,'2013-12-25 17:20:56',NULL,NULL),(853,530,'TE','6017362192',0,'2013-12-25 17:49:26',NULL,NULL),(32834,21485,'AP','4194387060',0,'2014-02-04 21:01:45',NULL,NULL),(31169,20298,'EM','mikebass@inbox.com',0,'2014-01-28 21:00:41',NULL,NULL),(29680,19179,'EM','mikejoe1783@gmail.com',0,'2014-01-21 08:46:07',NULL,NULL),(28190,18170,'TE','5137247291',0,'2014-01-15 02:07:57',NULL,NULL),(27552,17757,'TE','5132524444',0,'2014-01-14 01:33:31',NULL,NULL),(25565,16491,'TE','4193713224',0,'2014-01-07 04:06:34',NULL,NULL),(25517,16454,'TE','4195350327',0,'2014-01-07 04:05:31',NULL,NULL),(25062,16156,'AP','6147950232',0,'2014-01-04 06:00:04',NULL,NULL),(3286,2067,'AP','2169064763',0,'2013-12-25 19:16:16',NULL,NULL),(1814,1123,'AP','5673711888',0,'2013-12-25 18:17:50',NULL,NULL),(21155,13602,'AP','4192034113',0,'2013-12-26 13:05:27',NULL,NULL),(20879,13423,'EM','emecklenborg@yahoo.com',0,'2013-12-26 13:00:53',NULL,NULL),(6573,4243,'TE','5125852017',0,'2013-12-25 21:51:05',NULL,NULL),(6220,4011,'AP','5135161412',0,'2013-12-25 21:45:25',NULL,NULL),(2754,1669,'EM','sweetblack911@yahoo.com',0,'2013-12-25 18:53:51',NULL,NULL),(30490,19779,'AP','4199137997',0,'2014-01-23 21:01:33',NULL,NULL),(29101,18792,'AP','9375223111',0,'2014-01-17 03:35:57',NULL,NULL),(23456,15117,'EM','Mdgreen85@icloud.com',0,'2014-01-01 12:05:10',NULL,NULL),(7797,5089,'TE','8324521664',0,'2013-12-25 23:01:10',NULL,NULL),(7407,4817,'AP','5134440220',0,'2013-12-25 22:16:59',NULL,NULL),(40444,26849,'AP','6012782932',0,'2014-03-01 21:00:50',NULL,NULL),(10502,6840,'AP','3189968294',0,'2013-12-26 01:31:05',NULL,NULL),(4442,2832,'TE','3378845779',0,'2013-12-25 20:00:47',NULL,NULL),(37961,25047,'TE','5132535115',0,'2014-02-20 22:01:15',NULL,NULL),(37345,24586,'EM','buterflyze02@att.net',0,'2014-02-20 04:09:57',NULL,NULL),(36409,23979,'EM','Tinabhenderson@gmail.com',0,'2014-02-15 22:00:19',NULL,NULL),(35937,23645,'AP','9792030189',0,'2014-02-14 21:30:11',NULL,NULL),(14531,9493,'AP','4404206034',0,'2013-12-26 04:34:58',NULL,NULL),(25158,16218,'TE','5135825103',0,'2014-01-05 00:01:43',NULL,NULL),(40792,27111,'AP','7405411570',0,'2014-03-03 21:30:26',NULL,NULL),(42251,28064,'TE','9375479224',0,'2014-03-06 21:01:46',NULL,NULL),(12445,8152,'AP','7138549555',0,'2013-12-26 03:16:04',NULL,NULL),(36920,24315,'TE','8175681272',0,'2014-02-18 22:00:04',NULL,NULL),(32175,21016,'EM','kasm1@att.net',0,'2014-02-01 19:00:37',NULL,NULL),(20562,13234,'TE','2816877461',0,'2013-12-26 12:55:51',NULL,NULL),(21846,14071,'AP','6145802793',0,'2013-12-27 02:00:52',NULL,NULL),(10268,6707,'EM','anastasia.seward@yahoo.com',0,'2013-12-26 01:02:07',NULL,NULL),(9218,6033,'TE','9038752363',0,'2013-12-26 00:01:11',NULL,NULL),(3133,1951,'AP','4698655673',0,'2013-12-25 19:01:00',NULL,NULL),(36267,23869,'BN','4193038352',0,'2014-02-14 21:32:09',NULL,NULL),(35902,23623,'TE','4409356086',0,'2014-02-13 22:03:18',NULL,NULL),(25208,16255,'AP','6015305129',0,'2014-01-05 00:02:44',NULL,NULL),(31047,20198,'TE','9013830928',0,'2014-01-27 21:01:30',NULL,NULL),(41238,27388,'EM','SILKJ2@GMAIL.COM',0,'2014-03-04 21:01:26',NULL,NULL),(4135,2638,'TE','2165361993',0,'2013-12-25 19:46:16',NULL,NULL),(37480,24680,'TE','9402229901',0,'2014-02-20 04:30:09',NULL,NULL),(34141,22387,'AP','3306717704',0,'2014-02-10 21:30:12',NULL,NULL),(6199,3994,'EM','gwolf76@gmail.com',0,'2013-12-25 21:39:12',NULL,NULL),(8199,5367,'TE','5134041534',0,'2013-12-25 23:07:59',NULL,NULL),(38997,25786,'BN','3307017504',0,'2014-02-26 09:31:06',NULL,NULL),(38748,25617,'AP','8325746299',0,'2014-02-26 08:30:13',NULL,NULL),(32109,20968,'EM','jrussa216@gmail.com',0,'2014-02-01 19:00:13',NULL,NULL),(30355,19667,'AP','9855171724',0,'2014-01-23 21:00:29',NULL,NULL),(2299,1408,'TE','7732187521',0,'2013-12-25 18:46:49',NULL,NULL),(28373,18281,'AP','5129376848',0,'2014-01-16 08:44:47',NULL,NULL),(42274,28074,'AP','5024087982',0,'2014-03-06 21:01:53',NULL,NULL),(7491,4876,'AP','9723427208',0,'2013-12-25 22:31:09',NULL,NULL),(35501,23341,'TE','4406559466',0,'2014-02-13 22:00:38',NULL,NULL),(12429,8140,'TE','4199339988',0,'2013-12-26 03:15:47',NULL,NULL),(13719,8940,'AP','5136000476',0,'2013-12-26 04:03:18',NULL,NULL),(33102,21682,'AP','9376615415',0,'2014-02-05 21:31:03',NULL,NULL),(31289,20384,'TE','9129803208',0,'2014-01-29 21:00:13',NULL,NULL),(5802,3725,'TE','9377879087',0,'2013-12-25 21:32:27',NULL,NULL),(25173,16232,'EM','MPS072@YAHOO.COM',0,'2014-01-05 00:02:05',NULL,NULL),(21955,14142,'AP','3187330188',0,'2013-12-27 02:02:42',NULL,NULL),(43139,28675,'TE','5672771572',0,'2014-03-08 21:30:52',NULL,NULL),(871,542,'TE','3307304608',0,'2013-12-25 17:49:46',NULL,NULL),(11593,7543,'TE','8323269441',0,'2013-12-26 02:32:58',NULL,NULL),(11231,7312,'TE','3306464929',0,'2013-12-26 02:03:22',NULL,NULL),(3527,2206,'TE','3309791324',0,'2013-12-25 19:20:11',NULL,NULL),(9929,6499,'TE','4409753860',0,'2013-12-26 00:50:47',NULL,NULL),(22643,14601,'TE','9373697607',0,'2013-12-28 03:36:24',NULL,NULL),(26101,16809,'TE','8632322183',0,'2014-01-13 02:18:15',NULL,NULL),(6733,4374,'TE','2163380136',0,'2013-12-25 22:00:24',NULL,NULL),(13886,9055,'AP','5124198846',0,'2013-12-26 04:06:10',NULL,NULL),(10273,6709,'AP','2282167028',0,'2013-12-26 01:02:11',NULL,NULL),(35987,23676,'BN','7036252196',0,'2014-02-14 21:30:27',NULL,NULL),(1076,661,'EM','blairgdp@frontier.com',0,'2013-12-25 18:01:54',NULL,NULL),(20687,13300,'TE','3252124161',0,'2013-12-26 12:57:46',NULL,NULL),(30763,19993,'TE','5137674436',0,'2014-01-25 19:00:21',NULL,NULL),(30445,19736,'TE','3183878193',0,'2014-01-23 21:01:09',NULL,NULL),(24219,15647,'AP','2283271132',1,'2014-01-02 04:33:59',NULL,NULL),(186,110,'AP','8653872231',0,'2013-12-25 17:17:57',NULL,NULL),(13852,9032,'EM','paduaorange2002@aol.com',0,'2013-12-26 04:05:37',NULL,NULL),(39399,26053,'TE','3307853413',0,'2014-02-26 21:02:34',NULL,NULL),(37263,24520,'TE','9159229979',0,'2014-02-20 03:56:56',NULL,NULL),(34733,22774,'TE','5137370974',0,'2014-02-11 21:01:40',NULL,NULL),(32716,21402,'TE','5133904438',0,'2014-02-04 21:01:03',NULL,NULL),(32660,21360,'AP','5047150668',0,'2014-02-04 21:00:43',NULL,NULL),(26124,16820,'EM','VABELTRAN20@YAHOO.COM',0,'2014-01-13 02:18:22',NULL,NULL),(25893,16690,'AP','8067777582',0,'2014-01-08 18:24:34',NULL,NULL),(11402,7420,'AP','7632189645',0,'2013-12-26 02:17:01',NULL,NULL),(2069,1280,'TE','9378254518',0,'2013-12-25 18:30:32',NULL,NULL),(6464,4181,'TE','3304641663',0,'2013-12-25 21:49:25',NULL,NULL),(4279,2735,'TE','4145304295',0,'2013-12-25 19:48:36',NULL,NULL),(9259,6059,'TE','5138872755',0,'2013-12-26 00:01:54',NULL,NULL),(42085,27963,'TE','5042088186',0,'2014-03-06 21:00:46',NULL,NULL),(429,264,'TE','3307193951',0,'2013-12-25 17:21:55',NULL,NULL),(11272,7348,'EM','mbeshalske@gmail.com',0,'2013-12-26 02:04:11',NULL,NULL),(4813,3079,'EM','thomthomtime@outlook.com',0,'2013-12-25 20:19:41',NULL,NULL),(36520,24044,'AP','8176090303',0,'2014-02-15 22:01:00',NULL,NULL),(10522,6853,'AP','9375452138',0,'2013-12-26 01:31:27',NULL,NULL),(4533,2882,'TE','8325701069',0,'2013-12-25 20:02:16',NULL,NULL),(29753,19238,'EM','frankibragg@yahoo.com',0,'2014-01-21 08:46:36',NULL,NULL),(28355,18271,'AP','2813808400',0,'2014-01-16 08:44:41',NULL,NULL),(26008,16755,'TE','8322175101',0,'2014-01-08 18:24:56',NULL,NULL),(23486,15146,'AP','3476612082',0,'2014-01-01 12:05:54',NULL,NULL),(4513,2870,'TE','8323878818',0,'2013-12-25 20:01:56',NULL,NULL),(42998,28594,'EM','vhiris@gmail.com',0,'2014-03-08 21:30:05',NULL,NULL),(43537,28904,'EM','reylin@verizon.net',0,'2014-03-10 21:00:23',NULL,NULL),(629,391,'TE','3306380107',0,'2013-12-25 17:45:55',NULL,NULL),(35940,23647,'TE','8179419811',0,'2014-02-14 21:30:12',NULL,NULL),(35463,23323,'AP','4198132028',0,'2014-02-13 22:00:25',NULL,NULL),(23970,15470,'EM','amygarcia0218@gmail.com',1,'2014-01-02 04:28:54',NULL,NULL),(32038,20913,'AP','3303489192',0,'2014-01-31 21:01:29',NULL,NULL),(4694,3002,'EM','vanessarastetter@gmail.com',0,'2013-12-25 20:17:41',NULL,NULL),(11813,7685,'TE','5136331088',0,'2013-12-26 03:00:54',NULL,NULL),(1049,646,'TE','9374511193',0,'2013-12-25 18:01:29',NULL,NULL),(5731,3675,'TE','9377710001',0,'2013-12-25 21:31:18',NULL,NULL),(9099,5965,'EM','drjackson49@yahoo.com',0,'2013-12-25 23:51:27',NULL,NULL),(41215,27374,'TE','2284242303',0,'2014-03-04 21:01:18',NULL,NULL),(37610,24784,'EM','kkopis@hotmail.com',0,'2014-02-20 04:45:58',NULL,NULL),(10790,7014,'AP','8062836595',0,'2013-12-26 01:48:37',NULL,NULL),(33201,21739,'AP','8067819673',0,'2014-02-06 21:00:14',NULL,NULL),(32329,21119,'TE','4326145211',0,'2014-02-03 21:00:12',NULL,NULL),(27902,17979,'TE','3307334943',0,'2014-01-15 02:06:52',NULL,NULL),(43615,28953,'EM','stephenphillips10@yahoo.com',0,'2014-03-10 21:00:52',NULL,NULL),(37,25,'EM','freemianda@gmail.com',0,'2013-12-25 17:15:38',NULL,NULL),(22149,14265,'AP','5132911269',0,'2013-12-27 02:05:56',NULL,NULL),(39987,26483,'TE','7132561368',0,'2014-02-28 21:00:05',NULL,NULL),(38651,25543,'AP','2163333596',0,'2014-02-26 08:00:13',NULL,NULL),(30415,19715,'EM','bobw_thomas@yahoo.com',0,'2014-01-23 21:00:55',NULL,NULL),(26093,16804,'TE','4092891023',0,'2014-01-13 02:18:13',NULL,NULL),(14334,9371,'EM','mediaprosource@yahoo.com',0,'2013-12-26 04:31:50',NULL,NULL),(7057,4609,'AP','3305848509',0,'2013-12-25 22:05:56',NULL,NULL),(6719,4366,'AP','5133206656',0,'2013-12-25 22:00:11',NULL,NULL),(10385,6769,'AP','5042506502',0,'2013-12-26 01:16:34',NULL,NULL),(10107,6606,'TE','9375264412',0,'2013-12-26 00:53:40',NULL,NULL),(9421,6165,'TE','9375470457',0,'2013-12-26 00:16:54',NULL,NULL),(43227,28724,'TE','2259938282',0,'2014-03-09 20:59:59',NULL,NULL),(8209,5375,'TE','2259284272',0,'2013-12-25 23:08:11',NULL,NULL),(22757,14675,'TE','6013354161',1,'2013-12-29 11:08:23',NULL,NULL),(11456,7448,'AP','9376715957',0,'2013-12-26 02:30:39',NULL,NULL),(5526,3534,'EM','loriandelvis@yahoo.com',0,'2013-12-25 21:21:35',NULL,NULL),(35580,23397,'TE','5138753057',0,'2014-02-13 22:01:09',NULL,NULL),(23215,14959,'EM','regina0724@cableone.net',0,'2014-01-01 12:00:28',NULL,NULL),(29073,18777,'AP','5136254325',0,'2014-01-17 03:35:51',NULL,NULL),(30502,19784,'AP','3307178086',0,'2014-01-23 21:01:36',NULL,NULL),(32381,21158,'EM','jeremybrooks35@yahoo.com',0,'2014-02-03 21:00:31',NULL,NULL),(42016,27927,'EM','teddiscott@att.net',0,'2014-03-06 21:00:23',NULL,NULL),(658,409,'EM','SHERRELLUK2GOD2@HOTMAIL.COM',0,'2013-12-25 17:46:22',NULL,NULL),(36794,24226,'AP','6144200940',0,'2014-02-16 19:00:31',NULL,NULL),(36269,23870,'AP','4192765946',0,'2014-02-14 21:32:10',NULL,NULL),(7520,4902,'EM','farmall400@live.com',0,'2013-12-25 22:31:49',NULL,NULL),(32805,21462,'TE','3306701112',0,'2014-02-04 21:01:34',NULL,NULL),(6623,4278,'AP','4193032087',0,'2013-12-25 21:51:58',NULL,NULL),(30178,19551,'TE','4194788528',0,'2014-01-23 03:02:29',NULL,NULL),(2647,1610,'TE','2146065110',0,'2013-12-25 18:52:16',NULL,NULL),(29749,19235,'AP','5134011208',0,'2014-01-21 08:46:35',NULL,NULL),(25064,16157,'TE','4199992912',0,'2014-01-04 06:00:07',NULL,NULL),(28841,18625,'TE','3308562033',0,'2014-01-16 08:47:30',NULL,NULL),(26657,17148,'EM','loscatrachosmetairie@hotmail.com',0,'2014-01-13 02:21:56',NULL,NULL),(42926,28543,'AP','3304283539',0,'2014-03-07 21:32:16',NULL,NULL),(7741,5051,'AP','9567717018',0,'2013-12-25 23:00:12',NULL,NULL),(3369,2115,'EM','bushmanml@gmail.com',0,'2013-12-25 19:17:35',NULL,NULL),(37397,24626,'AP','2257177758',0,'2014-02-20 04:17:17',NULL,NULL),(35258,23155,'AP','5137676045',0,'2014-02-12 21:31:44',NULL,NULL),(32222,21044,'AP','9362399052',0,'2014-02-01 19:00:52',NULL,NULL),(11388,7415,'AP','4404878432',0,'2013-12-26 02:16:50',NULL,NULL),(9735,6369,'EM','debbph0731@aol.com',0,'2013-12-26 00:47:36',NULL,NULL),(2199,1351,'AP','8323610545',0,'2013-12-25 18:45:16',NULL,NULL),(39432,26081,'AP','2259784703',0,'2014-02-28 06:30:04',NULL,NULL),(34934,22926,'TE','5132527432',0,'2014-02-11 21:30:06',NULL,NULL),(24529,15822,'TE','4404881428',0,'2014-01-03 02:03:33',NULL,NULL),(24563,15844,'AP','7405032690',0,'2014-01-03 02:04:15',NULL,NULL),(27087,17420,'EM','tmhesson@sbcglobal.net',0,'2014-01-13 03:00:27',NULL,NULL),(26088,16801,'TE','9037058663',0,'2014-01-13 02:18:11',NULL,NULL),(42306,28090,'EM','rhale18@windstream.net',0,'2014-03-06 21:02:04',NULL,NULL),(8577,5639,'TE','3059234178',0,'2013-12-25 23:31:11',NULL,NULL),(38032,25086,'AP','3378497970',0,'2014-02-21 21:30:03',NULL,NULL),(9410,6160,'TE','5134654928',0,'2013-12-26 00:16:45',NULL,NULL),(33005,21619,'TE','3257545080',0,'2014-02-05 21:30:37',NULL,NULL),(24371,15738,'TE','4196454764',0,'2014-01-03 02:00:44',NULL,NULL),(26276,16911,'AP','4403208269',0,'2014-01-13 02:19:38',NULL,NULL),(40773,27095,'TE','3307245107',0,'2014-03-03 21:30:19',NULL,NULL),(11108,7220,'TE','3309321036',0,'2013-12-26 02:01:07',NULL,NULL),(8290,5432,'TE','5043050318',0,'2013-12-25 23:09:41',NULL,NULL),(7900,5148,'TE','7405446026',0,'2013-12-25 23:02:44',NULL,NULL),(31553,20567,'TE','4192055672',0,'2014-01-29 21:01:50',NULL,NULL),(29801,19274,'AP','5672087736',0,'2014-01-21 08:46:56',NULL,NULL),(7795,5088,'TE','8175948545',0,'2013-12-25 23:01:08',NULL,NULL),(2158,1328,'TE','7609022146',0,'2013-12-25 18:32:00',NULL,NULL),(24282,15691,'AP','3302083289',1,'2014-01-02 04:35:22',NULL,NULL),(14684,9609,'AP','3304143127',0,'2013-12-26 04:37:36',NULL,NULL),(42510,28274,'TE','3612440199',0,'2014-03-07 21:00:22',NULL,NULL),(43173,28689,'AP','3307338308',0,'2014-03-08 21:31:02',NULL,NULL),(43462,28862,'EM','Jamesasmith77@aol.com',0,'2014-03-09 21:30:05',NULL,NULL),(11950,7784,'EM','swencbox-healthcare2@yahoo.com',0,'2013-12-26 03:03:16',NULL,NULL),(40279,26718,'TE','7692334050',0,'2014-02-28 21:31:43',NULL,NULL),(37628,24798,'AP','7403363602',0,'2014-02-20 04:48:01',NULL,NULL),(36958,24337,'AP','8063925140',0,'2014-02-18 22:00:17',NULL,NULL),(34653,22722,'AP','5049098626',0,'2014-02-11 21:01:10',NULL,NULL),(30845,20050,'AP','3235402017',0,'2014-01-27 21:00:04',NULL,NULL),(11901,7742,'EM','c.todd.alexander@gmail.com',0,'2013-12-26 03:02:19',NULL,NULL),(25362,16356,'TE','7403960635',0,'2014-01-07 04:02:38',NULL,NULL),(20545,13225,'AP','2148743163',0,'2013-12-26 12:55:35',NULL,NULL),(20371,13121,'AP','5137066543',0,'2013-12-26 12:52:46',NULL,NULL),(6324,4077,'AP','9192800062',0,'2013-12-25 21:47:05',NULL,NULL),(14038,9171,'EM','Johnbjr6@aol.com',0,'2013-12-26 04:08:56',NULL,NULL),(42467,28215,'AP','5133835100',0,'2014-03-06 21:30:16',NULL,NULL),(5077,3260,'AP','3303104941',0,'2013-12-25 20:46:51',NULL,NULL),(23521,15172,'EM','donnagrotenrath@gmail.com',0,'2014-01-01 12:06:37',NULL,NULL),(35716,23489,'AP','4192037749',0,'2014-02-13 22:02:01',NULL,NULL),(28465,18342,'AP','6149359027',0,'2014-01-16 08:45:18',NULL,NULL),(33245,21771,'TE','6146255360',0,'2014-02-06 21:00:32',NULL,NULL),(31504,20528,'AP','6624027895',0,'2014-01-29 21:01:29',NULL,NULL),(30161,19542,'TE','4194785669',0,'2014-01-23 03:02:25',NULL,NULL),(42454,28202,'AP','9727432265',0,'2014-03-06 21:30:09',NULL,NULL),(4015,2554,'TE','6625547584',0,'2013-12-25 19:37:22',NULL,NULL),(39751,26288,'AP','3185149066',0,'2014-02-28 06:31:23',NULL,NULL),(36933,24321,'EM','style4u74@yahoo.com',0,'2014-02-18 22:00:08',NULL,NULL),(11492,7474,'EM','pearcej@ccf.org',0,'2013-12-26 02:31:15',NULL,NULL),(10654,6926,'EM','LEEBAUMES@GMAIL.COM',0,'2013-12-26 01:46:22',NULL,NULL),(22102,14235,'TE','6018566184',0,'2013-12-27 02:05:08',NULL,NULL),(9614,6292,'TE','7083737223',0,'2013-12-26 00:45:41',NULL,NULL),(43366,28802,'EM','lauradeeh@att.net',0,'2014-03-09 21:00:49',NULL,NULL),(229,141,'TE','3304723123',0,'2013-12-25 17:18:41',NULL,NULL),(7608,4955,'AP','5044579555',0,'2013-12-25 22:46:02',NULL,NULL),(35762,23519,'TE','2345255073',0,'2014-02-13 22:02:19',NULL,NULL),(14300,9353,'TE','3379981468',0,'2013-12-26 04:31:19',NULL,NULL),(33378,21869,'EM','zwatson@bchsnola.org',0,'2014-02-06 21:01:25',NULL,NULL),(29090,18786,'EM','gentleben58@hotmail.com',0,'2014-01-17 03:35:55',NULL,NULL),(29279,18911,'TE','4197787210',0,'2014-01-17 03:36:40',NULL,NULL),(30369,19674,'EM','springobmichael@gmail.com',0,'2014-01-23 21:00:34',NULL,NULL),(4240,2711,'AP','2162191121',0,'2013-12-25 19:47:58',NULL,NULL),(35375,23245,'TE','3306717566',0,'2014-02-13 21:30:04',NULL,NULL),(29700,19201,'EM','wjjj@frontier.com',0,'2014-01-21 08:46:17',NULL,NULL),(14688,9611,'TE','3308604523',0,'2013-12-26 04:37:39',NULL,NULL),(20743,13332,'TE','9567275725',0,'2013-12-26 12:58:39',NULL,NULL),(21590,13892,'TE','4199065482',0,'2013-12-26 13:13:30',NULL,NULL),(41966,27897,'AP','5133041523',0,'2014-03-05 21:32:43',NULL,NULL),(42065,27953,'AP','9723718419',0,'2014-03-06 21:00:39',NULL,NULL),(42539,28302,'TE','3309239583',0,'2014-03-07 21:00:32',NULL,NULL),(6687,4342,'TE','4192361740',0,'2013-12-25 21:53:19',NULL,NULL),(37629,24797,'EM','carlye.myka@gmail.com',0,'2014-02-20 04:48:02',NULL,NULL),(12161,7945,'TE','3184044719',0,'2013-12-26 03:07:00',NULL,NULL),(35515,23359,'TE','3308353750',0,'2014-02-13 22:00:45',NULL,NULL),(11280,7353,'TE','9039188219',0,'2013-12-26 02:15:11',NULL,NULL),(7942,5183,'AP','4198414945',0,'2013-12-25 23:03:33',NULL,NULL),(32934,21557,'TE','9376230013',0,'2014-02-05 21:30:17',NULL,NULL),(31546,20561,'AP','2063712112',0,'2014-01-29 21:01:47',NULL,NULL),(27312,17589,'EM','trucbonix@gmail.com',0,'2014-01-14 01:32:09',NULL,NULL),(43236,28730,'EM','Bubbabreck@gmail.com',0,'2014-03-09 21:00:02',NULL,NULL),(5136,3290,'EM','bwoyshville@hotmail.com',0,'2013-12-25 21:15:30',NULL,NULL),(1572,969,'EM','mummbles007@yahoo.com',0,'2013-12-25 18:09:58',NULL,NULL),(38124,25164,'AP','3302726492',0,'2014-02-21 22:00:24',NULL,NULL),(37976,25054,'AP','3309582132',0,'2014-02-20 22:01:19',NULL,NULL),(21432,13779,'AP','6625741477',0,'2013-12-26 13:10:42',NULL,NULL),(25959,16722,'TE','8063535548',0,'2014-01-08 18:24:46',NULL,NULL),(43184,28696,'TE','2256877404',0,'2014-03-08 21:31:06',NULL,NULL),(11236,7316,'AP','8309281281',0,'2013-12-26 02:03:28',NULL,NULL),(40582,26934,'TE','4403202491',0,'2014-03-03 01:00:21',NULL,NULL),(38944,25748,'TE','6144461229',0,'2014-02-26 09:30:44',NULL,NULL),(30316,19639,'EM','gmealka@gmail.com',0,'2014-01-23 21:00:14',NULL,NULL),(7648,4979,'TE','9037878253',0,'2013-12-25 22:46:40',NULL,NULL),(7178,4679,'EM','KEITHPAIGE77@GMAIL.COM',0,'2013-12-25 22:07:50',NULL,NULL),(7055,4608,'TE','3308646134',0,'2013-12-25 22:05:54',NULL,NULL),(14476,9454,'TE','5134976040',0,'2013-12-26 04:34:04',NULL,NULL),(41423,27520,'TE','2165439654',0,'2014-03-04 21:02:39',NULL,NULL),(441,274,'TE','5129632973',0,'2013-12-25 17:30:07',NULL,NULL),(40883,27165,'TE','2104544057',0,'2014-03-03 21:31:02',NULL,NULL),(970,596,'AP','7033141598',0,'2013-12-25 18:00:13',NULL,NULL),(9150,5993,'AP','5089511750',0,'2013-12-26 00:00:08',NULL,NULL),(22874,14759,'AP','9792208821',1,'2013-12-29 11:12:38',NULL,NULL),(24786,15987,'EM','EQRodriguez@windstream.net',0,'2014-01-04 02:01:09',NULL,NULL),(28123,18128,'TE','5134618749',0,'2014-01-15 02:07:42',NULL,NULL),(26171,16850,'TE','7692304420',0,'2014-01-13 02:18:39',NULL,NULL),(42010,27924,'TE','3023391116',0,'2014-03-06 21:00:21',NULL,NULL),(22605,14577,'AP','5046214535',0,'2013-12-28 03:35:44',NULL,NULL),(40292,26728,'AP','5136583530',0,'2014-02-28 21:31:48',NULL,NULL),(38548,25472,'TE','9047043120',0,'2014-02-25 21:31:38',NULL,NULL),(38540,25467,'AP','8304566523',0,'2014-02-25 21:31:35',NULL,NULL),(35428,23289,'EM','kyle@ohiohardwoodfurniture.com',0,'2014-02-13 22:00:06',NULL,NULL),(25446,16408,'TE','9363283250',0,'2014-01-07 04:04:08',NULL,NULL),(33591,22021,'TE','9402561869',0,'2014-02-07 19:00:58',NULL,NULL),(32889,21527,'EM','cassiehutto27@gmail.com',0,'2014-02-05 21:30:05',NULL,NULL),(32280,21087,'TE','3308326759',0,'2014-02-02 19:00:25',NULL,NULL),(27253,17547,'TE','9372765366',0,'2014-01-13 03:01:52',NULL,NULL),(6011,3860,'TE','4106032905',0,'2013-12-25 21:35:55',NULL,NULL),(40392,26810,'EM','sueadkins58@yahoo.com',0,'2014-03-01 21:00:28',NULL,NULL),(9073,5949,'TE','9375493286',0,'2013-12-25 23:51:03',NULL,NULL),(20958,13484,'TE','6788952018',0,'2013-12-26 13:02:17',NULL,NULL),(43373,28806,'AP','3306344893',0,'2014-03-09 21:00:52',NULL,NULL),(7513,4896,'AP','3302128470',0,'2013-12-25 22:31:40',NULL,NULL),(13848,9031,'AP','3303299860',0,'2013-12-26 04:05:34',NULL,NULL),(12393,8114,'EM','marciemckay11@yahoo.com',0,'2013-12-26 03:15:07',NULL,NULL),(38813,25660,'AP','3304682940',0,'2014-02-26 08:30:45',NULL,NULL),(38662,25550,'AP','5049399970',0,'2014-02-26 08:00:18',NULL,NULL),(35645,23438,'TE','2059037148',0,'2014-02-13 22:01:31',NULL,NULL),(32575,21299,'AP','9853518305',0,'2014-02-04 21:00:11',NULL,NULL),(32462,21208,'EM','bonxuan@gmail.com',0,'2014-02-03 21:00:58',NULL,NULL),(32388,21161,'AP','5135518881',0,'2014-02-03 21:00:33',NULL,NULL),(11732,7636,'TE','5139399386',0,'2013-12-26 02:46:25',NULL,NULL),(26322,16946,'AP','2252784109',0,'2014-01-13 02:19:57',NULL,NULL),(24126,15574,'AP','3304165910',1,'2014-01-02 04:32:00',NULL,NULL),(11338,7385,'EM','teric51@yahoo.com',0,'2013-12-26 02:16:01',NULL,NULL),(20489,13194,'TE','2149185363',0,'2013-12-26 12:54:44',NULL,NULL),(41781,27778,'TE','3309030870',0,'2014-03-05 21:31:32',NULL,NULL),(43887,29120,'TE','8034666464',0,'2014-03-10 21:02:30',NULL,NULL),(741,464,'TE','3307332806',0,'2013-12-25 17:47:43',NULL,NULL),(9200,6021,'AP','5134600189',0,'2013-12-26 00:00:52',NULL,NULL),(39412,26060,'TE','5136338288',0,'2014-02-26 21:02:39',NULL,NULL),(35435,23296,'AP','7404645527',0,'2014-02-13 22:00:11',NULL,NULL),(34889,22895,'TE','3305032655',0,'2014-02-11 21:02:39',NULL,NULL),(23354,15044,'TE','5045591172',0,'2014-01-01 12:03:05',NULL,NULL),(32127,20978,'EM','ARLENESIMON62@YAHOO.COM',0,'2014-02-01 19:00:19',NULL,NULL),(29260,18897,'AP','9375727135',0,'2014-01-17 03:36:35',NULL,NULL),(14518,9485,'EM','varms_@hotmail.com',0,'2013-12-26 04:34:46',NULL,NULL),(7508,4892,'AP','9154749955',0,'2013-12-25 22:31:34',NULL,NULL),(7086,4627,'EM','kjohnson475@gmail.com',0,'2013-12-25 22:06:25',NULL,NULL),(11101,7210,'TE','6145378624',0,'2013-12-26 02:00:55',NULL,NULL),(36924,24317,'TE','9564074776',0,'2014-02-18 22:00:06',NULL,NULL),(9066,5943,'AP','3185729941',0,'2013-12-25 23:50:54',NULL,NULL),(34276,22488,'AP','4192369710',0,'2014-02-10 21:31:06',NULL,NULL),(29629,19144,'EM','shirleinhaus905@yahoo.com',0,'2014-01-21 08:45:30',NULL,NULL),(4907,3151,'AP','5129300350',0,'2013-12-25 20:31:02',NULL,NULL),(25533,16472,'TE','3306565666',0,'2014-01-07 04:05:59',NULL,NULL),(4246,2716,'EM','amanda@toupsmeatery.com',0,'2013-12-25 19:48:05',NULL,NULL),(21469,13796,'TE','6013737224',0,'2013-12-26 13:11:14',NULL,NULL),(20360,13114,'TE','5133510439',0,'2013-12-26 12:52:34',NULL,NULL),(1192,727,'TE','5126692854',0,'2013-12-25 18:03:41',NULL,NULL),(39676,26234,'EM','lowellbentley@gmail.com',0,'2014-02-28 06:31:02',NULL,NULL),(37853,24972,'EM','JOSE.DELEONX@GMAIL.COM',0,'2014-02-20 22:00:28',NULL,NULL),(33650,22070,'AP','8172711441',0,'2014-02-08 19:00:14',NULL,NULL),(12333,8065,'TE','4197541320',0,'2013-12-26 03:10:04',NULL,NULL),(5867,3764,'TE','2165133447',0,'2013-12-25 21:33:31',NULL,NULL),(33171,21724,'AP','3373083217',0,'2014-02-06 21:00:05',NULL,NULL),(5594,3578,'EM','lowellslandscapes@cinci.rr.com',0,'2013-12-25 21:22:43',NULL,NULL),(22194,14296,'TE','4197527320',0,'2013-12-27 02:06:44',NULL,NULL),(4792,3065,'TE','9012887592',0,'2013-12-25 20:19:18',NULL,NULL),(906,560,'EM','tlsuch@juno.com',0,'2013-12-25 17:50:17',NULL,NULL),(41854,27833,'EM','LEFTYANDME12613@GMAIL.COM',0,'2014-03-05 21:32:02',NULL,NULL),(41142,27327,'TE','9564587913',0,'2014-03-04 21:00:50',NULL,NULL),(14258,9325,'EM','nolfris1@aol.com',0,'2013-12-26 04:30:37',NULL,NULL),(39900,26406,'TE','3303545829',0,'2014-02-28 07:00:35',NULL,NULL),(13552,8838,'TE','5127966088',0,'2013-12-26 04:00:40',NULL,NULL),(9953,6513,'TE','3305729498',0,'2013-12-26 00:51:11',NULL,NULL),(9902,6481,'TE','4409970463',0,'2013-12-26 00:50:19',NULL,NULL),(23415,15083,'AP','9566450274',0,'2014-01-01 12:04:14',NULL,NULL),(5647,3625,'TE','3306866026',0,'2013-12-25 21:23:45',NULL,NULL),(9356,6125,'EM','flourish.jf@gmail.com',0,'2013-12-26 00:15:51',NULL,NULL),(5695,3656,'EM','angelsand15@yahoo.com',0,'2013-12-25 21:30:46',NULL,NULL),(43261,28744,'TE','3186172874',0,'2014-03-09 21:00:12',NULL,NULL),(5505,3523,'TE','6013173108',0,'2013-12-25 21:21:18',NULL,NULL),(24052,15530,'TE','5043923452',1,'2014-01-02 04:30:36',NULL,NULL),(32932,21556,'AP','5136525637',0,'2014-02-05 21:30:16',NULL,NULL),(24875,16040,'TE','9724921174',0,'2014-01-04 02:02:49',NULL,NULL),(29868,19322,'AP','9156675227',1,'2014-01-22 03:22:12',NULL,NULL),(42947,28557,'TE','4194358289',0,'2014-03-07 21:32:24',NULL,NULL),(3138,1956,'TE','8176816774',0,'2013-12-25 19:01:06',NULL,NULL),(40651,26987,'AP','4199570822',0,'2014-03-03 01:00:40',NULL,NULL),(40490,26873,'EM','SHMARBY@HOTMAIL.COM',0,'2014-03-01 21:01:04',NULL,NULL),(37518,24708,'TE','4695701993',0,'2014-02-20 04:35:31',NULL,NULL),(22082,14222,'TE','9032185341',0,'2013-12-27 02:04:46',NULL,NULL),(3184,2001,'TE','8176816774',0,'2013-12-25 19:02:12',NULL,NULL),(5151,3302,'EM','dcb4459@gmail.com',0,'2013-12-25 21:15:44',NULL,NULL),(302,186,'TE','4404372275',0,'2013-12-25 17:19:50',NULL,NULL),(41622,27669,'AP','3523033310',0,'2014-03-05 21:30:33',NULL,NULL),(7916,5158,'TE','6145805632',0,'2013-12-25 23:02:59',NULL,NULL),(28669,18491,'TE','3306992408',0,'2014-01-16 08:46:25',NULL,NULL),(27573,17771,'AP','2105086468',0,'2014-01-14 01:33:38',NULL,NULL),(22608,14579,'TE','5042316116',0,'2013-12-28 03:35:48',NULL,NULL),(43141,28676,'TE','4197870160',0,'2014-03-08 21:30:52',NULL,NULL),(1499,922,'TE','3304683072',0,'2013-12-25 18:08:53',NULL,NULL),(13576,8851,'AP','2147246636',0,'2013-12-26 04:01:02',NULL,NULL),(14717,9628,'AP','3306960390',0,'2013-12-26 04:38:08',NULL,NULL),(20823,13383,'EM','brianghomer@gmail.com',0,'2013-12-26 12:59:58',NULL,NULL),(43687,29000,'TE','5672074636',0,'2014-03-10 21:01:18',NULL,NULL),(2472,1516,'AP','2165599731',0,'2013-12-25 18:49:40',NULL,NULL),(42106,27975,'EM','NHUGHES@UNO.EDU',0,'2014-03-06 21:00:53',NULL,NULL),(8335,5466,'TE','9373393461',0,'2013-12-25 23:10:33',NULL,NULL),(37964,25048,'AP','5132535115',0,'2014-02-20 22:01:15',NULL,NULL),(37599,24770,'AP','5132844411',0,'2014-02-20 04:44:32',NULL,NULL),(37285,24536,'TE','2256299850',0,'2014-02-20 04:01:27',NULL,NULL),(4023,2569,'TE','4197262795',0,'2013-12-25 19:37:38',NULL,NULL),(33066,21658,'EM','vicki8281969@yahoo.com',0,'2014-02-05 21:30:53',NULL,NULL),(301,185,'EM','whimworks@gmail.com',0,'2013-12-25 17:19:48',NULL,NULL),(14207,9296,'TE','3308774161',0,'2013-12-26 04:16:15',NULL,NULL),(735,461,'TE','4406698732',0,'2013-12-25 17:47:37',NULL,NULL),(1467,900,'TE','6017830350',0,'2013-12-25 18:08:15',NULL,NULL),(37348,24590,'TE','3307582631',0,'2014-02-20 04:10:27',NULL,NULL),(10807,7020,'EM','jescamia1@mail.stmarytx.edu',0,'2013-12-26 01:48:50',NULL,NULL),(10454,6811,'TE','9405771700',0,'2013-12-26 01:30:19',NULL,NULL),(23789,15342,'TE','3308586636',1,'2014-01-02 04:24:17',NULL,NULL),(28020,18059,'TE','9376909393',0,'2014-01-15 02:07:20',NULL,NULL),(27511,17724,'TE','3308823622',0,'2014-01-14 01:33:15',NULL,NULL),(25216,16259,'AP','4195758021',0,'2014-01-05 00:02:53',NULL,NULL),(20654,13283,'TE','9153293972',0,'2013-12-26 12:57:16',NULL,NULL),(22445,14475,'TE','5128282604',0,'2013-12-28 03:33:08',NULL,NULL),(27088,17421,'TE','3306998834',0,'2014-01-13 03:00:27',NULL,NULL),(34936,22927,'TE','3307225444',0,'2014-02-11 21:30:07',NULL,NULL),(30121,19511,'TE','8178293275',0,'2014-01-23 03:02:14',NULL,NULL),(29157,18837,'AP','3303290857',0,'2014-01-17 03:36:11',NULL,NULL),(42772,28448,'TE','2252296194',0,'2014-03-07 21:31:18',NULL,NULL),(43664,28979,'TE','3306594028',0,'2014-03-10 21:01:08',NULL,NULL),(8645,5679,'EM','shirleyboldmanva@yahoo.com',0,'2013-12-25 23:32:17',NULL,NULL),(21574,13873,'EM','Divasue1@aol.com',0,'2013-12-26 13:13:07',NULL,NULL),(36177,23810,'EM','annal.vyas@gmail.com',0,'2014-02-14 21:31:35',NULL,NULL),(36049,23711,'EM','pevidal@roadrunner.com',0,'2014-02-14 21:30:47',NULL,NULL),(23255,14984,'TE','9035635318',0,'2014-01-01 12:01:12',NULL,NULL),(25364,16358,'TE','9373740630',0,'2014-01-07 04:02:40',NULL,NULL),(31091,20238,'TE','6016450383',0,'2014-01-28 21:00:06',NULL,NULL),(522,327,'AP','9372183480',0,'2013-12-25 17:31:33',NULL,NULL),(14191,9285,'AP','3303402413',0,'2013-12-26 04:16:00',NULL,NULL),(41365,27481,'TE','8328830907',0,'2014-03-04 21:02:17',NULL,NULL),(8280,5424,'EM','Jtm133@icloud.com',0,'2013-12-25 23:09:29',NULL,NULL),(11549,7518,'TE','9852102203',0,'2013-12-26 02:32:17',NULL,NULL),(29676,19178,'TE','5126745889',0,'2014-01-21 08:46:06',NULL,NULL),(10250,6699,'AP','5138288282',0,'2013-12-26 01:01:52',NULL,NULL),(1694,1041,'TE','9564348422',0,'2013-12-25 18:15:47',NULL,NULL),(20762,13342,'TE','4056429404',0,'2013-12-26 12:58:57',NULL,NULL),(5767,3695,'TE','4196514265',0,'2013-12-25 21:31:49',NULL,NULL),(1104,678,'TE','3303239950',0,'2013-12-25 18:02:19',NULL,NULL),(3644,2309,'EM','famcordos@yahoo.com',0,'2013-12-25 19:31:08',NULL,NULL),(26915,17313,'TE','7738377128',0,'2014-01-13 02:23:46',NULL,NULL),(35079,23038,'TE','2146768846',0,'2014-02-12 21:30:38',NULL,NULL),(6656,4318,'AP','5132396554',0,'2013-12-25 21:52:42',NULL,NULL),(43941,29148,'AP','5139216376',0,'2014-03-10 21:02:47',NULL,NULL),(26615,17125,'TE','9378308291',0,'2014-01-13 02:21:44',NULL,NULL),(37847,24970,'TE','3252779677',0,'2014-02-20 22:00:26',NULL,NULL),(4363,2781,'TE','5133859483',0,'2013-12-25 19:49:52',NULL,NULL),(13887,9055,'EM','theb7742@sbcglobal.net',0,'2013-12-26 04:06:10',NULL,NULL),(31908,20824,'TE','9854290633',0,'2014-01-31 21:00:37',NULL,NULL),(5581,3567,'TE','4193463100',0,'2013-12-25 21:22:27',NULL,NULL),(39262,25976,'TE','4194385110',0,'2014-02-26 21:01:49',NULL,NULL),(39832,26346,'TE','5134791443',0,'2014-02-28 06:31:45',NULL,NULL),(28115,18121,'TE','3309232605',0,'2014-01-15 02:07:40',NULL,NULL),(38304,25293,'AP','9372159325',0,'2014-02-25 21:00:25',NULL,NULL),(32145,20995,'AP','9373294786',0,'2014-02-01 19:00:26',NULL,NULL),(10510,6845,'TE','4192448552',0,'2013-12-26 01:31:12',NULL,NULL),(26172,16850,'AP','6018422601',0,'2014-01-13 02:18:39',NULL,NULL),(6954,4533,'TE','2105357939',0,'2013-12-25 22:04:07',NULL,NULL),(12205,7974,'EM','crystal.icke@gmail.com',0,'2013-12-26 03:07:47',NULL,NULL),(23497,15154,'TE','6142362737',0,'2014-01-01 12:06:09',NULL,NULL),(22079,14220,'AP','9562700104',0,'2013-12-27 02:04:43',NULL,NULL),(38971,25766,'AP','6142062270',0,'2014-02-26 09:30:54',NULL,NULL),(40097,26590,'AP','4407252796',0,'2014-02-28 21:30:36',NULL,NULL),(41964,27896,'TE','9375493567',0,'2014-03-05 21:32:42',NULL,NULL),(43525,28898,'EM','dijlh17@gmail.com',0,'2014-03-10 21:00:19',NULL,NULL),(23807,15359,'TE','3307585467',1,'2014-01-02 04:24:43',NULL,NULL),(22987,14826,'AP','4193454000',1,'2013-12-29 11:14:28',NULL,NULL),(6501,4203,'AP','4322940524',0,'2013-12-25 21:49:58',NULL,NULL),(6799,4411,'EM','jimjennings4@gmail.com',0,'2013-12-25 22:01:22',NULL,NULL),(13980,9119,'TE','3303051650',0,'2013-12-26 04:07:44',NULL,NULL),(42598,28341,'TE','2812574272',0,'2014-03-07 21:30:17',NULL,NULL),(43509,28889,'TE','9562468235',0,'2014-03-10 21:00:14',NULL,NULL),(594,366,'TE','3258641410',0,'2013-12-25 17:45:19',NULL,NULL),(24763,15976,'AP','9157400104',0,'2014-01-04 02:00:47',NULL,NULL),(27361,17614,'BN','8327745652',0,'2014-01-14 01:32:24',NULL,NULL),(6709,4362,'TE','9374340530',0,'2013-12-25 22:00:03',NULL,NULL),(4773,3056,'TE','5045796513',0,'2013-12-25 20:19:02',NULL,NULL),(27800,17918,'TE','9562495110',0,'2014-01-15 02:06:30',NULL,NULL),(1331,813,'AP','4408126711',0,'2013-12-25 18:05:53',NULL,NULL),(33765,22157,'AP','5136770590',0,'2014-02-08 19:00:57',NULL,NULL),(40146,26627,'TE','9729891283',0,'2014-02-28 21:30:55',NULL,NULL),(42222,28049,'TE','6015734274',0,'2014-03-06 21:01:36',NULL,NULL),(42524,28291,'TE','5138856851',0,'2014-03-07 21:00:28',NULL,NULL),(26937,17325,'AP','9858075166',0,'2014-01-13 02:23:53',NULL,NULL),(20667,13290,'EM','eugenefranklin@aol.com',0,'2013-12-26 12:57:28',NULL,NULL),(32910,21546,'AP','6142713596',0,'2014-02-05 21:30:11',NULL,NULL),(12040,7852,'TE','3303721874',0,'2013-12-26 03:04:52',NULL,NULL),(5460,3497,'AP','4403460653',0,'2013-12-25 21:20:35',NULL,NULL),(40818,27124,'TE','6146048803',0,'2014-03-03 21:30:35',NULL,NULL),(9,6,'TE','9377637297',0,'2013-12-25 17:15:10',NULL,NULL),(24044,15525,'AP','2259933811',1,'2014-01-02 04:30:27',NULL,NULL),(37993,25063,'TE','6142521941',0,'2014-02-20 22:01:25',NULL,NULL),(36143,23786,'EM','g317537@aol.com',0,'2014-02-14 21:31:23',NULL,NULL),(4858,3110,'TE','9372882283',0,'2013-12-25 20:20:31',NULL,NULL),(30305,19633,'AP','2166959926',0,'2014-01-23 21:00:10',NULL,NULL),(29582,19113,'EM','nellie.tipton@gmail.com',0,'2014-01-21 08:44:46',NULL,NULL),(5925,3800,'TE','2165133447',0,'2013-12-25 21:34:30',NULL,NULL),(21408,13764,'AP','7313354686',0,'2013-12-26 13:10:19',NULL,NULL),(38239,25246,'TE','4192033473',0,'2014-02-21 22:01:10',NULL,NULL),(39923,26419,'TE','9158339266',0,'2014-02-28 07:30:07',NULL,NULL),(1452,887,'TE','5135684371',0,'2013-12-25 18:07:53',NULL,NULL),(35665,23458,'TE','6789078717',0,'2014-02-13 22:01:41',NULL,NULL),(34320,22518,'AP','2109957304',0,'2014-02-10 21:31:23',NULL,NULL),(12189,7965,'EM','GAILBROWN1958@BELLSOUTH.NET',0,'2013-12-26 03:07:32',NULL,NULL),(20386,13131,'TE','5135831476',0,'2013-12-26 12:53:02',NULL,NULL),(22630,14593,'AP','3303109592',0,'2013-12-28 03:36:11',NULL,NULL),(32008,20895,'AP','5136521671',0,'2014-01-31 21:01:17',NULL,NULL),(30711,19951,'AP','8608065390',0,'2014-01-25 19:00:03',NULL,NULL),(26457,17031,'EM','bettsohio@yahoo.com',0,'2014-01-13 02:20:45',NULL,NULL),(4332,2764,'EM','grannybooboots@yahoo.com',0,'2013-12-25 19:49:24',NULL,NULL),(4738,3034,'AP','4328166381',0,'2013-12-25 20:18:30',NULL,NULL),(11922,7760,'TE','9378907734',0,'2013-12-26 03:02:45',NULL,NULL),(24474,15794,'TE','5048324942',0,'2014-01-03 02:02:37',NULL,NULL),(23798,15350,'AP','2166322728',1,'2014-01-02 04:24:32',NULL,NULL),(7141,4658,'TE','3186877648',0,'2013-12-25 22:07:18',NULL,NULL),(809,501,'EM','askdavidpeters@gmail.com',0,'2013-12-25 17:48:44',NULL,NULL),(36278,23886,'AP','5133177755',0,'2014-02-14 21:32:15',NULL,NULL),(33181,21730,'EM','bojon59@gmail.com',0,'2014-02-06 21:00:09',NULL,NULL),(25144,16208,'AP','2544341288',0,'2014-01-05 00:01:23',NULL,NULL),(32126,20978,'TE','2258103179',0,'2014-02-01 19:00:19',NULL,NULL),(32019,20902,'TE','6143780992',0,'2014-01-31 21:01:22',NULL,NULL),(31453,20501,'TE','9852493878',0,'2014-01-29 21:01:13',NULL,NULL),(14808,9693,'TE','9376540395',0,'2013-12-26 04:39:46',NULL,NULL),(12137,7929,'EM','julia.g1@cox.net',0,'2013-12-26 03:06:34',NULL,NULL),(6671,4330,'TE','9375645597',0,'2013-12-25 21:53:01',NULL,NULL),(5226,3358,'AP','5128480760',0,'2013-12-25 21:16:55',NULL,NULL),(2026,1253,'AP','5134761970',0,'2013-12-25 18:21:19',NULL,NULL),(40000,26491,'AP','9858040685',0,'2014-02-28 21:00:10',NULL,NULL),(41917,27869,'EM','JACKIE_WINGSOFEAGLES@YAHOO.COM',0,'2014-03-05 21:32:24',NULL,NULL),(42161,28007,'EM','oliverrampello@hotmail.com',0,'2014-03-06 21:01:13',NULL,NULL),(26928,17322,'TE','9784001764',0,'2014-01-13 02:23:51',NULL,NULL),(37897,24999,'TE','3252481510',0,'2014-02-20 22:00:45',NULL,NULL),(34840,22847,'AP','4192037391',0,'2014-02-11 21:02:18',NULL,NULL),(11468,7458,'EM','applegirl8@hotmail.com',0,'2013-12-26 02:30:51',NULL,NULL),(25378,16368,'TE','6014548684',0,'2014-01-07 04:02:57',NULL,NULL),(6400,4129,'TE','3304269293',0,'2013-12-25 21:48:21',NULL,NULL),(27510,17723,'EM','ktrentc@live.com',0,'2014-01-14 01:33:15',NULL,NULL),(14893,9746,'AP','4195634484',0,'2013-12-26 04:46:04',NULL,NULL),(22968,14813,'EM','newimageproperty@gmail.com',1,'2013-12-29 11:14:08',NULL,NULL),(22355,14416,'AP','8322358299',0,'2013-12-28 03:31:36',NULL,NULL),(29611,19132,'TE','2252366803',0,'2014-01-21 08:45:24',NULL,NULL),(26348,16959,'TE','3308197283',0,'2014-01-13 02:20:05',NULL,NULL),(37020,24375,'TE','3183439476',0,'2014-02-18 22:00:40',NULL,NULL),(28049,18077,'TE','9857206225',0,'2014-01-15 02:07:25',NULL,NULL),(30524,19799,'EM','Yamily1997@hotmail.com',0,'2014-01-24 21:00:03',NULL,NULL),(7194,4687,'TE','9373828253',0,'2013-12-25 22:08:05',NULL,NULL),(7413,4820,'AP','3302898921',0,'2013-12-25 22:17:04',NULL,NULL),(3097,1932,'EM','belookn4@warpspeed1.net',0,'2013-12-25 19:00:26',NULL,NULL),(4197,2684,'AP','8065702244',0,'2013-12-25 19:47:19',NULL,NULL),(23609,15242,'AP','4194389189',0,'2014-01-01 12:08:39',NULL,NULL),(14864,9727,'AP','6147432106',0,'2013-12-26 04:45:37',NULL,NULL),(8177,5350,'TE','3307945382',0,'2013-12-25 23:07:36',NULL,NULL),(20333,13100,'EM','fslouis2169@yahoo.com',0,'2013-12-26 12:52:09',NULL,NULL),(40644,26979,'TE','5135153543',0,'2014-03-03 01:00:38',NULL,NULL),(28759,18558,'EM','joshuacatone@gmail.com',0,'2014-01-16 08:46:58',NULL,NULL),(27123,17462,'TE','5677129151',0,'2014-01-13 03:00:43',NULL,NULL),(29965,19388,'EM','Devignos@gmail.com',1,'2014-01-22 03:22:46',NULL,NULL),(39729,26276,'AP','3188161741',0,'2014-02-28 06:31:18',NULL,NULL),(6389,4115,'TE','6149914449',0,'2013-12-25 21:48:07',NULL,NULL),(5346,3425,'TE','3304021658',0,'2013-12-25 21:18:46',NULL,NULL),(23196,14949,'EM','stevenduemler@gmail.com',0,'2014-01-01 12:00:08',NULL,NULL),(23012,14842,'TE','9374415631',1,'2013-12-29 11:14:51',NULL,NULL),(24463,15790,'TE','2022575502',0,'2014-01-03 02:02:27',NULL,NULL),(586,361,'AP','5125771612',0,'2013-12-25 17:45:11',NULL,NULL),(30017,19441,'TE','4196057315',1,'2014-01-22 03:23:12',NULL,NULL),(4592,2931,'TE','3309584752',0,'2013-12-25 20:16:00',NULL,NULL),(21875,14093,'TE','5139216888',0,'2013-12-27 02:01:24',NULL,NULL),(8939,5851,'AP','2102907400',0,'2013-12-25 23:48:48',NULL,NULL),(11308,7369,'AP','3214439026',0,'2013-12-26 02:15:37',NULL,NULL),(42368,28139,'TE','4199364466',0,'2014-03-06 21:02:29',NULL,NULL),(43880,29114,'EM','batg2565@gmail.com',0,'2014-03-10 21:02:26',NULL,NULL),(26145,16831,'TE','5137144338',0,'2014-01-13 02:18:28',NULL,NULL),(38619,25523,'AP','5133142712',0,'2014-02-25 21:32:08',NULL,NULL),(28267,18226,'AP','9153282775',0,'2014-01-16 08:44:16',NULL,NULL),(2801,1697,'TE','4195342698',0,'2013-12-25 18:54:35',NULL,NULL),(22210,14314,'TE','4192024404',0,'2013-12-27 02:07:06',NULL,NULL),(40443,26849,'TE','6012782932',0,'2014-03-01 21:00:49',NULL,NULL),(42480,28242,'AP','5137041261',0,'2014-03-07 21:00:10',NULL,NULL),(42691,28399,'AP','9372310623',0,'2014-03-07 21:30:49',NULL,NULL),(29869,19322,'EM','LULUMERAZ@YAHOO.COM',1,'2014-01-22 03:22:12',NULL,NULL),(2651,1611,'AP','2818444912',0,'2013-12-25 18:52:19',NULL,NULL),(10332,6738,'TE','3306855454',0,'2013-12-26 01:15:41',NULL,NULL),(20927,13456,'AP','9372721622',0,'2013-12-26 13:01:39',NULL,NULL),(41676,27710,'EM','markusxo@live.com',0,'2014-03-05 21:30:53',NULL,NULL),(43146,28678,'AP','4199173402',0,'2014-03-08 21:30:54',NULL,NULL),(858,536,'TE','9014964740',0,'2013-12-25 17:49:34',NULL,NULL),(24958,16085,'AP','6145079318',0,'2014-01-04 02:04:16',NULL,NULL),(5959,3824,'EM','spamboxfull@aol.com',0,'2013-12-25 21:35:02',NULL,NULL),(37409,24637,'TE','3373511617',0,'2014-02-20 04:19:23',NULL,NULL),(36161,23800,'EM','iksmbx@gmail.com',0,'2014-02-14 21:31:29',NULL,NULL),(35650,23441,'TE','9565656001',0,'2014-02-13 22:01:33',NULL,NULL),(33466,21925,'AP','8177181099',0,'2014-02-07 19:00:08',NULL,NULL),(5969,3834,'AP','3302086027',0,'2013-12-25 21:35:13',NULL,NULL),(40625,26965,'EM','SHOFFMI@GMAIL.COM',0,'2014-03-03 01:00:32',NULL,NULL),(29288,18922,'TE','4403217675',0,'2014-01-20 08:05:33',NULL,NULL),(39486,26115,'EM','loomiswilliam@yahoo.com',0,'2014-02-28 06:30:17',NULL,NULL),(11576,7532,'EM','bryanwack@gmail.com',0,'2013-12-26 02:32:43',NULL,NULL),(35865,23584,'AP','5136091455',0,'2014-02-13 22:02:59',NULL,NULL),(27231,17530,'EM','sqzable69@me.com',0,'2014-01-13 03:01:43',NULL,NULL),(6568,4240,'TE','9564585796',0,'2013-12-25 21:51:00',NULL,NULL),(6492,4200,'AP','9404528456',0,'2013-12-25 21:49:52',NULL,NULL),(24191,15628,'TE','3185132091',1,'2014-01-02 04:33:25',NULL,NULL),(8519,5601,'TE','5183310914',0,'2013-12-25 23:30:15',NULL,NULL),(14199,9288,'EM','VON1116@SBCGLOBAL.NET',0,'2013-12-26 04:16:06',NULL,NULL),(32386,21160,'AP','5133563722',0,'2014-02-03 21:00:32',NULL,NULL),(33380,21871,'AP','4192963063',0,'2014-02-06 21:01:26',NULL,NULL),(30575,19838,'AP','2253022733',0,'2014-01-24 21:00:24',NULL,NULL),(3903,2478,'TE','5044628623',0,'2013-12-25 19:35:26',NULL,NULL),(33081,21668,'EM','magen.tardo.p19o@statefarm.com',0,'2014-02-05 21:30:58',NULL,NULL),(35184,23111,'TE','4158191968',0,'2014-02-12 21:31:17',NULL,NULL),(36024,23694,'AP','3303293580',0,'2014-02-14 21:30:39',NULL,NULL),(38806,25657,'AP','4195640945',0,'2014-02-26 08:30:42',NULL,NULL),(22133,14256,'EM','manzy3003@gmail.com',0,'2013-12-27 02:05:40',NULL,NULL),(26780,17228,'TE','6625883439',0,'2014-01-13 02:22:38',NULL,NULL),(43220,28720,'AP','4049853352',0,'2014-03-08 21:31:20',NULL,NULL),(290,179,'TE','3308054169',0,'2013-12-25 17:19:38',NULL,NULL),(26936,17325,'TE','9858075166',0,'2014-01-13 02:23:53',NULL,NULL),(38661,25550,'TE','5049399970',0,'2014-02-26 08:00:18',NULL,NULL),(8520,5601,'AP','5183310914',0,'2013-12-25 23:30:15',NULL,NULL),(34598,22686,'EM','sweelyw@gmail.com',0,'2014-02-11 21:00:50',NULL,NULL),(10462,6817,'TE','3304142197',0,'2013-12-26 01:30:26',NULL,NULL),(31438,20492,'AP','3184044561',0,'2014-01-29 21:01:08',NULL,NULL),(29457,19045,'AP','4199449506',0,'2014-01-20 08:06:40',NULL,NULL),(20272,13066,'AP','9377608808',0,'2013-12-26 12:51:11',NULL,NULL),(37332,24574,'EM','elliott1210@gmail.com',0,'2014-02-20 04:07:59',NULL,NULL),(24193,15631,'TE','5042373821',1,'2014-01-02 04:33:28',NULL,NULL),(7103,4638,'TE','6013455504',0,'2013-12-25 22:06:43',NULL,NULL),(868,541,'TE','2343127647',0,'2013-12-25 17:49:43',NULL,NULL),(24076,15543,'EM','seaux1@att.net',1,'2014-01-02 04:31:02',NULL,NULL),(7620,4965,'TE','3182216397',0,'2013-12-25 22:46:16',NULL,NULL),(31457,20502,'AP','9858709939',0,'2014-01-29 21:01:14',NULL,NULL),(33805,22196,'EM','meknight182@yahoo.com',0,'2014-02-09 19:00:12',NULL,NULL),(34006,22307,'TE','7696106997',0,'2014-02-10 11:00:41',NULL,NULL),(21112,13572,'TE','9859862433',0,'2013-12-26 13:04:43',NULL,NULL),(1614,992,'AP','6143297780',0,'2013-12-25 18:10:40',NULL,NULL),(35193,23114,'AP','6144773193',0,'2014-02-12 21:31:20',NULL,NULL),(38801,25652,'EM','missjunks@gmail.com',0,'2014-02-26 08:30:40',NULL,NULL),(22764,14678,'TE','6019275443',1,'2013-12-29 11:08:29',NULL,NULL),(12026,7841,'TE','5135417766',0,'2013-12-26 03:04:37',NULL,NULL),(1586,978,'AP','4194392156',0,'2013-12-25 18:10:13',NULL,NULL),(40104,26596,'AP','4322716877',0,'2014-02-28 21:30:39',NULL,NULL),(10567,6879,'EM','laquivia08@gmail.com',0,'2013-12-26 01:32:13',NULL,NULL),(22934,14797,'AP','2167021303',1,'2013-12-29 11:13:39',NULL,NULL),(37866,24980,'TE','8325331909',0,'2014-02-20 22:00:33',NULL,NULL),(37619,24793,'AP','5139811813',0,'2014-02-20 04:47:16',NULL,NULL),(35287,23175,'TE','5674295749',0,'2014-02-12 21:31:55',NULL,NULL),(24344,15724,'AP','9376575699',0,'2014-01-03 02:00:15',NULL,NULL),(25818,16643,'TE','9374364963',0,'2014-01-08 18:24:18',NULL,NULL),(32764,21435,'TE','8324540140',0,'2014-02-04 21:01:21',NULL,NULL),(25930,16707,'AP','7193342320',0,'2014-01-08 18:24:41',NULL,NULL),(29214,18871,'EM','cfarquh79@gmail.com',0,'2014-01-17 03:36:24',NULL,NULL),(31225,20335,'EM','mgarapic@ameritech.net',0,'2014-01-28 21:01:05',NULL,NULL),(31070,20213,'TE','4194663080',0,'2014-01-27 21:01:39',NULL,NULL),(431,265,'AP','4192361740',0,'2013-12-25 17:21:57',NULL,NULL),(37460,24666,'TE','4192862223',0,'2014-02-20 04:26:51',NULL,NULL),(29342,18960,'AP','8323326845',0,'2014-01-20 08:05:54',NULL,NULL),(9598,6285,'TE','5135455854',0,'2013-12-26 00:45:28',NULL,NULL),(693,429,'EM','PAUL.YANOVICH@YAHOO.COM',0,'2013-12-25 17:46:53',NULL,NULL),(9527,6235,'EM','kking21@hotmail.com',0,'2013-12-26 00:31:34',NULL,NULL),(4912,3154,'AP','5132543646',0,'2013-12-25 20:31:08',NULL,NULL),(22594,14573,'TE','4199730760',0,'2013-12-28 03:35:36',NULL,NULL),(22526,14525,'TE','8064016650',0,'2013-12-28 03:34:24',NULL,NULL),(20433,13159,'AP','3306061382',0,'2013-12-26 12:53:48',NULL,NULL),(43549,28915,'TE','5135157325',0,'2014-03-10 21:00:28',NULL,NULL),(12088,7901,'TE','5133600150',0,'2013-12-26 03:05:49',NULL,NULL),(39054,25831,'TE','7408772139',0,'2014-02-26 21:00:30',NULL,NULL),(36820,24250,'TE','3189268081',0,'2014-02-16 19:00:43',NULL,NULL),(2656,1613,'TE','8302991256',0,'2013-12-25 18:52:22',NULL,NULL),(31330,20416,'AP','5133063730',0,'2014-01-29 21:00:28',NULL,NULL),(2366,1438,'TE','6625708848',0,'2013-12-25 18:47:46',NULL,NULL),(10950,7117,'AP','9374021177',0,'2013-12-26 01:51:14',NULL,NULL),(13723,8942,'TE','3307990569',0,'2013-12-26 04:03:22',NULL,NULL),(10109,6607,'EM','dri00@hotmail.com',0,'2013-12-26 00:53:42',NULL,NULL),(10336,6739,'EM','bf2@uakron.edu',0,'2013-12-26 01:15:44',NULL,NULL),(6632,4292,'TE','6626940061',0,'2013-12-25 21:52:11',NULL,NULL),(5399,3454,'TE','5132254569',0,'2013-12-25 21:19:36',NULL,NULL),(8894,5825,'TE','7136641484',0,'2013-12-25 23:48:07',NULL,NULL),(39758,26293,'AP','4194943763',0,'2014-02-28 06:31:25',NULL,NULL),(37427,24646,'AP','3182642812',0,'2014-02-20 04:21:27',NULL,NULL),(37155,24458,'AP','9729510337',0,'2014-02-18 22:01:31',NULL,NULL),(21561,13865,'EM','rickyrockgod@yahoo.com',0,'2013-12-26 13:12:54',NULL,NULL),(327,205,'TE','2162368464',0,'2013-12-25 17:20:18',NULL,NULL),(40815,27122,'TE','5138636568',0,'2014-03-03 21:30:34',NULL,NULL),(12177,7954,'TE','6822093671',0,'2013-12-26 03:07:15',NULL,NULL),(34693,22749,'AP','9858599907',0,'2014-02-11 21:01:25',NULL,NULL),(34533,22653,'AP','2542203913',0,'2014-02-11 21:00:29',NULL,NULL),(32021,20902,'EM','tyler@tyography.com',0,'2014-01-31 21:01:22',NULL,NULL),(10987,7137,'TE','2812827669',0,'2013-12-26 01:51:49',NULL,NULL),(25215,16259,'TE','4195758021',0,'2014-01-05 00:02:52',NULL,NULL),(4634,2957,'TE','9035214786',0,'2013-12-25 20:16:40',NULL,NULL),(42265,28071,'TE','4402325420',0,'2014-03-06 21:01:50',NULL,NULL),(11660,7589,'TE','3305731132',0,'2013-12-26 02:45:05',NULL,NULL),(597,368,'TE','7139442391',0,'2013-12-25 17:45:22',NULL,NULL),(32242,21058,'TE','3183444721',0,'2014-02-02 19:00:10',NULL,NULL),(11150,7251,'TE','2253970714',0,'2013-12-26 02:01:55',NULL,NULL),(10750,6988,'TE','5136154365',0,'2013-12-26 01:47:55',NULL,NULL),(28888,18651,'EM','Kimcavazos1969@yahoo.com',0,'2014-01-17 03:35:10',NULL,NULL),(5207,3345,'TE','9364433679',0,'2013-12-25 21:16:36',NULL,NULL),(13538,8828,'TE','5628320418',0,'2013-12-26 04:00:27',NULL,NULL),(2914,1787,'AP','6144969390',0,'2013-12-25 18:56:30',NULL,NULL),(13992,9128,'AP','3372075405',0,'2013-12-26 04:07:56',NULL,NULL),(23020,14849,'AP','5135226004',1,'2013-12-29 11:15:03',NULL,NULL),(27842,17937,'EM','priscillachavarria62@yahoo.com',0,'2014-01-15 02:06:38',NULL,NULL),(35956,23655,'TE','9729891283',0,'2014-02-14 21:30:17',NULL,NULL),(22975,14819,'AP','9032938145',1,'2013-12-29 11:14:17',NULL,NULL),(22625,14589,'AP','2166336614',0,'2013-12-28 03:36:06',NULL,NULL),(20809,13368,'EM','jason@bigmeek.com',0,'2013-12-26 12:59:43',NULL,NULL),(32348,21132,'EM','ami_jo_flores@yahoo.com',0,'2014-02-03 21:00:19',NULL,NULL),(37086,24418,'AP','9374776776',0,'2014-02-18 22:01:05',NULL,NULL),(37048,24396,'AP','7403610928',0,'2014-02-18 22:00:52',NULL,NULL),(35101,23056,'TE','5042967858',0,'2014-02-12 21:30:49',NULL,NULL),(12354,8087,'AP','5135784924',0,'2013-12-26 03:10:35',NULL,NULL),(38592,25503,'TE','9032441221',0,'2014-02-25 21:31:56',NULL,NULL),(22125,14252,'TE','9035662440',0,'2013-12-27 02:05:32',NULL,NULL),(5023,3223,'TE','4194390433',0,'2013-12-25 20:45:48',NULL,NULL),(23763,15327,'AP','3254361587',1,'2014-01-02 04:23:48',NULL,NULL),(6263,4042,'AP','4198606105',0,'2013-12-25 21:46:07',NULL,NULL),(9890,6467,'TE','3306245500',0,'2013-12-26 00:50:04',NULL,NULL),(35609,23416,'TE','3613188102',0,'2014-02-13 22:01:19',NULL,NULL),(34615,22696,'AP','2103170817',0,'2014-02-11 21:00:56',NULL,NULL),(10193,6661,'AP','4092830479',0,'2013-12-26 01:00:52',NULL,NULL),(30752,19984,'TE','6146228128',0,'2014-01-25 19:00:16',NULL,NULL),(29991,19416,'AP','6014413572',1,'2014-01-22 03:23:00',NULL,NULL),(27270,17556,'EM','anne.canfield@hotmail.com',0,'2014-01-13 03:01:58',NULL,NULL),(35784,23532,'AP','3185422391',0,'2014-02-13 22:02:27',NULL,NULL),(40294,26729,'TE','4194602209',0,'2014-02-28 21:31:48',NULL,NULL),(26600,17111,'EM','kranford@gmail.com',0,'2014-01-13 02:21:37',NULL,NULL),(37819,24956,'AP','2287317705',0,'2014-02-20 22:00:15',NULL,NULL),(25275,16296,'TE','3378528174',0,'2014-01-07 04:01:01',NULL,NULL),(23263,14988,'TE','9564247036',0,'2014-01-01 12:01:20',NULL,NULL),(32979,21590,'TE','4198670171',0,'2014-02-05 21:30:29',NULL,NULL),(12458,8157,'EM','rv7rb@aol.com',0,'2013-12-26 03:16:14',NULL,NULL),(22853,14745,'EM','Beverlyjones1598@gmail.com',1,'2013-12-29 11:10:10',NULL,NULL),(14825,9705,'TE','4192800209',0,'2013-12-26 04:40:05',NULL,NULL),(21449,13787,'EM','taylorandsonsadc@aol.com',0,'2013-12-26 13:10:56',NULL,NULL),(22248,14339,'TE','4199577362',0,'2013-12-27 02:07:50',NULL,NULL),(3919,2486,'AP','5048134131',0,'2013-12-25 19:35:40',NULL,NULL),(37674,24841,'EM','k_tweet99@hotmail.com',0,'2014-02-20 04:54:01',NULL,NULL),(9479,6204,'TE','4197730331',0,'2013-12-26 00:30:42',NULL,NULL),(24874,16039,'EM','sshim73@outlook.com',0,'2014-01-04 02:02:47',NULL,NULL),(20909,13447,'EM','lukefeerer@yahoo.com',0,'2013-12-26 13:01:23',NULL,NULL),(9075,5952,'TE','6012912305',0,'2013-12-25 23:51:06',NULL,NULL),(27617,17803,'EM','keburt@yahoo.com',0,'2014-01-14 01:33:55',NULL,NULL),(11611,7550,'AP','5043556022',0,'2013-12-26 02:33:12',NULL,NULL),(27645,17820,'AP','6625412547',0,'2014-01-15 02:05:56',NULL,NULL),(36735,24186,'TE','5135157945',0,'2014-02-16 19:00:11',NULL,NULL),(31938,20849,'TE','6144461483',0,'2014-01-31 21:00:51',NULL,NULL),(28740,18546,'TE','6016245839',0,'2014-01-16 08:46:52',NULL,NULL),(42522,28284,'TE','5043307574',0,'2014-03-07 21:00:26',NULL,NULL),(42659,28380,'AP','2342009330',0,'2014-03-07 21:30:39',NULL,NULL),(43470,28869,'TE','8307887548',0,'2014-03-10 21:00:01',NULL,NULL),(43643,28968,'AP','3376543928',0,'2014-03-10 21:01:01',NULL,NULL),(3638,2302,'TE','4405268321',0,'2013-12-25 19:31:01',NULL,NULL),(29010,18727,'TE','6157156445',0,'2014-01-17 03:35:36',NULL,NULL),(35842,23567,'EM','aaellis8@gmail.com',0,'2014-02-13 22:02:49',NULL,NULL),(23217,14960,'EM','DREECEPET@GMAIL.COM',0,'2014-01-01 12:00:30',NULL,NULL),(30983,20154,'TE','5137878576',0,'2014-01-27 21:01:06',NULL,NULL),(14884,9740,'AP','8175006172',0,'2013-12-26 04:45:55',NULL,NULL),(460,290,'AP','2147185978',0,'2013-12-25 17:30:30',NULL,NULL),(11087,7203,'AP','3309984730',0,'2013-12-26 02:00:42',NULL,NULL),(25395,16377,'EM','diamamontoya@yahoo.com',0,'2014-01-07 04:03:14',NULL,NULL),(39848,26356,'EM','yeosanyi@yahoo.com',0,'2014-02-28 06:31:49',NULL,NULL),(43021,28605,'AP','2526704961',0,'2014-03-08 21:30:12',NULL,NULL),(23337,15036,'AP','5042143286',0,'2014-01-01 12:02:47',NULL,NULL),(13648,8900,'AP','4403761951',0,'2013-12-26 04:02:15',NULL,NULL),(4494,2858,'AP','6145569262',0,'2013-12-25 20:01:34',NULL,NULL),(27689,17847,'EM','M3davis2001@yahoo.com',0,'2014-01-15 02:06:05',NULL,NULL),(30907,20094,'TE','9855132891',0,'2014-01-27 21:00:32',NULL,NULL),(5442,3484,'EM','jamestarkany@yahoo.com',0,'2013-12-25 21:20:16',NULL,NULL),(3730,2369,'TE','4073610387',0,'2013-12-25 19:32:41',NULL,NULL),(10404,6781,'EM','TAXGAL1969@GMAIL.COM',0,'2013-12-26 01:16:52',NULL,NULL),(10804,7019,'EM','adam7n@gmail.com',0,'2013-12-26 01:48:48',NULL,NULL),(41358,27477,'AP','9403008347',0,'2014-03-04 21:02:14',NULL,NULL),(29144,18827,'TE','6018550353',0,'2014-01-17 03:36:08',NULL,NULL),(7726,5044,'TE','3306480004',0,'2013-12-25 22:48:06',NULL,NULL),(30386,19688,'TE','9564377529',0,'2014-01-23 21:00:41',NULL,NULL),(857,535,'TE','6018626071',0,'2013-12-25 17:49:32',NULL,NULL),(3861,2456,'AP','9723333846',0,'2013-12-25 19:34:47',NULL,NULL),(22609,14580,'TE','2253289110',0,'2013-12-28 03:35:49',NULL,NULL),(42172,28014,'AP','9374791630',0,'2014-03-06 21:01:17',NULL,NULL),(26905,17309,'TE','9034367148',0,'2014-01-13 02:23:43',NULL,NULL),(26576,17098,'TE','2102687470',0,'2014-01-13 02:21:30',NULL,NULL),(32051,20922,'TE','3306975537',0,'2014-01-31 21:01:33',NULL,NULL),(22780,14689,'EM','janmckee10@yahoo.com',1,'2013-12-29 11:08:46',NULL,NULL),(21930,14127,'AP','2253154699',0,'2013-12-27 02:02:18',NULL,NULL),(9749,6374,'EM','deloatch.patricia@yahoo.com',0,'2013-12-26 00:47:46',NULL,NULL),(1954,1210,'EM','keithjamescarpenter@gmail.com',0,'2013-12-25 18:20:06',NULL,NULL),(1371,835,'TE','5133008920',0,'2013-12-25 18:06:29',NULL,NULL),(4740,3035,'AP','4328166381',0,'2013-12-25 20:18:31',NULL,NULL),(3265,2053,'EM','kateingradschool@gmail.com',0,'2013-12-25 19:15:56',NULL,NULL),(2547,1557,'TE','6624175950',0,'2013-12-25 18:50:47',NULL,NULL),(9207,6024,'AP','5122877987',0,'2013-12-26 00:00:58',NULL,NULL),(736,461,'AP','4406698732',0,'2013-12-25 17:47:38',NULL,NULL),(43229,28724,'EM','mike@metalcarportdepotllc.com',0,'2014-03-09 20:59:59',NULL,NULL),(25589,16506,'EM','ldparm@yahoo.com',1,'2014-01-07 10:21:15',NULL,NULL),(24393,15751,'TE','9565872437',0,'2014-01-03 02:01:10',NULL,NULL),(21554,13859,'TE','3308983032',0,'2013-12-26 13:12:47',NULL,NULL),(33525,21978,'AP','5044288603',0,'2014-02-07 19:00:35',NULL,NULL),(33523,21977,'AP','5043446088',0,'2014-02-07 19:00:34',NULL,NULL),(20904,13445,'TE','9377460798',0,'2013-12-26 13:01:19',NULL,NULL),(28794,18582,'EM','JARMARA@LIVE.COM',0,'2014-01-16 08:47:09',NULL,NULL),(28875,18644,'TE','2104132180',0,'2014-01-17 03:35:07',NULL,NULL),(40389,26808,'TE','4409791413',0,'2014-03-01 21:00:27',NULL,NULL),(27923,17990,'AP','3306455756',0,'2014-01-15 02:06:57',NULL,NULL),(27767,17903,'AP','8173600815',0,'2014-01-15 02:06:24',NULL,NULL),(37868,24981,'TE','9567469998',0,'2014-02-20 22:00:34',NULL,NULL),(36514,24040,'TE','3305382148',0,'2014-02-15 22:00:58',NULL,NULL),(31410,20477,'EM','roncanini@att.net',0,'2014-01-29 21:00:59',NULL,NULL),(2197,1350,'EM','iluvsame@aol.com',0,'2013-12-25 18:45:14',NULL,NULL),(2416,1474,'TE','4193056191',0,'2013-12-25 18:48:39',NULL,NULL),(21436,13781,'TE','6018260424',0,'2013-12-26 13:10:45',NULL,NULL),(10276,6710,'AP','3305654223',0,'2013-12-26 01:02:14',NULL,NULL),(8229,5385,'TE','6196062686',0,'2013-12-25 23:08:29',NULL,NULL),(8020,5242,'TE','3302895231',0,'2013-12-25 23:04:56',NULL,NULL),(26900,17307,'TE','2108222013',0,'2014-01-13 02:23:42',NULL,NULL),(27344,17607,'AP','9035038805',0,'2014-01-14 01:32:19',NULL,NULL),(6,4,'AP','5136753181',0,'2013-12-25 17:15:07',NULL,NULL),(9856,6444,'TE','5677427161',0,'2013-12-26 00:49:32',NULL,NULL),(38242,25248,'AP','9379973640',0,'2014-02-21 22:01:12',NULL,NULL),(13986,9125,'TE','6626890618',0,'2013-12-26 04:07:51',NULL,NULL),(11816,7689,'TE','5135204635',0,'2013-12-26 03:00:59',NULL,NULL),(40722,27063,'AP','3372510003',0,'2014-03-03 21:30:01',NULL,NULL),(21893,14106,'TE','6144241172',0,'2013-12-27 02:01:43',NULL,NULL),(21653,13935,'AP','4194906645',0,'2013-12-26 13:14:37',NULL,NULL),(30762,19990,'EM','EMAILREX@YAHOO.COM',0,'2014-01-25 19:00:19',NULL,NULL),(8261,5406,'TE','5132840229',0,'2013-12-25 23:09:04',NULL,NULL),(11698,7616,'TE','3306275467',0,'2013-12-26 02:45:47',NULL,NULL),(13855,9033,'EM','ikrek@sbcglobal.net',0,'2013-12-26 04:05:39',NULL,NULL),(13884,9054,'EM','tabithamarble@gmail.com',0,'2013-12-26 04:06:08',NULL,NULL),(5016,3219,'AP','5046994532',0,'2013-12-25 20:45:40',NULL,NULL),(3295,2073,'AP','5044300175',0,'2013-12-25 19:16:25',NULL,NULL),(41565,27638,'TE','5133827670',0,'2014-03-05 21:30:14',NULL,NULL),(25979,16735,'AP','3306222290',0,'2014-01-08 18:24:50',NULL,NULL),(20395,13136,'AP','5135158959',0,'2013-12-26 12:53:10',NULL,NULL),(42757,28441,'TE','5049124353',0,'2014-03-07 21:31:13',NULL,NULL),(25350,16348,'AP','7246506670',0,'2014-01-07 04:02:25',NULL,NULL),(30025,19446,'AP','5132662706',0,'2014-01-23 03:01:51',NULL,NULL),(4344,2773,'TE','3308679752',0,'2013-12-25 19:49:35',NULL,NULL),(28971,18699,'AP','2259075924',0,'2014-01-17 03:35:27',NULL,NULL),(27306,17586,'TE','4407251111',0,'2014-01-14 01:32:08',NULL,NULL),(28446,18327,'EM','samgrtfl1@aol.com',0,'2014-01-16 08:45:11',NULL,NULL),(10810,7022,'TE','9726905975',0,'2013-12-26 01:48:52',NULL,NULL),(13571,8848,'EM','let_e79@live.com',0,'2013-12-26 04:00:57',NULL,NULL),(3837,2441,'AP','3302241607',0,'2013-12-25 19:34:27',NULL,NULL),(34478,22621,'EM','elanbills1@gmail.com',0,'2014-02-11 21:00:10',NULL,NULL),(30553,19825,'TE','2105893669',0,'2014-01-24 21:00:16',NULL,NULL),(103,60,'TE','3304218590',0,'2013-12-25 17:16:39',NULL,NULL),(36348,23936,'EM','joe2@robintek.com',0,'2014-02-15 21:00:07',NULL,NULL),(26354,16962,'TE','4192892297',0,'2014-01-13 02:20:08',NULL,NULL),(31621,20627,'AP','8302550697',0,'2014-01-30 21:00:26',NULL,NULL),(3845,2447,'TE','5138446218',0,'2013-12-25 19:34:34',NULL,NULL),(31962,20870,'TE','8018859780',0,'2014-01-31 21:01:01',NULL,NULL),(5435,3477,'EM','riesenberg4@aol.com',0,'2013-12-25 21:20:08',NULL,NULL),(34753,22786,'AP','7852824836',0,'2014-02-11 21:01:47',NULL,NULL),(23941,15447,'EM','CoonStopper1@hotmail.com',1,'2014-01-02 04:28:16',NULL,NULL),(20435,13160,'TE','5133403437',0,'2013-12-26 12:53:50',NULL,NULL),(43084,28641,'EM','marnapatterson@gmail.com',0,'2014-03-08 21:30:33',NULL,NULL),(31113,20258,'TE','5136751654',0,'2014-01-28 21:00:17',NULL,NULL),(36209,23833,'EM','wiggins.tiffany@gmail.com',0,'2014-02-14 21:31:48',NULL,NULL),(32507,21249,'BN','3307038859',0,'2014-02-03 21:01:17',NULL,NULL),(32665,21364,'TE','9092616284',0,'2014-02-04 21:00:45',NULL,NULL),(25234,16271,'TE','7409261616',0,'2014-01-07 04:00:17',NULL,NULL),(25199,16246,'EM','pchow1970@yahoo.com',0,'2014-01-05 00:02:33',NULL,NULL),(3682,2337,'AP','3617418385',0,'2013-12-25 19:31:50',NULL,NULL),(10520,6852,'AP','6143723959',0,'2013-12-26 01:31:25',NULL,NULL),(21407,13764,'TE','7313354686',0,'2013-12-26 13:10:18',NULL,NULL),(20586,13243,'EM','abroome@hotmail.com',0,'2013-12-26 12:56:10',NULL,NULL),(711,442,'EM','Califkoz@yahoo.com',0,'2013-12-25 17:47:12',NULL,NULL),(35590,23407,'TE','5138211872',0,'2014-02-13 22:01:13',NULL,NULL),(5000,3209,'EM','Chuckfritsch49@yahoo.com',0,'2013-12-25 20:45:24',NULL,NULL),(26392,16988,'BN','8322669657',0,'2014-01-13 02:20:22',NULL,NULL),(11483,7467,'EM','terri.41@gmail.com',0,'2013-12-26 02:31:06',NULL,NULL),(5484,3509,'TE','5133839789',0,'2013-12-25 21:20:57',NULL,NULL),(4325,2760,'AP','2162535635',0,'2013-12-25 19:49:18',NULL,NULL),(5912,3792,'TE','5136832715',0,'2013-12-25 21:34:16',NULL,NULL),(42165,28010,'AP','5133199866',0,'2014-03-06 21:01:15',NULL,NULL),(27610,17798,'AP','3142585587',0,'2014-01-14 01:33:52',NULL,NULL),(29403,19002,'EM','aleary1@cox.net',0,'2014-01-20 08:06:17',NULL,NULL),(39027,25807,'EM','BELLA.BEAL@ATT.NET',0,'2014-02-26 21:00:20',NULL,NULL),(33376,21869,'TE','5042067550',0,'2014-02-06 21:01:25',NULL,NULL),(40313,26748,'TE','3305719324',0,'2014-02-28 21:31:58',NULL,NULL),(10944,7113,'AP','2254540126',0,'2013-12-26 01:51:07',NULL,NULL),(3851,2453,'TE','9367180613',0,'2013-12-25 19:34:41',NULL,NULL),(11255,7330,'TE','5133686249',0,'2013-12-26 02:03:49',NULL,NULL),(26931,17323,'TE','2542266370',0,'2014-01-13 02:23:52',NULL,NULL),(23836,15379,'AP','5132370701',1,'2014-01-02 04:25:22',NULL,NULL),(9179,6007,'AP','6143517959',0,'2013-12-26 00:00:32',NULL,NULL),(23976,15479,'TE','6143156243',1,'2014-01-02 04:29:05',NULL,NULL),(25098,16181,'TE','2147700423',0,'2014-01-05 00:00:32',NULL,NULL),(41402,27505,'AP','4199801332',0,'2014-03-04 21:02:30',NULL,NULL),(42130,27986,'AP','9853870194',0,'2014-03-06 21:01:01',NULL,NULL),(583,360,'AP','2104644474',0,'2013-12-25 17:45:09',NULL,NULL),(11253,7328,'EM','will688@aol.com',0,'2013-12-26 02:03:46',NULL,NULL),(36487,24021,'TE','6142531027',0,'2014-02-15 22:00:47',NULL,NULL),(34053,22326,'EM','coachnu2000@yahoo.com',0,'2014-02-10 11:00:58',NULL,NULL),(30440,19733,'TE','5046551224',0,'2014-01-23 21:01:07',NULL,NULL),(23416,15083,'EM','bernal_terry@yahoo.com',0,'2014-01-01 12:04:14',NULL,NULL),(28998,18720,'TE','5132374863',0,'2014-01-17 03:35:34',NULL,NULL),(8770,5748,'AP','3189907573',0,'2013-12-25 23:46:08',NULL,NULL),(41156,27334,'EM','rikkard@aol.com',0,'2014-03-04 21:00:55',NULL,NULL),(11193,7277,'EM','ceceliaphillips@sbcglobal.net',0,'2013-12-26 02:02:36',NULL,NULL),(39724,26273,'AP','4193037566',0,'2014-02-28 06:31:17',NULL,NULL),(1971,1219,'TE','3308678229',0,'2013-12-25 18:20:21',NULL,NULL),(37229,24500,'TE','7139602677',0,'2014-02-20 03:48:58',NULL,NULL),(36942,24329,'TE','5126361802',0,'2014-02-18 22:00:13',NULL,NULL),(5783,3704,'AP','7404382237',0,'2013-12-25 21:32:03',NULL,NULL),(33926,22266,'TE','4322716877',0,'2014-02-10 11:00:11',NULL,NULL),(32578,21301,'TE','2256653329',0,'2014-02-04 21:00:12',NULL,NULL),(13765,8970,'EM','camilia.ward@yahoo.com',0,'2013-12-26 04:04:05',NULL,NULL),(22947,14804,'TE','5044919829',1,'2013-12-29 11:13:51',NULL,NULL),(10730,6978,'EM','danmccarthy1965@gmail.com',0,'2013-12-26 01:47:38',NULL,NULL),(38145,25177,'TE','5137065119',0,'2014-02-21 22:00:32',NULL,NULL),(6712,4363,'AP','2167022812',0,'2013-12-25 22:00:05',NULL,NULL),(34754,22786,'EM','draws4@roadrunner.com',0,'2014-02-11 21:01:47',NULL,NULL),(6416,4140,'EM','cnakkag@gmail.com',0,'2013-12-25 21:48:35',NULL,NULL),(11982,7807,'AP','3252343139',0,'2013-12-26 03:03:50',NULL,NULL),(12094,7905,'TE','5042203574',0,'2013-12-26 03:05:55',NULL,NULL),(30500,19783,'EM','dfabian4@aol.com',0,'2014-01-23 21:01:36',NULL,NULL),(29633,19146,'AP','5123509351',0,'2014-01-21 08:45:32',NULL,NULL),(24408,15759,'EM','empress.pando@gmail.com',0,'2014-01-03 02:01:26',NULL,NULL),(41100,27299,'EM','girlintx76@yahoo.com',0,'2014-03-04 21:00:34',NULL,NULL),(3977,2522,'AP','3304142349',0,'2013-12-25 19:36:38',NULL,NULL),(6459,4172,'AP','9373124118',0,'2013-12-25 21:49:16',NULL,NULL),(39273,25985,'AP','2169522408',0,'2014-02-26 21:01:54',NULL,NULL),(37909,25006,'AP','3305507878',0,'2014-02-20 22:00:49',NULL,NULL),(33785,22175,'AP','4192709442',0,'2014-02-08 19:30:08',NULL,NULL),(33052,21652,'AP','5048587013',0,'2014-02-05 21:30:50',NULL,NULL),(10338,6740,'AP','3302851972',0,'2013-12-26 01:15:46',NULL,NULL),(31401,20470,'TE','3307277081',0,'2014-01-29 21:00:55',NULL,NULL),(12038,7851,'AP','4403276912',0,'2013-12-26 03:04:50',NULL,NULL),(14243,9317,'TE','5055042988',0,'2013-12-26 04:30:25',NULL,NULL),(41850,27830,'EM','darlene.pabon13@gmail.com',0,'2014-03-05 21:32:00',NULL,NULL),(4436,2828,'TE','9854476555',0,'2013-12-25 20:00:41',NULL,NULL),(11086,7203,'TE','3309984730',0,'2013-12-26 02:00:41',NULL,NULL),(3125,1947,'TE','3307232382',0,'2013-12-25 19:00:52',NULL,NULL),(34530,22651,'AP','2816102150',0,'2014-02-11 21:00:28',NULL,NULL),(28241,18211,'TE','5134241399',0,'2014-01-15 02:08:10',NULL,NULL),(33055,21653,'AP','2258101478',0,'2014-02-05 21:30:51',NULL,NULL),(41736,27750,'AP','3378424161',0,'2014-03-05 21:31:15',NULL,NULL),(1737,1069,'TE','2162247341',0,'2013-12-25 18:16:28',NULL,NULL),(39788,26307,'AP','3616528119',0,'2014-02-28 06:31:32',NULL,NULL),(8574,5637,'AP','8068936526',0,'2013-12-25 23:31:08',NULL,NULL),(37675,24842,'TE','3308631538',0,'2014-02-20 04:54:05',NULL,NULL),(37446,24654,'TE','4196809902',0,'2014-02-20 04:23:57',NULL,NULL),(31641,20643,'AP','8329695416',0,'2014-01-30 21:00:34',NULL,NULL),(6190,3988,'EM','dlroehm@msn.com',0,'2013-12-25 21:39:02',NULL,NULL),(26521,17063,'AP','4697677656',0,'2014-01-13 02:21:13',NULL,NULL),(24218,15647,'TE','2284756826',1,'2014-01-02 04:33:59',NULL,NULL),(5183,3327,'EM','scott_jensen99@yahoo.com',0,'2013-12-25 21:16:12',NULL,NULL),(23372,15057,'TE','2256157671',0,'2014-01-01 12:03:26',NULL,NULL),(41437,27527,'TE','4194480065',0,'2014-03-04 21:02:45',NULL,NULL),(43074,28637,'TE','9563508159',0,'2014-03-08 21:30:30',NULL,NULL),(43433,28846,'TE','3309288192',0,'2014-03-09 21:01:15',NULL,NULL),(3325,2091,'AP','3372514225',0,'2013-12-25 19:16:53',NULL,NULL),(4364,2782,'TE','4194103568',0,'2013-12-25 19:49:54',NULL,NULL),(5476,3504,'AP','7403043679',0,'2013-12-25 21:20:49',NULL,NULL),(20763,13342,'AP','4056429404',0,'2013-12-26 12:58:57',NULL,NULL),(8732,5727,'TE','9855268749',0,'2013-12-25 23:45:34',NULL,NULL),(39871,26376,'BN','2165981642',0,'2014-02-28 07:00:17',NULL,NULL),(5686,3652,'TE','9372772229',0,'2013-12-25 21:30:40',NULL,NULL),(33767,22160,'TE','5133791739',0,'2014-02-08 19:00:58',NULL,NULL),(11093,7206,'TE','3304060289',0,'2013-12-26 02:00:47',NULL,NULL),(2345,1426,'EM','Pipepipper262004@yahoo.com',0,'2013-12-25 18:47:25',NULL,NULL),(28010,18055,'TE','4193408632',0,'2014-01-15 02:07:18',NULL,NULL),(2643,1608,'AP','3615503199',0,'2013-12-25 18:52:13',NULL,NULL),(3264,2052,'EM','KJLP1018@YAHOO.COM',0,'2013-12-25 19:15:55',NULL,NULL),(5425,3471,'AP','5132374722',0,'2013-12-25 21:19:59',NULL,NULL),(41817,27800,'AP','3309076676',0,'2014-03-05 21:31:46',NULL,NULL),(41430,27524,'AP','3308816700',0,'2014-03-04 21:02:42',NULL,NULL),(39264,25977,'TE','5136286016',0,'2014-02-26 21:01:50',NULL,NULL),(14940,9774,'TE','5044914112',0,'2013-12-26 05:00:34',NULL,NULL),(36362,23945,'EM','noemibucalan@yahoo.com',0,'2014-02-15 21:00:12',NULL,NULL),(32276,21084,'AP','2162952556',0,'2014-02-02 19:00:23',NULL,NULL),(14794,9683,'TE','5134775516',0,'2013-12-26 04:39:31',NULL,NULL),(30087,19492,'AP','4408128775',0,'2014-01-23 03:02:07',NULL,NULL),(3874,2463,'TE','9858093461',0,'2013-12-25 19:35:00',NULL,NULL),(22824,14718,'AP','9375614369',1,'2013-12-29 11:09:30',NULL,NULL),(43562,28928,'EM','ateppermyn@gmail.com',0,'2014-03-10 21:00:36',NULL,NULL),(9654,6314,'EM','casetser.md@gmail.com',0,'2013-12-26 00:46:17',NULL,NULL),(4629,2952,'TE','8326073819',0,'2013-12-25 20:16:33',NULL,NULL),(39549,26164,'AP','3306221743',0,'2014-02-28 06:30:34',NULL,NULL),(498,316,'TE','3303223866',0,'2013-12-25 17:31:11',NULL,NULL),(676,421,'EM','kaphiejones2004@hotmail.com',0,'2013-12-25 17:46:39',NULL,NULL),(34997,22977,'AP','4405415076',0,'2014-02-12 21:30:06',NULL,NULL),(20979,13503,'EM','katrina_frazier1978@yahoo.com',0,'2013-12-26 13:02:39',NULL,NULL),(22168,14277,'TE','6019221864',0,'2013-12-27 02:06:16',NULL,NULL),(43375,28807,'TE','3306344893',0,'2014-03-09 21:00:52',NULL,NULL),(158,94,'EM','popydady@verizon.net',0,'2013-12-25 17:17:32',NULL,NULL),(39568,26178,'EM','Cheriecook2000@yahoo.com',0,'2014-02-28 06:30:39',NULL,NULL),(25747,16593,'TE','9858395084',0,'2014-01-08 18:24:01',NULL,NULL),(24584,15857,'TE','3302127618',0,'2014-01-03 02:04:37',NULL,NULL),(21125,13584,'EM','dilmabollat@yahoo.com',0,'2013-12-26 13:04:59',NULL,NULL),(30064,19474,'TE','2817038843',0,'2014-01-23 03:02:01',NULL,NULL),(29818,19291,'AP','3186092658',1,'2014-01-22 03:21:55',NULL,NULL),(26082,16799,'TE','9155889727',0,'2014-01-13 02:18:10',NULL,NULL),(8006,5224,'TE','4253271474',0,'2013-12-25 23:04:37',NULL,NULL),(12241,8004,'AP','9563308066',0,'2013-12-26 03:08:27',NULL,NULL),(20737,13329,'TE','2102194601',0,'2013-12-26 12:58:34',NULL,NULL),(356,219,'AP','3182889671',0,'2013-12-25 17:20:43',NULL,NULL),(41873,27843,'AP','3259989692',0,'2014-03-05 21:32:09',NULL,NULL),(24849,16027,'EM','revlrturner@gmail.com',0,'2014-01-04 02:02:21',NULL,NULL),(23349,15042,'AP','2253248362',0,'2014-01-01 12:03:00',NULL,NULL),(37450,24657,'TE','4192430397',0,'2014-02-20 04:24:51',NULL,NULL),(37373,24602,'EM','vexxed4412@gmail.com',0,'2014-02-20 04:13:11',NULL,NULL),(34819,22838,'TE','3306082423',0,'2014-02-11 21:02:12',NULL,NULL),(22549,14543,'AP','6019463498',0,'2013-12-28 03:34:50',NULL,NULL),(32115,20971,'TE','9152530638',0,'2014-02-01 19:00:15',NULL,NULL),(31676,20664,'AP','9035061841',0,'2014-01-30 21:00:45',NULL,NULL),(30080,19488,'TE','8303177887',0,'2014-01-23 03:02:05',NULL,NULL),(7444,4850,'TE','3307609385',0,'2013-12-25 22:30:20',NULL,NULL),(11722,7631,'TE','3304743134',0,'2013-12-26 02:46:15',NULL,NULL),(43873,29110,'EM','alan.farris@gmail.com',0,'2014-03-10 21:02:24',NULL,NULL),(1746,1075,'EM','heskamp.josh@gmail.com',0,'2013-12-25 18:16:38',NULL,NULL),(32445,21201,'TE','4196010097',0,'2014-02-03 21:00:53',NULL,NULL),(32515,21255,'AP','4408644128',0,'2014-02-03 21:01:20',NULL,NULL),(39789,26307,'EM','TONI689@YAHOO.COM',0,'2014-02-28 06:31:32',NULL,NULL),(33876,22234,'EM','LesaMcKenzie514@hotmail.com',0,'2014-02-09 19:00:34',NULL,NULL),(38382,25357,'TE','2165414313',0,'2014-02-25 21:30:34',NULL,NULL),(43846,29099,'TE','5134036830',0,'2014-03-10 21:02:15',NULL,NULL),(560,348,'TE','4403134847',0,'2013-12-25 17:32:11',NULL,NULL),(9868,6452,'AP','2164702366',0,'2013-12-26 00:49:43',NULL,NULL),(11717,7628,'AP','9378309904',0,'2013-12-26 02:46:08',NULL,NULL),(39439,26085,'TE','5043589779',0,'2014-02-28 06:30:06',NULL,NULL),(20520,13209,'TE','8327172144',0,'2013-12-26 12:55:12',NULL,NULL),(32197,21030,'EM','dori3riddle@gmail.com',0,'2014-02-01 19:00:44',NULL,NULL),(1983,1225,'AP','3304955014',0,'2013-12-25 18:20:32',NULL,NULL),(27523,17728,'EM','kmwhittington@msn.com',0,'2014-01-14 01:33:18',NULL,NULL),(26752,17207,'AP','3307159525',0,'2014-01-13 02:22:27',NULL,NULL),(3910,2481,'AP','5043003205',0,'2013-12-25 19:35:31',NULL,NULL),(6388,4114,'EM','jonathanerus@yahoo.com',0,'2013-12-25 21:48:05',NULL,NULL),(23086,14890,'AP','5048108181',0,'2013-12-30 00:00:46',NULL,NULL),(41704,27730,'AP','9567425913',0,'2014-03-05 21:31:04',NULL,NULL),(37436,24649,'AP','5046069323',0,'2014-02-20 04:22:29',NULL,NULL),(32708,21395,'AP','4192423522',0,'2014-02-04 21:00:59',NULL,NULL),(33854,22223,'AP','3303389392',0,'2014-02-09 19:00:28',NULL,NULL),(9882,6462,'AP','2345427548',0,'2013-12-26 00:49:56',NULL,NULL),(41949,27885,'AP','4197872264',0,'2014-03-05 21:32:35',NULL,NULL),(9655,6321,'TE','6147361100',0,'2013-12-26 00:46:21',NULL,NULL),(6276,4048,'TE','6142541466',0,'2013-12-25 21:46:19',NULL,NULL),(35944,23650,'TE','4694717041',0,'2014-02-14 21:30:13',NULL,NULL),(6761,4388,'EM','gordon.dawson3@gmail.com',0,'2013-12-25 22:00:49',NULL,NULL),(32362,21146,'TE','4322137546',0,'2014-02-03 21:00:25',NULL,NULL),(28217,18190,'TE','3306679156',0,'2014-01-15 02:08:03',NULL,NULL),(6295,4056,'AP','3307479551',0,'2013-12-25 21:46:34',NULL,NULL),(6531,4224,'EM','MOSBAUGH.2@GMAIL.COM',0,'2013-12-25 21:50:30',NULL,NULL),(43449,28854,'EM','joneste72@gmail.com',0,'2014-03-09 21:01:21',NULL,NULL),(2234,1371,'EM','amark@math.utexas.edu',0,'2013-12-25 18:45:48',NULL,NULL),(4340,2771,'AP','3309980303',0,'2013-12-25 19:49:31',NULL,NULL),(5456,3493,'TE','9374733785',0,'2013-12-25 21:20:30',NULL,NULL),(23140,14919,'EM','fossilhunt4084@yahoo.com',0,'2013-12-30 00:01:37',NULL,NULL),(38329,25322,'AP','2254397575',0,'2014-02-25 21:30:10',NULL,NULL),(36104,23755,'AP','5132371316',0,'2014-02-14 21:31:08',NULL,NULL),(30764,19993,'AP','5137674436',0,'2014-01-25 19:00:21',NULL,NULL),(9219,6034,'TE','7135917052',0,'2013-12-26 00:01:13',NULL,NULL),(24841,16021,'BN','3185729778',0,'2014-01-04 02:02:11',NULL,NULL),(2829,1712,'TE','4193442684',0,'2013-12-25 18:55:01',NULL,NULL),(10471,6821,'EM','vonshaaj@live.com',0,'2013-12-26 01:30:33',NULL,NULL),(11410,7425,'TE','4199343997',0,'2013-12-26 02:17:10',NULL,NULL),(11448,7445,'AP','6057319547',0,'2013-12-26 02:30:33',NULL,NULL),(24971,16093,'TE','2282166206',0,'2014-01-04 02:04:31',NULL,NULL),(1292,787,'TE','5127300311',0,'2013-12-25 18:05:12',NULL,NULL),(26881,17294,'EM','paul.wh.lin@gmail.com',0,'2014-01-13 02:23:35',NULL,NULL),(30156,19539,'TE','4192907066',0,'2014-01-23 03:02:24',NULL,NULL),(40906,27179,'EM','sbunny17@yahoo.com',0,'2014-03-03 21:31:10',NULL,NULL),(32331,21120,'TE','9152041558',0,'2014-02-03 21:00:12',NULL,NULL),(43330,28785,'AP','5133351223',0,'2014-03-09 21:00:37',NULL,NULL),(611,377,'AP','9032585003',0,'2013-12-25 17:45:36',NULL,NULL),(23411,15080,'EM','Denisenewton@rocketmail.com',0,'2014-01-01 12:04:08',NULL,NULL),(21790,14040,'TE','5305103153',0,'2013-12-26 13:17:09',NULL,NULL),(12023,7840,'TE','5135417766',0,'2013-12-26 03:04:35',NULL,NULL),(31417,20480,'EM','klipconstr@roadrunner.com',0,'2014-01-29 21:01:01',NULL,NULL),(1516,933,'AP','7407100280',0,'2013-12-25 18:09:08',NULL,NULL),(27165,17488,'EM','cyndi.aidan@hotmail.com',0,'2014-01-13 03:01:18',NULL,NULL),(26862,17286,'EM','jdquintanilla2@gmail.com',0,'2014-01-13 02:23:30',NULL,NULL),(14594,9543,'TE','4402579412',0,'2013-12-26 04:36:05',NULL,NULL),(5035,3228,'AP','9374747068',0,'2013-12-25 20:45:59',NULL,NULL),(7809,5098,'TE','3617650368',0,'2013-12-25 23:01:23',NULL,NULL),(37103,24425,'AP','3308253026',0,'2014-02-18 22:01:11',NULL,NULL),(31179,20305,'AP','9037156700',0,'2014-01-28 21:00:46',NULL,NULL),(2122,1309,'AP','2254055865',0,'2013-12-25 18:31:24',NULL,NULL),(12366,8093,'TE','3302976171',0,'2013-12-26 03:10:46',NULL,NULL),(30398,19699,'AP','4694749597',0,'2014-01-23 21:00:46',NULL,NULL),(30167,19545,'AP','6628325978',0,'2014-01-23 03:02:26',NULL,NULL),(2037,1261,'AP','4194199762',0,'2013-12-25 18:21:33',NULL,NULL),(28674,18499,'TE','3307549090',0,'2014-01-16 08:46:29',NULL,NULL),(7781,5077,'TE','2103204412',0,'2013-12-25 23:00:52',NULL,NULL),(38970,25766,'TE','6142062270',0,'2014-02-26 09:30:54',NULL,NULL),(38333,25324,'EM','maynardmallory348@yahoo.com',0,'2014-02-25 21:30:12',NULL,NULL),(38293,25286,'TE','5132848620',0,'2014-02-25 21:00:20',NULL,NULL),(3538,2214,'EM','cjstech@yahoo.com',0,'2013-12-25 19:20:22',NULL,NULL),(37363,24595,'AP','5133002623',0,'2014-02-20 04:11:50',NULL,NULL),(2432,1491,'TE','3302407888',0,'2013-12-25 18:49:02',NULL,NULL),(30542,19813,'EM','samkayw@yahoo.com',0,'2014-01-24 21:00:10',NULL,NULL),(14807,9692,'TE','4194241468',0,'2013-12-26 04:39:45',NULL,NULL),(26545,17075,'AP','9152523145',0,'2014-01-13 02:21:19',NULL,NULL),(26508,17057,'TE','2104854224',0,'2014-01-13 02:21:09',NULL,NULL),(26117,16817,'BN','7137058263',0,'2014-01-13 02:18:20',NULL,NULL),(23862,15399,'TE','9034930111',1,'2014-01-02 04:26:44',NULL,NULL),(8100,5304,'AP','6013164523',0,'2013-12-25 23:06:23',NULL,NULL),(8451,5560,'TE','3306302296',0,'2013-12-25 23:16:25',NULL,NULL),(2467,1513,'EM','shml69@aol.com',0,'2013-12-25 18:49:35',NULL,NULL),(35531,23368,'EM','mkkegel@aol.com',0,'2014-02-13 22:00:50',NULL,NULL),(35306,23192,'EM','rcwalkerow@yahoo.com',0,'2014-02-12 21:32:04',NULL,NULL),(22532,14527,'AP','3615858692',0,'2013-12-28 03:34:28',NULL,NULL),(27149,17481,'TE','7137960301',0,'2014-01-13 03:01:13',NULL,NULL),(29087,18785,'AP','9373367804',0,'2014-01-17 03:35:54',NULL,NULL),(28269,18227,'TE','2812596926',0,'2014-01-16 08:44:17',NULL,NULL),(43595,28945,'AP','3372921352',0,'2014-03-10 21:00:46',NULL,NULL),(20618,13261,'TE','9035065077',0,'2013-12-26 12:56:40',NULL,NULL),(14176,9274,'TE','4402301217',0,'2013-12-26 04:15:46',NULL,NULL),(12412,8131,'TE','6145991605',0,'2013-12-26 03:15:31',NULL,NULL),(35040,23014,'TE','2253138452',0,'2014-02-12 21:30:25',NULL,NULL),(33938,22271,'AP','9039463615',0,'2014-02-10 11:00:14',NULL,NULL),(12190,7967,'TE','6157130126',0,'2013-12-26 03:07:34',NULL,NULL),(10794,7016,'TE','9368754636',0,'2013-12-26 01:48:41',NULL,NULL),(26591,17108,'TE','9374662290',0,'2014-01-13 02:21:35',NULL,NULL),(3842,2443,'EM','mboster1@yahoo.com',0,'2013-12-25 19:34:30',NULL,NULL),(14018,9155,'TE','5133681971',0,'2013-12-26 04:08:33',NULL,NULL),(40503,26881,'TE','3304540275',0,'2014-03-01 21:01:09',NULL,NULL),(40403,26818,'AP','5132386103',0,'2014-03-01 21:00:33',NULL,NULL),(12386,8112,'TE','2252755238',0,'2013-12-26 03:15:03',NULL,NULL),(37299,24543,'AP','3305071041',0,'2014-02-20 04:03:05',NULL,NULL),(2085,1288,'TE','9374080384',0,'2013-12-25 18:30:48',NULL,NULL),(2352,1429,'TE','6122816559',0,'2013-12-25 18:47:31',NULL,NULL),(33747,22145,'TE','3305482252',0,'2014-02-08 19:00:51',NULL,NULL),(23666,15282,'TE','2282844709',1,'2014-01-02 04:22:10',NULL,NULL),(29271,18904,'AP','4192176527',0,'2014-01-17 03:36:38',NULL,NULL),(24412,15761,'AP','8302634602',0,'2014-01-03 02:01:30',NULL,NULL),(39645,26216,'TE','3306732234',0,'2014-02-28 06:30:55',NULL,NULL),(39074,25842,'EM','cejasretreat@msn.com',0,'2014-02-26 21:00:36',NULL,NULL),(39042,25820,'TE','5138241332',0,'2014-02-26 21:00:25',NULL,NULL),(14230,9310,'EM','shn_atty@cox.net',0,'2013-12-26 04:30:14',NULL,NULL),(465,292,'EM','zduce8@neo.rr.com',0,'2013-12-25 17:30:36',NULL,NULL),(29244,18889,'EM','pikeless@hotmail.com',0,'2014-01-17 03:36:31',NULL,NULL),(3049,1897,'TE','4196771138',0,'2013-12-25 18:59:02',NULL,NULL),(42968,28574,'AP','8304219520',0,'2014-03-08 21:00:04',NULL,NULL),(42519,28282,'EM','Natyskef@hotmail.com',0,'2014-03-07 21:00:25',NULL,NULL),(25120,16193,'AP','8066764591',0,'2014-01-05 00:00:54',NULL,NULL),(23243,14979,'TE','3614805683',0,'2014-01-01 12:01:01',NULL,NULL),(23073,14880,'EM','solindahong_621@yahoo.com',0,'2013-12-30 00:00:31',NULL,NULL),(14468,9450,'EM','mikemoore@earthlink.net',0,'2013-12-26 04:33:57',NULL,NULL),(33459,21919,'TE','8303709594',0,'2014-02-07 19:00:05',NULL,NULL),(33009,21626,'TE','9728493663',0,'2014-02-05 21:30:39',NULL,NULL),(31570,20589,'EM','markewart@mac.com',0,'2014-01-30 21:00:07',NULL,NULL),(10455,6811,'AP','9405771700',0,'2013-12-26 01:30:19',NULL,NULL),(27216,17524,'AP','4192282006',0,'2014-01-13 03:01:38',NULL,NULL),(28401,18301,'TE','9372775461',0,'2014-01-16 08:44:57',NULL,NULL),(25230,16268,'AP','3309300382',0,'2014-01-07 04:00:13',NULL,NULL),(24746,15967,'TE','4322100487',0,'2014-01-04 02:00:30',NULL,NULL),(7228,4706,'AP','4195083268',0,'2013-12-25 22:08:35',NULL,NULL),(35112,23064,'TE','3186702497',0,'2014-02-12 21:30:53',NULL,NULL),(12049,7863,'EM','DRUMMER623@ATT.NET',0,'2013-12-26 03:05:03',NULL,NULL),(33254,21776,'EM','dsz64@yahoo.com',0,'2014-02-06 21:00:35',NULL,NULL),(777,484,'AP','7326909412',0,'2013-12-25 17:48:15',NULL,NULL),(25334,16336,'TE','7407572454',0,'2014-01-07 04:02:09',NULL,NULL),(24840,16021,'AP','3185729778',0,'2014-01-04 02:02:11',NULL,NULL),(35755,23515,'TE','6622298698',0,'2014-02-13 22:02:16',NULL,NULL),(27367,17617,'AP','8179155761',0,'2014-01-14 01:32:25',NULL,NULL),(29022,18738,'TE','9376843525',0,'2014-01-17 03:35:39',NULL,NULL),(35669,23459,'AP','9567354541',0,'2014-02-13 22:01:42',NULL,NULL),(42955,28565,'AP','9379998607',0,'2014-03-07 21:32:28',NULL,NULL),(14787,9675,'AP','4194968855',0,'2013-12-26 04:39:22',NULL,NULL),(7551,4917,'AP','4194961567',0,'2013-12-25 22:45:04',NULL,NULL),(38220,25227,'TE','3305482900',0,'2014-02-21 22:01:00',NULL,NULL),(3882,2468,'TE','3184484805',0,'2013-12-25 19:35:08',NULL,NULL),(31455,20501,'EM','deannadelatte@yahoo.com',0,'2014-01-29 21:01:13',NULL,NULL),(22207,14305,'TE','3308564729',0,'2013-12-27 02:06:58',NULL,NULL),(22817,14714,'EM','tjeffries04@yahoo.com',1,'2013-12-29 11:09:24',NULL,NULL),(22978,14820,'AP','8323020162',1,'2013-12-29 11:14:20',NULL,NULL),(65,42,'TE','6148736848',0,'2013-12-25 17:16:06',NULL,NULL),(1820,1128,'TE','9568673086',0,'2013-12-25 18:17:58',NULL,NULL),(23948,15451,'EM','widgl123@gmail.com',1,'2014-01-02 04:28:23',NULL,NULL),(25399,16381,'TE','3615703157',0,'2014-01-07 04:03:19',NULL,NULL),(29001,18722,'TE','5132374863',0,'2014-01-17 03:35:34',NULL,NULL),(881,547,'TE','4407288395',0,'2013-12-25 17:49:55',NULL,NULL),(13776,8979,'AP','9374692625',0,'2013-12-26 04:04:17',NULL,NULL),(38486,25434,'AP','7132615722',0,'2014-02-25 21:31:16',NULL,NULL),(1162,712,'AP','4199214749',0,'2013-12-25 18:03:15',NULL,NULL),(26502,17053,'AP','2607975827',0,'2014-01-13 02:20:59',NULL,NULL),(43311,28772,'AP','6144323079',0,'2014-03-09 21:00:30',NULL,NULL),(14892,9746,'TE','4195634484',0,'2013-12-26 04:46:04',NULL,NULL),(1821,1128,'AP','9568673086',0,'2013-12-25 18:17:59',NULL,NULL),(41325,27454,'TE','5134608588',0,'2014-03-04 21:02:01',NULL,NULL),(34700,22754,'AP','5044020777',0,'2014-02-11 21:01:28',NULL,NULL),(34055,22327,'AP','9377980770',0,'2014-02-10 11:00:58',NULL,NULL),(33307,21814,'AP','3307017044',0,'2014-02-06 21:00:56',NULL,NULL),(32036,20911,'AP','4199081202',0,'2014-01-31 21:01:27',NULL,NULL),(2042,1264,'EM','sanchez_andrew@hotmail.com',0,'2013-12-25 18:30:05',NULL,NULL),(29777,19254,'TE','2256367979',0,'2014-01-21 08:46:45',NULL,NULL),(28934,18679,'AP','4797159673',0,'2014-01-17 03:35:20',NULL,NULL),(28186,18167,'AP','9377796620',0,'2014-01-15 02:07:56',NULL,NULL),(9185,6013,'EM','melea.enz@gmail.com',0,'2013-12-26 00:00:39',NULL,NULL),(26294,16925,'AP','5046210515',0,'2014-01-13 02:19:46',NULL,NULL),(2463,1511,'AP','6142840510',0,'2013-12-25 18:49:32',NULL,NULL),(7895,5144,'EM','Flipper4018@yahoo.com',0,'2013-12-25 23:02:38',NULL,NULL),(21500,13816,'EM','mchl2234@roadrunner.com',0,'2013-12-26 13:11:46',NULL,NULL),(7267,4737,'TE','4196474209',0,'2013-12-25 22:09:20',NULL,NULL),(6331,4081,'AP','3308823997',0,'2013-12-25 21:47:12',NULL,NULL),(4142,2643,'EM','edt748@aol.com',0,'2013-12-25 19:46:24',NULL,NULL),(761,477,'TE','9854472866',0,'2013-12-25 17:48:02',NULL,NULL),(41484,27577,'AP','3185472260',0,'2014-03-04 21:30:23',NULL,NULL),(38916,25727,'TE','3183814086',0,'2014-02-26 09:30:33',NULL,NULL),(10622,6909,'EM','dewanbllrs@aol.com',0,'2013-12-26 01:45:53',NULL,NULL),(35857,23577,'EM','vfrruss@gmail.com',0,'2014-02-13 22:02:55',NULL,NULL),(6165,3973,'TE','5137341474',0,'2013-12-25 21:38:38',NULL,NULL),(30050,19464,'TE','9178685888',0,'2014-01-23 03:01:57',NULL,NULL),(25975,16729,'EM','girlmello15@yahoo.com',0,'2014-01-08 18:24:49',NULL,NULL),(2071,1281,'AP','9374097294',0,'2013-12-25 18:30:34',NULL,NULL),(3550,2223,'AP','4194813198',0,'2013-12-25 19:20:35',NULL,NULL),(1417,864,'AP','5673956960',0,'2013-12-25 18:07:16',NULL,NULL),(43435,28847,'TE','4192503455',0,'2014-03-09 21:01:16',NULL,NULL),(8093,5297,'TE','4196455206',0,'2013-12-25 23:06:12',NULL,NULL),(40371,26794,'EM','jeffshawn69ward@yahoo.com',0,'2014-03-01 21:00:21',NULL,NULL),(34321,22519,'TE','2144188315',0,'2014-02-10 21:31:24',NULL,NULL),(3737,2372,'AP','9376411267',0,'2013-12-25 19:32:46',NULL,NULL),(5924,3798,'EM','caserta.16@gmail.com',0,'2013-12-25 21:34:27',NULL,NULL),(3995,2538,'EM','patti_dugger@yahoo.com',0,'2013-12-25 19:36:58',NULL,NULL),(7591,4942,'AP','5132408986',0,'2013-12-25 22:45:43',NULL,NULL),(21714,13984,'EM','margies3@aol.com',0,'2013-12-26 13:15:41',NULL,NULL),(8461,5568,'TE','7409641044',0,'2013-12-25 23:16:37',NULL,NULL),(42462,28209,'TE','6013971376',0,'2014-03-06 21:30:13',NULL,NULL),(26363,16968,'TE','3306282460',0,'2014-01-13 02:20:12',NULL,NULL),(30157,19539,'AP','4192907066',0,'2014-01-23 03:02:24',NULL,NULL),(8069,5283,'AP','4403768860',0,'2013-12-25 23:05:50',NULL,NULL),(39012,25797,'EM','ukcatblue@gmail.com',0,'2014-02-26 21:00:14',NULL,NULL),(4158,2653,'TE','2165701428',0,'2013-12-25 19:46:40',NULL,NULL),(22309,14378,'AP','9377258466',0,'2013-12-28 03:30:44',NULL,NULL),(36215,23837,'EM','mlbridgeford@fuse.net',0,'2014-02-14 21:31:50',NULL,NULL),(28126,18132,'TE','5138964435',0,'2014-01-15 02:07:43',NULL,NULL),(27896,17975,'EM','arnoldhicks@netscape.net',0,'2014-01-15 02:06:51',NULL,NULL),(27777,17907,'TE','2106537704',0,'2014-01-15 02:06:25',NULL,NULL),(23632,15260,'EM','Tamaratrapnell@yahoo.com',0,'2014-01-01 12:09:15',NULL,NULL),(20190,13008,'TE','5133140487',0,'2013-12-26 12:49:43',NULL,NULL),(12039,7851,'EM','willysmith@oh.rr.com',0,'2013-12-26 03:04:51',NULL,NULL),(41974,27902,'TE','4327411499',0,'2014-03-06 21:00:10',NULL,NULL),(11730,7635,'TE','9376076256',0,'2013-12-26 02:46:23',NULL,NULL),(11560,7523,'TE','9377792517',0,'2013-12-26 02:32:27',NULL,NULL),(10468,6820,'TE','4405764926',0,'2013-12-26 01:30:31',NULL,NULL),(36320,23922,'AP','9016260081',0,'2014-02-14 22:00:06',NULL,NULL),(33208,21745,'EM','bodan5188@yahoo.com',0,'2014-02-06 21:00:18',NULL,NULL),(4932,3165,'AP','5133758602',0,'2013-12-25 20:31:27',NULL,NULL),(30218,19576,'TE','2254392694',0,'2014-01-23 03:02:38',NULL,NULL),(21411,13765,'EM','david_m.edwards@yahoo.com',0,'2013-12-26 13:10:21',NULL,NULL),(25175,16234,'AP','2163742928',0,'2014-01-05 00:02:08',NULL,NULL),(24472,15793,'AP','7155710123',0,'2014-01-03 02:02:35',NULL,NULL),(87,52,'AP','2126410808',0,'2013-12-25 17:16:25',NULL,NULL),(41253,27410,'AP','4403172468',0,'2014-03-04 21:01:35',NULL,NULL),(34741,22781,'TE','3308588762',0,'2014-02-11 21:01:44',NULL,NULL),(31393,20460,'TE','2169041790',0,'2014-01-29 21:00:51',NULL,NULL),(4856,3109,'AP','4197047889',0,'2013-12-25 20:20:29',NULL,NULL),(20597,13250,'TE','8067899086',0,'2013-12-26 12:56:21',NULL,NULL),(27815,17926,'AP','9033883314',0,'2014-01-15 02:06:33',NULL,NULL),(25651,16542,'TE','4404793738',1,'2014-01-07 10:22:24',NULL,NULL),(11765,7656,'EM','wjs611@gmail.com',0,'2013-12-26 03:00:09',NULL,NULL),(40323,26759,'AP','9035177741',0,'2014-03-01 19:00:07',NULL,NULL),(37553,24724,'AP','4405037555',0,'2014-02-20 04:38:37',NULL,NULL),(34490,22627,'AP','3046857757',0,'2014-02-11 21:00:15',NULL,NULL),(4857,3109,'EM','jmangas@metalink.net',0,'2013-12-25 20:20:29',NULL,NULL),(27309,17587,'EM','ktrentc@live.com',0,'2014-01-14 01:32:08',NULL,NULL),(5254,3374,'TE','7025860346',0,'2013-12-25 21:17:20',NULL,NULL),(14462,9447,'EM','Dana.shaw01@yahoo.com',0,'2013-12-26 04:33:52',NULL,NULL),(8665,5690,'AP','5132058684',0,'2013-12-25 23:32:35',NULL,NULL),(40659,26991,'TE','6019512299',0,'2014-03-03 01:00:42',NULL,NULL),(12166,7947,'EM','bigvee007@gmail.com',0,'2013-12-26 03:07:04',NULL,NULL),(9826,6428,'TE','9858019789',0,'2013-12-26 00:49:06',NULL,NULL),(34254,22469,'TE','6628093667',0,'2014-02-10 21:30:57',NULL,NULL),(32307,21100,'AP','5674556043',0,'2014-02-03 21:00:04',NULL,NULL),(20735,13327,'EM','cloudyguero@gmail.com',0,'2013-12-26 12:58:31',NULL,NULL),(23504,15165,'TE','2163987835',0,'2014-01-01 12:06:22',NULL,NULL),(26306,16937,'AP','2252813540',0,'2014-01-13 02:19:52',NULL,NULL),(24448,15783,'AP','9366974963',0,'2014-01-03 02:02:13',NULL,NULL),(7830,5111,'AP','3373157744',0,'2013-12-25 23:01:42',NULL,NULL),(2759,1674,'TE','5135827626',0,'2013-12-25 18:53:57',NULL,NULL),(3105,1938,'TE','3302849180',0,'2013-12-25 19:00:35',NULL,NULL),(40405,26820,'TE','5135213353',0,'2014-03-01 21:00:34',NULL,NULL),(5451,3489,'EM','Makowskis@gmail.com',0,'2013-12-25 21:20:24',NULL,NULL),(35962,23657,'AP','4966821508',0,'2014-02-14 21:30:18',NULL,NULL),(7136,4655,'TE','9857649901',0,'2013-12-25 22:07:14',NULL,NULL),(30354,19667,'TE','9855171724',0,'2014-01-23 21:00:29',NULL,NULL),(28182,18165,'EM','jamielynn627@yahoo.com',0,'2014-01-15 02:07:55',NULL,NULL),(24588,15858,'AP','3309803868',0,'2014-01-03 02:04:41',NULL,NULL),(23286,15003,'EM','sillycowsgomoo@gmail.com',0,'2014-01-01 12:01:48',NULL,NULL),(21540,13848,'TE','4194662309',0,'2013-12-26 13:12:32',NULL,NULL),(43593,28944,'BN','2488628365',0,'2014-03-10 21:00:45',NULL,NULL),(3071,1910,'EM','msschultzesa@gmail.com',0,'2013-12-25 18:59:25',NULL,NULL),(5908,3790,'EM','lake1frasier2@cinci.rr.com',0,'2013-12-25 21:34:13',NULL,NULL),(5152,3303,'TE','3304681458',0,'2013-12-25 21:15:44',NULL,NULL),(24077,15544,'TE','3375791481',1,'2014-01-02 04:31:04',NULL,NULL),(7336,4769,'TE','6144393760',0,'2013-12-25 22:15:46',NULL,NULL),(22759,14676,'TE','6018992421',1,'2013-12-29 11:08:25',NULL,NULL),(22249,14339,'AP','4199577362',0,'2013-12-27 02:07:50',NULL,NULL),(5982,3844,'TE','8043479840',0,'2013-12-25 21:35:27',NULL,NULL),(40175,26644,'TE','3304724647',0,'2014-02-28 21:31:05',NULL,NULL),(4743,3037,'EM','ron_kelps@hotmail.com',0,'2013-12-25 20:18:34',NULL,NULL),(20227,13030,'TE','2162001699',0,'2013-12-26 12:50:19',NULL,NULL),(28706,18523,'TE','8322358948',0,'2014-01-16 08:46:39',NULL,NULL),(6275,4047,'TE','4404667936',0,'2013-12-25 21:46:17',NULL,NULL),(11715,7626,'EM','shawnbeaverson@gmail.com',0,'2013-12-26 02:46:05',NULL,NULL),(37822,24957,'EM','Shamieka2012@hotmail.com',0,'2014-02-20 22:00:16',NULL,NULL),(36590,24085,'EM','rziler@gmail.com',0,'2014-02-15 22:01:24',NULL,NULL),(31671,20662,'AP','9035061841',0,'2014-01-30 21:00:44',NULL,NULL),(6944,4526,'TE','9566472563',0,'2013-12-25 22:03:56',NULL,NULL),(27918,17988,'TE','2347884654',0,'2014-01-15 02:06:56',NULL,NULL),(14927,9768,'TE','5136480867',0,'2013-12-26 05:00:22',NULL,NULL),(24297,15697,'EM','noahdeg1@aol.com',1,'2014-01-02 04:35:37',NULL,NULL),(27111,17439,'AP','4194387621',0,'2014-01-13 03:00:35',NULL,NULL),(13859,9037,'TE','4406221862',0,'2013-12-26 04:05:44',NULL,NULL),(39494,26123,'TE','5132425866',0,'2014-02-28 06:30:20',NULL,NULL),(38837,25670,'EM','notrick750@yahoo.com',0,'2014-02-26 08:30:52',NULL,NULL),(13797,8995,'TE','5135071368',0,'2013-12-26 04:04:41',NULL,NULL),(8391,5521,'TE','6149464985',0,'2013-12-25 23:15:21',NULL,NULL),(30746,19977,'AP','4195624362',0,'2014-01-25 19:00:14',NULL,NULL),(10885,7075,'TE','5713292048',0,'2013-12-26 01:50:09',NULL,NULL),(22482,14497,'TE','4328139724',0,'2013-12-28 03:33:41',NULL,NULL),(23376,15059,'AP','3185506007',0,'2014-01-01 12:03:30',NULL,NULL),(24766,15978,'AP','4322710493',0,'2014-01-04 02:00:50',NULL,NULL),(23665,15281,'EM','smithkathy45@yahoo.com',1,'2014-01-02 04:22:08',NULL,NULL),(23656,15277,'TE','5132370701',1,'2014-01-02 04:21:59',NULL,NULL),(44,28,'EM','kate.hattemer@gmail.com',0,'2013-12-25 17:15:44',NULL,NULL),(11859,7718,'TE','6144249609',0,'2013-12-26 03:01:41',NULL,NULL),(40465,26861,'AP','8174800389',0,'2014-03-01 21:00:56',NULL,NULL),(11426,7434,'EM','rkayp711@aol.com',0,'2013-12-26 02:30:14',NULL,NULL),(10635,6918,'TE','5134780854',0,'2013-12-26 01:46:07',NULL,NULL),(1440,878,'TE','9376992337',0,'2013-12-25 18:07:39',NULL,NULL),(43494,28881,'AP','2817886696',0,'2014-03-10 21:00:09',NULL,NULL),(43838,29095,'EM','k1sinclair@aol.com',0,'2014-03-10 21:02:13',NULL,NULL),(1311,799,'AP','5127990348',0,'2013-12-25 18:05:31',NULL,NULL),(40675,27006,'AP','3306125560',0,'2014-03-03 21:00:05',NULL,NULL),(39865,26373,'EM','efiba6@gmail.com',0,'2014-02-28 07:00:14',NULL,NULL),(39115,25875,'AP','5042749069',0,'2014-02-26 21:00:54',NULL,NULL),(39000,25787,'EM','yangyin1066@yahoo.com',0,'2014-02-26 09:31:07',NULL,NULL),(37485,24682,'AP','9365911036',0,'2014-02-20 04:31:00',NULL,NULL),(37157,24459,'EM','crclap@gmail.com',0,'2014-02-18 22:01:32',NULL,NULL),(36626,24112,'AP','8067780782',0,'2014-02-15 22:01:37',NULL,NULL),(35295,23184,'TE','6014520688',0,'2014-02-12 21:31:59',NULL,NULL),(9542,6247,'TE','5042539570',0,'2013-12-26 00:31:50',NULL,NULL),(2106,1301,'AP','8504509501',0,'2013-12-25 18:31:11',NULL,NULL),(9206,6024,'TE','5122877987',0,'2013-12-26 00:00:57',NULL,NULL),(27030,17381,'EM','nick@step1allstars.com',0,'2014-01-13 03:00:06',NULL,NULL),(6447,4164,'EM','jason@autolivery.com',0,'2013-12-25 21:49:04',NULL,NULL),(4021,2566,'AP','4192046015',0,'2013-12-25 19:37:34',NULL,NULL),(6246,4024,'EM','cbw6781@yahoo.com',0,'2013-12-25 21:45:45',NULL,NULL),(4215,2693,'EM','jenp1@peoplepc.com',0,'2013-12-25 19:47:34',NULL,NULL),(24033,15515,'EM','wisemay69@gmail.com',1,'2014-01-02 04:30:11',NULL,NULL),(36762,24205,'EM','lissettemenendez@yahoo.com',0,'2014-02-16 19:00:20',NULL,NULL),(34723,22768,'TE','3304557515',0,'2014-02-11 21:01:36',NULL,NULL),(27280,17566,'TE','6143892449',0,'2014-01-14 01:31:59',NULL,NULL),(28783,18573,'AP','3303100924',0,'2014-01-16 08:47:05',NULL,NULL),(1211,739,'AP','9155397955',0,'2013-12-25 18:03:59',NULL,NULL),(6029,3870,'EM','rogerlinde@hotmail.com',0,'2013-12-25 21:36:11',NULL,NULL),(13670,8912,'TE','2167515143',0,'2013-12-26 04:02:35',NULL,NULL),(39522,26141,'AP','6143576273',0,'2014-02-28 06:30:26',NULL,NULL),(38005,25072,'TE','4192354101',0,'2014-02-20 22:01:31',NULL,NULL),(37374,24606,'TE','5135041274',0,'2014-02-20 04:13:29',NULL,NULL),(11542,7513,'AP','3185058651',0,'2013-12-26 02:32:09',NULL,NULL),(11328,7378,'AP','4407894635',0,'2013-12-26 02:15:53',NULL,NULL),(14764,9656,'EM','bbgym@netzero.com',0,'2013-12-26 04:38:54',NULL,NULL),(30147,19534,'EM','igotonechild@gmail.com',0,'2014-01-23 03:02:22',NULL,NULL),(28956,18690,'BN','3186259928',0,'2014-01-17 03:35:24',NULL,NULL),(41942,27883,'TE','4192963640',0,'2014-03-05 21:32:34',NULL,NULL),(42448,28195,'TE','3253334582',0,'2014-03-06 21:30:06',NULL,NULL),(1511,930,'AP','6145569262',0,'2013-12-25 18:09:04',NULL,NULL),(30856,20057,'TE','4095430454',0,'2014-01-27 21:00:09',NULL,NULL),(8212,5376,'EM','locke.buras@theautoid.com',0,'2013-12-25 23:08:13',NULL,NULL),(43253,28740,'AP','5044507457',0,'2014-03-09 21:00:09',NULL,NULL),(6928,4513,'EM','bryanwack@gmail.com',0,'2013-12-25 22:03:39',NULL,NULL),(40228,26684,'AP','5043431590',0,'2014-02-28 21:31:25',NULL,NULL),(35131,23072,'EM','sharper53@charter.net',0,'2014-02-12 21:30:58',NULL,NULL),(29281,18912,'AP','9372125513',0,'2014-01-17 03:36:41',NULL,NULL),(9258,6058,'AP','5138843167',0,'2013-12-26 00:01:52',NULL,NULL),(2949,1817,'AP','2162585726',0,'2013-12-25 18:57:09',NULL,NULL),(20681,13297,'AP','8324920995',0,'2013-12-26 12:57:40',NULL,NULL),(10553,6870,'AP','2167026085',0,'2013-12-26 01:31:58',NULL,NULL),(38900,25715,'TE','2545926870',0,'2014-02-26 09:30:25',NULL,NULL),(38550,25472,'EM','jvgrant17@gmail.com',0,'2014-02-25 21:31:38',NULL,NULL),(8298,5436,'EM','RENOTTATAYLOR@GMAIL.COM',0,'2013-12-25 23:09:49',NULL,NULL),(34784,22815,'TE','9372694639',0,'2014-02-11 21:01:59',NULL,NULL),(22357,14419,'TE','8322358299',0,'2013-12-28 03:31:39',NULL,NULL),(32347,21132,'AP','9793130922',0,'2014-02-03 21:00:19',NULL,NULL),(23599,15238,'AP','4199101095',0,'2014-01-01 12:08:31',NULL,NULL),(26221,16878,'TE','9366311285',0,'2014-01-13 02:19:19',NULL,NULL),(5766,3694,'EM','vanettamayeva@yahoo.com',0,'2013-12-25 21:31:48',NULL,NULL),(40367,26793,'TE','4197488810',0,'2014-03-01 21:00:20',NULL,NULL),(12041,7852,'EM','gulfinron@aol.com',0,'2013-12-26 03:04:53',NULL,NULL),(39405,26056,'TE','4199215158',0,'2014-02-26 21:02:36',NULL,NULL),(11695,7613,'EM','lfanaselle21@gmail.com',0,'2013-12-26 02:45:43',NULL,NULL),(41566,27638,'AP','5133827670',0,'2014-03-05 21:30:14',NULL,NULL),(33681,22092,'AP','6018429145',0,'2014-02-08 19:00:25',NULL,NULL),(29660,19162,'TE','4195591520',0,'2014-01-21 08:45:42',NULL,NULL),(5564,3554,'EM','1calaurianti@windstream.net',0,'2013-12-25 21:22:08',NULL,NULL),(26064,16788,'TE','5133311737',0,'2014-01-08 18:25:08',NULL,NULL),(8857,5804,'AP','9797337763',0,'2013-12-25 23:47:35',NULL,NULL),(3661,2325,'TE','3256983055',0,'2013-12-25 19:31:30',NULL,NULL),(25133,16202,'AP','2545419809',0,'2014-01-05 00:01:10',NULL,NULL),(8032,5253,'EM','rthomas@neo.rr.com',0,'2013-12-25 23:05:12',NULL,NULL),(24184,15623,'AP','6016134736',1,'2014-01-02 04:33:15',NULL,NULL),(7947,5186,'TE','5132362968',0,'2013-12-25 23:03:38',NULL,NULL),(1346,822,'TE','3308823707',0,'2013-12-25 18:06:07',NULL,NULL),(14953,9782,'EM','gmgilbert68@gmail.com',0,'2013-12-26 05:00:46',NULL,NULL),(23192,14945,'EM','soundminded@gmail.com',0,'2013-12-30 00:02:28',NULL,NULL),(23888,15413,'AP','2108236250',1,'2014-01-02 04:27:11',NULL,NULL),(27673,17837,'BN','7405059694',0,'2014-01-15 02:06:02',NULL,NULL),(43591,28944,'TE','2488628365',0,'2014-03-10 21:00:45',NULL,NULL),(13580,8854,'EM','donmenfis@gmail.com',0,'2013-12-26 04:01:07',NULL,NULL),(11597,7544,'AP','5124222338',0,'2013-12-26 02:33:01',NULL,NULL),(36261,23863,'AP','5043432660',0,'2014-02-14 21:32:06',NULL,NULL),(33148,21711,'AP','9377255185',0,'2014-02-05 21:31:15',NULL,NULL),(5651,3627,'EM','jbstrick@nktelco.net',0,'2013-12-25 21:23:49',NULL,NULL),(23487,15146,'EM','luci5678@aol.com',0,'2014-01-01 12:05:55',NULL,NULL),(22291,14366,'AP','2166440814',0,'2013-12-28 03:30:25',NULL,NULL),(42374,28141,'AP','4195099554',0,'2014-03-06 21:02:31',NULL,NULL),(7531,4908,'EM','hrnetter423@yahoo.com',0,'2013-12-25 22:32:00',NULL,NULL),(10181,6653,'TE','5137749628',0,'2013-12-26 01:00:38',NULL,NULL),(5895,3780,'AP','5132355214',0,'2013-12-25 21:33:59',NULL,NULL),(35238,23142,'TE','3307339082',0,'2014-02-12 21:31:37',NULL,NULL),(34311,22512,'AP','9562925536',0,'2014-02-10 21:31:20',NULL,NULL),(33924,22265,'AP','9152587859',0,'2014-02-10 11:00:10',NULL,NULL),(7863,5129,'EM','aidan@earthsta.com',0,'2013-12-25 23:02:11',NULL,NULL),(30250,19594,'TE','2166871413',0,'2014-01-23 03:02:46',NULL,NULL),(30120,19510,'EM','bbates1977@yahoo.com',0,'2014-01-23 03:02:14',NULL,NULL),(20555,13229,'TE','8176791737',0,'2013-12-26 12:55:43',NULL,NULL),(24687,15920,'EM','jerald.dawson@gmail.com',0,'2014-01-03 02:06:39',NULL,NULL),(24669,15907,'TE','9375151810',0,'2014-01-03 02:06:16',NULL,NULL),(22649,14604,'TE','9738647634',0,'2013-12-28 03:36:29',NULL,NULL),(55,37,'TE','7406015550',0,'2013-12-25 17:15:57',NULL,NULL),(41561,27634,'TE','9372707599',0,'2014-03-05 21:30:12',NULL,NULL),(11710,7624,'TE','4194236737',0,'2013-12-26 02:46:01',NULL,NULL),(24830,16015,'EM','pauladavis50@yahoo.com',0,'2014-01-04 02:01:59',NULL,NULL),(27119,17457,'EM','gdeidrick@netzero.net',0,'2014-01-13 03:00:40',NULL,NULL),(27245,17542,'TE','4192282006',0,'2014-01-13 03:01:49',NULL,NULL),(43093,28645,'EM','FONDA_CHURCH@YAHOO.COM',0,'2014-03-08 21:30:35',NULL,NULL),(7220,4703,'TE','4194601532',0,'2013-12-25 22:08:30',NULL,NULL),(41930,27876,'AP','4197837157',0,'2014-03-05 21:32:29',NULL,NULL),(41572,27640,'EM','VIE_ADAMS@YAHOO.COM',0,'2014-03-05 21:30:16',NULL,NULL),(39771,26299,'AP','9376054533',0,'2014-02-28 06:31:28',NULL,NULL),(9950,6511,'TE','3308779276',0,'2013-12-26 00:51:08',NULL,NULL),(21534,13845,'AP','3304594649',0,'2013-12-26 13:12:26',NULL,NULL),(26240,16887,'AP','3617423746',0,'2014-01-13 02:19:25',NULL,NULL),(34033,22318,'AP','9854457561',0,'2014-02-10 11:00:52',NULL,NULL),(31761,20728,'TE','3306283281',0,'2014-01-30 21:01:18',NULL,NULL),(1090,671,'AP','9375649179',0,'2013-12-25 18:02:08',NULL,NULL),(10843,7039,'AP','2813810318',0,'2013-12-26 01:49:22',NULL,NULL),(12043,7856,'AP','9379742355',0,'2013-12-26 03:04:57',NULL,NULL),(10194,6661,'EM','johngazzaway@att.net',0,'2013-12-26 01:00:53',NULL,NULL),(36806,24234,'TE','9372882825',0,'2014-02-16 19:00:36',NULL,NULL),(6204,3996,'AP','9373679726',0,'2013-12-25 21:45:04',NULL,NULL),(4425,2821,'TE','2166514150',0,'2013-12-25 20:00:30',NULL,NULL),(4469,2846,'AP','8307199040',0,'2013-12-25 20:01:13',NULL,NULL),(21058,13544,'AP','3184032956',0,'2013-12-26 13:03:53',NULL,NULL),(10875,7060,'TE','6149755942',0,'2013-12-26 01:49:55',NULL,NULL),(41715,27738,'AP','9039180672',0,'2014-03-05 21:31:08',NULL,NULL),(30302,19630,'TE','6148483828',0,'2014-01-23 21:00:09',NULL,NULL),(41078,27287,'AP','8327257915',0,'2014-03-04 21:00:26',NULL,NULL),(30662,19905,'TE','6146336516',0,'2014-01-24 21:00:57',NULL,NULL),(37726,24877,'AP','5133440399',0,'2014-02-20 05:35:10',NULL,NULL),(545,340,'TE','5136617894',0,'2013-12-25 17:31:57',NULL,NULL),(42195,28028,'TE','4409518548',0,'2014-03-06 21:01:26',NULL,NULL),(37164,24462,'AP','3252459811',0,'2014-02-18 22:01:34',NULL,NULL),(20579,13241,'AP','8328656005',0,'2013-12-26 12:56:05',NULL,NULL),(5816,3734,'TE','8064742480',0,'2013-12-25 21:32:42',NULL,NULL),(1625,998,'AP','8326557956',0,'2013-12-25 18:10:51',NULL,NULL),(21939,14133,'TE','3375784639',0,'2013-12-27 02:02:27',NULL,NULL),(20921,13452,'AP','9374744557',0,'2013-12-26 13:01:33',NULL,NULL),(10551,6869,'AP','9405671526',0,'2013-12-26 01:31:56',NULL,NULL),(11721,7630,'AP','5139399386',0,'2013-12-26 02:46:13',NULL,NULL),(11010,7147,'AP','4099399852',0,'2013-12-26 01:52:06',NULL,NULL),(3854,2454,'TE','2103385407',0,'2013-12-25 19:34:44',NULL,NULL),(14083,9208,'TE','6012089655',0,'2013-12-26 04:09:51',NULL,NULL),(39246,25963,'TE','3308631538',0,'2014-02-26 21:01:42',NULL,NULL),(12304,8047,'TE','4194663079',0,'2013-12-26 03:09:34',NULL,NULL),(24749,15970,'TE','9155662713',0,'2014-01-04 02:00:34',NULL,NULL),(30076,19481,'EM','Sportluv@swbell.net',0,'2014-01-23 03:02:03',NULL,NULL),(34394,22562,'TE','5134393335',0,'2014-02-10 21:31:52',NULL,NULL),(30525,19800,'TE','9157313150',0,'2014-01-24 21:00:04',NULL,NULL),(20222,13026,'TE','4192673303',0,'2013-12-26 12:50:14',NULL,NULL),(13763,8970,'TE','8122491521',0,'2013-12-26 04:04:05',NULL,NULL),(37496,24690,'TE','9567401351',0,'2014-02-20 04:32:23',NULL,NULL),(7619,4964,'AP','5042593968',0,'2013-12-25 22:46:14',NULL,NULL),(32790,21454,'TE','3302459905',0,'2014-02-04 21:01:30',NULL,NULL),(6236,4018,'AP','5672041369',0,'2013-12-25 21:45:36',NULL,NULL),(26227,16880,'EM','serenamiller68@yahoo.com',0,'2014-01-13 02:19:21',NULL,NULL),(24089,15551,'TE','2253948589',1,'2014-01-02 04:31:17',NULL,NULL),(36628,24113,'AP','8067780782',0,'2014-02-15 22:01:38',NULL,NULL),(2900,1780,'TE','4193412181',0,'2013-12-25 18:56:18',NULL,NULL),(14445,9438,'AP','5134102342',0,'2013-12-26 04:33:36',NULL,NULL),(42928,28545,'TE','3304835976',0,'2014-03-07 21:32:17',NULL,NULL),(24976,16095,'EM','JASON_HUTCHINSON66@YAHOO.COM',0,'2014-01-04 02:04:36',NULL,NULL),(27578,17774,'TE','4093653833',0,'2014-01-14 01:33:40',NULL,NULL),(36005,23684,'EM','caenglou@aol.com',0,'2014-02-14 21:30:33',NULL,NULL),(35977,23671,'TE','5042965524',0,'2014-02-14 21:30:24',NULL,NULL),(27622,17807,'TE','5205593630',0,'2014-01-15 02:05:51',NULL,NULL),(32256,21069,'TE','4409541397',0,'2014-02-02 19:00:16',NULL,NULL),(12008,7823,'TE','2148616773',0,'2013-12-26 03:04:15',NULL,NULL),(4382,2794,'TE','7725294736',0,'2013-12-25 19:50:13',NULL,NULL),(38807,25657,'EM','Jsgirl3@yahoo.com',0,'2014-02-26 08:30:42',NULL,NULL),(35879,23593,'EM','mannioncr58@gmail.com',0,'2014-02-13 22:03:04',NULL,NULL),(35121,23068,'EM','j.erin.sheppard@gmail.com',0,'2014-02-12 21:30:55',NULL,NULL),(10985,7136,'AP','2148930152',0,'2013-12-26 01:51:47',NULL,NULL),(34025,22315,'TE','5049408074',0,'2014-02-10 11:00:49',NULL,NULL),(24226,15652,'TE','9018484750',1,'2014-01-02 04:34:09',NULL,NULL),(28945,18686,'TE','5045631875',0,'2014-01-17 03:35:22',NULL,NULL),(716,445,'TE','9375246777',0,'2013-12-25 17:47:16',NULL,NULL),(43304,28769,'TE','6146190390',0,'2014-03-09 21:00:28',NULL,NULL),(7764,5068,'TE','8304692403',0,'2013-12-25 23:00:38',NULL,NULL),(39805,26324,'TE','6629028977',0,'2014-02-28 06:31:37',NULL,NULL),(39651,26219,'EM','ccapellan@aol.com',0,'2014-02-28 06:30:56',NULL,NULL),(38306,25294,'TE','5137424494',0,'2014-02-25 21:00:25',NULL,NULL),(38167,25190,'EM','demitrax@gmail.com',0,'2014-02-21 22:00:39',NULL,NULL),(6104,3929,'AP','4197223089',0,'2013-12-25 21:37:35',NULL,NULL),(21353,13720,'EM','kustom442@yahoo.com',0,'2013-12-26 13:09:13',NULL,NULL),(7576,4931,'TE','5133853660',0,'2013-12-25 22:45:26',NULL,NULL),(42392,28157,'TE','4194093947',0,'2014-03-06 21:02:39',NULL,NULL),(2666,1617,'EM','nrubyarp@gmail.com',0,'2013-12-25 18:52:30',NULL,NULL),(10480,6829,'TE','7402522875',0,'2013-12-26 01:30:43',NULL,NULL),(11986,7809,'TE','9792408827',0,'2013-12-26 03:03:54',NULL,NULL),(37370,24597,'EM','laksmith1@aol.com',0,'2014-02-20 04:12:35',NULL,NULL),(30589,19845,'EM','leitch_gary@outlook.com',0,'2014-01-24 21:00:28',NULL,NULL),(27051,17397,'TE','4197492722',0,'2014-01-13 03:00:14',NULL,NULL),(43981,29176,'EM','DSNEED2000@GMAIL.COM',0,'2014-03-10 21:03:02',NULL,NULL),(8572,5636,'AP','9404441649',0,'2013-12-25 23:31:06',NULL,NULL),(1667,1024,'TE','3306444133',0,'2013-12-25 18:15:20',NULL,NULL),(40213,26672,'AP','9857785900',0,'2014-02-28 21:31:19',NULL,NULL),(2339,1424,'AP','5044736409',0,'2013-12-25 18:47:21',NULL,NULL),(3096,1932,'AP','9794798080',0,'2013-12-25 19:00:26',NULL,NULL),(38776,25635,'TE','5042286782',0,'2014-02-26 08:30:27',NULL,NULL),(38319,25316,'TE','5046216990',0,'2014-02-25 21:30:05',NULL,NULL),(5047,3239,'TE','7136730103',0,'2013-12-25 20:46:16',NULL,NULL),(34387,22556,'AP','4402416892',0,'2014-02-10 21:31:48',NULL,NULL),(22150,14267,'TE','5139471947',0,'2013-12-27 02:05:59',NULL,NULL),(28275,18231,'EM','donlucius77@gmail.com',0,'2014-01-16 08:44:19',NULL,NULL),(43900,29126,'EM','jonnybordner@gmail.com',0,'2014-03-10 21:02:34',NULL,NULL),(20940,13467,'AP','5136738981',0,'2013-12-26 13:01:56',NULL,NULL),(14223,9305,'AP','3375755765',0,'2013-12-26 04:30:07',NULL,NULL),(41714,27738,'TE','9039180672',0,'2014-03-05 21:31:08',NULL,NULL),(40986,27232,'AP','4407155019',0,'2014-03-03 21:31:42',NULL,NULL),(39974,26465,'BN','3302892620',0,'2014-02-28 07:30:34',NULL,NULL),(39597,26195,'AP','5136932490',0,'2014-02-28 06:30:46',NULL,NULL),(6370,4103,'EM','autry.williams@yahoo.com',0,'2013-12-25 21:47:48',NULL,NULL),(12067,7878,'TE','5136084001',0,'2013-12-26 03:05:21',NULL,NULL),(10677,6936,'EM','beth_btotman@yahoo.com',0,'2013-12-26 01:46:41',NULL,NULL),(9592,6278,'AP','5138506072',0,'2013-12-26 00:45:19',NULL,NULL),(1172,720,'AP','8173717538',0,'2013-12-25 18:03:26',NULL,NULL),(14634,9570,'AP','5805149160',0,'2013-12-26 04:36:43',NULL,NULL),(40954,27214,'TE','6018136265',0,'2014-03-03 21:31:30',NULL,NULL),(22101,14234,'AP','7737106760',0,'2013-12-27 02:05:06',NULL,NULL),(40066,26565,'TE','4192023136',0,'2014-02-28 21:30:23',NULL,NULL),(32634,21344,'TE','8066625784',0,'2014-02-04 21:00:34',NULL,NULL),(41967,27897,'EM','croppersonja@gmail.com',0,'2014-03-05 21:32:43',NULL,NULL),(5370,3438,'TE','2254853432',0,'2013-12-25 21:19:09',NULL,NULL),(38480,25430,'TE','8177167358',0,'2014-02-25 21:31:14',NULL,NULL),(33576,22013,'TE','6143385772',0,'2014-02-07 19:00:53',NULL,NULL),(7391,4808,'TE','2163853034',0,'2013-12-25 22:16:44',NULL,NULL),(30180,19553,'TE','3378849900',0,'2014-01-23 03:02:30',NULL,NULL),(25599,16514,'TE','9158611787',1,'2014-01-07 10:21:28',NULL,NULL),(23848,15386,'AP','4195649490',1,'2014-01-02 04:25:36',NULL,NULL),(22735,14662,'AP','2147979494',1,'2013-12-29 11:08:01',NULL,NULL),(43581,28939,'AP','4192768197',0,'2014-03-10 21:00:42',NULL,NULL),(8029,5252,'TE','3306783132',0,'2013-12-25 23:05:10',NULL,NULL),(41333,27457,'TE','3302173649',0,'2014-03-04 21:02:03',NULL,NULL),(40912,27186,'AP','9569904786',0,'2014-03-03 21:31:13',NULL,NULL),(14344,9376,'AP','5049753177',0,'2013-12-26 04:31:58',NULL,NULL),(25669,16549,'AP','2252005058',1,'2014-01-07 10:22:40',NULL,NULL),(27131,17467,'AP','4407231301',0,'2014-01-13 03:01:06',NULL,NULL),(6055,3889,'EM','pkh3878@att.net',0,'2013-12-25 21:36:39',NULL,NULL),(40157,26634,'TE','8179954871',0,'2014-02-28 21:30:59',NULL,NULL),(38117,25159,'AP','9562626622',0,'2014-02-21 22:00:21',NULL,NULL),(37804,24949,'TE','5044584860',0,'2014-02-20 22:00:10',NULL,NULL),(36781,24217,'TE','5126806048',0,'2014-02-16 19:00:27',NULL,NULL),(29233,18880,'EM','michealeastin1960@gmail.com',0,'2014-01-17 03:36:28',NULL,NULL),(11869,7726,'EM','debbudqueen@gmail.com',0,'2013-12-26 03:01:53',NULL,NULL),(26720,17186,'AP','5128766936',0,'2014-01-13 02:22:16',NULL,NULL),(26442,17016,'AP','3309587662',0,'2014-01-13 02:20:38',NULL,NULL),(21625,13917,'EM','kathymasters@bex.net',0,'2013-12-26 13:14:08',NULL,NULL),(923,569,'AP','5134906903',0,'2013-12-25 17:50:34',NULL,NULL),(9168,6002,'TE','3379401244',0,'2013-12-26 00:00:23',NULL,NULL),(1668,1024,'EM','Flippedballerina@aol.com',0,'2013-12-25 18:15:20',NULL,NULL),(2579,1573,'AP','9366618729',0,'2013-12-25 18:51:15',NULL,NULL),(2704,1643,'AP','9034311562',0,'2013-12-25 18:53:09',NULL,NULL),(27788,17912,'EM','aimeedesilet@yahoo.com',0,'2014-01-15 02:06:27',NULL,NULL),(32741,21420,'TE','4194786009',0,'2014-02-04 21:01:13',NULL,NULL),(31748,20720,'TE','9377799008',0,'2014-01-30 21:01:14',NULL,NULL),(11548,7515,'AP','3372448619',0,'2013-12-26 02:32:14',NULL,NULL),(10775,7003,'EM','vaughnmarie@ymail.com',0,'2013-12-26 01:48:21',NULL,NULL),(9838,6435,'EM','fcasby@cox.net',0,'2013-12-26 00:49:17',NULL,NULL),(33822,22207,'EM','jgtuck.jt@gmail.com',0,'2014-02-09 19:00:18',NULL,NULL),(22573,14556,'TE','3308829460',0,'2013-12-28 03:35:10',NULL,NULL),(27577,17772,'EM','drzayas@live.com',0,'2014-01-14 01:33:39',NULL,NULL),(27439,17675,'AP','9853974708',0,'2014-01-14 01:32:51',NULL,NULL),(42317,28101,'AP','3307302794',0,'2014-03-06 21:02:10',NULL,NULL),(1097,673,'EM','shp678@yahoo.com',0,'2013-12-25 18:02:12',NULL,NULL),(11206,7286,'TE','3303263220',0,'2013-12-26 02:02:49',NULL,NULL),(6768,4391,'EM','cndgroovy@hotmail.com',0,'2013-12-25 22:00:54',NULL,NULL),(38089,25142,'EM','tejanomanjohn@aol.com',0,'2014-02-21 22:00:11',NULL,NULL),(25956,16720,'AP','9568443975',0,'2014-01-08 18:24:46',NULL,NULL),(30213,19574,'TE','3182100238',0,'2014-01-23 03:02:37',NULL,NULL),(154,92,'EM','FREDDIE.OBREGON@YAHOO.COM',0,'2013-12-25 17:17:28',NULL,NULL),(11088,7203,'EM','angelamarlette@yahoo.com',0,'2013-12-26 02:00:42',NULL,NULL),(22118,14248,'EM','richardt-events@usa.net',0,'2013-12-27 02:05:26',NULL,NULL),(28028,18064,'TE','5132545871',0,'2014-01-15 02:07:21',NULL,NULL),(29113,18802,'TE','3304834892',0,'2014-01-17 03:36:00',NULL,NULL),(306,189,'TE','3309237716',0,'2013-12-25 17:19:54',NULL,NULL),(6875,4459,'AP','5132595194',0,'2013-12-25 22:02:36',NULL,NULL),(1368,834,'TE','7404580236',0,'2013-12-25 18:06:26',NULL,NULL),(34354,22535,'AP','6018621303',0,'2014-02-10 21:31:35',NULL,NULL),(33232,21760,'EM','tiffanylane007@yahoo.com',0,'2014-02-06 21:00:26',NULL,NULL),(10591,6892,'AP','2259216449',0,'2013-12-26 01:45:24',NULL,NULL),(26359,16964,'EM','youngadlai@yahoo.com',0,'2014-01-13 02:20:10',NULL,NULL),(9734,6369,'AP','5132355214',0,'2013-12-26 00:47:36',NULL,NULL),(20496,13197,'TE','9792455168',0,'2013-12-26 12:54:50',NULL,NULL),(14880,9739,'TE','8176818664',0,'2013-12-26 04:45:52',NULL,NULL),(13840,9023,'EM','mrkinzel1@aol.com',0,'2013-12-26 04:05:23',NULL,NULL),(1480,906,'AP','5133561220',0,'2013-12-25 18:08:25',NULL,NULL),(5308,3402,'EM','quietstormjazz63@yahoo.com',0,'2013-12-25 21:18:09',NULL,NULL),(8550,5618,'TE','5137034560',0,'2013-12-25 23:30:42',NULL,NULL),(8625,5666,'TE','3309201515',0,'2013-12-25 23:31:55',NULL,NULL),(9110,5971,'TE','6624470215',0,'2013-12-25 23:51:37',NULL,NULL),(4192,2682,'AP','5136046777',0,'2013-12-25 19:47:14',NULL,NULL),(14749,9646,'EM','MARVEMAWOLF@YAHOO.COM',0,'2013-12-26 04:38:38',NULL,NULL),(40280,26718,'AP','7692334050',0,'2014-02-28 21:31:43',NULL,NULL),(35470,23328,'TE','5133024955',0,'2014-02-13 22:00:28',NULL,NULL),(22298,14372,'TE','5137040843',0,'2013-12-28 03:30:34',NULL,NULL),(22470,14489,'TE','9722230274',0,'2013-12-28 03:33:29',NULL,NULL),(834,517,'EM','joeott54@gmail.com',0,'2013-12-25 17:49:07',NULL,NULL),(10074,6585,'EM','missy@cdpsinc.com',0,'2013-12-26 00:53:06',NULL,NULL),(33517,21970,'EM','htn89@yahoo.com',0,'2014-02-07 19:00:30',NULL,NULL),(3396,2135,'TE','2342179008',0,'2013-12-25 19:18:05',NULL,NULL),(25750,16594,'EM','trananhquoc1917@yahoo.com',0,'2014-01-08 18:24:02',NULL,NULL),(24362,15731,'EM','sommerskytime@live.com',0,'2014-01-03 02:00:32',NULL,NULL),(42219,28048,'TE','6018135832',0,'2014-03-06 21:01:35',NULL,NULL),(40008,26504,'AP','5132768121',0,'2014-02-28 21:00:16',NULL,NULL),(12240,8004,'TE','9563308066',0,'2013-12-26 03:08:27',NULL,NULL),(10966,7126,'TE','6015598296',0,'2013-12-26 01:51:29',NULL,NULL),(4764,3051,'TE','3376551763',0,'2013-12-25 20:18:54',NULL,NULL),(4277,2733,'AP','5044301317',0,'2013-12-25 19:48:33',NULL,NULL),(4675,2990,'TE','5136526760',0,'2013-12-25 20:17:25',NULL,NULL),(31383,20455,'EM','libby@wordplaycincy.org',0,'2014-01-29 21:00:48',NULL,NULL),(28467,18343,'TE','6149359027',0,'2014-01-16 08:45:18',NULL,NULL),(25968,16726,'TE','3302618463',0,'2014-01-08 18:24:48',NULL,NULL),(14520,9487,'AP','5132353167',0,'2013-12-26 04:34:49',NULL,NULL),(24244,15663,'TE','8183193054',1,'2014-01-02 04:34:31',NULL,NULL),(7353,4780,'TE','6627197468',0,'2013-12-25 22:16:06',NULL,NULL),(42343,28119,'EM','rowland.tyler@gmail.com',0,'2014-03-06 21:02:19',NULL,NULL),(5659,3633,'TE','6014343560',0,'2013-12-25 21:30:12',NULL,NULL),(35647,23438,'EM','hyeon68@aol.com',0,'2014-02-13 22:01:31',NULL,NULL),(29458,19046,'TE','4194725604',0,'2014-01-20 08:06:41',NULL,NULL),(14268,9334,'TE','5136158633',0,'2013-12-26 04:30:49',NULL,NULL),(26107,16812,'TE','9562159876',0,'2014-01-13 02:18:17',NULL,NULL),(25495,16439,'TE','3308586636',0,'2014-01-07 04:05:03',NULL,NULL),(25361,16353,'EM','nbader29@yahoo.com',0,'2014-01-07 04:02:35',NULL,NULL),(23972,15471,'AP','3302681707',1,'2014-01-02 04:28:56',NULL,NULL),(20578,13241,'TE','7136650561',0,'2013-12-26 12:56:05',NULL,NULL),(22153,14270,'EM','sabrinadoukas@yahoo.com',0,'2013-12-27 02:06:03',NULL,NULL),(6075,3911,'TE','8328659160',0,'2013-12-25 21:37:06',NULL,NULL),(41641,27681,'AP','9565922096',0,'2014-03-05 21:30:38',NULL,NULL),(39801,26319,'TE','9376314981',0,'2014-02-28 06:31:36',NULL,NULL),(39665,26227,'BN','6823518882',0,'2014-02-28 06:31:00',NULL,NULL),(31976,20878,'AP','7134087858',0,'2014-01-31 21:01:07',NULL,NULL),(1827,1130,'EM','RAYGARCIA64@GMAIL.COM',0,'2013-12-25 18:18:03',NULL,NULL),(29589,19119,'TE','9853512608',0,'2014-01-21 08:45:16',NULL,NULL),(26104,16811,'TE','3258293258',0,'2014-01-13 02:18:16',NULL,NULL),(2121,1309,'TE','2254055865',0,'2013-12-25 18:31:24',NULL,NULL),(2454,1507,'AP','5136489913',0,'2013-12-25 18:49:24',NULL,NULL),(7883,5138,'TE','7027431407',0,'2013-12-25 23:02:27',NULL,NULL),(20425,13154,'TE','6149295776',0,'2013-12-26 12:53:40',NULL,NULL),(1117,684,'EM','tlguest10@yahoo.com',0,'2013-12-25 18:02:29',NULL,NULL),(2785,1687,'TE','5045089916',0,'2013-12-25 18:54:20',NULL,NULL),(2791,1690,'TE','5042599106',0,'2013-12-25 18:54:26',NULL,NULL),(6556,4235,'EM','gloriagrodriguez@gmail.com',0,'2013-12-25 21:50:51',NULL,NULL),(26324,16947,'AP','6016690141',0,'2014-01-13 02:19:58',NULL,NULL),(26159,16843,'EM','embardes@gmail.com',0,'2014-01-13 02:18:35',NULL,NULL),(26074,16794,'TE','2142930739',0,'2014-01-13 02:18:08',NULL,NULL),(8882,5819,'EM','Megtaylor04@gmail.com',0,'2013-12-25 23:47:57',NULL,NULL),(3782,2398,'EM','tsearfos@sbcglobal.net',0,'2013-12-25 19:33:29',NULL,NULL),(21646,13932,'TE','4194722218',0,'2013-12-26 13:14:31',NULL,NULL),(1092,672,'TE','5132586570',0,'2013-12-25 18:02:09',NULL,NULL),(6523,4218,'EM','mrsjanerios@aol.com',0,'2013-12-25 21:50:21',NULL,NULL),(13574,8850,'EM','chap202@gmail.com',0,'2013-12-26 04:01:00',NULL,NULL),(37759,24916,'AP','3306082423',0,'2014-02-20 21:30:11',NULL,NULL),(9506,6221,'AP','5135199270',0,'2013-12-26 00:31:10',NULL,NULL),(8277,5420,'EM','Jtm133@icloud.com',0,'2013-12-25 23:09:23',NULL,NULL),(14844,9714,'EM','smm@0d7.com',0,'2013-12-26 04:45:18',NULL,NULL),(22033,14187,'EM','2beachnutz@yahoo.com',0,'2013-12-27 02:03:55',NULL,NULL),(30935,20117,'AP','4192973734',0,'2014-01-27 21:00:44',NULL,NULL),(27727,17872,'TE','9375523111',0,'2014-01-15 02:06:14',NULL,NULL),(1863,1150,'AP','2253159278',0,'2013-12-25 18:18:36',NULL,NULL),(13547,8835,'AP','9365560740',0,'2013-12-26 04:00:36',NULL,NULL),(14954,9783,'TE','7403141604',0,'2013-12-26 05:00:48',NULL,NULL),(28279,18233,'TE','5129225154',0,'2014-01-16 08:44:20',NULL,NULL),(21806,14051,'TE','5133867370',0,'2013-12-27 02:00:17',NULL,NULL),(11349,7394,'TE','3307803939',0,'2013-12-26 02:16:15',NULL,NULL),(41719,27741,'TE','3615429278',0,'2014-03-05 21:31:09',NULL,NULL),(39329,26012,'EM','jendmil@hotmail.com',0,'2014-02-26 21:02:11',NULL,NULL),(27505,17718,'AP','3303281753',0,'2014-01-14 01:33:13',NULL,NULL),(35467,23326,'EM','HALAKZ@AOL.COM',0,'2014-02-13 22:00:27',NULL,NULL),(43998,29192,'TE','5043432299',0,'2014-03-10 21:30:06',NULL,NULL),(7488,4873,'TE','5125208954',0,'2013-12-25 22:31:04',NULL,NULL),(5232,3363,'TE','5127879347',0,'2013-12-25 21:17:02',NULL,NULL),(36232,23845,'AP','4196015347',0,'2014-02-14 21:31:55',NULL,NULL),(36171,23805,'AP','3305739514',0,'2014-02-14 21:31:32',NULL,NULL),(32698,21391,'TE','4194083343',0,'2014-02-04 21:00:57',NULL,NULL),(32423,21184,'EM','SHENIKALOFTON46@GMAIL.COM',0,'2014-02-03 21:00:45',NULL,NULL),(11479,7466,'TE','9723337216',0,'2013-12-26 02:31:03',NULL,NULL),(30140,19531,'TE','6146324487',0,'2014-01-23 03:02:20',NULL,NULL),(9829,6431,'TE','3372502348',0,'2013-12-26 00:49:10',NULL,NULL),(24546,15831,'TE','5132802855',0,'2014-01-03 02:03:52',NULL,NULL),(24633,15885,'TE','3375505086',0,'2014-01-03 02:05:31',NULL,NULL),(43610,28952,'TE','9852652474',0,'2014-03-10 21:00:51',NULL,NULL),(44009,29206,'TE','4194903708',0,'2014-03-10 21:30:13',NULL,NULL),(12356,8089,'TE','4193084532',0,'2013-12-26 03:10:38',NULL,NULL),(40237,26690,'AP','5049121440',0,'2014-02-28 21:31:28',NULL,NULL),(6658,4321,'AP','5134172220',0,'2013-12-25 21:52:46',NULL,NULL),(2100,1298,'TE','9082406949',0,'2013-12-25 18:31:04',NULL,NULL),(9389,6144,'EM','jenniferroberts@horizonview.net',0,'2013-12-26 00:16:22',NULL,NULL),(33059,21655,'TE','2252509281',0,'2014-02-05 21:30:52',NULL,NULL),(8629,5668,'TE','3309575181',0,'2013-12-25 23:31:58',NULL,NULL),(28920,18673,'TE','8635348529',0,'2014-01-17 03:35:17',NULL,NULL),(10470,6821,'AP','9018645171',0,'2013-12-26 01:30:33',NULL,NULL),(10200,6664,'TE','2547158096',0,'2013-12-26 01:00:57',NULL,NULL),(4911,3154,'TE','5132543646',0,'2013-12-25 20:31:07',NULL,NULL),(20623,13268,'AP','9564665468',0,'2013-12-26 12:56:49',NULL,NULL),(35160,23094,'TE','5136756931',0,'2014-02-12 21:31:08',NULL,NULL),(24738,15960,'EM','skrenz@msn.com',0,'2014-01-04 02:00:20',NULL,NULL),(24847,16027,'TE','3184439487',0,'2014-01-04 02:02:20',NULL,NULL),(33569,22010,'AP','7403575597',0,'2014-02-07 19:00:51',NULL,NULL),(26461,17033,'TE','9858597867',0,'2014-01-13 02:20:46',NULL,NULL),(29906,19354,'TE','3302647841',1,'2014-01-22 03:22:27',NULL,NULL),(11655,7586,'EM','gblair7@gmail.com',0,'2013-12-26 02:34:05',NULL,NULL),(35462,23323,'TE','4198132028',0,'2014-02-13 22:00:25',NULL,NULL),(33374,21868,'AP','7348127906',0,'2014-02-06 21:01:24',NULL,NULL),(3564,2231,'TE','5133835100',0,'2013-12-25 19:20:48',NULL,NULL),(14851,9719,'TE','4128679950',0,'2013-12-26 04:45:24',NULL,NULL),(23209,14955,'AP','8503217338',0,'2014-01-01 12:00:21',NULL,NULL),(27177,17500,'TE','3186492771',0,'2014-01-13 03:01:24',NULL,NULL),(14700,9619,'AP','4199663314',0,'2013-12-26 04:37:52',NULL,NULL),(40563,26925,'TE','9377236768',0,'2014-03-03 01:00:17',NULL,NULL),(37127,24441,'EM','rita@mielkelaw.com',0,'2014-02-18 22:01:19',NULL,NULL),(2586,1578,'TE','9567235630',0,'2013-12-25 18:51:22',NULL,NULL),(34976,22963,'AP','6143525610',0,'2014-02-12 21:00:11',NULL,NULL),(14095,9216,'TE','5137042581',0,'2013-12-26 04:10:03',NULL,NULL),(26787,17233,'TE','6627191519',0,'2014-01-13 02:22:41',NULL,NULL),(25900,16693,'TE','9155417097',0,'2014-01-08 18:24:36',NULL,NULL),(13674,8913,'AP','7404044725',0,'2013-12-26 04:02:38',NULL,NULL),(23282,15002,'TE','2818654438',0,'2014-01-01 12:01:45',NULL,NULL),(20564,13234,'EM','leonarscott@yahoo.com',0,'2013-12-26 12:55:52',NULL,NULL),(3196,2008,'TE','5043735353',0,'2013-12-25 19:02:25',NULL,NULL),(5852,3755,'TE','4402241547',0,'2013-12-25 21:33:17',NULL,NULL),(9995,6540,'EM','scottmleavell@gmail.com',0,'2013-12-26 00:51:54',NULL,NULL),(4967,3187,'TE','3308354225',0,'2013-12-25 20:32:01',NULL,NULL),(14819,9703,'TE','4193057573',0,'2013-12-26 04:40:00',NULL,NULL),(42030,27934,'EM','myrnalangford@yahoo.com',0,'2014-03-06 21:00:28',NULL,NULL),(9869,6453,'TE','3305241572',0,'2013-12-26 00:49:44',NULL,NULL),(10232,6690,'AP','3176951146',0,'2013-12-26 01:01:33',NULL,NULL),(7955,5189,'TE','4408214694',0,'2013-12-25 23:03:44',NULL,NULL),(13519,8817,'AP','5135607196',0,'2013-12-26 04:00:09',NULL,NULL),(1882,1162,'TE','2253854807',0,'2013-12-25 18:18:55',NULL,NULL),(1950,1207,'TE','2167517568',0,'2013-12-25 18:20:02',NULL,NULL),(35056,23020,'TE','9547322987',0,'2014-02-12 21:30:30',NULL,NULL),(31213,20328,'EM','chaimandujano@gmail.com',0,'2014-01-28 21:01:00',NULL,NULL),(22252,14340,'AP','4192038649',0,'2013-12-27 02:07:52',NULL,NULL),(26865,17288,'TE','7747225089',0,'2014-01-13 02:23:31',NULL,NULL),(43071,28635,'EM','clhanyon@aim.com',0,'2014-03-08 21:30:29',NULL,NULL),(40949,27210,'AP','4193482351',0,'2014-03-03 21:31:27',NULL,NULL),(27069,17409,'EM','michaelpyee@gmail.com',0,'2014-01-13 03:00:21',NULL,NULL),(29893,19343,'TE','3308825816',1,'2014-01-22 03:22:22',NULL,NULL),(32794,21456,'AP','8436162708',0,'2014-02-04 21:01:31',NULL,NULL),(37210,24489,'AP','9152443276',0,'2014-02-20 03:43:52',NULL,NULL),(3968,2518,'AP','3303284085',0,'2013-12-25 19:36:31',NULL,NULL),(38888,25706,'TE','9035610437',0,'2014-02-26 09:30:21',NULL,NULL),(4323,2758,'EM','tslady232@yahoo.com',0,'2013-12-25 19:49:16',NULL,NULL),(32545,21278,'EM','HEDGES532003@YAHOO.COM',0,'2014-02-03 21:01:35',NULL,NULL),(9643,6310,'EM','p_markenson@yahoo.com',0,'2013-12-26 00:46:09',NULL,NULL),(29452,19043,'BN','7133205831',0,'2014-01-20 08:06:38',NULL,NULL),(28995,18717,'TE','3306076869',0,'2014-01-17 03:35:33',NULL,NULL),(28555,18412,'AP','5042517063',0,'2014-01-16 08:45:48',NULL,NULL),(21950,14139,'AP','3184612987',0,'2013-12-27 02:02:36',NULL,NULL),(1469,900,'EM','tlm0317@yahoo.com',0,'2013-12-25 18:08:16',NULL,NULL),(3037,1891,'TE','5138462130',0,'2013-12-25 18:58:51',NULL,NULL),(40918,27190,'TE','8326897294',0,'2014-03-03 21:31:15',NULL,NULL),(38682,25565,'AP','3309882762',0,'2014-02-26 08:00:26',NULL,NULL),(9131,5978,'AP','5135821094',0,'2013-12-25 23:51:53',NULL,NULL),(9343,6116,'EM','smicozzi@neo.rr.com',0,'2013-12-26 00:15:37',NULL,NULL),(34937,22927,'EM','artemis.the.hunter16@gmail.com',0,'2014-02-11 21:30:08',NULL,NULL),(10761,6996,'TE','9368979941',0,'2013-12-26 01:48:08',NULL,NULL),(43812,29082,'AP','6012126618',0,'2014-03-10 21:02:04',NULL,NULL),(1251,759,'EM','matthew.titsworth@gmail.com',0,'2013-12-25 18:04:32',NULL,NULL),(41742,27756,'AP','5042488703',0,'2014-03-05 21:31:18',NULL,NULL),(4297,2743,'TE','3304648589',0,'2013-12-25 19:48:51',NULL,NULL),(9759,6382,'TE','2165363724',0,'2013-12-26 00:47:57',NULL,NULL),(23355,15045,'TE','5045591172',0,'2014-01-01 12:03:06',NULL,NULL),(29311,18938,'TE','5133687611',0,'2014-01-20 08:05:43',NULL,NULL),(38568,25487,'EM','MWELLS@HORIZONINSGROUP.COM',0,'2014-02-25 21:31:46',NULL,NULL),(36371,23952,'AP','9039690092',0,'2014-02-15 22:00:05',NULL,NULL),(29766,19246,'AP','5049064230',0,'2014-01-21 08:46:41',NULL,NULL),(33406,21888,'TE','4195572747',0,'2014-02-06 21:01:36',NULL,NULL),(32943,21562,'TE','7407632136',0,'2014-02-05 21:30:19',NULL,NULL),(32675,21369,'TE','3615723637',0,'2014-02-04 21:00:47',NULL,NULL),(32586,21304,'EM','whitneypouncey@yahoo.com',0,'2014-02-04 21:00:14',NULL,NULL),(14922,9764,'AP','2053560173',0,'2013-12-26 05:00:16',NULL,NULL),(41301,27439,'AP','2257882772',0,'2014-03-04 21:01:52',NULL,NULL),(2405,1466,'TE','3304779158',0,'2013-12-25 18:48:27',NULL,NULL),(38086,25140,'EM','JUDYEDMUNDS48@YAHOO.COM',0,'2014-02-21 22:00:10',NULL,NULL),(10016,6553,'AP','8176372971',0,'2013-12-26 00:52:13',NULL,NULL),(37387,24620,'AP','6019830020',0,'2014-02-20 04:16:04',NULL,NULL),(36995,24357,'AP','3372588639',0,'2014-02-18 22:00:30',NULL,NULL),(23627,15255,'TE','9373045788',0,'2014-01-01 12:09:06',NULL,NULL),(30869,20064,'TE','3254508543',0,'2014-01-27 21:00:13',NULL,NULL),(28698,18519,'TE','2144407097',0,'2014-01-16 08:46:37',NULL,NULL),(28567,18418,'TE','5042148160',0,'2014-01-16 08:45:51',NULL,NULL),(24745,15966,'AP','9033098550',0,'2014-01-04 02:00:28',NULL,NULL),(24562,15844,'TE','7405032690',0,'2014-01-03 02:04:14',NULL,NULL),(2178,1339,'AP','7249775906',0,'2013-12-25 18:32:22',NULL,NULL),(5740,3679,'TE','5136710122',0,'2013-12-25 21:31:25',NULL,NULL),(22733,14660,'EM','jasbuell12@hotmail.com',1,'2013-12-29 11:07:59',NULL,NULL),(23153,14925,'AP','5133400705',0,'2013-12-30 00:01:49',NULL,NULL),(32760,21431,'AP','9033314871',0,'2014-02-04 21:01:19',NULL,NULL),(26539,17073,'TE','2547212334',0,'2014-01-13 02:21:18',NULL,NULL),(1118,685,'TE','3307577531',0,'2013-12-25 18:02:30',NULL,NULL),(10935,7110,'TE','3373663434',0,'2013-12-26 01:51:00',NULL,NULL),(41897,27858,'AP','5129392283',0,'2014-03-05 21:32:17',NULL,NULL),(33129,21700,'TE','6012122800',0,'2014-02-05 21:31:10',NULL,NULL),(385,236,'TE','4084603506',0,'2013-12-25 17:21:10',NULL,NULL),(21240,13653,'TE','5042729004',0,'2013-12-26 13:07:22',NULL,NULL),(11776,7661,'AP','5042319863',0,'2013-12-26 03:00:18',NULL,NULL),(3134,1953,'TE','8176816774',0,'2013-12-25 19:01:02',NULL,NULL),(5452,3490,'TE','9374166847',0,'2013-12-25 21:20:26',NULL,NULL),(6789,4403,'TE','4199445574',0,'2013-12-25 22:01:13',NULL,NULL),(40951,27212,'TE','4192034451',0,'2014-03-03 21:31:29',NULL,NULL),(38510,25449,'AP','2817063871',0,'2014-02-25 21:31:25',NULL,NULL),(37848,24970,'AP','3252779677',0,'2014-02-20 22:00:26',NULL,NULL),(6475,4189,'TE','3303576707',0,'2013-12-25 21:49:37',NULL,NULL),(33985,22294,'AP','9375273798',0,'2014-02-10 11:00:31',NULL,NULL),(31199,20317,'BN','2812530738',0,'2014-01-28 21:00:53',NULL,NULL),(6354,4094,'TE','5676983226',0,'2013-12-25 21:47:33',NULL,NULL),(29662,19163,'AP','4199670160',0,'2014-01-21 08:45:43',NULL,NULL),(28144,18142,'EM','connie.s.rutherford@gmail.com',0,'2014-01-15 02:07:47',NULL,NULL),(25459,16416,'TE','3302965759',0,'2014-01-07 04:04:24',NULL,NULL),(21380,13747,'TE','4197383667',0,'2013-12-26 13:09:52',NULL,NULL),(22134,14257,'TE','5043077505',0,'2013-12-27 02:05:41',NULL,NULL),(43913,29134,'TE','4193410259',0,'2014-03-10 21:02:39',NULL,NULL),(8211,5376,'AP','2259075407',0,'2013-12-25 23:08:13',NULL,NULL),(40255,26705,'TE','5672240101',0,'2014-02-28 21:31:35',NULL,NULL),(20402,13139,'TE','3304313787',0,'2013-12-26 12:53:15',NULL,NULL),(13897,9060,'TE','8133334841',0,'2013-12-26 04:06:19',NULL,NULL),(34382,22552,'TE','8034135585',0,'2014-02-10 21:31:46',NULL,NULL),(32768,21437,'TE','6013629070',0,'2014-02-04 21:01:22',NULL,NULL),(6347,4091,'TE','6016224220',0,'2013-12-25 21:47:27',NULL,NULL),(29129,18816,'AP','5136082836',0,'2014-01-17 03:36:04',NULL,NULL),(26122,16820,'TE','8177365376',0,'2014-01-13 02:18:21',NULL,NULL),(25616,16521,'AP','8067903657',1,'2014-01-07 10:21:44',NULL,NULL),(3191,2006,'TE','5136030445',0,'2013-12-25 19:02:20',NULL,NULL),(3908,2480,'EM','brbrad7134@gmail.com',0,'2013-12-25 19:35:30',NULL,NULL),(6720,4366,'EM','katherine.alex.stewart@gmail.com',0,'2013-12-25 22:00:11',NULL,NULL),(9556,6254,'TE','9372194620',0,'2013-12-26 00:32:03',NULL,NULL),(4440,2829,'EM','gmds50@hotmail.com',0,'2013-12-25 20:00:44',NULL,NULL),(34027,22316,'TE','5132135353',0,'2014-02-10 11:00:50',NULL,NULL),(36721,24179,'TE','3304670996',0,'2014-02-16 19:00:06',NULL,NULL),(36006,23685,'TE','9378449789',0,'2014-02-14 21:30:34',NULL,NULL);
/*!40000 ALTER TABLE `EdiParticipantContact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiProcessing`
--

DROP TABLE IF EXISTS `EdiProcessing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiProcessing` (
  `EdiProcessingId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProcessingDirection` enum('Inbound','OutBound') NOT NULL DEFAULT 'Inbound' COMMENT 'Should currently be inbound ',
  `FailedReason` varchar(400) DEFAULT NULL COMMENT 'If failed, reason for failure',
  `Status` enum('InProgress','Completed','Failed') NOT NULL,
  `FileName` varchar(200) NOT NULL,
  `FileTime` time NOT NULL COMMENT 'From Interchange Info:  Example 18:04',
  `FileDate` date NOT NULL COMMENT 'From Interchange Information',
  `TestIndicator` varchar(10) NOT NULL COMMENT 'From Interchange Info:  Example False',
  `InterchangeSenderId` varchar(20) NOT NULL COMMENT 'From Interchange Info: Example 0000008218',
  `InterchangeReceiverId` varchar(20) NOT NULL COMMENT 'From Interchange Info: Example 0000008218',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiProcessingId`)
) ENGINE=innodb AUTO_INCREMENT=2857 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiProcessing`
--

LOCK TABLES `EdiProcessing` WRITE;
/*!40000 ALTER TABLE `EdiProcessing` DISABLE KEYS */;
INSERT INTO `EdiProcessing` VALUES (16,'Inbound',NULL,'Completed','452721020.I834.D131025.T1807407.P.OUT','18:01:00','2013-10-25','','CMSFFM','452721020',0,'2013-12-25 18:31:49',NULL,'2013-12-25 18:32:12'),(1257,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112410.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:17',NULL,'2014-01-05 16:58:19'),(1798,'OutBound','5878','Completed','452721020.DSH.IC834.D140114.T230919582.P.IN','23:09:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:19',1,'2014-01-14 23:09:20'),(1946,'OutBound','4491','Completed','452721020.DSH.IC834.D140114.T231436225.P.IN','23:14:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:36',1,'2014-01-14 23:14:37'),(2767,'OutBound','7128','Completed','452721020.DSH.IC834.D140129.T134630598.P.IN','13:46:30','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:30',1,'2014-01-29 13:46:30'),(273,'OutBound','75','Completed','452721020.DSH.IC834.D131227.T152919228.P.IN','15:29:19','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:29:19',1,'2013-12-27 20:29:19'),(281,'OutBound','5042','Completed','452721020.DSH.IC834.D131227.T153149691.P.IN','15:31:49','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:50',1,'2013-12-27 20:31:50'),(530,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111013889.P.IN','11:10:13','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:14',NULL,NULL),(1245,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113353.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:43',NULL,'2014-01-05 16:57:45'),(1571,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114117.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:04:01',NULL,'2014-01-13 03:04:02'),(2074,'OutBound','428','Completed','452721020.DSH.IC834.D140114.T231719547.P.IN','23:17:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:19',1,'2014-01-14 23:17:20'),(417,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063224929.P.IN','06:32:24','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:32:24',NULL,NULL),(482,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104514735.P.IN','10:45:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:45:15',NULL,NULL),(1189,'Inbound',NULL,'Completed','452721020.999.D131228.T1113318.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:32',NULL,'2014-01-05 16:53:34'),(2248,'OutBound','3170','Completed','452721020.DSH.IC834.D140115.T001948848.P.IN','00:19:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:48',1,'2014-01-15 00:19:49'),(2305,'OutBound','3388','Completed','452721020.DSH.IC834.D140115.T002102242.P.IN','00:21:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:02',1,'2014-01-15 00:21:03'),(2331,'OutBound','1988','Completed','452721020.DSH.IC834.D140115.T090257678.P.IN','09:02:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:57',1,'2014-01-15 09:02:58'),(557,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113729888.T.IN','11:37:29','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:30',NULL,NULL),(1303,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112471.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:25',NULL,'2014-01-05 17:00:27'),(2267,'OutBound','5812','Completed','452721020.DSH.IC834.D140115.T002013781.P.IN','00:20:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:13',1,'2014-01-15 00:20:14'),(2395,'OutBound','5140','Completed','452721020.DSH.IC834.D140115.T090335332.P.IN','09:03:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:35',1,'2014-01-15 09:03:35'),(2551,'Inbound',NULL,'Completed','452721020.I834.D140117.T1832414.P.OUT','18:23:00','2014-01-17','','CMSFFM','452721020',0,'2014-01-20 08:05:33',NULL,'2014-01-20 08:06:47'),(2690,'Inbound',NULL,'Completed','452721020.999.D140115.T0242247.P.OUT','00:28:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:19:20',NULL,'2014-01-23 06:19:21'),(52,'Inbound',NULL,'Completed','452721020.I834.D131201.T1817110.P.OUT','18:08:00','2013-12-01','','CMSFFM','452721020',0,'2013-12-26 00:00:01',NULL,'2013-12-26 00:02:53'),(1363,'Inbound',NULL,'Completed','452721020.999.D131228.T1112419.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:53',NULL,'2014-01-05 17:22:55'),(2063,'OutBound','839','Completed','452721020.DSH.IC834.D140114.T231706143.P.IN','23:17:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:06',1,'2014-01-14 23:17:07'),(41,'Inbound',NULL,'Completed','452721020.I834.D131208.T1817172.P.OUT','18:10:00','2013-12-08','','CMSFFM','452721020',0,'2013-12-25 22:15:01',NULL,'2013-12-25 22:17:28'),(46,'Inbound',NULL,'Completed','452721020.I834.D131207.T1822259.P.OUT','18:13:00','2013-12-07','','CMSFFM','452721020',0,'2013-12-25 22:45:01',NULL,'2013-12-25 22:48:10'),(297,'OutBound','2977','Completed','452721020.DSH.IC834.D131227.T153515929.P.IN','15:35:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:35:16',1,'2013-12-27 20:35:16'),(546,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113642550.T.IN','11:36:42','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:42',NULL,NULL),(1744,'OutBound','383','Completed','452721020.DSH.IC834.D140114.T230808306.P.IN','23:08:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:08',1,'2014-01-14 23:08:09'),(1904,'OutBound','3009','Completed','452721020.DSH.IC834.D140114.T231139261.P.IN','23:11:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:39',1,'2014-01-14 23:11:40'),(1349,'Inbound',NULL,'Completed','452721020.999.D131228.T1113230.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:33',NULL,'2014-01-05 17:02:35'),(1590,'OutBound','2586','Completed','452721020.DSH.IC834.D140114.T230500397.P.IN','23:05:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:00',1,'2014-01-14 23:05:01'),(1763,'OutBound','2428','Completed','452721020.DSH.IC834.D140114.T230832793.P.IN','23:08:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:32',1,'2014-01-14 23:08:33'),(2818,'Inbound',NULL,'Completed','452721020.CIC834.D140225.T1842174.P.OUT','18:33:00','2014-02-25','','CMSFFM','452721020',0,'2014-02-25 21:00:09',0,'2014-02-25 21:00:33'),(421,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063449147.P.IN','06:34:49','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:34:49',NULL,NULL),(1749,'OutBound','163','Completed','452721020.DSH.IC834.D140114.T230814893.P.IN','23:08:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:15',1,'2014-01-14 23:08:15'),(2020,'OutBound','5347','Completed','452721020.DSH.IC834.D140114.T231610994.P.IN','23:16:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:11',1,'2014-01-14 23:16:11'),(2075,'OutBound','384','Completed','452721020.DSH.IC834.D140114.T231720812.P.IN','23:17:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:20',1,'2014-01-14 23:17:21'),(379,'OutBound','2412','Completed','452721020.DSH.IC834.D131227.T164529624.P.IN','16:45:29','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:45:29',1,'2013-12-27 21:45:30'),(1171,'Inbound',NULL,'Completed','452721020.999.D131228.T1112489.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:42',NULL,'2014-01-05 16:52:44'),(404,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062311456.P.IN','06:23:11','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:23:11',NULL,NULL),(1376,'Inbound',NULL,'Completed','452721020.999.D131228.T1112553.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:29',NULL,'2014-01-05 17:23:31'),(1730,'OutBound','840','Completed','452721020.DSH.IC834.D140114.T230749277.P.IN','23:07:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:49',1,'2014-01-14 23:07:50'),(1981,'OutBound','116','Completed','452721020.DSH.IC834.D140114.T231516117.P.IN','23:15:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:16',1,'2014-01-14 23:15:17'),(2065,'OutBound','837','Completed','452721020.DSH.IC834.D140114.T231708497.P.IN','23:17:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:08',1,'2014-01-14 23:17:09'),(2162,'OutBound','1655','Completed','452721020.DSH.IC834.D140115.T001800257.P.IN','00:18:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:00',1,'2014-01-15 00:18:01'),(1549,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113237.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:41',NULL,'2014-01-13 03:03:42'),(1993,'OutBound','6022','Completed','452721020.DSH.IC834.D140114.T231531215.P.IN','23:15:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:31',1,'2014-01-14 23:15:32'),(2662,'Inbound',NULL,'Completed','452721020.999.D140114.T2349220.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:35:25',1,'2014-01-23 04:35:26'),(2796,'Inbound',NULL,'Completed','452721020.I834.D140212.T1839421.P.OUT','18:31:00','2014-02-12','','CMSFFM','452721020',0,'2014-02-12 21:30:03',NULL,'2014-02-12 21:32:32'),(535,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111041272.P.IN','11:10:41','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:41',NULL,NULL),(1459,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112501.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:20',NULL,'2014-01-05 17:27:22'),(1671,'OutBound','6443','Completed','452721020.DSH.IC834.D140114.T230638460.P.IN','23:06:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:38',1,'2014-01-14 23:06:39'),(1791,'OutBound','1980','Completed','452721020.DSH.IC834.D140114.T230909880.P.IN','23:09:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:09',1,'2014-01-14 23:09:11'),(2328,'OutBound','1990','Completed','452721020.DSH.IC834.D140115.T090255938.P.IN','09:02:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:56',1,'2014-01-15 09:02:56'),(2330,'OutBound','2057','Completed','452721020.DSH.IC834.D140115.T090257132.P.IN','09:02:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:57',1,'2014-01-15 09:02:57'),(2790,'Inbound',NULL,'Completed','452721020.MISC.D140210.T0617556.P.OUT','05:02:00','2014-02-10','','CMSFFM','452721020',0,'2014-02-10 11:00:04',NULL,'2014-02-10 11:01:15'),(2810,'Inbound',NULL,'Completed','452721020.I834.D140219.T1845188.P.OUT','18:35:00','2014-02-19','','CMSFFM','452721020',0,'2014-02-20 04:00:10',0,'2014-02-20 04:57:01'),(342,'OutBound','5007','Completed','452721020.DSH.IC834.D131227.T155525762.P.IN','15:55:25','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:55:26',1,'2013-12-27 20:55:26'),(1318,'Inbound',NULL,'Completed','452721020.999.D131228.T1112202.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:06',NULL,'2014-01-05 17:01:09'),(2238,'OutBound','3021','Completed','452721020.DSH.IC834.D140115.T001936520.P.IN','00:19:36','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:36',1,'2014-01-15 00:19:37'),(2383,'OutBound','5138','Completed','452721020.DSH.IC834.D140115.T090327710.P.IN','09:03:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:27',1,'2014-01-15 09:03:28'),(11,'Inbound',NULL,'Completed','452721020.I834.D131024.T1807492.P.OUT','18:01:00','2013-10-24','','CMSFFM','452721020',0,'2013-12-25 18:11:12',NULL,'2013-12-25 18:11:16'),(1399,'Inbound',NULL,'Completed','452721020.999.D131227.T1703127.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:24:33',NULL,'2014-01-05 17:24:35'),(1462,'Inbound',NULL,'Completed','452721020.999.D131228.T1112465.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:28',NULL,'2014-01-05 17:27:31'),(1593,'OutBound','2305','Completed','452721020.DSH.IC834.D140114.T230503815.P.IN','23:05:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:03',1,'2014-01-14 23:05:04'),(1645,'OutBound','2196','Completed','452721020.DSH.IC834.D140114.T230605132.P.IN','23:06:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:05',1,'2014-01-14 23:06:06'),(1754,'OutBound','145','Completed','452721020.DSH.IC834.D140114.T230821275.P.IN','23:08:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:21',1,'2014-01-14 23:08:22'),(1936,'OutBound','290','Completed','452721020.DSH.IC834.D140114.T231424375.P.IN','23:14:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:24',1,'2014-01-14 23:14:25'),(1994,'OutBound','6020','Completed','452721020.DSH.IC834.D140114.T231532431.P.IN','23:15:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:32',1,'2014-01-14 23:15:33'),(2081,'OutBound','383','Completed','452721020.DSH.IC834.D140114.T231729562.P.IN','23:17:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:29',1,'2014-01-14 23:17:30'),(2245,'OutBound','3012','Completed','452721020.DSH.IC834.D140115.T001945283.P.IN','00:19:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:45',1,'2014-01-15 00:19:46'),(454,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070718456.P.IN','07:07:18','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:07:18',NULL,NULL),(1574,'OutBound','4893','Completed','452721020.DSH.IC834.D140113.T220906359.P.IN','22:09:06','2014-01-13','0','452721020','CMSFFM',1,'2014-01-13 22:09:06',1,'2014-01-13 22:09:07'),(2048,'OutBound','2237','Completed','452721020.DSH.IC834.D140114.T231646821.P.IN','23:16:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:46',1,'2014-01-14 23:16:47'),(2060,'OutBound','1005','Completed','452721020.DSH.IC834.D140114.T231702518.P.IN','23:17:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:02',1,'2014-01-14 23:17:03'),(2448,'OutBound','3016','Completed','452721020.DSH.IC834.D140115.T090414764.P.IN','09:04:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:14',1,'2014-01-15 09:04:15'),(39,'Inbound',NULL,'Completed','452721020.I834.D131217.T1851468.P.OUT','18:43:00','2013-12-17','','CMSFFM','452721020',0,'2013-12-25 21:45:02',NULL,'2013-12-25 21:53:46'),(219,'OutBound','6425','Completed','452721020.DSH.IC834.D131227.T150920177.P.IN','15:09:20','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:09:20',1,'2013-12-27 20:09:20'),(261,'OutBound','5064','Completed','452721020.DSH.IC834.D131227.T152457309.P.IN','15:24:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:24:57',1,'2013-12-27 20:24:58'),(1319,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112424.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:09',NULL,'2014-01-05 17:01:11'),(1510,'Inbound',NULL,'Completed','452721020.999.D131228.T1112240.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:40',NULL,'2014-01-13 03:02:41'),(2529,'OutBound','11398','Completed','452721020.DSH.IC834.D140115.T222150572.P.IN','22:21:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:50',1,'2014-01-15 22:21:50'),(2719,'Inbound',NULL,'Completed','452721020.999.D140114.T2354567.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 07:06:40',NULL,'2014-01-23 07:06:40'),(1156,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113191.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:01',NULL,'2014-01-05 16:52:03'),(1831,'OutBound','7163','Completed','452721020.DSH.IC834.D140114.T230959942.P.IN','23:09:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:00',1,'2014-01-14 23:10:00'),(1890,'OutBound','3011','Completed','452721020.DSH.IC834.D140114.T231120749.P.IN','23:11:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:20',1,'2014-01-14 23:11:21'),(1935,'OutBound','1106','Completed','452721020.DSH.IC834.D140114.T231423378.P.IN','23:14:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:23',1,'2014-01-14 23:14:24'),(2153,'OutBound','1658','Completed','452721020.DSH.IC834.D140115.T001748724.P.IN','00:17:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:48',1,'2014-01-15 00:17:49'),(558,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113730372.T.IN','11:37:30','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:30',NULL,NULL),(2688,'Inbound',NULL,'Completed','452721020.999.D140114.T2330375.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 05:30:13',NULL,'2014-01-23 05:30:14'),(402,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062032708.P.IN','06:20:32','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:20:33',NULL,NULL),(1582,'OutBound','1980','Completed','452721020.DSH.IC834.D140114.T230450150.P.IN','23:04:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:50',1,'2014-01-14 23:04:51'),(1610,'OutBound','3821','Completed','452721020.DSH.IC834.D140114.T230525121.P.IN','23:05:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:25',1,'2014-01-14 23:05:25'),(2581,'Inbound',NULL,'Completed','452721020.999.D140114.T2326343.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:44:38',1,'2014-01-23 03:44:38'),(2637,'Inbound',NULL,'Completed','452721020.999.D140114.T2346329.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:17:26',1,'2014-01-23 04:17:26'),(2804,'Inbound',NULL,'Completed','452721020.I834.D140216.T1819254.P.OUT','18:12:00','2014-02-16','','CMSFFM','452721020',0,'2014-02-16 19:00:04',0,'2014-02-16 19:00:44'),(483,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104515204.P.IN','10:45:15','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:45:15',NULL,NULL),(541,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111953633.P.IN','11:19:53','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:19:54',NULL,NULL),(1443,'Inbound',NULL,'Completed','452721020.999.D131228.T1113381.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:36',NULL,'2014-01-05 17:26:38'),(2090,'OutBound','164','Completed','452721020.DSH.IC834.D140114.T231741339.P.IN','23:17:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:41',1,'2014-01-14 23:17:42'),(2695,'Inbound',NULL,'Completed','452721020.999.D140114.T2351450.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:39:34',NULL,'2014-01-23 06:39:35'),(50,'Inbound',NULL,'Completed','452721020.I834.D131126.T1827095.P.OUT','18:20:00','2013-11-26','','CMSFFM','452721020',0,'2013-12-25 23:30:01',NULL,'2013-12-25 23:33:08'),(527,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110914619.P.IN','11:09:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:15',NULL,NULL),(2318,'OutBound','2070','Completed','452721020.DSH.IC834.D140115.T090250527.P.IN','09:02:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:50',1,'2014-01-15 09:02:50'),(415,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063143964.P.IN','06:31:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:31:44',NULL,NULL),(1204,'Inbound',NULL,'Completed','452721020.999.D131228.T1112187.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:13',NULL,'2014-01-05 16:54:16'),(1495,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113362.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:27',NULL,'2014-01-13 03:02:27'),(2556,'Inbound',NULL,'Completed','452721020.I834.D140122.T1838485.P.OUT','18:31:00','2014-01-22','','CMSFFM','452721020',0,'2014-01-23 03:01:49',NULL,'2014-01-23 03:02:55'),(2732,'Inbound',NULL,'Completed','452721020.999.D140114.T2349511.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 09:28:22',NULL,'2014-01-23 09:28:22'),(226,'OutBound','1965','Completed','452721020.DSH.IC834.D131227.T151133400.P.IN','15:11:33','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:11:33',1,'2013-12-27 20:11:34'),(1692,'OutBound','4410','Completed','452721020.DSH.IC834.D140114.T230703326.P.IN','23:07:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:03',1,'2014-01-14 23:07:04'),(2446,'OutBound','3113','Completed','452721020.DSH.IC834.D140115.T090413139.P.IN','09:04:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:13',1,'2014-01-15 09:04:13'),(255,'OutBound','913','Completed','452721020.DSH.IC834.D131227.T152257260.P.IN','15:22:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:22:57',1,'2013-12-27 20:22:58'),(1160,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112416.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:12',NULL,'2014-01-05 16:52:14'),(1290,'Inbound',NULL,'Completed','452721020.999.D131228.T1113580.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:48',NULL,'2014-01-05 16:59:51'),(1762,'OutBound','5121','Completed','452721020.DSH.IC834.D140114.T230830866.P.IN','23:08:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:30',1,'2014-01-14 23:08:31'),(1803,'OutBound','1827','Completed','452721020.DSH.IC834.D140114.T230926795.P.IN','23:09:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:26',1,'2014-01-14 23:09:27'),(2280,'OutBound','5978','Completed','452721020.DSH.IC834.D140115.T002029223.P.IN','00:20:29','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:29',1,'2014-01-15 00:20:30'),(1699,'OutBound','2630','Completed','452721020.DSH.IC834.D140114.T230712564.P.IN','23:07:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:12',1,'2014-01-14 23:07:13'),(534,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111040801.P.IN','11:10:40','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:41',NULL,NULL),(1902,'OutBound','3119','Completed','452721020.DSH.IC834.D140114.T231136363.P.IN','23:11:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:36',1,'2014-01-14 23:11:37'),(1917,'OutBound','2217','Completed','452721020.DSH.IC834.D140114.T231404364.P.IN','23:14:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:04',1,'2014-01-14 23:14:05'),(1566,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113393.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:57',NULL,'2014-01-13 03:03:57'),(2009,'OutBound','6452','Completed','452721020.DSH.IC834.D140114.T231557309.P.IN','23:15:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:57',1,'2014-01-14 23:15:58'),(2036,'OutBound','2630','Completed','452721020.DSH.IC834.D140114.T231632355.P.IN','23:16:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:32',1,'2014-01-14 23:16:33'),(2394,'OutBound','5118','Completed','452721020.DSH.IC834.D140115.T090334697.P.IN','09:03:34','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:34',1,'2014-01-15 09:03:35'),(2461,'OutBound','5787','Completed','452721020.DSH.IC834.D140115.T090424785.P.IN','09:04:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:24',1,'2014-01-15 09:04:25'),(2567,'Inbound',NULL,'Completed','452721020.999.D140114.T2325192.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:41:22',1,'2014-01-23 03:41:22'),(2699,'Inbound',NULL,'Completed','452721020.999.D140115.T0326411.P.OUT','02:22:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:40:34',NULL,'2014-01-23 06:40:34'),(220,'OutBound','4839','Completed','452721020.DSH.IC834.D131227.T150949511.P.IN','15:09:49','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:09:49',1,'2013-12-27 20:09:50'),(1864,'OutBound','3630','Completed','452721020.DSH.IC834.D140114.T231046783.P.IN','23:10:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:46',1,'2014-01-14 23:10:47'),(2263,'OutBound','5777','Completed','452721020.DSH.IC834.D140115.T002008863.P.IN','00:20:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:08',1,'2014-01-15 00:20:09'),(2314,'OutBound','3799','Completed','452721020.DSH.IC834.D140115.T090248350.P.IN','09:02:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:48',1,'2014-01-15 09:02:48'),(2316,'OutBound','3797','Completed','452721020.DSH.IC834.D140115.T090249409.P.IN','09:02:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:49',1,'2014-01-15 09:02:49'),(2526,'OutBound','5627','Completed','452721020.DSH.IC834.D140115.T222149151.P.IN','22:21:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:49',1,'2014-01-15 22:21:49'),(553,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113727972.T.IN','11:37:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:28',NULL,NULL),(473,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071702105.P.IN','07:17:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:17:02',NULL,NULL),(2004,'OutBound','4849','Completed','452721020.DSH.IC834.D140114.T231550701.P.IN','23:15:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:50',1,'2014-01-14 23:15:51'),(2246,'OutBound','3017','Completed','452721020.DSH.IC834.D140115.T001946460.P.IN','00:19:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:46',1,'2014-01-15 00:19:47'),(2554,'Inbound',NULL,'Completed','452721020.I834.D140120.T1827269.P.OUT','18:21:00','2014-01-20','','CMSFFM','452721020',0,'2014-01-21 08:46:00',NULL,'2014-01-21 08:47:01'),(2598,'Inbound',NULL,'Completed','452721020.999.D140114.T2337552.P.OUT','23:21:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:50:21',1,'2014-01-23 03:50:22'),(516,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105827275.P.IN','10:58:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:58:27',NULL,NULL),(1507,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113469.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:38',NULL,'2014-01-13 03:02:38'),(2564,'Inbound',NULL,'Completed','452721020.999.D140115.T1137041.P.OUT','11:28:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 03:39:37',NULL,'2014-01-23 03:39:38'),(232,'OutBound','2934','Completed','452721020.DSH.IC834.D131227.T151359659.P.IN','15:13:59','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:13:59',1,'2013-12-27 20:14:00'),(1674,'OutBound','5850','Completed','452721020.DSH.IC834.D140114.T230641758.P.IN','23:06:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:41',1,'2014-01-14 23:06:42'),(2508,'OutBound','3332','Completed','452721020.DSH.IC834.D140115.T090456803.P.IN','09:04:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:56',1,'2014-01-15 09:04:56'),(208,'OutBound','2295','Completed','452721020.DSH.IC834.D131227.T150412812.P.IN','15:04:12','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:04:13',1,'2013-12-27 20:04:13'),(284,'OutBound','245','Completed','452721020.DSH.IC834.D131227.T153221125.P.IN','15:32:21','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:32:21',1,'2013-12-27 20:32:21'),(360,'OutBound','2143','Completed','452721020.DSH.IC834.D131227.T161213298.P.IN','16:12:13','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:12:13',1,'2013-12-27 21:12:14'),(399,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061747489.P.IN','06:17:47','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:17:47',NULL,NULL),(1518,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113327.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:09',NULL,'2014-01-13 03:03:10'),(2091,'OutBound','145','Completed','452721020.DSH.IC834.D140114.T231742593.P.IN','23:17:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:42',1,'2014-01-14 23:17:43'),(2324,'OutBound','2055','Completed','452721020.DSH.IC834.D140115.T090253839.P.IN','09:02:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:53',1,'2014-01-15 09:02:54'),(2562,'Inbound',NULL,'Completed','452721020.999.D140113.T2231477.P.OUT','22:25:00','2014-01-13','','CMSFFM','452721020',0,'2014-01-23 03:39:36',NULL,'2014-01-23 03:39:36'),(12,'Inbound',NULL,'Completed','452721020.I834.D131017.T1807031.P.OUT','18:00:00','2013-10-17','','CMSFFM','452721020',0,'2013-12-25 18:11:17',NULL,'2013-12-25 18:11:19'),(493,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104732677.P.IN','10:47:32','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:33',NULL,NULL),(1474,'Inbound',NULL,'Completed','452721020.I834.D140109.T1837320.P.OUT','18:28:00','2014-01-09','','CMSFFM','452721020',0,'2014-01-13 02:19:06',NULL,'2014-01-13 02:21:01'),(2455,'OutBound','5776','Completed','452721020.DSH.IC834.D140115.T090420103.P.IN','09:04:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:20',1,'2014-01-15 09:04:20'),(2852,'Inbound',NULL,'Completed','452721020.I834.D140308.T1852373.P.OUT','18:43:00','2014-03-08','','CMSFFM','452721020',0,'2014-03-08 21:29:59',0,'2014-03-08 21:31:23'),(2378,'OutBound','5142','Completed','452721020.DSH.IC834.D140115.T090324766.P.IN','09:03:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:24',1,'2014-01-15 09:03:25'),(2471,'OutBound','5955','Completed','452721020.DSH.IC834.D140115.T090431692.P.IN','09:04:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:31',1,'2014-01-15 09:04:32'),(25,'Inbound',NULL,'Completed','452721020.I834.D131124.T1812193.P.OUT','18:02:00','2013-11-24','','CMSFFM','452721020',0,'2013-12-25 20:00:15',NULL,'2013-12-25 20:01:08'),(550,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113644473.T.IN','11:36:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:44',NULL,NULL),(1942,'OutBound','5351','Completed','452721020.DSH.IC834.D140114.T231431895.P.IN','23:14:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:32',1,'2014-01-14 23:14:32'),(2566,'Inbound',NULL,'Completed','452721020.999.D140115.T0255522.P.OUT','01:19:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:40:36',1,'2014-01-23 03:40:36'),(295,'OutBound','5052','Completed','452721020.DSH.IC834.D131227.T153453381.P.IN','15:34:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:34:53',1,'2013-12-27 20:34:54'),(494,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104751755.P.IN','10:47:51','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:52',NULL,NULL),(1341,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113402.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:11',NULL,'2014-01-05 17:02:13'),(1638,'OutBound','146','Completed','452721020.DSH.IC834.D140114.T230556926.P.IN','23:05:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:57',1,'2014-01-14 23:05:57'),(2143,'OutBound','1779','Completed','452721020.DSH.IC834.D140115.T001735856.P.IN','00:17:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:35',1,'2014-01-15 00:17:36'),(2283,'OutBound','5884','Completed','452721020.DSH.IC834.D140115.T002033128.P.IN','00:20:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:33',1,'2014-01-15 00:20:34'),(2615,'Inbound',NULL,'Completed','452721020.999.D140115.T0103507.P.OUT','23:55:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:00:32',1,'2014-01-23 04:00:32'),(1881,'OutBound','3653','Completed','452721020.DSH.IC834.D140114.T231108378.P.IN','23:11:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:08',1,'2014-01-14 23:11:09'),(2574,'Inbound',NULL,'Completed','452721020.999.D140115.T0312201.P.OUT','01:52:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:42:30',1,'2014-01-23 03:42:31'),(2576,'Inbound',NULL,'Completed','452721020.999.D140114.T2331596.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:43:30',1,'2014-01-23 03:43:30'),(286,'OutBound','49','Completed','452721020.DSH.IC834.D131227.T153239355.P.IN','15:32:39','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:32:39',1,'2013-12-27 20:32:40'),(380,'Inbound',NULL,'Completed','452721020.I834.D131227.T1851360.P.OUT','18:44:00','2013-12-27','','CMSFFM','452721020',0,'2013-12-28 03:30:01',NULL,'2013-12-28 03:37:22'),(1212,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703138.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:54:36',NULL,'2014-01-05 16:54:38'),(1258,'Inbound',NULL,'Completed','452721020.999.D131228.T1113252.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:19',NULL,'2014-01-05 16:58:22'),(1531,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113575.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:25',NULL,'2014-01-13 03:03:25'),(2253,'OutBound','5783','Completed','452721020.DSH.IC834.D140115.T001956606.P.IN','00:19:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:56',1,'2014-01-15 00:19:57'),(2356,'OutBound','1657','Completed','452721020.DSH.IC834.D140115.T090311520.P.IN','09:03:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:11',1,'2014-01-15 09:03:12'),(2410,'OutBound','3631','Completed','452721020.DSH.IC834.D140115.T090345923.P.IN','09:03:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:46',1,'2014-01-15 09:03:46'),(238,'OutBound','4457','Completed','452721020.DSH.IC834.D131227.T151556385.P.IN','15:15:56','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:15:56',1,'2013-12-27 20:15:57'),(244,'OutBound','3482','Completed','452721020.DSH.IC834.D131227.T151741821.P.IN','15:17:41','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:17:41',1,'2013-12-27 20:17:41'),(411,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062744189.P.IN','06:27:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:27:44',NULL,NULL),(1278,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112393.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:15',NULL,'2014-01-05 16:59:17'),(1390,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112205.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:08',NULL,'2014-01-05 17:24:10'),(1629,'OutBound','159','Completed','452721020.DSH.IC834.D140114.T230547815.P.IN','23:05:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:47',1,'2014-01-14 23:05:48'),(2139,'OutBound','1818','Completed','452721020.DSH.IC834.D140115.T001730106.P.IN','00:17:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:30',1,'2014-01-15 00:17:31'),(7,'Inbound',NULL,'Completed','452721020.I834.D131216.T1847245.P.OUT','18:37:00','2013-12-16','','CMSFFM','452721020',0,'2013-12-25 18:00:01',NULL,'2013-12-25 18:08:50'),(1618,'OutBound','7350','Completed','452721020.DSH.IC834.D140114.T230533960.P.IN','23:05:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:34',1,'2014-01-14 23:05:36'),(2315,'OutBound','3800','Completed','452721020.DSH.IC834.D140115.T090248871.P.IN','09:02:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:48',1,'2014-01-15 09:02:49'),(2397,'OutBound','5158','Completed','452721020.DSH.IC834.D140115.T090336521.P.IN','09:03:36','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:36',1,'2014-01-15 09:03:37'),(2846,'Inbound',NULL,'Completed','452721020.I834.D140305.T1857552.P.OUT','18:49:00','2014-03-05','','CMSFFM','452721020',0,'2014-03-05 21:30:02',0,'2014-03-05 21:32:46'),(510,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105543975.P.IN','10:55:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:44',NULL,NULL),(1755,'OutBound','151','Completed','452721020.DSH.IC834.D140114.T230822448.P.IN','23:08:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:22',1,'2014-01-14 23:08:23'),(1823,'OutBound','1781','Completed','452721020.DSH.IC834.D140114.T230950603.P.IN','23:09:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:50',1,'2014-01-14 23:09:51'),(1999,'OutBound','1589','Completed','452721020.DSH.IC834.D140114.T231541111.P.IN','23:15:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:41',1,'2014-01-14 23:15:43'),(2209,'OutBound','3633','Completed','452721020.DSH.IC834.D140115.T001859221.P.IN','00:18:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:59',1,'2014-01-15 00:19:00'),(2289,'OutBound','690','Completed','452721020.DSH.IC834.D140115.T002041830.P.IN','00:20:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:41',1,'2014-01-15 00:20:42'),(2548,'OutBound','3334','Completed','452721020.DSH.IC834.D140120.T054424679.P.IN','05:44:24','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:24',1,'2014-01-20 05:44:24'),(28,'Inbound',NULL,'Completed','452721020.I834.D131008.T1806543.P.OUT','18:00:00','2013-10-08','','CMSFFM','452721020',0,'2013-12-25 20:02:08',NULL,'2013-12-25 20:02:20'),(69,'Inbound',NULL,'Completed','452721020.I834.D131123.T1812343.P.OUT','18:05:00','2013-11-23','','CMSFFM','452721020',0,'2013-12-26 02:15:01',NULL,'2013-12-26 02:16:31'),(230,'OutBound','5336','Completed','452721020.DSH.IC834.D131227.T151326830.P.IN','15:13:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:13:27',1,'2013-12-27 20:13:27'),(470,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071629988.P.IN','07:16:29','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:16:30',NULL,NULL),(1849,'OutBound','5149','Completed','452721020.DSH.IC834.D140114.T231026180.P.IN','23:10:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:26',1,'2014-01-14 23:10:27'),(1949,'OutBound','4493','Completed','452721020.DSH.IC834.D140114.T231439338.P.IN','23:14:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:39',1,'2014-01-14 23:14:40'),(2000,'OutBound','1590','Completed','452721020.DSH.IC834.D140114.T231543236.P.IN','23:15:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:43',1,'2014-01-14 23:15:45'),(2326,'OutBound','2076','Completed','452721020.DSH.IC834.D140115.T090254832.P.IN','09:02:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:54',1,'2014-01-15 09:02:55'),(36,'Inbound',NULL,'Completed','452721020.I834.D131203.T1827324.P.OUT','18:20:00','2013-12-03','','CMSFFM','452721020',0,'2013-12-25 21:00:01',NULL,'2013-12-25 21:00:02'),(440,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065745760.P.IN','06:57:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:46',NULL,NULL),(1123,'Inbound',NULL,'Completed','452721020.999.D131228.T1114131.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:30',NULL,'2014-01-05 16:50:32'),(1529,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113194.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:23',NULL,'2014-01-13 03:03:23'),(2278,'OutBound','5885','Completed','452721020.DSH.IC834.D140115.T002026858.P.IN','00:20:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:26',1,'2014-01-15 00:20:27'),(2628,'Inbound',NULL,'Completed','452721020.999.D140115.T0247471.P.OUT','00:55:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:10:28',1,'2014-01-23 04:10:29'),(1601,'OutBound','5266','Completed','452721020.DSH.IC834.D140114.T230513107.P.IN','23:05:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:13',1,'2014-01-14 23:05:13'),(2023,'OutBound','4497','Completed','452721020.DSH.IC834.D140114.T231614471.P.IN','23:16:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:15',1,'2014-01-14 23:16:15'),(2424,'OutBound','3656','Completed','452721020.DSH.IC834.D140115.T090355974.P.IN','09:03:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:56',1,'2014-01-15 09:03:56'),(2242,'OutBound','3008','Completed','452721020.DSH.IC834.D140115.T001941106.P.IN','00:19:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:41',1,'2014-01-15 00:19:42'),(2577,'Inbound',NULL,'Completed','452721020.999.D140115.T0332052.P.OUT','01:56:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:43:33',1,'2014-01-23 03:43:33'),(2799,'Inbound',NULL,'Completed','452721020.I834.D140214.T1848384.P.OUT','18:39:00','2014-02-14','','CMSFFM','452721020',0,'2014-02-14 21:30:02',0,'2014-02-14 21:32:29'),(1450,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112544.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:55',NULL,'2014-01-05 17:26:57'),(1682,'OutBound','7258','Completed','452721020.DSH.IC834.D140114.T230650596.P.IN','23:06:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:50',1,'2014-01-14 23:06:51'),(2360,'OutBound','1782','Completed','452721020.DSH.IC834.D140115.T090313968.P.IN','09:03:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:14',1,'2014-01-15 09:03:14'),(2393,'OutBound','5161','Completed','452721020.DSH.IC834.D140115.T090334412.P.IN','09:03:34','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:34',1,'2014-01-15 09:03:34'),(2721,'Inbound',NULL,'Completed','452721020.999.D140114.T2339267.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 07:07:12',NULL,'2014-01-23 07:07:13'),(181,'OutBound','348','Completed','452721020.DSH.IC834.D131227.T145204788.P.IN','14:52:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:52:05',1,'2013-12-27 19:52:05'),(1255,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112270.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:11',NULL,'2014-01-05 16:58:13'),(2130,'OutBound','2059','Completed','452721020.DSH.IC834.D140115.T001718768.P.IN','00:17:18','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:18',1,'2014-01-15 00:17:19'),(2642,'Inbound',NULL,'Completed','452721020.999.D140115.T0122348.P.OUT','00:12:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:18:35',1,'2014-01-23 04:18:35'),(157,'OutBound','4808','Completed','452721020.DSH.IC834.D131227.T111516204.P.IN','11:15:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:15:16',1,'2013-12-27 16:15:16'),(54,'Inbound',NULL,'Completed','452721020.I834.D131002.T1806472.P.OUT','18:00:00','2013-10-02','','CMSFFM','452721020',0,'2013-12-26 00:17:01',NULL,'2013-12-26 00:17:18'),(369,'OutBound','5302','Completed','452721020.DSH.IC834.D131227.T162452363.P.IN','16:24:52','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:24:52',1,'2013-12-27 21:24:53'),(1285,'Inbound',NULL,'Completed','452721020.999.D131228.T1112440.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:34',NULL,'2014-01-05 16:59:37'),(2687,'Inbound',NULL,'Completed','452721020.999.D140115.T0149470.P.OUT','00:05:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 05:30:02',NULL,'2014-01-23 05:30:02'),(1729,'OutBound','1007','Completed','452721020.DSH.IC834.D140114.T230748639.P.IN','23:07:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:48',1,'2014-01-14 23:07:49'),(1846,'OutBound','5159','Completed','452721020.DSH.IC834.D140114.T231021242.P.IN','23:10:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:21',1,'2014-01-14 23:10:22'),(2494,'OutBound','689','Completed','452721020.DSH.IC834.D140115.T090446597.P.IN','09:04:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:46',1,'2014-01-15 09:04:47'),(2730,'Inbound',NULL,'Completed','452721020.999.D140115.T0329316.P.OUT','02:34:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 09:00:02',NULL,'2014-01-23 09:00:03'),(156,'OutBound','338','Completed','452721020.DSH.IC834.D131227.T111354978.P.IN','11:13:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:13:55',1,'2013-12-27 16:13:55'),(1410,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112427.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:04',NULL,'2014-01-05 17:25:06'),(253,'OutBound','2606','Completed','452721020.DSH.IC834.D131227.T152140989.P.IN','15:21:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:21:41',1,'2013-12-27 20:21:41'),(294,'OutBound','2971','Completed','452721020.DSH.IC834.D131227.T153431130.P.IN','15:34:31','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:34:31',1,'2013-12-27 20:34:31'),(427,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.064246282.P.IN','06:42:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:42:46',NULL,NULL),(2840,'OutBound',NULL,'InProgress','A834M.140228.0939.edi','09:39:18','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:39:18',NULL,NULL),(161,'OutBound','1569','Completed','452721020.DSH.IC834.D131227.T112004510.P.IN','11:20:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:20:04',1,'2013-12-27 16:20:05'),(396,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061127944.P.IN','06:11:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:11:27',NULL,NULL),(1555,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114107.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:47',NULL,'2014-01-13 03:03:47'),(2039,'OutBound','2218','Completed','452721020.DSH.IC834.D140114.T231635999.P.IN','23:16:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:36',1,'2014-01-14 23:16:37'),(2312,'OutBound','3906','Completed','452721020.DSH.IC834.D140115.T090247148.P.IN','09:02:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:47',1,'2014-01-15 09:02:47'),(2431,'OutBound','3168','Completed','452721020.DSH.IC834.D140115.T090400766.P.IN','09:04:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:00',1,'2014-01-15 09:04:01'),(2848,'Inbound',NULL,'Completed','452721020.CIC834.D140306.T1852240.P.OUT','18:46:00','2014-03-06','','CMSFFM','452721020',0,'2014-03-06 21:30:02',0,'2014-03-06 21:30:25'),(358,'OutBound','1951','Completed','452721020.DSH.IC834.D131227.T161047854.P.IN','16:10:47','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:10:48',1,'2013-12-27 21:10:48'),(1195,'Inbound',NULL,'Completed','452721020.999.D131228.T1113057.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:48',NULL,'2014-01-05 16:53:51'),(1444,'Inbound',NULL,'Completed','452721020.999.D131228.T1113365.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:38',NULL,'2014-01-05 17:26:41'),(263,'OutBound','419','Completed','452721020.DSH.IC834.D131227.T152554709.P.IN','15:25:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:25:55',1,'2013-12-27 20:25:55'),(1476,'Inbound',NULL,'InProgress','452721020.I834.D140110.T1833415.P.OUT','18:26:00','2014-01-10','','CMSFFM','452721020',0,'2014-01-13 02:23:09',NULL,NULL),(2105,'OutBound','2339','Completed','452721020.DSH.IC834.D140114.T231800817.P.IN','23:18:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:00',1,'2014-01-14 23:18:01'),(2738,'Inbound',NULL,'Completed','452721020.999.D140115.T0323168.P.OUT','02:12:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 10:30:02',NULL,'2014-01-23 10:30:02'),(250,'OutBound','1848','Completed','452721020.DSH.IC834.D131227.T152005125.P.IN','15:20:05','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:20:05',1,'2013-12-27 20:20:05'),(1487,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113318.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:20',NULL,'2014-01-13 03:02:20'),(1953,'OutBound','3903','Completed','452721020.DSH.IC834.D140114.T231444483.P.IN','23:14:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:44',1,'2014-01-14 23:14:45'),(2076,'OutBound','379','Completed','452721020.DSH.IC834.D140114.T231721976.P.IN','23:17:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:22',1,'2014-01-14 23:17:23'),(2423,'OutBound','3605','Completed','452721020.DSH.IC834.D140115.T090355337.P.IN','09:03:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:55',1,'2014-01-15 09:03:55'),(2595,'Inbound',NULL,'Completed','452721020.999.D140115.T0322402.P.OUT','02:11:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:49:11',1,'2014-01-23 03:49:11'),(2620,'Inbound',NULL,'Completed','452721020.999.D140115.T0316413.P.OUT','02:00:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:06:53',1,'2014-01-23 04:06:54'),(321,'OutBound','4514','Completed','452721020.DSH.IC834.D131227.T154417300.P.IN','15:44:17','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:44:17',1,'2013-12-27 20:44:18'),(366,'OutBound','892','Completed','452721020.DSH.IC834.D131227.T161723327.P.IN','16:17:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:17:23',1,'2013-12-27 21:17:24'),(1334,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112419.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:51',NULL,'2014-01-05 17:01:53'),(1512,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502128.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:42',NULL,'2014-01-13 03:02:43'),(2379,'OutBound','5145','Completed','452721020.DSH.IC834.D140115.T090325314.P.IN','09:03:25','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:25',1,'2014-01-15 09:03:25'),(2664,'Inbound',NULL,'Completed','452721020.999.D140114.T2356571.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:45:36',1,'2014-01-23 04:45:37'),(2773,'Inbound',NULL,'Completed','452721020.I834.D140130.T1843292.P.OUT','18:35:00','2014-01-30','','CMSFFM','452721020',0,'2014-01-30 21:00:03',NULL,'2014-01-30 21:01:41'),(1235,'Inbound',NULL,'Completed','452721020.999.D131228.T1113063.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:15',NULL,'2014-01-05 16:57:17'),(2268,'OutBound','5778','Completed','452721020.DSH.IC834.D140115.T002014959.P.IN','00:20:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:15',1,'2014-01-15 00:20:15'),(442,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065757300.P.IN','06:57:57','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:57',NULL,NULL),(1170,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703119.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:52:39',NULL,'2014-01-05 16:52:41'),(1420,'Inbound',NULL,'Completed','452721020.999.D131228.T1113469.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:32',NULL,'2014-01-05 17:25:34'),(1829,'OutBound','5155','Completed','452721020.DSH.IC834.D140114.T230957469.P.IN','23:09:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:57',1,'2014-01-14 23:09:58'),(1547,'Inbound',NULL,'Completed','452721020.999.D131228.T0502326.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:39',NULL,'2014-01-13 03:03:40'),(1796,'OutBound','1984','Completed','452721020.DSH.IC834.D140114.T230917152.P.IN','23:09:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:17',1,'2014-01-14 23:09:18'),(2542,'OutBound','3258','Completed','452721020.DSH.IC834.D140120.T054422133.P.IN','05:44:22','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:22',1,'2014-01-20 05:44:22'),(1307,'Inbound',NULL,'Completed','452721020.999.D131228.T1113179.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:36',NULL,'2014-01-05 17:00:38'),(2474,'OutBound','5888','Completed','452721020.DSH.IC834.D140115.T090433527.P.IN','09:04:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:33',1,'2014-01-15 09:04:33'),(47,'Inbound',NULL,'Completed','452721020.I834.D131219.T1916448.P.OUT','19:11:00','2013-12-19','','CMSFFM','452721020',0,'2013-12-25 23:00:02',NULL,'2013-12-25 23:11:27'),(487,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104627530.P.IN','10:46:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:27',NULL,NULL),(536,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111843162.P.IN','11:18:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:18:43',NULL,NULL),(1149,'Inbound',NULL,'Completed','452721020.999.D131228.T1113362.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:41',NULL,'2014-01-05 16:51:43'),(1321,'Inbound',NULL,'Completed','452721020.999.D131228.T1113420.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:15',NULL,'2014-01-05 17:01:17'),(1659,'OutBound','2552','Completed','452721020.DSH.IC834.D140114.T230624869.P.IN','23:06:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:24',1,'2014-01-14 23:06:25'),(2568,'Inbound',NULL,'Completed','452721020.999.D140114.T2328473.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:41:26',1,'2014-01-23 03:41:26'),(1269,'Inbound',NULL,'Completed','452721020.999.D131228.T1113327.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:50',NULL,'2014-01-05 16:58:52'),(2678,'Inbound',NULL,'Completed','452721020.999.D140114.T2357102.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:02:13',1,'2014-01-23 05:02:13'),(1704,'OutBound','2240','Completed','452721020.DSH.IC834.D140114.T230718428.P.IN','23:07:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:18',1,'2014-01-14 23:07:19'),(2006,'OutBound','4850','Completed','452721020.DSH.IC834.D140114.T231552951.P.IN','23:15:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:53',1,'2014-01-14 23:15:53'),(1120,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113417.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:21',NULL,'2014-01-05 16:50:24'),(1127,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502222.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:41',NULL,'2014-01-05 16:50:43'),(1913,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140114.T231151960.P.IN','23:11:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:52',NULL,NULL),(200,'OutBound','331','Completed','452721020.DSH.IC834.D131227.T145858752.P.IN','14:58:58','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:58:59',1,'2013-12-27 19:58:59'),(207,'OutBound','555','Completed','452721020.DSH.IC834.D131227.T150359506.P.IN','15:03:59','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:03:59',1,'2013-12-27 20:04:00'),(414,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063143496.P.IN','06:31:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:31:43',NULL,NULL),(1661,'OutBound','1653','Completed','452721020.DSH.IC834.D140114.T230627599.P.IN','23:06:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:27',1,'2014-01-14 23:06:27'),(1768,'OutBound','2339','Completed','452721020.DSH.IC834.D140114.T230838195.P.IN','23:08:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:38',1,'2014-01-14 23:08:39'),(2404,'OutBound','3118','Completed','452721020.DSH.IC834.D140115.T090341471.P.IN','09:03:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:41',1,'2014-01-15 09:03:42'),(8,'Inbound',NULL,'Completed','452721020.I834.D131031.T1815130.P.OUT','18:04:00','2013-10-31','','CMSFFM','452721020',0,'2013-12-25 18:08:52',NULL,'2013-12-25 18:10:34'),(160,'OutBound','3963','Completed','452721020.DSH.IC834.D131227.T111907288.P.IN','11:19:07','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:19:07',1,'2013-12-27 16:19:08'),(2435,'OutBound','3167','Completed','452721020.DSH.IC834.D140115.T090403472.P.IN','09:04:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:03',1,'2014-01-15 09:04:05'),(2845,'Inbound',NULL,'Completed','452721020.CIC834.D140305.T1851530.P.OUT','18:46:00','2014-03-05','','CMSFFM','452721020',0,'2014-03-05 21:00:10',0,'2014-03-05 21:00:33'),(392,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060926274.P.IN','06:09:26','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:09:26',NULL,NULL),(1178,'Inbound',NULL,'Completed','452721020.999.D131228.T1112584.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:01',NULL,'2014-01-05 16:53:03'),(1479,'Inbound',NULL,'Completed','452721020.999.D131228.T1113124.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:13',NULL,'2014-01-13 03:02:13'),(1652,'OutBound','7688','Completed','452721020.DSH.IC834.D140114.T230612981.P.IN','23:06:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:13',1,'2014-01-14 23:06:13'),(2260,'OutBound','5784','Completed','452721020.DSH.IC834.D140115.T002005226.P.IN','00:20:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:05',1,'2014-01-15 00:20:06'),(2744,'Inbound',NULL,'Completed','452721020.999.D140115.T0148340.P.OUT','00:05:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 13:30:02',NULL,'2014-01-23 13:30:03'),(357,'OutBound','4983','Completed','452721020.DSH.IC834.D131227.T160949263.P.IN','16:09:49','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:09:49',1,'2013-12-27 21:09:50'),(554,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113728451.T.IN','11:37:28','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:28',NULL,NULL),(1174,'Inbound',NULL,'Completed','452721020.999.D131228.T1113159.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:50',NULL,'2014-01-05 16:52:52'),(1922,'OutBound','2421','Completed','452721020.DSH.IC834.D140114.T231409685.P.IN','23:14:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:09',1,'2014-01-14 23:14:10'),(2022,'OutBound','4496','Completed','452721020.DSH.IC834.D140114.T231613339.P.IN','23:16:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:13',1,'2014-01-14 23:16:14'),(2649,'Inbound',NULL,'Completed','452721020.999.D140115.T0057525.P.OUT','23:44:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:22:25',1,'2014-01-23 04:22:25'),(2841,'OutBound',NULL,'InProgress','A834M.140228.0957.edi','09:57:08','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:57:08',NULL,NULL),(1506,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114090.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:37',NULL,'2014-01-13 03:02:37'),(1639,'OutBound','143','Completed','452721020.DSH.IC834.D140114.T230557981.P.IN','23:05:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:58',1,'2014-01-14 23:05:59'),(2809,'Inbound',NULL,'InProgress','452721020.I834.D140219.T1845188.P.OUT','18:35:00','2014-02-19','','CMSFFM','452721020',0,'2014-02-20 03:41:42',NULL,NULL),(2347,'OutBound','1778','Completed','452721020.DSH.IC834.D140115.T090306556.P.IN','09:03:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:06',1,'2014-01-15 09:03:06'),(1132,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703160.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:50:54',NULL,'2014-01-05 16:50:57'),(1891,'OutBound','3169','Completed','452721020.DSH.IC834.D140114.T231121955.P.IN','23:11:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:22',1,'2014-01-14 23:11:23'),(2227,'OutBound','3011','Completed','452721020.DSH.IC834.D140115.T001921645.P.IN','00:19:21','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:21',1,'2014-01-15 00:19:21'),(2706,'Inbound',NULL,'Completed','452721020.999.D140115.T0344134.P.OUT','02:41:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:44:43',NULL,'2014-01-23 06:44:44'),(178,'OutBound','333','Completed','452721020.DSH.IC834.D131227.T145131560.P.IN','14:51:31','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:51:31',1,'2013-12-27 19:51:32'),(217,'OutBound','6055','Completed','452721020.DSH.IC834.D131227.T150914628.P.IN','15:09:14','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:09:14',1,'2013-12-27 20:09:15'),(1413,'Inbound',NULL,'Completed','452721020.999.D131228.T1112317.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:12',NULL,'2014-01-05 17:25:14'),(1991,'OutBound','6019','Completed','452721020.DSH.IC834.D140114.T231527832.P.IN','23:15:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:27',1,'2014-01-14 23:15:29'),(2657,'Inbound',NULL,'Completed','452721020.999.D140115.T0229195.P.OUT','00:09:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:31:51',1,'2014-01-23 04:31:52'),(1442,'Inbound',NULL,'Completed','452721020.999.D131228.T1113182.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:33',NULL,'2014-01-05 17:26:35'),(1650,'OutBound','7723','Completed','452721020.DSH.IC834.D140114.T230610807.P.IN','23:06:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:10',1,'2014-01-14 23:06:11'),(1887,'OutBound','3605','Completed','452721020.DSH.IC834.D140114.T231115894.P.IN','23:11:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:16',1,'2014-01-14 23:11:17'),(2111,'OutBound','3994','Completed','452721020.DSH.IC834.D140114.T231808978.P.IN','23:18:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:09',1,'2014-01-14 23:18:10'),(2179,'OutBound','5142','Completed','452721020.DSH.IC834.D140115.T001821685.P.IN','00:18:21','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:21',1,'2014-01-15 00:18:22'),(2321,'OutBound','2072','Completed','452721020.DSH.IC834.D140115.T090252296.P.IN','09:02:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:52',1,'2014-01-15 09:02:52'),(1125,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112184.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:35',NULL,'2014-01-05 16:50:37'),(1177,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114069.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:58',NULL,'2014-01-05 16:53:01'),(2029,'OutBound','4410','Completed','452721020.DSH.IC834.D140114.T231623417.P.IN','23:16:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:23',1,'2014-01-14 23:16:24'),(329,'OutBound','7363','Completed','452721020.DSH.IC834.D131227.T154758356.P.IN','15:47:58','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:47:58',1,'2013-12-27 20:47:59'),(395,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061002660.P.IN','06:10:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:10:03',NULL,NULL),(1423,'Inbound',NULL,'Completed','452721020.999.D131228.T1113005.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:40',NULL,'2014-01-05 17:25:42'),(345,'OutBound','2110','Completed','452721020.DSH.IC834.D131227.T155720569.P.IN','15:57:20','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:57:20',1,'2013-12-27 20:57:21'),(481,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104449765.P.IN','10:44:49','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:44:50',NULL,NULL),(2097,'OutBound','2442','Completed','452721020.DSH.IC834.D140114.T231750591.P.IN','23:17:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:50',1,'2014-01-14 23:17:51'),(1203,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703127.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:54:11',NULL,'2014-01-05 16:54:13'),(2001,'OutBound','4884','Completed','452721020.DSH.IC834.D140114.T231545674.P.IN','23:15:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:45',1,'2014-01-14 23:15:48'),(2027,'OutBound','4398','Completed','452721020.DSH.IC834.D140114.T231621797.P.IN','23:16:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:21',1,'2014-01-14 23:16:22'),(2357,'OutBound','1656','Completed','452721020.DSH.IC834.D140115.T090312239.P.IN','09:03:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:12',1,'2014-01-15 09:03:12'),(2375,'OutBound','5128','Completed','452721020.DSH.IC834.D140115.T090322790.P.IN','09:03:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:22',1,'2014-01-15 09:03:23'),(2565,'Inbound',NULL,'Completed','452721020.999.D140115.T2307090.P.OUT','23:00:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 03:39:38',NULL,'2014-01-23 03:39:38'),(2625,'Inbound',NULL,'Completed','452721020.999.D140115.T0258163.P.OUT','01:06:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:08:58',1,'2014-01-23 04:08:58'),(539,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111926681.P.IN','11:19:26','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:19:27',NULL,NULL),(1871,'OutBound','3604','Completed','452721020.DSH.IC834.D140114.T231055882.P.IN','23:10:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:55',1,'2014-01-14 23:10:56'),(211,'OutBound','4233','Completed','452721020.DSH.IC834.D131227.T150612501.P.IN','15:06:12','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:06:12',1,'2013-12-27 20:06:13'),(1218,'Inbound',NULL,'Completed','452721020.999.D131228.T1113077.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:52',NULL,'2014-01-05 16:54:55'),(1900,'OutBound','3114','Completed','452721020.DSH.IC834.D140114.T231133947.P.IN','23:11:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:34',1,'2014-01-14 23:11:34'),(1959,'OutBound','2419','Completed','452721020.DSH.IC834.D140114.T231450652.P.IN','23:14:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:50',1,'2014-01-14 23:14:51'),(2016,'OutBound','5348','Completed','452721020.DSH.IC834.D140114.T231606397.P.IN','23:16:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:06',1,'2014-01-14 23:16:07'),(2086,'OutBound','163','Completed','452721020.DSH.IC834.D140114.T231736201.P.IN','23:17:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:36',1,'2014-01-14 23:17:37'),(192,'OutBound','409','Completed','452721020.DSH.IC834.D131227.T145615238.P.IN','14:56:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:56:15',1,'2013-12-27 19:56:15'),(446,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070146120.P.IN','07:01:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:01:46',NULL,NULL),(1268,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113057.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:47',NULL,'2014-01-05 16:58:49'),(1494,'Inbound',NULL,'Completed','i452721020.999.D131228.T1232193.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:26',NULL,'2014-01-13 03:02:27'),(1780,'OutBound','3797','Completed','452721020.DSH.IC834.D140114.T230853472.P.IN','23:08:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:53',1,'2014-01-14 23:08:54'),(2055,'OutBound','1011','Completed','452721020.DSH.IC834.D140114.T231655526.P.IN','23:16:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:55',1,'2014-01-14 23:16:57'),(2297,'OutBound','684','Completed','452721020.DSH.IC834.D140115.T002050998.P.IN','00:20:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:51',1,'2014-01-15 00:20:52'),(2822,'Inbound',NULL,'Completed','452721020.CIC834.D140223.T1818176.P.OUT','18:11:00','2014-02-23','','CMSFFM','452721020',0,'2014-02-26 08:00:49',0,'2014-02-26 08:00:51'),(1206,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113212.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:19',NULL,'2014-01-05 16:54:21'),(1375,'Inbound',NULL,'Completed','452721020.999.D131228.T0502128.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:26',NULL,'2014-01-05 17:23:28'),(2152,'OutBound','1819','Completed','452721020.DSH.IC834.D140115.T001747425.P.IN','00:17:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:47',1,'2014-01-15 00:17:48'),(31,'Inbound',NULL,'Completed','452721020.I834.D131118.T1812085.P.OUT','18:07:00','2013-11-18','','CMSFFM','452721020',0,'2013-12-25 20:30:40',NULL,'2013-12-25 20:32:08'),(448,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070156348.P.IN','07:01:56','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:01:56',NULL,NULL),(1434,'Inbound',NULL,'Completed','452721020.999.D131228.T1112223.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:11',NULL,'2014-01-05 17:26:13'),(1683,'OutBound','5347','Completed','452721020.DSH.IC834.D140114.T230651740.P.IN','23:06:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:51',1,'2014-01-14 23:06:52'),(1735,'OutBound','440','Completed','452721020.DSH.IC834.D140114.T230756598.P.IN','23:07:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:56',1,'2014-01-14 23:07:58'),(2669,'Inbound',NULL,'Completed','452721020.999.D140115.T0218043.P.OUT','00:01:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:51:15',1,'2014-01-23 04:51:16'),(2747,'Inbound',NULL,'Completed','452721020.999.D140115.T0326547.P.OUT','02:20:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 15:00:02',NULL,'2014-01-23 15:00:03'),(2784,'Inbound',NULL,'Completed','452721020.I834.D140207.T1821585.P.OUT','18:14:00','2014-02-07','','CMSFFM','452721020',0,'2014-02-07 19:00:03',NULL,'2014-02-07 19:01:11'),(2340,'OutBound','1660','Completed','452721020.DSH.IC834.D140115.T090302650.P.IN','09:03:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:02',1,'2014-01-15 09:03:03'),(337,'OutBound','7358','Completed','452721020.DSH.IC834.D131227.T155028440.P.IN','15:50:28','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:50:28',1,'2013-12-27 20:50:29'),(1587,'OutBound','2517','Completed','452721020.DSH.IC834.D140114.T230456994.P.IN','23:04:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:57',1,'2014-01-14 23:04:58'),(1867,'OutBound','3649','Completed','452721020.DSH.IC834.D140114.T231050908.P.IN','23:10:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:51',1,'2014-01-14 23:10:51'),(1934,'OutBound','249','Completed','452721020.DSH.IC834.D140114.T231422316.P.IN','23:14:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:22',1,'2014-01-14 23:14:23'),(2045,'OutBound','2234','Completed','452721020.DSH.IC834.D140114.T231643276.P.IN','23:16:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:43',1,'2014-01-14 23:16:44'),(2633,'Inbound',NULL,'Completed','452721020.999.D140115.T0030402.P.OUT','23:42:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:15:07',1,'2014-01-23 04:15:08'),(2691,'Inbound',NULL,'Completed','452721020.999.D140115.T0226378.P.OUT','00:07:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:30:02',NULL,'2014-01-23 06:30:02'),(2709,'Inbound',NULL,'Completed','452721020.999.D140114.T2326098.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:45:52',NULL,'2014-01-23 06:45:52'),(1300,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502230.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:16',NULL,'2014-01-05 17:00:19'),(1717,'OutBound','1009','Completed','452721020.DSH.IC834.D140114.T230733816.P.IN','23:07:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:33',1,'2014-01-14 23:07:34'),(2098,'OutBound','2427','Completed','452721020.DSH.IC834.D140114.T231751751.P.IN','23:17:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:51',1,'2014-01-14 23:17:52'),(2309,'OutBound','3332','Completed','452721020.DSH.IC834.D140115.T002107272.P.IN','00:21:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:07',1,'2014-01-15 00:21:08'),(1472,'OutBound','5963','Completed','452721020.DSH.IC834.D140109.T102602974.P.IN','10:26:02','2014-01-09','0','452721020','CMSFFM',1,'2014-01-09 10:26:03',1,'2014-01-09 10:26:03'),(1726,'OutBound','839','Completed','452721020.DSH.IC834.D140114.T230744505.P.IN','23:07:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:44',1,'2014-01-14 23:07:45'),(2005,'OutBound','4876','Completed','452721020.DSH.IC834.D140114.T231551850.P.IN','23:15:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:51',1,'2014-01-14 23:15:52'),(2557,'Inbound',NULL,'Completed','452721020.999.D140115.T0314387.P.OUT','01:31:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 03:38:41',NULL,'2014-01-23 03:38:41'),(2621,'Inbound',NULL,'Completed','452721020.999.D140114.T2339570.P.OUT','23:21:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:07:00',1,'2014-01-23 04:07:00'),(2652,'Inbound',NULL,'Completed','452721020.999.D140115.T0037472.P.OUT','23:50:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:25:53',1,'2014-01-23 04:25:54'),(299,'OutBound','5848','Completed','452721020.DSH.IC834.D131227.T153537728.P.IN','15:35:37','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:35:38',1,'2013-12-27 20:35:38'),(355,'OutBound','3236','Completed','452721020.DSH.IC834.D131227.T160650892.P.IN','16:06:50','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:06:51',1,'2013-12-27 21:06:51'),(389,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060545419.P.IN','06:05:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:05:45',NULL,NULL),(1369,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113264.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:09',NULL,'2014-01-05 17:23:12'),(1681,'OutBound','5350','Completed','452721020.DSH.IC834.D140114.T230649458.P.IN','23:06:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:49',1,'2014-01-14 23:06:50'),(2101,'OutBound','2444','Completed','452721020.DSH.IC834.D140114.T231755830.P.IN','23:17:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:55',1,'2014-01-14 23:17:56'),(2189,'OutBound','5116','Completed','452721020.DSH.IC834.D140115.T001835832.P.IN','00:18:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:35',1,'2014-01-15 00:18:36'),(2532,'OutBound','11649','Completed','452721020.DSH.IC834.D140115.T222152277.P.IN','22:21:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:52',1,'2014-01-15 22:21:52'),(271,'OutBound','3532','Completed','452721020.DSH.IC834.D131227.T152818899.P.IN','15:28:18','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:28:19',1,'2013-12-27 20:28:19'),(1776,'OutBound','3906','Completed','452721020.DSH.IC834.D140114.T230848655.P.IN','23:08:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:48',1,'2014-01-14 23:08:49'),(2705,'Inbound',NULL,'Completed','452721020.999.D140115.T0308487.P.OUT','01:19:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:42:34',NULL,'2014-01-23 06:42:34'),(1924,'OutBound','2517','Completed','452721020.DSH.IC834.D140114.T231411871.P.IN','23:14:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:11',1,'2014-01-14 23:14:12'),(2584,'Inbound',NULL,'Completed','452721020.999.D140115.T0152424.P.OUT','00:34:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:45:04',1,'2014-01-23 03:45:05'),(2622,'Inbound',NULL,'Completed','452721020.999.D140114.T2357461.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:07:06',1,'2014-01-23 04:07:07'),(317,'OutBound','4804','Completed','452721020.DSH.IC834.D131227.T154315583.P.IN','15:43:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:15',1,'2013-12-27 20:43:16'),(505,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105301285.P.IN','10:53:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:53:01',NULL,NULL),(2057,'OutBound','3323','Completed','452721020.DSH.IC834.D140114.T231658883.P.IN','23:16:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:58',1,'2014-01-14 23:16:59'),(2346,'OutBound','1659','Completed','452721020.DSH.IC834.D140115.T090305964.P.IN','09:03:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:06',1,'2014-01-15 09:03:06'),(2766,'OutBound','5034','Completed','452721020.DSH.IC834.D140129.T134630129.P.IN','13:46:30','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:30',1,'2014-01-29 13:46:30'),(51,'Inbound',NULL,'Completed','452721020.I834.D131224.T1011331.P.OUT','03:40:00','2013-12-24','','CMSFFM','452721020',0,'2013-12-25 23:45:01',NULL,'2013-12-25 23:52:12'),(1706,'OutBound','2230','Completed','452721020.DSH.IC834.D140114.T230720899.P.IN','23:07:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:21',1,'2014-01-14 23:07:21'),(2256,'OutBound','5776','Completed','452721020.DSH.IC834.D140115.T002000140.P.IN','00:20:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:00',1,'2014-01-15 00:20:01'),(2815,'Inbound',NULL,'Completed','452721020.CIC834.D140221.T1838246.P.OUT','18:28:00','2014-02-21','','CMSFFM','452721020',0,'2014-02-21 21:30:02',0,'2014-02-21 21:30:25'),(222,'OutBound','1682','Completed','452721020.DSH.IC834.D131227.T151018195.P.IN','15:10:18','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:10:18',1,'2013-12-27 20:10:18'),(71,'Inbound',NULL,'Completed','452721020.I834.D131215.T1821463.P.OUT','18:15:00','2013-12-15','','CMSFFM','452721020',0,'2013-12-26 02:30:02',NULL,'2013-12-26 02:34:07'),(319,'OutBound','6005','Completed','452721020.DSH.IC834.D131227.T154354827.P.IN','15:43:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:55',1,'2013-12-27 20:43:55'),(1828,'OutBound','5154','Completed','452721020.DSH.IC834.D140114.T230956368.P.IN','23:09:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:56',1,'2014-01-14 23:09:57'),(2391,'OutBound','5119','Completed','452721020.DSH.IC834.D140115.T090332647.P.IN','09:03:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:32',1,'2014-01-15 09:03:33'),(2703,'Inbound',NULL,'Completed','452721020.999.D140114.T2340096.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:41:48',NULL,'2014-01-23 06:41:48'),(2837,'OutBound','21846','Completed','A834M.140228.0928.edi','09:28:48','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:28:48',0,'2014-03-04 09:28:50'),(343,'OutBound','5065','Completed','452721020.DSH.IC834.D131227.T155555928.P.IN','15:55:55','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:55:56',1,'2013-12-27 20:55:56'),(547,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113643217.T.IN','11:36:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:43',NULL,NULL),(1208,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114042.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:24',NULL,'2014-01-05 16:54:27'),(1220,'Inbound',NULL,'Completed','452721020.999.D131228.T1113127.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:58',NULL,'2014-01-05 16:55:00'),(1602,'OutBound','5267','Completed','452721020.DSH.IC834.D140114.T230514198.P.IN','23:05:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:14',1,'2014-01-14 23:05:16'),(1907,'OutBound','3010','Completed','452721020.DSH.IC834.D140114.T231143653.P.IN','23:11:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:43',1,'2014-01-14 23:11:44'),(2191,'OutBound','5136','Completed','452721020.DSH.IC834.D140115.T001838125.P.IN','00:18:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:38',1,'2014-01-15 00:18:39'),(2520,'OutBound','1506','Completed','452721020.DSH.IC834.D140115.T222146109.P.IN','22:21:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:46',1,'2014-01-15 22:21:46'),(1415,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112217.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:18',NULL,'2014-01-05 17:25:20'),(2524,'OutBound','5622','Completed','452721020.DSH.IC834.D140115.T222148288.P.IN','22:21:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:48',1,'2014-01-15 22:21:48'),(1,'Inbound',NULL,'Completed','452721020.I834.D131205.T1837345.P.OUT','18:31:00','2013-12-05','','CMSFFM','452721020',0,'2013-12-25 17:15:01',NULL,'2013-12-25 17:22:05'),(182,'OutBound','2927','Completed','452721020.DSH.IC834.D131227.T145211704.P.IN','14:52:11','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:52:12',1,'2013-12-27 19:52:12'),(1722,'OutBound','966','Completed','452721020.DSH.IC834.D140114.T230739722.P.IN','23:07:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:39',1,'2014-01-14 23:07:40'),(203,'OutBound','3468','Completed','452721020.DSH.IC834.D131227.T150016493.P.IN','15:00:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:00:16',1,'2013-12-27 20:00:17'),(1184,'Inbound',NULL,'Completed','452721020.999.D131228.T1114115.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:18',NULL,'2014-01-05 16:53:20'),(1317,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112235.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:04',NULL,'2014-01-05 17:01:06'),(2329,'OutBound','2059','Completed','452721020.DSH.IC834.D140115.T090256551.P.IN','09:02:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:56',1,'2014-01-15 09:02:56'),(2359,'OutBound','1781','Completed','452721020.DSH.IC834.D140115.T090313412.P.IN','09:03:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:13',1,'2014-01-15 09:03:13'),(2624,'Inbound',NULL,'Completed','452721020.999.D140115.T0126093.P.OUT','00:17:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:08:17',1,'2014-01-23 04:08:18'),(58,'Inbound',NULL,'Completed','452721020.I834.D131007.T1922256.P.OUT','19:14:00','2013-10-07','','CMSFFM','452721020',0,'2013-12-26 00:32:09',NULL,'2013-12-26 00:32:28'),(1851,'OutBound','5163','Completed','452721020.DSH.IC834.D140114.T231029214.P.IN','23:10:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:29',1,'2014-01-14 23:10:30'),(514,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105724195.P.IN','10:57:24','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:57:24',NULL,NULL),(533,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111037783.P.IN','11:10:37','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:38',NULL,NULL),(1710,'OutBound','2220','Completed','452721020.DSH.IC834.D140114.T230725674.P.IN','23:07:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:25',1,'2014-01-14 23:07:26'),(2067,'OutBound','840','Completed','452721020.DSH.IC834.D140114.T231710764.P.IN','23:17:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:10',1,'2014-01-14 23:17:11'),(2196,'OutBound','5140','Completed','452721020.DSH.IC834.D140115.T001844194.P.IN','00:18:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:44',1,'2014-01-15 00:18:45'),(2288,'OutBound','679','Completed','452721020.DSH.IC834.D140115.T002039640.P.IN','00:20:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:39',1,'2014-01-15 00:20:40'),(2415,'OutBound','3638','Completed','452721020.DSH.IC834.D140115.T090349391.P.IN','09:03:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:49',1,'2014-01-15 09:03:50'),(1714,'OutBound','148','Completed','452721020.DSH.IC834.D140114.T230730256.P.IN','23:07:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:30',1,'2014-01-14 23:07:31'),(1825,'OutBound','1655','Completed','452721020.DSH.IC834.D140114.T230952907.P.IN','23:09:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:53',1,'2014-01-14 23:09:53'),(1842,'OutBound','5142','Completed','452721020.DSH.IC834.D140114.T231015551.P.IN','23:10:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:15',1,'2014-01-14 23:10:16'),(425,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063857283.P.IN','06:38:57','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:38:57',NULL,NULL),(1372,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112295.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:18',NULL,'2014-01-05 17:23:20'),(210,'OutBound','5927','Completed','452721020.DSH.IC834.D131227.T150510883.P.IN','15:05:10','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:05:11',1,'2013-12-27 20:05:11'),(1751,'OutBound','114','Completed','452721020.DSH.IC834.D140114.T230817390.P.IN','23:08:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:17',1,'2014-01-14 23:08:18'),(2599,'Inbound',NULL,'Completed','452721020.999.D140114.T2331519.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:50:32',1,'2014-01-23 03:50:32'),(231,'OutBound','1736','Completed','452721020.DSH.IC834.D131227.T151334942.P.IN','15:13:34','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:13:35',1,'2013-12-27 20:13:35'),(1457,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113233.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:15',NULL,'2014-01-05 17:27:17'),(1596,'OutBound','4428','Completed','452721020.DSH.IC834.D140114.T230507137.P.IN','23:05:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:07',1,'2014-01-14 23:05:07'),(2061,'OutBound','968','Completed','452721020.DSH.IC834.D140114.T231703734.P.IN','23:17:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:03',1,'2014-01-14 23:17:04'),(2418,'OutBound','3607','Completed','452721020.DSH.IC834.D140115.T090352257.P.IN','09:03:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:52',1,'2014-01-15 09:03:52'),(2518,'OutBound','1523','Completed','452721020.DSH.IC834.D140115.T222144713.P.IN','22:21:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:44',1,'2014-01-15 22:21:45'),(2805,'Inbound',NULL,'Completed','452721020.CIC834.D140217.T1813419.P.OUT','18:05:00','2014-02-17','','CMSFFM','452721020',0,'2014-02-17 19:00:02',0,'2014-02-17 19:00:03'),(1799,'OutBound','1986','Completed','452721020.DSH.IC834.D140114.T230920872.P.IN','23:09:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:22',1,'2014-01-14 23:09:22'),(2161,'OutBound','1782','Completed','452721020.DSH.IC834.D140115.T001758827.P.IN','00:17:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:58',1,'2014-01-15 00:17:59'),(2215,'OutBound','3628','Completed','452721020.DSH.IC834.D140115.T001906106.P.IN','00:19:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:06',1,'2014-01-15 00:19:08'),(2351,'OutBound','1819','Completed','452721020.DSH.IC834.D140115.T090308718.P.IN','09:03:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:08',1,'2014-01-15 09:03:09'),(2712,'Inbound',NULL,'Completed','452721020.999.D140115.T0333473.P.OUT','02:06:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:47:42',NULL,'2014-01-23 06:47:43'),(92,'Inbound',NULL,'Completed','452721020.I834.D131224.T0310518.P.OUT','01:56:00','2013-12-24','','CMSFFM','452721020',0,'2013-12-26 12:49:39',NULL,NULL),(2094,'OutBound','2440','Completed','452721020.DSH.IC834.D140114.T231746232.P.IN','23:17:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:46',1,'2014-01-14 23:17:47'),(2099,'OutBound','5121','Completed','452721020.DSH.IC834.D140114.T231753449.P.IN','23:17:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:53',1,'2014-01-14 23:17:54'),(2681,'Inbound',NULL,'Completed','452721020.999.D140114.T2331082.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:06:28',1,'2014-01-23 05:06:28'),(1133,'Inbound',NULL,'Completed','452721020.999.D131228.T1113353.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:57',NULL,'2014-01-05 16:50:59'),(1144,'Inbound',NULL,'Completed','452721020.999.D131228.T1113596.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:27',NULL,'2014-01-05 16:51:30'),(1470,'OutBound','2118','Completed','452721020.DSH.IC834.D140107.T055804199.P.IN','05:58:04','2014-01-07','0','452721020','CMSFFM',1,'2014-01-07 10:58:04',1,'2014-01-07 10:58:05'),(2187,'OutBound','5124','Completed','452721020.DSH.IC834.D140115.T001832112.P.IN','00:18:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:32',1,'2014-01-15 00:18:33'),(2217,'OutBound','3627','Completed','452721020.DSH.IC834.D140115.T001909404.P.IN','00:19:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:09',1,'2014-01-15 00:19:10'),(2224,'OutBound','3605','Completed','452721020.DSH.IC834.D140115.T001917560.P.IN','00:19:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:17',1,'2014-01-15 00:19:18'),(2429,'OutBound','3006','Completed','452721020.DSH.IC834.D140115.T090359508.P.IN','09:03:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:59',1,'2014-01-15 09:03:59'),(2663,'Inbound',NULL,'Completed','452721020.999.D140114.T2358166.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:45:33',1,'2014-01-23 04:45:33'),(2778,'Inbound',NULL,'Completed','452721020.I834.D140204.T1837179.P.OUT','18:29:00','2014-02-04','','CMSFFM','452721020',0,'2014-02-04 21:00:03',NULL,'2014-02-04 21:01:59'),(1240,'Inbound',NULL,'Completed','452721020.999.D131228.T1113016.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:29',NULL,'2014-01-05 16:57:31'),(1310,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112516.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:44',NULL,'2014-01-05 17:00:46'),(1609,'OutBound','4491','Completed','452721020.DSH.IC834.D140114.T230524457.P.IN','23:05:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:24',1,'2014-01-14 23:05:24'),(1670,'OutBound','4847','Completed','452721020.DSH.IC834.D140114.T230637302.P.IN','23:06:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:37',1,'2014-01-14 23:06:38'),(1964,'OutBound','7371','Completed','452721020.DSH.IC834.D140114.T231456199.P.IN','23:14:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:56',1,'2014-01-14 23:14:57'),(2307,'OutBound','3336','Completed','452721020.DSH.IC834.D140115.T002104832.P.IN','00:21:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:04',1,'2014-01-15 00:21:05'),(2325,'OutBound','2071','Completed','452721020.DSH.IC834.D140115.T090254330.P.IN','09:02:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:54',1,'2014-01-15 09:02:54'),(2507,'OutBound','3327','Completed','452721020.DSH.IC834.D140115.T090455503.P.IN','09:04:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:55',1,'2014-01-15 09:04:55'),(1213,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113002.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:38',NULL,'2014-01-05 16:54:41'),(2250,'OutBound','3122','Completed','452721020.DSH.IC834.D140115.T001952891.P.IN','00:19:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:53',1,'2014-01-15 00:19:53'),(2534,'OutBound','11617','Completed','452721020.DSH.IC834.D140115.T222153307.P.IN','22:21:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:53',1,'2014-01-15 22:21:53'),(2537,'OutBound','12139','Completed','452721020.DSH.IC834.D140115.T222155316.P.IN','22:21:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:55',1,'2014-01-15 22:21:55'),(2550,'OutBound','3339','Completed','452721020.DSH.IC834.D140120.T054425547.P.IN','05:44:25','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:25',1,'2014-01-20 05:44:25'),(2654,'Inbound',NULL,'Completed','452721020.999.D140115.T0205052.P.OUT','00:53:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:27:53',1,'2014-01-23 04:27:54'),(354,'OutBound','7356','Completed','452721020.DSH.IC834.D131227.T160517552.P.IN','16:05:17','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:05:17',1,'2013-12-27 21:05:18'),(1309,'Inbound',NULL,'Completed','452721020.999.D131228.T1112597.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:41',NULL,'2014-01-05 17:00:44'),(2336,'OutBound','1817','Completed','452721020.DSH.IC834.D140115.T090300499.P.IN','09:03:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:00',1,'2014-01-15 09:03:00'),(2629,'Inbound',NULL,'Completed','452721020.999.D140115.T0005040.P.OUT','23:22:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:12:40',1,'2014-01-23 04:12:40'),(204,'OutBound','5058','Completed','452721020.DSH.IC834.D131227.T150029761.P.IN','15:00:29','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:00:30',1,'2013-12-27 20:00:30'),(224,'OutBound','363','Completed','452721020.DSH.IC834.D131227.T151106785.P.IN','15:11:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:11:06',1,'2013-12-27 20:11:06'),(1666,'OutBound','4851','Completed','452721020.DSH.IC834.D140114.T230632815.P.IN','23:06:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:32',1,'2014-01-14 23:06:33'),(1880,'OutBound','3627','Completed','452721020.DSH.IC834.D140114.T231107178.P.IN','23:11:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:07',1,'2014-01-14 23:11:08'),(2713,'Inbound',NULL,'Completed','452721020.999.D140115.T0313560.P.OUT','01:53:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:48:31',NULL,'2014-01-23 06:48:31'),(246,'OutBound','2132','Completed','452721020.DSH.IC834.D131227.T151804907.P.IN','15:18:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:18:05',1,'2013-12-27 20:18:05'),(1129,'Inbound',NULL,'Completed','452721020.999.D131228.T1113194.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:46',NULL,'2014-01-05 16:50:48'),(1392,'Inbound',NULL,'Completed','452721020.999.D131228.T1113097.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:14',NULL,'2014-01-05 17:24:16'),(1519,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113472.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:10',NULL,'2014-01-13 03:03:11'),(1630,'OutBound','158','Completed','452721020.DSH.IC834.D140114.T230548167.P.IN','23:05:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:48',1,'2014-01-14 23:05:49'),(2110,'OutBound','2332','Completed','452721020.DSH.IC834.D140114.T231807674.P.IN','23:18:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:07',1,'2014-01-14 23:18:08'),(243,'OutBound','903','Completed','452721020.DSH.IC834.D131227.T151716695.P.IN','15:17:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:17:17',1,'2013-12-27 20:17:17'),(439,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065707844.P.IN','06:57:07','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:08',NULL,NULL),(496,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104801124.P.IN','10:48:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:48:01',NULL,NULL),(1429,'Inbound',NULL,'Completed','452721020.999.D131228.T1112483.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:57',NULL,'2014-01-05 17:25:59'),(1680,'OutBound','5346','Completed','452721020.DSH.IC834.D140114.T230648290.P.IN','23:06:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:48',1,'2014-01-14 23:06:49'),(1769,'OutBound','2333','Completed','452721020.DSH.IC834.D140114.T230839526.P.IN','23:08:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:39',1,'2014-01-14 23:08:40'),(2443,'OutBound','3010','Completed','452721020.DSH.IC834.D140115.T090411512.P.IN','09:04:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:11',1,'2014-01-15 09:04:11'),(1360,'Inbound',NULL,'Completed','452721020.999.D131228.T1112255.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:44',NULL,'2014-01-05 17:22:47'),(1708,'OutBound','2234','Completed','452721020.DSH.IC834.D140114.T230723222.P.IN','23:07:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:23',1,'2014-01-14 23:07:24'),(2028,'OutBound','4401','Completed','452721020.DSH.IC834.D140114.T231622242.P.IN','23:16:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:22',1,'2014-01-14 23:16:23'),(2136,'OutBound','1986','Completed','452721020.DSH.IC834.D140115.T001726331.P.IN','00:17:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:26',1,'2014-01-15 00:17:27'),(2502,'OutBound','717','Completed','452721020.DSH.IC834.D140115.T090451922.P.IN','09:04:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:52',1,'2014-01-15 09:04:52'),(2675,'Inbound',NULL,'Completed','452721020.999.D140115.T0112121.P.OUT','00:01:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 05:00:01',NULL,'2014-01-23 05:00:02'),(2771,'Inbound',NULL,'Completed','452721020.999.D140129.T1412167.P.OUT','14:05:00','2014-01-29','','CMSFFM','452721020',0,'2014-01-29 15:00:03',NULL,'2014-01-29 15:00:03'),(1957,'OutBound','2441','Completed','452721020.DSH.IC834.D140114.T231448592.P.IN','23:14:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:48',1,'2014-01-14 23:14:49'),(475,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071735411.P.IN','07:17:35','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:17:35',NULL,NULL),(1242,'Inbound',NULL,'Completed','452721020.999.D131228.T1113133.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:35',NULL,'2014-01-05 16:57:37'),(1337,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502206.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:59',NULL,'2014-01-05 17:02:02'),(1693,'OutBound','4411','Completed','452721020.DSH.IC834.D140114.T230704796.P.IN','23:07:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:04',1,'2014-01-14 23:07:05'),(1797,'OutBound','1979','Completed','452721020.DSH.IC834.D140114.T230918370.P.IN','23:09:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:18',1,'2014-01-14 23:09:19'),(2252,'OutBound','3004','Completed','452721020.DSH.IC834.D140115.T001955394.P.IN','00:19:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:55',1,'2014-01-15 00:19:56'),(269,'OutBound','772','Completed','452721020.DSH.IC834.D131227.T152745762.P.IN','15:27:45','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:27:46',1,'2013-12-27 20:27:46'),(370,'OutBound','1974','Completed','452721020.DSH.IC834.D131227.T162639860.P.IN','16:26:39','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:26:40',1,'2013-12-27 21:26:40'),(1217,'Inbound',NULL,'Completed','452721020.999.D131228.T1113405.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:50',NULL,'2014-01-05 16:54:52'),(2422,'OutBound','3637','Completed','452721020.DSH.IC834.D140115.T090354647.P.IN','09:03:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:54',1,'2014-01-15 09:03:55'),(2476,'OutBound','5979','Completed','452721020.DSH.IC834.D140115.T090434813.P.IN','09:04:34','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:34',1,'2014-01-15 09:04:35'),(490,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104710291.P.IN','10:47:10','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:10',NULL,NULL),(1250,'Inbound',NULL,'Completed','452721020.999.D131228.T1112501.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:57',NULL,'2014-01-05 16:57:59'),(1611,'OutBound','3820','Completed','452721020.DSH.IC834.D140114.T230526160.P.IN','23:05:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:26',1,'2014-01-14 23:05:27'),(2013,'OutBound','2283','Completed','452721020.DSH.IC834.D140114.T231602986.P.IN','23:16:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:03',1,'2014-01-14 23:16:03'),(2434,'OutBound','3121','Completed','452721020.DSH.IC834.D140115.T090402768.P.IN','09:04:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:02',1,'2014-01-15 09:04:03'),(209,'OutBound','1692','Completed','452721020.DSH.IC834.D131227.T150504439.P.IN','15:05:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:05:04',1,'2013-12-27 20:05:05'),(1364,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112223.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:55',NULL,'2014-01-05 17:22:58'),(1554,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113111.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:46',NULL,'2014-01-13 03:03:46'),(1784,'OutBound','1987','Completed','452721020.DSH.IC834.D140114.T230858812.P.IN','23:08:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:58',1,'2014-01-14 23:09:00'),(2302,'OutBound','720','Completed','452721020.DSH.IC834.D140115.T002057198.P.IN','00:20:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:57',1,'2014-01-15 00:20:58'),(2322,'OutBound','1981','Completed','452721020.DSH.IC834.D140115.T090252797.P.IN','09:02:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:52',1,'2014-01-15 09:02:53'),(1296,'Inbound',NULL,'Completed','452721020.999.D131228.T1112349.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:05',NULL,'2014-01-05 17:00:07'),(2012,'OutBound','7167','Completed','452721020.DSH.IC834.D140114.T231601606.P.IN','23:16:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:01',1,'2014-01-14 23:16:02'),(492,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104732195.P.IN','10:47:32','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:32',NULL,NULL),(2181,'OutBound','5115','Completed','452721020.DSH.IC834.D140115.T001823878.P.IN','00:18:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:23',1,'2014-01-15 00:18:24'),(2190,'OutBound','5152','Completed','452721020.DSH.IC834.D140115.T001837127.P.IN','00:18:37','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:37',1,'2014-01-15 00:18:37'),(2221,'OutBound','3641','Completed','452721020.DSH.IC834.D140115.T001914783.P.IN','00:19:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:14',1,'2014-01-15 00:19:15'),(2710,'Inbound',NULL,'Completed','452721020.999.D140115.T0231498.P.OUT','00:11:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:46:11',NULL,'2014-01-23 06:46:12'),(311,'OutBound','324','Completed','452721020.DSH.IC834.D131227.T154157283.P.IN','15:41:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:41:57',1,'2013-12-27 20:41:58'),(419,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063337789.P.IN','06:33:37','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:33:37',NULL,NULL),(1686,'OutBound','4497','Completed','452721020.DSH.IC834.D140114.T230656144.P.IN','23:06:56','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:56',1,'2014-01-14 23:06:57'),(1997,'OutBound','5791','Completed','452721020.DSH.IC834.D140114.T231537302.P.IN','23:15:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:37',1,'2014-01-14 23:15:38'),(2585,'Inbound',NULL,'Completed','452721020.999.D140115.T0333502.P.OUT','02:04:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:45:42',1,'2014-01-23 03:45:43'),(2693,'Inbound',NULL,'Completed','452721020.999.D140115.T0103433.P.OUT','23:54:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:38:51',NULL,'2014-01-23 06:38:52'),(2739,'Inbound',NULL,'Completed','452721020.999.D140115.T0224562.P.OUT','00:08:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 11:00:02',NULL,'2014-01-23 11:00:03'),(456,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070745474.P.IN','07:07:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:07:45',NULL,NULL),(529,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110947494.P.IN','11:09:47','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:47',NULL,NULL),(1483,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113349.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:16',NULL,'2014-01-13 03:02:17'),(1675,'OutBound','7167','Completed','452721020.DSH.IC834.D140114.T230642826.P.IN','23:06:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:42',1,'2014-01-14 23:06:43'),(1642,'OutBound','122','Completed','452721020.DSH.IC834.D140114.T230601878.P.IN','23:06:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:01',1,'2014-01-14 23:06:02'),(1872,'OutBound','3633','Completed','452721020.DSH.IC834.D140114.T231057204.P.IN','23:10:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:57',1,'2014-01-14 23:10:58'),(2205,'OutBound','3118','Completed','452721020.DSH.IC834.D140115.T001854685.P.IN','00:18:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:54',1,'2014-01-15 00:18:55'),(312,'OutBound','7222','Completed','452721020.DSH.IC834.D131227.T154210960.P.IN','15:42:10','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:42:11',1,'2013-12-27 20:42:11'),(381,'Inbound',NULL,'Completed','452721020.I834.D131228.T1821320.P.OUT','18:14:00','2013-12-28','','CMSFFM','452721020',1,'2013-12-29 11:07:21',1,'2013-12-29 11:10:29'),(2025,'OutBound','4494','Completed','452721020.DSH.IC834.D140114.T231617282.P.IN','23:16:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:17',1,'2014-01-14 23:16:18'),(362,'OutBound','5326','Completed','452721020.DSH.IC834.D131227.T161341765.P.IN','16:13:41','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:13:42',1,'2013-12-27 21:13:42'),(1326,'Inbound',NULL,'Completed','452721020.999.D131228.T1113291.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:29',NULL,'2014-01-05 17:01:31'),(1594,'OutBound','5305','Completed','452721020.DSH.IC834.D140114.T230505104.P.IN','23:05:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:05',1,'2014-01-14 23:05:05'),(1412,'Inbound',NULL,'Completed','452721020.999.D131228.T1114055.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:09',NULL,'2014-01-05 17:25:12'),(1586,'OutBound','232','Completed','452721020.DSH.IC834.D140114.T230454891.P.IN','23:04:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:55',1,'2014-01-14 23:04:56'),(431,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065110939.P.IN','06:51:10','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:51:11',NULL,NULL),(503,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105222134.P.IN','10:52:22','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:52:22',NULL,NULL),(521,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110244282.P.IN','11:02:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:02:44',NULL,NULL),(1514,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113114.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:06',NULL,'2014-01-13 03:03:06'),(1567,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113554.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:58',NULL,'2014-01-13 03:03:58'),(1577,'OutBound','11799','Completed','452721020.DSH.IC834.D140114.T230444203.P.IN','23:04:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:44',1,'2014-01-14 23:04:45'),(1732,'OutBound','430','Completed','452721020.DSH.IC834.D140114.T230751583.P.IN','23:07:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:51',1,'2014-01-14 23:07:52'),(2270,'OutBound','5781','Completed','452721020.DSH.IC834.D140115.T002017366.P.IN','00:20:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:17',1,'2014-01-15 00:20:18'),(2430,'OutBound','3120','Completed','452721020.DSH.IC834.D140115.T090400150.P.IN','09:04:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:00',1,'2014-01-15 09:04:00'),(2740,'Inbound',NULL,'Completed','452721020.999.D140115.T0109043.P.OUT','00:00:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 11:30:02',NULL,'2014-01-23 11:30:03'),(2775,'Inbound',NULL,'Completed','452721020.I834.D140201.T1822566.P.OUT','18:14:00','2014-02-01','','CMSFFM','452721020',0,'2014-02-01 19:00:03',NULL,'2014-02-01 19:00:52'),(259,'OutBound','13','Completed','452721020.DSH.IC834.D131227.T152423307.P.IN','15:24:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:24:23',1,'2013-12-27 20:24:24'),(2366,'OutBound','5126','Completed','452721020.DSH.IC834.D140115.T090317314.P.IN','09:03:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:17',1,'2014-01-15 09:03:17'),(2656,'Inbound',NULL,'Completed','452721020.999.D140115.T0131030.P.OUT','00:22:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 04:30:02',NULL,'2014-01-23 04:30:03'),(184,'OutBound','6427','Completed','452721020.DSH.IC834.D131227.T145302964.P.IN','14:53:02','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:53:03',1,'2013-12-27 19:53:03'),(1207,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112255.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:22',NULL,'2014-01-05 16:54:24'),(1845,'OutBound','5125','Completed','452721020.DSH.IC834.D140114.T231019813.P.IN','23:10:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:19',1,'2014-01-14 23:10:21'),(2575,'Inbound',NULL,'Completed','452721020.999.D140114.T2326578.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:42:44',1,'2014-01-23 03:42:44'),(327,'OutBound','4838','Completed','452721020.DSH.IC834.D131227.T154658928.P.IN','15:46:58','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:46:59',1,'2013-12-27 20:46:59'),(455,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070718933.P.IN','07:07:18','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:07:19',NULL,NULL),(2146,'OutBound','1783','Completed','452721020.DSH.IC834.D140115.T001739452.P.IN','00:17:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:39',1,'2014-01-15 00:17:40'),(2444,'OutBound','3012','Completed','452721020.DSH.IC834.D140115.T090411662.P.IN','09:04:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:11',1,'2014-01-15 09:04:12'),(333,'OutBound','993','Completed','452721020.DSH.IC834.D131227.T154855833.P.IN','15:48:55','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:48:56',1,'2013-12-27 20:48:56'),(1385,'Inbound',NULL,'Completed','452721020.999.D131228.T1114046.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:54',NULL,'2014-01-05 17:23:56'),(1438,'Inbound',NULL,'Completed','452721020.999.D131228.T1112593.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:22',NULL,'2014-01-05 17:26:24'),(1716,'OutBound','965','Completed','452721020.DSH.IC834.D140114.T230732751.P.IN','23:07:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:32',1,'2014-01-14 23:07:33'),(2049,'OutBound','836','Completed','452721020.DSH.IC834.D140114.T231648278.P.IN','23:16:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:48',1,'2014-01-14 23:16:49'),(2644,'Inbound',NULL,'Completed','452721020.999.D140115.T0333416.P.OUT','02:01:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:20:36',1,'2014-01-23 04:20:36'),(335,'OutBound','7696','Completed','452721020.DSH.IC834.D131227.T154935221.P.IN','15:49:35','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:49:35',1,'2013-12-27 20:49:35'),(1248,'Inbound',NULL,'Completed','452721020.999.D131228.T0502206.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:51',NULL,'2014-01-05 16:57:54'),(1689,'OutBound','4517','Completed','452721020.DSH.IC834.D140114.T230659648.P.IN','23:06:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:59',1,'2014-01-14 23:07:00'),(2473,'OutBound','5887','Completed','452721020.DSH.IC834.D140115.T090432951.P.IN','09:04:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:33',1,'2014-01-15 09:04:33'),(218,'OutBound','3786','Completed','452721020.DSH.IC834.D131227.T150915195.P.IN','15:09:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:09:15',1,'2013-12-27 20:09:16'),(254,'OutBound','1941','Completed','452721020.DSH.IC834.D131227.T152218860.P.IN','15:22:18','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:22:19',1,'2013-12-27 20:22:19'),(67,'Inbound',NULL,'Completed','452721020.I834.D131225.T1843110.P.OUT','18:35:00','2013-12-25','','CMSFFM','452721020',0,'2013-12-26 01:45:01',NULL,'2013-12-26 01:52:47'),(99,'Inbound',NULL,'Completed','452721020.I834.D131226.T1847294.P.OUT','18:41:00','2013-12-26','','CMSFFM','452721020',0,'2013-12-27 02:00:02',NULL,'2013-12-27 02:08:07'),(1425,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113028.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:46',NULL,'2014-01-05 17:25:48'),(1624,'OutBound','2338','Completed','452721020.DSH.IC834.D140114.T230541626.P.IN','23:05:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:41',1,'2014-01-14 23:05:42'),(2213,'OutBound','3647','Completed','452721020.DSH.IC834.D140115.T001903780.P.IN','00:19:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:03',1,'2014-01-15 00:19:04'),(44,'Inbound',NULL,'Completed','452721020.I834.D131004.T1806366.P.OUT','18:00:00','2013-10-04','','CMSFFM','452721020',0,'2013-12-25 22:31:19',NULL,'2013-12-25 22:31:41'),(1131,'Inbound',NULL,'Completed','452721020.999.D131228.T1112320.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:52',NULL,'2014-01-05 16:50:54'),(1440,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112483.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:27',NULL,'2014-01-05 17:26:30'),(2279,'OutBound','5883','Completed','452721020.DSH.IC834.D140115.T002028291.P.IN','00:20:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:28',1,'2014-01-15 00:20:29'),(1201,'Inbound',NULL,'Completed','452721020.999.D131228.T1112232.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:05',NULL,'2014-01-05 16:54:07'),(1311,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113255.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:47',NULL,'2014-01-05 17:00:49'),(2106,'OutBound','2333','Completed','452721020.DSH.IC834.D140114.T231802713.P.IN','23:18:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:02',1,'2014-01-14 23:18:03'),(2451,'OutBound','3004','Completed','452721020.DSH.IC834.D140115.T090416872.P.IN','09:04:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:17',1,'2014-01-15 09:04:17'),(82,'Inbound',NULL,'Completed','452721020.I834.D131221.T1842270.P.OUT','18:37:00','2013-12-21','','CMSFFM','452721020',0,'2013-12-26 04:30:01',NULL,'2013-12-26 04:40:06'),(551,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113644950.T.IN','11:36:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:45',NULL,NULL),(1119,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502329.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:19',NULL,'2014-01-05 16:50:21'),(1211,'Inbound',NULL,'Completed','452721020.999.D131228.T1232188.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:33',NULL,'2014-01-05 16:54:35'),(567,'OutBound','7120','Completed','452721020.DSH.IC834.D140102.T114109831.P.IN','11:41:09','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:10',1,'2014-01-02 16:41:10'),(1230,'Inbound',NULL,'Completed','452721020.999.D131228.T1112360.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:30',NULL,'2014-01-05 16:55:32'),(1511,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114104.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:41',NULL,'2014-01-13 03:02:42'),(1889,'OutBound','3115','Completed','452721020.DSH.IC834.D140114.T231119467.P.IN','23:11:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:19',1,'2014-01-14 23:11:20'),(2552,'Inbound',NULL,'Completed','452721020.I834.D140118.T1817577.P.OUT','18:11:00','2014-01-18','','CMSFFM','452721020',0,'2014-01-21 08:44:11',NULL,'2014-01-21 08:44:48'),(2426,'OutBound','3011','Completed','452721020.DSH.IC834.D140115.T090357416.P.IN','09:03:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:57',1,'2014-01-15 09:03:57'),(2638,'Inbound',NULL,'Completed','452721020.999.D140114.T2359462.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:17:32',1,'2014-01-23 04:17:33'),(1139,'Inbound',NULL,'Completed','452721020.999.D131228.T1112343.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:14',NULL,'2014-01-05 16:51:16'),(2856,'Inbound',NULL,'Completed','452721020.CIC834.D140310.T1924039.P.OUT','19:17:00','2014-03-10','','CMSFFM','452721020',0,'2014-03-10 21:29:57',0,'2014-03-10 21:30:18'),(463,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071404398.P.IN','07:14:04','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:14:04',NULL,NULL),(1646,'OutBound','113','Completed','452721020.DSH.IC834.D140114.T230606550.P.IN','23:06:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:06',1,'2014-01-14 23:06:07'),(2126,'OutBound','2071','Completed','452721020.DSH.IC834.D140115.T001714138.P.IN','00:17:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:14',1,'2014-01-15 00:17:15'),(2491,'OutBound','678','Completed','452721020.DSH.IC834.D140115.T090444725.P.IN','09:04:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:44',1,'2014-01-15 09:04:45'),(2658,'Inbound',NULL,'Completed','452721020.999.D140115.T0054095.P.OUT','23:36:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:33:10',1,'2014-01-23 04:33:11'),(2680,'Inbound',NULL,'Completed','452721020.999.D140115.T0103593.P.OUT','00:00:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 05:03:21',1,'2014-01-23 05:03:22'),(21,'Inbound',NULL,'Completed','452721020.I834.D131210.T1827208.P.OUT','18:21:00','2013-12-10','','CMSFFM','452721020',0,'2013-12-25 19:15:02',NULL,'2013-12-25 19:21:11'),(1346,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112315.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:24',NULL,'2014-01-05 17:02:27'),(1374,'Inbound',NULL,'Completed','452721020.999.D131228.T1113321.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:23',NULL,'2014-01-05 17:23:26'),(1644,'OutBound','116','Completed','452721020.DSH.IC834.D140114.T230604125.P.IN','23:06:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:04',1,'2014-01-14 23:06:04'),(2503,'OutBound','10927','Completed','452721020.DSH.IC834.D140115.T090452583.P.IN','09:04:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:52',1,'2014-01-15 09:04:53'),(1504,'Inbound',NULL,'Completed','452721020.999.D131228.T1112249.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:35',NULL,'2014-01-13 03:02:36'),(1616,'OutBound','3903','Completed','452721020.DSH.IC834.D140114.T230531845.P.IN','23:05:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:31',1,'2014-01-14 23:05:32'),(2723,'Inbound',NULL,'Completed','452721020.999.D140115.T0114056.P.OUT','00:03:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 07:30:02',NULL,'2014-01-23 07:30:02'),(1409,'Inbound',NULL,'Completed','452721020.999.D131228.T1113585.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:01',NULL,'2014-01-05 17:25:03'),(55,'Inbound',NULL,'Completed','452721020.I834.D131023.T1807161.P.OUT','18:01:00','2013-10-23','','CMSFFM','452721020',0,'2013-12-26 00:30:02',NULL,'2013-12-26 00:30:32'),(167,'OutBound','2113','Completed','452721020.DSH.IC834.D131227.T143828229.P.IN','14:38:28','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:38:28',1,'2013-12-27 19:38:28'),(1366,'Inbound',NULL,'Completed','452721020.999.D131228.T0502196.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:01',NULL,'2014-01-05 17:23:03'),(1394,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112249.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:19',NULL,'2014-01-05 17:24:21'),(1748,'OutBound','125','Completed','452721020.DSH.IC834.D140114.T230813558.P.IN','23:08:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:13',1,'2014-01-14 23:08:14'),(1838,'OutBound','5135','Completed','452721020.DSH.IC834.D140114.T231010194.P.IN','23:10:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:10',1,'2014-01-14 23:10:11'),(1861,'OutBound','5158','Completed','452721020.DSH.IC834.D140114.T231042589.P.IN','23:10:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:42',1,'2014-01-14 23:10:43'),(1998,'OutBound','1653','Completed','452721020.DSH.IC834.D140114.T231539104.P.IN','23:15:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:39',1,'2014-01-14 23:15:40'),(2052,'OutBound','838','Completed','452721020.DSH.IC834.D140114.T231652106.P.IN','23:16:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:52',1,'2014-01-14 23:16:53'),(1475,'Inbound',NULL,'Completed','452721020.I834.D140108.T1833084.P.OUT','18:27:00','2014-01-08','','CMSFFM','452721020',0,'2014-01-13 02:21:08',NULL,'2014-01-13 02:22:48'),(2470,'OutBound','5804','Completed','452721020.DSH.IC834.D140115.T090431208.P.IN','09:04:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:31',1,'2014-01-15 09:04:31'),(2588,'Inbound',NULL,'Completed','452721020.999.D140115.T0143536.P.OUT','00:27:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:46:43',1,'2014-01-23 03:46:44'),(189,'OutBound','4986','Completed','452721020.DSH.IC834.D131227.T145457400.P.IN','14:54:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:54:57',1,'2013-12-27 19:54:58'),(228,'OutBound','2310','Completed','452721020.DSH.IC834.D131227.T151250772.P.IN','15:12:50','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:12:51',1,'2013-12-27 20:12:51'),(383,'Inbound',NULL,'Completed','452721020.I834.D131229.T1817204.P.OUT','18:10:00','2013-12-29','','CMSFFM','452721020',0,'2013-12-30 00:00:01',NULL,'2013-12-30 00:02:29'),(485,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104615720.P.IN','10:46:15','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:15',NULL,NULL),(1700,'OutBound','2631','Completed','452721020.DSH.IC834.D140114.T230713776.P.IN','23:07:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:13',1,'2014-01-14 23:07:14'),(2323,'OutBound','2056','Completed','452721020.DSH.IC834.D140115.T090253296.P.IN','09:02:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:53',1,'2014-01-15 09:02:53'),(2827,'Inbound',NULL,'Completed','452721020.CIC834.D140226.T1847391.P.OUT','18:39:00','2014-02-26','','CMSFFM','452721020',0,'2014-02-28 07:00:03',0,'2014-02-28 07:00:42'),(545,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113642894.T.IN','11:36:42','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:42',NULL,NULL),(571,'Inbound',NULL,'Completed','452721020.I834.D140104.T1823002.P.OUT','18:14:00','2014-01-04','','CMSFFM','452721020',0,'2014-01-05 00:00:01',NULL,'2014-01-05 00:02:59'),(1404,'Inbound',NULL,'Completed','452721020.999.D131228.T1112448.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:47',NULL,'2014-01-05 17:24:49'),(1625,'OutBound','2335','Completed','452721020.DSH.IC834.D140114.T230542706.P.IN','23:05:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:42',1,'2014-01-14 23:05:43'),(1734,'OutBound','380','Completed','452721020.DSH.IC834.D140114.T230753907.P.IN','23:07:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:54',1,'2014-01-14 23:07:55'),(288,'OutBound','2160','Completed','452721020.DSH.IC834.D131227.T153311540.P.IN','15:33:11','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:33:11',1,'2013-12-27 20:33:12'),(1532,'Inbound',NULL,'Completed','452721020.999.D131228.T1113510.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:25',NULL,'2014-01-13 03:03:26'),(1698,'OutBound','2627','Completed','452721020.DSH.IC834.D140114.T230711285.P.IN','23:07:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:11',1,'2014-01-14 23:07:12'),(1759,'OutBound','2422','Completed','452721020.DSH.IC834.D140114.T230827265.P.IN','23:08:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:27',1,'2014-01-14 23:08:28'),(1978,'OutBound','123','Completed','452721020.DSH.IC834.D140114.T231512607.P.IN','23:15:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:12',1,'2014-01-14 23:15:13'),(2210,'OutBound','3636','Completed','452721020.DSH.IC834.D140115.T001900351.P.IN','00:19:00','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:00',1,'2014-01-15 00:19:01'),(2540,'Inbound',NULL,'Completed','452721020.I834.D140116.T1853457.P.OUT','18:41:00','2014-01-16','','CMSFFM','452721020',0,'2014-01-17 03:35:01',NULL,'2014-01-17 03:36:43'),(14,'Inbound',NULL,'Completed','452721020.I834.D131129.T1812296.P.OUT','18:04:00','2013-11-29','','CMSFFM','452721020',0,'2013-12-25 18:30:01',NULL,'2013-12-25 18:31:07'),(1284,'Inbound',NULL,'Completed','452721020.999.D131228.T1113442.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:32',NULL,'2014-01-05 16:59:34'),(2334,'OutBound','5878','Completed','452721020.DSH.IC834.D140115.T090259337.P.IN','09:02:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:59',1,'2014-01-15 09:02:59'),(2380,'OutBound','5115','Completed','452721020.DSH.IC834.D140115.T090325865.P.IN','09:03:25','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:26',1,'2014-01-15 09:03:26'),(1501,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502169.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:32',NULL,'2014-01-13 03:02:33'),(1707,'OutBound','2222','Completed','452721020.DSH.IC834.D140114.T230722139.P.IN','23:07:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:22',1,'2014-01-14 23:07:23'),(2015,'OutBound','2292','Completed','452721020.DSH.IC834.D140114.T231605245.P.IN','23:16:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:05',1,'2014-01-14 23:16:06'),(2425,'OutBound','3115','Completed','452721020.DSH.IC834.D140115.T090356677.P.IN','09:03:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:56',1,'2014-01-15 09:03:57'),(2485,'OutBound','705','Completed','452721020.DSH.IC834.D140115.T090440493.P.IN','09:04:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:40',1,'2014-01-15 09:04:40'),(1164,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113174.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:23',NULL,'2014-01-05 16:52:25'),(1186,'Inbound',NULL,'Completed','452721020.999.D131228.T1112367.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:23',NULL,'2014-01-05 16:53:25'),(1348,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114057.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:30',NULL,'2014-01-05 17:02:32'),(1464,'Inbound',NULL,'Completed','452721020.999.D131228.T1113227.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:34',NULL,'2014-01-05 17:27:36'),(1853,'OutBound','5152','Completed','452721020.DSH.IC834.D140114.T231031799.P.IN','23:10:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:31',1,'2014-01-14 23:10:32'),(2639,'Inbound',NULL,'Completed','452721020.999.D140114.T2324130.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:17:38',1,'2014-01-23 04:17:39'),(2757,'Inbound',NULL,'Completed','452721020.I834.D140125.T1817305.P.OUT','18:11:00','2014-01-25','','CMSFFM','452721020',0,'2014-01-25 19:00:02',NULL,'2014-01-25 19:00:21'),(2831,'Inbound',NULL,'Completed','452721020.CIC834.D140301.T1827290.P.OUT','18:21:00','2014-03-01','','CMSFFM','452721020',0,'2014-03-01 19:00:01',0,'2014-03-01 19:00:14'),(326,'OutBound','3061','Completed','452721020.DSH.IC834.D131227.T154642399.P.IN','15:46:42','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:46:42',1,'2013-12-27 20:46:43'),(364,'OutBound','896','Completed','452721020.DSH.IC834.D131227.T161540324.P.IN','16:15:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:15:40',1,'2013-12-27 21:15:41'),(2457,'OutBound','5811','Completed','452721020.DSH.IC834.D140115.T090421543.P.IN','09:04:21','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:21',1,'2014-01-15 09:04:22'),(2605,'Inbound',NULL,'Completed','452721020.999.D140115.T1038262.P.OUT','09:47:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:53:21',1,'2014-01-23 03:53:21'),(2666,'Inbound',NULL,'Completed','452721020.999.D140115.T1037267.P.OUT','09:49:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:46:06',1,'2014-01-23 04:46:07'),(386,'Inbound',NULL,'Completed','452721020.I834.D140101.T1827283.P.OUT','18:18:00','2014-01-01','','CMSFFM','452721020',1,'2014-01-02 04:21:42',1,'2014-01-02 04:25:53'),(1388,'Inbound',NULL,'Completed','452721020.999.D131228.T1113306.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:02',NULL,'2014-01-05 17:24:05'),(1568,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114046.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:58',NULL,'2014-01-13 03:03:59'),(1667,'OutBound','4849','Completed','452721020.DSH.IC834.D140114.T230633912.P.IN','23:06:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:34',1,'2014-01-14 23:06:34'),(2171,'OutBound','5134','Completed','452721020.DSH.IC834.D140115.T001811332.P.IN','00:18:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:11',1,'2014-01-15 00:18:12'),(2339,'OutBound','1827','Completed','452721020.DSH.IC834.D140115.T090302112.P.IN','09:03:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:02',1,'2014-01-15 09:03:02'),(2487,'OutBound','679','Completed','452721020.DSH.IC834.D140115.T090441985.P.IN','09:04:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:42',1,'2014-01-15 09:04:42'),(2616,'Inbound',NULL,'Completed','452721020.999.D140115.T0036409.P.OUT','23:48:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:01:11',1,'2014-01-23 04:01:11'),(187,'OutBound','3056','Completed','452721020.DSH.IC834.D131227.T145406132.P.IN','14:54:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:54:06',1,'2013-12-27 19:54:06'),(215,'OutBound','358','Completed','452721020.DSH.IC834.D131227.T150749910.P.IN','15:07:49','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:07:49',1,'2013-12-27 20:07:49'),(495,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104752234.P.IN','10:47:52','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:52',NULL,NULL),(1172,'Inbound',NULL,'Completed','452721020.999.D131228.T1112199.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:45',NULL,'2014-01-05 16:52:47'),(1756,'OutBound','119','Completed','452721020.DSH.IC834.D140114.T230823869.P.IN','23:08:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:23',1,'2014-01-14 23:08:24'),(2405,'OutBound','3655','Completed','452721020.DSH.IC834.D140115.T090342281.P.IN','09:03:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:42',1,'2014-01-15 09:03:42'),(2462,'OutBound','5777','Completed','452721020.DSH.IC834.D140115.T090425468.P.IN','09:04:25','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:25',1,'2014-01-15 09:04:25'),(2720,'Inbound',NULL,'Completed','452721020.999.D140115.T0346168.P.OUT','02:48:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 07:07:03',NULL,'2014-01-23 07:07:03'),(2745,'Inbound',NULL,'Completed','452721020.999.D140115.T0328553.P.OUT','02:28:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 14:00:02',NULL,'2014-01-23 14:00:02'),(2748,'Inbound',NULL,'Completed','452721020.999.D140115.T1038107.P.OUT','10:03:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 15:30:02',NULL,'2014-01-23 15:30:03'),(2756,'Inbound',NULL,'Completed','452721020.I834.D140124.T1833190.P.OUT','18:26:00','2014-01-24','','CMSFFM','452721020',0,'2014-01-24 21:00:02',NULL,'2014-01-24 21:01:20'),(2794,'Inbound',NULL,'Completed','452721020.CIC834.D140211.T1842515.P.OUT','18:37:00','2014-02-11','','CMSFFM','452721020',0,'2014-02-11 21:30:02',NULL,'2014-02-11 21:30:30'),(303,'OutBound','4388','Completed','452721020.DSH.IC834.D131227.T153648418.P.IN','15:36:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:36:48',1,'2013-12-27 20:36:48'),(314,'OutBound','2961','Completed','452721020.DSH.IC834.D131227.T154241208.P.IN','15:42:41','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:42:41',1,'2013-12-27 20:42:42'),(437,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065506885.P.IN','06:55:06','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:55:07',NULL,NULL),(552,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113727491.T.IN','11:37:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:27',NULL,NULL),(1197,'Inbound',NULL,'Completed','452721020.999.D131228.T1112453.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:54',NULL,'2014-01-05 16:53:56'),(1850,'OutBound','5124','Completed','452721020.DSH.IC834.D140114.T231027409.P.IN','23:10:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:27',1,'2014-01-14 23:10:29'),(2200,'OutBound','3603','Completed','452721020.DSH.IC834.D140115.T001848933.P.IN','00:18:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:49',1,'2014-01-15 00:18:49'),(1396,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112298.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:25',NULL,'2014-01-05 17:24:27'),(1600,'OutBound','6052','Completed','452721020.DSH.IC834.D140114.T230511921.P.IN','23:05:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:12',1,'2014-01-14 23:05:12'),(304,'OutBound','2406','Completed','452721020.DSH.IC834.D131227.T153733702.P.IN','15:37:33','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:37:34',1,'2013-12-27 20:37:34'),(1595,'OutBound','7255','Completed','452721020.DSH.IC834.D140114.T230506104.P.IN','23:05:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:06',1,'2014-01-14 23:05:06'),(2125,'OutBound','2055','Completed','452721020.DSH.IC834.D140115.T001713156.P.IN','00:17:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:13',1,'2014-01-15 00:17:13'),(2376,'OutBound','5150','Completed','452721020.DSH.IC834.D140115.T090323507.P.IN','09:03:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:23',1,'2014-01-15 09:03:23'),(225,'OutBound','984','Completed','452721020.DSH.IC834.D131227.T151115309.P.IN','15:11:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:11:15',1,'2013-12-27 20:11:16'),(2661,'Inbound',NULL,'Completed','452721020.999.D140115.T0340521.P.OUT','02:19:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:35:14',1,'2014-01-23 04:35:14'),(2854,'Inbound',NULL,'Completed','452721020.CIC834.D140309.T1829473.P.OUT','18:21:00','2014-03-09','','CMSFFM','452721020',0,'2014-03-09 21:29:58',0,'2014-03-09 21:30:08'),(2156,'OutBound','1823','Completed','452721020.DSH.IC834.D140115.T001752655.P.IN','00:17:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:52',1,'2014-01-15 00:17:53'),(1558,'Inbound',NULL,'Completed','452721020.999.D131228.T0502278.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:49',NULL,'2014-01-13 03:03:50'),(2382,'OutBound','5159','Completed','452721020.DSH.IC834.D140115.T090327149.P.IN','09:03:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:27',1,'2014-01-15 09:03:27'),(2541,'OutBound','3333','Completed','452721020.DSH.IC834.D140120.T054421576.P.IN','05:44:21','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:21',1,'2014-01-20 05:44:21'),(2646,'Inbound',NULL,'Completed','452721020.999.D140114.T2332499.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:21:11',1,'2014-01-23 04:21:12'),(2787,'Inbound',NULL,'Completed','452721020.CIC834.D140208.T1827226.P.OUT','18:12:00','2014-02-08','','CMSFFM','452721020',0,'2014-02-08 19:30:02',NULL,'2014-02-08 19:30:12'),(1202,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112468.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:08',NULL,'2014-01-05 16:54:10'),(1234,'Inbound',NULL,'Completed','452721020.999.D131228.T1112205.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:12',NULL,'2014-01-05 16:57:15'),(1597,'OutBound','249','Completed','452721020.DSH.IC834.D140114.T230508234.P.IN','23:05:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:08',1,'2014-01-14 23:05:09'),(1932,'OutBound','7255','Completed','452721020.DSH.IC834.D140114.T231420169.P.IN','23:14:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:20',1,'2014-01-14 23:14:20'),(2239,'OutBound','3119','Completed','452721020.DSH.IC834.D140115.T001937693.P.IN','00:19:37','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:37',1,'2014-01-15 00:19:38'),(2458,'OutBound','5786','Completed','452721020.DSH.IC834.D140115.T090422536.P.IN','09:04:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:22',1,'2014-01-15 09:04:23'),(275,'OutBound','1747','Completed','452721020.DSH.IC834.D131227.T153034843.P.IN','15:30:34','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:30:34',1,'2013-12-27 20:30:34'),(1857,'OutBound','5161','Completed','452721020.DSH.IC834.D140114.T231036996.P.IN','23:10:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:37',1,'2014-01-14 23:10:38'),(2262,'OutBound','5787','Completed','452721020.DSH.IC834.D140115.T002007600.P.IN','00:20:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:07',1,'2014-01-15 00:20:08'),(412,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063021803.P.IN','06:30:21','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:30:22',NULL,NULL),(511,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105544461.P.IN','10:55:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:44',NULL,NULL),(1657,'OutBound','6020','Completed','452721020.DSH.IC834.D140114.T230618652.P.IN','23:06:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:18',1,'2014-01-14 23:06:19'),(1952,'OutBound','3904','Completed','452721020.DSH.IC834.D140114.T231443339.P.IN','23:14:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:43',1,'2014-01-14 23:14:44'),(378,'OutBound','426','Completed','452721020.DSH.IC834.D131227.T164428585.P.IN','16:44:28','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:44:28',1,'2013-12-27 21:44:28'),(1451,'Inbound',NULL,'Completed','452721020.999.D131228.T1112217.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:58',NULL,'2014-01-05 17:27:00'),(1570,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113591.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:04:00',NULL,'2014-01-13 03:04:01'),(2607,'Inbound',NULL,'Completed','452721020.999.D140115.T0004478.P.OUT','23:22:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:54:50',1,'2014-01-23 03:54:51'),(63,'Inbound',NULL,'Completed','452721020.I834.D131125.T1817014.P.OUT','18:07:00','2013-11-25','','CMSFFM','452721020',0,'2013-12-26 01:15:02',NULL,'2013-12-26 01:17:26'),(1287,'Inbound',NULL,'Completed','452721020.999.D131228.T1113033.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:40',NULL,'2014-01-05 16:59:42'),(2640,'Inbound',NULL,'Completed','452721020.999.D140114.T2351414.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:17:41',1,'2014-01-23 04:17:42'),(56,'Inbound',NULL,'Completed','452721020.I834.D131016.T2057187.P.OUT','20:51:00','2013-10-16','','CMSFFM','452721020',0,'2013-12-26 00:30:33',NULL,'2013-12-26 00:31:16'),(1222,'Inbound',NULL,'Completed','452721020.999.D131228.T1113288.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:04',NULL,'2014-01-05 16:55:06'),(1378,'Inbound',NULL,'Completed','452721020.999.D131228.T1113490.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:35',NULL,'2014-01-05 17:23:37'),(1752,'OutBound','142','Completed','452721020.DSH.IC834.D140114.T230818669.P.IN','23:08:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:18',1,'2014-01-14 23:08:19'),(1856,'OutBound','5123','Completed','452721020.DSH.IC834.D140114.T231035718.P.IN','23:10:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:35',1,'2014-01-14 23:10:36'),(2572,'Inbound',NULL,'Completed','452721020.999.D140115.T0329134.P.OUT','02:28:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:41:55',1,'2014-01-23 03:41:57'),(519,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110009673.P.IN','11:00:09','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:00:10',NULL,NULL),(1965,'OutBound','1022','Completed','452721020.DSH.IC834.D140114.T231457299.P.IN','23:14:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:57',1,'2014-01-14 23:14:58'),(2087,'OutBound','147','Completed','452721020.DSH.IC834.D140114.T231737550.P.IN','23:17:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:37',1,'2014-01-14 23:17:38'),(1428,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112492.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:54',NULL,'2014-01-05 17:25:56'),(1893,'OutBound','3006','Completed','452721020.DSH.IC834.D140114.T231125206.P.IN','23:11:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:25',1,'2014-01-14 23:11:26'),(2192,'OutBound','5119','Completed','452721020.DSH.IC834.D140115.T001839421.P.IN','00:18:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:39',1,'2014-01-15 00:18:40'),(2762,'OutBound','3313','Completed','452721020.DSH.IC834.D140129.T134627537.P.IN','13:46:27','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:27',1,'2014-01-29 13:46:28'),(289,'OutBound','4998','Completed','452721020.DSH.IC834.D131227.T153334454.P.IN','15:33:34','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:33:34',1,'2013-12-27 20:33:35'),(371,'OutBound','5697','Completed','452721020.DSH.IC834.D131227.T162801139.P.IN','16:28:01','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:28:01',1,'2013-12-27 21:28:01'),(1253,'Inbound',NULL,'Completed','452721020.999.D131228.T1114090.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:05',NULL,'2014-01-05 16:58:08'),(1814,'OutBound','1820','Completed','452721020.DSH.IC834.D140114.T230939615.P.IN','23:09:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:39',1,'2014-01-14 23:09:40'),(2058,'OutBound','1002','Completed','452721020.DSH.IC834.D140114.T231700641.P.IN','23:17:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:00',1,'2014-01-14 23:17:01'),(166,'OutBound','3247','Completed','452721020.DSH.IC834.D131227.T143744231.P.IN','14:37:44','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:37:44',1,'2013-12-27 19:37:44'),(2120,'OutBound','1985','Completed','452721020.DSH.IC834.D140115.T001707556.P.IN','00:17:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:07',1,'2014-01-15 00:17:07'),(2131,'OutBound','2057','Completed','452721020.DSH.IC834.D140115.T001719872.P.IN','00:17:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:19',1,'2014-01-15 00:17:20'),(2459,'OutBound','5784','Completed','452721020.DSH.IC834.D140115.T090423338.P.IN','09:04:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:23',1,'2014-01-15 09:04:23'),(2499,'OutBound','670','Completed','452721020.DSH.IC834.D140115.T090449824.P.IN','09:04:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:49',1,'2014-01-15 09:04:50'),(2754,'Inbound',NULL,'Completed','452721020.999.D140115.T0226049.P.OUT','00:07:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 18:30:02',NULL,'2014-01-23 18:30:02'),(305,'OutBound','2168','Completed','452721020.DSH.IC834.D131227.T153736359.P.IN','15:37:36','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:37:36',1,'2013-12-27 20:37:37'),(2072,'OutBound','440','Completed','452721020.DSH.IC834.D140114.T231716512.P.IN','23:17:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:16',1,'2014-01-14 23:17:17'),(2149,'OutBound','1825','Completed','452721020.DSH.IC834.D140115.T001743654.P.IN','00:17:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:43',1,'2014-01-15 00:17:44'),(45,'Inbound',NULL,'Completed','452721020.I834.D131026.T1812366.P.OUT','18:04:00','2013-10-26','','CMSFFM','452721020',0,'2013-12-25 22:31:41',NULL,'2013-12-25 22:32:17'),(1175,'Inbound',NULL,'Completed','452721020.999.D131228.T1113255.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:53',NULL,'2014-01-05 16:52:55'),(1267,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112312.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:44',NULL,'2014-01-05 16:58:47'),(1276,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112343.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:09',NULL,'2014-01-05 16:59:12'),(1525,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113420.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:18',NULL,'2014-01-13 03:03:19'),(1684,'OutBound','5389','Completed','452721020.DSH.IC834.D140114.T230652809.P.IN','23:06:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:52',1,'2014-01-14 23:06:53'),(2851,'Inbound',NULL,'Completed','452721020.CIC834.D140308.T1848548.P.OUT','18:41:00','2014-03-08','','CMSFFM','452721020',0,'2014-03-08 21:00:01',0,'2014-03-08 21:00:14'),(407,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062425757.P.IN','06:24:25','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:24:26',NULL,NULL),(2080,'OutBound','429','Completed','452721020.DSH.IC834.D140114.T231728130.P.IN','23:17:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:28',1,'2014-01-14 23:17:29'),(2505,'OutBound','3257','Completed','452721020.DSH.IC834.D140115.T090454169.P.IN','09:04:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:54',1,'2014-01-15 09:04:54'),(258,'OutBound','7746','Completed','452721020.DSH.IC834.D131227.T152406522.P.IN','15:24:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:24:06',1,'2013-12-27 20:24:07'),(274,'OutBound','346','Completed','452721020.DSH.IC834.D131227.T152926642.P.IN','15:29:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:29:26',1,'2013-12-27 20:29:27'),(422,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063658394.P.IN','06:36:58','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:36:58',NULL,NULL),(2299,'OutBound','667','Completed','452721020.DSH.IC834.D140115.T002053438.P.IN','00:20:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:53',1,'2014-01-15 00:20:54'),(2441,'OutBound','3008','Completed','452721020.DSH.IC834.D140115.T090409705.P.IN','09:04:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:09',1,'2014-01-15 09:04:10'),(66,'Inbound',NULL,'Completed','452721020.I834.D131103.T1807237.P.OUT','18:02:00','2013-11-03','','CMSFFM','452721020',0,'2013-12-26 01:31:45',NULL,'2013-12-26 01:32:14'),(332,'OutBound','3472','Completed','452721020.DSH.IC834.D131227.T154840477.P.IN','15:48:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:48:40',1,'2013-12-27 20:48:41'),(525,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110907494.P.IN','11:09:07','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:07',NULL,NULL),(1205,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502326.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:16',NULL,'2014-01-05 16:54:18'),(2421,'OutBound','3657','Completed','452721020.DSH.IC834.D140115.T090354612.P.IN','09:03:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:54',1,'2014-01-15 09:03:54'),(237,'OutBound','6006','Completed','452721020.DSH.IC834.D131227.T151506965.P.IN','15:15:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:15:07',1,'2013-12-27 20:15:07'),(2686,'Inbound',NULL,'Completed','452721020.999.D140115.T0041321.P.OUT','00:00:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 05:08:10',1,'2014-01-23 05:08:10'),(1367,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112202.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:04',NULL,'2014-01-05 17:23:06'),(2798,'Inbound',NULL,'Completed','452721020.I834.D140213.T1852019.P.OUT','18:46:00','2014-02-13','','CMSFFM','452721020',0,'2014-02-13 22:00:03',NULL,'2014-02-13 22:03:22'),(186,'OutBound','3231','Completed','452721020.DSH.IC834.D131227.T145349184.P.IN','14:53:49','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:53:49',1,'2013-12-27 19:53:49'),(199,'OutBound','2135','Completed','452721020.DSH.IC834.D131227.T145851642.P.IN','14:58:51','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:58:51',1,'2013-12-27 19:58:52'),(1461,'Inbound',NULL,'Completed','452721020.999.D131228.T1114069.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:26',NULL,'2014-01-05 17:27:28'),(2069,'OutBound','430','Completed','452721020.DSH.IC834.D140114.T231713129.P.IN','23:17:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:13',1,'2014-01-14 23:17:14'),(2539,'Inbound',NULL,'Completed','452721020.I834.D140115.T1836344.P.OUT','18:30:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-16 08:44:12',NULL,'2014-01-16 08:47:31'),(391,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060748397.P.IN','06:07:48','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:07:48',NULL,NULL),(429,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.064343158.P.IN','06:43:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:43:43',NULL,NULL),(1509,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113331.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:39',NULL,'2014-01-13 03:02:40'),(2825,'Inbound',NULL,'Completed','452721020.I834.D140226.T1852059.P.OUT','18:43:00','2014-02-26','','CMSFFM','452721020',0,'2014-02-26 21:00:11',0,'2014-02-26 21:02:48'),(1403,'Inbound',NULL,'Completed','452721020.999.D131228.T1113303.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:44',NULL,'2014-01-05 17:24:46'),(1718,'OutBound','1011','Completed','452721020.DSH.IC834.D140114.T230734942.P.IN','23:07:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:35',1,'2014-01-14 23:07:35'),(1854,'OutBound','5136','Completed','452721020.DSH.IC834.D140114.T231033904.P.IN','23:10:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:33',1,'2014-01-14 23:10:34'),(2700,'Inbound',NULL,'Completed','452721020.999.D140115.T2312232.P.OUT','23:00:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:40:45',NULL,'2014-01-23 06:40:46'),(447,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070146594.P.IN','07:01:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:01:46',NULL,NULL),(1302,'Inbound',NULL,'Completed','452721020.999.D131228.T1113417.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:22',NULL,'2014-01-05 17:00:24'),(2220,'OutBound','3640','Completed','452721020.DSH.IC834.D140115.T001912960.P.IN','00:19:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:13',1,'2014-01-15 00:19:13'),(37,'Inbound',NULL,'Completed','452721020.I834.D131222.T1847208.P.OUT','18:40:00','2013-12-22','','CMSFFM','452721020',0,'2013-12-25 21:15:01',NULL,'2013-12-25 21:23:50'),(1422,'Inbound',NULL,'Completed','452721020.999.D131228.T1113002.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:37',NULL,'2014-01-05 17:25:39'),(2348,'OutBound','1825','Completed','452721020.DSH.IC834.D140115.T090307141.P.IN','09:03:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:07',1,'2014-01-15 09:03:07'),(80,'Inbound',NULL,'Completed','452721020.I834.D131218.T1856360.P.OUT','18:49:00','2013-12-18','','CMSFFM','452721020',0,'2013-12-26 04:00:01',NULL,'2013-12-26 04:10:51'),(1540,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113487.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:33',NULL,'2014-01-13 03:03:34'),(2571,'Inbound',NULL,'Completed','452721020.999.D140115.T0011516.P.OUT','23:33:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:41:37',1,'2014-01-23 03:41:38'),(2073,'OutBound','378','Completed','452721020.DSH.IC834.D140114.T231717857.P.IN','23:17:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:17',1,'2014-01-14 23:17:19'),(2439,'OutBound','3015','Completed','452721020.DSH.IC834.D140115.T090408370.P.IN','09:04:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:08',1,'2014-01-15 09:04:08'),(2647,'Inbound',NULL,'Completed','452721020.999.D140114.T2336595.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:21:16',1,'2014-01-23 04:21:17'),(2816,'Inbound',NULL,'Completed','452721020.I834.D140221.T1840174.P.OUT','18:31:00','2014-02-21','','CMSFFM','452721020',0,'2014-02-21 22:00:02',0,'2014-02-21 22:01:18'),(83,'Inbound',NULL,'Completed','452721020.I834.D131115.T1842320.P.OUT','18:34:00','2013-11-15','','CMSFFM','452721020',0,'2013-12-26 04:45:01',NULL,'2013-12-26 04:46:20'),(1496,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113510.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:28',NULL,'2014-01-13 03:02:28'),(2509,'OutBound','3328','Completed','452721020.DSH.IC834.D140115.T090456660.P.IN','09:04:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:56',1,'2014-01-15 09:04:57'),(1599,'OutBound','290','Completed','452721020.DSH.IC834.D140114.T230510830.P.IN','23:05:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:10',1,'2014-01-14 23:05:11'),(1765,'OutBound','2430','Completed','452721020.DSH.IC834.D140114.T230834513.P.IN','23:08:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:34',1,'2014-01-14 23:08:35'),(1806,'OutBound','1779','Completed','452721020.DSH.IC834.D140114.T230930374.P.IN','23:09:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:30',1,'2014-01-14 23:09:31'),(2345,'OutBound','1783','Completed','452721020.DSH.IC834.D140115.T090305398.P.IN','09:03:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:05',1,'2014-01-15 09:03:05'),(2619,'Inbound',NULL,'Completed','452721020.999.D140114.T2359179.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:06:35',1,'2014-01-23 04:06:35'),(2643,'Inbound',NULL,'Completed','452721020.999.D140115.T0012396.P.OUT','23:28:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:19:09',1,'2014-01-23 04:19:10'),(291,'OutBound','71','Completed','452721020.DSH.IC834.D131227.T153356430.P.IN','15:33:56','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:33:56',1,'2013-12-27 20:33:57'),(1148,'Inbound',NULL,'Completed','452721020.999.D131228.T1112264.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:38',NULL,'2014-01-05 16:51:41'),(1435,'Inbound',NULL,'Completed','452721020.999.D131228.T1112382.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:13',NULL,'2014-01-05 17:26:16'),(1581,'OutBound','4166','Completed','452721020.DSH.IC834.D140114.T230449605.P.IN','23:04:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:49',1,'2014-01-14 23:04:49'),(1767,'OutBound','2420','Completed','452721020.DSH.IC834.D140114.T230836972.P.IN','23:08:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:37',1,'2014-01-14 23:08:38'),(2226,'OutBound','3115','Completed','452721020.DSH.IC834.D140115.T001919927.P.IN','00:19:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:20',1,'2014-01-15 00:19:20'),(2287,'OutBound','674','Completed','452721020.DSH.IC834.D140115.T002038233.P.IN','00:20:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:38',1,'2014-01-15 00:20:39'),(2749,'Inbound',NULL,'Completed','452721020.999.D140115.T0134455.P.OUT','00:20:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 16:00:02',NULL,'2014-01-23 16:00:02'),(64,'Inbound',NULL,'Completed','452721020.I834.D131114.T1812219.P.OUT','18:05:00','2013-11-14','','CMSFFM','452721020',0,'2013-12-26 01:30:01',NULL,'2013-12-26 01:31:15'),(498,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104902738.P.IN','10:49:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:49:03',NULL,NULL),(1538,'Inbound',NULL,'Completed','i452721020.999.D131228.T1232188.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:31',NULL,'2014-01-13 03:03:32'),(2492,'OutBound','718','Completed','452721020.DSH.IC834.D140115.T090445289.P.IN','09:04:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:45',1,'2014-01-15 09:04:45'),(158,'OutBound','3037','Completed','452721020.DSH.IC834.D131227.T111655968.P.IN','11:16:55','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:16:55',1,'2013-12-27 16:16:55'),(1146,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113048.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:33',NULL,'2014-01-05 16:51:35'),(1633,'OutBound','3652','Completed','452721020.DSH.IC834.D140114.T230551485.P.IN','23:05:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:51',1,'2014-01-14 23:05:52'),(1875,'OutBound','3608','Completed','452721020.DSH.IC834.D140114.T231100988.P.IN','23:11:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:01',1,'2014-01-14 23:11:02'),(2186,'OutBound','5149','Completed','452721020.DSH.IC834.D140115.T001830823.P.IN','00:18:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:30',1,'2014-01-15 00:18:31'),(356,'OutBound','1734','Completed','452721020.DSH.IC834.D131227.T160853766.P.IN','16:08:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:08:54',1,'2013-12-27 21:08:54'),(509,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105524265.P.IN','10:55:24','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:24',NULL,NULL),(1914,'OutBound','11799','Completed','452721020.DSH.IC834.D140114.T231400875.P.IN','23:14:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:00',1,'2014-01-14 23:14:01'),(561,'OutBound','6112','Completed','452721020.DSH.IC834.D140102.T114101504.P.IN','11:41:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:01',1,'2014-01-02 16:41:02'),(1196,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113252.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:51',NULL,'2014-01-05 16:53:53'),(1933,'OutBound','4428','Completed','452721020.DSH.IC834.D140114.T231421201.P.IN','23:14:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:21',1,'2014-01-14 23:14:22'),(1971,'OutBound','153','Completed','452721020.DSH.IC834.D140114.T231504358.P.IN','23:15:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:04',1,'2014-01-14 23:15:05'),(2034,'OutBound','4400','Completed','452721020.DSH.IC834.D140114.T231629631.P.IN','23:16:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:29',1,'2014-01-14 23:16:30'),(2092,'OutBound','151','Completed','452721020.DSH.IC834.D140114.T231743764.P.IN','23:17:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:43',1,'2014-01-14 23:17:44'),(2308,'OutBound','3327','Completed','452721020.DSH.IC834.D140115.T002106142.P.IN','00:21:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:06',1,'2014-01-15 00:21:07'),(2396,'OutBound','5117','Completed','452721020.DSH.IC834.D140115.T090335928.P.IN','09:03:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:36',1,'2014-01-15 09:03:36'),(340,'OutBound','3507','Completed','452721020.DSH.IC834.D131227.T155253555.P.IN','15:52:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:52:53',1,'2013-12-27 20:52:54'),(1527,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113449.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:20',NULL,'2014-01-13 03:03:20'),(2114,'OutBound','3802','Completed','452721020.DSH.IC834.D140115.T001659890.P.IN','00:16:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:00',1,'2014-01-15 00:17:00'),(2414,'OutBound','3628','Completed','452721020.DSH.IC834.D140115.T090348730.P.IN','09:03:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:48',1,'2014-01-15 09:03:49'),(2112,'OutBound','3905','Completed','452721020.DSH.IC834.D140114.T231810270.P.IN','23:18:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:10',1,'2014-01-14 23:18:11'),(315,'OutBound','418','Completed','452721020.DSH.IC834.D131227.T154302948.P.IN','15:43:02','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:02',1,'2013-12-27 20:43:02'),(1354,'Inbound',NULL,'Completed','452721020.999.D131228.T1114079.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:47',NULL,'2014-01-05 17:02:49'),(1539,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113083.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:32',NULL,'2014-01-13 03:03:33'),(1543,'Inbound',NULL,'Completed','452721020.999.D131228.T1112235.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:36',NULL,'2014-01-13 03:03:36'),(1621,'OutBound','671','Completed','452721020.DSH.IC834.D140114.T230538461.P.IN','23:05:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:38',1,'2014-01-14 23:05:39'),(1725,'OutBound','1010','Completed','452721020.DSH.IC834.D140114.T230743360.P.IN','23:07:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:43',1,'2014-01-14 23:07:44'),(1773,'OutBound','2332','Completed','452721020.DSH.IC834.D140114.T230845107.P.IN','23:08:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:45',1,'2014-01-14 23:08:46'),(2353,'OutBound','5794','Completed','452721020.DSH.IC834.D140115.T090309795.P.IN','09:03:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:09',1,'2014-01-15 09:03:10'),(1737,'OutBound','428','Completed','452721020.DSH.IC834.D140114.T230759444.P.IN','23:07:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:59',1,'2014-01-14 23:08:00'),(173,'OutBound','4511','Completed','452721020.DSH.IC834.D131227.T144718324.P.IN','14:47:18','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:47:18',1,'2013-12-27 19:47:19'),(390,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060747891.P.IN','06:07:47','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:07:48',NULL,NULL),(1224,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112264.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:10',NULL,'2014-01-05 16:55:13'),(1424,'Inbound',NULL,'Completed','452721020.999.D131228.T1113506.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:43',NULL,'2014-01-05 17:25:45'),(1809,'OutBound','1783','Completed','452721020.DSH.IC834.D140114.T230933816.P.IN','23:09:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:33',1,'2014-01-14 23:09:34'),(1921,'OutBound','5352','Completed','452721020.DSH.IC834.D140114.T231408611.P.IN','23:14:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:08',1,'2014-01-14 23:14:09'),(1943,'OutBound','5361','Completed','452721020.DSH.IC834.D140114.T231432932.P.IN','23:14:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:33',1,'2014-01-14 23:14:33'),(2172,'OutBound','5122','Completed','452721020.DSH.IC834.D140115.T001812797.P.IN','00:18:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:12',1,'2014-01-15 00:18:13'),(432,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065115821.P.IN','06:51:15','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:51:16',NULL,NULL),(1286,'Inbound',NULL,'Completed','452721020.999.D131228.T1112485.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:37',NULL,'2014-01-05 16:59:39'),(2249,'OutBound','3016','Completed','452721020.DSH.IC834.D140115.T001950657.P.IN','00:19:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:50',1,'2014-01-15 00:19:52'),(2464,'OutBound','5792','Completed','452721020.DSH.IC834.D140115.T090426823.P.IN','09:04:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:26',1,'2014-01-15 09:04:27'),(1427,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112561.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:51',NULL,'2014-01-05 17:25:53'),(1463,'Inbound',NULL,'Completed','452721020.999.D131227.T1703145.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:27:31',NULL,'2014-01-05 17:27:34'),(409,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062514160.P.IN','06:25:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:25:14',NULL,NULL),(1244,'Inbound',NULL,'Completed','452721020.999.D131228.T1113528.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:40',NULL,'2014-01-05 16:57:42'),(1816,'OutBound','1658','Completed','452721020.DSH.IC834.D140114.T230941926.P.IN','23:09:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:42',1,'2014-01-14 23:09:42'),(5,'Inbound',NULL,'Completed','452721020.I834.D131109.T1812289.P.OUT','18:02:00','2013-11-09','','CMSFFM','452721020',0,'2013-12-25 17:31:51',NULL,'2013-12-25 17:32:28'),(32,'Inbound',NULL,'Completed','452721020.I834.D131003.T1807116.P.OUT','18:00:00','2013-10-03','','CMSFFM','452721020',0,'2013-12-25 20:32:08',NULL,'2013-12-25 20:32:17'),(464,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071449690.P.IN','07:14:49','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:14:50',NULL,NULL),(1668,'OutBound','4876','Completed','452721020.DSH.IC834.D140114.T230635560.P.IN','23:06:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:35',1,'2014-01-14 23:06:35'),(1982,'OutBound','2196','Completed','452721020.DSH.IC834.D140114.T231517317.P.IN','23:15:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:17',1,'2014-01-14 23:15:18'),(2233,'OutBound','3007','Completed','452721020.DSH.IC834.D140115.T001929803.P.IN','00:19:29','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:29',1,'2014-01-15 00:19:30'),(2579,'Inbound',NULL,'Completed','452721020.999.D140115.T0141114.P.OUT','00:32:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:43:59',1,'2014-01-23 03:44:00'),(2582,'Inbound',NULL,'Completed','452721020.999.D140114.T2327310.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:44:43',1,'2014-01-23 03:44:44'),(2645,'Inbound',NULL,'Completed','452721020.999.D140114.T2353043.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:21:04',1,'2014-01-23 04:21:05'),(2704,'Inbound',NULL,'Completed','452721020.999.D140115.T0053113.P.OUT','23:33:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:42:09',NULL,'2014-01-23 06:42:09'),(2483,'OutBound','669','Completed','452721020.DSH.IC834.D140115.T090439260.P.IN','09:04:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:39',1,'2014-01-15 09:04:39'),(1805,'OutBound','1822','Completed','452721020.DSH.IC834.D140114.T230929990.P.IN','23:09:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:29',1,'2014-01-14 23:09:30'),(2174,'OutBound','5160','Completed','452721020.DSH.IC834.D140115.T001815247.P.IN','00:18:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:15',1,'2014-01-15 00:18:16'),(2702,'Inbound',NULL,'Completed','452721020.999.D140114.T2347111.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:41:42',NULL,'2014-01-23 06:41:42'),(2737,'Inbound',NULL,'Completed','452721020.999.D140115.T0330337.P.OUT','01:46:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 10:00:02',NULL,'2014-01-23 10:00:03'),(154,'OutBound','250','Completed','452721020.DSH.IC834.D131227.T105031509.P.IN','10:50:31','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 15:50:31',1,'2013-12-27 15:50:32'),(1370,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112465.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:12',NULL,'2014-01-05 17:23:15'),(2050,'OutBound','1004','Completed','452721020.DSH.IC834.D140114.T231649423.P.IN','23:16:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:49',1,'2014-01-14 23:16:50'),(2236,'OutBound','3167','Completed','452721020.DSH.IC834.D140115.T001933603.P.IN','00:19:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:33',1,'2014-01-15 00:19:34'),(2338,'OutBound','1818','Completed','452721020.DSH.IC834.D140115.T090301612.P.IN','09:03:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:01',1,'2014-01-15 09:03:01'),(306,'OutBound','5340','Completed','452721020.DSH.IC834.D131227.T153737474.P.IN','15:37:37','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:37:37',1,'2013-12-27 20:37:38'),(310,'OutBound','3961','Completed','452721020.DSH.IC834.D131227.T154148636.P.IN','15:41:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:41:48',1,'2013-12-27 20:41:49'),(1368,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112553.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:07',NULL,'2014-01-05 17:23:09'),(1480,'Inbound',NULL,'Completed','i452721020.999.D131228.T1232186.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:14',NULL,'2014-01-13 03:02:14'),(1605,'OutBound','5351','Completed','452721020.DSH.IC834.D140114.T230519718.P.IN','23:05:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:19',1,'2014-01-14 23:05:20'),(2506,'OutBound','3336','Completed','452721020.DSH.IC834.D140115.T090454858.P.IN','09:04:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:54',1,'2014-01-15 09:04:55'),(308,'OutBound','5924','Completed','452721020.DSH.IC834.D131227.T153828674.P.IN','15:38:28','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:38:29',1,'2013-12-27 20:38:29'),(1421,'Inbound',NULL,'Completed','452721020.999.D131227.T1703119.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:25:34',NULL,'2014-01-05 17:25:37'),(1544,'Inbound',NULL,'Completed','452721020.999.D131228.T1112246.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:37',NULL,'2014-01-13 03:03:37'),(2155,'OutBound','3019','Completed','452721020.DSH.IC834.D140115.T001751228.P.IN','00:17:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:51',1,'2014-01-15 00:17:52'),(318,'OutBound','1862','Completed','452721020.DSH.IC834.D131227.T154324847.P.IN','15:43:24','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:25',1,'2013-12-27 20:43:25'),(489,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104651699.P.IN','10:46:51','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:52',NULL,NULL),(2273,'OutBound','5880','Completed','452721020.DSH.IC834.D140115.T002020924.P.IN','00:20:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:21',1,'2014-01-15 00:20:21'),(62,'Inbound',NULL,'Completed','452721020.I834.D131105.T1810074.P.OUT','18:03:00','2013-11-05','','CMSFFM','452721020',0,'2013-12-26 01:01:22',NULL,'2013-12-26 01:02:25'),(443,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065758307.P.IN','06:57:58','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:58',NULL,NULL),(1400,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113133.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:36',NULL,'2014-01-05 17:24:38'),(500,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104930313.P.IN','10:49:30','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:49:30',NULL,NULL),(1116,'Inbound',NULL,'Completed','452721020.999.D131228.T1113516.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:10',NULL,'2014-01-05 16:50:13'),(1490,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502196.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:22',NULL,'2014-01-13 03:02:23'),(1753,'OutBound','164','Completed','452721020.DSH.IC834.D140114.T230819952.P.IN','23:08:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:20',1,'2014-01-14 23:08:21'),(1827,'OutBound','5133','Completed','452721020.DSH.IC834.D140114.T230955236.P.IN','23:09:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:55',1,'2014-01-14 23:09:56'),(2113,'OutBound','3906','Completed','452721020.DSH.IC834.D140115.T001658678.P.IN','00:16:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:16:58',1,'2014-01-15 00:16:59'),(2121,'OutBound','1987','Completed','452721020.DSH.IC834.D140115.T001708188.P.IN','00:17:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:08',1,'2014-01-15 00:17:09'),(2454,'OutBound','5782','Completed','452721020.DSH.IC834.D140115.T090419359.P.IN','09:04:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:19',1,'2014-01-15 09:04:19'),(2521,'OutBound','5676','Completed','452721020.DSH.IC834.D140115.T222146595.P.IN','22:21:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:46',1,'2014-01-15 22:21:47'),(2817,'Inbound',NULL,'Completed','452721020.CIC834.D140222.T1823102.P.OUT','18:14:00','2014-02-22','','CMSFFM','452721020',0,'2014-02-22 19:00:10',0,'2014-02-22 19:00:16'),(1117,'Inbound',NULL,'Completed','452721020.999.D131228.T1113205.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:13',NULL,'2014-01-05 16:50:15'),(1508,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113570.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:39',NULL,'2014-01-13 03:02:39'),(1955,'OutBound','7350','Completed','452721020.DSH.IC834.D140114.T231446515.P.IN','23:14:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:46',1,'2014-01-14 23:14:47'),(2365,'OutBound','5155','Completed','452721020.DSH.IC834.D140115.T090316767.P.IN','09:03:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:16',1,'2014-01-15 09:03:17'),(2785,'Inbound',NULL,'Completed','452721020.CIC834.D140207.T1821518.P.OUT','18:13:00','2014-02-07','','CMSFFM','452721020',0,'2014-02-07 19:30:03',NULL,'2014-02-07 19:30:06'),(2791,'Inbound',NULL,'Completed','452721020.CIC834.D140210.T1832560.P.OUT','18:27:00','2014-02-10','','CMSFFM','452721020',0,'2014-02-10 21:00:02',NULL,'2014-02-10 21:00:15'),(434,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065420395.P.IN','06:54:20','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:54:20',NULL,NULL),(520,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110243813.P.IN','11:02:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:02:44',NULL,NULL),(1193,'Inbound',NULL,'Completed','452721020.999.D131228.T1113221.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:43',NULL,'2014-01-05 16:53:45'),(1322,'Inbound',NULL,'Completed','452721020.999.D131228.T1113466.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:18',NULL,'2014-01-05 17:01:20'),(1960,'OutBound','1074','Completed','452721020.DSH.IC834.D140114.T231451761.P.IN','23:14:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:51',1,'2014-01-14 23:14:52'),(449,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070156818.P.IN','07:01:56','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:01:57',NULL,NULL),(1863,'OutBound','3603','Completed','452721020.DSH.IC834.D140114.T231045383.P.IN','23:10:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:45',1,'2014-01-14 23:10:46'),(2010,'OutBound','6442','Completed','452721020.DSH.IC834.D140114.T231558435.P.IN','23:15:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:58',1,'2014-01-14 23:15:59'),(1458,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112284.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:17',NULL,'2014-01-05 17:27:20'),(2387,'OutBound','5163','Completed','452721020.DSH.IC834.D140115.T090330320.P.IN','09:03:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:30',1,'2014-01-15 09:03:30'),(2480,'OutBound','5977','Completed','452721020.DSH.IC834.D140115.T090437322.P.IN','09:04:37','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:37',1,'2014-01-15 09:04:37'),(2609,'Inbound',NULL,'Completed','452721020.999.D140114.T2330001.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:56:06',1,'2014-01-23 03:56:07'),(2782,'Inbound',NULL,'Completed','452721020.I834.D140206.T1837402.P.OUT','18:28:00','2014-02-06','','CMSFFM','452721020',0,'2014-02-06 21:00:03',NULL,'2014-02-06 21:01:54'),(2834,'Inbound',NULL,'Completed','452721020.CIC834.D140302.T1822236.P.OUT','18:15:00','2014-03-02','','CMSFFM','452721020',0,'2014-03-03 01:29:59',0,'2014-03-03 01:30:01'),(81,'Inbound',NULL,'Completed','452721020.I834.D131130.T1812065.P.OUT','18:04:00','2013-11-30','','CMSFFM','452721020',0,'2013-12-26 04:15:02',NULL,'2013-12-26 04:16:27'),(1379,'Inbound',NULL,'Completed','452721020.999.D131228.T1113522.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:37',NULL,'2014-01-05 17:23:40'),(2602,'Inbound',NULL,'Completed','452721020.999.D140114.T2356312.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:51:46',1,'2014-01-23 03:51:47'),(23,'Inbound',NULL,'Completed','452721020.I834.D131202.T1821464.P.OUT','18:14:00','2013-12-02','','CMSFFM','452721020',0,'2013-12-25 19:45:01',NULL,'2013-12-25 19:50:31'),(190,'OutBound','6029','Completed','452721020.DSH.IC834.D131227.T145513431.P.IN','14:55:13','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:55:13',1,'2013-12-27 19:55:14'),(191,'OutBound','3845','Completed','452721020.DSH.IC834.D131227.T145608515.P.IN','14:56:08','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:56:08',1,'2013-12-27 19:56:09'),(451,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070515248.P.IN','07:05:15','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:05:15',NULL,NULL),(1225,'Inbound',NULL,'Completed','452721020.999.D131228.T1113191.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:13',NULL,'2014-01-05 16:55:15'),(1330,'Inbound',NULL,'Completed','452721020.999.D131228.T1113402.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:40',NULL,'2014-01-05 17:01:42'),(1408,'Inbound',NULL,'Completed','452721020.999.D131228.T1113012.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:58',NULL,'2014-01-05 17:25:00'),(1643,'OutBound','121','Completed','452721020.DSH.IC834.D140114.T230603150.P.IN','23:06:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:03',1,'2014-01-14 23:06:03'),(2100,'OutBound','2428','Completed','452721020.DSH.IC834.D140114.T231754426.P.IN','23:17:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:54',1,'2014-01-14 23:17:55'),(2389,'OutBound','5152','Completed','452721020.DSH.IC834.D140115.T090331318.P.IN','09:03:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:31',1,'2014-01-15 09:03:31'),(2498,'OutBound','667','Completed','452721020.DSH.IC834.D140115.T090449238.P.IN','09:04:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:49',1,'2014-01-15 09:04:49'),(548,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113643509.T.IN','11:36:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:43',NULL,NULL),(1677,'OutBound','2284','Completed','452721020.DSH.IC834.D140114.T230645411.P.IN','23:06:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:45',1,'2014-01-14 23:06:45'),(1779,'OutBound','3800','Completed','452721020.DSH.IC834.D140114.T230852231.P.IN','23:08:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:52',1,'2014-01-14 23:08:53'),(242,'OutBound','904','Completed','452721020.DSH.IC834.D131227.T151702369.P.IN','15:17:02','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:17:02',1,'2013-12-27 20:17:03'),(1362,'Inbound',NULL,'Completed','452721020.999.D131228.T1113459.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:50',NULL,'2014-01-05 17:22:52'),(1563,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113153.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:54',NULL,'2014-01-13 03:03:55'),(1637,'OutBound','150','Completed','452721020.DSH.IC834.D140114.T230555844.P.IN','23:05:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:55',1,'2014-01-14 23:05:56'),(1844,'OutBound','5115','Completed','452721020.DSH.IC834.D140114.T231018376.P.IN','23:10:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:18',1,'2014-01-14 23:10:19'),(2182,'OutBound','5125','Completed','452721020.DSH.IC834.D140115.T001824958.P.IN','00:18:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:25',1,'2014-01-15 00:18:25'),(2614,'Inbound',NULL,'Completed','452721020.999.D140115.T0010473.P.OUT','23:33:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:59:54',1,'2014-01-23 03:59:55'),(300,'OutBound','46','Completed','452721020.DSH.IC834.D131227.T153553265.P.IN','15:35:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:35:53',1,'2013-12-27 20:35:54'),(1233,'Inbound',NULL,'Completed','452721020.999.D131228.T1113111.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:09',NULL,'2014-01-05 16:57:12'),(1655,'OutBound','6021','Completed','452721020.DSH.IC834.D140114.T230616430.P.IN','23:06:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:16',1,'2014-01-14 23:06:17'),(2292,'OutBound','678','Completed','452721020.DSH.IC834.D140115.T002044786.P.IN','00:20:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:44',1,'2014-01-15 00:20:45'),(2586,'Inbound',NULL,'Completed','452721020.999.D140114.T2346347.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:45:53',1,'2014-01-23 03:45:54'),(1239,'Inbound',NULL,'Completed','452721020.999.D131228.T1112312.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:26',NULL,'2014-01-05 16:57:29'),(1259,'Inbound',NULL,'Completed','452721020.999.D131228.T1113028.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:22',NULL,'2014-01-05 16:58:24'),(2853,'Inbound',NULL,'Completed','452721020.I834.D140309.T1828194.P.OUT','18:20:00','2014-03-09','','CMSFFM','452721020',0,'2014-03-09 20:59:58',0,'2014-03-09 21:01:22'),(1187,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112507.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:26',NULL,'2014-01-05 16:53:28'),(1216,'Inbound',NULL,'Completed','452721020.999.D131228.T1114005.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:47',NULL,'2014-01-05 16:54:49'),(1536,'Inbound',NULL,'Completed','452721020.999.D131228.T1113068.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:29',NULL,'2014-01-13 03:03:30'),(1882,'OutBound','3607','Completed','452721020.DSH.IC834.D140114.T231109676.P.IN','23:11:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:09',1,'2014-01-14 23:11:10'),(1950,'OutBound','3798','Completed','452721020.DSH.IC834.D140114.T231440694.P.IN','23:14:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:40',1,'2014-01-14 23:14:41'),(2133,'OutBound','1984','Completed','452721020.DSH.IC834.D140115.T001722343.P.IN','00:17:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:22',1,'2014-01-15 00:17:23'),(2243,'OutBound','2849','Completed','452721020.DSH.IC834.D140115.T001942882.P.IN','00:19:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:43',1,'2014-01-15 00:19:43'),(2591,'Inbound',NULL,'Completed','452721020.999.D140114.T2350548.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:47:36',1,'2014-01-23 03:47:36'),(1523,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114072.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:16',NULL,'2014-01-13 03:03:17'),(1811,'OutBound','1778','Completed','452721020.DSH.IC834.D140114.T230936167.P.IN','23:09:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:36',1,'2014-01-14 23:09:37'),(2137,'OutBound','1817','Completed','452721020.DSH.IC834.D140115.T001727720.P.IN','00:17:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:27',1,'2014-01-15 00:17:28'),(1141,'Inbound',NULL,'Completed','452721020.999.D131228.T1112315.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:19',NULL,'2014-01-05 16:51:21'),(93,'Inbound',NULL,'Completed','452721020.I834.D131224.T0310518.P.OUT','01:56:00','2013-12-24','','CMSFFM','452721020',0,'2013-12-26 13:07:09',NULL,'2013-12-26 13:17:12'),(538,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111926201.P.IN','11:19:26','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:19:26',NULL,NULL),(1673,'OutBound','6442','Completed','452721020.DSH.IC834.D140114.T230640723.P.IN','23:06:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:40',1,'2014-01-14 23:06:41'),(1705,'OutBound','2238','Completed','452721020.DSH.IC834.D140114.T230719591.P.IN','23:07:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:19',1,'2014-01-14 23:07:20'),(1822,'OutBound','1662','Completed','452721020.DSH.IC834.D140114.T230949477.P.IN','23:09:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:49',1,'2014-01-14 23:09:50'),(1931,'OutBound','5305','Completed','452721020.DSH.IC834.D140114.T231419124.P.IN','23:14:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:19',1,'2014-01-14 23:14:20'),(1548,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113321.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:40',NULL,'2014-01-13 03:03:41'),(1640,'OutBound','124','Completed','452721020.DSH.IC834.D140114.T230559239.P.IN','23:05:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:59',1,'2014-01-14 23:06:00'),(247,'OutBound','765','Completed','452721020.DSH.IC834.D131227.T151838211.P.IN','15:18:38','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:18:38',1,'2013-12-27 20:18:38'),(2051,'OutBound','148','Completed','452721020.DSH.IC834.D140114.T231650805.P.IN','23:16:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:50',1,'2014-01-14 23:16:51'),(2746,'Inbound',NULL,'Completed','452721020.999.D140115.T0357003.P.OUT','03:08:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 14:30:02',NULL,'2014-01-23 14:30:02'),(165,'OutBound','7697','Completed','452721020.DSH.IC834.D131227.T143740266.P.IN','14:37:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:37:40',1,'2013-12-27 19:37:41'),(234,'OutBound','5037','Completed','452721020.DSH.IC834.D131227.T151420744.P.IN','15:14:20','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:14:21',1,'2013-12-27 20:14:21'),(296,'OutBound','1955','Completed','452721020.DSH.IC834.D131227.T153504979.P.IN','15:35:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:35:05',1,'2013-12-27 20:35:05'),(1619,'OutBound','7625','Completed','452721020.DSH.IC834.D140114.T230536467.P.IN','23:05:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:36',1,'2014-01-14 23:05:37'),(1898,'OutBound','3121','Completed','452721020.DSH.IC834.D140114.T231131520.P.IN','23:11:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:31',1,'2014-01-14 23:11:32'),(2148,'OutBound','1778','Completed','452721020.DSH.IC834.D140115.T001741893.P.IN','00:17:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:42',1,'2014-01-15 00:17:42'),(2828,'Inbound',NULL,'Completed','452721020.CIC834.D140227.T1857056.P.OUT','18:43:00','2014-02-27','','CMSFFM','452721020',0,'2014-02-28 07:30:02',0,'2014-02-28 07:30:40'),(188,'OutBound','5005','Completed','452721020.DSH.IC834.D131227.T145433630.P.IN','14:54:33','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:54:33',1,'2013-12-27 19:54:34'),(1281,'Inbound',NULL,'Completed','452721020.999.D131228.T1114057.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:23',NULL,'2014-01-05 16:59:26'),(2199,'OutBound','5139','Completed','452721020.DSH.IC834.D140115.T001847699.P.IN','00:18:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:47',1,'2014-01-15 00:18:48'),(2399,'OutBound','3603','Completed','452721020.DSH.IC834.D140115.T090338184.P.IN','09:03:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:38',1,'2014-01-15 09:03:38'),(2839,'OutBound','21846','Completed','A834M.140228.0935.edi','09:35:42','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:35:42',0,'2014-03-04 09:35:43'),(513,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105600317.P.IN','10:56:00','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:56:00',NULL,NULL),(1291,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112246.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:51',NULL,'2014-01-05 16:59:53'),(1923,'OutBound','232','Completed','452721020.DSH.IC834.D140114.T231410793.P.IN','23:14:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:10',1,'2014-01-14 23:14:11'),(2158,'OutBound','1656','Completed','452721020.DSH.IC834.D140115.T001755151.P.IN','00:17:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:55',1,'2014-01-15 00:17:56'),(2753,'Inbound',NULL,'Completed','452721020.999.D140115.T1202055.P.OUT','11:28:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 18:00:03',NULL,'2014-01-23 18:00:03'),(2763,'OutBound','6112','Completed','452721020.DSH.IC834.D140129.T134628260.P.IN','13:46:28','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:28',1,'2014-01-29 13:46:28'),(3,'Inbound',NULL,'Completed','452721020.I834.D131113.T2237424.P.OUT','18:04:00','2013-11-13','','CMSFFM','452721020',0,'2013-12-25 17:30:33',NULL,'2013-12-25 17:31:34'),(2223,'OutBound','3637','Completed','452721020.DSH.IC834.D140115.T001916369.P.IN','00:19:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:16',1,'2014-01-15 00:19:17'),(1265,'Inbound',NULL,'Completed','452721020.999.D131228.T1113349.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:39',NULL,'2014-01-05 16:58:41'),(1800,'OutBound','1817','Completed','452721020.DSH.IC834.D140114.T230923191.P.IN','23:09:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:23',1,'2014-01-14 23:09:24'),(2109,'OutBound','2417','Completed','452721020.DSH.IC834.D140114.T231806349.P.IN','23:18:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:06',1,'2014-01-14 23:18:07'),(2368,'OutBound','5114','Completed','452721020.DSH.IC834.D140115.T090318492.P.IN','09:03:18','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:18',1,'2014-01-15 09:03:18'),(2102,'OutBound','2430','Completed','452721020.DSH.IC834.D140114.T231757194.P.IN','23:17:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:57',1,'2014-01-14 23:17:58'),(2201,'OutBound','3630','Completed','452721020.DSH.IC834.D140115.T001850857.P.IN','00:18:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:50',1,'2014-01-15 00:18:51'),(2653,'Inbound',NULL,'Completed','452721020.999.D140115.T0214450.P.OUT','00:01:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:26:58',1,'2014-01-23 04:26:58'),(2821,'Inbound',NULL,'Completed','452721020.CIC834.D140224.T1827449.P.OUT','18:19:00','2014-02-24','','CMSFFM','452721020',0,'2014-02-26 08:00:35',0,'2014-02-26 08:00:48'),(229,'OutBound','2542','Completed','452721020.DSH.IC834.D131227.T151259947.P.IN','15:12:59','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:13:00',1,'2013-12-27 20:13:00'),(420,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063448665.P.IN','06:34:48','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:34:49',NULL,NULL),(2570,'Inbound',NULL,'Completed','452721020.999.D140115.T0222457.P.OUT','00:05:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:41:36',1,'2014-01-23 03:41:36'),(2774,'Inbound',NULL,'Completed','452721020.I834.D140131.T1844029.P.OUT','18:37:00','2014-01-31','','CMSFFM','452721020',0,'2014-01-31 21:00:04',NULL,'2014-01-31 21:01:47'),(501,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104930787.P.IN','10:49:30','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:49:31',NULL,NULL),(1691,'OutBound','4401','Completed','452721020.DSH.IC834.D140114.T230701991.P.IN','23:07:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:02',1,'2014-01-14 23:07:03'),(241,'OutBound','1097','Completed','452721020.DSH.IC834.D131227.T151638259.P.IN','15:16:38','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:16:38',1,'2013-12-27 20:16:38'),(2096,'OutBound','2422','Completed','452721020.DSH.IC834.D140114.T231748586.P.IN','23:17:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:48',1,'2014-01-14 23:17:50'),(74,'Inbound',NULL,'Completed','452721020.I834.D131110.T1807198.P.OUT','18:01:00','2013-11-10','','CMSFFM','452721020',0,'2013-12-26 02:46:34',NULL,'2013-12-26 02:46:55'),(1572,'Inbound',NULL,'Completed','452721020.999.D131228.T0502314.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:04:02',NULL,'2014-01-13 03:04:03'),(1631,'OutBound','155','Completed','452721020.DSH.IC834.D140114.T230549441.P.IN','23:05:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:49',1,'2014-01-14 23:05:50'),(2264,'OutBound','5788','Completed','452721020.DSH.IC834.D140115.T002010248.P.IN','00:20:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:10',1,'2014-01-15 00:20:11'),(2386,'OutBound','5124','Completed','452721020.DSH.IC834.D140115.T090329395.P.IN','09:03:29','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:29',1,'2014-01-15 09:03:29'),(1226,'Inbound',NULL,'Completed','452721020.999.D131228.T1113436.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:16',NULL,'2014-01-05 16:55:20'),(2169,'OutBound','5114','Completed','452721020.DSH.IC834.D140115.T001808889.P.IN','00:18:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:09',1,'2014-01-15 00:18:09'),(2559,'Inbound',NULL,'Completed','452721020.999.D140114.T2351471.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 03:39:32',NULL,'2014-01-23 03:39:33'),(2758,'Inbound',NULL,'Completed','452721020.I834.D140126.T1817426.P.OUT','18:09:00','2014-01-26','','CMSFFM','452721020',0,'2014-01-26 19:00:02',NULL,'2014-01-26 19:00:31'),(441,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065746233.P.IN','06:57:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:46',NULL,NULL),(1377,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113387.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:32',NULL,'2014-01-05 17:23:34'),(1656,'OutBound','6022','Completed','452721020.DSH.IC834.D140114.T230617572.P.IN','23:06:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:17',1,'2014-01-14 23:06:18'),(2814,'Inbound',NULL,'Completed','452721020.I834.D140220.T1838500.P.OUT','18:28:00','2014-02-20','','CMSFFM','452721020',0,'2014-02-20 22:00:02',0,'2014-02-20 22:01:42'),(531,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111014358.P.IN','11:10:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:14',NULL,NULL),(1215,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112402.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:44',NULL,'2014-01-05 16:54:46'),(2438,'OutBound','3119','Completed','452721020.DSH.IC834.D140115.T090407404.P.IN','09:04:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:07',1,'2014-01-15 09:04:08'),(1158,'Inbound',NULL,'Completed','452721020.999.D131228.T1113591.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:06',NULL,'2014-01-05 16:52:08'),(1263,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113068.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:33',NULL,'2014-01-05 16:58:35'),(2275,'OutBound','5888','Completed','452721020.DSH.IC834.D140115.T002023201.P.IN','00:20:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:23',1,'2014-01-15 00:20:24'),(1660,'OutBound','5791','Completed','452721020.DSH.IC834.D140114.T230625922.P.IN','23:06:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:26',1,'2014-01-14 23:06:26'),(2083,'OutBound','117','Completed','452721020.DSH.IC834.D140114.T231732290.P.IN','23:17:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:32',1,'2014-01-14 23:17:33'),(2800,'Inbound',NULL,'Completed','452721020.CIC834.D140214.T1843420.P.OUT','18:36:00','2014-02-14','','CMSFFM','452721020',0,'2014-02-14 22:00:02',0,'2014-02-14 22:00:10'),(2332,'OutBound','1984','Completed','452721020.DSH.IC834.D140115.T090258213.P.IN','09:02:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:58',1,'2014-01-15 09:02:58'),(1941,'OutBound','5405','Completed','452721020.DSH.IC834.D140114.T231430848.P.IN','23:14:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:30',1,'2014-01-14 23:14:31'),(2776,'Inbound',NULL,'Completed','452721020.I834.D140202.T1817112.P.OUT','18:10:00','2014-02-02','','CMSFFM','452721020',0,'2014-02-02 19:00:03',NULL,'2014-02-02 19:00:34'),(559,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113730859.T.IN','11:37:30','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:31',NULL,NULL),(1182,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113046.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:12',NULL,'2014-01-05 16:53:14'),(1192,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113179.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:40',NULL,'2014-01-05 16:53:42'),(1433,'Inbound',NULL,'Completed','452721020.999.D131228.T1113051.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:08',NULL,'2014-01-05 17:26:10'),(1731,'OutBound','969','Completed','452721020.DSH.IC834.D140114.T230750475.P.IN','23:07:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:50',1,'2014-01-14 23:07:51'),(2495,'OutBound','683','Completed','452721020.DSH.IC834.D140115.T090447304.P.IN','09:04:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:47',1,'2014-01-15 09:04:47'),(2611,'Inbound',NULL,'Completed','452721020.999.D140114.T2331025.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:56:42',1,'2014-01-23 03:56:43'),(10,'Inbound',NULL,'Completed','452721020.I834.D131019.T1807223.P.OUT','18:01:00','2013-10-19','','CMSFFM','452721020',0,'2013-12-25 18:11:01',NULL,'2013-12-25 18:11:11'),(484,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104614603.P.IN','10:46:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:15',NULL,NULL),(1685,'OutBound','4496','Completed','452721020.DSH.IC834.D140114.T230653979.P.IN','23:06:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:54',1,'2014-01-14 23:06:55'),(2117,'OutBound','3797','Completed','452721020.DSH.IC834.D140115.T001703610.P.IN','00:17:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:03',1,'2014-01-15 00:17:04'),(1151,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502256.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:47',NULL,'2014-01-05 16:51:49'),(1740,'OutBound','3256','Completed','452721020.DSH.IC834.D140114.T230803120.P.IN','23:08:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:03',1,'2014-01-14 23:08:04'),(2211,'OutBound','3631','Completed','452721020.DSH.IC834.D140115.T001901482.P.IN','00:19:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:01',1,'2014-01-15 00:19:02'),(2240,'OutBound','3015','Completed','452721020.DSH.IC834.D140115.T001938826.P.IN','00:19:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:38',1,'2014-01-15 00:19:39'),(2257,'OutBound','5882','Completed','452721020.DSH.IC834.D140115.T002001395.P.IN','00:20:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:01',1,'2014-01-15 00:20:02'),(2493,'OutBound','675','Completed','452721020.DSH.IC834.D140115.T090445943.P.IN','09:04:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:46',1,'2014-01-15 09:04:46'),(418,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063336528.P.IN','06:33:36','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:33:36',NULL,NULL),(424,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063856553.P.IN','06:38:56','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:38:56',NULL,NULL),(2272,'OutBound','5955','Completed','452721020.DSH.IC834.D140115.T002019749.P.IN','00:20:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:19',1,'2014-01-15 00:20:20'),(302,'OutBound','3967','Completed','452721020.DSH.IC834.D131227.T153614329.P.IN','15:36:14','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:36:14',1,'2013-12-27 20:36:15'),(372,'OutBound','5872','Completed','452721020.DSH.IC834.D131227.T162848833.P.IN','16:28:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:28:49',1,'2013-12-27 21:28:49'),(462,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071403566.P.IN','07:14:03','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:14:03',NULL,NULL),(1130,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502314.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:49',NULL,'2014-01-05 16:50:51'),(1742,'OutBound','376','Completed','452721020.DSH.IC834.D140114.T230805627.P.IN','23:08:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:05',1,'2014-01-14 23:08:06'),(2407,'OutBound','3604','Completed','452721020.DSH.IC834.D140115.T090343609.P.IN','09:03:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:43',1,'2014-01-15 09:03:44'),(2711,'Inbound',NULL,'Completed','452721020.999.D140115.T0041028.P.OUT','23:50:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:46:44',NULL,'2014-01-23 06:46:45'),(328,'OutBound','2304','Completed','452721020.DSH.IC834.D131227.T154737124.P.IN','15:47:37','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:47:37',1,'2013-12-27 20:47:37'),(1147,'Inbound',NULL,'Completed','452721020.999.D131228.T1113499.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:36',NULL,'2014-01-05 16:51:38'),(1499,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113182.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:30',NULL,'2014-01-13 03:02:31'),(2401,'OutBound','3651','Completed','452721020.DSH.IC834.D140115.T090339296.P.IN','09:03:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:39',1,'2014-01-15 09:03:39'),(2488,'OutBound','690','Completed','452721020.DSH.IC834.D140115.T090442799.P.IN','09:04:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:42',1,'2014-01-15 09:04:43'),(155,'OutBound','7230','Completed','452721020.DSH.IC834.D131227.T111103473.P.IN','11:11:03','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:11:03',1,'2013-12-27 16:11:04'),(518,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110008181.P.IN','11:00:08','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:00:08',NULL,NULL),(1155,'Inbound',NULL,'Completed','452721020.999.D131228.T1113237.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:58',NULL,'2014-01-05 16:52:00'),(1232,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113171.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:07',NULL,'2014-01-05 16:57:09'),(1381,'Inbound',NULL,'Completed','452721020.999.D131228.T1112270.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:43',NULL,'2014-01-05 17:23:45'),(2472,'OutBound','5880','Completed','452721020.DSH.IC834.D140115.T090432354.P.IN','09:04:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:32',1,'2014-01-15 09:04:32'),(2826,'Inbound',NULL,'Completed','452721020.I834.D140227.T1858186.P.OUT','18:48:00','2014-02-27','','CMSFFM','452721020',0,'2014-02-28 06:30:02',0,'2014-02-28 06:31:50'),(35,'Inbound',NULL,'Completed','452721020.I834.D131128.T1811546.P.OUT','18:02:00','2013-11-28','','CMSFFM','452721020',0,'2013-12-25 20:46:24',NULL,'2013-12-25 20:47:17'),(301,'OutBound','2940','Completed','452721020.DSH.IC834.D131227.T153611490.P.IN','15:36:11','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:36:11',1,'2013-12-27 20:36:12'),(1467,'Inbound',NULL,'Completed','452721020.999.D131228.T1112445.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:42',NULL,'2014-01-05 17:27:45'),(1750,'OutBound','147','Completed','452721020.DSH.IC834.D140114.T230816174.P.IN','23:08:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:16',1,'2014-01-14 23:08:17'),(1897,'OutBound','7610','Completed','452721020.DSH.IC834.D140114.T231130316.P.IN','23:11:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:30',1,'2014-01-14 23:11:31'),(2573,'Inbound',NULL,'Completed','452721020.999.D140114.T2327356.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:42:09',1,'2014-01-23 03:42:10'),(2770,'OutBound','3628','Completed','452721020.DSH.IC834.D140129.T134742468.P.IN','13:47:42','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:47:42',1,'2014-01-29 13:47:43'),(373,'OutBound','4234','Completed','452721020.DSH.IC834.D131227.T163008593.P.IN','16:30:08','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:30:08',1,'2013-12-27 21:30:09'),(1956,'OutBound','7625','Completed','452721020.DSH.IC834.D140114.T231447566.P.IN','23:14:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:47',1,'2014-01-14 23:14:48'),(2079,'OutBound','376','Completed','452721020.DSH.IC834.D140114.T231726768.P.IN','23:17:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:26',1,'2014-01-14 23:17:27'),(2412,'OutBound','3647','Completed','452721020.DSH.IC834.D140115.T090347304.P.IN','09:03:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:47',1,'2014-01-15 09:03:47'),(438,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065707368.P.IN','06:57:07','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:57:07',NULL,NULL),(522,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110255722.P.IN','11:02:55','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:02:56',NULL,NULL),(1694,'OutBound','4414','Completed','452721020.DSH.IC834.D140114.T230706141.P.IN','23:07:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:06',1,'2014-01-14 23:07:07'),(2301,'OutBound','677','Completed','452721020.DSH.IC834.D140115.T002055968.P.IN','00:20:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:56',1,'2014-01-15 00:20:56'),(264,'OutBound','2124','Completed','452721020.DSH.IC834.D131227.T152605113.P.IN','15:26:05','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:26:05',1,'2013-12-27 20:26:05'),(1565,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113478.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:56',NULL,'2014-01-13 03:03:57'),(2116,'OutBound','3800','Completed','452721020.DSH.IC834.D140115.T001702120.P.IN','00:17:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:02',1,'2014-01-15 00:17:03'),(2298,'OutBound','706','Completed','452721020.DSH.IC834.D140115.T002052224.P.IN','00:20:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:52',1,'2014-01-15 00:20:53'),(2343,'OutBound','1816','Completed','452721020.DSH.IC834.D140115.T090304228.P.IN','09:03:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:04',1,'2014-01-15 09:03:04'),(1384,'Inbound',NULL,'Completed','452721020.999.D131228.T0502256.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:51',NULL,'2014-01-05 17:23:54'),(1858,'OutBound','5118','Completed','452721020.DSH.IC834.D140114.T231038316.P.IN','23:10:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:38',1,'2014-01-14 23:10:39'),(1910,'OutBound','3113','Completed','452721020.DSH.IC834.D140114.T231146826.P.IN','23:11:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:46',1,'2014-01-14 23:11:49'),(1915,'OutBound','4520','Completed','452721020.DSH.IC834.D140114.T231402189.P.IN','23:14:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:02',1,'2014-01-14 23:14:03'),(2374,'OutBound','5135','Completed','452721020.DSH.IC834.D140115.T090322106.P.IN','09:03:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:22',1,'2014-01-15 09:03:22'),(2833,'Inbound',NULL,'Completed','452721020.I834.D140302.T1823103.P.OUT','18:16:00','2014-03-02','','CMSFFM','452721020',0,'2014-03-03 01:00:01',0,'2014-03-03 01:00:42'),(65,'Inbound',NULL,'Completed','452721020.I834.D131005.T1807057.P.OUT','18:01:00','2013-10-05','','CMSFFM','452721020',0,'2013-12-26 01:31:15',NULL,'2013-12-26 01:31:45'),(540,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111953164.P.IN','11:19:53','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:19:53',NULL,NULL),(1820,'OutBound','1657','Completed','452721020.DSH.IC834.D140114.T230946927.P.IN','23:09:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:47',1,'2014-01-14 23:09:47'),(1980,'OutBound','121','Completed','452721020.DSH.IC834.D140114.T231514963.P.IN','23:15:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:15',1,'2014-01-14 23:15:15'),(2601,'Inbound',NULL,'Completed','452721020.999.D140114.T2358228.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:51:40',1,'2014-01-23 03:51:41'),(478,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.103115735.P.IN','10:31:15','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:31:16',NULL,NULL),(1162,'Inbound',NULL,'Completed','452721020.999.D131228.T1113331.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:17',NULL,'2014-01-05 16:52:19'),(1613,'OutBound','3798','Completed','452721020.DSH.IC834.D140114.T230528577.P.IN','23:05:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:28',1,'2014-01-14 23:05:29'),(1747,'OutBound','144','Completed','452721020.DSH.IC834.D140114.T230812393.P.IN','23:08:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:12',1,'2014-01-14 23:08:13'),(2241,'OutBound','3009','Completed','452721020.DSH.IC834.D140115.T001939950.P.IN','00:19:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:40',1,'2014-01-15 00:19:40'),(1356,'Inbound',NULL,'Completed','452721020.999.D131228.T1232186.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:33',NULL,'2014-01-05 17:22:35'),(1552,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113221.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:44',NULL,'2014-01-13 03:03:45'),(1697,'OutBound','4400','Completed','452721020.DSH.IC834.D140114.T230709885.P.IN','23:07:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:09',1,'2014-01-14 23:07:10'),(1909,'OutBound','3017','Completed','452721020.DSH.IC834.D140114.T231145566.P.IN','23:11:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:45',1,'2014-01-14 23:11:46'),(1945,'OutBound','4490','Completed','452721020.DSH.IC834.D140114.T231435185.P.IN','23:14:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:35',1,'2014-01-14 23:14:36'),(2304,'OutBound','10927','Completed','452721020.DSH.IC834.D140115.T002059855.P.IN','00:20:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:59',1,'2014-01-15 00:21:01'),(1179,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502278.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:04',NULL,'2014-01-05 16:53:06'),(1775,'OutBound','3905','Completed','452721020.DSH.IC834.D140114.T230847474.P.IN','23:08:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:47',1,'2014-01-14 23:08:48'),(1810,'OutBound','1659','Completed','452721020.DSH.IC834.D140114.T230934984.P.IN','23:09:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:35',1,'2014-01-14 23:09:35'),(1929,'OutBound','2589','Completed','452721020.DSH.IC834.D140114.T231417111.P.IN','23:14:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:17',1,'2014-01-14 23:14:17'),(2795,'Inbound',NULL,'Completed','452721020.CIC834.D140212.T1838074.P.OUT','18:27:00','2014-02-12','','CMSFFM','452721020',0,'2014-02-12 21:00:03',NULL,'2014-02-12 21:00:18'),(30,'Inbound',NULL,'Completed','452721020.I834.D131013.T1806438.P.OUT','18:01:00','2013-10-13','','CMSFFM','452721020',0,'2013-12-25 20:30:02',NULL,'2013-12-25 20:30:39'),(508,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105523550.P.IN','10:55:23','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:23',NULL,NULL),(1471,'Inbound',NULL,'Completed','452721020.I834.D140107.T1837234.P.OUT','18:29:00','2014-01-07','','CMSFFM','452721020',0,'2014-01-08 18:23:56',NULL,'2014-01-08 18:25:09'),(2107,'OutBound','2445','Completed','452721020.DSH.IC834.D140114.T231803329.P.IN','23:18:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:03',1,'2014-01-14 23:18:04'),(2469,'OutBound','5781','Completed','452721020.DSH.IC834.D140115.T090430180.P.IN','09:04:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:30',1,'2014-01-15 09:04:30'),(359,'OutBound','3843','Completed','452721020.DSH.IC834.D131227.T161145128.P.IN','16:11:45','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:11:45',1,'2013-12-27 21:11:45'),(1743,'OutBound','429','Completed','452721020.DSH.IC834.D140114.T230806835.P.IN','23:08:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:06',1,'2014-01-14 23:08:08'),(2193,'OutBound','5123','Completed','452721020.DSH.IC834.D140115.T001840638.P.IN','00:18:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:40',1,'2014-01-15 00:18:41'),(2596,'Inbound',NULL,'Completed','452721020.999.D140114.T2327251.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:49:22',1,'2014-01-23 03:49:22'),(198,'OutBound','5376','Completed','452721020.DSH.IC834.D131227.T145815808.P.IN','14:58:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:58:16',1,'2013-12-27 19:58:16'),(1866,'OutBound','1487','Completed','452721020.DSH.IC834.D140114.T231049631.P.IN','23:10:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:49',1,'2014-01-14 23:10:50'),(2127,'OutBound','2076','Completed','452721020.DSH.IC834.D140115.T001715210.P.IN','00:17:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:15',1,'2014-01-15 00:17:16'),(2593,'Inbound',NULL,'Completed','452721020.999.D140115.T0159196.P.OUT','00:43:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:47:58',1,'2014-01-23 03:47:59'),(2677,'Inbound',NULL,'Completed','452721020.999.D140114.T2324288.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:02:10',1,'2014-01-23 05:02:10'),(292,'OutBound','2368','Completed','452721020.DSH.IC834.D131227.T153421218.P.IN','15:34:21','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:34:21',1,'2013-12-27 20:34:21'),(1497,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113490.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:29',NULL,'2014-01-13 03:02:29'),(1988,'OutBound','7721','Completed','452721020.DSH.IC834.D140114.T231524543.P.IN','23:15:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:24',1,'2014-01-14 23:15:25'),(2230,'OutBound','3006','Completed','452721020.DSH.IC834.D140115.T001924636.P.IN','00:19:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:24',1,'2014-01-15 00:19:25'),(213,'OutBound','2597','Completed','452721020.DSH.IC834.D131227.T150709386.P.IN','15:07:09','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:07:09',1,'2013-12-27 20:07:10'),(2453,'OutBound','5785','Completed','452721020.DSH.IC834.D140115.T090418648.P.IN','09:04:18','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:18',1,'2014-01-15 09:04:19'),(2842,'OutBound','21846','Completed','A834M.140228.0959.edi','09:59:03','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:59:04',0,'2014-03-04 09:59:08'),(346,'OutBound','2110','Completed','452721020.DSH.IC834.D131227.T155754623.P.IN','15:57:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:57:54',1,'2013-12-27 20:57:55'),(423,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063658860.P.IN','06:36:58','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:36:59',NULL,NULL),(2535,'OutBound','11647','Completed','452721020.DSH.IC834.D140115.T222154775.P.IN','22:21:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:54',1,'2014-01-15 22:21:54'),(2623,'Inbound',NULL,'Completed','452721020.999.D140115.T0023044.P.OUT','23:27:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:07:27',1,'2014-01-23 04:07:28'),(1562,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114032.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:53',NULL,'2014-01-13 03:03:54'),(1804,'OutBound','1660','Completed','452721020.DSH.IC834.D140114.T230927948.P.IN','23:09:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:28',1,'2014-01-14 23:09:28'),(1741,'OutBound','382','Completed','452721020.DSH.IC834.D140114.T230804386.P.IN','23:08:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:04',1,'2014-01-14 23:08:05'),(1788,'OutBound','2055','Completed','452721020.DSH.IC834.D140114.T230906150.P.IN','23:09:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:06',1,'2014-01-14 23:09:07'),(2468,'OutBound','5813','Completed','452721020.DSH.IC834.D140115.T090429542.P.IN','09:04:29','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:29',1,'2014-01-15 09:04:29'),(2544,'OutBound','3331','Completed','452721020.DSH.IC834.D140120.T054422998.P.IN','05:44:22','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:23',1,'2014-01-20 05:44:23'),(2750,'Inbound',NULL,'Completed','452721020.999.D140114.T2336509.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 16:30:02',NULL,'2014-01-23 16:30:02'),(377,'OutBound','3546','Completed','452721020.DSH.IC834.D131227.T164330426.P.IN','16:43:30','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:43:30',1,'2013-12-27 21:43:30'),(459,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071205299.P.IN','07:12:05','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:12:05',NULL,NULL),(1437,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703157.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:26:19',NULL,'2014-01-05 17:26:21'),(1584,'OutBound','5352','Completed','452721020.DSH.IC834.D140114.T230452375.P.IN','23:04:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:52',1,'2014-01-14 23:04:53'),(1736,'OutBound','378','Completed','452721020.DSH.IC834.D140114.T230758258.P.IN','23:07:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:58',1,'2014-01-14 23:07:59'),(1180,'Inbound',NULL,'Completed','452721020.999.D131228.T1114008.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:07',NULL,'2014-01-05 16:53:09'),(1229,'Inbound',NULL,'Completed','452721020.999.D131228.T1113387.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:27',NULL,'2014-01-05 16:55:29'),(2406,'OutBound','3639','Completed','452721020.DSH.IC834.D140115.T090342958.P.IN','09:03:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:43',1,'2014-01-15 09:03:43'),(2665,'Inbound',NULL,'Completed','452721020.999.D140114.T2325423.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:45:46',1,'2014-01-23 04:45:47'),(2741,'Inbound',NULL,'Completed','452721020.999.D140115.T0304576.P.OUT','01:41:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 12:00:02',NULL,'2014-01-23 12:00:03'),(336,'OutBound','557','Completed','452721020.DSH.IC834.D131227.T154938864.P.IN','15:49:38','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:49:39',1,'2013-12-27 20:49:39'),(1262,'Inbound',NULL,'Completed','452721020.999.D131228.T1113478.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:30',NULL,'2014-01-05 16:58:33'),(1647,'OutBound','5406','Completed','452721020.DSH.IC834.D140114.T230607606.P.IN','23:06:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:07',1,'2014-01-14 23:06:08'),(2077,'OutBound','3256','Completed','452721020.DSH.IC834.D140114.T231723232.P.IN','23:17:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:23',1,'2014-01-14 23:17:24'),(2479,'OutBound','5978','Completed','452721020.DSH.IC834.D140115.T090436644.P.IN','09:04:36','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:36',1,'2014-01-15 09:04:37'),(2580,'Inbound',NULL,'Completed','452721020.999.D140115.T2302069.P.OUT','22:50:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:44:35',1,'2014-01-23 03:44:35'),(2692,'Inbound',NULL,'Completed','452721020.999.D140114.T2326127.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:30:13',NULL,'2014-01-23 06:30:13'),(1576,'Inbound',NULL,'Completed','452721020.I834.D140113.T1852150.P.OUT','18:44:00','2014-01-13','','CMSFFM','452721020',0,'2014-01-14 01:31:57',NULL,'2014-01-14 01:33:55'),(2219,'OutBound','3607','Completed','452721020.DSH.IC834.D140115.T001911757.P.IN','00:19:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:11',1,'2014-01-15 00:19:12'),(15,'Inbound',NULL,'Completed','452721020.I834.D131104.T1808052.P.OUT','18:02:00','2013-11-04','','CMSFFM','452721020',0,'2013-12-25 18:31:07',NULL,'2013-12-25 18:31:49'),(1194,'Inbound',NULL,'Completed','452721020.999.D131228.T1112214.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:45',NULL,'2014-01-05 16:53:48'),(2522,'OutBound','5621','Completed','452721020.DSH.IC834.D140115.T222147337.P.IN','22:21:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:47',1,'2014-01-15 22:21:47'),(2144,'OutBound','1816','Completed','452721020.DSH.IC834.D140115.T001737885.P.IN','00:17:37','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:37',1,'2014-01-15 00:17:38'),(212,'OutBound','24','Completed','452721020.DSH.IC834.D131227.T150640464.P.IN','15:06:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:06:40',1,'2013-12-27 20:06:41'),(469,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071521874.P.IN','07:15:21','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:15:22',NULL,NULL),(1333,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112199.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:48',NULL,'2014-01-05 17:01:51'),(1439,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112232.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:24',NULL,'2014-01-05 17:26:27'),(1575,'OutBound','4895','Completed','452721020.DSH.IC834.D140113.T221444334.P.IN','22:14:44','2014-01-13','0','452721020','CMSFFM',1,'2014-01-13 22:14:44',1,'2014-01-13 22:14:45'),(2141,'OutBound','1660','Completed','452721020.DSH.IC834.D140115.T001732501.P.IN','00:17:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:32',1,'2014-01-15 00:17:33'),(13,'Inbound',NULL,'Completed','production-452721020.I834.D131203.T1827324.P.OUT','18:20:00','2013-12-03','','CMSFFM','452721020',0,'2013-12-25 18:15:01',NULL,'2013-12-25 18:21:35'),(394,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061002156.P.IN','06:10:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:10:02',NULL,NULL),(397,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061127510.P.IN','06:11:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:11:27',NULL,NULL),(1157,'Inbound',NULL,'Completed','452721020.999.D131228.T1113046.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:03',NULL,'2014-01-05 16:52:06'),(1498,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113516.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:29',NULL,'2014-01-13 03:02:30'),(2274,'OutBound','5887','Completed','452721020.DSH.IC834.D140115.T002022234.P.IN','00:20:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:22',1,'2014-01-15 00:20:23'),(2667,'Inbound',NULL,'Completed','452721020.999.D140115.T1028118.P.OUT','09:37:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:47:05',1,'2014-01-23 04:47:05'),(453,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070618192.P.IN','07:06:18','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:06:18',NULL,NULL),(2838,'OutBound','21846','Completed','A834M.140228.0928.edi','09:28:58','2014-03-04','0','452721020M','31434',0,'2014-03-04 09:28:58',0,'2014-03-04 09:29:00'),(84,'Inbound',NULL,'Completed','452721020.I834.D131021.T1812315.P.OUT','18:04:00','2013-10-21','','CMSFFM','452721020',0,'2013-12-26 05:00:01',NULL,'2013-12-26 05:01:23'),(1832,'OutBound','5114','Completed','452721020.DSH.IC834.D140114.T231001211.P.IN','23:10:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:01',1,'2014-01-14 23:10:02'),(1884,'OutBound','3641','Completed','452721020.DSH.IC834.D140114.T231112181.P.IN','23:11:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:12',1,'2014-01-14 23:11:13'),(2047,'OutBound','2220','Completed','452721020.DSH.IC834.D140114.T231645621.P.IN','23:16:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:45',1,'2014-01-14 23:16:46'),(2078,'OutBound','382','Completed','452721020.DSH.IC834.D140114.T231724551.P.IN','23:17:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:24',1,'2014-01-14 23:17:26'),(2271,'OutBound','5804','Completed','452721020.DSH.IC834.D140115.T002018580.P.IN','00:20:18','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:18',1,'2014-01-15 00:20:19'),(2512,'OutBound','1529','Completed','452721020.DSH.IC834.D140115.T222141616.P.IN','22:21:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:41',1,'2014-01-15 22:21:41'),(2729,'Inbound',NULL,'Completed','452721020.999.D140115.T0345203.P.OUT','02:38:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 08:39:57',NULL,'2014-01-23 08:39:58'),(1928,'OutBound','157','Completed','452721020.DSH.IC834.D140114.T231415975.P.IN','23:14:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:16',1,'2014-01-14 23:14:16'),(2024,'OutBound','4489','Completed','452721020.DSH.IC834.D140114.T231616373.P.IN','23:16:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:16',1,'2014-01-14 23:16:17'),(2041,'OutBound','2240','Completed','452721020.DSH.IC834.D140114.T231638459.P.IN','23:16:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:38',1,'2014-01-14 23:16:39'),(2054,'OutBound','1009','Completed','452721020.DSH.IC834.D140114.T231654422.P.IN','23:16:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:54',1,'2014-01-14 23:16:55'),(2583,'Inbound',NULL,'Completed','452721020.999.D140114.T2350281.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:44:46',1,'2014-01-23 03:44:47'),(1373,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114008.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:21',NULL,'2014-01-05 17:23:23'),(2802,'Inbound',NULL,'Completed','452721020.I834.D140215.T1856592.P.OUT','18:48:00','2014-02-15','','CMSFFM','452721020',0,'2014-02-15 22:00:02',0,'2014-02-15 22:02:12'),(1886,'OutBound','3637','Completed','452721020.DSH.IC834.D140114.T231114664.P.IN','23:11:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:14',1,'2014-01-14 23:11:15'),(2420,'OutBound','3641','Completed','452721020.DSH.IC834.D140115.T090353450.P.IN','09:03:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:53',1,'2014-01-15 09:03:53'),(2523,'OutBound','5630','Completed','452721020.DSH.IC834.D140115.T222147819.P.IN','22:21:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:47',1,'2014-01-15 22:21:48'),(2626,'Inbound',NULL,'Completed','452721020.999.D140115.T0226504.P.OUT','00:07:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:09:32',1,'2014-01-23 04:09:32'),(316,'OutBound','5410','Completed','452721020.DSH.IC834.D131227.T154311858.P.IN','15:43:11','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:12',1,'2013-12-27 20:43:12'),(1447,'Inbound',NULL,'Completed','452721020.999.D131228.T1113423.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:47',NULL,'2014-01-05 17:26:49'),(1987,'OutBound','7723','Completed','452721020.DSH.IC834.D140114.T231523361.P.IN','23:15:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:23',1,'2014-01-14 23:15:24'),(2231,'OutBound','3120','Completed','452721020.DSH.IC834.D140115.T001925999.P.IN','00:19:25','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:26',1,'2014-01-15 00:19:27'),(2844,'Inbound',NULL,'Completed','452721020.CIC834.D140304.T1853098.P.OUT','18:46:00','2014-03-04','','CMSFFM','452721020',0,'2014-03-04 21:30:04',0,'2014-03-04 21:30:24'),(1418,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113016.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:26',NULL,'2014-01-05 17:25:28'),(1837,'OutBound','5160','Completed','452721020.DSH.IC834.D140114.T231008468.P.IN','23:10:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:08',1,'2014-01-14 23:10:09'),(2437,'OutBound','3021','Completed','452721020.DSH.IC834.D140115.T090406670.P.IN','09:04:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:06',1,'2014-01-15 09:04:07'),(216,'OutBound','6424','Completed','452721020.DSH.IC834.D131227.T150758589.P.IN','15:07:58','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:07:58',1,'2013-12-27 20:07:59'),(433,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065116290.P.IN','06:51:16','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:51:16',NULL,NULL),(1662,'OutBound','1589','Completed','452721020.DSH.IC834.D140114.T230628204.P.IN','23:06:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:28',1,'2014-01-14 23:06:29'),(2228,'OutBound','3169','Completed','452721020.DSH.IC834.D140115.T001922143.P.IN','00:19:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:22',1,'2014-01-15 00:19:23'),(1140,'Inbound',NULL,'Completed','452721020.999.D131228.T1112373.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:16',NULL,'2014-01-05 16:51:19'),(1441,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703145.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:26:30',NULL,'2014-01-05 17:26:32'),(2140,'OutBound','1827','Completed','452721020.DSH.IC834.D140115.T001731286.P.IN','00:17:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:31',1,'2014-01-15 00:17:32'),(2290,'OutBound','668','Completed','452721020.DSH.IC834.D140115.T002042348.P.IN','00:20:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:42',1,'2014-01-15 00:20:43'),(2504,'OutBound','3388','Completed','452721020.DSH.IC834.D140115.T090453390.P.IN','09:04:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:53',1,'2014-01-15 09:04:53'),(1314,'Inbound',NULL,'Completed','452721020.999.D131228.T1112471.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:55',NULL,'2014-01-05 17:00:58'),(1641,'OutBound','123','Completed','452721020.DSH.IC834.D140114.T230600487.P.IN','23:06:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:00',1,'2014-01-14 23:06:01'),(2634,'Inbound',NULL,'Completed','452721020.999.D140115.T0133327.P.OUT','00:20:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:16:02',1,'2014-01-23 04:16:03'),(48,'Inbound',NULL,'Completed','452721020.I834.D131127.T1812143.P.OUT','18:05:00','2013-11-27','','CMSFFM','452721020',0,'2013-12-25 23:15:02',NULL,'2013-12-25 23:16:30'),(227,'OutBound','2311','Completed','452721020.DSH.IC834.D131227.T151207466.P.IN','15:12:07','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:12:07',1,'2013-12-27 20:12:08'),(1986,'OutBound','7720','Completed','452721020.DSH.IC834.D140114.T231522243.P.IN','23:15:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:22',1,'2014-01-14 23:15:23'),(2082,'OutBound','377','Completed','452721020.DSH.IC834.D140114.T231730975.P.IN','23:17:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:31',1,'2014-01-14 23:17:32'),(2157,'OutBound','1657','Completed','452721020.DSH.IC834.D140115.T001753913.P.IN','00:17:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:54',1,'2014-01-15 00:17:54'),(2413,'OutBound','3609','Completed','452721020.DSH.IC834.D140115.T090348961.P.IN','09:03:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:48',1,'2014-01-15 09:03:48'),(2792,'Inbound',NULL,'Completed','452721020.I834.D140210.T1837329.P.OUT','18:30:00','2014-02-10','','CMSFFM','452721020',0,'2014-02-10 21:30:03',NULL,'2014-02-10 21:32:19'),(249,'OutBound','39','Completed','452721020.DSH.IC834.D131227.T151924549.P.IN','15:19:24','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:19:24',1,'2013-12-27 20:19:25'),(361,'OutBound','874','Completed','452721020.DSH.IC834.D131227.T161305105.P.IN','16:13:05','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:13:05',1,'2013-12-27 21:13:05'),(1274,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113063.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:04',NULL,'2014-01-05 16:59:06'),(1329,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113578.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:37',NULL,'2014-01-05 17:01:39'),(1426,'Inbound',NULL,'Completed','452721020.999.D131228.T1112393.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:48',NULL,'2014-01-05 17:25:51'),(2808,'Inbound',NULL,'Completed','452721020.I834.D140218.T1838566.P.OUT','18:28:00','2014-02-18','','CMSFFM','452721020',0,'2014-02-18 22:00:02',0,'2014-02-18 22:01:48'),(174,'OutBound','2109','Completed','452721020.DSH.IC834.D131227.T144946174.P.IN','14:49:46','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:49:46',1,'2013-12-27 19:49:46'),(1766,'OutBound','2432','Completed','452721020.DSH.IC834.D140114.T230835789.P.IN','23:08:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:35',1,'2014-01-14 23:08:36'),(2206,'OutBound','3655','Completed','452721020.DSH.IC834.D140115.T001855964.P.IN','00:18:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:56',1,'2014-01-15 00:18:56'),(2372,'OutBound','5129','Completed','452721020.DSH.IC834.D140115.T090320878.P.IN','09:03:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:21',1,'2014-01-15 09:03:21'),(59,'Inbound',NULL,'Completed','452721020.I834.D131211.T1841311.P.OUT','18:36:00','2013-12-11','','CMSFFM','452721020',0,'2013-12-26 00:45:02',NULL,'2013-12-26 00:54:21'),(1481,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113506.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:14',NULL,'2014-01-13 03:02:15'),(1573,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114125.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:04:03',NULL,'2014-01-13 03:04:04'),(1712,'OutBound','836','Completed','452721020.DSH.IC834.D140114.T230728489.P.IN','23:07:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:28',1,'2014-01-14 23:07:28'),(1777,'OutBound','3802','Completed','452721020.DSH.IC834.D140114.T230849789.P.IN','23:08:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:49',1,'2014-01-14 23:08:50'),(458,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071204512.P.IN','07:12:04','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:12:04',NULL,NULL),(2184,'OutBound','5138','Completed','452721020.DSH.IC834.D140115.T001827242.P.IN','00:18:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:27',1,'2014-01-15 00:18:29'),(2363,'OutBound','5133','Completed','452721020.DSH.IC834.D140115.T090315710.P.IN','09:03:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:15',1,'2014-01-15 09:03:16'),(1465,'Inbound',NULL,'Completed','452721020.999.D131228.T1112424.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:37',NULL,'2014-01-05 17:27:39'),(2303,'OutBound','717','Completed','452721020.DSH.IC834.D140115.T002058552.P.IN','00:20:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:58',1,'2014-01-15 00:20:59'),(2436,'OutBound','3114','Completed','452721020.DSH.IC834.D140115.T090405966.P.IN','09:04:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:06',1,'2014-01-15 09:04:06'),(1142,'Inbound',NULL,'Completed','452721020.999.D131228.T1113075.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:22',NULL,'2014-01-05 16:51:24'),(1343,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112273.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:16',NULL,'2014-01-05 17:02:18'),(1503,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114040.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:34',NULL,'2014-01-13 03:02:35'),(1843,'OutBound','5145','Completed','452721020.DSH.IC834.D140114.T231016865.P.IN','23:10:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:16',1,'2014-01-14 23:10:18'),(2390,'OutBound','5136','Completed','452721020.DSH.IC834.D140115.T090331953.P.IN','09:03:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:32',1,'2014-01-15 09:03:32'),(1293,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113051.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:57',NULL,'2014-01-05 16:59:59'),(1733,'OutBound','447','Completed','452721020.DSH.IC834.D140114.T230752748.P.IN','23:07:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:52',1,'2014-01-14 23:07:53'),(1892,'OutBound','3005','Completed','452721020.DSH.IC834.D140114.T231123663.P.IN','23:11:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:23',1,'2014-01-14 23:11:24'),(1951,'OutBound','3928','Completed','452721020.DSH.IC834.D140114.T231442844.P.IN','23:14:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:42',1,'2014-01-14 23:14:43'),(2021,'OutBound','5389','Completed','452721020.DSH.IC834.D140114.T231612156.P.IN','23:16:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:12',1,'2014-01-14 23:16:13'),(2124,'OutBound','2056','Completed','452721020.DSH.IC834.D140115.T001711692.P.IN','00:17:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:11',1,'2014-01-15 00:17:12'),(2164,'OutBound','5133','Completed','452721020.DSH.IC834.D140115.T001802700.P.IN','00:18:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:02',1,'2014-01-15 00:18:03'),(2167,'OutBound','5126','Completed','452721020.DSH.IC834.D140115.T001806363.P.IN','00:18:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:06',1,'2014-01-15 00:18:07'),(2400,'OutBound','3630','Completed','452721020.DSH.IC834.D140115.T090338616.P.IN','09:03:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:38',1,'2014-01-15 09:03:39'),(2777,'Inbound',NULL,'Completed','452721020.I834.D140203.T1842395.P.OUT','18:32:00','2014-02-03','','CMSFFM','452721020',0,'2014-02-03 21:00:03',NULL,'2014-02-03 21:01:39'),(1679,'OutBound','5348','Completed','452721020.DSH.IC834.D140114.T230647193.P.IN','23:06:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:47',1,'2014-01-14 23:06:48'),(1888,'OutBound','3656','Completed','452721020.DSH.IC834.D140114.T231118184.P.IN','23:11:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:18',1,'2014-01-14 23:11:19'),(1926,'OutBound','5875','Completed','452721020.DSH.IC834.D140114.T231413883.P.IN','23:14:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:13',1,'2014-01-14 23:14:14'),(2295,'OutBound','689','Completed','452721020.DSH.IC834.D140115.T002048593.P.IN','00:20:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:48',1,'2014-01-15 00:20:49'),(2496,'OutBound','684','Completed','452721020.DSH.IC834.D140115.T090447904.P.IN','09:04:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:48',1,'2014-01-15 09:04:48'),(1411,'Inbound',NULL,'Completed','452721020.999.D131228.T1112358.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:06',NULL,'2014-01-05 17:25:09'),(2160,'OutBound','1781','Completed','452721020.DSH.IC834.D140115.T001757658.P.IN','00:17:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:57',1,'2014-01-15 00:17:58'),(194,'OutBound','1689','Completed','452721020.DSH.IC834.D131227.T145713591.P.IN','14:57:13','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:57:13',1,'2013-12-27 19:57:14'),(367,'OutBound','2147','Completed','452721020.DSH.IC834.D131227.T161756165.P.IN','16:17:56','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:17:56',1,'2013-12-27 21:17:56'),(1393,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113294.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:16',NULL,'2014-01-05 17:24:19'),(1771,'OutBound','2336','Completed','452721020.DSH.IC834.D140114.T230841947.P.IN','23:08:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:42',1,'2014-01-14 23:08:43'),(1912,'OutBound','3016','Completed','452721020.DSH.IC834.D140114.T231150668.P.IN','23:11:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:50',1,'2014-01-14 23:11:51'),(2727,'Inbound',NULL,'Completed','452721020.999.D140115.T0258249.P.OUT','01:09:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 08:30:02',NULL,'2014-01-23 08:30:03'),(2768,'OutBound','5011','Completed','452721020.DSH.IC834.D140129.T134631171.P.IN','13:46:31','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:32',1,'2014-01-29 13:46:32'),(374,'OutBound','5059','Completed','452721020.DSH.IC834.D131227.T163143945.P.IN','16:31:43','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:31:44',1,'2013-12-27 21:31:44'),(1181,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112459.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:09',NULL,'2014-01-05 16:53:12'),(1387,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112593.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:00',NULL,'2014-01-05 17:24:02'),(2335,'OutBound','1986','Completed','452721020.DSH.IC834.D140115.T090259919.P.IN','09:02:59','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:00',1,'2014-01-15 09:03:00'),(2342,'OutBound','1779','Completed','452721020.DSH.IC834.D140115.T090303712.P.IN','09:03:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:03',1,'2014-01-15 09:03:04'),(320,'OutBound','2625','Completed','452721020.DSH.IC834.D131227.T154355954.P.IN','15:43:55','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:43:56',1,'2013-12-27 20:43:56'),(452,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070617717.P.IN','07:06:17','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:06:18',NULL,NULL),(1598,'OutBound','1106','Completed','452721020.DSH.IC834.D140114.T230509687.P.IN','23:05:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:09',1,'2014-01-14 23:05:10'),(1626,'OutBound','7370','Completed','452721020.DSH.IC834.D140114.T230543842.P.IN','23:05:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:43',1,'2014-01-14 23:05:44'),(2147,'OutBound','1659','Completed','452721020.DSH.IC834.D140115.T001740626.P.IN','00:17:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:40',1,'2014-01-15 00:17:41'),(197,'OutBound','26','Completed','452721020.DSH.IC834.D131227.T145813249.P.IN','14:58:13','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:58:13',1,'2013-12-27 19:58:13'),(549,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113643989.T.IN','11:36:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:44',NULL,NULL),(1687,'OutBound','4489','Completed','452721020.DSH.IC834.D140114.T230657268.P.IN','23:06:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:57',1,'2014-01-14 23:06:58'),(2237,'OutBound','3114','Completed','452721020.DSH.IC834.D140115.T001935213.P.IN','00:19:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:35',1,'2014-01-15 00:19:36'),(2385,'OutBound','5149','Completed','452721020.DSH.IC834.D140115.T090328834.P.IN','09:03:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:28',1,'2014-01-15 09:03:29'),(2608,'Inbound',NULL,'Completed','452721020.999.D140115.T0338016.P.OUT','02:11:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:55:56',1,'2014-01-23 03:55:56'),(2631,'Inbound',NULL,'Completed','452721020.999.D140115.T0242356.P.OUT','00:26:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:13:53',1,'2014-01-23 04:13:53'),(257,'OutBound','2125','Completed','452721020.DSH.IC834.D131227.T152333318.P.IN','15:23:33','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:23:33',1,'2013-12-27 20:23:34'),(349,'OutBound','2133','Completed','452721020.DSH.IC834.D131227.T160225122.P.IN','16:02:25','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:02:25',1,'2013-12-27 21:02:25'),(1608,'OutBound','4490','Completed','452721020.DSH.IC834.D140114.T230522983.P.IN','23:05:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:23',1,'2014-01-14 23:05:23'),(1819,'OutBound','1823','Completed','452721020.DSH.IC834.D140114.T230945760.P.IN','23:09:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:45',1,'2014-01-14 23:09:46'),(1869,'OutBound','3655','Completed','452721020.DSH.IC834.D140114.T231053316.P.IN','23:10:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:53',1,'2014-01-14 23:10:54'),(1885,'OutBound','3657','Completed','452721020.DSH.IC834.D140114.T231113460.P.IN','23:11:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:13',1,'2014-01-14 23:11:14'),(2296,'OutBound','683','Completed','452721020.DSH.IC834.D140115.T002049833.P.IN','00:20:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:49',1,'2014-01-15 00:20:50'),(29,'Inbound',NULL,'Completed','452721020.I834.D131206.T1826370.P.OUT','18:21:00','2013-12-06','','CMSFFM','452721020',0,'2013-12-25 20:15:02',NULL,'2013-12-25 20:20:34'),(195,'OutBound','2964','Completed','452721020.DSH.IC834.D131227.T145731415.P.IN','14:57:31','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:57:31',1,'2013-12-27 19:57:32'),(471,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071630455.P.IN','07:16:30','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:16:30',NULL,NULL),(1237,'Inbound',NULL,'Completed','452721020.999.D131228.T1114040.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:21',NULL,'2014-01-05 16:57:23'),(1453,'Inbound',NULL,'Completed','452721020.999.D131228.T1114072.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:03',NULL,'2014-01-05 17:27:06'),(1535,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113423.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:28',NULL,'2014-01-13 03:03:29'),(1778,'OutBound','3799','Completed','452721020.DSH.IC834.D140114.T230850942.P.IN','23:08:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:51',1,'2014-01-14 23:08:52'),(1815,'OutBound','1819','Completed','452721020.DSH.IC834.D140114.T230940762.P.IN','23:09:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:40',1,'2014-01-14 23:09:41'),(1896,'OutBound','3007','Completed','452721020.DSH.IC834.D140114.T231129105.P.IN','23:11:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:29',1,'2014-01-14 23:11:30'),(2482,'OutBound','5884','Completed','452721020.DSH.IC834.D140115.T090438643.P.IN','09:04:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:38',1,'2014-01-15 09:04:39'),(1324,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502297.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:23',NULL,'2014-01-05 17:01:25'),(1406,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113025.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:52',NULL,'2014-01-05 17:24:55'),(1781,'OutBound','2054','Completed','452721020.DSH.IC834.D140114.T230854755.P.IN','23:08:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:54',1,'2014-01-14 23:08:55'),(2701,'Inbound',NULL,'Completed','452721020.999.D140115.T0330344.P.OUT','01:35:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:41:04',NULL,'2014-01-23 06:41:05'),(1899,'OutBound','3167','Completed','452721020.DSH.IC834.D140114.T231132763.P.IN','23:11:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:32',1,'2014-01-14 23:11:33'),(2132,'OutBound','1988','Completed','452721020.DSH.IC834.D140115.T001721794.P.IN','00:17:21','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:21',1,'2014-01-15 00:17:22'),(185,'OutBound','2949','Completed','452721020.DSH.IC834.D131227.T145326839.P.IN','14:53:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:53:27',1,'2013-12-27 19:53:27'),(537,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111843628.P.IN','11:18:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:18:44',NULL,NULL),(1152,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112495.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:49',NULL,'2014-01-05 16:51:52'),(1344,'Inbound',NULL,'Completed','452721020.999.D131228.T1112561.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:19',NULL,'2014-01-05 17:02:21'),(1808,'OutBound','1821','Completed','452721020.DSH.IC834.D140114.T230932642.P.IN','23:09:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:32',1,'2014-01-14 23:09:33'),(1865,'OutBound','3651','Completed','452721020.DSH.IC834.D140114.T231048191.P.IN','23:10:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:48',1,'2014-01-14 23:10:49'),(2194,'OutBound','5161','Completed','452721020.DSH.IC834.D140115.T001841949.P.IN','00:18:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:42',1,'2014-01-15 00:18:42'),(2545,'OutBound','3393','Completed','452721020.DSH.IC834.D140120.T054423395.P.IN','05:44:23','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:23',1,'2014-01-20 05:44:23'),(49,'Inbound',NULL,'Completed','452721020.I834.D131106.T1810030.P.OUT','18:03:00','2013-11-06','','CMSFFM','452721020',0,'2013-12-25 23:16:30',NULL,'2013-12-25 23:17:21'),(1484,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114112.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:17',NULL,'2014-01-13 03:02:18'),(1592,'OutBound','2589','Completed','452721020.DSH.IC834.D140114.T230502633.P.IN','23:05:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:02',1,'2014-01-14 23:05:03'),(1653,'OutBound','5282','Completed','452721020.DSH.IC834.D140114.T230614190.P.IN','23:06:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:14',1,'2014-01-14 23:06:15'),(2070,'OutBound','447','Completed','452721020.DSH.IC834.D140114.T231714267.P.IN','23:17:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:14',1,'2014-01-14 23:17:15'),(2089,'OutBound','142','Completed','452721020.DSH.IC834.D140114.T231740126.P.IN','23:17:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:40',1,'2014-01-14 23:17:41'),(532,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.111037313.P.IN','11:10:37','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:10:37',NULL,NULL),(1719,'OutBound','1024','Completed','452721020.DSH.IC834.D140114.T230736151.P.IN','23:07:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:36',1,'2014-01-14 23:07:37'),(2064,'OutBound','967','Completed','452721020.DSH.IC834.D140114.T231707327.P.IN','23:17:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:07',1,'2014-01-14 23:17:08'),(2108,'OutBound','2336','Completed','452721020.DSH.IC834.D140114.T231804522.P.IN','23:18:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:18:04',1,'2014-01-14 23:18:05'),(2513,'OutBound','1531','Completed','452721020.DSH.IC834.D140115.T222141524.P.IN','22:21:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:41',1,'2014-01-15 22:21:41'),(444,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065809570.P.IN','06:58:09','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:58:09',NULL,NULL),(1701,'OutBound','1063','Completed','452721020.DSH.IC834.D140114.T230715218.P.IN','23:07:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:15',1,'2014-01-14 23:07:15'),(2040,'OutBound','1003','Completed','452721020.DSH.IC834.D140114.T231637316.P.IN','23:16:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:37',1,'2014-01-14 23:16:38'),(2355,'OutBound','1823','Completed','452721020.DSH.IC834.D140115.T090310917.P.IN','09:03:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:11',1,'2014-01-15 09:03:11'),(334,'OutBound','61','Completed','452721020.DSH.IC834.D131227.T154916854.P.IN','15:49:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:49:17',1,'2013-12-27 20:49:17'),(1159,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113452.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:09',NULL,'2014-01-05 16:52:11'),(1473,'Inbound',NULL,'Completed','452721020.I834.D140111.T1821554.P.OUT','18:16:00','2014-01-11','','CMSFFM','452721020',0,'2014-01-13 02:18:04',NULL,'2014-01-13 02:18:43'),(1883,'OutBound','3640','Completed','452721020.DSH.IC834.D140114.T231110896.P.IN','23:11:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:11',1,'2014-01-14 23:11:11'),(2553,'Inbound',NULL,'Completed','452721020.I834.D140119.T1817085.P.OUT','18:08:00','2014-01-19','','CMSFFM','452721020',0,'2014-01-21 08:45:15',NULL,'2014-01-21 08:45:44'),(2708,'Inbound',NULL,'Completed','452721020.999.D140114.T2353460.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:45:45',NULL,'2014-01-23 06:45:45'),(1528,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113499.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:21',NULL,'2014-01-13 03:03:22'),(1789,'OutBound','2071','Completed','452721020.DSH.IC834.D140114.T230907415.P.IN','23:09:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:07',1,'2014-01-14 23:09:08'),(2319,'OutBound','1985','Completed','452721020.DSH.IC834.D140115.T090251100.P.IN','09:02:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:51',1,'2014-01-15 09:02:51'),(1361,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112504.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:47',NULL,'2014-01-05 17:22:49'),(1669,'OutBound','4850','Completed','452721020.DSH.IC834.D140114.T230636152.P.IN','23:06:36','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:36',1,'2014-01-14 23:06:37'),(2185,'OutBound','5141','Completed','452721020.DSH.IC834.D140115.T001829454.P.IN','00:18:29','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:29',1,'2014-01-15 00:18:30'),(2760,'Inbound',NULL,'Completed','452721020.I834.D140128.T1838136.P.OUT','18:32:00','2014-01-28','','CMSFFM','452721020',0,'2014-01-28 21:00:02',NULL,'2014-01-28 21:01:24'),(43,'Inbound',NULL,'Completed','452721020.I834.D131010.T1807002.P.OUT','18:01:00','2013-10-10','','CMSFFM','452721020',0,'2013-12-25 22:30:52',NULL,'2013-12-25 22:31:19'),(468,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071521408.P.IN','07:15:21','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:15:21',NULL,NULL),(1335,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112358.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:54',NULL,'2014-01-05 17:01:56'),(1342,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113012.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:13',NULL,'2014-01-05 17:02:16'),(1709,'OutBound','2239','Completed','452721020.DSH.IC834.D140114.T230724473.P.IN','23:07:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:24',1,'2014-01-14 23:07:25'),(1764,'OutBound','2444','Completed','452721020.DSH.IC834.D140114.T230833250.P.IN','23:08:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:33',1,'2014-01-14 23:08:34'),(193,'OutBound','4117','Completed','452721020.DSH.IC834.D131227.T145705943.P.IN','14:57:05','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:57:06',1,'2013-12-27 19:57:06'),(1794,'OutBound','2057','Completed','452721020.DSH.IC834.D140114.T230914241.P.IN','23:09:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:14',1,'2014-01-14 23:09:15'),(2403,'OutBound','3649','Completed','452721020.DSH.IC834.D140115.T090340788.P.IN','09:03:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:40',1,'2014-01-15 09:03:41'),(179,'OutBound','70','Completed','452721020.DSH.IC834.D131227.T145143935.P.IN','14:51:43','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:51:44',1,'2013-12-27 19:51:44'),(252,'OutBound','1860','Completed','452721020.DSH.IC834.D131227.T152104913.P.IN','15:21:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:21:04',1,'2013-12-27 20:21:04'),(272,'OutBound','5062','Completed','452721020.DSH.IC834.D131227.T152851445.P.IN','15:28:51','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:28:51',1,'2013-12-27 20:28:52'),(1328,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112349.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:34',NULL,'2014-01-05 17:01:37'),(1482,'Inbound',NULL,'Completed','452721020.999.D131228.T0502329.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:15',NULL,'2014-01-13 03:02:16'),(1500,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113381.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:31',NULL,'2014-01-13 03:02:32'),(2558,'Inbound',NULL,'Completed','452721020.999.D140115.T0352579.P.OUT','02:47:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 03:39:19',NULL,'2014-01-23 03:39:20'),(2765,'OutBound','2601','Completed','452721020.DSH.IC834.D140129.T134629451.P.IN','13:46:29','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:29',1,'2014-01-29 13:46:29'),(76,'Inbound',NULL,'Completed','452721020.I834.D131122.T1816533.P.OUT','18:08:00','2013-11-22','','CMSFFM','452721020',0,'2013-12-26 03:15:01',NULL,'2013-12-26 03:16:38'),(499,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104903206.P.IN','10:49:03','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:49:03',NULL,NULL),(1137,'Inbound',NULL,'Completed','452721020.999.D131228.T1113487.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:08',NULL,'2014-01-05 16:51:10'),(1995,'OutBound','2563','Completed','452721020.DSH.IC834.D140114.T231533973.P.IN','23:15:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:34',1,'2014-01-14 23:15:35'),(2300,'OutBound','670','Completed','452721020.DSH.IC834.D140115.T002054657.P.IN','00:20:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:54',1,'2014-01-15 00:20:55'),(2313,'OutBound','3802','Completed','452721020.DSH.IC834.D140115.T090247839.P.IN','09:02:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:47',1,'2014-01-15 09:02:48'),(2364,'OutBound','5154','Completed','452721020.DSH.IC834.D140115.T090316211.P.IN','09:03:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:16',1,'2014-01-15 09:03:16'),(2514,'OutBound','1491','Completed','452721020.DSH.IC834.D140115.T222142351.P.IN','22:21:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:42',1,'2014-01-15 22:21:42'),(2549,'OutBound','3395','Completed','452721020.DSH.IC834.D140120.T054425847.P.IN','05:44:25','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:25',1,'2014-01-20 05:44:25'),(2714,'Inbound',NULL,'Completed','452721020.999.D140115.T1103012.P.OUT','10:28:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 07:00:02',NULL,'2014-01-23 07:00:02'),(1241,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113276.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:32',NULL,'2014-01-05 16:57:34'),(1295,'Inbound',NULL,'Completed','452721020.999.D131228.T1112541.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:02',NULL,'2014-01-05 17:00:05'),(1298,'Inbound',NULL,'Completed','452721020.999.D131228.T1113174.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:11',NULL,'2014-01-05 17:00:13'),(1588,'OutBound','6040','Completed','452721020.DSH.IC834.D140114.T230458203.P.IN','23:04:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:58',1,'2014-01-14 23:04:59'),(2497,'OutBound','706','Completed','452721020.DSH.IC834.D140115.T090448554.P.IN','09:04:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:48',1,'2014-01-15 09:04:49'),(2819,'Inbound',NULL,'Completed','452721020.I834.D140225.T1843146.P.OUT','18:36:00','2014-02-25','','CMSFFM','452721020',0,'2014-02-25 21:30:02',0,'2014-02-25 21:32:11'),(1383,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112445.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:48',NULL,'2014-01-05 17:23:51'),(1715,'OutBound','838','Completed','452721020.DSH.IC834.D140114.T230731642.P.IN','23:07:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:31',1,'2014-01-14 23:07:32'),(1345,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113008.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:22',NULL,'2014-01-05 17:02:24'),(1927,'OutBound','2586','Completed','452721020.DSH.IC834.D140114.T231414934.P.IN','23:14:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:15',1,'2014-01-14 23:14:15'),(1996,'OutBound','2552','Completed','452721020.DSH.IC834.D140114.T231535658.P.IN','23:15:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:35',1,'2014-01-14 23:15:37'),(2635,'Inbound',NULL,'Completed','452721020.999.D140115.T0356485.P.OUT','03:08:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:16:56',1,'2014-01-23 04:16:57'),(279,'OutBound','5017','Completed','452721020.DSH.IC834.D131227.T153123369.P.IN','15:31:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:23',1,'2013-12-27 20:31:24'),(1273,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113291.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:01',NULL,'2014-01-05 16:59:03'),(1792,'OutBound','1990','Completed','452721020.DSH.IC834.D140114.T230911575.P.IN','23:09:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:11',1,'2014-01-14 23:09:12'),(2093,'OutBound','119','Completed','452721020.DSH.IC834.D140114.T231744973.P.IN','23:17:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:45',1,'2014-01-14 23:17:45'),(2733,'Inbound',NULL,'Completed','452721020.999.D140114.T2349298.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 09:28:28',NULL,'2014-01-23 09:28:28'),(2832,'Inbound',NULL,'Completed','452721020.I834.D140301.T1832514.P.OUT','18:23:00','2014-03-01','','CMSFFM','452721020',0,'2014-03-01 21:00:07',0,'2014-03-01 21:01:12'),(542,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.112234680.T.IN','11:22:34','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:22:34',NULL,NULL),(1688,'OutBound','4494','Completed','452721020.DSH.IC834.D140114.T230658396.P.IN','23:06:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:58',1,'2014-01-14 23:06:59'),(1713,'OutBound','1004','Completed','452721020.DSH.IC834.D140114.T230729134.P.IN','23:07:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:29',1,'2014-01-14 23:07:30'),(2118,'OutBound','2054','Completed','452721020.DSH.IC834.D140115.T001704772.P.IN','00:17:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:04',1,'2014-01-15 00:17:05'),(2807,'Inbound',NULL,'Completed','452721020.CIC834.D140218.T1832475.P.OUT','18:25:00','2014-02-18','','CMSFFM','452721020',0,'2014-02-18 21:30:02',0,'2014-02-18 21:30:25'),(4,'Inbound',NULL,'Completed','452721020.I834.D131011.T1806443.P.OUT','18:01:00','2013-10-11','','CMSFFM','452721020',0,'2013-12-25 17:31:34',NULL,'2013-12-25 17:31:50'),(1316,'Inbound',NULL,'Completed','452721020.999.D131228.T1112298.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:01',NULL,'2014-01-05 17:01:03'),(1591,'OutBound','157','Completed','452721020.DSH.IC834.D140114.T230501535.P.IN','23:05:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:01',1,'2014-01-14 23:05:02'),(1711,'OutBound','2237','Completed','452721020.DSH.IC834.D140114.T230726885.P.IN','23:07:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:27',1,'2014-01-14 23:07:27'),(2032,'OutBound','4402','Completed','452721020.DSH.IC834.D140114.T231627158.P.IN','23:16:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:27',1,'2014-01-14 23:16:28'),(2068,'OutBound','969','Completed','452721020.DSH.IC834.D140114.T231711933.P.IN','23:17:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:12',1,'2014-01-14 23:17:12'),(2207,'OutBound','3639','Completed','452721020.DSH.IC834.D140115.T001857703.P.IN','00:18:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:57',1,'2014-01-15 00:18:57'),(2734,'Inbound',NULL,'Completed','452721020.999.D140115.T0114589.P.OUT','00:05:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 09:30:02',NULL,'2014-01-23 09:30:03'),(214,'OutBound','5069','Completed','452721020.DSH.IC834.D131227.T150716327.P.IN','15:07:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:07:16',1,'2013-12-27 20:07:17'),(1252,'Inbound',NULL,'Completed','452721020.999.D131228.T1113535.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:03',NULL,'2014-01-05 16:58:05'),(1745,'OutBound','377','Completed','452721020.DSH.IC834.D140114.T230809670.P.IN','23:08:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:09',1,'2014-01-14 23:08:10'),(2530,'OutBound','11615','Completed','452721020.DSH.IC834.D140115.T222151590.P.IN','22:21:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:51',1,'2014-01-15 22:21:51'),(428,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.064342689.P.IN','06:43:42','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:43:43',NULL,NULL),(1947,'OutBound','3821','Completed','452721020.DSH.IC834.D140114.T231437235.P.IN','23:14:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:37',1,'2014-01-14 23:14:38'),(2129,'OutBound','1990','Completed','452721020.DSH.IC834.D140115.T001717580.P.IN','00:17:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:17',1,'2014-01-15 00:17:18'),(2145,'OutBound','1821','Completed','452721020.DSH.IC834.D140115.T001738191.P.IN','00:17:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:38',1,'2014-01-15 00:17:39'),(2212,'OutBound','3608','Completed','452721020.DSH.IC834.D140115.T001902647.P.IN','00:19:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:02',1,'2014-01-15 00:19:03'),(2627,'Inbound',NULL,'Completed','452721020.999.D140115.T0015416.P.OUT','23:35:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:10:00',1,'2014-01-23 04:10:01'),(2442,'OutBound','2849','Completed','452721020.DSH.IC834.D140115.T090410337.P.IN','09:04:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:10',1,'2014-01-15 09:04:10'),(2761,'OutBound','3628','Completed','452721020.DSH.IC834.D140129.T133955102.P.IN','13:39:55','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:39:55',1,'2014-01-29 13:39:55'),(2780,'Inbound',NULL,'Completed','452721020.CIC834.D140205.T1841547.P.OUT','18:36:00','2014-02-05','','CMSFFM','452721020',0,'2014-02-05 21:00:03',NULL,'2014-02-05 21:00:08'),(1153,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113408.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:52',NULL,'2014-01-05 16:51:55'),(1282,'Inbound',NULL,'Completed','452721020.999.D131228.T1113554.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:26',NULL,'2014-01-05 16:59:28'),(1617,'OutBound','3901','Completed','452721020.DSH.IC834.D140114.T230532928.P.IN','23:05:32','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:33',1,'2014-01-14 23:05:33'),(2510,'OutBound','1514','Completed','452721020.DSH.IC834.D140115.T222139778.P.IN','22:21:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:39',1,'2014-01-15 22:21:40'),(569,'Inbound',NULL,'Completed','452721020.I834.D140103.T1846594.P.OUT','18:38:00','2014-01-03','','CMSFFM','452721020',0,'2014-01-04 02:00:02',NULL,'2014-01-04 02:06:24'),(1191,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113142.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:37',NULL,'2014-01-05 16:53:39'),(1219,'Inbound',NULL,'Completed','452721020.999.D131228.T1113008.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:55',NULL,'2014-01-05 16:54:57'),(1664,'OutBound','4884','Completed','452721020.DSH.IC834.D140114.T230630394.P.IN','23:06:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:30',1,'2014-01-14 23:06:31'),(1513,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113205.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:44',NULL,'2014-01-13 03:03:05'),(1402,'Inbound',NULL,'Completed','452721020.999.D131228.T1112427.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:41',NULL,'2014-01-05 17:24:44'),(2341,'OutBound','1822','Completed','452721020.DSH.IC834.D140115.T090303173.P.IN','09:03:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:03',1,'2014-01-15 09:03:03'),(2475,'OutBound','5956','Completed','452721020.DSH.IC834.D140115.T090434204.P.IN','09:04:34','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:34',1,'2014-01-15 09:04:34'),(277,'OutBound','2403','Completed','452721020.DSH.IC834.D131227.T153103171.P.IN','15:31:03','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:03',1,'2013-12-27 20:31:03'),(1272,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112489.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:58',NULL,'2014-01-05 16:59:01'),(1813,'OutBound','1780','Completed','452721020.DSH.IC834.D140114.T230938440.P.IN','23:09:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:38',1,'2014-01-14 23:09:39'),(2660,'Inbound',NULL,'Completed','452721020.999.D140115.T0304009.P.OUT','01:22:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:34:32',1,'2014-01-23 04:34:33'),(330,'OutBound','4220','Completed','452721020.DSH.IC834.D131227.T154818928.P.IN','15:48:18','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:48:19',1,'2013-12-27 20:48:19'),(1183,'Inbound',NULL,'Completed','452721020.999.D131228.T1114123.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:15',NULL,'2014-01-05 16:53:17'),(1266,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112326.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:42',NULL,'2014-01-05 16:58:44'),(1635,'OutBound','4824','Completed','452721020.DSH.IC834.D140114.T230553754.P.IN','23:05:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:53',1,'2014-01-14 23:05:54'),(2327,'OutBound','1980','Completed','452721020.DSH.IC834.D140115.T090255373.P.IN','09:02:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:55',1,'2014-01-15 09:02:55'),(2726,'Inbound',NULL,'Completed','452721020.999.D140115.T0202570.P.OUT','00:48:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 08:22:15',NULL,'2014-01-23 08:22:15'),(287,'OutBound','3474','Completed','452721020.DSH.IC834.D131227.T153257139.P.IN','15:32:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:32:57',1,'2013-12-27 20:32:57'),(457,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070745950.P.IN','07:07:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:07:46',NULL,NULL),(1389,'Inbound',NULL,'Completed','452721020.999.D131228.T1114032.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:05',NULL,'2014-01-05 17:24:07'),(1977,'OutBound','124','Completed','452721020.DSH.IC834.D140114.T231511359.P.IN','23:15:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:11',1,'2014-01-14 23:15:12'),(2173,'OutBound','5129','Completed','452721020.DSH.IC834.D140115.T001814320.P.IN','00:18:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:14',1,'2014-01-15 00:18:15'),(2203,'OutBound','1487','Completed','452721020.DSH.IC834.D140115.T001852441.P.IN','00:18:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:52',1,'2014-01-15 00:18:53'),(2282,'OutBound','5980','Completed','452721020.DSH.IC834.D140115.T002031597.P.IN','00:20:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:31',1,'2014-01-15 00:20:32'),(2377,'OutBound','5130','Completed','452721020.DSH.IC834.D140115.T090324114.P.IN','09:03:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:24',1,'2014-01-15 09:03:24'),(1430,'Inbound',NULL,'Completed','452721020.999.D131228.T1113168.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:59',NULL,'2014-01-05 17:26:02'),(1895,'OutBound','3168','Completed','452721020.DSH.IC834.D140114.T231127897.P.IN','23:11:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:28',1,'2014-01-14 23:11:28'),(2046,'OutBound','2239','Completed','452721020.DSH.IC834.D140114.T231644414.P.IN','23:16:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:44',1,'2014-01-14 23:16:45'),(2659,'Inbound',NULL,'Completed','452721020.999.D140115.T0237526.P.OUT','00:17:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:33:55',1,'2014-01-23 04:33:56'),(1340,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113005.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:08',NULL,'2014-01-05 17:02:10'),(1984,'OutBound','5406','Completed','452721020.DSH.IC834.D140114.T231519874.P.IN','23:15:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:19',1,'2014-01-14 23:15:20'),(2142,'OutBound','1822','Completed','452721020.DSH.IC834.D140115.T001733731.P.IN','00:17:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:33',1,'2014-01-15 00:17:35'),(2783,'Inbound',NULL,'Completed','452721020.CIC834.D140206.T1833270.P.OUT','18:26:00','2014-02-06','','CMSFFM','452721020',0,'2014-02-06 21:30:02',NULL,'2014-02-06 21:30:07'),(1448,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113459.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:50',NULL,'2014-01-05 17:26:52'),(1505,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114131.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:36',NULL,'2014-01-13 03:02:36'),(1522,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113227.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:13',NULL,'2014-01-13 03:03:16'),(1841,'OutBound','5130','Completed','452721020.DSH.IC834.D140114.T231014215.P.IN','23:10:14','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:14',1,'2014-01-14 23:10:15'),(1975,'OutBound','146','Completed','452721020.DSH.IC834.D140114.T231509179.P.IN','23:15:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:09',1,'2014-01-14 23:15:10'),(2478,'OutBound','5883','Completed','452721020.DSH.IC834.D140115.T090436386.P.IN','09:04:36','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:36',1,'2014-01-15 09:04:36'),(2170,'OutBound','7173','Completed','452721020.DSH.IC834.D140115.T001810118.P.IN','00:18:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:10',1,'2014-01-15 00:18:11'),(2294,'OutBound','675','Completed','452721020.DSH.IC834.D140115.T002047229.P.IN','00:20:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:47',1,'2014-01-15 00:20:48'),(239,'OutBound','4871','Completed','452721020.DSH.IC834.D131227.T151557574.P.IN','15:15:57','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:15:57',1,'2013-12-27 20:15:58'),(323,'OutBound','60','Completed','452721020.DSH.IC834.D131227.T154527183.P.IN','15:45:27','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:45:27',1,'2013-12-27 20:45:27'),(348,'OutBound','6132','Completed','452721020.DSH.IC834.D131227.T160123426.P.IN','16:01:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:01:23',1,'2013-12-27 21:01:24'),(1271,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112240.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:55',NULL,'2014-01-05 16:58:58'),(2632,'Inbound',NULL,'Completed','452721020.999.D140115.T0154054.P.OUT','00:37:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:14:29',1,'2014-01-23 04:14:30'),(24,'Inbound',NULL,'Completed','452721020.I834.D131015.T1807295.P.OUT','18:01:00','2013-10-15','','CMSFFM','452721020',0,'2013-12-25 20:00:02',NULL,'2013-12-25 20:00:15'),(177,'OutBound','6017','Completed','452721020.DSH.IC834.D131227.T145116780.P.IN','14:51:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:51:17',1,'2013-12-27 19:51:17'),(523,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110256234.P.IN','11:02:56','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:02:56',NULL,NULL),(1380,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114055.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:40',NULL,'2014-01-05 17:23:42'),(2578,'Inbound',NULL,'Completed','452721020.999.D140114.T2350587.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:43:43',1,'2014-01-23 03:43:44'),(201,'OutBound','2970','Completed','452721020.DSH.IC834.D131227.T145933426.P.IN','14:59:33','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:59:33',1,'2013-12-27 19:59:34'),(1502,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113288.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:33',NULL,'2014-01-13 03:02:34'),(1551,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113522.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:43',NULL,'2014-01-13 03:03:44'),(2159,'OutBound','1662','Completed','452721020.DSH.IC834.D140115.T001756501.P.IN','00:17:56','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:56',1,'2014-01-15 00:17:57'),(2232,'OutBound','3168','Completed','452721020.DSH.IC834.D140115.T001927224.P.IN','00:19:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:27',1,'2014-01-15 00:19:29'),(2251,'OutBound','4158','Completed','452721020.DSH.IC834.D140115.T001954125.P.IN','00:19:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:54',1,'2014-01-15 00:19:55'),(2293,'OutBound','718','Completed','452721020.DSH.IC834.D140115.T002045967.P.IN','00:20:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:46',1,'2014-01-15 00:20:47'),(2511,'OutBound','11619','Completed','452721020.DSH.IC834.D140115.T222140489.P.IN','22:21:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:40',1,'2014-01-15 22:21:40'),(2668,'Inbound',NULL,'Completed','452721020.999.D140115.T0033234.P.OUT','23:45:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:47:53',1,'2014-01-23 04:47:53'),(398,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061746998.P.IN','06:17:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:17:47',NULL,NULL),(1738,'OutBound','384','Completed','452721020.DSH.IC834.D140114.T230800784.P.IN','23:08:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:00',1,'2014-01-14 23:08:01'),(2486,'OutBound','674','Completed','452721020.DSH.IC834.D140115.T090441945.P.IN','09:04:41','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:41',1,'2014-01-15 09:04:41'),(2604,'Inbound',NULL,'Completed','452721020.999.D140115.T0129455.P.OUT','00:16:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:52:37',1,'2014-01-23 03:52:37'),(270,'OutBound','1066','Completed','452721020.DSH.IC834.D131227.T152754518.P.IN','15:27:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:27:54',1,'2013-12-27 20:27:55'),(1166,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112485.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:28',NULL,'2014-01-05 16:52:30'),(1696,'OutBound','4399','Completed','452721020.DSH.IC834.D140114.T230708520.P.IN','23:07:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:08',1,'2014-01-14 23:07:09'),(1847,'OutBound','5138','Completed','452721020.DSH.IC834.D140114.T231022679.P.IN','23:10:22','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:22',1,'2014-01-14 23:10:23'),(2381,'OutBound','5125','Completed','452721020.DSH.IC834.D140115.T090326470.P.IN','09:03:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:26',1,'2014-01-15 09:03:26'),(2433,'OutBound','7610','Completed','452721020.DSH.IC834.D140115.T090402103.P.IN','09:04:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:02',1,'2014-01-15 09:04:02'),(2697,'Inbound',NULL,'Completed','452721020.999.D140114.T2327223.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:39:43',NULL,'2014-01-23 06:39:44'),(2847,'Inbound',NULL,'Completed','452721020.I834.D140306.T1856506.P.OUT','18:51:00','2014-03-06','','CMSFFM','452721020',0,'2014-03-06 21:00:09',0,'2014-03-06 21:02:59'),(1478,'Inbound',NULL,'Completed','452721020.I834.D140112.T1821539.P.OUT','18:13:00','2014-01-12','','CMSFFM','452721020',0,'2014-01-13 03:01:04',NULL,'2014-01-13 03:02:02'),(1720,'OutBound','3323','Completed','452721020.DSH.IC834.D140114.T230737319.P.IN','23:07:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:37',1,'2014-01-14 23:07:38'),(2195,'OutBound','5118','Completed','452721020.DSH.IC834.D140115.T001843804.P.IN','00:18:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:43',1,'2014-01-15 00:18:43'),(2311,'Inbound',NULL,'Completed','452721020.I834.D140114.T1907141.P.OUT','19:00:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-15 02:05:50',NULL,'2014-01-15 02:08:13'),(2597,'Inbound',NULL,'Completed','452721020.999.D140115.T0147347.P.OUT','00:32:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:49:39',1,'2014-01-23 03:49:40'),(1903,'OutBound','3015','Completed','452721020.DSH.IC834.D140114.T231137925.P.IN','23:11:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:38',1,'2014-01-14 23:11:39'),(2062,'OutBound','1010','Completed','452721020.DSH.IC834.D140114.T231704950.P.IN','23:17:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:05',1,'2014-01-14 23:17:05'),(2676,'Inbound',NULL,'Completed','452721020.999.D140115.T0333340.P.OUT','02:01:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 05:01:58',1,'2014-01-23 05:01:59'),(1338,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112510.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:02',NULL,'2014-01-05 17:02:04'),(1541,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113365.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:34',NULL,'2014-01-13 03:03:35'),(1634,'OutBound','153','Completed','452721020.DSH.IC834.D140114.T230552542.P.IN','23:05:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:52',1,'2014-01-14 23:05:53'),(1948,'OutBound','3820','Completed','452721020.DSH.IC834.D140114.T231438209.P.IN','23:14:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:38',1,'2014-01-14 23:14:39'),(2183,'OutBound','5159','Completed','452721020.DSH.IC834.D140115.T001826119.P.IN','00:18:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:26',1,'2014-01-15 00:18:27'),(477,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.072043606.P.IN','07:20:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:20:44',NULL,NULL),(40,'Inbound',NULL,'Completed','452721020.I834.D131212.T1902183.P.OUT','18:53:00','2013-12-12','','CMSFFM','452721020',0,'2013-12-25 22:00:01',NULL,'2013-12-25 22:09:36'),(223,'OutBound','4837','Completed','452721020.DSH.IC834.D131227.T151038700.P.IN','15:10:38','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:10:39',1,'2013-12-27 20:10:39'),(479,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.103116214.P.IN','10:31:16','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:31:16',NULL,NULL),(517,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105827748.P.IN','10:58:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:58:28',NULL,NULL),(526,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110914152.P.IN','11:09:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:14',NULL,NULL),(1254,'Inbound',NULL,'Completed','452721020.999.D131228.T1112468.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:08',NULL,'2014-01-05 16:58:11'),(1795,'OutBound','1988','Completed','452721020.DSH.IC834.D140114.T230915727.P.IN','23:09:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:15',1,'2014-01-14 23:09:16'),(1862,'OutBound','5139','Completed','452721020.DSH.IC834.D140114.T231044555.P.IN','23:10:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:44',1,'2014-01-14 23:10:45'),(2002,'OutBound','4846','Completed','452721020.DSH.IC834.D140114.T231548222.P.IN','23:15:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:48',1,'2014-01-14 23:15:49'),(2180,'OutBound','5145','Completed','452721020.DSH.IC834.D140115.T001822763.P.IN','00:18:22','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:22',1,'2014-01-15 00:18:23'),(265,'OutBound','2537','Completed','452721020.DSH.IC834.D131227.T152623343.P.IN','15:26:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:26:23',1,'2013-12-27 20:26:24'),(1209,'Inbound',NULL,'Completed','452721020.999.D131228.T1112326.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:27',NULL,'2014-01-05 16:54:30'),(1607,'OutBound','5362','Completed','452721020.DSH.IC834.D140114.T230521857.P.IN','23:05:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:21',1,'2014-01-14 23:05:22'),(1632,'OutBound','4814','Completed','452721020.DSH.IC834.D140114.T230550447.P.IN','23:05:50','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:50',1,'2014-01-14 23:05:51'),(1772,'OutBound','2417','Completed','452721020.DSH.IC834.D140114.T230843240.P.IN','23:08:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:43',1,'2014-01-14 23:08:44'),(2398,'OutBound','5139','Completed','452721020.DSH.IC834.D140115.T090337341.P.IN','09:03:37','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:37',1,'2014-01-15 09:03:37'),(2538,'OutBound','12001','Completed','452721020.DSH.IC834.D140115.T222155943.P.IN','22:21:55','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:56',1,'2014-01-15 22:21:56'),(1874,'OutBound','3631','Completed','452721020.DSH.IC834.D140114.T231059764.P.IN','23:10:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:59',1,'2014-01-14 23:11:00'),(1167,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112448.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:31',NULL,'2014-01-05 16:52:33'),(1485,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113475.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:18',NULL,'2014-01-13 03:02:19'),(1579,'OutBound','806','Completed','452721020.DSH.IC834.D140114.T230446702.P.IN','23:04:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:46',1,'2014-01-14 23:04:47'),(2481,'OutBound','5980','Completed','452721020.DSH.IC834.D140115.T090438215.P.IN','09:04:38','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:38',1,'2014-01-15 09:04:38'),(2603,'Inbound',NULL,'Completed','452721020.999.D140114.T2335033.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:51:52',1,'2014-01-23 03:51:52'),(42,'Inbound',NULL,'Completed','452721020.I834.D131108.T1811413.P.OUT','18:03:00','2013-11-08','','CMSFFM','452721020',0,'2013-12-25 22:30:01',NULL,'2013-12-25 22:30:51'),(293,'OutBound','5433','Completed','452721020.DSH.IC834.D131227.T153423583.P.IN','15:34:23','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:34:23',1,'2013-12-27 20:34:24'),(1136,'Inbound',NULL,'Completed','452721020.999.D131228.T1113452.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:05',NULL,'2014-01-05 16:51:08'),(1143,'Inbound',NULL,'Completed','452721020.999.D131228.T1112459.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:25',NULL,'2014-01-05 16:51:27'),(1243,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112320.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:37',NULL,'2014-01-05 16:57:40'),(1612,'OutBound','4493','Completed','452721020.DSH.IC834.D140114.T230527394.P.IN','23:05:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:27',1,'2014-01-14 23:05:28'),(1969,'OutBound','4814','Completed','452721020.DSH.IC834.D140114.T231501803.P.IN','23:15:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:01',1,'2014-01-14 23:15:02'),(2698,'Inbound',NULL,'Completed','452721020.999.D140115.T0220394.P.OUT','00:03:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:40:04',NULL,'2014-01-23 06:40:05'),(180,'OutBound','4935','Completed','452721020.DSH.IC834.D131227.T145144803.P.IN','14:51:44','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:51:45',1,'2013-12-27 19:51:45'),(363,'OutBound','1089','Completed','452721020.DSH.IC834.D131227.T161426736.P.IN','16:14:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:14:27',1,'2013-12-27 21:14:27'),(1227,'Inbound',NULL,'Completed','452721020.999.D131228.T1113025.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:21',NULL,'2014-01-05 16:55:23'),(1289,'Inbound',NULL,'Completed','452721020.999.D131227.T1703157.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:59:46',NULL,'2014-01-05 16:59:48'),(2276,'OutBound','5956','Completed','452721020.DSH.IC834.D140115.T002024426.P.IN','00:20:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:24',1,'2014-01-15 00:20:25'),(568,'Inbound',NULL,'Completed','452721020.I834.D140102.T1851482.P.OUT','18:42:00','2014-01-02','','CMSFFM','452721020',0,'2014-01-03 02:00:02',NULL,'2014-01-03 02:07:28'),(1446,'Inbound',NULL,'Completed','452721020.999.D131228.T1112295.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:44',NULL,'2014-01-05 17:26:46'),(1812,'OutBound','1825','Completed','452721020.DSH.IC834.D140114.T230937278.P.IN','23:09:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:37',1,'2014-01-14 23:09:38'),(1973,'OutBound','152','Completed','452721020.DSH.IC834.D140114.T231506937.P.IN','23:15:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:07',1,'2014-01-14 23:15:07'),(1962,'OutBound','2335','Completed','452721020.DSH.IC834.D140114.T231453841.P.IN','23:14:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:53',1,'2014-01-14 23:14:54'),(2259,'OutBound','5786','Completed','452721020.DSH.IC834.D140115.T002004272.P.IN','00:20:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:04',1,'2014-01-15 00:20:05'),(1416,'Inbound',NULL,'Completed','452721020.999.D131228.T1113578.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:20',NULL,'2014-01-05 17:25:23'),(2764,'OutBound','775','Completed','452721020.DSH.IC834.D140129.T134628880.P.IN','13:46:28','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:29',1,'2014-01-29 13:46:29'),(34,'Inbound',NULL,'Completed','452721020.I834.D131006.T1806530.P.OUT','18:02:00','2013-10-06','','CMSFFM','452721020',0,'2013-12-25 20:45:55',NULL,'2013-12-25 20:46:24'),(515,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105724686.P.IN','10:57:24','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:57:25',NULL,NULL),(1199,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112317.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:59',NULL,'2014-01-05 16:54:02'),(1859,'OutBound','5140','Completed','452721020.DSH.IC834.D140114.T231039658.P.IN','23:10:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:39',1,'2014-01-14 23:10:41'),(1985,'OutBound','2235','Completed','452721020.DSH.IC834.D140114.T231521922.P.IN','23:15:21','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:21',1,'2014-01-14 23:15:22'),(2843,'Inbound',NULL,'Completed','452721020.I834.D140304.T1857369.P.OUT','18:50:00','2014-03-04','','CMSFFM','452721020',0,'2014-03-04 21:00:09',0,'2014-03-04 21:02:49'),(307,'OutBound','5025','Completed','452721020.DSH.IC834.D131227.T153756226.P.IN','15:37:56','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:37:56',1,'2013-12-27 20:37:56'),(555,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113728921.T.IN','11:37:28','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:29',NULL,NULL),(1135,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113580.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:03',NULL,'2014-01-05 16:51:05'),(1236,'Inbound',NULL,'Completed','452721020.999.D131228.T1112190.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:18',NULL,'2014-01-05 16:57:20'),(1658,'OutBound','2563','Completed','452721020.DSH.IC834.D140114.T230619818.P.IN','23:06:19','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:19',1,'2014-01-14 23:06:24'),(1760,'OutBound','2442','Completed','452721020.DSH.IC834.D140114.T230828498.P.IN','23:08:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:28',1,'2014-01-14 23:08:29'),(1918,'OutBound','4166','Completed','452721020.DSH.IC834.D140114.T231405373.P.IN','23:14:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:05',1,'2014-01-14 23:14:06'),(2789,'Inbound',NULL,'Completed','452721020.I834.D140209.T1817338.P.OUT','18:11:00','2014-02-09','','CMSFFM','452721020',0,'2014-02-09 19:00:09',NULL,'2014-02-09 19:00:46'),(1350,'Inbound',NULL,'Completed','452721020.999.D131227.T1142037.P.OUT','11:30:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:02:36',NULL,'2014-01-05 17:02:38'),(1839,'OutBound','5128','Completed','452721020.DSH.IC834.D140114.T231011523.P.IN','23:10:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:11',1,'2014-01-14 23:10:12'),(2384,'OutBound','5141','Completed','452721020.DSH.IC834.D140115.T090328273.P.IN','09:03:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:28',1,'2014-01-15 09:03:28'),(2445,'OutBound','3017','Completed','452721020.DSH.IC834.D140115.T090412494.P.IN','09:04:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:12',1,'2014-01-15 09:04:12'),(240,'OutBound','4834','Completed','452721020.DSH.IC834.D131227.T151615672.P.IN','15:16:15','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:16:15',1,'2013-12-27 20:16:15'),(1401,'Inbound',NULL,'Completed','452721020.999.D131227.T1703133.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:24:39',NULL,'2014-01-05 17:24:41'),(1407,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112597.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:55',NULL,'2014-01-05 17:24:58'),(1848,'OutBound','5141','Completed','452721020.DSH.IC834.D140114.T231023812.P.IN','23:10:23','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:23',1,'2014-01-14 23:10:25'),(1905,'OutBound','3008','Completed','452721020.DSH.IC834.D140114.T231140519.P.IN','23:11:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:40',1,'2014-01-14 23:11:41'),(2546,'OutBound','3391','Completed','452721020.DSH.IC834.D140120.T054423840.P.IN','05:44:23','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:23',1,'2014-01-20 05:44:24'),(1190,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113303.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:34',NULL,'2014-01-05 16:53:37'),(1520,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113466.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:11',NULL,'2014-01-13 03:03:12'),(1564,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114115.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:55',NULL,'2014-01-13 03:03:56'),(401,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061844894.P.IN','06:18:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:18:44',NULL,NULL),(1165,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112513.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:25',NULL,'2014-01-05 16:52:28'),(1249,'Inbound',NULL,'Completed','452721020.999.D131228.T1113048.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:54',NULL,'2014-01-05 16:57:56'),(1783,'OutBound','1985','Completed','452721020.DSH.IC834.D140114.T230857512.P.IN','23:08:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:57',1,'2014-01-14 23:08:58'),(2128,'OutBound','1980','Completed','452721020.DSH.IC834.D140115.T001716401.P.IN','00:17:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:16',1,'2014-01-15 00:17:17'),(406,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062425280.P.IN','06:24:25','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:24:25',NULL,NULL),(1312,'Inbound',NULL,'Completed','452721020.999.D131228.T1112504.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:50',NULL,'2014-01-05 17:00:52'),(1721,'OutBound','1002','Completed','452721020.DSH.IC834.D140114.T230738477.P.IN','23:07:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:38',1,'2014-01-14 23:07:39'),(2258,'OutBound','5811','Completed','452721020.DSH.IC834.D140115.T002002596.P.IN','00:20:02','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:02',1,'2014-01-15 00:20:03'),(163,'OutBound','3290','Completed','452721020.DSH.IC834.D131227.T143456436.P.IN','14:34:56','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:34:56',1,'2013-12-27 19:34:57'),(393,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060926509.P.IN','06:09:26','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:09:26',NULL,NULL),(1524,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113306.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:17',NULL,'2014-01-13 03:03:18'),(497,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104801595.P.IN','10:48:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:48:01',NULL,NULL),(1185,'Inbound',NULL,'Completed','452721020.999.D131228.T1113297.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:20',NULL,'2014-01-05 16:53:23'),(1432,'Inbound',NULL,'Completed','452721020.999.D131228.T1112524.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:05',NULL,'2014-01-05 17:26:07'),(2177,'OutBound','5150','Completed','452721020.DSH.IC834.D140115.T001819868.P.IN','00:18:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:19',1,'2014-01-15 00:18:20'),(2369,'OutBound','7173','Completed','452721020.DSH.IC834.D140115.T090319368.P.IN','09:03:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:19',1,'2014-01-15 09:03:19'),(2536,'OutBound','12177','Completed','452721020.DSH.IC834.D140115.T222154685.P.IN','22:21:54','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:54',1,'2014-01-15 22:21:55'),(2707,'Inbound',NULL,'Completed','452721020.999.D140115.T0231427.P.OUT','00:13:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 06:45:09',NULL,'2014-01-23 06:45:09'),(435,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065420859.P.IN','06:54:20','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:54:21',NULL,NULL),(1247,'Inbound',NULL,'Completed','452721020.999.D131228.T1113171.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:49',NULL,'2014-01-05 16:57:51'),(1313,'Inbound',NULL,'Completed','452721020.999.D131228.T1112323.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:52',NULL,'2014-01-05 17:00:55'),(2466,'OutBound','5812','Completed','452721020.DSH.IC834.D140115.T090428242.P.IN','09:04:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:28',1,'2014-01-15 09:04:28'),(2689,'Inbound',NULL,'Completed','452721020.999.D140115.T0022359.P.OUT','23:25:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:00:02',NULL,'2014-01-23 06:00:03'),(169,'OutBound','7366','Completed','452721020.DSH.IC834.D131227.T144245833.P.IN','14:42:45','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:42:46',1,'2013-12-27 19:42:46'),(280,'OutBound','4948','Completed','452721020.DSH.IC834.D131227.T153126622.P.IN','15:31:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:26',1,'2013-12-27 20:31:27'),(1454,'Inbound',NULL,'Completed','452721020.999.D131228.T1112507.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:06',NULL,'2014-01-05 17:27:08'),(1801,'OutBound','1663','Completed','452721020.DSH.IC834.D140114.T230924384.P.IN','23:09:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:24',1,'2014-01-14 23:09:25'),(1879,'OutBound','3638','Completed','452721020.DSH.IC834.D140114.T231105934.P.IN','23:11:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:06',1,'2014-01-14 23:11:06'),(1916,'OutBound','806','Completed','452721020.DSH.IC834.D140114.T231403284.P.IN','23:14:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:03',1,'2014-01-14 23:14:04'),(2247,'OutBound','3113','Completed','452721020.DSH.IC834.D140115.T001947619.P.IN','00:19:47','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:47',1,'2014-01-15 00:19:48'),(2655,'Inbound',NULL,'Completed','452721020.999.D140115.T0027165.P.OUT','23:40:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:29:32',1,'2014-01-23 04:29:33'),(2736,'Inbound',NULL,'Completed','452721020.999.D140115.T0125126.P.OUT','00:12:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 09:50:44',NULL,'2014-01-23 09:50:45'),(176,'OutBound','1753','Completed','452721020.DSH.IC834.D131227.T145040264.P.IN','14:50:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:50:40',1,'2013-12-27 19:50:41'),(205,'OutBound','1943','Completed','452721020.DSH.IC834.D131227.T150148598.P.IN','15:01:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:01:48',1,'2013-12-27 20:01:49'),(1168,'Inbound',NULL,'Completed','452721020.999.D131228.T1114107.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:34',NULL,'2014-01-05 16:52:36'),(1339,'Inbound',NULL,'Completed','452721020.999.D131227.T1703138.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:02:05',NULL,'2014-01-05 17:02:07'),(1623,'OutBound','1074','Completed','452721020.DSH.IC834.D140114.T230540612.P.IN','23:05:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:40',1,'2014-01-14 23:05:41'),(1938,'OutBound','5266','Completed','452721020.DSH.IC834.D140114.T231427534.P.IN','23:14:27','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:27',1,'2014-01-14 23:14:28'),(2151,'OutBound','1820','Completed','452721020.DSH.IC834.D140115.T001746203.P.IN','00:17:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:46',1,'2014-01-15 00:17:47'),(164,'OutBound','7697','Completed','452721020.DSH.IC834.D131227.T143631581.P.IN','14:36:31','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:36:31',1,'2013-12-27 19:36:32'),(375,'OutBound','3030','Completed','452721020.DSH.IC834.D131227.T164129493.P.IN','16:41:29','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:41:29',1,'2013-12-27 21:41:30'),(1530,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114109.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:24',NULL,'2014-01-13 03:03:24'),(1787,'OutBound','2056','Completed','452721020.DSH.IC834.D140114.T230903503.P.IN','23:09:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:03',1,'2014-01-14 23:09:05'),(1940,'OutBound','5404','Completed','452721020.DSH.IC834.D140114.T231429693.P.IN','23:14:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:29',1,'2014-01-14 23:14:30'),(2019,'OutBound','7258','Completed','452721020.DSH.IC834.D140114.T231609866.P.IN','23:16:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:09',1,'2014-01-14 23:16:10'),(2310,'OutBound','3328','Completed','452721020.DSH.IC834.D140115.T002108413.P.IN','00:21:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:08',1,'2014-01-15 00:21:09'),(2490,'OutBound','676','Completed','452721020.DSH.IC834.D140115.T090444958.P.IN','09:04:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:44',1,'2014-01-15 09:04:44'),(350,'OutBound','3497','Completed','452721020.DSH.IC834.D131227.T160300985.P.IN','16:03:00','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:03:01',1,'2013-12-27 21:03:01'),(1930,'OutBound','2305','Completed','452721020.DSH.IC834.D140114.T231418868.P.IN','23:14:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:18',1,'2014-01-14 23:14:18'),(2684,'Inbound',NULL,'Completed','452721020.999.D140114.T2327166.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:06:42',1,'2014-01-23 05:06:42'),(2751,'Inbound',NULL,'Completed','452721020.999.D140115.T0252482.P.OUT','01:08:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 17:00:02',NULL,'2014-01-23 17:00:02'),(1308,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112440.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:39',NULL,'2014-01-05 17:00:41'),(1436,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112323.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:16',NULL,'2014-01-05 17:26:18'),(2484,'OutBound','688','Completed','452721020.DSH.IC834.D140115.T090439888.P.IN','09:04:39','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:40',1,'2014-01-15 09:04:40'),(1604,'OutBound','5405','Completed','452721020.DSH.IC834.D140114.T230518666.P.IN','23:05:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:18',1,'2014-01-14 23:05:19'),(2175,'OutBound','5135','Completed','452721020.DSH.IC834.D140115.T001816509.P.IN','00:18:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:16',1,'2014-01-15 00:18:17'),(2277,'OutBound','5979','Completed','452721020.DSH.IC834.D140115.T002025655.P.IN','00:20:25','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:25',1,'2014-01-15 00:20:26'),(2543,'OutBound','3261','Completed','452721020.DSH.IC834.D140120.T054422598.P.IN','05:44:22','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:22',1,'2014-01-20 05:44:22'),(2752,'Inbound',NULL,'Completed','452721020.999.D140115.T0020539.P.OUT','23:24:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 17:30:02',NULL,'2014-01-23 17:30:03'),(2820,'Inbound',NULL,'Completed','452721020.I834.D140223.T1817550.P.OUT','18:10:00','2014-02-23','','CMSFFM','452721020',0,'2014-02-26 08:00:02',0,'2014-02-26 08:00:35'),(480,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104449295.P.IN','10:44:49','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:44:49',NULL,NULL),(1790,'OutBound','2076','Completed','452721020.DSH.IC834.D140114.T230908678.P.IN','23:09:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:08',1,'2014-01-14 23:09:09'),(1966,'OutBound','159','Completed','452721020.DSH.IC834.D140114.T231458429.P.IN','23:14:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:58',1,'2014-01-14 23:14:59'),(2337,'OutBound','1663','Completed','452721020.DSH.IC834.D140115.T090301356.P.IN','09:03:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:01',1,'2014-01-15 09:03:01'),(1695,'OutBound','4402','Completed','452721020.DSH.IC834.D140114.T230707367.P.IN','23:07:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:07',1,'2014-01-14 23:07:08'),(1939,'OutBound','5267','Completed','452721020.DSH.IC834.D140114.T231428587.P.IN','23:14:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:28',1,'2014-01-14 23:14:29'),(1990,'OutBound','5282','Completed','452721020.DSH.IC834.D140114.T231526745.P.IN','23:15:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:26',1,'2014-01-14 23:15:27'),(2104,'OutBound','2420','Completed','452721020.DSH.IC834.D140114.T231759626.P.IN','23:17:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:59',1,'2014-01-14 23:18:00'),(233,'OutBound','3464','Completed','452721020.DSH.IC834.D131227.T151404923.P.IN','15:14:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:14:05',1,'2013-12-27 20:14:05'),(1325,'Inbound',NULL,'Completed','452721020.999.D131228.T0502230.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:26',NULL,'2014-01-05 17:01:28'),(1873,'OutBound','3636','Completed','452721020.DSH.IC834.D140114.T231058441.P.IN','23:10:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:58',1,'2014-01-14 23:10:59'),(2053,'OutBound','965','Completed','452721020.DSH.IC834.D140114.T231653282.P.IN','23:16:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:53',1,'2014-01-14 23:16:54'),(2198,'OutBound','5158','Completed','452721020.DSH.IC834.D140115.T001846440.P.IN','00:18:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:46',1,'2014-01-15 00:18:47'),(2417,'OutBound','3653','Completed','452721020.DSH.IC834.D140115.T090351533.P.IN','09:03:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:51',1,'2014-01-15 09:03:51'),(1649,'OutBound','7720','Completed','452721020.DSH.IC834.D140114.T230609752.P.IN','23:06:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:09',1,'2014-01-14 23:06:10'),(2519,'OutBound','1511','Completed','452721020.DSH.IC834.D140115.T222145538.P.IN','22:21:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:45',1,'2014-01-15 22:21:45'),(27,'Inbound',NULL,'Completed','452721020.I834.D131022.T1807317.P.OUT','18:02:00','2013-10-22','','CMSFFM','452721020',0,'2013-12-25 20:01:52',NULL,'2013-12-25 20:02:07'),(430,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065110468.P.IN','06:51:10','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:51:10',NULL,NULL),(1126,'Inbound',NULL,'Completed','i452721020.999.D131227.T1142037.P.OUT','11:30:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:50:38',NULL,'2014-01-05 16:50:40'),(1651,'OutBound','7721','Completed','452721020.DSH.IC834.D140114.T230611906.P.IN','23:06:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:12',1,'2014-01-14 23:06:12'),(1963,'OutBound','7370','Completed','452721020.DSH.IC834.D140114.T231455160.P.IN','23:14:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:55',1,'2014-01-14 23:14:55'),(2489,'OutBound','668','Completed','452721020.DSH.IC834.D140115.T090443467.P.IN','09:04:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:43',1,'2014-01-15 09:04:43'),(2648,'Inbound',NULL,'Completed','452721020.999.D140115.T0119472.P.OUT','00:08:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:21:47',1,'2014-01-23 04:21:48'),(2671,'Inbound',NULL,'Completed','452721020.999.D140114.T2357330.P.OUT','23:19:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:52:40',1,'2014-01-23 04:52:41'),(276,'OutBound','7136','Completed','452721020.DSH.IC834.D131227.T153037384.P.IN','15:30:37','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:30:37',1,'2013-12-27 20:30:38'),(1280,'Inbound',NULL,'Completed','452721020.999.D131228.T1113276.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:21',NULL,'2014-01-05 16:59:23'),(1351,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112360.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:38',NULL,'2014-01-05 17:02:41'),(1606,'OutBound','5361','Completed','452721020.DSH.IC834.D140114.T230520761.P.IN','23:05:20','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:20',1,'2014-01-14 23:05:21'),(1663,'OutBound','1590','Completed','452721020.DSH.IC834.D140114.T230629260.P.IN','23:06:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:29',1,'2014-01-14 23:06:30'),(2134,'OutBound','1979','Completed','452721020.DSH.IC834.D140115.T001723673.P.IN','00:17:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:23',1,'2014-01-15 00:17:24'),(2163,'OutBound','5120','Completed','452721020.DSH.IC834.D140115.T001801351.P.IN','00:18:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:01',1,'2014-01-15 00:18:02'),(1818,'OutBound','3019','Completed','452721020.DSH.IC834.D140114.T230944587.P.IN','23:09:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:44',1,'2014-01-14 23:09:45'),(2178,'OutBound','5130','Completed','452721020.DSH.IC834.D140115.T001820351.P.IN','00:18:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:20',1,'2014-01-15 00:18:21'),(2716,'Inbound',NULL,'Completed','452721020.999.D140115.T0309474.P.OUT','01:52:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 07:05:49',NULL,'2014-01-23 07:05:50'),(2806,'Inbound',NULL,'Completed','452721020.I834.D140217.T1813140.P.OUT','18:05:00','2014-02-17','','CMSFFM','452721020',0,'2014-02-17 19:00:04',0,'2014-02-17 19:00:18'),(1118,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112541.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:16',NULL,'2014-01-05 16:50:18'),(2115,'OutBound','3799','Completed','452721020.DSH.IC834.D140115.T001701238.P.IN','00:17:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:01',1,'2014-01-15 00:17:01'),(2235,'OutBound','3121','Completed','452721020.DSH.IC834.D140115.T001932300.P.IN','00:19:32','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:32',1,'2014-01-15 00:19:33'),(385,'Inbound',NULL,'Completed','452721020.I834.D131230.T1908356.P.OUT','19:01:00','2013-12-30','','CMSFFM','452721020',0,'2014-01-01 12:00:01',NULL,'2014-01-01 12:09:32'),(1134,'Inbound',NULL,'Completed','452721020.999.D131228.T1113294.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:00',NULL,'2014-01-05 16:51:02'),(2533,'OutBound','11644','Completed','452721020.DSH.IC834.D140115.T222152755.P.IN','22:21:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:52',1,'2014-01-15 22:21:53'),(565,'OutBound','7128','Completed','452721020.DSH.IC834.D140102.T114107540.P.IN','11:41:07','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:07',1,'2014-01-02 16:41:07'),(1332,'Inbound',NULL,'Completed','452721020.999.D131228.T1112476.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:45',NULL,'2014-01-05 17:01:48'),(1992,'OutBound','6021','Completed','452721020.DSH.IC834.D140114.T231530431.P.IN','23:15:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:30',1,'2014-01-14 23:15:30'),(17,'Inbound',NULL,'Completed','452721020.I834.D131107.T1808536.P.OUT','18:02:00','2013-11-07','','CMSFFM','452721020',0,'2013-12-25 18:32:12',NULL,'2013-12-25 18:32:22'),(1870,'OutBound','3639','Completed','452721020.DSH.IC834.D140114.T231054541.P.IN','23:10:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:54',1,'2014-01-14 23:10:55'),(2409,'OutBound','3636','Completed','452721020.DSH.IC834.D140115.T090345236.P.IN','09:03:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:45',1,'2014-01-15 09:03:45'),(2465,'OutBound','5780','Completed','452721020.DSH.IC834.D140115.T090427520.P.IN','09:04:27','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:27',1,'2014-01-15 09:04:27'),(2769,'OutBound','7120','Completed','452721020.DSH.IC834.D140129.T134632723.P.IN','13:46:32','2014-01-29','0','452721020','CMSFFM',1,'2014-01-29 13:46:32',1,'2014-01-29 13:46:33'),(1488,'Inbound',NULL,'Completed','452721020.999.D131228.T1114117.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:21',NULL,'2014-01-13 03:02:21'),(1786,'OutBound','1981','Completed','452721020.DSH.IC834.D140114.T230902296.P.IN','23:09:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:02',1,'2014-01-14 23:09:03'),(1833,'OutBound','7173','Completed','452721020.DSH.IC834.D140114.T231002401.P.IN','23:10:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:02',1,'2014-01-14 23:10:03'),(1246,'Inbound',NULL,'Completed','i452721020.999.D131227.T1816315.P.OUT','18:10:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:57:46',NULL,'2014-01-05 16:57:48'),(1358,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112382.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:39',NULL,'2014-01-05 17:22:41'),(1515,'Inbound',NULL,'Completed','452721020.999.D131228.T1113142.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:07',NULL,'2014-01-13 03:03:07'),(2606,'Inbound',NULL,'Completed','452721020.999.D140115.T0055134.P.OUT','23:37:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:54:11',1,'2014-01-23 03:54:11'),(283,'OutBound','3024','Completed','452721020.DSH.IC834.D131227.T153216154.P.IN','15:32:16','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:32:16',1,'2013-12-27 20:32:16'),(1283,'Inbound',NULL,'Completed','452721020.999.D131228.T1113475.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:29',NULL,'2014-01-05 16:59:31'),(2362,'OutBound','5120','Completed','452721020.DSH.IC834.D140115.T090315148.P.IN','09:03:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:15',1,'2014-01-15 09:03:15'),(2743,'Inbound',NULL,'Completed','452721020.999.D140115.T0351007.P.OUT','02:57:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 13:00:02',NULL,'2014-01-23 13:00:02'),(543,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.112234537.T.IN','11:22:34','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:22:34',NULL,NULL),(1583,'OutBound','686','Completed','452721020.DSH.IC834.D140114.T230451318.P.IN','23:04:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:51',1,'2014-01-14 23:04:52'),(1739,'OutBound','379','Completed','452721020.DSH.IC834.D140114.T230801935.P.IN','23:08:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:02',1,'2014-01-14 23:08:02'),(2641,'Inbound',NULL,'Completed','452721020.999.D140115.T0311088.P.OUT','01:39:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:17:57',1,'2014-01-23 04:17:58'),(256,'OutBound','3064','Completed','452721020.DSH.IC834.D131227.T152308157.P.IN','15:23:08','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:23:08',1,'2013-12-27 20:23:08'),(2392,'OutBound','5123','Completed','452721020.DSH.IC834.D140115.T090333274.P.IN','09:03:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:33',1,'2014-01-15 09:03:33'),(2617,'Inbound',NULL,'Completed','452721020.999.D140115.T0045346.P.OUT','23:25:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:01:46',1,'2014-01-23 04:01:47'),(1331,'Inbound',NULL,'Completed','452721020.999.D131228.T1113090.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:43',NULL,'2014-01-05 17:01:45'),(1728,'OutBound','837','Completed','452721020.DSH.IC834.D140114.T230746929.P.IN','23:07:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:47',1,'2014-01-14 23:07:47'),(2450,'OutBound','4158','Completed','452721020.DSH.IC834.D140115.T090416165.P.IN','09:04:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:16',1,'2014-01-15 09:04:16'),(9,'Inbound',NULL,'Completed','452721020.I834.D131111.T1806565.P.OUT','18:02:00','2013-11-11','','CMSFFM','452721020',0,'2013-12-25 18:10:35',NULL,'2013-12-25 18:11:01'),(1560,'Inbound',NULL,'Completed','452721020.999.D131228.T1112410.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:51',NULL,'2014-01-13 03:03:52'),(570,'Inbound',NULL,'Completed','452721020.MISC.D140103.T2256590.P.OUT','19:07:00','2014-01-03','','CMSFFM','452721020',0,'2014-01-04 06:00:02',NULL,'2014-01-04 06:00:15'),(1386,'Inbound',NULL,'Completed','452721020.999.D131228.T1112416.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:57',NULL,'2014-01-05 17:23:59'),(1970,'OutBound','3652','Completed','452721020.DSH.IC834.D140114.T231503764.P.IN','23:15:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:03',1,'2014-01-14 23:15:04'),(2320,'OutBound','1987','Completed','452721020.DSH.IC834.D140115.T090251761.P.IN','09:02:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:51',1,'2014-01-15 09:02:52'),(2371,'OutBound','5122','Completed','452721020.DSH.IC834.D140115.T090320185.P.IN','09:03:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:20',1,'2014-01-15 09:03:20'),(2722,'Inbound',NULL,'Completed','452721020.999.D140115.T0050200.P.OUT','23:31:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 07:07:31',NULL,'2014-01-23 07:07:31'),(504,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105300804.P.IN','10:53:00','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:53:01',NULL,NULL),(1452,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112373.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:01',NULL,'2014-01-05 17:27:03'),(2,'Inbound',NULL,'Completed','452721020.I834.D131012.T1807283.P.OUT','18:01:00','2013-10-12','','CMSFFM','452721020',0,'2013-12-25 17:30:01',NULL,'2013-12-25 17:30:33'),(1277,'Inbound',NULL,'Completed','452721020.999.D131228.T1112492.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:12',NULL,'2014-01-05 16:59:14'),(2823,'Inbound',NULL,'Completed','452721020.I834.D140222.T1822521.P.OUT','18:14:00','2014-02-22','','CMSFFM','452721020',0,'2014-02-26 08:30:02',0,'2014-02-26 08:30:58'),(1198,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703154.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:53:57',NULL,'2014-01-05 16:53:59'),(2026,'OutBound','4517','Completed','452721020.DSH.IC834.D140114.T231618461.P.IN','23:16:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:18',1,'2014-01-14 23:16:19'),(2672,'Inbound',NULL,'Completed','452721020.999.D140114.T2331492.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:52:47',1,'2014-01-23 04:52:47'),(1901,'OutBound','3021','Completed','452721020.DSH.IC834.D140114.T231135162.P.IN','23:11:35','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:35',1,'2014-01-14 23:11:36'),(2044,'OutBound','2222','Completed','452721020.DSH.IC834.D140114.T231642687.P.IN','23:16:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:42',1,'2014-01-14 23:16:43'),(2500,'OutBound','677','Completed','452721020.DSH.IC834.D140115.T090450500.P.IN','09:04:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:50',1,'2014-01-15 09:04:51'),(2836,'Inbound',NULL,'Completed','452721020.I834.D140303.T1842397.P.OUT','18:33:00','2014-03-03','','CMSFFM','452721020',0,'2014-03-03 21:29:58',0,'2014-03-03 21:32:00'),(352,'OutBound','12','Completed','452721020.DSH.IC834.D131227.T160406820.P.IN','16:04:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:04:07',1,'2013-12-27 21:04:07'),(1761,'OutBound','2427','Completed','452721020.DSH.IC834.D140114.T230829721.P.IN','23:08:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:29',1,'2014-01-14 23:08:30'),(1860,'OutBound','5117','Completed','452721020.DSH.IC834.D140114.T231041217.P.IN','23:10:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:41',1,'2014-01-14 23:10:42'),(1919,'OutBound','1980','Completed','452721020.DSH.IC834.D140114.T231406446.P.IN','23:14:06','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:06',1,'2014-01-14 23:14:07'),(2202,'OutBound','3651','Completed','452721020.DSH.IC834.D140115.T001851329.P.IN','00:18:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:51',1,'2014-01-15 00:18:52'),(2725,'Inbound',NULL,'Completed','452721020.999.D140115.T0005388.P.OUT','23:21:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 08:13:36',NULL,'2014-01-23 08:13:37'),(405,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062311938.P.IN','06:23:11','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:23:12',NULL,NULL),(1534,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113405.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:27',NULL,'2014-01-13 03:03:28'),(2812,'Inbound',NULL,'Completed','452721020.CIC834.D140219.T1843297.P.OUT','18:32:00','2014-02-19','','CMSFFM','452721020',0,'2014-02-20 05:30:06',0,'2014-02-20 05:41:36'),(248,'OutBound','1855','Completed','452721020.DSH.IC834.D131227.T151921827.P.IN','15:19:21','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:19:22',1,'2013-12-27 20:19:22'),(260,'OutBound','1107','Completed','452721020.DSH.IC834.D131227.T152434803.P.IN','15:24:34','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:24:35',1,'2013-12-27 20:24:35'),(2255,'OutBound','5782','Completed','452721020.DSH.IC834.D140115.T001958964.P.IN','00:19:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:59',1,'2014-01-15 00:19:59'),(2682,'Inbound',NULL,'Completed','452721020.999.D140114.T2340027.P.OUT','23:21:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:06:32',1,'2014-01-23 05:06:33'),(1161,'Inbound',NULL,'Completed','i452721020.999.D131227.T1703133.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:52:14',NULL,'2014-01-05 16:52:17'),(2801,'Inbound',NULL,'Completed','452721020.CIC834.D140215.T1853249.P.OUT','18:44:00','2014-02-15','','CMSFFM','452721020',0,'2014-02-15 21:00:02',0,'2014-02-15 21:00:14'),(488,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104651227.P.IN','10:46:51','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:51',NULL,NULL),(1150,'Inbound',NULL,'Completed','452721020.999.D131228.T1114109.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:44',NULL,'2014-01-05 16:51:46'),(2651,'Inbound',NULL,'Completed','452721020.999.D140114.T2340067.P.OUT','23:21:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:25:24',1,'2014-01-23 04:25:25'),(266,'OutBound','2171','Completed','452721020.DSH.IC834.D131227.T152706218.P.IN','15:27:06','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:27:06',1,'2013-12-27 20:27:06'),(1154,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113033.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:55',NULL,'2014-01-05 16:51:57'),(1305,'Inbound',NULL,'Completed','452721020.999.D131228.T1113408.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:30',NULL,'2014-01-05 17:00:32'),(1603,'OutBound','5404','Completed','452721020.DSH.IC834.D140114.T230516562.P.IN','23:05:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:16',1,'2014-01-14 23:05:18'),(2388,'OutBound','5116','Completed','452721020.DSH.IC834.D140115.T090330720.P.IN','09:03:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:30',1,'2014-01-15 09:03:31'),(426,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.064245529.P.IN','06:42:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:42:45',NULL,NULL),(461,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071346221.P.IN','07:13:46','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:13:46',NULL,NULL),(506,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105501609.P.IN','10:55:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:02',NULL,NULL),(2017,'OutBound','5346','Completed','452721020.DSH.IC834.D140114.T231607552.P.IN','23:16:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:07',1,'2014-01-14 23:16:08'),(2150,'OutBound','1780','Completed','452721020.DSH.IC834.D140115.T001744986.P.IN','00:17:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:45',1,'2014-01-15 00:17:46'),(53,'Inbound',NULL,'Completed','452721020.I834.D131121.T1812153.P.OUT','18:06:00','2013-11-21','','CMSFFM','452721020',0,'2013-12-26 00:15:02',NULL,'2013-12-26 00:17:01'),(175,'OutBound','3907','Completed','452721020.DSH.IC834.D131227.T145026676.P.IN','14:50:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:50:27',1,'2013-12-27 19:50:27'),(2683,'Inbound',NULL,'Completed','452721020.999.D140114.T2339067.P.OUT','23:20:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 05:06:38',1,'2014-01-23 05:06:39'),(2849,'Inbound',NULL,'Completed','452721020.CIC834.D140307.T1852203.P.OUT','18:42:00','2014-03-07','','CMSFFM','452721020',0,'2014-03-07 21:00:08',0,'2014-03-07 21:00:37'),(172,'OutBound','6422','Completed','452721020.DSH.IC834.D131227.T144546398.P.IN','14:45:46','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:45:46',1,'2013-12-27 19:45:47'),(353,'OutBound','5709','Completed','452721020.DSH.IC834.D131227.T160440885.P.IN','16:04:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:04:41',1,'2013-12-27 21:04:41'),(290,'OutBound','975','Completed','452721020.DSH.IC834.D131227.T153335407.P.IN','15:33:35','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:33:35',1,'2013-12-27 20:33:36'),(1906,'OutBound','2849','Completed','452721020.DSH.IC834.D140114.T231141724.P.IN','23:11:41','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:41',1,'2014-01-14 23:11:42'),(388,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.060544939.P.IN','06:05:44','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:05:45',NULL,NULL),(1214,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112214.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:41',NULL,'2014-01-05 16:54:43'),(1614,'OutBound','3928','Completed','452721020.DSH.IC834.D140114.T230529678.P.IN','23:05:29','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:29',1,'2014-01-14 23:05:30'),(1758,'OutBound','2426','Completed','452721020.DSH.IC834.D140114.T230826160.P.IN','23:08:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:26',1,'2014-01-14 23:08:27'),(1908,'OutBound','3012','Completed','452721020.DSH.IC834.D140114.T231144318.P.IN','23:11:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:44',1,'2014-01-14 23:11:45'),(1944,'OutBound','5362','Completed','452721020.DSH.IC834.D140114.T231434529.P.IN','23:14:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:34',1,'2014-01-14 23:14:34'),(2003,'OutBound','4851','Completed','452721020.DSH.IC834.D140114.T231549552.P.IN','23:15:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:49',1,'2014-01-14 23:15:50'),(2281,'OutBound','5977','Completed','452721020.DSH.IC834.D140115.T002030340.P.IN','00:20:30','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:30',1,'2014-01-15 00:20:31'),(1469,'Inbound',NULL,'Completed','452721020.I834.D140105.T1817073.P.OUT','18:09:00','2014-01-05','','CMSFFM','452721020',1,'2014-01-07 10:21:11',1,'2014-01-07 10:23:35'),(2165,'OutBound','5154','Completed','452721020.DSH.IC834.D140115.T001803867.P.IN','00:18:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:03',1,'2014-01-15 00:18:04'),(2373,'OutBound','5160','Completed','452721020.DSH.IC834.D140115.T090321477.P.IN','09:03:21','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:21',1,'2014-01-15 09:03:21'),(2525,'OutBound','5675','Completed','452721020.DSH.IC834.D140115.T222148696.P.IN','22:21:48','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:48',1,'2014-01-15 22:21:48'),(1251,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112476.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:00',NULL,'2014-01-05 16:58:02'),(1327,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112187.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:32',NULL,'2014-01-05 17:01:34'),(1336,'Inbound',NULL,'Completed','452721020.999.D131228.T1114028.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:57',NULL,'2014-01-05 17:01:59'),(1359,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113127.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:42',NULL,'2014-01-05 17:22:44'),(1455,'Inbound',NULL,'Completed','452721020.999.D131228.T1113101.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:09',NULL,'2014-01-05 17:27:11'),(2056,'OutBound','1024','Completed','452721020.DSH.IC834.D140114.T231657678.P.IN','23:16:57','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:57',1,'2014-01-14 23:16:58'),(2561,'Inbound',NULL,'Completed','452721020.999.D140115.T0019559.P.OUT','22:20:00','2014-01-13','','CMSFFM','452721020',0,'2014-01-23 03:39:35',NULL,'2014-01-23 03:39:35'),(324,'OutBound','1863','Completed','452721020.DSH.IC834.D131227.T154608914.P.IN','15:46:08','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:46:09',1,'2013-12-27 20:46:09'),(1979,'OutBound','122','Completed','452721020.DSH.IC834.D140114.T231513779.P.IN','23:15:13','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:13',1,'2014-01-14 23:15:14'),(2043,'OutBound','2230','Completed','452721020.DSH.IC834.D140114.T231640874.P.IN','23:16:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:40',1,'2014-01-14 23:16:41'),(2855,'Inbound',NULL,'Completed','452721020.I834.D140310.T1933198.P.OUT','19:23:00','2014-03-10','','CMSFFM','452721020',0,'2014-03-10 20:59:59',0,'2014-03-10 21:03:04'),(450,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.070514551.P.IN','07:05:14','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:05:14',NULL,NULL),(1188,'Inbound',NULL,'Completed','452721020.999.D131228.T1113575.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:53:29',NULL,'2014-01-05 16:53:31'),(331,'OutBound','1748','Completed','452721020.DSH.IC834.D131227.T154839140.P.IN','15:48:39','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:48:39',1,'2013-12-27 20:48:39'),(1304,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112367.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:27',NULL,'2014-01-05 17:00:30'),(298,'OutBound','7214','Completed','452721020.DSH.IC834.D131227.T153517163.P.IN','15:35:17','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:35:17',1,'2013-12-27 20:35:17'),(1770,'OutBound','2445','Completed','452721020.DSH.IC834.D140114.T230840684.P.IN','23:08:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:40',1,'2014-01-14 23:08:41'),(2344,'OutBound','1821','Completed','452721020.DSH.IC834.D140115.T090304792.P.IN','09:03:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:04',1,'2014-01-15 09:03:05'),(2216,'OutBound','3638','Completed','452721020.DSH.IC834.D140115.T001908243.P.IN','00:19:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:08',1,'2014-01-15 00:19:09'),(2830,'Inbound',NULL,'Completed','452721020.I834.D140228.T1927148.P.OUT','19:12:00','2014-02-28','','CMSFFM','452721020',0,'2014-02-28 21:30:02',0,'2014-02-28 21:31:58'),(1138,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113075.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:11',NULL,'2014-01-05 16:51:13'),(2813,'Inbound',NULL,'Completed','452721020.CIC834.D140220.T1832576.P.OUT','18:26:00','2014-02-20','','CMSFFM','452721020',0,'2014-02-20 21:30:02',0,'2014-02-20 21:30:24'),(2835,'Inbound',NULL,'Completed','452721020.CIC834.D140303.T1838004.P.OUT','18:31:00','2014-03-03','','CMSFFM','452721020',0,'2014-03-03 21:00:00',0,'2014-03-03 21:00:28'),(1353,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113151.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:44',NULL,'2014-01-05 17:02:46'),(2428,'OutBound','3005','Completed','452721020.DSH.IC834.D140115.T090358886.P.IN','09:03:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:59',1,'2014-01-15 09:03:59'),(2214,'OutBound','3609','Completed','452721020.DSH.IC834.D140115.T001904971.P.IN','00:19:04','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:05',1,'2014-01-15 00:19:05'),(2370,'OutBound','5134','Completed','452721020.DSH.IC834.D140115.T090319590.P.IN','09:03:19','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:19',1,'2014-01-15 09:03:19'),(2717,'Inbound',NULL,'Completed','452721020.999.D140114.T2353392.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 07:05:59',NULL,'2014-01-23 07:05:59'),(562,'OutBound','775','Completed','452721020.DSH.IC834.D140102.T114102888.P.IN','11:41:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:03',1,'2014-01-02 16:41:03'),(2059,'OutBound','966','Completed','452721020.DSH.IC834.D140114.T231701335.P.IN','23:17:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:01',1,'2014-01-14 23:17:02'),(2755,'Inbound',NULL,'Completed','452721020.I834.D140123.T1832468.P.OUT','18:27:00','2014-01-23','','CMSFFM','452721020',0,'2014-01-23 21:00:02',NULL,'2014-01-23 21:01:47'),(267,'OutBound','7352','Completed','452721020.DSH.IC834.D131227.T152726268.P.IN','15:27:26','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:27:26',1,'2013-12-27 20:27:26'),(1264,'Inbound',NULL,'Completed','452721020.999.D131228.T0502179.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:36',NULL,'2014-01-05 16:58:38'),(1542,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113537.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:35',NULL,'2014-01-13 03:03:35'),(1817,'OutBound','5794','Completed','452721020.DSH.IC834.D140114.T230943141.P.IN','23:09:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:43',1,'2014-01-14 23:09:44'),(1840,'OutBound','5150','Completed','452721020.DSH.IC834.D140114.T231012888.P.IN','23:10:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:13',1,'2014-01-14 23:10:14'),(2154,'OutBound','5794','Completed','452721020.DSH.IC834.D140115.T001750631.P.IN','00:17:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:50',1,'2014-01-15 00:17:51'),(460,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071345750.P.IN','07:13:45','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:13:46',NULL,NULL),(1830,'OutBound','5126','Completed','452721020.DSH.IC834.D140114.T230958737.P.IN','23:09:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:58',1,'2014-01-14 23:09:59'),(1580,'OutBound','2217','Completed','452721020.DSH.IC834.D140114.T230447881.P.IN','23:04:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:48',1,'2014-01-14 23:04:48'),(2447,'OutBound','3170','Completed','452721020.DSH.IC834.D140115.T090413945.P.IN','09:04:13','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:14',1,'2014-01-15 09:04:14'),(2679,'Inbound',NULL,'Completed','452721020.999.D140115.T0204315.P.OUT','00:47:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 05:02:44',1,'2014-01-23 05:02:45'),(2788,'Inbound',NULL,'Completed','452721020.CIC834.D140209.T1817535.P.OUT','18:12:00','2014-02-09','','CMSFFM','452721020',0,'2014-02-09 19:00:03',NULL,'2014-02-09 19:00:09'),(1561,'Inbound',NULL,'Completed','452721020.999.D131228.T1113449.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:52',NULL,'2014-01-13 03:03:53'),(1836,'OutBound','5129','Completed','452721020.DSH.IC834.D140114.T231007279.P.IN','23:10:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:07',1,'2014-01-14 23:10:08'),(1961,'OutBound','2338','Completed','452721020.DSH.IC834.D140114.T231452720.P.IN','23:14:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:52',1,'2014-01-14 23:14:53'),(2824,'Inbound',NULL,'Completed','452721020.I834.D140224.T1829128.P.OUT','18:21:00','2014-02-24','','CMSFFM','452721020',0,'2014-02-26 09:30:02',0,'2014-02-26 09:31:09'),(466,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071459588.P.IN','07:14:59','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:14:59',NULL,NULL),(1294,'Inbound',NULL,'Completed','452721020.999.D131228.T1113570.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:59',NULL,'2014-01-05 17:00:02'),(1826,'OutBound','5120','Completed','452721020.DSH.IC834.D140114.T230954612.P.IN','23:09:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:54',1,'2014-01-14 23:09:54'),(2772,'Inbound',NULL,'Completed','452721020.I834.D140129.T1837149.P.OUT','18:30:00','2014-01-29','','CMSFFM','452721020',0,'2014-01-29 21:00:02',NULL,'2014-01-29 21:01:55'),(309,'OutBound','1727','Completed','452721020.DSH.IC834.D131227.T153948334.P.IN','15:39:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:39:48',1,'2013-12-27 20:39:49'),(1371,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114051.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:15',NULL,'2014-01-05 17:23:17'),(1757,'OutBound','2440','Completed','452721020.DSH.IC834.D140114.T230825642.P.IN','23:08:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:25',1,'2014-01-14 23:08:26'),(1954,'OutBound','3901','Completed','452721020.DSH.IC834.D140114.T231445488.P.IN','23:14:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:45',1,'2014-01-14 23:14:46'),(2011,'OutBound','5850','Completed','452721020.DSH.IC834.D140114.T231559492.P.IN','23:15:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:59',1,'2014-01-14 23:16:01'),(2367,'OutBound','7163','Completed','452721020.DSH.IC834.D140115.T090317929.P.IN','09:03:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:18',1,'2014-01-15 09:03:18'),(2547,'OutBound','3259','Completed','452721020.DSH.IC834.D140120.T054424232.P.IN','05:44:24','2014-01-20','0','452721020','CMSFFM',1,'2014-01-20 05:44:24',1,'2014-01-20 05:44:24'),(206,'OutBound','1732','Completed','452721020.DSH.IC834.D131227.T150227188.P.IN','15:02:27','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:02:27',1,'2013-12-27 20:02:27'),(486,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104627632.P.IN','10:46:27','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:46:27',NULL,NULL),(1228,'Inbound',NULL,'Completed','452721020.999.D131228.T1113502.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:24',NULL,'2014-01-05 16:55:26'),(1491,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114028.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:23',NULL,'2014-01-13 03:02:24'),(1974,'OutBound','150','Completed','452721020.DSH.IC834.D140114.T231508977.P.IN','23:15:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:08',1,'2014-01-14 23:15:09'),(2197,'OutBound','5117','Completed','452721020.DSH.IC834.D140115.T001845269.P.IN','00:18:45','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:45',1,'2014-01-15 00:18:46'),(2358,'OutBound','1662','Completed','452721020.DSH.IC834.D140115.T090312878.P.IN','09:03:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:13',1,'2014-01-15 09:03:13'),(2416,'OutBound','3627','Completed','452721020.DSH.IC834.D140115.T090350949.P.IN','09:03:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:51',1,'2014-01-15 09:03:51'),(2694,'Inbound',NULL,'Completed','452721020.999.D140114.T2350196.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:39:29',NULL,'2014-01-23 06:39:30'),(6,'Inbound',NULL,'Completed','452721020.I834.D131204.T1831483.P.OUT','18:22:00','2013-12-04','','CMSFFM','452721020',0,'2013-12-25 17:45:01',NULL,'2013-12-25 17:51:11'),(341,'OutBound','1088','Completed','452721020.DSH.IC834.D131227.T155510348.P.IN','15:55:10','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:55:10',1,'2013-12-27 20:55:11'),(365,'OutBound','5300','Completed','452721020.DSH.IC834.D131227.T161647765.P.IN','16:16:47','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:16:48',1,'2013-12-27 21:16:48'),(476,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.072043135.P.IN','07:20:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:20:43',NULL,NULL),(1124,'Inbound',NULL,'Completed','452721020.999.D131227.T1816315.P.OUT','18:10:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:50:32',NULL,'2014-01-05 16:50:35'),(2014,'OutBound','2284','Completed','452721020.DSH.IC834.D140114.T231604109.P.IN','23:16:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:04',1,'2014-01-14 23:16:05'),(2286,'OutBound','705','Completed','452721020.DSH.IC834.D140115.T002036781.P.IN','00:20:36','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:36',1,'2014-01-15 00:20:38'),(1169,'Inbound',NULL,'Completed','452721020.999.D131228.T1112513.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:36',NULL,'2014-01-05 16:52:39'),(1288,'Inbound',NULL,'Completed','452721020.999.D131228.T1113393.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:43',NULL,'2014-01-05 16:59:45'),(2018,'OutBound','5350','Completed','452721020.DSH.IC834.D140114.T231608693.P.IN','23:16:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:08',1,'2014-01-14 23:16:09'),(1121,'Inbound',NULL,'Completed','452721020.999.D131228.T1113212.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:24',NULL,'2014-01-05 16:50:26'),(1589,'OutBound','5875','Completed','452721020.DSH.IC834.D140114.T230459277.P.IN','23:04:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:59',1,'2014-01-14 23:05:00'),(1615,'OutBound','3904','Completed','452721020.DSH.IC834.D140114.T230530761.P.IN','23:05:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:30',1,'2014-01-14 23:05:31'),(1628,'OutBound','1022','Completed','452721020.DSH.IC834.D140114.T230545967.P.IN','23:05:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:46',1,'2014-01-14 23:05:46'),(2138,'OutBound','1663','Completed','452721020.DSH.IC834.D140115.T001728922.P.IN','00:17:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:29',1,'2014-01-15 00:17:29'),(2650,'Inbound',NULL,'Completed','452721020.999.D140115.T0223258.P.OUT','00:04:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:25:12',1,'2014-01-23 04:25:12'),(22,'Inbound',NULL,'Completed','452721020.I834.D131209.T1842144.P.OUT','18:28:00','2013-12-09','','CMSFFM','452721020',0,'2013-12-25 19:30:02',NULL,'2013-12-25 19:38:13'),(410,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062743710.P.IN','06:27:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:27:44',NULL,NULL),(1301,'Inbound',NULL,'Completed','452721020.999.D131228.T1112405.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:19',NULL,'2014-01-05 17:00:21'),(2188,'OutBound','5163','Completed','452721020.DSH.IC834.D140115.T001833703.P.IN','00:18:33','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:33',1,'2014-01-15 00:18:35'),(338,'OutBound','897','Completed','452721020.DSH.IC834.D131227.T155113509.P.IN','15:51:13','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:51:13',1,'2013-12-27 20:51:14'),(1723,'OutBound','1005','Completed','452721020.DSH.IC834.D140114.T230740908.P.IN','23:07:40','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:41',1,'2014-01-14 23:07:41'),(2208,'OutBound','3604','Completed','452721020.DSH.IC834.D140115.T001858113.P.IN','00:18:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:58',1,'2014-01-15 00:18:59'),(2350,'OutBound','1820','Completed','452721020.DSH.IC834.D140115.T090308194.P.IN','09:03:08','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:08',1,'2014-01-15 09:03:08'),(2517,'OutBound','1489','Completed','452721020.DSH.IC834.D140115.T222144150.P.IN','22:21:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:44',1,'2014-01-15 22:21:44'),(2613,'Inbound',NULL,'Completed','452721020.999.D140115.T0053411.P.OUT','23:36:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:57:57',1,'2014-01-23 03:57:58'),(2735,'Inbound',NULL,'Completed','452721020.999.D140115.T0216283.P.OUT','00:02:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 09:45:26',NULL,'2014-01-23 09:45:26'),(73,'Inbound',NULL,'Completed','452721020.I834.D131014.T1807356.P.OUT','18:02:00','2013-10-14','','CMSFFM','452721020',0,'2013-12-26 02:46:11',NULL,'2013-12-26 02:46:33'),(472,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071701639.P.IN','07:17:01','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:17:02',NULL,NULL),(1221,'Inbound',NULL,'Completed','452721020.999.D131228.T1232193.P.OUT','12:25:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:01',NULL,'2014-01-05 16:55:03'),(2427,'OutBound','3169','Completed','452721020.DSH.IC834.D140115.T090358147.P.IN','09:03:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:58',1,'2014-01-15 09:03:58'),(368,'OutBound','342','Completed','452721020.DSH.IC834.D131227.T161828240.P.IN','16:18:28','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:18:28',1,'2013-12-27 21:18:28'),(1391,'Inbound',NULL,'Completed','452721020.999.D131228.T1112495.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:11',NULL,'2014-01-05 17:24:13'),(1627,'OutBound','7371','Completed','452721020.DSH.IC834.D140114.T230544932.P.IN','23:05:44','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:45',1,'2014-01-14 23:05:45'),(1676,'OutBound','2283','Completed','452721020.DSH.IC834.D140114.T230643898.P.IN','23:06:43','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:44',1,'2014-01-14 23:06:44'),(1703,'OutBound','1003','Completed','452721020.DSH.IC834.D140114.T230717325.P.IN','23:07:17','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:17',1,'2014-01-14 23:07:18'),(1835,'OutBound','5122','Completed','452721020.DSH.IC834.D140114.T231005664.P.IN','23:10:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:05',1,'2014-01-14 23:10:07'),(2440,'OutBound','3009','Completed','452721020.DSH.IC834.D140115.T090409584.P.IN','09:04:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:09',1,'2014-01-15 09:04:09'),(2630,'Inbound',NULL,'Completed','452721020.999.D140115.T0203527.P.OUT','00:45:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 04:13:16',1,'2014-01-23 04:13:17'),(491,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.104710503.P.IN','10:47:10','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:47:10',NULL,NULL),(1585,'OutBound','2421','Completed','452721020.DSH.IC834.D140114.T230453609.P.IN','23:04:53','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:53',1,'2014-01-14 23:04:54'),(2718,'Inbound',NULL,'Completed','452721020.999.D140114.T2329171.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 07:06:35',NULL,'2014-01-23 07:06:35'),(2742,'Inbound',NULL,'Completed','452721020.999.D140115.T0351048.P.OUT','03:00:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 12:30:02',NULL,'2014-01-23 12:30:03'),(245,'OutBound','4968','Completed','452721020.DSH.IC834.D131227.T151753612.P.IN','15:17:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:17:53',1,'2013-12-27 20:17:54'),(528,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110947212.P.IN','11:09:47','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:47',NULL,NULL),(1163,'Inbound',NULL,'Completed','452721020.999.D131228.T1112402.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:20',NULL,'2014-01-05 16:52:22'),(1972,'OutBound','4824','Completed','452721020.DSH.IC834.D140114.T231505512.P.IN','23:15:05','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:05',1,'2014-01-14 23:15:06'),(2531,'OutBound','11538','Completed','452721020.DSH.IC834.D140115.T222151650.P.IN','22:21:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:51',1,'2014-01-15 22:21:52'),(2587,'Inbound',NULL,'Completed','452721020.999.D140115.T0027074.P.OUT','23:39:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:46:10',1,'2014-01-23 03:46:11'),(2685,'Inbound',NULL,'Completed','452721020.999.D140115.T0153150.P.OUT','00:40:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 05:06:59',1,'2014-01-23 05:06:59'),(57,'Inbound',NULL,'Completed','452721020.I834.D131119.T1818449.P.OUT','18:07:00','2013-11-19','','CMSFFM','452721020',0,'2013-12-26 00:31:17',NULL,'2013-12-26 00:32:08'),(1855,'OutBound','5119','Completed','452721020.DSH.IC834.D140114.T231034395.P.IN','23:10:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:34',1,'2014-01-14 23:10:35'),(2449,'OutBound','3122','Completed','452721020.DSH.IC834.D140115.T090415467.P.IN','09:04:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:15',1,'2014-01-15 09:04:15'),(2291,'OutBound','676','Completed','452721020.DSH.IC834.D140115.T002043554.P.IN','00:20:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:43',1,'2014-01-15 00:20:44'),(20,'Inbound',NULL,'Completed','452721020.I834.D131120.T1812251.P.OUT','18:06:00','2013-11-20','','CMSFFM','452721020',0,'2013-12-25 19:00:01',NULL,'2013-12-25 19:02:40'),(168,'OutBound','2619','Completed','452721020.DSH.IC834.D131227.T143955244.P.IN','14:39:55','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:39:55',1,'2013-12-27 19:39:56'),(1270,'Inbound',NULL,'Completed','452721020.999.D131228.T1112510.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:53',NULL,'2014-01-05 16:58:55'),(1477,'Inbound',NULL,'Completed','452721020.I834.D140110.T1833415.P.OUT','18:26:00','2014-01-10','','CMSFFM','452721020',0,'2014-01-13 03:00:03',NULL,'2014-01-13 03:00:44'),(1746,'OutBound','117','Completed','452721020.DSH.IC834.D140114.T230811643.P.IN','23:08:11','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:11',1,'2014-01-14 23:08:12'),(18,'Inbound',NULL,'Completed','452721020.I834.D131009.T1807246.P.OUT','18:01:00','2013-10-09','','CMSFFM','452721020',0,'2013-12-25 18:32:23',NULL,'2013-12-25 18:32:30'),(436,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065506422.P.IN','06:55:06','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:55:06',NULL,NULL),(560,'OutBound','3313','Completed','452721020.DSH.IC834.D140102.T114100746.P.IN','11:41:00','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:00',1,'2014-01-02 16:41:00'),(563,'OutBound','2601','Completed','452721020.DSH.IC834.D140102.T114104280.P.IN','11:41:04','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:04',1,'2014-01-02 16:41:05'),(1456,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113230.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:12',NULL,'2014-01-05 17:27:14'),(1569,'Inbound',NULL,'Completed','452721020.999.D131228.T1114042.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:59',NULL,'2014-01-13 03:04:00'),(1983,'OutBound','113','Completed','452721020.DSH.IC834.D140114.T231518669.P.IN','23:15:18','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:18',1,'2014-01-14 23:15:19'),(2265,'OutBound','5792','Completed','452721020.DSH.IC834.D140115.T002011315.P.IN','00:20:11','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:11',1,'2014-01-15 00:20:12'),(1256,'Inbound',NULL,'Completed','452721020.999.D131228.T1113472.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:14',NULL,'2014-01-05 16:58:16'),(1533,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113097.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:26',NULL,'2014-01-13 03:03:27'),(2229,'OutBound','3005','Completed','452721020.DSH.IC834.D140115.T001923433.P.IN','00:19:23','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:23',1,'2014-01-15 00:19:24'),(1357,'Inbound',NULL,'Completed','452721020.999.D131228.T1112544.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:36',NULL,'2014-01-05 17:22:38'),(1468,'Inbound',NULL,'Completed','452721020.I834.D140106.T1832458.P.OUT','18:24:00','2014-01-06','','CMSFFM','452721020',0,'2014-01-07 04:00:01',NULL,'2014-01-07 04:06:57'),(1958,'OutBound','671','Completed','452721020.DSH.IC834.D140114.T231449596.P.IN','23:14:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:49',1,'2014-01-14 23:14:50'),(2234,'OutBound','7610','Completed','452721020.DSH.IC834.D140115.T001931526.P.IN','00:19:31','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:31',1,'2014-01-15 00:19:32'),(2516,'OutBound','1502','Completed','452721020.DSH.IC834.D140115.T222143573.P.IN','22:21:43','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:43',1,'2014-01-15 22:21:43'),(72,'Inbound',NULL,'Completed','452721020.I834.D131117.T1812266.P.OUT','18:03:00','2013-11-17','','CMSFFM','452721020',0,'2013-12-26 02:45:01',NULL,'2013-12-26 02:46:10'),(322,'OutBound','1932','Completed','452721020.DSH.IC834.D131227.T154453990.P.IN','15:44:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:44:54',1,'2013-12-27 20:44:54'),(556,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113729401.T.IN','11:37:29','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:37:29',NULL,NULL),(1537,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113535.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:30',NULL,'2014-01-13 03:03:31'),(1556,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113297.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:48',NULL,'2014-01-13 03:03:48'),(2225,'OutBound','3656','Completed','452721020.DSH.IC834.D140115.T001918738.P.IN','00:19:18','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:18',1,'2014-01-15 00:19:19'),(2674,'Inbound',NULL,'Completed','452721020.999.D140115.T0106357.P.OUT','23:58:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:57:15',1,'2014-01-23 04:57:16'),(2779,'Inbound',NULL,'Completed','452721020.CIC834.D140204.T1832357.P.OUT','18:26:00','2014-02-04','','CMSFFM','452721020',0,'2014-02-04 21:30:02',NULL,'2014-02-04 21:30:03'),(2829,'Inbound',NULL,'Completed','452721020.CIC834.D140228.T1926212.P.OUT','19:08:00','2014-02-28','','CMSFFM','452721020',0,'2014-02-28 21:00:01',0,'2014-02-28 21:00:29'),(236,'OutBound','4990','Completed','452721020.DSH.IC834.D131227.T151504157.P.IN','15:15:04','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:15:04',1,'2013-12-27 20:15:04'),(1292,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113436.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:54',NULL,'2014-01-05 16:59:56'),(1355,'Inbound',NULL,'Completed','452721020.999.D131228.T1112516.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:50',NULL,'2014-01-05 17:02:52'),(1774,'OutBound','3994','Completed','452721020.DSH.IC834.D140114.T230846321.P.IN','23:08:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:46',1,'2014-01-14 23:08:47'),(2038,'OutBound','1063','Completed','452721020.DSH.IC834.D140114.T231634831.P.IN','23:16:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:34',1,'2014-01-14 23:16:35'),(2088,'OutBound','114','Completed','452721020.DSH.IC834.D140114.T231738819.P.IN','23:17:38','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:38',1,'2014-01-14 23:17:39'),(344,'OutBound','1942','Completed','452721020.DSH.IC834.D131227.T155642190.P.IN','15:56:42','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:56:42',1,'2013-12-27 20:56:42'),(1516,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113442.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:07',NULL,'2014-01-13 03:03:08'),(2590,'Inbound',NULL,'Completed','452721020.999.D140114.T2332178.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:47:31',1,'2014-01-23 03:47:32'),(347,'OutBound','4084','Completed','452721020.DSH.IC834.D131227.T160002435.P.IN','16:00:02','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:00:02',1,'2013-12-27 21:00:03'),(1200,'Inbound',NULL,'Completed','452721020.999.D131228.T1113176.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:02',NULL,'2014-01-05 16:54:04'),(1550,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114026.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:42',NULL,'2014-01-13 03:03:43'),(2037,'OutBound','2631','Completed','452721020.DSH.IC834.D140114.T231633592.P.IN','23:16:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:33',1,'2014-01-14 23:16:34'),(2122,'OutBound','2072','Completed','452721020.DSH.IC834.D140115.T001709326.P.IN','00:17:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:09',1,'2014-01-15 00:17:10'),(2317,'OutBound','2054','Completed','452721020.DSH.IC834.D140115.T090249957.P.IN','09:02:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:50',1,'2014-01-15 09:02:50'),(1173,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112524.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:47',NULL,'2014-01-05 16:52:50'),(1414,'Inbound',NULL,'Completed','452721020.999.D131228.T0502222.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:15',NULL,'2014-01-05 17:25:17'),(1431,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112364.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:02',NULL,'2014-01-05 17:26:05'),(1724,'OutBound','968','Completed','452721020.DSH.IC834.D140114.T230742118.P.IN','23:07:42','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:42',1,'2014-01-14 23:07:43'),(2432,'OutBound','3007','Completed','452721020.DSH.IC834.D140115.T090401437.P.IN','09:04:01','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:01',1,'2014-01-15 09:04:01'),(2515,'OutBound','1512','Completed','452721020.DSH.IC834.D140115.T222142900.P.IN','22:21:42','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:43',1,'2014-01-15 22:21:43'),(1702,'OutBound','2218','Completed','452721020.DSH.IC834.D140114.T230716200.P.IN','23:07:16','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:16',1,'2014-01-14 23:07:17'),(2266,'OutBound','5780','Completed','452721020.DSH.IC834.D140115.T002012513.P.IN','00:20:12','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:12',1,'2014-01-15 00:20:13'),(2467,'OutBound','5778','Completed','452721020.DSH.IC834.D140115.T090428827.P.IN','09:04:28','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:28',1,'2014-01-15 09:04:29'),(171,'OutBound','351','Completed','452721020.DSH.IC834.D131227.T144517800.P.IN','14:45:17','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:45:18',1,'2013-12-27 19:45:18'),(1395,'Inbound',NULL,'Completed','452721020.999.D131227.T1703160.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 17:24:22',NULL,'2014-01-05 17:24:24'),(235,'OutBound','1717','Completed','452721020.DSH.IC834.D131227.T151443502.P.IN','15:14:43','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:14:43',1,'2013-12-27 20:14:44'),(1517,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114079.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:08',NULL,'2014-01-13 03:03:09'),(1868,'OutBound','3118','Completed','452721020.DSH.IC834.D140114.T231052107.P.IN','23:10:52','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:52',1,'2014-01-14 23:10:53'),(1968,'OutBound','155','Completed','452721020.DSH.IC834.D140114.T231500685.P.IN','23:15:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:00',1,'2014-01-14 23:15:01'),(2085,'OutBound','125','Completed','452721020.DSH.IC834.D140114.T231734992.P.IN','23:17:34','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:35',1,'2014-01-14 23:17:36'),(2333,'OutBound','1979','Completed','452721020.DSH.IC834.D140115.T090258778.P.IN','09:02:58','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:02:58',1,'2014-01-15 09:02:59'),(2352,'OutBound','1658','Completed','452721020.DSH.IC834.D140115.T090309291.P.IN','09:03:09','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:09',1,'2014-01-15 09:03:09'),(382,'Inbound',NULL,'Completed','452721020.I834.D131228.T2122362.P.OUT','21:04:00','2013-12-28','','CMSFFM','452721020',1,'2013-12-29 11:12:34',1,'2013-12-29 11:15:27'),(465,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071450163.P.IN','07:14:50','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:14:50',NULL,NULL),(1489,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113585.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:21',NULL,'2014-01-13 03:02:22'),(1492,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113159.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:24',NULL,'2014-01-13 03:02:25'),(1622,'OutBound','2419','Completed','452721020.DSH.IC834.D140114.T230539511.P.IN','23:05:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:39',1,'2014-01-14 23:05:40'),(2728,'Inbound',NULL,'Completed','452721020.999.D140115.T0152015.P.OUT','00:42:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 08:38:31',NULL,'2014-01-23 08:38:31'),(2793,'Inbound',NULL,'Completed','452721020.I834.D140211.T1847405.P.OUT','18:41:00','2014-02-11','','CMSFFM','452721020',0,'2014-02-11 21:00:03',NULL,'2014-02-11 21:02:55'),(1397,'Inbound',NULL,'Completed','452721020.999.D131228.T1114026.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:27',NULL,'2014-01-05 17:24:30'),(1834,'OutBound','5134','Completed','452721020.DSH.IC834.D140114.T231003713.P.IN','23:10:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:03',1,'2014-01-14 23:10:04'),(2222,'OutBound','3657','Completed','452721020.DSH.IC834.D140115.T001915189.P.IN','00:19:15','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:15',1,'2014-01-15 00:19:16'),(2501,'OutBound','720','Completed','452721020.DSH.IC834.D140115.T090451275.P.IN','09:04:51','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:51',1,'2014-01-15 09:04:51'),(2673,'Inbound',NULL,'Completed','452721020.999.D140114.T2325119.P.OUT','23:15:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:52:49',1,'2014-01-23 04:52:49'),(400,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.061843618.P.IN','06:18:43','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:18:44',NULL,NULL),(1261,'Inbound',NULL,'Completed','452721020.999.D131228.T1112184.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:58:28',NULL,'2014-01-05 16:58:30'),(2166,'OutBound','5155','Completed','452721020.DSH.IC834.D140115.T001805923.P.IN','00:18:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:05',1,'2014-01-15 00:18:06'),(2797,'Inbound',NULL,'Completed','452721020.CIC834.D140213.T1848141.P.OUT','18:41:00','2014-02-13','','CMSFFM','452721020',0,'2014-02-13 21:30:02',NULL,'2014-02-13 21:30:18'),(1315,'Inbound',NULL,'Completed','452721020.999.D131228.T1113264.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:58',NULL,'2014-01-05 17:01:00'),(564,'OutBound','5034','Completed','452721020.DSH.IC834.D140102.T114105656.P.IN','11:41:05','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:06',1,'2014-01-02 16:41:06'),(1398,'Inbound',NULL,'Completed','452721020.999.D131228.T1113114.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:30',NULL,'2014-01-05 17:24:32'),(2135,'OutBound','5878','Completed','452721020.DSH.IC834.D140115.T001724984.P.IN','00:17:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:25',1,'2014-01-15 00:17:26'),(2361,'OutBound','1655','Completed','452721020.DSH.IC834.D140115.T090314590.P.IN','09:03:14','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:14',1,'2014-01-15 09:03:14'),(2803,'Inbound',NULL,'Completed','452721020.CIC834.D140216.T1819238.P.OUT','18:12:00','2014-02-16','','CMSFFM','452721020',0,'2014-02-16 19:00:02',0,'2014-02-16 19:00:03'),(524,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.110907116.P.IN','11:09:07','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:09:07',NULL,NULL),(1320,'Inbound',NULL,'Completed','452721020.999.D131228.T1112273.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:12',NULL,'2014-01-05 17:01:14'),(2528,'OutBound','3650','Completed','452721020.DSH.IC834.D140115.T222150696.P.IN','22:21:50','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:50',1,'2014-01-15 22:21:50'),(339,'OutBound','1944','Completed','452721020.DSH.IC834.D131227.T155208983.P.IN','15:52:08','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:52:09',1,'2013-12-27 20:52:09'),(1445,'Inbound',NULL,'Completed','452721020.999.D131228.T1112570.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:41',NULL,'2014-01-05 17:26:43'),(1852,'OutBound','5116','Completed','452721020.DSH.IC834.D140114.T231030439.P.IN','23:10:30','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:10:30',1,'2014-01-14 23:10:31'),(1894,'OutBound','3120','Completed','452721020.DSH.IC834.D140114.T231126658.P.IN','23:11:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:26',1,'2014-01-14 23:11:27'),(2204,'OutBound','3649','Completed','452721020.DSH.IC834.D140115.T001853544.P.IN','00:18:53','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:53',1,'2014-01-15 00:18:54'),(2354,'OutBound','3019','Completed','452721020.DSH.IC834.D140115.T090310372.P.IN','09:03:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:10',1,'2014-01-15 09:03:10'),(2460,'OutBound','5779','Completed','452721020.DSH.IC834.D140115.T090424805.P.IN','09:04:24','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:24',1,'2014-01-15 09:04:24'),(2589,'Inbound',NULL,'Completed','452721020.999.D140114.T2335182.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:47:25',1,'2014-01-23 03:47:26'),(376,'OutBound','2164','Completed','452721020.DSH.IC834.D131227.T164221608.P.IN','16:42:21','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:42:21',1,'2013-12-27 21:42:22'),(387,'Inbound',NULL,'Completed','452721020.I834.D131231.T1857330.P.OUT','18:52:00','2013-12-31','','CMSFFM','452721020',1,'2014-01-02 04:26:39',1,'2014-01-02 04:36:16'),(413,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063022271.P.IN','06:30:22','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:30:22',NULL,NULL),(1238,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112215.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:23',NULL,'2014-01-05 16:57:26'),(1678,'OutBound','2292','Completed','452721020.DSH.IC834.D140114.T230646114.P.IN','23:06:46','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:46',1,'2014-01-14 23:06:47'),(1920,'OutBound','686','Completed','452721020.DSH.IC834.D140114.T231407556.P.IN','23:14:07','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:07',1,'2014-01-14 23:14:08'),(26,'Inbound',NULL,'Completed','452721020.I834.D131102.T1808339.P.OUT','18:03:00','2013-11-02','','CMSFFM','452721020',0,'2013-12-25 20:01:08',NULL,'2013-12-25 20:01:51'),(70,'Inbound',NULL,'Completed','452721020.I834.D131028.T1816243.P.OUT','18:08:00','2013-10-28','','CMSFFM','452721020',0,'2013-12-26 02:16:32',NULL,'2013-12-26 02:17:13'),(1297,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112190.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:08',NULL,'2014-01-05 17:00:10'),(1976,'OutBound','143','Completed','452721020.DSH.IC834.D140114.T231510280.P.IN','23:15:10','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:10',1,'2014-01-14 23:15:11'),(2555,'Inbound',NULL,'Completed','452721020.I834.D140121.T1832039.P.OUT','18:24:00','2014-01-21','','CMSFFM','452721020',1,'2014-01-22 03:21:51',1,'2014-01-22 03:23:13'),(2560,'Inbound',NULL,'Completed','452721020.999.D140113.T2226452.P.OUT','22:20:00','2014-01-13','','CMSFFM','452721020',0,'2014-01-23 03:39:34',NULL,'2014-01-23 03:39:35'),(262,'OutBound','991','Completed','452721020.DSH.IC834.D131227.T152529683.P.IN','15:25:29','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:25:30',1,'2013-12-27 20:25:30'),(1128,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113090.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:43',NULL,'2014-01-05 16:50:46'),(2477,'OutBound','5885','Completed','452721020.DSH.IC834.D140115.T090435431.P.IN','09:04:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:35',1,'2014-01-15 09:04:35'),(2563,'Inbound',NULL,'Completed','452721020.999.D140115.T2256584.P.OUT','22:50:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 03:39:36',NULL,'2014-01-23 03:39:37'),(2569,'Inbound',NULL,'Completed','452721020.999.D140114.T2329204.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:41:31',1,'2014-01-23 03:41:32'),(2594,'Inbound',NULL,'Completed','452721020.999.D140115.T0136499.P.OUT','00:24:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:48:35',1,'2014-01-23 03:48:35'),(61,'Inbound',NULL,'Completed','452721020.I834.D131116.T1811345.P.OUT','18:03:00','2013-11-16','','CMSFFM','452721020',0,'2013-12-26 01:00:40',NULL,'2013-12-26 01:01:22'),(403,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062033179.P.IN','06:20:33','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:20:33',NULL,NULL),(445,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.065810414.P.IN','06:58:10','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:58:10',NULL,NULL),(1526,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114123.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:19',NULL,'2014-01-13 03:03:19'),(1559,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502166.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:50',NULL,'2014-01-13 03:03:51'),(1275,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112405.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:07',NULL,'2014-01-05 16:59:09'),(1545,'Inbound',NULL,'Completed','i452721020.999.D131228.T0502179.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:37',NULL,'2014-01-13 03:03:38'),(1654,'OutBound','6019','Completed','452721020.DSH.IC834.D140114.T230615286.P.IN','23:06:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:15',1,'2014-01-14 23:06:16'),(1911,'OutBound','3170','Completed','452721020.DSH.IC834.D140114.T231149378.P.IN','23:11:49','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:49',1,'2014-01-14 23:11:50'),(1937,'OutBound','6052','Completed','452721020.DSH.IC834.D140114.T231425475.P.IN','23:14:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:25',1,'2014-01-14 23:14:27'),(2610,'Inbound',NULL,'Completed','452721020.999.D140114.T2335026.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:56:32',1,'2014-01-23 03:56:33'),(68,'Inbound',NULL,'Completed','452721020.I834.D131214.T1827131.P.OUT','18:21:00','2013-12-14','','CMSFFM','452721020',0,'2013-12-26 02:00:01',NULL,'2013-12-26 02:04:11'),(1821,'OutBound','1656','Completed','452721020.DSH.IC834.D140114.T230948212.P.IN','23:09:48','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:48',1,'2014-01-14 23:09:49'),(2042,'OutBound','2238','Completed','452721020.DSH.IC834.D140114.T231639605.P.IN','23:16:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:39',1,'2014-01-14 23:16:40'),(2254,'OutBound','5785','Completed','452721020.DSH.IC834.D140115.T001957799.P.IN','00:19:57','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:57',1,'2014-01-15 00:19:58'),(2463,'OutBound','5788','Completed','452721020.DSH.IC834.D140115.T090426153.P.IN','09:04:26','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:26',1,'2014-01-15 09:04:26'),(159,'OutBound','776','Completed','452721020.DSH.IC834.D131227.T111752308.P.IN','11:17:52','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:17:52',1,'2013-12-27 16:17:53'),(221,'OutBound','4793','Completed','452721020.DSH.IC834.D131227.T151014385.P.IN','15:10:14','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:10:14',1,'2013-12-27 20:10:15'),(1417,'Inbound',NULL,'Completed','452721020.999.D131228.T1113153.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:23',NULL,'2014-01-05 17:25:26'),(2031,'OutBound','4414','Completed','452721020.DSH.IC834.D140114.T231626129.P.IN','23:16:26','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:26',1,'2014-01-14 23:16:27'),(2071,'OutBound','380','Completed','452721020.DSH.IC834.D140114.T231715375.P.IN','23:17:15','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:15',1,'2014-01-14 23:17:16'),(75,'Inbound',NULL,'Completed','452721020.I834.D131220.T1911583.P.OUT','19:06:00','2013-12-20','','CMSFFM','452721020',0,'2013-12-26 03:00:01',NULL,'2013-12-26 03:11:07'),(202,'OutBound','1587','Completed','452721020.DSH.IC834.D131227.T145948836.P.IN','14:59:48','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:59:49',1,'2013-12-27 19:59:49'),(507,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105502860.P.IN','10:55:02','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:55:02',NULL,NULL),(1546,'Inbound',NULL,'Completed','452721020.999.D131228.T1113233.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:39',NULL,'2014-01-13 03:03:39'),(2724,'Inbound',NULL,'Completed','452721020.999.D140115.T0353149.P.OUT','02:46:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 08:00:02',NULL,'2014-01-23 08:00:02'),(38,'Inbound',NULL,'Completed','452721020.I834.D131213.T1846513.P.OUT','18:39:00','2013-12-13','','CMSFFM','452721020',0,'2013-12-25 21:30:02',NULL,'2013-12-25 21:39:15'),(1648,'OutBound','2235','Completed','452721020.DSH.IC834.D140114.T230608672.P.IN','23:06:08','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:08',1,'2014-01-14 23:06:09'),(1782,'OutBound','2070','Completed','452721020.DSH.IC834.D140114.T230855982.P.IN','23:08:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:08:56',1,'2014-01-14 23:08:57'),(474,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071734937.P.IN','07:17:34','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:17:35',NULL,NULL),(1279,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113176.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:59:18',NULL,'2014-01-05 16:59:20'),(1323,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113168.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:01:20',NULL,'2014-01-05 17:01:23'),(2095,'OutBound','2426','Completed','452721020.DSH.IC834.D140114.T231747429.P.IN','23:17:47','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:47',1,'2014-01-14 23:17:48'),(2715,'Inbound',NULL,'Completed','452721020.999.D140115.T0336227.P.OUT','01:00:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 07:05:11',NULL,'2014-01-23 07:05:12'),(285,'OutBound','873','Completed','452721020.DSH.IC834.D131227.T153222659.P.IN','15:32:22','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:32:22',1,'2013-12-27 20:32:23'),(1352,'Inbound',NULL,'Completed','452721020.999.D131228.T0502169.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:41',NULL,'2014-01-05 17:02:44'),(2007,'OutBound','4847','Completed','452721020.DSH.IC834.D140114.T231554665.P.IN','23:15:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:54',1,'2014-01-14 23:15:54'),(2084,'OutBound','144','Completed','452721020.DSH.IC834.D140114.T231733603.P.IN','23:17:33','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:33',1,'2014-01-14 23:17:34'),(2285,'OutBound','688','Completed','452721020.DSH.IC834.D140115.T002035567.P.IN','00:20:35','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:35',1,'2014-01-15 00:20:36'),(2411,'OutBound','3608','Completed','452721020.DSH.IC834.D140115.T090346573.P.IN','09:03:46','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:46',1,'2014-01-15 09:03:47'),(268,'OutBound','5044','Completed','452721020.DSH.IC834.D131227.T152732819.P.IN','15:27:32','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:27:33',1,'2013-12-27 20:27:33'),(282,'OutBound','1098','Completed','452721020.DSH.IC834.D131227.T153154977.P.IN','15:31:54','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:55',1,'2013-12-27 20:31:55'),(1260,'Inbound',NULL,'Completed','452721020.999.D131227.T1703154.P.OUT','16:55:00','2013-12-27','','CMSFFM','452721020',0,'2014-01-05 16:58:25',NULL,'2014-01-05 16:58:27'),(1925,'OutBound','6040','Completed','452721020.DSH.IC834.D140114.T231412916.P.IN','23:14:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:13',1,'2014-01-14 23:14:13'),(2670,'Inbound',NULL,'Completed','452721020.999.D140114.T2334378.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:52:35',1,'2014-01-23 04:52:36'),(183,'OutBound','1939','Completed','452721020.DSH.IC834.D131227.T145253506.P.IN','14:52:53','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:52:53',1,'2013-12-27 19:52:54'),(408,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.062513696.P.IN','06:25:13','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:25:14',NULL,NULL),(1122,'Inbound',NULL,'Completed','452721020.999.D131228.T1113537.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:50:27',NULL,'2014-01-05 16:50:29'),(1878,'OutBound','3628','Completed','452721020.DSH.IC834.D140114.T231104645.P.IN','23:11:04','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:04',1,'2014-01-14 23:11:05'),(2008,'OutBound','6443','Completed','452721020.DSH.IC834.D140114.T231555166.P.IN','23:15:55','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:55',1,'2014-01-14 23:15:57'),(2759,'Inbound',NULL,'Completed','452721020.I834.D140127.T1832365.P.OUT','18:27:00','2014-01-27','','CMSFFM','452721020',0,'2014-01-27 21:00:02',NULL,'2014-01-27 21:01:51'),(416,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.063223626.P.IN','06:32:23','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 11:32:24',NULL,NULL),(1419,'Inbound',NULL,'Completed','452721020.999.D131228.T0502166.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:25:29',NULL,'2014-01-05 17:25:31'),(1690,'OutBound','4398','Completed','452721020.DSH.IC834.D140114.T230700852.P.IN','23:07:00','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:00',1,'2014-01-14 23:07:01'),(1793,'OutBound','2059','Completed','452721020.DSH.IC834.D140114.T230912806.P.IN','23:09:12','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:12',1,'2014-01-14 23:09:14'),(2176,'OutBound','5128','Completed','452721020.DSH.IC834.D140115.T001817788.P.IN','00:18:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:17',1,'2014-01-15 00:18:18'),(351,'OutBound','5735','Completed','452721020.DSH.IC834.D131227.T160336370.P.IN','16:03:36','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 21:03:36',1,'2013-12-27 21:03:37'),(1176,'Inbound',NULL,'Completed','452721020.999.D131228.T1113151.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:52:56',NULL,'2014-01-05 16:52:58'),(1876,'OutBound','3647','Completed','452721020.DSH.IC834.D140114.T231102189.P.IN','23:11:02','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:02',1,'2014-01-14 23:11:03'),(2244,'OutBound','3010','Completed','452721020.DSH.IC834.D140115.T001944107.P.IN','00:19:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:44',1,'2014-01-15 00:19:45'),(2408,'OutBound','3633','Completed','452721020.DSH.IC834.D140115.T090344429.P.IN','09:03:44','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:44',1,'2014-01-15 09:03:44'),(313,'OutBound','2413','Completed','452721020.DSH.IC834.D131227.T154240340.P.IN','15:42:40','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:42:40',1,'2013-12-27 20:42:41'),(1231,'Inbound',NULL,'Completed','452721020.999.D131228.T1112364.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:57:04',NULL,'2014-01-05 16:57:06'),(1466,'Inbound',NULL,'Completed','i452721020.999.D131228.T1114005.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:40',NULL,'2014-01-05 17:27:42'),(1578,'OutBound','4520','Completed','452721020.DSH.IC834.D140114.T230445524.P.IN','23:04:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:04:45',1,'2014-01-14 23:04:46'),(2306,'OutBound','3257','Completed','452721020.DSH.IC834.D140115.T002103551.P.IN','00:21:03','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:21:03',1,'2014-01-15 00:21:04'),(2696,'Inbound',NULL,'Completed','452721020.999.D140114.T2329522.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',0,'2014-01-23 06:39:41',NULL,'2014-01-23 06:39:41'),(1405,'Inbound',NULL,'Completed','452721020.999.D131228.T1112284.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:24:50',NULL,'2014-01-05 17:24:52'),(162,'OutBound','3224','Completed','452721020.DSH.IC834.D131227.T112109275.P.IN','11:21:09','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 16:21:09',1,'2013-12-27 16:21:10'),(544,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T113641605.T.IN','11:36:41','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:36:42',NULL,NULL),(1785,'OutBound','2072','Completed','452721020.DSH.IC834.D140114.T230901179.P.IN','23:09:01','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:01',1,'2014-01-14 23:09:02'),(1807,'OutBound','1816','Completed','452721020.DSH.IC834.D140114.T230931481.P.IN','23:09:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:31',1,'2014-01-14 23:09:32'),(2030,'OutBound','4411','Completed','452721020.DSH.IC834.D140114.T231624585.P.IN','23:16:24','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:24',1,'2014-01-14 23:16:25'),(1486,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113124.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:19',NULL,'2014-01-13 03:02:19'),(2261,'OutBound','5779','Completed','452721020.DSH.IC834.D140115.T002006405.P.IN','00:20:06','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:06',1,'2014-01-15 00:20:07'),(1299,'Inbound',NULL,'Completed','452721020.999.D131228.T1114125.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:13',NULL,'2014-01-05 17:00:16'),(2066,'OutBound','1007','Completed','452721020.DSH.IC834.D140114.T231709641.P.IN','23:17:09','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:09',1,'2014-01-14 23:17:10'),(2612,'Inbound',NULL,'Completed','452721020.999.D140115.T0049429.P.OUT','23:32:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:57:08',1,'2014-01-23 03:57:09'),(2731,'Inbound',NULL,'Completed','452721020.999.D140115.T0222451.P.OUT','00:03:00','2014-01-15','','CMSFFM','452721020',0,'2014-01-23 09:01:27',NULL,'2014-01-23 09:01:28'),(2811,'Inbound',NULL,'Completed','452721020.I834.D140219.T1845188.P.OUT','18:35:00','2014-02-19','','CMSFFM','452721020',0,'2014-02-20 04:30:11',0,'2014-02-20 04:56:57'),(467,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.071500804.P.IN','07:15:00','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 12:15:00',NULL,NULL),(1557,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113101.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:48',NULL,'2014-01-13 03:03:49'),(19,'Inbound',NULL,'Completed','452721020.I834.D131224.T1910500.P.OUT','18:40:00','2013-12-24','','CMSFFM','452721020',0,'2013-12-25 18:45:02',NULL,'2013-12-25 18:59:26'),(278,'OutBound','2614','Completed','452721020.DSH.IC834.D131227.T153112543.P.IN','15:31:12','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:31:12',1,'2013-12-27 20:31:13'),(566,'OutBound','5011','Completed','452721020.DSH.IC834.D140102.T114108450.P.IN','11:41:08','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 16:41:08',1,'2014-01-02 16:41:09'),(1493,'Inbound',NULL,'Completed','452721020.999.D131228.T1114112.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:02:25',NULL,'2014-01-13 03:02:26'),(2452,'OutBound','5783','Completed','452721020.DSH.IC834.D140115.T090417839.P.IN','09:04:17','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:18',1,'2014-01-15 09:04:18'),(2456,'OutBound','5882','Completed','452721020.DSH.IC834.D140115.T090420827.P.IN','09:04:20','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:04:20',1,'2014-01-15 09:04:21'),(1347,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113596.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:02:27',NULL,'2014-01-05 17:02:30'),(1636,'OutBound','152','Completed','452721020.DSH.IC834.D140114.T230554792.P.IN','23:05:54','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:54',1,'2014-01-14 23:05:55'),(2033,'OutBound','4399','Completed','452721020.DSH.IC834.D140114.T231628455.P.IN','23:16:28','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:28',1,'2014-01-14 23:16:29'),(2419,'OutBound','3640','Completed','452721020.DSH.IC834.D140115.T090352866.P.IN','09:03:52','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:52',1,'2014-01-15 09:03:53'),(33,'Inbound',NULL,'Completed','452721020.I834.D131101.T1807534.P.OUT','18:03:00','2013-11-01','','CMSFFM','452721020',0,'2013-12-25 20:45:01',NULL,'2013-12-25 20:45:55'),(60,'Inbound',NULL,'Completed','452721020.I834.D131112.T1811375.P.OUT','18:03:00','2013-11-12','','CMSFFM','452721020',0,'2013-12-26 01:00:01',NULL,'2013-12-26 01:00:39'),(251,'OutBound','51','Completed','452721020.DSH.IC834.D131227.T152032560.P.IN','15:20:32','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:20:32',1,'2013-12-27 20:20:32'),(502,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105221665.P.IN','10:52:21','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:52:22',NULL,NULL),(1306,'Inbound',NULL,'Completed','452721020.999.D131228.T1113083.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:00:33',NULL,'2014-01-05 17:00:35'),(1449,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112584.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:26:52',NULL,'2014-01-05 17:26:55'),(1824,'OutBound','1782','Completed','452721020.DSH.IC834.D140114.T230951701.P.IN','23:09:51','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:51',1,'2014-01-14 23:09:52'),(1967,'OutBound','158','Completed','452721020.DSH.IC834.D140114.T231459599.P.IN','23:14:59','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:14:59',1,'2014-01-14 23:15:00'),(2103,'OutBound','2432','Completed','452721020.DSH.IC834.D140114.T231758460.P.IN','23:17:58','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:17:58',1,'2014-01-14 23:17:59'),(2119,'OutBound','2070','Completed','452721020.DSH.IC834.D140115.T001705895.P.IN','00:17:05','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:06',1,'2014-01-15 00:17:06'),(2402,'OutBound','1487','Completed','452721020.DSH.IC834.D140115.T090340774.P.IN','09:03:40','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:40',1,'2014-01-15 09:03:40'),(2600,'Inbound',NULL,'Completed','452721020.999.D140115.T0212099.P.OUT','00:54:00','2014-01-15','','CMSFFM','452721020',1,'2014-01-23 03:50:49',1,'2014-01-23 03:50:50'),(1620,'OutBound','2441','Completed','452721020.DSH.IC834.D140114.T230537459.P.IN','23:05:37','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:05:37',1,'2014-01-14 23:05:38'),(1672,'OutBound','6452','Completed','452721020.DSH.IC834.D140114.T230639661.P.IN','23:06:39','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:39',1,'2014-01-14 23:06:40'),(2284,'OutBound','669','Completed','452721020.DSH.IC834.D140115.T002034300.P.IN','00:20:34','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:34',1,'2014-01-15 00:20:35'),(2850,'Inbound',NULL,'Completed','452721020.I834.D140307.T1853252.P.OUT','18:46:00','2014-03-07','','CMSFFM','452721020',0,'2014-03-07 21:30:00',0,'2014-03-07 21:32:31'),(170,'OutBound','1731','Completed','452721020.DSH.IC834.D131227.T144443307.P.IN','14:44:43','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:44:43',1,'2013-12-27 19:44:44'),(196,'OutBound','355','Completed','452721020.DSH.IC834.D131227.T145812433.P.IN','14:58:12','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 19:58:12',1,'2013-12-27 19:58:13'),(512,'OutBound',NULL,'InProgress','452721020.DSH.IC834.D140102.T.105559837.P.IN','10:55:59','2014-01-02','0','452721020','CMSFFM',1,'2014-01-02 15:56:00',NULL,NULL),(2123,'OutBound','1981','Completed','452721020.DSH.IC834.D140115.T001710497.P.IN','00:17:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:17:10',1,'2014-01-15 00:17:11'),(2218,'OutBound','3653','Completed','452721020.DSH.IC834.D140115.T001910532.P.IN','00:19:10','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:19:10',1,'2014-01-15 00:19:11'),(325,'OutBound','1745','Completed','452721020.DSH.IC834.D131227.T154610167.P.IN','15:46:10','2013-12-27','0','452721020','CMSFFM',1,'2013-12-27 20:46:10',1,'2013-12-27 20:46:10'),(1223,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112453.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:55:07',NULL,'2014-01-05 16:55:09'),(1460,'Inbound',NULL,'Completed','452721020.999.D131228.T1114104.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:27:23',NULL,'2014-01-05 17:27:25'),(1553,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113528.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:45',NULL,'2014-01-13 03:03:46'),(2786,'Inbound',NULL,'Completed','452721020.I834.D140208.T1818344.P.OUT','18:12:00','2014-02-08','','CMSFFM','452721020',0,'2014-02-08 19:00:03',NULL,'2014-02-08 19:01:03'),(1145,'Inbound',NULL,'Completed','452721020.999.D131228.T0502297.P.OUT','04:55:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:51:30',NULL,'2014-01-05 16:51:32'),(1365,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113077.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:22:58',NULL,'2014-01-05 17:23:01'),(1521,'Inbound',NULL,'Completed','i452721020.999.D131228.T1113502.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-13 03:03:12',NULL,'2014-01-13 03:03:13'),(1989,'OutBound','7688','Completed','452721020.DSH.IC834.D140114.T231525551.P.IN','23:15:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:15:25',1,'2014-01-14 23:15:26'),(2035,'OutBound','2627','Completed','452721020.DSH.IC834.D140114.T231631858.P.IN','23:16:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:16:31',1,'2014-01-14 23:16:32'),(2269,'OutBound','5813','Completed','452721020.DSH.IC834.D140115.T002016173.P.IN','00:20:16','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:20:16',1,'2014-01-15 00:20:17'),(2527,'OutBound','11859','Completed','452721020.DSH.IC834.D140115.T222149547.P.IN','22:21:49','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 22:21:49',1,'2014-01-15 22:21:49'),(2636,'Inbound',NULL,'Completed','452721020.999.D140114.T2345483.P.OUT','23:17:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:17:10',1,'2014-01-23 04:17:11'),(1210,'Inbound',NULL,'Completed','452721020.999.D131228.T1114051.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 16:54:30',NULL,'2014-01-05 16:54:32'),(1727,'OutBound','967','Completed','452721020.DSH.IC834.D140114.T230745724.P.IN','23:07:45','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:07:45',1,'2014-01-14 23:07:46'),(2618,'Inbound',NULL,'Completed','452721020.999.D140114.T2356546.P.OUT','23:18:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 04:06:25',1,'2014-01-23 04:06:25'),(1382,'Inbound',NULL,'Completed','i452721020.999.D131228.T1112570.P.OUT','11:05:00','2013-12-28','','CMSFFM','452721020',0,'2014-01-05 17:23:46',NULL,'2014-01-05 17:23:48'),(1665,'OutBound','4846','Completed','452721020.DSH.IC834.D140114.T230631618.P.IN','23:06:31','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:06:31',1,'2014-01-14 23:06:32'),(1802,'OutBound','1818','Completed','452721020.DSH.IC834.D140114.T230925689.P.IN','23:09:25','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:09:25',1,'2014-01-14 23:09:26'),(1877,'OutBound','3609','Completed','452721020.DSH.IC834.D140114.T231103459.P.IN','23:11:03','2014-01-14','0','452721020','CMSFFM',1,'2014-01-14 23:11:03',1,'2014-01-14 23:11:04'),(2592,'Inbound',NULL,'Completed','452721020.999.D140114.T2329062.P.OUT','23:16:00','2014-01-14','','CMSFFM','452721020',1,'2014-01-23 03:47:40',1,'2014-01-23 03:47:40'),(2781,'Inbound',NULL,'Completed','452721020.I834.D140205.T1847261.P.OUT','18:39:00','2014-02-05','','CMSFFM','452721020',0,'2014-02-05 21:30:03',NULL,'2014-02-05 21:31:20'),(2168,'OutBound','7163','Completed','452721020.DSH.IC834.D140115.T001807634.P.IN','00:18:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 00:18:07',1,'2014-01-15 00:18:08'),(2349,'OutBound','1780','Completed','452721020.DSH.IC834.D140115.T090307671.P.IN','09:03:07','2014-01-15','0','452721020','CMSFFM',1,'2014-01-15 09:03:07',1,'2014-01-15 09:03:08');
/*!40000 ALTER TABLE `EdiProcessing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiTA1`
--

DROP TABLE IF EXISTS `EdiTA1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiTA1` (
  `EdiTA1Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiProcessingId` bigint(64) NOT NULL,
  `Date` date NOT NULL,
  `Time` time DEFAULT NULL,
  `AcknowledgmentCode` enum('A','E','R') NOT NULL,
  `Note` varchar(10) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiTA1Id`),
  KEY `EdiProcessingId` (`EdiProcessingId`)
) ENGINE=innodb AUTO_INCREMENT=23733 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiTA1`
--

LOCK TABLES `EdiTA1` WRITE;
/*!40000 ALTER TABLE `EdiTA1` DISABLE KEYS */;
INSERT INTO `EdiTA1` VALUES (16,251,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:16',NULL,NULL),(5990,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:20',NULL,NULL),(14865,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:09',NULL,NULL),(1798,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:27',NULL,NULL),(14752,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:38',NULL,NULL),(12352,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:43',NULL,NULL),(12622,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:54',NULL,NULL),(21362,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:52',NULL,NULL),(22660,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:27',NULL,NULL),(22967,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:10',NULL,NULL),(17477,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:11',NULL,NULL),(10549,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:40',NULL,NULL),(1029,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:26',NULL,NULL),(20064,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:41',NULL,NULL),(18252,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:04',NULL,NULL),(17762,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:12:30',NULL,NULL),(14513,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:32',NULL,NULL),(12551,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:34',NULL,NULL),(6301,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:03',NULL,NULL),(5509,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:55',NULL,NULL),(3200,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:13',NULL,NULL),(23401,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:50',NULL,NULL),(23482,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:19',NULL,NULL),(14360,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:48',NULL,NULL),(10381,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:36',NULL,NULL),(7216,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:49',NULL,NULL),(2267,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:30',NULL,NULL),(6848,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:15',NULL,NULL),(10450,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:54',NULL,NULL),(22234,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:28',NULL,NULL),(628,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:11',NULL,NULL),(18087,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:24',NULL,NULL),(16469,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:58',NULL,NULL),(23051,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:26',NULL,NULL),(23529,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 13:30:02',NULL,NULL),(12330,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:36',NULL,NULL),(46,267,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:43',NULL,NULL),(297,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:21',NULL,NULL),(10557,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:42',NULL,NULL),(9273,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:17',NULL,NULL),(22195,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:17',NULL,NULL),(8802,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:19',NULL,NULL),(8627,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:32',NULL,NULL),(15891,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:45',NULL,NULL),(22189,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:15',NULL,NULL),(21531,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:55',NULL,NULL),(6476,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:51',NULL,NULL),(6717,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:40',NULL,NULL),(19222,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:03',NULL,NULL),(17066,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:20',NULL,NULL),(18697,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:08',NULL,NULL),(6541,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:32:08',NULL,NULL),(773,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:15',NULL,NULL),(4177,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:14',NULL,NULL),(2075,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:59',NULL,NULL),(12691,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:13',NULL,NULL),(13944,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:26',NULL,NULL),(16081,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:53',NULL,NULL),(17744,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:45',NULL,NULL),(23200,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:54',NULL,NULL),(10861,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:46:00',NULL,NULL),(17719,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:37',NULL,NULL),(9707,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:50',NULL,NULL),(10027,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:57',NULL,NULL),(7711,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:47',NULL,NULL),(5751,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:57',NULL,NULL),(1981,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:35',NULL,NULL),(4243,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:30',NULL,NULL),(3677,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:10',NULL,NULL),(20116,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:56',NULL,NULL),(18409,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:48',NULL,NULL),(20047,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:36',NULL,NULL),(8408,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:46',NULL,NULL),(5015,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:53',NULL,NULL),(3033,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:10',NULL,NULL),(19367,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:44',NULL,NULL),(20206,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:09',NULL,NULL),(15164,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:42',NULL,NULL),(4053,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:46',NULL,NULL),(13608,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:38',NULL,NULL),(6482,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:53',NULL,NULL),(2383,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:59',NULL,NULL),(22925,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:01',NULL,NULL),(22692,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:38',NULL,NULL),(19351,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:39',NULL,NULL),(13248,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:46',NULL,NULL),(10791,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:42',NULL,NULL),(1994,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:38',NULL,NULL),(1593,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:22',NULL,NULL),(23362,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:37',NULL,NULL),(4878,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:14',NULL,NULL),(10082,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:13',NULL,NULL),(22808,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:22',NULL,NULL),(21658,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:06',NULL,NULL),(6813,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:06',NULL,NULL),(20488,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:51',NULL,NULL),(13116,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:11',NULL,NULL),(12959,1869,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:26:30',NULL,NULL),(6115,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:13',NULL,NULL),(18784,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:08',NULL,NULL),(9222,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:03',NULL,NULL),(653,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:19',NULL,NULL),(668,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:24',NULL,NULL),(2719,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:19',NULL,NULL),(20403,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:21',NULL,NULL),(16998,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:57',NULL,NULL),(6092,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:06',NULL,NULL),(13122,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:13',NULL,NULL),(16985,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:53',NULL,NULL),(12160,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:47',NULL,NULL),(11728,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:36',NULL,NULL),(2688,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:07',NULL,NULL),(11429,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:22',NULL,NULL),(9205,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:58',NULL,NULL),(9970,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:58',NULL,NULL),(10464,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:18',NULL,NULL),(16623,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:56',NULL,NULL),(13396,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:06',NULL,NULL),(13615,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:39',NULL,NULL),(19319,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:31',NULL,NULL),(23035,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:23',NULL,NULL),(23156,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(7617,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:23',NULL,NULL),(641,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:15',NULL,NULL),(5134,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:11',NULL,NULL),(1610,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:28',NULL,NULL),(5744,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:54',NULL,NULL),(13560,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:31',NULL,NULL),(16742,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:41',NULL,NULL),(17764,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:31',NULL,NULL),(17982,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:47',NULL,NULL),(18160,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:48',NULL,NULL),(18263,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:07',NULL,NULL),(20648,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:50',NULL,NULL),(21100,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:02',NULL,NULL),(483,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:24',NULL,NULL),(12606,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:49',NULL,NULL),(12131,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:39',NULL,NULL),(11977,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:58',NULL,NULL),(10545,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:39',NULL,NULL),(8102,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:22',NULL,NULL),(3312,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:45',NULL,NULL),(3529,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:44',NULL,NULL),(13459,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:16',NULL,NULL),(15158,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:40',NULL,NULL),(16733,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:38',NULL,NULL),(18216,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:08',NULL,NULL),(6477,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:51',NULL,NULL),(527,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:39',NULL,NULL),(5153,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:16',NULL,NULL),(11969,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:54',NULL,NULL),(11881,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:15',NULL,NULL),(11007,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:19',NULL,NULL),(19896,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:53',NULL,NULL),(20583,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:26',NULL,NULL),(21021,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:40',NULL,NULL),(22537,1857,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:32:01',NULL,NULL),(12737,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:27',NULL,NULL),(954,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:05',NULL,NULL),(11341,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:55',NULL,NULL),(10072,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:10',NULL,NULL),(6225,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:43',NULL,NULL),(6118,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:30:13',NULL,NULL),(9798,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:14',NULL,NULL),(3439,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:19',NULL,NULL),(17839,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:58',NULL,NULL),(17937,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:32',NULL,NULL),(19091,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:34',NULL,NULL),(19483,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:16',NULL,NULL),(20962,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:24',NULL,NULL),(22571,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:13',NULL,NULL),(226,309,'2013-12-27','15:39:00','A','000',0,'2014-01-13 03:05:16',NULL,NULL),(5983,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:17',NULL,NULL),(5906,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:50',NULL,NULL),(8850,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:32',NULL,NULL),(7406,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:43',NULL,NULL),(12052,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:18',NULL,NULL),(10445,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:53',NULL,NULL),(7632,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:27',NULL,NULL),(5020,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:55',NULL,NULL),(7538,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:20',NULL,NULL),(2280,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:33',NULL,NULL),(13266,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:51',NULL,NULL),(14395,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:58',NULL,NULL),(17292,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:10',NULL,NULL),(23463,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:13',NULL,NULL),(23554,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 15:30:02',NULL,NULL),(11643,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:14',NULL,NULL),(4486,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:34',NULL,NULL),(2863,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:09',NULL,NULL),(4230,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:27',NULL,NULL),(3569,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:55',NULL,NULL),(8112,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:25',NULL,NULL),(8467,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:32:02',NULL,NULL),(9125,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:37',NULL,NULL),(9298,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:23',NULL,NULL),(9946,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:52',NULL,NULL),(15802,1851,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:04:39',NULL,NULL),(19758,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:17',NULL,NULL),(20949,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:20',NULL,NULL),(23405,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:52',NULL,NULL),(12793,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:42',NULL,NULL),(12703,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:17',NULL,NULL),(3589,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:00',NULL,NULL),(1917,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:56',NULL,NULL),(7775,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:04',NULL,NULL),(11330,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:01:52',NULL,NULL),(9344,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:35',NULL,NULL),(9536,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:05',NULL,NULL),(19703,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:02',NULL,NULL),(21792,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:53',NULL,NULL),(22604,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:24',NULL,NULL),(8877,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:39',NULL,NULL),(9058,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:18',NULL,NULL),(9984,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:46',NULL,NULL),(10133,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:27',NULL,NULL),(10896,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:10',NULL,NULL),(12734,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:26',NULL,NULL),(11434,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:21',NULL,NULL),(17430,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:56',NULL,NULL),(149,213,'2013-12-27','15:07:00','A','000',0,'2014-01-13 03:04:51',NULL,NULL),(7047,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:13',NULL,NULL),(856,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:38',NULL,NULL),(13305,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:01',NULL,NULL),(9331,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:32',NULL,NULL),(7933,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:48',NULL,NULL),(3348,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:55',NULL,NULL),(4104,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:59',NULL,NULL),(14682,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:19',NULL,NULL),(15765,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:26',NULL,NULL),(16565,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:33',NULL,NULL),(17826,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:53',NULL,NULL),(18536,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:25',NULL,NULL),(21864,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:19',NULL,NULL),(11261,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:34',NULL,NULL),(8373,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:37',NULL,NULL),(3697,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:15',NULL,NULL),(15652,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:47',NULL,NULL),(16809,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:09',NULL,NULL),(13341,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:11',NULL,NULL),(473,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:21',NULL,NULL),(7224,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:53',NULL,NULL),(6537,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:07',NULL,NULL),(12100,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:31',NULL,NULL),(2554,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:43',NULL,NULL),(4505,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:38',NULL,NULL),(13783,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:03',NULL,NULL),(15945,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:04',NULL,NULL),(16812,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:10',NULL,NULL),(20038,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:33',NULL,NULL),(20441,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:35',NULL,NULL),(20841,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:51',NULL,NULL),(20871,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:00',NULL,NULL),(22811,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:23',NULL,NULL),(516,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:35',NULL,NULL),(13612,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:38',NULL,NULL),(5702,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:40',NULL,NULL),(22273,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:38',NULL,NULL),(22139,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:02',NULL,NULL),(3886,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:04',NULL,NULL),(4002,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:32',NULL,NULL),(16088,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:56',NULL,NULL),(8834,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:28',NULL,NULL),(7611,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:21',NULL,NULL),(3344,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:54',NULL,NULL),(6864,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:20',NULL,NULL),(13987,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:33',NULL,NULL),(20733,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:21',NULL,NULL),(493,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:27',NULL,NULL),(17847,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:01',NULL,NULL),(13061,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:56',NULL,NULL),(8756,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:01:07',NULL,NULL),(12536,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:30',NULL,NULL),(5309,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:31:01',NULL,NULL),(6010,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:26',NULL,NULL),(21576,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:11',NULL,NULL),(17970,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:43',NULL,NULL),(15409,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:32',NULL,NULL),(17504,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:20',NULL,NULL),(14904,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:20',NULL,NULL),(4975,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:42',NULL,NULL),(9116,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:34',NULL,NULL),(494,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:28',NULL,NULL),(5967,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:11',NULL,NULL),(21103,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:02',NULL,NULL),(17590,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:50',NULL,NULL),(7475,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:02',NULL,NULL),(6896,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:29',NULL,NULL),(7133,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:27',NULL,NULL),(14901,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:20',NULL,NULL),(14086,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:47',NULL,NULL),(23455,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:10',NULL,NULL),(11072,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:41',NULL,NULL),(10534,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:36',NULL,NULL),(21780,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:49',NULL,NULL),(14751,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:38',NULL,NULL),(17720,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:37',NULL,NULL),(16685,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:21',NULL,NULL),(14455,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:16',NULL,NULL),(1212,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:02',NULL,NULL),(12389,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:53',NULL,NULL),(8033,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:04',NULL,NULL),(10533,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:44:36',NULL,NULL),(19127,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:44',NULL,NULL),(14978,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:40',NULL,NULL),(7848,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:25',NULL,NULL),(614,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:07',NULL,NULL),(17894,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:17',NULL,NULL),(21320,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:37',NULL,NULL),(18168,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:52',NULL,NULL),(3141,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:49',NULL,NULL),(9144,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:42',NULL,NULL),(9333,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:32',NULL,NULL),(4509,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:39',NULL,NULL),(7222,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:51',NULL,NULL),(22640,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:20',NULL,NULL),(20069,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:42',NULL,NULL),(8858,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:34',NULL,NULL),(440,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:10',NULL,NULL),(7899,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:39',NULL,NULL),(4666,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:15',NULL,NULL),(4120,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:03',NULL,NULL),(3819,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:47',NULL,NULL),(12692,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:13',NULL,NULL),(18128,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:38',NULL,NULL),(20470,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:45',NULL,NULL),(21506,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:46',NULL,NULL),(21585,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:15',NULL,NULL),(104,343,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:36',NULL,NULL),(3520,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:41',NULL,NULL),(7680,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:39',NULL,NULL),(13342,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:11',NULL,NULL),(13390,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:04',NULL,NULL),(13421,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:10',NULL,NULL),(18027,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:04',NULL,NULL),(19835,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:37',NULL,NULL),(22302,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:45',NULL,NULL),(22345,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:57',NULL,NULL),(7087,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:13',NULL,NULL),(1601,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:25',NULL,NULL),(12142,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:42',NULL,NULL),(4615,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:06',NULL,NULL),(7429,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:49',NULL,NULL),(4564,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:53',NULL,NULL),(16901,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:33',NULL,NULL),(17454,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:03',NULL,NULL),(17540,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:32',NULL,NULL),(17694,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:29',NULL,NULL),(19735,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:11',NULL,NULL),(19897,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:53',NULL,NULL),(20376,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:11',NULL,NULL),(10853,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:58',NULL,NULL),(10666,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:12',NULL,NULL),(10080,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:12',NULL,NULL),(7345,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:26',NULL,NULL),(3624,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:10',NULL,NULL),(4170,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:12',NULL,NULL),(14264,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:15',NULL,NULL),(16878,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:30:27',NULL,NULL),(10514,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:31',NULL,NULL),(4065,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:49',NULL,NULL),(4046,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:45',NULL,NULL),(9884,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:36',NULL,NULL),(8124,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:28',NULL,NULL),(2721,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:20',NULL,NULL),(13833,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:10',NULL,NULL),(14084,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:47',NULL,NULL),(16065,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:47',NULL,NULL),(16480,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:02',NULL,NULL),(17741,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:44',NULL,NULL),(21642,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:36',NULL,NULL),(22319,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:49',NULL,NULL),(23640,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 18:00:02',NULL,NULL),(12452,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:06',NULL,NULL),(11076,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:42',NULL,NULL),(4943,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:33',NULL,NULL),(10362,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:30',NULL,NULL),(3194,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:12',NULL,NULL),(2130,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:13',NULL,NULL),(13883,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:17',NULL,NULL),(14729,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:32',NULL,NULL),(15157,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:40',NULL,NULL),(16326,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:04',NULL,NULL),(17326,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:21',NULL,NULL),(17577,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:45',NULL,NULL),(21222,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:02',NULL,NULL),(22782,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:12',NULL,NULL),(23675,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 23:29:57',NULL,NULL),(12657,1839,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:03',NULL,NULL),(10770,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:37',NULL,NULL),(7045,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:02:12',NULL,NULL),(3317,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:46',NULL,NULL),(3618,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:08',NULL,NULL),(15607,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:33',NULL,NULL),(17301,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:13',NULL,NULL),(19320,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:31',NULL,NULL),(21361,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:52',NULL,NULL),(22237,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:29',NULL,NULL),(54,374,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:51',NULL,NULL),(4176,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:13',NULL,NULL),(6545,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:09',NULL,NULL),(7299,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:14',NULL,NULL),(15364,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:24',NULL,NULL),(16459,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:54',NULL,NULL),(18369,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:38',NULL,NULL),(18599,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:42',NULL,NULL),(18880,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:34',NULL,NULL),(1115,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:48',NULL,NULL),(10143,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:29',NULL,NULL),(1846,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:38',NULL,NULL),(4529,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:45',NULL,NULL),(6895,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:29',NULL,NULL),(17716,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:36',NULL,NULL),(20469,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:45',NULL,NULL),(124,278,'2013-12-27','15:31:00','A','000',0,'2014-01-13 03:04:43',NULL,NULL),(12278,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:20',NULL,NULL),(1410,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:17',NULL,NULL),(9804,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:15',NULL,NULL),(5877,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:40',NULL,NULL),(4747,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:38',NULL,NULL),(9745,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:59',NULL,NULL),(13404,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:08',NULL,NULL),(13906,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:20',NULL,NULL),(14485,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:24',NULL,NULL),(18877,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:33',NULL,NULL),(19022,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:15',NULL,NULL),(4489,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:35',NULL,NULL),(8571,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:18',NULL,NULL),(10570,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:45',NULL,NULL),(10899,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:10',NULL,NULL),(12530,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:28',NULL,NULL),(14271,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:16',NULL,NULL),(14325,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:25',NULL,NULL),(14550,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:42',NULL,NULL),(16948,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:44',NULL,NULL),(19150,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:51',NULL,NULL),(19318,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:30',NULL,NULL),(21174,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:43',NULL,NULL),(7327,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:22',NULL,NULL),(5799,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:13',NULL,NULL),(2848,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:04',NULL,NULL),(11764,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:45',NULL,NULL),(11180,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:10',NULL,NULL),(13687,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:48',NULL,NULL),(13831,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:10',NULL,NULL),(14654,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:12',NULL,NULL),(15370,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:25',NULL,NULL),(16017,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:30',NULL,NULL),(16638,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:02',NULL,NULL),(19032,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:18',NULL,NULL),(21564,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:07',NULL,NULL),(22106,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:45',NULL,NULL),(22228,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:26',NULL,NULL),(23356,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:35',NULL,NULL),(13032,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:48',NULL,NULL),(12505,1839,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:21',NULL,NULL),(11173,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:08',NULL,NULL),(2993,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:55',NULL,NULL),(10019,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:39:55',NULL,NULL),(8889,1867,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:42',NULL,NULL),(8419,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:49',NULL,NULL),(4695,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:24',NULL,NULL),(14765,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:42',NULL,NULL),(14897,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:18',NULL,NULL),(16560,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:31',NULL,NULL),(17072,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:22',NULL,NULL),(17318,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:19',NULL,NULL),(21873,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:22',NULL,NULL),(263,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:10',NULL,NULL),(813,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:27',NULL,NULL),(11367,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:03',NULL,NULL),(1476,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:41',NULL,NULL),(2105,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:06',NULL,NULL),(7934,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:48',NULL,NULL),(3001,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:58',NULL,NULL),(3622,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:09',NULL,NULL),(8591,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:23',NULL,NULL),(20169,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:10',NULL,NULL),(23236,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(10095,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:17',NULL,NULL),(8023,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:13',NULL,NULL),(1487,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:45',NULL,NULL),(9010,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:05',NULL,NULL),(2076,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-23 20:31:59',NULL,NULL),(8178,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:42',NULL,NULL),(15238,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:00',NULL,NULL),(21207,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:55',NULL,NULL),(321,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:30',NULL,NULL),(12087,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:27',NULL,NULL),(7082,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:11',NULL,NULL),(11754,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:43',NULL,NULL),(9742,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:59',NULL,NULL),(6529,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:05',NULL,NULL),(2773,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:38',NULL,NULL),(3114,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:40',NULL,NULL),(4059,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:48',NULL,NULL),(15186,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:01:50',NULL,NULL),(19570,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:41',NULL,NULL),(21467,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:30',NULL,NULL),(22990,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(3821,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:47',NULL,NULL),(7350,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:28',NULL,NULL),(5371,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:17',NULL,NULL),(14521,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:34',NULL,NULL),(16538,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:23',NULL,NULL),(16906,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:34',NULL,NULL),(17823,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:52',NULL,NULL),(20132,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:00',NULL,NULL),(21457,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:27',NULL,NULL),(12461,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:09',NULL,NULL),(1170,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:04',NULL,NULL),(11208,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:20',NULL,NULL),(20039,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:34',NULL,NULL),(6564,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:14',NULL,NULL),(4030,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:39',NULL,NULL),(5521,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:59',NULL,NULL),(6272,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:55',NULL,NULL),(17157,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:50',NULL,NULL),(19779,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:23',NULL,NULL),(18755,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:00',NULL,NULL),(15460,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:42',NULL,NULL),(14680,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:19',NULL,NULL),(7139,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:29',NULL,NULL),(12084,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:27',NULL,NULL),(10269,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:04',NULL,NULL),(17989,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:50',NULL,NULL),(3969,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:24',NULL,NULL),(13919,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:22',NULL,NULL),(13222,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:39',NULL,NULL),(10648,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:05',NULL,NULL),(9254,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:12',NULL,NULL),(7255,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:02',NULL,NULL),(3698,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:16',NULL,NULL),(1768,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:19',NULL,NULL),(7143,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:30:30',NULL,NULL),(16543,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:25',NULL,NULL),(15941,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:03',NULL,NULL),(5019,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:54',NULL,NULL),(3216,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:19',NULL,NULL),(8794,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:17',NULL,NULL),(13532,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:27',NULL,NULL),(6473,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:50',NULL,NULL),(7396,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:40',NULL,NULL),(8286,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:13',NULL,NULL),(19963,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:13',NULL,NULL),(8733,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:01',NULL,NULL),(17018,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:03',NULL,NULL),(7534,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:18',NULL,NULL),(12887,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:14',NULL,NULL),(23042,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(17334,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:24',NULL,NULL),(3949,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:20',NULL,NULL),(2989,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:54',NULL,NULL),(12442,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:04',NULL,NULL),(7442,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:52',NULL,NULL),(1922,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:57',NULL,NULL),(23047,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(15357,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:23',NULL,NULL),(3212,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:17',NULL,NULL),(11797,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:54',NULL,NULL),(13872,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:16',NULL,NULL),(10636,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:02',NULL,NULL),(22380,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:09',NULL,NULL),(12308,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:29',NULL,NULL),(4685,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:21',NULL,NULL),(4668,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:16',NULL,NULL),(178,347,'2013-12-27','16:00:00','A','000',0,'2014-01-13 03:05:00',NULL,NULL),(18120,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:35',NULL,NULL),(16487,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:05',NULL,NULL),(10305,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:14',NULL,NULL),(14117,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:52',NULL,NULL),(15504,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:58',NULL,NULL),(15716,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:09',NULL,NULL),(6142,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:21',NULL,NULL),(5103,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:18',NULL,NULL),(4659,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:13',NULL,NULL),(22599,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:32:22',NULL,NULL),(11616,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:15:07',NULL,NULL),(22412,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:19',NULL,NULL),(13155,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:22',NULL,NULL),(14602,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:56',NULL,NULL),(9056,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:18',NULL,NULL),(8649,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:38',NULL,NULL),(2029,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:48',NULL,NULL),(7432,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:31:50',NULL,NULL),(14519,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:33',NULL,NULL),(6130,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:17',NULL,NULL),(20389,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:16',NULL,NULL),(15741,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:17',NULL,NULL),(603,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:03',NULL,NULL),(14907,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:21',NULL,NULL),(23689,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 19:30:02',NULL,NULL),(22801,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:19',NULL,NULL),(17623,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:02',NULL,NULL),(9214,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:01',NULL,NULL),(6122,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:14',NULL,NULL),(17413,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:50',NULL,NULL),(4119,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:03',NULL,NULL),(17006,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:59',NULL,NULL),(8813,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:22',NULL,NULL),(6742,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:46',NULL,NULL),(7990,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:03',NULL,NULL),(17677,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:23',NULL,NULL),(17609,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:57',NULL,NULL),(6062,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:45',NULL,NULL),(16737,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:39',NULL,NULL),(1871,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:44',NULL,NULL),(14394,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:49:58',NULL,NULL),(20839,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:50',NULL,NULL),(20264,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:30',NULL,NULL),(2086,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:02',NULL,NULL),(3353,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:56',NULL,NULL),(12571,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:39',NULL,NULL),(18994,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:08',NULL,NULL),(11786,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:51',NULL,NULL),(8420,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:49',NULL,NULL),(7109,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:20',NULL,NULL),(1268,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:23',NULL,NULL),(2941,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:37',NULL,NULL),(1780,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:22',NULL,NULL),(12830,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:54',NULL,NULL),(13080,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:01',NULL,NULL),(14412,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:04',NULL,NULL),(17486,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:14',NULL,NULL),(17827,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:53',NULL,NULL),(20784,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:35',NULL,NULL),(22440,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:29',NULL,NULL),(762,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:12',NULL,NULL),(5453,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:39',NULL,NULL),(11350,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:59',NULL,NULL),(9832,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:23',NULL,NULL),(8200,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:48',NULL,NULL),(17048,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:13',NULL,NULL),(17270,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:02',NULL,NULL),(18623,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:48',NULL,NULL),(19106,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:38',NULL,NULL),(20343,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:58',NULL,NULL),(10627,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:00',NULL,NULL),(7740,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:55',NULL,NULL),(2669,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:14',NULL,NULL),(15869,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:37',NULL,NULL),(17156,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:49',NULL,NULL),(21148,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:16',NULL,NULL),(21680,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:13',NULL,NULL),(22552,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:06',NULL,NULL),(12655,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:03',NULL,NULL),(5154,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:30:16',NULL,NULL),(4260,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:35',NULL,NULL),(7229,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:55',NULL,NULL),(9026,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:09',NULL,NULL),(15603,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:31',NULL,NULL),(17501,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:01:19',NULL,NULL),(19030,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:17',NULL,NULL),(21159,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:19',NULL,NULL),(337,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:35',NULL,NULL),(987,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:14',NULL,NULL),(11004,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:18',NULL,NULL),(7071,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:08',NULL,NULL),(6047,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:40',NULL,NULL),(14512,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:32',NULL,NULL),(14704,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:25',NULL,NULL),(15867,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:37',NULL,NULL),(16149,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:19',NULL,NULL),(20601,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:32',NULL,NULL),(21476,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:34',NULL,NULL),(22813,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:23',NULL,NULL),(23703,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 15:30:01',NULL,NULL),(7199,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:44',NULL,NULL),(5887,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:43',NULL,NULL),(11706,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:30',NULL,NULL),(4147,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:06',NULL,NULL),(3111,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:39',NULL,NULL),(10308,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:15',NULL,NULL),(8153,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:35',NULL,NULL),(9334,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:33',NULL,NULL),(10008,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:52',NULL,NULL),(15310,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:14',NULL,NULL),(16328,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:04',NULL,NULL),(19288,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:22',NULL,NULL),(20750,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:25',NULL,NULL),(8179,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:43',NULL,NULL),(13508,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:23',NULL,NULL),(16395,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:30',NULL,NULL),(19713,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:05',NULL,NULL),(19762,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:18',NULL,NULL),(19848,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:41',NULL,NULL),(21295,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:28',NULL,NULL),(21978,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:59',NULL,NULL),(23122,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:39',NULL,NULL),(23702,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 13:30:01',NULL,NULL),(13027,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:47',NULL,NULL),(6858,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:18',NULL,NULL),(6790,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:00',NULL,NULL),(2005,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:41',NULL,NULL),(6305,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:04',NULL,NULL),(9917,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:45',NULL,NULL),(8533,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:08',NULL,NULL),(8509,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:13',NULL,NULL),(7927,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:46',NULL,NULL),(8077,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:16',NULL,NULL),(14457,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:16',NULL,NULL),(15325,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:16',NULL,NULL),(16620,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:54',NULL,NULL),(17343,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:27',NULL,NULL),(17549,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:35',NULL,NULL),(12715,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:21',NULL,NULL),(11775,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:48',NULL,NULL),(2532,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:38',NULL,NULL),(10682,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:16',NULL,NULL),(16874,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:26',NULL,NULL),(19243,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:09',NULL,NULL),(22066,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:30',NULL,NULL),(6200,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:37',NULL,NULL),(838,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:34',NULL,NULL),(1776,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:21',NULL,NULL),(7919,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:44',NULL,NULL),(5241,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:40',NULL,NULL),(13849,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:12',NULL,NULL),(18197,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:01',NULL,NULL),(21798,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:56',NULL,NULL),(22881,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:46',NULL,NULL),(23589,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 22:30:02',NULL,NULL),(10744,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:31',NULL,NULL),(6893,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:28',NULL,NULL),(1003,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:18',NULL,NULL),(9777,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:08',NULL,NULL),(2584,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:51',NULL,NULL),(5653,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:23',NULL,NULL),(5562,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:11',NULL,NULL),(6672,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:29',NULL,NULL),(6015,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:28',NULL,NULL),(14383,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:55',NULL,NULL),(17107,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:33',NULL,NULL),(19504,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:22',NULL,NULL),(20799,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:39',NULL,NULL),(21337,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:43',NULL,NULL),(21512,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:48',NULL,NULL),(22233,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:28',NULL,NULL),(22265,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:36',NULL,NULL),(22405,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:17',NULL,NULL),(7801,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:11',NULL,NULL),(9971,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:59',NULL,NULL),(9920,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:45',NULL,NULL),(979,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:12',NULL,NULL),(5952,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:06',NULL,NULL),(5763,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:01',NULL,NULL),(2766,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:35',NULL,NULL),(5244,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:41',NULL,NULL),(4905,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:21',NULL,NULL),(4464,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:28',NULL,NULL),(13657,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:44',NULL,NULL),(15700,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:04',NULL,NULL),(19508,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:24',NULL,NULL),(51,260,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:48',NULL,NULL),(11731,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:37',NULL,NULL),(9395,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:49',NULL,NULL),(724,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:44',NULL,NULL),(7803,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:12',NULL,NULL),(2256,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:27',NULL,NULL),(8689,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:49',NULL,NULL),(4834,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:02',NULL,NULL),(4312,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:48',NULL,NULL),(14123,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:53',NULL,NULL),(14552,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:42',NULL,NULL),(16241,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:51',NULL,NULL),(16702,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:27',NULL,NULL),(18939,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:51',NULL,NULL),(20181,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:13',NULL,NULL),(3108,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:38',NULL,NULL),(19601,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:49',NULL,NULL),(18324,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:25',NULL,NULL),(21689,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:16',NULL,NULL),(20350,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:01',NULL,NULL),(17821,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:51',NULL,NULL),(10926,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:17',NULL,NULL),(4832,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:01',NULL,NULL),(15707,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:06',NULL,NULL),(15690,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:01',NULL,NULL),(22976,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:12',NULL,NULL),(870,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:42',NULL,NULL),(16672,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:16',NULL,NULL),(15060,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:08',NULL,NULL),(23468,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:15',NULL,NULL),(23672,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 17:29:58',NULL,NULL),(11601,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:03',NULL,NULL),(22984,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(11523,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:44',NULL,NULL),(2624,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:01',NULL,NULL),(17205,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:06',NULL,NULL),(2329,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:46',NULL,NULL),(14335,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:27',NULL,NULL),(15668,1830,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:53',NULL,NULL),(23610,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 15:30:02',NULL,NULL),(11745,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:40',NULL,NULL),(9999,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:50',NULL,NULL),(678,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:29',NULL,NULL),(910,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:53',NULL,NULL),(21677,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:12',NULL,NULL),(9350,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:37',NULL,NULL),(20653,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:51',NULL,NULL),(19702,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:02',NULL,NULL),(21598,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:19',NULL,NULL),(533,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:40',NULL,NULL),(2196,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:05',NULL,NULL),(11682,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:24',NULL,NULL),(10999,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:16',NULL,NULL),(1714,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:06',NULL,NULL),(1825,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:33',NULL,NULL),(9032,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:11',NULL,NULL),(15337,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:19',NULL,NULL),(16714,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:31',NULL,NULL),(21120,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:07',NULL,NULL),(21261,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:16',NULL,NULL),(22684,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:35',NULL,NULL),(11424,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:20',NULL,NULL),(9896,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:39',NULL,NULL),(3231,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:23',NULL,NULL),(3427,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:16',NULL,NULL),(7888,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:37',NULL,NULL),(5340,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:09',NULL,NULL),(5004,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:50',NULL,NULL),(11423,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:20',NULL,NULL),(10242,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:56',NULL,NULL),(6173,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:29',NULL,NULL),(6156,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:25',NULL,NULL),(9326,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:30',NULL,NULL),(8522,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:05',NULL,NULL),(3736,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:25',NULL,NULL),(2951,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:40',NULL,NULL),(3258,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:30',NULL,NULL),(16049,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:41',NULL,NULL),(16094,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:58',NULL,NULL),(17372,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:37',NULL,NULL),(17824,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:52',NULL,NULL),(18257,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:06',NULL,NULL),(19692,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:16',NULL,NULL),(6346,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:15',NULL,NULL),(6041,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:38',NULL,NULL),(2518,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:34',NULL,NULL),(4605,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:32:03',NULL,NULL),(13598,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:36',NULL,NULL),(13740,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:57',NULL,NULL),(19831,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:36',NULL,NULL),(20237,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:20',NULL,NULL),(22455,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:34',NULL,NULL),(23667,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 23:29:59',NULL,NULL),(10856,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:59',NULL,NULL),(3843,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:53',NULL,NULL),(2161,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:21',NULL,NULL),(9180,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:52',NULL,NULL),(12632,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:56',NULL,NULL),(13320,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:05',NULL,NULL),(14326,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:25',NULL,NULL),(17015,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:02',NULL,NULL),(17591,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:01:50',NULL,NULL),(18218,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:15:08',NULL,NULL),(20595,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:30',NULL,NULL),(20976,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:28',NULL,NULL),(22582,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:16',NULL,NULL),(11238,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:28',NULL,NULL),(5167,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:20',NULL,NULL),(10197,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:44',NULL,NULL),(2099,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:05',NULL,NULL),(15975,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:15',NULL,NULL),(18945,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:53',NULL,NULL),(19323,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:32',NULL,NULL),(21957,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:52',NULL,NULL),(22578,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:15',NULL,NULL),(23269,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(10256,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:00',NULL,NULL),(5964,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:10',NULL,NULL),(2866,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:11',NULL,NULL),(2778,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:40',NULL,NULL),(2217,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:10',NULL,NULL),(4974,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:42',NULL,NULL),(15708,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:07',NULL,NULL),(16154,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:20',NULL,NULL),(17938,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:32',NULL,NULL),(18518,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:20',NULL,NULL),(20196,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:06',NULL,NULL),(146,231,'2013-12-27','15:13:00','A','000',0,'2014-01-13 03:04:50',NULL,NULL),(12475,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:13',NULL,NULL),(10755,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:33',NULL,NULL),(4873,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:12',NULL,NULL),(8499,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:10',NULL,NULL),(3694,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:15',NULL,NULL),(13046,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:52',NULL,NULL),(15694,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:02',NULL,NULL),(1213,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:02',NULL,NULL),(2250,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:26',NULL,NULL),(6739,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:45',NULL,NULL),(3890,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:05',NULL,NULL),(3401,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:09',NULL,NULL),(13867,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:15',NULL,NULL),(14695,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:23',NULL,NULL),(18177,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:55',NULL,NULL),(19546,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:34',NULL,NULL),(11011,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:20',NULL,NULL),(627,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:11',NULL,NULL),(9317,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:28',NULL,NULL),(8755,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:07',NULL,NULL),(9174,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:50',NULL,NULL),(14144,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:56',NULL,NULL),(14657,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:13',NULL,NULL),(20989,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:32',NULL,NULL),(22161,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:08',NULL,NULL),(11047,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:30',NULL,NULL),(7145,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:30',NULL,NULL),(1044,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:29',NULL,NULL),(7111,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:21',NULL,NULL),(10271,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:05',NULL,NULL),(9685,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:44',NULL,NULL),(3653,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:04',NULL,NULL),(3907,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:09',NULL,NULL),(9216,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:01',NULL,NULL),(7752,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:58',NULL,NULL),(8740,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:03',NULL,NULL),(14419,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:06',NULL,NULL),(17942,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:34',NULL,NULL),(19995,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:22',NULL,NULL),(11823,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:00',NULL,NULL),(6589,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:07',NULL,NULL),(6411,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:33',NULL,NULL),(14124,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:53',NULL,NULL),(17679,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:23',NULL,NULL),(19065,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:27',NULL,NULL),(20652,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:51',NULL,NULL),(21160,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:19',NULL,NULL),(22146,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:04',NULL,NULL),(22213,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:22',NULL,NULL),(23278,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-24 11:01:08',NULL,NULL),(10833,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:53',NULL,NULL),(2110,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:08',NULL,NULL),(1129,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:52',NULL,NULL),(1519,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:56',NULL,NULL),(15089,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:17',NULL,NULL),(16484,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:04',NULL,NULL),(16666,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:14',NULL,NULL),(21589,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:16',NULL,NULL),(22008,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:10',NULL,NULL),(23015,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(13099,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:06',NULL,NULL),(12732,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:25',NULL,NULL),(9590,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:19',NULL,NULL),(1680,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:54',NULL,NULL),(900,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:50',NULL,NULL),(1769,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:19',NULL,NULL),(1069,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:36',NULL,NULL),(14000,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:35',NULL,NULL),(15420,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:34',NULL,NULL),(15966,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:12',NULL,NULL),(16004,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:25',NULL,NULL),(16084,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:54',NULL,NULL),(16290,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:10',NULL,NULL),(16816,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:11',NULL,NULL),(17543,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:33',NULL,NULL),(19770,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:20',NULL,NULL),(19955,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:09',NULL,NULL),(20178,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:32:12',NULL,NULL),(12083,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:26',NULL,NULL),(11930,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:43',NULL,NULL),(7524,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:32:15',NULL,NULL),(10891,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:46:08',NULL,NULL),(15182,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:49',NULL,NULL),(17283,1859,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:07',NULL,NULL),(17581,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:46',NULL,NULL),(19872,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:47',NULL,NULL),(20828,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:47',NULL,NULL),(23523,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-29 17:30:02',NULL,NULL),(12762,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:33',NULL,NULL),(6511,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:32:00',NULL,NULL),(5454,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:40',NULL,NULL),(2502,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:30',NULL,NULL),(5060,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:06',NULL,NULL),(11471,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:31',NULL,NULL),(3014,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:03',NULL,NULL),(17798,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:43',NULL,NULL),(18384,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:42',NULL,NULL),(20611,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:36',NULL,NULL),(21652,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:03',NULL,NULL),(22392,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:13',NULL,NULL),(9085,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:26',NULL,NULL),(3038,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:14',NULL,NULL),(13415,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:10',NULL,NULL),(3938,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:17',NULL,NULL),(8116,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:26',NULL,NULL),(8942,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:57',NULL,NULL),(10749,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:32',NULL,NULL),(11478,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:32',NULL,NULL),(14776,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:45',NULL,NULL),(15830,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:23',NULL,NULL),(18159,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:48',NULL,NULL),(19564,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:39',NULL,NULL),(19685,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:14',NULL,NULL),(11069,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:39',NULL,NULL),(5879,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:41',NULL,NULL),(5527,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:00',NULL,NULL),(1797,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:26',NULL,NULL),(13786,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:04',NULL,NULL),(16554,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:29',NULL,NULL),(22254,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:33',NULL,NULL),(269,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:12',NULL,NULL),(12955,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:29',NULL,NULL),(579,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:55',NULL,NULL),(11795,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:53',NULL,NULL),(11580,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:58',NULL,NULL),(5582,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:17',NULL,NULL),(2964,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:01:46',NULL,NULL),(9644,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:34',NULL,NULL),(3416,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:31:13',NULL,NULL),(4026,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:38',NULL,NULL),(4298,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:44',NULL,NULL),(14841,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:03',NULL,NULL),(16692,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:23',NULL,NULL),(22257,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:34',NULL,NULL),(12866,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:24:07',NULL,NULL),(598,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:01',NULL,NULL),(776,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:16',NULL,NULL),(7536,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:18',NULL,NULL),(7437,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:51',NULL,NULL),(2013,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:43',NULL,NULL),(5536,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:03',NULL,NULL),(5125,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:08',NULL,NULL),(12777,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:37',NULL,NULL),(21739,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:35',NULL,NULL),(16561,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:31',NULL,NULL),(8445,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:56',NULL,NULL),(5344,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:10',NULL,NULL),(3076,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:27',NULL,NULL),(152,228,'2013-12-27','15:12:00','A','000',0,'2014-01-13 03:04:52',NULL,NULL),(6762,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:51',NULL,NULL),(21566,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:07',NULL,NULL),(5720,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:46',NULL,NULL),(14387,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:56',NULL,NULL),(14355,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:47',NULL,NULL),(4546,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:49',NULL,NULL),(12081,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:26',NULL,NULL),(21371,1863,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:41:55',NULL,NULL),(11334,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:53',NULL,NULL),(16895,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:31',NULL,NULL),(9322,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:29',NULL,NULL),(13679,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:47',NULL,NULL),(21732,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:32',NULL,NULL),(21694,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:18',NULL,NULL),(1207,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:14',NULL,NULL),(18698,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:08',NULL,NULL),(12378,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:50',NULL,NULL),(17927,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:29',NULL,NULL),(22132,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:54',NULL,NULL),(22050,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:25',NULL,NULL),(21701,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:21',NULL,NULL),(18693,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:07',NULL,NULL),(8570,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:18',NULL,NULL),(15619,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:36',NULL,NULL),(11569,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:55',NULL,NULL),(23146,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(22547,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:04',NULL,NULL),(19917,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:59',NULL,NULL),(6025,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:32',NULL,NULL),(2049,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:53',NULL,NULL),(19020,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:15',NULL,NULL),(18207,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:15:04',NULL,NULL),(18013,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:59',NULL,NULL),(14014,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:37',NULL,NULL),(14354,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:46',NULL,NULL),(6442,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:42',NULL,NULL),(20899,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:07',NULL,NULL),(20276,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:34',NULL,NULL),(18519,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:20',NULL,NULL),(2973,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:49',NULL,NULL),(15363,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:02:24',NULL,NULL),(14939,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:29',NULL,NULL),(5824,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:22',NULL,NULL),(13186,1840,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:29',NULL,NULL),(12640,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:58',NULL,NULL),(10329,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:21',NULL,NULL),(254,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:07',NULL,NULL),(9302,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:24',NULL,NULL),(5560,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:11',NULL,NULL),(3871,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:00',NULL,NULL),(4753,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:40',NULL,NULL),(19517,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:26',NULL,NULL),(19865,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:45',NULL,NULL),(12244,1833,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:20:11',NULL,NULL),(6633,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:19',NULL,NULL),(10949,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:02',NULL,NULL),(9391,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:48',NULL,NULL),(6535,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:07',NULL,NULL),(3584,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:59',NULL,NULL),(7890,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:37',NULL,NULL),(8749,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:05',NULL,NULL),(12695,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:14',NULL,NULL),(13858,1824,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:14',NULL,NULL),(21767,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:45',NULL,NULL),(10506,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:29',NULL,NULL),(6201,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:37',NULL,NULL),(5771,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:04',NULL,NULL),(15605,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:32',NULL,NULL),(16285,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:08',NULL,NULL),(16436,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:45',NULL,NULL),(18521,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:20',NULL,NULL),(19236,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:07',NULL,NULL),(19464,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:11',NULL,NULL),(21140,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:13',NULL,NULL),(772,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:15',NULL,NULL),(1011,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:20',NULL,NULL),(12277,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:19',NULL,NULL),(9245,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:09',NULL,NULL),(8230,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:56',NULL,NULL),(15020,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:55',NULL,NULL),(19911,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:57',NULL,NULL),(22673,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:31',NULL,NULL),(22890,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:49',NULL,NULL),(23652,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 01:30:12',NULL,NULL),(12482,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:15',NULL,NULL),(4851,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:06',NULL,NULL),(9787,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:10',NULL,NULL),(9491,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:35:54',NULL,NULL),(7390,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:39',NULL,NULL),(12811,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:47',NULL,NULL),(15005,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:50',NULL,NULL),(15585,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:25',NULL,NULL),(15868,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:37',NULL,NULL),(16159,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:22',NULL,NULL),(21814,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:01',NULL,NULL),(551,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:46',NULL,NULL),(684,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:31',NULL,NULL),(1119,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:49',NULL,NULL),(11215,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:21',NULL,NULL),(9559,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:11',NULL,NULL),(6489,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:54',NULL,NULL),(14009,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:36',NULL,NULL),(17666,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:18',NULL,NULL),(17759,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:29',NULL,NULL),(23443,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:05',NULL,NULL),(23535,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 01:30:02',NULL,NULL),(12061,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:21',NULL,NULL),(10927,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:17',NULL,NULL),(10384,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:36',NULL,NULL),(9975,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:43',NULL,NULL),(2552,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:43',NULL,NULL),(7189,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:42',NULL,NULL),(7691,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:42',NULL,NULL),(9576,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:36:15',NULL,NULL),(9172,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:50',NULL,NULL),(19117,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:41',NULL,NULL),(20664,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:55',NULL,NULL),(2426,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:11',NULL,NULL),(8914,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:49',NULL,NULL),(5046,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:02',NULL,NULL),(3917,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:12',NULL,NULL),(13333,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:09',NULL,NULL),(13436,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:13',NULL,NULL),(20160,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:07',NULL,NULL),(20724,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:18',NULL,NULL),(23394,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:48',NULL,NULL),(23496,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:24',NULL,NULL),(610,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:05',NULL,NULL),(10258,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:01',NULL,NULL),(5831,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:24',NULL,NULL),(9426,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:57',NULL,NULL),(9241,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:08',NULL,NULL),(3119,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:42',NULL,NULL),(7885,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:36',NULL,NULL),(15512,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:01',NULL,NULL),(16240,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:51',NULL,NULL),(17095,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:29',NULL,NULL),(19916,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:58',NULL,NULL),(20280,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:36',NULL,NULL),(6351,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:16',NULL,NULL),(5801,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:14',NULL,NULL),(10904,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:12',NULL,NULL),(2126,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:12',NULL,NULL),(8145,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:33',NULL,NULL),(4482,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:33',NULL,NULL),(8025,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:02',NULL,NULL),(18743,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:35:56',NULL,NULL),(2503,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:31',NULL,NULL),(6555,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:32:12',NULL,NULL),(5385,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:21',NULL,NULL),(1374,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:04',NULL,NULL),(14010,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:36',NULL,NULL),(17296,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:11',NULL,NULL),(19392,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:00:52',NULL,NULL),(22222,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:25',NULL,NULL),(22583,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:16',NULL,NULL),(22899,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:52',NULL,NULL),(1504,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:50',NULL,NULL),(11447,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:25',NULL,NULL),(7245,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:59',NULL,NULL),(7009,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:03',NULL,NULL),(5121,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:06',NULL,NULL),(18684,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:04',NULL,NULL),(20960,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:23',NULL,NULL),(21959,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:53',NULL,NULL),(9694,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:46',NULL,NULL),(1409,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:16',NULL,NULL),(3973,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:25',NULL,NULL),(4136,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:03',NULL,NULL),(6697,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:35',NULL,NULL),(5710,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:42',NULL,NULL),(16918,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:30:37',NULL,NULL),(17771,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:33',NULL,NULL),(19224,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:04',NULL,NULL),(19852,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:42',NULL,NULL),(20269,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:32',NULL,NULL),(22367,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:05',NULL,NULL),(10266,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:03',NULL,NULL),(12141,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:42',NULL,NULL),(12108,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:33',NULL,NULL),(3475,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:29',NULL,NULL),(4741,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:36',NULL,NULL),(9373,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:43',NULL,NULL),(8618,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:30',NULL,NULL),(15980,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:17',NULL,NULL),(18048,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:11',NULL,NULL),(19928,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:02',NULL,NULL),(22666,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:29',NULL,NULL),(167,226,'2013-12-27','15:11:00','A','000',0,'2014-01-13 03:04:57',NULL,NULL),(822,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:29',NULL,NULL),(9805,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:16',NULL,NULL),(8431,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:52',NULL,NULL),(3963,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:23',NULL,NULL),(6905,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:32',NULL,NULL),(1861,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:42',NULL,NULL),(5407,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:27',NULL,NULL),(4126,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:05',NULL,NULL),(21126,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:09',NULL,NULL),(21829,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:07',NULL,NULL),(1082,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:39',NULL,NULL),(9952,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:54',NULL,NULL),(7364,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:32',NULL,NULL),(9338,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:34',NULL,NULL),(9118,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:35',NULL,NULL),(2924,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:31',NULL,NULL),(13651,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:44',NULL,NULL),(9159,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:46',NULL,NULL),(8120,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:27',NULL,NULL),(4918,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:25',NULL,NULL),(1700,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:03',NULL,NULL),(6491,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:55',NULL,NULL),(4385,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:07',NULL,NULL),(3237,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:25',NULL,NULL),(5558,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:10',NULL,NULL),(5437,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:35',NULL,NULL),(15611,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:34',NULL,NULL),(23371,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:40',NULL,NULL),(12313,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:31',NULL,NULL),(571,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:53',NULL,NULL),(6803,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:04',NULL,NULL),(10619,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:58',NULL,NULL),(9567,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:13',NULL,NULL),(3394,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:07',NULL,NULL),(9280,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:18',NULL,NULL),(4281,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:40',NULL,NULL),(14278,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:16',NULL,NULL),(14304,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:20',NULL,NULL),(15633,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:41',NULL,NULL),(16262,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:00',NULL,NULL),(17108,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:34',NULL,NULL),(19400,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:54',NULL,NULL),(19826,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:35',NULL,NULL),(6689,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:33',NULL,NULL),(3163,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:30:03',NULL,NULL),(12415,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:21:56',NULL,NULL),(15354,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:22',NULL,NULL),(16802,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:07',NULL,NULL),(18163,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:50',NULL,NULL),(10386,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:41:37',NULL,NULL),(10300,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:13',NULL,NULL),(6868,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:21',NULL,NULL),(8607,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:27',NULL,NULL),(1698,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:03:01',NULL,NULL),(1759,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:17',NULL,NULL),(6650,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:23',NULL,NULL),(8241,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:59',NULL,NULL),(16025,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:33',NULL,NULL),(20816,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:44',NULL,NULL),(12642,1850,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:59',NULL,NULL),(6947,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:47',NULL,NULL),(10967,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:08',NULL,NULL),(20804,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:40',NULL,NULL),(16835,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:15',NULL,NULL),(3069,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:24',NULL,NULL),(22332,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:30:53',NULL,NULL),(20138,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:01',NULL,NULL),(4995,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:48',NULL,NULL),(3785,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:38',NULL,NULL),(3118,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:41',NULL,NULL),(13329,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:08',NULL,NULL),(18959,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:58',NULL,NULL),(17818,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:50',NULL,NULL),(812,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:27',NULL,NULL),(2112,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:08',NULL,NULL),(22020,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:14',NULL,NULL),(19448,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:07',NULL,NULL),(16688,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:22',NULL,NULL),(13853,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:13',NULL,NULL),(15010,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:51',NULL,NULL),(14291,1870,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:32:18',NULL,NULL),(22718,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:47',NULL,NULL),(7668,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:36',NULL,NULL),(17702,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:31',NULL,NULL),(1725,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:09',NULL,NULL),(3954,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:21',NULL,NULL),(11525,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:44',NULL,NULL),(16257,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:58',NULL,NULL),(15129,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:31',NULL,NULL),(12567,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:38',NULL,NULL),(10998,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:16',NULL,NULL),(6069,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:48',NULL,NULL),(4427,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:19',NULL,NULL),(5007,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:51',NULL,NULL),(23110,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(19723,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:08',NULL,NULL),(6126,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:16',NULL,NULL),(5570,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:14',NULL,NULL),(5217,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:34',NULL,NULL),(18905,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:41',NULL,NULL),(1224,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:06',NULL,NULL),(3020,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:05',NULL,NULL),(1809,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:29',NULL,NULL),(12371,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:48',NULL,NULL),(22875,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:44',NULL,NULL),(22870,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:43',NULL,NULL),(5306,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:00',NULL,NULL),(3693,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:00:14',NULL,NULL),(20874,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:00',NULL,NULL),(18007,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:56',NULL,NULL),(13145,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:19',NULL,NULL),(16590,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:42',NULL,NULL),(18978,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:03',NULL,NULL),(5030,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:58',NULL,NULL),(3458,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:24',NULL,NULL),(14480,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:23',NULL,NULL),(12624,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:54',NULL,NULL),(6148,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:22',NULL,NULL),(4897,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:19',NULL,NULL),(16024,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:32',NULL,NULL),(21819,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:03',NULL,NULL),(18705,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:10',NULL,NULL),(18248,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:03',NULL,NULL),(6264,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:53',NULL,NULL),(9134,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:40',NULL,NULL),(9809,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:17',NULL,NULL),(4319,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:49',NULL,NULL),(3855,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:56',NULL,NULL),(18170,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:52',NULL,NULL),(16643,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:04',NULL,NULL),(5325,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:05',NULL,NULL),(6518,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:02',NULL,NULL),(12888,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:15',NULL,NULL),(15270,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:06',NULL,NULL),(17528,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:28',NULL,NULL),(9385,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:46',NULL,NULL),(6619,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:15',NULL,NULL),(2174,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:24',NULL,NULL),(17046,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:13',NULL,NULL),(8469,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:02',NULL,NULL),(113,271,'2013-12-27','15:28:00','A','000',0,'2014-01-13 03:04:39',NULL,NULL),(14110,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:51',NULL,NULL),(13497,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:22',NULL,NULL),(7467,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:00',NULL,NULL),(20405,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:21',NULL,NULL),(11140,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:59',NULL,NULL),(2506,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:31',NULL,NULL),(1605,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:26',NULL,NULL),(4568,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:54',NULL,NULL),(19526,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:29',NULL,NULL),(13420,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:10',NULL,NULL),(12712,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:20',NULL,NULL),(2155,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:19',NULL,NULL),(9540,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:06',NULL,NULL),(3099,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:35',NULL,NULL),(7593,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:16',NULL,NULL),(9325,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:30',NULL,NULL),(726,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:02',NULL,NULL),(9164,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:30:48',NULL,NULL),(6387,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:27',NULL,NULL),(22717,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:47',NULL,NULL),(5168,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:20',NULL,NULL),(4565,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:53',NULL,NULL),(19648,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:04',NULL,NULL),(13089,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:03',NULL,NULL),(15561,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:17',NULL,NULL),(16968,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:49',NULL,NULL),(11198,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:16',NULL,NULL),(9264,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:14',NULL,NULL),(9029,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:10',NULL,NULL),(3087,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:31',NULL,NULL),(8518,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:04',NULL,NULL),(12911,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:16',NULL,NULL),(15194,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:01:51',NULL,NULL),(15666,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:52',NULL,NULL),(19109,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:39',NULL,NULL),(20742,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:23',NULL,NULL),(8071,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:14',NULL,NULL),(6308,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:05',NULL,NULL),(4236,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:28',NULL,NULL),(4763,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:42',NULL,NULL),(5577,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:16',NULL,NULL),(14722,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:30',NULL,NULL),(18245,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:02',NULL,NULL),(18663,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:58',NULL,NULL),(22018,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:13',NULL,NULL),(10920,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:16',NULL,NULL),(2521,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:35',NULL,NULL),(9978,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:44',NULL,NULL),(2113,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:08',NULL,NULL),(13619,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:39',NULL,NULL),(14630,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:05',NULL,NULL),(16536,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:23',NULL,NULL),(16570,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:35',NULL,NULL),(18179,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:55',NULL,NULL),(877,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:44',NULL,NULL),(12146,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:43',NULL,NULL),(10246,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:57',NULL,NULL),(4966,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:39',NULL,NULL),(2365,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:55',NULL,NULL),(10177,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:39',NULL,NULL),(7527,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:16',NULL,NULL),(7459,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:58',NULL,NULL),(13055,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:55',NULL,NULL),(13234,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:42',NULL,NULL),(13270,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:52',NULL,NULL),(14285,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:18',NULL,NULL),(14659,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:13',NULL,NULL),(15102,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:22',NULL,NULL),(15167,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:43',NULL,NULL),(15486,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:51',NULL,NULL),(17455,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:04',NULL,NULL),(17893,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:17',NULL,NULL),(19143,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:49',NULL,NULL),(20670,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:57',NULL,NULL),(434,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:08',NULL,NULL),(7126,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:25',NULL,NULL),(11041,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:28',NULL,NULL),(9160,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:47',NULL,NULL),(1322,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:43',NULL,NULL),(4958,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:37',NULL,NULL),(2934,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:34',NULL,NULL),(7509,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:11',NULL,NULL),(8416,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:48',NULL,NULL),(8243,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:59',NULL,NULL),(13759,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:00',NULL,NULL),(20161,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:08',NULL,NULL),(21400,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:06',NULL,NULL),(6987,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:01:56',NULL,NULL),(1113,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:48',NULL,NULL),(11543,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:49',NULL,NULL),(2010,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:43',NULL,NULL),(10032,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:59',NULL,NULL),(4655,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:12',NULL,NULL),(3424,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:16',NULL,NULL),(7832,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:20',NULL,NULL),(8086,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:18',NULL,NULL),(9261,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:14',NULL,NULL),(14559,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:44',NULL,NULL),(18840,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:23',NULL,NULL),(20985,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:30',NULL,NULL),(6031,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:34',NULL,NULL),(10283,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:08',NULL,NULL),(2387,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:00',NULL,NULL),(4113,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:02:01',NULL,NULL),(10157,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:33',NULL,NULL),(2782,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:41',NULL,NULL),(3990,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:30',NULL,NULL),(3850,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:54',NULL,NULL),(10116,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:22',NULL,NULL),(17240,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:18',NULL,NULL),(19506,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:23',NULL,NULL),(21039,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:45',NULL,NULL),(11899,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:19',NULL,NULL),(116,174,'2013-12-27','14:49:00','A','000',0,'2014-01-13 03:04:40',NULL,NULL),(11890,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:17',NULL,NULL),(11430,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:22',NULL,NULL),(5736,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:52',NULL,NULL),(3650,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:03',NULL,NULL),(5286,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:54',NULL,NULL),(10888,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:08',NULL,NULL),(13979,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:32',NULL,NULL),(18022,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:02',NULL,NULL),(19361,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:42',NULL,NULL),(19524,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:28',NULL,NULL),(19622,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:55',NULL,NULL),(20616,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:38',NULL,NULL),(12228,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:06',NULL,NULL),(11147,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:01',NULL,NULL),(191,352,'2013-12-27','16:04:00','A','000',0,'2014-01-13 03:05:05',NULL,NULL),(451,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:13',NULL,NULL),(907,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:52',NULL,NULL),(2498,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:29',NULL,NULL),(6487,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:54',NULL,NULL),(1408,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:16',NULL,NULL),(1643,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:39',NULL,NULL),(2389,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:01',NULL,NULL),(13585,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:35',NULL,NULL),(14967,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:00:37',NULL,NULL),(17336,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:25',NULL,NULL),(20665,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:55',NULL,NULL),(23003,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:17',NULL,NULL),(9814,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:37:18',NULL,NULL),(3501,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:36',NULL,NULL),(3459,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:25',NULL,NULL),(1779,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:22',NULL,NULL),(14532,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:37',NULL,NULL),(17350,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:29',NULL,NULL),(21150,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:16',NULL,NULL),(23032,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(10832,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:52',NULL,NULL),(1563,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:11',NULL,NULL),(13618,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:39',NULL,NULL),(15738,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:16',NULL,NULL),(19867,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:46',NULL,NULL),(20302,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:44',NULL,NULL),(21038,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:45',NULL,NULL),(21431,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:42:18',NULL,NULL),(300,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:21',NULL,NULL),(9725,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:54',NULL,NULL),(1233,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:09',NULL,NULL),(7080,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:11',NULL,NULL),(2292,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:36',NULL,NULL),(9187,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:54',NULL,NULL),(12957,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:30',NULL,NULL),(6692,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:34',NULL,NULL),(10850,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:57',NULL,NULL),(5050,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:03',NULL,NULL),(14171,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:00',NULL,NULL),(16873,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:25',NULL,NULL),(22290,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:42',NULL,NULL),(23617,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 14:00:02',NULL,NULL),(13017,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:45',NULL,NULL),(1239,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:12',NULL,NULL),(1259,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:20',NULL,NULL),(3642,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:15',NULL,NULL),(11967,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:54',NULL,NULL),(10874,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:04',NULL,NULL),(19752,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:16',NULL,NULL),(2200,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:06',NULL,NULL),(437,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:09',NULL,NULL),(13448,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:15',NULL,NULL),(13745,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:58',NULL,NULL),(22284,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:40',NULL,NULL),(670,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:25',NULL,NULL),(8039,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:05',NULL,NULL),(4549,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:49',NULL,NULL),(4527,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:44',NULL,NULL),(8674,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:45',NULL,NULL),(22781,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:12',NULL,NULL),(22830,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:29',NULL,NULL),(13225,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:40',NULL,NULL),(10327,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:20',NULL,NULL),(2125,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:11',NULL,NULL),(2376,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:58',NULL,NULL),(6016,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:28',NULL,NULL),(10226,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:52',NULL,NULL),(22185,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:14',NULL,NULL),(5568,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:13',NULL,NULL),(22022,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:14',NULL,NULL),(8704,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:53',NULL,NULL),(6645,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:22',NULL,NULL),(2661,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:12',NULL,NULL),(15929,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:59',NULL,NULL),(13959,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:28',NULL,NULL),(22353,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:00',NULL,NULL),(19227,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:05',NULL,NULL),(9837,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:24',NULL,NULL),(13558,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:31',NULL,NULL),(16813,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:10',NULL,NULL),(15176,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:46',NULL,NULL),(23183,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(19751,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:16',NULL,NULL),(16856,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:30:21',NULL,NULL),(15552,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:14',NULL,NULL),(4559,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:52',NULL,NULL),(14347,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:31',NULL,NULL),(7293,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:12',NULL,NULL),(16039,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:38',NULL,NULL),(3281,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:37',NULL,NULL),(5031,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:58',NULL,NULL),(412,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:01',NULL,NULL),(23388,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:46',NULL,NULL),(11171,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:07',NULL,NULL),(3868,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:59',NULL,NULL),(3356,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:57',NULL,NULL),(19226,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:04',NULL,NULL),(7211,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:48',NULL,NULL),(7415,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:45',NULL,NULL),(22458,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:35',NULL,NULL),(11929,1821,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:43',NULL,NULL),(3000,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:58',NULL,NULL),(22551,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:05',NULL,NULL),(19712,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:05',NULL,NULL),(2572,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:48',NULL,NULL),(1378,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:06',NULL,NULL),(14289,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:18',NULL,NULL),(12827,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:53',NULL,NULL),(9381,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:45',NULL,NULL),(20449,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:01:38',NULL,NULL),(5333,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:07',NULL,NULL),(14898,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:19',NULL,NULL),(8575,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:19',NULL,NULL),(8628,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:33',NULL,NULL),(7238,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:57',NULL,NULL),(16077,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:51',NULL,NULL),(14834,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:01',NULL,NULL),(10422,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:47',NULL,NULL),(4902,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:20',NULL,NULL),(11942,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:46',NULL,NULL),(10715,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:23',NULL,NULL),(21284,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:24',NULL,NULL),(17264,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:26',NULL,NULL),(7663,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:35',NULL,NULL),(880,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:45',NULL,NULL),(8108,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:24',NULL,NULL),(6713,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:39',NULL,NULL),(912,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:54',NULL,NULL),(21910,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:36',NULL,NULL),(21442,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:21',NULL,NULL),(2131,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:13',NULL,NULL),(6217,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:41',NULL,NULL),(6433,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:39',NULL,NULL),(22278,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:39',NULL,NULL),(15737,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:16',NULL,NULL),(23194,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(23533,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 22:00:02',NULL,NULL),(9137,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:41',NULL,NULL),(5776,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:05',NULL,NULL),(4280,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:40',NULL,NULL),(22744,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:56',NULL,NULL),(14119,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:52',NULL,NULL),(1276,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:26',NULL,NULL),(18078,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:21',NULL,NULL),(14225,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:08',NULL,NULL),(8773,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:11',NULL,NULL),(9640,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:32',NULL,NULL),(9129,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:38',NULL,NULL),(18999,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:09',NULL,NULL),(2954,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:41',NULL,NULL),(14664,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:15',NULL,NULL),(17712,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:35',NULL,NULL),(11926,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:42',NULL,NULL),(422,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:04',NULL,NULL),(14483,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:24',NULL,NULL),(22164,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:09',NULL,NULL),(17572,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:43',NULL,NULL),(5949,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:05',NULL,NULL),(1205,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:13',NULL,NULL),(21648,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:38',NULL,NULL),(11750,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:42',NULL,NULL),(20457,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:41',NULL,NULL),(18847,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:25',NULL,NULL),(5157,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:17',NULL,NULL),(8816,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:23',NULL,NULL),(5093,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:15',NULL,NULL),(4983,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:44',NULL,NULL),(4852,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:06',NULL,NULL),(15160,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:41',NULL,NULL),(15265,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:05',NULL,NULL),(2798,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:47',NULL,NULL),(824,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:30',NULL,NULL),(19755,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:17',NULL,NULL),(17144,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:45',NULL,NULL),(13374,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:19',NULL,NULL),(16635,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:01',NULL,NULL),(16862,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:23',NULL,NULL),(16867,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:24',NULL,NULL),(7633,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:27',NULL,NULL),(199,221,'2013-12-27','15:10:00','A','000',0,'2014-01-13 03:05:07',NULL,NULL),(6704,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:36',NULL,NULL),(3989,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:29',NULL,NULL),(4686,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:21',NULL,NULL),(3787,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:39',NULL,NULL),(2539,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:40',NULL,NULL),(6172,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:30:29',NULL,NULL),(16322,1888,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:18:02',NULL,NULL),(16422,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:40',NULL,NULL),(16779,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:54',NULL,NULL),(19988,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:20',NULL,NULL),(22346,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:58',NULL,NULL),(23531,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 17:30:02',NULL,NULL),(391,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:52',NULL,NULL),(10649,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:05',NULL,NULL),(6500,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:57',NULL,NULL),(9780,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:08',NULL,NULL),(3052,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:18',NULL,NULL),(3464,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:26',NULL,NULL),(9244,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:09',NULL,NULL),(9145,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:43',NULL,NULL),(15369,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:25',NULL,NULL),(16678,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:18',NULL,NULL),(16781,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:55',NULL,NULL),(17102,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:32',NULL,NULL),(17915,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:25',NULL,NULL),(18608,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:44',NULL,NULL),(20837,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:50',NULL,NULL),(21730,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:32',NULL,NULL),(22208,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:21',NULL,NULL),(23664,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 17:29:59',NULL,NULL),(12359,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:45',NULL,NULL),(742,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:07',NULL,NULL),(11002,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:17',NULL,NULL),(10727,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:26',NULL,NULL),(9030,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:11',NULL,NULL),(3478,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:30',NULL,NULL),(14668,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:16',NULL,NULL),(14983,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:42',NULL,NULL),(15523,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:04',NULL,NULL),(18695,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:07',NULL,NULL),(18979,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:03',NULL,NULL),(21142,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:14',NULL,NULL),(21953,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:50',NULL,NULL),(447,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:12',NULL,NULL),(6763,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:51',NULL,NULL),(9135,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:40',NULL,NULL),(5355,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:13',NULL,NULL),(2220,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:11',NULL,NULL),(3101,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:35',NULL,NULL),(4727,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:33',NULL,NULL),(15691,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:01',NULL,NULL),(16546,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:26',NULL,NULL),(16705,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:28',NULL,NULL),(18475,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:07',NULL,NULL),(19513,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:25',NULL,NULL),(20700,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:11',NULL,NULL),(23288,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:10',NULL,NULL),(10956,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:04',NULL,NULL),(589,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:59',NULL,NULL),(8524,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:05',NULL,NULL),(1422,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:21',NULL,NULL),(2348,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:51',NULL,NULL),(6064,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:46',NULL,NULL),(6562,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:14',NULL,NULL),(17620,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:01',NULL,NULL),(18065,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:17',NULL,NULL),(7447,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:54',NULL,NULL),(7149,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:31',NULL,NULL),(7107,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:20',NULL,NULL),(12526,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:27',NULL,NULL),(3695,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:15',NULL,NULL),(8175,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:42',NULL,NULL),(10734,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:28',NULL,NULL),(17682,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:24',NULL,NULL),(20936,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:17',NULL,NULL),(22842,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:33',NULL,NULL),(14689,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:21',NULL,NULL),(15300,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:12',NULL,NULL),(7938,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:49',NULL,NULL),(13243,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:45',NULL,NULL),(10689,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:17',NULL,NULL),(9962,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:56',NULL,NULL),(8486,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:07',NULL,NULL),(8472,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:03',NULL,NULL),(2816,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:53',NULL,NULL),(6617,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:14',NULL,NULL),(4227,1880,'2014-01-14','23:11:00','A','000',0,'2014-01-23 23:30:26',NULL,NULL),(4306,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:46',NULL,NULL),(4978,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:43',NULL,NULL),(5791,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:10',NULL,NULL),(6575,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:04',NULL,NULL),(6613,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:13',NULL,NULL),(17151,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:48',NULL,NULL),(17481,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:12',NULL,NULL),(17910,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:23',NULL,NULL),(18386,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:42',NULL,NULL),(83,301,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:17',NULL,NULL),(13144,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:19',NULL,NULL),(7779,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:06',NULL,NULL),(1043,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:29',NULL,NULL),(13123,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:13',NULL,NULL),(7670,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:37',NULL,NULL),(6040,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:02:37',NULL,NULL),(12460,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:08',NULL,NULL),(3951,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:20',NULL,NULL),(12387,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:52',NULL,NULL),(9210,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:00',NULL,NULL),(16839,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:17',NULL,NULL),(23187,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:51',NULL,NULL),(6843,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:14',NULL,NULL),(12417,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:21:56',NULL,NULL),(12271,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:18',NULL,NULL),(9545,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:08',NULL,NULL),(1806,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:29',NULL,NULL),(9321,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:29',NULL,NULL),(2619,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:00',NULL,NULL),(2883,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:16',NULL,NULL),(14782,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:47',NULL,NULL),(14801,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:52',NULL,NULL),(15596,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:29',NULL,NULL),(19312,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:28',NULL,NULL),(6524,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:04',NULL,NULL),(1148,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:31:58',NULL,NULL),(22424,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:23',NULL,NULL),(15401,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:31',NULL,NULL),(4940,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:32',NULL,NULL),(13541,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:28',NULL,NULL),(4356,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:00',NULL,NULL),(4041,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:43',NULL,NULL),(11644,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:14',NULL,NULL),(13101,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:07',NULL,NULL),(7610,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:21',NULL,NULL),(9196,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:56',NULL,NULL),(23550,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 23:30:02',NULL,NULL),(13275,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:53',NULL,NULL),(20418,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:26',NULL,NULL),(2938,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:36',NULL,NULL),(13484,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:20',NULL,NULL),(10292,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:11',NULL,NULL),(9509,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:35:58',NULL,NULL),(79,372,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:14',NULL,NULL),(10459,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:17',NULL,NULL),(19125,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:44',NULL,NULL),(2828,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:57',NULL,NULL),(3199,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:13',NULL,NULL),(12068,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:22',NULL,NULL),(3318,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:47',NULL,NULL),(10238,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:55',NULL,NULL),(22463,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:37',NULL,NULL),(12524,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:27',NULL,NULL),(14797,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:51',NULL,NULL),(18457,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:01',NULL,NULL),(18414,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:50',NULL,NULL),(3665,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:07',NULL,NULL),(21946,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:48',NULL,NULL),(10816,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:49',NULL,NULL),(11104,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:50',NULL,NULL),(20451,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:38',NULL,NULL),(9430,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:58',NULL,NULL),(644,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:16',NULL,NULL),(3768,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:33',NULL,NULL),(16214,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:41',NULL,NULL),(7040,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:11',NULL,NULL),(14364,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:49:49',NULL,NULL),(5169,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:21',NULL,NULL),(9676,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:42',NULL,NULL),(8427,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:51',NULL,NULL),(21439,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:20',NULL,NULL),(22919,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:59',NULL,NULL),(7514,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:13',NULL,NULL),(8415,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:48',NULL,NULL),(11604,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:04',NULL,NULL),(23420,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:57',NULL,NULL),(10969,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:08',NULL,NULL),(21787,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:51',NULL,NULL),(15025,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:56',NULL,NULL),(23476,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:17',NULL,NULL),(6066,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:46',NULL,NULL),(14705,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:26',NULL,NULL),(12292,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:24',NULL,NULL),(8885,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:41',NULL,NULL),(4406,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:13',NULL,NULL),(10291,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:10',NULL,NULL),(21841,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:11',NULL,NULL),(13792,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:04',NULL,NULL),(3180,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:08',NULL,NULL),(12603,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:48',NULL,NULL),(5875,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:39',NULL,NULL),(23477,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:18',NULL,NULL),(10663,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:11',NULL,NULL),(9045,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:14',NULL,NULL),(14482,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:23',NULL,NULL),(6565,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:14',NULL,NULL),(8313,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:21',NULL,NULL),(2096,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:04',NULL,NULL),(7695,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:43',NULL,NULL),(3615,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:07',NULL,NULL),(7403,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:42',NULL,NULL),(13899,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:20',NULL,NULL),(17059,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:18',NULL,NULL),(19519,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:27',NULL,NULL),(20147,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:04',NULL,NULL),(20394,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:18',NULL,NULL),(74,233,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:09',NULL,NULL),(5549,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:07',NULL,NULL),(11352,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:59',NULL,NULL),(9763,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:04',NULL,NULL),(2962,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:45',NULL,NULL),(2386,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:00',NULL,NULL),(9051,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:16',NULL,NULL),(14697,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:23',NULL,NULL),(15495,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:54',NULL,NULL),(15505,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:58',NULL,NULL),(15764,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:26',NULL,NULL),(16719,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:33',NULL,NULL),(20025,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:30',NULL,NULL),(20231,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:18',NULL,NULL),(22388,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:12',NULL,NULL),(897,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:49',NULL,NULL),(1226,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:07',NULL,NULL),(8863,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:35',NULL,NULL),(2559,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:45',NULL,NULL),(5933,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:59',NULL,NULL),(4479,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:32',NULL,NULL),(4156,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:08',NULL,NULL),(5698,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:38',NULL,NULL),(16371,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:20',NULL,NULL),(20454,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:39',NULL,NULL),(20462,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:42',NULL,NULL),(9954,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:54',NULL,NULL),(6159,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:25',NULL,NULL),(701,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:36',NULL,NULL),(9848,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:27',NULL,NULL),(7382,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:37',NULL,NULL),(7334,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:23',NULL,NULL),(15382,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:27',NULL,NULL),(15431,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:36',NULL,NULL),(17663,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:18',NULL,NULL),(17678,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:23',NULL,NULL),(20213,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:12',NULL,NULL),(20741,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:23',NULL,NULL),(12318,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:32',NULL,NULL),(5684,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:34',NULL,NULL),(4235,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:28',NULL,NULL),(4208,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:21',NULL,NULL),(10638,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:03',NULL,NULL),(14070,1840,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:45',NULL,NULL),(14440,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:12',NULL,NULL),(17622,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:02',NULL,NULL),(20680,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:04',NULL,NULL),(23219,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:57',NULL,NULL),(11061,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:34',NULL,NULL),(10990,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:14',NULL,NULL),(3426,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:16',NULL,NULL),(7214,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:49',NULL,NULL),(7993,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:03',NULL,NULL),(8717,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:56',NULL,NULL),(9652,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:36',NULL,NULL),(9480,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:12',NULL,NULL),(18115,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:34',NULL,NULL),(21299,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:29',NULL,NULL),(22386,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:11',NULL,NULL),(23661,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 11:30:00',NULL,NULL),(3328,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:49',NULL,NULL),(2800,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:47',NULL,NULL),(12950,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:28',NULL,NULL),(10598,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:52',NULL,NULL),(8495,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:09',NULL,NULL),(9414,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:54',NULL,NULL),(15464,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:43',NULL,NULL),(16579,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:38',NULL,NULL),(16770,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:51',NULL,NULL),(20955,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-24 09:31:22',NULL,NULL),(12163,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:48',NULL,NULL),(5223,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:35',NULL,NULL),(11640,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:13',NULL,NULL),(13169,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:25',NULL,NULL),(15673,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:55',NULL,NULL),(23328,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:25',NULL,NULL),(23410,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:53',NULL,NULL),(23427,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:59',NULL,NULL),(12176,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:51',NULL,NULL),(850,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:37',NULL,NULL),(4769,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:44',NULL,NULL),(1941,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:02',NULL,NULL),(5620,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:11',NULL,NULL),(5850,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:31',NULL,NULL),(14032,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:40',NULL,NULL),(14759,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:40',NULL,NULL),(17070,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:21',NULL,NULL),(18828,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:20',NULL,NULL),(18956,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:57',NULL,NULL),(21509,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:47',NULL,NULL),(11046,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:30',NULL,NULL),(10603,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:54',NULL,NULL),(9236,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:07',NULL,NULL),(1433,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:25',NULL,NULL),(8236,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:57',NULL,NULL),(4498,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:37',NULL,NULL),(5301,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:58',NULL,NULL),(5096,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:16',NULL,NULL),(13522,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:26',NULL,NULL),(15137,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:33',NULL,NULL),(15423,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:35',NULL,NULL),(17411,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:49',NULL,NULL),(484,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:24',NULL,NULL),(11028,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:24',NULL,NULL),(6640,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:20',NULL,NULL),(9490,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:54',NULL,NULL),(3549,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:49',NULL,NULL),(8322,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:23',NULL,NULL),(4302,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:45',NULL,NULL),(5519,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:58',NULL,NULL),(13898,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:19',NULL,NULL),(14276,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:16',NULL,NULL),(18907,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:42',NULL,NULL),(19390,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:51',NULL,NULL),(22954,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(23157,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(23323,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:23',NULL,NULL),(1151,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:59',NULL,NULL),(1740,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:12',NULL,NULL),(6914,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:36',NULL,NULL),(12768,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:35',NULL,NULL),(10844,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:55',NULL,NULL),(2493,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:28',NULL,NULL),(3988,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:29',NULL,NULL),(14096,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:49',NULL,NULL),(14741,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:35',NULL,NULL),(17099,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:31',NULL,NULL),(19512,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:25',NULL,NULL),(20026,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:30',NULL,NULL),(20576,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:23',NULL,NULL),(21179,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:45',NULL,NULL),(21578,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:12',NULL,NULL),(8759,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:08',NULL,NULL),(424,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:05',NULL,NULL),(6779,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:57',NULL,NULL),(6345,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:15',NULL,NULL),(955,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:05',NULL,NULL),(2272,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:31',NULL,NULL),(4329,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:52',NULL,NULL),(15841,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:27',NULL,NULL),(18906,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:42',NULL,NULL),(20242,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:22',NULL,NULL),(23469,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:15',NULL,NULL),(12109,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:33',NULL,NULL),(372,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:46',NULL,NULL),(462,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:17',NULL,NULL),(8801,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:19',NULL,NULL),(1130,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:52',NULL,NULL),(5327,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:05',NULL,NULL),(4989,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:46',NULL,NULL),(2711,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:16',NULL,NULL),(5585,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:18',NULL,NULL),(4256,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:34',NULL,NULL),(13930,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:24',NULL,NULL),(14712,1837,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:27',NULL,NULL),(15003,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:49',NULL,NULL),(17039,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:11',NULL,NULL),(18843,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:24',NULL,NULL),(20420,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:27',NULL,NULL),(23614,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 23:30:02',NULL,NULL),(22059,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:28',NULL,NULL),(23211,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(23246,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(13707,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:52',NULL,NULL),(328,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:32',NULL,NULL),(5486,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:49',NULL,NULL),(5026,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:56',NULL,NULL),(2912,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:26',NULL,NULL),(13664,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:45',NULL,NULL),(2488,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:27',NULL,NULL),(12893,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:11',NULL,NULL),(10373,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:33',NULL,NULL),(11475,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:32',NULL,NULL),(16273,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:04',NULL,NULL),(16725,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:35',NULL,NULL),(21152,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:17',NULL,NULL),(6854,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:17',NULL,NULL),(2564,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:46',NULL,NULL),(4882,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:15',NULL,NULL),(12320,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:33',NULL,NULL),(3481,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:31',NULL,NULL),(10678,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:15',NULL,NULL),(8321,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:23',NULL,NULL),(16840,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:17',NULL,NULL),(19225,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:04',NULL,NULL),(22932,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(11102,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:49',NULL,NULL),(5705,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:41',NULL,NULL),(3629,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:11',NULL,NULL),(1552,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:07',NULL,NULL),(1697,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:03:00',NULL,NULL),(7383,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:37',NULL,NULL),(2304,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:39',NULL,NULL),(16005,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:26',NULL,NULL),(1179,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:06',NULL,NULL),(12948,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:27',NULL,NULL),(5192,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:27',NULL,NULL),(12623,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:54',NULL,NULL),(2795,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:45',NULL,NULL),(4090,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:56',NULL,NULL),(4056,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:47',NULL,NULL),(3832,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:50',NULL,NULL),(11551,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:51',NULL,NULL),(9584,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:17',NULL,NULL),(11318,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:49',NULL,NULL),(15621,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:37',NULL,NULL),(16270,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:03',NULL,NULL),(20981,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:29',NULL,NULL),(13184,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:29',NULL,NULL),(12155,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:46',NULL,NULL),(591,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:59',NULL,NULL),(1471,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:39',NULL,NULL),(2107,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:07',NULL,NULL),(11886,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:16',NULL,NULL),(2958,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:43',NULL,NULL),(3303,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:43',NULL,NULL),(11260,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:33',NULL,NULL),(4573,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:55',NULL,NULL),(4957,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:37',NULL,NULL),(6279,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:57',NULL,NULL),(6964,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:51',NULL,NULL),(10365,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:31',NULL,NULL),(10280,1878,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:41:07',NULL,NULL),(16963,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:48',NULL,NULL),(18256,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:05',NULL,NULL),(20591,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:29',NULL,NULL),(21331,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:41',NULL,NULL),(23563,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 17:30:02',NULL,NULL),(23643,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-14 02:00:05',NULL,NULL),(6309,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:05',NULL,NULL),(692,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:33',NULL,NULL),(4835,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:02',NULL,NULL),(4718,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:30',NULL,NULL),(3916,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:12',NULL,NULL),(13177,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:27',NULL,NULL),(9138,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:41',NULL,NULL),(11404,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:14',NULL,NULL),(10267,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:03',NULL,NULL),(14241,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:10',NULL,NULL),(16056,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:44',NULL,NULL),(17918,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:26',NULL,NULL),(18525,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:22',NULL,NULL),(19302,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:26',NULL,NULL),(22745,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:57',NULL,NULL),(7434,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:50',NULL,NULL),(13851,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:13',NULL,NULL),(2127,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:12',NULL,NULL),(2593,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:53',NULL,NULL),(13682,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:48',NULL,NULL),(3081,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:29',NULL,NULL),(8185,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:44',NULL,NULL),(3849,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:54',NULL,NULL),(11815,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:58',NULL,NULL),(4078,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:52',NULL,NULL),(10015,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:54',NULL,NULL),(15438,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:38',NULL,NULL),(16585,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:40',NULL,NULL),(17396,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:45',NULL,NULL),(18555,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:30',NULL,NULL),(19620,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:54',NULL,NULL),(20780,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:34',NULL,NULL),(21231,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:05',NULL,NULL),(10688,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:17',NULL,NULL),(8479,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:05',NULL,NULL),(7613,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:22',NULL,NULL),(15745,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:19',NULL,NULL),(17900,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:19',NULL,NULL),(22867,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:42',NULL,NULL),(7212,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:48',NULL,NULL),(12852,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:01',NULL,NULL),(11142,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:00',NULL,NULL),(5366,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:16',NULL,NULL),(4232,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:27',NULL,NULL),(16958,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:46',NULL,NULL),(23090,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(151,162,'2013-12-27','11:21:00','A','000',0,'2014-01-13 03:04:51',NULL,NULL),(8667,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:43',NULL,NULL),(8639,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:36',NULL,NULL),(10515,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:31',NULL,NULL),(8474,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:03',NULL,NULL),(11091,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:46',NULL,NULL),(10159,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:34',NULL,NULL),(7201,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:45',NULL,NULL),(17782,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:37',NULL,NULL),(18827,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:20',NULL,NULL),(18910,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:43',NULL,NULL),(20011,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:26',NULL,NULL),(20274,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:34',NULL,NULL),(22325,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:50',NULL,NULL),(8640,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:36',NULL,NULL),(14265,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:15',NULL,NULL),(3354,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:56',NULL,NULL),(13432,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:12',NULL,NULL),(10360,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:29',NULL,NULL),(5477,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:46',NULL,NULL),(4815,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:56',NULL,NULL),(4818,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:57',NULL,NULL),(6418,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:35',NULL,NULL),(15014,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:53',NULL,NULL),(20106,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:53',NULL,NULL),(20404,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:21',NULL,NULL),(11226,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:24',NULL,NULL),(8511,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:13',NULL,NULL),(9835,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:23',NULL,NULL),(2544,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:41',NULL,NULL),(2750,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:30',NULL,NULL),(7842,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:23',NULL,NULL),(3433,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:18',NULL,NULL),(3710,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:19',NULL,NULL),(7604,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:20',NULL,NULL),(17563,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:40',NULL,NULL),(20091,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:48',NULL,NULL),(20876,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:01',NULL,NULL),(21194,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:51',NULL,NULL),(21279,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:22',NULL,NULL),(22076,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:34',NULL,NULL),(22143,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:03',NULL,NULL),(14439,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:11',NULL,NULL),(377,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:48',NULL,NULL),(7718,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:49',NULL,NULL),(1437,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:26',NULL,NULL),(11723,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:34',NULL,NULL),(6367,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:21',NULL,NULL),(5697,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:38',NULL,NULL),(14971,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:38',NULL,NULL),(20282,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:37',NULL,NULL),(21445,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:22',NULL,NULL),(796,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:22',NULL,NULL),(14016,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:37',NULL,NULL),(10589,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:50',NULL,NULL),(10335,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:23',NULL,NULL),(2665,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:13',NULL,NULL),(9301,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:24',NULL,NULL),(6966,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:51',NULL,NULL),(15522,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:04',NULL,NULL),(16568,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:34',NULL,NULL),(18085,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:24',NULL,NULL),(19451,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:08',NULL,NULL),(19993,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:21',NULL,NULL),(22055,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:27',NULL,NULL),(22671,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:31',NULL,NULL),(11392,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:10',NULL,NULL),(978,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:12',NULL,NULL),(1262,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:21',NULL,NULL),(8409,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:46',NULL,NULL),(4551,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:50',NULL,NULL),(8299,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:16',NULL,NULL),(5190,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:26',NULL,NULL),(8079,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:16',NULL,NULL),(15086,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:16',NULL,NULL),(15583,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:25',NULL,NULL),(16370,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:20',NULL,NULL),(18110,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:32',NULL,NULL),(18380,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:41',NULL,NULL),(22384,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:10',NULL,NULL),(8182,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:43',NULL,NULL),(960,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:07',NULL,NULL),(1576,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:16',NULL,NULL),(2219,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:10',NULL,NULL),(13022,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:46',NULL,NULL),(7279,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:08',NULL,NULL),(11766,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:46',NULL,NULL),(11211,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:20',NULL,NULL),(6254,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:51',NULL,NULL),(19409,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:57',NULL,NULL),(9143,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:42',NULL,NULL),(1194,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:11',NULL,NULL),(14420,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:06',NULL,NULL),(13023,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:46',NULL,NULL),(4847,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:05',NULL,NULL),(10568,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:45',NULL,NULL),(16531,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:21',NULL,NULL),(16949,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:44',NULL,NULL),(17605,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:56',NULL,NULL),(18520,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:20',NULL,NULL),(19429,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:02',NULL,NULL),(19984,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:19',NULL,NULL),(21651,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:03',NULL,NULL),(21851,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:14',NULL,NULL),(23223,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:58',NULL,NULL),(14553,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:43',NULL,NULL),(12679,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:09',NULL,NULL),(18659,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:57',NULL,NULL),(8751,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:06',NULL,NULL),(10209,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:40:47',NULL,NULL),(9867,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:32',NULL,NULL),(4231,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:27',NULL,NULL),(1575,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:15',NULL,NULL),(3997,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:31',NULL,NULL),(5275,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:50',NULL,NULL),(3287,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:38',NULL,NULL),(17887,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:15',NULL,NULL),(18103,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:30',NULL,NULL),(19556,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:37',NULL,NULL),(21181,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:46',NULL,NULL),(23240,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:01',NULL,NULL),(7893,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:38',NULL,NULL),(13363,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:17',NULL,NULL),(13280,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:54',NULL,NULL),(11873,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:13',NULL,NULL),(4188,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:16',NULL,NULL),(5079,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:11',NULL,NULL),(4209,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:22',NULL,NULL),(3692,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:14',NULL,NULL),(15792,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:35',NULL,NULL),(21404,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:07',NULL,NULL),(22863,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:40',NULL,NULL),(23342,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:30',NULL,NULL),(7564,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:09',NULL,NULL),(584,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:57',NULL,NULL),(1086,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:41',NULL,NULL),(15864,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:36',NULL,NULL),(16293,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:11',NULL,NULL),(9345,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:35',NULL,NULL),(788,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:20',NULL,NULL),(8593,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:23',NULL,NULL),(6985,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:56',NULL,NULL),(6548,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:10',NULL,NULL),(5988,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:19',NULL,NULL),(12907,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:15',NULL,NULL),(2512,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:33',NULL,NULL),(12218,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:03',NULL,NULL),(11983,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:00',NULL,NULL),(10982,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:12',NULL,NULL),(17210,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:08',NULL,NULL),(18224,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:11',NULL,NULL),(20397,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:19',NULL,NULL),(9147,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:43',NULL,NULL),(8832,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:27',NULL,NULL),(8761,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:08',NULL,NULL),(12615,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:52',NULL,NULL),(11054,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:32',NULL,NULL),(22650,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:24',NULL,NULL),(22827,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:28',NULL,NULL),(6372,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:23',NULL,NULL),(13356,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:15',NULL,NULL),(6019,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:29',NULL,NULL),(5785,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:08',NULL,NULL),(12265,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:16',NULL,NULL),(10845,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:56',NULL,NULL),(10989,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:14',NULL,NULL),(13838,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:11',NULL,NULL),(14076,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:46',NULL,NULL),(15087,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:17',NULL,NULL),(16206,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:39',NULL,NULL),(17212,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:08',NULL,NULL),(18399,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:46',NULL,NULL),(20368,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:08',NULL,NULL),(20460,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:42',NULL,NULL),(21772,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:46',NULL,NULL),(22570,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:12',NULL,NULL),(22776,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:09',NULL,NULL),(71,316,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:06',NULL,NULL),(11029,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:25',NULL,NULL),(3299,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:42',NULL,NULL),(2864,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:10',NULL,NULL),(7244,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:59',NULL,NULL),(4597,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:01',NULL,NULL),(1828,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:34',NULL,NULL),(5968,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:12',NULL,NULL),(14622,1862,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:03',NULL,NULL),(15181,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:48',NULL,NULL),(17974,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:45',NULL,NULL),(19116,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:41',NULL,NULL),(19594,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:47',NULL,NULL),(20486,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:51',NULL,NULL),(12392,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:53',NULL,NULL),(547,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:45',NULL,NULL),(1208,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:32:14',NULL,NULL),(1220,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:05',NULL,NULL),(1602,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:25',NULL,NULL),(12140,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:42',NULL,NULL),(11325,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:50',NULL,NULL),(8964,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:03',NULL,NULL),(6036,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:36',NULL,NULL),(17635,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:07',NULL,NULL),(18501,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:15',NULL,NULL),(19739,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:12',NULL,NULL),(22037,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:20',NULL,NULL),(12922,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:19',NULL,NULL),(5248,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:42',NULL,NULL),(8348,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:31',NULL,NULL),(2184,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:27',NULL,NULL),(5220,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:35',NULL,NULL),(3568,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:54',NULL,NULL),(18192,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:59',NULL,NULL),(18781,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:07',NULL,NULL),(18819,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:18',NULL,NULL),(704,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:37',NULL,NULL),(8947,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:58',NULL,NULL),(7588,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:15',NULL,NULL),(15199,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:52',NULL,NULL),(15834,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:25',NULL,NULL),(19435,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:04',NULL,NULL),(20191,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:04',NULL,NULL),(21583,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:14',NULL,NULL),(22487,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:45',NULL,NULL),(1142,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:56',NULL,NULL),(11924,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:42',NULL,NULL),(5633,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:16',NULL,NULL),(11661,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:19',NULL,NULL),(3095,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:33',NULL,NULL),(3022,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:06',NULL,NULL),(16806,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:08',NULL,NULL),(18774,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:05',NULL,NULL),(19389,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:51',NULL,NULL),(7705,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:46',NULL,NULL),(7567,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:10',NULL,NULL),(8411,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:47',NULL,NULL),(9743,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:59',NULL,NULL),(14582,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:50',NULL,NULL),(14966,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:36',NULL,NULL),(16359,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:15',NULL,NULL),(22166,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:09',NULL,NULL),(920,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:56',NULL,NULL),(14098,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:49',NULL,NULL),(7465,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:00',NULL,NULL),(1926,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:58',NULL,NULL),(6706,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:37',NULL,NULL),(5427,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:32',NULL,NULL),(15445,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:39',NULL,NULL),(18627,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:49',NULL,NULL),(18718,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:14',NULL,NULL),(18941,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:52',NULL,NULL),(19970,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:15',NULL,NULL),(20756,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:27',NULL,NULL),(10443,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:53',NULL,NULL),(8582,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:21',NULL,NULL),(12685,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:11',NULL,NULL),(11181,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:10',NULL,NULL),(9154,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:45',NULL,NULL),(7965,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:56',NULL,NULL),(4063,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:01:49',NULL,NULL),(5946,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:04',NULL,NULL),(4774,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:45',NULL,NULL),(7964,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:56',NULL,NULL),(14645,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:09',NULL,NULL),(15203,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:53',NULL,NULL),(15218,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:01:56',NULL,NULL),(17525,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:27',NULL,NULL),(18708,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:11',NULL,NULL),(23112,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(12185,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:54',NULL,NULL),(367,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:45',NULL,NULL),(8595,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:24',NULL,NULL),(11632,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:11',NULL,NULL),(6566,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:02',NULL,NULL),(1912,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:55',NULL,NULL),(11152,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:02',NULL,NULL),(5774,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:05',NULL,NULL),(9926,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:47',NULL,NULL),(15189,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:01:50',NULL,NULL),(18018,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:01',NULL,NULL),(19536,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:31',NULL,NULL),(22760,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:03',NULL,NULL),(13028,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:47',NULL,NULL),(12674,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:08',NULL,NULL),(8393,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:42',NULL,NULL),(4536,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:46',NULL,NULL),(4708,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:27',NULL,NULL),(9989,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:47',NULL,NULL),(12133,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:40',NULL,NULL),(20189,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:03',NULL,NULL),(374,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:47',NULL,NULL),(8527,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:06',NULL,NULL),(1114,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:48',NULL,NULL),(10647,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:05',NULL,NULL),(1387,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:09',NULL,NULL),(16909,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:35',NULL,NULL),(19034,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:18',NULL,NULL),(20559,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:17',NULL,NULL),(23193,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:52',NULL,NULL),(320,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:29',NULL,NULL),(13397,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:06',NULL,NULL),(4589,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:59',NULL,NULL),(4390,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:09',NULL,NULL),(12556,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:35',NULL,NULL),(12111,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:34',NULL,NULL),(2987,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:53',NULL,NULL),(15762,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:25',NULL,NULL),(17846,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:01',NULL,NULL),(18666,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:59',NULL,NULL),(18668,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:00',NULL,NULL),(19861,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:44',NULL,NULL),(20881,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:02',NULL,NULL),(22664,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:28',NULL,NULL),(197,181,'2013-12-27','14:52:00','A','000',0,'2014-01-13 03:05:07',NULL,NULL),(13085,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:02',NULL,NULL),(7342,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:26',NULL,NULL),(5471,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:44',NULL,NULL),(15684,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:59',NULL,NULL),(17802,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:45',NULL,NULL),(8726,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:59',NULL,NULL),(13203,1836,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:34',NULL,NULL),(12946,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:27',NULL,NULL),(1819,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:32',NULL,NULL),(7844,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:24',NULL,NULL),(12699,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:16',NULL,NULL),(2296,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:37',NULL,NULL),(15823,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:20',NULL,NULL),(8724,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:58',NULL,NULL),(11313,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:47',NULL,NULL),(7565,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:09',NULL,NULL),(10379,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:35',NULL,NULL),(1453,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:33',NULL,NULL),(3322,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:48',NULL,NULL),(6027,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:33',NULL,NULL),(17097,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:30',NULL,NULL),(19900,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:54',NULL,NULL),(21941,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:46',NULL,NULL),(649,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:18',NULL,NULL),(1000,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:17',NULL,NULL),(1324,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:44',NULL,NULL),(1406,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:15',NULL,NULL),(14245,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:11',NULL,NULL),(2701,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:12',NULL,NULL),(13941,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:26',NULL,NULL),(4698,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:25',NULL,NULL),(12468,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:11',NULL,NULL),(10185,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:41',NULL,NULL),(15951,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:06',NULL,NULL),(17333,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:24',NULL,NULL),(17652,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:13',NULL,NULL),(17695,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:29',NULL,NULL),(21335,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:42',NULL,NULL),(22953,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:07',NULL,NULL),(10221,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:51',NULL,NULL),(3407,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:11',NULL,NULL),(16298,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:17:53',NULL,NULL),(16320,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:01',NULL,NULL),(19391,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:52',NULL,NULL),(19555,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:37',NULL,NULL),(15008,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:51',NULL,NULL),(12048,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:17',NULL,NULL),(10296,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:12',NULL,NULL),(6886,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:27',NULL,NULL),(6463,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:48',NULL,NULL),(16374,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:21',NULL,NULL),(19814,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:32',NULL,NULL),(11980,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:59',NULL,NULL),(1152,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:59',NULL,NULL),(5642,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:19',NULL,NULL),(2545,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:41',NULL,NULL),(16445,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:48',NULL,NULL),(16846,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:18',NULL,NULL),(17312,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:17',NULL,NULL),(17544,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:33',NULL,NULL),(17987,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:49',NULL,NULL),(19377,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:47',NULL,NULL),(19643,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:03',NULL,NULL),(19802,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:29',NULL,NULL),(20005,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:25',NULL,NULL),(23230,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(9282,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:19',NULL,NULL),(1484,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:44',NULL,NULL),(1592,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:22',NULL,NULL),(8748,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:05',NULL,NULL),(13631,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:41',NULL,NULL),(13565,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:32',NULL,NULL),(11246,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:30',NULL,NULL),(10503,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:28',NULL,NULL),(3683,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:12',NULL,NULL),(16226,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:46',NULL,NULL),(17188,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:00',NULL,NULL),(9744,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:59',NULL,NULL),(13799,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:06',NULL,NULL),(9544,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:07',NULL,NULL),(8224,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:54',NULL,NULL),(12159,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:47',NULL,NULL),(12075,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:24',NULL,NULL),(10594,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:51',NULL,NULL),(5398,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:24',NULL,NULL),(18067,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:17',NULL,NULL),(21306,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:32',NULL,NULL),(22070,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:32',NULL,NULL),(8307,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:19',NULL,NULL),(15580,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:24',NULL,NULL),(444,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:01:11',NULL,NULL),(13823,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:09',NULL,NULL),(3154,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:54',NULL,NULL),(12227,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:06',NULL,NULL),(5118,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:05',NULL,NULL),(6353,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:17',NULL,NULL),(7294,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:12',NULL,NULL),(16559,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:31',NULL,NULL),(17321,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:20',NULL,NULL),(19063,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:26',NULL,NULL),(22317,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:48',NULL,NULL),(1829,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:34',NULL,NULL),(10270,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:04',NULL,NULL),(7677,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:39',NULL,NULL),(3884,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:03',NULL,NULL),(9518,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:01',NULL,NULL),(9111,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:33',NULL,NULL),(9050,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:16',NULL,NULL),(16673,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:16',NULL,NULL),(17912,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:24',NULL,NULL),(20335,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:56',NULL,NULL),(129,158,'2013-12-27','11:16:00','A','000',0,'2014-01-13 03:04:44',NULL,NULL),(13118,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:12',NULL,NULL),(11531,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:46',NULL,NULL),(2542,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:40',NULL,NULL),(5053,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:04',NULL,NULL),(18760,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:01',NULL,NULL),(22492,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:46',NULL,NULL),(1307,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:38',NULL,NULL),(2474,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:23',NULL,NULL),(14129,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:54',NULL,NULL),(3585,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:59',NULL,NULL),(6625,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:16',NULL,NULL),(12484,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:15',NULL,NULL),(11114,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:52',NULL,NULL),(17335,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:24',NULL,NULL),(18817,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:17',NULL,NULL),(19646,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:03',NULL,NULL),(19707,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:04',NULL,NULL),(10446,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:53',NULL,NULL),(9588,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:19',NULL,NULL),(8995,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:02:12',NULL,NULL),(730,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:03',NULL,NULL),(4504,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:38',NULL,NULL),(4576,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:56',NULL,NULL),(1659,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:46',NULL,NULL),(15155,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:39',NULL,NULL),(19111,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:39',NULL,NULL),(20045,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:35',NULL,NULL),(20179,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:13',NULL,NULL),(20288,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:39',NULL,NULL),(21366,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:53',NULL,NULL),(23076,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(23169,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:48',NULL,NULL),(13525,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:26',NULL,NULL),(8001,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:02:05',NULL,NULL),(7700,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:45',NULL,NULL),(1927,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:58',NULL,NULL),(12784,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:39',NULL,NULL),(11267,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:35',NULL,NULL),(6274,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:56',NULL,NULL),(3331,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:50',NULL,NULL),(6826,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:10',NULL,NULL),(16010,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:27',NULL,NULL),(18450,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:59',NULL,NULL),(20315,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:49',NULL,NULL),(20677,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:03',NULL,NULL),(22787,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:14',NULL,NULL),(12480,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:14',NULL,NULL),(939,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:31:01',NULL,NULL),(8675,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:45',NULL,NULL),(6705,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:37',NULL,NULL),(4935,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:30',NULL,NULL),(5258,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:45',NULL,NULL),(21248,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:11',NULL,NULL),(22637,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:19',NULL,NULL),(8105,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:23',NULL,NULL),(7788,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:08',NULL,NULL),(11699,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:28',NULL,NULL),(1713,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:06',NULL,NULL),(2118,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:10',NULL,NULL),(9810,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:17',NULL,NULL),(2996,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:57',NULL,NULL),(3359,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:58',NULL,NULL),(4514,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:41',NULL,NULL),(14866,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:10',NULL,NULL),(17419,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:52',NULL,NULL),(19395,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:53',NULL,NULL),(14407,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:02',NULL,NULL),(13977,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:31',NULL,NULL),(5076,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:10',NULL,NULL),(1711,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:05',NULL,NULL),(6020,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:30',NULL,NULL),(6767,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:52',NULL,NULL),(3289,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:39',NULL,NULL),(15467,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:44',NULL,NULL),(17769,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:32',NULL,NULL),(20427,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:30',NULL,NULL),(20830,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:48',NULL,NULL),(21621,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:28',NULL,NULL),(22078,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:35',NULL,NULL),(14549,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:41',NULL,NULL),(7346,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:27',NULL,NULL),(12810,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:47',NULL,NULL),(1745,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:14',NULL,NULL),(5368,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:16',NULL,NULL),(3835,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:51',NULL,NULL),(3826,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:49',NULL,NULL),(17121,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:38',NULL,NULL),(18614,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:46',NULL,NULL),(18885,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:35',NULL,NULL),(20246,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:24',NULL,NULL),(23567,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 01:30:02',NULL,NULL),(428,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:06',NULL,NULL),(8768,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:10',NULL,NULL),(2129,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:12',NULL,NULL),(5941,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:02',NULL,NULL),(7338,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:24',NULL,NULL),(5461,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:42',NULL,NULL),(7014,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:04',NULL,NULL),(15350,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:21',NULL,NULL),(16294,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:12',NULL,NULL),(18095,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:27',NULL,NULL),(20055,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:38',NULL,NULL),(23139,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:42',NULL,NULL),(9474,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:11',NULL,NULL),(2901,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:23',NULL,NULL),(9374,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:43',NULL,NULL),(15870,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:38',NULL,NULL),(16486,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:04',NULL,NULL),(19335,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:35',NULL,NULL),(20728,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:19',NULL,NULL),(21900,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:32',NULL,NULL),(23365,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:38',NULL,NULL),(23713,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 19:29:59',NULL,NULL),(14942,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:30',NULL,NULL),(12848,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:00',NULL,NULL),(9166,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:48',NULL,NULL),(12421,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:21:57',NULL,NULL),(21260,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:15',NULL,NULL),(22460,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:36',NULL,NULL),(7872,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:32',NULL,NULL),(1023,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:24',NULL,NULL),(13137,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:17',NULL,NULL),(6291,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:01',NULL,NULL),(1664,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:48',NULL,NULL),(5817,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:20',NULL,NULL),(12494,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:18',NULL,NULL),(12073,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:24',NULL,NULL),(11508,1877,'2014-01-14','23:11:00','A','000',0,'2014-01-24 05:14:40',NULL,NULL),(17174,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:55',NULL,NULL),(19682,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:13',NULL,NULL),(20755,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:27',NULL,NULL),(20966,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:25',NULL,NULL),(821,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:29',NULL,NULL),(15101,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:21',NULL,NULL),(3490,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:33',NULL,NULL),(4677,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:00:18',NULL,NULL),(7867,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:31',NULL,NULL),(7203,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:45',NULL,NULL),(14141,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:56',NULL,NULL),(5859,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:34',NULL,NULL),(13406,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:08',NULL,NULL),(12578,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:41',NULL,NULL),(10997,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:16',NULL,NULL),(16738,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:39',NULL,NULL),(18778,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:06',NULL,NULL),(18898,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:39',NULL,NULL),(21325,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:39',NULL,NULL),(23366,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:39',NULL,NULL),(8363,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:35',NULL,NULL),(1402,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:14',NULL,NULL),(2341,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:49',NULL,NULL),(6248,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:49',NULL,NULL),(5003,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:50',NULL,NULL),(9487,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:53',NULL,NULL),(16710,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:29',NULL,NULL),(10476,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:21',NULL,NULL),(6014,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:28',NULL,NULL),(9100,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:30',NULL,NULL),(8422,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:50',NULL,NULL),(1077,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:38',NULL,NULL),(8152,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:35',NULL,NULL),(1813,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:30',NULL,NULL),(16754,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:45',NULL,NULL),(18225,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:11',NULL,NULL),(20524,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:04',NULL,NULL),(22409,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:18',NULL,NULL),(22480,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:43',NULL,NULL),(22876,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:45',NULL,NULL),(4570,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:55',NULL,NULL),(5430,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:33',NULL,NULL),(7461,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:59',NULL,NULL),(7278,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:08',NULL,NULL),(2726,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:21',NULL,NULL),(17247,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:20',NULL,NULL),(18349,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:32',NULL,NULL),(19172,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:58',NULL,NULL),(22334,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:53',NULL,NULL),(22471,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:40',NULL,NULL),(23524,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-29 19:30:02',NULL,NULL),(8946,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:58',NULL,NULL),(8271,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:07',NULL,NULL),(672,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:27',NULL,NULL),(1389,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:09',NULL,NULL),(6371,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:22',NULL,NULL),(3681,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:11',NULL,NULL),(15874,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:39',NULL,NULL),(16927,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:39',NULL,NULL),(20626,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:42',NULL,NULL),(11633,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:11',NULL,NULL),(9449,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:04',NULL,NULL),(11621,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:08',NULL,NULL),(9060,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:19',NULL,NULL),(9011,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:05',NULL,NULL),(3070,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:25',NULL,NULL),(11316,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:48',NULL,NULL),(11116,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:53',NULL,NULL),(5373,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:18',NULL,NULL),(10932,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:18',NULL,NULL),(8741,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:03',NULL,NULL),(19977,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:17',NULL,NULL),(13942,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:26',NULL,NULL),(8886,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:41',NULL,NULL),(1895,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:50',NULL,NULL),(13514,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:25',NULL,NULL),(10236,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:55',NULL,NULL),(10145,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:30',NULL,NULL),(10004,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:39:51',NULL,NULL),(20864,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:58',NULL,NULL),(15501,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:57',NULL,NULL),(8587,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:22',NULL,NULL),(1984,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:36',NULL,NULL),(15404,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:31',NULL,NULL),(14537,1884,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:50:38',NULL,NULL),(7853,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:26',NULL,NULL),(14313,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:22',NULL,NULL),(13686,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:48',NULL,NULL),(5272,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:49',NULL,NULL),(11294,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:42',NULL,NULL),(11279,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:38',NULL,NULL),(18615,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:46',NULL,NULL),(18771,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:04',NULL,NULL),(22141,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:03',NULL,NULL),(22686,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:36',NULL,NULL),(15709,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:07',NULL,NULL),(15368,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:25',NULL,NULL),(13207,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:35',NULL,NULL),(7991,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:03',NULL,NULL),(4022,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:37',NULL,NULL),(7312,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:18',NULL,NULL),(4071,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:51',NULL,NULL),(6231,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:45',NULL,NULL),(17485,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:14',NULL,NULL),(19414,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:58',NULL,NULL),(20436,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:33',NULL,NULL),(22407,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:18',NULL,NULL),(15819,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:19',NULL,NULL),(15261,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:04',NULL,NULL),(14962,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:35',NULL,NULL),(9925,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:47',NULL,NULL),(14847,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:05',NULL,NULL),(5111,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:03',NULL,NULL),(12875,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:10',NULL,NULL),(12569,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:39',NULL,NULL),(10742,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:30',NULL,NULL),(7831,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:20',NULL,NULL),(4266,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:36',NULL,NULL),(12209,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:01',NULL,NULL),(11714,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:32',NULL,NULL),(8410,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:47',NULL,NULL),(9818,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:19',NULL,NULL),(15069,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:11',NULL,NULL),(16938,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:42',NULL,NULL),(20566,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:20',NULL,NULL),(22770,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:07',NULL,NULL),(13676,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:47',NULL,NULL),(998,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:17',NULL,NULL),(7865,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:31',NULL,NULL),(7690,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:42',NULL,NULL),(12843,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:59',NULL,NULL),(4599,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:02',NULL,NULL),(10948,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:02',NULL,NULL),(14661,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:14',NULL,NULL),(15469,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:45',NULL,NULL),(19360,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:42',NULL,NULL),(20883,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:03',NULL,NULL),(22923,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:00',NULL,NULL),(23083,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:32',NULL,NULL),(12236,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:08',NULL,NULL),(11524,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:44',NULL,NULL),(2012,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:43',NULL,NULL),(9496,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:55',NULL,NULL),(8269,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:06',NULL,NULL),(4790,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:49',NULL,NULL),(14495,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:27',NULL,NULL),(15543,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:11',NULL,NULL),(16713,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:30',NULL,NULL),(18540,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:26',NULL,NULL),(19381,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:48',NULL,NULL),(7777,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:05',NULL,NULL),(11650,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:16',NULL,NULL),(10592,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:51',NULL,NULL),(4327,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:51',NULL,NULL),(2190,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:30:03',NULL,NULL),(2221,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:11',NULL,NULL),(5918,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:54',NULL,NULL),(4496,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:36',NULL,NULL),(16377,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:22',NULL,NULL),(19079,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:30',NULL,NULL),(21938,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:45',NULL,NULL),(22926,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:02',NULL,NULL),(12230,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:07',NULL,NULL),(6113,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:30:12',NULL,NULL),(11918,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:24',NULL,NULL),(1997,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:39',NULL,NULL),(9897,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:40',NULL,NULL),(2693,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:09',NULL,NULL),(17395,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:44',NULL,NULL),(18486,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:10',NULL,NULL),(11184,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:12',NULL,NULL),(456,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:15',NULL,NULL),(10934,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:19',NULL,NULL),(21473,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:33',NULL,NULL),(21763,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:43',NULL,NULL),(22389,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:12',NULL,NULL),(983,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:13',NULL,NULL),(1642,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:39',NULL,NULL),(12942,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:26',NULL,NULL),(10057,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:06',NULL,NULL),(5934,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:59',NULL,NULL),(6424,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:37',NULL,NULL),(19528,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:29',NULL,NULL),(23540,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 19:30:02',NULL,NULL),(8867,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:36',NULL,NULL),(13446,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:14',NULL,NULL),(8597,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:24',NULL,NULL),(12574,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:40',NULL,NULL),(10798,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:44',NULL,NULL),(3072,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:26',NULL,NULL),(3784,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:38',NULL,NULL),(8158,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:37',NULL,NULL),(10390,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:38',NULL,NULL),(7482,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:32:04',NULL,NULL),(6666,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:00:27',NULL,NULL),(14557,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:44',NULL,NULL),(14667,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:16',NULL,NULL),(19884,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:50',NULL,NULL),(21556,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:04',NULL,NULL),(22232,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:27',NULL,NULL),(4830,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:01',NULL,NULL),(755,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:10',NULL,NULL),(861,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:40',NULL,NULL),(10341,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:24',NULL,NULL),(3236,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:24',NULL,NULL),(1874,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:45',NULL,NULL),(22593,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:20',NULL,NULL),(23311,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:19',NULL,NULL),(23568,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 11:30:02',NULL,NULL),(4945,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:34',NULL,NULL),(14359,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:48',NULL,NULL),(13235,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:43',NULL,NULL),(11414,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:18',NULL,NULL),(12225,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:05',NULL,NULL),(17502,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:19',NULL,NULL),(19080,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:31',NULL,NULL),(11534,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:46',NULL,NULL),(293,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:19',NULL,NULL),(8975,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:06',NULL,NULL),(10651,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:06',NULL,NULL),(4919,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:26',NULL,NULL),(6995,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:59',NULL,NULL),(1243,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:13',NULL,NULL),(2698,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:11',NULL,NULL),(8899,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:45',NULL,NULL),(21632,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:32',NULL,NULL),(22707,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:43',NULL,NULL),(22833,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:30',NULL,NULL),(1006,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:19',NULL,NULL),(11270,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:36',NULL,NULL),(6726,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:42',NULL,NULL),(16111,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:05',NULL,NULL),(18094,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:27',NULL,NULL),(19473,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:14',NULL,NULL),(4971,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:41',NULL,NULL),(2276,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:32',NULL,NULL),(5253,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:44',NULL,NULL),(7721,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:50',NULL,NULL),(7493,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:07',NULL,NULL),(1227,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:07',NULL,NULL),(5284,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:54',NULL,NULL),(15375,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:26',NULL,NULL),(15686,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:59',NULL,NULL),(16095,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:59',NULL,NULL),(16731,1837,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:20:37',NULL,NULL),(16986,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:53',NULL,NULL),(18287,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:15',NULL,NULL),(19534,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:31',NULL,NULL),(21223,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:02',NULL,NULL),(23189,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:52',NULL,NULL),(23465,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:14',NULL,NULL),(12914,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:17',NULL,NULL),(10202,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:46',NULL,NULL),(10045,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:02',NULL,NULL),(8126,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:28',NULL,NULL),(18591,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:39',NULL,NULL),(18679,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:03',NULL,NULL),(20361,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:05',NULL,NULL),(11175,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:09',NULL,NULL),(1004,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:19',NULL,NULL),(10718,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:24',NULL,NULL),(10038,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:00',NULL,NULL),(2990,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:54',NULL,NULL),(8385,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:31:40',NULL,NULL),(3600,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:03',NULL,NULL),(5090,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:14',NULL,NULL),(17297,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:12',NULL,NULL),(18742,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:35:56',NULL,NULL),(20278,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:35',NULL,NULL),(21065,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:52',NULL,NULL),(10030,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:58',NULL,NULL),(4535,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:46',NULL,NULL),(4355,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:00',NULL,NULL),(8103,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:23',NULL,NULL),(15434,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:37',NULL,NULL),(21513,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:48',NULL,NULL),(21762,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:43',NULL,NULL),(34,322,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:32',NULL,NULL),(515,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:35',NULL,NULL),(15121,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:28',NULL,NULL),(13393,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:05',NULL,NULL),(9130,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:39',NULL,NULL),(12264,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:16',NULL,NULL),(5447,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:38',NULL,NULL),(12114,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:35',NULL,NULL),(4894,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:18',NULL,NULL),(10312,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:16',NULL,NULL),(11346,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:58',NULL,NULL),(11227,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:25',NULL,NULL),(20090,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:48',NULL,NULL),(23164,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(9387,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:47',NULL,NULL),(7824,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:18',NULL,NULL),(1135,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:54',NULL,NULL),(7416,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:46',NULL,NULL),(1658,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:46',NULL,NULL),(14641,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:08',NULL,NULL),(13048,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:53',NULL,NULL),(11022,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:23',NULL,NULL),(5328,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:06',NULL,NULL),(3345,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:54',NULL,NULL),(18568,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:33',NULL,NULL),(21972,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:57',NULL,NULL),(14873,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:11',NULL,NULL),(7039,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:11',NULL,NULL),(1839,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:36',NULL,NULL),(2384,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:00',NULL,NULL),(2445,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:16',NULL,NULL),(6313,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:06',NULL,NULL),(14064,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:44',NULL,NULL),(16769,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:50',NULL,NULL),(21079,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:56',NULL,NULL),(21102,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:02',NULL,NULL),(21377,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:57',NULL,NULL),(12864,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:06',NULL,NULL),(12788,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:40',NULL,NULL),(9151,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:44',NULL,NULL),(7969,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:57',NULL,NULL),(11012,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:20',NULL,NULL),(1905,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:53',NULL,NULL),(7254,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:01',NULL,NULL),(2974,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:49',NULL,NULL),(15907,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:51',NULL,NULL),(16203,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:38',NULL,NULL),(16398,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:31',NULL,NULL),(20516,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:01',NULL,NULL),(22184,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:14',NULL,NULL),(22565,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:10',NULL,NULL),(14226,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:08',NULL,NULL),(9433,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:59',NULL,NULL),(12300,1854,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:20:26',NULL,NULL),(10802,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:45',NULL,NULL),(11963,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:53',NULL,NULL),(20271,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:33',NULL,NULL),(401,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:58',NULL,NULL),(11572,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:56',NULL,NULL),(5073,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:09',NULL,NULL),(1249,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:16',NULL,NULL),(7974,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:59',NULL,NULL),(8110,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:24',NULL,NULL),(16315,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:59',NULL,NULL),(16507,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:12',NULL,NULL),(19264,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:15',NULL,NULL),(20635,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:45',NULL,NULL),(20738,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:22',NULL,NULL),(21421,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:14',NULL,NULL),(10787,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:41',NULL,NULL),(406,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:59',NULL,NULL),(1312,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:39',NULL,NULL),(1721,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:08',NULL,NULL),(6013,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:27',NULL,NULL),(8252,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:02',NULL,NULL),(3680,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:11',NULL,NULL),(3762,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:32',NULL,NULL),(20502,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:56',NULL,NULL),(163,254,'2013-12-27','15:22:00','A','000',0,'2014-01-13 03:04:55',NULL,NULL),(13976,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:31',NULL,NULL),(13643,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:43',NULL,NULL),(7782,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:06',NULL,NULL),(12882,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:13',NULL,NULL),(12880,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:12',NULL,NULL),(12135,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:40',NULL,NULL),(20607,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:35',NULL,NULL),(21118,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:07',NULL,NULL),(22703,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:42',NULL,NULL),(8821,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:24',NULL,NULL),(1185,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:08',NULL,NULL),(8426,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:51',NULL,NULL),(15940,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:03',NULL,NULL),(14917,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:24',NULL,NULL),(12521,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:26',NULL,NULL),(17518,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:25',NULL,NULL),(17743,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:45',NULL,NULL),(3153,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:53',NULL,NULL),(1284,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:29',NULL,NULL),(10873,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:03',NULL,NULL),(9766,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:05',NULL,NULL),(10722,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:25',NULL,NULL),(19890,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:52',NULL,NULL),(23056,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(128,307,'2013-12-27','15:37:00','A','000',0,'2014-01-13 03:04:44',NULL,NULL),(4293,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:43',NULL,NULL),(13413,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:09',NULL,NULL),(12796,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:43',NULL,NULL),(11133,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:57',NULL,NULL),(14413,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:04',NULL,NULL),(21105,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:03',NULL,NULL),(127,217,'2013-12-27','15:09:00','A','000',0,'2014-01-13 03:04:44',NULL,NULL),(10988,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:13',NULL,NULL),(10646,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:05',NULL,NULL),(7363,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:31',NULL,NULL),(1464,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:37',NULL,NULL),(6439,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:41',NULL,NULL),(10595,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:51',NULL,NULL),(8464,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:01',NULL,NULL),(8734,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:01',NULL,NULL),(19138,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:48',NULL,NULL),(20258,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:28',NULL,NULL),(20926,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:14',NULL,NULL),(22538,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:01',NULL,NULL),(22561,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:09',NULL,NULL),(11195,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:15',NULL,NULL),(860,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:40',NULL,NULL),(2757,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:32',NULL,NULL),(8933,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:54',NULL,NULL),(8872,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:38',NULL,NULL),(6333,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:12',NULL,NULL),(14669,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:16',NULL,NULL),(14837,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:02',NULL,NULL),(18441,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:57',NULL,NULL),(18456,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:01',NULL,NULL),(21199,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:53',NULL,NULL),(22859,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:39',NULL,NULL),(14205,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:05',NULL,NULL),(6974,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:53',NULL,NULL),(364,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:43',NULL,NULL),(718,1867,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:02:42',NULL,NULL),(1056,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:33',NULL,NULL),(4522,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:43',NULL,NULL),(3996,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:31',NULL,NULL),(14425,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:08',NULL,NULL),(15811,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:16',NULL,NULL),(17983,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:48',NULL,NULL),(20344,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:59',NULL,NULL),(21191,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:50',NULL,NULL),(13620,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:39',NULL,NULL),(7545,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:04',NULL,NULL),(3404,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:10',NULL,NULL),(1388,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:09',NULL,NULL),(1568,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:13',NULL,NULL),(3255,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:30',NULL,NULL),(2171,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:23',NULL,NULL),(5842,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:28',NULL,NULL),(15714,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:09',NULL,NULL),(187,272,'2013-12-27','15:28:00','A','000',0,'2014-01-13 03:05:03',NULL,NULL),(8769,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:10',NULL,NULL),(495,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:28',NULL,NULL),(8500,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:32:10',NULL,NULL),(13964,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:29',NULL,NULL),(13136,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:16',NULL,NULL),(4064,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:49',NULL,NULL),(5184,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:25',NULL,NULL),(12938,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:24',NULL,NULL),(16893,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:31',NULL,NULL),(17931,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:30',NULL,NULL),(18507,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:17',NULL,NULL),(11268,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:36',NULL,NULL),(10493,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:25',NULL,NULL),(3623,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:10',NULL,NULL),(5091,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:14',NULL,NULL),(6862,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:19',NULL,NULL),(2745,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:28',NULL,NULL),(2756,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:32',NULL,NULL),(17939,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:33',NULL,NULL),(19568,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:40',NULL,NULL),(21313,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:34',NULL,NULL),(11305,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:45',NULL,NULL),(9364,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:40',NULL,NULL),(3463,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:26',NULL,NULL),(5353,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:12',NULL,NULL),(2806,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:49',NULL,NULL),(5160,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:18',NULL,NULL),(2905,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:24',NULL,NULL),(20481,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:49',NULL,NULL),(20679,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:03',NULL,NULL),(22147,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:04',NULL,NULL),(23678,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 13:30:02',NULL,NULL),(11515,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:42',NULL,NULL),(6879,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:25',NULL,NULL),(5201,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:29',NULL,NULL),(5117,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:05',NULL,NULL),(17795,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:42',NULL,NULL),(17854,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:03',NULL,NULL),(20920,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:13',NULL,NULL),(22633,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:18',NULL,NULL),(14444,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:13',NULL,NULL),(14113,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:52',NULL,NULL),(9905,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:42',NULL,NULL),(1134,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:54',NULL,NULL),(5406,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:27',NULL,NULL),(5236,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:39',NULL,NULL),(3748,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:29',NULL,NULL),(6392,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:28',NULL,NULL),(16777,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:53',NULL,NULL),(17889,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:16',NULL,NULL),(121,155,'2013-12-27','11:11:00','A','000',0,'2014-01-13 03:04:42',NULL,NULL),(13003,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:41',NULL,NULL),(565,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:51',NULL,NULL),(1332,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:46',NULL,NULL),(1992,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:38',NULL,NULL),(3284,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:38',NULL,NULL),(3290,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:39',NULL,NULL),(12967,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:32',NULL,NULL),(12870,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:08',NULL,NULL),(11778,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:49',NULL,NULL),(6743,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:46',NULL,NULL),(4692,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:23',NULL,NULL),(11528,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:45',NULL,NULL),(6653,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:24',NULL,NULL),(5631,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:15',NULL,NULL),(5704,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:40',NULL,NULL),(23458,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:11',NULL,NULL),(17513,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:23',NULL,NULL),(20803,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:40',NULL,NULL),(4587,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:59',NULL,NULL),(7252,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:31:01',NULL,NULL),(3613,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:07',NULL,NULL),(2465,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:21',NULL,NULL),(2769,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:36',NULL,NULL),(20796,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:38',NULL,NULL),(13915,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:22',NULL,NULL),(12430,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:00',NULL,NULL),(1833,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:35',NULL,NULL),(7062,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:04',NULL,NULL),(7720,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:49',NULL,NULL),(6702,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:36',NULL,NULL),(5515,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:57',NULL,NULL),(7409,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:44',NULL,NULL),(15470,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:46',NULL,NULL),(15616,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:36',NULL,NULL),(17357,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:31',NULL,NULL),(20703,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:12',NULL,NULL),(13989,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:33',NULL,NULL),(9106,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:32',NULL,NULL),(12698,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:16',NULL,NULL),(1515,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:54',NULL,NULL),(8644,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:37',NULL,NULL),(2890,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:19',NULL,NULL),(2998,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:57',NULL,NULL),(8541,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:10',NULL,NULL),(3879,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:02',NULL,NULL),(11979,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:59',NULL,NULL),(5688,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:35',NULL,NULL),(11952,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:49',NULL,NULL),(17559,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:38',NULL,NULL),(21617,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:27',NULL,NULL),(22511,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:52',NULL,NULL),(23406,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:52',NULL,NULL),(283,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:16',NULL,NULL),(5529,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:01',NULL,NULL),(5699,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:39',NULL,NULL),(5738,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:52',NULL,NULL),(1283,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:29',NULL,NULL),(2362,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:54',NULL,NULL),(18041,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:09',NULL,NULL),(20440,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:35',NULL,NULL),(21144,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:14',NULL,NULL),(23522,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-29 15:30:02',NULL,NULL),(14799,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:52',NULL,NULL),(6436,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:40',NULL,NULL),(5927,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:57',NULL,NULL),(14593,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:53',NULL,NULL),(1739,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:12',NULL,NULL),(13900,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:20',NULL,NULL),(3267,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:33',NULL,NULL),(11756,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:43',NULL,NULL),(10883,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:06',NULL,NULL),(20924,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:14',NULL,NULL),(21862,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:18',NULL,NULL),(14151,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:57',NULL,NULL),(8529,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:07',NULL,NULL),(2617,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:00',NULL,NULL),(8098,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:21',NULL,NULL),(4011,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:35',NULL,NULL),(13819,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:08',NULL,NULL),(7532,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:17',NULL,NULL),(5734,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:51',NULL,NULL),(7265,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:04',NULL,NULL),(7242,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:58',NULL,NULL),(12076,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:24',NULL,NULL),(19714,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:06',NULL,NULL),(21272,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:20',NULL,NULL),(14061,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:44',NULL,NULL),(8383,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:40',NULL,NULL),(7313,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:18',NULL,NULL),(4566,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:54',NULL,NULL),(13890,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:18',NULL,NULL),(10262,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:02',NULL,NULL),(11286,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:40',NULL,NULL),(11407,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:15',NULL,NULL),(13625,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:40',NULL,NULL),(18284,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:14',NULL,NULL),(19468,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:12',NULL,NULL),(13637,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:42',NULL,NULL),(1054,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:32',NULL,NULL),(1728,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:09',NULL,NULL),(11500,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:38',NULL,NULL),(2875,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:14',NULL,NULL),(5742,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:54',NULL,NULL),(7557,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:07',NULL,NULL),(7157,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:33',NULL,NULL),(17076,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:23',NULL,NULL),(18711,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:12',NULL,NULL),(19576,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:43',NULL,NULL),(19628,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:57',NULL,NULL),(590,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:59',NULL,NULL),(905,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:52',NULL,NULL),(9538,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:06',NULL,NULL),(1560,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:10',NULL,NULL),(9362,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:40',NULL,NULL),(15122,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:28',NULL,NULL),(11742,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:40',NULL,NULL),(18247,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:03',NULL,NULL),(23052,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:26',NULL,NULL),(23647,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 15:30:01',NULL,NULL),(570,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:52',NULL,NULL),(13932,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:24',NULL,NULL),(1386,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:08',NULL,NULL),(13658,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:45',NULL,NULL),(2320,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:43',NULL,NULL),(12824,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:51',NULL,NULL),(2722,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:20',NULL,NULL),(10995,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:15',NULL,NULL),(4234,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:28',NULL,NULL),(7191,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:42',NULL,NULL),(5123,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:08',NULL,NULL),(16388,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:27',NULL,NULL),(21132,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:11',NULL,NULL),(12157,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:46',NULL,NULL),(504,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:31',NULL,NULL),(11646,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:15',NULL,NULL),(6430,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:38',NULL,NULL),(7449,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:55',NULL,NULL),(16908,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:34',NULL,NULL),(18231,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:13',NULL,NULL),(21014,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:38',NULL,NULL),(22117,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:49',NULL,NULL),(1277,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:27',NULL,NULL),(2823,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:55',NULL,NULL),(6355,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:18',NULL,NULL),(1581,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:18',NULL,NULL),(16193,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:34',NULL,NULL),(16375,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:21',NULL,NULL),(16576,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:37',NULL,NULL),(18376,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:39',NULL,NULL),(21945,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:48',NULL,NULL),(12790,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:41',NULL,NULL),(4219,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:24',NULL,NULL),(3777,1877,'2014-01-14','23:11:00','A','000',0,'2014-01-23 23:00:36',NULL,NULL),(1009,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:20',NULL,NULL),(8344,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:29',NULL,NULL),(15893,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:46',NULL,NULL),(17629,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:05',NULL,NULL),(17941,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:33',NULL,NULL),(13646,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:43',NULL,NULL),(3947,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:19',NULL,NULL),(7568,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:10',NULL,NULL),(6993,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:58',NULL,NULL),(3441,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:20',NULL,NULL),(16092,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:58',NULL,NULL),(20182,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:13',NULL,NULL),(11594,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:01',NULL,NULL),(11389,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:09',NULL,NULL),(605,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:04',NULL,NULL),(10477,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:21',NULL,NULL),(7333,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:23',NULL,NULL),(6096,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:07',NULL,NULL),(4013,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:35',NULL,NULL),(4276,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:39',NULL,NULL),(15581,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:24',NULL,NULL),(15780,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:31',NULL,NULL),(16394,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:29',NULL,NULL),(17704,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:32',NULL,NULL),(18219,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:09',NULL,NULL),(19718,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:07',NULL,NULL),(23582,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 23:30:02',NULL,NULL),(13795,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:05',NULL,NULL),(12259,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:15',NULL,NULL),(635,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:14',NULL,NULL),(1081,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:39',NULL,NULL),(5487,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:31:49',NULL,NULL),(3021,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:06',NULL,NULL),(11780,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:49',NULL,NULL),(11385,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:08',NULL,NULL),(9916,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:44',NULL,NULL),(14981,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:41',NULL,NULL),(16763,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:48',NULL,NULL),(17158,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:50',NULL,NULL),(17662,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:17',NULL,NULL),(18278,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:13',NULL,NULL),(21788,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:52',NULL,NULL),(7849,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:25',NULL,NULL),(436,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:09',NULL,NULL),(13300,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:00',NULL,NULL),(7474,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:02',NULL,NULL),(12542,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:31',NULL,NULL),(7351,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:28',NULL,NULL),(10667,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:12',NULL,NULL),(10375,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:33',NULL,NULL),(9365,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:41',NULL,NULL),(4139,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:04',NULL,NULL),(3873,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:00',NULL,NULL),(23384,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:45',NULL,NULL),(13934,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:24',NULL,NULL),(7146,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:30',NULL,NULL),(6990,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:57',NULL,NULL),(10474,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:21',NULL,NULL),(4948,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:35',NULL,NULL),(10389,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:38',NULL,NULL),(5832,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:25',NULL,NULL),(7905,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:41',NULL,NULL),(20585,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:27',NULL,NULL),(21618,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:27',NULL,NULL),(21669,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:09',NULL,NULL),(22871,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:43',NULL,NULL),(13774,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:02',NULL,NULL),(8151,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:35',NULL,NULL),(5418,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:30',NULL,NULL),(5296,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:57',NULL,NULL),(16588,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:41',NULL,NULL),(16634,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:01',NULL,NULL),(22931,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(1103,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:45',NULL,NULL),(12941,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:25',NULL,NULL),(7727,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:51',NULL,NULL),(1958,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:29',NULL,NULL),(11214,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:21',NULL,NULL),(7652,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:32',NULL,NULL),(4271,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:38',NULL,NULL),(7187,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:41',NULL,NULL),(6881,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:25',NULL,NULL),(14914,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:23',NULL,NULL),(15698,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:03',NULL,NULL),(16251,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:55',NULL,NULL),(17725,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:39',NULL,NULL),(19419,1881,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:00:59',NULL,NULL),(23594,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 15:30:02',NULL,NULL),(12952,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:28',NULL,NULL),(12420,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:21:57',NULL,NULL),(556,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:48',NULL,NULL),(8059,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:11',NULL,NULL),(2779,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:40',NULL,NULL),(2674,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:02',NULL,NULL),(19639,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:02',NULL,NULL),(19680,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:13',NULL,NULL),(20174,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:11',NULL,NULL),(20565,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:19',NULL,NULL),(21413,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:11',NULL,NULL),(6695,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:34',NULL,NULL),(4972,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:41',NULL,NULL),(8289,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:13',NULL,NULL),(16891,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:30',NULL,NULL),(17805,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:46',NULL,NULL),(17905,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:21',NULL,NULL),(18226,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:11',NULL,NULL),(6402,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:31',NULL,NULL),(4716,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:30',NULL,NULL),(14546,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:41',NULL,NULL),(11358,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:01',NULL,NULL),(2590,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:52',NULL,NULL),(11240,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:28',NULL,NULL),(10776,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:39',NULL,NULL),(15105,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:23',NULL,NULL),(15406,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:32',NULL,NULL),(15676,1846,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:56',NULL,NULL),(19072,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:29',NULL,NULL),(22553,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:06',NULL,NULL),(14173,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:00',NULL,NULL),(8778,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:13',NULL,NULL),(7986,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:02',NULL,NULL),(781,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:17',NULL,NULL),(1106,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:46',NULL,NULL),(13018,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:45',NULL,NULL),(11154,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:03',NULL,NULL),(10916,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:15',NULL,NULL),(10034,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:59',NULL,NULL),(2317,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:43',NULL,NULL),(6744,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:46',NULL,NULL),(6038,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:36',NULL,NULL),(14821,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:58',NULL,NULL),(17693,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:28',NULL,NULL),(17971,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:44',NULL,NULL),(22065,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:30',NULL,NULL),(1173,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:05',NULL,NULL),(10478,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:22',NULL,NULL),(13324,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:06',NULL,NULL),(1724,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:08',NULL,NULL),(10975,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:10',NULL,NULL),(6933,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:43',NULL,NULL),(6163,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:27',NULL,NULL),(5441,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:36',NULL,NULL),(9084,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:26',NULL,NULL),(5245,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:42',NULL,NULL),(16417,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:38',NULL,NULL),(16940,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:42',NULL,NULL),(17567,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:41',NULL,NULL),(18801,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:13',NULL,NULL),(20279,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:35',NULL,NULL),(659,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:21',NULL,NULL),(9313,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:27',NULL,NULL),(13826,1849,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:09',NULL,NULL),(6366,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:21',NULL,NULL),(8992,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:02:11',NULL,NULL),(3084,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:30',NULL,NULL),(8804,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:20',NULL,NULL),(15873,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:39',NULL,NULL),(15917,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:54',NULL,NULL),(18752,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:35:59',NULL,NULL),(23106,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:36',NULL,NULL),(23440,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:04',NULL,NULL),(13485,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:20',NULL,NULL),(11664,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:19',NULL,NULL),(16108,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:04',NULL,NULL),(16630,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:59',NULL,NULL),(16910,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:35',NULL,NULL),(18612,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:45',NULL,NULL),(20461,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:42',NULL,NULL),(10581,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:48',NULL,NULL),(9724,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:54',NULL,NULL),(4465,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:29',NULL,NULL),(1868,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:44',NULL,NULL),(8256,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:03',NULL,NULL),(7614,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:22',NULL,NULL),(15228,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:01:58',NULL,NULL),(16138,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:15',NULL,NULL),(16936,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:41',NULL,NULL),(21486,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:38',NULL,NULL),(22596,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:21',NULL,NULL),(23178,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(14854,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:07',NULL,NULL),(13581,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:34',NULL,NULL),(926,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:57',NULL,NULL),(13445,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:14',NULL,NULL),(9193,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:55',NULL,NULL),(12293,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:24',NULL,NULL),(2728,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:00:22',NULL,NULL),(11554,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:51',NULL,NULL),(2904,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:24',NULL,NULL),(11340,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:55',NULL,NULL),(6732,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:43',NULL,NULL),(8360,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:31:34',NULL,NULL),(15201,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:53',NULL,NULL),(16418,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:39',NULL,NULL),(16969,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:49',NULL,NULL),(17293,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:10',NULL,NULL),(21868,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:20',NULL,NULL),(23145,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:43',NULL,NULL),(23434,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:02',NULL,NULL),(9762,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:04',NULL,NULL),(1834,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:35',NULL,NULL),(7095,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:15',NULL,NULL),(14613,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:59',NULL,NULL),(14224,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:08',NULL,NULL),(11461,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:28',NULL,NULL),(17431,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:56',NULL,NULL),(21422,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:14',NULL,NULL),(23683,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 23:30:04',NULL,NULL),(8729,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:59',NULL,NULL),(11547,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:50',NULL,NULL),(11174,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:08',NULL,NULL),(10731,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:28',NULL,NULL),(5402,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:26',NULL,NULL),(9390,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:47',NULL,NULL),(9335,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:33',NULL,NULL),(6404,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:32',NULL,NULL),(15804,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:39',NULL,NULL),(17860,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:06',NULL,NULL),(20316,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:49',NULL,NULL),(22064,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:30',NULL,NULL),(22130,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:53',NULL,NULL),(14020,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:38',NULL,NULL),(9853,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:28',NULL,NULL),(3673,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:09',NULL,NULL),(3976,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:26',NULL,NULL),(4049,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:45',NULL,NULL),(12976,1841,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:26:34',NULL,NULL),(7649,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:31',NULL,NULL),(5626,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:13',NULL,NULL),(5942,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:02',NULL,NULL),(6601,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:10',NULL,NULL),(7570,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:11',NULL,NULL),(11381,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:07',NULL,NULL),(15373,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:26',NULL,NULL),(16208,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:39',NULL,NULL),(18281,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:14',NULL,NULL),(18955,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:57',NULL,NULL),(19352,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:39',NULL,NULL),(20060,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:39',NULL,NULL),(20526,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:05',NULL,NULL),(9823,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:20',NULL,NULL),(11520,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:43',NULL,NULL),(6431,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:39',NULL,NULL),(6382,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:25',NULL,NULL),(3998,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:31',NULL,NULL),(17231,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:15',NULL,NULL),(10410,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:43',NULL,NULL),(17426,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:54',NULL,NULL),(17793,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:41',NULL,NULL),(18028,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:04',NULL,NULL),(18681,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:03',NULL,NULL),(22282,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:40',NULL,NULL),(22965,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(23459,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:11',NULL,NULL),(13200,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:33',NULL,NULL),(11474,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:31',NULL,NULL),(1536,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:01',NULL,NULL),(5502,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:53',NULL,NULL),(3608,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:32:05',NULL,NULL),(7640,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:29',NULL,NULL),(7011,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:03',NULL,NULL),(14307,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:21',NULL,NULL),(15359,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:23',NULL,NULL),(15755,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:22',NULL,NULL),(17427,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:55',NULL,NULL),(18211,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:06',NULL,NULL),(19182,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:38:00',NULL,NULL),(20814,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:43',NULL,NULL),(12192,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:56',NULL,NULL),(6802,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:03',NULL,NULL),(3013,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:03',NULL,NULL),(3092,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:32',NULL,NULL),(3788,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:39',NULL,NULL),(5747,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:55',NULL,NULL),(8473,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:32:03',NULL,NULL),(8658,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:41',NULL,NULL),(10946,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:02',NULL,NULL),(9610,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:25',NULL,NULL),(10827,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:51',NULL,NULL),(19973,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:16',NULL,NULL),(20610,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:36',NULL,NULL),(23620,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 20:00:03',NULL,NULL),(681,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:30',NULL,NULL),(804,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:24',NULL,NULL),(1523,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:57',NULL,NULL),(7814,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:16',NULL,NULL),(7729,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:52',NULL,NULL),(2931,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:33',NULL,NULL),(3259,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:31',NULL,NULL),(11657,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:18',NULL,NULL),(11372,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:02:05',NULL,NULL),(5474,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:45',NULL,NULL),(8568,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:17',NULL,NULL),(16009,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:27',NULL,NULL),(17671,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:21',NULL,NULL),(23699,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 23:30:01',NULL,NULL),(638,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:14',NULL,NULL),(12357,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:44',NULL,NULL),(8072,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:14',NULL,NULL),(11841,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:05',NULL,NULL),(11382,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:07',NULL,NULL),(3771,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:34',NULL,NULL),(9659,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:37',NULL,NULL),(3534,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:45',NULL,NULL),(14849,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:05',NULL,NULL),(14928,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:26',NULL,NULL),(20384,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:14',NULL,NULL),(21215,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:59',NULL,NULL),(21774,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:47',NULL,NULL),(21962,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:54',NULL,NULL),(23588,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 19:30:02',NULL,NULL),(13140,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:18',NULL,NULL),(1327,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:45',NULL,NULL),(8446,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:56',NULL,NULL),(12446,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:05',NULL,NULL),(12074,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:24',NULL,NULL),(10587,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:49',NULL,NULL),(14189,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:03',NULL,NULL),(16087,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:56',NULL,NULL),(16223,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:45',NULL,NULL),(18762,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:02',NULL,NULL),(21443,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:22',NULL,NULL),(22731,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:52',NULL,NULL),(13953,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:27',NULL,NULL),(12353,1823,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:43',NULL,NULL),(3419,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:31:14',NULL,NULL),(5056,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:05',NULL,NULL),(4284,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:41',NULL,NULL),(3509,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:38',NULL,NULL),(14809,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:54',NULL,NULL),(15644,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:45',NULL,NULL),(16789,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:04',NULL,NULL),(20362,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:06',NULL,NULL),(13002,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:41',NULL,NULL),(1188,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:09',NULL,NULL),(12939,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:25',NULL,NULL),(11397,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:11',NULL,NULL),(10254,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:00',NULL,NULL),(10237,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:55',NULL,NULL),(5064,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:07',NULL,NULL),(10039,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:01',NULL,NULL),(17249,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:21',NULL,NULL),(17261,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:25',NULL,NULL),(19286,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:21',NULL,NULL),(6810,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:05',NULL,NULL),(4152,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:07',NULL,NULL),(3457,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:24',NULL,NULL),(6266,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:54',NULL,NULL),(17109,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:34',NULL,NULL),(20598,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:31',NULL,NULL),(23160,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(23612,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 20:00:02',NULL,NULL),(13690,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:49',NULL,NULL),(12767,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:35',NULL,NULL),(7277,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:08',NULL,NULL),(7589,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:15',NULL,NULL),(15880,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:41',NULL,NULL),(16078,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:52',NULL,NULL),(18282,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:14',NULL,NULL),(19134,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:46',NULL,NULL),(19274,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:17',NULL,NULL),(20102,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:52',NULL,NULL),(722,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:44',NULL,NULL),(13443,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:14',NULL,NULL),(2830,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:58',NULL,NULL),(12440,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:03',NULL,NULL),(7083,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:12',NULL,NULL),(3595,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:02',NULL,NULL),(10767,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:36',NULL,NULL),(6251,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:50',NULL,NULL),(6193,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:35',NULL,NULL),(20793,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:37',NULL,NULL),(13105,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:08',NULL,NULL),(8788,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:15',NULL,NULL),(11458,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:27',NULL,NULL),(3719,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:21',NULL,NULL),(9228,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:05',NULL,NULL),(10892,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:09',NULL,NULL),(15435,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:37',NULL,NULL),(18311,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:22',NULL,NULL),(18593,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:40',NULL,NULL),(19067,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:27',NULL,NULL),(20240,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:22',NULL,NULL),(22039,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:21',NULL,NULL),(11228,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:25',NULL,NULL),(1353,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:55',NULL,NULL),(15729,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:14',NULL,NULL),(16621,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:54',NULL,NULL),(20786,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:30:36',NULL,NULL),(23322,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:23',NULL,NULL),(9993,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:48',NULL,NULL),(9124,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:37',NULL,NULL),(2717,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:18',NULL,NULL),(8940,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:56',NULL,NULL),(4459,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:27',NULL,NULL),(5680,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:32',NULL,NULL),(19218,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:02',NULL,NULL),(19257,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:13',NULL,NULL),(21037,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:45',NULL,NULL),(21823,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:05',NULL,NULL),(22359,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:02',NULL,NULL),(14475,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:22',NULL,NULL),(11470,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:30',NULL,NULL),(7320,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:20',NULL,NULL),(6155,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:30:24',NULL,NULL),(10717,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:24',NULL,NULL),(9709,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:50',NULL,NULL),(15032,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:59',NULL,NULL),(17801,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:45',NULL,NULL),(18944,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:52',NULL,NULL),(22235,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:28',NULL,NULL),(12746,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:29',NULL,NULL),(10511,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:30',NULL,NULL),(1264,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:22',NULL,NULL),(4401,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:12',NULL,NULL),(1840,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:37',NULL,NULL),(16704,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:27',NULL,NULL),(17966,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:42',NULL,NULL),(2154,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:19',NULL,NULL),(3543,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:48',NULL,NULL),(16994,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:55',NULL,NULL),(17681,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:24',NULL,NULL),(18655,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:56',NULL,NULL),(19470,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:13',NULL,NULL),(3086,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:30',NULL,NULL),(14566,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:46',NULL,NULL),(9910,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:43',NULL,NULL),(5501,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:53',NULL,NULL),(5667,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:28',NULL,NULL),(15450,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:40',NULL,NULL),(17991,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:50',NULL,NULL),(20133,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:00',NULL,NULL),(21008,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:36',NULL,NULL),(21638,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:35',NULL,NULL),(13302,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:00',NULL,NULL),(11574,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:56',NULL,NULL),(10061,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:07',NULL,NULL),(7386,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:38',NULL,NULL),(3455,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:24',NULL,NULL),(17871,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:09',NULL,NULL),(18896,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:39',NULL,NULL),(19447,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:07',NULL,NULL),(23212,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(23441,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:04',NULL,NULL),(11165,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:06',NULL,NULL),(2447,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:17',NULL,NULL),(2679,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:04',NULL,NULL),(10539,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:38',NULL,NULL),(8189,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:45',NULL,NULL),(9573,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:14',NULL,NULL),(4493,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:35',NULL,NULL),(16493,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:07',NULL,NULL),(16950,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:44',NULL,NULL),(20122,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:57',NULL,NULL),(20656,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:52',NULL,NULL),(8980,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:02:07',NULL,NULL),(14563,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:45',NULL,NULL),(13711,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:53',NULL,NULL),(7208,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:47',NULL,NULL),(2824,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:56',NULL,NULL),(8325,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:24',NULL,NULL),(4831,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:01',NULL,NULL),(5072,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:09',NULL,NULL),(8250,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:01',NULL,NULL),(16071,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:49',NULL,NULL),(17792,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:41',NULL,NULL),(21933,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:44',NULL,NULL),(9423,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:56',NULL,NULL),(13185,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:29',NULL,NULL),(10278,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:07',NULL,NULL),(1826,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:33',NULL,NULL),(4665,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:15',NULL,NULL),(15118,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:27',NULL,NULL),(608,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:05',NULL,NULL),(8259,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:04',NULL,NULL),(4706,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:27',NULL,NULL),(1068,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:36',NULL,NULL),(10684,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:16',NULL,NULL),(11833,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:03',NULL,NULL),(16843,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:18',NULL,NULL),(19166,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:56',NULL,NULL),(20969,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:26',NULL,NULL),(6607,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:12',NULL,NULL),(8809,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:21',NULL,NULL),(8565,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:16',NULL,NULL),(16184,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:31',NULL,NULL),(17053,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:15',NULL,NULL),(17094,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:29',NULL,NULL),(17425,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:54',NULL,NULL),(21163,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:39',NULL,NULL),(21816,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:02',NULL,NULL),(206,183,'2013-12-27','14:52:00','A','000',0,'2014-01-13 03:05:09',NULL,NULL),(14054,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:43',NULL,NULL),(13578,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:34',NULL,NULL),(1228,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:08',NULL,NULL),(9165,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:48',NULL,NULL),(1974,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:33',NULL,NULL),(8865,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:36',NULL,NULL),(2358,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:53',NULL,NULL),(8922,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:51',NULL,NULL),(2694,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:10',NULL,NULL),(6273,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:56',NULL,NULL),(23065,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(13562,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:31',NULL,NULL),(518,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:36',NULL,NULL),(1045,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:31:30',NULL,NULL),(12559,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:36',NULL,NULL),(11073,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:41',NULL,NULL),(4913,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:24',NULL,NULL),(1381,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:07',NULL,NULL),(9354,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:38',NULL,NULL),(19966,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:14',NULL,NULL),(20446,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:37',NULL,NULL),(20999,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:34',NULL,NULL),(8142,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:32',NULL,NULL),(12819,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:50',NULL,NULL),(6362,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:20',NULL,NULL),(10912,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:14',NULL,NULL),(2770,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:37',NULL,NULL),(5469,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:44',NULL,NULL),(6250,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:50',NULL,NULL),(14066,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:44',NULL,NULL),(15474,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:47',NULL,NULL),(13472,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:18',NULL,NULL),(373,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:46',NULL,NULL),(2920,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:29',NULL,NULL),(5228,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:30:37',NULL,NULL),(8945,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:57',NULL,NULL),(9495,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:55',NULL,NULL),(9979,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:44',NULL,NULL),(10941,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:21',NULL,NULL),(11052,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:32',NULL,NULL),(19356,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:41',NULL,NULL),(19950,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:08',NULL,NULL),(20008,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:25',NULL,NULL),(22728,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:51',NULL,NULL),(23499,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:25',NULL,NULL),(1956,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:28',NULL,NULL),(2412,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:07',NULL,NULL),(13816,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:08',NULL,NULL),(13467,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:17',NULL,NULL),(15594,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:28',NULL,NULL),(17406,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:48',NULL,NULL),(18649,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:55',NULL,NULL),(19743,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:13',NULL,NULL),(20431,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:31',NULL,NULL),(22843,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:33',NULL,NULL),(23576,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 11:30:02',NULL,NULL),(12395,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:54',NULL,NULL),(8396,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:43',NULL,NULL),(13340,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:10',NULL,NULL),(8562,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:15',NULL,NULL),(7866,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:31',NULL,NULL),(5768,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:03',NULL,NULL),(7140,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:29',NULL,NULL),(2860,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:08',NULL,NULL),(3362,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:59',NULL,NULL),(14146,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:57',NULL,NULL),(16068,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:48',NULL,NULL),(20075,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:44',NULL,NULL),(21458,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:27',NULL,NULL),(21749,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:38',NULL,NULL),(22488,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:45',NULL,NULL),(22586,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:17',NULL,NULL),(22989,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:14',NULL,NULL),(264,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:10',NULL,NULL),(3112,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:39',NULL,NULL),(2343,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:49',NULL,NULL),(2116,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:09',NULL,NULL),(15772,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:29',NULL,NULL),(22734,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:53',NULL,NULL),(23684,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 01:30:03',NULL,NULL),(13526,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:27',NULL,NULL),(2374,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:57',NULL,NULL),(2833,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:59',NULL,NULL),(1910,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:54',NULL,NULL),(18260,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:07',NULL,NULL),(20554,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:16',NULL,NULL),(20650,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:50',NULL,NULL),(10823,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:50',NULL,NULL),(10694,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:18',NULL,NULL),(9336,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:33',NULL,NULL),(946,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:03',NULL,NULL),(3765,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:33',NULL,NULL),(1980,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:34',NULL,NULL),(2601,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:55',NULL,NULL),(4606,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:04',NULL,NULL),(15042,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:02',NULL,NULL),(22225,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:26',NULL,NULL),(8368,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:36',NULL,NULL),(13482,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:20',NULL,NULL),(12535,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:29',NULL,NULL),(10782,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:40',NULL,NULL),(8978,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:07',NULL,NULL),(9681,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:43',NULL,NULL),(68,173,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:04',NULL,NULL),(11156,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:03',NULL,NULL),(9977,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:44',NULL,NULL),(6660,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:25',NULL,NULL),(8208,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:50',NULL,NULL),(6657,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:25',NULL,NULL),(5573,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:15',NULL,NULL),(5363,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:15',NULL,NULL),(3342,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:53',NULL,NULL),(3498,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:35',NULL,NULL),(5110,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:03',NULL,NULL),(6182,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:32',NULL,NULL),(16169,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:26',NULL,NULL),(18210,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:06',NULL,NULL),(23284,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:09',NULL,NULL),(8202,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:49',NULL,NULL),(11892,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:18',NULL,NULL),(9543,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:07',NULL,NULL),(8993,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:11',NULL,NULL),(15565,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:19',NULL,NULL),(15576,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:22',NULL,NULL),(16513,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:14',NULL,NULL),(17758,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:28',NULL,NULL),(18134,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:40',NULL,NULL),(18498,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:14',NULL,NULL),(21756,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:41',NULL,NULL),(12470,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:11',NULL,NULL),(11225,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:24',NULL,NULL),(10391,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:38',NULL,NULL),(10083,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:13',NULL,NULL),(6752,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:48',NULL,NULL),(8002,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:02:06',NULL,NULL),(14790,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:49',NULL,NULL),(17583,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:47',NULL,NULL),(18447,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:58',NULL,NULL),(19832,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:37',NULL,NULL),(20357,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:04',NULL,NULL),(22904,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:54',NULL,NULL),(8966,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:03',NULL,NULL),(7573,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:11',NULL,NULL),(7001,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:01',NULL,NULL),(12592,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:45',NULL,NULL),(6124,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:15',NULL,NULL),(11761,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:44',NULL,NULL),(9769,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:06',NULL,NULL),(16080,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:53',NULL,NULL),(19338,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:35',NULL,NULL),(22025,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:15',NULL,NULL),(22788,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:14',NULL,NULL),(23407,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:52',NULL,NULL),(38,164,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:36',NULL,NULL),(8881,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:40',NULL,NULL),(13762,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:00',NULL,NULL),(5760,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:00',NULL,NULL),(1782,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:23',NULL,NULL),(8430,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:52',NULL,NULL),(3066,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:23',NULL,NULL),(19869,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:46',NULL,NULL),(20244,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:23',NULL,NULL),(14138,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:55',NULL,NULL),(10075,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:11',NULL,NULL),(7639,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:28',NULL,NULL),(8682,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:47',NULL,NULL),(5372,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:17',NULL,NULL),(3269,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:33',NULL,NULL),(9279,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:18',NULL,NULL),(4900,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:20',NULL,NULL),(4476,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:31',NULL,NULL),(4590,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:32:00',NULL,NULL),(4816,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:57',NULL,NULL),(17947,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:36',NULL,NULL),(23069,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:29',NULL,NULL),(23171,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:48',NULL,NULL),(14881,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:14',NULL,NULL),(13051,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:54',NULL,NULL),(285,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:17',NULL,NULL),(4304,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:46',NULL,NULL),(11297,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:43',NULL,NULL),(10586,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:49',NULL,NULL),(4058,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:47',NULL,NULL),(2285,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:34',NULL,NULL),(16180,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:30',NULL,NULL),(16489,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:06',NULL,NULL),(17252,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:32:22',NULL,NULL),(17299,1873,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:12',NULL,NULL),(19544,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:01:33',NULL,NULL),(20455,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:40',NULL,NULL),(7116,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:22',NULL,NULL),(14548,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:41',NULL,NULL),(5957,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:07',NULL,NULL),(3514,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:40',NULL,NULL),(3364,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:59',NULL,NULL),(22215,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:23',NULL,NULL),(23631,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 14:00:03',NULL,NULL),(23644,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 08:30:02',NULL,NULL),(7676,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:38',NULL,NULL),(1925,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:58',NULL,NULL),(6644,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:21',NULL,NULL),(4531,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:45',NULL,NULL),(6485,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:53',NULL,NULL),(12101,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:31',NULL,NULL),(14217,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:07',NULL,NULL),(10993,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:15',NULL,NULL),(19223,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:04',NULL,NULL),(20358,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:04',NULL,NULL),(20503,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:57',NULL,NULL),(11498,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:37',NULL,NULL),(11222,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:23',NULL,NULL),(10031,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:58',NULL,NULL),(1878,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:46',NULL,NULL),(5713,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:44',NULL,NULL),(4887,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:16',NULL,NULL),(6106,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:10',NULL,NULL),(3376,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:03',NULL,NULL),(6457,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:46',NULL,NULL),(16533,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:21',NULL,NULL),(16832,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:15',NULL,NULL),(22201,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:19',NULL,NULL),(7249,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:00',NULL,NULL),(1419,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:20',NULL,NULL),(10660,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:09',NULL,NULL),(1793,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:25',NULL,NULL),(5541,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:05',NULL,NULL),(4157,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:08',NULL,NULL),(4081,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:53',NULL,NULL),(15724,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:12',NULL,NULL),(15925,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:57',NULL,NULL),(18434,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:55',NULL,NULL),(19202,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:38:06',NULL,NULL),(20725,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:19',NULL,NULL),(22682,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:34',NULL,NULL),(9156,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:46',NULL,NULL),(13680,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:47',NULL,NULL),(1876,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:46',NULL,NULL),(3380,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:04',NULL,NULL),(4091,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:56',NULL,NULL),(10527,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:34',NULL,NULL),(4609,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:32:04',NULL,NULL),(5294,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:56',NULL,NULL),(6651,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:23',NULL,NULL),(23303,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:16',NULL,NULL),(23428,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:59',NULL,NULL),(23624,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 14:00:02',NULL,NULL),(14879,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:13',NULL,NULL),(9528,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:03',NULL,NULL),(7150,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:31',NULL,NULL),(5503,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:53',NULL,NULL),(13739,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:57',NULL,NULL),(15947,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:05',NULL,NULL),(16364,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:17',NULL,NULL),(18435,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:55',NULL,NULL),(18611,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:45',NULL,NULL),(16074,1852,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:15:50',NULL,NULL),(8671,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:44',NULL,NULL),(3994,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:30',NULL,NULL),(9439,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:01',NULL,NULL),(3840,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:52',NULL,NULL),(1578,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:16',NULL,NULL),(2306,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:40',NULL,NULL),(8999,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:02',NULL,NULL),(6851,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:16',NULL,NULL),(7405,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:43',NULL,NULL),(18201,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:02',NULL,NULL),(11020,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:22',NULL,NULL),(4205,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:21',NULL,NULL),(5001,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:50',NULL,NULL),(5140,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:13',NULL,NULL),(10380,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:35',NULL,NULL),(16755,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:46',NULL,NULL),(17439,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:58',NULL,NULL),(17874,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:11',NULL,NULL),(18893,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:38',NULL,NULL),(19737,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:12',NULL,NULL),(22810,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:22',NULL,NULL),(22963,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(13259,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:49',NULL,NULL),(1373,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:04',NULL,NULL),(11265,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:35',NULL,NULL),(5171,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:21',NULL,NULL),(16699,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:26',NULL,NULL),(18492,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:12',NULL,NULL),(21002,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:35',NULL,NULL),(22378,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:08',NULL,NULL),(22766,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:05',NULL,NULL),(14053,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:43',NULL,NULL),(8490,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:08',NULL,NULL),(7966,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:57',NULL,NULL),(10692,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:18',NULL,NULL),(2523,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:36',NULL,NULL),(7607,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:20',NULL,NULL),(10158,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:34',NULL,NULL),(4084,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:54',NULL,NULL),(20541,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:11',NULL,NULL),(9720,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:53',NULL,NULL),(9342,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:35',NULL,NULL),(8407,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:46',NULL,NULL),(7235,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:56',NULL,NULL),(6765,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:52',NULL,NULL),(14261,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:14',NULL,NULL),(2231,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:21',NULL,NULL),(14256,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:13',NULL,NULL),(3227,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:22',NULL,NULL),(5039,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:00',NULL,NULL),(13949,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:27',NULL,NULL),(16575,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:36',NULL,NULL),(17836,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:57',NULL,NULL),(23068,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:29',NULL,NULL),(15353,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:22',NULL,NULL),(13817,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:08',NULL,NULL),(13258,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:49',NULL,NULL),(9966,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:57',NULL,NULL),(5409,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:28',NULL,NULL),(9340,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:34',NULL,NULL),(7540,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:03',NULL,NULL),(10358,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:29',NULL,NULL),(15866,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:36',NULL,NULL),(16465,1884,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:18:56',NULL,NULL),(21020,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:40',NULL,NULL),(22528,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:58',NULL,NULL),(15328,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:17',NULL,NULL),(14581,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:50',NULL,NULL),(14269,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:32:15',NULL,NULL),(13518,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:25',NULL,NULL),(11296,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:43',NULL,NULL),(4368,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:03',NULL,NULL),(5307,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:00',NULL,NULL),(16823,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:12',NULL,NULL),(17484,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:13',NULL,NULL),(20318,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:50',NULL,NULL),(12934,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:23',NULL,NULL),(12634,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:57',NULL,NULL),(12504,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:21',NULL,NULL),(12173,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:50',NULL,NULL),(7998,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:05',NULL,NULL),(6315,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:07',NULL,NULL),(3390,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:06',NULL,NULL),(5229,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:37',NULL,NULL),(4057,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:47',NULL,NULL),(11964,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:53',NULL,NULL),(16350,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:12',NULL,NULL),(18914,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:44',NULL,NULL),(19654,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:06',NULL,NULL),(20268,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:32',NULL,NULL),(21603,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:22',NULL,NULL),(23029,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(11603,1889,'2014-01-14','23:11:00','A','000',0,'2014-01-24 05:15:04',NULL,NULL),(10563,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:44',NULL,NULL),(6781,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:57',NULL,NULL),(16871,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:25',NULL,NULL),(17043,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:12',NULL,NULL),(21206,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:55',NULL,NULL),(21745,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:37',NULL,NULL),(22220,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:24',NULL,NULL),(23186,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:51',NULL,NULL),(14586,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:51',NULL,NULL),(2907,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:25',NULL,NULL),(10290,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:10',NULL,NULL),(2413,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:08',NULL,NULL),(2082,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:01',NULL,NULL),(8679,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:46',NULL,NULL),(18921,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:46',NULL,NULL),(22296,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:43',NULL,NULL),(9819,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:19',NULL,NULL),(361,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:42',NULL,NULL),(13704,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:52',NULL,NULL),(11583,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:59',NULL,NULL),(7510,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:12',NULL,NULL),(5156,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:17',NULL,NULL),(19339,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:36',NULL,NULL),(20419,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:27',NULL,NULL),(23385,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:45',NULL,NULL),(174,273,'2013-12-27','15:29:00','A','000',0,'2014-01-13 03:04:59',NULL,NULL),(10442,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:52',NULL,NULL),(2206,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:07',NULL,NULL),(9195,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:56',NULL,NULL),(9019,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:08',NULL,NULL),(8854,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:33',NULL,NULL),(15613,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:35',NULL,NULL),(4309,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:47',NULL,NULL),(4500,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:37',NULL,NULL),(17348,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:29',NULL,NULL),(19204,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:38:06',NULL,NULL),(23038,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(59,360,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:55',NULL,NULL),(14522,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:34',NULL,NULL),(11844,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:06',NULL,NULL),(4432,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:20',NULL,NULL),(5788,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:09',NULL,NULL),(18091,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:26',NULL,NULL),(18872,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:32',NULL,NULL),(20131,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:00',NULL,NULL),(21104,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:03',NULL,NULL),(1257,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:19',NULL,NULL),(16595,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:44',NULL,NULL),(15503,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:57',NULL,NULL),(2767,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:36',NULL,NULL),(15372,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:25',NULL,NULL),(2960,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:44',NULL,NULL),(5316,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:02',NULL,NULL),(15260,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:04',NULL,NULL),(7689,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:00:42',NULL,NULL),(13130,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:15',NULL,NULL),(10952,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:03',NULL,NULL),(9199,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:57',NULL,NULL),(10043,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:02',NULL,NULL),(19272,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:17',NULL,NULL),(20076,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:44',NULL,NULL),(15320,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:16',NULL,NULL),(4934,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:30',NULL,NULL),(11933,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:44',NULL,NULL),(9341,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:34',NULL,NULL),(1571,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:14',NULL,NULL),(16805,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:08',NULL,NULL),(17443,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:00',NULL,NULL),(17706,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:33',NULL,NULL),(18113,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:33',NULL,NULL),(18412,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:49',NULL,NULL),(18584,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:37',NULL,NULL),(417,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:03',NULL,NULL),(874,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:43',NULL,NULL),(14116,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:52',NULL,NULL),(9041,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:13',NULL,NULL),(8853,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:33',NULL,NULL),(2331,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:46',NULL,NULL),(8150,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:34',NULL,NULL),(5851,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:31',NULL,NULL),(16996,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:56',NULL,NULL),(20911,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:10',NULL,NULL),(22011,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:11',NULL,NULL),(15335,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:18',NULL,NULL),(14638,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:08',NULL,NULL),(11988,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:01',NULL,NULL),(5676,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:31',NULL,NULL),(9394,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:48',NULL,NULL),(19907,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:56',NULL,NULL),(52,378,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:49',NULL,NULL),(16037,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:37',NULL,NULL),(14736,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:34',NULL,NULL),(14374,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:52',NULL,NULL),(13873,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:16',NULL,NULL),(4133,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:02',NULL,NULL),(6852,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:17',NULL,NULL),(6942,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:45',NULL,NULL),(10078,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:12',NULL,NULL),(10131,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:26',NULL,NULL),(19094,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:35',NULL,NULL),(19787,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:25',NULL,NULL),(19824,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:35',NULL,NULL),(22708,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:44',NULL,NULL),(22831,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:30',NULL,NULL),(23204,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(41,313,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:39',NULL,NULL),(5262,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:46',NULL,NULL),(13097,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:06',NULL,NULL),(9772,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:06',NULL,NULL),(4331,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:53',NULL,NULL),(8026,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:30:02',NULL,NULL),(18845,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:25',NULL,NULL),(18850,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:26',NULL,NULL),(19729,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:10',NULL,NULL),(21019,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:39',NULL,NULL),(21265,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:17',NULL,NULL),(23064,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(820,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:29',NULL,NULL),(1093,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:43',NULL,NULL),(1349,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:00:54',NULL,NULL),(3858,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:56',NULL,NULL),(17002,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:58',NULL,NULL),(3392,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:07',NULL,NULL),(15671,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:54',NULL,NULL),(13938,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:25',NULL,NULL),(7311,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:17',NULL,NULL),(7561,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:08',NULL,NULL),(7940,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:50',NULL,NULL),(8688,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:49',NULL,NULL),(10513,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:30',NULL,NULL),(8738,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:02',NULL,NULL),(10147,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:31',NULL,NULL),(22856,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:38',NULL,NULL),(23097,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(751,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:09',NULL,NULL),(4833,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:01',NULL,NULL),(15600,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:30',NULL,NULL),(13879,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:17',NULL,NULL),(11212,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:21',NULL,NULL),(7240,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:58',NULL,NULL),(18289,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:16',NULL,NULL),(20142,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:03',NULL,NULL),(21036,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:44',NULL,NULL),(101,339,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:34',NULL,NULL),(421,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:04',NULL,NULL),(4762,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:42',NULL,NULL),(4707,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:27',NULL,NULL),(14443,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:13',NULL,NULL),(13999,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:35',NULL,NULL),(969,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:09',NULL,NULL),(4097,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:57',NULL,NULL),(13725,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:55',NULL,NULL),(13069,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:58',NULL,NULL),(6420,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:36',NULL,NULL),(12669,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:06',NULL,NULL),(17565,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:41',NULL,NULL),(18255,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:05',NULL,NULL),(19165,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:56',NULL,NULL),(19560,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:38',NULL,NULL),(19715,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:06',NULL,NULL),(21963,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:54',NULL,NULL),(22263,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:35',NULL,NULL),(22494,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:47',NULL,NULL),(13414,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:09',NULL,NULL),(4198,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:19',NULL,NULL),(7414,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:45',NULL,NULL),(6590,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:08',NULL,NULL),(19459,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:10',NULL,NULL),(22026,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:16',NULL,NULL),(404,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:59',NULL,NULL),(1730,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:10',NULL,NULL),(16939,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:42',NULL,NULL),(15473,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:46',NULL,NULL),(23267,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(23350,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:33',NULL,NULL),(11075,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:42',NULL,NULL),(2355,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:52',NULL,NULL),(10376,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:34',NULL,NULL),(8543,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:10',NULL,NULL),(16007,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:26',NULL,NULL),(20331,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:54',NULL,NULL),(20587,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:27',NULL,NULL),(9625,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:28',NULL,NULL),(14004,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:35',NULL,NULL),(4378,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:06',NULL,NULL),(8350,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:31',NULL,NULL),(2553,1878,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:31:43',NULL,NULL),(8161,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:37',NULL,NULL),(18096,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:27',NULL,NULL),(19572,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:42',NULL,NULL),(20478,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:48',NULL,NULL),(20492,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:53',NULL,NULL),(21551,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:02',NULL,NULL),(15719,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:10',NULL,NULL),(15080,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:14',NULL,NULL),(13424,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:11',NULL,NULL),(1528,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:59',NULL,NULL),(4366,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:03',NULL,NULL),(10023,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:56',NULL,NULL),(3046,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:16',NULL,NULL),(4400,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:11',NULL,NULL),(18107,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:31',NULL,NULL),(22752,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:59',NULL,NULL),(15995,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:22',NULL,NULL),(9067,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:21',NULL,NULL),(1669,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:49',NULL,NULL),(15416,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:34',NULL,NULL),(2760,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:33',NULL,NULL),(8191,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:46',NULL,NULL),(15358,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:23',NULL,NULL),(14579,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:50',NULL,NULL),(10662,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:10',NULL,NULL),(5805,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:15',NULL,NULL),(10624,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:59',NULL,NULL),(7081,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:11',NULL,NULL),(6678,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:30',NULL,NULL),(18411,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:49',NULL,NULL),(20086,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:47',NULL,NULL),(20621,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:40',NULL,NULL),(21977,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:59',NULL,NULL),(15520,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:03',NULL,NULL),(13019,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:45',NULL,NULL),(468,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:19',NULL,NULL),(3974,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:26',NULL,NULL),(6957,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:49',NULL,NULL),(4886,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:16',NULL,NULL),(1709,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:05',NULL,NULL),(16210,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:40',NULL,NULL),(16858,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:22',NULL,NULL),(18090,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:25',NULL,NULL),(19945,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:07',NULL,NULL),(20322,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:51',NULL,NULL),(21525,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:53',NULL,NULL),(21870,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:21',NULL,NULL),(15511,1851,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:01',NULL,NULL),(10304,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:41:14',NULL,NULL),(10215,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:49',NULL,NULL),(9523,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:02',NULL,NULL),(2403,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:05',NULL,NULL),(14921,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:24',NULL,NULL),(14464,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:19',NULL,NULL),(10828,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:51',NULL,NULL),(10766,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:36',NULL,NULL),(17120,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:38',NULL,NULL),(19273,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:17',NULL,NULL),(22268,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:36',NULL,NULL),(16163,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:24',NULL,NULL),(13962,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:29',NULL,NULL),(9997,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:50',NULL,NULL),(8681,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:47',NULL,NULL),(1328,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:45',NULL,NULL),(8342,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:29',NULL,NULL),(1500,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:49',NULL,NULL),(5324,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:05',NULL,NULL),(2765,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:35',NULL,NULL),(2978,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:50',NULL,NULL),(10758,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:34',NULL,NULL),(11387,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:09',NULL,NULL),(17223,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:12',NULL,NULL),(17401,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:46',NULL,NULL),(17881,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:13',NULL,NULL),(18496,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:14',NULL,NULL),(19926,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:01',NULL,NULL),(20424,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:28',NULL,NULL),(22002,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:08',NULL,NULL),(22047,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:24',NULL,NULL),(14633,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:06',NULL,NULL),(11902,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:20',NULL,NULL),(10409,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:43',NULL,NULL),(8011,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:08',NULL,NULL),(1995,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:38',NULL,NULL),(2300,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:38',NULL,NULL),(2313,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:42',NULL,NULL),(10751,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:32',NULL,NULL),(7850,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:25',NULL,NULL),(2549,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:42',NULL,NULL),(7624,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:25',NULL,NULL),(17888,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:15',NULL,NULL),(18592,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:40',NULL,NULL),(20571,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:21',NULL,NULL),(22489,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:45',NULL,NULL),(15876,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:40',NULL,NULL),(5588,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:19',NULL,NULL),(8041,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:06',NULL,NULL),(2819,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:54',NULL,NULL),(6466,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:48',NULL,NULL),(2497,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:29',NULL,NULL),(17487,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:14',NULL,NULL),(18119,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:35',NULL,NULL),(20194,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:05',NULL,NULL),(21721,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:28',NULL,NULL),(902,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:51',NULL,NULL),(1383,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:07',NULL,NULL),(1715,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:06',NULL,NULL),(15072,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:12',NULL,NULL),(11463,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:29',NULL,NULL),(18421,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:51',NULL,NULL),(18605,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:43',NULL,NULL),(22206,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:20',NULL,NULL),(15058,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:07',NULL,NULL),(14796,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:51',NULL,NULL),(6000,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:23',NULL,NULL),(10936,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:19',NULL,NULL),(6563,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:14',NULL,NULL),(7075,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:09',NULL,NULL),(7818,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:17',NULL,NULL),(9863,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:31',NULL,NULL),(10214,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:49',NULL,NULL),(16648,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:07',NULL,NULL),(19750,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:15',NULL,NULL),(23414,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:55',NULL,NULL),(2006,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:41',NULL,NULL),(16104,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:03',NULL,NULL),(15035,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:59',NULL,NULL),(6703,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:36',NULL,NULL),(7181,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:40',NULL,NULL),(12302,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:27',NULL,NULL),(8429,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:52',NULL,NULL),(12254,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:13',NULL,NULL),(16854,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:21',NULL,NULL),(18058,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:14',NULL,NULL),(21491,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:40',NULL,NULL),(21768,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:45',NULL,NULL),(22940,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:05',NULL,NULL),(15778,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:31',NULL,NULL),(5138,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:12',NULL,NULL),(1120,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:50',NULL,NULL),(1127,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:52',NULL,NULL),(3839,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:52',NULL,NULL),(15070,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:11',NULL,NULL),(3185,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:09',NULL,NULL),(7760,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:00',NULL,NULL),(7800,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:11',NULL,NULL),(12987,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:37',NULL,NULL),(9721,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:53',NULL,NULL),(10738,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:29',NULL,NULL),(10311,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:16',NULL,NULL),(10630,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:45:00',NULL,NULL),(17200,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:04',NULL,NULL),(15722,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:11',NULL,NULL),(11887,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:16',NULL,NULL),(2404,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:05',NULL,NULL),(3616,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:08',NULL,NULL),(795,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:21',NULL,NULL),(18713,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:12',NULL,NULL),(19855,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:43',NULL,NULL),(20006,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:25',NULL,NULL),(20341,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:58',NULL,NULL),(22516,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:54',NULL,NULL),(16242,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:52',NULL,NULL),(15710,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:07',NULL,NULL),(12878,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:12',NULL,NULL),(4621,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:02',NULL,NULL),(12519,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:25',NULL,NULL),(4173,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:12',NULL,NULL),(8088,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:18',NULL,NULL),(20584,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:26',NULL,NULL),(13465,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:17',NULL,NULL),(2744,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:28',NULL,NULL),(3604,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:04',NULL,NULL),(6572,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:03',NULL,NULL),(12865,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:06',NULL,NULL),(7983,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:01',NULL,NULL),(8664,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:42',NULL,NULL),(9393,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:48',NULL,NULL),(9409,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:52',NULL,NULL),(9990,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:47',NULL,NULL),(18875,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:33',NULL,NULL),(19145,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:50',NULL,NULL),(20557,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:17',NULL,NULL),(16244,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:52',NULL,NULL),(11190,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:13',NULL,NULL),(4499,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:37',NULL,NULL),(7227,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:54',NULL,NULL),(2649,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:08',NULL,NULL),(20295,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:42',NULL,NULL),(20543,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:12',NULL,NULL),(22574,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:14',NULL,NULL),(22698,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:40',NULL,NULL),(15173,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:46',NULL,NULL),(15075,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:12',NULL,NULL),(1506,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:51',NULL,NULL),(11828,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:01',NULL,NULL),(10243,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:57',NULL,NULL),(9018,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:07',NULL,NULL),(6906,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:33',NULL,NULL),(9000,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:03',NULL,NULL),(22053,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:26',NULL,NULL),(12368,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:47',NULL,NULL),(11398,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:12',NULL,NULL),(11271,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:01:36',NULL,NULL),(2347,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:50',NULL,NULL),(2886,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:17',NULL,NULL),(10166,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:36',NULL,NULL),(9191,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:55',NULL,NULL),(9383,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:45',NULL,NULL),(17584,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:47',NULL,NULL),(19578,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:43',NULL,NULL),(21296,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:28',NULL,NULL),(21956,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:52',NULL,NULL),(18455,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:01',NULL,NULL),(16780,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:54',NULL,NULL),(15188,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:50',NULL,NULL),(12268,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:17',NULL,NULL),(11323,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:50',NULL,NULL),(10429,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:49',NULL,NULL),(4086,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:55',NULL,NULL),(17981,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:47',NULL,NULL),(18682,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:04',NULL,NULL),(21303,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:31',NULL,NULL),(21827,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:01:06',NULL,NULL),(16302,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:55',NULL,NULL),(15933,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:00',NULL,NULL),(15187,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:50',NULL,NULL),(1991,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:37',NULL,NULL),(8244,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:00',NULL,NULL),(14660,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:13',NULL,NULL),(10164,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:35',NULL,NULL),(12283,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:21',NULL,NULL),(10783,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:40',NULL,NULL),(21676,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:12',NULL,NULL),(18208,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:05',NULL,NULL),(19300,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:25',NULL,NULL),(22464,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:37',NULL,NULL),(22626,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:16',NULL,NULL),(1442,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:28',NULL,NULL),(12891,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:16',NULL,NULL),(12729,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:25',NULL,NULL),(10152,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:32',NULL,NULL),(6340,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:13',NULL,NULL),(20517,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:02',NULL,NULL),(20767,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:30',NULL,NULL),(21886,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:27',NULL,NULL),(22370,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:06',NULL,NULL),(23581,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 22:30:02',NULL,NULL),(15915,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:54',NULL,NULL),(2294,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:37',NULL,NULL),(3031,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:09',NULL,NULL),(9964,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:57',NULL,NULL),(4175,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:13',NULL,NULL),(8159,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:37',NULL,NULL),(14398,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:59',NULL,NULL),(7210,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:47',NULL,NULL),(7192,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:42',NULL,NULL),(14208,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:06',NULL,NULL),(12170,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:49',NULL,NULL),(13129,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:15',NULL,NULL),(21496,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:42',NULL,NULL),(23437,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:03',NULL,NULL),(15670,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:54',NULL,NULL),(14503,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:29',NULL,NULL),(9561,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:12',NULL,NULL),(13749,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:58',NULL,NULL),(13572,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:33',NULL,NULL),(2632,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:04',NULL,NULL),(10370,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:32',NULL,NULL),(8864,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:35',NULL,NULL),(523,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:37',NULL,NULL),(5889,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:44',NULL,NULL),(14196,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:04',NULL,NULL),(5364,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:15',NULL,NULL),(13338,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:10',NULL,NULL),(3904,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:09',NULL,NULL),(13279,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:54',NULL,NULL),(12570,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:39',NULL,NULL),(16566,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:33',NULL,NULL),(20452,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:39',NULL,NULL),(22107,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:45',NULL,NULL),(13014,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:44',NULL,NULL),(1502,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:50',NULL,NULL),(1551,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:07',NULL,NULL),(4248,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:31',NULL,NULL),(6664,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:26',NULL,NULL),(18396,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:45',NULL,NULL),(20570,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:21',NULL,NULL),(9587,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:19',NULL,NULL),(14725,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:31',NULL,NULL),(7822,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:18',NULL,NULL),(7575,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:12',NULL,NULL),(5871,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:38',NULL,NULL),(3905,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:09',NULL,NULL),(5331,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:06',NULL,NULL),(17390,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:00:43',NULL,NULL),(17958,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:39',NULL,NULL),(18084,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:23',NULL,NULL),(18464,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:04',NULL,NULL),(19140,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:48',NULL,NULL),(20789,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:36',NULL,NULL),(23658,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 22:00:00',NULL,NULL),(15097,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:20',NULL,NULL),(14167,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:59',NULL,NULL),(4159,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:09',NULL,NULL),(13245,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:45',NULL,NULL),(4093,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:56',NULL,NULL),(3742,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:27',NULL,NULL),(11555,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:52',NULL,NULL),(12453,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:07',NULL,NULL),(16642,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:04',NULL,NULL),(17016,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:03',NULL,NULL),(18764,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:02',NULL,NULL),(15148,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:37',NULL,NULL),(5463,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:42',NULL,NULL),(1478,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:41',NULL,NULL),(15073,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:12',NULL,NULL),(10903,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:11',NULL,NULL),(16799,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:06',NULL,NULL),(17478,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:11',NULL,NULL),(17670,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:20',NULL,NULL),(21416,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:12',NULL,NULL),(13539,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:28',NULL,NULL),(4262,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:35',NULL,NULL),(5557,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:10',NULL,NULL),(9888,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:37',NULL,NULL),(2676,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:03',NULL,NULL),(19119,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:42',NULL,NULL),(21913,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:37',NULL,NULL),(22560,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:09',NULL,NULL),(15124,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:29',NULL,NULL),(1541,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:03',NULL,NULL),(1634,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:36',NULL,NULL),(1948,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:03',NULL,NULL),(13419,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:10',NULL,NULL),(12347,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:42',NULL,NULL),(3702,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:17',NULL,NULL),(5733,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:51',NULL,NULL),(10248,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:58',NULL,NULL),(17473,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:09',NULL,NULL),(9211,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:00',NULL,NULL),(14384,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:55',NULL,NULL),(11507,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:40',NULL,NULL),(5555,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:09',NULL,NULL),(5387,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:22',NULL,NULL),(6641,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:00:21',NULL,NULL),(18767,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:03',NULL,NULL),(21069,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:53',NULL,NULL),(16966,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:48',NULL,NULL),(223,263,'2013-12-27','15:25:00','A','000',0,'2014-01-13 03:05:15',NULL,NULL),(479,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:23',NULL,NULL),(16825,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:13',NULL,NULL),(526,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:38',NULL,NULL),(16735,1890,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:20:38',NULL,NULL),(15443,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:39',NULL,NULL),(14958,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:34',NULL,NULL),(10213,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:48',NULL,NULL),(14015,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:37',NULL,NULL),(9937,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:50',NULL,NULL),(3979,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-23 23:01:27',NULL,NULL),(11976,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:58',NULL,NULL),(5976,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:15',NULL,NULL),(18950,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:54',NULL,NULL),(21304,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:31',NULL,NULL),(7813,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:16',NULL,NULL),(1209,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:14',NULL,NULL),(9703,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:49',NULL,NULL),(16782,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:55',NULL,NULL),(13757,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:00',NULL,NULL),(4154,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:08',NULL,NULL),(5109,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:02',NULL,NULL),(1674,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:02:51',NULL,NULL),(14011,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:37',NULL,NULL),(5593,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:01',NULL,NULL),(12498,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:19',NULL,NULL),(5304,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:59',NULL,NULL),(12020,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:10',NULL,NULL),(11522,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:43',NULL,NULL),(11229,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:25',NULL,NULL),(9451,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:05',NULL,NULL),(10639,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:03',NULL,NULL),(18137,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:41',NULL,NULL),(18193,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:15:00',NULL,NULL),(20165,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:09',NULL,NULL),(20197,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:06',NULL,NULL),(20558,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:17',NULL,NULL),(22741,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:55',NULL,NULL),(17033,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:09',NULL,NULL),(15926,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:58',NULL,NULL),(14974,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:39',NULL,NULL),(4702,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:26',NULL,NULL),(3431,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:17',NULL,NULL),(8253,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:02',NULL,NULL),(2562,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:45',NULL,NULL),(2324,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:44',NULL,NULL),(2091,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:03',NULL,NULL),(7804,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:13',NULL,NULL),(399,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:57',NULL,NULL),(21025,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:41',NULL,NULL),(17073,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:22',NULL,NULL),(3992,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:30',NULL,NULL),(4103,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:59',NULL,NULL),(7020,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:06',NULL,NULL),(16684,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:20',NULL,NULL),(8080,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:16',NULL,NULL),(15667,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:53',NULL,NULL),(14734,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:33',NULL,NULL),(9642,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:33',NULL,NULL),(14540,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:39',NULL,NULL),(11364,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:02',NULL,NULL),(17592,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:51',NULL,NULL),(2378,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:58',NULL,NULL),(2471,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:23',NULL,NULL),(11030,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:25',NULL,NULL),(2910,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:26',NULL,NULL),(3860,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:57',NULL,NULL),(3178,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:07',NULL,NULL),(4085,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:54',NULL,NULL),(19944,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:06',NULL,NULL),(20787,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:36',NULL,NULL),(20801,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:39',NULL,NULL),(22426,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:24',NULL,NULL),(15109,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:24',NULL,NULL),(550,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:46',NULL,NULL),(10436,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:51',NULL,NULL),(2566,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:46',NULL,NULL),(3634,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:13',NULL,NULL),(8012,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:08',NULL,NULL),(6399,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:30',NULL,NULL),(7021,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:06',NULL,NULL),(17956,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:39',NULL,NULL),(18793,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:11',NULL,NULL),(19741,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:13',NULL,NULL),(1341,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:51',NULL,NULL),(17007,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:00',NULL,NULL),(14295,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:19',NULL,NULL),(5041,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:01',NULL,NULL),(14031,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:39',NULL,NULL),(3395,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:08',NULL,NULL),(11363,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:02',NULL,NULL),(9892,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:38',NULL,NULL),(8692,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:50',NULL,NULL),(6571,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:03',NULL,NULL),(6663,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:26',NULL,NULL),(8246,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:00',NULL,NULL),(20388,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:16',NULL,NULL),(20684,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:05',NULL,NULL),(20968,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:25',NULL,NULL),(2574,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:48',NULL,NULL),(6167,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:28',NULL,NULL),(17332,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:23',NULL,NULL),(2970,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:48',NULL,NULL),(17274,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:04',NULL,NULL),(6526,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:04',NULL,NULL),(6786,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:59',NULL,NULL),(16810,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:09',NULL,NULL),(9412,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:53',NULL,NULL),(12858,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:03',NULL,NULL),(10681,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:15',NULL,NULL),(18923,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:46',NULL,NULL),(19246,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:10',NULL,NULL),(19571,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:41',NULL,NULL),(20998,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:34',NULL,NULL),(286,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:17',NULL,NULL),(380,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:49',NULL,NULL),(16785,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:03',NULL,NULL),(5329,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:06',NULL,NULL),(5279,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:52',NULL,NULL),(16633,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:00',NULL,NULL),(15422,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:35',NULL,NULL),(8138,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:31',NULL,NULL),(13447,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:14',NULL,NULL),(13025,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:47',NULL,NULL),(12231,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:07',NULL,NULL),(11472,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:31',NULL,NULL),(18034,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:06',NULL,NULL),(20550,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:14',NULL,NULL),(13403,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:07',NULL,NULL),(13290,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:57',NULL,NULL),(9121,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:35',NULL,NULL),(18690,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:06',NULL,NULL),(19674,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:11',NULL,NULL),(1618,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:31',NULL,NULL),(17687,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:26',NULL,NULL),(2846,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:03',NULL,NULL),(15637,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:42',NULL,NULL),(12379,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:50',NULL,NULL),(8146,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:34',NULL,NULL),(8585,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:21',NULL,NULL),(11445,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:24',NULL,NULL),(18024,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:03',NULL,NULL),(22104,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:44',NULL,NULL),(17864,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:07',NULL,NULL),(6509,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:00',NULL,NULL),(16992,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:54',NULL,NULL),(5861,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:34',NULL,NULL),(16612,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:51',NULL,NULL),(16478,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:01',NULL,NULL),(18379,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:40',NULL,NULL),(20293,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:41',NULL,NULL),(23191,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:52',NULL,NULL),(15297,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:11',NULL,NULL),(13952,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:27',NULL,NULL),(1247,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:15',NULL,NULL),(11912,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:23',NULL,NULL),(11582,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:58',NULL,NULL),(6899,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:31',NULL,NULL),(3500,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:36',NULL,NULL),(18346,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:31',NULL,NULL),(20204,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:09',NULL,NULL),(10343,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:25',NULL,NULL),(280,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:15',NULL,NULL),(14508,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:30',NULL,NULL),(1801,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:27',NULL,NULL),(5084,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:13',NULL,NULL),(18191,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:59',NULL,NULL),(19841,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:39',NULL,NULL),(20261,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:29',NULL,NULL),(176,211,'2013-12-27','15:06:00','A','000',0,'2014-01-13 03:05:00',NULL,NULL),(13371,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:19',NULL,NULL),(6117,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:13',NULL,NULL),(13029,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:48',NULL,NULL),(16596,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:45',NULL,NULL),(17198,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:03',NULL,NULL),(18146,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:44',NULL,NULL),(19745,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:14',NULL,NULL),(20614,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:37',NULL,NULL),(21975,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:58',NULL,NULL),(22725,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:50',NULL,NULL),(22804,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:20',NULL,NULL),(11275,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:37',NULL,NULL),(10582,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:48',NULL,NULL),(992,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:15',NULL,NULL),(7806,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:14',NULL,NULL),(1339,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:50',NULL,NULL),(1623,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:32',NULL,NULL),(2151,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:18',NULL,NULL),(20802,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:40',NULL,NULL),(21984,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:01',NULL,NULL),(22377,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:08',NULL,NULL),(16467,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:57',NULL,NULL),(14134,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:55',NULL,NULL),(12033,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:13',NULL,NULL),(1530,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:59',NULL,NULL),(1787,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:24',NULL,NULL),(10921,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:46:16',NULL,NULL),(18030,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:05',NULL,NULL),(21961,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:53',NULL,NULL),(22563,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:10',NULL,NULL),(350,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:39',NULL,NULL),(16356,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:14',NULL,NULL),(15800,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:38',NULL,NULL),(8238,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:58',NULL,NULL),(11277,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:38',NULL,NULL),(5916,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:53',NULL,NULL),(3597,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:02',NULL,NULL),(19089,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:33',NULL,NULL),(20982,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:30',NULL,NULL),(13391,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:05',NULL,NULL),(12525,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:27',NULL,NULL),(1436,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:26',NULL,NULL),(5174,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:22',NULL,NULL),(18408,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:48',NULL,NULL),(21645,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:37',NULL,NULL),(10064,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:07',NULL,NULL),(5708,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:42',NULL,NULL),(2277,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:33',NULL,NULL),(2543,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:41',NULL,NULL),(7360,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:31',NULL,NULL),(9450,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:04',NULL,NULL),(9656,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:37',NULL,NULL),(3177,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-23 22:30:07',NULL,NULL),(21389,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:02',NULL,NULL),(480,1889,'2014-01-14','23:11:00','A','000',0,'2014-01-23 19:01:23',NULL,NULL),(12095,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:29',NULL,NULL),(587,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:58',NULL,NULL),(1790,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:25',NULL,NULL),(11675,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:22',NULL,NULL),(6004,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:24',NULL,NULL),(16941,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:42',NULL,NULL),(20380,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:12',NULL,NULL),(20672,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:58',NULL,NULL),(23176,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(9353,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:31:37',NULL,NULL),(13747,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:58',NULL,NULL),(8328,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:25',NULL,NULL),(2104,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:06',NULL,NULL),(11609,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:05',NULL,NULL),(8172,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:41',NULL,NULL),(6108,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:11',NULL,NULL),(5923,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:56',NULL,NULL),(20032,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:32',NULL,NULL),(20567,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:20',NULL,NULL),(23586,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 15:30:03',NULL,NULL),(15518,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:03',NULL,NULL),(739,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:06',NULL,NULL),(9854,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:29',NULL,NULL),(14833,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:52:01',NULL,NULL),(14181,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:01',NULL,NULL),(9736,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:57',NULL,NULL),(2417,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:09',NULL,NULL),(3256,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:30',NULL,NULL),(4439,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:22',NULL,NULL),(9140,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:41',NULL,NULL),(5636,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:17',NULL,NULL),(13283,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:55',NULL,NULL),(6676,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:30',NULL,NULL),(7322,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:20',NULL,NULL),(20463,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:43',NULL,NULL),(21761,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:42',NULL,NULL),(6682,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:31',NULL,NULL),(10255,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:00',NULL,NULL),(1649,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:41',NULL,NULL),(2519,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:35',NULL,NULL),(5797,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:13',NULL,NULL),(7693,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:43',NULL,NULL),(18340,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:30',NULL,NULL),(18813,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:16',NULL,NULL),(21233,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:06',NULL,NULL),(22915,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:58',NULL,NULL),(27,365,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:26',NULL,NULL),(3803,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:43',NULL,NULL),(10855,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:58',NULL,NULL),(3360,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:58',NULL,NULL),(9834,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:23',NULL,NULL),(1651,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:42',NULL,NULL),(17737,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:43',NULL,NULL),(20347,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:00',NULL,NULL),(21383,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:59',NULL,NULL),(22093,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:40',NULL,NULL),(23625,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 16:00:03',NULL,NULL),(23698,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 22:30:02',NULL,NULL),(276,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:14',NULL,NULL),(11602,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:03',NULL,NULL),(13556,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:31',NULL,NULL),(12581,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:42',NULL,NULL),(11444,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:24',NULL,NULL),(6318,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:08',NULL,NULL),(8943,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:57',NULL,NULL),(2163,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:21',NULL,NULL),(3301,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:42',NULL,NULL),(8036,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:05',NULL,NULL),(7388,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:38',NULL,NULL),(6154,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:24',NULL,NULL),(17444,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:00',NULL,NULL),(18302,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:19',NULL,NULL),(19112,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:40',NULL,NULL),(19531,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:30',NULL,NULL),(16609,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:49',NULL,NULL),(14702,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:25',NULL,NULL),(6512,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:00',NULL,NULL),(13546,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:29',NULL,NULL),(22991,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(12725,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:23',NULL,NULL),(18158,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:48',NULL,NULL),(18465,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:04',NULL,NULL),(3708,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:18',NULL,NULL),(17347,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:28',NULL,NULL),(16647,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:06',NULL,NULL),(8281,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:09',NULL,NULL),(8701,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:52',NULL,NULL),(9738,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:58',NULL,NULL),(16317,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:00',NULL,NULL),(13135,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:16',NULL,NULL),(21410,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:10',NULL,NULL),(14259,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:14',NULL,NULL),(15829,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:23',NULL,NULL),(19195,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:04',NULL,NULL),(22387,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:11',NULL,NULL),(23413,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:54',NULL,NULL),(23449,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:07',NULL,NULL),(14938,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:29',NULL,NULL),(634,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:13',NULL,NULL),(789,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:20',NULL,NULL),(13880,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:17',NULL,NULL),(5191,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:27',NULL,NULL),(1722,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:08',NULL,NULL),(4624,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:03',NULL,NULL),(4289,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:42',NULL,NULL),(11857,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:09',NULL,NULL),(10408,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:43',NULL,NULL),(10047,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:03',NULL,NULL),(19337,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:35',NULL,NULL),(22091,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:39',NULL,NULL),(23041,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(16177,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:29',NULL,NULL),(15492,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:53',NULL,NULL),(794,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:21',NULL,NULL),(1184,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:08',NULL,NULL),(3343,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:53',NULL,NULL),(8925,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:52',NULL,NULL),(2359,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:53',NULL,NULL),(7306,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:16',NULL,NULL),(19785,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:24',NULL,NULL),(21440,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:21',NULL,NULL),(22221,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:25',NULL,NULL),(120,363,'2013-12-27','16:14:00','A','000',0,'2014-01-13 03:04:42',NULL,NULL),(17692,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:28',NULL,NULL),(14251,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:13',NULL,NULL),(10288,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:09',NULL,NULL),(6616,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:14',NULL,NULL),(10089,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:15',NULL,NULL),(8684,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:48',NULL,NULL),(8848,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:31',NULL,NULL),(18805,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:14',NULL,NULL),(21374,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:56',NULL,NULL),(23071,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(2288,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:35',NULL,NULL),(16990,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:54',NULL,NULL),(3902,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:08',NULL,NULL),(13773,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:02',NULL,NULL),(7495,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:08',NULL,NULL),(13037,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:50',NULL,NULL),(10180,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:40',NULL,NULL),(7953,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:53',NULL,NULL),(9346,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:36',NULL,NULL),(9580,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:16',NULL,NULL),(18652,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:55',NULL,NULL),(18957,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:57',NULL,NULL),(19645,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:03',NULL,NULL),(16897,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:32',NULL,NULL),(12618,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:52',NULL,NULL),(1842,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:37',NULL,NULL),(4145,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:05',NULL,NULL),(4543,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:48',NULL,NULL),(6683,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:31',NULL,NULL),(11671,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:21',NULL,NULL),(10301,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:13',NULL,NULL),(9678,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:42',NULL,NULL),(18892,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:37',NULL,NULL),(425,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:05',NULL,NULL),(17302,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:13',NULL,NULL),(6095,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:07',NULL,NULL),(4693,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:23',NULL,NULL),(5466,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:43',NULL,NULL),(15838,1835,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:14:26',NULL,NULL),(6675,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:29',NULL,NULL),(6723,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:41',NULL,NULL),(7049,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:13',NULL,NULL),(8337,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:27',NULL,NULL),(9017,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:07',NULL,NULL),(9054,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:17',NULL,NULL),(9384,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:46',NULL,NULL),(9914,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:44',NULL,NULL),(15807,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:40',NULL,NULL),(11149,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:02',NULL,NULL),(13312,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:03',NULL,NULL),(20430,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:31',NULL,NULL),(20673,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:58',NULL,NULL),(21665,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:08',NULL,NULL),(16492,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:07',NULL,NULL),(661,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:22',NULL,NULL),(16387,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:26',NULL,NULL),(2599,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:55',NULL,NULL),(14017,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:37',NULL,NULL),(5522,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:59',NULL,NULL),(8326,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:24',NULL,NULL),(11428,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:22',NULL,NULL),(11573,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:56',NULL,NULL),(13569,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:33',NULL,NULL),(18383,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:41',NULL,NULL),(20018,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:28',NULL,NULL),(20159,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:07',NULL,NULL),(1993,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:38',NULL,NULL),(16529,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:20',NULL,NULL),(15992,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:21',NULL,NULL),(2796,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:46',NULL,NULL),(4444,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:23',NULL,NULL),(15539,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:10',NULL,NULL),(15021,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:55',NULL,NULL),(8792,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:16',NULL,NULL),(12030,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:12',NULL,NULL),(17944,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:35',NULL,NULL),(18566,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:33',NULL,NULL),(19584,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:45',NULL,NULL),(21111,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:05',NULL,NULL),(535,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:41',NULL,NULL),(6177,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:31',NULL,NULL),(15096,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:20',NULL,NULL),(14125,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:53',NULL,NULL),(13072,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:59',NULL,NULL),(10040,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:01',NULL,NULL),(2328,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:45',NULL,NULL),(3609,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:06',NULL,NULL),(1671,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:50',NULL,NULL),(18314,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:23',NULL,NULL),(20954,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:22',NULL,NULL),(21916,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:38',NULL,NULL),(22288,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:41',NULL,NULL),(23092,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(16268,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:02',NULL,NULL),(15550,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:14',NULL,NULL),(6244,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:48',NULL,NULL),(15022,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:55',NULL,NULL),(14715,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:28',NULL,NULL),(5665,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:27',NULL,NULL),(8780,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:13',NULL,NULL),(4374,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:05',NULL,NULL),(3571,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:55',NULL,NULL),(8007,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:07',NULL,NULL),(7168,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:36',NULL,NULL),(6766,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:52',NULL,NULL),(22933,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(779,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:17',NULL,NULL),(6203,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:38',NULL,NULL),(1462,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:36',NULL,NULL),(1645,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:40',NULL,NULL),(15415,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:33',NULL,NULL),(2081,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:01',NULL,NULL),(13091,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:04',NULL,NULL),(9386,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:31:46',NULL,NULL),(19914,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:58',NULL,NULL),(19920,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:59',NULL,NULL),(21143,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:14',NULL,NULL),(680,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:30',NULL,NULL),(5996,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:22',NULL,NULL),(17739,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:43',NULL,NULL),(16252,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:56',NULL,NULL),(4800,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:52',NULL,NULL),(1034,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:27',NULL,NULL),(4335,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:54',NULL,NULL),(15582,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:24',NULL,NULL),(2060,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:55',NULL,NULL),(13537,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:28',NULL,NULL),(13024,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:46',NULL,NULL),(7026,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:07',NULL,NULL),(7891,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:37',NULL,NULL),(9624,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:28',NULL,NULL),(12188,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:54',NULL,NULL),(9908,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:42',NULL,NULL),(11928,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:43',NULL,NULL),(10837,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:54',NULL,NULL),(19635,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:00',NULL,NULL),(20094,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:49',NULL,NULL),(20286,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:38',NULL,NULL),(16442,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:47',NULL,NULL),(11832,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:02',NULL,NULL),(686,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:32',NULL,NULL),(8557,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:14',NULL,NULL),(21573,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:10',NULL,NULL),(23375,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:42',NULL,NULL),(17422,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:53',NULL,NULL),(1075,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:38',NULL,NULL),(16618,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:53',NULL,NULL),(15752,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:21',NULL,NULL),(15750,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:21',NULL,NULL),(3368,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:00',NULL,NULL),(8198,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:48',NULL,NULL),(13715,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:53',NULL,NULL),(18983,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:05',NULL,NULL),(20183,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:14',NULL,NULL),(20600,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:32',NULL,NULL),(21433,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:18',NULL,NULL),(22187,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:15',NULL,NULL),(558,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:49',NULL,NULL),(4704,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:26',NULL,NULL),(3007,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:00',NULL,NULL),(16814,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:10',NULL,NULL),(10046,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:03',NULL,NULL),(11617,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:07',NULL,NULL),(23555,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 17:30:02',NULL,NULL),(18301,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:19',NULL,NULL),(19543,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:33',NULL,NULL),(13005,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:42',NULL,NULL),(2637,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:05',NULL,NULL),(11378,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:06',NULL,NULL),(9961,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:56',NULL,NULL),(9711,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:51',NULL,NULL),(5378,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:19',NULL,NULL),(3468,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:27',NULL,NULL),(18452,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:00',NULL,NULL),(21336,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:43',NULL,NULL),(17323,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:20',NULL,NULL),(16041,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:38',NULL,NULL),(15413,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:33',NULL,NULL),(12899,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:13',NULL,NULL),(3467,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:27',NULL,NULL),(12267,1836,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:20:17',NULL,NULL),(7709,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:47',NULL,NULL),(7913,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:43',NULL,NULL),(8272,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:07',NULL,NULL),(8441,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:55',NULL,NULL),(8454,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:58',NULL,NULL),(22099,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:42',NULL,NULL),(22214,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:30:23',NULL,NULL),(22438,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:28',NULL,NULL),(15323,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:16',NULL,NULL),(15130,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:31',NULL,NULL),(12545,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:32',NULL,NULL),(828,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:31',NULL,NULL),(10006,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:39:52',NULL,NULL),(8134,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:30',NULL,NULL),(19177,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:59',NULL,NULL),(20535,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:09',NULL,NULL),(22529,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:58',NULL,NULL),(8014,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:09',NULL,NULL),(6840,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:13',NULL,NULL),(21867,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:20',NULL,NULL),(15617,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:36',NULL,NULL),(14526,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:35',NULL,NULL),(12664,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:05',NULL,NULL),(11530,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:45',NULL,NULL),(20957,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:22',NULL,NULL),(23184,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:51',NULL,NULL),(255,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:07',NULL,NULL),(7124,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:25',NULL,NULL),(18547,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:28',NULL,NULL),(12191,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:55',NULL,NULL),(4875,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:13',NULL,NULL),(1762,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:18',NULL,NULL),(17923,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:27',NULL,NULL),(6504,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:58',NULL,NULL),(16319,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:01',NULL,NULL),(15053,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:05',NULL,NULL),(14421,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:06',NULL,NULL),(4254,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:33',NULL,NULL),(12284,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:21',NULL,NULL),(10658,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:09',NULL,NULL),(10650,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:06',NULL,NULL),(534,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:41',NULL,NULL),(17669,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:20',NULL,NULL),(1063,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:35',NULL,NULL),(15669,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:53',NULL,NULL),(18038,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:08',NULL,NULL),(15016,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:53',NULL,NULL),(11435,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:22',NULL,NULL),(4891,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:17',NULL,NULL),(4669,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:16',NULL,NULL),(11416,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:18',NULL,NULL),(7926,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:46',NULL,NULL),(10142,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:29',NULL,NULL),(10297,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:12',NULL,NULL),(22100,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:43',NULL,NULL),(708,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:39',NULL,NULL),(6597,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:09',NULL,NULL),(6538,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:07',NULL,NULL),(13834,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:10',NULL,NULL),(13535,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:28',NULL,NULL),(4362,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:02',NULL,NULL),(3885,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:04',NULL,NULL),(12472,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:12',NULL,NULL),(12256,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:14',NULL,NULL),(3602,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:04',NULL,NULL),(8061,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:11',NULL,NULL),(1566,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:12',NULL,NULL),(2461,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:20',NULL,NULL),(2009,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:42',NULL,NULL),(20027,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:30',NULL,NULL),(220,209,'2013-12-27','15:05:00','A','000',0,'2014-01-13 03:05:14',NULL,NULL),(7284,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:09',NULL,NULL),(18321,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:25',NULL,NULL),(7004,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:02',NULL,NULL),(16592,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:43',NULL,NULL),(15775,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:30',NULL,NULL),(6123,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:15',NULL,NULL),(13782,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:03',NULL,NULL),(11658,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:18',NULL,NULL),(10642,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:04',NULL,NULL),(8987,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:09',NULL,NULL),(20037,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:33',NULL,NULL),(553,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:47',NULL,NULL),(801,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:23',NULL,NULL),(17726,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:39',NULL,NULL),(17594,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:52',NULL,NULL),(14228,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:09',NULL,NULL),(4828,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:00',NULL,NULL),(12677,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:09',NULL,NULL),(8498,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:10',NULL,NULL),(9596,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:21',NULL,NULL),(12431,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:01',NULL,NULL),(792,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:21',NULL,NULL),(18485,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:10',NULL,NULL),(1089,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:41',NULL,NULL),(18258,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:06',NULL,NULL),(17539,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:31',NULL,NULL),(15854,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:32',NULL,NULL),(15551,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:14',NULL,NULL),(15209,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:54',NULL,NULL),(14576,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:49',NULL,NULL),(10929,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:18',NULL,NULL),(13194,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:31',NULL,NULL),(19901,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:54',NULL,NULL),(20130,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:59',NULL,NULL),(22590,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:19',NULL,NULL),(15651,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:47',NULL,NULL),(13161,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:23',NULL,NULL),(7650,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:31',NULL,NULL),(17172,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:55',NULL,NULL),(7397,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:41',NULL,NULL),(12319,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:33',NULL,NULL),(2867,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:11',NULL,NULL),(6534,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:06',NULL,NULL),(6304,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:04',NULL,NULL),(5318,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:03',NULL,NULL),(21647,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:38',NULL,NULL),(22096,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:41',NULL,NULL),(23313,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:20',NULL,NULL),(23578,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 15:30:02',NULL,NULL),(3115,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:40',NULL,NULL),(18410,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:49',NULL,NULL),(16547,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:26',NULL,NULL),(4249,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:32',NULL,NULL),(5752,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:57',NULL,NULL),(10090,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:15',NULL,NULL),(11329,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:52',NULL,NULL),(15721,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:11',NULL,NULL),(23331,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:26',NULL,NULL),(14446,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:13',NULL,NULL),(19851,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:41',NULL,NULL),(19921,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:00',NULL,NULL),(8301,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:17',NULL,NULL),(2321,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:44',NULL,NULL),(17555,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:37',NULL,NULL),(17616,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:00',NULL,NULL),(19075,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:29',NULL,NULL),(23037,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:23',NULL,NULL),(15448,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:40',NULL,NULL),(4841,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:03',NULL,NULL),(13119,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:12',NULL,NULL),(6935,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:44',NULL,NULL),(7761,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:00',NULL,NULL),(8270,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:06',NULL,NULL),(8859,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:34',NULL,NULL),(11784,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:50',NULL,NULL),(12910,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:16',NULL,NULL),(12588,1796,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:44',NULL,NULL),(21740,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:35',NULL,NULL),(22970,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(15695,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:02',NULL,NULL),(329,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:32',NULL,NULL),(14760,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:40',NULL,NULL),(14652,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:11',NULL,NULL),(5108,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:02',NULL,NULL),(11570,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:55',NULL,NULL),(9955,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:54',NULL,NULL),(7236,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:57',NULL,NULL),(7454,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:57',NULL,NULL),(17844,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:00',NULL,NULL),(481,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:23',NULL,NULL),(2097,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:04',NULL,NULL),(3627,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:11',NULL,NULL),(15912,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:53',NULL,NULL),(15175,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:46',NULL,NULL),(13807,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:07',NULL,NULL),(4595,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:32:01',NULL,NULL),(4687,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:21',NULL,NULL),(4721,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:31',NULL,NULL),(7326,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:21',NULL,NULL),(11481,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:14:33',NULL,NULL),(11413,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:17',NULL,NULL),(11080,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:43',NULL,NULL),(8766,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:10',NULL,NULL),(9751,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:01',NULL,NULL),(20580,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:25',NULL,NULL),(20963,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:24',NULL,NULL),(16032,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:35',NULL,NULL),(2357,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:53',NULL,NULL),(15418,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:34',NULL,NULL),(12204,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:59',NULL,NULL),(3055,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:19',NULL,NULL),(3057,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:20',NULL,NULL),(8227,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:55',NULL,NULL),(11872,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:16:13',NULL,NULL),(8916,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:50',NULL,NULL),(10576,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:47',NULL,NULL),(18367,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:37',NULL,NULL),(19775,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:22',NULL,NULL),(20859,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:56',NULL,NULL),(3935,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:16',NULL,NULL),(4528,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:44',NULL,NULL),(8078,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:16',NULL,NULL),(7645,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:30',NULL,NULL),(5071,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:09',NULL,NULL),(21760,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:42',NULL,NULL),(22704,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:42',NULL,NULL),(22761,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:03',NULL,NULL),(16235,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:49',NULL,NULL),(1900,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:52',NULL,NULL),(4080,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:53',NULL,NULL),(15296,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:11',NULL,NULL),(8711,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:55',NULL,NULL),(7957,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:54',NULL,NULL),(7420,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:47',NULL,NULL),(7484,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:05',NULL,NULL),(18677,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:02',NULL,NULL),(21438,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:20',NULL,NULL),(17919,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:26',NULL,NULL),(17328,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:22',NULL,NULL),(17207,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:07',NULL,NULL),(1022,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:23',NULL,NULL),(5905,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:50',NULL,NULL),(5359,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:14',NULL,NULL),(2055,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:54',NULL,NULL),(4352,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:59',NULL,NULL),(14496,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:27',NULL,NULL),(13968,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:29',NULL,NULL),(8924,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:52',NULL,NULL),(20444,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:36',NULL,NULL),(22617,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:28',NULL,NULL),(1206,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:14',NULL,NULL),(17316,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:18',NULL,NULL),(12001,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:04',NULL,NULL),(2152,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:18',NULL,NULL),(4976,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:42',NULL,NULL),(10348,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:26',NULL,NULL),(3883,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:03',NULL,NULL),(9939,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:50',NULL,NULL),(7958,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:54',NULL,NULL),(18873,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:32',NULL,NULL),(18958,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:58',NULL,NULL),(20243,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:23',NULL,NULL),(20710,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:13',NULL,NULL),(21232,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:05',NULL,NULL),(22779,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:11',NULL,NULL),(31,300,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:29',NULL,NULL),(15026,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:57',NULL,NULL),(13468,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:17',NULL,NULL),(6599,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:10',NULL,NULL),(5172,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:21',NULL,NULL),(12667,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:06',NULL,NULL),(12156,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:46',NULL,NULL),(448,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:13',NULL,NULL),(12121,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:37',NULL,NULL),(12112,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:34',NULL,NULL),(3219,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:19',NULL,NULL),(1434,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:25',NULL,NULL),(2784,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:42',NULL,NULL),(11418,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:19',NULL,NULL),(10979,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:11',NULL,NULL),(1735,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:11',NULL,NULL),(9192,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:55',NULL,NULL),(10484,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:23',NULL,NULL),(10403,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:41',NULL,NULL),(21918,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:38',NULL,NULL),(16622,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:55',NULL,NULL),(16402,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:33',NULL,NULL),(15011,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:52',NULL,NULL),(14342,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:29',NULL,NULL),(10981,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:11',NULL,NULL),(10725,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:26',NULL,NULL),(22851,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:36',NULL,NULL),(1867,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:43',NULL,NULL),(1934,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:00',NULL,NULL),(14321,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:24',NULL,NULL),(2633,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:04',NULL,NULL),(5565,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:12',NULL,NULL),(4760,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:41',NULL,NULL),(13700,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:50',NULL,NULL),(4162,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:10',NULL,NULL),(13489,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:21',NULL,NULL),(2709,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:15',NULL,NULL),(10951,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:03',NULL,NULL),(10808,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:46',NULL,NULL),(21032,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:43',NULL,NULL),(21309,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:33',NULL,NULL),(21737,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:34',NULL,NULL),(23473,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:16',NULL,NULL),(15299,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:11',NULL,NULL),(14323,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:24',NULL,NULL),(9641,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:33',NULL,NULL),(8981,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:07',NULL,NULL),(8044,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:07',NULL,NULL),(5603,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:05',NULL,NULL),(4962,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:38',NULL,NULL),(20381,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:13',NULL,NULL),(21769,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:45',NULL,NULL),(23216,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:57',NULL,NULL),(956,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:05',NULL,NULL),(2309,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:41',NULL,NULL),(6963,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:50',NULL,NULL),(15054,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:06',NULL,NULL),(5709,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:42',NULL,NULL),(4637,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:07',NULL,NULL),(3025,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:07',NULL,NULL),(7533,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:32:18',NULL,NULL),(14090,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:48',NULL,NULL),(22952,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:07',NULL,NULL),(23403,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:51',NULL,NULL),(23560,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 11:30:02',NULL,NULL),(17049,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:14',NULL,NULL),(15815,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:17',NULL,NULL),(1472,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:39',NULL,NULL),(1726,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:09',NULL,NULL),(15390,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:29',NULL,NULL),(14610,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:59',NULL,NULL),(6255,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:51',NULL,NULL),(2652,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:09',NULL,NULL),(3161,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:03',NULL,NULL),(12179,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:52',NULL,NULL),(11049,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:31',NULL,NULL),(4447,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:24',NULL,NULL),(3400,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:09',NULL,NULL),(10869,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:02',NULL,NULL),(19533,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:30',NULL,NULL),(299,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:21',NULL,NULL),(7013,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:04',NULL,NULL),(17339,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:26',NULL,NULL),(15895,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:47',NULL,NULL),(11794,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:53',NULL,NULL),(9076,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:23',NULL,NULL),(4458,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:27',NULL,NULL),(8847,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:31',NULL,NULL),(3649,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:03',NULL,NULL),(389,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:51',NULL,NULL),(1681,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:55',NULL,NULL),(20719,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:16',NULL,NULL),(21098,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:01',NULL,NULL),(23103,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(271,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:12',NULL,NULL),(18493,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:12',NULL,NULL),(16988,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:53',NULL,NULL),(4181,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:14',NULL,NULL),(13586,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:35',NULL,NULL),(12015,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:08',NULL,NULL),(13228,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:41',NULL,NULL),(19073,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:37:29',NULL,NULL),(22778,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:09',NULL,NULL),(22848,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:35',NULL,NULL),(16368,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:19',NULL,NULL),(12693,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:14',NULL,NULL),(8824,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:25',NULL,NULL),(20768,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:30',NULL,NULL),(21897,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:30',NULL,NULL),(22661,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:27',NULL,NULL),(12419,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:21:57',NULL,NULL),(505,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:32',NULL,NULL),(11370,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:04',NULL,NULL),(10289,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:10',NULL,NULL),(5349,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:11',NULL,NULL),(3454,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:23',NULL,NULL),(23457,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:11',NULL,NULL),(18116,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:34',NULL,NULL),(1706,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:04',NULL,NULL),(3293,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:40',NULL,NULL),(7302,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:15',NULL,NULL),(14769,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:43',NULL,NULL),(13717,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:54',NULL,NULL),(6183,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:32',NULL,NULL),(4630,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:05',NULL,NULL),(7945,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:51',NULL,NULL),(13276,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:53',NULL,NULL),(11755,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:43',NULL,NULL),(10097,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:17',NULL,NULL),(11662,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:19',NULL,NULL),(11460,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:28',NULL,NULL),(20821,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:45',NULL,NULL),(20894,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:06',NULL,NULL),(21381,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:59',NULL,NULL),(21801,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:57',NULL,NULL),(222,186,'2013-12-27','14:53:00','A','000',0,'2014-01-13 03:05:15',NULL,NULL),(17980,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:47',NULL,NULL),(16279,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:06',NULL,NULL),(15742,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:18',NULL,NULL),(15084,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:15',NULL,NULL),(892,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:48',NULL,NULL),(961,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:07',NULL,NULL),(12780,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:38',NULL,NULL),(5292,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:56',NULL,NULL),(12326,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:35',NULL,NULL),(8038,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:05',NULL,NULL),(20477,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:48',NULL,NULL),(20560,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:18',NULL,NULL),(21096,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:00',NULL,NULL),(22373,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:07',NULL,NULL),(10505,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:28',NULL,NULL),(5853,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:32',NULL,NULL),(15527,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:06',NULL,NULL),(15295,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:11',NULL,NULL),(12596,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:46',NULL,NULL),(3986,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:29',NULL,NULL),(17934,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:31',NULL,NULL),(18651,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:55',NULL,NULL),(20314,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:48',NULL,NULL),(23584,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 11:30:02',NULL,NULL),(23674,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 22:29:57',NULL,NULL),(9547,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:08',NULL,NULL),(15399,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:30',NULL,NULL),(5375,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:18',NULL,NULL),(4688,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:22',NULL,NULL),(3746,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:28',NULL,NULL),(2672,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:14',NULL,NULL),(21015,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:38',NULL,NULL),(22758,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:02',NULL,NULL),(10564,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:44',NULL,NULL),(1901,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:52',NULL,NULL),(15712,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:08',NULL,NULL),(13750,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:58',NULL,NULL),(2836,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:00',NULL,NULL),(12860,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:24:04',NULL,NULL),(5358,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:14',NULL,NULL),(7264,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:04',NULL,NULL),(7158,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:34',NULL,NULL),(12845,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:59',NULL,NULL),(7051,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:14',NULL,NULL),(18967,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:00',NULL,NULL),(19023,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:15',NULL,NULL),(20760,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:28',NULL,NULL),(22724,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:49',NULL,NULL),(12900,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:13',NULL,NULL),(12208,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:00',NULL,NULL),(10393,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:39',NULL,NULL),(11801,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:55',NULL,NULL),(4413,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:15',NULL,NULL),(1919,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:56',NULL,NULL),(9808,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:16',NULL,NULL),(5821,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:21',NULL,NULL),(17892,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:17',NULL,NULL),(13402,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:07',NULL,NULL),(9095,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:29',NULL,NULL),(2812,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:52',NULL,NULL),(7973,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:58',NULL,NULL),(3667,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:08',NULL,NULL),(5544,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:06',NULL,NULL),(16869,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:24',NULL,NULL),(19647,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:04',NULL,NULL),(21418,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:13',NULL,NULL),(21633,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:43:33',NULL,NULL),(16021,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:31',NULL,NULL),(14672,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:17',NULL,NULL),(9771,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:06',NULL,NULL),(14629,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:05',NULL,NULL),(13555,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:31',NULL,NULL),(5604,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:05',NULL,NULL),(13131,1845,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:15',NULL,NULL),(4223,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:25',NULL,NULL),(4990,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:47',NULL,NULL),(17585,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:48',NULL,NULL),(21499,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:43',NULL,NULL),(22799,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:18',NULL,NULL),(10743,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:30',NULL,NULL),(7852,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:26',NULL,NULL),(7862,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:30',NULL,NULL),(5144,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:14',NULL,NULL),(17863,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:07',NULL,NULL),(23270,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:07',NULL,NULL),(14150,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:57',NULL,NULL),(950,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:04',NULL,NULL),(12672,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:07',NULL,NULL),(6669,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:28',NULL,NULL),(6602,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:11',NULL,NULL),(17786,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:38',NULL,NULL),(19618,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:54',NULL,NULL),(20205,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:09',NULL,NULL),(16397,1826,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:31',NULL,NULL),(16028,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:34',NULL,NULL),(1154,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:59',NULL,NULL),(1305,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:37',NULL,NULL),(1603,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:25',NULL,NULL),(15074,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:12',NULL,NULL),(3541,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:47',NULL,NULL),(14996,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:46',NULL,NULL),(7151,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:32',NULL,NULL),(4453,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:26',NULL,NULL),(13015,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:44',NULL,NULL),(17748,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:46',NULL,NULL),(18432,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:54',NULL,NULL),(18508,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:17',NULL,NULL),(23036,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:23',NULL,NULL),(426,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:06',NULL,NULL),(7554,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:00:07',NULL,NULL),(6550,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:10',NULL,NULL),(16349,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:12',NULL,NULL),(13190,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:30',NULL,NULL),(5005,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:51',NULL,NULL),(5506,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:54',NULL,NULL),(17371,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:37',NULL,NULL),(17499,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:18',NULL,NULL),(19978,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:17',NULL,NULL),(20487,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:51',NULL,NULL),(22382,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:10',NULL,NULL),(6471,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:50',NULL,NULL),(175,356,'2013-12-27','16:08:00','A','000',0,'2014-01-13 03:04:59',NULL,NULL),(2683,1856,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:00:06',NULL,NULL),(2849,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:04',NULL,NULL),(15914,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:53',NULL,NULL),(11910,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:22',NULL,NULL),(12410,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:55',NULL,NULL),(13011,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:43',NULL,NULL),(15636,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:42',NULL,NULL),(17482,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:12',NULL,NULL),(16765,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:49',NULL,NULL),(15885,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:43',NULL,NULL),(928,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:58',NULL,NULL),(14945,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:30',NULL,NULL),(12805,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:45',NULL,NULL),(17723,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:38',NULL,NULL),(18382,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:41',NULL,NULL),(19539,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:32',NULL,NULL),(21657,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:05',NULL,NULL),(22113,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:47',NULL,NULL),(9455,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:06',NULL,NULL),(1906,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:53',NULL,NULL),(8609,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:28',NULL,NULL),(7131,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:27',NULL,NULL),(15608,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:33',NULL,NULL),(12072,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:23',NULL,NULL),(14608,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:58',NULL,NULL),(17972,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:44',NULL,NULL),(16006,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:26',NULL,NULL),(388,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:51',NULL,NULL),(14587,1810,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:52',NULL,NULL),(883,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:46',NULL,NULL),(974,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:10',NULL,NULL),(14493,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:26',NULL,NULL),(9748,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:00',NULL,NULL),(12671,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:07',NULL,NULL),(12090,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:28',NULL,NULL),(4715,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:29',NULL,NULL),(3906,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:09',NULL,NULL),(3152,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:53',NULL,NULL),(3044,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:16',NULL,NULL),(20708,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:13',NULL,NULL),(21982,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:00',NULL,NULL),(22882,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:47',NULL,NULL),(16189,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:33',NULL,NULL),(13940,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:25',NULL,NULL),(6646,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:22',NULL,NULL),(13647,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:43',NULL,NULL),(7596,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:17',NULL,NULL),(11991,1837,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:19:02',NULL,NULL),(11652,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:16',NULL,NULL),(18542,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:26',NULL,NULL),(20772,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:30:31',NULL,NULL),(21267,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:18',NULL,NULL),(521,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:37',NULL,NULL),(16325,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:03',NULL,NULL),(1567,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:13',NULL,NULL),(16089,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:56',NULL,NULL),(15063,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:09',NULL,NULL),(14337,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:28',NULL,NULL),(14331,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:26',NULL,NULL),(2430,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:12',NULL,NULL),(13614,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:39',NULL,NULL),(12297,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:26',NULL,NULL),(3064,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:23',NULL,NULL),(10900,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:11',NULL,NULL),(18719,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:14',NULL,NULL),(20902,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:08',NULL,NULL),(20950,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:21',NULL,NULL),(21976,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:58',NULL,NULL),(259,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:08',NULL,NULL),(14065,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:44',NULL,NULL),(3402,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:10',NULL,NULL),(11544,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:49',NULL,NULL),(7616,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:23',NULL,NULL),(11119,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:54',NULL,NULL),(10113,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:21',NULL,NULL),(18079,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:22',NULL,NULL),(19510,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:24',NULL,NULL),(21943,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:47',NULL,NULL),(184,218,'2013-12-27','15:09:00','A','000',0,'2014-01-13 03:05:02',NULL,NULL),(14677,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:18',NULL,NULL),(4273,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:30:38',NULL,NULL),(2575,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:49',NULL,NULL),(18757,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:00',NULL,NULL),(18852,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:27',NULL,NULL),(22390,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:12',NULL,NULL),(22400,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:16',NULL,NULL),(455,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:15',NULL,NULL),(16752,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:45',NULL,NULL),(12370,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:48',NULL,NULL),(2444,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:16',NULL,NULL),(3967,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:24',NULL,NULL),(9801,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:15',NULL,NULL),(7088,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:13',NULL,NULL),(9714,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:51',NULL,NULL),(17772,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:34',NULL,NULL),(1716,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:07',NULL,NULL),(2644,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:07',NULL,NULL),(12143,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:42',NULL,NULL),(10907,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:12',NULL,NULL),(4780,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:47',NULL,NULL),(7186,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:41',NULL,NULL),(8799,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:18',NULL,NULL),(19147,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:50',NULL,NULL),(335,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:34',NULL,NULL),(16483,1868,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:19:03',NULL,NULL),(1248,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:16',NULL,NULL),(15202,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:53',NULL,NULL),(15139,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:34',NULL,NULL),(14804,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:53',NULL,NULL),(13287,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:56',NULL,NULL),(4680,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:19',NULL,NULL),(12585,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:43',NULL,NULL),(7213,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:48',NULL,NULL),(7655,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:33',NULL,NULL),(9683,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:44',NULL,NULL),(18004,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:55',NULL,NULL),(18505,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:16',NULL,NULL),(21541,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:58',NULL,NULL),(21817,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:03',NULL,NULL),(22124,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:51',NULL,NULL),(22688,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:37',NULL,NULL),(22796,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:17',NULL,NULL),(15526,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:05',NULL,NULL),(5197,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:28',NULL,NULL),(6876,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:24',NULL,NULL),(14060,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:44',NULL,NULL),(10490,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:25',NULL,NULL),(17990,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:50',NULL,NULL),(23016,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(23445,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:06',NULL,NULL),(89,196,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:23',NULL,NULL),(15485,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:51',NULL,NULL),(2213,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:09',NULL,NULL),(14350,1836,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:32:32',NULL,NULL),(3818,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:47',NULL,NULL),(7239,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:57',NULL,NULL),(3398,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:08',NULL,NULL),(19137,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:47',NULL,NULL),(1131,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:53',NULL,NULL),(2279,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:33',NULL,NULL),(17192,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:01',NULL,NULL),(3145,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:02:51',NULL,NULL),(16881,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:28',NULL,NULL),(15252,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:03',NULL,NULL),(13790,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:04',NULL,NULL),(19259,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:14',NULL,NULL),(20661,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:54',NULL,NULL),(22522,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:56',NULL,NULL),(2451,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:18',NULL,NULL),(17965,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:42',NULL,NULL),(21109,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:04',NULL,NULL),(22527,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:58',NULL,NULL),(4618,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:07',NULL,NULL),(1405,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:15',NULL,NULL),(5465,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:43',NULL,NULL),(8315,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:21',NULL,NULL),(17647,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:12',NULL,NULL),(17933,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:31',NULL,NULL),(19922,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:00',NULL,NULL),(23266,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(23335,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:28',NULL,NULL),(9577,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:15',NULL,NULL),(7295,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:13',NULL,NULL),(6374,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:23',NULL,NULL),(15994,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:22',NULL,NULL),(15398,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:30',NULL,NULL),(2030,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:48',NULL,NULL),(11451,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:26',NULL,NULL),(11327,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:51',NULL,NULL),(10836,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:53',NULL,NULL),(16955,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:46',NULL,NULL),(17354,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:30',NULL,NULL),(20422,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:28',NULL,NULL),(21001,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:31:35',NULL,NULL),(22401,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:16',NULL,NULL),(14937,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:28',NULL,NULL),(14778,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:46',NULL,NULL),(13737,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:57',NULL,NULL),(13284,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:55',NULL,NULL),(11861,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:10',NULL,NULL),(11783,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:50',NULL,NULL),(12195,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:57',NULL,NULL),(9662,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:38',NULL,NULL),(10359,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:29',NULL,NULL),(5034,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:59',NULL,NULL),(4969,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:40',NULL,NULL),(3641,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:15',NULL,NULL),(16427,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:42',NULL,NULL),(17087,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:27',NULL,NULL),(21811,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:00',NULL,NULL),(467,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:19',NULL,NULL),(1028,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:25',NULL,NULL),(16105,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:03',NULL,NULL),(15237,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:00',NULL,NULL),(14572,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:48',NULL,NULL),(14111,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:51',NULL,NULL),(6468,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:49',NULL,NULL),(4396,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:10',NULL,NULL),(11422,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:20',NULL,NULL),(4980,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:44',NULL,NULL),(16455,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:53',NULL,NULL),(19353,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:40',NULL,NULL),(19929,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:02',NULL,NULL),(20078,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:45',NULL,NULL),(20311,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:47',NULL,NULL),(22838,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:32',NULL,NULL),(19,207,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:18',NULL,NULL),(14943,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:00:30',NULL,NULL),(8505,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:12',NULL,NULL),(12831,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:54',NULL,NULL),(2456,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:19',NULL,NULL),(10720,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:25',NULL,NULL),(20818,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:45',NULL,NULL),(22506,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:51',NULL,NULL),(23285,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:10',NULL,NULL),(995,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:16',NULL,NULL),(13891,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:18',NULL,NULL),(9404,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:51',NULL,NULL),(13375,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:20',NULL,NULL),(12150,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:44',NULL,NULL),(3268,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:33',NULL,NULL),(10994,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:15',NULL,NULL),(11217,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:22',NULL,NULL),(16534,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:22',NULL,NULL),(18039,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:08',NULL,NULL),(19102,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:37',NULL,NULL),(19260,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:14',NULL,NULL),(20110,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:54',NULL,NULL),(21068,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:53',NULL,NULL),(21447,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:23',NULL,NULL),(21861,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:18',NULL,NULL),(11898,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:19',NULL,NULL),(11230,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:26',NULL,NULL),(11070,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:39',NULL,NULL),(502,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:31',NULL,NULL),(11051,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:32',NULL,NULL),(5281,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:53',NULL,NULL),(1449,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:31',NULL,NULL),(1824,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:33',NULL,NULL),(1967,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:31',NULL,NULL),(2103,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:06',NULL,NULL),(2119,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:10',NULL,NULL),(4803,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:53',NULL,NULL),(3900,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:08',NULL,NULL),(10739,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:29',NULL,NULL),(3260,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:31',NULL,NULL),(17311,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:16',NULL,NULL),(18936,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:50',NULL,NULL),(19212,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:38:09',NULL,NULL),(19541,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:32',NULL,NULL),(22391,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:13',NULL,NULL),(23373,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:41',NULL,NULL),(23548,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 20:00:02',NULL,NULL),(9864,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:31',NULL,NULL),(13209,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:36',NULL,NULL),(13181,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:28',NULL,NULL),(2284,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:34',NULL,NULL),(2850,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:05',NULL,NULL),(13035,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:49',NULL,NULL),(7935,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:49',NULL,NULL),(12478,1749,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:14',NULL,NULL),(4860,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:09',NULL,NULL),(7056,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:03',NULL,NULL),(16691,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:23',NULL,NULL),(22905,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:54',NULL,NULL),(170,219,'2013-12-27','15:09:00','A','000',0,'2014-01-13 03:04:58',NULL,NULL),(196,227,'2013-12-27','15:12:00','A','000',0,'2014-01-13 03:05:06',NULL,NULL),(512,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:34',NULL,NULL),(14491,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:26',NULL,NULL),(6938,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:44',NULL,NULL),(6441,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:42',NULL,NULL),(3756,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:30',NULL,NULL),(5081,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:12',NULL,NULL),(18099,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:28',NULL,NULL),(20930,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:15',NULL,NULL),(10601,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:44:53',NULL,NULL),(14157,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:58',NULL,NULL),(1460,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:35',NULL,NULL),(8455,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:58',NULL,NULL),(13149,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:20',NULL,NULL),(5087,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:13',NULL,NULL),(16793,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:05',NULL,NULL),(17949,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:36',NULL,NULL),(18296,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:18',NULL,NULL),(19410,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:57',NULL,NULL),(20012,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:26',NULL,NULL),(21287,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:25',NULL,NULL),(21563,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:06',NULL,NULL),(22974,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(23389,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:46',NULL,NULL),(23591,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 01:30:02',NULL,NULL),(1145,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:57',NULL,NULL),(1365,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:01',NULL,NULL),(15587,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:26',NULL,NULL),(1989,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:37',NULL,NULL),(14570,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:47',NULL,NULL),(2269,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:30',NULL,NULL),(10233,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:54',NULL,NULL),(6111,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:12',NULL,NULL),(8131,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:30',NULL,NULL),(3732,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:25',NULL,NULL),(9986,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:46',NULL,NULL),(21171,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:42',NULL,NULL),(982,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:13',NULL,NULL),(4155,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:08',NULL,NULL),(1727,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:09',NULL,NULL),(2618,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:00',NULL,NULL),(6212,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:40',NULL,NULL),(17204,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:05',NULL,NULL),(17457,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:04',NULL,NULL),(18756,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:00',NULL,NULL),(21209,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:56',NULL,NULL),(23088,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(625,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:10',NULL,NULL),(16355,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:14',NULL,NULL),(16291,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:10',NULL,NULL),(9370,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:42',NULL,NULL),(1877,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:46',NULL,NULL),(18927,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:47',NULL,NULL),(1673,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:51',NULL,NULL),(5352,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:12',NULL,NULL),(1931,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:59',NULL,NULL),(4028,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:39',NULL,NULL),(4419,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:16',NULL,NULL),(8604,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:26',NULL,NULL),(9064,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:20',NULL,NULL),(9594,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:21',NULL,NULL),(17096,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:30',NULL,NULL),(11697,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:28',NULL,NULL),(14789,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:49',NULL,NULL),(16663,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:12',NULL,NULL),(17203,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:32:05',NULL,NULL),(19496,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:20',NULL,NULL),(20283,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:37',NULL,NULL),(22049,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:24',NULL,NULL),(14798,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:51',NULL,NULL),(14742,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:35',NULL,NULL),(13257,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:48',NULL,NULL),(11681,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:24',NULL,NULL),(1548,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:06',NULL,NULL),(3151,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:02:53',NULL,NULL),(1640,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:38',NULL,NULL),(9359,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:39',NULL,NULL),(11680,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:23',NULL,NULL),(9784,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:10',NULL,NULL),(11216,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:01:22',NULL,NULL),(18313,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:22',NULL,NULL),(2051,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:53',NULL,NULL),(15956,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:08',NULL,NULL),(12558,1749,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:36',NULL,NULL),(3999,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:32',NULL,NULL),(2746,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:28',NULL,NULL),(3272,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:34',NULL,NULL),(8121,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:27',NULL,NULL),(17733,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:41',NULL,NULL),(18105,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:30',NULL,NULL),(18728,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:17',NULL,NULL),(20835,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:49',NULL,NULL),(296,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:20',NULL,NULL),(17227,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:13',NULL,NULL),(1898,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:51',NULL,NULL),(2148,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:17',NULL,NULL),(6628,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:17',NULL,NULL),(12414,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:56',NULL,NULL),(9635,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:31',NULL,NULL),(9705,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:49',NULL,NULL),(10867,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:02',NULL,NULL),(11159,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:04',NULL,NULL),(22442,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:30',NULL,NULL),(188,177,'2013-12-27','14:51:00','A','000',0,'2014-01-13 03:05:04',NULL,NULL),(5599,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:04',NULL,NULL),(10363,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:30',NULL,NULL),(3750,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:29',NULL,NULL),(2839,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:01',NULL,NULL),(19933,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:03',NULL,NULL),(20533,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:08',NULL,NULL),(21738,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:34',NULL,NULL),(759,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:11',NULL,NULL),(15955,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:08',NULL,NULL),(4936,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:31',NULL,NULL),(15809,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:41',NULL,NULL),(13661,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:45',NULL,NULL),(3605,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:04',NULL,NULL),(13634,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:41',NULL,NULL),(10652,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:06',NULL,NULL),(10076,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:11',NULL,NULL),(8698,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:51',NULL,NULL),(17948,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:36',NULL,NULL),(18165,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:51',NULL,NULL),(18998,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:37:09',NULL,NULL),(19268,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:16',NULL,NULL),(21190,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:49',NULL,NULL),(513,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:34',NULL,NULL),(17398,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:45',NULL,NULL),(5844,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:29',NULL,NULL),(4625,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:03',NULL,NULL),(4283,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:40',NULL,NULL),(1923,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:57',NULL,NULL),(16744,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:42',NULL,NULL),(13208,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:35',NULL,NULL),(13009,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:43',NULL,NULL),(11590,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:00',NULL,NULL),(11944,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:47',NULL,NULL),(18033,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:06',NULL,NULL),(19868,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:46',NULL,NULL),(21201,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:53',NULL,NULL),(18145,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:43',NULL,NULL),(22691,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:38',NULL,NULL),(96,314,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:29',NULL,NULL),(341,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:36',NULL,NULL),(365,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:43',NULL,NULL),(9919,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:45',NULL,NULL),(1124,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:51',NULL,NULL),(13345,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:12',NULL,NULL),(12626,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:55',NULL,NULL),(11960,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:52',NULL,NULL),(4811,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:55',NULL,NULL),(11464,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:29',NULL,NULL),(18667,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:59',NULL,NULL),(22135,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:55',NULL,NULL),(22145,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:04',NULL,NULL),(719,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:43',NULL,NULL),(13346,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:12',NULL,NULL),(1169,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:03',NULL,NULL),(1288,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:30',NULL,NULL),(11167,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:06',NULL,NULL),(16256,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:57',NULL,NULL),(17417,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:52',NULL,NULL),(17721,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:38',NULL,NULL),(19968,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:14',NULL,NULL),(21117,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:06',NULL,NULL),(22850,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:36',NULL,NULL),(23081,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(23108,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(23530,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 15:30:02',NULL,NULL),(771,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:15',NULL,NULL),(3371,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:01',NULL,NULL),(1121,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:50',NULL,NULL),(2138,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:15',NULL,NULL),(6054,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:42',NULL,NULL),(1628,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:34',NULL,NULL),(18603,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:43',NULL,NULL),(20072,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:43',NULL,NULL),(20613,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:37',NULL,NULL),(22973,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(23470,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:15',NULL,NULL),(10430,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:49',NULL,NULL),(10007,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:52',NULL,NULL),(13444,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:14',NULL,NULL),(2188,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:02',NULL,NULL),(12196,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:57',NULL,NULL),(9007,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:04',NULL,NULL),(8931,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:54',NULL,NULL),(7195,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:43',NULL,NULL),(16485,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:04',NULL,NULL),(20020,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:28',NULL,NULL),(21397,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:05',NULL,NULL),(21441,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:21',NULL,NULL),(22035,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:19',NULL,NULL),(11864,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:11',NULL,NULL),(615,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:07',NULL,NULL),(8653,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:39',NULL,NULL),(8545,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:11',NULL,NULL),(6527,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:04',NULL,NULL),(7381,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:36',NULL,NULL),(8359,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:34',NULL,NULL),(7385,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:37',NULL,NULL),(3640,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:15',NULL,NULL),(19328,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:33',NULL,NULL),(19453,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:08',NULL,NULL),(13708,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:52',NULL,NULL),(12014,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:08',NULL,NULL),(472,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:21',NULL,NULL),(7884,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:36',NULL,NULL),(5100,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:17',NULL,NULL),(5224,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:36',NULL,NULL),(1221,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:05',NULL,NULL),(4567,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:54',NULL,NULL),(4471,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:30',NULL,NULL),(3480,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:30',NULL,NULL),(18773,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:05',NULL,NULL),(21455,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:26',NULL,NULL),(23325,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:24',NULL,NULL),(368,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:45',NULL,NULL),(16120,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:09',NULL,NULL),(15168,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:44',NULL,NULL),(1013,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:21',NULL,NULL),(10674,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:14',NULL,NULL),(1627,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:34',NULL,NULL),(15146,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:36',NULL,NULL),(3822,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:47',NULL,NULL),(8372,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:37',NULL,NULL),(3029,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:08',NULL,NULL),(18254,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:05',NULL,NULL),(18678,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:02',NULL,NULL),(491,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:27',NULL,NULL),(600,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:02',NULL,NULL),(9438,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:01',NULL,NULL),(9092,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:28',NULL,NULL),(1585,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:19',NULL,NULL),(15612,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:34',NULL,NULL),(6292,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:01',NULL,NULL),(2955,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:42',NULL,NULL),(15601,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:31',NULL,NULL),(5038,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:02:00',NULL,NULL),(18583,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:37',NULL,NULL),(19354,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:40',NULL,NULL),(20259,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:28',NULL,NULL),(21153,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:17',NULL,NULL),(22548,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:04',NULL,NULL),(23387,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:46',NULL,NULL),(13701,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:50',NULL,NULL),(8608,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:27',NULL,NULL),(12776,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:37',NULL,NULL),(7257,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:02',NULL,NULL),(5944,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:03',NULL,NULL),(4703,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:26',NULL,NULL),(4484,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:33',NULL,NULL),(12193,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:56',NULL,NULL),(18371,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:38',NULL,NULL),(19220,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:03',NULL,NULL),(14923,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:25',NULL,NULL),(14234,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:32:09',NULL,NULL),(797,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:22',NULL,NULL),(7453,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:57',NULL,NULL),(1855,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:40',NULL,NULL),(2449,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:17',NULL,NULL),(6708,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:37',NULL,NULL),(5711,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:43',NULL,NULL),(17041,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:11',NULL,NULL),(19734,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:11',NULL,NULL),(20154,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:06',NULL,NULL),(1196,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:11',NULL,NULL),(5336,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:08',NULL,NULL),(4134,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:02',NULL,NULL),(16732,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:37',NULL,NULL),(15697,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:03',NULL,NULL),(14583,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:51',NULL,NULL),(8735,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:01',NULL,NULL),(8911,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:48',NULL,NULL),(14352,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:45',NULL,NULL),(9661,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:38',NULL,NULL),(9879,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:35',NULL,NULL),(12242,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:10',NULL,NULL),(10943,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:21',NULL,NULL),(11894,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:18',NULL,NULL),(18108,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:31',NULL,NULL),(20450,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:38',NULL,NULL),(20953,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:21',NULL,NULL),(15749,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:21',NULL,NULL),(15679,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:57',NULL,NULL),(1527,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:58',NULL,NULL),(5277,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:51',NULL,NULL),(15544,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:11',NULL,NULL),(4502,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:38',NULL,NULL),(13223,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:39',NULL,NULL),(11914,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:23',NULL,NULL),(7232,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:55',NULL,NULL),(8503,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:11',NULL,NULL),(8715,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:56',NULL,NULL),(10144,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:30',NULL,NULL),(10980,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:11',NULL,NULL),(10703,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:21',NULL,NULL),(18266,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:08',NULL,NULL),(23549,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 21:30:02',NULL,NULL),(3758,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:31',NULL,NULL),(13671,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:46',NULL,NULL),(12872,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:09',NULL,NULL),(7135,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:28',NULL,NULL),(10676,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:14',NULL,NULL),(19359,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:42',NULL,NULL),(21490,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:40',NULL,NULL),(21504,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:45',NULL,NULL),(22658,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:26',NULL,NULL),(20666,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:56',NULL,NULL),(10710,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:22',NULL,NULL),(10559,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:43',NULL,NULL),(6429,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:38',NULL,NULL),(2353,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:52',NULL,NULL),(1543,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:04',NULL,NULL),(17527,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:28',NULL,NULL),(17932,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:30',NULL,NULL),(20931,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:16',NULL,NULL),(3028,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:08',NULL,NULL),(13151,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:20',NULL,NULL),(11916,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:24',NULL,NULL),(8693,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:50',NULL,NULL),(11122,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:54',NULL,NULL),(17735,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:42',NULL,NULL),(22623,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:15',NULL,NULL),(20135,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:01',NULL,NULL),(17186,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:59',NULL,NULL),(390,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:52',NULL,NULL),(622,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:09',NULL,NULL),(5298,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:58',NULL,NULL),(17052,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:15',NULL,NULL),(5193,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:27',NULL,NULL),(1424,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:22',NULL,NULL),(3250,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:28',NULL,NULL),(1921,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:57',NULL,NULL),(2172,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:23',NULL,NULL),(1943,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:02',NULL,NULL),(7793,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:09',NULL,NULL),(8950,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:59',NULL,NULL),(8986,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:09',NULL,NULL),(9550,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:09',NULL,NULL),(10129,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:26',NULL,NULL),(22383,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:10',NULL,NULL),(23048,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(19100,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:36',NULL,NULL),(21707,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:23',NULL,NULL),(16767,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:50',NULL,NULL),(12779,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:38',NULL,NULL),(1286,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:30',NULL,NULL),(7854,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:27',NULL,NULL),(3088,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:31',NULL,NULL),(3726,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:23',NULL,NULL),(18919,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:45',NULL,NULL),(19113,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:40',NULL,NULL),(19445,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:06',NULL,NULL),(22805,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:20',NULL,NULL),(23317,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:21',NULL,NULL),(1463,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:36',NULL,NULL),(5828,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:23',NULL,NULL),(16855,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:21',NULL,NULL),(7286,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:10',NULL,NULL),(21716,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:26',NULL,NULL),(10298,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:12',NULL,NULL),(13260,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:49',NULL,NULL),(11024,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:23',NULL,NULL),(11062,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:37',NULL,NULL),(409,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:00',NULL,NULL),(14324,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:25',NULL,NULL),(12751,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:31',NULL,NULL),(10773,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:38',NULL,NULL),(5350,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:12',NULL,NULL),(3930,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:15',NULL,NULL),(4372,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:04',NULL,NULL),(9619,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:27',NULL,NULL),(8214,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:52',NULL,NULL),(19678,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:12',NULL,NULL),(23129,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:40',NULL,NULL),(14631,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:05',NULL,NULL),(1982,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:35',NULL,NULL),(6198,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:36',NULL,NULL),(2233,1884,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:30:21',NULL,NULL),(2645,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:32:07',NULL,NULL),(8808,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:21',NULL,NULL),(9249,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:10',NULL,NULL),(9783,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:09',NULL,NULL),(10687,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:17',NULL,NULL),(12022,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:10',NULL,NULL),(12537,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:30',NULL,NULL),(12555,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:35',NULL,NULL),(12759,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:33',NULL,NULL),(21544,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:59',NULL,NULL),(22313,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:47',NULL,NULL),(2483,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:26',NULL,NULL),(14699,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:24',NULL,NULL),(9505,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:57',NULL,NULL),(5605,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:06',NULL,NULL),(23498,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:24',NULL,NULL),(17345,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:28',NULL,NULL),(17834,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:57',NULL,NULL),(21269,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:19',NULL,NULL),(22198,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:18',NULL,NULL),(22410,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:19',NULL,NULL),(15226,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:57',NULL,NULL),(1015,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:21',NULL,NULL),(1320,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:42',NULL,NULL),(10306,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:14',NULL,NULL),(10253,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:59',NULL,NULL),(12566,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:38',NULL,NULL),(5124,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:08',NULL,NULL),(4946,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:34',NULL,NULL),(7672,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:37',NULL,NULL),(8812,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:22',NULL,NULL),(4711,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:28',NULL,NULL),(16396,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:30',NULL,NULL),(18633,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:50',NULL,NULL),(18736,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:35:54',NULL,NULL),(21145,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:15',NULL,NULL),(22557,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:08',NULL,NULL),(23597,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 21:30:03',NULL,NULL),(144,161,'2013-12-27','11:20:00','A','000',0,'2014-01-13 03:04:49',NULL,NULL),(15131,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:31',NULL,NULL),(14919,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:00:24',NULL,NULL),(1445,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:29',NULL,NULL),(3519,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:41',NULL,NULL),(4301,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:45',NULL,NULL),(8523,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:05',NULL,NULL),(8491,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:08',NULL,NULL),(14772,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:44',NULL,NULL),(5534,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:03',NULL,NULL),(16518,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:16',NULL,NULL),(17013,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:02',NULL,NULL),(18740,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:35:56',NULL,NULL),(19612,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:52',NULL,NULL),(23636,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 02:00:02',NULL,NULL),(15153,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:38',NULL,NULL),(14786,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:48',NULL,NULL),(5884,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:42',NULL,NULL),(8549,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:12',NULL,NULL),(1894,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:50',NULL,NULL),(9673,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:41',NULL,NULL),(2354,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:52',NULL,NULL),(2460,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:20',NULL,NULL),(2589,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:52',NULL,NULL),(15774,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:29',NULL,NULL),(16584,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:40',NULL,NULL),(21530,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:54',NULL,NULL),(9004,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:04',NULL,NULL),(387,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:51',NULL,NULL),(5563,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:12',NULL,NULL),(596,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:01',NULL,NULL),(8849,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:31',NULL,NULL),(4404,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:12',NULL,NULL),(6321,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:08',NULL,NULL),(6048,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:40',NULL,NULL),(17831,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:55',NULL,NULL),(18903,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:41',NULL,NULL),(20515,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:01',NULL,NULL),(20892,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:05',NULL,NULL),(21627,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:31',NULL,NULL),(21702,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:21',NULL,NULL),(13298,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:59',NULL,NULL),(70,370,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:05',NULL,NULL),(12345,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:41',NULL,NULL),(9904,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:41',NULL,NULL),(18996,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:08',NULL,NULL),(14607,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:58',NULL,NULL),(7114,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:22',NULL,NULL),(3740,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:27',NULL,NULL),(7174,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:38',NULL,NULL),(3291,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:40',NULL,NULL),(3167,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:04',NULL,NULL),(3068,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:24',NULL,NULL),(2594,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:53',NULL,NULL),(19161,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:55',NULL,NULL),(19877,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:48',NULL,NULL),(20035,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:33',NULL,NULL),(14112,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:51',NULL,NULL),(403,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:58',NULL,NULL),(445,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:12',NULL,NULL),(13847,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:12',NULL,NULL),(3833,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:50',NULL,NULL),(16238,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:50',NULL,NULL),(17281,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:06',NULL,NULL),(23448,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:07',NULL,NULL),(23474,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:17',NULL,NULL),(575,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:54',NULL,NULL),(16023,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:32',NULL,NULL),(1545,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:05',NULL,NULL),(13587,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:35',NULL,NULL),(1911,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:54',NULL,NULL),(2948,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:39',NULL,NULL),(9942,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:51',NULL,NULL),(12826,1843,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:52',NULL,NULL),(6681,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:31',NULL,NULL),(11876,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:14',NULL,NULL),(11057,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:33',NULL,NULL),(11747,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:41',NULL,NULL),(1937,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:01',NULL,NULL),(16029,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:34',NULL,NULL),(14956,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:33',NULL,NULL),(5919,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:54',NULL,NULL),(13632,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:41',NULL,NULL),(5662,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:26',NULL,NULL),(4322,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:50',NULL,NULL),(16894,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:31',NULL,NULL),(17474,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:10',NULL,NULL),(91,262,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:25',NULL,NULL),(14472,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:21',NULL,NULL),(11074,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:41',NULL,NULL),(552,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:47',NULL,NULL),(3676,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:10',NULL,NULL),(9229,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:05',NULL,NULL),(8127,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:29',NULL,NULL),(3247,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:27',NULL,NULL),(1197,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:11',NULL,NULL),(1850,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:39',NULL,NULL),(7963,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:56',NULL,NULL),(6818,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:08',NULL,NULL),(1600,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:24',NULL,NULL),(15555,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:15',NULL,NULL),(4872,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:12',NULL,NULL),(14101,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:49',NULL,NULL),(13742,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:57',NULL,NULL),(13355,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:14',NULL,NULL),(5712,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:43',NULL,NULL),(6764,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:51',NULL,NULL),(12753,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:31',NULL,NULL),(11935,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:45',NULL,NULL),(19191,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:38:03',NULL,NULL),(20019,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:28',NULL,NULL),(1595,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:23',NULL,NULL),(5043,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:01',NULL,NULL),(4553,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:50',NULL,NULL),(13267,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:51',NULL,NULL),(11678,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:23',NULL,NULL),(5965,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:11',NULL,NULL),(11459,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:28',NULL,NULL),(7944,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:51',NULL,NULL),(20974,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:27',NULL,NULL),(21051,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:49',NULL,NULL),(225,289,'2013-12-27','15:33:00','A','000',0,'2014-01-13 03:05:16',NULL,NULL),(12700,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:16',NULL,NULL),(11999,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:04',NULL,NULL),(9327,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:31',NULL,NULL),(6652,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:23',NULL,NULL),(990,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:15',NULL,NULL),(6141,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:21',NULL,NULL),(19478,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:15',NULL,NULL),(20984,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:30',NULL,NULL),(21250,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:12',NULL,NULL),(2156,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:19',NULL,NULL),(3496,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:35',NULL,NULL),(5094,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:15',NULL,NULL),(4717,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:30',NULL,NULL),(6841,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:13',NULL,NULL),(14703,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:25',NULL,NULL),(7571,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:11',NULL,NULL),(16761,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:48',NULL,NULL),(17175,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:56',NULL,NULL),(18368,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:37',NULL,NULL),(22304,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:45',NULL,NULL),(9906,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:42',NULL,NULL),(2787,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:43',NULL,NULL),(4601,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:32:02',NULL,NULL),(16904,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:33',NULL,NULL),(17691,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:28',NULL,NULL),(20061,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:40',NULL,NULL),(21907,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:34',NULL,NULL),(21317,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:36',NULL,NULL),(1202,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:13',NULL,NULL),(12017,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:09',NULL,NULL),(8544,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:11',NULL,NULL),(2239,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:23',NULL,NULL),(16980,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:52',NULL,NULL),(22740,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:55',NULL,NULL),(16481,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:02',NULL,NULL),(3816,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:46',NULL,NULL),(5943,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:03',NULL,NULL),(13601,1868,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:37',NULL,NULL),(7067,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:06',NULL,NULL),(7129,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:26',NULL,NULL),(13240,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:44',NULL,NULL),(12841,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:58',NULL,NULL),(12724,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:23',NULL,NULL),(17258,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:24',NULL,NULL),(17602,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:55',NULL,NULL),(18176,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:54',NULL,NULL),(19197,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:38:04',NULL,NULL),(20228,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:17',NULL,NULL),(511,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:33',NULL,NULL),(1061,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:34',NULL,NULL),(15942,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:03',NULL,NULL),(10976,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:10',NULL,NULL),(10668,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:12',NULL,NULL),(9380,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:45',NULL,NULL),(18271,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:10',NULL,NULL),(378,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:48',NULL,NULL),(15159,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:41',NULL,NULL),(14459,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:17',NULL,NULL),(967,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:08',NULL,NULL),(1451,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:32',NULL,NULL),(14068,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:45',NULL,NULL),(13659,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:45',NULL,NULL),(12915,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:17',NULL,NULL),(9063,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:20',NULL,NULL),(12638,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:58',NULL,NULL),(9839,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:25',NULL,NULL),(21130,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:11',NULL,NULL),(21678,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:13',NULL,NULL),(22477,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:42',NULL,NULL),(15763,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:26',NULL,NULL),(5995,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:21',NULL,NULL),(6508,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:59',NULL,NULL),(15256,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:03',NULL,NULL),(12119,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:36',NULL,NULL),(9286,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:20',NULL,NULL),(9583,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:17',NULL,NULL),(10218,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:50',NULL,NULL),(11139,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:59',NULL,NULL),(17904,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:21',NULL,NULL),(19133,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:46',NULL,NULL),(21355,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:49',NULL,NULL),(21461,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:28',NULL,NULL),(21524,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:52',NULL,NULL),(21881,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:25',NULL,NULL),(23247,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(15400,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:31',NULL,NULL),(12138,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:41',NULL,NULL),(3856,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:56',NULL,NULL),(7352,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:28',NULL,NULL),(12071,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:23',NULL,NULL),(11752,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:42',NULL,NULL),(11452,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:26',NULL,NULL),(10566,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:44',NULL,NULL),(17738,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:43',NULL,NULL),(17978,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:46',NULL,NULL),(18292,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:17',NULL,NULL),(18573,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:34',NULL,NULL),(20563,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:19',NULL,NULL),(22074,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:33',NULL,NULL),(22269,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:37',NULL,NULL),(23066,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:29',NULL,NULL),(23310,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:19',NULL,NULL),(16196,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:35',NULL,NULL),(15190,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:51',NULL,NULL),(3434,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:18',NULL,NULL),(2861,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:09',NULL,NULL),(3300,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:30:42',NULL,NULL),(10353,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:28',NULL,NULL),(11291,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:42',NULL,NULL),(11441,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:23',NULL,NULL),(11817,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:59',NULL,NULL),(14209,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:06',NULL,NULL),(15389,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:28',NULL,NULL),(12361,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:45',NULL,NULL),(11635,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:15:12',NULL,NULL),(4532,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:45',NULL,NULL),(11199,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:17',NULL,NULL),(10841,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:55',NULL,NULL),(9591,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:20',NULL,NULL),(2548,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:42',NULL,NULL),(8418,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:49',NULL,NULL),(19957,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:10',NULL,NULL),(20625,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:41',NULL,NULL),(22109,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:46',NULL,NULL),(16830,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:14',NULL,NULL),(15766,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:26',NULL,NULL),(5231,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:38',NULL,NULL),(15440,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:38',NULL,NULL),(13520,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:26',NULL,NULL),(10171,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:37',NULL,NULL),(2000,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:40',NULL,NULL),(7072,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:09',NULL,NULL),(19503,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:22',NULL,NULL),(20689,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:08',NULL,NULL),(20850,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:54',NULL,NULL),(20887,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:04',NULL,NULL),(21949,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:49',NULL,NULL),(2278,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:33',NULL,NULL),(3189,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:10',NULL,NULL),(5700,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:39',NULL,NULL),(6465,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:48',NULL,NULL),(16960,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:47',NULL,NULL),(14874,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:12',NULL,NULL),(14653,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:12',NULL,NULL),(9310,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:26',NULL,NULL),(19249,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:11',NULL,NULL),(20113,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:55',NULL,NULL),(20612,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:36',NULL,NULL),(23238,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:01',NULL,NULL),(5422,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:31',NULL,NULL),(5517,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:57',NULL,NULL),(18190,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:59',NULL,NULL),(17879,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:12',NULL,NULL),(17601,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:54',NULL,NULL),(10800,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:45',NULL,NULL),(17009,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:00',NULL,NULL),(15881,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:42',NULL,NULL),(14871,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:11',NULL,NULL),(14267,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:15',NULL,NULL),(12714,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:20',NULL,NULL),(12791,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:41',NULL,NULL),(14235,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:10',NULL,NULL),(19538,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:32',NULL,NULL),(20234,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:19',NULL,NULL),(21777,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:48',NULL,NULL),(23417,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:56',NULL,NULL),(712,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:40',NULL,NULL),(2023,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:46',NULL,NULL),(15856,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:33',NULL,NULL),(15760,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:24',NULL,NULL),(14375,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:52',NULL,NULL),(5569,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:13',NULL,NULL),(7724,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:50',NULL,NULL),(14005,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:36',NULL,NULL),(8905,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:47',NULL,NULL),(12128,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:38',NULL,NULL),(12730,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:25',NULL,NULL),(18674,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:01',NULL,NULL),(19870,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:47',NULL,NULL),(20338,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:57',NULL,NULL),(21271,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:19',NULL,NULL),(22713,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:45',NULL,NULL),(899,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:50',NULL,NULL),(12336,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:38',NULL,NULL),(3926,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:14',NULL,NULL),(3936,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:16',NULL,NULL),(12212,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:02',NULL,NULL),(7424,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:48',NULL,NULL),(12202,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:59',NULL,NULL),(11064,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:37',NULL,NULL),(10590,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:50',NULL,NULL),(22140,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:03',NULL,NULL),(1062,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:34',NULL,NULL),(6412,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:34',NULL,NULL),(17091,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:28',NULL,NULL),(4812,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:56',NULL,NULL),(4291,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:42',NULL,NULL),(15224,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:57',NULL,NULL),(14262,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:14',NULL,NULL),(10460,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:17',NULL,NULL),(19902,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:55',NULL,NULL),(85,330,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:19',NULL,NULL),(181,281,'2013-12-27','15:31:00','A','000',0,'2014-01-13 03:05:01',NULL,NULL),(13168,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:25',NULL,NULL),(13070,1854,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:26:59',NULL,NULL),(619,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:08',NULL,NULL),(11850,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:07',NULL,NULL),(7692,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:42',NULL,NULL),(22123,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:51',NULL,NULL),(23359,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:36',NULL,NULL),(14853,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:06',NULL,NULL),(17787,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:38',NULL,NULL),(11781,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:50',NULL,NULL),(19434,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:03',NULL,NULL),(14687,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:21',NULL,NULL),(3365,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:59',NULL,NULL),(7138,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:28',NULL,NULL),(3482,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:31',NULL,NULL),(6386,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:27',NULL,NULL),(8005,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:02:07',NULL,NULL),(14454,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:16',NULL,NULL),(19234,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:07',NULL,NULL),(20577,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:24',NULL,NULL),(22727,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:50',NULL,NULL),(2494,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:28',NULL,NULL),(2730,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:23',NULL,NULL),(3685,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:12',NULL,NULL),(18046,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:10',NULL,NULL),(4082,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:53',NULL,NULL),(5556,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:10',NULL,NULL),(7992,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:02:03',NULL,NULL),(17755,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:49',NULL,NULL),(17514,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:23',NULL,NULL),(8971,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:04',NULL,NULL),(10655,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:08',NULL,NULL),(20877,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:01',NULL,NULL),(4110,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:02:01',NULL,NULL),(5383,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:21',NULL,NULL),(8139,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:32',NULL,NULL),(15455,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:41',NULL,NULL),(15251,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:02',NULL,NULL),(10400,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:41',NULL,NULL),(11241,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:29',NULL,NULL),(11943,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:47',NULL,NULL),(23570,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 15:30:02',NULL,NULL),(20594,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:30',NULL,NULL),(16051,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:42',NULL,NULL),(7747,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:56',NULL,NULL),(7226,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:54',NULL,NULL),(15882,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:42',NULL,NULL),(6021,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:30',NULL,NULL),(5746,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:55',NULL,NULL),(294,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:19',NULL,NULL),(11946,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:48',NULL,NULL),(8615,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:29',NULL,NULL),(21273,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:20',NULL,NULL),(22792,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:15',NULL,NULL),(14179,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:01',NULL,NULL),(13426,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:11',NULL,NULL),(12027,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:11',NULL,NULL),(4758,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:41',NULL,NULL),(8154,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:36',NULL,NULL),(2431,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:12',NULL,NULL),(2312,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:41',NULL,NULL),(17534,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:30',NULL,NULL),(16697,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:25',NULL,NULL),(16457,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:53',NULL,NULL),(16228,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:46',NULL,NULL),(14690,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:22',NULL,NULL),(4001,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:32',NULL,NULL),(5652,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:22',NULL,NULL),(8268,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:06',NULL,NULL),(11065,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:38',NULL,NULL),(2738,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:25',NULL,NULL),(15191,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:01:51',NULL,NULL),(10858,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:59',NULL,NULL),(21266,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:17',NULL,NULL),(21268,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:18',NULL,NULL),(17641,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:09',NULL,NULL),(8066,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:13',NULL,NULL),(16373,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:21',NULL,NULL),(5249,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:43',NULL,NULL),(13688,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:48',NULL,NULL),(6838,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:13',NULL,NULL),(6265,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:53',NULL,NULL),(13218,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:38',NULL,NULL),(21177,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:44',NULL,NULL),(21800,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:56',NULL,NULL),(23432,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:00',NULL,NULL),(23669,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 11:29:58',NULL,NULL),(366,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:44',NULL,NULL),(19187,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:02',NULL,NULL),(2664,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:12',NULL,NULL),(6577,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:04',NULL,NULL),(3346,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:54',NULL,NULL),(19029,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:17',NULL,NULL),(17618,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:01',NULL,NULL),(22343,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:57',NULL,NULL),(22602,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:23',NULL,NULL),(17610,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:58',NULL,NULL),(13474,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:18',NULL,NULL),(16463,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:55',NULL,NULL),(14250,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:13',NULL,NULL),(14726,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:31',NULL,NULL),(14588,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:52',NULL,NULL),(22701,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:41',NULL,NULL),(23055,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(2268,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:30',NULL,NULL),(19017,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:14',NULL,NULL),(7366,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:32',NULL,NULL),(17926,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:28',NULL,NULL),(7231,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:55',NULL,NULL),(5928,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:57',NULL,NULL),(3572,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:55',NULL,NULL),(4636,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:06',NULL,NULL),(15312,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:14',NULL,NULL),(14529,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:36',NULL,NULL),(14143,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:56',NULL,NULL),(11369,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:04',NULL,NULL),(20769,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:30',NULL,NULL),(21128,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:10',NULL,NULL),(21562,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:06',NULL,NULL),(18761,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:01',NULL,NULL),(17909,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:23',NULL,NULL),(17613,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:59',NULL,NULL),(7512,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:12',NULL,NULL),(6846,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:14',NULL,NULL),(8560,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:15',NULL,NULL),(9246,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:10',NULL,NULL),(10919,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:46:15',NULL,NULL),(12981,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:36',NULL,NULL),(13395,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:05',NULL,NULL),(16632,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:59',NULL,NULL),(14637,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:07',NULL,NULL),(15475,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:47',NULL,NULL),(18011,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:58',NULL,NULL),(19811,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:31',NULL,NULL),(7826,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:19',NULL,NULL),(4069,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:50',NULL,NULL),(5401,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:25',NULL,NULL),(19104,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:37',NULL,NULL),(17653,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:14',NULL,NULL),(14597,1852,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:50:54',NULL,NULL),(11127,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:56',NULL,NULL),(3339,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:52',NULL,NULL),(19825,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:35',NULL,NULL),(19650,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:04',NULL,NULL),(4794,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:51',NULL,NULL),(5608,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:07',NULL,NULL),(9402,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:50',NULL,NULL),(9477,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:11',NULL,NULL),(10452,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:55',NULL,NULL),(19631,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:58',NULL,NULL),(11739,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:39',NULL,NULL),(17232,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:15',NULL,NULL),(13111,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:10',NULL,NULL),(21003,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:35',NULL,NULL),(21182,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:46',NULL,NULL),(22809,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:22',NULL,NULL),(47,298,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:44',NULL,NULL),(8099,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:22',NULL,NULL),(1149,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:58',NULL,NULL),(1321,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:42',NULL,NULL),(6300,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:03',NULL,NULL),(19840,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:39',NULL,NULL),(14850,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:05',NULL,NULL),(8860,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:34',NULL,NULL),(12408,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:21:54',NULL,NULL),(14154,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:58',NULL,NULL),(7330,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:22',NULL,NULL),(7275,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:07',NULL,NULL),(20140,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:02',NULL,NULL),(22514,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:53',NULL,NULL),(23447,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:07',NULL,NULL),(17369,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:36',NULL,NULL),(1457,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:34',NULL,NULL),(6147,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:22',NULL,NULL),(1596,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:23',NULL,NULL),(5755,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:58',NULL,NULL),(14435,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:10',NULL,NULL),(13730,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:55',NULL,NULL),(6867,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:21',NULL,NULL),(2805,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:49',NULL,NULL),(4116,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:02',NULL,NULL),(3984,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:28',NULL,NULL),(3279,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:36',NULL,NULL),(18439,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:56',NULL,NULL),(18571,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:34',NULL,NULL),(20354,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:02',NULL,NULL),(22825,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:28',NULL,NULL),(14302,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:20',NULL,NULL),(14003,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:35',NULL,NULL),(5936,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:00',NULL,NULL),(1799,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:27',NULL,NULL),(13516,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:25',NULL,NULL),(2712,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:16',NULL,NULL),(2351,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:51',NULL,NULL),(7290,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:11',NULL,NULL),(11514,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:41',NULL,NULL),(11484,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:34',NULL,NULL),(18471,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:06',NULL,NULL),(18472,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:06',NULL,NULL),(18635,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:51',NULL,NULL),(23626,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 18:00:02',NULL,NULL),(585,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:57',NULL,NULL),(16225,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:45',NULL,NULL),(6218,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:41',NULL,NULL),(5259,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:45',NULL,NULL),(15571,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:21',NULL,NULL),(9697,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:47',NULL,NULL),(8705,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:53',NULL,NULL),(8614,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:29',NULL,NULL),(18763,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:02',NULL,NULL),(20783,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:35',NULL,NULL),(21101,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:02',NULL,NULL),(21696,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:19',NULL,NULL),(22835,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:31',NULL,NULL),(17117,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:37',NULL,NULL),(6298,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:02',NULL,NULL),(15842,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:28',NULL,NULL),(2187,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:02',NULL,NULL),(14810,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:54',NULL,NULL),(14297,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:19',NULL,NULL),(2663,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:12',NULL,NULL),(8554,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:13',NULL,NULL),(14106,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:50',NULL,NULL),(9471,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:32:10',NULL,NULL),(13176,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:27',NULL,NULL),(10968,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:08',NULL,NULL),(20498,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:55',NULL,NULL),(21134,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:12',NULL,NULL),(23028,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(17275,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:04',NULL,NULL),(6898,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:30',NULL,NULL),(1609,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:27',NULL,NULL),(16929,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:39',NULL,NULL),(2307,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:30:40',NULL,NULL),(18154,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:14:46',NULL,NULL),(10024,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:57',NULL,NULL),(9263,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:14',NULL,NULL),(18768,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:03',NULL,NULL),(20443,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:36',NULL,NULL),(22693,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:39',NULL,NULL),(2534,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:38',NULL,NULL),(17483,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:13',NULL,NULL),(13956,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:28',NULL,NULL),(13955,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:28',NULL,NULL),(12645,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:00',NULL,NULL),(12211,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:01',NULL,NULL),(8728,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:59',NULL,NULL),(4308,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:47',NULL,NULL),(23693,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 11:30:02',NULL,NULL),(354,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:40',NULL,NULL),(7276,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:07',NULL,NULL),(16811,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:09',NULL,NULL),(16624,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:56',NULL,NULL),(3503,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:37',NULL,NULL),(15820,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:19',NULL,NULL),(13496,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:21',NULL,NULL),(8742,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:03',NULL,NULL),(22448,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:32',NULL,NULL),(790,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:20',NULL,NULL),(10881,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:06',NULL,NULL),(1111,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:47',NULL,NULL),(3377,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:03',NULL,NULL),(3652,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:04',NULL,NULL),(4724,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:32',NULL,NULL),(5257,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:45',NULL,NULL),(5222,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:35',NULL,NULL),(10593,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:51',NULL,NULL),(23280,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:09',NULL,NULL),(17604,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:56',NULL,NULL),(1880,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:47',NULL,NULL),(2713,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:16',NULL,NULL),(4635,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:06',NULL,NULL),(5880,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:41',NULL,NULL),(9943,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:51',NULL,NULL),(11796,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:53',NULL,NULL),(12544,1828,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:32',NULL,NULL),(20678,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:03',NULL,NULL),(18585,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:38',NULL,NULL),(6497,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:56',NULL,NULL),(18362,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:36',NULL,NULL),(9320,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:29',NULL,NULL),(10796,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:44',NULL,NULL),(11561,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:53',NULL,NULL),(16212,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:41',NULL,NULL),(13334,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:09',NULL,NULL),(14056,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:43',NULL,NULL),(496,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:28',NULL,NULL),(17005,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:59',NULL,NULL),(14590,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:53',NULL,NULL),(10669,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:12',NULL,NULL),(10411,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:44',NULL,NULL),(2443,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:16',NULL,NULL),(19484,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:17',NULL,NULL),(19658,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:07',NULL,NULL),(23679,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 15:30:04',NULL,NULL),(1360,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:58',NULL,NULL),(10745,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:31',NULL,NULL),(5458,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:41',NULL,NULL),(19363,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:43',NULL,NULL),(20991,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:32',NULL,NULL),(22559,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:08',NULL,NULL),(22913,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:57',NULL,NULL),(913,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:54',NULL,NULL),(17356,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:31',NULL,NULL),(2136,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:14',NULL,NULL),(16943,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:43',NULL,NULL),(6060,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:44',NULL,NULL),(2675,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:03',NULL,NULL),(16219,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:43',NULL,NULL),(20438,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:34',NULL,NULL),(17817,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:50',NULL,NULL),(6376,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:24',NULL,NULL),(14136,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:55',NULL,NULL),(7792,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:09',NULL,NULL),(5645,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:20',NULL,NULL),(3921,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:13',NULL,NULL),(8851,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:32',NULL,NULL),(9014,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:06',NULL,NULL),(10634,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:01',NULL,NULL),(12763,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:34',NULL,NULL),(21485,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:38',NULL,NULL),(22498,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:48',NULL,NULL),(14043,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:41',NULL,NULL),(11232,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:26',NULL,NULL),(1693,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:02:59',NULL,NULL),(5719,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:46',NULL,NULL),(20306,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:45',NULL,NULL),(23721,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 19:29:58',NULL,NULL),(19149,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:51',NULL,NULL),(2476,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:24',NULL,NULL),(18672,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:01',NULL,NULL),(3415,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:13',NULL,NULL),(10130,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:26',NULL,NULL),(10457,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:56',NULL,NULL),(11905,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:21',NULL,NULL),(23085,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:32',NULL,NULL),(23602,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 15:30:02',NULL,NULL),(13128,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:14',NULL,NULL),(14093,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:48',NULL,NULL),(14114,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:52',NULL,NULL),(15806,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:40',NULL,NULL),(22368,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:05',NULL,NULL),(19683,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:13',NULL,NULL),(19210,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:08',NULL,NULL),(1611,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:28',NULL,NULL),(2434,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:13',NULL,NULL),(18975,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:02',NULL,NULL),(16890,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:30',NULL,NULL),(15065,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:09',NULL,NULL),(21472,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:32',NULL,NULL),(22900,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:59:53',NULL,NULL),(23049,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(23296,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:13',NULL,NULL),(209,190,'2013-12-27','14:55:00','A','000',0,'2014-01-13 03:05:10',NULL,NULL),(16924,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:38',NULL,NULL),(1554,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:08',NULL,NULL),(16674,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:17',NULL,NULL),(15477,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:48',NULL,NULL),(13668,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:46',NULL,NULL),(13082,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:02',NULL,NULL),(9582,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:17',NULL,NULL),(10714,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:23',NULL,NULL),(11443,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:24',NULL,NULL),(12248,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:12',NULL,NULL),(18857,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:28',NULL,NULL),(18770,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:36:04',NULL,NULL),(17216,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:10',NULL,NULL),(15112,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:25',NULL,NULL),(13663,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:45',NULL,NULL),(11242,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:29',NULL,NULL),(492,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:27',NULL,NULL),(17287,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:08',NULL,NULL),(937,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:00',NULL,NULL),(2710,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:00:15',NULL,NULL),(17114,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:36',NULL,NULL),(4903,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:20',NULL,NULL),(13937,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:25',NULL,NULL),(12050,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:18',NULL,NULL),(10672,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:13',NULL,NULL),(9983,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:45',NULL,NULL),(21892,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:29',NULL,NULL),(22181,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:13',NULL,NULL),(23395,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:48',NULL,NULL),(19036,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:19',NULL,NULL),(18588,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:39',NULL,NULL),(18106,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:31',NULL,NULL),(15897,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:48',NULL,NULL),(15331,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:18',NULL,NULL),(12434,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:01',NULL,NULL),(5263,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:46',NULL,NULL),(11182,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:11',NULL,NULL),(2739,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:26',NULL,NULL),(10073,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:10',NULL,NULL),(2961,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:45',NULL,NULL),(21131,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:11',NULL,NULL),(21991,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:04',NULL,NULL),(145,156,'2013-12-27','11:13:00','A','000',0,'2014-01-13 03:04:50',NULL,NULL),(8133,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:30',NULL,NULL),(8037,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:05',NULL,NULL),(529,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:39',NULL,NULL),(19842,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:39',NULL,NULL),(4418,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:16',NULL,NULL),(16245,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:53',NULL,NULL),(3471,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:28',NULL,NULL),(16018,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:30',NULL,NULL),(9077,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:24',NULL,NULL),(15482,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:50',NULL,NULL),(9761,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:03',NULL,NULL),(9870,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:33',NULL,NULL),(10182,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:40',NULL,NULL),(21293,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:27',NULL,NULL),(22935,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(18710,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:12',NULL,NULL),(8336,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:27',NULL,NULL),(18297,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:18',NULL,NULL),(18175,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:54',NULL,NULL),(9112,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:33',NULL,NULL),(17233,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:15',NULL,NULL),(15371,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:25',NULL,NULL),(10325,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:19',NULL,NULL),(10965,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:07',NULL,NULL),(1810,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:29',NULL,NULL),(17342,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:27',NULL,NULL),(12787,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:40',NULL,NULL),(10978,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:11',NULL,NULL),(3557,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:51',NULL,NULL),(6785,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:59',NULL,NULL),(6680,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:31',NULL,NULL),(6222,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:42',NULL,NULL),(6089,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:05',NULL,NULL),(5847,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:30',NULL,NULL),(5561,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:11',NULL,NULL),(1929,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:59',NULL,NULL),(4952,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:36',NULL,NULL),(20195,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:05',NULL,NULL),(508,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:33',NULL,NULL),(3540,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:47',NULL,NULL),(10584,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:49',NULL,NULL),(10712,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:23',NULL,NULL),(11433,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:21',NULL,NULL),(12029,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:12',NULL,NULL),(20923,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:14',NULL,NULL),(22342,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:56',NULL,NULL),(17349,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:29',NULL,NULL),(359,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:42',NULL,NULL),(8347,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:30',NULL,NULL),(7377,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:35',NULL,NULL),(19614,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:53',NULL,NULL),(6472,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:50',NULL,NULL),(18188,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:58',NULL,NULL),(5388,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:22',NULL,NULL),(1743,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:13',NULL,NULL),(4748,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:38',NULL,NULL),(2193,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:04',NULL,NULL),(4068,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:50',NULL,NULL),(18118,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:34',NULL,NULL),(8771,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:11',NULL,NULL),(16521,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:17',NULL,NULL),(20764,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:29',NULL,NULL),(19275,1877,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:00:18',NULL,NULL),(17537,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:31',NULL,NULL),(4040,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:43',NULL,NULL),(4719,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:30',NULL,NULL),(5584,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:18',NULL,NULL),(5180,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:24',NULL,NULL),(6003,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:24',NULL,NULL),(19931,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:02',NULL,NULL),(20775,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:33',NULL,NULL),(1497,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:48',NULL,NULL),(18003,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:54',NULL,NULL),(17996,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:52',NULL,NULL),(17711,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:34',NULL,NULL),(7967,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:57',NULL,NULL),(16036,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:37',NULL,NULL),(15850,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:31',NULL,NULL),(5897,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:47',NULL,NULL),(3523,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:42',NULL,NULL),(5470,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:44',NULL,NULL),(4838,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:03',NULL,NULL),(11243,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:29',NULL,NULL),(19941,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:05',NULL,NULL),(21753,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:40',NULL,NULL),(23363,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:38',NULL,NULL),(23543,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 01:30:02',NULL,NULL),(213,336,'2013-12-27','15:49:00','A','000',0,'2014-01-13 03:05:12',NULL,NULL),(7817,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:17',NULL,NULL),(18641,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:53',NULL,NULL),(1099,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:44',NULL,NULL),(18403,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:47',NULL,NULL),(6162,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:26',NULL,NULL),(5424,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:32',NULL,NULL),(2842,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:02',NULL,NULL),(5113,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:03',NULL,NULL),(18344,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:31',NULL,NULL),(16429,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:42',NULL,NULL),(16046,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:40',NULL,NULL),(9982,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:45',NULL,NULL),(15275,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:07',NULL,NULL),(12493,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:18',NULL,NULL),(21013,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:38',NULL,NULL),(21398,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:05',NULL,NULL),(22255,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:33',NULL,NULL),(22555,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:07',NULL,NULL),(22656,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:26',NULL,NULL),(17181,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:58',NULL,NULL),(16657,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:10',NULL,NULL),(2535,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:39',NULL,NULL),(2623,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:01',NULL,NULL),(2909,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:25',NULL,NULL),(3686,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:13',NULL,NULL),(3717,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:20',NULL,NULL),(12485,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:16',NULL,NULL),(4163,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:10',NULL,NULL),(6849,1856,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:01:15',NULL,NULL),(11197,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:16',NULL,NULL),(8908,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:48',NULL,NULL),(9693,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:46',NULL,NULL),(1562,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:11',NULL,NULL),(4392,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:09',NULL,NULL),(15171,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:45',NULL,NULL),(7756,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:59',NULL,NULL),(14987,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:43',NULL,NULL),(7137,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:28',NULL,NULL),(4394,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:10',NULL,NULL),(4876,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:13',NULL,NULL),(5554,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:09',NULL,NULL),(13593,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:36',NULL,NULL),(13007,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:42',NULL,NULL),(21484,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:37',NULL,NULL),(23361,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:37',NULL,NULL),(1741,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:13',NULL,NULL),(17815,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:49',NULL,NULL),(17184,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:59',NULL,NULL),(16501,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:10',NULL,NULL),(12103,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:32',NULL,NULL),(4201,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:20',NULL,NULL),(10219,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:50',NULL,NULL),(5148,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:15',NULL,NULL),(10138,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:28',NULL,NULL),(21189,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:49',NULL,NULL),(22736,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:53',NULL,NULL),(150,296,'2013-12-27','15:35:00','A','000',0,'2014-01-13 03:04:51',NULL,NULL),(7941,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:50',NULL,NULL),(459,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:16',NULL,NULL),(19523,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:28',NULL,NULL),(18442,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:57',NULL,NULL),(3110,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:39',NULL,NULL),(3891,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:05',NULL,NULL),(5917,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:54',NULL,NULL),(17130,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:41',NULL,NULL),(16019,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:31',NULL,NULL),(15385,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:28',NULL,NULL),(13306,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:01',NULL,NULL),(11701,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:29',NULL,NULL),(19708,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:04',NULL,NULL),(3933,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:16',NULL,NULL),(19379,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:48',NULL,NULL),(6774,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:55',NULL,NULL),(18111,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:32',NULL,NULL),(17654,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:14',NULL,NULL),(9329,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:31',NULL,NULL),(11096,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:47',NULL,NULL),(12037,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:14',NULL,NULL),(12553,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:34',NULL,NULL),(12564,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:37',NULL,NULL),(17239,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:17',NULL,NULL),(13349,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:13',NULL,NULL),(13756,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:59',NULL,NULL),(14930,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:27',NULL,NULL),(1647,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:40',NULL,NULL),(9133,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:40',NULL,NULL),(9070,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:22',NULL,NULL),(17907,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:22',NULL,NULL),(2692,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:09',NULL,NULL),(8082,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:17',NULL,NULL),(3061,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:22',NULL,NULL),(17632,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:06',NULL,NULL),(17177,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:56',NULL,NULL),(16569,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:34',NULL,NULL),(14087,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:47',NULL,NULL),(11417,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:18',NULL,NULL),(22328,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:51',NULL,NULL),(22485,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:44',NULL,NULL),(700,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:36',NULL,NULL),(18147,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:44',NULL,NULL),(17081,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:25',NULL,NULL),(4310,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:47',NULL,NULL),(5745,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:54',NULL,NULL),(14604,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:56',NULL,NULL),(13606,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:37',NULL,NULL),(13090,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:04',NULL,NULL),(19086,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:33',NULL,NULL),(20063,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:40',NULL,NULL),(22911,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:57',NULL,NULL),(23425,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:58',NULL,NULL),(19314,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:29',NULL,NULL),(9278,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:18',NULL,NULL),(13271,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:52',NULL,NULL),(3410,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:12',NULL,NULL),(12546,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:32',NULL,NULL),(11927,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:42',NULL,NULL),(3889,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:05',NULL,NULL),(5142,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:13',NULL,NULL),(11218,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:22',NULL,NULL),(10412,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:44',NULL,NULL),(4825,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:59',NULL,NULL),(9740,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:58',NULL,NULL),(22550,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:05',NULL,NULL),(652,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:19',NULL,NULL),(706,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:38',NULL,NULL),(909,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:53',NULL,NULL),(20353,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:02',NULL,NULL),(2144,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:16',NULL,NULL),(16690,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:22',NULL,NULL),(13973,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:31',NULL,NULL),(3830,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:49',NULL,NULL),(3709,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:18',NULL,NULL),(9881,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:36',NULL,NULL),(11716,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:32',NULL,NULL),(10428,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:48',NULL,NULL),(20928,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:15',NULL,NULL),(21770,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:46',NULL,NULL),(212,331,'2013-12-27','15:48:00','A','000',0,'2014-01-13 03:05:11',NULL,NULL),(9096,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:29',NULL,NULL),(9091,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:28',NULL,NULL),(4955,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:36',NULL,NULL),(4725,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:32',NULL,NULL),(4386,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:08',NULL,NULL),(1333,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:47',NULL,NULL),(6822,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:09',NULL,NULL),(2141,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:15',NULL,NULL),(3772,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:35',NULL,NULL),(7196,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:44',NULL,NULL),(5278,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:52',NULL,NULL),(21952,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:50',NULL,NULL),(19924,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:00',NULL,NULL),(397,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:56',NULL,NULL),(17215,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:09',NULL,NULL),(9722,1862,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:53',NULL,NULL),(4141,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:04',NULL,NULL),(2667,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:13',NULL,NULL),(7694,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:43',NULL,NULL),(1498,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:48',NULL,NULL),(21989,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:03',NULL,NULL),(22129,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:53',NULL,NULL),(453,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:14',NULL,NULL),(8569,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:17',NULL,NULL),(18021,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:02',NULL,NULL),(17402,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:47',NULL,NULL),(4909,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:22',NULL,NULL),(17229,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:14',NULL,NULL),(15529,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:06',NULL,NULL),(12232,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:07',NULL,NULL),(12853,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:02',NULL,NULL),(18310,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:22',NULL,NULL),(15378,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:27',NULL,NULL),(20298,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:43',NULL,NULL),(21489,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:39',NULL,NULL),(21969,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:56',NULL,NULL),(16476,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:00',NULL,NULL),(9492,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:54',NULL,NULL),(1832,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:35',NULL,NULL),(1884,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:48',NULL,NULL),(16446,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:49',NULL,NULL),(6856,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:18',NULL,NULL),(2078,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:00',NULL,NULL),(6157,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:25',NULL,NULL),(5252,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:44',NULL,NULL),(5856,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:33',NULL,NULL),(15553,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:15',NULL,NULL),(15200,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:52',NULL,NULL),(10777,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:39',NULL,NULL),(13907,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:21',NULL,NULL),(12035,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:14',NULL,NULL),(13326,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:07',NULL,NULL),(22191,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:16',NULL,NULL),(1928,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:58',NULL,NULL),(10574,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:46',NULL,NULL),(23306,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:17',NULL,NULL),(122,194,'2013-12-27','14:57:00','A','000',0,'2014-01-13 03:04:42',NULL,NULL),(18101,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:29',NULL,NULL),(1345,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:52',NULL,NULL),(17243,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:19',NULL,NULL),(16667,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:14',NULL,NULL),(7469,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:01',NULL,NULL),(16275,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:04',NULL,NULL),(15500,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:56',NULL,NULL),(6755,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:49',NULL,NULL),(6592,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:08',NULL,NULL),(10609,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:55',NULL,NULL),(10053,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:04',NULL,NULL),(9628,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:29',NULL,NULL),(22849,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:35',NULL,NULL),(11565,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:54',NULL,NULL),(11324,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:50',NULL,NULL),(6953,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:48',NULL,NULL),(11079,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:43',NULL,NULL),(4697,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:24',NULL,NULL),(5872,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:38',NULL,NULL),(4651,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:11',NULL,NULL),(4910,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:23',NULL,NULL),(20933,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:16',NULL,NULL),(19697,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:17',NULL,NULL),(8435,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:53',NULL,NULL),(19569,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:41',NULL,NULL),(1688,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:57',NULL,NULL),(19388,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:51',NULL,NULL),(14497,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:28',NULL,NULL),(13226,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:40',NULL,NULL),(13167,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:25',NULL,NULL),(4720,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:31',NULL,NULL),(11937,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:45',NULL,NULL),(21720,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:27',NULL,NULL),(22285,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:40',NULL,NULL),(19602,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:49',NULL,NULL),(2032,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:49',NULL,NULL),(19424,1867,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:01',NULL,NULL),(4217,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:24',NULL,NULL),(18010,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:58',NULL,NULL),(4466,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:29',NULL,NULL),(5772,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:04',NULL,NULL),(5641,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:19',NULL,NULL),(10546,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:39',NULL,NULL),(17036,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:10',NULL,NULL),(11322,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:50',NULL,NULL),(16145,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:17',NULL,NULL),(14489,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:25',NULL,NULL),(21196,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:52',NULL,NULL),(22472,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:40',NULL,NULL),(18712,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:12',NULL,NULL),(18237,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:15:15',NULL,NULL),(17075,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:23',NULL,NULL),(15411,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:33',NULL,NULL),(14708,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:26',NULL,NULL),(1252,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:17',NULL,NULL),(2530,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:37',NULL,NULL),(12918,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:18',NULL,NULL),(2862,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:09',NULL,NULL),(4610,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:32:05',NULL,NULL),(3847,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:54',NULL,NULL),(11134,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:58',NULL,NULL),(11355,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:00',NULL,NULL),(12172,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:50',NULL,NULL),(12388,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:52',NULL,NULL),(22385,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:11',NULL,NULL),(20800,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:39',NULL,NULL),(1947,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:03',NULL,NULL),(19873,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:47',NULL,NULL),(18270,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:09',NULL,NULL),(8192,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:46',NULL,NULL),(7441,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:52',NULL,NULL),(16443,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:48',NULL,NULL),(7323,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:21',NULL,NULL),(7285,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:10',NULL,NULL),(3472,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:28',NULL,NULL),(5533,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:03',NULL,NULL),(5984,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:18',NULL,NULL),(15487,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:51',NULL,NULL),(10554,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:41',NULL,NULL),(15414,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:33',NULL,NULL),(12096,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:30',NULL,NULL),(13843,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:12',NULL,NULL),(14045,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:41',NULL,NULL),(14126,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:53',NULL,NULL),(20561,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:18',NULL,NULL),(19805,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:30',NULL,NULL),(7379,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:36',NULL,NULL),(18243,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:02',NULL,NULL),(16384,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:25',NULL,NULL),(4376,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:05',NULL,NULL),(2442,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:15',NULL,NULL),(20739,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:22',NULL,NULL),(22641,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:21',NULL,NULL),(1153,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:59',NULL,NULL),(14505,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:30',NULL,NULL),(13367,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:18',NULL,NULL),(1617,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:30',NULL,NULL),(21277,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:21',NULL,NULL),(22028,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:17',NULL,NULL),(569,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:52',NULL,NULL),(18579,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:36',NULL,NULL),(16389,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:27',NULL,NULL),(11727,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:35',NULL,NULL),(11442,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:23',NULL,NULL),(6677,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:30',NULL,NULL),(21172,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:43',NULL,NULL),(22212,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:22',NULL,NULL),(22603,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:24',NULL,NULL),(20537,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:10',NULL,NULL),(17794,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:42',NULL,NULL),(16392,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:29',NULL,NULL),(8094,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:20',NULL,NULL),(5099,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:02:17',NULL,NULL),(5165,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:20',NULL,NULL),(14535,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:38',NULL,NULL),(10251,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:59',NULL,NULL),(6268,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:54',NULL,NULL),(9695,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:47',NULL,NULL),(21087,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:58',NULL,NULL),(21459,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:27',NULL,NULL),(22253,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:33',NULL,NULL),(581,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:56',NULL,NULL),(19081,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:31',NULL,NULL),(14286,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:18',NULL,NULL),(5764,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:01',NULL,NULL),(21985,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:02',NULL,NULL),(22543,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:03',NULL,NULL),(22803,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:20',NULL,NULL),(22938,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:04',NULL,NULL),(806,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:25',NULL,NULL),(20241,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:22',NULL,NULL),(19297,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:24',NULL,NULL),(17031,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:08',NULL,NULL),(8333,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:26',NULL,NULL),(19276,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:18',NULL,NULL),(12239,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:09',NULL,NULL),(2997,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:57',NULL,NULL),(3241,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:26',NULL,NULL),(10931,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:18',NULL,NULL),(5773,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:04',NULL,NULL),(23224,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:58',NULL,NULL),(23682,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 22:30:03',NULL,NULL),(1183,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:07',NULL,NULL),(8958,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:01',NULL,NULL),(8828,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:26',NULL,NULL),(8113,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:25',NULL,NULL),(1266,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:23',NULL,NULL),(1635,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:36',NULL,NULL),(20546,1868,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:02:13',NULL,NULL),(19780,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:23',NULL,NULL),(19442,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:06',NULL,NULL),(4350,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:59',NULL,NULL),(19198,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:05',NULL,NULL),(10644,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:04',NULL,NULL),(11806,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:56',NULL,NULL),(17384,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:41',NULL,NULL),(12745,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:29',NULL,NULL),(21550,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:02',NULL,NULL),(22432,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:26',NULL,NULL),(23053,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:26',NULL,NULL),(17103,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:32',NULL,NULL),(15592,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:28',NULL,NULL),(15610,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:34',NULL,NULL),(19098,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:36',NULL,NULL),(16451,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:51',NULL,NULL),(457,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:15',NULL,NULL),(8917,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:50',NULL,NULL),(8811,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:21',NULL,NULL),(3245,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:27',NULL,NULL),(11099,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:48',NULL,NULL),(10187,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:42',NULL,NULL),(21357,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:50',NULL,NULL),(23074,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(21244,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:10',NULL,NULL),(8084,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:17',NULL,NULL),(3093,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:33',NULL,NULL),(23615,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 01:30:02',NULL,NULL),(15396,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:30',NULL,NULL),(2046,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:31:52',NULL,NULL),(8652,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:39',NULL,NULL),(8128,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:29',NULL,NULL),(15386,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:28',NULL,NULL),(10118,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:23',NULL,NULL),(6659,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:25',NULL,NULL),(6889,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:27',NULL,NULL),(4161,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:09',NULL,NULL),(16626,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:57',NULL,NULL),(13965,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:29',NULL,NULL),(13528,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:27',NULL,NULL),(13370,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:18',NULL,NULL),(12818,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:49',NULL,NULL),(4165,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:10',NULL,NULL),(11427,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:21',NULL,NULL),(5274,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:50',NULL,NULL),(10528,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:35',NULL,NULL),(10778,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:39',NULL,NULL),(22879,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:46',NULL,NULL),(23294,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:12',NULL,NULL),(21041,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:46',NULL,NULL),(16791,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:04',NULL,NULL),(8555,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:14',NULL,NULL),(1522,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:57',NULL,NULL),(8476,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:04',NULL,NULL),(16494,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:07',NULL,NULL),(2478,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:24',NULL,NULL),(7802,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:12',NULL,NULL),(3155,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:54',NULL,NULL),(3182,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:08',NULL,NULL),(13916,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:22',NULL,NULL),(6207,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:39',NULL,NULL),(5980,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:16',NULL,NULL),(5444,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:37',NULL,NULL),(12929,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:22',NULL,NULL),(5267,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:48',NULL,NULL),(12797,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:43',NULL,NULL),(11529,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:45',NULL,NULL),(11630,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:11',NULL,NULL),(11913,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:23',NULL,NULL),(20713,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:14',NULL,NULL),(20148,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:32:04',NULL,NULL),(9812,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:18',NULL,NULL),(18182,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:56',NULL,NULL),(18036,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:07',NULL,NULL),(7372,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:34',NULL,NULL),(17664,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:18',NULL,NULL),(11511,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:41',NULL,NULL),(11642,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:14',NULL,NULL),(17180,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:57',NULL,NULL),(12451,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:06',NULL,NULL),(13488,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:20',NULL,NULL),(15852,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:31',NULL,NULL),(4029,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:39',NULL,NULL),(4603,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:03',NULL,NULL),(9828,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:22',NULL,NULL),(9667,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:39',NULL,NULL),(8985,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:09',NULL,NULL),(21514,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:48',NULL,NULL),(21141,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:14',NULL,NULL),(19965,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:14',NULL,NULL),(17953,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:38',NULL,NULL),(14876,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:12',NULL,NULL),(14918,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:24',NULL,NULL),(16126,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:11',NULL,NULL),(20898,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:07',NULL,NULL),(20547,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:13',NULL,NULL),(8694,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:50',NULL,NULL),(16868,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:24',NULL,NULL),(1271,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:24',NULL,NULL),(7569,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:10',NULL,NULL),(13660,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:45',NULL,NULL),(10970,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:08',NULL,NULL),(12270,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:18',NULL,NULL),(23604,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 20:30:02',NULL,NULL),(2391,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:02',NULL,NULL),(22768,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:59:06',NULL,NULL),(1907,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:53',NULL,NULL),(19158,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:54',NULL,NULL),(6299,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:03',NULL,NULL),(17190,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:01',NULL,NULL),(4751,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:39',NULL,NULL),(10398,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:40',NULL,NULL),(9494,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:35:55',NULL,NULL),(21247,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:11',NULL,NULL),(21535,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:56',NULL,NULL),(22930,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(23680,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 17:30:05',NULL,NULL),(458,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:16',NULL,NULL),(7886,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:36',NULL,NULL),(7417,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:46',NULL,NULL),(7148,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:31',NULL,NULL),(19056,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:24',NULL,NULL),(14785,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:48',NULL,NULL),(14388,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:49:56',NULL,NULL),(11821,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:00',NULL,NULL),(10150,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:31',NULL,NULL),(3535,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:46',NULL,NULL),(8963,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:02',NULL,NULL),(3590,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:00',NULL,NULL),(8676,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:46',NULL,NULL),(8890,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:43',NULL,NULL),(21384,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:00',NULL,NULL),(18621,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:47',NULL,NULL),(1030,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:26',NULL,NULL),(1094,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:43',NULL,NULL),(6825,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:09',NULL,NULL),(18122,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:36',NULL,NULL),(5416,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:29',NULL,NULL),(17222,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:12',NULL,NULL),(4370,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:04',NULL,NULL),(3956,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:21',NULL,NULL),(15689,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:00',NULL,NULL),(2436,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:14',NULL,NULL),(3015,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:04',NULL,NULL),(9016,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:07',NULL,NULL),(15236,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:59',NULL,NULL),(11674,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:22',NULL,NULL),(14982,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:42',NULL,NULL),(22655,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:25',NULL,NULL),(14963,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:35',NULL,NULL),(21070,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:54',NULL,NULL),(21327,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:39',NULL,NULL),(1343,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:52',NULL,NULL),(1503,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:50',NULL,NULL),(3941,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:18',NULL,NULL),(5212,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:32',NULL,NULL),(9488,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:35:53',NULL,NULL),(18702,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:09',NULL,NULL),(14156,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:58',NULL,NULL),(14201,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:04',NULL,NULL),(16202,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:37',NULL,NULL),(15836,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:25',NULL,NULL),(20239,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:21',NULL,NULL),(688,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:32',NULL,NULL),(1041,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:29',NULL,NULL),(7598,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:18',NULL,NULL),(1293,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:32',NULL,NULL),(18624,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:48',NULL,NULL),(15453,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:40',NULL,NULL),(14648,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:10',NULL,NULL),(1951,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:04',NULL,NULL),(12803,1880,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:23:45',NULL,NULL),(3224,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:21',NULL,NULL),(2879,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:15',NULL,NULL),(2124,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:11',NULL,NULL),(2400,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:04',NULL,NULL),(11836,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:03',NULL,NULL),(2164,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:21',NULL,NULL),(11103,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:49',NULL,NULL),(9212,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:00',NULL,NULL),(20364,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:06',NULL,NULL),(19771,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:21',NULL,NULL),(17071,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:22',NULL,NULL),(2496,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:29',NULL,NULL),(6361,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:19',NULL,NULL),(6205,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:38',NULL,NULL),(3939,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:17',NULL,NULL),(12670,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:07',NULL,NULL),(12495,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:19',NULL,NULL),(10033,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:59',NULL,NULL),(11702,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:29',NULL,NULL),(17351,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:29',NULL,NULL),(16928,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:39',NULL,NULL),(2160,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:20',NULL,NULL),(4019,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:37',NULL,NULL),(14200,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:04',NULL,NULL),(5579,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:16',NULL,NULL),(6070,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:48',NULL,NULL),(10846,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:56',NULL,NULL),(20248,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:24',NULL,NULL),(22918,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:59',NULL,NULL),(723,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:44',NULL,NULL),(1393,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:11',NULL,NULL),(19598,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:48',NULL,NULL),(18213,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:07',NULL,NULL),(16601,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:46',NULL,NULL),(6044,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:39',NULL,NULL),(15672,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:55',NULL,NULL),(14675,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:18',NULL,NULL),(14492,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:26',NULL,NULL),(11453,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:26',NULL,NULL),(9791,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:12',NULL,NULL),(11202,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:18',NULL,NULL),(10245,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:57',NULL,NULL),(10922,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:16',NULL,NULL),(21004,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:35',NULL,NULL),(3453,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:23',NULL,NULL),(15484,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:50',NULL,NULL),(8707,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:54',NULL,NULL),(8558,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:14',NULL,NULL),(13217,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:38',NULL,NULL),(7641,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:29',NULL,NULL),(11896,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:19',NULL,NULL),(20323,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:51',NULL,NULL),(19551,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:36',NULL,NULL),(15653,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:48',NULL,NULL),(7188,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:41',NULL,NULL),(2335,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:47',NULL,NULL),(3358,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:58',NULL,NULL),(15436,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:37',NULL,NULL),(3567,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:54',NULL,NULL),(16385,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:26',NULL,NULL),(7389,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:38',NULL,NULL),(6624,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:16',NULL,NULL),(15761,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:25',NULL,NULL),(8648,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:38',NULL,NULL),(10637,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:02',NULL,NULL),(9684,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:44',NULL,NULL),(4904,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:21',NULL,NULL),(9680,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:43',NULL,NULL),(3561,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:52',NULL,NULL),(1687,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:57',NULL,NULL),(15407,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:32',NULL,NULL),(7537,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:20',NULL,NULL),(13429,1871,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:30:12',NULL,NULL),(2385,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:00',NULL,NULL),(2608,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:57',NULL,NULL),(11489,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:35',NULL,NULL),(11375,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:05',NULL,NULL),(9608,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:24',NULL,NULL),(18557,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:30',NULL,NULL),(15989,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:20',NULL,NULL),(1869,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:44',NULL,NULL),(8458,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:59',NULL,NULL),(8157,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:36',NULL,NULL),(1885,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:48',NULL,NULL),(10716,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:24',NULL,NULL),(3024,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:07',NULL,NULL),(22239,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:29',NULL,NULL),(23536,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 11:30:02',NULL,NULL),(17441,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:59',NULL,NULL),(16331,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:05',NULL,NULL),(195,353,'2013-12-27','16:04:00','A','000',0,'2014-01-13 03:05:06',NULL,NULL),(16197,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:36',NULL,NULL),(15909,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:52',NULL,NULL),(14944,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:30',NULL,NULL),(14621,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:02',NULL,NULL),(1815,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:31',NULL,NULL),(12924,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:20',NULL,NULL),(2482,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:25',NULL,NULL),(12079,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:25',NULL,NULL),(12010,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:07',NULL,NULL),(10438,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:51',NULL,NULL),(11196,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:16',NULL,NULL),(23205,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(3186,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:09',NULL,NULL),(8660,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:41',NULL,NULL),(3277,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:36',NULL,NULL),(20369,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:08',NULL,NULL),(5305,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:59',NULL,NULL),(3448,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:22',NULL,NULL),(20348,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:00',NULL,NULL),(20245,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:23',NULL,NULL),(19461,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:11',NULL,NULL),(13163,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:24',NULL,NULL),(14206,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:05',NULL,NULL),(16841,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:17',NULL,NULL),(4405,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:13',NULL,NULL),(9318,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:28',NULL,NULL),(3648,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:03',NULL,NULL),(4303,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:45',NULL,NULL),(139,306,'2013-12-27','15:37:00','A','000',0,'2014-01-13 03:04:48',NULL,NULL),(18205,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:04',NULL,NULL),(18200,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:02',NULL,NULL),(9437,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:01',NULL,NULL),(185,341,'2013-12-27','15:55:00','A','000',0,'2014-01-13 03:05:03',NULL,NULL),(8706,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:53',NULL,NULL),(3370,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:01',NULL,NULL),(18098,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:14:28',NULL,NULL),(4072,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:51',NULL,NULL),(4365,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:03',NULL,NULL),(14646,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:10',NULL,NULL),(13681,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:48',NULL,NULL),(9611,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:25',NULL,NULL),(19790,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:26',NULL,NULL),(12338,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:39',NULL,NULL),(20889,1881,'2014-01-14','23:11:00','A','000',0,'2014-01-24 09:31:05',NULL,NULL),(23638,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 14:00:02',NULL,NULL),(23642,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-14 00:00:03',NULL,NULL),(18796,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:11',NULL,NULL),(8596,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:24',NULL,NULL),(17906,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:22',NULL,NULL),(16073,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:50',NULL,NULL),(12760,1852,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:33',NULL,NULL),(10293,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:11',NULL,NULL),(1808,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:29',NULL,NULL),(5596,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:03',NULL,NULL),(3337,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:52',NULL,NULL),(3924,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:13',NULL,NULL),(21510,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:47',NULL,NULL),(49,215,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:46',NULL,NULL),(1653,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:44',NULL,NULL),(8953,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:59',NULL,NULL),(18954,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:56',NULL,NULL),(2089,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:03',NULL,NULL),(7190,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:42',NULL,NULL),(6661,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:26',NULL,NULL),(4446,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:24',NULL,NULL),(15249,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:02',NULL,NULL),(15174,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:46',NULL,NULL),(6175,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:30',NULL,NULL),(5419,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:30',NULL,NULL),(12782,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:39',NULL,NULL),(12383,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:51',NULL,NULL),(16473,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:59',NULL,NULL),(2064,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:56',NULL,NULL),(13856,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:13',NULL,NULL),(2513,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:33',NULL,NULL),(6238,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:47',NULL,NULL),(109,326,'2013-12-27','15:46:00','A','000',1,'2014-01-07 10:13:17',NULL,NULL),(20794,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:38',NULL,NULL),(18552,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:29',NULL,NULL),(17655,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:15',NULL,NULL),(17147,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:46',NULL,NULL),(21672,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:10',NULL,NULL),(23004,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:17',NULL,NULL),(17047,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:13',NULL,NULL),(11920,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:41',NULL,NULL),(14815,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:56',NULL,NULL),(20097,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:50',NULL,NULL),(7997,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:04',NULL,NULL),(7515,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:32:13',NULL,NULL),(6998,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:00',NULL,NULL),(5321,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:04',NULL,NULL),(17410,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:49',NULL,NULL),(16140,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:16',NULL,NULL),(15646,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:45',NULL,NULL),(22403,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:31:17',NULL,NULL),(334,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:34',NULL,NULL),(1159,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:01',NULL,NULL),(11726,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:35',NULL,NULL),(20501,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:56',NULL,NULL),(21446,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:23',NULL,NULL),(21781,1880,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:00:49',NULL,NULL),(22169,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:10',NULL,NULL),(23008,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:18',NULL,NULL),(312,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:26',NULL,NULL),(720,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:43',NULL,NULL),(18050,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:12',NULL,NULL),(17511,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:22',NULL,NULL),(17298,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:12',NULL,NULL),(14554,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:43',NULL,NULL),(13268,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:51',NULL,NULL),(21297,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:28',NULL,NULL),(21891,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:28',NULL,NULL),(362,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:43',NULL,NULL),(18490,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:11',NULL,NULL),(4481,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:33',NULL,NULL),(13211,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:36',NULL,NULL),(9417,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:55',NULL,NULL),(20494,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:53',NULL,NULL),(20771,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:31',NULL,NULL),(20910,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:10',NULL,NULL),(22227,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:26',NULL,NULL),(22294,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:43',NULL,NULL),(18233,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:14',NULL,NULL),(16991,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:54',NULL,NULL),(15961,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:10',NULL,NULL),(4388,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:08',NULL,NULL),(14802,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:52',NULL,NULL),(12781,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:39',NULL,NULL),(12226,1844,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:20:05',NULL,NULL),(10626,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:59',NULL,NULL),(10768,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:37',NULL,NULL),(21115,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:06',NULL,NULL),(20036,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:33',NULL,NULL),(1969,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:32',NULL,NULL),(3511,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:39',NULL,NULL),(8459,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:59',NULL,NULL),(20010,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:26',NULL,NULL),(19217,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:02',NULL,NULL),(18940,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:51',NULL,NULL),(13030,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:48',NULL,NULL),(6368,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:22',NULL,NULL),(9653,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:36',NULL,NULL),(12529,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:28',NULL,NULL),(11220,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:23',NULL,NULL),(11900,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:20',NULL,NULL),(5758,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:59',NULL,NULL),(20723,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:18',NULL,NULL),(8892,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:43',NULL,NULL),(20098,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:51',NULL,NULL),(18860,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:29',NULL,NULL),(8642,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:36',NULL,NULL),(16379,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:23',NULL,NULL),(13521,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:26',NULL,NULL),(6289,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:00',NULL,NULL),(11746,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:41',NULL,NULL),(21536,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:57',NULL,NULL),(138,255,'2013-12-27','15:22:00','A','000',0,'2014-01-13 03:04:47',NULL,NULL),(19016,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:14',NULL,NULL),(13946,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:26',NULL,NULL),(623,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:10',NULL,NULL),(651,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:02:19',NULL,NULL),(12668,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:06',NULL,NULL),(1064,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:35',NULL,NULL),(6434,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:40',NULL,NULL),(5525,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:00',NULL,NULL),(9692,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:46',NULL,NULL),(1289,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:31',NULL,NULL),(9574,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:15',NULL,NULL),(22090,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:39',NULL,NULL),(22822,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:26',NULL,NULL),(1446,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:30',NULL,NULL),(17880,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:13',NULL,NULL),(8613,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:29',NULL,NULL),(17533,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:29',NULL,NULL),(15056,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:06',NULL,NULL),(4992,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:47',NULL,NULL),(6176,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:30',NULL,NULL),(14774,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:45',NULL,NULL),(13589,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:35',NULL,NULL),(23009,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:18',NULL,NULL),(2259,1887,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:30:28',NULL,NULL),(18988,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:06',NULL,NULL),(15336,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:19',NULL,NULL),(14184,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:02',NULL,NULL),(13731,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:56',NULL,NULL),(10207,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:47',NULL,NULL),(9704,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:49',NULL,NULL),(7462,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:59',NULL,NULL),(7470,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:32:01',NULL,NULL),(6967,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:51',NULL,NULL),(22730,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:51',NULL,NULL),(23275,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:08',NULL,NULL),(19148,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:51',NULL,NULL),(8896,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:44',NULL,NULL),(8526,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:06',NULL,NULL),(18669,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:00',NULL,NULL),(18577,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:35',NULL,NULL),(4313,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:48',NULL,NULL),(4772,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:44',NULL,NULL),(6153,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:24',NULL,NULL),(17008,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:00',NULL,NULL),(16661,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:12',NULL,NULL),(5159,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:18',NULL,NULL),(15514,1846,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:02',NULL,NULL),(12221,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:04',NULL,NULL),(12963,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:31',NULL,NULL),(13073,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:59',NULL,NULL),(22177,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:12',NULL,NULL),(800,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:23',NULL,NULL),(16979,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:51',NULL,NULL),(15857,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:33',NULL,NULL),(15797,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:37',NULL,NULL),(13423,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:11',NULL,NULL),(7732,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:52',NULL,NULL),(6865,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:20',NULL,NULL),(6631,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:18',NULL,NULL),(12879,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:12',NULL,NULL),(5813,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:18',NULL,NULL),(12064,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:21',NULL,NULL),(3588,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:00',NULL,NULL),(3670,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:09',NULL,NULL),(3913,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:11',NULL,NULL),(307,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:24',NULL,NULL),(17446,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:01',NULL,NULL),(7937,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:49',NULL,NULL),(15665,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:52',NULL,NULL),(15560,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:17',NULL,NULL),(11598,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:02',NULL,NULL),(2789,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:43',NULL,NULL),(6811,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:06',NULL,NULL),(11221,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:23',NULL,NULL),(6314,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:07',NULL,NULL),(5528,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:00',NULL,NULL),(10661,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:09',NULL,NULL),(4114,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:02',NULL,NULL),(5069,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:02:08',NULL,NULL),(1350,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:54',NULL,NULL),(17997,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:52',NULL,NULL),(7931,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:48',NULL,NULL),(7915,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:43',NULL,NULL),(2859,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:08',NULL,NULL),(6381,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:25',NULL,NULL),(16670,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:15',NULL,NULL),(15748,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:20',NULL,NULL),(14081,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:47',NULL,NULL),(5317,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:03',NULL,NULL),(10387,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:37',NULL,NULL),(11809,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:57',NULL,NULL),(21755,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:00:40',NULL,NULL),(21028,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:42',NULL,NULL),(9691,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:46',NULL,NULL),(20846,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:53',NULL,NULL),(20824,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:46',NULL,NULL),(2546,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:41',NULL,NULL),(3221,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:20',NULL,NULL),(7128,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:26',NULL,NULL),(20525,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:05',NULL,NULL),(20518,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:02',NULL,NULL),(14333,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:27',NULL,NULL),(21639,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:35',NULL,NULL),(21427,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:16',NULL,NULL),(1564,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:12',NULL,NULL),(8352,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:32',NULL,NULL),(19380,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:48',NULL,NULL),(4678,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:19',NULL,NULL),(16352,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:13',NULL,NULL),(10781,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:40',NULL,NULL),(13408,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:08',NULL,NULL),(23307,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:18',NULL,NULL),(21493,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:41',NULL,NULL),(2128,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:12',NULL,NULL),(19077,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:30',NULL,NULL),(9281,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:19',NULL,NULL),(18076,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:21',NULL,NULL),(3094,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:33',NULL,NULL),(17617,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:00',NULL,NULL),(16932,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:40',NULL,NULL),(10188,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:42',NULL,NULL),(15641,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:44',NULL,NULL),(13394,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:05',NULL,NULL),(23046,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(23050,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:26',NULL,NULL),(2258,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:28',NULL,NULL),(4426,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:19',NULL,NULL),(14811,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:55',NULL,NULL),(5029,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:57',NULL,NULL),(7681,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:40',NULL,NULL),(11685,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:25',NULL,NULL),(11466,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:29',NULL,NULL),(22157,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:07',NULL,NULL),(21742,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:36',NULL,NULL),(9037,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:12',NULL,NULL),(8611,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:28',NULL,NULL),(7907,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:41',NULL,NULL),(21310,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:33',NULL,NULL),(6877,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:24',NULL,NULL),(21156,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:18',NULL,NULL),(14988,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:44',NULL,NULL),(14627,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:04',NULL,NULL),(13067,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:58',NULL,NULL),(13110,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:10',NULL,NULL),(14556,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:43',NULL,NULL),(13694,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:49',NULL,NULL),(14163,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:59',NULL,NULL),(21979,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:59',NULL,NULL),(21238,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:08',NULL,NULL),(19923,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:00',NULL,NULL),(16694,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:24',NULL,NULL),(2177,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:25',NULL,NULL),(7970,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:58',NULL,NULL),(11502,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:38',NULL,NULL),(2707,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:14',NULL,NULL),(7582,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:14',NULL,NULL),(22496,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:48',NULL,NULL),(15950,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:06',NULL,NULL),(10317,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:17',NULL,NULL),(14067,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:45',NULL,NULL),(1110,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:47',NULL,NULL),(13491,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:21',NULL,NULL),(1313,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:40',NULL,NULL),(2689,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:08',NULL,NULL),(2939,1862,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:01:36',NULL,NULL),(11878,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:14',NULL,NULL),(20752,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:26',NULL,NULL),(19664,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:08',NULL,NULL),(18610,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:44',NULL,NULL),(7657,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:33',NULL,NULL),(15664,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:52',NULL,NULL),(13461,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:16',NULL,NULL),(12580,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:42',NULL,NULL),(2736,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:25',NULL,NULL),(21184,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:47',NULL,NULL),(20273,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:33',NULL,NULL),(8413,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:47',NULL,NULL),(19599,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:49',NULL,NULL),(7653,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:32',NULL,NULL),(4149,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:06',NULL,NULL),(6696,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:34',NULL,NULL),(18966,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:00',NULL,NULL),(14461,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:18',NULL,NULL),(18468,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:05',NULL,NULL),(15622,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:38',NULL,NULL),(934,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:59',NULL,NULL),(1168,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:03',NULL,NULL),(19041,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:20',NULL,NULL),(17767,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:32',NULL,NULL),(17211,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:08',NULL,NULL),(4460,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:28',NULL,NULL),(16679,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:19',NULL,NULL),(7710,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:47',NULL,NULL),(5075,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:10',NULL,NULL),(15794,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:36',NULL,NULL),(12331,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:36',NULL,NULL),(5825,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:22',NULL,NULL),(5143,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:13',NULL,NULL),(3603,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:04',NULL,NULL),(12151,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:44',NULL,NULL),(11045,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:30',NULL,NULL),(10562,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:43',NULL,NULL),(19256,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:13',NULL,NULL),(19820,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:34',NULL,NULL),(23500,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:25',NULL,NULL),(82,312,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:16',NULL,NULL),(703,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:37',NULL,NULL),(17387,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:42',NULL,NULL),(4128,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:05',NULL,NULL),(7050,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:02:13',NULL,NULL),(8303,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:17',NULL,NULL),(12066,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:22',NULL,NULL),(11505,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:39',NULL,NULL),(9323,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:30',NULL,NULL),(9224,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:04',NULL,NULL),(18849,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:26',NULL,NULL),(23491,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:22',NULL,NULL),(6140,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:20',NULL,NULL),(14909,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:22',NULL,NULL),(8355,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:33',NULL,NULL),(9541,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:07',NULL,NULL),(14569,1848,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:50:47',NULL,NULL),(11188,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:13',NULL,NULL),(11693,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:27',NULL,NULL),(12662,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:05',NULL,NULL),(20534,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:08',NULL,NULL),(21600,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:20',NULL,NULL),(13148,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:20',NULL,NULL),(14186,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:02',NULL,NULL),(18307,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:21',NULL,NULL),(18082,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:23',NULL,NULL),(15426,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:36',NULL,NULL),(12299,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:26',NULL,NULL),(10479,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:22',NULL,NULL),(2880,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:15',NULL,NULL),(19860,1859,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:44',NULL,NULL),(17140,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:44',NULL,NULL),(5206,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:31',NULL,NULL),(6890,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:28',NULL,NULL),(14848,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:05',NULL,NULL),(7901,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:40',NULL,NULL),(22439,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:29',NULL,NULL),(23188,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:51',NULL,NULL),(23210,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(15044,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:02',NULL,NULL),(6039,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:37',NULL,NULL),(9445,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:03',NULL,NULL),(5119,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:05',NULL,NULL),(8702,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:52',NULL,NULL),(8506,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:12',NULL,NULL),(8193,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:46',NULL,NULL),(4523,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:43',NULL,NULL),(20123,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:57',NULL,NULL),(16689,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:22',NULL,NULL),(721,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:43',NULL,NULL),(16267,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:02',NULL,NULL),(13221,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:39',NULL,NULL),(2658,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:11',NULL,NULL),(5472,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:45',NULL,NULL),(12343,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:40',NULL,NULL),(3751,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:29',NULL,NULL),(7630,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:26',NULL,NULL),(11940,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:46',NULL,NULL),(15654,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:48',NULL,NULL),(7218,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:50',NULL,NULL),(887,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:47',NULL,NULL),(12809,1848,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:47',NULL,NULL),(10565,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:44',NULL,NULL),(5495,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:51',NULL,NULL),(5010,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:52',NULL,NULL),(19021,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:15',NULL,NULL),(15726,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:12',NULL,NULL),(14551,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:42',NULL,NULL),(5628,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:14',NULL,NULL),(7778,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:05',NULL,NULL),(14327,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:25',NULL,NULL),(12713,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:20',NULL,NULL),(19009,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:12',NULL,NULL),(847,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:36',NULL,NULL),(17803,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:45',NULL,NULL),(16264,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:01',NULL,NULL),(4942,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:33',NULL,NULL),(15569,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:20',NULL,NULL),(14320,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:24',NULL,NULL),(9090,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:27',NULL,NULL),(9190,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:54',NULL,NULL),(11003,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:17',NULL,NULL),(10741,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:30',NULL,NULL),(21803,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:57',NULL,NULL),(22971,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(827,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:31',NULL,NULL),(2981,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:51',NULL,NULL),(6919,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:37',NULL,NULL),(6804,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:04',NULL,NULL),(19047,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:22',NULL,NULL),(16919,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:37',NULL,NULL),(15759,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:24',NULL,NULL),(7979,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:02:00',NULL,NULL),(14916,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:23',NULL,NULL),(10106,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:20',NULL,NULL),(14192,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:03',NULL,NULL),(12625,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:54',NULL,NULL),(12983,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:36',NULL,NULL),(22173,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:11',NULL,NULL),(15516,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:02',NULL,NULL),(7597,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:17',NULL,NULL),(11968,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:54',NULL,NULL),(3262,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:31',NULL,NULL),(3981,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:27',NULL,NULL),(4034,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:40',NULL,NULL),(21974,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:58',NULL,NULL),(22860,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:39',NULL,NULL),(1475,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:40',NULL,NULL),(2588,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:52',NULL,NULL),(18393,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:44',NULL,NULL),(17914,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:24',NULL,NULL),(6543,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:32:09',NULL,NULL),(16676,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:17',NULL,NULL),(15123,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:29',NULL,NULL),(4186,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:16',NULL,NULL),(7815,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:16',NULL,NULL),(14644,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:09',NULL,NULL),(10864,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:01',NULL,NULL),(9894,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:39',NULL,NULL),(19428,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:02',NULL,NULL),(21890,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:28',NULL,NULL),(23233,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(383,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:50',NULL,NULL),(485,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:25',NULL,NULL),(18832,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:21',NULL,NULL),(7316,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:19',NULL,NULL),(2827,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:57',NULL,NULL),(14353,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:49:46',NULL,NULL),(12203,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:59',NULL,NULL),(10179,1878,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:40:39',NULL,NULL),(5068,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:08',NULL,NULL),(8334,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:27',NULL,NULL),(8670,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:44',NULL,NULL),(8672,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:45',NULL,NULL),(8967,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:03',NULL,NULL),(9930,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:48',NULL,NULL),(9194,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:56',NULL,NULL),(19520,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:27',NULL,NULL),(20429,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:31',NULL,NULL),(23147,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(19271,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:17',NULL,NULL),(1404,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:15',NULL,NULL),(3722,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:22',NULL,NULL),(18274,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:11',NULL,NULL),(5200,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:29',NULL,NULL),(8251,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:01',NULL,NULL),(17458,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:05',NULL,NULL),(10225,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:52',NULL,NULL),(10723,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:26',NULL,NULL),(10880,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:05',NULL,NULL),(17154,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:49',NULL,NULL),(14839,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:03',NULL,NULL),(16090,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:57',NULL,NULL),(21042,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:46',NULL,NULL),(21860,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:18',NULL,NULL),(23116,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(18792,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:10',NULL,NULL),(4375,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:05',NULL,NULL),(5104,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:02:18',NULL,NULL),(8226,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:55',NULL,NULL),(18261,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:07',NULL,NULL),(15703,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:05',NULL,NULL),(9572,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:14',NULL,NULL),(13454,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:15',NULL,NULL),(20407,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:22',NULL,NULL),(21628,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:31',NULL,NULL),(21980,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:00',NULL,NULL),(18444,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:57',NULL,NULL),(18438,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:56',NULL,NULL),(903,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:51',NULL,NULL),(1088,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:41',NULL,NULL),(18130,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:38',NULL,NULL),(2210,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:08',NULL,NULL),(6344,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:15',NULL,NULL),(3123,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:43',NULL,NULL),(4092,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:01:56',NULL,NULL),(4583,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:58',NULL,NULL),(14908,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:21',NULL,NULL),(9797,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:13',NULL,NULL),(10427,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:48',NULL,NULL),(11377,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:06',NULL,NULL),(21063,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:52',NULL,NULL),(750,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:09',NULL,NULL),(16099,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:01',NULL,NULL),(10839,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:54',NULL,NULL),(5836,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:26',NULL,NULL),(5443,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:37',NULL,NULL),(8504,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:32:12',NULL,NULL),(2334,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:47',NULL,NULL),(1046,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:30',NULL,NULL),(16441,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:47',NULL,NULL),(10156,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:33',NULL,NULL),(2015,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:44',NULL,NULL),(5524,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:59',NULL,NULL),(1501,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:49',NULL,NULL),(2425,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:11',NULL,NULL),(3631,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:12',NULL,NULL),(2485,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:26',NULL,NULL),(20001,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:31:23',NULL,NULL),(21091,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:59',NULL,NULL),(21453,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:25',NULL,NULL),(17305,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:14',NULL,NULL),(13384,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:03',NULL,NULL),(7723,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:50',NULL,NULL),(12433,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:01',NULL,NULL),(12405,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:57',NULL,NULL),(12341,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:40',NULL,NULL),(6242,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:48',NULL,NULL),(3246,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:27',NULL,NULL),(21537,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:57',NULL,NULL),(21744,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:37',NULL,NULL),(21895,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:30',NULL,NULL),(22694,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:58:39',NULL,NULL),(22800,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:18',NULL,NULL),(22903,1873,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:59:54',NULL,NULL),(22921,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:00',NULL,NULL),(18562,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:32',NULL,NULL),(18127,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:38',NULL,NULL),(9221,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:03',NULL,NULL),(10382,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:36',NULL,NULL),(10597,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:52',NULL,NULL),(11237,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:27',NULL,NULL),(16380,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:24',NULL,NULL),(12295,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:25',NULL,NULL),(13261,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:49',NULL,NULL),(14936,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:28',NULL,NULL),(20249,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:25',NULL,NULL),(23690,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 22:30:02',NULL,NULL),(18609,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:44',NULL,NULL),(17209,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:07',NULL,NULL),(8090,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:19',NULL,NULL),(326,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:31',NULL,NULL),(19721,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:08',NULL,NULL),(19173,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:58',NULL,NULL),(14386,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:49:56',NULL,NULL),(5718,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:45',NULL,NULL),(5025,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:56',NULL,NULL),(2605,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:56',NULL,NULL),(13865,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:15',NULL,NULL),(11736,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:38',NULL,NULL),(20325,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:52',NULL,NULL),(22503,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:50',NULL,NULL),(23538,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 15:30:02',NULL,NULL),(23561,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 13:30:02',NULL,NULL),(386,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:50',NULL,NULL),(20192,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:04',NULL,NULL),(2487,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:27',NULL,NULL),(21502,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:44',NULL,NULL),(21802,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:57',NULL,NULL),(22032,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:18',NULL,NULL),(2223,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:12',NULL,NULL),(15037,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:00',NULL,NULL),(3449,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:22',NULL,NULL),(5120,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:05',NULL,NULL),(11707,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:30',NULL,NULL),(7780,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:06',NULL,NULL),(20826,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:47',NULL,NULL),(22846,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:34',NULL,NULL),(23668,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 02:29:59',NULL,NULL),(14905,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:21',NULL,NULL),(14756,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:39',NULL,NULL),(6086,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:04',NULL,NULL),(13789,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:04',NULL,NULL),(2950,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:40',NULL,NULL),(10125,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:25',NULL,NULL),(7421,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:47',NULL,NULL),(7627,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:25',NULL,NULL),(9750,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:01',NULL,NULL),(8826,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:25',NULL,NULL),(18329,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:27',NULL,NULL),(23452,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:09',NULL,NULL),(2102,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:06',NULL,NULL),(2201,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:06',NULL,NULL),(17868,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:08',NULL,NULL),(16430,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:43',NULL,NULL),(3059,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:21',NULL,NULL),(15588,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:26',NULL,NULL),(15093,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:19',NULL,NULL),(12513,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:24',NULL,NULL),(7466,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:00',NULL,NULL),(18104,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:30',NULL,NULL),(19522,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:27',NULL,NULL),(20143,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:03',NULL,NULL),(22743,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:56',NULL,NULL),(17943,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:34',NULL,NULL),(17895,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:18',NULL,NULL),(16239,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:50',NULL,NULL),(16103,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:02',NULL,NULL),(14606,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:57',NULL,NULL),(19719,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:07',NULL,NULL),(21035,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:44',NULL,NULL),(21724,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:30',NULL,NULL),(22669,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:30',NULL,NULL),(23161,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(501,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:30',NULL,NULL),(3172,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:06',NULL,NULL),(5660,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:25',NULL,NULL),(14948,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:31',NULL,NULL),(12807,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:46',NULL,NULL),(10263,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:02',NULL,NULL),(3513,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:31:39',NULL,NULL),(6736,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:44',NULL,NULL),(7165,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:35',NULL,NULL),(7707,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:46',NULL,NULL),(8218,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:53',NULL,NULL),(19082,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:31',NULL,NULL),(15465,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:43',NULL,NULL),(14618,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:01',NULL,NULL),(14180,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:01',NULL,NULL),(11360,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:01',NULL,NULL),(11176,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:09',NULL,NULL),(6973,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:53',NULL,NULL),(10653,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:07',NULL,NULL),(9991,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:39:48',NULL,NULL),(21095,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:00',NULL,NULL),(17352,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:30',NULL,NULL),(6618,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:14',NULL,NULL),(6539,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:08',NULL,NULL),(891,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:48',NULL,NULL),(1631,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:35',NULL,NULL),(4537,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:47',NULL,NULL),(3560,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:52',NULL,NULL),(3552,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:50',NULL,NULL),(2264,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:29',NULL,NULL),(18283,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:14',NULL,NULL),(16248,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:54',NULL,NULL),(14501,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:29',NULL,NULL),(8137,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:31',NULL,NULL),(8480,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:05',NULL,NULL),(8482,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:05',NULL,NULL),(13781,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:03',NULL,NULL),(19747,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:14',NULL,NULL),(23044,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(15125,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:29',NULL,NULL),(6325,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:10',NULL,NULL),(10402,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:41',NULL,NULL),(3617,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:08',NULL,NULL),(3811,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:45',NULL,NULL),(4928,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:28',NULL,NULL),(7585,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:14',NULL,NULL),(8107,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:24',NULL,NULL),(9623,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:28',NULL,NULL),(20531,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:02:07',NULL,NULL),(22238,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:29',NULL,NULL),(576,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-23 19:01:54',NULL,NULL),(6836,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:12',NULL,NULL),(1377,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:05',NULL,NULL),(4211,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:22',NULL,NULL),(18056,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:14',NULL,NULL),(1656,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:45',NULL,NULL),(13441,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:14',NULL,NULL),(7162,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:35',NULL,NULL),(13254,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:48',NULL,NULL),(9435,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:32:00',NULL,NULL),(12738,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:27',NULL,NULL),(17310,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:16',NULL,NULL),(6878,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:25',NULL,NULL),(6458,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:46',NULL,NULL),(11144,1884,'2014-01-14','23:11:00','A','000',0,'2014-01-24 05:01:00',NULL,NULL),(2438,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:14',NULL,NULL),(11059,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:34',NULL,NULL),(10913,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:14',NULL,NULL),(9931,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:48',NULL,NULL),(3625,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:10',NULL,NULL),(9153,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:45',NULL,NULL),(3700,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:16',NULL,NULL),(7367,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:32',NULL,NULL),(8225,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:54',NULL,NULL),(20629,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:43',NULL,NULL),(825,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:30',NULL,NULL),(6377,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:24',NULL,NULL),(1158,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:00',NULL,NULL),(5164,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:19',NULL,NULL),(1263,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:22',NULL,NULL),(16022,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:32',NULL,NULL),(12639,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:58',NULL,NULL),(8880,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:40',NULL,NULL),(11619,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:08',NULL,NULL),(11333,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:53',NULL,NULL),(19061,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:26',NULL,NULL),(20180,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:13',NULL,NULL),(21483,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:37',NULL,NULL),(21581,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:13',NULL,NULL),(18863,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:30',NULL,NULL),(5956,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:07',NULL,NULL),(1660,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:46',NULL,NULL),(20399,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:19',NULL,NULL),(22321,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:49',NULL,NULL),(23025,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:21',NULL,NULL),(2332,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:47',NULL,NULL),(3611,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:06',NULL,NULL),(16964,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:48',NULL,NULL),(9039,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:13',NULL,NULL),(9609,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:24',NULL,NULL),(9859,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:30',NULL,NULL),(10894,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:09',NULL,NULL),(16961,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:47',NULL,NULL),(16305,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:56',NULL,NULL),(15447,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:39',NULL,NULL),(12627,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:55',NULL,NULL),(21129,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:10',NULL,NULL),(13407,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:08',NULL,NULL),(19042,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:21',NULL,NULL),(23558,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 23:30:02',NULL,NULL),(18031,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:05',NULL,NULL),(2776,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:39',NULL,NULL),(17746,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:46',NULL,NULL),(17461,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:06',NULL,NULL),(17253,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:22',NULL,NULL),(4539,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:47',NULL,NULL),(5421,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:31',NULL,NULL),(17082,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:25',NULL,NULL),(13170,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:25',NULL,NULL),(9789,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:11',NULL,NULL),(8952,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:59',NULL,NULL),(22110,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:46',NULL,NULL),(22829,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:29',NULL,NULL),(1182,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:07',NULL,NULL),(18398,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:45',NULL,NULL),(2495,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:29',NULL,NULL),(2611,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:58',NULL,NULL),(5389,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:22',NULL,NULL),(15898,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:48',NULL,NULL),(13796,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:05',NULL,NULL),(12597,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:46',NULL,NULL),(11319,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:49',NULL,NULL),(1685,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:56',NULL,NULL),(13788,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:04',NULL,NULL),(4124,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:02:04',NULL,NULL),(13492,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:21',NULL,NULL),(5701,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:39',NULL,NULL),(11938,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:45',NULL,NULL),(4463,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:28',NULL,NULL),(5619,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:10',NULL,NULL),(5311,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:01',NULL,NULL),(7921,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:45',NULL,NULL),(22720,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:48',NULL,NULL),(18397,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:45',NULL,NULL),(2240,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:23',NULL,NULL),(6832,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:11',NULL,NULL),(18166,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:51',NULL,NULL),(6532,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:06',NULL,NULL),(6247,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:49',NULL,NULL),(14767,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:43',NULL,NULL),(9361,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:31:39',NULL,NULL),(8962,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:02',NULL,NULL),(19305,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:27',NULL,NULL),(21944,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:47',NULL,NULL),(22048,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:24',NULL,NULL),(22483,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:44',NULL,NULL),(23701,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 11:30:01',NULL,NULL),(418,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:03',NULL,NULL),(19156,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:53',NULL,NULL),(13732,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:56',NULL,NULL),(10056,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:05',NULL,NULL),(9101,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:30',NULL,NULL),(19401,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:55',NULL,NULL),(20303,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:44',NULL,NULL),(21173,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:40:43',NULL,NULL),(23163,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(1742,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:13',NULL,NULL),(3327,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:49',NULL,NULL),(17254,1894,'2014-01-14','23:11:00','A','000',0,'2014-01-24 06:32:23',NULL,NULL),(7260,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:03',NULL,NULL),(7113,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:22',NULL,NULL),(5627,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:13',NULL,NULL),(12816,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:49',NULL,NULL),(8318,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:22',NULL,NULL),(11109,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:51',NULL,NULL),(8507,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:32:12',NULL,NULL),(9513,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:59',NULL,NULL),(13378,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:20',NULL,NULL),(11989,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:01',NULL,NULL),(6908,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:33',NULL,NULL),(10709,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:22',NULL,NULL),(6554,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:32:11',NULL,NULL),(9269,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:16',NULL,NULL),(3139,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:49',NULL,NULL),(1147,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:57',NULL,NULL),(3978,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:27',NULL,NULL),(4577,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:56',NULL,NULL),(155,297,'2013-12-27','15:35:00','A','000',0,'2014-01-13 03:04:53',NULL,NULL),(19293,1891,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:00:23',NULL,NULL),(7321,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:20',NULL,NULL),(18963,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:59',NULL,NULL),(4923,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:27',NULL,NULL),(3507,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:38',NULL,NULL),(4150,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:06',NULL,NULL),(18735,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:35:54',NULL,NULL),(12547,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:33',NULL,NULL),(9031,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:11',NULL,NULL),(9827,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:21',NULL,NULL),(12031,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:13',NULL,NULL),(11538,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:47',NULL,NULL),(11506,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:39',NULL,NULL),(20676,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:03',NULL,NULL),(20907,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:09',NULL,NULL),(21081,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:56',NULL,NULL),(22223,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:25',NULL,NULL),(16490,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:06',NULL,NULL),(8797,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:18',NULL,NULL),(6772,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:54',NULL,NULL),(3083,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:29',NULL,NULL),(20030,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:31',NULL,NULL),(14121,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:53',NULL,NULL),(2702,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:12',NULL,NULL),(13713,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:53',NULL,NULL),(9287,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:20',NULL,NULL),(3168,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:05',NULL,NULL),(19595,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:48',NULL,NULL),(22060,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:28',NULL,NULL),(599,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:02',NULL,NULL),(1370,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:03',NULL,NULL),(5135,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:11',NULL,NULL),(15239,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:00',NULL,NULL),(11848,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:07',NULL,NULL),(20220,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:14',NULL,NULL),(21710,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:24',NULL,NULL),(21937,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:45',NULL,NULL),(23340,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:30',NULL,NULL),(310,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:25',NULL,NULL),(16956,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:46',NULL,NULL),(5054,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:04',NULL,NULL),(16631,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:59',NULL,NULL),(9271,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:16',NULL,NULL),(8428,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:51',NULL,NULL),(19269,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:16',NULL,NULL),(19565,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:40',NULL,NULL),(20715,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:15',NULL,NULL),(21084,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:57',NULL,NULL),(22769,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:06',NULL,NULL),(22966,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:10',NULL,NULL),(23033,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(15827,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:22',NULL,NULL),(15489,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:52',NULL,NULL),(725,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:02',NULL,NULL),(1421,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:20',NULL,NULL),(3027,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:08',NULL,NULL),(3518,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:41',NULL,NULL),(9122,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:36',NULL,NULL),(8054,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:09',NULL,NULL),(18625,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:48',NULL,NULL),(20356,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:03',NULL,NULL),(20992,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:32',NULL,NULL),(22457,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:35',NULL,NULL),(17869,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:09',NULL,NULL),(16079,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:52',NULL,NULL),(6278,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:57',NULL,NULL),(2273,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:31',NULL,NULL),(5551,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:08',NULL,NULL),(8176,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:42',NULL,NULL),(13471,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:18',NULL,NULL),(11408,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:15',NULL,NULL),(20529,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:06',NULL,NULL),(17850,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:02',NULL,NULL),(799,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:22',NULL,NULL),(16876,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:26',NULL,NULL),(3801,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:42',NULL,NULL),(13056,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:55',NULL,NULL),(9770,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:06',NULL,NULL),(12059,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:20',NULL,NULL),(12036,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:14',NULL,NULL),(11025,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:24',NULL,NULL),(19892,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:52',NULL,NULL),(21435,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:19',NULL,NULL),(18083,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:23',NULL,NULL),(882,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:45',NULL,NULL),(3251,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:28',NULL,NULL),(11687,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:25',NULL,NULL),(10736,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:29',NULL,NULL),(10294,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:11',NULL,NULL),(9877,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:34',NULL,NULL),(3664,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:00:07',NULL,NULL),(4684,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:21',NULL,NULL),(9250,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:11',NULL,NULL),(18616,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:46',NULL,NULL),(19046,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:22',NULL,NULL),(20124,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:58',NULL,NULL),(21241,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:09',NULL,NULL),(21825,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:05',NULL,NULL),(22326,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:50',NULL,NULL),(23179,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(1116,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:49',NULL,NULL),(7241,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:58',NULL,NULL),(16954,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:45',NULL,NULL),(2878,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:01:15',NULL,NULL),(6116,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:13',NULL,NULL),(5898,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:47',NULL,NULL),(5863,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:35',NULL,NULL),(16190,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:33',NULL,NULL),(4199,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:19',NULL,NULL),(14933,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:27',NULL,NULL),(7398,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:41',NULL,NULL),(12169,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:49',NULL,NULL),(9055,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:18',NULL,NULL),(12104,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:32',NULL,NULL),(10356,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:28',NULL,NULL),(11160,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:05',NULL,NULL),(20330,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:54',NULL,NULL),(1490,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:46',NULL,NULL),(17780,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:36',NULL,NULL),(6654,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:24',NULL,NULL),(16144,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:17',NULL,NULL),(13653,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:44',NULL,NULL),(1753,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:15',NULL,NULL),(12307,1847,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:20:29',NULL,NULL),(11157,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:04',NULL,NULL),(4241,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:30',NULL,NULL),(10136,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:28',NULL,NULL),(2817,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:53',NULL,NULL),(8371,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:37',NULL,NULL),(20096,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:50',NULL,NULL),(23353,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:34',NULL,NULL),(1508,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:52',NULL,NULL),(1955,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:28',NULL,NULL),(17849,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:02',NULL,NULL),(2865,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:10',NULL,NULL),(4544,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:48',NULL,NULL),(15618,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:36',NULL,NULL),(14220,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:08',NULL,NULL),(3521,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:42',NULL,NULL),(3599,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:03',NULL,NULL),(13364,1829,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:17',NULL,NULL),(13204,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:34',NULL,NULL),(12116,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:35',NULL,NULL),(19764,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:19',NULL,NULL),(20202,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:08',NULL,NULL),(520,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:36',NULL,NULL),(15861,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:35',NULL,NULL),(1193,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:10',NULL,NULL),(1960,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:30',NULL,NULL),(12416,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:21:56',NULL,NULL),(4487,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:34',NULL,NULL),(7810,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:15',NULL,NULL),(9290,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:21',NULL,NULL),(17359,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:32',NULL,NULL),(16759,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:47',NULL,NULL),(14970,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:38',NULL,NULL),(5809,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:17',NULL,NULL),(7808,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:14',NULL,NULL),(8267,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:06',NULL,NULL),(8624,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:31',NULL,NULL),(9741,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:58',NULL,NULL),(14894,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:18',NULL,NULL),(19996,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:22',NULL,NULL),(21664,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:08',NULL,NULL),(10895,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:09',NULL,NULL),(10050,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:04',NULL,NULL),(1458,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:35',NULL,NULL),(8043,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:07',NULL,NULL),(4299,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:44',NULL,NULL),(2480,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:25',NULL,NULL),(2834,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:59',NULL,NULL),(17703,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:31',NULL,NULL),(1379,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:06',NULL,NULL),(17542,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:32',NULL,NULL),(17367,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:35',NULL,NULL),(6461,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:31:47',NULL,NULL),(10632,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:01',NULL,NULL),(9432,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:59',NULL,NULL),(5567,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:13',NULL,NULL),(9057,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:18',NULL,NULL),(8791,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:16',NULL,NULL),(4839,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:03',NULL,NULL),(8356,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:33',NULL,NULL),(21370,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:55',NULL,NULL),(1225,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:07',NULL,NULL),(6777,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:56',NULL,NULL),(1330,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:46',NULL,NULL),(3577,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:57',NULL,NULL),(4525,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:44',NULL,NULL),(3594,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:01',NULL,NULL),(18812,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:16',NULL,NULL),(17438,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:58',NULL,NULL),(9469,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:09',NULL,NULL),(16306,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:56',NULL,NULL),(10013,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:54',NULL,NULL),(10809,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:47',NULL,NULL),(10866,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:01',NULL,NULL),(14298,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:19',NULL,NULL),(18964,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:59',NULL,NULL),(20198,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:06',NULL,NULL),(21027,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:42',NULL,NULL),(21488,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:39',NULL,NULL),(21545,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:00',NULL,NULL),(21662,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:07',NULL,NULL),(548,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:45',NULL,NULL),(7687,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:41',NULL,NULL),(18952,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:56',NULL,NULL),(1677,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:52',NULL,NULL),(4018,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:36',NULL,NULL),(8395,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:43',NULL,NULL),(9297,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:23',NULL,NULL),(18617,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:46',NULL,NULL),(11432,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:21',NULL,NULL),(16921,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:37',NULL,NULL),(15430,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:36',NULL,NULL),(14198,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:04',NULL,NULL),(15001,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:48',NULL,NULL),(23710,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 13:30:00',NULL,NULL),(12927,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:21',NULL,NULL),(10121,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:24',NULL,NULL),(2614,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:59',NULL,NULL),(1844,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:38',NULL,NULL),(5753,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:57',NULL,NULL),(19662,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:08',NULL,NULL),(21885,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:26',NULL,NULL),(1655,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:45',NULL,NULL),(7859,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:28',NULL,NULL),(3492,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:34',NULL,NULL),(17608,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:57',NULL,NULL),(17388,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:42',NULL,NULL),(8323,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:23',NULL,NULL),(16751,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:44',NULL,NULL),(15693,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:02',NULL,NULL),(10377,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:34',NULL,NULL),(19332,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:34',NULL,NULL),(19700,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:18',NULL,NULL),(20307,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:46',NULL,NULL),(22972,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(23268,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(862,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:40',NULL,NULL),(18194,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:00',NULL,NULL),(17778,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:35',NULL,NULL),(16136,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:14',NULL,NULL),(13295,1836,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:58',NULL,NULL),(12708,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:18',NULL,NULL),(12013,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:08',NULL,NULL),(9398,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:49',NULL,NULL),(8304,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:18',NULL,NULL),(20797,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:38',NULL,NULL),(22056,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:27',NULL,NULL),(22286,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:41',NULL,NULL),(22518,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:55',NULL,NULL),(1216,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:03',NULL,NULL),(19040,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:20',NULL,NULL),(18059,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:15',NULL,NULL),(13596,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:36',NULL,NULL),(2591,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:53',NULL,NULL),(4410,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:14',NULL,NULL),(6063,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:46',NULL,NULL),(5408,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:27',NULL,NULL),(8710,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:54',NULL,NULL),(10318,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:18',NULL,NULL),(19485,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:17',NULL,NULL),(19727,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:09',NULL,NULL),(20188,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:00:02',NULL,NULL),(22579,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:15',NULL,NULL),(23651,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 23:30:01',NULL,NULL),(17500,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:01:18',NULL,NULL),(8064,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:12',NULL,NULL),(15878,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:41',NULL,NULL),(7031,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:08',NULL,NULL),(4348,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:58',NULL,NULL),(13529,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:27',NULL,NULL),(8481,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:05',NULL,NULL),(9675,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:42',NULL,NULL),(12213,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:02',NULL,NULL),(10811,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:47',NULL,NULL),(12390,1826,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:53',NULL,NULL),(18497,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:14',NULL,NULL),(21973,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:57',NULL,NULL),(15655,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:48',NULL,NULL),(2192,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:04',NULL,NULL),(13911,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:21',NULL,NULL),(13570,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:33',NULL,NULL),(5892,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:45',NULL,NULL),(10859,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:59',NULL,NULL),(10695,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:19',NULL,NULL),(10205,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:46',NULL,NULL),(18948,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:53',NULL,NULL),(13352,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:14',NULL,NULL),(836,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:33',NULL,NULL),(13066,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:58',NULL,NULL),(889,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:47',NULL,NULL),(11235,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:27',NULL,NULL),(3338,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:52',NULL,NULL),(3319,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:47',NULL,NULL),(1253,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:17',NULL,NULL),(9764,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:04',NULL,NULL),(2871,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:12',NULL,NULL),(21569,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:09',NULL,NULL),(22956,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(166,286,'2013-12-27','15:32:00','A','000',0,'2014-01-13 03:04:56',NULL,NULL),(927,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:58',NULL,NULL),(2120,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:10',NULL,NULL),(2459,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:20',NULL,NULL),(16076,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:51',NULL,NULL),(2982,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:52',NULL,NULL),(5963,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:10',NULL,NULL),(5920,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:55',NULL,NULL),(5672,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:29',NULL,NULL),(4985,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:45',NULL,NULL),(15212,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:01:55',NULL,NULL),(4027,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:39',NULL,NULL),(7118,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:23',NULL,NULL),(7308,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:16',NULL,NULL),(7735,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:53',NULL,NULL),(14466,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:19',NULL,NULL),(14233,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:09',NULL,NULL),(10691,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:18',NULL,NULL),(12579,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:41',NULL,NULL),(17464,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:07',NULL,NULL),(17551,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:35',NULL,NULL),(20773,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:32',NULL,NULL),(22992,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(18790,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:36:10',NULL,NULL),(305,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:24',NULL,NULL),(2072,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:58',NULL,NULL),(14118,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:52',NULL,NULL),(12459,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:08',NULL,NULL),(12316,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:32',NULL,NULL),(10942,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:21',NULL,NULL),(19208,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:38:08',NULL,NULL),(19427,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:02',NULL,NULL),(16987,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:53',NULL,NULL),(6952,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:48',NULL,NULL),(7443,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:53',NULL,NULL),(770,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:14',NULL,NULL),(19837,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:38',NULL,NULL),(22178,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:12',NULL,NULL),(17319,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:19',NULL,NULL),(15817,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:18',NULL,NULL),(5945,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:03',NULL,NULL),(15634,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:41',NULL,NULL),(15298,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:11',NULL,NULL),(10526,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:34',NULL,NULL),(10425,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:48',NULL,NULL),(7355,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:29',NULL,NULL),(7917,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:44',NULL,NULL),(20406,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:22',NULL,NULL),(21529,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:54',NULL,NULL),(22473,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:40',NULL,NULL),(23126,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:40',NULL,NULL),(980,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:12',NULL,NULL),(2080,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:00',NULL,NULL),(3559,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:52',NULL,NULL),(6049,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:40',NULL,NULL),(13924,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:23',NULL,NULL),(4255,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:33',NULL,NULL),(13689,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:49',NULL,NULL),(9276,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:17',NULL,NULL),(19791,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:26',NULL,NULL),(19925,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:01',NULL,NULL),(21912,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:36',NULL,NULL),(258,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:08',NULL,NULL),(16831,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:14',NULL,NULL),(5024,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:56',NULL,NULL),(3445,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-23 22:31:21',NULL,NULL),(16606,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:48',NULL,NULL),(9613,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:25',NULL,NULL),(10186,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:41',NULL,NULL),(11537,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:47',NULL,NULL),(13165,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:24',NULL,NULL),(13381,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:02',NULL,NULL),(15463,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:43',NULL,NULL),(17973,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:44',NULL,NULL),(18138,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:41',NULL,NULL),(66,214,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:02',NULL,NULL),(525,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:38',NULL,NULL),(7115,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:22',NULL,NULL),(16965,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:48',NULL,NULL),(662,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:22',NULL,NULL),(2421,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:10',NULL,NULL),(15711,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:08',NULL,NULL),(3766,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:33',NULL,NULL),(17124,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:39',NULL,NULL),(14418,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:05',NULL,NULL),(12328,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:35',NULL,NULL),(9403,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:51',NULL,NULL),(9615,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:26',NULL,NULL),(10192,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:43',NULL,NULL),(12199,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:58',NULL,NULL),(18366,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:37',NULL,NULL),(20390,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:16',NULL,NULL),(20391,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:17',NULL,NULL),(14903,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:20',NULL,NULL),(14707,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:26',NULL,NULL),(3036,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:12',NULL,NULL),(5787,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:09',NULL,NULL),(5285,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:54',NULL,NULL),(13224,1655,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:40',NULL,NULL),(3914,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:11',NULL,NULL),(4130,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:02:06',NULL,NULL),(13041,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:51',NULL,NULL),(9552,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:09',NULL,NULL),(11090,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:46',NULL,NULL),(20952,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:21',NULL,NULL),(21752,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:39',NULL,NULL),(16539,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:24',NULL,NULL),(7354,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:29',NULL,NULL),(14172,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:00',NULL,NULL),(13685,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:48',NULL,NULL),(13437,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:13',NULL,NULL),(5116,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:04',NULL,NULL),(11412,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:17',NULL,NULL),(9918,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:45',NULL,NULL),(9912,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:43',NULL,NULL),(19880,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:49',NULL,NULL),(21463,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:29',NULL,NULL),(22395,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:14',NULL,NULL),(15860,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:34',NULL,NULL),(12930,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:22',NULL,NULL),(12663,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:05',NULL,NULL),(9944,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:51',NULL,NULL),(1461,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:36',NULL,NULL),(2897,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:21',NULL,NULL),(6438,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:41',NULL,NULL),(8691,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:50',NULL,NULL),(8510,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-24 03:32:13',NULL,NULL),(5630,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:15',NULL,NULL),(4347,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:58',NULL,NULL),(19247,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:10',NULL,NULL),(22138,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:02',NULL,NULL),(1509,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:52',NULL,NULL),(7503,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:10',NULL,NULL),(2825,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:56',NULL,NULL),(6101,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:09',NULL,NULL),(18029,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:14:05',NULL,NULL),(5547,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:07',NULL,NULL),(16295,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:14',NULL,NULL),(5208,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:31',NULL,NULL),(15288,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:09',NULL,NULL),(13319,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:05',NULL,NULL),(11877,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:14',NULL,NULL),(8807,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:20',NULL,NULL),(10371,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:32',NULL,NULL),(18595,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:41',NULL,NULL),(19509,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:24',NULL,NULL),(20838,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:50',NULL,NULL),(21094,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:00',NULL,NULL),(22636,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:19',NULL,NULL),(1403,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:14',NULL,NULL),(17327,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:22',NULL,NULL),(14591,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:53',NULL,NULL),(7037,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:10',NULL,NULL),(14153,1882,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:31:58',NULL,NULL),(13000,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:40',NULL,NULL),(6240,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:47',NULL,NULL),(11303,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:45',NULL,NULL),(4480,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:32',NULL,NULL),(4796,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:51',NULL,NULL),(2700,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:12',NULL,NULL),(19430,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:02',NULL,NULL),(20939,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:18',NULL,NULL),(22729,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:51',NULL,NULL),(23034,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:23',NULL,NULL),(807,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:25',NULL,NULL),(1302,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:36',NULL,NULL),(15376,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:26',NULL,NULL),(13997,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:34',NULL,NULL),(18060,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:15',NULL,NULL),(6184,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:33',NULL,NULL),(10876,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:04',NULL,NULL),(8919,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:51',NULL,NULL),(4358,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:01',NULL,NULL),(21779,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:49',NULL,NULL),(21840,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:11',NULL,NULL),(17267,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:27',NULL,NULL),(2979,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:51',NULL,NULL),(16410,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:36',NULL,NULL),(5048,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:03',NULL,NULL),(5574,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:15',NULL,NULL),(6494,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:56',NULL,NULL),(5830,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:24',NULL,NULL),(13458,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:16',NULL,NULL),(12838,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:57',NULL,NULL),(19203,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:06',NULL,NULL),(20978,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:29',NULL,NULL),(23502,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:26',NULL,NULL),(16656,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:10',NULL,NULL),(6397,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:30',NULL,NULL),(16234,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:49',NULL,NULL),(12123,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:37',NULL,NULL),(2571,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:48',NULL,NULL),(3526,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:43',NULL,NULL),(12120,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:36',NULL,NULL),(4314,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:48',NULL,NULL),(11773,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:48',NULL,NULL),(21452,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:25',NULL,NULL),(23258,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(656,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:20',NULL,NULL),(767,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:14',NULL,NULL),(2439,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:15',NULL,NULL),(18524,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:21',NULL,NULL),(17085,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:26',NULL,NULL),(9551,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:09',NULL,NULL),(16602,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:47',NULL,NULL),(12979,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:35',NULL,NULL),(19394,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:52',NULL,NULL),(19550,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:36',NULL,NULL),(19943,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:06',NULL,NULL),(20604,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:34',NULL,NULL),(20651,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:02:51',NULL,NULL),(20685,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:05',NULL,NULL),(21650,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:03',NULL,NULL),(22142,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:03',NULL,NULL),(23537,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 13:30:02',NULL,NULL),(1027,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:25',NULL,NULL),(7851,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:26',NULL,NULL),(17658,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:16',NULL,NULL),(17137,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:43',NULL,NULL),(17032,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:08',NULL,NULL),(16815,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:10',NULL,NULL),(4938,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:31',NULL,NULL),(5166,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:20',NULL,NULL),(16150,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:19',NULL,NULL),(15333,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:18',NULL,NULL),(11563,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:54',NULL,NULL),(20225,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:16',NULL,NULL),(22229,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:27',NULL,NULL),(14404,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:01',NULL,NULL),(7479,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:03',NULL,NULL),(14212,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:32:06',NULL,NULL),(4977,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:43',NULL,NULL),(9648,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:35',NULL,NULL),(2024,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:46',NULL,NULL),(19679,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:12',NULL,NULL),(16824,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:13',NULL,NULL),(16627,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:58',NULL,NULL),(5300,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:58',NULL,NULL),(6445,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:43',NULL,NULL),(14145,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:56',NULL,NULL),(12871,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:09',NULL,NULL),(14135,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:55',NULL,NULL),(21923,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:40',NULL,NULL),(1107,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:46',NULL,NULL),(19279,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:19',NULL,NULL),(6727,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:42',NULL,NULL),(17341,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:26',NULL,NULL),(16211,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:40',NULL,NULL),(5926,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:57',NULL,NULL),(14568,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:47',NULL,NULL),(12840,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:58',NULL,NULL),(14194,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:03',NULL,NULL),(22258,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:34',NULL,NULL),(18912,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:44',NULL,NULL),(18448,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:59',NULL,NULL),(18251,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:04',NULL,NULL),(16348,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:11',NULL,NULL),(2626,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:32:02',NULL,NULL),(3668,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:08',NULL,NULL),(14573,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:48',NULL,NULL),(6525,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:04',NULL,NULL),(14390,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:57',NULL,NULL),(16884,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:29',NULL,NULL),(22126,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:52',NULL,NULL),(23079,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(316,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:27',NULL,NULL),(640,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:15',NULL,NULL),(21049,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:48',NULL,NULL),(19992,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:21',NULL,NULL),(1060,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:34',NULL,NULL),(8089,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:19',NULL,NULL),(18884,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:35',NULL,NULL),(1987,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:36',NULL,NULL),(16594,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:44',NULL,NULL),(15920,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:56',NULL,NULL),(11957,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:51',NULL,NULL),(12988,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:37',NULL,NULL),(15293,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:10',NULL,NULL),(14195,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:03',NULL,NULL),(14239,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:10',NULL,NULL),(16834,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:15',NULL,NULL),(16589,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:42',NULL,NULL),(15862,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:35',NULL,NULL),(433,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:08',NULL,NULL),(19817,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:33',NULL,NULL),(8222,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:54',NULL,NULL),(17857,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:05',NULL,NULL),(7042,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:02:11',NULL,NULL),(6922,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:39',NULL,NULL),(17508,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:21',NULL,NULL),(2228,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:13',NULL,NULL),(16054,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:43',NULL,NULL),(14082,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:47',NULL,NULL),(4836,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:02',NULL,NULL),(10685,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:16',NULL,NULL),(11056,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:33',NULL,NULL),(22982,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(1441,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:28',NULL,NULL),(19938,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:04',NULL,NULL),(2290,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:36',NULL,NULL),(8309,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:20',NULL,NULL),(8081,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:17',NULL,NULL),(19709,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:04',NULL,NULL),(12629,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:55',NULL,NULL),(7914,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:43',NULL,NULL),(7560,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:08',NULL,NULL),(7094,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:15',NULL,NULL),(3486,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:32',NULL,NULL),(4956,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:37',NULL,NULL),(23101,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(1314,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:40',NULL,NULL),(21479,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:35',NULL,NULL),(10070,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:09',NULL,NULL),(2634,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:04',NULL,NULL),(9566,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:13',NULL,NULL),(4746,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:38',NULL,NULL),(20568,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:20',NULL,NULL),(18335,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:28',NULL,NULL),(13083,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:02',NULL,NULL),(14105,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:50',NULL,NULL),(22027,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:16',NULL,NULL),(22504,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:50',NULL,NULL),(23381,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:44',NULL,NULL),(577,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:55',NULL,NULL),(17040,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:11',NULL,NULL),(17625,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:03',NULL,NULL),(12728,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:24',NULL,NULL),(9400,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:50',NULL,NULL),(3292,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:40',NULL,NULL),(12635,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:57',NULL,NULL),(11366,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:03',NULL,NULL),(5600,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:04',NULL,NULL),(5360,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:14',NULL,NULL),(11282,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:39',NULL,NULL),(11362,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:02',NULL,NULL),(22300,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:44',NULL,NULL),(20592,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:29',NULL,NULL),(10005,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:52',NULL,NULL),(17168,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:53',NULL,NULL),(1426,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:22',NULL,NULL),(16399,1824,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:32',NULL,NULL),(2808,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:50',NULL,NULL),(14686,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:21',NULL,NULL),(4202,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:20',NULL,NULL),(4658,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:13',NULL,NULL),(5107,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:02',NULL,NULL),(22936,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:04',NULL,NULL),(1766,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:19',NULL,NULL),(21591,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:17',NULL,NULL),(21294,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:27',NULL,NULL),(21116,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:06',NULL,NULL),(20479,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:48',NULL,NULL),(3204,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:15',NULL,NULL),(16174,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:28',NULL,NULL),(3536,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:46',NULL,NULL),(3607,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:05',NULL,NULL),(15663,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:51',NULL,NULL),(15395,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:30',NULL,NULL),(7262,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:04',NULL,NULL),(7258,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:03',NULL,NULL),(13917,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:22',NULL,NULL),(19829,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:36',NULL,NULL),(6080,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:02',NULL,NULL),(18057,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:14',NULL,NULL),(11835,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:03',NULL,NULL),(17740,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:44',NULL,NULL),(23104,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:36',NULL,NULL),(14985,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:43',NULL,NULL),(1481,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:43',NULL,NULL),(9252,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:31:11',NULL,NULL),(9128,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:38',NULL,NULL),(21135,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:12',NULL,NULL),(7674,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:38',NULL,NULL),(1573,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:15',NULL,NULL),(3716,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:20',NULL,NULL),(1777,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:21',NULL,NULL),(5786,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:09',NULL,NULL),(5707,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:41',NULL,NULL),(4895,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:18',NULL,NULL),(1025,1881,'2014-01-14','23:11:00','A','000',0,'2014-01-23 19:31:24',NULL,NULL),(11026,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:24',NULL,NULL),(4765,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:43',NULL,NULL),(17509,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:21',NULL,NULL),(22834,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:31',NULL,NULL),(23007,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:18',NULL,NULL),(4004,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:33',NULL,NULL),(281,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:15',NULL,NULL),(9418,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:55',NULL,NULL),(1245,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:14',NULL,NULL),(7925,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:46',NULL,NULL),(11247,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:30',NULL,NULL),(13244,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:45',NULL,NULL),(13649,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:43',NULL,NULL),(16407,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:34',NULL,NULL),(18862,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:29',NULL,NULL),(19384,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:49',NULL,NULL),(19413,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:58',NULL,NULL),(19960,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:11',NULL,NULL),(21242,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:09',NULL,NULL),(22414,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:20',NULL,NULL),(5345,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:10',NULL,NULL),(10733,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:28',NULL,NULL),(4759,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:41',NULL,NULL),(9443,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:03',NULL,NULL),(4275,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:38',NULL,NULL),(6330,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:11',NULL,NULL),(2305,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:40',NULL,NULL),(20125,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:58',NULL,NULL),(22397,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:15',NULL,NULL),(23368,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:39',NULL,NULL),(557,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:48',NULL,NULL),(6830,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:11',NULL,NULL),(10813,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:48',NULL,NULL),(10771,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:37',NULL,NULL),(10578,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:47',NULL,NULL),(9171,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:49',NULL,NULL),(9730,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:55',NULL,NULL),(8294,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:15',NULL,NULL),(7785,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:07',NULL,NULL),(12813,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:48',NULL,NULL),(14059,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:43',NULL,NULL),(18476,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:08',NULL,NULL),(19051,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:23',NULL,NULL),(22360,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:02',NULL,NULL),(23249,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(5320,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:04',NULL,NULL),(1018,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:22',NULL,NULL),(3636,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:13',NULL,NULL),(8573,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:18',NULL,NULL),(5998,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:22',NULL,NULL),(17516,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:24',NULL,NULL),(20590,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:28',NULL,NULL),(4973,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:41',NULL,NULL),(4776,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:46',NULL,NULL),(1744,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:13',NULL,NULL),(4744,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:37',NULL,NULL),(6007,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:25',NULL,NULL),(8696,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:51',NULL,NULL),(23663,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 15:29:59',NULL,NULL),(5310,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:01',NULL,NULL),(4756,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:40',NULL,NULL),(8814,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:22',NULL,NULL),(3672,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:09',NULL,NULL),(2882,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:16',NULL,NULL),(3332,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:50',NULL,NULL),(11676,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:22',NULL,NULL),(12409,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:54',NULL,NULL),(16787,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:03',NULL,NULL),(2818,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:54',NULL,NULL),(13132,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:15',NULL,NULL),(15597,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:29',NULL,NULL),(16310,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:58',NULL,NULL),(22250,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:32',NULL,NULL),(4584,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:58',NULL,NULL),(9938,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:50',NULL,NULL),(9081,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:25',NULL,NULL),(8720,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:57',NULL,NULL),(7816,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:16',NULL,NULL),(7173,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:38',NULL,NULL),(1020,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:23',NULL,NULL),(6143,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:21',NULL,NULL),(2020,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:45',NULL,NULL),(12428,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:00',NULL,NULL),(17329,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:22',NULL,NULL),(19307,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:27',NULL,NULL),(19488,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:18',NULL,NULL),(20041,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:34',NULL,NULL),(23119,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(379,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:48',NULL,NULL),(3781,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:37',NULL,NULL),(8603,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:26',NULL,NULL),(10472,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:20',NULL,NULL),(3983,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:28',NULL,NULL),(7110,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:21',NULL,NULL),(12358,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:45',NULL,NULL),(13253,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:47',NULL,NULL),(15028,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:57',NULL,NULL),(18470,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:06',NULL,NULL),(22453,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:34',NULL,NULL),(6195,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:35',NULL,NULL),(10547,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:44:40',NULL,NULL),(1376,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:05',NULL,NULL),(11696,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:27',NULL,NULL),(2065,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:57',NULL,NULL),(7631,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:26',NULL,NULL),(5681,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:33',NULL,NULL),(4778,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:46',NULL,NULL),(2162,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:21',NULL,NULL),(19027,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:17',NULL,NULL),(177,210,'2013-12-27','15:05:00','A','000',0,'2014-01-13 03:05:00',NULL,NULL),(626,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:11',NULL,NULL),(8528,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:06',NULL,NULL),(6161,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:26',NULL,NULL),(18745,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:35:57',NULL,NULL),(4129,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:02:06',NULL,NULL),(10697,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:19',NULL,NULL),(11879,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:14',NULL,NULL),(18202,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:03',NULL,NULL),(14721,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:30',NULL,NULL),(17408,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:49',NULL,NULL),(22452,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:33',NULL,NULL),(2159,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:20',NULL,NULL),(17643,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:11',NULL,NULL),(17197,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:32:03',NULL,NULL),(11641,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:13',NULL,NULL),(8687,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:48',NULL,NULL),(3866,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:58',NULL,NULL),(3341,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:53',NULL,NULL),(2888,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:18',NULL,NULL),(6861,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:19',NULL,NULL),(2511,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:33',NULL,NULL),(6403,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:31',NULL,NULL),(5499,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:52',NULL,NULL),(22802,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:19',NULL,NULL),(23559,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 01:30:02',NULL,NULL),(398,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:57',NULL,NULL),(20014,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:27',NULL,NULL),(17902,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:20',NULL,NULL),(14795,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:51',NULL,NULL),(2486,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:26',NULL,NULL),(2604,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:56',NULL,NULL),(3674,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:10',NULL,NULL),(7079,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:10',NULL,NULL),(5516,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:57',NULL,NULL),(12400,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:56',NULL,NULL),(17199,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:04',NULL,NULL),(14860,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:08',NULL,NULL),(6916,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:36',NULL,NULL),(5865,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:36',NULL,NULL),(13573,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:33',NULL,NULL),(13288,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:56',NULL,NULL),(1847,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:38',NULL,NULL),(2697,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:11',NULL,NULL),(3892,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:06',NULL,NULL),(2433,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:13',NULL,NULL),(2847,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:04',NULL,NULL),(20758,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:27',NULL,NULL),(18709,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:11',NULL,NULL),(11567,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:55',NULL,NULL),(3447,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:22',NULL,NULL),(2195,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:04',NULL,NULL),(23136,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:42',NULL,NULL),(21987,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:02',NULL,NULL),(17353,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:30',NULL,NULL),(2062,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:56',NULL,NULL),(15821,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:20',NULL,NULL),(10538,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:37',NULL,NULL),(9891,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:38',NULL,NULL),(2935,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:35',NULL,NULL),(3175,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:06',NULL,NULL),(14057,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:43',NULL,NULL),(11955,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:50',NULL,NULL),(3663,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:07',NULL,NULL),(7960,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:55',NULL,NULL),(3230,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:23',NULL,NULL),(6639,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:20',NULL,NULL),(4441,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:23',NULL,NULL),(22224,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:25',NULL,NULL),(8240,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:59',NULL,NULL),(6414,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:34',NULL,NULL),(7625,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:25',NULL,NULL),(21108,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:04',NULL,NULL),(6929,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:42',NULL,NULL),(11213,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:21',NULL,NULL),(20941,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:18',NULL,NULL),(15222,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:01:57',NULL,NULL),(22892,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:50',NULL,NULL),(477,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:22',NULL,NULL),(21673,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:11',NULL,NULL),(3166,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:04',NULL,NULL),(19462,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:11',NULL,NULL),(19179,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:59',NULL,NULL),(15589,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:27',NULL,NULL),(21323,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:38',NULL,NULL),(7768,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:02',NULL,NULL),(7734,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:53',NULL,NULL),(5478,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:46',NULL,NULL),(1795,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:26',NULL,NULL),(21670,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:10',NULL,NULL),(2180,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:25',NULL,NULL),(4422,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:17',NULL,NULL),(8838,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:29',NULL,NULL),(18420,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:51',NULL,NULL),(16707,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:28',NULL,NULL),(15978,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:16',NULL,NULL),(15185,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:50',NULL,NULL),(19722,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:08',NULL,NULL),(17808,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:47',NULL,NULL),(8709,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:54',NULL,NULL),(15702,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:05',NULL,NULL),(1607,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:27',NULL,NULL),(4788,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:49',NULL,NULL),(9348,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:36',NULL,NULL),(9232,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:06',NULL,NULL),(4061,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:48',NULL,NULL),(3846,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:53',NULL,NULL),(3330,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:50',NULL,NULL),(23257,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(6391,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:28',NULL,NULL),(10486,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:24',NULL,NULL),(9958,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:55',NULL,NULL),(9909,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:43',NULL,NULL),(9629,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:29',NULL,NULL),(8891,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:43',NULL,NULL),(8823,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:25',NULL,NULL),(12229,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:06',NULL,NULL),(15076,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:13',NULL,NULL),(15490,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:53',NULL,NULL),(17038,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:10',NULL,NULL),(21255,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:14',NULL,NULL),(21748,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:38',NULL,NULL),(22665,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:29',NULL,NULL),(23605,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 21:30:03',NULL,NULL),(23681,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 19:30:04',NULL,NULL),(23723,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 23:29:58',NULL,NULL),(208,317,'2013-12-27','15:43:00','A','000',0,'2014-01-13 03:05:10',NULL,NULL),(10062,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:07',NULL,NULL),(6008,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:26',NULL,NULL),(11670,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:21',NULL,NULL),(12009,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:07',NULL,NULL),(13313,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:03',NULL,NULL),(15052,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:01:05',NULL,NULL),(20619,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:39',NULL,NULL),(20988,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:31',NULL,NULL),(22436,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:28',NULL,NULL),(12,157,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:12',NULL,NULL),(5540,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:05',NULL,NULL),(2852,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:05',NULL,NULL),(7297,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:13',NULL,NULL),(5504,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:54',NULL,NULL),(4554,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:51',NULL,NULL),(14073,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:46',NULL,NULL),(15735,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:15',NULL,NULL),(18064,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:16',NULL,NULL),(20624,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:41',NULL,NULL),(21149,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:16',NULL,NULL),(22247,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:31',NULL,NULL),(4221,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:25',NULL,NULL),(10504,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:28',NULL,NULL),(8659,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:41',NULL,NULL),(14169,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:00',NULL,NULL),(18242,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:17',NULL,NULL),(23154,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:45',NULL,NULL),(23514,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:30',NULL,NULL),(5514,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:56',NULL,NULL),(9948,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:52',NULL,NULL),(3720,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:22',NULL,NULL),(16411,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:36',NULL,NULL),(18676,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:02',NULL,NULL),(22958,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(23019,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 11:00:20',NULL,NULL),(295,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:20',NULL,NULL),(10793,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:43',NULL,NULL),(1638,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:37',NULL,NULL),(2615,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:59',NULL,NULL),(7675,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:38',NULL,NULL),(6992,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:58',NULL,NULL),(12223,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:05',NULL,NULL),(13274,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:53',NULL,NULL),(15425,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:35',NULL,NULL),(15645,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:45',NULL,NULL),(18750,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:58',NULL,NULL),(20233,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:19',NULL,NULL),(20346,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:00:59',NULL,NULL),(21622,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:29',NULL,NULL),(23102,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(1881,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:47',NULL,NULL),(5322,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:04',NULL,NULL),(4569,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:54',NULL,NULL),(3931,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:15',NULL,NULL),(9526,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:03',NULL,NULL),(12563,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:37',NULL,NULL),(18357,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:34',NULL,NULL),(19849,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:41',NULL,NULL),(21599,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:20',NULL,NULL),(21746,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:37',NULL,NULL),(22840,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:59:32',NULL,NULL),(6261,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:52',NULL,NULL),(833,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:32',NULL,NULL),(2410,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:07',NULL,NULL),(7179,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:39',NULL,NULL),(10096,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:17',NULL,NULL),(7861,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:30',NULL,NULL),(15352,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:22',NULL,NULL),(15902,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:49',NULL,NULL),(18300,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:19',NULL,NULL),(19432,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:03',NULL,NULL),(244,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:04',NULL,NULL),(10124,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:24',NULL,NULL),(8296,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:15',NULL,NULL),(4146,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:05',NULL,NULL),(1390,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:10',NULL,NULL),(3899,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:07',NULL,NULL),(7502,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:10',NULL,NULL),(2139,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:15',NULL,NULL),(13577,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:34',NULL,NULL),(14309,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:21',NULL,NULL),(14906,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:21',NULL,NULL),(15480,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:49',NULL,NULL),(15547,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:12',NULL,NULL),(16771,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:51',NULL,NULL),(17206,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:06',NULL,NULL),(18295,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:17',NULL,NULL),(19124,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:37:43',NULL,NULL),(21830,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:07',NULL,NULL),(21877,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:23',NULL,NULL),(22520,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:55',NULL,NULL),(22790,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:15',NULL,NULL),(23152,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:45',NULL,NULL),(2315,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:42',NULL,NULL),(8258,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:03',NULL,NULL),(11170,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:07',NULL,NULL),(5211,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:32',NULL,NULL),(16162,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:23',NULL,NULL),(16783,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:02',NULL,NULL),(18303,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:20',NULL,NULL),(18527,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:22',NULL,NULL),(20150,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:32:05',NULL,NULL),(20875,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:01',NULL,NULL),(1755,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:16',NULL,NULL),(11044,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:29',NULL,NULL),(4178,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:14',NULL,NULL),(9493,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:55',NULL,NULL),(9368,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:42',NULL,NULL),(1999,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:40',NULL,NULL),(9328,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:31',NULL,NULL),(9012,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:06',NULL,NULL),(13777,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:03',NULL,NULL),(13793,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:05',NULL,NULL),(16746,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:42',NULL,NULL),(18071,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:19',NULL,NULL),(18304,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:20',NULL,NULL),(23460,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:12',NULL,NULL),(23461,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:12',NULL,NULL),(69,241,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:04',NULL,NULL),(10698,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:19',NULL,NULL),(8181,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:43',NULL,NULL),(230,257,'2013-12-27','15:23:00','A','000',0,'2014-01-13 03:05:17',NULL,NULL),(7119,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:23',NULL,NULL),(6965,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:51',NULL,NULL),(6955,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:48',NULL,NULL),(470,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:20',NULL,NULL),(4430,1856,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:20',NULL,NULL),(19906,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:56',NULL,NULL),(8619,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:30',NULL,NULL),(20637,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:45',NULL,NULL),(2708,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:14',NULL,NULL),(19369,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:45',NULL,NULL),(2919,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:29',NULL,NULL),(7819,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:17',NULL,NULL),(7634,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:27',NULL,NULL),(7271,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:06',NULL,NULL),(4808,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:54',NULL,NULL),(18870,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:31',NULL,NULL),(6444,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:42',NULL,NULL),(14062,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:44',NULL,NULL),(6042,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:38',NULL,NULL),(22679,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:33',NULL,NULL),(105,266,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:37',NULL,NULL),(17153,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:48',NULL,NULL),(748,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:08',NULL,NULL),(5045,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:02:02',NULL,NULL),(7328,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:22',NULL,NULL),(5849,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:30',NULL,NULL),(3792,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:40',NULL,NULL),(3688,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:13',NULL,NULL),(22530,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:59',NULL,NULL),(22797,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:17',NULL,NULL),(21352,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:48',NULL,NULL),(4115,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:02',NULL,NULL),(9044,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:14',NULL,NULL),(16266,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:01',NULL,NULL),(8040,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:06',NULL,NULL),(13327,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:07',NULL,NULL),(5840,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:27',NULL,NULL),(11287,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:41',NULL,NULL),(7478,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:03',NULL,NULL),(20779,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:34',NULL,NULL),(16600,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:46',NULL,NULL),(1335,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:47',NULL,NULL),(9024,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:09',NULL,NULL),(16372,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:20',NULL,NULL),(20458,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:41',NULL,NULL),(12148,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:44',NULL,NULL),(11219,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:23',NULL,NULL),(10747,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:31',NULL,NULL),(5829,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:24',NULL,NULL),(805,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:25',NULL,NULL),(21243,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:09',NULL,NULL),(1112,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:48',NULL,NULL),(20730,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:20',NULL,NULL),(17688,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:26',NULL,NULL),(15064,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:09',NULL,NULL),(3504,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:37',NULL,NULL),(8051,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:09',NULL,NULL),(8022,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:12',NULL,NULL),(15029,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:58',NULL,NULL),(3770,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:34',NULL,NULL),(14635,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:06',NULL,NULL),(5899,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:48',NULL,NULL),(10532,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:36',NULL,NULL),(14281,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:17',NULL,NULL),(22772,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:07',NULL,NULL),(23132,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(179,245,'2013-12-27','15:17:00','A','000',0,'2014-01-13 03:05:01',NULL,NULL),(252,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:06',NULL,NULL),(272,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:13',NULL,NULL),(21471,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:32',NULL,NULL),(19687,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:14',NULL,NULL),(2558,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:44',NULL,NULL),(8144,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:30:33',NULL,NULL),(8073,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:14',NULL,NULL),(6503,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:58',NULL,NULL),(18102,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:29',NULL,NULL),(5132,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:10',NULL,NULL),(16133,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:13',NULL,NULL),(13791,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:04',NULL,NULL),(14863,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:09',NULL,NULL),(76,359,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:11',NULL,NULL),(499,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:29',NULL,NULL),(18075,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:20',NULL,NULL),(16641,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:03',NULL,NULL),(667,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:24',NULL,NULL),(1137,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:55',NULL,NULL),(2514,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:33',NULL,NULL),(3778,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:37',NULL,NULL),(15402,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:31',NULL,NULL),(14950,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:32',NULL,NULL),(12844,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:59',NULL,NULL),(4949,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:35',NULL,NULL),(22218,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:24',NULL,NULL),(22937,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:04',NULL,NULL),(23534,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 23:30:02',NULL,NULL),(21809,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:00',NULL,NULL),(10487,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:24',NULL,NULL),(1298,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:34',NULL,NULL),(17237,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:17',NULL,NULL),(17027,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:07',NULL,NULL),(15656,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:49',NULL,NULL),(3079,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:28',NULL,NULL),(13285,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:56',NULL,NULL),(7703,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:45',NULL,NULL),(4008,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:34',NULL,NULL),(3384,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:05',NULL,NULL),(3790,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:39',NULL,NULL),(5369,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:17',NULL,NULL),(21376,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:57',NULL,NULL),(19623,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:55',NULL,NULL),(18586,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:38',NULL,NULL),(16775,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:53',NULL,NULL),(14771,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:44',NULL,NULL),(8432,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:52',NULL,NULL),(7838,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:22',NULL,NULL),(3743,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:27',NULL,NULL),(5835,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:26',NULL,NULL),(4108,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:00',NULL,NULL),(119,264,'2013-12-27','15:26:00','A','000',0,'2014-01-13 03:04:41',NULL,NULL),(8237,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:57',NULL,NULL),(7769,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:02',NULL,NULL),(5291,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:55',NULL,NULL),(11822,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:00',NULL,NULL),(12587,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:43',NULL,NULL),(12735,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:26',NULL,NULL),(15931,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:59',NULL,NULL),(16042,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:39',NULL,NULL),(17494,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:16',NULL,NULL),(19189,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:02',NULL,NULL),(19385,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:50',NULL,NULL),(19549,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:35',NULL,NULL),(4965,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:39',NULL,NULL),(6174,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:30',NULL,NULL),(10613,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:56',NULL,NULL),(7269,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:06',NULL,NULL),(11393,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:10',NULL,NULL),(12315,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:31',NULL,NULL),(13696,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:49',NULL,NULL),(16512,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:14',NULL,NULL),(18015,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:00',NULL,NULL),(18587,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:38',NULL,NULL),(19130,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:45',NULL,NULL),(19237,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:08',NULL,NULL),(4118,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:02:03',NULL,NULL),(10824,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:50',NULL,NULL),(854,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:38',NULL,NULL),(9507,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:35:58',NULL,NULL),(1913,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:55',NULL,NULL),(3034,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:12',NULL,NULL),(869,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:42',NULL,NULL),(21375,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:57',NULL,NULL),(23439,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:04',NULL,NULL),(207,285,'2013-12-27','15:32:00','A','000',0,'2014-01-13 03:05:10',NULL,NULL),(414,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:02',NULL,NULL),(10316,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:17',NULL,NULL),(1661,1870,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:02:47',NULL,NULL),(9308,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:26',NULL,NULL),(11729,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:36',NULL,NULL),(13925,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:23',NULL,NULL),(16044,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:39',NULL,NULL),(19465,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:12',NULL,NULL),(21508,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:46',NULL,NULL),(22672,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:31',NULL,NULL),(160,364,'2013-12-27','16:15:00','A','000',0,'2014-01-13 03:04:54',NULL,NULL),(4672,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:17',NULL,NULL),(8165,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:39',NULL,NULL),(17104,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:32',NULL,NULL),(17418,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:52',NULL,NULL),(20141,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:02',NULL,NULL),(22600,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:23',NULL,NULL),(1178,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:06',NULL,NULL),(1652,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:42',NULL,NULL),(2260,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:28',NULL,NULL),(4611,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:32:05',NULL,NULL),(3494,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:34',NULL,NULL),(3430,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:31:17',NULL,NULL),(11659,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:18',NULL,NULL),(11820,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:59',NULL,NULL),(12974,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:34',NULL,NULL),(13483,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:20',NULL,NULL),(14617,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:01',NULL,NULL),(19194,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:38:04',NULL,NULL),(1066,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:35',NULL,NULL),(1174,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:05',NULL,NULL),(7877,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:34',NULL,NULL),(2022,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:46',NULL,NULL),(14671,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:17',NULL,NULL),(15923,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:57',NULL,NULL),(17515,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:24',NULL,NULL),(17657,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:15',NULL,NULL),(18604,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:43',NULL,NULL),(19420,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:00',NULL,NULL),(23485,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:20',NULL,NULL),(766,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:13',NULL,NULL),(11005,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:18',NULL,NULL),(10357,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:29',NULL,NULL),(9985,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:46',NULL,NULL),(8397,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:43',NULL,NULL),(5520,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:58',NULL,NULL),(12184,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:53',NULL,NULL),(15111,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:25',NULL,NULL),(17799,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:44',NULL,NULL),(18305,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:20',NULL,NULL),(19421,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:00',NULL,NULL),(4009,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:34',NULL,NULL),(3197,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:13',NULL,NULL),(13291,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:57',NULL,NULL),(21533,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:55',NULL,NULL),(22024,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:15',NULL,NULL),(22627,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:16',NULL,NULL),(1132,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:53',NULL,NULL),(3474,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:29',NULL,NULL),(10495,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:26',NULL,NULL),(6629,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:17',NULL,NULL),(6383,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:26',NULL,NULL),(15567,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:19',NULL,NULL),(17171,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:54',NULL,NULL),(17630,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:05',NULL,NULL),(17646,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:12',NULL,NULL),(18807,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:14',NULL,NULL),(19985,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:19',NULL,NULL),(23271,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:07',NULL,NULL),(7063,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:05',NULL,NULL),(10492,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:25',NULL,NULL),(11767,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:46',NULL,NULL),(11516,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:42',NULL,NULL),(12833,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:55',NULL,NULL),(13600,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:37',NULL,NULL),(14838,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:02',NULL,NULL),(17998,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:53',NULL,NULL),(19058,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:25',NULL,NULL),(21198,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:52',NULL,NULL),(23645,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 12:30:03',NULL,NULL),(2179,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:25',NULL,NULL),(6580,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:05',NULL,NULL),(10110,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:21',NULL,NULL),(9562,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:12',NULL,NULL),(8583,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:21',NULL,NULL),(7337,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:24',NULL,NULL),(7248,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:00',NULL,NULL),(14730,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:32',NULL,NULL),(15476,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:48',NULL,NULL),(16296,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:14',NULL,NULL),(18322,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:25',NULL,NULL),(21212,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:57',NULL,NULL),(21947,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:48',NULL,NULL),(1125,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:51',NULL,NULL),(11380,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:07',NULL,NULL),(10449,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:54',NULL,NULL),(4519,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:42',NULL,NULL),(3091,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:32',NULL,NULL),(8035,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:04',NULL,NULL),(4333,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:54',NULL,NULL),(7018,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:05',NULL,NULL),(14024,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:38',NULL,NULL),(17126,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:40',NULL,NULL),(21655,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:04',NULL,NULL),(23006,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:17',NULL,NULL),(664,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:23',NULL,NULL),(1423,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:21',NULL,NULL),(7805,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:14',NULL,NULL),(12812,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:48',NULL,NULL),(15217,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:56',NULL,NULL),(21176,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:44',NULL,NULL),(832,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:32',NULL,NULL),(9871,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:33',NULL,NULL),(19987,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:19',NULL,NULL),(8497,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:10',NULL,NULL),(7669,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:37',NULL,NULL),(16378,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:23',NULL,NULL),(11546,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:49',NULL,NULL),(2490,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:27',NULL,NULL),(5706,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:41',NULL,NULL),(6751,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:48',NULL,NULL),(2019,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:45',NULL,NULL),(22690,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:37',NULL,NULL),(2684,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:06',NULL,NULL),(2751,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:30',NULL,NULL),(9604,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:23',NULL,NULL),(9530,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:04',NULL,NULL),(22425,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:24',NULL,NULL),(18199,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:02',NULL,NULL),(17178,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:57',NULL,NULL),(7715,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:48',NULL,NULL),(17050,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:14',NULL,NULL),(16861,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:23',NULL,NULL),(7176,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:38',NULL,NULL),(3484,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:31',NULL,NULL),(6385,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:26',NULL,NULL),(3774,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:35',NULL,NULL),(15833,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:24',NULL,NULL),(11386,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:08',NULL,NULL),(15051,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:05',NULL,NULL),(20257,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:28',NULL,NULL),(13166,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:24',NULL,NULL),(14925,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:25',NULL,NULL),(18228,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:12',NULL,NULL),(17979,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:46',NULL,NULL),(2484,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:26',NULL,NULL),(9732,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:56',NULL,NULL),(3314,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:46',NULL,NULL),(15884,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:43',NULL,NULL),(13951,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:27',NULL,NULL),(11564,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:54',NULL,NULL),(23072,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(23123,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:39',NULL,NULL),(23724,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 01:29:58',NULL,NULL),(22519,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:55',NULL,NULL),(2820,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:54',NULL,NULL),(3276,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:35',NULL,NULL),(18293,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:17',NULL,NULL),(3669,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:08',NULL,NULL),(10918,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:15',NULL,NULL),(3958,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:22',NULL,NULL),(9303,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:24',NULL,NULL),(17230,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:14',NULL,NULL),(4468,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:29',NULL,NULL),(14367,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:50',NULL,NULL),(12257,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:14',NULL,NULL),(12577,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:41',NULL,NULL),(2337,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:48',NULL,NULL),(22580,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:15',NULL,NULL),(21180,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:45',NULL,NULL),(15347,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:21',NULL,NULL),(14539,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:39',NULL,NULL),(13948,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:26',NULL,NULL),(11501,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:38',NULL,NULL),(5376,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:18',NULL,NULL),(19498,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:20',NULL,NULL),(17825,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:53',NULL,NULL),(21046,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:47',NULL,NULL),(9700,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:48',NULL,NULL),(9630,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:30',NULL,NULL),(11711,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:31',NULL,NULL),(9360,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:39',NULL,NULL),(11494,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:36',NULL,NULL),(7590,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:16',NULL,NULL),(4555,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:51',NULL,NULL),(7100,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:30:18',NULL,NULL),(233,292,'2013-12-27','15:34:00','A','000',0,'2014-01-13 03:05:18',NULL,NULL),(11124,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:55',NULL,NULL),(11021,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:22',NULL,NULL),(10740,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:30',NULL,NULL),(22711,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:45',NULL,NULL),(10509,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:29',NULL,NULL),(1325,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:44',NULL,NULL),(21998,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:06',NULL,NULL),(9830,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:22',NULL,NULL),(4734,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:34',NULL,NULL),(20699,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:10',NULL,NULL),(6312,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:06',NULL,NULL),(18348,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:32',NULL,NULL),(18055,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:13',NULL,NULL),(929,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:58',NULL,NULL),(986,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:14',NULL,NULL),(10986,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:13',NULL,NULL),(3554,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:31:51',NULL,NULL),(22597,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:22',NULL,NULL),(20320,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:50',NULL,NULL),(18152,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:46',NULL,NULL),(6034,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:35',NULL,NULL),(12586,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:43',NULL,NULL),(13434,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:12',NULL,NULL),(14612,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:59',NULL,NULL),(15215,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:55',NULL,NULL),(15559,1859,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:17',NULL,NULL),(430,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:07',NULL,NULL),(9555,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:10',NULL,NULL),(8844,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:30',NULL,NULL),(8713,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:55',NULL,NULL),(756,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:11',NULL,NULL),(1126,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:51',NULL,NULL),(22667,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:29',NULL,NULL),(2489,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:27',NULL,NULL),(9747,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:00',NULL,NULL),(15531,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:07',NULL,NULL),(3671,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:09',NULL,NULL),(4863,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:10',NULL,NULL),(22281,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:40',NULL,NULL),(11824,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:00',NULL,NULL),(21347,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:47',NULL,NULL),(18506,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:16',NULL,NULL),(18902,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:40',NULL,NULL),(20321,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:51',NULL,NULL),(1280,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:28',NULL,NULL),(18026,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:03',NULL,NULL),(1663,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:47',NULL,NULL),(11169,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:07',NULL,NULL),(17003,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:58',NULL,NULL),(2134,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:14',NULL,NULL),(3841,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:52',NULL,NULL),(3912,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:11',NULL,NULL),(6282,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:58',NULL,NULL),(15268,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:06',NULL,NULL),(23151,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(14299,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:19',NULL,NULL),(7064,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:05',NULL,NULL),(10909,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:13',NULL,NULL),(7823,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:18',NULL,NULL),(8216,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:52',NULL,NULL),(12496,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:19',NULL,NULL),(12917,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:18',NULL,NULL),(15292,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:10',NULL,NULL),(22069,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:32',NULL,NULL),(2524,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:36',NULL,NULL),(6001,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:23',NULL,NULL),(4174,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:13',NULL,NULL),(4646,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:09',NULL,NULL),(9109,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:32',NULL,NULL),(6910,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:34',NULL,NULL),(6478,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:52',NULL,NULL),(12364,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:46',NULL,NULL),(19818,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:33',NULL,NULL),(19857,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:43',NULL,NULL),(5796,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:12',NULL,NULL),(5609,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:07',NULL,NULL),(9781,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:09',NULL,NULL),(8630,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:33',NULL,NULL),(7656,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:33',NULL,NULL),(7489,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:06',NULL,NULL),(3578,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:57',NULL,NULL),(5066,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:07',NULL,NULL),(13278,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:54',NULL,NULL),(16637,1821,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:02',NULL,NULL),(17683,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:25',NULL,NULL),(18630,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:50',NULL,NULL),(21462,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:29',NULL,NULL),(21964,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:54',NULL,NULL),(5203,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:30',NULL,NULL),(915,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:54',NULL,NULL),(1100,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:44',NULL,NULL),(10801,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:45',NULL,NULL),(9767,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:05',NULL,NULL),(9285,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:20',NULL,NULL),(6734,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:44',NULL,NULL),(6496,1876,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:31:56',NULL,NULL),(3149,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:52',NULL,NULL),(14100,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:49',NULL,NULL),(14817,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:56',NULL,NULL),(18088,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:25',NULL,NULL),(18673,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:01',NULL,NULL),(19998,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:23',NULL,NULL),(58,225,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:54',NULL,NULL),(3435,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:18',NULL,NULL),(11172,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:08',NULL,NULL),(1039,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:28',NULL,NULL),(1851,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:39',NULL,NULL),(9887,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:37',NULL,NULL),(9716,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:52',NULL,NULL),(9522,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:02',NULL,NULL),(6396,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:29',NULL,NULL),(8697,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:51',NULL,NULL),(8452,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:58',NULL,NULL),(14187,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:02',NULL,NULL),(14665,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:15',NULL,NULL),(19285,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:21',NULL,NULL),(6283,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:59',NULL,NULL),(7920,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:45',NULL,NULL),(4580,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:57',NULL,NULL),(2415,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:08',NULL,NULL),(12488,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:17',NULL,NULL),(12953,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:29',NULL,NULL),(14827,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:59',NULL,NULL),(15984,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:18',NULL,NULL),(17714,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:35',NULL,NULL),(18680,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:32:03',NULL,NULL),(22297,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:43',NULL,NULL),(141,375,'2013-12-27','16:41:00','A','000',0,'2014-01-13 03:04:48',NULL,NULL),(6081,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:03',NULL,NULL),(5052,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:04',NULL,NULL),(10573,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:46',NULL,NULL),(4944,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:33',NULL,NULL),(8831,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:27',NULL,NULL),(14780,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:47',NULL,NULL),(16496,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:08',NULL,NULL),(20393,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:17',NULL,NULL),(22862,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:40',NULL,NULL),(6269,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:55',NULL,NULL),(1372,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:04',NULL,NULL),(5997,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:22',NULL,NULL),(5578,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:16',NULL,NULL),(7317,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:19',NULL,NULL),(7130,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:26',NULL,NULL),(4785,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:48',NULL,NULL),(14130,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:54',NULL,NULL),(16597,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:45',NULL,NULL),(16715,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:31',NULL,NULL),(19170,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:57',NULL,NULL),(22428,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:25',NULL,NULL),(210,176,'2013-12-27','14:50:00','A','000',0,'2014-01-13 03:05:11',NULL,NULL),(12377,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:49',NULL,NULL),(6373,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:23',NULL,NULL),(1751,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:15',NULL,NULL),(4371,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:04',NULL,NULL),(2940,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:36',NULL,NULL),(12925,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:20',NULL,NULL),(13303,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:00',NULL,NULL),(13761,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:00',NULL,NULL),(20156,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:06',NULL,NULL),(20340,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:57',NULL,NULL),(20367,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:08',NULL,NULL),(22948,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(4908,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:22',NULL,NULL),(11713,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:32',NULL,NULL),(8466,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:01',NULL,NULL),(6926,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:40',NULL,NULL),(4789,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:49',NULL,NULL),(14019,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:38',NULL,NULL),(14828,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:52:00',NULL,NULL),(16506,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:12',NULL,NULL),(4257,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:34',NULL,NULL),(8273,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:07',NULL,NULL),(13548,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:29',NULL,NULL),(13861,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:14',NULL,NULL),(17988,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:49',NULL,NULL),(18602,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:42',NULL,NULL),(18965,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:59',NULL,NULL),(23332,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:27',NULL,NULL),(291,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:19',NULL,NULL),(1435,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:26',NULL,NULL),(1767,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:19',NULL,NULL),(5862,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:35',NULL,NULL),(14784,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:48',NULL,NULL),(4560,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:52',NULL,NULL),(2749,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:29',NULL,NULL),(14674,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:17',NULL,NULL),(12362,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:46',NULL,NULL),(19757,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:17',NULL,NULL),(20686,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:06',NULL,NULL),(20997,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:34',NULL,NULL),(21604,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:22',NULL,NULL),(1538,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:02',NULL,NULL),(19011,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:12',NULL,NULL),(5886,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:43',NULL,NULL),(8594,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:24',NULL,NULL),(9514,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:00',NULL,NULL),(10420,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:46',NULL,NULL),(13478,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:19',NULL,NULL),(11588,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:00',NULL,NULL),(22632,1898,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:58:18',NULL,NULL),(20505,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:57',NULL,NULL),(1146,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:57',NULL,NULL),(11904,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:21',NULL,NULL),(1875,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:45',NULL,NULL),(7558,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:08',NULL,NULL),(7325,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:21',NULL,NULL),(4109,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:02:00',NULL,NULL),(8714,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:56',NULL,NULL),(11467,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:30',NULL,NULL),(9265,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:15',NULL,NULL),(11118,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:53',NULL,NULL),(10640,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:03',NULL,NULL),(19742,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:13',NULL,NULL),(22155,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:06',NULL,NULL),(23167,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(23509,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:28',NULL,NULL),(15452,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:40',NULL,NULL),(8757,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:07',NULL,NULL),(11837,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:04',NULL,NULL),(10077,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:11',NULL,NULL),(22441,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:30',NULL,NULL),(22847,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:35',NULL,NULL),(15036,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:00',NULL,NULL),(14310,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:21',NULL,NULL),(13864,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:15',NULL,NULL),(9105,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:31',NULL,NULL),(3366,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:00',NULL,NULL),(6648,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:22',NULL,NULL),(6329,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:11',NULL,NULL),(1477,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:41',NULL,NULL),(20709,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:13',NULL,NULL),(18343,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:30',NULL,NULL),(8561,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:15',NULL,NULL),(8377,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:38',NULL,NULL),(8148,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:34',NULL,NULL),(563,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:50',NULL,NULL),(17340,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:26',NULL,NULL),(12543,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:32',NULL,NULL),(1456,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:34',NULL,NULL),(7418,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:46',NULL,NULL),(2265,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:29',NULL,NULL),(6435,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:40',NULL,NULL),(11653,1575,'2014-01-13','22:14:00','A','000',0,'2014-01-24 05:15:17',NULL,NULL),(11376,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:06',NULL,NULL),(3515,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:40',NULL,NULL),(5012,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:53',NULL,NULL),(10752,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:33',NULL,NULL),(10259,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:01',NULL,NULL),(21807,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:59',NULL,NULL),(14585,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:51',NULL,NULL),(13010,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:43',NULL,NULL),(9546,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:08',NULL,NULL),(20034,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:32',NULL,NULL),(22163,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:08',NULL,NULL),(18947,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:53',NULL,NULL),(14932,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:27',NULL,NULL),(12098,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:30',NULL,NULL),(2980,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:51',NULL,NULL),(4462,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:28',NULL,NULL),(4556,1867,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:51',NULL,NULL),(5426,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:32',NULL,NULL),(6226,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:43',NULL,NULL),(10244,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:57',NULL,NULL),(20851,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:54',NULL,NULL),(22861,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:40',NULL,NULL),(1357,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:57',NULL,NULL),(8731,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:00',NULL,NULL),(17118,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:37',NULL,NULL),(8003,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:06',NULL,NULL),(2516,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:34',NULL,NULL),(16207,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:39',NULL,NULL),(16192,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:34',NULL,NULL),(22620,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:29',NULL,NULL),(13113,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:11',NULL,NULL),(13263,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:50',NULL,NULL),(15782,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:32',NULL,NULL),(15066,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:10',NULL,NULL),(20819,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:45',NULL,NULL),(72,274,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:07',NULL,NULL),(1537,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:02',NULL,NULL),(14875,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:12',NULL,NULL),(12778,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:38',NULL,NULL),(11559,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:53',NULL,NULL),(2225,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:13',NULL,NULL),(3058,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:21',NULL,NULL),(10115,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:22',NULL,NULL),(21119,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:07',NULL,NULL),(22546,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:04',NULL,NULL),(22884,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:47',NULL,NULL),(18725,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:16',NULL,NULL),(964,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:08',NULL,NULL),(17331,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:23',NULL,NULL),(15771,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:28',NULL,NULL),(15769,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:27',NULL,NULL),(13045,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:52',NULL,NULL),(7736,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:54',NULL,NULL),(6335,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:12',NULL,NULL),(12785,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:40',NULL,NULL),(6873,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:22',NULL,NULL),(11234,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:27',NULL,NULL),(10093,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:16',NULL,NULL),(20046,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:36',NULL,NULL),(19773,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:21',NULL,NULL),(18596,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:41',NULL,NULL),(8283,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:11',NULL,NULL),(18338,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:29',NULL,NULL),(6474,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:50',NULL,NULL),(344,1878,'2014-01-14','23:11:00','A','000',0,'2014-01-23 19:00:37',NULL,NULL),(18330,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:27',NULL,NULL),(13771,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:02',NULL,NULL),(10608,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:55',NULL,NULL),(12997,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:40',NULL,NULL),(20300,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:43',NULL,NULL),(20646,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:49',NULL,NULL),(21528,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:54',NULL,NULL),(15784,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:33',NULL,NULL),(15432,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:37',NULL,NULL),(12614,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:51',NULL,NULL),(1550,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:07',NULL,NULL),(12180,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:52',NULL,NULL),(20305,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:45',NULL,NULL),(20820,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:45',NULL,NULL),(21133,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:11',NULL,NULL),(21776,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:48',NULL,NULL),(10352,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:27',NULL,NULL),(3937,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:17',NULL,NULL),(9947,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:52',NULL,NULL),(5890,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:44',NULL,NULL),(6989,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:57',NULL,NULL),(20918,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:12',NULL,NULL),(23261,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:05',NULL,NULL),(23315,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:21',NULL,NULL),(1702,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:03',NULL,NULL),(19740,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:13',NULL,NULL),(3942,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:18',NULL,NULL),(16946,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:43',NULL,NULL),(7725,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:00:51',NULL,NULL),(10524,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:33',NULL,NULL),(16386,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:26',NULL,NULL),(11825,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:01',NULL,NULL),(11860,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:10',NULL,NULL),(16360,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:16',NULL,NULL),(12290,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:23',NULL,NULL),(19502,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:21',NULL,NULL),(14103,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:50',NULL,NULL),(15648,1655,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:46',NULL,NULL),(22393,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:13',NULL,NULL),(22806,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:21',NULL,NULL),(171,191,'2013-12-27','14:56:00','A','000',0,'2014-01-13 03:04:58',NULL,NULL),(15591,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:27',NULL,NULL),(13262,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:50',NULL,NULL),(738,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:06',NULL,NULL),(8453,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:58',NULL,NULL),(18636,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:51',NULL,NULL),(764,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:13',NULL,NULL),(18620,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:47',NULL,NULL),(3896,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:07',NULL,NULL),(21343,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:45',NULL,NULL),(22415,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:20',NULL,NULL),(22544,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:03',NULL,NULL),(573,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:53',NULL,NULL),(1968,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:32',NULL,NULL),(20262,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:29',NULL,NULL),(18339,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:29',NULL,NULL),(18222,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:15:10',NULL,NULL),(5860,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:34',NULL,NULL),(11178,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:10',NULL,NULL),(22170,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:10',NULL,NULL),(14926,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:26',NULL,NULL),(16951,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:45',NULL,NULL),(22610,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:26',NULL,NULL),(1489,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:45',NULL,NULL),(20254,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:27',NULL,NULL),(2793,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:45',NULL,NULL),(15781,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:32',NULL,NULL),(10100,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:18',NULL,NULL),(10135,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:27',NULL,NULL),(15573,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:21',NULL,NULL),(15365,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:24',NULL,NULL),(11019,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:22',NULL,NULL),(12070,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:23',NULL,NULL),(15082,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:15',NULL,NULL),(14896,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:18',NULL,NULL),(23352,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:34',NULL,NULL),(16649,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:07',NULL,NULL),(9843,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:26',NULL,NULL),(19287,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:21',NULL,NULL),(2222,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:11',NULL,NULL),(9139,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:41',NULL,NULL),(3164,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:04',NULL,NULL),(3813,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:45',NULL,NULL),(2501,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:30',NULL,NULL),(7274,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:07',NULL,NULL),(23143,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:43',NULL,NULL),(115,200,'2013-12-27','14:58:00','A','000',0,'2014-01-13 03:04:40',NULL,NULL),(400,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:57',NULL,NULL),(7562,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:09',NULL,NULL),(20447,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:37',NULL,NULL),(18613,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:45',NULL,NULL),(2797,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:46',NULL,NULL),(3002,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:59',NULL,NULL),(4770,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:44',NULL,NULL),(5002,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:50',NULL,NULL),(14989,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:44',NULL,NULL),(14947,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:31',NULL,NULL),(14941,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:29',NULL,NULL),(18794,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:11',NULL,NULL),(11164,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:06',NULL,NULL),(12644,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:59',NULL,NULL),(21558,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:05',NULL,NULL),(21682,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:14',NULL,NULL),(18363,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:36',NULL,NULL),(1315,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:40',NULL,NULL),(5189,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:26',NULL,NULL),(17867,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:08',NULL,NULL),(6982,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:55',NULL,NULL),(15628,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:40',NULL,NULL),(11356,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:00',NULL,NULL),(15231,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:58',NULL,NULL),(20172,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:32:11',NULL,NULL),(21292,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:27',NULL,NULL),(564,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:50',NULL,NULL),(10068,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:09',NULL,NULL),(1098,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:44',NULL,NULL),(13854,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:13',NULL,NULL),(3129,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:02:45',NULL,NULL),(2361,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:54',NULL,NULL),(6102,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:09',NULL,NULL),(21089,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:59',NULL,NULL),(19994,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:22',NULL,NULL),(16912,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:35',NULL,NULL),(13195,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:32',NULL,NULL),(12439,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:03',NULL,NULL),(11961,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:52',NULL,NULL),(19952,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:09',NULL,NULL),(19233,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:06',NULL,NULL),(4961,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:38',NULL,NULL),(19001,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:10',NULL,NULL),(4647,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:09',NULL,NULL),(4550,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:50',NULL,NULL),(16551,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:28',NULL,NULL),(13460,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:16',NULL,NULL),(12675,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:08',NULL,NULL),(21154,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:17',NULL,NULL),(23475,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:17',NULL,NULL),(215,308,'2013-12-27','15:38:00','A','000',0,'2014-01-13 03:05:12',NULL,NULL),(14544,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:40',NULL,NULL),(1033,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:27',NULL,NULL),(14338,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:28',NULL,NULL),(10203,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:46',NULL,NULL),(20788,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:36',NULL,NULL),(23360,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:37',NULL,NULL),(1756,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:16',NULL,NULL),(17405,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:48',NULL,NULL),(8219,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:53',NULL,NULL),(2794,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:45',NULL,NULL),(7623,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:24',NULL,NULL),(15997,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:23',NULL,NULL),(7078,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:10',NULL,NULL),(3040,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:14',NULL,NULL),(6710,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:38',NULL,NULL),(5649,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:21',NULL,NULL),(14424,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:07',NULL,NULL),(13842,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:11',NULL,NULL),(10615,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:56',NULL,NULL),(9599,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:22',NULL,NULL),(20145,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:03',NULL,NULL),(15558,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:16',NULL,NULL),(13691,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:49',NULL,NULL),(8111,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:25',NULL,NULL),(11777,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:49',NULL,NULL),(2716,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:18',NULL,NULL),(5612,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:08',NULL,NULL),(2902,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:23',NULL,NULL),(3487,1889,'2014-01-14','23:11:00','A','000',0,'2014-01-23 22:31:32',NULL,NULL),(5147,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:14',NULL,NULL),(9059,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:19',NULL,NULL),(11273,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:37',NULL,NULL),(21711,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:24',NULL,NULL),(21896,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:30',NULL,NULL),(18619,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:47',NULL,NULL),(16209,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:40',NULL,NULL),(15900,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:49',NULL,NULL),(15332,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:18',NULL,NULL),(12350,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:42',NULL,NULL),(12374,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:49',NULL,NULL),(13026,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:47',NULL,NULL),(14946,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:31',NULL,NULL),(14792,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:50',NULL,NULL),(22112,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:47',NULL,NULL),(19547,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:35',NULL,NULL),(16488,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:05',NULL,NULL),(1057,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:33',NULL,NULL),(5018,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:54',NULL,NULL),(9235,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:07',NULL,NULL),(9339,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:34',NULL,NULL),(9516,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:00',NULL,NULL),(9831,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:22',NULL,NULL),(12503,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:21',NULL,NULL),(10448,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:54',NULL,NULL),(22398,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:15',NULL,NULL),(132,166,'2013-12-27','14:37:00','A','000',0,'2014-01-13 03:04:45',NULL,NULL),(8542,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:10',NULL,NULL),(8449,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:57',NULL,NULL),(3570,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:55',NULL,NULL),(16658,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:10',NULL,NULL),(7774,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:04',NULL,NULL),(15791,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:35',NULL,NULL),(13814,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:08',NULL,NULL),(12523,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:26',NULL,NULL),(10122,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:24',NULL,NULL),(20808,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:42',NULL,NULL),(17265,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:26',NULL,NULL),(16911,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:35',NULL,NULL),(3783,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:38',NULL,NULL),(4101,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:58',NULL,NULL),(6187,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:33',NULL,NULL),(11094,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:47',NULL,NULL),(12217,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:03',NULL,NULL),(14099,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:49',NULL,NULL),(16215,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:42',NULL,NULL),(20057,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:39',NULL,NULL),(21124,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:09',NULL,NULL),(14356,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:49:47',NULL,NULL),(14979,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:40',NULL,NULL),(1488,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:45',NULL,NULL),(19399,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:54',NULL,NULL),(18856,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:28',NULL,NULL),(8643,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:37',NULL,NULL),(16741,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:40',NULL,NULL),(15099,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:21',NULL,NULL),(13499,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:22',NULL,NULL),(6384,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:26',NULL,NULL),(11258,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:33',NULL,NULL),(10840,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:54',NULL,NULL),(21262,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:16',NULL,NULL),(21322,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:38',NULL,NULL),(814,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:27',NULL,NULL),(1246,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:14',NULL,NULL),(15267,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:05',NULL,NULL),(9068,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:21',NULL,NULL),(3193,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:12',NULL,NULL),(5334,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:07',NULL,NULL),(15009,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:51',NULL,NULL),(7898,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:39',NULL,NULL),(7871,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:32',NULL,NULL),(5553,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:08',NULL,NULL),(6656,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:24',NULL,NULL),(5721,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:46',NULL,NULL),(9876,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:34',NULL,NULL),(10086,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:14',NULL,NULL),(11117,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:53',NULL,NULL),(11891,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:17',NULL,NULL),(1010,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:20',NULL,NULL),(13887,1853,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:18',NULL,NULL),(9795,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:13',NULL,NULL),(5581,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:17',NULL,NULL),(4363,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:02',NULL,NULL),(3477,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:30',NULL,NULL),(22916,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:58',NULL,NULL),(18100,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:29',NULL,NULL),(16978,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:51',NULL,NULL),(16863,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:23',NULL,NULL),(16526,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:19',NULL,NULL),(14812,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:55',NULL,NULL),(6954,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:48',NULL,NULL),(12205,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:59',NULL,NULL),(945,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:02',NULL,NULL),(12080,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:26',NULL,NULL),(11179,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:10',NULL,NULL),(10510,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:30',NULL,NULL),(22079,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:35',NULL,NULL),(23497,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:24',NULL,NULL),(19282,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:20',NULL,NULL),(16031,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:35',NULL,NULL),(15078,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:13',NULL,NULL),(4842,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:04',NULL,NULL),(14855,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:07',NULL,NULL),(6501,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:57',NULL,NULL),(6799,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:02',NULL,NULL),(14244,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:11',NULL,NULL),(13980,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:32',NULL,NULL),(11834,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:03',NULL,NULL),(13400,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:07',NULL,NULL),(21924,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:40',NULL,NULL),(22987,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:14',NULL,NULL),(594,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:00',NULL,NULL),(16297,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:53',NULL,NULL),(1331,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:46',NULL,NULL),(13173,1830,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:26',NULL,NULL),(6320,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:08',NULL,NULL),(6709,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:38',NULL,NULL),(4773,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:45',NULL,NULL),(23483,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:20',NULL,NULL),(20667,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:56',NULL,NULL),(13778,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:03',NULL,NULL),(13036,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:50',NULL,NULL),(12040,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:15',NULL,NULL),(7594,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:17',NULL,NULL),(4228,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:26',NULL,NULL),(10170,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:37',NULL,NULL),(5460,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:41',NULL,NULL),(21557,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:04',NULL,NULL),(21408,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:09',NULL,NULL),(11034,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:26',NULL,NULL),(5925,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:56',NULL,NULL),(4858,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:08',NULL,NULL),(17279,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:06',NULL,NULL),(15879,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:41',NULL,NULL),(14740,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:35',NULL,NULL),(18598,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:41',NULL,NULL),(6125,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:15',NULL,NULL),(18392,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:44',NULL,NULL),(1452,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:33',NULL,NULL),(3405,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:11',NULL,NULL),(20813,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:43',NULL,NULL),(20386,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:15',NULL,NULL),(19947,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:07',NULL,NULL),(19932,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:03',NULL,NULL),(12189,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:55',NULL,NULL),(18334,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:28',NULL,NULL),(16687,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:21',NULL,NULL),(22630,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:17',NULL,NULL),(17149,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:47',NULL,NULL),(20863,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:57',NULL,NULL),(19357,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:41',NULL,NULL),(16646,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:06',NULL,NULL),(7141,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:29',NULL,NULL),(4332,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:53',NULL,NULL),(15999,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:24',NULL,NULL),(4738,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:36',NULL,NULL),(11922,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:41',NULL,NULL),(15949,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:06',NULL,NULL),(23276,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:08',NULL,NULL),(809,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:26',NULL,NULL),(17490,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:15',NULL,NULL),(16819,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:11',NULL,NULL),(16040,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:38',NULL,NULL),(15135,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:33',NULL,NULL),(8818,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:23',NULL,NULL),(2026,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:47',NULL,NULL),(5226,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:36',NULL,NULL),(6671,1873,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:00:28',NULL,NULL),(19676,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:12',NULL,NULL),(14808,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:54',NULL,NULL),(6245,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:48',NULL,NULL),(12137,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:41',NULL,NULL),(849,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:37',NULL,NULL),(14893,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:18',NULL,NULL),(14168,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:00',NULL,NULL),(11468,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:30',NULL,NULL),(6400,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:31',NULL,NULL),(8095,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:21',NULL,NULL),(11151,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:02',NULL,NULL),(22355,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:01',NULL,NULL),(22968,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:10',NULL,NULL),(996,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:16',NULL,NULL),(8177,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:42',NULL,NULL),(7745,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:56',NULL,NULL),(10596,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:52',NULL,NULL),(2202,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:06',NULL,NULL),(21684,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:15',NULL,NULL),(20333,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:55',NULL,NULL),(7413,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:45',NULL,NULL),(7194,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:43',NULL,NULL),(18323,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:25',NULL,NULL),(16750,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:44',NULL,NULL),(3097,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:34',NULL,NULL),(4197,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:19',NULL,NULL),(16523,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:18',NULL,NULL),(12936,1867,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:26:24',NULL,NULL),(16026,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:33',NULL,NULL),(14864,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:09',NULL,NULL),(15627,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:39',NULL,NULL),(22985,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(23609,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 13:30:02',NULL,NULL),(18989,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:06',NULL,NULL),(18560,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:31',NULL,NULL),(17272,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:03',NULL,NULL),(8340,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:28',NULL,NULL),(5346,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:10',NULL,NULL),(6389,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:27',NULL,NULL),(5749,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:56',NULL,NULL),(13605,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:37',NULL,NULL),(12399,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:55',NULL,NULL),(12822,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:51',NULL,NULL),(13239,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:43',NULL,NULL),(23012,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(23196,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(21875,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:23',NULL,NULL),(19765,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:19',NULL,NULL),(21722,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:29',NULL,NULL),(22634,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:18',NULL,NULL),(19241,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:09',NULL,NULL),(14980,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:41',NULL,NULL),(14414,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:04',NULL,NULL),(7708,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:46',NULL,NULL),(7507,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:11',NULL,NULL),(9688,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:45',NULL,NULL),(9816,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:19',NULL,NULL),(13322,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:06',NULL,NULL),(10241,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:56',NULL,NULL),(12636,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:57',NULL,NULL),(20636,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:45',NULL,NULL),(23399,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:50',NULL,NULL),(1072,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:37',NULL,NULL),(1141,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:56',NULL,NULL),(7480,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:04',NULL,NULL),(7022,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:06',NULL,NULL),(18707,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:11',NULL,NULL),(18523,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:21',NULL,NULL),(4591,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:00',NULL,NULL),(2165,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:22',NULL,NULL),(18077,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:21',NULL,NULL),(16401,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:32',NULL,NULL),(8723,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:58',NULL,NULL),(12862,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:05',NULL,NULL),(12198,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:57',NULL,NULL),(12820,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:50',NULL,NULL),(20218,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:14',NULL,NULL),(15677,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:56',NULL,NULL),(14479,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:23',NULL,NULL),(7739,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:54',NULL,NULL),(7544,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:04',NULL,NULL),(6699,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:35',NULL,NULL),(14471,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:20',NULL,NULL),(5128,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:09',NULL,NULL),(10542,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:38',NULL,NULL),(9377,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:44',NULL,NULL),(22854,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:37',NULL,NULL),(324,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:30',NULL,NULL),(8376,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:38',NULL,NULL),(16836,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:16',NULL,NULL),(13912,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:21',NULL,NULL),(10217,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:50',NULL,NULL),(2855,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:07',NULL,NULL),(20693,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:09',NULL,NULL),(23021,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:20',NULL,NULL),(450,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:13',NULL,NULL),(8379,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:39',NULL,NULL),(2918,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:01:29',NULL,NULL),(19162,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:55',NULL,NULL),(6390,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:28',NULL,NULL),(3374,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:02',NULL,NULL),(18700,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:09',NULL,NULL),(5379,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:19',NULL,NULL),(15858,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:34',NULL,NULL),(9470,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:10',NULL,NULL),(14474,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:21',NULL,NULL),(12145,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:43',NULL,NULL),(331,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:33',NULL,NULL),(18883,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:35',NULL,NULL),(7773,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:04',NULL,NULL),(7307,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:16',NULL,NULL),(613,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:06',NULL,NULL),(18874,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:32',NULL,NULL),(18696,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:08',NULL,NULL),(3763,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:32',NULL,NULL),(18315,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:23',NULL,NULL),(10369,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:32',NULL,NULL),(12694,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:14',NULL,NULL),(17969,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:43',NULL,NULL),(15751,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:21',NULL,NULL),(17727,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:39',NULL,NULL),(17573,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:44',NULL,NULL),(20439,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:34',NULL,NULL),(21611,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:25',NULL,NULL),(21815,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:02',NULL,NULL),(1770,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:20',NULL,NULL),(8673,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:45',NULL,NULL),(18871,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:32',NULL,NULL),(17392,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:43',NULL,NULL),(14995,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:46',NULL,NULL),(4213,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:23',NULL,NULL),(6949,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:47',NULL,NULL),(6285,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:59',NULL,NULL),(11250,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:31',NULL,NULL),(11591,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:01',NULL,NULL),(12465,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:10',NULL,NULL),(12666,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:06',NULL,NULL),(12794,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:42',NULL,NULL),(14423,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:07',NULL,NULL),(20856,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:55',NULL,NULL),(23333,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:27',NULL,NULL),(23367,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:39',NULL,NULL),(2216,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:10',NULL,NULL),(3067,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:24',NULL,NULL),(8817,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:23',NULL,NULL),(19387,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:50',NULL,NULL),(3920,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:12',NULL,NULL),(16276,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:05',NULL,NULL),(9757,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:02',NULL,NULL),(6549,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:10',NULL,NULL),(5678,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:32',NULL,NULL),(21356,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:50',NULL,NULL),(22406,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:17',NULL,NULL),(23027,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:21',NULL,NULL),(16460,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:54',NULL,NULL),(2813,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:52',NULL,NULL),(10759,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:34',NULL,NULL),(8207,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:50',NULL,NULL),(7881,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:35',NULL,NULL),(10240,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:56',NULL,NULL),(2881,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:16',NULL,NULL),(3315,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:46',NULL,NULL),(3539,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:47',NULL,NULL),(2858,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:08',NULL,NULL),(4614,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:32:06',NULL,NULL),(4032,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:40',NULL,NULL),(21390,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:42:02',NULL,NULL),(23030,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(2428,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:12',NULL,NULL),(17710,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:34',NULL,NULL),(17035,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:09',NULL,NULL),(2914,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:27',NULL,NULL),(13992,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:33',NULL,NULL),(5411,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:28',NULL,NULL),(13538,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:28',NULL,NULL),(8969,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:04',NULL,NULL),(13229,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:41',NULL,NULL),(10044,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:02',NULL,NULL),(10424,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:47',NULL,NULL),(12403,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:56',NULL,NULL),(3213,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:18',NULL,NULL),(16428,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:42',NULL,NULL),(13153,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:21',NULL,NULL),(12761,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:33',NULL,NULL),(11504,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:39',NULL,NULL),(10834,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:53',NULL,NULL),(10191,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:43',NULL,NULL),(20809,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:42',NULL,NULL),(22625,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:15',NULL,NULL),(22975,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:11',NULL,NULL),(23020,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:20',NULL,NULL),(17568,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:42',NULL,NULL),(16499,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:09',NULL,NULL),(15963,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:11',NULL,NULL),(2755,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:31',NULL,NULL),(14929,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:26',NULL,NULL),(13331,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:08',NULL,NULL),(12354,1823,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:43',NULL,NULL),(5023,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:56',NULL,NULL),(10558,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:42',NULL,NULL),(22125,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:51',NULL,NULL),(267,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:11',NULL,NULL),(20070,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:42',NULL,NULL),(18970,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:01',NULL,NULL),(1542,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:04',NULL,NULL),(7253,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:01',NULL,NULL),(14436,1850,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:50:11',NULL,NULL),(6263,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:53',NULL,NULL),(10193,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:43',NULL,NULL),(9890,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:38',NULL,NULL),(3804,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:43',NULL,NULL),(19450,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:08',NULL,NULL),(18528,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:22',NULL,NULL),(18381,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:41',NULL,NULL),(16334,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:06',NULL,NULL),(15059,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:07',NULL,NULL),(958,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:06',NULL,NULL),(4929,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:28',NULL,NULL),(4542,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:48',NULL,NULL),(14825,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:59',NULL,NULL),(14773,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:44',NULL,NULL),(2988,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:54',NULL,NULL),(12458,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:08',NULL,NULL),(21449,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:24',NULL,NULL),(21894,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:29',NULL,NULL),(22248,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:32',NULL,NULL),(22271,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:37',NULL,NULL),(22853,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:37',NULL,NULL),(23263,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:05',NULL,NULL),(3919,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:12',NULL,NULL),(9479,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:12',NULL,NULL),(4016,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:36',NULL,NULL),(17736,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:42',NULL,NULL),(9075,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:23',NULL,NULL),(7263,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:04',NULL,NULL),(4035,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:41',NULL,NULL),(13021,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:46',NULL,NULL),(11611,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:06',NULL,NULL),(9845,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:26',NULL,NULL),(5999,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:23',NULL,NULL),(4051,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:46',NULL,NULL),(5483,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:48',NULL,NULL),(20909,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:10',NULL,NULL),(460,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:16',NULL,NULL),(3638,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:14',NULL,NULL),(16426,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:41',NULL,NULL),(15639,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:43',NULL,NULL),(11087,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:45',NULL,NULL),(13487,1849,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:30:20',NULL,NULL),(14542,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:40',NULL,NULL),(20675,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:02',NULL,NULL),(14884,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:15',NULL,NULL),(23217,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:57',NULL,NULL),(1580,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:17',NULL,NULL),(13648,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:43',NULL,NULL),(3730,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:24',NULL,NULL),(4251,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:32',NULL,NULL),(4369,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:04',NULL,NULL),(4494,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:36',NULL,NULL),(4731,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:34',NULL,NULL),(13433,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:12',NULL,NULL),(17851,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:02',NULL,NULL),(17268,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:32:27',NULL,NULL),(10804,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:46',NULL,NULL),(5442,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:37',NULL,NULL),(6940,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:45',NULL,NULL),(10404,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:42',NULL,NULL),(22019,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:13',NULL,NULL),(23337,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:29',NULL,NULL),(23623,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 12:00:02',NULL,NULL),(857,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:39',NULL,NULL),(3861,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:57',NULL,NULL),(19458,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:10',NULL,NULL),(8781,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:14',NULL,NULL),(6035,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:35',NULL,NULL),(19025,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:16',NULL,NULL),(7726,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:51',NULL,NULL),(18504,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:16',NULL,NULL),(22287,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:41',NULL,NULL),(22609,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:26',NULL,NULL),(15638,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:43',NULL,NULL),(13328,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:07',NULL,NULL),(19329,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:33',NULL,NULL),(12499,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:20',NULL,NULL),(5302,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:59',NULL,NULL),(21778,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:48',NULL,NULL),(22780,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:11',NULL,NULL),(309,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:25',NULL,NULL),(9749,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:00',NULL,NULL),(17781,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:36',NULL,NULL),(17010,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:01',NULL,NULL),(9207,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:59',NULL,NULL),(736,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:05',NULL,NULL),(6809,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:05',NULL,NULL),(16952,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:45',NULL,NULL),(16944,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:43',NULL,NULL),(4740,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:36',NULL,NULL),(1371,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:03',NULL,NULL),(4696,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:24',NULL,NULL),(1954,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:28',NULL,NULL),(3548,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:49',NULL,NULL),(3265,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:32',NULL,NULL),(2547,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:42',NULL,NULL),(2573,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:48',NULL,NULL),(21993,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:04',NULL,NULL),(23598,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 23:30:03',NULL,NULL),(23606,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 23:30:03',NULL,NULL),(17383,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:40',NULL,NULL),(2977,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:50',NULL,NULL),(6456,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:46',NULL,NULL),(6323,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:09',NULL,NULL),(16504,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:11',NULL,NULL),(3621,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:09',NULL,NULL),(3406,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:11',NULL,NULL),(8716,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:56',NULL,NULL),(12382,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:51',NULL,NULL),(14574,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:48',NULL,NULL),(13821,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:09',NULL,NULL),(23222,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:58',NULL,NULL),(17167,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:53',NULL,NULL),(13062,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:56',NULL,NULL),(6679,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:30',NULL,NULL),(12731,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:25',NULL,NULL),(3734,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:25',NULL,NULL),(5230,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:37',NULL,NULL),(21553,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:03',NULL,NULL),(438,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:09',NULL,NULL),(830,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:31',NULL,NULL),(924,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:57',NULL,NULL),(19303,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:26',NULL,NULL),(13874,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:16',NULL,NULL),(12024,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:11',NULL,NULL),(3495,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:34',NULL,NULL),(6417,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:35',NULL,NULL),(4571,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:55',NULL,NULL),(20916,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:12',NULL,NULL),(21688,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:16',NULL,NULL),(23519,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:31',NULL,NULL),(18991,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:07',NULL,NULL),(18691,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:06',NULL,NULL),(7463,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:59',NULL,NULL),(7198,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:44',NULL,NULL),(6805,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:04',NULL,NULL),(6754,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:49',NULL,NULL),(5913,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:52',NULL,NULL),(1565,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:12',NULL,NULL),(18151,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:45',NULL,NULL),(20017,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:28',NULL,NULL),(4648,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:10',NULL,NULL),(11634,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:12',NULL,NULL),(8547,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:12',NULL,NULL),(8996,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:12',NULL,NULL),(9713,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:51',NULL,NULL),(9852,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:28',NULL,NULL),(10272,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:05',NULL,NULL),(11527,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:45',NULL,NULL),(20265,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:30',NULL,NULL),(21258,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:15',NULL,NULL),(22306,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:46',NULL,NULL),(1384,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:08',NULL,NULL),(19653,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:05',NULL,NULL),(11409,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:16',NULL,NULL),(9396,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:49',NULL,NULL),(4631,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:05',NULL,NULL),(23396,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:48',NULL,NULL),(23655,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 15:30:01',NULL,NULL),(540,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:43',NULL,NULL),(19309,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:28',NULL,NULL),(3324,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:48',NULL,NULL),(7028,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:08',NULL,NULL),(6894,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:29',NULL,NULL),(6698,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:35',NULL,NULL),(6520,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:03',NULL,NULL),(17582,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:47',NULL,NULL),(15983,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:18',NULL,NULL),(4649,1894,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:00:10',NULL,NULL),(8810,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:21',NULL,NULL),(15688,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:00',NULL,NULL),(21024,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:41',NULL,NULL),(22715,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:46',NULL,NULL),(15998,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:23',NULL,NULL),(8668,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:43',NULL,NULL),(15355,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:22',NULL,NULL),(14902,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:20',NULL,NULL),(14008,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:36',NULL,NULL),(4726,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:32',NULL,NULL),(1747,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:14',NULL,NULL),(9413,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:54',NULL,NULL),(13860,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:14',NULL,NULL),(21031,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:43',NULL,NULL),(22523,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:56',NULL,NULL),(22907,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:55',NULL,NULL),(20056,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:39',NULL,NULL),(8329,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:25',NULL,NULL),(3003,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:59',NULL,NULL),(3122,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:43',NULL,NULL),(18879,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:34',NULL,NULL),(4849,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:05',NULL,NULL),(6814,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:07',NULL,NULL),(18407,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:48',NULL,NULL),(10195,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:44',NULL,NULL),(10908,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:13',NULL,NULL),(18203,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:03',NULL,NULL),(17471,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:09',NULL,NULL),(17381,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:40',NULL,NULL),(11807,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:56',NULL,NULL),(16860,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:22',NULL,NULL),(15894,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:47',NULL,NULL),(159,163,'2013-12-27','14:34:00','A','000',0,'2014-01-13 03:04:54',NULL,NULL),(18385,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:42',NULL,NULL),(8634,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:34',NULL,NULL),(18117,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:34',NULL,NULL),(16535,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:22',NULL,NULL),(16414,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:37',NULL,NULL),(15568,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:20',NULL,NULL),(14458,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:17',NULL,NULL),(9558,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:11',NULL,NULL),(10026,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:39:57',NULL,NULL),(14132,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:54',NULL,NULL),(13988,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:33',NULL,NULL),(11577,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:57',NULL,NULL),(11579,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:58',NULL,NULL),(21968,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:56',NULL,NULL),(22251,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:32',NULL,NULL),(507,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:32',NULL,NULL),(19013,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:13',NULL,NULL),(1546,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:05',NULL,NULL),(18227,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:12',NULL,NULL),(13566,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:32',NULL,NULL),(4073,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:51',NULL,NULL),(12742,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:28',NULL,NULL),(12348,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:42',NULL,NULL),(9108,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:32',NULL,NULL),(7359,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:30',NULL,NULL),(5858,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:33',NULL,NULL),(6146,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:22',NULL,NULL),(21165,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:40',NULL,NULL),(21855,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:16',NULL,NULL),(20067,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:42',NULL,NULL),(3062,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:22',NULL,NULL),(8903,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:46',NULL,NULL),(18337,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:29',NULL,NULL),(7015,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:05',NULL,NULL),(16542,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:25',NULL,NULL),(13697,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:50',NULL,NULL),(12855,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:02',NULL,NULL),(7829,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:20',NULL,NULL),(23166,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(17754,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:48',NULL,NULL),(17469,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:08',NULL,NULL),(19733,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:11',NULL,NULL),(21548,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:01',NULL,NULL),(22042,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:22',NULL,NULL),(22084,1862,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:37',NULL,NULL),(1323,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:43',NULL,NULL),(20210,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:11',NULL,NULL),(16491,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:06',NULL,NULL),(7121,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:24',NULL,NULL),(8736,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:01',NULL,NULL),(5827,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:23',NULL,NULL),(22889,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:49',NULL,NULL),(106,357,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:38',NULL,NULL),(8779,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:13',NULL,NULL),(20852,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:54',NULL,NULL),(5571,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:14',NULL,NULL),(19716,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:06',NULL,NULL),(999,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:17',NULL,NULL),(17750,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:47',NULL,NULL),(1352,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:55',NULL,NULL),(15272,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:06',NULL,NULL),(2084,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:01',NULL,NULL),(2411,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:07',NULL,NULL),(3450,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:22',NULL,NULL),(14558,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:44',NULL,NULL),(9520,1870,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:01',NULL,NULL),(11589,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:00',NULL,NULL),(11266,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:35',NULL,NULL),(10394,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:41:39',NULL,NULL),(21835,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:09',NULL,NULL),(268,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:11',NULL,NULL),(15976,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:15',NULL,NULL),(14013,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:37',NULL,NULL),(13626,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:40',NULL,NULL),(5723,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:47',NULL,NULL),(13622,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:40',NULL,NULL),(10769,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:37',NULL,NULL),(11014,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:21',NULL,NULL),(12962,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:31',NULL,NULL),(20602,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:33',NULL,NULL),(12462,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:09',NULL,NULL),(1260,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:20',NULL,NULL),(19759,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:18',NULL,NULL),(7811,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:15',NULL,NULL),(19749,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:15',NULL,NULL),(7638,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:28',NULL,NULL),(7204,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:46',NULL,NULL),(4791,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:50',NULL,NULL),(19265,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:15',NULL,NULL),(6186,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:33',NULL,NULL),(18867,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:31',NULL,NULL),(18561,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:31',NULL,NULL),(16236,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:49',NULL,NULL),(15971,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:14',NULL,NULL),(15824,1881,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:14:21',NULL,NULL),(15696,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:03',NULL,NULL),(13523,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:26',NULL,NULL),(13824,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:09',NULL,NULL),(14270,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:15',NULL,NULL),(20605,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:34',NULL,NULL),(8204,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:49',NULL,NULL),(8129,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:29',NULL,NULL),(20500,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:55',NULL,NULL),(19481,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:16',NULL,NULL),(4428,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:19',NULL,NULL),(6731,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:43',NULL,NULL),(4862,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:09',NULL,NULL),(16312,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:58',NULL,NULL),(9802,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:15',NULL,NULL),(11568,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:55',NULL,NULL),(12631,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:56',NULL,NULL),(13272,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:52',NULL,NULL),(22531,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:59',NULL,NULL),(21090,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:59',NULL,NULL),(13296,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:58',NULL,NULL),(12224,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:05',NULL,NULL),(8034,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:04',NULL,NULL),(1690,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:58',NULL,NULL),(11168,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:07',NULL,NULL),(351,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:39',NULL,NULL),(9173,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:50',NULL,NULL),(4207,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:21',NULL,NULL),(17631,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:05',NULL,NULL),(6073,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:49',NULL,NULL),(14595,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:54',NULL,NULL),(6611,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:13',NULL,NULL),(10017,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:55',NULL,NULL),(21666,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:08',NULL,NULL),(21842,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:11',NULL,NULL),(22335,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:54',NULL,NULL),(15967,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:12',NULL,NULL),(2408,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:06',NULL,NULL),(14706,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:26',NULL,NULL),(12702,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:17',NULL,NULL),(7529,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:17',NULL,NULL),(5037,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:59',NULL,NULL),(22362,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:03',NULL,NULL),(20622,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:40',NULL,NULL),(19672,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:11',NULL,NULL),(18985,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:05',NULL,NULL),(8101,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:22',NULL,NULL),(18167,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:51',NULL,NULL),(3261,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:30:31',NULL,NULL),(7522,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:15',NULL,NULL),(21594,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:18',NULL,NULL),(16187,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:32',NULL,NULL),(3179,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:08',NULL,NULL),(4112,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:01',NULL,NULL),(8156,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:36',NULL,NULL),(8063,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:12',NULL,NULL),(4203,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:20',NULL,NULL),(14222,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:08',NULL,NULL),(23181,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(1549,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:06',NULL,NULL),(11974,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:57',NULL,NULL),(9669,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:40',NULL,NULL),(5293,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:56',NULL,NULL),(12839,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:57',NULL,NULL),(13336,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:09',NULL,NULL),(13722,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:54',NULL,NULL),(14391,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:57',NULL,NULL),(15491,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:53',NULL,NULL),(17078,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:24',NULL,NULL),(18513,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:18',NULL,NULL),(19561,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:39',NULL,NULL),(5673,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:30',NULL,NULL),(4777,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:46',NULL,NULL),(1791,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:25',NULL,NULL),(9726,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:54',NULL,NULL),(9237,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:07',NULL,NULL),(7481,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:04',NULL,NULL),(7054,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:02',NULL,NULL),(14029,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:39',NULL,NULL),(17845,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:00',NULL,NULL),(18716,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:13',NULL,NULL),(20754,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:26',NULL,NULL),(22942,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:05',NULL,NULL),(23077,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(875,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:43',NULL,NULL),(12077,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:25',NULL,NULL),(11911,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:23',NULL,NULL),(10530,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:35',NULL,NULL),(12837,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:57',NULL,NULL),(14376,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:52',NULL,NULL),(15234,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:59',NULL,NULL),(20900,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:07',NULL,NULL),(23297,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:13',NULL,NULL),(5726,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:48',NULL,NULL),(1035,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:27',NULL,NULL),(11571,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:14:56',NULL,NULL),(1109,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:47',NULL,NULL),(1399,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:13',NULL,NULL),(5531,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:32:01',NULL,NULL),(10347,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:26',NULL,NULL),(10160,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:34',NULL,NULL),(4645,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:09',NULL,NULL),(3187,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:10',NULL,NULL),(9775,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:07',NULL,NULL),(2245,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:24',NULL,NULL),(8155,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:36',NULL,NULL),(7038,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:02:10',NULL,NULL),(13096,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:05',NULL,NULL),(14074,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:46',NULL,NULL),(18229,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:15:12',NULL,NULL),(18920,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:46',NULL,NULL),(21844,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:12',NULL,NULL),(22366,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:04',NULL,NULL),(454,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:14',NULL,NULL),(4497,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:36',NULL,NULL),(4050,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:46',NULL,NULL),(8703,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:53',NULL,NULL),(1574,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:15',NULL,NULL),(2448,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:17',NULL,NULL),(13479,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:19',NULL,NULL),(13931,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:24',NULL,NULL),(15144,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:36',NULL,NULL),(17241,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:18',NULL,NULL),(19415,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:58',NULL,NULL),(21482,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:37',NULL,NULL),(22820,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:26',NULL,NULL),(261,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:09',NULL,NULL),(11907,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:22',NULL,NULL),(7303,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:15',NULL,NULL),(7875,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:33',NULL,NULL),(13321,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:05',NULL,NULL),(15166,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:43',NULL,NULL),(15747,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:19',NULL,NULL),(20416,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:25',NULL,NULL),(20643,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:48',NULL,NULL),(21812,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:01',NULL,NULL),(6499,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:57',NULL,NULL),(11895,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:18',NULL,NULL),(10706,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:21',NULL,NULL),(9760,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:03',NULL,NULL),(9607,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:24',NULL,NULL),(8948,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:58',NULL,NULL),(8255,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:03',NULL,NULL),(2877,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:14',NULL,NULL),(2153,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:18',NULL,NULL),(1058,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:33',NULL,NULL),(4066,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:49',NULL,NULL),(4456,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:26',NULL,NULL),(13885,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:18',NULL,NULL),(14805,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:53',NULL,NULL),(15274,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:07',NULL,NULL),(16933,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:40',NULL,NULL),(21876,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:23',NULL,NULL),(3901,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:08',NULL,NULL),(12538,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:30',NULL,NULL),(674,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:28',NULL,NULL),(3696,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:15',NULL,NULL),(13481,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:19',NULL,NULL),(14283,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:17',NULL,NULL),(16524,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:18',NULL,NULL),(19788,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:25',NULL,NULL),(20873,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:00',NULL,NULL),(21330,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:40',NULL,NULL),(22242,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:30',NULL,NULL),(22344,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:57',NULL,NULL),(22515,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:54',NULL,NULL),(23511,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:29',NULL,NULL),(402,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:58',NULL,NULL),(6586,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:07',NULL,NULL),(3825,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:48',NULL,NULL),(2581,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:50',NULL,NULL),(17986,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:49',NULL,NULL),(21348,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:47',NULL,NULL),(6738,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:45',NULL,NULL),(12806,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:46',NULL,NULL),(884,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:46',NULL,NULL),(1443,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:28',NULL,NULL),(5158,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:17',NULL,NULL),(11396,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:02:11',NULL,NULL),(4690,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:22',NULL,NULL),(9411,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:53',NULL,NULL),(8620,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:30',NULL,NULL),(7378,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:35',NULL,NULL),(13996,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:34',NULL,NULL),(14560,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:44',NULL,NULL),(15161,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:41',NULL,NULL),(16309,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:57',NULL,NULL),(19192,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:38:03',NULL,NULL),(5131,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:10',NULL,NULL),(3872,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:00',NULL,NULL),(3321,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:48',NULL,NULL),(7319,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:20',NULL,NULL),(13377,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:20',NULL,NULL),(14142,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:56',NULL,NULL),(14379,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:53',NULL,NULL),(18689,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:06',NULL,NULL),(19554,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:37',NULL,NULL),(19629,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:57',NULL,NULL),(21619,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:28',NULL,NULL),(415,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:02',NULL,NULL),(1204,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:13',NULL,NULL),(11925,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:42',NULL,NULL),(1495,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:47',NULL,NULL),(3922,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:13',NULL,NULL),(8300,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:16',NULL,NULL),(13183,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:29',NULL,NULL),(17412,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:50',NULL,NULL),(19454,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:09',NULL,NULL),(22878,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:45',NULL,NULL),(4673,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:17',NULL,NULL),(7501,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:09',NULL,NULL),(12748,1870,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:30',NULL,NULL),(10355,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:28',NULL,NULL),(10911,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:13',NULL,NULL),(14477,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:22',NULL,NULL),(15954,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:07',NULL,NULL),(18836,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:22',NULL,NULL),(18894,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:38',NULL,NULL),(18901,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:40',NULL,NULL),(5221,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:35',NULL,NULL),(5027,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:57',NULL,NULL),(8302,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:17',NULL,NULL),(4582,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:58',NULL,NULL),(3690,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:14',NULL,NULL),(3195,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:12',NULL,NULL),(13921,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:23',NULL,NULL),(15183,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:49',NULL,NULL),(15822,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:20',NULL,NULL),(16341,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:09',NULL,NULL),(4495,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:36',NULL,NULL),(9960,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:56',NULL,NULL),(16110,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:05',NULL,NULL),(19066,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:27',NULL,NULL),(6057,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:43',NULL,NULL),(3844,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:53',NULL,NULL),(7868,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:31',NULL,NULL),(9486,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:52',NULL,NULL),(9913,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:44',NULL,NULL),(14115,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:52',NULL,NULL),(16069,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:48',NULL,NULL),(18671,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:00',NULL,NULL),(19641,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:02',NULL,NULL),(20485,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:50',NULL,NULL),(20542,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:11',NULL,NULL),(11189,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:13',NULL,NULL),(11627,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:10',NULL,NULL),(12483,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:15',NULL,NULL),(14886,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:15',NULL,NULL),(19720,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:07',NULL,NULL),(22501,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:49',NULL,NULL),(22512,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:53',NULL,NULL),(22751,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:59',NULL,NULL),(1864,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:43',NULL,NULL),(6369,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:22',NULL,NULL),(11082,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:44',NULL,NULL),(5815,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:19',NULL,NULL),(2316,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:42',NULL,NULL),(2943,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:38',NULL,NULL),(17536,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:30',NULL,NULL),(17752,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:48',NULL,NULL),(19776,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:22',NULL,NULL),(21970,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:56',NULL,NULL),(22575,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:14',NULL,NULL),(7719,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:49',NULL,NULL),(13282,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:55',NULL,NULL),(13040,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:51',NULL,NULL),(5637,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:17',NULL,NULL),(10405,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:42',NULL,NULL),(4294,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:43',NULL,NULL),(4991,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:47',NULL,NULL),(15100,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:21',NULL,NULL),(21373,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:56',NULL,NULL),(23706,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 22:30:01',NULL,NULL),(110,326,'2013-12-27','15:46:00','A','000',0,'2014-01-07 11:00:01',NULL,NULL),(5761,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:00',NULL,NULL),(5173,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:22',NULL,NULL),(9951,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:53',NULL,NULL),(8935,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:55',NULL,NULL),(2885,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:17',NULL,NULL),(14378,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:53',NULL,NULL),(14515,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:32',NULL,NULL),(15104,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:22',NULL,NULL),(15801,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:38',NULL,NULL),(16454,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:52',NULL,NULL),(17173,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:55',NULL,NULL),(18126,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:37',NULL,NULL),(19500,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:21',NULL,NULL),(7160,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:34',NULL,NULL),(3387,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:05',NULL,NULL),(12757,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:32',NULL,NULL),(4431,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:20',NULL,NULL),(15115,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:26',NULL,NULL),(18928,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:48',NULL,NULL),(21072,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:54',NULL,NULL),(232,202,'2013-12-27','14:59:00','A','000',0,'2014-01-13 03:05:18',NULL,NULL),(13515,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:25',NULL,NULL),(13380,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:02',NULL,NULL),(977,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:11',NULL,NULL),(8990,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:10',NULL,NULL),(8913,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:49',NULL,NULL),(4461,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:28',NULL,NULL),(1356,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:56',NULL,NULL),(6002,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:24',NULL,NULL),(1909,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:54',NULL,NULL),(3558,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:52',NULL,NULL),(1945,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:31:03',NULL,NULL),(21017,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:39',NULL,NULL),(23137,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:42',NULL,NULL),(1775,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:21',NULL,NULL),(13607,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:38',NULL,NULL),(4354,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:00',NULL,NULL),(12863,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:05',NULL,NULL),(36,256,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:34',NULL,NULL),(12028,1810,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:12',NULL,NULL),(10825,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:51',NULL,NULL),(1096,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:43',NULL,NULL),(8143,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:33',NULL,NULL),(1123,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:51',NULL,NULL),(1529,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:59',NULL,NULL),(6643,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:21',NULL,NULL),(2628,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:03',NULL,NULL),(3307,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:44',NULL,NULL),(6561,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:13',NULL,NULL),(3135,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:47',NULL,NULL),(13057,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:55',NULL,NULL),(13592,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:36',NULL,NULL),(18744,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:35:57',NULL,NULL),(19689,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:15',NULL,NULL),(20834,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:49',NULL,NULL),(22852,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:36',NULL,NULL),(23060,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(6655,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:24',NULL,NULL),(9078,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:24',NULL,NULL),(12249,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:12',NULL,NULL),(13120,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:12',NULL,NULL),(14097,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:49',NULL,NULL),(14655,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:12',NULL,NULL),(19529,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:29',NULL,NULL),(21026,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:41',NULL,NULL),(5580,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:16',NULL,NULL),(3972,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:25',NULL,NULL),(10374,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:33',NULL,NULL),(8186,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:45',NULL,NULL),(12894,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:12',NULL,NULL),(13543,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:29',NULL,NULL),(14442,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:12',NULL,NULL),(15339,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:19',NULL,NULL),(15662,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:51',NULL,NULL),(17029,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:07',NULL,NULL),(17994,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:51',NULL,NULL),(20995,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:33',NULL,NULL),(21211,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:57',NULL,NULL),(22542,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:02',NULL,NULL),(6769,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:53',NULL,NULL),(2242,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:24',NULL,NULL),(2577,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:49',NULL,NULL),(6413,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:34',NULL,NULL),(5722,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:47',NULL,NULL),(5063,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:07',NULL,NULL),(4010,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:34',NULL,NULL),(22283,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:40',NULL,NULL),(831,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:32',NULL,NULL),(11585,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:59',NULL,NULL),(1682,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:55',NULL,NULL),(2360,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:53',NULL,NULL),(2393,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:02',NULL,NULL),(14219,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:07',NULL,NULL),(16431,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:43',NULL,NULL),(19327,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:33',NULL,NULL),(19438,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:04',NULL,NULL),(20410,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:23',NULL,NULL),(20536,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:09',NULL,NULL),(20970,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:26',NULL,NULL),(21624,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:29',NULL,NULL),(22572,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:13',NULL,NULL),(23727,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 15:29:57',NULL,NULL),(6164,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:27',NULL,NULL),(5629,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:14',NULL,NULL),(11880,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:15',NULL,NULL),(4598,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:32:02',NULL,NULL),(3798,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:41',NULL,NULL),(7706,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:46',NULL,NULL),(1255,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:18',NULL,NULL),(2642,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:06',NULL,NULL),(14685,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:20',NULL,NULL),(20906,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:09',NULL,NULL),(20990,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:32',NULL,NULL),(21073,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:54',NULL,NULL),(22331,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:52',NULL,NULL),(22588,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:32:18',NULL,NULL),(157,361,'2013-12-27','16:13:00','A','000',0,'2014-01-13 03:04:53',NULL,NULL),(666,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:23',NULL,NULL),(11552,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:51',NULL,NULL),(11112,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:52',NULL,NULL),(768,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:14',NULL,NULL),(10556,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:42',NULL,NULL),(8617,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:30',NULL,NULL),(3915,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:11',NULL,NULL),(13509,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:23',NULL,NULL),(17325,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:21',NULL,NULL),(17437,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:58',NULL,NULL),(21289,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:26',NULL,NULL),(22556,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:07',NULL,NULL),(369,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:45',NULL,NULL),(11509,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:40',NULL,NULL),(10415,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:45',NULL,NULL),(9746,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:00',NULL,NULL),(1073,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:37',NULL,NULL),(4877,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:13',NULL,NULL),(3389,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:06',NULL,NULL),(1285,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:29',NULL,NULL),(2687,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:07',NULL,NULL),(16519,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:16',NULL,NULL),(19801,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:29',NULL,NULL),(21623,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:43:29',NULL,NULL),(21641,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:36',NULL,NULL),(22274,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:38',NULL,NULL),(1729,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:10',NULL,NULL),(13159,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:23',NULL,NULL),(11575,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:57',NULL,NULL),(7452,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:56',NULL,NULL),(9347,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:36',NULL,NULL),(9230,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:05',NULL,NULL),(8444,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:55',NULL,NULL),(7361,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:31',NULL,NULL),(6740,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:45',NULL,NULL),(6950,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:47',NULL,NULL),(14701,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:25',NULL,NULL),(14747,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:37',NULL,NULL),(20945,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:19',NULL,NULL),(21040,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:45',NULL,NULL),(21515,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:49',NULL,NULL),(22236,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:28',NULL,NULL),(156,358,'2013-12-27','16:10:00','A','000',0,'2014-01-13 03:04:53',NULL,NULL),(12595,1830,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:46',NULL,NULL),(3223,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:21',NULL,NULL),(10789,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:42',NULL,NULL),(10461,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:17',NULL,NULL),(4954,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:36',NULL,NULL),(15165,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:42',NULL,NULL),(17187,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:00',NULL,NULL),(17901,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:20',NULL,NULL),(19074,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:29',NULL,NULL),(23691,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 23:30:01',NULL,NULL),(14694,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:23',NULL,NULL),(16362,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:16',NULL,NULL),(19416,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:59',NULL,NULL),(21478,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:35',NULL,NULL),(23165,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(1555,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:09',NULL,NULL),(2039,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:50',NULL,NULL),(8616,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:29',NULL,NULL),(9557,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:11',NULL,NULL),(14986,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:43',NULL,NULL),(15283,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:08',NULL,NULL),(18483,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:10',NULL,NULL),(358,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:41',NULL,NULL),(7261,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:03',NULL,NULL),(7108,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:20',NULL,NULL),(5910,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:51',NULL,NULL),(4868,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:11',NULL,NULL),(4045,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:44',NULL,NULL),(4689,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:22',NULL,NULL),(20108,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:53',NULL,NULL),(1071,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:37',NULL,NULL),(12689,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:13',NULL,NULL),(12045,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:16',NULL,NULL),(5793,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:11',NULL,NULL),(10729,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:27',NULL,NULL),(6270,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:55',NULL,NULL),(15393,1845,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:02:29',NULL,NULL),(16734,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:38',NULL,NULL),(20810,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:42',NULL,NULL),(22131,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:53',NULL,NULL),(86,259,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:20',NULL,NULL),(11668,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:20',NULL,NULL),(1953,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:28',NULL,NULL),(2423,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:10',NULL,NULL),(8465,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:01',NULL,NULL),(2595,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:54',NULL,NULL),(4075,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:52',NULL,NULL),(7155,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:33',NULL,NULL),(14791,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:49',NULL,NULL),(19573,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:42',NULL,NULL),(21546,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:00',NULL,NULL),(23010,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:18',NULL,NULL),(7123,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:25',NULL,NULL),(13498,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:22',NULL,NULL),(13256,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:48',NULL,NULL),(1512,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:53',NULL,NULL),(2379,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:58',NULL,NULL),(11262,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:34',NULL,NULL),(8291,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:14',NULL,NULL),(16288,1870,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:17:09',NULL,NULL),(18430,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:54',NULL,NULL),(19084,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:32',NULL,NULL),(21349,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:47',NULL,NULL),(23142,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:43',NULL,NULL),(1235,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:10',NULL,NULL),(13727,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:55',NULL,NULL),(13304,1839,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:28:01',NULL,NULL),(5242,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:41',NULL,NULL),(15831,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:23',NULL,NULL),(16391,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:28',NULL,NULL),(18404,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:47',NULL,NULL),(18488,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:11',NULL,NULL),(19982,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:18',NULL,NULL),(442,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:11',NULL,NULL),(13442,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:14',NULL,NULL),(1420,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:20',NULL,NULL),(11636,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:12',NULL,NULL),(7980,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:00',NULL,NULL),(10849,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:57',NULL,NULL),(5356,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:13',NULL,NULL),(10094,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:16',NULL,NULL),(6668,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:28',NULL,NULL),(8332,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:26',NULL,NULL),(14456,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:16',NULL,NULL),(16514,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:14',NULL,NULL),(16718,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:32',NULL,NULL),(22589,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:18',NULL,NULL),(23419,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:56',NULL,NULL),(7581,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:13',NULL,NULL),(13768,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:01',NULL,NULL),(1796,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:26',NULL,NULL),(4268,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:37',NULL,NULL),(10915,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:14',NULL,NULL),(9036,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:12',NULL,NULL),(14377,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:53',NULL,NULL),(15119,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:27',NULL,NULL),(19169,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:57',NULL,NULL),(22706,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:43',NULL,NULL),(7270,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:06',NULL,NULL),(14149,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:57',NULL,NULL),(8855,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:33',NULL,NULL),(9009,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:05',NULL,NULL),(11948,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:48',NULL,NULL),(15957,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:09',NULL,NULL),(17235,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:16',NULL,NULL),(18511,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:18',NULL,NULL),(19006,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:11',NULL,NULL),(20726,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:19',NULL,NULL),(21926,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:41',NULL,NULL),(22675,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:32',NULL,NULL),(7521,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:15',NULL,NULL),(487,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:25',NULL,NULL),(536,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:41',NULL,NULL),(6728,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:42',NULL,NULL),(5044,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:01',NULL,NULL),(15178,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:47',NULL,NULL),(15330,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:17',NULL,NULL),(16194,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:35',NULL,NULL),(17065,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:19',NULL,NULL),(19311,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:28',NULL,NULL),(8477,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:32:04',NULL,NULL),(1996,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:39',NULL,NULL),(7678,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:39',NULL,NULL),(11790,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:52',NULL,NULL),(11486,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:34',NULL,NULL),(6855,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:17',NULL,NULL),(11031,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:25',NULL,NULL),(5819,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:20',NULL,NULL),(3791,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:40',NULL,NULL),(14511,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:31',NULL,NULL),(14605,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:57',NULL,NULL),(14998,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:47',NULL,NULL),(16640,1828,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:03',NULL,NULL),(23262,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:05',NULL,NULL),(15206,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:01:54',NULL,NULL),(15847,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:29',NULL,NULL),(18751,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:35:59',NULL,NULL),(18791,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:10',NULL,NULL),(19596,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:48',NULL,NULL),(20569,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:21',NULL,NULL),(20647,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:49',NULL,NULL),(345,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:37',NULL,NULL),(11758,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:44',NULL,NULL),(6407,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:32',NULL,NULL),(671,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:26',NULL,NULL),(9510,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:35:59',NULL,NULL),(6943,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:46',NULL,NULL),(8091,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:19',NULL,NULL),(13888,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:18',NULL,NULL),(16147,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:18',NULL,NULL),(19055,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:24',NULL,NULL),(19632,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:58',NULL,NULL),(20115,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:55',NULL,NULL),(22016,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:12',NULL,NULL),(23677,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 11:30:02',NULL,NULL),(6059,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:44',NULL,NULL),(10972,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:09',NULL,NULL),(2001,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:40',NULL,NULL),(12601,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:47',NULL,NULL),(15417,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:34',NULL,NULL),(17891,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:16',NULL,NULL),(19235,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:07',NULL,NULL),(20044,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:35',NULL,NULL),(734,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:05',NULL,NULL),(11496,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:14:37',NULL,NULL),(7219,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:50',NULL,NULL),(7202,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:45',NULL,NULL),(5195,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:28',NULL,NULL),(4798,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:52',NULL,NULL),(931,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:59',NULL,NULL),(4062,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:48',NULL,NULL),(4263,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:35',NULL,NULL),(13705,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:52',NULL,NULL),(15262,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:04',NULL,NULL),(15730,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:14',NULL,NULL),(16515,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:15',NULL,NULL),(19443,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:06',NULL,NULL),(21396,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:04',NULL,NULL),(21997,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:06',NULL,NULL),(22466,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:38',NULL,NULL),(4602,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:03',NULL,NULL),(9521,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:01',NULL,NULL),(9307,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:25',NULL,NULL),(1218,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:04',NULL,NULL),(7008,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:03',NULL,NULL),(3943,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:18',NULL,NULL),(14949,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:31',NULL,NULL),(15327,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:17',NULL,NULL),(15374,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:26',NULL,NULL),(15979,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:16',NULL,NULL),(18545,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:27',NULL,NULL),(19372,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:46',NULL,NULL),(19532,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:30',NULL,NULL),(20482,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:49',NULL,NULL),(192,179,'2013-12-27','14:51:00','A','000',0,'2014-01-13 03:05:05',NULL,NULL),(6127,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:16',NULL,NULL),(10395,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:39',NULL,NULL),(9932,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:48',NULL,NULL),(4516,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:41',NULL,NULL),(7904,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:41',NULL,NULL),(1494,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:47',NULL,NULL),(7092,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:14',NULL,NULL),(2822,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:55',NULL,NULL),(2872,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:13',NULL,NULL),(12474,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:12',NULL,NULL),(12884,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:14',NULL,NULL),(15554,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:15',NULL,NULL),(19730,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:10',NULL,NULL),(22534,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:00',NULL,NULL),(22659,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:27',NULL,NULL),(5266,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:47',NULL,NULL),(12106,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:32',NULL,NULL),(7392,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:39',NULL,NULL),(11317,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:48',NULL,NULL),(9306,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:25',NULL,NULL),(13064,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:57',NULL,NULL),(19959,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:11',NULL,NULL),(3852,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:55',NULL,NULL),(10819,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:49',NULL,NULL),(3684,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:12',NULL,NULL),(9375,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:43',NULL,NULL),(8389,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:41',NULL,NULL),(3214,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:18',NULL,NULL),(14408,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:03',NULL,NULL),(18706,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:11',NULL,NULL),(20836,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:49',NULL,NULL),(21592,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:17',NULL,NULL),(21697,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:19',NULL,NULL),(5575,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:15',NULL,NULL),(9227,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:05',NULL,NULL),(12055,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:19',NULL,NULL),(14122,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:53',NULL,NULL),(16118,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:08',NULL,NULL),(20467,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:44',NULL,NULL),(22259,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:34',NULL,NULL),(23386,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:45',NULL,NULL),(1587,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:20',NULL,NULL),(12723,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:23',NULL,NULL),(12660,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:04',NULL,NULL),(11667,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:20',NULL,NULL),(11405,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:14',NULL,NULL),(11166,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:06',NULL,NULL),(5823,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:22',NULL,NULL),(10625,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:59',NULL,NULL),(13357,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:15',NULL,NULL),(14193,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:03',NULL,NULL),(16053,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:43',NULL,NULL),(16220,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:44',NULL,NULL),(17651,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:13',NULL,NULL),(18741,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:56',NULL,NULL),(21086,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:58',NULL,NULL),(21481,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:36',NULL,NULL),(1717,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:07',NULL,NULL),(3469,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:27',NULL,NULL),(9568,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:13',NULL,NULL),(13146,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:19',NULL,NULL),(15788,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:34',NULL,NULL),(17775,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:34',NULL,NULL),(19340,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:36',NULL,NULL),(19405,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:56',NULL,NULL),(22338,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:55',NULL,NULL),(6977,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:54',NULL,NULL),(12774,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:37',NULL,NULL),(9768,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:05',NULL,NULL),(8456,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:59',NULL,NULL),(8260,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:04',NULL,NULL),(4548,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:49',NULL,NULL),(3887,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:04',NULL,NULL),(13583,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:34',NULL,NULL),(13974,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:31',NULL,NULL),(16788,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:04',NULL,NULL),(16913,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:35',NULL,NULL),(17161,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:51',NULL,NULL),(17571,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:43',NULL,NULL),(17611,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:58',NULL,NULL),(20915,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:11',NULL,NULL),(6869,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:21',NULL,NULL),(5650,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:22',NULL,NULL),(5496,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:52',NULL,NULL),(9875,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:34',NULL,NULL),(8800,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:18',NULL,NULL),(7841,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:23',NULL,NULL),(8487,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:32:07',NULL,NULL),(15546,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:12',NULL,NULL),(16850,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:20',NULL,NULL),(17459,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:05',NULL,NULL),(18332,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:27',NULL,NULL),(19418,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:59',NULL,NULL),(21596,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:19',NULL,NULL),(126,169,'2013-12-27','14:42:00','A','000',0,'2014-01-13 03:04:43',NULL,NULL),(6326,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:10',NULL,NULL),(2101,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:05',NULL,NULL),(1369,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:02',NULL,NULL),(9515,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:00',NULL,NULL),(15466,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:44',NULL,NULL),(20284,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:37',NULL,NULL),(21205,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:55',NULL,NULL),(2705,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:13',NULL,NULL),(10569,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:45',NULL,NULL),(12130,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:39',NULL,NULL),(11826,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:01',NULL,NULL),(10051,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:40:04',NULL,NULL),(5950,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:05',NULL,NULL),(14818,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:57',NULL,NULL),(15258,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:04',NULL,NULL),(20229,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:17',NULL,NULL),(20770,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:31',NULL,NULL),(23398,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:49',NULL,NULL),(679,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:29',NULL,NULL),(1924,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:57',NULL,NULL),(2622,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:01',NULL,NULL),(8606,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:27',NULL,NULL),(8050,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:08',NULL,NULL),(5951,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:05',NULL,NULL),(6815,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:07',NULL,NULL),(13557,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:31',NULL,NULL),(19349,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:38',NULL,NULL),(20663,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:55',NULL,NULL),(21687,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:16',NULL,NULL),(21794,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:54',NULL,NULL),(23244,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(23657,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 20:00:01',NULL,NULL),(6006,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:25',NULL,NULL),(10307,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:15',NULL,NULL),(728,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:03',NULL,NULL),(2346,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:50',NULL,NULL),(7870,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:01:32',NULL,NULL),(2952,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:41',NULL,NULL),(5834,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:25',NULL,NULL),(5781,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:07',NULL,NULL),(15818,1877,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:14:19',NULL,NULL),(16573,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:36',NULL,NULL),(17553,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:36',NULL,NULL),(19252,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:12',NULL,NULL),(19807,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:30',NULL,NULL),(21758,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:41',NULL,NULL),(7936,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:49',NULL,NULL),(12633,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:56',NULL,NULL),(12060,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:20',NULL,NULL),(645,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:17',NULL,NULL),(2815,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:53',NULL,NULL),(6870,1889,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:01:21',NULL,NULL),(4933,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:30',NULL,NULL),(18618,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:47',NULL,NULL),(20232,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:19',NULL,NULL),(22750,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:59',NULL,NULL),(6087,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:05',NULL,NULL),(9803,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:15',NULL,NULL),(12718,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:22',NULL,NULL),(10879,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:05',NULL,NULL),(10886,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:07',NULL,NULL),(10897,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:10',NULL,NULL),(17963,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:41',NULL,NULL),(19038,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:19',NULL,NULL),(20043,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:35',NULL,NULL),(21351,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:48',NULL,NULL),(21729,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:31',NULL,NULL),(22262,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:35',NULL,NULL),(22815,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:24',NULL,NULL),(23583,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 01:30:02',NULL,NULL),(319,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:29',NULL,NULL),(12334,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:37',NULL,NULL),(11931,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:43',NULL,NULL),(7834,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:21',NULL,NULL),(9460,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:07',NULL,NULL),(4225,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:26',NULL,NULL),(612,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:06',NULL,NULL),(7154,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:33',NULL,NULL),(6071,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:48',NULL,NULL),(14465,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:19',NULL,NULL),(15308,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:13',NULL,NULL),(15557,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:16',NULL,NULL),(16557,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:30',NULL,NULL),(16887,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:29',NULL,NULL),(18581,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:37',NULL,NULL),(19291,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:22',NULL,NULL),(20304,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:45',NULL,NULL),(343,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:37',NULL,NULL),(13636,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:42',NULL,NULL),(7193,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:43',NULL,NULL),(2191,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:03',NULL,NULL),(11720,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:33',NULL,NULL),(6058,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:44',NULL,NULL),(4575,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:56',NULL,NULL),(5638,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:18',NULL,NULL),(4713,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:29',NULL,NULL),(15934,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:00',NULL,NULL),(17024,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:06',NULL,NULL),(18212,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:15:06',NULL,NULL),(21837,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:10',NULL,NULL),(92,282,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:25',NULL,NULL),(2094,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:04',NULL,NULL),(4871,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:12',NULL,NULL),(8223,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:54',NULL,NULL),(3436,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:19',NULL,NULL),(12986,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:37',NULL,NULL),(14826,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:59',NULL,NULL),(17304,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:14',NULL,NULL),(21967,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:55',NULL,NULL),(22837,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:31',NULL,NULL),(1133,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:53',NULL,NULL),(12562,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:37',NULL,NULL),(12078,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:25',NULL,NULL),(1470,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:39',NULL,NULL),(9927,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:47',NULL,NULL),(9575,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:15',NULL,NULL),(8610,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:28',NULL,NULL),(7737,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:54',NULL,NULL),(5542,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:05',NULL,NULL),(2224,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:12',NULL,NULL),(2916,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:28',NULL,NULL),(13677,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:47',NULL,NULL),(14530,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:36',NULL,NULL),(20855,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:55',NULL,NULL),(5145,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:14',NULL,NULL),(1310,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:39',NULL,NULL),(3878,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:02',NULL,NULL),(9167,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:48',NULL,NULL),(1964,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:31',NULL,NULL),(3724,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:23',NULL,NULL),(2325,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:45',NULL,NULL),(15768,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:27',NULL,NULL),(17916,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:25',NULL,NULL),(18997,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:09',NULL,NULL),(21850,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:14',NULL,NULL),(21863,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:19',NULL,NULL),(22812,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:23',NULL,NULL),(5970,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:13',NULL,NULL),(2550,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:42',NULL,NULL),(5155,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:17',NULL,NULL),(4807,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:54',NULL,NULL),(3030,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:09',NULL,NULL),(14735,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:34',NULL,NULL),(5632,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:15',NULL,NULL),(2629,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:03',NULL,NULL),(13766,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:01',NULL,NULL),(14727,1828,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:31',NULL,NULL),(16762,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:48',NULL,NULL),(18924,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:47',NULL,NULL),(19239,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:08',NULL,NULL),(20171,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:10',NULL,NULL),(20193,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:04',NULL,NULL),(7399,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:41',NULL,NULL),(11789,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:52',NULL,NULL),(6237,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:46',NULL,NULL),(5313,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:02',NULL,NULL),(4341,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:56',NULL,NULL),(9658,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:37',NULL,NULL),(14528,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:36',NULL,NULL),(14831,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:00',NULL,NULL),(204,236,'2013-12-27','15:15:00','A','000',0,'2014-01-13 03:05:09',NULL,NULL),(12921,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:19',NULL,NULL),(1666,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:48',NULL,NULL),(10878,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:05',NULL,NULL),(9880,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:35',NULL,NULL),(9399,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:50',NULL,NULL),(9088,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:27',NULL,NULL),(8712,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:55',NULL,NULL),(8447,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:56',NULL,NULL),(5545,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:06',NULL,NULL),(3462,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:26',NULL,NULL),(6082,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:03',NULL,NULL),(13187,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:30',NULL,NULL),(13360,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:16',NULL,NULL),(13440,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:13',NULL,NULL),(14221,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:08',NULL,NULL),(22891,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:49',NULL,NULL),(22962,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(23172,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(246,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:04',NULL,NULL),(12466,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:10',NULL,NULL),(815,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:27',NULL,NULL),(8076,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:15',NULL,NULL),(5610,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:07',NULL,NULL),(5614,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:09',NULL,NULL),(3288,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:39',NULL,NULL),(2895,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:21',NULL,NULL),(1392,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:10',NULL,NULL),(1630,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:35',NULL,NULL),(14048,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:42',NULL,NULL),(17166,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:53',NULL,NULL),(18749,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:58',NULL,NULL),(21074,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:55',NULL,NULL),(22446,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:31',NULL,NULL),(22615,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:28',NULL,NULL),(243,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:03',NULL,NULL),(439,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:10',NULL,NULL),(7077,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:10',NULL,NULL),(10063,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:07',NULL,NULL),(3516,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:40',NULL,NULL),(8345,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:30',NULL,NULL),(8115,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:26',NULL,NULL),(15888,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:44',NULL,NULL),(17386,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:41',NULL,NULL),(17434,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:57',NULL,NULL),(17917,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:25',NULL,NULL),(18657,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:57',NULL,NULL),(18772,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:05',NULL,NULL),(19566,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:40',NULL,NULL),(21123,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:08',NULL,NULL),(601,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:02',NULL,NULL),(616,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:07',NULL,NULL),(3285,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:38',NULL,NULL),(11842,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:05',NULL,NULL),(10284,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:08',NULL,NULL),(10314,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:17',NULL,NULL),(14636,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:07',NULL,NULL),(20351,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:01',NULL,NULL),(20697,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:10',NULL,NULL),(88,204,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:22',NULL,NULL),(2771,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:37',NULL,NULL),(12253,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:13',NULL,NULL),(12102,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:31',NULL,NULL),(12019,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:09',NULL,NULL),(4996,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:48',NULL,NULL),(8578,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:20',NULL,NULL),(14139,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:56',NULL,NULL),(16003,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:25',NULL,NULL),(16128,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:11',NULL,NULL),(17554,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:37',NULL,NULL),(17596,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:52',NULL,NULL),(21999,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:06',NULL,NULL),(1957,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:29',NULL,NULL),(4434,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:21',NULL,NULL),(17391,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:43',NULL,NULL),(21256,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:14',NULL,NULL),(6519,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:02',NULL,NULL),(13273,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:52',NULL,NULL),(12653,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:02',NULL,NULL),(5225,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:36',NULL,NULL),(2252,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:26',NULL,NULL),(18316,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:23',NULL,NULL),(18701,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:09',NULL,NULL),(19348,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:38',NULL,NULL),(21235,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:06',NULL,NULL),(22676,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:32',NULL,NULL),(7612,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:22',NULL,NULL),(13655,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:44',NULL,NULL),(1217,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:03',NULL,NULL),(2422,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:10',NULL,NULL),(5070,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:02:09',NULL,NULL),(15291,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:10',NULL,NULL),(15349,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:21',NULL,NULL),(16675,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:17',NULL,NULL),(16837,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:16',NULL,NULL),(22587,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:18',NULL,NULL),(490,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:26',NULL,NULL),(4218,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:24',NULL,NULL),(4485,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:34',NULL,NULL),(4804,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:00:53',NULL,NULL),(8777,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:13',NULL,NULL),(11249,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:31',NULL,NULL),(14273,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:16',NULL,NULL),(14362,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:48',NULL,NULL),(15865,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:36',NULL,NULL),(15946,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:05',NULL,NULL),(16246,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:53',NULL,NULL),(18277,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:13',NULL,NULL),(18449,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:59',NULL,NULL),(22349,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:59',NULL,NULL),(22858,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:39',NULL,NULL),(8338,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:28',NULL,NULL),(6171,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:29',NULL,NULL),(2322,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:44',NULL,NULL),(8910,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:48',NULL,NULL),(15314,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:14',NULL,NULL),(22635,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:19',NULL,NULL),(23096,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(23527,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 01:30:02',NULL,NULL),(782,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:18',NULL,NULL),(1296,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:33',NULL,NULL),(8421,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:50',NULL,NULL),(11115,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:53',NULL,NULL),(9554,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:10',NULL,NULL),(6513,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:01',NULL,NULL),(5467,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:43',NULL,NULL),(4047,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:45',NULL,NULL),(6056,1884,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:02:43',NULL,NULL),(15361,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:23',NULL,NULL),(16829,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:14',NULL,NULL),(18934,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:50',NULL,NULL),(21057,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:50',NULL,NULL),(22491,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:46',NULL,NULL),(23660,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 01:30:00',NULL,NULL),(7686,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:41',NULL,NULL),(12002,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:05',NULL,NULL),(7060,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:04',NULL,NULL),(2181,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:26',NULL,NULL),(9874,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:34',NULL,NULL),(17822,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:52',NULL,NULL),(20644,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:48',NULL,NULL),(8457,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:59',NULL,NULL),(13477,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:19',NULL,NULL),(12873,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:24:09',NULL,NULL),(12752,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:31',NULL,NULL),(1686,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:56',NULL,NULL),(4821,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:58',NULL,NULL),(11839,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:04',NULL,NULL),(11533,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:46',NULL,NULL),(10222,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:51',NULL,NULL),(3159,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:55',NULL,NULL),(8965,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:02:03',NULL,NULL),(17020,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:04',NULL,NULL),(17959,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:40',NULL,NULL),(19090,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:34',NULL,NULL),(20374,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:10',NULL,NULL),(21071,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:54',NULL,NULL),(23105,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:36',NULL,NULL),(7281,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:09',NULL,NULL),(12322,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:34',NULL,NULL),(3647,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:02',NULL,NULL),(2906,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:24',NULL,NULL),(1675,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:52',NULL,NULL),(14673,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:17',NULL,NULL),(17951,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:37',NULL,NULL),(18109,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:32',NULL,NULL),(19537,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:31',NULL,NULL),(1872,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:45',NULL,NULL),(14296,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:32:19',NULL,NULL),(2205,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:07',NULL,NULL),(12764,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:34',NULL,NULL),(11852,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:08',NULL,NULL),(11637,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:12',NULL,NULL),(2944,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:38',NULL,NULL),(9981,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:45',NULL,NULL),(17132,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:42',NULL,NULL),(18451,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:00',NULL,NULL),(18538,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:25',NULL,NULL),(22683,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:35',NULL,NULL),(381,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:49',NULL,NULL),(988,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:14',NULL,NULL),(13042,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:51',NULL,NULL),(12683,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:11',NULL,NULL),(2025,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:47',NULL,NULL),(10815,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:48',NULL,NULL),(4373,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:05',NULL,NULL),(4797,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:51',NULL,NULL),(6583,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:06',NULL,NULL),(15223,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:57',NULL,NULL),(16033,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:36',NULL,NULL),(16063,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:46',NULL,NULL),(17037,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:10',NULL,NULL),(17083,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:25',NULL,NULL),(23327,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:25',NULL,NULL),(23345,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:31',NULL,NULL),(23494,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:23',NULL,NULL),(586,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:57',NULL,NULL),(18549,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:28',NULL,NULL),(16255,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:57',NULL,NULL),(9636,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:32',NULL,NULL),(8939,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:56',NULL,NULL),(8417,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:49',NULL,NULL),(15150,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:37',NULL,NULL),(13456,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:16',NULL,NULL),(13236,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:43',NULL,NULL),(4592,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:00',NULL,NULL),(11308,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:46',NULL,NULL),(2801,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:48',NULL,NULL),(19355,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:40',NULL,NULL),(18986,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:05',NULL,NULL),(17377,1574,'2014-01-13','22:09:00','A','000',0,'2014-01-24 07:00:38',NULL,NULL),(22210,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:22',NULL,NULL),(12740,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:28',NULL,NULL),(20927,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:15',NULL,NULL),(10332,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:22',NULL,NULL),(19535,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:31',NULL,NULL),(1150,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:58',NULL,NULL),(15877,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:40',NULL,NULL),(8483,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:06',NULL,NULL),(12656,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:03',NULL,NULL),(2651,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:09',NULL,NULL),(5803,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:15',NULL,NULL),(858,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:30:39',NULL,NULL),(11018,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:22',NULL,NULL),(21077,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:55',NULL,NULL),(15319,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:15',NULL,NULL),(4169,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:11',NULL,NULL),(5969,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:12',NULL,NULL),(8406,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:46',NULL,NULL),(5959,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:08',NULL,NULL),(461,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:17',NULL,NULL),(19918,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:59',NULL,NULL),(16915,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:36',NULL,NULL),(11576,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:57',NULL,NULL),(6492,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:55',NULL,NULL),(4846,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:05',NULL,NULL),(5814,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:18',NULL,NULL),(4088,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:55',NULL,NULL),(6568,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:02',NULL,NULL),(20412,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:24',NULL,NULL),(15584,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:25',NULL,NULL),(19999,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:23',NULL,NULL),(8519,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:04',NULL,NULL),(17924,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:28',NULL,NULL),(15273,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:06',NULL,NULL),(9256,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:12',NULL,NULL),(14329,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:26',NULL,NULL),(6260,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:52',NULL,NULL),(14199,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:04',NULL,NULL),(23319,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:22',NULL,NULL),(20827,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:47',NULL,NULL),(11063,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:37',NULL,NULL),(17668,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:20',NULL,NULL),(13640,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:42',NULL,NULL),(22133,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:54',NULL,NULL),(3222,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:21',NULL,NULL),(8019,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:02:11',NULL,NULL),(12710,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:19',NULL,NULL),(3903,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:08',NULL,NULL),(290,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:18',NULL,NULL),(20272,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:33',NULL,NULL),(5769,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:03',NULL,NULL),(8520,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:04',NULL,NULL),(8375,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:38',NULL,NULL),(16865,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:23',NULL,NULL),(11309,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:46',NULL,NULL),(10462,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:18',NULL,NULL),(6536,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:07',NULL,NULL),(7103,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:19',NULL,NULL),(868,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:42',NULL,NULL),(17770,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:33',NULL,NULL),(17466,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:07',NULL,NULL),(1614,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:29',NULL,NULL),(9631,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:30',NULL,NULL),(16466,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:57',NULL,NULL),(7665,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:35',NULL,NULL),(16222,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:44',NULL,NULL),(2003,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:41',NULL,NULL),(7620,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:24',NULL,NULL),(16059,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:45',NULL,NULL),(15758,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:24',NULL,NULL),(14766,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:42',NULL,NULL),(22764,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:05',NULL,NULL),(11744,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:40',NULL,NULL),(21847,1880,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:01:13',NULL,NULL),(21112,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:05',NULL,NULL),(12026,1825,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:11',NULL,NULL),(13150,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:20',NULL,NULL),(1586,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:19',NULL,NULL),(6560,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:13',NULL,NULL),(10567,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:45',NULL,NULL),(12500,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:20',NULL,NULL),(13311,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:03',NULL,NULL),(14279,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:17',NULL,NULL),(16587,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:41',NULL,NULL),(17259,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:24',NULL,NULL),(17660,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:17',NULL,NULL),(22934,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:03',NULL,NULL),(431,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-23 19:01:07',NULL,NULL),(10418,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:46',NULL,NULL),(9598,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:22',NULL,NULL),(9527,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:03',NULL,NULL),(693,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:34',NULL,NULL),(914,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:54',NULL,NULL),(1514,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:54',NULL,NULL),(5141,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:13',NULL,NULL),(4926,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:28',NULL,NULL),(4912,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:24',NULL,NULL),(14232,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:09',NULL,NULL),(14450,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:14',NULL,NULL),(15264,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:05',NULL,NULL),(16335,1843,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:18:07',NULL,NULL),(20433,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:32',NULL,NULL),(21444,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:22',NULL,NULL),(22526,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:57',NULL,NULL),(22594,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:21',NULL,NULL),(22981,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(23358,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:36',NULL,NULL),(4250,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:32',NULL,NULL),(2656,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:10',NULL,NULL),(10950,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:03',NULL,NULL),(2366,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:55',NULL,NULL),(10336,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:23',NULL,NULL),(10109,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:20',NULL,NULL),(6632,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:18',NULL,NULL),(12088,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:28',NULL,NULL),(13723,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:55',NULL,NULL),(19406,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:56',NULL,NULL),(5399,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:25',NULL,NULL),(8894,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:44',NULL,NULL),(11113,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:52',NULL,NULL),(18645,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:54',NULL,NULL),(21561,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:06',NULL,NULL),(327,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:31',NULL,NULL),(11785,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:51',NULL,NULL),(4634,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:06',NULL,NULL),(10987,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:13',NULL,NULL),(6835,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:12',NULL,NULL),(7878,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:34',NULL,NULL),(12177,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:51',NULL,NULL),(12464,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:10',NULL,NULL),(13462,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:16',NULL,NULL),(16098,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:00',NULL,NULL),(21822,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:04',NULL,NULL),(333,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:33',NULL,NULL),(11660,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:18',NULL,NULL),(597,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:01',NULL,NULL),(11150,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:02',NULL,NULL),(10750,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:32',NULL,NULL),(5207,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:31',NULL,NULL),(9907,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:42',NULL,NULL),(3266,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:33',NULL,NULL),(7336,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:24',NULL,NULL),(13411,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:09',NULL,NULL),(13752,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:58',NULL,NULL),(22249,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:32',NULL,NULL),(22759,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:02',NULL,NULL),(2473,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:23',NULL,NULL),(5982,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:17',NULL,NULL),(3479,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:30',NULL,NULL),(8632,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:34',NULL,NULL),(7606,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:20',NULL,NULL),(4743,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:37',NULL,NULL),(15789,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:34',NULL,NULL),(15840,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:27',NULL,NULL),(18062,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:16',NULL,NULL),(20227,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:17',NULL,NULL),(6275,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:56',NULL,NULL),(11715,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:32',NULL,NULL),(10670,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:13',NULL,NULL),(607,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:04',NULL,NULL),(3831,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:50',NULL,NULL),(6944,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:46',NULL,NULL),(5512,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:56',NULL,NULL),(14927,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:26',NULL,NULL),(18675,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:02',NULL,NULL),(19586,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:45',NULL,NULL),(19608,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:51',NULL,NULL),(67,310,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:03',NULL,NULL),(99,295,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:32',NULL,NULL),(1425,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:22',NULL,NULL),(10885,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:07',NULL,NULL),(8391,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:42',NULL,NULL),(13192,1796,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:31',NULL,NULL),(13797,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:05',NULL,NULL),(13859,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:14',NULL,NULL),(16970,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:49',NULL,NULL),(22482,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:43',NULL,NULL),(23376,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:42',NULL,NULL),(23656,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 17:30:00',NULL,NULL),(23665,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 19:29:59',NULL,NULL),(44,328,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:41',NULL,NULL),(11859,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:09',NULL,NULL),(11426,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:21',NULL,NULL),(10635,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:02',NULL,NULL),(1440,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:27',NULL,NULL),(6934,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:43',NULL,NULL),(3183,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:09',NULL,NULL),(16195,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:35',NULL,NULL),(17145,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:46',NULL,NULL),(19136,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:47',NULL,NULL),(22312,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:47',NULL,NULL),(22417,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:21',NULL,NULL),(1201,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:12',NULL,NULL),(1311,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:39',NULL,NULL),(9542,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:07',NULL,NULL),(2106,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:07',NULL,NULL),(9206,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:59',NULL,NULL),(6447,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:43',NULL,NULL),(4021,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:37',NULL,NULL),(13621,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:40',NULL,NULL),(17363,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:34',NULL,NULL),(23063,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(6246,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:49',NULL,NULL),(4215,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:23',NULL,NULL),(3107,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:37',NULL,NULL),(13219,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:38',NULL,NULL),(14484,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:24',NULL,NULL),(14961,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:35',NULL,NULL),(15439,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:38',NULL,NULL),(17777,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:35',NULL,NULL),(21925,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:41',NULL,NULL),(1211,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:15',NULL,NULL),(11840,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:05',NULL,NULL),(12444,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:04',NULL,NULL),(11542,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:48',NULL,NULL),(11415,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:18',NULL,NULL),(11328,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:52',NULL,NULL),(6029,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:02:33',NULL,NULL),(12832,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:55',NULL,NULL),(13369,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:18',NULL,NULL),(13670,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:46',NULL,NULL),(14449,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:14',NULL,NULL),(14764,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:42',NULL,NULL),(15537,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:09',NULL,NULL),(19675,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:11',NULL,NULL),(6018,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:29',NULL,NULL),(5457,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:40',NULL,NULL),(1230,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:08',NULL,NULL),(10830,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:52',NULL,NULL),(1511,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:53',NULL,NULL),(8212,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:51',NULL,NULL),(13095,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:05',NULL,NULL),(17589,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:50',NULL,NULL),(18049,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:11',NULL,NULL),(22182,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:14',NULL,NULL),(23571,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 17:30:02',NULL,NULL),(6928,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:41',NULL,NULL),(2949,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:40',NULL,NULL),(9258,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:13',NULL,NULL),(6885,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:26',NULL,NULL),(14127,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:54',NULL,NULL),(9774,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:07',NULL,NULL),(9718,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:52',NULL,NULL),(4640,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:07',NULL,NULL),(11871,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:12',NULL,NULL),(8904,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:47',NULL,NULL),(11743,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:40',NULL,NULL),(8563,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:16',NULL,NULL),(7583,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:14',NULL,NULL),(23544,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 11:30:02',NULL,NULL),(339,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:35',NULL,NULL),(18373,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:39',NULL,NULL),(9980,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:45',NULL,NULL),(14571,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:47',NULL,NULL),(1080,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:39',NULL,NULL),(5067,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:08',NULL,NULL),(5112,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:03',NULL,NULL),(5341,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:09',NULL,NULL),(8274,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:08',NULL,NULL),(14547,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:41',NULL,NULL),(783,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:18',NULL,NULL),(18733,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:35:54',NULL,NULL),(6401,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:31',NULL,NULL),(2889,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:18',NULL,NULL),(22567,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:11',NULL,NULL),(376,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:47',NULL,NULL),(1238,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:11',NULL,NULL),(1920,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:56',NULL,NULL),(20054,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:38',NULL,NULL),(6620,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:15',NULL,NULL),(19108,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:38',NULL,NULL),(4959,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:37',NULL,NULL),(5826,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:23',NULL,NULL),(5319,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:03',NULL,NULL),(1012,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:21',NULL,NULL),(9270,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:16',NULL,NULL),(21307,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:32',NULL,NULL),(1976,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:34',NULL,NULL),(10334,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:22',NULL,NULL),(10261,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:02',NULL,NULL),(10137,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:28',NULL,NULL),(3308,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:44',NULL,NULL),(16796,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:06',NULL,NULL),(9729,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:55',NULL,NULL),(14959,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:34',NULL,NULL),(5658,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:25',NULL,NULL),(6819,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:08',NULL,NULL),(14317,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:23',NULL,NULL),(13199,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:33',NULL,NULL),(21743,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:00:36',NULL,NULL),(22411,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:19',NULL,NULL),(22777,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:09',NULL,NULL),(23501,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:25',NULL,NULL),(18714,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:13',NULL,NULL),(15849,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:30',NULL,NULL),(3582,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:58',NULL,NULL),(15848,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:30',NULL,NULL),(13517,1846,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:30:25',NULL,NULL),(6316,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:07',NULL,NULL),(5848,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:30',NULL,NULL),(13490,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:21',NULL,NULL),(12520,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:25',NULL,NULL),(12197,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:57',NULL,NULL),(22841,1887,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:59:33',NULL,NULL),(23301,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:15',NULL,NULL),(61,248,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:57',NULL,NULL),(16444,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:48',NULL,NULL),(15753,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:22',NULL,NULL),(10176,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:38',NULL,NULL),(14846,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:04',NULL,NULL),(3786,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:38',NULL,NULL),(19971,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:15',NULL,NULL),(21712,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:25',NULL,NULL),(22422,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:23',NULL,NULL),(23478,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:18',NULL,NULL),(1654,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:44',NULL,NULL),(21372,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:55',NULL,NULL),(21319,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:37',NULL,NULL),(18543,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:27',NULL,NULL),(9482,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:13',NULL,NULL),(17676,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:22',NULL,NULL),(17201,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:04',NULL,NULL),(4642,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:08',NULL,NULL),(16722,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:34',NULL,NULL),(15713,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:08',NULL,NULL),(11420,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:19',NULL,NULL),(13568,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:32',NULL,NULL),(22030,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:17',NULL,NULL),(2947,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:39',NULL,NULL),(10022,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:56',NULL,NULL),(20548,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:14',NULL,NULL),(7722,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:50',NULL,NULL),(19101,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:37',NULL,NULL),(18723,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:32:15',NULL,NULL),(4259,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:34',NULL,NULL),(5179,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:23',NULL,NULL),(11100,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:49',NULL,NULL),(4153,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:07',NULL,NULL),(10812,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:48',NULL,NULL),(10711,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:23',NULL,NULL),(10437,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:51',NULL,NULL),(9820,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:20',NULL,NULL),(9715,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:52',NULL,NULL),(6595,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:09',NULL,NULL),(3142,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:50',NULL,NULL),(11239,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:28',NULL,NULL),(12491,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:18',NULL,NULL),(12573,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:40',NULL,NULL),(14976,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:39',NULL,NULL),(17448,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:01',NULL,NULL),(21257,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:14',NULL,NULL),(1396,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:12',NULL,NULL),(6570,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:03',NULL,NULL),(9141,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:42',NULL,NULL),(7535,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:18',NULL,NULL),(11793,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:53',NULL,NULL),(14036,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:40',NULL,NULL),(15739,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:17',NULL,NULL),(16974,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:50',NULL,NULL),(21795,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:54',NULL,NULL),(22324,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:50',NULL,NULL),(22723,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:49',NULL,NULL),(4357,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:01',NULL,NULL),(6287,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:00',NULL,NULL),(6584,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:06',NULL,NULL),(13033,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:49',NULL,NULL),(17273,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:04',NULL,NULL),(17606,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:56',NULL,NULL),(20392,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:17',NULL,NULL),(20895,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:06',NULL,NULL),(22086,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:38',NULL,NULL),(4288,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:42',NULL,NULL),(9686,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:44',NULL,NULL),(3422,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:15',NULL,NULL),(2957,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:43',NULL,NULL),(12282,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:21',NULL,NULL),(14363,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:49:49',NULL,NULL),(16879,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:27',NULL,NULL),(17245,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:19',NULL,NULL),(20983,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:30',NULL,NULL),(21464,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:29',NULL,NULL),(23195,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(643,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:16',NULL,NULL),(4767,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:43',NULL,NULL),(7471,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:01',NULL,NULL),(6213,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:40',NULL,NULL),(12397,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:55',NULL,NULL),(12643,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:59',NULL,NULL),(15030,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:58',NULL,NULL),(16201,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:37',NULL,NULL),(18325,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:26',NULL,NULL),(20829,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:48',NULL,NULL),(4963,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:39',NULL,NULL),(10826,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:51',NULL,NULL),(4025,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:38',NULL,NULL),(9440,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:02',NULL,NULL),(8106,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:23',NULL,NULL),(7984,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:01',NULL,NULL),(7331,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:23',NULL,NULL),(2646,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:07',NULL,NULL),(2541,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:40',NULL,NULL),(11673,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:22',NULL,NULL),(12448,1848,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:05',NULL,NULL),(16877,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:27',NULL,NULL),(19597,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:48',NULL,NULL),(21588,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:16',NULL,NULL),(22719,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:48',NULL,NULL),(4922,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:27',NULL,NULL),(6994,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:59',NULL,NULL),(12609,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:50',NULL,NULL),(13597,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:36',NULL,NULL),(13683,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:48',NULL,NULL),(14800,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:52',NULL,NULL),(21346,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:46',NULL,NULL),(22709,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:44',NULL,NULL),(1070,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:36',NULL,NULL),(9647,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:34',NULL,NULL),(8140,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:32',NULL,NULL),(1857,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:41',NULL,NULL),(2262,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:29',NULL,NULL),(3120,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:42',NULL,NULL),(5909,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:51',NULL,NULL),(13154,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:21',NULL,NULL),(13206,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:35',NULL,NULL),(15525,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:05',NULL,NULL),(17028,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:07',NULL,NULL),(17315,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:18',NULL,NULL),(17368,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:36',NULL,NULL),(22960,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(23107,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:36',NULL,NULL),(23717,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 11:29:58',NULL,NULL),(5973,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:14',NULL,NULL),(11406,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:14',NULL,NULL),(9668,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:40',NULL,NULL),(9107,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:32',NULL,NULL),(1657,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:45',NULL,NULL),(12065,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:22',NULL,NULL),(15720,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:10',NULL,NULL),(18394,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:44',NULL,NULL),(18499,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:14',NULL,NULL),(21392,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:03',NULL,NULL),(23256,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(23339,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:29',NULL,NULL),(5448,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:38',NULL,NULL),(14643,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:09',NULL,NULL),(15381,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:27',NULL,NULL),(15733,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:15',NULL,NULL),(15793,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:36',NULL,NULL),(16721,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:33',NULL,NULL),(20996,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:33',NULL,NULL),(100,367,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:33',NULL,NULL),(11110,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:51',NULL,NULL),(4166,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:11',NULL,NULL),(9737,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:57',NULL,NULL),(9535,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:05',NULL,NULL),(5265,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:47',NULL,NULL),(13102,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:07',NULL,NULL),(13171,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:26',NULL,NULL),(13602,1868,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:30:37',NULL,NULL),(13812,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:07',NULL,NULL),(15446,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:39',NULL,NULL),(15777,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:30',NULL,NULL),(17562,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:40',NULL,NULL),(20270,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:00:32',NULL,NULL),(21519,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:50',NULL,NULL),(22087,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:38',NULL,NULL),(911,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:53',NULL,NULL),(11384,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:02:08',NULL,NULL),(8601,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:26',NULL,NULL),(10003,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:51',NULL,NULL),(12344,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:41',NULL,NULL),(14473,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:21',NULL,NULL),(15027,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:57',NULL,NULL),(19054,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:24',NULL,NULL),(20903,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:08',NULL,NULL),(21521,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:51',NULL,NULL),(22006,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:09',NULL,NULL),(22348,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:58',NULL,NULL),(519,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:36',NULL,NULL),(6988,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:57',NULL,NULL),(7730,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:52',NULL,NULL),(12961,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:31',NULL,NULL),(15306,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:13',NULL,NULL),(16390,1887,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:18:28',NULL,NULL),(18424,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:52',NULL,NULL),(19591,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:46',NULL,NULL),(21480,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:36',NULL,NULL),(22467,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:38',NULL,NULL),(136,340,'2013-12-27','15:52:00','A','000',0,'2014-01-13 03:04:47',NULL,NULL),(6610,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:13',NULL,NULL),(6026,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:32',NULL,NULL),(2762,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:34',NULL,NULL),(7468,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:00',NULL,NULL),(4342,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:56',NULL,NULL),(3116,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:41',NULL,NULL),(15532,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:07',NULL,NULL),(16075,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:50',NULL,NULL),(2367,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:55',NULL,NULL),(21930,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:43',NULL,NULL),(20904,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:08',NULL,NULL),(3678,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:11',NULL,NULL),(20387,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:15',NULL,NULL),(9161,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:47',NULL,NULL),(13428,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:11',NULL,NULL),(13001,1878,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:26:41',NULL,NULL),(10721,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:25',NULL,NULL),(8351,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:31',NULL,NULL),(21554,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:03',NULL,NULL),(19883,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:50',NULL,NULL),(2197,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:05',NULL,NULL),(2416,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:08',NULL,NULL),(16216,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:42',NULL,NULL),(8020,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:11',NULL,NULL),(8229,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:55',NULL,NULL),(10276,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:06',NULL,NULL),(12056,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:19',NULL,NULL),(13265,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:50',NULL,NULL),(21436,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:19',NULL,NULL),(476,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:22',NULL,NULL),(2014,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:44',NULL,NULL),(9856,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:29',NULL,NULL),(2286,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:35',NULL,NULL),(7177,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:39',NULL,NULL),(6911,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:35',NULL,NULL),(5902,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:49',NULL,NULL),(4663,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:14',NULL,NULL),(20659,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:53',NULL,NULL),(10788,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:42',NULL,NULL),(11816,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:58',NULL,NULL),(13986,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:32',NULL,NULL),(19766,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:19',NULL,NULL),(19242,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:09',NULL,NULL),(19121,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:42',NULL,NULL);
INSERT INTO `EdiTA1` VALUES (18904,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:41',NULL,NULL),(19196,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:04',NULL,NULL),(17674,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:22',NULL,NULL),(13884,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:17',NULL,NULL),(8261,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:04',NULL,NULL),(3295,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:41',NULL,NULL),(5016,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:54',NULL,NULL),(13855,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:13',NULL,NULL),(13450,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:15',NULL,NULL),(11698,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:28',NULL,NULL),(13368,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:18',NULL,NULL),(21653,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:04',NULL,NULL),(21893,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:29',NULL,NULL),(20395,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:18',NULL,NULL),(19846,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:40',NULL,NULL),(1589,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:20',NULL,NULL),(16664,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:13',NULL,NULL),(7542,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:03',NULL,NULL),(16432,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:43',NULL,NULL),(16416,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:38',NULL,NULL),(1615,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:30',NULL,NULL),(2650,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:32:08',NULL,NULL),(14538,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:38',NULL,NULL),(12514,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:24',NULL,NULL),(3749,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:29',NULL,NULL),(10585,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:49',NULL,NULL),(23634,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 20:00:02',NULL,NULL),(18220,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:09',NULL,NULL),(410,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:00',NULL,NULL),(4344,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:56',NULL,NULL),(5314,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:02',NULL,NULL),(8221,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:53',NULL,NULL),(8695,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:51',NULL,NULL),(21229,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:04',NULL,NULL),(18553,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:29',NULL,NULL),(17597,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:52',NULL,NULL),(15483,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:50',NULL,NULL),(13571,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:33',NULL,NULL),(10810,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:47',NULL,NULL),(3837,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:51',NULL,NULL),(23390,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:47',NULL,NULL),(103,318,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:35',NULL,NULL),(10696,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:19',NULL,NULL),(10466,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:19',NULL,NULL),(20435,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:33',NULL,NULL),(9645,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:34',NULL,NULL),(9456,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:06',NULL,NULL),(8502,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:11',NULL,NULL),(18241,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:15:16',NULL,NULL),(11536,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:47',NULL,NULL),(1037,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:28',NULL,NULL),(5435,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:35',NULL,NULL),(5597,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:03',NULL,NULL),(4917,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:25',NULL,NULL),(3845,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:53',NULL,NULL),(6169,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:28',NULL,NULL),(21407,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:09',NULL,NULL),(20586,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:27',NULL,NULL),(10520,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:32',NULL,NULL),(18081,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:22',NULL,NULL),(17813,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:49',NULL,NULL),(14183,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:02',NULL,NULL),(12164,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:48',NULL,NULL),(7586,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:15',NULL,NULL),(4920,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:26',NULL,NULL),(3682,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:12',NULL,NULL),(6690,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:33',NULL,NULL),(23155,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:45',NULL,NULL),(23585,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 13:30:02',NULL,NULL),(711,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:40',NULL,NULL),(10555,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:42',NULL,NULL),(10035,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:00',NULL,NULL),(15360,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:23',NULL,NULL),(14632,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:05',NULL,NULL),(9035,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:12',NULL,NULL),(8586,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:22',NULL,NULL),(7987,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:02:02',NULL,NULL),(13889,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:18',NULL,NULL),(20118,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:56',NULL,NULL),(19686,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:14',NULL,NULL),(18632,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:50',NULL,NULL),(5912,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:52',NULL,NULL),(11483,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:34',NULL,NULL),(3780,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:37',NULL,NULL),(5484,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:48',NULL,NULL),(5182,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:24',NULL,NULL),(4295,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:43',NULL,NULL),(5000,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:49',NULL,NULL),(4325,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:51',NULL,NULL),(245,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:04',NULL,NULL),(10944,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:21',NULL,NULL),(17578,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:45',NULL,NULL),(10059,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:06',NULL,NULL),(9179,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:51',NULL,NULL),(528,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:39',NULL,NULL),(17541,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:32',NULL,NULL),(13958,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:28',NULL,NULL),(2531,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:38',NULL,NULL),(11255,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:32',NULL,NULL),(4237,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:29',NULL,NULL),(4437,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:22',NULL,NULL),(3851,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:55',NULL,NULL),(583,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:56',NULL,NULL),(16337,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:08',NULL,NULL),(21300,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:30',NULL,NULL),(9189,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:54',NULL,NULL),(19477,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:15',NULL,NULL),(8770,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:11',NULL,NULL),(18460,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:03',NULL,NULL),(15345,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:20',NULL,NULL),(11253,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:32',NULL,NULL),(23416,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:55',NULL,NULL),(561,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:50',NULL,NULL),(8739,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:02',NULL,NULL),(2396,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:03',NULL,NULL),(1971,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:32',NULL,NULL),(5922,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:55',NULL,NULL),(5783,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:08',NULL,NULL),(11193,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:14',NULL,NULL),(11584,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:59',NULL,NULL),(11733,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:37',NULL,NULL),(13180,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:28',NULL,NULL),(13765,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:01',NULL,NULL),(22539,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:01',NULL,NULL),(22947,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(5530,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:01',NULL,NULL),(11131,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:57',NULL,NULL),(10730,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:27',NULL,NULL),(10199,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:45',NULL,NULL),(6712,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:38',NULL,NULL),(6416,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:35',NULL,NULL),(11982,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:59',NULL,NULL),(12094,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:29',NULL,NULL),(17303,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:14',NULL,NULL),(17493,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:16',NULL,NULL),(18425,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:53',NULL,NULL),(21354,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:49',NULL,NULL),(3977,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:26',NULL,NULL),(6459,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:46',NULL,NULL),(10338,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:23',NULL,NULL),(7643,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:30',NULL,NULL),(12038,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:14',NULL,NULL),(14243,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:32:11',NULL,NULL),(14303,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:20',NULL,NULL),(14999,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:47',NULL,NULL),(15682,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:58',NULL,NULL),(15918,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:55',NULL,NULL),(22839,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:32',NULL,NULL),(4950,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:35',NULL,NULL),(11086,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:45',NULL,NULL),(8909,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:48',NULL,NULL),(4436,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:21',NULL,NULL),(3125,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:44',NULL,NULL),(1773,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:20',NULL,NULL),(1621,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:32',NULL,NULL),(12285,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:22',NULL,NULL),(17282,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:07',NULL,NULL),(17456,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:04',NULL,NULL),(1001,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:18',NULL,NULL),(1737,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:12',NULL,NULL),(6190,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:34',NULL,NULL),(5183,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:24',NULL,NULL),(3528,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:44',NULL,NULL),(9379,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:44',NULL,NULL),(8574,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:19',NULL,NULL),(12610,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:50',NULL,NULL),(15338,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:19',NULL,NULL),(17546,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:34',NULL,NULL),(20695,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:09',NULL,NULL),(23372,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:41',NULL,NULL),(3325,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:49',NULL,NULL),(6688,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:33',NULL,NULL),(9677,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:42',NULL,NULL),(7426,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:48',NULL,NULL),(13059,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:56',NULL,NULL),(13174,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:26',NULL,NULL),(19031,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:18',NULL,NULL),(22101,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:43',NULL,NULL),(5370,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:17',NULL,NULL),(11491,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:36',NULL,NULL),(7391,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:39',NULL,NULL),(6350,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:16',NULL,NULL),(16016,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:30',NULL,NULL),(17251,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:22',NULL,NULL),(20645,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:49',NULL,NULL),(22735,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:53',NULL,NULL),(1427,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:23',NULL,NULL),(11465,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:29',NULL,NULL),(8029,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:03',NULL,NULL),(8774,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:12',NULL,NULL),(13006,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:42',NULL,NULL),(14344,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:30',NULL,NULL),(14415,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:04',NULL,NULL),(15077,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:13',NULL,NULL),(18326,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:26',NULL,NULL),(19619,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:54',NULL,NULL),(22322,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:49',NULL,NULL),(6055,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:43',NULL,NULL),(11869,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:12',NULL,NULL),(8957,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:01',NULL,NULL),(7548,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:05',NULL,NULL),(1816,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:31',NULL,NULL),(15071,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:11',NULL,NULL),(15803,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:39',NULL,NULL),(17843,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:00',NULL,NULL),(21625,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:30',NULL,NULL),(22998,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(23221,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:58',NULL,NULL),(32,379,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:30',NULL,NULL),(923,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:56',NULL,NULL),(9168,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:49',NULL,NULL),(1026,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:24',NULL,NULL),(11161,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:05',NULL,NULL),(1668,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:49',NULL,NULL),(6046,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:39',NULL,NULL),(2579,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:49',NULL,NULL),(2582,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:50',NULL,NULL),(2704,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:13',NULL,NULL),(16000,1655,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:24',NULL,NULL),(17146,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:46',NULL,NULL),(4771,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:44',NULL,NULL),(15987,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:19',NULL,NULL),(10491,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:25',NULL,NULL),(12509,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:23',NULL,NULL),(162,199,'2013-12-27','14:58:00','A','000',0,'2014-01-13 03:04:55',NULL,NULL),(544,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:44',NULL,NULL),(19704,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:03',NULL,NULL),(1050,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:31',NULL,NULL),(1785,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:23',NULL,NULL),(4805,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:53',NULL,NULL),(18466,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:04',NULL,NULL),(16997,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:56',NULL,NULL),(12508,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:22',NULL,NULL),(13060,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:56',NULL,NULL),(13214,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:37',NULL,NULL),(14290,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:18',NULL,NULL),(16367,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:18',NULL,NULL),(14567,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:46',NULL,NULL),(14620,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:02',NULL,NULL),(16274,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:04',NULL,NULL),(22430,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:25',NULL,NULL),(5639,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:18',NULL,NULL),(19059,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:25',NULL,NULL),(17574,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:44',NULL,NULL),(6357,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:18',NULL,NULL),(8879,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:39',NULL,NULL),(8772,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:11',NULL,NULL),(10529,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:35',NULL,NULL),(10848,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:56',NULL,NULL),(13892,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:18',NULL,NULL),(14494,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:27',NULL,NULL),(733,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:04',NULL,NULL),(19875,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:48',NULL,NULL),(9366,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:41',NULL,NULL),(19706,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:03',NULL,NULL),(5332,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:07',NULL,NULL),(7833,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:21',NULL,NULL),(18172,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:53',NULL,NULL),(5812,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:18',NULL,NULL),(11257,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:33',NULL,NULL),(17749,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:47',NULL,NULL),(14050,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:42',NULL,NULL),(22949,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(19313,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:29',NULL,NULL),(3248,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:28',NULL,NULL),(16953,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:45',NULL,NULL),(16853,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:20',NULL,NULL),(16400,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:32',NULL,NULL),(11187,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:12',NULL,NULL),(13425,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:11',NULL,NULL),(22246,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:31',NULL,NULL),(22893,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:50',NULL,NULL),(22979,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:12',NULL,NULL),(21088,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:58',NULL,NULL),(9300,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:24',NULL,NULL),(19592,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:47',NULL,NULL),(19545,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:33',NULL,NULL),(8918,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:50',NULL,NULL),(1493,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:47',NULL,NULL),(14651,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:11',NULL,NULL),(6252,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:50',NULL,NULL),(6022,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:31',NULL,NULL),(5269,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:48',NULL,NULL),(11814,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:58',NULL,NULL),(3244,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:26',NULL,NULL),(11092,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:46',NULL,NULL),(1636,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:37',NULL,NULL),(10189,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:42',NULL,NULL),(9428,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:58',NULL,NULL),(20510,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:01:59',NULL,NULL),(9114,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:34',NULL,NULL),(2419,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:09',NULL,NULL),(5903,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:49',NULL,NULL),(19120,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:42',NULL,NULL),(13138,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:17',NULL,NULL),(13439,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:13',NULL,NULL),(16544,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:25',NULL,NULL),(21006,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:36',NULL,NULL),(10414,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:45',NULL,NULL),(19487,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:17',NULL,NULL),(17112,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:35',NULL,NULL),(8798,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:18',NULL,NULL),(947,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:03',NULL,NULL),(17055,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:16',NULL,NULL),(16011,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:28',NULL,NULL),(5679,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:32',NULL,NULL),(10863,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:01',NULL,NULL),(2402,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:05',NULL,NULL),(5133,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:11',NULL,NULL),(5028,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:57',NULL,NULL),(3005,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:00',NULL,NULL),(16743,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:41',NULL,NULL),(13628,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:40',NULL,NULL),(12531,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:28',NULL,NULL),(8579,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:20',NULL,NULL),(12113,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:34',NULL,NULL),(11810,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:57',NULL,NULL),(20522,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:03',NULL,NULL),(10893,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:09',NULL,NULL),(7266,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:05',NULL,NULL),(23648,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 17:30:02',NULL,NULL),(23686,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 13:30:02',NULL,NULL),(20163,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:08',NULL,NULL),(2218,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:10',NULL,NULL),(20024,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:30',NULL,NULL),(7860,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:28',NULL,NULL),(7679,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:39',NULL,NULL),(18478,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:08',NULL,NULL),(15661,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:51',NULL,NULL),(22533,1882,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:31:59',NULL,NULL),(12686,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:12',NULL,NULL),(13332,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:08',NULL,NULL),(14498,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:28',NULL,NULL),(325,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:31',NULL,NULL),(1223,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:06',NULL,NULL),(1553,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:08',NULL,NULL),(20401,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:20',NULL,NULL),(13845,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:12',NULL,NULL),(2786,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:42',NULL,NULL),(4377,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:06',NULL,NULL),(7373,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:34',NULL,NULL),(6348,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:16',NULL,NULL),(22832,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:30',NULL,NULL),(1521,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:56',NULL,NULL),(15740,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:17',NULL,NULL),(14072,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:45',NULL,NULL),(4450,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:25',NULL,NULL),(4518,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:42',NULL,NULL),(4775,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:45',NULL,NULL),(5268,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:48',NULL,NULL),(13053,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:54',NULL,NULL),(12912,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:17',NULL,NULL),(6605,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:11',NULL,NULL),(22240,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:29',NULL,NULL),(23125,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:40',NULL,NULL),(22081,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:36',NULL,NULL),(14012,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:37',NULL,NULL),(3333,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:51',NULL,NULL),(10028,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:58',NULL,NULL),(8233,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:56',NULL,NULL),(21437,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:20',NULL,NULL),(3970,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:25',NULL,NULL),(13896,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:19',NULL,NULL),(17689,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:27',NULL,NULL),(14077,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:46',NULL,NULL),(7256,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:02',NULL,NULL),(21430,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:17',NULL,NULL),(4906,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:21',NULL,NULL),(3460,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:25',NULL,NULL),(5215,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:33',NULL,NULL),(1705,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:04',NULL,NULL),(10784,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:41',NULL,NULL),(8388,1861,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:31:41',NULL,NULL),(7273,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:07',NULL,NULL),(7170,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:37',NULL,NULL),(1822,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:32',NULL,NULL),(4874,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:13',NULL,NULL),(4732,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:00:34',NULL,NULL),(14164,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:59',NULL,NULL),(14389,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:57',NULL,NULL),(16278,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:05',NULL,NULL),(16821,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:12',NULL,NULL),(17699,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:30',NULL,NULL),(18025,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:03',NULL,NULL),(19804,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:29',NULL,NULL),(19983,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:18',NULL,NULL),(20947,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:20',NULL,NULL),(23208,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(4245,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:31',NULL,NULL),(9204,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:58',NULL,NULL),(3297,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:41',NULL,NULL),(6514,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:01',NULL,NULL),(10602,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:53',NULL,NULL),(13667,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:46',NULL,NULL),(16321,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:02',NULL,NULL),(18968,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:00',NULL,NULL),(19344,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:37',NULL,NULL),(21092,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:59',NULL,NULL),(21286,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:25',NULL,NULL),(247,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:05',NULL,NULL),(6191,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:34',NULL,NULL),(18124,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:37',NULL,NULL),(22767,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:06',NULL,NULL),(135,180,'2013-12-27','14:51:00','A','000',0,'2014-01-13 03:04:46',NULL,NULL),(165,235,'2013-12-27','15:14:00','A','000',0,'2014-01-13 03:04:56',NULL,NULL),(234,288,'2013-12-27','15:33:00','A','000',0,'2014-01-13 03:05:19',NULL,NULL),(6808,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:05',NULL,NULL),(6490,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:55',NULL,NULL),(5078,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:11',NULL,NULL),(2857,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:07',NULL,NULL),(14814,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:56',NULL,NULL),(16048,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:41',NULL,NULL),(16540,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:24',NULL,NULL),(23265,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(23541,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 22:00:02',NULL,NULL),(1281,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:28',NULL,NULL),(2199,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:05',NULL,NULL),(14783,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:47',NULL,NULL),(15289,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:09',NULL,NULL),(15451,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:40',NULL,NULL),(19607,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:51',NULL,NULL),(20544,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:12',NULL,NULL),(8577,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:19',NULL,NULL),(11141,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:59',NULL,NULL),(10500,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:27',NULL,NULL),(9410,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:53',NULL,NULL),(16628,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:58',NULL,NULL),(23093,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(23295,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:13',NULL,NULL),(5977,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:15',NULL,NULL),(11108,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:51',NULL,NULL),(1291,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:32',NULL,NULL),(8290,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:14',NULL,NULL),(2753,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:31',NULL,NULL),(7900,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:40',NULL,NULL),(7795,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:10',NULL,NULL),(2158,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:20',NULL,NULL),(6857,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:18',NULL,NULL),(13504,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:23',NULL,NULL),(14684,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:20',NULL,NULL),(16181,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:30',NULL,NULL),(18687,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:05',NULL,NULL),(19433,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:03',NULL,NULL),(19452,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:08',NULL,NULL),(20929,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:15',NULL,NULL),(21691,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:17',NULL,NULL),(3715,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:20',NULL,NULL),(10675,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:14',NULL,NULL),(6324,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:09',NULL,NULL),(8450,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:57',NULL,NULL),(11901,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:20',NULL,NULL),(11950,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:49',NULL,NULL),(13231,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:42',NULL,NULL),(14038,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:40',NULL,NULL),(14820,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:57',NULL,NULL),(15757,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:23',NULL,NULL),(15973,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:14',NULL,NULL),(16318,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:01',NULL,NULL),(18206,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:04',NULL,NULL),(19035,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:19',NULL,NULL),(20371,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:09',NULL,NULL),(20545,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:12',NULL,NULL),(1265,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:22',NULL,NULL),(5077,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:10',NULL,NULL),(11281,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:39',NULL,NULL),(12646,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:00',NULL,NULL),(14216,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:07',NULL,NULL),(23521,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:32',NULL,NULL),(4015,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:36',NULL,NULL),(11492,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:36',NULL,NULL),(10901,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:46:11',NULL,NULL),(10654,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:07',NULL,NULL),(9614,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:26',NULL,NULL),(6684,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:32',NULL,NULL),(12404,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:57',NULL,NULL),(22102,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:43',NULL,NULL),(9213,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:00',NULL,NULL),(10497,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:26',NULL,NULL),(16450,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:50',NULL,NULL),(21690,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:17',NULL,NULL),(22696,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:40',NULL,NULL),(22721,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:48',NULL,NULL),(22739,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:54',NULL,NULL),(23023,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:21',NULL,NULL),(30,373,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:28',NULL,NULL),(8264,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:05',NULL,NULL),(2469,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:22',NULL,NULL),(7995,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:02:04',NULL,NULL),(6971,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:52',NULL,NULL),(10249,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:58',NULL,NULL),(14955,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:33',NULL,NULL),(15346,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:21',NULL,NULL),(16509,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:13',NULL,NULL),(17451,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:02',NULL,NULL),(20572,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:22',NULL,NULL),(21405,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:08',NULL,NULL),(21888,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:27',NULL,NULL),(8612,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:28',NULL,NULL),(9452,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:05',NULL,NULL),(14336,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:28',NULL,NULL),(15494,1840,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:02:54',NULL,NULL),(19748,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:15',NULL,NULL),(20507,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:58',NULL,NULL),(21614,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:26',NULL,NULL),(1866,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:43',NULL,NULL),(2677,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:03',NULL,NULL),(7340,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:25',NULL,NULL),(7046,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:12',NULL,NULL),(6685,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:32',NULL,NULL),(16917,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:36',NULL,NULL),(19651,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:05',NULL,NULL),(292,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:19',NULL,NULL),(8423,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:50',NULL,NULL),(3593,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:01',NULL,NULL),(5219,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:34',NULL,NULL),(5497,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:52',NULL,NULL),(2230,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:21',NULL,NULL),(15545,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:12',NULL,NULL),(16161,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:23',NULL,NULL),(876,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:44',NULL,NULL),(12960,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:30',NULL,NULL),(6980,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:55',NULL,NULL),(2453,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:18',NULL,NULL),(4755,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:40',NULL,NULL),(15208,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:54',NULL,NULL),(16934,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:41',NULL,NULL),(18328,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:26',NULL,NULL),(20071,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:43',NULL,NULL),(20114,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:55',NULL,NULL),(22275,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:38',NULL,NULL),(8534,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:08',NULL,NULL),(8400,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:44',NULL,NULL),(13582,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:34',NULL,NULL),(12846,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:00',NULL,NULL),(11106,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:50',NULL,NULL),(8245,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:00',NULL,NULL),(10444,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:53',NULL,NULL),(8123,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:28',NULL,NULL),(9988,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:47',NULL,NULL),(9519,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:01',NULL,NULL),(5431,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:34',NULL,NULL),(5583,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:17',NULL,NULL),(14625,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:04',NULL,NULL),(17961,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:40',NULL,NULL),(19321,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:31',NULL,NULL),(21700,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:20',NULL,NULL),(22765,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:05',NULL,NULL),(1804,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:28',NULL,NULL),(6859,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:18',NULL,NULL),(13909,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:21',NULL,NULL),(6824,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:09',NULL,NULL),(13075,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:00',NULL,NULL),(11532,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:46',NULL,NULL),(4586,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:59',NULL,NULL),(4890,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:17',NULL,NULL),(18374,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:39',NULL,NULL),(18503,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:15',NULL,NULL),(23391,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:47',NULL,NULL),(8666,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:43',NULL,NULL),(14311,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:22',NULL,NULL),(2468,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:22',NULL,NULL),(15023,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:56',NULL,NULL),(7731,1892,'2014-01-14','23:11:00','A','000',0,'2014-01-24 03:00:52',NULL,NULL),(7070,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:08',NULL,NULL),(13309,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:02',NULL,NULL),(12804,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:45',NULL,NULL),(12126,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:38',NULL,NULL),(6228,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:44',NULL,NULL),(4710,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:28',NULL,NULL),(3630,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:12',NULL,NULL),(18530,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:23',NULL,NULL),(1180,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:06',NULL,NULL),(7104,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:19',NULL,NULL),(2406,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:06',NULL,NULL),(2741,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:26',NULL,NULL),(5049,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:03',NULL,NULL),(17807,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:47',NULL,NULL),(18453,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:00',NULL,NULL),(18825,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:19',NULL,NULL),(22642,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:21',NULL,NULL),(336,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:34',NULL,NULL),(2077,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:00',NULL,NULL),(2580,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:50',NULL,NULL),(6235,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:46',NULL,NULL),(3355,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:57',NULL,NULL),(15090,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:18',NULL,NULL),(15718,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:10',NULL,NULL),(17717,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:36',NULL,NULL),(17878,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:12',NULL,NULL),(18006,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:55',NULL,NULL),(20497,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:54',NULL,NULL),(22785,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:13',NULL,NULL),(7376,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:35',NULL,NULL),(13550,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:30',NULL,NULL),(4326,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:51',NULL,NULL),(4478,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:32',NULL,NULL),(11312,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:47',NULL,NULL),(4783,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:47',NULL,NULL),(4784,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:48',NULL,NULL),(6533,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:06',NULL,NULL),(16695,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:24',NULL,NULL),(18054,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:13',NULL,NULL),(18236,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:15',NULL,NULL),(8669,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:44',NULL,NULL),(6052,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:42',NULL,NULL),(9723,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:54',NULL,NULL),(12272,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:18',NULL,NULL),(10877,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:04',NULL,NULL),(15315,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:14',NULL,NULL),(20370,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:01:09',NULL,NULL),(22888,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:48',NULL,NULL),(8279,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:09',NULL,NULL),(7549,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:05',NULL,NULL),(13524,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:26',NULL,NULL),(13182,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:28',NULL,NULL),(13086,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:03',NULL,NULL),(5449,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:38',NULL,NULL),(5299,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:58',NULL,NULL),(17600,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:53',NULL,NULL),(18639,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:52',NULL,NULL),(18895,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:39',NULL,NULL),(18977,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:03',NULL,NULL),(19290,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:22',NULL,NULL),(8008,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:07',NULL,NULL),(13510,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:24',NULL,NULL),(12985,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:37',NULL,NULL),(12707,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:18',NULL,NULL),(7767,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:02',NULL,NULL),(7637,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:28',NULL,NULL),(9664,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:39',NULL,NULL),(4701,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:25',NULL,NULL),(5022,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:55',NULL,NULL),(7518,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:14',NULL,NULL),(3080,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:02:28',NULL,NULL),(16115,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:07',NULL,NULL),(17182,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:58',NULL,NULL),(19559,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:38',NULL,NULL),(20445,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:36',NULL,NULL),(23292,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:11',NULL,NULL),(394,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:53',NULL,NULL),(14877,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:13',NULL,NULL),(9597,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:21',NULL,NULL),(6714,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:39',NULL,NULL),(5972,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:13',NULL,NULL),(10962,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:06',NULL,NULL),(4168,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:11',NULL,NULL),(3444,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:21',NULL,NULL),(15461,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:43',NULL,NULL),(17566,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:41',NULL,NULL),(18269,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:09',NULL,NULL),(19326,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:32',NULL,NULL),(7982,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:02:01',NULL,NULL),(15114,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:26',NULL,NULL),(5854,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:32',NULL,NULL),(5743,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:54',NULL,NULL),(6729,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:43',NULL,NULL),(4397,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:11',NULL,NULL),(7387,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:38',NULL,NULL),(2838,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:01',NULL,NULL),(15572,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:21',NULL,NULL),(15773,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:29',NULL,NULL),(16972,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:50',NULL,NULL),(19681,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:13',NULL,NULL),(19871,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:47',NULL,NULL),(22202,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:19',NULL,NULL),(23423,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:57',NULL,NULL),(2271,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:31',NULL,NULL),(15340,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:19',NULL,NULL),(15196,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:01:52',NULL,NULL),(15034,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:59',NULL,NULL),(13594,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:36',NULL,NULL),(13388,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:04',NULL,NULL),(2729,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:22',NULL,NULL),(12701,1844,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:17',NULL,NULL),(12288,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:23',NULL,NULL),(4588,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:59',NULL,NULL),(4939,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:32',NULL,NULL),(5975,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:14',NULL,NULL),(5587,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:18',NULL,NULL),(18516,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:19',NULL,NULL),(21616,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:27',NULL,NULL),(22122,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:50',NULL,NULL),(2054,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:54',NULL,NULL),(14026,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:39',NULL,NULL),(13292,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:57',NULL,NULL),(12792,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:42',NULL,NULL),(2583,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:50',NULL,NULL),(7790,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:08',NULL,NULL),(20137,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:01',NULL,NULL),(21311,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:34',NULL,NULL),(21848,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:13',NULL,NULL),(9824,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:21',NULL,NULL),(15458,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:42',NULL,NULL),(5417,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:30',NULL,NULL),(13227,1828,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:40',NULL,NULL),(12237,1824,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:09',NULL,NULL),(15872,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:38',NULL,NULL),(16808,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:09',NULL,NULL),(17512,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:23',NULL,NULL),(19711,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:05',NULL,NULL),(23451,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:08',NULL,NULL),(717,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:42',NULL,NULL),(2420,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:09',NULL,NULL),(3146,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:51',NULL,NULL),(10196,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:44',NULL,NULL),(3275,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:35',NULL,NULL),(16363,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:17',NULL,NULL),(16848,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:19',NULL,NULL),(19789,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:25',NULL,NULL),(20759,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:28',NULL,NULL),(22946,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(6760,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:50',NULL,NULL),(15134,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:32',NULL,NULL),(2844,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:03',NULL,NULL),(5199,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:29',NULL,NULL),(11185,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:12',NULL,NULL),(13926,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:23',NULL,NULL),(12450,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:06',NULL,NULL),(11592,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:01',NULL,NULL),(16243,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:52',NULL,NULL),(18387,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:42',NULL,NULL),(18972,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:01',NULL,NULL),(22429,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:31:25',NULL,NULL),(23595,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 17:30:02',NULL,NULL),(1418,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:19',NULL,NULL),(15566,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:19',NULL,NULL),(1837,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:36',NULL,NULL),(2437,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:14',NULL,NULL),(20260,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:29',NULL,NULL),(20287,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:39',NULL,NULL),(21921,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:39',NULL,NULL),(22231,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:27',NULL,NULL),(279,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:15',NULL,NULL),(14381,1876,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:49:54',NULL,NULL),(13724,1845,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:30:55',NULL,NULL),(8210,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:51',NULL,NULL),(12147,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:43',NULL,NULL),(9299,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:23',NULL,NULL),(2093,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:04',NULL,NULL),(4892,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:17',NULL,NULL),(2733,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:24',NULL,NULL),(3562,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:53',NULL,NULL),(2832,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:58',NULL,NULL),(3270,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:34',NULL,NULL),(17313,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:17',NULL,NULL),(17838,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:58',NULL,NULL),(21318,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:36',NULL,NULL),(21460,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:28',NULL,NULL),(21634,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:33',NULL,NULL),(7061,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:04',NULL,NULL),(6596,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:09',NULL,NULL),(11457,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:27',NULL,NULL),(4472,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:30',NULL,NULL),(9352,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:37',NULL,NULL),(14779,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:46',NULL,NULL),(16369,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:19',NULL,NULL),(18286,1863,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:15',NULL,NULL),(19411,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:57',NULL,NULL),(23729,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 19:29:57',NULL,NULL),(993,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:16',NULL,NULL),(14598,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:55',NULL,NULL),(1316,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:41',NULL,NULL),(8311,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:20',NULL,NULL),(12602,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:48',NULL,NULL),(12296,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:25',NULL,NULL),(8065,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:12',NULL,NULL),(5523,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:59',NULL,NULL),(2207,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:08',NULL,NULL),(4171,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:12',NULL,NULL),(2734,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:24',NULL,NULL),(16271,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:03',NULL,NULL),(17715,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:36',NULL,NULL),(18550,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:28',NULL,NULL),(23503,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:26',NULL,NULL),(214,185,'2013-12-27','14:53:00','A','000',0,'2014-01-13 03:05:12',NULL,NULL),(7205,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:46',NULL,NULL),(14306,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:20',NULL,NULL),(3530,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:44',NULL,NULL),(12324,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:34',NULL,NULL),(10865,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:01',NULL,NULL),(9444,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:03',NULL,NULL),(18495,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:13',NULL,NULL),(19128,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:44',NULL,NULL),(22151,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:05',NULL,NULL),(22814,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:24',NULL,NULL),(8752,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:06',NULL,NULL),(13162,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:23',NULL,NULL),(12913,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:17',NULL,NULL),(12093,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:29',NULL,NULL),(9291,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:21',NULL,NULL),(2627,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:32:02',NULL,NULL),(5462,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:42',NULL,NULL),(7102,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:18',NULL,NULL),(3144,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:50',NULL,NULL),(17495,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:17',NULL,NULL),(18782,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:08',NULL,NULL),(21288,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:25',NULL,NULL),(2986,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:53',NULL,NULL),(12905,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:15',NULL,NULL),(12425,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:21:58',NULL,NULL),(9785,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:10',NULL,NULL),(2761,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:34',NULL,NULL),(9079,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:24',NULL,NULL),(17452,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:03',NULL,NULL),(18533,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:24',NULL,NULL),(22305,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:45',NULL,NULL),(6614,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:14',NULL,NULL),(3993,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:30',NULL,NULL),(13038,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:50',NULL,NULL),(22939,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:04',NULL,NULL),(23228,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(6968,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:52',NULL,NULL),(2995,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:56',NULL,NULL),(3824,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:48',NULL,NULL),(4106,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:02:00',NULL,NULL),(11618,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:07',NULL,NULL),(5059,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:06',NULL,NULL),(9529,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:04',NULL,NULL),(15614,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:35',NULL,NULL),(20603,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:33',NULL,NULL),(20896,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:06',NULL,NULL),(21683,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:14',NULL,NULL),(1513,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:54',NULL,NULL),(6507,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:59',NULL,NULL),(9959,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:55',NULL,NULL),(10451,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:55',NULL,NULL),(12604,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:48',NULL,NULL),(16556,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:30',NULL,NULL),(22003,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:08',NULL,NULL),(22469,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:39',NULL,NULL),(11307,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:46',NULL,NULL),(12990,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:38',NULL,NULL),(15590,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:27',NULL,NULL),(15828,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:22',NULL,NULL),(15962,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:10',NULL,NULL),(18769,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:04',NULL,NULL),(19699,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:18',NULL,NULL),(20848,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:53',NULL,NULL),(21056,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:50',NULL,NULL),(277,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:14',NULL,NULL),(10905,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:12',NULL,NULL),(650,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:18',NULL,NULL),(9589,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:19',NULL,NULL),(4285,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:41',NULL,NULL),(3712,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:19',NULL,NULL),(4395,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:10',NULL,NULL),(6847,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:15',NULL,NULL),(6517,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:02',NULL,NULL),(17614,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:59',NULL,NULL),(18890,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:37',NULL,NULL),(19244,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:09',NULL,NULL),(19878,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:49',NULL,NULL),(20328,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:53',NULL,NULL),(20714,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:15',NULL,NULL),(21186,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:48',NULL,NULL),(21501,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:44',NULL,NULL),(22887,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:48',NULL,NULL),(23489,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:22',NULL,NULL),(330,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:32',NULL,NULL),(10806,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:46',NULL,NULL),(9666,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:39',NULL,NULL),(901,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:51',NULL,NULL),(6551,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:11',NULL,NULL),(3728,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:24',NULL,NULL),(5900,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:48',NULL,NULL),(15924,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:57',NULL,NULL),(16477,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:01',NULL,NULL),(22685,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:35',NULL,NULL),(2898,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:22',NULL,NULL),(5717,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:00:45',NULL,NULL),(5841,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:28',NULL,NULL),(3242,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:26',NULL,NULL),(7539,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:03',NULL,NULL),(17497,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:17',NULL,NULL),(17564,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:40',NULL,NULL),(17675,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:22',NULL,NULL),(20372,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:09',NULL,NULL),(22337,1878,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:30:54',NULL,NULL),(22502,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:50',NULL,NULL),(23089,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(23185,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:51',NULL,NULL),(1977,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:34',NULL,NULL),(14626,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:04',NULL,NULL),(11808,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:56',NULL,NULL),(9178,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:51',NULL,NULL),(8806,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:20',NULL,NULL),(3867,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:59',NULL,NULL),(5446,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:38',NULL,NULL),(8239,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:58',NULL,NULL),(16567,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:34',NULL,NULL),(17872,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:10',NULL,NULL),(22775,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:08',NULL,NULL),(23641,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 20:00:02',NULL,NULL),(578,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:55',NULL,NULL),(14624,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:03',NULL,NULL),(14434,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:10',NULL,NULL),(7928,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:47',NULL,NULL),(13726,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:55',NULL,NULL),(2659,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:11',NULL,NULL),(11383,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:08',NULL,NULL),(6834,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:12',NULL,NULL),(16545,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:26',NULL,NULL),(16680,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:19',NULL,NULL),(21522,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:51',NULL,NULL),(21532,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:55',NULL,NULL),(23596,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 20:30:03',NULL,NULL),(9663,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:38',NULL,NULL),(2142,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:15',NULL,NULL),(2783,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:41',NULL,NULL),(3008,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:01',NULL,NULL),(7091,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:14',NULL,NULL),(4300,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:45',NULL,NULL),(4714,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:29',NULL,NULL),(5196,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:28',NULL,NULL),(10757,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:34',NULL,NULL),(10231,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:53',NULL,NULL),(16142,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:16',NULL,NULL),(16541,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:24',NULL,NULL),(16749,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:43',NULL,NULL),(17025,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:06',NULL,NULL),(22993,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(23484,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:20',NULL,NULL),(23593,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 13:30:02',NULL,NULL),(1448,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:31',NULL,NULL),(8525,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:06',NULL,NULL),(8438,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:54',NULL,NULL),(14716,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:29',NULL,NULL),(1975,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:33',NULL,NULL),(10838,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:54',NULL,NULL),(7175,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:38',NULL,NULL),(3451,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:23',NULL,NULL),(16292,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:11',NULL,NULL),(19474,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:14',NULL,NULL),(20540,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:11',NULL,NULL),(22449,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:32',NULL,NULL),(3336,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:51',NULL,NULL),(3375,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:02',NULL,NULL),(3610,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:06',NULL,NULL),(4819,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:57',NULL,NULL),(5455,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:40',NULL,NULL),(13610,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:38',NULL,NULL),(13238,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:43',NULL,NULL),(9425,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:57',NULL,NULL),(9388,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:47',NULL,NULL),(9184,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:53',NULL,NULL),(8314,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:21',NULL,NULL),(6924,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:40',NULL,NULL),(8760,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:08',NULL,NULL),(20042,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:35',NULL,NULL),(2170,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:23',NULL,NULL),(8013,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:09',NULL,NULL),(14757,1851,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:40',NULL,NULL),(11055,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:33',NULL,NULL),(14380,1864,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:49:54',NULL,NULL),(13882,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:17',NULL,NULL),(21904,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:33',NULL,NULL),(21986,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:02',NULL,NULL),(22509,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:52',NULL,NULL),(22607,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:25',NULL,NULL),(239,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:02',NULL,NULL),(323,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:30',NULL,NULL),(8206,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:50',NULL,NULL),(4927,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:28',NULL,NULL),(11201,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:17',NULL,NULL),(11345,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:57',NULL,NULL),(18319,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:24',NULL,NULL),(20250,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:25',NULL,NULL),(20297,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:00:42',NULL,NULL),(20512,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:00',NULL,NULL),(21428,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:16',NULL,NULL),(1380,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:06',NULL,NULL),(3580,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:58',NULL,NULL),(4024,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:38',NULL,NULL),(16433,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:44',NULL,NULL),(20551,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:15',NULL,NULL),(21419,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:13',NULL,NULL),(201,203,'2013-12-27','15:00:00','A','000',0,'2014-01-13 03:05:08',NULL,NULL),(16281,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:07',NULL,NULL),(13124,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:13',NULL,NULL),(10396,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:39',NULL,NULL),(12165,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:48',NULL,NULL),(7301,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:14',NULL,NULL),(4674,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:17',NULL,NULL),(6133,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:17',NULL,NULL),(2251,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:26',NULL,NULL),(20415,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:25',NULL,NULL),(7874,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:33',NULL,NULL),(6880,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:25',NULL,NULL),(1326,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:44',NULL,NULL),(14523,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:34',NULL,NULL),(14358,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:47',NULL,NULL),(3491,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:33',NULL,NULL),(9616,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:26',NULL,NULL),(17476,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:10',NULL,NULL),(17848,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:01',NULL,NULL),(18765,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:03',NULL,NULL),(19772,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:21',NULL,NULL),(20312,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:48',NULL,NULL),(21605,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:22',NULL,NULL),(23446,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:06',NULL,NULL),(2603,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:56',NULL,NULL),(14601,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:56',NULL,NULL),(1485,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:44',NULL,NULL),(11539,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:47',NULL,NULL),(12834,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:56',NULL,NULL),(14869,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:10',NULL,NULL),(15279,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:07',NULL,NULL),(16338,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:08',NULL,NULL),(18622,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:48',NULL,NULL),(18823,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:19',NULL,NULL),(18960,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:58',NULL,NULL),(21880,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:24',NULL,NULL),(22176,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:12',NULL,NULL),(23299,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:14',NULL,NULL),(23566,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 23:30:02',NULL,NULL),(42,187,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:39',NULL,NULL),(13669,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:46',NULL,NULL),(13554,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:30',NULL,NULL),(12637,1842,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:57',NULL,NULL),(963,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:07',NULL,NULL),(1136,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:54',NULL,NULL),(1143,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:56',NULL,NULL),(6454,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:45',NULL,NULL),(1612,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:29',NULL,NULL),(8203,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:49',NULL,NULL),(15326,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:17',NULL,NULL),(18822,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:18',NULL,NULL),(19527,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:29',NULL,NULL),(21324,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:38',NULL,NULL),(23495,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:23',NULL,NULL),(4180,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:14',NULL,NULL),(13947,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:26',NULL,NULL),(8057,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:10',NULL,NULL),(8512,1872,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:02',NULL,NULL),(15316,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:15',NULL,NULL),(15715,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:09',NULL,NULL),(16156,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:21',NULL,NULL),(17409,1876,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:00:49',NULL,NULL),(23293,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:12',NULL,NULL),(8758,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:08',NULL,NULL),(14723,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:30',NULL,NULL),(14452,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:15',NULL,NULL),(14252,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:13',NULL,NULL),(11762,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:45',NULL,NULL),(10104,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:19',NULL,NULL),(9924,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:46',NULL,NULL),(9739,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:58',NULL,NULL),(180,303,'2013-12-27','15:36:00','A','000',0,'2014-01-13 03:05:01',NULL,NULL),(363,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:43',NULL,NULL),(6996,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:00',NULL,NULL),(959,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:06',NULL,NULL),(19190,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:03',NULL,NULL),(21417,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:12',NULL,NULL),(568,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:52',NULL,NULL),(14287,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:18',NULL,NULL),(749,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:09',NULL,NULL),(11497,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:37',NULL,NULL),(9152,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:45',NULL,NULL),(1973,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:33',NULL,NULL),(9699,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:48',NULL,NULL),(9537,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:06',NULL,NULL),(7053,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:02',NULL,NULL),(4076,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:52',NULL,NULL),(3827,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:49',NULL,NULL),(3735,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:25',NULL,NULL),(7365,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:32',NULL,NULL),(15524,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:05',NULL,NULL),(17141,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:44',NULL,NULL),(18564,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:32',NULL,NULL),(21606,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:23',NULL,NULL),(818,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:28',NULL,NULL),(15107,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:23',NULL,NULL),(12252,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:13',NULL,NULL),(1962,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:30',NULL,NULL),(8708,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:54',NULL,NULL),(4193,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:18',NULL,NULL),(9794,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:12',NULL,NULL),(7894,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:38',NULL,NULL),(16682,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:20',NULL,NULL),(17686,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:26',NULL,NULL),(21085,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:57',NULL,NULL),(1416,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:19',NULL,NULL),(13623,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:40',NULL,NULL),(2764,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:35',NULL,NULL),(8403,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:45',NULL,NULL),(3566,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:54',NULL,NULL),(7090,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:14',NULL,NULL),(15397,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:30',NULL,NULL),(15678,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:57',NULL,NULL),(17389,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:42',NULL,NULL),(20474,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:46',NULL,NULL),(9457,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:06',NULL,NULL),(9295,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:22',NULL,NULL),(14577,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:49',NULL,NULL),(14178,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:01',NULL,NULL),(5670,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:29',NULL,NULL),(13034,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:49',NULL,NULL),(12599,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:47',NULL,NULL),(2894,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:20',NULL,NULL),(10799,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:44',NULL,NULL),(7207,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:47',NULL,NULL),(1918,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:56',NULL,NULL),(13301,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:00',NULL,NULL),(13233,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:42',NULL,NULL),(13175,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:27',NULL,NULL),(6428,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:38',NULL,NULL),(12301,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:27',NULL,NULL),(17373,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:37',NULL,NULL),(17378,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:39',NULL,NULL),(19581,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:44',NULL,NULL),(20007,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:25',NULL,NULL),(774,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:16',NULL,NULL),(12984,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:36',NULL,NULL),(16683,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:20',NULL,NULL),(21971,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:57',NULL,NULL),(240,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:02',NULL,NULL),(15510,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:00',NULL,NULL),(952,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:04',NULL,NULL),(1848,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:39',NULL,NULL),(12447,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:05',NULL,NULL),(11688,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:25',NULL,NULL),(11365,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:03',NULL,NULL),(11040,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:28',NULL,NULL),(10029,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:58',NULL,NULL),(15835,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:25',NULL,NULL),(20476,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:47',NULL,NULL),(23149,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(1190,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:09',NULL,NULL),(14481,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:23',NULL,NULL),(4737,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:35',NULL,NULL),(15513,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:01',NULL,NULL),(11401,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:13',NULL,NULL),(11994,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:03',NULL,NULL),(16851,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:20',NULL,NULL),(17450,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:02',NULL,NULL),(19856,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:43',NULL,NULL),(20109,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:53',NULL,NULL),(21230,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:05',NULL,NULL),(21754,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:40',NULL,NULL),(23707,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 23:30:00',NULL,NULL),(574,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:54',NULL,NULL),(11862,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:10',NULL,NULL),(1165,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:02',NULL,NULL),(6806,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:04',NULL,NULL),(7035,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:10',NULL,NULL),(9788,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:11',NULL,NULL),(21059,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:51',NULL,NULL),(21379,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:58',NULL,NULL),(23562,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 15:30:02',NULL,NULL),(117,320,'2013-12-27','15:43:00','A','000',0,'2014-01-13 03:04:41',NULL,NULL),(10871,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:03',NULL,NULL),(9901,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:41',NULL,NULL),(3575,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:56',NULL,NULL),(7587,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:15',NULL,NULL),(17098,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:30',NULL,NULL),(17884,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:14',NULL,NULL),(18502,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:15',NULL,NULL),(20252,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:26',NULL,NULL),(393,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:53',NULL,NULL),(1524,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:57',NULL,NULL),(5930,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:58',NULL,NULL),(12086,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:27',NULL,NULL),(15235,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:01:59',NULL,NULL),(16505,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:11',NULL,NULL),(21649,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:02',NULL,NULL),(7742,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:55',NULL,NULL),(5646,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:20',NULL,NULL),(15845,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:29',NULL,NULL),(15609,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:33',NULL,NULL),(15424,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:35',NULL,NULL),(15380,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:27',NULL,NULL),(3188,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:10',NULL,NULL),(11737,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:38',NULL,NULL),(11998,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:04',NULL,NULL),(17603,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:55',NULL,NULL),(19460,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:10',NULL,NULL),(19736,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:12',NULL,NULL),(19949,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:08',NULL,NULL),(20509,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:59',NULL,NULL),(20942,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:18',NULL,NULL),(9660,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:38',NULL,NULL),(7796,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:10',NULL,NULL),(7099,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:18',NULL,NULL),(12335,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:38',NULL,NULL),(2466,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:21',NULL,NULL),(6139,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:20',NULL,NULL),(4233,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:28',NULL,NULL),(5714,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:44',NULL,NULL),(5992,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:20',NULL,NULL),(23162,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:47',NULL,NULL),(6448,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:44',NULL,NULL),(5273,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:49',NULL,NULL),(13507,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:23',NULL,NULL),(11037,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:27',NULL,NULL),(4488,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:34',NULL,NULL),(2655,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:10',NULL,NULL),(2247,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:25',NULL,NULL),(16221,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:44',NULL,NULL),(20058,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:39',NULL,NULL),(21007,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:36',NULL,NULL),(23078,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(7280,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:08',NULL,NULL),(15433,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:37',NULL,NULL),(14965,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:36',NULL,NULL),(4750,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:39',NULL,NULL),(11353,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:59',NULL,NULL),(12518,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:25',NULL,NULL),(11550,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:50',NULL,NULL),(11521,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:43',NULL,NULL),(18597,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:41',NULL,NULL),(20975,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:28',NULL,NULL),(205,224,'2013-12-27','15:11:00','A','000',0,'2014-01-13 03:05:09',NULL,NULL),(16052,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:42',NULL,NULL),(15896,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:47',NULL,NULL),(14373,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:52',NULL,NULL),(12964,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:31',NULL,NULL),(12384,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:51',NULL,NULL),(8685,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:48',NULL,NULL),(7127,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:26',NULL,NULL),(1938,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:01',NULL,NULL),(10820,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:50',NULL,NULL),(375,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:47',NULL,NULL),(16403,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:33',NULL,NULL),(7547,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:05',NULL,NULL),(12269,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:17',NULL,NULL),(5811,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:17',NULL,NULL),(16636,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:01',NULL,NULL),(21358,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:51',NULL,NULL),(22451,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:33',NULL,NULL),(22908,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:55',NULL,NULL),(1930,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:59',NULL,NULL),(9992,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:48',NULL,NULL),(7112,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:21',NULL,NULL),(13210,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:36',NULL,NULL),(13126,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:14',NULL,NULL),(12250,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:12',NULL,NULL),(12214,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:02',NULL,NULL),(11992,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:02',NULL,NULL),(5250,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:43',NULL,NULL),(18161,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:49',NULL,NULL),(18264,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:08',NULL,NULL),(21302,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:30',NULL,NULL),(23277,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:08',NULL,NULL),(895,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:49',NULL,NULL),(21874,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:22',NULL,NULL),(21935,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:44',NULL,NULL),(22419,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:22',NULL,NULL),(23117,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(5488,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:49',NULL,NULL),(13744,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:57',NULL,NULL),(921,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:56',NULL,NULL),(12539,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:31',NULL,NULL),(10795,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:45:43',NULL,NULL),(10108,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:20',NULL,NULL),(3162,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:03',NULL,NULL),(3573,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:56',NULL,NULL),(3202,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:14',NULL,NULL),(3769,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:34',NULL,NULL),(20696,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:10',NULL,NULL),(23002,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:17',NULL,NULL),(8266,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:05',NULL,NULL),(11903,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:20',NULL,NULL),(5838,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:27',NULL,NULL),(3411,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:12',NULL,NULL),(3704,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-23 23:00:17',NULL,NULL),(15536,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:09',NULL,NULL),(17407,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:48',NULL,NULL),(19482,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:16',NULL,NULL),(19501,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:21',NULL,NULL),(22295,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:43',NULL,NULL),(22687,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:36',NULL,NULL),(5675,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:30',NULL,NULL),(12153,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:45',NULL,NULL),(1843,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:37',NULL,NULL),(2390,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:01',NULL,NULL),(11613,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:06',NULL,NULL),(9309,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:26',NULL,NULL),(9048,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:15',NULL,NULL),(4185,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:16',NULL,NULL),(5061,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:06',NULL,NULL),(3379,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:03',NULL,NULL),(16644,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:05',NULL,NULL),(19853,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:42',NULL,NULL),(19927,1869,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:31:01',NULL,NULL),(20149,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:05',NULL,NULL),(20977,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:28',NULL,NULL),(1733,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:11',NULL,NULL),(12896,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:12',NULL,NULL),(12607,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:49',NULL,NULL),(5640,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:18',NULL,NULL),(2021,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:46',NULL,NULL),(2777,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:39',NULL,NULL),(15197,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:52',NULL,NULL),(17060,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:18',NULL,NULL),(21865,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:19',NULL,NULL),(1679,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:54',NULL,NULL),(3733,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:25',NULL,NULL),(14034,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:40',NULL,NULL),(12053,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:18',NULL,NULL),(9602,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:23',NULL,NULL),(4652,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:11',NULL,NULL),(17290,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:09',NULL,NULL),(20251,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:25',NULL,NULL),(21497,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:42',NULL,NULL),(22092,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:40',NULL,NULL),(682,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:30',NULL,NULL),(8215,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:52',NULL,NULL),(9815,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:18',NULL,NULL),(14308,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:21',NULL,NULL),(13943,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:26',NULL,NULL),(13016,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:44',NULL,NULL),(8132,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:30',NULL,NULL),(12661,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:04',NULL,NULL),(11245,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:30',NULL,NULL),(3316,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:46',NULL,NULL),(4330,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:52',NULL,NULL),(5498,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:52',NULL,NULL),(18040,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:08',NULL,NULL),(18509,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:17',NULL,NULL),(19673,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:11',NULL,NULL),(20581,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:25',NULL,NULL),(20781,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:34',NULL,NULL),(22085,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:37',NULL,NULL),(22340,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:55',NULL,NULL),(22614,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:27',NULL,NULL),(194,240,'2013-12-27','15:16:00','A','000',0,'2014-01-13 03:05:06',NULL,NULL),(14284,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:17',NULL,NULL),(6884,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:26',NULL,NULL),(2727,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:22',NULL,NULL),(9181,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:52',NULL,NULL),(17784,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:38',NULL,NULL),(20761,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:28',NULL,NULL),(21249,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:11',NULL,NULL),(21920,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:39',NULL,NULL),(23431,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:00',NULL,NULL),(2911,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:26',NULL,NULL),(14385,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:49:55',NULL,NULL),(3043,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:15',NULL,NULL),(11321,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:49',NULL,NULL),(19002,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:10',NULL,NULL),(19809,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:31',NULL,NULL),(22316,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:48',NULL,NULL),(22545,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:03',NULL,NULL),(6750,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:48',NULL,NULL),(11320,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:49',NULL,NULL),(5855,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:32',NULL,NULL),(2870,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:12',NULL,NULL),(2342,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:49',NULL,NULL),(15905,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:50',NULL,NULL),(20226,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:16',NULL,NULL),(22631,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:17',NULL,NULL),(22951,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:07',NULL,NULL),(8754,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:06',NULL,NULL),(1626,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:33',NULL,NULL),(3048,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:17',NULL,NULL),(12069,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:23',NULL,NULL),(15318,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:15',NULL,NULL),(15324,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:16',NULL,NULL),(15705,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:06',NULL,NULL),(18473,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:07',NULL,NULL),(19439,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:05',NULL,NULL),(23539,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 17:30:02',NULL,NULL),(549,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:46',NULL,NULL),(13500,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:22',NULL,NULL),(4547,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:49',NULL,NULL),(9448,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:04',NULL,NULL),(2631,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:32:03',NULL,NULL),(15127,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:30',NULL,NULL),(20683,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:05',NULL,NULL),(22179,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:13',NULL,NULL),(22622,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:30',NULL,NULL),(22794,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:16',NULL,NULL),(22995,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(23031,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:22',NULL,NULL),(349,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:38',NULL,NULL),(15033,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:59',NULL,NULL),(1608,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:27',NULL,NULL),(5737,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:52',NULL,NULL),(11348,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:58',NULL,NULL),(15632,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:41',NULL,NULL),(17440,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:59',NULL,NULL),(22747,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:57',NULL,NULL),(8074,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:15',NULL,NULL),(1237,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:11',NULL,NULL),(10501,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:27',NULL,NULL),(1535,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:01',NULL,NULL),(3465,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:26',NULL,NULL),(1896,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:51',NULL,NULL),(16164,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:24',NULL,NULL),(17100,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:31',NULL,NULL),(1781,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:22',NULL,NULL),(14823,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:58',NULL,NULL),(8284,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:11',NULL,NULL),(9458,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:06',NULL,NULL),(17530,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:28',NULL,NULL),(18132,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:39',NULL,NULL),(1899,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:51',NULL,NULL),(14739,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:35',NULL,NULL),(14500,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:28',NULL,NULL),(12857,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:03',NULL,NULL),(11129,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:56',NULL,NULL),(2132,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:13',NULL,NULL),(9534,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:05',NULL,NULL),(7044,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:12',NULL,NULL),(3173,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:06',NULL,NULL),(8242,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:59',NULL,NULL),(16790,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:04',NULL,NULL),(20309,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:46',NULL,NULL),(20363,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:06',NULL,NULL),(20944,1851,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:31:19',NULL,NULL),(8852,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:32',NULL,NULL),(8367,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:36',NULL,NULL),(7197,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:44',NULL,NULL),(10641,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:03',NULL,NULL),(16155,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:21',NULL,NULL),(16794,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:05',NULL,NULL),(17588,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:49',NULL,NULL),(18361,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:35',NULL,NULL),(18482,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:09',NULL,NULL),(20413,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:24',NULL,NULL),(20720,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:16',NULL,NULL),(22944,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(23454,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:09',NULL,NULL),(6817,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:07',NULL,NULL),(1865,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:43',NULL,NULL),(15904,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:50',NULL,NULL),(17262,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:25',NULL,NULL),(17763,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:30',NULL,NULL),(19577,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:43',NULL,NULL),(20263,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:30',NULL,NULL),(7621,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:00:24',NULL,NULL),(9712,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:51',NULL,NULL),(2903,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:23',NULL,NULL),(12522,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:26',NULL,NULL),(11936,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:45',NULL,NULL),(2945,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:38',NULL,NULL),(3864,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:58',NULL,NULL),(5727,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:48',NULL,NULL),(5932,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:59',NULL,NULL),(5415,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:29',NULL,NULL),(5390,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:22',NULL,NULL),(6120,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:14',NULL,NULL),(9512,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:59',NULL,NULL),(21382,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:59',NULL,NULL),(22088,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:38',NULL,NULL),(1719,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:07',NULL,NULL),(15232,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:01:59',NULL,NULL),(7728,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:51',NULL,NULL),(12992,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:38',NULL,NULL),(12367,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:47',NULL,NULL),(3226,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:22',NULL,NULL),(4641,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:08',NULL,NULL),(11919,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:40',NULL,NULL),(11757,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:43',NULL,NULL),(7615,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:22',NULL,NULL),(7516,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:13',NULL,NULL),(17644,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:11',NULL,NULL),(23248,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(23254,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(123,206,'2013-12-27','15:02:00','A','000',0,'2014-01-13 03:04:43',NULL,NULL),(15699,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:04',NULL,NULL),(1701,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:03',NULL,NULL),(14813,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:55',NULL,NULL),(14670,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:16',NULL,NULL),(14649,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:10',NULL,NULL),(6415,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:34',NULL,NULL),(13595,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:36',NULL,NULL),(5218,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:34',NULL,NULL),(12568,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:38',NULL,NULL),(13511,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:24',NULL,NULL),(12808,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:46',NULL,NULL),(17001,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:58',NULL,NULL),(17698,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:30',NULL,NULL),(18628,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:49',NULL,NULL),(20704,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:12',NULL,NULL),(23150,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(2040,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:51',NULL,NULL),(15303,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:12',NULL,NULL),(13603,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:37',NULL,NULL),(12973,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:34',NULL,NULL),(3053,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:19',NULL,NULL),(10822,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:50',NULL,NULL),(3802,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:42',NULL,NULL),(4662,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:14',NULL,NULL),(10048,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:03',NULL,NULL),(16237,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:50',NULL,NULL),(16935,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:41',NULL,NULL),(20746,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:24',NULL,NULL),(8521,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:04',NULL,NULL),(14158,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:58',NULL,NULL),(1473,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:40',NULL,NULL),(11223,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:24',NULL,NULL),(7098,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:17',NULL,NULL),(3836,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:51',NULL,NULL),(3361,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:58',NULL,NULL),(17470,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:08',NULL,NULL),(19281,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:20',NULL,NULL),(20702,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:11',NULL,NULL),(8354,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:32',NULL,NULL),(705,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:38',NULL,NULL),(16724,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:34',NULL,NULL),(19408,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:57',NULL,NULL),(19935,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:04',NULL,NULL),(20681,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:04',NULL,NULL),(775,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:30:16',NULL,NULL),(12550,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:34',NULL,NULL),(10553,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:41',NULL,NULL),(4968,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:40',NULL,NULL),(4848,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:05',NULL,NULL),(8298,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:16',NULL,NULL),(13125,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:14',NULL,NULL),(13741,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:57',NULL,NULL),(13755,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:59',NULL,NULL),(16175,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:28',NULL,NULL),(17877,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:12',NULL,NULL),(18454,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:00',NULL,NULL),(19370,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:45',NULL,NULL),(19397,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:53',NULL,NULL),(22357,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:01',NULL,NULL),(22786,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:13',NULL,NULL),(23599,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 01:30:03',NULL,NULL),(5766,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:02',NULL,NULL),(12591,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:44',NULL,NULL),(12041,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:15',NULL,NULL),(11695,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:27',NULL,NULL),(5564,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:12',NULL,NULL),(8857,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:34',NULL,NULL),(3661,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:06',NULL,NULL),(8032,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:04',NULL,NULL),(7947,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:52',NULL,NULL),(17214,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:09',NULL,NULL),(17260,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:25',NULL,NULL),(18043,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:09',NULL,NULL),(21378,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:58',NULL,NULL),(6759,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:50',NULL,NULL),(4044,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:44',NULL,NULL),(1346,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-23 20:00:53',NULL,NULL),(13373,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:19',NULL,NULL),(13850,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:13',NULL,NULL),(14953,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:32',NULL,NULL),(16091,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:57',NULL,NULL),(18631,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:50',NULL,NULL),(23192,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:52',NULL,NULL),(1616,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:30',NULL,NULL),(12665,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:05',NULL,NULL),(12598,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:47',NULL,NULL),(11597,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:02',NULL,NULL),(4039,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:42',NULL,NULL),(10041,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:01',NULL,NULL),(5651,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:22',NULL,NULL),(5869,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:37',NULL,NULL),(13580,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:34',NULL,NULL),(18413,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:49',NULL,NULL),(22291,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:42',NULL,NULL),(22292,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:42',NULL,NULL),(23487,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:21',NULL,NULL),(7531,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:17',NULL,NULL),(10181,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:40',NULL,NULL),(5895,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:46',NULL,NULL),(7863,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:30',NULL,NULL),(17638,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:08',NULL,NULL),(18445,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:58',NULL,NULL),(19833,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:37',NULL,NULL),(20555,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:16',NULL,NULL),(22649,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:23',NULL,NULL),(23711,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 15:29:59',NULL,NULL),(55,354,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:51',NULL,NULL),(7106,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:20',NULL,NULL),(6591,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:08',NULL,NULL),(5810,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:17',NULL,NULL),(11710,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:31',NULL,NULL),(9305,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:25',NULL,NULL),(14088,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:48',NULL,NULL),(15799,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:37',NULL,NULL),(18798,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:12',NULL,NULL),(7220,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:50',NULL,NULL),(9950,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:53',NULL,NULL),(1394,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:11',NULL,NULL),(1748,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:14',NULL,NULL),(17833,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:56',NULL,NULL),(18891,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:37',NULL,NULL),(21011,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:37',NULL,NULL),(21534,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:56',NULL,NULL),(1090,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:42',NULL,NULL),(12006,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:06',NULL,NULL),(11954,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:50',NULL,NULL),(12043,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:16',NULL,NULL),(11651,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:16',NULL,NULL),(11128,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:56',NULL,NULL),(10843,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:55',NULL,NULL),(10194,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:44',NULL,NULL),(2470,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:22',NULL,NULL),(7096,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:16',NULL,NULL),(6204,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:38',NULL,NULL),(4425,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:18',NULL,NULL),(4469,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:30',NULL,NULL),(4921,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:26',NULL,NULL),(16232,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:48',NULL,NULL),(18365,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:36',NULL,NULL),(19181,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:00',NULL,NULL),(21058,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:50',NULL,NULL),(22052,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:25',NULL,NULL),(189,160,'2013-12-27','11:19:00','A','000',0,'2014-01-13 03:05:04',NULL,NULL),(228,238,'2013-12-27','15:15:00','A','000',0,'2014-01-13 03:05:17',NULL,NULL),(10875,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:04',NULL,NULL),(7827,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:19',NULL,NULL),(7433,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:50',NULL,NULL),(7887,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:36',NULL,NULL),(5129,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:10',NULL,NULL),(7309,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:17',NULL,NULL),(13798,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:05',NULL,NULL),(21448,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:24',NULL,NULL),(545,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:44',NULL,NULL),(5816,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:19',NULL,NULL),(11721,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:34',NULL,NULL),(11010,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:19',NULL,NULL),(1625,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:33',NULL,NULL),(10551,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:41',NULL,NULL),(5592,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:20',NULL,NULL),(4671,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:17',NULL,NULL),(14709,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:27',NULL,NULL),(15245,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:01',NULL,NULL),(18976,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:03',NULL,NULL),(20579,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:24',NULL,NULL),(20921,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:13',NULL,NULL),(21939,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:46',NULL,NULL),(23259,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(23393,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:48',NULL,NULL),(3854,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:55',NULL,NULL),(5893,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:45',NULL,NULL),(12304,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:28',NULL,NULL),(5586,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:18',NULL,NULL),(4880,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:14',NULL,NULL),(14083,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:47',NULL,NULL),(14231,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:09',NULL,NULL),(17761,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:29',NULL,NULL),(18063,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:16',NULL,NULL),(22651,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:24',NULL,NULL),(22697,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:40',NULL,NULL),(7622,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:24',NULL,NULL),(7619,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:23',NULL,NULL),(13763,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:00',NULL,NULL),(1532,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:00',NULL,NULL),(8876,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:39',NULL,NULL),(6236,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:46',NULL,NULL),(2540,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:40',NULL,NULL),(5126,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:09',NULL,NULL),(15403,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:31',NULL,NULL),(16119,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:08',NULL,NULL),(17506,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:20',NULL,NULL),(18045,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:10',NULL,NULL),(19085,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:32',NULL,NULL),(19567,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:40',NULL,NULL),(20222,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:15',NULL,NULL),(23131,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(14,333,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:14',NULL,NULL),(13466,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:17',NULL,NULL),(13387,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:04',NULL,NULL),(13213,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:37',NULL,NULL),(2380,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:59',NULL,NULL),(18814,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:16',NULL,NULL),(19039,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:20',NULL,NULL),(20074,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:44',NULL,NULL),(2900,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:22',NULL,NULL),(10178,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:39',NULL,NULL),(14445,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:13',NULL,NULL),(14964,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:36',NULL,NULL),(15643,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:44',NULL,NULL),(1164,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:02',NULL,NULL),(13366,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:17',NULL,NULL),(12008,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:06',NULL,NULL),(8030,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:03',NULL,NULL),(10985,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:13',NULL,NULL),(4382,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:07',NULL,NULL),(9255,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:12',NULL,NULL),(15408,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:32',NULL,NULL),(17208,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:07',NULL,NULL),(21474,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:33',NULL,NULL),(716,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:42',NULL,NULL),(2831,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:58',NULL,NULL),(10631,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:01',NULL,NULL),(10372,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:33',NULL,NULL),(9358,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:39',NULL,NULL),(8979,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:07',NULL,NULL),(7764,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:01',NULL,NULL),(13806,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:06',NULL,NULL),(6104,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:10',NULL,NULL),(14524,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:35',NULL,NULL),(16199,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:36',NULL,NULL),(16902,1897,'2014-01-14','23:11:00','A','000',0,'2014-01-24 06:30:33',NULL,NULL),(17042,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:12',NULL,NULL),(20255,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:27',NULL,NULL),(20630,1877,'2014-01-14','23:11:00','A','000',0,'2014-01-24 09:02:43',NULL,NULL),(21353,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:49',NULL,NULL),(7576,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:12',NULL,NULL),(2666,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-23 21:32:13',NULL,NULL),(13098,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:06',NULL,NULL),(11986,1853,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:19:00',NULL,NULL),(11799,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:54',NULL,NULL),(10480,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:22',NULL,NULL),(3793,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:40',NULL,NULL),(14714,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:28',NULL,NULL),(15563,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:18',NULL,NULL),(16254,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:57',NULL,NULL),(16995,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:55',NULL,NULL),(20484,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:50',NULL,NULL),(23013,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(8572,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:18',NULL,NULL),(14063,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:44',NULL,NULL),(872,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:43',NULL,NULL),(1667,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:49',NULL,NULL),(2339,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:48',NULL,NULL),(3546,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:48',NULL,NULL),(3096,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:34',NULL,NULL),(5047,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:02',NULL,NULL),(15779,1877,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:04:31',NULL,NULL),(16277,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:05',NULL,NULL),(21498,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:43',NULL,NULL),(22150,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:05',NULL,NULL),(8188,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:45',NULL,NULL),(14223,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:08',NULL,NULL),(6370,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:22',NULL,NULL),(9592,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:20',NULL,NULL),(10677,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:14',NULL,NULL),(12127,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:38',NULL,NULL),(12067,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:22',NULL,NULL),(18634,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:51',NULL,NULL),(20532,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:08',NULL,NULL),(20940,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:18',NULL,NULL),(21575,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:11',NULL,NULL),(22399,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:15',NULL,NULL),(1172,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:04',NULL,NULL),(12441,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:03',NULL,NULL),(14634,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:06',NULL,NULL),(8292,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:14',NULL,NULL),(2405,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:05',NULL,NULL),(10016,1873,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:39:55',NULL,NULL),(4320,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:49',NULL,NULL),(2462,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:20',NULL,NULL),(2720,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:19',NULL,NULL),(7968,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:57',NULL,NULL),(15240,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:00',NULL,NULL),(16758,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:47',NULL,NULL),(18148,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:44',NULL,NULL),(18419,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:51',NULL,NULL),(18558,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:30',NULL,NULL),(18848,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:26',NULL,NULL),(23627,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 20:00:02',NULL,NULL),(23671,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 15:29:59',NULL,NULL),(6941,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:45',NULL,NULL),(5740,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:53',NULL,NULL),(2178,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:25',NULL,NULL),(4654,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:11',NULL,NULL),(14992,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:45',NULL,NULL),(18092,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:26',NULL,NULL),(18458,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:02',NULL,NULL),(22350,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:59',NULL,NULL),(229,172,'2013-12-27','14:45:00','A','000',0,'2014-01-13 03:05:17',NULL,NULL),(2570,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:47',NULL,NULL),(10091,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:15',NULL,NULL),(9903,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:41',NULL,NULL),(7159,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:34',NULL,NULL),(3106,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:37',NULL,NULL),(7608,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:20',NULL,NULL),(12680,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:10',NULL,NULL),(13470,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:18',NULL,NULL),(14300,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:19',NULL,NULL),(16342,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:09',NULL,NULL),(16408,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:35',NULL,NULL),(16502,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:10',NULL,NULL),(17812,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:48',NULL,NULL),(1691,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:02:58',NULL,NULL),(4240,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:29',NULL,NULL),(10162,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:35',NULL,NULL),(9817,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:19',NULL,NULL),(7006,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:02',NULL,NULL),(13784,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:03',NULL,NULL),(14688,1837,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:21',NULL,NULL),(20743,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:23',NULL,NULL),(21590,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:17',NULL,NULL),(4735,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:35',NULL,NULL),(12161,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:47',NULL,NULL),(11302,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:44',NULL,NULL),(11280,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:39',NULL,NULL),(8364,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:35',NULL,NULL),(3525,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:43',NULL,NULL),(7942,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:50',NULL,NULL),(6687,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:32',NULL,NULL),(19997,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:22',NULL,NULL),(5136,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:11',NULL,NULL),(1572,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:02:14',NULL,NULL),(12801,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:44',NULL,NULL),(13247,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:46',NULL,NULL),(16365,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:18',NULL,NULL),(19037,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:19',NULL,NULL),(19437,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:04',NULL,NULL),(20068,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:42',NULL,NULL),(21432,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:18',NULL,NULL),(21773,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:47',NULL,NULL),(6051,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:41',NULL,NULL),(11236,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:27',NULL,NULL),(10785,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:41',NULL,NULL),(10252,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:59',NULL,NULL),(2925,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:31',NULL,NULL),(7648,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:31',NULL,NULL),(7178,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:39',NULL,NULL),(7055,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:02',NULL,NULL),(3367,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:00',NULL,NULL),(4552,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:50',NULL,NULL),(14476,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:22',NULL,NULL),(17842,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:59',NULL,NULL),(20104,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:52',NULL,NULL),(22272,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:37',NULL,NULL),(441,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:10',NULL,NULL),(970,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:09',NULL,NULL),(4055,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:47',NULL,NULL),(9150,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:44',NULL,NULL),(15507,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:59',NULL,NULL),(15701,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:04',NULL,NULL),(22015,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:12',NULL,NULL),(22874,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:44',NULL,NULL),(5843,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:28',NULL,NULL),(7889,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:37',NULL,NULL),(10229,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:53',NULL,NULL),(10531,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:35',NULL,NULL),(16035,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:36',NULL,NULL),(19893,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:52',NULL,NULL),(22605,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:24',NULL,NULL),(6011,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:27',NULL,NULL),(4253,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:33',NULL,NULL),(9073,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:23',NULL,NULL),(10852,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:57',NULL,NULL),(12886,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:14',NULL,NULL),(14816,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:56',NULL,NULL),(15790,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:35',NULL,NULL),(16651,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:08',NULL,NULL),(17886,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:15',NULL,NULL),(19621,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:55',NULL,NULL),(19795,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:27',NULL,NULL),(20100,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:51',NULL,NULL),(20958,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:23',NULL,NULL),(22012,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:11',NULL,NULL),(22054,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:26',NULL,NULL),(7513,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:12',NULL,NULL),(8434,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:53',NULL,NULL),(12719,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:22',NULL,NULL),(11338,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:54',NULL,NULL),(12393,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:54',NULL,NULL),(11732,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:37',NULL,NULL),(13848,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:12',NULL,NULL),(15230,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:58',NULL,NULL),(20489,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:52',NULL,NULL),(20901,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:08',NULL,NULL),(741,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:07',NULL,NULL),(3574,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:56',NULL,NULL),(8045,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:07',NULL,NULL),(10960,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:06',NULL,NULL),(10645,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:04',NULL,NULL),(9200,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:57',NULL,NULL),(13844,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:12',NULL,NULL),(16438,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:46',NULL,NULL),(19135,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:47',NULL,NULL),(19661,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:08',NULL,NULL),(21285,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:24',NULL,NULL),(23354,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:35',NULL,NULL),(769,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:14',NULL,NULL),(13201,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:33',NULL,NULL),(12245,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:11',NULL,NULL),(7508,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:11',NULL,NULL),(11101,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:49',NULL,NULL),(10664,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:11',NULL,NULL),(9066,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:21',NULL,NULL),(9053,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:17',NULL,NULL),(7086,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:30:13',NULL,NULL),(4661,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:14',NULL,NULL),(4907,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:22',NULL,NULL),(4246,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:31',NULL,NULL),(6449,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:44',NULL,NULL),(14518,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:33',NULL,NULL),(14761,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:41',NULL,NULL),(17436,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:57',NULL,NULL),(20360,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:05',NULL,NULL),(21469,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:31',NULL,NULL),(559,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:49',NULL,NULL),(6079,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:02',NULL,NULL),(12333,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:37',NULL,NULL),(10611,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:55',NULL,NULL),(1192,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:10',NULL,NULL),(10413,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:44',NULL,NULL),(5867,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:37',NULL,NULL),(5594,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:02',NULL,NULL),(3598,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:02',NULL,NULL),(4792,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:50',NULL,NULL),(14463,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:18',NULL,NULL),(19667,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:09',NULL,NULL),(22194,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:17',NULL,NULL),(906,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:52',NULL,NULL),(6229,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:44',NULL,NULL),(9953,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:54',NULL,NULL),(9902,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:41',NULL,NULL),(5695,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:37',NULL,NULL),(9356,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:38',NULL,NULL),(5647,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:21',NULL,NULL),(7978,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:00',NULL,NULL),(13552,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:30',NULL,NULL),(14258,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:14',NULL,NULL),(18937,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:51',NULL,NULL),(23415,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:55',NULL,NULL),(5505,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:54',NULL,NULL),(2257,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:27',NULL,NULL),(10475,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:21',NULL,NULL),(14470,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:20',NULL,NULL),(16185,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:31',NULL,NULL),(16406,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:34',NULL,NULL),(16614,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:52',NULL,NULL),(21412,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:11',NULL,NULL),(6932,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:43',NULL,NULL),(3138,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:48',NULL,NULL),(5083,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:02:12',NULL,NULL),(3156,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:54',NULL,NULL),(5151,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:16',NULL,NULL),(3184,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:09',NULL,NULL),(19497,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:20',NULL,NULL),(19625,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:56',NULL,NULL),(20022,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:29',NULL,NULL),(22082,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:36',NULL,NULL),(302,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:22',NULL,NULL),(12994,1838,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:26:39',NULL,NULL),(12489,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:17',NULL,NULL),(617,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:08',NULL,NULL),(7916,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:44',NULL,NULL),(2407,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:06',NULL,NULL),(5413,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:29',NULL,NULL),(4503,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:38',NULL,NULL),(15412,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:33',NULL,NULL),(17159,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:50',NULL,NULL),(18806,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:14',NULL,NULL),(19069,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:28',NULL,NULL),(20844,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:52',NULL,NULL),(22608,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:25',NULL,NULL),(7002,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:01',NULL,NULL),(1499,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:49',NULL,NULL),(9498,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:56',NULL,NULL),(13576,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:33',NULL,NULL),(14717,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:29',NULL,NULL),(20823,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:46',NULL,NULL),(21799,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:56',NULL,NULL),(7981,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:00',NULL,NULL),(1101,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:45',NULL,NULL),(1155,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:00',NULL,NULL),(2472,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:23',NULL,NULL),(2826,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:56',NULL,NULL),(8335,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:27',NULL,NULL),(4023,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:38',NULL,NULL),(4752,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:39',NULL,NULL),(17058,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:17',NULL,NULL),(17503,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:19',NULL,NULL),(17637,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:07',NULL,NULL),(18306,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:21',NULL,NULL),(21185,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:48',NULL,NULL),(23135,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(301,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:22',NULL,NULL),(735,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:05',NULL,NULL),(12233,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:08',NULL,NULL),(1467,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:38',NULL,NULL),(10807,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:46',NULL,NULL),(10577,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:47',NULL,NULL),(10454,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:56',NULL,NULL),(4512,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:40',NULL,NULL),(1750,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:15',NULL,NULL),(14207,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:05',NULL,NULL),(16405,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:34',NULL,NULL),(18463,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:04',NULL,NULL),(21731,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:32',NULL,NULL),(22299,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:44',NULL,NULL),(7457,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:58',NULL,NULL),(20409,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:23',NULL,NULL),(20654,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:52',NULL,NULL),(22445,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:31',NULL,NULL),(8645,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:37',NULL,NULL),(10945,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:22',NULL,NULL),(15776,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:30',NULL,NULL),(16314,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:59',NULL,NULL),(18223,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:10',NULL,NULL),(19174,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:58',NULL,NULL),(19507,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:24',NULL,NULL),(20860,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:57',NULL,NULL),(21574,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:11',NULL,NULL),(23255,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:04',NULL,NULL),(23670,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 13:29:58',NULL,NULL),(522,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:37',NULL,NULL),(8280,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:09',NULL,NULL),(11549,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:50',NULL,NULL),(11089,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:46',NULL,NULL),(10250,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:58',NULL,NULL),(1694,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:59',NULL,NULL),(6185,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:33',NULL,NULL),(14191,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:03',NULL,NULL),(17358,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:32',NULL,NULL),(18720,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:14',NULL,NULL),(19375,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:47',NULL,NULL),(20762,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:29',NULL,NULL),(21341,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:44',NULL,NULL),(5767,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:02',NULL,NULL),(10774,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:38',NULL,NULL),(1104,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:45',NULL,NULL),(5381,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:20',NULL,NULL),(3644,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:32:16',NULL,NULL),(15906,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:51',NULL,NULL),(904,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:51',NULL,NULL),(925,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:57',NULL,NULL),(12385,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:52',NULL,NULL),(17195,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:02',NULL,NULL),(18859,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:29',NULL,NULL),(19436,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:04',NULL,NULL),(22447,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:32',NULL,NULL),(289,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:18',NULL,NULL),(371,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:46',NULL,NULL),(11248,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:30',NULL,NULL),(853,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:38',NULL,NULL),(3286,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:38',NULL,NULL),(1814,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:30',NULL,NULL),(12548,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:33',NULL,NULL),(20879,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:02',NULL,NULL),(21155,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:18',NULL,NULL),(22080,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:36',NULL,NULL),(6573,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:03',NULL,NULL),(6220,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:42',NULL,NULL),(2754,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:31',NULL,NULL),(7797,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:10',NULL,NULL),(7407,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:43',NULL,NULL),(12815,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:48',NULL,NULL),(13047,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:53',NULL,NULL),(15050,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:04',NULL,NULL),(15810,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:41',NULL,NULL),(17276,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:05',NULL,NULL),(22994,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:15',NULL,NULL),(23456,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:10',NULL,NULL),(1008,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:20',NULL,NULL),(6365,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:21',NULL,NULL),(8994,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:11',NULL,NULL),(10502,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:28',NULL,NULL),(4442,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:23',NULL,NULL),(14531,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:37',NULL,NULL),(16898,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-24 06:30:32',NULL,NULL),(45,299,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:42',NULL,NULL),(9503,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:57',NULL,NULL),(9243,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:09',NULL,NULL),(1175,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:05',NULL,NULL),(1684,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:56',NULL,NULL),(12445,1839,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:04',NULL,NULL),(13127,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:14',NULL,NULL),(14094,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:48',NULL,NULL),(14640,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:08',NULL,NULL),(15083,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:15',NULL,NULL),(20562,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:18',NULL,NULL),(21766,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:44',NULL,NULL),(21846,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:13',NULL,NULL),(23338,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:29',NULL,NULL),(4881,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:15',NULL,NULL),(1051,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:31',NULL,NULL),(10957,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:05',NULL,NULL),(10268,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:04',NULL,NULL),(9218,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:02',NULL,NULL),(3133,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:46',NULL,NULL),(4122,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:02:04',NULL,NULL),(4204,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:20',NULL,NULL),(4563,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:53',NULL,NULL),(14913,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:23',NULL,NULL),(15004,1889,'2014-01-14','23:11:00','A','000',0,'2014-01-24 06:00:49',NULL,NULL),(16351,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:13',NULL,NULL),(16439,1789,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:46',NULL,NULL),(18522,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:21',NULL,NULL),(637,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:14',NULL,NULL),(6206,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:38',NULL,NULL),(6199,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:37',NULL,NULL),(2505,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:31',NULL,NULL),(3862,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:57',NULL,NULL),(4135,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:03',NULL,NULL),(12534,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:29',NULL,NULL),(12676,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:08',NULL,NULL),(13978,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:31',NULL,NULL),(4190,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:17',NULL,NULL),(12222,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:04',NULL,NULL),(2299,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:38',NULL,NULL),(11371,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:04',NULL,NULL),(8199,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:48',NULL,NULL),(2441,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:15',NULL,NULL),(15062,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:08',NULL,NULL),(15117,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:27',NULL,NULL),(18086,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:24',NULL,NULL),(18433,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:55',NULL,NULL),(22068,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:31',NULL,NULL),(7166,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:36',NULL,NULL),(12429,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:00',NULL,NULL),(11709,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:31',NULL,NULL),(5802,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:14',NULL,NULL),(11436,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:22',NULL,NULL),(4898,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:19',NULL,NULL),(7395,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:40',NULL,NULL),(7491,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:07',NULL,NULL),(12749,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:30',NULL,NULL),(12856,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:03',NULL,NULL),(13719,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:54',NULL,NULL),(15706,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:06',NULL,NULL),(15908,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:51',NULL,NULL),(16303,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:17:55',NULL,NULL),(17837,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:58',NULL,NULL),(18133,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:39',NULL,NULL),(21902,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:32',NULL,NULL),(21955,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:51',NULL,NULL),(23114,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(237,276,'2013-12-27','15:30:00','A','000',0,'2014-01-13 03:05:20',NULL,NULL),(871,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:42',NULL,NULL),(11593,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:01',NULL,NULL),(11231,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:26',NULL,NULL),(10319,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:41:18',NULL,NULL),(3527,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:43',NULL,NULL),(9929,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:48',NULL,NULL),(8884,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:41',NULL,NULL),(15043,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:02',NULL,NULL),(16333,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:06',NULL,NULL),(22643,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:21',NULL,NULL),(6733,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:44',NULL,NULL),(10419,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:46',NULL,NULL),(10273,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:05',NULL,NULL),(1076,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:38',NULL,NULL),(13886,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:18',NULL,NULL),(15243,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:01',NULL,NULL),(15342,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:20',NULL,NULL),(16653,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:09',NULL,NULL),(18929,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:48',NULL,NULL),(19744,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:14',NULL,NULL),(20687,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:07',NULL,NULL),(20849,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:53',NULL,NULL),(23229,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(186,291,'2013-12-27','15:33:00','A','000',0,'2014-01-13 03:05:03',NULL,NULL),(12647,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:00',NULL,NULL),(11402,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:13',NULL,NULL),(10754,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:33',NULL,NULL),(9259,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:13',NULL,NULL),(6615,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:14',NULL,NULL),(4279,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:39',NULL,NULL),(6464,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:48',NULL,NULL),(2069,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:58',NULL,NULL),(5098,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:16',NULL,NULL),(12969,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:33',NULL,NULL),(13852,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:13',NULL,NULL),(14997,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:47',NULL,NULL),(15225,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:57',NULL,NULL),(18052,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:12',NULL,NULL),(429,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:01:06',NULL,NULL),(12726,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:24',NULL,NULL),(12085,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:27',NULL,NULL),(11272,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:37',NULL,NULL),(4813,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:56',NULL,NULL),(10522,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:33',NULL,NULL),(4533,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:46',NULL,NULL),(9464,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:08',NULL,NULL),(4513,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:40',NULL,NULL),(23234,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(23486,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:21',NULL,NULL),(629,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:12',NULL,NULL),(1049,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:31',NULL,NULL),(11813,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:58',NULL,NULL),(5731,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:50',NULL,NULL),(4694,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:24',NULL,NULL),(1854,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:40',NULL,NULL),(8680,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:47',NULL,NULL),(14185,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:02',NULL,NULL),(14211,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:06',NULL,NULL),(16313,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:59',NULL,NULL),(16458,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:54',NULL,NULL),(18232,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:13',NULL,NULL),(20199,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:07',NULL,NULL),(866,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:41',NULL,NULL),(10790,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:42',NULL,NULL),(9099,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:30',NULL,NULL),(13350,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:13',NULL,NULL),(13994,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:34',NULL,NULL),(17125,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:39',NULL,NULL),(37,243,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:35',NULL,NULL),(7057,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:03',NULL,NULL),(10704,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:21',NULL,NULL),(10385,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:37',NULL,NULL),(10107,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:20',NULL,NULL),(9421,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:56',NULL,NULL),(6866,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:21',NULL,NULL),(5991,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:20',NULL,NULL),(6719,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:40',NULL,NULL),(14334,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:27',NULL,NULL),(17234,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:16',NULL,NULL),(22149,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:05',NULL,NULL),(5526,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:00',NULL,NULL),(12859,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:04',NULL,NULL),(8209,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:50',NULL,NULL),(10453,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:55',NULL,NULL),(11683,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:24',NULL,NULL),(11456,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:27',NULL,NULL),(14332,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:27',NULL,NULL),(18089,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:25',NULL,NULL),(20782,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:34',NULL,NULL),(22757,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:02',NULL,NULL),(23215,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(658,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:21',NULL,NULL),(7520,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:14',NULL,NULL),(2073,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:59',NULL,NULL),(6623,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:16',NULL,NULL),(2647,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:08',NULL,NULL),(14561,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:45',NULL,NULL),(15344,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:20',NULL,NULL),(20891,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:05',NULL,NULL),(112,346,'2013-12-27','15:57:00','A','000',0,'2014-01-13 03:04:39',NULL,NULL),(7741,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:55',NULL,NULL),(13134,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:16',NULL,NULL),(3369,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:00',NULL,NULL),(12486,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:16',NULL,NULL),(4364,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:02',NULL,NULL),(5476,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:46',NULL,NULL),(11388,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:09',NULL,NULL),(9735,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:57',NULL,NULL),(8517,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:03',NULL,NULL),(15294,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:11',NULL,NULL),(18262,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:07',NULL,NULL),(20763,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:29',NULL,NULL),(21166,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:40',NULL,NULL),(5686,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:34',NULL,NULL),(4017,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:36',NULL,NULL),(3909,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:10',NULL,NULL),(12089,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:28',NULL,NULL),(11093,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:47',NULL,NULL),(2345,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:50',NULL,NULL),(2643,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:32:06',NULL,NULL),(9253,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:11',NULL,NULL),(8732,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:00',NULL,NULL),(3264,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:32',NULL,NULL),(5425,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:32',NULL,NULL),(3848,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:54',NULL,NULL),(3378,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:03',NULL,NULL),(3874,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:01',NULL,NULL),(4000,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:32',NULL,NULL),(2226,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:13',NULL,NULL),(14794,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:50',NULL,NULL),(14920,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:24',NULL,NULL),(14940,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:29',NULL,NULL),(16508,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:12',NULL,NULL),(16828,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:14',NULL,NULL),(19270,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:16',NULL,NULL),(22824,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:27',NULL,NULL),(22959,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(64,329,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:00',NULL,NULL),(12885,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:24:14',NULL,NULL),(498,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:29',NULL,NULL),(12373,1810,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:48',NULL,NULL),(9654,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:36',NULL,NULL),(4629,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:05',NULL,NULL),(676,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:28',NULL,NULL),(6951,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:47',NULL,NULL),(20979,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:29',NULL,NULL),(22168,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:10',NULL,NULL),(158,287,'2013-12-27','15:32:00','A','000',0,'2014-01-13 03:04:54',NULL,NULL),(8006,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:07',NULL,NULL),(12241,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:10',NULL,NULL),(5102,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:17',NULL,NULL),(4657,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:12',NULL,NULL),(6481,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:52',NULL,NULL),(2186,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:02',NULL,NULL),(2972,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:48',NULL,NULL),(18469,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:05',NULL,NULL),(21214,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:58',NULL,NULL),(6241,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:47',NULL,NULL),(11548,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:50',NULL,NULL),(10775,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:38',NULL,NULL),(9838,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:24',NULL,NULL),(17680,1895,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:02:24',NULL,NULL),(18352,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:33',NULL,NULL),(19049,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:22',NULL,NULL),(21593,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:18',NULL,NULL),(21859,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:17',NULL,NULL),(22573,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:13',NULL,NULL),(23207,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(1097,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:44',NULL,NULL),(11206,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:19',NULL,NULL),(4264,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:36',NULL,NULL),(6768,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:53',NULL,NULL),(7005,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:02',NULL,NULL),(7296,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:13',NULL,NULL),(12424,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:58',NULL,NULL),(18437,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:56',NULL,NULL),(19373,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:46',NULL,NULL),(19974,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:16',NULL,NULL),(154,325,'2013-12-27','15:46:00','A','000',0,'2014-01-13 03:04:52',NULL,NULL),(11088,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:45',NULL,NULL),(9401,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:50',NULL,NULL),(816,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:28',NULL,NULL),(2338,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:48',NULL,NULL),(7225,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:54',NULL,NULL),(14911,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:22',NULL,NULL),(17789,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:39',NULL,NULL),(19940,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:05',NULL,NULL),(22118,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:49',NULL,NULL),(306,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:00:24',NULL,NULL),(6875,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:23',NULL,NULL),(1368,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:02',NULL,NULL),(10591,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:50',NULL,NULL),(9734,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:57',NULL,NULL),(9110,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:33',NULL,NULL),(8625,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:32',NULL,NULL),(8550,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:12',NULL,NULL),(5308,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:00',NULL,NULL),(1480,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:42',NULL,NULL),(13840,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:11',NULL,NULL),(14880,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:13',NULL,NULL),(20496,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:54',NULL,NULL),(23637,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 12:00:02',NULL,NULL),(4192,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:17',NULL,NULL),(8055,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:10',NULL,NULL),(8822,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:24',NULL,NULL),(9524,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:02',NULL,NULL),(14749,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:37',NULL,NULL),(16989,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:54',NULL,NULL),(18032,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:05',NULL,NULL),(20158,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:07',NULL,NULL),(20378,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:12',NULL,NULL),(20937,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:17',NULL,NULL),(22298,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:44',NULL,NULL),(22470,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:39',NULL,NULL),(834,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:32',NULL,NULL),(5618,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:10',NULL,NULL),(10074,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:10',NULL,NULL),(9502,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:57',NULL,NULL),(3396,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:08',NULL,NULL),(7023,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:06',NULL,NULL),(3532,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:45',NULL,NULL),(13835,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:10',NULL,NULL),(18739,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:35:55',NULL,NULL),(19078,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:30',NULL,NULL),(19830,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:36',NULL,NULL),(21110,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:04',NULL,NULL),(23512,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:29',NULL,NULL),(62,337,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:58',NULL,NULL),(5775,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:05',NULL,NULL),(5694,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:37',NULL,NULL),(12149,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:44',NULL,NULL),(14460,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:18',NULL,NULL),(17722,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:38',NULL,NULL),(17732,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:41',NULL,NULL),(17841,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:59',NULL,NULL),(20506,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:58',NULL,NULL),(6883,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:26',NULL,NULL),(12240,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:10',NULL,NULL),(5507,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:54',NULL,NULL),(10966,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:07',NULL,NULL),(1400,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:13',NULL,NULL),(5395,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:24',NULL,NULL),(4764,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:42',NULL,NULL),(4277,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:39',NULL,NULL),(4675,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:18',NULL,NULL),(14520,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:34',NULL,NULL),(16756,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:46',NULL,NULL),(17022,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:05',NULL,NULL),(18389,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:43',NULL,NULL),(19004,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:10',NULL,NULL),(19070,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:28',NULL,NULL),(23556,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 20:00:02',NULL,NULL),(500,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:01:30',NULL,NULL),(12007,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:06',NULL,NULL),(11854,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:08',NULL,NULL),(11759,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:44',NULL,NULL),(11512,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:41',NULL,NULL),(11487,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:35',NULL,NULL),(5659,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:25',NULL,NULL),(7353,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:29',NULL,NULL),(3351,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:56',NULL,NULL),(13147,1891,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:27:19',NULL,NULL),(14268,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:15',NULL,NULL),(20578,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:24',NULL,NULL),(21775,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:47',NULL,NULL),(22153,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:06',NULL,NULL),(23357,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:36',NULL,NULL),(23408,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:53',NULL,NULL),(6075,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:50',NULL,NULL),(1827,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:34',NULL,NULL),(2121,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:10',NULL,NULL),(7883,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:35',NULL,NULL),(2454,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:18',NULL,NULL),(12923,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:20',NULL,NULL),(14330,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:26',NULL,NULL),(16786,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:03',NULL,NULL),(16857,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:21',NULL,NULL),(17138,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:43',NULL,NULL),(17242,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:18',NULL,NULL),(20425,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:29',NULL,NULL),(20987,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:31',NULL,NULL),(21061,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:51',NULL,NULL),(21157,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:18',NULL,NULL),(1117,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:49',NULL,NULL),(6556,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:32:12',NULL,NULL),(11148,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:01:01',NULL,NULL),(10463,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:18',NULL,NULL),(2785,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:42',NULL,NULL),(2791,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:44',NULL,NULL),(8882,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:40',NULL,NULL),(3782,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:38',NULL,NULL),(14889,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:16',NULL,NULL),(17170,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:54',NULL,NULL),(21646,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:38',NULL,NULL),(1092,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:42',NULL,NULL),(6523,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:03',NULL,NULL),(9506,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:35:58',NULL,NULL),(8130,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:29',NULL,NULL),(8745,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:04',NULL,NULL),(8277,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:08',NULL,NULL),(13574,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:33',NULL,NULL),(14844,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:04',NULL,NULL),(17344,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:27',NULL,NULL),(22033,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:18',NULL,NULL),(1863,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:42',NULL,NULL),(3147,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:51',NULL,NULL),(13547,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:29',NULL,NULL),(14954,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:33',NULL,NULL),(16711,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:30',NULL,NULL),(20077,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:44',NULL,NULL),(20157,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:07',NULL,NULL),(21806,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:58',NULL,NULL),(4200,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:19',NULL,NULL),(12194,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:56',NULL,NULL),(11349,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:58',NULL,NULL),(2609,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:58',NULL,NULL),(8220,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:53',NULL,NULL),(15844,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:28',NULL,NULL),(17074,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:23',NULL,NULL),(17277,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:05',NULL,NULL),(17796,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:42',NULL,NULL),(19103,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:37',NULL,NULL),(81,319,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:15',NULL,NULL),(7660,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:34',NULL,NULL),(7488,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:32:06',NULL,NULL),(11479,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:33',NULL,NULL),(5232,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:30:38',NULL,NULL),(9829,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:22',NULL,NULL),(18918,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:45',NULL,NULL),(20377,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:11',NULL,NULL),(23,355,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:22',NULL,NULL),(12356,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:44',NULL,NULL),(12351,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:43',NULL,NULL),(190,232,'2013-12-27','15:13:00','A','000',0,'2014-01-13 03:05:04',NULL,NULL),(6658,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:25',NULL,NULL),(9389,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:47',NULL,NULL),(8629,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:33',NULL,NULL),(3980,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:27',NULL,NULL),(2100,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:05',NULL,NULL),(16344,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:10',NULL,NULL),(16479,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:02',NULL,NULL),(17307,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:15',NULL,NULL),(21076,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:55',NULL,NULL),(7093,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:15',NULL,NULL),(12502,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:21',NULL,NULL),(11606,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:04',NULL,NULL),(10470,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:20',NULL,NULL),(10200,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:45',NULL,NULL),(5664,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:00:27',NULL,NULL),(4530,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:45',NULL,NULL),(4911,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:23',NULL,NULL),(15964,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:11',NULL,NULL),(20623,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:41',NULL,NULL),(242,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:03',NULL,NULL),(11655,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:17',NULL,NULL),(6578,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:05',NULL,NULL),(3564,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:53',NULL,NULL),(14851,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:06',NULL,NULL),(15038,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:00',NULL,NULL),(15419,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:34',NULL,NULL),(17248,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:20',NULL,NULL),(23209,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(1065,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:35',NULL,NULL),(9995,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:49',NULL,NULL),(2586,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:51',NULL,NULL),(3196,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:12',NULL,NULL),(6598,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:10',NULL,NULL),(12850,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:01',NULL,NULL),(12381,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:50',NULL,NULL),(4967,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:40',NULL,NULL),(8937,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:55',NULL,NULL),(5852,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:31',NULL,NULL),(13674,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:47',NULL,NULL),(14095,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:49',NULL,NULL),(14700,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:24',NULL,NULL),(15307,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:13',NULL,NULL),(17467,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:07',NULL,NULL),(20207,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:10',NULL,NULL),(20564,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:19',NULL,NULL),(23282,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:09',NULL,NULL),(8125,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:28',NULL,NULL),(13430,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:30:12',NULL,NULL),(9869,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:32',NULL,NULL),(10232,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:54',NULL,NULL),(14819,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:57',NULL,NULL),(19557,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:37',NULL,NULL),(20345,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:59',NULL,NULL),(23601,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 13:30:03',NULL,NULL),(1187,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:09',NULL,NULL),(13519,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:25',NULL,NULL),(7955,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:54',NULL,NULL),(11965,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:53',NULL,NULL),(1882,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:47',NULL,NULL),(4844,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:04',NULL,NULL),(1950,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:04',NULL,NULL),(6189,1858,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:30:34',NULL,NULL),(15213,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:55',NULL,NULL),(20854,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:55',NULL,NULL),(22252,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:32',NULL,NULL),(786,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:19',NULL,NULL),(12216,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:03',NULL,NULL),(9319,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:29',NULL,NULL),(9689,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:45',NULL,NULL),(15244,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:01',NULL,NULL),(16727,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:35',NULL,NULL),(20668,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:56',NULL,NULL),(3968,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:24',NULL,NULL),(4323,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:50',NULL,NULL),(9643,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:33',NULL,NULL),(16218,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:43',NULL,NULL),(17535,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:30',NULL,NULL),(94,345,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:27',NULL,NULL),(216,237,'2013-12-27','15:15:00','A','000',0,'2014-01-13 03:05:13',NULL,NULL),(8317,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:22',NULL,NULL),(624,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:10',NULL,NULL),(7268,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:05',NULL,NULL),(12215,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:02',NULL,NULL),(6234,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:46',NULL,NULL),(4941,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:32',NULL,NULL),(5891,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:45',NULL,NULL),(21995,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:05',NULL,NULL),(23120,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:39',NULL,NULL),(1140,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:56',NULL,NULL),(14750,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:38',NULL,NULL),(9431,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:59',NULL,NULL),(2140,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:15',NULL,NULL),(7999,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:05',NULL,NULL),(12376,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:49',NULL,NULL),(19347,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:38',NULL,NULL),(22569,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:12',NULL,NULL),(23590,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 23:30:02',NULL,NULL),(10498,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:27',NULL,NULL),(16057,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:44',NULL,NULL),(14910,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:22',NULL,NULL),(14403,1868,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:50:01',NULL,NULL),(13868,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:15',NULL,NULL),(13735,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:56',NULL,NULL),(13382,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:02',NULL,NULL),(9701,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:48',NULL,NULL),(9436,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:00',NULL,NULL),(3065,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:23',NULL,NULL),(8783,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:14',NULL,NULL),(19472,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:13',NULL,NULL),(19705,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:03',NULL,NULL),(48,368,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:45',NULL,NULL),(227,208,'2013-12-27','15:04:00','A','000',0,'2014-01-13 03:05:16',NULL,NULL),(4994,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:48',NULL,NULL),(5080,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:11',NULL,NULL),(7550,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:05',NULL,NULL),(9549,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:09',NULL,NULL),(2792,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:44',NULL,NULL),(17077,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:24',NULL,NULL),(19185,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:38:01',NULL,NULL),(19815,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:32',NULL,NULL),(8746,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:04',NULL,NULL),(15575,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:22',NULL,NULL),(13828,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:09',NULL,NULL),(1329,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:45',NULL,NULL),(6421,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:36',NULL,NULL),(2929,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:33',NULL,NULL),(3032,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:09',NULL,NULL),(2965,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:46',NULL,NULL),(17731,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:41',NULL,NULL),(5204,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:30',NULL,NULL),(13666,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:46',NULL,NULL),(14509,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:31',NULL,NULL),(18821,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:18',NULL,NULL),(19376,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:47',NULL,NULL),(20464,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:43',NULL,NULL),(21934,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:44',NULL,NULL),(22646,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:22',NULL,NULL),(10521,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:33',NULL,NULL),(7287,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:10',NULL,NULL),(13335,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:09',NULL,NULL),(6903,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:32',NULL,NULL),(18215,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:07',NULL,NULL),(19691,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:02:16',NULL,NULL),(22188,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:15',NULL,NULL),(22566,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:11',NULL,NULL),(22584,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:17',NULL,NULL),(4883,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:15',NULL,NULL),(1946,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:03',NULL,NULL),(3023,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:06',NULL,NULL),(6792,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:00',NULL,NULL),(8262,1877,'2014-01-14','23:11:00','A','000',0,'2014-01-24 03:31:04',NULL,NULL),(14975,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:39',NULL,NULL),(8837,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:28',NULL,NULL),(17742,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:44',NULL,NULL),(18002,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:54',NULL,NULL),(273,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:13',NULL,NULL),(4117,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:02:02',NULL,NULL),(13995,1832,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:34',NULL,NULL),(530,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:39',NULL,NULL),(11446,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:24',NULL,NULL),(9605,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:23',NULL,NULL),(2074,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:59',NULL,NULL),(9266,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:15',NULL,NULL),(6794,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:01',NULL,NULL),(863,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:40',NULL,NULL),(18141,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:42',NULL,NULL),(21290,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:26',NULL,NULL),(23237,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(23608,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 11:30:02',NULL,NULL),(1189,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:32:09',NULL,NULL),(15017,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:54',NULL,NULL),(14490,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:26',NULL,NULL),(5246,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:42',NULL,NULL),(13216,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:37',NULL,NULL),(11690,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:26',NULL,NULL),(11285,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:40',NULL,NULL),(2248,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:25',NULL,NULL),(3675,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:10',NULL,NULL),(23383,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:44',NULL,NULL),(148,284,'2013-12-27','15:32:00','A','000',0,'2014-01-13 03:04:50',NULL,NULL),(2395,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:03',NULL,NULL),(2551,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:43',NULL,NULL),(14254,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:13',NULL,NULL),(12847,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:00',NULL,NULL),(7505,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:10',NULL,NULL),(10169,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:36',NULL,NULL),(18704,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:32:10',NULL,NULL),(18802,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:13',NULL,NULL),(19295,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:23',NULL,NULL),(20495,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:54',NULL,NULL),(20815,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:44',NULL,NULL),(21783,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:50',NULL,NULL),(22465,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:38',NULL,NULL),(1363,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:00',NULL,NULL),(5256,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:45',NULL,NULL),(5065,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:07',NULL,NULL),(2063,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:56',NULL,NULL),(12276,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:19',NULL,NULL),(13078,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:01',NULL,NULL),(17705,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:32',NULL,NULL),(19159,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:54',NULL,NULL),(23557,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 21:30:02',NULL,NULL),(546,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:45',NULL,NULL),(15795,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:36',NULL,NULL),(14895,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:18',NULL,NULL),(3103,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:36',NULL,NULL),(10890,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:08',NULL,NULL),(6098,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:08',NULL,NULL),(21291,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:26',NULL,NULL),(3764,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:32',NULL,NULL),(17176,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:56',NULL,NULL),(3655,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:05',NULL,NULL),(16993,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:55',NULL,NULL),(6983,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:55',NULL,NULL),(15530,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:07',NULL,NULL),(8690,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:49',NULL,NULL),(12989,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:38',NULL,NULL),(12795,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:42',NULL,NULL),(11251,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:31',NULL,NULL),(9698,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:47',NULL,NULL),(20079,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:45',NULL,NULL),(20247,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:24',NULL,NULL),(21936,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:45',NULL,NULL),(22200,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:18',NULL,NULL),(22902,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:53',NULL,NULL),(23080,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:31',NULL,NULL),(23218,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:57',NULL,NULL),(23421,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:57',NULL,NULL),(3235,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:24',NULL,NULL),(16361,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:16',NULL,NULL),(1763,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:18',NULL,NULL),(15595,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:29',NULL,NULL),(13933,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:24',NULL,NULL),(6178,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:31',NULL,NULL),(13077,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:00',NULL,NULL),(12711,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:19',NULL,NULL),(6917,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:37',NULL,NULL),(11066,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:38',NULL,NULL),(11039,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:28',NULL,NULL),(10656,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:08',NULL,NULL),(10407,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:42',NULL,NULL),(7430,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:49',NULL,NULL),(19495,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:19',NULL,NULL),(19767,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:20',NULL,NULL),(20129,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:59',NULL,NULL),(20717,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:15',NULL,NULL),(942,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:02',NULL,NULL),(14835,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:01',NULL,NULL),(4318,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:49',NULL,NULL),(2983,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:52',NULL,NULL),(1749,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:15',NULL,NULL),(6778,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:56',NULL,NULL),(7394,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:40',NULL,NULL),(10208,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:47',NULL,NULL),(8440,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:54',NULL,NULL),(18729,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:35:52',NULL,NULL),(18777,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:36:06',NULL,NULL),(19669,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:10',NULL,NULL),(20040,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:34',NULL,NULL),(21034,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:44',NULL,NULL),(21849,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:14',NULL,NULL),(1171,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:04',NULL,NULL),(16553,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:28',NULL,NULL),(16525,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:19',NULL,NULL),(14984,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:42',NULL,NULL),(14743,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:36',NULL,NULL),(14596,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:54',NULL,NULL),(14402,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:01',NULL,NULL),(13901,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:20',NULL,NULL),(5703,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:40',NULL,NULL),(9289,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:21',NULL,NULL),(8540,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:10',NULL,NULL),(7438,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:51',NULL,NULL),(4467,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:29',NULL,NULL),(6787,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:59',NULL,NULL),(20858,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:56',NULL,NULL),(23695,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 15:30:02',NULL,NULL),(6121,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:14',NULL,NULL),(17320,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:19',NULL,NULL),(5051,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:03',NULL,NULL),(5391,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:23',NULL,NULL),(13991,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:33',NULL,NULL),(21948,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:49',NULL,NULL),(5428,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:33',NULL,NULL),(2662,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:32:12',NULL,NULL),(3807,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:44',NULL,NULL),(6850,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:16',NULL,NULL),(15515,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:02',NULL,NULL),(12355,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:44',NULL,NULL),(21385,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:00',NULL,NULL),(630,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:12',NULL,NULL),(5410,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:28',NULL,NULL),(14282,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:17',NULL,NULL),(985,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:13',NULL,NULL),(1459,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:35',NULL,NULL),(11838,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:04',NULL,NULL),(11310,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:47',NULL,NULL),(3881,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:03',NULL,NULL),(9082,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:25',NULL,NULL),(2330,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:46',NULL,NULL),(2790,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:44',NULL,NULL),(2810,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:51',NULL,NULL),(3421,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:15',NULL,NULL),(17753,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:48',NULL,NULL),(18354,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:33',NULL,NULL),(18436,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:55',NULL,NULL),(18494,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:13',NULL,NULL),(19446,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:07',NULL,NULL),(21565,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:07',NULL,NULL),(133,350,'2013-12-27','16:03:00','A','000',0,'2014-01-13 03:04:46',NULL,NULL),(142,201,'2013-12-27','14:59:00','A','000',0,'2014-01-13 03:04:49',NULL,NULL),(15927,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:58',NULL,NULL),(6194,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:35',NULL,NULL),(5779,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:06',NULL,NULL),(14973,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:39',NULL,NULL),(5114,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:04',NULL,NULL),(1318,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:41',NULL,NULL),(8399,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:44',NULL,NULL),(2238,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:23',NULL,NULL),(17925,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:28',NULL,NULL),(19493,1863,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:19',NULL,NULL),(22216,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:23',NULL,NULL),(22895,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:51',NULL,NULL),(1936,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:00',NULL,NULL),(15883,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:43',NULL,NULL),(9277,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:18',NULL,NULL),(15322,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:16',NULL,NULL),(11984,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:00',NULL,NULL),(18995,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:08',NULL,NULL),(19088,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:33',NULL,NULL),(19954,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:09',NULL,NULL),(21791,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:53',NULL,NULL),(21922,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:40',NULL,NULL),(14120,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:52',NULL,NULL),(10772,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:38',NULL,NULL),(12916,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:18',NULL,NULL),(12741,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:28',NULL,NULL),(9203,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:58',NULL,NULL),(12201,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:58',NULL,NULL),(12047,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:17',NULL,NULL),(3443,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:21',NULL,NULL),(18000,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:53',NULL,NULL),(20119,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:56',NULL,NULL),(23312,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:20',NULL,NULL),(2175,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:24',NULL,NULL),(15499,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:56',NULL,NULL),(14052,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:42',NULL,NULL),(13435,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:13',NULL,NULL),(11558,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:52',NULL,NULL),(11473,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:31',NULL,NULL),(2752,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:30',NULL,NULL),(9702,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:48',NULL,NULL),(7975,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:59',NULL,NULL),(10543,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:39',NULL,NULL),(3113,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:40',NULL,NULL),(18909,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:43',NULL,NULL),(22912,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:57',NULL,NULL),(572,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:53',NULL,NULL),(1966,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:31',NULL,NULL),(10141,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:29',NULL,NULL),(5518,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:58',NULL,NULL),(6341,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:14',NULL,NULL),(16976,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:51',NULL,NULL),(1939,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:01',NULL,NULL),(16280,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:06',NULL,NULL),(13780,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:03',NULL,NULL),(8285,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:12',NULL,NULL),(12947,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:27',NULL,NULL),(11725,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:35',NULL,NULL),(5303,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:59',NULL,NULL),(7753,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:58',NULL,NULL),(6446,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:43',NULL,NULL),(7772,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:03',NULL,NULL),(5929,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:58',NULL,NULL),(10303,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:14',NULL,NULL),(1873,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:45',NULL,NULL),(14931,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:27',NULL,NULL),(2053,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:54',NULL,NULL),(8932,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:54',NULL,NULL),(12000,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:04',NULL,NULL),(12931,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:22',NULL,NULL),(12561,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:37',NULL,NULL),(11274,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:37',NULL,NULL),(12554,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:35',NULL,NULL),(11831,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:02',NULL,NULL),(8927,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:53',NULL,NULL),(7030,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:02:08',NULL,NULL),(4421,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:17',NULL,NULL),(4517,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:41',NULL,NULL),(4859,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:08',NULL,NULL),(17569,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:42',NULL,NULL),(21784,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:50',NULL,NULL),(11145,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:00',NULL,NULL),(16982,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:52',NULL,NULL),(16462,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:55',NULL,NULL),(13351,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:13',NULL,NULL),(785,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:19',NULL,NULL),(4736,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:35',NULL,NULL),(1963,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:30',NULL,NULL),(2671,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:14',NULL,NULL),(2648,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:08',NULL,NULL),(6160,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:26',NULL,NULL),(18214,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:07',NULL,NULL),(22009,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:10',NULL,NULL),(11499,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:38',NULL,NULL),(15205,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:53',NULL,NULL),(1351,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:54',NULL,NULL),(12783,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:39',NULL,NULL),(9248,1881,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:31:10',NULL,NULL),(4728,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:33',NULL,NULL),(17734,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:42',NULL,NULL),(19045,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:21',NULL,NULL),(4579,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:57',NULL,NULL),(5644,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:20',NULL,NULL),(8920,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:51',NULL,NULL),(13961,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:29',NULL,NULL),(13540,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:28',NULL,NULL),(17832,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:55',NULL,NULL),(19412,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:58',NULL,NULL),(20266,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:31',NULL,NULL),(20905,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:09',NULL,NULL),(22568,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:11',NULL,NULL),(22988,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:14',NULL,NULL),(23115,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(4470,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:30',NULL,NULL),(6253,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:50',NULL,NULL),(10633,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:01',NULL,NULL),(16002,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:25',NULL,NULL),(20329,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:53',NULL,NULL),(182,268,'2013-12-27','15:27:00','A','000',0,'2014-01-13 03:05:01',NULL,NULL),(17393,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:44',NULL,NULL),(15462,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:43',NULL,NULL),(5423,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:31',NULL,NULL),(6945,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:46',NULL,NULL),(9857,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:29',NULL,NULL),(19728,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:10',NULL,NULL),(203,189,'2013-12-27','14:54:00','A','000',0,'2014-01-13 03:05:08',NULL,NULL),(17134,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:42',NULL,NULL),(16233,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:48',NULL,NULL),(5270,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:49',NULL,NULL),(1317,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:41',NULL,NULL),(15179,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:47',NULL,NULL),(15085,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:16',NULL,NULL),(12897,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:12',NULL,NULL),(8983,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:08',NULL,NULL),(6574,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:00:04',NULL,NULL),(19426,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:01',NULL,NULL),(22075,1888,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:02:34',NULL,NULL),(5404,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:26',NULL,NULL),(4558,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:52',NULL,NULL),(17089,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:27',NULL,NULL),(15271,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:06',NULL,NULL),(15147,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:36',NULL,NULL),(3799,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:42',NULL,NULL),(11519,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:43',NULL,NULL),(11186,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:12',NULL,NULL),(10349,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:26',NULL,NULL),(7036,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:10',NULL,NULL),(10247,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:58',NULL,NULL),(17806,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:46',NULL,NULL),(18916,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:45',NULL,NULL),(3809,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:44',NULL,NULL),(17560,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:39',NULL,NULL),(4384,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:07',NULL,NULL),(7559,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:08',NULL,NULL),(7755,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:59',NULL,NULL),(12971,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:33',NULL,NULL),(12167,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:49',NULL,NULL),(10088,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:14',NULL,NULL),(18155,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:47',NULL,NULL),(18360,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:35',NULL,NULL),(19894,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:53',NULL,NULL),(865,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:41',NULL,NULL),(6137,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:20',NULL,NULL),(12909,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:16',NULL,NULL),(7595,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:17',NULL,NULL),(8169,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:40',NULL,NULL),(11485,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:34',NULL,NULL),(18186,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:58',NULL,NULL),(19118,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:41',NULL,NULL),(19386,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:50',NULL,NULL),(20117,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:56',NULL,NULL),(21012,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:38',NULL,NULL),(21654,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:04',NULL,NULL),(4349,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:58',NULL,NULL),(6552,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:11',NULL,NULL),(17064,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:19',NULL,NULL),(16050,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:42',NULL,NULL),(16047,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:41',NULL,NULL),(11125,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:55',NULL,NULL),(19782,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:24',NULL,NULL),(22162,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:08',NULL,NULL),(620,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:09',NULL,NULL),(17532,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:29',NULL,NULL),(845,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:35',NULL,NULL),(3946,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:19',NULL,NULL),(15855,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:32',NULL,NULL),(4206,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:21',NULL,NULL),(8998,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:13',NULL,NULL),(8190,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:46',NULL,NULL),(7530,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:17',NULL,NULL),(19132,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:46',NULL,NULL),(19793,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:27',NULL,NULL),(20870,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:59',NULL,NULL),(22836,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:31',NULL,NULL),(22983,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(231,193,'2013-12-27','14:57:00','A','000',0,'2014-01-13 03:05:18',NULL,NULL),(4982,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:44',NULL,NULL),(15012,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:52',NULL,NULL),(2061,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:56',NULL,NULL),(2418,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:09',NULL,NULL),(7976,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:59',NULL,NULL),(7909,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:42',NULL,NULL),(7374,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:34',NULL,NULL),(6897,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:30',NULL,NULL),(19981,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:18',NULL,NULL),(916,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:55',NULL,NULL),(16942,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:42',NULL,NULL),(6582,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:06',NULL,NULL),(2215,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:09',NULL,NULL),(7876,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:33',NULL,NULL),(11622,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:08',NULL,NULL),(8327,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:24',NULL,NULL),(10127,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:25',NULL,NULL),(19656,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:06',NULL,NULL),(19778,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:23',NULL,NULL),(6460,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:47',NULL,NULL),(17816,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:50',NULL,NULL),(2681,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:05',NULL,NULL),(2953,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:41',NULL,NULL),(14214,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:07',NULL,NULL),(13633,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:41',NULL,NULL),(13193,1882,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:27:31',NULL,NULL),(3612,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:07',NULL,NULL),(21626,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:43:30',NULL,NULL),(23148,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:44',NULL,NULL),(23467,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:14',NULL,NULL),(1144,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:57',NULL,NULL),(18267,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:08',NULL,NULL),(17317,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:18',NULL,NULL),(6099,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:08',NULL,NULL),(2429,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:12',NULL,NULL),(15280,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:08',NULL,NULL),(5414,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:29',NULL,NULL),(8805,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:20',NULL,NULL),(9885,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:37',NULL,NULL),(20908,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:10',NULL,NULL),(22928,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:02',NULL,NULL),(1240,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:12',NULL,NULL),(1670,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:50',NULL,NULL),(2507,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:32',NULL,NULL),(16757,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:46',NULL,NULL),(18280,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:13',NULL,NULL),(3205,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:15',NULL,NULL),(17760,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:29',NULL,NULL),(17757,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:28',NULL,NULL),(14599,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:55',NULL,NULL),(14292,1870,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:32:18',NULL,NULL),(14041,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:41',NULL,NULL),(13012,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:43',NULL,NULL),(12594,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:45',NULL,NULL),(11889,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:17',NULL,NULL),(3632,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:12',NULL,NULL),(9500,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:35:56',NULL,NULL),(7951,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:53',NULL,NULL),(9025,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:09',NULL,NULL),(8412,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:47',NULL,NULL),(19014,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:13',NULL,NULL),(6920,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:37',NULL,NULL),(6837,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:12',NULL,NULL),(15846,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:29',NULL,NULL),(2537,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:39',NULL,NULL),(2654,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:10',NULL,NULL),(3056,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:20',NULL,NULL),(3828,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:49',NULL,NULL),(10388,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:37',NULL,NULL),(10344,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:25',NULL,NULL),(8839,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:29',NULL,NULL),(8118,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:26',NULL,NULL),(18876,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:33',NULL,NULL),(23314,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:20',NULL,NULL),(1309,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:38',NULL,NULL),(4454,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:26',NULL,NULL),(2336,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:48',NULL,NULL),(7642,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:29',NULL,NULL),(15180,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:48',NULL,NULL),(8997,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:12',NULL,NULL),(12920,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:19',NULL,NULL),(12575,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:40',NULL,NULL),(12262,1814,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:15',NULL,NULL),(11719,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:33',NULL,NULL),(18415,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:50',NULL,NULL),(19440,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:05',NULL,NULL),(19838,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:38',NULL,NULL),(21587,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:16',NULL,NULL),(22111,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:46',NULL,NULL),(22267,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:36',NULL,NULL),(23099,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(270,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:12',NULL,NULL),(10383,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:36',NULL,NULL),(1696,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:03:00',NULL,NULL),(19052,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:23',NULL,NULL),(21329,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:40',NULL,NULL),(8184,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:44',NULL,NULL),(5396,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:24',NULL,NULL),(2597,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:54',NULL,NULL),(13971,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:30',NULL,NULL),(12174,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:51',NULL,NULL),(11973,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:55',NULL,NULL),(11595,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:02',NULL,NULL),(11136,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:58',NULL,NULL),(2311,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:41',NULL,NULL),(10870,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:02',NULL,NULL),(19183,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:38:01',NULL,NULL),(933,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:59',NULL,NULL),(15394,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:30',NULL,NULL),(15277,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:07',NULL,NULL),(10803,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:45',NULL,NULL),(1903,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:52',NULL,NULL),(4761,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:42',NULL,NULL),(9416,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:54',NULL,NULL),(7335,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:24',NULL,NULL),(1338,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:50',NULL,NULL),(15184,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:49',NULL,NULL),(2183,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:26',NULL,NULL),(14237,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:10',NULL,NULL),(13502,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:22',NULL,NULL),(3429,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:17',NULL,NULL),(12876,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:11',NULL,NULL),(4083,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:54',NULL,NULL),(11829,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:02',NULL,NULL),(11351,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:59',NULL,NULL),(7375,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:35',NULL,NULL),(8171,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:41',NULL,NULL),(5434,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:34',NULL,NULL),(17219,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:11',NULL,NULL),(19655,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:06',NULL,NULL),(20608,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:35',NULL,NULL),(22063,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:29',NULL,NULL),(787,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:19',NULL,NULL),(16330,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:05',NULL,NULL),(3090,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:32',NULL,NULL),(13385,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:03',NULL,NULL),(8912,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:49',NULL,NULL),(3666,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:08',NULL,NULL),(8331,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:26',NULL,NULL),(4477,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:32',NULL,NULL),(21158,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:18',NULL,NULL),(23442,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:05',NULL,NULL),(40,258,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:38',NULL,NULL),(517,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:35',NULL,NULL),(966,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:08',NULL,NULL),(1254,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:18',NULL,NULL),(16412,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:36',NULL,NULL),(7153,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:32',NULL,NULL),(15162,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:41',NULL,NULL),(2002,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:40',NULL,NULL),(14361,1796,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:48',NULL,NULL),(8655,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:40',NULL,NULL),(4452,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:25',NULL,NULL),(6662,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:26',NULL,NULL),(17940,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:33',NULL,NULL),(18897,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:39',NULL,NULL),(7318,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:19',NULL,NULL),(1772,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:20',NULL,NULL),(15255,1832,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:02:03',NULL,NULL),(7156,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:33',NULL,NULL),(2538,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:39',NULL,NULL),(6259,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:52',NULL,NULL),(3414,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:13',NULL,NULL),(6061,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:45',NULL,NULL),(19671,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:10',NULL,NULL),(4346,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:57',NULL,NULL),(15286,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:09',NULL,NULL),(4562,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:53',NULL,NULL),(12681,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:10',NULL,NULL),(6559,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:32:13',NULL,NULL),(7486,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:05',NULL,NULL),(11800,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:54',NULL,NULL),(9424,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:57',NULL,NULL),(18647,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:54',NULL,NULL),(22036,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:20',NULL,NULL),(284,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:16',NULL,NULL),(5598,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:03',NULL,NULL),(5380,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:19',NULL,NULL),(360,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:42',NULL,NULL),(9600,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:22',NULL,NULL),(1518,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:55',NULL,NULL),(7401,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:42',NULL,NULL),(18531,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:23',NULL,NULL),(21612,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:25',NULL,NULL),(2455,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:19',NULL,NULL),(7918,1882,'2014-01-14','23:11:00','A','000',0,'2014-01-24 03:01:44',NULL,NULL),(9040,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:13',NULL,NULL),(16482,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:03',NULL,NULL),(9113,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:33',NULL,NULL),(9933,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:49',NULL,NULL),(10614,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:56',NULL,NULL),(14162,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:59',NULL,NULL),(13775,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:02',NULL,NULL),(12825,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:52',NULL,NULL),(12706,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:18',NULL,NULL),(12582,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:42',NULL,NULL),(10735,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:28',NULL,NULL),(11203,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:18',NULL,NULL),(10760,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:35',NULL,NULL),(23289,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:10',NULL,NULL),(4691,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:23',NULL,NULL),(14775,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:45',NULL,NULL),(14215,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:07',NULL,NULL),(4561,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:52',NULL,NULL),(10423,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:47',NULL,NULL),(8278,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:09',NULL,NULL),(7362,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:31',NULL,NULL),(20049,1890,'2014-01-14','23:11:00','A','000',0,'2014-01-24 08:31:36',NULL,NULL),(20292,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:41',NULL,NULL),(22475,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:41',NULL,NULL),(25,344,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:24',NULL,NULL),(16900,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:32',NULL,NULL),(1942,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:02',NULL,NULL),(11495,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:37',NULL,NULL),(10604,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:54',NULL,NULL),(6288,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:00',NULL,NULL),(10337,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:23',NULL,NULL),(9806,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:16',NULL,NULL),(8339,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:28',NULL,NULL),(7956,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:54',NULL,NULL),(17861,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:06',NULL,NULL),(21826,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:06',NULL,NULL),(22136,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:01',NULL,NULL),(2283,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:34',NULL,NULL),(5185,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:25',NULL,NULL),(15787,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:34',NULL,NULL),(15253,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:03',NULL,NULL),(3425,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:16',NULL,NULL),(2893,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:20',NULL,NULL),(12540,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:31',NULL,NULL),(6363,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:20',NULL,NULL),(11081,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:43',NULL,NULL),(10212,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:48',NULL,NULL),(6426,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:37',NULL,NULL),(17946,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:35',NULL,NULL),(19193,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:38:03',NULL,NULL),(19213,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:09',NULL,NULL),(19886,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:51',NULL,NULL),(23430,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:00',NULL,NULL),(6032,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:34',NULL,NULL),(17442,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:59',NULL,NULL),(6453,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:45',NULL,NULL),(6891,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:28',NULL,NULL),(9941,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:51',NULL,NULL),(16766,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:49',NULL,NULL),(14990,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:44',NULL,NULL),(10235,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:54',NULL,NULL),(20473,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:46',NULL,NULL),(21147,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:15',NULL,NULL),(21667,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:09',NULL,NULL),(22795,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:17',NULL,NULL),(2253,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:26',NULL,NULL),(3211,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:17',NULL,NULL),(2356,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:52',NULL,NULL),(16152,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:20',NULL,NULL),(9531,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:04',NULL,NULL),(15006,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:50',NULL,NULL),(10431,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:49',NULL,NULL),(10973,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:09',NULL,NULL),(12659,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:04',NULL,NULL),(12481,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:15',NULL,NULL),(12178,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:52',NULL,NULL),(23397,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:49',NULL,NULL),(238,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:02',NULL,NULL),(13957,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:28',NULL,NULL),(1278,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:27',NULL,NULL),(1629,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:34',NULL,NULL),(11656,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:17',NULL,NULL),(10120,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:23',NULL,NULL),(2968,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:01:47',NULL,NULL),(8087,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:18',NULL,NULL),(7716,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:48',NULL,NULL),(18951,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:56',NULL,NULL),(19180,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:38:00',NULL,NULL),(19885,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:50',NULL,NULL),(20631,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:43',NULL,NULL),(2397,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:03',NULL,NULL),(17873,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:10',NULL,NULL),(5187,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:25',NULL,NULL),(7671,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:37',NULL,NULL),(14272,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:16',NULL,NULL),(13534,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:28',NULL,NULL),(9182,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:52',NULL,NULL),(10786,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:41',NULL,NULL),(19511,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:25',NULL,NULL),(21364,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:53',NULL,NULL),(22705,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:43',NULL,NULL),(510,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:33',NULL,NULL),(973,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:10',NULL,NULL),(984,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:13',NULL,NULL),(5161,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:18',NULL,NULL),(5127,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:09',NULL,NULL),(1823,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:33',NULL,NULL),(13983,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:32',NULL,NULL),(4705,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:27',NULL,NULL),(2289,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:36',NULL,NULL),(3869,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:59',NULL,NULL),(3228,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:22',NULL,NULL),(8786,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:15',NULL,NULL),(9311,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:26',NULL,NULL),(22784,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:13',NULL,NULL),(28,222,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:27',NULL,NULL),(6462,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:47',NULL,NULL),(16578,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:38',NULL,NULL),(16135,1823,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:14',NULL,NULL),(609,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:05',NULL,NULL),(1849,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:39',NULL,NULL),(13530,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:27',NULL,NULL),(2326,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:45',NULL,NULL),(19083,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:32',NULL,NULL),(19864,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:45',NULL,NULL),(6112,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:12',NULL,NULL),(8501,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:11',NULL,NULL),(16826,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:13',NULL,NULL),(15786,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:33',NULL,NULL),(8718,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:57',NULL,NULL),(8989,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:10',NULL,NULL),(12427,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:21:59',NULL,NULL),(9442,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:02',NULL,NULL),(18888,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:36',NULL,NULL),(21391,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:02',NULL,NULL),(21871,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:21',NULL,NULL),(8553,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:13',NULL,NULL),(8954,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:00',NULL,NULL),(10496,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:26',NULL,NULL),(10851,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:57',NULL,NULL),(11703,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:29',NULL,NULL),(11704,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:29',NULL,NULL),(12650,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:01',NULL,NULL),(12869,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:08',NULL,NULL),(20223,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:15',NULL,NULL),(21992,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:04',NULL,NULL),(22535,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:00',NULL,NULL),(6921,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:38',NULL,NULL),(5683,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:33',NULL,NULL),(2424,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:10',NULL,NULL),(14406,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:02',NULL,NULL),(8053,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:09',NULL,NULL),(6812,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:06',NULL,NULL),(14155,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:58',NULL,NULL),(1789,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:24',NULL,NULL),(3432,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:18',NULL,NULL),(6085,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:04',NULL,NULL),(17061,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:18',NULL,NULL),(18734,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:35:54',NULL,NULL),(21708,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:23',NULL,NULL),(23346,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:32',NULL,NULL),(648,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:18',NULL,NULL),(2185,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:27',NULL,NULL),(4474,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:31',NULL,NULL),(5062,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:06',NULL,NULL),(7799,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:11',NULL,NULL),(12754,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:31',NULL,NULL),(7543,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:04',NULL,NULL),(16784,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:03',NULL,NULL),(17218,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:10',NULL,NULL),(9371,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:42',NULL,NULL),(98,376,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:31',NULL,NULL),(13117,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:12',NULL,NULL),(844,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:35',NULL,NULL),(12982,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:36',NULL,NULL),(11654,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:17',NULL,NULL),(5692,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:36',NULL,NULL),(4866,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:10',NULL,NULL),(16124,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:10',NULL,NULL),(17756,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:27',NULL,NULL),(18973,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:02',NULL,NULL),(18990,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:06',NULL,NULL),(21369,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:54',NULL,NULL),(193,171,'2013-12-27','14:45:00','A','000',0,'2014-01-13 03:05:05',NULL,NULL),(8599,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:25',NULL,NULL),(7024,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:02:07',NULL,NULL),(14580,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:50',NULL,NULL),(14536,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:38',NULL,NULL),(6749,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:48',NULL,NULL),(14080,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:46',NULL,NULL),(11359,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:01',NULL,NULL),(11183,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:11',NULL,NULL),(6090,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:05',NULL,NULL),(5981,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:16',NULL,NULL),(20660,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:54',NULL,NULL),(20913,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:11',NULL,NULL),(21717,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:26',NULL,NULL),(23227,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(10421,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:47',NULL,NULL),(10184,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:41',NULL,NULL),(18178,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:55',NULL,NULL),(19129,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:45',NULL,NULL),(20599,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:32',NULL,NULL),(23198,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(23633,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 18:00:02',NULL,NULL),(9579,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:16',NULL,NULL),(15624,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:38',NULL,NULL),(9089,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:27',NULL,NULL),(2364,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:55',NULL,NULL),(11856,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:09',NULL,NULL),(2714,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:17',NULL,NULL),(16583,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:39',NULL,NULL),(19374,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:46',NULL,NULL),(753,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:10',NULL,NULL),(1078,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:38',NULL,NULL),(11849,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:07',NULL,NULL),(11342,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:56',NULL,NULL),(4094,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:57',NULL,NULL),(5210,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:32',NULL,NULL),(1241,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:12',NULL,NULL),(6284,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:59',NULL,NULL),(9956,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:55',NULL,NULL),(3050,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:18',NULL,NULL),(8168,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:40',NULL,NULL),(19228,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:05',NULL,NULL),(19331,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:34',NULL,NULL),(19336,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:35',NULL,NULL),(21264,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:17',NULL,NULL),(21359,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:51',NULL,NULL),(10069,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:09',NULL,NULL),(16113,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:06',NULL,NULL),(9021,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:08',NULL,NULL),(12207,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:00',NULL,NULL),(8677,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:46',NULL,NULL),(5009,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:52',NULL,NULL),(7835,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:21',NULL,NULL),(19178,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:59',NULL,NULL),(23061,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(23320,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:22',NULL,NULL),(2678,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:04',NULL,NULL),(5260,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:46',NULL,NULL),(6455,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:45',NULL,NULL),(14322,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:24',NULL,NULL),(14174,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:01',NULL,NULL),(11311,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:47',NULL,NULL),(16975,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:50',NULL,NULL),(21175,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:44',NULL,NULL),(21492,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:40',NULL,NULL),(3082,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:29',NULL,NULL),(3085,1886,'2014-01-14','23:11:00','A','000',0,'2014-01-23 22:02:30',NULL,NULL),(7555,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:07',NULL,NULL),(14022,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:38',NULL,NULL),(9840,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:25',NULL,NULL),(20552,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:15',NULL,NULL),(22320,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:49',NULL,NULL),(23696,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 17:30:02',NULL,NULL),(23725,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 11:29:58',NULL,NULL),(699,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:36',NULL,NULL),(3206,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:16',NULL,NULL),(15736,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:16',NULL,NULL),(8845,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:30',NULL,NULL),(14190,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:03',NULL,NULL),(9833,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:23',NULL,NULL),(12471,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:12',NULL,NULL),(10992,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:15',NULL,NULL),(18722,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:32:15',NULL,NULL),(20649,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:50',NULL,NULL),(200,192,'2013-12-27','14:56:00','A','000',0,'2014-01-13 03:05:07',NULL,NULL),(5601,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:04',NULL,NULL),(12517,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:25',NULL,NULL),(618,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:08',NULL,NULL),(10620,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:58',NULL,NULL),(9973,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:43',NULL,NULL),(5845,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:29',NULL,NULL),(4870,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:11',NULL,NULL),(4042,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:44',NULL,NULL),(17000,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:57',NULL,NULL),(19330,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:33',NULL,NULL),(2845,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:03',NULL,NULL),(16603,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:47',NULL,NULL),(16453,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:52',NULL,NULL),(3691,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:14',NULL,NULL),(3865,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:58',NULL,NULL),(15631,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:41',NULL,NULL),(14085,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:47',NULL,NULL),(4557,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:51',NULL,NULL),(6210,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:39',NULL,NULL),(10977,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:10',NULL,NULL),(9603,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:23',NULL,NULL),(9284,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:19',NULL,NULL),(18922,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:46',NULL,NULL),(20051,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:37',NULL,NULL),(21224,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:03',NULL,NULL),(392,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:00:52',NULL,NULL),(15110,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:25',NULL,NULL),(14160,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:59',NULL,NULL),(7147,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:31',NULL,NULL),(13452,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:15',NULL,NULL),(12287,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:22',NULL,NULL),(17400,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:46',NULL,NULL),(20209,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:10',NULL,NULL),(554,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:47',NULL,NULL),(4827,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:00',NULL,NULL),(12584,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:43',NULL,NULL),(919,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:55',NULL,NULL),(8320,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:22',NULL,NULL),(7845,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:24',NULL,NULL),(6197,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:36',NULL,NULL),(21345,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:46',NULL,NULL),(21726,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:30',NULL,NULL),(22497,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:48',NULL,NULL),(1105,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:46',NULL,NULL),(5590,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:19',NULL,NULL),(5177,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:23',NULL,NULL),(13544,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:29',NULL,NULL),(4261,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:35',NULL,NULL),(10561,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:43',NULL,NULL),(1639,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:38',NULL,NULL),(7250,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:00',NULL,NULL),(8494,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:09',NULL,NULL),(18804,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:14',NULL,NULL),(19845,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:40',NULL,NULL),(20359,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:04',NULL,NULL),(22058,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:28',NULL,NULL),(22333,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:53',NULL,NULL),(23618,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 16:00:02',NULL,NULL),(997,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:17',NULL,NULL),(12613,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:51',NULL,NULL),(5622,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:12',NULL,NULL),(4403,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:12',NULL,NULL),(7902,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:40',NULL,NULL),(11194,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:15',NULL,NULL),(9825,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:21',NULL,NULL),(19479,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:15',NULL,NULL),(21878,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:24',NULL,NULL),(22416,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:21',NULL,NULL),(23573,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 22:30:02',NULL,NULL),(1891,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:49',NULL,NULL),(5864,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:36',NULL,NULL),(5782,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:07',NULL,NULL),(13698,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:50',NULL,NULL),(2227,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:13',NULL,NULL),(2706,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:00:14',NULL,NULL),(11315,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:48',NULL,NULL),(5552,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:08',NULL,NULL),(9454,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:05',NULL,NULL),(7400,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:41',NULL,NULL),(5354,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:13',NULL,NULL),(4925,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:27',NULL,NULL),(19774,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:22',NULL,NULL),(23067,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:29',NULL,NULL),(217,242,'2013-12-27','15:17:00','A','000',0,'2014-01-13 03:05:13',NULL,NULL),(16613,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:52',NULL,NULL),(1413,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:18',NULL,NULL),(2657,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:11',NULL,NULL),(8970,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:02:04',NULL,NULL),(10560,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:43',NULL,NULL),(10713,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:23',NULL,NULL),(11224,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:24',NULL,NULL),(17498,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:18',NULL,NULL),(18489,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:11',NULL,NULL),(18811,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:15',NULL,NULL),(21161,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:19',NULL,NULL),(21602,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:21',NULL,NULL),(1650,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:42',NULL,NULL),(16983,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:52',NULL,NULL),(16127,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:11',NULL,NULL),(14510,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:31',NULL,NULL),(13764,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:01',NULL,NULL),(6105,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:10',NULL,NULL),(1887,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:48',NULL,NULL),(11615,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:07',NULL,NULL),(10930,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:18',NULL,NULL),(2111,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:08',NULL,NULL),(4095,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:57',NULL,NULL),(3309,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:44',NULL,NULL),(21570,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:09',NULL,NULL),(153,338,'2013-12-27','15:51:00','A','000',0,'2014-01-13 03:04:52',NULL,NULL),(1177,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:06',NULL,NULL),(13805,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:06',NULL,NULL),(12234,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:08',NULL,NULL),(20152,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:05',NULL,NULL),(22910,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:56',NULL,NULL),(77,362,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:12',NULL,NULL),(16962,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:47',NULL,NULL),(16926,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:39',NULL,NULL),(15728,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:13',NULL,NULL),(5741,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:53',NULL,NULL),(4984,1884,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:01:45',NULL,NULL),(6546,1867,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:32:09',NULL,NULL),(13902,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:20',NULL,NULL),(11669,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:21',NULL,NULL),(7084,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:12',NULL,NULL),(9949,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:53',NULL,NULL),(17922,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:27',NULL,NULL),(18830,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:21',NULL,NULL),(19781,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:23',NULL,NULL),(20065,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:41',NULL,NULL),(21162,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:38',NULL,NULL),(22606,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:25',NULL,NULL),(6084,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:03',NULL,NULL),(5648,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:21',NULL,NULL),(15754,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:22',NULL,NULL),(4214,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:23',NULL,NULL),(14238,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:10',NULL,NULL),(7664,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:35',NULL,NULL),(13728,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:55',NULL,NULL),(13464,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:17',NULL,NULL),(20089,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:48',NULL,NULL),(22733,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:52',NULL,NULL),(23153,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:45',NULL,NULL),(1118,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:49',NULL,NULL),(2115,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:09',NULL,NULL),(10935,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:19',NULL,NULL),(9601,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:22',NULL,NULL),(9034,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:12',NULL,NULL),(4779,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:46',NULL,NULL),(20085,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:47',NULL,NULL),(385,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:50',NULL,NULL),(7167,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:36',NULL,NULL),(6789,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:00',NULL,NULL),(11776,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:15:48',NULL,NULL),(2533,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:38',NULL,NULL),(9283,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:19',NULL,NULL),(5452,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:39',NULL,NULL),(3134,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:47',NULL,NULL),(3812,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:45',NULL,NULL),(16102,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:02',NULL,NULL),(17672,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:21',NULL,NULL),(18795,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:11',NULL,NULL),(21240,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:08',NULL,NULL),(22158,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:07',NULL,NULL),(8060,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:11',NULL,NULL),(3423,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:15',NULL,NULL),(7994,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:04',NULL,NULL),(7659,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:34',NULL,NULL),(4931,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:29',NULL,NULL),(9367,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:41',NULL,NULL),(15305,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:12',NULL,NULL),(16139,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:15',NULL,NULL),(17648,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:12',NULL,NULL),(18009,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:57',NULL,NULL),(18889,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:37',NULL,NULL),(20080,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:45',NULL,NULL),(20669,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:57',NULL,NULL),(20740,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:22',NULL,NULL),(21828,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:06',NULL,NULL),(21960,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:53',NULL,NULL),(22680,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:34',NULL,NULL),(8647,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:38',NULL,NULL),(12479,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:14',NULL,NULL),(4541,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:47',NULL,NULL),(4524,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:43',NULL,NULL),(4189,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:17',NULL,NULL),(2409,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:07',NULL,NULL),(4003,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:33',NULL,NULL),(6349,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:16',NULL,NULL),(16703,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:27',NULL,NULL),(16745,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:42',NULL,NULL),(18788,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:09',NULL,NULL),(19640,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:02',NULL,NULL),(20745,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:24',NULL,NULL),(20884,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:03',NULL,NULL),(21905,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:34',NULL,NULL),(8785,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:15',NULL,NULL),(15048,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:04',NULL,NULL),(13969,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:30',NULL,NULL),(1786,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:24',NULL,NULL),(8276,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:08',NULL,NULL),(11628,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:10',NULL,NULL),(11482,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:33',NULL,NULL),(5213,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:33',NULL,NULL),(15538,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:09',NULL,NULL),(19630,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:57',NULL,NULL),(20175,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:11',NULL,NULL),(9463,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:08',NULL,NULL),(1358,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:57',NULL,NULL),(7494,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:07',NULL,NULL),(10588,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:50',NULL,NULL),(22017,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:13',NULL,NULL),(22901,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:53',NULL,NULL),(839,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:34',NULL,NULL),(14993,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:45',NULL,NULL),(14410,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:03',NULL,NULL),(11419,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:19',NULL,NULL),(5057,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:02:05',NULL,NULL),(4424,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:18',NULL,NULL),(8083,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:17',NULL,NULL),(5674,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:30',NULL,NULL),(15839,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:26',NULL,NULL),(18372,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:38',NULL,NULL),(7579,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:13',NULL,NULL),(15106,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:23',NULL,NULL),(1583,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:18',NULL,NULL),(2641,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:06',NULL,NULL),(4111,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:02:01',NULL,NULL),(17690,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:27',NULL,NULL),(21251,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:12',NULL,NULL),(22051,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:25',NULL,NULL),(256,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:07',NULL,NULL),(15502,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:57',NULL,NULL),(4585,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:58',NULL,NULL),(15564,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:18',NULL,NULL),(15853,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:32',NULL,NULL),(18136,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:40',NULL,NULL),(18422,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:52',NULL,NULL),(18758,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:01',NULL,NULL),(21882,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:25',NULL,NULL),(22119,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:49',NULL,NULL),(23084,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:32',NULL,NULL),(23199,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(23722,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 22:29:58',NULL,NULL),(8663,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:42',NULL,NULL),(5105,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:02:18',NULL,NULL),(11724,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:35',NULL,NULL),(12696,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:15',NULL,NULL),(16420,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:39',NULL,NULL),(17101,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:31',NULL,NULL),(17819,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:51',NULL,NULL),(18390,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:43',NULL,NULL),(18809,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:15',NULL,NULL),(9617,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:26',NULL,NULL),(15649,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:46',NULL,NULL),(15556,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:16',NULL,NULL),(14227,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:08',NULL,NULL),(7989,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:02',NULL,NULL),(12716,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:21',NULL,NULL),(2922,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:30',NULL,NULL),(3875,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:01',NULL,NULL),(4132,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:02:06',NULL,NULL),(16229,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:47',NULL,NULL),(16753,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:45',NULL,NULL),(17346,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:28',NULL,NULL),(17433,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:57',NULL,NULL),(20718,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:16',NULL,NULL),(20833,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:49',NULL,NULL),(4195,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:18',NULL,NULL),(6638,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:20',NULL,NULL),(6380,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:25',NULL,NULL),(10516,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:31',NULL,NULL),(17627,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:04',NULL,NULL),(22071,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:32',NULL,NULL),(23528,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 11:30:02',NULL,NULL),(810,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:26',NULL,NULL),(14079,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:46',NULL,NULL),(1970,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:32',NULL,NULL),(2371,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:56',NULL,NULL),(3004,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:59',NULL,NULL),(12260,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:15',NULL,NULL),(4475,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:31',NULL,NULL),(5690,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:36',NULL,NULL),(16357,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:15',NULL,NULL),(20980,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:29',NULL,NULL),(22753,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:00',NULL,NULL),(125,280,'2013-12-27','15:31:00','A','000',0,'2014-01-13 03:04:43',NULL,NULL),(15132,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:32',NULL,NULL),(1053,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:32',NULL,NULL),(8959,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:01',NULL,NULL),(11209,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:20',NULL,NULL),(3130,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:45',NULL,NULL),(6516,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:32:02',NULL,NULL),(4412,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:15',NULL,NULL),(18881,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:34',NULL,NULL),(9637,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:32',NULL,NULL),(3329,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:50',NULL,NULL),(7217,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:50',NULL,NULL),(14247,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:12',NULL,NULL),(13188,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:30',NULL,NULL),(6151,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:23',NULL,NULL),(5728,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:49',NULL,NULL),(4287,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:41',NULL,NULL),(16030,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:35',NULL,NULL),(16522,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:18',NULL,NULL),(17337,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:25',NULL,NULL),(17615,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:00',NULL,NULL),(17659,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:16',NULL,NULL),(8827,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:26',NULL,NULL),(1079,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:39',NULL,NULL),(14340,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:29',NULL,NULL),(13584,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:35',NULL,NULL),(8514,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:02',NULL,NULL),(8234,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:57',NULL,NULL),(3060,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:21',NULL,NULL),(20972,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:27',NULL,NULL),(21047,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:48',NULL,NULL),(22844,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:34',NULL,NULL),(23450,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:08',NULL,NULL),(23635,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 00:00:02',NULL,NULL),(9657,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:37',NULL,NULL),(15916,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:54',NULL,NULL),(2500,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:30',NULL,NULL),(13794,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:05',NULL,NULL),(9071,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:22',NULL,NULL),(7105,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:19',NULL,NULL),(10680,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:15',NULL,NULL),(12436,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:02',NULL,NULL),(12175,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:51',NULL,NULL),(11001,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:17',NULL,NULL),(18342,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:30',NULL,NULL),(18961,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:58',NULL,NULL),(19803,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:29',NULL,NULL),(22828,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:29',NULL,NULL),(23202,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:54',NULL,NULL),(114,349,'2013-12-27','16:02:00','A','000',0,'2014-01-13 03:04:40',NULL,NULL),(352,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:39',NULL,NULL),(1761,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:17',NULL,NULL),(1860,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:42',NULL,NULL),(16768,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:50',NULL,NULL),(17194,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:02',NULL,NULL),(9620,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:27',NULL,NULL),(14525,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:35',NULL,NULL),(13495,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:21',NULL,NULL),(5362,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:15',NULL,NULL),(18142,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:42',NULL,NULL),(21940,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:46',NULL,NULL),(22358,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:02',NULL,NULL),(10354,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:28',NULL,NULL),(260,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:09',NULL,NULL),(8194,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:47',NULL,NULL),(2682,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:05',NULL,NULL),(14506,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:30',NULL,NULL),(13985,1832,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:32',NULL,NULL),(3440,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:20',NULL,NULL),(16892,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:30',NULL,NULL),(17598,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:53',NULL,NULL),(18724,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:15',NULL,NULL),(20398,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:19',NULL,NULL),(20890,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:05',NULL,NULL),(21139,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:13',NULL,NULL),(1161,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:01',NULL,NULL),(13820,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:08',NULL,NULL),(13365,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:17',NULL,NULL),(8484,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:06',NULL,NULL),(2976,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:50',NULL,NULL),(4613,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:32:05',NULL,NULL),(21328,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:40',NULL,NULL),(22148,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:05',NULL,NULL),(9467,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:09',NULL,NULL),(7504,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:10',NULL,NULL),(4074,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:51',NULL,NULL),(12325,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:35',NULL,NULL),(12099,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:31',NULL,NULL),(4183,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:15',NULL,NULL),(16748,1825,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:43',NULL,NULL),(22654,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:25',NULL,NULL),(266,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:11',NULL,NULL),(9462,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:07',NULL,NULL),(2388,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:01',NULL,NULL),(3754,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:30',NULL,NULL),(14960,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:34',NULL,NULL),(19206,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:07',NULL,NULL),(20111,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:54',NULL,NULL),(21477,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:34',NULL,NULL),(21620,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:43:28',NULL,NULL),(21856,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:16',NULL,NULL),(23201,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:54',NULL,NULL),(5656,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:24',NULL,NULL),(2017,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:45',NULL,NULL),(15163,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:42',NULL,NULL),(2150,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:17',NULL,NULL),(4383,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:07',NULL,NULL),(5384,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:21',NULL,NULL),(19253,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:12',NULL,NULL),(22749,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:58',NULL,NULL),(11354,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:00',NULL,NULL),(1007,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:19',NULL,NULL),(7551,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:06',NULL,NULL),(3882,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:03',NULL,NULL),(14787,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:48',NULL,NULL),(15574,1856,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:22',NULL,NULL),(17526,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:27',NULL,NULL),(21043,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:46',NULL,NULL),(21312,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:34',NULL,NULL),(22207,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:21',NULL,NULL),(22817,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:25',NULL,NULL),(22978,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:12',NULL,NULL),(65,159,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:01',NULL,NULL),(7744,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:56',NULL,NULL),(917,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:55',NULL,NULL),(9921,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:46',NULL,NULL),(9752,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:01',NULL,NULL),(9670,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:40',NULL,NULL),(1820,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:32',NULL,NULL),(17086,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:26',NULL,NULL),(18834,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:22',NULL,NULL),(19492,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:19',NULL,NULL),(21858,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:17',NULL,NULL),(881,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:45',NULL,NULL),(13776,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:02',NULL,NULL),(1162,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:02',NULL,NULL),(2241,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:23',NULL,NULL),(12309,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:29',NULL,NULL),(16797,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:06',NULL,NULL),(18012,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:58',NULL,NULL),(19956,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:10',NULL,NULL),(19962,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:13',NULL,NULL),(20016,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:27',NULL,NULL),(22920,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:59',NULL,NULL),(752,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:09',NULL,NULL),(1821,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:32',NULL,NULL),(2042,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:51',NULL,NULL),(9185,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:53',NULL,NULL),(2463,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:21',NULL,NULL),(7895,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:38',NULL,NULL),(5778,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:06',NULL,NULL),(6331,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:11',NULL,NULL),(7267,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:05',NULL,NULL),(4142,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:04',NULL,NULL),(5194,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:27',NULL,NULL),(4581,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:57',NULL,NULL),(14663,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:14',NULL,NULL),(14892,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:17',NULL,NULL),(18882,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:35',NULL,NULL),(21500,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:43',NULL,NULL),(221,247,'2013-12-27','15:18:00','A','000',0,'2014-01-13 03:05:14',NULL,NULL),(14161,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:59',NULL,NULL),(761,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:12',NULL,NULL),(10622,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:58',NULL,NULL),(1417,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:19',NULL,NULL),(6165,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:27',NULL,NULL),(3550,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:49',NULL,NULL),(2071,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:58',NULL,NULL),(17992,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:51',NULL,NULL),(75,270,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:10',NULL,NULL),(14165,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:59',NULL,NULL),(13825,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:09',NULL,NULL),(202,188,'2013-12-27','14:54:00','A','000',0,'2014-01-13 03:05:08',NULL,NULL),(8166,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:39',NULL,NULL),(8093,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:20',NULL,NULL),(8028,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:02',NULL,NULL),(9639,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:32',NULL,NULL),(9304,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:25',NULL,NULL),(5924,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:56',NULL,NULL),(3737,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:26',NULL,NULL),(7591,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:16',NULL,NULL),(3995,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:31',NULL,NULL),(16532,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:21',NULL,NULL),(17128,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:40',NULL,NULL),(20151,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:05',NULL,NULL),(21146,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:15',NULL,NULL),(21543,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:59',NULL,NULL),(21714,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:25',NULL,NULL),(8461,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:00',NULL,NULL),(8042,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:06',NULL,NULL),(14341,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:29',NULL,NULL),(13870,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:15',NULL,NULL),(13818,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:08',NULL,NULL),(10128,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:40:25',NULL,NULL),(16708,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:29',NULL,NULL),(16818,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:11',NULL,NULL),(18112,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:33',NULL,NULL),(18683,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:32:04',NULL,NULL),(20184,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:14',NULL,NULL),(20967,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:25',NULL,NULL),(972,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:10',NULL,NULL),(1648,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:41',NULL,NULL),(11292,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:42',NULL,NULL),(8069,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:13',NULL,NULL),(2884,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:17',NULL,NULL),(4158,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:09',NULL,NULL),(22309,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:46',NULL,NULL),(23632,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 16:00:02',NULL,NULL),(474,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:21',NULL,NULL),(14696,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:23',NULL,NULL),(1279,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:27',NULL,NULL),(12039,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:15',NULL,NULL),(11730,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:36',NULL,NULL),(11679,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:23',NULL,NULL),(11560,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:53',NULL,NULL),(10468,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:19',NULL,NULL),(4932,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:30',NULL,NULL),(9796,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:13',NULL,NULL),(4107,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:00',NULL,NULL),(16012,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:28',NULL,NULL),(17263,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:26',NULL,NULL),(20190,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:03',NULL,NULL),(21411,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:10',NULL,NULL),(87,304,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:21',NULL,NULL),(4856,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:08',NULL,NULL),(14862,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:09',NULL,NULL),(14744,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:36',NULL,NULL),(4148,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:06',NULL,NULL),(2007,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:42',NULL,NULL),(11293,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:42',NULL,NULL),(16182,1843,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:16:30',NULL,NULL),(19677,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:12',NULL,NULL),(19696,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:02:17',NULL,NULL),(20597,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:31',NULL,NULL),(21932,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:43',NULL,NULL),(282,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:16',NULL,NULL),(5361,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:15',NULL,NULL),(12541,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:31',NULL,NULL),(11765,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:45',NULL,NULL),(10765,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:36',NULL,NULL),(4896,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:18',NULL,NULL),(4857,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:08',NULL,NULL),(4572,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:55',NULL,NULL),(5254,1896,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:30:44',NULL,NULL),(6258,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:30:52',NULL,NULL),(15068,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:10',NULL,NULL),(12166,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:48',NULL,NULL),(8665,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:43',NULL,NULL),(14462,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:18',NULL,NULL),(9826,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:21',NULL,NULL),(20735,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:21',NULL,NULL),(23504,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:26',NULL,NULL),(183,212,'2013-12-27','15:06:00','A','000',0,'2014-01-13 03:05:02',NULL,NULL),(14676,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:18',NULL,NULL),(7830,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:20',NULL,NULL),(7283,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:09',NULL,NULL),(7136,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:28',NULL,NULL),(2759,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:33',NULL,NULL),(5451,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:39',NULL,NULL),(3105,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:37',NULL,NULL),(21406,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:08',NULL,NULL),(23286,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:10',NULL,NULL),(5908,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:51',NULL,NULL),(2176,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:24',NULL,NULL),(10105,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:19',NULL,NULL),(3071,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:25',NULL,NULL),(5162,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:18',NULL,NULL),(5152,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:16',NULL,NULL),(5873,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:39',NULL,NULL),(16736,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:39',NULL,NULL),(21540,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:58',NULL,NULL),(22818,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:25',NULL,NULL),(1176,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:05',NULL,NULL),(15459,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:42',NULL,NULL),(14318,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:23',NULL,NULL),(7836,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:21',NULL,NULL),(13277,1834,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:53',NULL,NULL),(12890,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:15',NULL,NULL),(11981,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:59',NULL,NULL),(22167,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:09',NULL,NULL),(791,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:20',NULL,NULL),(10792,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:43',NULL,NULL),(10928,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:17',NULL,NULL),(13399,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:06',NULL,NULL),(13289,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:57',NULL,NULL),(13108,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:09',NULL,NULL),(12220,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:04',NULL,NULL),(16253,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:56',NULL,NULL),(17285,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:08',NULL,NULL),(17531,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:29',NULL,NULL),(17626,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:03',NULL,NULL),(19168,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:57',NULL,NULL),(21456,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:26',NULL,NULL),(22638,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:20',NULL,NULL),(22689,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:37',NULL,NULL),(8349,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:31:31',NULL,NULL),(13939,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:25',NULL,NULL),(12018,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:09',NULL,NULL),(5807,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:16',NULL,NULL),(4222,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:25',NULL,NULL),(1466,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:37',NULL,NULL),(8031,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:03',NULL,NULL),(16931,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:40',NULL,NULL),(18942,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:52',NULL,NULL),(19490,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:18',NULL,NULL),(908,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:53',NULL,NULL),(15725,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:12',NULL,NULL),(14656,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:12',NULL,NULL),(14089,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:48',NULL,NULL),(9397,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:49',NULL,NULL),(3805,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:43',NULL,NULL),(16158,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:22',NULL,NULL),(20732,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:20',NULL,NULL),(22098,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:42',NULL,NULL),(3699,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:16',NULL,NULL),(3388,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:06',NULL,NULL),(3257,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:30',NULL,NULL),(10260,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:01',NULL,NULL),(17067,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:20',NULL,NULL),(1486,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:44',NULL,NULL),(2261,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:28',NULL,NULL),(4070,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:50',NULL,NULL),(16131,1826,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:12',NULL,NULL),(10066,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:08',NULL,NULL),(6450,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:44',NULL,NULL),(13157,1834,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:22',NULL,NULL),(12940,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:25',NULL,NULL),(10458,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:57',NULL,NULL),(11120,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:54',NULL,NULL),(17967,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:42',NULL,NULL),(17977,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:46',NULL,NULL),(18717,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:13',NULL,NULL),(22001,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:07',NULL,NULL),(646,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:17',NULL,NULL),(9234,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:06',NULL,NULL),(1299,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:34',NULL,NULL),(5921,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:55',NULL,NULL),(6209,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:39',NULL,NULL),(8955,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:00',NULL,NULL),(2066,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:57',NULL,NULL),(2612,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:58',NULL,NULL),(4151,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:07',NULL,NULL),(2731,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:23',NULL,NULL),(3009,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:01',NULL,NULL),(2811,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:51',NULL,NULL),(16677,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:18',NULL,NULL),(17936,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:32',NULL,NULL),(18189,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:59',NULL,NULL),(9911,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:43',NULL,NULL),(1557,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:09',NULL,NULL),(15990,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:20',NULL,NULL),(3165,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:04',NULL,NULL),(7746,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:56',NULL,NULL),(4745,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:37',NULL,NULL),(16336,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:07',NULL,NULL),(21301,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:30',NULL,NULL),(22499,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:49',NULL,NULL),(23321,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:23',NULL,NULL),(23344,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:31',NULL,NULL),(23479,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:18',NULL,NULL),(278,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:15',NULL,NULL),(16186,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:32',NULL,NULL),(15977,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:16',NULL,NULL),(4924,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:27',NULL,NULL),(14213,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:06',NULL,NULL),(10746,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:31',NULL,NULL),(18861,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:29',NULL,NULL),(21659,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:06',NULL,NULL),(21950,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:49',NULL,NULL),(22351,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:59',NULL,NULL),(665,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:23',NULL,NULL),(13841,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:11',NULL,NULL),(4345,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:57',NULL,NULL),(1469,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:38',NULL,NULL),(2373,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:57',NULL,NULL),(10761,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:35',NULL,NULL),(3037,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:13',NULL,NULL),(9343,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:35',NULL,NULL),(9131,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:39',NULL,NULL),(19139,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:48',NULL,NULL),(19350,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:39',NULL,NULL),(1251,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:17',NULL,NULL),(1359,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:58',NULL,NULL),(4297,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:44',NULL,NULL),(2056,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:55',NULL,NULL),(2561,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:45',NULL,NULL),(9759,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:03',NULL,NULL),(15814,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:17',NULL,NULL),(16859,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:22',NULL,NULL),(17257,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:24',NULL,NULL),(18539,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:25',NULL,NULL),(18575,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:35',NULL,NULL),(23355,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:35',NULL,NULL),(7029,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:08',NULL,NULL),(6475,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:51',NULL,NULL),(6354,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:17',NULL,NULL),(8789,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:16',NULL,NULL),(14922,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:25',NULL,NULL),(17269,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:02',NULL,NULL),(18345,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:31',NULL,NULL),(18570,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:34',NULL,NULL),(18600,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:42',NULL,NULL),(18838,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:23',NULL,NULL),(19486,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:17',NULL,NULL),(21380,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:58',NULL,NULL),(21805,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:58',NULL,NULL),(22134,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:54',NULL,NULL),(22957,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(23213,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(8211,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:51',NULL,NULL),(14133,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:55',NULL,NULL),(13897,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:19',NULL,NULL),(13076,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:00',NULL,NULL),(13068,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:58',NULL,NULL),(6347,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:15',NULL,NULL),(3191,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:11',NULL,NULL),(6211,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:40',NULL,NULL),(11395,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:11',NULL,NULL),(3908,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:10',NULL,NULL),(15825,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:21',NULL,NULL),(20402,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:20',NULL,NULL),(6720,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:40',NULL,NULL),(13286,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:56',NULL,NULL),(11331,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:52',NULL,NULL),(9556,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:10',NULL,NULL),(1304,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:37',NULL,NULL),(4440,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:22',NULL,NULL),(19701,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:18',NULL,NULL),(22807,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:21',NULL,NULL),(298,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:21',NULL,NULL),(1016,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:22',NULL,NULL),(7910,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:42',NULL,NULL),(9023,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:09',NULL,NULL),(7552,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:06',NULL,NULL),(15533,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:08',NULL,NULL),(15930,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:59',NULL,NULL),(17142,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:45',NULL,NULL),(17403,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:47',NULL,NULL),(20048,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:36',NULL,NULL),(8819,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:23',NULL,NULL),(7117,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:23',NULL,NULL),(6791,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:00',NULL,NULL),(11665,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:20',NULL,NULL),(10058,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:06',NULL,NULL),(15812,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:16',NULL,NULL),(19891,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:52',NULL,NULL),(1047,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:30',NULL,NULL),(14058,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:43',NULL,NULL),(14002,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:35',NULL,NULL),(13389,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:04',NULL,NULL),(7348,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:27',NULL,NULL),(12901,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:14',NULL,NULL),(9674,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:41',NULL,NULL),(16130,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:12',NULL,NULL),(17768,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:32',NULL,NULL),(19951,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:08',NULL,NULL),(22043,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:22',NULL,NULL),(22577,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:15',NULL,NULL),(23418,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:56',NULL,NULL),(1014,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:21',NULL,NULL),(13361,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:16',NULL,NULL),(11990,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:02',NULL,NULL),(8010,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:08',NULL,NULL),(6293,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:01',NULL,NULL),(6716,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:39',NULL,NULL),(7682,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:40',NULL,NULL),(17148,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:47',NULL,NULL),(21220,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:01',NULL,NULL),(2214,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:09',NULL,NULL),(10541,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:38',NULL,NULL),(2370,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:56',NULL,NULL),(9198,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:57',NULL,NULL),(6188,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:34',NULL,NULL),(6874,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:22',NULL,NULL),(6202,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:37',NULL,NULL),(15579,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:23',NULL,NULL),(16820,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:12',NULL,NULL),(23309,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:18',NULL,NULL),(23545,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 13:30:02',NULL,NULL),(8475,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:04',NULL,NULL),(14488,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:25',NULL,NULL),(8470,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:02',NULL,NULL),(5948,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:04',NULL,NULL),(11450,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:25',NULL,NULL),(4415,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:15',NULL,NULL),(10606,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:54',NULL,NULL),(9585,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:18',NULL,NULL),(18184,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:57',NULL,NULL),(18535,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:24',NULL,NULL),(22160,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:08',NULL,NULL),(9020,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:08',NULL,NULL),(14683,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:20',NULL,NULL),(1052,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:32',NULL,NULL),(6405,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:32',NULL,NULL),(5756,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:58',NULL,NULL),(3741,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:27',NULL,NULL),(4782,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:47',NULL,NULL),(18992,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:07',NULL,NULL),(19930,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:02',NULL,NULL),(21718,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:27',NULL,NULL),(22941,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:05',NULL,NULL),(5342,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:09',NULL,NULL),(13678,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:47',NULL,NULL),(13052,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:54',NULL,NULL),(11545,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:49',NULL,NULL),(10000,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:50',NULL,NULL),(18429,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:54',NULL,NULL),(19296,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:24',NULL,NULL),(23551,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 01:30:02',NULL,NULL),(3296,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:41',NULL,NULL),(9349,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:36',NULL,NULL),(14416,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:05',NULL,NULL),(12965,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:32',NULL,NULL),(12688,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:12',NULL,NULL),(10699,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:20',NULL,NULL),(10508,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:29',NULL,NULL),(10361,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:30',NULL,NULL),(7221,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:51',NULL,NULL),(15509,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:00',NULL,NULL),(16114,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:07',NULL,NULL),(16497,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:08',NULL,NULL),(16899,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:32',NULL,NULL),(18047,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:11',NULL,NULL),(18943,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:52',NULL,NULL),(21409,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:09',NULL,NULL),(22077,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:34',NULL,NULL),(9392,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:48',NULL,NULL),(14260,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:14',NULL,NULL),(13645,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:43',NULL,NULL),(13624,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:40',NULL,NULL),(13604,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:37',NULL,NULL),(842,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:35',NULL,NULL),(1830,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:34',NULL,NULL),(3127,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:44',NULL,NULL),(8878,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:39',NULL,NULL),(9296,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:23',NULL,NULL),(5671,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:29',NULL,NULL),(9117,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:35',NULL,NULL),(21193,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:50',NULL,NULL),(22347,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:58',NULL,NULL),(23128,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:40',NULL,NULL),(23170,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:48',NULL,NULL),(8874,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:38',NULL,NULL),(11718,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:33',NULL,NULL),(13542,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:29',NULL,NULL),(12051,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:18',NULL,NULL),(9649,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:35',NULL,NULL),(10954,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:04',NULL,NULL),(3657,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:05',NULL,NULL),(6221,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:42',NULL,NULL),(6030,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:34',NULL,NULL),(5625,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:13',NULL,NULL),(6962,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:50',NULL,NULL),(6978,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:54',NULL,NULL),(7492,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:07',NULL,NULL),(9293,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:22',NULL,NULL),(8485,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:06',NULL,NULL),(16903,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:33',NULL,NULL),(17278,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:05',NULL,NULL),(19341,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:36',NULL,NULL),(20817,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:44',NULL,NULL),(22034,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:19',NULL,NULL),(22710,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:44',NULL,NULL),(23433,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:01',NULL,NULL),(1561,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:11',NULL,NULL),(1836,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:36',NULL,NULL),(1961,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:30',NULL,NULL),(13344,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:12',NULL,NULL),(13250,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:47',NULL,NULL),(11771,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:47',NULL,NULL),(15681,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:58',NULL,NULL),(15687,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:00',NULL,NULL),(17492,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:16',NULL,NULL),(18285,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:15',NULL,NULL),(7961,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:55',NULL,NULL),(14994,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:46',NULL,NULL),(14175,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:01',NULL,NULL),(4699,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:25',NULL,NULL),(2772,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:37',NULL,NULL),(10275,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:06',NULL,NULL),(3140,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:49',NULL,NULL),(3635,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:13',NULL,NULL),(3363,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:59',NULL,NULL),(18931,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:49',NULL,NULL),(20671,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:57',NULL,NULL),(22524,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:57',NULL,NULL),(9369,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:42',NULL,NULL),(15626,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:39',NULL,NULL),(16066,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:47',NULL,NULL),(23094,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(9936,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:49',NULL,NULL),(12874,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:10',NULL,NULL),(8699,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:52',NULL,NULL),(6757,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:50',NULL,NULL),(7012,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:04',NULL,NULL),(4729,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:33',NULL,NULL),(20208,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:10',NULL,NULL),(22479,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:42',NULL,NULL),(486,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:25',NULL,NULL),(14274,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:16',NULL,NULL),(873,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:43',NULL,NULL),(8941,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:56',NULL,NULL),(12789,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:41',NULL,NULL),(4511,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:40',NULL,NULL),(4619,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:07',NULL,NULL),(5209,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:32',NULL,NULL),(18008,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:56',NULL,NULL),(18235,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:14',NULL,NULL),(18643,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:53',NULL,NULL),(20986,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:31',NULL,NULL),(22493,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:47',NULL,NULL),(7233,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:56',NULL,NULL),(14370,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:51',NULL,NULL),(13753,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:59',NULL,NULL),(13533,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:27',NULL,NULL),(5762,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:01',NULL,NULL),(4005,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:33',NULL,NULL),(4742,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:37',NULL,NULL),(10884,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:06',NULL,NULL),(16227,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:46',NULL,NULL),(22540,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:02',NULL,NULL),(1005,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:19',NULL,NULL),(15092,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:18',NULL,NULL),(15383,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:27',NULL,NULL),(16183,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:31',NULL,NULL),(20737,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:22',NULL,NULL),(21125,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:09',NULL,NULL),(22364,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:04',NULL,NULL),(356,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:41',NULL,NULL),(11722,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:34',NULL,NULL),(509,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:33',NULL,NULL),(7444,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:53',NULL,NULL),(2291,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:36',NULL,NULL),(10227,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:52',NULL,NULL),(9260,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:13',NULL,NULL),(16125,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:10',NULL,NULL),(17196,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:03',NULL,NULL),(17432,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:56',NULL,NULL),(17520,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:25',NULL,NULL),(18484,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:10',NULL,NULL),(19316,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:30',NULL,NULL),(19652,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:05',NULL,NULL),(22549,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:05',NULL,NULL),(23349,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:33',NULL,NULL),(8730,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:00',NULL,NULL),(168,279,'2013-12-27','15:31:00','A','000',0,'2014-01-13 03:04:57',NULL,NULL),(1746,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:14',NULL,NULL),(3018,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:05',NULL,NULL),(14832,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:01',NULL,NULL),(15145,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:36',NULL,NULL),(15427,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:36',NULL,NULL),(18230,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:13',NULL,NULL),(21637,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:34',NULL,NULL),(22014,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:12',NULL,NULL),(560,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:49',NULL,NULL),(7458,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:58',NULL,NULL),(1569,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:13',NULL,NULL),(11717,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:33',NULL,NULL),(11455,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:27',NULL,NULL),(1983,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:35',NULL,NULL),(5205,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:30',NULL,NULL),(9868,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:32',NULL,NULL),(3910,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:10',NULL,NULL),(15002,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:48',NULL,NULL),(17612,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:58',NULL,NULL),(19422,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:00',NULL,NULL),(20520,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:03',NULL,NULL),(593,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:00',NULL,NULL),(10939,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:20',NULL,NULL),(3820,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:47',NULL,NULL),(13702,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:50',NULL,NULL),(6388,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:27',NULL,NULL),(20865,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:58',NULL,NULL),(20897,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:07',NULL,NULL),(22791,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:15',NULL,NULL),(23086,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(1256,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:18',NULL,NULL),(7324,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:21',NULL,NULL),(11782,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:50',NULL,NULL),(9882,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:36',NULL,NULL),(9655,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:36',NULL,NULL),(6276,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:56',NULL,NULL),(6761,1887,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:00:51',NULL,NULL),(3102,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:36',NULL,NULL),(4865,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:10',NULL,NULL),(6295,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:02',NULL,NULL),(6531,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:32:06',NULL,NULL),(3721,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:22',NULL,NULL),(18426,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:53',NULL,NULL),(8092,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:20',NULL,NULL),(2234,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:22',NULL,NULL),(4340,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:55',NULL,NULL),(10432,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:50',NULL,NULL),(7431,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:50',NULL,NULL),(5456,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:40',NULL,NULL),(15692,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:01',NULL,NULL),(16698,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:25',NULL,NULL),(16922,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:38',NULL,NULL),(18370,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:38',NULL,NULL),(23140,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:42',NULL,NULL),(9219,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:02',NULL,NULL),(322,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:30',NULL,NULL),(12828,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:53',NULL,NULL),(5693,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:37',NULL,NULL),(11448,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:25',NULL,NULL),(11410,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:16',NULL,NULL),(11038,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:27',NULL,NULL),(10724,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:26',NULL,NULL),(10471,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:20',NULL,NULL),(2829,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:57',NULL,NULL),(4620,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:02',NULL,NULL),(15944,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:04',NULL,NULL),(16013,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:29',NULL,NULL),(17955,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:38',NULL,NULL),(18221,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:09',NULL,NULL),(19732,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:11',NULL,NULL),(23518,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:31',NULL,NULL),(9406,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:52',NULL,NULL),(12255,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:14',NULL,NULL),(10525,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:34',NULL,NULL),(8598,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:25',NULL,NULL),(6114,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:12',NULL,NULL),(1292,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:00:32',NULL,NULL),(7000,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:02:01',NULL,NULL),(7759,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:00',NULL,NULL),(2038,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:50',NULL,NULL),(1774,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:20',NULL,NULL),(17696,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:29',NULL,NULL),(20777,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:33',NULL,NULL),(611,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:06',NULL,NULL),(14594,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:54',NULL,NULL),(1516,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:55',NULL,NULL),(13103,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:07',NULL,NULL),(12944,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:26',NULL,NULL),(12023,1800,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:10',NULL,NULL),(10299,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:12',NULL,NULL),(16067,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:48',NULL,NULL),(16730,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:37',NULL,NULL),(21790,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:53',NULL,NULL),(23411,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:54',NULL,NULL),(23726,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 13:29:57',NULL,NULL),(9476,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:11',NULL,NULL),(1200,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:12',NULL,NULL),(13811,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:07',NULL,NULL),(13405,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:08',NULL,NULL),(13323,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:06',NULL,NULL),(7809,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:15',NULL,NULL),(12507,1751,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:22',NULL,NULL),(12366,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:47',NULL,NULL),(2037,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:50',NULL,NULL),(2122,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:11',NULL,NULL),(5035,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:59',NULL,NULL),(15938,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:02',NULL,NULL),(19396,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:53',NULL,NULL),(19813,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:32',NULL,NULL),(20812,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:43',NULL,NULL),(1414,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:18',NULL,NULL),(1431,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:24',NULL,NULL),(14807,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:54',NULL,NULL),(2432,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:13',NULL,NULL),(12654,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:02',NULL,NULL),(2515,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:34',NULL,NULL),(3273,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:35',NULL,NULL),(6627,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:17',NULL,NULL),(3538,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:46',NULL,NULL),(7781,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:06',NULL,NULL),(3859,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:57',NULL,NULL),(8100,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:22',NULL,NULL),(8451,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:57',NULL,NULL),(14972,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:38',NULL,NULL),(18417,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:50',NULL,NULL),(22996,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(23525,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-29 22:00:02',NULL,NULL),(2266,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:30',NULL,NULL),(2467,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:22',NULL,NULL),(12171,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:50',NULL,NULL),(3857,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:56',NULL,NULL),(16358,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:15',NULL,NULL),(18395,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:45',NULL,NULL),(18844,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:24',NULL,NULL),(22532,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:59',NULL,NULL),(9183,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:52',NULL,NULL),(14176,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:01',NULL,NULL),(6801,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:03',NULL,NULL),(13084,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:02',NULL,NULL),(13020,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:45',NULL,NULL),(12412,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:21:55',NULL,NULL),(12190,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:55',NULL,NULL),(5227,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:36',NULL,NULL),(10794,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:43',NULL,NULL),(10708,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:22',NULL,NULL),(9968,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:58',NULL,NULL),(3233,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:23',NULL,NULL),(3842,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:52',NULL,NULL),(18162,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:50',NULL,NULL),(20582,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:25',NULL,NULL),(20618,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:39',NULL,NULL),(20917,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:12',NULL,NULL),(235,249,'2013-12-27','15:19:00','A','000',0,'2014-01-13 03:05:19',NULL,NULL),(14405,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:01',NULL,NULL),(14018,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:37',NULL,NULL),(13563,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:32',NULL,NULL),(12386,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:52',NULL,NULL),(11741,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:39',NULL,NULL),(1517,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:55',NULL,NULL),(4398,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:11',NULL,NULL),(2085,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:02',NULL,NULL),(2352,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:52',NULL,NULL),(16205,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:38',NULL,NULL),(23666,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 21:29:58',NULL,NULL),(382,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:49',NULL,NULL),(465,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:18',NULL,NULL),(14230,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:09',NULL,NULL),(13894,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:19',NULL,NULL),(9499,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:56',NULL,NULL),(1622,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:32',NULL,NULL),(9080,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:25',NULL,NULL),(4140,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:04',NULL,NULL),(16043,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:39',NULL,NULL),(16593,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:43',NULL,NULL),(18290,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:16',NULL,NULL),(3049,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:17',NULL,NULL),(2673,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:02',NULL,NULL),(14468,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:20',NULL,NULL),(10455,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:56',NULL,NULL),(12305,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:28',NULL,NULL),(18308,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:21',NULL,NULL),(19530,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:30',NULL,NULL),(23073,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(23243,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(7228,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:54',NULL,NULL),(12360,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:45',NULL,NULL),(12049,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:17',NULL,NULL),(777,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:16',NULL,NULL),(10065,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:08',NULL,NULL),(9504,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:57',NULL,NULL),(10286,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:09',NULL,NULL),(5468,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:43',NULL,NULL),(18572,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:34',NULL,NULL),(19753,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:16',NULL,NULL),(22327,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:51',NULL,NULL),(10153,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:32',NULL,NULL),(15242,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:01',NULL,NULL),(14658,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:13',NULL,NULL),(4360,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:01',NULL,NULL),(13343,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:11',NULL,NULL),(7043,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:12',NULL,NULL),(19033,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:18',NULL,NULL),(22897,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:52',NULL,NULL),(835,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:33',NULL,NULL),(4612,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:05',NULL,NULL),(11204,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:18',NULL,NULL),(10536,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:37',NULL,NULL),(3639,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:32:14',NULL,NULL),(3953,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:21',NULL,NULL),(2803,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:48',NULL,NULL),(15528,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:06',NULL,NULL),(17093,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:29',NULL,NULL),(18839,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:23',NULL,NULL),(18984,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:05',NULL,NULL),(21217,1863,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:41:00',NULL,NULL),(22700,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:41',NULL,NULL),(23039,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(23532,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-30 19:30:02',NULL,NULL),(524,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:38',NULL,NULL),(10134,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:27',NULL,NULL),(3759,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:31',NULL,NULL),(12091,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:28',NULL,NULL),(11016,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:21',NULL,NULL),(7578,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:13',NULL,NULL),(6958,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:49',NULL,NULL),(9517,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:00',NULL,NULL),(9427,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:58',NULL,NULL),(16530,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:20',NULL,NULL),(19343,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:37',NULL,NULL),(19637,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:00',NULL,NULL),(20778,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:33',NULL,NULL),(21187,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:48',NULL,NULL),(23378,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:43',NULL,NULL),(5958,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:08',NULL,NULL),(709,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:39',NULL,NULL),(4292,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:43',NULL,NULL),(16172,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:27',NULL,NULL),(15675,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:56',NULL,NULL),(3985,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:28',NULL,NULL),(14600,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:55',NULL,NULL),(3689,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:13',NULL,NULL),(13431,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:12',NULL,NULL),(9813,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:18',NULL,NULL),(10552,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:41',NULL,NULL),(12025,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:11',NULL,NULL),(19010,1880,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:37:12',NULL,NULL),(20185,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:14',NULL,NULL),(21661,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:07',NULL,NULL),(22585,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:17',NULL,NULL),(39,351,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:37',NULL,NULL),(17189,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:00',NULL,NULL),(16470,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:58',NULL,NULL),(219,223,'2013-12-27','15:10:00','A','000',0,'2014-01-13 03:05:14',NULL,NULL),(15660,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:50',NULL,NULL),(13863,1758,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:14',NULL,NULL),(4407,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:13',NULL,NULL),(10971,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:09',NULL,NULL),(1510,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:53',NULL,NULL),(2529,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:37',NULL,NULL),(19494,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:19',NULL,NULL),(21188,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:49',NULL,NULL),(21511,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:47',NULL,NULL),(22541,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:02',NULL,NULL),(23649,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 19:30:02',NULL,NULL),(715,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:41',NULL,NULL),(17595,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:52',NULL,NULL),(1156,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:00',NULL,NULL),(1890,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:49',NULL,NULL),(3243,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:26',NULL,NULL),(14131,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:54',NULL,NULL),(19816,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:33',NULL,NULL),(21487,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:39',NULL,NULL),(7272,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:06',NULL,NULL),(11132,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:57',NULL,NULL),(14662,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:14',NULL,NULL),(13198,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:33',NULL,NULL),(11915,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:24',NULL,NULL),(22115,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:48',NULL,NULL),(1582,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:18',NULL,NULL),(17379,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:39',NULL,NULL),(14366,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:50',NULL,NULL),(14345,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:30',NULL,NULL),(6510,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:00',NULL,NULL),(6078,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:51',NULL,NULL),(10705,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:21',NULL,NULL),(2804,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:49',NULL,NULL),(5181,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:24',NULL,NULL),(8343,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:29',NULL,NULL),(8141,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:32',NULL,NULL),(3959,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:22',NULL,NULL),(19850,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:41',NULL,NULL),(541,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:43',NULL,NULL),(18135,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:40',NULL,NULL),(2090,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:03',NULL,NULL),(16650,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:07',NULL,NULL),(6319,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:08',NULL,NULL),(2695,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:10',NULL,NULL),(13984,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:32',NULL,NULL),(13954,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:27',NULL,NULL),(4408,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:14',NULL,NULL),(18783,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:08',NULL,NULL),(21699,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:20',NULL,NULL),(23075,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(50,195,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:47',NULL,NULL),(17291,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:10',NULL,NULL),(16870,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:25',NULL,NULL),(16655,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:09',NULL,NULL),(16423,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:40',NULL,NULL),(6756,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:49',NULL,NULL),(6558,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:13',NULL,NULL),(15091,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:18',NULL,NULL),(14861,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:08',NULL,NULL),(6297,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:02',NULL,NULL),(12016,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:08',NULL,NULL),(2318,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:43',NULL,NULL),(2913,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:27',NULL,NULL),(4951,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:35',NULL,NULL),(19107,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:38',NULL,NULL),(20221,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:15',NULL,NULL),(20382,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:13',NULL,NULL),(21151,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:16',NULL,NULL),(2556,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:44',NULL,NULL),(15410,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:33',NULL,NULL),(14755,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:39',NULL,NULL),(13927,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:23',NULL,NULL),(8776,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:12',NULL,NULL),(2732,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:23',NULL,NULL),(7949,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:52',NULL,NULL),(3823,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:48',NULL,NULL),(3934,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:16',NULL,NULL),(4296,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:43',NULL,NULL),(3397,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:08',NULL,NULL),(18658,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:57',NULL,NULL),(19480,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:15',NULL,NULL),(1692,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:59',NULL,NULL),(2446,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:16',NULL,NULL),(14845,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:04',NULL,NULL),(2971,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:48',NULL,NULL),(13703,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:52',NULL,NULL),(13531,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:27',NULL,NULL),(8052,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:09',NULL,NULL),(12652,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:02',NULL,NULL),(11847,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:06',NULL,NULL),(8678,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:46',NULL,NULL),(10401,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:41',NULL,NULL),(20373,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:10',NULL,NULL),(20589,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:28',NULL,NULL),(21078,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:56',NULL,NULL),(21226,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:03',NULL,NULL),(5818,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:20',NULL,NULL),(1160,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:01',NULL,NULL),(17661,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:17',NULL,NULL),(16930,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:40',NULL,NULL),(16447,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:49',NULL,NULL),(15437,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:02:38',NULL,NULL),(14763,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:42',NULL,NULL),(13827,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:09',NULL,NULL),(12219,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:03',NULL,NULL),(1290,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:31',NULL,NULL),(10025,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:57',NULL,NULL),(9847,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:27',NULL,NULL),(9618,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:27',NULL,NULL),(9257,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:12',NULL,NULL),(8398,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:44',NULL,NULL),(3234,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:24',NULL,NULL),(1803,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:28',NULL,NULL),(20511,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:59',NULL,NULL),(21899,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:31',NULL,NULL),(851,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:37',NULL,NULL),(6486,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:54',NULL,NULL),(1699,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:02',NULL,NULL),(15421,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:34',NULL,NULL),(3326,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:49',NULL,NULL),(3461,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:25',NULL,NULL),(18803,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:13',NULL,NULL),(8566,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:17',NULL,NULL),(11068,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:38',NULL,NULL),(9800,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:14',NULL,NULL),(10350,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:27',NULL,NULL),(19231,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:06',NULL,NULL),(20508,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:58',NULL,NULL),(6972,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:53',NULL,NULL),(6028,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:33',NULL,NULL),(5657,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:24',NULL,NULL),(5576,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:15',NULL,NULL),(4893,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:18',NULL,NULL),(14343,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:32:30',NULL,NULL),(12054,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:19',NULL,NULL),(1902,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:52',NULL,NULL),(10964,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:07',NULL,NULL),(20294,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:41',NULL,NULL),(23241,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:01',NULL,NULL),(23400,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:50',NULL,NULL),(6522,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:03',NULL,NULL),(17729,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:40',NULL,NULL),(17193,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:02',NULL,NULL),(15756,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:23',NULL,NULL),(6158,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:25',NULL,NULL),(3800,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:42',NULL,NULL),(3614,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:07',NULL,NULL),(2699,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:11',NULL,NULL),(10910,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:13',NULL,NULL),(2567,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:47',NULL,NULL),(2394,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:02',NULL,NULL),(2036,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:50',NULL,NULL),(22914,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:57',NULL,NULL),(23505,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:27',NULL,NULL),(2263,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:29',NULL,NULL),(6483,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:53',NULL,NULL),(2314,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:42',NULL,NULL),(2526,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:36',NULL,NULL),(3723,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:22',NULL,NULL),(12487,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:16',NULL,NULL),(7912,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:43',NULL,NULL),(9799,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:14',NULL,NULL),(20912,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:11',NULL,NULL),(23018,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 11:00:20',NULL,NULL),(7209,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:47',NULL,NULL),(7183,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:40',NULL,NULL),(4399,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:11',NULL,NULL),(15943,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:04',NULL,NULL),(4850,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:06',NULL,NULL),(19358,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:41',NULL,NULL),(19975,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:16',NULL,NULL),(21951,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:50',NULL,NULL),(22165,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:09',NULL,NULL),(22199,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:18',NULL,NULL),(22375,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:07',NULL,NULL),(879,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:45',NULL,NULL),(18607,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:44',NULL,NULL),(6484,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:53',NULL,NULL),(2004,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:41',NULL,NULL),(18150,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:45',NULL,NULL),(2246,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:25',NULL,NULL),(16176,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:28',NULL,NULL),(2598,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:54',NULL,NULL),(3499,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:35',NULL,NULL),(8310,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:20',NULL,NULL),(13004,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:41',NULL,NULL),(23731,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 23:29:57',NULL,NULL),(655,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:20',NULL,NULL),(15837,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:26',NULL,NULL),(8027,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:02',NULL,NULL),(13401,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:07',NULL,NULL),(7464,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:59',NULL,NULL),(18826,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:20',NULL,NULL),(17797,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:43',NULL,NULL),(17236,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:16',NULL,NULL),(1507,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:51',NULL,NULL),(5150,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:15',NULL,NULL),(9478,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:12',NULL,NULL),(9002,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:03',NULL,NULL),(4311,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:47',NULL,NULL),(21674,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:11',NULL,NULL),(7996,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:04',NULL,NULL),(3810,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:44',NULL,NULL),(11344,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:56',NULL,NULL),(13480,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:19',NULL,NULL),(14315,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:22',NULL,NULL),(19644,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:03',NULL,NULL),(20186,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:14',NULL,NULL),(21136,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:12',NULL,NULL),(23712,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 17:29:59',NULL,NULL),(7584,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:14',NULL,NULL),(16822,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:12',NULL,NULL),(15723,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:04:11',NULL,NULL),(7553,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:06',NULL,NULL),(7172,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:37',NULL,NULL),(11951,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:49',NULL,NULL),(6961,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:50',NULL,NULL),(3779,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:37',NULL,NULL),(3456,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:24',NULL,NULL),(21942,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:47',NULL,NULL),(13579,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:34',NULL,NULL),(17945,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:35',NULL,NULL),(14890,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:16',NULL,NULL),(17090,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:28',NULL,NULL),(15309,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:13',NULL,NULL),(20339,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:57',NULL,NULL),(23334,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:28',NULL,NULL),(23619,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 18:00:02',NULL,NULL),(6626,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:17',NULL,NULL),(729,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:03',NULL,NULL),(2596,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:54',NULL,NULL),(8915,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:50',NULL,NULL),(12492,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:18',NULL,NULL),(15094,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:19',NULL,NULL),(12552,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:34',NULL,NULL),(21928,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:42',NULL,NULL),(23481,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:19',NULL,NULL),(803,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:24',NULL,NULL),(16471,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:58',NULL,NULL),(13486,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:20',NULL,NULL),(13058,1785,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:55',NULL,NULL),(8976,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:06',NULL,NULL),(9651,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:35',NULL,NULL),(224,269,'2013-12-27','15:27:00','A','000',0,'2014-01-13 03:05:15',NULL,NULL),(18250,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:04',NULL,NULL),(14346,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:31',NULL,NULL),(22612,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:27',NULL,NULL),(3508,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:38',NULL,NULL),(18638,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:52',NULL,NULL),(5130,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:10',NULL,NULL),(12280,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:20',NULL,NULL),(17785,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:38',NULL,NULL),(14793,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:50',NULL,NULL),(15785,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:33',NULL,NULL),(21237,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:07',NULL,NULL),(21786,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:51',NULL,NULL),(745,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:08',NULL,NULL),(17079,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:24',NULL,NULL),(6406,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:32',NULL,NULL),(16259,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:59',NULL,NULL),(16250,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:55',NULL,NULL),(15937,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:02',NULL,NULL),(4007,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:34',NULL,NULL),(3767,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:33',NULL,NULL),(940,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:01',NULL,NULL),(9560,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:11',NULL,NULL),(1429,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:23',NULL,NULL),(19898,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:54',NULL,NULL),(22619,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:29',NULL,NULL),(22872,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:43',NULL,NULL),(7748,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:00:57',NULL,NULL),(18932,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:49',NULL,NULL),(17876,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:11',NULL,NULL),(15629,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:40',NULL,NULL),(14616,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:00',NULL,NULL),(13914,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:21',NULL,NULL),(12349,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:42',NULL,NULL),(1708,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:05',NULL,NULL),(8898,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:45',NULL,NULL),(2028,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:48',NULL,NULL),(3470,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:28',NULL,NULL),(3517,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:41',NULL,NULL),(7423,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:47',NULL,NULL),(21393,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:03',NULL,NULL),(6828,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:01:10',NULL,NULL),(17649,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:12',NULL,NULL),(17360,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:32',NULL,NULL),(6243,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:48',NULL,NULL),(17255,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:23',NULL,NULL),(3278,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:36',NULL,NULL),(5040,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:00',NULL,NULL),(14824,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:58',NULL,NULL),(14021,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:38',NULL,NULL),(13308,1735,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:02',NULL,NULL),(12042,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:16',NULL,NULL),(10488,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:24',NULL,NULL),(8217,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:52',NULL,NULL),(19346,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:38',NULL,NULL),(22647,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:23',NULL,NULL),(22873,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:44',NULL,NULL),(23694,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 13:30:02',NULL,NULL),(3340,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:53',NULL,NULL),(19093,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:34',NULL,NULL),(6356,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:18',NULL,NULL),(17365,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:35',NULL,NULL),(16886,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:29',NULL,NULL),(12512,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:23',NULL,NULL),(12883,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:13',NULL,NULL),(20959,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:23',NULL,NULL),(475,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:21',NULL,NULL),(18259,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:06',NULL,NULL),(15216,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:01:56',NULL,NULL),(6999,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:00',NULL,NULL),(13981,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:32',NULL,NULL),(727,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:03',NULL,NULL),(9779,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:08',NULL,NULL),(8662,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:42',NULL,NULL),(3192,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:11',NULL,NULL),(1242,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:13',NULL,NULL),(1337,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:50',NULL,NULL),(21579,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:12',NULL,NULL),(370,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:45',NULL,NULL),(7048,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:13',NULL,NULL),(16421,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:40',NULL,NULL),(17462,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:06',NULL,NULL),(17169,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:54',NULL,NULL),(16517,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:16',NULL,NULL),(16434,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:44',NULL,NULL),(20081,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:46',NULL,NULL),(1250,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:16',NULL,NULL),(7873,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:33',NULL,NULL),(6144,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:22',NULL,NULL),(3556,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:51',NULL,NULL),(18529,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:23',NULL,NULL),(17238,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:17',NULL,NULL),(9315,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:28',NULL,NULL),(10756,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:34',NULL,NULL),(19859,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:44',NULL,NULL),(20105,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:52',NULL,NULL),(1364,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:00',NULL,NULL),(17062,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:18',NULL,NULL),(1784,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:23',NULL,NULL),(2302,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:39',NULL,NULL),(8443,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:55',NULL,NULL),(14253,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:13',NULL,NULL),(9355,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:38',NULL,NULL),(20366,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:07',NULL,NULL),(22010,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:10',NULL,NULL),(23190,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:52',NULL,NULL),(3252,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:29',NULL,NULL),(19301,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:25',NULL,NULL),(3310,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:45',NULL,NULL),(4033,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:40',NULL,NULL),(17322,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:20',NULL,NULL),(7408,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:43',NULL,NULL),(4643,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:08',NULL,NULL),(5146,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:14',NULL,NULL),(20219,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:14',NULL,NULL),(763,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:12',NULL,NULL),(19457,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:10',NULL,NULL),(18157,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:47',NULL,NULL),(2946,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:39',NULL,NULL),(2969,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:47',NULL,NULL),(15429,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:36',NULL,NULL),(13993,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:34',NULL,NULL),(3026,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:07',NULL,NULL),(13613,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:38',NULL,NULL),(13191,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:31',NULL,NULL),(3927,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:14',NULL,NULL),(3620,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:09',NULL,NULL),(10572,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:46',NULL,NULL),(3506,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:37',NULL,NULL),(3209,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:16',NULL,NULL),(3229,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:22',NULL,NULL),(20493,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:53',NULL,NULL),(21298,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:29',NULL,NULL),(22712,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:45',NULL,NULL),(311,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:26',NULL,NULL),(19365,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:44',NULL,NULL),(8531,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:07',NULL,NULL),(419,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:03',NULL,NULL),(7344,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:26',NULL,NULL),(15982,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:17',NULL,NULL),(6131,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:17',NULL,NULL),(15391,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:29',NULL,NULL),(2585,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:51',NULL,NULL),(14788,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:49',NULL,NULL),(13416,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:10',NULL,NULL),(12995,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:39',NULL,NULL),(12919,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:19',NULL,NULL),(4843,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:04',NULL,NULL),(4187,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:16',NULL,NULL),(10902,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:11',NULL,NULL),(8787,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:15',NULL,NULL),(9822,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:20',NULL,NULL),(9446,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:32:03',NULL,NULL),(20795,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:38',NULL,NULL),(21321,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:37',NULL,NULL),(6109,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:11',NULL,NULL),(1483,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:43',NULL,NULL),(2930,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:33',NULL,NULL),(9525,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:03',NULL,NULL),(10001,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:51',NULL,NULL),(11123,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:55',NULL,NULL),(22478,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:42',NULL,NULL),(23552,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 11:30:02',NULL,NULL),(3386,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:05',NULL,NULL),(6771,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:54',NULL,NULL),(18548,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:28',NULL,NULL),(3814,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:46',NULL,NULL),(9564,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:12',NULL,NULL),(9731,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:56',NULL,NULL),(16323,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:03',NULL,NULL),(11985,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:00',NULL,NULL),(15233,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:59',NULL,NULL),(14030,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:39',NULL,NULL),(13561,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:31',NULL,NULL),(21505,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:45',NULL,NULL),(22644,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:22',NULL,NULL),(4014,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:35',NULL,NULL),(4682,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:20',NULL,NULL),(17639,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:08',NULL,NULL),(8056,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:10',NULL,NULL),(7948,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:52',NULL,NULL),(15843,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:28',NULL,NULL),(8944,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:57',NULL,NULL),(12003,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:05',NULL,NULL),(13237,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:43',NULL,NULL),(13205,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:34',NULL,NULL),(12238,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:09',NULL,NULL),(21170,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:42',NULL,NULL),(21901,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:32',NULL,NULL),(1594,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:22',NULL,NULL),(19760,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:18',NULL,NULL),(2985,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:53',NULL,NULL),(13695,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:49',NULL,NULL),(13564,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:32',NULL,NULL),(9483,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:13',NULL,NULL),(12951,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:28',NULL,NULL),(22999,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(23273,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 11:01:07',NULL,NULL),(23453,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:09',NULL,NULL),(691,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:33',NULL,NULL),(7161,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:34',NULL,NULL),(1167,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:03',NULL,NULL),(1579,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:17',NULL,NULL),(2481,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:31:25',NULL,NULL),(13936,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:25',NULL,NULL),(10618,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:57',NULL,NULL),(12733,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:26',NULL,NULL),(12401,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:56',NULL,NULL),(12235,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:08',NULL,NULL),(11843,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:05',NULL,NULL),(20736,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:21',NULL,NULL),(21000,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:34',NULL,NULL),(21048,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:48',NULL,NULL),(21227,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:04',NULL,NULL),(21582,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:14',NULL,NULL),(757,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:11',NULL,NULL),(8316,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:21',NULL,NULL),(20028,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:31',NULL,NULL),(3957,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:22',NULL,NULL),(4723,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:32',NULL,NULL),(6735,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:44',NULL,NULL),(18808,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:15',NULL,NULL),(18037,1892,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:14:07',NULL,NULL),(13970,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:30',NULL,NULL),(13751,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:58',NULL,NULL),(10036,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:00',NULL,NULL),(20825,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:47',NULL,NULL),(22576,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:14',NULL,NULL),(23054,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(9115,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:34',NULL,NULL),(5792,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:11',NULL,NULL),(7541,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:03',NULL,NULL),(18913,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:44',NULL,NULL),(18908,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:42',NULL,NULL),(6053,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:42',NULL,NULL),(17288,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:09',NULL,NULL),(16611,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:51',NULL,NULL),(7428,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:49',NULL,NULL),(8866,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:36',NULL,NULL),(8833,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:27',NULL,NULL),(17480,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:12',NULL,NULL),(17133,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:42',NULL,NULL),(16817,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:11',NULL,NULL),(953,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:05',NULL,NULL),(13675,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:47',NULL,NULL),(5394,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:23',NULL,NULL),(12391,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:53',NULL,NULL),(5198,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:28',NULL,NULL),(19693,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:16',NULL,NULL),(2799,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:47',NULL,NULL),(17791,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:41',NULL,NULL),(17286,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:08',NULL,NULL),(16137,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:15',NULL,NULL),(12943,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:26',NULL,NULL),(5013,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:53',NULL,NULL),(7765,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:01',NULL,NULL),(8767,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:01:10',NULL,NULL),(11610,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:05',NULL,NULL),(6239,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:47',NULL,NULL),(18653,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:56',NULL,NULL),(18035,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:07',NULL,NULL),(1450,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:32',NULL,NULL),(16324,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:03',NULL,NULL),(7601,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:18',NULL,NULL),(7636,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:28',NULL,NULL),(13512,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:24',NULL,NULL),(11200,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:17',NULL,NULL),(10732,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:28',NULL,NULL),(8000,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:05',NULL,NULL),(10101,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:18',NULL,NULL),(20757,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:27',NULL,NULL),(21560,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:05',NULL,NULL),(6635,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:19',NULL,NULL),(15770,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:28',NULL,NULL),(14033,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:40',NULL,NULL),(5634,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:16',NULL,NULL),(5261,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:46',NULL,NULL),(1038,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:28',NULL,NULL),(9332,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:32',NULL,NULL),(4638,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:07',NULL,NULL),(1040,1873,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:31:28',NULL,NULL),(18786,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:09',NULL,NULL),(19008,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:11',NULL,NULL),(19087,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:33',NULL,NULL),(19144,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:49',NULL,NULL),(19958,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:10',NULL,NULL),(4052,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:46',NULL,NULL),(15683,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:58',NULL,NULL),(4960,1881,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:01:38',NULL,NULL),(5042,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:01',NULL,NULL),(12154,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:45',NULL,NULL),(11958,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:51',NULL,NULL),(8556,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:14',NULL,NULL),(11517,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:42',NULL,NULL),(9696,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:47',NULL,NULL),(21254,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:13',NULL,NULL),(21399,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:05',NULL,NULL),(22031,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:18',NULL,NULL),(2963,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:45',NULL,NULL),(18933,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:49',NULL,NULL),(17776,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:35',NULL,NULL),(15863,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:35',NULL,NULL),(15172,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:45',NULL,NULL),(9351,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:37',NULL,NULL),(11978,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:58',NULL,NULL),(21686,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:15',NULL,NULL),(22508,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:51',NULL,NULL),(3745,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:28',NULL,NULL),(18341,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:30',NULL,NULL),(8024,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:13',NULL,NULL),(8488,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:07',NULL,NULL),(14023,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:38',NULL,NULL),(17510,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:22',NULL,NULL),(20792,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:37',NULL,NULL),(8346,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:30',NULL,NULL),(16340,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:09',NULL,NULL),(8815,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:22',NULL,NULL),(14433,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:10',NULL,NULL),(19611,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:52',NULL,NULL),(22754,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:00',NULL,NULL),(253,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:07',NULL,NULL),(17650,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:13',NULL,NULL),(6336,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:12',NULL,NULL),(2840,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:01',NULL,NULL),(13107,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:08',NULL,NULL),(427,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:06',NULL,NULL),(10702,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:20',NULL,NULL),(9634,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:31',NULL,NULL),(19587,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:45',NULL,NULL),(21195,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:51',NULL,NULL),(21580,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:13',NULL,NULL),(21845,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:12',NULL,NULL),(23279,1885,'2014-01-14','23:11:00','A','000',0,'2014-01-24 11:01:08',NULL,NULL),(161,234,'2013-12-27','15:14:00','A','000',0,'2014-01-13 03:04:55',NULL,NULL),(396,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:56',NULL,NULL),(949,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:04',NULL,NULL),(12456,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:07',NULL,NULL),(4367,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:03',NULL,NULL),(11787,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:51',NULL,NULL),(11252,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:31',NULL,NULL),(10701,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:20',NULL,NULL),(10426,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:48',NULL,NULL),(3493,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:34',NULL,NULL),(8135,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:31',NULL,NULL),(19627,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:57',NULL,NULL),(20408,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:23',NULL,NULL),(21704,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:22',NULL,NULL),(22241,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:30',NULL,NULL),(22361,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:03',NULL,NULL),(23059,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(1195,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:11',NULL,NULL),(19266,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:15',NULL,NULL),(1444,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:29',NULL,NULL),(17034,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:09',NULL,NULL),(3117,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:41',NULL,NULL),(16668,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:14',NULL,NULL),(6839,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:13',NULL,NULL),(6257,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:51',NULL,NULL),(15018,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:54',NULL,NULL),(9065,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:20',NULL,NULL),(14382,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:54',NULL,NULL),(13935,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:25',NULL,NULL),(11692,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:26',NULL,NULL),(10346,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:26',NULL,NULL),(20334,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:55',NULL,NULL),(22279,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:39',NULL,NULL),(23043,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(10499,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:27',NULL,NULL),(18580,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:36',NULL,NULL),(15680,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:57',NULL,NULL),(11774,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:48',NULL,NULL),(13866,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:15',NULL,NULL),(20573,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:22',NULL,NULL),(21547,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:01',NULL,NULL),(22374,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:07',NULL,NULL),(22591,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:19',NULL,NULL),(22668,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:30',NULL,NULL),(23579,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 17:30:02',NULL,NULL),(250,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:06',NULL,NULL),(19115,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:40',NULL,NULL),(2620,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:00',NULL,NULL),(6918,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:37',NULL,NULL),(14037,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:40',NULL,NULL),(5696,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:38',NULL,NULL),(8515,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:03',NULL,NULL),(20691,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:08',NULL,NULL),(23040,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:24',NULL,NULL),(1334,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:47',NULL,NULL),(19642,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:02',NULL,NULL),(10485,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:23',NULL,NULL),(12321,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:33',NULL,NULL),(18246,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:03',NULL,NULL),(18164,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:50',NULL,NULL),(13156,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:22',NULL,NULL),(13802,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:06',NULL,NULL),(14517,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:33',NULL,NULL),(19799,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:28',NULL,NULL),(23513,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:29',NULL,NULL),(7812,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:15',NULL,NULL),(19638,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:01',NULL,NULL),(3238,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:25',NULL,NULL),(8552,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:13',NULL,NULL),(8960,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:02:01',NULL,NULL),(9247,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:10',NULL,NULL),(20843,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:51',NULL,NULL),(3744,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:27',NULL,NULL),(3796,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:41',NULL,NULL),(6440,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:41',NULL,NULL),(17766,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:31',NULL,NULL),(14266,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:15',NULL,NULL),(16549,1837,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:19:27',NULL,NULL),(16599,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:46',NULL,NULL),(20628,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:42',NULL,NULL),(21344,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:46',NULL,NULL),(1547,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:06',NULL,NULL),(18753,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:35:59',NULL,NULL),(8306,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:19',NULL,NULL),(5323,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:04',NULL,NULL),(19746,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:14',NULL,NULL),(19200,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:05',NULL,NULL),(4324,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:51',NULL,NULL),(17954,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:38',NULL,NULL),(8433,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:53',NULL,NULL),(9093,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:28',NULL,NULL),(13299,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:59',NULL,NULL),(20211,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:11',NULL,NULL),(20256,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:27',NULL,NULL),(20349,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:00',NULL,NULL),(21713,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:25',NULL,NULL),(22336,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:54',NULL,NULL),(22431,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:26',NULL,NULL),(7685,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:41',NULL,NULL),(7626,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:25',NULL,NULL),(11095,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:47',NULL,NULL),(11792,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:52',NULL,NULL),(16747,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:43',NULL,NULL),(20099,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:51',NULL,NULL),(22029,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:17',NULL,NULL),(22046,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:23',NULL,NULL),(5607,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:06',NULL,NULL),(2568,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:47',NULL,NULL),(19184,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:01',NULL,NULL),(17673,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:21',NULL,NULL),(16581,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:39',NULL,NULL),(8897,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:45',NULL,NULL),(13920,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:22',NULL,NULL),(9186,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:53',NULL,NULL),(10719,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:25',NULL,NULL),(10103,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:19',NULL,NULL),(20153,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:06',NULL,NULL),(21555,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:04',NULL,NULL),(1269,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:24',NULL,NULL),(20176,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:12',NULL,NULL),(19903,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:55',NULL,NULL),(18858,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:28',NULL,NULL),(2635,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:04',NULL,NULL),(18042,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:09',NULL,NULL),(3218,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:19',NULL,NULL),(3391,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:07',NULL,NULL),(4286,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:41',NULL,NULL),(5288,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:55',NULL,NULL),(5954,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:06',NULL,NULL),(10277,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:06',NULL,NULL),(9149,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:44',NULL,NULL),(20421,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:27',NULL,NULL),(21386,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:01',NULL,NULL),(1273,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:25',NULL,NULL),(15113,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:25',NULL,NULL),(12772,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:36',NULL,NULL),(12616,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:52',NULL,NULL),(1792,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:25',NULL,NULL),(11526,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:44',NULL,NULL),(3399,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:09',NULL,NULL),(6506,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:59',NULL,NULL),(5800,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:14',NULL,NULL),(3806,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:43',NULL,NULL),(4443,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:23',NULL,NULL),(20716,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:15',NULL,NULL),(23045,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:25',NULL,NULL),(23374,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:41',NULL,NULL),(542,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:43',NULL,NULL),(673,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:27',NULL,NULL),(2807,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:50',NULL,NULL),(3948,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:19',NULL,NULL),(6352,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:17',NULL,NULL),(5621,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:00:11',NULL,NULL),(12678,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:09',NULL,NULL),(22045,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:23',NULL,NULL),(1591,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:21',NULL,NULL),(2068,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:57',NULL,NULL),(7683,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:40',NULL,NULL),(19292,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:23',NULL,NULL),(18569,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:33',NULL,NULL),(18474,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:07',NULL,NULL),(10917,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:15',NULL,NULL),(17835,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:57',NULL,NULL),(12612,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:51',NULL,NULL),(16461,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:55',NULL,NULL),(13893,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:19',NULL,NULL),(21192,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:40:50',NULL,NULL),(23231,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(23377,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:42',NULL,NULL),(823,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:29',NULL,NULL),(19588,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:46',NULL,NULL),(7743,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:55',NULL,NULL),(7939,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:50',NULL,NULL),(10099,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:18',NULL,NULL),(10959,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:05',NULL,NULL),(18377,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:40',NULL,NULL),(18559,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:31',NULL,NULL),(21213,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:58',NULL,NULL),(21915,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:37',NULL,NULL),(1203,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:13',NULL,NULL),(17021,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:04',NULL,NULL),(16803,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:07',NULL,NULL),(16740,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:40',NULL,NULL),(5500,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:53',NULL,NULL),(2565,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:46',NULL,NULL),(14650,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:11',NULL,NULL),(13960,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:28',NULL,NULL),(12337,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:38',NULL,NULL),(8841,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:29',NULL,NULL),(21833,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:08',NULL,NULL),(6612,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:13',NULL,NULL),(11631,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:11',NULL,NULL),(4733,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:34',NULL,NULL),(5315,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:02',NULL,NULL),(7600,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:18',NULL,NULL),(20639,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:46',NULL,NULL),(714,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:41',NULL,NULL),(1959,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:29',NULL,NULL),(2016,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:44',NULL,NULL),(14028,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:39',NULL,NULL),(12210,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:01',NULL,NULL),(9061,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:19',NULL,NULL),(3126,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:44',NULL,NULL),(19754,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:16',NULL,NULL),(20471,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:45',NULL,NULL),(22484,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:44',NULL,NULL),(22611,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:26',NULL,NULL),(446,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:12',NULL,NULL),(6913,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:36',NULL,NULL),(6606,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:12',NULL,NULL),(3601,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:32:03',NULL,NULL),(16555,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:29',NULL,NULL),(2297,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:37',NULL,NULL),(8906,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:47',NULL,NULL),(5615,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:09',NULL,NULL),(1375,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:05',NULL,NULL),(4448,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:24',NULL,NULL),(3225,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:21',NULL,NULL),(7384,1895,'2014-01-14','23:11:00','A','000',0,'2014-01-24 02:31:37',NULL,NULL),(7789,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:08',NULL,NULL),(18754,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:00',NULL,NULL),(21764,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:44',NULL,NULL),(22402,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:16',NULL,NULL),(7052,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:14',NULL,NULL),(6976,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:54',NULL,NULL),(14822,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:58',NULL,NULL),(4879,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:14',NULL,NULL),(13409,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:09',NULL,NULL),(4510,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:40',NULL,NULL),(685,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:31',NULL,NULL),(3522,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:42',NULL,NULL),(2747,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:00:29',NULL,NULL),(1683,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:55',NULL,NULL),(9665,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:39',NULL,NULL),(20326,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:52',NULL,NULL),(20523,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:04',NULL,NULL),(21719,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:27',NULL,NULL),(2340,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:49',NULL,NULL),(17226,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:13',NULL,NULL),(3485,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:32',NULL,NULL),(5464,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:42',NULL,NULL),(8686,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:48',NULL,NULL),(9201,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:57',NULL,NULL),(12717,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:21',NULL,NULL),(11812,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:57',NULL,NULL),(19806,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:30',NULL,NULL),(2045,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:52',NULL,NULL),(16845,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:18',NULL,NULL),(4667,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:16',NULL,NULL),(13876,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:16',NULL,NULL),(4048,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:45',NULL,NULL),(2691,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:09',NULL,NULL),(7897,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:39',NULL,NULL),(17911,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:23',NULL,NULL),(9027,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:10',NULL,NULL),(20705,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:12',NULL,NULL),(21615,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:26',NULL,NULL),(23507,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:27',NULL,NULL),(829,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:31',NULL,NULL),(17547,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:34',NULL,NULL),(1300,1863,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:00:35',NULL,NULL),(6900,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:31',NULL,NULL),(6233,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:45',NULL,NULL),(2098,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:05',NULL,NULL),(8312,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:20',NULL,NULL),(4455,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:26',NULL,NULL),(3437,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:19',NULL,NULL),(20701,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:11',NULL,NULL),(21503,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:44',NULL,NULL),(21821,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:04',NULL,NULL),(6721,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:41',NULL,NULL),(10575,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:47',NULL,NULL),(21208,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:56',NULL,NULL),(1019,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:23',NULL,NULL),(7500,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:09',NULL,NULL),(2557,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:44',NULL,NULL),(2621,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:01',NULL,NULL),(14762,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:41',NULL,NULL),(5330,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:06',NULL,NULL),(13044,1695,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:52',NULL,NULL),(5326,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:05',NULL,NULL),(8590,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:23',NULL,NULL),(8646,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:38',NULL,NULL),(10748,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:32',NULL,NULL),(9274,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:17',NULL,NULL),(21122,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:08',NULL,NULL),(22196,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:17',NULL,NULL),(355,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:40',NULL,NULL),(17521,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:26',NULL,NULL),(6296,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:02',NULL,NULL),(16686,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:21',NULL,NULL),(16354,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:14',NULL,NULL),(5955,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:07',NULL,NULL),(14316,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:22',NULL,NULL),(12849,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:24:01',NULL,NULL),(4483,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:33',NULL,NULL),(11691,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:26',NULL,NULL),(4079,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:53',NULL,NULL),(2189,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:03',NULL,NULL),(19580,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:44',NULL,NULL),(6227,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:44',NULL,NULL),(2942,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:37',NULL,NULL),(11540,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:48',NULL,NULL),(16112,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:05',NULL,NULL),(14078,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:46',NULL,NULL),(12363,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:46',NULL,NULL),(13453,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:15',NULL,NULL),(21705,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:22',NULL,NULL),(21839,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:10',NULL,NULL),(22072,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:33',NULL,NULL),(22408,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:18',NULL,NULL),(23134,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(837,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:33',NULL,NULL),(7448,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:54',NULL,NULL),(13881,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:17',NULL,NULL),(13133,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:16',NULL,NULL),(7288,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:11',NULL,NULL),(12406,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:21:53',NULL,NULL),(11556,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:52',NULL,NULL),(11006,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:18',NULL,NULL),(9372,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:43',NULL,NULL),(9314,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:27',NULL,NULL),(2975,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:49',NULL,NULL),(4781,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:47',NULL,NULL),(4267,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:36',NULL,NULL),(19563,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:39',NULL,NULL),(21818,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:03',NULL,NULL),(317,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:28',NULL,NULL),(19015,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:13',NULL,NULL),(15796,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:37',NULL,NULL),(14887,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:15',NULL,NULL),(12935,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:23',NULL,NULL),(7525,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:32:16',NULL,NULL),(12063,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:21',NULL,NULL),(6180,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:31',NULL,NULL),(2057,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:55',NULL,NULL),(8492,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:32:08',NULL,NULL),(4184,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:15',NULL,NULL),(21281,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:23',NULL,NULL),(23629,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 02:00:03',NULL,NULL),(639,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:15',NULL,NULL),(7089,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:14',NULL,NULL),(16582,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:39',NULL,NULL),(4077,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:52',NULL,NULL),(9188,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:54',NULL,NULL),(9972,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:59',NULL,NULL),(10683,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:16',NULL,NULL),(10780,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:40',NULL,NULL),(10821,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:50',NULL,NULL),(19823,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:34',NULL,NULL),(19876,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:48',NULL,NULL),(21236,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:07',NULL,NULL),(7289,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:11',NULL,NULL),(689,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:33',NULL,NULL),(17853,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:03',NULL,NULL),(17634,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:06',NULL,NULL),(16726,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:35',NULL,NULL),(6249,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:49',NULL,NULL),(6168,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:28',NULL,NULL),(3039,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:14',NULL,NULL),(13945,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:26',NULL,NULL),(4144,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:05',NULL,NULL),(4121,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:03',NULL,NULL),(9157,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:46',NULL,NULL),(3929,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:15',NULL,NULL),(3280,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:37',NULL,NULL),(21425,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:15',NULL,NULL),(22219,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:24',NULL,NULL),(592,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:02:00',NULL,NULL),(19324,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:32',NULL,NULL),(19283,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:20',NULL,NULL),(18364,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:36',NULL,NULL),(17586,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:48',NULL,NULL),(16452,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:51',NULL,NULL),(15948,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:05',NULL,NULL),(7837,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:22',NULL,NULL),(8365,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:35',NULL,NULL),(3531,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:44',NULL,NULL),(663,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:22',NULL,NULL),(2837,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:00',NULL,NULL),(2703,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:13',NULL,NULL),(6077,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:50',NULL,NULL),(7603,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:19',NULL,NULL),(1021,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:23',NULL,NULL),(20168,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:10',NULL,NULL),(20593,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:29',NULL,NULL),(20722,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:18',NULL,NULL),(23380,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:43',NULL,NULL),(2520,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:35',NULL,NULL),(6170,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:29',NULL,NULL),(18869,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:31',NULL,NULL),(17935,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:31',NULL,NULL),(17550,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:35',NULL,NULL),(8763,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:09',NULL,NULL),(16311,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:58',NULL,NULL),(11770,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:47',NULL,NULL),(11751,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:42',NULL,NULL),(19589,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:46',NULL,NULL),(20943,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:19',NULL,NULL),(6290,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:00',NULL,NULL),(5770,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:03',NULL,NULL),(15650,1844,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:03:47',NULL,NULL),(15602,1673,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:31',NULL,NULL),(5668,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:28',NULL,NULL),(859,1862,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:30:39',NULL,NULL),(2363,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:54',NULL,NULL),(10847,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:56',NULL,NULL),(4768,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:43',NULL,NULL),(8737,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:02',NULL,NULL),(19634,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:00',NULL,NULL),(710,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:40',NULL,NULL),(1465,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:37',NULL,NULL),(5202,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:30',NULL,NULL),(17397,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:45',NULL,NULL),(2303,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:39',NULL,NULL),(11067,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:38',NULL,NULL),(12200,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:58',NULL,NULL),(14428,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:08',NULL,NULL),(19660,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:07',NULL,NULL),(20948,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:20',NULL,NULL),(22000,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:07',NULL,NULL),(11596,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:02',NULL,NULL),(15521,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:04',NULL,NULL),(18589,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:39',NULL,NULL),(16838,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:16',NULL,NULL),(22505,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:51',NULL,NULL),(7097,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:16',NULL,NULL),(23705,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 19:30:00',NULL,NULL),(3089,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:31',NULL,NULL),(16045,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:40',NULL,NULL),(14007,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:36',NULL,NULL),(15039,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:01',NULL,NULL),(15367,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:24',NULL,NULL),(18073,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:19',NULL,NULL),(19425,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:01',NULL,NULL),(22293,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:42',NULL,NULL),(22474,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:41',NULL,NULL),(11009,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:19',NULL,NULL),(353,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:40',NULL,NULL),(15972,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:14',NULL,NULL),(2921,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:30',NULL,NULL),(10020,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:39:56',NULL,NULL),(14447,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:14',NULL,NULL),(14393,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:49:58',NULL,NULL),(12836,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:56',NULL,NULL),(8530,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:07',NULL,NULL),(17580,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:46',NULL,NULL),(17684,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:25',NULL,NULL),(17976,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:45',NULL,NULL),(18309,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:21',NULL,NULL),(18738,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:55',NULL,NULL),(19604,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:50',NULL,NULL),(20432,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:32',NULL,NULL),(20811,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:43',NULL,NULL),(22171,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:10',NULL,NULL),(22521,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:56',NULL,NULL),(6498,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:57',NULL,NULL),(17143,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:45',NULL,NULL),(13354,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:14',NULL,NULL),(18661,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:58',NULL,NULL),(19518,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:26',NULL,NULL),(19710,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:04',NULL,NULL),(20400,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:20',NULL,NULL),(20878,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:01',NULL,NULL),(21005,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:36',NULL,NULL),(95,293,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:28',NULL,NULL),(8926,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:52',NULL,NULL),(15910,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:52',NULL,NULL),(15798,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:37',NULL,NULL),(1017,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:22',NULL,NULL),(9606,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:24',NULL,NULL),(13386,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:03',NULL,NULL),(10155,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:33',NULL,NULL),(12549,1754,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:33',NULL,NULL),(1908,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:54',NULL,NULL),(1944,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:02',NULL,NULL),(6608,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:12',NULL,NULL),(5784,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:08',NULL,NULL),(17852,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:03',NULL,NULL),(18491,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:12',NULL,NULL),(19858,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:43',NULL,NULL),(22277,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:39',NULL,NULL),(22880,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:46',NULL,NULL),(1412,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:17',NULL,NULL),(4307,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:46',NULL,NULL),(6770,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:53',NULL,NULL),(8747,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:04',NULL,NULL),(9895,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:39',NULL,NULL),(20385,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:14',NULL,NULL),(20951,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:21',NULL,NULL),(21082,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:57',NULL,NULL),(21586,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:15',NULL,NULL),(5795,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:12',NULL,NULL),(17375,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:38',NULL,NULL),(1577,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:16',NULL,NULL),(16122,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:09',NULL,NULL),(1732,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:10',NULL,NULL),(2270,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:31',NULL,NULL),(14770,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:44',NULL,NULL),(4730,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:33',NULL,NULL),(2740,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:26',NULL,NULL),(2775,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:39',NULL,NULL),(12829,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:53',NULL,NULL),(10320,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:18',NULL,NULL),(20519,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:02',NULL,NULL),(21640,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:36',NULL,NULL),(23305,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:17',NULL,NULL),(898,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:50',NULL,NULL),(7410,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:44',NULL,NULL),(14055,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:43',NULL,NULL),(8661,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:42',NULL,NULL),(18775,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:05',NULL,NULL),(20466,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:44',NULL,NULL),(20946,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:20',NULL,NULL),(22121,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:50',NULL,NULL),(22945,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:06',NULL,NULL),(23251,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(698,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:35',NULL,NULL),(17362,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:33',NULL,NULL),(14857,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:07',NULL,NULL),(1845,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:38',NULL,NULL),(9994,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:49',NULL,NULL),(7758,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:59',NULL,NULL),(7251,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:01',NULL,NULL),(6604,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:11',NULL,NULL),(17765,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:31',NULL,NULL),(18835,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:22',NULL,NULL),(19238,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:08',NULL,NULL),(20674,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:58',NULL,NULL),(6327,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:10',NULL,NULL),(6094,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:07',NULL,NULL),(15247,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:01',NULL,NULL),(6642,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:21',NULL,NULL),(10763,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:35',NULL,NULL),(10274,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:05',NULL,NULL),(9923,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:46',NULL,NULL),(7794,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:09',NULL,NULL),(9043,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:14',NULL,NULL),(9220,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:03',NULL,NULL),(18418,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:51',NULL,NULL),(20144,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:03',NULL,NULL),(20885,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:04',NULL,NULL),(5666,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:27',NULL,NULL),(16153,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:20',NULL,NULL),(14204,1739,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:05',NULL,NULL),(13815,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:08',NULL,NULL),(12851,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:24:01',NULL,NULL),(3137,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:48',NULL,NULL),(7439,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:52',NULL,NULL),(19899,1857,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:54',NULL,NULL),(6443,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:42',NULL,NULL),(3131,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:46',NULL,NULL),(3646,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:02',NULL,NULL),(3829,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:49',NULL,NULL),(4538,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:47',NULL,NULL),(6927,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:40',NULL,NULL),(8257,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:03',NULL,NULL),(10326,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:20',NULL,NULL),(8462,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:00',NULL,NULL),(8651,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:39',NULL,NULL),(19471,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:13',NULL,NULL),(21018,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:39',NULL,NULL),(21636,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:34',NULL,NULL),(22507,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:51',NULL,NULL),(218,327,'2013-12-27','15:46:00','A','000',0,'2014-01-13 03:05:13',NULL,NULL),(16662,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:12',NULL,NULL),(7496,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:08',NULL,NULL),(10882,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:06',NULL,NULL),(12046,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:17',NULL,NULL),(23329,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:26',NULL,NULL),(1624,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:33',NULL,NULL),(17830,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:54',NULL,NULL),(5591,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:19',NULL,NULL),(3160,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:30:02',NULL,NULL),(12463,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:09',NULL,NULL),(12134,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:40',NULL,NULL),(12004,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:05',NULL,NULL),(10764,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:36',NULL,NULL),(3579,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:57',NULL,NULL),(6694,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:34',NULL,NULL),(19146,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:50',NULL,NULL),(21584,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:43:14',NULL,NULL),(23330,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:26',NULL,NULL),(6166,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:28',NULL,NULL),(5255,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:44',NULL,NULL),(4594,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:01',NULL,NULL),(16008,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:27',NULL,NULL),(15540,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:10',NULL,NULL),(7943,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:51',NULL,NULL),(14738,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:34',NULL,NULL),(9146,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:43',NULL,NULL),(13718,1796,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:54',NULL,NULL),(10161,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:34',NULL,NULL),(9176,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:51',NULL,NULL),(19345,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:37',NULL,NULL),(20173,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:11',NULL,NULL),(23348,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:32',NULL,NULL),(3148,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:52',NULL,NULL),(9790,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:11',NULL,NULL),(16760,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:47',NULL,NULL),(13264,1843,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:50',NULL,NULL),(13249,1820,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:46',NULL,NULL),(10123,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:24',NULL,NULL),(18534,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:24',NULL,NULL),(19175,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:58',NULL,NULL),(19624,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:55',NULL,NULL),(21127,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:10',NULL,NULL),(2984,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:52',NULL,NULL),(8361,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:34',NULL,NULL),(15996,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:23',NULL,NULL),(14647,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:10',NULL,NULL),(8589,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:22',NULL,NULL),(8936,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:55',NULL,NULL),(11013,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:20',NULL,NULL),(10991,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:14',NULL,NULL),(18917,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:45',NULL,NULL),(19334,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:34',NULL,NULL),(19663,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:08',NULL,NULL),(19936,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:04',NULL,NULL),(20275,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:34',NULL,NULL),(20662,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:54',NULL,NULL),(20692,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:08',NULL,NULL),(21552,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:03',NULL,NULL),(21879,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:24',NULL,NULL),(22756,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:01',NULL,NULL),(7713,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:48',NULL,NULL),(17575,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:44',NULL,NULL),(16160,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:23',NULL,NULL),(9967,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:58',NULL,NULL),(20342,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:58',NULL,NULL),(22624,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:15',NULL,NULL),(567,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:52',NULL,NULL),(867,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:41',NULL,NULL),(1889,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:49',NULL,NULL),(5289,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:55',NULL,NULL),(3928,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:14',NULL,NULL),(11301,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:44',NULL,NULL),(3047,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:17',NULL,NULL),(9407,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:52',NULL,NULL),(8287,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:13',NULL,NULL),(22372,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:06',NULL,NULL),(23281,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:09',NULL,NULL),(2638,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:05',NULL,NULL),(17804,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:46',NULL,NULL),(5820,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:21',NULL,NULL),(16424,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:41',NULL,NULL),(8308,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:19',NULL,NULL),(14507,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:30',NULL,NULL),(10805,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:46',NULL,NULL),(9690,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:45',NULL,NULL),(9532,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:36:04',NULL,NULL),(9003,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:03',NULL,NULL),(18746,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:57',NULL,NULL),(21009,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:37',NULL,NULL),(21218,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:00',NULL,NULL),(1139,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:55',NULL,NULL),(17607,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:57',NULL,NULL),(2856,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:07',NULL,NULL),(13975,1719,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:31',NULL,NULL),(12532,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:29',NULL,NULL),(12402,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:56',NULL,NULL),(11953,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:50',NULL,NULL),(11033,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:26',NULL,NULL),(3041,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:15',NULL,NULL),(4888,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:16',NULL,NULL),(3583,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:58',NULL,NULL),(7519,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:14',NULL,NULL),(7766,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:01',NULL,NULL),(19028,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:17',NULL,NULL),(20375,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:11',NULL,NULL),(22864,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:41',NULL,NULL),(23235,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(463,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:17',NULL,NULL),(1646,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:40',NULL,NULL),(16287,1838,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:17:09',NULL,NULL),(2491,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:28',NULL,NULL),(15488,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:52',NULL,NULL),(13910,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:21',NULL,NULL),(2680,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:05',NULL,NULL),(13158,1720,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:22',NULL,NULL),(12928,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:21',NULL,NULL),(12775,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:37',NULL,NULL),(12560,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:36',NULL,NULL),(16957,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:46',NULL,NULL),(17271,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:03',NULL,NULL),(20640,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:47',NULL,NULL),(21929,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:42',NULL,NULL),(1347,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:53',NULL,NULL),(15606,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:32',NULL,NULL),(8538,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:09',NULL,NULL),(5724,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:47',NULL,NULL),(33,283,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:31',NULL,NULL),(12411,1828,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:21:55',NULL,NULL),(10154,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:32',NULL,NULL),(8096,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:21',NULL,NULL),(6930,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:42',NULL,NULL),(3476,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:29',NULL,NULL),(11032,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:25',NULL,NULL),(3124,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:43',NULL,NULL),(19199,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:38:05',NULL,NULL),(22898,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:52',NULL,NULL),(8551,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:13',NULL,NULL),(15549,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:13',NULL,NULL),(7950,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:52',NULL,NULL),(3645,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:16',NULL,NULL),(4793,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:50',NULL,NULL),(5092,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:15',NULL,NULL),(11939,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:46',NULL,NULL),(11162,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:05',NULL,NULL),(17014,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:02',NULL,NULL),(17465,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:07',NULL,NULL),(18093,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:26',NULL,NULL),(21526,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:53',NULL,NULL),(21698,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:20',NULL,NULL),(10190,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:42',NULL,NULL),(16617,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:53',NULL,NULL),(15985,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:18',NULL,NULL),(15198,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:01:52',NULL,NULL),(3408,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:11',NULL,NULL),(13379,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:21',NULL,NULL),(6807,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:05',NULL,NULL),(3834,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:51',NULL,NULL),(17645,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:11',NULL,NULL),(18665,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:59',NULL,NULL),(20003,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:24',NULL,NULL),(20491,1891,'2014-01-14','23:11:00','A','000',0,'2014-01-24 09:01:52',NULL,NULL),(10054,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:05',NULL,NULL),(15456,1660,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:41',NULL,NULL),(15195,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:51',NULL,NULL),(8437,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:54',NULL,NULL),(3305,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:43',NULL,NULL),(12329,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:36',NULL,NULL),(12107,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:33',NULL,NULL),(5572,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:14',NULL,NULL),(6975,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:53',NULL,NULL),(17069,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:21',NULL,NULL),(17700,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:02:30',NULL,NULL),(19636,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:00',NULL,NULL),(21635,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:43:34',NULL,NULL),(22404,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:17',NULL,NULL),(10481,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:22',NULL,NULL),(2035,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:49',NULL,NULL),(2636,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:32:05',NULL,NULL),(14371,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:49:51',NULL,NULL),(2937,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:35',NULL,NULL),(7787,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:08',NULL,NULL),(8829,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:26',NULL,NULL),(8249,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:01',NULL,NULL),(19444,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:06',NULL,NULL),(22763,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:04',NULL,NULL),(23232,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:00',NULL,NULL),(10366,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:31',NULL,NULL),(16739,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:40',NULL,NULL),(16345,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:10',NULL,NULL),(16117,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:08',NULL,NULL),(14437,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:11',NULL,NULL),(13372,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:19',NULL,NULL),(12600,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:47',NULL,NULL),(11439,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:23',NULL,NULL),(11288,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:41',NULL,NULL),(6342,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:14',NULL,NULL),(18356,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:34',NULL,NULL),(18479,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:09',NULL,NULL),(20324,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:52',NULL,NULL),(20734,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:21',NULL,NULL),(21246,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:10',NULL,NULL),(22443,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:30',NULL,NULL),(22628,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:16',NULL,NULL),(22755,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:01',NULL,NULL),(1382,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:07',NULL,NULL),(1665,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:48',NULL,NULL),(10302,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:13',NULL,NULL),(16249,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:55',NULL,NULL),(14679,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:19',NULL,NULL),(5374,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:18',NULL,NULL),(9231,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:06',NULL,NULL),(3239,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:25',NULL,NULL),(2592,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:53',NULL,NULL),(2781,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:41',NULL,NULL),(18467,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:05',NULL,NULL),(19277,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:18',NULL,NULL),(20021,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:29',NULL,NULL),(22762,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:04',NULL,NULL),(11612,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:06',NULL,NULL),(15045,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:03',NULL,NULL),(16440,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:47',NULL,NULL),(20867,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:58',NULL,NULL),(22437,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:28',NULL,NULL),(23409,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:53',NULL,NULL),(660,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:21',NULL,NULL),(15282,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:08',NULL,NULL),(4981,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:44',NULL,NULL),(843,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:35',NULL,NULL),(13642,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:42',NULL,NULL),(3591,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:32:00',NULL,NULL),(12034,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:13',NULL,NULL),(12011,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:07',NULL,NULL),(9626,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:29',NULL,NULL),(18541,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:26',NULL,NULL),(21465,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:30',NULL,NULL),(23109,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(23177,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(23283,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:09',NULL,NULL),(5550,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:08',NULL,NULL),(16571,1802,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:35',NULL,NULL),(5490,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:50',NULL,NULL),(3045,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:16',NULL,NULL),(11791,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:52',NULL,NULL),(10925,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:17',NULL,NULL),(10330,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:21',NULL,NULL),(8288,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:13',NULL,NULL),(21093,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:00',NULL,NULL),(22868,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:42',NULL,NULL),(23336,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:28',NULL,NULL),(23438,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:03',NULL,NULL),(23708,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 01:30:00',NULL,NULL),(1619,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:31',NULL,NULL),(8793,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:17',NULL,NULL),(22716,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:47',NULL,NULL),(5393,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:23',NULL,NULL),(16001,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:24',NULL,NULL),(15899,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:48',NULL,NULL),(15143,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:35',NULL,NULL),(6281,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:58',NULL,NULL),(6502,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:58',NULL,NULL),(18209,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:05',NULL,NULL),(18590,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:39',NULL,NULL),(19076,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:30',NULL,NULL),(21245,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:10',NULL,NULL),(21966,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:55',NULL,NULL),(23316,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:21',NULL,NULL),(23351,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:34',NULL,NULL),(5732,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:50',NULL,NULL),(17558,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:38',NULL,NULL),(16923,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:38',NULL,NULL),(16577,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:37',NULL,NULL),(4414,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:15',NULL,NULL),(888,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:47',NULL,NULL),(14210,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:06',NULL,NULL),(6746,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:47',NULL,NULL),(6937,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:44',NULL,NULL),(8623,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:31',NULL,NULL),(9087,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:27',NULL,NULL),(23510,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:28',NULL,NULL),(1031,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:26',NULL,NULL),(2763,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:34',NULL,NULL),(17063,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:19',NULL,NULL),(6488,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:54',NULL,NULL),(13251,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:47',NULL,NULL),(8414,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:48',NULL,NULL),(13079,1749,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:01',NULL,NULL),(5623,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:12',NULL,NULL),(16343,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:10',NULL,NULL),(15919,1699,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:55',NULL,NULL),(4656,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:12',NULL,NULL),(4137,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:03',NULL,NULL),(10737,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:29',NULL,NULL),(7069,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:06',NULL,NULL),(19980,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:17',NULL,NULL),(2109,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:07',NULL,NULL),(16619,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:54',NULL,NULL),(16170,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:26',NULL,NULL),(6150,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:23',NULL,NULL),(2368,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:55',NULL,NULL),(4096,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:57',NULL,NULL),(12407,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:54',NULL,NULL),(8532,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:07',NULL,NULL),(9581,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:17',NULL,NULL),(20136,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:32:01',NULL,NULL),(21197,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:52',NULL,NULL),(21470,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:31',NULL,NULL),(2821,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:55',NULL,NULL),(5511,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:56',NULL,NULL),(5106,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:01',NULL,NULL),(3626,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:10',NULL,NULL),(4244,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:30',NULL,NULL),(6542,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:08',NULL,NULL),(10938,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:20',NULL,NULL),(9940,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:50',NULL,NULL),(9687,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:45',NULL,NULL),(19053,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:23',NULL,NULL),(19905,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:56',NULL,NULL),(20880,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:02',NULL,NULL),(22678,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:33',NULL,NULL),(2774,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:38',NULL,NULL),(7749,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:57',NULL,NULL),(8319,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:22',NULL,NULL),(8795,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:17',NULL,NULL),(13337,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:10',NULL,NULL),(19126,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:44',NULL,NULL),(21693,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:18',NULL,NULL),(5011,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:52',NULL,NULL),(4337,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:55',NULL,NULL),(3263,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:32',NULL,NULL),(11883,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:15',NULL,NULL),(11107,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:50',NULL,NULL),(19221,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:03',NULL,NULL),(20235,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:20',NULL,NULL),(20490,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:52',NULL,NULL),(23730,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 22:29:56',NULL,NULL),(241,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:03',NULL,NULL),(760,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:12',NULL,NULL),(4947,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:01:34',NULL,NULL),(4269,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:37',NULL,NULL),(12687,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:12',NULL,NULL),(6827,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:10',NULL,NULL),(8536,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:09',NULL,NULL),(8782,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:14',NULL,NULL),(10220,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:50',NULL,NULL),(10149,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:31',NULL,NULL),(8846,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:31',NULL,NULL),(21567,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:08',NULL,NULL),(23022,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:20',NULL,NULL),(780,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:17',NULL,NULL),(17538,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:31',NULL,NULL),(17424,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:54',NULL,NULL),(7411,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:44',NULL,NULL),(7592,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:16',NULL,NULL),(16914,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:36',NULL,NULL),(7798,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:11',NULL,NULL),(12747,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:29',NULL,NULL),(18378,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:30:40',NULL,NULL),(20882,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:02',NULL,NULL),(2169,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:23',NULL,NULL),(16123,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:10',NULL,NULL),(15263,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:04',NULL,NULL),(15136,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:33',NULL,NULL),(2758,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:33',NULL,NULL),(14365,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:49',NULL,NULL),(13729,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:55',NULL,NULL),(22356,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:01',NULL,NULL),(4164,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:10',NULL,NULL),(18068,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:18',NULL,NULL),(2814,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:52',NULL,NULL),(17306,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:15',NULL,NULL),(8265,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:05',NULL,NULL),(9786,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:10',NULL,NULL),(10342,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:25',NULL,NULL),(10923,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:46:16',NULL,NULL),(21750,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:39',NULL,NULL),(22394,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:14',NULL,NULL),(198,229,'2013-12-27','15:12:00','A','000',0,'2014-01-13 03:05:07',NULL,NULL),(3294,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:40',NULL,NULL),(17556,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:37',NULL,NULL),(4986,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:45',NULL,NULL),(17019,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:04',NULL,NULL),(13141,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:18',NULL,NULL),(9811,1875,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:37:17',NULL,NULL),(9419,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:55',NULL,NULL),(8513,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:02',NULL,NULL),(19989,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:20',NULL,NULL),(20459,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:41',NULL,NULL),(21228,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:04',NULL,NULL),(1988,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:37',NULL,NULL),(19205,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:38:07',NULL,NULL),(18664,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:59',NULL,NULL),(3042,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:15',NULL,NULL),(8162,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:38',NULL,NULL),(3512,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:39',NULL,NULL),(17709,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:34',NULL,NULL),(7074,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:09',NULL,NULL),(12306,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:28',NULL,NULL),(13972,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:30',NULL,NULL),(20785,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:35',NULL,NULL),(1036,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:27',NULL,NULL),(6691,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:33',NULL,NULL),(8836,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:28',NULL,NULL),(8871,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:37',NULL,NULL),(17962,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:41',NULL,NULL),(17463,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:06',NULL,NULL),(17370,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:36',NULL,NULL),(16776,1850,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:20:53',NULL,NULL),(9873,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:33',NULL,NULL),(11278,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:38',NULL,NULL),(13139,1709,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:17',NULL,NULL),(346,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:38',NULL,NULL),(423,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:05',NULL,NULL),(4102,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:59',NULL,NULL),(15031,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:58',NULL,NULL),(13629,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:41',NULL,NULL),(13115,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:11',NULL,NULL),(5539,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:32:04',NULL,NULL),(12289,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:23',NULL,NULL),(18878,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:34',NULL,NULL),(11290,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:41',NULL,NULL),(11098,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:48',NULL,NULL),(20023,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:29',NULL,NULL),(8564,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:16',NULL,NULL),(19026,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:16',NULL,NULL),(18686,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:05',NULL,NULL),(7315,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:18',NULL,NULL),(6379,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:24',NULL,NULL),(9533,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:05',NULL,NULL),(21388,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:01',NULL,NULL),(1788,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:24',NULL,NULL),(3274,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:35',NULL,NULL),(3971,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:25',NULL,NULL),(7825,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:19',NULL,NULL),(13255,1813,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:48',NULL,NULL),(6959,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:49',NULL,NULL),(11753,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:42',NULL,NULL),(20862,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:57',NULL,NULL),(20922,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:13',NULL,NULL),(21709,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:23',NULL,NULL),(1584,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:19',NULL,NULL),(1736,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:11',NULL,NULL),(4916,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:25',NULL,NULL),(5566,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:32:13',NULL,NULL),(16165,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:24',NULL,NULL),(5033,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:58',NULL,NULL),(9415,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:54',NULL,NULL),(13684,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:48',NULL,NULL),(13513,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:24',NULL,NULL),(10228,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:52',NULL,NULL),(12510,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:23',NULL,NULL),(10417,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:45',NULL,NULL),(20215,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:13',NULL,NULL),(22137,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:02',NULL,NULL),(1229,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:08',NULL,NULL),(5595,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:02',NULL,NULL),(6724,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:41',NULL,NULL),(5716,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:45',NULL,NULL),(13178,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:27',NULL,NULL),(15615,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:35',NULL,NULL),(21996,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:05',NULL,NULL),(23324,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:24',NULL,NULL),(2479,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:25',NULL,NULL),(19688,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:15',NULL,NULL),(7903,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:40',NULL,NULL),(3863,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:58',NULL,NULL),(5243,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:41',NULL,NULL),(4766,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:43',NULL,NULL),(14951,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:32',NULL,NULL),(12835,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:56',NULL,NULL),(14051,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:42',NULL,NULL),(13862,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:14',NULL,NULL),(22663,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:28',NULL,NULL),(8744,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:04',NULL,NULL),(18217,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:08',NULL,NULL),(3385,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:05',NULL,NULL),(6969,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:52',NULL,NULL),(16888,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:29',NULL,NULL),(14840,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:03',NULL,NULL),(10665,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:11',NULL,NULL),(19904,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:55',NULL,NULL),(15,154,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:15',NULL,NULL),(20499,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:55',NULL,NULL),(2522,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:35',NULL,NULL),(15088,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:17',NULL,NULL),(13501,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:22',NULL,NULL),(7952,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:53',NULL,NULL),(7821,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:18',NULL,NULL),(5139,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:12',NULL,NULL),(4220,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:24',NULL,NULL),(4290,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:42',NULL,NULL),(23493,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:23',NULL,NULL),(962,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:07',NULL,NULL),(5178,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:23',NULL,NULL),(20101,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:51',NULL,NULL),(19763,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:19',NULL,NULL),(18747,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:35:57',NULL,NULL),(16844,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:18',NULL,NULL),(4438,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:22',NULL,NULL),(16437,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:45',NULL,NULL),(9928,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:47',NULL,NULL),(12755,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:32',NULL,NULL),(21202,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:40:54',NULL,NULL),(469,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:19',NULL,NULL),(14691,1736,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:22',NULL,NULL),(14504,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:29',NULL,NULL),(10548,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:40',NULL,NULL),(10098,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:17',NULL,NULL),(8442,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:55',NULL,NULL),(8374,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:37',NULL,NULL),(1439,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:27',NULL,NULL),(21468,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:31',NULL,NULL),(22906,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:55',NULL,NULL),(13,311,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:13',NULL,NULL),(1157,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:00',NULL,NULL),(9094,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:28',NULL,NULL),(17185,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:59',NULL,NULL),(17080,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:24',NULL,NULL),(16327,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:04',NULL,NULL),(14878,1872,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:00:13',NULL,NULL),(11476,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:32',NULL,NULL),(10287,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:09',NULL,NULL),(8650,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:39',NULL,NULL),(8358,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:33',NULL,NULL),(6093,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:06',NULL,NULL),(2274,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:32',NULL,NULL),(6067,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:47',NULL,NULL),(3170,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:05',NULL,NULL),(20774,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:32',NULL,NULL),(4167,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:11',NULL,NULL),(10367,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:31',NULL,NULL),(11535,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:47',NULL,NULL),(20092,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:49',NULL,NULL),(15496,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:55',NULL,NULL),(14399,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:00',NULL,NULL),(21314,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:35',NULL,NULL),(22969,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:10',NULL,NULL),(23024,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:21',NULL,NULL),(84,305,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:18',NULL,NULL),(21030,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:43',NULL,NULL),(19738,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:12',NULL,NULL),(2047,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:52',NULL,NULL),(5966,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:11',NULL,NULL),(10265,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:03',NULL,NULL),(11647,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:15',NULL,NULL),(22924,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:01',NULL,NULL),(23565,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 22:00:02',NULL,NULL),(2041,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:51',NULL,NULL),(19915,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:58',NULL,NULL),(19828,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:36',NULL,NULL),(3323,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:48',NULL,NULL),(17523,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:26',NULL,NULL),(8721,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:57',NULL,NULL),(11462,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:28',NULL,NULL),(15921,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:56',NULL,NULL),(15586,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:26',NULL,NULL),(13438,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:13',NULL,NULL),(23130,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(6788,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:59',NULL,NULL),(19582,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:44',NULL,NULL),(19403,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:55',NULL,NULL),(2802,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:48',NULL,NULL),(18626,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:49',NULL,NULL),(17423,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:00:53',NULL,NULL),(9376,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:44',NULL,NULL),(4258,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:34',NULL,NULL),(13869,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:15',NULL,NULL),(14107,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:51',NULL,NULL),(22670,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:30',NULL,NULL),(23111,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(23426,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:59',NULL,NULL),(754,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:10',NULL,NULL),(20456,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:40',NULL,NULL),(9240,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:08',NULL,NULL),(1886,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:48',NULL,NULL),(7971,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:58',NULL,NULL),(18181,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:56',NULL,NULL),(6603,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:11',NULL,NULL),(15886,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:43',NULL,NULL),(15348,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:21',NULL,NULL),(15211,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:54',NULL,NULL),(11304,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:45',NULL,NULL),(17416,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:51',NULL,NULL),(13800,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:06',NULL,NULL),(22303,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:45',NULL,NULL),(23516,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:30',NULL,NULL),(9646,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:34',NULL,NULL),(21280,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:22',NULL,NULL),(951,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:04',NULL,NULL),(1447,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:31',NULL,NULL),(19441,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:05',NULL,NULL),(5750,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:56',NULL,NULL),(17106,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:33',NULL,NULL),(6338,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:13',NULL,NULL),(16269,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:17:02',NULL,NULL),(13142,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:18',NULL,NULL),(15642,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:03:44',NULL,NULL),(14991,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:45',NULL,NULL),(21527,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:53',NULL,NULL),(21751,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:39',NULL,NULL),(21914,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:37',NULL,NULL),(4534,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:46',NULL,NULL),(18480,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:09',NULL,NULL),(17435,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:57',NULL,NULL),(17054,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:15',NULL,NULL),(5429,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:33',NULL,NULL),(6110,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:11',NULL,NULL),(9119,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:35',NULL,NULL),(14368,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:49:50',NULL,NULL),(21516,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:49',NULL,NULL),(21367,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:54',NULL,NULL),(21333,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:41',NULL,NULL),(13359,1827,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:15',NULL,NULL),(6306,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:04',NULL,NULL),(7751,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:57',NULL,NULL),(23716,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 01:29:59',NULL,NULL),(713,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:02:41',NULL,NULL),(20530,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:07',NULL,NULL),(20216,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:13',NULL,NULL),(1662,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:47',NULL,NULL),(17870,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:09',NULL,NULL),(6425,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:37',NULL,NULL),(17621,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:02',NULL,NULL),(4224,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:25',NULL,NULL),(16528,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:20',NULL,NULL),(4660,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:13',NULL,NULL),(11959,1831,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:52',NULL,NULL),(22023,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:15',NULL,NULL),(9878,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:35',NULL,NULL),(21568,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:08',NULL,NULL),(20706,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:12',NULL,NULL),(8592,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:23',NULL,NULL),(8353,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:32',NULL,NULL),(17811,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:48',NULL,NULL),(7985,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:01',NULL,NULL),(17023,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:05',NULL,NULL),(15969,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:13',NULL,NULL),(7605,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:20',NULL,NULL),(15287,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:09',NULL,NULL),(7184,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:40',NULL,NULL),(22722,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:49',NULL,NULL),(23141,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:43',NULL,NULL),(2145,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:16',NULL,NULL),(20383,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:14',NULL,NULL),(2212,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:09',NULL,NULL),(19325,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:32',NULL,NULL),(2899,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:22',NULL,NULL),(17152,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:48',NULL,NULL),(17092,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:28',NULL,NULL),(9682,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:43',NULL,NULL),(10605,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:54',NULL,NULL),(14565,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:46',NULL,NULL),(20575,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:23',NULL,NULL),(107,326,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:39',NULL,NULL),(7911,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:42',NULL,NULL),(19819,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:33',NULL,NULL),(7152,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:32',NULL,NULL),(5386,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:31:21',NULL,NULL),(18051,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:12',NULL,NULL),(2780,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:40',NULL,NULL),(13197,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:32',NULL,NULL),(11605,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:04',NULL,NULL),(9292,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:22',NULL,NULL),(9001,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:03',NULL,NULL),(17524,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:27',NULL,NULL),(17136,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:43',NULL,NULL),(8122,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:27',NULL,NULL),(7807,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:14',NULL,NULL),(12720,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:22',NULL,NULL),(11244,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:29',NULL,NULL),(2510,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:32',NULL,NULL),(3731,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:24',NULL,NULL),(3893,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:06',NULL,NULL),(7673,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:38',NULL,NULL),(5635,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:17',NULL,NULL),(1282,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:28',NULL,NULL),(6758,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:50',NULL,NULL),(22105,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:44',NULL,NULL),(22821,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:26',NULL,NULL),(8439,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:54',NULL,NULL),(19289,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:22',NULL,NULL),(1191,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:10',NULL,NULL),(16607,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:48',NULL,NULL),(7259,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:03',NULL,NULL),(15133,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:32',NULL,NULL),(14829,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:00',NULL,NULL),(14236,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:10',NULL,NULL),(12323,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:34',NULL,NULL),(1219,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:04',NULL,NULL),(2966,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:46',NULL,NULL),(5687,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:35',NULL,NULL),(4515,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:41',NULL,NULL),(22174,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:11',NULL,NULL),(4993,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:47',NULL,NULL),(8700,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:52',NULL,NULL),(8559,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:15',NULL,NULL),(6569,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:02',NULL,NULL),(6100,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:09',NULL,NULL),(14042,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:41',NULL,NULL),(12854,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:02',NULL,NULL),(11993,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:02',NULL,NULL),(11126,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:55',NULL,NULL),(10112,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:21',NULL,NULL),(2475,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:24',NULL,NULL),(19808,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:30',NULL,NULL),(6860,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:19',NULL,NULL),(15472,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:46',NULL,NULL),(15387,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:28',NULL,NULL),(15098,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:20',NULL,NULL),(2967,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:47',NULL,NULL),(9622,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:28',NULL,NULL),(5006,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:51',NULL,NULL),(21423,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:15',NULL,NULL),(21572,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:10',NULL,NULL),(1059,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:33',NULL,NULL),(20606,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:34',NULL,NULL),(8580,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:20',NULL,NULL),(19684,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:14',NULL,NULL),(1272,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:25',NULL,NULL),(18336,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:29',NULL,NULL),(2660,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:32:11',NULL,NULL),(16516,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:15',NULL,NULL),(15468,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:45',NULL,NULL),(7134,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:27',NULL,NULL),(13314,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:03',NULL,NULL),(3488,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:33',NULL,NULL),(4639,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:07',NULL,NULL),(2327,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:45',NULL,NULL),(6317,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:07',NULL,NULL),(6307,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:05',NULL,NULL),(5617,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:10',NULL,NULL),(12057,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:20',NULL,NULL),(17898,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:19',NULL,NULL),(15497,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:55',NULL,NULL),(21507,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:46',NULL,NULL),(23290,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 11:01:11',NULL,NULL),(23547,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 17:30:02',NULL,NULL),(23653,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 11:30:01',NULL,NULL),(287,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:17',NULL,NULL),(9268,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:15',NULL,NULL),(18268,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:09',NULL,NULL),(17820,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:51',NULL,NULL),(4099,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:58',NULL,NULL),(15040,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:01',NULL,NULL),(12908,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:15',NULL,NULL),(4507,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:39',NULL,NULL),(10507,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:29',NULL,NULL),(6149,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:23',NULL,NULL),(2173,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:24',NULL,NULL),(2203,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:07',NULL,NULL),(14859,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:08',NULL,NULL),(10489,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:24',NULL,NULL),(8104,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:23',NULL,NULL),(2282,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:34',NULL,NULL),(6845,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:14',NULL,NULL),(6783,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:58',NULL,NULL),(8895,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:44',NULL,NULL),(2377,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:58',NULL,NULL),(22205,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:20',NULL,NULL),(23611,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 17:30:02',NULL,NULL),(1430,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:24',NULL,NULL),(3006,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:00',NULL,NULL),(7609,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:21',NULL,NULL),(14753,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:38',NULL,NULL),(12032,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:13',NULL,NULL),(7455,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:57',NULL,NULL),(647,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:17',NULL,NULL),(17447,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:01',NULL,NULL),(1340,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:51',NULL,NULL),(15356,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:23',NULL,NULL),(2932,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:34',NULL,NULL),(8187,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:45',NULL,NULL),(3283,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:37',NULL,NULL),(6670,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:28',NULL,NULL),(11694,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:27',NULL,NULL),(22894,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:50',NULL,NULL),(1505,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:51',NULL,NULL),(8929,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:53',NULL,NULL),(20657,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:53',NULL,NULL),(20426,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:29',NULL,NULL),(20128,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:59',NULL,NULL),(19308,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:27',NULL,NULL),(19280,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:19',NULL,NULL),(1841,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:37',NULL,NULL),(3960,1874,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:01:22',NULL,NULL),(14713,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:28',NULL,NULL),(5276,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:50',NULL,NULL),(13837,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:11',NULL,NULL),(13353,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:14',NULL,NULL),(11105,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:50',NULL,NULL),(23158,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(4593,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:00',NULL,NULL),(5532,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:02',NULL,NULL),(20238,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:21',NULL,NULL),(6215,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:41',NULL,NULL),(19616,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:53',NULL,NULL),(6286,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:59',NULL,NULL),(8888,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:42',NULL,NULL),(12394,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:54',NULL,NULL),(23520,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:32',NULL,NULL),(4855,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:07',NULL,NULL),(6358,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:19',NULL,NULL),(12743,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:28',NULL,NULL),(20281,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:36',NULL,NULL),(14732,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:33',NULL,NULL),(17964,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:41',NULL,NULL),(15151,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:38',NULL,NULL),(21725,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:30',NULL,NULL),(348,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:00:38',NULL,NULL),(21064,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:52',NULL,NULL),(633,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:13',NULL,NULL),(20556,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:16',NULL,NULL),(8394,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:43',NULL,NULL),(20352,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:02',NULL,NULL),(19908,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:56',NULL,NULL),(19822,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:34',NULL,NULL),(18514,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:19',NULL,NULL),(5233,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:38',NULL,NULL),(16304,1825,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:55',NULL,NULL),(11975,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:58',NULL,NULL),(13457,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:16',NULL,NULL),(12690,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:13',NULL,NULL),(23291,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:11',NULL,NULL),(24,332,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:23',NULL,NULL),(20790,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:37',NULL,NULL),(2578,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:49',NULL,NULL),(18820,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:18',NULL,NULL),(13469,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:17',NULL,NULL),(17810,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:12:48',NULL,NULL),(2232,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:21',NULL,NULL),(20688,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:07',NULL,NULL),(19171,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:57',NULL,NULL),(17882,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:13',NULL,NULL),(9733,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:56',NULL,NULL),(9251,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:11',NULL,NULL),(15936,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:01',NULL,NULL),(14899,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:19',NULL,NULL),(12821,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:50',NULL,NULL),(8254,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:02',NULL,NULL),(2293,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:37',NULL,NULL),(7246,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:59',NULL,NULL),(4644,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-24 00:00:09',NULL,NULL),(2668,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:13',NULL,NULL),(5122,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:08',NULL,NULL),(5874,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:39',NULL,NULL),(22261,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:35',NULL,NULL),(22677,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:33',NULL,NULL),(23011,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:18',NULL,NULL),(1738,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:12',NULL,NULL),(9453,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:05',NULL,NULL),(18692,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:07',NULL,NULL),(8297,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:15',NULL,NULL),(15685,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:59',NULL,NULL),(14868,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:10',NULL,NULL),(6515,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:01',NULL,NULL),(11738,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:39',NULL,NULL),(896,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:49',NULL,NULL),(20857,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:55',NULL,NULL),(19967,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:14',NULL,NULL),(17324,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:21',NULL,NULL),(1166,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:32:03',NULL,NULL),(15767,1592,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:27',NULL,NULL),(15079,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:14',NULL,NULL),(4823,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:59',NULL,NULL),(14534,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:37',NULL,NULL),(14426,1756,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:08',NULL,NULL),(13665,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:46',NULL,NULL),(4336,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:54',NULL,NULL),(2381,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:59',NULL,NULL),(22877,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:45',NULL,NULL),(922,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:56',NULL,NULL),(938,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:01',NULL,NULL),(7843,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:23',NULL,NULL),(18594,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:40',NULL,NULL),(16712,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:30',NULL,NULL),(15013,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:52',NULL,NULL),(14257,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:14',NULL,NULL),(13857,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:14',NULL,NULL),(12608,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:50',NULL,NULL),(6997,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:02:00',NULL,NULL),(3418,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:14',NULL,NULL),(1720,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:08',NULL,NULL),(4953,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:36',NULL,NULL),(23168,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:48',NULL,NULL),(957,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:06',NULL,NULL),(10868,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:02',NULL,NULL),(18640,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:52',NULL,NULL),(19167,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:56',NULL,NULL),(18721,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:15',NULL,NULL),(1892,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:50',NULL,NULL),(18406,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:47',NULL,NULL),(17068,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:31:20',NULL,NULL),(7962,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:56',NULL,NULL),(5397,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:24',NULL,NULL),(13553,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:30',NULL,NULL),(2167,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:22',NULL,NULL),(12144,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:43',NULL,NULL),(9126,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:38',NULL,NULL),(1888,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:49',NULL,NULL),(2295,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:37',NULL,NULL),(19402,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:55',NULL,NULL),(18318,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:24',NULL,NULL),(4037,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:41',NULL,NULL),(16527,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:19',NULL,NULL),(15049,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:04',NULL,NULL),(14777,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:46',NULL,NULL),(12932,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:22',NULL,NULL),(4216,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:23',NULL,NULL),(10544,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:39',NULL,NULL),(20747,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:24',NULL,NULL),(21656,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:05',NULL,NULL),(21981,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:00',NULL,NULL),(22073,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:33',NULL,NULL),(694,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:34',NULL,NULL),(1411,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:17',NULL,NULL),(4979,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:43',NULL,NULL),(16419,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:39',NULL,NULL),(16213,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:41',NULL,NULL),(15007,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:50',NULL,NULL),(10239,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:55',NULL,NULL),(12966,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:32',NULL,NULL),(12904,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:14',NULL,NULL),(20727,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:19',NULL,NULL),(20831,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:48',NULL,NULL),(22108,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:45',NULL,NULL),(1771,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:20',NULL,NULL),(2768,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:36',NULL,NULL),(6432,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:39',NULL,NULL),(3729,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:24',NULL,NULL),(4391,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:09',NULL,NULL),(4087,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:55',NULL,NULL),(8991,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:02:11',NULL,NULL),(11945,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:47',NULL,NULL),(9872,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:33',NULL,NULL),(20120,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:57',NULL,NULL),(23274,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:07',NULL,NULL),(7697,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:44',NULL,NULL),(16795,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:05',NULL,NULL),(16778,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:54',NULL,NULL),(16143,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:17',NULL,NULL),(16106,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:03',NULL,NULL),(7068,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:06',NULL,NULL),(9821,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:20',NULL,NULL),(12954,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:29',NULL,NULL),(11866,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:11',NULL,NULL),(21022,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:40',NULL,NULL),(22927,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:02',NULL,NULL),(602,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:03',NULL,NULL),(1181,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:07',NULL,NULL),(19097,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:36',NULL,NULL),(17774,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:34',NULL,NULL),(16615,1697,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:52',NULL,NULL),(16563,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:32',NULL,NULL),(16070,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:49',NULL,NULL),(5473,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:45',NULL,NULL),(4820,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:58',NULL,NULL),(11827,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:01',NULL,NULL),(9861,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:30',NULL,NULL),(4210,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:22',NULL,NULL),(21316,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:41:36',NULL,NULL),(21857,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:16',NULL,NULL),(23572,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 19:30:02',NULL,NULL),(452,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:14',NULL,NULL),(17724,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:39',NULL,NULL),(943,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:02',NULL,NULL),(8062,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:12',NULL,NULL),(11493,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:36',NULL,NULL),(5239,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:40',NULL,NULL),(1598,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:24',NULL,NULL),(4429,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:20',NULL,NULL),(2147,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:17',NULL,NULL),(22427,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:24',NULL,NULL),(8862,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:35',NULL,NULL),(20217,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:13',NULL,NULL),(19491,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:18',NULL,NULL),(18886,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:36',NULL,NULL),(2237,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 21:30:22',NULL,NULL),(13878,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:16',NULL,NULL),(4449,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:25',NULL,NULL),(9461,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:32:07',NULL,NULL),(9765,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:05',NULL,NULL),(10173,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:38',NULL,NULL),(9935,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:49',NULL,NULL),(20588,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:28',NULL,NULL),(257,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:08',NULL,NULL),(19012,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:13',NULL,NULL),(8875,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:38',NULL,NULL),(18204,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:03',NULL,NULL),(17890,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:16',NULL,NULL),(16393,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:29',NULL,NULL),(2874,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:13',NULL,NULL),(20013,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:27',NULL,NULL),(12298,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:26',NULL,NULL),(4596,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:32:01',NULL,NULL),(9851,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:28',NULL,NULL),(9565,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:13',NULL,NULL),(9441,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:02',NULL,NULL),(2891,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:19',NULL,NULL),(3545,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:48',NULL,NULL),(3483,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:31',NULL,NULL),(21854,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:15',NULL,NULL),(23370,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:40',NULL,NULL),(29,315,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:28',NULL,NULL),(18139,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:41',NULL,NULL),(8820,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:24',NULL,NULL),(16999,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:57',NULL,NULL),(16882,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:28',NULL,NULL),(471,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:20',NULL,NULL),(16308,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:17:57',NULL,NULL),(1778,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:21',NULL,NULL),(7164,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:35',NULL,NULL),(15177,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:47',NULL,NULL),(6673,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:29',NULL,NULL),(5808,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:16',NULL,NULL),(3098,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:34',NULL,NULL),(12799,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:44',NULL,NULL),(12490,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:17',NULL,NULL),(9899,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:40',NULL,NULL),(11819,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:59',NULL,NULL),(20749,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:25',NULL,NULL),(22581,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:16',NULL,NULL),(6528,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:32:05',NULL,NULL),(20504,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:57',NULL,NULL),(4321,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:50',NULL,NULL),(10906,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:12',NULL,NULL),(11078,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:42',NULL,NULL),(16475,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:00',NULL,NULL),(17127,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:40',NULL,NULL),(20698,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:10',NULL,NULL),(20748,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:25',NULL,NULL),(20842,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:51',NULL,NULL),(3383,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:04',NULL,NULL),(18935,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:50',NULL,NULL),(16224,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:45',NULL,NULL),(14545,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:40',NULL,NULL),(4343,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:56',NULL,NULL),(6701,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:36',NULL,NULL),(4633,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:06',NULL,NULL),(23488,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:21',NULL,NULL),(23687,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 15:30:02',NULL,NULL),(9511,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:35:59',NULL,NULL),(18320,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:24',NULL,NULL),(9501,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:35:56',NULL,NULL),(7528,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:16',NULL,NULL),(5837,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:26',NULL,NULL),(5938,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:01',NULL,NULL),(14615,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:00',NULL,NULL),(10174,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:38',NULL,NULL),(13412,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:09',NULL,NULL),(13054,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:54',NULL,NULL),(20744,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:24',NULL,NULL),(21703,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:21',NULL,NULL),(23444,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:02:05',NULL,NULL),(537,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:42',NULL,NULL),(7628,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:26',NULL,NULL),(17993,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:51',NULL,NULL),(1344,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:52',NULL,NULL),(17561,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:39',NULL,NULL),(16764,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:49',NULL,NULL),(6553,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:32:11',NULL,NULL),(13998,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:34',NULL,NULL),(13904,1868,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:20',NULL,NULL),(5780,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:07',NULL,NULL),(11254,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:32',NULL,NULL),(4138,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:03',NULL,NULL),(9865,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:31',NULL,NULL),(2194,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:04',NULL,NULL),(3711,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:19',NULL,NULL),(2070,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:58',NULL,NULL),(19521,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:27',NULL,NULL),(19382,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:49',NULL,NULL),(4845,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:04',NULL,NULL),(17897,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:18',NULL,NULL),(16109,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:16:04',NULL,NULL),(15257,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:03',NULL,NULL),(6302,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:03',NULL,NULL),(15204,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:01:53',NULL,NULL),(5677,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:31',NULL,NULL),(15046,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:03',NULL,NULL),(13104,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:07',NULL,NULL),(532,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:40',NULL,NULL),(18601,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:42',NULL,NULL),(2108,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:07',NULL,NULL),(16383,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:25',NULL,NULL),(15887,1757,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:44',NULL,NULL),(14678,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:18',NULL,NULL),(13918,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:22',NULL,NULL),(5459,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:41',NULL,NULL),(10151,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:32',NULL,NULL),(10009,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:39:53',NULL,NULL),(7393,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:39',NULL,NULL),(23464,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:13',NULL,NULL),(5036,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:59',NULL,NULL),(8009,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:08',NULL,NULL),(18732,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:35:53',NULL,NULL),(7380,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:36',NULL,NULL),(6232,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:45',NULL,NULL),(11897,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:19',NULL,NULL),(11971,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:55',NULL,NULL),(16353,1705,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:13',NULL,NULL),(12012,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:07',NULL,NULL),(12286,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:22',NULL,NULL),(22365,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:04',NULL,NULL),(22702,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:58:42',NULL,NULL),(23506,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:27',NULL,NULL),(5282,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:53',NULL,NULL),(6715,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:39',NULL,NULL),(8402,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:45',NULL,NULL),(10198,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:45',NULL,NULL),(15892,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:46',NULL,NULL),(10898,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:10',NULL,NULL),(13803,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:06',NULL,NULL),(1883,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:47',NULL,NULL),(8305,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:18',NULL,NULL),(20200,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:07',NULL,NULL),(6948,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:47',NULL,NULL),(6083,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:03',NULL,NULL),(16852,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:20',NULL,NULL),(15890,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:45',NULL,NULL),(5748,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:55',NULL,NULL),(12124,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:37',NULL,NULL),(11805,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:56',NULL,NULL),(11772,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:48',NULL,NULL),(10165,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:35',NULL,NULL),(9072,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:22',NULL,NULL),(18855,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:27',NULL,NULL),(18694,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:07',NULL,NULL),(18174,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:54',NULL,NULL),(8167,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:39',NULL,NULL),(15826,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:21',NULL,NULL),(13982,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:32',NULL,NULL),(6939,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:45',NULL,NULL),(2319,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:43',NULL,NULL),(6747,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:47',NULL,NULL),(21679,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:13',NULL,NULL),(1361,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:58',NULL,NULL),(5280,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:53',NULL,NULL),(18526,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:22',NULL,NULL),(7855,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:27',NULL,NULL),(15000,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:48',NULL,NULL),(6091,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:06',NULL,NULL),(43,321,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:40',NULL,NULL),(17619,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:01',NULL,NULL),(21023,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:40',NULL,NULL),(22418,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:21',NULL,NULL),(22461,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:36',NULL,NULL),(1812,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:30',NULL,NULL),(19990,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:20',NULL,NULL),(19843,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:39',NULL,NULL),(18253,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:05',NULL,NULL),(8293,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:14',NULL,NULL),(2892,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:20',NULL,NULL),(17131,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:41',NULL,NULL),(6181,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:32',NULL,NULL),(11077,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:42',NULL,NULL),(14745,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:36',NULL,NULL),(12454,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:07',NULL,NULL),(12641,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:59',NULL,NULL),(9434,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:32:00',NULL,NULL),(9177,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:51',NULL,NULL),(18359,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:35',NULL,NULL),(16058,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:15:45',NULL,NULL),(8764,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:09',NULL,NULL),(15229,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:58',NULL,NULL),(3054,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:19',NULL,NULL),(8657,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:41',NULL,NULL),(11863,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:10',NULL,NULL),(11060,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:34',NULL,NULL),(8468,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:02',NULL,NULL),(8401,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:44',NULL,NULL),(4869,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:11',NULL,NULL),(21539,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:42:58',NULL,NULL),(3016,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:04',NULL,NULL),(20313,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:48',NULL,NULL),(8404,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:45',NULL,NULL),(3210,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:17',NULL,NULL),(5846,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:29',NULL,NULL),(5283,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:53',NULL,NULL),(11394,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:10',NULL,NULL),(16301,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:54',NULL,NULL),(13212,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:36',NULL,NULL),(15478,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:48',NULL,NULL),(23472,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:16',NULL,NULL),(23646,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 13:30:02',NULL,NULL),(1199,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:32:12',NULL,NULL),(19463,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:11',NULL,NULL),(1859,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:41',NULL,NULL),(1985,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:36',NULL,NULL),(18005,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:55',NULL,NULL),(8638,1874,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:00:35',NULL,NULL),(6609,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:12',NULL,NULL),(2843,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:02',NULL,NULL),(12247,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:11',NULL,NULL),(10148,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:31',NULL,NULL),(21695,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:19',NULL,NULL),(22774,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:08',NULL,NULL),(555,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:48',NULL,NULL),(21060,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:51',NULL,NULL),(20337,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:56',NULL,NULL),(7896,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:39',NULL,NULL),(1236,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:00:11',NULL,NULL),(1760,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:17',NULL,NULL),(14758,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:40',NULL,NULL),(12449,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:06',NULL,NULL),(11995,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:03',NULL,NULL),(2992,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:55',NULL,NULL),(5338,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:08',NULL,NULL),(10599,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:52',NULL,NULL),(21520,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:51',NULL,NULL),(8021,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:02:12',NULL,NULL),(19777,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:30:22',NULL,NULL),(19278,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:19',NULL,NULL),(18987,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:06',NULL,NULL),(18350,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:32',NULL,NULL),(3687,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:13',NULL,NULL),(6277,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:57',NULL,NULL),(16263,1870,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:17:00',NULL,NULL),(5989,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:19',NULL,NULL),(21210,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:40:57',NULL,NULL),(11053,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:32',NULL,NULL),(21908,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:35',NULL,NULL),(23062,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:28',NULL,NULL),(23138,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:42',NULL,NULL),(23719,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 15:29:58',NULL,NULL),(1401,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:14',NULL,NULL),(1407,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:16',NULL,NULL),(8974,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:05',NULL,NULL),(4574,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:56',NULL,NULL),(10315,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:17',NULL,NULL),(12312,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:30',NULL,NULL),(17828,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:12:54',NULL,NULL),(15704,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:04:05',NULL,NULL),(15517,1668,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:02',NULL,NULL),(21785,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:51',NULL,NULL),(23720,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 17:29:58',NULL,NULL),(1520,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:56',NULL,NULL),(21451,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:25',NULL,NULL),(4143,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:05',NULL,NULL),(20866,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:58',NULL,NULL),(4182,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:15',NULL,NULL),(19219,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:03',NULL,NULL),(18016,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:00',NULL,NULL),(17150,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:47',NULL,NULL),(17129,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:41',NULL,NULL),(11639,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:13',NULL,NULL),(14431,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:09',NULL,NULL),(13063,1796,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:57',NULL,NULL),(22308,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:46',NULL,NULL),(1783,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:23',NULL,NULL),(21595,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:18',NULL,NULL),(9621,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:27',NULL,NULL),(21168,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:41',NULL,NULL),(8378,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:38',NULL,NULL),(18240,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:16',NULL,NULL),(6074,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:49',NULL,NULL),(6730,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:43',NULL,NULL),(11135,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:58',NULL,NULL),(13830,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:10',NULL,NULL),(14396,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:59',NULL,NULL),(22154,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:06',NULL,NULL),(8923,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:52',NULL,NULL),(18556,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:30',NULL,NULL),(18169,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:52',NULL,NULL),(16173,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:27',NULL,NULL),(6375,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:24',NULL,NULL),(10671,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:13',NULL,NULL),(5367,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:16',NULL,NULL),(6776,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:56',NULL,NULL),(9915,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:44',NULL,NULL),(11469,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:14:30',NULL,NULL),(17952,1857,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:13:37',NULL,NULL),(17116,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:36',NULL,NULL),(12991,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:38',NULL,NULL),(13348,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:13',NULL,NULL),(14575,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:48',NULL,NULL),(497,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:29',NULL,NULL),(9468,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:32:09',NULL,NULL),(1432,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:24',NULL,NULL),(19160,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:54',NULL,NULL),(18066,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:17',NULL,NULL),(2369,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:56',NULL,NULL),(16616,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:53',NULL,NULL),(15479,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:48',NULL,NULL),(12511,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:23',NULL,NULL),(7662,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:35',NULL,NULL),(11477,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:32',NULL,NULL),(10690,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:18',NULL,NULL),(6493,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:55',NULL,NULL),(2536,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:39',NULL,NULL),(6452,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:45',NULL,NULL),(23118,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:38',NULL,NULL),(435,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:08',NULL,NULL),(21965,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:55',NULL,NULL),(20053,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:38',NULL,NULL),(10102,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:18',NULL,NULL),(15903,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:50',NULL,NULL),(8842,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:30',NULL,NULL),(3565,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:54',NULL,NULL),(3964,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:23',NULL,NULL),(5175,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:22',NULL,NULL),(169,246,'2013-12-27','15:18:00','A','000',0,'2014-01-13 03:04:57',NULL,NULL),(21685,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:15',NULL,NULL),(21252,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:12',NULL,NULL),(1454,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:33',NULL,NULL),(8049,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:08',NULL,NULL),(6467,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:49',NULL,NULL),(17809,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:47',NULL,NULL),(17790,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:40',NULL,NULL),(1879,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:46',NULL,NULL),(15441,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:39',NULL,NULL),(13545,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:29',NULL,NULL),(6310,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:05',NULL,NULL),(6097,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:07',NULL,NULL),(11191,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:14',NULL,NULL),(1916,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:56',NULL,NULL),(3761,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:32',NULL,NULL),(10616,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:57',NULL,NULL),(10518,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:32',NULL,NULL),(13905,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:20',NULL,NULL),(15220,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:01:56',NULL,NULL),(17044,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:12',NULL,NULL),(9710,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:51',NULL,NULL),(21824,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:05',NULL,NULL),(19514,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:25',NULL,NULL),(9708,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:50',NULL,NULL),(3619,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:32:08',NULL,NULL),(17713,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:35',NULL,NULL),(7714,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:48',NULL,NULL),(5439,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:36',NULL,NULL),(12814,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:48',NULL,NULL),(164,197,'2013-12-27','14:58:00','A','000',0,'2014-01-13 03:04:56',NULL,NULL),(8725,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:58',NULL,NULL),(7666,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:36',NULL,NULL),(17701,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:31',NULL,NULL),(7556,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:07',NULL,NULL),(12933,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:23',NULL,NULL),(1940,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:01',NULL,NULL),(2310,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:41',NULL,NULL),(7473,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:02',NULL,NULL),(8381,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:39',NULL,NULL),(3304,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:43',NULL,NULL),(20861,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:57',NULL,NULL),(7738,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:54',NULL,NULL),(7477,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:03',NULL,NULL),(7451,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:56',NULL,NULL),(3776,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:36',NULL,NULL),(12557,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:35',NULL,NULL),(15278,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:07',NULL,NULL),(22699,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:41',NULL,NULL),(22865,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:41',NULL,NULL),(1308,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:38',NULL,NULL),(20002,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:24',NULL,NULL),(18953,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:56',NULL,NULL),(10974,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:10',NULL,NULL),(7314,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:18',NULL,NULL),(17295,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:11',NULL,NULL),(5878,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:40',NULL,NULL),(11518,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:42',NULL,NULL),(23226,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:59',NULL,NULL),(23462,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:13',NULL,NULL),(1604,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:26',NULL,NULL),(3417,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:14',NULL,NULL),(21958,1874,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:01:52',NULL,NULL),(21852,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:15',NULL,NULL),(21466,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:30',NULL,NULL),(21050,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:48',NULL,NULL),(18911,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:43',NULL,NULL),(8282,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:10',NULL,NULL),(6224,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:43',NULL,NULL),(16654,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:09',NULL,NULL),(16574,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:36',NULL,NULL),(14891,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:17',NULL,NULL),(14242,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:32:11',NULL,NULL),(3349,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:55',NULL,NULL),(10111,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:21',NULL,NULL),(21571,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:09',NULL,NULL),(10889,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:08',NULL,NULL),(20914,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:11',NULL,NULL),(7144,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:30',NULL,NULL),(6784,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:58',NULL,NULL),(6745,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:47',NULL,NULL),(12975,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:34',NULL,NULL),(12877,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:24:11',NULL,NULL),(12476,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:13',NULL,NULL),(12340,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:39',NULL,NULL),(11798,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:54',NULL,NULL),(4506,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:39',NULL,NULL),(5935,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:02:00',NULL,NULL),(1695,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:03:00',NULL,NULL),(19769,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:20',NULL,NULL),(10797,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:44',NULL,NULL),(10339,1857,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:41:24',NULL,NULL),(17191,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:01',NULL,NULL),(14731,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:32',NULL,NULL),(14109,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:51',NULL,NULL),(21203,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:54',NULL,NULL),(9465,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:32:08',NULL,NULL),(20396,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:18',NULL,NULL),(13172,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:26',NULL,NULL),(21671,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:10',NULL,NULL),(8934,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:54',NULL,NULL),(8743,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:03',NULL,NULL),(15095,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:19',NULL,NULL),(6360,1839,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:19',NULL,NULL),(10456,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:56',NULL,NULL),(12892,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:24:16',NULL,NULL),(12823,1749,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:51',NULL,NULL),(11403,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:14',NULL,NULL),(16896,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:30:31',NULL,NULL),(18831,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:21',NULL,NULL),(21137,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:32:13',NULL,NULL),(21884,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:26',NULL,NULL),(22621,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:30',NULL,NULL),(23471,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:16',NULL,NULL),(10310,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:15',NULL,NULL),(1024,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:24',NULL,NULL),(10014,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:54',NULL,NULL),(12593,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:45',NULL,NULL),(13810,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:07',NULL,NULL),(13760,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:00',NULL,NULL),(13734,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:56',NULL,NULL),(11553,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:51',NULL,NULL),(6888,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:27',NULL,NULL),(8097,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:21',NULL,NULL),(1852,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:40',NULL,NULL),(21609,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:24',NULL,NULL),(413,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:01',NULL,NULL),(11586,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:59',NULL,NULL),(10984,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:12',NULL,NULL),(1678,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:54',NULL,NULL),(5589,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:32:19',NULL,NULL),(3628,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:11',NULL,NULL),(16166,1742,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:25',NULL,NULL),(19888,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:51',NULL,NULL),(20845,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:52',NULL,NULL),(22695,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:39',NULL,NULL),(23070,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:30',NULL,NULL),(26,265,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:25',NULL,NULL),(8654,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:40',NULL,NULL),(1091,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:42',NULL,NULL),(11906,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:21',NULL,NULL),(11205,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:18',NULL,NULL),(11071,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:40',NULL,NULL),(4712,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:28',NULL,NULL),(3373,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:02',NULL,NULL),(7446,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:54',NULL,NULL),(2560,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:45',NULL,NULL),(2555,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:44',NULL,NULL),(1297,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:34',NULL,NULL),(16500,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:09',NULL,NULL),(20766,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:30',NULL,NULL),(21887,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:27',NULL,NULL),(23005,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:17',NULL,NULL),(262,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:09',NULL,NULL),(580,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:01:56',NULL,NULL),(14069,1840,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:45',NULL,NULL),(12294,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:25',NULL,NULL),(12125,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:38',NULL,NULL),(11015,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:21',NULL,NULL),(747,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:08',NULL,NULL),(10328,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:21',NULL,NULL),(2477,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:24',NULL,NULL),(7440,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:52',NULL,NULL),(2569,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:47',NULL,NULL),(18443,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:57',NULL,NULL),(21350,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:48',NULL,NULL),(21898,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:31',NULL,NULL),(22886,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:48',NULL,NULL),(10340,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:24',NULL,NULL),(14349,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:31',NULL,NULL),(1526,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:58',NULL,NULL),(4036,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:41',NULL,NULL),(13656,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:44',NULL,NULL),(13644,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:43',NULL,NULL),(12413,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:21:55',NULL,NULL),(11566,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:54',NULL,NULL),(3215,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:18',NULL,NULL),(17640,1866,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:02:08',NULL,NULL),(21339,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:44',NULL,NULL),(23732,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-11 01:29:56',NULL,NULL),(1275,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:26',NULL,NULL),(10331,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:22',NULL,NULL),(3555,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:51',NULL,NULL),(12949,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:28',NULL,NULL),(4038,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:41',NULL,NULL),(12766,1795,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:34',NULL,NULL),(16875,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:26',NULL,NULL),(18353,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:33',NULL,NULL),(18431,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:54',NULL,NULL),(19019,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:14',NULL,NULL),(19155,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:53',NULL,NULL),(21765,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:44',NULL,NULL),(22318,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:48',NULL,NULL),(23630,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 12:00:03',NULL,NULL),(2610,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:58',NULL,NULL),(2917,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:28',NULL,NULL),(15334,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:02:18',NULL,NULL),(15285,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:09',NULL,NULL),(3537,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:46',NULL,NULL),(11623,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:09',NULL,NULL),(12115,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:35',NULL,NULL),(18654,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:56',NULL,NULL),(21692,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:18',NULL,NULL),(22256,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:33',NULL,NULL),(22363,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:03',NULL,NULL),(314,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:27',NULL,NULL),(4338,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:55',NULL,NULL),(11256,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:32',NULL,NULL),(11153,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:03',NULL,NULL),(3553,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:50',NULL,NULL),(10467,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:19',NULL,NULL),(10204,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:46',NULL,NULL),(9508,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:58',NULL,NULL),(3489,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:33',NULL,NULL),(6393,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:29',NULL,NULL),(18238,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:15:15',NULL,NULL),(18737,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:35:55',NULL,NULL),(18971,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:01',NULL,NULL),(22057,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:27',NULL,NULL),(4885,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:16',NULL,NULL),(2956,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:43',NULL,NULL),(3637,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:14',NULL,NULL),(4339,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:55',NULL,NULL),(6842,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:13',NULL,NULL),(13347,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:12',NULL,NULL),(13189,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:30',NULL,NULL),(10433,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:50',NULL,NULL),(12527,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:27',NULL,NULL),(11343,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:56',NULL,NULL),(11788,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:51',NULL,NULL),(17858,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:05',NULL,NULL),(18980,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:04',NULL,NULL),(19466,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:12',NULL,NULL),(20428,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:30',NULL,NULL),(22211,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:22',NULL,NULL),(22977,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:12',NULL,NULL),(23662,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-02 13:30:00',NULL,NULL),(3100,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:35',NULL,NULL),(5868,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:37',NULL,NULL),(11818,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:59',NULL,NULL),(7332,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:23',NULL,NULL),(7869,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:32',NULL,NULL),(8369,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:36',NULL,NULL),(17855,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:04',NULL,NULL),(18347,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:31',NULL,NULL),(18866,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:30',NULL,NULL),(20073,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:43',NULL,NULL),(22280,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:39',NULL,NULL),(965,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:08',NULL,NULL),(15498,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:56',NULL,NULL),(13031,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:48',NULL,NULL),(5438,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:35',NULL,NULL),(968,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:09',NULL,NULL),(4491,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:35',NULL,NULL),(4179,1859,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:30:14',NULL,NULL),(2854,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:06',NULL,NULL),(3757,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:31',NULL,NULL),(16907,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:34',NULL,NULL),(19114,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:40',NULL,NULL),(6986,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:56',NULL,NULL),(15351,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:21',NULL,NULL),(14733,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:33',NULL,NULL),(9008,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:05',NULL,NULL),(12648,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:01',NULL,NULL),(11035,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:27',NULL,NULL),(18291,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:16',NULL,NULL),(19796,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:27',NULL,NULL),(22883,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:47',NULL,NULL),(23091,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(23144,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:43',NULL,NULL),(1558,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:10',NULL,NULL),(15254,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:02:03',NULL,NULL),(14348,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:31',NULL,NULL),(13716,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:53',NULL,NULL),(13536,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:28',NULL,NULL),(10607,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:54',NULL,NULL),(5149,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:15',NULL,NULL),(7647,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:31',NULL,NULL),(6012,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:27',NULL,NULL),(2382,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:59',NULL,NULL),(4787,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:48',NULL,NULL),(18703,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:10',NULL,NULL),(19919,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:59',NULL,NULL),(22783,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:12',NULL,NULL),(1234,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:10',NULL,NULL),(14754,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:39',NULL,NULL),(14025,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:39',NULL,NULL),(12528,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:28',NULL,NULL),(12110,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:33',NULL,NULL),(1597,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:23',NULL,NULL),(10439,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:52',NULL,NULL),(2458,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:19',NULL,NULL),(7371,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:31:33',NULL,NULL),(16925,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:38',NULL,NULL),(18833,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:21',NULL,NULL),(20751,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:25',NULL,NULL),(21114,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:32:06',NULL,NULL),(22980,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:13',NULL,NULL),(3128,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:45',NULL,NULL),(4242,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:30',NULL,NULL),(15871,1768,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:14:38',NULL,NULL),(7341,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:25',NULL,NULL),(10483,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:23',NULL,NULL),(11488,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:35',NULL,NULL),(12118,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:36',NULL,NULL),(18351,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:32',NULL,NULL),(18423,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:52',NULL,NULL),(18688,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:05',NULL,NULL),(5297,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:57',NULL,NULL),(3962,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:23',NULL,NULL),(14693,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:51:22',NULL,NULL),(14666,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:15',NULL,NULL),(11875,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:13',NULL,NULL),(11023,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:23',NULL,NULL),(7574,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:12',NULL,NULL),(18001,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:54',NULL,NULL),(21538,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:57',NULL,NULL),(802,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:24',NULL,NULL),(4817,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:57',NULL,NULL),(14806,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:53',NULL,NULL),(2607,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:57',NULL,NULL),(6451,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:44',NULL,NULL),(7237,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:57',NULL,NULL),(13627,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:40',NULL,NULL),(9671,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:40',NULL,NULL),(17088,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:27',NULL,NULL),(18272,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:10',NULL,NULL),(19670,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:10',NULL,NULL),(19879,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:49',NULL,NULL),(21838,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:10',NULL,NULL),(22067,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:31',NULL,NULL),(22323,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:50',NULL,NULL),(23607,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 01:30:02',NULL,NULL),(4433,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:21',NULL,NULL),(6960,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:50',NULL,NULL),(15542,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:11',NULL,NULL),(15302,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:12',NULL,NULL),(8058,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:10',NULL,NULL),(15108,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:24',NULL,NULL),(10230,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:53',NULL,NULL),(11855,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:08',NULL,NULL),(19717,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:07',NULL,NULL),(56,334,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:53',NULL,NULL),(15623,1893,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:03:38',NULL,NULL),(1222,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:05',NULL,NULL),(14392,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:57',NULL,NULL),(7858,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:28',NULL,NULL),(8535,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:08',NULL,NULL),(8907,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:47',NULL,NULL),(10707,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:21',NULL,NULL),(11298,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:43',NULL,NULL),(17266,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:27',NULL,NULL),(18440,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:56',NULL,NULL),(22714,1892,'2014-01-14','23:11:00','A','000',0,'2014-01-24 10:58:46',NULL,NULL),(631,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:12',NULL,NULL),(14728,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:32',NULL,NULL),(7347,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:27',NULL,NULL),(12996,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:39',NULL,NULL),(12673,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:08',NULL,NULL),(2896,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:21',NULL,NULL),(4247,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:31',NULL,NULL),(4409,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:14',NULL,NULL),(18061,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:15',NULL,NULL),(19258,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:13',NULL,NULL),(20832,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:48',NULL,NULL),(21275,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:21',NULL,NULL),(22922,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:00',NULL,NULL),(9969,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:58',NULL,NULL),(13966,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:29',NULL,NULL),(11607,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:05',NULL,NULL),(6882,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:26',NULL,NULL),(6017,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:29',NULL,NULL),(17896,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:18',NULL,NULL),(18670,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:32:00',NULL,NULL),(21723,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:29',NULL,NULL),(1301,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:36',NULL,NULL),(15366,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:24',NULL,NULL),(3428,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:17',NULL,NULL),(5978,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:16',NULL,NULL),(16100,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:01',NULL,NULL),(8581,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:20',NULL,NULL),(20093,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:49',NULL,NULL),(21613,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:25',NULL,NULL),(21883,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:25',NULL,NULL),(23697,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 19:30:02',NULL,NULL),(8843,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:30',NULL,NULL),(14203,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:32:05',NULL,NULL),(13315,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:04',NULL,NULL),(13152,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:21',NULL,NULL),(2350,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:51',NULL,NULL),(6907,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:33',NULL,NULL),(2517,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:34',NULL,NULL),(16564,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:33',NULL,NULL),(19665,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:09',NULL,NULL),(21549,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:01',NULL,NULL),(23341,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:30',NULL,NULL),(73,239,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:08',NULL,NULL),(16449,1618,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:50',NULL,NULL),(15442,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:39',NULL,NULL),(8017,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:10',NULL,NULL),(12435,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:02',NULL,NULL),(976,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:11',NULL,NULL),(7602,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:19',NULL,NULL),(2427,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:11',NULL,NULL),(3169,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:05',NULL,NULL),(5606,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:06',NULL,NULL),(4125,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:05',NULL,NULL),(16498,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:09',NULL,NULL),(18993,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:07',NULL,NULL),(696,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:35',NULL,NULL),(16495,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:08',NULL,NULL),(941,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:01',NULL,NULL),(15562,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:18',NULL,NULL),(10175,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:38',NULL,NULL),(1703,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:03',NULL,NULL),(14314,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:22',NULL,NULL),(13693,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:49',NULL,NULL),(13392,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:05',NULL,NULL),(12162,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:47',NULL,NULL),(11027,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:24',NULL,NULL),(7007,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:02:03',NULL,NULL),(3932,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:15',NULL,NULL),(3563,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:53',NULL,NULL),(3420,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:15',NULL,NULL),(6138,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:20',NULL,NULL),(21167,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:41',NULL,NULL),(22616,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:28',NULL,NULL),(6427,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:38',NULL,NULL),(5689,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:35',NULL,NULL),(11269,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:36',NULL,NULL),(14499,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:28',NULL,NULL),(14319,1708,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:23',NULL,NULL),(14039,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:41',NULL,NULL),(18234,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:14',NULL,NULL),(18846,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:25',NULL,NULL),(20938,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:17',NULL,NULL),(9052,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:16',NULL,NULL),(13950,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:27',NULL,NULL),(1163,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:32:02',NULL,NULL),(12186,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:54',NULL,NULL),(16889,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:30',NULL,NULL),(17113,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:35',NULL,NULL),(19469,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:13',NULL,NULL),(20468,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:44',NULL,NULL),(21363,1864,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:41:52',NULL,NULL),(57,198,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:53',NULL,NULL),(8548,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:12',NULL,NULL),(14543,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:40',NULL,NULL),(14312,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:22',NULL,NULL),(3253,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:29',NULL,NULL),(7033,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:09',NULL,NULL),(6946,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:01:46',NULL,NULL),(4799,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:52',NULL,NULL),(6024,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:31',NULL,NULL),(7200,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:45',NULL,NULL),(19698,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:17',NULL,NULL),(2034,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:49',NULL,NULL),(2308,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:40',NULL,NULL),(2092,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:03',NULL,NULL),(14746,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:36',NULL,NULL),(9163,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:47',NULL,NULL),(10657,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:08',NULL,NULL),(13241,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:44',NULL,NULL),(11314,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:48',NULL,NULL),(17017,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:31:03',NULL,NULL),(17105,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:33',NULL,NULL),(18532,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:23',NULL,NULL),(18854,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:27',NULL,NULL),(18864,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:30',NULL,NULL),(19889,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:51',NULL,NULL),(20711,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:14',NULL,NULL),(340,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:36',NULL,NULL),(16880,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:27',NULL,NULL),(16299,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:54',NULL,NULL),(5685,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:34',NULL,NULL),(2114,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:09',NULL,NULL),(3817,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:46',NULL,NULL),(15081,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:15',NULL,NULL),(15019,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:00:54',NULL,NULL),(14719,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:29',NULL,NULL),(2414,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:08',NULL,NULL),(10519,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:32',NULL,NULL),(11036,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:27',NULL,NULL),(19976,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:16',NULL,NULL),(20925,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:14',NULL,NULL),(23197,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:53',NULL,NULL),(23272,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-24 11:01:07',NULL,NULL),(5987,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:19',NULL,NULL),(16716,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:32',NULL,NULL),(7003,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:02:01',NULL,NULL),(7856,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:27',NULL,NULL),(10201,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:45',NULL,NULL),(17496,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:17',NULL,NULL),(20291,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:40',NULL,NULL),(21033,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:43',NULL,NULL),(23709,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 11:30:00',NULL,NULL),(315,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:00:27',NULL,NULL),(16572,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:35',NULL,NULL),(15047,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:03',NULL,NULL),(13493,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:21',NULL,NULL),(11867,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:11',NULL,NULL),(11207,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:19',NULL,NULL),(5240,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:40',NULL,NULL),(1539,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:03',NULL,NULL),(8170,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:40',NULL,NULL),(4889,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:17',NULL,NULL),(4305,1892,'2014-01-14','23:11:00','A','000',0,'2014-01-23 23:30:46',NULL,NULL),(19548,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:35',NULL,NULL),(21734,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:00:33',NULL,NULL),(22476,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:41',NULL,NULL),(22558,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:08',NULL,NULL),(23673,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-03 19:29:58',NULL,NULL),(7445,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:53',NULL,NULL),(7857,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:27',NULL,NULL),(11440,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:23',NULL,NULL),(21644,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:37',NULL,NULL),(23182,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(173,170,'2013-12-27','14:44:00','A','000',0,'2014-01-13 03:04:58',NULL,NULL),(17244,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:19',NULL,NULL),(1002,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:18',NULL,NULL),(14924,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:25',NULL,NULL),(16435,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:45',NULL,NULL),(15599,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:30',NULL,NULL),(19863,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:45',NULL,NULL),(21759,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:42',NULL,NULL),(22005,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:09',NULL,NULL),(22517,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:54',NULL,NULL),(432,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:07',NULL,NULL),(16920,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:37',NULL,NULL),(16800,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:07',NULL,NULL),(5513,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:56',NULL,NULL),(16200,1805,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:37',NULL,NULL),(15281,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:02:08',NULL,NULL),(13449,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:15',NULL,NULL),(2249,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:25',NULL,NULL),(10617,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:57',NULL,NULL),(10368,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:32',NULL,NULL),(5290,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:30:55',NULL,NULL),(7329,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:22',NULL,NULL),(3075,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:27',NULL,NULL),(2933,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:34',NULL,NULL),(17866,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:08',NULL,NULL),(17928,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:29',NULL,NULL),(19827,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:35',NULL,NULL),(20167,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:09',NULL,NULL),(20480,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:49',NULL,NULL),(20721,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:16',NULL,NULL),(4351,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:59',NULL,NULL),(10860,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:46:00',NULL,NULL),(15851,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:31',NULL,NULL),(14748,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:37',NULL,NULL),(18748,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:35:58',NULL,NULL),(20574,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:23',NULL,NULL),(23587,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-06 17:30:03',NULL,NULL),(6294,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:01',NULL,NULL),(1244,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:14',NULL,NULL),(14128,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:54',NULL,NULL),(13252,1752,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:47',NULL,NULL),(3727,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:23',NULL,NULL),(12649,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:01',NULL,NULL),(7180,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:39',NULL,NULL),(7750,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:57',NULL,NULL),(18427,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:53',NULL,NULL),(21831,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:01:08',NULL,NULL),(23466,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:14',NULL,NULL),(852,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:37',NULL,NULL),(15717,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:10',NULL,NULL),(18312,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:22',NULL,NULL),(20596,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:31',NULL,NULL),(20956,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:22',NULL,NULL),(23515,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:30',NULL,NULL),(23546,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-01 15:30:02',NULL,NULL),(3334,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:51',NULL,NULL),(5163,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:19',NULL,NULL),(12469,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:11',NULL,NULL),(12432,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:01',NULL,NULL),(11438,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:22',NULL,NULL),(7298,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:31:14',NULL,NULL),(9378,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:44',NULL,NULL),(9015,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:07',NULL,NULL),(8275,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:08',NULL,NULL),(8119,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:27',NULL,NULL),(1805,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:28',NULL,NULL),(15493,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:54',NULL,NULL),(15449,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:40',NULL,NULL),(15192,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:51',NULL,NULL),(6328,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:10',NULL,NULL),(2737,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:00:25',NULL,NULL),(11263,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:34',NULL,NULL),(17995,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:52',NULL,NULL),(18114,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:33',NULL,NULL),(18900,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:40',NULL,NULL),(21954,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:51',NULL,NULL),(2050,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:53',NULL,NULL),(17859,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:05',NULL,NULL),(16300,1674,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:54',NULL,NULL),(16038,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:37',NULL,NULL),(2236,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:22',NULL,NULL),(13654,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:44',NULL,NULL),(13293,1821,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:58',NULL,NULL),(6925,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:40',NULL,NULL),(10955,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:04',NULL,NULL),(9238,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:07',NULL,NULL),(9202,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:58',NULL,NULL),(8973,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:02:05',NULL,NULL),(8602,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:26',NULL,NULL),(8004,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:02:06',NULL,NULL),(19207,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:07',NULL,NULL),(21395,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:04',NULL,NULL),(22798,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:18',NULL,NULL),(22816,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:24',NULL,NULL),(8201,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:48',NULL,NULL),(23364,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:38',NULL,NULL),(21,216,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:20',NULL,NULL),(18014,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:59',NULL,NULL),(1644,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:39',NULL,NULL),(13325,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:28:06',NULL,NULL),(6339,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:13',NULL,NULL),(12246,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:11',NULL,NULL),(11956,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:50',NULL,NULL),(10686,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:16',NULL,NULL),(2868,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:11',NULL,NULL),(10351,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:27',NULL,NULL),(9754,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:02',NULL,NULL),(9706,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:49',NULL,NULL),(4616,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:32:06',NULL,NULL),(19164,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:56',NULL,NULL),(2723,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:20',NULL,NULL),(18477,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:08',NULL,NULL),(17667,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:19',NULL,NULL),(16093,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:58',NULL,NULL),(3944,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:18',NULL,NULL),(15128,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:30',NULL,NULL),(11192,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:14',NULL,NULL),(12898,1726,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:13',NULL,NULL),(20994,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:33',NULL,NULL),(23098,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(4622,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:02',NULL,NULL),(7490,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:32:06',NULL,NULL),(17747,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:46',NULL,NULL),(5237,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:39',NULL,NULL),(16107,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:04',NULL,NULL),(5339,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:09',NULL,NULL),(15362,1850,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:02:24',NULL,NULL),(15266,1629,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:05',NULL,NULL),(15142,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:35',NULL,NULL),(14842,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:03',NULL,NULL),(9223,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:04',NULL,NULL),(14159,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:58',NULL,NULL),(9267,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:15',NULL,NULL),(23613,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-09 21:30:02',NULL,NULL),(23616,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-10 12:00:03',NULL,NULL),(6686,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:32',NULL,NULL),(5960,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:08',NULL,NULL),(18428,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:53',NULL,NULL),(6557,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:12',NULL,NULL),(9883,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:36',NULL,NULL),(11111,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:51',NULL,NULL),(13215,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:37',NULL,NULL),(19991,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:20',NULL,NULL),(20411,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:24',NULL,NULL),(20609,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:35',NULL,NULL),(1366,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:01',NULL,NULL),(17522,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:26',NULL,NULL),(16659,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:20:11',NULL,NULL),(1838,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:36',NULL,NULL),(14724,1841,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:31',NULL,NULL),(14692,1790,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:22',NULL,NULL),(1998,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:40',NULL,NULL),(9650,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:35',NULL,NULL),(8803,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:19',NULL,NULL),(8448,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:56',NULL,NULL),(2052,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:54',NULL,NULL),(2959,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:44',NULL,NULL),(21278,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:22',NULL,NULL),(21735,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:33',NULL,NULL),(23017,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(3815,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:00:46',NULL,NULL),(6773,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:54',NULL,NULL),(6409,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:33',NULL,NULL),(17213,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:32:09',NULL,NULL),(4054,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:46',NULL,NULL),(15875,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:14:40',NULL,NULL),(15301,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:12',NULL,NULL),(7839,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:22',NULL,NULL),(8968,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:04',NULL,NULL),(12682,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:11',NULL,NULL),(20872,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:00',NULL,NULL),(21808,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:00:59',NULL,NULL),(22243,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:30',NULL,NULL),(22330,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:52',NULL,NULL),(2323,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:44',NULL,NULL),(3633,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:12',NULL,NULL),(18759,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:01',NULL,NULL),(15156,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:39',NULL,NULL),(14830,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:52:00',NULL,NULL),(6088,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:05',NULL,NULL),(12721,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:22',NULL,NULL),(4316,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:49',NULL,NULL),(9086,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:26',NULL,NULL),(21075,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:55',NULL,NULL),(22266,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:36',NULL,NULL),(23220,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:57',NULL,NULL),(1102,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:45',NULL,NULL),(19393,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:52',NULL,NULL),(4826,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:00',NULL,NULL),(18446,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:58',NULL,NULL),(9038,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:13',NULL,NULL),(11663,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:19',NULL,NULL),(22186,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:30:15',NULL,NULL),(23214,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:56',NULL,NULL),(1734,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:11',NULL,NULL),(18946,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:53',NULL,NULL),(9006,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:04',NULL,NULL),(9316,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:28',NULL,NULL),(18153,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:46',NULL,NULL),(15991,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:21',NULL,NULL),(12266,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:17',NULL,NULL),(14711,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:27',NULL,NULL),(22601,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:32:23',NULL,NULL),(288,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:18',NULL,NULL),(7696,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:44',NULL,NULL),(1978,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:34',NULL,NULL),(4196,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:18',NULL,NULL),(14934,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:28',NULL,NULL),(12651,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:23:02',NULL,NULL),(13720,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:54',NULL,NULL),(7304,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:15',NULL,NULL),(18249,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:04',NULL,NULL),(16827,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:13',NULL,NULL),(16283,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:07',NULL,NULL),(16188,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:32',NULL,NULL),(841,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:34',NULL,NULL),(14589,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:52',NULL,NULL),(14104,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:50',NULL,NULL),(3897,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:07',NULL,NULL),(9169,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:49',NULL,NULL),(22204,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:20',NULL,NULL),(22260,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:35',NULL,NULL),(22369,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:05',NULL,NULL),(7339,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:25',NULL,NULL),(8247,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:00',NULL,NULL),(15832,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:24',NULL,NULL),(13339,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:10',NULL,NULL),(12926,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:21',NULL,NULL),(11357,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:01',NULL,NULL),(11177,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:09',NULL,NULL),(6540,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:32:08',NULL,NULL),(4252,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:33',NULL,NULL),(3382,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:04',NULL,NULL),(1707,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:04',NULL,NULL),(1186,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:08',NULL,NULL),(19371,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:45',NULL,NULL),(17628,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:04',NULL,NULL),(1348,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:53',NULL,NULL),(1853,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:40',NULL,NULL),(7169,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:36',NULL,NULL),(2639,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:05',NULL,NULL),(3656,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:05',NULL,NULL),(12317,1893,'2014-01-14','23:11:00','A','000',1,'2014-01-24 05:20:32',NULL,NULL),(9934,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:49',NULL,NULL),(9539,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:06',NULL,NULL),(3651,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:04',NULL,NULL),(20177,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:12',NULL,NULL),(21394,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:03',NULL,NULL),(22564,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:10',NULL,NULL),(23100,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:35',NULL,NULL),(2926,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:32',NULL,NULL),(3576,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:56',NULL,NULL),(11846,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:06',NULL,NULL),(17920,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:26',NULL,NULL),(17415,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:51',NULL,NULL),(13875,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:16',NULL,NULL),(15889,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:45',NULL,NULL),(21270,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:19',NULL,NULL),(21813,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:01',NULL,NULL),(22855,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:37',NULL,NULL),(108,326,'2013-12-27','15:46:00','A','000',1,'2014-01-07 10:03:18',NULL,NULL),(8390,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:42',NULL,NULL),(18288,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:15',NULL,NULL),(18143,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:43',NULL,NULL),(18074,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:20',NULL,NULL),(6979,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:54',NULL,NULL),(16665,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:13',NULL,NULL),(14883,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:14',NULL,NULL),(2457,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:19',NULL,NULL),(6378,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:24',NULL,NULL),(18926,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:47',NULL,NULL),(8656,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:40',NULL,NULL),(10537,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:37',NULL,NULL),(13310,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:02',NULL,NULL),(12867,1816,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:07',NULL,NULL),(798,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:22',NULL,NULL),(20214,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:12',NULL,NULL),(2616,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:59',NULL,NULL),(3150,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:52',NULL,NULL),(4683,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:20',NULL,NULL),(3853,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:55',NULL,NULL),(9466,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:09',NULL,NULL),(16382,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:24',NULL,NULL),(15384,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:28',NULL,NULL),(14969,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:37',NULL,NULL),(13638,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:42',NULL,NULL),(793,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:21',NULL,NULL),(17139,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:44',NULL,NULL),(16020,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:31',NULL,NULL),(8195,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:47',NULL,NULL),(3176,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:07',NULL,NULL),(13770,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:01',NULL,NULL),(13769,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:01',NULL,NULL),(7171,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:37',NULL,NULL),(20514,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:01',NULL,NULL),(2748,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:29',NULL,NULL),(18824,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:19',NULL,NULL),(7498,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:32:08',NULL,NULL),(5247,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:42',NULL,NULL),(14872,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:11',NULL,NULL),(20317,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:49',NULL,NULL),(19690,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:15',NULL,NULL),(3760,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:31',NULL,NULL),(14351,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:45',NULL,NULL),(4060,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:48',NULL,NULL),(13087,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:03',NULL,NULL),(12619,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:53',NULL,NULL),(9363,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:40',NULL,NULL),(78,323,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:13',NULL,NULL),(1818,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:31',NULL,NULL),(8436,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:53',NULL,NULL),(15210,1777,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:01:54',NULL,NULL),(14152,1882,'2014-01-14','23:11:00','A','000',0,'2014-01-24 05:31:57',NULL,NULL),(13743,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:57',NULL,NULL),(7485,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:05',NULL,NULL),(10206,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:47',NULL,NULL),(10580,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:48',NULL,NULL),(22793,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:16',NULL,NULL),(23304,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:16',NULL,NULL),(2235,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:22',NULL,NULL),(6505,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:59',NULL,NULL),(17718,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:37',NULL,NULL),(7704,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:46',NULL,NULL),(10571,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:46',NULL,NULL),(14197,1649,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:04',NULL,NULL),(19455,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:09',NULL,NULL),(19854,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:42',NULL,NULL),(20869,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:59',NULL,NULL),(21016,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:39',NULL,NULL),(21919,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:39',NULL,NULL),(707,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:39',NULL,NULL),(19626,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:56',NULL,NULL),(7577,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:12',NULL,NULL),(10168,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:36',NULL,NULL),(15808,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:41',NULL,NULL),(11289,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:41',NULL,NULL),(20847,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:30:53',NULL,NULL),(21415,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:12',NULL,NULL),(3703,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:17',NULL,NULL),(19724,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:08',NULL,NULL),(17642,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:10',NULL,NULL),(17414,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:50',NULL,NULL),(4387,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:08',NULL,NULL),(5613,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:08',NULL,NULL),(9793,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:12',NULL,NULL),(11740,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:39',NULL,NULL),(17,324,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:17',NULL,NULL),(1870,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:44',NULL,NULL),(19383,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:49',NULL,NULL),(21283,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:24',NULL,NULL),(20029,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:31',NULL,NULL),(22381,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:09',NULL,NULL),(531,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:40',NULL,NULL),(1215,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:03',NULL,NULL),(16671,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:16',NULL,NULL),(15570,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:20',NULL,NULL),(14768,1727,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:43',NULL,NULL),(14049,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:42',NULL,NULL),(11768,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:47',NULL,NULL),(4679,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:19',NULL,NULL),(4626,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:04',NULL,NULL),(3335,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:51',NULL,NULL),(3701,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:16',NULL,NULL),(19912,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:57',NULL,NULL),(22083,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:37',NULL,NULL),(23412,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:54',NULL,NULL),(23621,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 00:00:02',NULL,NULL),(23639,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-13 16:00:02',NULL,NULL),(4100,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:58',NULL,NULL),(18391,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:43',NULL,NULL),(2275,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:32',NULL,NULL),(14040,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:41',NULL,NULL),(10281,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:08',NULL,NULL),(10416,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:45',NULL,NULL),(19887,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:51',NULL,NULL),(23308,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:18',NULL,NULL),(1055,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:32',NULL,NULL),(5611,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:08',NULL,NULL),(18416,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:50',NULL,NULL),(16550,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:27',NULL,NULL),(13922,1713,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:23',NULL,NULL),(9728,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:36:55',NULL,NULL),(8902,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:46',NULL,NULL),(2083,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:01',NULL,NULL),(3063,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:22',NULL,NULL),(4435,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:21',NULL,NULL),(19540,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:32',NULL,NULL),(20164,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:32:09',NULL,NULL),(21067,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:53',NULL,NULL),(21308,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:33',NULL,NULL),(23264,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:06',NULL,NULL),(8263,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:05',NULL,NULL),(18097,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:28',NULL,NULL),(17250,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:21',NULL,NULL),(11138,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:59',NULL,NULL),(11802,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:55',NULL,NULL),(12418,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:21:57',NULL,NULL),(19515,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:26',NULL,NULL),(19617,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:53',NULL,NULL),(20658,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:53',NULL,NULL),(893,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:48',NULL,NULL),(3017,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:04',NULL,NULL),(3174,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:06',NULL,NULL),(4127,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:02:05',NULL,NULL),(5188,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:26',NULL,NULL),(7566,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:10',NULL,NULL),(7763,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:01',NULL,NULL),(9563,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:12',NULL,NULL),(20095,1829,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:50',NULL,NULL),(21797,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:55',NULL,NULL),(21909,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:35',NULL,NULL),(1731,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:10',NULL,NULL),(3773,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:35',NULL,NULL),(3797,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:41',NULL,NULL),(7972,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:58',NULL,NULL),(13376,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:28:20',NULL,NULL),(19972,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:15',NULL,NULL),(22554,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:06',NULL,NULL),(2117,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:09',NULL,NULL),(16179,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:29',NULL,NULL),(15928,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:58',NULL,NULL),(18785,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:08',NULL,NULL),(5759,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:00',NULL,NULL),(13599,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:37',NULL,NULL),(4317,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:49',NULL,NULL),(5400,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:25',NULL,NULL),(10857,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:59',NULL,NULL),(9773,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:07',NULL,NULL),(9013,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:06',NULL,NULL),(19255,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:12',NULL,NULL),(19964,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:13',NULL,NULL),(20961,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:31:23',NULL,NULL),(2211,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:09',NULL,NULL),(19215,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:10',NULL,NULL),(19151,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:52',NULL,NULL),(18800,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:13',NULL,NULL),(6649,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:23',NULL,NULL),(5729,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:49',NULL,NULL),(16937,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:41',NULL,NULL),(4105,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:59',NULL,NULL),(14611,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:59',NULL,NULL),(13635,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:41',NULL,NULL),(10210,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:48',NULL,NULL),(5420,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:31',NULL,NULL),(5214,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:33',NULL,NULL),(20166,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:09',NULL,NULL),(23318,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:22',NULL,NULL),(746,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:08',NULL,NULL),(840,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:34',NULL,NULL),(17376,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:38',NULL,NULL),(16804,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:08',NULL,NULL),(16773,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:52',NULL,NULL),(16376,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:22',NULL,NULL),(14401,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:00',NULL,NULL),(6479,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:52',NULL,NULL),(10081,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:12',NULL,NULL),(3220,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:20',NULL,NULL),(9553,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:10',NULL,NULL),(6119,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:14',NULL,NULL),(8567,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:17',NULL,NULL),(7959,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:55',NULL,NULL),(5937,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:00',NULL,NULL),(22653,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:25',NULL,NULL),(7599,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:18',NULL,NULL),(3466,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:27',NULL,NULL),(17084,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:26',NULL,NULL),(16905,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:34',NULL,NULL),(16847,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:19',NULL,NULL),(19476,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:14',NULL,NULL),(8324,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:24',NULL,NULL),(9097,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:29',NULL,NULL),(11000,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:17',NULL,NULL),(90,342,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:24',NULL,NULL),(18510,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:17',NULL,NULL),(18294,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:17',NULL,NULL),(17968,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:43',NULL,NULL),(17507,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:21',NULL,NULL),(13639,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:42',NULL,NULL),(683,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:31',NULL,NULL),(13294,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:58',NULL,NULL),(12895,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:12',NULL,NULL),(6674,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:29',NULL,NULL),(6132,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:17',NULL,NULL),(848,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:36',NULL,NULL),(2401,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:04',NULL,NULL),(3011,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:02',NULL,NULL),(4997,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:49',NULL,NULL),(3381,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:04',NULL,NULL),(4411,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:14',NULL,NULL),(21053,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:49',NULL,NULL),(1232,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:09',NULL,NULL),(6267,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:54',NULL,NULL),(4361,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:02',NULL,NULL),(8366,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:35',NULL,NULL),(17636,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:02:07',NULL,NULL),(14229,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:09',NULL,NULL),(14046,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:42',NULL,NULL),(13913,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:21',NULL,NULL),(9922,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:46',NULL,NULL),(9974,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:43',NULL,NULL),(10049,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:03',NULL,NULL),(11300,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:44',NULL,NULL),(23203,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:54',NULL,NULL),(23382,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:44',NULL,NULL),(35,290,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:33',NULL,NULL),(19186,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:38:01',NULL,NULL),(18279,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:13',NULL,NULL),(17570,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:42',NULL,NULL),(695,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:34',NULL,NULL),(15658,1780,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:49',NULL,NULL),(13088,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:03',NULL,NULL),(12903,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:14',NULL,NULL),(11299,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:44',NULL,NULL),(9866,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:32',NULL,NULL),(6667,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:27',NULL,NULL),(3240,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:30:25',NULL,NULL),(1897,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:51',NULL,NULL),(2936,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:35',NULL,NULL),(5971,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:13',NULL,NULL),(19946,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:31:07',NULL,NULL),(23392,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:47',NULL,NULL),(118,167,'2013-12-27','14:38:00','A','000',0,'2014-01-13 03:04:41',NULL,NULL),(19364,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:43',NULL,NULL),(18779,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:07',NULL,NULL),(3357,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:57',NULL,NULL),(13297,1774,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:59',NULL,NULL),(15743,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:18',NULL,NULL),(14710,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:27',NULL,NULL),(20423,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:28',NULL,NULL),(20632,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:44',NULL,NULL),(21403,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:07',NULL,NULL),(22481,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:43',NULL,NULL),(2079,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:00',NULL,NULL),(19201,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:38:06',NULL,NULL),(17903,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:21',NULL,NULL),(17225,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:13',NULL,NULL),(7300,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:14',NULL,NULL),(17057,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:16',NULL,NULL),(16456,1581,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:53',NULL,NULL),(16072,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:49',NULL,NULL),(14555,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:43',NULL,NULL),(14486,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:25',NULL,NULL),(13787,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:04',NULL,NULL),(13196,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:32',NULL,NULL),(5663,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:00:26',NULL,NULL),(5382,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:20',NULL,NULL),(11763,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:45',NULL,NULL),(10011,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:53',NULL,NULL),(3660,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:06',NULL,NULL),(5251,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:43',NULL,NULL),(19910,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:57',NULL,NULL),(20139,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:32:02',NULL,NULL),(20934,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:16',NULL,NULL),(7988,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:02:02',NULL,NULL),(2301,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:39',NULL,NULL),(19142,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:49',NULL,NULL),(19071,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:28',NULL,NULL),(17004,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:59',NULL,NULL),(7483,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:32:04',NULL,NULL),(10814,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:48',NULL,NULL),(11130,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:57',NULL,NULL),(11048,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:30',NULL,NULL),(20082,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:46',NULL,NULL),(20308,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:46',NULL,NULL),(22040,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:21',NULL,NULL),(22354,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:00',NULL,NULL),(657,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:02:20',NULL,NULL),(7635,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:27',NULL,NULL),(5510,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:55',NULL,NULL),(2298,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:38',NULL,NULL),(4545,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:48',NULL,NULL),(19847,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:40',NULL,NULL),(19731,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:10',NULL,NULL),(12620,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:53',NULL,NULL),(12455,1687,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:07',NULL,NULL),(8174,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:41',NULL,NULL),(19866,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:45',NULL,NULL),(7820,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:17',NULL,NULL),(17505,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:20',NULL,NULL),(13990,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:33',NULL,NULL),(1858,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:30:41',NULL,NULL),(10313,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:16',NULL,NULL),(9858,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:30',NULL,NULL),(9612,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:25',NULL,NULL),(7517,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:13',NULL,NULL),(3143,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:02:50',NULL,NULL),(3442,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:20',NULL,NULL),(1915,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:55',NULL,NULL),(6741,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:46',NULL,NULL),(5790,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:10',NULL,NULL),(23574,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 23:30:02',NULL,NULL),(8588,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:22',NULL,NULL),(5535,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:03',NULL,NULL),(4861,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:09',NULL,NULL),(17183,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:58',NULL,NULL),(9170,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:49',NULL,NULL),(9489,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:35:53',NULL,NULL),(14044,1755,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:41',NULL,NULL),(13754,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:59',NULL,NULL),(478,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:22',NULL,NULL),(19668,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:10',NULL,NULL),(8635,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:34',NULL,NULL),(1613,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:29',NULL,NULL),(8016,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:10',NULL,NULL),(21200,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:53',NULL,NULL),(2254,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:27',NULL,NULL),(2504,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:31',NULL,NULL),(3104,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:36',NULL,NULL),(16171,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:27',NULL,NULL),(10831,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:52',NULL,NULL),(12263,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:16',NULL,NULL),(11421,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:20',NULL,NULL),(22413,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:20',NULL,NULL),(23569,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-04 13:30:02',NULL,NULL),(23654,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 13:30:01',NULL,NULL),(1641,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:38',NULL,NULL),(6107,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:10',NULL,NULL),(20919,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:12',NULL,NULL),(6923,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:39',NULL,NULL),(13160,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:23',NULL,NULL),(16959,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:47',NULL,NULL),(23575,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 01:30:02',NULL,NULL),(10612,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:56',NULL,NULL),(1986,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:36',NULL,NULL),(16329,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:05',NULL,NULL),(14781,1655,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:47',NULL,NULL),(14218,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:07',NULL,NULL),(21338,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:43',NULL,NULL),(2157,1844,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:32:19',NULL,NULL),(17557,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:38',NULL,NULL),(3313,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:45',NULL,NULL),(5822,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:21',NULL,NULL),(12182,1759,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:53',NULL,NULL),(11326,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:51',NULL,NULL),(249,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:05',NULL,NULL),(1274,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:26',NULL,NULL),(20004,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:24',NULL,NULL),(19583,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:44',NULL,NULL),(19579,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:43',NULL,NULL),(18646,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:54',NULL,NULL),(17380,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:39',NULL,NULL),(8382,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:39',NULL,NULL),(6480,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:52',NULL,NULL),(15428,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:36',NULL,NULL),(11760,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:15:44',NULL,NULL),(13609,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:38',NULL,NULL),(12279,1801,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:20:20',NULL,NULL),(12243,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:10',NULL,NULL),(10673,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:13',NULL,NULL),(2372,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:57',NULL,NULL),(21342,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:45',NULL,NULL),(9758,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:03',NULL,NULL),(9294,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:22',NULL,NULL),(9042,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:14',NULL,NULL),(17472,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:01:09',NULL,NULL),(16984,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:53',NULL,NULL),(8085,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:18',NULL,NULL),(16151,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:19',NULL,NULL),(8070,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:14',NULL,NULL),(6871,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:22',NULL,NULL),(14843,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:04',NULL,NULL),(6322,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:09',NULL,NULL),(12968,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:32',NULL,NULL),(12617,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:52',NULL,NULL),(11335,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:54',NULL,NULL),(19188,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:38:02',NULL,NULL),(19062,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:26',NULL,NULL),(948,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:03',NULL,NULL),(16157,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:21',NULL,NULL),(8478,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:04',NULL,NULL),(1712,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:06',NULL,NULL),(20707,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:13',NULL,NULL),(20615,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:38',NULL,NULL),(20083,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:46',NULL,NULL),(17449,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:02',NULL,NULL),(4031,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:40',NULL,NULL),(3505,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:37',NULL,NULL),(11769,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:47',NULL,NULL),(12958,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:30',NULL,NULL),(18053,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:13',NULL,NULL),(19659,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:07',NULL,NULL),(19575,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:42',NULL,NULL),(10114,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:22',NULL,NULL),(11734,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:37',NULL,NULL),(10018,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:39:55',NULL,NULL),(482,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:24',NULL,NULL),(846,1856,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:30:36',NULL,NULL),(5312,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:01',NULL,NULL),(17665,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:18',NULL,NULL),(6343,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:14',NULL,NULL),(12945,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:26',NULL,NULL),(2690,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:08',NULL,NULL),(17800,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:44',NULL,NULL),(15152,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:38',NULL,NULL),(1303,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:36',NULL,NULL),(14047,1647,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:42',NULL,NULL),(8471,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:32:03',NULL,NULL),(7771,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:03',NULL,NULL),(6630,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:18',NULL,NULL),(11336,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:54',NULL,NULL),(9429,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:58',NULL,NULL),(20310,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:47',NULL,NULL),(20033,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:32',NULL,NULL),(4508,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:39',NULL,NULL),(17165,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:52',NULL,NULL),(7882,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:35',NULL,NULL),(15154,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:39',NULL,NULL),(7058,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:03',NULL,NULL),(3592,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:01',NULL,NULL),(23159,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:46',NULL,NULL),(10937,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:46:20',NULL,NULL),(21793,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:54',NULL,NULL),(19110,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:39',NULL,NULL),(17779,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:12:36',NULL,NULL),(14432,1811,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:09',NULL,NULL),(14108,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:51',NULL,NULL),(13242,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:45',NULL,NULL),(12611,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:50',NULL,NULL),(12438,1787,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:02',NULL,NULL),(1904,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:53',NULL,NULL),(7427,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:49',NULL,NULL),(7661,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:34',NULL,NULL),(9127,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:38',NULL,NULL),(9447,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:04',NULL,NULL),(1590,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:21',NULL,NULL),(22116,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:48',NULL,NULL),(2923,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:31',NULL,NULL),(11425,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:21',NULL,NULL),(13307,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:02',NULL,NULL),(21138,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:32:13',NULL,NULL),(15214,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:01:55',NULL,NULL),(5216,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:33',NULL,NULL),(5839,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:27',NULL,NULL),(20868,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:59',NULL,NULL),(4999,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:49',NULL,NULL),(15647,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:46',NULL,NULL),(15246,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:02:01',NULL,NULL),(2999,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:58',NULL,NULL),(3121,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:42',NULL,NULL),(18537,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:25',NULL,NULL),(18515,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:19',NULL,NULL),(23253,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(23542,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-31 23:30:02',NULL,NULL),(8961,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:02:02',NULL,NULL),(19553,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:36',NULL,NULL),(11283,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:39',NULL,NULL),(22396,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:14',NULL,NULL),(10085,1879,'2014-01-14','23:11:00','A','000',0,'2014-01-24 04:40:14',NULL,NULL),(20121,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:57',NULL,NULL),(18401,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:46',NULL,NULL),(2928,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:01:32',NULL,NULL),(14397,1766,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:49:59',NULL,NULL),(2876,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:14',NULL,NULL),(12750,1644,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:30',NULL,NULL),(7122,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:24',NULL,NULL),(342,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:00:36',NULL,NULL),(23180,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:50',NULL,NULL),(8493,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:09',NULL,NULL),(22896,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:51',NULL,NULL),(12800,1782,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:44',NULL,NULL),(12005,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:05',NULL,NULL),(11379,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:06',NULL,NULL),(10482,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:23',NULL,NULL),(12684,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:11',NULL,NULL),(7125,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:25',NULL,NULL),(10037,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:00',NULL,NULL),(9217,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:31:02',NULL,NULL),(1754,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:16',NULL,NULL),(9855,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:29',NULL,NULL),(10818,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:49',NULL,NULL),(932,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:59',NULL,NULL),(22997,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(8180,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:43',NULL,NULL),(2048,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:53',NULL,NULL),(12861,1819,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:24:04',NULL,NULL),(16191,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:34',NULL,NULL),(15169,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:44',NULL,NULL),(5074,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:10',NULL,NULL),(22525,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:57',NULL,NULL),(22120,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:50',NULL,NULL),(22038,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:02:20',NULL,NULL),(19792,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:26',NULL,NULL),(19516,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:26',NULL,NULL),(11803,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:55',NULL,NULL),(13451,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:15',NULL,NULL),(13230,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:41',NULL,NULL),(3911,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:10',NULL,NULL),(6793,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:01',NULL,NULL),(1319,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:42',NULL,NULL),(3898,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:07',NULL,NULL),(1935,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:00',NULL,NULL),(1831,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:35',NULL,NULL),(17164,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:52',NULL,NULL),(13362,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:28:16',NULL,NULL),(10629,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:00',NULL,NULL),(16055,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:43',NULL,NULL),(8951,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:59',NULL,NULL),(20521,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:02:03',NULL,NULL),(8869,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:37',NULL,NULL),(13699,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:50',NULL,NULL),(8750,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:05',NULL,NULL),(23490,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:02:22',NULL,NULL),(4822,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:58',NULL,NULL),(7435,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:51',NULL,NULL),(21931,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:43',NULL,NULL),(14977,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:40',NULL,NULL),(18275,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:11',NULL,NULL),(9898,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:40',NULL,NULL),(4282,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:40',NULL,NULL),(8861,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:35',NULL,NULL),(5082,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:12',NULL,NULL),(18239,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:15:16',NULL,NULL),(16141,1723,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:16',NULL,NULL),(7924,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:46',NULL,NULL),(14246,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:12',NULL,NULL),(12956,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:29',NULL,NULL),(11666,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:20',NULL,NULL),(11163,1855,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:01:05',NULL,NULL),(6521,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:03',NULL,NULL),(7085,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:12',NULL,NULL),(1862,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:42',NULL,NULL),(4457,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:27',NULL,NULL),(20127,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:58',NULL,NULL),(11259,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:01:33',NULL,NULL),(17885,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:14',NULL,NULL),(12443,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:04',NULL,NULL),(12993,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:39',NULL,NULL),(14867,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:10',NULL,NULL),(23628,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-12 00:00:02',NULL,NULL),(265,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:10',NULL,NULL),(10224,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:51',NULL,NULL),(8489,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:07',NULL,NULL),(1632,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:35',NULL,NULL),(22190,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:16',NULL,NULL),(15207,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:54',NULL,NULL),(13549,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:29',NULL,NULL),(13330,1770,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:28:08',NULL,NULL),(2398,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:04',NULL,NULL),(3203,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:14',NULL,NULL),(19694,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:02:16',NULL,NULL),(2508,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:32',NULL,NULL),(3808,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:44',NULL,NULL),(5433,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:34',NULL,NULL),(22128,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:52',NULL,NULL),(21810,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:00',NULL,NULL),(20201,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:07',NULL,NULL),(17123,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:39',NULL,NULL),(12152,1725,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:45',NULL,NULL),(13650,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:44',NULL,NULL),(19874,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:48',NULL,NULL),(22144,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:04',NULL,NULL),(10469,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:19',NULL,NULL),(855,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:38',NULL,NULL),(18644,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:53',NULL,NULL),(1474,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:40',NULL,NULL),(16284,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:08',NULL,NULL),(15241,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:00',NULL,NULL),(14357,1833,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:49:47',NULL,NULL),(13617,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:39',NULL,NULL),(4670,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:16',NULL,NULL),(12802,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:44',NULL,NULL),(4623,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:03',NULL,NULL),(8197,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:47',NULL,NULL),(21259,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:15',NULL,NULL),(20253,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:26',NULL,NULL),(19176,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:59',NULL,NULL),(16709,1651,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:29',NULL,NULL),(17115,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:31:36',NULL,NULL),(17364,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:34',NULL,NULL),(9893,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:39',NULL,NULL),(16645,1775,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:05',NULL,NULL),(15593,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:28',NULL,NULL),(6821,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:08',NULL,NULL),(14469,1730,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:20',NULL,NULL),(12251,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:20:12',NULL,NULL),(7762,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:00',NULL,NULL),(2143,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:16',NULL,NULL),(12515,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:24',NULL,NULL),(2576,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:49',NULL,NULL),(9886,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:37',NULL,NULL),(8068,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:13',NULL,NULL),(13455,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:16',NULL,NULL),(12999,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:40',NULL,NULL),(4540,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:47',NULL,NULL),(11882,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:15',NULL,NULL),(22746,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:57',NULL,NULL),(22159,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:07',NULL,NULL),(21326,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:39',NULL,NULL),(18715,1876,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:32:13',NULL,NULL),(5643,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:19',NULL,NULL),(10887,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:07',NULL,NULL),(1258,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:19',NULL,NULL),(13202,1873,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:27:34',NULL,NULL),(1531,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:00',NULL,NULL),(7651,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:32',NULL,NULL),(5170,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:21',NULL,NULL),(23225,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:58',NULL,NULL),(20765,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:29',NULL,NULL),(8109,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:24',NULL,NULL),(411,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:01:01',NULL,NULL),(7629,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:26',NULL,NULL),(5896,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:46',NULL,NULL),(20212,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:11',NULL,NULL),(7930,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:47',NULL,NULL),(17045,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:13',NULL,NULL),(16548,1707,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:27',NULL,NULL),(14409,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:03',NULL,NULL),(13551,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:30',NULL,NULL),(6196,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:36',NULL,NULL),(5347,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:11',NULL,NULL),(20236,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:20',NULL,NULL),(4987,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:46',NULL,NULL),(9074,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:23',NULL,NULL),(9103,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:31',NULL,NULL),(9965,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:37:57',NULL,NULL),(2209,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:08',NULL,NULL),(1949,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:04',NULL,NULL),(13923,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:23',NULL,NULL),(14182,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:02',NULL,NULL),(17829,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:54',NULL,NULL),(17788,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:12:39',NULL,NULL),(12590,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:44',NULL,NULL),(1990,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:37',NULL,NULL),(11608,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:05',NULL,NULL),(2915,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:28',NULL,NULL),(6136,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:19',NULL,NULL),(10623,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:59',NULL,NULL),(2198,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:05',NULL,NULL),(9459,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:32:07',NULL,NULL),(11830,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:02',NULL,NULL),(14177,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:01',NULL,NULL),(14533,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:37',NULL,NULL),(16121,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:09',NULL,NULL),(9382,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:45',NULL,NULL),(22943,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:05',NULL,NULL),(4970,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:40',NULL,NULL),(8901,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:46',NULL,NULL),(10055,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:40:05',NULL,NULL),(6737,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:45',NULL,NULL),(4853,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:07',NULL,NULL),(11893,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:18',NULL,NULL),(21429,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:42:17',NULL,NULL),(23058,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(744,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:07',NULL,NULL),(1606,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:26',NULL,NULL),(19585,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:45',NULL,NULL),(19304,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:26',NULL,NULL),(9719,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:53',NULL,NULL),(17160,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:51',NULL,NULL),(6665,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:27',NULL,NULL),(16134,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:14',NULL,NULL),(14584,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:51',NULL,NULL),(5115,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:04',NULL,NULL),(22929,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:02',NULL,NULL),(20642,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:47',NULL,NULL),(8380,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:39',NULL,NULL),(7247,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:00',NULL,NULL),(1415,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:18',NULL,NULL),(22301,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:44',NULL,NULL),(11705,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:30',NULL,NULL),(10953,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:03',NULL,NULL),(6844,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:14',NULL,NULL),(10406,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:42',NULL,NULL),(13652,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:44',NULL,NULL),(22450,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:33',NULL,NULL),(19294,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:23',NULL,NULL),(16598,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:45',NULL,NULL),(4492,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:35',NULL,NULL),(3232,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:23',NULL,NULL),(9889,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:38',NULL,NULL),(23000,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(22618,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:32:29',NULL,NULL),(7563,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:09',NULL,NULL),(514,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:34',NULL,NULL),(22329,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:52',NULL,NULL),(1710,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:05',NULL,NULL),(20442,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:35',NULL,NULL),(12704,1696,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:17',NULL,NULL),(2067,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:57',NULL,NULL),(8048,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:08',NULL,NULL),(8015,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:02:10',NULL,NULL),(16015,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:29',NULL,NULL),(14427,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:08',NULL,NULL),(21340,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:44',NULL,NULL),(1342,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 20:00:51',NULL,NULL),(18915,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:44',NULL,NULL),(6820,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:08',NULL,NULL),(11599,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:03',NULL,NULL),(11374,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:05',NULL,NULL),(6208,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:39',NULL,NULL),(1764,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:18',NULL,NULL),(10726,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:26',NULL,NULL),(3713,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:19',NULL,NULL),(5475,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:46',NULL,NULL),(10309,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:15',NULL,NULL),(1794,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:26',NULL,NULL),(3074,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:26',NULL,NULL),(20059,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:39',NULL,NULL),(19562,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:01:39',NULL,NULL),(9233,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:06',NULL,NULL),(7132,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:27',NULL,NULL),(5757,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:59',NULL,NULL),(12658,1688,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:03',NULL,NULL),(13758,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:00',NULL,NULL),(14027,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:39',NULL,NULL),(21706,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:22',NULL,NULL),(702,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:37',NULL,NULL),(1482,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:43',NULL,NULL),(21274,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:20',NULL,NULL),(20888,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:04',NULL,NULL),(5804,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:01:15',NULL,NULL),(19306,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:27',NULL,NULL),(21610,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:24',NULL,NULL),(22103,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:44',NULL,NULL),(22420,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:22',NULL,NULL),(22645,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:22',NULL,NULL),(9475,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:11',NULL,NULL),(9275,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:17',NULL,NULL),(16973,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:50',NULL,NULL),(4265,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:36',NULL,NULL),(7460,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:58',NULL,NULL),(6192,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:35',NULL,NULL),(13112,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:10',NULL,NULL),(13100,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:06',NULL,NULL),(1295,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:33',NULL,NULL),(9330,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:31:32',NULL,NULL),(8231,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:56',NULL,NULL),(1588,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:20',NULL,NULL),(16562,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:32',NULL,NULL),(15970,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:13',NULL,NULL),(3347,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:55',NULL,NULL),(13692,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:49',NULL,NULL),(6364,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:21',NULL,NULL),(13164,1578,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:24',NULL,NULL),(12058,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:20',NULL,NULL),(10835,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:45:53',NULL,NULL),(2168,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:32:22',NULL,NULL),(21836,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:09',NULL,NULL),(2349,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:30:51',NULL,NULL),(21121,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:08',NULL,NULL),(20009,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:26',NULL,NULL),(3524,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:42',NULL,NULL),(3643,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:32:15',NULL,NULL),(8546,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:11',NULL,NULL),(15731,1767,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:14',NULL,NULL),(15481,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:49',NULL,NULL),(11908,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:22',NULL,NULL),(14441,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:12',NULL,NULL),(14188,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:03',NULL,NULL),(13008,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:42',NULL,NULL),(12346,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:41',NULL,NULL),(19417,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:59',NULL,NULL),(6707,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:37',NULL,NULL),(1704,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:04',NULL,NULL),(21424,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:15',NULL,NULL),(10779,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:39',NULL,NULL),(19216,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:02',NULL,NULL),(4795,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:51',NULL,NULL),(16286,1639,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:09',NULL,NULL),(10172,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:37',NULL,NULL),(778,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:17',NULL,NULL),(15284,1728,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:09',NULL,NULL),(15103,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:22',NULL,NULL),(13588,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:35',NULL,NULL),(17685,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:25',NULL,NULL),(16872,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:25',NULL,NULL),(16717,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:32',NULL,NULL),(13709,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:53',NULL,NULL),(22681,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:34',NULL,NULL),(5377,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:19',NULL,NULL),(22127,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:52',NULL,NULL),(16468,1885,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:18:57',NULL,NULL),(9569,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:14',NULL,NULL),(604,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:03',NULL,NULL),(8956,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:02:00',NULL,NULL),(9485,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:32:13',NULL,NULL),(7120,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:24',NULL,NULL),(22964,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(9312,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:27',NULL,NULL),(21052,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:49',NULL,NULL),(19229,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:05',NULL,NULL),(17366,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:35',NULL,NULL),(2435,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:14',NULL,NULL),(3880,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:02',NULL,NULL),(14467,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:19',NULL,NULL),(13590,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:35',NULL,NULL),(5351,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:12',NULL,NULL),(1479,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:42',NULL,NULL),(18487,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:11',NULL,NULL),(3659,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:06',NULL,NULL),(357,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:41',NULL,NULL),(18727,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:32:16',NULL,NULL),(10092,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:16',NULL,NULL),(16652,1866,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:20:08',NULL,NULL),(14514,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:32',NULL,NULL),(14429,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:09',NULL,NULL),(13779,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:03',NULL,NULL),(6833,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:11',NULL,NULL),(2841,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:02',NULL,NULL),(2809,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:50',NULL,NULL),(21365,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:53',NULL,NULL),(3403,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:10',NULL,NULL),(10364,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:30',NULL,NULL),(21988,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:03',NULL,NULL),(17984,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:48',NULL,NULL),(15659,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:50',NULL,NULL),(10087,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:14',NULL,NULL),(11874,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:13',NULL,NULL),(7757,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:59',NULL,NULL),(5735,1833,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:00:51',NULL,NULL),(5691,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:36',NULL,NULL),(20634,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:44',NULL,NULL),(18131,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:39',NULL,NULL),(4840,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:03',NULL,NULL),(5915,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:53',NULL,NULL),(21368,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:54',NULL,NULL),(19095,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:35',NULL,NULL),(7908,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:42',NULL,NULL),(3945,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:19',NULL,NULL),(6909,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:33',NULL,NULL),(20528,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:06',NULL,NULL),(4837,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:02',NULL,NULL),(17404,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:47',NULL,NULL),(3950,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:20',NULL,NULL),(12332,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:37',NULL,NULL),(12889,1643,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:15',NULL,NULL),(5238,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:40',NULL,NULL),(395,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:56',NULL,NULL),(20031,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:32',NULL,NULL),(11888,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:17',NULL,NULL),(1095,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:43',NULL,NULL),(11868,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:12',NULL,NULL),(4417,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:16',NULL,NULL),(11870,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:12',NULL,NULL),(11700,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:28',NULL,NULL),(11684,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:24',NULL,NULL),(22468,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:39',NULL,NULL),(21727,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:31',NULL,NULL),(20015,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:27',NULL,NULL),(19060,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:25',NULL,NULL),(5548,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:07',NULL,NULL),(5494,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:51',NULL,NULL),(5058,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:05',NULL,NULL),(15635,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:42',NULL,NULL),(15444,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:39',NULL,NULL),(9098,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:29',NULL,NULL),(7422,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:47',NULL,NULL),(22789,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:14',NULL,NULL),(14562,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:45',NULL,NULL),(2625,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:02',NULL,NULL),(3965,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:24',NULL,NULL),(2375,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:57',NULL,NULL),(5450,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:39',NULL,NULL),(2027,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:47',NULL,NULL),(539,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:42',NULL,NULL),(21107,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:04',NULL,NULL),(19404,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:55',NULL,NULL),(5493,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:51',NULL,NULL),(1083,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:40',NULL,NULL),(3198,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:13',NULL,NULL),(6637,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:20',NULL,NULL),(13591,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:36',NULL,NULL),(211,277,'2013-12-27','15:31:00','A','000',0,'2014-01-13 03:05:11',NULL,NULL),(7010,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:02:03',NULL,NULL),(16132,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:13',NULL,NULL),(19862,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:44',NULL,NULL),(17330,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:23',NULL,NULL),(23676,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-04 01:29:57',NULL,NULL),(3136,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:48',NULL,NULL),(17217,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:32:10',NULL,NULL),(7946,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:51',NULL,NULL),(8235,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:57',NULL,NULL),(15535,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:08',NULL,NULL),(13503,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:23',NULL,NULL),(21434,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:19',NULL,NULL),(21741,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:35',NULL,NULL),(23287,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:10',NULL,NULL),(23492,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:02:22',NULL,NULL),(308,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:25',NULL,NULL),(4854,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:07',NULL,NULL),(7343,1786,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:26',NULL,NULL),(14249,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:32:12',NULL,NULL),(12533,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:29',NULL,NULL),(11620,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:08',NULL,NULL),(11449,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:25',NULL,NULL),(18459,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:03',NULL,NULL),(19214,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:38:10',NULL,NULL),(19695,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:02:17',NULL,NULL),(20527,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:06',NULL,NULL),(318,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:28',NULL,NULL),(18125,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:37',NULL,NULL),(18123,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:36',NULL,NULL),(6359,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:19',NULL,NULL),(17289,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:09',NULL,NULL),(9998,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:39:50',NULL,NULL),(14578,1821,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:49',NULL,NULL),(13877,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:16',NULL,NULL),(10397,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:40',NULL,NULL),(18512,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:18',NULL,NULL),(18629,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:49',NULL,NULL),(21675,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:12',NULL,NULL),(22869,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:42',NULL,NULL),(740,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:06',NULL,NULL),(5876,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:40',NULL,NULL),(9357,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:38',NULL,NULL),(16693,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:23',NULL,NULL),(13232,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:42',NULL,NULL),(10002,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:51',NULL,NULL),(10163,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:35',NULL,NULL),(10862,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:00',NULL,NULL),(18815,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:16',NULL,NULL),(21305,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:31',NULL,NULL),(21820,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:01:04',NULL,NULL),(443,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:11',NULL,NULL),(5480,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:47',NULL,NULL),(17399,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:46',NULL,NULL),(13013,1722,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:44',NULL,NULL),(12583,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:42',NULL,NULL),(12291,1661,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:23',NULL,NULL),(3311,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:45',NULL,NULL),(5287,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:54',NULL,NULL),(10659,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:09',NULL,NULL),(4810,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:55',NULL,NULL),(4315,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:30:48',NULL,NULL),(7572,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:11',NULL,NULL),(8893,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:44',NULL,NULL),(20840,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:50',NULL,NULL),(20993,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:33',NULL,NULL),(6469,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:49',NULL,NULL),(18400,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:46',NULL,NULL),(18140,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:42',NULL,NULL),(4043,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:44',NULL,NULL),(5235,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:30:39',NULL,NULL),(8928,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:53',NULL,NULL),(14075,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:46',NULL,NULL),(9062,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:19',NULL,NULL),(18642,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:53',NULL,NULL),(22004,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:08',NULL,NULL),(6902,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:31',NULL,NULL),(6621,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:15',NULL,NULL),(17576,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:45',NULL,NULL),(16604,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:47',NULL,NULL),(6271,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:55',NULL,NULL),(15913,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:53',NULL,NULL),(14451,1698,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:15',NULL,NULL),(4664,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:14',NULL,NULL),(4420,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:17',NULL,NULL),(11972,1779,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:55',NULL,NULL),(11454,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:14:26',NULL,NULL),(11210,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:20',NULL,NULL),(3254,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:29',NULL,NULL),(10700,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:20',NULL,NULL),(7526,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:16',NULL,NULL),(7906,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:01:41',NULL,NULL),(20379,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:12',NULL,NULL),(22490,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:46',NULL,NULL),(5939,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:01',NULL,NULL),(3952,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:20',NULL,NULL),(17428,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:55',NULL,NULL),(16231,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:47',NULL,NULL),(3925,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:14',NULL,NULL),(14952,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:32',NULL,NULL),(10333,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:22',NULL,NULL),(13567,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:32',NULL,NULL),(11996,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:03',NULL,NULL),(22486,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:45',NULL,NULL),(22598,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:22',NULL,NULL),(23175,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(7305,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:15',NULL,NULL),(17545,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:33',NULL,NULL),(16629,1798,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:58',NULL,NULL),(16178,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:16:29',NULL,NULL),(5271,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:30:49',NULL,NULL),(15625,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:39',NULL,NULL),(14170,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:00',NULL,NULL),(19003,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:10',NULL,NULL),(21253,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:41:13',NULL,NULL),(22595,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:21',NULL,NULL),(449,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:13',NULL,NULL),(7349,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:28',NULL,NULL),(3298,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:41',NULL,NULL),(15959,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:09',NULL,NULL),(13630,1776,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:41',NULL,NULL),(991,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:15',NULL,NULL),(18196,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:15:01',NULL,NULL),(6050,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:41',NULL,NULL),(4829,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:00',NULL,NULL),(19615,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:53',NULL,NULL),(20437,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:01:34',NULL,NULL),(20513,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:00',NULL,NULL),(687,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:32',NULL,NULL),(2602,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:56',NULL,NULL),(6579,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:05',NULL,NULL),(17468,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:08',NULL,NULL),(5979,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:16',NULL,NULL),(16230,1747,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:47',NULL,NULL),(13871,1729,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:16',NULL,NULL),(13611,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:38',NULL,NULL),(11712,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:32',NULL,NULL),(3679,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:11',NULL,NULL),(9945,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:52',NULL,NULL),(3714,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:19',NULL,NULL),(4722,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:31',NULL,NULL),(4739,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:36',NULL,NULL),(18962,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:59',NULL,NULL),(3739,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:26',NULL,NULL),(8183,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:44',NULL,NULL),(9841,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:25',NULL,NULL),(16967,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:48',NULL,NULL),(16586,1807,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:19:40',NULL,NULL),(16425,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:41',NULL,NULL),(11581,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:58',NULL,NULL),(13092,1806,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:27:04',NULL,NULL),(14255,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:13',NULL,NULL),(19131,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:45',NULL,NULL),(21083,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-24 09:31:57',NULL,NULL),(21523,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:52',NULL,NULL),(890,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:48',NULL,NULL),(10914,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:46:14',NULL,NULL),(12516,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:24',NULL,NULL),(18149,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:45',NULL,NULL),(17985,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:48',NULL,NULL),(12817,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:49',NULL,NULL),(16404,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:33',NULL,NULL),(19267,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:16',NULL,NULL),(19366,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:44',NULL,NULL),(22379,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:09',NULL,NULL),(1362,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:00',NULL,NULL),(18554,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:29',NULL,NULL),(15813,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:17',NULL,NULL),(14968,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:37',NULL,NULL),(13736,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:56',NULL,NULL),(7654,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:00:33',NULL,NULL),(12630,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:56',NULL,NULL),(11480,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:33',NULL,NULL),(1637,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:37',NULL,NULL),(9836,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:24',NULL,NULL),(2182,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:26',NULL,NULL),(6135,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:19',NULL,NULL),(4278,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:39',NULL,NULL),(21080,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:56',NULL,NULL),(22662,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:28',NULL,NULL),(4802,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:00:53',NULL,NULL),(18273,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:10',NULL,NULL),(18129,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:14:38',NULL,NULL),(4988,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:46',NULL,NULL),(8762,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:09',NULL,NULL),(17246,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:20',NULL,NULL),(9047,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:15',NULL,NULL),(9862,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:31',NULL,NULL),(11276,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:38',NULL,NULL),(2853,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:06',NULL,NULL),(19141,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:49',NULL,NULL),(18299,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:30:18',NULL,NULL),(7425,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:48',NULL,NULL),(6065,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:46',NULL,NULL),(17228,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:14',NULL,NULL),(16316,1580,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:00',NULL,NULL),(6037,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:36',NULL,NULL),(16097,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:00',NULL,NULL),(15311,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:14',NULL,NULL),(15057,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:07',NULL,NULL),(5088,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:02:14',NULL,NULL),(12937,1650,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:24',NULL,NULL),(12771,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:36',NULL,NULL),(4709,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:28',NULL,NULL),(12628,1791,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:55',NULL,NULL),(3752,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:29',NULL,NULL),(8621,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:31',NULL,NULL),(19657,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:02:06',NULL,NULL),(2133,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:32:13',NULL,NULL),(19262,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:14',NULL,NULL),(7786,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:07',NULL,NULL),(2243,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:24',NULL,NULL),(17519,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:25',NULL,NULL),(17030,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:08',NULL,NULL),(14372,1653,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:49:51',NULL,NULL),(14293,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:19',NULL,NULL),(11941,1804,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:46',NULL,NULL),(12437,1626,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:02',NULL,NULL),(19407,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:56',NULL,NULL),(19725,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:09',NULL,NULL),(22421,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:22',NULL,NULL),(885,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:46',NULL,NULL),(19211,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:38:09',NULL,NULL),(18265,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:08',NULL,NULL),(7456,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:57',NULL,NULL),(4379,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:06',NULL,NULL),(15321,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:16',NULL,NULL),(10621,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:58',NULL,NULL),(22341,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:56',NULL,NULL),(22648,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:58:23',NULL,NULL),(1811,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:30',NULL,NULL),(19315,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:30',NULL,NULL),(2137,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:14',NULL,NULL),(18563,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:32',NULL,NULL),(16096,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:59',NULL,NULL),(15140,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:34',NULL,NULL),(6152,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:24',NULL,NULL),(10139,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:40:28',NULL,NULL),(11779,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:49',NULL,NULL),(19726,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:09',NULL,NULL),(22771,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:07',NULL,NULL),(23001,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:00:16',NULL,NULL),(5798,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:13',NULL,NULL),(4608,1831,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:32:04',NULL,NULL),(2525,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:31:36',NULL,NULL),(18144,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:43',NULL,NULL),(3547,1830,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:49',NULL,NULL),(9420,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:55',NULL,NULL),(20290,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:40',NULL,NULL),(23113,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:37',NULL,NULL),(23692,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-06 01:30:02',NULL,NULL),(1336,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:48',NULL,NULL),(19310,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:28',NULL,NULL),(18461,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:31:03',NULL,NULL),(16945,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:43',NULL,NULL),(1455,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:34',NULL,NULL),(15534,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:08',NULL,NULL),(5335,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:08',NULL,NULL),(4915,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:24',NULL,NULL),(14102,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:49',NULL,NULL),(3171,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:05',NULL,NULL),(7892,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:38',NULL,NULL),(6437,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:40',NULL,NULL),(18731,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:35:53',NULL,NULL),(11017,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:21',NULL,NULL),(11400,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:13',NULL,NULL),(11804,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:55',NULL,NULL),(14166,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:59',NULL,NULL),(16027,1772,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:33',NULL,NULL),(16729,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:36',NULL,NULL),(8722,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:00:58',NULL,NULL),(19299,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:25',NULL,NULL),(2031,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:49',NULL,NULL),(6816,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:07',NULL,NULL),(4676,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:18',NULL,NULL),(5295,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:30:57',NULL,NULL),(4754,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:40',NULL,NULL),(10295,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:11',NULL,NULL),(10924,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:17',NULL,NULL),(11600,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:03',NULL,NULL),(13721,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:30:54',NULL,NULL),(23369,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:40',NULL,NULL),(8883,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:41',NULL,NULL),(19154,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:53',NULL,NULL),(15141,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:35',NULL,NULL),(14957,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:33',NULL,NULL),(2724,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:21',NULL,NULL),(3190,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:11',NULL,NULL),(13832,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:10',NULL,NULL),(7784,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:07',NULL,NULL),(7644,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:30',NULL,NULL),(4964,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:39',NULL,NULL),(10257,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:01',NULL,NULL),(9792,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:12',NULL,NULL),(5186,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:25',NULL,NULL),(9083,1836,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:30:25',NULL,NULL),(6223,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:43',NULL,NULL),(20805,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:41',NULL,NULL),(21239,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:08',NULL,NULL),(21607,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:23',NULL,NULL),(22095,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:41',NULL,NULL),(22950,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:07',NULL,NULL),(864,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:30:41',NULL,NULL),(3789,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:39',NULL,NULL),(4653,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:11',NULL,NULL),(18070,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:18',NULL,NULL),(16728,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:36',NULL,NULL),(8856,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:33',NULL,NULL),(7754,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:58',NULL,NULL),(21106,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:03',NULL,NULL),(23300,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:14',NULL,NULL),(384,1815,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:00:50',NULL,NULL),(19250,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:11',NULL,NULL),(17975,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:45',NULL,NULL),(4757,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:41',NULL,NULL),(9262,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:31:14',NULL,NULL),(15276,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:07',NULL,NULL),(20417,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:26',NULL,NULL),(11748,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:41',NULL,NULL),(12082,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:26',NULL,NULL),(23133,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:41',NULL,NULL),(23564,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-03 19:30:02',NULL,NULL),(7684,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:00:41',NULL,NULL),(2095,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:04',NULL,NULL),(19057,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:25',NULL,NULL),(18072,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:19',NULL,NULL),(6748,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:48',NULL,NULL),(13093,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:27:04',NULL,NULL),(12497,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:19',NULL,NULL),(10854,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:58',NULL,NULL),(4930,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:29',NULL,NULL),(3352,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:56',NULL,NULL),(2715,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:17',NULL,NULL),(8605,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:27',NULL,NULL),(5337,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:08',NULL,NULL),(20731,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:20',NULL,NULL),(20617,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:38',NULL,NULL),(20465,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:43',NULL,NULL),(20336,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:56',NULL,NULL),(4416,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:16',NULL,NULL),(18358,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:34',NULL,NULL),(4238,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:29',NULL,NULL),(16146,1715,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:18',NULL,NULL),(2908,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:25',NULL,NULL),(9755,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:02',NULL,NULL),(14541,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:50:39',NULL,NULL),(13641,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:42',NULL,NULL),(9850,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:37:28',NULL,NULL),(22986,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:14',NULL,NULL),(9120,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:35',NULL,NULL),(19092,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:34',NULL,NULL),(17875,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:13:11',NULL,NULL),(2887,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:01:18',NULL,NULL),(3010,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:02',NULL,NULL),(3955,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:21',NULL,NULL),(11399,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:12',NULL,NULL),(12327,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:35',NULL,NULL),(21789,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:52',NULL,NULL),(8900,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:45',NULL,NULL),(20126,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:58',NULL,NULL),(2670,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:32:14',NULL,NULL),(5655,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:24',NULL,NULL),(8424,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:50',NULL,NULL),(10324,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:19',NULL,NULL),(12314,1718,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:31',NULL,NULL),(17548,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:34',NULL,NULL),(17374,1841,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:37',NULL,NULL),(17110,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:34',NULL,NULL),(12998,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:40',NULL,NULL),(13109,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:27:09',NULL,NULL),(13316,1732,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:28:04',NULL,NULL),(21542,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:59',NULL,NULL),(23239,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:01',NULL,NULL),(408,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:00',NULL,NULL),(1122,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:50',NULL,NULL),(2008,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:42',NULL,NULL),(6408,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:33',NULL,NULL),(18020,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:01',NULL,NULL),(12977,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:26:35',NULL,NULL),(15250,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:02',NULL,NULL),(14912,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:22',NULL,NULL),(14720,1686,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:30',NULL,NULL),(21631,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:32',NULL,NULL),(22193,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:17',NULL,NULL),(416,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:01:02',NULL,NULL),(9272,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:16',NULL,NULL),(19836,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:38',NULL,NULL),(17930,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:30',NULL,NULL),(16474,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:59',NULL,NULL),(14803,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:53',NULL,NULL),(13318,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:05',NULL,NULL),(9022,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:08',NULL,NULL),(12758,1716,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:32',NULL,NULL),(4191,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:17',NULL,NULL),(10829,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:52',NULL,NULL),(11050,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:31',NULL,NULL),(8173,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:41',NULL,NULL),(20690,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:08',NULL,NULL),(19378,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:47',NULL,NULL),(17728,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:02:40',NULL,NULL),(6134,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:30:18',NULL,NULL),(11614,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:06',NULL,NULL),(13417,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:10',NULL,NULL),(11934,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:44',NULL,NULL),(2244,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:24',NULL,NULL),(20932,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:16',NULL,NULL),(19254,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:12',NULL,NULL),(16625,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:19:56',NULL,NULL),(8930,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:53',NULL,NULL),(8775,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:12',NULL,NULL),(13527,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:27',NULL,NULL),(4998,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:49',NULL,NULL),(9987,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:47',NULL,NULL),(6600,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:10',NULL,NULL),(6145,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:22',NULL,NULL),(21728,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:31',NULL,NULL),(313,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:26',NULL,NULL),(606,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:04',NULL,NULL),(1231,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:09',NULL,NULL),(19590,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:46',NULL,NULL),(2696,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:00:10',NULL,NULL),(21420,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:14',NULL,NULL),(18925,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:47',NULL,NULL),(3409,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:12',NULL,NULL),(17385,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:41',NULL,NULL),(16510,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:13',NULL,NULL),(11932,1812,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:18:44',NULL,NULL),(3438,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:31:19',NULL,NULL),(22773,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:08',NULL,NULL),(23718,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-09 13:29:59',NULL,NULL),(3078,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:02:28',NULL,NULL),(19797,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:28',NULL,NULL),(17707,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:33',NULL,NULL),(16842,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:17',NULL,NULL),(10060,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:06',NULL,NULL),(16061,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:46',NULL,NULL),(12139,1808,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:19:41',NULL,NULL),(15935,1624,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:01',NULL,NULL),(22013,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:11',NULL,NULL),(22961,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:09',NULL,NULL),(23715,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 23:29:59',NULL,NULL),(9324,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:30',NULL,NULL),(21450,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:24',NULL,NULL),(20549,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:14',NULL,NULL),(4423,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:18',NULL,NULL),(19322,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:31',NULL,NULL),(1807,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:29',NULL,NULL),(14430,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:09',NULL,NULL),(16413,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:37',NULL,NULL),(16258,1623,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:58',NULL,NULL),(23173,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(5940,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:01',NULL,NULL),(5993,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:20',NULL,NULL),(19979,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:17',NULL,NULL),(14718,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:29',NULL,NULL),(20627,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:02:42',NULL,NULL),(22742,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:58:55',NULL,NULL),(1032,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:26',NULL,NULL),(5085,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:13',NULL,NULL),(6863,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:20',NULL,NULL),(18551,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:29',NULL,NULL),(18183,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:57',NULL,NULL),(12398,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:55',NULL,NULL),(14147,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:57',NULL,NULL),(1085,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:40',NULL,NULL),(21733,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:33',NULL,NULL),(9049,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:16',NULL,NULL),(18787,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:09',NULL,NULL),(18187,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:58',NULL,NULL),(3775,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:35',NULL,NULL),(5602,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:05',NULL,NULL),(11629,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:10',NULL,NULL),(566,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:51',NULL,NULL),(21906,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:01:34',NULL,NULL),(21747,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:38',NULL,NULL),(9132,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:39',NULL,NULL),(8938,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:56',NULL,NULL),(8295,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:15',NULL,NULL),(18333,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:28',NULL,NULL),(18185,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:57',NULL,NULL),(16792,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:05',NULL,NULL),(15746,1794,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:04:19',NULL,NULL),(2452,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:18',NULL,NULL),(13836,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:10',NULL,NULL),(13813,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:07',NULL,NULL),(13710,1599,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:53',NULL,NULL),(12092,1609,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:29',NULL,NULL),(10583,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:49',NULL,NULL),(23326,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:25',NULL,NULL),(23343,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:31',NULL,NULL),(2033,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:49',NULL,NULL),(21660,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:06',NULL,NULL),(3753,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:30',NULL,NULL),(15388,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:28',NULL,NULL),(17421,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:53',NULL,NULL),(16060,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:45',NULL,NULL),(60,205,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:56',NULL,NULL),(10216,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:40:49',NULL,NULL),(20539,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:10',NULL,NULL),(19881,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:49',NULL,NULL),(19783,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:24',NULL,NULL),(251,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:06',NULL,NULL),(19248,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:10',NULL,NULL),(18180,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:56',NULL,NULL),(17256,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:32:24',NULL,NULL),(1306,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:00:37',NULL,NULL),(6470,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:49',NULL,NULL),(5624,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:00:12',NULL,NULL),(15269,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:06',NULL,NULL),(2600,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:55',NULL,NULL),(22314,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:47',NULL,NULL),(944,1651,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:02',NULL,NULL),(10211,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:48',NULL,NULL),(15974,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:15',NULL,NULL),(13808,1620,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:07',NULL,NULL),(1620,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:31',NULL,NULL),(21911,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:36',NULL,NULL),(16885,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:29',NULL,NULL),(16472,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:59',NULL,NULL),(2087,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:02',NULL,NULL),(15952,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:07',NULL,NULL),(11858,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:16:09',NULL,NULL),(14900,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:19',NULL,NULL),(14527,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:50:36',NULL,NULL),(12181,1625,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:52',NULL,NULL),(18842,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:24',NULL,NULL),(20448,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:37',NULL,NULL),(22459,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:36',NULL,NULL),(1428,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:01:23',NULL,NULL),(16448,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:18:50',NULL,NULL),(3982,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:28',NULL,NULL),(5914,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:53',NULL,NULL),(6796,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:01',NULL,NULL),(7618,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:23',NULL,NULL),(17475,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:01:10',NULL,NULL),(20822,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:46',NULL,NULL),(737,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:05',NULL,NULL),(14915,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:23',NULL,NULL),(5974,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:14',NULL,NULL),(3888,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:04',NULL,NULL),(3271,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:34',NULL,NULL),(10345,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:25',NULL,NULL),(2058,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:55',NULL,NULL),(8516,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:03',NULL,NULL),(2994,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:01:56',NULL,NULL),(17491,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:15',NULL,NULL),(22376,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:08',NULL,NULL),(2499,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:30',NULL,NULL),(16282,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:07',NULL,NULL),(3012,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:02',NULL,NULL),(7840,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:22',NULL,NULL),(8067,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:13',NULL,NULL),(21221,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:01',NULL,NULL),(22857,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:59:38',NULL,NULL),(2149,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:17',NULL,NULL),(17056,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:16',NULL,NULL),(7282,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:09',NULL,NULL),(12970,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:33',NULL,NULL),(10728,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:45:27',NULL,NULL),(11097,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:00:48',NULL,NULL),(11337,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:54',NULL,NULL),(17751,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:47',NULL,NULL),(22315,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:48',NULL,NULL),(642,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:16',NULL,NULL),(17308,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:15',NULL,NULL),(17179,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:57',NULL,NULL),(6782,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:00:57',NULL,NULL),(16866,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:24',NULL,NULL),(12339,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:39',NULL,NULL),(10494,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:44:26',NULL,NULL),(10140,1872,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:40:29',NULL,NULL),(9593,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:20',NULL,NULL),(1267,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:23',NULL,NULL),(2851,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:05',NULL,NULL),(1525,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:58',NULL,NULL),(3706,1842,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:00:18',NULL,NULL),(407,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:00',NULL,NULL),(878,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:30:44',NULL,NULL),(3372,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:01',NULL,NULL),(4578,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:57',NULL,NULL),(3725,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:23',NULL,NULL),(14248,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:12',NULL,NULL),(13106,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:08',NULL,NULL),(12621,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:53',NULL,NULL),(11390,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:09',NULL,NULL),(7076,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:10',NULL,NULL),(10465,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:18',NULL,NULL),(5543,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:05',NULL,NULL),(13929,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:24',NULL,NULL),(7698,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:44',NULL,NULL),(8626,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:32',NULL,NULL),(13463,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:17',NULL,NULL),(12868,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:07',NULL,NULL),(10628,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:45:00',NULL,NULL),(22021,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:14',NULL,NULL),(274,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:13',NULL,NULL),(7932,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:48',NULL,NULL),(15958,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:09',NULL,NULL),(18969,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:00',NULL,NULL),(21216,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:59',NULL,NULL),(21853,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:15',NULL,NULL),(23347,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:32',NULL,NULL),(6798,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:02',NULL,NULL),(3596,1865,'2014-01-14','23:10:00','A','000',0,'2014-01-23 22:32:02',NULL,NULL),(16346,1607,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:11',NULL,NULL),(4380,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:06',NULL,NULL),(17579,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:46',NULL,NULL),(7450,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:56',NULL,NULL),(8949,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:58',NULL,NULL),(13398,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:06',NULL,NULL),(12722,1667,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:23',NULL,NULL),(12422,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:21:58',NULL,NULL),(11885,1832,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:16:16',NULL,NULL),(18298,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:18',NULL,NULL),(20301,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:44',NULL,NULL),(23124,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:39',NULL,NULL),(2686,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:07',NULL,NULL),(17697,1894,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:02:29',NULL,NULL),(6214,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:40',NULL,NULL),(3581,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:58',NULL,NULL),(14288,1711,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:32:18',NULL,NULL),(13748,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:30:58',NULL,NULL),(13269,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:51',NULL,NULL),(7412,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:45',NULL,NULL),(9633,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:31',NULL,NULL),(18637,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:52',NULL,NULL),(18816,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:17',NULL,NULL),(20327,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:53',NULL,NULL),(22097,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:42',NULL,NULL),(23302,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:15',NULL,NULL),(137,369,'2013-12-27','16:24:00','A','000',0,'2014-01-13 03:04:47',NULL,NULL),(17445,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:00',NULL,NULL),(7041,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:11',NULL,NULL),(981,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:12',NULL,NULL),(1367,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:02',NULL,NULL),(5089,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:14',NULL,NULL),(7846,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:24',NULL,NULL),(11306,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:46',NULL,NULL),(18841,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:24',NULL,NULL),(20066,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:41',NULL,NULL),(636,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:14',NULL,NULL),(16706,1834,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:20:28',NULL,NULL),(16101,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:01',NULL,NULL),(7358,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:30',NULL,NULL),(6853,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:01:17',NULL,NULL),(1087,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:41',NULL,NULL),(11949,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:48',NULL,NULL),(11735,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:38',NULL,NULL),(3413,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:13',NULL,NULL),(5725,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:48',NULL,NULL),(5357,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:13',NULL,NULL),(5343,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:10',NULL,NULL),(3961,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:23',NULL,NULL),(21263,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:16',NULL,NULL),(21866,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:20',NULL,NULL),(5559,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:10',NULL,NULL),(5365,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:31:16',NULL,NULL),(17921,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:27',NULL,NULL),(17913,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:24',NULL,NULL),(17773,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:34',NULL,NULL),(4131,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:02:06',NULL,NULL),(16217,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:16:42',NULL,NULL),(15960,1597,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:10',NULL,NULL),(7880,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:34',NULL,NULL),(14369,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:49:50',NULL,NULL),(13829,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:10',NULL,NULL),(8790,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:16',NULL,NULL),(11917,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:16:24',NULL,NULL),(19152,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:52',NULL,NULL),(19368,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:44',NULL,NULL),(19784,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:24',NULL,NULL),(21869,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:21',NULL,NULL),(7404,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:42',NULL,NULL),(18198,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:15:02',NULL,NULL),(7368,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:31:33',NULL,NULL),(15024,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:56',NULL,NULL),(6829,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:10',NULL,NULL),(6823,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:09',NULL,NULL),(1718,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:07',NULL,NULL),(5654,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:23',NULL,NULL),(9860,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:30',NULL,NULL),(9672,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:41',NULL,NULL),(9104,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:31',NULL,NULL),(20277,1820,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:00:35',NULL,NULL),(20641,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:47',NULL,NULL),(21518,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:50',NULL,NULL),(22062,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:29',NULL,NULL),(6722,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:41',NULL,NULL),(15981,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:17',NULL,NULL),(6622,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:16',NULL,NULL),(14487,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:25',NULL,NULL),(6588,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:07',NULL,NULL),(5986,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:18',NULL,NULL),(18017,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:00',NULL,NULL),(13505,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:23',NULL,NULL),(3542,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:47',NULL,NULL),(10279,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:07',NULL,NULL),(9846,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:27',NULL,NULL),(4627,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:00:04',NULL,NULL),(8341,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:31:28',NULL,NULL),(8114,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:25',NULL,NULL),(18887,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:36',NULL,NULL),(21045,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:47',NULL,NULL),(22845,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:59:34',NULL,NULL),(23174,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:49',NULL,NULL),(621,1843,'2014-01-14','23:10:00','A','000',0,'2014-01-23 19:02:09',NULL,NULL),(17708,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:33',NULL,NULL),(4700,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:25',NULL,NULL),(8232,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:56',NULL,NULL),(16260,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:59',NULL,NULL),(13506,1784,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:23',NULL,NULL),(11264,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:35',NULL,NULL),(19050,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:23',NULL,NULL),(19342,1781,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:37',NULL,NULL),(20103,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:52',NULL,NULL),(80,252,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:14',NULL,NULL),(6072,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:49',NULL,NULL),(1540,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:03',NULL,NULL),(15783,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:32',NULL,NULL),(15290,1608,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:10',NULL,NULL),(13809,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:31:07',NULL,NULL),(12206,1764,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:00',NULL,NULL),(5715,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:44',NULL,NULL),(9175,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:50',NULL,NULL),(9632,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:30',NULL,NULL),(11155,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:03',NULL,NULL),(10012,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:39:54',NULL,NULL),(18797,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:12',NULL,NULL),(18865,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:30',NULL,NULL),(19794,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:27',NULL,NULL),(22657,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:26',NULL,NULL),(3658,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:00:06',NULL,NULL),(18565,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:32',NULL,NULL),(9197,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:56',NULL,NULL),(11562,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:53',NULL,NULL),(13179,1628,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:28',NULL,NULL),(16552,1585,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:19:28',NULL,NULL),(16247,1642,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:54',NULL,NULL),(19942,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:06',NULL,NULL),(21360,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:51',NULL,NULL),(21559,1796,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:05',NULL,NULL),(1084,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:40',NULL,NULL),(18662,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:58',NULL,NULL),(1496,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:01:48',NULL,NULL),(2509,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:32',NULL,NULL),(7065,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:30:05',NULL,NULL),(16849,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:19',NULL,NULL),(8248,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:01',NULL,NULL),(16580,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:38',NULL,NULL),(9422,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:56',NULL,NULL),(11368,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:02:04',NULL,NULL),(14148,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:57',NULL,NULL),(12709,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:19',NULL,NULL),(19362,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:43',NULL,NULL),(21178,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:45',NULL,NULL),(23242,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(131,230,'2013-12-27','15:13:00','A','000',0,'2014-01-13 03:04:45',NULL,NULL),(16503,1842,'2014-01-14','23:10:00','A','000',1,'2014-01-24 06:19:11',NULL,NULL),(936,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:31:00',NULL,NULL),(6043,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:38',NULL,NULL),(10535,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:36',NULL,NULL),(9727,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:55',NULL,NULL),(8887,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:42',NULL,NULL),(3158,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:55',NULL,NULL),(1765,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:18',NULL,NULL),(6033,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:35',NULL,NULL),(5097,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:16',NULL,NULL),(1599,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:24',NULL,NULL),(18938,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:51',NULL,NULL),(19007,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:11',NULL,NULL),(22114,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:48',NULL,NULL),(22276,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:38',NULL,NULL),(22434,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:27',NULL,NULL),(22444,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:31',NULL,NULL),(9226,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:04',NULL,NULL),(20853,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:54',NULL,NULL),(20655,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:02:52',NULL,NULL),(19786,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:25',NULL,NULL),(3654,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:05',NULL,NULL),(19122,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:42',NULL,NULL),(8641,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:36',NULL,NULL),(17745,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:02:45',NULL,NULL),(16916,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:30:36',NULL,NULL),(4607,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:04',NULL,NULL),(15932,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:00',NULL,NULL),(8213,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:51',NULL,NULL),(15041,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:01:01',NULL,NULL),(14280,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:32:17',NULL,NULL),(7369,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:33',NULL,NULL),(9473,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:10',NULL,NULL),(10146,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:30',NULL,NULL),(21663,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:07',NULL,NULL),(2606,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:57',NULL,NULL),(18799,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:12',NULL,NULL),(18402,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:46',NULL,NULL),(18069,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:18',NULL,NULL),(16639,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:20:03',NULL,NULL),(16605,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:48',NULL,NULL),(15519,1771,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:03',NULL,NULL),(8370,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:36',NULL,NULL),(12697,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:15',NULL,NULL),(13801,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:06',NULL,NULL),(13383,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:30:03',NULL,NULL),(22152,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:06',NULL,NULL),(1067,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:36',NULL,NULL),(21054,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:49',NULL,NULL),(17394,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:44',NULL,NULL),(16883,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:28',NULL,NULL),(14614,1652,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:51:00',NULL,NULL),(7497,1846,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:32:08',NULL,NULL),(12097,1748,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:30',NULL,NULL),(9849,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:27',NULL,NULL),(8149,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:34',NULL,NULL),(2743,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 22:00:27',NULL,NULL),(22311,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:47',NULL,NULL),(543,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:44',NULL,NULL),(8576,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:19',NULL,NULL),(16981,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:52',NULL,NULL),(894,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:30:49',NULL,NULL),(7370,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:33',NULL,NULL),(7182,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:40',NULL,NULL),(6587,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:07',NULL,NULL),(13317,1605,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:04',NULL,NULL),(6005,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:02:25',NULL,NULL),(5904,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:49',NULL,NULL),(10322,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:19',NULL,NULL),(2392,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:31:02',NULL,NULL),(20886,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:31:04',NULL,NULL),(19333,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:00:34',NULL,NULL),(8683,1816,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:47',NULL,NULL),(3282,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:30:37',NULL,NULL),(15577,1583,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:03:23',NULL,NULL),(15392,1845,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:02:29',NULL,NULL),(5947,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:04',NULL,NULL),(10378,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:34',NULL,NULL),(14836,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:52:02',NULL,NULL),(11645,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:15',NULL,NULL),(9102,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:30',NULL,NULL),(20112,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:55',NULL,NULL),(4272,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:38',NULL,NULL),(7864,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:30',NULL,NULL),(11146,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:01',NULL,NULL),(11008,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:19',NULL,NULL),(4786,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:48',NULL,NULL),(5137,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:12',NULL,NULL),(7658,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:34',NULL,NULL),(21643,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:43:37',NULL,NULL),(23592,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-07 11:30:02',NULL,NULL),(731,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:30:04',NULL,NULL),(21475,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:33',NULL,NULL),(21414,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:11',NULL,NULL),(2450,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:17',NULL,NULL),(20107,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:53',NULL,NULL),(16591,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:42',NULL,NULL),(14140,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:56',NULL,NULL),(13822,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:09',NULL,NULL),(4212,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:22',NULL,NULL),(7847,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:01:24',NULL,NULL),(4867,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:11',NULL,NULL),(6216,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:41',NULL,NULL),(5086,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:13',NULL,NULL),(971,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:31:09',NULL,NULL),(4172,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:12',NULL,NULL),(19251,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:11',NULL,NULL),(18355,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:34',NULL,NULL),(17220,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:32:11',NULL,NULL),(17011,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:01',NULL,NULL),(12756,1662,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:32',NULL,NULL),(4353,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:00',NULL,NULL),(10947,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:02',NULL,NULL),(10126,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:25',NULL,NULL),(4274,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:38',NULL,NULL),(20694,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:09',NULL,NULL),(19913,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:30:58',NULL,NULL),(19821,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:34',NULL,NULL),(17453,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:03',NULL,NULL),(7487,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:32:06',NULL,NULL),(16062,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:46',NULL,NULL),(5883,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:42',NULL,NULL),(15313,1648,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:14',NULL,NULL),(6634,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:19',NULL,NULL),(14603,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:56',NULL,NULL),(14301,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:20',NULL,NULL),(13767,1838,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:31:01',NULL,NULL),(19317,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:30',NULL,NULL),(10983,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:12',NULL,NULL),(11638,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:15:13',NULL,NULL),(11966,1693,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:18:53',NULL,NULL),(11672,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:22',NULL,NULL),(7580,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:13',NULL,NULL),(4806,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:54',NULL,NULL),(6887,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:27',NULL,NULL),(6530,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:32:05',NULL,NULL),(12303,1733,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:27',NULL,NULL),(16774,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:52',NULL,NULL),(22180,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:13',NULL,NULL),(22270,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:37',NULL,NULL),(23014,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:00:19',NULL,NULL),(3019,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:05',NULL,NULL),(3350,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:30:55',NULL,NULL),(20146,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:04',NULL,NULL),(19798,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:28',NULL,NULL),(3446,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:21',NULL,NULL),(5870,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:38',NULL,NULL),(10234,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:54',NULL,NULL),(21832,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:08',NULL,NULL),(9627,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:29',NULL,NULL),(886,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:46',NULL,NULL),(1198,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:32:12',NULL,NULL),(6636,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:19',NULL,NULL),(6495,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:56',NULL,NULL),(19449,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:07',NULL,NULL),(5508,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:55',NULL,NULL),(13246,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:46',NULL,NULL),(2044,1782,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:52',NULL,NULL),(21889,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:28',NULL,NULL),(20296,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:00:42',NULL,NULL),(20285,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:38',NULL,NULL),(19298,1853,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:25',NULL,NULL),(17122,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:31:38',NULL,NULL),(16339,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:08',NULL,NULL),(15953,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:07',NULL,NULL),(3132,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:46',NULL,NULL),(9595,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:21',NULL,NULL),(13121,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:13',NULL,NULL),(13094,1594,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:27:05',NULL,NULL),(6718,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:40',NULL,NULL),(6753,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:49',NULL,NULL),(2725,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:21',NULL,NULL),(8753,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:06',NULL,NULL),(20620,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:39',NULL,NULL),(6567,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:02',NULL,NULL),(5881,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:41',NULL,NULL),(12501,1646,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:22:20',NULL,NULL),(13706,1591,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:52',NULL,NULL),(15816,1818,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:14:18',NULL,NULL),(405,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:00:59',NULL,NULL),(1534,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:01',NULL,NULL),(3302,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:42',NULL,NULL),(11513,1653,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:41',NULL,NULL),(16681,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:19',NULL,NULL),(15805,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:40',NULL,NULL),(23526,2770,'2014-01-29','13:47:00','A','000',0,'2014-01-29 23:30:02',NULL,NULL),(248,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:05',NULL,NULL),(10264,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:03',NULL,NULL),(20776,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:30:33',NULL,NULL),(2255,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:30:27',NULL,NULL),(17862,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:06',NULL,NULL),(16415,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:18:37',NULL,NULL),(3181,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:08',NULL,NULL),(7977,1737,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:59',NULL,NULL),(13785,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:04',NULL,NULL),(6076,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:50',NULL,NULL),(5405,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:26',NULL,NULL),(9570,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:36:14',NULL,NULL),(5432,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:34',NULL,NULL),(19263,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:00:15',NULL,NULL),(6593,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:00:08',NULL,NULL),(17856,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:04',NULL,NULL),(11648,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:15',NULL,NULL),(15170,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:45',NULL,NULL),(15116,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:26',NULL,NULL),(488,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:26',NULL,NULL),(21234,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:06',NULL,NULL),(9578,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:16',NULL,NULL),(20538,1715,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:10',NULL,NULL),(9239,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:31:08',NULL,NULL),(18317,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:24',NULL,NULL),(8460,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:32:00',NULL,NULL),(15630,1658,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:40',NULL,NULL),(4445,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:24',NULL,NULL),(10523,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:33',NULL,NULL),(9963,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:56',NULL,NULL),(20453,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:39',NULL,NULL),(19948,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:07',NULL,NULL),(19800,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:28',NULL,NULL),(18648,1871,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:31:54',NULL,NULL),(16701,1799,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:20:26',NULL,NULL),(9123,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:36',NULL,NULL),(13928,1611,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:24',NULL,NULL),(7073,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:09',NULL,NULL),(6009,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:26',NULL,NULL),(6901,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:31',NULL,NULL),(23580,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 19:30:02',NULL,NULL),(9242,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:09',NULL,NULL),(506,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:32',NULL,NULL),(19431,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:03',NULL,NULL),(18606,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:43',NULL,NULL),(697,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:02:35',NULL,NULL),(16148,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:18',NULL,NULL),(6256,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:51',NULL,NULL),(2873,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:13',NULL,NULL),(3473,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:28',NULL,NULL),(3510,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:39',NULL,NULL),(23121,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:00:39',NULL,NULL),(23622,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-11 02:00:03',NULL,NULL),(53,371,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:50',NULL,NULL),(9472,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:10',NULL,NULL),(17135,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:42',NULL,NULL),(16511,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:19:13',NULL,NULL),(15744,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:18',NULL,NULL),(8584,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:21',NULL,NULL),(20134,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:32:00',NULL,NULL),(8392,1849,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:31:42',NULL,NULL),(19423,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:01',NULL,NULL),(19232,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:00:06',NULL,NULL),(7142,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:29',NULL,NULL),(15304,1700,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:12',NULL,NULL),(4814,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:56',NULL,NULL),(5994,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:02:21',NULL,NULL),(11490,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:14:35',NULL,NULL),(13410,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:09',NULL,NULL),(13050,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:26:53',NULL,NULL),(12457,1860,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:22:08',NULL,NULL),(172,335,'2013-12-27','15:49:00','A','000',0,'2014-01-13 03:04:58',NULL,NULL),(2991,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:01:55',NULL,NULL),(19552,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:36',NULL,NULL),(19240,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:00:08',NULL,NULL),(18195,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:15:01',NULL,NULL),(3207,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:30:16',NULL,NULL),(17479,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:01:11',NULL,NULL),(15379,1654,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:27',NULL,NULL),(14478,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:22',NULL,NULL),(8830,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:26',NULL,NULL),(7025,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:02:07',NULL,NULL),(11970,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:18:54',NULL,NULL),(23688,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 17:30:02',NULL,NULL),(4270,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:37',NULL,NULL),(17460,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:05',NULL,NULL),(16947,1848,'2014-01-14','23:10:00','A','000',0,'2014-01-24 06:30:44',NULL,NULL),(22007,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:02:09',NULL,NULL),(11411,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:02:16',NULL,NULL),(6334,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:12',NULL,NULL),(11677,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:23',NULL,NULL),(22819,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:25',NULL,NULL),(1214,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:00:02',NULL,NULL),(8387,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:41',NULL,NULL),(1758,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:17',NULL,NULL),(7234,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:56',NULL,NULL),(16261,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:16:59',NULL,NULL),(2281,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 21:30:34',NULL,NULL),(22732,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:52',NULL,NULL),(6230,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:44',NULL,NULL),(15149,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:37',NULL,NULL),(5264,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:47',NULL,NULL),(11962,1684,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:52',NULL,NULL),(22592,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:32:20',NULL,NULL),(11987,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:01',NULL,NULL),(19939,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:05',NULL,NULL),(23422,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:57',NULL,NULL),(588,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:01:58',NULL,NULL),(975,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:11',NULL,NULL),(17338,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:25',NULL,NULL),(16723,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:20:34',NULL,NULL),(5479,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:47',NULL,NULL),(16167,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:25',NULL,NULL),(15578,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:03:23',NULL,NULL),(12062,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:21',NULL,NULL),(9148,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:43',NULL,NULL),(11578,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:57',NULL,NULL),(7688,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:41',NULL,NULL),(9717,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:52',NULL,NULL),(6129,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:30:16',NULL,NULL),(503,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:31',NULL,NULL),(6693,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:34',NULL,NULL),(14609,1675,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:58',NULL,NULL),(3877,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:02',NULL,NULL),(4632,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:05',NULL,NULL),(12187,1721,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:54',NULL,NULL),(23600,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 11:30:03',NULL,NULL),(134,168,'2013-12-27','14:39:00','A','000',0,'2014-01-13 03:04:46',NULL,NULL),(7712,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:47',NULL,NULL),(21204,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:54',NULL,NULL),(19812,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:31',NULL,NULL),(7017,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 02:02:05',NULL,NULL),(14628,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:51:04',NULL,NULL),(6647,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:22',NULL,NULL),(12044,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:16',NULL,NULL),(11853,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:08',NULL,NULL),(22352,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:00',NULL,NULL),(3393,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:07',NULL,NULL),(6780,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:57',NULL,NULL),(19600,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:49',NULL,NULL),(14035,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:31:40',NULL,NULL),(11749,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:41',NULL,NULL),(8982,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:02:08',NULL,NULL),(743,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:07',NULL,NULL),(2146,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:16',NULL,NULL),(20319,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:50',NULL,NULL),(20170,1819,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:32:10',NULL,NULL),(19261,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:14',NULL,NULL),(18650,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:55',NULL,NULL),(10600,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:44:53',NULL,NULL),(1385,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:08',NULL,NULL),(1438,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:27',NULL,NULL),(8163,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:38',NULL,NULL),(5017,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:54',NULL,NULL),(7101,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:18',NULL,NULL),(6280,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:58',NULL,NULL),(1689,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:02:57',NULL,NULL),(10550,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:40',NULL,NULL),(10399,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:40',NULL,NULL),(6931,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:43',NULL,NULL),(6585,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:00:06',NULL,NULL),(4359,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:01',NULL,NULL),(4402,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:12',NULL,NULL),(12842,1821,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:23:58',NULL,NULL),(1672,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:51',NULL,NULL),(4389,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:09',NULL,NULL),(5485,1769,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:31:49',NULL,NULL),(11431,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:02:22',NULL,NULL),(7701,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:45',NULL,NULL),(19558,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:38',NULL,NULL),(2123,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:32:11',NULL,NULL),(21872,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:22',NULL,NULL),(9288,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:20',NULL,NULL),(10872,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:03',NULL,NULL),(12423,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:21:58',NULL,NULL),(17899,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:19',NULL,NULL),(16537,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:23',NULL,NULL),(16064,1622,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:47',NULL,NULL),(14737,1836,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:34',NULL,NULL),(15248,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:02',NULL,NULL),(9807,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:16',NULL,NULL),(20638,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:02:46',NULL,NULL),(8727,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:59',NULL,NULL),(18660,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:58',NULL,NULL),(14888,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:16',NULL,NULL),(14277,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:16',NULL,NULL),(5537,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:32:04',NULL,NULL),(12906,1810,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:26:15',NULL,NULL),(6179,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:30:31',NULL,NULL),(10643,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:45:04',NULL,NULL),(22435,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:31:27',NULL,NULL),(2527,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-23 21:31:37',NULL,NULL),(15341,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:02:20',NULL,NULL),(5661,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:00:26',NULL,NULL),(13476,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:19',NULL,NULL),(6410,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:31:33',NULL,NULL),(19605,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:50',NULL,NULL),(1210,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:32:15',NULL,NULL),(22423,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:23',NULL,NULL),(10440,1642,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:52',NULL,NULL),(19005,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:11',NULL,NULL),(18726,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:16',NULL,NULL),(17599,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:53',NULL,NULL),(15939,1682,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:02',NULL,NULL),(7667,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:36',NULL,NULL),(4006,1696,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:33',NULL,NULL),(21315,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:41:35',NULL,NULL),(5348,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:11',NULL,NULL),(1802,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:28',NULL,NULL),(7402,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:31:42',NULL,NULL),(17051,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:14',NULL,NULL),(16289,1595,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:17:10',NULL,NULL),(3201,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:14',NULL,NULL),(22244,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:31',NULL,NULL),(21782,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:50',NULL,NULL),(10117,1750,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:22',NULL,NULL),(3966,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:24',NULL,NULL),(4884,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:01:15',NULL,NULL),(20893,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:06',NULL,NULL),(3497,1725,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:35',NULL,NULL),(9215,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:31:01',NULL,NULL),(3918,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:12',NULL,NULL),(93,253,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:26',NULL,NULL),(538,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:42',NULL,NULL),(21334,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:42',NULL,NULL),(6023,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:31',NULL,NULL),(595,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:01',NULL,NULL),(19610,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:51',NULL,NULL),(19467,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:12',NULL,NULL),(10392,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:41:38',NULL,NULL),(8508,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:32:13',NULL,NULL),(5888,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:44',NULL,NULL),(8636,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:35',NULL,NULL),(3718,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:21',NULL,NULL),(13081,1589,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:01',NULL,NULL),(5794,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:11',NULL,NULL),(14071,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:45',NULL,NULL),(7230,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:55',NULL,NULL),(7032,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:09',NULL,NULL),(11923,1740,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:18:41',NULL,NULL),(12372,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:48',NULL,NULL),(2399,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:04',NULL,NULL),(16014,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:15:29',NULL,NULL),(22454,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:31:34',NULL,NULL),(16833,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:30:15',NULL,NULL),(7770,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:03',NULL,NULL),(15454,1793,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:02:41',NULL,NULL),(8870,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:01:37',NULL,NULL),(9225,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:04',NULL,NULL),(15221,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:56',NULL,NULL),(19068,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:27',NULL,NULL),(8228,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:55',NULL,NULL),(23087,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:33',NULL,NULL),(22738,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:54',NULL,NULL),(19123,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:43',NULL,NULL),(17624,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:02:03',NULL,NULL),(13673,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:30:47',NULL,NULL),(8405,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:31:45',NULL,NULL),(13575,1734,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:30:33',NULL,NULL),(12473,1815,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:12',NULL,NULL),(23480,1765,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:02:19',NULL,NULL),(1800,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:27',NULL,NULL),(4801,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:00:52',NULL,NULL),(13074,1731,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:59',NULL,NULL),(20434,1743,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:32',NULL,NULL),(17429,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:55',NULL,NULL),(13746,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:58',NULL,NULL),(732,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:04',NULL,NULL),(5962,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:09',NULL,NULL),(22613,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:32:27',NULL,NULL),(17730,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:40',NULL,NULL),(15329,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:02:17',NULL,NULL),(2653,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:09',NULL,NULL),(5392,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:23',NULL,NULL),(8765,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:09',NULL,NULL),(420,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:04',NULL,NULL),(9162,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:47',NULL,NULL),(20365,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:01:07',NULL,NULL),(18023,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:02',NULL,NULL),(12275,1657,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:19',NULL,NULL),(935,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:00',NULL,NULL),(3894,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:06',NULL,NULL),(18517,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:19',NULL,NULL),(18173,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:53',NULL,NULL),(16307,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:17:56',NULL,NULL),(13043,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:52',NULL,NULL),(2287,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:35',NULL,NULL),(15674,1744,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:55',NULL,NULL),(15061,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:08',NULL,NULL),(11541,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:48',NULL,NULL),(13839,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:31:11',NULL,NULL),(14263,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:32:14',NULL,NULL),(19048,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:22',NULL,NULL),(20807,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:41',NULL,NULL),(23700,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 01:30:01',NULL,NULL),(23728,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-10 17:29:57',NULL,NULL),(2492,1669,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:28',NULL,NULL),(11557,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:14:52',NULL,NULL),(14639,1851,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:51:08',NULL,NULL),(11649,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:16',NULL,NULL),(21029,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:42',NULL,NULL),(23508,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:28',NULL,NULL),(23517,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:31',NULL,NULL),(1633,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:02:36',NULL,NULL),(18244,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:30:02',NULL,NULL),(17314,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:00:17',NULL,NULL),(17224,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:32:13',NULL,NULL),(13475,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:19',NULL,NULL),(13422,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:30:10',NULL,NULL),(8972,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:05',NULL,NULL),(9957,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:55',NULL,NULL),(10517,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:31',NULL,NULL),(20289,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:39',NULL,NULL),(21183,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:40:47',NULL,NULL),(22495,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:47',NULL,NULL),(22500,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:31:49',NULL,NULL),(22536,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:32:00',NULL,NULL),(765,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:13',NULL,NULL),(15508,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:59',NULL,NULL),(1914,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:55',NULL,NULL),(15259,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:02:04',NULL,NULL),(14885,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:15',NULL,NULL),(14275,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:32:16',NULL,NULL),(12261,1680,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:15',NULL,NULL),(11909,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:16:22',NULL,NULL),(10693,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:18',NULL,NULL),(21757,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:41',NULL,NULL),(23127,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:40',NULL,NULL),(20,302,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:19',NULL,NULL),(16083,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:54',NULL,NULL),(1270,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:24',NULL,NULL),(8539,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:00:09',NULL,NULL),(13963,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:31:29',NULL,NULL),(7733,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:53',NULL,NULL),(10052,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:04',NULL,NULL),(6831,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:11',NULL,NULL),(6103,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:30:09',NULL,NULL),(6045,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:02:39',NULL,NULL),(19475,1682,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:14',NULL,NULL),(21495,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:42',NULL,NULL),(22264,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:30:35',NULL,NULL),(18,366,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:18',NULL,NULL),(7523,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:15',NULL,NULL),(18331,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:30:27',NULL,NULL),(758,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:11',NULL,NULL),(16272,1797,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:17:03',NULL,NULL),(5911,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:52',NULL,NULL),(5857,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:33',NULL,NULL),(4501,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:37',NULL,NULL),(3747,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:28',NULL,NULL),(3794,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:40',NULL,NULL),(9408,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:31:52',NULL,NULL),(19633,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:58',NULL,NULL),(677,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:29',NULL,NULL),(18375,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:39',NULL,NULL),(9033,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:11',NULL,NULL),(13804,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:31:06',NULL,NULL),(8357,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:33',NULL,NULL),(11373,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:02:05',NULL,NULL),(10079,1647,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:12',NULL,NULL),(9548,1673,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:36:08',NULL,NULL),(3157,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:55',NULL,NULL),(5616,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:00:09',NULL,NULL),(19574,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:42',NULL,NULL),(23260,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:05',NULL,NULL),(1533,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:00',NULL,NULL),(2229,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:13',NULL,NULL),(18829,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:20',NULL,NULL),(17814,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:49',NULL,NULL),(16332,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:18:06',NULL,NULL),(7717,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:00:49',NULL,NULL),(14422,1822,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:50:06',NULL,NULL),(11284,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:01:40',NULL,NULL),(19934,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:03',NULL,NULL),(21715,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:00:26',NULL,NULL),(1468,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:01:38',NULL,NULL),(17163,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:52',NULL,NULL),(5412,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:28',NULL,NULL),(16772,1645,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:52',NULL,NULL),(11624,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:09',NULL,NULL),(14516,1587,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:33',NULL,NULL),(21426,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:42:16',NULL,NULL),(22866,1670,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:41',NULL,NULL),(1556,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:09',NULL,NULL),(19649,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:02:04',NULL,NULL),(19105,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:38',NULL,NULL),(18044,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:10',NULL,NULL),(17119,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:37',NULL,NULL),(15055,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:06',NULL,NULL),(7702,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:45',NULL,NULL),(5754,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:58',NULL,NULL),(11686,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:25',NULL,NULL),(4123,1643,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:02:04',NULL,NULL),(11121,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:54',NULL,NULL),(3073,1776,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:02:26',NULL,NULL),(21066,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:53',NULL,NULL),(21608,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:23',NULL,NULL),(21736,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:00:34',NULL,NULL),(21796,1779,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:00:55',NULL,NULL),(22510,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:52',NULL,NULL),(22826,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:59:28',NULL,NULL),(23082,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:32',NULL,NULL),(236,244,'2013-12-27','15:17:00','A','000',0,'2014-01-13 03:05:19',NULL,NULL),(1355,1794,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:56',NULL,NULL),(18699,1797,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:08',NULL,NULL),(18574,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:35',NULL,NULL),(17960,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:40',NULL,NULL),(2088,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:32:02',NULL,NULL),(16977,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:51',NULL,NULL),(16409,1788,'2014-01-14','23:09:00','A','000',1,'2014-01-24 06:18:35',NULL,NULL),(8147,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:30:34',NULL,NULL),(4328,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:30:52',NULL,NULL),(15227,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:01:57',NULL,NULL),(6984,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:56',NULL,NULL),(6775,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:56',NULL,NULL),(12506,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:22:22',NULL,NULL),(11437,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:14:22',NULL,NULL),(10961,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:06',NULL,NULL),(102,250,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:35',NULL,NULL),(19895,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:53',NULL,NULL),(8600,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:00:25',NULL,NULL),(19768,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:20',NULL,NULL),(8136,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:31',NULL,NULL),(18388,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:43',NULL,NULL),(5882,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:42',NULL,NULL),(3051,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:18',NULL,NULL),(17488,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:15',NULL,NULL),(11851,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:16:07',NULL,NULL),(12117,1762,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:35',NULL,NULL),(23057,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:00:27',NULL,NULL),(147,182,'2013-12-27','14:52:00','A','000',0,'2014-01-13 03:04:50',NULL,NULL),(19986,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:31:19',NULL,NULL),(19606,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:50',NULL,NULL),(19230,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:06',NULL,NULL),(17294,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:11',NULL,NULL),(17026,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:06',NULL,NULL),(15986,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:19',NULL,NULL),(347,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:38',NULL,NULL),(654,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:02:20',NULL,NULL),(14417,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:05',NULL,NULL),(5008,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:52',NULL,NULL),(6594,1784,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:09',NULL,NULL),(21219,1687,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:01',NULL,NULL),(3795,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:00:41',NULL,NULL),(19398,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:00:54',NULL,NULL),(18810,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:15',NULL,NULL),(14870,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:11',NULL,NULL),(11921,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:18:41',NULL,NULL),(5403,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:26',NULL,NULL),(6956,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:49',NULL,NULL),(20935,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:17',NULL,NULL),(21044,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:47',NULL,NULL),(22371,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:31:06',NULL,NULL),(3035,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:02:12',NULL,NULL),(8835,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:28',NULL,NULL),(18156,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:14:47',NULL,NULL),(11085,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:44',NULL,NULL),(12168,1634,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:49',NULL,NULL),(14294,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:19',NULL,NULL),(22061,1874,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:02:29',NULL,NULL),(9782,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:09',NULL,NULL),(9679,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:36:43',NULL,NULL),(15343,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:02:20',NULL,NULL),(14001,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:35',NULL,NULL),(13714,1773,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:30:53',NULL,NULL),(13712,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:30:53',NULL,NULL),(6970,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:52',NULL,NULL),(12572,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:39',NULL,NULL),(19099,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:36',NULL,NULL),(6711,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:38',NULL,NULL),(784,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:19',NULL,NULL),(3217,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:19',NULL,NULL),(1395,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:12',NULL,NULL),(994,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:16',NULL,NULL),(3876,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:01',NULL,NULL),(22652,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:24',NULL,NULL),(23095,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:34',NULL,NULL),(2333,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:47',NULL,NULL),(4098,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:01:58',NULL,NULL),(6422,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:36',NULL,NULL),(15377,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:02:26',NULL,NULL),(17012,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:31:01',NULL,NULL),(15734,1664,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:04:15',NULL,NULL),(21990,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:02:03',NULL,NULL),(22513,1745,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:53',NULL,NULL),(23685,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-05 11:30:02',NULL,NULL),(1492,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:46',NULL,NULL),(7436,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:51',NULL,NULL),(19153,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:52',NULL,NULL),(16807,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:30:08',NULL,NULL),(10434,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:50',NULL,NULL),(10610,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:44:55',NULL,NULL),(12769,1763,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:35',NULL,NULL),(13427,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:11',NULL,NULL),(13772,1681,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:02',NULL,NULL),(14006,1685,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:31:36',NULL,NULL),(1397,1804,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:12',NULL,NULL),(17300,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:13',NULL,NULL),(9842,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:25',NULL,NULL),(15901,1601,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:49',NULL,NULL),(9136,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:40',NULL,NULL),(18171,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:14:53',NULL,NULL),(17957,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:13:39',NULL,NULL),(8160,1870,'2014-01-14','23:10:00','A','000',0,'2014-01-24 03:30:37',NULL,NULL),(8047,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:08',NULL,NULL),(3838,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:52',NULL,NULL),(5765,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:02',NULL,NULL),(22639,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:20',NULL,NULL),(1261,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:21',NULL,NULL),(2166,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:32:22',NULL,NULL),(19096,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:35',NULL,NULL),(19024,1601,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:16',NULL,NULL),(5961,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:02:09',NULL,NULL),(18121,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:14:36',NULL,NULL),(18080,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:14:22',NULL,NULL),(17656,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:15',NULL,NULL),(15506,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:59',NULL,NULL),(15219,1809,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:56',NULL,NULL),(5806,1860,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:01:16',NULL,NULL),(5481,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:31:47',NULL,NULL),(5440,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:36',NULL,NULL),(21834,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:09',NULL,NULL),(21917,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:01:38',NULL,NULL),(690,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:33',NULL,NULL),(18981,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:04',NULL,NULL),(9844,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:26',NULL,NULL),(10579,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:44:48',NULL,NULL),(11361,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:02:02',NULL,NULL),(20414,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:01:25',NULL,NULL),(14642,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:09',NULL,NULL),(14339,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:32:29',NULL,NULL),(13672,1817,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:46',NULL,NULL),(13065,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:57',NULL,NULL),(22230,1699,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:27',NULL,NULL),(22885,1811,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:59:48',NULL,NULL),(23250,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(9405,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:51',NULL,NULL),(17361,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:00:33',NULL,NULL),(16204,1616,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:38',NULL,NULL),(8362,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:31:34',NULL,NULL),(13662,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:45',NULL,NULL),(19044,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:21',NULL,NULL),(4020,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:37',NULL,NULL),(3306,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:43',NULL,NULL),(19969,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:15',NULL,NULL),(8330,1672,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:31:25',NULL,NULL),(675,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:28',NULL,NULL),(19666,1872,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:02:09',NULL,NULL),(17929,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:29',NULL,NULL),(6700,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:35',NULL,NULL),(13418,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:10',NULL,NULL),(10958,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:05',NULL,NULL),(930,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:58',NULL,NULL),(1979,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:31:34',NULL,NULL),(4628,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:04',NULL,NULL),(4901,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:01:20',NULL,NULL),(5014,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:01:53',NULL,NULL),(2043,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:51',NULL,NULL),(5730,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:49',NULL,NULL),(20964,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:24',NULL,NULL),(20971,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:31:26',NULL,NULL),(21983,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:02:01',NULL,NULL),(6398,1806,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:30',NULL,NULL),(4617,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:32:06',NULL,NULL),(5021,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:01:55',NULL,NULL),(18276,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:30:12',NULL,NULL),(10940,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:46:20',NULL,NULL),(22192,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:16',NULL,NULL),(8386,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:31:40',NULL,NULL),(3208,1623,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:16',NULL,NULL),(3755,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:00:30',NULL,NULL),(10132,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:26',NULL,NULL),(18500,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:15',NULL,NULL),(13039,1694,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:50',NULL,NULL),(15988,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:20',NULL,NULL),(16082,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:53',NULL,NULL),(16801,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:07',NULL,NULL),(2344,1659,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:30:50',NULL,NULL),(19542,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:33',NULL,NULL),(3975,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:26',NULL,NULL),(3991,1847,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:01:30',NULL,NULL),(14091,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:48',NULL,NULL),(21994,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:02:05',NULL,NULL),(3412,1625,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:12',NULL,NULL),(19961,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:11',NULL,NULL),(6912,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:35',NULL,NULL),(17221,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:32:12',NULL,NULL),(4012,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:35',NULL,NULL),(12972,1761,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:26:33',NULL,NULL),(12744,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:23:29',NULL,NULL),(10447,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:41:54',NULL,NULL),(4650,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:10',NULL,NULL),(6219,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:42',NULL,NULL),(21771,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:00:46',NULL,NULL),(21843,1852,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:01:12',NULL,NULL),(22041,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:22',NULL,NULL),(1138,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:55',NULL,NULL),(19839,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:38',NULL,NULL),(17284,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:07',NULL,NULL),(8637,1764,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:35',NULL,NULL),(2835,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:00',NULL,NULL),(10753,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:33',NULL,NULL),(7016,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:05',NULL,NULL),(10119,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:23',NULL,NULL),(6068,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:47',NULL,NULL),(5931,1810,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:01:58',NULL,NULL),(5833,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:25',NULL,NULL),(4526,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:31:44',NULL,NULL),(8496,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:32:09',NULL,NULL),(8463,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:32:00',NULL,NULL),(3895,1818,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:06',NULL,NULL),(16798,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:06',NULL,NULL),(9028,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:30:10',NULL,NULL),(13903,1868,'2014-01-14','23:10:00','A','000',0,'2014-01-24 05:31:20',NULL,NULL),(9209,1739,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:30:59',NULL,NULL),(13358,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:28:15',NULL,NULL),(10817,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:49',NULL,NULL),(6395,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:29',NULL,NULL),(19456,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:01:09',NULL,NULL),(16971,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:30:49',NULL,NULL),(8196,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 03:30:47',NULL,NULL),(14882,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:14',NULL,NULL),(14852,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 06:00:06',NULL,NULL),(14502,1677,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:29',NULL,NULL),(8164,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:30:38',NULL,NULL),(7791,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:09',NULL,NULL),(7163,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:30:35',NULL,NULL),(7059,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:30:04',NULL,NULL),(6936,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:44',NULL,NULL),(10167,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:36',NULL,NULL),(9586,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:18',NULL,NULL),(562,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:50',NULL,NULL),(826,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:30:30',NULL,NULL),(16864,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:30:23',NULL,NULL),(2059,1734,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:31:55',NULL,NULL),(7291,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:31:11',NULL,NULL),(3705,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:00:17',NULL,NULL),(13967,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:31:29',NULL,NULL),(4520,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:42',NULL,NULL),(20553,1712,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:02:15',NULL,NULL),(21668,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:00:09',NULL,NULL),(22183,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:14',NULL,NULL),(9208,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:59',NULL,NULL),(20230,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:18',NULL,NULL),(9142,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:30:42',NULL,NULL),(1817,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 20:30:31',NULL,NULL),(3533,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:45',NULL,NULL),(18567,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:33',NULL,NULL),(18462,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:03',NULL,NULL),(14400,1600,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:00',NULL,NULL),(13616,1823,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:30:39',NULL,NULL),(4937,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:31',NULL,NULL),(4226,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:26',NULL,NULL),(4239,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:29',NULL,NULL),(20712,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:14',NULL,NULL),(22217,1701,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:24',NULL,NULL),(22433,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:31:27',NULL,NULL),(22674,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:58:32',NULL,NULL),(140,175,'2013-12-27','14:50:00','A','000',0,'2014-01-13 03:04:48',NULL,NULL),(8868,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:37',NULL,NULL),(18949,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:54',NULL,NULL),(8425,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:51',NULL,NULL),(18481,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:31:09',NULL,NULL),(7356,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:29',NULL,NULL),(17552,1768,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:35',NULL,NULL),(7185,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:41',NULL,NULL),(15471,1640,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:46',NULL,NULL),(4381,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:31:06',NULL,NULL),(989,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:31:14',NULL,NULL),(1042,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:31:29',NULL,NULL),(14137,1692,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:31:55',NULL,NULL),(21681,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:14',NULL,NULL),(22156,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:07',NULL,NULL),(9155,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:45',NULL,NULL),(18327,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:30:26',NULL,NULL),(17865,1668,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:07',NULL,NULL),(7215,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:30:49',NULL,NULL),(17155,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:31:49',NULL,NULL),(16198,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:16:36',NULL,NULL),(6904,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:32',NULL,NULL),(12978,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:35',NULL,NULL),(12770,1781,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:36',NULL,NULL),(12369,1717,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:47',NULL,NULL),(12021,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:10',NULL,NULL),(6547,1795,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:32:10',NULL,NULL),(10183,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:40:40',NULL,NULL),(4521,1754,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:31:43',NULL,NULL),(17111,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:35',NULL,NULL),(16696,1678,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:25',NULL,NULL),(9976,1744,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:39:44',NULL,NULL),(14623,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:03',NULL,NULL),(20973,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:27',NULL,NULL),(21169,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:40:41',NULL,NULL),(23402,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:51',NULL,NULL),(23553,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-02 13:30:02',NULL,NULL),(23704,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-07 17:30:01',NULL,NULL),(2788,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:43',NULL,NULL),(16669,1630,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:15',NULL,NULL),(16034,1612,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:36',NULL,NULL),(14448,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:14',NULL,NULL),(7929,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:47',NULL,NULL),(5176,1676,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:30:23',NULL,NULL),(7476,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:03',NULL,NULL),(7206,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:46',NULL,NULL),(10933,1789,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:46:19',NULL,NULL),(8921,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:01:51',NULL,NULL),(6795,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:01',NULL,NULL),(11233,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:26',NULL,NULL),(17202,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:32:05',NULL,NULL),(21332,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:41',NULL,NULL),(21577,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:12',NULL,NULL),(22339,1583,'2014-01-14','23:04:00','A','000',0,'2014-01-24 10:30:55',NULL,NULL),(23245,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:02',NULL,NULL),(23298,1648,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:01:14',NULL,NULL),(130,220,'2013-12-27','15:09:00','A','000',0,'2014-01-13 03:04:45',NULL,NULL),(16085,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:15:55',NULL,NULL),(15911,1671,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:14:52',NULL,NULL),(466,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:01:18',NULL,NULL),(14411,1663,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:50:03',NULL,NULL),(1294,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:00:33',NULL,NULL),(13114,1582,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:11',NULL,NULL),(13049,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:53',NULL,NULL),(6419,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:36',NULL,NULL),(18405,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:30:47',NULL,NULL),(11084,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:44',NULL,NULL),(9481,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:32:12',NULL,NULL),(19245,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:00:10',NULL,NULL),(632,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:02:13',NULL,NULL),(6128,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:30:16',NULL,NULL),(4749,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:00:39',NULL,NULL),(4600,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:32:02',NULL,NULL),(15126,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:01:30',NULL,NULL),(1757,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:30:16',NULL,NULL),(2011,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:31:43',NULL,NULL),(21276,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:41:21',NULL,NULL),(23206,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:55',NULL,NULL),(97,294,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:07:30',NULL,NULL),(9753,1821,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:37:01',NULL,NULL),(3738,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:00:26',NULL,NULL),(19043,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:37:21',NULL,NULL),(18656,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:56',NULL,NULL),(16129,1633,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:12',NULL,NULL),(16086,1669,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:55',NULL,NULL),(4490,1837,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:31:35',NULL,NULL),(5055,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:02:05',NULL,NULL),(12980,1703,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:26:35',NULL,NULL),(11332,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:01:53',NULL,NULL),(5789,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:10',NULL,NULL),(6981,1609,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:55',NULL,NULL),(21601,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:43:21',NULL,NULL),(23429,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:01:59',NULL,NULL),(1491,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:01:46',NULL,NULL),(9778,1582,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:37:08',NULL,NULL),(19834,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:30:37',NULL,NULL),(17529,1592,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:01:28',NULL,NULL),(16464,1704,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:56',NULL,NULL),(16366,1769,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:18:18',NULL,NULL),(12467,1760,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:22:10',NULL,NULL),(15657,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:49',NULL,NULL),(15138,1650,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:01:34',NULL,NULL),(14438,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:50:11',NULL,NULL),(13895,1579,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:31:19',NULL,NULL),(12565,1792,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:38',NULL,NULL),(22917,1660,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:59:58',NULL,NULL),(23603,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-08 17:30:02',NULL,NULL),(5436,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:31:35',NULL,NULL),(21097,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:32:01',NULL,NULL),(17517,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:01:24',NULL,NULL),(17999,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:13:53',NULL,NULL),(18544,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:31:27',NULL,NULL),(18546,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:31:27',NULL,NULL),(18582,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:37',NULL,NULL),(18776,1826,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:36:06',NULL,NULL),(22909,1733,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:56',NULL,NULL),(22955,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 11:00:08',NULL,NULL),(23026,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:00:21',NULL,NULL),(2018,1689,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:31:45',NULL,NULL),(20798,1724,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:39',NULL,NULL),(20084,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:47',NULL,NULL),(9776,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:37:07',NULL,NULL),(8840,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 04:01:29',NULL,NULL),(4914,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:01:24',NULL,NULL),(4334,1612,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:30:54',NULL,NULL),(12136,1584,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:41',NULL,NULL),(12158,1750,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:46',NULL,NULL),(22172,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:11',NULL,NULL),(22629,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:58:17',NULL,NULL),(23714,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-08 22:29:59',NULL,NULL),(1074,1610,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:37',NULL,NULL),(21164,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:40:39',NULL,NULL),(10021,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:56',NULL,NULL),(20267,1741,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:00:31',NULL,NULL),(8633,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:34',NULL,NULL),(19609,1834,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:51',NULL,NULL),(7310,1590,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:17',NULL,NULL),(7019,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 02:02:05',NULL,NULL),(3707,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:00:18',NULL,NULL),(15640,1738,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:03:43',NULL,NULL),(5492,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:50',NULL,NULL),(11947,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:18:48',NULL,NULL),(22,275,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:21',NULL,NULL),(20332,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:00:55',NULL,NULL),(19810,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:31',NULL,NULL),(5777,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:01:06',NULL,NULL),(15859,1577,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:14:34',NULL,NULL),(13473,1656,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:30:18',NULL,NULL),(12365,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:46',NULL,NULL),(7292,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:31:12',NULL,NULL),(5894,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:01:46',NULL,NULL),(21804,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:00:58',NULL,NULL),(338,1719,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:35',NULL,NULL),(21402,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:42:07',NULL,NULL),(1723,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:08',NULL,NULL),(21225,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:41:03',NULL,NULL),(20806,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:41',NULL,NULL),(8825,1756,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:25',NULL,NULL),(17783,1622,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:12:37',NULL,NULL),(2208,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:30:08',NULL,NULL),(2613,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:59',NULL,NULL),(2735,1777,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:24',NULL,NULL),(12589,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:22:44',NULL,NULL),(8018,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:02:11',NULL,NULL),(7472,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:01',NULL,NULL),(22456,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:35',NULL,NULL),(10282,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:08',NULL,NULL),(918,1753,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:55',NULL,NULL),(20224,1721,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:00:16',NULL,NULL),(20155,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:06',NULL,NULL),(20062,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:31:40',NULL,NULL),(18578,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:31:36',NULL,NULL),(7923,1716,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:45',NULL,NULL),(17593,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:01:51',NULL,NULL),(16265,1689,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:17:01',NULL,NULL),(13733,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:30:56',NULL,NULL),(12274,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:19',NULL,NULL),(7828,1718,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:19',NULL,NULL),(7776,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:05',NULL,NULL),(7646,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:00:30',NULL,NULL),(23435,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 11:02:02',NULL,NULL),(1391,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:01:10',NULL,NULL),(1676,1773,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:02:52',NULL,NULL),(1835,1708,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:35',NULL,NULL),(20187,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:32:15',NULL,NULL),(20052,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:37',NULL,NULL),(19761,1690,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:30:18',NULL,NULL),(19209,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:38:08',NULL,NULL),(19018,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:37:14',NULL,NULL),(19000,1691,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:09',NULL,NULL),(10042,1649,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:02',NULL,NULL),(17908,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:13:22',NULL,NULL),(2440,1666,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:15',NULL,NULL),(8075,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:30:15',NULL,NULL),(2630,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:32:03',NULL,NULL),(6915,1633,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:36',NULL,NULL),(808,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:25',NULL,NULL),(2718,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:00:18',NULL,NULL),(2742,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:00:27',NULL,NULL),(14564,1606,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:45',NULL,NULL),(6423,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:31:37',NULL,NULL),(12132,1672,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:19:39',NULL,NULL),(11884,1664,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:16',NULL,NULL),(21454,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:26',NULL,NULL),(21010,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:31:37',NULL,NULL),(3606,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:32:05',NULL,NULL),(19937,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:04',NULL,NULL),(5985,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:02:18',NULL,NULL),(7223,1613,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:51',NULL,NULL),(11626,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:10',NULL,NULL),(10441,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:41:52',NULL,NULL),(21055,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:31:50',NULL,NULL),(20000,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:23',NULL,NULL),(1972,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:33',NULL,NULL),(7499,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:32:09',NULL,NULL),(15548,1602,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:13',NULL,NULL),(15405,1598,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:31',NULL,NULL),(2587,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:52',NULL,NULL),(12705,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:18',NULL,NULL),(5739,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:53',NULL,NULL),(2685,1665,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:00:06',NULL,NULL),(10996,1702,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:00:16',NULL,NULL),(10473,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:44:20',NULL,NULL),(9046,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:30:15',NULL,NULL),(19613,1801,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:01:52',NULL,NULL),(1048,1824,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:31',NULL,NULL),(7922,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:01:45',NULL,NULL),(4824,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:59',NULL,NULL),(7034,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:02:09',NULL,NULL),(6872,1812,'2014-01-14','23:09:00','A','000',0,'2014-01-24 02:01:22',NULL,NULL),(1933,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:00',NULL,NULL),(20483,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:50',NULL,NULL),(12902,1637,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:14',NULL,NULL),(15620,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:37',NULL,NULL),(669,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:02:25',NULL,NULL),(811,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:26',NULL,NULL),(14202,1833,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:32:05',NULL,NULL),(17355,1728,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:00:31',NULL,NULL),(8046,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:07',NULL,NULL),(6991,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:57',NULL,NULL),(13846,1814,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:31:12',NULL,NULL),(19284,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:00:20',NULL,NULL),(17633,1695,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:02:06',NULL,NULL),(14092,1702,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:31:48',NULL,NULL),(15727,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:04:13',NULL,NULL),(1354,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:00:55',NULL,NULL),(21927,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:01:41',NULL,NULL),(8622,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:31',NULL,NULL),(16116,1604,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:07',NULL,NULL),(11158,1709,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:01:04',NULL,NULL),(14328,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:32:26',NULL,NULL),(5032,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:58',NULL,NULL),(12258,1670,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:14',NULL,NULL),(111,178,'2013-12-27','14:51:00','A','000',0,'2014-01-13 03:04:39',NULL,NULL),(22310,1735,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:30:47',NULL,NULL),(21387,1608,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:01',NULL,NULL),(10285,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:41:09',NULL,NULL),(8537,1598,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:00:09',NULL,NULL),(18899,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:40',NULL,NULL),(15317,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-24 06:02:15',NULL,NULL),(2464,1654,'2014-01-14','23:06:00','A','000',0,'2014-01-23 21:31:21',NULL,NULL),(11689,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:15:26',NULL,NULL),(22245,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:31',NULL,NULL),(22089,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:39',NULL,NULL),(22044,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:23',NULL,NULL),(12310,1706,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:30',NULL,NULL),(19489,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:18',NULL,NULL),(13559,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:31',NULL,NULL),(15732,1743,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:04:14',NULL,NULL),(9005,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:30:04',NULL,NULL),(19163,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:37:55',NULL,NULL),(12311,1737,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:20:30',NULL,NULL),(15965,1745,'2014-01-14','23:08:00','A','000',1,'2014-01-24 06:15:11',NULL,NULL),(9484,1717,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:32:13',NULL,NULL),(18853,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:36:27',NULL,NULL),(464,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:01:18',NULL,NULL),(5445,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:37',NULL,NULL),(3109,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:02:38',NULL,NULL),(6303,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:31:04',NULL,NULL),(19525,1835,'2014-01-14','23:10:00','A','000',0,'2014-01-24 08:01:28',NULL,NULL),(8631,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:00:33',NULL,NULL),(16347,1710,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:18:11',NULL,NULL),(8205,1790,'2014-01-14','23:09:00','A','000',0,'2014-01-24 03:30:49',NULL,NULL),(7511,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:12',NULL,NULL),(22737,1706,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:58:54',NULL,NULL),(17840,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:12:59',NULL,NULL),(17420,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 07:00:52',NULL,NULL),(6576,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:00:04',NULL,NULL),(13738,1602,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:57',NULL,NULL),(12798,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:43',NULL,NULL),(11143,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:00',NULL,NULL),(22209,1621,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:21',NULL,NULL),(16381,1897,'2014-01-14','23:11:00','A','000',1,'2014-01-24 06:18:24',NULL,NULL),(19756,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:30:17',NULL,NULL),(4393,1713,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:31:10',NULL,NULL),(20753,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:30:26',NULL,NULL),(12281,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:21',NULL,NULL),(14592,1590,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:53',NULL,NULL),(15968,1659,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:15:13',NULL,NULL),(1544,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:02:04',NULL,NULL),(13281,1683,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:55',NULL,NULL),(3502,1817,'2014-01-14','23:09:00','A','000',0,'2014-01-23 22:31:36',NULL,NULL),(12477,1603,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:13',NULL,NULL),(12426,1809,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:21:59',NULL,NULL),(7419,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:46',NULL,NULL),(10323,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:19',NULL,NULL),(11625,1703,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:15:09',NULL,NULL),(5901,1629,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:01:48',NULL,NULL),(15604,1593,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:32',NULL,NULL),(13220,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:27:38',NULL,NULL),(5546,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:32:06',NULL,NULL),(489,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:26',NULL,NULL),(11339,1620,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:55',NULL,NULL),(7699,1732,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:00:44',NULL,NULL),(12881,1676,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:24:13',NULL,NULL),(16700,1679,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:20:26',NULL,NULL),(19157,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:37:53',NULL,NULL),(11083,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 05:00:44',NULL,NULL),(3586,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:31:59',NULL,NULL),(1398,1827,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:01:13',NULL,NULL),(4160,1579,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:30:09',NULL,NULL),(4194,1742,'2014-01-14','23:08:00','A','000',0,'2014-01-23 23:30:18',NULL,NULL),(2135,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:32:14',NULL,NULL),(5907,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:01:50',NULL,NULL),(23424,1631,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:58',NULL,NULL),(23436,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:02:03',NULL,NULL),(2528,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 21:31:37',NULL,NULL),(20965,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:31:25',NULL,NULL),(3587,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:31:59',NULL,NULL),(19505,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:23',NULL,NULL),(18780,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:07',NULL,NULL),(3662,1854,'2014-01-14','23:10:00','A','000',0,'2014-01-23 23:00:07',NULL,NULL),(4089,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:55',NULL,NULL),(10071,1761,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:40:09',NULL,NULL),(4681,1793,'2014-01-14','23:09:00','A','000',0,'2014-01-24 00:00:20',NULL,NULL),(4864,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:10',NULL,NULL),(7546,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:00:04',NULL,NULL),(22094,1599,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:02:41',NULL,NULL),(22289,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:41',NULL,NULL),(10223,1857,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:40:51',NULL,NULL),(18766,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:03',NULL,NULL),(8988,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:10',NULL,NULL),(16608,1724,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:49',NULL,NULL),(5491,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:31:50',NULL,NULL),(6262,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:30:53',NULL,NULL),(13071,1632,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:26:59',NULL,NULL),(10762,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:45:35',NULL,NULL),(5538,1587,'2014-01-14','23:04:00','A','000',0,'2014-01-24 00:32:04',NULL,NULL),(5682,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 01:00:33',NULL,NULL),(22307,1606,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:46',NULL,NULL),(1108,1639,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:31:47',NULL,NULL),(18837,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:36:23',NULL,NULL),(2204,1723,'2014-01-14','23:07:00','A','000',0,'2014-01-23 21:30:07',NULL,NULL),(16610,1665,'2014-01-14','23:06:00','A','000',1,'2014-01-24 06:19:50',NULL,NULL),(15993,1691,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:15:22',NULL,NULL),(15457,1617,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:02:42',NULL,NULL),(14240,1772,'2014-01-14','23:08:00','A','000',0,'2014-01-24 05:32:10',NULL,NULL),(12786,1613,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:40',NULL,NULL),(9158,1697,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:46',NULL,NULL),(21629,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:43:31',NULL,NULL),(22748,1850,'2014-01-14','23:10:00','A','000',0,'2014-01-24 10:58:58',NULL,NULL),(7357,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:31:30',NULL,NULL),(20299,1680,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:43',NULL,NULL),(3544,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:48',NULL,NULL),(11042,1635,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:28',NULL,NULL),(15922,1610,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:14:56',NULL,NULL),(11997,1588,'2014-01-14','23:04:00','A','000',1,'2014-01-24 05:19:03',NULL,NULL),(11503,1628,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:39',NULL,NULL),(22462,1763,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:31:37',NULL,NULL),(9069,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:30:21',NULL,NULL),(9756,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:37:02',NULL,NULL),(19953,1805,'2014-01-14','23:09:00','A','000',0,'2014-01-24 08:31:09',NULL,NULL),(9638,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:36:32',NULL,NULL),(15015,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 06:00:53',NULL,NULL),(6725,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 02:00:42',NULL,NULL),(11137,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:00:58',NULL,NULL),(11811,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:15:57',NULL,NULL),(22197,1593,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:18',NULL,NULL),(23650,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-28 22:30:01',NULL,NULL),(1128,1828,'2014-01-14','23:09:00','A','000',0,'2014-01-23 19:31:52',NULL,NULL),(20203,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:00:08',NULL,NULL),(19603,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:01:50',NULL,NULL),(2563,1581,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:31:46',NULL,NULL),(18019,1785,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:14:01',NULL,NULL),(5234,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:30:38',NULL,NULL),(5482,1705,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:31:48',NULL,NULL),(13908,1803,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:31:21',NULL,NULL),(10842,1677,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:45:55',NULL,NULL),(11347,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:01:58',NULL,NULL),(12773,1746,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:36',NULL,NULL),(11587,1634,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:15:00',NULL,NULL),(12380,1666,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:50',NULL,NULL),(23577,2770,'2014-01-29','13:47:00','A','000',0,'2014-02-05 13:30:02',NULL,NULL),(10540,1874,'2014-01-14','23:10:00','A','000',0,'2014-01-24 04:44:38',NULL,NULL),(17162,1632,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:31:51',NULL,NULL),(1559,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:02:10',NULL,NULL),(5669,1577,'2014-01-14','23:04:00','A','000',0,'2014-01-24 01:00:28',NULL,NULL),(15598,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:03:30',NULL,NULL),(12396,1655,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:20:54',NULL,NULL),(14619,1621,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:51:01',NULL,NULL),(20633,1799,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:02:44',NULL,NULL),(20087,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:31:47',NULL,NULL),(12736,1596,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:23:27',NULL,NULL),(19499,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 08:01:21',NULL,NULL),(3077,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:02:27',NULL,NULL),(21630,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:43:32',NULL,NULL),(3870,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-23 23:01:00',NULL,NULL),(9571,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:36:14',NULL,NULL),(21099,1624,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:32:01',NULL,NULL),(21062,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:31:51',NULL,NULL),(20791,1627,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:30:37',NULL,NULL),(8384,1637,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:31:40',NULL,NULL),(7783,1729,'2014-01-14','23:07:00','A','000',0,'2014-01-24 03:01:07',NULL,NULL),(17489,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:15',NULL,NULL),(6394,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 01:31:29',NULL,NULL),(5489,1883,'2014-01-14','23:11:00','A','000',0,'2014-01-24 00:31:50',NULL,NULL),(15541,1714,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:03:10',NULL,NULL),(22203,1603,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:30:20',NULL,NULL),(8984,1636,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:09',NULL,NULL),(20682,1800,'2014-01-14','23:09:00','A','000',0,'2014-01-24 09:30:04',NULL,NULL),(7243,1638,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:30:59',NULL,NULL),(7027,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:02:08',NULL,NULL),(19064,1588,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:26',NULL,NULL),(18868,1722,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:31',NULL,NULL),(18789,1678,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:36:10',NULL,NULL),(6337,1694,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:31:13',NULL,NULL),(17280,1813,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:00:06',NULL,NULL),(14856,1822,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:00:07',NULL,NULL),(12605,1619,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:22:49',NULL,NULL),(12129,1778,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:19:39',NULL,NULL),(4229,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:30:27',NULL,NULL),(303,1604,'2014-01-14','23:05:00','A','000',0,'2014-01-23 19:00:23',NULL,NULL),(14698,1741,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:51:24',NULL,NULL),(16168,1614,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:16:25',NULL,NULL),(10679,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:45:15',NULL,NULL),(19882,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:30:50',NULL,NULL),(14453,1631,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:50:15',NULL,NULL),(7954,1655,'2014-01-14','23:06:00','A','000',0,'2014-01-24 03:01:53',NULL,NULL),(4473,1626,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:31:31',NULL,NULL),(6892,1591,'2014-01-14','23:05:00','A','000',0,'2014-01-24 02:01:28',NULL,NULL),(6800,1738,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:01:02',NULL,NULL),(6797,1645,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:01:02',NULL,NULL),(22823,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 10:59:27',NULL,NULL),(304,1693,'2014-01-14','23:07:00','A','000',0,'2014-01-23 19:00:23',NULL,NULL),(12273,1783,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:19',NULL,NULL),(20162,1681,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:32:08',NULL,NULL),(12183,1690,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:19:53',NULL,NULL),(22562,1657,'2014-01-14','23:06:00','A','000',0,'2014-01-24 10:32:09',NULL,NULL),(4899,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 00:01:19',NULL,NULL),(3923,1688,'2014-01-14','23:06:00','A','000',0,'2014-01-23 23:01:13',NULL,NULL),(20472,1663,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:01:46',NULL,NULL),(18974,1619,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:37:02',NULL,NULL),(7506,1674,'2014-01-14','23:06:00','A','000',0,'2014-01-24 02:32:11',NULL,NULL),(21903,1595,'2014-01-14','23:05:00','A','000',0,'2014-01-24 10:01:33',NULL,NULL),(21113,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:32:05',NULL,NULL),(17382,1887,'2014-01-14','23:11:00','A','000',0,'2014-01-24 07:00:40',NULL,NULL),(5101,1700,'2014-01-14','23:07:00','A','000',0,'2014-01-24 00:02:17',NULL,NULL),(3987,1600,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:01:29',NULL,NULL),(12576,1701,'2014-01-14','23:07:00','A','000',1,'2014-01-24 05:22:41',NULL,NULL),(11865,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:16:11',NULL,NULL),(582,1767,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:01:56',NULL,NULL),(21494,1630,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:42:41',NULL,NULL),(14681,1786,'2014-01-14','23:09:00','A','000',1,'2014-01-24 05:51:19',NULL,NULL),(15120,1808,'2014-01-14','23:09:00','A','000',0,'2014-01-24 06:01:28',NULL,NULL),(819,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-23 19:30:28',NULL,NULL),(10084,1711,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:40:13',NULL,NULL),(18685,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 07:32:05',NULL,NULL),(4809,1780,'2014-01-14','23:08:00','A','000',0,'2014-01-24 00:00:55',NULL,NULL),(16720,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:33',NULL,NULL),(1932,1698,'2014-01-14','23:07:00','A','000',0,'2014-01-23 20:30:59',NULL,NULL),(7879,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-24 03:01:34',NULL,NULL),(11845,1685,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:16:06',NULL,NULL),(275,1775,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:00:14',NULL,NULL),(22175,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 10:30:12',NULL,NULL),(7066,1748,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:30:05',NULL,NULL),(5953,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 01:02:06',NULL,NULL),(5095,1646,'2014-01-14','23:06:00','A','000',0,'2014-01-24 00:02:15',NULL,NULL),(1952,1771,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:31:27',NULL,NULL),(21401,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:42:06',NULL,NULL),(15067,1726,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:01:10',NULL,NULL),(12122,1636,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:37',NULL,NULL),(1570,1611,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:02:14',NULL,NULL),(8117,1778,'2014-01-14','23:08:00','A','000',0,'2014-01-24 03:30:26',NULL,NULL),(10010,1617,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:39:53',NULL,NULL),(63,377,'2013-12-27','00:00:00','A','000',1,'2014-01-02 06:06:59',NULL,NULL),(10435,1667,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:41:50',NULL,NULL),(21597,1675,'2014-01-14','23:06:00','A','000',0,'2014-01-24 09:43:19',NULL,NULL),(18930,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:48',NULL,NULL),(18576,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:31:35',NULL,NULL),(12375,1753,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:20:49',NULL,NULL),(12342,1615,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:20:40',NULL,NULL),(1287,1802,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:00:30',NULL,NULL),(2640,1585,'2014-01-14','23:04:00','A','000',0,'2014-01-23 21:32:06',NULL,NULL),(4451,1825,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:31:25',NULL,NULL),(10512,1618,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:44:30',NULL,NULL),(20355,1584,'2014-01-14','23:04:00','A','000',0,'2014-01-24 09:01:03',NULL,NULL),(1752,1658,'2014-01-14','23:06:00','A','000',0,'2014-01-23 20:30:15',NULL,NULL),(18730,1683,'2014-01-14','23:06:00','A','000',0,'2014-01-24 07:35:53',NULL,NULL),(17883,1589,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:13:14',NULL,NULL),(1856,1758,'2014-01-14','23:08:00','A','000',0,'2014-01-23 20:30:41',NULL,NULL),(9900,1684,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:37:40',NULL,NULL),(12739,1765,'2014-01-14','23:08:00','A','000',1,'2014-01-24 05:23:27',NULL,NULL),(8977,1605,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:02:06',NULL,NULL),(9497,1746,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:35:56',NULL,NULL),(21517,1727,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:42:49',NULL,NULL),(1965,1615,'2014-01-14','23:05:00','A','000',0,'2014-01-23 20:31:31',NULL,NULL),(3320,1704,'2014-01-14','23:07:00','A','000',0,'2014-01-23 22:30:47',NULL,NULL),(11510,1594,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:14:40',NULL,NULL),(16660,1627,'2014-01-14','23:05:00','A','000',1,'2014-01-24 06:20:11',NULL,NULL),(817,1749,'2014-01-14','23:08:00','A','000',0,'2014-01-23 19:30:28',NULL,NULL),(1893,1823,'2014-01-14','23:09:00','A','000',0,'2014-01-23 20:30:50',NULL,NULL),(12727,1641,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:23:24',NULL,NULL),(12105,1638,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:19:32',NULL,NULL),(8719,1760,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:00:57',NULL,NULL),(23659,2770,'2014-01-29','13:47:00','A','000',0,'2014-03-01 23:30:00',NULL,NULL),(6332,1752,'2014-01-14','23:08:00','A','000',0,'2014-01-24 01:31:11',NULL,NULL),(3940,1792,'2014-01-14','23:09:00','A','000',0,'2014-01-23 23:01:17',NULL,NULL),(8873,1807,'2014-01-14','23:09:00','A','000',0,'2014-01-24 04:01:38',NULL,NULL),(16558,1712,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:30',NULL,NULL),(13494,1614,'2014-01-14','23:05:00','A','000',0,'2014-01-24 05:30:21',NULL,NULL),(13143,1656,'2014-01-14','23:06:00','A','000',1,'2014-01-24 05:27:18',NULL,NULL),(3249,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-23 22:30:28',NULL,NULL),(23404,1640,'2014-01-14','23:05:00','A','000',0,'2014-01-24 11:01:51',NULL,NULL),(11391,1707,'2014-01-14','23:07:00','A','000',0,'2014-01-24 05:02:10',NULL,NULL),(22726,1787,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:58:50',NULL,NULL),(6311,1838,'2014-01-14','23:10:00','A','000',0,'2014-01-24 01:31:06',NULL,NULL),(10321,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 04:41:18',NULL,NULL),(17309,1596,'2014-01-14','23:05:00','A','000',0,'2014-01-24 07:00:16',NULL,NULL),(4067,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-23 23:01:50',NULL,NULL),(9337,1774,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:31:33',NULL,NULL),(14305,1635,'2014-01-14','23:05:00','A','000',1,'2014-01-24 05:32:20',NULL,NULL),(22226,1803,'2014-01-14','23:09:00','A','000',0,'2014-01-24 10:30:26',NULL,NULL),(8796,1671,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:01:17',NULL,NULL),(3452,1679,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:31:23',NULL,NULL),(20088,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 08:31:48',NULL,NULL),(6581,1770,'2014-01-14','23:08:00','A','000',0,'2014-01-24 02:00:05',NULL,NULL),(11043,1788,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:00:29',NULL,NULL),(3551,1766,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:31:50',NULL,NULL),(12765,1861,'2014-01-14','23:10:00','A','000',1,'2014-01-24 05:23:34',NULL,NULL),(8784,1783,'2014-01-14','23:08:00','A','000',0,'2014-01-24 04:01:14',NULL,NULL),(23252,1798,'2014-01-14','23:09:00','A','000',0,'2014-01-24 11:01:03',NULL,NULL),(20729,1736,'2014-01-14','23:07:00','A','000',0,'2014-01-24 09:30:20',NULL,NULL),(19909,1762,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:57',NULL,NULL),(14935,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 06:00:28',NULL,NULL),(16520,1692,'2014-01-14','23:07:00','A','000',1,'2014-01-24 06:19:17',NULL,NULL),(5866,1884,'2014-01-14','23:11:00','A','000',0,'2014-01-24 01:01:36',NULL,NULL),(21282,1607,'2014-01-14','23:05:00','A','000',0,'2014-01-24 09:41:23',NULL,NULL),(2927,1751,'2014-01-14','23:08:00','A','000',0,'2014-01-23 22:01:32',NULL,NULL),(17587,1714,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:01:48',NULL,NULL),(11708,1791,'2014-01-14','23:09:00','A','000',0,'2014-01-24 05:15:30',NULL,NULL),(23379,1759,'2014-01-14','23:08:00','A','000',0,'2014-01-24 11:01:43',NULL,NULL),(332,1580,'2014-01-14','23:04:00','A','000',0,'2014-01-23 19:00:33',NULL,NULL),(17950,1740,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:13:37',NULL,NULL),(11295,1652,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:01:43',NULL,NULL),(15193,1586,'2014-01-14','23:04:00','A','000',1,'2014-01-24 06:01:51',NULL,NULL),(14858,1597,'2014-01-14','23:05:00','A','000',0,'2014-01-24 06:00:08',NULL,NULL),(10067,1641,'2014-01-14','23:06:00','A','000',0,'2014-01-24 04:40:08',NULL,NULL),(10963,1662,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:06',NULL,NULL),(4604,1616,'2014-01-14','23:05:00','A','000',0,'2014-01-23 23:32:03',NULL,NULL),(11058,1661,'2014-01-14','23:06:00','A','000',0,'2014-01-24 05:00:34',NULL,NULL),(143,184,'2013-12-27','14:53:00','A','000',0,'2014-01-13 03:04:49',NULL,NULL),(9996,1710,'2014-01-14','23:07:00','A','000',0,'2014-01-24 04:39:49',NULL,NULL),(5885,1720,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:01:43',NULL,NULL),(6544,1730,'2014-01-14','23:07:00','A','000',0,'2014-01-24 01:32:09',NULL,NULL),(20475,1755,'2014-01-14','23:08:00','A','000',0,'2014-01-24 09:01:47',NULL,NULL),(20050,1586,'2014-01-14','23:04:00','A','000',0,'2014-01-24 08:31:37',NULL,NULL),(19844,1747,'2014-01-14','23:08:00','A','000',0,'2014-01-24 08:30:40',NULL,NULL),(2869,1686,'2014-01-14','23:06:00','A','000',0,'2014-01-23 22:01:12',NULL,NULL),(19593,1644,'2014-01-14','23:06:00','A','000',0,'2014-01-24 08:01:47',NULL,NULL),(18982,1578,'2014-01-14','23:04:00','A','000',0,'2014-01-24 07:37:04',NULL,NULL),(18851,1757,'2014-01-14','23:08:00','A','000',0,'2014-01-24 07:36:26',NULL,NULL),(18818,1731,'2014-01-14','23:07:00','A','000',0,'2014-01-24 07:36:17',NULL,NULL);
/*!40000 ALTER TABLE `EdiTA1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EdiTransaction`
--

DROP TABLE IF EXISTS `EdiTransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EdiTransaction` (
  `EdiTransactionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EdiFunctionalGroupId` bigint(64) NOT NULL,
  `ControlNumber` varchar(45) NOT NULL COMMENT 'Example 568175',
  `DocumentType` varchar(10) NOT NULL COMMENT 'Example:  834',
  `TransactionSetPurposeCode` varchar(30) NOT NULL COMMENT 'Example Original',
  `TransactionStandard` varchar(45) NOT NULL,
  `ReferenceIdentification` varchar(45) NOT NULL COMMENT 'Example 568175',
  `OriginalReferenceIdentification` varchar(10) NOT NULL COMMENT 'Example 568175',
  `TransactionDate` date NOT NULL COMMENT 'Example 11/29/2013',
  `TransactionTime` time NOT NULL COMMENT '18:04  HH:MM',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EdiTransactionId`),
  KEY `EdiTransactionRefEdiFunctionalGroup_fk_idx` (`EdiFunctionalGroupId`)
) ENGINE=innodb AUTO_INCREMENT=23771 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EdiTransaction`
--

LOCK TABLES `EdiTransaction` WRITE;
/*!40000 ALTER TABLE `EdiTransaction` DISABLE KEYS */;
INSERT INTO `EdiTransaction` VALUES (5702,1067,'276496','834','00','005010X220A1','276496','','2013-12-14','16:30:03',0,'2013-12-26 02:00:30',NULL,NULL),(2508,448,'827501','834','00','005010X220A1','827501','','2013-10-13','10:48:24',0,'2013-12-25 20:30:17',NULL,NULL),(3808,662,'1246464','834','00','005010X220A1','1246464','','2013-12-07','19:47:26',0,'2013-12-25 22:16:36',NULL,NULL),(3886,703,'623511','834','00','005010X220A1','623511','','2013-10-26','02:00:25',0,'2013-12-25 22:31:44',NULL,NULL),(4002,731,'446470','834','00','005010X220A1','446470','','2013-12-18','20:52:43',0,'2013-12-25 23:00:14',NULL,NULL),(5433,1032,'910292','834','00','005010X220A1','910292','','2013-10-05','00:13:51',0,'2013-12-26 01:31:25',NULL,NULL),(13650,2271,'2395185','834','00','005010X220A1','2395185','','2014-01-07','12:16:00',0,'2014-01-08 18:24:10',NULL,NULL),(12152,1591,'1809438','834','00','005010X220A1','1809438','','2013-12-30','15:14:47',0,'2014-01-01 12:07:31',NULL,NULL),(16088,2780,'2262196','834','00','005010X220A1','2262196','','2014-01-22','11:23:45',0,'2014-01-23 03:02:53',NULL,NULL),(17123,3143,'2166600','834','00','005010X220A1','2166600','','2014-01-30','12:15:21',0,'2014-01-30 21:00:20',NULL,NULL),(20201,3781,'3494494','834','00','005010X220A1','3494494','','2014-02-19','10:38:08',0,'2014-02-20 04:18:21',NULL,NULL),(21810,4093,'3233603','834','00','005010X220A1','3233603','','2014-02-27','20:59:48',0,'2014-02-28 21:31:27',NULL,NULL),(22128,4179,'2783106','834','00','005010X220A1','2783106','','2014-03-02','20:29:40',0,'2014-03-03 21:30:39',NULL,NULL),(22139,4179,'2769200','834','00','005010X220A1','2769200','','2014-03-03','12:59:37',0,'2014-03-03 21:30:47',NULL,NULL),(22273,4200,'2842316','834','00','005010X220A1','2842316','','2014-03-04','14:03:57',0,'2014-03-04 21:00:38',NULL,NULL),(13987,2326,'2237656','834','00','005010X220A1','2237656','','2014-01-08','23:10:12',0,'2014-01-13 02:20:48',NULL,NULL),(7611,1303,'408275','834','00','005010X220A1','408275','','2013-12-21','14:19:59',0,'2013-12-26 04:37:36',NULL,NULL),(3344,587,'783993','834','00','005010X220A1','783993','','2013-12-16','20:35:20',0,'2013-12-25 21:50:00',NULL,NULL),(19874,3709,'3580062','834','00','005010X220A1','3580062','','2014-02-15','21:54:02',0,'2014-02-16 19:00:20',NULL,NULL),(22144,4179,'3675314','834','00','005010X220A1','3675314','','2014-03-03','13:50:53',0,'2014-03-03 21:30:51',NULL,NULL),(14357,2404,'1881719','834','00','005010X220A1','1881719','','2014-01-12','09:33:25',0,'2014-01-13 03:01:31',NULL,NULL),(493,102,'114584','834','00','005010X220A1','114584','','2013-12-15','21:52:06',0,'2013-12-25 18:00:16',NULL,NULL),(855,175,'202210','834','00','005010X220A1','202210','','2013-12-03','11:44:16',0,'2013-12-25 18:15:47',NULL,NULL),(1474,252,'1506819','834','00','005010X220A1','1506819','','2013-12-24','16:55:12',0,'2013-12-25 18:56:36',NULL,NULL),(13617,2270,'1613014','834','00','005010X220A1','1613014','','2014-01-06','18:35:53',0,'2014-01-08 18:23:56',NULL,NULL),(13061,1905,'0001','999','BE','005010X231A1','177167','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:50',NULL,NULL),(12802,1703,'1693668','834','00','005010X220A1','1693668','','2014-01-03','13:53:35',0,'2014-01-04 02:01:20',NULL,NULL),(5309,990,'701549','834','00','005010X220A1','701549','','2013-11-05','15:36:08',0,'2013-12-26 01:01:46',NULL,NULL),(12536,1648,'2519528','834','00','005010X220A1','2519528','','2013-12-31','08:36:00',1,'2014-01-02 04:34:38',NULL,NULL),(4670,831,'1734872','834','00','005010X220A1','1734872','','2013-12-23','22:44:16',0,'2013-12-25 23:49:35',NULL,NULL),(10469,1400,'248327','834','00','005010X220A1','248327','','2013-12-23','14:25:08',0,'2013-12-26 12:52:55',NULL,NULL),(15241,2598,'1936497','834','00','005010X220A1','1936497','','2014-01-15','14:54:04',0,'2014-01-16 08:46:51',NULL,NULL),(16284,2976,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:08:00',0,'2014-01-23 17:00:02',NULL,NULL),(17847,3291,'1746063','834','00','005010X220A1','1746063','','2014-02-04','19:31:43',0,'2014-02-05 21:30:04',NULL,NULL),(18644,3463,'2404863','834','00','005010X220A1','2404863','','2014-02-10','13:38:04',0,'2014-02-10 21:31:35',NULL,NULL),(20733,3903,'2841024','834','00','005010X220A1','2841024','','2014-02-24','20:44:15',0,'2014-02-25 21:30:05',NULL,NULL),(6010,1136,'715101','834','00','005010X220A1','715101','','2013-11-17','10:20:46',0,'2013-12-26 02:45:14',NULL,NULL),(4623,827,'1802911','834','00','005010X220A1','1802911','','2013-12-23','22:11:26',0,'2013-12-25 23:47:59',NULL,NULL),(15409,2628,'2389953','834','00','005010X220A1','2389953','','2014-01-15','18:38:13',0,'2014-01-17 03:35:52',NULL,NULL),(16709,3064,'1517960','834','00','005010X220A1','1517960','','2014-01-27','10:57:08',0,'2014-01-27 21:00:49',NULL,NULL),(17115,3142,'2484387','834','00','005010X220A1','2484387','','2014-01-30','14:27:31',0,'2014-01-30 21:00:15',NULL,NULL),(17970,3302,'2002223','834','00','005010X220A1','2002223','','2014-02-05','13:54:44',0,'2014-02-05 21:31:06',NULL,NULL),(19176,3564,'2734726','834','00','005010X220A1','2734726','','2014-02-12','14:31:38',0,'2014-02-12 21:32:29',NULL,NULL),(20253,3793,'2775540','834','00','005010X220A1','2775540','','2014-02-19','14:24:54',0,'2014-02-20 04:32:47',NULL,NULL),(21259,4000,'3785642','834','00','005010X220A1','3785642','','2014-02-26','09:24:04',0,'2014-02-26 21:01:54',NULL,NULL),(21576,4055,'3718379','834','00','005010X220A1','3718379','','2014-02-26','13:32:33',0,'2014-02-28 07:00:17',NULL,NULL),(17364,3182,'2142596','834','00','005010X220A1','2142596','','2014-01-31','08:38:48',0,'2014-01-31 21:01:26',NULL,NULL),(17504,3225,'2215848','834','00','005010X220A1','2215848','','2014-02-01','23:05:10',0,'2014-02-02 19:00:27',NULL,NULL),(14904,2558,'2265896','834','00','005010X220A1','2265896','','2014-01-14','12:58:46',0,'2014-01-15 02:07:31',NULL,NULL),(4975,935,'943923','834','00','005010X220A1','943923','','2013-12-10','19:05:22',0,'2013-12-26 00:45:11',NULL,NULL),(14469,2490,'0001','999','BE','005010X231A1','768681','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:42',NULL,NULL),(12251,1620,'1270878','834','00','005010X220A1','1270878','','2013-12-31','20:05:00',1,'2014-01-02 04:23:28',NULL,NULL),(15593,2659,'1745687','834','00','005010X220A1','1745687','','2014-01-17','15:39:53',0,'2014-01-20 08:06:21',NULL,NULL),(16645,3060,'1942703','834','00','005010X220A1','1942703','','2014-01-27','11:03:37',0,'2014-01-27 21:00:08',NULL,NULL),(14901,2558,'1807187','834','00','005010X220A1','1807187','','2014-01-14','12:21:00',0,'2014-01-15 02:07:30',NULL,NULL),(494,102,'175037','834','00','005010X220A1','175037','','2013-12-15','22:45:49',0,'2013-12-25 18:00:18',NULL,NULL),(14086,2341,'2425604','834','00','005010X220A1','2425604','','2014-01-08','11:28:43',0,'2014-01-13 02:22:01',NULL,NULL),(12515,1643,'2136491','834','00','005010X220A1','2136491','','2013-12-31','11:01:52',1,'2014-01-02 04:33:54',NULL,NULL),(2143,360,'858759','834','00','005010X220A1','858759','','2013-12-02','13:44:34',0,'2013-12-25 19:46:15',NULL,NULL),(5967,1117,'702065','834','00','005010X220A1','702065','','2013-12-15','14:14:32',0,'2013-12-26 02:32:53',NULL,NULL),(7762,1350,'47696','834','00','005010X220A1','47696','','2013-10-20','20:37:57',0,'2013-12-26 05:01:16',NULL,NULL),(7133,1236,'230966','834','00','005010X220A1','230966','','2013-12-18','17:20:45',0,'2013-12-26 04:04:34',NULL,NULL),(7475,1296,'1275465','834','00','005010X220A1','1275465','','2013-12-21','15:41:54',0,'2013-12-26 04:33:08',NULL,NULL),(17590,3238,'2391659','834','00','005010X220A1','2391659','','2014-02-02','23:41:34',0,'2014-02-03 21:00:52',NULL,NULL),(21103,3993,'3590321','834','00','005010X220A1','3590321','','2014-02-24','17:27:56',0,'2014-02-26 09:31:08',NULL,NULL),(23455,4410,'3103403','834','00','005010X220A1','3103403','','2014-03-09','15:15:37',0,'2014-03-09 21:00:55',NULL,NULL),(14751,2551,'1984509','834','00','005010X220A1','1984509','','2014-01-13','18:54:24',0,'2014-01-15 02:06:24',NULL,NULL),(13455,2224,'2094110','834','00','005010X220A1','2094110','','2014-01-06','14:46:54',0,'2014-01-07 04:02:56',NULL,NULL),(2576,472,'204407','834','00','005010X220A1','204407','','2013-11-01','16:50:00',0,'2013-12-25 20:45:11',NULL,NULL),(12999,1739,'2313840','834','00','005010X220A1','2313840','','2014-01-04','11:06:41',0,'2014-01-05 00:02:03',NULL,NULL),(11072,1421,'1669706','834','00','005010X220A1','1669706','','2013-12-23','13:45:25',0,'2013-12-26 13:13:10',NULL,NULL),(4540,825,'1587588','834','00','005010X220A1','1587588','','2013-12-23','21:28:33',0,'2013-12-25 23:45:20',NULL,NULL),(10534,1401,'1226403','834','00','005010X220A1','1226403','','2013-12-23','15:24:05',0,'2013-12-26 12:54:56',NULL,NULL),(21780,4091,'3629588','834','00','005010X220A1','3629588','','2014-02-28','13:43:53',0,'2014-02-28 21:31:08',NULL,NULL),(14455,2476,'0001','999','BE','005010X231A1','552185','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:29',NULL,NULL),(5643,1048,'1593707','834','00','005010X220A1','1593707','','2013-12-24','23:29:19',0,'2013-12-26 01:51:05',NULL,NULL),(13202,2046,'0001','999','BE','005010X231A1','54340','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:58',NULL,NULL),(1212,243,'1769022','834','00','005010X220A1','1769022','','2013-12-24','07:56:31',0,'2013-12-25 18:48:08',NULL,NULL),(1258,243,'1713858','834','00','005010X220A1','1713858','','2013-12-24','13:07:35',0,'2013-12-25 18:49:27',NULL,NULL),(1531,260,'2065185','834','00','005010X220A1','2065185','','2013-12-24','17:01:20',0,'2013-12-25 18:58:23',NULL,NULL),(12389,1637,'1485038','834','00','005010X220A1','1485038','','2013-12-31','09:41:15',1,'2014-01-02 04:29:17',NULL,NULL),(11882,1560,'513548','834','00','005010X220A1','513548','','2013-12-29','15:03:11',0,'2013-12-30 00:00:27',NULL,NULL),(7651,1312,'342495','834','00','005010X220A1','342495','','2013-12-20','23:29:12',0,'2013-12-26 04:38:53',NULL,NULL),(10533,1401,'1702365','834','00','005010X220A1','1702365','','2013-12-23','14:05:36',0,'2013-12-26 12:54:54',NULL,NULL),(10887,1409,'191566','834','00','005010X220A1','191566','','2013-12-22','19:15:32',0,'2013-12-26 13:07:11',NULL,NULL),(16685,3062,'1541294','834','00','005010X220A1','1541294','','2014-01-27','12:27:00',0,'2014-01-27 21:00:34',NULL,NULL),(17720,3261,'2150146','834','00','005010X220A1','2150146','','2014-02-04','14:05:40',0,'2014-02-04 21:00:41',NULL,NULL),(18715,3485,'2214796','834','00','005010X220A1','2214796','','2014-02-10','20:37:37',0,'2014-02-11 21:00:11',NULL,NULL),(21326,4019,'3545024','834','00','005010X220A1','3545024','','2014-02-26','16:31:03',0,'2014-02-26 21:02:45',NULL,NULL),(22159,4180,'2730308','834','00','005010X220A1','2730308','','2014-03-03','10:34:57',0,'2014-03-03 21:31:01',NULL,NULL),(22746,4276,'3255881','834','00','005010X220A1','3255881','','2014-03-06','12:22:54',0,'2014-03-06 21:00:26',NULL,NULL),(5170,947,'12895','834','00','005010X220A1','12895','','2013-12-10','19:22:05',0,'2013-12-26 00:51:23',NULL,NULL),(14978,2573,'1750470','834','00','005010X220A1','1750470','','2014-01-14','12:07:04',0,'2014-01-15 02:08:05',NULL,NULL),(411,77,'1201394','834','00','005010X220A1','1201394','','2013-12-04','12:21:27',0,'2013-12-25 17:48:44',NULL,NULL),(7629,1308,'83788','834','00','005010X220A1','83788','','2013-12-21','15:57:06',0,'2013-12-26 04:38:12',NULL,NULL),(19127,3547,'1974085','834','00','005010X220A1','1974085','','2014-02-12','15:12:03',0,'2014-02-12 21:31:55',NULL,NULL),(20765,3906,'2642606','834','00','005010X220A1','2642606','','2014-02-25','11:41:05',0,'2014-02-25 21:30:31',NULL,NULL),(23225,4356,'2663632','834','00','005010X220A1','2663632','','2014-03-07','07:31:43',0,'2014-03-07 21:32:03',NULL,NULL),(14409,2430,'0001','999','BE','005010X231A1','1203839','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:22',NULL,NULL),(614,108,'74185','834','00','005010X220A1','74185','','2013-12-15','23:28:27',0,'2013-12-25 18:04:02',NULL,NULL),(5896,1110,'149285','834','00','005010X220A1','149285','','2013-12-15','11:58:14',0,'2013-12-26 02:30:38',NULL,NULL),(13551,2244,'1608940','834','00','005010X220A1','1608940','','2014-01-06','16:18:44',0,'2014-01-07 04:06:29',NULL,NULL),(16548,3023,'1826290','834','00','005010X220A1','1826290','','2014-01-24','13:39:15',0,'2014-01-24 21:01:11',NULL,NULL),(17045,3122,'1845258','834','00','005010X220A1','1845258','','2014-01-29','13:00:49',0,'2014-01-29 21:01:23',NULL,NULL),(17894,3295,'1528472','834','00','005010X220A1','1528472','','2014-02-04','20:09:50',0,'2014-02-05 21:30:28',NULL,NULL),(20212,3781,'3051802','834','00','005010X220A1','3051802','','2014-02-19','14:25:47',0,'2014-02-20 04:21:00',NULL,NULL),(6196,1167,'1034020','834','00','005010X220A1','1034020','','2013-12-20','18:27:44',0,'2013-12-26 03:04:12',NULL,NULL),(5347,1003,'518236','834','00','005010X220A1','518236','','2013-11-25','11:53:45',0,'2013-12-26 01:15:44',NULL,NULL),(4987,935,'1093371','834','00','005010X220A1','1093371','','2013-12-10','22:55:48',0,'2013-12-26 00:45:34',NULL,NULL),(3141,553,'199036','834','00','005010X220A1','199036','','2013-12-13','16:12:53',0,'2013-12-25 21:37:26',NULL,NULL),(2209,365,'1259921','834','00','005010X220A1','1259921','','2013-12-02','18:07:44',0,'2013-12-25 19:48:28',NULL,NULL),(18168,3350,'2990297','834','00','005010X220A1','2990297','','2014-02-07','15:52:25',0,'2014-02-07 19:00:13',NULL,NULL),(20236,3791,'2887092','834','00','005010X220A1','2887092','','2014-02-18','21:01:21',0,'2014-02-20 04:28:51',NULL,NULL),(21320,4013,'3532361','834','00','005010X220A1','3532361','','2014-02-26','17:02:39',0,'2014-02-26 21:02:41',NULL,NULL),(7222,1241,'235583','834','00','005010X220A1','235583','','2013-12-18','14:24:03',0,'2013-12-26 04:07:17',NULL,NULL),(14182,2365,'1540895','834','00','005010X220A1','1540895','','2014-01-09','21:06:06',0,'2014-01-13 02:23:30',NULL,NULL),(13923,2314,'1751704','834','00','005010X220A1','1751704','','2014-01-08','22:34:21',0,'2014-01-13 02:19:59',NULL,NULL),(1949,326,'162011','834','00','005010X220A1','162011','','2013-12-09','11:59:10',0,'2013-12-25 19:33:12',NULL,NULL),(4509,811,'1018311','834','00','005010X220A1','1018311','','2013-11-25','22:45:23',0,'2013-12-25 23:32:20',NULL,NULL),(17788,3269,'2285141','834','00','005010X220A1','2285141','','2014-02-03','21:39:17',0,'2014-02-04 21:01:24',NULL,NULL),(17829,3278,'2443336','834','00','005010X220A1','2443336','','2014-02-04','17:16:40',0,'2014-02-04 21:01:53',NULL,NULL),(20069,3758,'3022164','834','00','005010X220A1','3022164','','2014-02-18','10:22:03',0,'2014-02-18 22:01:23',NULL,NULL),(22640,4253,'3263065','834','00','005010X220A1','3263065','','2014-03-05','10:46:01',0,'2014-03-05 21:31:46',NULL,NULL),(12692,1674,'1597500','834','00','005010X220A1','1597500','','2014-01-02','14:54:37',0,'2014-01-03 02:04:28',NULL,NULL),(440,81,'816852','834','00','005010X220A1','816852','','2013-12-03','22:51:37',0,'2013-12-25 17:49:38',NULL,NULL),(3819,668,'699723','834','00','005010X220A1','699723','','2013-12-08','09:25:53',0,'2013-12-25 22:17:00',NULL,NULL),(4120,733,'459160','834','00','005010X220A1','459160','','2013-12-19','13:42:44',0,'2013-12-25 23:03:50',NULL,NULL),(4666,831,'705243','834','00','005010X220A1','705243','','2013-12-23','22:29:16',0,'2013-12-25 23:49:25',NULL,NULL),(18128,3334,'2128726','834','00','005010X220A1','2128726','','2014-02-06','15:40:52',0,'2014-02-06 21:01:36',NULL,NULL),(20470,3842,'3217021','834','00','005010X220A1','3217021','','2014-02-20','14:05:05',0,'2014-02-20 22:00:39',NULL,NULL),(21506,4031,'2937704','834','00','005010X220A1','2937704','','2014-02-26','19:30:46',0,'2014-02-28 06:31:24',NULL,NULL),(21585,4056,'3510341','834','00','005010X220A1','3510341','','2014-02-26','13:08:35',0,'2014-02-28 07:00:26',NULL,NULL),(104,4,'649942','834','00','005010X220A1','649942','','2013-12-05','15:26:28',0,'2013-12-25 17:18:08',NULL,NULL),(3520,615,'968227','834','00','005010X220A1','968227','','2013-12-12','17:38:27',0,'2013-12-25 22:01:49',NULL,NULL),(7680,1324,'818714','834','00','005010X220A1','818714','','2013-12-21','13:35:29',0,'2013-12-26 04:39:50',NULL,NULL),(13421,2222,'1567816','834','00','005010X220A1','1567816','','2014-01-06','16:45:46',0,'2014-01-07 04:01:36',NULL,NULL),(13390,2221,'2054650','834','00','005010X220A1','2054650','','2014-01-06','16:18:44',0,'2014-01-07 04:00:31',NULL,NULL),(13342,2186,'0001','999','BE','005010X231A1','54340','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:09',NULL,NULL),(18027,3318,'2436824','834','00','005010X220A1','2436824','','2014-02-06','14:53:17',0,'2014-02-06 21:00:26',NULL,NULL),(19835,3684,'2856077','834','00','005010X220A1','2856077','','2014-02-15','10:59:54',0,'2014-02-15 22:01:52',NULL,NULL),(22302,4201,'2825859','834','00','005010X220A1','2825859','','2014-03-04','10:27:22',0,'2014-03-04 21:01:00',NULL,NULL),(22345,4204,'3283230','834','00','005010X220A1','3283230','','2014-03-04','10:56:36',0,'2014-03-04 21:01:33',NULL,NULL),(12142,1591,'1555058','834','00','005010X220A1','1555058','','2013-12-29','21:40:30',0,'2014-01-01 12:07:11',NULL,NULL),(1601,281,'321456','834','00','005010X220A1','321456','','2013-11-19','22:59:35',0,'2013-12-25 19:01:14',NULL,NULL),(7429,1295,'1115815','834','00','005010X220A1','1115815','','2013-12-21','12:42:27',0,'2013-12-26 04:31:46',NULL,NULL),(7087,1236,'882934','834','00','005010X220A1','882934','','2013-12-18','10:45:20',0,'2013-12-26 04:03:14',NULL,NULL),(4615,827,'1705884','834','00','005010X220A1','1705884','','2013-12-23','21:37:05',0,'2013-12-25 23:47:42',NULL,NULL),(4564,825,'1076068','834','00','005010X220A1','1076068','','2013-12-24','01:38:08',0,'2013-12-25 23:46:08',NULL,NULL),(16901,3102,'1668069','834','00','005010X220A1','1668069','','2014-01-28','11:32:39',0,'2014-01-28 21:01:14',NULL,NULL),(17454,3208,'1377343','834','00','005010X220A1','1377343','','2014-02-01','14:09:18',0,'2014-02-01 19:00:44',NULL,NULL),(17540,3235,'2280223','834','00','005010X220A1','2280223','','2014-02-03','16:27:50',0,'2014-02-03 21:00:20',NULL,NULL),(17694,3260,'1725712','834','00','005010X220A1','1725712','','2014-02-04','15:46:13',0,'2014-02-04 21:00:27',NULL,NULL),(19735,3673,'3285094','834','00','005010X220A1','3285094','','2014-02-15','10:07:32',0,'2014-02-15 22:00:33',NULL,NULL),(19897,3713,'3150037','834','00','005010X220A1','3150037','','2014-02-16','15:26:31',0,'2014-02-16 19:00:36',NULL,NULL),(20376,3824,'2493271','834','00','005010X220A1','2493271','','2014-02-19','09:54:00',0,'2014-02-20 05:35:19',NULL,NULL),(7345,1280,'143475','834','00','005010X220A1','143475','','2013-11-29','18:42:16',0,'2013-12-26 04:15:19',NULL,NULL),(14264,2375,'1408509','834','00','005010X220A1','1408509','','2014-01-10','11:21:42',0,'2014-01-13 03:00:06',NULL,NULL),(10853,1406,'1402940','834','00','005010X220A1','1402940','','2013-12-23','11:05:51',0,'2013-12-26 13:05:36',NULL,NULL),(10666,1403,'1109619','834','00','005010X220A1','1109619','','2013-12-22','18:50:44',0,'2013-12-26 12:59:18',NULL,NULL),(3624,621,'1212875','834','00','005010X220A1','1212875','','2013-12-12','17:36:30',0,'2013-12-25 22:05:04',NULL,NULL),(4170,734,'1017941','834','00','005010X220A1','1017941','','2013-12-19','10:26:52',0,'2013-12-25 23:05:16',NULL,NULL),(16878,3093,'1846343','834','00','005010X220A1','1846343','','2014-01-28','17:10:01',0,'2014-01-28 21:00:58',NULL,NULL),(14084,2341,'1706347','834','00','005010X220A1','1706347','','2014-01-08','10:52:16',0,'2014-01-13 02:21:59',NULL,NULL),(4065,732,'9062','834','00','005010X220A1','9062','','2013-12-18','19:52:11',0,'2013-12-25 23:02:10',NULL,NULL),(4046,731,'507912','834','00','005010X220A1','507912','','2013-12-19','17:25:58',0,'2013-12-25 23:01:33',NULL,NULL),(13833,2303,'2472448','834','00','005010X220A1','2472448','','2014-01-11','10:57:06',0,'2014-01-13 02:18:37',NULL,NULL),(10514,1401,'1464313','834','00','005010X220A1','1464313','','2013-12-22','20:03:27',0,'2013-12-26 12:54:16',NULL,NULL),(2721,503,'300989','834','00','005010X220A1','300989','','2013-12-21','21:49:47',0,'2013-12-25 21:17:51',NULL,NULL),(16065,2773,'1479897','834','00','005010X220A1','1479897','','2014-01-22','16:34:53',0,'2014-01-23 03:02:43',NULL,NULL),(16480,3010,'2592994','834','00','005010X220A1','2592994','','2014-01-24','11:26:22',0,'2014-01-24 21:00:29',NULL,NULL),(17741,3262,'2854726','834','00','005010X220A1','2854726','','2014-02-04','08:24:49',0,'2014-02-04 21:00:55',NULL,NULL),(21642,4071,'2655623','834','00','005010X220A1','2655623','','2014-02-27','14:33:35',0,'2014-02-28 07:30:33',NULL,NULL),(22319,4201,'3105715','834','00','005010X220A1','3105715','','2014-03-04','17:40:41',0,'2014-03-04 21:01:12',NULL,NULL),(23640,4441,'3398245','834','00','005010X220A1','3398245','','2014-03-10','14:04:36',0,'2014-03-10 21:01:44',NULL,NULL),(15157,2588,'1954478','834','00','005010X220A1','1954478','','2014-01-15','13:14:16',0,'2014-01-16 08:45:58',NULL,NULL),(14729,2550,'1791287','834','00','005010X220A1','1791287','','2014-01-14','14:01:13',0,'2014-01-15 02:06:14',NULL,NULL),(13883,2312,'1548628','834','00','005010X220A1','1548628','','2014-01-09','16:34:33',0,'2014-01-13 02:19:35',NULL,NULL),(4943,920,'295293','834','00','005010X220A1','295293','','2013-11-19','10:15:53',0,'2013-12-26 00:31:32',NULL,NULL),(12452,1639,'2041812','834','00','005010X220A1','2041812','','2013-12-31','10:07:43',1,'2014-01-02 04:31:35',NULL,NULL),(11076,1421,'745990','834','00','005010X220A1','745990','','2013-12-23','17:12:09',0,'2013-12-26 13:13:19',NULL,NULL),(2130,360,'791802','834','00','005010X220A1','791802','','2013-12-02','17:26:39',0,'2013-12-25 19:45:50',NULL,NULL),(3194,578,'786871','834','00','005010X220A1','786871','','2013-12-16','18:46:57',0,'2013-12-25 21:45:07',NULL,NULL),(16326,2983,'2597825','834','00','005010X220A1','2597825','','2014-01-22','19:41:15',0,'2014-01-23 21:00:33',NULL,NULL),(17326,3175,'1606126','834','00','005010X220A1','1606126','','2014-01-31','12:38:11',0,'2014-01-31 21:00:59',NULL,NULL),(17577,3237,'1655636','834','00','005010X220A1','1655636','','2014-02-02','22:39:08',0,'2014-02-03 21:00:43',NULL,NULL),(21222,3998,'3690690','834','00','005010X220A1','3690690','','2014-02-26','16:40:50',0,'2014-02-26 21:01:31',NULL,NULL),(22782,4277,'3019916','834','00','005010X220A1','3019916','','2014-03-06','13:18:49',0,'2014-03-06 21:00:52',NULL,NULL),(23675,4445,'3051298','834','00','005010X220A1','3051298','','2014-03-10','14:22:27',0,'2014-03-10 21:02:09',NULL,NULL),(15607,2664,'1369392','834','00','005010X220A1','1369392','','2014-01-17','11:29:51',0,'2014-01-20 08:06:31',NULL,NULL),(12657,1672,'2518559','834','00','005010X220A1','2518559','','2014-01-02','17:52:03',0,'2014-01-03 02:03:12',NULL,NULL),(7045,1235,'125326','834','00','005010X220A1','125326','','2013-12-18','16:30:48',0,'2013-12-26 04:01:52',NULL,NULL),(3317,584,'583296','834','00','005010X220A1','583296','','2013-12-17','16:10:11',0,'2013-12-25 21:49:05',NULL,NULL),(3618,621,'842871','834','00','005010X220A1','842871','','2013-12-12','13:09:50',0,'2013-12-25 22:04:54',NULL,NULL),(10770,1404,'990605','834','00','005010X220A1','990605','','2013-12-22','22:42:43',0,'2013-12-26 13:02:55',NULL,NULL),(17301,3172,'2577791','834','00','005010X220A1','2577791','','2014-01-31','17:55:37',0,'2014-01-31 21:00:41',NULL,NULL),(19320,3583,'2350209','834','00','005010X220A1','2350209','','2014-02-13','11:00:29',0,'2014-02-13 22:01:30',NULL,NULL),(21361,4024,'3427320','834','00','005010X220A1','3427320','','2014-02-26','20:05:01',0,'2014-02-28 06:30:17',NULL,NULL),(22237,4199,'3194742','834','00','005010X220A1','3194742','','2014-03-03','21:44:01',0,'2014-03-04 21:00:10',NULL,NULL),(54,3,'1348920','834','00','005010X220A1','1348920','','2013-12-05','09:47:40',0,'2013-12-25 17:16:38',NULL,NULL),(15364,2624,'2380036','834','00','005010X220A1','2380036','','2014-01-15','21:02:07',0,'2014-01-17 03:35:29',NULL,NULL),(4176,734,'402346','834','00','005010X220A1','402346','','2013-12-19','11:24:58',0,'2013-12-25 23:05:27',NULL,NULL),(7299,1260,'802354','834','00','005010X220A1','802354','','2013-12-18','10:44:17',0,'2013-12-26 04:09:41',NULL,NULL),(16459,3006,'1569656','834','00','005010X220A1','1569656','','2014-01-24','13:34:34',0,'2014-01-24 21:00:17',NULL,NULL),(18369,3406,'2781325','834','00','005010X220A1','2781325','','2014-02-09','08:05:38',0,'2014-02-09 19:00:14',NULL,NULL),(18599,3456,'2232627','834','00','005010X220A1','2232627','','2014-02-09','22:06:55',0,'2014-02-10 21:31:03',NULL,NULL),(18880,3496,'2378240','834','00','005010X220A1','2378240','','2014-02-11','11:25:52',0,'2014-02-11 21:02:18',NULL,NULL),(16,1,'63364','834','00','005010X220A1','63364','','2013-12-05','10:55:06',0,'2013-12-25 17:15:30',NULL,NULL),(12958,1734,'1612957','834','00','005010X220A1','1612957','','2014-01-03','21:18:41',0,'2014-01-05 00:00:39',NULL,NULL),(12622,1671,'2347660','834','00','005010X220A1','2347660','','2014-01-02','15:00:07',0,'2014-01-03 02:01:52',NULL,NULL),(1798,304,'1088001','834','00','005010X220A1','1088001','','2013-12-09','23:16:19',0,'2013-12-25 19:19:35',NULL,NULL),(3505,615,'282469','834','00','005010X220A1','282469','','2013-12-12','14:48:16',0,'2013-12-25 22:01:23',NULL,NULL),(5990,1126,'670753','834','00','005010X220A1','670753','','2013-12-15','10:45:38',0,'2013-12-26 02:33:38',NULL,NULL),(12352,1634,'2034134','834','00','005010X220A1','2034134','','2013-12-31','13:46:15',1,'2014-01-02 04:27:57',NULL,NULL),(11769,1528,'1774400','834','00','005010X220A1','1774400','','2013-12-27','18:38:47',1,'2013-12-29 11:09:59',NULL,NULL),(14752,2551,'1728017','834','00','005010X220A1','1728017','','2014-01-13','18:58:25',0,'2014-01-15 02:06:24',NULL,NULL),(14865,2555,'2096497','834','00','005010X220A1','2096497','','2014-01-13','19:59:18',0,'2014-01-15 02:07:13',NULL,NULL),(18053,3319,'2917320','834','00','005010X220A1','2917320','','2014-02-06','14:48:38',0,'2014-02-06 21:00:44',NULL,NULL),(19575,3628,'2276677','834','00','005010X220A1','2276677','','2014-02-13','18:52:33',0,'2014-02-14 21:31:20',NULL,NULL),(19659,3651,'3003950','834','00','005010X220A1','3003950','','2014-02-14','17:37:22',0,'2014-02-14 21:32:21',NULL,NULL),(21362,4024,'3613766','834','00','005010X220A1','3613766','','2014-02-26','23:02:06',0,'2014-02-28 06:30:17',NULL,NULL),(22660,4254,'2622175','834','00','005010X220A1','2622175','','2014-03-05','10:03:38',0,'2014-03-05 21:31:59',NULL,NULL),(22967,4313,'3594562','834','00','005010X220A1','3594562','','2014-03-06','11:29:16',0,'2014-03-06 21:30:09',NULL,NULL),(11734,1520,'1637885','834','00','005010X220A1','1637885','','2013-12-28','00:35:40',1,'2013-12-29 11:08:57',NULL,NULL),(10549,1402,'1537568','834','00','005010X220A1','1537568','','2013-12-22','19:47:46',0,'2013-12-26 12:55:31',NULL,NULL),(1029,194,'94496','834','00','005010X220A1','94496','','2013-12-03','10:01:09',0,'2013-12-25 18:21:09',NULL,NULL),(17477,3218,'2757143','834','00','005010X220A1','2757143','','2014-02-02','15:19:52',0,'2014-02-02 19:00:11',NULL,NULL),(5509,1041,'1629504','834','00','005010X220A1','1629504','','2013-12-24','20:22:13',0,'2013-12-26 01:46:43',NULL,NULL),(482,98,'401843','834','00','005010X220A1','401843','','2013-12-04','17:16:06',0,'2013-12-25 17:51:04',NULL,NULL),(846,175,'766858','834','00','005010X220A1','766858','','2013-12-03','13:00:06',0,'2013-12-25 18:15:32',NULL,NULL),(12945,1733,'1727797','834','00','005010X220A1','1727797','','2014-01-03','19:08:38',0,'2014-01-05 00:00:10',NULL,NULL),(5312,992,'952566','834','00','005010X220A1','952566','','2013-11-04','19:18:35',0,'2013-12-26 01:01:53',NULL,NULL),(12551,1656,'2530715','834','00','005010X220A1','2530715','','2013-12-31','16:15:31',1,'2014-01-02 04:35:16',NULL,NULL),(6343,1177,'232141','834','00','005010X220A1','232141','','2013-12-20','09:26:45',0,'2013-12-26 03:08:43',NULL,NULL),(6301,1174,'1204391','834','00','005010X220A1','1204391','','2013-12-19','20:48:01',0,'2013-12-26 03:07:26',NULL,NULL),(3200,578,'5610','834','00','005010X220A1','5610','','2013-12-16','21:13:57',0,'2013-12-25 21:45:17',NULL,NULL),(14513,2516,'2200150','834','00','005010X220A1','2200150','','2014-01-13','17:12:20',0,'2014-01-14 01:32:11',NULL,NULL),(17665,3258,'2640880','834','00','005010X220A1','2640880','','2014-02-04','14:10:57',0,'2014-02-04 21:00:08',NULL,NULL),(17762,3262,'1384128','834','00','005010X220A1','1384128','','2014-02-04','15:28:57',0,'2014-02-04 21:01:07',NULL,NULL),(18252,3376,'1524339','834','00','005010X220A1','1524339','','2014-02-07','19:31:49',0,'2014-02-08 19:00:05',NULL,NULL),(20064,3754,'3110110','834','00','005010X220A1','3110110','','2014-02-18','11:45:36',0,'2014-02-18 22:01:19',NULL,NULL),(23401,4403,'3638334','834','00','005010X220A1','3638334','','2014-03-09','17:46:07',0,'2014-03-09 21:00:12',NULL,NULL),(23482,4425,'3467137','834','00','005010X220A1','3467137','','2014-03-09','16:05:39',0,'2014-03-09 21:01:20',NULL,NULL),(2690,502,'829860','834','00','005010X220A1','829860','','2013-12-22','12:10:40',0,'2013-12-25 21:16:51',NULL,NULL),(14360,2404,'2446454','834','00','005010X220A1','2446454','','2014-01-12','10:07:59',0,'2014-01-13 03:01:33',NULL,NULL),(1303,244,'450425','834','00','005010X220A1','450425','','2013-12-24','17:24:03',0,'2013-12-25 18:50:53',NULL,NULL),(2267,386,'830250','834','00','005010X220A1','830250','','2013-10-14','19:54:04',0,'2013-12-25 20:00:02',NULL,NULL),(7216,1241,'286210','834','00','005010X220A1','286210','','2013-12-18','10:53:22',0,'2013-12-26 04:07:07',NULL,NULL),(10381,1400,'164098','834','00','005010X220A1','164098','','2013-12-22','21:38:35',0,'2013-12-26 12:50:07',NULL,NULL),(14047,2338,'1774690','834','00','005010X220A1','1774690','','2014-01-08','14:01:23',0,'2014-01-13 02:21:35',NULL,NULL),(10450,1400,'1239770','834','00','005010X220A1','1239770','','2013-12-23','13:09:55',0,'2013-12-26 12:52:18',NULL,NULL),(15152,2588,'1633347','834','00','005010X220A1','1633347','','2014-01-15','10:25:52',0,'2014-01-16 08:45:55',NULL,NULL),(17800,3270,'1509144','834','00','005010X220A1','1509144','','2014-02-04','15:37:29',0,'2014-02-04 21:01:33',NULL,NULL),(11336,1456,'2083297','834','00','005010X220A1','2083297','','2013-12-26','16:25:41',0,'2013-12-27 02:04:37',NULL,NULL),(628,108,'814548','834','00','005010X220A1','814548','','2013-12-16','11:26:40',0,'2013-12-25 18:04:32',NULL,NULL),(7058,1236,'919714','834','00','005010X220A1','919714','','2013-12-17','19:19:49',0,'2013-12-26 04:02:16',NULL,NULL),(4508,810,'1259858','834','00','005010X220A1','1259858','','2013-11-26','15:25:56',0,'2013-12-25 23:32:19',NULL,NULL),(3592,617,'571266','834','00','005010X220A1','571266','','2013-12-12','16:25:44',0,'2013-12-25 22:04:05',NULL,NULL),(15154,2588,'2527575','834','00','005010X220A1','2527575','','2014-01-15','14:07:53',0,'2014-01-16 08:45:56',NULL,NULL),(16469,3008,'2517643','834','00','005010X220A1','2517643','','2014-01-24','11:03:30',0,'2014-01-24 21:00:23',NULL,NULL),(17165,3145,'2708229','834','00','005010X220A1','2708229','','2014-01-30','02:15:53',0,'2014-01-30 21:00:47',NULL,NULL),(18087,3323,'1727254','834','00','005010X220A1','1727254','','2014-02-06','16:50:37',0,'2014-02-06 21:01:07',NULL,NULL),(20033,3750,'2193516','834','00','005010X220A1','2193516','','2014-02-18','14:28:33',0,'2014-02-18 22:00:55',NULL,NULL),(20310,3795,'3480326','834','00','005010X220A1','3480326','','2014-02-19','13:32:54',0,'2014-02-20 04:45:58',NULL,NULL),(22234,4197,'2944418','834','00','005010X220A1','2944418','','2014-03-03','17:38:11',0,'2014-03-03 21:31:58',NULL,NULL),(23051,4337,'3279236','834','00','005010X220A1','3279236','','2014-03-07','16:24:05',0,'2014-03-07 21:00:36',NULL,NULL),(23159,4344,'3744807','834','00','005010X220A1','3744807','','2014-03-07','09:45:32',0,'2014-03-07 21:31:17',NULL,NULL),(23529,4434,'3039880','834','00','005010X220A1','3039880','','2014-03-10','17:30:21',0,'2014-03-10 21:00:23',NULL,NULL),(14432,2453,'0001','999','BE','005010X231A1','1294753','834','2013-12-28','04:55:00',0,'2014-01-13 03:02:42',NULL,NULL),(46,3,'237598','834','00','005010X220A1','237598','','2013-12-04','18:23:04',0,'2013-12-25 17:16:22',NULL,NULL),(297,70,'1161766','834','00','005010X220A1','1161766','','2013-12-03','18:17:01',0,'2013-12-25 17:45:07',NULL,NULL),(14108,2344,'1542201','834','00','005010X220A1','1542201','','2014-01-08','12:40:08',0,'2014-01-13 02:22:15',NULL,NULL),(13242,2086,'0001','999','BE','005010X231A1','630417','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:49',NULL,NULL),(1904,325,'984119','834','00','005010X220A1','984119','','2013-12-09','13:11:12',0,'2013-12-25 19:31:53',NULL,NULL),(12611,1671,'1830042','834','00','005010X220A1','1830042','','2014-01-02','11:39:22',0,'2014-01-03 02:01:28',NULL,NULL),(12438,1638,'2335181','834','00','005010X220A1','2335181','','2013-12-31','15:42:28',1,'2014-01-02 04:31:03',NULL,NULL),(7427,1295,'40832','834','00','005010X220A1','40832','','2013-12-21','12:39:24',0,'2013-12-26 04:31:43',NULL,NULL),(7661,1316,'327156','834','00','005010X220A1','327156','','2013-12-21','12:45:06',0,'2013-12-26 04:39:10',NULL,NULL),(10557,1402,'299668','834','00','005010X220A1','299668','','2013-12-22','22:23:16',0,'2013-12-26 12:55:46',NULL,NULL),(10937,1410,'1552083','834','00','005010X220A1','1552083','','2013-12-23','13:35:51',0,'2013-12-26 13:08:51',NULL,NULL),(12330,1634,'2202434','834','00','005010X220A1','2202434','','2013-12-31','01:30:57',1,'2014-01-02 04:27:12',NULL,NULL),(17779,3267,'1878466','834','00','005010X220A1','1878466','','2014-02-04','00:19:00',0,'2014-02-04 21:01:19',NULL,NULL),(19110,3544,'2466254','834','00','005010X220A1','2466254','','2014-02-12','16:34:07',0,'2014-02-12 21:31:44',NULL,NULL),(21793,4092,'3379072','834','00','005010X220A1','3379072','','2014-02-28','00:14:09',0,'2014-02-28 21:31:16',NULL,NULL),(1590,280,'345693','834','00','005010X220A1','345693','','2013-11-20','11:43:51',0,'2013-12-25 19:00:56',NULL,NULL),(15891,2740,'2237034','834','00','005010X220A1','2237034','','2014-01-21','17:05:34',1,'2014-01-22 03:22:35',NULL,NULL),(22116,4177,'2799529','834','00','005010X220A1','2799529','','2014-03-03','13:08:39',0,'2014-03-03 21:30:32',NULL,NULL),(22195,4183,'3277895','834','00','005010X220A1','3277895','','2014-03-02','18:29:31',0,'2014-03-03 21:31:28',NULL,NULL),(2923,541,'113370','834','00','005010X220A1','113370','','2013-12-12','18:55:42',0,'2013-12-25 21:30:39',NULL,NULL),(13307,2151,'0001','999','BE','005010X231A1','89853','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:31',NULL,NULL),(11425,1472,'2202332','834','00','005010X220A1','2202332','','2013-12-26','16:07:26',0,'2013-12-27 02:07:21',NULL,NULL),(15214,2593,'2233250','834','00','005010X220A1','2233250','','2014-01-15','13:59:16',0,'2014-01-16 08:46:34',NULL,NULL),(17066,3126,'2287940','834','00','005010X220A1','2287940','','2014-01-29','12:18:51',0,'2014-01-29 21:01:37',NULL,NULL),(19222,3580,'2841789','834','00','005010X220A1','2841789','','2014-02-13','01:12:12',0,'2014-02-13 22:00:11',NULL,NULL),(21138,3996,'3084863','834','00','005010X220A1','3084863','','2014-02-26','12:40:39',0,'2014-02-26 21:00:37',NULL,NULL),(21531,4038,'3286751','834','00','005010X220A1','3286751','','2014-02-27','17:40:11',0,'2014-02-28 06:31:36',NULL,NULL),(22189,4180,'3792615','834','00','005010X220A1','3792615','','2014-03-03','17:33:50',0,'2014-03-03 21:31:23',NULL,NULL),(13944,2318,'2482557','834','00','005010X220A1','2482557','','2014-01-09','09:57:33',0,'2014-01-13 02:20:16',NULL,NULL),(5216,951,'1285670','834','00','005010X220A1','1285670','','2013-12-11','08:50:52',0,'2013-12-26 00:52:54',NULL,NULL),(773,144,'683179','834','00','005010X220A1','683179','','2013-10-31','11:26:20',0,'2013-12-25 18:09:10',NULL,NULL),(12691,1674,'2522134','834','00','005010X220A1','2522134','','2014-01-02','08:19:34',0,'2014-01-03 02:04:25',NULL,NULL),(4177,734,'659978','834','00','005010X220A1','659978','','2013-12-19','11:46:18',0,'2013-12-25 23:05:28',NULL,NULL),(2075,341,'236485','834','00','005010X220A1','236485','','2013-12-09','15:17:46',0,'2013-12-25 19:37:14',NULL,NULL),(16081,2776,'2499169','834','00','005010X220A1','2499169','','2014-01-22','12:47:29',0,'2014-01-23 03:02:50',NULL,NULL),(17744,3262,'2138512','834','00','005010X220A1','2138512','','2014-02-04','10:14:01',0,'2014-02-04 21:00:57',NULL,NULL),(18697,3477,'1931927','834','00','005010X220A1','1931927','','2014-02-10','12:28:53',0,'2014-02-10 21:32:11',NULL,NULL),(23200,4346,'3510722','834','00','005010X220A1','3510722','','2014-03-07','16:34:42',0,'2014-03-07 21:31:46',NULL,NULL),(10861,1407,'1473835','834','00','005010X220A1','1473835','','2013-12-23','09:19:35',0,'2013-12-26 13:05:52',NULL,NULL),(5839,1092,'1216563','834','00','005010X220A1','1216563','','2013-11-23','09:44:29',0,'2013-12-26 02:15:42',NULL,NULL),(4999,935,'1101170','834','00','005010X220A1','1101170','','2013-12-11','09:42:39',0,'2013-12-26 00:45:56',NULL,NULL),(15246,2598,'1393692','834','00','005010X220A1','1393692','','2014-01-15','15:57:05',0,'2014-01-16 08:46:54',NULL,NULL),(15647,2681,'2056413','834','00','005010X220A1','2056413','','2014-01-17','19:53:27',0,'2014-01-21 08:44:22',NULL,NULL),(17719,3261,'2334529','834','00','005010X220A1','2334529','','2014-02-04','13:59:07',0,'2014-02-04 21:00:41',NULL,NULL),(20868,3915,'3111704','834','00','005010X220A1','3111704','','2014-02-25','10:39:15',0,'2014-02-25 21:31:44',NULL,NULL),(7711,1334,'1170493','834','00','005010X220A1','1170493','','2013-11-14','22:52:28',0,'2013-12-26 04:45:51',NULL,NULL),(4243,739,'1266866','834','00','005010X220A1','1266866','','2013-12-19','12:31:00',0,'2013-12-25 23:07:35',NULL,NULL),(5751,1070,'1242046','834','00','005010X220A1','1242046','','2013-12-14','16:36:53',0,'2013-12-26 02:01:54',NULL,NULL),(1981,327,'1157395','834','00','005010X220A1','1157395','','2013-12-08','22:49:51',0,'2013-12-25 19:34:13',NULL,NULL),(3677,629,'752725','834','00','005010X220A1','752725','','2013-12-12','11:10:08',0,'2013-12-25 22:06:44',NULL,NULL),(3121,547,'1059516','834','00','005010X220A1','1059516','','2013-12-13','16:11:37',0,'2013-12-25 21:36:48',NULL,NULL),(2999,542,'703196','834','00','005010X220A1','703196','','2013-12-13','14:52:56',0,'2013-12-25 21:33:06',NULL,NULL),(18409,3416,'3021916','834','00','005010X220A1','3021916','','2014-02-09','13:33:36',0,'2014-02-09 19:00:42',NULL,NULL),(18515,3449,'2480980','834','00','005010X220A1','2480980','','2014-02-10','15:14:05',0,'2014-02-10 21:00:12',NULL,NULL),(18537,3451,'2396023','834','00','005010X220A1','2396023','','2014-02-10','16:07:25',0,'2014-02-10 21:30:20',NULL,NULL),(20116,3772,'3263696','834','00','005010X220A1','3263696','','2014-02-18','23:05:30',0,'2014-02-20 03:50:00',NULL,NULL),(23253,4370,'2953346','834','00','005010X220A1','2953346','','2014-03-07','13:34:12',0,'2014-03-07 21:32:25',NULL,NULL),(23542,4435,'3495084','834','00','005010X220A1','3495084','','2014-03-10','13:01:13',0,'2014-03-10 21:00:33',NULL,NULL),(3033,544,'960670','834','00','005010X220A1','960670','','2013-12-13','09:23:46',0,'2013-12-25 21:34:06',NULL,NULL),(5015,935,'373983','834','00','005010X220A1','373983','','2013-12-11','11:22:08',0,'2013-12-26 00:46:27',NULL,NULL),(19367,3590,'2490810','834','00','005010X220A1','2490810','','2014-02-12','22:45:59',0,'2014-02-13 22:02:05',NULL,NULL),(19553,3626,'1870919','834','00','005010X220A1','1870919','','2014-02-13','23:53:19',0,'2014-02-14 21:31:03',NULL,NULL),(20047,3751,'3556683','834','00','005010X220A1','3556683','','2014-02-18','13:19:10',0,'2014-02-18 22:01:06',NULL,NULL),(15164,2588,'1786430','834','00','005010X220A1','1786430','','2014-01-15','17:12:45',0,'2014-01-16 08:46:03',NULL,NULL),(14397,2419,'1442674','834','00','005010X220A1','1442674','','2014-01-12','15:56:08',0,'2014-01-13 03:02:00',NULL,NULL),(13608,2264,'1490013','834','00','005010X220A1','1490013','','2014-01-04','20:12:23',1,'2014-01-07 10:23:10',NULL,NULL),(4053,731,'1061955','834','00','005010X220A1','1061955','','2013-12-19','18:17:16',0,'2013-12-25 23:01:46',NULL,NULL),(2928,541,'776693','834','00','005010X220A1','776693','','2013-12-12','20:16:19',0,'2013-12-25 21:30:51',NULL,NULL),(12750,1690,'1404643','834','00','005010X220A1','1404643','','2014-01-02','13:08:08',0,'2014-01-03 02:06:41',NULL,NULL),(2876,519,'950861','834','00','005010X220A1','950861','','2013-12-22','15:32:45',0,'2013-12-25 21:22:50',NULL,NULL),(7122,1236,'254511','834','00','005010X220A1','254511','','2013-12-18','15:42:15',0,'2013-12-26 04:04:16',NULL,NULL),(11283,1455,'54075','834','00','005010X220A1','54075','','2013-12-26','13:56:54',0,'2013-12-27 02:02:58',NULL,NULL),(18401,3413,'1966331','834','00','005010X220A1','1966331','','2014-02-09','12:17:39',0,'2014-02-09 19:00:36',NULL,NULL),(20121,3772,'3589111','834','00','005010X220A1','3589111','','2014-02-19','09:38:05',0,'2014-02-20 03:52:46',NULL,NULL),(20206,3781,'3600266','834','00','005010X220A1','3600266','','2014-02-19','11:34:08',0,'2014-02-20 04:19:34',NULL,NULL),(22396,4212,'3650744','834','00','005010X220A1','3650744','','2014-03-04','13:41:42',0,'2014-03-04 21:02:16',NULL,NULL),(2383,414,'898108','834','00','005010X220A1','898108','','2013-12-06','17:14:03',0,'2013-12-25 20:16:42',NULL,NULL),(12800,1703,'1799763','834','00','005010X220A1','1799763','','2014-01-03','12:16:07',0,'2014-01-04 02:01:15',NULL,NULL),(342,72,'534285','834','00','005010X220A1','534285','','2013-12-03','19:20:04',0,'2013-12-25 17:46:31',NULL,NULL),(22692,4259,'3011844','834','00','005010X220A1','3011844','','2014-03-05','12:09:04',0,'2014-03-05 21:32:22',NULL,NULL),(22896,4284,'3854845','834','00','005010X220A1','3854845','','2014-03-06','13:42:37',0,'2014-03-06 21:02:12',NULL,NULL),(22925,4291,'2985828','834','00','005010X220A1','2985828','','2014-03-06','11:41:00',0,'2014-03-06 21:02:34',NULL,NULL),(23180,4345,'3279204','834','00','005010X220A1','3279204','','2014-03-07','08:55:08',0,'2014-03-07 21:31:32',NULL,NULL),(11,1,'441053','834','00','005010X220A1','441053','','2013-12-05','09:39:57',0,'2013-12-25 17:15:21',NULL,NULL),(7125,1236,'401272','834','00','005010X220A1','401272','','2013-12-18','16:05:45',0,'2013-12-26 04:04:21',NULL,NULL),(13248,2092,'0001','999','BE','005010X231A1','848292','834','2013-12-27','16:55:00',0,'2014-01-05 17:02:06',NULL,NULL),(12684,1673,'1441031','834','00','005010X220A1','1441031','','2014-01-02','15:18:01',0,'2014-01-03 02:04:07',NULL,NULL),(12005,1583,'1316575','834','00','005010X220A1','1316575','','2013-12-29','19:02:07',0,'2014-01-01 12:02:16',NULL,NULL),(11379,1462,'2077219','834','00','005010X220A1','2077219','','2013-12-26','08:28:59',0,'2013-12-27 02:05:55',NULL,NULL),(1593,281,'67015','834','00','005010X220A1','67015','','2013-11-19','22:58:05',0,'2013-12-25 19:01:02',NULL,NULL),(10791,1404,'599112','834','00','005010X220A1','599112','','2013-12-23','12:34:33',0,'2013-12-26 13:03:35',NULL,NULL),(1754,293,'181031','834','00','005010X220A1','181031','','2013-12-10','16:55:58',0,'2013-12-25 19:18:06',NULL,NULL),(10482,1400,'748401','834','00','005010X220A1','748401','','2013-12-23','15:57:39',0,'2013-12-26 12:53:19',NULL,NULL),(1994,329,'594669','834','00','005010X220A1','594669','','2013-12-08','20:25:40',0,'2013-12-25 19:34:37',NULL,NULL),(19351,3584,'2728470','834','00','005010X220A1','2728470','','2014-02-13','09:46:29',0,'2014-02-13 22:01:53',NULL,NULL),(15169,2591,'1843578','834','00','005010X220A1','1843578','','2014-01-14','19:51:19',0,'2014-01-16 08:46:07',NULL,NULL),(4878,889,'665663','834','00','005010X220A1','665663','','2013-11-21','15:20:54',0,'2013-12-26 00:16:33',NULL,NULL),(13116,1960,'0001','999','BE','005010X231A1','615635','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:23',NULL,NULL),(932,181,'804047','834','00','005010X220A1','804047','','2013-12-02','19:40:32',0,'2013-12-25 18:18:05',NULL,NULL),(12959,1734,'2407657','834','00','005010X220A1','2407657','','2014-01-03','21:39:35',0,'2014-01-05 00:00:42',NULL,NULL),(12861,1706,'2384846','834','00','005010X220A1','2384846','','2014-01-03','10:07:20',0,'2014-01-04 02:03:28',NULL,NULL),(2048,335,'1019942','834','00','005010X220A1','1019942','','2013-12-09','10:48:43',0,'2013-12-25 19:36:20',NULL,NULL),(10818,1404,'783176','834','00','005010X220A1','783176','','2013-12-23','16:33:33',0,'2013-12-26 13:04:27',NULL,NULL),(16191,2883,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:36:00',1,'2014-01-23 04:33:10',NULL,NULL),(20488,3844,'2560481','834','00','005010X220A1','2560481','','2014-02-20','16:12:28',0,'2014-02-20 22:00:55',NULL,NULL),(21658,4077,'2572000','834','00','005010X220A1','2572000','','2014-02-27','20:43:00',0,'2014-02-28 21:00:06',NULL,NULL),(22808,4278,'3761959','834','00','005010X220A1','3761959','','2014-03-05','20:28:54',0,'2014-03-06 21:01:09',NULL,NULL),(22997,4322,'3428983','834','00','005010X220A1','3428983','','2014-03-07','12:33:02',0,'2014-03-07 21:00:10',NULL,NULL),(23362,4391,'2839995','834','00','005010X220A1','2839995','','2014-03-07','22:37:57',0,'2014-03-08 21:31:07',NULL,NULL),(13451,2224,'2013308','834','00','005010X220A1','2013308','','2014-01-06','10:40:33',0,'2014-01-07 04:02:48',NULL,NULL),(6115,1166,'715839','834','00','005010X220A1','715839','','2013-12-20','13:55:10',0,'2013-12-26 03:01:45',NULL,NULL),(13230,2074,'0001','999','BE','005010X231A1','1201205','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:16',NULL,NULL),(653,108,'928831','834','00','005010X220A1','928831','','2013-12-16','16:29:35',0,'2013-12-25 18:05:18',NULL,NULL),(668,109,'349053','834','00','005010X220A1','349053','','2013-12-15','19:46:55',0,'2013-12-25 18:05:43',NULL,NULL),(5074,936,'1212815','834','00','005010X220A1','1212815','','2013-12-11','14:38:00',0,'2013-12-26 00:48:22',NULL,NULL),(1319,245,'688720','834','00','005010X220A1','688720','','2013-12-24','10:49:24',0,'2013-12-25 18:51:25',NULL,NULL),(3911,712,'206200','834','00','005010X220A1','206200','','2013-12-06','20:22:13',0,'2013-12-25 22:45:24',NULL,NULL),(3898,708,'645846','834','00','005010X220A1','645846','','2013-10-26','13:40:04',0,'2013-12-25 22:32:10',NULL,NULL),(2719,503,'1396436','834','00','005010X220A1','1396436','','2013-12-21','20:05:21',0,'2013-12-25 21:17:47',NULL,NULL),(11803,1538,'965029','834','00','005010X220A1','965029','','2013-12-28','20:30:25',1,'2013-12-29 11:13:11',NULL,NULL),(18784,3487,'1922477','834','00','005010X220A1','1922477','','2014-02-10','20:41:17',0,'2014-02-11 21:01:03',NULL,NULL),(19516,3622,'3058795','834','00','005010X220A1','3058795','','2014-02-13','20:59:39',0,'2014-02-14 21:30:36',NULL,NULL),(19792,3677,'3332651','834','00','005010X220A1','3332651','','2014-02-15','08:48:14',0,'2014-02-15 22:01:15',NULL,NULL),(22038,4163,'3090737','834','00','005010X220A1','3090737','','2014-03-03','13:12:44',0,'2014-03-03 21:00:03',NULL,NULL),(22120,4177,'3255735','834','00','005010X220A1','3255735','','2014-03-03','15:18:31',0,'2014-03-03 21:30:34',NULL,NULL),(22525,4247,'2631053','834','00','005010X220A1','2631053','','2014-03-05','14:14:01',0,'2014-03-05 21:30:24',NULL,NULL),(6092,1166,'585776','834','00','005010X220A1','585776','','2013-12-19','22:28:46',0,'2013-12-26 03:01:05',NULL,NULL),(13362,2206,'0001','999','BE','005010X231A1','193275','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:04',NULL,NULL),(13122,1966,'0001','999','BE','005010X231A1','1170605','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:39',NULL,NULL),(1935,326,'703022','834','00','005010X220A1','703022','','2013-12-09','09:33:19',0,'2013-12-25 19:32:46',NULL,NULL),(1831,314,'108276','834','00','005010X220A1','108276','','2013-12-10','16:29:19',0,'2013-12-25 19:20:36',NULL,NULL),(16985,3118,'2057896','834','00','005010X220A1','2057896','','2014-01-28','19:53:58',0,'2014-01-29 21:00:44',NULL,NULL),(16998,3118,'2506472','834','00','005010X220A1','2506472','','2014-01-29','11:39:39',0,'2014-01-29 21:00:53',NULL,NULL),(17164,3145,'2170562','834','00','005010X220A1','2170562','','2014-01-29','18:44:43',0,'2014-01-30 21:00:46',NULL,NULL),(20403,3832,'3512385','834','00','005010X220A1','3512385','','2014-02-20','17:01:37',0,'2014-02-20 21:30:08',NULL,NULL),(13615,2269,'1380807','834','00','005010X220A1','1380807','','2014-01-05','14:57:24',1,'2014-01-07 10:23:32',NULL,NULL),(13396,2221,'1546130','834','00','005010X220A1','1546130','','2014-01-06','17:02:53',0,'2014-01-07 04:00:46',NULL,NULL),(2688,502,'669997','834','00','005010X220A1','669997','','2013-12-22','10:41:13',0,'2013-12-25 21:16:47',NULL,NULL),(12160,1593,'2363923','834','00','005010X220A1','2363923','','2013-12-30','09:00:14',0,'2014-01-01 12:07:47',NULL,NULL),(10464,1400,'329550','834','00','005010X220A1','329550','','2013-12-23','14:06:35',0,'2013-12-26 12:52:43',NULL,NULL),(11429,1474,'845155','834','00','005010X220A1','845155','','2013-12-26','16:26:19',0,'2013-12-27 02:07:29',NULL,NULL),(11728,1520,'94183','834','00','005010X220A1','94183','','2013-12-28','16:57:52',1,'2013-12-29 11:08:44',NULL,NULL),(16623,3050,'2306963','834','00','005010X220A1','2306963','','2014-01-26','15:08:04',0,'2014-01-26 19:00:19',NULL,NULL),(19319,3583,'2266618','834','00','005010X220A1','2266618','','2014-02-13','10:29:07',0,'2014-02-13 22:01:29',NULL,NULL),(6272,1172,'142771','834','00','005010X220A1','142771','','2013-12-20','09:34:42',0,'2013-12-26 03:06:37',NULL,NULL),(5521,1041,'1505479','834','00','005010X220A1','1505479','','2013-12-24','21:13:18',0,'2013-12-26 01:47:03',NULL,NULL),(4030,731,'131280','834','00','005010X220A1','131280','','2013-12-19','14:29:51',0,'2013-12-25 23:01:02',NULL,NULL),(17157,3144,'2568901','834','00','005010X220A1','2568901','','2014-01-30','16:19:08',0,'2014-01-30 21:00:41',NULL,NULL),(20039,3751,'3581544','834','00','005010X220A1','3581544','','2014-02-18','08:28:47',0,'2014-02-18 22:00:59',NULL,NULL),(1704,292,'12881','834','00','005010X220A1','12881','','2013-12-10','11:23:11',0,'2013-12-25 19:16:37',NULL,NULL),(12084,1586,'1463208','834','00','005010X220A1','1463208','','2013-12-30','15:36:25',0,'2014-01-01 12:05:10',NULL,NULL),(4795,865,'237503','834','00','005010X220A1','237503','','2013-12-01','08:22:03',0,'2013-12-26 00:01:44',NULL,NULL),(10779,1404,'730570','834','00','005010X220A1','730570','','2013-12-23','09:14:31',0,'2013-12-26 13:03:12',NULL,NULL),(7139,1237,'1080794','834','00','005010X220A1','1080794','','2013-12-17','18:38:31',0,'2013-12-26 04:04:44',NULL,NULL),(14680,2548,'1811237','834','00','005010X220A1','1811237','','2014-01-14','16:43:11',0,'2014-01-15 02:05:53',NULL,NULL),(15460,2632,'1626016','834','00','005010X220A1','1626016','','2014-01-16','16:00:45',0,'2014-01-17 03:36:13',NULL,NULL),(16286,2978,'0001','999','BE','005010X231A1','775091','834','2014-01-15','11:28:00',0,'2014-01-23 18:00:03',NULL,NULL),(18755,3485,'2582862','834','00','005010X220A1','2582862','','2014-02-11','15:22:56',0,'2014-02-11 21:00:42',NULL,NULL),(19216,3580,'3250385','834','00','005010X220A1','3250385','','2014-02-12','21:29:23',0,'2014-02-13 22:00:05',NULL,NULL),(19779,3675,'3104137','834','00','005010X220A1','3104137','','2014-02-15','11:44:27',0,'2014-02-15 22:01:05',NULL,NULL),(21424,4026,'2908344','834','00','005010X220A1','2908344','','2014-02-27','15:55:38',0,'2014-02-28 06:30:45',NULL,NULL),(13919,2313,'1602832','834','00','005010X220A1','1602832','','2014-01-09','17:30:53',0,'2014-01-13 02:19:56',NULL,NULL),(778,145,'984839','834','00','005010X220A1','984839','','2013-10-28','18:41:18',0,'2013-12-25 18:09:20',NULL,NULL),(13709,2275,'1774633','834','00','005010X220A1','1774633','','2014-01-06','18:47:38',0,'2014-01-08 18:24:33',NULL,NULL),(13588,2257,'1299775','834','00','005010X220A1','1299775','','2014-01-05','15:56:15',1,'2014-01-07 10:22:21',NULL,NULL),(3969,716,'820970','834','00','005010X220A1','820970','','2013-12-07','16:32:27',0,'2013-12-25 22:47:12',NULL,NULL),(15103,2587,'1951896','834','00','005010X220A1','1951896','','2014-01-14','21:54:54',0,'2014-01-16 08:45:22',NULL,NULL),(15284,2612,'1964427','834','00','005010X220A1','1964427','','2014-01-15','16:53:41',0,'2014-01-16 08:47:20',NULL,NULL),(16717,3064,'1849772','834','00','005010X220A1','1849772','','2014-01-27','13:25:36',0,'2014-01-27 21:00:54',NULL,NULL),(16872,3093,'2123306','834','00','005010X220A1','2123306','','2014-01-28','14:34:16',0,'2014-01-28 21:00:55',NULL,NULL),(17685,3259,'2643211','834','00','005010X220A1','2643211','','2014-02-04','16:26:57',0,'2014-02-04 21:00:21',NULL,NULL),(17989,3312,'2536449','834','00','005010X220A1','2536449','','2014-02-05','12:06:58',0,'2014-02-05 21:31:16',NULL,NULL),(22681,4255,'3486606','834','00','005010X220A1','3486606','','2014-03-05','16:35:21',0,'2014-03-05 21:32:14',NULL,NULL),(5377,1010,'1214003','834','00','005010X220A1','1214003','','2013-11-25','12:08:47',0,'2013-12-26 01:16:47',NULL,NULL),(13222,2066,'0001','999','BE','005010X231A1','1003197','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:53',NULL,NULL),(10648,1402,'235988','834','00','005010X220A1','235988','','2013-12-23','18:04:04',0,'2013-12-26 12:58:44',NULL,NULL),(604,107,'306715','834','00','005010X220A1','306715','','2013-12-16','17:13:36',0,'2013-12-25 18:03:43',NULL,NULL),(3698,633,'407808','834','00','005010X220A1','407808','','2013-12-12','12:49:58',0,'2013-12-25 22:07:27',NULL,NULL),(1768,297,'1106340','834','00','005010X220A1','1106340','','2013-12-10','17:43:16',0,'2013-12-25 19:18:33',NULL,NULL),(7255,1246,'417980','834','00','005010X220A1','417980','','2013-12-18','12:04:07',0,'2013-12-26 04:08:21',NULL,NULL),(7120,1236,'948079','834','00','005010X220A1','948079','','2013-12-18','15:29:01',0,'2013-12-26 04:04:12',NULL,NULL),(7143,1237,'577860','834','00','005010X220A1','577860','','2013-12-18','10:26:02',0,'2013-12-26 04:04:54',NULL,NULL),(16468,3007,'1386264','834','00','005010X220A1','1386264','','2014-01-24','07:20:16',0,'2014-01-24 21:00:22',NULL,NULL),(22127,4179,'3827246','834','00','005010X220A1','3827246','','2014-03-02','19:17:05',0,'2014-03-03 21:30:38',NULL,NULL),(22964,4312,'3442637','834','00','005010X220A1','3442637','','2014-03-06','12:36:09',0,'2014-03-06 21:30:07',NULL,NULL),(8,1,'261803','834','00','005010X220A1','261803','','2013-12-04','23:45:59',0,'2013-12-25 17:15:15',NULL,NULL),(14467,2488,'0001','999','BE','005010X231A1','624169','834','2013-12-28','04:55:00',0,'2014-01-13 03:03:40',NULL,NULL),(2435,418,'823516','834','00','005010X220A1','823516','','2013-12-06','13:19:29',0,'2013-12-25 20:18:19',NULL,NULL),(5019,935,'953008','834','00','005010X220A1','953008','','2013-12-11','11:32:55',0,'2013-12-26 00:46:34',NULL,NULL),(3216,578,'1127544','834','00','005010X220A1','1127544','','2013-12-17','09:31:10',0,'2013-12-25 21:45:49',NULL,NULL),(13590,2258,'1614189','834','00','005010X220A1','1614189','','2014-01-05','13:55:30',1,'2014-01-07 10:22:26',NULL,NULL),(3880,699,'152754','834','00','005010X220A1','152754','','2013-10-04','12:37:16',0,'2013-12-25 22:31:32',NULL,NULL),(7396,1294,'1261780','834','00','005010X220A1','1261780','','2013-12-21','06:25:21',0,'2013-12-26 04:30:45',NULL,NULL),(13532,2241,'2509637','834','00','005010X220A1','2509637','','2014-01-06','10:59:32',0,'2014-01-07 04:05:50',NULL,NULL),(15941,2757,'1748151','834','00','005010X220A1','1748151','','2014-01-21','12:09:56',1,'2014-01-22 03:23:07',NULL,NULL),(16543,3020,'2114832','834','00','005010X220A1','2114832','','2014-01-24','03:21:45',0,'2014-01-24 21:01:08',NULL,NULL),(17366,3183,'2381801','834','00','005010X220A1','2381801','','2014-01-31','09:19:39',0,'2014-01-31 21:01:28',NULL,NULL),(19229,3580,'2737317','834','00','005010X220A1','2737317','','2014-02-13','10:11:30',0,'2014-02-13 22:00:17',NULL,NULL),(21052,3978,'2736476','834','00','005010X220A1','2736476','','2014-02-23','21:26:07',0,'2014-02-26 09:30:28',NULL,NULL),(5351,1003,'349955','834','00','005010X220A1','349955','','2013-11-25','10:27:14',0,'2013-12-26 01:15:53',NULL,NULL),(12887,1707,'2028703','834','00','005010X220A1','2028703','','2014-01-03','11:17:51',0,'2014-01-04 02:04:24',NULL,NULL),(1479,253,'1926575','834','00','005010X220A1','1926575','','2013-12-24','08:07:05',0,'2013-12-25 18:56:45',NULL,NULL),(7534,1300,'356808','834','00','005010X220A1','356808','','2013-12-21','15:13:05',0,'2013-12-26 04:35:07',NULL,NULL),(3659,626,'78284','834','00','005010X220A1','78284','','2013-12-11','21:14:04',0,'2013-12-25 22:06:12',NULL,NULL),(17018,3119,'2663903','834','00','005010X220A1','2663903','','2014-01-29','17:56:37',0,'2014-01-29 21:01:05',NULL,NULL),(18487,3433,'2102024','834','00','005010X220A1','2102024','','2014-02-10','04:03:58',0,'2014-02-10 11:01:04',NULL,NULL),(19963,3746,'3476130','834','00','005010X220A1','3476130','','2014-02-18','10:37:11',0,'2014-02-18 22:00:06',NULL,NULL),(23042,4332,'3276941','834','00','005010X220A1','3276941','','2014-03-07','11:15:14',0,'2014-03-07 21:00:32',NULL,NULL),(357,72,'643583','834','00','005010X220A1','643583','','2013-12-04','08:24:45',0,'2013-12-25 17:47:00',NULL,NULL),(3949,715,'614132','834','00','005010X220A1','614132','','2013-12-06','19:43:42',0,'2013-12-25 22:46:30',NULL,NULL),(2989,542,'1014024','834','00','005010X220A1','1014024','','2013-12-13','12:23:39',0,'2013-12-25 21:32:47',NULL,NULL),(14514,2517,'1366634','834','00','005010X220A1','1366634','','2014-01-12','18:48:22',0,'2014-01-14 01:32:11',NULL,NULL),(14429,2450,'0001','999','BE','005010X231A1','458447','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:40',NULL,NULL),(1922,326,'734666','834','00','005010X220A1','734666','','2013-12-08','19:14:57',0,'2013-12-25 19:32:24',NULL,NULL),(13779,2289,'1380862','834','00','005010X220A1','1380862','','2014-01-07','15:56:48',0,'2014-01-08 18:25:05',NULL,NULL),(2841,511,'199462','834','00','005010X220A1','199462','','2013-12-22','15:01:19',0,'2013-12-25 21:21:42',NULL,NULL),(7442,1296,'1256918','834','00','005010X220A1','1256918','','2013-12-20','19:28:04',0,'2013-12-26 04:32:10',NULL,NULL),(12442,1638,'2551073','834','00','005010X220A1','2551073','','2013-12-31','16:08:36',1,'2014-01-02 04:31:12',NULL,NULL),(16652,3060,'1964623','834','00','005010X220A1','1964623','','2014-01-27','12:42:04',0,'2014-01-27 21:00:13',NULL,NULL),(17334,3177,'2535297','834','00','005010X220A1','2535297','','2014-01-31','13:19:31',0,'2014-01-31 21:01:05',NULL,NULL),(18727,3485,'1934414','834','00','005010X220A1','1934414','','2014-02-11','09:58:26',0,'2014-02-11 21:00:21',NULL,NULL),(23047,4336,'3712532','834','00','005010X220A1','3712532','','2014-03-07','16:02:57',0,'2014-03-07 21:00:34',NULL,NULL),(11797,1537,'535179','834','00','005010X220A1','535179','','2013-12-28','20:25:06',1,'2013-12-29 11:13:02',NULL,NULL),(2809,506,'1411797','834','00','005010X220A1','1411797','','2013-12-22','15:03:05',0,'2013-12-25 21:20:36',NULL,NULL),(3403,590,'785463','834','00','005010X220A1','785463','','2013-12-16','20:56:15',0,'2013-12-25 21:51:47',NULL,NULL),(3212,578,'878606','834','00','005010X220A1','878606','','2013-12-17','08:49:07',0,'2013-12-25 21:45:41',NULL,NULL),(15357,2623,'2125611','834','00','005010X220A1','2125611','','2014-01-16','14:02:29',0,'2014-01-17 03:35:26',NULL,NULL),(21365,4024,'3684308','834','00','005010X220A1','3684308','','2014-02-26','23:43:23',0,'2014-02-28 06:30:18',NULL,NULL),(13872,2311,'2220355','834','00','005010X220A1','2220355','','2014-01-09','17:18:53',0,'2014-01-13 02:19:27',NULL,NULL),(11874,1560,'233556','834','00','005010X220A1','233556','','2013-12-29','09:57:38',0,'2013-12-30 00:00:11',NULL,NULL),(7757,1347,'350748','834','00','005010X220A1','350748','','2013-10-20','19:23:05',0,'2013-12-26 05:01:06',NULL,NULL),(15659,2684,'2382749','834','00','005010X220A1','2382749','','2014-01-18','13:23:46',0,'2014-01-21 08:44:30',NULL,NULL),(17984,3308,'2807534','834','00','005010X220A1','2807534','','2014-02-04','23:46:19',0,'2014-02-05 21:31:13',NULL,NULL),(21988,4145,'3402202','834','00','005010X220A1','3402202','','2014-03-02','12:04:08',0,'2014-03-03 01:00:16',NULL,NULL),(12308,1630,'2203528','834','00','005010X220A1','2203528','','2014-01-01','10:47:27',1,'2014-01-02 04:25:34',NULL,NULL),(5735,1069,'1194379','834','00','005010X220A1','1194379','','2013-12-14','17:46:25',0,'2013-12-26 02:01:28',NULL,NULL),(5691,1067,'1306421','834','00','005010X220A1','1306421','','2013-12-13','21:02:52',0,'2013-12-26 02:00:05',NULL,NULL),(4840,883,'11268','834','00','005010X220A1','11268','','2013-11-21','12:30:03',0,'2013-12-26 00:15:18',NULL,NULL),(10636,1402,'1401895','834','00','005010X220A1','1401895','','2013-12-23','16:57:23',0,'2013-12-26 12:58:21',NULL,NULL),(4685,833,'162768','834','00','005010X220A1','162768','','2013-12-23','23:19:37',0,'2013-12-25 23:50:07',NULL,NULL),(4668,831,'349602','834','00','005010X220A1','349602','','2013-12-23','22:41:10',0,'2013-12-25 23:49:29',NULL,NULL),(18131,3335,'2831236','834','00','005010X220A1','2831236','','2014-02-05','20:30:14',0,'2014-02-06 21:01:39',NULL,NULL),(20634,3873,'3024303','834','00','005010X220A1','3024303','','2014-02-20','18:46:26',0,'2014-02-21 22:00:41',NULL,NULL),(22380,4208,'3641711','834','00','005010X220A1','3641711','','2014-03-04','11:20:00',0,'2014-03-04 21:02:03',NULL,NULL),(178,16,'216480','834','00','005010X220A1','216480','','2013-12-05','13:08:10',0,'2013-12-25 17:20:31',NULL,NULL),(5915,1112,'1268746','834','00','005010X220A1','1268746','','2013-12-15','09:24:20',0,'2013-12-26 02:31:16',NULL,NULL),(14117,2347,'1793372','834','00','005010X220A1','1793372','','2014-01-08','15:01:58',0,'2014-01-13 02:22:21',NULL,NULL),(15504,2637,'1470011','834','00','005010X220A1','1470011','','2014-01-16','10:11:35',0,'2014-01-17 03:36:33',NULL,NULL),(15716,2707,'1378492','834','00','005010X220A1','1378492','','2014-01-19','11:54:06',0,'2014-01-21 08:45:40',NULL,NULL),(16487,3010,'2578608','834','00','005010X220A1','2578608','','2014-01-24','17:14:09',0,'2014-01-24 21:00:33',NULL,NULL),(18120,3330,'2298445','834','00','005010X220A1','2298445','','2014-02-06','14:04:16',0,'2014-02-06 21:01:31',NULL,NULL),(19095,3543,'2687121','834','00','005010X220A1','2687121','','2014-02-12','10:07:54',0,'2014-02-12 21:31:35',NULL,NULL),(21368,4024,'3380342','834','00','005010X220A1','3380342','','2014-02-27','09:44:36',0,'2014-02-28 06:30:20',NULL,NULL),(6142,1166,'1158904','834','00','005010X220A1','1158904','','2013-12-20','16:41:21',0,'2013-12-26 03:02:34',NULL,NULL),(5103,940,'321824','834','00','005010X220A1','321824','','2013-12-11','14:45:51',0,'2013-12-26 00:49:15',NULL,NULL),(4659,830,'1719478','834','00','005010X220A1','1719478','','2013-12-23','21:44:27',0,'2013-12-25 23:49:14',NULL,NULL),(3945,715,'105634','834','00','005010X220A1','105634','','2013-12-06','18:54:23',0,'2013-12-25 22:46:22',NULL,NULL),(13155,1999,'0001','999','BE','005010X231A1','546147','834','2013-12-27','18:10:00',0,'2014-01-05 16:57:47',NULL,NULL),(11616,1494,'476069','834','00','005010X220A1','476069','','2013-12-27','12:08:13',0,'2013-12-28 03:35:13',NULL,NULL),(20528,3849,'3366506','834','00','005010X220A1','3366506','','2014-02-20','14:20:37',0,'2014-02-20 22:01:26',NULL,NULL),(22412,4215,'3461900','834','00','005010X220A1','3461900','','2014-03-04','14:51:26',0,'2014-03-04 21:02:30',NULL,NULL),(22599,4250,'3767212','834','00','005010X220A1','3767212','','2014-03-05','10:14:57',0,'2014-03-05 21:31:17',NULL,NULL),(14602,2521,'2526350','834','00','005010X220A1','2526350','','2014-01-13','15:01:32',0,'2014-01-14 01:33:08',NULL,NULL),(14519,2517,'2101701','834','00','005010X220A1','2101701','','2014-01-13','18:23:12',0,'2014-01-14 01:32:15',NULL,NULL),(4837,883,'33505','834','00','005010X220A1','33505','','2013-11-21','17:54:21',0,'2013-12-26 00:15:12',NULL,NULL),(2029,331,'345969','834','00','005010X220A1','345969','','2013-12-09','16:32:55',0,'2013-12-25 19:35:47',NULL,NULL),(12889,1707,'2106478','834','00','005010X220A1','2106478','','2014-01-03','16:19:41',0,'2014-01-04 02:04:29',NULL,NULL),(3950,715,'655492','834','00','005010X220A1','655492','','2013-12-06','20:59:13',0,'2013-12-25 22:46:33',NULL,NULL),(12332,1634,'1841738','834','00','005010X220A1','1841738','','2013-12-31','08:07:32',1,'2014-01-02 04:27:17',NULL,NULL),(7432,1295,'414715','834','00','005010X220A1','414715','','2013-12-21','13:50:39',0,'2013-12-26 04:31:53',NULL,NULL),(17404,3198,'1614879','834','00','005010X220A1','1614879','','2014-02-01','12:16:16',0,'2014-02-01 19:00:12',NULL,NULL),(6130,1166,'369806','834','00','005010X220A1','369806','','2013-12-20','15:42:45',0,'2013-12-26 03:02:15',NULL,NULL),(5238,957,'491881','834','00','005010X220A1','491881','','2013-12-11','09:42:39',0,'2013-12-26 00:53:38',NULL,NULL),(395,76,'1189353','834','00','005010X220A1','1189353','','2013-12-03','19:52:12',0,'2013-12-25 17:48:13',NULL,NULL),(603,107,'1165005','834','00','005010X220A1','1165005','','2013-12-16','16:41:47',0,'2013-12-25 18:03:41',NULL,NULL),(14907,2558,'2404197','834','00','005010X220A1','2404197','','2014-01-14','14:58:49',0,'2014-01-15 02:07:32',NULL,NULL),(1095,224,'644484','834','00','005010X220A1','644484','','2013-10-25','11:39:58',0,'2013-12-25 18:31:50',NULL,NULL),(11888,1561,'1915459','834','00','005010X220A1','1915459','','2013-12-28','18:29:43',0,'2013-12-30 00:00:38',NULL,NULL),(4417,786,'1067961','834','00','005010X220A1','1067961','','2013-11-06','13:07:29',0,'2013-12-25 23:16:31',NULL,NULL),(11868,1559,'946071','834','00','005010X220A1','946071','','2013-12-28','20:30:12',1,'2013-12-29 11:15:25',NULL,NULL),(11870,1560,'1616614','834','00','005010X220A1','1616614','','2013-12-28','19:18:08',0,'2013-12-30 00:00:05',NULL,NULL),(15741,2712,'2157356','834','00','005010X220A1','2157356','','2014-01-20','13:18:25',0,'2014-01-21 08:46:12',NULL,NULL),(20031,3750,'2806937','834','00','005010X220A1','2806937','','2014-02-18','14:19:52',0,'2014-02-18 22:00:54',NULL,NULL),(20389,3828,'3403178','834','00','005010X220A1','3403178','','2014-02-19','14:48:03',0,'2014-02-20 05:40:10',NULL,NULL),(23689,4449,'3890792','834','00','005010X220A1','3890792','','2014-03-10','11:44:48',0,'2014-03-10 21:02:20',NULL,NULL),(11700,1517,'714891','834','00','005010X220A1','714891','','2013-12-27','21:05:34',1,'2013-12-29 11:07:54',NULL,NULL),(11684,1516,'1757733','834','00','005010X220A1','1757733','','2013-12-28','10:40:07',1,'2013-12-29 11:07:23',NULL,NULL),(5058,936,'159929','834','00','005010X220A1','159929','','2013-12-11','10:02:32',0,'2013-12-26 00:47:52',NULL,NULL),(6122,1166,'1254564','834','00','005010X220A1','1254564','','2013-12-20','14:46:51',0,'2013-12-26 03:01:57',NULL,NULL),(5548,1042,'645776','834','00','005010X220A1','645776','','2013-12-24','18:22:29',0,'2013-12-26 01:47:59',NULL,NULL),(4119,733,'376559','834','00','005010X220A1','376559','','2013-12-19','13:41:32',0,'2013-12-25 23:03:48',NULL,NULL),(5494,1041,'1615136','834','00','005010X220A1','1615136','','2013-12-24','18:59:40',0,'2013-12-26 01:46:12',NULL,NULL),(15444,2630,'2401822','834','00','005010X220A1','2401822','','2014-01-15','22:20:04',0,'2014-01-17 03:36:07',NULL,NULL),(15635,2676,'1723898','834','00','005010X220A1','1723898','','2014-01-18','17:52:30',0,'2014-01-21 08:44:15',NULL,NULL),(17006,3118,'1945265','834','00','005010X220A1','1945265','','2014-01-29','15:11:20',0,'2014-01-29 21:00:57',NULL,NULL),(17413,3199,'2022204','834','00','005010X220A1','2022204','','2014-02-01','16:26:48',0,'2014-02-01 19:00:18',NULL,NULL),(17623,3243,'2314585','834','00','005010X220A1','2314585','','2014-02-03','14:15:53',0,'2014-02-03 21:01:13',NULL,NULL),(19060,3542,'3299834','834','00','005010X220A1','3299834','','2014-02-12','13:29:06',0,'2014-02-12 21:31:08',NULL,NULL),(20015,3750,'3296327','834','00','005010X220A1','3296327','','2014-02-18','08:53:42',0,'2014-02-18 22:00:43',NULL,NULL),(21727,4088,'2791636','834','00','005010X220A1','2791636','','2014-02-28','15:06:20',0,'2014-02-28 21:30:31',NULL,NULL),(22468,4238,'3336008','834','00','005010X220A1','3336008','','2014-03-05','16:08:20',0,'2014-03-05 21:00:15',NULL,NULL),(22801,4278,'3379263','834','00','005010X220A1','3379263','','2014-03-05','19:06:37',0,'2014-03-06 21:01:05',NULL,NULL),(7422,1295,'771503','834','00','005010X220A1','771503','','2013-12-21','11:06:16',0,'2013-12-26 04:31:33',NULL,NULL),(14562,2519,'1485370','834','00','005010X220A1','1485370','','2014-01-13','13:02:51',0,'2014-01-14 01:32:42',NULL,NULL),(2027,331,'272261','834','00','005010X220A1','272261','','2013-12-09','16:05:26',0,'2013-12-25 19:35:43',NULL,NULL),(3965,716,'776514','834','00','005010X220A1','776514','','2013-12-07','10:49:00',0,'2013-12-25 22:47:06',NULL,NULL),(2375,413,'260769','834','00','005010X220A1','260769','','2013-12-05','18:20:41',0,'2013-12-25 20:16:29',NULL,NULL),(5450,1036,'683201','834','00','005010X220A1','683201','','2013-11-03','17:21:25',0,'2013-12-26 01:32:01',NULL,NULL),(2625,490,'457234','834','00','005010X220A1','457234','','2013-11-28','17:49:05',0,'2013-12-25 20:46:45',NULL,NULL),(22789,4277,'3315216','834','00','005010X220A1','3315216','','2014-03-06','16:06:34',0,'2014-03-06 21:00:57',NULL,NULL),(539,102,'914404','834','00','005010X220A1','914404','','2013-12-16','17:04:20',0,'2013-12-25 18:01:40',NULL,NULL),(14394,2417,'1691123','834','00','005010X220A1','1691123','','2014-01-12','14:52:54',0,'2014-01-13 03:01:58',NULL,NULL),(13591,2258,'2133021','834','00','005010X220A1','2133021','','2014-01-04','22:26:03',1,'2014-01-07 10:22:28',NULL,NULL),(1083,217,'631104','834','00','005010X220A1','631104','','2013-11-04','17:43:41',0,'2013-12-25 18:31:23',NULL,NULL),(1871,324,'520964','834','00','005010X220A1','520964','','2013-12-09','16:23:17',0,'2013-12-25 19:30:54',NULL,NULL),(3198,578,'1011527','834','00','005010X220A1','1011527','','2013-12-16','20:37:49',0,'2013-12-25 21:45:15',NULL,NULL),(5493,1041,'1625400','834','00','005010X220A1','1625400','','2013-12-24','18:51:48',0,'2013-12-26 01:46:10',NULL,NULL),(6062,1164,'644139','834','00','005010X220A1','644139','','2013-12-19','19:45:55',0,'2013-12-26 03:00:05',NULL,NULL),(16737,3065,'2080658','834','00','005010X220A1','2080658','','2014-01-27','13:26:03',0,'2014-01-27 21:01:08',NULL,NULL),(17609,3240,'2394414','834','00','005010X220A1','2394414','','2014-02-03','17:28:14',0,'2014-02-03 21:01:04',NULL,NULL),(17677,3259,'2583886','834','00','005010X220A1','2583886','','2014-02-04','11:07:29',0,'2014-02-04 21:00:16',NULL,NULL),(19404,3593,'3194214','834','00','005010X220A1','3194214','','2014-02-13','12:50:06',0,'2014-02-13 22:02:32',NULL,NULL),(21107,3994,'2959923','834','00','005010X220A1','2959923','','2014-02-26','10:31:59',0,'2014-02-26 21:00:13',NULL,NULL),(211,25,'1029445','834','00','005010X220A1','1029445','','2013-12-05','14:37:00',0,'2013-12-25 17:21:38',NULL,NULL),(7010,1235,'676406','834','00','005010X220A1','676406','','2013-12-17','23:46:39',0,'2013-12-26 04:00:49',NULL,NULL),(12571,1668,'2116491','834','00','005010X220A1','2116491','','2013-12-31','17:47:26',1,'2014-01-02 04:36:10',NULL,NULL),(3353,587,'599928','834','00','005010X220A1','599928','','2013-12-17','09:06:22',0,'2013-12-25 21:50:16',NULL,NULL),(2086,346,'851033','834','00','005010X220A1','851033','','2013-12-09','16:54:08',0,'2013-12-25 19:37:35',NULL,NULL),(16132,2824,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:50:32',NULL,NULL),(17330,3176,'2214577','834','00','005010X220A1','2214577','','2014-01-31','15:46:48',0,'2014-01-31 21:01:02',NULL,NULL),(18994,3538,'3290130','834','00','005010X220A1','3290130','','2014-02-11','19:49:38',0,'2014-02-12 21:30:22',NULL,NULL),(19862,3705,'2304749','834','00','005010X220A1','2304749','','2014-02-15','18:18:13',0,'2014-02-16 19:00:09',NULL,NULL),(20264,3795,'2635309','834','00','005010X220A1','2635309','','2014-02-19','00:03:44',0,'2014-02-20 04:34:31',NULL,NULL),(20839,3911,'3580237','834','00','005010X220A1','3580237','','2014-02-25','12:25:45',0,'2014-02-25 21:31:22',NULL,NULL),(14412,2433,'0001','999','BE','005010X231A1','4258','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:24',NULL,NULL),(7109,1236,'1237974','834','00','005010X220A1','1237974','','2013-12-18','13:13:56',0,'2013-12-26 04:03:51',NULL,NULL),(13080,1924,'0001','999','BE','005010X231A1','1279288','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:43',NULL,NULL),(1268,243,'800172','834','00','005010X220A1','800172','','2013-12-24','14:59:57',0,'2013-12-25 18:49:45',NULL,NULL),(12830,1704,'2360281','834','00','005010X220A1','2360281','','2014-01-03','10:56:59',0,'2014-01-04 02:02:19',NULL,NULL),(1780,299,'441170','834','00','005010X220A1','441170','','2013-12-10','12:59:59',0,'2013-12-25 19:18:57',NULL,NULL),(11786,1537,'1293246','834','00','005010X220A1','1293246','','2013-12-28','20:09:26',1,'2013-12-29 11:12:41',NULL,NULL),(2941,541,'446197','834','00','005010X220A1','446197','','2013-12-12','22:32:16',0,'2013-12-25 21:31:17',NULL,NULL),(17486,3220,'1583681','834','00','005010X220A1','1583681','','2014-02-01','21:09:58',0,'2014-02-02 19:00:16',NULL,NULL),(17827,3277,'2575184','834','00','005010X220A1','2575184','','2014-02-04','12:59:04',0,'2014-02-04 21:01:52',NULL,NULL),(20784,3907,'3190493','834','00','005010X220A1','3190493','','2014-02-25','16:20:15',0,'2014-02-25 21:30:43',NULL,NULL),(22440,4230,'3209695','834','00','005010X220A1','3209695','','2014-03-04','13:58:17',0,'2014-03-04 21:30:09',NULL,NULL),(762,141,'779062','834','00','005010X220A1','779062','','2013-12-16','15:52:13',0,'2013-12-25 18:08:44',NULL,NULL),(11350,1457,'1886118','834','00','005010X220A1','1886118','','2013-12-26','17:23:38',0,'2013-12-27 02:05:02',NULL,NULL),(5453,1037,'1134234','834','00','005010X220A1','1134234','','2013-11-03','12:25:21',0,'2013-12-26 01:32:06',NULL,NULL),(17048,3122,'2370623','834','00','005010X220A1','2370623','','2014-01-29','16:32:08',0,'2014-01-29 21:01:25',NULL,NULL),(3108,546,'727662','834','00','005010X220A1','727662','','2013-12-13','13:55:27',0,'2013-12-25 21:36:24',NULL,NULL),(5115,942,'890609','834','00','005010X220A1','890609','','2013-12-10','21:03:10',0,'2013-12-26 00:49:43',NULL,NULL),(7247,1244,'180194','834','00','005010X220A1','180194','','2013-12-18','13:48:18',0,'2013-12-26 04:08:06',NULL,NULL),(18324,3385,'2841649','834','00','005010X220A1','2841649','','2014-02-08','16:19:31',0,'2014-02-08 19:00:49',NULL,NULL),(19601,3632,'1912278','834','00','005010X220A1','1912278','','2014-02-13','20:19:33',0,'2014-02-14 21:31:38',NULL,NULL),(20642,3874,'2423744','834','00','005010X220A1','2423744','','2014-02-21','15:46:37',0,'2014-02-21 22:00:46',NULL,NULL),(22929,4293,'3309178','834','00','005010X220A1','3309178','','2014-03-06','11:37:41',0,'2014-03-06 21:02:37',NULL,NULL),(1415,248,'1617701','834','00','005010X220A1','1617701','','2013-12-24','09:49:09',0,'2013-12-25 18:54:32',NULL,NULL),(11705,1517,'2400118','834','00','005010X220A1','2400118','','2013-12-28','13:55:39',1,'2013-12-29 11:08:02',NULL,NULL),(10953,1410,'1749807','834','00','005010X220A1','1749807','','2013-12-23','17:52:43',0,'2013-12-26 13:09:18',NULL,NULL),(10926,1410,'855624','834','00','005010X220A1','855624','','2013-12-23','11:43:30',0,'2013-12-26 13:08:31',NULL,NULL),(4832,882,'129280','834','00','005010X220A1','129280','','2013-11-20','19:59:56',0,'2013-12-26 00:15:03',NULL,NULL),(15690,2697,'1398934','834','00','005010X220A1','1398934','','2014-01-19','08:45:47',0,'2014-01-21 08:45:20',NULL,NULL),(15707,2701,'2537501','834','00','005010X220A1','2537501','','2014-01-19','17:40:45',0,'2014-01-21 08:45:33',NULL,NULL),(17821,3274,'2869037','834','00','005010X220A1','2869037','','2014-02-04','10:07:53',0,'2014-02-04 21:01:46',NULL,NULL),(20350,3810,'3365485','834','00','005010X220A1','3365485','','2014-02-19','13:33:15',0,'2014-02-20 04:54:41',NULL,NULL),(21689,4086,'3234810','834','00','005010X220A1','3234810','','2014-02-28','17:42:55',0,'2014-02-28 21:00:28',NULL,NULL),(22301,4201,'3571908','834','00','005010X220A1','3571908','','2014-03-04','10:26:03',0,'2014-03-04 21:00:59',NULL,NULL),(13652,2271,'1442521','834','00','005010X220A1','1442521','','2014-01-07','12:21:51',0,'2014-01-08 18:24:11',NULL,NULL),(10406,1400,'333203','834','00','005010X220A1','333203','','2013-12-23','09:06:38',0,'2013-12-26 12:50:52',NULL,NULL),(870,176,'1230832','834','00','005010X220A1','1230832','','2013-12-03','16:47:38',0,'2013-12-25 18:16:19',NULL,NULL),(15060,2585,'2260532','834','00','005010X220A1','2260532','','2014-01-15','10:01:47',0,'2014-01-16 08:44:55',NULL,NULL),(16598,3046,'1782494','834','00','005010X220A1','1782494','','2014-01-25','12:59:20',0,'2014-01-25 19:00:20',NULL,NULL),(16672,3061,'2033489','834','00','005010X220A1','2033489','','2014-01-27','08:59:32',0,'2014-01-27 21:00:25',NULL,NULL),(19294,3582,'2440778','834','00','005010X220A1','2440778','','2014-02-13','15:42:37',0,'2014-02-13 22:01:08',NULL,NULL),(22450,4232,'3047252','834','00','005010X220A1','3047252','','2014-03-04','11:13:23',0,'2014-03-04 21:30:16',NULL,NULL),(22976,4316,'3454971','834','00','005010X220A1','3454971','','2014-03-06','13:36:58',0,'2014-03-06 21:30:15',NULL,NULL),(23468,4418,'3374028','834','00','005010X220A1','3374028','','2014-03-09','12:37:47',0,'2014-03-09 21:01:07',NULL,NULL),(23672,4445,'2876046','834','00','005010X220A1','2876046','','2014-03-09','21:29:33',0,'2014-03-10 21:02:07',NULL,NULL),(14335,2400,'1884071','834','00','005010X220A1','1884071','','2014-01-12','14:10:16',0,'2014-01-13 03:01:14',NULL,NULL),(4492,804,'725824','834','00','005010X220A1','725824','','2013-11-25','23:27:13',0,'2013-12-25 23:31:47',NULL,NULL),(11601,1493,'1593760','834','00','005010X220A1','1593760','','2013-12-27','12:15:01',0,'2013-12-28 03:34:44',NULL,NULL),(11523,1490,'1567583','834','00','005010X220A1','1567583','','2013-12-27','12:13:13',0,'2013-12-28 03:32:20',NULL,NULL),(3232,578,'41764','834','00','005010X220A1','41764','','2013-12-17','13:00:14',0,'2013-12-25 21:46:17',NULL,NULL),(2624,490,'1001673','834','00','005010X220A1','1001673','','2013-11-28','17:34:38',0,'2013-12-25 20:46:43',NULL,NULL),(2329,410,'1096671','834','00','005010X220A1','1096671','','2013-10-08','12:49:49',0,'2013-12-25 20:02:15',NULL,NULL),(15668,2686,'1386151','834','00','005010X220A1','1386151','','2014-01-18','11:25:51',0,'2014-01-21 08:44:37',NULL,NULL),(17205,3150,'2114935','834','00','005010X220A1','2114935','','2014-01-29','19:58:27',0,'2014-01-30 21:01:12',NULL,NULL),(22984,4317,'3505619','834','00','005010X220A1','3505619','','2014-03-06','15:47:59',0,'2014-03-06 21:30:21',NULL,NULL),(23610,4440,'3430658','834','00','005010X220A1','3430658','','2014-03-10','17:31:57',0,'2014-03-10 21:01:23',NULL,NULL),(11745,1521,'2296182','834','00','005010X220A1','2296182','','2013-12-27','18:55:38',1,'2013-12-29 11:09:17',NULL,NULL),(7563,1301,'197809','834','00','005010X220A1','197809','','2013-12-21','11:57:30',0,'2013-12-26 04:36:03',NULL,NULL),(678,109,'762525','834','00','005010X220A1','762525','','2013-12-16','13:21:51',0,'2013-12-25 18:06:01',NULL,NULL),(910,177,'496238','834','00','005010X220A1','496238','','2013-12-03','16:17:10',0,'2013-12-25 18:17:23',NULL,NULL),(19702,3671,'2800457','834','00','005010X220A1','2800457','','2014-02-15','13:40:12',0,'2014-02-15 22:00:09',NULL,NULL),(20653,3876,'2228953','834','00','005010X220A1','2228953','','2014-02-21','10:15:21',0,'2014-02-21 22:00:55',NULL,NULL),(21677,4079,'3238542','834','00','005010X220A1','3238542','','2014-02-28','17:40:44',0,'2014-02-28 21:00:19',NULL,NULL),(22618,4251,'3627150','834','00','005010X220A1','3627150','','2014-03-05','12:00:02',0,'2014-03-05 21:31:31',NULL,NULL),(23000,4322,'3863789','834','00','005010X220A1','3863789','','2014-03-07','13:03:07',0,'2014-03-07 21:00:12',NULL,NULL),(514,102,'1045708','834','00','005010X220A1','1045708','','2013-12-16','11:44:23',0,'2013-12-25 18:00:53',NULL,NULL),(533,102,'654330','834','00','005010X220A1','654330','','2013-12-16','15:55:42',0,'2013-12-25 18:01:28',NULL,NULL),(1710,292,'101484','834','00','005010X220A1','101484','','2013-12-10','16:31:46',0,'2013-12-25 19:16:49',NULL,NULL),(2067,340,'1233723','834','00','005010X220A1','1233723','','2013-12-09','11:22:27',0,'2013-12-25 19:37:00',NULL,NULL),(2196,364,'677157','834','00','005010X220A1','677157','','2013-12-02','13:57:06',0,'2013-12-25 19:48:01',NULL,NULL),(12704,1677,'1632010','834','00','005010X220A1','1632010','','2014-01-02','14:09:49',0,'2014-01-03 02:04:56',NULL,NULL),(20442,3841,'3278714','834','00','005010X220A1','3278714','','2014-02-20','14:09:22',0,'2014-02-20 22:00:16',NULL,NULL),(21598,4062,'2692691','834','00','005010X220A1','2692691','','2014-02-26','15:43:19',0,'2014-02-28 07:00:41',NULL,NULL),(22329,4203,'2985707','834','00','005010X220A1','2985707','','2014-03-03','18:20:56',0,'2014-03-04 21:01:21',NULL,NULL),(15337,2622,'2083898','834','00','005010X220A1','2083898','','2014-01-15','19:18:19',0,'2014-01-17 03:35:17',NULL,NULL),(11682,1515,'2160937','834','00','005010X220A1','2160937','','2013-12-27','18:28:10',0,'2013-12-28 03:37:21',NULL,NULL),(1714,292,'928612','834','00','005010X220A1','928612','','2013-12-10','18:10:30',0,'2013-12-25 19:16:56',NULL,NULL),(1825,312,'1164767','834','00','005010X220A1','1164767','','2013-12-10','16:54:03',0,'2013-12-25 19:20:23',NULL,NULL),(10999,1413,'519133','834','00','005010X220A1','519133','','2013-12-23','16:17:18',0,'2013-12-26 13:10:44',NULL,NULL),(16714,3064,'2380244','834','00','005010X220A1','2380244','','2014-01-27','12:53:46',0,'2014-01-27 21:00:52',NULL,NULL),(21120,3994,'3234702','834','00','005010X220A1','3234702','','2014-02-26','14:16:00',0,'2014-02-26 21:00:22',NULL,NULL),(21261,4000,'3206782','834','00','005010X220A1','3206782','','2014-02-26','13:35:40',0,'2014-02-26 21:01:56',NULL,NULL),(22684,4255,'3602092','834','00','005010X220A1','3602092','','2014-03-05','17:08:52',0,'2014-03-05 21:32:16',NULL,NULL),(11424,1472,'1584201','834','00','005010X220A1','1584201','','2013-12-26','14:51:29',0,'2013-12-27 02:07:18',NULL,NULL),(5340,1002,'873258','834','00','005010X220A1','873258','','2013-11-25','10:27:14',0,'2013-12-26 01:15:30',NULL,NULL),(3231,578,'306736','834','00','005010X220A1','306736','','2013-12-17','12:44:25',0,'2013-12-25 21:46:16',NULL,NULL),(3427,596,'484012','834','00','005010X220A1','484012','','2013-12-17','02:00:08',0,'2013-12-25 21:52:33',NULL,NULL),(5004,935,'431660','834','00','005010X220A1','431660','','2013-12-11','10:27:46',0,'2013-12-26 00:46:05',NULL,NULL),(11423,1472,'1315093','834','00','005010X220A1','1315093','','2013-12-26','14:45:06',0,'2013-12-27 02:07:17',NULL,NULL),(3736,641,'364570','834','00','005010X220A1','364570','','2013-12-12','14:20:44',0,'2013-12-25 22:08:44',NULL,NULL),(6173,1167,'844713','834','00','005010X220A1','844713','','2013-12-20','15:38:29',0,'2013-12-26 03:03:30',NULL,NULL),(6156,1167,'814782','834','00','005010X220A1','814782','','2013-12-19','20:26:01',0,'2013-12-26 03:03:02',NULL,NULL),(3258,579,'1132438','834','00','005010X220A1','1132438','','2013-12-17','10:23:39',0,'2013-12-25 21:47:04',NULL,NULL),(2951,541,'328968','834','00','005010X220A1','328968','','2013-12-13','10:17:16',0,'2013-12-25 21:31:35',NULL,NULL),(16049,2772,'2197861','834','00','005010X220A1','2197861','','2014-01-22','16:47:44',0,'2014-01-23 03:02:35',NULL,NULL),(16094,2786,'0001','999','BE','005010X231A1','229985','834','2014-01-13','22:20:00',0,'2014-01-23 03:39:35',NULL,NULL),(17372,3185,'2313139','834','00','005010X220A1','2313139','','2014-01-31','11:08:46',0,'2014-01-31 21:01:32',NULL,NULL),(17824,3275,'2189471','834','00','005010X220A1','2189471','','2014-02-04','11:15:42',0,'2014-02-04 21:01:49',NULL,NULL),(18257,3376,'2958377','834','00','005010X220A1','2958377','','2014-02-07','23:11:23',0,'2014-02-08 19:00:08',NULL,NULL),(19692,3670,'2217494','834','00','005010X220A1','2217494','','2014-02-14','20:47:08',0,'2014-02-15 21:00:13',NULL,NULL),(6346,1178,'55170','834','00','005010X220A1','55170','','2013-12-20','08:47:54',0,'2013-12-26 03:08:48',NULL,NULL),(6041,1151,'1013399','834','00','005010X220A1','1013399','','2013-10-14','10:11:54',0,'2013-12-26 02:46:16',NULL,NULL),(13740,2276,'1513424','834','00','005010X220A1','1513424','','2014-01-06','19:28:55',0,'2014-01-08 18:24:47',NULL,NULL),(13598,2261,'1659123','834','00','005010X220A1','1659123','','2014-01-05','13:39:42',1,'2014-01-07 10:22:47',NULL,NULL),(4605,826,'1149135','834','00','005010X220A1','1149135','','2013-12-24','01:46:00',0,'2013-12-25 23:47:23',NULL,NULL),(2518,451,'744799','834','00','005010X220A1','744799','','2013-10-13','14:26:16',0,'2013-12-25 20:30:34',NULL,NULL),(19831,3681,'2464046','834','00','005010X220A1','2464046','','2014-02-15','10:01:42',0,'2014-02-15 22:01:48',NULL,NULL),(20237,3792,'2887092','834','00','005010X220A1','2887092','','2014-02-18','21:01:21',0,'2014-02-20 04:29:05',NULL,NULL),(22455,4233,'3244825','834','00','005010X220A1','3244825','','2014-03-04','11:18:33',0,'2014-03-04 21:30:20',NULL,NULL),(23667,4444,'3687345','834','00','005010X220A1','3687345','','2014-03-10','15:04:52',0,'2014-03-10 21:02:03',NULL,NULL),(14326,2400,'1628552','834','00','005010X220A1','1628552','','2014-01-11','18:44:04',0,'2014-01-13 03:01:08',NULL,NULL),(3843,682,'1122903','834','00','005010X220A1','1122903','','2013-11-08','14:14:02',0,'2013-12-25 22:30:21',NULL,NULL),(2161,362,'501169','834','00','005010X220A1','501169','','2013-12-02','09:51:43',0,'2013-12-25 19:46:48',NULL,NULL),(10856,1406,'1465541','834','00','005010X220A1','1465541','','2013-12-23','13:31:03',0,'2013-12-26 13:05:42',NULL,NULL),(12632,1671,'2237520','834','00','005010X220A1','2237520','','2014-01-02','17:52:46',0,'2014-01-03 02:02:11',NULL,NULL),(13320,2164,'0001','999','BE','005010X231A1','1269622','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:07',NULL,NULL),(17015,3119,'1369642','834','00','005010X220A1','1369642','','2014-01-29','15:14:55',0,'2014-01-29 21:01:03',NULL,NULL),(17591,3239,'2123461','834','00','005010X220A1','2123461','','2014-02-03','05:27:53',0,'2014-02-03 21:00:53',NULL,NULL),(18218,3357,'3005091','834','00','005010X220A1','3005091','','2014-02-06','19:01:03',0,'2014-02-07 19:00:47',NULL,NULL),(20595,3870,'3324910','834','00','005010X220A1','3324910','','2014-02-20','20:11:10',0,'2014-02-21 22:00:11',NULL,NULL),(20976,3956,'2579309','834','00','005010X220A1','2579309','','2014-02-22','13:58:23',0,'2014-02-26 08:30:15',NULL,NULL),(22582,4248,'3493705','834','00','005010X220A1','3493705','','2014-03-05','16:19:37',0,'2014-03-05 21:31:05',NULL,NULL),(11238,1454,'1776714','834','00','005010X220A1','1776714','','2013-12-26','12:55:55',0,'2013-12-27 02:01:36',NULL,NULL),(5167,946,'12894','834','00','005010X220A1','12894','','2013-12-10','19:20:48',0,'2013-12-26 00:51:18',NULL,NULL),(2099,355,'483763','834','00','005010X220A1','483763','','2013-12-09','18:01:09',0,'2013-12-25 19:38:00',NULL,NULL),(15975,2764,'1459987','834','00','005010X220A1','1459987','','2014-01-22','11:48:00',0,'2014-01-23 03:02:01',NULL,NULL),(18945,3526,'2324541','834','00','005010X220A1','2324541','','2014-02-11','08:30:08',0,'2014-02-11 21:30:24',NULL,NULL),(19323,3583,'3025176','834','00','005010X220A1','3025176','','2014-02-13','11:51:55',0,'2014-02-13 22:01:32',NULL,NULL),(21957,4139,'2851798','834','00','005010X220A1','2851798','','2014-03-01','16:10:55',0,'2014-03-01 21:01:11',NULL,NULL),(22578,4248,'3015958','834','00','005010X220A1','3015958','','2014-03-05','15:21:53',0,'2014-03-05 21:31:02',NULL,NULL),(23269,4379,'3718751','834','00','005010X220A1','3718751','','2014-03-08','13:35:48',0,'2014-03-08 21:00:07',NULL,NULL),(15708,2702,'1648009','834','00','005010X220A1','1648009','','2014-01-18','19:45:31',0,'2014-01-21 08:45:34',NULL,NULL),(2866,514,'430945','834','00','005010X220A1','430945','','2013-12-22','08:03:03',0,'2013-12-25 21:22:29',NULL,NULL),(2778,506,'1314776','834','00','005010X220A1','1314776','','2013-12-21','23:07:24',0,'2013-12-25 21:19:34',NULL,NULL),(5964,1117,'661196','834','00','005010X220A1','661196','','2013-12-15','11:38:55',0,'2013-12-26 02:32:46',NULL,NULL),(2217,367,'679638','834','00','005010X220A1','679638','','2013-12-01','20:03:25',0,'2013-12-25 19:48:43',NULL,NULL),(4974,935,'771000','834','00','005010X220A1','771000','','2013-12-10','18:56:59',0,'2013-12-26 00:45:09',NULL,NULL),(16154,2846,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:21:00',1,'2014-01-23 04:07:00',NULL,NULL),(17938,3299,'1728584','834','00','005010X220A1','1728584','','2014-02-04','19:51:42',0,'2014-02-05 21:30:49',NULL,NULL),(18518,3450,'3047983','834','00','005010X220A1','3047983','','2014-02-10','10:48:14',0,'2014-02-10 21:30:04',NULL,NULL),(20196,3782,'3582919','834','00','005010X220A1','3582919','','2014-02-19','09:07:14',0,'2014-02-20 04:17:11',NULL,NULL),(146,10,'245042','834','00','005010X220A1','245042','','2013-12-05','09:58:08',0,'2013-12-25 17:19:33',NULL,NULL),(15694,2698,'1768446','834','00','005010X220A1','1768446','','2014-01-19','14:07:04',0,'2014-01-21 08:45:23',NULL,NULL),(13046,1890,'0001','999','BE','005010X231A1','796564','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:09',NULL,NULL),(4873,887,'234970','834','00','005010X220A1','234970','','2013-11-21','08:33:11',0,'2013-12-26 00:16:21',NULL,NULL),(12475,1640,'1844569','834','00','005010X220A1','1844569','','2013-12-30','23:08:05',1,'2014-01-02 04:32:22',NULL,NULL),(10755,1403,'1295602','834','00','005010X220A1','1295602','','2013-12-23','18:14:25',0,'2013-12-26 13:02:25',NULL,NULL),(3694,633,'978110','834','00','005010X220A1','978110','','2013-12-12','11:01:54',0,'2013-12-25 22:07:19',NULL,NULL),(1213,243,'247003','834','00','005010X220A1','247003','','2013-12-24','08:04:01',0,'2013-12-25 18:48:09',NULL,NULL),(2250,378,'648746','834','00','005010X220A1','648746','','2013-12-02','12:54:51',0,'2013-12-25 19:49:56',NULL,NULL),(14695,2549,'1897783','834','00','005010X220A1','1897783','','2014-01-14','15:45:40',0,'2014-01-15 02:05:59',NULL,NULL),(13867,2311,'2005087','834','00','005010X220A1','2005087','','2014-01-09','11:46:30',0,'2014-01-13 02:19:23',NULL,NULL),(3401,589,'771250','834','00','005010X220A1','771250','','2013-12-17','08:08:47',0,'2013-12-25 21:51:44',NULL,NULL),(3890,704,'1238686','834','00','005010X220A1','1238686','','2013-10-26','04:35:51',0,'2013-12-25 22:31:54',NULL,NULL),(18177,3351,'2835842','834','00','005010X220A1','2835842','','2014-02-06','18:33:24',0,'2014-02-07 19:00:19',NULL,NULL),(19546,3626,'2530391','834','00','005010X220A1','2530391','','2014-02-13','19:50:08',0,'2014-02-14 21:30:58',NULL,NULL),(14657,2532,'2296569','834','00','005010X220A1','2296569','','2014-01-13','12:58:36',0,'2014-01-14 01:33:43',NULL,NULL),(627,108,'421692','834','00','005010X220A1','421692','','2013-12-16','11:11:31',0,'2013-12-25 18:04:30',NULL,NULL),(14144,2356,'2046951','834','00','005010X220A1','2046951','','2014-01-08','11:07:15',0,'2014-01-13 02:22:38',NULL,NULL),(11011,1414,'764051','834','00','005010X220A1','764051','','2013-12-23','10:18:34',0,'2013-12-26 13:11:10',NULL,NULL),(20989,3958,'3187161','834','00','005010X220A1','3187161','','2014-02-22','13:38:32',0,'2014-02-26 08:30:29',NULL,NULL),(22161,4180,'2634640','834','00','005010X220A1','2634640','','2014-03-03','11:02:13',0,'2014-03-03 21:31:03',NULL,NULL),(7752,1345,'1124231','834','00','005010X220A1','1124231','','2013-10-20','20:16:43',0,'2013-12-26 05:00:55',NULL,NULL),(14419,2440,'0001','999','BE','005010X231A1','1192756','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:31',NULL,NULL),(1044,204,'759915','834','00','005010X220A1','759915','','2013-11-28','19:38:36',0,'2013-12-25 18:30:06',NULL,NULL),(7145,1237,'367487','834','00','005010X220A1','367487','','2013-12-18','11:13:40',0,'2013-12-26 04:04:57',NULL,NULL),(7111,1236,'1245688','834','00','005010X220A1','1245688','','2013-12-18','13:55:22',0,'2013-12-26 04:03:54',NULL,NULL),(11047,1418,'1187666','834','00','005010X220A1','1187666','','2013-12-23','15:03:15',0,'2013-12-26 13:12:20',NULL,NULL),(3653,625,'237837','834','00','005010X220A1','237837','','2013-12-12','12:39:11',0,'2013-12-25 22:06:02',NULL,NULL),(3907,712,'308784','834','00','005010X220A1','308784','','2013-12-06','18:16:10',0,'2013-12-25 22:45:14',NULL,NULL),(17942,3299,'2738215','834','00','005010X220A1','2738215','','2014-02-04','21:18:56',0,'2014-02-05 21:30:50',NULL,NULL),(19995,3748,'3377440','834','00','005010X220A1','3377440','','2014-02-18','08:32:57',0,'2014-02-18 22:00:29',NULL,NULL),(14124,2350,'2342705','834','00','005010X220A1','2342705','','2014-01-08','00:07:22',0,'2014-01-13 02:22:26',NULL,NULL),(6411,1198,'1232856','834','00','005010X220A1','1232856','','2013-12-20','16:11:23',0,'2013-12-26 03:10:54',NULL,NULL),(11823,1540,'1268209','834','00','005010X220A1','1268209','','2013-12-28','20:08:59',1,'2013-12-29 11:13:49',NULL,NULL),(17679,3259,'2679348','834','00','005010X220A1','2679348','','2014-02-04','12:12:23',0,'2014-02-04 21:00:17',NULL,NULL),(19065,3542,'2772671','834','00','005010X220A1','2772671','','2014-02-12','15:44:37',0,'2014-02-12 21:31:12',NULL,NULL),(20652,3875,'3427195','834','00','005010X220A1','3427195','','2014-02-21','17:36:13',0,'2014-02-21 22:00:53',NULL,NULL),(21160,3997,'3487702','834','00','005010X220A1','3487702','','2014-02-26','15:36:06',0,'2014-02-26 21:00:49',NULL,NULL),(22146,4179,'3393284','834','00','005010X220A1','3393284','','2014-03-03','14:10:09',0,'2014-03-03 21:30:52',NULL,NULL),(22213,4186,'3065672','834','00','005010X220A1','3065672','','2014-03-03','17:33:25',0,'2014-03-03 21:31:40',NULL,NULL),(23278,4380,'3169267','834','00','005010X220A1','3169267','','2014-03-07','23:00:33',0,'2014-03-08 21:30:03',NULL,NULL),(15089,2585,'2554455','834','00','005010X220A1','2554455','','2014-01-15','16:19:38',0,'2014-01-16 08:45:12',NULL,NULL),(10833,1404,'1096362','834','00','005010X220A1','1096362','','2013-12-23','18:22:32',0,'2013-12-26 13:04:56',NULL,NULL),(1129,238,'618484','834','00','005010X220A1','618484','','2013-12-24','14:39:56',0,'2013-12-25 18:45:32',NULL,NULL),(2110,360,'1170605','834','00','005010X220A1','1170605','','2013-12-01','20:28:31',0,'2013-12-25 19:45:14',NULL,NULL),(1519,259,'98143','834','00','005010X220A1','98143','','2013-12-24','16:00:35',0,'2013-12-25 18:58:01',NULL,NULL),(16484,3010,'1773706','834','00','005010X220A1','1773706','','2014-01-24','00:05:22',0,'2014-01-24 21:00:32',NULL,NULL),(16666,3060,'2561150','834','00','005010X220A1','2561150','','2014-01-27','17:29:56',0,'2014-01-27 21:00:21',NULL,NULL),(21589,4056,'3479170','834','00','005010X220A1','3479170','','2014-02-26','15:04:22',0,'2014-02-28 07:00:30',NULL,NULL),(22008,4149,'3457684','834','00','005010X220A1','3457684','','2014-03-02','12:22:36',0,'2014-03-03 01:00:28',NULL,NULL),(23015,4325,'3605777','834','00','005010X220A1','3605777','','2014-03-06','22:56:12',0,'2014-03-07 21:00:18',NULL,NULL),(16290,2980,'1961937','834','00','005010X220A1','1961937','','2014-01-22','19:09:46',0,'2014-01-23 21:00:04',NULL,NULL),(16084,2778,'2381631','834','00','005010X220A1','2381631','','2014-01-22','16:33:50',0,'2014-01-23 03:02:52',NULL,NULL),(16004,2767,'2087234','834','00','005010X220A1','2087234','','2014-01-21','19:48:42',0,'2014-01-23 03:02:15',NULL,NULL),(15966,2764,'1953214','834','00','005010X220A1','1953214','','2014-01-22','10:41:04',0,'2014-01-23 03:01:57',NULL,NULL),(900,177,'529434','834','00','005010X220A1','529434','','2013-12-03','18:10:50',0,'2013-12-25 18:17:07',NULL,NULL),(1769,298,'769803','834','00','005010X220A1','769803','','2013-12-09','19:06:12',0,'2013-12-25 19:18:34',NULL,NULL),(1069,212,'819362','834','00','005010X220A1','819362','','2013-11-29','14:30:50',0,'2013-12-25 18:30:55',NULL,NULL),(1680,290,'311441','834','00','005010X220A1','311441','','2013-12-10','18:09:28',0,'2013-12-25 19:15:50',NULL,NULL),(12732,1684,'1385738','834','00','005010X220A1','1385738','','2014-01-02','14:27:01',0,'2014-01-03 02:06:02',NULL,NULL),(13099,1943,'0001','999','BE','005010X231A1','272694','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:35',NULL,NULL),(14000,2332,'2126573','834','00','005010X220A1','2126573','','2014-01-08','21:49:44',0,'2014-01-13 02:20:57',NULL,NULL),(15420,2629,'2538921','834','00','005010X220A1','2538921','','2014-01-16','09:33:39',0,'2014-01-17 03:35:57',NULL,NULL),(16816,3090,'2156115','834','00','005010X220A1','2156115','','2014-01-27','21:44:59',0,'2014-01-28 21:00:18',NULL,NULL),(17543,3235,'1788232','834','00','005010X220A1','1788232','','2014-02-03','16:41:13',0,'2014-02-03 21:00:22',NULL,NULL),(19770,3675,'2239693','834','00','005010X220A1','2239693','','2014-02-15','10:48:39',0,'2014-02-15 22:00:59',NULL,NULL),(19955,3744,'3452196','834','00','005010X220A1','3452196','','2014-02-18','16:35:38',0,'2014-02-18 21:30:23',NULL,NULL),(20178,3778,'3510172','834','00','005010X220A1','3510172','','2014-02-19','15:31:40',0,'2014-02-20 04:12:02',NULL,NULL),(15182,2591,'2088249','834','00','005010X220A1','2088249','','2014-01-15','15:56:01',0,'2014-01-16 08:46:14',NULL,NULL),(12083,1586,'1648583','834','00','005010X220A1','1648583','','2013-12-30','15:26:08',0,'2014-01-01 12:05:08',NULL,NULL),(10891,1409,'985898','834','00','005010X220A1','985898','','2013-12-22','21:42:50',0,'2013-12-26 13:07:20',NULL,NULL),(7524,1300,'949745','834','00','005010X220A1','949745','','2013-12-21','12:57:30',0,'2013-12-26 04:34:47',NULL,NULL),(11930,1570,'2216334','834','00','005010X220A1','2216334','','2013-12-29','12:18:10',0,'2013-12-30 00:01:58',NULL,NULL),(17283,3171,'1909041','834','00','005010X220A1','1909041','','2014-01-31','13:20:08',0,'2014-01-31 21:00:30',NULL,NULL),(17581,3237,'1490750','834','00','005010X220A1','1490750','','2014-02-03','11:09:15',0,'2014-02-03 21:00:45',NULL,NULL),(19872,3708,'3220431','834','00','005010X220A1','3220431','','2014-02-16','17:09:55',0,'2014-02-16 19:00:18',NULL,NULL),(20828,3911,'3472609','834','00','005010X220A1','3472609','','2014-02-24','19:50:07',0,'2014-02-25 21:31:14',NULL,NULL),(23523,4434,'3550171','834','00','005010X220A1','3550171','','2014-03-10','16:18:06',0,'2014-03-10 21:00:19',NULL,NULL),(12762,1696,'1432738','834','00','005010X220A1','1432738','','2014-01-02','13:58:03',0,'2014-01-03 02:07:10',NULL,NULL),(5454,1037,'400527','834','00','005010X220A1','400527','','2013-11-03','17:06:01',0,'2013-12-26 01:32:09',NULL,NULL),(588,105,'1298912','834','00','005010X220A1','1298912','','2013-12-15','18:44:27',0,'2013-12-25 18:03:11',NULL,NULL),(975,184,'371501','834','00','005010X220A1','371501','','2013-12-03','07:06:25',0,'2013-12-25 18:19:25',NULL,NULL),(6129,1166,'1030038','834','00','005010X220A1','1030038','','2013-12-20','15:26:49',0,'2013-12-26 03:02:13',NULL,NULL),(12062,1586,'2271343','834','00','005010X220A1','2271343','','2013-12-29','20:46:00',0,'2014-01-01 12:04:26',NULL,NULL),(3076,545,'682326','834','00','005010X220A1','682326','','2013-12-13','11:17:23',0,'2013-12-25 21:35:28',NULL,NULL),(5479,1040,'2053015','834','00','005010X220A1','2053015','','2013-12-24','23:41:55',0,'2013-12-26 01:45:44',NULL,NULL),(5344,1002,'962761','834','00','005010X220A1','962761','','2013-11-25','14:05:17',0,'2013-12-26 01:15:39',NULL,NULL),(7688,1329,'499890','834','00','005010X220A1','499890','','2013-11-14','19:09:52',0,'2013-12-26 04:45:02',NULL,NULL),(11578,1492,'1584240','834','00','005010X220A1','1584240','','2013-12-27','15:55:24',0,'2013-12-28 03:34:04',NULL,NULL),(15578,2658,'1458832','834','00','005010X220A1','1458832','','2014-01-17','11:24:12',0,'2014-01-20 08:06:09',NULL,NULL),(16167,2859,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:20:00',1,'2014-01-23 04:16:03',NULL,NULL),(16561,3034,'1674331','834','00','005010X220A1','1674331','','2014-01-24','18:28:00',0,'2014-01-25 19:00:02',NULL,NULL),(16723,3064,'1801409','834','00','005010X220A1','1801409','','2014-01-27','16:11:04',0,'2014-01-27 21:00:59',NULL,NULL),(17338,3178,'1430758','834','00','005010X220A1','1430758','','2014-01-31','08:51:46',0,'2014-01-31 21:01:08',NULL,NULL),(21739,4090,'2522072','834','00','005010X220A1','2522072','','2014-02-27','19:06:08',0,'2014-02-28 21:30:40',NULL,NULL),(152,10,'394463','834','00','005010X220A1','394463','','2013-12-05','13:57:04',0,'2013-12-25 17:19:43',NULL,NULL),(14609,2522,'2347890','834','00','005010X220A1','2347890','','2014-01-12','22:35:38',0,'2014-01-14 01:33:12',NULL,NULL),(503,102,'1115507','834','00','005010X220A1','1115507','','2013-12-16','10:05:27',0,'2013-12-25 18:00:33',NULL,NULL),(5720,1069,'1127482','834','00','005010X220A1','1127482','','2013-12-14','12:07:55',0,'2013-12-26 02:01:02',NULL,NULL),(14387,2413,'2139385','834','00','005010X220A1','2139385','','2014-01-12','13:40:24',0,'2014-01-13 03:01:53',NULL,NULL),(14355,2404,'2009136','834','00','005010X220A1','2009136','','2014-01-12','09:31:17',0,'2014-01-13 03:01:30',NULL,NULL),(12187,1603,'1327617','834','00','005010X220A1','1327617','','2013-12-30','10:29:37',0,'2014-01-01 12:08:50',NULL,NULL),(12081,1586,'1489871','834','00','005010X220A1','1489871','','2013-12-30','14:13:30',0,'2014-01-01 12:05:03',NULL,NULL),(3877,697,'14859','834','00','005010X220A1','14859','','2013-10-04','15:21:11',0,'2013-12-25 22:31:27',NULL,NULL),(4546,825,'573279','834','00','005010X220A1','573279','','2013-12-23','22:37:01',0,'2013-12-25 23:45:33',NULL,NULL),(4632,827,'1778019','834','00','005010X220A1','1778019','','2013-12-23','23:18:35',0,'2013-12-25 23:48:19',NULL,NULL),(21566,4053,'2815847','834','00','005010X220A1','2815847','','2014-02-26','15:27:17',0,'2014-02-28 07:00:10',NULL,NULL),(23600,4439,'3743533','834','00','005010X220A1','3743533','','2014-03-09','19:13:18',0,'2014-03-10 21:01:17',NULL,NULL),(134,8,'88371','834','00','005010X220A1','88371','','2013-12-05','12:42:19',0,'2013-12-25 17:19:09',NULL,NULL),(14628,2524,'2367916','834','00','005010X220A1','2367916','','2014-01-13','16:16:43',0,'2014-01-14 01:33:24',NULL,NULL),(13679,2272,'1897585','834','00','005010X220A1','1897585','','2014-01-07','11:08:11',0,'2014-01-08 18:24:21',NULL,NULL),(12044,1583,'19029','834','00','005010X220A1','19029','','2013-12-30','17:32:41',0,'2014-01-01 12:03:44',NULL,NULL),(7017,1235,'1290286','834','00','005010X220A1','1290286','','2013-12-18','10:05:54',0,'2013-12-26 04:01:01',NULL,NULL),(7712,1334,'166519','834','00','005010X220A1','166519','','2013-11-15','01:13:05',0,'2013-12-26 04:45:53',NULL,NULL),(11334,1456,'1915404','834','00','005010X220A1','1915404','','2013-12-26','15:49:36',0,'2013-12-27 02:04:32',NULL,NULL),(16895,3099,'2166541','834','00','005010X220A1','2166541','','2014-01-28','10:42:16',0,'2014-01-28 21:01:10',NULL,NULL),(19812,3679,'3398914','834','00','005010X220A1','3398914','','2014-02-14','18:45:06',0,'2014-02-15 22:01:32',NULL,NULL),(21204,3998,'2671081','834','00','005010X220A1','2671081','','2014-02-26','15:36:33',0,'2014-02-26 21:01:19',NULL,NULL),(21371,4024,'3193119','834','00','005010X220A1','3193119','','2014-02-27','11:44:02',0,'2014-02-28 06:30:21',NULL,NULL),(14035,2337,'2546497','834','00','005010X220A1','2546497','','2014-01-08','15:07:07',0,'2014-01-13 02:21:27',NULL,NULL),(3393,588,'1003290','834','00','005010X220A1','1003290','','2013-12-17','11:25:19',0,'2013-12-25 21:51:27',NULL,NULL),(1207,243,'29429','834','00','005010X220A1','29429','','2013-12-24','04:31:45',0,'2013-12-25 18:48:00',NULL,NULL),(12378,1637,'1924335','834','00','005010X220A1','1924335','','2013-12-30','18:53:49',1,'2014-01-02 04:28:52',NULL,NULL),(11853,1550,'1608522','834','00','005010X220A1','1608522','','2013-12-28','20:15:22',1,'2013-12-29 11:14:54',NULL,NULL),(17927,3296,'2314640','834','00','005010X220A1','2314640','','2014-02-05','13:52:02',0,'2014-02-05 21:30:43',NULL,NULL),(18698,3478,'2664155','834','00','005010X220A1','2664155','','2014-02-10','12:58:37',0,'2014-02-10 21:32:12',NULL,NULL),(19600,3632,'3367808','834','00','005010X220A1','3367808','','2014-02-13','19:28:51',0,'2014-02-14 21:31:38',NULL,NULL),(21694,4087,'2809179','834','00','005010X220A1','2809179','','2014-02-28','10:31:01',0,'2014-02-28 21:30:06',NULL,NULL),(21732,4089,'3383122','834','00','005010X220A1','3383122','','2014-02-27','18:19:39',0,'2014-02-28 21:30:34',NULL,NULL),(22352,4205,'3357654','834','00','005010X220A1','3357654','','2014-03-03','22:44:36',0,'2014-03-04 21:01:40',NULL,NULL),(11749,1521,'1290923','834','00','005010X220A1','1290923','','2013-12-28','15:50:37',1,'2013-12-29 11:09:25',NULL,NULL),(2146,360,'1259918','834','00','005010X220A1','1259918','','2013-12-02','16:44:46',0,'2013-12-25 19:46:21',NULL,NULL),(743,131,'1251815','834','00','005010X220A1','1251815','','2013-12-16','12:43:22',0,'2013-12-25 18:08:08',NULL,NULL),(15619,2670,'1936568','834','00','005010X220A1','1936568','','2014-01-17','17:29:28',0,'2014-01-20 08:06:40',NULL,NULL),(18650,3464,'2307298','834','00','005010X220A1','2307298','','2014-02-10','10:30:10',0,'2014-02-10 21:31:40',NULL,NULL),(18693,3475,'2436887','834','00','005010X220A1','2436887','','2014-02-10','12:24:14',0,'2014-02-10 21:32:08',NULL,NULL),(19261,3581,'2620541','834','00','005010X220A1','2620541','','2014-02-13','14:11:18',0,'2014-02-13 22:00:43',NULL,NULL),(20170,3778,'3536173','834','00','005010X220A1','3536173','','2014-02-19','11:31:31',0,'2014-02-20 04:09:37',NULL,NULL),(20319,3794,'3234539','834','00','005010X220A1','3234539','','2014-02-19','16:54:54',0,'2014-02-20 04:48:04',NULL,NULL),(21701,4087,'3505387','834','00','005010X220A1','3505387','','2014-02-28','14:31:23',0,'2014-02-28 21:30:13',NULL,NULL),(22050,4167,'3294506','834','00','005010X220A1','3294506','','2014-03-03','10:49:32',0,'2014-03-03 21:00:10',NULL,NULL),(22132,4179,'3758951','834','00','005010X220A1','3758951','','2014-03-03','08:50:53',0,'2014-03-03 21:30:42',NULL,NULL),(14354,2404,'2054800','834','00','005010X220A1','2054800','','2014-01-11','21:00:36',0,'2014-01-13 03:01:28',NULL,NULL),(14014,2337,'1645352','834','00','005010X220A1','1645352','','2014-01-07','21:58:03',0,'2014-01-13 02:21:15',NULL,NULL),(1385,245,'1298231','834','00','005010X220A1','1298231','','2013-12-24','17:01:54',0,'2013-12-25 18:53:32',NULL,NULL),(1438,252,'1871005','834','00','005010X220A1','1871005','','2013-12-24','10:31:30',0,'2013-12-25 18:55:17',NULL,NULL),(6025,1140,'929552','834','00','005010X220A1','929552','','2013-11-17','11:45:48',0,'2013-12-26 02:45:43',NULL,NULL),(2049,335,'538176','834','00','005010X220A1','538176','','2013-12-09','12:47:19',0,'2013-12-25 19:36:22',NULL,NULL),(11569,1492,'759583','834','00','005010X220A1','759583','','2013-12-27','14:29:35',0,'2013-12-28 03:33:48',NULL,NULL),(5017,935,'1040265','834','00','005010X220A1','1040265','','2013-12-11','11:24:27',0,'2013-12-26 00:46:30',NULL,NULL),(10600,1402,'1608464','834','00','005010X220A1','1608464','','2013-12-23','13:02:05',0,'2013-12-26 12:57:10',NULL,NULL),(7101,1236,'908703','834','00','005010X220A1','908703','','2013-12-18','12:21:06',0,'2013-12-26 04:03:37',NULL,NULL),(18013,3318,'2231029','834','00','005010X220A1','2231029','','2014-02-05','18:36:29',0,'2014-02-06 21:00:16',NULL,NULL),(18207,3356,'2831259','834','00','005010X220A1','2831259','','2014-02-06','20:46:23',0,'2014-02-07 19:00:39',NULL,NULL),(19020,3539,'2461058','834','00','005010X220A1','2461058','','2014-02-12','10:17:34',0,'2014-02-12 21:30:40',NULL,NULL),(19917,3727,'3314708','834','00','005010X220A1','3314708','','2014-02-17','01:17:08',0,'2014-02-17 19:00:11',NULL,NULL),(22547,4248,'3275468','834','00','005010X220A1','3275468','','2014-03-05','09:45:46',0,'2014-03-05 21:30:42',NULL,NULL),(23146,4342,'3830089','834','00','005010X220A1','3830089','','2014-03-07','15:59:29',0,'2014-03-07 21:31:07',NULL,NULL),(6442,1207,'589649','834','00','005010X220A1','589649','','2013-11-21','23:34:22',0,'2013-12-26 03:15:50',NULL,NULL),(6280,1172,'1008180','834','00','005010X220A1','1008180','','2013-12-20','15:16:26',0,'2013-12-26 03:06:51',NULL,NULL),(1689,291,'853582','834','00','005010X220A1','853582','','2013-12-10','15:45:27',0,'2013-12-25 19:16:10',NULL,NULL),(14939,2561,'2432627','834','00','005010X220A1','2432627','','2014-01-14','14:59:22',0,'2014-01-15 02:07:47',NULL,NULL),(2973,541,'1080660','834','00','005010X220A1','1080660','','2013-12-13','15:18:46',0,'2013-12-25 21:32:20',NULL,NULL),(13186,2030,'0001','999','BE','005010X231A1','1129316','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:13',NULL,NULL),(12640,1672,'2232865','834','00','005010X220A1','2232865','','2014-01-02','14:47:35',0,'2014-01-03 02:02:31',NULL,NULL),(5824,1088,'586159','834','00','005010X220A1','586159','','2013-11-23','09:20:07',0,'2013-12-26 02:15:12',NULL,NULL),(10550,1402,'298570','834','00','005010X220A1','298570','','2013-12-22','20:57:53',0,'2013-12-26 12:55:32',NULL,NULL),(4359,763,'118561','834','00','005010X220A1','118561','','2013-12-19','14:12:17',0,'2013-12-25 23:11:03',NULL,NULL),(4402,776,'1217790','834','00','005010X220A1','1217790','','2013-11-27','17:59:55',0,'2013-12-25 23:16:00',NULL,NULL),(10399,1400,'976126','834','00','005010X220A1','976126','','2013-12-23','08:21:18',0,'2013-12-26 12:50:41',NULL,NULL),(15363,2624,'1753017','834','00','005010X220A1','1753017','','2014-01-15','18:36:42',0,'2014-01-17 03:35:29',NULL,NULL),(18519,3450,'3017763','834','00','005010X220A1','3017763','','2014-02-10','16:45:02',0,'2014-02-10 21:30:05',NULL,NULL),(20276,3794,'3457376','834','00','005010X220A1','3457376','','2014-02-19','09:35:47',0,'2014-02-20 04:37:08',NULL,NULL),(20899,3926,'2892332','834','00','005010X220A1','2892332','','2014-02-25','17:30:51',0,'2014-02-25 21:32:08',NULL,NULL),(5560,1043,'2097477','834','00','005010X220A1','2097477','','2013-12-24','19:23:19',0,'2013-12-26 01:48:22',NULL,NULL),(254,46,'1203641','834','00','005010X220A1','1203641','','2013-11-13','16:27:28',0,'2013-12-25 17:31:00',NULL,NULL),(4753,858,'882411','834','00','005010X220A1','882411','','2013-11-30','18:54:44',0,'2013-12-26 00:00:24',NULL,NULL),(3871,693,'730824','834','00','005010X220A1','730824','','2013-10-10','13:32:49',0,'2013-12-25 22:31:14',NULL,NULL),(19517,3622,'3334007','834','00','005010X220A1','3334007','','2014-02-13','22:27:23',0,'2014-02-14 21:30:37',NULL,NULL),(19865,3707,'1842906','834','00','005010X220A1','1842906','','2014-02-15','19:27:20',0,'2014-02-16 19:00:12',NULL,NULL),(13858,2311,'1948388','834','00','005010X220A1','1948388','','2014-01-08','19:10:13',0,'2014-01-13 02:19:18',NULL,NULL),(3584,617,'889427','834','00','005010X220A1','889427','','2013-12-12','14:02:54',0,'2013-12-25 22:03:52',NULL,NULL),(12695,1674,'1402252','834','00','005010X220A1','1402252','','2014-01-02','11:03:18',0,'2014-01-03 02:04:35',NULL,NULL),(12244,1619,'2374661','834','00','005010X220A1','2374661','','2013-12-31','23:49:13',1,'2014-01-02 04:23:12',NULL,NULL),(10949,1410,'363741','834','00','005010X220A1','363741','','2013-12-23','17:29:38',0,'2013-12-26 13:09:11',NULL,NULL),(21767,4090,'3658755','834','00','005010X220A1','3658755','','2014-02-28','16:13:10',0,'2014-02-28 21:30:58',NULL,NULL),(15605,2663,'2021919','834','00','005010X220A1','2021919','','2014-01-17','10:35:26',0,'2014-01-20 08:06:29',NULL,NULL),(6201,1168,'616846','834','00','005010X220A1','616846','','2013-12-19','19:23:26',0,'2013-12-26 03:04:22',NULL,NULL),(10506,1400,'1707354','834','00','005010X220A1','1707354','','2013-12-23','18:37:13',0,'2013-12-26 12:54:03',NULL,NULL),(5771,1072,'884092','834','00','005010X220A1','884092','','2013-12-14','16:41:46',0,'2013-12-26 02:02:34',NULL,NULL),(16285,2977,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:24:00',0,'2014-01-23 17:30:02',NULL,NULL),(16436,3006,'2056537','834','00','005010X220A1','2056537','','2014-01-24','11:44:57',0,'2014-01-24 21:00:04',NULL,NULL),(18521,3451,'1876176','834','00','005010X220A1','1876176','','2014-02-09','18:34:27',0,'2014-02-10 21:30:07',NULL,NULL),(19236,3580,'2602514','834','00','005010X220A1','2602514','','2014-02-13','12:56:17',0,'2014-02-13 22:00:24',NULL,NULL),(19464,3617,'3356007','834','00','005010X220A1','3356007','','2014-02-13','17:02:59',0,'2014-02-13 22:03:20',NULL,NULL),(21140,3996,'3261581','834','00','005010X220A1','3261581','','2014-02-26','15:00:23',0,'2014-02-26 21:00:38',NULL,NULL),(772,144,'103765','834','00','005010X220A1','103765','','2013-10-29','12:26:02',0,'2013-12-25 18:09:07',NULL,NULL),(1011,188,'704364','834','00','005010X220A1','704364','','2013-12-03','12:03:15',0,'2013-12-25 18:20:36',NULL,NULL),(15020,2584,'2295561','834','00','005010X220A1','2295561','','2014-01-15','09:30:46',0,'2014-01-16 08:44:30',NULL,NULL),(12277,1623,'1800773','834','00','005010X220A1','1800773','','2014-01-01','14:50:51',1,'2014-01-02 04:24:26',NULL,NULL),(19911,3725,'2304755','834','00','005010X220A1','2304755','','2014-02-16','20:23:09',0,'2014-02-17 19:00:06',NULL,NULL),(22673,4255,'2901208','834','00','005010X220A1','2901208','','2014-03-05','11:00:11',0,'2014-03-05 21:32:08',NULL,NULL),(22890,4282,'3266994','834','00','005010X220A1','3266994','','2014-03-06','13:47:16',0,'2014-03-06 21:02:08',NULL,NULL),(23652,4442,'2719365','834','00','005010X220A1','2719365','','2014-03-09','21:04:19',0,'2014-03-10 21:01:52',NULL,NULL),(7390,1293,'912346','834','00','005010X220A1','912346','','2013-12-21','13:51:25',0,'2013-12-26 04:30:31',NULL,NULL),(15585,2659,'2296747','834','00','005010X220A1','2296747','','2014-01-17','11:55:40',0,'2014-01-20 08:06:16',NULL,NULL),(4851,884,'1136654','834','00','005010X220A1','1136654','','2013-11-21','12:46:05',0,'2013-12-26 00:15:38',NULL,NULL),(15005,2584,'2273852','834','00','005010X220A1','2273852','','2014-01-14','23:08:08',0,'2014-01-16 08:44:20',NULL,NULL),(12811,1703,'1553889','834','00','005010X220A1','1553889','','2014-01-03','17:00:36',0,'2014-01-04 02:01:40',NULL,NULL),(12482,1640,'1313908','834','00','005010X220A1','1313908','','2013-12-31','14:43:20',1,'2014-01-02 04:32:34',NULL,NULL),(15868,2738,'1368003','834','00','005010X220A1','1368003','','2014-01-21','18:00:20',1,'2014-01-22 03:22:19',NULL,NULL),(16159,2851,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:07:00',1,'2014-01-23 04:09:32',NULL,NULL),(21814,4093,'3133045','834','00','005010X220A1','3133045','','2014-02-28','14:21:06',0,'2014-02-28 21:31:30',NULL,NULL),(551,103,'1017771','834','00','005010X220A1','1017771','','2013-12-16','08:58:44',0,'2013-12-25 18:02:03',NULL,NULL),(684,109,'1179508','834','00','005010X220A1','1179508','','2013-12-16','15:11:55',0,'2013-12-25 18:06:13',NULL,NULL),(1119,238,'1411995','834','00','005010X220A1','1411995','','2013-12-24','12:47:36',0,'2013-12-25 18:45:14',NULL,NULL),(14009,2337,'2083597','834','00','005010X220A1','2083597','','2014-01-07','21:08:25',0,'2014-01-13 02:21:11',NULL,NULL),(11215,1454,'855837','834','00','005010X220A1','855837','','2013-12-26','09:58:56',0,'2013-12-27 02:00:55',NULL,NULL),(17666,3258,'1830853','834','00','005010X220A1','1830853','','2014-02-04','14:52:56',0,'2014-02-04 21:00:08',NULL,NULL),(17759,3262,'1682644','834','00','005010X220A1','1682644','','2014-02-04','15:02:29',0,'2014-02-04 21:01:06',NULL,NULL),(23443,4407,'3057369','834','00','005010X220A1','3057369','','2014-03-09','15:25:27',0,'2014-03-09 21:00:44',NULL,NULL),(23535,4435,'3405257','834','00','005010X220A1','3405257','','2014-03-10','09:21:06',0,'2014-03-10 21:00:27',NULL,NULL),(10384,1400,'210589','834','00','005010X220A1','210589','','2013-12-22','22:03:34',0,'2013-12-26 12:50:13',NULL,NULL),(7691,1330,'217623','834','00','005010X220A1','217623','','2013-11-15','11:29:23',0,'2013-12-26 04:45:08',NULL,NULL),(12061,1586,'840879','834','00','005010X220A1','840879','','2013-12-29','19:17:59',0,'2014-01-01 12:04:24',NULL,NULL),(10927,1410,'1632647','834','00','005010X220A1','1632647','','2013-12-23','11:43:30',0,'2013-12-26 13:08:32',NULL,NULL),(7189,1239,'1036483','834','00','005010X220A1','1036483','','2013-12-18','11:58:51',0,'2013-12-26 04:06:18',NULL,NULL),(2552,458,'344230','834','00','005010X220A1','344230','','2013-11-18','17:26:50',0,'2013-12-25 20:31:37',NULL,NULL),(19117,3545,'2043948','834','00','005010X220A1','2043948','','2014-02-12','17:20:14',0,'2014-02-12 21:31:48',NULL,NULL),(20664,3877,'2780452','834','00','005010X220A1','2780452','','2014-02-21','16:36:18',0,'2014-02-21 22:01:02',NULL,NULL),(2426,417,'1157347','834','00','005010X220A1','1157347','','2013-12-06','12:29:31',0,'2013-12-25 20:18:04',NULL,NULL),(5046,936,'927117','834','00','005010X220A1','927117','','2013-12-10','19:08:55',0,'2013-12-26 00:47:26',NULL,NULL),(13436,2223,'2430423','834','00','005010X220A1','2430423','','2014-01-06','12:31:49',0,'2014-01-07 04:02:10',NULL,NULL),(3917,712,'960488','834','00','005010X220A1','960488','','2013-12-07','12:43:15',0,'2013-12-25 22:45:33',NULL,NULL),(13333,2177,'0001','999','BE','005010X231A1','412866','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:44',NULL,NULL),(20160,3777,'2604881','834','00','005010X220A1','2604881','','2014-02-18','20:59:49',0,'2014-02-20 04:06:29',NULL,NULL),(20724,3898,'3441086','834','00','005010X220A1','3441086','','2014-02-25','10:09:49',0,'2014-02-25 21:00:29',NULL,NULL),(23394,4403,'3245022','834','00','005010X220A1','3245022','','2014-03-08','18:17:38',0,'2014-03-09 21:00:07',NULL,NULL),(23496,4434,'2949689','834','00','005010X220A1','2949689','','2014-03-09','19:51:03',0,'2014-03-10 21:00:00',NULL,NULL),(610,108,'115934','834','00','005010X220A1','115934','','2013-12-15','20:49:10',0,'2013-12-25 18:03:55',NULL,NULL),(15512,2644,'2005353','834','00','005010X220A1','2005353','','2014-01-16','13:49:39',0,'2014-01-17 03:36:36',NULL,NULL),(5831,1090,'1006438','834','00','005010X220A1','1006438','','2013-11-23','17:46:46',0,'2013-12-26 02:15:26',NULL,NULL),(3119,547,'1026307','834','00','005010X220A1','1026307','','2013-12-13','14:52:34',0,'2013-12-25 21:36:45',NULL,NULL),(16240,2932,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:13:00',0,'2014-01-23 06:45:09',NULL,NULL),(17095,3142,'2323115','834','00','005010X220A1','2323115','','2014-01-29','18:23:45',0,'2014-01-30 21:00:03',NULL,NULL),(19916,3726,'3229522','834','00','005010X220A1','3229522','','2014-02-17','00:28:21',0,'2014-02-17 19:00:10',NULL,NULL),(20280,3795,'2603864','834','00','005010X220A1','2603864','','2014-02-19','10:16:12',0,'2014-02-20 04:37:56',NULL,NULL),(6351,1179,'1177580','834','00','005010X220A1','1177580','','2013-12-19','21:11:18',0,'2013-12-26 03:08:55',NULL,NULL),(5801,1078,'1020144','834','00','005010X220A1','1020144','','2013-12-14','10:41:13',0,'2013-12-26 02:03:34',NULL,NULL),(10904,1409,'1099018','834','00','005010X220A1','1099018','','2013-12-23','14:58:39',0,'2013-12-26 13:07:46',NULL,NULL),(2126,360,'656571','834','00','005010X220A1','656571','','2013-12-02','14:06:46',0,'2013-12-25 19:45:42',NULL,NULL),(4482,802,'589671','834','00','005010X220A1','589671','','2013-11-26','11:54:15',0,'2013-12-25 23:31:27',NULL,NULL),(18743,3485,'3234304','834','00','005010X220A1','3234304','','2014-02-11','13:05:42',0,'2014-02-11 21:00:32',NULL,NULL),(5385,1011,'617457','834','00','005010X220A1','617457','','2013-11-25','16:00:00',0,'2013-12-26 01:17:02',NULL,NULL),(14010,2337,'1637136','834','00','005010X220A1','1637136','','2014-01-07','21:21:44',0,'2014-01-13 02:21:12',NULL,NULL),(2503,447,'916205','834','00','005010X220A1','916205','','2013-10-12','18:56:38',0,'2013-12-25 20:30:08',NULL,NULL),(1374,245,'1998914','834','00','005010X220A1','1998914','','2013-12-24','15:49:04',0,'2013-12-25 18:53:09',NULL,NULL),(17296,3172,'2269770','834','00','005010X220A1','2269770','','2014-01-31','15:14:04',0,'2014-01-31 21:00:39',NULL,NULL),(19392,3593,'2511734','834','00','005010X220A1','2511734','','2014-02-13','10:24:09',0,'2014-02-13 22:02:24',NULL,NULL),(22222,4190,'3750099','834','00','005010X220A1','3750099','','2014-03-03','15:00:29',0,'2014-03-03 21:31:48',NULL,NULL),(22583,4248,'3654657','834','00','005010X220A1','3654657','','2014-03-05','16:21:02',0,'2014-03-05 21:31:06',NULL,NULL),(22899,4284,'3500231','834','00','005010X220A1','3500231','','2014-03-06','15:47:46',0,'2014-03-06 21:02:15',NULL,NULL),(1504,258,'1147835','834','00','005010X220A1','1147835','','2013-12-24','11:20:02',0,'2013-12-25 18:57:29',NULL,NULL),(11447,1488,'2170893','834','00','005010X220A1','2170893','','2013-12-26','18:34:40',0,'2013-12-28 03:30:04',NULL,NULL),(7245,1244,'1215925','834','00','005010X220A1','1215925','','2013-12-17','20:35:29',0,'2013-12-26 04:08:02',NULL,NULL),(7009,1235,'317041','834','00','005010X220A1','317041','','2013-12-17','22:57:50',0,'2013-12-26 04:00:47',NULL,NULL),(5121,942,'693085','834','00','005010X220A1','693085','','2013-12-11','11:53:48',0,'2013-12-26 00:49:55',NULL,NULL),(18684,3471,'3031708','834','00','005010X220A1','3031708','','2014-02-10','10:21:23',0,'2014-02-10 21:32:02',NULL,NULL),(20960,3954,'3087640','834','00','005010X220A1','3087640','','2014-02-23','13:02:15',0,'2014-02-26 08:00:49',NULL,NULL),(21959,4141,'2650951','834','00','005010X220A1','2650951','','2014-03-01','18:25:22',0,'2014-03-03 01:00:01',NULL,NULL),(5710,1069,'1093488','834','00','005010X220A1','1093488','','2013-12-13','20:53:22',0,'2013-12-26 02:00:46',NULL,NULL),(1409,247,'1484836','834','00','005010X220A1','1484836','','2013-12-24','16:03:17',0,'2013-12-25 18:54:19',NULL,NULL),(3973,717,'987697','834','00','005010X220A1','987697','','2013-12-07','05:40:57',0,'2013-12-25 22:47:21',NULL,NULL),(4136,733,'860734','834','00','005010X220A1','860734','','2013-12-19','15:56:00',0,'2013-12-25 23:04:16',NULL,NULL),(16918,3114,'1411685','834','00','005010X220A1','1411685','','2014-01-28','18:25:49',0,'2014-01-29 21:00:03',NULL,NULL),(17771,3264,'2389270','834','00','005010X220A1','2389270','','2014-02-04','14:07:46',0,'2014-02-04 21:01:12',NULL,NULL),(19852,3697,'3581516','834','00','005010X220A1','3581516','','2014-02-15','15:40:20',0,'2014-02-15 22:02:08',NULL,NULL),(20269,3796,'3187054','834','00','005010X220A1','3187054','','2014-02-18','22:31:44',0,'2014-02-20 04:35:32',NULL,NULL),(22367,4205,'3849794','834','00','005010X220A1','3849794','','2014-03-04','15:23:20',0,'2014-03-04 21:01:52',NULL,NULL),(19224,3580,'3055371','834','00','005010X220A1','3055371','','2014-02-13','01:12:12',0,'2014-02-13 22:00:12',NULL,NULL),(15980,2764,'1488150','834','00','005010X220A1','1488150','','2014-01-22','17:48:10',0,'2014-01-23 03:02:04',NULL,NULL),(12141,1590,'1938154','834','00','005010X220A1','1938154','','2013-12-30','16:34:57',0,'2014-01-01 12:07:09',NULL,NULL),(12108,1587,'1832746','834','00','005010X220A1','1832746','','2013-12-30','12:10:17',0,'2014-01-01 12:05:59',NULL,NULL),(3475,615,'59518','834','00','005010X220A1','59518','','2013-12-12','07:21:07',0,'2013-12-25 22:00:23',NULL,NULL),(4741,854,'1847770','834','00','005010X220A1','1847770','','2013-12-24','01:36:02',0,'2013-12-25 23:52:09',NULL,NULL),(18048,3319,'2733162','834','00','005010X220A1','2733162','','2014-02-06','10:18:37',0,'2014-02-06 21:00:40',NULL,NULL),(93,4,'937556','834','00','005010X220A1','937556','','2013-12-05','11:19:16',0,'2013-12-25 17:17:49',NULL,NULL),(538,102,'1215859','834','00','005010X220A1','1215859','','2013-12-16','16:52:29',0,'2013-12-25 18:01:38',NULL,NULL),(4940,919,'269301','834','00','005010X220A1','269301','','2013-11-19','12:15:04',0,'2013-12-26 00:31:28',NULL,NULL),(13541,2241,'2497401','834','00','005010X220A1','2497401','','2014-01-06','05:19:10',0,'2014-01-07 04:06:06',NULL,NULL),(13101,1945,'0001','999','BE','005010X231A1','552645','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:41',NULL,NULL),(11644,1499,'1767831','834','00','005010X220A1','1767831','','2013-12-27','09:56:45',0,'2013-12-28 03:36:04',NULL,NULL),(6023,1140,'377131','834','00','005010X220A1','377131','','2013-11-17','09:01:26',0,'2013-12-26 02:45:39',NULL,NULL),(4041,731,'969596','834','00','005010X220A1','969596','','2013-12-19','16:23:07',0,'2013-12-25 23:01:22',NULL,NULL),(4356,762,'844643','834','00','005010X220A1','844643','','2013-12-19','13:07:44',0,'2013-12-25 23:10:59',NULL,NULL),(15401,2626,'1447884','834','00','005010X220A1','1447884','','2014-01-15','23:36:19',0,'2014-01-17 03:35:47',NULL,NULL),(21334,4022,'2748219','834','00','005010X220A1','2748219','','2014-02-26','19:32:40',0,'2014-02-28 06:30:04',NULL,NULL),(22424,4222,'3389550','834','00','005010X220A1','3389550','','2014-03-04','13:42:52',0,'2014-03-04 21:02:40',NULL,NULL),(595,107,'199099','834','00','005010X220A1','199099','','2013-12-15','23:48:05',0,'2013-12-25 18:03:25',NULL,NULL),(10392,1400,'362209','834','00','005010X220A1','362209','','2013-12-23','05:16:23',0,'2013-12-26 12:50:28',NULL,NULL),(7610,1303,'506672','834','00','005010X220A1','506672','','2013-12-21','13:58:10',0,'2013-12-26 04:37:34',NULL,NULL),(5888,1109,'923476','834','00','005010X220A1','923476','','2013-12-15','17:06:18',0,'2013-12-26 02:30:22',NULL,NULL),(19467,3620,'3321906','834','00','005010X220A1','3321906','','2014-02-13','18:16:19',0,'2014-02-14 21:30:02',NULL,NULL),(19610,3635,'2911456','834','00','005010X220A1','2911456','','2014-02-14','02:09:34',0,'2014-02-14 21:31:44',NULL,NULL),(23550,4435,'3029923','834','00','005010X220A1','3029923','','2014-03-10','16:07:58',0,'2014-03-10 21:00:40',NULL,NULL),(14071,2340,'2541327','834','00','005010X220A1','2541327','','2014-01-08','09:05:10',0,'2014-01-13 02:21:50',NULL,NULL),(5794,1075,'1023797','834','00','005010X220A1','1023797','','2013-12-14','17:23:21',0,'2013-12-26 02:03:19',NULL,NULL),(3718,635,'1256586','834','00','005010X220A1','1256586','','2013-12-12','15:30:53',0,'2013-12-25 22:08:08',NULL,NULL),(2938,541,'378591','834','00','005010X220A1','378591','','2013-12-12','21:39:48',0,'2013-12-25 21:31:11',NULL,NULL),(13484,2226,'1428673','834','00','005010X220A1','1428673','','2014-01-06','14:07:24',0,'2014-01-07 04:04:03',NULL,NULL),(7230,1241,'1084759','834','00','005010X220A1','1084759','','2013-12-18','15:38:50',0,'2013-12-26 04:07:33',NULL,NULL),(13081,1925,'0001','999','BE','005010X231A1','630417','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:46',NULL,NULL),(13275,2119,'0001','999','BE','005010X231A1','940340','834','2013-12-28','04:55:00',0,'2014-01-05 17:23:02',NULL,NULL),(20418,3835,'3516416','834','00','005010X220A1','3516416','','2014-02-20','16:08:20',0,'2014-02-20 21:30:18',NULL,NULL),(79,4,'1148227','834','00','005010X220A1','1148227','','2013-12-04','19:25:28',0,'2013-12-25 17:17:24',NULL,NULL),(12372,1635,'1628243','834','00','005010X220A1','1628243','','2013-12-30','18:43:27',1,'2014-01-02 04:28:40',NULL,NULL),(12068,1586,'1375305','834','00','005010X220A1','1375305','','2013-12-30','08:20:08',0,'2014-01-01 12:04:38',NULL,NULL),(11923,1566,'1443676','834','00','005010X220A1','1443676','','2013-12-28','18:59:02',0,'2013-12-30 00:01:42',NULL,NULL),(10459,1400,'1165445','834','00','005010X220A1','1165445','','2013-12-23','13:38:09',0,'2013-12-26 12:52:35',NULL,NULL),(3199,578,'516415','834','00','005010X220A1','516415','','2013-12-16','20:56:15',0,'2013-12-25 21:45:16',NULL,NULL),(7032,1235,'663808','834','00','005010X220A1','663808','','2013-12-18','13:22:07',0,'2013-12-26 04:01:30',NULL,NULL),(2828,510,'279469','834','00','005010X220A1','279469','','2013-12-22','11:42:56',0,'2013-12-25 21:21:14',NULL,NULL),(19125,3546,'1879861','834','00','005010X220A1','1879861','','2014-02-12','15:54:32',0,'2014-02-12 21:31:53',NULL,NULL),(3318,584,'572841','834','00','005010X220A1','572841','','2013-12-17','16:37:37',0,'2013-12-25 21:49:07',NULL,NULL),(14797,2551,'1866213','834','00','005010X220A1','1866213','','2014-01-14','17:21:27',0,'2014-01-15 02:06:43',NULL,NULL),(12524,1645,'2168542','834','00','005010X220A1','2168542','','2013-12-30','21:22:16',1,'2014-01-02 04:34:12',NULL,NULL),(2399,415,'204736','834','00','005010X220A1','204736','','2013-12-05','19:26:58',0,'2013-12-25 20:17:10',NULL,NULL),(16014,2767,'1936630','834','00','005010X220A1','1936630','','2014-01-22','14:04:41',0,'2014-01-23 03:02:19',NULL,NULL),(18414,3420,'1866646','834','00','005010X220A1','1866646','','2014-02-10','00:07:41',0,'2014-02-10 11:00:04',NULL,NULL),(18457,3424,'2241888','834','00','005010X220A1','2241888','','2014-02-10','00:08:53',0,'2014-02-10 11:00:40',NULL,NULL),(22454,4232,'3506593','834','00','005010X220A1','3506593','','2014-03-04','14:02:06',0,'2014-03-04 21:30:19',NULL,NULL),(22463,4238,'3018465','834','00','005010X220A1','3018465','','2014-03-05','10:34:30',0,'2014-03-05 21:00:12',NULL,NULL),(16833,3091,'1954740','834','00','005010X220A1','1954740','','2014-01-28','13:20:15',0,'2014-01-28 21:00:28',NULL,NULL),(3665,626,'578972','834','00','005010X220A1','578972','','2013-12-12','17:23:01',0,'2013-12-25 22:06:21',NULL,NULL),(11104,1425,'1496680','834','00','005010X220A1','1496680','','2013-12-23','13:50:46',0,'2013-12-26 13:14:14',NULL,NULL),(10816,1404,'697904','834','00','005010X220A1','697904','','2013-12-23','16:11:54',0,'2013-12-26 13:04:23',NULL,NULL),(15221,2594,'1698203','834','00','005010X220A1','1698203','','2014-01-15','13:29:41',0,'2014-01-16 08:46:39',NULL,NULL),(15454,2632,'2572460','834','00','005010X220A1','2572460','','2014-01-16','11:43:24',0,'2014-01-17 03:36:11',NULL,NULL),(19068,3542,'2816805','834','00','005010X220A1','2816805','','2014-02-12','15:47:59',0,'2014-02-12 21:31:14',NULL,NULL),(20451,3842,'2605981','834','00','005010X220A1','2605981','','2014-02-19','19:49:22',0,'2014-02-20 22:00:24',NULL,NULL),(21946,4133,'3445424','834','00','005010X220A1','3445424','','2014-03-01','09:16:48',0,'2014-03-01 21:01:02',NULL,NULL),(14364,2404,'2513396','834','00','005010X220A1','2513396','','2014-01-12','11:09:53',0,'2014-01-13 03:01:36',NULL,NULL),(644,108,'974521','834','00','005010X220A1','974521','','2013-12-16','14:56:25',0,'2013-12-25 18:05:02',NULL,NULL),(3768,654,'80572','834','00','005010X220A1','80572','','2013-12-08','14:41:25',0,'2013-12-25 22:15:16',NULL,NULL),(13673,2271,'2344854','834','00','005010X220A1','2344854','','2014-01-07','17:52:49',0,'2014-01-08 18:24:18',NULL,NULL),(7040,1235,'1040557','834','00','005010X220A1','1040557','','2013-12-18','15:02:30',0,'2013-12-26 04:01:44',NULL,NULL),(16214,2906,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 05:06:28',NULL,NULL),(17624,3243,'1743524','834','00','005010X220A1','1743524','','2014-02-03','14:37:41',0,'2014-02-03 21:01:13',NULL,NULL),(19123,3546,'2905651','834','00','005010X220A1','2905651','','2014-02-11','20:27:13',0,'2014-02-12 21:31:52',NULL,NULL),(22738,4276,'2994716','834','00','005010X220A1','2994716','','2014-03-05','23:12:50',0,'2014-03-06 21:00:21',NULL,NULL),(23087,4339,'3604583','834','00','005010X220A1','3604583','','2014-03-07','14:00:55',0,'2014-03-07 21:30:26',NULL,NULL),(5169,946,'651547','834','00','005010X220A1','651547','','2013-12-11','14:51:17',0,'2013-12-26 00:51:21',NULL,NULL),(13575,2254,'2072591','834','00','005010X220A1','2072591','','2014-01-04','22:51:24',1,'2014-01-07 10:21:49',NULL,NULL),(12473,1640,'1647470','834','00','005010X220A1','1647470','','2013-12-30','20:00:12',1,'2014-01-02 04:32:18',NULL,NULL),(7514,1300,'1139930','834','00','005010X220A1','1139930','','2013-12-21','11:05:43',0,'2013-12-26 04:34:29',NULL,NULL),(21439,4027,'3606696','834','00','005010X220A1','3606696','','2014-02-27','15:06:20',0,'2014-02-28 06:30:54',NULL,NULL),(22919,4288,'3609642','834','00','005010X220A1','3609642','','2014-03-05','22:14:45',0,'2014-03-06 21:02:30',NULL,NULL),(23480,4423,'3350726','834','00','005010X220A1','3350726','','2014-03-09','17:00:34',0,'2014-03-09 21:01:18',NULL,NULL),(15025,2584,'1982059','834','00','005010X220A1','1982059','','2014-01-15','13:59:54',0,'2014-01-16 08:44:33',NULL,NULL),(1800,305,'147704','834','00','005010X220A1','147704','','2013-12-10','08:36:40',0,'2013-12-25 19:19:39',NULL,NULL),(13074,1918,'0001','999','BE','005010X231A1','927012','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:26',NULL,NULL),(4801,865,'987572','834','00','005010X220A1','987572','','2013-12-01','09:35:47',0,'2013-12-26 00:01:55',NULL,NULL),(10969,1410,'836434','834','00','005010X220A1','836434','','2013-12-23','19:28:47',0,'2013-12-26 13:09:41',NULL,NULL),(13746,2276,'1740474','834','00','005010X220A1','1740474','','2014-01-07','16:56:38',0,'2014-01-08 18:24:49',NULL,NULL),(11604,1493,'1713990','834','00','005010X220A1','1713990','','2013-12-27','14:19:43',0,'2013-12-28 03:34:49',NULL,NULL),(17429,3202,'2294596','834','00','005010X220A1','2294596','','2014-02-01','16:03:55',0,'2014-02-01 19:00:28',NULL,NULL),(20434,3841,'3234548','834','00','005010X220A1','3234548','','2014-02-19','22:39:43',0,'2014-02-20 22:00:09',NULL,NULL),(21787,4092,'3318396','834','00','005010X220A1','3318396','','2014-02-27','20:10:56',0,'2014-02-28 21:31:12',NULL,NULL),(23420,4404,'3528803','834','00','005010X220A1','3528803','','2014-03-09','16:54:18',0,'2014-03-09 21:00:25',NULL,NULL),(732,125,'250243','834','00','005010X220A1','250243','','2013-12-16','13:00:13',0,'2013-12-25 18:07:48',NULL,NULL),(6066,1164,'287377','834','00','005010X220A1','287377','','2013-12-20','10:05:05',0,'2013-12-26 03:00:14',NULL,NULL),(5962,1117,'1153806','834','00','005010X220A1','1153806','','2013-12-15','10:58:16',0,'2013-12-26 02:32:41',NULL,NULL),(2653,501,'331713','834','00','005010X220A1','331713','','2013-12-22','07:43:25',0,'2013-12-25 21:15:29',NULL,NULL),(5392,1014,'753393','834','00','005010X220A1','753393','','2013-11-24','20:38:31',0,'2013-12-26 01:17:17',NULL,NULL),(4406,778,'65769','834','00','005010X220A1','65769','','2013-11-26','21:29:40',0,'2013-12-25 23:16:08',NULL,NULL),(15329,2622,'2527647','834','00','005010X220A1','2527647','','2014-01-16','16:10:20',0,'2014-01-17 03:35:14',NULL,NULL),(14705,2550,'1804748','834','00','005010X220A1','1804748','','2014-01-13','22:57:17',0,'2014-01-15 02:06:04',NULL,NULL),(12292,1624,'2320116','834','00','005010X220A1','2320116','','2014-01-01','15:11:36',1,'2014-01-02 04:24:58',NULL,NULL),(17730,3261,'2833461','834','00','005010X220A1','2833461','','2014-02-04','17:41:33',0,'2014-02-04 21:00:48',NULL,NULL),(22613,4250,'3492643','834','00','005010X220A1','3492643','','2014-03-05','17:48:46',0,'2014-03-05 21:31:27',NULL,NULL),(23476,4421,'3661343','834','00','005010X220A1','3661343','','2014-03-09','17:36:30',0,'2014-03-09 21:01:14',NULL,NULL),(13792,2294,'1445058','834','00','005010X220A1','1445058','','2014-01-11','09:40:42',0,'2014-01-13 02:18:09',NULL,NULL),(420,77,'671846','834','00','005010X220A1','671846','','2013-12-04','10:51:00',0,'2013-12-25 17:49:02',NULL,NULL),(12603,1671,'1542074','834','00','005010X220A1','1542074','','2014-01-02','16:16:53',0,'2014-01-03 02:01:13',NULL,NULL),(3180,568,'246392','834','00','005010X220A1','246392','','2013-12-13','13:09:05',0,'2013-12-25 21:38:51',NULL,NULL),(12275,1623,'2405113','834','00','005010X220A1','2405113','','2014-01-01','12:40:07',1,'2014-01-02 04:24:23',NULL,NULL),(18023,3318,'1609694','834','00','005010X220A1','1609694','','2014-02-05','23:51:34',0,'2014-02-06 21:00:24',NULL,NULL),(20365,3821,'3434886','834','00','005010X220A1','3434886','','2014-02-19','08:28:01',0,'2014-02-20 05:31:24',NULL,NULL),(21841,4106,'3015786','834','00','005010X220A1','3015786','','2014-02-28','13:38:08',0,'2014-02-28 21:31:53',NULL,NULL),(14482,2503,'0001','999','BE','005010X231A1','631459','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:53',NULL,NULL),(935,181,'483601','834','00','005010X220A1','483601','','2013-12-03','05:09:13',0,'2013-12-25 18:18:12',NULL,NULL),(13043,1887,'0001','999','BE','005010X231A1','155725','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:01',NULL,NULL),(5875,1106,'352058','834','00','005010X220A1','352058','','2013-10-26','18:40:36',0,'2013-12-26 02:17:06',NULL,NULL),(10663,1402,'1520562','834','00','005010X220A1','1520562','','2013-12-23','19:21:10',0,'2013-12-26 12:59:12',NULL,NULL),(3894,706,'494870','834','00','005010X220A1','494870','','2013-10-26','00:11:04',0,'2013-12-25 22:32:01',NULL,NULL),(16307,2980,'1396207','834','00','005010X220A1','1396207','','2014-01-23','12:20:18',0,'2014-01-23 21:00:18',NULL,NULL),(18173,3350,'2459908','834','00','005010X220A1','2459908','','2014-02-07','16:48:07',0,'2014-02-07 19:00:16',NULL,NULL),(18517,3450,'3016527','834','00','005010X220A1','3016527','','2014-02-09','18:23:52',0,'2014-02-10 21:30:03',NULL,NULL),(23477,4422,'3029876','834','00','005010X220A1','3029876','','2014-03-09','14:11:32',0,'2014-03-09 21:01:15',NULL,NULL),(7403,1295,'763905','834','00','005010X220A1','763905','','2013-12-20','20:17:30',0,'2013-12-26 04:30:57',NULL,NULL),(13899,2313,'1927078','834','00','005010X220A1','1927078','','2014-01-08','18:40:34',0,'2014-01-13 02:19:44',NULL,NULL),(2096,354,'1156155','834','00','005010X220A1','1156155','','2013-12-09','16:29:05',0,'2013-12-25 19:37:55',NULL,NULL),(7695,1331,'1241551','834','00','005010X220A1','1241551','','2013-11-15','11:00:49',0,'2013-12-26 04:45:16',NULL,NULL),(3615,621,'595858','834','00','005010X220A1','595858','','2013-12-11','19:18:27',0,'2013-12-25 22:04:49',NULL,NULL),(17059,3125,'1582253','834','00','005010X220A1','1582253','','2014-01-29','10:01:32',0,'2014-01-29 21:01:32',NULL,NULL),(19519,3622,'3344174','834','00','005010X220A1','3344174','','2014-02-14','09:54:37',0,'2014-02-14 21:30:39',NULL,NULL),(20147,3775,'3367930','834','00','005010X220A1','3367930','','2014-02-19','08:53:17',0,'2014-02-20 04:03:06',NULL,NULL),(20394,3830,'2591074','834','00','005010X220A1','2591074','','2014-02-19','21:11:49',0,'2014-02-20 21:30:03',NULL,NULL),(74,3,'886051','834','00','005010X220A1','886051','','2013-12-05','12:50:31',0,'2013-12-25 17:17:15',NULL,NULL),(5549,1043,'659016','834','00','005010X220A1','659016','','2013-12-24','18:26:21',0,'2013-12-26 01:48:01',NULL,NULL),(15764,2714,'2055020','834','00','005010X220A1','2055020','','2014-01-19','20:05:21',0,'2014-01-21 08:46:25',NULL,NULL),(15505,2637,'1923309','834','00','005010X220A1','1923309','','2014-01-16','12:25:26',0,'2014-01-17 03:36:33',NULL,NULL),(2962,541,'704668','834','00','005010X220A1','704668','','2013-12-13','13:19:48',0,'2013-12-25 21:31:58',NULL,NULL),(2386,414,'157328','834','00','005010X220A1','157328','','2013-12-06','18:13:50',0,'2013-12-25 20:16:48',NULL,NULL),(11352,1458,'2026108','834','00','005010X220A1','2026108','','2013-12-26','00:18:36',0,'2013-12-27 02:05:05',NULL,NULL),(15495,2634,'2289070','834','00','005010X220A1','2289070','','2014-01-15','19:15:07',0,'2014-01-17 03:36:28',NULL,NULL),(14697,2549,'1853142','834','00','005010X220A1','1853142','','2014-01-14','16:08:17',0,'2014-01-15 02:06:00',NULL,NULL),(16719,3064,'1976273','834','00','005010X220A1','1976273','','2014-01-27','14:16:47',0,'2014-01-27 21:00:56',NULL,NULL),(20025,3750,'3500926','834','00','005010X220A1','3500926','','2014-02-18','13:47:41',0,'2014-02-18 22:00:50',NULL,NULL),(20231,3788,'3366450','834','00','005010X220A1','3366450','','2014-02-18','19:56:19',0,'2014-02-20 04:26:27',NULL,NULL),(22388,4209,'3098208','834','00','005010X220A1','3098208','','2014-03-04','16:46:49',0,'2014-03-04 21:02:09',NULL,NULL),(897,177,'412866','834','00','005010X220A1','412866','','2013-12-03','13:53:14',0,'2013-12-25 18:17:02',NULL,NULL),(1226,243,'1944263','834','00','005010X220A1','1944263','','2013-12-24','09:42:31',0,'2013-12-25 18:48:34',NULL,NULL),(5698,1067,'602460','834','00','005010X220A1','602460','','2013-12-14','12:47:52',0,'2013-12-26 02:00:22',NULL,NULL),(2559,463,'1082648','834','00','005010X220A1','1082648','','2013-11-18','15:48:37',0,'2013-12-25 20:31:52',NULL,NULL),(4479,802,'204590','834','00','005010X220A1','204590','','2013-11-26','11:37:38',0,'2013-12-25 23:31:22',NULL,NULL),(4156,734,'565200','834','00','005010X220A1','565200','','2013-12-18','20:32:25',0,'2013-12-25 23:04:54',NULL,NULL),(5933,1112,'300659','834','00','005010X220A1','300659','','2013-12-15','16:19:08',0,'2013-12-26 02:31:50',NULL,NULL),(16371,2986,'1930034','834','00','005010X220A1','1930034','','2014-01-23','16:39:09',0,'2014-01-23 21:01:03',NULL,NULL),(20454,3842,'3506254','834','00','005010X220A1','3506254','','2014-02-19','20:52:26',0,'2014-02-20 22:00:26',NULL,NULL),(20462,3842,'3172414','834','00','005010X220A1','3172414','','2014-02-20','11:45:05',0,'2014-02-20 22:00:32',NULL,NULL),(15431,2629,'2378946','834','00','005010X220A1','2378946','','2014-01-16','16:25:56',0,'2014-01-17 03:36:02',NULL,NULL),(7382,1293,'435690','834','00','005010X220A1','435690','','2013-12-20','22:51:03',0,'2013-12-26 04:30:13',NULL,NULL),(701,114,'1177343','834','00','005010X220A1','1177343','','2013-12-16','09:37:25',0,'2013-12-25 18:06:46',NULL,NULL),(15382,2624,'2260610','834','00','005010X220A1','2260610','','2014-01-16','16:06:20',0,'2014-01-17 03:35:39',NULL,NULL),(7334,1276,'251769','834','00','005010X220A1','251769','','2013-12-18','17:20:45',0,'2013-12-26 04:10:46',NULL,NULL),(6159,1167,'244164','834','00','005010X220A1','244164','','2013-12-19','23:20:04',0,'2013-12-26 03:03:08',NULL,NULL),(17663,3258,'2217182','834','00','005010X220A1','2217182','','2014-02-04','11:26:51',0,'2014-02-04 21:00:06',NULL,NULL),(17678,3259,'1813067','834','00','005010X220A1','1813067','','2014-02-04','11:59:36',0,'2014-02-04 21:00:16',NULL,NULL),(20213,3782,'2641315','834','00','005010X220A1','2641315','','2014-02-19','12:41:26',0,'2014-02-20 04:21:05',NULL,NULL),(20741,3903,'2705541','834','00','005010X220A1','2705541','','2014-02-25','10:47:52',0,'2014-02-25 21:30:11',NULL,NULL),(14440,2461,'0001','999','BE','005010X231A1','461156','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:11',NULL,NULL),(5684,1062,'412491','834','00','005010X220A1','412491','','2013-12-24','22:07:55',0,'2013-12-26 01:52:36',NULL,NULL),(4235,738,'964696','834','00','005010X220A1','964696','','2013-12-19','15:53:39',0,'2013-12-25 23:07:19',NULL,NULL),(4208,737,'1057247','834','00','005010X220A1','1057247','','2013-12-19','10:37:34',0,'2013-12-25 23:06:29',NULL,NULL),(14070,2340,'2517201','834','00','005010X220A1','2517201','','2014-01-07','18:22:01',0,'2014-01-13 02:21:50',NULL,NULL),(10638,1402,'1621557','834','00','005010X220A1','1621557','','2013-12-23','16:00:08',0,'2013-12-26 12:58:25',NULL,NULL),(12318,1634,'425565','834','00','005010X220A1','425565','','2013-12-30','19:29:36',1,'2014-01-02 04:26:45',NULL,NULL),(17622,3243,'2713341','834','00','005010X220A1','2713341','','2014-02-03','13:59:03',0,'2014-02-03 21:01:12',NULL,NULL),(20680,3883,'2925145','834','00','005010X220A1','2925145','','2014-02-21','14:26:04',0,'2014-02-21 22:01:13',NULL,NULL),(23219,4350,'2896000','834','00','005010X220A1','2896000','','2014-03-07','10:37:24',0,'2014-03-07 21:31:59',NULL,NULL),(7214,1241,'180178','834','00','005010X220A1','180178','','2013-12-18','10:29:57',0,'2013-12-26 04:07:03',NULL,NULL),(11061,1421,'1063488','834','00','005010X220A1','1063488','','2013-12-22','23:20:52',0,'2013-12-26 13:12:50',NULL,NULL),(10990,1413,'395210','834','00','005010X220A1','395210','','2013-12-23','12:02:13',0,'2013-12-26 13:10:25',NULL,NULL),(3426,595,'1105507','834','00','005010X220A1','1105507','','2013-12-17','14:46:13',0,'2013-12-25 21:52:32',NULL,NULL),(18115,3330,'1945425','834','00','005010X220A1','1945425','','2014-02-06','08:51:25',0,'2014-02-06 21:01:28',NULL,NULL),(21299,4008,'2963985','834','00','005010X220A1','2963985','','2014-02-26','11:03:46',0,'2014-02-26 21:02:24',NULL,NULL),(22386,4209,'3073841','834','00','005010X220A1','3073841','','2014-03-03','20:49:29',0,'2014-03-04 21:02:08',NULL,NULL),(23661,4444,'2821585','834','00','005010X220A1','2821585','','2014-03-09','21:23:53',0,'2014-03-10 21:01:59',NULL,NULL),(15464,2632,'2601866','834','00','005010X220A1','2601866','','2014-01-15','19:45:03',0,'2014-01-17 03:36:15',NULL,NULL),(3328,586,'623214','834','00','005010X220A1','623214','','2013-12-17','08:53:22',0,'2013-12-25 21:49:27',NULL,NULL),(2800,506,'1190029','834','00','005010X220A1','1190029','','2013-12-22','12:22:21',0,'2013-12-25 21:20:21',NULL,NULL),(10598,1402,'1438384','834','00','005010X220A1','1438384','','2013-12-23','12:57:22',0,'2013-12-26 12:57:07',NULL,NULL),(12950,1733,'1997989','834','00','005010X220A1','1997989','','2014-01-04','16:13:26',0,'2014-01-05 00:00:20',NULL,NULL),(16579,3037,'1856665','834','00','005010X220A1','1856665','','2014-01-25','11:17:07',0,'2014-01-25 19:00:11',NULL,NULL),(16770,3073,'2152242','834','00','005010X220A1','2152242','','2014-01-27','10:26:19',0,'2014-01-27 21:01:33',NULL,NULL),(20955,3950,'2802112','834','00','005010X220A1','2802112','','2014-02-24','16:27:55',0,'2014-02-26 08:00:45',NULL,NULL),(15673,2686,'1621164','834','00','005010X220A1','1621164','','2014-01-18','16:26:45',0,'2014-01-21 08:44:40',NULL,NULL),(13169,2013,'0001','999','BE','005010X231A1','1084759','834','2013-12-27','16:55:00',0,'2014-01-05 16:58:26',NULL,NULL),(12163,1593,'1432660','834','00','005010X220A1','1432660','','2013-12-30','17:44:05',0,'2014-01-01 12:07:52',NULL,NULL),(5223,953,'1250529','834','00','005010X220A1','1250529','','2013-12-10','22:12:51',0,'2013-12-26 00:53:09',NULL,NULL),(11640,1498,'1697689','834','00','005010X220A1','1697689','','2013-12-26','22:49:45',0,'2013-12-28 03:35:57',NULL,NULL),(23328,4384,'2975980','834','00','005010X220A1','2975980','','2014-03-07','19:07:08',0,'2014-03-08 21:30:42',NULL,NULL),(23410,4404,'3893338','834','00','005010X220A1','3893338','','2014-03-09','11:08:31',0,'2014-03-09 21:00:19',NULL,NULL),(23427,4405,'3413697','834','00','005010X220A1','3413697','','2014-03-09','12:26:01',0,'2014-03-09 21:00:31',NULL,NULL),(14759,2551,'2485219','834','00','005010X220A1','2485219','','2014-01-13','22:09:24',0,'2014-01-15 02:06:27',NULL,NULL),(850,175,'1205012','834','00','005010X220A1','1205012','','2013-12-03','15:15:02',0,'2013-12-25 18:15:38',NULL,NULL),(14032,2337,'2286004','834','00','005010X220A1','2286004','','2014-01-08','14:48:15',0,'2014-01-13 02:21:26',NULL,NULL),(1941,326,'373910','834','00','005010X220A1','373910','','2013-12-09','10:25:27',0,'2013-12-25 19:32:58',NULL,NULL),(12176,1596,'2223760','834','00','005010X220A1','2223760','','2013-12-30','12:59:49',0,'2014-01-01 12:08:21',NULL,NULL),(4769,861,'554722','834','00','005010X220A1','554722','','2013-12-01','16:29:39',0,'2013-12-26 00:00:58',NULL,NULL),(5620,1045,'1957601','834','00','005010X220A1','1957601','','2013-12-24','18:41:44',0,'2013-12-26 01:50:21',NULL,NULL),(5850,1093,'412768','834','00','005010X220A1','412768','','2013-11-23','15:59:37',0,'2013-12-26 02:16:08',NULL,NULL),(17070,3128,'1820536','834','00','005010X220A1','1820536','','2014-01-29','10:18:26',0,'2014-01-29 21:01:39',NULL,NULL),(18828,3490,'2194642','834','00','005010X220A1','2194642','','2014-02-11','11:42:01',0,'2014-02-11 21:01:36',NULL,NULL),(18956,3531,'2404940','834','00','005010X220A1','2404940','','2014-02-12','16:06:45',0,'2014-02-12 21:00:08',NULL,NULL),(21509,4031,'3599171','834','00','005010X220A1','3599171','','2014-02-27','17:36:02',0,'2014-02-28 06:31:25',NULL,NULL),(15423,2629,'1699545','834','00','005010X220A1','1699545','','2014-01-16','11:41:06',0,'2014-01-17 03:35:59',NULL,NULL),(15137,2587,'1881871','834','00','005010X220A1','1881871','','2014-01-15','18:10:28',0,'2014-01-16 08:45:45',NULL,NULL),(13522,2236,'2100293','834','00','005010X220A1','2100293','','2014-01-06','08:47:52',0,'2014-01-07 04:05:29',NULL,NULL),(1433,252,'1233168','834','00','005010X220A1','1233168','','2013-12-24','09:48:37',0,'2013-12-25 18:55:08',NULL,NULL),(13745,2276,'2305138','834','00','005010X220A1','2305138','','2014-01-07','16:43:41',0,'2014-01-08 18:24:49',NULL,NULL),(303,70,'920689','834','00','005010X220A1','920689','','2013-12-04','00:17:20',0,'2013-12-25 17:45:18',NULL,NULL),(13448,2223,'2420289','834','00','005010X220A1','2420289','','2014-01-06','17:08:28',0,'2014-01-07 04:02:43',NULL,NULL),(437,80,'723634','834','00','005010X220A1','723634','','2013-12-03','20:54:34',0,'2013-12-25 17:49:33',NULL,NULL),(2200,365,'1165808','834','00','005010X220A1','1165808','','2013-12-01','21:26:32',0,'2013-12-25 19:48:11',NULL,NULL),(14698,2550,'1803553','834','00','005010X220A1','1803553','','2014-01-13','18:39:59',0,'2014-01-15 02:06:01',NULL,NULL),(16168,2860,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','03:08:00',1,'2014-01-23 04:16:56',NULL,NULL),(19752,3673,'3030589','834','00','005010X220A1','3030589','','2014-02-15','15:00:59',0,'2014-02-15 22:00:45',NULL,NULL),(22284,4200,'3072771','834','00','005010X220A1','3072771','','2014-03-04','16:24:38',0,'2014-03-04 21:00:46',NULL,NULL),(670,109,'1210554','834','00','005010X220A1','1210554','','2013-12-16','10:14:20',0,'2013-12-25 18:05:47',NULL,NULL),(10679,1403,'1243668','834','00','005010X220A1','1243668','','2013-12-22','21:20:00',0,'2013-12-26 12:59:43',NULL,NULL),(4549,825,'847873','834','00','005010X220A1','847873','','2013-12-23','22:53:27',0,'2013-12-25 23:45:41',NULL,NULL),(4527,820,'163253','834','00','005010X220A1','163253','','2013-11-26','17:33:51',0,'2013-12-25 23:32:59',NULL,NULL),(4473,802,'1230744','834','00','005010X220A1','1230744','','2013-11-26','10:23:24',0,'2013-12-25 23:31:10',NULL,NULL),(14453,2474,'0001','999','BE','005010X231A1','637212','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:27',NULL,NULL),(19882,3710,'3039217','834','00','005010X220A1','3039217','','2014-02-15','20:13:31',0,'2014-02-16 19:00:25',NULL,NULL),(22781,4277,'3083939','834','00','005010X220A1','3083939','','2014-03-06','13:12:23',0,'2014-03-06 21:00:51',NULL,NULL),(22823,4278,'3244936','834','00','005010X220A1','3244936','','2014-03-06','14:21:52',0,'2014-03-06 21:01:20',NULL,NULL),(22830,4278,'3216138','834','00','005010X220A1','3216138','','2014-03-06','15:47:46',0,'2014-03-06 21:01:25',NULL,NULL),(304,70,'962863','834','00','005010X220A1','962863','','2013-12-04','05:25:56',0,'2013-12-25 17:45:20',NULL,NULL),(13225,2069,'0001','999','BE','005010X231A1','632109','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:02',NULL,NULL),(2125,360,'165485','834','00','005010X220A1','165485','','2013-12-02','11:59:44',0,'2013-12-25 19:45:41',NULL,NULL),(2376,413,'466057','834','00','005010X220A1','466057','','2013-12-05','18:50:02',0,'2013-12-25 20:16:31',NULL,NULL),(6016,1136,'355982','834','00','005010X220A1','355982','','2013-11-17','13:06:58',0,'2013-12-26 02:45:25',NULL,NULL),(12273,1623,'1378034','834','00','005010X220A1','1378034','','2014-01-01','12:20:11',1,'2014-01-02 04:24:19',NULL,NULL),(12183,1600,'2163354','834','00','005010X220A1','2163354','','2013-12-30','09:50:25',0,'2014-01-01 12:08:40',NULL,NULL),(20162,3778,'2604881','834','00','005010X220A1','2604881','','2014-02-18','20:59:49',0,'2014-02-20 04:07:07',NULL,NULL),(22185,4180,'2926689','834','00','005010X220A1','2926689','','2014-03-03','16:50:39',0,'2014-03-03 21:31:20',NULL,NULL),(22562,4248,'2813483','834','00','005010X220A1','2813483','','2014-03-05','12:38:33',0,'2014-03-05 21:30:52',NULL,NULL),(5568,1043,'1888394','834','00','005010X220A1','1888394','','2013-12-24','20:06:22',0,'2013-12-26 01:48:36',NULL,NULL),(4899,904,'675633','834','00','005010X220A1','675633','','2013-10-22','20:55:34',0,'2013-12-26 00:30:04',NULL,NULL),(2661,501,'944486','834','00','005010X220A1','944486','','2013-12-22','14:14:21',0,'2013-12-25 21:15:50',NULL,NULL),(3923,712,'816933','834','00','005010X220A1','816933','','2013-12-07','08:45:57',0,'2013-12-25 22:45:44',NULL,NULL),(18974,3537,'2157897','834','00','005010X220A1','2157897','','2014-02-11','22:12:22',0,'2014-02-12 21:30:09',NULL,NULL),(20472,3842,'2931118','834','00','005010X220A1','2931118','','2014-02-20','15:03:58',0,'2014-02-20 22:00:40',NULL,NULL),(22022,4154,'3721092','834','00','005010X220A1','3721092','','2014-03-02','12:14:06',0,'2014-03-03 01:00:37',NULL,NULL),(13959,2322,'1687289','834','00','005010X220A1','1687289','','2014-01-08','22:50:35',0,'2014-01-13 02:20:27',NULL,NULL),(5101,940,'268340','834','00','005010X220A1','268340','','2013-12-11','13:23:36',0,'2013-12-26 00:49:11',NULL,NULL),(12576,1670,'2515612','834','00','005010X220A1','2515612','','2014-01-02','14:21:26',0,'2014-01-03 02:00:11',NULL,NULL),(3987,724,'427368','834','00','005010X220A1','427368','','2013-12-07','08:53:33',0,'2013-12-25 22:47:49',NULL,NULL),(11865,1556,'415957','834','00','005010X220A1','415957','','2013-12-28','20:23:59',1,'2013-12-29 11:15:19',NULL,NULL),(7506,1300,'1088477','834','00','005010X220A1','1088477','','2013-12-21','00:21:40',0,'2013-12-26 04:34:14',NULL,NULL),(15929,2749,'2331619','834','00','005010X220A1','2331619','','2014-01-21','11:58:26',1,'2014-01-22 03:22:59',NULL,NULL),(17382,3190,'1668146','834','00','005010X220A1','1668146','','2014-01-31','15:44:52',0,'2014-01-31 21:01:39',NULL,NULL),(21113,3994,'3251962','834','00','005010X220A1','3251962','','2014-02-26','12:45:51',0,'2014-02-26 21:00:17',NULL,NULL),(21903,4127,'3845739','834','00','005010X220A1','3845739','','2014-03-01','00:13:34',0,'2014-03-01 21:00:32',NULL,NULL),(22353,4205,'2778197','834','00','005010X220A1','2778197','','2014-03-03','23:53:54',0,'2014-03-04 21:01:41',NULL,NULL),(582,104,'1083137','834','00','005010X220A1','1083137','','2013-12-15','19:29:45',0,'2013-12-25 18:03:00',NULL,NULL),(13558,2251,'2122772','834','00','005010X220A1','2122772','','2014-01-06','14:47:01',0,'2014-01-07 04:06:52',NULL,NULL),(14681,2549,'2435060','834','00','005010X220A1','2435060','','2014-01-13','18:37:35',0,'2014-01-15 02:05:54',NULL,NULL),(15120,2587,'1903920','834','00','005010X220A1','1903920','','2014-01-14','18:55:01',0,'2014-01-16 08:45:33',NULL,NULL),(15176,2591,'2006644','834','00','005010X220A1','2006644','','2014-01-15','12:53:52',0,'2014-01-16 08:46:11',NULL,NULL),(16813,3090,'2084148','834','00','005010X220A1','2084148','','2014-01-27','19:34:24',0,'2014-01-28 21:00:15',NULL,NULL),(19227,3580,'2758640','834','00','005010X220A1','2758640','','2014-02-13','07:28:11',0,'2014-02-13 22:00:14',NULL,NULL),(21494,4030,'2994450','834','00','005010X220A1','2994450','','2014-02-26','22:23:16',0,'2014-02-28 06:31:18',NULL,NULL),(23183,4345,'2770682','834','00','005010X220A1','2770682','','2014-03-07','11:20:16',0,'2014-03-07 21:31:34',NULL,NULL),(23742,4469,'2763295','834','00','005010X220A1','2763295','','2014-03-10','16:58:37',0,'2014-03-10 21:03:02',NULL,NULL),(819,163,'223879','834','00','005010X220A1','223879','','2013-11-11','04:22:59',0,'2013-12-25 18:10:52',NULL,NULL),(11845,1546,'1496725','834','00','005010X220A1','1496725','','2013-12-28','20:13:32',1,'2013-12-29 11:14:34',NULL,NULL),(4809,865,'754694','834','00','005010X220A1','754694','','2013-12-01','12:50:45',0,'2013-12-26 00:02:08',NULL,NULL),(4559,825,'1594968','834','00','005010X220A1','1594968','','2013-12-24','00:38:24',0,'2013-12-25 23:46:00',NULL,NULL),(1932,326,'864853','834','00','005010X220A1','864853','','2013-12-09','09:04:56',0,'2013-12-25 19:32:40',NULL,NULL),(7293,1256,'375344','834','00','005010X220A1','375344','','2013-12-18','12:56:27',0,'2013-12-26 04:09:30',NULL,NULL),(14347,2401,'1585854','834','00','005010X220A1','1585854','','2014-01-12','11:18:48',0,'2014-01-13 03:01:23',NULL,NULL),(15552,2655,'2535030','834','00','005010X220A1','2535030','','2014-01-17','17:49:06',0,'2014-01-20 08:05:50',NULL,NULL),(16720,3064,'1927527','834','00','005010X220A1','1927527','','2014-01-27','15:24:45',0,'2014-01-27 21:00:56',NULL,NULL),(16856,3093,'1972305','834','00','005010X220A1','1972305','','2014-01-27','20:19:50',0,'2014-01-28 21:00:44',NULL,NULL),(18685,3472,'2650343','834','00','005010X220A1','2650343','','2014-02-10','10:32:16',0,'2014-02-10 21:32:03',NULL,NULL),(19751,3673,'2103870','834','00','005010X220A1','2103870','','2014-02-15','14:51:52',0,'2014-02-15 22:00:44',NULL,NULL),(275,58,'193026','834','00','005010X220A1','193026','','2013-10-10','22:33:07',0,'2013-12-25 17:31:46',NULL,NULL),(7066,1236,'968423','834','00','005010X220A1','968423','','2013-12-17','20:38:56',0,'2013-12-26 04:02:30',NULL,NULL),(5031,935,'753686','834','00','005010X220A1','753686','','2013-12-11','13:13:17',0,'2013-12-26 00:46:58',NULL,NULL),(5095,940,'532074','834','00','005010X220A1','532074','','2013-12-11','11:52:06',0,'2013-12-26 00:49:01',NULL,NULL),(3281,583,'804475','834','00','005010X220A1','804475','','2013-12-17','11:45:25',0,'2013-12-25 21:47:51',NULL,NULL),(5953,1114,'295798','834','00','005010X220A1','295798','','2013-12-15','15:29:42',0,'2013-12-26 02:32:24',NULL,NULL),(16039,2771,'1964541','834','00','005010X220A1','1964541','','2014-01-22','11:12:06',0,'2014-01-23 03:02:30',NULL,NULL),(22175,4180,'3111909','834','00','005010X220A1','3111909','','2014-03-03','15:16:29',0,'2014-03-03 21:31:13',NULL,NULL),(412,77,'144744','834','00','005010X220A1','144744','','2013-12-04','12:21:27',0,'2013-12-25 17:48:45',NULL,NULL),(12122,1587,'2070182','834','00','005010X220A1','2070182','','2013-12-30','15:24:04',0,'2014-01-01 12:06:29',NULL,NULL),(1952,326,'857723','834','00','005010X220A1','857723','','2013-12-09','12:15:47',0,'2013-12-25 19:33:17',NULL,NULL),(15067,2585,'1989544','834','00','005010X220A1','1989544','','2014-01-15','10:56:51',0,'2014-01-16 08:45:00',NULL,NULL),(21401,4025,'2782997','834','00','005010X220A1','2782997','','2014-02-27','09:23:27',0,'2014-02-28 06:30:35',NULL,NULL),(23388,4401,'3092348','834','00','005010X220A1','3092348','','2014-03-09','13:38:23',0,'2014-03-09 21:00:02',NULL,NULL),(11171,1444,'850283','834','00','005010X220A1','850283','','2013-12-23','10:50:51',0,'2013-12-26 13:16:40',NULL,NULL),(3868,693,'167619','834','00','005010X220A1','167619','','2013-10-10','01:38:25',0,'2013-12-25 22:31:10',NULL,NULL),(3356,587,'293027','834','00','005010X220A1','293027','','2013-12-17','10:28:47',0,'2013-12-25 21:50:19',NULL,NULL),(1570,277,'405251','834','00','005010X220A1','405251','','2013-11-19','18:25:22',0,'2013-12-25 19:00:17',NULL,NULL),(7211,1241,'776882','834','00','005010X220A1','776882','','2013-12-18','10:07:40',0,'2013-12-26 04:06:58',NULL,NULL),(7415,1295,'1016645','834','00','005010X220A1','1016645','','2013-12-21','00:16:52',0,'2013-12-26 04:31:21',NULL,NULL),(19226,3580,'3158318','834','00','005010X220A1','3158318','','2014-02-13','01:51:41',0,'2014-02-13 22:00:13',NULL,NULL),(63,3,'395616','834','00','005010X220A1','395616','','2013-12-05','14:13:03',0,'2013-12-25 17:16:53',NULL,NULL),(12375,1636,'1626894','834','00','005010X220A1','1626894','','2013-12-31','11:20:24',1,'2014-01-02 04:28:44',NULL,NULL),(1287,243,'472166','834','00','005010X220A1','472166','','2013-12-24','17:50:26',0,'2013-12-25 18:50:23',NULL,NULL),(2640,500,'1008267','834','00','005010X220A1','1008267','','2013-12-21','22:44:21',0,'2013-12-25 21:15:04',NULL,NULL),(3000,542,'315452','834','00','005010X220A1','315452','','2013-12-13','15:25:20',0,'2013-12-25 21:33:07',NULL,NULL),(12342,1634,'2063981','834','00','005010X220A1','2063981','','2013-12-31','12:05:26',1,'2014-01-02 04:27:37',NULL,NULL),(11929,1570,'1386741','834','00','005010X220A1','1386741','','2013-12-28','23:43:37',0,'2013-12-30 00:01:56',NULL,NULL),(10435,1400,'863276','834','00','005010X220A1','863276','','2013-12-23','11:24:54',0,'2013-12-26 12:51:47',NULL,NULL),(18576,3453,'3154406','834','00','005010X220A1','3154406','','2014-02-10','14:49:57',0,'2014-02-10 21:30:47',NULL,NULL),(18930,3519,'2266541','834','00','005010X220A1','2266541','','2014-02-11','09:23:07',0,'2014-02-11 21:30:09',NULL,NULL),(21597,4062,'3109180','834','00','005010X220A1','3109180','','2014-02-26','15:43:19',0,'2014-02-28 07:00:41',NULL,NULL),(22458,4236,'3585694','834','00','005010X220A1','3585694','','2014-03-04','13:49:19',0,'2014-03-04 21:30:23',NULL,NULL),(4451,801,'9909','834','00','005010X220A1','9909','','2013-11-25','21:22:39',0,'2013-12-25 23:30:28',NULL,NULL),(14289,2379,'1560178','834','00','005010X220A1','1560178','','2014-01-10','14:34:58',0,'2014-01-13 03:00:20',NULL,NULL),(2572,472,'1231910','834','00','005010X220A1','1231910','','2013-11-01','15:39:51',0,'2013-12-25 20:45:04',NULL,NULL),(1378,245,'1396727','834','00','005010X220A1','1396727','','2013-12-24','16:07:58',0,'2013-12-25 18:53:18',NULL,NULL),(1752,293,'481681','834','00','005010X220A1','481681','','2013-12-10','16:50:31',0,'2013-12-25 19:18:02',NULL,NULL),(1856,324,'643679','834','00','005010X220A1','643679','','2013-12-09','11:48:17',0,'2013-12-25 19:30:24',NULL,NULL),(10512,1401,'665258','834','00','005010X220A1','665258','','2013-12-22','19:05:30',0,'2013-12-26 12:54:13',NULL,NULL),(12827,1704,'2279484','834','00','005010X220A1','2279484','','2014-01-03','10:26:55',0,'2014-01-04 02:02:14',NULL,NULL),(12739,1686,'1526406','834','00','005010X220A1','1526406','','2014-01-02','14:38:55',0,'2014-01-03 02:06:15',NULL,NULL),(17883,3294,'2438014','834','00','005010X220A1','2438014','','2014-02-05','12:43:28',0,'2014-02-05 21:30:22',NULL,NULL),(18730,3485,'2830298','834','00','005010X220A1','2830298','','2014-02-11','10:26:28',0,'2014-02-11 21:00:23',NULL,NULL),(19712,3672,'2853943','834','00','005010X220A1','2853943','','2014-02-15','09:28:08',0,'2014-02-15 22:00:17',NULL,NULL),(20355,3815,'3225900','834','00','005010X220A1','3225900','','2014-02-19','16:35:57',0,'2014-02-20 04:55:55',NULL,NULL),(22551,4248,'2872259','834','00','005010X220A1','2872259','','2014-03-05','10:35:40',0,'2014-03-05 21:30:44',NULL,NULL),(7238,1242,'485581','834','00','005010X220A1','485581','','2013-12-17','20:16:05',0,'2013-12-26 04:07:52',NULL,NULL),(3320,584,'452607','834','00','005010X220A1','452607','','2013-12-17','17:17:37',0,'2013-12-25 21:49:12',NULL,NULL),(1965,326,'1199099','834','00','005010X220A1','1199099','','2013-12-09','14:16:15',0,'2013-12-25 19:33:38',NULL,NULL),(5333,1002,'283215','834','00','005010X220A1','283215','','2013-11-25','17:43:40',0,'2013-12-26 01:15:16',NULL,NULL),(14898,2558,'2122966','834','00','005010X220A1','2122966','','2014-01-14','11:57:01',0,'2014-01-15 02:07:29',NULL,NULL),(20449,3842,'2767387','834','00','005010X220A1','2767387','','2014-02-19','18:56:09',0,'2014-02-20 22:00:22',NULL,NULL),(21517,4035,'3441169','834','00','005010X220A1','3441169','','2014-02-26','22:46:15',0,'2014-02-28 06:31:29',NULL,NULL),(14834,2553,'1901559','834','00','005010X220A1','1901559','','2014-01-13','20:45:47',0,'2014-01-15 02:06:59',NULL,NULL),(817,161,'448018','834','00','005010X220A1','448018','','2013-11-11','16:38:42',0,'2013-12-25 18:10:48',NULL,NULL),(12727,1682,'2561661','834','00','005010X220A1','2561661','','2014-01-01','18:47:43',0,'2014-01-03 02:05:50',NULL,NULL),(1893,325,'1032463','834','00','005010X220A1','1032463','','2013-12-09','11:25:35',0,'2013-12-25 19:31:33',NULL,NULL),(12105,1587,'2349051','834','00','005010X220A1','2349051','','2013-12-30','11:42:32',0,'2014-01-01 12:05:52',NULL,NULL),(11510,1490,'1567572','834','00','005010X220A1','1567572','','2013-12-26','22:49:14',0,'2013-12-28 03:31:58',NULL,NULL),(10422,1400,'253582','834','00','005010X220A1','253582','','2013-12-23','10:27:46',0,'2013-12-26 12:51:23',NULL,NULL),(4902,905,'754465','834','00','005010X220A1','754465','','2013-10-22','21:13:45',0,'2013-12-26 00:30:11',NULL,NULL),(16077,2776,'1735704','834','00','005010X220A1','1735704','','2014-01-22','09:36:19',0,'2014-01-23 03:02:48',NULL,NULL),(16660,3060,'2131158','834','00','005010X220A1','2131158','','2014-01-27','14:31:48',0,'2014-01-27 21:00:18',NULL,NULL),(23659,4443,'3164602','834','00','005010X220A1','3164602','','2014-03-09','21:19:00',0,'2014-03-10 21:01:58',NULL,NULL),(13494,2228,'1779853','834','00','005010X220A1','1779853','','2014-01-06','15:56:54',0,'2014-01-07 04:04:23',NULL,NULL),(13143,1987,'0001','999','BE','005010X231A1','3727','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:13',NULL,NULL),(6332,1176,'1238098','834','00','005010X220A1','1238098','','2013-12-19','20:38:00',0,'2013-12-26 03:08:23',NULL,NULL),(3940,714,'1221372','834','00','005010X220A1','1221372','','2013-12-07','16:54:29',0,'2013-12-25 22:46:13',NULL,NULL),(11942,1577,'1574023','834','00','005010X220A1','1574023','','2013-12-29','14:51:21',0,'2013-12-30 00:02:22',NULL,NULL),(880,177,'989881','834','00','005010X220A1','989881','','2013-12-03','09:09:13',0,'2013-12-25 18:16:35',NULL,NULL),(10715,1403,'1613746','834','00','005010X220A1','1613746','','2013-12-23','12:33:21',0,'2013-12-26 13:01:03',NULL,NULL),(3249,578,'170978','834','00','005010X220A1','170978','','2013-12-17','16:38:34',0,'2013-12-25 21:46:49',NULL,NULL),(7663,1316,'1204486','834','00','005010X220A1','1204486','','2013-12-21','17:47:09',0,'2013-12-26 04:39:15',NULL,NULL),(16558,3031,'2363182','834','00','005010X220A1','2363182','','2014-01-24','14:24:42',0,'2014-01-24 21:01:18',NULL,NULL),(17264,3170,'2389191','834','00','005010X220A1','2389191','','2014-01-31','10:45:31',0,'2014-01-31 21:00:16',NULL,NULL),(21284,4005,'3214401','834','00','005010X220A1','3214401','','2014-02-26','07:39:44',0,'2014-02-26 21:02:13',NULL,NULL),(23404,4404,'3092344','834','00','005010X220A1','3092344','','2014-03-08','23:31:22',0,'2014-03-09 21:00:14',NULL,NULL),(11391,1463,'1489784','834','00','005010X220A1','1489784','','2013-12-26','16:11:10',0,'2013-12-27 02:06:16',NULL,NULL),(912,177,'128324','834','00','005010X220A1','128324','','2013-12-03','16:30:39',0,'2013-12-25 18:17:25',NULL,NULL),(6311,1175,'593855','834','00','005010X220A1','593855','','2013-12-19','20:27:17',0,'2013-12-26 03:07:44',NULL,NULL),(4067,732,'309258','834','00','005010X220A1','309258','','2013-12-19','16:33:38',0,'2013-12-25 23:02:14',NULL,NULL),(2131,360,'240932','834','00','005010X220A1','240932','','2013-12-02','17:52:48',0,'2013-12-25 19:45:51',NULL,NULL),(6217,1168,'906567','834','00','005010X220A1','906567','','2013-12-20','09:32:41',0,'2013-12-26 03:04:49',NULL,NULL),(17309,3173,'1368236','834','00','005010X220A1','1368236','','2014-01-31','16:16:01',0,'2014-01-31 21:00:47',NULL,NULL),(21442,4027,'2726438','834','00','005010X220A1','2726438','','2014-02-27','17:20:48',0,'2014-02-28 06:30:55',NULL,NULL),(21910,4127,'2671189','834','00','005010X220A1','2671189','','2014-03-01','12:38:19',0,'2014-03-01 21:00:36',NULL,NULL),(22726,4276,'3265533','834','00','005010X220A1','3265533','','2014-03-05','18:34:58',0,'2014-03-06 21:00:11',NULL,NULL),(6433,1203,'36353','834','00','005010X220A1','36353','','2013-11-22','11:45:10',0,'2013-12-26 03:15:30',NULL,NULL),(14305,2389,'2054759','834','00','005010X220A1','2054759','','2014-01-10','13:04:46',0,'2014-01-13 03:00:32',NULL,NULL),(15737,2712,'2220663','834','00','005010X220A1','2220663','','2014-01-19','21:17:32',0,'2014-01-21 08:46:10',NULL,NULL),(22226,4191,'3564465','834','00','005010X220A1','3564465','','2014-03-03','15:56:20',0,'2014-03-03 21:31:51',NULL,NULL),(22278,4200,'3325240','834','00','005010X220A1','3325240','','2014-03-04','14:53:59',0,'2014-03-04 21:00:42',NULL,NULL),(23194,4346,'3136950','834','00','005010X220A1','3136950','','2014-03-06','20:10:24',0,'2014-03-07 21:31:41',NULL,NULL),(23533,4435,'3326916','834','00','005010X220A1','3326916','','2014-03-09','22:21:44',0,'2014-03-10 21:00:25',NULL,NULL),(14119,2348,'1500981','834','00','005010X220A1','1500981','','2014-01-08','11:49:04',0,'2014-01-13 02:22:23',NULL,NULL),(5776,1074,'478010','834','00','005010X220A1','478010','','2013-12-13','20:55:49',0,'2013-12-26 02:02:45',NULL,NULL),(4280,742,'667576','834','00','005010X220A1','667576','','2013-12-19','16:49:22',0,'2013-12-25 23:08:42',NULL,NULL),(1276,243,'698015','834','00','005010X220A1','698015','','2013-12-24','16:10:57',0,'2013-12-25 18:50:02',NULL,NULL),(3452,607,'43247','834','00','005010X220A1','43247','','2013-12-17','17:50:51',0,'2013-12-25 21:53:24',NULL,NULL),(20088,3765,'3482626','834','00','005010X220A1','3482626','','2014-02-18','12:21:35',0,'2014-02-18 22:01:37',NULL,NULL),(22744,4276,'3031125','834','00','005010X220A1','3031125','','2014-03-06','10:55:56',0,'2014-03-06 21:00:25',NULL,NULL),(14225,2366,'1912844','834','00','005010X220A1','1912844','','2014-01-10','16:46:14',0,'2014-01-13 02:24:00',NULL,NULL),(12765,1698,'2443701','834','00','005010X220A1','2443701','','2014-01-02','11:46:40',0,'2014-01-03 02:07:17',NULL,NULL),(11043,1418,'531473','834','00','005010X220A1','531473','','2013-12-23','11:38:09',0,'2013-12-26 13:12:14',NULL,NULL),(3551,616,'999363','834','00','005010X220A1','999363','','2013-12-12','14:52:50',0,'2013-12-25 22:02:48',NULL,NULL),(18078,3323,'2128716','834','00','005010X220A1','2128716','','2014-02-06','13:46:22',0,'2014-02-06 21:01:01',NULL,NULL),(14935,2561,'2240205','834','00','005010X220A1','2240205','','2014-01-13','23:19:10',0,'2014-01-15 02:07:45',NULL,NULL),(14664,2539,'1746797','834','00','005010X220A1','1746797','','2014-01-13','15:37:40',0,'2014-01-14 01:33:48',NULL,NULL),(2954,541,'1071979','834','00','005010X220A1','1071979','','2013-12-13','10:43:25',0,'2013-12-25 21:31:43',NULL,NULL),(16520,3015,'1504870','834','00','005010X220A1','1504870','','2014-01-24','12:42:24',0,'2014-01-24 21:00:54',NULL,NULL),(18999,3538,'2428883','834','00','005010X220A1','2428883','','2014-02-12','10:29:25',0,'2014-02-12 21:30:25',NULL,NULL),(19909,3724,'2643565','834','00','005010X220A1','2643565','','2014-02-16','19:24:02',0,'2014-02-17 19:00:05',NULL,NULL),(20729,3901,'3191867','834','00','005010X220A1','3191867','','2014-02-25','13:32:50',0,'2014-02-25 21:00:32',NULL,NULL),(23252,4369,'3267063','834','00','005010X220A1','3267063','','2014-03-07','17:25:58',0,'2014-03-07 21:32:24',NULL,NULL),(5866,1102,'544604','834','00','005010X220A1','544604','','2013-10-28','17:23:18',0,'2013-12-26 02:16:46',NULL,NULL),(14483,2504,'0001','999','BE','005010X231A1','110550','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:54',NULL,NULL),(422,77,'193416','834','00','005010X220A1','193416','','2013-12-04','16:23:00',0,'2013-12-25 17:49:05',NULL,NULL),(11926,1567,'1909609','834','00','005010X220A1','1909609','','2013-12-28','19:21:49',0,'2013-12-30 00:01:48',NULL,NULL),(2927,541,'1052121','834','00','005010X220A1','1052121','','2013-12-12','20:05:05',0,'2013-12-25 21:30:49',NULL,NULL),(17587,3237,'2408361','834','00','005010X220A1','2408361','','2014-02-03','15:01:22',0,'2014-02-03 21:00:49',NULL,NULL),(17712,3261,'1761214','834','00','005010X220A1','1761214','','2014-02-04','09:29:19',0,'2014-02-04 21:00:37',NULL,NULL),(21282,4005,'2705576','834','00','005010X220A1','2705576','','2014-02-26','10:46:15',0,'2014-02-26 21:02:12',NULL,NULL),(15193,2592,'1896767','834','00','005010X220A1','1896767','','2014-01-14','21:45:01',0,'2014-01-16 08:46:20',NULL,NULL),(332,72,'555939','834','00','005010X220A1','555939','','2013-12-04','09:26:24',0,'2013-12-25 17:46:13',NULL,NULL),(14858,2553,'1374370','834','00','005010X220A1','1374370','','2014-01-14','18:07:56',0,'2014-01-15 02:07:10',NULL,NULL),(11708,1517,'2293752','834','00','005010X220A1','2293752','','2013-12-28','17:04:39',1,'2013-12-29 11:08:07',NULL,NULL),(1205,241,'2052994','834','00','005010X220A1','2052994','','2013-12-24','18:12:29',0,'2013-12-25 18:47:56',NULL,NULL),(5949,1113,'1231160','834','00','005010X220A1','1231160','','2013-12-15','13:27:00',0,'2013-12-26 02:32:16',NULL,NULL),(11295,1455,'900429','834','00','005010X220A1','900429','','2013-12-26','17:36:54',0,'2013-12-27 02:03:21',NULL,NULL),(11058,1421,'1357464','834','00','005010X220A1','1357464','','2013-12-22','20:32:47',0,'2013-12-26 13:12:44',NULL,NULL),(4604,826,'1145107','834','00','005010X220A1','1145107','','2013-12-24','01:46:00',0,'2013-12-25 23:47:22',NULL,NULL),(10963,1410,'1682951','834','00','005010X220A1','1682951','','2013-12-23','18:30:07',0,'2013-12-26 13:09:32',NULL,NULL),(17572,3236,'1851275','834','00','005010X220A1','1851275','','2014-02-03','16:07:36',0,'2014-02-03 21:00:39',NULL,NULL),(17950,3299,'2765913','834','00','005010X220A1','2765913','','2014-02-05','13:12:56',0,'2014-02-05 21:30:54',NULL,NULL),(22164,4180,'3669728','834','00','005010X220A1','3669728','','2014-03-03','11:36:41',0,'2014-03-03 21:31:05',NULL,NULL),(12902,1713,'1643758','834','00','005010X220A1','1643758','','2014-01-03','11:39:17',0,'2014-01-04 02:04:58',NULL,NULL),(10967,1410,'1185260','834','00','005010X220A1','1185260','','2013-12-23','19:02:29',0,'2013-12-26 13:09:38',NULL,NULL),(1933,326,'1263787','834','00','005010X220A1','1263787','','2013-12-09','09:09:45',0,'2013-12-25 19:32:42',NULL,NULL),(15620,2670,'2250882','834','00','005010X220A1','2250882','','2014-01-17','17:34:41',0,'2014-01-20 08:06:40',NULL,NULL),(16835,3091,'1368150','834','00','005010X220A1','1368150','','2014-01-28','15:32:03',0,'2014-01-28 21:00:29',NULL,NULL),(20483,3843,'3684139','834','00','005010X220A1','3684139','','2014-02-20','15:01:42',0,'2014-02-20 22:00:50',NULL,NULL),(20804,3910,'2887209','834','00','005010X220A1','2887209','','2014-02-24','18:36:06',0,'2014-02-25 21:30:58',NULL,NULL),(14202,2365,'2250638','834','00','005010X220A1','2250638','','2014-01-10','14:30:47',0,'2014-01-13 02:23:45',NULL,NULL),(669,109,'828207','834','00','005010X220A1','828207','','2013-12-16','08:38:28',0,'2013-12-25 18:05:45',NULL,NULL),(811,160,'63158','834','00','005010X220A1','63158','','2013-11-11','11:21:24',0,'2013-12-25 18:10:37',NULL,NULL),(4995,935,'1114108','834','00','005010X220A1','1114108','','2013-12-11','08:42:39',0,'2013-12-26 00:45:49',NULL,NULL),(3785,656,'305280','834','00','005010X220A1','305280','','2013-12-08','13:33:51',0,'2013-12-25 22:15:49',NULL,NULL),(3118,547,'201205','834','00','005010X220A1','201205','','2013-12-13','14:24:46',0,'2013-12-25 21:36:43',NULL,NULL),(3069,545,'1144515','834','00','005010X220A1','1144515','','2013-12-13','17:51:23',0,'2013-12-25 21:35:16',NULL,NULL),(13329,2173,'0001','999','BE','005010X231A1','140799','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:33',NULL,NULL),(17355,3181,'2185971','834','00','005010X220A1','2185971','','2014-01-31','13:50:54',0,'2014-01-31 21:01:20',NULL,NULL),(17818,3273,'1756270','834','00','005010X220A1','1756270','','2014-02-04','17:52:32',0,'2014-02-04 21:01:44',NULL,NULL),(18959,3534,'1945556','834','00','005010X220A1','1945556','','2014-02-12','11:51:50',0,'2014-02-12 21:00:11',NULL,NULL),(20138,3773,'3307451','834','00','005010X220A1','3307451','','2014-02-18','19:48:19',0,'2014-02-20 04:00:45',NULL,NULL),(22332,4203,'3229916','834','00','005010X220A1','3229916','','2014-03-04','14:33:50',0,'2014-03-04 21:01:23',NULL,NULL),(812,160,'397865','834','00','005010X220A1','397865','','2013-11-11','12:11:27',0,'2013-12-25 18:10:39',NULL,NULL),(2112,360,'1290986','834','00','005010X220A1','1290986','','2013-12-01','20:40:40',0,'2013-12-25 19:45:18',NULL,NULL),(14291,2380,'2211604','834','00','005010X220A1','2211604','','2014-01-10','00:15:12',0,'2014-01-13 03:00:22',NULL,NULL),(14092,2341,'1848231','834','00','005010X220A1','1848231','','2014-01-08','15:44:27',0,'2014-01-13 02:22:05',NULL,NULL),(6991,1234,'647963','834','00','005010X220A1','647963','','2013-12-18','13:31:38',0,'2013-12-26 04:00:11',NULL,NULL),(13853,2311,'1565503','834','00','005010X220A1','1565503','','2014-01-09','12:35:25',0,'2014-01-13 02:19:14',NULL,NULL),(13846,2311,'1869982','834','00','005010X220A1','1869982','','2014-01-08','22:49:47',0,'2014-01-13 02:19:09',NULL,NULL),(15010,2584,'1356797','834','00','005010X220A1','1356797','','2014-01-15','10:42:04',0,'2014-01-16 08:44:24',NULL,NULL),(15727,2711,'1447953','834','00','005010X220A1','1447953','','2014-01-20','12:49:36',0,'2014-01-21 08:46:04',NULL,NULL),(16688,3062,'1626205','834','00','005010X220A1','1626205','','2014-01-27','14:09:22',0,'2014-01-27 21:00:36',NULL,NULL),(17633,3244,'2709739','834','00','005010X220A1','2709739','','2014-02-03','13:27:59',0,'2014-02-03 21:01:18',NULL,NULL),(19284,3582,'3013909','834','00','005010X220A1','3013909','','2014-02-13','13:54:20',0,'2014-02-13 22:01:01',NULL,NULL),(19448,3606,'2941320','834','00','005010X220A1','2941320','','2014-02-13','12:26:05',0,'2014-02-13 22:03:06',NULL,NULL),(22020,4152,'3705798','834','00','005010X220A1','3705798','','2014-03-02','12:17:20',0,'2014-03-03 01:00:36',NULL,NULL),(22718,4271,'3502908','834','00','005010X220A1','3502908','','2014-03-05','14:38:05',0,'2014-03-05 21:32:42',NULL,NULL),(11525,1490,'2065268','834','00','005010X220A1','2065268','','2013-12-27','12:50:16',0,'2013-12-28 03:32:24',NULL,NULL),(1354,245,'1890882','834','00','005010X220A1','1890882','','2013-12-24','13:52:29',0,'2013-12-25 18:52:33',NULL,NULL),(7668,1318,'1381447','834','00','005010X220A1','1381447','','2013-12-21','09:57:07',0,'2013-12-26 04:39:25',NULL,NULL),(3954,715,'285809','834','00','005010X220A1','285809','','2013-12-07','01:18:09',0,'2013-12-25 22:46:41',NULL,NULL),(1725,293,'169457','834','00','005010X220A1','169457','','2013-12-09','22:42:56',0,'2013-12-25 19:17:14',NULL,NULL),(16257,2949,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:46:00',0,'2014-01-23 08:00:02',NULL,NULL),(17702,3261,'2343352','834','00','005010X220A1','2343352','','2014-02-03','20:34:49',0,'2014-02-04 21:00:31',NULL,NULL),(21927,4128,'3479301','834','00','005010X220A1','3479301','','2014-03-01','13:24:07',0,'2014-03-01 21:00:47',NULL,NULL),(14328,2400,'2036873','834','00','005010X220A1','2036873','','2014-01-11','21:56:41',0,'2014-01-13 03:01:09',NULL,NULL),(12567,1664,'2432340','834','00','005010X220A1','2432340','','2013-12-31','14:44:08',1,'2014-01-02 04:35:59',NULL,NULL),(6069,1164,'1252064','834','00','005010X220A1','1252064','','2013-12-20','14:53:32',0,'2013-12-26 03:00:19',NULL,NULL),(12258,1620,'2006277','834','00','005010X220A1','2006277','','2014-01-01','11:56:52',1,'2014-01-02 04:23:44',NULL,NULL),(4427,790,'676984','834','00','005010X220A1','676984','','2013-11-06','00:06:09',0,'2013-12-25 23:16:56',NULL,NULL),(5007,935,'654131','834','00','005010X220A1','654131','','2013-12-11','10:44:12',0,'2013-12-26 00:46:11',NULL,NULL),(5032,935,'681167','834','00','005010X220A1','681167','','2013-12-11','13:33:00',0,'2013-12-26 00:47:00',NULL,NULL),(11158,1438,'46015','834','00','005010X220A1','46015','','2013-12-23','09:39:50',0,'2013-12-26 13:16:12',NULL,NULL),(10998,1413,'1214955','834','00','005010X220A1','1214955','','2013-12-23','15:58:08',0,'2013-12-26 13:10:42',NULL,NULL),(15129,2587,'2576228','834','00','005010X220A1','2576228','','2014-01-15','15:57:11',0,'2014-01-16 08:45:39',NULL,NULL),(16116,2808,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 03:44:46',NULL,NULL),(23110,4341,'2948273','834','00','005010X220A1','2948273','','2014-03-07','16:51:46',0,'2014-03-07 21:30:42',NULL,NULL),(111,6,'796707','834','00','005010X220A1','796707','','2013-12-05','12:06:35',0,'2013-12-25 17:18:22',NULL,NULL),(6126,1166,'88908','834','00','005010X220A1','88908','','2013-12-20','15:20:45',0,'2013-12-26 03:02:06',NULL,NULL),(5570,1043,'1633978','834','00','005010X220A1','1633978','','2013-12-24','20:28:03',0,'2013-12-26 01:48:40',NULL,NULL),(5217,951,'364523','834','00','005010X220A1','364523','','2013-12-11','13:07:59',0,'2013-12-26 00:52:56',NULL,NULL),(12371,1634,'1562717','834','00','005010X220A1','1562717','','2013-12-31','18:07:15',1,'2014-01-02 04:28:36',NULL,NULL),(1224,243,'412418','834','00','005010X220A1','412418','','2013-12-24','09:12:18',0,'2013-12-25 18:48:31',NULL,NULL),(3020,543,'1134747','834','00','005010X220A1','1134747','','2013-12-13','15:46:47',0,'2013-12-25 21:33:43',NULL,NULL),(1809,310,'690661','834','00','005010X220A1','690661','','2013-12-10','11:54:39',0,'2013-12-25 19:19:56',NULL,NULL),(15317,2622,'1754356','834','00','005010X220A1','1754356','','2014-01-16','01:26:31',0,'2014-01-17 03:35:08',NULL,NULL),(18899,3503,'1818027','834','00','005010X220A1','1818027','','2014-02-11','10:03:24',0,'2014-02-11 21:02:35',NULL,NULL),(18905,3506,'1912169','834','00','005010X220A1','1912169','','2014-02-11','14:29:12',0,'2014-02-11 21:02:41',NULL,NULL),(19723,3672,'2383429','834','00','005010X220A1','2383429','','2014-02-15','13:59:00',0,'2014-02-15 22:00:24',NULL,NULL),(21387,4024,'2659634','834','00','005010X220A1','2659634','','2014-02-27','15:18:15',0,'2014-02-28 06:30:29',NULL,NULL),(22310,4201,'3759012','834','00','005010X220A1','3759012','','2014-03-04','13:57:57',0,'2014-03-04 21:01:05',NULL,NULL),(22875,4281,'2791849','834','00','005010X220A1','2791849','','2014-03-06','14:45:24',0,'2014-03-06 21:01:58',NULL,NULL),(13559,2252,'1652781','834','00','005010X220A1','1652781','','2014-01-06','14:49:08',0,'2014-01-07 04:06:54',NULL,NULL),(13145,1989,'0001','999','BE','005010X231A1','1217911','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:19',NULL,NULL),(5306,988,'325241','834','00','005010X220A1','325241','','2013-11-05','13:30:45',0,'2013-12-26 01:01:39',NULL,NULL),(2464,424,'878287','834','00','005010X220A1','878287','','2013-12-06','01:13:17',0,'2013-12-25 20:19:19',NULL,NULL),(3693,633,'1228253','834','00','005010X220A1','1228253','','2013-12-12','10:39:45',0,'2013-12-25 22:07:17',NULL,NULL),(12310,1630,'1657845','834','00','005010X220A1','1657845','','2014-01-01','17:20:45',1,'2014-01-02 04:25:39',NULL,NULL),(11689,1517,'1083843','834','00','005010X220A1','1083843','','2013-12-28','08:50:37',1,'2013-12-29 11:07:35',NULL,NULL),(15732,2711,'2479365','834','00','005010X220A1','2479365','','2014-01-20','16:24:14',0,'2014-01-21 08:46:07',NULL,NULL),(16590,3041,'1733741','834','00','005010X220A1','1733741','','2014-01-25','13:05:23',0,'2014-01-25 19:00:17',NULL,NULL),(18007,3318,'1961066','834','00','005010X220A1','1961066','','2014-02-06','17:24:56',0,'2014-02-06 21:00:12',NULL,NULL),(19489,3620,'2986525','834','00','005010X220A1','2986525','','2014-02-14','10:55:41',0,'2014-02-14 21:30:18',NULL,NULL),(20874,3917,'3576004','834','00','005010X220A1','3576004','','2014-02-24','21:28:27',0,'2014-02-25 21:31:49',NULL,NULL),(22044,4163,'2965675','834','00','005010X220A1','2965675','','2014-03-03','17:15:40',0,'2014-03-03 21:00:06',NULL,NULL),(22089,4175,'2730329','834','00','005010X220A1','2730329','','2014-03-03','16:38:52',0,'2014-03-03 21:30:09',NULL,NULL),(22245,4200,'3527294','834','00','005010X220A1','3527294','','2014-03-03','18:12:37',0,'2014-03-04 21:00:16',NULL,NULL),(22870,4281,'2822715','834','00','005010X220A1','2822715','','2014-03-05','19:13:25',0,'2014-03-06 21:01:54',NULL,NULL),(14480,2501,'0001','999','BE','005010X231A1','858759','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:51',NULL,NULL),(5030,935,'106963','834','00','005010X220A1','106963','','2013-12-11','13:09:42',0,'2013-12-26 00:46:57',NULL,NULL),(3458,610,'563684','834','00','005010X220A1','563684','','2013-12-17','13:29:16',0,'2013-12-25 21:53:36',NULL,NULL),(12624,1671,'1388286','834','00','005010X220A1','1388286','','2014-01-02','15:22:34',0,'2014-01-03 02:01:56',NULL,NULL),(12311,1631,'2469596','834','00','005010X220A1','2469596','','2014-01-01','11:33:55',1,'2014-01-02 04:25:42',NULL,NULL),(15965,2764,'2559742','834','00','005010X220A1','2559742','','2014-01-22','10:22:11',0,'2014-01-23 03:01:57',NULL,NULL),(18978,3537,'2385842','834','00','005010X220A1','2385842','','2014-02-12','11:08:14',0,'2014-02-12 21:30:12',NULL,NULL),(19163,3556,'2650448','834','00','005010X220A1','2650448','','2014-02-12','15:03:04',0,'2014-02-12 21:32:20',NULL,NULL),(6148,1166,'1352496','834','00','005010X220A1','1352496','','2013-12-20','18:41:56',0,'2013-12-26 03:02:45',NULL,NULL),(4897,903,'244139','834','00','005010X220A1','244139','','2013-10-02','17:56:00',0,'2013-12-26 00:17:17',NULL,NULL),(16024,2768,'2253581','834','00','005010X220A1','2253581','','2014-01-22','10:36:16',0,'2014-01-23 03:02:24',NULL,NULL),(21819,4095,'2879962','834','00','005010X220A1','2879962','','2014-02-27','23:30:43',0,'2014-02-28 21:31:34',NULL,NULL),(6264,1172,'1125132','834','00','005010X220A1','1125132','','2013-12-20','08:22:17',0,'2013-12-26 03:06:20',NULL,NULL),(3855,687,'936139','834','00','005010X220A1','936139','','2013-11-08','10:10:43',0,'2013-12-25 22:30:45',NULL,NULL),(464,87,'260723','834','00','005010X220A1','260723','','2013-12-03','23:24:45',0,'2013-12-25 17:50:26',NULL,NULL),(3109,546,'982885','834','00','005010X220A1','982885','','2013-12-13','14:49:34',0,'2013-12-25 21:36:26',NULL,NULL),(4319,750,'860740','834','00','005010X220A1','860740','','2013-12-19','16:46:11',0,'2013-12-25 23:09:49',NULL,NULL),(5325,1001,'1196228','834','00','005010X220A1','1196228','','2013-11-05','16:19:09',0,'2013-12-26 01:02:23',NULL,NULL),(5445,1035,'412618','834','00','005010X220A1','412618','','2013-11-03','10:03:28',0,'2013-12-26 01:31:49',NULL,NULL),(16643,3060,'2098315','834','00','005010X220A1','2098315','','2014-01-27','09:59:55',0,'2014-01-27 21:00:07',NULL,NULL),(18170,3350,'2322144','834','00','005010X220A1','2322144','','2014-02-07','16:13:17',0,'2014-02-07 19:00:14',NULL,NULL),(18248,3374,'2997795','834','00','005010X220A1','2997795','','2014-02-06','23:03:03',0,'2014-02-07 19:30:03',NULL,NULL),(18705,3484,'2698767','834','00','005010X220A1','2698767','','2014-02-10','17:44:45',0,'2014-02-10 21:32:18',NULL,NULL),(18853,3491,'2556564','834','00','005010X220A1','2556564','','2014-02-11','14:46:26',0,'2014-02-11 21:01:55',NULL,NULL),(15270,2605,'2232026','834','00','005010X220A1','2232026','','2014-01-15','01:52:18',0,'2014-01-16 08:47:11',NULL,NULL),(12888,1707,'1797188','834','00','005010X220A1','1797188','','2014-01-03','16:14:36',0,'2014-01-04 02:04:27',NULL,NULL),(17528,3235,'1509113','834','00','005010X220A1','1509113','','2014-02-03','13:20:12',0,'2014-02-03 21:00:14',NULL,NULL),(6303,1174,'268748','834','00','005010X220A1','268748','','2013-12-20','12:55:22',0,'2013-12-26 03:07:29',NULL,NULL),(2174,363,'1274698','834','00','005010X220A1','1274698','','2013-12-01','18:40:27',0,'2013-12-25 19:47:17',NULL,NULL),(16347,2983,'1863847','834','00','005010X220A1','1863847','','2014-01-23','12:15:59',0,'2014-01-23 21:00:46',NULL,NULL),(17046,3122,'2630097','834','00','005010X220A1','2630097','','2014-01-29','14:31:28',0,'2014-01-29 21:01:24',NULL,NULL),(19525,3622,'3462685','834','00','005010X220A1','3462685','','2014-02-14','12:16:39',0,'2014-02-14 21:30:43',NULL,NULL),(113,7,'639659','834','00','005010X220A1','639659','','2013-12-04','18:53:38',0,'2013-12-25 17:18:26',NULL,NULL),(14110,2344,'1389878','834','00','005010X220A1','1389878','','2014-01-08','16:05:56',0,'2014-01-13 02:22:17',NULL,NULL),(7467,1296,'927618','834','00','005010X220A1','927618','','2013-12-21','12:40:51',0,'2013-12-26 04:32:52',NULL,NULL),(13738,2275,'1878978','834','00','005010X220A1','1878978','','2014-01-07','17:27:22',0,'2014-01-08 18:24:46',NULL,NULL),(13497,2230,'2321338','834','00','005010X220A1','2321338','','2014-01-06','15:33:06',0,'2014-01-07 04:04:32',NULL,NULL),(12798,1703,'1735264','834','00','005010X220A1','1735264','','2014-01-03','11:50:08',0,'2014-01-04 02:01:12',NULL,NULL),(7511,1300,'866854','834','00','005010X220A1','866854','','2013-12-21','10:29:16',0,'2013-12-26 04:34:22',NULL,NULL),(17420,3200,'1487107','834','00','005010X220A1','1487107','','2014-02-01','15:44:01',0,'2014-02-01 19:00:21',NULL,NULL),(17840,3286,'2422236','834','00','005010X220A1','2422236','','2014-02-05','17:59:24',0,'2014-02-05 21:00:03',NULL,NULL),(22737,4276,'3644493','834','00','005010X220A1','3644493','','2014-03-05','22:56:40',0,'2014-03-06 21:00:20',NULL,NULL),(11143,1433,'766453','834','00','005010X220A1','766453','','2013-12-23','09:57:59',0,'2013-12-26 13:15:41',NULL,NULL),(11140,1432,'233276','834','00','005010X220A1','233276','','2013-12-23','14:47:36',0,'2013-12-26 13:15:35',NULL,NULL),(2506,448,'1019471','834','00','005010X220A1','1019471','','2013-10-12','19:37:34',0,'2013-12-25 20:30:14',NULL,NULL),(1605,281,'1210045','834','00','005010X220A1','1210045','','2013-11-20','09:29:43',0,'2013-12-25 19:01:20',NULL,NULL),(16381,2986,'1996296','834','00','005010X220A1','1996296','','2014-01-23','15:47:06',0,'2014-01-23 21:01:10',NULL,NULL),(19756,3673,'3187007','834','00','005010X220A1','3187007','','2014-02-15','16:39:13',0,'2014-02-15 22:00:48',NULL,NULL),(20405,3833,'2873079','834','00','005010X220A1','2873079','','2014-02-20','13:42:28',0,'2014-02-20 21:30:10',NULL,NULL),(22209,4186,'2677620','834','00','005010X220A1','2677620','','2014-03-03','16:11:52',0,'2014-03-03 21:31:38',NULL,NULL),(7419,1295,'438811','834','00','005010X220A1','438811','','2013-12-21','08:10:29',0,'2013-12-26 04:31:28',NULL,NULL),(4568,825,'1711281','834','00','005010X220A1','1711281','','2013-12-24','01:29:07',0,'2013-12-25 23:46:16',NULL,NULL),(4393,774,'640984','834','00','005010X220A1','640984','','2013-11-27','17:00:19',0,'2013-12-25 23:15:42',NULL,NULL),(1544,263,'1742563','834','00','005010X220A1','1742563','','2013-12-24','17:18:46',0,'2013-12-25 18:58:45',NULL,NULL),(2155,361,'912721','834','00','005010X220A1','912721','','2013-12-02','10:12:54',0,'2013-12-25 19:46:38',NULL,NULL),(14592,2521,'1699375','834','00','005010X220A1','1699375','','2014-01-13','12:35:54',0,'2014-01-14 01:33:01',NULL,NULL),(3099,546,'1273892','834','00','005010X220A1','1273892','','2013-12-13','09:27:28',0,'2013-12-25 21:36:09',NULL,NULL),(3502,615,'1065501','834','00','005010X220A1','1065501','','2013-12-12','14:39:13',0,'2013-12-25 22:01:16',NULL,NULL),(7593,1302,'240443','834','00','005010X220A1','240443','','2013-12-21','11:14:29',0,'2013-12-26 04:37:05',NULL,NULL),(11625,1496,'1790841','834','00','005010X220A1','1790841','','2013-12-26','20:57:44',0,'2013-12-28 03:35:30',NULL,NULL),(12281,1624,'1382011','834','00','005010X220A1','1382011','','2013-12-31','22:15:25',1,'2014-01-02 04:24:34',NULL,NULL),(12426,1638,'2194883','834','00','005010X220A1','2194883','','2013-12-31','12:35:16',1,'2014-01-02 04:30:36',NULL,NULL),(12477,1640,'2012055','834','00','005010X220A1','2012055','','2013-12-31','10:46:23',1,'2014-01-02 04:32:25',NULL,NULL),(12712,1677,'1710408','834','00','005010X220A1','1710408','','2014-01-02','13:37:10',0,'2014-01-03 02:05:12',NULL,NULL),(13281,2125,'0001','999','BE','005010X231A1','180178','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:19',NULL,NULL),(13420,2222,'2091527','834','00','005010X220A1','2091527','','2014-01-06','16:41:58',0,'2014-01-07 04:01:34',NULL,NULL),(15968,2764,'1877016','834','00','005010X220A1','1877016','','2014-01-22','16:01:42',0,'2014-01-23 03:01:58',NULL,NULL),(19526,3622,'2691370','834','00','005010X220A1','2691370','','2014-02-14','13:09:19',0,'2014-02-14 21:30:44',NULL,NULL),(20753,3903,'2710370','834','00','005010X220A1','2710370','','2014-02-25','15:13:45',0,'2014-02-25 21:30:22',NULL,NULL),(15604,2662,'1632445','834','00','005010X220A1','1632445','','2014-01-17','10:23:00',0,'2014-01-20 08:06:28',NULL,NULL),(489,102,'1187192','834','00','005010X220A1','1187192','','2013-12-15','19:09:11',0,'2013-12-25 18:00:07',NULL,NULL),(726,123,'180076','834','00','005010X220A1','180076','','2013-12-16','10:14:48',0,'2013-12-25 18:07:38',NULL,NULL),(13220,2064,'0001','999','BE','005010X231A1','160713','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:48',NULL,NULL),(5901,1110,'512817','834','00','005010X220A1','512817','','2013-12-15','13:28:25',0,'2013-12-26 02:30:49',NULL,NULL),(11339,1456,'545881','834','00','005010X220A1','545881','','2013-12-26','16:45:58',0,'2013-12-27 02:04:42',NULL,NULL),(5546,1041,'1282522','834','00','005010X220A1','1282522','','2013-12-25','12:42:37',0,'2013-12-26 01:47:55',NULL,NULL),(15561,2655,'2523971','834','00','005010X220A1','2523971','','2014-01-17','12:42:01',0,'2014-01-20 08:05:56',NULL,NULL),(7699,1331,'890268','834','00','005010X220A1','890268','','2013-11-15','17:58:33',0,'2013-12-26 04:45:25',NULL,NULL),(6387,1186,'768771','834','00','005010X220A1','768771','','2013-12-20','09:13:49',0,'2013-12-26 03:10:05',NULL,NULL),(13089,1933,'0001','999','BE','005010X231A1','906097','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:08',NULL,NULL),(4565,825,'1538990','834','00','005010X220A1','1538990','','2013-12-24','01:47:10',0,'2013-12-25 23:46:10',NULL,NULL),(5168,946,'848431','834','00','005010X220A1','848431','','2013-12-10','20:12:55',0,'2013-12-26 00:51:20',NULL,NULL),(12881,1706,'2353063','834','00','005010X220A1','2353063','','2014-01-03','16:29:18',0,'2014-01-04 02:04:12',NULL,NULL),(16700,3064,'1631334','834','00','005010X220A1','1631334','','2014-01-26','22:50:43',0,'2014-01-27 21:00:44',NULL,NULL),(16968,3116,'1396317','834','00','005010X220A1','1396317','','2014-01-29','13:03:55',0,'2014-01-29 21:00:35',NULL,NULL),(19157,3555,'2524547','834','00','005010X220A1','2524547','','2014-02-12','15:11:37',0,'2014-02-12 21:32:16',NULL,NULL),(19648,3647,'2701652','834','00','005010X220A1','2701652','','2014-02-14','12:06:47',0,'2014-02-14 21:32:12',NULL,NULL),(22717,4270,'3052193','834','00','005010X220A1','3052193','','2014-03-05','14:35:56',0,'2014-03-05 21:32:41',NULL,NULL),(15666,2685,'2310440','834','00','005010X220A1','2310440','','2014-01-18','09:42:21',0,'2014-01-21 08:44:36',NULL,NULL),(15194,2592,'1903929','834','00','005010X220A1','1903929','','2014-01-14','22:37:10',0,'2014-01-16 08:46:21',NULL,NULL),(12911,1714,'1667497','834','00','005010X220A1','1667497','','2014-01-03','11:14:09',0,'2014-01-04 02:05:19',NULL,NULL),(3087,546,'127278','834','00','005010X220A1','127278','','2013-12-12','19:07:52',0,'2013-12-25 21:35:48',NULL,NULL),(11198,1453,'1995578','834','00','005010X220A1','1995578','','2013-12-26','15:53:29',0,'2013-12-27 02:00:22',NULL,NULL),(19109,3544,'2824327','834','00','005010X220A1','2824327','','2014-02-12','16:31:38',0,'2014-02-12 21:31:43',NULL,NULL),(20742,3903,'2864402','834','00','005010X220A1','2864402','','2014-02-25','11:49:39',0,'2014-02-25 21:30:12',NULL,NULL),(14722,2550,'1451262','834','00','005010X220A1','1451262','','2014-01-14','11:47:22',0,'2014-01-15 02:06:11',NULL,NULL),(4763,859,'604596','834','00','005010X220A1','604596','','2013-12-01','09:37:41',0,'2013-12-26 00:00:45',NULL,NULL),(6308,1174,'317192','834','00','005010X220A1','317192','','2013-12-20','15:43:20',0,'2013-12-26 03:07:38',NULL,NULL),(4236,738,'644118','834','00','005010X220A1','644118','','2013-12-19','15:54:50',0,'2013-12-25 23:07:21',NULL,NULL),(5577,1043,'1877490','834','00','005010X220A1','1877490','','2013-12-24','22:07:33',0,'2013-12-26 01:48:55',NULL,NULL),(18245,3371,'3046609','834','00','005010X220A1','3046609','','2014-02-07','17:29:35',0,'2014-02-07 19:01:09',NULL,NULL),(18663,3467,'2534319','834','00','005010X220A1','2534319','','2014-02-10','10:12:39',0,'2014-02-10 21:31:48',NULL,NULL),(22018,4151,'3200743','834','00','005010X220A1','3200743','','2014-03-02','16:07:58',0,'2014-03-03 01:00:34',NULL,NULL),(14630,2525,'1610469','834','00','005010X220A1','1610469','','2014-01-13','09:13:52',0,'2014-01-14 01:33:25',NULL,NULL),(2521,454,'428613','834','00','005010X220A1','428613','','2013-11-18','12:47:15',0,'2013-12-25 20:30:40',NULL,NULL),(13619,2270,'1520972','834','00','005010X220A1','1520972','','2014-01-06','23:56:00',0,'2014-01-08 18:23:57',NULL,NULL),(2113,360,'305119','834','00','005010X220A1','305119','','2013-12-01','21:12:26',0,'2013-12-25 19:45:20',NULL,NULL),(10920,1410,'218555','834','00','005010X220A1','218555','','2013-12-23','09:43:03',0,'2013-12-26 13:08:18',NULL,NULL),(16536,3020,'2206652','834','00','005010X220A1','2206652','','2014-01-24','16:45:33',0,'2014-01-24 21:01:05',NULL,NULL),(16570,3035,'2335768','834','00','005010X220A1','2335768','','2014-01-25','13:22:35',0,'2014-01-25 19:00:06',NULL,NULL),(18179,3351,'2408472','834','00','005010X220A1','2408472','','2014-02-06','20:33:02',0,'2014-02-07 19:00:21',NULL,NULL),(877,177,'648759','834','00','005010X220A1','648759','','2013-12-03','07:49:40',0,'2013-12-25 18:16:31',NULL,NULL),(15486,2634,'2464591','834','00','005010X220A1','2464591','','2014-01-16','13:00:03',0,'2014-01-17 03:36:25',NULL,NULL),(15167,2589,'2214197','834','00','005010X220A1','2214197','','2014-01-14','19:22:34',0,'2014-01-16 08:46:05',NULL,NULL),(7527,1300,'1123824','834','00','005010X220A1','1123824','','2013-12-21','13:35:29',0,'2013-12-26 04:34:55',NULL,NULL),(2365,413,'1051910','834','00','005010X220A1','1051910','','2013-12-06','07:39:14',0,'2013-12-25 20:16:11',NULL,NULL),(15102,2587,'1459789','834','00','005010X220A1','1459789','','2014-01-14','20:30:38',0,'2014-01-16 08:45:22',NULL,NULL),(14659,2534,'2579717','834','00','005010X220A1','2579717','','2014-01-13','13:47:47',0,'2014-01-14 01:33:44',NULL,NULL),(7459,1296,'957002','834','00','005010X220A1','957002','','2013-12-21','06:19:31',0,'2013-12-26 04:32:39',NULL,NULL),(23035,4329,'3159034','834','00','005010X220A1','3159034','','2014-03-07','14:30:35',0,'2014-03-07 21:00:27',NULL,NULL),(23156,4344,'3774750','834','00','005010X220A1','3774750','','2014-03-06','22:12:22',0,'2014-03-07 21:31:15',NULL,NULL),(13560,2253,'2244714','834','00','005010X220A1','2244714','','2014-01-04','18:32:37',1,'2014-01-07 10:21:12',NULL,NULL),(641,108,'823851','834','00','005010X220A1','823851','','2013-12-16','13:17:39',0,'2013-12-25 18:04:56',NULL,NULL),(7617,1305,'550425','834','00','005010X220A1','550425','','2013-12-20','19:39:27',0,'2013-12-26 04:37:48',NULL,NULL),(1610,281,'227902','834','00','005010X220A1','227902','','2013-11-19','23:00:53',0,'2013-12-25 19:01:28',NULL,NULL),(5134,943,'885102','834','00','005010X220A1','885102','','2013-12-11','09:47:29',0,'2013-12-26 00:50:20',NULL,NULL),(5744,1070,'20774','834','00','005010X220A1','20774','','2013-12-14','13:13:57',0,'2013-12-26 02:01:43',NULL,NULL),(16742,3066,'2348285','834','00','005010X220A1','2348285','','2014-01-27','11:01:00',0,'2014-01-27 21:01:12',NULL,NULL),(17764,3262,'2725810','834','00','005010X220A1','2725810','','2014-02-04','16:50:03',0,'2014-02-04 21:01:08',NULL,NULL),(17982,3306,'2304422','834','00','005010X220A1','2304422','','2014-02-05','14:54:57',0,'2014-02-05 21:31:12',NULL,NULL),(18160,3350,'2714526','834','00','005010X220A1','2714526','','2014-02-06','20:11:39',0,'2014-02-07 19:00:07',NULL,NULL),(18263,3376,'2649149','834','00','005010X220A1','2649149','','2014-02-08','13:21:32',0,'2014-02-08 19:00:11',NULL,NULL),(20648,3875,'3499821','834','00','005010X220A1','3499821','','2014-02-21','13:23:47',0,'2014-02-21 22:00:51',NULL,NULL),(21100,3990,'2904665','834','00','005010X220A1','2904665','','2014-02-24','17:42:06',0,'2014-02-26 09:31:05',NULL,NULL),(483,99,'169321','834','00','005010X220A1','169321','','2013-12-04','14:36:04',0,'2013-12-25 17:51:06',NULL,NULL),(15158,2588,'1671586','834','00','005010X220A1','1671586','','2014-01-15','16:42:21',0,'2014-01-16 08:45:59',NULL,NULL),(13459,2225,'2058505','834','00','005010X220A1','2058505','','2014-01-06','14:21:57',0,'2014-01-07 04:03:06',NULL,NULL),(12606,1671,'1901234','834','00','005010X220A1','1901234','','2014-01-01','20:44:29',0,'2014-01-03 02:01:19',NULL,NULL),(12131,1587,'2390831','834','00','005010X220A1','2390831','','2013-12-30','17:55:21',0,'2014-01-01 12:06:47',NULL,NULL),(11977,1580,'1561302','834','00','005010X220A1','1561302','','2013-12-30','15:15:09',0,'2014-01-01 12:01:15',NULL,NULL),(3312,584,'1115582','834','00','005010X220A1','1115582','','2013-12-17','15:18:55',0,'2013-12-25 21:48:53',NULL,NULL),(3529,616,'1183352','834','00','005010X220A1','1183352','','2013-12-11','18:57:18',0,'2013-12-25 22:02:06',NULL,NULL),(10545,1402,'1423524','834','00','005010X220A1','1423524','','2013-12-22','19:47:45',0,'2013-12-26 12:55:20',NULL,NULL),(16733,3065,'1673271','834','00','005010X220A1','1673271','','2014-01-27','11:11:49',0,'2014-01-27 21:01:06',NULL,NULL),(18216,3356,'2712445','834','00','005010X220A1','2712445','','2014-02-07','16:10:11',0,'2014-02-07 19:00:45',NULL,NULL),(11969,1580,'2241174','834','00','005010X220A1','2241174','','2013-12-30','12:59:20',0,'2014-01-01 12:00:54',NULL,NULL),(527,102,'531072','834','00','005010X220A1','531072','','2013-12-16','14:00:27',0,'2013-12-25 18:01:14',NULL,NULL),(5153,943,'1103885','834','00','005010X220A1','1103885','','2013-12-11','17:02:55',0,'2013-12-26 00:50:53',NULL,NULL),(11881,1560,'1789866','834','00','005010X220A1','1789866','','2013-12-29','14:26:31',0,'2013-12-30 00:00:25',NULL,NULL),(11007,1414,'312002','834','00','005010X220A1','312002','','2013-12-22','22:47:22',0,'2013-12-26 13:11:02',NULL,NULL),(19896,3713,'3485102','834','00','005010X220A1','3485102','','2014-02-15','21:12:55',0,'2014-02-16 19:00:36',NULL,NULL),(20583,3869,'3601703','834','00','005010X220A1','3601703','','2014-02-21','13:01:13',0,'2014-02-21 21:30:25',NULL,NULL),(21021,3970,'2856242','834','00','005010X220A1','2856242','','2014-02-22','16:03:27',0,'2014-02-26 08:30:56',NULL,NULL),(22537,4248,'2989591','834','00','005010X220A1','2989591','','2014-03-04','18:48:28',0,'2014-03-05 21:30:33',NULL,NULL),(12737,1685,'1974603','834','00','005010X220A1','1974603','','2014-01-02','18:01:54',0,'2014-01-03 02:06:11',NULL,NULL),(954,181,'458596','834','00','005010X220A1','458596','','2013-12-03','14:16:25',0,'2013-12-25 18:18:46',NULL,NULL),(11341,1456,'825977','834','00','005010X220A1','825977','','2013-12-26','17:02:25',0,'2013-12-27 02:04:46',NULL,NULL),(3439,601,'405812','834','00','005010X220A1','405812','','2013-12-17','09:32:10',0,'2013-12-25 21:52:57',NULL,NULL),(6225,1168,'917156','834','00','005010X220A1','917156','','2013-12-20','15:40:23',0,'2013-12-26 03:05:05',NULL,NULL),(6118,1166,'571627','834','00','005010X220A1','571627','','2013-12-20','14:23:48',0,'2013-12-26 03:01:50',NULL,NULL),(17839,3286,'2373036','834','00','005010X220A1','2373036','','2014-02-04','19:59:35',0,'2014-02-05 21:00:03',NULL,NULL),(17937,3299,'2863882','834','00','005010X220A1','2863882','','2014-02-04','19:30:34',0,'2014-02-05 21:30:48',NULL,NULL),(19091,3543,'2972639','834','00','005010X220A1','2972639','','2014-02-12','09:19:00',0,'2014-02-12 21:31:32',NULL,NULL),(19483,3620,'1691923','834','00','005010X220A1','1691923','','2014-02-13','23:39:15',0,'2014-02-14 21:30:14',NULL,NULL),(20962,3955,'2835154','834','00','005010X220A1','2835154','','2014-02-23','15:42:37',0,'2014-02-26 08:00:50',NULL,NULL),(22571,4248,'3368373','834','00','005010X220A1','3368373','','2014-03-05','13:55:49',0,'2014-03-05 21:30:57',NULL,NULL),(226,35,'310956','834','00','005010X220A1','310956','','2013-10-11','23:48:00',0,'2013-12-25 17:30:06',NULL,NULL),(12052,1585,'120532','834','00','005010X220A1','120532','','2013-12-29','20:06:25',0,'2014-01-01 12:04:04',NULL,NULL),(7406,1295,'1162444','834','00','005010X220A1','1162444','','2013-12-20','21:40:25',0,'2013-12-26 04:31:03',NULL,NULL),(5983,1123,'372997','834','00','005010X220A1','372997','','2013-12-15','08:57:28',0,'2013-12-26 02:33:26',NULL,NULL),(5906,1111,'1137092','834','00','005010X220A1','1137092','','2013-12-15','09:30:54',0,'2013-12-26 02:30:58',NULL,NULL),(10445,1400,'1016817','834','00','005010X220A1','1016817','','2013-12-23','13:00:08',0,'2013-12-26 12:52:08',NULL,NULL),(7632,1308,'956013','834','00','005010X220A1','956013','','2013-12-21','18:18:57',0,'2013-12-26 04:38:17',NULL,NULL),(7538,1300,'392760','834','00','005010X220A1','392760','','2013-12-21','15:27:21',0,'2013-12-26 04:35:13',NULL,NULL),(14395,2417,'2410461','834','00','005010X220A1','2410461','','2014-01-12','17:46:37',0,'2014-01-13 03:01:58',NULL,NULL),(13266,2110,'0001','999','BE','005010X231A1','856276','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:37',NULL,NULL),(2280,393,'995228','834','00','005010X220A1','995228','','2013-11-23','18:30:49',0,'2013-12-25 20:00:29',NULL,NULL),(5020,935,'577594','834','00','005010X220A1','577594','','2013-12-11','11:36:18',0,'2013-12-26 00:46:36',NULL,NULL),(17292,3172,'2454477','834','00','005010X220A1','2454477','','2014-01-31','14:21:04',0,'2014-01-31 21:00:36',NULL,NULL),(23463,4413,'3830137','834','00','005010X220A1','3830137','','2014-03-09','15:51:48',0,'2014-03-09 21:01:02',NULL,NULL),(23554,4436,'2812215','834','00','005010X220A1','2812215','','2014-03-09','19:30:35',0,'2014-03-10 21:00:44',NULL,NULL),(15802,2723,'2255788','834','00','005010X220A1','2255788','','2014-01-20','12:16:49',0,'2014-01-21 08:46:49',NULL,NULL),(4486,803,'472595','834','00','005010X220A1','472595','','2013-11-25','18:57:54',0,'2013-12-25 23:31:38',NULL,NULL),(2863,513,'793590','834','00','005010X220A1','793590','','2013-12-22','17:22:55',0,'2013-12-25 21:22:24',NULL,NULL),(4230,738,'204132','834','00','005010X220A1','204132','','2013-12-19','14:09:14',0,'2013-12-25 23:07:09',NULL,NULL),(3569,617,'472933','834','00','005010X220A1','472933','','2013-12-11','22:21:45',0,'2013-12-25 22:03:24',NULL,NULL),(11643,1499,'1857284','834','00','005010X220A1','1857284','','2013-12-26','23:40:18',0,'2013-12-28 03:36:02',NULL,NULL),(19758,3674,'3460165','834','00','005010X220A1','3460165','','2014-02-15','07:12:33',0,'2014-02-15 22:00:49',NULL,NULL),(20949,3949,'3228639','834','00','005010X220A1','3228639','','2014-02-24','14:02:37',0,'2014-02-26 08:00:41',NULL,NULL),(23405,4404,'3031232','834','00','005010X220A1','3031232','','2014-03-08','23:38:47',0,'2014-03-09 21:00:15',NULL,NULL),(12793,1703,'1605407','834','00','005010X220A1','1605407','','2014-01-03','11:06:58',0,'2014-01-04 02:00:59',NULL,NULL),(12703,1677,'2522143','834','00','005010X220A1','2522143','','2014-01-02','12:38:34',0,'2014-01-03 02:04:53',NULL,NULL),(3589,617,'1066955','834','00','005010X220A1','1066955','','2013-12-12','15:54:54',0,'2013-12-25 22:04:01',NULL,NULL),(1917,325,'394562','834','00','005010X220A1','394562','','2013-12-09','16:37:10',0,'2013-12-25 19:32:15',NULL,NULL),(11330,1456,'2246808','834','00','005010X220A1','2246808','','2013-12-26','14:33:02',0,'2013-12-27 02:04:25',NULL,NULL),(19703,3671,'3044271','834','00','005010X220A1','3044271','','2014-02-15','13:45:54',0,'2014-02-15 22:00:09',NULL,NULL),(21792,4092,'3076210','834','00','005010X220A1','3076210','','2014-02-27','23:48:50',0,'2014-02-28 21:31:16',NULL,NULL),(22604,4250,'3656068','834','00','005010X220A1','3656068','','2014-03-05','12:35:11',0,'2014-03-05 21:31:21',NULL,NULL),(12734,1684,'1764223','834','00','005010X220A1','1764223','','2014-01-01','22:03:17',0,'2014-01-03 02:06:05',NULL,NULL),(10896,1409,'1363594','834','00','005010X220A1','1363594','','2013-12-23','01:05:53',0,'2013-12-26 13:07:29',NULL,NULL),(11434,1478,'476038','834','00','005010X220A1','476038','','2013-12-26','13:58:31',0,'2013-12-27 02:07:40',NULL,NULL),(17430,3203,'2093574','834','00','005010X220A1','2093574','','2014-01-31','21:13:35',0,'2014-02-01 19:00:28',NULL,NULL),(149,10,'502487','834','00','005010X220A1','502487','','2013-12-05','10:42:22',0,'2013-12-25 17:19:39',NULL,NULL),(16565,3034,'1742070','834','00','005010X220A1','1742070','','2014-01-25','16:41:11',0,'2014-01-25 19:00:04',NULL,NULL),(856,175,'1145585','834','00','005010X220A1','1145585','','2013-12-03','14:25:58',0,'2013-12-25 18:15:49',NULL,NULL),(15765,2714,'2088336','834','00','005010X220A1','2088336','','2014-01-20','10:09:27',0,'2014-01-21 08:46:26',NULL,NULL),(7047,1235,'818550','834','00','005010X220A1','818550','','2013-12-18','17:08:40',0,'2013-12-26 04:01:56',NULL,NULL),(14682,2549,'1818766','834','00','005010X220A1','1818766','','2014-01-13','19:12:48',0,'2014-01-15 02:05:54',NULL,NULL),(13305,2149,'0001','999','BE','005010X231A1','632109','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:26',NULL,NULL),(4104,733,'235652','834','00','005010X220A1','235652','','2013-12-19','11:53:34',0,'2013-12-25 23:03:21',NULL,NULL),(3348,587,'100283','834','00','005010X220A1','100283','','2013-12-16','23:10:58',0,'2013-12-25 21:50:07',NULL,NULL),(17826,3276,'1847717','834','00','005010X220A1','1847717','','2014-02-04','14:31:35',0,'2014-02-04 21:01:51',NULL,NULL),(18536,3451,'2106119','834','00','005010X220A1','2106119','','2014-02-10','15:44:15',0,'2014-02-10 21:30:19',NULL,NULL),(21864,4118,'3317270','834','00','005010X220A1','3317270','','2014-02-28','20:41:50',0,'2014-03-01 19:00:11',NULL,NULL),(11261,1455,'1550825','834','00','005010X220A1','1550825','','2013-12-25','22:59:44',0,'2013-12-27 02:02:18',NULL,NULL),(16809,3089,'2384297','834','00','005010X220A1','2384297','','2014-01-28','15:43:06',0,'2014-01-28 21:00:13',NULL,NULL),(3697,633,'697317','834','00','005010X220A1','697317','','2013-12-12','12:21:26',0,'2013-12-25 22:07:26',NULL,NULL),(15652,2683,'2415666','834','00','005010X220A1','2415666','','2014-01-18','09:42:21',0,'2014-01-21 08:44:25',NULL,NULL),(23735,4467,'3314376','834','00','005010X220A1','3314376','','2014-03-10','14:22:32',0,'2014-03-10 21:02:56',NULL,NULL),(16812,3090,'2516233','834','00','005010X220A1','2516233','','2014-01-27','19:25:56',0,'2014-01-28 21:00:15',NULL,NULL),(473,91,'480442','834','00','005010X220A1','480442','','2013-12-04','07:52:49',0,'2013-12-25 17:50:45',NULL,NULL),(7224,1241,'682502','834','00','005010X220A1','682502','','2013-12-18','14:43:29',0,'2013-12-26 04:07:22',NULL,NULL),(15945,2760,'2451678','834','00','005010X220A1','2451678','','2014-01-21','15:03:53',1,'2014-01-22 03:23:10',NULL,NULL),(13783,2291,'1994725','834','00','005010X220A1','1994725','','2014-01-07','15:03:37',0,'2014-01-08 18:25:07',NULL,NULL),(4505,810,'416322','834','00','005010X220A1','416322','','2013-11-25','22:08:55',0,'2013-12-25 23:32:13',NULL,NULL),(13341,2185,'0001','999','BE','005010X231A1','371501','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:06',NULL,NULL),(2554,460,'1086486','834','00','005010X220A1','1086486','','2013-11-18','14:41:05',0,'2013-12-25 20:31:41',NULL,NULL),(12100,1587,'1553754','834','00','005010X220A1','1553754','','2013-12-30','08:19:18',0,'2014-01-01 12:05:41',NULL,NULL),(20038,3750,'3189255','834','00','005010X220A1','3189255','','2014-02-18','17:57:40',0,'2014-02-18 22:00:59',NULL,NULL),(20441,3841,'2677288','834','00','005010X220A1','2677288','','2014-02-20','14:05:44',0,'2014-02-20 22:00:15',NULL,NULL),(20841,3911,'3232201','834','00','005010X220A1','3232201','','2014-02-25','12:37:31',0,'2014-02-25 21:31:23',NULL,NULL),(20871,3916,'3407291','834','00','005010X220A1','3407291','','2014-02-25','13:31:52',0,'2014-02-25 21:31:47',NULL,NULL),(22811,4278,'3099587','834','00','005010X220A1','3099587','','2014-03-06','09:48:02',0,'2014-03-06 21:01:12',NULL,NULL),(516,102,'291693','834','00','005010X220A1','291693','','2013-12-16','12:34:53',0,'2013-12-25 18:00:57',NULL,NULL),(10678,1403,'1531360','834','00','005010X220A1','1531360','','2013-12-22','21:20:00',0,'2013-12-26 12:59:41',NULL,NULL),(16840,3091,'1747177','834','00','005010X220A1','1747177','','2014-01-28','17:31:39',0,'2014-01-28 21:00:32',NULL,NULL),(2564,465,'886861','834','00','005010X220A1','886861','','2013-11-18','12:44:45',0,'2013-12-25 20:32:02',NULL,NULL),(4882,891,'942452','834','00','005010X220A1','942452','','2013-11-21','17:00:11',0,'2013-12-26 00:16:40',NULL,NULL),(13612,2267,'2442550','834','00','005010X220A1','2442550','','2014-01-04','22:24:25',1,'2014-01-07 10:23:23',NULL,NULL),(3481,615,'648997','834','00','005010X220A1','648997','','2013-12-12','09:11:44',0,'2013-12-25 22:00:34',NULL,NULL),(12320,1634,'1488640','834','00','005010X220A1','1488640','','2013-12-30','20:03:51',1,'2014-01-02 04:26:48',NULL,NULL),(19225,3580,'3012606','834','00','005010X220A1','3012606','','2014-02-13','01:12:12',0,'2014-02-13 22:00:13',NULL,NULL),(22932,4293,'2932766','834','00','005010X220A1','2932766','','2014-03-06','17:20:58',0,'2014-03-06 21:02:40',NULL,NULL),(16005,2767,'1391572','834','00','005010X220A1','1391572','','2014-01-21','20:22:56',0,'2014-01-23 03:02:16',NULL,NULL),(5705,1068,'1263969','834','00','005010X220A1','1263969','','2013-12-13','18:29:32',0,'2013-12-26 02:00:36',NULL,NULL),(7383,1293,'1105727','834','00','005010X220A1','1105727','','2013-12-21','11:04:10',0,'2013-12-26 04:30:15',NULL,NULL),(1552,267,'1935909','834','00','005010X220A1','1935909','','2013-12-24','16:08:27',0,'2013-12-25 18:59:01',NULL,NULL),(1697,292,'723776','834','00','005010X220A1','723776','','2013-12-09','21:29:36',0,'2013-12-25 19:16:24',NULL,NULL),(3629,622,'8788','834','00','005010X220A1','8788','','2013-12-12','00:30:28',0,'2013-12-25 22:05:15',NULL,NULL),(11102,1425,'730592','834','00','005010X220A1','730592','','2013-12-23','11:19:56',0,'2013-12-26 13:14:11',NULL,NULL),(2304,400,'891466','834','00','005010X220A1','891466','','2013-11-02','16:23:27',0,'2013-12-25 20:01:21',NULL,NULL),(1179,239,'1312184','834','00','005010X220A1','1312184','','2013-12-24','14:49:06',0,'2013-12-25 18:47:07',NULL,NULL),(16270,2962,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:46:00',0,'2014-01-23 10:00:02',NULL,NULL),(11551,1492,'358691','834','00','005010X220A1','358691','','2013-12-26','21:00:13',0,'2013-12-28 03:33:11',NULL,NULL),(11318,1456,'451811','834','00','005010X220A1','451811','','2013-12-26','12:55:42',0,'2013-12-27 02:04:02',NULL,NULL),(2795,506,'1016700','834','00','005010X220A1','1016700','','2013-12-22','11:08:40',0,'2013-12-25 21:20:11',NULL,NULL),(15621,2670,'2471443','834','00','005010X220A1','2471443','','2014-01-17','17:59:09',0,'2014-01-20 08:06:41',NULL,NULL),(5192,949,'1004304','834','00','005010X220A1','1004304','','2013-12-11','11:38:24',0,'2013-12-26 00:52:05',NULL,NULL),(12948,1733,'2273600','834','00','005010X220A1','2273600','','2014-01-03','22:56:58',0,'2014-01-05 00:00:14',NULL,NULL),(3832,679,'903012','834','00','005010X220A1','903012','','2013-11-07','19:18:19',0,'2013-12-25 22:30:03',NULL,NULL),(4056,731,'801287','834','00','005010X220A1','801287','','2013-12-19','18:30:33',0,'2013-12-25 23:01:52',NULL,NULL),(4090,733,'258526','834','00','005010X220A1','258526','','2013-12-19','10:37:59',0,'2013-12-25 23:03:00',NULL,NULL),(12623,1671,'1408303','834','00','005010X220A1','1408303','','2014-01-02','15:22:12',0,'2014-01-03 02:01:53',NULL,NULL),(20981,3957,'2708791','834','00','005010X220A1','2708791','','2014-02-21','18:29:29',0,'2014-02-26 08:30:20',NULL,NULL),(16963,3116,'2327922','834','00','005010X220A1','2327922','','2014-01-29','11:43:26',0,'2014-01-29 21:00:32',NULL,NULL),(11886,1561,'1373948','834','00','005010X220A1','1373948','','2013-12-28','18:18:45',0,'2013-12-30 00:00:35',NULL,NULL),(591,105,'1010588','834','00','005010X220A1','1010588','','2013-12-16','14:44:40',0,'2013-12-25 18:03:18',NULL,NULL),(1471,252,'1619062','834','00','005010X220A1','1619062','','2013-12-24','16:20:27',0,'2013-12-25 18:56:28',NULL,NULL),(2107,360,'665724','834','00','005010X220A1','665724','','2013-12-01','19:37:55',0,'2013-12-25 19:45:08',NULL,NULL),(13184,2028,'0001','999','BE','005010X231A1','461070','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:08',NULL,NULL),(2958,541,'371789','834','00','005010X220A1','371789','','2013-12-13','10:56:54',0,'2013-12-25 21:31:50',NULL,NULL),(3303,584,'700044','834','00','005010X220A1','700044','','2013-12-17','12:34:04',0,'2013-12-25 21:48:34',NULL,NULL),(11260,1455,'2045153','834','00','005010X220A1','2045153','','2013-12-25','22:18:54',0,'2013-12-27 02:02:16',NULL,NULL),(4573,826,'1662590','834','00','005010X220A1','1662590','','2013-12-23','21:40:37',0,'2013-12-25 23:46:26',NULL,NULL),(4957,928,'1210035','834','00','005010X220A1','1210035','','2013-11-19','13:07:17',0,'2013-12-26 00:32:05',NULL,NULL),(6279,1172,'806209','834','00','005010X220A1','806209','','2013-12-20','14:46:42',0,'2013-12-26 03:06:49',NULL,NULL),(12155,1591,'2068895','834','00','005010X220A1','2068895','','2013-12-30','18:29:05',0,'2014-01-01 12:07:38',NULL,NULL),(18256,3376,'2889293','834','00','005010X220A1','2889293','','2014-02-07','22:44:56',0,'2014-02-08 19:00:07',NULL,NULL),(20591,3870,'3601696','834','00','005010X220A1','3601696','','2014-02-21','10:35:18',0,'2014-02-21 22:00:08',NULL,NULL),(21331,4022,'3479189','834','00','005010X220A1','3479189','','2014-02-26','18:21:19',0,'2014-02-28 06:30:03',NULL,NULL),(23563,4436,'3633589','834','00','005010X220A1','3633589','','2014-03-10','10:21:12',0,'2014-03-10 21:00:50',NULL,NULL),(23643,4441,'3180891','834','00','005010X220A1','3180891','','2014-03-10','14:43:27',0,'2014-03-10 21:01:46',NULL,NULL),(11404,1465,'1432572','834','00','005010X220A1','1432572','','2013-12-26','17:31:10',0,'2013-12-27 02:06:41',NULL,NULL),(692,110,'562385','834','00','005010X220A1','562385','','2013-12-16','12:02:32',0,'2013-12-25 18:06:30',NULL,NULL),(6309,1174,'1065888','834','00','005010X220A1','1065888','','2013-12-20','16:28:07',0,'2013-12-26 03:07:40',NULL,NULL),(4835,883,'621537','834','00','005010X220A1','621537','','2013-11-21','15:48:57',0,'2013-12-26 00:15:08',NULL,NULL),(4718,840,'62719','834','00','005010X220A1','62719','','2013-12-23','22:08:40',0,'2013-12-25 23:51:16',NULL,NULL),(3916,712,'505028','834','00','005010X220A1','505028','','2013-12-07','12:43:15',0,'2013-12-25 22:45:31',NULL,NULL),(13177,2021,'0001','999','BE','005010X231A1','501228','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:48',NULL,NULL),(14241,2372,'2387490','834','00','005010X220A1','2387490','','2014-01-10','16:01:30',0,'2014-01-13 02:24:11',NULL,NULL),(16056,2772,'1873104','834','00','005010X220A1','1873104','','2014-01-22','17:56:25',0,'2014-01-23 03:02:38',NULL,NULL),(17918,3296,'1559457','834','00','005010X220A1','1559457','','2014-02-05','10:00:28',0,'2014-02-05 21:30:39',NULL,NULL),(18525,3451,'2213484','834','00','005010X220A1','2213484','','2014-02-10','11:47:42',0,'2014-02-10 21:30:11',NULL,NULL),(19302,3583,'2864101','834','00','005010X220A1','2864101','','2014-02-12','19:23:57',0,'2014-02-13 22:01:15',NULL,NULL),(22745,4276,'2954390','834','00','005010X220A1','2954390','','2014-03-06','12:21:43',0,'2014-03-06 21:00:25',NULL,NULL),(11815,1539,'22593','834','00','005010X220A1','22593','','2013-12-28','20:22:22',1,'2013-12-29 11:13:32',NULL,NULL),(17396,3198,'1953450','834','00','005010X220A1','1953450','','2014-02-01','11:52:37',0,'2014-02-01 19:00:06',NULL,NULL),(2127,360,'1113900','834','00','005010X220A1','1113900','','2013-12-02','14:56:07',0,'2013-12-25 19:45:43',NULL,NULL),(2593,479,'1050379','834','00','005010X220A1','1050379','','2013-10-31','20:04:32',0,'2013-12-25 20:45:45',NULL,NULL),(16585,3040,'2271993','834','00','005010X220A1','2271993','','2014-01-25','11:57:05',0,'2014-01-25 19:00:14',NULL,NULL),(3081,545,'243855','834','00','005010X220A1','243855','','2013-12-13','12:53:44',0,'2013-12-25 21:35:37',NULL,NULL),(7434,1295,'248180','834','00','005010X220A1','248180','','2013-12-21','14:43:19',0,'2013-12-26 04:31:57',NULL,NULL),(3849,685,'419721','834','00','005010X220A1','419721','','2013-11-08','09:21:15',0,'2013-12-25 22:30:34',NULL,NULL),(15438,2629,'2026717','834','00','005010X220A1','2026717','','2014-01-15','20:10:54',0,'2014-01-17 03:36:04',NULL,NULL),(4078,733,'1003391','834','00','005010X220A1','1003391','','2013-12-19','07:45:12',0,'2013-12-25 23:02:37',NULL,NULL),(13851,2311,'2533570','834','00','005010X220A1','2533570','','2014-01-09','12:12:56',0,'2014-01-13 02:19:13',NULL,NULL),(13682,2272,'2245804','834','00','005010X220A1','2245804','','2014-01-07','11:54:04',0,'2014-01-08 18:24:22',NULL,NULL),(18555,3452,'2413613','834','00','005010X220A1','2413613','','2014-02-10','17:18:07',0,'2014-02-10 21:30:32',NULL,NULL),(19620,3639,'2676205','834','00','005010X220A1','2676205','','2014-02-13','21:52:14',0,'2014-02-14 21:31:52',NULL,NULL),(20780,3907,'2697736','834','00','005010X220A1','2697736','','2014-02-25','14:48:09',0,'2014-02-25 21:30:41',NULL,NULL),(21231,3999,'2575778','834','00','005010X220A1','2575778','','2014-02-26','10:27:38',0,'2014-02-26 21:01:36',NULL,NULL),(15745,2712,'2000673','834','00','005010X220A1','2000673','','2014-01-20','14:19:18',0,'2014-01-21 08:46:15',NULL,NULL),(10688,1403,'783109','834','00','005010X220A1','783109','','2013-12-23','06:44:30',0,'2013-12-26 13:00:05',NULL,NULL),(7613,1303,'1137404','834','00','005010X220A1','1137404','','2013-12-21','17:33:31',0,'2013-12-26 04:37:41',NULL,NULL),(17900,3295,'1923726','834','00','005010X220A1','1923726','','2014-02-05','12:37:28',0,'2014-02-05 21:30:32',NULL,NULL),(22867,4280,'3739230','834','00','005010X220A1','3739230','','2014-03-06','14:16:42',0,'2014-03-06 21:01:51',NULL,NULL),(11142,1433,'969790','834','00','005010X220A1','969790','','2013-12-23','00:19:04',0,'2013-12-26 13:15:40',NULL,NULL),(16958,3116,'1537247','834','00','005010X220A1','1537247','','2014-01-28','22:41:37',0,'2014-01-29 21:00:28',NULL,NULL),(7212,1241,'945654','834','00','005010X220A1','945654','','2013-12-18','10:17:29',0,'2013-12-26 04:06:59',NULL,NULL),(5366,1009,'696989','834','00','005010X220A1','696989','','2013-11-25','15:12:52',0,'2013-12-26 01:16:25',NULL,NULL),(12852,1706,'1379554','834','00','005010X220A1','1379554','','2014-01-02','19:50:17',0,'2014-01-04 02:03:08',NULL,NULL),(4232,738,'572968','834','00','005010X220A1','572968','','2013-12-19','14:38:22',0,'2013-12-25 23:07:12',NULL,NULL),(23090,4339,'3567120','834','00','005010X220A1','3567120','','2014-03-07','15:21:03',0,'2014-03-07 21:30:28',NULL,NULL),(151,10,'544919','834','00','005010X220A1','544919','','2013-12-05','13:04:22',0,'2013-12-25 17:19:41',NULL,NULL),(1115,238,'1233164','834','00','005010X220A1','1233164','','2013-12-24','08:47:02',0,'2013-12-25 18:45:07',NULL,NULL),(4529,822,'608279','834','00','005010X220A1','608279','','2013-11-26','17:37:10',0,'2013-12-25 23:33:04',NULL,NULL),(1846,324,'904777','834','00','005010X220A1','904777','','2013-12-08','18:10:00',0,'2013-12-25 19:30:02',NULL,NULL),(17716,3261,'1728563','834','00','005010X220A1','1728563','','2014-02-04','12:22:29',0,'2014-02-04 21:00:38',NULL,NULL),(20469,3842,'2348920','834','00','005010X220A1','2348920','','2014-02-20','13:59:01',0,'2014-02-20 22:00:38',NULL,NULL),(124,7,'195964','834','00','005010X220A1','195964','','2013-12-05','17:47:49',0,'2013-12-25 17:18:48',NULL,NULL),(14485,2506,'0001','999','BE','005010X231A1','1137846','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:56',NULL,NULL),(1410,247,'1044873','834','00','005010X220A1','1044873','','2013-12-24','16:55:33',0,'2013-12-25 18:54:21',NULL,NULL),(13906,2313,'2456467','834','00','005010X220A1','2456467','','2014-01-08','19:25:46',0,'2014-01-13 02:19:49',NULL,NULL),(13404,2222,'2020091','834','00','005010X220A1','2020091','','2014-01-06','15:28:14',0,'2014-01-07 04:01:02',NULL,NULL),(4747,858,'699557','834','00','005010X220A1','699557','','2013-12-01','16:39:58',0,'2013-12-26 00:00:11',NULL,NULL),(12278,1623,'2082375','834','00','005010X220A1','2082375','','2014-01-01','14:50:51',1,'2014-01-02 04:24:27',NULL,NULL),(5877,1108,'91726','834','00','005010X220A1','91726','','2013-10-28','14:59:37',0,'2013-12-26 02:17:11',NULL,NULL),(18877,3495,'1759877','834','00','005010X220A1','1759877','','2014-02-10','21:20:10',0,'2014-02-11 21:02:15',NULL,NULL),(19022,3539,'3128897','834','00','005010X220A1','3128897','','2014-02-12','10:24:27',0,'2014-02-12 21:30:41',NULL,NULL),(10570,1402,'927728','834','00','005010X220A1','927728','','2013-12-23','09:42:13',0,'2013-12-26 12:56:13',NULL,NULL),(4489,803,'786398','834','00','005010X220A1','786398','','2013-11-26','16:56:50',0,'2013-12-25 23:31:42',NULL,NULL),(10899,1409,'26514','834','00','005010X220A1','26514','','2013-12-23','09:23:15',0,'2013-12-26 13:07:36',NULL,NULL),(12530,1646,'1311013','834','00','005010X220A1','1311013','','2013-12-31','06:29:31',1,'2014-01-02 04:34:26',NULL,NULL),(14271,2375,'1391280','834','00','005010X220A1','1391280','','2014-01-10','14:24:53',0,'2014-01-13 03:00:10',NULL,NULL),(14325,2399,'1400046','834','00','005010X220A1','1400046','','2014-01-12','16:27:07',0,'2014-01-13 03:01:07',NULL,NULL),(14550,2519,'1906318','834','00','005010X220A1','1906318','','2014-01-12','19:56:45',0,'2014-01-14 01:32:34',NULL,NULL),(16948,3115,'1840216','834','00','005010X220A1','1840216','','2014-01-29','16:12:45',0,'2014-01-29 21:00:22',NULL,NULL),(19150,3552,'2112530','834','00','005010X220A1','2112530','','2014-02-12','13:04:03',0,'2014-02-12 21:32:09',NULL,NULL),(19318,3583,'2521665','834','00','005010X220A1','2521665','','2014-02-13','10:27:37',0,'2014-02-13 22:01:28',NULL,NULL),(21174,3998,'2620852','834','00','005010X220A1','2620852','','2014-02-26','10:43:05',0,'2014-02-26 21:00:59',NULL,NULL),(11180,1449,'354538','834','00','005010X220A1','354538','','2013-12-23','14:59:28',0,'2013-12-26 13:16:58',NULL,NULL),(7327,1272,'704876','834','00','005010X220A1','704876','','2013-12-18','14:50:06',0,'2013-12-26 04:10:32',NULL,NULL),(5799,1077,'1193084','834','00','005010X220A1','1193084','','2013-12-14','16:31:28',0,'2013-12-26 02:03:29',NULL,NULL),(16638,3060,'2628941','834','00','005010X220A1','2628941','','2014-01-26','18:14:22',0,'2014-01-27 21:00:03',NULL,NULL),(16017,2767,'1420336','834','00','005010X220A1','1420336','','2014-01-22','17:34:57',0,'2014-01-23 03:02:20',NULL,NULL),(2848,512,'944458','834','00','005010X220A1','944458','','2013-12-21','22:24:43',0,'2013-12-25 21:21:57',NULL,NULL),(11764,1526,'2386125','834','00','005010X220A1','2386125','','2013-12-28','14:39:18',1,'2013-12-29 11:09:51',NULL,NULL),(13687,2273,'2018945','834','00','005010X220A1','2018945','','2014-01-07','12:17:36',0,'2014-01-08 18:24:24',NULL,NULL),(13831,2301,'2305218','834','00','005010X220A1','2305218','','2014-01-11','10:27:32',0,'2014-01-13 02:18:35',NULL,NULL),(14654,2530,'2122949','834','00','005010X220A1','2122949','','2014-01-13','16:51:29',0,'2014-01-14 01:33:40',NULL,NULL),(15370,2624,'2387663','834','00','005010X220A1','2387663','','2014-01-15','22:45:16',0,'2014-01-17 03:35:32',NULL,NULL),(19032,3540,'2579027','834','00','005010X220A1','2579027','','2014-02-11','23:08:03',0,'2014-02-12 21:30:48',NULL,NULL),(21564,4053,'3385610','834','00','005010X220A1','3385610','','2014-02-26','14:47:13',0,'2014-02-28 07:00:08',NULL,NULL),(22106,4177,'3153910','834','00','005010X220A1','3153910','','2014-03-03','10:16:09',0,'2014-03-03 21:30:23',NULL,NULL),(22228,4192,'3038217','834','00','005010X220A1','3038217','','2014-03-03','13:26:17',0,'2014-03-03 21:31:53',NULL,NULL),(23356,4389,'2885395','834','00','005010X220A1','2885395','','2014-03-08','15:31:34',0,'2014-03-08 21:31:03',NULL,NULL),(16560,3033,'1978655','834','00','005010X220A1','1978655','','2014-01-24','14:54:26',0,'2014-01-24 21:01:19',NULL,NULL),(11173,1445,'1809155','834','00','005010X220A1','1809155','','2013-12-23','18:28:45',0,'2013-12-26 13:16:44',NULL,NULL),(14897,2558,'2031786','834','00','005010X220A1','2031786','','2014-01-14','11:45:38',0,'2014-01-15 02:07:28',NULL,NULL),(2993,542,'234233','834','00','005010X220A1','234233','','2013-12-13','13:29:23',0,'2013-12-25 21:32:54',NULL,NULL),(14765,2551,'2249639','834','00','005010X220A1','2249639','','2014-01-14','10:17:40',0,'2014-01-15 02:06:30',NULL,NULL),(13032,1876,'0001','999','BE','005010X231A1','534185','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:31',NULL,NULL),(12505,1642,'2539924','834','00','005010X220A1','2539924','','2013-12-31','14:39:12',1,'2014-01-02 04:33:33',NULL,NULL),(4695,833,'1624230','834','00','005010X220A1','1624230','','2013-12-24','01:43:22',0,'2013-12-25 23:50:29',NULL,NULL),(17072,3129,'2034813','834','00','005010X220A1','2034813','','2014-01-29','10:22:31',0,'2014-01-29 21:01:41',NULL,NULL),(17318,3174,'1969808','834','00','005010X220A1','1969808','','2014-01-31','10:14:48',0,'2014-01-31 21:00:53',NULL,NULL),(21873,4122,'3843267','834','00','005010X220A1','3843267','','2014-02-28','23:57:43',0,'2014-03-01 21:00:12',NULL,NULL),(263,49,'920486','834','00','005010X220A1','920486','','2013-11-12','21:28:07',0,'2013-12-25 17:31:19',NULL,NULL),(813,160,'759793','834','00','005010X220A1','759793','','2013-11-11','15:24:59',0,'2013-12-25 18:10:41',NULL,NULL),(11367,1460,'2079832','834','00','005010X220A1','2079832','','2013-12-26','06:17:20',0,'2013-12-27 02:05:33',NULL,NULL),(1476,252,'1145169','834','00','005010X220A1','1145169','','2013-12-24','17:16:40',0,'2013-12-25 18:56:40',NULL,NULL),(2105,360,'1201334','834','00','005010X220A1','1201334','','2013-12-01','18:20:54',0,'2013-12-25 19:45:02',NULL,NULL),(3622,621,'16833','834','00','005010X220A1','16833','','2013-12-12','15:28:11',0,'2013-12-25 22:05:01',NULL,NULL),(3001,542,'147862','834','00','005010X220A1','147862','','2013-12-13','16:06:17',0,'2013-12-25 21:33:09',NULL,NULL),(20169,3777,'3221466','834','00','005010X220A1','3221466','','2014-02-19','13:13:31',0,'2014-02-20 04:09:21',NULL,NULL),(23236,4363,'2930523','834','00','005010X220A1','2930523','','2014-03-07','11:21:05',0,'2014-03-07 21:32:12',NULL,NULL),(15238,2598,'1906456','834','00','005010X220A1','1906456','','2014-01-15','14:41:19',0,'2014-01-16 08:46:49',NULL,NULL),(2076,341,'453696','834','00','005010X220A1','453696','','2013-12-09','16:08:02',0,'2013-12-25 19:37:17',NULL,NULL),(1487,254,'233389','834','00','005010X220A1','233389','','2013-12-24','11:18:15',0,'2013-12-25 18:56:58',NULL,NULL),(21207,3998,'2758995','834','00','005010X220A1','2758995','','2014-02-26','15:48:43',0,'2014-02-26 21:01:21',NULL,NULL),(321,71,'261773','834','00','005010X220A1','261773','','2013-12-03','18:55:09',0,'2013-12-25 17:45:51',NULL,NULL),(15186,2591,'1578161','834','00','005010X220A1','1578161','','2014-01-15','17:43:21',0,'2014-01-16 08:46:16',NULL,NULL),(12087,1586,'1775750','834','00','005010X220A1','1775750','','2013-12-30','16:42:44',0,'2014-01-01 12:05:17',NULL,NULL),(11754,1523,'1439738','834','00','005010X220A1','1439738','','2013-12-28','14:08:09',1,'2013-12-29 11:09:34',NULL,NULL),(4059,731,'979382','834','00','005010X220A1','979382','','2013-12-18','18:39:20',0,'2013-12-25 23:01:57',NULL,NULL),(7082,1236,'1300394','834','00','005010X220A1','1300394','','2013-12-18','10:24:28',0,'2013-12-26 04:03:04',NULL,NULL),(2773,506,'858295','834','00','005010X220A1','858295','','2013-12-21','21:50:29',0,'2013-12-25 21:19:27',NULL,NULL),(3114,547,'153420','834','00','005010X220A1','153420','','2013-12-13','11:28:43',0,'2013-12-25 21:36:36',NULL,NULL),(19570,3627,'2461145','834','00','005010X220A1','2461145','','2014-02-14','11:13:29',0,'2014-02-14 21:31:16',NULL,NULL),(21467,4028,'3228777','834','00','005010X220A1','3228777','','2014-02-27','12:29:09',0,'2014-02-28 06:31:06',NULL,NULL),(22990,4320,'3103309','834','00','005010X220A1','3103309','','2014-03-06','17:56:05',0,'2014-03-06 21:30:25',NULL,NULL),(16906,3105,'1463913','834','00','005010X220A1','1463913','','2014-01-28','13:00:33',0,'2014-01-28 21:01:17',NULL,NULL),(7350,1282,'570965','834','00','005010X220A1','570965','','2013-11-30','07:57:24',0,'2013-12-26 04:15:28',NULL,NULL),(5371,1009,'1010077','834','00','005010X220A1','1010077','','2013-11-25','14:36:56',0,'2013-12-26 01:16:33',NULL,NULL),(16538,3020,'1489288','834','00','005010X220A1','1489288','','2014-01-24','16:47:17',0,'2014-01-24 21:01:05',NULL,NULL),(3821,669,'386972','834','00','005010X220A1','386972','','2013-12-08','13:56:43',0,'2013-12-25 22:17:05',NULL,NULL),(14521,2518,'1404894','834','00','005010X220A1','1404894','','2014-01-12','19:20:20',0,'2014-01-14 01:32:16',NULL,NULL),(17823,3274,'1655686','834','00','005010X220A1','1655686','','2014-02-04','18:03:44',0,'2014-02-04 21:01:48',NULL,NULL),(20132,3772,'2871855','834','00','005010X220A1','2871855','','2014-02-19','15:41:40',0,'2014-02-20 03:58:37',NULL,NULL),(21457,4028,'3026860','834','00','005010X220A1','3026860','','2014-02-27','01:04:16',0,'2014-02-28 06:31:02',NULL,NULL),(16673,3061,'2432942','834','00','005010X220A1','2432942','','2014-01-27','14:32:08',0,'2014-01-27 21:00:26',NULL,NULL),(1170,239,'1472989','834','00','005010X220A1','1472989','','2013-12-24','13:10:32',0,'2013-12-25 18:46:48',NULL,NULL),(12461,1639,'2299026','834','00','005010X220A1','2299026','','2013-12-31','13:04:39',1,'2014-01-02 04:31:52',NULL,NULL),(1829,314,'912907','834','00','005010X220A1','912907','','2013-12-10','13:44:42',0,'2013-12-25 19:20:30',NULL,NULL),(11208,1454,'1327519','834','00','005010X220A1','1327519','','2013-12-26','08:28:59',0,'2013-12-27 02:00:41',NULL,NULL),(7677,1321,'323434','834','00','005010X220A1','323434','','2013-12-21','11:49:50',0,'2013-12-26 04:39:44',NULL,NULL),(3884,701,'695373','834','00','005010X220A1','695373','','2013-10-04','14:04:17',0,'2013-12-25 22:31:39',NULL,NULL),(17912,3296,'2686925','834','00','005010X220A1','2686925','','2014-02-04','21:09:52',0,'2014-02-05 21:30:37',NULL,NULL),(129,8,'615156','834','00','005010X220A1','615156','','2013-12-05','16:27:27',0,'2013-12-25 17:19:00',NULL,NULL),(11531,1490,'1262204','834','00','005010X220A1','1262204','','2013-12-27','14:08:18',0,'2013-12-28 03:32:33',NULL,NULL),(13118,1962,'0001','999','BE','005010X231A1','319022','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:28',NULL,NULL),(2542,457,'1169440','834','00','005010X220A1','1169440','','2013-11-18','08:42:06',0,'2013-12-25 20:31:16',NULL,NULL),(5053,936,'226928','834','00','005010X220A1','226928','','2013-12-11','08:59:30',0,'2013-12-26 00:47:42',NULL,NULL),(18760,3485,'3088692','834','00','005010X220A1','3088692','','2014-02-11','16:43:38',0,'2014-02-11 21:00:46',NULL,NULL),(22492,4244,'3742103','834','00','005010X220A1','3742103','','2014-03-05','14:54:10',0,'2014-03-05 21:00:31',NULL,NULL),(1307,245,'1715274','834','00','005010X220A1','1715274','','2013-12-24','08:04:59',0,'2013-12-25 18:51:02',NULL,NULL),(2474,429,'1130797','834','00','005010X220A1','1130797','','2013-12-06','14:41:01',0,'2013-12-25 20:19:39',NULL,NULL),(17335,3177,'1529814','834','00','005010X220A1','1529814','','2014-01-31','17:21:08',0,'2014-01-31 21:01:05',NULL,NULL),(3585,617,'183627','834','00','005010X220A1','183627','','2013-12-12','14:10:32',0,'2013-12-25 22:03:53',NULL,NULL),(11114,1426,'1465534','834','00','005010X220A1','1465534','','2013-12-23','12:44:02',0,'2013-12-26 13:14:33',NULL,NULL),(14129,2351,'2234452','834','00','005010X220A1','2234452','','2014-01-08','14:52:26',0,'2014-01-13 02:22:29',NULL,NULL),(12484,1640,'2384792','834','00','005010X220A1','2384792','','2013-12-31','15:41:27',1,'2014-01-02 04:32:41',NULL,NULL),(18817,3489,'3217883','834','00','005010X220A1','3217883','','2014-02-11','16:32:18',0,'2014-02-11 21:01:28',NULL,NULL),(19646,3647,'3477411','834','00','005010X220A1','3477411','','2014-02-14','11:23:47',0,'2014-02-14 21:32:11',NULL,NULL),(19707,3671,'2615573','834','00','005010X220A1','2615573','','2014-02-15','15:43:15',0,'2014-02-15 22:00:13',NULL,NULL),(23760,4477,'3322658','834','00','005010X220A1','3322658','','2014-03-10','15:51:02',0,'2014-03-10 21:30:10',NULL,NULL),(10446,1400,'550598','834','00','005010X220A1','550598','','2013-12-23','13:00:46',0,'2013-12-26 12:52:10',NULL,NULL),(15155,2588,'1601707','834','00','005010X220A1','1601707','','2014-01-15','14:45:50',0,'2014-01-16 08:45:57',NULL,NULL),(4504,809,'890353','834','00','005010X220A1','890353','','2013-11-25','21:31:40',0,'2013-12-25 23:32:12',NULL,NULL),(730,124,'561149','834','00','005010X220A1','561149','','2013-12-16','17:45:30',0,'2013-12-25 18:07:44',NULL,NULL),(4576,826,'1495680','834','00','005010X220A1','1495680','','2013-12-23','21:56:24',0,'2013-12-25 23:46:30',NULL,NULL),(1659,289,'945342','834','00','005010X220A1','945342','','2013-12-10','12:44:07',0,'2013-12-25 19:15:12',NULL,NULL),(19111,3545,'2917461','834','00','005010X220A1','2917461','','2014-02-11','20:27:00',0,'2014-02-12 21:31:45',NULL,NULL),(20045,3751,'2279274','834','00','005010X220A1','2279274','','2014-02-18','12:28:50',0,'2014-02-18 22:01:04',NULL,NULL),(20179,3778,'3300041','834','00','005010X220A1','3300041','','2014-02-19','16:01:26',0,'2014-02-20 04:12:42',NULL,NULL),(20288,3795,'3455961','834','00','005010X220A1','3455961','','2014-02-19','10:36:28',0,'2014-02-20 04:40:14',NULL,NULL),(21366,4024,'2755171','834','00','005010X220A1','2755171','','2014-02-27','00:18:51',0,'2014-02-28 06:30:19',NULL,NULL),(23076,4339,'3752665','834','00','005010X220A1','3752665','','2014-03-07','11:06:17',0,'2014-03-07 21:30:18',NULL,NULL),(23169,4344,'3826302','834','00','005010X220A1','3826302','','2014-03-07','15:36:28',0,'2014-03-07 21:31:24',NULL,NULL),(16010,2767,'2153139','834','00','005010X220A1','2153139','','2014-01-22','09:53:33',0,'2014-01-23 03:02:18',NULL,NULL),(13525,2238,'1822284','834','00','005010X220A1','1822284','','2014-01-06','10:06:14',0,'2014-01-07 04:05:35',NULL,NULL),(11267,1455,'1771658','834','00','005010X220A1','1771658','','2013-12-26','11:43:36',0,'2013-12-27 02:02:29',NULL,NULL),(1927,326,'353841','834','00','005010X220A1','353841','','2013-12-09','07:31:54',0,'2013-12-25 19:32:33',NULL,NULL),(12784,1703,'2306388','834','00','005010X220A1','2306388','','2014-01-02','21:20:08',0,'2014-01-04 02:00:41',NULL,NULL),(6274,1172,'765253','834','00','005010X220A1','765253','','2013-12-20','10:00:36',0,'2013-12-26 03:06:40',NULL,NULL),(7700,1331,'124652','834','00','005010X220A1','124652','','2013-11-15','18:22:59',0,'2013-12-26 04:45:28',NULL,NULL),(3331,586,'1088272','834','00','005010X220A1','1088272','','2013-12-17','13:45:50',0,'2013-12-25 21:49:32',NULL,NULL),(18450,3423,'1599081','834','00','005010X220A1','1599081','','2014-02-10','04:10:02',0,'2014-02-10 11:00:33',NULL,NULL),(20315,3795,'3179072','834','00','005010X220A1','3179072','','2014-02-19','15:26:36',0,'2014-02-20 04:46:47',NULL,NULL),(20677,3881,'3405998','834','00','005010X220A1','3405998','','2014-02-21','16:30:40',0,'2014-02-21 22:01:11',NULL,NULL),(22787,4277,'3200904','834','00','005010X220A1','3200904','','2014-03-06','15:52:53',0,'2014-03-06 21:00:56',NULL,NULL),(12480,1640,'1857408','834','00','005010X220A1','1857408','','2013-12-31','12:07:11',1,'2014-01-02 04:32:30',NULL,NULL),(939,181,'514962','834','00','005010X220A1','514962','','2013-12-03','10:18:19',0,'2013-12-25 18:18:19',NULL,NULL),(5258,968,'606016','834','00','005010X220A1','606016','','2013-12-11','16:54:53',0,'2013-12-26 00:54:18',NULL,NULL),(4935,918,'552185','834','00','005010X220A1','552185','','2013-11-19','12:07:11',0,'2013-12-26 00:31:18',NULL,NULL),(21248,3999,'3564291','834','00','005010X220A1','3564291','','2014-02-26','13:35:00',0,'2014-02-26 21:01:47',NULL,NULL),(22637,4253,'3569572','834','00','005010X220A1','3569572','','2014-03-04','21:24:59',0,'2014-03-05 21:31:44',NULL,NULL),(11699,1517,'1444721','834','00','005010X220A1','1444721','','2013-12-27','21:04:07',1,'2013-12-29 11:07:53',NULL,NULL),(17419,3200,'2775074','834','00','005010X220A1','2775074','','2014-02-01','13:32:10',0,'2014-02-01 19:00:20',NULL,NULL),(14866,2555,'1561637','834','00','005010X220A1','1561637','','2014-01-13','20:39:54',0,'2014-01-15 02:07:14',NULL,NULL),(1713,292,'1272672','834','00','005010X220A1','1272672','','2013-12-10','17:22:57',0,'2013-12-25 19:16:54',NULL,NULL),(2118,360,'427243','834','00','005010X220A1','427243','','2013-12-02','09:19:16',0,'2013-12-25 19:45:29',NULL,NULL),(4514,812,'1227970','834','00','005010X220A1','1227970','','2013-11-26','11:40:26',0,'2013-12-25 23:32:32',NULL,NULL),(2996,542,'862791','834','00','005010X220A1','862791','','2013-12-13','14:06:18',0,'2013-12-25 21:33:00',NULL,NULL),(3359,587,'1285870','834','00','005010X220A1','1285870','','2013-12-17','10:42:40',0,'2013-12-25 21:50:24',NULL,NULL),(19395,3593,'3210130','834','00','005010X220A1','3210130','','2014-02-13','11:31:00',0,'2014-02-13 22:02:26',NULL,NULL),(17769,3264,'2404717','834','00','005010X220A1','2404717','','2014-02-04','11:29:25',0,'2014-02-04 21:01:11',NULL,NULL),(15467,2633,'1749228','834','00','005010X220A1','1749228','','2014-01-15','22:07:46',0,'2014-01-17 03:36:17',NULL,NULL),(14407,2428,'0001','999','BE','005010X231A1','1173637','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:20',NULL,NULL),(6020,1138,'1257239','834','00','005010X220A1','1257239','','2013-11-17','06:42:00',0,'2013-12-26 02:45:33',NULL,NULL),(1711,292,'1314259','834','00','005010X220A1','1314259','','2013-12-10','16:42:57',0,'2013-12-25 19:16:51',NULL,NULL),(13977,2323,'1854016','834','00','005010X220A1','1854016','','2014-01-09','11:35:35',0,'2014-01-13 02:20:40',NULL,NULL),(5076,936,'689316','834','00','005010X220A1','689316','','2013-12-11','16:17:33',0,'2013-12-26 00:48:26',NULL,NULL),(3289,584,'857990','834','00','005010X220A1','857990','','2013-12-16','20:51:06',0,'2013-12-25 21:48:05',NULL,NULL),(20427,3840,'3240635','834','00','005010X220A1','3240635','','2014-02-19','18:01:07',0,'2014-02-20 22:00:03',NULL,NULL),(20830,3911,'3540617','834','00','005010X220A1','3540617','','2014-02-24','22:04:33',0,'2014-02-25 21:31:15',NULL,NULL),(21621,4065,'2719006','834','00','005010X220A1','2719006','','2014-02-27','14:03:45',0,'2014-02-28 07:30:19',NULL,NULL),(22078,4174,'3045765','834','00','005010X220A1','3045765','','2014-03-03','09:19:23',0,'2014-03-03 21:30:01',NULL,NULL),(17121,3143,'2119681','834','00','005010X220A1','2119681','','2014-01-29','18:27:31',0,'2014-01-30 21:00:19',NULL,NULL),(14549,2519,'2044461','834','00','005010X220A1','2044461','','2014-01-12','19:51:46',0,'2014-01-14 01:32:34',NULL,NULL),(7346,1280,'432390','834','00','005010X220A1','432390','','2013-11-30','13:05:09',0,'2013-12-26 04:15:20',NULL,NULL),(1745,293,'258154','834','00','005010X220A1','258154','','2013-12-10','14:44:54',0,'2013-12-25 19:17:49',NULL,NULL),(12810,1703,'1955377','834','00','005010X220A1','1955377','','2014-01-03','16:26:07',0,'2014-01-04 02:01:36',NULL,NULL),(5368,1009,'434954','834','00','005010X220A1','434954','','2013-11-24','23:34:16',0,'2013-12-26 01:16:29',NULL,NULL),(3835,679,'336323','834','00','005010X220A1','336323','','2013-11-08','10:57:29',0,'2013-12-25 22:30:06',NULL,NULL),(3826,674,'99960','834','00','005010X220A1','99960','','2013-12-08','15:04:25',0,'2013-12-25 22:17:17',NULL,NULL),(18614,3456,'2949940','834','00','005010X220A1','2949940','','2014-02-10','15:54:32',0,'2014-02-10 21:31:13',NULL,NULL),(18885,3497,'2156457','834','00','005010X220A1','2156457','','2014-02-10','22:09:53',0,'2014-02-11 21:02:22',NULL,NULL),(20246,3793,'2851497','834','00','005010X220A1','2851497','','2014-02-18','22:51:13',0,'2014-02-20 04:31:19',NULL,NULL),(23567,4436,'3689900','834','00','005010X220A1','3689900','','2014-03-10','11:25:30',0,'2014-03-10 21:00:53',NULL,NULL),(428,78,'169306','834','00','005010X220A1','169306','','2013-12-03','20:24:22',0,'2013-12-25 17:49:18',NULL,NULL),(16294,2980,'2237075','834','00','005010X220A1','2237075','','2014-01-23','10:24:47',0,'2014-01-23 21:00:08',NULL,NULL),(2129,360,'144703','834','00','005010X220A1','144703','','2013-12-02','17:20:21',0,'2013-12-25 19:45:48',NULL,NULL),(7338,1279,'53008','834','00','005010X220A1','53008','','2013-11-30','12:18:19',0,'2013-12-26 04:15:04',NULL,NULL),(15350,2623,'2354493','834','00','005010X220A1','2354493','','2014-01-15','23:16:15',0,'2014-01-17 03:35:23',NULL,NULL),(5461,1040,'1721813','834','00','005010X220A1','1721813','','2013-12-24','19:18:12',0,'2013-12-26 01:45:11',NULL,NULL),(7014,1235,'730287','834','00','005010X220A1','730287','','2013-12-18','09:19:27',0,'2013-12-26 04:00:55',NULL,NULL),(5941,1113,'779001','834','00','005010X220A1','779001','','2013-12-14','23:05:39',0,'2013-12-26 02:32:04',NULL,NULL),(18095,3327,'2841590','834','00','005010X220A1','2841590','','2014-02-06','11:42:27',0,'2014-02-06 21:01:12',NULL,NULL),(20055,3753,'3436158','834','00','005010X220A1','3436158','','2014-02-18','11:09:04',0,'2014-02-18 22:01:12',NULL,NULL),(23139,4342,'3010541','834','00','005010X220A1','3010541','','2014-03-07','14:04:57',0,'2014-03-07 21:31:02',NULL,NULL),(16486,3010,'1519099','834','00','005010X220A1','1519099','','2014-01-24','13:47:01',0,'2014-01-24 21:00:32',NULL,NULL),(15870,2739,'1431791','834','00','005010X220A1','1431791','','2014-01-20','18:54:21',1,'2014-01-22 03:22:22',NULL,NULL),(2901,538,'1105793','834','00','005010X220A1','1105793','','2013-12-22','18:02:22',0,'2013-12-25 21:23:48',NULL,NULL),(19335,3583,'2233914','834','00','005010X220A1','2233914','','2014-02-13','14:09:10',0,'2014-02-13 22:01:40',NULL,NULL),(20728,3900,'3270129','834','00','005010X220A1','3270129','','2014-02-25','10:54:50',0,'2014-02-25 21:00:31',NULL,NULL),(21900,4127,'2676611','834','00','005010X220A1','2676611','','2014-02-28','19:52:39',0,'2014-03-01 21:00:31',NULL,NULL),(23365,4392,'3757743','834','00','005010X220A1','3757743','','2014-03-07','19:42:50',0,'2014-03-08 21:31:09',NULL,NULL),(23713,4457,'3301635','834','00','005010X220A1','3301635','','2014-03-10','10:51:37',0,'2014-03-10 21:02:37',NULL,NULL),(12421,1638,'2254147','834','00','005010X220A1','2254147','','2013-12-31','06:04:49',1,'2014-01-02 04:30:25',NULL,NULL),(14942,2561,'2522468','834','00','005010X220A1','2522468','','2014-01-14','16:36:19',0,'2014-01-15 02:07:48',NULL,NULL),(12848,1705,'2109326','834','00','005010X220A1','2109326','','2014-01-03','14:04:06',0,'2014-01-04 02:02:58',NULL,NULL),(21260,4000,'2641468','834','00','005010X220A1','2641468','','2014-02-26','12:02:22',0,'2014-02-26 21:01:55',NULL,NULL),(22460,4238,'2752606','834','00','005010X220A1','2752606','','2014-03-04','18:29:43',0,'2014-03-05 21:00:10',NULL,NULL),(12494,1641,'1813405','834','00','005010X220A1','1813405','','2013-12-31','14:20:18',1,'2014-01-02 04:33:08',NULL,NULL),(1023,192,'765673','834','00','005010X220A1','765673','','2013-12-03','09:09:13',0,'2013-12-25 18:21:00',NULL,NULL),(12073,1586,'1753873','834','00','005010X220A1','1753873','','2013-12-30','10:08:50',0,'2014-01-01 12:04:47',NULL,NULL),(17174,3146,'1563505','834','00','005010X220A1','1563505','','2014-01-30','13:35:56',0,'2014-01-30 21:00:53',NULL,NULL),(1664,290,'572566','834','00','005010X220A1','572566','','2013-12-09','18:23:35',0,'2013-12-25 19:15:23',NULL,NULL),(11508,1490,'1417258','834','00','005010X220A1','1417258','','2013-12-26','19:20:06',0,'2013-12-28 03:31:54',NULL,NULL),(17270,3170,'1506387','834','00','005010X220A1','1506387','','2014-01-31','13:44:11',0,'2014-01-31 21:00:21',NULL,NULL),(18623,3459,'2722304','834','00','005010X220A1','2722304','','2014-02-09','22:36:07',0,'2014-02-10 21:31:20',NULL,NULL),(19106,3544,'2202108','834','00','005010X220A1','2202108','','2014-02-11','19:57:09',0,'2014-02-12 21:31:41',NULL,NULL),(7740,1343,'1214777','834','00','005010X220A1','1214777','','2013-10-20','18:13:46',0,'2013-12-26 05:00:31',NULL,NULL),(15869,2738,'1563277','834','00','005010X220A1','1563277','','2014-01-21','16:27:12',1,'2014-01-22 03:22:21',NULL,NULL),(10627,1402,'1165471','834','00','005010X220A1','1165471','','2013-12-23','15:52:03',0,'2013-12-26 12:58:03',NULL,NULL),(2669,501,'522807','834','00','005010X220A1','522807','','2013-12-22','17:06:16',0,'2013-12-25 21:16:11',NULL,NULL),(17156,3144,'1465395','834','00','005010X220A1','1465395','','2014-01-30','16:12:15',0,'2014-01-30 21:00:40',NULL,NULL),(21148,3997,'2911730','834','00','005010X220A1','2911730','','2014-02-26','10:12:46',0,'2014-02-26 21:00:42',NULL,NULL),(21680,4081,'3301297','834','00','005010X220A1','3301297','','2014-02-28','14:25:53',0,'2014-02-28 21:00:21',NULL,NULL),(22552,4248,'3013201','834','00','005010X220A1','3013201','','2014-03-05','11:35:29',0,'2014-03-05 21:30:45',NULL,NULL),(7229,1241,'667497','834','00','005010X220A1','667497','','2013-12-18','15:33:21',0,'2013-12-26 04:07:30',NULL,NULL),(15603,2661,'1815151','834','00','005010X220A1','1815151','','2014-01-17','12:41:05',0,'2014-01-20 08:06:27',NULL,NULL),(4260,742,'309202','834','00','005010X220A1','309202','','2013-12-18','20:05:50',0,'2013-12-25 23:08:07',NULL,NULL),(5154,944,'580265','834','00','005010X220A1','580265','','2013-12-10','18:58:45',0,'2013-12-26 00:50:55',NULL,NULL),(12655,1672,'2539964','834','00','005010X220A1','2539964','','2014-01-02','17:15:29',0,'2014-01-03 02:03:07',NULL,NULL),(17501,3222,'2590640','834','00','005010X220A1','2590640','','2014-02-02','15:35:39',0,'2014-02-02 19:00:25',NULL,NULL),(19030,3540,'2593428','834','00','005010X220A1','2593428','','2014-02-11','20:34:27',0,'2014-02-12 21:30:47',NULL,NULL),(21159,3997,'3284074','834','00','005010X220A1','3284074','','2014-02-26','15:13:11',0,'2014-02-26 21:00:48',NULL,NULL),(337,72,'572448','834','00','005010X220A1','572448','','2013-12-04','15:06:53',0,'2013-12-25 17:46:21',NULL,NULL),(987,184,'359119','834','00','005010X220A1','359119','','2013-12-03','15:59:57',0,'2013-12-25 18:19:47',NULL,NULL),(15867,2738,'1854314','834','00','005010X220A1','1854314','','2014-01-21','18:00:12',1,'2014-01-22 03:22:19',NULL,NULL),(7071,1236,'1114409','834','00','005010X220A1','1114409','','2013-12-18','00:23:51',0,'2013-12-26 04:02:40',NULL,NULL),(6047,1155,'278457','834','00','005010X220A1','278457','','2013-10-14','01:04:32',0,'2013-12-26 02:46:28',NULL,NULL),(14704,2550,'1670375','834','00','005010X220A1','1670375','','2014-01-13','21:44:30',0,'2014-01-15 02:06:03',NULL,NULL),(14512,2516,'2084771','834','00','005010X220A1','2084771','','2014-01-12','18:31:51',0,'2014-01-14 01:32:10',NULL,NULL),(11004,1413,'1713769','834','00','005010X220A1','1713769','','2013-12-23','18:08:55',0,'2013-12-26 13:10:54',NULL,NULL),(16149,2841,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:48:00',1,'2014-01-23 04:01:11',NULL,NULL),(20601,3870,'3176630','834','00','005010X220A1','3176630','','2014-02-21','13:18:15',0,'2014-02-21 22:00:16',NULL,NULL),(21476,4028,'3770842','834','00','005010X220A1','3770842','','2014-02-27','15:35:24',0,'2014-02-28 06:31:11',NULL,NULL),(22813,4278,'3078902','834','00','005010X220A1','3078902','','2014-03-06','10:53:30',0,'2014-03-06 21:01:13',NULL,NULL),(23703,4451,'3579280','834','00','005010X220A1','3579280','','2014-03-10','15:59:32',0,'2014-03-10 21:02:29',NULL,NULL),(7199,1240,'442740','834','00','005010X220A1','442740','','2013-12-17','19:11:09',0,'2013-12-26 04:06:35',NULL,NULL),(5887,1109,'320734','834','00','005010X220A1','320734','','2013-12-15','15:33:43',0,'2013-12-26 02:30:20',NULL,NULL),(15310,2622,'1597901','834','00','005010X220A1','1597901','','2014-01-15','23:12:38',0,'2014-01-17 03:35:06',NULL,NULL),(4147,733,'684064','834','00','005010X220A1','684064','','2013-12-19','17:52:15',0,'2013-12-25 23:04:36',NULL,NULL),(3111,547,'931418','834','00','005010X220A1','931418','','2013-12-13','18:05:23',0,'2013-12-25 21:36:30',NULL,NULL),(11706,1517,'2070147','834','00','005010X220A1','2070147','','2013-12-28','15:27:47',1,'2013-12-29 11:08:03',NULL,NULL),(16328,2983,'1497557','834','00','005010X220A1','1497557','','2014-01-22','21:16:43',0,'2014-01-23 21:00:34',NULL,NULL),(19288,3582,'3397406','834','00','005010X220A1','3397406','','2014-02-13','14:26:50',0,'2014-02-13 22:01:03',NULL,NULL),(20750,3903,'3300171','834','00','005010X220A1','3300171','','2014-02-25','14:31:43',0,'2014-02-25 21:30:19',NULL,NULL),(13508,2233,'1417527','834','00','005010X220A1','1417527','','2014-01-06','14:49:32',0,'2014-01-07 04:05:00',NULL,NULL),(16395,2993,'2463489','834','00','005010X220A1','2463489','','2014-01-23','13:59:31',0,'2014-01-23 21:01:19',NULL,NULL),(19713,3672,'2483488','834','00','005010X220A1','2483488','','2014-02-15','10:33:55',0,'2014-02-15 22:00:17',NULL,NULL),(19762,3674,'2829027','834','00','005010X220A1','2829027','','2014-02-15','16:38:01',0,'2014-02-15 22:00:52',NULL,NULL),(19848,3694,'2665503','834','00','005010X220A1','2665503','','2014-02-14','20:52:18',0,'2014-02-15 22:02:04',NULL,NULL),(21295,4006,'3453735','834','00','005010X220A1','3453735','','2014-02-26','14:29:13',0,'2014-02-26 21:02:21',NULL,NULL),(21978,4144,'3231321','834','00','005010X220A1','3231321','','2014-03-02','15:06:58',0,'2014-03-03 01:00:11',NULL,NULL),(23122,4342,'3257096','834','00','005010X220A1','3257096','','2014-03-07','08:39:40',0,'2014-03-07 21:30:51',NULL,NULL),(23702,4451,'3332048','834','00','005010X220A1','3332048','','2014-03-10','15:54:58',0,'2014-03-10 21:02:28',NULL,NULL),(6305,1174,'373273','834','00','005010X220A1','373273','','2013-12-20','14:45:36',0,'2013-12-26 03:07:31',NULL,NULL),(15325,2622,'1671627','834','00','005010X220A1','1671627','','2014-01-16','14:28:29',0,'2014-01-17 03:35:12',NULL,NULL),(14457,2478,'0001','999','BE','005010X231A1','783942','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:30',NULL,NULL),(2005,330,'922216','834','00','005010X220A1','922216','','2013-12-09','14:42:28',0,'2013-12-25 19:35:01',NULL,NULL),(13027,1871,'0001','999','BE','005010X231A1','315403','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:17',NULL,NULL),(16620,3050,'1740939','834','00','005010X220A1','1740939','','2014-01-25','22:41:43',0,'2014-01-26 19:00:17',NULL,NULL),(17549,3235,'2007081','834','00','005010X220A1','2007081','','2014-02-03','18:21:38',0,'2014-02-03 21:00:26',NULL,NULL),(17343,3181,'2543073','834','00','005010X220A1','2543073','','2014-01-30','22:23:06',0,'2014-01-31 21:01:12',NULL,NULL),(12715,1678,'2416333','834','00','005010X220A1','2416333','','2014-01-02','14:53:47',0,'2014-01-03 02:05:20',NULL,NULL),(10682,1403,'481149','834','00','005010X220A1','481149','','2013-12-22','22:57:41',0,'2013-12-26 12:59:50',NULL,NULL),(11775,1531,'1308631','834','00','005010X220A1','1308631','','2013-12-27','20:06:56',1,'2013-12-29 11:10:11',NULL,NULL),(2532,455,'438041','834','00','005010X220A1','438041','','2013-11-18','11:46:47',0,'2013-12-25 20:30:58',NULL,NULL),(16874,3093,'2321896','834','00','005010X220A1','2321896','','2014-01-28','15:27:26',0,'2014-01-28 21:00:56',NULL,NULL),(19243,3580,'3277404','834','00','005010X220A1','3277404','','2014-02-13','15:07:25',0,'2014-02-13 22:00:28',NULL,NULL),(22066,4169,'3585638','834','00','005010X220A1','3585638','','2014-03-03','11:17:48',0,'2014-03-03 21:00:21',NULL,NULL),(13849,2311,'1592779','834','00','005010X220A1','1592779','','2014-01-09','10:41:54',0,'2014-01-13 02:19:12',NULL,NULL),(838,174,'111836','834','00','005010X220A1','111836','','2013-12-03','14:50:14',0,'2013-12-25 18:15:17',NULL,NULL),(1776,298,'887197','834','00','005010X220A1','887197','','2013-12-10','17:49:50',0,'2013-12-25 19:18:48',NULL,NULL),(5241,957,'414242','834','00','005010X220A1','414242','','2013-12-11','15:07:14',0,'2013-12-26 00:53:43',NULL,NULL),(6200,1168,'1183712','834','00','005010X220A1','1183712','','2013-12-19','19:02:05',0,'2013-12-26 03:04:20',NULL,NULL),(18197,3353,'2358510','834','00','005010X220A1','2358510','','2014-02-07','17:19:05',0,'2014-02-07 19:00:32',NULL,NULL),(21798,4092,'3618734','834','00','005010X220A1','3618734','','2014-02-28','12:17:35',0,'2014-02-28 21:31:20',NULL,NULL),(22881,4281,'3110659','834','00','005010X220A1','3110659','','2014-03-06','17:35:06',0,'2014-03-06 21:02:02',NULL,NULL),(23589,4437,'3194987','834','00','005010X220A1','3194987','','2014-03-10','09:41:22',0,'2014-03-10 21:01:09',NULL,NULL),(14383,2411,'1508599','834','00','005010X220A1','1508599','','2014-01-12','12:52:14',0,'2014-01-13 03:01:50',NULL,NULL),(10744,1403,'641859','834','00','005010X220A1','641859','','2013-12-23','16:11:37',0,'2013-12-26 13:02:00',NULL,NULL),(1003,188,'1197513','834','00','005010X220A1','1197513','','2013-12-03','18:10:50',0,'2013-12-25 18:20:22',NULL,NULL),(5562,1043,'1253531','834','00','005010X220A1','1253531','','2013-12-24','19:26:08',0,'2013-12-26 01:48:25',NULL,NULL),(2584,474,'257750','834','00','005010X220A1','257750','','2013-11-01','15:24:50',0,'2013-12-25 20:45:26',NULL,NULL),(5653,1050,'654896','834','00','005010X220A1','654896','','2013-12-24','22:44:58',0,'2013-12-26 01:51:24',NULL,NULL),(6015,1136,'109367','834','00','005010X220A1','109367','','2013-11-17','17:43:27',0,'2013-12-26 02:45:23',NULL,NULL),(17107,3142,'2243068','834','00','005010X220A1','2243068','','2014-01-30','10:17:21',0,'2014-01-30 21:00:11',NULL,NULL),(19504,3621,'2629408','834','00','005010X220A1','2629408','','2014-02-14','11:32:26',0,'2014-02-14 21:30:28',NULL,NULL),(20799,3909,'3332880','834','00','005010X220A1','3332880','','2014-02-25','14:45:29',0,'2014-02-25 21:30:54',NULL,NULL),(21337,4022,'2555506','834','00','005010X220A1','2555506','','2014-02-26','22:37:42',0,'2014-02-28 06:30:06',NULL,NULL),(21512,4032,'3147821','834','00','005010X220A1','3147821','','2014-02-27','15:32:10',0,'2014-02-28 06:31:27',NULL,NULL),(22233,4196,'3483027','834','00','005010X220A1','3483027','','2014-03-03','17:33:44',0,'2014-03-03 21:31:57',NULL,NULL),(22265,4200,'2702149','834','00','005010X220A1','2702149','','2014-03-04','12:59:46',0,'2014-03-04 21:00:32',NULL,NULL),(22405,4214,'2664814','834','00','005010X220A1','2664814','','2014-03-04','15:31:48',0,'2014-03-04 21:02:24',NULL,NULL),(15700,2700,'1889041','834','00','005010X220A1','1889041','','2014-01-18','23:08:57',0,'2014-01-21 08:45:28',NULL,NULL),(5952,1114,'110937','834','00','005010X220A1','110937','','2013-12-15','12:22:35',0,'2013-12-26 02:32:22',NULL,NULL),(13657,2271,'1490078','834','00','005010X220A1','1490078','','2014-01-07','16:03:40',0,'2014-01-08 18:24:13',NULL,NULL),(979,184,'161854','834','00','005010X220A1','161854','','2013-12-03','10:07:52',0,'2013-12-25 18:19:33',NULL,NULL),(5244,959,'1119616','834','00','005010X220A1','1119616','','2013-12-11','13:07:57',0,'2013-12-26 00:53:49',NULL,NULL),(4905,906,'120645','834','00','005010X220A1','120645','','2013-10-23','02:41:00',0,'2013-12-26 00:30:18',NULL,NULL),(2766,506,'940729','834','00','005010X220A1','940729','','2013-12-21','18:51:59',0,'2013-12-25 21:19:14',NULL,NULL),(4464,801,'12641','834','00','005010X220A1','12641','','2013-11-26','17:37:10',0,'2013-12-25 23:30:52',NULL,NULL),(5763,1072,'514231','834','00','005010X220A1','514231','','2013-12-14','09:51:49',0,'2013-12-26 02:02:19',NULL,NULL),(19508,3622,'2864146','834','00','005010X220A1','2864146','','2014-02-13','18:28:13',0,'2014-02-14 21:30:31',NULL,NULL),(51,3,'750299','834','00','005010X220A1','750299','','2013-12-04','22:01:36',0,'2013-12-25 17:16:31',NULL,NULL),(16702,3064,'1745854','834','00','005010X220A1','1745854','','2014-01-27','06:57:36',0,'2014-01-27 21:00:46',NULL,NULL),(16241,2933,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',0,'2014-01-23 06:45:45',NULL,NULL),(724,121,'58394','834','00','005010X220A1','58394','','2013-12-16','11:19:19',0,'2013-12-25 18:07:32',NULL,NULL),(4834,883,'347193','834','00','005010X220A1','347193','','2013-11-20','22:48:02',0,'2013-12-26 00:15:07',NULL,NULL),(2256,380,'700635','834','00','005010X220A1','700635','','2013-12-02','12:04:54',0,'2013-12-25 19:50:06',NULL,NULL),(14552,2519,'1790189','834','00','005010X220A1','1790189','','2014-01-13','07:32:32',0,'2014-01-14 01:32:36',NULL,NULL),(4312,750,'10545','834','00','005010X220A1','10545','','2013-12-18','22:23:50',0,'2013-12-25 23:09:36',NULL,NULL),(11731,1520,'1933331','834','00','005010X220A1','1933331','','2013-12-27','19:25:45',1,'2013-12-29 11:08:50',NULL,NULL),(14123,2349,'2057401','834','00','005010X220A1','2057401','','2014-01-08','16:06:32',0,'2014-01-13 02:22:25',NULL,NULL),(18939,3524,'2617909','834','00','005010X220A1','2617909','','2014-02-10','22:31:04',0,'2014-02-11 21:30:18',NULL,NULL),(20181,3777,'3312589','834','00','005010X220A1','3312589','','2014-02-19','16:52:08',0,'2014-02-20 04:13:12',NULL,NULL),(22650,4253,'3113082','834','00','005010X220A1','3113082','','2014-03-05','16:19:18',0,'2014-03-05 21:31:53',NULL,NULL),(22827,4278,'3010502','834','00','005010X220A1','3010502','','2014-03-06','15:20:21',0,'2014-03-06 21:01:22',NULL,NULL),(10989,1413,'1577350','834','00','005010X220A1','1577350','','2013-12-23','11:01:01',0,'2013-12-26 13:10:23',NULL,NULL),(16206,2898,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 04:52:49',NULL,NULL),(15087,2585,'2428218','834','00','005010X220A1','2428218','','2014-01-15','13:47:13',0,'2014-01-16 08:45:12',NULL,NULL),(10845,1405,'499436','834','00','005010X220A1','499436','','2013-12-22','20:41:50',0,'2013-12-26 13:05:19',NULL,NULL),(6372,1183,'354316','834','00','005010X220A1','354316','','2013-12-20','13:54:59',0,'2013-12-26 03:09:38',NULL,NULL),(14076,2341,'1755546','834','00','005010X220A1','1755546','','2014-01-07','20:21:47',0,'2014-01-13 02:21:54',NULL,NULL),(6019,1138,'1022213','834','00','005010X220A1','1022213','','2013-11-16','20:24:29',0,'2013-12-26 02:45:31',NULL,NULL),(5785,1075,'43130','834','00','005010X220A1','43130','','2013-12-14','09:41:44',0,'2013-12-26 02:03:05',NULL,NULL),(12265,1621,'1454821','834','00','005010X220A1','1454821','','2014-01-01','15:35:24',1,'2014-01-02 04:24:01',NULL,NULL),(13838,2307,'1898795','834','00','005010X220A1','1898795','','2014-01-11','13:26:53',0,'2014-01-13 02:18:40',NULL,NULL),(13356,2200,'0001','999','BE','005010X231A1','552185','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:48',NULL,NULL),(17212,3151,'2663924','834','00','005010X220A1','2663924','','2014-01-30','17:26:03',0,'2014-01-30 21:01:17',NULL,NULL),(18399,3412,'2326709','834','00','005010X220A1','2326709','','2014-02-09','08:05:38',0,'2014-02-09 19:00:35',NULL,NULL),(20368,3822,'2832636','834','00','005010X220A1','2832636','','2014-02-19','08:42:59',0,'2014-02-20 05:32:29',NULL,NULL),(20460,3842,'2994282','834','00','005010X220A1','2994282','','2014-02-20','10:26:05',0,'2014-02-20 22:00:31',NULL,NULL),(21772,4090,'3690763','834','00','005010X220A1','3690763','','2014-02-28','17:29:26',0,'2014-02-28 21:31:01',NULL,NULL),(22570,4248,'2834271','834','00','005010X220A1','2834271','','2014-03-05','13:55:49',0,'2014-03-05 21:30:56',NULL,NULL),(22776,4277,'2725465','834','00','005010X220A1','2725465','','2014-03-06','11:06:35',0,'2014-03-06 21:00:48',NULL,NULL),(71,3,'99905','834','00','005010X220A1','99905','','2013-12-05','17:44:14',0,'2013-12-25 17:17:09',NULL,NULL),(15181,2591,'2602982','834','00','005010X220A1','2602982','','2014-01-15','16:48:51',0,'2014-01-16 08:46:13',NULL,NULL),(11029,1417,'1545577','834','00','005010X220A1','1545577','','2013-12-22','21:59:19',0,'2013-12-26 13:11:46',NULL,NULL),(14622,2524,'2273777','834','00','005010X220A1','2273777','','2014-01-13','12:08:42',0,'2014-01-14 01:33:20',NULL,NULL),(7244,1243,'698873','834','00','005010X220A1','698873','','2013-12-18','16:04:44',0,'2013-12-26 04:08:00',NULL,NULL),(3299,584,'338433','834','00','005010X220A1','338433','','2013-12-17','09:02:50',0,'2013-12-25 21:48:24',NULL,NULL),(1828,313,'239966','834','00','005010X220A1','239966','','2013-12-10','13:26:45',0,'2013-12-25 19:20:29',NULL,NULL),(2864,514,'557712','834','00','005010X220A1','557712','','2013-12-22','06:51:41',0,'2013-12-25 21:22:26',NULL,NULL),(5968,1117,'1228350','834','00','005010X220A1','1228350','','2013-12-15','14:21:18',0,'2013-12-26 02:32:55',NULL,NULL),(4597,826,'390206','834','00','005010X220A1','390206','','2013-12-24','00:09:17',0,'2013-12-25 23:47:10',NULL,NULL),(17974,3304,'2845014','834','00','005010X220A1','2845014','','2014-02-05','15:28:17',0,'2014-02-05 21:31:08',NULL,NULL),(19116,3545,'3303259','834','00','005010X220A1','3303259','','2014-02-12','17:00:21',0,'2014-02-12 21:31:48',NULL,NULL),(19594,3631,'3172243','834','00','005010X220A1','3172243','','2014-02-13','19:25:56',0,'2014-02-14 21:31:33',NULL,NULL),(20486,3844,'3314781','834','00','005010X220A1','3314781','','2014-02-20','09:28:24',0,'2014-02-20 22:00:53',NULL,NULL),(12392,1637,'2472179','834','00','005010X220A1','2472179','','2013-12-31','10:34:25',1,'2014-01-02 04:29:23',NULL,NULL),(547,103,'1092413','834','00','005010X220A1','1092413','','2013-12-15','23:42:07',0,'2013-12-25 18:01:54',NULL,NULL),(1208,243,'1790718','834','00','005010X220A1','1790718','','2013-12-24','05:03:45',0,'2013-12-25 18:48:01',NULL,NULL),(1220,243,'1889666','834','00','005010X220A1','1889666','','2013-12-24','08:59:20',0,'2013-12-25 18:48:22',NULL,NULL),(1602,281,'332304','834','00','005010X220A1','332304','','2013-11-19','22:59:35',0,'2013-12-25 19:01:16',NULL,NULL),(11325,1456,'1622909','834','00','005010X220A1','1622909','','2013-12-26','13:37:11',0,'2013-12-27 02:04:15',NULL,NULL),(12140,1590,'2384737','834','00','005010X220A1','2384737','','2013-12-30','11:55:33',0,'2014-01-01 12:07:07',NULL,NULL),(6036,1146,'189204','834','00','005010X220A1','189204','','2013-11-17','13:06:21',0,'2013-12-26 02:46:03',NULL,NULL),(17635,3244,'2092189','834','00','005010X220A1','2092189','','2014-02-03','15:01:37',0,'2014-02-03 21:01:19',NULL,NULL),(18501,3443,'2598215','834','00','005010X220A1','2598215','','2014-02-10','08:53:51',0,'2014-02-10 21:00:03',NULL,NULL),(19739,3673,'2530446','834','00','005010X220A1','2530446','','2014-02-15','10:51:13',0,'2014-02-15 22:00:35',NULL,NULL),(22037,4163,'2803610','834','00','005010X220A1','2803610','','2014-03-03','08:58:13',0,'2014-03-03 21:00:03',NULL,NULL),(12922,1716,'2338138','834','00','005010X220A1','2338138','','2014-01-03','12:48:01',0,'2014-01-04 02:05:43',NULL,NULL),(3568,617,'1021516','834','00','005010X220A1','1021516','','2013-12-11','21:35:41',0,'2013-12-25 22:03:22',NULL,NULL),(5220,952,'126099','834','00','005010X220A1','126099','','2013-12-11','11:36:18',0,'2013-12-26 00:53:02',NULL,NULL),(2184,363,'213563','834','00','005010X220A1','213563','','2013-12-02','12:28:51',0,'2013-12-25 19:47:36',NULL,NULL),(5248,962,'691728','834','00','005010X220A1','691728','','2013-12-11','11:26:57',0,'2013-12-26 00:53:56',NULL,NULL),(18192,3352,'2604546','834','00','005010X220A1','2604546','','2014-02-06','18:26:09',0,'2014-02-07 19:00:29',NULL,NULL),(18781,3487,'2827448','834','00','005010X220A1','2827448','','2014-02-11','18:21:56',0,'2014-02-11 21:01:01',NULL,NULL),(18819,3489,'2596927','834','00','005010X220A1','2596927','','2014-02-11','17:55:11',0,'2014-02-11 21:01:30',NULL,NULL),(704,116,'399738','834','00','005010X220A1','399738','','2013-12-15','23:46:10',0,'2013-12-25 18:06:52',NULL,NULL),(7588,1301,'1386359','834','00','005010X220A1','1386359','','2013-12-21','18:02:03',0,'2013-12-26 04:36:56',NULL,NULL),(15834,2736,'1374532','834','00','005010X220A1','1374532','','2014-01-21','16:40:45',1,'2014-01-22 03:21:58',NULL,NULL),(15199,2592,'1874295','834','00','005010X220A1','1874295','','2014-01-15','14:58:43',0,'2014-01-16 08:46:25',NULL,NULL),(19435,3602,'2504194','834','00','005010X220A1','2504194','','2014-02-13','11:50:29',0,'2014-02-13 22:02:55',NULL,NULL),(20191,3779,'3674991','834','00','005010X220A1','3674991','','2014-02-19','15:23:46',0,'2014-02-20 04:15:39',NULL,NULL),(21583,4056,'2767540','834','00','005010X220A1','2767540','','2014-02-26','12:37:35',0,'2014-02-28 07:00:24',NULL,NULL),(22487,4243,'2834286','834','00','005010X220A1','2834286','','2014-03-05','17:37:26',0,'2014-03-05 21:00:28',NULL,NULL),(1142,239,'450357','834','00','005010X220A1','450357','','2013-12-24','07:29:48',0,'2013-12-25 18:45:58',NULL,NULL),(11924,1566,'1738806','834','00','005010X220A1','1738806','','2013-12-28','22:52:05',0,'2013-12-30 00:01:44',NULL,NULL),(11661,1500,'1677523','834','00','005010X220A1','1677523','','2013-12-27','14:49:53',0,'2013-12-28 03:36:38',NULL,NULL),(16806,3089,'1554561','834','00','005010X220A1','1554561','','2014-01-28','14:45:09',0,'2014-01-28 21:00:11',NULL,NULL),(5633,1047,'1416191','834','00','005010X220A1','1416191','','2013-12-24','20:07:45',0,'2013-12-26 01:50:47',NULL,NULL),(3022,543,'535940','834','00','005010X220A1','535940','','2013-12-13','16:18:04',0,'2013-12-25 21:33:47',NULL,NULL),(3095,546,'246382','834','00','005010X220A1','246382','','2013-12-12','23:34:05',0,'2013-12-25 21:36:03',NULL,NULL),(18774,3486,'2634031','834','00','005010X220A1','2634031','','2014-02-11','02:58:39',0,'2014-02-11 21:00:56',NULL,NULL),(19389,3593,'3095255','834','00','005010X220A1','3095255','','2014-02-13','03:39:01',0,'2014-02-13 22:02:21',NULL,NULL),(7705,1332,'88171','834','00','005010X220A1','88171','','2013-11-15','12:11:45',0,'2013-12-26 04:45:37',NULL,NULL),(7567,1301,'62496','834','00','005010X220A1','62496','','2013-12-21','12:32:49',0,'2013-12-26 04:36:11',NULL,NULL),(16359,2984,'1770887','834','00','005010X220A1','1770887','','2014-01-23','14:51:36',0,'2014-01-23 21:00:54',NULL,NULL),(14966,2569,'2430617','834','00','005010X220A1','2430617','','2014-01-14','10:18:34',0,'2014-01-15 02:08:00',NULL,NULL),(14582,2520,'2373655','834','00','005010X220A1','2373655','','2014-01-13','16:33:48',0,'2014-01-14 01:32:55',NULL,NULL),(22166,4180,'3210654','834','00','005010X220A1','3210654','','2014-03-03','12:04:18',0,'2014-03-03 21:31:07',NULL,NULL),(920,177,'493791','834','00','005010X220A1','493791','','2013-12-03','17:53:51',0,'2013-12-25 18:17:41',NULL,NULL),(15445,2630,'1980909','834','00','005010X220A1','1980909','','2014-01-15','23:20:14',0,'2014-01-17 03:36:07',NULL,NULL),(7465,1296,'1016657','834','00','005010X220A1','1016657','','2013-12-21','12:18:12',0,'2013-12-26 04:32:49',NULL,NULL),(1926,326,'163445','834','00','005010X220A1','163445','','2013-12-09','07:31:54',0,'2013-12-25 19:32:30',NULL,NULL),(5427,1030,'366827','834','00','005010X220A1','366827','','2013-11-14','14:48:48',0,'2013-12-26 01:31:14',NULL,NULL),(14098,2343,'2184127','834','00','005010X220A1','2184127','','2014-01-08','00:22:05',0,'2014-01-13 02:22:09',NULL,NULL),(18627,3459,'2937209','834','00','005010X220A1','2937209','','2014-02-10','16:06:17',0,'2014-02-10 21:31:23',NULL,NULL),(18718,3485,'3105013','834','00','005010X220A1','3105013','','2014-02-10','21:33:00',0,'2014-02-11 21:00:14',NULL,NULL),(18941,3525,'2298578','834','00','005010X220A1','2298578','','2014-02-11','12:38:28',0,'2014-02-11 21:30:20',NULL,NULL),(19970,3746,'3515069','834','00','005010X220A1','3515069','','2014-02-18','13:05:14',0,'2014-02-18 22:00:11',NULL,NULL),(20756,3903,'3524731','834','00','005010X220A1','3524731','','2014-02-25','17:13:47',0,'2014-02-25 21:30:24',NULL,NULL),(15218,2594,'1458742','834','00','005010X220A1','1458742','','2014-01-14','23:18:55',0,'2014-01-16 08:46:37',NULL,NULL),(15203,2592,'1874275','834','00','005010X220A1','1874275','','2014-01-15','11:52:32',0,'2014-01-16 08:46:27',NULL,NULL),(11181,1449,'1571157','834','00','005010X220A1','1571157','','2013-12-23','19:25:15',0,'2013-12-26 13:17:00',NULL,NULL),(10443,1400,'1035318','834','00','005010X220A1','1035318','','2013-12-23','12:25:40',0,'2013-12-26 12:52:04',NULL,NULL),(14645,2530,'1985911','834','00','005010X220A1','1985911','','2014-01-13','11:42:39',0,'2014-01-14 01:33:35',NULL,NULL),(5946,1113,'732656','834','00','005010X220A1','732656','','2013-12-15','12:36:18',0,'2013-12-26 02:32:12',NULL,NULL),(4063,732,'1131240','834','00','005010X220A1','1131240','','2013-12-18','19:12:39',0,'2013-12-25 23:02:06',NULL,NULL),(5060,936,'776606','834','00','005010X220A1','776606','','2013-12-11','10:13:21',0,'2013-12-26 00:47:55',NULL,NULL),(2502,446,'194286','834','00','005010X220A1','194286','','2013-10-13','15:34:38',0,'2013-12-25 20:30:06',NULL,NULL),(11471,1488,'1639246','834','00','005010X220A1','1639246','','2013-12-27','12:39:58',0,'2013-12-28 03:30:46',NULL,NULL),(3014,543,'902331','834','00','005010X220A1','902331','','2013-12-13','13:36:53',0,'2013-12-25 21:33:33',NULL,NULL),(17798,3270,'1814256','834','00','005010X220A1','1814256','','2014-02-04','14:40:48',0,'2014-02-04 21:01:31',NULL,NULL),(18384,3407,'2443441','834','00','005010X220A1','2443441','','2014-02-09','15:47:20',0,'2014-02-09 19:00:24',NULL,NULL),(20611,3871,'3631860','834','00','005010X220A1','3631860','','2014-02-20','23:24:59',0,'2014-02-21 22:00:24',NULL,NULL),(21652,4076,'2951720','834','00','005010X220A1','2951720','','2014-02-28','08:55:49',0,'2014-02-28 21:00:02',NULL,NULL),(22392,4211,'3146646','834','00','005010X220A1','3146646','','2014-03-03','21:46:38',0,'2014-03-04 21:02:13',NULL,NULL),(15830,2736,'2589198','834','00','005010X220A1','2589198','','2014-01-21','17:17:40',1,'2014-01-22 03:21:56',NULL,NULL),(3038,544,'1307880','834','00','005010X220A1','1307880','','2013-12-13','10:51:54',0,'2013-12-25 21:34:15',NULL,NULL),(10749,1403,'1810576','834','00','005010X220A1','1810576','','2013-12-23','17:20:53',0,'2013-12-26 13:02:12',NULL,NULL),(14776,2551,'1415283','834','00','005010X220A1','1415283','','2014-01-14','13:11:59',0,'2014-01-15 02:06:35',NULL,NULL),(3938,714,'426033','834','00','005010X220A1','426033','','2013-12-07','10:43:16',0,'2013-12-25 22:46:10',NULL,NULL),(11478,1488,'119089','834','00','005010X220A1','119089','','2013-12-27','15:06:35',0,'2013-12-28 03:31:00',NULL,NULL),(13415,2222,'1447569','834','00','005010X220A1','1447569','','2014-01-06','16:08:54',0,'2014-01-07 04:01:24',NULL,NULL),(18159,3350,'1698742','834','00','005010X220A1','1698742','','2014-02-06','20:01:01',0,'2014-02-07 19:00:06',NULL,NULL),(19564,3626,'2226081','834','00','005010X220A1','2226081','','2014-02-14','16:49:40',0,'2014-02-14 21:31:12',NULL,NULL),(19685,3666,'3503749','834','00','005010X220A1','3503749','','2014-02-15','11:00:47',0,'2014-02-15 21:00:08',NULL,NULL),(23769,4481,'3429078','834','00','005010X220A1','3429078','','2014-03-10','14:37:59',0,'2014-03-10 21:30:16',NULL,NULL),(11069,1421,'1056170','834','00','005010X220A1','1056170','','2013-12-23','13:36:55',0,'2013-12-26 13:13:05',NULL,NULL),(5879,1109,'93491','834','00','005010X220A1','93491','','2013-12-14','18:14:06',0,'2013-12-26 02:30:06',NULL,NULL),(5527,1041,'1873684','834','00','005010X220A1','1873684','','2013-12-24','22:22:08',0,'2013-12-26 01:47:16',NULL,NULL),(16554,3027,'2318180','834','00','005010X220A1','2318180','','2014-01-24','17:19:57',0,'2014-01-24 21:01:15',NULL,NULL),(13786,2293,'1739139','834','00','005010X220A1','1739139','','2014-01-10','18:21:05',0,'2014-01-13 02:18:05',NULL,NULL),(1797,303,'256669','834','00','005010X220A1','256669','','2013-12-10','17:26:16',0,'2013-12-25 19:19:32',NULL,NULL),(22254,4200,'3694505','834','00','005010X220A1','3694505','','2014-03-03','23:14:12',0,'2014-03-04 21:00:23',NULL,NULL),(269,54,'149972','834','00','005010X220A1','149972','','2013-11-13','16:01:32',0,'2013-12-25 17:31:32',NULL,NULL),(11580,1492,'2060610','834','00','005010X220A1','2060610','','2013-12-27','16:14:30',0,'2013-12-28 03:34:07',NULL,NULL),(579,104,'437523','834','00','005010X220A1','437523','','2013-12-15','18:59:34',0,'2013-12-25 18:02:55',NULL,NULL),(16692,3062,'1988661','834','00','005010X220A1','1988661','','2014-01-27','16:30:02',0,'2014-01-27 21:00:38',NULL,NULL),(14841,2553,'2272726','834','00','005010X220A1','2272726','','2014-01-14','10:23:17',0,'2014-01-15 02:07:02',NULL,NULL),(12955,1734,'2322418','834','00','005010X220A1','2322418','','2014-01-03','18:45:10',0,'2014-01-05 00:00:31',NULL,NULL),(2964,541,'1225887','834','00','005010X220A1','1225887','','2013-12-13','14:02:27',0,'2013-12-25 21:32:02',NULL,NULL),(5582,1043,'1746325','834','00','005010X220A1','1746325','','2013-12-24','23:21:16',0,'2013-12-26 01:49:03',NULL,NULL),(3416,592,'606227','834','00','005010X220A1','606227','','2013-12-17','12:59:48',0,'2013-12-25 21:52:12',NULL,NULL),(4026,731,'410703','834','00','005010X220A1','410703','','2013-12-19','14:01:29',0,'2013-12-25 23:00:55',NULL,NULL),(4298,748,'79857','834','00','005010X220A1','79857','','2013-12-18','22:03:23',0,'2013-12-25 23:09:15',NULL,NULL),(11795,1537,'265268','834','00','005010X220A1','265268','','2013-12-28','20:22:47',1,'2013-12-29 11:12:57',NULL,NULL),(22257,4200,'3461870','834','00','005010X220A1','3461870','','2014-03-04','08:53:31',0,'2014-03-04 21:00:26',NULL,NULL),(16938,3115,'1679653','834','00','005010X220A1','1679653','','2014-01-29','11:52:36',0,'2014-01-29 21:00:15',NULL,NULL),(598,107,'80844','834','00','005010X220A1','80844','','2013-12-16','11:44:49',0,'2013-12-25 18:03:31',NULL,NULL),(776,144,'1009870','834','00','005010X220A1','1009870','','2013-10-31','14:19:06',0,'2013-12-25 18:09:15',NULL,NULL),(15069,2585,'2597656','834','00','005010X220A1','2597656','','2014-01-15','12:27:53',0,'2014-01-16 08:45:01',NULL,NULL),(7536,1300,'1378990','834','00','005010X220A1','1378990','','2013-12-21','15:13:58',0,'2013-12-26 04:35:10',NULL,NULL),(2013,331,'467505','834','00','005010X220A1','467505','','2013-12-09','11:46:46',0,'2013-12-25 19:35:16',NULL,NULL),(7437,1295,'190046','834','00','005010X220A1','190046','','2013-12-21','15:55:37',0,'2013-12-26 04:32:01',NULL,NULL),(5536,1041,'1427246','834','00','005010X220A1','1427246','','2013-12-24','23:32:44',0,'2013-12-26 01:47:34',NULL,NULL),(12866,1706,'2441187','834','00','005010X220A1','2441187','','2014-01-03','10:49:56',0,'2014-01-04 02:03:38',NULL,NULL),(4266,742,'1187426','834','00','005010X220A1','1187426','','2013-12-19','15:55:07',0,'2013-12-25 23:08:18',NULL,NULL),(12777,1702,'1985693','834','00','005010X220A1','1985693','','2014-01-03','14:34:00',0,'2014-01-04 02:00:23',NULL,NULL),(12209,1615,'1926885','834','00','005010X220A1','1926885','','2013-12-31','20:10:55',1,'2014-01-02 04:21:49',NULL,NULL),(5125,943,'903395','834','00','005010X220A1','903395','','2013-12-10','19:54:27',0,'2013-12-26 00:50:03',NULL,NULL),(11714,1519,'1483712','834','00','005010X220A1','1483712','','2013-12-28','10:33:48',1,'2013-12-29 11:08:20',NULL,NULL),(20566,3864,'2803355','834','00','005010X220A1','2803355','','2014-02-21','15:35:00',0,'2014-02-21 21:30:13',NULL,NULL),(22770,4277,'3128378','834','00','005010X220A1','3128378','','2014-03-05','20:19:33',0,'2014-03-06 21:00:44',NULL,NULL),(10948,1410,'1413271','834','00','005010X220A1','1413271','','2013-12-23','16:59:34',0,'2013-12-26 13:09:09',NULL,NULL),(998,186,'1042629','834','00','005010X220A1','1042629','','2013-12-02','22:51:39',0,'2013-12-25 18:20:12',NULL,NULL),(7690,1330,'811683','834','00','005010X220A1','811683','','2013-11-14','19:10:47',0,'2013-12-26 04:45:06',NULL,NULL),(15469,2634,'1806101','834','00','005010X220A1','1806101','','2014-01-15','22:08:19',0,'2014-01-17 03:36:18',NULL,NULL),(4599,826,'1194949','834','00','005010X220A1','1194949','','2013-12-24','00:38:27',0,'2013-12-25 23:47:14',NULL,NULL),(14661,2536,'1484117','834','00','005010X220A1','1484117','','2014-01-13','14:47:40',0,'2014-01-14 01:33:46',NULL,NULL),(12843,1705,'1758999','834','00','005010X220A1','1758999','','2014-01-02','20:49:24',0,'2014-01-04 02:02:48',NULL,NULL),(13676,2272,'1847051','834','00','005010X220A1','1847051','','2014-01-07','12:38:01',0,'2014-01-08 18:24:20',NULL,NULL),(19360,3586,'2467760','834','00','005010X220A1','2467760','','2014-02-12','19:40:56',0,'2014-02-13 22:02:00',NULL,NULL),(20883,3920,'3105470','834','00','005010X220A1','3105470','','2014-02-25','17:25:56',0,'2014-02-25 21:31:56',NULL,NULL),(22923,4290,'2663585','834','00','005010X220A1','2663585','','2014-03-06','09:53:39',0,'2014-03-06 21:02:33',NULL,NULL),(23083,4339,'3278105','834','00','005010X220A1','3278105','','2014-03-07','13:06:26',0,'2014-03-07 21:30:23',NULL,NULL),(16713,3064,'2062374','834','00','005010X220A1','2062374','','2014-01-27','12:10:13',0,'2014-01-27 21:00:51',NULL,NULL),(15543,2654,'1692802','834','00','005010X220A1','1692802','','2014-01-17','12:50:42',0,'2014-01-20 08:05:43',NULL,NULL),(2012,331,'1312862','834','00','005010X220A1','1312862','','2013-12-09','09:24:42',0,'2013-12-25 19:35:14',NULL,NULL),(11524,1490,'2250283','834','00','005010X220A1','2250283','','2013-12-27','12:30:54',0,'2013-12-28 03:32:22',NULL,NULL),(14495,2515,'2305232','834','00','005010X220A1','2305232','','2014-01-12','18:31:51',0,'2014-01-14 01:31:58',NULL,NULL),(12236,1618,'1729238','834','00','005010X220A1','1729238','','2014-01-01','10:32:47',1,'2014-01-02 04:22:53',NULL,NULL),(4790,865,'775122','834','00','005010X220A1','775122','','2013-12-01','13:55:00',0,'2013-12-26 00:01:34',NULL,NULL),(18540,3452,'2459939','834','00','005010X220A1','2459939','','2014-02-09','20:29:01',0,'2014-02-10 21:30:22',NULL,NULL),(19381,3591,'3359305','834','00','005010X220A1','3359305','','2014-02-13','14:27:30',0,'2014-02-13 22:02:15',NULL,NULL),(10592,1402,'1254790','834','00','005010X220A1','1254790','','2013-12-23','12:24:18',0,'2013-12-26 12:56:53',NULL,NULL),(16377,2986,'2180992','834','00','005010X220A1','2180992','','2014-01-23','14:43:06',0,'2014-01-23 21:01:08',NULL,NULL),(11650,1500,'2061677','834','00','005010X220A1','2061677','','2013-12-26','23:41:02',0,'2013-12-28 03:36:17',NULL,NULL),(4327,751,'798373','834','00','005010X220A1','798373','','2013-12-18','22:56:16',0,'2013-12-25 23:10:02',NULL,NULL),(2190,363,'68491','834','00','005010X220A1','68491','','2013-12-02','16:14:58',0,'2013-12-25 19:47:48',NULL,NULL),(2221,367,'251276','834','00','005010X220A1','251276','','2013-12-02','17:29:21',0,'2013-12-25 19:48:52',NULL,NULL),(5918,1112,'1058405','834','00','005010X220A1','1058405','','2013-12-15','11:39:18',0,'2013-12-26 02:31:21',NULL,NULL),(4496,804,'85628','834','00','005010X220A1','85628','','2013-11-26','11:46:28',0,'2013-12-25 23:31:55',NULL,NULL),(19079,3542,'2036203','834','00','005010X220A1','2036203','','2014-02-12','12:31:41',0,'2014-02-12 21:31:24',NULL,NULL),(21938,4132,'3170168','834','00','005010X220A1','3170168','','2014-02-28','19:58:35',0,'2014-03-01 21:00:56',NULL,NULL),(22926,4291,'3369884','834','00','005010X220A1','3369884','','2014-03-06','12:15:47',0,'2014-03-06 21:02:35',NULL,NULL),(11918,1565,'1688293','834','00','005010X220A1','1688293','','2013-12-29','11:08:05',0,'2013-12-30 00:01:34',NULL,NULL),(12230,1618,'1692312','834','00','005010X220A1','1692312','','2013-12-31','19:04:46',1,'2014-01-02 04:22:38',NULL,NULL),(6113,1166,'629673','834','00','005010X220A1','629673','','2013-12-20','13:28:32',0,'2013-12-26 03:01:42',NULL,NULL),(1997,329,'1207745','834','00','005010X220A1','1207745','','2013-12-09','12:22:28',0,'2013-12-25 19:34:45',NULL,NULL),(2693,502,'1219643','834','00','005010X220A1','1219643','','2013-12-22','13:22:51',0,'2013-12-25 21:16:57',NULL,NULL),(17395,3198,'1509079','834','00','005010X220A1','1509079','','2014-02-01','11:07:57',0,'2014-02-01 19:00:06',NULL,NULL),(18486,3432,'2257117','834','00','005010X220A1','2257117','','2014-02-10','04:30:57',0,'2014-02-10 11:01:03',NULL,NULL),(11184,1450,'867039','834','00','005010X220A1','867039','','2013-12-23','19:16:35',0,'2013-12-26 13:17:06',NULL,NULL),(456,83,'716705','834','00','005010X220A1','716705','','2013-12-04','13:00:13',0,'2013-12-25 17:50:09',NULL,NULL),(10934,1410,'526274','834','00','005010X220A1','526274','','2013-12-23','13:01:21',0,'2013-12-26 13:08:45',NULL,NULL),(21473,4028,'3231248','834','00','005010X220A1','3231248','','2014-02-27','14:50:27',0,'2014-02-28 06:31:09',NULL,NULL),(21763,4090,'3438870','834','00','005010X220A1','3438870','','2014-02-28','14:10:32',0,'2014-02-28 21:30:55',NULL,NULL),(22389,4210,'3068014','834','00','005010X220A1','3068014','','2014-03-03','21:01:35',0,'2014-03-04 21:02:10',NULL,NULL),(983,184,'1017363','834','00','005010X220A1','1017363','','2013-12-03','13:09:39',0,'2013-12-25 18:19:41',NULL,NULL),(1642,283,'282105','834','00','005010X220A1','282105','','2013-11-20','09:28:40',0,'2013-12-25 19:02:15',NULL,NULL),(12942,1733,'2106482','834','00','005010X220A1','2106482','','2014-01-03','18:31:41',0,'2014-01-05 00:00:02',NULL,NULL),(6424,1203,'796564','834','00','005010X220A1','796564','','2013-11-22','10:54:00',0,'2013-12-26 03:15:17',NULL,NULL),(5934,1112,'1285818','834','00','005010X220A1','1285818','','2013-12-15','16:19:58',0,'2013-12-26 02:31:51',NULL,NULL),(19528,3622,'2573129','834','00','005010X220A1','2573129','','2014-02-14','13:39:56',0,'2014-02-14 21:30:46',NULL,NULL),(23540,4435,'3271954','834','00','005010X220A1','3271954','','2014-03-10','10:42:22',0,'2014-03-10 21:00:31',NULL,NULL),(14667,2542,'2108241','834','00','005010X220A1','2108241','','2014-01-13','15:59:42',0,'2014-01-14 01:33:51',NULL,NULL),(14557,2519,'2416583','834','00','005010X220A1','2416583','','2014-01-13','11:24:35',0,'2014-01-14 01:32:39',NULL,NULL),(10798,1404,'850310','834','00','005010X220A1','850310','','2013-12-23','14:02:34',0,'2013-12-26 13:03:48',NULL,NULL),(13446,2223,'2443807','834','00','005010X220A1','2443807','','2014-01-06','14:23:25',0,'2014-01-07 04:02:36',NULL,NULL),(12574,1670,'2229133','834','00','005010X220A1','2229133','','2014-01-02','08:00:16',0,'2014-01-03 02:00:06',NULL,NULL),(3072,545,'676232','834','00','005010X220A1','676232','','2013-12-13','18:07:17',0,'2013-12-25 21:35:21',NULL,NULL),(3784,656,'882577','834','00','005010X220A1','882577','','2013-12-08','13:11:27',0,'2013-12-25 22:15:47',NULL,NULL),(10390,1400,'1193518','834','00','005010X220A1','1193518','','2013-12-23','01:35:52',0,'2013-12-26 12:50:25',NULL,NULL),(7482,1296,'293294','834','00','005010X220A1','293294','','2013-12-21','17:55:50',0,'2013-12-26 04:33:22',NULL,NULL),(19884,3710,'3120249','834','00','005010X220A1','3120249','','2014-02-16','00:23:04',0,'2014-02-16 19:00:27',NULL,NULL),(21556,4050,'3789539','834','00','005010X220A1','3789539','','2014-02-27','15:51:37',0,'2014-02-28 06:31:48',NULL,NULL),(22232,4195,'3057126','834','00','005010X220A1','3057126','','2014-03-03','17:15:53',0,'2014-03-03 21:31:56',NULL,NULL),(4830,880,'743980','834','00','005010X220A1','743980','','2013-12-01','15:17:36',0,'2013-12-26 00:02:48',NULL,NULL),(755,138,'210218','834','00','005010X220A1','210218','','2013-12-16','14:13:41',0,'2013-12-25 18:08:31',NULL,NULL),(861,175,'546318','834','00','005010X220A1','546318','','2013-12-03','12:20:20',0,'2013-12-25 18:16:00',NULL,NULL),(3236,578,'1209271','834','00','005010X220A1','1209271','','2013-12-17','15:01:49',0,'2013-12-25 21:46:25',NULL,NULL),(1874,324,'554881','834','00','005010X220A1','554881','','2013-12-09','17:08:19',0,'2013-12-25 19:31:00',NULL,NULL),(22593,4250,'3115813','834','00','005010X220A1','3115813','','2014-03-04','19:54:45',0,'2014-03-05 21:31:14',NULL,NULL),(23311,4381,'2784437','834','00','005010X220A1','2784437','','2014-03-08','12:12:22',0,'2014-03-08 21:30:28',NULL,NULL),(23568,4436,'2913284','834','00','005010X220A1','2913284','','2014-03-10','12:28:00',0,'2014-03-10 21:00:54',NULL,NULL),(12225,1617,'2075056','834','00','005010X220A1','2075056','','2013-12-31','20:14:51',1,'2014-01-02 04:22:25',NULL,NULL),(17502,3223,'2636024','834','00','005010X220A1','2636024','','2014-02-01','21:25:36',0,'2014-02-02 19:00:26',NULL,NULL),(14359,2404,'1938422','834','00','005010X220A1','1938422','','2014-01-12','10:03:40',0,'2014-01-13 03:01:33',NULL,NULL),(11414,1468,'1506868','834','00','005010X220A1','1506868','','2013-12-26','11:23:55',0,'2013-12-27 02:07:00',NULL,NULL),(4945,921,'51768','834','00','005010X220A1','51768','','2013-11-18','23:37:56',0,'2013-12-26 00:31:37',NULL,NULL),(13235,2079,'0001','999','BE','005010X231A1','853860','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:30',NULL,NULL),(19080,3542,'2178663','834','00','005010X220A1','2178663','','2014-02-12','12:44:44',0,'2014-02-12 21:31:24',NULL,NULL),(4919,910,'679374','834','00','005010X220A1','679374','','2013-10-15','19:43:31',0,'2013-12-26 00:30:47',NULL,NULL),(293,67,'371308','834','00','005010X220A1','371308','','2013-11-09','07:44:17',0,'2013-12-25 17:32:26',NULL,NULL),(11534,1490,'1654784','834','00','005010X220A1','1654784','','2013-12-27','14:59:18',0,'2013-12-28 03:32:39',NULL,NULL),(6995,1235,'22171','834','00','005010X220A1','22171','','2013-12-17','18:47:15',0,'2013-12-26 04:00:19',NULL,NULL),(2698,502,'1457920','834','00','005010X220A1','1457920','','2013-12-22','14:26:11',0,'2013-12-25 21:17:07',NULL,NULL),(10651,1402,'346653','834','00','005010X220A1','346653','','2013-12-23','18:13:29',0,'2013-12-26 12:58:50',NULL,NULL),(1243,243,'883369','834','00','005010X220A1','883369','','2013-12-24','11:17:01',0,'2013-12-25 18:48:59',NULL,NULL),(21632,4068,'3787066','834','00','005010X220A1','3787066','','2014-02-27','11:06:54',0,'2014-02-28 07:30:27',NULL,NULL),(22707,4264,'3395601','834','00','005010X220A1','3395601','','2014-03-05','16:10:37',0,'2014-03-05 21:32:33',NULL,NULL),(22833,4278,'3835791','834','00','005010X220A1','3835791','','2014-03-06','16:52:25',0,'2014-03-06 21:01:26',NULL,NULL),(1006,188,'996646','834','00','005010X220A1','996646','','2013-12-03','14:04:30',0,'2013-12-25 18:20:27',NULL,NULL),(16111,2803,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 03:43:43',NULL,NULL),(11270,1455,'2180288','834','00','005010X220A1','2180288','','2013-12-26','11:56:46',0,'2013-12-27 02:02:35',NULL,NULL),(18094,3326,'1429452','834','00','005010X220A1','1429452','','2014-02-06','10:51:14',0,'2014-02-06 21:01:11',NULL,NULL),(19473,3620,'2285419','834','00','005010X220A1','2285419','','2014-02-13','20:24:58',0,'2014-02-14 21:30:07',NULL,NULL),(16986,3118,'1521504','834','00','005010X220A1','1521504','','2014-01-28','20:02:14',0,'2014-01-29 21:00:45',NULL,NULL),(16731,3065,'1572076','834','00','005010X220A1','1572076','','2014-01-27','00:20:48',0,'2014-01-27 21:01:04',NULL,NULL),(16095,2787,'0001','999','BE','005010X231A1','228651','834','2014-01-13','22:25:00',0,'2014-01-23 03:39:36',NULL,NULL),(7721,1337,'966772','834','00','005010X220A1','966772','','2013-11-15','15:06:02',0,'2013-12-26 04:46:12',NULL,NULL),(7493,1300,'598942','834','00','005010X220A1','598942','','2013-12-20','19:49:09',0,'2013-12-26 04:33:49',NULL,NULL),(15686,2695,'2513627','834','00','005010X220A1','2513627','','2014-01-19','17:23:07',0,'2014-01-21 08:45:17',NULL,NULL),(15375,2624,'2273901','834','00','005010X220A1','2273901','','2014-01-15','23:28:24',0,'2014-01-17 03:35:35',NULL,NULL),(5284,979,'498513','834','00','005010X220A1','498513','','2013-11-15','20:55:17',0,'2013-12-26 01:00:51',NULL,NULL),(1227,243,'1882288','834','00','005010X220A1','1882288','','2013-12-24','09:42:32',0,'2013-12-25 18:48:35',NULL,NULL),(5253,966,'39311','834','00','005010X220A1','39311','','2013-12-11','13:12:04',0,'2013-12-26 00:54:08',NULL,NULL),(2276,391,'144623','834','00','005010X220A1','144623','','2013-11-24','12:44:15',0,'2013-12-25 20:00:21',NULL,NULL),(4971,935,'1343865','834','00','005010X220A1','1343865','','2013-12-10','18:18:30',0,'2013-12-26 00:45:02',NULL,NULL),(18287,3380,'2032390','834','00','005010X220A1','2032390','','2014-02-07','18:46:38',0,'2014-02-08 19:00:26',NULL,NULL),(19534,3622,'3258658','834','00','005010X220A1','3258658','','2014-02-14','17:35:57',0,'2014-02-14 21:30:50',NULL,NULL),(21223,3999,'2621917','834','00','005010X220A1','2621917','','2014-02-26','08:43:01',0,'2014-02-26 21:01:32',NULL,NULL),(23189,4345,'3164556','834','00','005010X220A1','3164556','','2014-03-07','15:52:13',0,'2014-03-07 21:31:38',NULL,NULL),(23465,4415,'3013361','834','00','005010X220A1','3013361','','2014-03-09','11:18:51',0,'2014-03-09 21:01:05',NULL,NULL),(12914,1714,'1864557','834','00','005010X220A1','1864557','','2014-01-03','14:18:51',0,'2014-01-04 02:05:25',NULL,NULL),(18591,3455,'1865444','834','00','005010X220A1','1865444','','2014-02-09','19:06:40',0,'2014-02-10 21:30:57',NULL,NULL),(18679,3468,'2610704','834','00','005010X220A1','2610704','','2014-02-10','06:52:53',0,'2014-02-10 21:31:58',NULL,NULL),(20361,3821,'2912665','834','00','005010X220A1','2912665','','2014-02-18','18:36:39',0,'2014-02-20 05:30:15',NULL,NULL),(17297,3172,'2684376','834','00','005010X220A1','2684376','','2014-01-31','15:52:51',0,'2014-01-31 21:00:39',NULL,NULL),(1004,188,'42788','834','00','005010X220A1','42788','','2013-12-03','01:14:46',0,'2013-12-25 18:20:24',NULL,NULL),(5090,940,'58191','834','00','005010X220A1','58191','','2013-12-10','18:43:43',0,'2013-12-26 00:48:51',NULL,NULL),(10718,1403,'1235775','834','00','005010X220A1','1235775','','2013-12-23','13:03:46',0,'2013-12-26 13:01:08',NULL,NULL),(2990,542,'668454','834','00','005010X220A1','668454','','2013-12-13','12:35:46',0,'2013-12-25 21:32:49',NULL,NULL),(11175,1446,'1633807','834','00','005010X220A1','1633807','','2013-12-23','14:42:55',0,'2013-12-26 13:16:49',NULL,NULL),(3600,617,'1204090','834','00','005010X220A1','1204090','','2013-12-12','18:22:36',0,'2013-12-25 22:04:20',NULL,NULL),(18742,3485,'2853791','834','00','005010X220A1','2853791','','2014-02-11','12:40:32',0,'2014-02-11 21:00:32',NULL,NULL),(20278,3796,'2597144','834','00','005010X220A1','2597144','','2014-02-19','01:08:58',0,'2014-02-20 04:37:20',NULL,NULL),(21065,3980,'3047000','834','00','005010X220A1','3047000','','2014-02-24','11:43:50',0,'2014-02-26 09:30:38',NULL,NULL),(15434,2629,'1408713','834','00','005010X220A1','1408713','','2014-01-16','17:16:20',0,'2014-01-17 03:36:03',NULL,NULL),(4355,761,'90265','834','00','005010X220A1','90265','','2013-12-19','18:24:33',0,'2013-12-25 23:10:56',NULL,NULL),(4535,824,'1109782','834','00','005010X220A1','1109782','','2013-12-23','23:16:36',0,'2013-12-25 23:45:11',NULL,NULL),(21513,4033,'3243250','834','00','005010X220A1','3243250','','2014-02-26','21:19:08',0,'2014-02-28 06:31:27',NULL,NULL),(21762,4090,'2839731','834','00','005010X220A1','2839731','','2014-02-28','13:23:20',0,'2014-02-28 21:30:54',NULL,NULL),(34,1,'109577','834','00','005010X220A1','109577','','2013-12-05','12:56:34',0,'2013-12-25 17:16:00',NULL,NULL),(515,102,'250242','834','00','005010X220A1','250242','','2013-12-16','12:22:15',0,'2013-12-25 18:00:55',NULL,NULL),(15121,2587,'1874262','834','00','005010X220A1','1874262','','2014-01-15','09:35:14',0,'2014-01-16 08:45:34',NULL,NULL),(12264,1621,'2145585','834','00','005010X220A1','2145585','','2013-12-31','19:38:32',1,'2014-01-02 04:23:58',NULL,NULL),(12114,1587,'1653654','834','00','005010X220A1','1653654','','2013-12-30','13:04:55',0,'2014-01-01 12:06:10',NULL,NULL),(11346,1456,'1473097','834','00','005010X220A1','1473097','','2013-12-26','18:17:11',0,'2013-12-27 02:04:53',NULL,NULL),(11227,1454,'1945854','834','00','005010X220A1','1945854','','2013-12-26','10:46:31',0,'2013-12-27 02:01:16',NULL,NULL),(13393,2221,'1690992','834','00','005010X220A1','1690992','','2014-01-06','11:39:30',0,'2014-01-07 04:00:39',NULL,NULL),(4894,901,'400038','834','00','005010X220A1','400038','','2013-10-02','13:50:14',0,'2013-12-26 00:17:10',NULL,NULL),(5447,1035,'5978','834','00','005010X220A1','5978','','2013-11-03','17:20:09',0,'2013-12-26 01:31:53',NULL,NULL),(20090,3765,'2304778','834','00','005010X220A1','2304778','','2014-02-18','13:44:58',0,'2014-02-18 22:01:39',NULL,NULL),(23164,4344,'3716436','834','00','005010X220A1','3716436','','2014-03-07','11:55:29',0,'2014-03-07 21:31:20',NULL,NULL),(13048,1892,'0001','999','BE','005010X231A1','556024','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:15',NULL,NULL),(14641,2529,'2399240','834','00','005010X220A1','2399240','','2014-01-13','11:17:36',0,'2014-01-14 01:33:32',NULL,NULL),(1135,238,'1967725','834','00','005010X220A1','1967725','','2013-12-24','17:15:28',0,'2013-12-25 18:45:44',NULL,NULL),(11022,1416,'429532','834','00','005010X220A1','429532','','2013-12-22','22:27:23',0,'2013-12-26 13:11:33',NULL,NULL),(1658,289,'215148','834','00','005010X220A1','215148','','2013-12-09','21:28:02',0,'2013-12-25 19:15:09',NULL,NULL),(7416,1295,'707754','834','00','005010X220A1','707754','','2013-12-21','00:43:06',0,'2013-12-26 04:31:23',NULL,NULL),(5328,1002,'9906','834','00','005010X220A1','9906','','2013-11-25','13:01:14',0,'2013-12-26 01:15:06',NULL,NULL),(3345,587,'313163','834','00','005010X220A1','313163','','2013-12-16','21:07:49',0,'2013-12-25 21:50:02',NULL,NULL),(4966,931,'1064952','834','00','005010X220A1','1064952','','2013-10-06','19:55:10',0,'2013-12-26 00:32:19',NULL,NULL),(14285,2379,'1687316','834','00','005010X220A1','1687316','','2014-01-09','23:35:55',0,'2014-01-13 03:00:18',NULL,NULL),(13270,2114,'0001','999','BE','005010X231A1','691076','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:48',NULL,NULL),(12146,1591,'2194822','834','00','005010X220A1','2194822','','2013-12-30','10:14:17',0,'2014-01-01 12:07:18',NULL,NULL),(13055,1899,'0001','999','BE','005010X231A1','773275','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:34',NULL,NULL),(13234,2078,'0001','999','BE','005010X231A1','49381','834','2013-12-28','04:55:00',0,'2014-01-05 17:01:27',NULL,NULL),(17455,3209,'2110049','834','00','005010X220A1','2110049','','2014-02-01','11:35:17',0,'2014-02-01 19:00:45',NULL,NULL),(17893,3295,'1849983','834','00','005010X220A1','1849983','','2014-02-04','19:26:40',0,'2014-02-05 21:30:27',NULL,NULL),(19143,3549,'2412299','834','00','005010X220A1','2412299','','2014-02-12','10:50:56',0,'2014-02-12 21:32:04',NULL,NULL),(20670,3879,'2941531','834','00','005010X220A1','2941531','','2014-02-21','11:24:44',0,'2014-02-21 22:01:06',NULL,NULL),(434,79,'1011133','834','00','005010X220A1','1011133','','2013-12-03','23:35:28',0,'2013-12-25 17:49:28',NULL,NULL),(7509,1300,'585846','834','00','005010X220A1','585846','','2013-12-21','09:54:59',0,'2013-12-26 04:34:18',NULL,NULL),(13759,2277,'1405813','834','00','005010X220A1','1405813','','2014-01-07','15:16:10',0,'2014-01-08 18:24:56',NULL,NULL),(7126,1236,'176557','834','00','005010X220A1','176557','','2013-12-18','16:21:20',0,'2013-12-26 04:04:24',NULL,NULL),(1322,245,'1300844','834','00','005010X220A1','1300844','','2013-12-24','10:53:30',0,'2013-12-25 18:51:31',NULL,NULL),(4958,929,'362729','834','00','005010X220A1','362729','','2013-11-19','13:25:04',0,'2013-12-26 00:32:07',NULL,NULL),(2934,541,'79599','834','00','005010X220A1','79599','','2013-12-12','20:50:40',0,'2013-12-25 21:31:04',NULL,NULL),(11041,1418,'1247149','834','00','005010X220A1','1247149','','2013-12-23','10:58:27',0,'2013-12-26 13:12:11',NULL,NULL),(20161,3777,'2417518','834','00','005010X220A1','2417518','','2014-02-18','22:04:54',0,'2014-02-20 04:06:55',NULL,NULL),(21400,4025,'3199482','834','00','005010X220A1','3199482','','2014-02-26','22:16:36',0,'2014-02-28 06:30:35',NULL,NULL),(6987,1234,'962246','834','00','005010X220A1','962246','','2013-12-17','20:26:23',0,'2013-12-26 04:00:05',NULL,NULL),(1113,238,'25317','834','00','005010X220A1','25317','','2013-12-24','03:00:28',0,'2013-12-25 18:45:02',NULL,NULL),(14559,2519,'2220433','834','00','005010X220A1','2220433','','2014-01-13','12:00:14',0,'2014-01-14 01:32:40',NULL,NULL),(2010,330,'130878','834','00','005010X220A1','130878','','2013-12-09','18:00:04',0,'2013-12-25 19:35:11',NULL,NULL),(11543,1492,'1481493','834','00','005010X220A1','1481493','','2013-12-26','18:51:45',0,'2013-12-28 03:32:55',NULL,NULL),(4655,829,'1589701','834','00','005010X220A1','1589701','','2013-12-23','22:53:17',0,'2013-12-25 23:49:05',NULL,NULL),(3424,595,'71711','834','00','005010X220A1','71711','','2013-12-17','05:52:25',0,'2013-12-25 21:52:28',NULL,NULL),(18840,3491,'2919789','834','00','005010X220A1','2919789','','2014-02-10','21:20:10',0,'2014-02-11 21:01:45',NULL,NULL),(20985,3957,'3542027','834','00','005010X220A1','3542027','','2014-02-22','14:40:18',0,'2014-02-26 08:30:24',NULL,NULL),(6031,1143,'416253','834','00','005010X220A1','416253','','2013-11-17','10:12:35',0,'2013-12-26 02:45:54',NULL,NULL),(3850,685,'1173197','834','00','005010X220A1','1173197','','2013-11-08','15:52:48',0,'2013-12-25 22:30:36',NULL,NULL),(2387,414,'1254117','834','00','005010X220A1','1254117','','2013-12-06','00:26:19',0,'2013-12-25 20:16:49',NULL,NULL),(4113,733,'421840','834','00','005010X220A1','421840','','2013-12-19','13:07:09',0,'2013-12-25 23:03:35',NULL,NULL),(3990,726,'540750','834','00','005010X220A1','540750','','2013-12-07','14:26:51',0,'2013-12-25 22:47:56',NULL,NULL),(2782,506,'1407776','834','00','005010X220A1','1407776','','2013-12-22','04:17:59',0,'2013-12-25 21:19:43',NULL,NULL),(17240,3165,'1374716','834','00','005010X220A1','1374716','','2014-01-30','14:10:36',0,'2014-01-30 21:01:36',NULL,NULL),(19506,3621,'2055637','834','00','005010X220A1','2055637','','2014-02-14','17:34:20',0,'2014-02-14 21:30:30',NULL,NULL),(21039,3977,'3415792','834','00','005010X220A1','3415792','','2014-02-24','12:09:45',0,'2014-02-26 09:30:17',NULL,NULL),(13979,2323,'1265062','834','00','005010X220A1','1265062','','2014-01-09','15:19:54',0,'2014-01-13 02:20:41',NULL,NULL),(116,7,'975415','834','00','005010X220A1','975415','','2013-12-04','20:27:06',0,'2013-12-25 17:18:32',NULL,NULL),(11899,1561,'1469485','834','00','005010X220A1','1469485','','2013-12-29','15:29:38',0,'2013-12-30 00:00:58',NULL,NULL),(11890,1561,'2368701','834','00','005010X220A1','2368701','','2013-12-28','19:15:20',0,'2013-12-30 00:00:41',NULL,NULL),(5736,1069,'722452','834','00','005010X220A1','722452','','2013-12-14','17:59:39',0,'2013-12-26 02:01:30',NULL,NULL),(3650,625,'260939','834','00','005010X220A1','260939','','2013-12-11','22:01:10',0,'2013-12-25 22:05:55',NULL,NULL),(5286,979,'651166','834','00','005010X220A1','651166','','2013-11-16','11:12:14',0,'2013-12-26 01:00:55',NULL,NULL),(11430,1475,'1853665','834','00','005010X220A1','1853665','','2013-12-26','13:01:27',0,'2013-12-27 02:07:31',NULL,NULL),(10888,1409,'1233001','834','00','005010X220A1','1233001','','2013-12-22','20:41:13',0,'2013-12-26 13:07:13',NULL,NULL),(18022,3318,'2506650','834','00','005010X220A1','2506650','','2014-02-05','23:39:33',0,'2014-02-06 21:00:22',NULL,NULL),(19361,3586,'3095258','834','00','005010X220A1','3095258','','2014-02-13','08:44:58',0,'2014-02-13 22:02:00',NULL,NULL),(19524,3622,'3274936','834','00','005010X220A1','3274936','','2014-02-14','12:08:38',0,'2014-02-14 21:30:43',NULL,NULL),(19622,3639,'2173499','834','00','005010X220A1','2173499','','2014-02-14','16:59:03',0,'2014-02-14 21:31:54',NULL,NULL),(20616,3871,'3240681','834','00','005010X220A1','3240681','','2014-02-21','10:37:29',0,'2014-02-21 22:00:28',NULL,NULL),(14967,2569,'2267176','834','00','005010X220A1','2267176','','2014-01-14','10:55:18',0,'2014-01-15 02:08:00',NULL,NULL),(13585,2256,'2430404','834','00','005010X220A1','2430404','','2014-01-05','14:01:32',1,'2014-01-07 10:22:14',NULL,NULL),(191,16,'1285534','834','00','005010X220A1','1285534','','2013-12-05','12:43:40',0,'2013-12-25 17:20:56',NULL,NULL),(451,82,'1059208','834','00','005010X220A1','1059208','','2013-12-04','12:44:37',0,'2013-12-25 17:50:00',NULL,NULL),(907,177,'324219','834','00','005010X220A1','324219','','2013-12-03','14:14:27',0,'2013-12-25 18:17:18',NULL,NULL),(11147,1434,'104842','834','00','005010X220A1','104842','','2013-12-23','05:26:40',0,'2013-12-26 13:15:49',NULL,NULL),(12228,1617,'2325849','834','00','005010X220A1','2325849','','2014-01-01','15:53:33',1,'2014-01-02 04:22:33',NULL,NULL),(1408,247,'1556326','834','00','005010X220A1','1556326','','2013-12-24','14:34:58',0,'2013-12-25 18:54:17',NULL,NULL),(1643,283,'77943','834','00','005010X220A1','77943','','2013-11-20','10:03:28',0,'2013-12-25 19:02:16',NULL,NULL),(2498,444,'121013','834','00','005010X220A1','121013','','2013-12-06','13:53:08',0,'2013-12-25 20:20:30',NULL,NULL),(2389,414,'1040132','834','00','005010X220A1','1040132','','2013-12-06','12:00:51',0,'2013-12-25 20:16:52',NULL,NULL),(17336,3177,'1855710','834','00','005010X220A1','1855710','','2014-01-31','17:25:42',0,'2014-01-31 21:01:06',NULL,NULL),(20665,3878,'3502510','834','00','005010X220A1','3502510','','2014-02-21','11:14:23',0,'2014-02-21 22:01:03',NULL,NULL),(23003,4322,'3110702','834','00','005010X220A1','3110702','','2014-03-07','13:17:25',0,'2014-03-07 21:00:13',NULL,NULL),(14532,2518,'2080271','834','00','005010X220A1','2080271','','2014-01-13','11:30:28',0,'2014-01-14 01:32:23',NULL,NULL),(3501,615,'1183391','834','00','005010X220A1','1183391','','2013-12-12','14:36:09',0,'2013-12-25 22:01:14',NULL,NULL),(3459,611,'1123550','834','00','005010X220A1','1123550','','2013-12-17','13:41:24',0,'2013-12-25 21:53:37',NULL,NULL),(1779,299,'399529','834','00','005010X220A1','399529','','2013-12-09','19:46:43',0,'2013-12-25 19:18:55',NULL,NULL),(17350,3181,'2366132','834','00','005010X220A1','2366132','','2014-01-31','11:34:09',0,'2014-01-31 21:01:17',NULL,NULL),(21150,3997,'2876956','834','00','005010X220A1','2876956','','2014-02-26','10:22:55',0,'2014-02-26 21:00:43',NULL,NULL),(23032,4328,'3387285','834','00','005010X220A1','3387285','','2014-03-07','15:05:22',0,'2014-03-07 21:00:26',NULL,NULL),(15738,2712,'2034632','834','00','005010X220A1','2034632','','2014-01-20','15:25:19',0,'2014-01-21 08:46:11',NULL,NULL),(10832,1404,'1387920','834','00','005010X220A1','1387920','','2013-12-23','18:21:23',0,'2013-12-26 13:04:54',NULL,NULL),(1563,276,'996524','834','00','005010X220A1','996524','','2013-11-19','18:15:39',0,'2013-12-25 19:00:02',NULL,NULL),(13618,2270,'1433847','834','00','005010X220A1','1433847','','2014-01-06','19:34:58',0,'2014-01-08 18:23:57',NULL,NULL),(19867,3708,'2333387','834','00','005010X220A1','2333387','','2014-02-15','19:30:30',0,'2014-02-16 19:00:14',NULL,NULL),(20302,3794,'2720209','834','00','005010X220A1','2720209','','2014-02-19','12:55:08',0,'2014-02-20 04:43:47',NULL,NULL),(21038,3977,'3222608','834','00','005010X220A1','3222608','','2014-02-24','09:30:42',0,'2014-02-26 09:30:16',NULL,NULL),(21431,4027,'3043112','834','00','005010X220A1','3043112','','2014-02-27','10:08:11',0,'2014-02-28 06:30:49',NULL,NULL),(300,70,'620425','834','00','005010X220A1','620425','','2013-12-03','20:45:50',0,'2013-12-25 17:45:13',NULL,NULL),(16873,3093,'1689032','834','00','005010X220A1','1689032','','2014-01-28','15:25:54',0,'2014-01-28 21:00:55',NULL,NULL),(1233,243,'201832','834','00','005010X220A1','201832','','2013-12-24','10:27:23',0,'2013-12-25 18:48:45',NULL,NULL),(10850,1405,'1668309','834','00','005010X220A1','1668309','','2013-12-23','18:35:45',0,'2013-12-26 13:05:30',NULL,NULL),(2292,396,'552221','834','00','005010X220A1','552221','','2013-11-24','11:02:39',0,'2013-12-25 20:00:54',NULL,NULL),(14171,2364,'1939778','834','00','005010X220A1','1939778','','2014-01-09','18:53:39',0,'2014-01-13 02:23:21',NULL,NULL),(12957,1734,'1625657','834','00','005010X220A1','1625657','','2014-01-03','20:16:04',0,'2014-01-05 00:00:36',NULL,NULL),(7080,1236,'464023','834','00','005010X220A1','464023','','2013-12-18','09:54:42',0,'2013-12-26 04:03:00',NULL,NULL),(5050,936,'53242','834','00','005010X220A1','53242','','2013-12-10','23:13:52',0,'2013-12-26 00:47:34',NULL,NULL),(22290,4201,'3466908','834','00','005010X220A1','3466908','','2014-03-03','18:04:41',0,'2014-03-04 21:00:51',NULL,NULL),(23617,4441,'3197535','834','00','005010X220A1','3197535','','2014-03-10','09:01:24',0,'2014-03-10 21:01:28',NULL,NULL),(23756,4476,'3659072','834','00','005010X220A1','3659072','','2014-03-10','11:31:20',0,'2014-03-10 21:30:07',NULL,NULL),(10410,1400,'766450','834','00','005010X220A1','766450','','2013-12-23','09:17:54',0,'2013-12-26 12:50:59',NULL,NULL),(1239,243,'74764','834','00','005010X220A1','74764','','2013-12-24','10:56:15',0,'2013-12-25 18:48:53',NULL,NULL),(1259,243,'316100','834','00','005010X220A1','316100','','2013-12-24','13:11:29',0,'2013-12-25 18:49:29',NULL,NULL),(3642,623,'1266555','834','00','005010X220A1','1266555','','2013-12-11','19:22:55',0,'2013-12-25 22:05:40',NULL,NULL),(11967,1580,'2035131','834','00','005010X220A1','2035131','','2013-12-30','12:44:58',0,'2014-01-01 12:00:50',NULL,NULL),(13017,1745,'2402851','834','00','005010X220A1','2402851','','2014-01-04','12:12:50',0,'2014-01-05 00:02:51',NULL,NULL),(17426,3202,'2163100','834','00','005010X220A1','2163100','','2014-02-01','15:19:51',0,'2014-02-01 19:00:26',NULL,NULL),(17793,3270,'1497816','834','00','005010X220A1','1497816','','2014-02-04','09:51:42',0,'2014-02-04 21:01:27',NULL,NULL),(18028,3318,'2416041','834','00','005010X220A1','2416041','','2014-02-06','14:58:36',0,'2014-02-06 21:00:27',NULL,NULL),(18681,3469,'1801710','834','00','005010X220A1','1801710','','2014-02-10','14:06:11',0,'2014-02-10 21:31:59',NULL,NULL),(22282,4200,'2743091','834','00','005010X220A1','2743091','','2014-03-04','16:06:02',0,'2014-03-04 21:00:45',NULL,NULL),(22965,4312,'3807901','834','00','005010X220A1','3807901','','2014-03-06','16:36:42',0,'2014-03-06 21:30:07',NULL,NULL),(23459,4412,'3290887','834','00','005010X220A1','3290887','','2014-03-09','10:45:12',0,'2014-03-09 21:00:59',NULL,NULL),(15755,2714,'2004398','834','00','005010X220A1','2004398','','2014-01-20','09:11:54',0,'2014-01-21 08:46:20',NULL,NULL),(11474,1488,'1360182','834','00','005010X220A1','1360182','','2013-12-27','14:15:00',0,'2013-12-28 03:30:52',NULL,NULL),(1536,261,'1812019','834','00','005010X220A1','1812019','','2013-12-24','13:44:28',0,'2013-12-25 18:58:30',NULL,NULL),(15359,2623,'1513783','834','00','005010X220A1','1513783','','2014-01-16','17:00:17',0,'2014-01-17 03:35:27',NULL,NULL),(14307,2391,'1589219','834','00','005010X220A1','1589219','','2014-01-10','14:05:18',0,'2014-01-13 03:00:35',NULL,NULL),(7640,1309,'905353','834','00','005010X220A1','905353','','2013-12-21','14:08:02',0,'2013-12-26 04:38:31',NULL,NULL),(7011,1235,'62304','834','00','005010X220A1','62304','','2013-12-18','06:15:31',0,'2013-12-26 04:00:51',NULL,NULL),(13200,2044,'0001','999','BE','005010X231A1','1062790','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:52',NULL,NULL),(3608,619,'823690','834','00','005010X220A1','823690','','2013-12-12','12:24:03',0,'2013-12-25 22:04:36',NULL,NULL),(5502,1041,'1483617','834','00','005010X220A1','1483617','','2013-12-24','20:00:04',0,'2013-12-26 01:46:29',NULL,NULL),(17427,3202,'2233610','834','00','005010X220A1','2233610','','2014-02-01','12:22:52',0,'2014-02-01 19:00:26',NULL,NULL),(18211,3356,'2981217','834','00','005010X220A1','2981217','','2014-02-06','22:05:17',0,'2014-02-07 19:00:41',NULL,NULL),(19182,3569,'2717332','834','00','005010X220A1','2717332','','2014-02-12','21:11:08',0,'2014-02-13 21:30:04',NULL,NULL),(20814,3910,'2707762','834','00','005010X220A1','2707762','','2014-02-25','13:42:59',0,'2014-02-25 21:31:05',NULL,NULL),(12192,1606,'47607','834','00','005010X220A1','47607','','2013-12-30','13:22:18',0,'2014-01-01 12:09:02',NULL,NULL),(10946,1410,'666582','834','00','005010X220A1','666582','','2013-12-23','16:18:01',0,'2013-12-26 13:09:06',NULL,NULL),(3013,543,'1155099','834','00','005010X220A1','1155099','','2013-12-13','12:54:26',0,'2013-12-25 21:33:31',NULL,NULL),(3092,546,'856656','834','00','005010X220A1','856656','','2013-12-12','20:41:53',0,'2013-12-25 21:35:57',NULL,NULL),(3788,656,'734663','834','00','005010X220A1','734663','','2013-12-08','16:42:27',0,'2013-12-25 22:15:54',NULL,NULL),(10827,1404,'688646','834','00','005010X220A1','688646','','2013-12-23','17:37:41',0,'2013-12-26 13:04:45',NULL,NULL),(5747,1070,'366028','834','00','005010X220A1','366028','','2013-12-14','15:33:30',0,'2013-12-26 02:01:48',NULL,NULL),(19973,3746,'3613516','834','00','005010X220A1','3613516','','2014-02-18','13:37:15',0,'2014-02-18 22:00:13',NULL,NULL),(20610,3871,'2348945','834','00','005010X220A1','2348945','','2014-02-20','23:24:45',0,'2014-02-21 22:00:24',NULL,NULL),(23620,4441,'2872412','834','00','005010X220A1','2872412','','2014-03-10','10:24:48',0,'2014-03-10 21:01:30',NULL,NULL),(681,109,'1129932','834','00','005010X220A1','1129932','','2013-12-16','15:00:00',0,'2013-12-25 18:06:07',NULL,NULL),(804,154,'486090','834','00','005010X220A1','486090','','2013-10-29','08:24:41',0,'2013-12-25 18:10:19',NULL,NULL),(1523,260,'1081317','834','00','005010X220A1','1081317','','2013-12-24','11:14:17',0,'2013-12-25 18:58:10',NULL,NULL),(11372,1460,'158253','834','00','005010X220A1','158253','','2013-12-26','11:41:13',0,'2013-12-27 02:05:42',NULL,NULL),(7729,1342,'676619','834','00','005010X220A1','676619','','2013-10-20','17:18:25',0,'2013-12-26 05:00:11',NULL,NULL),(2931,541,'169578','834','00','005010X220A1','169578','','2013-12-12','20:29:12',0,'2013-12-25 21:30:57',NULL,NULL),(3259,579,'1043049','834','00','005010X220A1','1043049','','2013-12-17','11:47:07',0,'2013-12-25 21:47:06',NULL,NULL),(16009,2767,'1498891','834','00','005010X220A1','1498891','','2014-01-22','09:12:01',0,'2014-01-23 03:02:17',NULL,NULL),(11657,1500,'1688255','834','00','005010X220A1','1688255','','2013-12-27','12:11:22',0,'2013-12-28 03:36:30',NULL,NULL),(5474,1040,'2114028','834','00','005010X220A1','2114028','','2013-12-24','22:31:38',0,'2013-12-26 01:45:34',NULL,NULL),(17671,3259,'1762578','834','00','005010X220A1','1762578','','2014-02-03','20:33:38',0,'2014-02-04 21:00:12',NULL,NULL),(23699,4451,'3883114','834','00','005010X220A1','3883114','','2014-03-10','10:28:10',0,'2014-03-10 21:02:27',NULL,NULL),(638,108,'107141','834','00','005010X220A1','107141','','2013-12-16','12:37:05',0,'2013-12-25 18:04:50',NULL,NULL),(14928,2560,'2310279','834','00','005010X220A1','2310279','','2014-01-13','20:21:34',0,'2014-01-15 02:07:42',NULL,NULL),(11382,1462,'2156700','834','00','005010X220A1','2156700','','2013-12-26','14:00:08',0,'2013-12-27 02:05:59',NULL,NULL),(14849,2553,'1584695','834','00','005010X220A1','1584695','','2014-01-14','13:17:24',0,'2014-01-15 02:07:06',NULL,NULL),(12357,1634,'1599898','834','00','005010X220A1','1599898','','2013-12-31','14:39:43',1,'2014-01-02 04:28:06',NULL,NULL),(11841,1544,'133041','834','00','005010X220A1','133041','','2013-12-28','20:10:03',1,'2013-12-29 11:14:26',NULL,NULL),(3534,616,'886234','834','00','005010X220A1','886234','','2013-12-12','09:35:37',0,'2013-12-25 22:02:17',NULL,NULL),(3771,655,'1023575','834','00','005010X220A1','1023575','','2013-12-07','18:21:42',0,'2013-12-25 22:15:22',NULL,NULL),(20384,3825,'2910494','834','00','005010X220A1','2910494','','2014-02-19','10:59:05',0,'2014-02-20 05:38:23',NULL,NULL),(21215,3998,'3487704','834','00','005010X220A1','3487704','','2014-02-26','16:41:43',0,'2014-02-26 21:01:27',NULL,NULL),(21774,4090,'2932551','834','00','005010X220A1','2932551','','2014-02-28','17:37:09',0,'2014-02-28 21:31:02',NULL,NULL),(21962,4142,'3415997','834','00','005010X220A1','3415997','','2014-03-01','19:19:49',0,'2014-03-03 01:00:03',NULL,NULL),(23588,4437,'2902879','834','00','005010X220A1','2902879','','2014-03-10','09:31:20',0,'2014-03-10 21:01:09',NULL,NULL),(16223,2915,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:28:00',0,'2014-01-23 06:19:21',NULL,NULL),(1327,245,'600452','834','00','005010X220A1','600452','','2013-12-24','11:32:28',0,'2013-12-25 18:51:40',NULL,NULL),(10587,1402,'420737','834','00','005010X220A1','420737','','2013-12-23','12:14:11',0,'2013-12-26 12:56:44',NULL,NULL),(16087,2780,'2420707','834','00','005010X220A1','2420707','','2014-01-22','11:21:16',0,'2014-01-23 03:02:53',NULL,NULL),(14189,2365,'1893795','834','00','005010X220A1','1893795','','2014-01-10','11:27:44',0,'2014-01-13 02:23:36',NULL,NULL),(13140,1984,'0001','999','BE','005010X231A1','165514','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:05',NULL,NULL),(12446,1638,'1730430','834','00','005010X220A1','1730430','','2013-12-31','16:32:33',1,'2014-01-02 04:31:21',NULL,NULL),(12074,1586,'2231564','834','00','005010X220A1','2231564','','2013-12-30','10:42:54',0,'2014-01-01 12:04:49',NULL,NULL),(18762,3485,'2529253','834','00','005010X220A1','2529253','','2014-02-11','17:13:00',0,'2014-02-11 21:00:47',NULL,NULL),(21443,4027,'3714746','834','00','005010X220A1','3714746','','2014-02-27','17:57:03',0,'2014-02-28 06:30:55',NULL,NULL),(22731,4276,'2966943','834','00','005010X220A1','2966943','','2014-03-05','21:14:03',0,'2014-03-06 21:00:15',NULL,NULL),(16789,3086,'2568822','834','00','005010X220A1','2568822','','2014-01-27','16:49:30',0,'2014-01-27 21:01:49',NULL,NULL),(15644,2679,'1821608','834','00','005010X220A1','1821608','','2014-01-17','19:33:49',0,'2014-01-21 08:44:20',NULL,NULL),(5056,936,'901032','834','00','005010X220A1','901032','','2013-12-11','09:36:31',0,'2013-12-26 00:47:48',NULL,NULL),(4284,742,'566307','834','00','005010X220A1','566307','','2013-12-19','18:21:47',0,'2013-12-25 23:08:49',NULL,NULL),(3509,615,'1236678','834','00','005010X220A1','1236678','','2013-12-12','15:52:05',0,'2013-12-25 22:01:30',NULL,NULL),(3419,593,'331401','834','00','005010X220A1','331401','','2013-12-16','22:35:08',0,'2013-12-25 21:52:18',NULL,NULL),(12353,1634,'2022623','834','00','005010X220A1','2022623','','2013-12-31','13:58:14',1,'2014-01-02 04:27:59',NULL,NULL),(13953,2320,'2404070','834','00','005010X220A1','2404070','','2014-01-09','18:11:38',0,'2014-01-13 02:20:22',NULL,NULL),(14809,2552,'1367776','834','00','005010X220A1','1367776','','2014-01-13','20:03:37',0,'2014-01-15 02:06:48',NULL,NULL),(20362,3821,'3232040','834','00','005010X220A1','3232040','','2014-02-18','22:07:41',0,'2014-02-20 05:30:26',NULL,NULL),(11397,1464,'1586503','834','00','005010X220A1','1586503','','2013-12-26','17:24:47',0,'2013-12-27 02:06:27',NULL,NULL),(1188,239,'1918862','834','00','005010X220A1','1918862','','2013-12-24','16:52:16',0,'2013-12-25 18:47:24',NULL,NULL),(17261,3170,'2556277','834','00','005010X220A1','2556277','','2014-01-31','09:41:49',0,'2014-01-31 21:00:14',NULL,NULL),(17249,3170,'1792738','834','00','005010X220A1','1792738','','2014-01-30','18:44:58',0,'2014-01-31 21:00:06',NULL,NULL),(13002,1740,'1442463','834','00','005010X220A1','1442463','','2014-01-04','07:03:36',0,'2014-01-05 00:02:10',NULL,NULL),(12939,1730,'243964','834','00','005010X220A1','243964','','2014-01-03','18:33:58',0,'2014-01-04 06:00:05',NULL,NULL),(5064,936,'267043','834','00','005010X220A1','267043','','2013-12-11','11:11:09',0,'2013-12-26 00:48:02',NULL,NULL),(19286,3582,'3163889','834','00','005010X220A1','3163889','','2014-02-13','14:12:17',0,'2014-02-13 22:01:02',NULL,NULL),(17109,3142,'2238163','834','00','005010X220A1','2238163','','2014-01-30','12:51:53',0,'2014-01-30 21:00:12',NULL,NULL),(6266,1172,'1057308','834','00','005010X220A1','1057308','','2013-12-20','08:57:42',0,'2013-12-26 03:06:24',NULL,NULL),(4152,734,'589011','834','00','005010X220A1','589011','','2013-12-18','19:06:54',0,'2013-12-25 23:04:43',NULL,NULL),(3457,610,'995720','834','00','005010X220A1','995720','','2013-12-17','13:29:16',0,'2013-12-25 21:53:35',NULL,NULL),(20598,3870,'2802049','834','00','005010X220A1','2802049','','2014-02-21','12:11:31',0,'2014-02-21 22:00:13',NULL,NULL),(23160,4344,'3018581','834','00','005010X220A1','3018581','','2014-03-07','10:29:25',0,'2014-03-07 21:31:18',NULL,NULL),(23612,4441,'2853350','834','00','005010X220A1','2853350','','2014-03-09','20:23:54',0,'2014-03-10 21:01:24',NULL,NULL),(16078,2776,'2011548','834','00','005010X220A1','2011548','','2014-01-22','10:01:15',0,'2014-01-23 03:02:49',NULL,NULL),(15880,2739,'2284883','834','00','005010X220A1','2284883','','2014-01-21','16:38:57',1,'2014-01-22 03:22:28',NULL,NULL),(7589,1302,'492313','834','00','005010X220A1','492313','','2013-12-20','19:13:23',0,'2013-12-26 04:36:58',NULL,NULL),(13690,2273,'1632124','834','00','005010X220A1','1632124','','2014-01-06','22:31:55',0,'2014-01-08 18:24:25',NULL,NULL),(7277,1254,'897462','834','00','005010X220A1','897462','','2013-12-18','13:42:01',0,'2013-12-26 04:09:01',NULL,NULL),(12767,1700,'2091453','834','00','005010X220A1','2091453','','2014-01-02','17:52:32',0,'2014-01-03 02:07:23',NULL,NULL),(18282,3379,'1528545','834','00','005010X220A1','1528545','','2014-02-07','18:40:35',0,'2014-02-08 19:00:23',NULL,NULL),(19134,3548,'3169675','834','00','005010X220A1','3169675','','2014-02-12','15:11:55',0,'2014-02-12 21:31:59',NULL,NULL),(19274,3582,'2374446','834','00','005010X220A1','2374446','','2014-02-12','23:32:50',0,'2014-02-13 22:00:54',NULL,NULL),(20102,3771,'3307451','834','00','005010X220A1','3307451','','2014-02-18','19:48:19',0,'2014-02-20 03:42:14',NULL,NULL),(722,121,'1067073','834','00','005010X220A1','1067073','','2013-12-16','09:53:04',0,'2013-12-25 18:07:29',NULL,NULL),(13443,2223,'1536701','834','00','005010X220A1','1536701','','2014-01-06','09:27:32',0,'2014-01-07 04:02:29',NULL,NULL),(2830,510,'817553','834','00','005010X220A1','817553','','2013-12-22','13:05:15',0,'2013-12-25 21:21:17',NULL,NULL),(10767,1404,'1352612','834','00','005010X220A1','1352612','','2013-12-22','21:55:37',0,'2013-12-26 13:02:49',NULL,NULL),(12440,1638,'2433521','834','00','005010X220A1','2433521','','2013-12-31','15:53:20',1,'2014-01-02 04:31:08',NULL,NULL),(10603,1402,'947236','834','00','005010X220A1','947236','','2013-12-23','13:07:34',0,'2013-12-26 12:57:17',NULL,NULL),(11046,1418,'1742424','834','00','005010X220A1','1742424','','2013-12-23','14:12:53',0,'2013-12-26 13:12:19',NULL,NULL),(5301,986,'386637','834','00','005010X220A1','386637','','2013-11-05','05:21:14',0,'2013-12-26 01:01:28',NULL,NULL),(5096,940,'1062927','834','00','005010X220A1','1062927','','2013-12-11','11:58:52',0,'2013-12-26 00:49:03',NULL,NULL),(4498,805,'204588','834','00','005010X220A1','204588','','2013-11-25','20:20:34',0,'2013-12-25 23:32:00',NULL,NULL),(17411,3199,'1922243','834','00','005010X220A1','1922243','','2014-02-01','12:59:30',0,'2014-02-01 19:00:17',NULL,NULL),(14276,2375,'2534803','834','00','005010X220A1','2534803','','2014-01-10','17:15:07',0,'2014-01-13 03:00:13',NULL,NULL),(484,100,'1049219','834','00','005010X220A1','1049219','','2013-12-04','17:15:16',0,'2013-12-25 17:51:07',NULL,NULL),(13898,2313,'2392478','834','00','005010X220A1','2392478','','2014-01-08','18:36:52',0,'2014-01-13 02:19:44',NULL,NULL),(11028,1417,'190100','834','00','005010X220A1','190100','','2013-12-22','19:01:20',0,'2013-12-26 13:11:44',NULL,NULL),(5519,1041,'1892414','834','00','005010X220A1','1892414','','2013-12-24','21:01:58',0,'2013-12-26 01:46:58',NULL,NULL),(3549,616,'835809','834','00','005010X220A1','835809','','2013-12-12','14:26:27',0,'2013-12-25 22:02:44',NULL,NULL),(4302,749,'157755','834','00','005010X220A1','157755','','2013-12-19','01:16:34',0,'2013-12-25 23:09:22',NULL,NULL),(18907,3508,'1553365','834','00','005010X220A1','1553365','','2014-02-11','11:13:14',0,'2014-02-11 21:02:44',NULL,NULL),(19390,3593,'2596978','834','00','005010X220A1','2596978','','2014-02-13','04:57:02',0,'2014-02-13 22:02:22',NULL,NULL),(22954,4309,'2854494','834','00','005010X220A1','2854494','','2014-03-06','16:11:04',0,'2014-03-06 21:02:58',NULL,NULL),(23157,4344,'3452725','834','00','005010X220A1','3452725','','2014-03-06','22:21:07',0,'2014-03-07 21:31:15',NULL,NULL),(23323,4383,'3432735','834','00','005010X220A1','3432735','','2014-03-08','15:17:01',0,'2014-03-08 21:30:38',NULL,NULL),(1151,239,'952219','834','00','005010X220A1','952219','','2013-12-24','10:44:35',0,'2013-12-25 18:46:13',NULL,NULL),(1740,293,'416544','834','00','005010X220A1','416544','','2013-12-10','13:26:36',0,'2013-12-25 19:17:41',NULL,NULL),(10844,1405,'1357450','834','00','005010X220A1','1357450','','2013-12-22','18:56:30',0,'2013-12-26 13:05:17',NULL,NULL),(14741,2550,'2022972','834','00','005010X220A1','2022972','','2014-01-14','15:49:24',0,'2014-01-15 02:06:19',NULL,NULL),(14096,2343,'1507196','834','00','005010X220A1','1507196','','2014-01-07','19:48:01',0,'2014-01-13 02:22:07',NULL,NULL),(2493,441,'621700','834','00','005010X220A1','621700','','2013-12-06','15:42:38',0,'2013-12-25 20:20:19',NULL,NULL),(3988,724,'849584','834','00','005010X220A1','849584','','2013-12-07','11:55:14',0,'2013-12-25 22:47:51',NULL,NULL),(12768,1701,'1862193','834','00','005010X220A1','1862193','','2014-01-02','17:53:48',0,'2014-01-03 02:07:26',NULL,NULL),(17099,3142,'1895725','834','00','005010X220A1','1895725','','2014-01-29','20:35:46',0,'2014-01-30 21:00:06',NULL,NULL),(19512,3622,'3294038','834','00','005010X220A1','3294038','','2014-02-13','19:16:46',0,'2014-02-14 21:30:34',NULL,NULL),(20026,3750,'2705370','834','00','005010X220A1','2705370','','2014-02-18','13:52:05',0,'2014-02-18 22:00:50',NULL,NULL),(20576,3866,'2587238','834','00','005010X220A1','2587238','','2014-02-21','12:01:43',0,'2014-02-21 21:30:20',NULL,NULL),(21179,3998,'3551059','834','00','005010X220A1','3551059','','2014-02-26','11:41:00',0,'2014-02-26 21:01:03',NULL,NULL),(21578,4055,'3604262','834','00','005010X220A1','3604262','','2014-02-26','15:30:41',0,'2014-02-28 07:00:19',NULL,NULL),(6345,1178,'425053','834','00','005010X220A1','425053','','2013-12-19','23:01:22',0,'2013-12-26 03:08:46',NULL,NULL),(424,77,'448227','834','00','005010X220A1','448227','','2013-12-04','16:38:41',0,'2013-12-25 17:49:08',NULL,NULL),(15841,2737,'1679471','834','00','005010X220A1','1679471','','2014-01-21','16:15:00',1,'2014-01-22 03:22:03',NULL,NULL),(4329,752,'751965','834','00','005010X220A1','751965','','2013-12-19','06:38:27',0,'2013-12-25 23:10:07',NULL,NULL),(955,181,'1081772','834','00','005010X220A1','1081772','','2013-12-03','14:25:01',0,'2013-12-25 18:18:48',NULL,NULL),(2272,390,'877929','834','00','005010X220A1','877929','','2013-10-15','02:32:09',0,'2013-12-25 20:00:13',NULL,NULL),(18906,3507,'2693750','834','00','005010X220A1','2693750','','2014-02-11','11:02:53',0,'2014-02-11 21:02:43',NULL,NULL),(20242,3792,'3539395','834','00','005010X220A1','3539395','','2014-02-18','23:03:10',0,'2014-02-20 04:30:33',NULL,NULL),(23469,4418,'3851146','834','00','005010X220A1','3851146','','2014-03-09','16:26:54',0,'2014-03-09 21:01:08',NULL,NULL),(13930,2317,'2456473','834','00','005010X220A1','2456473','','2014-01-09','08:48:20',0,'2014-01-13 02:20:06',NULL,NULL),(372,73,'1094424','834','00','005010X220A1','1094424','','2013-12-04','11:59:16',0,'2013-12-25 17:47:28',NULL,NULL),(462,86,'473850','834','00','005010X220A1','473850','','2013-12-04','14:45:41',0,'2013-12-25 17:50:22',NULL,NULL),(15003,2584,'1921862','834','00','005010X220A1','1921862','','2014-01-14','21:59:31',0,'2014-01-16 08:44:19',NULL,NULL),(1130,238,'1711360','834','00','005010X220A1','1711360','','2013-12-24','15:27:35',0,'2013-12-25 18:45:34',NULL,NULL),(5585,1043,'1504111','834','00','005010X220A1','1504111','','2013-12-24','23:39:13',0,'2013-12-26 01:49:10',NULL,NULL),(14712,2550,'1525230','834','00','005010X220A1','1525230','','2014-01-14','10:36:47',0,'2014-01-15 02:06:07',NULL,NULL),(2711,502,'730535','834','00','005010X220A1','730535','','2013-12-22','18:09:16',0,'2013-12-25 21:17:32',NULL,NULL),(12109,1587,'1474223','834','00','005010X220A1','1474223','','2013-12-30','12:33:09',0,'2014-01-01 12:06:01',NULL,NULL),(5327,1002,'12621','834','00','005010X220A1','12621','','2013-11-25','13:01:14',0,'2013-12-26 01:15:05',NULL,NULL),(4256,741,'19924','834','00','005010X220A1','19924','','2013-12-19','10:48:14',0,'2013-12-25 23:08:00',NULL,NULL),(4989,935,'139739','834','00','005010X220A1','139739','','2013-12-11','00:25:45',0,'2013-12-26 00:45:37',NULL,NULL),(17039,3120,'1358598','834','00','005010X220A1','1358598','','2014-01-29','17:57:40',0,'2014-01-29 21:01:19',NULL,NULL),(18843,3491,'3087324','834','00','005010X220A1','3087324','','2014-02-11','10:40:53',0,'2014-02-11 21:01:47',NULL,NULL),(20420,3836,'3347674','834','00','005010X220A1','3347674','','2014-02-20','16:08:20',0,'2014-02-20 21:30:19',NULL,NULL),(22059,4168,'3533983','834','00','005010X220A1','3533983','','2014-03-03','14:13:25',0,'2014-03-03 21:00:16',NULL,NULL),(23211,4347,'3632357','834','00','005010X220A1','3632357','','2014-03-07','14:33:31',0,'2014-03-07 21:31:53',NULL,NULL),(23246,4365,'2851002','834','00','005010X220A1','2851002','','2014-03-07','14:39:46',0,'2014-03-07 21:32:20',NULL,NULL),(23614,4441,'3351916','834','00','005010X220A1','3351916','','2014-03-09','23:23:26',0,'2014-03-10 21:01:25',NULL,NULL),(10373,1400,'881803','834','00','005010X220A1','881803','','2013-12-22','19:34:35',0,'2013-12-26 12:49:53',NULL,NULL),(328,72,'431463','834','00','005010X220A1','431463','','2013-12-03','20:32:17',0,'2013-12-25 17:46:05',NULL,NULL),(16725,3064,'2303078','834','00','005010X220A1','2303078','','2014-01-27','17:21:53',0,'2014-01-27 21:01:00',NULL,NULL),(5486,1040,'2119867','834','00','005010X220A1','2119867','','2013-12-25','00:35:17',0,'2013-12-26 01:45:56',NULL,NULL),(5026,935,'798051','834','00','005010X220A1','798051','','2013-12-11','12:17:56',0,'2013-12-26 00:46:48',NULL,NULL),(16273,2965,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:00:00',0,'2014-01-23 11:30:03',NULL,NULL),(2912,540,'667279','834','00','005010X220A1','667279','','2013-12-13','12:39:41',0,'2013-12-25 21:30:19',NULL,NULL),(2488,437,'1006590','834','00','005010X220A1','1006590','','2013-12-06','07:55:44',0,'2013-12-25 20:20:08',NULL,NULL),(11475,1488,'1290903','834','00','005010X220A1','1290903','','2013-12-27','14:19:09',0,'2013-12-28 03:30:54',NULL,NULL),(12893,1709,'2119048','834','00','005010X220A1','2119048','','2014-01-03','10:19:28',0,'2014-01-04 02:04:38',NULL,NULL),(13707,2275,'2333831','834','00','005010X220A1','2333831','','2014-01-06','18:39:52',0,'2014-01-08 18:24:32',NULL,NULL),(13664,2271,'1984344','834','00','005010X220A1','1984344','','2014-01-07','11:30:06',0,'2014-01-08 18:24:15',NULL,NULL),(21152,3997,'3488861','834','00','005010X220A1','3488861','','2014-02-26','11:10:00',0,'2014-02-26 21:00:44',NULL,NULL),(23065,4339,'3857514','834','00','005010X220A1','3857514','','2014-03-07','00:39:50',0,'2014-03-07 21:30:09',NULL,NULL),(11073,1421,'1287752','834','00','005010X220A1','1287752','','2013-12-23','14:29:55',0,'2013-12-26 13:13:12',NULL,NULL),(518,102,'670777','834','00','005010X220A1','670777','','2013-12-16','12:40:14',0,'2013-12-25 18:01:00',NULL,NULL),(1045,204,'157167','834','00','005010X220A1','157167','','2013-11-29','12:20:57',0,'2013-12-25 18:30:08',NULL,NULL),(13562,2253,'2260263','834','00','005010X220A1','2260263','','2014-01-05','12:14:46',1,'2014-01-07 10:21:16',NULL,NULL),(12559,1659,'2335177','834','00','005010X220A1','2335177','','2013-12-31','14:34:14',1,'2014-01-02 04:35:37',NULL,NULL),(4913,909,'735454','834','00','005010X220A1','735454','','2013-10-15','22:57:09',0,'2013-12-26 00:30:34',NULL,NULL),(1381,245,'130365','834','00','005010X220A1','130365','','2013-12-24','16:38:49',0,'2013-12-25 18:53:23',NULL,NULL),(19966,3746,'2625349','834','00','005010X220A1','2625349','','2014-02-18','11:30:17',0,'2014-02-18 22:00:09',NULL,NULL),(20446,3841,'3428503','834','00','005010X220A1','3428503','','2014-02-20','16:45:37',0,'2014-02-20 22:00:19',NULL,NULL),(20999,3960,'2770248','834','00','005010X220A1','2770248','','2014-02-22','10:32:13',0,'2014-02-26 08:30:37',NULL,NULL),(10912,1410,'1418352','834','00','005010X220A1','1418352','','2013-12-22','19:47:23',0,'2013-12-26 13:08:02',NULL,NULL),(15474,2634,'1802505','834','00','005010X220A1','1802505','','2014-01-16','00:01:34',0,'2014-01-17 03:36:20',NULL,NULL),(14066,2339,'2054694','834','00','005010X220A1','2054694','','2014-01-08','12:49:09',0,'2014-01-13 02:21:47',NULL,NULL),(12819,1704,'1551047','834','00','005010X220A1','1551047','','2014-01-02','21:24:15',0,'2014-01-04 02:01:57',NULL,NULL),(5469,1040,'1528901','834','00','005010X220A1','1528901','','2013-12-24','21:34:00',0,'2013-12-26 01:45:25',NULL,NULL),(6250,1172,'9136','834','00','005010X220A1','9136','','2013-12-19','20:08:39',0,'2013-12-26 03:05:55',NULL,NULL),(6362,1181,'39713','834','00','005010X220A1','39713','','2013-12-20','15:20:45',0,'2013-12-26 03:09:15',NULL,NULL),(2770,506,'1407770','834','00','005010X220A1','1407770','','2013-12-21','21:19:45',0,'2013-12-25 21:19:21',NULL,NULL),(11052,1419,'821613','834','00','005010X220A1','821613','','2013-12-22','20:12:55',0,'2013-12-26 13:12:30',NULL,NULL),(373,74,'292596','834','00','005010X220A1','292596','','2013-12-03','18:40:23',0,'2013-12-25 17:47:30',NULL,NULL),(2920,541,'898287','834','00','005010X220A1','898287','','2013-12-12','18:39:45',0,'2013-12-25 21:30:33',NULL,NULL),(10941,1410,'541499','834','00','005010X220A1','541499','','2013-12-23','14:30:29',0,'2013-12-26 13:08:57',NULL,NULL),(13472,2226,'1398531','834','00','005010X220A1','1398531','','2014-01-06','10:22:42',0,'2014-01-07 04:03:33',NULL,NULL),(5228,955,'916763','834','00','005010X220A1','916763','','2013-12-11','00:54:02',0,'2013-12-26 00:53:20',NULL,NULL),(19356,3585,'2861383','834','00','005010X220A1','2861383','','2014-02-13','12:56:03',0,'2014-02-13 22:01:57',NULL,NULL),(19950,3741,'2847638','834','00','005010X220A1','2847638','','2014-02-18','15:48:33',0,'2014-02-18 21:30:18',NULL,NULL),(20008,3748,'3357275','834','00','005010X220A1','3357275','','2014-02-18','16:05:53',0,'2014-02-18 22:00:38',NULL,NULL),(22728,4276,'3208258','834','00','005010X220A1','3208258','','2014-03-05','19:24:42',0,'2014-03-06 21:00:13',NULL,NULL),(23499,4434,'2791970','834','00','005010X220A1','2791970','','2014-03-09','21:01:13',0,'2014-03-10 21:00:02',NULL,NULL),(1956,326,'1189491','834','00','005010X220A1','1189491','','2013-12-09','12:52:20',0,'2013-12-25 19:33:24',NULL,NULL),(17406,3198,'2320840','834','00','005010X220A1','2320840','','2014-02-01','14:03:24',0,'2014-02-01 19:00:13',NULL,NULL),(2412,415,'630417','834','00','005010X220A1','630417','','2013-12-06','12:55:52',0,'2013-12-25 20:17:37',NULL,NULL),(12395,1637,'2036605','834','00','005010X220A1','2036605','','2013-12-31','11:48:53',1,'2014-01-02 04:29:29',NULL,NULL),(13467,2226,'2450169','834','00','005010X220A1','2450169','','2014-01-05','23:18:20',0,'2014-01-07 04:03:24',NULL,NULL),(13816,2298,'1706429','834','00','005010X220A1','1706429','','2014-01-10','19:08:23',0,'2014-01-13 02:18:26',NULL,NULL),(18649,3464,'2313343','834','00','005010X220A1','2313343','','2014-02-10','10:30:10',0,'2014-02-10 21:31:39',NULL,NULL),(19743,3673,'3353682','834','00','005010X220A1','3353682','','2014-02-15','11:27:25',0,'2014-02-15 22:00:38',NULL,NULL),(20431,3840,'3062816','834','00','005010X220A1','3062816','','2014-02-20','16:35:19',0,'2014-02-20 22:00:07',NULL,NULL),(22843,4279,'3034627','834','00','005010X220A1','3034627','','2014-03-05','19:24:23',0,'2014-03-06 21:01:34',NULL,NULL),(23576,4436,'2896101','834','00','005010X220A1','2896101','','2014-03-10','15:31:47',0,'2014-03-10 21:01:00',NULL,NULL),(15594,2659,'1582026','834','00','005010X220A1','1582026','','2014-01-17','15:52:14',0,'2014-01-20 08:06:22',NULL,NULL),(16068,2773,'1991161','834','00','005010X220A1','1991161','','2014-01-22','11:14:31',0,'2014-01-23 03:02:44',NULL,NULL),(14146,2356,'1950720','834','00','005010X220A1','1950720','','2014-01-08','12:52:23',0,'2014-01-13 02:22:39',NULL,NULL),(13340,2184,'0001','999','BE','005010X231A1','165514','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:03',NULL,NULL),(7140,1237,'1227513','834','00','005010X220A1','1227513','','2013-12-17','20:16:10',0,'2013-12-26 04:04:46',NULL,NULL),(5768,1072,'577743','834','00','005010X220A1','577743','','2013-12-14','14:23:17',0,'2013-12-26 02:02:28',NULL,NULL),(3362,587,'792246','834','00','005010X220A1','792246','','2013-12-17','11:00:39',0,'2013-12-25 21:50:29',NULL,NULL),(2860,512,'969762','834','00','005010X220A1','969762','','2013-12-22','18:02:34',0,'2013-12-25 21:22:20',NULL,NULL),(20075,3760,'3280143','834','00','005010X220A1','3280143','','2014-02-18','15:00:50',0,'2014-02-18 22:01:27',NULL,NULL),(21458,4028,'2804752','834','00','005010X220A1','2804752','','2014-02-27','01:35:53',0,'2014-02-28 06:31:02',NULL,NULL),(21749,4090,'3112875','834','00','005010X220A1','3112875','','2014-02-27','23:42:59',0,'2014-02-28 21:30:46',NULL,NULL),(22488,4243,'3200875','834','00','005010X220A1','3200875','','2014-03-05','17:39:29',0,'2014-03-05 21:00:29',NULL,NULL),(22586,4248,'3768354','834','00','005010X220A1','3768354','','2014-03-05','17:41:53',0,'2014-03-05 21:31:08',NULL,NULL),(22989,4320,'3484323','834','00','005010X220A1','3484323','','2014-03-06','17:56:05',0,'2014-03-06 21:30:24',NULL,NULL),(264,49,'51719','834','00','005010X220A1','51719','','2013-11-13','17:56:37',0,'2013-12-25 17:31:20',NULL,NULL),(15772,2717,'1513835','834','00','005010X220A1','1513835','','2014-01-19','21:38:26',0,'2014-01-21 08:46:31',NULL,NULL),(3112,547,'1031197','834','00','005010X220A1','1031197','','2013-12-13','18:05:23',0,'2013-12-25 21:36:31',NULL,NULL),(2343,413,'225371','834','00','005010X220A1','225371','','2013-12-05','23:13:48',0,'2013-12-25 20:15:27',NULL,NULL),(2116,360,'980233','834','00','005010X220A1','980233','','2013-12-02','07:59:55',0,'2013-12-25 19:45:26',NULL,NULL),(22734,4276,'3732599','834','00','005010X220A1','3732599','','2014-03-05','21:46:23',0,'2014-03-06 21:00:17',NULL,NULL),(23684,4447,'3205751','834','00','005010X220A1','3205751','','2014-03-10','12:40:47',0,'2014-03-10 21:02:16',NULL,NULL),(13526,2239,'1831597','834','00','005010X220A1','1831597','','2014-01-06','10:06:35',0,'2014-01-07 04:05:37',NULL,NULL),(2833,511,'1281194','834','00','005010X220A1','1281194','','2013-12-21','22:09:50',0,'2013-12-25 21:21:24',NULL,NULL),(2374,413,'898107','834','00','005010X220A1','898107','','2013-12-06','16:18:36',0,'2013-12-25 20:16:28',NULL,NULL),(1910,325,'663471','834','00','005010X220A1','663471','','2013-12-09','14:06:46',0,'2013-12-25 19:32:03',NULL,NULL),(18260,3376,'2087623','834','00','005010X220A1','2087623','','2014-02-08','12:24:10',0,'2014-02-08 19:00:09',NULL,NULL),(20554,3862,'2493345','834','00','005010X220A1','2493345','','2014-02-21','15:06:56',0,'2014-02-21 21:30:07',NULL,NULL),(20650,3875,'2917742','834','00','005010X220A1','2917742','','2014-02-21','16:30:29',0,'2014-02-21 22:00:52',NULL,NULL),(15042,2584,'1482063','834','00','005010X220A1','1482063','','2014-01-15','17:48:36',0,'2014-01-16 08:44:44',NULL,NULL),(10823,1404,'1172883','834','00','005010X220A1','1172883','','2013-12-23','17:01:08',0,'2013-12-26 13:04:38',NULL,NULL),(4606,826,'658928','834','00','005010X220A1','658928','','2013-12-24','01:51:57',0,'2013-12-25 23:47:25',NULL,NULL),(946,181,'578694','834','00','005010X220A1','578694','','2013-12-03','15:00:31',0,'2013-12-25 18:18:31',NULL,NULL),(3765,654,'1186936','834','00','005010X220A1','1186936','','2013-12-08','08:41:45',0,'2013-12-25 22:15:09',NULL,NULL),(1980,327,'199912','834','00','005010X220A1','199912','','2013-12-08','20:52:14',0,'2013-12-25 19:34:10',NULL,NULL),(2601,483,'280772','834','00','005010X220A1','280772','','2013-10-06','12:16:22',0,'2013-12-25 20:46:02',NULL,NULL),(10694,1403,'1647088','834','00','005010X220A1','1647088','','2013-12-23','09:16:00',0,'2013-12-26 13:00:18',NULL,NULL),(22225,4191,'2660947','834','00','005010X220A1','2660947','','2014-03-03','14:40:06',0,'2014-03-03 21:31:51',NULL,NULL),(10782,1404,'1047321','834','00','005010X220A1','1047321','','2013-12-23','10:36:50',0,'2013-12-26 13:03:17',NULL,NULL),(13482,2226,'1816039','834','00','005010X220A1','1816039','','2014-01-05','21:04:08',0,'2014-01-07 04:03:59',NULL,NULL),(12535,1647,'357259','834','00','005010X220A1','357259','','2013-12-30','23:09:38',1,'2014-01-02 04:34:36',NULL,NULL),(68,3,'1294797','834','00','005010X220A1','1294797','','2013-12-05','17:35:41',0,'2013-12-25 17:17:03',NULL,NULL),(16169,2861,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 04:17:10',NULL,NULL),(5363,1008,'1148129','834','00','005010X220A1','1148129','','2013-11-25','08:05:06',0,'2013-12-26 01:16:16',NULL,NULL),(5110,941,'1060535','834','00','005010X220A1','1060535','','2013-12-10','20:00:31',0,'2013-12-26 00:49:31',NULL,NULL),(11156,1437,'431030','834','00','005010X220A1','431030','','2013-12-23','08:56:41',0,'2013-12-26 13:16:07',NULL,NULL),(5573,1043,'1296834','834','00','005010X220A1','1296834','','2013-12-24','20:40:49',0,'2013-12-26 01:48:46',NULL,NULL),(6182,1167,'940677','834','00','005010X220A1','940677','','2013-12-20','16:50:08',0,'2013-12-26 03:03:46',NULL,NULL),(3498,615,'369430','834','00','005010X220A1','369430','','2013-12-12','14:12:10',0,'2013-12-25 22:01:07',NULL,NULL),(3342,587,'395974','834','00','005010X220A1','395974','','2013-12-16','20:21:55',0,'2013-12-25 21:49:55',NULL,NULL),(18210,3356,'2618904','834','00','005010X220A1','2618904','','2014-02-06','21:18:15',0,'2014-02-07 19:00:40',NULL,NULL),(23284,4380,'3412593','834','00','005010X220A1','3412593','','2014-03-08','11:26:00',0,'2014-03-08 21:30:08',NULL,NULL),(11892,1561,'1924277','834','00','005010X220A1','1924277','','2013-12-28','21:38:21',0,'2013-12-30 00:00:44',NULL,NULL),(17758,3262,'2403580','834','00','005010X220A1','2403580','','2014-02-04','14:48:05',0,'2014-02-04 21:01:05',NULL,NULL),(16513,3013,'2114843','834','00','005010X220A1','2114843','','2014-01-24','13:48:07',0,'2014-01-24 21:00:50',NULL,NULL),(15576,2657,'1430500','834','00','005010X220A1','1430500','','2014-01-17','12:24:24',0,'2014-01-20 08:06:08',NULL,NULL),(15565,2657,'1651780','834','00','005010X220A1','1651780','','2014-01-16','19:06:10',0,'2014-01-20 08:06:00',NULL,NULL),(18134,3337,'1464126','834','00','005010X220A1','1464126','','2014-02-05','21:55:04',0,'2014-02-06 21:01:41',NULL,NULL),(18498,3440,'1596871','834','00','005010X220A1','1596871','','2014-02-10','04:23:02',0,'2014-02-10 11:01:13',NULL,NULL),(21756,4090,'2727500','834','00','005010X220A1','2727500','','2014-02-28','11:47:07',0,'2014-02-28 21:30:50',NULL,NULL),(17583,3237,'2460821','834','00','005010X220A1','2460821','','2014-02-03','12:35:19',0,'2014-02-03 21:00:46',NULL,NULL),(14790,2551,'2039880','834','00','005010X220A1','2039880','','2014-01-14','16:08:56',0,'2014-01-15 02:06:41',NULL,NULL),(11225,1454,'737990','834','00','005010X220A1','737990','','2013-12-26','10:39:21',0,'2013-12-27 02:01:12',NULL,NULL),(10391,1400,'954869','834','00','005010X220A1','954869','','2013-12-23','04:17:25',0,'2013-12-26 12:50:26',NULL,NULL),(12470,1640,'1385667','834','00','005010X220A1','1385667','','2013-12-30','19:26:56',1,'2014-01-02 04:32:14',NULL,NULL),(18447,3423,'2472855','834','00','005010X220A1','2472855','','2014-02-10','00:08:22',0,'2014-02-10 11:00:31',NULL,NULL),(19832,3682,'2607031','834','00','005010X220A1','2607031','','2014-02-15','10:01:42',0,'2014-02-15 22:01:49',NULL,NULL),(20357,3817,'3090381','834','00','005010X220A1','3090381','','2014-02-19','16:47:54',0,'2014-02-20 04:56:17',NULL,NULL),(22904,4285,'2784341','834','00','005010X220A1','2784341','','2014-03-05','22:31:17',0,'2014-03-06 21:02:19',NULL,NULL),(12592,1671,'1901248','834','00','005010X220A1','1901248','','2014-01-02','12:15:35',0,'2014-01-03 02:00:48',NULL,NULL),(11761,1524,'2280335','834','00','005010X220A1','2280335','','2013-12-28','12:35:03',1,'2013-12-29 11:09:45',NULL,NULL),(7573,1301,'1281167','834','00','005010X220A1','1281167','','2013-12-21','14:14:38',0,'2013-12-26 04:36:23',NULL,NULL),(7001,1235,'993151','834','00','005010X220A1','993151','','2013-12-17','20:08:55',0,'2013-12-26 04:00:31',NULL,NULL),(6124,1166,'171135','834','00','005010X220A1','171135','','2013-12-20','15:08:24',0,'2013-12-26 03:02:02',NULL,NULL),(16080,2776,'1995140','834','00','005010X220A1','1995140','','2014-01-22','17:12:01',0,'2014-01-23 03:02:50',NULL,NULL),(19338,3583,'2511749','834','00','005010X220A1','2511749','','2014-02-13','14:27:21',0,'2014-02-13 22:01:42',NULL,NULL),(22025,4157,'3017082','834','00','005010X220A1','3017082','','2014-03-02','12:40:41',0,'2014-03-03 01:00:39',NULL,NULL),(22788,4277,'2754065','834','00','005010X220A1','2754065','','2014-03-06','15:55:02',0,'2014-03-06 21:00:56',NULL,NULL),(23407,4404,'3179647','834','00','005010X220A1','3179647','','2014-03-09','00:02:33',0,'2014-03-09 21:00:17',NULL,NULL),(38,1,'1281571','834','00','005010X220A1','1281571','','2013-12-05','15:53:51',0,'2013-12-25 17:16:06',NULL,NULL),(13762,2278,'2265702','834','00','005010X220A1','2265702','','2014-01-07','14:30:31',0,'2014-01-08 18:24:57',NULL,NULL),(5760,1072,'1111730','834','00','005010X220A1','1111730','','2013-12-13','22:34:02',0,'2013-12-26 02:02:13',NULL,NULL),(3066,544,'316885','834','00','005010X220A1','316885','','2013-12-13','16:12:53',0,'2013-12-25 21:35:07',NULL,NULL),(1782,299,'118166','834','00','005010X220A1','118166','','2013-12-10','15:37:36',0,'2013-12-25 19:19:01',NULL,NULL),(19869,3708,'3230971','834','00','005010X220A1','3230971','','2014-02-15','20:49:33',0,'2014-02-16 19:00:15',NULL,NULL),(20244,3792,'2916472','834','00','005010X220A1','2916472','','2014-02-19','00:10:24',0,'2014-02-20 04:30:58',NULL,NULL),(17947,3299,'1983808','834','00','005010X220A1','1983808','','2014-02-05','11:56:26',0,'2014-02-05 21:30:53',NULL,NULL),(14138,2353,'2235583','834','00','005010X220A1','2235583','','2014-01-08','13:38:25',0,'2014-01-13 02:22:34',NULL,NULL),(5372,1009,'214923','834','00','005010X220A1','214923','','2013-11-25','16:57:43',0,'2013-12-26 01:16:35',NULL,NULL),(4900,904,'606653','834','00','005010X220A1','606653','','2013-10-22','22:05:05',0,'2013-12-26 00:30:06',NULL,NULL),(7639,1309,'137951','834','00','005010X220A1','137951','','2013-12-21','14:08:02',0,'2013-12-26 04:38:30',NULL,NULL),(3269,581,'207531','834','00','005010X220A1','207531','','2013-12-16','18:50:13',0,'2013-12-25 21:47:28',NULL,NULL),(4816,869,'423319','834','00','005010X220A1','423319','','2013-12-01','08:32:20',0,'2013-12-26 00:02:20',NULL,NULL),(19928,3733,'3170964','834','00','005010X220A1','3170964','','2014-02-18','09:27:19',0,'2014-02-18 21:30:03',NULL,NULL),(22666,4254,'2912028','834','00','005010X220A1','2912028','','2014-03-05','15:13:06',0,'2014-03-05 21:32:03',NULL,NULL),(167,14,'483656','834','00','005010X220A1','483656','','2013-12-05','09:15:35',0,'2013-12-25 17:20:12',NULL,NULL),(822,165,'496071','834','00','005010X220A1','496071','','2013-11-11','00:45:55',0,'2013-12-25 18:10:59',NULL,NULL),(3963,716,'8664','834','00','005010X220A1','8664','','2013-12-07','00:52:02',0,'2013-12-25 22:47:01',NULL,NULL),(4126,733,'202817','834','00','005010X220A1','202817','','2013-12-19','14:24:12',0,'2013-12-25 23:03:59',NULL,NULL),(1861,324,'397195','834','00','005010X220A1','397195','','2013-12-09','12:48:04',0,'2013-12-25 19:30:34',NULL,NULL),(5407,1021,'33431','834','00','005010X220A1','33431','','2013-11-14','17:29:27',0,'2013-12-26 01:30:29',NULL,NULL),(21126,3994,'3651564','834','00','005010X220A1','3651564','','2014-02-26','16:38:05',0,'2014-02-26 21:00:27',NULL,NULL),(21829,4098,'3775775','834','00','005010X220A1','3775775','','2014-02-28','16:21:45',0,'2014-02-28 21:31:42',NULL,NULL),(1082,217,'540416','834','00','005010X220A1','540416','','2013-11-04','09:55:04',0,'2013-12-25 18:31:21',NULL,NULL),(7364,1285,'480370','834','00','005010X220A1','480370','','2013-11-30','15:05:22',0,'2013-12-26 04:15:59',NULL,NULL),(2924,541,'429014','834','00','005010X220A1','429014','','2013-12-12','19:21:21',0,'2013-12-25 21:30:41',NULL,NULL),(15611,2666,'2468672','834','00','005010X220A1','2468672','','2014-01-17','14:22:42',0,'2014-01-20 08:06:33',NULL,NULL),(13651,2271,'1299817','834','00','005010X220A1','1299817','','2014-01-07','12:16:00',0,'2014-01-08 18:24:10',NULL,NULL),(4385,774,'1216591','834','00','005010X220A1','1216591','','2013-11-26','23:46:15',0,'2013-12-25 23:15:30',NULL,NULL),(4918,909,'749947','834','00','005010X220A1','749947','','2013-10-16','20:20:26',0,'2013-12-26 00:30:44',NULL,NULL),(1700,292,'712968','834','00','005010X220A1','712968','','2013-12-09','21:55:51',0,'2013-12-25 19:16:29',NULL,NULL),(5558,1043,'952278','834','00','005010X220A1','952278','','2013-12-24','19:18:50',0,'2013-12-26 01:48:17',NULL,NULL),(5437,1033,'269073','834','00','005010X220A1','269073','','2013-10-04','20:41:44',0,'2013-12-26 01:31:33',NULL,NULL),(3237,578,'1265656','834','00','005010X220A1','1265656','','2013-12-17','15:03:25',0,'2013-12-25 21:46:27',NULL,NULL),(23371,4395,'2854566','834','00','005010X220A1','2854566','','2014-03-08','12:06:08',0,'2014-03-08 21:31:14',NULL,NULL),(16262,2954,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:38:00',0,'2014-01-23 08:39:58',NULL,NULL),(571,103,'703281','834','00','005010X220A1','703281','','2013-12-16','15:00:00',0,'2013-12-25 18:02:41',NULL,NULL),(15633,2676,'2599154','834','00','005010X220A1','2599154','','2014-01-17','18:58:36',0,'2014-01-21 08:44:14',NULL,NULL),(10619,1402,'920098','834','00','005010X220A1','920098','','2013-12-23','14:56:59',0,'2013-12-26 12:57:48',NULL,NULL),(14304,2388,'1821351','834','00','005010X220A1','1821351','','2014-01-10','13:04:23',0,'2014-01-13 03:00:32',NULL,NULL),(3394,588,'54989','834','00','005010X220A1','54989','','2013-12-17','11:25:19',0,'2013-12-25 21:51:29',NULL,NULL),(14278,2376,'2277171','834','00','005010X220A1','2277171','','2014-01-10','11:21:27',0,'2014-01-13 03:00:15',NULL,NULL),(4281,742,'602712','834','00','005010X220A1','602712','','2013-12-19','16:54:04',0,'2013-12-25 23:08:45',NULL,NULL),(12313,1631,'2053204','834','00','005010X220A1','2053204','','2014-01-01','15:05:49',1,'2014-01-02 04:25:46',NULL,NULL),(17108,3142,'1976362','834','00','005010X220A1','1976362','','2014-01-30','12:50:42',0,'2014-01-30 21:00:11',NULL,NULL),(19400,3593,'3302061','834','00','005010X220A1','3302061','','2014-02-13','12:22:17',0,'2014-02-13 22:02:30',NULL,NULL),(19826,3680,'3345329','834','00','005010X220A1','3345329','','2014-02-14','20:55:50',0,'2014-02-15 22:01:43',NULL,NULL),(16802,3089,'1438154','834','00','005010X220A1','1438154','','2014-01-27','18:28:03',0,'2014-01-28 21:00:09',NULL,NULL),(3163,563,'249081','834','00','005010X220A1','249081','','2013-12-13','10:44:42',0,'2013-12-25 21:38:12',NULL,NULL),(15354,2623,'1937569','834','00','005010X220A1','1937569','','2014-01-16','09:48:04',0,'2014-01-17 03:35:25',NULL,NULL),(12415,1638,'480058','834','00','005010X220A1','480058','','2013-12-30','19:14:16',1,'2014-01-02 04:30:14',NULL,NULL),(18163,3350,'2548321','834','00','005010X220A1','2548321','','2014-02-06','22:15:16',0,'2014-02-07 19:00:09',NULL,NULL),(10386,1400,'1537587','834','00','005010X220A1','1537587','','2013-12-22','23:06:54',0,'2013-12-26 12:50:18',NULL,NULL),(16025,2768,'2484228','834','00','005010X220A1','2484228','','2014-01-22','13:12:11',0,'2014-01-23 03:02:24',NULL,NULL),(1759,294,'933698','834','00','005010X220A1','933698','','2013-12-10','00:45:03',0,'2013-12-25 19:18:15',NULL,NULL),(1698,292,'1202709','834','00','005010X220A1','1202709','','2013-12-09','21:44:38',0,'2013-12-25 19:16:26',NULL,NULL),(20816,3910,'3564259','834','00','005010X220A1','3564259','','2014-02-25','13:54:55',0,'2014-02-25 21:31:06',NULL,NULL),(12642,1672,'1411054','834','00','005010X220A1','1411054','','2014-01-02','16:26:09',0,'2014-01-03 02:02:36',NULL,NULL),(10722,1403,'1290647','834','00','005010X220A1','1290647','','2013-12-23','14:02:24',0,'2013-12-26 13:01:21',NULL,NULL),(3153,559,'1127450','834','00','005010X220A1','1127450','','2013-12-13','10:47:20',0,'2013-12-25 21:37:51',NULL,NULL),(1284,243,'1892396','834','00','005010X220A1','1892396','','2013-12-24','17:42:09',0,'2013-12-25 18:50:17',NULL,NULL),(19890,3711,'3026614','834','00','005010X220A1','3026614','','2014-02-15','23:09:14',0,'2014-02-16 19:00:32',NULL,NULL),(23056,4339,'3545359','834','00','005010X220A1','3545359','','2014-03-06','18:23:53',0,'2014-03-07 21:30:03',NULL,NULL),(128,8,'1208884','834','00','005010X220A1','1208884','','2013-12-05','13:19:53',0,'2013-12-25 17:18:57',NULL,NULL),(11133,1430,'705222','834','00','005010X220A1','705222','','2013-12-23','19:00:19',0,'2013-12-26 13:15:18',NULL,NULL),(4293,746,'482055','834','00','005010X220A1','482055','','2013-12-19','12:37:31',0,'2013-12-25 23:09:05',NULL,NULL),(14413,2434,'0001','999','BE','005010X231A1','920930','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:25',NULL,NULL),(12796,1703,'1679002','834','00','005010X220A1','1679002','','2014-01-03','11:39:00',0,'2014-01-04 02:01:07',NULL,NULL),(13413,2222,'2154090','834','00','005010X220A1','2154090','','2014-01-06','10:16:20',0,'2014-01-07 04:01:20',NULL,NULL),(21105,3994,'3117922','834','00','005010X220A1','3117922','','2014-02-26','10:00:26',0,'2014-02-26 21:00:11',NULL,NULL),(127,8,'1071710','834','00','005010X220A1','1071710','','2013-12-04','19:07:05',0,'2013-12-25 17:18:56',NULL,NULL),(6439,1205,'916437','834','00','005010X220A1','916437','','2013-11-21','20:49:50',0,'2013-12-26 03:15:42',NULL,NULL),(10988,1413,'1473848','834','00','005010X220A1','1473848','','2013-12-23','10:44:04',0,'2013-12-26 13:10:21',NULL,NULL),(7363,1285,'1269622','834','00','005010X220A1','1269622','','2013-11-30','13:37:42',0,'2013-12-26 04:15:57',NULL,NULL),(1464,252,'1935903','834','00','005010X220A1','1935903','','2013-12-24','15:00:22',0,'2013-12-25 18:56:14',NULL,NULL),(10646,1402,'1462961','834','00','005010X220A1','1462961','','2013-12-23','17:57:12',0,'2013-12-26 12:58:40',NULL,NULL),(10595,1402,'1283756','834','00','005010X220A1','1283756','','2013-12-23','12:34:18',0,'2013-12-26 12:57:00',NULL,NULL),(19138,3549,'2506803','834','00','005010X220A1','2506803','','2014-02-11','21:50:44',0,'2014-02-12 21:32:01',NULL,NULL),(20258,3794,'3335583','834','00','005010X220A1','3335583','','2014-02-18','22:31:44',0,'2014-02-20 04:33:36',NULL,NULL),(20926,3935,'3132884','834','00','005010X220A1','3132884','','2014-02-23','13:40:32',0,'2014-02-26 08:00:21',NULL,NULL),(22538,4248,'3547521','834','00','005010X220A1','3547521','','2014-03-04','19:13:11',0,'2014-03-05 21:30:34',NULL,NULL),(22561,4248,'3798028','834','00','005010X220A1','3798028','','2014-03-05','12:29:40',0,'2014-03-05 21:30:51',NULL,NULL),(14837,2553,'2582147','834','00','005010X220A1','2582147','','2014-01-13','22:12:25',0,'2014-01-15 02:07:00',NULL,NULL),(860,175,'937490','834','00','005010X220A1','937490','','2013-12-03','12:10:34',0,'2013-12-25 18:15:57',NULL,NULL),(2757,505,'474524','834','00','005010X220A1','474524','','2013-12-22','09:37:48',0,'2013-12-25 21:18:57',NULL,NULL),(14669,2544,'2139423','834','00','005010X220A1','2139423','','2014-01-13','16:20:59',0,'2014-01-14 01:33:52',NULL,NULL),(11195,1453,'1572705','834','00','005010X220A1','1572705','','2013-12-26','13:37:55',0,'2013-12-27 02:00:16',NULL,NULL),(6333,1176,'668752','834','00','005010X220A1','668752','','2013-12-19','21:08:00',0,'2013-12-26 03:08:24',NULL,NULL),(18441,3421,'1597951','834','00','005010X220A1','1597951','','2014-02-10','04:07:47',0,'2014-02-10 11:00:26',NULL,NULL),(18456,3423,'2548001','834','00','005010X220A1','2548001','','2014-02-10','04:31:26',0,'2014-02-10 11:00:39',NULL,NULL),(21199,3998,'2697768','834','00','005010X220A1','2697768','','2014-02-26','14:58:00',0,'2014-02-26 21:01:15',NULL,NULL),(22859,4280,'3253694','834','00','005010X220A1','3253694','','2014-03-06','12:05:09',0,'2014-03-06 21:01:46',NULL,NULL),(15811,2727,'1812759','834','00','005010X220A1','1812759','','2014-01-20','10:13:15',0,'2014-01-21 08:46:55',NULL,NULL),(14425,2446,'0001','999','BE','005010X231A1','534185','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:36',NULL,NULL),(364,72,'268161','834','00','005010X220A1','268161','','2013-12-04','11:19:54',0,'2013-12-25 17:47:12',NULL,NULL),(718,120,'369554','834','00','005010X220A1','369554','','2013-12-16','10:49:58',0,'2013-12-25 18:07:20',NULL,NULL),(1056,207,'1059111','834','00','005010X220A1','1059111','','2013-11-29','16:02:15',0,'2013-12-25 18:30:28',NULL,NULL),(14205,2365,'1428800','834','00','005010X220A1','1428800','','2014-01-10','14:53:40',0,'2014-01-13 02:23:47',NULL,NULL),(4522,816,'180777','834','00','005010X220A1','180777','','2013-11-26','10:14:35',0,'2013-12-25 23:32:49',NULL,NULL),(3996,731,'757794','834','00','005010X220A1','757794','','2013-12-18','19:02:35',0,'2013-12-25 23:00:02',NULL,NULL),(17983,3307,'2282530','834','00','005010X220A1','2282530','','2014-02-04','23:04:46',0,'2014-02-05 21:31:12',NULL,NULL),(20344,3805,'3499759','834','00','005010X220A1','3499759','','2014-02-19','17:15:41',0,'2014-02-20 04:53:22',NULL,NULL),(21191,3998,'3190524','834','00','005010X220A1','3190524','','2014-02-26','14:18:36',0,'2014-02-26 21:01:11',NULL,NULL),(7545,1300,'522757','834','00','005010X220A1','522757','','2013-12-21','17:45:17',0,'2013-12-26 04:35:27',NULL,NULL),(5842,1092,'951239','834','00','005010X220A1','951239','','2013-11-22','23:25:59',0,'2013-12-26 02:15:49',NULL,NULL),(15714,2707,'2273965','834','00','005010X220A1','2273965','','2014-01-19','12:42:08',0,'2014-01-21 08:45:39',NULL,NULL),(1388,245,'1496829','834','00','005010X220A1','1496829','','2013-12-24','17:16:34',0,'2013-12-25 18:53:38',NULL,NULL),(1568,276,'389173','834','00','005010X220A1','389173','','2013-11-20','08:44:37',0,'2013-12-25 19:00:12',NULL,NULL),(13620,2270,'1821240','834','00','005010X220A1','1821240','','2014-01-07','12:21:50',0,'2014-01-08 18:23:57',NULL,NULL),(2171,362,'110550','834','00','005010X220A1','110550','','2013-12-02','13:57:05',0,'2013-12-25 19:47:11',NULL,NULL),(3255,578,'889608','834','00','005010X220A1','889608','','2013-12-17','18:22:18',0,'2013-12-25 21:46:57',NULL,NULL),(3404,590,'766084','834','00','005010X220A1','766084','','2013-12-16','21:13:57',0,'2013-12-25 21:51:48',NULL,NULL),(187,16,'589805','834','00','005010X220A1','589805','','2013-12-05','14:18:04',0,'2013-12-25 17:20:48',NULL,NULL),(16893,3098,'1531107','834','00','005010X220A1','1531107','','2014-01-28','13:18:33',0,'2014-01-28 21:01:09',NULL,NULL),(495,102,'1119778','834','00','005010X220A1','1119778','','2013-12-16','07:05:40',0,'2013-12-25 18:00:20',NULL,NULL),(13964,2322,'2464348','834','00','005010X220A1','2464348','','2014-01-09','16:09:02',0,'2014-01-13 02:20:31',NULL,NULL),(13136,1980,'0001','999','BE','005010X231A1','341749','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:22',NULL,NULL),(12938,1730,'1102594','834','00','005010X220A1','1102594','','2014-01-03','18:33:25',0,'2014-01-04 06:00:03',NULL,NULL),(4064,732,'1243413','834','00','005010X220A1','1243413','','2013-12-18','19:23:01',0,'2013-12-25 23:02:08',NULL,NULL),(5184,949,'1016149','834','00','005010X220A1','1016149','','2013-12-10','22:52:26',0,'2013-12-26 00:51:50',NULL,NULL),(17931,3296,'2830166','834','00','005010X220A1','2830166','','2014-02-05','15:04:18',0,'2014-02-05 21:30:45',NULL,NULL),(18507,3446,'1869223','834','00','005010X220A1','1869223','','2014-02-10','12:14:01',0,'2014-02-10 21:00:08',NULL,NULL),(3623,621,'267118','834','00','005010X220A1','267118','','2013-12-12','17:08:17',0,'2013-12-25 22:05:03',NULL,NULL),(11268,1455,'2118845','834','00','005010X220A1','2118845','','2013-12-26','11:44:27',0,'2013-12-27 02:02:30',NULL,NULL),(5091,940,'438346','834','00','005010X220A1','438346','','2013-12-10','19:29:05',0,'2013-12-26 00:48:53',NULL,NULL),(2756,505,'253491','834','00','005010X220A1','253491','','2013-12-21','21:43:34',0,'2013-12-25 21:18:55',NULL,NULL),(10493,1400,'1563659','834','00','005010X220A1','1563659','','2013-12-23','17:24:38',0,'2013-12-26 12:53:39',NULL,NULL),(2745,503,'1327253','834','00','005010X220A1','1327253','','2013-12-22','17:36:42',0,'2013-12-25 21:18:35',NULL,NULL),(17939,3299,'2739596','834','00','005010X220A1','2739596','','2014-02-04','20:12:45',0,'2014-02-05 21:30:49',NULL,NULL),(19568,3627,'3269874','834','00','005010X220A1','3269874','','2014-02-13','19:40:07',0,'2014-02-14 21:31:15',NULL,NULL),(21313,4009,'3766976','834','00','005010X220A1','3766976','','2014-02-26','13:05:57',0,'2014-02-26 21:02:35',NULL,NULL),(11305,1456,'2107773','834','00','005010X220A1','2107773','','2013-12-26','09:58:06',0,'2013-12-27 02:03:40',NULL,NULL),(3463,614,'1317330','834','00','005010X220A1','1317330','','2013-12-17','17:11:12',0,'2013-12-25 21:53:45',NULL,NULL),(2905,539,'39414','834','00','005010X220A1','39414','','2013-12-13','14:29:34',0,'2013-12-25 21:30:07',NULL,NULL),(5353,1004,'320292','834','00','005010X220A1','320292','','2013-11-25','11:25:23',0,'2013-12-26 01:15:57',NULL,NULL),(2806,506,'831228','834','00','005010X220A1','831228','','2013-12-22','14:18:27',0,'2013-12-25 21:20:32',NULL,NULL),(5160,944,'754928','834','00','005010X220A1','754928','','2013-12-11','13:24:31',0,'2013-12-26 00:51:06',NULL,NULL),(20481,3843,'3409536','834','00','005010X220A1','3409536','','2014-02-20','14:21:18',0,'2014-02-20 22:00:49',NULL,NULL),(20679,3883,'3034255','834','00','005010X220A1','3034255','','2014-02-21','12:12:07',0,'2014-02-21 22:01:12',NULL,NULL),(22147,4179,'2903786','834','00','005010X220A1','2903786','','2014-03-03','14:19:34',0,'2014-03-03 21:30:53',NULL,NULL),(23678,4445,'2912228','834','00','005010X220A1','2912228','','2014-03-10','15:48:37',0,'2014-03-10 21:02:11',NULL,NULL),(17854,3293,'1814268','834','00','005010X220A1','1814268','','2014-02-04','18:57:50',0,'2014-02-05 21:30:08',NULL,NULL),(17795,3270,'2208058','834','00','005010X220A1','2208058','','2014-02-04','12:15:23',0,'2014-02-04 21:01:29',NULL,NULL),(11515,1490,'1839353','834','00','005010X220A1','1839353','','2013-12-27','11:08:32',0,'2013-12-28 03:32:05',NULL,NULL),(5201,949,'999315','834','00','005010X220A1','999315','','2013-12-11','13:23:49',0,'2013-12-26 00:52:23',NULL,NULL),(5117,942,'614251','834','00','005010X220A1','614251','','2013-12-11','07:48:04',0,'2013-12-26 00:49:46',NULL,NULL),(20920,3932,'3157434','834','00','005010X220A1','3157434','','2014-02-23','16:36:56',0,'2014-02-26 08:00:16',NULL,NULL),(22633,4252,'2920494','834','00','005010X220A1','2920494','','2014-03-05','15:30:33',0,'2014-03-05 21:31:41',NULL,NULL),(17889,3294,'2379363','834','00','005010X220A1','2379363','','2014-02-05','15:43:15',0,'2014-02-05 21:30:25',NULL,NULL),(16777,3077,'2639471','834','00','005010X220A1','2639471','','2014-01-27','12:12:28',0,'2014-01-27 21:01:39',NULL,NULL),(14444,2465,'0001','999','BE','005010X231A1','919448','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:17',NULL,NULL),(1134,238,'323723','834','00','005010X220A1','323723','','2013-12-24','15:55:27',0,'2013-12-25 18:45:42',NULL,NULL),(14113,2346,'1723588','834','00','005010X220A1','1723588','','2014-01-07','21:03:17',0,'2014-01-13 02:22:19',NULL,NULL),(5406,1021,'656440','834','00','005010X220A1','656440','','2013-11-14','10:18:54',0,'2013-12-26 01:30:27',NULL,NULL),(3748,645,'769896','834','00','005010X220A1','769896','','2013-12-12','14:00:58',0,'2013-12-25 22:09:07',NULL,NULL),(5236,957,'24593','834','00','005010X220A1','24593','','2013-12-11','09:01:29',0,'2013-12-26 00:53:35',NULL,NULL),(6392,1187,'317174','834','00','005010X220A1','317174','','2013-12-20','09:46:48',0,'2013-12-26 03:10:12',NULL,NULL),(121,7,'132228','834','00','005010X220A1','132228','','2013-12-05','09:23:02',0,'2013-12-25 17:18:42',NULL,NULL),(11778,1532,'1413505','834','00','005010X220A1','1413505','','2013-12-27','20:31:52',1,'2013-12-29 11:10:18',NULL,NULL),(565,103,'1127522','834','00','005010X220A1','1127522','','2013-12-16','12:47:45',0,'2013-12-25 18:02:31',NULL,NULL),(1332,245,'187753','834','00','005010X220A1','187753','','2013-12-24','12:08:03',0,'2013-12-25 18:51:50',NULL,NULL),(1992,328,'404402','834','00','005010X220A1','404402','','2013-12-09','13:39:40',0,'2013-12-25 19:34:33',NULL,NULL),(3284,583,'485570','834','00','005010X220A1','485570','','2013-12-17','17:08:59',0,'2013-12-25 21:47:56',NULL,NULL),(3290,584,'4258','834','00','005010X220A1','4258','','2013-12-16','20:52:53',0,'2013-12-25 21:48:07',NULL,NULL),(17513,3233,'2087479','834','00','005010X220A1','2087479','','2014-02-02','18:08:58',0,'2014-02-03 21:00:03',NULL,NULL),(11528,1490,'2066510','834','00','005010X220A1','2066510','','2013-12-27','13:54:37',0,'2013-12-28 03:32:29',NULL,NULL),(13003,1741,'1919137','834','00','005010X220A1','1919137','','2014-01-03','22:35:41',0,'2014-01-05 00:02:13',NULL,NULL),(5704,1067,'203899','834','00','005010X220A1','203899','','2013-12-14','17:57:49',0,'2013-12-26 02:00:34',NULL,NULL),(4692,833,'905561','834','00','005010X220A1','905561','','2013-12-24','01:06:57',0,'2013-12-25 23:50:22',NULL,NULL),(12967,1734,'1881539','834','00','005010X220A1','1881539','','2014-01-04','12:12:28',0,'2014-01-05 00:01:00',NULL,NULL),(5631,1046,'572041','834','00','005010X220A1','572041','','2013-12-25','07:45:20',0,'2013-12-26 01:50:43',NULL,NULL),(12870,1706,'1719793','834','00','005010X220A1','1719793','','2014-01-03','12:15:01',0,'2014-01-04 02:03:48',NULL,NULL),(20803,3909,'3551039','834','00','005010X220A1','3551039','','2014-02-25','17:33:45',0,'2014-02-25 21:30:57',NULL,NULL),(23458,4411,'2657347','834','00','005010X220A1','2657347','','2014-03-09','15:19:12',0,'2014-03-09 21:00:58',NULL,NULL),(4587,826,'1498070','834','00','005010X220A1','1498070','','2013-12-23','22:55:25',0,'2013-12-25 23:46:51',NULL,NULL),(7252,1246,'580546','834','00','005010X220A1','580546','','2013-12-18','11:20:06',0,'2013-12-26 04:08:16',NULL,NULL),(3613,619,'754991','834','00','005010X220A1','754991','','2013-12-12','18:11:23',0,'2013-12-25 22:04:44',NULL,NULL),(2465,425,'1250423','834','00','005010X220A1','1250423','','2013-12-06','11:00:24',0,'2013-12-25 20:19:21',NULL,NULL),(2769,506,'811308','834','00','005010X220A1','811308','','2013-12-21','20:40:32',0,'2013-12-25 21:19:19',NULL,NULL),(20796,3909,'3680218','834','00','005010X220A1','3680218','','2014-02-25','12:12:10',0,'2014-02-25 21:30:52',NULL,NULL),(12430,1638,'2500937','834','00','005010X220A1','2500937','','2013-12-31','13:44:03',1,'2014-01-02 04:30:45',NULL,NULL),(17357,3181,'2346818','834','00','005010X220A1','2346818','','2014-01-31','14:53:36',0,'2014-01-31 21:01:21',NULL,NULL),(1833,315,'468724','834','00','005010X220A1','468724','','2013-12-10','16:04:39',0,'2013-12-25 19:20:40',NULL,NULL),(15616,2668,'2426998','834','00','005010X220A1','2426998','','2014-01-17','14:39:55',0,'2014-01-20 08:06:37',NULL,NULL),(15470,2634,'1853216','834','00','005010X220A1','1853216','','2014-01-15','22:14:11',0,'2014-01-17 03:36:18',NULL,NULL),(13915,2313,'2218011','834','00','005010X220A1','2218011','','2014-01-09','11:52:24',0,'2014-01-13 02:19:53',NULL,NULL),(5515,1041,'2111346','834','00','005010X220A1','2111346','','2013-12-24','20:45:44',0,'2013-12-26 01:46:52',NULL,NULL),(7720,1337,'1094230','834','00','005010X220A1','1094230','','2013-11-15','11:15:08',0,'2013-12-26 04:46:10',NULL,NULL),(7062,1236,'608801','834','00','005010X220A1','608801','','2013-12-17','20:06:41',0,'2013-12-26 04:02:23',NULL,NULL),(7409,1295,'1275438','834','00','005010X220A1','1275438','','2013-12-20','23:04:10',0,'2013-12-26 04:31:08',NULL,NULL),(20703,3893,'3749898','834','00','005010X220A1','3749898','','2014-02-24','20:26:02',0,'2014-02-25 21:00:13',NULL,NULL),(12698,1676,'2324798','834','00','005010X220A1','2324798','','2014-01-02','10:16:56',0,'2014-01-03 02:04:42',NULL,NULL),(11979,1580,'2097635','834','00','005010X220A1','2097635','','2013-12-30','16:08:06',0,'2014-01-01 12:01:19',NULL,NULL),(17559,3236,'2265022','834','00','005010X220A1','2265022','','2014-02-03','09:23:41',0,'2014-02-03 21:00:32',NULL,NULL),(1515,258,'1672440','834','00','005010X220A1','1672440','','2013-12-24','17:48:35',0,'2013-12-25 18:57:51',NULL,NULL),(11952,1580,'2102635','834','00','005010X220A1','2102635','','2013-12-29','23:39:20',0,'2014-01-01 12:00:17',NULL,NULL),(2890,530,'477237','834','00','005010X220A1','477237','','2013-12-22','16:17:09',0,'2013-12-25 21:23:22',NULL,NULL),(2998,542,'165811','834','00','005010X220A1','165811','','2013-12-13','14:47:31',0,'2013-12-25 21:33:03',NULL,NULL),(13989,2326,'1452477','834','00','005010X220A1','1452477','','2014-01-09','11:51:56',0,'2014-01-13 02:20:49',NULL,NULL),(3879,698,'1113575','834','00','005010X220A1','1113575','','2013-10-04','14:04:17',0,'2013-12-25 22:31:30',NULL,NULL),(5688,1066,'2183814','834','00','005010X220A1','2183814','','2013-12-25','15:45:15',0,'2013-12-26 01:52:46',NULL,NULL),(21617,4065,'3413356','834','00','005010X220A1','3413356','','2014-02-27','11:33:12',0,'2014-02-28 07:30:17',NULL,NULL),(22511,4247,'3700728','834','00','005010X220A1','3700728','','2014-03-05','11:12:54',0,'2014-03-05 21:30:14',NULL,NULL),(23406,4404,'3037307','834','00','005010X220A1','3037307','','2014-03-08','23:52:07',0,'2014-03-09 21:00:16',NULL,NULL),(283,61,'107889','834','00','005010X220A1','107889','','2013-11-08','18:40:44',0,'2013-12-25 17:32:06',NULL,NULL),(18041,3319,'2661375','834','00','005010X220A1','2661375','','2014-02-05','21:01:38',0,'2014-02-06 21:00:35',NULL,NULL),(5529,1041,'1384542','834','00','005010X220A1','1384542','','2013-12-24','22:46:19',0,'2013-12-26 01:47:19',NULL,NULL),(5738,1070,'258311','834','00','005010X220A1','258311','','2013-12-13','20:35:21',0,'2013-12-26 02:01:34',NULL,NULL),(1283,243,'1929250','834','00','005010X220A1','1929250','','2013-12-24','17:30:36',0,'2013-12-25 18:50:15',NULL,NULL),(2362,413,'698441','834','00','005010X220A1','698441','','2013-12-05','22:42:51',0,'2013-12-25 20:16:04',NULL,NULL),(5699,1067,'746861','834','00','005010X220A1','746861','','2013-12-14','13:07:44',0,'2013-12-26 02:00:24',NULL,NULL),(20440,3841,'2511909','834','00','005010X220A1','2511909','','2014-02-20','13:40:03',0,'2014-02-20 22:00:15',NULL,NULL),(21144,3997,'2878432','834','00','005010X220A1','2878432','','2014-02-26','08:34:05',0,'2014-02-26 21:00:40',NULL,NULL),(23522,4434,'3122377','834','00','005010X220A1','3122377','','2014-03-10','16:15:51',0,'2014-03-10 21:00:18',NULL,NULL),(11756,1523,'1763118','834','00','005010X220A1','1763118','','2013-12-28','14:49:47',1,'2013-12-29 11:09:37',NULL,NULL),(14799,2551,'1625911','834','00','005010X220A1','1625911','','2014-01-14','18:04:56',0,'2014-01-15 02:06:44',NULL,NULL),(6436,1204,'1078873','834','00','005010X220A1','1078873','','2013-11-22','16:25:43',0,'2013-12-26 03:15:36',NULL,NULL),(14593,2521,'2573643','834','00','005010X220A1','2573643','','2014-01-13','13:30:57',0,'2014-01-14 01:33:02',NULL,NULL),(1739,293,'1024895','834','00','005010X220A1','1024895','','2013-12-10','13:10:07',0,'2013-12-25 19:17:39',NULL,NULL),(23379,4398,'3125795','834','00','005010X220A1','3125795','','2014-03-08','16:46:20',0,'2014-03-08 21:31:20',NULL,NULL),(143,10,'365727','834','00','005010X220A1','365727','','2013-12-05','09:00:58',0,'2013-12-25 17:19:27',NULL,NULL),(15265,2602,'1699459','834','00','005010X220A1','1699459','','2014-01-14','23:40:52',0,'2014-01-16 08:47:07',NULL,NULL),(15160,2588,'1763623','834','00','005010X220A1','1763623','','2014-01-15','15:16:00',0,'2014-01-16 08:46:01',NULL,NULL),(5885,1109,'553656','834','00','005010X220A1','553656','','2013-12-15','11:06:23',0,'2013-12-26 02:30:16',NULL,NULL),(5157,944,'1015107','834','00','005010X220A1','1015107','','2013-12-10','22:52:05',0,'2013-12-26 00:51:01',NULL,NULL),(11750,1521,'1763120','834','00','005010X220A1','1763120','','2013-12-28','17:22:19',1,'2013-12-29 11:09:26',NULL,NULL),(5093,940,'151851','834','00','005010X220A1','151851','','2013-12-10','20:50:57',0,'2013-12-26 00:48:57',NULL,NULL),(4983,935,'71475','834','00','005010X220A1','71475','','2013-12-10','20:21:24',0,'2013-12-26 00:45:25',NULL,NULL),(4852,885,'362736','834','00','005010X220A1','362736','','2013-11-20','20:52:06',0,'2013-12-26 00:15:40',NULL,NULL),(18847,3491,'2535549','834','00','005010X220A1','2535549','','2014-02-11','12:42:02',0,'2014-02-11 21:01:50',NULL,NULL),(20457,3842,'2721279','834','00','005010X220A1','2721279','','2014-02-20','07:26:17',0,'2014-02-20 22:00:29',NULL,NULL),(21648,4074,'3004247','834','00','005010X220A1','3004247','','2014-02-27','15:56:03',0,'2014-02-28 07:30:38',NULL,NULL),(13374,2218,'0001','999','BE','005010X231A1','1039031','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:38',NULL,NULL),(824,167,'1050343','834','00','005010X220A1','1050343','','2013-10-19','17:28:36',0,'2013-12-25 18:11:04',NULL,NULL),(2869,515,'579406','834','00','005010X220A1','579406','','2013-12-22','09:21:54',0,'2013-12-25 21:22:36',NULL,NULL),(2798,506,'1484587','834','00','005010X220A1','1484587','','2013-12-22','12:02:38',0,'2013-12-25 21:20:17',NULL,NULL),(16635,3058,'1747114','834','00','005010X220A1','1747114','','2014-01-26','15:19:57',0,'2014-01-26 19:00:29',NULL,NULL),(16862,3093,'2244070','834','00','005010X220A1','2244070','','2014-01-28','12:07:37',0,'2014-01-28 21:00:48',NULL,NULL),(18818,3489,'2036184','834','00','005010X220A1','2036184','','2014-02-11','17:02:40',0,'2014-02-11 21:01:29',NULL,NULL),(18851,3491,'3234308','834','00','005010X220A1','3234308','','2014-02-11','13:41:15',0,'2014-02-11 21:01:54',NULL,NULL),(18982,3537,'3183631','834','00','005010X220A1','3183631','','2014-02-12','10:08:45',0,'2014-02-12 21:30:15',NULL,NULL),(19593,3630,'3068595','834','00','005010X220A1','3068595','','2014-02-13','19:11:21',0,'2014-02-14 21:31:33',NULL,NULL),(19755,3673,'2692440','834','00','005010X220A1','2692440','','2014-02-15','16:20:43',0,'2014-02-15 22:00:47',NULL,NULL),(19844,3691,'2473317','834','00','005010X220A1','2473317','','2014-02-14','20:00:28',0,'2014-02-15 22:02:00',NULL,NULL),(16867,3093,'1773787','834','00','005010X220A1','1773787','','2014-01-28','13:48:22',0,'2014-01-28 21:00:51',NULL,NULL),(17144,3144,'1694386','834','00','005010X220A1','1694386','','2014-01-30','11:47:54',0,'2014-01-30 21:00:33',NULL,NULL),(20050,3751,'3201590','834','00','005010X220A1','3201590','','2014-02-18','16:40:45',0,'2014-02-18 22:01:08',NULL,NULL),(20475,3842,'3097856','834','00','005010X220A1','3097856','','2014-02-20','16:11:32',0,'2014-02-20 22:00:43',NULL,NULL),(3989,725,'835668','834','00','005010X220A1','835668','','2013-12-07','11:01:46',0,'2013-12-25 22:47:53',NULL,NULL),(199,19,'1174532','834','00','005010X220A1','1174532','','2013-12-04','21:35:48',0,'2013-12-25 17:21:13',NULL,NULL),(4686,833,'1702450','834','00','005010X220A1','1702450','','2013-12-23','23:59:08',0,'2013-12-25 23:50:09',NULL,NULL),(7633,1309,'61050','834','00','005010X220A1','61050','','2013-12-20','21:38:33',0,'2013-12-26 04:38:18',NULL,NULL),(3787,656,'380866','834','00','005010X220A1','380866','','2013-12-08','15:04:25',0,'2013-12-25 22:15:52',NULL,NULL),(6172,1167,'772518','834','00','005010X220A1','772518','','2013-12-20','15:33:14',0,'2013-12-26 03:03:28',NULL,NULL),(2539,457,'1100820','834','00','005010X220A1','1100820','','2013-11-17','23:13:00',0,'2013-12-25 20:31:10',NULL,NULL),(16322,2982,'1486922','834','00','005010X220A1','1486922','','2014-01-23','12:56:41',0,'2014-01-23 21:00:29',NULL,NULL),(16422,3000,'1811474','834','00','005010X220A1','1811474','','2014-01-23','09:12:04',0,'2014-01-23 21:01:37',NULL,NULL),(16779,3079,'2329224','834','00','005010X220A1','2329224','','2014-01-27','13:18:01',0,'2014-01-27 21:01:41',NULL,NULL),(19988,3746,'3457366','834','00','005010X220A1','3457366','','2014-02-18','17:23:24',0,'2014-02-18 22:00:25',NULL,NULL),(22346,4204,'3778424','834','00','005010X220A1','3778424','','2014-03-04','14:21:54',0,'2014-03-04 21:01:34',NULL,NULL),(23531,4435,'3637091','834','00','005010X220A1','3637091','','2014-03-09','18:26:32',0,'2014-03-10 21:00:24',NULL,NULL),(391,76,'158701','834','00','005010X220A1','158701','','2013-12-03','22:14:13',0,'2013-12-25 17:48:05',NULL,NULL),(15369,2624,'2203969','834','00','005010X220A1','2203969','','2014-01-15','22:36:01',0,'2014-01-17 03:35:32',NULL,NULL),(10649,1402,'1556232','834','00','005010X220A1','1556232','','2013-12-23','18:08:23',0,'2013-12-26 12:58:46',NULL,NULL),(3464,615,'1173637','834','00','005010X220A1','1173637','','2013-12-11','18:25:07',0,'2013-12-25 22:00:02',NULL,NULL),(3052,544,'161066','834','00','005010X220A1','161066','','2013-12-13','13:49:26',0,'2013-12-25 21:34:41',NULL,NULL),(16678,3062,'1944095','834','00','005010X220A1','1944095','','2014-01-26','19:05:00',0,'2014-01-27 21:00:29',NULL,NULL),(16781,3080,'1529703','834','00','005010X220A1','1529703','','2014-01-27','15:10:47',0,'2014-01-27 21:01:42',NULL,NULL),(17102,3142,'2578710','834','00','005010X220A1','2578710','','2014-01-30','09:12:08',0,'2014-01-30 21:00:07',NULL,NULL),(17915,3296,'1649429','834','00','005010X220A1','1649429','','2014-02-05','06:19:13',0,'2014-02-05 21:30:38',NULL,NULL),(18608,3456,'2737232','834','00','005010X220A1','2737232','','2014-02-10','14:03:42',0,'2014-02-10 21:31:09',NULL,NULL),(20837,3911,'3114229','834','00','005010X220A1','3114229','','2014-02-25','11:46:18',0,'2014-02-25 21:31:21',NULL,NULL),(21730,4088,'3359742','834','00','005010X220A1','3359742','','2014-02-28','17:30:37',0,'2014-02-28 21:30:33',NULL,NULL),(22208,4186,'3160265','834','00','005010X220A1','3160265','','2014-03-03','11:56:03',0,'2014-03-03 21:31:37',NULL,NULL),(23664,4444,'3079022','834','00','005010X220A1','3079022','','2014-03-10','11:55:10',0,'2014-03-10 21:02:01',NULL,NULL),(15523,2651,'2210444','834','00','005010X220A1','2210444','','2014-01-15','19:29:10',0,'2014-01-17 03:36:41',NULL,NULL),(742,131,'970586','834','00','005010X220A1','970586','','2013-12-16','12:43:22',0,'2013-12-25 18:08:06',NULL,NULL),(14983,2577,'1816269','834','00','005010X220A1','1816269','','2014-01-14','14:26:10',0,'2014-01-15 02:08:08',NULL,NULL),(10727,1403,'658852','834','00','005010X220A1','658852','','2013-12-23','14:32:55',0,'2013-12-26 13:01:31',NULL,NULL),(14668,2543,'1700740','834','00','005010X220A1','1700740','','2014-01-13','16:10:18',0,'2014-01-14 01:33:52',NULL,NULL),(12359,1634,'1469557','834','00','005010X220A1','1469557','','2013-12-31','14:47:49',1,'2014-01-02 04:28:10',NULL,NULL),(11002,1413,'469358','834','00','005010X220A1','469358','','2013-12-23','17:54:14',0,'2013-12-26 13:10:51',NULL,NULL),(3478,615,'132415','834','00','005010X220A1','132415','','2013-12-12','08:31:55',0,'2013-12-25 22:00:28',NULL,NULL),(18695,3476,'3093997','834','00','005010X220A1','3093997','','2014-02-10','12:19:44',0,'2014-02-10 21:32:10',NULL,NULL),(18979,3537,'2195895','834','00','005010X220A1','2195895','','2014-02-12','13:11:50',0,'2014-02-12 21:30:13',NULL,NULL),(21142,3996,'3512523','834','00','005010X220A1','3512523','','2014-02-26','17:32:20',0,'2014-02-26 21:00:39',NULL,NULL),(21953,4136,'3430292','834','00','005010X220A1','3430292','','2014-03-01','14:37:07',0,'2014-03-01 21:01:08',NULL,NULL),(447,81,'734559','834','00','005010X220A1','734559','','2013-12-04','13:10:03',0,'2013-12-25 17:49:52',NULL,NULL),(15691,2698,'1391525','834','00','005010X220A1','1391525','','2014-01-19','16:31:32',0,'2014-01-21 08:45:21',NULL,NULL),(4727,843,'30853','834','00','005010X220A1','30853','','2013-12-23','23:41:32',0,'2013-12-25 23:51:36',NULL,NULL),(5355,1005,'544784','834','00','005010X220A1','544784','','2013-11-25','16:51:03',0,'2013-12-26 01:16:01',NULL,NULL),(2220,367,'1006495','834','00','005010X220A1','1006495','','2013-12-02','09:46:36',0,'2013-12-25 19:48:50',NULL,NULL),(3101,546,'1166152','834','00','005010X220A1','1166152','','2013-12-13','11:48:19',0,'2013-12-25 21:36:13',NULL,NULL),(16546,3023,'1937742','834','00','005010X220A1','1937742','','2014-01-24','12:48:53',0,'2014-01-24 21:01:10',NULL,NULL),(16705,3064,'2111092','834','00','005010X220A1','2111092','','2014-01-27','10:19:22',0,'2014-01-27 21:00:47',NULL,NULL),(18475,3429,'2497983','834','00','005010X220A1','2497983','','2014-02-10','04:20:44',0,'2014-02-10 11:00:55',NULL,NULL),(19513,3622,'3068596','834','00','005010X220A1','3068596','','2014-02-13','19:16:59',0,'2014-02-14 21:30:34',NULL,NULL),(20700,3892,'3001743','834','00','005010X220A1','3001743','','2014-02-25','15:09:33',0,'2014-02-25 21:00:11',NULL,NULL),(23288,4380,'3668574','834','00','005010X220A1','3668574','','2014-03-08','14:14:41',0,'2014-03-08 21:30:11',NULL,NULL),(6064,1164,'698977','834','00','005010X220A1','698977','','2013-12-20','09:21:05',0,'2013-12-26 03:00:09',NULL,NULL),(589,105,'58390','834','00','005010X220A1','58390','','2013-12-16','10:32:06',0,'2013-12-25 18:03:13',NULL,NULL),(10956,1410,'294871','834','00','005010X220A1','294871','','2013-12-23','18:22:06',0,'2013-12-26 13:09:22',NULL,NULL),(1422,250,'1726092','834','00','005010X220A1','1726092','','2013-12-24','07:53:58',0,'2013-12-25 18:54:46',NULL,NULL),(2348,413,'371585','834','00','005010X220A1','371585','','2013-12-06','11:31:12',0,'2013-12-25 20:15:35',NULL,NULL),(17620,3243,'1784135','834','00','005010X220A1','1784135','','2014-02-03','13:23:08',0,'2014-02-03 21:01:11',NULL,NULL),(18065,3321,'2103584','834','00','005010X220A1','2103584','','2014-02-06','15:22:30',0,'2014-02-06 21:00:52',NULL,NULL),(10734,1403,'1511780','834','00','005010X220A1','1511780','','2013-12-23','15:02:24',0,'2013-12-26 13:01:43',NULL,NULL),(7447,1296,'437797','834','00','005010X220A1','437797','','2013-12-20','20:26:57',0,'2013-12-26 04:32:20',NULL,NULL),(7149,1237,'223232','834','00','005010X220A1','223232','','2013-12-18','15:50:32',0,'2013-12-26 04:05:03',NULL,NULL),(7107,1236,'1069845','834','00','005010X220A1','1069845','','2013-12-18','12:44:48',0,'2013-12-26 04:03:48',NULL,NULL),(3695,633,'929908','834','00','005010X220A1','929908','','2013-12-12','11:02:36',0,'2013-12-25 22:07:21',NULL,NULL),(15300,2621,'2071768','834','00','005010X220A1','2071768','','2014-01-15','17:38:36',0,'2014-01-16 08:47:31',NULL,NULL),(14689,2549,'1740641','834','00','005010X220A1','1740641','','2014-01-14','11:08:32',0,'2014-01-15 02:05:56',NULL,NULL),(12526,1645,'1480412','834','00','005010X220A1','1480412','','2013-12-31','10:30:08',1,'2014-01-02 04:34:16',NULL,NULL),(17682,3259,'2513955','834','00','005010X220A1','2513955','','2014-02-04','14:13:34',0,'2014-02-04 21:00:19',NULL,NULL),(20936,3942,'3148752','834','00','005010X220A1','3148752','','2014-02-23','14:00:13',0,'2014-02-26 08:00:30',NULL,NULL),(22842,4279,'2968069','834','00','005010X220A1','2968069','','2014-03-05','18:44:01',0,'2014-03-06 21:01:33',NULL,NULL),(23758,4476,'2916003','834','00','005010X220A1','2916003','','2014-03-10','13:33:47',0,'2014-03-10 21:30:09',NULL,NULL),(10689,1403,'749754','834','00','005010X220A1','749754','','2013-12-23','06:38:45',0,'2013-12-26 13:00:06',NULL,NULL),(13243,2087,'0001','999','BE','005010X231A1','99905','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:52',NULL,NULL),(4306,749,'593835','834','00','005010X220A1','593835','','2013-12-19','15:03:49',0,'2013-12-25 23:09:28',NULL,NULL),(4227,738,'1166420','834','00','005010X220A1','1166420','','2013-12-19','12:43:23',0,'2013-12-25 23:07:04',NULL,NULL),(5791,1075,'286075','834','00','005010X220A1','286075','','2013-12-14','16:07:24',0,'2013-12-26 02:03:15',NULL,NULL),(4978,935,'554916','834','00','005010X220A1','554916','','2013-12-10','19:20:48',0,'2013-12-26 00:45:18',NULL,NULL),(2816,506,'338738','834','00','005010X220A1','338738','','2013-12-22','18:02:34',0,'2013-12-25 21:20:49',NULL,NULL),(17151,3144,'1602050','834','00','005010X220A1','1602050','','2014-01-30','15:31:00',0,'2014-01-30 21:00:38',NULL,NULL),(17481,3219,'2737062','834','00','005010X220A1','2737062','','2014-02-02','15:27:34',0,'2014-02-02 19:00:13',NULL,NULL),(17910,3296,'2408399','834','00','005010X220A1','2408399','','2014-02-04','20:05:55',0,'2014-02-05 21:30:36',NULL,NULL),(18386,3407,'2812731','834','00','005010X220A1','2812731','','2014-02-09','16:40:40',0,'2014-02-09 19:00:25',NULL,NULL),(83,4,'881086','834','00','005010X220A1','881086','','2013-12-04','22:08:10',0,'2013-12-25 17:17:30',NULL,NULL),(13144,1988,'0001','999','BE','005010X231A1','669242','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:16',NULL,NULL),(13123,1967,'0001','999','BE','005010X231A1','910292','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:42',NULL,NULL),(1043,204,'949026','834','00','005010X220A1','949026','','2013-11-28','19:20:59',0,'2013-12-25 18:30:04',NULL,NULL),(7670,1319,'530095','834','00','005010X220A1','530095','','2013-12-21','11:34:39',0,'2013-12-26 04:39:30',NULL,NULL),(6040,1150,'809114','834','00','005010X220A1','809114','','2013-10-13','20:10:26',0,'2013-12-26 02:46:14',NULL,NULL),(12460,1639,'2002605','834','00','005010X220A1','2002605','','2013-12-31','13:04:39',1,'2014-01-02 04:31:51',NULL,NULL),(12387,1637,'1413564','834','00','005010X220A1','1413564','','2013-12-31','09:21:46',1,'2014-01-02 04:29:12',NULL,NULL),(3951,715,'875841','834','00','005010X220A1','875841','','2013-12-06','22:03:45',0,'2013-12-25 22:46:34',NULL,NULL),(16839,3091,'2489257','834','00','005010X220A1','2489257','','2014-01-28','17:15:11',0,'2014-01-28 21:00:31',NULL,NULL),(23187,4345,'3778562','834','00','005010X220A1','3778562','','2014-03-07','14:17:30',0,'2014-03-07 21:31:37',NULL,NULL),(15596,2660,'1583391','834','00','005010X220A1','1583391','','2014-01-17','11:17:13',0,'2014-01-20 08:06:24',NULL,NULL),(14801,2551,'1387162','834','00','005010X220A1','1387162','','2014-01-14','18:27:39',0,'2014-01-15 02:06:45',NULL,NULL),(14782,2551,'1356757','834','00','005010X220A1','1356757','','2014-01-14','14:57:45',0,'2014-01-15 02:06:37',NULL,NULL),(12417,1638,'2377209','834','00','005010X220A1','2377209','','2013-12-30','19:45:03',1,'2014-01-02 04:30:17',NULL,NULL),(1806,308,'104240','834','00','005010X220A1','104240','','2013-12-10','09:46:44',0,'2013-12-25 19:19:50',NULL,NULL),(12271,1623,'2349115','834','00','005010X220A1','2349115','','2014-01-01','10:48:24',1,'2014-01-02 04:24:16',NULL,NULL),(2619,489,'846883','834','00','005010X220A1','846883','','2013-11-28','12:06:09',0,'2013-12-25 20:46:34',NULL,NULL),(2883,524,'523974','834','00','005010X220A1','523974','','2013-12-22','15:31:29',0,'2013-12-25 21:23:05',NULL,NULL),(19312,3583,'2641135','834','00','005010X220A1','2641135','','2014-02-12','21:51:24',0,'2014-02-13 22:01:22',NULL,NULL),(6355,1180,'949676','834','00','005010X220A1','949676','','2013-12-19','21:43:48',0,'2013-12-26 03:09:03',NULL,NULL),(1148,239,'1920054','834','00','005010X220A1','1920054','','2013-12-24','10:15:30',0,'2013-12-25 18:46:08',NULL,NULL),(16375,2986,'2369367','834','00','005010X220A1','2369367','','2014-01-23','11:13:44',0,'2014-01-23 21:01:06',NULL,NULL),(1581,278,'984995','834','00','005010X220A1','984995','','2013-11-20','01:03:23',0,'2013-12-25 19:00:40',NULL,NULL),(16193,2885,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:22:00',1,'2014-01-23 04:34:33',NULL,NULL),(16576,3037,'2565004','834','00','005010X220A1','2565004','','2014-01-24','22:14:35',0,'2014-01-25 19:00:09',NULL,NULL),(18376,3406,'1553314','834','00','005010X220A1','1553314','','2014-02-09','15:56:53',0,'2014-02-09 19:00:19',NULL,NULL),(21945,4133,'3143848','834','00','005010X220A1','3143848','','2014-02-28','20:17:03',0,'2014-03-01 21:01:02',NULL,NULL),(15893,2740,'1785274','834','00','005010X220A1','1785274','','2014-01-21','10:47:48',1,'2014-01-22 03:22:36',NULL,NULL),(12790,1703,'1513347','834','00','005010X220A1','1513347','','2014-01-03','10:35:10',0,'2014-01-04 02:00:53',NULL,NULL),(3777,656,'140776','834','00','005010X220A1','140776','','2013-12-07','20:41:14',0,'2013-12-25 22:15:34',NULL,NULL),(1009,188,'1188357','834','00','005010X220A1','1188357','','2013-12-03','16:05:12',0,'2013-12-25 18:20:33',NULL,NULL),(4219,738,'813664','834','00','005010X220A1','813664','','2013-12-18','23:40:45',0,'2013-12-25 23:06:48',NULL,NULL),(17629,3243,'2064799','834','00','005010X220A1','2064799','','2014-02-03','18:05:21',0,'2014-02-03 21:01:16',NULL,NULL),(17941,3299,'2240716','834','00','005010X220A1','2240716','','2014-02-04','20:49:49',0,'2014-02-05 21:30:50',NULL,NULL),(23759,4477,'3723546','834','00','005010X220A1','3723546','','2014-03-10','12:00:04',0,'2014-03-10 21:30:10',NULL,NULL),(16092,2784,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',0,'2014-01-23 03:39:32',NULL,NULL),(7568,1301,'171198','834','00','005010X220A1','171198','','2013-12-21','12:43:15',0,'2013-12-26 04:36:13',NULL,NULL),(6993,1235,'664958','834','00','005010X220A1','664958','','2013-12-17','18:32:26',0,'2013-12-26 04:00:16',NULL,NULL),(13646,2271,'2030084','834','00','005010X220A1','2030084','','2014-01-07','10:32:21',0,'2014-01-08 18:24:08',NULL,NULL),(3947,715,'1145686','834','00','005010X220A1','1145686','','2013-12-06','19:23:33',0,'2013-12-25 22:46:26',NULL,NULL),(3441,603,'145158','834','00','005010X220A1','145158','','2013-12-17','10:47:48',0,'2013-12-25 21:53:02',NULL,NULL),(20182,3778,'3243063','834','00','005010X220A1','3243063','','2014-02-19','16:50:12',0,'2014-02-20 04:13:41',NULL,NULL),(16394,2992,'1833339','834','00','005010X220A1','1833339','','2014-01-23','13:44:47',0,'2014-01-23 21:01:19',NULL,NULL),(15780,2717,'1787922','834','00','005010X220A1','1787922','','2014-01-20','10:37:43',0,'2014-01-21 08:46:36',NULL,NULL),(605,107,'591255','834','00','005010X220A1','591255','','2013-12-16','18:06:55',0,'2013-12-25 18:03:45',NULL,NULL),(11594,1493,'86697','834','00','005010X220A1','86697','','2013-12-26','19:15:32',0,'2013-12-28 03:34:33',NULL,NULL),(11389,1463,'1578922','834','00','005010X220A1','1578922','','2013-12-26','15:49:18',0,'2013-12-27 02:06:12',NULL,NULL),(15581,2658,'2418158','834','00','005010X220A1','2418158','','2014-01-16','20:38:21',0,'2014-01-20 08:06:13',NULL,NULL),(4013,731,'459139','834','00','005010X220A1','459139','','2013-12-19','10:25:08',0,'2013-12-25 23:00:31',NULL,NULL),(4276,742,'818611','834','00','005010X220A1','818611','','2013-12-19','16:31:25',0,'2013-12-25 23:08:35',NULL,NULL),(6096,1166,'672413','834','00','005010X220A1','672413','','2013-12-20','08:51:48',0,'2013-12-26 03:01:12',NULL,NULL),(7333,1275,'442792','834','00','005010X220A1','442792','','2013-12-18','17:31:26',0,'2013-12-26 04:10:44',NULL,NULL),(10477,1400,'1465561','834','00','005010X220A1','1465561','','2013-12-23','15:11:14',0,'2013-12-26 12:53:08',NULL,NULL),(17704,3261,'2692097','834','00','005010X220A1','2692097','','2014-02-03','20:38:36',0,'2014-02-04 21:00:32',NULL,NULL),(18219,3357,'2334619','834','00','005010X220A1','2334619','','2014-02-06','23:05:55',0,'2014-02-07 19:00:49',NULL,NULL),(19718,3672,'3511117','834','00','005010X220A1','3511117','','2014-02-14','20:25:30',0,'2014-02-15 22:00:21',NULL,NULL),(23582,4436,'3771267','834','00','005010X220A1','3771267','','2014-03-10','17:28:00',0,'2014-03-10 21:01:04',NULL,NULL),(11385,1463,'2028499','834','00','005010X220A1','2028499','','2013-12-26','12:17:53',0,'2013-12-27 02:06:04',NULL,NULL),(16763,3071,'2516211','834','00','005010X220A1','2516211','','2014-01-27','10:49:17',0,'2014-01-27 21:01:28',NULL,NULL),(635,108,'662245','834','00','005010X220A1','662245','','2013-12-16','12:23:42',0,'2013-12-25 18:04:45',NULL,NULL),(1081,216,'227792','834','00','005010X220A1','227792','','2013-11-04','17:39:25',0,'2013-12-25 18:31:18',NULL,NULL),(5487,1040,'723123','834','00','005010X220A1','723123','','2013-12-25','12:49:36',0,'2013-12-26 01:45:58',NULL,NULL),(3021,543,'830834','834','00','005010X220A1','830834','','2013-12-13','16:12:39',0,'2013-12-25 21:33:45',NULL,NULL),(14981,2576,'2148255','834','00','005010X220A1','2148255','','2014-01-14','14:15:51',0,'2014-01-15 02:08:07',NULL,NULL),(13795,2294,'2496194','834','00','005010X220A1','2496194','','2014-01-11','11:35:10',0,'2014-01-13 02:18:11',NULL,NULL),(11780,1534,'1683209','834','00','005010X220A1','1683209','','2013-12-28','17:27:53',1,'2013-12-29 11:10:22',NULL,NULL),(12259,1620,'2040676','834','00','005010X220A1','2040676','','2014-01-01','12:27:27',1,'2014-01-02 04:23:46',NULL,NULL),(17158,3144,'2368379','834','00','005010X220A1','2368379','','2014-01-30','16:43:32',0,'2014-01-30 21:00:41',NULL,NULL),(17662,3258,'2676862','834','00','005010X220A1','2676862','','2014-02-03','20:53:17',0,'2014-02-04 21:00:05',NULL,NULL),(18278,3378,'2120928','834','00','005010X220A1','2120928','','2014-02-07','18:31:41',0,'2014-02-08 19:00:20',NULL,NULL),(21788,4092,'3283082','834','00','005010X220A1','3283082','','2014-02-27','20:59:00',0,'2014-02-28 21:31:13',NULL,NULL),(13300,2144,'0001','999','BE','005010X231A1','177167','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:12',NULL,NULL),(436,79,'1111420','834','00','005010X220A1','1111420','','2013-12-04','16:58:36',0,'2013-12-25 17:49:31',NULL,NULL),(12542,1651,'1651306','834','00','005010X220A1','1651306','','2013-12-31','10:46:41',1,'2014-01-02 04:34:56',NULL,NULL),(4139,733,'317142','834','00','005010X220A1','317142','','2013-12-19','15:57:20',0,'2013-12-25 23:04:20',NULL,NULL),(10667,1403,'1485917','834','00','005010X220A1','1485917','','2013-12-22','18:56:30',0,'2013-12-26 12:59:19',NULL,NULL),(10375,1400,'365074','834','00','005010X220A1','365074','','2013-12-22','20:09:58',0,'2013-12-26 12:49:56',NULL,NULL),(3873,694,'997394','834','00','005010X220A1','997394','','2013-10-10','03:56:01',0,'2013-12-25 22:31:18',NULL,NULL),(7351,1282,'585152','834','00','005010X220A1','585152','','2013-11-30','17:52:15',0,'2013-12-26 04:15:30',NULL,NULL),(7474,1296,'806267','834','00','005010X220A1','806267','','2013-12-21','14:46:24',0,'2013-12-26 04:33:05',NULL,NULL),(23384,4401,'3050258','834','00','005010X220A1','3050258','','2014-03-08','18:38:57',0,'2014-03-09 20:59:59',NULL,NULL),(13934,2317,'1647675','834','00','005010X220A1','1647675','','2014-01-08','19:48:17',0,'2014-01-13 02:20:09',NULL,NULL),(10474,1400,'917340','834','00','005010X220A1','917340','','2013-12-23','14:56:30',0,'2013-12-26 12:53:02',NULL,NULL),(10389,1400,'1248265','834','00','005010X220A1','1248265','','2013-12-23','00:24:53',0,'2013-12-26 12:50:23',NULL,NULL),(6990,1234,'1017878','834','00','005010X220A1','1017878','','2013-12-18','12:43:35',0,'2013-12-26 04:00:09',NULL,NULL),(4948,921,'154309','834','00','005010X220A1','154309','','2013-11-19','16:36:46',0,'2013-12-26 00:31:45',NULL,NULL),(7146,1237,'731671','834','00','005010X220A1','731671','','2013-12-18','11:49:33',0,'2013-12-26 04:04:59',NULL,NULL),(5832,1091,'832618','834','00','005010X220A1','832618','','2013-11-22','22:31:39',0,'2013-12-26 02:15:28',NULL,NULL),(20585,3870,'3557939','834','00','005010X220A1','3557939','','2014-02-20','21:12:19',0,'2014-02-21 22:00:03',NULL,NULL),(21618,4065,'2665847','834','00','005010X220A1','2665847','','2014-02-27','13:06:31',0,'2014-02-28 07:30:18',NULL,NULL),(21669,4078,'2648645','834','00','005010X220A1','2648645','','2014-02-28','10:32:37',0,'2014-02-28 21:00:13',NULL,NULL),(22871,4281,'3722295','834','00','005010X220A1','3722295','','2014-03-05','19:43:06',0,'2014-03-06 21:01:54',NULL,NULL),(16634,3057,'1543879','834','00','005010X220A1','1543879','','2014-01-26','11:41:30',0,'2014-01-26 19:00:28',NULL,NULL),(16588,3040,'1764856','834','00','005010X220A1','1764856','','2014-01-25','12:00:11',0,'2014-01-25 19:00:16',NULL,NULL),(13774,2286,'1852953','834','00','005010X220A1','1852953','','2014-01-07','11:11:22',0,'2014-01-08 18:25:02',NULL,NULL),(7201,1241,'224524','834','00','005010X220A1','224524','','2013-12-17','19:14:56',0,'2013-12-26 04:06:38',NULL,NULL),(11091,1424,'1564877','834','00','005010X220A1','1564877','','2013-12-22','22:36:56',0,'2013-12-26 13:13:49',NULL,NULL),(10515,1401,'1392869','834','00','005010X220A1','1392869','','2013-12-22','21:48:49',0,'2013-12-26 12:54:19',NULL,NULL),(17782,3267,'2820628','834','00','005010X220A1','2820628','','2014-02-04','17:27:55',0,'2014-02-04 21:01:20',NULL,NULL),(18827,3490,'2771380','834','00','005010X220A1','2771380','','2014-02-11','11:37:04',0,'2014-02-11 21:01:35',NULL,NULL),(18910,3509,'3121517','834','00','005010X220A1','3121517','','2014-02-11','11:19:10',0,'2014-02-11 21:02:46',NULL,NULL),(20011,3748,'2452367','834','00','005010X220A1','2452367','','2014-02-18','17:55:06',0,'2014-02-18 22:00:40',NULL,NULL),(20274,3795,'2592249','834','00','005010X220A1','2592249','','2014-02-19','08:31:05',0,'2014-02-20 04:36:35',NULL,NULL),(22325,4202,'2740384','834','00','005010X220A1','2740384','','2014-03-04','12:43:16',0,'2014-03-04 21:01:17',NULL,NULL),(15014,2584,'2601831','834','00','005010X220A1','2601831','','2014-01-15','12:49:16',0,'2014-01-16 08:44:26',NULL,NULL),(14265,2375,'2320350','834','00','005010X220A1','2320350','','2014-01-10','11:21:42',0,'2014-01-13 03:00:07',NULL,NULL),(3354,587,'320791','834','00','005010X220A1','320791','','2013-12-17','09:22:08',0,'2013-12-25 21:50:17',NULL,NULL),(6418,1202,'725806','834','00','005010X220A1','725806','','2013-11-22','10:25:42',0,'2013-12-26 03:15:04',NULL,NULL),(5477,1040,'2004727','834','00','005010X220A1','2004727','','2013-12-24','22:45:10',0,'2013-12-26 01:45:39',NULL,NULL),(13432,2222,'1514814','834','00','005010X220A1','1514814','','2014-01-06','17:56:59',0,'2014-01-07 04:01:59',NULL,NULL),(4815,868,'717770','834','00','005010X220A1','717770','','2013-11-30','20:37:50',0,'2013-12-26 00:02:17',NULL,NULL),(4818,871,'980224','834','00','005010X220A1','980224','','2013-12-01','11:20:50',0,'2013-12-26 00:02:24',NULL,NULL),(20106,3772,'2861520','834','00','005010X220A1','2861520','','2014-02-18','18:10:49',0,'2014-02-20 03:44:23',NULL,NULL),(20404,3832,'3436242','834','00','005010X220A1','3436242','','2014-02-20','17:30:47',0,'2014-02-20 21:30:09',NULL,NULL),(23749,4473,'3041186','834','00','005010X220A1','3041186','','2014-03-10','09:51:25',0,'2014-03-10 21:30:00',NULL,NULL),(11226,1454,'1645027','834','00','005010X220A1','1645027','','2013-12-26','10:40:41',0,'2013-12-27 02:01:14',NULL,NULL),(7604,1303,'675123','834','00','005010X220A1','675123','','2013-12-21','10:57:32',0,'2013-12-26 04:37:24',NULL,NULL),(17563,3236,'1860587','834','00','005010X220A1','1860587','','2014-02-03','11:24:32',0,'2014-02-03 21:00:34',NULL,NULL),(2544,457,'190679','834','00','005010X220A1','190679','','2013-11-18','12:24:21',0,'2013-12-25 20:31:20',NULL,NULL),(2750,503,'666488','834','00','005010X220A1','666488','','2013-12-22','18:16:55',0,'2013-12-25 21:18:44',NULL,NULL),(3710,633,'139818','834','00','005010X220A1','139818','','2013-12-12','16:15:05',0,'2013-12-25 22:07:51',NULL,NULL),(3433,599,'451178','834','00','005010X220A1','451178','','2013-12-17','08:44:19',0,'2013-12-25 21:52:46',NULL,NULL),(20091,3765,'2608469','834','00','005010X220A1','2608469','','2014-02-18','14:44:41',0,'2014-02-18 22:01:39',NULL,NULL),(20876,3918,'3323489','834','00','005010X220A1','3323489','','2014-02-25','08:28:06',0,'2014-02-25 21:31:51',NULL,NULL),(21194,3998,'3604259','834','00','005010X220A1','3604259','','2014-02-26','14:39:51',0,'2014-02-26 21:01:12',NULL,NULL),(21279,4003,'2606141','834','00','005010X220A1','2606141','','2014-02-26','15:13:02',0,'2014-02-26 21:02:09',NULL,NULL),(22076,4174,'3540816','834','00','005010X220A1','3540816','','2014-03-03','09:01:48',0,'2014-03-03 21:29:59',NULL,NULL),(22143,4179,'2838750','834','00','005010X220A1','2838750','','2014-03-03','13:23:00',0,'2014-03-03 21:30:50',NULL,NULL),(14971,2571,'1590324','834','00','005010X220A1','1590324','','2014-01-14','15:37:49',0,'2014-01-15 02:08:02',NULL,NULL),(377,74,'1093190','834','00','005010X220A1','1093190','','2013-12-04','18:13:01',0,'2013-12-25 17:47:38',NULL,NULL),(11723,1520,'1909601','834','00','005010X220A1','1909601','','2013-12-28','12:09:34',1,'2013-12-29 11:08:37',NULL,NULL),(1437,252,'304736','834','00','005010X220A1','304736','','2013-12-24','10:25:17',0,'2013-12-25 18:55:14',NULL,NULL),(14439,2460,'0001','999','BE','005010X231A1','231159','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:10',NULL,NULL),(7718,1336,'7119','834','00','005010X220A1','7119','','2013-11-15','02:46:28',0,'2013-12-26 04:46:05',NULL,NULL),(5697,1067,'1003197','834','00','005010X220A1','1003197','','2013-12-14','11:58:22',0,'2013-12-26 02:00:18',NULL,NULL),(6367,1182,'610041','834','00','005010X220A1','610041','','2013-12-20','14:29:20',0,'2013-12-26 03:09:26',NULL,NULL),(20282,3795,'3528213','834','00','005010X220A1','3528213','','2014-02-19','10:21:42',0,'2014-02-20 04:38:31',NULL,NULL),(21445,4028,'2970381','834','00','005010X220A1','2970381','','2014-02-26','19:04:22',0,'2014-02-28 06:30:56',NULL,NULL),(796,149,'780926','834','00','005010X220A1','780926','','2013-10-28','20:24:52',0,'2013-12-25 18:10:02',NULL,NULL),(16568,3035,'2622272','834','00','005010X220A1','2622272','','2014-01-24','21:29:19',0,'2014-01-25 19:00:05',NULL,NULL),(10589,1402,'1134109','834','00','005010X220A1','1134109','','2013-12-23','12:19:18',0,'2013-12-26 12:56:47',NULL,NULL),(15522,2650,'1421485','834','00','005010X220A1','1421485','','2014-01-15','19:15:22',0,'2014-01-17 03:36:40',NULL,NULL),(2665,501,'1051347','834','00','005010X220A1','1051347','','2013-12-22','15:55:22',0,'2013-12-25 21:16:02',NULL,NULL),(14016,2337,'1823581','834','00','005010X220A1','1823581','','2014-01-07','22:37:41',0,'2014-01-13 02:21:16',NULL,NULL),(18085,3323,'2442007','834','00','005010X220A1','2442007','','2014-02-06','12:33:01',0,'2014-02-06 21:01:05',NULL,NULL),(19451,3607,'2855010','834','00','005010X220A1','2855010','','2014-02-13','15:51:35',0,'2014-02-13 22:03:08',NULL,NULL),(19993,3748,'3028038','834','00','005010X220A1','3028038','','2014-02-17','20:05:07',0,'2014-02-18 22:00:28',NULL,NULL),(22055,4168,'3448827','834','00','005010X220A1','3448827','','2014-03-02','22:15:15',0,'2014-03-03 21:00:14',NULL,NULL),(22671,4255,'2677669','834','00','005010X220A1','2677669','','2014-03-04','19:33:51',0,'2014-03-05 21:32:07',NULL,NULL),(16370,2986,'2221995','834','00','005010X220A1','2221995','','2014-01-23','13:40:02',0,'2014-01-23 21:01:03',NULL,NULL),(978,184,'497633','834','00','005010X220A1','497633','','2013-12-03','09:46:38',0,'2013-12-25 18:19:32',NULL,NULL),(1262,243,'1757599','834','00','005010X220A1','1757599','','2013-12-24','13:24:19',0,'2013-12-25 18:49:34',NULL,NULL),(11392,1463,'1986680','834','00','005010X220A1','1986680','','2013-12-26','16:11:32',0,'2013-12-27 02:06:17',NULL,NULL),(15583,2658,'1673103','834','00','005010X220A1','1673103','','2014-01-17','12:31:13',0,'2014-01-20 08:06:14',NULL,NULL),(15086,2585,'1573238','834','00','005010X220A1','1573238','','2014-01-15','13:43:33',0,'2014-01-16 08:45:11',NULL,NULL),(4551,825,'1303369','834','00','005010X220A1','1303369','','2013-12-23','22:59:42',0,'2013-12-25 23:45:43',NULL,NULL),(5190,949,'1053281','834','00','005010X220A1','1053281','','2013-12-11','11:16:44',0,'2013-12-26 00:52:02',NULL,NULL),(18110,3330,'2372032','834','00','005010X220A1','2372032','','2014-02-06','15:10:17',0,'2014-02-06 21:01:23',NULL,NULL),(18380,3407,'2769856','834','00','005010X220A1','2769856','','2014-02-08','21:33:11',0,'2014-02-09 19:00:21',NULL,NULL),(22384,4208,'2868493','834','00','005010X220A1','2868493','','2014-03-04','14:10:08',0,'2014-03-04 21:02:06',NULL,NULL),(11766,1527,'1967842','834','00','005010X220A1','1967842','','2013-12-28','16:20:41',1,'2013-12-29 11:09:55',NULL,NULL),(960,181,'874493','834','00','005010X220A1','874493','','2013-12-03','16:47:40',0,'2013-12-25 18:18:56',NULL,NULL),(1576,277,'886882','834','00','005010X220A1','886882','','2013-11-20','10:34:02',0,'2013-12-25 19:00:30',NULL,NULL),(2219,367,'1006493','834','00','005010X220A1','1006493','','2013-12-02','09:17:14',0,'2013-12-25 19:48:47',NULL,NULL),(7279,1254,'1161081','834','00','005010X220A1','1161081','','2013-12-18','16:20:26',0,'2013-12-26 04:09:04',NULL,NULL),(11211,1454,'1289377','834','00','005010X220A1','1289377','','2013-12-26','09:33:11',0,'2013-12-27 02:00:47',NULL,NULL),(6254,1172,'985732','834','00','005010X220A1','985732','','2013-12-19','21:22:13',0,'2013-12-26 03:06:02',NULL,NULL),(19409,3593,'3011278','834','00','005010X220A1','3011278','','2014-02-13','14:23:08',0,'2014-02-13 22:02:36',NULL,NULL),(17605,3240,'2187126','834','00','005010X220A1','2187126','','2014-02-03','15:31:50',0,'2014-02-03 21:01:01',NULL,NULL),(1194,239,'1547114','834','00','005010X220A1','1547114','','2013-12-24','17:35:52',0,'2013-12-25 18:47:34',NULL,NULL),(10568,1402,'1085045','834','00','005010X220A1','1085045','','2013-12-23','08:58:20',0,'2013-12-26 12:56:08',NULL,NULL),(16949,3115,'2424621','834','00','005010X220A1','2424621','','2014-01-29','16:15:06',0,'2014-01-29 21:00:22',NULL,NULL),(4847,884,'1085466','834','00','005010X220A1','1085466','','2013-11-20','22:27:23',0,'2013-12-26 00:15:30',NULL,NULL),(14420,2441,'0001','999','BE','005010X231A1','830697','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:31',NULL,NULL),(16531,3018,'1543850','834','00','005010X220A1','1543850','','2014-01-24','13:41:32',0,'2014-01-24 21:01:00',NULL,NULL),(18520,3451,'2731766','834','00','005010X220A1','2731766','','2014-02-09','18:34:24',0,'2014-02-10 21:30:06',NULL,NULL),(19429,3601,'2530357','834','00','005010X220A1','2530357','','2014-02-13','11:38:17',0,'2014-02-13 22:02:51',NULL,NULL),(19984,3746,'3591656','834','00','005010X220A1','3591656','','2014-02-18','16:22:14',0,'2014-02-18 22:00:22',NULL,NULL),(21651,4076,'3743196','834','00','005010X220A1','3743196','','2014-02-27','18:32:46',0,'2014-02-28 21:00:02',NULL,NULL),(21851,4113,'3459133','834','00','005010X220A1','3459133','','2014-02-28','23:12:17',0,'2014-03-01 19:00:03',NULL,NULL),(23223,4354,'2818832','834','00','005010X220A1','2818832','','2014-03-07','03:21:10',0,'2014-03-07 21:32:01',NULL,NULL),(14553,2519,'2161334','834','00','005010X220A1','2161334','','2014-01-13','09:14:21',0,'2014-01-14 01:32:36',NULL,NULL),(12679,1673,'1487615','834','00','005010X220A1','1487615','','2014-01-02','11:46:26',0,'2014-01-03 02:03:57',NULL,NULL),(18659,3467,'2734617','834','00','005010X220A1','2734617','','2014-02-10','00:36:50',0,'2014-02-10 21:31:45',NULL,NULL),(18103,3327,'2875121','834','00','005010X220A1','2875121','','2014-02-06','14:02:36',0,'2014-02-06 21:01:18',NULL,NULL),(17887,3294,'2707232','834','00','005010X220A1','2707232','','2014-02-05','14:26:27',0,'2014-02-05 21:30:24',NULL,NULL),(4231,738,'784142','834','00','005010X220A1','784142','','2013-12-19','14:26:58',0,'2013-12-25 23:07:10',NULL,NULL),(3997,731,'753984','834','00','005010X220A1','753984','','2013-12-18','19:11:57',0,'2013-12-25 23:00:05',NULL,NULL),(1575,277,'746389','834','00','005010X220A1','746389','','2013-11-20','10:16:42',0,'2013-12-25 19:00:28',NULL,NULL),(5275,974,'1209971','834','00','005010X220A1','1209971','','2013-11-12','12:13:20',0,'2013-12-26 01:00:30',NULL,NULL),(3287,584,'1015317','834','00','005010X220A1','1015317','','2013-12-16','20:23:26',0,'2013-12-25 21:48:02',NULL,NULL),(19556,3626,'3127847','834','00','005010X220A1','3127847','','2014-02-14','05:10:02',0,'2014-02-14 21:31:05',NULL,NULL),(21181,3998,'2641469','834','00','005010X220A1','2641469','','2014-02-26','12:12:16',0,'2014-02-26 21:01:04',NULL,NULL),(23240,4364,'3684637','834','00','005010X220A1','3684637','','2014-03-07','11:24:42',0,'2014-03-07 21:32:15',NULL,NULL),(11873,1560,'1780757','834','00','005010X220A1','1780757','','2013-12-28','22:05:50',0,'2013-12-30 00:00:10',NULL,NULL),(15792,2721,'2401895','834','00','005010X220A1','2401895','','2014-01-20','09:49:21',0,'2014-01-21 08:46:43',NULL,NULL),(13363,2207,'0001','999','BE','005010X231A1','654131','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:07',NULL,NULL),(13280,2124,'0001','999','BE','005010X231A1','165485','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:16',NULL,NULL),(5079,936,'949304','834','00','005010X220A1','949304','','2013-12-11','18:19:08',0,'2013-12-26 00:48:31',NULL,NULL),(4209,737,'938069','834','00','005010X220A1','938069','','2013-12-19','11:51:17',0,'2013-12-25 23:06:31',NULL,NULL),(4188,734,'954686','834','00','005010X220A1','954686','','2013-12-19','15:55:16',0,'2013-12-25 23:05:52',NULL,NULL),(3692,633,'1062959','834','00','005010X220A1','1062959','','2013-12-12','09:55:44',0,'2013-12-25 22:07:15',NULL,NULL),(21404,4025,'3084913','834','00','005010X220A1','3084913','','2014-02-27','12:21:00',0,'2014-02-28 06:30:37',NULL,NULL),(22863,4280,'2921953','834','00','005010X220A1','2921953','','2014-03-06','13:11:34',0,'2014-03-06 21:01:49',NULL,NULL),(23342,4386,'3318698','834','00','005010X220A1','3318698','','2014-03-07','19:31:37',0,'2014-03-08 21:30:52',NULL,NULL),(7564,1301,'176730','834','00','005010X220A1','176730','','2013-12-21','12:02:07',0,'2013-12-26 04:36:07',NULL,NULL),(584,104,'615470','834','00','005010X220A1','615470','','2013-12-15','21:46:56',0,'2013-12-25 18:03:03',NULL,NULL),(1086,218,'686120','834','00','005010X220A1','686120','','2013-11-04','06:12:24',0,'2013-12-25 18:31:29',NULL,NULL),(16293,2980,'2220749','834','00','005010X220A1','2220749','','2014-01-23','10:13:57',0,'2014-01-23 21:00:07',NULL,NULL),(15864,2738,'2221947','834','00','005010X220A1','2221947','','2014-01-21','15:37:40',1,'2014-01-22 03:22:17',NULL,NULL),(18224,3357,'2975043','834','00','005010X220A1','2975043','','2014-02-07','15:56:31',0,'2014-02-07 19:00:52',NULL,NULL),(788,146,'1239946','834','00','005010X220A1','1239946','','2013-10-28','21:16:31',0,'2013-12-25 18:09:44',NULL,NULL),(12907,1713,'1733206','834','00','005010X220A1','1733206','','2014-01-03','18:15:28',0,'2014-01-04 02:05:08',NULL,NULL),(17210,3151,'2169291','834','00','005010X220A1','2169291','','2014-01-30','11:58:51',0,'2014-01-30 21:01:16',NULL,NULL),(5988,1125,'514256','834','00','005010X220A1','514256','','2013-12-15','11:23:39',0,'2013-12-26 02:33:35',NULL,NULL),(12218,1616,'1520844','834','00','005010X220A1','1520844','','2013-12-31','18:35:36',1,'2014-01-02 04:22:09',NULL,NULL),(10982,1413,'1414528','834','00','005010X220A1','1414528','','2013-12-23','09:29:43',0,'2013-12-26 13:10:09',NULL,NULL),(2512,448,'380430','834','00','005010X220A1','380430','','2013-10-13','14:46:30',0,'2013-12-25 20:30:24',NULL,NULL),(11983,1580,'2335136','834','00','005010X220A1','2335136','','2013-12-30','16:30:41',0,'2014-01-01 12:01:28',NULL,NULL),(20397,3831,'2731113','834','00','005010X220A1','2731113','','2014-02-19','19:15:29',0,'2014-02-20 21:30:05',NULL,NULL),(17874,3293,'1794085','834','00','005010X220A1','1794085','','2014-02-05','17:18:29',0,'2014-02-05 21:30:18',NULL,NULL),(17439,3205,'2735861','834','00','005010X220A1','2735861','','2014-02-01','01:30:53',0,'2014-02-01 19:00:34',NULL,NULL),(12615,1671,'2285872','834','00','005010X220A1','2285872','','2014-01-02','13:13:10',0,'2014-01-03 02:01:37',NULL,NULL),(16755,3067,'1627546','834','00','005010X220A1','1627546','','2014-01-27','16:53:57',0,'2014-01-27 21:01:21',NULL,NULL),(10380,1400,'56359','834','00','005010X220A1','56359','','2013-12-22','21:28:08',0,'2013-12-26 12:50:05',NULL,NULL),(11054,1420,'1267046','834','00','005010X220A1','1267046','','2013-12-22','20:15:25',0,'2013-12-26 13:12:36',NULL,NULL),(4205,737,'482024','834','00','005010X220A1','482024','','2013-12-18','21:34:52',0,'2013-12-25 23:06:23',NULL,NULL),(18893,3499,'2642245','834','00','005010X220A1','2642245','','2014-02-10','22:50:31',0,'2014-02-11 21:02:29',NULL,NULL),(19737,3673,'3203986','834','00','005010X220A1','3203986','','2014-02-15','10:25:45',0,'2014-02-15 22:00:34',NULL,NULL),(22810,4278,'2845865','834','00','005010X220A1','2845865','','2014-03-06','06:05:55',0,'2014-03-06 21:01:11',NULL,NULL),(22963,4312,'2779637','834','00','005010X220A1','2779637','','2014-03-06','11:29:15',0,'2014-03-06 21:30:06',NULL,NULL),(5001,935,'670591','834','00','005010X220A1','670591','','2013-12-11','09:54:35',0,'2013-12-26 00:45:59',NULL,NULL),(5140,943,'314121','834','00','005010X220A1','314121','','2013-12-11','11:57:19',0,'2013-12-26 00:50:31',NULL,NULL),(11020,1416,'17316','834','00','005010X220A1','17316','','2013-12-22','19:34:36',0,'2013-12-26 13:11:30',NULL,NULL),(11265,1455,'2192221','834','00','005010X220A1','2192221','','2013-12-26','11:15:33',0,'2013-12-27 02:02:26',NULL,NULL),(1373,245,'1985425','834','00','005010X220A1','1985425','','2013-12-24','15:46:17',0,'2013-12-25 18:53:07',NULL,NULL),(13259,2103,'0001','999','BE','005010X231A1','546147','834','2013-12-27','11:30:00',0,'2014-01-05 17:02:37',NULL,NULL),(18492,3435,'2199405','834','00','005010X220A1','2199405','','2014-02-10','04:25:17',0,'2014-02-10 11:01:08',NULL,NULL),(5171,947,'965657','834','00','005010X220A1','965657','','2013-12-11','15:02:15',0,'2013-12-26 00:51:25',NULL,NULL),(16699,3064,'2436581','834','00','005010X220A1','2436581','','2014-01-26','21:33:44',0,'2014-01-27 21:00:43',NULL,NULL),(21002,3960,'2696431','834','00','005010X220A1','2696431','','2014-02-22','14:40:18',0,'2014-02-26 08:30:40',NULL,NULL),(22378,4208,'2855545','834','00','005010X220A1','2855545','','2014-03-03','20:42:32',0,'2014-03-04 21:02:01',NULL,NULL),(22766,4277,'3064649','834','00','005010X220A1','3064649','','2014-03-05','18:10:38',0,'2014-03-06 21:00:41',NULL,NULL),(14053,2339,'1775924','834','00','005010X220A1','1775924','','2014-01-07','21:50:37',0,'2014-01-13 02:21:39',NULL,NULL),(10692,1403,'814956','834','00','005010X220A1','814956','','2013-12-23','08:30:13',0,'2013-12-26 13:00:14',NULL,NULL),(7607,1303,'188945','834','00','005010X220A1','188945','','2013-12-21','13:18:49',0,'2013-12-26 04:37:28',NULL,NULL),(4084,733,'1267879','834','00','005010X220A1','1267879','','2013-12-19','09:58:33',0,'2013-12-25 23:02:48',NULL,NULL),(2523,455,'966788','834','00','005010X220A1','966788','','2013-11-17','19:21:14',0,'2013-12-25 20:30:44',NULL,NULL),(20541,3857,'2957592','834','00','005010X220A1','2957592','','2014-02-20','13:16:37',0,'2014-02-20 22:01:38',NULL,NULL),(17836,3284,'1835027','834','00','005010X220A1','1835027','','2014-02-04','17:52:32',0,'2014-02-04 21:01:58',NULL,NULL),(16575,3036,'1375985','834','00','005010X220A1','1375985','','2014-01-25','10:21:36',0,'2014-01-25 19:00:08',NULL,NULL),(14261,2375,'1773331','834','00','005010X220A1','1773331','','2014-01-09','21:37:47',0,'2014-01-13 03:00:05',NULL,NULL),(7235,1241,'1002269','834','00','005010X220A1','1002269','','2013-12-18','18:00:23',0,'2013-12-26 04:07:43',NULL,NULL),(13949,2320,'1463457','834','00','005010X220A1','1463457','','2014-01-08','20:57:43',0,'2014-01-13 02:20:20',NULL,NULL),(5039,935,'1271256','834','00','005010X220A1','1271256','','2013-12-11','16:42:28',0,'2013-12-26 00:47:14',NULL,NULL),(2231,372,'850861','834','00','005010X220A1','850861','','2013-12-02','17:12:09',0,'2013-12-25 19:49:14',NULL,NULL),(3227,578,'1094848','834','00','005010X220A1','1094848','','2013-12-17','11:28:25',0,'2013-12-25 21:46:08',NULL,NULL),(23068,4339,'3794242','834','00','005010X220A1','3794242','','2014-03-07','08:17:19',0,'2014-03-07 21:30:12',NULL,NULL),(16465,3006,'1551578','834','00','005010X220A1','1551578','','2014-01-24','14:25:59',0,'2014-01-24 21:00:20',NULL,NULL),(15866,2738,'2247473','834','00','005010X220A1','2247473','','2014-01-21','15:56:53',1,'2014-01-22 03:22:18',NULL,NULL),(15353,2623,'1857880','834','00','005010X220A1','1857880','','2014-01-16','00:31:30',0,'2014-01-17 03:35:25',NULL,NULL),(13258,2102,'0001','999','BE','005010X231A1','1117810','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:34',NULL,NULL),(5409,1023,'958781','834','00','005010X220A1','958781','','2013-11-13','21:34:18',0,'2013-12-26 01:30:34',NULL,NULL),(7540,1300,'1291708','834','00','005010X220A1','1291708','','2013-12-21','16:09:32',0,'2013-12-26 04:35:19',NULL,NULL),(13817,2298,'2496189','834','00','005010X220A1','2496189','','2014-01-10','19:34:48',0,'2014-01-13 02:18:27',NULL,NULL),(21020,3969,'3497358','834','00','005010X220A1','3497358','','2014-02-22','12:46:25',0,'2014-02-26 08:30:55',NULL,NULL),(22528,4247,'3008358','834','00','005010X220A1','3008358','','2014-03-05','14:49:55',0,'2014-03-05 21:30:26',NULL,NULL),(17484,3220,'1766053','834','00','005010X220A1','1766053','','2014-02-01','20:31:38',0,'2014-02-02 19:00:15',NULL,NULL),(16823,3090,'2455927','834','00','005010X220A1','2455927','','2014-01-28','16:44:05',0,'2014-01-28 21:00:22',NULL,NULL),(13518,2235,'2332348','834','00','005010X220A1','2332348','','2014-01-06','14:17:43',0,'2014-01-07 04:05:19',NULL,NULL),(15328,2622,'2114664','834','00','005010X220A1','2114664','','2014-01-16','14:55:29',0,'2014-01-17 03:35:13',NULL,NULL),(14581,2520,'1925852','834','00','005010X220A1','1925852','','2014-01-13','15:57:05',0,'2014-01-14 01:32:54',NULL,NULL),(11296,1455,'957390','834','00','005010X220A1','957390','','2013-12-26','17:45:59',0,'2013-12-27 02:03:22',NULL,NULL),(14269,2375,'2268137','834','00','005010X220A1','2268137','','2014-01-10','13:45:05',0,'2014-01-13 03:00:10',NULL,NULL),(5307,988,'206883','834','00','005010X220A1','206883','','2013-11-05','17:55:25',0,'2013-12-26 01:01:41',NULL,NULL),(4368,768,'948153','834','00','005010X220A1','948153','','2013-12-19','16:37:47',0,'2013-12-25 23:11:21',NULL,NULL),(20318,3795,'2823439','834','00','005010X220A1','2823439','','2014-02-19','16:30:04',0,'2014-02-20 04:47:32',NULL,NULL),(18914,3512,'2373184','834','00','005010X220A1','2373184','','2014-02-11','14:56:30',0,'2014-02-11 21:02:49',NULL,NULL),(12934,1726,'2288701','834','00','005010X220A1','2288701','','2014-01-03','15:48:35',0,'2014-01-04 02:06:15',NULL,NULL),(16350,2983,'1537135','834','00','005010X220A1','1537135','','2014-01-23','15:09:36',0,'2014-01-23 21:00:48',NULL,NULL),(12634,1672,'2401394','834','00','005010X220A1','2401394','','2014-01-02','02:22:02',0,'2014-01-03 02:02:16',NULL,NULL),(12504,1642,'2121490','834','00','005010X220A1','2121490','','2013-12-31','14:11:16',1,'2014-01-02 04:33:30',NULL,NULL),(6315,1175,'398651','834','00','005010X220A1','398651','','2013-12-20','10:10:20',0,'2013-12-26 03:07:50',NULL,NULL),(3390,588,'1083188','834','00','005010X220A1','1083188','','2013-12-16','23:16:35',0,'2013-12-25 21:51:23',NULL,NULL),(12173,1595,'1575396','834','00','005010X220A1','1575396','','2013-12-29','23:38:23',0,'2014-01-01 12:08:14',NULL,NULL),(4057,731,'97724','834','00','005010X220A1','97724','','2013-12-18','18:33:25',0,'2013-12-25 23:01:55',NULL,NULL),(11964,1580,'1898476','834','00','005010X220A1','1898476','','2013-12-30','11:48:26',0,'2014-01-01 12:00:43',NULL,NULL),(5229,955,'435258','834','00','005010X220A1','435258','','2013-12-11','08:28:17',0,'2013-12-26 00:53:23',NULL,NULL),(19654,3649,'2553713','834','00','005010X220A1','2553713','','2014-02-14','17:27:58',0,'2014-02-14 21:32:17',NULL,NULL),(20268,3795,'2334948','834','00','005010X220A1','2334948','','2014-02-19','00:11:09',0,'2014-02-20 04:35:11',NULL,NULL),(21603,4064,'3219463','834','00','005010X220A1','3219463','','2014-02-26','20:24:37',0,'2014-02-28 07:30:07',NULL,NULL),(23029,4328,'3605783','834','00','005010X220A1','3605783','','2014-03-07','09:57:31',0,'2014-03-07 21:00:25',NULL,NULL),(17043,3122,'1815380','834','00','005010X220A1','1815380','','2014-01-28','22:58:13',0,'2014-01-29 21:01:22',NULL,NULL),(16871,3093,'1861662','834','00','005010X220A1','1861662','','2014-01-28','14:05:42',0,'2014-01-28 21:00:54',NULL,NULL),(11603,1493,'1661575','834','00','005010X220A1','1661575','','2013-12-27','13:36:10',0,'2013-12-28 03:34:46',NULL,NULL),(10563,1402,'607753','834','00','005010X220A1','607753','','2013-12-22','23:24:59',0,'2013-12-26 12:55:58',NULL,NULL),(21206,3998,'2875622','834','00','005010X220A1','2875622','','2014-02-26','15:42:35',0,'2014-02-26 21:01:20',NULL,NULL),(21745,4090,'3584544','834','00','005010X220A1','3584544','','2014-02-27','22:44:20',0,'2014-02-28 21:30:44',NULL,NULL),(22220,4189,'2822593','834','00','005010X220A1','2822593','','2014-03-03','04:06:25',0,'2014-03-03 21:31:47',NULL,NULL),(23186,4345,'3199801','834','00','005010X220A1','3199801','','2014-03-07','14:17:30',0,'2014-03-07 21:31:36',NULL,NULL),(13137,1981,'0001','999','BE','005010X231A1','920734','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:25',NULL,NULL),(5817,1084,'1052178','834','00','005010X220A1','1052178','','2013-12-14','16:49:59',0,'2013-12-26 02:04:07',NULL,NULL),(6291,1172,'1290454','834','00','005010X220A1','1290454','','2013-12-20','18:09:57',0,'2013-12-26 03:07:09',NULL,NULL),(19682,3664,'3216903','834','00','005010X220A1','3216903','','2014-02-15','12:48:03',0,'2014-02-15 21:00:05',NULL,NULL),(20755,3903,'3099286','834','00','005010X220A1','3099286','','2014-02-25','16:39:39',0,'2014-02-25 21:30:24',NULL,NULL),(20966,3956,'3505212','834','00','005010X220A1','3505212','','2014-02-21','22:53:04',0,'2014-02-26 08:30:04',NULL,NULL),(821,165,'423191','834','00','005010X220A1','423191','','2013-11-10','20:25:27',0,'2013-12-25 18:10:57',NULL,NULL),(16738,3065,'1654312','834','00','005010X220A1','1654312','','2014-01-27','15:38:51',0,'2014-01-27 21:01:09',NULL,NULL),(3490,615,'58253','834','00','005010X220A1','58253','','2013-12-12','11:24:21',0,'2013-12-25 22:00:51',NULL,NULL),(4677,831,'1096415','834','00','005010X220A1','1096415','','2013-12-24','00:22:43',0,'2013-12-25 23:49:50',NULL,NULL),(15101,2587,'1812609','834','00','005010X220A1','1812609','','2014-01-14','20:11:09',0,'2014-01-16 08:45:21',NULL,NULL),(12578,1670,'2255275','834','00','005010X220A1','2255275','','2014-01-02','16:33:41',0,'2014-01-03 02:00:18',NULL,NULL),(10997,1413,'1458039','834','00','005010X220A1','1458039','','2013-12-23','15:29:00',0,'2013-12-26 13:10:38',NULL,NULL),(5859,1100,'823334','834','00','005010X220A1','823334','','2013-11-23','16:52:19',0,'2013-12-26 02:16:30',NULL,NULL),(14141,2355,'1481792','834','00','005010X220A1','1481792','','2014-01-08','11:02:25',0,'2014-01-13 02:22:36',NULL,NULL),(7203,1241,'1054721','834','00','005010X220A1','1054721','','2013-12-17','19:22:41',0,'2013-12-26 04:06:43',NULL,NULL),(13406,2222,'2565907','834','00','005010X220A1','2565907','','2014-01-06','15:47:51',0,'2014-01-07 04:01:07',NULL,NULL),(18778,3486,'1879822','834','00','005010X220A1','1879822','','2014-02-11','15:46:07',0,'2014-02-11 21:00:59',NULL,NULL),(18898,3502,'2897675','834','00','005010X220A1','2897675','','2014-02-11','09:34:34',0,'2014-02-11 21:02:34',NULL,NULL),(21325,4018,'3004196','834','00','005010X220A1','3004196','','2014-02-26','16:12:33',0,'2014-02-26 21:02:44',NULL,NULL),(23366,4392,'3185497','834','00','005010X220A1','3185497','','2014-03-08','13:02:43',0,'2014-03-08 21:31:10',NULL,NULL),(16710,3064,'1585012','834','00','005010X220A1','1585012','','2014-01-27','11:21:55',0,'2014-01-27 21:00:50',NULL,NULL),(1402,247,'1957541','834','00','005010X220A1','1957541','','2013-12-24','09:58:16',0,'2013-12-25 18:54:07',NULL,NULL),(2341,413,'747651','834','00','005010X220A1','747651','','2013-12-05','23:04:13',0,'2013-12-25 20:15:24',NULL,NULL),(6248,1172,'86244','834','00','005010X220A1','86244','','2013-12-19','19:15:49',0,'2013-12-26 03:05:52',NULL,NULL),(5003,935,'492954','834','00','005010X220A1','492954','','2013-12-11','10:25:57',0,'2013-12-26 00:46:03',NULL,NULL),(18225,3357,'2796204','834','00','005010X220A1','2796204','','2014-02-07','16:49:03',0,'2014-02-07 19:00:53',NULL,NULL),(16754,3067,'1708303','834','00','005010X220A1','1708303','','2014-01-27','16:03:44',0,'2014-01-27 21:01:20',NULL,NULL),(1813,310,'700851','834','00','005010X220A1','700851','','2013-12-10','16:25:50',0,'2013-12-25 19:20:02',NULL,NULL),(10476,1400,'580912','834','00','005010X220A1','580912','','2013-12-23','15:07:31',0,'2013-12-26 12:53:05',NULL,NULL),(1077,216,'4956','834','00','005010X220A1','4956','','2013-11-03','22:00:16',0,'2013-12-25 18:31:10',NULL,NULL),(6014,1136,'148795','834','00','005010X220A1','148795','','2013-11-17','17:32:04',0,'2013-12-26 02:45:21',NULL,NULL),(20524,3849,'2159379','834','00','005010X220A1','2159379','','2014-02-20','13:51:10',0,'2014-02-20 22:01:23',NULL,NULL),(22409,4215,'3794102','834','00','005010X220A1','3794102','','2014-03-04','14:25:14',0,'2014-03-04 21:02:28',NULL,NULL),(22480,4241,'2766730','834','00','005010X220A1','2766730','','2014-03-05','08:37:52',0,'2014-03-05 21:00:23',NULL,NULL),(22876,4281,'3130669','834','00','005010X220A1','3130669','','2014-03-06','15:05:58',0,'2014-03-06 21:01:59',NULL,NULL),(18349,3398,'2910184','834','00','005010X220A1','2910184','','2014-02-08','13:16:37',0,'2014-02-08 19:30:09',NULL,NULL),(17247,3170,'2224576','834','00','005010X220A1','2224576','','2014-01-31','18:09:41',0,'2014-01-31 21:00:04',NULL,NULL),(4570,826,'426800','834','00','005010X220A1','426800','','2013-12-23','21:24:08',0,'2013-12-25 23:46:19',NULL,NULL),(7461,1296,'61062','834','00','005010X220A1','61062','','2013-12-21','10:24:18',0,'2013-12-26 04:32:41',NULL,NULL),(7278,1254,'70425','834','00','005010X220A1','70425','','2013-12-18','15:01:33',0,'2013-12-26 04:09:02',NULL,NULL),(5430,1031,'1182754','834','00','005010X220A1','1182754','','2013-10-05','10:44:35',0,'2013-12-26 01:31:20',NULL,NULL),(2726,503,'1277736','834','00','005010X220A1','1277736','','2013-12-22','09:54:10',0,'2013-12-25 21:18:00',NULL,NULL),(19172,3560,'3020591','834','00','005010X220A1','3020591','','2014-02-12','12:18:30',0,'2014-02-12 21:32:26',NULL,NULL),(22334,4203,'3748781','834','00','005010X220A1','3748781','','2014-03-04','16:10:57',0,'2014-03-04 21:01:25',NULL,NULL),(22471,4238,'2721707','834','00','005010X220A1','2721707','','2014-03-05','16:38:18',0,'2014-03-05 21:00:17',NULL,NULL),(23524,4434,'3360109','834','00','005010X220A1','3360109','','2014-03-10','16:28:59',0,'2014-03-10 21:00:19',NULL,NULL),(16927,3115,'1731077','834','00','005010X220A1','1731077','','2014-01-28','18:34:25',0,'2014-01-29 21:00:08',NULL,NULL),(6371,1183,'737564','834','00','005010X220A1','737564','','2013-12-20','13:31:06',0,'2013-12-26 03:09:35',NULL,NULL),(672,109,'80836','834','00','005010X220A1','80836','','2013-12-16','10:18:38',0,'2013-12-25 18:05:51',NULL,NULL),(1389,245,'262721','834','00','005010X220A1','262721','','2013-12-24','17:21:08',0,'2013-12-25 18:53:40',NULL,NULL),(15874,2739,'1498873','834','00','005010X220A1','1498873','','2014-01-21','13:35:00',1,'2014-01-22 03:22:24',NULL,NULL),(3681,629,'936645','834','00','005010X220A1','936645','','2013-12-12','12:58:09',0,'2013-12-25 22:06:51',NULL,NULL),(20626,3871,'2679826','834','00','005010X220A1','2679826','','2014-02-21','15:31:43',0,'2014-02-21 22:00:35',NULL,NULL),(10932,1410,'440401','834','00','005010X220A1','440401','','2013-12-23','12:41:28',0,'2013-12-26 13:08:42',NULL,NULL),(5373,1010,'1153388','834','00','005010X220A1','1153388','','2013-11-25','13:56:29',0,'2013-12-26 01:16:37',NULL,NULL),(11633,1497,'1602536','834','00','005010X220A1','1602536','','2013-12-27','12:13:37',0,'2013-12-28 03:35:45',NULL,NULL),(11621,1495,'1839342','834','00','005010X220A1','1839342','','2013-12-26','20:57:03',0,'2013-12-28 03:35:23',NULL,NULL),(11316,1456,'2145417','834','00','005010X220A1','2145417','','2013-12-26','12:50:51',0,'2013-12-27 02:03:58',NULL,NULL),(3070,545,'1032641','834','00','005010X220A1','1032641','','2013-12-13','18:05:08',0,'2013-12-25 21:35:18',NULL,NULL),(11116,1426,'1398057','834','00','005010X220A1','1398057','','2013-12-23','14:50:25',0,'2013-12-26 13:14:37',NULL,NULL),(19977,3746,'3407127','834','00','005010X220A1','3407127','','2014-02-18','14:17:15',0,'2014-02-18 22:00:17',NULL,NULL),(13942,2318,'2108153','834','00','005010X220A1','2108153','','2014-01-09','14:53:43',0,'2014-01-13 02:20:14',NULL,NULL),(13514,2235,'2210124','834','00','005010X220A1','2210124','','2014-01-05','21:49:19',0,'2014-01-07 04:05:12',NULL,NULL),(1895,325,'146213','834','00','005010X220A1','146213','','2013-12-09','11:32:57',0,'2013-12-25 19:31:37',NULL,NULL),(20864,3913,'3384403','834','00','005010X220A1','3384403','','2014-02-24','18:46:07',0,'2014-02-25 21:31:41',NULL,NULL),(18771,3486,'3167097','834','00','005010X220A1','3167097','','2014-02-10','21:19:56',0,'2014-02-11 21:00:54',NULL,NULL),(11294,1455,'2160900','834','00','005010X220A1','2160900','','2013-12-26','17:28:42',0,'2013-12-27 02:03:19',NULL,NULL),(1984,327,'222860','834','00','005010X220A1','222860','','2013-12-09','13:11:14',0,'2013-12-25 19:34:17',NULL,NULL),(18615,3456,'2363561','834','00','005010X220A1','2363561','','2014-02-10','16:44:37',0,'2014-02-10 21:31:14',NULL,NULL),(15501,2636,'2246112','834','00','005010X220A1','2246112','','2014-01-16','12:42:27',0,'2014-01-17 03:36:31',NULL,NULL),(11279,1455,'1726211','834','00','005010X220A1','1726211','','2013-12-26','13:24:10',0,'2013-12-27 02:02:51',NULL,NULL),(15404,2626,'2388865','834','00','005010X220A1','2388865','','2014-01-15','19:33:34',0,'2014-01-17 03:35:49',NULL,NULL),(14537,2518,'2202729','834','00','005010X220A1','2202729','','2014-01-13','13:02:47',0,'2014-01-14 01:32:26',NULL,NULL),(5272,973,'501024','834','00','005010X220A1','501024','','2013-11-12','10:35:15',0,'2013-12-26 01:00:24',NULL,NULL),(14313,2393,'2426733','834','00','005010X220A1','2426733','','2014-01-10','14:33:34',0,'2014-01-13 03:00:39',NULL,NULL),(13686,2273,'2543863','834','00','005010X220A1','2543863','','2014-01-07','12:10:36',0,'2014-01-08 18:24:23',NULL,NULL),(22141,4179,'3255729','834','00','005010X220A1','3255729','','2014-03-03','13:12:39',0,'2014-03-03 21:30:49',NULL,NULL),(22686,4257,'3589517','834','00','005010X220A1','3589517','','2014-03-04','22:52:29',0,'2014-03-05 21:32:18',NULL,NULL),(17485,3220,'2701289','834','00','005010X220A1','2701289','','2014-02-01','20:39:04',0,'2014-02-02 19:00:15',NULL,NULL),(13207,2051,'0001','999','BE','005010X231A1','853582','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:12',NULL,NULL),(15709,2703,'2532567','834','00','005010X220A1','2532567','','2014-01-18','20:15:14',0,'2014-01-21 08:45:35',NULL,NULL),(7312,1264,'225762','834','00','005010X220A1','225762','','2013-12-18','11:14:23',0,'2013-12-26 04:10:04',NULL,NULL),(15368,2624,'2154399','834','00','005010X220A1','2154399','','2014-01-15','21:54:46',0,'2014-01-17 03:35:31',NULL,NULL),(4022,731,'44599','834','00','005010X220A1','44599','','2013-12-19','13:37:01',0,'2013-12-25 23:00:49',NULL,NULL),(6231,1168,'200412','834','00','005010X220A1','200412','','2013-12-20','17:20:55',0,'2013-12-26 03:05:17',NULL,NULL),(4071,732,'1095007','834','00','005010X220A1','1095007','','2013-12-19','18:26:25',0,'2013-12-25 23:02:23',NULL,NULL),(19414,3594,'2199690','834','00','005010X220A1','2199690','','2014-02-13','11:16:24',0,'2014-02-13 22:02:39',NULL,NULL),(20436,3841,'2907119','834','00','005010X220A1','2907119','','2014-02-20','00:07:51',0,'2014-02-20 22:00:12',NULL,NULL),(22407,4215,'3286889','834','00','005010X220A1','3286889','','2014-03-04','10:07:10',0,'2014-03-04 21:02:26',NULL,NULL),(15819,2734,'2577535','834','00','005010X220A1','2577535','','2014-01-20','16:52:36',0,'2014-01-21 08:46:59',NULL,NULL),(15261,2601,'1964399','834','00','005010X220A1','1964399','','2014-01-15','11:18:08',0,'2014-01-16 08:47:04',NULL,NULL),(14962,2567,'2230504','834','00','005010X220A1','2230504','','2014-01-14','11:30:21',0,'2014-01-15 02:07:58',NULL,NULL),(14847,2553,'1648953','834','00','005010X220A1','1648953','','2014-01-14','13:00:57',0,'2014-01-15 02:07:05',NULL,NULL),(10742,1403,'1667133','834','00','005010X220A1','1667133','','2013-12-23','16:08:51',0,'2013-12-26 13:01:57',NULL,NULL),(5111,941,'553496','834','00','005010X220A1','553496','','2013-12-10','21:34:51',0,'2013-12-26 00:49:32',NULL,NULL),(6340,1176,'1271672','834','00','005010X220A1','1271672','','2013-12-20','16:32:59',0,'2013-12-26 03:08:36',NULL,NULL),(12569,1666,'2110472','834','00','005010X220A1','2110472','','2013-12-31','16:53:10',1,'2014-01-02 04:36:05',NULL,NULL),(12875,1706,'2108017','834','00','005010X220A1','2108017','','2014-01-03','13:52:30',0,'2014-01-04 02:03:58',NULL,NULL),(20517,3849,'2977796','834','00','005010X220A1','2977796','','2014-02-20','08:38:01',0,'2014-02-20 22:01:18',NULL,NULL),(20767,3907,'3706976','834','00','005010X220A1','3706976','','2014-02-24','18:13:42',0,'2014-02-25 21:30:32',NULL,NULL),(21886,4124,'3694437','834','00','005010X220A1','3694437','','2014-03-01','16:46:12',0,'2014-03-01 21:00:20',NULL,NULL),(22370,4206,'3832449','834','00','005010X220A1','3832449','','2014-03-03','19:29:56',0,'2014-03-04 21:01:55',NULL,NULL),(23581,4436,'3109659','834','00','005010X220A1','3109659','','2014-03-10','17:18:55',0,'2014-03-10 21:01:04',NULL,NULL),(15915,2743,'1390233','834','00','005010X220A1','1390233','','2014-01-21','14:18:43',1,'2014-01-22 03:22:51',NULL,NULL),(2294,397,'223983','834','00','005010X220A1','223983','','2013-11-24','13:03:24',0,'2013-12-25 20:00:58',NULL,NULL),(3031,544,'598592','834','00','005010X220A1','598592','','2013-12-13','09:00:57',0,'2013-12-25 21:34:03',NULL,NULL),(13129,1973,'0001','999','BE','005010X231A1','818189','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:59',NULL,NULL),(4175,734,'405953','834','00','005010X220A1','405953','','2013-12-19','11:21:56',0,'2013-12-25 23:05:25',NULL,NULL),(12170,1594,'2457462','834','00','005010X220A1','2457462','','2013-12-30','15:55:44',0,'2014-01-01 12:08:06',NULL,NULL),(14398,2419,'2242623','834','00','005010X220A1','2242623','','2014-01-12','17:33:20',0,'2014-01-13 03:02:01',NULL,NULL),(7210,1241,'1176030','834','00','005010X220A1','1176030','','2013-12-18','10:03:52',0,'2013-12-26 04:06:56',NULL,NULL),(7192,1239,'200259','834','00','005010X220A1','200259','','2013-12-18','13:01:46',0,'2013-12-26 04:06:23',NULL,NULL),(14208,2365,'1711784','834','00','005010X220A1','1711784','','2014-01-10','16:14:35',0,'2014-01-13 02:23:49',NULL,NULL),(21496,4030,'3594296','834','00','005010X220A1','3594296','','2014-02-27','01:11:52',0,'2014-02-28 06:31:20',NULL,NULL),(23437,4406,'3684689','834','00','005010X220A1','3684689','','2014-03-08','21:02:41',0,'2014-03-09 21:00:39',NULL,NULL),(15670,2686,'1878126','834','00','005010X220A1','1878126','','2014-01-18','17:37:07',0,'2014-01-21 08:44:38',NULL,NULL),(14503,2515,'2229401','834','00','005010X220A1','2229401','','2014-01-13','13:32:59',0,'2014-01-14 01:32:03',NULL,NULL),(13572,2254,'1586721','834','00','005010X220A1','1586721','','2014-01-05','13:55:16',1,'2014-01-07 10:21:39',NULL,NULL),(13749,2276,'2333847','834','00','005010X220A1','2333847','','2014-01-07','13:53:57',0,'2014-01-08 18:24:51',NULL,NULL),(2632,496,'1111321','834','00','005010X220A1','1111321','','2013-11-27','18:13:23',0,'2013-12-25 20:47:01',NULL,NULL),(13338,2182,'0001','999','BE','005010X231A1','620557','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:58',NULL,NULL),(13279,2123,'0001','999','BE','005010X231A1','102827','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:13',NULL,NULL),(523,102,'726316','834','00','005010X220A1','726316','','2013-12-16','13:18:01',0,'2013-12-25 18:01:07',NULL,NULL),(12570,1667,'1463256','834','00','005010X220A1','1463256','','2013-12-31','17:14:26',1,'2014-01-02 04:36:08',NULL,NULL),(16566,3035,'1557144','834','00','005010X220A1','1557144','','2014-01-24','18:31:35',0,'2014-01-25 19:00:04',NULL,NULL),(10370,1400,'536373','834','00','005010X220A1','536373','','2013-12-22','19:38:16',0,'2013-12-26 12:49:48',NULL,NULL),(14196,2365,'2133177','834','00','005010X220A1','2133177','','2014-01-10','13:18:10',0,'2014-01-13 02:23:41',NULL,NULL),(3904,711,'423452','834','00','005010X220A1','423452','','2013-12-06','23:59:13',0,'2013-12-25 22:45:08',NULL,NULL),(5364,1008,'819325','834','00','005010X220A1','819325','','2013-11-25','12:08:47',0,'2013-12-26 01:16:20',NULL,NULL),(5889,1110,'1149955','834','00','005010X220A1','1149955','','2013-12-14','18:42:47',0,'2013-12-26 02:30:24',NULL,NULL),(20452,3842,'3428480','834','00','005010X220A1','3428480','','2014-02-19','20:06:09',0,'2014-02-20 22:00:25',NULL,NULL),(22107,4177,'3777169','834','00','005010X220A1','3777169','','2014-03-03','10:59:18',0,'2014-03-03 21:30:24',NULL,NULL),(18396,3411,'2723276','834','00','005010X220A1','2723276','','2014-02-09','13:58:49',0,'2014-02-09 19:00:33',NULL,NULL),(1502,258,'1602399','834','00','005010X220A1','1602399','','2013-12-24','10:46:24',0,'2013-12-25 18:57:26',NULL,NULL),(1551,267,'658990','834','00','005010X220A1','658990','','2013-12-24','14:56:44',0,'2013-12-25 18:58:59',NULL,NULL),(4248,739,'577959','834','00','005010X220A1','577959','','2013-12-19','16:25:10',0,'2013-12-25 23:07:44',NULL,NULL),(13014,1744,'1851818','834','00','005010X220A1','1851818','','2014-01-04','10:18:36',0,'2014-01-05 00:02:43',NULL,NULL),(20570,3865,'3523544','834','00','005010X220A1','3523544','','2014-02-21','14:31:06',0,'2014-02-21 21:30:16',NULL,NULL),(17390,3197,'1992738','834','00','005010X220A1','1992738','','2014-01-31','18:27:42',0,'2014-02-01 19:00:03',NULL,NULL),(19140,3549,'2878054','834','00','005010X220A1','2878054','','2014-02-12','09:55:43',0,'2014-02-12 21:32:02',NULL,NULL),(7575,1301,'926353','834','00','005010X220A1','926353','','2013-12-21','14:52:49',0,'2013-12-26 04:36:26',NULL,NULL),(5871,1104,'951044','834','00','005010X220A1','951044','','2013-10-28','14:42:44',0,'2013-12-26 02:16:57',NULL,NULL),(5331,1002,'185553','834','00','005010X220A1','185553','','2013-11-25','15:06:44',0,'2013-12-26 01:15:12',NULL,NULL),(3905,711,'1285570','834','00','005010X220A1','1285570','','2013-12-07','11:41:18',0,'2013-12-25 22:45:09',NULL,NULL),(14725,2550,'2210349','834','00','005010X220A1','2210349','','2014-01-14','13:10:48',0,'2014-01-15 02:06:12',NULL,NULL),(17958,3299,'2179960','834','00','005010X220A1','2179960','','2014-02-05','16:15:28',0,'2014-02-05 21:30:59',NULL,NULL),(18084,3323,'1872149','834','00','005010X220A1','1872149','','2014-02-06','04:24:39',0,'2014-02-06 21:01:05',NULL,NULL),(18464,3426,'1498964','834','00','005010X220A1','1498964','','2014-02-10','04:20:03',0,'2014-02-10 11:00:46',NULL,NULL),(20789,3909,'3376190','834','00','005010X220A1','3376190','','2014-02-24','18:31:31',0,'2014-02-25 21:30:48',NULL,NULL),(23658,4442,'3856346','834','00','005010X220A1','3856346','','2014-03-10','16:58:31',0,'2014-03-10 21:01:57',NULL,NULL),(3742,643,'1244362','834','00','005010X220A1','1244362','','2013-12-12','15:51:40',0,'2013-12-25 22:08:55',NULL,NULL),(13245,2089,'0001','999','BE','005010X231A1','707404','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:57',NULL,NULL),(12453,1639,'1853801','834','00','005010X220A1','1853801','','2013-12-31','11:20:55',1,'2014-01-02 04:31:37',NULL,NULL),(4093,733,'1152542','834','00','005010X220A1','1152542','','2013-12-19','10:44:49',0,'2013-12-25 23:03:04',NULL,NULL),(11555,1492,'1774372','834','00','005010X220A1','1774372','','2013-12-27','08:39:12',0,'2013-12-28 03:33:19',NULL,NULL),(14167,2363,'1566717','834','00','005010X220A1','1566717','','2014-01-10','14:05:04',0,'2014-01-13 02:23:17',NULL,NULL),(15097,2585,'1714529','834','00','005010X220A1','1714529','','2014-01-15','18:13:37',0,'2014-01-16 08:45:17',NULL,NULL),(16642,3060,'2578634','834','00','005010X220A1','2578634','','2014-01-27','09:16:58',0,'2014-01-27 21:00:06',NULL,NULL),(17016,3119,'2576530','834','00','005010X220A1','2576530','','2014-01-29','15:52:09',0,'2014-01-29 21:01:04',NULL,NULL),(18764,3485,'2537991','834','00','005010X220A1','2537991','','2014-02-11','17:19:03',0,'2014-02-11 21:00:49',NULL,NULL),(4159,734,'885444','834','00','005010X220A1','885444','','2013-12-18','21:54:04',0,'2013-12-25 23:04:58',NULL,NULL),(15073,2585,'2163801','834','00','005010X220A1','2163801','','2014-01-15','12:52:23',0,'2014-01-16 08:45:03',NULL,NULL),(15148,2588,'1404993','834','00','005010X220A1','1404993','','2014-01-15','00:25:03',0,'2014-01-16 08:45:53',NULL,NULL),(16799,3088,'1875874','834','00','005010X220A1','1875874','','2014-01-28','16:23:49',0,'2014-01-28 21:00:07',NULL,NULL),(17478,3218,'1469070','834','00','005010X220A1','1469070','','2014-02-02','15:48:11',0,'2014-02-02 19:00:11',NULL,NULL),(17670,3259,'2561323','834','00','005010X220A1','2561323','','2014-02-03','19:04:40',0,'2014-02-04 21:00:11',NULL,NULL),(5463,1040,'257501','834','00','005010X220A1','257501','','2013-12-24','20:05:12',0,'2013-12-26 01:45:15',NULL,NULL),(21416,4026,'2656954','834','00','005010X220A1','2656954','','2014-02-27','10:34:12',0,'2014-02-28 06:30:42',NULL,NULL),(10903,1409,'1114748','834','00','005010X220A1','1114748','','2013-12-23','14:13:21',0,'2013-12-26 13:07:44',NULL,NULL),(1478,252,'1076155','834','00','005010X220A1','1076155','','2013-12-24','18:11:37',0,'2013-12-25 18:56:43',NULL,NULL),(4262,742,'132723','834','00','005010X220A1','132723','','2013-12-19','13:06:27',0,'2013-12-25 23:08:10',NULL,NULL),(13539,2241,'1395752','834','00','005010X220A1','1395752','','2014-01-06','16:32:18',0,'2014-01-07 04:06:02',NULL,NULL),(5557,1043,'1869583','834','00','005010X220A1','1869583','','2013-12-24','19:03:24',0,'2013-12-26 01:48:15',NULL,NULL),(19119,3545,'2862716','834','00','005010X220A1','2862716','','2014-02-12','14:27:03',0,'2014-02-12 21:31:50',NULL,NULL),(2676,502,'1160156','834','00','005010X220A1','1160156','','2013-12-21','18:49:33',0,'2013-12-25 21:16:25',NULL,NULL),(21913,4127,'3193212','834','00','005010X220A1','3193212','','2014-03-01','14:37:07',0,'2014-03-01 21:00:38',NULL,NULL),(22560,4248,'3216079','834','00','005010X220A1','3216079','','2014-03-05','12:29:37',0,'2014-03-05 21:30:51',NULL,NULL),(17473,3218,'2757138','834','00','005010X220A1','2757138','','2014-02-01','21:12:14',0,'2014-02-02 19:00:08',NULL,NULL),(12347,1634,'2144070','834','00','005010X220A1','2144070','','2013-12-31','12:35:36',1,'2014-01-02 04:27:47',NULL,NULL),(1541,261,'1799518','834','00','005010X220A1','1799518','','2013-12-24','18:03:31',0,'2013-12-25 18:58:38',NULL,NULL),(1634,281,'1086505','834','00','005010X220A1','1086505','','2013-11-19','23:07:36',0,'2013-12-25 19:02:02',NULL,NULL),(1948,326,'1016086','834','00','005010X220A1','1016086','','2013-12-09','11:31:17',0,'2013-12-25 19:33:09',NULL,NULL),(5733,1069,'149271','834','00','005010X220A1','149271','','2013-12-14','16:38:22',0,'2013-12-26 02:01:23',NULL,NULL),(13419,2222,'1958936','834','00','005010X220A1','1958936','','2014-01-06','16:37:48',0,'2014-01-07 04:01:32',NULL,NULL),(3702,633,'481766','834','00','005010X220A1','481766','','2013-12-12','13:57:06',0,'2013-12-25 22:07:34',NULL,NULL),(15124,2587,'1790315','834','00','005010X220A1','1790315','','2014-01-15','13:15:16',0,'2014-01-16 08:45:36',NULL,NULL),(11507,1490,'1419667','834','00','005010X220A1','1419667','','2013-12-26','19:11:14',0,'2013-12-28 03:31:52',NULL,NULL),(5387,1011,'573847','834','00','005010X220A1','573847','','2013-11-25','16:11:09',0,'2013-12-26 01:17:05',NULL,NULL),(18767,3486,'2549495','834','00','005010X220A1','2549495','','2014-02-11','18:17:25',0,'2014-02-11 21:00:51',NULL,NULL),(5555,1043,'1613911','834','00','005010X220A1','1613911','','2013-12-24','18:58:28',0,'2013-12-26 01:48:12',NULL,NULL),(14384,2412,'2479124','834','00','005010X220A1','2479124','','2014-01-12','13:00:15',0,'2014-01-13 03:01:51',NULL,NULL),(21069,3980,'3257681','834','00','005010X220A1','3257681','','2014-02-24','14:54:22',0,'2014-02-26 09:30:42',NULL,NULL),(18950,3528,'2047790','834','00','005010X220A1','2047790','','2014-02-11','16:55:48',0,'2014-02-11 21:30:29',NULL,NULL),(14958,2566,'1660548','834','00','005010X220A1','1660548','','2014-01-14','12:24:20',0,'2014-01-15 02:07:56',NULL,NULL),(5976,1120,'947932','834','00','005010X220A1','947932','','2013-12-14','21:15:31',0,'2013-12-26 02:33:13',NULL,NULL),(15443,2630,'1574507','834','00','005010X220A1','1574507','','2014-01-15','21:25:32',0,'2014-01-17 03:36:07',NULL,NULL),(3979,719,'590949','834','00','005010X220A1','590949','','2013-12-07','16:59:28',0,'2013-12-25 22:47:30',NULL,NULL),(16735,3065,'2576456','834','00','005010X220A1','2576456','','2014-01-27','12:36:00',0,'2014-01-27 21:01:07',NULL,NULL),(16825,3091,'1646858','834','00','005010X220A1','1646858','','2014-01-27','19:02:44',0,'2014-01-28 21:00:23',NULL,NULL),(16966,3116,'2471653','834','00','005010X220A1','2471653','','2014-01-29','12:37:56',0,'2014-01-29 21:00:34',NULL,NULL),(11976,1580,'1359234','834','00','005010X220A1','1359234','','2013-12-30','15:01:37',0,'2014-01-01 12:01:13',NULL,NULL),(21304,4008,'3414432','834','00','005010X220A1','3414432','','2014-02-26','15:11:12',0,'2014-02-26 21:02:28',NULL,NULL),(14015,2337,'2057371','834','00','005010X220A1','2057371','','2014-01-07','21:58:03',0,'2014-01-13 02:21:15',NULL,NULL),(223,33,'497706','834','00','005010X220A1','497706','','2013-12-05','18:13:43',0,'2013-12-25 17:22:03',NULL,NULL),(479,96,'6247','834','00','005010X220A1','6247','','2013-12-04','08:01:07',0,'2013-12-25 17:50:59',NULL,NULL),(12685,1673,'1566523','834','00','005010X220A1','1566523','','2014-01-02','15:38:18',0,'2014-01-03 02:04:09',NULL,NULL),(4774,861,'430201','834','00','005010X220A1','430201','','2013-11-30','21:31:08',0,'2013-12-26 00:01:06',NULL,NULL),(17525,3235,'2415959','834','00','005010X220A1','2415959','','2014-02-03','10:47:24',0,'2014-02-03 21:00:12',NULL,NULL),(18708,3485,'3055284','834','00','005010X220A1','3055284','','2014-02-10','18:46:34',0,'2014-02-11 21:00:06',NULL,NULL),(23112,4341,'2973408','834','00','005010X220A1','2973408','','2014-03-07','17:45:11',0,'2014-03-07 21:30:44',NULL,NULL),(23736,4467,'3734822','834','00','005010X220A1','3734822','','2014-03-10','17:31:37',0,'2014-03-10 21:02:56',NULL,NULL),(15189,2592,'1748012','834','00','005010X220A1','1748012','','2014-01-14','20:39:47',0,'2014-01-16 08:46:18',NULL,NULL),(367,72,'936414','834','00','005010X220A1','936414','','2013-12-04','14:59:40',0,'2013-12-25 17:47:18',NULL,NULL),(11632,1497,'1429921','834','00','005010X220A1','1429921','','2013-12-27','11:20:28',0,'2013-12-28 03:35:43',NULL,NULL),(11152,1435,'293392','834','00','005010X220A1','293392','','2013-12-23','11:07:41',0,'2013-12-26 13:15:57',NULL,NULL),(5774,1072,'638910','834','00','005010X220A1','638910','','2013-12-14','17:44:50',0,'2013-12-26 02:02:40',NULL,NULL),(1912,325,'84429','834','00','005010X220A1','84429','','2013-12-09','14:26:32',0,'2013-12-25 19:32:06',NULL,NULL),(12185,1601,'2464084','834','00','005010X220A1','2464084','','2013-12-30','10:01:35',0,'2014-01-01 12:08:44',NULL,NULL),(18018,3318,'1407618','834','00','005010X220A1','1407618','','2014-02-05','19:31:37',0,'2014-02-06 21:00:19',NULL,NULL),(19536,3623,'2968927','834','00','005010X220A1','2968927','','2014-02-13','18:29:07',0,'2014-02-14 21:30:52',NULL,NULL),(22760,4276,'3792770','834','00','005010X220A1','3792770','','2014-03-06','16:43:03',0,'2014-03-06 21:00:37',NULL,NULL),(13028,1872,'0001','999','BE','005010X231A1','614257','834','2013-12-28','04:55:00',0,'2014-01-05 16:50:20',NULL,NULL),(12674,1673,'2042849','834','00','005010X220A1','2042849','','2014-01-01','19:57:54',0,'2014-01-03 02:03:48',NULL,NULL),(12133,1588,'2236397','834','00','005010X220A1','2236397','','2013-12-29','20:18:40',0,'2014-01-01 12:06:52',NULL,NULL),(4536,824,'1571192','834','00','005010X220A1','1571192','','2013-12-23','23:16:43',0,'2013-12-25 23:45:12',NULL,NULL),(4708,835,'1884880','834','00','005010X220A1','1884880','','2013-12-23','21:32:58',0,'2013-12-25 23:50:55',NULL,NULL),(20189,3780,'3446102','834','00','005010X220A1','3446102','','2014-02-19','11:48:10',0,'2014-02-20 04:15:02',NULL,NULL),(374,74,'682035','834','00','005010X220A1','682035','','2013-12-03','22:42:00',0,'2013-12-25 17:47:32',NULL,NULL),(16909,3106,'2507506','834','00','005010X220A1','2507506','','2014-01-28','12:56:38',0,'2014-01-28 21:01:19',NULL,NULL),(1114,238,'46145','834','00','005010X220A1','46145','','2013-12-24','07:01:16',0,'2013-12-25 18:45:04',NULL,NULL),(10647,1402,'907838','834','00','005010X220A1','907838','','2013-12-23','18:03:56',0,'2013-12-26 12:58:42',NULL,NULL),(1387,245,'2010814','834','00','005010X220A1','2010814','','2013-12-24','17:15:02',0,'2013-12-25 18:53:36',NULL,NULL),(19034,3540,'2407252','834','00','005010X220A1','2407252','','2014-02-12','11:33:43',0,'2014-02-12 21:30:50',NULL,NULL),(20559,3863,'2691557','834','00','005010X220A1','2691557','','2014-02-21','16:19:20',0,'2014-02-21 21:30:10',NULL,NULL),(23193,4345,'3097201','834','00','005010X220A1','3097201','','2014-03-07','17:49:00',0,'2014-03-07 21:31:41',NULL,NULL),(320,71,'720806','834','00','005010X220A1','720806','','2013-12-03','18:55:09',0,'2013-12-25 17:45:50',NULL,NULL),(12111,1587,'2173784','834','00','005010X220A1','2173784','','2013-12-30','12:46:04',0,'2014-01-01 12:06:05',NULL,NULL),(15762,2714,'1734671','834','00','005010X220A1','1734671','','2014-01-20','12:48:24',0,'2014-01-21 08:46:24',NULL,NULL),(4589,826,'72196','834','00','005010X220A1','72196','','2013-12-23','23:04:03',0,'2013-12-25 23:46:56',NULL,NULL),(13397,2221,'2083568','834','00','005010X220A1','2083568','','2014-01-06','17:02:53',0,'2014-01-07 04:00:48',NULL,NULL),(4390,774,'285669','834','00','005010X220A1','285669','','2013-11-27','14:26:22',0,'2013-12-25 23:15:38',NULL,NULL),(2987,542,'385909','834','00','005010X220A1','385909','','2013-12-13','11:27:23',0,'2013-12-25 21:32:44',NULL,NULL),(12556,1657,'1380708','834','00','005010X220A1','1380708','','2013-12-31','17:50:51',1,'2014-01-02 04:35:29',NULL,NULL),(17846,3291,'1837504','834','00','005010X220A1','1837504','','2014-02-04','18:36:51',0,'2014-02-05 21:30:03',NULL,NULL),(18666,3467,'2379480','834','00','005010X220A1','2379480','','2014-02-10','12:02:09',0,'2014-02-10 21:31:50',NULL,NULL),(18668,3467,'2120968','834','00','005010X220A1','2120968','','2014-02-10','12:19:44',0,'2014-02-10 21:31:51',NULL,NULL),(19861,3704,'2923831','834','00','005010X220A1','2923831','','2014-02-15','21:18:19',0,'2014-02-16 19:00:08',NULL,NULL),(20881,3920,'3071087','834','00','005010X220A1','3071087','','2014-02-25','13:03:40',0,'2014-02-25 21:31:55',NULL,NULL),(22664,4254,'3095879','834','00','005010X220A1','3095879','','2014-03-05','11:02:37',0,'2014-03-05 21:32:01',NULL,NULL),(197,18,'1030937','834','00','005010X220A1','1030937','','2013-12-05','09:43:15',0,'2013-12-25 17:21:09',NULL,NULL),(17802,3270,'2466039','834','00','005010X220A1','2466039','','2014-02-04','18:01:23',0,'2014-02-04 21:01:34',NULL,NULL),(7342,1279,'614004','834','00','005010X220A1','614004','','2013-11-30','16:44:00',0,'2013-12-26 04:15:12',NULL,NULL),(5471,1040,'1847863','834','00','005010X220A1','1847863','','2013-12-24','21:37:48',0,'2013-12-26 01:45:28',NULL,NULL),(15684,2695,'2541655','834','00','005010X220A1','2541655','','2014-01-19','13:36:15',0,'2014-01-21 08:45:16',NULL,NULL),(13085,1929,'0001','999','BE','005010X231A1','810567','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:56',NULL,NULL),(15823,2736,'2037115','834','00','005010X220A1','2037115','','2014-01-20','18:45:47',1,'2014-01-22 03:21:52',NULL,NULL),(13203,2047,'0001','999','BE','005010X231A1','378477','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:00',NULL,NULL),(12946,1733,'2300394','834','00','005010X220A1','2300394','','2014-01-03','20:42:44',0,'2014-01-05 00:00:11',NULL,NULL),(1819,312,'30099','834','00','005010X220A1','30099','','2013-12-10','14:13:31',0,'2013-12-25 19:20:13',NULL,NULL),(12699,1677,'1398446','834','00','005010X220A1','1398446','','2014-01-02','10:30:59',0,'2014-01-03 02:04:44',NULL,NULL),(2296,397,'236265','834','00','005010X220A1','236265','','2013-11-24','15:46:35',0,'2013-12-25 20:01:03',NULL,NULL),(23762,4478,'3295781','834','00','005010X220A1','3295781','','2014-03-10','12:38:40',0,'2014-03-10 21:30:12',NULL,NULL),(17097,3142,'2549196','834','00','005010X220A1','2549196','','2014-01-29','19:19:44',0,'2014-01-30 21:00:05',NULL,NULL),(10379,1400,'215702','834','00','005010X220A1','215702','','2013-12-22','21:22:38',0,'2013-12-26 12:50:03',NULL,NULL),(7565,1301,'1232910','834','00','005010X220A1','1232910','','2013-12-21','12:09:45',0,'2013-12-26 04:36:09',NULL,NULL),(3322,585,'1267770','834','00','005010X220A1','1267770','','2013-12-17','09:54:09',0,'2013-12-25 21:49:16',NULL,NULL),(1453,252,'900324','834','00','005010X220A1','900324','','2013-12-24','12:51:33',0,'2013-12-25 18:55:48',NULL,NULL),(6027,1141,'1081632','834','00','005010X220A1','1081632','','2013-11-17','09:52:13',0,'2013-12-26 02:45:46',NULL,NULL),(11313,1456,'1906918','834','00','005010X220A1','1906918','','2013-12-26','12:12:40',0,'2013-12-27 02:03:55',NULL,NULL),(19900,3716,'3370400','834','00','005010X220A1','3370400','','2014-02-15','22:14:12',0,'2014-02-16 19:00:39',NULL,NULL),(21941,4132,'3426364','834','00','005010X220A1','3426364','','2014-03-01','10:32:16',0,'2014-03-01 21:00:58',NULL,NULL),(649,108,'228452','834','00','005010X220A1','228452','','2013-12-16','15:40:29',0,'2013-12-25 18:05:11',NULL,NULL),(1000,187,'651316','834','00','005010X220A1','651316','','2013-12-03','16:48:52',0,'2013-12-25 18:20:16',NULL,NULL),(1324,245,'70889','834','00','005010X220A1','70889','','2013-12-24','11:12:31',0,'2013-12-25 18:51:34',NULL,NULL),(1406,247,'1760166','834','00','005010X220A1','1760166','','2013-12-24','14:24:37',0,'2013-12-25 18:54:15',NULL,NULL),(17695,3260,'2385623','834','00','005010X220A1','2385623','','2014-02-04','17:52:52',0,'2014-02-04 21:00:27',NULL,NULL),(2701,502,'878927','834','00','005010X220A1','878927','','2013-12-22','15:38:07',0,'2013-12-25 21:17:15',NULL,NULL),(12468,1640,'2491023','834','00','005010X220A1','2491023','','2013-12-30','19:08:29',1,'2014-01-02 04:32:11',NULL,NULL),(4698,834,'1835182','834','00','005010X220A1','1835182','','2013-12-23','22:07:35',0,'2013-12-25 23:50:35',NULL,NULL),(13941,2318,'2437324','834','00','005010X220A1','2437324','','2014-01-09','10:08:41',0,'2014-01-13 02:20:14',NULL,NULL),(17652,3251,'2773795','834','00','005010X220A1','2773795','','2014-02-03','18:00:54',0,'2014-02-03 21:01:31',NULL,NULL),(15951,2763,'2594007','834','00','005010X220A1','2594007','','2014-01-22','13:52:45',0,'2014-01-23 03:01:50',NULL,NULL),(17333,3177,'1771062','834','00','005010X220A1','1771062','','2014-01-31','13:07:14',0,'2014-01-31 21:01:04',NULL,NULL),(21335,4022,'2742889','834','00','005010X220A1','2742889','','2014-02-26','19:43:01',0,'2014-02-28 06:30:05',NULL,NULL),(22953,4308,'3117169','834','00','005010X220A1','3117169','','2014-03-06','14:28:47',0,'2014-03-06 21:02:57',NULL,NULL),(16320,2982,'1639915','834','00','005010X220A1','1639915','','2014-01-22','22:56:59',0,'2014-01-23 21:00:28',NULL,NULL),(16298,2980,'2069512','834','00','005010X220A1','2069512','','2014-01-23','16:44:29',0,'2014-01-23 21:00:11',NULL,NULL),(3407,590,'844533','834','00','005010X220A1','844533','','2013-12-17','14:25:19',0,'2013-12-25 21:51:54',NULL,NULL),(19391,3593,'3282667','834','00','005010X220A1','3282667','','2014-02-13','08:27:45',0,'2014-02-13 22:02:23',NULL,NULL),(19555,3626,'2074795','834','00','005010X220A1','2074795','','2014-02-14','00:58:50',0,'2014-02-14 21:31:04',NULL,NULL),(12048,1585,'1876410','834','00','005010X220A1','1876410','','2013-12-29','19:15:01',0,'2014-01-01 12:03:55',NULL,NULL),(16374,2986,'1800291','834','00','005010X220A1','1800291','','2014-01-23','08:35:55',0,'2014-01-23 21:01:06',NULL,NULL),(15008,2584,'2566155','834','00','005010X220A1','2566155','','2014-01-15','10:30:19',0,'2014-01-16 08:44:22',NULL,NULL),(6463,1220,'1104975','834','00','005010X220A1','1104975','','2013-11-22','11:37:14',0,'2013-12-26 03:16:33',NULL,NULL),(19814,3679,'2706299','834','00','005010X220A1','2706299','','2014-02-14','19:14:56',0,'2014-02-15 22:01:33',NULL,NULL),(11980,1580,'1914051','834','00','005010X220A1','1914051','','2013-12-30','16:12:35',0,'2014-01-01 12:01:21',NULL,NULL),(1152,239,'1550728','834','00','005010X220A1','1550728','','2013-12-24','10:48:22',0,'2013-12-25 18:46:15',NULL,NULL),(5642,1048,'86648','834','00','005010X220A1','86648','','2013-12-24','22:56:03',0,'2013-12-26 01:51:03',NULL,NULL),(2545,457,'1230690','834','00','005010X220A1','1230690','','2013-11-18','16:05:34',0,'2013-12-25 20:31:21',NULL,NULL),(17987,3310,'1537400','834','00','005010X220A1','1537400','','2014-02-05','15:56:05',0,'2014-02-05 21:31:15',NULL,NULL),(19377,3590,'2374472','834','00','005010X220A1','2374472','','2014-02-13','16:50:39',0,'2014-02-13 22:02:13',NULL,NULL),(19643,3645,'3050619','834','00','005010X220A1','3050619','','2014-02-14','11:08:18',0,'2014-02-14 21:32:08',NULL,NULL),(19802,3677,'2608434','834','00','005010X220A1','2608434','','2014-02-15','14:14:33',0,'2014-02-15 22:01:24',NULL,NULL),(20005,3748,'2573229','834','00','005010X220A1','2573229','','2014-02-18','15:06:16',0,'2014-02-18 22:00:36',NULL,NULL),(23230,4359,'2790589','834','00','005010X220A1','2790589','','2014-03-07','12:56:30',0,'2014-03-07 21:32:07',NULL,NULL),(17544,3235,'2129980','834','00','005010X220A1','2129980','','2014-02-03','16:43:00',0,'2014-02-03 21:00:23',NULL,NULL),(16445,3006,'1989764','834','00','005010X220A1','1989764','','2014-01-23','19:17:44',0,'2014-01-24 21:00:09',NULL,NULL),(16846,3092,'2233509','834','00','005010X220A1','2233509','','2014-01-28','11:51:31',0,'2014-01-28 21:00:36',NULL,NULL),(17312,3174,'2744801','834','00','005010X220A1','2744801','','2014-01-30','20:04:46',0,'2014-01-31 21:00:49',NULL,NULL),(11246,1454,'1234552','834','00','005010X220A1','1234552','','2013-12-26','14:15:13',0,'2013-12-27 02:01:50',NULL,NULL),(1484,254,'1471782','834','00','005010X220A1','1471782','','2013-12-24','08:10:47',0,'2013-12-25 18:56:54',NULL,NULL),(1592,281,'786356','834','00','005010X220A1','786356','','2013-11-19','22:57:46',0,'2013-12-25 19:01:01',NULL,NULL),(10503,1400,'1509334','834','00','005010X220A1','1509334','','2013-12-23','18:26:48',0,'2013-12-26 12:53:58',NULL,NULL),(16226,2918,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:54:00',0,'2014-01-23 06:38:52',NULL,NULL),(17188,3148,'1655582','834','00','005010X220A1','1655582','','2014-01-30','17:52:59',0,'2014-01-30 21:01:01',NULL,NULL),(13631,2270,'1549870','834','00','005010X220A1','1549870','','2014-01-07','09:51:23',0,'2014-01-08 18:24:03',NULL,NULL),(13565,2254,'1507129','834','00','005010X220A1','1507129','','2014-01-04','19:21:59',1,'2014-01-07 10:21:22',NULL,NULL),(3683,629,'102975','834','00','005010X220A1','102975','','2013-12-12','18:32:08',0,'2013-12-25 22:06:54',NULL,NULL),(18067,3321,'1675657','834','00','005010X220A1','1675657','','2014-02-06','08:37:16',0,'2014-02-06 21:00:53',NULL,NULL),(13799,2294,'2480290','834','00','005010X220A1','2480290','','2014-01-11','14:02:38',0,'2014-01-13 02:18:14',NULL,NULL),(10594,1402,'144314','834','00','005010X220A1','144314','','2013-12-23','12:29:49',0,'2013-12-26 12:56:57',NULL,NULL),(12159,1593,'1860951','834','00','005010X220A1','1860951','','2013-12-29','22:55:58',0,'2014-01-01 12:07:45',NULL,NULL),(12075,1586,'1855970','834','00','005010X220A1','1855970','','2013-12-30','12:24:18',0,'2014-01-01 12:04:50',NULL,NULL),(5398,1019,'1095336','834','00','005010X220A1','1095336','','2013-11-14','09:21:52',0,'2013-12-26 01:30:06',NULL,NULL),(21306,4008,'2584461','834','00','005010X220A1','2584461','','2014-02-26','15:43:23',0,'2014-02-26 21:02:29',NULL,NULL),(22070,4171,'3221781','834','00','005010X220A1','3221781','','2014-03-03','11:35:45',0,'2014-03-03 21:00:24',NULL,NULL),(17321,3174,'2133647','834','00','005010X220A1','2133647','','2014-01-31','14:20:31',0,'2014-01-31 21:00:55',NULL,NULL),(16559,3032,'1710993','834','00','005010X220A1','1710993','','2014-01-24','14:41:54',0,'2014-01-24 21:01:18',NULL,NULL),(444,81,'742994','834','00','005010X220A1','742994','','2013-12-03','21:14:51',0,'2013-12-25 17:49:47',NULL,NULL),(15580,2658,'2511120','834','00','005010X220A1','2511120','','2014-01-17','16:11:04',0,'2014-01-20 08:06:12',NULL,NULL),(3154,560,'467653','834','00','005010X220A1','467653','','2013-12-13','09:17:58',0,'2013-12-25 21:37:53',NULL,NULL),(13823,2299,'2317832','834','00','005010X220A1','2317832','','2014-01-10','22:22:49',0,'2014-01-13 02:18:30',NULL,NULL),(5118,942,'1053277','834','00','005010X220A1','1053277','','2013-12-11','09:06:33',0,'2013-12-26 00:49:49',NULL,NULL),(7294,1256,'533633','834','00','005010X220A1','533633','','2013-12-18','15:56:32',0,'2013-12-26 04:09:31',NULL,NULL),(12227,1617,'1418814','834','00','005010X220A1','1418814','','2014-01-01','14:39:10',1,'2014-01-02 04:22:31',NULL,NULL),(6353,1180,'66419','834','00','005010X220A1','66419','','2013-12-19','21:13:13',0,'2013-12-26 03:08:59',NULL,NULL),(19063,3542,'3197928','834','00','005010X220A1','3197928','','2014-02-12','15:23:39',0,'2014-02-12 21:31:10',NULL,NULL),(22317,4201,'3076361','834','00','005010X220A1','3076361','','2014-03-04','16:10:08',0,'2014-03-04 21:01:10',NULL,NULL),(23267,4377,'3194948','834','00','005010X220A1','3194948','','2014-03-08','14:43:45',0,'2014-03-08 21:00:06',NULL,NULL),(23350,4388,'3518125','834','00','005010X220A1','3518125','','2014-03-08','16:15:51',0,'2014-03-08 21:30:58',NULL,NULL),(16007,2767,'1381223','834','00','005010X220A1','1381223','','2014-01-21','20:45:03',0,'2014-01-23 03:02:16',NULL,NULL),(2355,413,'55688','834','00','005010X220A1','55688','','2013-12-06','17:26:51',0,'2013-12-25 20:15:48',NULL,NULL),(10376,1400,'227502','834','00','005010X220A1','227502','','2013-12-22','20:17:15',0,'2013-12-26 12:49:57',NULL,NULL),(11075,1421,'1471687','834','00','005010X220A1','1471687','','2013-12-23','15:05:53',0,'2013-12-26 13:13:16',NULL,NULL),(20331,3798,'3472488','834','00','005010X220A1','3472488','','2014-02-19','14:25:57',0,'2014-02-20 04:50:58',NULL,NULL),(20587,3870,'2705460','834','00','005010X220A1','2705460','','2014-02-20','22:33:25',0,'2014-02-21 22:00:05',NULL,NULL),(18096,3327,'2762318','834','00','005010X220A1','2762318','','2014-02-06','11:55:07',0,'2014-02-06 21:01:13',NULL,NULL),(14004,2336,'1812464','834','00','005010X220A1','1812464','','2014-01-09','15:13:53',0,'2014-01-13 02:21:01',NULL,NULL),(2553,459,'354996','834','00','005010X220A1','354996','','2013-11-18','11:07:12',0,'2013-12-25 20:31:39',NULL,NULL),(4378,773,'529367','834','00','005010X220A1','529367','','2013-11-27','15:23:38',0,'2013-12-25 23:15:15',NULL,NULL),(19572,3627,'2689878','834','00','005010X220A1','2689878','','2014-02-14','12:50:55',0,'2014-02-14 21:31:18',NULL,NULL),(20478,3843,'3648107','834','00','005010X220A1','3648107','','2014-02-20','13:45:31',0,'2014-02-20 22:00:46',NULL,NULL),(20492,3845,'2551050','834','00','005010X220A1','2551050','','2014-02-19','20:52:34',0,'2014-02-20 22:00:57',NULL,NULL),(21551,4046,'3775713','834','00','005010X220A1','3775713','','2014-02-27','12:17:09',0,'2014-02-28 06:31:45',NULL,NULL),(13424,2222,'1405780','834','00','005010X220A1','1405780','','2014-01-06','16:56:13',0,'2014-01-07 04:01:44',NULL,NULL),(18107,3329,'2523024','834','00','005010X220A1','2523024','','2014-02-06','13:32:34',0,'2014-02-06 21:01:21',NULL,NULL),(15719,2710,'1463754','834','00','005010X220A1','1463754','','2014-01-19','15:54:43',0,'2014-01-21 08:45:43',NULL,NULL),(1528,260,'1720660','834','00','005010X220A1','1720660','','2013-12-24','16:08:28',0,'2013-12-25 18:58:18',NULL,NULL),(15080,2585,'2143413','834','00','005010X220A1','2143413','','2014-01-15','11:31:25',0,'2014-01-16 08:45:08',NULL,NULL),(4400,776,'1221203','834','00','005010X220A1','1221203','','2013-11-26','23:46:15',0,'2013-12-25 23:15:56',NULL,NULL),(3046,544,'663626','834','00','005010X220A1','663626','','2013-12-13','12:23:53',0,'2013-12-25 21:34:28',NULL,NULL),(4366,766,'1227642','834','00','005010X220A1','1227642','','2013-12-19','15:58:06',0,'2013-12-25 23:11:16',NULL,NULL),(22752,4276,'3177045','834','00','005010X220A1','3177045','','2014-03-06','13:46:14',0,'2014-03-06 21:00:31',NULL,NULL),(18411,3418,'2131461','834','00','005010X220A1','2131461','','2014-02-09','16:19:07',0,'2014-02-09 19:00:43',NULL,NULL),(15995,2765,'1659559','834','00','005010X220A1','1659559','','2014-01-22','15:13:54',0,'2014-01-23 03:02:11',NULL,NULL),(1669,290,'674609','834','00','005010X220A1','674609','','2013-12-09','22:42:30',0,'2013-12-25 19:15:31',NULL,NULL),(15416,2629,'2541587','834','00','005010X220A1','2541587','','2014-01-15','22:07:46',0,'2014-01-17 03:35:55',NULL,NULL),(2760,505,'1053805','834','00','005010X220A1','1053805','','2013-12-22','12:37:52',0,'2013-12-25 21:19:02',NULL,NULL),(10662,1402,'43657','834','00','005010X220A1','43657','','2013-12-23','19:10:37',0,'2013-12-26 12:59:10',NULL,NULL),(15358,2623,'2267285','834','00','005010X220A1','2267285','','2014-01-16','16:38:17',0,'2014-01-17 03:35:27',NULL,NULL),(14579,2520,'1993426','834','00','005010X220A1','1993426','','2014-01-13','15:05:03',0,'2014-01-14 01:32:53',NULL,NULL),(10624,1402,'818893','834','00','005010X220A1','818893','','2013-12-23','15:29:49',0,'2013-12-26 12:57:57',NULL,NULL),(5805,1080,'18224','834','00','005010X220A1','18224','','2013-12-14','11:51:10',0,'2013-12-26 02:03:43',NULL,NULL),(7081,1236,'1086045','834','00','005010X220A1','1086045','','2013-12-18','10:13:46',0,'2013-12-26 04:03:02',NULL,NULL),(20086,3763,'2375829','834','00','005010X220A1','2375829','','2014-02-18','16:41:53',0,'2014-02-18 22:01:35',NULL,NULL),(20621,3871,'3271377','834','00','005010X220A1','3271377','','2014-02-21','12:40:32',0,'2014-02-21 22:00:31',NULL,NULL),(21977,4144,'3616284','834','00','005010X220A1','3616284','','2014-03-02','13:16:19',0,'2014-03-03 01:00:11',NULL,NULL),(18090,3324,'2540786','834','00','005010X220A1','2540786','','2014-02-06','12:40:52',0,'2014-02-06 21:01:09',NULL,NULL),(16858,3093,'1423129','834','00','005010X220A1','1423129','','2014-01-28','10:47:54',0,'2014-01-28 21:00:45',NULL,NULL),(468,89,'5239','834','00','005010X220A1','5239','','2013-12-03','21:06:07',0,'2013-12-25 17:50:36',NULL,NULL),(16210,2902,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 05:02:10',NULL,NULL),(13019,1746,'2039605','834','00','005010X220A1','2039605','','2014-01-04','16:35:59',0,'2014-01-05 00:02:55',NULL,NULL),(15520,2648,'2358002','834','00','005010X220A1','2358002','','2014-01-15','20:56:27',0,'2014-01-17 03:36:39',NULL,NULL),(1709,292,'749184','834','00','005010X220A1','749184','','2013-12-10','16:04:32',0,'2013-12-25 19:16:47',NULL,NULL),(4886,894,'1256222','834','00','005010X220A1','1256222','','2013-11-21','14:19:17',0,'2013-12-26 00:16:49',NULL,NULL),(3974,717,'698463','834','00','005010X220A1','698463','','2013-12-07','05:40:57',0,'2013-12-25 22:47:22',NULL,NULL),(19945,3738,'2856120','834','00','005010X220A1','2856120','','2014-02-18','11:21:56',0,'2014-02-18 21:30:15',NULL,NULL),(20322,3796,'2383493','834','00','005010X220A1','2383493','','2014-02-19','13:51:10',0,'2014-02-20 04:48:37',NULL,NULL),(21525,4036,'3792478','834','00','005010X220A1','3792478','','2014-02-27','15:07:57',0,'2014-02-28 06:31:33',NULL,NULL),(21870,4122,'2959036','834','00','005010X220A1','2959036','','2014-02-28','21:00:35',0,'2014-03-01 21:00:09',NULL,NULL),(19273,3582,'2494591','834','00','005010X220A1','2494591','','2014-02-12','22:09:05',0,'2014-02-13 22:00:53',NULL,NULL),(17120,3142,'1752197','834','00','005010X220A1','1752197','','2014-01-30','17:41:16',0,'2014-01-30 21:00:18',NULL,NULL),(15511,2643,'2228099','834','00','005010X220A1','2228099','','2014-01-16','13:09:55',0,'2014-01-17 03:36:36',NULL,NULL),(10828,1404,'1777984','834','00','005010X220A1','1777984','','2013-12-23','18:00:41',0,'2013-12-26 13:04:47',NULL,NULL),(2403,415,'399465','834','00','005010X220A1','399465','','2013-12-06','11:51:58',0,'2013-12-25 20:17:19',NULL,NULL),(10766,1404,'983334','834','00','005010X220A1','983334','','2013-12-22','21:50:40',0,'2013-12-26 13:02:47',NULL,NULL),(14921,2559,'1806002','834','00','005010X220A1','1806002','','2014-01-14','11:35:17',0,'2014-01-15 02:07:39',NULL,NULL),(14464,2485,'0001','999','BE','005010X231A1','1062790','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:37',NULL,NULL),(22268,4200,'3200789','834','00','005010X220A1','3200789','','2014-03-04','13:35:17',0,'2014-03-04 21:00:34',NULL,NULL),(11387,1463,'1109919','834','00','005010X220A1','1109919','','2013-12-26','13:23:08',0,'2013-12-27 02:06:07',NULL,NULL),(10758,1403,'1154374','834','00','005010X220A1','1154374','','2013-12-23','19:05:56',0,'2013-12-26 13:02:31',NULL,NULL),(18496,3438,'2743506','834','00','005010X220A1','2743506','','2014-02-10','04:20:36',0,'2014-02-10 11:01:11',NULL,NULL),(5324,1000,'916312','834','00','005010X220A1','916312','','2013-11-05','14:08:49',0,'2013-12-26 01:02:21',NULL,NULL),(1328,245,'824394','834','00','005010X220A1','824394','','2013-12-24','11:34:37',0,'2013-12-25 18:51:42',NULL,NULL),(2978,542,'1307898','834','00','005010X220A1','1307898','','2013-12-13','17:33:27',0,'2013-12-25 21:32:29',NULL,NULL),(1500,257,'484509','834','00','005010X220A1','484509','','2013-12-24','11:18:23',0,'2013-12-25 18:57:22',NULL,NULL),(2765,506,'1123841','834','00','005010X220A1','1123841','','2013-12-21','18:48:33',0,'2013-12-25 21:19:11',NULL,NULL),(13962,2322,'1543458','834','00','005010X220A1','1543458','','2014-01-09','14:59:27',0,'2014-01-13 02:20:29',NULL,NULL),(16163,2855,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:45:00',1,'2014-01-23 04:13:16',NULL,NULL),(17223,3156,'1944195','834','00','005010X220A1','1944195','','2014-01-30','09:32:19',0,'2014-01-30 21:01:25',NULL,NULL),(17401,3198,'2679298','834','00','005010X220A1','2679298','','2014-02-01','15:08:55',0,'2014-02-01 19:00:09',NULL,NULL),(18568,3453,'2537951','834','00','005010X220A1','2537951','','2014-02-10','13:10:43',0,'2014-02-10 21:30:41',NULL,NULL),(21972,4143,'2640409','834','00','005010X220A1','2640409','','2014-03-02','17:05:02',0,'2014-03-03 01:00:08',NULL,NULL),(16769,3072,'1772412','834','00','005010X220A1','1772412','','2014-01-27','12:12:33',0,'2014-01-27 21:01:32',NULL,NULL),(14873,2555,'1812584','834','00','005010X220A1','1812584','','2014-01-14','12:57:11',0,'2014-01-15 02:07:16',NULL,NULL),(1839,318,'827997','834','00','005010X220A1','827997','','2013-12-10','15:25:45',0,'2013-12-25 19:20:55',NULL,NULL),(2384,414,'608435','834','00','005010X220A1','608435','','2013-12-06','17:19:02',0,'2013-12-25 20:16:45',NULL,NULL),(2445,420,'791898','834','00','005010X220A1','791898','','2013-12-06','13:42:43',0,'2013-12-25 20:18:41',NULL,NULL),(7039,1235,'841719','834','00','005010X220A1','841719','','2013-12-18','14:42:46',0,'2013-12-26 04:01:43',NULL,NULL),(6313,1175,'782915','834','00','005010X220A1','782915','','2013-12-19','21:40:19',0,'2013-12-26 03:07:47',NULL,NULL),(14064,2339,'2063010','834','00','005010X220A1','2063010','','2014-01-08','11:52:00',0,'2014-01-13 02:21:46',NULL,NULL),(21079,3980,'3169991','834','00','005010X220A1','3169991','','2014-02-24','17:56:41',0,'2014-02-26 09:30:48',NULL,NULL),(21102,3992,'2912778','834','00','005010X220A1','2912778','','2014-02-24','17:13:10',0,'2014-02-26 09:31:07',NULL,NULL),(21377,4024,'3233573','834','00','005010X220A1','3233573','','2014-02-27','12:38:22',0,'2014-02-28 06:30:25',NULL,NULL),(16398,2993,'1550328','834','00','005010X220A1','1550328','','2014-01-23','14:59:22',0,'2014-01-23 21:01:21',NULL,NULL),(16203,2895,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 04:52:35',NULL,NULL),(12864,1706,'1872602','834','00','005010X220A1','1872602','','2014-01-03','10:38:48',0,'2014-01-04 02:03:34',NULL,NULL),(12788,1703,'2319105','834','00','005010X220A1','2319105','','2014-01-03','10:02:01',0,'2014-01-04 02:00:49',NULL,NULL),(15907,2743,'2242870','834','00','005010X220A1','2242870','','2014-01-21','11:00:37',1,'2014-01-22 03:22:46',NULL,NULL),(1905,325,'937654','834','00','005010X220A1','937654','','2013-12-09','13:15:32',0,'2013-12-25 19:31:55',NULL,NULL),(11012,1414,'520336','834','00','005010X220A1','520336','','2013-12-23','10:18:35',0,'2013-12-26 13:11:11',NULL,NULL),(2974,541,'963147','834','00','005010X220A1','963147','','2013-12-13','15:20:57',0,'2013-12-25 21:32:22',NULL,NULL),(7254,1246,'552827','834','00','005010X220A1','552827','','2013-12-18','11:46:53',0,'2013-12-26 04:08:19',NULL,NULL),(20516,3849,'2881135','834','00','005010X220A1','2881135','','2014-02-19','22:31:42',0,'2014-02-20 22:01:17',NULL,NULL),(22184,4180,'3054424','834','00','005010X220A1','3054424','','2014-03-03','16:33:38',0,'2014-03-03 21:31:19',NULL,NULL),(22565,4248,'3175478','834','00','005010X220A1','3175478','','2014-03-05','12:52:13',0,'2014-03-05 21:30:54',NULL,NULL),(14226,2367,'2576025','834','00','005010X220A1','2576025','','2014-01-09','18:38:30',0,'2014-01-13 02:24:01',NULL,NULL),(12300,1628,'1566487','834','00','005010X220A1','1566487','','2014-01-01','10:29:48',1,'2014-01-02 04:25:17',NULL,NULL),(10802,1404,'1413251','834','00','005010X220A1','1413251','','2013-12-23','14:40:46',0,'2013-12-26 13:03:56',NULL,NULL),(11963,1580,'1475450','834','00','005010X220A1','1475450','','2013-12-30','11:46:31',0,'2014-01-01 12:00:40',NULL,NULL),(20271,3795,'2597144','834','00','005010X220A1','2597144','','2014-02-19','01:08:58',0,'2014-02-20 04:35:50',NULL,NULL),(401,76,'435078','834','00','005010X220A1','435078','','2013-12-04','13:32:01',0,'2013-12-25 17:48:24',NULL,NULL),(16507,3011,'1623656','834','00','005010X220A1','1623656','','2014-01-24','14:41:54',0,'2014-01-24 21:00:45',NULL,NULL),(16315,2980,'2185801','834','00','005010X220A1','2185801','','2014-01-23','15:45:40',0,'2014-01-23 21:00:24',NULL,NULL),(1249,243,'940967','834','00','005010X220A1','940967','','2013-12-24','11:28:58',0,'2013-12-25 18:49:09',NULL,NULL),(5073,936,'480657','834','00','005010X220A1','480657','','2013-12-11','14:36:11',0,'2013-12-26 00:48:19',NULL,NULL),(11572,1492,'1999017','834','00','005010X220A1','1999017','','2013-12-27','15:07:11',0,'2013-12-28 03:33:54',NULL,NULL),(19264,3581,'2294906','834','00','005010X220A1','2294906','','2014-02-13','15:15:42',0,'2014-02-13 22:00:45',NULL,NULL),(20635,3873,'2873104','834','00','005010X220A1','2873104','','2014-02-21','12:32:06',0,'2014-02-21 22:00:41',NULL,NULL),(20738,3903,'2850585','834','00','005010X220A1','2850585','','2014-02-25','02:46:51',0,'2014-02-25 21:30:09',NULL,NULL),(21421,4026,'3817845','834','00','005010X220A1','3817845','','2014-02-27','13:00:06',0,'2014-02-28 06:30:44',NULL,NULL),(6013,1136,'675773','834','00','005010X220A1','675773','','2013-11-17','17:08:43',0,'2013-12-26 02:45:19',NULL,NULL),(406,76,'1101002','834','00','005010X220A1','1101002','','2013-12-04','17:19:35',0,'2013-12-25 17:48:34',NULL,NULL),(1312,245,'798752','834','00','005010X220A1','798752','','2013-12-24','09:49:04',0,'2013-12-25 18:51:12',NULL,NULL),(1721,293,'564861','834','00','005010X220A1','564861','','2013-12-09','20:26:22',0,'2013-12-25 19:17:07',NULL,NULL),(10787,1404,'1305485','834','00','005010X220A1','1305485','','2013-12-23','11:29:39',0,'2013-12-26 13:03:27',NULL,NULL),(3762,654,'193496','834','00','005010X220A1','193496','','2013-12-07','20:57:15',0,'2013-12-25 22:15:04',NULL,NULL),(3680,629,'739667','834','00','005010X220A1','739667','','2013-12-12','12:58:09',0,'2013-12-25 22:06:50',NULL,NULL),(20502,3846,'3597747','834','00','005010X220A1','3597747','','2014-02-20','16:32:56',0,'2014-02-20 22:01:05',NULL,NULL),(163,12,'566826','834','00','005010X220A1','566826','','2013-12-04','19:50:35',0,'2013-12-25 17:20:04',NULL,NULL),(13976,2323,'2050889','834','00','005010X220A1','2050889','','2014-01-08','19:30:37',0,'2014-01-13 02:20:39',NULL,NULL),(13643,2271,'2389676','834','00','005010X220A1','2389676','','2014-01-06','18:36:36',0,'2014-01-08 18:24:07',NULL,NULL),(12135,1588,'2159544','834','00','005010X220A1','2159544','','2013-12-30','10:23:09',0,'2014-01-01 12:06:56',NULL,NULL),(12882,1706,'1814739','834','00','005010X220A1','1814739','','2014-01-03','16:41:15',0,'2014-01-04 02:04:14',NULL,NULL),(12880,1706,'2471061','834','00','005010X220A1','2471061','','2014-01-03','16:17:56',0,'2014-01-04 02:04:09',NULL,NULL),(20607,3870,'2882436','834','00','005010X220A1','2882436','','2014-02-21','17:18:14',0,'2014-02-21 22:00:21',NULL,NULL),(21118,3994,'3693265','834','00','005010X220A1','3693265','','2014-02-26','13:36:22',0,'2014-02-26 21:00:21',NULL,NULL),(22703,4263,'3688248','834','00','005010X220A1','3688248','','2014-03-05','14:29:29',0,'2014-03-05 21:32:30',NULL,NULL),(12521,1643,'1615329','834','00','005010X220A1','1615329','','2013-12-31','16:08:53',1,'2014-01-02 04:34:06',NULL,NULL),(1185,239,'1129178','834','00','005010X220A1','1129178','','2013-12-24','15:25:33',0,'2013-12-25 18:47:17',NULL,NULL),(18379,3407,'2948755','834','00','005010X220A1','2948755','','2014-02-08','18:44:38',0,'2014-02-09 19:00:20',NULL,NULL),(17743,3262,'2163158','834','00','005010X220A1','2163158','','2014-02-04','10:07:53',0,'2014-02-04 21:00:56',NULL,NULL),(17518,3234,'1687900','834','00','005010X220A1','1687900','','2014-02-03','13:22:42',0,'2014-02-03 21:00:07',NULL,NULL),(15940,2756,'1421599','834','00','005010X220A1','1421599','','2014-01-21','16:38:57',1,'2014-01-22 03:23:06',NULL,NULL),(14917,2558,'2587629','834','00','005010X220A1','2587629','','2014-01-14','18:35:45',0,'2014-01-15 02:07:37',NULL,NULL),(20293,3796,'3461519','834','00','005010X220A1','3461519','','2014-02-19','10:28:22',0,'2014-02-20 04:41:24',NULL,NULL),(23191,4345,'3307994','834','00','005010X220A1','3307994','','2014-03-07','16:52:10',0,'2014-03-07 21:31:39',NULL,NULL),(23757,4476,'3464946','834','00','005010X220A1','3464946','','2014-03-10','13:33:47',0,'2014-03-10 21:30:08',NULL,NULL),(18346,3396,'2773896','834','00','005010X220A1','2773896','','2014-02-07','19:00:46',0,'2014-02-08 19:30:05',NULL,NULL),(11912,1565,'2060638','834','00','005010X220A1','2060638','','2013-12-28','20:20:20',0,'2013-12-30 00:01:24',NULL,NULL),(1247,243,'1900947','834','00','005010X220A1','1900947','','2013-12-24','11:22:17',0,'2013-12-25 18:49:05',NULL,NULL),(11582,1492,'252350','834','00','005010X220A1','252350','','2013-12-27','16:22:41',0,'2013-12-28 03:34:10',NULL,NULL),(15297,2618,'2174236','834','00','005010X220A1','2174236','','2014-01-15','13:36:23',0,'2014-01-16 08:47:28',NULL,NULL),(13952,2320,'2121705','834','00','005010X220A1','2121705','','2014-01-09','14:48:15',0,'2014-01-13 02:20:21',NULL,NULL),(3500,615,'38005','834','00','005010X220A1','38005','','2013-12-12','14:18:12',0,'2013-12-25 22:01:11',NULL,NULL),(20204,3781,'3511201','834','00','005010X220A1','3511201','','2014-02-19','11:21:20',0,'2014-02-20 04:19:04',NULL,NULL),(18191,3351,'2309772','834','00','005010X220A1','2309772','','2014-02-07','16:21:19',0,'2014-02-07 19:00:28',NULL,NULL),(280,60,'4998','834','00','005010X220A1','4998','','2013-11-08','22:28:22',0,'2013-12-25 17:31:58',NULL,NULL),(14508,2515,'1543554','834','00','005010X220A1','1543554','','2014-01-13','15:45:17',0,'2014-01-14 01:32:07',NULL,NULL),(1801,305,'586414','834','00','005010X220A1','586414','','2013-12-10','08:36:40',0,'2013-12-25 19:19:40',NULL,NULL),(5084,938,'4027','834','00','005010X220A1','4027','','2013-12-10','18:35:36',0,'2013-12-26 00:48:41',NULL,NULL),(19841,3688,'3101641','834','00','005010X220A1','3101641','','2014-02-15','11:38:46',0,'2014-02-15 22:01:58',NULL,NULL),(20261,3796,'3602959','834','00','005010X220A1','3602959','','2014-02-18','21:38:45',0,'2014-02-20 04:34:08',NULL,NULL),(176,16,'655435','834','00','005010X220A1','655435','','2013-12-05','09:34:18',0,'2013-12-25 17:20:27',NULL,NULL),(18146,3343,'2157743','834','00','005010X220A1','2157743','','2014-02-06','14:15:15',0,'2014-02-06 21:01:51',NULL,NULL),(17198,3149,'2136075','834','00','005010X220A1','2136075','','2014-01-30','13:28:07',0,'2014-01-30 21:01:08',NULL,NULL),(16596,3044,'1976249','834','00','005010X220A1','1976249','','2014-01-25','14:13:17',0,'2014-01-25 19:00:20',NULL,NULL),(6117,1166,'1252055','834','00','005010X220A1','1252055','','2013-12-20','14:16:36',0,'2013-12-26 03:01:48',NULL,NULL),(13029,1873,'0001','999','BE','005010X231A1','791584','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:22',NULL,NULL),(13371,2215,'0001','999','BE','005010X231A1','102827','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:29',NULL,NULL),(19745,3673,'2483473','834','00','005010X220A1','2483473','','2014-02-14','19:20:24',0,'2014-02-15 22:00:40',NULL,NULL),(20614,3871,'2758868','834','00','005010X220A1','2758868','','2014-02-21','09:27:09',0,'2014-02-21 22:00:26',NULL,NULL),(21975,4144,'2950527','834','00','005010X220A1','2950527','','2014-03-02','10:44:04',0,'2014-03-03 01:00:10',NULL,NULL),(22725,4276,'3531265','834','00','005010X220A1','3531265','','2014-03-05','18:30:06',0,'2014-03-06 21:00:10',NULL,NULL),(22804,4278,'3268093','834','00','005010X220A1','3268093','','2014-03-05','19:56:18',0,'2014-03-06 21:01:07',NULL,NULL),(10582,1402,'289714','834','00','005010X220A1','289714','','2013-12-23','12:06:29',0,'2013-12-26 12:56:38',NULL,NULL),(11275,1455,'1446133','834','00','005010X220A1','1446133','','2013-12-26','12:38:54',0,'2013-12-27 02:02:45',NULL,NULL),(992,184,'509931','834','00','005010X220A1','509931','','2013-12-03','14:32:38',0,'2013-12-25 18:19:59',NULL,NULL),(2151,361,'67108','834','00','005010X220A1','67108','','2013-12-02','17:15:38',0,'2013-12-25 19:46:29',NULL,NULL),(1339,245,'935851','834','00','005010X220A1','935851','','2013-12-24','12:39:47',0,'2013-12-25 18:52:01',NULL,NULL),(1623,281,'715131','834','00','005010X220A1','715131','','2013-11-19','23:04:58',0,'2013-12-25 19:01:47',NULL,NULL),(20802,3909,'3604229','834','00','005010X220A1','3604229','','2014-02-25','17:04:18',0,'2014-02-25 21:30:56',NULL,NULL),(21984,4145,'2891059','834','00','005010X220A1','2891059','','2014-03-01','20:52:00',0,'2014-03-03 01:00:14',NULL,NULL),(22377,4207,'3219666','834','00','005010X220A1','3219666','','2014-03-04','16:57:01',0,'2014-03-04 21:02:00',NULL,NULL),(23754,4475,'2729244','834','00','005010X220A1','2729244','','2014-03-10','10:56:54',0,'2014-03-10 21:30:06',NULL,NULL),(18030,3318,'1678502','834','00','005010X220A1','1678502','','2014-02-06','16:30:09',0,'2014-02-06 21:00:28',NULL,NULL),(16467,3006,'1817664','834','00','005010X220A1','1817664','','2014-01-24','14:53:13',0,'2014-01-24 21:00:22',NULL,NULL),(10921,1410,'1437062','834','00','005010X220A1','1437062','','2013-12-23','09:52:55',0,'2013-12-26 13:08:20',NULL,NULL),(1530,260,'461965','834','00','005010X220A1','461965','','2013-12-24','17:00:56',0,'2013-12-25 18:58:21',NULL,NULL),(1787,300,'638751','834','00','005010X220A1','638751','','2013-12-10','16:42:04',0,'2013-12-25 19:19:11',NULL,NULL),(14134,2352,'1951714','834','00','005010X220A1','1951714','','2014-01-08','13:39:38',0,'2014-01-13 02:22:32',NULL,NULL),(12033,1583,'865794','834','00','005010X220A1','865794','','2013-12-30','14:37:27',0,'2014-01-01 12:03:21',NULL,NULL),(21961,4142,'2752512','834','00','005010X220A1','2752512','','2014-03-01','18:30:57',0,'2014-03-03 01:00:03',NULL,NULL),(22563,4248,'3051141','834','00','005010X220A1','3051141','','2014-03-05','12:44:33',0,'2014-03-05 21:30:53',NULL,NULL),(350,72,'59323','834','00','005010X220A1','59323','','2013-12-04','13:58:40',0,'2013-12-25 17:46:48',NULL,NULL),(19089,3543,'2614446','834','00','005010X220A1','2614446','','2014-02-11','19:47:10',0,'2014-02-12 21:31:31',NULL,NULL),(16356,2983,'1573417','834','00','005010X220A1','1573417','','2014-01-23','15:55:57',0,'2014-01-23 21:00:52',NULL,NULL),(15800,2722,'1547822','834','00','005010X220A1','1547822','','2014-01-20','16:38:51',0,'2014-01-21 08:46:48',NULL,NULL),(5916,1112,'1120952','834','00','005010X220A1','1120952','','2013-12-15','10:57:04',0,'2013-12-26 02:31:17',NULL,NULL),(11277,1455,'1385564','834','00','005010X220A1','1385564','','2013-12-26','12:53:12',0,'2013-12-27 02:02:48',NULL,NULL),(3597,617,'690765','834','00','005010X220A1','690765','','2013-12-12','17:17:06',0,'2013-12-25 22:04:15',NULL,NULL),(20982,3957,'3301142','834','00','005010X220A1','3301142','','2014-02-21','19:35:29',0,'2014-02-26 08:30:21',NULL,NULL),(13391,2221,'2154089','834','00','005010X220A1','2154089','','2014-01-06','09:56:29',0,'2014-01-07 04:00:34',NULL,NULL),(5174,948,'1263837','834','00','005010X220A1','1263837','','2013-12-11','00:25:38',0,'2013-12-26 00:51:32',NULL,NULL),(12525,1645,'1904665','834','00','005010X220A1','1904665','','2013-12-31','10:20:39',1,'2014-01-02 04:34:13',NULL,NULL),(18408,3416,'1528565','834','00','005010X220A1','1528565','','2014-02-09','13:33:35',0,'2014-02-09 19:00:41',NULL,NULL),(21645,4072,'3074750','834','00','005010X220A1','3074750','','2014-02-27','13:06:31',0,'2014-02-28 07:30:35',NULL,NULL),(1436,252,'1700223','834','00','005010X220A1','1700223','','2013-12-24','10:06:20',0,'2013-12-25 18:55:13',NULL,NULL),(5708,1069,'799553','834','00','005010X220A1','799553','','2013-12-13','19:13:17',0,'2013-12-26 02:00:43',NULL,NULL),(7360,1284,'144660','834','00','005010X220A1','144660','','2013-11-30','11:24:17',0,'2013-12-26 04:15:49',NULL,NULL),(2277,391,'268063','834','00','005010X220A1','268063','','2013-11-24','17:20:53',0,'2013-12-25 20:00:22',NULL,NULL),(2543,457,'845440','834','00','005010X220A1','845440','','2013-11-18','10:58:13',0,'2013-12-25 20:31:18',NULL,NULL),(3177,567,'726228','834','00','005010X220A1','726228','','2013-12-13','12:18:03',0,'2013-12-25 21:38:43',NULL,NULL),(21389,4024,'2710456','834','00','005010X220A1','2710456','','2014-02-27','16:43:49',0,'2014-02-28 06:30:30',NULL,NULL),(16941,3115,'2173068','834','00','005010X220A1','2173068','','2014-01-29','12:26:06',0,'2014-01-29 21:00:16',NULL,NULL),(6004,1136,'181752','834','00','005010X220A1','181752','','2013-11-16','19:33:01',0,'2013-12-26 02:45:04',NULL,NULL),(20380,3824,'3646648','834','00','005010X220A1','3646648','','2014-02-19','12:49:50',0,'2014-02-20 05:36:52',NULL,NULL),(20672,3881,'3489758','834','00','005010X220A1','3489758','','2014-02-20','18:27:34',0,'2014-02-21 22:01:07',NULL,NULL),(23176,4345,'3660327','834','00','005010X220A1','3660327','','2014-03-06','21:20:43',0,'2014-03-07 21:31:29',NULL,NULL),(480,97,'447089','834','00','005010X220A1','447089','','2013-12-04','11:32:09',0,'2013-12-25 17:51:01',NULL,NULL),(11675,1509,'1603855','834','00','005010X220A1','1603855','','2013-12-27','12:23:14',0,'2013-12-28 03:37:06',NULL,NULL),(587,104,'632753','834','00','005010X220A1','632753','','2013-12-15','23:54:20',0,'2013-12-25 18:03:10',NULL,NULL),(1790,301,'397221','834','00','005010X220A1','397221','','2013-12-10','10:17:14',0,'2013-12-25 19:19:18',NULL,NULL),(12095,1587,'790028','834','00','005010X220A1','790028','','2013-12-29','22:54:24',0,'2014-01-01 12:05:32',NULL,NULL),(6108,1166,'603913','834','00','005010X220A1','603913','','2013-12-20','13:00:36',0,'2013-12-26 03:01:33',NULL,NULL),(5923,1112,'13075','834','00','005010X220A1','13075','','2013-12-15','14:33:36',0,'2013-12-26 02:31:30',NULL,NULL),(13747,2276,'1956881','834','00','005010X220A1','1956881','','2014-01-06','20:25:55',0,'2014-01-08 18:24:50',NULL,NULL),(2104,359,'163475','834','00','005010X220A1','163475','','2013-12-09','18:04:53',0,'2013-12-25 19:38:12',NULL,NULL),(11609,1493,'1571378','834','00','005010X220A1','1571378','','2013-12-27','16:57:51',0,'2013-12-28 03:34:59',NULL,NULL),(20032,3750,'3367900','834','00','005010X220A1','3367900','','2014-02-18','14:24:34',0,'2014-02-18 22:00:54',NULL,NULL),(20567,3864,'2936112','834','00','005010X220A1','2936112','','2014-02-21','17:34:30',0,'2014-02-21 21:30:14',NULL,NULL),(23586,4437,'3077917','834','00','005010X220A1','3077917','','2014-03-09','20:34:26',0,'2014-03-10 21:01:07',NULL,NULL),(13283,2127,'0001','999','BE','005010X231A1','375710','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:24',NULL,NULL),(14181,2365,'2247173','834','00','005010X220A1','2247173','','2014-01-09','19:48:14',0,'2014-01-13 02:23:30',NULL,NULL),(14833,2553,'2191457','834','00','005010X220A1','2191457','','2014-01-13','20:41:37',0,'2014-01-15 02:06:59',NULL,NULL),(5636,1048,'1264670','834','00','005010X220A1','1264670','','2013-12-24','18:54:53',0,'2013-12-26 01:50:52',NULL,NULL),(15518,2648,'1646637','834','00','005010X220A1','1646637','','2014-01-16','17:14:23',0,'2014-01-17 03:36:39',NULL,NULL),(20463,3842,'2643629','834','00','005010X220A1','2643629','','2014-02-20','11:47:48',0,'2014-02-20 22:00:33',NULL,NULL),(21761,4090,'2919168','834','00','005010X220A1','2919168','','2014-02-28','12:57:06',0,'2014-02-28 21:30:54',NULL,NULL),(7322,1270,'661328','834','00','005010X220A1','661328','','2013-12-18','14:36:52',0,'2013-12-26 04:10:22',NULL,NULL),(739,129,'594938','834','00','005010X220A1','594938','','2013-12-16','16:16:09',0,'2013-12-25 18:08:00',NULL,NULL),(4439,800,'59228','834','00','005010X220A1','59228','','2013-11-25','18:21:28',0,'2013-12-25 23:30:02',NULL,NULL),(3256,579,'798265','834','00','005010X220A1','798265','','2013-12-16','18:41:36',0,'2013-12-25 21:47:00',NULL,NULL),(2417,417,'1070604','834','00','005010X220A1','1070604','','2013-12-05','19:28:04',0,'2013-12-25 20:17:48',NULL,NULL),(18813,3489,'2262619','834','00','005010X220A1','2262619','','2014-02-11','12:22:28',0,'2014-02-11 21:01:25',NULL,NULL),(18340,3393,'1611097','834','00','005010X220A1','1611097','','2014-02-08','15:56:33',0,'2014-02-08 19:01:01',NULL,NULL),(1649,285,'352226','834','00','005010X220A1','352226','','2013-11-20','12:10:45',0,'2013-12-25 19:02:27',NULL,NULL),(2519,452,'282960','834','00','005010X220A1','282960','','2013-10-13','15:29:41',0,'2013-12-25 20:30:36',NULL,NULL),(5797,1077,'1152329','834','00','005010X220A1','1152329','','2013-12-14','12:28:17',0,'2013-12-26 02:03:26',NULL,NULL),(7693,1331,'843953','834','00','005010X220A1','843953','','2013-11-14','23:42:19',0,'2013-12-26 04:45:12',NULL,NULL),(21233,3999,'3072517','834','00','005010X220A1','3072517','','2014-02-26','10:58:17',0,'2014-02-26 21:01:37',NULL,NULL),(22915,4286,'3403665','834','00','005010X220A1','3403665','','2014-03-06','16:26:24',0,'2014-03-06 21:02:27',NULL,NULL),(17737,3262,'2664007','834','00','005010X220A1','2664007','','2014-02-03','21:22:38',0,'2014-02-04 21:00:52',NULL,NULL),(3803,661,'367098','834','00','005010X220A1','367098','','2013-12-07','19:43:53',0,'2013-12-25 22:16:26',NULL,NULL),(20347,3807,'2288489','834','00','005010X220A1','2288489','','2014-02-19','11:36:05',0,'2014-02-20 04:54:09',NULL,NULL),(21383,4024,'3605496','834','00','005010X220A1','3605496','','2014-02-27','14:20:32',0,'2014-02-28 06:30:28',NULL,NULL),(22093,4176,'3045769','834','00','005010X220A1','3045769','','2014-03-03','11:06:22',0,'2014-03-03 21:30:13',NULL,NULL),(23625,4441,'2662345','834','00','005010X220A1','2662345','','2014-03-10','11:10:48',0,'2014-03-10 21:01:33',NULL,NULL),(23698,4451,'2887715','834','00','005010X220A1','2887715','','2014-03-10','10:28:10',0,'2014-03-10 21:02:26',NULL,NULL),(27,1,'894480','834','00','005010X220A1','894480','','2013-12-05','17:59:50',0,'2013-12-25 17:15:49',NULL,NULL),(3360,587,'145157','834','00','005010X220A1','145157','','2013-12-17','10:44:43',0,'2013-12-25 21:50:27',NULL,NULL),(1651,285,'37647','834','00','005010X220A1','37647','','2013-11-20','14:22:18',0,'2013-12-25 19:02:31',NULL,NULL),(10855,1406,'994844','834','00','005010X220A1','994844','','2013-12-23','12:03:30',0,'2013-12-26 13:05:40',NULL,NULL),(276,59,'32070','834','00','005010X220A1','32070','','2013-10-11','16:23:45',0,'2013-12-25 17:31:49',NULL,NULL),(13556,2249,'2048379','834','00','005010X220A1','2048379','','2014-01-06','14:17:09',0,'2014-01-07 04:06:46',NULL,NULL),(6154,1167,'692104','834','00','005010X220A1','692104','','2013-12-19','20:08:40',0,'2013-12-26 03:02:58',NULL,NULL),(6318,1175,'142784','834','00','005010X220A1','142784','','2013-12-20','14:06:34',0,'2013-12-26 03:07:56',NULL,NULL),(17444,3205,'2138461','834','00','005010X220A1','2138461','','2014-02-01','10:36:03',0,'2014-02-01 19:00:37',NULL,NULL),(3301,584,'193784','834','00','005010X220A1','193784','','2013-12-17','11:19:01',0,'2013-12-25 21:48:28',NULL,NULL),(18302,3382,'2459917','834','00','005010X220A1','2459917','','2014-02-07','21:39:41',0,'2014-02-08 19:00:36',NULL,NULL),(2163,362,'251265','834','00','005010X220A1','251265','','2013-12-02','09:59:06',0,'2013-12-25 19:46:51',NULL,NULL),(19112,3545,'2972638','834','00','005010X220A1','2972638','','2014-02-12','09:16:47',0,'2014-02-12 21:31:45',NULL,NULL),(19531,3622,'2900700','834','00','005010X220A1','2900700','','2014-02-14','16:21:15',0,'2014-02-14 21:30:48',NULL,NULL),(12581,1670,'2106432','834','00','005010X220A1','2106432','','2014-01-01','20:05:18',0,'2014-01-03 02:00:26',NULL,NULL),(11602,1493,'1804344','834','00','005010X220A1','1804344','','2013-12-27','12:55:25',0,'2013-12-28 03:34:45',NULL,NULL),(7388,1293,'1395156','834','00','005010X220A1','1395156','','2013-12-21','13:31:47',0,'2013-12-26 04:30:26',NULL,NULL),(11444,1486,'1689403','834','00','005010X220A1','1689403','','2013-12-26','17:35:49',0,'2013-12-27 02:08:03',NULL,NULL),(18465,3427,'2253667','834','00','005010X220A1','2253667','','2014-02-10','00:23:28',0,'2014-02-10 11:00:47',NULL,NULL),(18158,3350,'2606773','834','00','005010X220A1','2606773','','2014-02-06','19:19:54',0,'2014-02-07 19:00:06',NULL,NULL),(12725,1682,'2398989','834','00','005010X220A1','2398989','','2014-01-02','12:32:46',0,'2014-01-03 02:05:46',NULL,NULL),(16609,3049,'2063451','834','00','005010X220A1','2063451','','2014-01-25','18:29:55',0,'2014-01-26 19:00:09',NULL,NULL),(13546,2241,'2119109','834','00','005010X220A1','2119109','','2014-01-06','14:54:39',0,'2014-01-07 04:06:15',NULL,NULL),(14702,2550,'1618252','834','00','005010X220A1','1618252','','2014-01-13','19:54:28',0,'2014-01-15 02:06:02',NULL,NULL),(22991,4321,'3325348','834','00','005010X220A1','3325348','','2014-03-06','18:36:16',0,'2014-03-07 21:00:08',NULL,NULL),(3708,633,'424706','834','00','005010X220A1','424706','','2013-12-12','15:07:10',0,'2013-12-25 22:07:47',NULL,NULL),(19195,3571,'3134968','834','00','005010X220A1','3134968','','2014-02-13','15:21:35',0,'2014-02-13 21:30:09',NULL,NULL),(17347,3181,'2195617','834','00','005010X220A1','2195617','','2014-01-31','10:37:28',0,'2014-01-31 21:01:15',NULL,NULL),(13900,2313,'2317787','834','00','005010X220A1','2317787','','2014-01-08','20:48:44',0,'2014-01-13 02:19:45',NULL,NULL),(3267,580,'734997','834','00','005010X220A1','734997','','2013-12-17','18:22:32',0,'2013-12-25 21:47:23',NULL,NULL),(5927,1112,'624169','834','00','005010X220A1','624169','','2013-12-15','14:50:29',0,'2013-12-26 02:31:38',NULL,NULL),(20924,3934,'2940431','834','00','005010X220A1','2940431','','2014-02-23','01:50:56',0,'2014-02-26 08:00:19',NULL,NULL),(21862,4117,'2697895','834','00','005010X220A1','2697895','','2014-02-28','19:40:22',0,'2014-03-01 19:00:10',NULL,NULL),(14151,2358,'2353158','834','00','005010X220A1','2353158','','2014-01-08','13:56:03',0,'2014-01-13 02:22:43',NULL,NULL),(12076,1586,'2242299','834','00','005010X220A1','2242299','','2013-12-30','13:01:15',0,'2014-01-01 12:04:53',NULL,NULL),(2617,489,'955226','834','00','005010X220A1','955226','','2013-11-27','19:43:13',0,'2013-12-25 20:46:30',NULL,NULL),(7532,1300,'1353602','834','00','005010X220A1','1353602','','2013-12-21','14:50:29',0,'2013-12-26 04:35:03',NULL,NULL),(4011,731,'1276279','834','00','005010X220A1','1276279','','2013-12-19','07:57:14',0,'2013-12-25 23:00:27',NULL,NULL),(13819,2298,'2485154','834','00','005010X220A1','2485154','','2014-01-11','11:26:05',0,'2014-01-13 02:18:28',NULL,NULL),(7265,1249,'1064474','834','00','005010X220A1','1064474','','2013-12-17','23:44:00',0,'2013-12-26 04:08:38',NULL,NULL),(5734,1069,'588828','834','00','005010X220A1','588828','','2013-12-14','17:21:45',0,'2013-12-26 02:01:26',NULL,NULL),(7242,1243,'774616','834','00','005010X220A1','774616','','2013-12-18','12:25:51',0,'2013-12-26 04:07:58',NULL,NULL),(19714,3672,'3022107','834','00','005010X220A1','3022107','','2014-02-14','18:13:12',0,'2014-02-15 22:00:18',NULL,NULL),(21272,4001,'3117938','834','00','005010X220A1','3117938','','2014-02-26','13:20:14',0,'2014-02-26 21:02:04',NULL,NULL),(18284,3379,'2838130','834','00','005010X220A1','2838130','','2014-02-07','23:22:32',0,'2014-02-08 19:00:24',NULL,NULL),(14061,2339,'1747800','834','00','005010X220A1','1747800','','2014-01-08','11:01:34',0,'2014-01-13 02:21:43',NULL,NULL),(11407,1466,'2216248','834','00','005010X220A1','2216248','','2013-12-26','12:34:40',0,'2013-12-27 02:06:48',NULL,NULL),(4566,825,'573292','834','00','005010X220A1','573292','','2013-12-24','02:42:18',0,'2013-12-25 23:46:12',NULL,NULL),(11286,1455,'1373876','834','00','005010X220A1','1373876','','2013-12-26','14:29:12',0,'2013-12-27 02:03:04',NULL,NULL),(7313,1264,'756328','834','00','005010X220A1','756328','','2013-12-18','11:14:23',0,'2013-12-26 04:10:06',NULL,NULL),(13890,2312,'2085900','834','00','005010X220A1','2085900','','2014-01-09','13:01:20',0,'2014-01-13 02:19:39',NULL,NULL),(13625,2270,'1671307','834','00','005010X220A1','1671307','','2014-01-07','16:23:20',0,'2014-01-08 18:24:00',NULL,NULL),(19468,3620,'3117640','834','00','005010X220A1','3117640','','2014-02-13','18:19:08',0,'2014-02-14 21:30:03',NULL,NULL),(18711,3485,'2141476','834','00','005010X220A1','2141476','','2014-02-10','20:00:17',0,'2014-02-11 21:00:07',NULL,NULL),(1054,207,'560702','834','00','005010X220A1','560702','','2013-11-29','14:00:24',0,'2013-12-25 18:30:24',NULL,NULL),(1728,293,'698529','834','00','005010X220A1','698529','','2013-12-10','10:21:52',0,'2013-12-25 19:17:20',NULL,NULL),(11500,1489,'1984097','834','00','005010X220A1','1984097','','2013-12-27','10:33:47',0,'2013-12-28 03:31:38',NULL,NULL),(2875,519,'1466550','834','00','005010X220A1','1466550','','2013-12-22','09:11:08',0,'2013-12-25 21:22:49',NULL,NULL),(17076,3132,'2057907','834','00','005010X220A1','2057907','','2014-01-29','11:47:40',0,'2014-01-29 21:01:43',NULL,NULL),(13637,2270,'2289897','834','00','005010X220A1','2289897','','2014-01-07','13:56:14',0,'2014-01-08 18:24:05',NULL,NULL),(5742,1070,'547698','834','00','005010X220A1','547698','','2013-12-14','10:55:03',0,'2013-12-26 02:01:41',NULL,NULL),(7557,1301,'1358770','834','00','005010X220A1','1358770','','2013-12-21','10:16:39',0,'2013-12-26 04:35:51',NULL,NULL),(7157,1238,'672257','834','00','005010X220A1','672257','','2013-12-17','21:24:29',0,'2013-12-26 04:05:18',NULL,NULL),(19576,3629,'3035340','834','00','005010X220A1','3035340','','2014-02-13','18:53:55',0,'2014-02-14 21:31:20',NULL,NULL),(19628,3641,'3369324','834','00','005010X220A1','3369324','','2014-02-14','16:35:19',0,'2014-02-14 21:31:58',NULL,NULL),(11742,1521,'2331046','834','00','005010X220A1','2331046','','2013-12-28','14:15:31',1,'2013-12-29 11:09:12',NULL,NULL),(590,105,'170896','834','00','005010X220A1','170896','','2013-12-16','11:45:10',0,'2013-12-25 18:03:16',NULL,NULL),(905,177,'985130','834','00','005010X220A1','985130','','2013-12-03','14:11:32',0,'2013-12-25 18:17:16',NULL,NULL),(18247,3373,'2128748','834','00','005010X220A1','2128748','','2014-02-07','17:45:54',0,'2014-02-07 19:01:10',NULL,NULL),(1560,273,'920243','834','00','005010X220A1','920243','','2013-12-24','16:10:39',0,'2013-12-25 18:59:20',NULL,NULL),(15122,2587,'2164938','834','00','005010X220A1','2164938','','2014-01-15','09:41:10',0,'2014-01-16 08:45:34',NULL,NULL),(23052,4338,'2866265','834','00','005010X220A1','2866265','','2014-03-07','16:24:05',0,'2014-03-07 21:00:36',NULL,NULL),(23647,4441,'3423131','834','00','005010X220A1','3423131','','2014-03-10','16:18:52',0,'2014-03-10 21:01:49',NULL,NULL),(570,103,'392500','834','00','005010X220A1','392500','','2013-12-16','14:59:50',0,'2013-12-25 18:02:40',NULL,NULL),(13932,2317,'1620882','834','00','005010X220A1','1620882','','2014-01-09','16:07:59',0,'2014-01-13 02:20:07',NULL,NULL),(1386,245,'1291964','834','00','005010X220A1','1291964','','2013-12-24','17:09:02',0,'2013-12-25 18:53:34',NULL,NULL),(16388,2989,'1548973','834','00','005010X220A1','1548973','','2014-01-23','00:24:50',0,'2014-01-23 21:01:15',NULL,NULL),(2320,407,'727058','834','00','005010X220A1','727058','','2013-10-21','19:43:21',0,'2013-12-25 20:01:54',NULL,NULL),(13658,2271,'2030098','834','00','005010X220A1','2030098','','2014-01-07','16:18:33',0,'2014-01-08 18:24:13',NULL,NULL),(2722,503,'201607','834','00','005010X220A1','201607','','2013-12-22','00:41:00',0,'2013-12-25 21:17:53',NULL,NULL),(7191,1239,'182405','834','00','005010X220A1','182405','','2013-12-18','12:26:34',0,'2013-12-26 04:06:22',NULL,NULL),(4234,738,'949643','834','00','005010X220A1','949643','','2013-12-19','15:07:58',0,'2013-12-25 23:07:16',NULL,NULL),(12824,1704,'2067835','834','00','005010X220A1','2067835','','2014-01-03','06:58:10',0,'2014-01-04 02:02:08',NULL,NULL),(10995,1413,'1047361','834','00','005010X220A1','1047361','','2013-12-23','14:58:57',0,'2013-12-26 13:10:34',NULL,NULL),(5123,943,'651516','834','00','005010X220A1','651516','','2013-12-10','18:48:08',0,'2013-12-26 00:49:59',NULL,NULL),(21132,3995,'2530673','834','00','005010X220A1','2530673','','2014-02-26','08:17:46',0,'2014-02-26 21:00:32',NULL,NULL),(18231,3360,'2968702','834','00','005010X220A1','2968702','','2014-02-06','23:37:01',0,'2014-02-07 19:00:57',NULL,NULL),(504,102,'719714','834','00','005010X220A1','719714','','2013-12-16','10:26:03',0,'2013-12-25 18:00:35',NULL,NULL),(16908,3105,'1712208','834','00','005010X220A1','1712208','','2014-01-28','16:50:15',0,'2014-01-28 21:01:18',NULL,NULL),(12157,1592,'1366314','834','00','005010X220A1','1366314','','2013-12-29','22:39:04',0,'2014-01-01 12:07:41',NULL,NULL),(7449,1296,'1371040','834','00','005010X220A1','1371040','','2013-12-20','21:26:28',0,'2013-12-26 04:32:23',NULL,NULL),(11646,1499,'1876363','834','00','005010X220A1','1876363','','2013-12-27','10:37:41',0,'2013-12-28 03:36:07',NULL,NULL),(6430,1203,'362744','834','00','005010X220A1','362744','','2013-11-22','11:04:49',0,'2013-12-26 03:15:27',NULL,NULL),(21014,3964,'3016854','834','00','005010X220A1','3016854','','2014-02-21','21:54:34',0,'2014-02-26 08:30:50',NULL,NULL),(22117,4177,'3030984','834','00','005010X220A1','3030984','','2014-03-03','13:12:01',0,'2014-03-03 21:30:33',NULL,NULL),(18651,3464,'2897637','834','00','005010X220A1','2897637','','2014-02-10','11:00:23',0,'2014-02-10 21:31:40',NULL,NULL),(1277,243,'1939344','834','00','005010X220A1','1939344','','2013-12-24','16:13:05',0,'2013-12-25 18:50:04',NULL,NULL),(2823,508,'348017','834','00','005010X220A1','348017','','2013-12-22','07:56:12',0,'2013-12-25 21:21:04',NULL,NULL),(12596,1671,'1970401','834','00','005010X220A1','1970401','','2014-01-02','12:41:16',0,'2014-01-03 02:00:57',NULL,NULL),(17934,3296,'1490818','834','00','005010X220A1','1490818','','2014-02-05','18:21:11',0,'2014-02-05 21:30:46',NULL,NULL),(15527,2654,'2254672','834','00','005010X220A1','2254672','','2014-01-16','18:45:05',0,'2014-01-20 08:05:33',NULL,NULL),(15295,2617,'2537405','834','00','005010X220A1','2537405','','2014-01-15','14:57:15',0,'2014-01-16 08:47:27',NULL,NULL),(3986,723,'1069468','834','00','005010X220A1','1069468','','2013-12-07','16:37:13',0,'2013-12-25 22:47:46',NULL,NULL),(20314,3794,'3179072','834','00','005010X220A1','3179072','','2014-02-19','15:26:36',0,'2014-02-20 04:46:26',NULL,NULL),(23584,4437,'3867459','834','00','005010X220A1','3867459','','2014-03-09','18:42:50',0,'2014-03-10 21:01:06',NULL,NULL),(23674,4445,'3197546','834','00','005010X220A1','3197546','','2014-03-10','12:05:22',0,'2014-03-10 21:02:08',NULL,NULL),(15399,2626,'1815113','834','00','005010X220A1','1815113','','2014-01-15','21:34:41',0,'2014-01-17 03:35:47',NULL,NULL),(5375,1010,'561913','834','00','005010X220A1','561913','','2013-11-24','19:35:32',0,'2013-12-26 01:16:42',NULL,NULL),(2672,501,'1367021','834','00','005010X220A1','1367021','','2013-12-22','17:37:12',0,'2013-12-25 21:16:16',NULL,NULL),(4688,833,'1395387','834','00','005010X220A1','1395387','','2013-12-24','00:35:30',0,'2013-12-25 23:50:14',NULL,NULL),(3746,644,'954386','834','00','005010X220A1','954386','','2013-12-12','16:32:13',0,'2013-12-25 22:09:04',NULL,NULL),(21015,3965,'3182723','834','00','005010X220A1','3182723','','2014-02-21','22:15:43',0,'2014-02-26 08:30:51',NULL,NULL),(22758,4276,'3063254','834','00','005010X220A1','3063254','','2014-03-06','16:19:21',0,'2014-03-06 21:00:35',NULL,NULL),(19023,3539,'1672213','834','00','005010X220A1','1672213','','2014-02-12','10:59:51',0,'2014-02-12 21:30:42',NULL,NULL),(1901,325,'226859','834','00','005010X220A1','226859','','2013-12-09','12:33:54',0,'2013-12-25 19:31:47',NULL,NULL),(13750,2276,'1485220','834','00','005010X220A1','1485220','','2014-01-07','17:08:31',0,'2014-01-08 18:24:52',NULL,NULL),(18967,3536,'2679562','834','00','005010X220A1','2679562','','2014-02-12','12:27:52',0,'2014-02-12 21:00:17',NULL,NULL),(2836,511,'135669','834','00','005010X220A1','135669','','2013-12-21','23:55:06',0,'2013-12-25 21:21:32',NULL,NULL),(12860,1706,'1634230','834','00','005010X220A1','1634230','','2014-01-03','09:49:29',0,'2014-01-04 02:03:25',NULL,NULL),(5358,1007,'870774','834','00','005010X220A1','870774','','2013-11-24','23:34:08',0,'2013-12-26 01:16:06',NULL,NULL),(12845,1705,'2164642','834','00','005010X220A1','2164642','','2014-01-02','23:24:17',0,'2014-01-04 02:02:52',NULL,NULL),(7051,1235,'1033889','834','00','005010X220A1','1033889','','2013-12-18','17:34:18',0,'2013-12-26 04:02:04',NULL,NULL),(15712,2705,'1932714','834','00','005010X220A1','1932714','','2014-01-19','14:27:26',0,'2014-01-21 08:45:37',NULL,NULL),(7158,1238,'555187','834','00','005010X220A1','555187','','2013-12-17','21:28:55',0,'2013-12-26 04:05:21',NULL,NULL),(7264,1248,'185111','834','00','005010X220A1','185111','','2013-12-18','16:46:55',0,'2013-12-26 04:08:35',NULL,NULL),(10564,1402,'62596','834','00','005010X220A1','62596','','2013-12-23','01:05:14',0,'2013-12-26 12:56:00',NULL,NULL),(20760,3905,'2708850','834','00','005010X220A1','2708850','','2014-02-24','18:34:16',0,'2014-02-25 21:30:27',NULL,NULL),(22724,4276,'3446556','834','00','005010X220A1','3446556','','2014-03-05','18:04:31',0,'2014-03-06 21:00:09',NULL,NULL),(17892,3295,'2390414','834','00','005010X220A1','2390414','','2014-02-04','19:15:29',0,'2014-02-05 21:30:27',NULL,NULL),(4413,783,'857509','834','00','005010X220A1','857509','','2013-11-27','13:02:54',0,'2013-12-25 23:16:22',NULL,NULL),(12208,1615,'1569086','834','00','005010X220A1','1569086','','2013-12-31','19:29:41',1,'2014-01-02 04:21:47',NULL,NULL),(5821,1087,'136134','834','00','005010X220A1','136134','','2013-11-22','20:32:05',0,'2013-12-26 02:15:06',NULL,NULL),(10393,1400,'1455555','834','00','005010X220A1','1455555','','2013-12-23','05:43:07',0,'2013-12-26 12:50:30',NULL,NULL),(1919,325,'697205','834','00','005010X220A1','697205','','2013-12-09','17:31:03',0,'2013-12-25 19:32:18',NULL,NULL),(12900,1713,'2014453','834','00','005010X220A1','2014453','','2014-01-02','23:06:05',0,'2014-01-04 02:04:54',NULL,NULL),(11801,1538,'703769','834','00','005010X220A1','703769','','2013-12-28','20:26:54',1,'2013-12-29 11:13:08',NULL,NULL),(3667,627,'999333','834','00','005010X220A1','999333','','2013-12-11','22:51:07',0,'2013-12-25 22:06:26',NULL,NULL),(16869,3093,'1983647','834','00','005010X220A1','1983647','','2014-01-28','13:52:04',0,'2014-01-28 21:00:53',NULL,NULL),(5544,1041,'1764038','834','00','005010X220A1','1764038','','2013-12-25','00:45:23',0,'2013-12-26 01:47:51',NULL,NULL),(21418,4026,'2654417','834','00','005010X220A1','2654417','','2014-02-27','12:28:06',0,'2014-02-28 06:30:43',NULL,NULL),(21633,4068,'3250794','834','00','005010X220A1','3250794','','2014-02-27','11:06:54',0,'2014-02-28 07:30:27',NULL,NULL),(2812,506,'491274','834','00','005010X220A1','491274','','2013-12-22','16:35:06',0,'2013-12-25 21:20:41',NULL,NULL),(13402,2222,'1491448','834','00','005010X220A1','1491448','','2014-01-06','12:40:23',0,'2014-01-07 04:00:59',NULL,NULL),(19647,3647,'2992646','834','00','005010X220A1','2992646','','2014-02-14','11:43:33',0,'2014-02-14 21:32:11',NULL,NULL),(4990,935,'919448','834','00','005010X220A1','919448','','2013-12-11','06:42:23',0,'2013-12-26 00:45:40',NULL,NULL),(14629,2524,'2456584','834','00','005010X220A1','2456584','','2014-01-13','16:25:14',0,'2014-01-14 01:33:25',NULL,NULL),(14672,2547,'2540244','834','00','005010X220A1','2540244','','2014-01-13','18:11:15',0,'2014-01-14 01:33:54',NULL,NULL),(16021,2767,'1407341','834','00','005010X220A1','1407341','','2014-01-22','15:52:13',0,'2014-01-23 03:02:22',NULL,NULL),(4223,738,'355699','834','00','005010X220A1','355699','','2013-12-19','08:45:04',0,'2013-12-25 23:06:55',NULL,NULL),(17585,3237,'2608078','834','00','005010X220A1','2608078','','2014-02-03','14:16:52',0,'2014-02-03 21:00:48',NULL,NULL),(21499,4030,'3359682','834','00','005010X220A1','3359682','','2014-02-27','11:08:26',0,'2014-02-28 06:31:21',NULL,NULL),(22799,4278,'2869927','834','00','005010X220A1','2869927','','2014-03-05','18:22:04',0,'2014-03-06 21:01:04',NULL,NULL),(5604,1044,'833679','834','00','005010X220A1','833679','','2013-12-24','19:52:12',0,'2013-12-26 01:49:46',NULL,NULL),(13131,1975,'0001','999','BE','005010X231A1','347193','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:05',NULL,NULL),(13555,2248,'1903651','834','00','005010X220A1','1903651','','2014-01-06','11:44:39',0,'2014-01-07 04:06:43',NULL,NULL),(17863,3293,'1644576','834','00','005010X220A1','1644576','','2014-02-05','12:31:29',0,'2014-02-05 21:30:12',NULL,NULL),(10743,1403,'1506688','834','00','005010X220A1','1506688','','2013-12-23','16:09:34',0,'2013-12-26 13:01:58',NULL,NULL),(5144,943,'805744','834','00','005010X220A1','805744','','2013-12-11','13:29:31',0,'2013-12-26 00:50:37',NULL,NULL),(23270,4379,'3469318','834','00','005010X220A1','3469318','','2014-03-08','13:35:48',0,'2014-03-08 21:00:08',NULL,NULL),(14150,2358,'2044355','834','00','005010X220A1','2044355','','2014-01-08','13:21:22',0,'2014-01-13 02:22:42',NULL,NULL),(19618,3638,'3125117','834','00','005010X220A1','3125117','','2014-02-13','21:28:35',0,'2014-02-14 21:31:51',NULL,NULL),(20205,3782,'3035462','834','00','005010X220A1','3035462','','2014-02-19','10:43:49',0,'2014-02-20 04:19:07',NULL,NULL),(12672,1673,'1938221','834','00','005010X220A1','1938221','','2014-01-02','16:50:39',0,'2014-01-03 02:03:45',NULL,NULL),(950,181,'857571','834','00','005010X220A1','857571','','2013-12-03','06:57:44',0,'2013-12-25 18:18:39',NULL,NULL),(17786,3268,'2424742','834','00','005010X220A1','2424742','','2014-02-04','14:04:44',0,'2014-02-04 21:01:23',NULL,NULL),(17748,3262,'2119802','834','00','005010X220A1','2119802','','2014-02-04','11:38:38',0,'2014-02-04 21:00:59',NULL,NULL),(13015,1744,'2207371','834','00','005010X220A1','2207371','','2014-01-04','10:28:46',0,'2014-01-05 00:02:46',NULL,NULL),(1154,239,'1568805','834','00','005010X220A1','1568805','','2013-12-24','10:52:30',0,'2013-12-25 18:46:19',NULL,NULL),(1305,245,'1429757','834','00','005010X220A1','1429757','','2013-12-24','05:44:41',0,'2013-12-25 18:50:58',NULL,NULL),(1603,281,'967862','834','00','005010X220A1','967862','','2013-11-19','22:59:51',0,'2013-12-25 19:01:17',NULL,NULL),(16397,2993,'2225563','834','00','005010X220A1','2225563','','2014-01-23','14:38:27',0,'2014-01-23 21:01:21',NULL,NULL),(14996,2584,'1646514','834','00','005010X220A1','1646514','','2014-01-14','19:38:15',0,'2014-01-16 08:44:15',NULL,NULL),(15074,2585,'1455186','834','00','005010X220A1','1455186','','2014-01-15','14:04:17',0,'2014-01-16 08:45:04',NULL,NULL),(16028,2769,'1976179','834','00','005010X220A1','1976179','','2014-01-21','20:06:27',0,'2014-01-23 03:02:25',NULL,NULL),(18432,3420,'1685328','834','00','005010X220A1','1685328','','2014-02-10','04:27:11',0,'2014-02-10 11:00:18',NULL,NULL),(18508,3446,'2232634','834','00','005010X220A1','2232634','','2014-02-10','12:14:01',0,'2014-02-10 21:00:08',NULL,NULL),(4453,801,'478883','834','00','005010X220A1','478883','','2013-11-25','23:13:07',0,'2013-12-25 23:30:31',NULL,NULL),(7151,1237,'811120','834','00','005010X220A1','811120','','2013-12-18','16:42:20',0,'2013-12-26 04:05:05',NULL,NULL),(3541,616,'908468','834','00','005010X220A1','908468','','2013-12-12','10:56:37',0,'2013-12-25 22:02:30',NULL,NULL),(23036,4330,'3763328','834','00','005010X220A1','3763328','','2014-03-07','11:10:14',0,'2014-03-07 21:00:28',NULL,NULL),(426,77,'5245','834','00','005010X220A1','5245','','2013-12-04','11:20:47',0,'2013-12-25 17:49:12',NULL,NULL),(13190,2034,'0001','999','BE','005010X231A1','171735','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:24',NULL,NULL),(17499,3222,'1832303','834','00','005010X220A1','1832303','','2014-02-02','12:27:28',0,'2014-02-02 19:00:24',NULL,NULL),(7554,1301,'117326','834','00','005010X220A1','117326','','2013-12-21','08:24:02',0,'2013-12-26 04:35:45',NULL,NULL),(17371,3185,'1497731','834','00','005010X220A1','1497731','','2014-01-31','11:08:46',0,'2014-01-31 21:01:32',NULL,NULL),(16349,2983,'2179633','834','00','005010X220A1','2179633','','2014-01-23','15:09:36',0,'2014-01-23 21:00:48',NULL,NULL),(5506,1041,'1633976','834','00','005010X220A1','1633976','','2013-12-24','20:10:11',0,'2013-12-26 01:46:38',NULL,NULL),(19978,3746,'3083416','834','00','005010X220A1','3083416','','2014-02-18','14:28:00',0,'2014-02-18 22:00:18',NULL,NULL),(5005,935,'614257','834','00','005010X220A1','614257','','2013-12-11','10:32:30',0,'2013-12-26 00:46:07',NULL,NULL),(20487,3844,'3052984','834','00','005010X220A1','3052984','','2014-02-20','14:58:14',0,'2014-02-20 22:00:54',NULL,NULL),(22382,4208,'3399431','834','00','005010X220A1','3399431','','2014-03-04','12:23:54',0,'2014-03-04 21:02:04',NULL,NULL),(12410,1637,'2452476','834','00','005010X220A1','2452476','','2013-12-31','17:40:20',1,'2014-01-02 04:30:01',NULL,NULL),(17482,3220,'2378023','834','00','005010X220A1','2378023','','2014-02-01','19:26:19',0,'2014-02-02 19:00:14',NULL,NULL),(13011,1742,'1624604','834','00','005010X220A1','1624604','','2014-01-04','14:13:43',0,'2014-01-05 00:02:34',NULL,NULL),(15636,2676,'2344163','834','00','005010X220A1','2344163','','2014-01-18','12:36:32',0,'2014-01-21 08:44:16',NULL,NULL),(15914,2743,'2607804','834','00','005010X220A1','2607804','','2014-01-21','14:04:01',1,'2014-01-22 03:22:50',NULL,NULL),(11910,1565,'2098992','834','00','005010X220A1','2098992','','2013-12-28','18:58:25',0,'2013-12-30 00:01:21',NULL,NULL),(175,16,'479009','834','00','005010X220A1','479009','','2013-12-05','09:04:16',0,'2013-12-25 17:20:26',NULL,NULL),(2683,502,'640320','834','00','005010X220A1','640320','','2013-12-22','03:13:07',0,'2013-12-25 21:16:40',NULL,NULL),(2849,512,'680418','834','00','005010X220A1','680418','','2013-12-21','22:24:43',0,'2013-12-25 21:21:59',NULL,NULL),(19539,3624,'3019367','834','00','005010X220A1','3019367','','2014-02-13','23:02:30',0,'2014-02-14 21:30:53',NULL,NULL),(18382,3407,'2840606','834','00','005010X220A1','2840606','','2014-02-09','14:02:15',0,'2014-02-09 19:00:23',NULL,NULL),(928,180,'569577','834','00','005010X220A1','569577','','2013-12-03','15:40:04',0,'2013-12-25 18:17:57',NULL,NULL),(17723,3261,'2325634','834','00','005010X220A1','2325634','','2014-02-04','15:27:00',0,'2014-02-04 21:00:43',NULL,NULL),(16765,3071,'2337257','834','00','005010X220A1','2337257','','2014-01-27','10:51:04',0,'2014-01-27 21:01:29',NULL,NULL),(15885,2740,'2232173','834','00','005010X220A1','2232173','','2014-01-21','11:32:00',1,'2014-01-22 03:22:31',NULL,NULL),(12805,1703,'1776950','834','00','005010X220A1','1776950','','2014-01-03','14:25:45',0,'2014-01-04 02:01:25',NULL,NULL),(14945,2561,'1561681','834','00','005010X220A1','1561681','','2014-01-14','17:19:41',0,'2014-01-15 02:07:50',NULL,NULL),(21657,4076,'3087835','834','00','005010X220A1','3087835','','2014-02-28','17:55:05',0,'2014-02-28 21:00:05',NULL,NULL),(22113,4177,'3457706','834','00','005010X220A1','3457706','','2014-03-03','12:59:16',0,'2014-03-03 21:30:30',NULL,NULL),(14608,2522,'2192628','834','00','005010X220A1','2192628','','2014-01-12','22:32:33',0,'2014-01-14 01:33:11',NULL,NULL),(15608,2665,'1735639','834','00','005010X220A1','1735639','','2014-01-17','11:42:05',0,'2014-01-20 08:06:31',NULL,NULL),(7131,1236,'1198040','834','00','005010X220A1','1198040','','2013-12-18','17:08:07',0,'2013-12-26 04:04:31',NULL,NULL),(17972,3303,'2239397','834','00','005010X220A1','2239397','','2014-02-04','20:27:42',0,'2014-02-05 21:31:07',NULL,NULL),(1906,325,'720953','834','00','005010X220A1','720953','','2013-12-09','13:39:02',0,'2013-12-25 19:31:57',NULL,NULL),(12072,1586,'2107877','834','00','005010X220A1','2107877','','2013-12-30','10:00:46',0,'2014-01-01 12:04:45',NULL,NULL),(16006,2767,'2116074','834','00','005010X220A1','2116074','','2014-01-21','20:22:56',0,'2014-01-23 03:02:16',NULL,NULL),(388,76,'436118','834','00','005010X220A1','436118','','2013-12-03','20:05:15',0,'2013-12-25 17:47:58',NULL,NULL),(14587,2521,'1944804','834','00','005010X220A1','1944804','','2014-01-13','11:16:46',0,'2014-01-14 01:32:58',NULL,NULL),(883,177,'514959','834','00','005010X220A1','514959','','2013-12-03','09:20:58',0,'2013-12-25 18:16:39',NULL,NULL),(974,184,'496220','834','00','005010X220A1','496220','','2013-12-02','22:55:15',0,'2013-12-25 18:19:24',NULL,NULL),(4715,838,'215868','834','00','005010X220A1','215868','','2013-12-24','02:44:11',0,'2013-12-25 23:51:09',NULL,NULL),(3906,711,'412983','834','00','005010X220A1','412983','','2013-12-07','14:13:01',0,'2013-12-25 22:45:12',NULL,NULL),(12671,1673,'1488717','834','00','005010X220A1','1488717','','2014-01-02','16:36:30',0,'2014-01-03 02:03:43',NULL,NULL),(3152,559,'787834','834','00','005010X220A1','787834','','2013-12-13','09:03:30',0,'2013-12-25 21:37:49',NULL,NULL),(3044,544,'726223','834','00','005010X220A1','726223','','2013-12-13','11:56:30',0,'2013-12-25 21:34:25',NULL,NULL),(12090,1586,'1377983','834','00','005010X220A1','1377983','','2013-12-30','17:49:13',0,'2014-01-01 12:05:23',NULL,NULL),(14493,2514,'0001','999','BE','005010X231A1','79599','834','2013-12-28','11:05:00',0,'2014-01-13 03:04:03',NULL,NULL),(20708,3893,'2673657','834','00','005010X220A1','2673657','','2014-02-25','13:51:53',0,'2014-02-25 21:00:17',NULL,NULL),(21982,4145,'2841233','834','00','005010X220A1','2841233','','2014-03-01','19:35:15',0,'2014-03-03 01:00:13',NULL,NULL),(22882,4282,'2635797','834','00','005010X220A1','2635797','','2014-03-05','19:34:25',0,'2014-03-06 21:02:03',NULL,NULL),(18542,3452,'3113761','834','00','005010X220A1','3113761','','2014-02-10','09:57:36',0,'2014-02-10 21:30:23',NULL,NULL),(16189,2881,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:22:00',0,'2014-01-23 04:30:03',NULL,NULL),(4590,826,'1801802','834','00','005010X220A1','1801802','','2013-12-23','23:09:16',0,'2013-12-25 23:46:57',NULL,NULL),(4476,802,'900773','834','00','005010X220A1','900773','','2013-11-26','14:47:46',0,'2013-12-25 23:31:16',NULL,NULL),(23069,4339,'3644538','834','00','005010X220A1','3644538','','2014-03-07','08:58:43',0,'2014-03-07 21:30:13',NULL,NULL),(23171,4345,'3151791','834','00','005010X220A1','3151791','','2014-03-06','19:47:31',0,'2014-03-07 21:31:26',NULL,NULL),(17299,3172,'2179846','834','00','005010X220A1','2179846','','2014-01-31','16:17:12',0,'2014-01-31 21:00:40',NULL,NULL),(11297,1455,'1770220','834','00','005010X220A1','1770220','','2013-12-26','17:48:31',0,'2013-12-27 02:03:25',NULL,NULL),(285,62,'1212394','834','00','005010X220A1','1212394','','2013-11-08','22:08:35',0,'2013-12-25 17:32:10',NULL,NULL),(17252,3170,'1685535','834','00','005010X220A1','1685535','','2014-01-30','19:57:11',0,'2014-01-31 21:00:08',NULL,NULL),(10586,1402,'22523','834','00','005010X220A1','22523','','2013-12-23','12:14:11',0,'2013-12-26 12:56:43',NULL,NULL),(16489,3010,'2553143','834','00','005010X220A1','2553143','','2014-01-24','10:57:16',0,'2014-01-24 21:00:34',NULL,NULL),(16180,2872,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',1,'2014-01-23 04:21:17',NULL,NULL),(2285,395,'1150668','834','00','005010X220A1','1150668','','2013-11-23','19:02:24',0,'2013-12-25 20:00:40',NULL,NULL),(4304,749,'577917','834','00','005010X220A1','577917','','2013-12-19','08:48:12',0,'2013-12-25 23:09:25',NULL,NULL),(14881,2558,'2235710','834','00','005010X220A1','2235710','','2014-01-13','20:00:32',0,'2014-01-15 02:07:21',NULL,NULL),(4058,731,'498124','834','00','005010X220A1','498124','','2013-12-18','18:39:05',0,'2013-12-25 23:01:56',NULL,NULL),(13051,1895,'0001','999','BE','005010X231A1','139453','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:23',NULL,NULL),(19544,3626,'3206468','834','00','005010X220A1','3206468','','2014-02-13','18:41:22',0,'2014-02-14 21:30:57',NULL,NULL),(20455,3842,'2611040','834','00','005010X220A1','2611040','','2014-02-20','00:04:55',0,'2014-02-20 22:00:27',NULL,NULL),(14548,2518,'1987111','834','00','005010X220A1','1987111','','2014-01-13','17:35:36',0,'2014-01-14 01:32:33',NULL,NULL),(5957,1117,'150505','834','00','005010X220A1','150505','','2013-12-14','20:44:23',0,'2013-12-26 02:32:33',NULL,NULL),(7116,1236,'571505','834','00','005010X220A1','571505','','2013-12-18','15:16:50',0,'2013-12-26 04:04:04',NULL,NULL),(3514,615,'506256','834','00','005010X220A1','506256','','2013-12-12','16:37:55',0,'2013-12-25 22:01:39',NULL,NULL),(3364,587,'1229875','834','00','005010X220A1','1229875','','2013-12-17','11:16:39',0,'2013-12-25 21:50:32',NULL,NULL),(22215,4188,'3537522','834','00','005010X220A1','3537522','','2014-03-03','04:02:37',0,'2014-03-03 21:31:43',NULL,NULL),(23631,4441,'3319811','834','00','005010X220A1','3319811','','2014-03-10','12:28:18',0,'2014-03-10 21:01:37',NULL,NULL),(23644,4441,'2839018','834','00','005010X220A1','2839018','','2014-03-10','15:10:35',0,'2014-03-10 21:01:46',NULL,NULL),(10993,1413,'90463','834','00','005010X220A1','90463','','2013-12-23','12:49:46',0,'2013-12-26 13:10:30',NULL,NULL),(1925,326,'989995','834','00','005010X220A1','989995','','2013-12-09','07:16:13',0,'2013-12-25 19:32:29',NULL,NULL),(7676,1320,'509393','834','00','005010X220A1','509393','','2013-12-21','14:47:58',0,'2013-12-26 04:39:42',NULL,NULL),(4531,824,'1381689','834','00','005010X220A1','1381689','','2013-12-23','21:01:21',0,'2013-12-25 23:45:02',NULL,NULL),(14217,2366,'2398023','834','00','005010X220A1','2398023','','2014-01-10','11:30:04',0,'2014-01-13 02:23:55',NULL,NULL),(12101,1587,'1597407','834','00','005010X220A1','1597407','','2013-12-30','08:49:27',0,'2014-01-01 12:05:43',NULL,NULL),(19223,3580,'2706226','834','00','005010X220A1','2706226','','2014-02-13','01:12:12',0,'2014-02-13 22:00:12',NULL,NULL),(20358,3818,'3090381','834','00','005010X220A1','3090381','','2014-02-19','16:47:54',0,'2014-02-20 04:56:24',NULL,NULL),(20503,3846,'2615680','834','00','005010X220A1','2615680','','2014-02-20','17:13:52',0,'2014-02-20 22:01:06',NULL,NULL),(16832,3091,'2445728','834','00','005010X220A1','2445728','','2014-01-28','12:44:54',0,'2014-01-28 21:00:27',NULL,NULL),(11498,1489,'1408146','834','00','005010X220A1','1408146','','2013-12-27','10:15:29',0,'2013-12-28 03:31:34',NULL,NULL),(11222,1454,'823078','834','00','005010X220A1','823078','','2013-12-26','10:30:45',0,'2013-12-27 02:01:07',NULL,NULL),(1878,325,'735905','834','00','005010X220A1','735905','','2013-12-08','19:09:52',0,'2013-12-25 19:31:09',NULL,NULL),(16533,3019,'2448061','834','00','005010X220A1','2448061','','2014-01-24','12:19:25',0,'2014-01-24 21:01:02',NULL,NULL),(6106,1166,'1120024','834','00','005010X220A1','1120024','','2013-12-20','10:01:54',0,'2013-12-26 03:01:31',NULL,NULL),(5713,1069,'586580','834','00','005010X220A1','586580','','2013-12-13','23:58:07',0,'2013-12-26 02:00:52',NULL,NULL),(3376,587,'885352','834','00','005010X220A1','885352','','2013-12-17','15:21:11',0,'2013-12-25 21:50:57',NULL,NULL),(4887,895,'983910','834','00','005010X220A1','983910','','2013-11-21','14:21:41',0,'2013-12-26 00:16:52',NULL,NULL),(6457,1214,'905854','834','00','005010X220A1','905854','','2013-11-22','09:09:51',0,'2013-12-26 03:16:22',NULL,NULL),(22201,4185,'2757921','834','00','005010X220A1','2757921','','2014-03-03','11:45:37',0,'2014-03-03 21:31:32',NULL,NULL),(10660,1402,'1385401','834','00','005010X220A1','1385401','','2013-12-23','18:58:26',0,'2013-12-26 12:59:07',NULL,NULL),(1419,249,'1889656','834','00','005010X220A1','1889656','','2013-12-24','07:15:12',0,'2013-12-25 18:54:41',NULL,NULL),(7249,1246,'234385','834','00','005010X220A1','234385','','2013-12-17','20:50:06',0,'2013-12-26 04:08:11',NULL,NULL),(1793,302,'1201533','834','00','005010X220A1','1201533','','2013-12-09','21:26:52',0,'2013-12-25 19:19:23',NULL,NULL),(18434,3420,'1843794','834','00','005010X220A1','1843794','','2014-02-10','04:32:45',0,'2014-02-10 11:00:20',NULL,NULL),(15925,2746,'1433213','834','00','005010X220A1','1433213','','2014-01-21','11:05:43',1,'2014-01-22 03:22:56',NULL,NULL),(4081,733,'1110871','834','00','005010X220A1','1110871','','2013-12-19','09:09:16',0,'2013-12-25 23:02:42',NULL,NULL),(4157,734,'149463','834','00','005010X220A1','149463','','2013-12-18','20:46:44',0,'2013-12-25 23:04:55',NULL,NULL),(15724,2711,'1456405','834','00','005010X220A1','1456405','','2014-01-20','11:58:32',0,'2014-01-21 08:46:02',NULL,NULL),(5541,1041,'54040','834','00','005010X220A1','54040','','2013-12-25','00:07:23',0,'2013-12-26 01:47:46',NULL,NULL),(19202,3574,'2913776','834','00','005010X220A1','2913776','','2014-02-13','09:41:40',0,'2014-02-13 21:30:12',NULL,NULL),(20725,3898,'3164173','834','00','005010X220A1','3164173','','2014-02-25','16:09:39',0,'2014-02-25 21:00:29',NULL,NULL),(22682,4255,'3502920','834','00','005010X220A1','3502920','','2014-03-05','17:08:18',0,'2014-03-05 21:32:15',NULL,NULL),(13680,2272,'1848196','834','00','005010X220A1','1848196','','2014-01-07','11:39:19',0,'2014-01-08 18:24:21',NULL,NULL),(10527,1401,'268962','834','00','005010X220A1','268962','','2013-12-23','12:20:08',0,'2013-12-26 12:54:43',NULL,NULL),(1876,324,'1078091','834','00','005010X220A1','1078091','','2013-12-09','17:49:30',0,'2013-12-25 19:31:05',NULL,NULL),(3380,587,'960838','834','00','005010X220A1','960838','','2013-12-17','16:49:47',0,'2013-12-25 21:51:04',NULL,NULL),(4091,733,'655933','834','00','005010X220A1','655933','','2013-12-19','10:37:59',0,'2013-12-25 23:03:02',NULL,NULL),(5294,982,'958803','834','00','005010X220A1','958803','','2013-11-16','10:40:28',0,'2013-12-26 01:01:12',NULL,NULL),(4609,827,'396444','834','00','005010X220A1','396444','','2013-12-23','21:06:10',0,'2013-12-25 23:47:31',NULL,NULL),(23303,4381,'3861474','834','00','005010X220A1','3861474','','2014-03-08','10:38:41',0,'2014-03-08 21:30:23',NULL,NULL),(23428,4405,'3530228','834','00','005010X220A1','3530228','','2014-03-09','13:18:26',0,'2014-03-09 21:00:32',NULL,NULL),(23624,4441,'3787446','834','00','005010X220A1','3787446','','2014-03-10','10:48:29',0,'2014-03-10 21:01:32',NULL,NULL),(18611,3456,'3077087','834','00','005010X220A1','3077087','','2014-02-10','14:49:13',0,'2014-02-10 21:31:11',NULL,NULL),(18435,3421,'2061371','834','00','005010X220A1','2061371','','2014-02-10','00:07:43',0,'2014-02-10 11:00:21',NULL,NULL),(16364,2985,'1967288','834','00','005010X220A1','1967288','','2014-01-23','15:00:17',0,'2014-01-23 21:00:57',NULL,NULL),(16074,2774,'2338685','834','00','005010X220A1','2338685','','2014-01-22','17:59:20',0,'2014-01-23 03:02:47',NULL,NULL),(15947,2762,'1472606','834','00','005010X220A1','1472606','','2014-01-21','16:17:45',1,'2014-01-22 03:23:12',NULL,NULL),(5503,1041,'1788488','834','00','005010X220A1','1788488','','2013-12-24','20:03:04',0,'2013-12-26 01:46:31',NULL,NULL),(14879,2557,'2218119','834','00','005010X220A1','2218119','','2014-01-13','20:47:39',0,'2014-01-15 02:07:20',NULL,NULL),(13739,2275,'2269158','834','00','005010X220A1','2269158','','2014-01-07','17:31:40',0,'2014-01-08 18:24:46',NULL,NULL),(7150,1237,'222245','834','00','005010X220A1','222245','','2013-12-18','16:10:22',0,'2013-12-26 04:05:04',NULL,NULL),(18201,3355,'2659085','834','00','005010X220A1','2659085','','2014-02-06','19:33:43',0,'2014-02-07 19:00:34',NULL,NULL),(7405,1295,'419594','834','00','005010X220A1','419594','','2013-12-20','20:54:53',0,'2013-12-26 04:31:01',NULL,NULL),(3840,682,'112907','834','00','005010X220A1','112907','','2013-11-08','10:55:45',0,'2013-12-25 22:30:15',NULL,NULL),(3994,729,'898132','834','00','005010X220A1','898132','','2013-12-07','17:35:01',0,'2013-12-25 22:48:05',NULL,NULL),(1578,278,'487687','834','00','005010X220A1','487687','','2013-11-19','19:03:58',0,'2013-12-25 19:00:34',NULL,NULL),(2306,402,'217539','834','00','005010X220A1','217539','','2013-11-01','19:58:56',0,'2013-12-25 20:01:26',NULL,NULL),(21109,3994,'3663517','834','00','005010X220A1','3663517','','2014-02-26','11:28:41',0,'2014-02-26 21:00:15',NULL,NULL),(22527,4247,'2789433','834','00','005010X220A1','2789433','','2014-03-05','14:47:56',0,'2014-03-05 21:30:25',NULL,NULL),(17933,3296,'2660213','834','00','005010X220A1','2660213','','2014-02-05','17:23:26',0,'2014-02-05 21:30:46',NULL,NULL),(1405,247,'1439568','834','00','005010X220A1','1439568','','2013-12-24','10:40:33',0,'2013-12-25 18:54:12',NULL,NULL),(5465,1040,'1398236','834','00','005010X220A1','1398236','','2013-12-24','20:42:01',0,'2013-12-26 01:45:19',NULL,NULL),(4618,827,'1090065','834','00','005010X220A1','1090065','','2013-12-23','21:51:45',0,'2013-12-25 23:47:48',NULL,NULL),(17647,3250,'1626360','834','00','005010X220A1','1626360','','2014-02-03','14:36:10',0,'2014-02-03 21:01:28',NULL,NULL),(19922,3729,'3351263','834','00','005010X220A1','3351263','','2014-02-17','13:35:12',0,'2014-02-17 19:00:14',NULL,NULL),(23266,4377,'3103379','834','00','005010X220A1','3103379','','2014-03-08','14:16:39',0,'2014-03-08 21:00:05',NULL,NULL),(23335,4384,'3189790','834','00','005010X220A1','3189790','','2014-03-08','15:43:27',0,'2014-03-08 21:30:46',NULL,NULL),(11451,1488,'1549633','834','00','005010X220A1','1549633','','2013-12-26','19:14:27',0,'2013-12-28 03:30:11',NULL,NULL),(11327,1456,'1465756','834','00','005010X220A1','1465756','','2013-12-26','13:43:17',0,'2013-12-27 02:04:19',NULL,NULL),(10836,1404,'263988','834','00','005010X220A1','263988','','2013-12-23','18:33:23',0,'2013-12-26 13:05:01',NULL,NULL),(7295,1257,'1153946','834','00','005010X220A1','1153946','','2013-12-18','10:17:57',0,'2013-12-26 04:09:32',NULL,NULL),(6374,1183,'1004722','834','00','005010X220A1','1004722','','2013-12-20','14:17:51',0,'2013-12-26 03:09:41',NULL,NULL),(2030,331,'1294895','834','00','005010X220A1','1294895','','2013-12-09','16:33:12',0,'2013-12-25 19:35:49',NULL,NULL),(17354,3181,'1542761','834','00','005010X220A1','1542761','','2014-01-31','13:23:50',0,'2014-01-31 21:01:19',NULL,NULL),(16955,3116,'2590537','834','00','005010X220A1','2590537','','2014-01-28','18:48:52',0,'2014-01-29 21:00:26',NULL,NULL),(15994,2765,'1415501','834','00','005010X220A1','1415501','','2014-01-22','12:43:18',0,'2014-01-23 03:02:10',NULL,NULL),(15398,2626,'2404274','834','00','005010X220A1','2404274','','2014-01-15','21:07:44',0,'2014-01-17 03:35:46',NULL,NULL),(20422,3837,'3094342','834','00','005010X220A1','3094342','','2014-02-20','16:47:06',0,'2014-02-20 21:30:21',NULL,NULL),(21001,3960,'3434977','834','00','005010X220A1','3434977','','2014-02-22','11:56:41',0,'2014-02-26 08:30:39',NULL,NULL),(22401,4214,'3290679','834','00','005010X220A1','3290679','','2014-03-04','10:48:18',0,'2014-03-04 21:02:21',NULL,NULL),(14937,2561,'1433043','834','00','005010X220A1','1433043','','2014-01-14','14:19:33',0,'2014-01-15 02:07:46',NULL,NULL),(14778,2551,'1359611','834','00','005010X220A1','1359611','','2014-01-14','14:10:20',0,'2014-01-15 02:06:36',NULL,NULL),(13737,2275,'2552700','834','00','005010X220A1','2552700','','2014-01-07','17:14:11',0,'2014-01-08 18:24:45',NULL,NULL),(13284,2128,'0001','999','BE','005010X231A1','1294753','834','2013-12-28','04:55:00',0,'2014-01-05 17:23:27',NULL,NULL),(11783,1537,'1031778','834','00','005010X220A1','1031778','','2013-12-28','20:05:27',1,'2013-12-29 11:12:35',NULL,NULL),(11861,1555,'403813','834','00','005010X220A1','403813','','2013-12-28','20:23:54',1,'2013-12-29 11:15:11',NULL,NULL),(17087,3136,'2657648','834','00','005010X220A1','2657648','','2014-01-29','14:42:38',0,'2014-01-29 21:01:50',NULL,NULL),(12195,1607,'1483759','834','00','005010X220A1','1483759','','2013-12-30','14:33:50',0,'2014-01-01 12:09:08',NULL,NULL),(16427,3002,'1758393','834','00','005010X220A1','1758393','','2014-01-23','15:17:33',0,'2014-01-23 21:01:40',NULL,NULL),(5034,935,'866398','834','00','005010X220A1','866398','','2013-12-11','13:34:19',0,'2013-12-26 00:47:04',NULL,NULL),(4969,933,'1002536','834','00','005010X220A1','1002536','','2013-10-07','11:22:42',0,'2013-12-26 00:32:24',NULL,NULL),(3641,622,'89955','834','00','005010X220A1','89955','','2013-12-12','16:13:38',0,'2013-12-25 22:05:37',NULL,NULL),(21811,4093,'2909633','834','00','005010X220A1','2909633','','2014-02-27','23:33:41',0,'2014-02-28 21:31:28',NULL,NULL),(467,89,'1230842','834','00','005010X220A1','1230842','','2013-12-03','21:01:00',0,'2013-12-25 17:50:33',NULL,NULL),(1028,193,'530654','834','00','005010X220A1','530654','','2013-12-03','11:29:47',0,'2013-12-25 18:21:06',NULL,NULL),(11422,1472,'1298291','834','00','005010X220A1','1298291','','2013-12-26','13:01:46',0,'2013-12-27 02:07:15',NULL,NULL),(19353,3585,'2374435','834','00','005010X220A1','2374435','','2014-02-12','19:46:40',0,'2014-02-13 22:01:55',NULL,NULL),(16455,3006,'1827366','834','00','005010X220A1','1827366','','2014-01-24','13:04:40',0,'2014-01-24 21:00:14',NULL,NULL),(16105,2797,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:28:00',1,'2014-01-23 03:41:56',NULL,NULL),(4980,935,'1109072','834','00','005010X220A1','1109072','','2013-12-10','20:10:54',0,'2013-12-26 00:45:21',NULL,NULL),(4396,774,'1183052','834','00','005010X220A1','1183052','','2013-11-27','16:18:37',0,'2013-12-25 23:15:47',NULL,NULL),(15237,2598,'2361709','834','00','005010X220A1','2361709','','2014-01-15','00:50:13',0,'2014-01-16 08:46:49',NULL,NULL),(14111,2344,'2240089','834','00','005010X220A1','2240089','','2014-01-08','16:31:01',0,'2014-01-13 02:22:17',NULL,NULL),(14572,2520,'1729497','834','00','005010X220A1','1729497','','2014-01-13','10:54:03',0,'2014-01-14 01:32:49',NULL,NULL),(19929,3733,'2447379','834','00','005010X220A1','2447379','','2014-02-18','09:27:19',0,'2014-02-18 21:30:04',NULL,NULL),(20078,3761,'2464075','834','00','005010X220A1','2464075','','2014-02-18','11:34:45',0,'2014-02-18 22:01:29',NULL,NULL),(20311,3794,'2383493','834','00','005010X220A1','2383493','','2014-02-19','13:51:10',0,'2014-02-20 04:46:02',NULL,NULL),(22838,4279,'2893795','834','00','005010X220A1','2893795','','2014-03-05','18:16:32',0,'2014-03-06 21:01:31',NULL,NULL),(19,1,'171786','834','00','005010X220A1','171786','','2013-12-05','16:13:39',0,'2013-12-25 17:15:34',NULL,NULL),(14943,2561,'2578377','834','00','005010X220A1','2578377','','2014-01-14','16:47:09',0,'2014-01-15 02:07:49',NULL,NULL),(12831,1704,'1577819','834','00','005010X220A1','1577819','','2014-01-03','11:00:12',0,'2014-01-04 02:02:22',NULL,NULL),(2456,422,'881116','834','00','005010X220A1','881116','','2013-12-05','20:15:43',0,'2013-12-25 20:19:03',NULL,NULL),(10720,1403,'1684388','834','00','005010X220A1','1684388','','2013-12-23','13:39:03',0,'2013-12-26 13:01:14',NULL,NULL),(20818,3910,'2685037','834','00','005010X220A1','2685037','','2014-02-25','14:38:12',0,'2014-02-25 21:31:07',NULL,NULL),(22506,4247,'3113055','834','00','005010X220A1','3113055','','2014-03-05','09:36:28',0,'2014-03-05 21:30:11',NULL,NULL),(23285,4380,'2663677','834','00','005010X220A1','2663677','','2014-03-08','11:27:45',0,'2014-03-08 21:30:08',NULL,NULL),(995,184,'614057','834','00','005010X220A1','614057','','2013-12-03','16:32:19',0,'2013-12-25 18:20:04',NULL,NULL),(10994,1413,'1234362','834','00','005010X220A1','1234362','','2013-12-23','13:17:30',0,'2013-12-26 13:10:32',NULL,NULL),(13375,2219,'0001','999','BE','005010X231A1','615292','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:41',NULL,NULL),(12150,1591,'1489866','834','00','005010X220A1','1489866','','2013-12-30','12:12:26',0,'2014-01-01 12:07:25',NULL,NULL),(11217,1454,'1607634','834','00','005010X220A1','1607634','','2013-12-26','10:01:36',0,'2013-12-27 02:00:58',NULL,NULL),(13891,2312,'1531983','834','00','005010X220A1','1531983','','2014-01-09','13:06:49',0,'2014-01-13 02:19:39',NULL,NULL),(3268,581,'54967','834','00','005010X220A1','54967','','2013-12-16','18:48:41',0,'2013-12-25 21:47:26',NULL,NULL),(16534,3020,'1489274','834','00','005010X220A1','1489274','','2014-01-24','12:06:15',0,'2014-01-24 21:01:03',NULL,NULL),(18039,3319,'2334609','834','00','005010X220A1','2334609','','2014-02-06','15:49:33',0,'2014-02-06 21:00:34',NULL,NULL),(19102,3543,'2388262','834','00','005010X220A1','2388262','','2014-02-12','14:17:20',0,'2014-02-12 21:31:39',NULL,NULL),(19260,3581,'3177701','834','00','005010X220A1','3177701','','2014-02-13','14:08:26',0,'2014-02-13 22:00:42',NULL,NULL),(20110,3772,'3399006','834','00','005010X220A1','3399006','','2014-02-18','19:29:52',0,'2014-02-20 03:46:25',NULL,NULL),(21068,3980,'3261506','834','00','005010X220A1','3261506','','2014-02-24','14:32:23',0,'2014-02-26 09:30:41',NULL,NULL),(21447,4028,'3028291','834','00','005010X220A1','3028291','','2014-02-26','20:08:53',0,'2014-02-28 06:30:57',NULL,NULL),(21861,4116,'3736836','834','00','005010X220A1','3736836','','2014-02-28','19:30:19',0,'2014-03-01 19:00:09',NULL,NULL),(5281,977,'340432','834','00','005010X220A1','340432','','2013-11-16','16:58:30',0,'2013-12-26 01:00:46',NULL,NULL),(4803,865,'20408','834','00','005010X220A1','20408','','2013-12-01','09:59:46',0,'2013-12-26 00:01:58',NULL,NULL),(17311,3174,'1956017','834','00','005010X220A1','1956017','','2014-01-30','19:09:47',0,'2014-01-31 21:00:48',NULL,NULL),(18936,3523,'2598257','834','00','005010X220A1','2598257','','2014-02-10','21:34:16',0,'2014-02-11 21:30:15',NULL,NULL),(3900,710,'223771','834','00','005010X220A1','223771','','2013-10-26','14:49:09',0,'2013-12-25 22:32:15',NULL,NULL),(19212,3579,'2916347','834','00','005010X220A1','2916347','','2014-02-13','15:49:02',0,'2014-02-13 21:30:17',NULL,NULL),(19541,3624,'3054005','834','00','005010X220A1','3054005','','2014-02-14','16:49:56',0,'2014-02-14 21:30:55',NULL,NULL),(22391,4210,'3787230','834','00','005010X220A1','3787230','','2014-03-04','16:19:35',0,'2014-03-04 21:02:12',NULL,NULL),(23373,4395,'3593491','834','00','005010X220A1','3593491','','2014-03-08','14:13:09',0,'2014-03-08 21:31:15',NULL,NULL),(23548,4435,'3904272','834','00','005010X220A1','3904272','','2014-03-10','14:47:16',0,'2014-03-10 21:00:39',NULL,NULL),(11898,1561,'1452224','834','00','005010X220A1','1452224','','2013-12-29','15:12:24',0,'2013-12-30 00:00:56',NULL,NULL),(502,102,'621998','834','00','005010X220A1','621998','','2013-12-16','10:01:51',0,'2013-12-25 18:00:31',NULL,NULL),(11230,1454,'1981525','834','00','005010X220A1','1981525','','2013-12-26','11:09:34',0,'2013-12-27 02:01:20',NULL,NULL),(11070,1421,'469322','834','00','005010X220A1','469322','','2013-12-23','13:38:09',0,'2013-12-26 13:13:08',NULL,NULL),(1449,252,'158166','834','00','005010X220A1','158166','','2013-12-24','12:17:21',0,'2013-12-25 18:55:41',NULL,NULL),(1824,312,'826596','834','00','005010X220A1','826596','','2013-12-10','16:39:37',0,'2013-12-25 19:20:21',NULL,NULL),(1967,326,'985282','834','00','005010X220A1','985282','','2013-12-09','15:06:26',0,'2013-12-25 19:33:42',NULL,NULL),(2103,359,'471355','834','00','005010X220A1','471355','','2013-12-09','18:03:01',0,'2013-12-25 19:38:10',NULL,NULL),(2119,360,'947578','834','00','005010X220A1','947578','','2013-12-02','09:19:16',0,'2013-12-25 19:45:30',NULL,NULL),(11051,1418,'47340','834','00','005010X220A1','47340','','2013-12-23','18:44:15',0,'2013-12-26 13:12:28',NULL,NULL),(3260,579,'1078354','834','00','005010X220A1','1078354','','2013-12-17','12:30:03',0,'2013-12-25 21:47:08',NULL,NULL),(10739,1403,'9406','834','00','005010X220A1','9406','','2013-12-23','15:35:57',0,'2013-12-26 13:01:51',NULL,NULL),(13209,2053,'0001','999','BE','005010X231A1','49381','834','2013-12-28','04:55:00',0,'2014-01-05 17:00:17',NULL,NULL),(13181,2025,'0001','999','BE','005010X231A1','1279288','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:59',NULL,NULL),(13035,1879,'0001','999','BE','005010X231A1','546147','834','2013-12-27','11:30:00',0,'2014-01-05 16:50:39',NULL,NULL),(2284,394,'94427','834','00','005010X220A1','94427','','2013-11-23','20:56:28',0,'2013-12-25 20:00:38',NULL,NULL),(2850,512,'190070','834','00','005010X220A1','190070','','2013-12-22','01:33:04',0,'2013-12-25 21:22:01',NULL,NULL),(16691,3062,'1652000','834','00','005010X220A1','1652000','','2014-01-27','16:13:27',0,'2014-01-27 21:00:38',NULL,NULL),(12478,1640,'1686019','834','00','005010X220A1','1686019','','2013-12-31','12:04:25',1,'2014-01-02 04:32:27',NULL,NULL),(7056,1236,'319405','834','00','005010X220A1','319405','','2013-12-17','18:32:42',0,'2013-12-26 04:02:12',NULL,NULL),(4860,885,'56862','834','00','005010X220A1','56862','','2013-11-21','17:27:52',0,'2013-12-26 00:15:55',NULL,NULL),(22905,4285,'3783668','834','00','005010X220A1','3783668','','2014-03-06','11:47:31',0,'2014-03-06 21:02:20',NULL,NULL),(14491,2512,'0001','999','BE','005010X231A1','1197349','834','2013-12-28','11:05:00',0,'2014-01-13 03:04:01',NULL,NULL),(5081,937,'789100','834','00','005010X220A1','789100','','2013-12-11','11:11:09',0,'2013-12-26 00:48:36',NULL,NULL),(3756,649,'458858','834','00','005010X220A1','458858','','2013-12-12','15:23:39',0,'2013-12-25 22:09:27',NULL,NULL),(6441,1206,'565617','834','00','005010X220A1','565617','','2013-11-21','21:10:22',0,'2013-12-26 03:15:46',NULL,NULL),(512,102,'406845','834','00','005010X220A1','406845','','2013-12-16','11:42:23',0,'2013-12-25 18:00:49',NULL,NULL),(18099,3327,'2303324','834','00','005010X220A1','2303324','','2014-02-06','17:37:28',0,'2014-02-06 21:01:15',NULL,NULL),(196,18,'710660','834','00','005010X220A1','710660','','2013-12-04','20:42:38',0,'2013-12-25 17:21:07',NULL,NULL),(20930,3937,'2804657','834','00','005010X220A1','2804657','','2014-02-23','11:58:03',0,'2014-02-26 08:00:25',NULL,NULL),(170,15,'977924','834','00','005010X220A1','977924','','2013-12-05','14:18:36',0,'2013-12-25 17:20:17',NULL,NULL),(13149,1993,'0001','999','BE','005010X231A1','1194379','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:30',NULL,NULL),(20012,3749,'2383449','834','00','005010X220A1','2383449','','2014-02-18','07:05:37',0,'2014-02-18 22:00:41',NULL,NULL),(1460,252,'472140','834','00','005010X220A1','472140','','2013-12-24','14:21:48',0,'2013-12-25 18:56:05',NULL,NULL),(19410,3593,'3317969','834','00','005010X220A1','3317969','','2014-02-13','15:42:58',0,'2014-02-13 22:02:36',NULL,NULL),(10601,1402,'842044','834','00','005010X220A1','842044','','2013-12-23','13:03:03',0,'2013-12-26 12:57:13',NULL,NULL),(14157,2363,'1573057','834','00','005010X220A1','1573057','','2014-01-09','18:18:31',0,'2014-01-13 02:23:09',NULL,NULL),(18296,3380,'2204445','834','00','005010X220A1','2204445','','2014-02-08','13:58:59',0,'2014-02-08 19:00:33',NULL,NULL),(5296,983,'47832','834','00','005010X220A1','47832','','2013-11-16','12:30:37',0,'2013-12-26 01:01:16',NULL,NULL),(5418,1025,'492591','834','00','005010X220A1','492591','','2013-11-14','13:16:38',0,'2013-12-26 01:30:54',NULL,NULL),(22931,4293,'3861394','834','00','005010X220A1','3861394','','2014-03-06','15:53:26',0,'2014-03-06 21:02:39',NULL,NULL),(1103,230,'709130','834','00','005010X220A1','709130','','2013-10-25','09:21:04',0,'2013-12-25 18:32:07',NULL,NULL),(11214,1454,'1836481','834','00','005010X220A1','1836481','','2013-12-26','09:46:19',0,'2013-12-27 02:00:53',NULL,NULL),(16251,2943,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',0,'2014-01-23 07:06:35',NULL,NULL),(1958,326,'893107','834','00','005010X220A1','893107','','2013-12-09','13:44:28',0,'2013-12-25 19:33:27',NULL,NULL),(15698,2700,'2596425','834','00','005010X220A1','2596425','','2014-01-18','19:15:05',0,'2014-01-21 08:45:26',NULL,NULL),(7727,1342,'902918','834','00','005010X220A1','902918','','2013-10-19','22:10:54',0,'2013-12-26 05:00:06',NULL,NULL),(4271,742,'1058619','834','00','005010X220A1','1058619','','2013-12-19','16:00:05',0,'2013-12-25 23:08:25',NULL,NULL),(14914,2558,'1387157','834','00','005010X220A1','1387157','','2014-01-14','17:19:21',0,'2014-01-15 02:07:35',NULL,NULL),(7652,1312,'1327179','834','00','005010X220A1','1327179','','2013-12-21','10:09:24',0,'2013-12-26 04:38:55',NULL,NULL),(12941,1732,'933962','834','00','005010X220A1','933962','','2014-01-03','18:35:45',0,'2014-01-04 06:00:12',NULL,NULL),(7187,1239,'765126','834','00','005010X220A1','765126','','2013-12-18','10:31:39',0,'2013-12-26 04:06:15',NULL,NULL),(17725,3261,'2424747','834','00','005010X220A1','2424747','','2014-02-04','16:05:29',0,'2014-02-04 21:00:44',NULL,NULL),(19419,3596,'1870895','834','00','005010X220A1','1870895','','2014-02-13','14:55:32',0,'2014-02-13 22:02:43',NULL,NULL),(23594,4437,'3674116','834','00','005010X220A1','3674116','','2014-03-10','14:43:01',0,'2014-03-10 21:01:12',NULL,NULL),(12952,1733,'1458457','834','00','005010X220A1','1458457','','2014-01-04','15:39:47',0,'2014-01-05 00:00:24',NULL,NULL),(12420,1638,'1927959','834','00','005010X220A1','1927959','','2013-12-31','00:54:59',1,'2014-01-02 04:30:23',NULL,NULL),(556,103,'908603','834','00','005010X220A1','908603','','2013-12-16','10:16:37',0,'2013-12-25 18:02:13',NULL,NULL),(2779,506,'85024','834','00','005010X220A1','85024','','2013-12-21','23:11:00',0,'2013-12-25 21:19:37',NULL,NULL),(2674,501,'1362550','834','00','005010X220A1','1362550','','2013-12-22','18:14:14',0,'2013-12-25 21:16:19',NULL,NULL),(19639,3644,'2476033','834','00','005010X220A1','2476033','','2014-02-14','09:26:29',0,'2014-02-14 21:32:06',NULL,NULL),(19680,3664,'2746628','834','00','005010X220A1','2746628','','2014-02-15','09:49:25',0,'2014-02-15 21:00:03',NULL,NULL),(20174,3778,'3172392','834','00','005010X220A1','3172392','','2014-02-19','13:35:45',0,'2014-02-20 04:10:47',NULL,NULL),(20565,3864,'2916557','834','00','005010X220A1','2916557','','2014-02-21','15:31:08',0,'2014-02-21 21:30:13',NULL,NULL),(21413,4026,'2994449','834','00','005010X220A1','2994449','','2014-02-26','21:54:08',0,'2014-02-28 06:30:41',NULL,NULL),(16891,3097,'2511311','834','00','005010X220A1','2511311','','2014-01-28','17:38:01',0,'2014-01-28 21:01:06',NULL,NULL),(4972,935,'1138170','834','00','005010X220A1','1138170','','2013-12-10','18:29:36',0,'2013-12-26 00:45:05',NULL,NULL),(17805,3271,'2549295','834','00','005010X220A1','2549295','','2014-02-04','11:47:35',0,'2014-02-04 21:01:36',NULL,NULL),(17905,3295,'2433159','834','00','005010X220A1','2433159','','2014-02-05','15:28:17',0,'2014-02-05 21:30:34',NULL,NULL),(18226,3357,'2173271','834','00','005010X220A1','2173271','','2014-02-07','17:22:14',0,'2014-02-07 19:00:54',NULL,NULL),(15676,2689,'2360698','834','00','005010X220A1','2360698','','2014-01-18','11:58:23',0,'2014-01-21 08:44:43',NULL,NULL),(11358,1459,'362490','834','00','005010X220A1','362490','','2013-12-26','01:37:25',0,'2013-12-27 02:05:18',NULL,NULL),(15406,2626,'2268315','834','00','005010X220A1','2268315','','2014-01-15','20:54:06',0,'2014-01-17 03:35:50',NULL,NULL),(15105,2587,'1698179','834','00','005010X220A1','1698179','','2014-01-14','22:13:59',0,'2014-01-16 08:45:24',NULL,NULL),(2590,476,'872033','834','00','005010X220A1','872033','','2013-10-31','18:03:13',0,'2013-12-25 20:45:39',NULL,NULL),(11240,1454,'1915394','834','00','005010X220A1','1915394','','2013-12-26','13:33:23',0,'2013-12-27 02:01:39',NULL,NULL),(4716,839,'636963','834','00','005010X220A1','636963','','2013-12-23','22:06:32',0,'2013-12-25 23:51:12',NULL,NULL),(10776,1404,'275671','834','00','005010X220A1','275671','','2013-12-23','07:57:23',0,'2013-12-26 13:03:07',NULL,NULL),(6402,1193,'893572','834','00','005010X220A1','893572','','2013-12-20','15:08:23',0,'2013-12-26 03:10:31',NULL,NULL),(14546,2518,'1875523','834','00','005010X220A1','1875523','','2014-01-13','17:13:47',0,'2014-01-14 01:32:32',NULL,NULL),(19072,3542,'3359271','834','00','005010X220A1','3359271','','2014-02-12','17:12:07',0,'2014-02-12 21:31:18',NULL,NULL),(22553,4248,'3431581','834','00','005010X220A1','3431581','','2014-03-05','11:41:48',0,'2014-03-05 21:30:46',NULL,NULL),(11154,1436,'1473831','834','00','005010X220A1','1473831','','2013-12-23','08:21:12',0,'2013-12-26 13:16:02',NULL,NULL),(10916,1410,'488543','834','00','005010X220A1','488543','','2013-12-22','21:55:48',0,'2013-12-26 13:08:10',NULL,NULL),(6038,1148,'786322','834','00','005010X220A1','786322','','2013-11-17','15:44:37',0,'2013-12-26 02:46:09',NULL,NULL),(781,145,'495995','834','00','005010X220A1','495995','','2013-10-28','23:56:09',0,'2013-12-25 18:09:28',NULL,NULL),(1106,233,'446851','834','00','005010X220A1','446851','','2013-11-07','01:59:15',0,'2013-12-25 18:32:16',NULL,NULL),(14821,2552,'2504914','834','00','005010X220A1','2504914','','2014-01-14','16:13:55',0,'2014-01-15 02:06:53',NULL,NULL),(14173,2364,'1523645','834','00','005010X220A1','1523645','','2014-01-10','11:20:57',0,'2014-01-13 02:23:23',NULL,NULL),(13018,1746,'2522201','834','00','005010X220A1','2522201','','2014-01-04','14:56:18',0,'2014-01-05 00:02:53',NULL,NULL),(2317,405,'409888','834','00','005010X220A1','409888','','2013-11-01','21:34:02',0,'2013-12-25 20:01:47',NULL,NULL),(17693,3260,'2883123','834','00','005010X220A1','2883123','','2014-02-04','12:19:18',0,'2014-02-04 21:00:26',NULL,NULL),(17971,3302,'2826276','834','00','005010X220A1','2826276','','2014-02-05','18:09:03',0,'2014-02-05 21:31:06',NULL,NULL),(22065,4168,'2807310','834','00','005010X220A1','2807310','','2014-03-03','17:25:08',0,'2014-03-03 21:00:20',NULL,NULL),(1173,239,'1360068','834','00','005010X220A1','1360068','','2013-12-24','13:28:33',0,'2013-12-25 18:46:55',NULL,NULL),(16940,3115,'1434392','834','00','005010X220A1','1434392','','2014-01-29','12:18:25',0,'2014-01-29 21:00:16',NULL,NULL),(16417,2998,'2124485','834','00','005010X220A1','2124485','','2014-01-22','23:29:51',0,'2014-01-23 21:01:32',NULL,NULL),(1724,293,'841437','834','00','005010X220A1','841437','','2013-12-09','22:09:10',0,'2013-12-25 19:17:13',NULL,NULL),(13324,2168,'0001','999','BE','005010X231A1','891466','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:19',NULL,NULL),(5441,1033,'47640','834','00','005010X220A1','47640','','2013-10-05','17:29:35',0,'2013-12-26 01:31:41',NULL,NULL),(6163,1167,'1265832','834','00','005010X220A1','1265832','','2013-12-20','08:52:26',0,'2013-12-26 03:03:13',NULL,NULL),(5245,960,'518517','834','00','005010X220A1','518517','','2013-12-11','10:44:12',0,'2013-12-26 00:53:51',NULL,NULL),(10975,1412,'191650','834','00','005010X220A1','191650','','2013-12-23','13:35:05',0,'2013-12-26 13:09:54',NULL,NULL),(17567,3236,'1856863','834','00','005010X220A1','1856863','','2014-02-03','12:50:00',0,'2014-02-03 21:00:37',NULL,NULL),(18801,3487,'2172012','834','00','005010X220A1','2172012','','2014-02-11','15:49:53',0,'2014-02-11 21:01:16',NULL,NULL),(20279,3794,'2603864','834','00','005010X220A1','2603864','','2014-02-19','10:16:12',0,'2014-02-20 04:37:52',NULL,NULL),(10478,1400,'842059','834','00','005010X220A1','842059','','2013-12-23','15:21:30',0,'2013-12-26 12:53:11',NULL,NULL),(659,108,'1160972','834','00','005010X220A1','1160972','','2013-12-16','16:54:21',0,'2013-12-25 18:05:28',NULL,NULL),(15917,2743,'2354568','834','00','005010X220A1','2354568','','2014-01-21','08:55:44',1,'2014-01-22 03:22:52',NULL,NULL),(15873,2739,'2047303','834','00','005010X220A1','2047303','','2014-01-21','13:32:47',1,'2014-01-22 03:22:23',NULL,NULL),(13826,2300,'1884049','834','00','005010X220A1','1884049','','2014-01-11','09:57:08',0,'2014-01-13 02:18:32',NULL,NULL),(6366,1182,'1283573','834','00','005010X220A1','1283573','','2013-12-20','14:23:45',0,'2013-12-26 03:09:24',NULL,NULL),(18752,3485,'1928915','834','00','005010X220A1','1928915','','2014-02-11','15:09:05',0,'2014-02-11 21:00:40',NULL,NULL),(23106,4341,'2780879','834','00','005010X220A1','2780879','','2014-03-07','11:15:06',0,'2014-03-07 21:30:39',NULL,NULL),(23440,4407,'3685804','834','00','005010X220A1','3685804','','2014-03-08','21:55:20',0,'2014-03-09 21:00:41',NULL,NULL),(3084,545,'54880','834','00','005010X220A1','54880','','2013-12-13','16:53:16',0,'2013-12-25 21:35:43',NULL,NULL),(16910,3106,'2609361','834','00','005010X220A1','2609361','','2014-01-28','14:12:43',0,'2014-01-28 21:01:19',NULL,NULL),(16630,3053,'1891741','834','00','005010X220A1','1891741','','2014-01-26','08:47:44',0,'2014-01-26 19:00:25',NULL,NULL),(11664,1501,'685998','834','00','005010X220A1','685998','','2013-12-27','00:15:00',0,'2013-12-28 03:36:42',NULL,NULL),(16108,2800,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 03:42:44',NULL,NULL),(13485,2226,'2433647','834','00','005010X220A1','2433647','','2014-01-06','14:10:19',0,'2014-01-07 04:04:05',NULL,NULL),(18612,3456,'1551960','834','00','005010X220A1','1551960','','2014-02-10','15:15:27',0,'2014-02-10 21:31:12',NULL,NULL),(20461,3842,'3141296','834','00','005010X220A1','3141296','','2014-02-20','11:07:14',0,'2014-02-20 22:00:32',NULL,NULL),(16936,3115,'2030591','834','00','005010X220A1','2030591','','2014-01-29','00:26:56',0,'2014-01-29 21:00:14',NULL,NULL),(16138,2830,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','09:47:00',1,'2014-01-23 03:53:21',NULL,NULL),(15228,2595,'1544976','834','00','005010X220A1','1544976','','2014-01-15','12:50:29',0,'2014-01-16 08:46:43',NULL,NULL),(1868,324,'254135','834','00','005010X220A1','254135','','2013-12-09','15:37:17',0,'2013-12-25 19:30:47',NULL,NULL),(4465,801,'496166','834','00','005010X220A1','496166','','2013-11-26','17:40:04',0,'2013-12-25 23:30:53',NULL,NULL),(7614,1304,'873930','834','00','005010X220A1','873930','','2013-12-20','19:26:20',0,'2013-12-26 04:37:42',NULL,NULL),(10581,1402,'1576344','834','00','005010X220A1','1576344','','2013-12-23','11:44:02',0,'2013-12-26 12:56:36',NULL,NULL),(21486,4028,'2814674','834','00','005010X220A1','2814674','','2014-02-27','17:32:02',0,'2014-02-28 06:31:15',NULL,NULL),(22596,4250,'2751142','834','00','005010X220A1','2751142','','2014-03-05','08:48:55',0,'2014-03-05 21:31:15',NULL,NULL),(23178,4345,'3384806','834','00','005010X220A1','3384806','','2014-03-07','00:45:09',0,'2014-03-07 21:31:30',NULL,NULL),(17293,3172,'1903130','834','00','005010X220A1','1903130','','2014-01-31','14:51:41',0,'2014-01-31 21:00:37',NULL,NULL),(16969,3116,'1476204','834','00','005010X220A1','1476204','','2014-01-29','14:43:15',0,'2014-01-29 21:00:35',NULL,NULL),(926,180,'903213','834','00','005010X220A1','903213','','2013-12-02','19:35:22',0,'2013-12-25 18:17:54',NULL,NULL),(12293,1625,'2416313','834','00','005010X220A1','2416313','','2013-12-31','20:56:48',1,'2014-01-02 04:25:02',NULL,NULL),(11554,1492,'1635390','834','00','005010X220A1','1635390','','2013-12-27','00:40:21',0,'2013-12-28 03:33:17',NULL,NULL),(16418,2999,'2406798','834','00','005010X220A1','2406798','','2014-01-23','11:10:01',0,'2014-01-23 21:01:34',NULL,NULL),(2728,503,'538718','834','00','005010X220A1','538718','','2013-12-22','10:30:09',0,'2013-12-25 21:18:03',NULL,NULL),(11340,1456,'1258440','834','00','005010X220A1','1258440','','2013-12-26','16:52:42',0,'2013-12-27 02:04:44',NULL,NULL),(2904,539,'563551','834','00','005010X220A1','563551','','2013-12-13','11:31:52',0,'2013-12-25 21:30:05',NULL,NULL),(15201,2592,'1410039','834','00','005010X220A1','1410039','','2014-01-15','09:44:21',0,'2014-01-16 08:46:26',NULL,NULL),(13445,2223,'1684907','834','00','005010X220A1','1684907','','2014-01-06','14:09:57',0,'2014-01-07 04:02:33',NULL,NULL),(21868,4122,'2731374','834','00','005010X220A1','2731374','','2014-02-28','18:15:28',0,'2014-03-01 21:00:08',NULL,NULL),(13581,2255,'2538564','834','00','005010X220A1','2538564','','2014-01-04','21:46:57',1,'2014-01-07 10:22:03',NULL,NULL),(14854,2553,'1521174','834','00','005010X220A1','1521174','','2014-01-14','16:34:56',0,'2014-01-15 02:07:08',NULL,NULL),(23145,4342,'3283402','834','00','005010X220A1','3283402','','2014-03-07','15:59:29',0,'2014-03-07 21:31:06',NULL,NULL),(23434,4405,'3738226','834','00','005010X220A1','3738226','','2014-03-09','16:12:59',0,'2014-03-09 21:00:36',NULL,NULL),(17431,3204,'1838871','834','00','005010X220A1','1838871','','2014-01-31','21:37:40',0,'2014-02-01 19:00:29',NULL,NULL),(1834,315,'1050831','834','00','005010X220A1','1050831','','2013-12-10','16:12:06',0,'2013-12-25 19:20:43',NULL,NULL),(11461,1488,'2136380','834','00','005010X220A1','2136380','','2013-12-27','10:15:35',0,'2013-12-28 03:30:30',NULL,NULL),(14613,2522,'2261959','834','00','005010X220A1','2261959','','2014-01-13','16:30:02',0,'2014-01-14 01:33:14',NULL,NULL),(14224,2366,'1369187','834','00','005010X220A1','1369187','','2014-01-10','15:03:26',0,'2014-01-13 02:24:00',NULL,NULL),(7095,1236,'20943','834','00','005010X220A1','20943','','2013-12-18','11:08:54',0,'2013-12-26 04:03:28',NULL,NULL),(21422,4026,'2744230','834','00','005010X220A1','2744230','','2014-02-27','13:59:20',0,'2014-02-28 06:30:45',NULL,NULL),(23683,4447,'3060873','834','00','005010X220A1','3060873','','2014-03-10','11:26:46',0,'2014-03-10 21:02:16',NULL,NULL),(11547,1492,'2054395','834','00','005010X220A1','2054395','','2013-12-26','19:20:46',0,'2013-12-28 03:33:02',NULL,NULL),(11174,1446,'304643','834','00','005010X220A1','304643','','2013-12-23','14:32:33',0,'2013-12-26 13:16:47',NULL,NULL),(17860,3293,'2833467','834','00','005010X220A1','2833467','','2014-02-05','09:57:27',0,'2014-02-05 21:30:11',NULL,NULL),(10731,1403,'682867','834','00','005010X220A1','682867','','2013-12-23','14:57:34',0,'2013-12-26 13:01:39',NULL,NULL),(15804,2725,'1630258','834','00','005010X220A1','1630258','','2014-01-20','12:24:21',0,'2014-01-21 08:46:50',NULL,NULL),(5402,1020,'360245','834','00','005010X220A1','360245','','2013-11-14','12:10:10',0,'2013-12-26 01:30:16',NULL,NULL),(6404,1195,'632999','834','00','005010X220A1','632999','','2013-12-20','15:22:03',0,'2013-12-26 03:10:36',NULL,NULL),(20316,3794,'2823439','834','00','005010X220A1','2823439','','2014-02-19','16:30:04',0,'2014-02-20 04:47:12',NULL,NULL),(22064,4168,'3135494','834','00','005010X220A1','3135494','','2014-03-03','17:25:08',0,'2014-03-03 21:00:19',NULL,NULL),(22130,4179,'2990932','834','00','005010X220A1','2990932','','2014-03-02','23:04:18',0,'2014-03-03 21:30:41',NULL,NULL),(12976,1734,'2319147','834','00','005010X220A1','2319147','','2014-01-04','13:52:10',0,'2014-01-05 00:01:17',NULL,NULL),(11381,1462,'1067763','834','00','005010X220A1','1067763','','2013-12-26','13:57:24',0,'2013-12-27 02:05:57',NULL,NULL),(3673,628,'515173','834','00','005010X220A1','515173','','2013-12-11','21:13:00',0,'2013-12-25 22:06:39',NULL,NULL),(3976,718,'361539','834','00','005010X220A1','361539','','2013-12-07','14:04:26',0,'2013-12-25 22:47:26',NULL,NULL),(4049,731,'477089','834','00','005010X220A1','477089','','2013-12-19','17:43:15',0,'2013-12-25 23:01:39',NULL,NULL),(16208,2900,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:01:00',0,'2014-01-23 05:00:02',NULL,NULL),(7649,1311,'821538','834','00','005010X220A1','821538','','2013-12-21','15:20:04',0,'2013-12-26 04:38:48',NULL,NULL),(5626,1046,'1829830','834','00','005010X220A1','1829830','','2013-12-24','19:07:19',0,'2013-12-26 01:50:34',NULL,NULL),(5942,1113,'39461','834','00','005010X220A1','39461','','2013-12-15','09:11:25',0,'2013-12-26 02:32:05',NULL,NULL),(15373,2624,'2171456','834','00','005010X220A1','2171456','','2014-01-15','23:07:32',0,'2014-01-17 03:35:33',NULL,NULL),(7570,1301,'901504','834','00','005010X220A1','901504','','2013-12-21','13:30:32',0,'2013-12-26 04:36:18',NULL,NULL),(14020,2337,'1655025','834','00','005010X220A1','1655025','','2014-01-08','11:24:39',0,'2014-01-13 02:21:18',NULL,NULL),(18281,3378,'2269954','834','00','005010X220A1','2269954','','2014-02-08','17:52:33',0,'2014-02-08 19:00:22',NULL,NULL),(18955,3531,'3256317','834','00','005010X220A1','3256317','','2014-02-11','19:39:54',0,'2014-02-12 21:00:08',NULL,NULL),(19352,3585,'2907916','834','00','005010X220A1','2907916','','2014-02-12','19:36:36',0,'2014-02-13 22:01:54',NULL,NULL),(20060,3753,'3400421','834','00','005010X220A1','3400421','','2014-02-18','15:49:11',0,'2014-02-18 22:01:16',NULL,NULL),(20526,3849,'2720245','834','00','005010X220A1','2720245','','2014-02-20','14:10:04',0,'2014-02-20 22:01:25',NULL,NULL),(11520,1490,'843684','834','00','005010X220A1','843684','','2013-12-27','12:06:58',0,'2013-12-28 03:32:15',NULL,NULL),(17834,3282,'2419593','834','00','005010X220A1','2419593','','2014-02-04','15:39:47',0,'2014-02-04 21:01:56',NULL,NULL),(17345,3181,'1505021','834','00','005010X220A1','1505021','','2014-01-31','10:22:58',0,'2014-01-31 21:01:13',NULL,NULL),(17231,3159,'1771032','834','00','005010X220A1','1771032','','2014-01-30','11:03:13',0,'2014-01-30 21:01:30',NULL,NULL),(6431,1203,'826289','834','00','005010X220A1','826289','','2013-11-22','11:04:49',0,'2013-12-26 03:15:28',NULL,NULL),(6382,1185,'760573','834','00','005010X220A1','760573','','2013-12-20','08:35:36',0,'2013-12-26 03:09:55',NULL,NULL),(3998,731,'169843','834','00','005010X220A1','169843','','2013-12-18','19:13:15',0,'2013-12-25 23:00:06',NULL,NULL),(21269,4001,'2856297','834','00','005010X220A1','2856297','','2014-02-26','10:34:00',0,'2014-02-26 21:02:02',NULL,NULL),(22198,4185,'2773180','834','00','005010X220A1','2773180','','2014-03-02','20:12:37',0,'2014-03-03 21:31:30',NULL,NULL),(22410,4215,'3045834','834','00','005010X220A1','3045834','','2014-03-04','14:45:15',0,'2014-03-04 21:02:29',NULL,NULL),(16396,2993,'2012655','834','00','005010X220A1','2012655','','2014-01-23','11:22:33',0,'2014-01-23 21:01:20',NULL,NULL),(1015,190,'785034','834','00','005010X220A1','785034','','2013-12-03','02:29:12',0,'2013-12-25 18:20:44',NULL,NULL),(1320,245,'37372','834','00','005010X220A1','37372','','2013-12-24','10:50:30',0,'2013-12-25 18:51:27',NULL,NULL),(12566,1663,'2528268','834','00','005010X220A1','2528268','','2013-12-31','17:32:21',1,'2014-01-02 04:35:56',NULL,NULL),(15226,2595,'2345076','834','00','005010X220A1','2345076','','2014-01-14','21:21:40',0,'2014-01-16 08:46:42',NULL,NULL),(4946,921,'509803','834','00','005010X220A1','509803','','2013-11-19','10:59:09',0,'2013-12-26 00:31:40',NULL,NULL),(4711,837,'1591178','834','00','005010X220A1','1591178','','2013-12-23','21:47:22',0,'2013-12-25 23:50:59',NULL,NULL),(7672,1320,'854069','834','00','005010X220A1','854069','','2013-12-21','11:32:39',0,'2013-12-26 04:39:35',NULL,NULL),(5124,943,'1254213','834','00','005010X220A1','1254213','','2013-12-10','19:12:40',0,'2013-12-26 00:50:01',NULL,NULL),(18633,3461,'2761175','834','00','005010X220A1','2761175','','2014-02-10','12:46:13',0,'2014-02-10 21:31:27',NULL,NULL),(18736,3485,'3053849','834','00','005010X220A1','3053849','','2014-02-11','11:18:34',0,'2014-02-11 21:00:27',NULL,NULL),(21145,3997,'3719857','834','00','005010X220A1','3719857','','2014-02-26','08:57:54',0,'2014-02-26 21:00:41',NULL,NULL),(22557,4248,'2993192','834','00','005010X220A1','2993192','','2014-03-05','12:01:40',0,'2014-03-05 21:30:49',NULL,NULL),(23597,4437,'3542556','834','00','005010X220A1','3542556','','2014-03-10','17:54:48',0,'2014-03-10 21:01:14',NULL,NULL),(144,10,'717860','834','00','005010X220A1','717860','','2013-12-05','09:43:52',0,'2013-12-25 17:19:29',NULL,NULL),(17013,3119,'2254907','834','00','005010X220A1','2254907','','2014-01-28','23:39:16',0,'2014-01-29 21:01:02',NULL,NULL),(16518,3015,'1923463','834','00','005010X220A1','1923463','','2014-01-23','18:26:50',0,'2014-01-24 21:00:53',NULL,NULL),(1445,252,'1352812','834','00','005010X220A1','1352812','','2013-12-24','11:25:13',0,'2013-12-25 18:55:32',NULL,NULL),(3519,615,'11644','834','00','005010X220A1','11644','','2013-12-12','17:17:55',0,'2013-12-25 22:01:46',NULL,NULL),(4301,749,'435575','834','00','005010X220A1','435575','','2013-12-19','00:04:19',0,'2013-12-25 23:09:20',NULL,NULL),(15131,2587,'1947609','834','00','005010X220A1','1947609','','2014-01-15','17:10:29',0,'2014-01-16 08:45:41',NULL,NULL),(14919,2559,'2125498','834','00','005010X220A1','2125498','','2014-01-14','09:53:12',0,'2014-01-15 02:07:38',NULL,NULL),(14772,2551,'1508652','834','00','005010X220A1','1508652','','2014-01-14','11:43:35',0,'2014-01-15 02:06:33',NULL,NULL),(5534,1041,'671410','834','00','005010X220A1','671410','','2013-12-24','23:25:43',0,'2013-12-26 01:47:31',NULL,NULL),(18740,3485,'3024022','834','00','005010X220A1','3024022','','2014-02-11','12:08:56',0,'2014-02-11 21:00:30',NULL,NULL),(19612,3635,'3064088','834','00','005010X220A1','3064088','','2014-02-14','02:15:56',0,'2014-02-14 21:31:45',NULL,NULL),(23636,4441,'3348257','834','00','005010X220A1','3348257','','2014-03-10','13:39:21',0,'2014-03-10 21:01:41',NULL,NULL),(16584,3040,'2577630','834','00','005010X220A1','2577630','','2014-01-25','10:42:29',0,'2014-01-25 19:00:14',NULL,NULL),(15774,2717,'2236991','834','00','005010X220A1','2236991','','2014-01-20','11:27:40',0,'2014-01-21 08:46:32',NULL,NULL),(15153,2588,'1847295','834','00','005010X220A1','1847295','','2014-01-15','12:42:16',0,'2014-01-16 08:45:56',NULL,NULL),(14786,2551,'2370249','834','00','005010X220A1','2370249','','2014-01-14','15:23:02',0,'2014-01-15 02:06:39',NULL,NULL),(1894,325,'799376','834','00','005010X220A1','799376','','2013-12-09','11:27:31',0,'2013-12-25 19:31:35',NULL,NULL),(5884,1109,'20799','834','00','005010X220A1','20799','','2013-12-15','09:54:16',0,'2013-12-26 02:30:14',NULL,NULL),(2354,413,'158777','834','00','005010X220A1','158777','','2013-12-06','17:25:10',0,'2013-12-25 20:15:46',NULL,NULL),(2460,422,'261843','834','00','005010X220A1','261843','','2013-12-06','10:53:26',0,'2013-12-25 20:19:11',NULL,NULL),(2589,475,'1224332','834','00','005010X220A1','1224332','','2013-11-01','10:23:08',0,'2013-12-25 20:45:37',NULL,NULL),(21530,4038,'2716580','834','00','005010X220A1','2716580','','2014-02-27','10:35:23',0,'2014-02-28 06:31:35',NULL,NULL),(23765,4480,'3749018','834','00','005010X220A1','3749018','','2014-03-10','13:21:23',0,'2014-03-10 21:30:14',NULL,NULL),(17831,3280,'2571368','834','00','005010X220A1','2571368','','2014-02-04','14:13:04',0,'2014-02-04 21:01:55',NULL,NULL),(387,76,'899383','834','00','005010X220A1','899383','','2013-12-03','20:01:07',0,'2013-12-25 17:47:57',NULL,NULL),(5563,1043,'1124151','834','00','005010X220A1','1124151','','2013-12-24','19:33:03',0,'2013-12-26 01:48:27',NULL,NULL),(596,107,'561124','834','00','005010X220A1','561124','','2013-12-16','08:33:00',0,'2013-12-25 18:03:27',NULL,NULL),(4404,777,'19341','834','00','005010X220A1','19341','','2013-11-26','20:59:24',0,'2013-12-25 23:16:04',NULL,NULL),(6048,1156,'1122773','834','00','005010X220A1','1122773','','2013-10-14','08:59:04',0,'2013-12-26 02:46:30',NULL,NULL),(6321,1175,'112445','834','00','005010X220A1','112445','','2013-12-20','14:39:20',0,'2013-12-26 03:08:00',NULL,NULL),(18903,3505,'3109906','834','00','005010X220A1','3109906','','2014-02-11','10:24:50',0,'2014-02-11 21:02:40',NULL,NULL),(20515,3849,'3458883','834','00','005010X220A1','3458883','','2014-02-19','22:05:26',0,'2014-02-20 22:01:15',NULL,NULL),(20892,3923,'2423808','834','00','005010X220A1','2423808','','2014-02-25','10:29:01',0,'2014-02-25 21:32:02',NULL,NULL),(21627,4066,'3431381','834','00','005010X220A1','3431381','','2014-02-27','14:31:42',0,'2014-02-28 07:30:23',NULL,NULL),(21702,4087,'3472758','834','00','005010X220A1','3472758','','2014-02-28','14:41:22',0,'2014-02-28 21:30:14',NULL,NULL),(3595,617,'146346','834','00','005010X220A1','146346','','2013-12-12','17:14:54',0,'2013-12-25 22:04:10',NULL,NULL),(7083,1236,'644017','834','00','005010X220A1','644017','','2013-12-18','10:27:00',0,'2013-12-26 04:03:07',NULL,NULL),(6251,1172,'658607','834','00','005010X220A1','658607','','2013-12-19','20:30:16',0,'2013-12-26 03:05:58',NULL,NULL),(6193,1167,'579342','834','00','005010X220A1','579342','','2013-12-20','18:03:27',0,'2013-12-26 03:04:06',NULL,NULL),(20793,3909,'2651786','834','00','005010X220A1','2651786','','2014-02-24','19:52:50',0,'2014-02-25 21:30:50',NULL,NULL),(15435,2629,'1414019','834','00','005010X220A1','1414019','','2014-01-15','19:09:48',0,'2014-01-17 03:36:03',NULL,NULL),(11458,1488,'2268876','834','00','005010X220A1','2268876','','2013-12-27','09:13:48',0,'2013-12-28 03:30:25',NULL,NULL),(10892,1409,'1538834','834','00','005010X220A1','1538834','','2013-12-22','23:30:24',0,'2013-12-26 13:07:21',NULL,NULL),(13105,1949,'0001','999','BE','005010X231A1','1144377','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:52',NULL,NULL),(3719,636,'737214','834','00','005010X220A1','737214','','2013-12-12','09:01:18',0,'2013-12-25 22:08:10',NULL,NULL),(18311,3384,'2712452','834','00','005010X220A1','2712452','','2014-02-07','23:18:52',0,'2014-02-08 19:00:42',NULL,NULL),(18593,3455,'2510496','834','00','005010X220A1','2510496','','2014-02-10','11:55:35',0,'2014-02-10 21:30:58',NULL,NULL),(19067,3542,'1715110','834','00','005010X220A1','1715110','','2014-02-12','15:47:21',0,'2014-02-12 21:31:13',NULL,NULL),(20240,3791,'3539395','834','00','005010X220A1','3539395','','2014-02-18','23:03:10',0,'2014-02-20 04:30:21',NULL,NULL),(22039,4163,'3815235','834','00','005010X220A1','3815235','','2014-03-03','13:21:59',0,'2014-03-03 21:00:03',NULL,NULL),(16621,3050,'2077960','834','00','005010X220A1','2077960','','2014-01-26','13:46:09',0,'2014-01-26 19:00:18',NULL,NULL),(1353,245,'2018558','834','00','005010X220A1','2018558','','2013-12-24','13:37:41',0,'2013-12-25 18:52:31',NULL,NULL),(11228,1454,'1610038','834','00','005010X220A1','1610038','','2013-12-26','10:49:35',0,'2013-12-27 02:01:17',NULL,NULL),(15729,2711,'1491826','834','00','005010X220A1','1491826','','2014-01-20','15:54:54',0,'2014-01-21 08:46:05',NULL,NULL),(20786,3907,'2521985','834','00','005010X220A1','2521985','','2014-02-25','17:00:11',0,'2014-02-25 21:30:45',NULL,NULL),(23322,4383,'2765653','834','00','005010X220A1','2765653','','2014-03-08','08:57:40',0,'2014-03-08 21:30:37',NULL,NULL),(5680,1058,'1498176','834','00','005010X220A1','1498176','','2013-12-24','21:13:18',0,'2013-12-26 01:52:27',NULL,NULL),(4459,801,'1008795','834','00','005010X220A1','1008795','','2013-11-26','14:23:15',0,'2013-12-25 23:30:43',NULL,NULL),(2717,503,'1389211','834','00','005010X220A1','1389211','','2013-12-21','19:21:01',0,'2013-12-25 21:17:43',NULL,NULL),(19218,3580,'2825367','834','00','005010X220A1','2825367','','2014-02-12','22:29:22',0,'2014-02-13 22:00:07',NULL,NULL),(19257,3581,'2637423','834','00','005010X220A1','2637423','','2014-02-13','11:39:35',0,'2014-02-13 22:00:40',NULL,NULL),(21037,3977,'3441054','834','00','005010X220A1','3441054','','2014-02-24','08:50:53',0,'2014-02-26 09:30:16',NULL,NULL),(21823,4097,'3099382','834','00','005010X220A1','3099382','','2014-02-27','21:19:19',0,'2014-02-28 21:31:36',NULL,NULL),(22359,4205,'2766691','834','00','005010X220A1','2766691','','2014-03-04','12:50:57',0,'2014-03-04 21:01:45',NULL,NULL),(11470,1488,'131752','834','00','005010X220A1','131752','','2013-12-27','12:16:14',0,'2013-12-28 03:30:45',NULL,NULL),(17801,3270,'2250154','834','00','005010X220A1','2250154','','2014-02-04','17:40:55',0,'2014-02-04 21:01:33',NULL,NULL),(10717,1403,'1511762','834','00','005010X220A1','1511762','','2013-12-23','12:55:55',0,'2013-12-26 13:01:07',NULL,NULL),(15032,2584,'1946457','834','00','005010X220A1','1946457','','2014-01-15','15:07:54',0,'2014-01-16 08:44:38',NULL,NULL),(7320,1268,'647966','834','00','005010X220A1','647966','','2013-12-18','14:06:24',0,'2013-12-26 04:10:18',NULL,NULL),(14475,2496,'0001','999','BE','005010X231A1','799523','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:47',NULL,NULL),(6155,1167,'837651','834','00','005010X220A1','837651','','2013-12-19','20:12:21',0,'2013-12-26 03:03:00',NULL,NULL),(18944,3525,'2948849','834','00','005010X220A1','2948849','','2014-02-11','15:21:46',0,'2014-02-11 21:30:23',NULL,NULL),(22235,4198,'3725636','834','00','005010X220A1','3725636','','2014-03-03','17:41:11',0,'2014-03-03 21:31:59',NULL,NULL),(10511,1401,'268888','834','00','005010X220A1','268888','','2013-12-22','18:37:08',0,'2013-12-26 12:54:11',NULL,NULL),(17966,3301,'2150160','834','00','005010X220A1','2150160','','2014-02-04','19:53:02',0,'2014-02-05 21:31:03',NULL,NULL),(1264,243,'2018563','834','00','005010X220A1','2018563','','2013-12-24','14:19:44',0,'2013-12-25 18:49:37',NULL,NULL),(16704,3064,'2563636','834','00','005010X220A1','2563636','','2014-01-27','09:42:06',0,'2014-01-27 21:00:47',NULL,NULL),(12746,1688,'2176473','834','00','005010X220A1','2176473','','2014-01-02','14:50:53',0,'2014-01-03 02:06:32',NULL,NULL),(1840,319,'701917','834','00','005010X220A1','701917','','2013-12-10','16:19:04',0,'2013-12-25 19:20:57',NULL,NULL),(4401,776,'274832','834','00','005010X220A1','274832','','2013-11-27','13:11:46',0,'2013-12-25 23:15:58',NULL,NULL),(17681,3259,'2263901','834','00','005010X220A1','2263901','','2014-02-04','12:58:21',0,'2014-02-04 21:00:18',NULL,NULL),(16994,3118,'1569748','834','00','005010X220A1','1569748','','2014-01-29','10:01:32',0,'2014-01-29 21:00:50',NULL,NULL),(2154,361,'360408','834','00','005010X220A1','360408','','2013-12-02','15:38:35',0,'2013-12-25 19:46:35',NULL,NULL),(3543,616,'385854','834','00','005010X220A1','385854','','2013-12-12','11:32:25',0,'2013-12-25 22:02:34',NULL,NULL),(18655,3464,'3142242','834','00','005010X220A1','3142242','','2014-02-10','15:15:06',0,'2014-02-10 21:31:42',NULL,NULL),(19470,3620,'2603715','834','00','005010X220A1','2603715','','2014-02-13','19:06:42',0,'2014-02-14 21:30:04',NULL,NULL),(3086,546,'147825','834','00','005010X220A1','147825','','2013-12-12','18:58:14',0,'2013-12-25 21:35:46',NULL,NULL),(17991,3313,'1983819','834','00','005010X220A1','1983819','','2014-02-05','15:21:51',0,'2014-02-05 21:31:17',NULL,NULL),(15450,2631,'2470007','834','00','005010X220A1','2470007','','2014-01-15','18:54:40',0,'2014-01-17 03:36:09',NULL,NULL),(14566,2519,'2017841','834','00','005010X220A1','2017841','','2014-01-13','15:19:02',0,'2014-01-14 01:32:45',NULL,NULL),(5667,1053,'1680257','834','00','005010X220A1','1680257','','2013-12-24','22:50:45',0,'2013-12-26 01:51:56',NULL,NULL),(5501,1041,'1418608','834','00','005010X220A1','1418608','','2013-12-24','19:51:43',0,'2013-12-26 01:46:26',NULL,NULL),(20133,3772,'3567787','834','00','005010X220A1','3567787','','2014-02-19','15:54:53',0,'2014-02-20 03:58:51',NULL,NULL),(21008,3961,'3058979','834','00','005010X220A1','3058979','','2014-02-22','12:00:11',0,'2014-02-26 08:30:44',NULL,NULL),(21638,4070,'3476355','834','00','005010X220A1','3476355','','2014-02-27','11:37:54',0,'2014-02-28 07:30:30',NULL,NULL),(11574,1492,'1422357','834','00','005010X220A1','1422357','','2013-12-27','15:31:42',0,'2013-12-28 03:33:58',NULL,NULL),(17871,3293,'1694532','834','00','005010X220A1','1694532','','2014-02-05','16:07:55',0,'2014-02-05 21:30:16',NULL,NULL),(13302,2146,'0001','999','BE','005010X231A1','155725','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:17',NULL,NULL),(7386,1293,'1019077','834','00','005010X220A1','1019077','','2013-12-21','11:53:58',0,'2013-12-26 04:30:20',NULL,NULL),(3455,609,'393758','834','00','005010X220A1','393758','','2013-12-17','13:08:48',0,'2013-12-25 21:53:30',NULL,NULL),(18896,3501,'2469196','834','00','005010X220A1','2469196','','2014-02-11','09:18:37',0,'2014-02-11 21:02:32',NULL,NULL),(19447,3605,'3326103','834','00','005010X220A1','3326103','','2014-02-13','12:15:02',0,'2014-02-13 22:03:05',NULL,NULL),(23212,4347,'3330842','834','00','005010X220A1','3330842','','2014-03-07','14:38:25',0,'2014-03-07 21:31:54',NULL,NULL),(23441,4407,'3898394','834','00','005010X220A1','3898394','','2014-03-08','23:27:00',0,'2014-03-09 21:00:42',NULL,NULL),(16950,3115,'2301004','834','00','005010X220A1','2301004','','2014-01-29','16:37:02',0,'2014-01-29 21:00:23',NULL,NULL),(2447,421,'8648','834','00','005010X220A1','8648','','2013-12-06','14:02:33',0,'2013-12-25 20:18:46',NULL,NULL),(2679,502,'859506','834','00','005010X220A1','859506','','2013-12-21','21:33:45',0,'2013-12-25 21:16:31',NULL,NULL),(16493,3011,'1989761','834','00','005010X220A1','1989761','','2014-01-23','18:42:05',0,'2014-01-24 21:00:36',NULL,NULL),(4493,804,'374802','834','00','005010X220A1','374802','','2013-11-26','12:01:20',0,'2013-12-25 23:31:50',NULL,NULL),(11165,1440,'289748','834','00','005010X220A1','289748','','2013-12-23','15:05:53',0,'2013-12-26 13:16:28',NULL,NULL),(10539,1401,'323615','834','00','005010X220A1','323615','','2013-12-23','18:12:39',0,'2013-12-26 12:55:07',NULL,NULL),(20122,3772,'3289141','834','00','005010X220A1','3289141','','2014-02-19','10:09:47',0,'2014-02-20 03:53:16',NULL,NULL),(20656,3876,'2352778','834','00','005010X220A1','2352778','','2014-02-20','20:52:21',0,'2014-02-21 22:00:57',NULL,NULL),(17792,3270,'2324386','834','00','005010X220A1','2324386','','2014-02-03','21:59:30',0,'2014-02-04 21:01:27',NULL,NULL),(16071,2774,'2372742','834','00','005010X220A1','2372742','','2014-01-21','22:24:04',0,'2014-01-23 03:02:45',NULL,NULL),(14563,2519,'2438650','834','00','005010X220A1','2438650','','2014-01-13','14:45:08',0,'2014-01-14 01:32:42',NULL,NULL),(13711,2275,'1847046','834','00','005010X220A1','1847046','','2014-01-07','10:23:43',0,'2014-01-08 18:24:34',NULL,NULL),(2824,508,'820113','834','00','005010X220A1','820113','','2013-12-22','12:16:39',0,'2013-12-25 21:21:06',NULL,NULL),(7208,1241,'1075623','834','00','005010X220A1','1075623','','2013-12-18','09:20:42',0,'2013-12-26 04:06:53',NULL,NULL),(4831,881,'728656','834','00','005010X220A1','728656','','2013-12-01','15:42:50',0,'2013-12-26 00:02:51',NULL,NULL),(5072,936,'1164809','834','00','005010X220A1','1164809','','2013-12-11','14:36:11',0,'2013-12-26 00:48:18',NULL,NULL),(21933,4129,'3087863','834','00','005010X220A1','3087863','','2014-03-01','17:54:53',0,'2014-03-01 21:00:51',NULL,NULL),(13185,2029,'0001','999','BE','005010X231A1','556024','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:10',NULL,NULL),(1826,312,'91079','834','00','005010X220A1','91079','','2013-12-10','16:59:57',0,'2013-12-25 19:20:25',NULL,NULL),(4665,831,'1083636','834','00','005010X220A1','1083636','','2013-12-23','22:19:41',0,'2013-12-25 23:49:23',NULL,NULL),(11833,1541,'93975','834','00','005010X220A1','93975','','2013-12-28','20:30:03',1,'2013-12-29 11:14:09',NULL,NULL),(608,108,'973030','834','00','005010X220A1','973030','','2013-12-15','19:59:42',0,'2013-12-25 18:03:51',NULL,NULL),(10684,1403,'1602255','834','00','005010X220A1','1602255','','2013-12-22','23:36:27',0,'2013-12-26 12:59:56',NULL,NULL),(4706,834,'1394312','834','00','005010X220A1','1394312','','2013-12-24','01:05:16',0,'2013-12-25 23:50:50',NULL,NULL),(1068,211,'189303','834','00','005010X220A1','189303','','2013-11-29','15:09:46',0,'2013-12-25 18:30:52',NULL,NULL),(15118,2587,'1508709','834','00','005010X220A1','1508709','','2014-01-15','14:58:43',0,'2014-01-16 08:45:32',NULL,NULL),(16843,3092,'1732554','834','00','005010X220A1','1732554','','2014-01-27','20:15:59',0,'2014-01-28 21:00:34',NULL,NULL),(19166,3557,'2610807','834','00','005010X220A1','2610807','','2014-02-12','15:44:37',0,'2014-02-12 21:32:22',NULL,NULL),(20969,3956,'2972920','834','00','005010X220A1','2972920','','2014-02-21','23:46:59',0,'2014-02-26 08:30:07',NULL,NULL),(17425,3202,'2017230','834','00','005010X220A1','2017230','','2014-01-31','23:12:18',0,'2014-02-01 19:00:25',NULL,NULL),(17094,3141,'2219812','834','00','005010X220A1','2219812','','2014-01-29','18:12:46',0,'2014-01-29 21:01:55',NULL,NULL),(17053,3124,'1890642','834','00','005010X220A1','1890642','','2014-01-28','23:00:58',0,'2014-01-29 21:01:28',NULL,NULL),(16184,2876,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:21:00',1,'2014-01-23 04:25:25',NULL,NULL),(21163,3997,'3686871','834','00','005010X220A1','3686871','','2014-02-26','16:47:16',0,'2014-02-26 21:00:51',NULL,NULL),(21816,4094,'3227587','834','00','005010X220A1','3227587','','2014-02-27','18:50:32',0,'2014-02-28 21:31:32',NULL,NULL),(206,24,'749058','834','00','005010X220A1','749058','','2013-12-05','13:45:26',0,'2013-12-25 17:21:27',NULL,NULL),(18145,3342,'2731729','834','00','005010X220A1','2731729','','2014-02-06','16:17:57',0,'2014-02-06 21:01:50',NULL,NULL),(14054,2339,'1468493','834','00','005010X220A1','1468493','','2014-01-07','22:08:27',0,'2014-01-13 02:21:39',NULL,NULL),(1228,243,'1647242','834','00','005010X220A1','1647242','','2013-12-24','09:47:06',0,'2013-12-25 18:48:37',NULL,NULL),(13578,2254,'2099153','834','00','005010X220A1','2099153','','2014-01-05','16:35:05',1,'2014-01-07 10:21:56',NULL,NULL),(1974,326,'620557','834','00','005010X220A1','620557','','2013-12-09','16:05:33',0,'2013-12-25 19:33:55',NULL,NULL),(6273,1172,'339713','834','00','005010X220A1','339713','','2013-12-20','09:44:31',0,'2013-12-26 03:06:39',NULL,NULL),(2358,413,'902112','834','00','005010X220A1','902112','','2013-12-06','18:12:11',0,'2013-12-25 20:15:53',NULL,NULL),(2694,502,'460617','834','00','005010X220A1','460617','','2013-12-22','13:35:51',0,'2013-12-25 21:16:59',NULL,NULL),(22691,4259,'3022624','834','00','005010X220A1','3022624','','2014-03-05','09:34:56',0,'2014-03-05 21:32:21',NULL,NULL),(13345,2189,'0001','999','BE','005010X231A1','1003197','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:17',NULL,NULL),(96,4,'554796','834','00','005010X220A1','554796','','2013-12-05','11:52:48',0,'2013-12-25 17:17:54',NULL,NULL),(341,72,'1254058','834','00','005010X220A1','1254058','','2013-12-03','19:13:51',0,'2013-12-25 17:46:29',NULL,NULL),(365,72,'1019834','834','00','005010X220A1','1019834','','2013-12-04','11:43:24',0,'2013-12-25 17:47:14',NULL,NULL),(12626,1671,'1700501','834','00','005010X220A1','1700501','','2014-01-02','15:55:03',0,'2014-01-03 02:02:00',NULL,NULL),(1124,238,'879133','834','00','005010X220A1','879133','','2013-12-24','13:48:43',0,'2013-12-25 18:45:24',NULL,NULL),(11960,1580,'1612819','834','00','005010X220A1','1612819','','2013-12-30','10:56:55',0,'2014-01-01 12:00:33',NULL,NULL),(11464,1488,'1774380','834','00','005010X220A1','1774380','','2013-12-27','11:23:03',0,'2013-12-28 03:30:35',NULL,NULL),(18667,3467,'2857312','834','00','005010X220A1','2857312','','2014-02-10','12:17:43',0,'2014-02-10 21:31:50',NULL,NULL),(4811,866,'651267','834','00','005010X220A1','651267','','2013-11-30','19:50:58',0,'2013-12-26 00:02:11',NULL,NULL),(22135,4179,'2932606','834','00','005010X220A1','2932606','','2014-03-03','11:56:00',0,'2014-03-03 21:30:45',NULL,NULL),(22145,4179,'3496239','834','00','005010X220A1','3496239','','2014-03-03','14:04:12',0,'2014-03-03 21:30:52',NULL,NULL),(719,120,'786845','834','00','005010X220A1','786845','','2013-12-16','12:13:45',0,'2013-12-25 18:07:24',NULL,NULL),(17721,3261,'2217189','834','00','005010X220A1','2217189','','2014-02-04','14:33:11',0,'2014-02-04 21:00:42',NULL,NULL),(1169,239,'1846703','834','00','005010X220A1','1846703','','2013-12-24','13:04:10',0,'2013-12-25 18:46:46',NULL,NULL),(1288,243,'1494750','834','00','005010X220A1','1494750','','2013-12-24','17:53:39',0,'2013-12-25 18:50:25',NULL,NULL),(13346,2190,'0001','999','BE','005010X231A1','1197949','834','2013-12-27','16:55:00',0,'2014-01-05 17:26:20',NULL,NULL),(17417,3200,'2232446','834','00','005010X220A1','2232446','','2014-02-01','00:08:26',0,'2014-02-01 19:00:20',NULL,NULL),(16256,2948,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:03:00',0,'2014-01-23 07:30:02',NULL,NULL),(11167,1440,'849073','834','00','005010X220A1','849073','','2013-12-23','15:55:09',0,'2013-12-26 13:16:31',NULL,NULL),(19968,3746,'3238228','834','00','005010X220A1','3238228','','2014-02-18','12:42:35',0,'2014-02-18 22:00:10',NULL,NULL),(21117,3994,'3176772','834','00','005010X220A1','3176772','','2014-02-26','13:27:16',0,'2014-02-26 21:00:20',NULL,NULL),(22850,4279,'3058328','834','00','005010X220A1','3058328','','2014-03-06','16:36:33',0,'2014-03-06 21:01:39',NULL,NULL),(23081,4339,'2798238','834','00','005010X220A1','2798238','','2014-03-07','12:54:36',0,'2014-03-07 21:30:22',NULL,NULL),(23108,4341,'3898350','834','00','005010X220A1','3898350','','2014-03-07','14:53:23',0,'2014-03-07 21:30:40',NULL,NULL),(23530,4434,'3097282','834','00','005010X220A1','3097282','','2014-03-10','17:51:52',0,'2014-03-10 21:00:24',NULL,NULL),(771,144,'1258514','834','00','005010X220A1','1258514','','2013-10-29','07:34:43',0,'2013-12-25 18:09:05',NULL,NULL),(18603,3456,'2610712','834','00','005010X220A1','2610712','','2014-02-10','10:17:04',0,'2014-02-10 21:31:05',NULL,NULL),(1121,238,'267785','834','00','005010X220A1','267785','','2013-12-24','13:11:47',0,'2013-12-25 18:45:18',NULL,NULL),(6054,1161,'765478','834','00','005010X220A1','765478','','2013-11-10','16:00:30',0,'2013-12-26 02:46:43',NULL,NULL),(3371,587,'707532','834','00','005010X220A1','707532','','2013-12-17','13:32:46',0,'2013-12-25 21:50:47',NULL,NULL),(1628,281,'503640','834','00','005010X220A1','503640','','2013-11-19','23:05:51',0,'2013-12-25 19:01:53',NULL,NULL),(2138,360,'270649','834','00','005010X220A1','270649','','2013-12-02','10:19:35',0,'2013-12-25 19:46:04',NULL,NULL),(20072,3758,'3472458','834','00','005010X220A1','3472458','','2014-02-18','16:27:35',0,'2014-02-18 22:01:25',NULL,NULL),(20613,3871,'3087604','834','00','005010X220A1','3087604','','2014-02-21','09:27:09',0,'2014-02-21 22:00:26',NULL,NULL),(22973,4315,'3225308','834','00','005010X220A1','3225308','','2014-03-06','12:51:39',0,'2014-03-06 21:30:13',NULL,NULL),(23470,4419,'2825069','834','00','005010X220A1','2825069','','2014-03-09','12:57:48',0,'2014-03-09 21:01:09',NULL,NULL),(13444,2223,'1516067','834','00','005010X220A1','1516067','','2014-01-06','11:50:36',0,'2014-01-07 04:02:31',NULL,NULL),(10430,1400,'1040866','834','00','005010X220A1','1040866','','2013-12-23','11:09:51',0,'2013-12-26 12:51:37',NULL,NULL),(16485,3010,'1698402','834','00','005010X220A1','1698402','','2014-01-24','02:34:38',0,'2014-01-24 21:00:32',NULL,NULL),(2188,363,'572398','834','00','005010X220A1','572398','','2013-12-02','13:45:31',0,'2013-12-25 19:47:45',NULL,NULL),(12196,1608,'1857369','834','00','005010X220A1','1857369','','2013-12-30','12:03:13',0,'2014-01-01 12:09:10',NULL,NULL),(7195,1239,'771326','834','00','005010X220A1','771326','','2013-12-18','16:51:30',0,'2013-12-26 04:06:28',NULL,NULL),(20020,3750,'3095394','834','00','005010X220A1','3095394','','2014-02-18','11:37:57',0,'2014-02-18 22:00:46',NULL,NULL),(21397,4025,'3729778','834','00','005010X220A1','3729778','','2014-02-26','18:22:07',0,'2014-02-28 06:30:34',NULL,NULL),(21441,4027,'3558121','834','00','005010X220A1','3558121','','2014-02-27','15:52:05',0,'2014-02-28 06:30:55',NULL,NULL),(22035,4163,'3646912','834','00','005010X220A1','3646912','','2014-03-03','08:23:04',0,'2014-03-03 21:00:01',NULL,NULL),(19328,3583,'3149926','834','00','005010X220A1','3149926','','2014-02-13','12:50:32',0,'2014-02-13 22:01:35',NULL,NULL),(615,108,'311622','834','00','005010X220A1','311622','','2013-12-15','23:43:44',0,'2013-12-25 18:04:04',NULL,NULL),(3640,622,'100118','834','00','005010X220A1','100118','','2013-12-12','15:50:03',0,'2013-12-25 22:05:36',NULL,NULL),(11864,1555,'917384','834','00','005010X220A1','917384','','2013-12-28','20:29:36',1,'2013-12-29 11:15:17',NULL,NULL),(7381,1293,'824114','834','00','005010X220A1','824114','','2013-12-20','22:20:35',0,'2013-12-26 04:30:11',NULL,NULL),(7385,1293,'1256939','834','00','005010X220A1','1256939','','2013-12-21','11:36:38',0,'2013-12-26 04:30:19',NULL,NULL),(19453,3608,'2803113','834','00','005010X220A1','2803113','','2014-02-13','15:10:05',0,'2014-02-13 22:03:10',NULL,NULL),(18773,3486,'1762766','834','00','005010X220A1','1762766','','2014-02-11','01:56:57',0,'2014-02-11 21:00:55',NULL,NULL),(13708,2275,'2487298','834','00','005010X220A1','2487298','','2014-01-06','18:43:51',0,'2014-01-08 18:24:32',NULL,NULL),(472,90,'189376','834','00','005010X220A1','189376','','2013-12-03','21:15:26',0,'2013-12-25 17:50:44',NULL,NULL),(5224,954,'481694','834','00','005010X220A1','481694','','2013-12-10','22:22:55',0,'2013-12-26 00:53:12',NULL,NULL),(5100,940,'1037584','834','00','005010X220A1','1037584','','2013-12-11','13:05:23',0,'2013-12-26 00:49:09',NULL,NULL),(12014,1583,'2270065','834','00','005010X220A1','2270065','','2013-12-30','10:32:41',0,'2014-01-01 12:02:36',NULL,NULL),(1221,243,'51500','834','00','005010X220A1','51500','','2013-12-24','09:00:05',0,'2013-12-25 18:48:24',NULL,NULL),(4567,825,'1631727','834','00','005010X220A1','1631727','','2013-12-24','01:04:18',0,'2013-12-25 23:46:14',NULL,NULL),(4471,802,'72689','834','00','005010X220A1','72689','','2013-11-25','19:22:23',0,'2013-12-25 23:31:05',NULL,NULL),(3480,615,'137538','834','00','005010X220A1','137538','','2013-12-12','09:08:47',0,'2013-12-25 22:00:32',NULL,NULL),(21455,4028,'3404862','834','00','005010X220A1','3404862','','2014-02-26','23:56:01',0,'2014-02-28 06:31:01',NULL,NULL),(23325,4384,'3008477','834','00','005010X220A1','3008477','','2014-03-08','08:45:24',0,'2014-03-08 21:30:40',NULL,NULL),(18678,3467,'1934402','834','00','005010X220A1','1934402','','2014-02-10','17:26:07',0,'2014-02-10 21:31:58',NULL,NULL),(15146,2588,'1658172','834','00','005010X220A1','1658172','','2014-01-14','23:51:55',0,'2014-01-16 08:45:52',NULL,NULL),(15168,2590,'2420522','834','00','005010X220A1','2420522','','2014-01-14','19:27:04',0,'2014-01-16 08:46:06',NULL,NULL),(18254,3376,'2366312','834','00','005010X220A1','2366312','','2014-02-07','20:40:36',0,'2014-02-08 19:00:06',NULL,NULL),(16120,2812,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:39:00',1,'2014-01-23 03:46:10',NULL,NULL),(368,72,'118037','834','00','005010X220A1','118037','','2013-12-04','17:35:30',0,'2013-12-25 17:47:19',NULL,NULL),(3822,670,'594663','834','00','005010X220A1','594663','','2013-12-08','11:37:53',0,'2013-12-25 22:17:07',NULL,NULL),(3029,544,'572687','834','00','005010X220A1','572687','','2013-12-12','23:06:14',0,'2013-12-25 21:33:59',NULL,NULL),(1013,189,'985118','834','00','005010X220A1','985118','','2013-12-03','00:42:57',0,'2013-12-25 18:20:40',NULL,NULL),(10674,1403,'108870','834','00','005010X220A1','108870','','2013-12-22','19:27:04',0,'2013-12-26 12:59:32',NULL,NULL),(1627,281,'76556','834','00','005010X220A1','76556','','2013-11-19','23:05:51',0,'2013-12-25 19:01:52',NULL,NULL),(491,102,'956699','834','00','005010X220A1','956699','','2013-12-15','20:26:00',0,'2013-12-25 18:00:11',NULL,NULL),(600,107,'766056','834','00','005010X220A1','766056','','2013-12-16','13:09:32',0,'2013-12-25 18:03:35',NULL,NULL),(19354,3585,'2662951','834','00','005010X220A1','2662951','','2014-02-13','10:23:45',0,'2014-02-13 22:01:55',NULL,NULL),(5038,935,'471414','834','00','005010X220A1','471414','','2013-12-11','15:05:38',0,'2013-12-26 00:47:11',NULL,NULL),(1585,278,'710485','834','00','005010X220A1','710485','','2013-11-20','10:43:17',0,'2013-12-25 19:00:47',NULL,NULL),(2955,541,'1260213','834','00','005010X220A1','1260213','','2013-12-13','10:43:25',0,'2013-12-25 21:31:46',NULL,NULL),(6292,1172,'281727','834','00','005010X220A1','281727','','2013-12-20','18:11:52',0,'2013-12-26 03:07:10',NULL,NULL),(18583,3453,'2825279','834','00','005010X220A1','2825279','','2014-02-10','16:03:35',0,'2014-02-10 21:30:52',NULL,NULL),(15601,2661,'1924809','834','00','005010X220A1','1924809','','2014-01-17','14:27:33',0,'2014-01-20 08:06:26',NULL,NULL),(15612,2666,'1873003','834','00','005010X220A1','1873003','','2014-01-17','12:13:13',0,'2014-01-20 08:06:34',NULL,NULL),(20259,3795,'3335583','834','00','005010X220A1','3335583','','2014-02-18','22:31:44',0,'2014-02-20 04:33:53',NULL,NULL),(21153,3997,'3050885','834','00','005010X220A1','3050885','','2014-02-26','11:41:39',0,'2014-02-26 21:00:45',NULL,NULL),(22548,4248,'2646484','834','00','005010X220A1','2646484','','2014-03-05','09:45:46',0,'2014-03-05 21:30:42',NULL,NULL),(23387,4401,'2822856','834','00','005010X220A1','2822856','','2014-03-09','12:33:02',0,'2014-03-09 21:00:01',NULL,NULL),(18921,3517,'2444657','834','00','005010X220A1','2444657','','2014-02-11','17:36:40',0,'2014-02-11 21:02:54',NULL,NULL),(14586,2521,'1977216','834','00','005010X220A1','1977216','','2014-01-13','11:16:45',0,'2014-01-14 01:32:57',NULL,NULL),(2907,540,'901143','834','00','005010X220A1','901143','','2013-12-13','17:20:07',0,'2013-12-25 21:30:11',NULL,NULL),(2413,415,'1062790','834','00','005010X220A1','1062790','','2013-12-06','10:32:40',0,'2013-12-25 20:17:39',NULL,NULL),(2082,344,'350156','834','00','005010X220A1','350156','','2013-12-09','11:40:45',0,'2013-12-25 19:37:28',NULL,NULL),(22296,4201,'2606296','834','00','005010X220A1','2606296','','2014-03-04','09:33:00',0,'2014-03-04 21:00:56',NULL,NULL),(5156,944,'238692','834','00','005010X220A1','238692','','2013-12-10','20:00:19',0,'2013-12-26 00:50:59',NULL,NULL),(7510,1300,'127698','834','00','005010X220A1','127698','','2013-12-21','10:14:46',0,'2013-12-26 04:34:20',NULL,NULL),(19339,3583,'1771405','834','00','005010X220A1','1771405','','2014-02-13','14:35:57',0,'2014-02-13 22:01:43',NULL,NULL),(20419,3835,'3168739','834','00','005010X220A1','3168739','','2014-02-20','16:08:20',0,'2014-02-20 21:30:18',NULL,NULL),(23385,4401,'3573565','834','00','005010X220A1','3573565','','2014-03-08','22:44:06',0,'2014-03-09 21:00:00',NULL,NULL),(11583,1492,'684522','834','00','005010X220A1','684522','','2013-12-27','16:23:59',0,'2013-12-28 03:34:11',NULL,NULL),(361,72,'324252','834','00','005010X220A1','324252','','2013-12-04','11:09:46',0,'2013-12-25 17:47:07',NULL,NULL),(13704,2274,'1992129','834','00','005010X220A1','1992129','','2014-01-07','15:25:28',0,'2014-01-08 18:24:31',NULL,NULL),(174,16,'519633','834','00','005010X220A1','519633','','2013-12-04','21:18:47',0,'2013-12-25 17:20:23',NULL,NULL),(19204,3575,'2543420','834','00','005010X220A1','2543420','','2014-02-13','12:03:11',0,'2014-02-13 21:30:13',NULL,NULL),(2206,365,'870831','834','00','005010X220A1','870831','','2013-12-02','17:28:07',0,'2013-12-25 19:48:22',NULL,NULL),(10442,1400,'1684366','834','00','005010X220A1','1684366','','2013-12-23','12:04:59',0,'2013-12-26 12:52:02',NULL,NULL),(17348,3181,'1945312','834','00','005010X220A1','1945312','','2014-01-31','10:38:54',0,'2014-01-31 21:01:16',NULL,NULL),(4500,806,'165429','834','00','005010X220A1','165429','','2013-11-25','20:27:01',0,'2013-12-25 23:32:04',NULL,NULL),(4309,749,'991944','834','00','005010X220A1','991944','','2013-12-19','17:37:50',0,'2013-12-25 23:09:32',NULL,NULL),(15613,2666,'1578214','834','00','005010X220A1','1578214','','2014-01-17','12:17:16',0,'2014-01-20 08:06:35',NULL,NULL),(23038,4330,'3391167','834','00','005010X220A1','3391167','','2014-03-07','11:40:18',0,'2014-03-07 21:00:29',NULL,NULL),(14522,2518,'1817325','834','00','005010X220A1','1817325','','2014-01-12','19:39:12',0,'2014-01-14 01:32:17',NULL,NULL),(18091,3325,'2904194','834','00','005010X220A1','2904194','','2014-02-06','11:26:21',0,'2014-02-06 21:01:09',NULL,NULL),(20131,3772,'3179070','834','00','005010X220A1','3179070','','2014-02-19','15:00:24',0,'2014-02-20 03:58:05',NULL,NULL),(21104,3994,'2675181','834','00','005010X220A1','2675181','','2014-02-26','08:16:57',0,'2014-02-26 21:00:11',NULL,NULL),(59,3,'572463','834','00','005010X220A1','572463','','2013-12-05','00:17:19',0,'2013-12-25 17:16:46',NULL,NULL),(18872,3493,'2774000','834','00','005010X220A1','2774000','','2014-02-11','17:43:17',0,'2014-02-11 21:02:11',NULL,NULL),(11844,1545,'1816778','834','00','005010X220A1','1816778','','2013-12-28','20:19:26',1,'2013-12-29 11:14:32',NULL,NULL),(4432,794,'68283','834','00','005010X220A1','68283','','2013-11-05','23:48:32',0,'2013-12-25 23:17:07',NULL,NULL),(5788,1075,'796980','834','00','005010X220A1','796980','','2013-12-14','13:45:37',0,'2013-12-26 02:03:10',NULL,NULL),(1257,243,'1526132','834','00','005010X220A1','1526132','','2013-12-24','12:37:45',0,'2013-12-25 18:49:24',NULL,NULL),(5316,994,'163094','834','00','005010X220A1','163094','','2013-11-04','19:57:53',0,'2013-12-26 01:02:02',NULL,NULL),(19272,3582,'2968879','834','00','005010X220A1','2968879','','2014-02-12','21:35:41',0,'2014-02-13 22:00:52',NULL,NULL),(16595,3043,'2345292','834','00','005010X220A1','2345292','','2014-01-25','15:05:07',0,'2014-01-25 19:00:19',NULL,NULL),(2767,506,'1056051','834','00','005010X220A1','1056051','','2013-12-21','19:41:11',0,'2013-12-25 21:19:15',NULL,NULL),(15503,2637,'2593893','834','00','005010X220A1','2593893','','2014-01-15','23:19:52',0,'2014-01-17 03:36:32',NULL,NULL),(2960,541,'352623','834','00','005010X220A1','352623','','2013-12-13','11:39:02',0,'2013-12-25 21:31:54',NULL,NULL),(7689,1329,'77905','834','00','005010X220A1','77905','','2013-11-15','16:31:53',0,'2013-12-26 04:45:04',NULL,NULL),(10952,1410,'904064','834','00','005010X220A1','904064','','2013-12-23','17:33:00',0,'2013-12-26 13:09:16',NULL,NULL),(13130,1974,'0001','999','BE','005010X231A1','1159453','834','2013-12-28','12:25:00',0,'2014-01-05 16:55:02',NULL,NULL),(15372,2624,'1458804','834','00','005010X220A1','1458804','','2014-01-15','22:58:34',0,'2014-01-17 03:35:33',NULL,NULL),(15260,2601,'2189035','834','00','005010X220A1','2189035','','2014-01-15','14:21:19',0,'2014-01-16 08:47:03',NULL,NULL),(20076,3760,'3637692','834','00','005010X220A1','3637692','','2014-02-18','15:44:41',0,'2014-02-18 22:01:28',NULL,NULL),(18584,3453,'2664167','834','00','005010X220A1','2664167','','2014-02-10','16:09:16',0,'2014-02-10 21:30:52',NULL,NULL),(1571,277,'276043','834','00','005010X220A1','276043','','2013-11-20','09:07:17',0,'2013-12-25 19:00:18',NULL,NULL),(18412,3419,'2683154','834','00','005010X220A1','2683154','','2014-02-09','17:26:34',0,'2014-02-09 19:00:44',NULL,NULL),(18113,3330,'2531566','834','00','005010X220A1','2531566','','2014-02-05','22:25:19',0,'2014-02-06 21:01:26',NULL,NULL),(17706,3261,'1617494','834','00','005010X220A1','1617494','','2014-02-03','20:57:01',0,'2014-02-04 21:00:33',NULL,NULL),(4934,917,'509601','834','00','005010X220A1','509601','','2013-10-16','20:31:11',0,'2013-12-26 00:31:13',NULL,NULL),(17443,3205,'1822990','834','00','005010X220A1','1822990','','2014-02-01','15:26:13',0,'2014-02-01 19:00:36',NULL,NULL),(16805,3089,'2638302','834','00','005010X220A1','2638302','','2014-01-28','11:10:57',0,'2014-01-28 21:00:11',NULL,NULL),(11933,1570,'1973037','834','00','005010X220A1','1973037','','2013-12-29','17:06:15',0,'2013-12-30 00:02:04',NULL,NULL),(15320,2622,'1488025','834','00','005010X220A1','1488025','','2014-01-16','10:49:21',0,'2014-01-17 03:35:10',NULL,NULL),(417,77,'278816','834','00','005010X220A1','278816','','2013-12-03','21:01:00',0,'2013-12-25 17:48:55',NULL,NULL),(874,177,'1326502','834','00','005010X220A1','1326502','','2013-12-03','02:04:52',0,'2013-12-25 18:16:25',NULL,NULL),(16996,3118,'1494335','834','00','005010X220A1','1494335','','2014-01-29','10:26:53',0,'2014-01-29 21:00:52',NULL,NULL),(14116,2347,'1697971','834','00','005010X220A1','1697971','','2014-01-08','13:49:16',0,'2014-01-13 02:22:21',NULL,NULL),(5851,1094,'1250242','834','00','005010X220A1','1250242','','2013-11-23','15:27:04',0,'2013-12-26 02:16:10',NULL,NULL),(2331,411,'353370','834','00','005010X220A1','353370','','2013-10-08','12:05:29',0,'2013-12-25 20:02:18',NULL,NULL),(20911,3931,'2587266','834','00','005010X220A1','2587266','','2014-02-23','13:35:43',0,'2014-02-26 08:00:10',NULL,NULL),(22011,4150,'3130481','834','00','005010X220A1','3130481','','2014-03-02','13:46:57',0,'2014-03-03 01:00:30',NULL,NULL),(19907,3722,'2271259','834','00','005010X220A1','2271259','','2014-02-17','11:05:42',0,'2014-02-17 19:00:02',NULL,NULL),(5676,1055,'1605143','834','00','005010X220A1','1605143','','2013-12-24','22:00:08',0,'2013-12-26 01:52:16',NULL,NULL),(15335,2622,'1442845','834','00','005010X220A1','1442845','','2014-01-16','18:21:09',0,'2014-01-17 03:35:16',NULL,NULL),(14638,2527,'2400460','834','00','005010X220A1','2400460','','2014-01-13','14:58:28',0,'2014-01-14 01:33:30',NULL,NULL),(11988,1580,'2216374','834','00','005010X220A1','2216374','','2013-12-30','17:57:39',0,'2014-01-01 12:01:38',NULL,NULL),(52,3,'197251','834','00','005010X220A1','197251','','2013-12-04','22:47:20',0,'2013-12-25 17:16:33',NULL,NULL),(19824,3679,'3452152','834','00','005010X220A1','3452152','','2014-02-15','15:46:31',0,'2014-02-15 22:01:42',NULL,NULL),(19787,3675,'3249393','834','00','005010X220A1','3249393','','2014-02-15','14:42:57',0,'2014-02-15 22:01:11',NULL,NULL),(4133,733,'282793','834','00','005010X220A1','282793','','2013-12-19','15:54:30',0,'2013-12-25 23:04:12',NULL,NULL),(19094,3543,'3075742','834','00','005010X220A1','3075742','','2014-02-12','11:36:13',0,'2014-02-12 21:31:34',NULL,NULL),(16037,2771,'1777443','834','00','005010X220A1','1777443','','2014-01-21','20:42:14',0,'2014-01-23 03:02:29',NULL,NULL),(14736,2550,'1876811','834','00','005010X220A1','1876811','','2014-01-14','15:20:49',0,'2014-01-15 02:06:18',NULL,NULL),(14374,2405,'1895262','834','00','005010X220A1','1895262','','2014-01-12','10:58:46',0,'2014-01-13 03:01:43',NULL,NULL),(13873,2311,'1722233','834','00','005010X220A1','1722233','','2014-01-09','17:22:24',0,'2014-01-13 02:19:27',NULL,NULL),(22708,4265,'3057194','834','00','005010X220A1','3057194','','2014-03-05','11:22:24',0,'2014-03-05 21:32:34',NULL,NULL),(22831,4278,'3819163','834','00','005010X220A1','3819163','','2014-03-06','16:35:22',0,'2014-03-06 21:01:25',NULL,NULL),(23204,4347,'3424227','834','00','005010X220A1','3424227','','2014-03-07','10:39:38',0,'2014-03-07 21:31:49',NULL,NULL),(41,2,'453580','834','00','005010X220A1','453580','','2013-12-04','19:56:30',0,'2013-12-25 17:16:12',NULL,NULL),(13097,1941,'0001','999','BE','005010X231A1','937485','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:30',NULL,NULL),(19729,3672,'2654157','834','00','005010X220A1','2654157','','2014-02-15','15:27:32',0,'2014-02-15 22:00:29',NULL,NULL),(18850,3491,'1928906','834','00','005010X220A1','1928906','','2014-02-11','13:09:21',0,'2014-02-11 21:01:52',NULL,NULL),(4331,753,'641598','834','00','005010X220A1','641598','','2013-12-19','17:49:58',0,'2013-12-25 23:10:10',NULL,NULL),(18845,3491,'2893075','834','00','005010X220A1','2893075','','2014-02-11','12:03:35',0,'2014-02-11 21:01:48',NULL,NULL),(5262,970,'200700','834','00','005010X220A1','200700','','2013-11-12','13:10:31',0,'2013-12-26 01:00:05',NULL,NULL),(21019,3968,'2615720','834','00','005010X220A1','2615720','','2014-02-22','12:18:29',0,'2014-02-26 08:30:54',NULL,NULL),(21265,4000,'2647366','834','00','005010X220A1','2647366','','2014-02-26','16:44:50',0,'2014-02-26 21:01:59',NULL,NULL),(23064,4339,'3194886','834','00','005010X220A1','3194886','','2014-03-07','00:30:53',0,'2014-03-07 21:30:08',NULL,NULL),(820,164,'381613','834','00','005010X220A1','381613','','2013-11-11','14:25:20',0,'2013-12-25 18:10:54',NULL,NULL),(17002,3118,'1922163','834','00','005010X220A1','1922163','','2014-01-29','11:58:54',0,'2014-01-29 21:00:55',NULL,NULL),(15671,2686,'1506122','834','00','005010X220A1','1506122','','2014-01-18','12:39:21',0,'2014-01-21 08:44:39',NULL,NULL),(10513,1401,'60022','834','00','005010X220A1','60022','','2013-12-22','19:57:48',0,'2013-12-26 12:54:14',NULL,NULL),(7561,1301,'976024','834','00','005010X220A1','976024','','2013-12-21','11:43:56',0,'2013-12-26 04:36:01',NULL,NULL),(7311,1263,'719829','834','00','005010X220A1','719829','','2013-12-18','13:14:28',0,'2013-12-26 04:10:02',NULL,NULL),(13938,2317,'2146947','834','00','005010X220A1','2146947','','2014-01-09','17:01:24',0,'2014-01-13 02:20:12',NULL,NULL),(3392,588,'279222','834','00','005010X220A1','279222','','2013-12-17','11:19:24',0,'2013-12-25 21:51:26',NULL,NULL),(1093,222,'26880','834','00','005010X220A1','26880','','2013-11-03','23:06:50',0,'2013-12-25 18:31:45',NULL,NULL),(3858,689,'760720','834','00','005010X220A1','760720','','2013-10-10','11:28:34',0,'2013-12-25 22:30:53',NULL,NULL),(1349,245,'548296','834','00','005010X220A1','548296','','2013-12-24','13:13:47',0,'2013-12-25 18:52:23',NULL,NULL),(22856,4280,'2709184','834','00','005010X220A1','2709184','','2014-03-05','23:21:04',0,'2014-03-06 21:01:44',NULL,NULL),(23097,4339,'3075065','834','00','005010X220A1','3075065','','2014-03-07','17:28:21',0,'2014-03-07 21:30:32',NULL,NULL),(751,135,'787942','834','00','005010X220A1','787942','','2013-12-16','16:04:03',0,'2013-12-25 18:08:24',NULL,NULL),(20142,3772,'2633033','834','00','005010X220A1','2633033','','2014-02-19','17:28:21',0,'2014-02-20 04:01:42',NULL,NULL),(4833,883,'55472','834','00','005010X220A1','55472','','2013-11-20','20:40:41',0,'2013-12-26 00:15:05',NULL,NULL),(18289,3380,'2409990','834','00','005010X220A1','2409990','','2014-02-07','19:50:49',0,'2014-02-08 19:00:27',NULL,NULL),(15600,2661,'1921939','834','00','005010X220A1','1921939','','2014-01-17','11:38:16',0,'2014-01-20 08:06:26',NULL,NULL),(7240,1243,'435514','834','00','005010X220A1','435514','','2013-12-17','19:31:33',0,'2013-12-26 04:07:56',NULL,NULL),(13879,2312,'2027548','834','00','005010X220A1','2027548','','2014-01-09','10:47:03',0,'2014-01-13 02:19:32',NULL,NULL),(11212,1454,'2019818','834','00','005010X220A1','2019818','','2013-12-26','09:38:18',0,'2013-12-27 02:00:49',NULL,NULL),(21036,3977,'2823517','834','00','005010X220A1','2823517','','2014-02-24','00:46:32',0,'2014-02-26 09:30:15',NULL,NULL),(101,4,'496304','834','00','005010X220A1','496304','','2013-12-05','15:16:36',0,'2013-12-25 17:18:04',NULL,NULL),(421,77,'251323','834','00','005010X220A1','251323','','2013-12-04','13:10:03',0,'2013-12-25 17:49:03',NULL,NULL),(19715,3672,'2655315','834','00','005010X220A1','2655315','','2014-02-14','18:19:43',0,'2014-02-15 22:00:18',NULL,NULL),(4762,859,'284284','834','00','005010X220A1','284284','','2013-12-01','17:54:23',0,'2013-12-26 00:00:43',NULL,NULL),(4707,834,'532802','834','00','005010X220A1','532802','','2013-12-24','02:37:08',0,'2013-12-25 23:50:52',NULL,NULL),(969,182,'405382','834','00','005010X220A1','405382','','2013-12-03','16:22:05',0,'2013-12-25 18:19:15',NULL,NULL),(19560,3626,'3141145','834','00','005010X220A1','3141145','','2014-02-14','10:14:40',0,'2014-02-14 21:31:09',NULL,NULL),(19165,3557,'2318614','834','00','005010X220A1','2318614','','2014-02-12','15:23:39',0,'2014-02-12 21:32:21',NULL,NULL),(4097,733,'358195','834','00','005010X220A1','358195','','2013-12-19','10:53:39',0,'2013-12-25 23:03:10',NULL,NULL),(18255,3376,'2528084','834','00','005010X220A1','2528084','','2014-02-07','22:12:50',0,'2014-02-08 19:00:07',NULL,NULL),(6420,1203,'1255110','834','00','005010X220A1','1255110','','2013-11-21','18:57:19',0,'2013-12-26 03:15:09',NULL,NULL),(17565,3236,'1962153','834','00','005010X220A1','1962153','','2014-02-03','11:53:25',0,'2014-02-03 21:00:35',NULL,NULL),(12669,1673,'2152641','834','00','005010X220A1','2152641','','2014-01-02','16:15:11',0,'2014-01-03 02:03:39',NULL,NULL),(13069,1913,'0001','999','BE','005010X231A1','606591','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:12',NULL,NULL),(13725,2275,'1977045','834','00','005010X220A1','1977045','','2014-01-06','20:37:43',0,'2014-01-08 18:24:40',NULL,NULL),(13999,2332,'2428045','834','00','005010X220A1','2428045','','2014-01-09','16:29:12',0,'2014-01-13 02:20:57',NULL,NULL),(14443,2464,'0001','999','BE','005010X231A1','193275','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:16',NULL,NULL),(21963,4142,'3164315','834','00','005010X220A1','3164315','','2014-03-02','13:17:10',0,'2014-03-03 01:00:03',NULL,NULL),(22263,4200,'3147974','834','00','005010X220A1','3147974','','2014-03-04','11:22:05',0,'2014-03-04 21:00:31',NULL,NULL),(22494,4245,'3150587','834','00','005010X220A1','3150587','','2014-03-05','17:53:00',0,'2014-03-05 21:00:33',NULL,NULL),(19459,3612,'2433381','834','00','005010X220A1','2433381','','2014-02-13','15:05:39',0,'2014-02-13 22:03:15',NULL,NULL),(13414,2222,'2247050','834','00','005010X220A1','2247050','','2014-01-06','13:11:01',0,'2014-01-07 04:01:22',NULL,NULL),(4198,735,'757800','834','00','005010X220A1','757800','','2013-12-18','20:26:55',0,'2013-12-25 23:06:11',NULL,NULL),(7414,1295,'1128873','834','00','005010X220A1','1128873','','2013-12-20','23:49:50',0,'2013-12-26 04:31:19',NULL,NULL),(22026,4157,'2804860','834','00','005010X220A1','2804860','','2014-03-02','15:29:39',0,'2014-03-03 01:00:39',NULL,NULL),(404,76,'441033','834','00','005010X220A1','441033','','2013-12-04','14:03:10',0,'2013-12-25 17:48:30',NULL,NULL),(13569,2254,'1498449','834','00','005010X220A1','1498449','','2014-01-05','11:20:05',1,'2014-01-07 10:21:31',NULL,NULL),(11573,1492,'2097571','834','00','005010X220A1','2097571','','2013-12-27','15:15:21',0,'2013-12-28 03:33:56',NULL,NULL),(11428,1474,'400375','834','00','005010X220A1','400375','','2013-12-26','12:35:46',0,'2013-12-27 02:07:28',NULL,NULL),(5522,1041,'1622866','834','00','005010X220A1','1622866','','2013-12-24','21:39:13',0,'2013-12-26 01:47:05',NULL,NULL),(20159,3778,'3351296','834','00','005010X220A1','3351296','','2014-02-18','20:59:48',0,'2014-02-20 04:06:22',NULL,NULL),(20018,3750,'2333408','834','00','005010X220A1','2333408','','2014-02-18','11:20:33',0,'2014-02-18 22:00:45',NULL,NULL),(18383,3407,'2256181','834','00','005010X220A1','2256181','','2014-02-09','15:39:08',0,'2014-02-09 19:00:23',NULL,NULL),(1730,293,'492924','834','00','005010X220A1','492924','','2013-12-10','10:39:34',0,'2013-12-25 19:17:23',NULL,NULL),(16939,3115,'1490659','834','00','005010X220A1','1490659','','2014-01-29','12:10:27',0,'2014-01-29 21:00:15',NULL,NULL),(14017,2337,'1825915','834','00','005010X220A1','1825915','','2014-01-08','09:20:11',0,'2014-01-13 02:21:17',NULL,NULL),(15473,2634,'2548949','834','00','005010X220A1','2548949','','2014-01-15','23:53:10',0,'2014-01-17 03:36:19',NULL,NULL),(1993,328,'173288','834','00','005010X220A1','173288','','2013-12-09','16:03:01',0,'2013-12-25 19:34:35',NULL,NULL),(19584,3629,'2140225','834','00','005010X220A1','2140225','','2014-02-14','12:11:01',0,'2014-02-14 21:31:25',NULL,NULL),(18566,3453,'3037606','834','00','005010X220A1','3037606','','2014-02-10','11:29:23',0,'2014-02-10 21:30:40',NULL,NULL),(2796,506,'373363','834','00','005010X220A1','373363','','2013-12-22','11:24:02',0,'2013-12-25 21:20:13',NULL,NULL),(4444,801,'1039965','834','00','005010X220A1','1039965','','2013-11-25','18:38:24',0,'2013-12-25 23:30:12',NULL,NULL),(17944,3299,'2061527','834','00','005010X220A1','2061527','','2014-02-05','10:25:49',0,'2014-02-05 21:30:52',NULL,NULL),(12030,1583,'1558592','834','00','005010X220A1','1558592','','2013-12-30','14:07:54',0,'2014-01-01 12:03:13',NULL,NULL),(16529,3017,'2005499','834','00','005010X220A1','2005499','','2014-01-24','10:47:44',0,'2014-01-24 21:01:00',NULL,NULL),(15021,2584,'1703131','834','00','005010X220A1','1703131','','2014-01-15','11:09:37',0,'2014-01-16 08:44:30',NULL,NULL),(15992,2765,'1453868','834','00','005010X220A1','1453868','','2014-01-22','12:11:55',0,'2014-01-23 03:02:09',NULL,NULL),(15539,2654,'1578221','834','00','005010X220A1','1578221','','2014-01-17','16:15:19',0,'2014-01-20 08:05:40',NULL,NULL),(21111,3994,'2844459','834','00','005010X220A1','2844459','','2014-02-26','11:34:03',0,'2014-02-26 21:00:16',NULL,NULL),(535,102,'915652','834','00','005010X220A1','915652','','2013-12-16','16:13:16',0,'2013-12-25 18:01:32',NULL,NULL),(18314,3384,'2228586','834','00','005010X220A1','2228586','','2014-02-08','11:43:34',0,'2014-02-08 19:00:44',NULL,NULL),(6177,1167,'393951','834','00','005010X220A1','393951','','2013-12-20','16:17:36',0,'2013-12-26 03:03:36',NULL,NULL),(15096,2585,'2337058','834','00','005010X220A1','2337058','','2014-01-15','17:50:05',0,'2014-01-16 08:45:16',NULL,NULL),(14125,2351,'2409204','834','00','005010X220A1','2409204','','2014-01-08','00:22:05',0,'2014-01-13 02:22:26',NULL,NULL),(13072,1916,'0001','999','BE','005010X231A1','247699','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:21',NULL,NULL),(1671,290,'616398','834','00','005010X220A1','616398','','2013-12-10','10:49:14',0,'2013-12-25 19:15:34',NULL,NULL),(2328,409,'353369','834','00','005010X220A1','353369','','2013-10-08','11:51:31',0,'2013-12-25 20:02:12',NULL,NULL),(3609,619,'867744','834','00','005010X220A1','867744','','2013-12-12','14:56:42',0,'2013-12-25 22:04:37',NULL,NULL),(20954,3949,'2597283','834','00','005010X220A1','2597283','','2014-02-24','17:00:09',0,'2014-02-26 08:00:44',NULL,NULL),(21916,4127,'3569461','834','00','005010X220A1','3569461','','2014-03-01','14:37:07',0,'2014-03-01 21:00:39',NULL,NULL),(22288,4200,'2748429','834','00','005010X220A1','2748429','','2014-03-04','17:05:08',0,'2014-03-04 21:00:49',NULL,NULL),(23092,4339,'3894474','834','00','005010X220A1','3894474','','2014-03-07','15:40:34',0,'2014-03-07 21:30:29',NULL,NULL),(16268,2960,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:02:00',0,'2014-01-23 09:45:26',NULL,NULL),(7168,1238,'299404','834','00','005010X220A1','299404','','2013-12-18','12:30:07',0,'2013-12-26 04:05:37',NULL,NULL),(15550,2655,'2563451','834','00','005010X220A1','2563451','','2014-01-17','14:05:18',0,'2014-01-20 08:05:48',NULL,NULL),(15022,2584,'1518864','834','00','005010X220A1','1518864','','2014-01-15','11:11:51',0,'2014-01-16 08:44:31',NULL,NULL),(14715,2550,'2436319','834','00','005010X220A1','2436319','','2014-01-14','10:57:18',0,'2014-01-15 02:06:08',NULL,NULL),(3571,617,'922320','834','00','005010X220A1','922320','','2013-12-11','22:52:40',0,'2013-12-25 22:03:28',NULL,NULL),(4374,773,'917845','834','00','005010X220A1','917845','','2013-11-27','12:35:18',0,'2013-12-25 23:15:08',NULL,NULL),(6244,1170,'266340','834','00','005010X220A1','266340','','2013-12-20','13:00:36',0,'2013-12-26 03:05:44',NULL,NULL),(5665,1053,'1918886','834','00','005010X220A1','1918886','','2013-12-24','20:15:54',0,'2013-12-26 01:51:52',NULL,NULL),(22933,4294,'3716384','834','00','005010X220A1','3716384','','2014-03-06','11:39:02',0,'2014-03-06 21:02:40',NULL,NULL),(779,145,'1066416','834','00','005010X220A1','1066416','','2013-10-28','20:47:55',0,'2013-12-25 18:09:22',NULL,NULL),(13091,1935,'0001','999','BE','005010X231A1','373910','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:13',NULL,NULL),(19920,3728,'3396172','834','00','005010X220A1','3396172','','2014-02-17','12:13:59',0,'2014-02-17 19:00:13',NULL,NULL),(2081,343,'847106','834','00','005010X220A1','847106','','2013-12-09','17:27:07',0,'2013-12-25 19:37:26',NULL,NULL),(19914,3725,'2650599','834','00','005010X220A1','2650599','','2014-02-17','16:24:43',0,'2014-02-17 19:00:08',NULL,NULL),(6203,1168,'624400','834','00','005010X220A1','624400','','2013-12-19','20:10:55',0,'2013-12-26 03:04:25',NULL,NULL),(1645,283,'123424','834','00','005010X220A1','123424','','2013-11-20','10:41:45',0,'2013-12-25 19:02:19',NULL,NULL),(1462,252,'786030','834','00','005010X220A1','786030','','2013-12-24','14:30:43',0,'2013-12-25 18:56:11',NULL,NULL),(15415,2629,'2013666','834','00','005010X220A1','2013666','','2014-01-15','21:55:20',0,'2014-01-17 03:35:54',NULL,NULL),(21143,3996,'2989385','834','00','005010X220A1','2989385','','2014-02-26','17:42:12',0,'2014-02-26 21:00:40',NULL,NULL),(680,109,'7672','834','00','005010X220A1','7672','','2013-12-16','14:31:32',0,'2013-12-25 18:06:06',NULL,NULL),(1034,198,'1011111','834','00','005010X220A1','1011111','','2013-12-03','11:49:27',0,'2013-12-25 18:21:21',NULL,NULL),(4800,865,'1186781','834','00','005010X220A1','1186781','','2013-12-01','09:35:47',0,'2013-12-26 00:01:53',NULL,NULL),(20286,3795,'3461519','834','00','005010X220A1','3461519','','2014-02-19','10:28:22',0,'2014-02-20 04:39:26',NULL,NULL),(20094,3766,'2604861','834','00','005010X220A1','2604861','','2014-02-18','13:52:05',0,'2014-02-18 22:01:41',NULL,NULL),(5996,1130,'539721','834','00','005010X220A1','539721','','2013-12-15','12:30:07',0,'2013-12-26 02:33:53',NULL,NULL),(7026,1235,'570046','834','00','005010X220A1','570046','','2013-12-18','12:05:13',0,'2013-12-26 04:01:18',NULL,NULL),(4335,755,'282792','834','00','005010X220A1','282792','','2013-12-19','14:33:31',0,'2013-12-25 23:10:18',NULL,NULL),(19635,3643,'2202209','834','00','005010X220A1','2202209','','2014-02-14','13:09:32',0,'2014-02-14 21:32:04',NULL,NULL),(2060,337,'32533','834','00','005010X220A1','32533','','2013-12-09','08:04:19',0,'2013-12-25 19:36:45',NULL,NULL),(17739,3262,'1844025','834','00','005010X220A1','1844025','','2014-02-03','23:03:14',0,'2014-02-04 21:00:53',NULL,NULL),(16252,2944,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',0,'2014-01-23 07:06:40',NULL,NULL),(526,102,'354096','834','00','005010X220A1','354096','','2013-12-16','13:20:01',0,'2013-12-25 18:01:12',NULL,NULL),(13757,2277,'1856202','834','00','005010X220A1','1856202','','2014-01-07','16:50:58',0,'2014-01-08 18:24:55',NULL,NULL),(1209,243,'1678681','834','00','005010X220A1','1678681','','2013-12-24','05:06:14',0,'2013-12-25 18:48:03',NULL,NULL),(16782,3081,'1922110','834','00','005010X220A1','1922110','','2014-01-27','14:05:11',0,'2014-01-27 21:01:43',NULL,NULL),(4154,734,'1138490','834','00','005010X220A1','1138490','','2013-12-18','19:58:25',0,'2013-12-25 23:04:49',NULL,NULL),(5109,941,'955458','834','00','005010X220A1','955458','','2013-12-10','18:44:06',0,'2013-12-26 00:49:29',NULL,NULL),(1674,290,'772044','834','00','005010X220A1','772044','','2013-12-10','11:07:42',0,'2013-12-25 19:15:39',NULL,NULL),(20197,3781,'3280164','834','00','005010X220A1','3280164','','2014-02-19','09:39:01',0,'2014-02-20 04:17:30',NULL,NULL),(5593,1043,'996285','834','00','005010X220A1','996285','','2013-12-25','00:51:05',0,'2013-12-26 01:49:27',NULL,NULL),(20165,3777,'2905872','834','00','005010X220A1','2905872','','2014-02-19','10:44:24',0,'2014-02-20 04:08:12',NULL,NULL),(5304,986,'327349','834','00','005010X220A1','327349','','2013-11-05','16:46:40',0,'2013-12-26 01:01:36',NULL,NULL),(18193,3353,'2137421','834','00','005010X220A1','2137421','','2014-02-06','18:32:01',0,'2014-02-07 19:00:29',NULL,NULL),(10639,1402,'634620','834','00','005010X220A1','634620','','2013-12-23','17:07:14',0,'2013-12-26 12:58:26',NULL,NULL),(11229,1454,'1809320','834','00','005010X220A1','1809320','','2013-12-26','11:03:22',0,'2013-12-27 02:01:19',NULL,NULL),(11522,1490,'1667350','834','00','005010X220A1','1667350','','2013-12-27','12:12:27',0,'2013-12-28 03:32:18',NULL,NULL),(18137,3338,'2858691','834','00','005010X220A1','2858691','','2014-02-06','14:00:21',0,'2014-02-06 21:01:44',NULL,NULL),(12020,1583,'1634118','834','00','005010X220A1','1634118','','2013-12-30','12:30:50',0,'2014-01-01 12:02:51',NULL,NULL),(12498,1642,'1388220','834','00','005010X220A1','1388220','','2013-12-30','20:22:41',1,'2014-01-02 04:33:17',NULL,NULL),(14011,2337,'1655023','834','00','005010X220A1','1655023','','2014-01-07','21:32:50',0,'2014-01-13 02:21:12',NULL,NULL),(20558,3863,'3105374','834','00','005010X220A1','3105374','','2014-02-21','10:51:40',0,'2014-02-21 21:30:09',NULL,NULL),(22741,4276,'3220947','834','00','005010X220A1','3220947','','2014-03-06','10:09:06',0,'2014-03-06 21:00:22',NULL,NULL),(17033,3120,'1652062','834','00','005010X220A1','1652062','','2014-01-29','16:25:24',0,'2014-01-29 21:01:15',NULL,NULL),(15926,2747,'2189185','834','00','005010X220A1','2189185','','2014-01-21','11:13:56',1,'2014-01-22 03:22:56',NULL,NULL),(14974,2572,'1622265','834','00','005010X220A1','1622265','','2014-01-14','13:18:44',0,'2014-01-15 02:08:04',NULL,NULL),(2091,350,'1141771','834','00','005010X220A1','1141771','','2013-12-09','15:51:12',0,'2013-12-25 19:37:45',NULL,NULL),(4702,834,'1721721','834','00','005010X220A1','1721721','','2013-12-23','23:06:03',0,'2013-12-25 23:50:43',NULL,NULL),(3431,598,'958296','834','00','005010X220A1','958296','','2013-12-17','10:06:57',0,'2013-12-25 21:52:43',NULL,NULL),(399,76,'536813','834','00','005010X220A1','536813','','2013-12-03','21:53:19',0,'2013-12-25 17:48:20',NULL,NULL),(2562,464,'926809','834','00','005010X220A1','926809','','2013-11-18','10:18:53',0,'2013-12-25 20:31:58',NULL,NULL),(2324,407,'63068','834','00','005010X220A1','63068','','2013-10-22','15:23:36',0,'2013-12-25 20:02:03',NULL,NULL),(21025,3974,'2969174','834','00','005010X220A1','2969174','','2014-02-23','19:50:22',0,'2014-02-26 09:30:04',NULL,NULL),(17592,3240,'2486943','834','00','005010X220A1','2486943','','2014-02-03','05:45:53',0,'2014-02-03 21:00:53',NULL,NULL),(3992,728,'1066795','834','00','005010X220A1','1066795','','2013-12-07','14:31:22',0,'2013-12-25 22:48:01',NULL,NULL),(4103,733,'1349409','834','00','005010X220A1','1349409','','2013-12-19','11:40:36',0,'2013-12-25 23:03:20',NULL,NULL),(7020,1235,'1176033','834','00','005010X220A1','1176033','','2013-12-18','10:32:40',0,'2013-12-26 04:01:05',NULL,NULL),(17073,3130,'2122168','834','00','005010X220A1','2122168','','2014-01-29','10:53:27',0,'2014-01-29 21:01:41',NULL,NULL),(16684,3062,'1383930','834','00','005010X220A1','1383930','','2014-01-27','11:46:18',0,'2014-01-27 21:00:33',NULL,NULL),(15667,2686,'2152091','834','00','005010X220A1','2152091','','2014-01-18','09:56:00',0,'2014-01-21 08:44:37',NULL,NULL),(14734,2550,'2331431','834','00','005010X220A1','2331431','','2014-01-14','14:43:01',0,'2014-01-15 02:06:17',NULL,NULL),(11364,1459,'1853666','834','00','005010X220A1','1853666','','2013-12-26','13:04:09',0,'2013-12-27 02:05:26',NULL,NULL),(14540,2518,'2089257','834','00','005010X220A1','2089257','','2014-01-13','14:10:40',0,'2014-01-14 01:32:28',NULL,NULL),(23740,4469,'2896105','834','00','005010X220A1','2896105','','2014-03-10','16:14:02',0,'2014-03-10 21:03:00',NULL,NULL),(2378,414,'59374','834','00','005010X220A1','59374','','2013-12-06','11:27:58',0,'2013-12-25 20:16:34',NULL,NULL),(2471,426,'36530','834','00','005010X220A1','36530','','2013-12-06','15:41:45',0,'2013-12-25 20:19:34',NULL,NULL),(19944,3738,'3506202','834','00','005010X220A1','3506202','','2014-02-18','11:21:56',0,'2014-02-18 21:30:14',NULL,NULL),(2910,540,'331282','834','00','005010X220A1','331282','','2013-12-13','10:56:18',0,'2013-12-25 21:30:15',NULL,NULL),(11030,1417,'1777986','834','00','005010X220A1','1777986','','2013-12-23','18:15:03',0,'2013-12-26 13:11:47',NULL,NULL),(3178,567,'593554','834','00','005010X220A1','593554','','2013-12-13','13:38:02',0,'2013-12-25 21:38:46',NULL,NULL),(4085,733,'349235','834','00','005010X220A1','349235','','2013-12-19','10:01:26',0,'2013-12-25 23:02:50',NULL,NULL),(3860,690,'650996','834','00','005010X220A1','650996','','2013-10-10','10:13:25',0,'2013-12-25 22:30:56',NULL,NULL),(20787,3908,'3436314','834','00','005010X220A1','3436314','','2014-02-24','18:17:01',0,'2014-02-25 21:30:46',NULL,NULL),(20801,3909,'3352530','834','00','005010X220A1','3352530','','2014-02-25','16:22:07',0,'2014-02-25 21:30:56',NULL,NULL),(22426,4224,'3856090','834','00','005010X220A1','3856090','','2014-03-04','14:37:07',0,'2014-03-04 21:02:42',NULL,NULL),(19741,3673,'3326188','834','00','005010X220A1','3326188','','2014-02-15','11:13:54',0,'2014-02-15 22:00:37',NULL,NULL),(18793,3487,'2283967','834','00','005010X220A1','2283967','','2014-02-11','12:43:17',0,'2014-02-11 21:01:10',NULL,NULL),(550,103,'1303966','834','00','005010X220A1','1303966','','2013-12-16','08:45:42',0,'2013-12-25 18:02:01',NULL,NULL),(17956,3299,'2610599','834','00','005010X220A1','2610599','','2014-02-05','15:17:03',0,'2014-02-05 21:30:58',NULL,NULL),(6399,1191,'1055972','834','00','005010X220A1','1055972','','2013-12-20','15:36:08',0,'2013-12-26 03:10:27',NULL,NULL),(7021,1235,'38232','834','00','005010X220A1','38232','','2013-12-18','10:41:39',0,'2013-12-26 04:01:08',NULL,NULL),(2566,467,'64524','834','00','005010X220A1','64524','','2013-11-18','13:02:45',0,'2013-12-25 20:32:06',NULL,NULL),(3634,622,'677416','834','00','005010X220A1','677416','','2013-12-12','10:55:54',0,'2013-12-25 22:05:25',NULL,NULL),(10436,1400,'90443','834','00','005010X220A1','90443','','2013-12-23','11:27:15',0,'2013-12-26 12:51:49',NULL,NULL),(15109,2587,'1933805','834','00','005010X220A1','1933805','','2014-01-15','10:02:00',0,'2014-01-16 08:45:27',NULL,NULL),(1341,245,'1715301','834','00','005010X220A1','1715301','','2013-12-24','12:44:31',0,'2013-12-25 18:52:06',NULL,NULL),(20388,3828,'2801993','834','00','005010X220A1','2801993','','2014-02-19','14:48:03',0,'2014-02-20 05:39:57',NULL,NULL),(20684,3884,'3345510','834','00','005010X220A1','3345510','','2014-02-21','17:33:59',0,'2014-02-21 22:01:15',NULL,NULL),(17007,3118,'2583772','834','00','005010X220A1','2583772','','2014-01-29','15:11:20',0,'2014-01-29 21:00:58',NULL,NULL),(14295,2382,'1903769','834','00','005010X220A1','1903769','','2014-01-10','11:20:59',0,'2014-01-13 03:00:24',NULL,NULL),(14031,2337,'1666396','834','00','005010X220A1','1666396','','2014-01-08','14:48:15',0,'2014-01-13 02:21:25',NULL,NULL),(5041,935,'41565','834','00','005010X220A1','41565','','2013-12-11','17:30:32',0,'2013-12-26 00:47:17',NULL,NULL),(11363,1459,'1473076','834','00','005010X220A1','1473076','','2013-12-26','12:25:52',0,'2013-12-27 02:05:25',NULL,NULL),(3395,588,'776833','834','00','005010X220A1','776833','','2013-12-17','13:09:07',0,'2013-12-25 21:51:30',NULL,NULL),(20968,3956,'2624073','834','00','005010X220A1','2624073','','2014-02-21','23:28:31',0,'2014-02-26 08:30:06',NULL,NULL),(2574,472,'1251197','834','00','005010X220A1','1251197','','2013-10-31','19:41:38',0,'2013-12-25 20:45:07',NULL,NULL),(19571,3627,'1912289','834','00','005010X220A1','1912289','','2014-02-14','08:18:45',0,'2014-02-14 21:31:17',NULL,NULL),(6167,1167,'228668','834','00','005010X220A1','228668','','2013-12-20','14:27:03',0,'2013-12-26 03:03:20',NULL,NULL),(19246,3580,'3158348','834','00','005010X220A1','3158348','','2014-02-13','16:05:13',0,'2014-02-13 22:00:30',NULL,NULL),(2970,541,'940340','834','00','005010X220A1','940340','','2013-12-13','14:37:25',0,'2013-12-25 21:32:12',NULL,NULL),(10681,1403,'1020587','834','00','005010X220A1','1020587','','2013-12-22','22:27:23',0,'2013-12-26 12:59:48',NULL,NULL),(12858,1706,'1548468','834','00','005010X220A1','1548468','','2014-01-03','09:14:57',0,'2014-01-04 02:03:23',NULL,NULL),(18923,3518,'2046281','834','00','005010X220A1','2046281','','2014-02-11','18:13:49',0,'2014-02-11 21:30:03',NULL,NULL),(17332,3177,'2480751','834','00','005010X220A1','2480751','','2014-01-30','21:53:05',0,'2014-01-31 21:01:03',NULL,NULL),(16810,3089,'2032143','834','00','005010X220A1','2032143','','2014-01-28','17:31:55',0,'2014-01-28 21:00:13',NULL,NULL),(17274,3170,'1855703','834','00','005010X220A1','1855703','','2014-01-31','15:43:21',0,'2014-01-31 21:00:23',NULL,NULL),(20998,3960,'2874287','834','00','005010X220A1','2874287','','2014-02-21','22:36:42',0,'2014-02-26 08:30:36',NULL,NULL),(286,62,'657817','834','00','005010X220A1','657817','','2013-11-09','00:48:31',0,'2013-12-25 17:32:12',NULL,NULL),(380,74,'995322','834','00','005010X220A1','995322','','2013-12-04','10:21:48',0,'2013-12-25 17:47:43',NULL,NULL),(20550,3862,'3306282','834','00','005010X220A1','3306282','','2014-02-20','20:52:26',0,'2014-02-21 21:30:05',NULL,NULL),(5329,1002,'462278','834','00','005010X220A1','462278','','2013-11-25','13:22:41',0,'2013-12-26 01:15:08',NULL,NULL),(5279,977,'548626','834','00','005010X220A1','548626','','2013-11-16','08:25:27',0,'2013-12-26 01:00:42',NULL,NULL),(18034,3319,'2934423','834','00','005010X220A1','2934423','','2014-02-06','11:19:43',0,'2014-02-06 21:00:30',NULL,NULL),(16785,3082,'2354709','834','00','005010X220A1','2354709','','2014-01-27','18:17:33',0,'2014-01-27 21:01:46',NULL,NULL),(16633,3056,'1631327','834','00','005010X220A1','1631327','','2014-01-26','10:42:21',0,'2014-01-26 19:00:27',NULL,NULL),(15422,2629,'1598917','834','00','005010X220A1','1598917','','2014-01-16','11:18:21',0,'2014-01-17 03:35:58',NULL,NULL),(11472,1488,'1547203','834','00','005010X220A1','1547203','','2013-12-27','13:59:49',0,'2013-12-28 03:30:47',NULL,NULL),(13447,2223,'2232937','834','00','005010X220A1','2232937','','2014-01-06','14:27:06',0,'2014-01-07 04:02:39',NULL,NULL),(12231,1618,'1626917','834','00','005010X220A1','1626917','','2013-12-31','19:09:09',1,'2014-01-02 04:22:41',NULL,NULL),(13025,1869,'0001','999','BE','005010X231A1','1065232','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:11',NULL,NULL),(23744,4471,'3522926','834','00','005010X220A1','3522926','','2014-03-10','16:52:51',0,'2014-03-10 21:03:03',NULL,NULL),(19674,3661,'3448445','834','00','005010X220A1','3448445','','2014-02-14','16:16:12',0,'2014-02-14 22:00:06',NULL,NULL),(18690,3474,'2195830','834','00','005010X220A1','2195830','','2014-02-10','14:23:27',0,'2014-02-10 21:32:06',NULL,NULL),(13403,2222,'1794676','834','00','005010X220A1','1794676','','2014-01-06','12:40:59',0,'2014-01-07 04:01:00',NULL,NULL),(13290,2134,'0001','999','BE','005010X231A1','550040','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:44',NULL,NULL),(1618,281,'973995','834','00','005010X220A1','973995','','2013-11-19','23:03:40',0,'2013-12-25 19:01:40',NULL,NULL),(18024,3318,'1389101','834','00','005010X220A1','1389101','','2014-02-06','00:21:58',0,'2014-02-06 21:00:24',NULL,NULL),(2846,511,'60011','834','00','005010X220A1','60011','','2013-12-22','17:15:17',0,'2013-12-25 21:21:52',NULL,NULL),(17687,3259,'2340060','834','00','005010X220A1','2340060','','2014-02-04','17:01:29',0,'2014-02-04 21:00:22',NULL,NULL),(15637,2676,'1474776','834','00','005010X220A1','1474776','','2014-01-18','12:39:00',0,'2014-01-21 08:44:16',NULL,NULL),(12379,1637,'1793147','834','00','005010X220A1','1793147','','2013-12-30','19:18:47',1,'2014-01-02 04:28:55',NULL,NULL),(11445,1487,'1932081','834','00','005010X220A1','1932081','','2013-12-26','18:16:44',0,'2013-12-27 02:08:05',NULL,NULL),(22104,4177,'3767112','834','00','005010X220A1','3767112','','2014-03-03','09:37:11',0,'2014-03-03 21:30:22',NULL,NULL),(20625,3871,'3561634','834','00','005010X220A1','3561634','','2014-02-21','15:12:51',0,'2014-02-21 22:00:35',NULL,NULL),(19957,3746,'3130136','834','00','005010X220A1','3130136','','2014-02-17','19:30:34',0,'2014-02-18 22:00:02',NULL,NULL),(5861,1101,'541729','834','00','005010X220A1','541729','','2013-10-26','22:43:01',0,'2013-12-26 02:16:34',NULL,NULL),(17864,3293,'2921102','834','00','005010X220A1','2921102','','2014-02-05','13:40:39',0,'2014-02-05 21:30:13',NULL,NULL),(16992,3118,'2173064','834','00','005010X220A1','2173064','','2014-01-29','08:54:08',0,'2014-01-29 21:00:49',NULL,NULL),(16612,3049,'2281015','834','00','005010X220A1','2281015','','2014-01-26','00:48:13',0,'2014-01-26 19:00:11',NULL,NULL),(16478,3008,'1734763','834','00','005010X220A1','1734763','','2014-01-24','10:42:11',0,'2014-01-24 21:00:28',NULL,NULL),(15389,2624,'1650475','834','00','005010X220A1','1650475','','2014-01-15','20:39:43',0,'2014-01-17 03:35:42',NULL,NULL),(4532,824,'785947','834','00','005010X220A1','785947','','2013-12-23','21:08:12',0,'2013-12-25 23:45:04',NULL,NULL),(12361,1634,'1398415','834','00','005010X220A1','1398415','','2013-12-31','15:05:27',1,'2014-01-02 04:28:14',NULL,NULL),(11635,1497,'2015299','834','00','005010X220A1','2015299','','2013-12-27','15:32:02',0,'2013-12-28 03:35:48',NULL,NULL),(11199,1453,'2200911','834','00','005010X220A1','2200911','','2013-12-26','16:19:35',0,'2013-12-27 02:00:24',NULL,NULL),(2548,457,'413882','834','00','005010X220A1','413882','','2013-11-18','13:21:05',0,'2013-12-25 20:31:28',NULL,NULL),(10841,1404,'1637671','834','00','005010X220A1','1637671','','2013-12-23','19:15:14',0,'2013-12-26 13:05:11',NULL,NULL),(22109,4177,'3720035','834','00','005010X220A1','3720035','','2014-03-02','20:45:36',0,'2014-03-03 21:30:27',NULL,NULL),(20887,3922,'2470911','834','00','005010X220A1','2470911','','2014-02-25','10:25:45',0,'2014-02-25 21:31:59',NULL,NULL),(20850,3911,'3010167','834','00','005010X220A1','3010167','','2014-02-25','15:31:18',0,'2014-02-25 21:31:30',NULL,NULL),(20689,3889,'3433648','834','00','005010X220A1','3433648','','2014-02-22','10:27:06',0,'2014-02-22 19:00:12',NULL,NULL),(7072,1236,'1031359','834','00','005010X220A1','1031359','','2013-12-18','05:39:13',0,'2013-12-26 04:02:42',NULL,NULL),(19503,3621,'3256431','834','00','005010X220A1','3256431','','2014-02-14','11:24:43',0,'2014-02-14 21:30:28',NULL,NULL),(5231,955,'40373','834','00','005010X220A1','40373','','2013-12-11','14:14:07',0,'2013-12-26 00:53:25',NULL,NULL),(2000,329,'507471','834','00','005010X220A1','507471','','2013-12-09','13:57:21',0,'2013-12-25 19:34:52',NULL,NULL),(16830,3091,'2042506','834','00','005010X220A1','2042506','','2014-01-28','11:46:03',0,'2014-01-28 21:00:26',NULL,NULL),(13520,2235,'1392249','834','00','005010X220A1','1392249','','2014-01-06','14:48:27',0,'2014-01-07 04:05:24',NULL,NULL),(15766,2714,'2480525','834','00','005010X220A1','2480525','','2014-01-20','10:17:55',0,'2014-01-21 08:46:26',NULL,NULL),(15440,2629,'1595644','834','00','005010X220A1','1595644','','2014-01-15','20:53:58',0,'2014-01-17 03:36:05',NULL,NULL),(21949,4134,'3188568','834','00','005010X220A1','3188568','','2014-02-28','21:05:53',0,'2014-03-01 21:01:04',NULL,NULL),(2278,392,'326389','834','00','005010X220A1','326389','','2013-11-23','20:49:26',0,'2013-12-25 20:00:24',NULL,NULL),(6465,1222,'1007449','834','00','005010X220A1','1007449','','2013-11-22','13:39:26',0,'2013-12-26 03:16:36',NULL,NULL),(20612,3871,'2707684','834','00','005010X220A1','2707684','','2014-02-21','08:24:31',0,'2014-02-21 22:00:25',NULL,NULL),(5700,1067,'1271373','834','00','005010X220A1','1271373','','2013-12-14','13:12:59',0,'2013-12-26 02:00:26',NULL,NULL),(3189,575,'958161','834','00','005010X220A1','958161','','2013-12-13','15:49:07',0,'2013-12-25 21:39:11',NULL,NULL),(20113,3772,'3469880','834','00','005010X220A1','3469880','','2014-02-18','21:13:17',0,'2014-02-20 03:48:07',NULL,NULL),(14653,2530,'2376230','834','00','005010X220A1','2376230','','2014-01-13','15:28:42',0,'2014-01-14 01:33:40',NULL,NULL),(14874,2555,'1569415','834','00','005010X220A1','1569415','','2014-01-14','13:52:39',0,'2014-01-15 02:07:17',NULL,NULL),(19249,3580,'2660446','834','00','005010X220A1','2660446','','2014-02-13','17:00:54',0,'2014-02-13 22:00:33',NULL,NULL),(16960,3116,'1757414','834','00','005010X220A1','1757414','','2014-01-29','10:16:21',0,'2014-01-29 21:00:29',NULL,NULL),(23238,4363,'3474078','834','00','005010X220A1','3474078','','2014-03-07','15:57:16',0,'2014-03-07 21:32:13',NULL,NULL),(5422,1026,'899224','834','00','005010X220A1','899224','','2013-11-14','05:29:06',0,'2013-12-26 01:31:01',NULL,NULL),(20234,3789,'2359973','834','00','005010X220A1','2359973','','2014-02-19','10:40:44',0,'2014-02-20 04:28:07',NULL,NULL),(19538,3624,'2636384','834','00','005010X220A1','2636384','','2014-02-13','22:20:13',0,'2014-02-14 21:30:53',NULL,NULL),(18190,3351,'1967600','834','00','005010X220A1','1967600','','2014-02-07','15:49:08',0,'2014-02-07 19:00:27',NULL,NULL),(17879,3294,'2866669','834','00','005010X220A1','2866669','','2014-02-04','20:47:55',0,'2014-02-05 21:30:20',NULL,NULL),(10800,1404,'1280160','834','00','005010X220A1','1280160','','2013-12-23','14:10:16',0,'2013-12-26 13:03:52',NULL,NULL),(17601,3240,'1443159','834','00','005010X220A1','1443159','','2014-02-03','12:50:01',0,'2014-02-03 21:00:59',NULL,NULL),(5517,1041,'445470','834','00','005010X220A1','445470','','2013-12-24','20:58:44',0,'2013-12-26 01:46:56',NULL,NULL),(12714,1678,'1672683','834','00','005010X220A1','1672683','','2014-01-02','12:15:36',0,'2014-01-03 02:05:17',NULL,NULL),(12791,1703,'1741516','834','00','005010X220A1','1741516','','2014-01-03','10:36:33',0,'2014-01-04 02:00:55',NULL,NULL),(17009,3118,'2304275','834','00','005010X220A1','2304275','','2014-01-29','16:02:27',0,'2014-01-29 21:00:59',NULL,NULL),(14235,2370,'1369183','834','00','005010X220A1','1369183','','2014-01-10','14:12:24',0,'2014-01-13 02:24:06',NULL,NULL),(14267,2375,'2219305','834','00','005010X220A1','2219305','','2014-01-10','11:31:21',0,'2014-01-13 03:00:09',NULL,NULL),(14871,2555,'1592921','834','00','005010X220A1','1592921','','2014-01-14','12:14:36',0,'2014-01-15 02:07:16',NULL,NULL),(15881,2740,'1721375','834','00','005010X220A1','1721375','','2014-01-20','19:33:37',1,'2014-01-22 03:22:29',NULL,NULL),(21777,4091,'2769118','834','00','005010X220A1','2769118','','2014-02-28','10:31:28',0,'2014-02-28 21:31:05',NULL,NULL),(23417,4404,'2761989','834','00','005010X220A1','2761989','','2014-03-09','15:16:00',0,'2014-03-09 21:00:23',NULL,NULL),(712,117,'492096','834','00','005010X220A1','492096','','2013-12-16','15:41:26',0,'2013-12-25 18:07:08',NULL,NULL),(2023,331,'1211388','834','00','005010X220A1','1211388','','2013-12-09','14:54:12',0,'2013-12-25 19:35:35',NULL,NULL),(7724,1340,'578545','834','00','005010X220A1','578545','','2013-11-15','12:50:13',0,'2013-12-26 04:46:18',NULL,NULL),(21271,4001,'3432338','834','00','005010X220A1','3432338','','2014-02-26','12:48:01',0,'2014-02-26 21:02:03',NULL,NULL),(5569,1043,'1718155','834','00','005010X220A1','1718155','','2013-12-24','20:23:26',0,'2013-12-26 01:48:37',NULL,NULL),(19870,3708,'2860323','834','00','005010X220A1','2860323','','2014-02-15','21:28:14',0,'2014-02-16 19:00:16',NULL,NULL),(12128,1587,'1840528','834','00','005010X220A1','1840528','','2013-12-30','17:25:17',0,'2014-01-01 12:06:43',NULL,NULL),(12730,1683,'1926911','834','00','005010X220A1','1926911','','2014-01-02','12:33:44',0,'2014-01-03 02:05:57',NULL,NULL),(14005,2337,'2080169','834','00','005010X220A1','2080169','','2014-01-08','18:14:47',0,'2014-01-13 02:21:09',NULL,NULL),(14375,2406,'1844864','834','00','005010X220A1','1844864','','2014-01-12','10:44:40',0,'2014-01-13 03:01:44',NULL,NULL),(18674,3467,'1723003','834','00','005010X220A1','1723003','','2014-02-10','15:37:23',0,'2014-02-10 21:31:55',NULL,NULL),(15760,2714,'2241770','834','00','005010X220A1','2241770','','2014-01-20','12:16:49',0,'2014-01-21 08:46:23',NULL,NULL),(15856,2738,'1478459','834','00','005010X220A1','1478459','','2014-01-21','13:17:51',1,'2014-01-22 03:22:13',NULL,NULL),(22713,4267,'3545291','834','00','005010X220A1','3545291','','2014-03-05','14:25:01',0,'2014-03-05 21:32:38',NULL,NULL),(899,177,'748987','834','00','005010X220A1','748987','','2013-12-03','15:39:50',0,'2013-12-25 18:17:05',NULL,NULL),(12336,1634,'2029941','834','00','005010X220A1','2029941','','2013-12-31','11:30:15',1,'2014-01-02 04:27:27',NULL,NULL),(7424,1295,'550446','834','00','005010X220A1','550446','','2013-12-21','11:22:29',0,'2013-12-26 04:31:37',NULL,NULL),(12212,1615,'2239900','834','00','005010X220A1','2239900','','2014-01-01','09:10:05',1,'2014-01-02 04:21:56',NULL,NULL),(3926,712,'1261242','834','00','005010X220A1','1261242','','2013-12-07','15:03:22',0,'2013-12-25 22:45:50',NULL,NULL),(3936,714,'1206251','834','00','005010X220A1','1206251','','2013-12-07','00:39:55',0,'2013-12-25 22:46:07',NULL,NULL),(12202,1611,'1420994','834','00','005010X220A1','1420994','','2013-12-30','14:41:40',0,'2014-01-01 12:09:22',NULL,NULL),(10590,1402,'680513','834','00','005010X220A1','680513','','2013-12-23','12:19:41',0,'2013-12-26 12:56:50',NULL,NULL),(11064,1421,'440387','834','00','005010X220A1','440387','','2013-12-23','10:46:17',0,'2013-12-26 13:12:56',NULL,NULL),(22140,4179,'2778170','834','00','005010X220A1','2778170','','2014-03-03','13:01:13',0,'2014-03-03 21:30:48',NULL,NULL),(1062,209,'443385','834','00','005010X220A1','443385','','2013-11-29','10:43:51',0,'2013-12-25 18:30:40',NULL,NULL),(19902,3718,'2579177','834','00','005010X220A1','2579177','','2014-02-15','23:55:23',0,'2014-02-16 19:00:41',NULL,NULL),(17091,3139,'1683938','834','00','005010X220A1','1683938','','2014-01-29','17:12:10',0,'2014-01-29 21:01:52',NULL,NULL),(6412,1198,'201541','834','00','005010X220A1','201541','','2013-12-20','16:47:18',0,'2013-12-26 03:10:57',NULL,NULL),(15224,2594,'1530838','834','00','005010X220A1','1530838','','2014-01-15','15:41:41',0,'2014-01-16 08:46:40',NULL,NULL),(4812,866,'1139262','834','00','005010X220A1','1139262','','2013-11-30','19:58:34',0,'2013-12-26 00:02:13',NULL,NULL),(4291,746,'1242227','834','00','005010X220A1','1242227','','2013-12-18','22:03:01',0,'2013-12-25 23:09:02',NULL,NULL),(14262,2375,'2405333','834','00','005010X220A1','2405333','','2014-01-09','21:47:18',0,'2014-01-13 03:00:05',NULL,NULL),(10460,1400,'874110','834','00','005010X220A1','874110','','2013-12-23','13:42:28',0,'2013-12-26 12:52:36',NULL,NULL),(85,4,'1129575','834','00','005010X220A1','1129575','','2013-12-05','09:09:06',0,'2013-12-25 17:17:34',NULL,NULL),(181,16,'673139','834','00','005010X220A1','673139','','2013-12-05','06:27:22',0,'2013-12-25 17:20:37',NULL,NULL),(619,108,'782656','834','00','005010X220A1','782656','','2013-12-16','07:34:11',0,'2013-12-25 18:04:13',NULL,NULL),(7692,1331,'665589','834','00','005010X220A1','665589','','2013-11-14','19:59:26',0,'2013-12-26 04:45:10',NULL,NULL),(13168,2012,'0001','999','BE','005010X231A1','1166929','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:23',NULL,NULL),(13070,1914,'0001','999','BE','005010X231A1','432763','834','2013-12-27','16:55:00',0,'2014-01-05 16:52:15',NULL,NULL),(11850,1547,'628558','834','00','005010X220A1','628558','','2013-12-28','20:25:55',1,'2013-12-29 11:14:46',NULL,NULL),(17881,3294,'2778804','834','00','005010X220A1','2778804','','2014-02-05','09:19:43',0,'2014-02-05 21:30:21',NULL,NULL),(19926,3732,'2949030','834','00','005010X220A1','2949030','','2014-02-17','15:01:27',0,'2014-02-17 19:00:17',NULL,NULL),(20424,3838,'3022237','834','00','005010X220A1','3022237','','2014-02-20','16:48:54',0,'2014-02-20 21:30:22',NULL,NULL),(22002,4147,'2715166','834','00','005010X220A1','2715166','','2014-03-01','19:35:15',0,'2014-03-03 01:00:24',NULL,NULL),(22047,4165,'2933733','834','00','005010X220A1','2933733','','2014-03-03','11:59:46',0,'2014-03-03 21:00:09',NULL,NULL),(11902,1562,'1962641','834','00','005010X220A1','1962641','','2013-12-28','18:45:27',0,'2013-12-30 00:01:05',NULL,NULL),(18592,3455,'3101419','834','00','005010X220A1','3101419','','2014-02-10','11:13:46',0,'2014-02-10 21:30:58',NULL,NULL),(10751,1403,'1538923','834','00','005010X220A1','1538923','','2013-12-23','17:38:20',0,'2013-12-26 13:02:15',NULL,NULL),(10409,1400,'1193525','834','00','005010X220A1','1193525','','2013-12-23','09:16:01',0,'2013-12-26 12:50:58',NULL,NULL),(1995,329,'613020','834','00','005010X220A1','613020','','2013-12-08','20:53:09',0,'2013-12-25 19:34:40',NULL,NULL),(2300,399,'444221','834','00','005010X220A1','444221','','2013-11-01','20:09:12',0,'2013-12-25 20:01:11',NULL,NULL),(2313,403,'8343','834','00','005010X220A1','8343','','2013-11-02','09:26:22',0,'2013-12-25 20:01:40',NULL,NULL),(2549,457,'778543','834','00','005010X220A1','778543','','2013-11-18','13:52:27',0,'2013-12-25 20:31:31',NULL,NULL),(14633,2526,'2042147','834','00','005010X220A1','2042147','','2014-01-13','10:39:04',0,'2014-01-14 01:33:27',NULL,NULL),(7624,1308,'395059','834','00','005010X220A1','395059','','2013-12-20','21:21:48',0,'2013-12-26 04:38:03',NULL,NULL),(17888,3294,'1973929','834','00','005010X220A1','1973929','','2014-02-05','15:01:03',0,'2014-02-05 21:30:25',NULL,NULL),(20571,3865,'2614739','834','00','005010X220A1','2614739','','2014-02-21','14:31:06',0,'2014-02-21 21:30:16',NULL,NULL),(22489,4243,'2918107','834','00','005010X220A1','2918107','','2014-03-05','17:39:29',0,'2014-03-05 21:00:30',NULL,NULL),(15876,2739,'1795098','834','00','005010X220A1','1795098','','2014-01-21','14:07:55',1,'2014-01-22 03:22:26',NULL,NULL),(17487,3220,'2576600','834','00','005010X220A1','2576600','','2014-02-01','22:36:00',0,'2014-02-02 19:00:16',NULL,NULL),(18119,3330,'2964938','834','00','005010X220A1','2964938','','2014-02-06','14:02:45',0,'2014-02-06 21:01:30',NULL,NULL),(5588,1043,'1986647','834','00','005010X220A1','1986647','','2013-12-24','23:52:13',0,'2013-12-26 01:49:15',NULL,NULL),(2819,507,'1042227','834','00','005010X220A1','1042227','','2013-12-21','19:46:37',0,'2013-12-25 21:20:56',NULL,NULL),(2497,443,'1192856','834','00','005010X220A1','1192856','','2013-12-06','16:17:04',0,'2013-12-25 20:20:27',NULL,NULL),(20194,3782,'2946288','834','00','005010X220A1','2946288','','2014-02-18','18:33:10',0,'2014-02-20 04:16:47',NULL,NULL),(21721,4088,'2766570','834','00','005010X220A1','2766570','','2014-02-28','12:49:57',0,'2014-02-28 21:30:28',NULL,NULL),(902,177,'902004','834','00','005010X220A1','902004','','2013-12-03','11:31:02',0,'2013-12-25 18:17:11',NULL,NULL),(1383,245,'1608629','834','00','005010X220A1','1608629','','2013-12-24','16:41:16',0,'2013-12-25 18:53:28',NULL,NULL),(1715,293,'549958','834','00','005010X220A1','549958','','2013-12-09','18:37:31',0,'2013-12-25 19:16:58',NULL,NULL),(18605,3456,'2449673','834','00','005010X220A1','2449673','','2014-02-10','12:55:31',0,'2014-02-10 21:31:07',NULL,NULL),(11463,1488,'1541911','834','00','005010X220A1','1541911','','2013-12-27','11:22:23',0,'2013-12-28 03:30:33',NULL,NULL),(18421,3420,'1716163','834','00','005010X220A1','1716163','','2014-02-10','03:53:49',0,'2014-02-10 11:00:10',NULL,NULL),(15072,2585,'1879199','834','00','005010X220A1','1879199','','2014-01-15','12:50:29',0,'2014-01-16 08:45:03',NULL,NULL),(22206,4185,'2847013','834','00','005010X220A1','2847013','','2014-03-03','16:10:22',0,'2014-03-03 21:31:36',NULL,NULL),(16648,3060,'2223433','834','00','005010X220A1','2223433','','2014-01-27','11:34:09',0,'2014-01-27 21:00:10',NULL,NULL),(15058,2585,'1876841','834','00','005010X220A1','1876841','','2014-01-14','21:53:25',0,'2014-01-16 08:44:54',NULL,NULL),(10936,1410,'652175','834','00','005010X220A1','652175','','2013-12-23','13:27:31',0,'2013-12-26 13:08:49',NULL,NULL),(7075,1236,'674938','834','00','005010X220A1','674938','','2013-12-18','08:49:34',0,'2013-12-26 04:02:49',NULL,NULL),(14796,2551,'1655202','834','00','005010X220A1','1655202','','2014-01-14','17:21:19',0,'2014-01-15 02:06:43',NULL,NULL),(6000,1134,'67478','834','00','005010X220A1','67478','','2013-12-15','16:15:09',0,'2013-12-26 02:34:01',NULL,NULL),(19750,3673,'2292113','834','00','005010X220A1','2292113','','2014-02-15','13:29:05',0,'2014-02-15 22:00:43',NULL,NULL),(23414,4404,'3434112','834','00','005010X220A1','3434112','','2014-03-09','13:32:17',0,'2014-03-09 21:00:22',NULL,NULL),(2006,330,'769792','834','00','005010X220A1','769792','','2013-12-09','15:00:14',0,'2013-12-25 19:35:03',NULL,NULL),(12302,1629,'2197302','834','00','005010X220A1','2197302','','2014-01-01','12:36:27',1,'2014-01-02 04:25:20',NULL,NULL),(12254,1620,'2254181','834','00','005010X220A1','2254181','','2013-12-31','21:54:02',1,'2014-01-02 04:23:34',NULL,NULL),(18058,3319,'1655735','834','00','005010X220A1','1655735','','2014-02-06','16:58:17',0,'2014-02-06 21:00:46',NULL,NULL),(7181,1238,'1053616','834','00','005010X220A1','1053616','','2013-12-18','18:20:07',0,'2013-12-26 04:06:02',NULL,NULL),(16854,3092,'1731076','834','00','005010X220A1','1731076','','2014-01-28','18:06:36',0,'2014-01-28 21:00:42',NULL,NULL),(16104,2796,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:33:00',1,'2014-01-23 03:41:37',NULL,NULL),(15035,2584,'2480455','834','00','005010X220A1','2480455','','2014-01-15','17:03:41',0,'2014-01-16 08:44:40',NULL,NULL),(21491,4030,'3280367','834','00','005010X220A1','3280367','','2014-02-26','19:26:17',0,'2014-02-28 06:31:17',NULL,NULL),(21768,4090,'2732331','834','00','005010X220A1','2732331','','2014-02-28','16:32:00',0,'2014-02-28 21:30:58',NULL,NULL),(22940,4298,'3828878','834','00','005010X220A1','3828878','','2014-03-06','12:17:29',0,'2014-03-06 21:02:46',NULL,NULL),(17200,3149,'2317057','834','00','005010X220A1','2317057','','2014-01-30','15:38:41',0,'2014-01-30 21:01:09',NULL,NULL),(12987,1738,'1593956','834','00','005010X220A1','1593956','','2014-01-03','20:09:39',0,'2014-01-05 00:01:40',NULL,NULL),(15778,2717,'1506136','834','00','005010X220A1','1506136','','2014-01-20','08:25:04',0,'2014-01-21 08:46:34',NULL,NULL),(15070,2585,'2254586','834','00','005010X220A1','2254586','','2014-01-15','12:48:03',0,'2014-01-16 08:45:02',NULL,NULL),(10738,1403,'759367','834','00','005010X220A1','759367','','2013-12-23','15:23:21',0,'2013-12-26 13:01:48',NULL,NULL),(10630,1402,'1748438','834','00','005010X220A1','1748438','','2013-12-23','16:18:15',0,'2013-12-26 12:58:10',NULL,NULL),(7760,1348,'309382','834','00','005010X220A1','309382','','2013-10-20','18:58:14',0,'2013-12-26 05:01:12',NULL,NULL),(3185,572,'109843','834','00','005010X220A1','109843','','2013-12-13','14:46:39',0,'2013-12-25 21:39:03',NULL,NULL),(5138,943,'372814','834','00','005010X220A1','372814','','2013-12-11','11:17:47',0,'2013-12-26 00:50:28',NULL,NULL),(3839,682,'1256104','834','00','005010X220A1','1256104','','2013-11-08','09:36:43',0,'2013-12-25 22:30:13',NULL,NULL),(1127,238,'1572640','834','00','005010X220A1','1572640','','2013-12-24','14:07:15',0,'2013-12-25 18:45:29',NULL,NULL),(1120,238,'1832537','834','00','005010X220A1','1832537','','2013-12-24','12:53:10',0,'2013-12-25 18:45:16',NULL,NULL),(19855,3700,'3523427','834','00','005010X220A1','3523427','','2014-02-15','17:17:05',0,'2014-02-15 22:02:11',NULL,NULL),(18713,3485,'2988876','834','00','005010X220A1','2988876','','2014-02-10','20:19:56',0,'2014-02-11 21:00:10',NULL,NULL),(11887,1561,'2247887','834','00','005010X220A1','2247887','','2013-12-28','18:28:38',0,'2013-12-30 00:00:37',NULL,NULL),(15722,2711,'1804949','834','00','005010X220A1','1804949','','2014-01-20','11:24:32',0,'2014-01-21 08:46:01',NULL,NULL),(795,148,'80208','834','00','005010X220A1','80208','','2013-10-28','19:32:05',0,'2013-12-25 18:09:59',NULL,NULL),(2404,415,'557088','834','00','005010X220A1','557088','','2013-12-06','14:14:00',0,'2013-12-25 20:17:21',NULL,NULL),(3616,621,'1278511','834','00','005010X220A1','1278511','','2013-12-12','00:36:49',0,'2013-12-25 22:04:50',NULL,NULL),(20006,3748,'2829075','834','00','005010X220A1','2829075','','2014-02-18','15:37:03',0,'2014-02-18 22:00:37',NULL,NULL),(20341,3805,'3443733','834','00','005010X220A1','3443733','','2014-02-19','15:48:43',0,'2014-02-20 04:53:01',NULL,NULL),(22516,4247,'3657463','834','00','005010X220A1','3657463','','2014-03-05','12:17:24',0,'2014-03-05 21:30:17',NULL,NULL),(16242,2934,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',0,'2014-01-23 06:45:52',NULL,NULL),(12878,1706,'1950611','834','00','005010X220A1','1950611','','2014-01-03','15:03:35',0,'2014-01-04 02:04:04',NULL,NULL),(12519,1643,'1577747','834','00','005010X220A1','1577747','','2013-12-31','14:10:36',1,'2014-01-02 04:34:02',NULL,NULL),(15710,2704,'1447934','834','00','005010X220A1','1447934','','2014-01-18','20:23:48',0,'2014-01-21 08:45:35',NULL,NULL),(4621,827,'1481343','834','00','005010X220A1','1481343','','2013-12-23','22:05:44',0,'2013-12-25 23:47:56',NULL,NULL),(4173,734,'386155','834','00','005010X220A1','386155','','2013-12-19','11:05:42',0,'2013-12-25 23:05:22',NULL,NULL),(20584,3870,'2692546','834','00','005010X220A1','2692546','','2014-02-20','21:02:18',0,'2014-02-21 22:00:03',NULL,NULL),(19145,3549,'1679990','834','00','005010X220A1','1679990','','2014-02-12','16:23:13',0,'2014-02-12 21:32:05',NULL,NULL),(13465,2226,'1671281','834','00','005010X220A1','1671281','','2014-01-06','15:58:02',0,'2014-01-07 04:03:20',NULL,NULL),(18875,3494,'2768634','834','00','005010X220A1','2768634','','2014-02-11','01:56:54',0,'2014-02-11 21:02:14',NULL,NULL),(12865,1706,'1911182','834','00','005010X220A1','1911182','','2014-01-03','10:43:49',0,'2014-01-04 02:03:35',NULL,NULL),(2744,503,'1278994','834','00','005010X220A1','1278994','','2013-12-22','17:33:47',0,'2013-12-25 21:18:33',NULL,NULL),(3604,619,'192473','834','00','005010X220A1','192473','','2013-12-11','20:55:11',0,'2013-12-25 22:04:28',NULL,NULL),(20557,3863,'2518370','834','00','005010X220A1','2518370','','2014-02-21','10:51:40',0,'2014-02-21 21:30:08',NULL,NULL),(16244,2936,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:50:00',0,'2014-01-23 06:46:45',NULL,NULL),(4499,805,'1076530','834','00','005010X220A1','1076530','','2013-11-26','15:17:47',0,'2013-12-25 23:32:02',NULL,NULL),(11190,1453,'1613944','834','00','005010X220A1','1613944','','2013-12-26','08:47:01',0,'2013-12-27 02:00:08',NULL,NULL),(7227,1241,'837558','834','00','005010X220A1','837558','','2013-12-18','15:31:24',0,'2013-12-26 04:07:28',NULL,NULL),(2649,501,'984664','834','00','005010X220A1','984664','','2013-12-21','23:32:08',0,'2013-12-25 21:15:22',NULL,NULL),(20295,3795,'2879706','834','00','005010X220A1','2879706','','2014-02-19','11:52:37',0,'2014-02-20 04:41:52',NULL,NULL),(20543,3859,'2645122','834','00','005010X220A1','2645122','','2014-02-20','15:18:47',0,'2014-02-20 22:01:40',NULL,NULL),(22574,4248,'3865125','834','00','005010X220A1','3865125','','2014-03-05','14:36:11',0,'2014-03-05 21:30:59',NULL,NULL),(22698,4261,'3022645','834','00','005010X220A1','3022645','','2014-03-05','13:10:59',0,'2014-03-05 21:32:26',NULL,NULL),(15173,2591,'1526741','834','00','005010X220A1','1526741','','2014-01-14','22:11:06',0,'2014-01-16 08:46:09',NULL,NULL),(15075,2585,'2218203','834','00','005010X220A1','2218203','','2014-01-15','14:08:36',0,'2014-01-16 08:45:05',NULL,NULL),(11828,1541,'145635','834','00','005010X220A1','145635','','2013-12-28','20:12:52',1,'2013-12-29 11:13:59',NULL,NULL),(1506,258,'1772855','834','00','005010X220A1','1772855','','2013-12-24','11:32:30',0,'2013-12-25 18:57:33',NULL,NULL),(22053,4167,'3717466','834','00','005010X220A1','3717466','','2014-03-03','13:44:01',0,'2014-03-03 21:00:12',NULL,NULL),(19578,3629,'3414096','834','00','005010X220A1','3414096','','2014-02-13','19:30:40',0,'2014-02-14 21:31:22',NULL,NULL),(18455,3423,'2156083','834','00','005010X220A1','2156083','','2014-02-10','04:26:58',0,'2014-02-10 11:00:38',NULL,NULL),(12368,1634,'2038070','834','00','005010X220A1','2038070','','2013-12-31','17:16:42',1,'2014-01-02 04:28:30',NULL,NULL),(11398,1465,'544421','834','00','005010X220A1','544421','','2013-12-26','10:18:47',0,'2013-12-27 02:06:29',NULL,NULL),(11271,1455,'2093845','834','00','005010X220A1','2093845','','2013-12-26','11:59:06',0,'2013-12-27 02:02:37',NULL,NULL),(17584,3237,'2128623','834','00','005010X220A1','2128623','','2014-02-03','12:39:41',0,'2014-02-03 21:00:47',NULL,NULL),(2886,527,'1254693','834','00','005010X220A1','1254693','','2013-12-22','11:30:17',0,'2013-12-25 21:23:12',NULL,NULL),(2347,413,'1274826','834','00','005010X220A1','1274826','','2013-12-06','11:29:51',0,'2013-12-25 20:15:33',NULL,NULL),(21296,4006,'3300222','834','00','005010X220A1','3300222','','2014-02-26','16:14:04',0,'2014-02-26 21:02:21',NULL,NULL),(21956,4138,'3581907','834','00','005010X220A1','3581907','','2014-03-01','14:25:02',0,'2014-03-01 21:01:10',NULL,NULL),(18682,3470,'1892093','834','00','005010X220A1','1892093','','2014-02-10','09:46:39',0,'2014-02-10 21:32:00',NULL,NULL),(17981,3306,'2189508','834','00','005010X220A1','2189508','','2014-02-05','13:15:25',0,'2014-02-05 21:31:11',NULL,NULL),(12268,1623,'1969093','834','00','005010X220A1','1969093','','2014-01-01','10:35:23',1,'2014-01-02 04:24:10',NULL,NULL),(11323,1456,'1262162','834','00','005010X220A1','1262162','','2013-12-26','13:20:11',0,'2013-12-27 02:04:11',NULL,NULL),(16780,3080,'1434343','834','00','005010X220A1','1434343','','2014-01-27','13:55:36',0,'2014-01-27 21:01:41',NULL,NULL),(10429,1400,'299704','834','00','005010X220A1','299704','','2013-12-23','11:06:40',0,'2013-12-26 12:51:35',NULL,NULL),(15188,2592,'1561690','834','00','005010X220A1','1561690','','2014-01-14','20:37:52',0,'2014-01-16 08:46:18',NULL,NULL),(4086,733,'1089719','834','00','005010X220A1','1089719','','2013-12-19','10:13:31',0,'2013-12-25 23:02:52',NULL,NULL),(21303,4008,'2933564','834','00','005010X220A1','2933564','','2014-02-26','14:38:31',0,'2014-02-26 21:02:27',NULL,NULL),(21827,4098,'2917943','834','00','005010X220A1','2917943','','2014-02-28','12:19:52',0,'2014-02-28 21:31:40',NULL,NULL),(19300,3582,'2304623','834','00','005010X220A1','2304623','','2014-02-12','18:31:20',0,'2014-02-13 22:01:13',NULL,NULL),(12283,1624,'1906061','834','00','005010X220A1','1906061','','2013-12-31','23:41:06',1,'2014-01-02 04:24:39',NULL,NULL),(18208,3356,'1415831','834','00','005010X220A1','1415831','','2014-02-06','21:00:09',0,'2014-02-07 19:00:39',NULL,NULL),(10783,1404,'1571095','834','00','005010X220A1','1571095','','2013-12-23','10:45:07',0,'2013-12-26 13:03:20',NULL,NULL),(16302,2980,'1526992','834','00','005010X220A1','1526992','','2014-01-23','11:49:00',0,'2014-01-23 21:00:14',NULL,NULL),(15933,2751,'1920861','834','00','005010X220A1','1920861','','2014-01-21','13:43:40',1,'2014-01-22 03:23:01',NULL,NULL),(1991,328,'165630','834','00','005010X220A1','165630','','2013-12-08','19:57:23',0,'2013-12-25 19:34:31',NULL,NULL),(15187,2592,'1458727','834','00','005010X220A1','1458727','','2014-01-14','20:06:57',0,'2014-01-16 08:46:17',NULL,NULL),(14660,2535,'2288918','834','00','005010X220A1','2288918','','2014-01-13','14:37:18',0,'2014-01-14 01:33:45',NULL,NULL),(21676,4079,'2807230','834','00','005010X220A1','2807230','','2014-02-28','17:40:44',0,'2014-02-28 21:00:19',NULL,NULL),(22464,4238,'2998587','834','00','005010X220A1','2998587','','2014-03-05','10:55:02',0,'2014-03-05 21:00:13',NULL,NULL),(22626,4252,'2775969','834','00','005010X220A1','2775969','','2014-03-04','22:03:40',0,'2014-03-05 21:31:37',NULL,NULL),(1442,252,'513379','834','00','005010X220A1','513379','','2013-12-24','11:01:24',0,'2013-12-25 18:55:27',NULL,NULL),(19075,3542,'2963603','834','00','005010X220A1','2963603','','2014-02-12','10:30:43',0,'2014-02-12 21:31:21',NULL,NULL),(12891,1709,'2177687','834','00','005010X220A1','2177687','','2014-01-02','20:29:19',0,'2014-01-04 02:04:34',NULL,NULL),(12729,1682,'1966719','834','00','005010X220A1','1966719','','2014-01-02','17:00:21',0,'2014-01-03 02:05:54',NULL,NULL),(17616,3243,'2295979','834','00','005010X220A1','2295979','','2014-02-03','11:07:02',0,'2014-02-03 21:01:08',NULL,NULL),(17555,3236,'1564809','834','00','005010X220A1','1564809','','2014-02-02','23:01:25',0,'2014-02-03 21:00:29',NULL,NULL),(2321,407,'1026693','834','00','005010X220A1','1026693','','2013-10-21','20:19:16',0,'2013-12-25 20:01:57',NULL,NULL),(23037,4330,'3858964','834','00','005010X220A1','3858964','','2014-03-07','11:40:18',0,'2014-03-07 21:00:29',NULL,NULL),(15448,2630,'2187726','834','00','005010X220A1','2187726','','2014-01-15','19:27:19',0,'2014-01-17 03:36:09',NULL,NULL),(13119,1963,'0001','999','BE','005010X231A1','165485','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:31',NULL,NULL),(12910,1714,'1453359','834','00','005010X220A1','1453359','','2014-01-03','00:10:47',0,'2014-01-04 02:05:16',NULL,NULL),(12588,1670,'1917797','834','00','005010X220A1','1917797','','2014-01-02','15:40:03',0,'2014-01-03 02:00:41',NULL,NULL),(4841,883,'819303','834','00','005010X220A1','819303','','2013-11-21','14:22:48',0,'2013-12-26 00:15:19',NULL,NULL),(11784,1537,'1077535','834','00','005010X220A1','1077535','','2013-12-28','20:06:11',1,'2013-12-29 11:12:37',NULL,NULL),(7761,1349,'1121628','834','00','005010X220A1','1121628','','2013-10-20','19:18:18',0,'2013-12-26 05:01:14',NULL,NULL),(21740,4090,'3038111','834','00','005010X220A1','3038111','','2014-02-27','19:14:22',0,'2014-02-28 21:30:41',NULL,NULL),(22970,4313,'3190849','834','00','005010X220A1','3190849','','2014-03-06','16:21:36',0,'2014-03-06 21:30:10',NULL,NULL),(17844,3289,'2503952','834','00','005010X220A1','2503952','','2014-02-05','15:31:19',0,'2014-02-05 21:00:07',NULL,NULL),(15695,2698,'1559107','834','00','005010X220A1','1559107','','2014-01-19','11:12:11',0,'2014-01-21 08:45:24',NULL,NULL),(11570,1492,'1083823','834','00','005010X220A1','1083823','','2013-12-27','14:32:39',0,'2013-12-28 03:33:50',NULL,NULL),(7454,1296,'244225','834','00','005010X220A1','244225','','2013-12-20','23:54:46',0,'2013-12-26 04:32:30',NULL,NULL),(7236,1241,'1177499','834','00','005010X220A1','1177499','','2013-12-18','18:04:41',0,'2013-12-26 04:07:46',NULL,NULL),(5108,940,'115802','834','00','005010X220A1','115802','','2013-12-11','17:53:37',0,'2013-12-26 00:49:26',NULL,NULL),(14760,2551,'1451249','834','00','005010X220A1','1451249','','2014-01-13','22:16:19',0,'2014-01-15 02:06:28',NULL,NULL),(14652,2530,'2437436','834','00','005010X220A1','2437436','','2014-01-13','14:31:18',0,'2014-01-14 01:33:39',NULL,NULL),(329,72,'525482','834','00','005010X220A1','525482','','2013-12-04','05:17:48',0,'2013-12-25 17:46:07',NULL,NULL),(481,98,'1127183','834','00','005010X220A1','1127183','','2013-12-04','11:35:57',0,'2013-12-25 17:51:03',NULL,NULL),(20580,3868,'3445164','834','00','005010X220A1','3445164','','2014-02-21','12:55:21',0,'2014-02-21 21:30:23',NULL,NULL),(15912,2743,'1748149','834','00','005010X220A1','1748149','','2014-01-21','11:44:26',1,'2014-01-22 03:22:49',NULL,NULL),(11481,1488,'2220060','834','00','005010X220A1','2220060','','2013-12-27','16:02:00',0,'2013-12-28 03:31:07',NULL,NULL),(11413,1468,'2054376','834','00','005010X220A1','2054376','','2013-12-26','11:07:11',0,'2013-12-27 02:06:58',NULL,NULL),(11080,1422,'107591','834','00','005010X220A1','107591','','2013-12-23','15:34:58',0,'2013-12-26 13:13:27',NULL,NULL),(15175,2591,'1575820','834','00','005010X220A1','1575820','','2014-01-15','12:49:30',0,'2014-01-16 08:46:10',NULL,NULL),(13807,2296,'2134245','834','00','005010X220A1','2134245','','2014-01-10','18:40:29',0,'2014-01-13 02:18:19',NULL,NULL),(2097,355,'1138134','834','00','005010X220A1','1138134','','2013-12-09','16:53:58',0,'2013-12-25 19:37:57',NULL,NULL),(7326,1271,'733834','834','00','005010X220A1','733834','','2013-12-18','14:43:29',0,'2013-12-26 04:10:31',NULL,NULL),(4721,841,'411037','834','00','005010X220A1','411037','','2013-12-23','22:11:15',0,'2013-12-25 23:51:22',NULL,NULL),(4687,833,'948481','834','00','005010X220A1','948481','','2013-12-24','00:25:15',0,'2013-12-25 23:50:12',NULL,NULL),(4595,826,'1536295','834','00','005010X220A1','1536295','','2013-12-23','23:45:15',0,'2013-12-25 23:47:07',NULL,NULL),(3627,622,'609669','834','00','005010X220A1','609669','','2013-12-11','20:52:19',0,'2013-12-25 22:05:11',NULL,NULL),(20963,3956,'3676402','834','00','005010X220A1','3676402','','2014-02-21','18:05:19',0,'2014-02-26 08:30:02',NULL,NULL),(20859,3911,'2836317','834','00','005010X220A1','2836317','','2014-02-25','17:12:59',0,'2014-02-25 21:31:37',NULL,NULL),(19775,3675,'3561491','834','00','005010X220A1','3561491','','2014-02-15','11:01:52',0,'2014-02-15 22:01:02',NULL,NULL),(12204,1613,'2169797','834','00','005010X220A1','2169797','','2013-12-30','15:34:26',0,'2014-01-01 12:09:27',NULL,NULL),(11872,1560,'2194804','834','00','005010X220A1','2194804','','2013-12-28','21:07:55',0,'2013-12-30 00:00:08',NULL,NULL),(10576,1402,'415889','834','00','005010X220A1','415889','','2013-12-23','11:17:34',0,'2013-12-26 12:56:24',NULL,NULL),(3057,544,'475324','834','00','005010X220A1','475324','','2013-12-13','14:38:01',0,'2013-12-25 21:34:50',NULL,NULL),(3055,544,'823764','834','00','005010X220A1','823764','','2013-12-13','14:12:54',0,'2013-12-25 21:34:47',NULL,NULL),(18367,3406,'2370857','834','00','005010X220A1','2370857','','2014-02-08','20:59:35',0,'2014-02-09 19:00:13',NULL,NULL),(16032,2770,'1412786','834','00','005010X220A1','1412786','','2014-01-21','20:37:30',0,'2014-01-23 03:02:27',NULL,NULL),(2357,413,'225388','834','00','005010X220A1','225388','','2013-12-06','18:08:40',0,'2013-12-25 20:15:51',NULL,NULL),(15418,2629,'2180854','834','00','005010X220A1','2180854','','2014-01-15','23:11:53',0,'2014-01-17 03:35:56',NULL,NULL),(3935,714,'1233689','834','00','005010X220A1','1233689','','2013-12-06','21:56:29',0,'2013-12-25 22:46:05',NULL,NULL),(4528,821,'1311178','834','00','005010X220A1','1311178','','2013-11-26','17:34:08',0,'2013-12-25 23:33:02',NULL,NULL),(7645,1310,'254670','834','00','005010X220A1','254670','','2013-12-21','09:18:05',0,'2013-12-26 04:38:40',NULL,NULL),(5071,936,'981580','834','00','005010X220A1','981580','','2013-12-11','13:16:43',0,'2013-12-26 00:48:17',NULL,NULL),(21760,4090,'3026906','834','00','005010X220A1','3026906','','2014-02-28','12:47:18',0,'2014-02-28 21:30:53',NULL,NULL),(22704,4263,'2950655','834','00','005010X220A1','2950655','','2014-03-05','17:05:37',0,'2014-03-05 21:32:31',NULL,NULL),(22761,4276,'3083964','834','00','005010X220A1','3083964','','2014-03-06','16:57:00',0,'2014-03-06 21:00:37',NULL,NULL),(18677,3467,'1994088','834','00','005010X220A1','1994088','','2014-02-10','17:14:11',0,'2014-02-10 21:31:57',NULL,NULL),(16235,2927,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',0,'2014-01-23 06:41:42',NULL,NULL),(7484,1297,'1256950','834','00','005010X220A1','1256950','','2013-12-21','14:01:18',0,'2013-12-26 04:33:27',NULL,NULL),(15296,2618,'2063228','834','00','005010X220A1','2063228','','2014-01-15','14:57:56',0,'2014-01-16 08:47:28',NULL,NULL),(4080,733,'965975','834','00','005010X220A1','965975','','2013-12-19','09:06:13',0,'2013-12-25 23:02:40',NULL,NULL),(7420,1295,'361075','834','00','005010X220A1','361075','','2013-12-21','10:09:04',0,'2013-12-26 04:31:31',NULL,NULL),(1900,325,'954273','834','00','005010X220A1','954273','','2013-12-09','12:32:40',0,'2013-12-25 19:31:46',NULL,NULL),(21438,4027,'3468020','834','00','005010X220A1','3468020','','2014-02-27','14:51:33',0,'2014-02-28 06:30:53',NULL,NULL),(20444,3841,'3341039','834','00','005010X220A1','3341039','','2014-02-20','15:59:43',0,'2014-02-20 22:00:18',NULL,NULL),(4352,760,'527485','834','00','005010X220A1','527485','','2013-12-19','09:42:25',0,'2013-12-25 23:10:50',NULL,NULL),(17919,3296,'2457084','834','00','005010X220A1','2457084','','2014-02-05','10:31:52',0,'2014-02-05 21:30:40',NULL,NULL),(16647,3060,'2618644','834','00','005010X220A1','2618644','','2014-01-27','11:20:40',0,'2014-01-27 21:00:09',NULL,NULL),(13135,1979,'0001','999','BE','005010X231A1','212515','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:19',NULL,NULL),(15829,2736,'2278581','834','00','005010X220A1','2278581','','2014-01-21','14:00:10',1,'2014-01-22 03:21:55',NULL,NULL),(16317,2980,'2574930','834','00','005010X220A1','2574930','','2014-01-23','15:48:07',0,'2014-01-23 21:00:25',NULL,NULL),(21410,4026,'3167555','834','00','005010X220A1','3167555','','2014-02-26','19:51:34',0,'2014-02-28 06:30:39',NULL,NULL),(22387,4209,'3492556','834','00','005010X220A1','3492556','','2014-03-03','20:59:39',0,'2014-03-04 21:02:08',NULL,NULL),(23413,4404,'3406497','834','00','005010X220A1','3406497','','2014-03-09','13:27:11',0,'2014-03-09 21:00:21',NULL,NULL),(23449,4409,'3146854','834','00','005010X220A1','3146854','','2014-03-08','21:55:21',0,'2014-03-09 21:00:49',NULL,NULL),(19337,3583,'3026517','834','00','005010X220A1','3026517','','2014-02-13','14:21:25',0,'2014-02-13 22:01:41',NULL,NULL),(634,108,'84677','834','00','005010X220A1','84677','','2013-12-16','12:12:15',0,'2013-12-25 18:04:43',NULL,NULL),(789,146,'295164','834','00','005010X220A1','295164','','2013-10-28','22:10:40',0,'2013-12-25 18:09:46',NULL,NULL),(14938,2561,'1588214','834','00','005010X220A1','1588214','','2014-01-14','14:32:22',0,'2014-01-15 02:07:46',NULL,NULL),(5191,949,'616454','834','00','005010X220A1','616454','','2013-12-11','11:34:39',0,'2013-12-26 00:52:03',NULL,NULL),(1722,293,'188412','834','00','005010X220A1','188412','','2013-12-09','21:50:10',0,'2013-12-25 19:17:08',NULL,NULL),(4624,827,'1561067','834','00','005010X220A1','1561067','','2013-12-23','22:14:26',0,'2013-12-25 23:48:02',NULL,NULL),(4289,744,'231019','834','00','005010X220A1','231019','','2013-12-19','14:41:52',0,'2013-12-25 23:08:58',NULL,NULL),(10408,1400,'504548','834','00','005010X220A1','504548','','2013-12-23','09:15:01',0,'2013-12-26 12:50:56',NULL,NULL),(11857,1553,'1825382','834','00','005010X220A1','1825382','','2013-12-28','20:19:43',1,'2013-12-29 11:15:02',NULL,NULL),(13880,2312,'1755581','834','00','005010X220A1','1755581','','2014-01-09','12:32:19',0,'2014-01-13 02:19:32',NULL,NULL),(22091,4176,'3043240','834','00','005010X220A1','3043240','','2014-03-03','07:28:02',0,'2014-03-03 21:30:11',NULL,NULL),(23041,4332,'3459368','834','00','005010X220A1','3459368','','2014-03-07','11:15:14',0,'2014-03-07 21:00:31',NULL,NULL),(19785,3675,'3001519','834','00','005010X220A1','3001519','','2014-02-15','14:13:04',0,'2014-02-15 22:01:10',NULL,NULL),(16177,2869,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:01:00',1,'2014-01-23 04:20:36',NULL,NULL),(794,147,'60107','834','00','005010X220A1','60107','','2013-10-28','19:16:42',0,'2013-12-25 18:09:57',NULL,NULL),(1184,239,'1630479','834','00','005010X220A1','1630479','','2013-12-24','15:19:02',0,'2013-12-25 18:47:16',NULL,NULL),(3343,587,'1291415','834','00','005010X220A1','1291415','','2013-12-16','20:25:58',0,'2013-12-25 21:49:57',NULL,NULL),(15492,2634,'1936548','834','00','005010X220A1','1936548','','2014-01-16','16:21:02',0,'2014-01-17 03:36:27',NULL,NULL),(2359,413,'453619','834','00','005010X220A1','453619','','2013-12-05','20:47:24',0,'2013-12-25 20:15:55',NULL,NULL),(7306,1262,'897482','834','00','005010X220A1','897482','','2013-12-18','16:26:42',0,'2013-12-26 04:09:54',NULL,NULL),(21440,4027,'2608728','834','00','005010X220A1','2608728','','2014-02-27','15:29:08',0,'2014-02-28 06:30:54',NULL,NULL),(22221,4190,'2799523','834','00','005010X220A1','2799523','','2014-03-03','11:28:34',0,'2014-03-03 21:31:48',NULL,NULL),(120,7,'276188','834','00','005010X220A1','276188','','2013-12-05','07:22:33',0,'2013-12-25 17:18:40',NULL,NULL),(18805,3487,'3203825','834','00','005010X220A1','3203825','','2014-02-11','16:54:31',0,'2014-02-11 21:01:19',NULL,NULL),(17692,3260,'1515478','834','00','005010X220A1','1515478','','2014-02-03','18:42:37',0,'2014-02-04 21:00:25',NULL,NULL),(21374,4024,'3639153','834','00','005010X220A1','3639153','','2014-02-27','12:17:09',0,'2014-02-28 06:30:22',NULL,NULL),(23071,4339,'3602161','834','00','005010X220A1','3602161','','2014-03-07','09:48:54',0,'2014-03-07 21:30:14',NULL,NULL),(2288,395,'514872','834','00','005010X220A1','514872','','2013-11-24','16:13:56',0,'2013-12-25 20:00:46',NULL,NULL),(19645,3646,'1985281','834','00','005010X220A1','1985281','','2014-02-14','11:22:58',0,'2014-02-14 21:32:10',NULL,NULL),(3902,711,'520932','834','00','005010X220A1','520932','','2013-12-07','16:27:14',0,'2013-12-25 22:45:04',NULL,NULL),(18957,3532,'2806713','834','00','005010X220A1','2806713','','2014-02-11','22:16:58',0,'2014-02-12 21:00:09',NULL,NULL),(7495,1300,'343932','834','00','005010X220A1','343932','','2013-12-20','20:06:52',0,'2013-12-26 04:33:52',NULL,NULL),(18652,3464,'2529202','834','00','005010X220A1','2529202','','2014-02-10','12:13:37',0,'2014-02-10 21:31:41',NULL,NULL),(16990,3118,'2273071','834','00','005010X220A1','2273071','','2014-01-29','08:01:04',0,'2014-01-29 21:00:48',NULL,NULL),(13773,2286,'2004032','834','00','005010X220A1','2004032','','2014-01-07','16:50:36',0,'2014-01-08 18:25:02',NULL,NULL),(13037,1881,'0001','999','BE','005010X231A1','1225887','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:44',NULL,NULL),(18892,3498,'3184735','834','00','005010X220A1','3184735','','2014-02-11','16:37:50',0,'2014-02-11 21:02:28',NULL,NULL),(16897,3100,'2570180','834','00','005010X220A1','2570180','','2014-01-28','11:24:34',0,'2014-01-28 21:01:11',NULL,NULL),(1842,320,'88488','834','00','005010X220A1','88488','','2013-12-10','17:02:47',0,'2013-12-25 19:21:01',NULL,NULL),(4145,733,'199298','834','00','005010X220A1','199298','','2013-12-19','16:52:38',0,'2013-12-25 23:04:32',NULL,NULL),(4543,825,'1631712','834','00','005010X220A1','1631712','','2013-12-23','22:06:52',0,'2013-12-25 23:45:27',NULL,NULL),(12618,1671,'1368977','834','00','005010X220A1','1368977','','2014-01-02','13:24:25',0,'2014-01-03 02:01:43',NULL,NULL),(11671,1505,'1712668','834','00','005010X220A1','1712668','','2013-12-27','10:46:30',0,'2013-12-28 03:36:57',NULL,NULL),(425,77,'407583','834','00','005010X220A1','407583','','2013-12-04','11:02:43',0,'2013-12-25 17:49:10',NULL,NULL),(7049,1235,'1243402','834','00','005010X220A1','1243402','','2013-12-18','17:18:37',0,'2013-12-26 04:02:00',NULL,NULL),(20673,3881,'2890824','834','00','005010X220A1','2890824','','2014-02-20','19:22:38',0,'2014-02-21 22:01:08',NULL,NULL),(6095,1166,'555335','834','00','005010X220A1','555335','','2013-12-20','08:49:13',0,'2013-12-26 03:01:10',NULL,NULL),(4693,833,'1515700','834','00','005010X220A1','1515700','','2013-12-24','01:08:12',0,'2013-12-25 23:50:24',NULL,NULL),(5466,1040,'1940779','834','00','005010X220A1','1940779','','2013-12-24','20:42:00',0,'2013-12-26 01:45:20',NULL,NULL),(20430,3840,'3334170','834','00','005010X220A1','3334170','','2014-02-20','15:00:41',0,'2014-02-20 22:00:06',NULL,NULL),(11149,1435,'1314842','834','00','005010X220A1','1314842','','2013-12-23','07:13:12',0,'2013-12-26 13:15:52',NULL,NULL),(13312,2156,'0001','999','BE','005010X231A1','272694','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:45',NULL,NULL),(15807,2726,'2381559','834','00','005010X220A1','2381559','','2014-01-19','20:45:46',0,'2014-01-21 08:46:52',NULL,NULL),(15838,2737,'1885712','834','00','005010X220A1','1885712','','2014-01-21','11:20:39',1,'2014-01-22 03:22:01',NULL,NULL),(17302,3173,'2040277','834','00','005010X220A1','2040277','','2014-01-30','18:43:19',0,'2014-01-31 21:00:42',NULL,NULL),(21665,4077,'3142760','834','00','005010X220A1','3142760','','2014-02-28','17:14:54',0,'2014-02-28 21:00:10',NULL,NULL),(20140,3773,'2806975','834','00','005010X220A1','2806975','','2014-02-19','15:10:40',0,'2014-02-20 04:01:12',NULL,NULL),(7330,1274,'672310','834','00','005010X220A1','672310','','2013-12-18','15:57:57',0,'2013-12-26 04:10:39',NULL,NULL),(7275,1254,'543886','834','00','005010X220A1','543886','','2013-12-18','09:23:56',0,'2013-12-26 04:08:57',NULL,NULL),(661,108,'135355','834','00','005010X220A1','135355','','2013-12-16','17:07:31',0,'2013-12-25 18:05:32',NULL,NULL),(16492,3011,'2079258','834','00','005010X220A1','2079258','','2014-01-24','11:59:27',0,'2014-01-24 21:00:36',NULL,NULL),(2599,483,'770482','834','00','005010X220A1','770482','','2013-10-06','12:13:36',0,'2013-12-25 20:46:00',NULL,NULL),(16387,2989,'2370486','834','00','005010X220A1','2370486','','2014-01-23','17:42:25',0,'2014-01-23 21:01:14',NULL,NULL),(14154,2360,'2558226','834','00','005010X220A1','2558226','','2014-01-08','14:58:39',0,'2014-01-13 02:22:46',NULL,NULL),(22514,4247,'3447867','834','00','005010X220A1','3447867','','2014-03-05','12:06:39',0,'2014-03-05 21:30:17',NULL,NULL),(23447,4408,'3885171','834','00','005010X220A1','3885171','','2014-03-09','11:33:22',0,'2014-03-09 21:00:48',NULL,NULL),(20354,3814,'2819696','834','00','005010X220A1','2819696','','2014-02-19','15:22:36',0,'2014-02-20 04:55:41',NULL,NULL),(18571,3453,'2475860','834','00','005010X220A1','2475860','','2014-02-10','13:42:21',0,'2014-02-10 21:30:43',NULL,NULL),(1457,252,'1688147','834','00','005010X220A1','1688147','','2013-12-24','13:43:13',0,'2013-12-25 18:55:58',NULL,NULL),(6147,1166,'132799','834','00','005010X220A1','132799','','2013-12-20','17:49:14',0,'2013-12-26 03:02:43',NULL,NULL),(1596,281,'786357','834','00','005010X220A1','786357','','2013-11-19','22:58:25',0,'2013-12-25 19:01:07',NULL,NULL),(5755,1071,'555051','834','00','005010X220A1','555051','','2013-12-14','00:41:07',0,'2013-12-26 02:02:04',NULL,NULL),(18439,3421,'2098208','834','00','005010X220A1','2098208','','2014-02-10','03:56:24',0,'2014-02-10 11:00:24',NULL,NULL),(17369,3184,'2653761','834','00','005010X220A1','2653761','','2014-01-31','15:26:09',0,'2014-01-31 21:01:30',NULL,NULL),(14435,2456,'0001','999','BE','005010X231A1','28823','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:07',NULL,NULL),(2805,506,'317282','834','00','005010X220A1','317282','','2013-12-22','14:14:55',0,'2013-12-25 21:20:29',NULL,NULL),(4116,733,'119982','834','00','005010X220A1','119982','','2013-12-19','13:35:01',0,'2013-12-25 23:03:43',NULL,NULL),(3984,721,'676015','834','00','005010X220A1','676015','','2013-12-07','11:34:14',0,'2013-12-25 22:47:40',NULL,NULL),(3279,583,'1159870','834','00','005010X220A1','1159870','','2013-12-17','01:53:52',0,'2013-12-25 21:47:47',NULL,NULL),(13730,2275,'1778445','834','00','005010X220A1','1778445','','2014-01-07','09:22:59',0,'2014-01-08 18:24:42',NULL,NULL),(22825,4278,'2803779','834','00','005010X220A1','2803779','','2014-03-06','15:08:18',0,'2014-03-06 21:01:21',NULL,NULL),(18635,3462,'2959495','834','00','005010X220A1','2959495','','2014-02-09','21:40:10',0,'2014-02-10 21:31:29',NULL,NULL),(7290,1256,'757751','834','00','005010X220A1','757751','','2013-12-18','10:35:28',0,'2013-12-26 04:09:24',NULL,NULL),(5936,1112,'216800','834','00','005010X220A1','216800','','2013-12-15','16:59:56',0,'2013-12-26 02:31:54',NULL,NULL),(1799,304,'88490','834','00','005010X220A1','88490','','2013-12-10','17:07:19',0,'2013-12-25 19:19:37',NULL,NULL),(18472,3429,'2507533','834','00','005010X220A1','2507533','','2014-02-10','04:10:23',0,'2014-02-10 11:00:53',NULL,NULL),(2712,502,'1230214','834','00','005010X220A1','1230214','','2013-12-22','18:18:31',0,'2013-12-25 21:17:33',NULL,NULL),(2351,413,'1343760','834','00','005010X220A1','1343760','','2013-12-06','14:35:23',0,'2013-12-25 20:15:41',NULL,NULL),(11484,1488,'1963892','834','00','005010X220A1','1963892','','2013-12-27','16:53:50',0,'2013-12-28 03:31:12',NULL,NULL),(11514,1490,'418517','834','00','005010X220A1','418517','','2013-12-27','11:01:57',0,'2013-12-28 03:32:04',NULL,NULL),(18471,3429,'1693089','834','00','005010X220A1','1693089','','2014-02-10','04:09:52',0,'2014-02-10 11:00:52',NULL,NULL),(13516,2235,'2272519','834','00','005010X220A1','2272519','','2014-01-06','09:06:47',0,'2014-01-07 04:05:16',NULL,NULL),(14003,2335,'2358938','834','00','005010X220A1','2358938','','2014-01-09','11:29:10',0,'2014-01-13 02:21:00',NULL,NULL),(14302,2386,'1843445','834','00','005010X220A1','1843445','','2014-01-10','12:27:28',0,'2014-01-13 03:00:30',NULL,NULL),(23626,4441,'3747678','834','00','005010X220A1','3747678','','2014-03-10','11:13:10',0,'2014-03-10 21:01:34',NULL,NULL),(585,104,'143903','834','00','005010X220A1','143903','','2013-12-15','22:33:37',0,'2013-12-25 18:03:05',NULL,NULL),(21101,3991,'3589235','834','00','005010X220A1','3589235','','2014-02-24','16:14:40',0,'2014-02-26 09:31:07',NULL,NULL),(6218,1168,'504364','834','00','005010X220A1','504364','','2013-12-20','09:38:49',0,'2013-12-26 03:04:51',NULL,NULL),(5259,969,'975604','834','00','005010X220A1','975604','','2013-12-11','17:10:24',0,'2013-12-26 00:54:20',NULL,NULL),(20783,3907,'3156294','834','00','005010X220A1','3156294','','2014-02-25','16:09:53',0,'2014-02-25 21:30:43',NULL,NULL),(18763,3485,'3267417','834','00','005010X220A1','3267417','','2014-02-11','17:17:46',0,'2014-02-11 21:00:48',NULL,NULL),(16225,2917,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',0,'2014-01-23 06:30:13',NULL,NULL),(15571,2657,'2350927','834','00','005010X220A1','2350927','','2014-01-17','05:09:51',0,'2014-01-20 08:06:04',NULL,NULL),(21696,4087,'3778292','834','00','005010X220A1','3778292','','2014-02-28','12:02:28',0,'2014-02-28 21:30:08',NULL,NULL),(22835,4278,'3306740','834','00','005010X220A1','3306740','','2014-03-06','17:25:58',0,'2014-03-06 21:01:28',NULL,NULL),(21134,3996,'2887249','834','00','005010X220A1','2887249','','2014-02-26','08:32:27',0,'2014-02-26 21:00:34',NULL,NULL),(2187,363,'929645','834','00','005010X220A1','929645','','2013-12-02','13:14:07',0,'2013-12-25 19:47:43',NULL,NULL),(6298,1174,'510519','834','00','005010X220A1','510519','','2013-12-19','19:35:38',0,'2013-12-26 03:07:21',NULL,NULL),(20498,3846,'2714881','834','00','005010X220A1','2714881','','2014-02-19','19:34:41',0,'2014-02-20 22:01:02',NULL,NULL),(17117,3142,'1849861','834','00','005010X220A1','1849861','','2014-01-30','16:10:52',0,'2014-01-30 21:00:16',NULL,NULL),(2663,501,'1349606','834','00','005010X220A1','1349606','','2013-12-22','14:38:37',0,'2013-12-25 21:15:57',NULL,NULL),(15842,2738,'1578265','834','00','005010X220A1','1578265','','2014-01-20','18:42:17',1,'2014-01-22 03:22:04',NULL,NULL),(10968,1410,'1428252','834','00','005010X220A1','1428252','','2013-12-23','19:04:14',0,'2013-12-26 13:09:40',NULL,NULL),(13176,2020,'0001','999','BE','005010X231A1','878207','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:45',NULL,NULL),(14106,2343,'2200045','834','00','005010X220A1','2200045','','2014-01-08','17:13:56',0,'2014-01-13 02:22:14',NULL,NULL),(14297,2384,'1417655','834','00','005010X220A1','1417655','','2014-01-10','12:06:10',0,'2014-01-13 03:00:26',NULL,NULL),(14810,2552,'2568543','834','00','005010X220A1','2568543','','2014-01-13','21:34:42',0,'2014-01-15 02:06:49',NULL,NULL),(23028,4327,'3867378','834','00','005010X220A1','3867378','','2014-03-07','09:32:21',0,'2014-03-07 21:00:24',NULL,NULL),(20443,3841,'3091783','834','00','005010X220A1','3091783','','2014-02-20','15:42:47',0,'2014-02-20 22:00:17',NULL,NULL),(1609,281,'150028','834','00','005010X220A1','150028','','2013-11-19','23:00:53',0,'2013-12-25 19:01:26',NULL,NULL),(18768,3486,'3167095','834','00','005010X220A1','3167095','','2014-02-10','19:14:31',0,'2014-02-11 21:00:52',NULL,NULL),(2307,402,'902968','834','00','005010X220A1','902968','','2013-11-01','21:13:42',0,'2013-12-25 20:01:28',NULL,NULL),(18154,3350,'2938544','834','00','005010X220A1','2938544','','2014-02-06','18:21:37',0,'2014-02-07 19:00:03',NULL,NULL),(17275,3170,'1501580','834','00','005010X220A1','1501580','','2014-01-31','15:56:09',0,'2014-01-31 21:00:24',NULL,NULL),(16929,3115,'2239231','834','00','005010X220A1','2239231','','2014-01-28','20:13:03',0,'2014-01-29 21:00:09',NULL,NULL),(22693,4259,'2617401','834','00','005010X220A1','2617401','','2014-03-05','14:43:49',0,'2014-03-05 21:32:23',NULL,NULL),(23764,4479,'2616214','834','00','005010X220A1','2616214','','2014-03-10','13:10:08',0,'2014-03-10 21:30:13',NULL,NULL),(2534,455,'497507','834','00','005010X220A1','497507','','2013-11-18','17:39:34',0,'2013-12-25 20:31:01',NULL,NULL),(17483,3220,'2171767','834','00','005010X220A1','2171767','','2014-02-01','19:30:37',0,'2014-02-02 19:00:14',NULL,NULL),(13956,2320,'2596140','834','00','005010X220A1','2596140','','2014-01-09','15:09:55',0,'2014-01-13 02:20:24',NULL,NULL),(13955,2320,'2118108','834','00','005010X220A1','2118108','','2014-01-09','13:22:17',0,'2014-01-13 02:20:23',NULL,NULL),(12645,1672,'2411287','834','00','005010X220A1','2411287','','2014-01-02','00:34:18',0,'2014-01-03 02:02:44',NULL,NULL),(4308,749,'547923','834','00','005010X220A1','547923','','2013-12-19','16:38:35',0,'2013-12-25 23:09:31',NULL,NULL),(12211,1615,'2480069','834','00','005010X220A1','2480069','','2014-01-01','09:02:25',1,'2014-01-02 04:21:55',NULL,NULL),(23693,4450,'3941610','834','00','005010X220A1','3941610','','2014-03-10','14:55:28',0,'2014-03-10 21:02:23',NULL,NULL),(354,72,'31373','834','00','005010X220A1','31373','','2013-12-04','16:34:34',0,'2013-12-25 17:46:54',NULL,NULL),(16811,3090,'1553057','834','00','005010X220A1','1553057','','2014-01-27','18:47:18',0,'2014-01-28 21:00:14',NULL,NULL),(16624,3050,'2255906','834','00','005010X220A1','2255906','','2014-01-26','17:14:33',0,'2014-01-26 19:00:20',NULL,NULL),(15820,2734,'2095668','834','00','005010X220A1','2095668','','2014-01-20','17:11:44',0,'2014-01-21 08:47:00',NULL,NULL),(3503,615,'139807','834','00','005010X220A1','139807','','2013-12-12','14:40:58',0,'2013-12-25 22:01:18',NULL,NULL),(13496,2229,'1604070','834','00','005010X220A1','1604070','','2014-01-06','14:12:18',0,'2014-01-07 04:04:28',NULL,NULL),(7276,1254,'1001020','834','00','005010X220A1','1001020','','2013-12-18','11:27:37',0,'2013-12-26 04:08:58',NULL,NULL),(22448,4231,'3180657','834','00','005010X220A1','3180657','','2014-03-04','16:07:13',0,'2014-03-04 21:30:15',NULL,NULL),(790,146,'738108','834','00','005010X220A1','738108','','2013-10-29','07:50:38',0,'2013-12-25 18:09:48',NULL,NULL),(10593,1402,'629876','834','00','005010X220A1','629876','','2013-12-23','12:26:29',0,'2013-12-26 12:56:55',NULL,NULL),(5257,968,'1055560','834','00','005010X220A1','1055560','','2013-12-11','16:54:53',0,'2013-12-26 00:54:17',NULL,NULL),(1111,237,'671497','834','00','005010X220A1','671497','','2013-10-09','13:03:34',0,'2013-12-25 18:32:28',NULL,NULL),(3377,587,'556356','834','00','005010X220A1','556356','','2013-12-17','15:24:43',0,'2013-12-25 21:50:59',NULL,NULL),(3652,625,'883995','834','00','005010X220A1','883995','','2013-12-12','11:32:55',0,'2013-12-25 22:06:00',NULL,NULL),(4724,842,'996170','834','00','005010X220A1','996170','','2013-12-23','23:10:16',0,'2013-12-25 23:51:31',NULL,NULL),(5222,952,'1111609','834','00','005010X220A1','1111609','','2013-12-11','12:53:55',0,'2013-12-26 00:53:07',NULL,NULL),(23280,4380,'3291885','834','00','005010X220A1','3291885','','2014-03-08','08:54:52',0,'2014-03-08 21:30:05',NULL,NULL),(20678,3882,'3445151','834','00','005010X220A1','3445151','','2014-02-20','19:26:41',0,'2014-02-21 22:01:11',NULL,NULL),(1880,325,'808040','834','00','005010X220A1','808040','','2013-12-08','19:54:31',0,'2013-12-25 19:31:13',NULL,NULL),(2713,502,'1395216','834','00','005010X220A1','1395216','','2013-12-22','18:22:10',0,'2013-12-25 21:17:36',NULL,NULL),(5880,1109,'83461','834','00','005010X220A1','83461','','2013-12-14','18:42:47',0,'2013-12-26 02:30:07',NULL,NULL),(4635,827,'1303370','834','00','005010X220A1','1303370','','2013-12-23','23:23:28',0,'2013-12-25 23:48:25',NULL,NULL),(11796,1537,'499559','834','00','005010X220A1','499559','','2013-12-28','20:24:46',1,'2013-12-29 11:12:59',NULL,NULL),(12544,1652,'1284107','834','00','005010X220A1','1284107','','2013-12-31','11:57:08',1,'2014-01-02 04:35:00',NULL,NULL),(17604,3240,'1409015','834','00','005010X220A1','1409015','','2014-02-03','15:16:22',0,'2014-02-03 21:01:01',NULL,NULL),(18585,3453,'3181314','834','00','005010X220A1','3181314','','2014-02-10','16:18:16',0,'2014-02-10 21:30:53',NULL,NULL),(10796,1404,'662696','834','00','005010X220A1','662696','','2013-12-23','13:11:32',0,'2013-12-26 13:03:44',NULL,NULL),(18362,3405,'2523081','834','00','005010X220A1','2523081','','2014-02-09','14:11:48',0,'2014-02-09 19:00:10',NULL,NULL),(11561,1492,'1637856','834','00','005010X220A1','1637856','','2013-12-27','11:11:40',0,'2013-12-28 03:33:32',NULL,NULL),(16212,2904,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:47:00',1,'2014-01-23 05:02:45',NULL,NULL),(13334,2178,'0001','999','BE','005010X231A1','1166929','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:46',NULL,NULL),(14056,2339,'1454959','834','00','005010X220A1','1454959','','2014-01-08','10:07:04',0,'2014-01-13 02:21:40',NULL,NULL),(496,102,'432847','834','00','005010X220A1','432847','','2013-12-16','07:05:40',0,'2013-12-25 18:00:21',NULL,NULL),(10669,1403,'92688','834','00','005010X220A1','92688','','2013-12-22','19:48:28',0,'2013-12-26 12:59:23',NULL,NULL),(10411,1400,'271480','834','00','005010X220A1','271480','','2013-12-23','09:18:04',0,'2013-12-26 12:51:03',NULL,NULL),(19658,3651,'2055608','834','00','005010X220A1','2055608','','2014-02-14','10:16:29',0,'2014-02-14 21:32:21',NULL,NULL),(19484,3620,'2484776','834','00','005010X220A1','2484776','','2014-02-14','00:09:22',0,'2014-02-14 21:30:15',NULL,NULL),(17005,3118,'1455455','834','00','005010X220A1','1455455','','2014-01-29','14:15:38',0,'2014-01-29 21:00:57',NULL,NULL),(14590,2521,'2492377','834','00','005010X220A1','2492377','','2014-01-13','12:06:42',0,'2014-01-14 01:32:59',NULL,NULL),(2443,420,'1085620','834','00','005010X220A1','1085620','','2013-12-05','22:50:11',0,'2013-12-25 20:18:35',NULL,NULL),(23679,4445,'3135779','834','00','005010X220A1','3135779','','2014-03-10','17:41:00',0,'2014-03-10 21:02:12',NULL,NULL),(1360,245,'439134','834','00','005010X220A1','439134','','2013-12-24','14:54:10',0,'2013-12-25 18:52:45',NULL,NULL),(20991,3958,'3524657','834','00','005010X220A1','3524657','','2014-02-22','15:20:10',0,'2014-02-26 08:30:31',NULL,NULL),(10745,1403,'226120','834','00','005010X220A1','226120','','2013-12-23','16:30:38',0,'2013-12-26 13:02:02',NULL,NULL),(19363,3588,'1724470','834','00','005010X220A1','1724470','','2014-02-12','20:32:56',0,'2014-02-13 22:02:02',NULL,NULL),(5458,1040,'1422271','834','00','005010X220A1','1422271','','2013-12-24','18:46:04',0,'2013-12-26 01:45:04',NULL,NULL),(22559,4248,'2950627','834','00','005010X220A1','2950627','','2014-03-05','12:15:56',0,'2014-03-05 21:30:50',NULL,NULL),(22913,4286,'3275526','834','00','005010X220A1','3275526','','2014-03-06','12:44:11',0,'2014-03-06 21:02:25',NULL,NULL),(913,177,'539400','834','00','005010X220A1','539400','','2013-12-03','16:38:31',0,'2013-12-25 18:17:27',NULL,NULL),(20438,3841,'2938918','834','00','005010X220A1','2938918','','2014-02-20','10:02:32',0,'2014-02-20 22:00:13',NULL,NULL),(17356,3181,'1963471','834','00','005010X220A1','1963471','','2014-01-31','14:43:08',0,'2014-01-31 21:01:20',NULL,NULL),(6060,1164,'376585','834','00','005010X220A1','376585','','2013-12-19','18:47:41',0,'2013-12-26 03:00:02',NULL,NULL),(2136,360,'827773','834','00','005010X220A1','827773','','2013-12-02','12:57:30',0,'2013-12-25 19:46:00',NULL,NULL),(2675,502,'533838','834','00','005010X220A1','533838','','2013-12-21','18:29:50',0,'2013-12-25 21:16:23',NULL,NULL),(16943,3115,'1931661','834','00','005010X220A1','1931661','','2014-01-29','14:22:51',0,'2014-01-29 21:00:18',NULL,NULL),(16219,2911,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:00:00',1,'2014-01-23 05:08:10',NULL,NULL),(22498,4246,'3505585','834','00','005010X220A1','3505585','','2014-03-05','17:53:10',0,'2014-03-05 21:30:05',NULL,NULL),(3921,712,'18012','834','00','005010X220A1','18012','','2013-12-07','16:10:02',0,'2013-12-25 22:45:39',NULL,NULL),(6376,1183,'774786','834','00','005010X220A1','774786','','2013-12-20','18:01:59',0,'2013-12-26 03:09:45',NULL,NULL),(21485,4028,'3499999','834','00','005010X220A1','3499999','','2014-02-27','17:17:30',0,'2014-02-28 06:31:14',NULL,NULL),(10634,1402,'1234392','834','00','005010X220A1','1234392','','2013-12-23','16:36:03',0,'2013-12-26 12:58:17',NULL,NULL),(5645,1048,'479927','834','00','005010X220A1','479927','','2013-12-25','10:54:36',0,'2013-12-26 01:51:09',NULL,NULL),(12345,1634,'1466997','834','00','005010X220A1','1466997','','2013-12-31','12:10:25',1,'2014-01-02 04:27:43',NULL,NULL),(70,3,'461070','834','00','005010X220A1','461070','','2013-12-05','17:38:44',0,'2013-12-25 17:17:08',NULL,NULL),(13298,2142,'0001','999','BE','005010X231A1','631459','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:06',NULL,NULL),(18996,3538,'3105068','834','00','005010X220A1','3105068','','2014-02-12','11:56:33',0,'2014-02-12 21:30:23',NULL,NULL),(14607,2521,'2378793','834','00','005010X220A1','2378793','','2014-01-13','18:02:49',0,'2014-01-14 01:33:10',NULL,NULL),(7114,1236,'103195','834','00','005010X220A1','103195','','2013-12-18','14:40:46',0,'2013-12-26 04:04:00',NULL,NULL),(7174,1238,'60872','834','00','005010X220A1','60872','','2013-12-18','15:27:58',0,'2013-12-26 04:05:50',NULL,NULL),(3740,643,'1061663','834','00','005010X220A1','1061663','','2013-12-12','13:41:04',0,'2013-12-25 22:08:52',NULL,NULL),(3291,584,'495524','834','00','005010X220A1','495524','','2013-12-16','22:35:08',0,'2013-12-25 21:48:10',NULL,NULL),(3167,564,'1137032','834','00','005010X220A1','1137032','','2013-12-13','10:52:50',0,'2013-12-25 21:38:19',NULL,NULL),(3068,544,'101622','834','00','005010X220A1','101622','','2013-12-13','16:59:48',0,'2013-12-25 21:35:13',NULL,NULL),(2594,480,'801655','834','00','005010X220A1','801655','','2013-10-31','21:09:47',0,'2013-12-25 20:45:47',NULL,NULL),(19161,3555,'2971365','834','00','005010X220A1','2971365','','2014-02-12','14:21:43',0,'2014-02-12 21:32:19',NULL,NULL),(19877,3709,'2036365','834','00','005010X220A1','2036365','','2014-02-16','00:36:39',0,'2014-02-16 19:00:22',NULL,NULL),(20035,3750,'2717487','834','00','005010X220A1','2717487','','2014-02-18','16:35:27',0,'2014-02-18 22:00:56',NULL,NULL),(17281,3170,'2614210','834','00','005010X220A1','2614210','','2014-01-31','17:52:07',0,'2014-01-31 21:00:28',NULL,NULL),(403,76,'512504','834','00','005010X220A1','512504','','2013-12-04','13:58:50',0,'2013-12-25 17:48:27',NULL,NULL),(445,81,'1206164','834','00','005010X220A1','1206164','','2013-12-03','21:14:59',0,'2013-12-25 17:49:48',NULL,NULL),(16238,2930,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:19:00',0,'2014-01-23 06:42:34',NULL,NULL),(14112,2345,'1802227','834','00','005010X220A1','1802227','','2014-01-07','20:37:31',0,'2014-01-13 02:22:18',NULL,NULL),(13847,2311,'1575635','834','00','005010X220A1','1575635','','2014-01-09','00:23:55',0,'2014-01-13 02:19:10',NULL,NULL),(23448,4408,'3193514','834','00','005010X220A1','3193514','','2014-03-09','12:58:16',0,'2014-03-09 21:00:48',NULL,NULL),(23474,4420,'2755537','834','00','005010X220A1','2755537','','2014-03-09','13:14:49',0,'2014-03-09 21:01:13',NULL,NULL),(3833,679,'303565','834','00','005010X220A1','303565','','2013-11-07','19:22:31',0,'2013-12-25 22:30:04',NULL,NULL),(575,103,'1088239','834','00','005010X220A1','1088239','','2013-12-16','17:38:01',0,'2013-12-25 18:02:48',NULL,NULL),(16023,2768,'2495284','834','00','005010X220A1','2495284','','2014-01-21','22:42:51',0,'2014-01-23 03:02:23',NULL,NULL),(1545,264,'8241','834','00','005010X220A1','8241','','2013-12-24','12:00:24',0,'2013-12-25 18:58:46',NULL,NULL),(13587,2257,'1958905','834','00','005010X220A1','1958905','','2014-01-05','08:53:22',1,'2014-01-07 10:22:19',NULL,NULL),(1911,325,'980405','834','00','005010X220A1','980405','','2013-12-09','14:17:04',0,'2013-12-25 19:32:05',NULL,NULL),(2948,541,'206379','834','00','005010X220A1','206379','','2013-12-13','09:54:11',0,'2013-12-25 21:31:30',NULL,NULL),(11057,1420,'1586332','834','00','005010X220A1','1586332','','2013-12-23','18:57:48',0,'2013-12-26 13:12:42',NULL,NULL),(11747,1521,'1962623','834','00','005010X220A1','1962623','','2013-12-27','20:39:39',1,'2013-12-29 11:09:21',NULL,NULL),(12826,1704,'1686083','834','00','005010X220A1','1686083','','2014-01-03','10:02:00',0,'2014-01-04 02:02:12',NULL,NULL),(11876,1560,'1862068','834','00','005010X220A1','1862068','','2013-12-29','12:10:42',0,'2013-12-30 00:00:14',NULL,NULL),(1937,326,'1158417','834','00','005010X220A1','1158417','','2013-12-09','10:03:40',0,'2013-12-25 19:32:50',NULL,NULL),(17474,3218,'2596699','834','00','005010X220A1','2596699','','2014-02-01','21:20:37',0,'2014-02-02 19:00:09',NULL,NULL),(16894,3098,'2566468','834','00','005010X220A1','2566468','','2014-01-28','14:45:45',0,'2014-01-28 21:01:09',NULL,NULL),(13632,2270,'1579220','834','00','005010X220A1','1579220','','2014-01-07','11:18:09',0,'2014-01-08 18:24:03',NULL,NULL),(16029,2769,'2461977','834','00','005010X220A1','2461977','','2014-01-21','21:11:18',0,'2014-01-23 03:02:26',NULL,NULL),(14956,2566,'2214151','834','00','005010X220A1','2214151','','2014-01-14','00:16:41',0,'2014-01-15 02:07:54',NULL,NULL),(5919,1112,'31700','834','00','005010X220A1','31700','','2013-12-15','12:47:08',0,'2013-12-26 02:31:22',NULL,NULL),(4322,750,'568832','834','00','005010X220A1','568832','','2013-12-19','17:01:52',0,'2013-12-25 23:09:54',NULL,NULL),(5662,1052,'1533105','834','00','005010X220A1','1533105','','2013-12-25','00:34:50',0,'2013-12-26 01:51:43',NULL,NULL),(91,4,'1038760','834','00','005010X220A1','1038760','','2013-12-05','16:17:02',0,'2013-12-25 17:17:45',NULL,NULL),(14472,2493,'0001','999','BE','005010X231A1','212659','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:44',NULL,NULL),(552,103,'1204183','834','00','005010X220A1','1204183','','2013-12-16','09:53:04',0,'2013-12-25 18:02:05',NULL,NULL),(11074,1421,'121759','834','00','005010X220A1','121759','','2013-12-23','14:56:57',0,'2013-12-26 13:13:14',NULL,NULL),(3676,629,'1177211','834','00','005010X220A1','1177211','','2013-12-12','10:00:02',0,'2013-12-25 22:06:43',NULL,NULL),(3247,578,'853860','834','00','005010X220A1','853860','','2013-12-17','16:15:39',0,'2013-12-25 21:46:46',NULL,NULL),(1850,324,'1000671','834','00','005010X220A1','1000671','','2013-12-09','05:53:10',0,'2013-12-25 19:30:11',NULL,NULL),(1197,239,'1892397','834','00','005010X220A1','1892397','','2013-12-24','17:48:49',0,'2013-12-25 18:47:40',NULL,NULL),(1600,281,'207016','834','00','005010X220A1','207016','','2013-11-19','22:59:04',0,'2013-12-25 19:01:12',NULL,NULL),(15555,2655,'2090800','834','00','005010X220A1','2090800','','2014-01-16','22:42:48',0,'2014-01-20 08:05:52',NULL,NULL),(12753,1690,'2365440','834','00','005010X220A1','2365440','','2014-01-02','17:52:34',0,'2014-01-03 02:06:47',NULL,NULL),(14101,2343,'2297713','834','00','005010X220A1','2297713','','2014-01-08','09:34:18',0,'2014-01-13 02:22:11',NULL,NULL),(11935,1572,'2114130','834','00','005010X220A1','2114130','','2013-12-29','10:19:56',0,'2013-12-30 00:02:09',NULL,NULL),(13742,2276,'1380851','834','00','005010X220A1','1380851','','2014-01-07','12:44:32',0,'2014-01-08 18:24:47',NULL,NULL),(13355,2199,'0001','999','BE','005010X231A1','180178','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:45',NULL,NULL),(5712,1069,'242308','834','00','005010X220A1','242308','','2013-12-13','23:29:38',0,'2013-12-26 02:00:50',NULL,NULL),(4872,887,'198625','834','00','005010X220A1','198625','','2013-11-21','15:37:20',0,'2013-12-26 00:16:19',NULL,NULL),(19191,3571,'2221237','834','00','005010X220A1','2221237','','2014-02-13','00:26:13',0,'2014-02-13 21:30:07',NULL,NULL),(20019,3750,'2907061','834','00','005010X220A1','2907061','','2014-02-18','11:34:43',0,'2014-02-18 22:00:46',NULL,NULL),(1595,281,'178484','834','00','005010X220A1','178484','','2013-11-19','22:58:25',0,'2013-12-25 19:01:05',NULL,NULL),(5043,935,'615334','834','00','005010X220A1','615334','','2013-12-11','18:01:16',0,'2013-12-26 00:47:20',NULL,NULL),(4553,825,'1493347','834','00','005010X220A1','1493347','','2013-12-23','23:08:59',0,'2013-12-25 23:45:48',NULL,NULL),(13267,2111,'0001','999','BE','005010X231A1','235583','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:40',NULL,NULL),(11678,1511,'1646055','834','00','005010X220A1','1646055','','2013-12-27','12:39:58',0,'2013-12-28 03:37:11',NULL,NULL),(5965,1117,'442637','834','00','005010X220A1','442637','','2013-12-15','13:43:42',0,'2013-12-26 02:32:49',NULL,NULL),(11459,1488,'791467','834','00','005010X220A1','791467','','2013-12-27','09:46:04',0,'2013-12-28 03:30:27',NULL,NULL),(20974,3956,'3694192','834','00','005010X220A1','3694192','','2014-02-22','11:46:02',0,'2014-02-26 08:30:12',NULL,NULL),(21051,3977,'3480439','834','00','005010X220A1','3480439','','2014-02-24','17:30:36',0,'2014-02-26 09:30:27',NULL,NULL),(23739,4469,'3489329','834','00','005010X220A1','3489329','','2014-03-10','15:32:11',0,'2014-03-10 21:02:59',NULL,NULL),(225,34,'390397','834','00','005010X220A1','390397','','2013-10-11','21:30:30',0,'2013-12-25 17:30:04',NULL,NULL),(6141,1166,'83736','834','00','005010X220A1','83736','','2013-12-20','16:28:14',0,'2013-12-26 03:02:33',NULL,NULL),(12700,1677,'2236505','834','00','005010X220A1','2236505','','2014-01-02','12:16:06',0,'2014-01-03 02:04:45',NULL,NULL),(11999,1581,'1372525','834','00','005010X220A1','1372525','','2013-12-30','10:08:50',0,'2014-01-01 12:02:00',NULL,NULL),(990,184,'160764','834','00','005010X220A1','160764','','2013-12-03','08:20:36',0,'2013-12-25 18:19:54',NULL,NULL),(19478,3620,'2905746','834','00','005010X220A1','2905746','','2014-02-13','21:56:44',0,'2014-02-14 21:30:10',NULL,NULL),(20984,3957,'3395231','834','00','005010X220A1','3395231','','2014-02-22','13:45:05',0,'2014-02-26 08:30:23',NULL,NULL),(21250,3999,'3209495','834','00','005010X220A1','3209495','','2014-02-26','15:03:04',0,'2014-02-26 21:01:48',NULL,NULL),(2156,362,'923090','834','00','005010X220A1','923090','','2013-12-01','18:39:49',0,'2013-12-25 19:46:39',NULL,NULL),(18368,3406,'2554980','834','00','005010X220A1','2554980','','2014-02-08','22:00:50',0,'2014-02-09 19:00:13',NULL,NULL),(4717,839,'1396651','834','00','005010X220A1','1396651','','2013-12-23','22:39:33',0,'2013-12-25 23:51:14',NULL,NULL),(5094,940,'539585','834','00','005010X220A1','539585','','2013-12-11','09:51:03',0,'2013-12-26 00:48:59',NULL,NULL),(3496,615,'610793','834','00','005010X220A1','610793','','2013-12-12','13:38:00',0,'2013-12-25 22:01:03',NULL,NULL),(7571,1301,'1019082','834','00','005010X220A1','1019082','','2013-12-21','14:04:35',0,'2013-12-26 04:36:20',NULL,NULL),(17175,3147,'2280120','834','00','005010X220A1','2280120','','2014-01-29','19:08:54',0,'2014-01-30 21:00:53',NULL,NULL),(16761,3070,'2343167','834','00','005010X220A1','2343167','','2014-01-27','03:48:58',0,'2014-01-27 21:01:26',NULL,NULL),(14703,2550,'2421687','834','00','005010X220A1','2421687','','2014-01-13','20:20:41',0,'2014-01-15 02:06:03',NULL,NULL),(22304,4201,'3089337','834','00','005010X220A1','3089337','','2014-03-04','10:48:01',0,'2014-03-04 21:01:01',NULL,NULL),(17691,3259,'2418547','834','00','005010X220A1','2418547','','2014-02-04','18:11:02',0,'2014-02-04 21:00:25',NULL,NULL),(16904,3105,'2308348','834','00','005010X220A1','2308348','','2014-01-28','12:33:09',0,'2014-01-28 21:01:16',NULL,NULL),(2787,506,'1451801','834','00','005010X220A1','1451801','','2013-12-22','08:56:57',0,'2013-12-25 21:19:55',NULL,NULL),(4601,826,'1949101','834','00','005010X220A1','1949101','','2013-12-24','01:19:46',0,'2013-12-25 23:47:18',NULL,NULL),(20061,3753,'2467920','834','00','005010X220A1','2467920','','2014-02-18','16:18:01',0,'2014-02-18 22:01:17',NULL,NULL),(21317,4012,'3239762','834','00','005010X220A1','3239762','','2014-02-26','12:27:36',0,'2014-02-26 21:02:38',NULL,NULL),(21907,4127,'2685188','834','00','005010X220A1','2685188','','2014-03-01','12:14:36',0,'2014-03-01 21:00:34',NULL,NULL),(1202,241,'1454542','834','00','005010X220A1','1454542','','2013-12-24','04:26:21',0,'2013-12-25 18:47:50',NULL,NULL),(16980,3117,'1968575','834','00','005010X220A1','1968575','','2014-01-29','10:49:49',0,'2014-01-29 21:00:42',NULL,NULL),(12017,1583,'2059550','834','00','005010X220A1','2059550','','2013-12-30','11:46:37',0,'2014-01-01 12:02:44',NULL,NULL),(2239,372,'120896','834','00','005010X220A1','120896','','2013-12-02','16:02:18',0,'2013-12-25 19:49:32',NULL,NULL),(22740,4276,'3188742','834','00','005010X220A1','3188742','','2014-03-06','00:48:03',0,'2014-03-06 21:00:22',NULL,NULL),(19197,3572,'2477300','834','00','005010X220A1','2477300','','2014-02-13','04:57:45',0,'2014-02-13 21:30:10',NULL,NULL),(13601,2261,'2004993','834','00','005010X220A1','2004993','','2014-01-05','17:30:07',1,'2014-01-07 10:22:52',NULL,NULL),(13240,2084,'0001','999','BE','005010X231A1','1225887','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:44',NULL,NULL),(12841,1705,'1838176','834','00','005010X220A1','1838176','','2014-01-02','18:59:47',0,'2014-01-04 02:02:43',NULL,NULL),(12724,1681,'1912614','834','00','005010X220A1','1912614','','2014-01-02','12:22:10',0,'2014-01-03 02:05:42',NULL,NULL),(18176,3351,'2384530','834','00','005010X220A1','2384530','','2014-02-06','18:30:48',0,'2014-02-07 19:00:18',NULL,NULL),(17602,3240,'1931764','834','00','005010X220A1','1931764','','2014-02-03','13:01:33',0,'2014-02-03 21:01:00',NULL,NULL),(17258,3170,'2501698','834','00','005010X220A1','2501698','','2014-01-30','23:01:18',0,'2014-01-31 21:00:12',NULL,NULL),(16481,3010,'1866453','834','00','005010X220A1','1866453','','2014-01-24','11:37:35',0,'2014-01-24 21:00:30',NULL,NULL),(7129,1236,'531183','834','00','005010X220A1','531183','','2013-12-18','16:50:34',0,'2013-12-26 04:04:29',NULL,NULL),(7067,1236,'202692','834','00','005010X220A1','202692','','2013-12-17','20:40:54',0,'2013-12-26 04:02:33',NULL,NULL),(3816,665,'176183','834','00','005010X220A1','176183','','2013-12-08','16:30:49',0,'2013-12-25 22:16:52',NULL,NULL),(5943,1113,'936732','834','00','005010X220A1','936732','','2013-12-15','09:11:25',0,'2013-12-26 02:32:06',NULL,NULL),(20228,3785,'2560450','834','00','005010X220A1','2560450','','2014-02-19','17:40:22',0,'2014-02-20 04:25:39',NULL,NULL),(511,102,'268513','834','00','005010X220A1','268513','','2013-12-16','11:33:49',0,'2013-12-25 18:00:48',NULL,NULL),(18271,3377,'2369691','834','00','005010X220A1','2369691','','2014-02-07','21:35:07',0,'2014-02-08 19:00:16',NULL,NULL),(15942,2758,'2394130','834','00','005010X220A1','2394130','','2014-01-21','12:36:28',1,'2014-01-22 03:23:08',NULL,NULL),(10976,1412,'1354858','834','00','005010X220A1','1354858','','2013-12-23','14:04:39',0,'2013-12-26 13:09:55',NULL,NULL),(10668,1403,'817579','834','00','005010X220A1','817579','','2013-12-22','19:10:25',0,'2013-12-26 12:59:21',NULL,NULL),(1061,208,'689055','834','00','005010X220A1','689055','','2013-11-28','22:28:07',0,'2013-12-25 18:30:38',NULL,NULL),(378,74,'1102189','834','00','005010X220A1','1102189','','2013-12-03','19:03:57',0,'2013-12-25 17:47:39',NULL,NULL),(15159,2588,'1612105','834','00','005010X220A1','1612105','','2014-01-15','16:52:50',0,'2014-01-16 08:46:00',NULL,NULL),(14459,2480,'0001','999','BE','005010X231A1','303809','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:32',NULL,NULL),(14068,2339,'1359451','834','00','005010X220A1','1359451','','2014-01-08','14:42:08',0,'2014-01-13 02:21:48',NULL,NULL),(967,182,'72767','834','00','005010X220A1','72767','','2013-12-03','14:12:30',0,'2013-12-25 18:19:12',NULL,NULL),(1451,252,'1747394','834','00','005010X220A1','1747394','','2013-12-24','12:40:49',0,'2013-12-25 18:55:45',NULL,NULL),(13659,2271,'1670190','834','00','005010X220A1','1670190','','2014-01-06','20:42:13',0,'2014-01-08 18:24:13',NULL,NULL),(12915,1714,'1491395','834','00','005010X220A1','1491395','','2014-01-03','15:27:18',0,'2014-01-04 02:05:28',NULL,NULL),(12638,1672,'1888576','834','00','005010X220A1','1888576','','2014-01-02','12:32:04',0,'2014-01-03 02:02:26',NULL,NULL),(21130,3994,'3038070','834','00','005010X220A1','3038070','','2014-02-26','17:36:07',0,'2014-02-26 21:00:31',NULL,NULL),(21678,4080,'3722110','834','00','005010X220A1','3722110','','2014-02-28','12:04:05',0,'2014-02-28 21:00:20',NULL,NULL),(22477,4239,'3802865','834','00','005010X220A1','3802865','','2014-03-05','15:40:16',0,'2014-03-05 21:00:21',NULL,NULL),(19133,3548,'2032516','834','00','005010X220A1','2032516','','2014-02-12','13:18:31',0,'2014-02-12 21:31:58',NULL,NULL),(5995,1129,'91267','834','00','005010X220A1','91267','','2013-12-15','10:58:04',0,'2013-12-26 02:33:51',NULL,NULL),(11139,1432,'1146407','834','00','005010X220A1','1146407','','2013-12-23','13:15:40',0,'2013-12-26 13:15:33',NULL,NULL),(17904,3295,'1977796','834','00','005010X220A1','1977796','','2014-02-05','15:20:09',0,'2014-02-05 21:30:33',NULL,NULL),(12119,1587,'1793138','834','00','005010X220A1','1793138','','2013-12-30','15:04:37',0,'2014-01-01 12:06:21',NULL,NULL),(15763,2714,'2184468','834','00','005010X220A1','2184468','','2014-01-20','12:54:34',0,'2014-01-21 08:46:25',NULL,NULL),(15256,2600,'1546462','834','00','005010X220A1','1546462','','2014-01-15','18:01:11',0,'2014-01-16 08:47:01',NULL,NULL),(21355,4023,'3250785','834','00','005010X220A1','3250785','','2014-02-26','23:18:08',0,'2014-02-28 06:30:14',NULL,NULL),(21461,4028,'3669612','834','00','005010X220A1','3669612','','2014-02-27','10:52:46',0,'2014-02-28 06:31:04',NULL,NULL),(21524,4036,'2899547','834','00','005010X220A1','2899547','','2014-02-27','14:15:08',0,'2014-02-28 06:31:33',NULL,NULL),(21881,4123,'3396517','834','00','005010X220A1','3396517','','2014-02-28','18:20:19',0,'2014-03-01 21:00:17',NULL,NULL),(23247,4365,'3545399','834','00','005010X220A1','3545399','','2014-03-07','15:49:52',0,'2014-03-07 21:32:21',NULL,NULL),(18573,3453,'2550730','834','00','005010X220A1','2550730','','2014-02-10','14:28:15',0,'2014-02-10 21:30:44',NULL,NULL),(12138,1590,'1773038','834','00','005010X220A1','1773038','','2013-12-29','21:25:49',0,'2014-01-01 12:07:02',NULL,NULL),(12071,1586,'1543179','834','00','005010X220A1','1543179','','2013-12-30','09:25:02',0,'2014-01-01 12:04:43',NULL,NULL),(11752,1522,'526555','834','00','005010X220A1','526555','','2013-12-28','12:35:03',1,'2013-12-29 11:09:31',NULL,NULL),(11452,1488,'2002488','834','00','005010X220A1','2002488','','2013-12-26','19:27:47',0,'2013-12-28 03:30:13',NULL,NULL),(18292,3380,'2289581','834','00','005010X220A1','2289581','','2014-02-08','11:06:11',0,'2014-02-08 19:00:29',NULL,NULL),(17978,3306,'2642112','834','00','005010X220A1','2642112','','2014-02-04','21:00:53',0,'2014-02-05 21:31:10',NULL,NULL),(10566,1402,'1452942','834','00','005010X220A1','1452942','','2013-12-23','05:08:45',0,'2013-12-26 12:56:04',NULL,NULL),(7352,1283,'1183065','834','00','005010X220A1','1183065','','2013-11-30','07:59:41',0,'2013-12-26 04:15:32',NULL,NULL),(3856,687,'210943','834','00','005010X220A1','210943','','2013-11-08','10:33:12',0,'2013-12-25 22:30:47',NULL,NULL),(17738,3262,'2777415','834','00','005010X220A1','2777415','','2014-02-03','21:39:17',0,'2014-02-04 21:00:52',NULL,NULL),(15400,2626,'2557061','834','00','005010X220A1','2557061','','2014-01-15','21:36:32',0,'2014-01-17 03:35:47',NULL,NULL),(20563,3864,'3028157','834','00','005010X220A1','3028157','','2014-02-21','14:00:04',0,'2014-02-21 21:30:12',NULL,NULL),(22074,4173,'3477842','834','00','005010X220A1','3477842','','2014-03-03','13:44:01',0,'2014-03-03 21:00:27',NULL,NULL),(22269,4200,'3214617','834','00','005010X220A1','3214617','','2014-03-04','13:36:34',0,'2014-03-04 21:00:35',NULL,NULL),(23066,4339,'3476609','834','00','005010X220A1','3476609','','2014-03-07','00:39:50',0,'2014-03-07 21:30:10',NULL,NULL),(23310,4381,'2880273','834','00','005010X220A1','2880273','','2014-03-07','19:20:21',0,'2014-03-08 21:30:27',NULL,NULL),(18497,3439,'1393897','834','00','005010X220A1','1393897','','2014-02-10','04:21:20',0,'2014-02-10 11:01:12',NULL,NULL),(12390,1637,'1834185','834','00','005010X220A1','1834185','','2013-12-31','10:14:31',1,'2014-01-02 04:29:19',NULL,NULL),(16196,2888,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 04:45:33',NULL,NULL),(15190,2592,'1946415','834','00','005010X220A1','1946415','','2014-01-14','21:06:07',0,'2014-01-16 08:46:19',NULL,NULL),(11817,1539,'339999','834','00','005010X220A1','339999','','2013-12-28','20:23:23',1,'2013-12-29 11:13:37',NULL,NULL),(11441,1483,'718880','834','00','005010X220A1','718880','','2013-12-26','15:39:47',0,'2013-12-27 02:07:54',NULL,NULL),(11291,1455,'1968941','834','00','005010X220A1','1968941','','2013-12-26','16:35:11',0,'2013-12-27 02:03:14',NULL,NULL),(3300,584,'438595','834','00','005010X220A1','438595','','2013-12-17','10:36:56',0,'2013-12-25 21:48:26',NULL,NULL),(3434,599,'230869','834','00','005010X220A1','230869','','2013-12-17','10:55:48',0,'2013-12-25 21:52:48',NULL,NULL),(2861,513,'1402855','834','00','005010X220A1','1402855','','2013-12-21','23:04:26',0,'2013-12-25 21:22:21',NULL,NULL),(14209,2365,'2443938','834','00','005010X220A1','2443938','','2014-01-10','17:30:31',0,'2014-01-13 02:23:50',NULL,NULL),(21973,4144,'3174156','834','00','005010X220A1','3174156','','2014-03-01','19:03:01',0,'2014-03-03 01:00:09',NULL,NULL),(18948,3528,'2421191','834','00','005010X220A1','2421191','','2014-02-11','16:27:00',0,'2014-02-11 21:30:27',NULL,NULL),(13570,2254,'1844684','834','00','005010X220A1','1844684','','2014-01-05','13:23:35',1,'2014-01-07 10:21:34',NULL,NULL),(10859,1406,'228919','834','00','005010X220A1','228919','','2013-12-23','16:33:50',0,'2013-12-26 13:05:48',NULL,NULL),(10695,1403,'532655','834','00','005010X220A1','532655','','2013-12-23','09:22:49',0,'2013-12-26 13:00:21',NULL,NULL),(15655,2683,'1685304','834','00','005010X220A1','1685304','','2014-01-18','15:03:46',0,'2014-01-21 08:44:27',NULL,NULL),(5892,1110,'729088','834','00','005010X220A1','729088','','2013-12-15','08:57:28',0,'2013-12-26 02:30:30',NULL,NULL),(13911,2313,'2396681','834','00','005010X220A1','2396681','','2014-01-08','21:36:28',0,'2014-01-13 02:19:51',NULL,NULL),(2192,364,'609412','834','00','005010X220A1','609412','','2013-12-01','18:46:05',0,'2013-12-25 19:47:53',NULL,NULL),(13352,2196,'0001','999','BE','005010X231A1','830697','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:36',NULL,NULL),(13066,1910,'0001','999','BE','005010X231A1','373910','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:04',NULL,NULL),(836,174,'128306','834','00','005010X220A1','128306','','2013-12-02','18:32:26',0,'2013-12-25 18:15:14',NULL,NULL),(889,177,'1215457','834','00','005010X220A1','1215457','','2013-12-03','10:47:36',0,'2013-12-25 18:16:48',NULL,NULL),(11235,1454,'1198588','834','00','005010X220A1','1198588','','2013-12-26','11:55:11',0,'2013-12-27 02:01:30',NULL,NULL),(3338,586,'650348','834','00','005010X220A1','650348','','2013-12-17','16:55:22',0,'2013-12-25 21:49:47',NULL,NULL),(3319,584,'1059665','834','00','005010X220A1','1059665','','2013-12-17','16:54:10',0,'2013-12-25 21:49:10',NULL,NULL),(1253,243,'1193693','834','00','005010X220A1','1193693','','2013-12-24','12:24:07',0,'2013-12-25 18:49:16',NULL,NULL),(2871,516,'859515','834','00','005010X220A1','859515','','2013-12-22','08:49:39',0,'2013-12-25 21:22:39',NULL,NULL),(21569,4054,'3220664','834','00','005010X220A1','3220664','','2014-02-26','14:45:43',0,'2014-02-28 07:00:12',NULL,NULL),(22956,4311,'3627175','834','00','005010X220A1','3627175','','2014-03-05','18:19:29',0,'2014-03-06 21:30:02',NULL,NULL),(166,14,'441044','834','00','005010X220A1','441044','','2013-12-04','20:14:37',0,'2013-12-25 17:20:10',NULL,NULL),(927,180,'174655','834','00','005010X220A1','174655','','2013-12-02','20:03:37',0,'2013-12-25 18:17:56',NULL,NULL),(7308,1262,'1206672','834','00','005010X220A1','1206672','','2013-12-18','18:02:40',0,'2013-12-26 04:09:56',NULL,NULL),(7118,1236,'582002','834','00','005010X220A1','582002','','2013-12-18','15:24:38',0,'2013-12-26 04:04:09',NULL,NULL),(2120,360,'719297','834','00','005010X220A1','719297','','2013-12-02','11:01:50',0,'2013-12-25 19:45:32',NULL,NULL),(2459,422,'848343','834','00','005010X220A1','848343','','2013-12-06','15:57:20',0,'2013-12-25 20:19:09',NULL,NULL),(18790,3487,'2079678','834','00','005010X220A1','2079678','','2014-02-11','10:52:10',0,'2014-02-11 21:01:08',NULL,NULL),(5963,1117,'842955','834','00','005010X220A1','842955','','2013-12-15','11:28:33',0,'2013-12-26 02:32:43',NULL,NULL),(5920,1112,'497958','834','00','005010X220A1','497958','','2013-12-15','13:21:31',0,'2013-12-26 02:31:24',NULL,NULL),(5672,1053,'1543079','834','00','005010X220A1','1543079','','2013-12-25','00:55:40',0,'2013-12-26 01:52:07',NULL,NULL),(4985,935,'632567','834','00','005010X220A1','632567','','2013-12-10','21:06:23',0,'2013-12-26 00:45:29',NULL,NULL),(2982,542,'535906','834','00','005010X220A1','535906','','2013-12-12','19:44:49',0,'2013-12-25 21:32:35',NULL,NULL),(19220,3580,'2995551','834','00','005010X220A1','2995551','','2014-02-12','23:23:57',0,'2014-02-13 22:00:09',NULL,NULL),(12776,1702,'1382055','834','00','005010X220A1','1382055','','2014-01-03','13:40:53',0,'2014-01-04 02:00:21',NULL,NULL),(18371,3406,'2253973','834','00','005010X220A1','2253973','','2014-02-09','13:22:43',0,'2014-02-09 19:00:15',NULL,NULL),(12193,1607,'1527554','834','00','005010X220A1','1527554','','2013-12-30','11:51:01',0,'2014-01-01 12:09:04',NULL,NULL),(13701,2274,'2269141','834','00','005010X220A1','2269141','','2014-01-07','13:18:08',0,'2014-01-08 18:24:30',NULL,NULL),(4484,802,'464767','834','00','005010X220A1','464767','','2013-11-26','13:57:39',0,'2013-12-25 23:31:31',NULL,NULL),(7257,1246,'391217','834','00','005010X220A1','391217','','2013-12-18','13:50:47',0,'2013-12-26 04:08:24',NULL,NULL),(5944,1113,'1045673','834','00','005010X220A1','1045673','','2013-12-15','11:34:40',0,'2013-12-26 02:32:08',NULL,NULL),(4703,834,'1511862','834','00','005010X220A1','1511862','','2013-12-23','23:22:57',0,'2013-12-25 23:50:45',NULL,NULL),(14234,2370,'2025035','834','00','005010X220A1','2025035','','2014-01-09','19:45:49',0,'2014-01-13 02:24:06',NULL,NULL),(5711,1069,'77016','834','00','005010X220A1','77016','','2013-12-13','21:18:41',0,'2013-12-26 02:00:48',NULL,NULL),(2449,422,'1173475','834','00','005010X220A1','1173475','','2013-12-06','08:31:35',0,'2013-12-25 20:18:49',NULL,NULL),(14923,2559,'2282013','834','00','005010X220A1','2282013','','2014-01-14','14:05:48',0,'2014-01-15 02:07:40',NULL,NULL),(17041,3121,'2278739','834','00','005010X220A1','2278739','','2014-01-29','11:58:54',0,'2014-01-29 21:01:20',NULL,NULL),(1855,324,'102827','834','00','005010X220A1','102827','','2013-12-09','10:19:19',0,'2013-12-25 19:30:22',NULL,NULL),(19734,3673,'3092988','834','00','005010X220A1','3092988','','2014-02-15','08:46:32',0,'2014-02-15 22:00:32',NULL,NULL),(20154,3776,'3602983','834','00','005010X220A1','3602983','','2014-02-19','16:00:55',0,'2014-02-20 04:04:51',NULL,NULL),(797,149,'200609','834','00','005010X220A1','200609','','2013-10-29','00:42:23',0,'2013-12-25 18:10:03',NULL,NULL),(7453,1296,'1237067','834','00','005010X220A1','1237067','','2013-12-20','23:48:10',0,'2013-12-26 04:32:28',NULL,NULL),(1196,239,'425412','834','00','005010X220A1','425412','','2013-12-24','17:40:14',0,'2013-12-25 18:47:38',NULL,NULL),(18108,3329,'2142707','834','00','005010X220A1','2142707','','2014-02-06','10:31:24',0,'2014-02-06 21:01:22',NULL,NULL),(5336,1002,'1301191','834','00','005010X220A1','1301191','','2013-11-24','19:52:04',0,'2013-12-26 01:15:21',NULL,NULL),(4134,733,'574471','834','00','005010X220A1','574471','','2013-12-19','15:55:40',0,'2013-12-25 23:04:13',NULL,NULL),(16732,3065,'1858987','834','00','005010X220A1','1858987','','2014-01-27','10:12:32',0,'2014-01-27 21:01:05',NULL,NULL),(15697,2700,'1475978','834','00','005010X220A1','1475978','','2014-01-18','18:15:48',0,'2014-01-21 08:45:25',NULL,NULL),(14583,2520,'1992290','834','00','005010X220A1','1992290','','2014-01-13','17:25:10',0,'2014-01-14 01:32:55',NULL,NULL),(10943,1410,'893783','834','00','005010X220A1','893783','','2013-12-23','14:38:46',0,'2013-12-26 13:09:00',NULL,NULL),(14352,2403,'2568481','834','00','005010X220A1','2568481','','2014-01-11','19:22:21',0,'2014-01-13 03:01:27',NULL,NULL),(11894,1561,'94185','834','00','005010X220A1','94185','','2013-12-29','09:30:57',0,'2013-12-30 00:00:49',NULL,NULL),(12242,1618,'2498643','834','00','005010X220A1','2498643','','2014-01-01','17:36:39',1,'2014-01-02 04:23:07',NULL,NULL),(20450,3842,'3585327','834','00','005010X220A1','3585327','','2014-02-19','19:40:40',0,'2014-02-20 22:00:23',NULL,NULL),(20953,3949,'3386872','834','00','005010X220A1','3386872','','2014-02-24','17:00:09',0,'2014-02-26 08:00:43',NULL,NULL),(18266,3376,'1797974','834','00','005010X220A1','1797974','','2014-02-08','14:50:42',0,'2014-02-08 19:00:13',NULL,NULL),(15749,2713,'2486682','834','00','005010X220A1','2486682','','2014-01-20','15:40:56',0,'2014-01-21 08:46:17',NULL,NULL),(1527,260,'1934568','834','00','005010X220A1','1934568','','2013-12-24','15:26:22',0,'2013-12-25 18:58:17',NULL,NULL),(5277,976,'488901','834','00','005010X220A1','488901','','2013-11-12','13:50:05',0,'2013-12-26 01:00:37',NULL,NULL),(15679,2690,'1622429','834','00','005010X220A1','1622429','','2014-01-18','15:38:53',0,'2014-01-21 08:44:45',NULL,NULL),(4502,808,'699514','834','00','005010X220A1','699514','','2013-11-25','21:22:39',0,'2013-12-25 23:32:09',NULL,NULL),(15544,2655,'2526508','834','00','005010X220A1','2526508','','2014-01-16','18:51:26',0,'2014-01-20 08:05:44',NULL,NULL),(13223,2067,'0001','999','BE','005010X231A1','1267581','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:56',NULL,NULL),(7232,1241,'692033','834','00','005010X220A1','692033','','2013-12-18','17:02:46',0,'2013-12-26 04:07:38',NULL,NULL),(11914,1565,'1941984','834','00','005010X220A1','1941984','','2013-12-28','20:36:21',0,'2013-12-30 00:01:26',NULL,NULL),(10703,1403,'1501649','834','00','005010X220A1','1501649','','2013-12-23','10:46:17',0,'2013-12-26 13:00:38',NULL,NULL),(10980,1413,'1181096','834','00','005010X220A1','1181096','','2013-12-23','05:54:09',0,'2013-12-26 13:10:05',NULL,NULL),(23549,4435,'2864887','834','00','005010X220A1','2864887','','2014-03-10','16:02:06',0,'2014-03-10 21:00:39',NULL,NULL),(3758,651,'408922','834','00','005010X220A1','408922','','2013-12-12','16:09:45',0,'2013-12-25 22:09:30',NULL,NULL),(19359,3585,'2333285','834','00','005010X220A1','2333285','','2014-02-13','14:35:56',0,'2014-02-13 22:01:59',NULL,NULL),(13671,2271,'1736398','834','00','005010X220A1','1736398','','2014-01-07','13:53:57',0,'2014-01-08 18:24:17',NULL,NULL),(7135,1236,'527452','834','00','005010X220A1','527452','','2013-12-18','17:31:26',0,'2013-12-26 04:04:36',NULL,NULL),(10676,1403,'53783','834','00','005010X220A1','53783','','2013-12-22','20:08:50',0,'2013-12-26 12:59:36',NULL,NULL),(12872,1706,'1887564','834','00','005010X220A1','1887564','','2014-01-03','12:38:57',0,'2014-01-04 02:03:51',NULL,NULL),(20666,3878,'3228600','834','00','005010X220A1','3228600','','2014-02-21','12:39:23',0,'2014-02-21 22:01:03',NULL,NULL),(21490,4029,'3732341','834','00','005010X220A1','3732341','','2014-02-27','10:01:34',0,'2014-02-28 06:31:16',NULL,NULL),(21504,4030,'3824940','834','00','005010X220A1','3824940','','2014-02-27','14:12:11',0,'2014-02-28 06:31:23',NULL,NULL),(22658,4254,'2770585','834','00','005010X220A1','2770585','','2014-03-05','09:59:47',0,'2014-03-05 21:31:58',NULL,NULL),(17932,3296,'2414558','834','00','005010X220A1','2414558','','2014-02-05','16:22:19',0,'2014-02-05 21:30:45',NULL,NULL),(17527,3235,'2017260','834','00','005010X220A1','2017260','','2014-02-03','13:07:28',0,'2014-02-03 21:00:13',NULL,NULL),(10710,1403,'685727','834','00','005010X220A1','685727','','2013-12-23','11:34:55',0,'2013-12-26 13:00:52',NULL,NULL),(10559,1402,'1259550','834','00','005010X220A1','1259550','','2013-12-22','22:56:31',0,'2013-12-26 12:55:50',NULL,NULL),(1543,263,'1393044','834','00','005010X220A1','1393044','','2013-12-24','11:47:58',0,'2013-12-25 18:58:43',NULL,NULL),(6429,1203,'890330','834','00','005010X220A1','890330','','2013-11-22','09:48:06',0,'2013-12-26 03:15:25',NULL,NULL),(2353,413,'447168','834','00','005010X220A1','447168','','2013-12-06','17:15:40',0,'2013-12-25 20:15:44',NULL,NULL),(20931,3938,'3060367','834','00','005010X220A1','3060367','','2014-02-23','12:51:15',0,'2014-02-26 08:00:26',NULL,NULL),(3028,544,'1090837','834','00','005010X220A1','1090837','','2013-12-12','23:06:14',0,'2013-12-25 21:33:57',NULL,NULL),(20135,3772,'2996791','834','00','005010X220A1','2996791','','2014-02-19','16:31:25',0,'2014-02-20 03:59:50',NULL,NULL),(11122,1428,'1146369','834','00','005010X220A1','1146369','','2013-12-23','09:33:47',0,'2013-12-26 13:14:51',NULL,NULL),(17735,3262,'2817874','834','00','005010X220A1','2817874','','2014-02-03','19:39:19',0,'2014-02-04 21:00:51',NULL,NULL),(11916,1565,'1513204','834','00','005010X220A1','1513204','','2013-12-28','21:40:27',0,'2013-12-30 00:01:30',NULL,NULL),(13151,1995,'0001','999','BE','005010X231A1','1183065','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:36',NULL,NULL),(22623,4252,'3611017','834','00','005010X220A1','3611017','','2014-03-04','18:37:50',0,'2014-03-05 21:31:35',NULL,NULL),(19100,3543,'1724442','834','00','005010X220A1','1724442','','2014-02-12','12:27:15',0,'2014-02-12 21:31:38',NULL,NULL),(1943,326,'818189','834','00','005010X220A1','818189','','2013-12-09','10:36:16',0,'2013-12-25 19:33:01',NULL,NULL),(2172,362,'507266','834','00','005010X220A1','507266','','2013-12-02','16:23:04',0,'2013-12-25 19:47:13',NULL,NULL),(1921,325,'1175738','834','00','005010X220A1','1175738','','2013-12-09','18:01:53',0,'2013-12-25 19:32:21',NULL,NULL),(3250,578,'440049','834','00','005010X220A1','440049','','2013-12-17','17:28:20',0,'2013-12-25 21:46:51',NULL,NULL),(1424,250,'1510603','834','00','005010X220A1','1510603','','2013-12-24','10:59:31',0,'2013-12-25 18:54:51',NULL,NULL),(5193,949,'292808','834','00','005010X220A1','292808','','2013-12-11','12:00:51',0,'2013-12-26 00:52:08',NULL,NULL),(17186,3148,'2662629','834','00','005010X220A1','2662629','','2014-01-30','13:42:59',0,'2014-01-30 21:01:00',NULL,NULL),(5298,985,'643412','834','00','005010X220A1','643412','','2013-11-16','16:22:14',0,'2013-12-26 01:01:20',NULL,NULL),(622,108,'1300301','834','00','005010X220A1','1300301','','2013-12-16','10:13:36',0,'2013-12-25 18:04:20',NULL,NULL),(390,76,'955312','834','00','005010X220A1','955312','','2013-12-03','20:46:36',0,'2013-12-25 17:48:03',NULL,NULL),(17052,3123,'2338829','834','00','005010X220A1','2338829','','2014-01-29','15:39:59',0,'2014-01-29 21:01:27',NULL,NULL),(21707,4088,'3065567','834','00','005010X220A1','3065567','','2014-02-27','21:02:22',0,'2014-02-28 21:30:19',NULL,NULL),(22383,4208,'3053336','834','00','005010X220A1','3053336','','2014-03-04','13:00:07',0,'2014-03-04 21:02:05',NULL,NULL),(23048,4336,'3065864','834','00','005010X220A1','3065864','','2014-03-07','16:02:57',0,'2014-03-07 21:00:34',NULL,NULL),(19445,3604,'2252722','834','00','005010X220A1','2252722','','2014-02-13','12:03:59',0,'2014-02-13 22:03:04',NULL,NULL),(19113,3545,'2995518','834','00','005010X220A1','2995518','','2014-02-12','11:16:40',0,'2014-02-12 21:31:46',NULL,NULL),(12779,1703,'1282718','834','00','005010X220A1','1282718','','2014-01-02','18:36:03',0,'2014-01-04 02:00:28',NULL,NULL),(18919,3515,'2976204','834','00','005010X220A1','2976204','','2014-02-11','17:08:51',0,'2014-02-11 21:02:53',NULL,NULL),(16767,3071,'1824067','834','00','005010X220A1','1824067','','2014-01-27','13:09:16',0,'2014-01-27 21:01:31',NULL,NULL),(1286,243,'1775580','834','00','005010X220A1','1775580','','2013-12-24','17:45:43',0,'2013-12-25 18:50:21',NULL,NULL),(3088,546,'392386','834','00','005010X220A1','392386','','2013-12-12','19:28:31',0,'2013-12-25 21:35:50',NULL,NULL),(3726,637,'916814','834','00','005010X220A1','916814','','2013-12-12','09:37:11',0,'2013-12-25 22:08:24',NULL,NULL),(22805,4278,'3167813','834','00','005010X220A1','3167813','','2014-03-05','19:59:04',0,'2014-03-06 21:01:07',NULL,NULL),(23317,4381,'3289781','834','00','005010X220A1','3289781','','2014-03-08','16:43:03',0,'2014-03-08 21:30:33',NULL,NULL),(1463,252,'545796','834','00','005010X220A1','545796','','2013-12-24','14:59:56',0,'2013-12-25 18:56:13',NULL,NULL),(5828,1088,'724634','834','00','005010X220A1','724634','','2013-11-23','16:06:11',0,'2013-12-26 02:15:20',NULL,NULL),(16855,3093,'2339883','834','00','005010X220A1','2339883','','2014-01-27','19:48:50',0,'2014-01-28 21:00:43',NULL,NULL),(7286,1255,'768667','834','00','005010X220A1','768667','','2013-12-18','15:29:01',0,'2013-12-26 04:09:16',NULL,NULL),(13260,2104,'0001','999','BE','005010X231A1','430422','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:39',NULL,NULL),(11024,1416,'666516','834','00','005010X220A1','666516','','2013-12-23','06:44:30',0,'2013-12-26 13:11:37',NULL,NULL),(11062,1421,'1242470','834','00','005010X220A1','1242470','','2013-12-23','07:53:25',0,'2013-12-26 13:12:53',NULL,NULL),(21716,4088,'2723834','834','00','005010X220A1','2723834','','2014-02-28','11:07:08',0,'2014-02-28 21:30:25',NULL,NULL),(409,77,'501228','834','00','005010X220A1','501228','','2013-12-04','06:53:12',0,'2013-12-25 17:48:40',NULL,NULL),(19678,3664,'2776664','834','00','005010X220A1','2776664','','2014-02-15','00:12:20',0,'2014-02-15 21:00:02',NULL,NULL),(14324,2399,'2336907','834','00','005010X220A1','2336907','','2014-01-12','14:05:39',0,'2014-01-13 03:01:06',NULL,NULL),(12751,1690,'1787446','834','00','005010X220A1','1787446','','2014-01-02','13:48:50',0,'2014-01-03 02:06:43',NULL,NULL),(5350,1003,'851857','834','00','005010X220A1','851857','','2013-11-25','08:56:30',0,'2013-12-26 01:15:51',NULL,NULL),(3930,714,'182013','834','00','005010X220A1','182013','','2013-12-06','18:34:30',0,'2013-12-25 22:45:56',NULL,NULL),(4372,772,'32337','834','00','005010X220A1','32337','','2013-11-26','18:15:26',0,'2013-12-25 23:15:03',NULL,NULL),(10773,1404,'1620239','834','00','005010X220A1','1620239','','2013-12-23','00:11:03',0,'2013-12-26 13:03:02',NULL,NULL),(23129,4342,'3537754','834','00','005010X220A1','3537754','','2014-03-07','11:16:26',0,'2014-03-07 21:30:56',NULL,NULL),(5,1,'594593','834','00','005010X220A1','594593','','2013-12-04','20:28:34',0,'2013-12-25 17:15:09',NULL,NULL),(14631,2525,'1813679','834','00','005010X220A1','1813679','','2014-01-13','11:24:35',0,'2014-01-14 01:33:26',NULL,NULL),(6198,1168,'903796','834','00','005010X220A1','903796','','2013-12-19','18:59:04',0,'2013-12-26 03:04:17',NULL,NULL),(1982,327,'1262740','834','00','005010X220A1','1262740','','2013-12-09','11:37:29',0,'2013-12-25 19:34:15',NULL,NULL),(2233,372,'408615','834','00','005010X220A1','408615','','2013-12-02','17:51:58',0,'2013-12-25 19:49:18',NULL,NULL),(2645,501,'93803','834','00','005010X220A1','93803','','2013-12-21','19:02:37',0,'2013-12-25 21:15:15',NULL,NULL),(10687,1403,'1190100','834','00','005010X220A1','1190100','','2013-12-23','05:08:13',0,'2013-12-26 13:00:04',NULL,NULL),(12022,1583,'1611617','834','00','005010X220A1','1611617','','2013-12-30','12:41:48',0,'2014-01-01 12:02:54',NULL,NULL),(12537,1648,'1563986','834','00','005010X220A1','1563986','','2013-12-31','18:30:17',1,'2014-01-02 04:34:43',NULL,NULL),(12555,1657,'2133956','834','00','005010X220A1','2133956','','2013-12-31','15:35:22',1,'2014-01-02 04:35:27',NULL,NULL),(12759,1695,'2102712','834','00','005010X220A1','2102712','','2014-01-02','06:14:23',0,'2014-01-03 02:07:04',NULL,NULL),(21544,4042,'3000761','834','00','005010X220A1','3000761','','2014-02-27','12:03:16',0,'2014-02-28 06:31:42',NULL,NULL),(22313,4201,'3069086','834','00','005010X220A1','3069086','','2014-03-04','14:51:05',0,'2014-03-04 21:01:07',NULL,NULL),(2483,434,'825029','834','00','005010X220A1','825029','','2013-12-06','16:34:32',0,'2013-12-25 20:19:56',NULL,NULL),(20030,3750,'2533243','834','00','005010X220A1','2533243','','2014-02-18','14:19:52',0,'2014-02-18 22:00:53',NULL,NULL),(14699,2550,'2555815','834','00','005010X220A1','2555815','','2014-01-13','18:59:15',0,'2014-01-15 02:06:01',NULL,NULL),(5605,1044,'103672','834','00','005010X220A1','103672','','2013-12-24','20:41:08',0,'2013-12-26 01:49:48',NULL,NULL),(23498,4434,'3318747','834','00','005010X220A1','3318747','','2014-03-09','20:15:05',0,'2014-03-10 21:00:02',NULL,NULL),(19595,3631,'3081828','834','00','005010X220A1','3081828','','2014-02-13','22:06:29',0,'2014-02-14 21:31:34',NULL,NULL),(13713,2275,'1646310','834','00','005010X220A1','1646310','','2014-01-07','12:49:25',0,'2014-01-08 18:24:35',NULL,NULL),(14121,2348,'1483978','834','00','005010X220A1','1483978','','2014-01-08','12:00:43',0,'2014-01-13 02:22:24',NULL,NULL),(3168,564,'448481','834','00','005010X220A1','448481','','2013-12-13','13:18:54',0,'2013-12-25 21:38:21',NULL,NULL),(2702,502,'1200944','834','00','005010X220A1','1200944','','2013-12-22','15:38:07',0,'2013-12-25 21:17:16',NULL,NULL),(22060,4168,'3291641','834','00','005010X220A1','3291641','','2014-03-03','14:44:03',0,'2014-03-03 21:00:17',NULL,NULL),(599,107,'1142032','834','00','005010X220A1','1142032','','2013-12-16','12:59:03',0,'2013-12-25 18:03:33',NULL,NULL),(1370,245,'1879987','834','00','005010X220A1','1879987','','2013-12-24','15:22:50',0,'2013-12-25 18:53:02',NULL,NULL),(20220,3785,'2541144','834','00','005010X220A1','2541144','','2014-02-18','19:26:05',0,'2014-02-20 04:23:30',NULL,NULL),(5135,943,'1029589','834','00','005010X220A1','1029589','','2013-12-11','10:08:15',0,'2013-12-26 00:50:22',NULL,NULL),(15239,2598,'2425843','834','00','005010X220A1','2425843','','2014-01-15','14:46:38',0,'2014-01-16 08:46:50',NULL,NULL),(11848,1547,'1770055','834','00','005010X220A1','1770055','','2013-12-28','20:18:24',1,'2013-12-29 11:14:41',NULL,NULL),(21710,4088,'3642889','834','00','005010X220A1','3642889','','2014-02-28','09:23:25',0,'2014-02-28 21:30:21',NULL,NULL),(21937,4131,'2991958','834','00','005010X220A1','2991958','','2014-03-01','11:08:42',0,'2014-03-01 21:00:54',NULL,NULL),(23340,4385,'3854922','834','00','005010X220A1','3854922','','2014-03-08','00:01:31',0,'2014-03-08 21:30:50',NULL,NULL),(310,70,'1165890','834','00','005010X220A1','1165890','','2013-12-04','15:53:56',0,'2013-12-25 17:45:30',NULL,NULL),(20715,3895,'3670916','834','00','005010X220A1','3670916','','2014-02-25','13:22:22',0,'2014-02-25 21:00:22',NULL,NULL),(5054,936,'906119','834','00','005010X220A1','906119','','2013-12-11','09:05:39',0,'2013-12-26 00:47:44',NULL,NULL),(19565,3626,'3428377','834','00','005010X220A1','3428377','','2014-02-14','17:10:25',0,'2014-02-14 21:31:13',NULL,NULL),(19269,3581,'2950077','834','00','005010X220A1','2950077','','2014-02-13','17:22:16',0,'2014-02-13 22:00:49',NULL,NULL),(16631,3054,'1891742','834','00','005010X220A1','1891742','','2014-01-26','08:55:49',0,'2014-01-26 19:00:26',NULL,NULL),(16956,3116,'2120700','834','00','005010X220A1','2120700','','2014-01-28','19:59:58',0,'2014-01-29 21:00:26',NULL,NULL),(22769,4277,'3156598','834','00','005010X220A1','3156598','','2014-03-05','18:40:42',0,'2014-03-06 21:00:43',NULL,NULL),(22966,4312,'2608980','834','00','005010X220A1','2608980','','2014-03-06','16:36:42',0,'2014-03-06 21:30:08',NULL,NULL),(23033,4329,'3467062','834','00','005010X220A1','3467062','','2014-03-07','10:30:12',0,'2014-03-07 21:00:27',NULL,NULL),(21084,3983,'3198221','834','00','005010X220A1','3198221','','2014-02-24','14:05:35',0,'2014-02-26 09:30:52',NULL,NULL),(20992,3959,'3380186','834','00','005010X220A1','3380186','','2014-02-21','18:38:26',0,'2014-02-26 08:30:31',NULL,NULL),(20356,3816,'3225900','834','00','005010X220A1','3225900','','2014-02-19','16:35:57',0,'2014-02-20 04:56:01',NULL,NULL),(18625,3459,'2876518','834','00','005010X220A1','2876518','','2014-02-10','11:59:44',0,'2014-02-10 21:31:22',NULL,NULL),(15827,2736,'1402781','834','00','005010X220A1','1402781','','2014-01-20','22:53:29',1,'2014-01-22 03:21:54',NULL,NULL),(3518,615,'390985','834','00','005010X220A1','390985','','2013-12-12','17:11:56',0,'2013-12-25 22:01:44',NULL,NULL),(3027,544,'1022646','834','00','005010X220A1','1022646','','2013-12-12','20:40:21',0,'2013-12-25 21:33:56',NULL,NULL),(1421,249,'1523172','834','00','005010X220A1','1523172','','2013-12-24','12:13:32',0,'2013-12-25 18:54:45',NULL,NULL),(15489,2634,'1776209','834','00','005010X220A1','1776209','','2014-01-16','14:58:59',0,'2014-01-17 03:36:26',NULL,NULL),(725,122,'704751','834','00','005010X220A1','704751','','2013-12-16','10:10:03',0,'2013-12-25 18:07:34',NULL,NULL),(22457,4235,'3227698','834','00','005010X220A1','3227698','','2014-03-04','12:30:03',0,'2014-03-04 21:30:22',NULL,NULL),(20529,3849,'3518609','834','00','005010X220A1','3518609','','2014-02-20','14:36:03',0,'2014-02-20 22:01:27',NULL,NULL),(13471,2226,'2448865','834','00','005010X220A1','2448865','','2014-01-06','10:18:49',0,'2014-01-07 04:03:31',NULL,NULL),(11408,1466,'2139014','834','00','005010X220A1','2139014','','2013-12-26','17:17:44',0,'2013-12-27 02:06:49',NULL,NULL),(17869,3293,'2419617','834','00','005010X220A1','2419617','','2014-02-05','15:44:06',0,'2014-02-05 21:30:15',NULL,NULL),(5551,1043,'1642260','834','00','005010X220A1','1642260','','2013-12-24','18:32:22',0,'2013-12-26 01:48:04',NULL,NULL),(6278,1172,'1352470','834','00','005010X220A1','1352470','','2013-12-20','14:39:30',0,'2013-12-26 03:06:47',NULL,NULL),(16079,2776,'1773651','834','00','005010X220A1','1773651','','2014-01-22','13:38:38',0,'2014-01-23 03:02:49',NULL,NULL),(2273,391,'1257292','834','00','005010X220A1','1257292','','2013-11-23','18:05:54',0,'2013-12-25 20:00:16',NULL,NULL),(19892,3711,'3282789','834','00','005010X220A1','3282789','','2014-02-16','10:26:09',0,'2014-02-16 19:00:33',NULL,NULL),(17850,3291,'2793348','834','00','005010X220A1','2793348','','2014-02-04','23:03:32',0,'2014-02-05 21:30:05',NULL,NULL),(13056,1900,'0001','999','BE','005010X231A1','129405','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:37',NULL,NULL),(12059,1585,'1508277','834','00','005010X220A1','1508277','','2013-12-30','18:25:32',0,'2014-01-01 12:04:19',NULL,NULL),(12036,1583,'2110434','834','00','005010X220A1','2110434','','2013-12-30','15:01:14',0,'2014-01-01 12:03:26',NULL,NULL),(11025,1416,'1011891','834','00','005010X220A1','1011891','','2013-12-23','09:00:18',0,'2013-12-26 13:11:38',NULL,NULL),(16876,3093,'2277608','834','00','005010X220A1','2277608','','2014-01-28','15:37:49',0,'2014-01-28 21:00:57',NULL,NULL),(799,150,'1251187','834','00','005010X220A1','1251187','','2013-10-28','20:28:43',0,'2013-12-25 18:10:08',NULL,NULL),(3801,660,'974266','834','00','005010X220A1','974266','','2013-12-08','14:54:58',0,'2013-12-25 22:16:20',NULL,NULL),(21435,4027,'3558104','834','00','005010X220A1','3558104','','2014-02-27','11:44:02',0,'2014-02-28 06:30:51',NULL,NULL),(21241,3999,'3331563','834','00','005010X220A1','3331563','','2014-02-26','12:40:39',0,'2014-02-26 21:01:43',NULL,NULL),(3664,626,'483872','834','00','005010X220A1','483872','','2013-12-12','15:50:09',0,'2013-12-25 22:06:20',NULL,NULL),(4684,833,'353213','834','00','005010X220A1','353213','','2013-12-23','23:12:59',0,'2013-12-25 23:50:05',NULL,NULL),(20124,3772,'3564103','834','00','005010X220A1','3564103','','2014-02-19','11:28:10',0,'2014-02-20 03:54:30',NULL,NULL),(19046,3540,'2966314','834','00','005010X220A1','2966314','','2014-02-12','14:11:10',0,'2014-02-12 21:30:57',NULL,NULL),(18616,3456,'2637311','834','00','005010X220A1','2637311','','2014-02-10','18:06:01',0,'2014-02-10 21:31:15',NULL,NULL),(3251,578,'376451','834','00','005010X220A1','376451','','2013-12-17','17:33:08',0,'2013-12-25 21:46:52',NULL,NULL),(18083,3323,'1830889','834','00','005010X220A1','1830889','','2014-02-05','22:53:21',0,'2014-02-06 21:01:04',NULL,NULL),(882,177,'146060','834','00','005010X220A1','146060','','2013-12-03','09:20:58',0,'2013-12-25 18:16:38',NULL,NULL),(11687,1516,'1585520','834','00','005010X220A1','1585520','','2013-12-27','19:49:32',1,'2013-12-29 11:07:31',NULL,NULL),(10736,1403,'258803','834','00','005010X220A1','258803','','2013-12-23','15:18:21',0,'2013-12-26 13:01:45',NULL,NULL),(21825,4098,'3217230','834','00','005010X220A1','3217230','','2014-02-27','21:45:58',0,'2014-02-28 21:31:39',NULL,NULL),(22326,4202,'3806464','834','00','005010X220A1','3806464','','2014-03-04','13:57:17',0,'2014-03-04 21:01:18',NULL,NULL),(23179,4345,'3226416','834','00','005010X220A1','3226416','','2014-03-07','08:15:36',0,'2014-03-07 21:31:31',NULL,NULL),(1116,238,'260224','834','00','005010X220A1','260224','','2013-12-24','11:06:06',0,'2013-12-25 18:45:08',NULL,NULL),(7398,1294,'1165295','834','00','005010X220A1','1165295','','2013-12-21','12:43:23',0,'2013-12-26 04:30:48',NULL,NULL),(2878,521,'148266','834','00','005010X220A1','148266','','2013-12-22','10:20:28',0,'2013-12-25 21:22:55',NULL,NULL),(7241,1243,'1317360','834','00','005010X220A1','1317360','','2013-12-18','10:58:40',0,'2013-12-26 04:07:57',NULL,NULL),(20330,3799,'3472488','834','00','005010X220A1','3472488','','2014-02-19','14:25:57',0,'2014-02-20 04:50:48',NULL,NULL),(6116,1166,'255965','834','00','005010X220A1','255965','','2013-12-20','13:59:21',0,'2013-12-26 03:01:46',NULL,NULL),(5898,1110,'621980','834','00','005010X220A1','621980','','2013-12-15','12:18:45',0,'2013-12-26 02:30:41',NULL,NULL),(5863,1101,'436897','834','00','005010X220A1','436897','','2013-10-28','15:36:52',0,'2013-12-26 02:16:39',NULL,NULL),(7596,1303,'22360','834','00','005010X220A1','22360','','2013-12-20','19:13:37',0,'2013-12-26 04:37:10',NULL,NULL),(11652,1500,'2068809','834','00','005010X220A1','2068809','','2013-12-27','10:23:36',0,'2013-12-28 03:36:20',NULL,NULL),(11991,1580,'1637946','834','00','005010X220A1','1637946','','2013-12-30','18:14:14',0,'2014-01-01 12:01:43',NULL,NULL),(13647,2271,'1648757','834','00','005010X220A1','1648757','','2014-01-07','10:41:56',0,'2014-01-08 18:24:09',NULL,NULL),(13940,2318,'1466055','834','00','005010X220A1','1466055','','2014-01-08','20:23:44',0,'2014-01-13 02:20:13',NULL,NULL),(20772,3907,'3205265','834','00','005010X220A1','3205265','','2014-02-24','21:43:02',0,'2014-02-25 21:30:35',NULL,NULL),(21267,4000,'3811371','834','00','005010X220A1','3811371','','2014-02-26','16:47:02',0,'2014-02-26 21:02:00',NULL,NULL),(521,102,'1245582','834','00','005010X220A1','1245582','','2013-12-16','12:53:03',0,'2013-12-25 18:01:04',NULL,NULL),(18719,3485,'2783630','834','00','005010X220A1','2783630','','2014-02-10','22:27:45',0,'2014-02-11 21:00:14',NULL,NULL),(1567,276,'663220','834','00','005010X220A1','663220','','2013-11-20','13:52:46',0,'2013-12-25 19:00:10',NULL,NULL),(16325,2983,'2294387','834','00','005010X220A1','2294387','','2014-01-22','19:06:45',0,'2014-01-23 21:00:32',NULL,NULL),(16089,2781,'1550293','834','00','005010X220A1','1550293','','2014-01-22','14:06:15',0,'2014-01-23 03:02:54',NULL,NULL),(15063,2585,'1655228','834','00','005010X220A1','1655228','','2014-01-15','10:35:35',0,'2014-01-16 08:44:57',NULL,NULL),(14337,2400,'1404890','834','00','005010X220A1','1404890','','2014-01-12','17:24:28',0,'2014-01-13 03:01:16',NULL,NULL),(2430,417,'32479','834','00','005010X220A1','32479','','2013-12-06','10:02:05',0,'2013-12-25 20:18:10',NULL,NULL),(14331,2400,'2221706','834','00','005010X220A1','2221706','','2014-01-12','12:27:18',0,'2014-01-13 03:01:11',NULL,NULL),(13614,2268,'2271497','834','00','005010X220A1','2271497','','2014-01-05','10:07:22',1,'2014-01-07 10:23:29',NULL,NULL),(3064,544,'1039031','834','00','005010X220A1','1039031','','2013-12-13','15:32:19',0,'2013-12-25 21:35:04',NULL,NULL),(10900,1409,'1414529','834','00','005010X220A1','1414529','','2013-12-23','09:50:43',0,'2013-12-26 13:07:38',NULL,NULL),(12297,1626,'1981716','834','00','005010X220A1','1981716','','2014-01-01','15:43:08',1,'2014-01-02 04:25:11',NULL,NULL),(20902,3929,'3486268','834','00','005010X220A1','3486268','','2014-02-22','19:04:04',0,'2014-02-26 08:00:03',NULL,NULL),(20950,3949,'2604982','834','00','005010X220A1','2604982','','2014-02-24','14:02:37',0,'2014-02-26 08:00:41',NULL,NULL),(21976,4144,'3820446','834','00','005010X220A1','3820446','','2014-03-02','12:02:35',0,'2014-03-03 01:00:10',NULL,NULL),(259,48,'244808','834','00','005010X220A1','244808','','2013-11-12','20:10:05',0,'2013-12-25 17:31:10',NULL,NULL),(19510,3622,'3312473','834','00','005010X220A1','3312473','','2014-02-13','19:06:09',0,'2014-02-14 21:30:32',NULL,NULL),(3402,589,'235509','834','00','005010X220A1','235509','','2013-12-17','10:01:50',0,'2013-12-25 21:51:45',NULL,NULL),(18079,3323,'2074580','834','00','005010X220A1','2074580','','2014-02-06','13:47:48',0,'2014-02-06 21:01:01',NULL,NULL),(7616,1304,'921342','834','00','005010X220A1','921342','','2013-12-20','20:03:14',0,'2013-12-26 04:37:46',NULL,NULL),(11119,1427,'322365','834','00','005010X220A1','322365','','2013-12-23','06:01:07',0,'2013-12-26 13:14:46',NULL,NULL),(11544,1492,'54089','834','00','005010X220A1','54089','','2013-12-26','18:55:38',0,'2013-12-28 03:32:57',NULL,NULL),(14065,2339,'2546491','834','00','005010X220A1','2546491','','2014-01-08','12:33:18',0,'2014-01-13 02:21:46',NULL,NULL),(21943,4132,'3584595','834','00','005010X220A1','3584595','','2014-03-01','15:51:14',0,'2014-03-01 21:01:00',NULL,NULL),(184,16,'1302516','834','00','005010X220A1','1302516','','2013-12-05','11:25:12',0,'2013-12-25 17:20:42',NULL,NULL),(18852,3491,'1700077','834','00','005010X220A1','1700077','','2014-02-11','13:41:42',0,'2014-02-11 21:01:54',NULL,NULL),(4273,742,'231029','834','00','005010X220A1','231029','','2013-12-19','16:20:03',0,'2013-12-25 23:08:30',NULL,NULL),(18757,3485,'3223545','834','00','005010X220A1','3223545','','2014-02-11','15:32:30',0,'2014-02-11 21:00:43',NULL,NULL),(2575,472,'976327','834','00','005010X220A1','976327','','2013-10-31','20:04:34',0,'2013-12-25 20:45:09',NULL,NULL),(14677,2548,'1379838','834','00','005010X220A1','1379838','','2014-01-14','12:29:23',0,'2014-01-15 02:05:52',NULL,NULL),(22390,4210,'3585702','834','00','005010X220A1','3585702','','2014-03-04','14:52:24',0,'2014-03-04 21:02:11',NULL,NULL),(22400,4214,'3571899','834','00','005010X220A1','3571899','','2014-03-04','09:03:32',0,'2014-03-04 21:02:20',NULL,NULL),(455,83,'180884','834','00','005010X220A1','180884','','2013-12-03','23:49:48',0,'2013-12-25 17:50:08',NULL,NULL),(7088,1236,'509173','834','00','005010X220A1','509173','','2013-12-18','10:47:36',0,'2013-12-26 04:03:16',NULL,NULL),(17772,3265,'2807499','834','00','005010X220A1','2807499','','2014-02-03','20:40:57',0,'2014-02-04 21:01:13',NULL,NULL),(16752,3067,'1972294','834','00','005010X220A1','1972294','','2014-01-27','15:04:16',0,'2014-01-27 21:01:19',NULL,NULL),(2444,420,'315226','834','00','005010X220A1','315226','','2013-12-05','22:52:55',0,'2013-12-25 20:18:37',NULL,NULL),(3967,716,'556024','834','00','005010X220A1','556024','','2013-12-07','13:00:12',0,'2013-12-25 22:47:09',NULL,NULL),(12370,1634,'2433526','834','00','005010X220A1','2433526','','2013-12-31','17:38:47',1,'2014-01-02 04:28:34',NULL,NULL),(1716,293,'255471','834','00','005010X220A1','255471','','2013-12-09','20:06:19',0,'2013-12-25 19:17:00',NULL,NULL),(2644,501,'1049890','834','00','005010X220A1','1049890','','2013-12-21','18:59:29',0,'2013-12-25 21:15:12',NULL,NULL),(19147,3550,'3176334','834','00','005010X220A1','3176334','','2014-02-12','06:33:17',0,'2014-02-12 21:32:07',NULL,NULL),(12143,1591,'2087760','834','00','005010X220A1','2087760','','2013-12-30','09:34:51',0,'2014-01-01 12:07:13',NULL,NULL),(4780,862,'949052','834','00','005010X220A1','949052','','2013-12-01','16:17:58',0,'2013-12-26 00:01:16',NULL,NULL),(7186,1239,'708671','834','00','005010X220A1','708671','','2013-12-17','23:19:25',0,'2013-12-26 04:06:13',NULL,NULL),(10907,1409,'1710014','834','00','005010X220A1','1710014','','2013-12-23','16:51:16',0,'2013-12-26 13:07:51',NULL,NULL),(335,72,'1051868','834','00','005010X220A1','1051868','','2013-12-04','12:33:59',0,'2013-12-25 17:46:17',NULL,NULL),(18505,3444,'2879437','834','00','005010X220A1','2879437','','2014-02-10','10:28:01',0,'2014-02-10 21:00:05',NULL,NULL),(1248,243,'1548164','834','00','005010X220A1','1548164','','2013-12-24','11:26:20',0,'2013-12-25 18:49:07',NULL,NULL),(18004,3318,'2684508','834','00','005010X220A1','2684508','','2014-02-06','15:35:43',0,'2014-02-06 21:00:10',NULL,NULL),(16483,3010,'2491663','834','00','005010X220A1','2491663','','2014-01-24','18:17:45',0,'2014-01-24 21:00:31',NULL,NULL),(15202,2592,'1886611','834','00','005010X220A1','1886611','','2014-01-15','11:47:12',0,'2014-01-16 08:46:27',NULL,NULL),(15139,2588,'2592775','834','00','005010X220A1','2592775','','2014-01-14','19:37:00',0,'2014-01-16 08:45:47',NULL,NULL),(4680,832,'46123','834','00','005010X220A1','46123','','2013-12-23','21:15:30',0,'2013-12-25 23:49:56',NULL,NULL),(7213,1241,'244028','834','00','005010X220A1','244028','','2013-12-18','10:17:35',0,'2013-12-26 04:07:00',NULL,NULL),(7655,1313,'799897','834','00','005010X220A1','799897','','2013-12-21','17:53:05',0,'2013-12-26 04:39:01',NULL,NULL),(12585,1670,'1312402','834','00','005010X220A1','1312402','','2014-01-02','11:21:10',0,'2014-01-03 02:00:34',NULL,NULL),(13287,2131,'0001','999','BE','005010X231A1','46580','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:35',NULL,NULL),(14804,2551,'2331447','834','00','005010X220A1','2331447','','2014-01-14','18:34:50',0,'2014-01-15 02:06:46',NULL,NULL),(21541,4041,'2641513','834','00','005010X220A1','2641513','','2014-02-27','10:24:20',0,'2014-02-28 06:31:40',NULL,NULL),(21817,4094,'3247146','834','00','005010X220A1','3247146','','2014-02-28','11:27:46',0,'2014-02-28 21:31:33',NULL,NULL),(22124,4179,'2866045','834','00','005010X220A1','2866045','','2014-03-03','09:55:26',0,'2014-03-03 21:30:37',NULL,NULL),(22688,4257,'3445599','834','00','005010X220A1','3445599','','2014-03-05','16:33:47',0,'2014-03-05 21:32:19',NULL,NULL),(22796,4277,'2930498','834','00','005010X220A1','2930498','','2014-03-06','17:11:54',0,'2014-03-06 21:01:02',NULL,NULL),(17990,3313,'1441890','834','00','005010X220A1','1441890','','2014-02-05','12:31:29',0,'2014-02-05 21:31:17',NULL,NULL),(5197,949,'549999','834','00','005010X220A1','549999','','2013-12-11','12:56:47',0,'2013-12-26 00:52:16',NULL,NULL),(15526,2653,'2249741','834','00','005010X220A1','2249741','','2014-01-15','20:50:43',0,'2014-01-17 03:36:43',NULL,NULL),(10490,1400,'801546','834','00','005010X220A1','801546','','2013-12-23','17:00:21',0,'2013-12-26 12:53:33',NULL,NULL),(14060,2339,'1823586','834','00','005010X220A1','1823586','','2014-01-08','10:52:58',0,'2014-01-13 02:21:43',NULL,NULL),(23016,4325,'3875197','834','00','005010X220A1','3875197','','2014-03-06','22:56:12',0,'2014-03-07 21:00:18',NULL,NULL),(23445,4408,'3685808','834','00','005010X220A1','3685808','','2014-03-09','09:45:51',0,'2014-03-09 21:00:45',NULL,NULL),(89,4,'158739','834','00','005010X220A1','158739','','2013-12-05','13:31:51',0,'2013-12-25 17:17:42',NULL,NULL),(7239,1243,'989343','834','00','005010X220A1','989343','','2013-12-17','19:31:33',0,'2013-12-26 04:07:54',NULL,NULL),(19137,3548,'2672087','834','00','005010X220A1','2672087','','2014-02-12','16:29:35',0,'2014-02-12 21:32:01',NULL,NULL),(3818,667,'845711','834','00','005010X220A1','845711','','2013-12-08','06:22:37',0,'2013-12-25 22:16:57',NULL,NULL),(15485,2634,'2136952','834','00','005010X220A1','2136952','','2014-01-16','12:13:05',0,'2014-01-17 03:36:24',NULL,NULL),(14350,2402,'2031707','834','00','005010X220A1','2031707','','2014-01-11','18:58:12',0,'2014-01-13 03:01:25',NULL,NULL),(3398,589,'1205407','834','00','005010X220A1','1205407','','2013-12-16','20:37:49',0,'2013-12-25 21:51:37',NULL,NULL),(2213,365,'612867','834','00','005010X220A1','612867','','2013-12-02','13:28:53',0,'2013-12-25 19:48:35',NULL,NULL),(1131,238,'4809','834','00','005010X220A1','4809','','2013-12-24','15:35:26',0,'2013-12-25 18:45:36',NULL,NULL),(2279,392,'738291','834','00','005010X220A1','738291','','2013-11-24','16:32:49',0,'2013-12-25 20:00:26',NULL,NULL),(20661,3877,'2844360','834','00','005010X220A1','2844360','','2014-02-21','14:25:06',0,'2014-02-21 22:01:00',NULL,NULL),(3145,556,'936662','834','00','005010X220A1','936662','','2013-12-12','20:40:21',0,'2013-12-25 21:37:36',NULL,NULL),(19259,3581,'2700295','834','00','005010X220A1','2700295','','2014-02-13','13:48:32',0,'2014-02-13 22:00:41',NULL,NULL),(17192,3149,'2213260','834','00','005010X220A1','2213260','','2014-01-30','11:35:28',0,'2014-01-30 21:01:04',NULL,NULL),(16881,3094,'2661161','834','00','005010X220A1','2661161','','2014-01-27','20:44:05',0,'2014-01-28 21:01:00',NULL,NULL),(13790,2294,'1625810','834','00','005010X220A1','1625810','','2014-01-10','21:52:43',0,'2014-01-13 02:18:07',NULL,NULL),(15252,2600,'1426742','834','00','005010X220A1','1426742','','2014-01-15','14:49:13',0,'2014-01-16 08:46:58',NULL,NULL),(22522,4247,'3442607','834','00','005010X220A1','3442607','','2014-03-05','13:21:27',0,'2014-03-05 21:30:22',NULL,NULL),(2451,422,'97295','834','00','005010X220A1','97295','','2013-12-06','11:12:19',0,'2013-12-25 20:18:53',NULL,NULL),(19820,3679,'2811567','834','00','005010X220A1','2811567','','2014-02-15','13:29:13',0,'2014-02-15 22:01:39',NULL,NULL),(5825,1088,'375873','834','00','005010X220A1','375873','','2013-11-23','12:56:40',0,'2013-12-26 02:15:13',NULL,NULL),(5143,943,'263313','834','00','005010X220A1','263313','','2013-12-11','12:57:15',0,'2013-12-26 00:50:36',NULL,NULL),(3603,619,'690727','834','00','005010X220A1','690727','','2013-12-11','19:13:22',0,'2013-12-25 22:04:26',NULL,NULL),(10562,1402,'619720','834','00','005010X220A1','619720','','2013-12-22','23:18:40',0,'2013-12-26 12:55:57',NULL,NULL),(11045,1418,'658840','834','00','005010X220A1','658840','','2013-12-23','13:25:07',0,'2013-12-26 13:12:18',NULL,NULL),(12151,1591,'1985569','834','00','005010X220A1','1985569','','2013-12-30','13:16:31',0,'2014-01-01 12:07:27',NULL,NULL),(19256,3581,'2673331','834','00','005010X220A1','2673331','','2014-02-13','10:42:58',0,'2014-02-13 22:00:39',NULL,NULL),(17965,3300,'1966263','834','00','005010X220A1','1966263','','2014-02-05','18:09:36',0,'2014-02-05 21:31:03',NULL,NULL),(23500,4434,'3495061','834','00','005010X220A1','3495061','','2014-03-09','21:25:01',0,'2014-03-10 21:00:03',NULL,NULL),(82,4,'418980','834','00','005010X220A1','418980','','2013-12-04','20:47:54',0,'2013-12-25 17:17:28',NULL,NULL),(703,115,'1249401','834','00','005010X220A1','1249401','','2013-12-15','23:44:10',0,'2013-12-25 18:06:50',NULL,NULL),(7050,1235,'906463','834','00','005010X220A1','906463','','2013-12-18','17:23:40',0,'2013-12-26 04:02:01',NULL,NULL),(18849,3491,'2317318','834','00','005010X220A1','2317318','','2014-02-11','13:07:45',0,'2014-02-11 21:01:51',NULL,NULL),(4128,733,'1249604','834','00','005010X220A1','1249604','','2013-12-19','14:30:19',0,'2013-12-25 23:04:02',NULL,NULL),(17387,3194,'2669000','834','00','005010X220A1','2669000','','2014-01-31','17:50:53',0,'2014-01-31 21:01:44',NULL,NULL),(12066,1586,'1839408','834','00','005010X220A1','1839408','','2013-12-30','05:44:10',0,'2014-01-01 12:04:34',NULL,NULL),(11505,1489,'564304','834','00','005010X220A1','564304','','2013-12-27','18:28:24',0,'2013-12-28 03:31:48',NULL,NULL),(23491,4431,'2930586','834','00','005010X220A1','2930586','','2014-03-09','13:52:47',0,'2014-03-09 21:30:05',NULL,NULL),(6140,1166,'259935','834','00','005010X220A1','259935','','2013-12-20','16:27:18',0,'2013-12-26 03:02:32',NULL,NULL),(21600,4064,'2695283','834','00','005010X220A1','2695283','','2014-02-26','18:34:42',0,'2014-02-28 07:30:04',NULL,NULL),(11188,1453,'789924','834','00','005010X220A1','789924','','2013-12-25','19:56:08',0,'2013-12-27 02:00:04',NULL,NULL),(11693,1517,'1399665','834','00','005010X220A1','1399665','','2013-12-27','18:48:49',1,'2013-12-29 11:07:42',NULL,NULL),(12662,1673,'2317627','834','00','005010X220A1','2317627','','2014-01-02','10:32:00',0,'2014-01-03 02:03:24',NULL,NULL),(13148,1992,'0001','999','BE','005010X231A1','878207','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:27',NULL,NULL),(14186,2365,'2323814','834','00','005010X220A1','2323814','','2014-01-09','22:34:34',0,'2014-01-13 02:23:34',NULL,NULL),(14569,2519,'2089270','834','00','005010X220A1','2089270','','2014-01-13','16:27:47',0,'2014-01-14 01:32:47',NULL,NULL),(14909,2558,'1757082','834','00','005010X220A1','1757082','','2014-01-14','16:04:02',0,'2014-01-15 02:07:33',NULL,NULL),(20534,3852,'3346454','834','00','005010X220A1','3346454','','2014-02-20','10:59:45',0,'2014-02-20 22:01:31',NULL,NULL),(19860,3704,'2792459','834','00','005010X220A1','2792459','','2014-02-15','18:13:38',0,'2014-02-16 19:00:07',NULL,NULL),(18307,3383,'1934360','834','00','005010X220A1','1934360','','2014-02-08','11:17:46',0,'2014-02-08 19:00:39',NULL,NULL),(18082,3323,'2170734','834','00','005010X220A1','2170734','','2014-02-05','19:49:51',0,'2014-02-06 21:01:03',NULL,NULL),(2880,522,'693675','834','00','005010X220A1','693675','','2013-12-22','17:56:24',0,'2013-12-25 21:22:59',NULL,NULL),(15426,2629,'1782336','834','00','005010X220A1','1782336','','2014-01-16','13:16:51',0,'2014-01-17 03:36:00',NULL,NULL),(12299,1627,'2526058','834','00','005010X220A1','2526058','','2014-01-01','09:04:30',1,'2014-01-02 04:25:15',NULL,NULL),(10479,1400,'748395','834','00','005010X220A1','748395','','2013-12-23','15:23:26',0,'2013-12-26 12:53:14',NULL,NULL),(17140,3144,'2379223','834','00','005010X220A1','2379223','','2014-01-30','11:01:17',0,'2014-01-30 21:00:31',NULL,NULL),(14848,2553,'1786359','834','00','005010X220A1','1786359','','2014-01-14','13:17:20',0,'2014-01-15 02:07:05',NULL,NULL),(5206,949,'248994','834','00','005010X220A1','248994','','2013-12-11','14:40:59',0,'2013-12-26 00:52:33',NULL,NULL),(22439,4230,'3301413','834','00','005010X220A1','3301413','','2014-03-04','13:09:36',0,'2014-03-04 21:30:08',NULL,NULL),(23188,4345,'3257121','834','00','005010X220A1','3257121','','2014-03-07','15:36:09',0,'2014-03-07 21:31:37',NULL,NULL),(23210,4347,'2841464','834','00','005010X220A1','2841464','','2014-03-07','14:05:42',0,'2014-03-07 21:31:52',NULL,NULL),(20123,3772,'3534787','834','00','005010X220A1','3534787','','2014-02-19','10:41:07',0,'2014-02-20 03:53:54',NULL,NULL),(15044,2584,'1678043','834','00','005010X220A1','1678043','','2014-01-15','18:06:27',0,'2014-01-16 08:44:45',NULL,NULL),(6039,1149,'95619','834','00','005010X220A1','95619','','2013-10-14','10:20:07',0,'2013-12-26 02:46:12',NULL,NULL),(4523,817,'957811','834','00','005010X220A1','957811','','2013-11-26','12:05:01',0,'2013-12-25 23:32:50',NULL,NULL),(5119,942,'204863','834','00','005010X220A1','204863','','2013-12-11','10:25:42',0,'2013-12-26 00:49:51',NULL,NULL),(16689,3062,'2602088','834','00','005010X220A1','2602088','','2014-01-27','14:28:48',0,'2014-01-27 21:00:36',NULL,NULL),(7630,1308,'1003548','834','00','005010X220A1','1003548','','2013-12-21','16:03:14',0,'2013-12-26 04:38:13',NULL,NULL),(721,121,'311625','834','00','005010X220A1','311625','','2013-12-16','09:53:04',0,'2013-12-25 18:07:28',NULL,NULL),(16267,2959,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:05:00',0,'2014-01-23 09:30:03',NULL,NULL),(13221,2065,'0001','999','BE','005010X231A1','691076','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:51',NULL,NULL),(2658,501,'931827','834','00','005010X220A1','931827','','2013-12-22','12:34:10',0,'2013-12-25 21:15:42',NULL,NULL),(5472,1040,'1440799','834','00','005010X220A1','1440799','','2013-12-24','21:42:38',0,'2013-12-26 01:45:30',NULL,NULL),(12343,1634,'2217809','834','00','005010X220A1','2217809','','2013-12-31','12:06:21',1,'2014-01-02 04:27:39',NULL,NULL),(3751,645,'177459','834','00','005010X220A1','177459','','2013-12-12','16:54:05',0,'2013-12-25 22:09:13',NULL,NULL),(11940,1575,'2004821','834','00','005010X220A1','2004821','','2013-12-29','17:34:10',0,'2013-12-30 00:02:18',NULL,NULL),(19021,3539,'2315967','834','00','005010X220A1','2315967','','2014-02-12','10:17:34',0,'2014-02-12 21:30:41',NULL,NULL),(15654,2683,'1373074','834','00','005010X220A1','1373074','','2014-01-18','13:11:11',0,'2014-01-21 08:44:27',NULL,NULL),(10565,1402,'1430851','834','00','005010X220A1','1430851','','2013-12-23','03:19:44',0,'2013-12-26 12:56:02',NULL,NULL),(7218,1241,'1171153','834','00','005010X220A1','1171153','','2013-12-18','11:51:12',0,'2013-12-26 04:07:10',NULL,NULL),(12809,1703,'2539998','834','00','005010X220A1','2539998','','2014-01-03','16:06:27',0,'2014-01-04 02:01:35',NULL,NULL),(5495,1041,'362455','834','00','005010X220A1','362455','','2013-12-24','19:03:08',0,'2013-12-26 01:46:15',NULL,NULL),(887,177,'621619','834','00','005010X220A1','621619','','2013-12-03','09:33:40',0,'2013-12-25 18:16:45',NULL,NULL),(5010,935,'611816','834','00','005010X220A1','611816','','2013-12-11','11:05:05',0,'2013-12-26 00:46:19',NULL,NULL),(19009,3539,'3308517','834','00','005010X220A1','3308517','','2014-02-12','00:10:13',0,'2014-02-12 21:30:32',NULL,NULL),(15726,2711,'1755912','834','00','005010X220A1','1755912','','2014-01-20','12:37:18',0,'2014-01-21 08:46:04',NULL,NULL),(5628,1046,'1399581','834','00','005010X220A1','1399581','','2013-12-24','23:09:09',0,'2013-12-26 01:50:39',NULL,NULL),(14551,2519,'2059923','834','00','005010X220A1','2059923','','2014-01-12','23:49:29',0,'2014-01-14 01:32:35',NULL,NULL),(12713,1677,'1654917','834','00','005010X220A1','1654917','','2014-01-02','15:40:40',0,'2014-01-03 02:05:14',NULL,NULL),(14327,2400,'2432567','834','00','005010X220A1','2432567','','2014-01-11','20:19:56',0,'2014-01-13 03:01:08',NULL,NULL),(847,175,'986528','834','00','005010X220A1','986528','','2013-12-03','13:00:06',0,'2013-12-25 18:15:33',NULL,NULL),(10741,1403,'890017','834','00','005010X220A1','890017','','2013-12-23','16:06:46',0,'2013-12-26 13:01:54',NULL,NULL),(21803,4092,'2986960','834','00','005010X220A1','2986960','','2014-02-28','13:48:02',0,'2014-02-28 21:31:23',NULL,NULL),(17803,3271,'2857164','834','00','005010X220A1','2857164','','2014-02-03','22:34:57',0,'2014-02-04 21:01:35',NULL,NULL),(4942,919,'621510','834','00','005010X220A1','621510','','2013-11-19','11:51:57',0,'2013-12-26 00:31:31',NULL,NULL),(16264,2956,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:03:00',0,'2014-01-23 09:01:27',NULL,NULL),(15569,2657,'1759400','834','00','005010X220A1','1759400','','2014-01-17','00:38:55',0,'2014-01-20 08:06:03',NULL,NULL),(11003,1413,'1650995','834','00','005010X220A1','1650995','','2013-12-23','17:55:32',0,'2013-12-26 13:10:53',NULL,NULL),(14320,2397,'1566737','834','00','005010X220A1','1566737','','2014-01-10','17:11:03',0,'2014-01-13 03:00:43',NULL,NULL),(22971,4314,'3395630','834','00','005010X220A1','3395630','','2014-03-06','12:37:31',0,'2014-03-06 21:30:12',NULL,NULL),(827,170,'152819','834','00','005010X220A1','152819','','2013-10-23','18:26:34',0,'2013-12-25 18:11:12',NULL,NULL),(22173,4180,'2761741','834','00','005010X220A1','2761741','','2014-03-03','14:37:16',0,'2014-03-03 21:31:11',NULL,NULL),(2981,542,'630582','834','00','005010X220A1','630582','','2013-12-12','18:46:28',0,'2013-12-25 21:32:33',NULL,NULL),(19047,3540,'3320402','834','00','005010X220A1','3320402','','2014-02-12','14:51:08',0,'2014-02-12 21:30:58',NULL,NULL),(12625,1671,'2058431','834','00','005010X220A1','2058431','','2014-01-02','15:52:21',0,'2014-01-03 02:01:59',NULL,NULL),(12983,1736,'2089040','834','00','005010X220A1','2089040','','2014-01-03','19:12:44',0,'2014-01-05 00:01:32',NULL,NULL),(16919,3114,'1515353','834','00','005010X220A1','1515353','','2014-01-28','19:04:25',0,'2014-01-29 21:00:03',NULL,NULL),(14192,2365,'2573577','834','00','005010X220A1','2573577','','2014-01-10','12:06:30',0,'2014-01-13 02:23:38',NULL,NULL),(14916,2558,'2245004','834','00','005010X220A1','2245004','','2014-01-14','18:33:21',0,'2014-01-15 02:07:36',NULL,NULL),(15759,2714,'2042369','834','00','005010X220A1','2042369','','2014-01-20','11:44:22',0,'2014-01-21 08:46:23',NULL,NULL),(21974,4144,'2830840','834','00','005010X220A1','2830840','','2014-03-01','19:58:44',0,'2014-03-03 01:00:09',NULL,NULL),(7597,1303,'1165273','834','00','005010X220A1','1165273','','2013-12-20','20:26:57',0,'2013-12-26 04:37:12',NULL,NULL),(15516,2646,'1403761','834','00','005010X220A1','1403761','','2014-01-16','15:36:44',0,'2014-01-17 03:36:38',NULL,NULL),(11968,1580,'2466658','834','00','005010X220A1','2466658','','2013-12-30','12:58:28',0,'2014-01-01 12:00:52',NULL,NULL),(3262,579,'890879','834','00','005010X220A1','890879','','2013-12-17','15:36:54',0,'2013-12-25 21:47:11',NULL,NULL),(4034,731,'522630','834','00','005010X220A1','522630','','2013-12-19','14:45:50',0,'2013-12-25 23:01:11',NULL,NULL),(3981,720,'325605','834','00','005010X220A1','325605','','2013-12-07','12:42:14',0,'2013-12-25 22:47:35',NULL,NULL),(22860,4280,'3448967','834','00','005010X220A1','3448967','','2014-03-06','12:11:24',0,'2014-03-06 21:01:47',NULL,NULL),(1475,252,'1570142','834','00','005010X220A1','1570142','','2013-12-24','16:55:12',0,'2013-12-25 18:56:39',NULL,NULL),(2588,475,'1122839','834','00','005010X220A1','1122839','','2013-11-01','06:35:27',0,'2013-12-25 20:45:35',NULL,NULL),(10864,1407,'521692','834','00','005010X220A1','521692','','2013-12-23','16:19:21',0,'2013-12-26 13:05:58',NULL,NULL),(21890,4125,'3690773','834','00','005010X220A1','3690773','','2014-02-28','19:55:23',0,'2014-03-01 21:00:24',NULL,NULL),(19428,3601,'3158323','834','00','005010X220A1','3158323','','2014-02-13','11:06:53',0,'2014-02-13 22:02:51',NULL,NULL),(4186,734,'127573','834','00','005010X220A1','127573','','2013-12-19','14:50:53',0,'2013-12-25 23:05:48',NULL,NULL),(18393,3410,'2742372','834','00','005010X220A1','2742372','','2014-02-08','19:46:36',0,'2014-02-09 19:00:31',NULL,NULL),(17914,3296,'1655695','834','00','005010X220A1','1655695','','2014-02-05','06:08:40',0,'2014-02-05 21:30:37',NULL,NULL),(14644,2529,'2201324','834','00','005010X220A1','2201324','','2014-01-13','13:53:20',0,'2014-01-14 01:33:34',NULL,NULL),(17949,3299,'2469059','834','00','005010X220A1','2469059','','2014-02-05','12:24:45',0,'2014-02-05 21:30:54',NULL,NULL),(16793,3088,'1880869','834','00','005010X220A1','1880869','','2014-01-27','18:42:03',0,'2014-01-28 21:00:04',NULL,NULL),(5087,938,'108293','834','00','005010X220A1','108293','','2013-12-11','08:42:39',0,'2013-12-26 00:48:45',NULL,NULL),(21287,4005,'2836338','834','00','005010X220A1','2836338','','2014-02-26','13:18:49',0,'2014-02-26 21:02:15',NULL,NULL),(21563,4053,'3707047','834','00','005010X220A1','3707047','','2014-02-26','14:18:17',0,'2014-02-28 07:00:07',NULL,NULL),(22974,4315,'3213310','834','00','005010X220A1','3213310','','2014-03-06','12:51:39',0,'2014-03-06 21:30:14',NULL,NULL),(23389,4401,'3237538','834','00','005010X220A1','3237538','','2014-03-09','13:46:04',0,'2014-03-09 21:00:03',NULL,NULL),(23591,4437,'2810905','834','00','005010X220A1','2810905','','2014-03-10','13:41:43',0,'2014-03-10 21:01:11',NULL,NULL),(21171,3998,'3471459','834','00','005010X220A1','3471459','','2014-02-26','08:41:48',0,'2014-02-26 21:00:57',NULL,NULL),(1145,239,'1783102','834','00','005010X220A1','1783102','','2013-12-24','09:00:54',0,'2013-12-25 18:46:04',NULL,NULL),(1365,245,'1741232','834','00','005010X220A1','1741232','','2013-12-24','15:09:08',0,'2013-12-25 18:52:53',NULL,NULL),(15587,2659,'2270579','834','00','005010X220A1','2270579','','2014-01-17','16:47:57',0,'2014-01-20 08:06:17',NULL,NULL),(1989,327,'553465','834','00','005010X220A1','553465','','2013-12-09','17:00:22',0,'2013-12-25 19:34:25',NULL,NULL),(14570,2519,'2109562','834','00','005010X220A1','2109562','','2014-01-13','16:48:48',0,'2014-01-14 01:32:48',NULL,NULL),(2269,388,'98371','834','00','005010X220A1','98371','','2013-10-14','23:03:56',0,'2013-12-25 20:00:08',NULL,NULL),(6111,1166,'1349476','834','00','005010X220A1','1349476','','2013-12-20','13:17:01',0,'2013-12-26 03:01:38',NULL,NULL),(3732,639,'685190','834','00','005010X220A1','685190','','2013-12-12','10:56:51',0,'2013-12-25 22:08:37',NULL,NULL),(18756,3485,'2586947','834','00','005010X220A1','2586947','','2014-02-11','15:26:20',0,'2014-02-11 21:00:43',NULL,NULL),(6212,1168,'998336','834','00','005010X220A1','998336','','2013-12-19','23:10:27',0,'2013-12-26 03:04:40',NULL,NULL),(4155,734,'1274139','834','00','005010X220A1','1274139','','2013-12-18','20:12:52',0,'2013-12-25 23:04:52',NULL,NULL),(2618,489,'335086','834','00','005010X220A1','335086','','2013-11-27','22:32:38',0,'2013-12-25 20:46:32',NULL,NULL),(17204,3149,'1855677','834','00','005010X220A1','1855677','','2014-01-30','18:13:29',0,'2014-01-30 21:01:12',NULL,NULL),(17457,3211,'1553163','834','00','005010X220A1','1553163','','2014-02-01','15:43:24',0,'2014-02-01 19:00:46',NULL,NULL),(21209,3998,'3558070','834','00','005010X220A1','3558070','','2014-02-26','15:58:11',0,'2014-02-26 21:01:22',NULL,NULL),(23088,4339,'3227850','834','00','005010X220A1','3227850','','2014-03-07','14:05:30',0,'2014-03-07 21:30:27',NULL,NULL),(982,184,'197203','834','00','005010X220A1','197203','','2013-12-03','13:00:35',0,'2013-12-25 18:19:39',NULL,NULL),(1727,293,'461156','834','00','005010X220A1','461156','','2013-12-10','09:55:30',0,'2013-12-25 19:17:18',NULL,NULL),(625,108,'208919','834','00','005010X220A1','208919','','2013-12-16','11:09:43',0,'2013-12-25 18:04:26',NULL,NULL),(18927,3519,'2746443','834','00','005010X220A1','2746443','','2014-02-11','05:25:17',0,'2014-02-11 21:30:07',NULL,NULL),(16355,2983,'1366914','834','00','005010X220A1','1366914','','2014-01-23','15:54:56',0,'2014-01-23 21:00:51',NULL,NULL),(16291,2980,'1640931','834','00','005010X220A1','1640931','','2014-01-22','20:40:25',0,'2014-01-23 21:00:05',NULL,NULL),(1877,324,'1168528','834','00','005010X220A1','1168528','','2013-12-09','17:58:54',0,'2013-12-25 19:31:07',NULL,NULL),(1673,290,'776579','834','00','005010X220A1','776579','','2013-12-10','11:07:41',0,'2013-12-25 19:15:38',NULL,NULL),(5352,1003,'67050','834','00','005010X220A1','67050','','2013-11-25','12:49:20',0,'2013-12-26 01:15:54',NULL,NULL),(1931,326,'744143','834','00','005010X220A1','744143','','2013-12-09','08:34:40',0,'2013-12-25 19:32:39',NULL,NULL),(4028,731,'465448','834','00','005010X220A1','465448','','2013-12-19','14:25:05',0,'2013-12-25 23:00:58',NULL,NULL),(4419,787,'86862','834','00','005010X220A1','86862','','2013-11-06','09:39:00',0,'2013-12-25 23:16:37',NULL,NULL),(20283,3794,'3528213','834','00','005010X220A1','3528213','','2014-02-19','10:21:42',0,'2014-02-20 04:38:33',NULL,NULL),(11697,1517,'2384691','834','00','005010X220A1','2384691','','2013-12-27','20:35:48',1,'2013-12-29 11:07:49',NULL,NULL),(14789,2551,'1847251','834','00','005010X220A1','1847251','','2014-01-14','16:01:07',0,'2014-01-15 02:06:40',NULL,NULL),(19496,3620,'3502343','834','00','005010X220A1','3502343','','2014-02-14','15:48:36',0,'2014-02-14 21:30:22',NULL,NULL),(17203,3149,'1567190','834','00','005010X220A1','1567190','','2014-01-30','18:13:29',0,'2014-01-30 21:01:11',NULL,NULL),(16663,3060,'1934076','834','00','005010X220A1','1934076','','2014-01-27','16:21:49',0,'2014-01-27 21:00:20',NULL,NULL),(17096,3142,'2390281','834','00','005010X220A1','2390281','','2014-01-29','18:27:11',0,'2014-01-30 21:00:04',NULL,NULL),(22049,4166,'3732465','834','00','005010X220A1','3732465','','2014-03-03','11:17:48',0,'2014-03-03 21:00:10',NULL,NULL),(18313,3384,'2566725','834','00','005010X220A1','2566725','','2014-02-08','11:35:55',0,'2014-02-08 19:00:43',NULL,NULL),(14798,2551,'2369122','834','00','005010X220A1','2369122','','2014-01-14','17:41:54',0,'2014-01-15 02:06:44',NULL,NULL),(14742,2550,'1840916','834','00','005010X220A1','1840916','','2014-01-14','15:53:46',0,'2014-01-15 02:06:20',NULL,NULL),(13257,2101,'0001','999','BE','005010X231A1','171735','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:31',NULL,NULL),(1548,266,'1375143','834','00','005010X220A1','1375143','','2013-12-24','12:26:19',0,'2013-12-25 18:58:54',NULL,NULL),(3151,558,'401051','834','00','005010X220A1','401051','','2013-12-13','09:01:28',0,'2013-12-25 21:37:47',NULL,NULL),(1640,281,'965349','834','00','005010X220A1','965349','','2013-11-19','23:08:35',0,'2013-12-25 19:02:11',NULL,NULL),(11216,1454,'95583','834','00','005010X220A1','95583','','2013-12-26','09:59:46',0,'2013-12-27 02:00:57',NULL,NULL),(11680,1513,'1933322','834','00','005010X220A1','1933322','','2013-12-27','15:25:01',0,'2013-12-28 03:37:16',NULL,NULL),(11681,1514,'2182434','834','00','005010X220A1','2182434','','2013-12-27','16:02:34',0,'2013-12-28 03:37:19',NULL,NULL),(2051,335,'1004268','834','00','005010X220A1','1004268','','2013-12-09','16:40:33',0,'2013-12-25 19:36:26',NULL,NULL),(2746,503,'140254','834','00','005010X220A1','140254','','2013-12-22','17:48:17',0,'2013-12-25 21:18:36',NULL,NULL),(18728,3485,'1779309','834','00','005010X220A1','1779309','','2014-02-11','09:58:26',0,'2014-02-11 21:00:22',NULL,NULL),(18105,3327,'2617807','834','00','005010X220A1','2617807','','2014-02-06','16:17:46',0,'2014-02-06 21:01:19',NULL,NULL),(3999,731,'584433','834','00','005010X220A1','584433','','2013-12-18','20:12:15',0,'2013-12-25 23:00:08',NULL,NULL),(17733,3262,'2585289','834','00','005010X220A1','2585289','','2014-02-03','18:49:55',0,'2014-02-04 21:00:50',NULL,NULL),(3272,582,'528406','834','00','005010X220A1','528406','','2013-12-17','09:31:39',0,'2013-12-25 21:47:34',NULL,NULL),(15956,2763,'2192914','834','00','005010X220A1','2192914','','2014-01-22','15:03:28',0,'2014-01-23 03:01:53',NULL,NULL),(12558,1659,'2226343','834','00','005010X220A1','2226343','','2013-12-31','12:33:27',1,'2014-01-02 04:35:34',NULL,NULL),(20835,3911,'2575747','834','00','005010X220A1','2575747','','2014-02-25','11:16:08',0,'2014-02-25 21:31:19',NULL,NULL),(296,69,'1280533','834','00','005010X220A1','1280533','','2013-12-03','23:05:09',0,'2013-12-25 17:45:05',NULL,NULL),(17227,3156,'1541400','834','00','005010X220A1','1541400','','2014-01-30','16:07:44',0,'2014-01-30 21:01:27',NULL,NULL),(1898,325,'119583','834','00','005010X220A1','119583','','2013-12-09','12:23:29',0,'2013-12-25 19:31:42',NULL,NULL),(2148,360,'799227','834','00','005010X220A1','799227','','2013-12-02','16:56:59',0,'2013-12-25 19:46:24',NULL,NULL),(11159,1439,'150948','834','00','005010X220A1','150948','','2013-12-23','09:40:36',0,'2013-12-26 13:16:15',NULL,NULL),(12414,1638,'2272387','834','00','005010X220A1','2272387','','2013-12-30','19:08:41',1,'2014-01-02 04:30:11',NULL,NULL),(22442,4231,'2961574','834','00','005010X220A1','2961574','','2014-03-03','20:29:16',0,'2014-03-04 21:30:11',NULL,NULL),(188,16,'977925','834','00','005010X220A1','977925','','2013-12-05','14:32:17',0,'2013-12-25 17:20:50',NULL,NULL),(5599,1044,'1162775','834','00','005010X220A1','1162775','','2013-12-24','18:41:44',0,'2013-12-26 01:49:37',NULL,NULL),(20533,3851,'3381606','834','00','005010X220A1','3381606','','2014-02-20','09:12:57',0,'2014-02-20 22:01:30',NULL,NULL),(3750,645,'978133','834','00','005010X220A1','978133','','2013-12-12','16:16:20',0,'2013-12-25 22:09:11',NULL,NULL),(2839,511,'228763','834','00','005010X220A1','228763','','2013-12-22','09:51:13',0,'2013-12-25 21:21:38',NULL,NULL),(19933,3733,'2945189','834','00','005010X220A1','2945189','','2014-02-18','17:04:04',0,'2014-02-18 21:30:06',NULL,NULL),(21738,4090,'3002895','834','00','005010X220A1','3002895','','2014-02-27','18:47:36',0,'2014-02-28 21:30:39',NULL,NULL),(759,140,'833122','834','00','005010X220A1','833122','','2013-12-16','14:45:30',0,'2013-12-25 18:08:37',NULL,NULL),(19268,3581,'2696199','834','00','005010X220A1','2696199','','2014-02-13','16:42:21',0,'2014-02-13 22:00:48',NULL,NULL),(4936,918,'779653','834','00','005010X220A1','779653','','2013-11-19','12:07:44',0,'2013-12-26 00:31:20',NULL,NULL),(18998,3538,'2297368','834','00','005010X220A1','2297368','','2014-02-12','17:24:53',0,'2014-02-12 21:30:24',NULL,NULL),(18165,3350,'2967233','834','00','005010X220A1','2967233','','2014-02-07','10:12:52',0,'2014-02-07 19:00:11',NULL,NULL),(3605,619,'1199223','834','00','005010X220A1','1199223','','2013-12-12','09:02:49',0,'2013-12-25 22:04:29',NULL,NULL),(10652,1402,'21364','834','00','005010X220A1','21364','','2013-12-23','18:17:31',0,'2013-12-26 12:58:52',NULL,NULL),(13634,2270,'2457656','834','00','005010X220A1','2457656','','2014-01-07','13:23:41',0,'2014-01-08 18:24:04',NULL,NULL),(13661,2271,'1507173','834','00','005010X220A1','1507173','','2014-01-07','11:10:14',0,'2014-01-08 18:24:14',NULL,NULL),(17948,3299,'2473025','834','00','005010X220A1','2473025','','2014-02-05','12:04:02',0,'2014-02-05 21:30:53',NULL,NULL),(15809,2726,'1360773','834','00','005010X220A1','1360773','','2014-01-20','13:46:57',0,'2014-01-21 08:46:53',NULL,NULL),(15955,2763,'1639911','834','00','005010X220A1','1639911','','2014-01-22','17:38:17',0,'2014-01-23 03:01:52',NULL,NULL),(21190,3998,'3758814','834','00','005010X220A1','3758814','','2014-02-26','14:10:04',0,'2014-02-26 21:01:10',NULL,NULL),(513,102,'519981','834','00','005010X220A1','519981','','2013-12-16','11:43:07',0,'2013-12-25 18:00:51',NULL,NULL),(19868,3708,'3555282','834','00','005010X220A1','3555282','','2014-02-15','20:47:35',0,'2014-02-16 19:00:15',NULL,NULL),(5844,1092,'699500','834','00','005010X220A1','699500','','2013-11-23','08:24:49',0,'2013-12-26 02:15:54',NULL,NULL),(4625,827,'112721','834','00','005010X220A1','112721','','2013-12-23','22:26:31',0,'2013-12-25 23:48:04',NULL,NULL),(4283,742,'558736','834','00','005010X220A1','558736','','2013-12-19','18:18:06',0,'2013-12-25 23:08:47',NULL,NULL),(1923,326,'328779','834','00','005010X220A1','328779','','2013-12-08','21:01:20',0,'2013-12-25 19:32:26',NULL,NULL),(18033,3319,'2205625','834','00','005010X220A1','2205625','','2014-02-06','11:10:23',0,'2014-02-06 21:00:30',NULL,NULL),(11590,1492,'2218989','834','00','005010X220A1','2218989','','2013-12-27','17:39:29',0,'2013-12-28 03:34:25',NULL,NULL),(11944,1579,'1878736','834','00','005010X220A1','1878736','','2013-12-29','18:03:36',0,'2013-12-30 00:02:26',NULL,NULL),(13009,1742,'2493612','834','00','005010X220A1','2493612','','2014-01-04','10:41:57',0,'2014-01-05 00:02:28',NULL,NULL),(17398,3198,'1524192','834','00','005010X220A1','1524192','','2014-02-01','13:13:54',0,'2014-02-01 19:00:08',NULL,NULL),(13208,2052,'0001','999','BE','005010X231A1','79599','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:14',NULL,NULL),(16744,3067,'2220804','834','00','005010X220A1','2220804','','2014-01-26','22:47:39',0,'2014-01-27 21:01:13',NULL,NULL),(21201,3998,'2658393','834','00','005010X220A1','2658393','','2014-02-26','14:59:46',0,'2014-02-26 21:01:17',NULL,NULL),(21502,4030,'3465673','834','00','005010X220A1','3465673','','2014-02-27','12:05:30',0,'2014-02-28 06:31:22',NULL,NULL),(21802,4092,'3663603','834','00','005010X220A1','3663603','','2014-02-28','13:21:21',0,'2014-02-28 21:31:22',NULL,NULL),(22032,4162,'3359765','834','00','005010X220A1','3359765','','2014-03-02','15:43:30',0,'2014-03-03 01:30:00',NULL,NULL),(20826,3910,'2732223','834','00','005010X220A1','2732223','','2014-02-25','17:39:58',0,'2014-02-25 21:31:13',NULL,NULL),(15037,2584,'1884215','834','00','005010X220A1','1884215','','2014-01-15','17:22:05',0,'2014-01-16 08:44:41',NULL,NULL),(2223,368,'412825','834','00','005010X220A1','412825','','2013-12-01','20:24:02',0,'2013-12-25 19:48:56',NULL,NULL),(5120,942,'631530','834','00','005010X220A1','631530','','2013-12-11','10:37:07',0,'2013-12-26 00:49:53',NULL,NULL),(11707,1517,'2339139','834','00','005010X220A1','2339139','','2013-12-28','15:39:23',1,'2013-12-29 11:08:05',NULL,NULL),(3449,606,'518753','834','00','005010X220A1','518753','','2013-12-17','11:36:20',0,'2013-12-25 21:53:17',NULL,NULL),(22846,4279,'3708719','834','00','005010X220A1','3708719','','2014-03-06','10:58:42',0,'2014-03-06 21:01:36',NULL,NULL),(23668,4444,'2786956','834','00','005010X220A1','2786956','','2014-03-10','16:06:43',0,'2014-03-10 21:02:04',NULL,NULL),(18329,3386,'2266474','834','00','005010X220A1','2266474','','2014-02-08','12:06:38',0,'2014-02-08 19:00:52',NULL,NULL),(14905,2558,'2528596','834','00','005010X220A1','2528596','','2014-01-14','13:24:54',0,'2014-01-15 02:07:32',NULL,NULL),(6086,1166,'318317','834','00','005010X220A1','318317','','2013-12-19','20:48:12',0,'2013-12-26 03:00:53',NULL,NULL),(14756,2551,'2449061','834','00','005010X220A1','2449061','','2014-01-13','20:23:12',0,'2014-01-15 02:06:26',NULL,NULL),(2950,541,'1011416','834','00','005010X220A1','1011416','','2013-12-13','10:12:48',0,'2013-12-25 21:31:33',NULL,NULL),(13789,2294,'1601553','834','00','005010X220A1','1601553','','2014-01-10','18:34:02',0,'2014-01-13 02:18:07',NULL,NULL),(7421,1295,'205344','834','00','005010X220A1','205344','','2013-12-21','10:43:22',0,'2013-12-26 04:31:32',NULL,NULL),(7627,1308,'780408','834','00','005010X220A1','780408','','2013-12-21','12:46:40',0,'2013-12-26 04:38:08',NULL,NULL),(23452,4410,'2933982','834','00','005010X220A1','2933982','','2014-03-09','10:14:31',0,'2014-03-09 21:00:52',NULL,NULL),(2102,358,'162031','834','00','005010X220A1','162031','','2013-12-09','17:46:46',0,'2013-12-25 19:38:08',NULL,NULL),(2201,365,'965419','834','00','005010X220A1','965419','','2013-12-01','22:22:57',0,'2013-12-25 19:48:12',NULL,NULL),(20143,3774,'2933381','834','00','005010X220A1','2933381','','2014-02-18','18:04:03',0,'2014-02-20 04:01:47',NULL,NULL),(19522,3622,'2334851','834','00','005010X220A1','2334851','','2014-02-14','11:43:41',0,'2014-02-14 21:30:41',NULL,NULL),(3059,544,'1202868','834','00','005010X220A1','1202868','','2013-12-13','14:48:03',0,'2013-12-25 21:34:54',NULL,NULL),(18104,3327,'2032367','834','00','005010X220A1','2032367','','2014-02-06','14:49:16',0,'2014-02-06 21:01:19',NULL,NULL),(17868,3293,'2272242','834','00','005010X220A1','2272242','','2014-02-05','15:38:10',0,'2014-02-05 21:30:15',NULL,NULL),(16430,3003,'1845150','834','00','005010X220A1','1845150','','2014-01-23','15:25:00',0,'2014-01-23 21:01:44',NULL,NULL),(7466,1296,'125499','834','00','005010X220A1','125499','','2013-12-21','12:18:12',0,'2013-12-26 04:32:50',NULL,NULL),(15588,2659,'2607743','834','00','005010X220A1','2607743','','2014-01-17','01:04:03',0,'2014-01-20 08:06:18',NULL,NULL),(12513,1643,'1736234','834','00','005010X220A1','1736234','','2013-12-31','09:48:14',1,'2014-01-02 04:33:50',NULL,NULL),(15093,2585,'1494056','834','00','005010X220A1','1494056','','2014-01-15','17:32:25',0,'2014-01-16 08:45:14',NULL,NULL),(22743,4276,'2991111','834','00','005010X220A1','2991111','','2014-03-06','10:52:14',0,'2014-03-06 21:00:24',NULL,NULL),(21035,3977,'2589987','834','00','005010X220A1','2589987','','2014-02-23','22:38:15',0,'2014-02-26 09:30:14',NULL,NULL),(19719,3672,'2538158','834','00','005010X220A1','2538158','','2014-02-15','12:05:37',0,'2014-02-15 22:00:21',NULL,NULL),(17943,3299,'2285175','834','00','005010X220A1','2285175','','2014-02-05','09:58:47',0,'2014-02-05 21:30:51',NULL,NULL),(14606,2521,'1601598','834','00','005010X220A1','1601598','','2014-01-13','17:29:02',0,'2014-01-14 01:33:10',NULL,NULL),(16103,2795,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:05:00',1,'2014-01-23 03:41:36',NULL,NULL),(16239,2931,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:41:00',0,'2014-01-23 06:44:44',NULL,NULL),(23161,4344,'2874721','834','00','005010X220A1','2874721','','2014-03-07','10:57:37',0,'2014-03-07 21:31:18',NULL,NULL),(17895,3295,'2857195','834','00','005010X220A1','2857195','','2014-02-04','20:11:32',0,'2014-02-05 21:30:28',NULL,NULL),(21724,4088,'2641568','834','00','005010X220A1','2641568','','2014-02-28','13:42:43',0,'2014-02-28 21:30:30',NULL,NULL),(22669,4254,'3344793','834','00','005010X220A1','3344793','','2014-03-05','15:43:17',0,'2014-03-05 21:32:05',NULL,NULL),(501,102,'1260290','834','00','005010X220A1','1260290','','2013-12-16','09:57:02',0,'2013-12-25 18:00:30',NULL,NULL),(5660,1052,'1921315','834','00','005010X220A1','1921315','','2013-12-24','20:58:01',0,'2013-12-26 01:51:39',NULL,NULL),(19082,3542,'2166914','834','00','005010X220A1','2166914','','2014-02-12','14:04:32',0,'2014-02-12 21:31:26',NULL,NULL),(3172,565,'1155097','834','00','005010X220A1','1155097','','2013-12-13','12:24:16',0,'2013-12-25 21:38:34',NULL,NULL),(14948,2562,'1804792','834','00','005010X220A1','1804792','','2014-01-14','16:48:03',0,'2014-01-15 02:07:51',NULL,NULL),(12807,1703,'1875303','834','00','005010X220A1','1875303','','2014-01-03','15:42:37',0,'2014-01-04 02:01:30',NULL,NULL),(3513,615,'537094','834','00','005010X220A1','537094','','2013-12-12','16:37:55',0,'2013-12-25 22:01:37',NULL,NULL),(7165,1238,'545318','834','00','005010X220A1','545318','','2013-12-18','11:20:29',0,'2013-12-26 04:05:32',NULL,NULL),(7707,1333,'955115','834','00','005010X220A1','955115','','2013-11-14','20:34:16',0,'2013-12-26 04:45:43',NULL,NULL),(21095,3987,'2994354','834','00','005010X220A1','2994354','','2014-02-24','13:55:53',0,'2014-02-26 09:31:01',NULL,NULL),(15465,2632,'1862588','834','00','005010X220A1','1862588','','2014-01-15','20:27:03',0,'2014-01-17 03:36:16',NULL,NULL),(14618,2524,'2090611','834','00','005010X220A1','2090611','','2014-01-13','09:49:34',0,'2014-01-14 01:33:19',NULL,NULL),(14180,2365,'2532296','834','00','005010X220A1','2532296','','2014-01-09','18:57:14',0,'2014-01-13 02:23:28',NULL,NULL),(10653,1402,'678026','834','00','005010X220A1','678026','','2013-12-23','18:22:04',0,'2013-12-26 12:58:54',NULL,NULL),(11176,1446,'1233088','834','00','005010X220A1','1233088','','2013-12-23','15:29:26',0,'2013-12-26 13:16:50',NULL,NULL),(11360,1459,'1360148','834','00','005010X220A1','1360148','','2013-12-26','11:46:53',0,'2013-12-27 02:05:21',NULL,NULL),(19747,3673,'2767303','834','00','005010X220A1','2767303','','2014-02-15','12:22:02',0,'2014-02-15 22:00:41',NULL,NULL),(18283,3379,'1919929','834','00','005010X220A1','1919929','','2014-02-07','20:12:08',0,'2014-02-08 19:00:23',NULL,NULL),(891,177,'527972','834','00','005010X220A1','527972','','2013-12-03','13:15:57',0,'2013-12-25 18:16:52',NULL,NULL),(1631,281,'872180','834','00','005010X220A1','872180','','2013-11-19','23:06:40',0,'2013-12-25 19:01:58',NULL,NULL),(4537,824,'1742504','834','00','005010X220A1','1742504','','2013-12-24','00:07:41',0,'2013-12-25 23:45:14',NULL,NULL),(3560,617,'265951','834','00','005010X220A1','265951','','2013-12-11','18:37:05',0,'2013-12-25 22:03:09',NULL,NULL),(3552,616,'419204','834','00','005010X220A1','419204','','2013-12-12','14:53:18',0,'2013-12-25 22:02:49',NULL,NULL),(2264,383,'369131','834','00','005010X220A1','369131','','2013-12-02','16:49:17',0,'2013-12-25 19:50:25',NULL,NULL),(17352,3181,'1895760','834','00','005010X220A1','1895760','','2014-01-31','12:28:29',0,'2014-01-31 21:01:18',NULL,NULL),(16248,2940,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:00:00',0,'2014-01-23 07:05:11',NULL,NULL),(13781,2290,'1741588','834','00','005010X220A1','1741588','','2014-01-07','13:50:59',0,'2014-01-08 18:25:06',NULL,NULL),(14501,2515,'1821398','834','00','005010X220A1','1821398','','2014-01-13','13:11:46',0,'2014-01-14 01:32:02',NULL,NULL),(23044,4334,'3328132','834','00','005010X220A1','3328132','','2014-03-07','14:48:10',0,'2014-03-07 21:00:33',NULL,NULL),(20531,3849,'2661797','834','00','005010X220A1','2661797','','2014-02-20','17:14:55',0,'2014-02-20 22:01:28',NULL,NULL),(15125,2587,'2601840','834','00','005010X220A1','2601840','','2014-01-15','16:00:13',0,'2014-01-16 08:45:36',NULL,NULL),(3617,621,'851131','834','00','005010X220A1','851131','','2013-12-12','12:56:57',0,'2013-12-25 22:04:53',NULL,NULL),(6325,1175,'533757','834','00','005010X220A1','533757','','2013-12-20','15:06:11',0,'2013-12-26 03:08:09',NULL,NULL),(3811,664,'169405','834','00','005010X220A1','169405','','2013-12-08','06:51:48',0,'2013-12-25 22:16:42',NULL,NULL),(4928,913,'172863','834','00','005010X220A1','172863','','2013-10-15','22:03:15',0,'2013-12-26 00:31:04',NULL,NULL),(7585,1301,'141335','834','00','005010X220A1','141335','','2013-12-21','17:16:45',0,'2013-12-26 04:36:49',NULL,NULL),(10402,1400,'648245','834','00','005010X220A1','648245','','2013-12-23','08:47:02',0,'2013-12-26 12:50:47',NULL,NULL),(22238,4199,'3213204','834','00','005010X220A1','3213204','','2014-03-04','05:06:38',0,'2014-03-04 21:00:11',NULL,NULL),(576,103,'188656','834','00','005010X220A1','188656','','2013-12-16','17:58:35',0,'2013-12-25 18:02:50',NULL,NULL),(13441,2223,'2317715','834','00','005010X220A1','2317715','','2014-01-06','10:26:35',0,'2014-01-07 04:02:22',NULL,NULL),(13254,2098,'0001','999','BE','005010X231A1','128101','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:23',NULL,NULL),(12738,1685,'1634186','834','00','005010X220A1','1634186','','2014-01-01','21:06:21',0,'2014-01-03 02:06:13',NULL,NULL),(18056,3319,'2758462','834','00','005010X220A1','2758462','','2014-02-06','16:10:11',0,'2014-02-06 21:00:45',NULL,NULL),(1377,245,'1981481','834','00','005010X220A1','1981481','','2013-12-24','15:54:41',0,'2013-12-25 18:53:16',NULL,NULL),(4211,738,'673627','834','00','005010X220A1','673627','','2013-12-18','19:32:20',0,'2013-12-25 23:06:33',NULL,NULL),(1656,289,'1326662','834','00','005010X220A1','1326662','','2013-12-09','19:39:00',0,'2013-12-25 19:15:04',NULL,NULL),(7162,1238,'640104','834','00','005010X220A1','640104','','2013-12-18','10:22:23',0,'2013-12-26 04:05:27',NULL,NULL),(20629,3872,'3223817','834','00','005010X220A1','3223817','','2014-02-21','11:46:34',0,'2014-02-21 22:00:38',NULL,NULL),(7367,1285,'57972','834','00','005010X220A1','57972','','2013-11-30','14:43:02',0,'2013-12-26 04:16:06',NULL,NULL),(6458,1215,'599424','834','00','005010X220A1','599424','','2013-11-22','09:16:55',0,'2013-12-26 03:16:24',NULL,NULL),(17310,3174,'2651133','834','00','005010X220A1','2651133','','2014-01-30','19:04:45',0,'2014-01-31 21:00:47',NULL,NULL),(2438,419,'1012303','834','00','005010X220A1','1012303','','2013-12-06','09:56:48',0,'2013-12-25 20:18:25',NULL,NULL),(11144,1433,'737777','834','00','005010X220A1','737777','','2013-12-23','13:01:27',0,'2013-12-26 13:15:43',NULL,NULL),(11059,1421,'1265981','834','00','005010X220A1','1265981','','2013-12-22','21:02:44',0,'2013-12-26 13:12:46',NULL,NULL),(10913,1410,'528730','834','00','005010X220A1','528730','','2013-12-22','19:09:26',0,'2013-12-26 13:08:03',NULL,NULL),(3625,621,'449678','834','00','005010X220A1','449678','','2013-12-12','17:40:30',0,'2013-12-25 22:05:06',NULL,NULL),(3700,633,'28778','834','00','005010X220A1','28778','','2013-12-12','13:21:34',0,'2013-12-25 22:07:30',NULL,NULL),(15582,2658,'1828227','834','00','005010X220A1','1828227','','2014-01-16','20:48:19',0,'2014-01-20 08:06:14',NULL,NULL),(10837,1404,'1721683','834','00','005010X220A1','1721683','','2013-12-23','18:49:20',0,'2013-12-26 13:05:03',NULL,NULL),(11928,1569,'2386133','834','00','005010X220A1','2386133','','2013-12-28','23:30:21',0,'2013-12-30 00:01:53',NULL,NULL),(13537,2241,'2312504','834','00','005010X220A1','2312504','','2014-01-06','13:47:29',0,'2014-01-07 04:05:58',NULL,NULL),(12188,1604,'1368888','834','00','005010X220A1','1368888','','2013-12-30','11:06:11',0,'2014-01-01 12:08:53',NULL,NULL),(16442,3006,'2096767','834','00','005010X220A1','2096767','','2014-01-24','15:38:15',0,'2014-01-24 21:00:08',NULL,NULL),(11832,1541,'812706','834','00','005010X220A1','812706','','2013-12-28','20:27:59',1,'2013-12-29 11:14:07',NULL,NULL),(686,109,'733751','834','00','005010X220A1','733751','','2013-12-16','16:10:41',0,'2013-12-25 18:06:17',NULL,NULL),(21573,4054,'3419836','834','00','005010X220A1','3419836','','2014-02-26','17:28:57',0,'2014-02-28 07:00:15',NULL,NULL),(23375,4397,'3695774','834','00','005010X220A1','3695774','','2014-03-08','13:21:49',0,'2014-03-08 21:31:17',NULL,NULL),(20600,3870,'3427189','834','00','005010X220A1','3427189','','2014-02-21','13:01:50',0,'2014-02-21 22:00:15',NULL,NULL),(1075,215,'73727','834','00','005010X220A1','73727','','2013-11-29','15:49:16',0,'2013-12-25 18:31:05',NULL,NULL),(20183,3779,'2851488','834','00','005010X220A1','2851488','','2014-02-18','18:28:46',0,'2014-02-20 04:13:45',NULL,NULL),(18983,3537,'2831389','834','00','005010X220A1','2831389','','2014-02-12','10:31:51',0,'2014-02-12 21:30:15',NULL,NULL),(3368,587,'1236861','834','00','005010X220A1','1236861','','2013-12-17','13:00:50',0,'2013-12-25 21:50:41',NULL,NULL),(17422,3201,'1727139','834','00','005010X220A1','1727139','','2014-01-31','21:32:25',0,'2014-02-01 19:00:22',NULL,NULL),(13715,2275,'1624636','834','00','005010X220A1','1624636','','2014-01-07','14:02:17',0,'2014-01-08 18:24:35',NULL,NULL),(16618,3050,'1884439','834','00','005010X220A1','1884439','','2014-01-25','21:58:08',0,'2014-01-26 19:00:15',NULL,NULL),(15750,2713,'2529860','834','00','005010X220A1','2529860','','2014-01-20','18:06:49',0,'2014-01-21 08:46:17',NULL,NULL),(15752,2714,'1596798','834','00','005010X220A1','1596798','','2014-01-19','19:33:51',0,'2014-01-21 08:46:19',NULL,NULL),(21433,4027,'3689502','834','00','005010X220A1','3689502','','2014-02-27','11:25:41',0,'2014-02-28 06:30:50',NULL,NULL),(22187,4180,'3070153','834','00','005010X220A1','3070153','','2014-03-03','17:28:32',0,'2014-03-03 21:31:21',NULL,NULL),(558,103,'1031252','834','00','005010X220A1','1031252','','2013-12-16','10:48:52',0,'2013-12-25 18:02:18',NULL,NULL),(19543,3625,'2329692','834','00','005010X220A1','2329692','','2014-02-13','20:17:16',0,'2014-02-14 21:30:56',NULL,NULL),(18301,3382,'3012470','834','00','005010X220A1','3012470','','2014-02-07','20:55:36',0,'2014-02-08 19:00:36',NULL,NULL),(11617,1494,'1906942','834','00','005010X220A1','1906942','','2013-12-27','12:24:35',0,'2013-12-28 03:35:15',NULL,NULL),(16814,3090,'2133563','834','00','005010X220A1','2133563','','2014-01-27','19:46:19',0,'2014-01-28 21:00:16',NULL,NULL),(3007,543,'877351','834','00','005010X220A1','877351','','2013-12-13','09:11:03',0,'2013-12-25 21:33:20',NULL,NULL),(4704,834,'1253458','834','00','005010X220A1','1253458','','2013-12-23','23:57:19',0,'2013-12-25 23:50:46',NULL,NULL),(23555,4436,'3334731','834','00','005010X220A1','3334731','','2014-03-09','20:36:40',0,'2014-03-10 21:00:44',NULL,NULL),(21336,4022,'3176796','834','00','005010X220A1','3176796','','2014-02-26','20:59:41',0,'2014-02-28 06:30:05',NULL,NULL),(5378,1011,'324135','834','00','005010X220A1','324135','','2013-11-25','15:21:34',0,'2013-12-26 01:16:49',NULL,NULL),(18452,3423,'2459655','834','00','005010X220A1','2459655','','2014-02-10','04:11:20',0,'2014-02-10 11:00:35',NULL,NULL),(13005,1741,'2007662','834','00','005010X220A1','2007662','','2014-01-04','13:35:57',0,'2014-01-05 00:02:17',NULL,NULL),(2637,498,'189294','834','00','005010X220A1','189294','','2013-11-28','14:05:36',0,'2013-12-25 20:47:11',NULL,NULL),(11378,1461,'1394437','834','00','005010X220A1','1394437','','2013-12-26','13:12:02',0,'2013-12-27 02:05:53',NULL,NULL),(3468,615,'714044','834','00','005010X220A1','714044','','2013-12-11','19:35:53',0,'2013-12-25 22:00:10',NULL,NULL),(17323,3174,'2481986','834','00','005010X220A1','2481986','','2014-01-31','15:19:54',0,'2014-01-31 21:00:56',NULL,NULL),(7709,1334,'1189178','834','00','005010X220A1','1189178','','2013-11-14','20:43:39',0,'2013-12-26 04:45:46',NULL,NULL),(16041,2771,'2445610','834','00','005010X220A1','2445610','','2014-01-22','14:49:47',0,'2014-01-23 03:02:31',NULL,NULL),(15413,2629,'1642882','834','00','005010X220A1','1642882','','2014-01-15','21:49:54',0,'2014-01-17 03:35:54',NULL,NULL),(12899,1712,'2042886','834','00','005010X220A1','2042886','','2014-01-02','22:07:33',0,'2014-01-04 02:04:52',NULL,NULL),(3467,615,'828065','834','00','005010X220A1','828065','','2013-12-11','19:22:27',0,'2013-12-25 22:00:07',NULL,NULL),(12267,1623,'2194899','834','00','005010X220A1','2194899','','2013-12-31','20:10:55',1,'2014-01-02 04:24:07',NULL,NULL),(22099,4176,'2860718','834','00','005010X220A1','2860718','','2014-03-03','14:46:20',0,'2014-03-03 21:30:18',NULL,NULL),(22214,4187,'2765410','834','00','005010X220A1','2765410','','2014-03-02','21:25:59',0,'2014-03-03 21:31:41',NULL,NULL),(22438,4230,'3641712','834','00','005010X220A1','3641712','','2014-03-04','12:17:48',0,'2014-03-04 21:30:08',NULL,NULL),(20535,3853,'2925116','834','00','005010X220A1','2925116','','2014-02-20','11:07:37',0,'2014-02-20 22:01:32',NULL,NULL),(12545,1653,'1836626','834','00','005010X220A1','1836626','','2013-12-31','11:13:36',1,'2014-01-02 04:35:03',NULL,NULL),(19177,3565,'3311118','834','00','005010X220A1','3311118','','2014-02-12','14:34:58',0,'2014-02-12 21:32:30',NULL,NULL),(15323,2622,'1860250','834','00','005010X220A1','1860250','','2014-01-16','14:17:58',0,'2014-01-17 03:35:11',NULL,NULL),(15130,2587,'1416753','834','00','005010X220A1','1416753','','2014-01-15','17:09:03',0,'2014-01-16 08:45:40',NULL,NULL),(828,171,'1007263','834','00','005010X220A1','1007263','','2013-10-24','14:28:44',0,'2013-12-25 18:11:15',NULL,NULL),(22529,4247,'2997231','834','00','005010X220A1','2997231','','2014-03-05','15:58:59',0,'2014-03-05 21:30:27',NULL,NULL),(21867,4121,'2639103','834','00','005010X220A1','2639103','','2014-02-28','18:08:42',0,'2014-03-01 21:00:07',NULL,NULL),(20957,3951,'3399132','834','00','005010X220A1','3399132','','2014-02-24','12:29:26',0,'2014-02-26 08:00:46',NULL,NULL),(15617,2669,'1532241','834','00','005010X220A1','1532241','','2014-01-17','16:43:16',0,'2014-01-20 08:06:38',NULL,NULL),(14526,2518,'2361610','834','00','005010X220A1','2361610','','2014-01-12','23:46:18',0,'2014-01-14 01:32:19',NULL,NULL),(12664,1673,'1654904','834','00','005010X220A1','1654904','','2014-01-02','12:17:58',0,'2014-01-03 02:03:28',NULL,NULL),(11530,1490,'1771698','834','00','005010X220A1','1771698','','2013-12-27','14:02:29',0,'2013-12-28 03:32:32',NULL,NULL),(23184,4345,'3892174','834','00','005010X220A1','3892174','','2014-03-07','11:40:47',0,'2014-03-07 21:31:35',NULL,NULL),(255,47,'1222241','834','00','005010X220A1','1222241','','2013-11-12','21:40:01',0,'2013-12-25 17:31:02',NULL,NULL),(12191,1606,'428383','834','00','005010X220A1','428383','','2013-12-30','11:18:13',0,'2014-01-01 12:09:00',NULL,NULL),(4875,887,'15105','834','00','005010X220A1','15105','','2013-11-21','14:07:11',0,'2013-12-26 00:16:25',NULL,NULL),(18547,3452,'2987725','834','00','005010X220A1','2987725','','2014-02-10','12:23:35',0,'2014-02-10 21:30:27',NULL,NULL),(1762,295,'1343831','834','00','005010X220A1','1343831','','2013-12-09','18:46:14',0,'2013-12-25 19:18:21',NULL,NULL),(7124,1236,'86174','834','00','005010X220A1','86174','','2013-12-18','15:56:25',0,'2013-12-26 04:04:20',NULL,NULL),(17923,3296,'1531295','834','00','005010X220A1','1531295','','2014-02-05','12:10:54',0,'2014-02-05 21:30:41',NULL,NULL),(10658,1402,'917371','834','00','005010X220A1','917371','','2013-12-23','18:50:38',0,'2013-12-26 12:59:03',NULL,NULL),(10650,1402,'1755076','834','00','005010X220A1','1755076','','2013-12-23','18:09:44',0,'2013-12-26 12:58:48',NULL,NULL),(16319,2982,'2259717','834','00','005010X220A1','2259717','','2014-01-22','18:46:24',0,'2014-01-23 21:00:27',NULL,NULL),(15053,2585,'1601666','834','00','005010X220A1','1601666','','2014-01-14','21:28:19',0,'2014-01-16 08:44:52',NULL,NULL),(4254,741,'329226','834','00','005010X220A1','329226','','2013-12-18','21:08:24',0,'2013-12-25 23:07:56',NULL,NULL),(14421,2442,'0001','999','BE','005010X231A1','258154','834','2013-12-28','04:55:00',0,'2014-01-13 03:02:32',NULL,NULL),(12284,1624,'2082371','834','00','005010X220A1','2082371','','2014-01-01','01:01:08',1,'2014-01-02 04:24:42',NULL,NULL),(534,102,'1064390','834','00','005010X220A1','1064390','','2013-12-16','16:09:45',0,'2013-12-25 18:01:30',NULL,NULL),(22100,4176,'3778372','834','00','005010X220A1','3778372','','2014-03-03','14:58:38',0,'2014-03-03 21:30:18',NULL,NULL),(11435,1478,'1283980','834','00','005010X220A1','1283980','','2013-12-26','17:53:33',0,'2013-12-27 02:07:42',NULL,NULL),(11416,1469,'1989033','834','00','005010X220A1','1989033','','2013-12-26','17:54:41',0,'2013-12-27 02:07:04',NULL,NULL),(18038,3319,'2173246','834','00','005010X220A1','2173246','','2014-02-06','15:18:11',0,'2014-02-06 21:00:33',NULL,NULL),(4669,831,'1064895','834','00','005010X220A1','1064895','','2013-12-23','22:43:43',0,'2013-12-25 23:49:31',NULL,NULL),(4891,899,'351960','834','00','005010X220A1','351960','','2013-10-02','10:40:16',0,'2013-12-26 00:17:04',NULL,NULL),(17669,3259,'2729520','834','00','005010X220A1','2729520','','2014-02-03','18:39:36',0,'2014-02-04 21:00:10',NULL,NULL),(15669,2686,'1545068','834','00','005010X220A1','1545068','','2014-01-18','17:29:34',0,'2014-01-21 08:44:38',NULL,NULL),(15016,2584,'2228038','834','00','005010X220A1','2228038','','2014-01-15','14:01:31',0,'2014-01-16 08:44:28',NULL,NULL),(1063,210,'1137941','834','00','005010X220A1','1137941','','2013-11-29','10:53:39',0,'2013-12-25 18:30:42',NULL,NULL),(708,117,'973054','834','00','005010X220A1','973054','','2013-12-16','11:18:26',0,'2013-12-25 18:06:58',NULL,NULL),(13535,2241,'2083561','834','00','005010X220A1','2083561','','2014-01-06','13:19:51',0,'2014-01-07 04:05:55',NULL,NULL),(12472,1640,'1804426','834','00','005010X220A1','1804426','','2013-12-30','19:35:10',1,'2014-01-02 04:32:17',NULL,NULL),(12256,1620,'2373340','834','00','005010X220A1','2373340','','2013-12-31','22:49:00',1,'2014-01-02 04:23:39',NULL,NULL),(20027,3750,'2885839','834','00','005010X220A1','2885839','','2014-02-18','13:52:05',0,'2014-02-18 22:00:51',NULL,NULL),(13834,2304,'2341687','834','00','005010X220A1','2341687','','2014-01-11','11:37:33',0,'2014-01-13 02:18:38',NULL,NULL),(2461,422,'44112','834','00','005010X220A1','44112','','2013-12-06','13:13:40',0,'2013-12-25 20:19:13',NULL,NULL),(1566,276,'1129438','834','00','005010X220A1','1129438','','2013-11-20','09:38:22',0,'2013-12-25 19:00:08',NULL,NULL),(2009,330,'169443','834','00','005010X220A1','169443','','2013-12-09','17:05:42',0,'2013-12-25 19:35:08',NULL,NULL),(3602,618,'305400','834','00','005010X220A1','305400','','2013-12-11','18:54:39',0,'2013-12-25 22:04:24',NULL,NULL),(4362,764,'1105623','834','00','005010X220A1','1105623','','2013-12-19','14:11:17',0,'2013-12-25 23:11:08',NULL,NULL),(3885,702,'838245','834','00','005010X220A1','838245','','2013-10-26','08:51:45',0,'2013-12-25 22:31:42',NULL,NULL),(220,31,'1072831','834','00','005010X220A1','1072831','','2013-12-05','12:24:55',0,'2013-12-25 17:21:58',NULL,NULL),(6123,1166,'1201988','834','00','005010X220A1','1201988','','2013-12-20','14:54:41',0,'2013-12-26 03:01:59',NULL,NULL),(20037,3750,'2614649','834','00','005010X220A1','2614649','','2014-02-18','17:05:59',0,'2014-02-18 22:00:58',NULL,NULL),(7004,1235,'704850','834','00','005010X220A1','704850','','2013-12-17','20:53:36',0,'2013-12-26 04:00:37',NULL,NULL),(18321,3385,'2557529','834','00','005010X220A1','2557529','','2014-02-08','05:18:29',0,'2014-02-08 19:00:48',NULL,NULL),(7284,1255,'613408','834','00','005010X220A1','613408','','2013-12-18','15:24:38',0,'2013-12-26 04:09:13',NULL,NULL),(10642,1402,'46076','834','00','005010X220A1','46076','','2013-12-23','17:27:17',0,'2013-12-26 12:58:33',NULL,NULL),(16592,3041,'1888139','834','00','005010X220A1','1888139','','2014-01-25','15:23:46',0,'2014-01-25 19:00:17',NULL,NULL),(15775,2717,'2404367','834','00','005010X220A1','2404367','','2014-01-20','12:35:17',0,'2014-01-21 08:46:32',NULL,NULL),(11658,1500,'570584','834','00','005010X220A1','570584','','2013-12-27','12:18:59',0,'2013-12-28 03:36:31',NULL,NULL),(13782,2290,'1887644','834','00','005010X220A1','1887644','','2014-01-07','13:50:59',0,'2014-01-08 18:25:07',NULL,NULL),(553,103,'887375','834','00','005010X220A1','887375','','2013-12-16','09:53:04',0,'2013-12-25 18:02:06',NULL,NULL),(801,152,'853092','834','00','005010X220A1','853092','','2013-10-28','22:42:12',0,'2013-12-25 18:10:12',NULL,NULL),(17726,3261,'2482068','834','00','005010X220A1','2482068','','2014-02-04','16:14:24',0,'2014-02-04 21:00:45',NULL,NULL),(4828,878,'512426','834','00','005010X220A1','512426','','2013-12-01','12:26:18',0,'2013-12-26 00:02:44',NULL,NULL),(17594,3240,'1767492','834','00','005010X220A1','1767492','','2014-02-03','10:22:22',0,'2014-02-03 21:00:55',NULL,NULL),(14228,2368,'2431517','834','00','005010X220A1','2431517','','2014-01-09','22:27:07',0,'2014-01-13 02:24:02',NULL,NULL),(12677,1673,'2487195','834','00','005010X220A1','2487195','','2014-01-02','11:24:48',0,'2014-01-03 02:03:54',NULL,NULL),(12431,1638,'2078659','834','00','005010X220A1','2078659','','2013-12-31','13:57:43',1,'2014-01-02 04:30:48',NULL,NULL),(792,146,'406184','834','00','005010X220A1','406184','','2013-10-31','10:07:43',0,'2013-12-25 18:09:52',NULL,NULL),(13194,2038,'0001','999','BE','005010X231A1','821786','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:35',NULL,NULL),(20130,3772,'2958719','834','00','005010X220A1','2958719','','2014-02-19','14:59:39',0,'2014-02-20 03:57:40',NULL,NULL),(19901,3717,'3058857','834','00','005010X220A1','3058857','','2014-02-15','23:42:37',0,'2014-02-16 19:00:40',NULL,NULL),(18485,3432,'2122203','834','00','005010X220A1','2122203','','2014-02-10','04:14:40',0,'2014-02-10 11:01:03',NULL,NULL),(18258,3376,'2064903','834','00','005010X220A1','2064903','','2014-02-08','11:40:11',0,'2014-02-08 19:00:08',NULL,NULL),(17539,3235,'1881030','834','00','005010X220A1','1881030','','2014-02-03','15:50:32',0,'2014-02-03 21:00:20',NULL,NULL),(1089,218,'1129316','834','00','005010X220A1','1129316','','2013-11-04','16:09:06',0,'2013-12-25 18:31:36',NULL,NULL),(15854,2738,'1430547','834','00','005010X220A1','1430547','','2014-01-21','11:51:44',1,'2014-01-22 03:22:12',NULL,NULL),(10929,1410,'947219','834','00','005010X220A1','947219','','2013-12-23','11:46:59',0,'2013-12-26 13:08:36',NULL,NULL),(14576,2520,'1720048','834','00','005010X220A1','1720048','','2014-01-13','13:18:54',0,'2014-01-14 01:32:51',NULL,NULL),(15209,2592,'2197700','834','00','005010X220A1','2197700','','2014-01-15','15:08:12',0,'2014-01-16 08:46:30',NULL,NULL),(15551,2655,'1565807','834','00','005010X220A1','1565807','','2014-01-17','14:22:37',0,'2014-01-20 08:05:49',NULL,NULL),(22590,4249,'3194829','834','00','005010X220A1','3194829','','2014-03-05','17:29:37',0,'2014-03-05 21:31:11',NULL,NULL),(22096,4176,'3431485','834','00','005010X220A1','3431485','','2014-03-03','12:39:01',0,'2014-03-03 21:30:16',NULL,NULL),(21647,4074,'2874435','834','00','005010X220A1','2874435','','2014-02-27','14:36:50',0,'2014-02-28 07:30:37',NULL,NULL),(13161,2005,'0001','999','BE','005010X231A1','783942','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:03',NULL,NULL),(12319,1634,'1742729','834','00','005010X220A1','1742729','','2013-12-30','19:29:36',1,'2014-01-02 04:26:47',NULL,NULL),(17172,3146,'2432005','834','00','005010X220A1','2432005','','2014-01-29','19:43:01',0,'2014-01-30 21:00:51',NULL,NULL),(15651,2683,'2562096','834','00','005010X220A1','2562096','','2014-01-17','22:19:44',0,'2014-01-21 08:44:24',NULL,NULL),(5318,996,'17674','834','00','005010X220A1','17674','','2013-11-05','02:37:09',0,'2013-12-26 01:02:07',NULL,NULL),(6304,1174,'1060991','834','00','005010X220A1','1060991','','2013-12-20','12:55:22',0,'2013-12-26 03:07:30',NULL,NULL),(2867,514,'1506559','834','00','005010X220A1','1506559','','2013-12-22','11:32:25',0,'2013-12-25 21:22:31',NULL,NULL),(7397,1294,'945855','834','00','005010X220A1','945855','','2013-12-21','11:40:26',0,'2013-12-26 04:30:46',NULL,NULL),(7650,1311,'1290499','834','00','005010X220A1','1290499','','2013-12-21','15:42:00',0,'2013-12-26 04:38:50',NULL,NULL),(23313,4381,'3757752','834','00','005010X220A1','3757752','','2014-03-08','13:36:54',0,'2014-03-08 21:30:30',NULL,NULL),(23578,4436,'3925045','834','00','005010X220A1','3925045','','2014-03-10','16:47:00',0,'2014-03-10 21:01:01',NULL,NULL),(3115,547,'216736','834','00','005010X220A1','216736','','2013-12-13','12:40:23',0,'2013-12-25 21:36:38',NULL,NULL),(19921,3728,'3457344','834','00','005010X220A1','3457344','','2014-02-17','14:34:21',0,'2014-02-17 19:00:13',NULL,NULL),(5752,1070,'468879','834','00','005010X220A1','468879','','2013-12-14','17:54:00',0,'2013-12-26 02:01:56',NULL,NULL),(4249,739,'727907','834','00','005010X220A1','727907','','2013-12-19','17:07:36',0,'2013-12-25 23:07:46',NULL,NULL),(19851,3697,'2498441','834','00','005010X220A1','2498441','','2014-02-15','12:35:44',0,'2014-02-15 22:02:07',NULL,NULL),(11329,1456,'1396782','834','00','005010X220A1','1396782','','2013-12-26','14:19:43',0,'2013-12-27 02:04:23',NULL,NULL),(18410,3417,'2443442','834','00','005010X220A1','2443442','','2014-02-09','15:49:19',0,'2014-02-09 19:00:43',NULL,NULL),(16547,3023,'2326400','834','00','005010X220A1','2326400','','2014-01-24','13:16:21',0,'2014-01-24 21:01:10',NULL,NULL),(14446,2467,'0001','999','BE','005010X231A1','1169440','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:19',NULL,NULL),(15721,2711,'1738015','834','00','005010X220A1','1738015','','2014-01-20','11:19:25',0,'2014-01-21 08:46:01',NULL,NULL),(23331,4384,'3316380','834','00','005010X220A1','3316380','','2014-03-07','20:59:13',0,'2014-03-08 21:30:44',NULL,NULL),(1810,310,'1197680','834','00','005010X220A1','1197680','','2013-12-10','11:54:39',0,'2013-12-25 19:19:58',NULL,NULL),(20195,3781,'3582919','834','00','005010X220A1','3582919','','2014-02-19','09:07:14',0,'2014-02-20 04:16:56',NULL,NULL),(3557,616,'724978','834','00','005010X220A1','724978','','2013-12-12','15:40:42',0,'2013-12-25 22:03:01',NULL,NULL),(10978,1413,'1067471','834','00','005010X220A1','1067471','','2013-12-22','20:08:20',0,'2013-12-26 13:10:00',NULL,NULL),(17342,3181,'2092142','834','00','005010X220A1','2092142','','2014-01-30','21:32:02',0,'2014-01-31 21:01:11',NULL,NULL),(1929,326,'656727','834','00','005010X220A1','656727','','2013-12-09','07:54:37',0,'2013-12-25 19:32:35',NULL,NULL),(12787,1703,'2528330','834','00','005010X220A1','2528330','','2014-01-03','04:39:31',0,'2014-01-04 02:00:47',NULL,NULL),(4952,923,'495016','834','00','005010X220A1','495016','','2013-11-19','13:43:54',0,'2013-12-26 00:31:53',NULL,NULL),(6222,1168,'157839','834','00','005010X220A1','157839','','2013-12-20','14:33:47',0,'2013-12-26 03:05:00',NULL,NULL),(6089,1166,'517644','834','00','005010X220A1','517644','','2013-12-19','21:05:21',0,'2013-12-26 03:00:58',NULL,NULL),(5847,1092,'347218','834','00','005010X220A1','347218','','2013-11-23','16:03:24',0,'2013-12-26 02:16:02',NULL,NULL),(5561,1043,'1588815','834','00','005010X220A1','1588815','','2013-12-24','19:23:50',0,'2013-12-26 01:48:24',NULL,NULL),(508,102,'525798','834','00','005010X220A1','525798','','2013-12-16','11:02:12',0,'2013-12-25 18:00:43',NULL,NULL),(3540,616,'542245','834','00','005010X220A1','542245','','2013-12-12','10:56:37',0,'2013-12-25 22:02:28',NULL,NULL),(11433,1477,'1315087','834','00','005010X220A1','1315087','','2013-12-26','13:22:39',0,'2013-12-27 02:07:37',NULL,NULL),(10584,1402,'1477573','834','00','005010X220A1','1477573','','2013-12-23','12:10:19',0,'2013-12-26 12:56:40',NULL,NULL),(10712,1403,'1661286','834','00','005010X220A1','1661286','','2013-12-23','11:43:29',0,'2013-12-26 13:00:57',NULL,NULL),(12029,1583,'1366327','834','00','005010X220A1','1366327','','2013-12-30','13:59:07',0,'2014-01-01 12:03:11',NULL,NULL),(22342,4204,'3253596','834','00','005010X220A1','3253596','','2014-03-04','01:59:49',0,'2014-03-04 21:01:31',NULL,NULL),(20923,3933,'3302320','834','00','005010X220A1','3302320','','2014-02-23','17:30:25',0,'2014-02-26 08:00:19',NULL,NULL),(17349,3181,'1762508','834','00','005010X220A1','1762508','','2014-01-31','11:23:20',0,'2014-01-31 21:01:16',NULL,NULL),(359,72,'40175','834','00','005010X220A1','40175','','2013-12-04','11:00:13',0,'2013-12-25 17:47:03',NULL,NULL),(20764,3906,'3551016','834','00','005010X220A1','3551016','','2014-02-25','09:04:46',0,'2014-02-25 21:30:30',NULL,NULL),(19614,3635,'2434618','834','00','005010X220A1','2434618','','2014-02-14','13:18:53',0,'2014-02-14 21:31:47',NULL,NULL),(4068,732,'317149','834','00','005010X220A1','317149','','2013-12-19','16:57:56',0,'2013-12-25 23:02:17',NULL,NULL),(18188,3351,'2968709','834','00','005010X220A1','2968709','','2014-02-07','10:38:42',0,'2014-02-07 19:00:26',NULL,NULL),(4748,858,'677134','834','00','005010X220A1','677134','','2013-11-30','20:56:52',0,'2013-12-26 00:00:13',NULL,NULL),(2193,364,'1103633','834','00','005010X220A1','1103633','','2013-12-02','13:32:22',0,'2013-12-25 19:47:57',NULL,NULL),(5388,1011,'424349','834','00','005010X220A1','424349','','2013-11-25','16:17:16',0,'2013-12-26 01:17:07',NULL,NULL),(1743,293,'1075340','834','00','005010X220A1','1075340','','2013-12-10','14:21:25',0,'2013-12-25 19:17:46',NULL,NULL),(7377,1293,'454194','834','00','005010X220A1','454194','','2013-12-20','19:21:48',0,'2013-12-26 04:30:04',NULL,NULL),(18118,3330,'1912054','834','00','005010X220A1','1912054','','2014-02-06','12:57:46',0,'2014-02-06 21:01:30',NULL,NULL),(16521,3015,'2363183','834','00','005010X220A1','2363183','','2014-01-24','14:40:36',0,'2014-01-24 21:00:55',NULL,NULL),(20775,3907,'3613692','834','00','005010X220A1','3613692','','2014-02-25','09:43:12',0,'2014-02-25 21:30:37',NULL,NULL),(19931,3733,'2173561','834','00','005010X220A1','2173561','','2014-02-18','14:07:01',0,'2014-02-18 21:30:05',NULL,NULL),(5180,949,'894618','834','00','005010X220A1','894618','','2013-12-10','21:44:39',0,'2013-12-26 00:51:42',NULL,NULL),(5584,1043,'2057052','834','00','005010X220A1','2057052','','2013-12-24','23:27:01',0,'2013-12-26 01:49:07',NULL,NULL),(6003,1135,'1107309','834','00','005010X220A1','1107309','','2013-11-16','18:14:38',0,'2013-12-26 02:45:02',NULL,NULL),(19275,3582,'2585561','834','00','005010X220A1','2585561','','2014-02-13','08:59:59',0,'2014-02-13 22:00:54',NULL,NULL),(4719,840,'517950','834','00','005010X220A1','517950','','2013-12-23','23:27:33',0,'2013-12-25 23:51:19',NULL,NULL),(4040,731,'975938','834','00','005010X220A1','975938','','2013-12-19','16:12:12',0,'2013-12-25 23:01:21',NULL,NULL),(17537,3235,'2175953','834','00','005010X220A1','2175953','','2014-02-03','15:31:38',0,'2014-02-03 21:00:18',NULL,NULL),(1497,256,'391700','834','00','005010X220A1','391700','','2013-12-24','14:53:52',0,'2013-12-25 18:57:18',NULL,NULL),(21753,4090,'2935041','834','00','005010X220A1','2935041','','2014-02-28','11:11:32',0,'2014-02-28 21:30:48',NULL,NULL),(11243,1454,'1376421','834','00','005010X220A1','1376421','','2013-12-26','13:55:46',0,'2013-12-27 02:01:44',NULL,NULL),(19941,3737,'3078394','834','00','005010X220A1','3078394','','2014-02-18','10:14:36',0,'2014-02-18 21:30:12',NULL,NULL),(18003,3318,'2793396','834','00','005010X220A1','2793396','','2014-02-06','15:34:13',0,'2014-02-06 21:00:09',NULL,NULL),(5897,1110,'937880','834','00','005010X220A1','937880','','2013-12-15','11:58:14',0,'2013-12-26 02:30:40',NULL,NULL),(17996,3318,'2582723','834','00','005010X220A1','2582723','','2014-02-06','01:31:43',0,'2014-02-06 21:00:04',NULL,NULL),(5470,1040,'1593698','834','00','005010X220A1','1593698','','2013-12-24','21:35:26',0,'2013-12-26 01:45:27',NULL,NULL),(3523,615,'91181','834','00','005010X220A1','91181','','2013-12-12','18:27:39',0,'2013-12-25 22:01:54',NULL,NULL),(22123,4178,'2880054','834','00','005010X220A1','2880054','','2014-03-03','13:04:36',0,'2014-03-03 21:30:37',NULL,NULL),(23359,4390,'3791341','834','00','005010X220A1','3791341','','2014-03-08','13:07:23',0,'2014-03-08 21:31:05',NULL,NULL),(19434,3602,'3397390','834','00','005010X220A1','3397390','','2014-02-13','11:21:42',0,'2014-02-13 22:02:55',NULL,NULL),(17787,3268,'2585308','834','00','005010X220A1','2585308','','2014-02-04','14:39:43',0,'2014-02-04 21:01:23',NULL,NULL),(14853,2553,'1691187','834','00','005010X220A1','1691187','','2014-01-14','16:06:07',0,'2014-01-15 02:07:07',NULL,NULL),(11781,1535,'257585','834','00','005010X220A1','257585','','2013-12-28','17:34:30',1,'2013-12-29 11:10:25',NULL,NULL),(20577,3866,'2767431','834','00','005010X220A1','2767431','','2014-02-21','12:51:40',0,'2014-02-21 21:30:20',NULL,NULL),(3365,587,'218216','834','00','005010X220A1','218216','','2013-12-17','11:23:59',0,'2013-12-25 21:50:34',NULL,NULL),(3482,615,'294252','834','00','005010X220A1','294252','','2013-12-12','09:26:02',0,'2013-12-25 22:00:36',NULL,NULL),(7138,1236,'725206','834','00','005010X220A1','725206','','2013-12-18','17:59:33',0,'2013-12-26 04:04:42',NULL,NULL),(6386,1185,'1101603','834','00','005010X220A1','1101603','','2013-12-20','15:27:07',0,'2013-12-26 03:10:03',NULL,NULL),(19234,3580,'2581720','834','00','005010X220A1','2581720','','2014-02-13','12:34:50',0,'2014-02-13 22:00:22',NULL,NULL),(14454,2475,'0001','999','BE','005010X231A1','41239','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:27',NULL,NULL),(14687,2549,'2082653','834','00','005010X220A1','2082653','','2014-01-14','10:09:29',0,'2014-01-15 02:05:56',NULL,NULL),(22727,4276,'3803930','834','00','005010X220A1','3803930','','2014-03-05','19:11:14',0,'2014-03-06 21:00:11',NULL,NULL),(2494,442,'568301','834','00','005010X220A1','568301','','2013-12-06','10:20:09',0,'2013-12-25 20:20:21',NULL,NULL),(10655,1402,'833550','834','00','005010X220A1','833550','','2013-12-23','18:29:37',0,'2013-12-26 12:58:58',NULL,NULL),(2730,503,'1210875','834','00','005010X220A1','1210875','','2013-12-22','13:14:07',0,'2013-12-25 21:18:07',NULL,NULL),(3685,631,'751644','834','00','005010X220A1','751644','','2013-12-11','23:15:38',0,'2013-12-25 22:07:00',NULL,NULL),(5556,1043,'1355022','834','00','005010X220A1','1355022','','2013-12-24','18:59:35',0,'2013-12-26 01:48:14',NULL,NULL),(20877,3919,'3757316','834','00','005010X220A1','3757316','','2014-02-25','08:33:55',0,'2014-02-25 21:31:51',NULL,NULL),(4082,733,'736321','834','00','005010X220A1','736321','','2013-12-19','09:25:19',0,'2013-12-25 23:02:44',NULL,NULL),(18046,3319,'2888137','834','00','005010X220A1','2888137','','2014-02-06','08:35:59',0,'2014-02-06 21:00:39',NULL,NULL),(17755,3262,'1373412','834','00','005010X220A1','1373412','','2014-02-04','13:44:52',0,'2014-02-04 21:01:03',NULL,NULL),(17514,3233,'2420976','834','00','005010X220A1','2420976','','2014-02-03','18:04:04',0,'2014-02-03 21:00:04',NULL,NULL),(4110,733,'297341','834','00','005010X220A1','297341','','2013-12-19','12:37:01',0,'2013-12-25 23:03:31',NULL,NULL),(11943,1578,'1908224','834','00','005010X220A1','1908224','','2013-12-29','16:58:45',0,'2013-12-30 00:02:24',NULL,NULL),(11241,1454,'1496887','834','00','005010X220A1','1496887','','2013-12-26','13:35:36',0,'2013-12-27 02:01:41',NULL,NULL),(10400,1400,'120211','834','00','005010X220A1','120211','','2013-12-23','08:22:37',0,'2013-12-26 12:50:44',NULL,NULL),(5383,1011,'1190581','834','00','005010X220A1','1190581','','2013-11-24','20:19:03',0,'2013-12-26 01:16:59',NULL,NULL),(20594,3870,'3049743','834','00','005010X220A1','3049743','','2014-02-21','11:54:02',0,'2014-02-21 22:00:10',NULL,NULL),(15251,2600,'1842118','834','00','005010X220A1','1842118','','2014-01-14','22:58:05',0,'2014-01-16 08:46:57',NULL,NULL),(15455,2632,'2181939','834','00','005010X220A1','2181939','','2014-01-16','12:00:10',0,'2014-01-17 03:36:12',NULL,NULL),(23570,4436,'2973471','834','00','005010X220A1','2973471','','2014-03-10','12:51:52',0,'2014-03-10 21:00:55',NULL,NULL),(21273,4001,'2937676','834','00','005010X220A1','2937676','','2014-02-26','13:49:21',0,'2014-02-26 21:02:04',NULL,NULL),(16051,2772,'2063380','834','00','005010X220A1','2063380','','2014-01-22','14:14:30',0,'2014-01-23 03:02:36',NULL,NULL),(11946,1580,'1922785','834','00','005010X220A1','1922785','','2013-12-29','20:04:04',0,'2014-01-01 12:00:04',NULL,NULL),(15882,2740,'1949894','834','00','005010X220A1','1949894','','2014-01-20','20:27:31',1,'2014-01-22 03:22:30',NULL,NULL),(294,68,'937508','834','00','005010X220A1','937508','','2013-12-03','18:15:08',0,'2013-12-25 17:45:02',NULL,NULL),(5746,1070,'300630','834','00','005010X220A1','300630','','2013-12-14','14:56:38',0,'2013-12-26 02:01:47',NULL,NULL),(6021,1139,'740522','834','00','005010X220A1','740522','','2013-11-17','07:19:09',0,'2013-12-26 02:45:35',NULL,NULL),(7747,1344,'465712','834','00','005010X220A1','465712','','2013-10-21','00:33:15',0,'2013-12-26 05:00:44',NULL,NULL),(7226,1241,'60869','834','00','005010X220A1','60869','','2013-12-18','15:21:43',0,'2013-12-26 04:07:26',NULL,NULL),(22792,4277,'3454984','834','00','005010X220A1','3454984','','2014-03-06','16:18:30',0,'2014-03-06 21:00:59',NULL,NULL),(14179,2365,'1449992','834','00','005010X220A1','1449992','','2014-01-09','18:49:57',0,'2014-01-13 02:23:27',NULL,NULL),(13426,2222,'1620769','834','00','005010X220A1','1620769','','2014-01-06','09:28:31',0,'2014-01-07 04:01:47',NULL,NULL),(12027,1583,'1288099','834','00','005010X220A1','1288099','','2013-12-30','13:42:13',0,'2014-01-01 12:03:06',NULL,NULL),(2431,417,'512552','834','00','005010X220A1','512552','','2013-12-06','10:43:14',0,'2013-12-25 20:18:12',NULL,NULL),(4758,859,'380694','834','00','005010X220A1','380694','','2013-12-01','11:13:15',0,'2013-12-26 00:00:34',NULL,NULL),(2312,403,'765426','834','00','005010X220A1','765426','','2013-11-02','08:52:37',0,'2013-12-25 20:01:38',NULL,NULL),(17534,3235,'2769744','834','00','005010X220A1','2769744','','2014-02-03','15:00:37',0,'2014-02-03 21:00:16',NULL,NULL),(16697,3064,'2475523','834','00','005010X220A1','2475523','','2014-01-26','20:43:19',0,'2014-01-27 21:00:42',NULL,NULL),(11065,1421,'302192','834','00','005010X220A1','302192','','2013-12-23','11:25:09',0,'2013-12-26 13:12:59',NULL,NULL),(16457,3006,'2105762','834','00','005010X220A1','2105762','','2014-01-24','13:14:40',0,'2014-01-24 21:00:15',NULL,NULL),(4001,731,'708742','834','00','005010X220A1','708742','','2013-12-18','20:42:15',0,'2013-12-25 23:00:12',NULL,NULL),(16228,2920,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',0,'2014-01-23 06:39:34',NULL,NULL),(5652,1050,'1455768','834','00','005010X220A1','1455768','','2013-12-24','20:11:39',0,'2013-12-26 01:51:23',NULL,NULL),(14690,2549,'2034458','834','00','005010X220A1','2034458','','2014-01-14','11:29:52',0,'2014-01-15 02:05:57',NULL,NULL),(2738,503,'745876','834','00','005010X220A1','745876','','2013-12-22','15:27:22',0,'2013-12-25 21:18:21',NULL,NULL),(10858,1406,'1453010','834','00','005010X220A1','1453010','','2013-12-23','16:33:50',0,'2013-12-26 13:05:46',NULL,NULL),(21268,4001,'3388182','834','00','005010X220A1','3388182','','2014-02-26','09:42:44',0,'2014-02-26 21:02:01',NULL,NULL),(21266,4000,'3096855','834','00','005010X220A1','3096855','','2014-02-26','16:44:50',0,'2014-02-26 21:01:59',NULL,NULL),(15191,2592,'1914442','834','00','005010X220A1','1914442','','2014-01-14','21:28:19',0,'2014-01-16 08:46:19',NULL,NULL),(21800,4092,'3498798','834','00','005010X220A1','3498798','','2014-02-28','12:42:30',0,'2014-02-28 21:31:21',NULL,NULL),(13688,2273,'1481768','834','00','005010X220A1','1481768','','2014-01-07','12:26:39',0,'2014-01-08 18:24:24',NULL,NULL),(13218,2062,'0001','999','BE','005010X231A1','84223','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:42',NULL,NULL),(5249,963,'1159651','834','00','005010X220A1','1159651','','2013-12-11','12:04:09',0,'2013-12-26 00:53:57',NULL,NULL),(21177,3998,'3435062','834','00','005010X220A1','3435062','','2014-02-26','10:56:15',0,'2014-02-26 21:01:02',NULL,NULL),(6265,1172,'546887','834','00','005010X220A1','546887','','2013-12-20','08:36:06',0,'2013-12-26 03:06:22',NULL,NULL),(17641,3247,'1884618','834','00','005010X220A1','1884618','','2014-02-03','12:07:13',0,'2014-02-03 21:01:23',NULL,NULL),(16373,2986,'1788016','834','00','005010X220A1','1788016','','2014-01-23','16:44:14',0,'2014-01-23 21:01:05',NULL,NULL),(23432,4405,'3051261','834','00','005010X220A1','3051261','','2014-03-09','15:05:04',0,'2014-03-09 21:00:35',NULL,NULL),(23669,4444,'3410148','834','00','005010X220A1','3410148','','2014-03-10','16:51:04',0,'2014-03-10 21:02:04',NULL,NULL),(366,72,'652627','834','00','005010X220A1','652627','','2013-12-04','11:47:45',0,'2013-12-25 17:47:17',NULL,NULL),(13474,2226,'1428662','834','00','005010X220A1','1428662','','2014-01-06','10:37:29',0,'2014-01-07 04:03:39',NULL,NULL),(22343,4204,'3668389','834','00','005010X220A1','3668389','','2014-03-04','01:59:49',0,'2014-03-04 21:01:32',NULL,NULL),(19187,3569,'1819513','834','00','005010X220A1','1819513','','2014-02-13','10:41:40',0,'2014-02-13 21:30:06',NULL,NULL),(3346,587,'691926','834','00','005010X220A1','691926','','2013-12-16','21:14:03',0,'2013-12-25 21:50:03',NULL,NULL),(2664,501,'938247','834','00','005010X220A1','938247','','2013-12-22','14:52:00',0,'2013-12-25 21:16:00',NULL,NULL),(19029,3540,'2358600','834','00','005010X220A1','2358600','','2014-02-11','19:30:10',0,'2014-02-12 21:30:46',NULL,NULL),(17618,3243,'2551861','834','00','005010X220A1','2551861','','2014-02-03','13:04:05',0,'2014-02-03 21:01:10',NULL,NULL),(17610,3241,'2440493','834','00','005010X220A1','2440493','','2014-02-03','09:02:48',0,'2014-02-03 21:01:05',NULL,NULL),(16463,3006,'1452848','834','00','005010X220A1','1452848','','2014-01-24','10:35:07',0,'2014-01-24 21:00:19',NULL,NULL),(14588,2521,'2514830','834','00','005010X220A1','2514830','','2014-01-13','11:23:01',0,'2014-01-14 01:32:58',NULL,NULL),(14726,2550,'1955647','834','00','005010X220A1','1955647','','2014-01-14','13:17:32',0,'2014-01-15 02:06:13',NULL,NULL),(22602,4250,'3748826','834','00','005010X220A1','3748826','','2014-03-05','11:34:47',0,'2014-03-05 21:31:19',NULL,NULL),(22701,4262,'2759223','834','00','005010X220A1','2759223','','2014-03-05','10:53:46',0,'2014-03-05 21:32:29',NULL,NULL),(23055,4339,'2761917','834','00','005010X220A1','2761917','','2014-03-06','18:13:46',0,'2014-03-07 21:30:02',NULL,NULL),(2268,387,'387699','834','00','005010X220A1','387699','','2013-10-14','21:21:02',0,'2013-12-25 20:00:05',NULL,NULL),(4636,827,'396455','834','00','005010X220A1','396455','','2013-12-23','23:29:52',0,'2013-12-25 23:48:26',NULL,NULL),(3572,617,'1184595','834','00','005010X220A1','1184595','','2013-12-11','23:12:26',0,'2013-12-25 22:03:29',NULL,NULL),(5928,1112,'973020','834','00','005010X220A1','973020','','2013-12-15','15:03:40',0,'2013-12-26 02:31:40',NULL,NULL),(7231,1241,'372001','834','00','005010X220A1','372001','','2013-12-18','16:47:58',0,'2013-12-26 04:07:36',NULL,NULL),(21562,4053,'3403360','834','00','005010X220A1','3403360','','2014-02-26','13:55:41',0,'2014-02-28 07:00:06',NULL,NULL),(7366,1285,'1279288','834','00','005010X220A1','1279288','','2013-11-30','17:43:14',0,'2013-12-26 04:16:04',NULL,NULL),(11369,1460,'1031916','834','00','005010X220A1','1031916','','2013-12-26','10:36:52',0,'2013-12-27 02:05:36',NULL,NULL),(14143,2356,'1634332','834','00','005010X220A1','1634332','','2014-01-08','11:04:41',0,'2014-01-13 02:22:38',NULL,NULL),(14529,2518,'1519922','834','00','005010X220A1','1519922','','2014-01-13','10:22:29',0,'2014-01-14 01:32:21',NULL,NULL),(15312,2622,'1615736','834','00','005010X220A1','1615736','','2014-01-15','23:52:59',0,'2014-01-17 03:35:06',NULL,NULL),(17926,3296,'2354914','834','00','005010X220A1','2354914','','2014-02-05','12:59:43',0,'2014-02-05 21:30:43',NULL,NULL),(19017,3539,'3245551','834','00','005010X220A1','3245551','','2014-02-12','17:19:16',0,'2014-02-12 21:30:38',NULL,NULL),(21128,3994,'2850651','834','00','005010X220A1','2850651','','2014-02-26','16:54:20',0,'2014-02-26 21:00:28',NULL,NULL),(20769,3907,'3220591','834','00','005010X220A1','3220591','','2014-02-24','18:34:16',0,'2014-02-25 21:30:33',NULL,NULL),(18761,3485,'3024032','834','00','005010X220A1','3024032','','2014-02-11','17:12:13',0,'2014-02-11 21:00:47',NULL,NULL),(17909,3296,'2636088','834','00','005010X220A1','2636088','','2014-02-04','19:59:06',0,'2014-02-05 21:30:35',NULL,NULL),(10919,1410,'470542','834','00','005010X220A1','470542','','2013-12-23','09:27:04',0,'2013-12-26 13:08:16',NULL,NULL),(17613,3243,'1962147','834','00','005010X220A1','1962147','','2014-02-03','09:18:00',0,'2014-02-03 21:01:07',NULL,NULL),(7512,1300,'628368','834','00','005010X220A1','628368','','2013-12-21','10:41:02',0,'2013-12-26 04:34:24',NULL,NULL),(12981,1734,'1364129','834','00','005010X220A1','1364129','','2014-01-04','17:35:11',0,'2014-01-05 00:01:27',NULL,NULL),(13395,2221,'1483933','834','00','005010X220A1','1483933','','2014-01-06','14:49:32',0,'2014-01-07 04:00:45',NULL,NULL),(16632,3055,'1727009','834','00','005010X220A1','1727009','','2014-01-26','10:01:35',0,'2014-01-26 19:00:27',NULL,NULL),(14637,2527,'1838403','834','00','005010X220A1','1838403','','2014-01-13','14:23:14',0,'2014-01-14 01:33:29',NULL,NULL),(15475,2634,'2517476','834','00','005010X220A1','2517476','','2014-01-16','00:23:44',0,'2014-01-17 03:36:20',NULL,NULL),(19811,3679,'2833745','834','00','005010X220A1','2833745','','2014-02-14','18:40:19',0,'2014-02-15 22:01:32',NULL,NULL),(19104,3543,'2896561','834','00','005010X220A1','2896561','','2014-02-12','14:37:32',0,'2014-02-12 21:31:40',NULL,NULL),(5401,1020,'895678','834','00','005010X220A1','895678','','2013-11-14','11:24:13',0,'2013-12-26 01:30:14',NULL,NULL),(18011,3318,'2247808','834','00','005010X220A1','2247808','','2014-02-06','18:07:46',0,'2014-02-06 21:00:15',NULL,NULL),(17653,3252,'2173174','834','00','005010X220A1','2173174','','2014-02-03','14:48:54',0,'2014-02-03 21:01:33',NULL,NULL),(11127,1429,'33183','834','00','005010X220A1','33183','','2013-12-22','22:34:16',0,'2013-12-26 13:15:05',NULL,NULL),(4069,732,'572983','834','00','005010X220A1','572983','','2013-12-19','16:58:04',0,'2013-12-25 23:02:19',NULL,NULL),(14597,2521,'1445105','834','00','005010X220A1','1445105','','2014-01-13','13:45:31',0,'2014-01-14 01:33:05',NULL,NULL),(3339,586,'516455','834','00','005010X220A1','516455','','2013-12-17','16:58:50',0,'2013-12-25 21:49:48',NULL,NULL),(13111,1955,'0001','999','BE','005010X231A1','603024','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:09',NULL,NULL),(22809,4278,'3135594','834','00','005010X220A1','3135594','','2014-03-05','23:12:17',0,'2014-03-06 21:01:10',NULL,NULL),(21182,3998,'2847817','834','00','005010X220A1','2847817','','2014-02-26','12:27:10',0,'2014-02-26 21:01:05',NULL,NULL),(10452,1400,'1649696','834','00','005010X220A1','1649696','','2013-12-23','13:19:17',0,'2013-12-26 12:52:22',NULL,NULL),(21003,3960,'3097894','834','00','005010X220A1','3097894','','2014-02-22','15:06:44',0,'2014-02-26 08:30:40',NULL,NULL),(5608,1044,'846590','834','00','005010X220A1','846590','','2013-12-24','21:16:23',0,'2013-12-26 01:49:53',NULL,NULL),(11739,1520,'1570237','834','00','005010X220A1','1570237','','2013-12-28','09:35:20',1,'2013-12-29 11:09:05',NULL,NULL),(19825,3680,'3273651','834','00','005010X220A1','3273651','','2014-02-14','23:59:22',0,'2014-02-15 22:01:43',NULL,NULL),(4794,865,'724671','834','00','005010X220A1','724671','','2013-11-30','23:15:48',0,'2013-12-26 00:01:43',NULL,NULL),(19650,3648,'2189759','834','00','005010X220A1','2189759','','2014-02-14','02:03:54',0,'2014-02-14 21:32:14',NULL,NULL),(17232,3160,'2229819','834','00','005010X220A1','2229819','','2014-01-30','11:12:19',0,'2014-01-30 21:01:31',NULL,NULL),(19631,3643,'2963682','834','00','005010X220A1','2963682','','2014-02-14','01:36:02',0,'2014-02-14 21:32:01',NULL,NULL),(47,3,'254028','834','00','005010X220A1','254028','','2013-12-04','18:49:49',0,'2013-12-25 17:16:24',NULL,NULL),(12408,1637,'1911126','834','00','005010X220A1','1911126','','2013-12-31','16:49:30',1,'2014-01-02 04:29:56',NULL,NULL),(19840,3687,'3105208','834','00','005010X220A1','3105208','','2014-02-15','11:28:21',0,'2014-02-15 22:01:57',NULL,NULL),(14850,2553,'2110831','834','00','005010X220A1','2110831','','2014-01-14','13:19:18',0,'2014-01-15 02:07:06',NULL,NULL),(6300,1174,'1049782','834','00','005010X220A1','1049782','','2013-12-19','20:45:00',0,'2013-12-26 03:07:24',NULL,NULL),(1321,245,'102212','834','00','005010X220A1','102212','','2013-12-24','10:51:42',0,'2013-12-25 18:51:29',NULL,NULL),(1149,239,'1955079','834','00','005010X220A1','1955079','','2013-12-24','10:22:00',0,'2013-12-25 18:46:09',NULL,NULL),(10574,1402,'335971','834','00','005010X220A1','335971','','2013-12-23','11:10:37',0,'2013-12-26 12:56:20',NULL,NULL),(23306,4381,'3268191','834','00','005010X220A1','3268191','','2014-03-08','11:07:07',0,'2014-03-08 21:30:25',NULL,NULL),(122,7,'956407','834','00','005010X220A1','956407','','2013-12-05','14:13:49',0,'2013-12-25 17:18:45',NULL,NULL),(22849,4279,'2683891','834','00','005010X220A1','2683891','','2014-03-06','12:45:06',0,'2014-03-06 21:01:39',NULL,NULL),(18101,3327,'2274338','834','00','005010X220A1','2274338','','2014-02-05','23:34:11',0,'2014-02-06 21:01:17',NULL,NULL),(7469,1296,'622288','834','00','005010X220A1','622288','','2013-12-21','13:40:11',0,'2013-12-26 04:32:56',NULL,NULL),(17243,3167,'2637079','834','00','005010X220A1','2637079','','2014-01-30','15:22:22',0,'2014-01-30 21:01:38',NULL,NULL),(16667,3060,'1960795','834','00','005010X220A1','1960795','','2014-01-27','17:32:14',0,'2014-01-27 21:00:22',NULL,NULL),(10609,1402,'662701','834','00','005010X220A1','662701','','2013-12-23','13:34:55',0,'2013-12-26 12:57:28',NULL,NULL),(16275,2967,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','03:00:00',0,'2014-01-23 12:30:02',NULL,NULL),(15500,2636,'2284805','834','00','005010X220A1','2284805','','2014-01-16','12:03:26',0,'2014-01-17 03:36:30',NULL,NULL),(1345,245,'1602416','834','00','005010X220A1','1602416','','2013-12-24','13:07:17',0,'2013-12-25 18:52:15',NULL,NULL),(20933,3939,'2944159','834','00','005010X220A1','2944159','','2014-02-23','16:49:25',0,'2014-02-26 08:00:28',NULL,NULL),(4651,828,'929319','834','00','005010X220A1','929319','','2013-12-23','21:07:59',0,'2013-12-25 23:48:55',NULL,NULL),(5872,1105,'632109','834','00','005010X220A1','632109','','2013-10-26','18:17:32',0,'2013-12-26 02:17:00',NULL,NULL),(11079,1422,'138088','834','00','005010X220A1','138088','','2013-12-23','13:31:32',0,'2013-12-26 13:13:26',NULL,NULL),(11324,1456,'1547169','834','00','005010X220A1','1547169','','2013-12-26','13:25:14',0,'2013-12-27 02:04:14',NULL,NULL),(4697,834,'302295','834','00','005010X220A1','302295','','2013-12-23','21:48:51',0,'2013-12-25 23:50:33',NULL,NULL),(11565,1492,'769295','834','00','005010X220A1','769295','','2013-12-27','13:39:13',0,'2013-12-28 03:33:40',NULL,NULL),(4910,907,'704089','834','00','005010X220A1','704089','','2013-10-23','14:18:53',0,'2013-12-26 00:30:28',NULL,NULL),(19697,3671,'2226104','834','00','005010X220A1','2226104','','2014-02-15','10:47:05',0,'2014-02-15 22:00:05',NULL,NULL),(13226,2070,'0001','999','BE','005010X231A1','5245','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:05',NULL,NULL),(13167,2011,'0001','999','BE','005010X231A1','1144377','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:20',NULL,NULL),(19569,3627,'2770038','834','00','005010X220A1','2770038','','2014-02-13','22:25:12',0,'2014-02-14 21:31:16',NULL,NULL),(22285,4200,'3256974','834','00','005010X220A1','3256974','','2014-03-04','16:34:12',0,'2014-03-04 21:00:47',NULL,NULL),(4720,840,'359998','834','00','005010X220A1','359998','','2013-12-23','23:51:30',0,'2013-12-25 23:51:20',NULL,NULL),(21720,4088,'2620931','834','00','005010X220A1','2620931','','2014-02-28','12:39:51',0,'2014-02-28 21:30:27',NULL,NULL),(19388,3593,'3132628','834','00','005010X220A1','3132628','','2014-02-13','00:35:43',0,'2014-02-13 22:02:20',NULL,NULL),(14497,2515,'2492366','834','00','005010X220A1','2492366','','2014-01-13','09:54:43',0,'2014-01-14 01:31:59',NULL,NULL),(1688,291,'707246','834','00','005010X220A1','707246','','2013-12-10','14:53:21',0,'2013-12-25 19:16:07',NULL,NULL),(11937,1573,'2381001','834','00','005010X220A1','2381001','','2013-12-29','11:20:13',0,'2013-12-30 00:02:11',NULL,NULL),(22472,4239,'2981964','834','00','005010X220A1','2981964','','2014-03-05','07:56:45',0,'2014-03-05 21:00:18',NULL,NULL),(21196,3998,'3538555','834','00','005010X220A1','3538555','','2014-02-26','14:45:50',0,'2014-02-26 21:01:14',NULL,NULL),(4466,801,'595564','834','00','005010X220A1','595564','','2013-11-26','11:14:44',0,'2013-12-25 23:30:55',NULL,NULL),(4217,738,'361971','834','00','005010X220A1','361971','','2013-12-18','20:18:22',0,'2013-12-25 23:06:44',NULL,NULL),(19602,3632,'3264990','834','00','005010X220A1','3264990','','2014-02-14','00:29:39',0,'2014-02-14 21:31:39',NULL,NULL),(5641,1048,'1929272','834','00','005010X220A1','1929272','','2013-12-24','22:07:44',0,'2013-12-26 01:51:01',NULL,NULL),(5772,1072,'995634','834','00','005010X220A1','995634','','2013-12-14','17:17:51',0,'2013-12-26 02:02:37',NULL,NULL),(2032,331,'268284','834','00','005010X220A1','268284','','2013-12-09','16:35:17',0,'2013-12-25 19:35:52',NULL,NULL),(19424,3598,'2774028','834','00','005010X220A1','2774028','','2014-02-12','18:35:23',0,'2014-02-13 22:02:47',NULL,NULL),(10546,1402,'1142388','834','00','005010X220A1','1142388','','2013-12-22','19:03:06',0,'2013-12-26 12:55:23',NULL,NULL),(18010,3318,'1767602','834','00','005010X220A1','1767602','','2014-02-06','17:55:52',0,'2014-02-06 21:00:15',NULL,NULL),(11322,1456,'2188488','834','00','005010X220A1','2188488','','2013-12-26','13:08:15',0,'2013-12-27 02:04:09',NULL,NULL),(17036,3120,'1898133','834','00','005010X220A1','1898133','','2014-01-29','16:59:39',0,'2014-01-29 21:01:17',NULL,NULL),(16145,2837,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:32:00',1,'2014-01-23 03:57:08',NULL,NULL),(14489,2510,'0001','999','BE','005010X231A1','103765','834','2013-12-28','11:05:00',0,'2014-01-13 03:04:00',NULL,NULL),(22385,4208,'2985752','834','00','005010X220A1','2985752','','2014-03-04','17:04:28',0,'2014-03-04 21:02:07',NULL,NULL),(20800,3909,'3221608','834','00','005010X220A1','3221608','','2014-02-25','15:42:34',0,'2014-02-25 21:30:55',NULL,NULL),(11134,1431,'1500439','834','00','005010X220A1','1500439','','2013-12-22','23:36:28',0,'2013-12-26 13:15:20',NULL,NULL),(11355,1458,'1526229','834','00','005010X220A1','1526229','','2013-12-26','13:31:23',0,'2013-12-27 02:05:11',NULL,NULL),(12172,1594,'1619217','834','00','005010X220A1','1619217','','2013-12-30','18:37:12',0,'2014-01-01 12:08:12',NULL,NULL),(1252,243,'1761528','834','00','005010X220A1','1761528','','2013-12-24','12:03:51',0,'2013-12-25 18:49:14',NULL,NULL),(2530,455,'1045231','834','00','005010X220A1','1045231','','2013-11-18','12:39:00',0,'2013-12-25 20:30:54',NULL,NULL),(2862,513,'318469','834','00','005010X220A1','318469','','2013-12-22','15:00:25',0,'2013-12-25 21:22:23',NULL,NULL),(18712,3485,'2552057','834','00','005010X220A1','2552057','','2014-02-10','20:07:47',0,'2014-02-11 21:00:09',NULL,NULL),(3847,683,'134734','834','00','005010X220A1','134734','','2013-11-08','07:13:06',0,'2013-12-25 22:30:30',NULL,NULL),(4610,827,'21388','834','00','005010X220A1','21388','','2013-12-23','21:14:39',0,'2013-12-25 23:47:33',NULL,NULL),(12388,1637,'1844574','834','00','005010X220A1','1844574','','2013-12-31','09:41:13',1,'2014-01-02 04:29:14',NULL,NULL),(12918,1715,'2570604','834','00','005010X220A1','2570604','','2014-01-03','01:56:40',0,'2014-01-04 02:05:34',NULL,NULL),(14708,2550,'2110814','834','00','005010X220A1','2110814','','2014-01-14','08:58:29',0,'2014-01-15 02:06:05',NULL,NULL),(18237,3364,'2646880','834','00','005010X220A1','2646880','','2014-02-07','10:25:19',0,'2014-02-07 19:01:02',NULL,NULL),(15411,2629,'1888983','834','00','005010X220A1','1888983','','2014-01-15','18:39:02',0,'2014-01-17 03:35:53',NULL,NULL),(17075,3131,'1694367','834','00','005010X220A1','1694367','','2014-01-29','15:09:33',0,'2014-01-29 21:01:43',NULL,NULL),(1947,326,'1098314','834','00','005010X220A1','1098314','','2013-12-09','11:28:30',0,'2013-12-25 19:33:08',NULL,NULL),(5359,1008,'1192682','834','00','005010X220A1','1192682','','2013-11-25','13:15:04',0,'2013-12-26 01:16:08',NULL,NULL),(5905,1111,'460252','834','00','005010X220A1','460252','','2013-12-15','09:19:36',0,'2013-12-26 02:30:56',NULL,NULL),(17328,3176,'2409818','834','00','005010X220A1','2409818','','2014-01-31','11:40:52',0,'2014-01-31 21:01:00',NULL,NULL),(2055,336,'365814','834','00','005010X220A1','365814','','2013-12-09','13:16:13',0,'2013-12-25 19:36:34',NULL,NULL),(1022,192,'436098','834','00','005010X220A1','436098','','2013-12-03','09:09:13',0,'2013-12-25 18:20:57',NULL,NULL),(13968,2322,'1835703','834','00','005010X220A1','1835703','','2014-01-09','11:40:45',0,'2014-01-13 02:20:34',NULL,NULL),(14496,2515,'2370170','834','00','005010X220A1','2370170','','2014-01-13','00:03:38',0,'2014-01-14 01:31:59',NULL,NULL),(17207,3150,'2134749','834','00','005010X220A1','2134749','','2014-01-30','14:17:40',0,'2014-01-30 21:01:13',NULL,NULL),(22617,4251,'3156563','834','00','005010X220A1','3156563','','2014-03-05','10:33:32',0,'2014-03-05 21:31:30',NULL,NULL),(1206,242,'658931','834','00','005010X220A1','658931','','2013-12-24','04:31:45',0,'2013-12-25 18:47:58',NULL,NULL),(12001,1581,'1981629','834','00','005010X220A1','1981629','','2013-12-30','13:26:43',0,'2014-01-01 12:02:04',NULL,NULL),(3883,701,'562951','834','00','005010X220A1','562951','','2013-10-04','14:04:17',0,'2013-12-25 22:31:38',NULL,NULL),(21232,3999,'2727409','834','00','005010X220A1','2727409','','2014-02-26','10:57:49',0,'2014-02-26 21:01:37',NULL,NULL),(4976,935,'598494','834','00','005010X220A1','598494','','2013-12-10','19:11:07',0,'2013-12-26 00:45:13',NULL,NULL),(20710,3893,'3270150','834','00','005010X220A1','3270150','','2014-02-25','17:38:06',0,'2014-02-25 21:00:18',NULL,NULL),(2152,361,'1309','834','00','005010X220A1','1309','','2013-12-02','17:44:53',0,'2013-12-25 19:46:31',NULL,NULL),(20243,3791,'2916472','834','00','005010X220A1','2916472','','2014-02-19','00:10:24',0,'2014-02-20 04:30:48',NULL,NULL),(18958,3533,'2375638','834','00','005010X220A1','2375638','','2014-02-12','11:41:35',0,'2014-02-12 21:00:10',NULL,NULL),(18873,3493,'3113840','834','00','005010X220A1','3113840','','2014-02-11','17:53:35',0,'2014-02-11 21:02:11',NULL,NULL),(17316,3174,'2554795','834','00','005010X220A1','2554795','','2014-01-31','08:51:46',0,'2014-01-31 21:00:52',NULL,NULL),(22779,4277,'2661075','834','00','005010X220A1','2661075','','2014-03-06','12:51:34',0,'2014-03-06 21:00:50',NULL,NULL),(31,1,'768232','834','00','005010X220A1','768232','','2013-12-05','12:45:22',0,'2013-12-25 17:15:55',NULL,NULL),(13468,2226,'1464798','834','00','005010X220A1','1464798','','2014-01-05','23:18:21',0,'2014-01-07 04:03:26',NULL,NULL),(15026,2584,'1721277','834','00','005010X220A1','1721277','','2014-01-15','16:19:50',0,'2014-01-16 08:44:33',NULL,NULL),(12667,1673,'1355251','834','00','005010X220A1','1355251','','2014-01-02','14:01:10',0,'2014-01-03 02:03:34',NULL,NULL),(12156,1592,'1657758','834','00','005010X220A1','1657758','','2013-12-29','22:15:36',0,'2014-01-01 12:07:40',NULL,NULL),(12121,1587,'1491290','834','00','005010X220A1','1491290','','2013-12-30','15:07:57',0,'2014-01-01 12:06:25',NULL,NULL),(12112,1587,'1361628','834','00','005010X220A1','1361628','','2013-12-30','12:59:26',0,'2014-01-01 12:06:07',NULL,NULL),(11418,1470,'1948052','834','00','005010X220A1','1948052','','2013-12-26','11:07:31',0,'2013-12-27 02:07:08',NULL,NULL),(10979,1413,'1494506','834','00','005010X220A1','1494506','','2013-12-22','22:36:54',0,'2013-12-26 13:10:02',NULL,NULL),(10484,1400,'403783','834','00','005010X220A1','403783','','2013-12-23','16:22:05',0,'2013-12-26 12:53:23',NULL,NULL),(1735,293,'461162','834','00','005010X220A1','461162','','2013-12-10','12:59:08',0,'2013-12-25 19:17:33',NULL,NULL),(10403,1400,'587010','834','00','005010X220A1','587010','','2013-12-23','08:49:16',0,'2013-12-26 12:50:48',NULL,NULL),(2784,506,'67826','834','00','005010X220A1','67826','','2013-12-22','07:29:57',0,'2013-12-25 21:19:48',NULL,NULL),(448,81,'583946','834','00','005010X220A1','583946','','2013-12-04','16:47:55',0,'2013-12-25 17:49:53',NULL,NULL),(3219,578,'97625','834','00','005010X220A1','97625','','2013-12-17','09:47:58',0,'2013-12-25 21:45:53',NULL,NULL),(5172,947,'201112','834','00','005010X220A1','201112','','2013-12-11','15:23:57',0,'2013-12-26 00:51:27',NULL,NULL),(1434,252,'143088','834','00','005010X220A1','143088','','2013-12-24','10:06:20',0,'2013-12-25 18:55:10',NULL,NULL),(21918,4127,'2961510','834','00','005010X220A1','2961510','','2014-03-01','15:06:12',0,'2014-03-01 21:00:41',NULL,NULL),(16622,3050,'1408847','834','00','005010X220A1','1408847','','2014-01-26','13:49:17',0,'2014-01-26 19:00:18',NULL,NULL),(16402,2993,'1429123','834','00','005010X220A1','1429123','','2014-01-23','15:54:16',0,'2014-01-23 21:01:23',NULL,NULL),(15011,2584,'1732274','834','00','005010X220A1','1732274','','2014-01-15','12:07:22',0,'2014-01-16 08:44:25',NULL,NULL),(10981,1413,'152418','834','00','005010X220A1','152418','','2013-12-23','08:24:35',0,'2013-12-26 13:10:07',NULL,NULL),(10725,1403,'121749','834','00','005010X220A1','121749','','2013-12-23','14:21:15',0,'2013-12-26 13:01:27',NULL,NULL),(14342,2401,'1691117','834','00','005010X220A1','1691117','','2014-01-11','21:59:15',0,'2014-01-13 03:01:20',NULL,NULL),(22851,4279,'3125711','834','00','005010X220A1','3125711','','2014-03-06','17:51:31',0,'2014-03-06 21:01:40',NULL,NULL),(1867,324,'1304828','834','00','005010X220A1','1304828','','2013-12-09','14:32:40',0,'2013-12-25 19:30:45',NULL,NULL),(13700,2274,'2273656','834','00','005010X220A1','2273656','','2014-01-07','11:52:53',0,'2014-01-08 18:24:29',NULL,NULL),(13489,2226,'1665301','834','00','005010X220A1','1665301','','2014-01-06','17:08:07',0,'2014-01-07 04:04:11',NULL,NULL),(10951,1410,'257374','834','00','005010X220A1','257374','','2013-12-23','17:33:00',0,'2013-12-26 13:09:14',NULL,NULL),(10808,1404,'1073612','834','00','005010X220A1','1073612','','2013-12-23','15:10:53',0,'2013-12-26 13:04:08',NULL,NULL),(21309,4008,'3000734','834','00','005010X220A1','3000734','','2014-02-26','17:15:26',0,'2014-02-26 21:02:32',NULL,NULL),(2709,502,'102032','834','00','005010X220A1','102032','','2013-12-22','17:21:51',0,'2013-12-25 21:17:28',NULL,NULL),(21032,3975,'3290437','834','00','005010X220A1','3290437','','2014-02-23','19:55:11',0,'2014-02-26 09:30:11',NULL,NULL),(4162,734,'662419','834','00','005010X220A1','662419','','2013-12-19','08:37:20',0,'2013-12-25 23:05:03',NULL,NULL),(14321,2398,'1923096','834','00','005010X220A1','1923096','','2014-01-10','17:25:56',0,'2014-01-13 03:00:44',NULL,NULL),(4760,859,'1233526','834','00','005010X220A1','1233526','','2013-12-01','14:36:15',0,'2013-12-26 00:00:37',NULL,NULL),(5565,1043,'1409485','834','00','005010X220A1','1409485','','2013-12-24','19:49:21',0,'2013-12-26 01:48:31',NULL,NULL),(2633,496,'503707','834','00','005010X220A1','503707','','2013-11-28','09:11:23',0,'2013-12-25 20:47:03',NULL,NULL),(1934,326,'1184499','834','00','005010X220A1','1184499','','2013-12-09','09:31:34',0,'2013-12-25 19:32:45',NULL,NULL),(21737,4090,'3400671','834','00','005010X220A1','3400671','','2014-02-27','18:29:08',0,'2014-02-28 21:30:38',NULL,NULL),(23473,4420,'3449082','834','00','005010X220A1','3449082','','2014-03-09','13:10:40',0,'2014-03-09 21:01:12',NULL,NULL),(20381,3824,'3594109','834','00','005010X220A1','3594109','','2014-02-19','12:53:06',0,'2014-02-20 05:37:06',NULL,NULL),(15299,2620,'2436405','834','00','005010X220A1','2436405','','2014-01-15','17:34:02',0,'2014-01-16 08:47:29',NULL,NULL),(14323,2399,'2422739','834','00','005010X220A1','2422739','','2014-01-12','10:32:30',0,'2014-01-13 03:01:05',NULL,NULL),(4962,930,'285423','834','00','005010X220A1','285423','','2013-10-06','20:55:17',0,'2013-12-26 00:32:14',NULL,NULL),(5603,1044,'1694924','834','00','005010X220A1','1694924','','2013-12-24','19:21:24',0,'2013-12-26 01:49:44',NULL,NULL),(21769,4090,'3400713','834','00','005010X220A1','3400713','','2014-02-28','16:54:59',0,'2014-02-28 21:30:59',NULL,NULL),(23216,4349,'3750277','834','00','005010X220A1','3750277','','2014-03-06','20:53:35',0,'2014-03-07 21:31:57',NULL,NULL),(956,181,'744027','834','00','005010X220A1','744027','','2013-12-03','14:25:01',0,'2013-12-25 18:18:50',NULL,NULL),(3025,544,'625425','834','00','005010X220A1','625425','','2013-12-13','17:47:19',0,'2013-12-25 21:33:52',NULL,NULL),(2309,403,'724467','834','00','005010X220A1','724467','','2013-11-01','19:53:49',0,'2013-12-25 20:01:33',NULL,NULL),(4637,827,'1156869','834','00','005010X220A1','1156869','','2013-12-23','23:29:52',0,'2013-12-25 23:48:28',NULL,NULL),(5709,1069,'752811','834','00','005010X220A1','752811','','2013-12-13','20:08:46',0,'2013-12-26 02:00:44',NULL,NULL),(7533,1300,'521510','834','00','005010X220A1','521510','','2013-12-21','15:10:56',0,'2013-12-26 04:35:06',NULL,NULL),(15054,2585,'1813777','834','00','005010X220A1','1813777','','2014-01-14','21:30:08',0,'2014-01-16 08:44:52',NULL,NULL),(14090,2341,'1431443','834','00','005010X220A1','1431443','','2014-01-08','15:00:26',0,'2014-01-13 02:22:04',NULL,NULL),(22952,4307,'3640780','834','00','005010X220A1','3640780','','2014-03-06','14:24:55',0,'2014-03-06 21:02:56',NULL,NULL),(23403,4404,'2805110','834','00','005010X220A1','2805110','','2014-03-08','19:54:33',0,'2014-03-09 21:00:14',NULL,NULL),(23560,4436,'2904032','834','00','005010X220A1','2904032','','2014-03-09','22:55:01',0,'2014-03-10 21:00:48',NULL,NULL),(19533,3622,'3289054','834','00','005010X220A1','3289054','','2014-02-14','16:51:39',0,'2014-02-14 21:30:49',NULL,NULL),(17049,3122,'2307048','834','00','005010X220A1','2307048','','2014-01-29','17:46:03',0,'2014-01-29 21:01:25',NULL,NULL),(12179,1597,'1443692','834','00','005010X220A1','1443692','','2013-12-30','06:33:18',0,'2014-01-01 12:08:28',NULL,NULL),(11049,1418,'1154342','834','00','005010X220A1','1154342','','2013-12-23','16:11:05',0,'2013-12-26 13:12:24',NULL,NULL),(15815,2731,'1650542','834','00','005010X220A1','1650542','','2014-01-20','13:35:01',0,'2014-01-21 08:46:57',NULL,NULL),(2652,501,'1199689','834','00','005010X220A1','1199689','','2013-12-22','05:11:03',0,'2013-12-25 21:15:27',NULL,NULL),(3161,562,'40451','834','00','005010X220A1','40451','','2013-12-13','10:43:25',0,'2013-12-25 21:38:09',NULL,NULL),(3400,589,'661247','834','00','005010X220A1','661247','','2013-12-17','08:08:47',0,'2013-12-25 21:51:41',NULL,NULL),(4447,801,'962770','834','00','005010X220A1','962770','','2013-11-25','20:12:32',0,'2013-12-25 23:30:20',NULL,NULL),(15390,2625,'1830425','834','00','005010X220A1','1830425','','2014-01-15','18:34:53',0,'2014-01-17 03:35:42',NULL,NULL),(14610,2522,'2151882','834','00','005010X220A1','2151882','','2014-01-13','09:08:48',0,'2014-01-14 01:33:12',NULL,NULL),(1472,252,'1962515','834','00','005010X220A1','1962515','','2013-12-24','16:43:54',0,'2013-12-25 18:56:31',NULL,NULL),(1726,293,'324399','834','00','005010X220A1','324399','','2013-12-10','09:12:33',0,'2013-12-25 19:17:16',NULL,NULL),(6255,1172,'255945','834','00','005010X220A1','255945','','2013-12-19','21:24:08',0,'2013-12-26 03:06:04',NULL,NULL),(299,70,'71323','834','00','005010X220A1','71323','','2013-12-03','20:43:30',0,'2013-12-25 17:45:12',NULL,NULL),(11794,1537,'1864159','834','00','005010X220A1','1864159','','2013-12-28','20:21:11',1,'2013-12-29 11:12:55',NULL,NULL),(21098,3989,'2656856','834','00','005010X220A1','2656856','','2014-02-24','15:40:01',0,'2014-02-26 09:31:04',NULL,NULL),(20719,3897,'3102936','834','00','005010X220A1','3102936','','2014-02-25','11:13:38',0,'2014-02-25 21:00:25',NULL,NULL),(1681,291,'263259','834','00','005010X220A1','263259','','2013-12-09','18:27:13',0,'2013-12-25 19:15:53',NULL,NULL),(3649,625,'946624','834','00','005010X220A1','946624','','2013-12-11','20:55:24',0,'2013-12-25 22:05:53',NULL,NULL),(17339,3179,'1900597','834','00','005010X220A1','1900597','','2014-01-30','21:05:00',0,'2014-01-31 21:01:09',NULL,NULL),(4458,801,'465920','834','00','005010X220A1','465920','','2013-11-26','14:04:08',0,'2013-12-25 23:30:41',NULL,NULL),(15895,2741,'1964512','834','00','005010X220A1','1964512','','2014-01-20','19:41:34',1,'2014-01-22 03:22:37',NULL,NULL),(7013,1235,'787992','834','00','005010X220A1','787992','','2013-12-18','07:18:55',0,'2013-12-26 04:00:54',NULL,NULL),(389,76,'660852','834','00','005010X220A1','660852','','2013-12-03','20:31:41',0,'2013-12-25 17:48:01',NULL,NULL),(23103,4340,'2729176','834','00','005010X220A1','2729176','','2014-03-07','15:27:58',0,'2014-03-07 21:30:37',NULL,NULL),(271,55,'26779','834','00','005010X220A1','26779','','2013-10-11','10:01:24',0,'2013-12-25 17:31:37',NULL,NULL),(13586,2256,'1907134','834','00','005010X220A1','1907134','','2014-01-05','14:06:57',1,'2014-01-07 10:22:16',NULL,NULL),(19073,3542,'3048088','834','00','005010X220A1','3048088','','2014-02-12','17:18:56',0,'2014-02-12 21:31:19',NULL,NULL),(13228,2072,'0001','999','BE','005010X231A1','1039031','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:10',NULL,NULL),(18493,3436,'2304350','834','00','005010X220A1','2304350','','2014-02-10','04:16:16',0,'2014-02-10 11:01:09',NULL,NULL),(12015,1583,'2193652','834','00','005010X220A1','2193652','','2013-12-30','11:30:46',0,'2014-01-01 12:02:38',NULL,NULL),(16988,3118,'2351157','834','00','005010X220A1','2351157','','2014-01-28','21:50:39',0,'2014-01-29 21:00:46',NULL,NULL),(4181,734,'1290369','834','00','005010X220A1','1290369','','2013-12-19','14:06:30',0,'2013-12-25 23:05:37',NULL,NULL),(22778,4277,'2992144','834','00','005010X220A1','2992144','','2014-03-06','12:14:00',0,'2014-03-06 21:00:49',NULL,NULL),(22848,4279,'3072827','834','00','005010X220A1','3072827','','2014-03-06','12:25:41',0,'2014-03-06 21:01:38',NULL,NULL),(21897,4126,'3654496','834','00','005010X220A1','3654496','','2014-03-01','00:42:45',0,'2014-03-01 21:00:29',NULL,NULL),(20768,3907,'2921589','834','00','005010X220A1','2921589','','2014-02-24','18:33:28',0,'2014-02-25 21:30:32',NULL,NULL),(12693,1674,'2053208','834','00','005010X220A1','2053208','','2014-01-01','19:09:35',0,'2014-01-03 02:04:30',NULL,NULL),(16368,2986,'2108525','834','00','005010X220A1','2108525','','2014-01-23','10:47:31',0,'2014-01-23 21:01:00',NULL,NULL),(22661,4254,'3022629','834','00','005010X220A1','3022629','','2014-03-05','10:38:25',0,'2014-03-05 21:32:00',NULL,NULL),(505,102,'235454','834','00','005010X220A1','235454','','2013-12-16','10:27:50',0,'2013-12-25 18:00:37',NULL,NULL),(3454,608,'399811','834','00','005010X220A1','399811','','2013-12-17','13:03:09',0,'2013-12-25 21:53:28',NULL,NULL),(12419,1638,'2224967','834','00','005010X220A1','2224967','','2013-12-30','20:28:59',1,'2014-01-02 04:30:21',NULL,NULL),(5349,1003,'312682','834','00','005010X220A1','312682','','2013-11-25','15:46:11',0,'2013-12-26 01:15:49',NULL,NULL),(11370,1460,'1801932','834','00','005010X220A1','1801932','','2013-12-26','10:41:07',0,'2013-12-27 02:05:38',NULL,NULL),(23457,4411,'3534239','834','00','005010X220A1','3534239','','2014-03-09','10:16:26',0,'2014-03-09 21:00:58',NULL,NULL),(21801,4092,'3415954','834','00','005010X220A1','3415954','','2014-02-28','13:13:21',0,'2014-02-28 21:31:21',NULL,NULL),(13276,2120,'0001','999','BE','005010X231A1','1260060','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:05',NULL,NULL),(11755,1523,'2074961','834','00','005010X220A1','2074961','','2013-12-28','14:16:51',1,'2013-12-29 11:09:35',NULL,NULL),(11662,1500,'2268893','834','00','005010X220A1','2268893','','2013-12-27','15:46:51',0,'2013-12-28 03:36:39',NULL,NULL),(11460,1488,'2235274','834','00','005010X220A1','2235274','','2013-12-27','10:12:55',0,'2013-12-28 03:30:29',NULL,NULL),(21381,4024,'3356401','834','00','005010X220A1','3356401','','2014-02-27','13:42:32',0,'2014-02-28 06:30:27',NULL,NULL),(4630,827,'1386563','834','00','005010X220A1','1386563','','2013-12-23','23:15:47',0,'2013-12-25 23:48:15',NULL,NULL),(3293,584,'856795','834','00','005010X220A1','856795','','2013-12-16','22:51:45',0,'2013-12-25 21:48:13',NULL,NULL),(1706,292,'497786','834','00','005010X220A1','497786','','2013-12-10','11:35:05',0,'2013-12-25 19:16:40',NULL,NULL),(6183,1167,'812438','834','00','005010X220A1','812438','','2013-12-20','16:54:14',0,'2013-12-26 03:03:48',NULL,NULL),(20894,3924,'2708883','834','00','005010X220A1','2708883','','2014-02-25','15:53:18',0,'2014-02-25 21:32:04',NULL,NULL),(7302,1262,'645257','834','00','005010X220A1','645257','','2013-12-18','12:27:18',0,'2013-12-26 04:09:46',NULL,NULL),(20821,3910,'3077463','834','00','005010X220A1','3077463','','2014-02-25','15:24:31',0,'2014-02-25 21:31:09',NULL,NULL),(18116,3330,'2263961','834','00','005010X220A1','2263961','','2014-02-06','10:55:50',0,'2014-02-06 21:01:28',NULL,NULL),(14769,2551,'1437801','834','00','005010X220A1','1437801','','2014-01-14','11:39:10',0,'2014-01-15 02:06:32',NULL,NULL),(13717,2275,'2197421','834','00','005010X220A1','2197421','','2014-01-07','14:07:46',0,'2014-01-08 18:24:36',NULL,NULL),(222,32,'54621','834','00','005010X220A1','54621','','2013-12-05','12:56:34',0,'2013-12-25 17:22:02',NULL,NULL),(12780,1703,'2361395','834','00','005010X220A1','2361395','','2014-01-02','18:45:02',0,'2014-01-04 02:00:31',NULL,NULL),(12326,1634,'2179020','834','00','005010X220A1','2179020','','2013-12-30','23:23:25',1,'2014-01-02 04:27:02',NULL,NULL),(5292,980,'404097','834','00','005010X220A1','404097','','2013-11-16','09:07:37',0,'2013-12-26 01:01:08',NULL,NULL),(17980,3306,'2678043','834','00','005010X220A1','2678043','','2014-02-05','12:11:27',0,'2014-02-05 21:31:11',NULL,NULL),(21096,3988,'3569272','834','00','005010X220A1','3569272','','2014-02-24','14:17:04',0,'2014-02-26 09:31:02',NULL,NULL),(20560,3863,'3517624','834','00','005010X220A1','3517624','','2014-02-21','16:19:20',0,'2014-02-21 21:30:10',NULL,NULL),(20477,3843,'2994278','834','00','005010X220A1','2994278','','2014-02-19','19:11:22',0,'2014-02-20 22:00:45',NULL,NULL),(16279,2971,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','03:08:00',0,'2014-01-23 14:30:02',NULL,NULL),(15742,2712,'2099554','834','00','005010X220A1','2099554','','2014-01-20','16:01:22',0,'2014-01-21 08:46:13',NULL,NULL),(15084,2585,'2441514','834','00','005010X220A1','2441514','','2014-01-15','13:34:51',0,'2014-01-16 08:45:10',NULL,NULL),(892,177,'1192756','834','00','005010X220A1','1192756','','2013-12-03','13:21:10',0,'2013-12-25 18:16:54',NULL,NULL),(961,181,'253995','834','00','005010X220A1','253995','','2013-12-03','16:55:06',0,'2013-12-25 18:18:58',NULL,NULL),(22373,4206,'2717913','834','00','005010X220A1','2717913','','2014-03-04','11:49:28',0,'2014-03-04 21:01:58',NULL,NULL),(10505,1400,'1491038','834','00','005010X220A1','1491038','','2013-12-23','18:34:53',0,'2013-12-26 12:54:01',NULL,NULL),(2391,414,'987690','834','00','005010X220A1','987690','','2013-12-06','15:41:52',0,'2013-12-25 20:16:54',NULL,NULL),(5853,1096,'336440','834','00','005010X220A1','336440','','2013-11-22','23:55:27',0,'2013-12-26 02:16:14',NULL,NULL),(22768,4277,'3789774','834','00','005010X220A1','3789774','','2014-03-05','18:26:48',0,'2014-03-06 21:00:42',NULL,NULL),(1907,325,'249993','834','00','005010X220A1','249993','','2013-12-09','13:47:09',0,'2013-12-25 19:31:58',NULL,NULL),(21535,4039,'3215874','834','00','005010X220A1','3215874','','2014-02-27','11:08:55',0,'2014-02-28 06:31:37',NULL,NULL),(21247,3999,'3311469','834','00','005010X220A1','3311469','','2014-02-26','13:32:55',0,'2014-02-26 21:01:47',NULL,NULL),(19158,3555,'3320405','834','00','005010X220A1','3320405','','2014-02-12','15:27:48',0,'2014-02-12 21:32:16',NULL,NULL),(6299,1174,'1144805','834','00','005010X220A1','1144805','','2013-12-19','20:41:48',0,'2013-12-26 03:07:23',NULL,NULL),(4751,858,'76634','834','00','005010X220A1','76634','','2013-12-01','06:35:20',0,'2013-12-26 00:00:19',NULL,NULL),(22930,4293,'3408705','834','00','005010X220A1','3408705','','2014-03-06','15:18:51',0,'2014-03-06 21:02:38',NULL,NULL),(23680,4446,'3101000','834','00','005010X220A1','3101000','','2014-03-09','22:06:51',0,'2014-03-10 21:02:13',NULL,NULL),(10398,1400,'970969','834','00','005010X220A1','970969','','2013-12-23','07:01:19',0,'2013-12-26 12:50:40',NULL,NULL),(17190,3149,'2020687','834','00','005010X220A1','2020687','','2014-01-29','22:52:17',0,'2014-01-30 21:01:03',NULL,NULL),(458,84,'587392','834','00','005010X220A1','587392','','2013-12-04','06:19:10',0,'2013-12-25 17:50:13',NULL,NULL),(11821,1539,'988490','834','00','005010X220A1','988490','','2013-12-28','20:30:42',1,'2013-12-29 11:13:46',NULL,NULL),(21384,4024,'2885026','834','00','005010X220A1','2885026','','2014-02-27','14:22:12',0,'2014-02-28 06:30:28',NULL,NULL),(3590,617,'556164','834','00','005010X220A1','556164','','2013-12-12','15:54:54',0,'2013-12-25 22:04:02',NULL,NULL),(3535,616,'469998','834','00','005010X220A1','469998','','2013-12-12','09:54:26',0,'2013-12-25 22:02:19',NULL,NULL),(19056,3542,'3097608','834','00','005010X220A1','3097608','','2014-02-12','11:31:46',0,'2014-02-12 21:31:05',NULL,NULL),(14785,2551,'2048632','834','00','005010X220A1','2048632','','2014-01-14','15:16:13',0,'2014-01-15 02:06:39',NULL,NULL),(14388,2414,'2526320','834','00','005010X220A1','2526320','','2014-01-12','13:56:15',0,'2014-01-13 03:01:53',NULL,NULL),(7417,1295,'1102837','834','00','005010X220A1','1102837','','2013-12-21','07:05:52',0,'2013-12-26 04:31:24',NULL,NULL),(7148,1237,'1011603','834','00','005010X220A1','1011603','','2013-12-18','13:48:03',0,'2013-12-26 04:05:02',NULL,NULL),(21327,4020,'3654405','834','00','005010X220A1','3654405','','2014-02-26','17:38:32',0,'2014-02-26 21:02:46',NULL,NULL),(21070,3980,'2984078','834','00','005010X220A1','2984078','','2014-02-24','15:06:33',0,'2014-02-26 09:30:42',NULL,NULL),(1030,195,'1158290','834','00','005010X220A1','1158290','','2013-12-03','10:27:01',0,'2013-12-25 18:21:11',NULL,NULL),(1094,223,'394162','834','00','005010X220A1','394162','','2013-11-04','15:56:00',0,'2013-12-25 18:31:47',NULL,NULL),(5416,1025,'33426','834','00','005010X220A1','33426','','2013-11-14','09:09:48',0,'2013-12-26 01:30:50',NULL,NULL),(18621,3459,'2576774','834','00','005010X220A1','2576774','','2014-02-09','19:35:12',0,'2014-02-10 21:31:18',NULL,NULL),(4370,770,'368689','834','00','005010X220A1','368689','','2013-12-19','17:50:38',0,'2013-12-25 23:11:25',NULL,NULL),(3956,715,'819515','834','00','005010X220A1','819515','','2013-12-07','14:57:29',0,'2013-12-25 22:46:45',NULL,NULL),(18122,3331,'2457138','834','00','005010X220A1','2457138','','2014-02-06','13:49:06',0,'2014-02-06 21:01:32',NULL,NULL),(22655,4254,'3254740','834','00','005010X220A1','3254740','','2014-03-05','09:41:51',0,'2014-03-05 21:31:57',NULL,NULL),(17222,3155,'2402127','834','00','005010X220A1','2402127','','2014-01-30','08:20:04',0,'2014-01-30 21:01:24',NULL,NULL),(3015,543,'1199299','834','00','005010X220A1','1199299','','2013-12-13','14:09:03',0,'2013-12-25 21:33:35',NULL,NULL),(2436,419,'768253','834','00','005010X220A1','768253','','2013-12-05','21:15:09',0,'2013-12-25 20:18:21',NULL,NULL),(11674,1508,'1634048','834','00','005010X220A1','1634048','','2013-12-27','12:10:23',0,'2013-12-28 03:37:04',NULL,NULL),(15689,2697,'1847386','834','00','005010X220A1','1847386','','2014-01-18','21:49:05',0,'2014-01-21 08:45:19',NULL,NULL),(15236,2598,'2269358','834','00','005010X220A1','2269358','','2014-01-15','00:42:29',0,'2014-01-16 08:46:48',NULL,NULL),(14963,2567,'1501152','834','00','005010X220A1','1501152','','2014-01-14','12:25:35',0,'2014-01-15 02:07:58',NULL,NULL),(14982,2576,'1605729','834','00','005010X220A1','1605729','','2014-01-14','14:21:23',0,'2014-01-15 02:08:08',NULL,NULL),(1343,245,'454492','834','00','005010X220A1','454492','','2013-12-24','13:01:20',0,'2013-12-25 18:52:09',NULL,NULL),(20239,3792,'2851497','834','00','005010X220A1','2851497','','2014-02-18','22:51:13',0,'2014-02-20 04:29:45',NULL,NULL),(5212,950,'62065','834','00','005010X220A1','62065','','2013-12-11','12:27:05',0,'2013-12-26 00:52:44',NULL,NULL),(3941,714,'182019','834','00','005010X220A1','182019','','2013-12-06','23:48:46',0,'2013-12-25 22:46:15',NULL,NULL),(1503,258,'294940','834','00','005010X220A1','294940','','2013-12-24','10:58:11',0,'2013-12-25 18:57:27',NULL,NULL),(14156,2362,'1630882','834','00','005010X220A1','1630882','','2014-01-08','16:01:26',0,'2014-01-13 02:22:48',NULL,NULL),(14201,2365,'1562956','834','00','005010X220A1','1562956','','2014-01-10','14:30:42',0,'2014-01-13 02:23:44',NULL,NULL),(17817,3273,'1887083','834','00','005010X220A1','1887083','','2014-02-04','16:00:55',0,'2014-02-04 21:01:44',NULL,NULL),(12763,1697,'2343655','834','00','005010X220A1','2343655','','2014-01-02','09:31:14',0,'2014-01-03 02:07:13',NULL,NULL),(14136,2352,'1845858','834','00','005010X220A1','1845858','','2014-01-08','15:50:26',0,'2014-01-13 02:22:33',NULL,NULL),(20306,3794,'3124175','834','00','005010X220A1','3124175','','2014-02-19','13:17:30',0,'2014-02-20 04:44:54',NULL,NULL),(14043,2337,'1928143','834','00','005010X220A1','1928143','','2014-01-08','17:06:14',0,'2014-01-13 02:21:32',NULL,NULL),(1693,291,'1241884','834','00','005010X220A1','1241884','','2013-12-10','17:47:55',0,'2013-12-25 19:16:17',NULL,NULL),(11232,1454,'2019824','834','00','005010X220A1','2019824','','2013-12-26','11:27:22',0,'2013-12-27 02:01:26',NULL,NULL),(5719,1069,'1217014','834','00','005010X220A1','1217014','','2013-12-14','11:51:10',0,'2013-12-26 02:01:01',NULL,NULL),(23721,4460,'2815078','834','00','005010X220A1','2815078','','2014-03-10','11:42:31',0,'2014-03-10 21:02:45',NULL,NULL),(22368,4205,'3394476','834','00','005010X220A1','3394476','','2014-03-04','15:41:27',0,'2014-03-04 21:01:53',NULL,NULL),(13128,1972,'0001','999','BE','005010X231A1','128101','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:56',NULL,NULL),(11905,1563,'1417317','834','00','005010X220A1','1417317','','2013-12-29','06:01:23',0,'2013-12-30 00:01:11',NULL,NULL),(19149,3551,'2803061','834','00','005010X220A1','2803061','','2014-02-12','11:08:14',0,'2014-02-12 21:32:08',NULL,NULL),(3415,592,'109963','834','00','005010X220A1','109963','','2013-12-17','11:03:49',0,'2013-12-25 21:52:11',NULL,NULL),(10457,1400,'1117388','834','00','005010X220A1','1117388','','2013-12-23','13:33:39',0,'2013-12-26 12:52:32',NULL,NULL),(2476,430,'761143','834','00','005010X220A1','761143','','2013-12-06','14:43:05',0,'2013-12-25 20:19:43',NULL,NULL),(14093,2341,'1470984','834','00','005010X220A1','1470984','','2014-01-08','16:15:52',0,'2014-01-13 02:22:06',NULL,NULL),(14114,2347,'1312520','834','00','005010X220A1','1312520','','2014-01-07','21:49:46',0,'2014-01-13 02:22:20',NULL,NULL),(15806,2726,'2353501','834','00','005010X220A1','2353501','','2014-01-20','12:24:21',0,'2014-01-21 08:46:51',NULL,NULL),(18672,3467,'3078157','834','00','005010X220A1','3078157','','2014-02-10','14:07:23',0,'2014-02-10 21:31:54',NULL,NULL),(23085,4339,'3090944','834','00','005010X220A1','3090944','','2014-03-07','13:34:40',0,'2014-03-07 21:30:25',NULL,NULL),(23602,4440,'3631216','834','00','005010X220A1','3631216','','2014-03-09','19:44:20',0,'2014-03-10 21:01:18',NULL,NULL),(22900,4284,'2794240','834','00','005010X220A1','2794240','','2014-03-06','16:17:19',0,'2014-03-06 21:02:16',NULL,NULL),(21472,4028,'3114336','834','00','005010X220A1','3114336','','2014-02-27','14:29:37',0,'2014-02-28 06:31:09',NULL,NULL),(19683,3665,'3015444','834','00','005010X220A1','3015444','','2014-02-15','06:59:22',0,'2014-02-15 21:00:06',NULL,NULL),(2434,418,'1150827','834','00','005010X220A1','1150827','','2013-12-06','17:12:55',0,'2013-12-25 20:18:18',NULL,NULL),(19210,3578,'2523236','834','00','005010X220A1','2523236','','2014-02-13','13:05:53',0,'2014-02-13 21:30:16',NULL,NULL),(1611,281,'695594','834','00','005010X220A1','695594','','2013-11-19','23:01:10',0,'2013-12-25 19:01:29',NULL,NULL),(15065,2585,'2337018','834','00','005010X220A1','2337018','','2014-01-15','10:54:44',0,'2014-01-16 08:44:59',NULL,NULL),(16890,3097,'2610392','834','00','005010X220A1','2610392','','2014-01-28','16:44:39',0,'2014-01-28 21:01:06',NULL,NULL),(18975,3537,'3015313','834','00','005010X220A1','3015313','','2014-02-11','23:57:24',0,'2014-02-12 21:30:10',NULL,NULL),(23049,4336,'3490227','834','00','005010X220A1','3490227','','2014-03-07','17:35:56',0,'2014-03-07 21:00:35',NULL,NULL),(23296,4381,'3585892','834','00','005010X220A1','3585892','','2014-03-07','21:43:34',0,'2014-03-08 21:30:17',NULL,NULL),(209,25,'1303657','834','00','005010X220A1','1303657','','2013-12-05','11:50:43',0,'2013-12-25 17:21:35',NULL,NULL),(16924,3114,'2310660','834','00','005010X220A1','2310660','','2014-01-29','11:27:28',0,'2014-01-29 21:00:06',NULL,NULL),(11443,1485,'1886116','834','00','005010X220A1','1886116','','2013-12-26','16:41:51',0,'2013-12-27 02:07:59',NULL,NULL),(10714,1403,'331813','834','00','005010X220A1','331813','','2013-12-23','12:21:21',0,'2013-12-26 13:01:01',NULL,NULL),(1554,268,'1946977','834','00','005010X220A1','1946977','','2013-12-24','15:33:34',0,'2013-12-25 18:59:06',NULL,NULL),(16674,3061,'2414358','834','00','005010X220A1','2414358','','2014-01-27','15:10:22',0,'2014-01-27 21:00:26',NULL,NULL),(15477,2634,'1539723','834','00','005010X220A1','1539723','','2014-01-16','01:23:32',0,'2014-01-17 03:36:21',NULL,NULL),(12248,1619,'1942062','834','00','005010X220A1','1942062','','2014-01-01','14:09:39',1,'2014-01-02 04:23:20',NULL,NULL),(13082,1926,'0001','999','BE','005010X231A1','371501','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:48',NULL,NULL),(13668,2271,'2411399','834','00','005010X220A1','2411399','','2014-01-07','11:43:28',0,'2014-01-08 18:24:16',NULL,NULL),(18857,3491,'3153374','834','00','005010X220A1','3153374','','2014-02-11','16:44:25',0,'2014-02-11 21:01:59',NULL,NULL),(18770,3486,'1934409','834','00','005010X220A1','1934409','','2014-02-10','20:33:02',0,'2014-02-11 21:00:53',NULL,NULL),(11242,1454,'1906922','834','00','005010X220A1','1906922','','2013-12-26','13:45:57',0,'2013-12-27 02:01:42',NULL,NULL),(17216,3152,'1678353','834','00','005010X220A1','1678353','','2014-01-30','10:41:29',0,'2014-01-30 21:01:19',NULL,NULL),(15112,2587,'2315314','834','00','005010X220A1','2315314','','2014-01-15','10:53:11',0,'2014-01-16 08:45:28',NULL,NULL),(13663,2271,'2100325','834','00','005010X220A1','2100325','','2014-01-07','11:17:16',0,'2014-01-08 18:24:15',NULL,NULL),(492,102,'874843','834','00','005010X220A1','874843','','2013-12-15','20:49:33',0,'2013-12-25 18:00:14',NULL,NULL),(22181,4180,'2784221','834','00','005010X220A1','2784221','','2014-03-03','16:17:13',0,'2014-03-03 21:31:17',NULL,NULL),(21892,4125,'2915657','834','00','005010X220A1','2915657','','2014-02-28','21:02:27',0,'2014-03-01 21:00:25',NULL,NULL),(12050,1585,'1934711','834','00','005010X220A1','1934711','','2013-12-29','19:38:37',0,'2014-01-01 12:04:00',NULL,NULL),(17287,3172,'2528985','834','00','005010X220A1','2528985','','2014-01-31','11:28:14',0,'2014-01-31 21:00:33',NULL,NULL),(17114,3142,'2217094','834','00','005010X220A1','2217094','','2014-01-30','14:21:02',0,'2014-01-30 21:00:15',NULL,NULL),(13937,2317,'2530938','834','00','005010X220A1','2530938','','2014-01-09','15:43:03',0,'2014-01-13 02:20:11',NULL,NULL),(10672,1403,'1193497','834','00','005010X220A1','1193497','','2013-12-22','19:47:33',0,'2013-12-26 12:59:28',NULL,NULL),(937,181,'98704','834','00','005010X220A1','98704','','2013-12-03','09:10:33',0,'2013-12-25 18:18:15',NULL,NULL),(2710,502,'652100','834','00','005010X220A1','652100','','2013-12-22','17:31:19',0,'2013-12-25 21:17:30',NULL,NULL),(4903,905,'1174206','834','00','005010X220A1','1174206','','2013-10-22','22:39:48',0,'2013-12-26 00:30:13',NULL,NULL),(23395,4403,'3900595','834','00','005010X220A1','3900595','','2014-03-08','19:30:34',0,'2014-03-09 21:00:07',NULL,NULL),(21991,4145,'3277884','834','00','005010X220A1','3277884','','2014-03-02','13:56:38',0,'2014-03-03 01:00:18',NULL,NULL),(21131,3994,'3322239','834','00','005010X220A1','3322239','','2014-02-26','17:47:08',0,'2014-02-26 21:00:31',NULL,NULL),(19036,3540,'2037629','834','00','005010X220A1','2037629','','2014-02-12','13:19:33',0,'2014-02-12 21:30:51',NULL,NULL),(18588,3454,'2623672','834','00','005010X220A1','2623672','','2014-02-09','18:50:43',0,'2014-02-10 21:30:55',NULL,NULL),(12434,1638,'2401347','834','00','005010X220A1','2401347','','2013-12-31','14:15:51',1,'2014-01-02 04:30:53',NULL,NULL),(18106,3328,'2880762','834','00','005010X220A1','2880762','','2014-02-06','11:46:14',0,'2014-02-06 21:01:20',NULL,NULL),(15897,2741,'2511162','834','00','005010X220A1','2511162','','2014-01-21','00:41:16',1,'2014-01-22 03:22:39',NULL,NULL),(5263,970,'820705','834','00','005010X220A1','820705','','2013-11-12','13:30:30',0,'2013-12-26 01:00:07',NULL,NULL),(2961,541,'1160865','834','00','005010X220A1','1160865','','2013-12-13','12:07:10',0,'2013-12-25 21:31:56',NULL,NULL),(15331,2622,'2292752','834','00','005010X220A1','2292752','','2014-01-16','16:24:15',0,'2014-01-17 03:35:15',NULL,NULL),(2739,503,'1040803','834','00','005010X220A1','1040803','','2013-12-22','15:48:36',0,'2013-12-25 21:18:22',NULL,NULL),(11182,1450,'50081','834','00','005010X220A1','50081','','2013-12-23','15:28:24',0,'2013-12-26 13:17:03',NULL,NULL),(145,10,'467398','834','00','005010X220A1','467398','','2013-12-05','09:47:40',0,'2013-12-25 17:19:31',NULL,NULL),(529,102,'1244489','834','00','005010X220A1','1244489','','2013-12-16','14:56:01',0,'2013-12-25 18:01:19',NULL,NULL),(22935,4294,'3763291','834','00','005010X220A1','3763291','','2014-03-06','15:55:06',0,'2014-03-06 21:02:42',NULL,NULL),(21293,4006,'2732244','834','00','005010X220A1','2732244','','2014-02-26','12:24:16',0,'2014-02-26 21:02:19',NULL,NULL),(19842,3689,'3448471','834','00','005010X220A1','3448471','','2014-02-15','11:41:47',0,'2014-02-15 22:01:59',NULL,NULL),(16245,2937,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:06:00',0,'2014-01-23 06:47:42',NULL,NULL),(4418,787,'293837','834','00','005010X220A1','293837','','2013-11-05','19:28:57',0,'2013-12-25 23:16:33',NULL,NULL),(3471,615,'93382','834','00','005010X220A1','93382','','2013-12-11','21:23:06',0,'2013-12-25 22:00:15',NULL,NULL),(15482,2634,'2465658','834','00','005010X220A1','2465658','','2014-01-16','11:57:08',0,'2014-01-17 03:36:23',NULL,NULL),(16018,2767,'1720307','834','00','005010X220A1','1720307','','2014-01-22','12:50:44',0,'2014-01-23 03:02:21',NULL,NULL),(23008,4323,'3675479','834','00','005010X220A1','3675479','','2014-03-06','19:19:45',0,'2014-03-07 21:00:15',NULL,NULL),(22169,4180,'2803624','834','00','005010X220A1','2803624','','2014-03-03','13:26:22',0,'2014-03-03 21:31:09',NULL,NULL),(21781,4091,'3481733','834','00','005010X220A1','3481733','','2014-02-28','14:18:24',0,'2014-02-28 21:31:09',NULL,NULL),(11726,1520,'1632948','834','00','005010X220A1','1632948','','2013-12-28','12:35:03',1,'2013-12-29 11:08:42',NULL,NULL),(10965,1410,'1557292','834','00','005010X220A1','1557292','','2013-12-23','18:45:50',0,'2013-12-26 13:09:34',NULL,NULL),(21446,4028,'3578855','834','00','005010X220A1','3578855','','2014-02-26','19:12:38',0,'2014-02-28 06:30:57',NULL,NULL),(20501,3846,'3222533','834','00','005010X220A1','3222533','','2014-02-20','12:44:31',0,'2014-02-20 22:01:05',NULL,NULL),(18710,3485,'3164865','834','00','005010X220A1','3164865','','2014-02-10','19:08:03',0,'2014-02-11 21:00:07',NULL,NULL),(15371,2624,'1927309','834','00','005010X220A1','1927309','','2014-01-15','22:57:23',0,'2014-01-17 03:35:33',NULL,NULL),(18297,3380,'2194572','834','00','005010X220A1','2194572','','2014-02-08','14:32:50',0,'2014-02-08 19:00:33',NULL,NULL),(17233,3161,'2260890','834','00','005010X220A1','2260890','','2014-01-30','11:13:01',0,'2014-01-30 21:01:32',NULL,NULL),(18175,3351,'1522938','834','00','005010X220A1','1522938','','2014-02-06','18:26:09',0,'2014-02-07 19:00:18',NULL,NULL),(312,70,'478980','834','00','005010X220A1','478980','','2013-12-03','21:06:13',0,'2013-12-25 17:45:34',NULL,NULL),(13268,2112,'0001','999','BE','005010X231A1','818189','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:42',NULL,NULL),(21891,4125,'3797873','834','00','005010X220A1','3797873','','2014-02-28','20:25:19',0,'2014-03-01 21:00:24',NULL,NULL),(21297,4006,'3201796','834','00','005010X220A1','3201796','','2014-02-26','16:43:31',0,'2014-02-26 21:02:22',NULL,NULL),(18050,3319,'2063723','834','00','005010X220A1','2063723','','2014-02-06','12:56:46',0,'2014-02-06 21:00:41',NULL,NULL),(17511,3231,'2233623','834','00','005010X220A1','2233623','','2014-02-02','16:40:47',0,'2014-02-02 19:00:32',NULL,NULL),(17298,3172,'2246396','834','00','005010X220A1','2246396','','2014-01-31','15:54:25',0,'2014-01-31 21:00:39',NULL,NULL),(14554,2519,'1402529','834','00','005010X220A1','1402529','','2014-01-13','09:49:34',0,'2014-01-14 01:32:37',NULL,NULL),(720,120,'921087','834','00','005010X220A1','921087','','2013-12-16','12:51:15',0,'2013-12-25 18:07:25',NULL,NULL),(362,72,'794290','834','00','005010X220A1','794290','','2013-12-04','11:10:22',0,'2013-12-25 17:47:08',NULL,NULL),(22294,4201,'2820076','834','00','005010X220A1','2820076','','2014-03-03','23:11:30',0,'2014-03-04 21:00:54',NULL,NULL),(22227,4191,'2687707','834','00','005010X220A1','2687707','','2014-03-03','16:08:16',0,'2014-03-03 21:31:52',NULL,NULL),(13211,2055,'0001','999','BE','005010X231A1','791584','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:23',NULL,NULL),(20910,3931,'3520115','834','00','005010X220A1','3520115','','2014-02-23','11:31:49',0,'2014-02-26 08:00:10',NULL,NULL),(20771,3907,'2905984','834','00','005010X220A1','2905984','','2014-02-24','21:42:34',0,'2014-02-25 21:30:34',NULL,NULL),(4481,802,'1024647','834','00','005010X220A1','1024647','','2013-11-26','11:49:24',0,'2013-12-25 23:31:25',NULL,NULL),(20494,3845,'2985372','834','00','005010X220A1','2985372','','2014-02-20','12:34:50',0,'2014-02-20 22:00:58',NULL,NULL),(18490,3434,'1425523','834','00','005010X220A1','1425523','','2014-02-10','04:04:45',0,'2014-02-10 11:01:07',NULL,NULL),(21115,3994,'3147761','834','00','005010X220A1','3147761','','2014-02-26','13:01:47',0,'2014-02-26 21:00:19',NULL,NULL),(12781,1703,'1357973','834','00','005010X220A1','1357973','','2014-01-02','19:33:55',0,'2014-01-04 02:00:33',NULL,NULL),(18233,3361,'2646879','834','00','005010X220A1','2646879','','2014-02-07','08:06:50',0,'2014-02-07 19:00:59',NULL,NULL),(16991,3118,'1481114','834','00','005010X220A1','1481114','','2014-01-29','08:42:45',0,'2014-01-29 21:00:49',NULL,NULL),(4388,774,'292504','834','00','005010X220A1','292504','','2013-11-27','11:35:32',0,'2013-12-25 23:15:35',NULL,NULL),(15961,2764,'2586492','834','00','005010X220A1','2586492','','2014-01-21','20:54:43',0,'2014-01-23 03:01:55',NULL,NULL),(14802,2551,'2110849','834','00','005010X220A1','2110849','','2014-01-14','18:30:25',0,'2014-01-15 02:06:45',NULL,NULL),(10626,1402,'2133','834','00','005010X220A1','2133','','2013-12-23','15:45:47',0,'2013-12-26 12:58:01',NULL,NULL),(10768,1404,'167416','834','00','005010X220A1','167416','','2013-12-22','22:32:22',0,'2013-12-26 13:02:52',NULL,NULL),(12226,1617,'2438362','834','00','005010X220A1','2438362','','2014-01-01','00:53:10',1,'2014-01-02 04:22:29',NULL,NULL),(757,139,'473086','834','00','005010X220A1','473086','','2013-12-16','14:17:14',0,'2013-12-25 18:08:34',NULL,NULL),(1969,326,'1206307','834','00','005010X220A1','1206307','','2013-12-09','15:40:32',0,'2013-12-25 19:33:46',NULL,NULL),(11900,1561,'2292287','834','00','005010X220A1','2292287','','2013-12-29','15:30:09',0,'2013-12-30 00:01:01',NULL,NULL),(11220,1454,'1534390','834','00','005010X220A1','1534390','','2013-12-26','10:24:29',0,'2013-12-27 02:01:04',NULL,NULL),(3511,615,'537093','834','00','005010X220A1','537093','','2013-12-12','16:16:20',0,'2013-12-25 22:01:34',NULL,NULL),(3957,715,'3951','834','00','005010X220A1','3951','','2013-12-07','14:57:29',0,'2013-12-25 22:46:47',NULL,NULL),(4723,842,'484469','834','00','005010X220A1','484469','','2013-12-23','22:16:18',0,'2013-12-25 23:51:28',NULL,NULL),(6368,1182,'1357302','834','00','005010X220A1','1357302','','2013-12-20','14:41:48',0,'2013-12-26 03:09:28',NULL,NULL),(12529,1646,'2517012','834','00','005010X220A1','2517012','','2013-12-30','22:26:20',1,'2014-01-02 04:34:25',NULL,NULL),(13030,1874,'0001','999','BE','005010X231A1','51896','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:25',NULL,NULL),(13751,2277,'1411145','834','00','005010X220A1','1411145','','2014-01-06','19:46:56',0,'2014-01-08 18:24:52',NULL,NULL),(13970,2322,'2115704','834','00','005010X220A1','2115704','','2014-01-09','13:42:18',0,'2014-01-13 02:20:35',NULL,NULL),(18037,3319,'2625020','834','00','005010X220A1','2625020','','2014-02-06','13:37:34',0,'2014-02-06 21:00:33',NULL,NULL),(18808,3487,'2594411','834','00','005010X220A1','2594411','','2014-02-11','17:29:17',0,'2014-02-11 21:01:21',NULL,NULL),(18940,3525,'2828826','834','00','005010X220A1','2828826','','2014-02-10','22:31:04',0,'2014-02-11 21:30:20',NULL,NULL),(19217,3580,'2257356','834','00','005010X220A1','2257356','','2014-02-12','21:48:55',0,'2014-02-13 22:00:06',NULL,NULL),(20010,3748,'2618130','834','00','005010X220A1','2618130','','2014-02-18','17:46:56',0,'2014-02-18 22:00:40',NULL,NULL),(20028,3750,'3181532','834','00','005010X220A1','3181532','','2014-02-18','14:10:20',0,'2014-02-18 22:00:52',NULL,NULL),(20036,3750,'3469867','834','00','005010X220A1','3469867','','2014-02-18','16:41:46',0,'2014-02-18 22:00:57',NULL,NULL),(20825,3910,'3659947','834','00','005010X220A1','3659947','','2014-02-25','17:33:28',0,'2014-02-25 21:31:11',NULL,NULL),(22576,4248,'3140416','834','00','005010X220A1','3140416','','2014-03-05','15:03:45',0,'2014-03-05 21:31:01',NULL,NULL),(23054,4339,'3789817','834','00','005010X220A1','3789817','','2014-03-06','18:09:10',0,'2014-03-07 21:30:02',NULL,NULL),(5758,1072,'939089','834','00','005010X220A1','939089','','2013-12-13','20:49:00',0,'2013-12-26 02:02:09',NULL,NULL),(13521,2235,'2230292','834','00','005010X220A1','2230292','','2014-01-06','17:29:35',0,'2014-01-07 04:05:26',NULL,NULL),(6053,1160,'1034322','834','00','005010X220A1','1034322','','2013-11-09','22:45:42',0,'2013-12-26 02:46:41',NULL,NULL),(6289,1172,'401394','834','00','005010X220A1','401394','','2013-12-20','17:40:35',0,'2013-12-26 03:07:05',NULL,NULL),(7428,1295,'294691','834','00','005010X220A1','294691','','2013-12-21','12:40:21',0,'2013-12-26 04:31:45',NULL,NULL),(11746,1521,'1740235','834','00','005010X220A1','1740235','','2013-12-27','19:31:07',1,'2013-12-29 11:09:19',NULL,NULL),(7541,1300,'500737','834','00','005010X220A1','500737','','2013-12-21','16:11:48',0,'2013-12-26 04:35:21',NULL,NULL),(5792,1075,'264717','834','00','005010X220A1','264717','','2013-12-14','17:00:51',0,'2013-12-26 02:03:17',NULL,NULL),(16379,2986,'2587838','834','00','005010X220A1','2587838','','2014-01-23','00:29:02',0,'2014-01-23 21:01:09',NULL,NULL),(16611,3049,'2173001','834','00','005010X220A1','2173001','','2014-01-25','22:15:09',0,'2014-01-26 19:00:10',NULL,NULL),(17288,3172,'2377990','834','00','005010X220A1','2377990','','2014-01-31','12:05:53',0,'2014-01-31 21:00:34',NULL,NULL),(18860,3492,'2641050','834','00','005010X220A1','2641050','','2014-02-10','20:37:32',0,'2014-02-11 21:02:01',NULL,NULL),(18908,3508,'2265234','834','00','005010X220A1','2265234','','2014-02-11','15:03:34',0,'2014-02-11 21:02:44',NULL,NULL),(18913,3511,'2580438','834','00','005010X220A1','2580438','','2014-02-11','13:41:42',0,'2014-02-11 21:02:48',NULL,NULL),(20098,3768,'2603831','834','00','005010X220A1','2603831','','2014-02-18','14:45:12',0,'2014-02-18 22:01:44',NULL,NULL),(20723,3897,'2740131','834','00','005010X220A1','2740131','','2014-02-25','15:37:21',0,'2014-02-25 21:00:27',NULL,NULL),(21536,4039,'3646830','834','00','005010X220A1','3646830','','2014-02-27','12:47:57',0,'2014-02-28 06:31:38',NULL,NULL),(138,9,'770881','834','00','005010X220A1','770881','','2013-12-05','14:01:12',0,'2013-12-25 17:19:16',NULL,NULL),(6434,1203,'827718','834','00','005010X220A1','827718','','2013-11-22','17:55:56',0,'2013-12-26 03:15:32',NULL,NULL),(1064,210,'380678','834','00','005010X220A1','380678','','2013-11-29','13:18:24',0,'2013-12-25 18:30:44',NULL,NULL),(953,181,'345811','834','00','005010X220A1','345811','','2013-12-03','14:15:33',0,'2013-12-25 18:18:43',NULL,NULL),(651,108,'23337','834','00','005010X220A1','23337','','2013-12-16','16:00:28',0,'2013-12-25 18:05:15',NULL,NULL),(623,108,'872666','834','00','005010X220A1','872666','','2013-12-16','10:53:08',0,'2013-12-25 18:04:23',NULL,NULL),(5525,1041,'1556372','834','00','005010X220A1','1556372','','2013-12-24','22:17:37',0,'2013-12-26 01:47:11',NULL,NULL),(5394,1016,'692786','834','00','005010X220A1','692786','','2013-11-25','00:19:57',0,'2013-12-26 01:17:21',NULL,NULL),(1289,243,'1673532','834','00','005010X220A1','1673532','','2013-12-24','18:10:37',0,'2013-12-25 18:50:26',NULL,NULL),(5198,949,'159940','834','00','005010X220A1','159940','','2013-12-11','13:13:09',0,'2013-12-26 00:52:18',NULL,NULL),(12391,1637,'2087807','834','00','005010X220A1','2087807','','2013-12-31','10:28:37',1,'2014-01-02 04:29:21',NULL,NULL),(12668,1673,'1602675','834','00','005010X220A1','1602675','','2014-01-02','16:12:28',0,'2014-01-03 02:03:37',NULL,NULL),(13675,2272,'2382403','834','00','005010X220A1','2382403','','2014-01-06','19:30:09',0,'2014-01-08 18:24:19',NULL,NULL),(13946,2318,'1521038','834','00','005010X220A1','1521038','','2014-01-09','13:35:13',0,'2014-01-13 02:20:17',NULL,NULL),(16817,3090,'1438162','834','00','005010X220A1','1438162','','2014-01-27','22:50:19',0,'2014-01-28 21:00:18',NULL,NULL),(17133,3144,'2695822','834','00','005010X220A1','2695822','','2014-01-29','19:56:47',0,'2014-01-30 21:00:27',NULL,NULL),(17480,3219,'1544033','834','00','005010X220A1','1544033','','2014-02-01','19:18:20',0,'2014-02-02 19:00:13',NULL,NULL),(19016,3539,'3107622','834','00','005010X220A1','3107622','','2014-02-12','17:19:16',0,'2014-02-12 21:30:37',NULL,NULL),(21023,3972,'3472583','834','00','005010X220A1','3472583','','2014-02-23','18:14:28',0,'2014-02-26 09:30:02',NULL,NULL),(22090,4175,'3717483','834','00','005010X220A1','3717483','','2014-03-03','16:40:34',0,'2014-03-03 21:30:10',NULL,NULL),(22418,4219,'2630989','834','00','005010X220A1','2630989','','2014-03-04','12:12:14',0,'2014-03-04 21:02:36',NULL,NULL),(22461,4238,'3013194','834','00','005010X220A1','3013194','','2014-03-05','10:12:01',0,'2014-03-05 21:00:10',NULL,NULL),(22822,4278,'3600721','834','00','005010X220A1','3600721','','2014-03-06','13:54:15',0,'2014-03-06 21:01:19',NULL,NULL),(1446,252,'244507','834','00','005010X220A1','244507','','2013-12-24','11:29:45',0,'2013-12-25 18:55:33',NULL,NULL),(13589,2258,'2412736','834','00','005010X220A1','2412736','','2014-01-05','13:15:47',1,'2014-01-07 10:22:23',NULL,NULL),(6176,1167,'140148','834','00','005010X220A1','140148','','2013-12-20','16:11:13',0,'2013-12-26 03:03:34',NULL,NULL),(6181,1167,'1218487','834','00','005010X220A1','1218487','','2013-12-20','16:36:13',0,'2013-12-26 03:03:44',NULL,NULL),(4992,935,'75346','834','00','005010X220A1','75346','','2013-12-11','08:31:26',0,'2013-12-26 00:45:43',NULL,NULL),(2892,530,'392815','834','00','005010X220A1','392815','','2013-12-22','17:54:51',0,'2013-12-25 21:23:26',NULL,NULL),(11077,1422,'1542839','834','00','005010X220A1','1542839','','2013-12-22','20:42:35',0,'2013-12-26 13:13:23',NULL,NULL),(1812,310,'586422','834','00','005010X220A1','586422','','2013-12-10','14:49:21',0,'2013-12-25 19:20:00',NULL,NULL),(12454,1639,'2416281','834','00','005010X220A1','2416281','','2013-12-31','12:18:31',1,'2014-01-02 04:31:39',NULL,NULL),(12641,1672,'2254211','834','00','005010X220A1','2254211','','2014-01-02','16:01:13',0,'2014-01-03 02:02:33',NULL,NULL),(14745,2550,'2596293','834','00','005010X220A1','2596293','','2014-01-14','17:12:42',0,'2014-01-15 02:06:21',NULL,NULL),(14774,2551,'2559533','834','00','005010X220A1','2559533','','2014-01-14','12:52:08',0,'2014-01-15 02:06:34',NULL,NULL),(15056,2585,'2590218','834','00','005010X220A1','2590218','','2014-01-14','21:46:27',0,'2014-01-16 08:44:53',NULL,NULL),(17131,3144,'1865205','834','00','005010X220A1','1865205','','2014-01-29','18:56:22',0,'2014-01-30 21:00:25',NULL,NULL),(17533,3235,'1806485','834','00','005010X220A1','1806485','','2014-02-03','15:00:15',0,'2014-02-03 21:00:16',NULL,NULL),(17880,3294,'2698633','834','00','005010X220A1','2698633','','2014-02-04','22:48:53',0,'2014-02-05 21:30:20',NULL,NULL),(18253,3376,'2491971','834','00','005010X220A1','2491971','','2014-02-07','20:09:03',0,'2014-02-08 19:00:05',NULL,NULL),(19843,3690,'3262555','834','00','005010X220A1','3262555','','2014-02-14','18:44:09',0,'2014-02-15 22:02:00',NULL,NULL),(19990,3746,'3194353','834','00','005010X220A1','3194353','','2014-02-18','17:44:45',0,'2014-02-18 22:00:26',NULL,NULL),(23009,4323,'2760633','834','00','005010X220A1','2760633','','2014-03-06','19:19:45',0,'2014-03-07 21:00:15',NULL,NULL),(2259,380,'442280','834','00','005010X220A1','442280','','2013-12-02','13:13:26',0,'2013-12-25 19:50:12',NULL,NULL),(4199,735,'419477','834','00','005010X220A1','419477','','2013-12-18','22:03:23',0,'2013-12-25 23:06:14',NULL,NULL),(16954,3115,'2605448','834','00','005010X220A1','2605448','','2014-01-29','17:25:18',0,'2014-01-29 21:00:25',NULL,NULL),(11160,1439,'1622671','834','00','005010X220A1','1622671','','2013-12-23','11:53:23',0,'2013-12-26 13:16:16',NULL,NULL),(12104,1587,'1629647','834','00','005010X220A1','1629647','','2013-12-30','11:13:34',0,'2014-01-01 12:05:51',NULL,NULL),(12169,1594,'2231589','834','00','005010X220A1','2231589','','2013-12-30','14:52:35',0,'2014-01-01 12:08:05',NULL,NULL),(16190,2882,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:09:00',1,'2014-01-23 04:31:51',NULL,NULL),(14933,2561,'1486687','834','00','005010X220A1','1486687','','2014-01-13','20:28:11',0,'2014-01-15 02:07:44',NULL,NULL),(1490,254,'74808','834','00','005010X220A1','74808','','2013-12-24','15:43:31',0,'2013-12-25 18:57:04',NULL,NULL),(11157,1437,'1381587','834','00','005010X220A1','1381587','','2013-12-23','11:10:34',0,'2013-12-26 13:16:09',NULL,NULL),(20096,3766,'3437527','834','00','005010X220A1','3437527','','2014-02-18','14:32:42',0,'2014-02-18 22:01:43',NULL,NULL),(2817,506,'495839','834','00','005010X220A1','495839','','2013-12-22','18:02:34',0,'2013-12-25 21:20:50',NULL,NULL),(17780,3267,'1799182','834','00','005010X220A1','1799182','','2014-02-04','16:23:49',0,'2014-02-04 21:01:19',NULL,NULL),(4241,739,'756391','834','00','005010X220A1','756391','','2013-12-19','10:29:08',0,'2013-12-25 23:07:32',NULL,NULL),(16144,2836,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:56:42',NULL,NULL),(13653,2271,'1448803','834','00','005010X220A1','1448803','','2014-01-07','12:49:14',0,'2014-01-08 18:24:11',NULL,NULL),(1753,293,'796827','834','00','005010X220A1','796827','','2013-12-10','16:54:03',0,'2013-12-25 19:18:04',NULL,NULL),(12307,1630,'1312383','834','00','005010X220A1','1312383','','2014-01-01','10:44:25',1,'2014-01-02 04:25:33',NULL,NULL),(23353,4389,'2867629','834','00','005010X220A1','2867629','','2014-03-07','19:43:50',0,'2014-03-08 21:31:00',NULL,NULL),(1508,258,'1811996','834','00','005010X220A1','1811996','','2013-12-24','11:43:14',0,'2013-12-25 18:57:37',NULL,NULL),(1955,326,'385746','834','00','005010X220A1','385746','','2013-12-09','12:34:05',0,'2013-12-25 19:33:22',NULL,NULL),(2865,514,'725413','834','00','005010X220A1','725413','','2013-12-22','07:26:37',0,'2013-12-25 21:22:28',NULL,NULL),(3521,615,'954390','834','00','005010X220A1','954390','','2013-12-12','17:41:06',0,'2013-12-25 22:01:50',NULL,NULL),(20202,3781,'3035462','834','00','005010X220A1','3035462','','2014-02-19','10:43:49',0,'2014-02-20 04:18:41',NULL,NULL),(3599,617,'650159','834','00','005010X220A1','650159','','2013-12-12','17:59:26',0,'2013-12-25 22:04:18',NULL,NULL),(4544,825,'1537731','834','00','005010X220A1','1537731','','2013-12-23','22:32:45',0,'2013-12-25 23:45:29',NULL,NULL),(19764,3675,'2708619','834','00','005010X220A1','2708619','','2014-02-14','22:40:10',0,'2014-02-15 22:00:54',NULL,NULL),(17849,3291,'2276449','834','00','005010X220A1','2276449','','2014-02-04','21:45:48',0,'2014-02-05 21:30:05',NULL,NULL),(15618,2670,'2415659','834','00','005010X220A1','2415659','','2014-01-17','17:19:44',0,'2014-01-20 08:06:39',NULL,NULL),(12116,1587,'1465848','834','00','005010X220A1','1465848','','2013-12-30','13:58:01',0,'2014-01-01 12:06:16',NULL,NULL),(13204,2048,'0001','999','BE','005010X231A1','315403','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:03',NULL,NULL),(13364,2208,'0001','999','BE','005010X231A1','534285','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:10',NULL,NULL),(14220,2366,'2503321','834','00','005010X220A1','2503321','','2014-01-10','13:08:26',0,'2014-01-13 02:23:57',NULL,NULL),(520,102,'329081','834','00','005010X220A1','329081','','2013-12-16','12:53:03',0,'2013-12-25 18:01:03',NULL,NULL),(1193,239,'1050162','834','00','005010X220A1','1050162','','2013-12-24','17:29:18',0,'2013-12-25 18:47:32',NULL,NULL),(15861,2738,'1539822','834','00','005010X220A1','1539822','','2014-01-21','08:48:19',1,'2014-01-22 03:22:16',NULL,NULL),(1960,326,'109657','834','00','005010X220A1','109657','','2013-12-09','13:46:26',0,'2013-12-25 19:33:30',NULL,NULL),(12416,1638,'2260128','834','00','005010X220A1','2260128','','2013-12-30','19:42:34',1,'2014-01-02 04:30:15',NULL,NULL),(4487,803,'1078898','834','00','005010X220A1','1078898','','2013-11-26','14:23:15',0,'2013-12-25 23:31:39',NULL,NULL),(21664,4077,'2906134','834','00','005010X220A1','2906134','','2014-02-28','15:45:57',0,'2014-02-28 21:00:10',NULL,NULL),(19996,3748,'2588447','834','00','005010X220A1','2588447','','2014-02-18','08:43:47',0,'2014-02-18 22:00:30',NULL,NULL),(17359,3181,'2571311','834','00','005010X220A1','2571311','','2014-01-31','16:30:46',0,'2014-01-31 21:01:23',NULL,NULL),(5809,1081,'332759','834','00','005010X220A1','332759','','2013-12-14','12:01:16',0,'2013-12-26 02:03:51',NULL,NULL),(16759,3069,'2047419','834','00','005010X220A1','2047419','','2014-01-27','12:57:36',0,'2014-01-27 21:01:25',NULL,NULL),(14894,2558,'1663180','834','00','005010X220A1','1663180','','2014-01-14','11:35:05',0,'2014-01-15 02:07:27',NULL,NULL),(14970,2571,'2186633','834','00','005010X220A1','2186633','','2014-01-14','11:16:46',0,'2014-01-15 02:08:02',NULL,NULL),(1458,252,'1364888','834','00','005010X220A1','1364888','','2013-12-24','14:14:51',0,'2013-12-25 18:56:01',NULL,NULL),(10895,1409,'450210','834','00','005010X220A1','450210','','2013-12-23','00:37:19',0,'2013-12-26 13:07:28',NULL,NULL),(2834,511,'414746','834','00','005010X220A1','414746','','2013-12-21','22:44:00',0,'2013-12-25 21:21:27',NULL,NULL),(2480,433,'76784','834','00','005010X220A1','76784','','2013-12-06','17:05:34',0,'2013-12-25 20:19:50',NULL,NULL),(4299,748,'1279859','834','00','005010X220A1','1279859','','2013-12-19','10:32:52',0,'2013-12-25 23:09:16',NULL,NULL),(21370,4024,'2727461','834','00','005010X220A1','2727461','','2014-02-27','10:58:23',0,'2014-02-28 06:30:21',NULL,NULL),(17703,3261,'2673072','834','00','005010X220A1','2673072','','2014-02-03','20:38:36',0,'2014-02-04 21:00:31',NULL,NULL),(17542,3235,'2143845','834','00','005010X220A1','2143845','','2014-02-03','16:40:58',0,'2014-02-03 21:00:21',NULL,NULL),(17367,3184,'1804013','834','00','005010X220A1','1804013','','2014-01-31','09:31:59',0,'2014-01-31 21:01:28',NULL,NULL),(4839,883,'534185','834','00','005010X220A1','534185','','2013-11-21','08:48:04',0,'2013-12-26 00:15:16',NULL,NULL),(10632,1402,'1260723','834','00','005010X220A1','1260723','','2013-12-23','16:30:59',0,'2013-12-26 12:58:13',NULL,NULL),(1379,245,'1460504','834','00','005010X220A1','1460504','','2013-12-24','16:17:09',0,'2013-12-25 18:53:20',NULL,NULL),(5567,1043,'451770','834','00','005010X220A1','451770','','2013-12-24','20:06:22',0,'2013-12-26 01:48:34',NULL,NULL),(6461,1218,'204568','834','00','005010X220A1','204568','','2013-11-22','11:24:03',0,'2013-12-26 03:16:29',NULL,NULL),(1225,243,'1349795','834','00','005010X220A1','1349795','','2013-12-24','09:28:22',0,'2013-12-25 18:48:32',NULL,NULL),(21662,4077,'2789258','834','00','005010X220A1','2789258','','2014-02-27','22:40:39',0,'2014-02-28 21:00:09',NULL,NULL),(21545,4043,'3705706','834','00','005010X220A1','3705706','','2014-02-27','10:53:23',0,'2014-02-28 06:31:42',NULL,NULL),(3594,617,'1301579','834','00','005010X220A1','1301579','','2013-12-12','16:50:03',0,'2013-12-25 22:04:09',NULL,NULL),(21488,4028,'3108026','834','00','005010X220A1','3108026','','2014-02-27','17:47:28',0,'2014-02-28 06:31:16',NULL,NULL),(3577,617,'378551','834','00','005010X220A1','378551','','2013-12-12','10:27:52',0,'2013-12-25 22:03:38',NULL,NULL),(4525,818,'908154','834','00','005010X220A1','908154','','2013-11-26','12:16:13',0,'2013-12-25 23:32:55',NULL,NULL),(10809,1404,'927801','834','00','005010X220A1','927801','','2013-12-23','15:16:45',0,'2013-12-26 13:04:09',NULL,NULL),(1330,245,'1947961','834','00','005010X220A1','1947961','','2013-12-24','11:57:20',0,'2013-12-25 18:51:46',NULL,NULL),(14298,2384,'1740545','834','00','005010X220A1','1740545','','2014-01-10','12:39:26',0,'2014-01-13 03:00:27',NULL,NULL),(16306,2980,'1686599','834','00','005010X220A1','1686599','','2014-01-23','09:35:32',0,'2014-01-23 21:00:17',NULL,NULL),(21027,3974,'3423790','834','00','005010X220A1','3423790','','2014-02-24','13:41:01',0,'2014-02-26 09:30:06',NULL,NULL),(20198,3782,'3280164','834','00','005010X220A1','3280164','','2014-02-19','09:39:01',0,'2014-02-20 04:17:45',NULL,NULL),(18964,3534,'2967370','834','00','005010X220A1','2967370','','2014-02-12','12:48:23',0,'2014-02-12 21:00:15',NULL,NULL),(17438,3205,'2381834','834','00','005010X220A1','2381834','','2014-02-01','01:30:53',0,'2014-02-01 19:00:33',NULL,NULL),(18812,3489,'2462432','834','00','005010X220A1','2462432','','2014-02-10','19:18:03',0,'2014-02-11 21:01:24',NULL,NULL),(548,103,'1164973','834','00','005010X220A1','1164973','','2013-12-16','07:43:20',0,'2013-12-25 18:01:56',NULL,NULL),(1677,290,'514090','834','00','005010X220A1','514090','','2013-12-10','15:24:15',0,'2013-12-25 19:15:44',NULL,NULL),(7687,1328,'1193455','834','00','005010X220A1','1193455','','2013-12-21','17:01:40',0,'2013-12-26 04:40:04',NULL,NULL),(18952,3530,'2103707','834','00','005010X220A1','2103707','','2014-02-11','19:31:42',0,'2014-02-12 21:00:05',NULL,NULL),(18617,3457,'2825258','834','00','005010X220A1','2825258','','2014-02-09','19:00:27',0,'2014-02-10 21:31:15',NULL,NULL),(4018,731,'703446','834','00','005010X220A1','703446','','2013-12-19','11:38:37',0,'2013-12-25 23:00:40',NULL,NULL),(11432,1476,'1260902','834','00','005010X220A1','1260902','','2013-12-26','13:17:12',0,'2013-12-27 02:07:35',NULL,NULL),(16921,3114,'2122156','834','00','005010X220A1','2122156','','2014-01-28','19:55:52',0,'2014-01-29 21:00:05',NULL,NULL),(15430,2629,'1618429','834','00','005010X220A1','1618429','','2014-01-16','15:53:47',0,'2014-01-17 03:36:01',NULL,NULL),(14198,2365,'1596518','834','00','005010X220A1','1596518','','2014-01-10','14:03:34',0,'2014-01-13 02:23:42',NULL,NULL),(15001,2584,'2370270','834','00','005010X220A1','2370270','','2014-01-14','21:49:23',0,'2014-01-16 08:44:18',NULL,NULL),(23710,4455,'3524114','834','00','005010X220A1','3524114','','2014-03-10','10:49:36',0,'2014-03-10 21:02:35',NULL,NULL),(21885,4124,'2639104','834','00','005010X220A1','2639104','','2014-02-28','18:38:59',0,'2014-03-01 21:00:19',NULL,NULL),(19662,3653,'2233955','834','00','005010X220A1','2233955','','2014-02-14','15:59:45',0,'2014-02-14 21:32:23',NULL,NULL),(12927,1719,'1552484','834','00','005010X220A1','1552484','','2014-01-03','11:22:59',0,'2014-01-04 02:05:55',NULL,NULL),(2614,489,'160713','834','00','005010X220A1','160713','','2013-11-27','18:24:48',0,'2013-12-25 20:46:25',NULL,NULL),(5753,1071,'1290142','834','00','005010X220A1','1290142','','2013-12-13','19:43:34',0,'2013-12-26 02:01:59',NULL,NULL),(1844,322,'128504','834','00','005010X220A1','128504','','2013-12-10','17:04:42',0,'2013-12-25 19:21:08',NULL,NULL),(1655,289,'1010331','834','00','005010X220A1','1010331','','2013-12-09','18:18:30',0,'2013-12-25 19:15:03',NULL,NULL),(20307,3795,'3124175','834','00','005010X220A1','3124175','','2014-02-19','13:17:30',0,'2014-02-20 04:45:10',NULL,NULL),(19700,3671,'3015432','834','00','005010X220A1','3015432','','2014-02-14','20:35:31',0,'2014-02-15 22:00:07',NULL,NULL),(19332,3583,'3085980','834','00','005010X220A1','3085980','','2014-02-13','13:44:03',0,'2014-02-13 22:01:38',NULL,NULL),(10377,1400,'43534','834','00','005010X220A1','43534','','2013-12-22','20:38:11',0,'2013-12-26 12:49:59',NULL,NULL),(3492,615,'539633','834','00','005010X220A1','539633','','2013-12-12','12:30:21',0,'2013-12-25 22:00:55',NULL,NULL),(15693,2698,'1769727','834','00','005010X220A1','1769727','','2014-01-18','22:03:21',0,'2014-01-21 08:45:22',NULL,NULL),(16751,3067,'2662546','834','00','005010X220A1','2662546','','2014-01-27','14:58:04',0,'2014-01-27 21:01:18',NULL,NULL),(17608,3240,'1716330','834','00','005010X220A1','1716330','','2014-02-03','17:19:14',0,'2014-02-03 21:01:04',NULL,NULL),(17388,3195,'2548172','834','00','005010X220A1','2548172','','2014-01-31','16:36:44',0,'2014-01-31 21:01:45',NULL,NULL),(22972,4314,'3186516','834','00','005010X220A1','3186516','','2014-03-06','17:06:41',0,'2014-03-06 21:30:12',NULL,NULL),(23268,4378,'3491440','834','00','005010X220A1','3491440','','2014-03-07','21:41:46',0,'2014-03-08 21:00:07',NULL,NULL),(862,175,'881040','834','00','005010X220A1','881040','','2013-12-03','12:20:24',0,'2013-12-25 18:16:01',NULL,NULL),(13295,2139,'0001','999','BE','005010X231A1','606591','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:58',NULL,NULL),(22286,4200,'3618865','834','00','005010X220A1','3618865','','2014-03-04','16:34:46',0,'2014-03-04 21:00:48',NULL,NULL),(20797,3909,'3255545','834','00','005010X220A1','3255545','','2014-02-25','13:58:56',0,'2014-02-25 21:30:53',NULL,NULL),(12708,1677,'2020002','834','00','005010X220A1','2020002','','2014-01-02','14:48:28',0,'2014-01-03 02:05:03',NULL,NULL),(18194,3353,'2368538','834','00','005010X220A1','2368538','','2014-02-07','00:34:41',0,'2014-02-07 19:00:30',NULL,NULL),(12013,1583,'2332163','834','00','005010X220A1','2332163','','2013-12-30','08:48:04',0,'2014-01-01 12:02:35',NULL,NULL),(17778,3267,'2550599','834','00','005010X220A1','2550599','','2014-02-03','23:16:19',0,'2014-02-04 21:01:18',NULL,NULL),(16136,2828,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 03:51:52',NULL,NULL),(22056,4168,'3365817','834','00','005010X220A1','3365817','','2014-03-03','13:16:00',0,'2014-03-03 21:00:14',NULL,NULL),(22518,4247,'3667413','834','00','005010X220A1','3667413','','2014-03-05','13:01:22',0,'2014-03-05 21:30:19',NULL,NULL),(1216,243,'983498','834','00','005010X220A1','983498','','2013-12-24','08:28:01',0,'2013-12-25 18:48:15',NULL,NULL),(13596,2259,'2155559','834','00','005010X220A1','2155559','','2014-01-04','20:43:46',1,'2014-01-07 10:22:41',NULL,NULL),(22579,4248,'2748463','834','00','005010X220A1','2748463','','2014-03-05','16:09:18',0,'2014-03-05 21:31:03',NULL,NULL),(20188,3779,'3096655','834','00','005010X220A1','3096655','','2014-02-19','11:50:25',0,'2014-02-20 04:15:02',NULL,NULL),(5408,1022,'138324','834','00','005010X220A1','138324','','2013-11-13','21:17:26',0,'2013-12-26 01:30:31',NULL,NULL),(6063,1164,'903809','834','00','005010X220A1','903809','','2013-12-20','06:24:42',0,'2013-12-26 03:00:07',NULL,NULL),(4410,780,'1181752','834','00','005010X220A1','1181752','','2013-11-27','17:38:57',0,'2013-12-25 23:16:16',NULL,NULL),(2591,477,'21487','834','00','005010X220A1','21487','','2013-10-31','18:26:47',0,'2013-12-25 20:45:41',NULL,NULL),(19727,3672,'2663050','834','00','005010X220A1','2663050','','2014-02-15','15:06:45',0,'2014-02-15 22:00:27',NULL,NULL),(19485,3620,'1892258','834','00','005010X220A1','1892258','','2014-02-14','00:55:27',0,'2014-02-14 21:30:15',NULL,NULL),(19040,3540,'1922563','834','00','005010X220A1','1922563','','2014-02-12','17:57:05',0,'2014-02-12 21:30:53',NULL,NULL),(18059,3320,'2761095','834','00','005010X220A1','2761095','','2014-02-06','06:16:18',0,'2014-02-06 21:00:47',NULL,NULL),(23651,4441,'3617901','834','00','005010X220A1','3617901','','2014-03-10','17:43:28',0,'2014-03-10 21:01:52',NULL,NULL),(22634,4252,'2998610','834','00','005010X220A1','2998610','','2014-03-05','16:14:22',0,'2014-03-05 21:31:42',NULL,NULL),(4348,759,'649300','834','00','005010X220A1','649300','','2013-12-19','10:37:49',0,'2013-12-25 23:10:43',NULL,NULL),(21722,4088,'3654468','834','00','005010X220A1','3654468','','2014-02-28','13:10:51',0,'2014-02-28 21:30:28',NULL,NULL),(10811,1404,'1305526','834','00','005010X220A1','1305526','','2013-12-23','15:22:02',0,'2013-12-26 13:04:13',NULL,NULL),(19765,3675,'3432060','834','00','005010X220A1','3432060','','2014-02-15','08:58:34',0,'2014-02-15 22:00:54',NULL,NULL),(17500,3222,'1434494','834','00','005010X220A1','1434494','','2014-02-02','13:20:00',0,'2014-02-02 19:00:24',NULL,NULL),(7031,1235,'641507','834','00','005010X220A1','641507','','2013-12-18','13:19:42',0,'2013-12-26 04:01:28',NULL,NULL),(12213,1615,'2014411','834','00','005010X220A1','2014411','','2014-01-01','12:36:27',1,'2014-01-02 04:21:58',NULL,NULL),(13529,2240,'1888675','834','00','005010X220A1','1888675','','2014-01-06','17:51:04',0,'2014-01-07 04:05:44',NULL,NULL),(15878,2739,'2109805','834','00','005010X220A1','2109805','','2014-01-21','17:14:19',1,'2014-01-22 03:22:27',NULL,NULL),(20636,3874,'3397628','834','00','005010X220A1','3397628','','2014-02-20','23:54:50',0,'2014-02-21 22:00:42',NULL,NULL),(13322,2166,'0001','999','BE','005010X231A1','367204','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:13',NULL,NULL),(12636,1672,'1608851','834','00','005010X220A1','1608851','','2014-01-02','12:16:34',0,'2014-01-03 02:02:20',NULL,NULL),(19241,3580,'2860226','834','00','005010X220A1','2860226','','2014-02-13','14:42:11',0,'2014-02-13 22:00:27',NULL,NULL),(7507,1300,'860837','834','00','005010X220A1','860837','','2013-12-21','08:07:33',0,'2013-12-26 04:34:15',NULL,NULL),(7708,1333,'1038556','834','00','005010X220A1','1038556','','2013-11-14','20:34:16',0,'2013-12-26 04:45:44',NULL,NULL),(14980,2575,'2546680','834','00','005010X220A1','2546680','','2014-01-14','14:14:02',0,'2014-01-15 02:08:07',NULL,NULL),(14414,2435,'0001','999','BE','005010X231A1','1159453','834','2013-12-28','12:25:00',0,'2014-01-13 03:02:26',NULL,NULL),(23399,4403,'3880420','834','00','005010X220A1','3880420','','2014-03-09','12:13:47',0,'2014-03-09 21:00:10',NULL,NULL),(1072,213,'83056','834','00','005010X220A1','83056','','2013-11-29','15:58:51',0,'2013-12-25 18:31:00',NULL,NULL),(12862,1706,'2232884','834','00','005010X220A1','2232884','','2014-01-03','10:19:22',0,'2014-01-04 02:03:30',NULL,NULL),(12820,1704,'1690939','834','00','005010X220A1','1690939','','2014-01-02','22:11:00',0,'2014-01-04 02:01:59',NULL,NULL),(12198,1609,'2452427','834','00','005010X220A1','2452427','','2013-12-30','14:33:51',0,'2014-01-01 12:09:13',NULL,NULL),(20218,3783,'2766292','834','00','005010X220A1','2766292','','2014-02-18','18:55:26',0,'2014-02-20 04:22:45',NULL,NULL),(18707,3485,'1985177','834','00','005010X220A1','1985177','','2014-02-11','18:21:35',0,'2014-02-11 21:00:05',NULL,NULL),(4591,826,'53941','834','00','005010X220A1','53941','','2013-12-23','23:11:59',0,'2013-12-25 23:46:59',NULL,NULL),(18523,3451,'2982410','834','00','005010X220A1','2982410','','2014-02-10','10:55:06',0,'2014-02-10 21:30:09',NULL,NULL),(18077,3323,'2967205','834','00','005010X220A1','2967205','','2014-02-06','09:44:33',0,'2014-02-06 21:01:00',NULL,NULL),(7022,1235,'360884','834','00','005010X220A1','360884','','2013-12-18','10:43:11',0,'2013-12-26 04:01:10',NULL,NULL),(7480,1296,'754142','834','00','005010X220A1','754142','','2013-12-21','17:21:36',0,'2013-12-26 04:33:18',NULL,NULL),(2165,362,'415089','834','00','005010X220A1','415089','','2013-12-02','17:56:08',0,'2013-12-25 19:46:56',NULL,NULL),(1141,239,'650842','834','00','005010X220A1','650842','','2013-12-24','03:36:29',0,'2013-12-25 18:45:56',NULL,NULL),(16401,2993,'2041261','834','00','005010X220A1','2041261','','2014-01-23','15:42:11',0,'2014-01-23 21:01:22',NULL,NULL),(22854,4280,'3588283','834','00','005010X220A1','3588283','','2014-03-05','21:39:46',0,'2014-03-06 21:01:42',NULL,NULL),(15677,2690,'1536069','834','00','005010X220A1','1536069','','2014-01-18','15:05:27',0,'2014-01-21 08:44:44',NULL,NULL),(14479,2500,'0001','999','BE','005010X231A1','539400','834','2013-12-28','04:55:00',0,'2014-01-13 03:03:51',NULL,NULL),(14471,2492,'0001','999','BE','005010X231A1','1174662','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:43',NULL,NULL),(10542,1402,'454304','834','00','005010X220A1','454304','','2013-12-22','18:37:12',0,'2013-12-26 12:55:13',NULL,NULL),(5128,943,'1200409','834','00','005010X220A1','1200409','','2013-12-10','20:50:20',0,'2013-12-26 00:50:09',NULL,NULL),(7739,1343,'1196010','834','00','005010X220A1','1196010','','2013-10-20','16:53:00',0,'2013-12-26 05:00:29',NULL,NULL),(7544,1300,'667686','834','00','005010X220A1','667686','','2013-12-21','17:12:42',0,'2013-12-26 04:35:25',NULL,NULL),(324,72,'1159453','834','00','005010X220A1','1159453','','2013-12-03','18:51:43',0,'2013-12-25 17:45:58',NULL,NULL),(23021,4325,'2834375','834','00','005010X220A1','2834375','','2014-03-07','12:01:11',0,'2014-03-07 21:00:21',NULL,NULL),(20693,3890,'3421098','834','00','005010X220A1','3421098','','2014-02-22','15:33:35',0,'2014-02-22 19:00:14',NULL,NULL),(16836,3091,'2638314','834','00','005010X220A1','2638314','','2014-01-28','15:45:12',0,'2014-01-28 21:00:30',NULL,NULL),(13912,2313,'1851935','834','00','005010X220A1','1851935','','2014-01-09','09:50:11',0,'2014-01-13 02:19:52',NULL,NULL),(2855,512,'964860','834','00','005010X220A1','964860','','2013-12-22','12:34:10',0,'2013-12-25 21:22:10',NULL,NULL),(450,82,'770851','834','00','005010X220A1','770851','','2013-12-04','12:38:57',0,'2013-12-25 17:49:58',NULL,NULL),(12145,1591,'1845621','834','00','005010X220A1','1845621','','2013-12-30','10:07:27',0,'2014-01-01 12:07:17',NULL,NULL),(5379,1011,'628927','834','00','005010X220A1','628927','','2013-11-25','17:31:44',0,'2013-12-26 01:16:51',NULL,NULL),(19162,3555,'2926126','834','00','005010X220A1','2926126','','2014-02-12','14:36:29',0,'2014-02-12 21:32:19',NULL,NULL),(18700,3479,'2512909','834','00','005010X220A1','2512909','','2014-02-10','13:51:12',0,'2014-02-10 21:32:14',NULL,NULL),(6390,1186,'922697','834','00','005010X220A1','922697','','2013-12-20','14:44:38',0,'2013-12-26 03:10:08',NULL,NULL),(15858,2738,'2453023','834','00','005010X220A1','2453023','','2014-01-21','14:38:04',1,'2014-01-22 03:22:14',NULL,NULL),(14474,2495,'0001','999','BE','005010X231A1','667011','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:46',NULL,NULL),(3374,587,'1197967','834','00','005010X220A1','1197967','','2013-12-17','15:04:44',0,'2013-12-25 21:50:53',NULL,NULL),(2918,541,'813446','834','00','005010X220A1','813446','','2013-12-13','18:07:11',0,'2013-12-25 21:30:30',NULL,NULL),(331,72,'171735','834','00','005010X220A1','171735','','2013-12-04','09:13:51',0,'2013-12-25 17:46:11',NULL,NULL),(21815,4093,'3679175','834','00','005010X220A1','3679175','','2014-02-28','16:46:18',0,'2014-02-28 21:31:32',NULL,NULL),(12694,1674,'1544642','834','00','005010X220A1','1544642','','2014-01-02','09:55:35',0,'2014-01-03 02:04:32',NULL,NULL),(3763,654,'44140','834','00','005010X220A1','44140','','2013-12-07','21:06:34',0,'2013-12-25 22:15:06',NULL,NULL),(21611,4064,'2810508','834','00','005010X220A1','2810508','','2014-02-27','16:16:57',0,'2014-02-28 07:30:13',NULL,NULL),(20439,3841,'2817015','834','00','005010X220A1','2817015','','2014-02-20','12:33:36',0,'2014-02-20 22:00:14',NULL,NULL),(7307,1262,'334253','834','00','005010X220A1','334253','','2013-12-18','17:30:13',0,'2013-12-26 04:09:55',NULL,NULL),(10369,1400,'1444398','834','00','005010X220A1','1444398','','2013-12-22','19:53:45',0,'2013-12-26 12:49:46',NULL,NULL),(613,108,'398409','834','00','005010X220A1','398409','','2013-12-15','22:07:50',0,'2013-12-25 18:04:00',NULL,NULL),(15751,2713,'2340953','834','00','005010X220A1','2340953','','2014-01-20','16:34:37',0,'2014-01-21 08:46:18',NULL,NULL),(18883,3496,'3160971','834','00','005010X220A1','3160971','','2014-02-11','15:46:19',0,'2014-02-11 21:02:20',NULL,NULL),(18874,3494,'3202396','834','00','005010X220A1','3202396','','2014-02-10','21:15:38',0,'2014-02-11 21:02:12',NULL,NULL),(18696,3476,'2973875','834','00','005010X220A1','2973875','','2014-02-10','12:56:46',0,'2014-02-10 21:32:10',NULL,NULL),(17573,3236,'1687907','834','00','005010X220A1','1687907','','2014-02-03','16:19:05',0,'2014-02-03 21:00:40',NULL,NULL),(17727,3261,'1806507','834','00','005010X220A1','1806507','','2014-02-04','16:26:50',0,'2014-02-04 21:00:46',NULL,NULL),(17969,3302,'2315792','834','00','005010X220A1','2315792','','2014-02-05','13:39:34',0,'2014-02-05 21:31:05',NULL,NULL),(18315,3384,'2088743','834','00','005010X220A1','2088743','','2014-02-08','12:04:22',0,'2014-02-08 19:00:44',NULL,NULL),(1770,298,'92152','834','00','005010X220A1','92152','','2013-12-09','19:07:14',0,'2013-12-25 19:18:36',NULL,NULL),(12794,1703,'2432392','834','00','005010X220A1','2432392','','2014-01-03','11:09:51',0,'2014-01-04 02:01:02',NULL,NULL),(12666,1673,'2176467','834','00','005010X220A1','2176467','','2014-01-02','12:56:41',0,'2014-01-03 02:03:32',NULL,NULL),(15123,2587,'1671551','834','00','005010X220A1','1671551','','2014-01-15','11:10:39',0,'2014-01-16 08:45:35',NULL,NULL),(16676,3061,'1983627','834','00','005010X220A1','1983627','','2014-01-27','16:16:58',0,'2014-01-27 21:00:28',NULL,NULL),(23233,4361,'2864779','834','00','005010X220A1','2864779','','2014-03-07','10:50:05',0,'2014-03-07 21:32:10',NULL,NULL),(383,74,'419961','834','00','005010X220A1','419961','','2013-12-04','11:44:32',0,'2013-12-25 17:47:49',NULL,NULL),(485,101,'472720','834','00','005010X220A1','472720','','2013-12-04','17:48:38',0,'2013-12-25 17:51:09',NULL,NULL),(7316,1266,'917026','834','00','005010X220A1','917026','','2013-12-18','12:05:15',0,'2013-12-26 04:10:11',NULL,NULL),(20429,3840,'3645452','834','00','005010X220A1','3645452','','2014-02-19','21:54:47',0,'2014-02-20 22:00:05',NULL,NULL),(19520,3622,'2231264','834','00','005010X220A1','2231264','','2014-02-14','11:00:04',0,'2014-02-14 21:30:39',NULL,NULL),(2827,510,'324919','834','00','005010X220A1','324919','','2013-12-21','20:28:40',0,'2013-12-25 21:21:12',NULL,NULL),(18832,3490,'2135011','834','00','005010X220A1','2135011','','2014-02-11','13:07:05',0,'2014-02-11 21:01:39',NULL,NULL),(14353,2403,'1787682','834','00','005010X220A1','1787682','','2014-01-11','21:46:29',0,'2014-01-13 03:01:28',NULL,NULL),(5068,936,'1090764','834','00','005010X220A1','1090764','','2013-12-11','11:46:10',0,'2013-12-26 00:48:11',NULL,NULL),(12203,1612,'1577706','834','00','005010X220A1','1577706','','2013-12-30','14:55:07',0,'2014-01-01 12:09:25',NULL,NULL),(23147,4342,'3526494','834','00','005010X220A1','3526494','','2014-03-07','16:51:46',0,'2014-03-07 21:31:07',NULL,NULL),(21860,4116,'2757879','834','00','005010X220A1','2757879','','2014-02-28','19:30:18',0,'2014-03-01 19:00:09',NULL,NULL),(21042,3977,'3604190','834','00','005010X220A1','3604190','','2014-02-24','14:37:39',0,'2014-02-26 09:30:20',NULL,NULL),(5200,949,'384456','834','00','005010X220A1','384456','','2013-12-11','13:23:30',0,'2013-12-26 00:52:22',NULL,NULL),(19271,3582,'2483392','834','00','005010X220A1','2483392','','2014-02-12','19:53:26',0,'2014-02-13 22:00:51',NULL,NULL),(3722,636,'336807','834','00','005010X220A1','336807','','2013-12-12','12:47:06',0,'2013-12-25 22:08:16',NULL,NULL),(10723,1403,'519115','834','00','005010X220A1','519115','','2013-12-23','14:07:23',0,'2013-12-26 13:01:23',NULL,NULL),(1404,247,'1859524','834','00','005010X220A1','1859524','','2013-12-24','10:35:47',0,'2013-12-25 18:54:11',NULL,NULL),(14839,2553,'2208944','834','00','005010X220A1','2208944','','2014-01-14','09:12:42',0,'2014-01-15 02:07:01',NULL,NULL),(16090,2782,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:31:00',0,'2014-01-23 03:38:41',NULL,NULL),(17154,3144,'1886975','834','00','005010X220A1','1886975','','2014-01-30','16:03:24',0,'2014-01-30 21:00:40',NULL,NULL),(17458,3212,'2080796','834','00','005010X220A1','2080796','','2014-02-01','07:57:10',0,'2014-02-01 19:00:47',NULL,NULL),(18274,3377,'2897597','834','00','005010X220A1','2897597','','2014-02-08','14:07:42',0,'2014-02-08 19:00:18',NULL,NULL),(23116,4342,'3068175','834','00','005010X220A1','3068175','','2014-03-06','19:37:50',0,'2014-03-07 21:30:47',NULL,NULL),(21980,4145,'2742975','834','00','005010X220A1','2742975','','2014-03-01','19:12:24',0,'2014-03-03 01:00:13',NULL,NULL),(13454,2224,'1292244','834','00','005010X220A1','1292244','','2014-01-06','11:40:10',0,'2014-01-07 04:02:55',NULL,NULL),(21628,4066,'3760295','834','00','005010X220A1','3760295','','2014-02-27','14:31:42',0,'2014-02-28 07:30:24',NULL,NULL),(5104,940,'1233792','834','00','005010X220A1','1233792','','2013-12-11','15:56:33',0,'2013-12-26 00:49:17',NULL,NULL),(4375,773,'487740','834','00','005010X220A1','487740','','2013-11-27','12:35:20',0,'2013-12-25 23:15:10',NULL,NULL),(20407,3833,'3507589','834','00','005010X220A1','3507589','','2014-02-20','14:04:22',0,'2014-02-20 21:30:11',NULL,NULL),(15703,2700,'2040022','834','00','005010X220A1','2040022','','2014-01-19','17:24:15',0,'2014-01-21 08:45:30',NULL,NULL),(18792,3487,'2739741','834','00','005010X220A1','2739741','','2014-02-11','12:33:24',0,'2014-02-11 21:01:09',NULL,NULL),(18261,3376,'2563911','834','00','005010X220A1','2563911','','2014-02-08','12:32:20',0,'2014-02-08 19:00:10',NULL,NULL),(21063,3979,'3332845','834','00','005010X220A1','3332845','','2014-02-24','17:29:34',0,'2014-02-26 09:30:37',NULL,NULL),(11377,1461,'836565','834','00','005010X220A1','836565','','2013-12-26','07:54:16',0,'2013-12-27 02:05:51',NULL,NULL),(10427,1400,'1464350','834','00','005010X220A1','1464350','','2013-12-23','10:40:22',0,'2013-12-26 12:51:32',NULL,NULL),(903,177,'937485','834','00','005010X220A1','937485','','2013-12-03','11:34:47',0,'2013-12-25 18:17:13',NULL,NULL),(18444,3422,'2379156','834','00','005010X220A1','2379156','','2014-02-10','00:08:07',0,'2014-02-10 11:00:28',NULL,NULL),(1088,218,'791584','834','00','005010X220A1','791584','','2013-11-04','11:18:25',0,'2013-12-25 18:31:33',NULL,NULL),(18438,3421,'2019484','834','00','005010X220A1','2019484','','2014-02-10','00:23:51',0,'2014-02-10 11:00:23',NULL,NULL),(6344,1178,'459197','834','00','005010X220A1','459197','','2013-12-19','20:48:31',0,'2013-12-26 03:08:44',NULL,NULL),(2210,365,'22927','834','00','005010X220A1','22927','','2013-12-02','12:33:37',0,'2013-12-25 19:48:29',NULL,NULL),(3123,548,'1214378','834','00','005010X220A1','1214378','','2013-12-13','18:17:54',0,'2013-12-25 21:36:53',NULL,NULL),(4583,826,'1276645','834','00','005010X220A1','1276645','','2013-12-23','22:34:33',0,'2013-12-25 23:46:44',NULL,NULL),(18130,3335,'2714521','834','00','005010X220A1','2714521','','2014-02-06','17:46:55',0,'2014-02-06 21:01:38',NULL,NULL),(4092,733,'956887','834','00','005010X220A1','956887','','2013-12-19','10:39:10',0,'2013-12-25 23:03:03',NULL,NULL),(14908,2558,'1577063','834','00','005010X220A1','1577063','','2014-01-14','15:47:07',0,'2014-01-15 02:07:33',NULL,NULL),(23738,4469,'3577826','834','00','005010X220A1','3577826','','2014-03-10','15:11:23',0,'2014-03-10 21:02:58',NULL,NULL),(750,135,'272511','834','00','005010X220A1','272511','','2013-12-16','13:18:01',0,'2013-12-25 18:08:21',NULL,NULL),(10839,1404,'1776537','834','00','005010X220A1','1776537','','2013-12-23','18:57:25',0,'2013-12-26 13:05:06',NULL,NULL),(16099,2791,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:19:00',1,'2014-01-23 03:40:36',NULL,NULL),(2334,412,'374929','834','00','005010X220A1','374929','','2013-12-06','11:47:05',0,'2013-12-25 20:15:07',NULL,NULL),(5836,1091,'758412','834','00','005010X220A1','758412','','2013-11-22','21:10:25',0,'2013-12-26 02:15:36',NULL,NULL),(5443,1033,'463190','834','00','005010X220A1','463190','','2013-10-05','17:31:20',0,'2013-12-26 01:31:44',NULL,NULL),(1046,204,'1234921','834','00','005010X220A1','1234921','','2013-11-29','16:57:02',0,'2013-12-25 18:30:09',NULL,NULL),(21453,4028,'3311503','834','00','005010X220A1','3311503','','2014-02-26','22:17:47',0,'2014-02-28 06:31:00',NULL,NULL),(21091,3985,'2538338','834','00','005010X220A1','2538338','','2014-02-24','13:19:09',0,'2014-02-26 09:30:58',NULL,NULL),(2425,417,'273514','834','00','005010X220A1','273514','','2013-12-06','09:09:02',0,'2013-12-25 20:18:01',NULL,NULL),(2485,436,'456283','834','00','005010X220A1','456283','','2013-12-06','07:49:35',0,'2013-12-25 20:20:01',NULL,NULL),(2015,331,'1161918','834','00','005010X220A1','1161918','','2013-12-09','12:45:57',0,'2013-12-25 19:35:20',NULL,NULL),(20001,3748,'3591642','834','00','005010X220A1','3591642','','2014-02-18','11:24:32',0,'2014-02-18 22:00:33',NULL,NULL),(3631,622,'1149858','834','00','005010X220A1','1149858','','2013-12-12','10:10:38',0,'2013-12-25 22:05:19',NULL,NULL),(16441,3006,'2465819','834','00','005010X220A1','2465819','','2014-01-24','15:34:39',0,'2014-01-24 21:00:07',NULL,NULL),(1501,258,'1898271','834','00','005010X220A1','1898271','','2013-12-24','10:04:24',0,'2013-12-25 18:57:24',NULL,NULL),(5524,1041,'959930','834','00','005010X220A1','959930','','2013-12-24','21:58:30',0,'2013-12-26 01:47:08',NULL,NULL),(22921,4288,'3005965','834','00','005010X220A1','3005965','','2014-03-06','16:50:52',0,'2014-03-06 21:02:32',NULL,NULL),(12341,1634,'1392107','834','00','005010X220A1','1392107','','2013-12-31','11:53:09',1,'2014-01-02 04:27:35',NULL,NULL),(22903,4285,'2985814','834','00','005010X220A1','2985814','','2014-03-05','20:31:52',0,'2014-03-06 21:02:18',NULL,NULL),(6242,1169,'755331','834','00','005010X220A1','755331','','2013-12-20','15:11:44',0,'2013-12-26 03:05:39',NULL,NULL),(22800,4278,'3439051','834','00','005010X220A1','3439051','','2014-03-05','18:28:28',0,'2014-03-06 21:01:05',NULL,NULL),(22694,4260,'2628477','834','00','005010X220A1','2628477','','2014-03-05','10:05:08',0,'2014-03-05 21:32:24',NULL,NULL),(21895,4125,'3225118','834','00','005010X220A1','3225118','','2014-03-01','13:46:07',0,'2014-03-01 21:00:27',NULL,NULL),(7723,1339,'576097','834','00','005010X220A1','576097','','2013-11-15','12:37:52',0,'2013-12-26 04:46:16',NULL,NULL),(3246,578,'192705','834','00','005010X220A1','192705','','2013-12-17','16:14:49',0,'2013-12-25 21:46:43',NULL,NULL),(21744,4090,'2691730','834','00','005010X220A1','2691730','','2014-02-27','22:08:52',0,'2014-02-28 21:30:43',NULL,NULL),(21537,4039,'3675213','834','00','005010X220A1','3675213','','2014-02-27','16:19:31',0,'2014-02-28 06:31:38',NULL,NULL),(17305,3173,'2258495','834','00','005010X220A1','2258495','','2014-01-31','11:17:26',0,'2014-01-31 21:00:44',NULL,NULL),(12405,1637,'1563980','834','00','005010X220A1','1563980','','2013-12-31','14:30:11',1,'2014-01-02 04:29:48',NULL,NULL),(12433,1638,'1404609','834','00','005010X220A1','1404609','','2013-12-31','14:07:15',1,'2014-01-02 04:30:51',NULL,NULL),(13384,2221,'2010048','834','00','005010X220A1','2010048','','2014-01-06','08:38:32',0,'2014-01-07 04:00:18',NULL,NULL),(20249,3792,'2608503','834','00','005010X220A1','2608503','','2014-02-19','17:35:56',0,'2014-02-20 04:32:03',NULL,NULL),(18562,3453,'3008698','834','00','005010X220A1','3008698','','2014-02-09','22:54:55',0,'2014-02-10 21:30:37',NULL,NULL),(11237,1454,'1835326','834','00','005010X220A1','1835326','','2013-12-26','12:23:57',0,'2013-12-27 02:01:34',NULL,NULL),(18127,3333,'1870722','834','00','005010X220A1','1870722','','2014-02-06','15:26:19',0,'2014-02-06 21:01:35',NULL,NULL),(10382,1400,'667763','834','00','005010X220A1','667763','','2013-12-22','21:53:45',0,'2013-12-26 12:50:09',NULL,NULL),(10597,1402,'1406423','834','00','005010X220A1','1406423','','2013-12-23','12:47:23',0,'2013-12-26 12:57:05',NULL,NULL),(12295,1626,'2520687','834','00','005010X220A1','2520687','','2014-01-01','10:41:47',1,'2014-01-02 04:25:07',NULL,NULL),(13261,2105,'0001','999','BE','005010X231A1','258154','834','2013-12-28','04:55:00',0,'2014-01-05 17:02:42',NULL,NULL),(16380,2986,'1545162','834','00','005010X220A1','1545162','','2014-01-23','15:44:54',0,'2014-01-23 21:01:09',NULL,NULL),(14936,2561,'2597580','834','00','005010X220A1','2597580','','2014-01-14','11:07:01',0,'2014-01-15 02:07:46',NULL,NULL),(23690,4450,'3908190','834','00','005010X220A1','3908190','','2014-03-09','23:16:17',0,'2014-03-10 21:02:21',NULL,NULL),(22503,4247,'3417359','834','00','005010X220A1','3417359','','2014-03-04','20:33:43',0,'2014-03-05 21:30:08',NULL,NULL),(326,72,'773121','834','00','005010X220A1','773121','','2013-12-03','20:02:33',0,'2013-12-25 17:46:02',NULL,NULL),(20325,3795,'2873065','834','00','005010X220A1','2873065','','2014-02-19','17:47:13',0,'2014-02-20 04:49:04',NULL,NULL),(11736,1520,'2313662','834','00','005010X220A1','2313662','','2013-12-28','00:37:34',1,'2013-12-29 11:09:00',NULL,NULL),(19721,3672,'2306164','834','00','005010X220A1','2306164','','2014-02-15','12:57:36',0,'2014-02-15 22:00:23',NULL,NULL),(2605,484,'738027','834','00','005010X220A1','738027','','2013-10-06','09:54:01',0,'2013-12-25 20:46:08',NULL,NULL),(5025,935,'27319','834','00','005010X220A1','27319','','2013-12-11','12:13:24',0,'2013-12-26 00:46:45',NULL,NULL),(19173,3561,'2942586','834','00','005010X220A1','2942586','','2014-02-12','12:30:05',0,'2014-02-12 21:32:27',NULL,NULL),(5718,1069,'1101309','834','00','005010X220A1','1101309','','2013-12-14','11:51:10',0,'2013-12-26 02:00:59',NULL,NULL),(18609,3456,'3019228','834','00','005010X220A1','3019228','','2014-02-10','14:23:06',0,'2014-02-10 21:31:10',NULL,NULL),(17209,3151,'2012813','834','00','005010X220A1','2012813','','2014-01-30','09:58:37',0,'2014-01-30 21:01:15',NULL,NULL),(13865,2311,'1752772','834','00','005010X220A1','1752772','','2014-01-09','11:19:05',0,'2014-01-13 02:19:22',NULL,NULL),(14386,2413,'2146999','834','00','005010X220A1','2146999','','2014-01-12','13:40:24',0,'2014-01-13 03:01:52',NULL,NULL),(23538,4435,'3843574','834','00','005010X220A1','3843574','','2014-03-10','10:06:20',0,'2014-03-10 21:00:30',NULL,NULL),(23561,4436,'3398217','834','00','005010X220A1','3398217','','2014-03-09','23:35:09',0,'2014-03-10 21:00:49',NULL,NULL),(386,75,'158699','834','00','005010X220A1','158699','','2013-12-03','21:04:04',0,'2013-12-25 17:47:55',NULL,NULL),(23475,4421,'3038466','834','00','005010X220A1','3038466','','2014-03-09','13:59:42',0,'2014-03-09 21:01:13',NULL,NULL),(2487,436,'119548','834','00','005010X220A1','119548','','2013-12-06','16:49:20',0,'2013-12-25 20:20:05',NULL,NULL),(21154,3997,'3412214','834','00','005010X220A1','3412214','','2014-02-26','11:56:17',0,'2014-02-26 21:00:45',NULL,NULL),(4961,930,'900502','834','00','005010X220A1','900502','','2013-10-06','20:53:40',0,'2013-12-26 00:32:12',NULL,NULL),(20192,3780,'3674991','834','00','005010X220A1','3674991','','2014-02-19','15:23:46',0,'2014-02-20 04:16:00',NULL,NULL),(4647,827,'520449','834','00','005010X220A1','520449','','2013-12-24','00:43:16',0,'2013-12-25 23:48:47',NULL,NULL),(4550,825,'1514378','834','00','005010X220A1','1514378','','2013-12-23','22:59:42',0,'2013-12-25 23:45:42',NULL,NULL),(19952,3742,'2357398','834','00','005010X220A1','2357398','','2014-02-18','14:49:08',0,'2014-02-18 21:30:20',NULL,NULL),(19233,3580,'3374501','834','00','005010X220A1','3374501','','2014-02-13','12:25:33',0,'2014-02-13 22:00:21',NULL,NULL),(12675,1673,'2347650','834','00','005010X220A1','2347650','','2014-01-02','00:19:24',0,'2014-01-03 02:03:51',NULL,NULL),(13460,2226,'2547501','834','00','005010X220A1','2547501','','2014-01-06','12:38:59',0,'2014-01-07 04:03:09',NULL,NULL),(19001,3538,'3112436','834','00','005010X220A1','3112436','','2014-02-12','12:02:39',0,'2014-02-12 21:30:26',NULL,NULL),(16551,3025,'1917325','834','00','005010X220A1','1917325','','2014-01-24','10:36:34',0,'2014-01-24 21:01:13',NULL,NULL),(215,27,'383216','834','00','005010X220A1','383216','','2013-12-05','08:24:22',0,'2013-12-25 17:21:46',NULL,NULL),(23360,4390,'2751289','834','00','005010X220A1','2751289','','2014-03-08','13:30:05',0,'2014-03-08 21:31:06',NULL,NULL),(20788,3908,'3286649','834','00','005010X220A1','3286649','','2014-02-25','11:12:41',0,'2014-02-25 21:30:47',NULL,NULL),(14544,2518,'2454043','834','00','005010X220A1','2454043','','2014-01-13','16:05:32',0,'2014-01-14 01:32:31',NULL,NULL),(14338,2400,'1613172','834','00','005010X220A1','1613172','','2014-01-12','17:30:44',0,'2014-01-13 03:01:17',NULL,NULL),(1033,197,'625092','834','00','005010X220A1','625092','','2013-12-02','23:22:58',0,'2013-12-25 18:21:18',NULL,NULL),(1756,293,'465041','834','00','005010X220A1','465041','','2013-12-10','16:56:39',0,'2013-12-25 19:18:09',NULL,NULL),(7078,1236,'579175','834','00','005010X220A1','579175','','2013-12-18','09:30:14',0,'2013-12-26 04:02:56',NULL,NULL),(17405,3198,'2251171','834','00','005010X220A1','2251171','','2014-02-01','12:35:01',0,'2014-02-01 19:00:12',NULL,NULL),(7623,1307,'441624','834','00','005010X220A1','441624','','2013-12-20','21:38:48',0,'2013-12-26 04:38:01',NULL,NULL),(2794,506,'506717','834','00','005010X220A1','506717','','2013-12-22','11:05:05',0,'2013-12-25 21:20:10',NULL,NULL),(10615,1402,'1267120','834','00','005010X220A1','1267120','','2013-12-23','14:37:31',0,'2013-12-26 12:57:41',NULL,NULL),(15997,2766,'2473907','834','00','005010X220A1','2473907','','2014-01-21','21:40:06',0,'2014-01-23 03:02:12',NULL,NULL),(5649,1049,'2053021','834','00','005010X220A1','2053021','','2013-12-25','12:57:16',0,'2013-12-26 01:51:16',NULL,NULL),(14424,2445,'0001','999','BE','005010X231A1','343366','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:35',NULL,NULL),(3040,544,'581797','834','00','005010X220A1','581797','','2013-12-13','10:55:16',0,'2013-12-25 21:34:18',NULL,NULL),(13842,2311,'2483876','834','00','005010X220A1','2483876','','2014-01-08','18:18:10',0,'2014-01-13 02:19:06',NULL,NULL),(21896,4126,'3818960','834','00','005010X220A1','3818960','','2014-02-28','18:41:48',0,'2014-03-01 21:00:28',NULL,NULL),(11777,1531,'1616611','834','00','005010X220A1','1616611','','2013-12-28','15:22:13',1,'2013-12-29 11:10:15',NULL,NULL),(21711,4088,'2653268','834','00','005010X220A1','2653268','','2014-02-28','10:49:45',0,'2014-02-28 21:30:22',NULL,NULL),(11273,1455,'187835','834','00','005010X220A1','187835','','2013-12-26','12:35:22',0,'2013-12-27 02:02:40',NULL,NULL),(20145,3775,'3641301','834','00','005010X220A1','3641301','','2014-02-18','20:59:49',0,'2014-02-20 04:02:36',NULL,NULL),(15558,2655,'2267293','834','00','005010X220A1','2267293','','2014-01-17','09:41:48',0,'2014-01-20 08:05:55',NULL,NULL),(2716,503,'111306','834','00','005010X220A1','111306','','2013-12-21','18:57:55',0,'2013-12-25 21:17:41',NULL,NULL),(5612,1044,'1809301','834','00','005010X220A1','1809301','','2013-12-24','22:20:57',0,'2013-12-26 01:50:02',NULL,NULL),(2902,539,'36732','834','00','005010X220A1','36732','','2013-12-13','17:08:10',0,'2013-12-25 21:30:02',NULL,NULL),(3487,615,'383427','834','00','005010X220A1','383427','','2013-12-12','10:56:07',0,'2013-12-25 22:00:45',NULL,NULL),(5147,943,'529644','834','00','005010X220A1','529644','','2013-12-11','15:09:00',0,'2013-12-26 00:50:43',NULL,NULL),(13691,2273,'2517189','834','00','005010X220A1','2517189','','2014-01-07','13:16:38',0,'2014-01-08 18:24:25',NULL,NULL),(23748,4472,'3662551','834','00','005010X220A1','3662551','','2014-03-10','11:12:20',0,'2014-03-10 21:30:00',NULL,NULL),(2235,372,'573900','834','00','005010X220A1','573900','','2013-12-02','15:13:52',0,'2013-12-25 19:49:22',NULL,NULL),(12374,1636,'1493625','834','00','005010X220A1','1493625','','2013-12-31','09:52:07',1,'2014-01-02 04:28:43',NULL,NULL),(12350,1634,'1503149','834','00','005010X220A1','1503149','','2013-12-31','13:31:25',1,'2014-01-02 04:27:54',NULL,NULL),(7704,1332,'123370','834','00','005010X220A1','123370','','2013-11-15','06:45:18',0,'2013-12-26 04:45:35',NULL,NULL),(10571,1402,'720109','834','00','005010X220A1','720109','','2013-12-23','10:13:01',0,'2013-12-26 12:56:14',NULL,NULL),(13026,1870,'0001','999','BE','005010X231A1','244976','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:14',NULL,NULL),(14197,2365,'2031683','834','00','005010X220A1','2031683','','2014-01-10','13:47:12',0,'2014-01-13 02:23:41',NULL,NULL),(14792,2551,'2161407','834','00','005010X220A1','2161407','','2014-01-14','16:41:10',0,'2014-01-15 02:06:42',NULL,NULL),(14946,2561,'2435099','834','00','005010X220A1','2435099','','2014-01-14','17:37:19',0,'2014-01-15 02:07:50',NULL,NULL),(15332,2622,'2544215','834','00','005010X220A1','2544215','','2014-01-16','17:04:10',0,'2014-01-17 03:35:15',NULL,NULL),(15900,2741,'2280910','834','00','005010X220A1','2280910','','2014-01-21','12:20:32',1,'2014-01-22 03:22:41',NULL,NULL),(16209,2901,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:01:00',1,'2014-01-23 05:01:58',NULL,NULL),(17718,3261,'2790976','834','00','005010X220A1','2790976','','2014-02-04','13:48:34',0,'2014-02-04 21:00:39',NULL,NULL),(18619,3457,'1909261','834','00','005010X220A1','1909261','','2014-02-10','09:30:27',0,'2014-02-10 21:31:17',NULL,NULL),(19455,3609,'2159194','834','00','005010X220A1','2159194','','2014-02-13','12:54:05',0,'2014-02-13 22:03:11',NULL,NULL),(19854,3699,'3175012','834','00','005010X220A1','3175012','','2014-02-15','16:20:43',0,'2014-02-15 22:02:10',NULL,NULL),(20869,3916,'3369523','834','00','005010X220A1','3369523','','2014-02-24','20:20:21',0,'2014-02-25 21:31:45',NULL,NULL),(21016,3965,'3143628','834','00','005010X220A1','3143628','','2014-02-21','23:55:38',0,'2014-02-26 08:30:52',NULL,NULL),(21919,4127,'2678724','834','00','005010X220A1','2678724','','2014-03-01','16:34:20',0,'2014-03-01 21:00:42',NULL,NULL),(22112,4177,'3381939','834','00','005010X220A1','3381939','','2014-03-03','11:26:27',0,'2014-03-03 21:30:29',NULL,NULL),(707,117,'229715','834','00','005010X220A1','229715','','2013-12-15','23:51:35',0,'2013-12-25 18:06:56',NULL,NULL),(12503,1642,'1489907','834','00','005010X220A1','1489907','','2013-12-31','13:05:11',1,'2014-01-02 04:33:29',NULL,NULL),(1057,207,'776342','834','00','005010X220A1','776342','','2013-11-28','21:23:34',0,'2013-12-25 18:30:30',NULL,NULL),(11289,1455,'2182407','834','00','005010X220A1','2182407','','2013-12-26','15:55:32',0,'2013-12-27 02:03:10',NULL,NULL),(10448,1400,'684271','834','00','005010X220A1','684271','','2013-12-23','13:05:09',0,'2013-12-26 12:52:14',NULL,NULL),(7577,1301,'1166574','834','00','005010X220A1','1166574','','2013-12-21','15:14:32',0,'2013-12-26 04:36:30',NULL,NULL),(5018,935,'679893','834','00','005010X220A1','679893','','2013-12-11','11:31:31',0,'2013-12-26 00:46:32',NULL,NULL),(15808,2726,'2606378','834','00','005010X220A1','2606378','','2014-01-20','13:02:06',0,'2014-01-21 08:46:53',NULL,NULL),(16488,3010,'2382880','834','00','005010X220A1','2382880','','2014-01-24','17:27:09',0,'2014-01-24 21:00:34',NULL,NULL),(19547,3626,'2861414','834','00','005010X220A1','2861414','','2014-02-13','20:03:23',0,'2014-02-14 21:30:59',NULL,NULL),(19626,3641,'2249073','834','00','005010X220A1','2249073','','2014-02-13','22:54:40',0,'2014-02-14 21:31:56',NULL,NULL),(20847,3911,'3533783','834','00','005010X220A1','3533783','','2014-02-25','14:19:09',0,'2014-02-25 21:31:29',NULL,NULL),(21415,4026,'3181797','834','00','005010X220A1','3181797','','2014-02-27','09:57:10',0,'2014-02-28 06:30:42',NULL,NULL),(22398,4212,'2672679','834','00','005010X220A1','2672679','','2014-03-04','17:34:33',0,'2014-03-04 21:02:18',NULL,NULL),(132,8,'1072833','834','00','005010X220A1','1072833','','2013-12-05','12:28:25',0,'2013-12-25 17:19:06',NULL,NULL),(12523,1644,'2374620','834','00','005010X220A1','2374620','','2013-12-30','21:07:31',1,'2014-01-02 04:34:10',NULL,NULL),(3570,617,'438408','834','00','005010X220A1','438408','','2013-12-11','22:52:40',0,'2013-12-25 22:03:26',NULL,NULL),(11740,1521,'2318956','834','00','005010X220A1','2318956','','2013-12-28','12:11:09',1,'2013-12-29 11:09:07',NULL,NULL),(3703,633,'45498','834','00','005010X220A1','45498','','2013-12-12','14:27:07',0,'2013-12-25 22:07:36',NULL,NULL),(4387,774,'283226','834','00','005010X220A1','283226','','2013-11-27','10:31:58',0,'2013-12-25 23:15:33',NULL,NULL),(5613,1044,'1837934','834','00','005010X220A1','1837934','','2013-12-24','22:59:01',0,'2013-12-26 01:50:04',NULL,NULL),(13814,2297,'1576967','834','00','005010X220A1','1576967','','2014-01-11','13:11:47',0,'2014-01-13 02:18:25',NULL,NULL),(15791,2720,'1617170','834','00','005010X220A1','1617170','','2014-01-20','09:33:34',0,'2014-01-21 08:46:43',NULL,NULL),(16658,3060,'2424570','834','00','005010X220A1','2424570','','2014-01-27','14:08:56',0,'2014-01-27 21:00:16',NULL,NULL),(17414,3200,'2472941','834','00','005010X220A1','2472941','','2014-01-31','19:00:53',0,'2014-02-01 19:00:18',NULL,NULL),(17642,3247,'2217154','834','00','005010X220A1','2217154','','2014-02-03','12:12:59',0,'2014-02-03 21:01:24',NULL,NULL),(19724,3672,'3121681','834','00','005010X220A1','3121681','','2014-02-15','14:44:10',0,'2014-02-15 22:00:24',NULL,NULL),(20808,3910,'2933525','834','00','005010X220A1','2933525','','2014-02-24','23:32:48',0,'2014-02-25 21:31:01',NULL,NULL),(17,1,'40212','834','00','005010X220A1','40212','','2013-12-05','13:29:01',0,'2013-12-25 17:15:31',NULL,NULL),(1870,324,'428892','834','00','005010X220A1','428892','','2013-12-09','16:04:12',0,'2013-12-25 19:30:51',NULL,NULL),(12217,1615,'1699126','834','00','005010X220A1','1699126','','2014-01-01','16:57:52',1,'2014-01-02 04:22:06',NULL,NULL),(11094,1424,'1631640','834','00','005010X220A1','1631640','','2013-12-23','13:41:35',0,'2013-12-26 13:13:53',NULL,NULL),(3783,656,'1150850','834','00','005010X220A1','1150850','','2013-12-08','11:50:56',0,'2013-12-25 22:15:45',NULL,NULL),(825,168,'1202248','834','00','005010X220A1','1202248','','2013-10-19','14:25:47',0,'2013-12-25 18:11:07',NULL,NULL),(21581,4056,'3560425','834','00','005010X220A1','3560425','','2014-02-26','11:43:01',0,'2014-02-28 07:00:22',NULL,NULL),(1158,239,'1760144','834','00','005010X220A1','1760144','','2013-12-24','11:55:50',0,'2013-12-25 18:46:26',NULL,NULL),(6377,1184,'305749','834','00','005010X220A1','305749','','2013-12-20','07:36:49',0,'2013-12-26 03:09:47',NULL,NULL),(1263,243,'182906','834','00','005010X220A1','182906','','2013-12-24','14:11:03',0,'2013-12-25 18:49:36',NULL,NULL),(5164,945,'52080','834','00','005010X220A1','52080','','2013-12-10','19:08:39',0,'2013-12-26 00:51:13',NULL,NULL),(21483,4028,'3265328','834','00','005010X220A1','3265328','','2014-02-27','16:04:47',0,'2014-02-28 06:31:14',NULL,NULL),(20180,3777,'3243063','834','00','005010X220A1','3243063','','2014-02-19','16:50:12',0,'2014-02-20 04:12:54',NULL,NULL),(11333,1456,'1586498','834','00','005010X220A1','1586498','','2013-12-26','15:45:26',0,'2013-12-27 02:04:30',NULL,NULL),(11619,1494,'1747511','834','00','005010X220A1','1747511','','2013-12-27','12:46:12',0,'2013-12-28 03:35:18',NULL,NULL),(12639,1672,'2213881','834','00','005010X220A1','2213881','','2014-01-02','14:38:31',0,'2014-01-03 02:02:28',NULL,NULL),(19061,3542,'3167174','834','00','005010X220A1','3167174','','2014-02-12','13:55:42',0,'2014-02-12 21:31:09',NULL,NULL),(16022,2768,'2377755','834','00','005010X220A1','2377755','','2014-01-21','20:00:42',0,'2014-01-23 03:02:23',NULL,NULL),(20399,3832,'2922716','834','00','005010X220A1','2922716','','2014-02-20','11:15:54',0,'2014-02-20 21:30:06',NULL,NULL),(1660,289,'432636','834','00','005010X220A1','432636','','2013-12-10','14:25:52',0,'2013-12-25 19:15:14',NULL,NULL),(5956,1116,'137665','834','00','005010X220A1','137665','','2013-12-15','14:46:50',0,'2013-12-26 02:32:31',NULL,NULL),(18863,3493,'1638931','834','00','005010X220A1','1638931','','2014-02-11','09:10:22',0,'2014-02-11 21:02:04',NULL,NULL),(22321,4201,'3699235','834','00','005010X220A1','3699235','','2014-03-04','17:59:45',0,'2014-03-04 21:01:13',NULL,NULL),(23025,4325,'3546536','834','00','005010X220A1','3546536','','2014-03-07','14:55:35',0,'2014-03-07 21:00:22',NULL,NULL),(2332,412,'444525','834','00','005010X220A1','444525','','2013-12-05','19:02:54',0,'2013-12-25 20:15:03',NULL,NULL),(3611,619,'914276','834','00','005010X220A1','914276','','2013-12-12','16:52:23',0,'2013-12-25 22:04:41',NULL,NULL),(10894,1409,'1397983','834','00','005010X220A1','1397983','','2013-12-22','23:49:05',0,'2013-12-26 13:07:26',NULL,NULL),(21129,3994,'2538419','834','00','005010X220A1','2538419','','2014-02-26','17:23:26',0,'2014-02-26 21:00:29',NULL,NULL),(19042,3540,'2222452','834','00','005010X220A1','2222452','','2014-02-12','12:25:17',0,'2014-02-12 21:30:55',NULL,NULL),(16964,3116,'2158775','834','00','005010X220A1','2158775','','2014-01-29','11:44:29',0,'2014-01-29 21:00:32',NULL,NULL),(12627,1671,'2356283','834','00','005010X220A1','2356283','','2014-01-02','17:00:24',0,'2014-01-03 02:02:01',NULL,NULL),(13407,2222,'2111667','834','00','005010X220A1','2111667','','2014-01-06','18:07:02',0,'2014-01-07 04:01:08',NULL,NULL),(15447,2630,'1882996','834','00','005010X220A1','1882996','','2014-01-16','12:05:44',0,'2014-01-17 03:36:08',NULL,NULL),(16305,2980,'2237073','834','00','005010X220A1','2237073','','2014-01-23','09:28:03',0,'2014-01-23 21:00:16',NULL,NULL),(16961,3116,'2048981','834','00','005010X220A1','2048981','','2014-01-29','10:16:21',0,'2014-01-29 21:00:30',NULL,NULL),(23558,4436,'2809541','834','00','005010X220A1','2809541','','2014-03-09','21:33:06',0,'2014-03-10 21:00:47',NULL,NULL),(22110,4177,'3750074','834','00','005010X220A1','3750074','','2014-03-02','20:53:39',0,'2014-03-03 21:30:27',NULL,NULL),(2776,506,'450117','834','00','005010X220A1','450117','','2013-12-21','22:04:57',0,'2013-12-25 21:19:32',NULL,NULL),(18031,3318,'2043776','834','00','005010X220A1','2043776','','2014-02-06','16:49:22',0,'2014-02-06 21:00:29',NULL,NULL),(17746,3262,'2571361','834','00','005010X220A1','2571361','','2014-02-04','11:01:35',0,'2014-02-04 21:00:58',NULL,NULL),(17461,3214,'2593173','834','00','005010X220A1','2593173','','2014-02-01','14:58:00',0,'2014-02-01 19:00:50',NULL,NULL),(17253,3170,'2486903','834','00','005010X220A1','2486903','','2014-01-30','21:01:06',0,'2014-01-31 21:00:09',NULL,NULL),(17082,3133,'1921017','834','00','005010X220A1','1921017','','2014-01-29','13:07:57',0,'2014-01-29 21:01:47',NULL,NULL),(4539,825,'1537720','834','00','005010X220A1','1537720','','2013-12-23','21:02:25',0,'2013-12-25 23:45:19',NULL,NULL),(13170,2014,'0001','999','BE','005010X231A1','935224','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:29',NULL,NULL),(5421,1025,'341628','834','00','005010X220A1','341628','','2013-11-14','17:27:22',0,'2013-12-26 01:30:59',NULL,NULL),(22829,4278,'3285677','834','00','005010X220A1','3285677','','2014-03-06','15:41:29',0,'2014-03-06 21:01:24',NULL,NULL),(1182,239,'1710137','834','00','005010X220A1','1710137','','2013-12-24','15:08:46',0,'2013-12-25 18:47:11',NULL,NULL),(18398,3411,'2002298','834','00','005010X220A1','2002298','','2014-02-09','15:56:31',0,'2014-02-09 19:00:34',NULL,NULL),(2495,442,'782362','834','00','005010X220A1','782362','','2013-12-06','13:05:35',0,'2013-12-25 20:20:22',NULL,NULL),(2611,487,'947269','834','00','005010X220A1','947269','','2013-10-05','18:02:27',0,'2013-12-25 20:46:20',NULL,NULL),(15898,2741,'2595248','834','00','005010X220A1','2595248','','2014-01-21','11:32:35',1,'2014-01-22 03:22:39',NULL,NULL),(13796,2294,'1430284','834','00','005010X220A1','1430284','','2014-01-11','11:36:12',0,'2014-01-13 02:18:12',NULL,NULL),(5389,1012,'416317','834','00','005010X220A1','416317','','2013-11-25','15:47:10',0,'2013-12-26 01:17:09',NULL,NULL),(11319,1456,'2121363','834','00','005010X220A1','2121363','','2013-12-26','13:00:26',0,'2013-12-27 02:04:04',NULL,NULL),(12597,1671,'1878852','834','00','005010X220A1','1878852','','2014-01-02','12:41:16',0,'2014-01-03 02:00:59',NULL,NULL),(1685,291,'755994','834','00','005010X220A1','755994','','2013-12-09','20:33:38',0,'2013-12-25 19:16:00',NULL,NULL),(13788,2293,'2443953','834','00','005010X220A1','2443953','','2014-01-11','14:38:39',0,'2014-01-13 02:18:06',NULL,NULL),(13492,2227,'1605470','834','00','005010X220A1','1605470','','2014-01-06','15:00:05',0,'2014-01-07 04:04:18',NULL,NULL),(11938,1574,'1707583','834','00','005010X220A1','1707583','','2013-12-29','12:02:48',0,'2013-12-30 00:02:14',NULL,NULL),(5701,1067,'175013','834','00','005010X220A1','175013','','2013-12-14','14:49:48',0,'2013-12-26 02:00:28',NULL,NULL),(5311,991,'1008655','834','00','005010X220A1','1008655','','2013-11-05','14:25:40',0,'2013-12-26 01:01:50',NULL,NULL),(4124,733,'407028','834','00','005010X220A1','407028','','2013-12-19','14:16:30',0,'2013-12-25 23:03:56',NULL,NULL),(4463,801,'349962','834','00','005010X220A1','349962','','2013-11-26','17:18:51',0,'2013-12-25 23:30:50',NULL,NULL),(5619,1044,'1766531','834','00','005010X220A1','1766531','','2013-12-25','15:30:09',0,'2013-12-26 01:50:20',NULL,NULL),(22720,4272,'3645862','834','00','005010X220A1','3645862','','2014-03-05','16:41:49',0,'2014-03-05 21:32:43',NULL,NULL),(22048,4166,'3662262','834','00','005010X220A1','3662262','','2014-03-03','10:46:02',0,'2014-03-03 21:00:09',NULL,NULL),(21944,4132,'3565523','834','00','005010X220A1','3565523','','2014-03-01','16:21:24',0,'2014-03-01 21:01:01',NULL,NULL),(19305,3583,'2419830','834','00','005010X220A1','2419830','','2014-02-12','20:05:33',0,'2014-02-13 22:01:17',NULL,NULL),(6247,1171,'721434','834','00','005010X220A1','721434','','2013-12-19','20:07:08',0,'2013-12-26 03:05:50',NULL,NULL),(18397,3411,'2494463','834','00','005010X220A1','2494463','','2014-02-09','14:45:38',0,'2014-02-09 19:00:33',NULL,NULL),(2240,372,'978875','834','00','005010X220A1','978875','','2013-12-02','16:27:18',0,'2013-12-25 19:49:34',NULL,NULL),(18166,3350,'2964957','834','00','005010X220A1','2964957','','2014-02-07','15:21:54',0,'2014-02-07 19:00:12',NULL,NULL),(14767,2551,'2059981','834','00','005010X220A1','2059981','','2014-01-14','11:04:44',0,'2014-01-15 02:06:31',NULL,NULL),(22483,4242,'2875877','834','00','005010X220A1','2875877','','2014-03-05','12:10:24',0,'2014-03-05 21:00:25',NULL,NULL),(23701,4451,'3270594','834','00','005010X220A1','3270594','','2014-03-10','15:02:59',0,'2014-03-10 21:02:28',NULL,NULL),(418,77,'163334','834','00','005010X220A1','163334','','2013-12-03','23:19:21',0,'2013-12-25 17:48:58',NULL,NULL),(21173,3998,'3604239','834','00','005010X220A1','3604239','','2014-02-26','10:40:39',0,'2014-02-26 21:00:59',NULL,NULL),(20303,3796,'2879706','834','00','005010X220A1','2879706','','2014-02-19','11:52:37',0,'2014-02-20 04:44:00',NULL,NULL),(19401,3593,'3287554','834','00','005010X220A1','3287554','','2014-02-13','12:32:10',0,'2014-02-13 22:02:30',NULL,NULL),(19156,3555,'3013862','834','00','005010X220A1','3013862','','2014-02-12','13:59:37',0,'2014-02-12 21:32:15',NULL,NULL),(13732,2275,'2268036','834','00','005010X220A1','2268036','','2014-01-07','13:23:00',0,'2014-01-08 18:24:43',NULL,NULL),(23163,4344,'3064711','834','00','005010X220A1','3064711','','2014-03-07','11:32:45',0,'2014-03-07 21:31:19',NULL,NULL),(1742,293,'599681','834','00','005010X220A1','599681','','2013-12-10','13:55:33',0,'2013-12-25 19:17:44',NULL,NULL),(11109,1426,'1245963','834','00','005010X220A1','1245963','','2013-12-22','23:53:32',0,'2013-12-26 13:14:23',NULL,NULL),(17254,3170,'2042577','834','00','005010X220A1','2042577','','2014-01-30','21:07:07',0,'2014-01-31 21:00:10',NULL,NULL),(12816,1704,'1933470','834','00','005010X220A1','1933470','','2014-01-02','20:53:11',0,'2014-01-04 02:01:51',NULL,NULL),(7260,1247,'724077','834','00','005010X220A1','724077','','2013-12-17','21:30:16',0,'2013-12-26 04:08:29',NULL,NULL),(7113,1236,'1113341','834','00','005010X220A1','1113341','','2013-12-18','14:30:44',0,'2013-12-26 04:03:59',NULL,NULL),(5627,1046,'1290833','834','00','005010X220A1','1290833','','2013-12-24','19:42:16',0,'2013-12-26 01:50:36',NULL,NULL),(3327,586,'1153870','834','00','005010X220A1','1153870','','2013-12-17','05:02:37',0,'2013-12-25 21:49:25',NULL,NULL),(13378,2221,'1734242','834','00','005010X220A1','1734242','','2014-01-06','12:37:14',0,'2014-01-07 04:00:04',NULL,NULL),(10709,1403,'1353717','834','00','005010X220A1','1353717','','2013-12-23','11:34:54',0,'2013-12-26 13:00:50',NULL,NULL),(11989,1580,'1958776','834','00','005010X220A1','1958776','','2013-12-30','17:58:25',0,'2014-01-01 12:01:40',NULL,NULL),(3139,552,'1256633','834','00','005010X220A1','1256633','','2013-12-13','14:07:17',0,'2013-12-25 21:37:22',NULL,NULL),(3978,719,'902118','834','00','005010X220A1','902118','','2013-12-07','10:24:56',0,'2013-12-25 22:47:29',NULL,NULL),(1147,239,'61314','834','00','005010X220A1','61314','','2013-12-24','10:00:53',0,'2013-12-25 18:46:06',NULL,NULL),(4577,826,'10911','834','00','005010X220A1','10911','','2013-12-23','22:09:36',0,'2013-12-25 23:46:32',NULL,NULL),(155,10,'325554','834','00','005010X220A1','325554','','2013-12-05','14:59:20',0,'2013-12-25 17:19:48',NULL,NULL),(11538,1491,'147136','834','00','005010X220A1','147136','','2013-12-26','18:37:43',0,'2013-12-28 03:32:46',NULL,NULL),(11506,1490,'1364983','834','00','005010X220A1','1364983','','2013-12-26','18:32:22',0,'2013-12-28 03:31:51',NULL,NULL),(22223,4191,'3568093','834','00','005010X220A1','3568093','','2014-03-03','11:53:31',0,'2014-03-03 21:31:49',NULL,NULL),(21081,3982,'2737580','834','00','005010X220A1','2737580','','2014-02-24','07:14:31',0,'2014-02-26 09:30:49',NULL,NULL),(4150,733,'352889','834','00','005010X220A1','352889','','2013-12-19','18:28:56',0,'2013-12-25 23:04:40',NULL,NULL),(3507,615,'315403','834','00','005010X220A1','315403','','2013-12-12','15:11:53',0,'2013-12-25 22:01:26',NULL,NULL),(4923,910,'1150419','834','00','005010X220A1','1150419','','2013-10-16','20:29:23',0,'2013-12-26 00:30:54',NULL,NULL),(20907,3930,'3275140','834','00','005010X220A1','3275140','','2014-02-23','12:51:21',0,'2014-02-26 08:00:07',NULL,NULL),(7321,1269,'339590','834','00','005010X220A1','339590','','2013-12-18','12:35:40',0,'2013-12-26 04:10:20',NULL,NULL),(20676,3881,'3066659','834','00','005010X220A1','3066659','','2014-02-21','14:40:37',0,'2014-02-21 22:01:10',NULL,NULL),(12031,1583,'1666145','834','00','005010X220A1','1666145','','2013-12-30','14:31:51',0,'2014-01-01 12:03:16',NULL,NULL),(12547,1655,'1533274','834','00','005010X220A1','1533274','','2013-12-31','11:31:28',1,'2014-01-02 04:35:09',NULL,NULL),(19293,3582,'2375694','834','00','005010X220A1','2375694','','2014-02-13','15:40:25',0,'2014-02-13 22:01:07',NULL,NULL),(18963,3534,'2374428','834','00','005010X220A1','2374428','','2014-02-12','17:22:46',0,'2014-02-12 21:00:14',NULL,NULL),(18735,3485,'1751136','834','00','005010X220A1','1751136','','2014-02-11','11:12:38',0,'2014-02-11 21:00:27',NULL,NULL),(21993,4145,'3471614','834','00','005010X220A1','3471614','','2014-03-02','17:02:44',0,'2014-03-03 01:00:19',NULL,NULL),(16490,3010,'2436552','834','00','005010X220A1','2436552','','2014-01-24','10:11:22',0,'2014-01-24 21:00:35',NULL,NULL),(3083,545,'699915','834','00','005010X220A1','699915','','2013-12-13','15:05:42',0,'2013-12-25 21:35:41',NULL,NULL),(2573,472,'358852','834','00','005010X220A1','358852','','2013-10-31','18:56:28',0,'2013-12-25 20:45:05',NULL,NULL),(23598,4438,'3757778','834','00','005010X220A1','3757778','','2014-03-09','18:58:47',0,'2014-03-10 21:01:15',NULL,NULL),(23606,4440,'2930621','834','00','005010X220A1','2930621','','2014-03-10','12:32:42',0,'2014-03-10 21:01:21',NULL,NULL),(17383,3191,'2157597','834','00','005010X220A1','2157597','','2014-01-31','13:57:15',0,'2014-01-31 21:01:40',NULL,NULL),(2977,541,'707404','834','00','005010X220A1','707404','','2013-12-13','16:28:53',0,'2013-12-25 21:32:26',NULL,NULL),(16504,3011,'1423056','834','00','005010X220A1','1423056','','2014-01-24','10:04:56',0,'2014-01-24 21:00:43',NULL,NULL),(3406,590,'1242128','834','00','005010X220A1','1242128','','2013-12-17','10:57:57',0,'2013-12-25 21:51:51',NULL,NULL),(6456,1213,'551050','834','00','005010X220A1','551050','','2013-11-22','09:46:09',0,'2013-12-26 03:16:20',NULL,NULL),(6323,1175,'584525','834','00','005010X220A1','584525','','2013-12-20','15:01:25',0,'2013-12-26 03:08:05',NULL,NULL),(3621,621,'192499','834','00','005010X220A1','192499','','2013-12-12','14:09:02',0,'2013-12-25 22:05:00',NULL,NULL),(12382,1637,'2308778','834','00','005010X220A1','2308778','','2013-12-30','22:59:58',1,'2014-01-02 04:29:02',NULL,NULL),(14574,2520,'1393574','834','00','005010X220A1','1393574','','2014-01-13','12:19:18',0,'2014-01-14 01:32:50',NULL,NULL),(13821,2298,'1570615','834','00','005010X220A1','1570615','','2014-01-11','14:35:23',0,'2014-01-13 02:18:29',NULL,NULL),(23222,4353,'3565725','834','00','005010X220A1','3565725','','2014-03-06','21:19:34',0,'2014-03-07 21:32:01',NULL,NULL),(21553,4047,'3811407','834','00','005010X220A1','3811407','','2014-02-27','13:28:40',0,'2014-02-28 06:31:46',NULL,NULL),(17167,3145,'2585199','834','00','005010X220A1','2585199','','2014-01-30','12:17:41',0,'2014-01-30 21:00:48',NULL,NULL),(13062,1906,'0001','999','BE','005010X231A1','306736','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:53',NULL,NULL),(12731,1683,'1370326','834','00','005010X220A1','1370326','','2014-01-02','14:59:15',0,'2014-01-03 02:05:59',NULL,NULL),(3734,641,'242222','834','00','005010X220A1','242222','','2013-12-12','11:11:50',0,'2013-12-25 22:08:41',NULL,NULL),(5230,955,'471400','834','00','005010X220A1','471400','','2013-12-11','11:03:46',0,'2013-12-26 00:53:24',NULL,NULL),(438,80,'518338','834','00','005010X220A1','518338','','2013-12-04','08:12:18',0,'2013-12-25 17:49:35',NULL,NULL),(12024,1583,'2478801','834','00','005010X220A1','2478801','','2013-12-30','13:03:21',0,'2014-01-01 12:02:58',NULL,NULL),(4571,826,'1508003','834','00','005010X220A1','1508003','','2013-12-23','21:28:11',0,'2013-12-25 23:46:21',NULL,NULL),(3495,615,'1015162','834','00','005010X220A1','1015162','','2013-12-12','13:36:09',0,'2013-12-25 22:01:02',NULL,NULL),(6417,1202,'328555','834','00','005010X220A1','328555','','2013-11-22','18:05:21',0,'2013-12-26 03:15:02',NULL,NULL),(21688,4086,'2979376','834','00','005010X220A1','2979376','','2014-02-28','17:42:55',0,'2014-02-28 21:00:27',NULL,NULL),(20916,3932,'3390717','834','00','005010X220A1','3390717','','2014-02-23','13:36:41',0,'2014-02-26 08:00:14',NULL,NULL),(19303,3583,'3065159','834','00','005010X220A1','3065159','','2014-02-12','19:46:20',0,'2014-02-13 22:01:16',NULL,NULL),(13874,2311,'2418979','834','00','005010X220A1','2418979','','2014-01-09','17:27:30',0,'2014-01-13 02:19:28',NULL,NULL),(924,179,'530661','834','00','005010X220A1','530661','','2013-12-03','13:47:10',0,'2013-12-25 18:17:51',NULL,NULL),(830,173,'206067','834','00','005010X220A1','206067','','2013-12-02','18:21:11',0,'2013-12-25 18:15:02',NULL,NULL),(23519,4434,'3589728','834','00','005010X220A1','3589728','','2014-03-10','15:23:12',0,'2014-03-10 21:00:16',NULL,NULL),(22306,4201,'3231399','834','00','005010X220A1','3231399','','2014-03-04','12:26:27',0,'2014-03-04 21:01:03',NULL,NULL),(21258,3999,'3372132','834','00','005010X220A1','3372132','','2014-02-26','17:21:52',0,'2014-02-26 21:01:53',NULL,NULL),(1565,276,'566697','834','00','005010X220A1','566697','','2013-11-20','09:30:14',0,'2013-12-25 19:00:06',NULL,NULL),(7463,1296,'1198217','834','00','005010X220A1','1198217','','2013-12-21','11:03:28',0,'2013-12-26 04:32:45',NULL,NULL),(11527,1490,'1826600','834','00','005010X220A1','1826600','','2013-12-27','13:27:20',0,'2013-12-28 03:32:27',NULL,NULL),(7198,1239,'846119','834','00','005010X220A1','846119','','2013-12-18','17:00:45',0,'2013-12-26 04:06:33',NULL,NULL),(5913,1112,'974491','834','00','005010X220A1','974491','','2013-12-14','22:11:39',0,'2013-12-26 02:31:12',NULL,NULL),(20265,3796,'2402660','834','00','005010X220A1','2402660','','2014-02-18','22:31:44',0,'2014-02-20 04:34:48',NULL,NULL),(20017,3750,'2097387','834','00','005010X220A1','2097387','','2014-02-18','10:13:23',0,'2014-02-18 22:00:45',NULL,NULL),(18991,3537,'2484715','834','00','005010X220A1','2484715','','2014-02-12','18:15:28',0,'2014-02-12 21:30:20',NULL,NULL),(4648,827,'830072','834','00','005010X220A1','830072','','2013-12-24','00:49:38',0,'2013-12-25 23:48:49',NULL,NULL),(11634,1497,'1863146','834','00','005010X220A1','1863146','','2013-12-27','14:15:36',0,'2013-12-28 03:35:47',NULL,NULL),(18691,3474,'2413603','834','00','005010X220A1','2413603','','2014-02-10','14:57:22',0,'2014-02-10 21:32:07',NULL,NULL),(18151,3347,'1905602','834','00','005010X220A1','1905602','','2014-02-06','18:04:29',0,'2014-02-06 21:30:04',NULL,NULL),(1384,245,'1181303','834','00','005010X220A1','1181303','','2013-12-24','17:01:06',0,'2013-12-25 18:53:30',NULL,NULL),(11409,1467,'1117604','834','00','005010X220A1','1117604','','2013-12-26','10:34:59',0,'2013-12-27 02:06:51',NULL,NULL),(19653,3649,'2827556','834','00','005010X220A1','2827556','','2014-02-14','13:54:34',0,'2014-02-14 21:32:17',NULL,NULL),(4631,827,'564122','834','00','005010X220A1','564122','','2013-12-23','23:18:09',0,'2013-12-25 23:48:17',NULL,NULL),(23396,4403,'3872828','834','00','005010X220A1','3872828','','2014-03-08','23:09:20',0,'2014-03-09 21:00:08',NULL,NULL),(23655,4442,'3064798','834','00','005010X220A1','3064798','','2014-03-10','12:17:22',0,'2014-03-10 21:01:55',NULL,NULL),(540,103,'740997','834','00','005010X220A1','740997','','2013-12-15','18:12:47',0,'2013-12-25 18:01:42',NULL,NULL),(3324,586,'531084','834','00','005010X220A1','531084','','2013-12-16','19:31:20',0,'2013-12-25 21:49:20',NULL,NULL),(4649,827,'1454534','834','00','005010X220A1','1454534','','2013-12-24','00:56:54',0,'2013-12-25 23:48:51',NULL,NULL),(22715,4269,'3207037','834','00','005010X220A1','3207037','','2014-03-05','13:07:14',0,'2014-03-05 21:32:39',NULL,NULL),(7028,1235,'1012754','834','00','005010X220A1','1012754','','2013-12-18','12:42:03',0,'2013-12-26 04:01:21',NULL,NULL),(21024,3973,'3521392','834','00','005010X220A1','3521392','','2014-02-23','18:52:27',0,'2014-02-26 09:30:03',NULL,NULL),(19309,3583,'3011235','834','00','005010X220A1','3011235','','2014-02-12','21:12:45',0,'2014-02-13 22:01:20',NULL,NULL),(17582,3237,'2246425','834','00','005010X220A1','2246425','','2014-02-03','12:22:25',0,'2014-02-03 21:00:46',NULL,NULL),(15688,2697,'1993613','834','00','005010X220A1','1993613','','2014-01-19','16:16:34',0,'2014-01-21 08:45:18',NULL,NULL),(15983,2764,'1393859','834','00','005010X220A1','1393859','','2014-01-22','12:55:00',0,'2014-01-23 03:02:05',NULL,NULL),(22907,4286,'3744758','834','00','005010X220A1','3744758','','2014-03-05','20:34:38',0,'2014-03-06 21:02:21',NULL,NULL),(22523,4247,'3728546','834','00','005010X220A1','3728546','','2014-03-05','13:28:00',0,'2014-03-05 21:30:23',NULL,NULL),(4726,843,'1804160','834','00','005010X220A1','1804160','','2013-12-23','23:07:25',0,'2013-12-25 23:51:35',NULL,NULL),(1747,293,'1144377','834','00','005010X220A1','1144377','','2013-12-10','15:23:01',0,'2013-12-25 19:17:53',NULL,NULL),(13860,2311,'2590037','834','00','005010X220A1','2590037','','2014-01-08','19:38:10',0,'2014-01-13 02:19:19',NULL,NULL),(14008,2337,'2331257','834','00','005010X220A1','2331257','','2014-01-07','19:30:14',0,'2014-01-13 02:21:10',NULL,NULL),(14902,2558,'1801095','834','00','005010X220A1','1801095','','2014-01-14','12:21:18',0,'2014-01-15 02:07:30',NULL,NULL),(15355,2623,'1864930','834','00','005010X220A1','1864930','','2014-01-16','10:38:48',0,'2014-01-17 03:35:25',NULL,NULL),(15998,2766,'2371703','834','00','005010X220A1','2371703','','2014-01-22','09:36:53',0,'2014-01-23 03:02:12',NULL,NULL),(21031,3974,'2817101','834','00','005010X220A1','2817101','','2014-02-24','17:18:03',0,'2014-02-26 09:30:09',NULL,NULL),(20056,3753,'3385407','834','00','005010X220A1','3385407','','2014-02-18','11:20:33',0,'2014-02-18 22:01:13',NULL,NULL),(11807,1539,'1352750','834','00','005010X220A1','1352750','','2013-12-28','20:10:11',1,'2013-12-29 11:13:17',NULL,NULL),(18879,3496,'3029033','834','00','005010X220A1','3029033','','2014-02-10','21:44:02',0,'2014-02-11 21:02:17',NULL,NULL),(18407,3415,'1611116','834','00','005010X220A1','1611116','','2014-02-09','13:14:46',0,'2014-02-09 19:00:41',NULL,NULL),(3003,542,'377595','834','00','005010X220A1','377595','','2013-12-13','16:34:48',0,'2013-12-25 21:33:12',NULL,NULL),(18203,3355,'1738418','834','00','005010X220A1','1738418','','2014-02-07','16:40:21',0,'2014-02-07 19:00:36',NULL,NULL),(10908,1409,'800078','834','00','005010X220A1','800078','','2013-12-23','17:22:04',0,'2013-12-26 13:07:54',NULL,NULL),(3122,547,'212857','834','00','005010X220A1','212857','','2013-12-13','16:57:29',0,'2013-12-25 21:36:50',NULL,NULL),(4849,884,'1149508','834','00','005010X220A1','1149508','','2013-11-21','15:37:20',0,'2013-12-26 00:15:34',NULL,NULL),(17471,3218,'2368413','834','00','005010X220A1','2368413','','2014-02-01','19:02:21',0,'2014-02-02 19:00:07',NULL,NULL),(17381,3190,'2061437','834','00','005010X220A1','2061437','','2014-01-31','13:50:46',0,'2014-01-31 21:01:39',NULL,NULL),(15894,2740,'1533840','834','00','005010X220A1','1533840','','2014-01-21','16:36:57',1,'2014-01-22 03:22:37',NULL,NULL),(16860,3093,'1992647','834','00','005010X220A1','1992647','','2014-01-28','11:11:48',0,'2014-01-28 21:00:47',NULL,NULL),(159,10,'457342','834','00','005010X220A1','457342','','2013-12-05','15:14:56',0,'2013-12-25 17:19:55',NULL,NULL),(22251,4200,'3770968','834','00','005010X220A1','3770968','','2014-03-03','21:08:15',0,'2014-03-04 21:00:20',NULL,NULL),(21968,4143,'3763094','834','00','005010X220A1','3763094','','2014-03-01','22:35:11',0,'2014-03-03 01:00:06',NULL,NULL),(11579,1492,'119094','834','00','005010X220A1','119094','','2013-12-27','16:10:02',0,'2013-12-28 03:34:06',NULL,NULL),(11577,1492,'1784657','834','00','005010X220A1','1784657','','2013-12-27','15:53:59',0,'2013-12-28 03:34:02',NULL,NULL),(18385,3407,'2723277','834','00','005010X220A1','2723277','','2014-02-09','16:33:30',0,'2014-02-09 19:00:24',NULL,NULL),(18117,3330,'2055362','834','00','005010X220A1','2055362','','2014-02-06','12:56:00',0,'2014-02-06 21:01:29',NULL,NULL),(16535,3020,'2395649','834','00','005010X220A1','2395649','','2014-01-24','16:26:07',0,'2014-01-24 21:01:04',NULL,NULL),(4027,731,'532449','834','00','005010X220A1','532449','','2013-12-19','14:01:29',0,'2013-12-25 23:00:56',NULL,NULL),(17551,3236,'2019582','834','00','005010X220A1','2019582','','2014-02-02','21:14:55',0,'2014-02-03 21:00:27',NULL,NULL),(7735,1342,'583638','834','00','005010X220A1','583638','','2013-10-21','07:31:51',0,'2013-12-26 05:00:21',NULL,NULL),(10691,1403,'619735','834','00','005010X220A1','619735','','2013-12-23','08:28:11',0,'2013-12-26 13:00:10',NULL,NULL),(12579,1670,'2172415','834','00','005010X220A1','2172415','','2014-01-02','16:35:12',0,'2014-01-03 02:00:20',NULL,NULL),(14233,2369,'1604177','834','00','005010X220A1','1604177','','2014-01-10','13:03:26',0,'2014-01-13 02:24:05',NULL,NULL),(14466,2487,'0001','999','BE','005010X231A1','159929','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:39',NULL,NULL),(15212,2593,'1646517','834','00','005010X220A1','1646517','','2014-01-14','20:22:14',0,'2014-01-16 08:46:32',NULL,NULL),(20773,3907,'2665751','834','00','005010X220A1','2665751','','2014-02-25','07:39:00',0,'2014-02-25 21:30:36',NULL,NULL),(22992,4322,'2921981','834','00','005010X220A1','2921981','','2014-03-06','18:41:57',0,'2014-03-07 21:00:08',NULL,NULL),(16076,2775,'1368012','834','00','005010X220A1','1368012','','2014-01-22','10:49:58',0,'2014-01-23 03:02:48',NULL,NULL),(17464,3215,'2141269','834','00','005010X220A1','2141269','','2014-02-01','16:38:06',0,'2014-02-01 19:00:52',NULL,NULL),(305,70,'1130737','834','00','005010X220A1','1130737','','2013-12-04','12:36:20',0,'2013-12-25 17:45:21',NULL,NULL),(19427,3600,'2378314','834','00','005010X220A1','2378314','','2014-02-13','10:46:57',0,'2014-02-13 22:02:50',NULL,NULL),(12459,1639,'1822143','834','00','005010X220A1','1822143','','2013-12-31','13:04:39',1,'2014-01-02 04:31:49',NULL,NULL),(12316,1634,'1544580','834','00','005010X220A1','1544580','','2013-12-30','18:42:33',1,'2014-01-02 04:26:40',NULL,NULL),(19208,3577,'2292030','834','00','005010X220A1','2292030','','2014-02-13','13:19:18',0,'2014-02-13 21:30:15',NULL,NULL),(14118,2348,'1771943','834','00','005010X220A1','1771943','','2014-01-07','22:05:08',0,'2014-01-13 02:22:22',NULL,NULL),(10942,1410,'363706','834','00','005010X220A1','363706','','2013-12-23','14:38:44',0,'2013-12-26 13:08:59',NULL,NULL),(2072,341,'350162','834','00','005010X220A1','350162','','2013-12-09','12:14:01',0,'2013-12-25 19:37:09',NULL,NULL),(19837,3684,'3428401','834','00','005010X220A1','3428401','','2014-02-15','12:50:52',0,'2014-02-15 22:01:54',NULL,NULL),(16987,3118,'1725570','834','00','005010X220A1','1725570','','2014-01-28','20:02:14',0,'2014-01-29 21:00:46',NULL,NULL),(7443,1296,'30604','834','00','005010X220A1','30604','','2013-12-20','19:36:47',0,'2013-12-26 04:32:13',NULL,NULL),(770,144,'1014630','834','00','005010X220A1','1014630','','2013-10-29','00:24:16',0,'2013-12-25 18:09:03',NULL,NULL),(22178,4180,'3011760','834','00','005010X220A1','3011760','','2014-03-03','15:44:30',0,'2014-03-03 21:31:15',NULL,NULL),(20406,3833,'2803314','834','00','005010X220A1','2803314','','2014-02-20','13:42:28',0,'2014-02-20 21:30:10',NULL,NULL),(10425,1400,'1645776','834','00','005010X220A1','1645776','','2013-12-23','10:35:38',0,'2013-12-26 12:51:27',NULL,NULL),(7355,1283,'240901','834','00','005010X220A1','240901','','2013-11-30','12:02:33',0,'2013-12-26 04:15:39',NULL,NULL),(17319,3174,'2492831','834','00','005010X220A1','2492831','','2014-01-31','12:57:35',0,'2014-01-31 21:00:54',NULL,NULL),(5945,1113,'261057','834','00','005010X220A1','261057','','2013-12-15','11:57:58',0,'2013-12-26 02:32:10',NULL,NULL),(15817,2733,'1792526','834','00','005010X220A1','1792526','','2014-01-20','16:15:16',0,'2014-01-21 08:46:58',NULL,NULL),(15634,2676,'1923358','834','00','005010X220A1','1923358','','2014-01-18','13:26:58',0,'2014-01-21 08:44:14',NULL,NULL),(15298,2619,'1624842','834','00','005010X220A1','1624842','','2014-01-14','18:58:32',0,'2014-01-16 08:47:29',NULL,NULL),(10526,1401,'957147','834','00','005010X220A1','957147','','2013-12-23','11:46:52',0,'2013-12-26 12:54:41',NULL,NULL),(21529,4038,'3532373','834','00','005010X220A1','3532373','','2014-02-27','09:54:13',0,'2014-02-28 06:31:35',NULL,NULL),(22473,4239,'3700712','834','00','005010X220A1','3700712','','2014-03-05','08:47:55',0,'2014-03-05 21:00:19',NULL,NULL),(23126,4342,'2921994','834','00','005010X220A1','2921994','','2014-03-07','10:50:23',0,'2014-03-07 21:30:54',NULL,NULL),(980,184,'456182','834','00','005010X220A1','456182','','2013-12-03','10:28:02',0,'2013-12-25 18:19:34',NULL,NULL),(19925,3731,'3136371','834','00','005010X220A1','3136371','','2014-02-17','14:41:03',0,'2014-02-17 19:00:16',NULL,NULL),(2080,343,'228177','834','00','005010X220A1','228177','','2013-12-09','14:15:07',0,'2013-12-25 19:37:24',NULL,NULL),(3559,616,'995554','834','00','005010X220A1','995554','','2013-12-12','17:02:54',0,'2013-12-25 22:03:06',NULL,NULL),(6049,1157,'106424','834','00','005010X220A1','106424','','2013-10-14','11:12:44',0,'2013-12-26 02:46:31',NULL,NULL),(19791,3677,'2946225','834','00','005010X220A1','2946225','','2014-02-15','08:40:21',0,'2014-02-15 22:01:15',NULL,NULL),(4255,741,'101827','834','00','005010X220A1','101827','','2013-12-19','09:56:20',0,'2013-12-25 23:07:58',NULL,NULL),(13924,2314,'2341627','834','00','005010X220A1','2341627','','2014-01-08','22:55:40',0,'2014-01-13 02:20:00',NULL,NULL),(13689,2273,'1676364','834','00','005010X220A1','1676364','','2014-01-07','12:50:43',0,'2014-01-08 18:24:25',NULL,NULL),(21912,4127,'2912971','834','00','005010X220A1','2912971','','2014-03-01','14:26:49',0,'2014-03-01 21:00:38',NULL,NULL),(258,47,'716487','834','00','005010X220A1','716487','','2013-11-13','17:25:55',0,'2013-12-25 17:31:08',NULL,NULL),(18138,3339,'2161978','834','00','005010X220A1','2161978','','2014-02-06','10:18:14',0,'2014-02-06 21:01:45',NULL,NULL),(5024,935,'750466','834','00','005010X220A1','750466','','2013-12-11','12:11:13',0,'2013-12-26 00:46:44',NULL,NULL),(3445,605,'177610','834','00','005010X220A1','177610','','2013-12-17','11:34:25',0,'2013-12-25 21:53:09',NULL,NULL),(11537,1490,'865755','834','00','005010X220A1','865755','','2013-12-27','16:36:20',0,'2013-12-28 03:32:44',NULL,NULL),(13165,2009,'0001','999','BE','005010X231A1','231159','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:15',NULL,NULL),(13381,2221,'2515706','834','00','005010X220A1','2515706','','2014-01-06','15:57:07',0,'2014-01-07 04:00:11',NULL,NULL),(15463,2632,'2262070','834','00','005010X220A1','2262070','','2014-01-15','19:12:28',0,'2014-01-17 03:36:15',NULL,NULL),(17973,3304,'2705989','834','00','005010X220A1','2705989','','2014-02-04','20:30:47',0,'2014-02-05 21:31:07',NULL,NULL),(16606,3047,'2474001','834','00','005010X220A1','2474001','','2014-01-26','15:52:57',0,'2014-01-26 19:00:07',NULL,NULL),(16831,3091,'1811569','834','00','005010X220A1','1811569','','2014-01-28','11:56:32',0,'2014-01-28 21:00:27',NULL,NULL),(66,3,'7345','834','00','005010X220A1','7345','','2013-12-05','17:02:52',0,'2013-12-25 17:16:59',NULL,NULL),(20391,3829,'3220490','834','00','005010X220A1','3220490','','2014-02-19','17:18:21',0,'2014-02-20 05:40:45',NULL,NULL),(20390,3829,'2452401','834','00','005010X220A1','2452401','','2014-02-19','17:18:21',0,'2014-02-20 05:40:31',NULL,NULL),(18366,3406,'2511578','834','00','005010X220A1','2511578','','2014-02-08','19:23:19',0,'2014-02-09 19:00:12',NULL,NULL),(12328,1634,'2510611','834','00','005010X220A1','2510611','','2013-12-31','00:36:41',1,'2014-01-02 04:27:08',NULL,NULL),(12199,1609,'1299638','834','00','005010X220A1','1299638','','2013-12-30','15:14:07',0,'2014-01-01 12:09:15',NULL,NULL),(17124,3143,'1694393','834','00','005010X220A1','1694393','','2014-01-30','14:43:53',0,'2014-01-30 21:00:21',NULL,NULL),(16965,3116,'1886947','834','00','005010X220A1','1886947','','2014-01-29','12:21:52',0,'2014-01-29 21:00:33',NULL,NULL),(3766,654,'246205','834','00','005010X220A1','246205','','2013-12-08','10:12:41',0,'2013-12-25 22:15:11',NULL,NULL),(15711,2705,'1615788','834','00','005010X220A1','1615788','','2014-01-18','21:49:02',0,'2014-01-21 08:45:36',NULL,NULL),(7115,1236,'806092','834','00','005010X220A1','806092','','2013-12-18','14:55:23',0,'2013-12-26 04:04:02',NULL,NULL),(2421,417,'51989','834','00','005010X220A1','51989','','2013-12-06','17:22:46',0,'2013-12-25 20:17:55',NULL,NULL),(662,108,'30361','834','00','005010X220A1','30361','','2013-12-16','17:14:15',0,'2013-12-25 18:05:33',NULL,NULL),(14418,2439,'0001','999','BE','005010X231A1','1065232','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:30',NULL,NULL),(525,102,'363273','834','00','005010X220A1','363273','','2013-12-16','13:20:01',0,'2013-12-25 18:01:11',NULL,NULL),(20952,3949,'3319280','834','00','005010X220A1','3319280','','2014-02-24','14:34:27',0,'2014-02-26 08:00:42',NULL,NULL),(14903,2558,'1746834','834','00','005010X220A1','1746834','','2014-01-14','12:48:10',0,'2014-01-15 02:07:31',NULL,NULL),(14707,2550,'2310285','834','00','005010X220A1','2310285','','2014-01-14','08:53:30',0,'2014-01-15 02:06:05',NULL,NULL),(3036,544,'1130983','834','00','005010X220A1','1130983','','2013-12-13','10:16:56',0,'2013-12-25 21:34:11',NULL,NULL),(5787,1075,'873660','834','00','005010X220A1','873660','','2013-12-14','12:10:33',0,'2013-12-26 02:03:07',NULL,NULL),(5285,979,'668030','834','00','005010X220A1','668030','','2013-11-15','23:30:55',0,'2013-12-26 01:00:53',NULL,NULL),(13224,2068,'0001','999','BE','005010X231A1','512367','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:59',NULL,NULL),(3914,712,'88419','834','00','005010X220A1','88419','','2013-12-07','12:42:05',0,'2013-12-25 22:45:28',NULL,NULL),(4130,733,'1273066','834','00','005010X220A1','1273066','','2013-12-19','14:54:50',0,'2013-12-25 23:04:06',NULL,NULL),(11090,1424,'522825','834','00','005010X220A1','522825','','2013-12-22','21:58:11',0,'2013-12-26 13:13:47',NULL,NULL),(13041,1885,'0001','999','BE','005010X231A1','1009870','834','2013-12-27','16:55:00',0,'2014-01-05 16:50:55',NULL,NULL),(21752,4090,'3242160','834','00','005010X220A1','3242160','','2014-02-28','10:50:29',0,'2014-02-28 21:30:48',NULL,NULL),(19880,3709,'3502403','834','00','005010X220A1','3502403','','2014-02-16','17:46:09',0,'2014-02-16 19:00:23',NULL,NULL),(16539,3020,'1949965','834','00','005010X220A1','1949965','','2014-01-23','21:26:26',0,'2014-01-24 21:01:06',NULL,NULL),(7354,1283,'632315','834','00','005010X220A1','632315','','2013-11-30','11:47:59',0,'2013-12-26 04:15:36',NULL,NULL),(14172,2364,'2324998','834','00','005010X220A1','2324998','','2014-01-09','21:32:54',0,'2014-01-13 02:23:22',NULL,NULL),(5116,942,'607158','834','00','005010X220A1','607158','','2013-12-10','23:27:54',0,'2013-12-26 00:49:45',NULL,NULL),(13685,2273,'2300447','834','00','005010X220A1','2300447','','2014-01-07','10:14:16',0,'2014-01-08 18:24:23',NULL,NULL),(13437,2223,'1793311','834','00','005010X220A1','1793311','','2014-01-06','15:00:05',0,'2014-01-07 04:02:14',NULL,NULL),(11412,1468,'1952531','834','00','005010X220A1','1952531','','2013-12-26','10:58:00',0,'2013-12-27 02:06:57',NULL,NULL),(21463,4028,'2600100','834','00','005010X220A1','2600100','','2014-02-27','11:03:58',0,'2014-02-28 06:31:05',NULL,NULL),(22395,4212,'3047258','834','00','005010X220A1','3047258','','2014-03-04','12:47:45',0,'2014-03-04 21:02:15',NULL,NULL),(19247,3580,'2808780','834','00','005010X220A1','2808780','','2014-02-13','16:15:52',0,'2014-02-13 22:00:31',NULL,NULL),(15860,2738,'1465181','834','00','005010X220A1','1465181','','2014-01-21','01:31:02',1,'2014-01-22 03:22:15',NULL,NULL),(1461,252,'503395','834','00','005010X220A1','503395','','2013-12-24','14:22:08',0,'2013-12-25 18:56:09',NULL,NULL),(12930,1722,'2575872','834','00','005010X220A1','2575872','','2014-01-03','15:11:37',0,'2014-01-04 02:06:03',NULL,NULL),(2897,534,'1467907','834','00','005010X220A1','1467907','','2013-12-22','16:07:38',0,'2013-12-25 21:23:38',NULL,NULL),(6438,1204,'216327','834','00','005010X220A1','216327','','2013-11-22','15:45:01',0,'2013-12-26 03:15:40',NULL,NULL),(12663,1673,'2442484','834','00','005010X220A1','2442484','','2014-01-02','12:01:11',0,'2014-01-03 02:03:26',NULL,NULL),(4347,759,'284901','834','00','005010X220A1','284901','','2013-12-19','10:37:49',0,'2013-12-25 23:10:42',NULL,NULL),(5630,1046,'156731','834','00','005010X220A1','156731','','2013-12-24','23:59:20',0,'2013-12-26 01:50:41',NULL,NULL),(22138,4179,'3225160','834','00','005010X220A1','3225160','','2014-03-03','12:54:15',0,'2014-03-03 21:30:47',NULL,NULL),(1509,258,'1690640','834','00','005010X220A1','1690640','','2013-12-24','12:08:36',0,'2013-12-25 18:57:39',NULL,NULL),(18595,3455,'2029650','834','00','005010X220A1','2029650','','2014-02-10','15:38:53',0,'2014-02-10 21:30:59',NULL,NULL),(5547,1041,'1818315','834','00','005010X220A1','1818315','','2013-12-25','16:55:54',0,'2013-12-26 01:47:57',NULL,NULL),(18029,3318,'2571441','834','00','005010X220A1','2571441','','2014-02-06','16:15:51',0,'2014-02-06 21:00:27',NULL,NULL),(6101,1166,'128918','834','00','005010X220A1','128918','','2013-12-20','09:34:35',0,'2013-12-26 03:01:23',NULL,NULL),(7503,1300,'715886','834','00','005010X220A1','715886','','2013-12-20','23:28:47',0,'2013-12-26 04:34:10',NULL,NULL),(10371,1400,'1206901','834','00','005010X220A1','1206901','','2013-12-22','19:09:28',0,'2013-12-26 12:49:49',NULL,NULL),(22636,4253,'3254727','834','00','005010X220A1','3254727','','2014-03-04','18:52:05',0,'2014-03-05 21:31:43',NULL,NULL),(16295,2980,'2459567','834','00','005010X220A1','2459567','','2014-01-23','10:36:40',0,'2014-01-23 21:00:08',NULL,NULL),(2825,508,'1425943','834','00','005010X220A1','1425943','','2013-12-22','17:43:52',0,'2013-12-25 21:21:08',NULL,NULL),(5208,949,'208747','834','00','005010X220A1','208747','','2013-12-11','15:28:51',0,'2013-12-26 00:52:37',NULL,NULL),(11877,1560,'1289468','834','00','005010X220A1','1289468','','2013-12-29','12:12:09',0,'2013-12-30 00:00:16',NULL,NULL),(21094,3986,'2776876','834','00','005010X220A1','2776876','','2014-02-24','13:26:57',0,'2014-02-26 09:31:00',NULL,NULL),(13319,2163,'0001','999','BE','005010X231A1','1122903','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:05',NULL,NULL),(20838,3911,'3136557','834','00','005010X220A1','3136557','','2014-02-25','12:06:29',0,'2014-02-25 21:31:22',NULL,NULL),(19509,3622,'2337723','834','00','005010X220A1','2337723','','2014-02-13','18:53:55',0,'2014-02-14 21:30:32',NULL,NULL),(15288,2615,'2467110','834','00','005010X220A1','2467110','','2014-01-15','12:59:35',0,'2014-01-16 08:47:24',NULL,NULL),(1403,247,'1533020','834','00','005010X220A1','1533020','','2013-12-24','10:23:28',0,'2013-12-25 18:54:09',NULL,NULL),(20939,3945,'3399126','834','00','005010X220A1','3399126','','2014-02-23','17:28:29',0,'2014-02-26 08:00:34',NULL,NULL),(19430,3601,'3283764','834','00','005010X220A1','3283764','','2014-02-13','13:16:06',0,'2014-02-13 22:02:52',NULL,NULL),(17327,3176,'2389186','834','00','005010X220A1','2389186','','2014-01-30','20:07:34',0,'2014-01-31 21:01:00',NULL,NULL),(7037,1235,'113578','834','00','005010X220A1','113578','','2013-12-18','14:31:57',0,'2013-12-26 04:01:40',NULL,NULL),(6240,1169,'544015','834','00','005010X220A1','544015','','2013-12-20','08:35:36',0,'2013-12-26 03:05:35',NULL,NULL),(2700,502,'597696','834','00','005010X220A1','597696','','2013-12-22','15:33:07',0,'2013-12-25 21:17:13',NULL,NULL),(14591,2521,'2274797','834','00','005010X220A1','2274797','','2014-01-13','12:27:09',0,'2014-01-14 01:33:00',NULL,NULL),(4796,865,'783573','834','00','005010X220A1','783573','','2013-12-01','08:35:50',0,'2013-12-26 00:01:46',NULL,NULL),(4480,802,'411371','834','00','005010X220A1','411371','','2013-11-26','11:44:12',0,'2013-12-25 23:31:24',NULL,NULL),(11303,1456,'1986657','834','00','005010X220A1','1986657','','2013-12-26','09:14:04',0,'2013-12-27 02:03:37',NULL,NULL),(13000,1739,'2407664','834','00','005010X220A1','2407664','','2014-01-04','14:35:28',0,'2014-01-05 00:02:06',NULL,NULL),(14153,2359,'1495123','834','00','005010X220A1','1495123','','2014-01-08','13:49:39',0,'2014-01-13 02:22:45',NULL,NULL),(22729,4276,'3815360','834','00','005010X220A1','3815360','','2014-03-05','19:31:35',0,'2014-03-06 21:00:13',NULL,NULL),(23034,4329,'3334679','834','00','005010X220A1','3334679','','2014-03-07','14:30:35',0,'2014-03-07 21:00:27',NULL,NULL),(807,157,'911400','834','00','005010X220A1','911400','','2013-10-31','14:30:23',0,'2013-12-25 18:10:27',NULL,NULL),(1302,244,'2050492','834','00','005010X220A1','2050492','','2013-12-24','17:02:14',0,'2013-12-25 18:50:51',NULL,NULL),(6184,1167,'1183764','834','00','005010X220A1','1183764','','2013-12-20','16:54:14',0,'2013-12-26 03:03:49',NULL,NULL),(18060,3320,'2483215','834','00','005010X220A1','2483215','','2014-02-06','15:21:34',0,'2014-02-06 21:00:48',NULL,NULL),(15376,2624,'1669073','834','00','005010X220A1','1669073','','2014-01-15','23:37:21',0,'2014-01-17 03:35:35',NULL,NULL),(4358,763,'213125','834','00','005010X220A1','213125','','2013-12-19','13:26:15',0,'2013-12-25 23:11:01',NULL,NULL),(13997,2330,'1936299','834','00','005010X220A1','1936299','','2014-01-09','16:10:50',0,'2014-01-13 02:20:55',NULL,NULL),(21779,4091,'3148937','834','00','005010X220A1','3148937','','2014-02-28','13:23:27',0,'2014-02-28 21:31:07',NULL,NULL),(21840,4105,'3044605','834','00','005010X220A1','3044605','','2014-02-28','14:56:45',0,'2014-02-28 21:31:52',NULL,NULL),(20978,3956,'3642703','834','00','005010X220A1','3642703','','2014-02-22','14:42:49',0,'2014-02-26 08:30:17',NULL,NULL),(2979,542,'137623','834','00','005010X220A1','137623','','2013-12-13','17:44:43',0,'2013-12-25 21:32:30',NULL,NULL),(19203,3575,'2916324','834','00','005010X220A1','2916324','','2014-02-13','11:38:20',0,'2014-02-13 21:30:13',NULL,NULL),(5048,936,'54771','834','00','005010X220A1','54771','','2013-12-10','21:33:30',0,'2013-12-26 00:47:30',NULL,NULL),(5574,1043,'1853637','834','00','005010X220A1','1853637','','2013-12-24','21:33:27',0,'2013-12-26 01:48:48',NULL,NULL),(5830,1090,'85609','834','00','005010X220A1','85609','','2013-11-22','20:25:48',0,'2013-12-26 02:15:25',NULL,NULL),(17267,3170,'2505364','834','00','005010X220A1','2505364','','2014-01-31','11:29:32',0,'2014-01-31 21:00:19',NULL,NULL),(12838,1704,'1479428','834','00','005010X220A1','1479428','','2014-01-03','14:20:54',0,'2014-01-04 02:02:37',NULL,NULL),(13458,2225,'1863388','834','00','005010X220A1','1863388','','2014-01-06','13:20:48',0,'2014-01-07 04:03:05',NULL,NULL),(16410,2995,'2124493','834','00','005010X220A1','2124493','','2014-01-23','14:59:54',0,'2014-01-23 21:01:28',NULL,NULL),(23502,4434,'3031258','834','00','005010X220A1','3031258','','2014-03-10','10:35:05',0,'2014-03-10 21:00:04',NULL,NULL),(21452,4028,'3435102','834','00','005010X220A1','3435102','','2014-02-26','21:36:36',0,'2014-02-28 06:31:00',NULL,NULL),(16656,3060,'1725522','834','00','005010X220A1','1725522','','2014-01-27','14:07:27',0,'2014-01-27 21:00:15',NULL,NULL),(12123,1587,'1635468','834','00','005010X220A1','1635468','','2013-12-30','15:35:15',0,'2014-01-01 12:06:31',NULL,NULL),(12120,1587,'19022','834','00','005010X220A1','19022','','2013-12-30','15:06:02',0,'2014-01-01 12:06:23',NULL,NULL),(11773,1529,'1948126','834','00','005010X220A1','1948126','','2013-12-28','16:35:54',1,'2013-12-29 11:10:06',NULL,NULL),(16234,2926,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:35:00',0,'2014-01-23 06:41:04',NULL,NULL),(2571,472,'470940','834','00','005010X220A1','470940','','2013-11-01','08:15:13',0,'2013-12-25 20:45:02',NULL,NULL),(6397,1190,'1065869','834','00','005010X220A1','1065869','','2013-12-20','13:58:24',0,'2013-12-26 03:10:23',NULL,NULL),(4314,750,'596170','834','00','005010X220A1','596170','','2013-12-19','15:56:22',0,'2013-12-25 23:09:40',NULL,NULL),(3526,616,'817051','834','00','005010X220A1','817051','','2013-12-11','18:47:48',0,'2013-12-25 22:02:01',NULL,NULL),(23258,4375,'3219797','834','00','005010X220A1','3219797','','2014-03-07','15:12:29',0,'2014-03-07 21:32:29',NULL,NULL),(656,108,'1187229','834','00','005010X220A1','1187229','','2013-12-16','16:39:37',0,'2013-12-25 18:05:23',NULL,NULL),(767,144,'601888','834','00','005010X220A1','601888','','2013-10-28','19:44:42',0,'2013-12-25 18:08:56',NULL,NULL),(2439,419,'385704','834','00','005010X220A1','385704','','2013-12-06','16:25:06',0,'2013-12-25 20:18:26',NULL,NULL),(21650,4075,'3009245','834','00','005010X220A1','3009245','','2014-02-27','17:23:03',0,'2014-02-28 07:30:39',NULL,NULL),(20685,3885,'3014122','834','00','005010X220A1','3014122','','2014-02-21','14:43:13',0,'2014-02-21 22:01:16',NULL,NULL),(12979,1734,'1622000','834','00','005010X220A1','1622000','','2014-01-04','15:44:30',0,'2014-01-05 00:01:24',NULL,NULL),(20651,3875,'2907172','834','00','005010X220A1','2907172','','2014-02-21','17:12:25',0,'2014-02-21 22:00:53',NULL,NULL),(22142,4179,'3000886','834','00','005010X220A1','3000886','','2014-03-03','13:12:39',0,'2014-03-03 21:30:49',NULL,NULL),(23537,4435,'3928483','834','00','005010X220A1','3928483','','2014-03-10','09:48:42',0,'2014-03-10 21:00:29',NULL,NULL),(20604,3870,'3050800','834','00','005010X220A1','3050800','','2014-02-21','15:33:24',0,'2014-02-21 22:00:18',NULL,NULL),(19943,3737,'2616968','834','00','005010X220A1','2616968','','2014-02-18','14:11:24',0,'2014-02-18 21:30:13',NULL,NULL),(16602,3047,'2529954','834','00','005010X220A1','2529954','','2014-01-26','11:43:56',0,'2014-01-26 19:00:04',NULL,NULL),(17085,3135,'2281103','834','00','005010X220A1','2281103','','2014-01-29','12:59:04',0,'2014-01-29 21:01:48',NULL,NULL),(18524,3451,'2412211','834','00','005010X220A1','2412211','','2014-02-10','11:06:21',0,'2014-02-10 21:30:10',NULL,NULL),(19550,3626,'2592129','834','00','005010X220A1','2592129','','2014-02-13','22:15:57',0,'2014-02-14 21:31:01',NULL,NULL),(19394,3593,'1900904','834','00','005010X220A1','1900904','','2014-02-13','11:17:20',0,'2014-02-13 22:02:25',NULL,NULL),(1027,193,'24390','834','00','005010X220A1','24390','','2013-12-03','11:29:47',0,'2013-12-25 18:21:05',NULL,NULL),(20225,3786,'2864287','834','00','005010X220A1','2864287','','2014-02-19','15:38:15',0,'2014-02-20 04:24:44',NULL,NULL),(17658,3256,'2008396','834','00','005010X220A1','2008396','','2014-02-03','17:47:35',0,'2014-02-03 21:01:38',NULL,NULL),(17137,3144,'1989893','834','00','005010X220A1','1989893','','2014-01-29','23:43:23',0,'2014-01-30 21:00:29',NULL,NULL),(17032,3120,'2691988','834','00','005010X220A1','2691988','','2014-01-29','14:41:29',0,'2014-01-29 21:01:14',NULL,NULL),(4938,918,'1055214','834','00','005010X220A1','1055214','','2013-11-19','17:17:02',0,'2013-12-26 00:31:24',NULL,NULL),(5166,945,'1139493','834','00','005010X220A1','1139493','','2013-12-11','10:13:11',0,'2013-12-26 00:51:16',NULL,NULL),(16815,3090,'2171676','834','00','005010X220A1','2171676','','2014-01-27','21:35:57',0,'2014-01-28 21:00:17',NULL,NULL),(11563,1492,'216016','834','00','005010X220A1','216016','','2013-12-27','12:50:24',0,'2013-12-28 03:33:36',NULL,NULL),(16150,2842,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:25:00',1,'2014-01-23 04:01:46',NULL,NULL),(15333,2622,'2057671','834','00','005010X220A1','2057671','','2014-01-16','17:15:41',0,'2014-01-17 03:35:16',NULL,NULL),(22229,4193,'3063115','834','00','005010X220A1','3063115','','2014-03-03','13:28:49',0,'2014-03-03 21:31:53',NULL,NULL),(14404,2425,'0001','999','BE','005010X231A1','920930','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:17',NULL,NULL),(14212,2365,'2281904','834','00','005010X220A1','2281904','','2014-01-10','17:44:36',0,'2014-01-13 02:23:51',NULL,NULL),(4977,935,'235268','834','00','005010X220A1','235268','','2013-12-10','19:20:02',0,'2013-12-26 00:45:15',NULL,NULL),(7479,1296,'372234','834','00','005010X220A1','372234','','2013-12-21','17:15:03',0,'2013-12-26 04:33:16',NULL,NULL),(291,66,'554566','834','00','005010X220A1','554566','','2013-11-09','16:44:43',0,'2013-12-25 17:32:21',NULL,NULL),(21604,4064,'3462992','834','00','005010X220A1','3462992','','2014-02-26','21:27:05',0,'2014-02-28 07:30:08',NULL,NULL),(1435,252,'1669802','834','00','005010X220A1','1669802','','2013-12-24','10:06:20',0,'2013-12-25 18:55:11',NULL,NULL),(5862,1101,'432182','834','00','005010X220A1','432182','','2013-10-28','15:04:25',0,'2013-12-26 02:16:36',NULL,NULL),(1767,297,'236503','834','00','005010X220A1','236503','','2013-12-10','09:12:33',0,'2013-12-25 19:18:30',NULL,NULL),(4560,825,'834991','834','00','005010X220A1','834991','','2013-12-24','00:38:24',0,'2013-12-25 23:46:01',NULL,NULL),(4838,883,'483505','834','00','005010X220A1','483505','','2013-11-21','08:37:25',0,'2013-12-26 00:15:14',NULL,NULL),(17711,3261,'2570370','834','00','005010X220A1','2570370','','2014-02-04','09:18:55',0,'2014-02-04 21:00:36',NULL,NULL),(16036,2770,'1360816','834','00','005010X220A1','1360816','','2014-01-22','12:33:04',0,'2014-01-23 03:02:29',NULL,NULL),(15850,2738,'1827290','834','00','005010X220A1','1827290','','2014-01-21','09:39:49',1,'2014-01-22 03:22:09',NULL,NULL),(23363,4391,'2965862','834','00','005010X220A1','2965862','','2014-03-07','20:21:56',0,'2014-03-08 21:31:08',NULL,NULL),(23543,4435,'3916716','834','00','005010X220A1','3916716','','2014-03-10','13:01:49',0,'2014-03-10 21:00:34',NULL,NULL),(213,25,'418998','834','00','005010X220A1','418998','','2013-12-05','15:53:26',0,'2013-12-25 17:21:42',NULL,NULL),(12493,1641,'2206020','834','00','005010X220A1','2206020','','2013-12-31','13:41:25',1,'2014-01-02 04:33:06',NULL,NULL),(5113,941,'437360','834','00','005010X220A1','437360','','2013-12-11','08:52:08',0,'2013-12-26 00:49:39',NULL,NULL),(2842,511,'186387','834','00','005010X220A1','186387','','2013-12-22','15:15:37',0,'2013-12-25 21:21:44',NULL,NULL),(5424,1027,'185451','834','00','005010X220A1','185451','','2013-11-14','07:40:22',0,'2013-12-26 01:31:05',NULL,NULL),(6162,1167,'14540','834','00','005010X220A1','14540','','2013-12-20','00:56:56',0,'2013-12-26 03:03:11',NULL,NULL),(1099,226,'1015660','834','00','005010X220A1','1015660','','2013-10-25','11:43:47',0,'2013-12-25 18:31:59',NULL,NULL),(22656,4254,'3828818','834','00','005010X220A1','3828818','','2014-03-05','09:59:47',0,'2014-03-05 21:31:57',NULL,NULL),(22555,4248,'3377877','834','00','005010X220A1','3377877','','2014-03-05','11:52:56',0,'2014-03-05 21:30:47',NULL,NULL),(22255,4200,'2935153','834','00','005010X220A1','2935153','','2014-03-04','00:02:09',0,'2014-03-04 21:00:24',NULL,NULL),(15275,2608,'1709221','834','00','005010X220A1','1709221','','2014-01-15','10:35:31',0,'2014-01-16 08:47:14',NULL,NULL),(16046,2772,'2287799','834','00','005010X220A1','2287799','','2014-01-22','13:07:10',0,'2014-01-23 03:02:33',NULL,NULL),(16429,3003,'1533898','834','00','005010X220A1','1533898','','2014-01-23','17:43:32',0,'2014-01-23 21:01:43',NULL,NULL),(21398,4025,'3570552','834','00','005010X220A1','3570552','','2014-02-26','19:20:02',0,'2014-02-28 06:30:34',NULL,NULL),(21013,3963,'3404727','834','00','005010X220A1','3404727','','2014-02-21','20:38:17',0,'2014-02-26 08:30:49',NULL,NULL),(18641,3463,'2204474','834','00','005010X220A1','2204474','','2014-02-10','09:18:05',0,'2014-02-10 21:31:33',NULL,NULL),(18403,3413,'2445982','834','00','005010X220A1','2445982','','2014-02-09','15:45:21',0,'2014-02-09 19:00:38',NULL,NULL),(18344,3395,'2248847','834','00','005010X220A1','2248847','','2014-02-07','18:33:40',0,'2014-02-08 19:30:03',NULL,NULL),(17181,3148,'2123350','834','00','005010X220A1','2123350','','2014-01-29','20:32:42',0,'2014-01-30 21:00:57',NULL,NULL),(16657,3060,'1777537','834','00','005010X220A1','1777537','','2014-01-27','14:07:31',0,'2014-01-27 21:00:15',NULL,NULL),(12485,1640,'2541185','834','00','005010X220A1','2541185','','2013-12-31','17:18:15',1,'2014-01-02 04:32:44',NULL,NULL),(11197,1453,'257538','834','00','005010X220A1','257538','','2013-12-26','15:47:46',0,'2013-12-27 02:00:20',NULL,NULL),(4163,734,'532422','834','00','005010X220A1','532422','','2013-12-19','08:45:04',0,'2013-12-25 23:05:05',NULL,NULL),(3717,635,'73026','834','00','005010X220A1','73026','','2013-12-12','15:29:14',0,'2013-12-25 22:08:06',NULL,NULL),(2535,456,'1046448','834','00','005010X220A1','1046448','','2013-11-17','21:58:21',0,'2013-12-25 20:31:03',NULL,NULL),(2623,490,'313845','834','00','005010X220A1','313845','','2013-11-27','20:50:03',0,'2013-12-25 20:46:40',NULL,NULL),(2909,540,'931379','834','00','005010X220A1','931379','','2013-12-13','10:19:29',0,'2013-12-25 21:30:14',NULL,NULL),(3686,631,'922325','834','00','005010X220A1','922325','','2013-12-12','08:35:47',0,'2013-12-25 22:07:02',NULL,NULL),(1562,275,'453112','834','00','005010X220A1','453112','','2013-12-24','17:57:57',0,'2013-12-25 18:59:23',NULL,NULL),(13593,2258,'1518576','834','00','005010X220A1','1518576','','2014-01-05','16:49:03',1,'2014-01-07 10:22:34',NULL,NULL),(13007,1742,'2259234','834','00','005010X220A1','2259234','','2014-01-03','23:53:33',0,'2014-01-05 00:02:22',NULL,NULL),(4876,888,'1113831','834','00','005010X220A1','1113831','','2013-11-21','05:26:23',0,'2013-12-26 00:16:27',NULL,NULL),(5554,1043,'1228947','834','00','005010X220A1','1228947','','2013-12-24','18:46:33',0,'2013-12-26 01:48:10',NULL,NULL),(21484,4028,'2753809','834','00','005010X220A1','2753809','','2014-02-27','17:12:40',0,'2014-02-28 06:31:14',NULL,NULL),(4394,774,'1021227','834','00','005010X220A1','1021227','','2013-11-27','17:43:02',0,'2013-12-25 23:15:44',NULL,NULL),(23361,4390,'3226471','834','00','005010X220A1','3226471','','2014-03-08','14:58:52',0,'2014-03-08 21:31:06',NULL,NULL),(7137,1236,'1257887','834','00','005010X220A1','1257887','','2013-12-18','17:58:00',0,'2013-12-26 04:04:40',NULL,NULL),(15171,2591,'2236858','834','00','005010X220A1','2236858','','2014-01-14','20:32:10',0,'2014-01-16 08:46:08',NULL,NULL),(7756,1347,'932177','834','00','005010X220A1','932177','','2013-10-20','14:58:12',0,'2013-12-26 05:01:04',NULL,NULL),(4392,774,'660778','834','00','005010X220A1','660778','','2013-11-27','14:54:05',0,'2013-12-25 23:15:41',NULL,NULL),(14987,2579,'2568584','834','00','005010X220A1','2568584','','2014-01-14','16:20:51',0,'2014-01-15 02:08:10',NULL,NULL),(1741,293,'605968','834','00','005010X220A1','605968','','2013-12-10','13:50:26',0,'2013-12-25 19:17:42',NULL,NULL),(22736,4276,'3301500','834','00','005010X220A1','3301500','','2014-03-05','22:02:29',0,'2014-03-06 21:00:19',NULL,NULL),(21189,3998,'2679928','834','00','005010X220A1','2679928','','2014-02-26','13:45:55',0,'2014-02-26 21:01:10',NULL,NULL),(4201,735,'112361','834','00','005010X220A1','112361','','2013-12-19','08:43:19',0,'2013-12-25 23:06:16',NULL,NULL),(5148,943,'91127','834','00','005010X220A1','91127','','2013-12-11','15:17:04',0,'2013-12-26 00:50:44',NULL,NULL),(17815,3273,'2091152','834','00','005010X220A1','2091152','','2014-02-04','14:31:59',0,'2014-02-04 21:01:43',NULL,NULL),(17184,3148,'1874606','834','00','005010X220A1','1874606','','2014-01-30','11:13:01',0,'2014-01-30 21:00:59',NULL,NULL),(16501,3011,'2190685','834','00','005010X220A1','2190685','','2014-01-24','13:27:07',0,'2014-01-24 21:00:42',NULL,NULL),(12103,1587,'1276874','834','00','005010X220A1','1276874','','2013-12-30','10:49:14',0,'2014-01-01 12:05:49',NULL,NULL),(150,10,'249907','834','00','005010X220A1','249907','','2013-12-05','13:03:28',0,'2013-12-25 17:19:40',NULL,NULL),(19523,3622,'3321924','834','00','005010X220A1','3321924','','2014-02-14','08:41:15',0,'2014-02-14 21:30:42',NULL,NULL),(18442,3421,'1874407','834','00','005010X220A1','1874407','','2014-02-10','04:22:55',0,'2014-02-10 11:00:26',NULL,NULL),(3891,704,'1112584','834','00','005010X220A1','1112584','','2013-10-26','17:51:23',0,'2013-12-25 22:31:56',NULL,NULL),(3110,546,'58331','834','00','005010X220A1','58331','','2013-12-13','16:43:09',0,'2013-12-25 21:36:28',NULL,NULL),(17130,3144,'2476933','834','00','005010X220A1','2476933','','2014-01-29','18:49:40',0,'2014-01-30 21:00:25',NULL,NULL),(16019,2767,'2346633','834','00','005010X220A1','2346633','','2014-01-22','12:55:01',0,'2014-01-23 03:02:21',NULL,NULL),(11701,1517,'1995629','834','00','005010X220A1','1995629','','2013-12-27','22:33:58',1,'2013-12-29 11:07:56',NULL,NULL),(15385,2624,'1802485','834','00','005010X220A1','1802485','','2014-01-15','19:02:00',0,'2014-01-17 03:35:40',NULL,NULL),(459,84,'430259','834','00','005010X220A1','430259','','2013-12-03','19:15:09',0,'2013-12-25 17:50:15',NULL,NULL),(13306,2150,'0001','999','BE','005010X231A1','457321','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:28',NULL,NULL),(5917,1112,'1183473','834','00','005010X220A1','1183473','','2013-12-15','10:57:04',0,'2013-12-26 02:31:18',NULL,NULL),(19708,3671,'3019433','834','00','005010X220A1','3019433','','2014-02-15','16:15:10',0,'2014-02-15 22:00:14',NULL,NULL),(12564,1662,'1389691','834','00','005010X220A1','1389691','','2013-12-31','14:54:52',1,'2014-01-02 04:35:52',NULL,NULL),(12553,1656,'1311042','834','00','005010X220A1','1311042','','2013-12-31','18:09:50',1,'2014-01-02 04:35:20',NULL,NULL),(12037,1583,'1377976','834','00','005010X220A1','1377976','','2013-12-30','15:08:32',0,'2014-01-01 12:03:28',NULL,NULL),(11096,1424,'292162','834','00','005010X220A1','292162','','2013-12-23','15:09:57',0,'2013-12-26 13:13:57',NULL,NULL),(3933,714,'907053','834','00','005010X220A1','907053','','2013-12-06','20:40:32',0,'2013-12-25 22:46:01',NULL,NULL),(19379,3591,'2603688','834','00','005010X220A1','2603688','','2014-02-13','12:31:37',0,'2014-02-13 22:02:14',NULL,NULL),(18111,3330,'2684489','834','00','005010X220A1','2684489','','2014-02-05','20:08:26',0,'2014-02-06 21:01:24',NULL,NULL),(17654,3253,'2129979','834','00','005010X220A1','2129979','','2014-02-03','16:18:13',0,'2014-02-03 21:01:33',NULL,NULL),(13349,2193,'0001','999','BE','005010X231A1','620557','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:28',NULL,NULL),(13756,2277,'2110609','834','00','005010X220A1','2110609','','2014-01-07','14:55:25',0,'2014-01-08 18:24:55',NULL,NULL),(14930,2560,'2540277','834','00','005010X220A1','2540277','','2014-01-14','16:34:36',0,'2014-01-15 02:07:43',NULL,NULL),(17239,3164,'2550522','834','00','005010X220A1','2550522','','2014-01-30','18:06:34',0,'2014-01-30 21:01:36',NULL,NULL),(1647,285,'337925','834','00','005010X220A1','337925','','2013-11-20','13:25:02',0,'2013-12-25 19:02:24',NULL,NULL),(22485,4243,'3491300','834','00','005010X220A1','3491300','','2014-03-05','12:14:34',0,'2014-03-05 21:00:27',NULL,NULL),(22328,4203,'3412395','834','00','005010X220A1','3412395','','2014-03-03','18:07:56',0,'2014-03-04 21:01:20',NULL,NULL),(17907,3296,'1540122','834','00','005010X220A1','1540122','','2014-02-04','19:21:39',0,'2014-02-05 21:30:35',NULL,NULL),(3061,544,'935224','834','00','005010X220A1','935224','','2013-12-13','14:57:44',0,'2013-12-25 21:34:59',NULL,NULL),(17632,3244,'2547128','834','00','005010X220A1','2547128','','2014-02-03','12:37:14',0,'2014-02-03 21:01:17',NULL,NULL),(2692,502,'917242','834','00','005010X220A1','917242','','2013-12-22','13:12:06',0,'2013-12-25 21:16:55',NULL,NULL),(17177,3147,'1551714','834','00','005010X220A1','1551714','','2014-01-30','14:56:38',0,'2014-01-30 21:00:55',NULL,NULL),(11417,1469,'1207208','834','00','005010X220A1','1207208','','2013-12-26','18:22:37',0,'2013-12-27 02:07:05',NULL,NULL),(16569,3035,'1714703','834','00','005010X220A1','1714703','','2014-01-24','22:50:14',0,'2014-01-25 19:00:05',NULL,NULL),(14087,2341,'2580792','834','00','005010X220A1','2580792','','2014-01-08','12:53:09',0,'2014-01-13 02:22:01',NULL,NULL),(700,114,'104449','834','00','005010X220A1','104449','','2013-12-16','00:31:15',0,'2013-12-25 18:06:44',NULL,NULL),(13606,2262,'1775866','834','00','005010X220A1','1775866','','2014-01-05','15:39:38',1,'2014-01-07 10:23:02',NULL,NULL),(13090,1934,'0001','999','BE','005010X231A1','589789','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:10',NULL,NULL),(10665,1402,'1477655','834','00','005010X220A1','1477655','','2013-12-23','19:26:56',0,'2013-12-26 12:59:15',NULL,NULL),(5745,1070,'496557','834','00','005010X220A1','496557','','2013-12-14','13:55:34',0,'2013-12-26 02:01:45',NULL,NULL),(4310,749,'909809','834','00','005010X220A1','909809','','2013-12-19','17:52:19',0,'2013-12-25 23:09:33',NULL,NULL),(3385,587,'859243','834','00','005010X220A1','859243','','2013-12-17','17:58:02',0,'2013-12-25 21:51:14',NULL,NULL),(14604,2521,'1897740','834','00','005010X220A1','1897740','','2014-01-13','16:42:42',0,'2014-01-14 01:33:09',NULL,NULL),(14840,2553,'2158419','834','00','005010X220A1','2158419','','2014-01-14','09:30:01',0,'2014-01-15 02:07:01',NULL,NULL),(16888,3097,'2454371','834','00','005010X220A1','2454371','','2014-01-28','10:05:23',0,'2014-01-28 21:01:05',NULL,NULL),(17081,3133,'1390398','834','00','005010X220A1','1390398','','2014-01-29','13:07:57',0,'2014-01-29 21:01:46',NULL,NULL),(18147,3344,'2403624','834','00','005010X220A1','2403624','','2014-02-06','14:36:25',0,'2014-02-06 21:01:52',NULL,NULL),(18217,3356,'1910576','834','00','005010X220A1','1910576','','2014-02-07','16:25:59',0,'2014-02-07 19:00:46',NULL,NULL),(19086,3542,'3259787','834','00','005010X220A1','3259787','','2014-02-12','16:31:38',0,'2014-02-12 21:31:29',NULL,NULL),(19904,3719,'2826623','834','00','005010X220A1','2826623','','2014-02-16','09:40:32',0,'2014-02-16 19:00:42',NULL,NULL),(20063,3754,'2121215','834','00','005010X220A1','2121215','','2014-02-18','09:32:04',0,'2014-02-18 22:01:18',NULL,NULL),(22911,4286,'3230002','834','00','005010X220A1','3230002','','2014-03-06','12:03:04',0,'2014-03-06 21:02:24',NULL,NULL),(23425,4405,'3490255','834','00','005010X220A1','3490255','','2014-03-09','11:29:49',0,'2014-03-09 21:00:29',NULL,NULL),(15,1,'615142','834','00','005010X220A1','615142','','2013-12-05','10:40:55',0,'2013-12-25 17:15:29',NULL,NULL),(13501,2231,'1525028','834','00','005010X220A1','1525028','','2014-01-06','18:11:01',0,'2014-01-07 04:04:42',NULL,NULL),(13271,2115,'0001','999','BE','005010X231A1','1301191','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:51',NULL,NULL),(4290,745,'736313','834','00','005010X220A1','736313','','2013-12-18','21:44:47',0,'2013-12-25 23:09:00',NULL,NULL),(4825,876,'836982','834','00','005010X220A1','836982','','2013-12-01','12:53:55',0,'2013-12-26 00:02:38',NULL,NULL),(4220,738,'615635','834','00','005010X220A1','615635','','2013-12-19','06:20:43',0,'2013-12-25 23:06:50',NULL,NULL),(5139,943,'1518','834','00','005010X220A1','1518','','2013-12-11','11:32:46',0,'2013-12-26 00:50:29',NULL,NULL),(5142,943,'943949','834','00','005010X220A1','943949','','2013-12-11','12:26:13',0,'2013-12-26 00:50:34',NULL,NULL),(3889,703,'1110079','834','00','005010X220A1','1110079','','2013-10-26','17:48:11',0,'2013-12-25 22:31:51',NULL,NULL),(10412,1400,'887761','834','00','005010X220A1','887761','','2013-12-23','09:31:37',0,'2013-12-26 12:51:05',NULL,NULL),(3410,591,'1012688','834','00','005010X220A1','1012688','','2013-12-17','13:22:46',0,'2013-12-25 21:52:01',NULL,NULL),(11218,1454,'147113','834','00','005010X220A1','147113','','2013-12-26','10:09:20',0,'2013-12-27 02:01:00',NULL,NULL),(11927,1568,'2192291','834','00','005010X220A1','2192291','','2013-12-28','20:20:20',0,'2013-12-30 00:01:52',NULL,NULL),(2522,454,'695582','834','00','005010X220A1','695582','','2013-11-18','15:21:16',0,'2013-12-25 20:30:42',NULL,NULL),(12546,1654,'2057204','834','00','005010X220A1','2057204','','2013-12-31','11:15:28',1,'2014-01-02 04:35:06',NULL,NULL),(15088,2585,'2392685','834','00','005010X220A1','2392685','','2014-01-15','16:19:38',0,'2014-01-16 08:45:12',NULL,NULL),(19314,3583,'3261232','834','00','005010X220A1','3261232','','2014-02-12','23:38:23',0,'2014-02-13 22:01:24',NULL,NULL),(20499,3846,'3460279','834','00','005010X220A1','3460279','','2014-02-20','11:35:05',0,'2014-02-20 22:01:03',NULL,NULL),(22550,4248,'3604463','834','00','005010X220A1','3604463','','2014-03-05','09:54:15',0,'2014-03-05 21:30:44',NULL,NULL),(23493,4432,'3476683','834','00','005010X220A1','3476683','','2014-03-09','15:35:59',0,'2014-03-09 21:30:07',NULL,NULL),(652,108,'772264','834','00','005010X220A1','772264','','2013-12-16','16:29:35',0,'2013-12-25 18:05:17',NULL,NULL),(706,116,'310498','834','00','005010X220A1','310498','','2013-12-16','16:44:42',0,'2013-12-25 18:06:54',NULL,NULL),(12755,1692,'2321245','834','00','005010X220A1','2321245','','2014-01-01','18:35:33',0,'2014-01-03 02:06:54',NULL,NULL),(909,177,'1054268','834','00','005010X220A1','1054268','','2013-12-03','14:51:44',0,'2013-12-25 18:17:21',NULL,NULL),(11716,1519,'1559847','834','00','005010X220A1','1559847','','2013-12-28','14:36:09',1,'2013-12-29 11:08:24',NULL,NULL),(10428,1400,'1353702','834','00','005010X220A1','1353702','','2013-12-23','10:43:14',0,'2013-12-26 12:51:33',NULL,NULL),(962,181,'257993','834','00','005010X220A1','257993','','2013-12-03','17:18:10',0,'2013-12-25 18:19:00',NULL,NULL),(2144,360,'1006506','834','00','005010X220A1','1006506','','2013-12-02','16:14:21',0,'2013-12-25 19:46:17',NULL,NULL),(3709,633,'505189','834','00','005010X220A1','505189','','2013-12-12','16:02:10',0,'2013-12-25 22:07:49',NULL,NULL),(5178,949,'479149','834','00','005010X220A1','479149','','2013-12-10','20:34:49',0,'2013-12-26 00:51:38',NULL,NULL),(4438,799,'120719','834','00','005010X220A1','120719','','2013-11-06','12:53:26',0,'2013-12-25 23:17:19',NULL,NULL),(3830,678,'899518','834','00','005010X220A1','899518','','2013-12-08','17:20:24',0,'2013-12-25 22:17:27',NULL,NULL),(13973,2323,'2360408','834','00','005010X220A1','2360408','','2014-01-09','08:48:20',0,'2014-01-13 02:20:37',NULL,NULL),(16437,3006,'1862779','834','00','005010X220A1','1862779','','2014-01-24','15:29:09',0,'2014-01-24 21:00:05',NULL,NULL),(16690,3062,'2604293','834','00','005010X220A1','2604293','','2014-01-27','16:08:41',0,'2014-01-27 21:00:37',NULL,NULL),(16844,3092,'1901878','834','00','005010X220A1','1901878','','2014-01-28','10:51:47',0,'2014-01-28 21:00:35',NULL,NULL),(18747,3485,'2944974','834','00','005010X220A1','2944974','','2014-02-11','13:26:45',0,'2014-02-11 21:00:36',NULL,NULL),(19763,3674,'3163945','834','00','005010X220A1','3163945','','2014-02-14','19:49:03',0,'2014-02-15 22:00:53',NULL,NULL),(20101,3771,'3615965','834','00','005010X220A1','3615965','','2014-02-18','18:02:56',0,'2014-02-20 03:41:50',NULL,NULL),(20353,3813,'2819696','834','00','005010X220A1','2819696','','2014-02-19','15:22:36',0,'2014-02-20 04:55:36',NULL,NULL),(20928,3936,'3172483','834','00','005010X220A1','3172483','','2014-02-23','17:10:27',0,'2014-02-26 08:00:23',NULL,NULL),(21202,3998,'3703010','834','00','005010X220A1','3703010','','2014-02-26','15:11:46',0,'2014-02-26 21:01:18',NULL,NULL),(21770,4090,'3226163','834','00','005010X220A1','3226163','','2014-02-28','16:57:06',0,'2014-02-28 21:31:00',NULL,NULL),(212,25,'459936','834','00','005010X220A1','459936','','2013-12-05','12:08:16',0,'2013-12-25 17:21:40',NULL,NULL),(469,89,'719352','834','00','005010X220A1','719352','','2013-12-03','23:11:18',0,'2013-12-25 17:50:37',NULL,NULL),(1333,245,'1844353','834','00','005010X220A1','1844353','','2013-12-24','12:19:06',0,'2013-12-25 18:51:52',NULL,NULL),(10548,1402,'170070','834','00','005010X220A1','170070','','2013-12-22','19:22:31',0,'2013-12-26 12:55:28',NULL,NULL),(1439,252,'1825444','834','00','005010X220A1','1825444','','2013-12-24','10:33:17',0,'2013-12-25 18:55:19',NULL,NULL),(2141,360,'739402','834','00','005010X220A1','739402','','2013-12-02','13:37:36',0,'2013-12-25 19:46:10',NULL,NULL),(5278,977,'1103494','834','00','005010X220A1','1103494','','2013-11-15','20:24:38',0,'2013-12-26 01:00:40',NULL,NULL),(7196,1239,'775656','834','00','005010X220A1','775656','','2013-12-18','16:54:39',0,'2013-12-26 04:06:29',NULL,NULL),(3772,655,'340716','834','00','005010X220A1','340716','','2013-12-07','22:12:57',0,'2013-12-25 22:15:24',NULL,NULL),(4386,774,'627585','834','00','005010X220A1','627585','','2013-11-27','10:08:39',0,'2013-12-25 23:15:32',NULL,NULL),(4955,926,'779659','834','00','005010X220A1','779659','','2013-11-19','17:20:16',0,'2013-12-26 00:32:00',NULL,NULL),(4725,843,'336080','834','00','005010X220A1','336080','','2013-12-23','22:34:10',0,'2013-12-25 23:51:33',NULL,NULL),(14504,2515,'2446485','834','00','005010X220A1','2446485','','2014-01-13','13:49:48',0,'2014-01-14 01:32:04',NULL,NULL),(14691,2549,'1555465','834','00','005010X220A1','1555465','','2014-01-14','12:16:55',0,'2014-01-15 02:05:57',NULL,NULL),(21468,4028,'2982900','834','00','005010X220A1','2982900','','2014-02-27','13:42:51',0,'2014-02-28 06:31:07',NULL,NULL),(21952,4136,'3840866','834','00','005010X220A1','3840866','','2014-03-01','09:44:23',0,'2014-03-01 21:01:07',NULL,NULL),(22906,4285,'2625853','834','00','005010X220A1','2625853','','2014-03-06','12:32:06',0,'2014-03-06 21:02:20',NULL,NULL),(13,1,'392138','834','00','005010X220A1','392138','','2013-12-05','09:52:09',0,'2013-12-25 17:15:25',NULL,NULL),(4141,733,'358220','834','00','005010X220A1','358220','','2013-12-19','15:58:15',0,'2013-12-25 23:04:25',NULL,NULL),(2667,501,'1035251','834','00','005010X220A1','1035251','','2013-12-22','16:21:59',0,'2013-12-25 21:16:05',NULL,NULL),(2274,391,'85616','834','00','005010X220A1','85616','','2013-11-23','18:49:09',0,'2013-12-25 20:00:18',NULL,NULL),(1498,256,'1789749','834','00','005010X220A1','1789749','','2013-12-24','18:04:07',0,'2013-12-25 18:57:19',NULL,NULL),(6067,1164,'917142','834','00','005010X220A1','917142','','2013-12-20','13:30:20',0,'2013-12-26 03:00:16',NULL,NULL),(6093,1166,'851462','834','00','005010X220A1','851462','','2013-12-19','23:29:45',0,'2013-12-26 03:01:06',NULL,NULL),(7694,1331,'981217','834','00','005010X220A1','981217','','2013-11-15','10:45:25',0,'2013-12-26 04:45:14',NULL,NULL),(1157,239,'1712540','834','00','005010X220A1','1712540','','2013-12-24','11:40:28',0,'2013-12-25 18:46:24',NULL,NULL),(11476,1488,'2007448','834','00','005010X220A1','2007448','','2013-12-27','14:49:59',0,'2013-12-28 03:30:55',NULL,NULL),(397,76,'184617','834','00','005010X220A1','184617','','2013-12-03','21:07:38',0,'2013-12-25 17:48:18',NULL,NULL),(14878,2557,'2328894','834','00','005010X220A1','2328894','','2014-01-13','19:45:39',0,'2014-01-15 02:07:19',NULL,NULL),(16327,2983,'2290322','834','00','005010X220A1','2290322','','2014-01-22','21:15:06',0,'2014-01-23 21:00:33',NULL,NULL),(17080,3133,'1878337','834','00','005010X220A1','1878337','','2014-01-29','12:25:05',0,'2014-01-29 21:01:46',NULL,NULL),(17185,3148,'2609421','834','00','005010X220A1','2609421','','2014-01-30','11:32:52',0,'2014-01-30 21:00:59',NULL,NULL),(17215,3152,'2013946','834','00','005010X220A1','2013946','','2014-01-30','10:39:36',0,'2014-01-30 21:01:19',NULL,NULL),(19924,3730,'3525896','834','00','005010X220A1','3525896','','2014-02-17','14:43:05',0,'2014-02-17 19:00:16',NULL,NULL),(21989,4145,'2798026','834','00','005010X220A1','2798026','','2014-03-02','13:29:42',0,'2014-03-03 01:00:17',NULL,NULL),(22129,4179,'3407475','834','00','005010X220A1','3407475','','2014-03-02','22:16:53',0,'2014-03-03 21:30:40',NULL,NULL),(23768,4480,'2774827','834','00','005010X220A1','2774827','','2014-03-10','16:29:02',0,'2014-03-10 21:30:15',NULL,NULL),(453,82,'415137','834','00','005010X220A1','415137','','2013-12-04','14:47:41',0,'2013-12-25 17:50:03',NULL,NULL),(4909,906,'12406','834','00','005010X220A1','12406','','2013-10-23','15:27:38',0,'2013-12-26 00:30:27',NULL,NULL),(4167,734,'1276284','834','00','005010X220A1','1276284','','2013-12-19','09:58:33',0,'2013-12-25 23:05:10',NULL,NULL),(3170,564,'303013','834','00','005010X220A1','303013','','2013-12-13','16:16:24',0,'2013-12-25 21:38:28',NULL,NULL),(10367,1400,'720073','834','00','005010X220A1','720073','','2013-12-22','19:38:17',0,'2013-12-26 12:49:42',NULL,NULL),(11535,1490,'1373925','834','00','005010X220A1','1373925','','2013-12-27','15:34:06',0,'2013-12-28 03:32:41',NULL,NULL),(12232,1618,'2437135','834','00','005010X220A1','2437135','','2013-12-31','19:48:25',1,'2014-01-02 04:22:43',NULL,NULL),(12853,1706,'1979368','834','00','005010X220A1','1979368','','2014-01-02','21:36:45',0,'2014-01-04 02:03:10',NULL,NULL),(14399,2420,'0001','999','BE','005010X231A1','581641','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:13',NULL,NULL),(15378,2624,'2451579','834','00','005010X220A1','2451579','','2014-01-16','00:24:17',0,'2014-01-17 03:35:36',NULL,NULL),(15496,2634,'2209062','834','00','005010X220A1','2209062','','2014-01-15','19:37:38',0,'2014-01-17 03:36:29',NULL,NULL),(15529,2654,'2491529','834','00','005010X220A1','2491529','','2014-01-16','19:57:07',0,'2014-01-20 08:05:34',NULL,NULL),(17229,3157,'1681114','834','00','005010X220A1','1681114','','2014-01-30','14:41:03',0,'2014-01-30 21:01:28',NULL,NULL),(17402,3198,'2060409','834','00','005010X220A1','2060409','','2014-02-01','17:07:26',0,'2014-02-01 19:00:10',NULL,NULL),(18021,3318,'2854786','834','00','005010X220A1','2854786','','2014-02-05','22:54:54',0,'2014-02-06 21:00:21',NULL,NULL),(18310,3384,'1811826','834','00','005010X220A1','1811826','','2014-02-07','21:19:58',0,'2014-02-08 19:00:41',NULL,NULL),(5533,1041,'1981511','834','00','005010X220A1','1981511','','2013-12-24','23:18:42',0,'2013-12-26 01:47:27',NULL,NULL),(5984,1123,'1134805','834','00','005010X220A1','1134805','','2013-12-15','17:53:08',0,'2013-12-26 02:33:27',NULL,NULL),(3472,615,'1267581','834','00','005010X220A1','1267581','','2013-12-11','21:52:44',0,'2013-12-25 22:00:16',NULL,NULL),(19873,3709,'3075913','834','00','005010X220A1','3075913','','2014-02-15','19:45:08',0,'2014-02-16 19:00:19',NULL,NULL),(7285,1255,'1287423','834','00','005010X220A1','1287423','','2013-12-18','15:29:01',0,'2013-12-26 04:09:14',NULL,NULL),(7323,1270,'1151235','834','00','005010X220A1','1151235','','2013-12-18','14:55:45',0,'2013-12-26 04:10:25',NULL,NULL),(18270,3377,'1738428','834','00','005010X220A1','1738428','','2014-02-07','20:27:26',0,'2014-02-08 19:00:16',NULL,NULL),(7441,1296,'1194689','834','00','005010X220A1','1194689','','2013-12-20','19:14:57',0,'2013-12-26 04:32:08',NULL,NULL),(10554,1402,'1327270','834','00','005010X220A1','1327270','','2013-12-22','21:18:32',0,'2013-12-26 12:55:40',NULL,NULL),(16443,3006,'2262256','834','00','005010X220A1','2262256','','2014-01-24','18:07:52',0,'2014-01-24 21:00:08',NULL,NULL),(15487,2634,'1837122','834','00','005010X220A1','1837122','','2014-01-16','13:53:43',0,'2014-01-17 03:36:25',NULL,NULL),(12096,1587,'1635447','834','00','005010X220A1','1635447','','2013-12-29','23:24:13',0,'2014-01-01 12:05:35',NULL,NULL),(13843,2311,'2045481','834','00','005010X220A1','2045481','','2014-01-08','18:46:52',0,'2014-01-13 02:19:07',NULL,NULL),(14045,2337,'2291171','834','00','005010X220A1','2291171','','2014-01-08','17:46:58',0,'2014-01-13 02:21:33',NULL,NULL),(14126,2351,'1360425','834','00','005010X220A1','1360425','','2014-01-08','09:48:28',0,'2014-01-13 02:22:27',NULL,NULL),(15414,2629,'1416772','834','00','005010X220A1','1416772','','2014-01-15','21:51:05',0,'2014-01-17 03:35:54',NULL,NULL),(22641,4253,'3058269','834','00','005010X220A1','3058269','','2014-03-05','12:04:31',0,'2014-03-05 21:31:46',NULL,NULL),(20739,3903,'3281708','834','00','005010X220A1','3281708','','2014-02-25','09:49:18',0,'2014-02-25 21:30:09',NULL,NULL),(20561,3864,'3604156','834','00','005010X220A1','3604156','','2014-02-21','11:35:04',0,'2014-02-21 21:30:11',NULL,NULL),(4376,773,'1183051','834','00','005010X220A1','1183051','','2013-11-27','13:33:00',0,'2013-12-25 23:15:12',NULL,NULL),(19805,3677,'3037822','834','00','005010X220A1','3037822','','2014-02-15','17:16:57',0,'2014-02-15 22:01:27',NULL,NULL),(18243,3370,'2560091','834','00','005010X220A1','2560091','','2014-02-07','17:08:12',0,'2014-02-07 19:01:07',NULL,NULL),(7379,1293,'533789','834','00','005010X220A1','533789','','2013-12-20','20:01:55',0,'2013-12-26 04:30:08',NULL,NULL),(16384,2987,'1922048','834','00','005010X220A1','1922048','','2014-01-23','15:48:07',0,'2014-01-23 21:01:12',NULL,NULL),(2442,420,'1095591','834','00','005010X220A1','1095591','','2013-12-06','18:09:52',0,'2013-12-25 20:18:33',NULL,NULL),(1153,239,'1454567','834','00','005010X220A1','1454567','','2013-12-24','10:52:08',0,'2013-12-25 18:46:17',NULL,NULL),(13367,2211,'0001','999','BE','005010X231A1','163334','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:18',NULL,NULL),(22028,4159,'3381922','834','00','005010X220A1','3381922','','2014-03-02','14:46:47',0,'2014-03-03 01:00:40',NULL,NULL),(21277,4002,'3621535','834','00','005010X220A1','3621535','','2014-02-26','14:52:36',0,'2014-02-26 21:02:08',NULL,NULL),(14505,2515,'1513614','834','00','005010X220A1','1513614','','2014-01-13','14:06:49',0,'2014-01-14 01:32:04',NULL,NULL),(1617,281,'1063858','834','00','005010X220A1','1063858','','2013-11-19','23:03:40',0,'2013-12-25 19:01:38',NULL,NULL),(569,103,'269816','834','00','005010X220A1','269816','','2013-12-16','14:59:50',0,'2013-12-25 18:02:38',NULL,NULL),(7259,1246,'167147','834','00','005010X220A1','167147','','2013-12-18','15:07:47',0,'2013-12-26 04:08:28',NULL,NULL),(11442,1484,'1410892','834','00','005010X220A1','1410892','','2013-12-26','15:40:42',0,'2013-12-27 02:07:57',NULL,NULL),(4515,812,'586182','834','00','005010X220A1','586182','','2013-11-26','15:32:18',0,'2013-12-25 23:32:34',NULL,NULL),(2966,541,'1211547','834','00','005010X220A1','1211547','','2013-12-13','14:24:53',0,'2013-12-25 21:32:06',NULL,NULL),(11727,1520,'2042734','834','00','005010X220A1','2042734','','2013-12-28','12:35:03',1,'2013-12-29 11:08:43',NULL,NULL),(1219,243,'682970','834','00','005010X220A1','682970','','2013-12-24','08:53:49',0,'2013-12-25 18:48:21',NULL,NULL),(12323,1634,'1384702','834','00','005010X220A1','1384702','','2013-12-30','22:54:11',1,'2014-01-02 04:26:55',NULL,NULL),(1191,239,'1534356','834','00','005010X220A1','1534356','','2013-12-24','17:10:37',0,'2013-12-25 18:47:29',NULL,NULL),(5687,1065,'1303499','834','00','005010X220A1','1303499','','2013-12-25','15:10:42',0,'2013-12-26 01:52:43',NULL,NULL),(14236,2371,'1966896','834','00','005010X220A1','1966896','','2014-01-09','19:49:00',0,'2014-01-13 02:24:07',NULL,NULL),(14829,2552,'1472416','834','00','005010X220A1','1472416','','2014-01-14','18:07:56',0,'2014-01-15 02:06:57',NULL,NULL),(15133,2587,'1511261','834','00','005010X220A1','1511261','','2014-01-15','17:20:29',0,'2014-01-16 08:45:42',NULL,NULL),(16389,2989,'2106990','834','00','005010X220A1','2106990','','2014-01-23','09:48:23',0,'2014-01-23 21:01:15',NULL,NULL),(16607,3047,'1837286','834','00','005010X220A1','1837286','','2014-01-26','16:25:33',0,'2014-01-26 19:00:08',NULL,NULL),(18579,3453,'2709941','834','00','005010X220A1','2709941','','2014-02-10','15:15:17',0,'2014-02-10 21:30:49',NULL,NULL),(19289,3582,'2698871','834','00','005010X220A1','2698871','','2014-02-13','14:39:09',0,'2014-02-13 22:01:04',NULL,NULL),(21172,3998,'3528376','834','00','005010X220A1','3528376','','2014-02-26','10:40:39',0,'2014-02-26 21:00:58',NULL,NULL),(22174,4180,'3037070','834','00','005010X220A1','3037070','','2014-03-03','14:44:55',0,'2014-03-03 21:31:12',NULL,NULL),(22212,4186,'3788647','834','00','005010X220A1','3788647','','2014-03-03','17:32:56',0,'2014-03-03 21:31:40',NULL,NULL),(22603,4250,'3086558','834','00','005010X220A1','3086558','','2014-03-05','11:47:22',0,'2014-03-05 21:31:20',NULL,NULL),(4993,935,'847155','834','00','005010X220A1','847155','','2013-12-11','08:31:26',0,'2013-12-26 00:45:45',NULL,NULL),(5099,940,'1251644','834','00','005010X220A1','1251644','','2013-12-11','12:47:22',0,'2013-12-26 00:49:08',NULL,NULL),(5165,945,'778836','834','00','005010X220A1','778836','','2013-12-10','19:08:39',0,'2013-12-26 00:51:14',NULL,NULL),(11993,1580,'1721973','834','00','005010X220A1','1721973','','2013-12-30','18:23:34',0,'2014-01-01 12:01:48',NULL,NULL),(11126,1428,'857198','834','00','005010X220A1','857198','','2013-12-23','17:19:57',0,'2013-12-26 13:15:02',NULL,NULL),(6100,1166,'848841','834','00','005010X220A1','848841','','2013-12-20','09:16:38',0,'2013-12-26 03:01:21',NULL,NULL),(6268,1172,'315754','834','00','005010X220A1','315754','','2013-12-20','09:19:16',0,'2013-12-26 03:06:28',NULL,NULL),(12854,1706,'2084566','834','00','005010X220A1','2084566','','2014-01-02','22:02:46',0,'2014-01-04 02:03:13',NULL,NULL),(14042,2337,'1891308','834','00','005010X220A1','1891308','','2014-01-08','16:43:22',0,'2014-01-13 02:21:31',NULL,NULL),(14535,2518,'1686320','834','00','005010X220A1','1686320','','2014-01-13','11:52:49',0,'2014-01-14 01:32:25',NULL,NULL),(16392,2991,'1937718','834','00','005010X220A1','1937718','','2014-01-23','13:22:10',0,'2014-01-23 21:01:18',NULL,NULL),(17794,3270,'1761218','834','00','005010X220A1','1761218','','2014-02-04','12:08:35',0,'2014-02-04 21:01:28',NULL,NULL),(20537,3854,'3637765','834','00','005010X220A1','3637765','','2014-02-20','14:33:48',0,'2014-02-20 22:01:34',NULL,NULL),(21087,3984,'3554349','834','00','005010X220A1','3554349','','2014-02-24','13:04:45',0,'2014-02-26 09:30:54',NULL,NULL),(21459,4028,'3148883','834','00','005010X220A1','3148883','','2014-02-27','09:16:04',0,'2014-02-28 06:31:03',NULL,NULL),(22253,4200,'3722206','834','00','005010X220A1','3722206','','2014-03-03','22:57:08',0,'2014-03-04 21:00:22',NULL,NULL),(581,104,'999468','834','00','005010X220A1','999468','','2013-12-15','19:29:45',0,'2013-12-25 18:02:58',NULL,NULL),(5006,935,'738579','834','00','005010X220A1','738579','','2013-12-11','10:42:58',0,'2013-12-26 00:46:09',NULL,NULL),(5764,1072,'1168698','834','00','005010X220A1','1168698','','2013-12-14','10:16:23',0,'2013-12-26 02:02:21',NULL,NULL),(2967,541,'555027','834','00','005010X220A1','555027','','2013-12-13','14:24:53',0,'2013-12-25 21:32:07',NULL,NULL),(2475,429,'1206222','834','00','005010X220A1','1206222','','2013-12-05','18:34:50',0,'2013-12-25 20:19:41',NULL,NULL),(14286,2379,'1560167','834','00','005010X220A1','1560167','','2014-01-10','11:21:09',0,'2014-01-13 03:00:19',NULL,NULL),(15098,2586,'2317947','834','00','005010X220A1','2317947','','2014-01-14','19:04:44',0,'2014-01-16 08:45:19',NULL,NULL),(15387,2624,'1806094','834','00','005010X220A1','1806094','','2014-01-15','19:52:13',0,'2014-01-17 03:35:41',NULL,NULL),(15472,2634,'2512423','834','00','005010X220A1','2512423','','2014-01-15','22:48:04',0,'2014-01-17 03:36:19',NULL,NULL),(19081,3542,'2585532','834','00','005010X220A1','2585532','','2014-02-12','14:02:23',0,'2014-02-12 21:31:25',NULL,NULL),(19808,3679,'2559188','834','00','005010X220A1','2559188','','2014-02-14','23:53:08',0,'2014-02-15 22:01:30',NULL,NULL),(21423,4026,'2973064','834','00','005010X220A1','2973064','','2014-02-27','14:20:32',0,'2014-02-28 06:30:45',NULL,NULL),(21572,4054,'3548315','834','00','005010X220A1','3548315','','2014-02-26','17:15:41',0,'2014-02-28 07:00:14',NULL,NULL),(21985,4145,'3072675','834','00','005010X220A1','3072675','','2014-03-01','21:31:29',0,'2014-03-03 01:00:15',NULL,NULL),(22543,4248,'3255811','834','00','005010X220A1','3255811','','2014-03-04','23:33:23',0,'2014-03-05 21:30:39',NULL,NULL),(22803,4278,'2632312','834','00','005010X220A1','2632312','','2014-03-05','19:44:02',0,'2014-03-06 21:01:06',NULL,NULL),(22938,4297,'3714966','834','00','005010X220A1','3714966','','2014-03-06','11:48:34',0,'2014-03-06 21:02:44',NULL,NULL),(806,156,'140445','834','00','005010X220A1','140445','','2013-10-31','12:40:49',0,'2013-12-25 18:10:24',NULL,NULL),(13314,2158,'0001','999','BE','005010X231A1','163334','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:51',NULL,NULL),(3488,615,'288152','834','00','005010X220A1','288152','','2013-12-12','11:09:35',0,'2013-12-25 22:00:47',NULL,NULL),(3241,578,'397530','834','00','005010X220A1','397530','','2013-12-17','15:34:54',0,'2013-12-25 21:46:35',NULL,NULL),(2997,542,'104377','834','00','005010X220A1','104377','','2013-12-13','14:13:33',0,'2013-12-25 21:33:02',NULL,NULL),(4639,827,'349611','834','00','005010X220A1','349611','','2013-12-23','23:50:44',0,'2013-12-25 23:48:32',NULL,NULL),(5773,1072,'524722','834','00','005010X220A1','524722','','2013-12-14','17:31:06',0,'2013-12-26 02:02:39',NULL,NULL),(2660,501,'1394130','834','00','005010X220A1','1394130','','2013-12-22','13:36:53',0,'2013-12-25 21:15:46',NULL,NULL),(7134,1236,'295959','834','00','005010X220A1','295959','','2013-12-18','17:20:45',0,'2013-12-26 04:04:35',NULL,NULL),(1272,243,'1992905','834','00','005010X220A1','1992905','','2013-12-24','15:50:58',0,'2013-12-25 18:49:54',NULL,NULL),(1059,207,'1081700','834','00','005010X220A1','1081700','','2013-11-29','09:45:09',0,'2013-12-25 18:30:33',NULL,NULL),(10931,1410,'75928','834','00','005010X220A1','75928','','2013-12-23','12:29:13',0,'2013-12-26 13:08:40',NULL,NULL),(12239,1618,'1708881','834','00','005010X220A1','1708881','','2014-01-01','15:31:54',1,'2014-01-02 04:23:00',NULL,NULL),(15468,2633,'2373804','834','00','005010X220A1','2373804','','2014-01-16','13:12:00',0,'2014-01-17 03:36:17',NULL,NULL),(16516,3014,'2607871','834','00','005010X220A1','2607871','','2014-01-23','22:27:32',0,'2014-01-24 21:00:52',NULL,NULL),(23224,4355,'2919413','834','00','005010X220A1','2919413','','2014-03-07','07:24:23',0,'2014-03-07 21:32:02',NULL,NULL),(17031,3120,'2013927','834','00','005010X220A1','2013927','','2014-01-29','14:29:41',0,'2014-01-29 21:01:14',NULL,NULL),(18336,3389,'2066317','834','00','005010X220A1','2066317','','2014-02-08','12:37:29',0,'2014-02-08 19:00:57',NULL,NULL),(19276,3582,'2156546','834','00','005010X220A1','2156546','','2014-02-13','09:13:37',0,'2014-02-13 22:00:55',NULL,NULL),(19297,3582,'3204994','834','00','005010X220A1','3204994','','2014-02-13','17:33:11',0,'2014-02-13 22:01:11',NULL,NULL),(19684,3665,'3528138','834','00','005010X220A1','3528138','','2014-02-15','09:01:27',0,'2014-02-15 21:00:07',NULL,NULL),(20241,3793,'2887092','834','00','005010X220A1','2887092','','2014-02-18','21:01:21',0,'2014-02-20 04:30:28',NULL,NULL),(20606,3870,'3210391','834','00','005010X220A1','3210391','','2014-02-21','16:26:02',0,'2014-02-21 22:00:20',NULL,NULL),(23682,4447,'3076574','834','00','005010X220A1','3076574','','2014-03-10','10:13:19',0,'2014-03-10 21:02:15',NULL,NULL),(1183,239,'1972896','834','00','005010X220A1','1972896','','2013-12-24','15:15:13',0,'2013-12-25 18:47:13',NULL,NULL),(5617,1044,'1701348','834','00','005010X220A1','1701348','','2013-12-25','00:19:30',0,'2013-12-26 01:50:14',NULL,NULL),(4350,759,'75707','834','00','005010X220A1','75707','','2013-12-19','14:55:51',0,'2013-12-25 23:10:47',NULL,NULL),(6307,1174,'334353','834','00','005010X220A1','334353','','2013-12-20','15:24:31',0,'2013-12-26 03:07:35',NULL,NULL),(6317,1175,'1349480','834','00','005010X220A1','1349480','','2013-12-20','13:39:56',0,'2013-12-26 03:07:54',NULL,NULL),(2327,409,'293720','834','00','005010X220A1','293720','','2013-10-08','11:27:51',0,'2013-12-25 20:02:11',NULL,NULL),(1635,281,'1055220','834','00','005010X220A1','1055220','','2013-11-19','23:07:47',0,'2013-12-25 19:02:04',NULL,NULL),(10644,1402,'1798024','834','00','005010X220A1','1798024','','2013-12-23','17:45:28',0,'2013-12-26 12:58:36',NULL,NULL),(1266,243,'570495','834','00','005010X220A1','570495','','2013-12-24','14:26:33',0,'2013-12-25 18:49:41',NULL,NULL),(11806,1539,'1269307','834','00','005010X220A1','1269307','','2013-12-28','20:09:00',1,'2013-12-29 11:13:15',NULL,NULL),(12057,1585,'2014355','834','00','005010X220A1','2014355','','2013-12-30','13:50:47',0,'2014-01-01 12:04:15',NULL,NULL),(12745,1687,'2173868','834','00','005010X220A1','2173868','','2014-01-02','13:16:17',0,'2014-01-03 02:06:30',NULL,NULL),(15497,2634,'2093252','834','00','005010X220A1','2093252','','2014-01-15','20:34:38',0,'2014-01-17 03:36:29',NULL,NULL),(15592,2659,'1550199','834','00','005010X220A1','1550199','','2014-01-17','15:06:53',0,'2014-01-20 08:06:21',NULL,NULL),(15610,2666,'2577494','834','00','005010X220A1','2577494','','2014-01-17','13:09:34',0,'2014-01-20 08:06:33',NULL,NULL),(17103,3142,'2003329','834','00','005010X220A1','2003329','','2014-01-30','09:15:28',0,'2014-01-30 21:00:08',NULL,NULL),(17384,3192,'1649350','834','00','005010X220A1','1649350','','2014-01-31','14:43:01',0,'2014-01-31 21:01:41',NULL,NULL),(17898,3295,'1754792','834','00','005010X220A1','1754792','','2014-02-05','10:42:54',0,'2014-02-05 21:30:30',NULL,NULL),(19198,3573,'3235527','834','00','005010X220A1','3235527','','2014-02-13','07:27:11',0,'2014-02-13 21:30:10',NULL,NULL),(19442,3603,'2636356','834','00','005010X220A1','2636356','','2014-02-13','13:36:09',0,'2014-02-13 22:03:01',NULL,NULL),(19780,3675,'2664344','834','00','005010X220A1','2664344','','2014-02-14','18:54:03',0,'2014-02-15 22:01:05',NULL,NULL),(20546,3861,'3250623','834','00','005010X220A1','3250623','','2014-02-21','10:25:10',0,'2014-02-21 21:30:03',NULL,NULL),(21507,4031,'3453772','834','00','005010X220A1','3453772','','2014-02-27','07:55:03',0,'2014-02-28 06:31:24',NULL,NULL),(21550,4045,'3136658','834','00','005010X220A1','3136658','','2014-02-27','12:27:11',0,'2014-02-28 06:31:44',NULL,NULL),(22432,4229,'3540884','834','00','005010X220A1','3540884','','2014-03-04','17:06:37',0,'2014-03-04 21:02:47',NULL,NULL),(23053,4339,'3876590','834','00','005010X220A1','3876590','','2014-03-06','18:01:56',0,'2014-03-07 21:30:01',NULL,NULL),(23290,4380,'3318722','834','00','005010X220A1','3318722','','2014-03-08','14:43:20',0,'2014-03-08 21:30:12',NULL,NULL),(23547,4435,'3388648','834','00','005010X220A1','3388648','','2014-03-10','14:29:22',0,'2014-03-10 21:00:38',NULL,NULL),(23653,4442,'3679513','834','00','005010X220A1','3679513','','2014-03-09','22:27:10',0,'2014-03-10 21:01:53',NULL,NULL),(287,62,'857371','834','00','005010X220A1','857371','','2013-11-09','10:27:12',0,'2013-12-25 17:32:14',NULL,NULL),(4507,810,'80385','834','00','005010X220A1','80385','','2013-11-26','11:42:11',0,'2013-12-25 23:32:17',NULL,NULL),(4099,733,'766204','834','00','005010X220A1','766204','','2013-12-19','11:08:26',0,'2013-12-25 23:03:13',NULL,NULL),(6149,1166,'588026','834','00','005010X220A1','588026','','2013-12-20','18:42:02',0,'2013-12-26 03:02:47',NULL,NULL),(3245,578,'185043','834','00','005010X220A1','185043','','2013-12-17','16:03:33',0,'2013-12-25 21:46:41',NULL,NULL),(457,83,'849510','834','00','005010X220A1','849510','','2013-12-04','14:38:04',0,'2013-12-25 17:50:11',NULL,NULL),(10507,1400,'475866','834','00','005010X220A1','475866','','2013-12-23','18:52:57',0,'2013-12-26 12:54:05',NULL,NULL),(11099,1425,'667762','834','00','005010X220A1','667762','','2013-12-22','21:51:43',0,'2013-12-26 13:14:04',NULL,NULL),(12908,1713,'2430377','834','00','005010X220A1','2430377','','2014-01-03','17:06:12',0,'2014-01-04 02:05:10',NULL,NULL),(15040,2584,'1604376','834','00','005010X220A1','1604376','','2014-01-15','17:43:09',0,'2014-01-16 08:44:43',NULL,NULL),(16451,3006,'2437731','834','00','005010X220A1','2437731','','2014-01-24','12:15:42',0,'2014-01-24 21:00:13',NULL,NULL),(17820,3273,'2432138','834','00','005010X220A1','2432138','','2014-02-04','18:13:41',0,'2014-02-04 21:01:46',NULL,NULL),(18268,3376,'2120940','834','00','005010X220A1','2120940','','2014-02-08','16:37:39',0,'2014-02-08 19:00:14',NULL,NULL),(19098,3543,'3330095','834','00','005010X220A1','3330095','','2014-02-12','12:03:04',0,'2014-02-12 21:31:36',NULL,NULL),(21357,4024,'3311494','834','00','005010X220A1','3311494','','2014-02-26','18:34:14',0,'2014-02-28 06:30:15',NULL,NULL),(23074,4339,'3313117','834','00','005010X220A1','3313117','','2014-03-07','10:50:46',0,'2014-03-07 21:30:16',NULL,NULL),(2173,362,'188201','834','00','005010X220A1','188201','','2013-12-02','16:42:17',0,'2013-12-25 19:47:15',NULL,NULL),(10489,1400,'1788350','834','00','005010X220A1','1788350','','2013-12-23','16:55:00',0,'2013-12-26 12:53:32',NULL,NULL),(3093,546,'851160','834','00','005010X220A1','851160','','2013-12-12','20:56:13',0,'2013-12-25 21:35:59',NULL,NULL),(2377,414,'914048','834','00','005010X220A1','914048','','2013-12-05','19:15:56',0,'2013-12-25 20:16:32',NULL,NULL),(2282,393,'221642','834','00','005010X220A1','221642','','2013-11-24','18:00:12',0,'2013-12-25 20:00:34',NULL,NULL),(2203,365,'1217824','834','00','005010X220A1','1217824','','2013-12-02','14:46:54',0,'2013-12-25 19:48:17',NULL,NULL),(14859,2553,'1885533','834','00','005010X220A1','1885533','','2014-01-14','18:30:39',0,'2014-01-15 02:07:10',NULL,NULL),(21244,3999,'3492371','834','00','005010X220A1','3492371','','2014-02-26','12:59:12',0,'2014-02-26 21:01:44',NULL,NULL),(22205,4185,'3700637','834','00','005010X220A1','3700637','','2014-03-03','14:51:24',0,'2014-03-03 21:31:35',NULL,NULL),(23611,4441,'3294758','834','00','005010X220A1','3294758','','2014-03-09','19:54:04',0,'2014-03-10 21:01:24',NULL,NULL),(23615,4441,'2989800','834','00','005010X220A1','2989800','','2014-03-10','00:02:17',0,'2014-03-10 21:01:26',NULL,NULL),(1430,252,'1016928','834','00','005010X220A1','1016928','','2013-12-24','08:01:33',0,'2013-12-25 18:55:03',NULL,NULL),(3006,543,'670696','834','00','005010X220A1','670696','','2013-12-13','08:49:14',0,'2013-12-25 21:33:18',NULL,NULL),(4161,734,'1121139','834','00','005010X220A1','1121139','','2013-12-18','23:15:08',0,'2013-12-25 23:05:01',NULL,NULL),(7455,1296,'1044552','834','00','005010X220A1','1044552','','2013-12-21','00:27:56',0,'2013-12-26 04:32:31',NULL,NULL),(7609,1303,'160419','834','00','005010X220A1','160419','','2013-12-21','13:49:39',0,'2013-12-26 04:37:32',NULL,NULL),(2046,334,'920805','834','00','005010X220A1','920805','','2013-12-09','08:31:17',0,'2013-12-25 19:36:17',NULL,NULL),(12032,1583,'1885132','834','00','005010X220A1','1885132','','2013-12-30','14:32:26',0,'2014-01-01 12:03:18',NULL,NULL),(14753,2551,'1455106','834','00','005010X220A1','1455106','','2014-01-13','18:59:45',0,'2014-01-15 02:06:25',NULL,NULL),(15386,2624,'1447865','834','00','005010X220A1','1447865','','2014-01-15','19:27:33',0,'2014-01-17 03:35:40',NULL,NULL),(15396,2626,'2507261','834','00','005010X220A1','2507261','','2014-01-15','18:45:57',0,'2014-01-17 03:35:45',NULL,NULL),(647,108,'1265605','834','00','005010X220A1','1265605','','2013-12-16','15:30:29',0,'2013-12-25 18:05:08',NULL,NULL),(13528,2240,'2491163','834','00','005010X220A1','2491163','','2014-01-06','13:05:13',0,'2014-01-07 04:05:43',NULL,NULL),(5274,973,'631153','834','00','005010X220A1','631153','','2013-11-12','15:31:39',0,'2013-12-26 01:00:27',NULL,NULL),(4165,734,'1306655','834','00','005010X220A1','1306655','','2013-12-19','09:55:13',0,'2013-12-25 23:05:08',NULL,NULL),(3283,583,'188704','834','00','005010X220A1','188704','','2013-12-17','15:58:01',0,'2013-12-25 21:47:55',NULL,NULL),(2932,541,'557300','834','00','005010X220A1','557300','','2013-12-12','20:35:07',0,'2013-12-25 21:31:00',NULL,NULL),(11427,1473,'1361537','834','00','005010X220A1','1361537','','2013-12-26','12:23:57',0,'2013-12-27 02:07:25',NULL,NULL),(11694,1517,'2351461','834','00','005010X220A1','2351461','','2013-12-27','19:45:23',1,'2013-12-29 11:07:44',NULL,NULL),(12818,1704,'2478898','834','00','005010X220A1','2478898','','2014-01-02','20:59:13',0,'2014-01-04 02:01:55',NULL,NULL),(10528,1401,'825743','834','00','005010X220A1','825743','','2013-12-23','12:47:12',0,'2013-12-26 12:54:46',NULL,NULL),(1340,245,'299861','834','00','005010X220A1','299861','','2013-12-24','12:41:08',0,'2013-12-25 18:52:03',NULL,NULL),(10778,1404,'72074','834','00','005010X220A1','72074','','2013-12-23','09:13:57',0,'2013-12-26 13:03:10',NULL,NULL),(13370,2214,'0001','999','BE','005010X231A1','1262648','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:27',NULL,NULL),(13965,2322,'2197506','834','00','005010X220A1','2197506','','2014-01-09','16:10:50',0,'2014-01-13 02:20:31',NULL,NULL),(15356,2623,'1699547','834','00','005010X220A1','1699547','','2014-01-16','12:00:17',0,'2014-01-17 03:35:26',NULL,NULL),(16626,3051,'2149934','834','00','005010X220A1','2149934','','2014-01-26','13:28:18',0,'2014-01-26 19:00:21',NULL,NULL),(17447,3205,'2255000','834','00','005010X220A1','2255000','','2014-02-01','14:49:48',0,'2014-02-01 19:00:39',NULL,NULL),(22879,4281,'3366970','834','00','005010X220A1','3366970','','2014-03-06','16:08:54',0,'2014-03-06 21:02:01',NULL,NULL),(22894,4284,'3593374','834','00','005010X220A1','3593374','','2014-03-06','12:14:24',0,'2014-03-06 21:02:11',NULL,NULL),(23294,4380,'2876032','834','00','005010X220A1','2876032','','2014-03-08','16:46:20',0,'2014-03-08 21:30:15',NULL,NULL),(1505,258,'391674','834','00','005010X220A1','391674','','2013-12-24','11:20:09',0,'2013-12-25 18:57:31',NULL,NULL),(3960,716,'1011224','834','00','005010X220A1','1011224','','2013-12-06','21:21:44',0,'2013-12-25 22:46:54',NULL,NULL),(5267,972,'186618','834','00','005010X220A1','186618','','2013-11-12','17:04:18',0,'2013-12-26 01:00:15',NULL,NULL),(5276,975,'1105946','834','00','005010X220A1','1105946','','2013-11-12','13:30:30',0,'2013-12-26 01:00:34',NULL,NULL),(5444,1034,'183144','834','00','005010X220A1','183144','','2013-11-03','09:06:26',0,'2013-12-26 01:31:46',NULL,NULL),(5980,1121,'210183','834','00','005010X220A1','210183','','2013-12-15','14:19:38',0,'2013-12-26 02:33:20',NULL,NULL),(6207,1168,'1118672','834','00','005010X220A1','1118672','','2013-12-19','20:14:09',0,'2013-12-26 03:04:31',NULL,NULL),(3182,569,'1246656','834','00','005010X220A1','1246656','','2013-12-13','13:10:36',0,'2013-12-25 21:38:55',NULL,NULL),(3155,560,'169588','834','00','005010X220A1','169588','','2013-12-13','09:39:46',0,'2013-12-25 21:37:55',NULL,NULL),(2478,432,'1205094','834','00','005010X220A1','1205094','','2013-12-06','17:00:39',0,'2013-12-25 20:19:47',NULL,NULL),(18702,3481,'2845107','834','00','005010X220A1','2845107','','2014-02-10','14:13:00',0,'2014-02-10 21:32:16',NULL,NULL),(15836,2737,'1480916','834','00','005010X220A1','1480916','','2014-01-21','00:15:26',1,'2014-01-22 03:22:00',NULL,NULL),(16202,2894,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:01:00',1,'2014-01-23 04:51:15',NULL,NULL),(688,109,'461400','834','00','005010X220A1','461400','','2013-12-16','17:41:15',0,'2013-12-25 18:06:21',NULL,NULL),(2400,415,'184677','834','00','005010X220A1','184677','','2013-12-05','21:45:26',0,'2013-12-25 20:17:13',NULL,NULL),(1951,326,'581641','834','00','005010X220A1','581641','','2013-12-09','12:03:33',0,'2013-12-25 19:33:15',NULL,NULL),(2879,522,'1451803','834','00','005010X220A1','1451803','','2013-12-22','10:23:03',0,'2013-12-25 21:22:58',NULL,NULL),(3224,578,'1197949','834','00','005010X220A1','1197949','','2013-12-17','11:14:34',0,'2013-12-25 21:46:02',NULL,NULL),(20364,3821,'3438599','834','00','005010X220A1','3438599','','2014-02-19','08:28:01',0,'2014-02-20 05:31:10',NULL,NULL),(18624,3459,'2108922','834','00','005010X220A1','2108922','','2014-02-10','11:29:23',0,'2014-02-10 21:31:21',NULL,NULL),(15453,2632,'2109695','834','00','005010X220A1','2109695','','2014-01-15','21:45:07',0,'2014-01-17 03:36:11',NULL,NULL),(1293,244,'1566246','834','00','005010X220A1','1566246','','2013-12-24','10:09:00',0,'2013-12-25 18:50:34',NULL,NULL),(7598,1303,'566384','834','00','005010X220A1','566384','','2013-12-20','21:50:55',0,'2013-12-26 04:37:14',NULL,NULL),(1041,203,'655388','834','00','005010X220A1','655388','','2013-12-03','16:55:11',0,'2013-12-25 18:21:34',NULL,NULL),(11836,1543,'1836338','834','00','005010X220A1','1836338','','2013-12-28','20:20:19',1,'2013-12-29 11:14:15',NULL,NULL),(11103,1425,'1669698','834','00','005010X220A1','1669698','','2013-12-23','13:20:37',0,'2013-12-26 13:14:13',NULL,NULL),(14648,2530,'2203838','834','00','005010X220A1','2203838','','2014-01-13','13:43:10',0,'2014-01-14 01:33:37',NULL,NULL),(2164,362,'321564','834','00','005010X220A1','321564','','2013-12-02','11:45:40',0,'2013-12-25 19:46:53',NULL,NULL),(2124,360,'113072','834','00','005010X220A1','113072','','2013-12-02','11:54:18',0,'2013-12-25 19:45:38',NULL,NULL),(12803,1703,'2235461','834','00','005010X220A1','2235461','','2014-01-03','13:57:44',0,'2014-01-04 02:01:22',NULL,NULL),(19771,3675,'2953903','834','00','005010X220A1','2953903','','2014-02-15','10:51:11',0,'2014-02-15 22:00:59',NULL,NULL),(11702,1517,'2024726','834','00','005010X220A1','2024726','','2013-12-27','23:05:49',1,'2013-12-29 11:07:57',NULL,NULL),(17071,3128,'1851161','834','00','005010X220A1','1851161','','2014-01-29','17:06:02',0,'2014-01-29 21:01:40',NULL,NULL),(12670,1673,'2569548','834','00','005010X220A1','2569548','','2014-01-02','16:27:25',0,'2014-01-03 02:03:40',NULL,NULL),(6361,1181,'722691','834','00','005010X220A1','722691','','2013-12-19','21:17:19',0,'2013-12-26 03:09:13',NULL,NULL),(6205,1168,'680315','834','00','005010X220A1','680315','','2013-12-19','20:11:39',0,'2013-12-26 03:04:28',NULL,NULL),(2496,443,'937596','834','00','005010X220A1','937596','','2013-12-06','13:27:14',0,'2013-12-25 20:20:25',NULL,NULL),(3939,714,'327666','834','00','005010X220A1','327666','','2013-12-07','12:43:03',0,'2013-12-25 22:46:12',NULL,NULL),(12495,1641,'1693593','834','00','005010X220A1','1693593','','2013-12-31','16:12:57',1,'2014-01-02 04:33:11',NULL,NULL),(20248,3791,'2608503','834','00','005010X220A1','2608503','','2014-02-19','17:35:56',0,'2014-02-20 04:31:48',NULL,NULL),(22918,4287,'3354223','834','00','005010X220A1','3354223','','2014-03-06','14:25:34',0,'2014-03-06 21:02:29',NULL,NULL),(6070,1164,'7913','834','00','005010X220A1','7913','','2013-12-20','15:23:21',0,'2013-12-26 03:00:21',NULL,NULL),(4019,731,'455515','834','00','005010X220A1','455515','','2013-12-19','12:32:14',0,'2013-12-25 23:00:42',NULL,NULL),(10846,1405,'319732','834','00','005010X220A1','319732','','2013-12-23','07:11:44',0,'2013-12-26 13:05:21',NULL,NULL),(2160,362,'810567','834','00','005010X220A1','810567','','2013-12-01','23:53:28',0,'2013-12-25 19:46:47',NULL,NULL),(17351,3181,'2008329','834','00','005010X220A1','2008329','','2014-01-31','12:02:10',0,'2014-01-31 21:01:18',NULL,NULL),(5579,1043,'1846738','834','00','005010X220A1','1846738','','2013-12-24','22:25:12',0,'2013-12-26 01:48:58',NULL,NULL),(16928,3115,'1573510','834','00','005010X220A1','1573510','','2014-01-28','19:26:57',0,'2014-01-29 21:00:09',NULL,NULL),(14200,2365,'2122877','834','00','005010X220A1','2122877','','2014-01-10','14:12:11',0,'2014-01-13 02:23:43',NULL,NULL),(723,121,'978263','834','00','005010X220A1','978263','','2013-12-16','11:19:19',0,'2013-12-25 18:07:31',NULL,NULL),(21004,3960,'2031205','834','00','005010X220A1','2031205','','2014-02-22','16:52:29',0,'2014-02-26 08:30:41',NULL,NULL),(1393,245,'1509453','834','00','005010X220A1','1509453','','2013-12-24','17:57:51',0,'2013-12-25 18:53:48',NULL,NULL),(11453,1488,'1787284','834','00','005010X220A1','1787284','','2013-12-26','19:59:41',0,'2013-12-28 03:30:15',NULL,NULL),(11202,1454,'1067751','834','00','005010X220A1','1067751','','2013-12-25','19:42:39',0,'2013-12-27 02:00:30',NULL,NULL),(19598,3631,'1859468','834','00','005010X220A1','1859468','','2014-02-14','10:45:22',0,'2014-02-14 21:31:36',NULL,NULL),(10922,1410,'342608','834','00','005010X220A1','342608','','2013-12-23','10:03:27',0,'2013-12-26 13:08:23',NULL,NULL),(18213,3356,'2962022','834','00','005010X220A1','2962022','','2014-02-06','23:08:19',0,'2014-02-07 19:00:42',NULL,NULL),(6044,1153,'1143861','834','00','005010X220A1','1143861','','2013-10-13','20:36:45',0,'2013-12-26 02:46:22',NULL,NULL),(16601,3047,'2118504','834','00','005010X220A1','2118504','','2014-01-26','11:07:02',0,'2014-01-26 19:00:03',NULL,NULL),(15672,2686,'2093301','834','00','005010X220A1','2093301','','2014-01-18','12:55:12',0,'2014-01-21 08:44:40',NULL,NULL),(14675,2548,'2449065','834','00','005010X220A1','2449065','','2014-01-13','21:54:22',0,'2014-01-15 02:05:51',NULL,NULL),(14492,2513,'0001','999','BE','005010X231A1','658045','834','2013-12-28','04:55:00',0,'2014-01-13 03:04:02',NULL,NULL),(3453,608,'1317304','834','00','005010X220A1','1317304','','2013-12-17','12:20:10',0,'2013-12-25 21:53:26',NULL,NULL),(13217,2061,'0001','999','BE','005010X231A1','821786','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:39',NULL,NULL),(20323,3794,'2873065','834','00','005010X220A1','2873065','','2014-02-19','17:47:13',0,'2014-02-20 04:48:41',NULL,NULL),(7641,1309,'21159','834','00','005010X220A1','21159','','2013-12-21','14:23:14',0,'2013-12-26 04:38:33',NULL,NULL),(15484,2634,'2147192','834','00','005010X220A1','2147192','','2014-01-16','12:06:16',0,'2014-01-17 03:36:24',NULL,NULL),(11896,1561,'1477874','834','00','005010X220A1','1477874','','2013-12-29','12:05:25',0,'2013-12-30 00:00:53',NULL,NULL),(19551,3626,'3289028','834','00','005010X220A1','3289028','','2014-02-13','22:27:51',0,'2014-02-14 21:31:02',NULL,NULL),(3567,617,'143761','834','00','005010X220A1','143761','','2013-12-11','20:57:34',0,'2013-12-25 22:03:20',NULL,NULL),(15653,2683,'2218286','834','00','005010X220A1','2218286','','2014-01-18','11:33:09',0,'2014-01-21 08:44:26',NULL,NULL),(15436,2629,'2033292','834','00','005010X220A1','2033292','','2014-01-15','19:46:56',0,'2014-01-17 03:36:04',NULL,NULL),(2335,412,'1026076','834','00','005010X220A1','1026076','','2013-12-06','14:02:41',0,'2013-12-25 20:15:09',NULL,NULL),(3358,587,'1018816','834','00','005010X220A1','1018816','','2013-12-17','10:39:41',0,'2013-12-25 21:50:23',NULL,NULL),(7188,1239,'229819','834','00','005010X220A1','229819','','2013-12-18','11:28:52',0,'2013-12-26 04:06:16',NULL,NULL),(16385,2988,'1796257','834','00','005010X220A1','1796257','','2014-01-22','21:52:57',0,'2014-01-23 21:01:13',NULL,NULL),(3561,617,'1036224','834','00','005010X220A1','1036224','','2013-12-11','18:43:57',0,'2013-12-25 22:03:10',NULL,NULL),(15761,2714,'1583432','834','00','005010X220A1','1583432','','2014-01-20','12:19:40',0,'2014-01-21 08:46:23',NULL,NULL),(10637,1402,'1536237','834','00','005010X220A1','1536237','','2013-12-23','16:57:56',0,'2013-12-26 12:58:23',NULL,NULL),(4904,905,'474734','834','00','005010X220A1','474734','','2013-10-23','00:51:25',0,'2013-12-26 00:30:15',NULL,NULL),(7389,1293,'1226239','834','00','005010X220A1','1226239','','2013-12-21','13:32:04',0,'2013-12-26 04:30:28',NULL,NULL),(1687,291,'627863','834','00','005010X220A1','627863','','2013-12-10','14:33:09',0,'2013-12-25 19:16:04',NULL,NULL),(7537,1300,'824141','834','00','005010X220A1','824141','','2013-12-21','15:18:26',0,'2013-12-26 04:35:11',NULL,NULL),(11375,1460,'1960036','834','00','005010X220A1','1960036','','2013-12-26','13:44:47',0,'2013-12-27 02:05:48',NULL,NULL),(11489,1488,'2273408','834','00','005010X220A1','2273408','','2013-12-27','18:10:50',0,'2013-12-28 03:31:20',NULL,NULL),(15407,2627,'1569486','834','00','005010X220A1','1569486','','2014-01-15','18:36:01',0,'2014-01-17 03:35:50',NULL,NULL),(2385,414,'592012','834','00','005010X220A1','592012','','2013-12-06','17:53:01',0,'2013-12-25 20:16:46',NULL,NULL),(2608,485,'69641','834','00','005010X220A1','69641','','2013-10-05','19:59:55',0,'2013-12-25 20:46:14',NULL,NULL),(13429,2222,'1827887','834','00','005010X220A1','1827887','','2014-01-06','17:08:01',0,'2014-01-07 04:01:53',NULL,NULL),(23536,4435,'3186617','834','00','005010X220A1','3186617','','2014-03-10','09:41:22',0,'2014-03-10 21:00:28',NULL,NULL),(22239,4199,'3011787','834','00','005010X220A1','3011787','','2014-03-04','12:04:45',0,'2014-03-04 21:00:11',NULL,NULL),(18557,3453,'2463829','834','00','005010X220A1','2463829','','2014-02-09','18:36:08',0,'2014-02-10 21:30:33',NULL,NULL),(3024,544,'86013','834','00','005010X220A1','86013','','2013-12-13','17:40:23',0,'2013-12-25 21:33:50',NULL,NULL),(15989,2765,'1993675','834','00','005010X220A1','1993675','','2014-01-22','14:31:18',0,'2014-01-23 03:02:08',NULL,NULL),(1869,324,'642423','834','00','005010X220A1','642423','','2013-12-09','16:02:52',0,'2013-12-25 19:30:49',NULL,NULL),(10716,1403,'1560982','834','00','005010X220A1','1560982','','2013-12-23','12:55:55',0,'2013-12-26 13:01:05',NULL,NULL),(1885,325,'228156','834','00','005010X220A1','228156','','2013-12-09','07:21:42',0,'2013-12-25 19:31:22',NULL,NULL),(29,1,'163371','834','00','005010X220A1','163371','','2013-12-05','12:35:45',0,'2013-12-25 17:15:52',NULL,NULL),(12924,1717,'2027409','834','00','005010X220A1','2027409','','2014-01-03','10:05:19',0,'2014-01-04 02:05:49',NULL,NULL),(12799,1703,'1828864','834','00','005010X220A1','1828864','','2014-01-03','12:12:57',0,'2014-01-04 02:01:14',NULL,NULL),(3098,546,'146358','834','00','005010X220A1','146358','','2013-12-13','09:27:28',0,'2013-12-25 21:36:08',NULL,NULL),(5808,1080,'1156324','834','00','005010X220A1','1156324','','2013-12-14','14:54:27',0,'2013-12-26 02:03:48',NULL,NULL),(2482,434,'925733','834','00','005010X220A1','925733','','2013-12-05','22:22:41',0,'2013-12-25 20:19:54',NULL,NULL),(7164,1238,'575635','834','00','005010X220A1','575635','','2013-12-18','10:30:57',0,'2013-12-26 04:05:31',NULL,NULL),(1815,311,'1482','834','00','005010X220A1','1482','','2013-12-10','12:27:23',0,'2013-12-25 19:20:06',NULL,NULL),(11819,1539,'554179','834','00','005010X220A1','554179','','2013-12-28','20:25:18',1,'2013-12-29 11:13:42',NULL,NULL),(12010,1583,'1840499','834','00','005010X220A1','1840499','','2013-12-30','00:02:43',0,'2014-01-01 12:02:29',NULL,NULL),(12079,1586,'1887456','834','00','005010X220A1','1887456','','2013-12-30','13:29:10',0,'2014-01-01 12:04:59',NULL,NULL),(12490,1641,'1932191','834','00','005010X220A1','1932191','','2013-12-30','21:27:05',1,'2014-01-02 04:32:56',NULL,NULL),(1778,299,'936552','834','00','005010X220A1','936552','','2013-12-09','19:34:59',0,'2013-12-25 19:18:53',NULL,NULL),(471,89,'958976','834','00','005010X220A1','958976','','2013-12-04','13:07:58',0,'2013-12-25 17:50:42',NULL,NULL),(10438,1400,'497060','834','00','005010X220A1','497060','','2013-12-23','11:39:52',0,'2013-12-26 12:51:53',NULL,NULL),(195,17,'90964','834','00','005010X220A1','90964','','2013-12-05','18:00:42',0,'2013-12-25 17:21:03',NULL,NULL),(11196,1453,'823098','834','00','005010X220A1','823098','','2013-12-26','15:07:08',0,'2013-12-27 02:00:18',NULL,NULL),(14621,2524,'2269275','834','00','005010X220A1','2269275','','2014-01-13','11:39:05',0,'2014-01-14 01:33:20',NULL,NULL);
INSERT INTO `EdiTransaction` VALUES (14944,2561,'1413954','834','00','005010X220A1','1413954','','2014-01-14','16:52:43',0,'2014-01-15 02:07:49',NULL,NULL),(15177,2591,'1663256','834','00','005010X220A1','1663256','','2014-01-15','14:15:18',0,'2014-01-16 08:46:11',NULL,NULL),(15909,2743,'1772305','834','00','005010X220A1','1772305','','2014-01-21','11:17:29',1,'2014-01-22 03:22:47',NULL,NULL),(16197,2889,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 04:45:37',NULL,NULL),(16308,2980,'2494102','834','00','005010X220A1','2494102','','2014-01-23','12:20:40',0,'2014-01-23 21:00:19',NULL,NULL),(16331,2983,'1560526','834','00','005010X220A1','1560526','','2014-01-22','22:07:35',0,'2014-01-23 21:00:36',NULL,NULL),(16882,3094,'2220822','834','00','005010X220A1','2220822','','2014-01-27','20:44:05',0,'2014-01-28 21:01:01',NULL,NULL),(16999,3118,'2456929','834','00','005010X220A1','2456929','','2014-01-29','11:46:36',0,'2014-01-29 21:00:53',NULL,NULL),(17441,3205,'1667009','834','00','005010X220A1','1667009','','2014-02-01','11:58:53',0,'2014-02-01 19:00:35',NULL,NULL),(18139,3339,'2900469','834','00','005010X220A1','2900469','','2014-02-06','14:35:16',0,'2014-02-06 21:01:46',NULL,NULL),(20749,3903,'3062940','834','00','005010X220A1','3062940','','2014-02-25','14:30:47',0,'2014-02-25 21:30:18',NULL,NULL),(22581,4248,'3633444','834','00','005010X220A1','3633444','','2014-03-05','16:14:34',0,'2014-03-05 21:31:05',NULL,NULL),(23205,4347,'3475560','834','00','005010X220A1','3475560','','2014-03-07','10:40:38',0,'2014-03-07 21:31:49',NULL,NULL),(3186,572,'438481','834','00','005010X220A1','438481','','2013-12-13','16:58:59',0,'2013-12-25 21:39:04',NULL,NULL),(13163,2007,'0001','999','BE','005010X231A1','603024','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:09',NULL,NULL),(4321,750,'1179694','834','00','005010X220A1','1179694','','2013-12-19','16:55:13',0,'2013-12-25 23:09:52',NULL,NULL),(3448,606,'739852','834','00','005010X220A1','739852','','2013-12-17','11:36:19',0,'2013-12-25 21:53:16',NULL,NULL),(5305,987,'44988','834','00','005010X220A1','44988','','2013-11-04','22:13:41',0,'2013-12-26 01:01:37',NULL,NULL),(10906,1409,'1473900','834','00','005010X220A1','1473900','','2013-12-23','15:34:31',0,'2013-12-26 13:07:49',NULL,NULL),(11078,1422,'981032','834','00','005010X220A1','981032','','2013-12-23','09:47:57',0,'2013-12-26 13:13:24',NULL,NULL),(3277,583,'610957','834','00','005010X220A1','610957','','2013-12-16','22:50:01',0,'2013-12-25 21:47:44',NULL,NULL),(14206,2365,'2257985','834','00','005010X220A1','2257985','','2014-01-10','15:23:03',0,'2014-01-13 02:23:48',NULL,NULL),(16475,3008,'1466492','834','00','005010X220A1','1466492','','2014-01-24','13:32:42',0,'2014-01-24 21:00:26',NULL,NULL),(16841,3092,'2292945','834','00','005010X220A1','2292945','','2014-01-27','19:16:35',0,'2014-01-28 21:00:33',NULL,NULL),(17127,3143,'1804001','834','00','005010X220A1','1804001','','2014-01-30','16:35:05',0,'2014-01-30 21:00:22',NULL,NULL),(19461,3614,'1990233','834','00','005010X220A1','1990233','','2014-02-13','15:06:25',0,'2014-02-13 22:03:16',NULL,NULL),(20245,3791,'2775540','834','00','005010X220A1','2775540','','2014-02-19','14:24:54',0,'2014-02-20 04:31:08',NULL,NULL),(20348,3808,'2288489','834','00','005010X220A1','2288489','','2014-02-19','11:36:05',0,'2014-02-20 04:54:16',NULL,NULL),(20369,3822,'3533628','834','00','005010X220A1','3533628','','2014-02-19','09:54:01',0,'2014-02-20 05:32:45',NULL,NULL),(20504,3846,'2931128','834','00','005010X220A1','2931128','','2014-02-20','17:31:31',0,'2014-02-20 22:01:07',NULL,NULL),(20698,3892,'3171124','834','00','005010X220A1','3171124','','2014-02-24','19:15:01',0,'2014-02-25 21:00:10',NULL,NULL),(20748,3903,'2951612','834','00','005010X220A1','2951612','','2014-02-25','13:46:47',0,'2014-02-25 21:30:17',NULL,NULL),(20842,3911,'3771989','834','00','005010X220A1','3771989','','2014-02-25','13:04:28',0,'2014-02-25 21:31:24',NULL,NULL),(3383,587,'523711','834','00','005010X220A1','523711','','2013-12-17','17:08:02',0,'2013-12-25 21:51:10',NULL,NULL),(4343,757,'1137301','834','00','005010X220A1','1137301','','2013-12-19','16:41:19',0,'2013-12-25 23:10:33',NULL,NULL),(4405,778,'673040','834','00','005010X220A1','673040','','2013-11-26','20:36:21',0,'2013-12-25 23:16:06',NULL,NULL),(4633,827,'692409','834','00','005010X220A1','692409','','2013-12-23','23:18:57',0,'2013-12-25 23:48:20',NULL,NULL),(4303,749,'751963','834','00','005010X220A1','751963','','2013-12-19','01:28:17',0,'2013-12-25 23:09:24',NULL,NULL),(3648,625,'665981','834','00','005010X220A1','665981','','2013-12-11','20:53:34',0,'2013-12-25 22:05:51',NULL,NULL),(14545,2518,'2202740','834','00','005010X220A1','2202740','','2014-01-13','16:54:45',0,'2014-01-14 01:32:31',NULL,NULL),(16224,2916,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:07:00',0,'2014-01-23 06:30:02',NULL,NULL),(18935,3522,'2438130','834','00','005010X220A1','2438130','','2014-02-10','19:59:47',0,'2014-02-11 21:30:14',NULL,NULL),(23488,4430,'3587059','834','00','005010X220A1','3587059','','2014-03-09','13:14:28',0,'2014-03-09 21:30:02',NULL,NULL),(23687,4448,'3735989','834','00','005010X220A1','3735989','','2014-03-10','13:05:31',0,'2014-03-10 21:02:18',NULL,NULL),(139,9,'773167','834','00','005010X220A1','773167','','2013-12-05','17:19:17',0,'2013-12-25 17:19:17',NULL,NULL),(12338,1634,'2448730','834','00','005010X220A1','2448730','','2013-12-31','11:33:56',1,'2014-01-02 04:27:30',NULL,NULL),(185,16,'485130','834','00','005010X220A1','485130','','2013-12-05','11:26:12',0,'2013-12-25 17:20:44',NULL,NULL),(3370,587,'768605','834','00','005010X220A1','768605','','2013-12-17','13:14:02',0,'2013-12-25 21:50:45',NULL,NULL),(7528,1300,'1194723','834','00','005010X220A1','1194723','','2013-12-21','13:51:39',0,'2013-12-26 04:34:56',NULL,NULL),(4072,733,'625601','834','00','005010X220A1','625601','','2013-12-18','19:06:52',0,'2013-12-25 23:02:26',NULL,NULL),(4365,765,'284940','834','00','005010X220A1','284940','','2013-12-19','17:01:51',0,'2013-12-25 23:11:14',NULL,NULL),(5938,1113,'604990','834','00','005010X220A1','604990','','2013-12-14','19:49:19',0,'2013-12-26 02:31:58',NULL,NULL),(5837,1092,'613954','834','00','005010X220A1','613954','','2013-11-23','09:44:17',0,'2013-12-26 02:15:38',NULL,NULL),(13054,1898,'0001','999','BE','005010X231A1','328619','834','2013-12-28','04:55:00',0,'2014-01-05 16:51:31',NULL,NULL),(13412,2222,'1738987','834','00','005010X220A1','1738987','','2014-01-06','06:55:01',0,'2014-01-07 04:01:17',NULL,NULL),(13681,2272,'2096311','834','00','005010X220A1','2096311','','2014-01-07','11:50:32',0,'2014-01-08 18:24:21',NULL,NULL),(14615,2523,'1849459','834','00','005010X220A1','1849459','','2014-01-13','15:57:28',0,'2014-01-14 01:33:16',NULL,NULL),(14646,2530,'1557859','834','00','005010X220A1','1557859','','2014-01-13','12:01:18',0,'2014-01-14 01:33:36',NULL,NULL),(18098,3327,'1590843','834','00','005010X220A1','1590843','','2014-02-06','15:18:13',0,'2014-02-06 21:01:15',NULL,NULL),(18200,3355,'2956008','834','00','005010X220A1','2956008','','2014-02-06','18:35:47',0,'2014-02-07 19:00:33',NULL,NULL),(18205,3356,'2682025','834','00','005010X220A1','2682025','','2014-02-06','18:45:09',0,'2014-02-07 19:00:37',NULL,NULL),(18320,3384,'1743630','834','00','005010X220A1','1743630','','2014-02-08','17:35:23',0,'2014-02-08 19:00:47',NULL,NULL),(19790,3677,'3500879','834','00','005010X220A1','3500879','','2014-02-14','23:02:34',0,'2014-02-15 22:01:14',NULL,NULL),(20744,3903,'3556859','834','00','005010X220A1','3556859','','2014-02-25','12:30:34',0,'2014-02-25 21:30:14',NULL,NULL),(20889,3922,'3249595','834','00','005010X220A1','3249595','','2014-02-25','14:04:45',0,'2014-02-25 21:32:00',NULL,NULL),(21703,4087,'3327879','834','00','005010X220A1','3327879','','2014-02-28','14:41:30',0,'2014-02-28 21:30:14',NULL,NULL),(23444,4408,'3115966','834','00','005010X220A1','3115966','','2014-03-08','21:35:41',0,'2014-03-09 21:00:45',NULL,NULL),(23638,4441,'2987320','834','00','005010X220A1','2987320','','2014-03-10','13:44:57',0,'2014-03-10 21:01:42',NULL,NULL),(23642,4441,'2968228','834','00','005010X220A1','2968228','','2014-03-10','14:25:06',0,'2014-03-10 21:01:45',NULL,NULL),(537,102,'1023854','834','00','005010X220A1','1023854','','2013-12-16','16:43:35',0,'2013-12-25 18:01:36',NULL,NULL),(2194,364,'204638','834','00','005010X220A1','204638','','2013-12-02','13:32:22',0,'2013-12-25 19:47:59',NULL,NULL),(3337,586,'689552','834','00','005010X220A1','689552','','2013-12-17','16:30:45',0,'2013-12-25 21:49:43',NULL,NULL),(3711,633,'928699','834','00','005010X220A1','928699','','2013-12-12','17:02:44',0,'2013-12-25 22:07:54',NULL,NULL),(3924,712,'68644','834','00','005010X220A1','68644','','2013-12-07','14:19:50',0,'2013-12-25 22:45:46',NULL,NULL),(4138,733,'1086139','834','00','005010X220A1','1086139','','2013-12-19','15:57:17',0,'2013-12-25 23:04:19',NULL,NULL),(5596,1043,'1926680','834','00','005010X220A1','1926680','','2013-12-25','13:30:24',0,'2013-12-26 01:49:32',NULL,NULL),(1808,310,'1163464','834','00','005010X220A1','1163464','','2013-12-10','11:45:44',0,'2013-12-25 19:19:55',NULL,NULL),(5780,1074,'1210510','834','00','005010X220A1','1210510','','2013-12-14','13:09:51',0,'2013-12-26 02:02:55',NULL,NULL),(7628,1308,'944425','834','00','005010X220A1','944425','','2013-12-21','14:45:57',0,'2013-12-26 04:38:10',NULL,NULL),(11254,1454,'2072368','834','00','005010X220A1','2072368','','2013-12-26','16:20:13',0,'2013-12-27 02:02:06',NULL,NULL),(1344,245,'175649','834','00','005010X220A1','175649','','2013-12-24','13:07:16',0,'2013-12-25 18:52:12',NULL,NULL),(12760,1696,'1942080','834','00','005010X220A1','1942080','','2014-01-02','09:19:27',0,'2014-01-03 02:07:06',NULL,NULL),(13904,2313,'1802282','834','00','005010X220A1','1802282','','2014-01-09','16:42:14',0,'2014-01-13 02:19:48',NULL,NULL),(13998,2331,'1555338','834','00','005010X220A1','1555338','','2014-01-09','16:15:28',0,'2014-01-13 02:20:56',NULL,NULL),(16073,2774,'1614650','834','00','005010X220A1','1614650','','2014-01-22','14:09:03',0,'2014-01-23 03:02:46',NULL,NULL),(16764,3071,'1688982','834','00','005010X220A1','1688982','','2014-01-27','10:51:04',0,'2014-01-27 21:01:29',NULL,NULL),(17561,3236,'2383052','834','00','005010X220A1','2383052','','2014-02-03','11:04:14',0,'2014-02-03 21:00:33',NULL,NULL),(17906,3295,'2489457','834','00','005010X220A1','2489457','','2014-02-05','16:13:56',0,'2014-02-05 21:30:34',NULL,NULL),(17993,3315,'1754800','834','00','005010X220A1','1754800','','2014-02-05','14:35:39',0,'2014-02-05 21:31:18',NULL,NULL),(18796,3487,'2336119','834','00','005010X220A1','2336119','','2014-02-11','13:54:49',0,'2014-02-11 21:01:12',NULL,NULL),(21510,4032,'3205343','834','00','005010X220A1','3205343','','2014-02-26','20:06:15',0,'2014-02-28 06:31:26',NULL,NULL),(49,3,'589789','834','00','005010X220A1','589789','','2013-12-04','20:27:40',0,'2013-12-25 17:16:27',NULL,NULL),(5677,1056,'1612705','834','00','005010X220A1','1612705','','2013-12-24','20:51:57',0,'2013-12-26 01:52:18',NULL,NULL),(5419,1025,'370176','834','00','005010X220A1','370176','','2013-11-14','13:44:26',0,'2013-12-26 01:30:55',NULL,NULL),(12383,1637,'2246925','834','00','005010X220A1','2246925','','2013-12-30','23:28:41',1,'2014-01-02 04:29:04',NULL,NULL),(4845,884,'208419','834','00','005010X220A1','208419','','2013-11-20','20:50:39',0,'2013-12-26 00:15:25',NULL,NULL),(4446,801,'468472','834','00','005010X220A1','468472','','2013-11-25','19:05:54',0,'2013-12-25 23:30:18',NULL,NULL),(6175,1167,'590372','834','00','005010X220A1','590372','','2013-12-20','15:53:49',0,'2013-12-26 03:03:33',NULL,NULL),(6302,1174,'892282','834','00','005010X220A1','892282','','2013-12-20','08:11:13',0,'2013-12-26 03:07:27',NULL,NULL),(7190,1239,'279271','834','00','005010X220A1','279271','','2013-12-18','12:18:15',0,'2013-12-26 04:06:20',NULL,NULL),(2089,348,'89844','834','00','005010X220A1','89844','','2013-12-09','14:45:30',0,'2013-12-25 19:37:41',NULL,NULL),(13731,2275,'1475652','834','00','005010X220A1','1475652','','2014-01-07','11:11:24',0,'2014-01-08 18:24:43',NULL,NULL),(7470,1296,'1167687','834','00','005010X220A1','1167687','','2013-12-21','13:46:32',0,'2013-12-26 04:32:58',NULL,NULL),(7462,1296,'159351','834','00','005010X220A1','159351','','2013-12-21','10:59:46',0,'2013-12-26 04:32:43',NULL,NULL),(11060,1421,'1083510','834','00','005010X220A1','1083510','','2013-12-22','22:56:56',0,'2013-12-26 13:12:48',NULL,NULL),(4869,886,'251198','834','00','005010X220A1','251198','','2013-11-21','16:26:24',0,'2013-12-26 00:16:13',NULL,NULL),(11863,1555,'852827','834','00','005010X220A1','852827','','2013-12-28','20:28:43',1,'2013-12-29 11:15:15',NULL,NULL),(3054,544,'776712','834','00','005010X220A1','776712','','2013-12-13','14:01:00',0,'2013-12-25 21:34:45',NULL,NULL),(14184,2365,'1980686','834','00','005010X220A1','1980686','','2014-01-09','21:45:50',0,'2014-01-13 02:23:32',NULL,NULL),(15229,2595,'1555529','834','00','005010X220A1','1555529','','2014-01-15','13:27:44',0,'2014-01-16 08:46:43',NULL,NULL),(15336,2622,'2124341','834','00','005010X220A1','2124341','','2014-01-15','19:14:19',0,'2014-01-17 03:35:17',NULL,NULL),(16058,2772,'1838678','834','00','005010X220A1','1838678','','2014-01-22','12:27:30',0,'2014-01-23 03:02:39',NULL,NULL),(18359,3404,'2676010','834','00','005010X220A1','2676010','','2014-02-09','16:55:03',0,'2014-02-09 19:00:08',NULL,NULL),(18988,3537,'2106213','834','00','005010X220A1','2106213','','2014-02-12','14:35:05',0,'2014-02-12 21:30:19',NULL,NULL),(21539,4039,'3133016','834','00','005010X220A1','3133016','','2014-02-27','17:04:50',0,'2014-02-28 06:31:39',NULL,NULL),(22730,4276,'3712459','834','00','005010X220A1','3712459','','2014-03-05','19:47:29',0,'2014-03-06 21:00:14',NULL,NULL),(23275,4380,'2821543','834','00','005010X220A1','2821543','','2014-03-07','21:38:55',0,'2014-03-08 21:30:01',NULL,NULL),(3016,543,'614361','834','00','005010X220A1','614361','','2013-12-13','14:49:54',0,'2013-12-25 21:33:37',NULL,NULL),(13212,2056,'0001','999','BE','005010X231A1','1267581','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:26',NULL,NULL),(13073,1917,'0001','999','BE','005010X231A1','853582','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:24',NULL,NULL),(12963,1734,'1577846','834','00','005010X220A1','1577846','','2014-01-04','00:28:43',0,'2014-01-05 00:00:50',NULL,NULL),(4313,750,'304366','834','00','005010X220A1','304366','','2013-12-19','14:44:51',0,'2013-12-25 23:09:38',NULL,NULL),(4772,861,'978838','834','00','005010X220A1','978838','','2013-11-30','19:35:19',0,'2013-12-26 00:01:04',NULL,NULL),(5159,944,'407755','834','00','005010X220A1','407755','','2013-12-11','11:06:19',0,'2013-12-26 00:51:03',NULL,NULL),(5283,979,'240793','834','00','005010X220A1','240793','','2013-11-15','20:34:31',0,'2013-12-26 01:00:50',NULL,NULL),(5846,1092,'1145498','834','00','005010X220A1','1145498','','2013-11-23','14:23:13',0,'2013-12-26 02:15:59',NULL,NULL),(6153,1167,'108733','834','00','005010X220A1','108733','','2013-12-19','19:52:34',0,'2013-12-26 03:02:56',NULL,NULL),(3210,578,'649168','834','00','005010X220A1','649168','','2013-12-17','08:30:30',0,'2013-12-25 21:45:38',NULL,NULL),(11394,1463,'1439688','834','00','005010X220A1','1439688','','2013-12-26','17:16:48',0,'2013-12-27 02:06:21',NULL,NULL),(12221,1616,'2342556','834','00','005010X220A1','2342556','','2013-12-31','20:33:58',1,'2014-01-02 04:22:17',NULL,NULL),(15478,2634,'1447888','834','00','005010X220A1','1447888','','2014-01-16','01:23:32',0,'2014-01-17 03:36:21',NULL,NULL),(15514,2645,'1622369','834','00','005010X220A1','1622369','','2014-01-15','19:05:34',0,'2014-01-17 03:36:37',NULL,NULL),(16301,2980,'1803836','834','00','005010X220A1','1803836','','2014-01-23','11:34:13',0,'2014-01-23 21:00:13',NULL,NULL),(16661,3060,'2580068','834','00','005010X220A1','2580068','','2014-01-27','15:08:16',0,'2014-01-27 21:00:18',NULL,NULL),(17008,3118,'2615121','834','00','005010X220A1','2615121','','2014-01-29','15:11:45',0,'2014-01-29 21:00:58',NULL,NULL),(18577,3453,'2054169','834','00','005010X220A1','2054169','','2014-02-10','14:53:24',0,'2014-02-10 21:30:48',NULL,NULL),(22177,4180,'3033382','834','00','005010X220A1','3033382','','2014-03-03','15:44:07',0,'2014-03-03 21:31:14',NULL,NULL),(23472,4419,'3113208','834','00','005010X220A1','3113208','','2014-03-09','14:16:19',0,'2014-03-09 21:01:11',NULL,NULL),(23646,4441,'3424326','834','00','005010X220A1','3424326','','2014-03-10','15:21:55',0,'2014-03-10 21:01:48',NULL,NULL),(18669,3467,'1454260','834','00','005010X220A1','1454260','','2014-02-10','12:48:56',0,'2014-02-10 21:31:51',NULL,NULL),(19148,3550,'3074355','834','00','005010X220A1','3074355','','2014-02-12','16:49:58',0,'2014-02-12 21:32:08',NULL,NULL),(20313,3795,'2383493','834','00','005010X220A1','2383493','','2014-02-19','13:51:10',0,'2014-02-20 04:46:25',NULL,NULL),(800,151,'998844','834','00','005010X220A1','998844','','2013-10-28','20:37:15',0,'2013-12-25 18:10:10',NULL,NULL),(5813,1083,'489397','834','00','005010X220A1','489397','','2013-12-14','16:05:29',0,'2013-12-26 02:03:58',NULL,NULL),(7732,1342,'521524','834','00','005010X220A1','521524','','2013-10-20','19:26:46',0,'2013-12-26 05:00:16',NULL,NULL),(3670,627,'1194303','834','00','005010X220A1','1194303','','2013-12-12','15:07:26',0,'2013-12-25 22:06:33',NULL,NULL),(3588,617,'182174','834','00','005010X220A1','182174','','2013-12-12','15:48:29',0,'2013-12-25 22:04:00',NULL,NULL),(2843,511,'287508','834','00','005010X220A1','287508','','2013-12-22','16:07:58',0,'2013-12-25 21:21:46',NULL,NULL),(12064,1586,'1840496','834','00','005010X220A1','1840496','','2013-12-29','22:07:51',0,'2014-01-01 12:04:29',NULL,NULL),(1985,327,'956484','834','00','005010X220A1','956484','','2013-12-09','14:05:25',0,'2013-12-25 19:34:19',NULL,NULL),(12247,1619,'2429040','834','00','005010X220A1','2429040','','2014-01-01','13:58:34',1,'2014-01-02 04:23:19',NULL,NULL),(1859,324,'3981','834','00','005010X220A1','3981','','2013-12-09','12:27:48',0,'2013-12-25 19:30:30',NULL,NULL),(1199,240,'265298','834','00','005010X220A1','265298','','2013-12-24','03:49:37',0,'2013-12-25 18:47:44',NULL,NULL),(3913,712,'1044006','834','00','005010X220A1','1044006','','2013-12-07','12:13:07',0,'2013-12-25 22:45:27',NULL,NULL),(12879,1706,'2243457','834','00','005010X220A1','2243457','','2014-01-03','15:33:37',0,'2014-01-04 02:04:07',NULL,NULL),(13423,2222,'2038202','834','00','005010X220A1','2038202','','2014-01-06','16:56:13',0,'2014-01-07 04:01:41',NULL,NULL),(15797,2722,'2223300','834','00','005010X220A1','2223300','','2014-01-20','13:10:52',0,'2014-01-21 08:46:47',NULL,NULL),(15857,2738,'1852285','834','00','005010X220A1','1852285','','2014-01-21','14:00:24',1,'2014-01-22 03:22:14',NULL,NULL),(16979,3117,'2369485','834','00','005010X220A1','2369485','','2014-01-29','10:26:12',0,'2014-01-29 21:00:41',NULL,NULL),(18005,3318,'2353879','834','00','005010X220A1','2353879','','2014-02-06','15:47:35',0,'2014-02-06 21:00:10',NULL,NULL),(19463,3616,'2885734','834','00','005010X220A1','2885734','','2014-02-13','16:56:31',0,'2014-02-13 22:03:19',NULL,NULL),(21695,4087,'3050962','834','00','005010X220A1','3050962','','2014-02-28','11:18:00',0,'2014-02-28 21:30:07',NULL,NULL),(22774,4277,'3796722','834','00','005010X220A1','3796722','','2014-03-05','23:27:23',0,'2014-03-06 21:00:47',NULL,NULL),(307,70,'44055','834','00','005010X220A1','44055','','2013-12-04','15:28:26',0,'2013-12-25 17:45:24',NULL,NULL),(555,103,'719711','834','00','005010X220A1','719711','','2013-12-16','10:14:09',0,'2013-12-25 18:02:10',NULL,NULL),(12449,1639,'2505744','834','00','005010X220A1','2505744','','2013-12-30','18:46:24',1,'2014-01-02 04:31:27',NULL,NULL),(1236,243,'1617711','834','00','005010X220A1','1617711','','2013-12-24','10:32:08',0,'2013-12-25 18:48:48',NULL,NULL),(11995,1581,'1911066','834','00','005010X220A1','1911066','','2013-12-29','18:53:50',0,'2014-01-01 12:01:52',NULL,NULL),(11598,1493,'2194771','834','00','005010X220A1','2194771','','2013-12-27','09:21:43',0,'2013-12-28 03:34:39',NULL,NULL),(11221,1454,'119039','834','00','005010X220A1','119039','','2013-12-26','10:27:27',0,'2013-12-27 02:01:05',NULL,NULL),(1760,294,'945353','834','00','005010X220A1','945353','','2013-12-10','16:30:26',0,'2013-12-25 19:18:16',NULL,NULL),(10661,1402,'115093','834','00','005010X220A1','115093','','2013-12-23','19:01:42',0,'2013-12-26 12:59:08',NULL,NULL),(10599,1402,'1657449','834','00','005010X220A1','1657449','','2013-12-23','13:02:07',0,'2013-12-26 12:57:09',NULL,NULL),(2789,506,'170037','834','00','005010X220A1','170037','','2013-12-22','10:33:14',0,'2013-12-25 21:19:59',NULL,NULL),(2992,542,'986826','834','00','005010X220A1','986826','','2013-12-13','13:17:30',0,'2013-12-25 21:32:53',NULL,NULL),(4114,733,'504312','834','00','005010X220A1','504312','','2013-12-19','13:07:54',0,'2013-12-25 23:03:37',NULL,NULL),(6314,1175,'1152596','834','00','005010X220A1','1152596','','2013-12-20','08:05:05',0,'2013-12-26 03:07:49',NULL,NULL),(5528,1041,'572025','834','00','005010X220A1','572025','','2013-12-24','22:45:43',0,'2013-12-26 01:47:17',NULL,NULL),(5338,1002,'849399','834','00','005010X220A1','849399','','2013-11-25','09:04:44',0,'2013-12-26 01:15:25',NULL,NULL),(5069,936,'1055543','834','00','005010X220A1','1055543','','2013-12-11','12:17:23',0,'2013-12-26 00:48:14',NULL,NULL),(14758,2551,'2578339','834','00','005010X220A1','2578339','','2014-01-13','21:51:19',0,'2014-01-15 02:06:27',NULL,NULL),(15560,2655,'2334163','834','00','005010X220A1','2334163','','2014-01-17','12:35:27',0,'2014-01-20 08:05:56',NULL,NULL),(15665,2684,'1728217','834','00','005010X220A1','1728217','','2014-01-18','14:07:12',0,'2014-01-21 08:44:34',NULL,NULL),(17446,3205,'2616513','834','00','005010X220A1','2616513','','2014-02-01','14:20:29',0,'2014-02-01 19:00:38',NULL,NULL),(21060,3979,'3205255','834','00','005010X220A1','3205255','','2014-02-24','14:34:33',0,'2014-02-26 09:30:35',NULL,NULL),(21520,4036,'3123244','834','00','005010X220A1','3123244','','2014-02-27','11:26:04',0,'2014-02-28 06:31:31',NULL,NULL),(20337,3805,'3039266','834','00','005010X220A1','3039266','','2014-02-18','22:51:03',0,'2014-02-20 04:52:22',NULL,NULL),(1350,245,'1758745','834','00','005010X220A1','1758745','','2013-12-24','13:14:50',0,'2013-12-25 18:52:25',NULL,NULL),(5989,1126,'855200','834','00','005010X220A1','855200','','2013-12-15','09:59:51',0,'2013-12-26 02:33:36',NULL,NULL),(6277,1172,'287388','834','00','005010X220A1','287388','','2013-12-20','14:38:50',0,'2013-12-26 03:06:45',NULL,NULL),(5317,995,'1015711','834','00','005010X220A1','1015711','','2013-11-04','20:17:56',0,'2013-12-26 01:02:05',NULL,NULL),(6381,1184,'319559','834','00','005010X220A1','319559','','2013-12-20','13:24:38',0,'2013-12-26 03:09:53',NULL,NULL),(3687,631,'620672','834','00','005010X220A1','620672','','2013-12-12','11:51:33',0,'2013-12-25 22:07:04',NULL,NULL),(10387,1400,'812587','834','00','005010X220A1','812587','','2013-12-22','23:10:09',0,'2013-12-26 12:50:20',NULL,NULL),(11053,1419,'1637641','834','00','005010X220A1','1637641','','2013-12-23','15:11:51',0,'2013-12-26 13:12:33',NULL,NULL),(11809,1539,'148410','834','00','005010X220A1','148410','','2013-12-28','20:13:21',1,'2013-12-29 11:13:20',NULL,NULL),(2859,512,'877803','834','00','005010X220A1','877803','','2013-12-22','16:02:04',0,'2013-12-25 21:22:18',NULL,NULL),(14081,2341,'2187481','834','00','005010X220A1','2187481','','2014-01-07','23:37:09',0,'2014-01-13 02:21:58',NULL,NULL),(15748,2713,'1982159','834','00','005010X220A1','1982159','','2014-01-19','21:41:12',0,'2014-01-21 08:46:16',NULL,NULL),(16263,2955,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:34:00',0,'2014-01-23 09:00:02',NULL,NULL),(16670,3061,'2360839','834','00','005010X220A1','2360839','','2014-01-26','18:20:51',0,'2014-01-27 21:00:24',NULL,NULL),(17997,3318,'2840551','834','00','005010X220A1','2840551','','2014-02-06','11:30:37',0,'2014-02-06 21:00:04',NULL,NULL),(18350,3399,'1833672','834','00','005010X220A1','1833672','','2014-02-08','15:37:00',0,'2014-02-08 19:30:10',NULL,NULL),(18987,3537,'2357229','834','00','005010X220A1','2357229','','2014-02-12','14:00:34',0,'2014-02-12 21:30:18',NULL,NULL),(19278,3582,'3015368','834','00','005010X220A1','3015368','','2014-02-13','11:37:05',0,'2014-02-13 22:00:57',NULL,NULL),(19777,3675,'2940270','834','00','005010X220A1','2940270','','2014-02-15','11:21:01',0,'2014-02-15 22:01:03',NULL,NULL),(21210,3998,'2970365','834','00','005010X220A1','2970365','','2014-02-26','16:07:42',0,'2014-02-26 21:01:23',NULL,NULL),(21755,4090,'3737924','834','00','005010X220A1','3737924','','2014-02-28','11:44:13',0,'2014-02-28 21:30:50',NULL,NULL),(21908,4127,'3406198','834','00','005010X220A1','3406198','','2014-03-01','12:28:04',0,'2014-03-01 21:00:35',NULL,NULL),(23062,4339,'3167868','834','00','005010X220A1','3167868','','2014-03-06','23:53:15',0,'2014-03-07 21:30:07',NULL,NULL),(23138,4342,'2657295','834','00','005010X220A1','2657295','','2014-03-07','13:58:51',0,'2014-03-07 21:31:02',NULL,NULL),(23719,4459,'3524134','834','00','005010X220A1','3524134','','2014-03-10','15:10:35',0,'2014-03-10 21:02:43',NULL,NULL),(1401,247,'1721747','834','00','005010X220A1','1721747','','2013-12-24','09:42:08',0,'2013-12-25 18:54:05',NULL,NULL),(7128,1236,'202745','834','00','005010X220A1','202745','','2013-12-18','16:50:34',0,'2013-12-26 04:04:27',NULL,NULL),(4574,826,'532777','834','00','005010X220A1','532777','','2013-12-23','21:46:07',0,'2013-12-25 23:46:27',NULL,NULL),(12312,1631,'1800770','834','00','005010X220A1','1800770','','2014-01-01','13:32:26',1,'2014-01-02 04:25:44',NULL,NULL),(3221,578,'1260331','834','00','005010X220A1','1260331','','2013-12-17','10:01:50',0,'2013-12-25 21:45:57',NULL,NULL),(2546,457,'1057892','834','00','005010X220A1','1057892','','2013-11-18','11:13:15',0,'2013-12-25 20:31:23',NULL,NULL),(1407,247,'1979108','834','00','005010X220A1','1979108','','2013-12-24','14:32:03',0,'2013-12-25 18:54:16',NULL,NULL),(14333,2400,'1773376','834','00','005010X220A1','1773376','','2014-01-12','13:35:20',0,'2014-01-13 03:01:13',NULL,NULL),(15517,2647,'2255737','834','00','005010X220A1','2255737','','2014-01-16','16:07:46',0,'2014-01-17 03:36:38',NULL,NULL),(15704,2700,'1427900','834','00','005010X220A1','1427900','','2014-01-19','09:17:44',0,'2014-01-21 08:45:31',NULL,NULL),(17828,3278,'1984981','834','00','005010X220A1','1984981','','2014-02-04','13:12:02',0,'2014-02-04 21:01:52',NULL,NULL),(20518,3849,'3495923','834','00','005010X220A1','3495923','','2014-02-20','10:01:07',0,'2014-02-20 22:01:18',NULL,NULL),(20525,3849,'2614701','834','00','005010X220A1','2614701','','2014-02-20','14:02:09',0,'2014-02-20 22:01:24',NULL,NULL),(20824,3910,'2695236','834','00','005010X220A1','2695236','','2014-02-25','17:23:29',0,'2014-02-25 21:31:11',NULL,NULL),(20846,3911,'3793867','834','00','005010X220A1','3793867','','2014-02-25','14:06:52',0,'2014-02-25 21:31:27',NULL,NULL),(21028,3974,'3522396','834','00','005010X220A1','3522396','','2014-02-24','14:23:27',0,'2014-02-26 09:30:07',NULL,NULL),(21639,4070,'2804763','834','00','005010X220A1','2804763','','2014-02-27','13:28:14',0,'2014-02-28 07:30:31',NULL,NULL),(21785,4091,'3463072','834','00','005010X220A1','3463072','','2014-02-28','15:22:40',0,'2014-02-28 21:31:11',NULL,NULL),(23720,4460,'3527544','834','00','005010X220A1','3527544','','2014-03-10','11:26:01',0,'2014-03-10 21:02:44',NULL,NULL),(1520,259,'1536369','834','00','005010X220A1','1536369','','2013-12-24','17:09:42',0,'2013-12-25 18:58:03',NULL,NULL),(13408,2222,'2015501','834','00','005010X220A1','2015501','','2014-01-05','18:13:12',0,'2014-01-07 04:01:11',NULL,NULL),(10781,1404,'469289','834','00','005010X220A1','469289','','2013-12-23','10:26:58',0,'2013-12-26 13:03:16',NULL,NULL),(4678,831,'141559','834','00','005010X220A1','141559','','2013-12-24','00:32:02',0,'2013-12-25 23:49:51',NULL,NULL),(11639,1497,'2039413','834','00','005010X220A1','2039413','','2013-12-27','18:16:08',0,'2013-12-28 03:35:55',NULL,NULL),(4182,734,'317137','834','00','005010X220A1','317137','','2013-12-19','14:06:50',0,'2013-12-25 23:05:40',NULL,NULL),(4143,733,'547921','834','00','005010X220A1','547921','','2013-12-19','16:13:21',0,'2013-12-25 23:04:28',NULL,NULL),(1564,276,'253878','834','00','005010X220A1','253878','','2013-11-20','09:12:30',0,'2013-12-25 19:00:04',NULL,NULL),(13063,1907,'0001','999','BE','005010X231A1','1255497','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:56',NULL,NULL),(14431,2452,'0001','999','BE','005010X231A1','1117840','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:41',NULL,NULL),(16352,2983,'1522606','834','00','005010X220A1','1522606','','2014-01-23','15:20:22',0,'2014-01-23 21:00:50',NULL,NULL),(17129,3144,'2093516','834','00','005010X220A1','2093516','','2014-01-29','18:33:52',0,'2014-01-30 21:00:24',NULL,NULL),(17150,3144,'2280137','834','00','005010X220A1','2280137','','2014-01-30','14:48:03',0,'2014-01-30 21:00:37',NULL,NULL),(18016,3318,'2314654','834','00','005010X220A1','2314654','','2014-02-05','19:11:56',0,'2014-02-06 21:00:18',NULL,NULL),(19219,3580,'2711236','834','00','005010X220A1','2711236','','2014-02-12','22:32:57',0,'2014-02-13 22:00:08',NULL,NULL),(19380,3591,'1809081','834','00','005010X220A1','1809081','','2014-02-13','12:40:19',0,'2014-02-13 22:02:15',NULL,NULL),(20866,3914,'2617113','834','00','005010X220A1','2617113','','2014-02-25','11:31:14',0,'2014-02-25 21:31:42',NULL,NULL),(21427,4027,'2870937','834','00','005010X220A1','2870937','','2014-02-26','18:47:29',0,'2014-02-28 06:30:47',NULL,NULL),(21451,4028,'3807624','834','00','005010X220A1','3807624','','2014-02-26','21:36:28',0,'2014-02-28 06:30:59',NULL,NULL),(22308,4201,'3160314','834','00','005010X220A1','3160314','','2014-03-04','13:01:43',0,'2014-03-04 21:01:04',NULL,NULL),(23307,4381,'2751269','834','00','005010X220A1','2751269','','2014-03-07','19:03:35',0,'2014-03-08 21:30:26',NULL,NULL),(1783,299,'1207779','834','00','005010X220A1','1207779','','2013-12-10','16:43:07',0,'2013-12-25 19:19:03',NULL,NULL),(3094,546,'143816','834','00','005010X220A1','143816','','2013-12-12','21:28:15',0,'2013-12-25 21:36:01',NULL,NULL),(2128,360,'284304','834','00','005010X220A1','284304','','2013-12-02','17:14:07',0,'2013-12-25 19:45:46',NULL,NULL),(11135,1432,'791170','834','00','005010X220A1','791170','','2013-12-22','23:52:53',0,'2013-12-26 13:15:23',NULL,NULL),(6074,1164,'893590','834','00','005010X220A1','893590','','2013-12-20','17:07:06',0,'2013-12-26 03:00:28',NULL,NULL),(13394,2221,'2096291','834','00','005010X220A1','2096291','','2014-01-06','14:37:29',0,'2014-01-07 04:00:42',NULL,NULL),(13830,2301,'2578274','834','00','005010X220A1','2578274','','2014-01-11','10:07:44',0,'2014-01-13 02:18:34',NULL,NULL),(14396,2418,'1486639','834','00','005010X220A1','1486639','','2014-01-12','14:48:54',0,'2014-01-13 03:01:59',NULL,NULL),(15641,2678,'1748101','834','00','005010X220A1','1748101','','2014-01-17','19:08:17',0,'2014-01-21 08:44:18',NULL,NULL),(16932,3115,'1527105','834','00','005010X220A1','1527105','','2014-01-28','22:29:43',0,'2014-01-29 21:00:11',NULL,NULL),(17617,3243,'2662706','834','00','005010X220A1','2662706','','2014-02-03','12:38:47',0,'2014-02-03 21:01:09',NULL,NULL),(18076,3322,'2246530','834','00','005010X220A1','2246530','','2014-02-06','14:00:27',0,'2014-02-06 21:00:59',NULL,NULL),(18240,3367,'1623969','834','00','005010X220A1','1623969','','2014-02-07','16:12:34',0,'2014-02-07 19:01:05',NULL,NULL),(19077,3542,'1715091','834','00','005010X220A1','1715091','','2014-02-12','10:54:24',0,'2014-02-12 21:31:22',NULL,NULL),(21168,3997,'3124360','834','00','005010X220A1','3124360','','2014-02-26','17:41:07',0,'2014-02-26 21:00:55',NULL,NULL),(21493,4030,'3180478','834','00','005010X220A1','3180478','','2014-02-26','20:13:55',0,'2014-02-28 06:31:18',NULL,NULL),(21595,4061,'3655826','834','00','005010X220A1','3655826','','2014-02-26','14:39:20',0,'2014-02-28 07:00:38',NULL,NULL),(22154,4180,'3426399','834','00','005010X220A1','3426399','','2014-03-03','10:02:44',0,'2014-03-03 21:30:58',NULL,NULL),(23046,4335,'3834759','834','00','005010X220A1','3834759','','2014-03-07','15:05:22',0,'2014-03-07 21:00:34',NULL,NULL),(23050,4336,'3333261','834','00','005010X220A1','3333261','','2014-03-07','17:35:56',0,'2014-03-07 21:00:35',NULL,NULL),(2258,380,'839780','834','00','005010X220A1','839780','','2013-12-02','10:06:21',0,'2013-12-25 19:50:10',NULL,NULL),(6375,1183,'766283','834','00','005010X220A1','766283','','2013-12-20','15:10:52',0,'2013-12-26 03:09:43',NULL,NULL),(5029,935,'54791','834','00','005010X220A1','54791','','2013-12-11','13:01:38',0,'2013-12-26 00:46:54',NULL,NULL),(7681,1324,'161476','834','00','005010X220A1','161476','','2013-12-21','13:59:05',0,'2013-12-26 04:39:51',NULL,NULL),(10671,1403,'1490909','834','00','005010X220A1','1490909','','2013-12-22','19:56:15',0,'2013-12-26 12:59:26',NULL,NULL),(4426,790,'397831','834','00','005010X220A1','397831','','2013-11-05','22:56:14',0,'2013-12-25 23:16:55',NULL,NULL),(11466,1488,'1530298','834','00','005010X220A1','1530298','','2013-12-27','11:35:50',0,'2013-12-28 03:30:38',NULL,NULL),(11685,1516,'2187271','834','00','005010X220A1','2187271','','2013-12-28','16:11:45',1,'2013-12-29 11:07:26',NULL,NULL),(14811,2552,'2203871','834','00','005010X220A1','2203871','','2014-01-14','03:45:06',0,'2014-01-15 02:06:49',NULL,NULL),(16173,2865,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 04:17:42',NULL,NULL),(18169,3350,'1636421','834','00','005010X220A1','1636421','','2014-02-07','15:54:06',0,'2014-02-07 19:00:13',NULL,NULL),(18556,3452,'2975111','834','00','005010X220A1','2975111','','2014-02-10','18:04:55',0,'2014-02-10 21:30:32',NULL,NULL),(22157,4180,'3832420','834','00','005010X220A1','3832420','','2014-03-03','10:28:28',0,'2014-03-03 21:31:00',NULL,NULL),(5367,1009,'514873','834','00','005010X220A1','514873','','2013-11-24','21:06:05',0,'2013-12-26 01:16:27',NULL,NULL),(13694,2274,'1430174','834','00','005010X220A1','1430174','','2014-01-06','19:24:20',0,'2014-01-08 18:24:27',NULL,NULL),(13110,1954,'0001','999','BE','005010X231A1','321564','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:06',NULL,NULL),(13348,2192,'0001','999','BE','005010X231A1','321564','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:25',NULL,NULL),(11469,1488,'1469449','834','00','005010X220A1','1469449','','2013-12-27','12:03:57',0,'2013-12-28 03:30:43',NULL,NULL),(13067,1911,'0001','999','BE','005010X231A1','292504','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:07',NULL,NULL),(12991,1738,'1632056','834','00','005010X220A1','1632056','','2014-01-03','22:22:14',0,'2014-01-05 00:01:48',NULL,NULL),(14163,2363,'2175369','834','00','005010X220A1','2175369','','2014-01-10','11:21:40',0,'2014-01-13 02:23:14',NULL,NULL),(14556,2519,'1550003','834','00','005010X220A1','1550003','','2014-01-13','10:03:49',0,'2014-01-14 01:32:38',NULL,NULL),(14575,2520,'1723709','834','00','005010X220A1','1723709','','2014-01-13','12:35:17',0,'2014-01-14 01:32:50',NULL,NULL),(14627,2524,'2343944','834','00','005010X220A1','2343944','','2014-01-13','15:58:28',0,'2014-01-14 01:33:24',NULL,NULL),(14988,2580,'1659371','834','00','005010X220A1','1659371','','2014-01-14','16:57:49',0,'2014-01-15 02:08:10',NULL,NULL),(17116,3142,'2697040','834','00','005010X220A1','2697040','','2014-01-30','15:14:46',0,'2014-01-30 21:00:16',NULL,NULL),(17952,3299,'2812665','834','00','005010X220A1','2812665','','2014-02-05','13:48:31',0,'2014-02-05 21:30:55',NULL,NULL),(21156,3997,'3097999','834','00','005010X220A1','3097999','','2014-02-26','14:18:11',0,'2014-02-26 21:00:46',NULL,NULL),(21310,4008,'3408409','834','00','005010X220A1','3408409','','2014-02-26','17:30:34',0,'2014-02-26 21:02:32',NULL,NULL),(21742,4090,'3240886','834','00','005010X220A1','3240886','','2014-02-27','20:02:56',0,'2014-02-28 21:30:42',NULL,NULL),(21979,4144,'3646905','834','00','005010X220A1','3646905','','2014-03-02','16:43:53',0,'2014-03-03 01:00:12',NULL,NULL),(497,102,'710981','834','00','005010X220A1','710981','','2013-12-16','08:48:38',0,'2013-12-25 18:00:23',NULL,NULL),(2707,502,'542713','834','00','005010X220A1','542713','','2013-12-22','17:14:35',0,'2013-12-25 21:17:25',NULL,NULL),(6452,1210,'326377','834','00','005010X220A1','326377','','2013-11-22','10:34:06',0,'2013-12-26 03:16:09',NULL,NULL),(16414,2997,'2243990','834','00','005010X220A1','2243990','','2014-01-23','16:39:35',0,'2014-01-23 21:01:30',NULL,NULL),(15568,2657,'1543710','834','00','005010X220A1','1543710','','2014-01-16','21:27:18',0,'2014-01-20 08:06:02',NULL,NULL),(13988,2326,'1406972','834','00','005010X220A1','1406972','','2014-01-08','23:36:29',0,'2014-01-13 02:20:49',NULL,NULL),(14132,2352,'2322511','834','00','005010X220A1','2322511','','2014-01-08','08:01:24',0,'2014-01-13 02:22:30',NULL,NULL),(14458,2479,'0001','999','BE','005010X231A1','18034','834','2013-12-28','12:25:00',0,'2014-01-13 03:03:31',NULL,NULL),(507,102,'438548','834','00','005010X220A1','438548','','2013-12-16','10:53:39',0,'2013-12-25 18:00:41',NULL,NULL),(12348,1634,'2500934','834','00','005010X220A1','2500934','','2013-12-31','12:50:21',1,'2014-01-02 04:27:49',NULL,NULL),(1546,264,'1813179','834','00','005010X220A1','1813179','','2013-12-24','12:01:42',0,'2013-12-25 18:58:48',NULL,NULL),(21165,3997,'3644216','834','00','005010X220A1','3644216','','2014-02-26','17:12:24',0,'2014-02-26 21:00:53',NULL,NULL),(21855,4114,'3839815','834','00','005010X220A1','3839815','','2014-02-28','18:03:34',0,'2014-03-01 19:00:06',NULL,NULL),(19013,3539,'3197916','834','00','005010X220A1','3197916','','2014-02-12','11:56:13',0,'2014-02-12 21:30:35',NULL,NULL),(7359,1283,'256437','834','00','005010X220A1','256437','','2013-11-30','16:22:00',0,'2013-12-26 04:15:47',NULL,NULL),(18227,3358,'2578897','834','00','005010X220A1','2578897','','2014-02-06','19:20:50',0,'2014-02-07 19:00:55',NULL,NULL),(6146,1166,'430875','834','00','005010X220A1','430875','','2013-12-20','17:26:23',0,'2013-12-26 03:02:41',NULL,NULL),(4073,733,'424988','834','00','005010X220A1','424988','','2013-12-18','19:46:14',0,'2013-12-25 23:02:28',NULL,NULL),(5858,1099,'962750','834','00','005010X220A1','962750','','2013-11-23','14:25:40',0,'2013-12-26 02:16:27',NULL,NULL),(13566,2254,'2538562','834','00','005010X220A1','2538562','','2014-01-04','19:45:48',1,'2014-01-07 10:21:24',NULL,NULL),(12742,1687,'1508348','834','00','005010X220A1','1508348','','2014-01-02','14:53:50',0,'2014-01-03 02:06:23',NULL,NULL),(864,175,'795456','834','00','005010X220A1','795456','','2013-12-03','12:46:07',0,'2013-12-25 18:16:06',NULL,NULL),(3789,656,'53160','834','00','005010X220A1','53160','','2013-12-08','17:10:50',0,'2013-12-25 22:15:56',NULL,NULL),(3062,544,'603627','834','00','005010X220A1','603627','','2013-12-13','15:04:37',0,'2013-12-25 21:35:01',NULL,NULL),(7754,1346,'43505','834','00','005010X220A1','43505','','2013-10-20','19:58:47',0,'2013-12-26 05:01:00',NULL,NULL),(4653,828,'340033','834','00','005010X220A1','340033','','2013-12-24','00:09:17',0,'2013-12-25 23:49:00',NULL,NULL),(7015,1235,'196333','834','00','005010X220A1','196333','','2013-12-18','09:42:27',0,'2013-12-26 04:00:57',NULL,NULL),(12855,1706,'2563030','834','00','005010X220A1','2563030','','2014-01-02','22:52:09',0,'2014-01-04 02:03:16',NULL,NULL),(13697,2274,'2367782','834','00','005010X220A1','2367782','','2014-01-07','14:17:05',0,'2014-01-08 18:24:28',NULL,NULL),(16542,3020,'2473972','834','00','005010X220A1','2473972','','2014-01-24','13:54:53',0,'2014-01-24 21:01:07',NULL,NULL),(16728,3065,'2351097','834','00','005010X220A1','2351097','','2014-01-26','20:21:53',0,'2014-01-27 21:01:02',NULL,NULL),(18070,3321,'2470452','834','00','005010X220A1','2470452','','2014-02-06','12:52:37',0,'2014-02-06 21:00:55',NULL,NULL),(18337,3390,'2350059','834','00','005010X220A1','2350059','','2014-02-08','13:53:53',0,'2014-02-08 19:00:58',NULL,NULL),(20067,3757,'3575839','834','00','005010X220A1','3575839','','2014-02-18','10:12:41',0,'2014-02-18 22:01:22',NULL,NULL),(21106,3994,'3513807','834','00','005010X220A1','3513807','','2014-02-26','10:07:35',0,'2014-02-26 21:00:12',NULL,NULL),(23166,4344,'3112104','834','00','005010X220A1','3112104','','2014-03-07','12:49:18',0,'2014-03-07 21:31:22',NULL,NULL),(23300,4381,'3001112','834','00','005010X220A1','3001112','','2014-03-07','23:24:08',0,'2014-03-08 21:30:20',NULL,NULL),(384,74,'339149','834','00','005010X220A1','339149','','2013-12-04','14:59:09',0,'2013-12-25 17:47:51',NULL,NULL),(12082,1586,'1864432','834','00','005010X220A1','1864432','','2013-12-30','15:17:24',0,'2014-01-01 12:05:05',NULL,NULL),(11748,1521,'2102610','834','00','005010X220A1','2102610','','2013-12-27','23:56:07',1,'2013-12-29 11:09:22',NULL,NULL),(4757,859,'986484','834','00','005010X220A1','986484','','2013-12-01','08:33:45',0,'2013-12-26 00:00:32',NULL,NULL),(15276,2609,'1546421','834','00','005010X220A1','1546421','','2014-01-15','10:37:52',0,'2014-01-16 08:47:15',NULL,NULL),(17469,3216,'2689561','834','00','005010X220A1','2689561','','2014-02-02','13:51:45',0,'2014-02-02 19:00:05',NULL,NULL),(17754,3262,'2371983','834','00','005010X220A1','2371983','','2014-02-04','13:16:42',0,'2014-02-04 21:01:03',NULL,NULL),(17975,3305,'1545437','834','00','005010X220A1','1545437','','2014-02-04','20:51:06',0,'2014-02-05 21:31:09',NULL,NULL),(19250,3580,'2474457','834','00','005010X220A1','2474457','','2014-02-13','17:40:25',0,'2014-02-13 22:00:34',NULL,NULL),(19733,3673,'2797645','834','00','005010X220A1','2797645','','2014-02-14','23:44:58',0,'2014-02-15 22:00:32',NULL,NULL),(20417,3835,'3111610','834','00','005010X220A1','3111610','','2014-02-20','15:14:09',0,'2014-02-20 21:30:17',NULL,NULL),(21548,4044,'3554452','834','00','005010X220A1','3554452','','2014-02-27','11:27:50',0,'2014-02-28 06:31:43',NULL,NULL),(22042,4163,'3432504','834','00','005010X220A1','3432504','','2014-03-03','15:26:45',0,'2014-03-03 21:00:05',NULL,NULL),(22084,4174,'2788087','834','00','005010X220A1','2788087','','2014-03-03','16:23:42',0,'2014-03-03 21:30:05',NULL,NULL),(23133,4342,'3548625','834','00','005010X220A1','3548625','','2014-03-07','12:13:57',0,'2014-03-07 21:30:58',NULL,NULL),(23564,4436,'3070393','834','00','005010X220A1','3070393','','2014-03-10','11:19:11',0,'2014-03-10 21:00:51',NULL,NULL),(1323,245,'118919','834','00','005010X220A1','118919','','2013-12-24','11:00:28',0,'2013-12-25 18:51:33',NULL,NULL),(2095,353,'91049','834','00','005010X220A1','91049','','2013-12-09','16:25:07',0,'2013-12-25 19:37:53',NULL,NULL),(10854,1406,'756657','834','00','005010X220A1','756657','','2013-12-23','11:44:29',0,'2013-12-26 13:05:37',NULL,NULL),(2715,503,'1430784','834','00','005010X220A1','1430784','','2013-12-21','18:39:10',0,'2013-12-25 21:17:39',NULL,NULL),(7684,1325,'45924','834','00','005010X220A1','45924','','2013-12-21','13:49:14',0,'2013-12-26 04:39:56',NULL,NULL),(3352,587,'1143296','834','00','005010X220A1','1143296','','2013-12-17','08:06:59',0,'2013-12-25 21:50:14',NULL,NULL),(7121,1236,'686865','834','00','005010X220A1','686865','','2013-12-18','15:39:47',0,'2013-12-26 04:04:13',NULL,NULL),(5827,1088,'208440','834','00','005010X220A1','208440','','2013-11-23','14:39:46',0,'2013-12-26 02:15:18',NULL,NULL),(12497,1641,'2439780','834','00','005010X220A1','2439780','','2013-12-31','18:28:41',1,'2014-01-02 04:33:15',NULL,NULL),(4930,914,'601851','834','00','005010X220A1','601851','','2013-10-16','00:19:15',0,'2013-12-26 00:31:07',NULL,NULL),(13093,1937,'0001','999','BE','005010X231A1','796827','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:18',NULL,NULL),(16491,3011,'2161692','834','00','005010X220A1','2161692','','2014-01-24','11:39:44',0,'2014-01-24 21:00:35',NULL,NULL),(18072,3321,'2595594','834','00','005010X220A1','2595594','','2014-02-06','16:07:29',0,'2014-02-06 21:00:57',NULL,NULL),(19057,3542,'2844065','834','00','005010X220A1','2844065','','2014-02-12','11:36:13',0,'2014-02-12 21:31:06',NULL,NULL),(20210,3781,'2641315','834','00','005010X220A1','2641315','','2014-02-19','12:41:26',0,'2014-02-20 04:20:30',NULL,NULL),(22889,4282,'3197438','834','00','005010X220A1','3197438','','2014-03-06','17:57:47',0,'2014-03-06 21:02:08',NULL,NULL),(106,5,'377303','834','00','005010X220A1','377303','','2013-12-04','18:35:16',0,'2013-12-25 17:18:12',NULL,NULL),(13641,2270,'1714270','834','00','005010X220A1','1714270','','2014-01-07','18:09:23',0,'2014-01-08 18:24:06',NULL,NULL),(3450,606,'264807','834','00','005010X220A1','264807','','2013-12-17','12:51:33',0,'2013-12-25 21:53:19',NULL,NULL),(4238,738,'1165181','834','00','005010X220A1','1165181','','2013-12-19','17:57:04',0,'2013-12-25 23:07:25',NULL,NULL),(2908,540,'227060','834','00','005010X220A1','227060','','2013-12-13','17:31:43',0,'2013-12-25 21:30:12',NULL,NULL),(4416,785,'230390','834','00','005010X220A1','230390','','2013-11-27','17:43:02',0,'2013-12-25 23:16:28',NULL,NULL),(2411,415,'144812','834','00','005010X220A1','144812','','2013-12-06','12:06:03',0,'2013-12-25 20:17:35',NULL,NULL),(5337,1002,'928348','834','00','005010X220A1','928348','','2013-11-24','23:34:10',0,'2013-12-26 01:15:23',NULL,NULL),(5571,1043,'990834','834','00','005010X220A1','990834','','2013-12-24','20:35:46',0,'2013-12-26 01:48:41',NULL,NULL),(10394,1400,'996033','834','00','005010X220A1','996033','','2013-12-23','05:53:56',0,'2013-12-26 12:50:32',NULL,NULL),(2084,345,'1453','834','00','005010X220A1','1453','','2013-12-09','11:50:47',0,'2013-12-25 19:37:31',NULL,NULL),(11266,1455,'1951400','834','00','005010X220A1','1951400','','2013-12-26','11:30:06',0,'2013-12-27 02:02:27',NULL,NULL),(1352,245,'1572636','834','00','005010X220A1','1572636','','2013-12-24','13:23:56',0,'2013-12-25 18:52:29',NULL,NULL),(999,187,'67119','834','00','005010X220A1','67119','','2013-12-03','00:11:20',0,'2013-12-25 18:20:14',NULL,NULL),(11589,1492,'1513187','834','00','005010X220A1','1513187','','2013-12-27','17:27:46',0,'2013-12-28 03:34:23',NULL,NULL),(14541,2518,'1670360','834','00','005010X220A1','1670360','','2014-01-13','15:01:30',0,'2014-01-14 01:32:28',NULL,NULL),(14558,2519,'2510925','834','00','005010X220A1','2510925','','2014-01-13','11:25:56',0,'2014-01-14 01:32:39',NULL,NULL),(15272,2606,'2493908','834','00','005010X220A1','2493908','','2014-01-15','11:25:48',0,'2014-01-16 08:47:12',NULL,NULL),(16146,2838,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:36:00',1,'2014-01-23 03:57:57',NULL,NULL),(17750,3262,'1957509','834','00','005010X220A1','1957509','','2014-02-04','12:15:23',0,'2014-02-04 21:01:01',NULL,NULL),(18358,3403,'2927312','834','00','005010X220A1','2927312','','2014-02-09','15:41:04',0,'2014-02-09 19:00:07',NULL,NULL),(19716,3672,'3425972','834','00','005010X220A1','3425972','','2014-02-14','18:24:14',0,'2014-02-15 22:00:19',NULL,NULL),(20336,3804,'3039266','834','00','005010X220A1','3039266','','2014-02-18','22:51:03',0,'2014-02-20 04:52:09',NULL,NULL),(20465,3842,'3129132','834','00','005010X220A1','3129132','','2014-02-20','12:21:23',0,'2014-02-20 22:00:35',NULL,NULL),(20617,3871,'2629565','834','00','005010X220A1','2629565','','2014-02-20','18:24:00',0,'2014-02-21 22:00:28',NULL,NULL),(20731,3903,'2782912','834','00','005010X220A1','2782912','','2014-02-24','18:01:56',0,'2014-02-25 21:30:03',NULL,NULL),(20852,3911,'3630750','834','00','005010X220A1','3630750','','2014-02-25','15:48:18',0,'2014-02-25 21:31:32',NULL,NULL),(21835,4101,'3090657','834','00','005010X220A1','3090657','','2014-02-28','10:31:01',0,'2014-02-28 21:31:47',NULL,NULL),(22986,4319,'2932757','834','00','005010X220A1','2932757','','2014-03-06','15:41:19',0,'2014-03-06 21:30:23',NULL,NULL),(268,53,'1160','834','00','005010X220A1','1160','','2013-11-13','14:06:18',0,'2013-12-25 17:31:30',NULL,NULL),(13626,2270,'1472206','834','00','005010X220A1','1472206','','2014-01-07','16:36:18',0,'2014-01-08 18:24:00',NULL,NULL),(13622,2270,'1449925','834','00','005010X220A1','1449925','','2014-01-07','14:44:34',0,'2014-01-08 18:23:58',NULL,NULL),(5723,1069,'1252936','834','00','005010X220A1','1252936','','2013-12-14','12:12:12',0,'2013-12-26 02:01:07',NULL,NULL),(3955,715,'1132090','834','00','005010X220A1','1132090','','2013-12-07','14:41:58',0,'2013-12-25 22:46:42',NULL,NULL),(10769,1404,'1448231','834','00','005010X220A1','1448231','','2013-12-22','22:33:26',0,'2013-12-26 13:02:53',NULL,NULL),(11014,1414,'1484675','834','00','005010X220A1','1484675','','2013-12-23','12:10:45',0,'2013-12-26 13:11:15',NULL,NULL),(11399,1465,'836571','834','00','005010X220A1','836571','','2013-12-26','10:40:41',0,'2013-12-27 02:06:31',NULL,NULL),(3010,543,'365984','834','00','005010X220A1','365984','','2013-12-13','10:48:07',0,'2013-12-25 21:33:25',NULL,NULL),(12327,1634,'1312356','834','00','005010X220A1','1312356','','2013-12-31','00:06:48',1,'2014-01-02 04:27:05',NULL,NULL),(12462,1639,'948710','834','00','005010X220A1','948710','','2013-12-31','14:23:39',1,'2014-01-02 04:31:54',NULL,NULL),(2887,528,'891160','834','00','005010X220A1','891160','','2013-12-22','11:37:49',0,'2013-12-25 21:23:14',NULL,NULL),(12962,1734,'2469656','834','00','005010X220A1','2469656','','2014-01-04','00:16:17',0,'2014-01-05 00:00:47',NULL,NULL),(14013,2337,'1653852','834','00','005010X220A1','1653852','','2014-01-07','21:43:46',0,'2014-01-13 02:21:14',NULL,NULL),(15976,2764,'1526960','834','00','005010X220A1','1526960','','2014-01-22','11:51:33',0,'2014-01-23 03:02:02',NULL,NULL),(21789,4092,'3042028','834','00','005010X220A1','3042028','','2014-02-27','21:02:38',0,'2014-02-28 21:31:14',NULL,NULL),(17875,3293,'2730698','834','00','005010X220A1','2730698','','2014-02-05','17:18:29',0,'2014-02-05 21:30:18',NULL,NULL),(19092,3543,'2768677','834','00','005010X220A1','2768677','','2014-02-12','09:51:45',0,'2014-02-12 21:31:33',NULL,NULL),(20602,3870,'3497341','834','00','005010X220A1','3497341','','2014-02-21','13:28:33',0,'2014-02-21 22:00:17',NULL,NULL),(1260,243,'619922','834','00','005010X220A1','619922','','2013-12-24','13:13:54',0,'2013-12-25 18:49:30',NULL,NULL),(13109,1953,'0001','999','BE','005010X231A1','1170605','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:03',NULL,NULL),(12998,1739,'2365482','834','00','005010X220A1','2365482','','2014-01-04','08:58:55',0,'2014-01-05 00:02:02',NULL,NULL),(2670,501,'1505186','834','00','005010X220A1','1505186','','2013-12-22','17:13:12',0,'2013-12-25 21:16:13',NULL,NULL),(4791,865,'308633','834','00','005010X220A1','308633','','2013-12-01','16:10:59',0,'2013-12-26 00:01:36',NULL,NULL),(7638,1309,'636744','834','00','005010X220A1','636744','','2013-12-21','13:44:53',0,'2013-12-26 04:38:27',NULL,NULL),(7204,1241,'256938','834','00','005010X220A1','256938','','2013-12-17','19:59:44',0,'2013-12-26 04:06:46',NULL,NULL),(5655,1050,'1904532','834','00','005010X220A1','1904532','','2013-12-25','14:19:09',0,'2013-12-26 01:51:28',NULL,NULL),(12314,1632,'2163438','834','00','005010X220A1','2163438','','2014-01-01','13:33:24',1,'2014-01-02 04:25:49',NULL,NULL),(6186,1167,'442915','834','00','005010X220A1','442915','','2013-12-20','17:40:49',0,'2013-12-26 03:03:53',NULL,NULL),(13316,2160,'0001','999','BE','005010X231A1','84223','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:56',NULL,NULL),(13523,2237,'1605458','834','00','005010X220A1','1605458','','2014-01-06','10:05:40',0,'2014-01-07 04:05:30',NULL,NULL),(13824,2299,'2172615','834','00','005010X220A1','2172615','','2014-01-11','10:04:21',0,'2014-01-13 02:18:31',NULL,NULL),(14270,2375,'2389765','834','00','005010X220A1','2389765','','2014-01-10','14:05:32',0,'2014-01-13 03:00:10',NULL,NULL),(15696,2699,'1972150','834','00','005010X220A1','1972150','','2014-01-19','16:41:24',0,'2014-01-21 08:45:24',NULL,NULL),(15824,2736,'1545102','834','00','005010X220A1','1545102','','2014-01-20','19:10:49',1,'2014-01-22 03:21:52',NULL,NULL),(15971,2764,'2607840','834','00','005010X220A1','2607840','','2014-01-22','16:44:37',0,'2014-01-23 03:01:59',NULL,NULL),(16236,2928,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',0,'2014-01-23 06:41:48',NULL,NULL),(17110,3142,'2207970','834','00','005010X220A1','2207970','','2014-01-30','13:17:44',0,'2014-01-30 21:00:13',NULL,NULL),(17374,3185,'2098457','834','00','005010X220A1','2098457','','2014-01-31','13:48:44',0,'2014-01-31 21:01:34',NULL,NULL),(17548,3235,'1811715','834','00','005010X220A1','1811715','','2014-02-03','18:06:05',0,'2014-02-03 21:00:25',NULL,NULL),(18561,3453,'1801689','834','00','005010X220A1','1801689','','2014-02-09','22:06:03',0,'2014-02-10 21:30:37',NULL,NULL),(18867,3493,'3225641','834','00','005010X220A1','3225641','','2014-02-11','11:43:35',0,'2014-02-11 21:02:07',NULL,NULL),(19265,3581,'2911427','834','00','005010X220A1','2911427','','2014-02-13','15:43:09',0,'2014-02-13 22:00:46',NULL,NULL),(19749,3673,'2676262','834','00','005010X220A1','2676262','','2014-02-15','12:54:59',0,'2014-02-15 22:00:43',NULL,NULL),(19759,3674,'2930985','834','00','005010X220A1','2930985','','2014-02-15','09:26:44',0,'2014-02-15 22:00:50',NULL,NULL),(20126,3772,'2871849','834','00','005010X220A1','2871849','','2014-02-19','12:53:03',0,'2014-02-20 03:55:31',NULL,NULL),(21542,4041,'2944289','834','00','005010X220A1','2944289','','2014-02-27','15:28:33',0,'2014-02-28 06:31:41',NULL,NULL),(23239,4363,'3548645','834','00','005010X220A1','3548645','','2014-03-07','17:02:01',0,'2014-03-07 21:32:14',NULL,NULL),(408,77,'421371','834','00','005010X220A1','421371','','2013-12-04','00:58:53',0,'2013-12-25 17:48:37',NULL,NULL),(12977,1734,'2046860','834','00','005010X220A1','2046860','','2014-01-04','15:19:37',0,'2014-01-05 00:01:20',NULL,NULL),(12631,1671,'1926919','834','00','005010X220A1','1926919','','2014-01-02','17:52:45',0,'2014-01-03 02:02:09',NULL,NULL),(11568,1492,'1429929','834','00','005010X220A1','1429929','','2013-12-27','14:19:49',0,'2013-12-28 03:33:45',NULL,NULL),(1122,238,'1468123','834','00','005010X220A1','1468123','','2013-12-24','13:36:05',0,'2013-12-25 18:45:20',NULL,NULL),(2008,330,'1054421','834','00','005010X220A1','1054421','','2013-12-09','16:47:41',0,'2013-12-25 19:35:07',NULL,NULL),(4428,791,'569352','834','00','005010X220A1','569352','','2013-11-06','11:41:45',0,'2013-12-25 23:16:59',NULL,NULL),(4862,885,'713723','834','00','005010X220A1','713723','','2013-11-21','17:52:23',0,'2013-12-26 00:15:59',NULL,NULL),(6408,1197,'23582','834','00','005010X220A1','23582','','2013-12-20','15:42:30',0,'2013-12-26 03:10:45',NULL,NULL),(13272,2116,'0001','999','BE','005010X231A1','99905','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:54',NULL,NULL),(14720,2550,'2346426','834','00','005010X220A1','2346426','','2014-01-14','11:31:05',0,'2014-01-15 02:06:10',NULL,NULL),(14912,2558,'1737868','834','00','005010X220A1','1737868','','2014-01-14','16:57:39',0,'2014-01-15 02:07:35',NULL,NULL),(15250,2600,'1633337','834','00','005010X220A1','1633337','','2014-01-14','22:58:04',0,'2014-01-16 08:46:56',NULL,NULL),(16312,2980,'2522717','834','00','005010X220A1','2522717','','2014-01-23','15:12:47',0,'2014-01-23 21:00:22',NULL,NULL),(18020,3318,'1540150','834','00','005010X220A1','1540150','','2014-02-05','21:17:51',0,'2014-02-06 21:00:20',NULL,NULL),(19481,3620,'2772733','834','00','005010X220A1','2772733','','2014-02-13','23:23:24',0,'2014-02-14 21:30:12',NULL,NULL),(20500,3846,'3586504','834','00','005010X220A1','3586504','','2014-02-20','12:19:05',0,'2014-02-20 22:01:04',NULL,NULL),(20605,3870,'3083511','834','00','005010X220A1','3083511','','2014-02-21','16:02:04',0,'2014-02-21 22:00:18',NULL,NULL),(21631,4068,'3449971','834','00','005010X220A1','3449971','','2014-02-27','07:32:11',0,'2014-02-28 07:30:25',NULL,NULL),(22193,4181,'3076306','834','00','005010X220A1','3076306','','2014-03-03','16:11:20',0,'2014-03-03 21:31:26',NULL,NULL),(22531,4247,'3259175','834','00','005010X220A1','3259175','','2014-03-05','16:21:54',0,'2014-03-05 21:30:28',NULL,NULL),(416,77,'1024740','834','00','005010X220A1','1024740','','2013-12-03','19:56:07',0,'2013-12-25 17:48:53',NULL,NULL),(13318,2162,'0001','999','BE','005010X231A1','1203839','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:02',NULL,NULL),(13296,2140,'0001','999','BE','005010X231A1','1267470','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:01',NULL,NULL),(4191,734,'401340','834','00','005010X220A1','401340','','2013-12-19','16:14:21',0,'2013-12-25 23:05:58',NULL,NULL),(12758,1694,'1463290','834','00','005010X220A1','1463290','','2014-01-02','13:19:22',0,'2014-01-03 02:07:01',NULL,NULL),(1690,291,'1154982','834','00','005010X220A1','1154982','','2013-12-10','16:40:43',0,'2013-12-25 19:16:12',NULL,NULL),(10829,1404,'1019262','834','00','005010X220A1','1019262','','2013-12-23','18:09:52',0,'2013-12-26 13:04:49',NULL,NULL),(11050,1418,'228934','834','00','005010X220A1','228934','','2013-12-23','18:11:16',0,'2013-12-26 13:12:26',NULL,NULL),(11168,1441,'970982','834','00','005010X220A1','970982','','2013-12-23','09:56:33',0,'2013-12-26 13:16:33',NULL,NULL),(12224,1617,'2053195','834','00','005010X220A1','2053195','','2013-12-31','18:44:05',1,'2014-01-02 04:22:23',NULL,NULL),(14803,2551,'1538367','834','00','005010X220A1','1538367','','2014-01-14','18:32:44',0,'2014-01-15 02:06:46',NULL,NULL),(16474,3008,'2645482','834','00','005010X220A1','2645482','','2014-01-24','13:08:09',0,'2014-01-24 21:00:26',NULL,NULL),(17930,3296,'1464112','834','00','005010X220A1','1464112','','2014-02-05','14:51:24',0,'2014-02-05 21:30:44',NULL,NULL),(19836,3684,'3381508','834','00','005010X220A1','3381508','','2014-02-15','11:05:51',0,'2014-02-15 22:01:53',NULL,NULL),(21090,3984,'3249568','834','00','005010X220A1','3249568','','2014-02-24','16:36:22',0,'2014-02-26 09:30:56',NULL,NULL),(351,72,'1294753','834','00','005010X220A1','1294753','','2013-12-04','16:09:44',0,'2013-12-25 17:46:49',NULL,NULL),(11614,1494,'1750024','834','00','005010X220A1','1750024','','2013-12-27','11:25:51',0,'2013-12-28 03:35:11',NULL,NULL),(11934,1571,'2416218','834','00','005010X220A1','2416218','','2013-12-29','08:18:15',0,'2013-12-30 00:02:06',NULL,NULL),(6134,1166,'792440','834','00','005010X220A1','792440','','2013-12-20','15:55:53',0,'2013-12-26 03:02:22',NULL,NULL),(6073,1164,'322234','834','00','005010X220A1','322234','','2013-12-20','15:44:32',0,'2013-12-26 03:00:26',NULL,NULL),(4207,737,'218318','834','00','005010X220A1','218318','','2013-12-19','06:41:32',0,'2013-12-25 23:06:27',NULL,NULL),(13417,2222,'2277071','834','00','005010X220A1','2277071','','2014-01-06','16:14:34',0,'2014-01-07 04:01:28',NULL,NULL),(14595,2521,'2488808','834','00','005010X220A1','2488808','','2014-01-13','13:39:28',0,'2014-01-14 01:33:03',NULL,NULL),(17631,3244,'2293086','834','00','005010X220A1','2293086','','2014-02-03','10:25:48',0,'2014-02-03 21:01:17',NULL,NULL),(17728,3261,'2667642','834','00','005010X220A1','2667642','','2014-02-04','16:37:37',0,'2014-02-04 21:00:46',NULL,NULL),(19378,3591,'2786111','834','00','005010X220A1','2786111','','2014-02-12','23:05:32',0,'2014-02-13 22:02:13',NULL,NULL),(20690,3889,'3458946','834','00','005010X220A1','3458946','','2014-02-22','10:27:06',0,'2014-02-22 19:00:13',NULL,NULL),(21666,4077,'3119209','834','00','005010X220A1','3119209','','2014-02-28','17:48:09',0,'2014-02-28 21:00:11',NULL,NULL),(21842,4107,'3355179','834','00','005010X220A1','3355179','','2014-02-28','14:06:44',0,'2014-02-28 21:31:53',NULL,NULL),(22335,4204,'3752497','834','00','005010X220A1','3752497','','2014-03-03','18:08:51',0,'2014-03-04 21:01:26',NULL,NULL),(2244,375,'203521','834','00','005010X220A1','203521','','2013-12-02','14:19:40',0,'2013-12-25 19:49:42',NULL,NULL),(13527,2240,'2011122','834','00','005010X220A1','2011122','','2014-01-06','10:24:33',0,'2014-01-07 04:05:40',NULL,NULL),(7529,1300,'1012975','834','00','005010X220A1','1012975','','2013-12-21','13:58:10',0,'2013-12-26 04:34:58',NULL,NULL),(6145,1166,'644205','834','00','005010X220A1','644205','','2013-12-20','17:20:14',0,'2013-12-26 03:02:39',NULL,NULL),(12702,1677,'1880208','834','00','005010X220A1','1880208','','2014-01-02','12:37:01',0,'2014-01-03 02:04:50',NULL,NULL),(5037,935,'974347','834','00','005010X220A1','974347','','2013-12-11','14:46:14',0,'2013-12-26 00:47:10',NULL,NULL),(4998,935,'615292','834','00','005010X220A1','615292','','2013-12-11','09:27:36',0,'2013-12-26 00:45:54',NULL,NULL),(2408,415,'1016016','834','00','005010X220A1','1016016','','2013-12-05','20:01:45',0,'2013-12-25 20:17:29',NULL,NULL),(14706,2550,'2097996','834','00','005010X220A1','2097996','','2014-01-13','23:37:27',0,'2014-01-15 02:06:04',NULL,NULL),(15967,2764,'2086260','834','00','005010X220A1','2086260','','2014-01-22','10:56:39',0,'2014-01-23 03:01:58',NULL,NULL),(16625,3051,'2094617','834','00','005010X220A1','2094617','','2014-01-25','21:21:33',0,'2014-01-26 19:00:21',NULL,NULL),(19254,3581,'2383332','834','00','005010X220A1','2383332','','2014-02-12','21:48:20',0,'2014-02-13 22:00:37',NULL,NULL),(12465,1639,'2155470','834','00','005010X220A1','2155470','','2013-12-31','17:22:44',1,'2014-01-02 04:32:05',NULL,NULL),(4213,738,'774658','834','00','005010X220A1','774658','','2013-12-18','19:38:45',0,'2013-12-25 23:06:37',NULL,NULL),(6285,1172,'1304218','834','00','005010X220A1','1304218','','2013-12-20','15:27:27',0,'2013-12-26 03:06:59',NULL,NULL),(20856,3911,'2836313','834','00','005010X220A1','2836313','','2014-02-25','16:22:33',0,'2014-02-25 21:31:36',NULL,NULL),(18871,3493,'3230794','834','00','005010X220A1','3230794','','2014-02-11','14:51:40',0,'2014-02-11 21:02:10',NULL,NULL),(17392,3198,'1499134','834','00','005010X220A1','1499134','','2014-01-31','19:03:41',0,'2014-02-01 19:00:04',NULL,NULL),(11250,1454,'827459','834','00','005010X220A1','827459','','2013-12-26','15:00:08',0,'2013-12-27 02:01:58',NULL,NULL),(11591,1492,'1847956','834','00','005010X220A1','1847956','','2013-12-27','17:45:26',0,'2013-12-28 03:34:27',NULL,NULL),(14995,2584,'1591841','834','00','005010X220A1','1591841','','2014-01-14','19:36:15',0,'2014-01-16 08:44:14',NULL,NULL),(14423,2444,'0001','999','BE','005010X231A1','1052121','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:34',NULL,NULL),(23333,4384,'3712554','834','00','005010X220A1','3712554','','2014-03-08','12:44:42',0,'2014-03-08 21:30:45',NULL,NULL),(23367,4392,'2903994','834','00','005010X220A1','2903994','','2014-03-08','13:10:41',0,'2014-03-08 21:31:11',NULL,NULL),(2216,366,'595602','834','00','005010X220A1','595602','','2013-12-02','12:11:45',0,'2013-12-25 19:48:41',NULL,NULL),(23027,4327,'2692991','834','00','005010X220A1','2692991','','2014-03-07','09:32:21',0,'2014-03-07 21:00:23',NULL,NULL),(5678,1056,'904201','834','00','005010X220A1','904201','','2013-12-24','21:08:20',0,'2013-12-26 01:52:21',NULL,NULL),(22406,4214,'2992072','834','00','005010X220A1','2992072','','2014-03-04','16:42:16',0,'2014-03-04 21:02:25',NULL,NULL),(21356,4024,'3050907','834','00','005010X220A1','3050907','','2014-02-26','18:15:48',0,'2014-02-28 06:30:14',NULL,NULL),(19387,3592,'2324645','834','00','005010X220A1','2324645','','2014-02-13','15:29:12',0,'2014-02-13 22:02:19',NULL,NULL),(3920,712,'954233','834','00','005010X220A1','954233','','2013-12-07','16:10:02',0,'2013-12-25 22:45:38',NULL,NULL),(16276,2968,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:57:00',0,'2014-01-23 13:00:02',NULL,NULL),(3067,544,'315464','834','00','005010X220A1','315464','','2013-12-13','16:51:32',0,'2013-12-25 21:35:09',NULL,NULL),(23030,4328,'2941962','834','00','005010X220A1','2941962','','2014-03-07','09:57:31',0,'2014-03-07 21:00:25',NULL,NULL),(3315,584,'1206602','834','00','005010X220A1','1206602','','2013-12-17','16:00:01',0,'2013-12-25 21:48:59',NULL,NULL),(3539,616,'903447','834','00','005010X220A1','903447','','2013-12-12','10:42:12',0,'2013-12-25 22:02:26',NULL,NULL),(2881,523,'1081084','834','00','005010X220A1','1081084','','2013-12-22','10:38:47',0,'2013-12-25 21:23:02',NULL,NULL),(4032,731,'299488','834','00','005010X220A1','299488','','2013-12-19','14:35:24',0,'2013-12-25 23:01:07',NULL,NULL),(21390,4024,'2719022','834','00','005010X220A1','2719022','','2014-02-27','17:18:34',0,'2014-02-28 06:30:30',NULL,NULL),(4614,827,'1361421','834','00','005010X220A1','1361421','','2013-12-23','21:37:05',0,'2013-12-25 23:47:41',NULL,NULL),(16460,3006,'1639950','834','00','005010X220A1','1639950','','2014-01-24','17:30:07',0,'2014-01-24 21:00:17',NULL,NULL),(2813,506,'1263334','834','00','005010X220A1','1263334','','2013-12-22','17:04:39',0,'2013-12-25 21:20:44',NULL,NULL),(10759,1403,'1615013','834','00','005010X220A1','1615013','','2013-12-23','19:12:50',0,'2013-12-26 13:02:32',NULL,NULL),(2858,512,'1491988','834','00','005010X220A1','1491988','','2013-12-22','15:45:17',0,'2013-12-25 21:22:16',NULL,NULL),(2428,417,'1205084','834','00','005010X220A1','1205084','','2013-12-06','12:38:20',0,'2013-12-25 20:18:06',NULL,NULL),(13538,2241,'1746635','834','00','005010X220A1','1746635','','2014-01-06','16:20:06',0,'2014-01-07 04:06:00',NULL,NULL),(17710,3261,'1423304','834','00','005010X220A1','1423304','','2014-02-04','00:19:51',0,'2014-02-04 21:00:35',NULL,NULL),(13229,2073,'0001','999','BE','005010X231A1','311098','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:13',NULL,NULL),(12403,1637,'2409036','834','00','005010X220A1','2409036','','2013-12-31','13:50:48',1,'2014-01-02 04:29:45',NULL,NULL),(5411,1024,'1212434','834','00','005010X220A1','1212434','','2013-11-14','16:34:11',0,'2013-12-26 01:30:41',NULL,NULL),(17035,3120,'2465898','834','00','005010X220A1','2465898','','2014-01-29','16:49:18',0,'2014-01-29 21:01:16',NULL,NULL),(10424,1400,'353093','834','00','005010X220A1','353093','','2013-12-23','10:33:51',0,'2013-12-26 12:51:25',NULL,NULL),(13992,2327,'1359463','834','00','005010X220A1','1359463','','2014-01-08','19:22:40',0,'2014-01-13 02:20:51',NULL,NULL),(2914,540,'1137052','834','00','005010X220A1','1137052','','2013-12-13','16:33:25',0,'2013-12-25 21:30:22',NULL,NULL),(3213,578,'1114348','834','00','005010X220A1','1114348','','2013-12-17','08:54:30',0,'2013-12-25 21:45:44',NULL,NULL),(13153,1997,'0001','999','BE','005010X231A1','1326502','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:41',NULL,NULL),(12761,1696,'1508343','834','00','005010X220A1','1508343','','2014-01-02','13:38:44',0,'2014-01-03 02:07:07',NULL,NULL),(20809,3910,'3000667','834','00','005010X220A1','3000667','','2014-02-25','00:04:51',0,'2014-02-25 21:31:01',NULL,NULL),(23020,4325,'2918185','834','00','005010X220A1','2918185','','2014-03-07','11:27:23',0,'2014-03-07 21:00:20',NULL,NULL),(22975,4316,'3687181','834','00','005010X220A1','3687181','','2014-03-06','13:36:57',0,'2014-03-06 21:30:15',NULL,NULL),(10834,1404,'1819565','834','00','005010X220A1','1819565','','2013-12-23','18:22:32',0,'2013-12-26 13:04:57',NULL,NULL),(11504,1489,'2214958','834','00','005010X220A1','2214958','','2013-12-27','17:09:10',0,'2013-12-28 03:31:46',NULL,NULL),(22625,4252,'3205548','834','00','005010X220A1','3205548','','2014-03-04','20:35:42',0,'2014-03-05 21:31:36',NULL,NULL),(16428,3003,'1415532','834','00','005010X220A1','1415532','','2014-01-23','14:38:17',0,'2014-01-23 21:01:41',NULL,NULL),(22125,4179,'3834545','834','00','005010X220A1','3834545','','2014-03-03','10:16:51',0,'2014-03-03 21:30:38',NULL,NULL),(13331,2175,'0001','999','BE','005010X231A1','1170605','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:38',NULL,NULL),(5023,935,'1101180','834','00','005010X220A1','1101180','','2013-12-11','11:52:19',0,'2013-12-26 00:46:42',NULL,NULL),(17568,3236,'2118665','834','00','005010X220A1','2118665','','2014-02-03','14:22:05',0,'2014-02-03 21:00:37',NULL,NULL),(16499,3011,'1894163','834','00','005010X220A1','1894163','','2014-01-24','13:09:43',0,'2014-01-24 21:00:40',NULL,NULL),(10558,1402,'180465','834','00','005010X220A1','180465','','2013-12-22','22:30:47',0,'2013-12-26 12:55:48',NULL,NULL),(15963,2764,'2450612','834','00','005010X220A1','2450612','','2014-01-21','22:13:51',0,'2014-01-23 03:01:56',NULL,NULL),(2755,505,'1352552','834','00','005010X220A1','1352552','','2013-12-21','19:34:30',0,'2013-12-25 21:18:53',NULL,NULL),(14929,2560,'2191482','834','00','005010X220A1','2191482','','2014-01-14','14:56:53',0,'2014-01-15 02:07:42',NULL,NULL),(12354,1634,'1616679','834','00','005010X220A1','1616679','','2013-12-31','14:01:09',1,'2014-01-02 04:28:01',NULL,NULL),(23763,4478,'3062274','834','00','005010X220A1','3062274','','2014-03-10','12:38:40',0,'2014-03-10 21:30:12',NULL,NULL),(267,52,'995148','834','00','005010X220A1','995148','','2013-11-13','12:31:38',0,'2013-12-25 17:31:28',NULL,NULL),(7253,1246,'759001','834','00','005010X220A1','759001','','2013-12-18','11:43:19',0,'2013-12-26 04:08:18',NULL,NULL),(1542,262,'1648390','834','00','005010X220A1','1648390','','2013-12-24','11:32:22',0,'2013-12-25 18:58:40',NULL,NULL),(1817,312,'608529','834','00','005010X220A1','608529','','2013-12-10','13:34:18',0,'2013-12-25 19:20:09',NULL,NULL),(6263,1172,'534888','834','00','005010X220A1','534888','','2013-12-20','00:04:24',0,'2013-12-26 03:06:18',NULL,NULL),(3533,616,'397296','834','00','005010X220A1','397296','','2013-12-12','08:32:50',0,'2013-12-25 22:02:15',NULL,NULL),(4937,918,'231396','834','00','005010X220A1','231396','','2013-11-19','15:45:39',0,'2013-12-26 00:31:21',NULL,NULL),(3804,661,'192337','834','00','005010X220A1','192337','','2013-12-07','20:55:29',0,'2013-12-25 22:16:28',NULL,NULL),(4226,738,'456751','834','00','005010X220A1','456751','','2013-12-19','11:30:03',0,'2013-12-25 23:07:03',NULL,NULL),(4239,739,'79849','834','00','005010X220A1','79849','','2013-12-18','19:38:53',0,'2013-12-25 23:07:27',NULL,NULL),(13616,2270,'2014508','834','00','005010X220A1','2014508','','2014-01-06','18:28:00',0,'2014-01-08 18:23:56',NULL,NULL),(14400,2421,'0001','999','BE','005010X231A1','949643','834','2013-12-28','12:25:00',0,'2014-01-13 03:02:14',NULL,NULL),(14436,2457,'0001','999','BE','005010X231A1','764857','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:08',NULL,NULL),(18462,3426,'2171647','834','00','005010X220A1','2171647','','2014-02-10','00:22:57',0,'2014-02-10 11:00:44',NULL,NULL),(18567,3453,'1624001','834','00','005010X220A1','1624001','','2014-02-10','11:35:06',0,'2014-02-10 21:30:40',NULL,NULL),(18970,3537,'2929797','834','00','005010X220A1','2929797','','2014-02-11','19:31:12',0,'2014-02-12 21:30:05',NULL,NULL),(22217,4188,'3531152','834','00','005010X220A1','3531152','','2014-03-03','13:59:02',0,'2014-03-03 21:31:44',NULL,NULL),(22433,4230,'3291655','834','00','005010X220A1','3291655','','2014-03-03','18:01:25',0,'2014-03-04 21:30:04',NULL,NULL),(22674,4255,'3344781','834','00','005010X220A1','3344781','','2014-03-05','12:52:13',0,'2014-03-05 21:32:09',NULL,NULL),(20070,3758,'3596295','834','00','005010X220A1','3596295','','2014-02-18','10:31:02',0,'2014-02-18 22:01:24',NULL,NULL),(20230,3787,'3366450','834','00','005010X220A1','3366450','','2014-02-18','19:56:19',0,'2014-02-20 04:26:15',NULL,NULL),(20712,3894,'3544949','834','00','005010X220A1','3544949','','2014-02-24','21:12:28',0,'2014-02-25 21:00:19',NULL,NULL),(140,10,'1101005','834','00','005010X220A1','1101005','','2013-12-04','19:11:17',0,'2013-12-25 17:19:20',NULL,NULL),(2988,542,'286022','834','00','005010X220A1','286022','','2013-12-13','11:30:50',0,'2013-12-25 21:32:46',NULL,NULL),(4381,774,'22890','834','00','005010X220A1','22890','','2013-11-26','18:40:51',0,'2013-12-25 23:15:22',NULL,NULL),(4542,825,'1662588','834','00','005010X220A1','1662588','','2013-12-23','21:33:41',0,'2013-12-25 23:45:25',NULL,NULL),(4929,913,'885642','834','00','005010X220A1','885642','','2013-10-15','22:03:15',0,'2013-12-26 00:31:05',NULL,NULL),(1042,204,'824895','834','00','005010X220A1','824895','','2013-11-28','19:09:34',0,'2013-12-25 18:30:02',NULL,NULL),(7185,1239,'939225','834','00','005010X220A1','939225','','2013-12-17','22:18:46',0,'2013-12-26 04:06:11',NULL,NULL),(7356,1283,'177167','834','00','005010X220A1','177167','','2013-11-30','12:11:31',0,'2013-12-26 04:15:40',NULL,NULL),(989,184,'745129','834','00','005010X220A1','745129','','2013-12-03','03:55:01',0,'2013-12-25 18:19:51',NULL,NULL),(12458,1639,'1419780','834','00','005010X220A1','1419780','','2013-12-31','12:50:13',1,'2014-01-02 04:31:47',NULL,NULL),(958,181,'1146942','834','00','005010X220A1','1146942','','2013-12-03','16:38:10',0,'2013-12-25 18:18:52',NULL,NULL),(14137,2353,'1427607','834','00','005010X220A1','1427607','','2014-01-08','09:26:10',0,'2014-01-13 02:22:34',NULL,NULL),(14773,2551,'1787752','834','00','005010X220A1','1787752','','2014-01-14','12:22:04',0,'2014-01-15 02:06:34',NULL,NULL),(14825,2552,'1388596','834','00','005010X220A1','1388596','','2014-01-14','17:10:00',0,'2014-01-15 02:06:55',NULL,NULL),(15059,2585,'1645548','834','00','005010X220A1','1645548','','2014-01-14','22:16:01',0,'2014-01-16 08:44:55',NULL,NULL),(15471,2634,'2438789','834','00','005010X220A1','2438789','','2014-01-15','22:24:22',0,'2014-01-17 03:36:19',NULL,NULL),(16334,2983,'2610270','834','00','005010X220A1','2610270','','2014-01-23','10:02:26',0,'2014-01-23 21:00:38',NULL,NULL),(17552,3236,'2590644','834','00','005010X220A1','2590644','','2014-02-02','22:18:00',0,'2014-02-03 21:00:28',NULL,NULL),(18381,3407,'1620179','834','00','005010X220A1','1620179','','2014-02-09','12:58:38',0,'2014-02-09 19:00:22',NULL,NULL),(18481,3432,'1781388','834','00','005010X220A1','1781388','','2014-02-10','04:02:45',0,'2014-02-10 11:01:00',NULL,NULL),(18528,3451,'2711118','834','00','005010X220A1','2711118','','2014-02-10','12:32:14',0,'2014-02-10 21:30:14',NULL,NULL),(18949,3528,'2883325','834','00','005010X220A1','2883325','','2014-02-11','16:55:48',0,'2014-02-11 21:30:28',NULL,NULL),(19450,3607,'3299875','834','00','005010X220A1','3299875','','2014-02-13','15:09:19',0,'2014-02-13 22:03:07',NULL,NULL),(21449,4028,'3712210','834','00','005010X220A1','3712210','','2014-02-26','21:04:28',0,'2014-02-28 06:30:58',NULL,NULL),(21681,4082,'3701711','834','00','005010X220A1','3701711','','2014-02-28','14:25:53',0,'2014-02-28 21:00:22',NULL,NULL),(21894,4125,'2936297','834','00','005010X220A1','2936297','','2014-03-01','11:39:19',0,'2014-03-01 21:00:26',NULL,NULL),(22156,4180,'2827980','834','00','005010X220A1','2827980','','2014-03-03','10:28:20',0,'2014-03-03 21:30:59',NULL,NULL),(22248,4200,'3055858','834','00','005010X220A1','3055858','','2014-03-03','19:54:28',0,'2014-03-04 21:00:18',NULL,NULL),(22271,4200,'2722995','834','00','005010X220A1','2722995','','2014-03-04','13:47:42',0,'2014-03-04 21:00:37',NULL,NULL),(22853,4280,'3208257','834','00','005010X220A1','3208257','','2014-03-05','18:58:51',0,'2014-03-06 21:01:41',NULL,NULL),(23263,4377,'3204635','834','00','005010X220A1','3204635','','2014-03-08','11:21:39',0,'2014-03-08 21:00:03',NULL,NULL),(3919,712,'5320','834','00','005010X220A1','5320','','2013-12-07','13:51:54',0,'2013-12-25 22:45:37',NULL,NULL),(7215,1241,'1306589','834','00','005010X220A1','1306589','','2013-12-18','10:50:59',0,'2013-12-26 04:07:04',NULL,NULL),(5999,1133,'757624','834','00','005010X220A1','757624','','2013-12-15','16:11:45',0,'2013-12-26 02:34:00',NULL,NULL),(7263,1248,'577849','834','00','005010X220A1','577849','','2013-12-17','21:40:26',0,'2013-12-26 04:08:34',NULL,NULL),(5483,1040,'1612716','834','00','005010X220A1','1612716','','2013-12-25','00:13:56',0,'2013-12-26 01:45:51',NULL,NULL),(4051,731,'1142222','834','00','005010X220A1','1142222','','2013-12-19','18:13:27',0,'2013-12-25 23:01:43',NULL,NULL),(11611,1494,'1545875','834','00','005010X220A1','1545875','','2013-12-27','10:07:30',0,'2013-12-28 03:35:03',NULL,NULL),(12021,1583,'1846870','834','00','005010X220A1','1846870','','2013-12-30','12:34:01',0,'2014-01-01 12:02:52',NULL,NULL),(12369,1634,'1439821','834','00','005010X220A1','1439821','','2013-12-31','17:30:40',1,'2014-01-02 04:28:31',NULL,NULL),(4035,731,'280414','834','00','005010X220A1','280414','','2013-12-19','14:50:44',0,'2013-12-25 23:01:12',NULL,NULL),(12770,1702,'2276997','834','00','005010X220A1','2276997','','2014-01-02','19:29:09',0,'2014-01-04 02:00:05',NULL,NULL),(4016,731,'754003','834','00','005010X220A1','754003','','2013-12-19','11:11:02',0,'2013-12-25 23:00:36',NULL,NULL),(12978,1734,'1985710','834','00','005010X220A1','1985710','','2014-01-04','15:41:04',0,'2014-01-05 00:01:21',NULL,NULL),(16198,2890,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 04:45:47',NULL,NULL),(17155,3144,'1952251','834','00','005010X220A1','1952251','','2014-01-30','16:11:10',0,'2014-01-30 21:00:40',NULL,NULL),(17736,3262,'2722162','834','00','005010X220A1','2722162','','2014-02-03','21:07:10',0,'2014-02-04 21:00:51',NULL,NULL),(17865,3293,'2802913','834','00','005010X220A1','2802913','','2014-02-05','13:46:00',0,'2014-02-05 21:30:13',NULL,NULL),(18327,3386,'2552001','834','00','005010X220A1','2552001','','2014-02-08','10:17:23',0,'2014-02-08 19:00:51',NULL,NULL),(20909,3931,'3220562','834','00','005010X220A1','3220562','','2014-02-23','03:04:58',0,'2014-02-26 08:00:09',NULL,NULL),(460,85,'621649','834','00','005010X220A1','621649','','2013-12-04','15:12:03',0,'2013-12-25 17:50:18',NULL,NULL),(13487,2226,'1485186','834','00','005010X220A1','1485186','','2014-01-06','14:49:39',0,'2014-01-07 04:04:08',NULL,NULL),(4521,815,'687692','834','00','005010X220A1','687692','','2013-11-26','00:55:04',0,'2013-12-25 23:32:46',NULL,NULL),(11087,1423,'1741113','834','00','005010X220A1','1741113','','2013-12-23','16:27:27',0,'2013-12-26 13:13:40',NULL,NULL),(3638,622,'1134704','834','00','005010X220A1','1134704','','2013-12-12','14:22:31',0,'2013-12-25 22:05:32',NULL,NULL),(14542,2518,'1675075','834','00','005010X220A1','1675075','','2014-01-13','15:16:20',0,'2014-01-14 01:32:29',NULL,NULL),(14623,2524,'1698088','834','00','005010X220A1','1698088','','2014-01-13','12:15:10',0,'2014-01-14 01:33:21',NULL,NULL),(14884,2558,'1817371','834','00','005010X220A1','1817371','','2014-01-14','01:07:34',0,'2014-01-15 02:07:23',NULL,NULL),(15639,2677,'1366827','834','00','005010X220A1','1366827','','2014-01-17','19:03:40',0,'2014-01-21 08:44:17',NULL,NULL),(16426,3002,'1862737','834','00','005010X220A1','1862737','','2014-01-23','09:44:22',0,'2014-01-23 21:01:40',NULL,NULL),(16696,3064,'2372841','834','00','005010X220A1','2372841','','2014-01-26','19:58:50',0,'2014-01-27 21:00:41',NULL,NULL),(17111,3142,'2084228','834','00','005010X220A1','2084228','','2014-01-30','14:07:09',0,'2014-01-30 21:00:13',NULL,NULL),(20675,3881,'3636566','834','00','005010X220A1','3636566','','2014-02-21','13:43:20',0,'2014-02-21 22:01:09',NULL,NULL),(20973,3956,'2899421','834','00','005010X220A1','2899421','','2014-02-22','11:25:48',0,'2014-02-26 08:30:11',NULL,NULL),(21169,3997,'2778059','834','00','005010X220A1','2778059','','2014-02-26','17:46:55',0,'2014-02-26 21:00:56',NULL,NULL),(23217,4349,'2874734','834','00','005010X220A1','2874734','','2014-03-07','13:02:10',0,'2014-03-07 21:31:58',NULL,NULL),(23402,4404,'3910644','834','00','005010X220A1','3910644','','2014-03-08','19:43:40',0,'2014-03-09 21:00:13',NULL,NULL),(23553,4436,'3445753','834','00','005010X220A1','3445753','','2014-03-09','18:39:11',0,'2014-03-10 21:00:43',NULL,NULL),(23704,4452,'3706099','834','00','005010X220A1','3706099','','2014-03-10','09:15:38',0,'2014-03-10 21:02:30',NULL,NULL),(1580,278,'167804','834','00','005010X220A1','167804','','2013-11-19','20:36:31',0,'2013-12-25 19:00:38',NULL,NULL),(7206,1241,'326954','834','00','005010X220A1','326954','','2013-12-17','23:44:00',0,'2013-12-26 04:06:50',NULL,NULL),(7476,1296,'1058721','834','00','005010X220A1','1058721','','2013-12-21','16:04:46',0,'2013-12-26 04:33:10',NULL,NULL),(4731,846,'749900','834','00','005010X220A1','749900','','2013-12-23','22:57:25',0,'2013-12-25 23:51:46',NULL,NULL),(10404,1400,'83865','834','00','005010X220A1','83865','','2013-12-23','09:04:02',0,'2013-12-26 12:50:50',NULL,NULL),(4494,804,'179643','834','00','005010X220A1','179643','','2013-11-26','14:47:19',0,'2013-12-25 23:31:52',NULL,NULL),(10804,1404,'564051','834','00','005010X220A1','564051','','2013-12-23','14:50:29',0,'2013-12-26 13:03:59',NULL,NULL),(10933,1410,'889978','834','00','005010X220A1','889978','','2013-12-23','13:00:53',0,'2013-12-26 13:08:43',NULL,NULL),(4369,769,'991945','834','00','005010X220A1','991945','','2013-12-19','17:41:48',0,'2013-12-25 23:11:22',NULL,NULL),(4251,740,'642801','834','00','005010X220A1','642801','','2013-12-18','19:43:29',0,'2013-12-25 23:07:50',NULL,NULL),(3730,638,'16826','834','00','005010X220A1','16826','','2013-12-12','14:11:38',0,'2013-12-25 22:08:34',NULL,NULL),(2788,506,'372249','834','00','005010X220A1','372249','','2013-12-22','10:23:03',0,'2013-12-25 21:19:58',NULL,NULL),(5176,948,'270927','834','00','005010X220A1','270927','','2013-12-11','15:35:03',0,'2013-12-26 00:51:35',NULL,NULL),(5442,1033,'882122','834','00','005010X220A1','882122','','2013-10-05','17:31:14',0,'2013-12-26 01:31:42',NULL,NULL),(13433,2222,'1393414','834','00','005010X220A1','1393414','','2014-01-06','17:59:53',0,'2014-01-07 04:02:03',NULL,NULL),(13648,2271,'2338213','834','00','005010X220A1','2338213','','2014-01-07','12:01:07',0,'2014-01-08 18:24:09',NULL,NULL),(14448,2469,'0001','999','BE','005010X231A1','129405','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:21',NULL,NULL),(16034,2770,'1411570','834','00','005010X220A1','1411570','','2014-01-22','18:06:41',0,'2014-01-23 03:02:28',NULL,NULL),(16669,3060,'2652444','834','00','005010X220A1','2652444','','2014-01-27','18:16:57',0,'2014-01-27 21:00:23',NULL,NULL),(17268,3170,'2233588','834','00','005010X220A1','2233588','','2014-01-31','11:43:53',0,'2014-01-31 21:00:19',NULL,NULL),(17851,3291,'2000989','834','00','005010X220A1','2000989','','2014-02-05','11:49:43',0,'2014-02-05 21:30:06',NULL,NULL),(22019,4152,'3618784','834','00','005010X220A1','3618784','','2014-03-02','07:47:24',0,'2014-03-03 01:00:35',NULL,NULL),(23337,4384,'2738046','834','00','005010X220A1','2738046','','2014-03-08','16:02:04',0,'2014-03-08 21:30:48',NULL,NULL),(23623,4441,'2935378','834','00','005010X220A1','2935378','','2014-03-10','10:45:45',0,'2014-03-10 21:01:32',NULL,NULL),(857,175,'827806','834','00','005010X220A1','827806','','2013-12-03','14:59:28',0,'2013-12-25 18:15:52',NULL,NULL),(6035,1145,'300154','834','00','005010X220A1','300154','','2013-11-17','10:57:19',0,'2013-12-26 02:46:01',NULL,NULL),(7726,1341,'1137688','834','00','005010X220A1','1137688','','2013-10-21','17:04:30',0,'2013-12-26 05:00:04',NULL,NULL),(11233,1454,'2086577','834','00','005010X220A1','2086577','','2013-12-26','11:35:19',0,'2013-12-27 02:01:27',NULL,NULL),(3861,690,'96865','834','00','005010X220A1','96865','','2013-10-10','10:20:44',0,'2013-12-25 22:30:58',NULL,NULL),(17202,3149,'2431016','834','00','005010X220A1','2431016','','2014-01-30','17:50:28',0,'2014-01-30 21:01:11',NULL,NULL),(18504,3443,'2965025','834','00','005010X220A1','2965025','','2014-02-10','15:16:05',0,'2014-02-10 21:00:05',NULL,NULL),(19025,3539,'3233150','834','00','005010X220A1','3233150','','2014-02-12','14:50:52',0,'2014-02-12 21:30:43',NULL,NULL),(19458,3612,'2770018','834','00','005010X220A1','2770018','','2014-02-13','14:37:33',0,'2014-02-13 22:03:14',NULL,NULL),(21332,4022,'3499964','834','00','005010X220A1','3499964','','2014-02-26','18:32:09',0,'2014-02-28 06:30:03',NULL,NULL),(21577,4055,'3116867','834','00','005010X220A1','3116867','','2014-02-26','13:32:33',0,'2014-02-28 07:00:19',NULL,NULL),(22287,4200,'3289576','834','00','005010X220A1','3289576','','2014-03-04','16:59:08',0,'2014-03-04 21:00:49',NULL,NULL),(22339,4204,'3306630','834','00','005010X220A1','3306630','','2014-03-03','21:44:47',0,'2014-03-04 21:01:29',NULL,NULL),(22609,4250,'3058280','834','00','005010X220A1','3058280','','2014-03-05','15:43:53',0,'2014-03-05 21:31:24',NULL,NULL),(23245,4365,'3692410','834','00','005010X220A1','3692410','','2014-03-07','12:34:57',0,'2014-03-07 21:32:19',NULL,NULL),(23298,4381,'3734721','834','00','005010X220A1','3734721','','2014-03-07','22:53:32',0,'2014-03-08 21:30:18',NULL,NULL),(130,8,'700716','834','00','005010X220A1','700716','','2013-12-05','14:28:37',0,'2013-12-25 17:19:02',NULL,NULL),(1294,244,'196763','834','00','005010X220A1','196763','','2013-12-24','11:01:28',0,'2013-12-25 18:50:36',NULL,NULL),(5302,986,'821786','834','00','005010X220A1','821786','','2013-11-05','13:27:59',0,'2013-12-26 01:01:30',NULL,NULL),(6419,1202,'675823','834','00','005010X220A1','675823','','2013-11-22','15:16:26',0,'2013-12-26 03:15:06',NULL,NULL),(11084,1423,'540121','834','00','005010X220A1','540121','','2013-12-22','20:43:22',0,'2013-12-26 13:13:34',NULL,NULL),(12499,1642,'1875204','834','00','005010X220A1','1875204','','2013-12-30','20:54:01',1,'2014-01-02 04:33:19',NULL,NULL),(13049,1893,'0001','999','BE','005010X231A1','1271176','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:17',NULL,NULL),(13114,1958,'0001','999','BE','005010X231A1','624169','834','2013-12-28','04:55:00',0,'2014-01-05 16:54:17',NULL,NULL),(466,88,'53052','834','00','005010X220A1','53052','','2013-12-03','19:45:29',0,'2013-12-25 17:50:30',NULL,NULL),(13328,2172,'0001','999','BE','005010X231A1','539400','834','2013-12-28','04:55:00',0,'2014-01-05 17:25:30',NULL,NULL),(14411,2432,'0001','999','BE','005010X231A1','707404','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:24',NULL,NULL),(15638,2676,'1920823','834','00','005010X220A1','1920823','','2014-01-18','14:18:46',0,'2014-01-21 08:44:17',NULL,NULL),(4101,733,'613440','834','00','005010X220A1','613440','','2013-12-19','11:18:51',0,'2013-12-25 23:03:16',NULL,NULL),(6187,1167,'1287573','834','00','005010X220A1','1287573','','2013-12-20','17:44:25',0,'2013-12-26 03:03:55',NULL,NULL),(14099,2343,'2402929','834','00','005010X220A1','2402929','','2014-01-08','07:29:41',0,'2014-01-13 02:22:09',NULL,NULL),(14356,2404,'1477197','834','00','005010X220A1','1477197','','2014-01-12','09:33:25',0,'2014-01-13 03:01:30',NULL,NULL),(14979,2574,'1714448','834','00','005010X220A1','1714448','','2014-01-14','12:10:53',0,'2014-01-15 02:08:06',NULL,NULL),(16215,2907,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:21:00',1,'2014-01-23 05:06:32',NULL,NULL),(16911,3107,'1991276','834','00','005010X220A1','1991276','','2014-01-28','13:25:16',0,'2014-01-28 21:01:20',NULL,NULL),(17265,3170,'2693504','834','00','005010X220A1','2693504','','2014-01-31','10:50:40',0,'2014-01-31 21:00:17',NULL,NULL),(19383,3591,'2580545','834','00','005010X220A1','2580545','','2014-02-13','15:26:51',0,'2014-02-13 22:02:17',NULL,NULL),(20057,3753,'2790001','834','00','005010X220A1','2790001','','2014-02-18','12:55:48',0,'2014-02-18 22:01:13',NULL,NULL),(21124,3994,'3496084','834','00','005010X220A1','3496084','','2014-02-26','16:23:25',0,'2014-02-26 21:00:26',NULL,NULL),(21283,4005,'2676491','834','00','005010X220A1','2676491','','2014-02-26','11:46:19',0,'2014-02-26 21:02:13',NULL,NULL),(22444,4231,'3014444','834','00','005010X220A1','3014444','','2014-03-04','12:57:15',0,'2014-03-04 21:30:12',NULL,NULL),(1488,254,'1835226','834','00','005010X220A1','1835226','','2013-12-24','11:30:46',0,'2013-12-25 18:57:00',NULL,NULL),(13499,2230,'1934893','834','00','005010X220A1','1934893','','2014-01-06','13:47:40',0,'2014-01-07 04:04:38',NULL,NULL),(7369,1287,'244933','834','00','005010X220A1','244933','','2013-11-30','12:12:29',0,'2013-12-26 04:16:12',NULL,NULL),(10840,1404,'1682959','834','00','005010X220A1','1682959','','2013-12-23','19:00:06',0,'2013-12-26 13:05:09',NULL,NULL),(11258,1455,'1921335','834','00','005010X220A1','1921335','','2013-12-25','19:28:11',0,'2013-12-27 02:02:13',NULL,NULL),(6384,1185,'1058660','834','00','005010X220A1','1058660','','2013-12-20','14:41:14',0,'2013-12-26 03:09:58',NULL,NULL),(4607,826,'1594972','834','00','005010X220A1','1594972','','2013-12-24','02:20:37',0,'2013-12-25 23:47:27',NULL,NULL),(3654,625,'1153719','834','00','005010X220A1','1153719','','2013-12-12','14:56:00',0,'2013-12-25 22:06:03',NULL,NULL),(14280,2377,'1486596','834','00','005010X220A1','1486596','','2014-01-09','21:22:13',0,'2014-01-13 03:00:16',NULL,NULL),(15041,2584,'2258167','834','00','005010X220A1','2258167','','2014-01-15','17:47:02',0,'2014-01-16 08:44:43',NULL,NULL),(15099,2587,'1426704','834','00','005010X220A1','1426704','','2014-01-14','19:15:25',0,'2014-01-16 08:45:19',NULL,NULL),(15932,2750,'2076892','834','00','005010X220A1','2076892','','2014-01-21','17:02:03',1,'2014-01-22 03:23:01',NULL,NULL),(16741,3066,'2249944','834','00','005010X220A1','2249944','','2014-01-26','22:24:11',0,'2014-01-27 21:01:11',NULL,NULL),(16916,3112,'2521317','834','00','005010X220A1','2521317','','2014-01-28','18:17:52',0,'2014-01-28 21:01:23',NULL,NULL),(17745,3262,'2598098','834','00','005010X220A1','2598098','','2014-02-04','10:38:34',0,'2014-02-04 21:00:57',NULL,NULL),(18856,3491,'2733283','834','00','005010X220A1','2733283','','2014-02-11','15:45:33',0,'2014-02-11 21:01:58',NULL,NULL),(19122,3545,'2417337','834','00','005010X220A1','2417337','','2014-02-12','18:01:47',0,'2014-02-12 21:31:52',NULL,NULL),(19399,3593,'3236769','834','00','005010X220A1','3236769','','2014-02-13','12:14:03',0,'2014-02-13 22:02:29',NULL,NULL),(19786,3675,'3267587','834','00','005010X220A1','3267587','','2014-02-15','14:14:33',0,'2014-02-15 22:01:10',NULL,NULL),(20655,3876,'2598533','834','00','005010X220A1','2598533','','2014-02-20','20:49:02',0,'2014-02-21 22:00:56',NULL,NULL),(20853,3911,'3057962','834','00','005010X220A1','3057962','','2014-02-25','15:52:18',0,'2014-02-25 21:31:33',NULL,NULL),(21262,4000,'3404838','834','00','005010X220A1','3404838','','2014-02-26','14:11:03',0,'2014-02-26 21:01:56',NULL,NULL),(21322,4015,'3456137','834','00','005010X220A1','3456137','','2014-02-26','14:20:01',0,'2014-02-26 21:02:42',NULL,NULL),(21663,4077,'3482956','834','00','005010X220A1','3482956','','2014-02-28','15:45:57',0,'2014-02-28 21:00:09',NULL,NULL),(814,160,'63159','834','00','005010X220A1','63159','','2013-11-11','16:38:42',0,'2013-12-25 18:10:42',NULL,NULL),(13383,2221,'2313865','834','00','005010X220A1','2313865','','2014-01-05','19:45:17',0,'2014-01-07 04:00:16',NULL,NULL),(5721,1069,'15572','834','00','005010X220A1','15572','','2013-12-14','12:07:55',0,'2013-12-26 02:01:04',NULL,NULL),(5553,1043,'1316447','834','00','005010X220A1','1316447','','2013-12-24','18:45:31',0,'2013-12-26 01:48:08',NULL,NULL),(5334,1002,'71229','834','00','005010X220A1','71229','','2013-11-25','17:56:27',0,'2013-12-26 01:15:18',NULL,NULL),(11117,1426,'892554','834','00','005010X220A1','892554','','2013-12-23','17:27:05',0,'2013-12-26 13:14:40',NULL,NULL),(11891,1561,'2314859','834','00','005010X220A1','2314859','','2013-12-28','19:57:07',0,'2013-12-30 00:00:42',NULL,NULL),(3193,578,'346210','834','00','005010X220A1','346210','','2013-12-16','18:41:44',0,'2013-12-25 21:45:06',NULL,NULL),(2606,484,'1124188','834','00','005010X220A1','1124188','','2013-10-06','12:12:00',0,'2013-12-25 20:46:10',NULL,NULL),(12697,1675,'1919087','834','00','005010X220A1','1919087','','2014-01-02','10:16:56',0,'2014-01-03 02:04:39',NULL,NULL),(1246,243,'1493388','834','00','005010X220A1','1493388','','2013-12-24','11:18:28',0,'2013-12-25 18:49:04',NULL,NULL),(13801,2294,'1440052','834','00','005010X220A1','1440052','','2014-01-11','15:23:08',0,'2014-01-13 02:18:15',NULL,NULL),(15009,2584,'2369144','834','00','005010X220A1','2369144','','2014-01-15','10:41:49',0,'2014-01-16 08:44:23',NULL,NULL),(15267,2603,'2278435','834','00','005010X220A1','2278435','','2014-01-15','11:16:19',0,'2014-01-16 08:47:08',NULL,NULL),(15519,2648,'2492537','834','00','005010X220A1','2492537','','2014-01-16','17:37:48',0,'2014-01-17 03:36:39',NULL,NULL),(16605,3047,'2184588','834','00','005010X220A1','2184588','','2014-01-26','15:32:14',0,'2014-01-26 19:00:07',NULL,NULL),(16639,3060,'1718974','834','00','005010X220A1','1718974','','2014-01-26','18:46:53',0,'2014-01-27 21:00:04',NULL,NULL),(18069,3321,'2735992','834','00','005010X220A1','2735992','','2014-02-06','12:48:44',0,'2014-02-06 21:00:55',NULL,NULL),(18402,3413,'1962293','834','00','005010X220A1','1962293','','2014-02-09','13:33:36',0,'2014-02-09 19:00:37',NULL,NULL),(18799,3487,'2439345','834','00','005010X220A1','2439345','','2014-02-11','15:46:09',0,'2014-02-11 21:01:14',NULL,NULL),(22152,4179,'2733829','834','00','005010X220A1','2733829','','2014-03-03','16:32:53',0,'2014-03-03 21:30:56',NULL,NULL),(1010,188,'235086','834','00','005010X220A1','235086','','2013-12-03','16:15:58',0,'2013-12-25 18:20:34',NULL,NULL),(5581,1043,'1592421','834','00','005010X220A1','1592421','','2013-12-24','23:04:14',0,'2013-12-26 01:49:02',NULL,NULL),(4363,765,'332982','834','00','005010X220A1','332982','','2013-12-19','14:19:54',0,'2013-12-25 23:11:10',NULL,NULL),(3477,615,'49499','834','00','005010X220A1','49499','','2013-12-12','08:10:09',0,'2013-12-25 22:00:27',NULL,NULL),(2743,503,'1364676','834','00','005010X220A1','1364676','','2013-12-22','16:20:33',0,'2013-12-25 21:18:31',NULL,NULL),(12097,1587,'2457432','834','00','005010X220A1','2457432','','2013-12-30','06:33:18',0,'2014-01-01 12:05:36',NULL,NULL),(7497,1300,'1228635','834','00','005010X220A1','1228635','','2013-12-20','21:01:00',0,'2013-12-26 04:33:56',NULL,NULL),(1067,211,'428675','834','00','005010X220A1','428675','','2013-11-29','13:05:10',0,'2013-12-25 18:30:50',NULL,NULL),(13887,2312,'1739091','834','00','005010X220A1','1739091','','2014-01-09','11:29:10',0,'2014-01-13 02:19:37',NULL,NULL),(14614,2523,'2468470','834','00','005010X220A1','2468470','','2014-01-13','00:11:37',0,'2014-01-14 01:33:16',NULL,NULL),(16883,3095,'2566447','834','00','005010X220A1','2566447','','2014-01-27','21:24:37',0,'2014-01-28 21:01:01',NULL,NULL),(17394,3198,'1669434','834','00','005010X220A1','1669434','','2014-02-01','11:07:14',0,'2014-02-01 19:00:05',NULL,NULL),(21054,3979,'2912757','834','00','005010X220A1','2912757','','2014-02-24','00:18:38',0,'2014-02-26 09:30:30',NULL,NULL),(22311,4201,'2716773','834','00','005010X220A1','2716773','','2014-03-04','14:02:58',0,'2014-03-04 21:01:06',NULL,NULL),(22916,4286,'2639322','834','00','005010X220A1','2639322','','2014-03-06','17:51:02',0,'2014-03-06 21:02:27',NULL,NULL),(543,103,'1110706','834','00','005010X220A1','1110706','','2013-12-15','19:20:17',0,'2013-12-25 18:01:47',NULL,NULL),(945,181,'1133317','834','00','005010X220A1','1133317','','2013-12-03','13:54:32',0,'2013-12-25 18:18:29',NULL,NULL),(10510,1400,'1184007','834','00','005010X220A1','1184007','','2013-12-23','19:22:40',0,'2013-12-26 12:54:10',NULL,NULL),(11179,1448,'1658655','834','00','005010X220A1','1658655','','2013-12-23','14:57:28',0,'2013-12-26 13:16:56',NULL,NULL),(894,177,'414028','834','00','005010X220A1','414028','','2013-12-03','13:27:00',0,'2013-12-25 18:16:57',NULL,NULL),(12080,1586,'2133915','834','00','005010X220A1','2133915','','2013-12-30','14:07:06',0,'2014-01-01 12:05:00',NULL,NULL),(12205,1614,'2274461','834','00','005010X220A1','2274461','','2013-12-30','16:02:16',0,'2014-01-01 12:09:29',NULL,NULL),(7370,1288,'1168321','834','00','005010X220A1','1168321','','2013-11-30','12:26:07',0,'2013-12-26 04:16:14',NULL,NULL),(7182,1239,'579161','834','00','005010X220A1','579161','','2013-12-17','19:02:08',0,'2013-12-26 04:06:04',NULL,NULL),(5904,1111,'1209188','834','00','005010X220A1','1209188','','2013-12-14','18:51:29',0,'2013-12-26 02:30:55',NULL,NULL),(6005,1136,'306163','834','00','005010X220A1','306163','','2013-11-16','20:32:57',0,'2013-12-26 02:45:06',NULL,NULL),(13317,2161,'0001','999','BE','005010X231A1','1267879','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:59',NULL,NULL),(14812,2552,'2235715','834','00','005010X220A1','2235715','','2014-01-14','03:47:18',0,'2014-01-15 02:06:50',NULL,NULL),(16526,3017,'1944064','834','00','005010X220A1','1944064','','2014-01-24','09:52:00',0,'2014-01-24 21:00:58',NULL,NULL),(16863,3093,'2067328','834','00','005010X220A1','2067328','','2014-01-28','12:41:20',0,'2014-01-28 21:00:49',NULL,NULL),(16978,3117,'1431974','834','00','005010X220A1','1431974','','2014-01-28','23:15:17',0,'2014-01-29 21:00:41',NULL,NULL),(16981,3117,'2002048','834','00','005010X220A1','2002048','','2014-01-29','12:25:42',0,'2014-01-29 21:00:43',NULL,NULL),(18100,3327,'1743584','834','00','005010X220A1','1743584','','2014-02-05','20:06:47',0,'2014-02-06 21:01:16',NULL,NULL),(22079,4174,'2662064','834','00','005010X220A1','2662064','','2014-03-03','09:36:05',0,'2014-03-03 21:30:01',NULL,NULL),(23497,4434,'3284486','834','00','005010X220A1','3284486','','2014-03-09','20:13:10',0,'2014-03-10 21:00:01',NULL,NULL),(2392,414,'546389','834','00','005010X220A1','546389','','2013-12-06','15:47:34',0,'2013-12-25 20:16:57',NULL,NULL),(13400,2221,'2300433','834','00','005010X220A1','2300433','','2014-01-06','17:46:34',0,'2014-01-07 04:00:54',NULL,NULL),(3282,583,'698810','834','00','005010X220A1','698810','','2013-12-17','15:19:44',0,'2013-12-25 21:47:53',NULL,NULL),(11834,1542,'1109764','834','00','005010X220A1','1109764','','2013-12-28','20:06:42',1,'2013-12-29 11:14:11',NULL,NULL),(11645,1499,'354773','834','00','005010X220A1','354773','','2013-12-27','10:06:18',0,'2013-12-28 03:36:06',NULL,NULL),(10378,1400,'440349','834','00','005010X220A1','440349','','2013-12-22','21:02:25',0,'2013-12-26 12:50:01',NULL,NULL),(4842,883,'1234864','834','00','005010X220A1','1234864','','2013-11-21','14:22:48',0,'2013-12-26 00:15:21',NULL,NULL),(5947,1113,'291669','834','00','005010X220A1','291669','','2013-12-15','13:09:08',0,'2013-12-26 02:32:14',NULL,NULL),(13980,2323,'2013402','834','00','005010X220A1','2013402','','2014-01-09','15:38:11',0,'2014-01-13 02:20:42',NULL,NULL),(14836,2553,'1594198','834','00','005010X220A1','1594198','','2014-01-13','21:36:13',0,'2014-01-15 02:07:00',NULL,NULL),(14855,2553,'2025184','834','00','005010X220A1','2025184','','2014-01-14','16:38:36',0,'2014-01-15 02:07:08',NULL,NULL),(15078,2585,'1390102','834','00','005010X220A1','1390102','','2014-01-15','09:47:02',0,'2014-01-16 08:45:06',NULL,NULL),(15392,2625,'2472623','834','00','005010X220A1','2472623','','2014-01-15','22:12:09',0,'2014-01-17 03:35:43',NULL,NULL),(15577,2658,'2178090','834','00','005010X220A1','2178090','','2014-01-16','19:45:18',0,'2014-01-20 08:06:09',NULL,NULL),(16031,2769,'1654217','834','00','005010X220A1','1654217','','2014-01-22','12:17:04',0,'2014-01-23 03:02:27',NULL,NULL),(19282,3582,'2942645','834','00','005010X220A1','2942645','','2014-02-13','13:42:28',0,'2014-02-13 22:01:00',NULL,NULL),(22987,4319,'3072851','834','00','005010X220A1','3072851','','2014-03-06','16:05:51',0,'2014-03-06 21:30:23',NULL,NULL),(19333,3583,'2871697','834','00','005010X220A1','2871697','','2014-02-13','13:50:04',0,'2014-02-13 22:01:38',NULL,NULL),(20886,3921,'3682804','834','00','005010X220A1','3682804','','2014-02-25','16:30:58',0,'2014-02-25 21:31:58',NULL,NULL),(21924,4128,'3682967','834','00','005010X220A1','3682967','','2014-03-01','08:49:48',0,'2014-03-01 21:00:45',NULL,NULL),(594,107,'1118463','834','00','005010X220A1','1118463','','2013-12-15','23:48:05',0,'2013-12-25 18:03:24',NULL,NULL),(6320,1175,'897588','834','00','005010X220A1','897588','','2013-12-20','14:22:30',0,'2013-12-26 03:07:59',NULL,NULL),(5137,943,'202408','834','00','005010X220A1','202408','','2013-12-11','10:27:17',0,'2013-12-26 00:50:26',NULL,NULL),(7658,1315,'278186','834','00','005010X220A1','278186','','2013-12-21','07:18:52',0,'2013-12-26 04:39:05',NULL,NULL),(11008,1414,'164109','834','00','005010X220A1','164109','','2013-12-22','23:26:46',0,'2013-12-26 13:11:04',NULL,NULL),(11146,1433,'844974','834','00','005010X220A1','844974','','2013-12-23','18:20:02',0,'2013-12-26 13:15:46',NULL,NULL),(4786,863,'810558','834','00','005010X220A1','810558','','2013-12-01','11:54:38',0,'2013-12-26 00:01:26',NULL,NULL),(4773,861,'764604','834','00','005010X220A1','764604','','2013-11-30','21:31:08',0,'2013-12-26 00:01:05',NULL,NULL),(4272,742,'381279','834','00','005010X220A1','381279','','2013-12-19','16:15:49',0,'2013-12-25 23:08:28',NULL,NULL),(1331,245,'1814443','834','00','005010X220A1','1814443','','2013-12-24','11:58:17',0,'2013-12-25 18:51:48',NULL,NULL),(13173,2017,'0001','999','BE','005010X231A1','113072','834','2013-12-28','04:55:00',0,'2014-01-05 16:58:37',NULL,NULL),(16297,2980,'2507411','834','00','005010X220A1','2507411','','2014-01-23','13:13:34',0,'2014-01-23 21:00:10',NULL,NULL),(20112,3772,'3526979','834','00','005010X220A1','3526979','','2014-02-18','20:10:32',0,'2014-02-20 03:47:30',NULL,NULL),(21643,4071,'3143780','834','00','005010X220A1','3143780','','2014-02-27','14:33:35',0,'2014-02-28 07:30:34',NULL,NULL),(23483,4425,'2795683','834','00','005010X220A1','2795683','','2014-03-09','16:24:10',0,'2014-03-09 21:01:20',NULL,NULL),(23592,4437,'2898529','834','00','005010X220A1','2898529','','2014-03-10','13:46:59',0,'2014-03-10 21:01:11',NULL,NULL),(731,125,'1020194','834','00','005010X220A1','1020194','','2013-12-16','10:16:25',0,'2013-12-25 18:07:46',NULL,NULL),(13778,2289,'1791106','834','00','005010X220A1','1791106','','2014-01-07','11:52:53',0,'2014-01-08 18:25:05',NULL,NULL),(5460,1040,'1543058','834','00','005010X220A1','1543058','','2013-12-24','19:05:24',0,'2013-12-26 01:45:08',NULL,NULL),(5086,938,'441187','834','00','005010X220A1','441187','','2013-12-11','08:42:39',0,'2013-12-26 00:48:44',NULL,NULL),(6216,1168,'573006','834','00','005010X220A1','573006','','2013-12-20','09:27:25',0,'2013-12-26 03:04:47',NULL,NULL),(4867,886,'374776','834','00','005010X220A1','374776','','2013-11-21','17:43:18',0,'2013-12-26 00:16:09',NULL,NULL),(4228,738,'375416','834','00','005010X220A1','375416','','2013-12-19','13:22:50',0,'2013-12-25 23:07:07',NULL,NULL),(7594,1302,'1075852','834','00','005010X220A1','1075852','','2013-12-21','15:23:53',0,'2013-12-26 04:37:06',NULL,NULL),(4212,738,'603836','834','00','005010X220A1','603836','','2013-12-18','19:38:45',0,'2013-12-25 23:06:35',NULL,NULL),(12040,1583,'1690849','834','00','005010X220A1','1690849','','2013-12-30','15:25:42',0,'2014-01-01 12:03:35',NULL,NULL),(2450,422,'498743','834','00','005010X220A1','498743','','2013-12-06','11:11:57',0,'2013-12-25 20:18:51',NULL,NULL),(13036,1880,'0001','999','BE','005010X231A1','437088','834','2013-12-28','04:55:00',0,'2014-01-05 16:50:42',NULL,NULL),(13822,2298,'1615563','834','00','005010X220A1','1615563','','2014-01-11','16:12:19',0,'2014-01-13 02:18:30',NULL,NULL),(14140,2354,'1538193','834','00','005010X220A1','1538193','','2014-01-08','11:01:34',0,'2014-01-13 02:22:36',NULL,NULL),(16591,3041,'1748242','834','00','005010X220A1','1748242','','2014-01-25','17:33:48',0,'2014-01-25 19:00:17',NULL,NULL),(20107,3772,'3261383','834','00','005010X220A1','3261383','','2014-02-18','18:21:14',0,'2014-02-20 03:44:48',NULL,NULL),(20667,3878,'3400505','834','00','005010X220A1','3400505','','2014-02-21','13:26:34',0,'2014-02-21 22:01:04',NULL,NULL),(21414,4026,'3817828','834','00','005010X220A1','3817828','','2014-02-26','22:20:49',0,'2014-02-28 06:30:41',NULL,NULL),(21475,4028,'3317208','834','00','005010X220A1','3317208','','2014-02-27','15:20:30',0,'2014-02-28 06:31:10',NULL,NULL),(21557,4051,'3477746','834','00','005010X220A1','3477746','','2014-02-27','16:42:04',0,'2014-02-28 06:31:48',NULL,NULL),(9,1,'655432','834','00','005010X220A1','655432','','2013-12-05','07:22:33',0,'2013-12-25 17:15:18',NULL,NULL),(4858,885,'60278','834','00','005010X220A1','60278','','2013-11-21','15:27:58',0,'2013-12-26 00:15:51',NULL,NULL),(5925,1112,'566074','834','00','005010X220A1','566074','','2013-12-15','14:45:07',0,'2013-12-26 02:31:33',NULL,NULL),(4353,760,'255898','834','00','005010X220A1','255898','','2013-12-19','11:54:18',0,'2013-12-25 23:10:52',NULL,NULL),(4172,734,'119969','834','00','005010X220A1','119969','','2013-12-19','11:04:52',0,'2013-12-25 23:05:19',NULL,NULL),(10947,1410,'1154344','834','00','005010X220A1','1154344','','2013-12-23','16:19:50',0,'2013-12-26 13:09:07',NULL,NULL),(11034,1418,'1386440','834','00','005010X220A1','1386440','','2013-12-23','00:08:20',0,'2013-12-26 13:11:56',NULL,NULL),(971,184,'27105','834','00','005010X220A1','27105','','2013-12-02','20:13:29',0,'2013-12-25 18:19:19',NULL,NULL),(12756,1693,'1887525','834','00','005010X220A1','1887525','','2014-01-01','20:14:53',0,'2014-01-03 02:06:57',NULL,NULL),(17011,3119,'2287929','834','00','005010X220A1','2287929','','2014-01-28','20:02:49',0,'2014-01-29 21:01:00',NULL,NULL),(17220,3154,'1368189','834','00','005010X220A1','1368189','','2014-01-30','01:56:10',0,'2014-01-30 21:01:22',NULL,NULL),(18355,3401,'1691733','834','00','005010X220A1','1691733','','2014-02-08','18:54:58',0,'2014-02-09 19:00:05',NULL,NULL),(19251,3580,'2822101','834','00','005010X220A1','2822101','','2014-02-12','18:47:54',0,'2014-02-13 22:00:35',NULL,NULL),(21408,4026,'3277779','834','00','005010X220A1','3277779','','2014-02-26','18:45:19',0,'2014-02-28 06:30:38',NULL,NULL),(4274,742,'782890','834','00','005010X220A1','782890','','2013-12-19','16:26:41',0,'2013-12-25 23:08:32',NULL,NULL),(11966,1580,'1751461','834','00','005010X220A1','1751461','','2013-12-30','12:33:57',0,'2014-01-01 12:00:48',NULL,NULL),(6125,1166,'27767','834','00','005010X220A1','27767','','2013-12-20','15:19:35',0,'2013-12-26 03:02:04',NULL,NULL),(5883,1109,'632726','834','00','005010X220A1','632726','','2013-12-14','19:38:53',0,'2013-12-26 02:30:12',NULL,NULL),(11672,1506,'1764093','834','00','005010X220A1','1764093','','2013-12-27','10:50:51',0,'2013-12-28 03:36:59',NULL,NULL),(11638,1497,'1000192','834','00','005010X220A1','1000192','','2013-12-27','18:01:50',0,'2013-12-28 03:35:54',NULL,NULL),(7487,1298,'1082429','834','00','005010X220A1','1082429','','2013-12-21','12:15:55',0,'2013-12-26 04:33:35',NULL,NULL),(10983,1413,'948359','834','00','005010X220A1','948359','','2013-12-23','09:44:00',0,'2013-12-26 13:10:12',NULL,NULL),(13767,2281,'2556763','834','00','005010X220A1','2556763','','2014-01-07','12:03:58',0,'2014-01-08 18:24:59',NULL,NULL),(14301,2385,'1412458','834','00','005010X220A1','1412458','','2014-01-10','12:11:34',0,'2014-01-13 03:00:29',NULL,NULL),(14603,2521,'1941283','834','00','005010X220A1','1941283','','2014-01-13','15:45:23',0,'2014-01-14 01:33:08',NULL,NULL),(14740,2550,'1823764','834','00','005010X220A1','1823764','','2014-01-14','15:42:22',0,'2014-01-15 02:06:19',NULL,NULL),(15313,2622,'2411701','834','00','005010X220A1','2411701','','2014-01-16','00:33:01',0,'2014-01-17 03:35:07',NULL,NULL),(15879,2739,'1946588','834','00','005010X220A1','1946588','','2014-01-21','15:07:05',1,'2014-01-22 03:22:27',NULL,NULL),(16062,2773,'2413173','834','00','005010X220A1','2413173','','2014-01-21','21:46:16',0,'2014-01-23 03:02:41',NULL,NULL),(17279,3170,'1745995','834','00','005010X220A1','1745995','','2014-01-31','16:58:44',0,'2014-01-31 21:00:27',NULL,NULL),(17453,3208,'2776280','834','00','005010X220A1','2776280','','2014-02-01','09:04:28',0,'2014-02-01 19:00:43',NULL,NULL),(18392,3409,'2903144','834','00','005010X220A1','2903144','','2014-02-09','17:04:18',0,'2014-02-09 19:00:30',NULL,NULL),(18598,3456,'2680792','834','00','005010X220A1','2680792','','2014-02-09','20:42:32',0,'2014-02-10 21:31:02',NULL,NULL),(19317,3583,'2461102','834','00','005010X220A1','2461102','','2014-02-13','10:23:29',0,'2014-02-13 22:01:27',NULL,NULL),(19821,3679,'3034120','834','00','005010X220A1','3034120','','2014-02-15','13:57:07',0,'2014-02-15 22:01:39',NULL,NULL),(19913,3725,'2879665','834','00','005010X220A1','2879665','','2014-02-17','13:08:07',0,'2014-02-17 19:00:08',NULL,NULL),(20694,3890,'3669470','834','00','005010X220A1','3669470','','2014-02-22','15:33:35',0,'2014-02-22 19:00:14',NULL,NULL),(1452,252,'2014162','834','00','005010X220A1','2014162','','2013-12-24','12:43:53',0,'2013-12-25 18:55:46',NULL,NULL),(7580,1301,'1198239','834','00','005010X220A1','1198239','','2013-12-21','16:06:06',0,'2013-12-26 04:36:35',NULL,NULL),(4806,865,'1087808','834','00','005010X220A1','1087808','','2013-12-01','12:30:45',0,'2013-12-26 00:02:03',NULL,NULL),(3405,590,'447514','834','00','005010X220A1','447514','','2013-12-17','10:55:09',0,'2013-12-25 21:51:49',NULL,NULL),(12189,1605,'1481562','834','00','005010X220A1','1481562','','2013-12-30','11:06:32',0,'2014-01-01 12:08:56',NULL,NULL),(12303,1629,'2349122','834','00','005010X220A1','2349122','','2014-01-01','16:59:19',1,'2014-01-02 04:25:23',NULL,NULL),(16687,3062,'2640707','834','00','005010X220A1','2640707','','2014-01-27','13:24:53',0,'2014-01-27 21:00:35',NULL,NULL),(16774,3075,'2151106','834','00','005010X220A1','2151106','','2014-01-27','15:53:28',0,'2014-01-27 21:01:36',NULL,NULL),(17149,3144,'2722088','834','00','005010X220A1','2722088','','2014-01-30','14:25:35',0,'2014-01-30 21:00:36',NULL,NULL),(18334,3387,'2403657','834','00','005010X220A1','2403657','','2014-02-08','10:32:32',0,'2014-02-08 19:00:55',NULL,NULL),(19932,3733,'3280141','834','00','005010X220A1','3280141','','2014-02-18','14:49:22',0,'2014-02-18 21:30:05',NULL,NULL),(19947,3740,'2569395','834','00','005010X220A1','2569395','','2014-02-18','14:26:58',0,'2014-02-18 21:30:16',NULL,NULL),(20386,3826,'3313756','834','00','005010X220A1','3313756','','2014-02-19','12:19:23',0,'2014-02-20 05:38:57',NULL,NULL),(20813,3910,'2982817','834','00','005010X220A1','2982817','','2014-02-25','13:05:12',0,'2014-02-25 21:31:04',NULL,NULL),(22180,4180,'3201957','834','00','005010X220A1','3201957','','2014-03-03','16:17:07',0,'2014-03-03 21:31:16',NULL,NULL),(22270,4200,'2692857','834','00','005010X220A1','2692857','','2014-03-04','13:36:59',0,'2014-03-04 21:00:36',NULL,NULL),(22630,4252,'3388486','834','00','005010X220A1','3388486','','2014-03-05','14:07:08',0,'2014-03-05 21:31:39',NULL,NULL),(23014,4324,'3157830','834','00','005010X220A1','3157830','','2014-03-06','21:17:08',0,'2014-03-07 21:00:18',NULL,NULL),(2,1,'946429','834','00','005010X220A1','946429','','2013-12-04','19:33:32',0,'2013-12-25 17:15:04',NULL,NULL),(4738,852,'1608560','834','00','005010X220A1','1608560','','2013-12-24','00:51:08',0,'2013-12-25 23:52:04',NULL,NULL),(20997,3960,'2761511','834','00','005010X220A1','2761511','','2014-02-21','19:33:34',0,'2014-02-26 08:30:36',NULL,NULL),(2749,503,'1520417','834','00','005010X220A1','1520417','','2013-12-22','18:13:59',0,'2013-12-25 21:18:43',NULL,NULL),(12362,1634,'2474870','834','00','005010X220A1','2474870','','2013-12-31','15:09:57',1,'2014-01-02 04:28:17',NULL,NULL),(20686,3886,'3501020','834','00','005010X220A1','3501020','','2014-02-21','17:45:00',0,'2014-02-21 22:01:18',NULL,NULL),(19757,3674,'3041685','834','00','005010X220A1','3041685','','2014-02-14','22:11:38',0,'2014-02-15 22:00:49',NULL,NULL),(14674,2548,'2303912','834','00','005010X220A1','2303912','','2014-01-13','21:15:25',0,'2014-01-15 02:05:50',NULL,NULL),(14784,2551,'2288974','834','00','005010X220A1','2288974','','2014-01-14','15:15:28',0,'2014-01-15 02:06:38',NULL,NULL),(1538,261,'1844379','834','00','005010X220A1','1844379','','2013-12-24','15:26:05',0,'2013-12-25 18:58:33',NULL,NULL),(13478,2226,'1924458','834','00','005010X220A1','1924458','','2014-01-06','13:48:53',0,'2014-01-07 04:03:49',NULL,NULL),(20505,3847,'3537232','834','00','005010X220A1','3537232','','2014-02-19','19:41:08',0,'2014-02-20 22:01:07',NULL,NULL),(19011,3539,'2585519','834','00','005010X220A1','2585519','','2014-02-12','11:37:19',0,'2014-02-12 21:30:33',NULL,NULL),(5886,1109,'422739','834','00','005010X220A1','422739','','2013-12-15','11:08:47',0,'2013-12-26 02:30:18',NULL,NULL),(10420,1400,'1252226','834','00','005010X220A1','1252226','','2013-12-23','10:24:00',0,'2013-12-26 12:51:20',NULL,NULL),(11588,1492,'1628189','834','00','005010X220A1','1628189','','2013-12-27','17:12:56',0,'2013-12-28 03:34:20',NULL,NULL),(22632,4252,'3720159','834','00','005010X220A1','3720159','','2014-03-05','15:05:59',0,'2014-03-05 21:31:41',NULL,NULL),(1146,239,'309616','834','00','005010X220A1','309616','','2013-12-24','09:17:48',0,'2013-12-25 18:46:05',NULL,NULL),(22155,4180,'3024555','834','00','005010X220A1','3024555','','2014-03-03','10:26:26',0,'2014-03-03 21:30:58',NULL,NULL),(19742,3673,'2637499','834','00','005010X220A1','2637499','','2014-02-15','11:27:23',0,'2014-02-15 22:00:37',NULL,NULL),(10640,1402,'1636622','834','00','005010X220A1','1636622','','2013-12-23','17:16:48',0,'2013-12-26 12:58:30',NULL,NULL),(11118,1427,'1439400','834','00','005010X220A1','1439400','','2013-12-22','22:14:04',0,'2013-12-26 13:14:43',NULL,NULL),(11467,1488,'2011952','834','00','005010X220A1','2011952','','2013-12-27','11:47:25',0,'2013-12-28 03:30:39',NULL,NULL),(7558,1301,'731853','834','00','005010X220A1','731853','','2013-12-21','10:54:42',0,'2013-12-26 04:35:53',NULL,NULL),(7325,1271,'682501','834','00','005010X220A1','682501','','2013-12-18','14:43:29',0,'2013-12-26 04:10:29',NULL,NULL),(1875,324,'578847','834','00','005010X220A1','578847','','2013-12-09','17:49:30',0,'2013-12-25 19:31:02',NULL,NULL),(4109,733,'15788','834','00','005010X220A1','15788','','2013-12-19','12:37:01',0,'2013-12-25 23:03:28',NULL,NULL),(11904,1563,'1404543','834','00','005010X220A1','1404543','','2013-12-28','22:26:26',0,'2013-12-30 00:01:09',NULL,NULL),(23167,4344,'3806603','834','00','005010X220A1','3806603','','2014-03-07','14:00:37',0,'2014-03-07 21:31:22',NULL,NULL),(23509,4434,'3459467','834','00','005010X220A1','3459467','','2014-03-10','12:35:48',0,'2014-03-10 21:00:09',NULL,NULL),(15452,2632,'2577447','834','00','005010X220A1','2577447','','2014-01-15','21:19:20',0,'2014-01-17 03:36:10',NULL,NULL),(11837,1543,'210706','834','00','005010X220A1','210706','','2013-12-28','20:21:52',1,'2013-12-29 11:14:16',NULL,NULL),(22441,4230,'3239984','834','00','005010X220A1','3239984','','2014-03-04','15:10:50',0,'2014-03-04 21:30:10',NULL,NULL),(22847,4279,'3321037','834','00','005010X220A1','3321037','','2014-03-06','11:36:23',0,'2014-03-06 21:01:37',NULL,NULL),(20709,3893,'3754853','834','00','005010X220A1','3754853','','2014-02-25','15:32:07',0,'2014-02-25 21:00:17',NULL,NULL),(15036,2584,'2047209','834','00','005010X220A1','2047209','','2014-01-15','17:14:24',0,'2014-01-16 08:44:40',NULL,NULL),(14310,2391,'2383842','834','00','005010X220A1','2383842','','2014-01-10','16:51:52',0,'2014-01-13 03:00:37',NULL,NULL),(6329,1175,'194007','834','00','005010X220A1','194007','','2013-12-20','15:45:36',0,'2013-12-26 03:08:17',NULL,NULL),(13864,2311,'2560695','834','00','005010X220A1','2560695','','2014-01-09','11:05:13',0,'2014-01-13 02:19:22',NULL,NULL),(3366,587,'4273','834','00','005010X220A1','4273','','2013-12-17','12:50:13',0,'2013-12-25 21:50:36',NULL,NULL),(1477,252,'1832582','834','00','005010X220A1','1832582','','2013-12-24','17:47:42',0,'2013-12-25 18:56:41',NULL,NULL),(21807,4093,'2829361','834','00','005010X220A1','2829361','','2014-02-27','18:50:19',0,'2014-02-28 21:31:26',NULL,NULL),(7418,1295,'990505','834','00','005010X220A1','990505','','2013-12-21','07:12:08',0,'2013-12-26 04:31:27',NULL,NULL),(18343,3395,'2742354','834','00','005010X220A1','2742354','','2014-02-07','18:33:40',0,'2014-02-08 19:30:03',NULL,NULL),(3515,615,'115839','834','00','005010X220A1','115839','','2013-12-12','16:49:02',0,'2013-12-25 22:01:40',NULL,NULL),(17340,3179,'1875945','834','00','005010X220A1','1875945','','2014-01-31','11:39:20',0,'2014-01-31 21:01:10',NULL,NULL),(2265,384,'1024702','834','00','005010X220A1','1024702','','2013-12-02','10:06:15',0,'2013-12-25 19:50:27',NULL,NULL),(1456,252,'1554905','834','00','005010X220A1','1554905','','2013-12-24','13:40:31',0,'2013-12-25 18:55:56',NULL,NULL),(10752,1403,'1076006','834','00','005010X220A1','1076006','','2013-12-23','17:43:49',0,'2013-12-26 13:02:16',NULL,NULL),(11376,1460,'842251','834','00','005010X220A1','842251','','2013-12-26','14:35:50',0,'2013-12-27 02:05:49',NULL,NULL),(12543,1652,'2199846','834','00','005010X220A1','2199846','','2013-12-31','10:52:27',1,'2014-01-02 04:34:57',NULL,NULL),(11653,1500,'2133835','834','00','005010X220A1','2133835','','2013-12-27','11:04:06',0,'2013-12-28 03:36:22',NULL,NULL),(563,103,'1314461','834','00','005010X220A1','1314461','','2013-12-16','12:12:17',0,'2013-12-25 18:02:27',NULL,NULL),(5012,935,'380939','834','00','005010X220A1','380939','','2013-12-11','11:08:12',0,'2013-12-26 00:46:22',NULL,NULL),(6435,1204,'344260','834','00','005010X220A1','344260','','2013-11-21','20:37:14',0,'2013-12-26 03:15:34',NULL,NULL),(22163,4180,'3608240','834','00','005010X220A1','3608240','','2014-03-03','11:32:37',0,'2014-03-03 21:31:04',NULL,NULL),(20034,3750,'3376051','834','00','005010X220A1','3376051','','2014-02-18','15:32:13',0,'2014-02-18 22:00:55',NULL,NULL),(14585,2521,'1601577','834','00','005010X220A1','1601577','','2014-01-12','21:36:48',0,'2014-01-14 01:32:57',NULL,NULL),(13010,1742,'2194977','834','00','005010X220A1','2194977','','2014-01-04','11:35:50',0,'2014-01-05 00:02:30',NULL,NULL),(23733,4465,'3800648','834','00','005010X220A1','3800648','','2014-03-10','14:04:12',0,'2014-03-10 21:02:54',NULL,NULL),(20851,3911,'3015679','834','00','005010X220A1','3015679','','2014-02-25','15:41:12',0,'2014-02-25 21:31:31',NULL,NULL),(18947,3528,'3258528','834','00','005010X220A1','3258528','','2014-02-11','16:27:00',0,'2014-02-11 21:30:26',NULL,NULL),(14932,2560,'1924671','834','00','005010X220A1','1924671','','2014-01-14','18:12:43',0,'2014-01-15 02:07:44',NULL,NULL),(12098,1587,'1945940','834','00','005010X220A1','1945940','','2013-12-30','06:33:18',0,'2014-01-01 12:05:38',NULL,NULL),(2980,542,'395879','834','00','005010X220A1','395879','','2013-12-13','17:50:16',0,'2013-12-25 21:32:32',NULL,NULL),(4462,801,'967901','834','00','005010X220A1','967901','','2013-11-26','17:13:52',0,'2013-12-25 23:30:48',NULL,NULL),(4556,825,'28058','834','00','005010X220A1','28058','','2013-12-23','23:41:37',0,'2013-12-25 23:45:54',NULL,NULL),(6226,1168,'1361160','834','00','005010X220A1','1361160','','2013-12-20','15:42:30',0,'2013-12-26 03:05:07',NULL,NULL),(5426,1029,'488921','834','00','005010X220A1','488921','','2013-11-14','13:45:02',0,'2013-12-26 01:31:11',NULL,NULL),(22861,4280,'3663815','834','00','005010X220A1','3663815','','2014-03-06','12:14:24',0,'2014-03-06 21:01:47',NULL,NULL),(1357,245,'1117553','834','00','005010X220A1','1117553','','2013-12-24','14:01:41',0,'2013-12-25 18:52:39',NULL,NULL),(13263,2107,'0001','999','BE','005010X231A1','911391','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:48',NULL,NULL),(13113,1957,'0001','999','BE','005010X231A1','1124188','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:14',NULL,NULL),(22620,4251,'2611454','834','00','005010X220A1','2611454','','2014-03-05','14:08:37',0,'2014-03-05 21:31:33',NULL,NULL),(2516,449,'330705','834','00','005010X220A1','330705','','2013-10-13','08:33:58',0,'2013-12-25 20:30:30',NULL,NULL),(20819,3910,'2552412','834','00','005010X220A1','2552412','','2014-02-25','14:54:43',0,'2014-02-25 21:31:07',NULL,NULL),(17118,3142,'2349858','834','00','005010X220A1','2349858','','2014-01-30','16:36:20',0,'2014-01-30 21:00:17',NULL,NULL),(16207,2899,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:58:00',1,'2014-01-23 04:57:15',NULL,NULL),(15066,2585,'2379990','834','00','005010X220A1','2379990','','2014-01-15','10:54:44',0,'2014-01-16 08:44:59',NULL,NULL),(15782,2717,'2334205','834','00','005010X220A1','2334205','','2014-01-20','16:29:52',0,'2014-01-21 08:46:37',NULL,NULL),(16192,2884,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:17:00',1,'2014-01-23 04:33:56',NULL,NULL),(72,3,'68586','834','00','005010X220A1','68586','','2013-12-05','17:45:54',0,'2013-12-25 17:17:11',NULL,NULL),(12778,1703,'1517364','834','00','005010X220A1','1517364','','2014-01-02','18:30:00',0,'2014-01-04 02:00:26',NULL,NULL),(22546,4248,'3805268','834','00','005010X220A1','3805268','','2014-03-05','05:05:09',0,'2014-03-05 21:30:41',NULL,NULL),(21119,3994,'3284070','834','00','005010X220A1','3284070','','2014-02-26','14:15:53',0,'2014-02-26 21:00:22',NULL,NULL),(14875,2555,'2421721','834','00','005010X220A1','2421721','','2014-01-14','16:41:19',0,'2014-01-15 02:07:17',NULL,NULL),(11559,1492,'840821','834','00','005010X220A1','840821','','2013-12-27','10:21:48',0,'2013-12-28 03:33:28',NULL,NULL),(3058,544,'502745','834','00','005010X220A1','502745','','2013-12-13','14:48:02',0,'2013-12-25 21:34:53',NULL,NULL),(2225,370,'173116','834','00','005010X220A1','173116','','2013-12-01','22:45:29',0,'2013-12-25 19:49:00',NULL,NULL),(1537,261,'1970156','834','00','005010X220A1','1970156','','2013-12-24','15:04:12',0,'2013-12-25 18:58:31',NULL,NULL),(22884,4282,'2946750','834','00','005010X220A1','2946750','','2014-03-06','11:08:55',0,'2014-03-06 21:02:05',NULL,NULL),(20046,3751,'3216951','834','00','005010X220A1','3216951','','2014-02-18','12:51:56',0,'2014-02-18 22:01:05',NULL,NULL),(18725,3485,'3103938','834','00','005010X220A1','3103938','','2014-02-11','09:52:16',0,'2014-02-11 21:00:19',NULL,NULL),(17331,3177,'2650123','834','00','005010X220A1','2650123','','2014-01-30','20:44:18',0,'2014-01-31 21:01:03',NULL,NULL),(15771,2716,'1932716','834','00','005010X220A1','1932716','','2014-01-19','21:16:37',0,'2014-01-21 08:46:30',NULL,NULL),(11234,1454,'2222620','834','00','005010X220A1','2222620','','2013-12-26','11:45:33',0,'2013-12-27 02:01:29',NULL,NULL),(15769,2715,'2305481','834','00','005010X220A1','2305481','','2014-01-19','21:13:39',0,'2014-01-21 08:46:28',NULL,NULL),(964,181,'1054279','834','00','005010X220A1','1054279','','2013-12-03','17:54:06',0,'2013-12-25 18:19:05',NULL,NULL),(7736,1342,'1218651','834','00','005010X220A1','1218651','','2013-10-21','11:45:42',0,'2013-12-26 05:00:23',NULL,NULL),(13045,1889,'0001','999','BE','005010X231A1','483505','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:06',NULL,NULL),(6335,1176,'224649','834','00','005010X220A1','224649','','2013-12-19','23:42:31',0,'2013-12-26 03:08:28',NULL,NULL),(12785,1703,'2284446','834','00','005010X220A1','2284446','','2014-01-02','22:53:48',0,'2014-01-04 02:00:43',NULL,NULL),(21528,4037,'3162782','834','00','005010X220A1','3162782','','2014-02-27','16:34:57',0,'2014-02-28 06:31:35',NULL,NULL),(20646,3875,'3511260','834','00','005010X220A1','3511260','','2014-02-20','18:43:47',0,'2014-02-21 22:00:49',NULL,NULL),(344,72,'1222459','834','00','005010X220A1','1222459','','2013-12-03','23:43:06',0,'2013-12-25 17:46:35',NULL,NULL),(20300,3794,'2365222','834','00','005010X220A1','2365222','','2014-02-19','12:40:43',0,'2014-02-20 04:43:14',NULL,NULL),(19773,3675,'3319105','834','00','005010X220A1','3319105','','2014-02-15','10:51:21',0,'2014-02-15 22:01:00',NULL,NULL),(18596,3456,'2845095','834','00','005010X220A1','2845095','','2014-02-09','18:59:31',0,'2014-02-10 21:31:00',NULL,NULL),(10608,1402,'607813','834','00','005010X220A1','607813','','2013-12-23','13:30:12',0,'2013-12-26 12:57:27',NULL,NULL),(12997,1739,'1639444','834','00','005010X220A1','1639444','','2014-01-04','08:35:21',0,'2014-01-05 00:02:00',NULL,NULL),(13771,2284,'1544744','834','00','005010X220A1','1544744','','2014-01-07','12:48:48',0,'2014-01-08 18:25:01',NULL,NULL),(18338,3391,'1545519','834','00','005010X220A1','1545519','','2014-02-08','13:59:39',0,'2014-02-08 19:00:59',NULL,NULL),(18330,3386,'2925981','834','00','005010X220A1','2925981','','2014-02-08','12:14:56',0,'2014-02-08 19:00:53',NULL,NULL),(21776,4091,'2759064','834','00','005010X220A1','2759064','','2014-02-27','23:21:10',0,'2014-02-28 21:31:04',NULL,NULL),(12180,1598,'428375','834','00','005010X220A1','428375','','2013-12-30','09:16:47',0,'2014-01-01 12:08:29',NULL,NULL),(21133,3995,'3719891','834','00','005010X220A1','3719891','','2014-02-26','15:06:13',0,'2014-02-26 21:00:33',NULL,NULL),(20820,3910,'3115558','834','00','005010X220A1','3115558','','2014-02-25','15:02:41',0,'2014-02-25 21:31:08',NULL,NULL),(1550,267,'205636','834','00','005010X220A1','205636','','2013-12-24','12:28:32',0,'2013-12-25 18:58:57',NULL,NULL),(20305,3796,'3657036','834','00','005010X220A1','3657036','','2014-02-19','11:59:08',0,'2014-02-20 04:44:46',NULL,NULL),(12614,1671,'1971651','834','00','005010X220A1','1971651','','2014-01-02','13:07:12',0,'2014-01-03 02:01:35',NULL,NULL),(15784,2718,'1674246','834','00','005010X220A1','1674246','','2014-01-20','14:40:24',0,'2014-01-21 08:46:38',NULL,NULL),(15432,2629,'1991078','834','00','005010X220A1','1991078','','2014-01-16','16:39:12',0,'2014-01-17 03:36:02',NULL,NULL),(20918,3932,'2859146','834','00','005010X220A1','2859146','','2014-02-23','14:20:38',0,'2014-02-26 08:00:15',NULL,NULL),(5890,1110,'224413','834','00','005010X220A1','224413','','2013-12-14','19:44:51',0,'2013-12-26 02:30:27',NULL,NULL),(6989,1234,'736269','834','00','005010X220A1','736269','','2013-12-18','10:23:29',0,'2013-12-26 04:00:07',NULL,NULL),(3937,714,'403061','834','00','005010X220A1','403061','','2013-12-07','10:30:21',0,'2013-12-25 22:46:08',NULL,NULL),(23261,4377,'3264265','834','00','005010X220A1','3264265','','2014-03-07','18:29:07',0,'2014-03-08 21:00:02',NULL,NULL),(23315,4381,'3632390','834','00','005010X220A1','3632390','','2014-03-08','15:22:02',0,'2014-03-08 21:30:31',NULL,NULL),(1702,292,'654100','834','00','005010X220A1','654100','','2013-12-09','23:33:04',0,'2013-12-25 19:16:32',NULL,NULL),(3942,715,'1043993','834','00','005010X220A1','1043993','','2013-12-06','18:42:06',0,'2013-12-25 22:46:17',NULL,NULL),(7725,1341,'1010836','834','00','005010X220A1','1010836','','2013-10-19','20:57:42',0,'2013-12-26 05:00:02',NULL,NULL),(10524,1401,'226051','834','00','005010X220A1','226051','','2013-12-23','09:18:26',0,'2013-12-26 12:54:37',NULL,NULL),(22806,4278,'3734625','834','00','005010X220A1','3734625','','2014-03-05','20:03:44',0,'2014-03-06 21:01:08',NULL,NULL),(11825,1540,'798699','834','00','005010X220A1','798699','','2013-12-28','20:27:47',1,'2013-12-29 11:13:53',NULL,NULL),(11860,1555,'35939','834','00','005010X220A1','35939','','2013-12-28','20:23:34',1,'2013-12-29 11:15:09',NULL,NULL),(22393,4212,'3252177','834','00','005010X220A1','3252177','','2014-03-03','23:04:16',0,'2014-03-04 21:02:14',NULL,NULL),(19740,3673,'2795002','834','00','005010X220A1','2795002','','2014-02-15','11:09:54',0,'2014-02-15 22:00:36',NULL,NULL),(12290,1624,'1825746','834','00','005010X220A1','1825746','','2014-01-01','14:30:12',1,'2014-01-02 04:24:54',NULL,NULL),(14103,2343,'1430207','834','00','005010X220A1','1430207','','2014-01-08','11:10:53',0,'2014-01-13 02:22:12',NULL,NULL),(19502,3621,'3386615','834','00','005010X220A1','3386615','','2014-02-14','00:01:24',0,'2014-02-14 21:30:27',NULL,NULL),(15648,2682,'2025315','834','00','005010X220A1','2025315','','2014-01-17','22:06:53',0,'2014-01-21 08:44:22',NULL,NULL),(16360,2985,'1638519','834','00','005010X220A1','1638519','','2014-01-22','19:34:48',0,'2014-01-23 21:00:55',NULL,NULL),(16386,2989,'1742025','834','00','005010X220A1','1742025','','2014-01-22','22:06:22',0,'2014-01-23 21:01:14',NULL,NULL),(16946,3115,'1919717','834','00','005010X220A1','1919717','','2014-01-29','15:31:54',0,'2014-01-29 21:00:20',NULL,NULL),(171,15,'1188420','834','00','005010X220A1','1188420','','2013-12-05','14:18:36',0,'2013-12-25 17:20:19',NULL,NULL),(13262,2106,'0001','999','BE','005010X231A1','810567','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:45',NULL,NULL),(22544,4248,'3431569','834','00','005010X220A1','3431569','','2014-03-04','23:34:38',0,'2014-03-05 21:30:39',NULL,NULL),(3896,707,'642058','834','00','005010X220A1','642058','','2013-10-26','15:53:31',0,'2013-12-25 22:32:06',NULL,NULL),(22415,4216,'3842314','834','00','005010X220A1','3842314','','2014-03-04','10:28:15',0,'2014-03-04 21:02:33',NULL,NULL),(21343,4022,'3616192','834','00','005010X220A1','3616192','','2014-02-27','11:51:46',0,'2014-02-28 06:30:08',NULL,NULL),(18636,3462,'1979004','834','00','005010X220A1','1979004','','2014-02-10','09:53:27',0,'2014-02-10 21:31:29',NULL,NULL),(18620,3458,'2202033','834','00','005010X220A1','2202033','','2014-02-09','19:07:14',0,'2014-02-10 21:31:17',NULL,NULL),(764,143,'466383','834','00','005010X220A1','466383','','2013-12-16','17:45:44',0,'2013-12-25 18:08:48',NULL,NULL),(738,129,'1007954','834','00','005010X220A1','1007954','','2013-12-16','15:34:44',0,'2013-12-25 18:07:58',NULL,NULL),(15591,2659,'1658272','834','00','005010X220A1','1658272','','2014-01-17','12:56:56',0,'2014-01-20 08:06:20',NULL,NULL),(573,103,'694680','834','00','005010X220A1','694680','','2013-12-16','15:26:56',0,'2013-12-25 18:02:45',NULL,NULL),(1968,326,'1001887','834','00','005010X220A1','1001887','','2013-12-09','15:09:47',0,'2013-12-25 19:33:43',NULL,NULL),(22610,4250,'2981999','834','00','005010X220A1','2981999','','2014-03-05','15:52:52',0,'2014-03-05 21:31:25',NULL,NULL),(11178,1447,'506827','834','00','005010X220A1','506827','','2013-12-23','15:41:35',0,'2013-12-26 13:16:54',NULL,NULL),(22170,4180,'3445479','834','00','005010X220A1','3445479','','2014-03-03','13:33:16',0,'2014-03-03 21:31:10',NULL,NULL),(5860,1101,'161563','834','00','005010X220A1','161563','','2013-10-26','21:19:38',0,'2013-12-26 02:16:32',NULL,NULL),(20262,3795,'3187054','834','00','005010X220A1','3187054','','2014-02-18','22:31:44',0,'2014-02-20 04:34:11',NULL,NULL),(14926,2559,'2147103','834','00','005010X220A1','2147103','','2014-01-14','18:04:14',0,'2014-01-15 02:07:41',NULL,NULL),(18339,3392,'2213457','834','00','005010X220A1','2213457','','2014-02-08','14:19:06',0,'2014-02-08 19:01:00',NULL,NULL),(18222,3357,'2062629','834','00','005010X220A1','2062629','','2014-02-07','09:59:26',0,'2014-02-07 19:00:51',NULL,NULL),(16951,3115,'1832223','834','00','005010X220A1','1832223','','2014-01-29','16:40:23',0,'2014-01-29 21:00:24',NULL,NULL),(1489,254,'1972890','834','00','005010X220A1','1972890','','2013-12-24','14:40:46',0,'2013-12-25 18:57:01',NULL,NULL),(23352,4389,'3468352','834','00','005010X220A1','3468352','','2014-03-07','21:49:49',0,'2014-03-08 21:30:59',NULL,NULL),(20254,3795,'3602959','834','00','005010X220A1','3602959','','2014-02-18','21:38:45',0,'2014-02-20 04:32:53',NULL,NULL),(15781,2717,'1923395','834','00','005010X220A1','1923395','','2014-01-20','16:02:36',0,'2014-01-21 08:46:36',NULL,NULL),(15573,2657,'2282142','834','00','005010X220A1','2282142','','2014-01-17','17:28:20',0,'2014-01-20 08:06:06',NULL,NULL),(15365,2624,'1882975','834','00','005010X220A1','1882975','','2014-01-15','21:08:25',0,'2014-01-17 03:35:30',NULL,NULL),(11019,1415,'648210','834','00','005010X220A1','648210','','2013-12-22','19:00:47',0,'2013-12-26 13:11:27',NULL,NULL),(15082,2585,'1924705','834','00','005010X220A1','1924705','','2014-01-15','11:57:20',0,'2014-01-16 08:45:09',NULL,NULL),(2793,506,'156443','834','00','005010X220A1','156443','','2013-12-22','11:05:05',0,'2013-12-25 21:20:09',NULL,NULL),(12070,1586,'2191095','834','00','005010X220A1','2191095','','2013-12-30','09:25:02',0,'2014-01-01 12:04:42',NULL,NULL),(14896,2558,'1427761','834','00','005010X220A1','1427761','','2014-01-14','11:38:57',0,'2014-01-15 02:07:28',NULL,NULL),(23143,4342,'2955601','834','00','005010X220A1','2955601','','2014-03-07','14:50:25',0,'2014-03-07 21:31:05',NULL,NULL),(19287,3582,'2806786','834','00','005010X220A1','2806786','','2014-02-13','14:16:18',0,'2014-02-13 22:01:03',NULL,NULL),(16649,3060,'2087341','834','00','005010X220A1','2087341','','2014-01-27','11:40:14',0,'2014-01-27 21:00:10',NULL,NULL),(3813,664,'23059','834','00','005010X220A1','23059','','2013-12-08','13:59:08',0,'2013-12-25 22:16:46',NULL,NULL),(7274,1253,'438651','834','00','005010X220A1','438651','','2013-12-18','11:36:30',0,'2013-12-26 04:08:55',NULL,NULL),(3164,563,'1261445','834','00','005010X220A1','1261445','','2013-12-13','12:24:56',0,'2013-12-25 21:38:14',NULL,NULL),(2501,446,'595332','834','00','005010X220A1','595332','','2013-10-12','18:55:38',0,'2013-12-25 20:30:04',NULL,NULL),(2222,367,'547385','834','00','005010X220A1','547385','','2013-12-02','16:34:45',0,'2013-12-25 19:48:54',NULL,NULL),(115,7,'104108','834','00','005010X220A1','104108','','2013-12-04','19:14:44',0,'2013-12-25 17:18:30',NULL,NULL),(21682,4082,'2827925','834','00','005010X220A1','2827925','','2014-02-28','14:37:58',0,'2014-02-28 21:00:23',NULL,NULL),(21558,4052,'2810512','834','00','005010X220A1','2810512','','2014-02-27','16:49:01',0,'2014-02-28 06:31:49',NULL,NULL),(20447,3841,'2782838','834','00','005010X220A1','2782838','','2014-02-20','17:33:15',0,'2014-02-20 22:00:20',NULL,NULL),(18794,3487,'2911313','834','00','005010X220A1','2911313','','2014-02-11','13:00:25',0,'2014-02-11 21:01:10',NULL,NULL),(5002,935,'1192960','834','00','005010X220A1','1192960','','2013-12-11','10:17:40',0,'2013-12-26 00:46:01',NULL,NULL),(4770,861,'75113','834','00','005010X220A1','75113','','2013-12-01','16:29:48',0,'2013-12-26 00:01:00',NULL,NULL),(3002,542,'1251740','834','00','005010X220A1','1251740','','2013-12-13','16:30:32',0,'2013-12-25 21:33:10',NULL,NULL),(12644,1672,'1882588','834','00','005010X220A1','1882588','','2014-01-02','18:01:33',0,'2014-01-03 02:02:41',NULL,NULL),(2797,506,'672516','834','00','005010X220A1','672516','','2013-12-22','11:36:37',0,'2013-12-25 21:20:15',NULL,NULL),(7562,1301,'125497','834','00','005010X220A1','125497','','2013-12-21','11:55:58',0,'2013-12-26 04:36:02',NULL,NULL),(18613,3456,'2782527','834','00','005010X220A1','2782527','','2014-02-10','15:34:01',0,'2014-02-10 21:31:13',NULL,NULL),(11164,1440,'817684','834','00','005010X220A1','817684','','2013-12-23','14:57:32',0,'2013-12-26 13:16:27',NULL,NULL),(14989,2581,'1864841','834','00','005010X220A1','1864841','','2014-01-14','17:10:25',0,'2014-01-15 02:08:11',NULL,NULL),(400,76,'320407','834','00','005010X220A1','320407','','2013-12-04','10:50:55',0,'2013-12-25 17:48:22',NULL,NULL),(14941,2561,'1773440','834','00','005010X220A1','1773440','','2014-01-14','15:53:45',0,'2014-01-15 02:07:48',NULL,NULL),(14947,2562,'2179375','834','00','005010X220A1','2179375','','2014-01-13','20:58:20',0,'2014-01-15 02:07:50',NULL,NULL),(21292,4006,'2956493','834','00','005010X220A1','2956493','','2014-02-26','11:48:55',0,'2014-02-26 21:02:18',NULL,NULL),(11356,1458,'1651176','834','00','005010X220A1','1651176','','2013-12-26','16:03:04',0,'2013-12-27 02:05:14',NULL,NULL),(20172,3777,'3172392','834','00','005010X220A1','3172392','','2014-02-19','13:35:45',0,'2014-02-20 04:10:12',NULL,NULL),(5189,949,'265928','834','00','005010X220A1','265928','','2013-12-11','11:04:12',0,'2013-12-26 00:52:00',NULL,NULL),(1315,245,'1916486','834','00','005010X220A1','1916486','','2013-12-24','10:24:18',0,'2013-12-25 18:51:17',NULL,NULL),(18363,3405,'1545530','834','00','005010X220A1','1545530','','2014-02-09','14:31:52',0,'2014-02-09 19:00:10',NULL,NULL),(20092,3765,'2990605','834','00','005010X220A1','2990605','','2014-02-18','16:06:37',0,'2014-02-18 22:01:40',NULL,NULL),(20298,3795,'3657036','834','00','005010X220A1','3657036','','2014-02-19','11:59:08',0,'2014-02-20 04:42:37',NULL,NULL),(20774,3907,'3049799','834','00','005010X220A1','3049799','','2014-02-25','08:49:14',0,'2014-02-25 21:30:36',NULL,NULL),(21314,4009,'2830718','834','00','005010X220A1','2830718','','2014-02-26','17:38:37',0,'2014-02-26 21:02:35',NULL,NULL),(21489,4029,'3438805','834','00','005010X220A1','3438805','','2014-02-26','19:00:18',0,'2014-02-28 06:31:16',NULL,NULL),(21969,4143,'2771941','834','00','005010X220A1','2771941','','2014-03-01','22:52:35',0,'2014-03-03 01:00:06',NULL,NULL),(22969,4313,'3757676','834','00','005010X220A1','3757676','','2014-03-06','16:21:36',0,'2014-03-06 21:30:10',NULL,NULL),(23024,4325,'3485673','834','00','005010X220A1','3485673','','2014-03-07','14:55:35',0,'2014-03-07 21:00:22',NULL,NULL),(84,4,'1014960','834','00','005010X220A1','1014960','','2013-12-05','07:38:16',0,'2013-12-25 17:17:32',NULL,NULL),(12035,1583,'1527565','834','00','005010X220A1','1527565','','2013-12-30','14:56:25',0,'2014-01-01 12:03:24',NULL,NULL),(5252,965,'984216','834','00','005010X220A1','984216','','2013-12-11','17:45:31',0,'2013-12-26 00:54:04',NULL,NULL),(2078,343,'259421','834','00','005010X220A1','259421','','2013-12-09','11:32:54',0,'2013-12-25 19:37:20',NULL,NULL),(2047,335,'1084360','834','00','005010X220A1','1084360','','2013-12-08','23:54:54',0,'2013-12-25 19:36:19',NULL,NULL),(1884,325,'700804','834','00','005010X220A1','700804','','2013-12-09','07:21:42',0,'2013-12-25 19:31:21',NULL,NULL),(13326,2170,'0001','999','BE','005010X231A1','110550','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:24',NULL,NULL),(1832,315,'524560','834','00','005010X220A1','524560','','2013-12-10','14:22:06',0,'2013-12-25 19:20:38',NULL,NULL),(5856,1097,'208442','834','00','005010X220A1','208442','','2013-11-23','16:04:13',0,'2013-12-26 02:16:21',NULL,NULL),(11647,1499,'1801962','834','00','005010X220A1','1801962','','2013-12-27','11:50:41',0,'2013-12-28 03:36:10',NULL,NULL),(5966,1117,'231885','834','00','005010X220A1','231885','','2013-12-15','13:43:45',0,'2013-12-26 02:32:51',NULL,NULL),(10777,1404,'1600904','834','00','005010X220A1','1600904','','2013-12-23','07:58:36',0,'2013-12-26 13:03:09',NULL,NULL),(6157,1167,'533739','834','00','005010X220A1','533739','','2013-12-19','22:27:51',0,'2013-12-26 03:03:04',NULL,NULL),(13907,2313,'2356418','834','00','005010X220A1','2356418','','2014-01-08','21:03:24',0,'2014-01-13 02:19:50',NULL,NULL),(15200,2592,'2533728','834','00','005010X220A1','2533728','','2014-01-15','09:04:47',0,'2014-01-16 08:46:26',NULL,NULL),(15553,2655,'2573826','834','00','005010X220A1','2573826','','2014-01-16','22:16:43',0,'2014-01-20 08:05:51',NULL,NULL),(16446,3006,'2237095','834','00','005010X220A1','2237095','','2014-01-23','20:16:35',0,'2014-01-24 21:00:10',NULL,NULL),(16476,3008,'1640980','834','00','005010X220A1','1640980','','2014-01-24','13:45:25',0,'2014-01-24 21:00:27',NULL,NULL),(19738,3673,'3530737','834','00','005010X220A1','3530737','','2014-02-15','10:37:09',0,'2014-02-15 22:00:35',NULL,NULL),(21030,3974,'2568176','834','00','005010X220A1','2568176','','2014-02-24','16:19:09',0,'2014-02-26 09:30:09',NULL,NULL),(22191,4181,'3408537','834','00','005010X220A1','3408537','','2014-03-03','10:52:08',0,'2014-03-03 21:31:25',NULL,NULL),(22924,4291,'2920521','834','00','005010X220A1','2920521','','2014-03-06','10:31:32',0,'2014-03-06 21:02:34',NULL,NULL),(23565,4436,'3454191','834','00','005010X220A1','3454191','','2014-03-10','11:21:45',0,'2014-03-10 21:00:52',NULL,NULL),(1928,326,'226848','834','00','005010X220A1','226848','','2013-12-09','07:49:26',0,'2013-12-25 19:32:34',NULL,NULL),(13438,2223,'2089081','834','00','005010X220A1','2089081','','2014-01-06','15:35:34',0,'2014-01-07 04:02:15',NULL,NULL),(2024,331,'863794','834','00','005010X220A1','863794','','2013-12-09','15:09:55',0,'2013-12-25 19:35:37',NULL,NULL),(12871,1706,'2255305','834','00','005010X220A1','2255305','','2014-01-03','12:32:00',0,'2014-01-04 02:03:50',NULL,NULL),(2041,331,'590991','834','00','005010X220A1','590991','','2013-12-09','18:11:25',0,'2013-12-25 19:36:07',NULL,NULL),(3323,586,'1082169','834','00','005010X220A1','1082169','','2013-12-16','19:31:20',0,'2013-12-25 21:49:18',NULL,NULL),(11462,1488,'2295044','834','00','005010X220A1','2295044','','2013-12-27','10:49:57',0,'2013-12-28 03:30:31',NULL,NULL),(5300,986,'128101','834','00','005010X220A1','128101','','2013-11-04','21:45:40',0,'2013-12-26 01:01:26',NULL,NULL),(6445,1208,'885872','834','00','005010X220A1','885872','','2013-11-22','16:40:51',0,'2013-12-26 03:15:56',NULL,NULL),(14135,2352,'2319234','834','00','005010X220A1','2319234','','2014-01-08','15:08:57',0,'2014-01-13 02:22:32',NULL,NULL),(14145,2356,'2509691','834','00','005010X220A1','2509691','','2014-01-08','11:39:13',0,'2014-01-13 02:22:39',NULL,NULL),(15586,2659,'1610666','834','00','005010X220A1','1610666','','2014-01-17','13:20:36',0,'2014-01-20 08:06:17',NULL,NULL),(15921,2743,'2427062','834','00','005010X220A1','2427062','','2014-01-21','15:05:10',1,'2014-01-22 03:22:54',NULL,NULL),(16627,3051,'2247559','834','00','005010X220A1','2247559','','2014-01-26','15:22:25',0,'2014-01-26 19:00:22',NULL,NULL),(16824,3090,'1484486','834','00','005010X220A1','1484486','','2014-01-28','17:11:19',0,'2014-01-28 21:00:22',NULL,NULL),(21923,4128,'2824777','834','00','005010X220A1','2824777','','2014-02-28','23:15:35',0,'2014-03-01 21:00:44',NULL,NULL),(23130,4342,'3637019','834','00','005010X220A1','3637019','','2014-03-07','11:20:39',0,'2014-03-07 21:30:57',NULL,NULL),(17523,3235,'2340007','834','00','005010X220A1','2340007','','2014-02-03','10:08:39',0,'2014-02-03 21:00:10',NULL,NULL),(19679,3664,'3222424','834','00','005010X220A1','3222424','','2014-02-15','07:45:43',0,'2014-02-15 21:00:03',NULL,NULL),(19828,3680,'2885804','834','00','005010X220A1','2885804','','2014-02-15','13:32:50',0,'2014-02-15 22:01:45',NULL,NULL),(19915,3725,'2801940','834','00','005010X220A1','2801940','','2014-02-17','17:17:26',0,'2014-02-17 19:00:09',NULL,NULL),(1107,234,'54340','834','00','005010X220A1','54340','','2013-11-06','22:31:06',0,'2013-12-25 18:32:18',NULL,NULL),(12840,1704,'1766775','834','00','005010X220A1','1766775','','2014-01-03','16:50:51',0,'2014-01-04 02:02:41',NULL,NULL),(5926,1112,'890781','834','00','005010X220A1','890781','','2013-12-15','14:46:50',0,'2013-12-26 02:31:36',NULL,NULL),(4258,741,'6768','834','00','005010X220A1','6768','','2013-12-19','13:00:35',0,'2013-12-25 23:08:03',NULL,NULL),(2802,506,'400070','834','00','005010X220A1','400070','','2013-12-22','14:01:11',0,'2013-12-25 21:20:25',NULL,NULL),(13869,2311,'1911332','834','00','005010X220A1','1911332','','2014-01-09','13:17:47',0,'2014-01-13 02:19:25',NULL,NULL),(14107,2344,'2245821','834','00','005010X220A1','2245821','','2014-01-07','20:30:03',0,'2014-01-13 02:22:15',NULL,NULL),(14194,2365,'1569306','834','00','005010X220A1','1569306','','2014-01-10','13:04:16',0,'2014-01-13 02:23:39',NULL,NULL),(14568,2519,'2525207','834','00','005010X220A1','2525207','','2014-01-13','15:57:28',0,'2014-01-14 01:32:46',NULL,NULL),(16211,2903,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 05:02:13',NULL,NULL),(17341,3180,'1563523','834','00','005010X220A1','1563523','','2014-01-30','21:18:06',0,'2014-01-31 21:01:10',NULL,NULL),(17423,3201,'2051458','834','00','005010X220A1','2051458','','2014-02-01','15:53:08',0,'2014-02-01 19:00:23',NULL,NULL),(18626,3459,'2930819','834','00','005010X220A1','2930819','','2014-02-10','16:06:17',0,'2014-02-10 21:31:22',NULL,NULL),(19279,3582,'3272342','834','00','005010X220A1','3272342','','2014-02-13','12:03:59',0,'2014-02-13 22:00:58',NULL,NULL),(19403,3593,'3085977','834','00','005010X220A1','3085977','','2014-02-13','12:48:42',0,'2014-02-13 22:02:32',NULL,NULL),(19582,3629,'3035349','834','00','005010X220A1','3035349','','2014-02-14','11:00:04',0,'2014-02-14 21:31:24',NULL,NULL),(22258,4200,'3213205','834','00','005010X220A1','3213205','','2014-03-04','09:22:24',0,'2014-03-04 21:00:26',NULL,NULL),(22670,4255,'2875848','834','00','005010X220A1','2875848','','2014-03-04','18:46:09',0,'2014-03-05 21:32:06',NULL,NULL),(23111,4341,'3463371','834','00','005010X220A1','3463371','','2014-03-07','17:28:30',0,'2014-03-07 21:30:43',NULL,NULL),(23426,4405,'2871315','834','00','005010X220A1','2871315','','2014-03-09','11:36:06',0,'2014-03-09 21:00:30',NULL,NULL),(754,137,'437551','834','00','005010X220A1','437551','','2013-12-16','13:53:57',0,'2013-12-25 18:08:29',NULL,NULL),(2626,491,'846878','834','00','005010X220A1','846878','','2013-11-27','18:18:01',0,'2013-12-25 20:46:47',NULL,NULL),(1886,325,'1042753','834','00','005010X220A1','1042753','','2013-12-09','07:38:08',0,'2013-12-25 19:31:23',NULL,NULL),(11304,1456,'100885','834','00','005010X220A1','100885','','2013-12-26','09:33:06',0,'2013-12-27 02:03:38',NULL,NULL),(3668,627,'552559','834','00','005010X220A1','552559','','2013-12-12','07:26:01',0,'2013-12-25 22:06:28',NULL,NULL),(13800,2294,'2582095','834','00','005010X220A1','2582095','','2014-01-11','15:16:03',0,'2014-01-13 02:18:15',NULL,NULL),(14390,2415,'1462210','834','00','005010X220A1','1462210','','2014-01-12','18:00:16',0,'2014-01-13 03:01:55',NULL,NULL),(14573,2520,'1969366','834','00','005010X220A1','1969366','','2014-01-13','11:02:30',0,'2014-01-14 01:32:49',NULL,NULL),(15211,2592,'2322781','834','00','005010X220A1','2322781','','2014-01-15','17:50:05',0,'2014-01-16 08:46:31',NULL,NULL),(15348,2623,'2550232','834','00','005010X220A1','2550232','','2014-01-15','22:05:53',0,'2014-01-17 03:35:22',NULL,NULL),(15886,2740,'2166410','834','00','005010X220A1','2166410','','2014-01-21','13:32:47',1,'2014-01-22 03:22:32',NULL,NULL),(16348,2983,'2581175','834','00','005010X220A1','2581175','','2014-01-23','12:41:36',0,'2014-01-23 21:00:47',NULL,NULL),(16884,3096,'1360916','834','00','005010X220A1','1360916','','2014-01-27','22:10:23',0,'2014-01-28 21:01:02',NULL,NULL),(17416,3200,'2085237','834','00','005010X220A1','2085237','','2014-01-31','23:30:24',0,'2014-02-01 19:00:19',NULL,NULL),(18181,3351,'2539346','834','00','005010X220A1','2539346','','2014-02-07','09:08:36',0,'2014-02-07 19:00:22',NULL,NULL),(18251,3376,'2059303','834','00','005010X220A1','2059303','','2014-02-07','19:30:09',0,'2014-02-08 19:00:04',NULL,NULL),(18448,3423,'2315450','834','00','005010X220A1','2315450','','2014-02-10','00:23:00',0,'2014-02-10 11:00:32',NULL,NULL),(18912,3510,'3052714','834','00','005010X220A1','3052714','','2014-02-11','11:34:25',0,'2014-02-11 21:02:47',NULL,NULL),(20456,3842,'2952832','834','00','005010X220A1','2952832','','2014-02-20','01:27:19',0,'2014-02-20 22:00:28',NULL,NULL),(22126,4179,'2744341','834','00','005010X220A1','2744341','','2014-03-03','10:35:33',0,'2014-03-03 21:30:38',NULL,NULL),(22303,4201,'2951842','834','00','005010X220A1','2951842','','2014-03-04','10:45:15',0,'2014-03-04 21:01:01',NULL,NULL),(23079,4339,'3480853','834','00','005010X220A1','3480853','','2014-03-07','11:56:31',0,'2014-03-07 21:30:20',NULL,NULL),(23516,4434,'2960364','834','00','005010X220A1','2960364','','2014-03-10','14:47:02',0,'2014-03-10 21:00:14',NULL,NULL),(316,70,'1167041','834','00','005010X220A1','1167041','','2013-12-04','16:46:55',0,'2013-12-25 17:45:42',NULL,NULL),(1987,327,'52047','834','00','005010X220A1','52047','','2013-12-09','15:09:28',0,'2013-12-25 19:34:22',NULL,NULL),(5750,1070,'860518','834','00','005010X220A1','860518','','2013-12-14','16:26:13',0,'2013-12-26 02:01:53',NULL,NULL),(6338,1176,'1192268','834','00','005010X220A1','1192268','','2013-12-20','14:39:52',0,'2013-12-26 03:08:33',NULL,NULL),(1447,252,'175636','834','00','005010X220A1','175636','','2013-12-24','12:13:25',0,'2013-12-25 18:55:34',NULL,NULL),(1060,207,'434984','834','00','005010X220A1','434984','','2013-11-29','13:08:40',0,'2013-12-25 18:30:35',NULL,NULL),(951,181,'83091','834','00','005010X220A1','83091','','2013-12-03','11:04:26',0,'2013-12-25 18:18:40',NULL,NULL),(11957,1580,'2066561','834','00','005010X220A1','2066561','','2013-12-30','09:27:00',0,'2014-01-01 12:00:28',NULL,NULL),(640,108,'655772','834','00','005010X220A1','655772','','2013-12-16','12:55:51',0,'2013-12-25 18:04:53',NULL,NULL),(12988,1738,'1305934','834','00','005010X220A1','1305934','','2014-01-03','20:18:08',0,'2014-01-05 00:01:42',NULL,NULL),(13142,1986,'0001','999','BE','005010X231A1','667011','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:10',NULL,NULL),(14195,2365,'1693852','834','00','005010X220A1','1693852','','2014-01-10','13:04:46',0,'2014-01-13 02:23:40',NULL,NULL),(14239,2372,'2519747','834','00','005010X220A1','2519747','','2014-01-10','11:23:27',0,'2014-01-13 02:24:09',NULL,NULL),(14991,2583,'1648969','834','00','005010X220A1','1648969','','2014-01-14','18:00:50',0,'2014-01-15 02:08:12',NULL,NULL),(15293,2616,'1826133','834','00','005010X220A1','1826133','','2014-01-15','17:23:07',0,'2014-01-16 08:47:26',NULL,NULL),(15642,2678,'2121975','834','00','005010X220A1','2121975','','2014-01-17','22:51:00',0,'2014-01-21 08:44:19',NULL,NULL),(15920,2743,'2182025','834','00','005010X220A1','2182025','','2014-01-21','15:03:53',1,'2014-01-22 03:22:53',NULL,NULL),(16269,2961,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:12:00',0,'2014-01-23 09:50:44',NULL,NULL),(21049,3977,'3533750','834','00','005010X220A1','3533750','','2014-02-24','16:52:39',0,'2014-02-26 09:30:26',NULL,NULL),(16594,3043,'2118490','834','00','005010X220A1','2118490','','2014-01-25','02:25:04',0,'2014-01-25 19:00:19',NULL,NULL),(17106,3142,'1455471','834','00','005010X220A1','1455471','','2014-01-30','10:11:05',0,'2014-01-30 21:00:10',NULL,NULL),(18884,3496,'1787049','834','00','005010X220A1','1787049','','2014-02-11','16:19:27',0,'2014-02-11 21:02:22',NULL,NULL),(19441,3603,'2705226','834','00','005010X220A1','2705226','','2014-02-13','11:50:48',0,'2014-02-13 22:02:59',NULL,NULL),(19992,3747,'2961170','834','00','005010X220A1','2961170','','2014-02-17','19:47:20',0,'2014-02-18 22:00:28',NULL,NULL),(21280,4004,'2950362','834','00','005010X220A1','2950362','','2014-02-26','10:34:40',0,'2014-02-26 21:02:10',NULL,NULL),(21527,4037,'3084932','834','00','005010X220A1','3084932','','2014-02-27','16:25:48',0,'2014-02-28 06:31:34',NULL,NULL),(21751,4090,'2944312','834','00','005010X220A1','2944312','','2014-02-28','00:12:20',0,'2014-02-28 21:30:47',NULL,NULL),(21914,4127,'2777070','834','00','005010X220A1','2777070','','2014-03-01','14:37:07',0,'2014-03-01 21:00:39',NULL,NULL),(4534,824,'695185','834','00','005010X220A1','695185','','2013-12-23','22:58:15',0,'2013-12-25 23:45:08',NULL,NULL),(6306,1174,'271314','834','00','005010X220A1','271314','','2013-12-20','15:01:55',0,'2013-12-26 03:07:33',NULL,NULL),(6110,1166,'793458','834','00','005010X220A1','793458','','2013-12-20','13:16:51',0,'2013-12-26 03:01:36',NULL,NULL),(7751,1345,'882158','834','00','005010X220A1','882158','','2013-10-20','16:15:47',0,'2013-12-26 05:00:53',NULL,NULL),(5429,1031,'1046228','834','00','005010X220A1','1046228','','2013-10-05','08:43:12',0,'2013-12-26 01:31:18',NULL,NULL),(13359,2203,'0001','999','BE','005010X231A1','856276','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:56',NULL,NULL),(14368,2404,'2582102','834','00','005010X220A1','2582102','','2014-01-12','14:13:21',0,'2014-01-13 03:01:39',NULL,NULL),(15862,2738,'2237017','834','00','005010X220A1','2237017','','2014-01-21','10:12:51',1,'2014-01-22 03:22:16',NULL,NULL),(16589,3040,'1856674','834','00','005010X220A1','1856674','','2014-01-25','18:04:19',0,'2014-01-25 19:00:16',NULL,NULL),(16834,3091,'2679190','834','00','005010X220A1','2679190','','2014-01-28','13:52:19',0,'2014-01-28 21:00:28',NULL,NULL),(17054,3124,'2575038','834','00','005010X220A1','2575038','','2014-01-29','10:17:42',0,'2014-01-29 21:01:29',NULL,NULL),(17435,3204,'1968649','834','00','005010X220A1','1968649','','2014-02-01','14:04:59',0,'2014-02-01 19:00:31',NULL,NULL),(18480,3431,'2374087','834','00','005010X220A1','2374087','','2014-02-10','03:59:50',0,'2014-02-10 11:00:59',NULL,NULL),(21333,4022,'3306443','834','00','005010X220A1','3306443','','2014-02-26','18:36:20',0,'2014-02-28 06:30:04',NULL,NULL),(21367,4024,'3242115','834','00','005010X220A1','3242115','','2014-02-27','09:36:43',0,'2014-02-28 06:30:19',NULL,NULL),(21516,4034,'3512573','834','00','005010X220A1','3512573','','2014-02-27','17:15:48',0,'2014-02-28 06:31:29',NULL,NULL),(23716,4458,'3299544','834','00','005010X220A1','3299544','','2014-03-10','17:13:19',0,'2014-03-10 21:02:40',NULL,NULL),(433,79,'934905','834','00','005010X220A1','934905','','2013-12-03','23:14:20',0,'2013-12-25 17:49:27',NULL,NULL),(4836,883,'483512','834','00','005010X220A1','483512','','2013-11-21','15:58:08',0,'2013-12-26 00:15:10',NULL,NULL),(4660,830,'584829','834','00','005010X220A1','584829','','2013-12-23','21:52:53',0,'2013-12-25 23:49:15',NULL,NULL),(6425,1203,'512367','834','00','005010X220A1','512367','','2013-11-22','12:27:23',0,'2013-12-26 03:15:18',NULL,NULL),(7042,1235,'903695','834','00','005010X220A1','903695','','2013-12-18','15:43:35',0,'2013-12-26 04:01:47',NULL,NULL),(4224,738,'669804','834','00','005010X220A1','669804','','2013-12-19','11:02:43',0,'2013-12-25 23:06:57',NULL,NULL),(10685,1403,'180473','834','00','005010X220A1','180473','','2013-12-23','01:17:01',0,'2013-12-26 12:59:59',NULL,NULL),(11056,1420,'1414535','834','00','005010X220A1','1414535','','2013-12-23','10:29:45',0,'2013-12-26 13:12:40',NULL,NULL),(2228,372,'1189306','834','00','005010X220A1','1189306','','2013-12-02','11:35:01',0,'2013-12-25 19:49:08',NULL,NULL),(11959,1580,'1500769','834','00','005010X220A1','1500769','','2013-12-30','10:56:55',0,'2014-01-01 12:00:32',NULL,NULL),(1662,289,'97396','834','00','005010X220A1','97396','','2013-12-10','16:33:06',0,'2013-12-25 19:15:17',NULL,NULL),(713,118,'617917','834','00','005010X220A1','617917','','2013-12-16','08:45:42',0,'2013-12-25 18:07:10',NULL,NULL),(14082,2341,'2270286','834','00','005010X220A1','2270286','','2014-01-08','08:36:19',0,'2014-01-13 02:21:58',NULL,NULL),(16054,2772,'2586519','834','00','005010X220A1','2586519','','2014-01-22','17:24:04',0,'2014-01-23 03:02:37',NULL,NULL),(16528,3017,'2371761','834','00','005010X220A1','2371761','','2014-01-24','17:12:47',0,'2014-01-24 21:00:59',NULL,NULL),(17508,3228,'1650831','834','00','005010X220A1','1650831','','2014-02-02','14:21:42',0,'2014-02-02 19:00:30',NULL,NULL),(17621,3243,'2080836','834','00','005010X220A1','2080836','','2014-02-03','13:53:57',0,'2014-02-03 21:01:12',NULL,NULL),(17857,3293,'1872110','834','00','005010X220A1','1872110','','2014-02-05','05:23:42',0,'2014-02-05 21:30:09',NULL,NULL),(17870,3293,'1434567','834','00','005010X220A1','1434567','','2014-02-05','15:48:57',0,'2014-02-05 21:30:16',NULL,NULL),(19817,3679,'3326193','834','00','005010X220A1','3326193','','2014-02-15','12:44:07',0,'2014-02-15 22:01:36',NULL,NULL),(20216,3781,'2876793','834','00','005010X220A1','2876793','','2014-02-19','15:36:41',0,'2014-02-20 04:22:12',NULL,NULL),(20530,3849,'3555369','834','00','005010X220A1','3555369','','2014-02-20','14:55:17',0,'2014-02-20 22:01:28',NULL,NULL),(22023,4155,'2799500','834','00','005010X220A1','2799500','','2014-03-02','12:31:21',0,'2014-03-03 01:00:37',NULL,NULL),(22982,4317,'3733621','834','00','005010X220A1','3733621','','2014-03-06','15:30:36',0,'2014-03-06 21:30:20',NULL,NULL),(1441,252,'203191','834','00','005010X220A1','203191','','2013-12-24','11:00:14',0,'2013-12-25 18:55:24',NULL,NULL),(7560,1301,'1174119','834','00','005010X220A1','1174119','','2013-12-21','11:25:47',0,'2013-12-26 04:35:58',NULL,NULL),(10831,1404,'1744925','834','00','005010X220A1','1744925','','2013-12-23','18:18:53',0,'2013-12-26 13:04:53',NULL,NULL),(11421,1472,'1418649','834','00','005010X220A1','1418649','','2013-12-26','12:55:48',0,'2013-12-27 02:07:13',NULL,NULL),(7094,1236,'1020305','834','00','005010X220A1','1020305','','2013-12-18','11:08:32',0,'2013-12-26 04:03:26',NULL,NULL),(4956,927,'1028196','834','00','005010X220A1','1028196','','2013-11-19','09:59:04',0,'2013-12-26 00:32:02',NULL,NULL),(12263,1620,'2455269','834','00','005010X220A1','2455269','','2014-01-01','17:39:15',1,'2014-01-02 04:23:55',NULL,NULL),(3486,615,'659680','834','00','005010X220A1','659680','','2013-12-12','10:44:35',0,'2013-12-25 22:00:43',NULL,NULL),(3104,546,'73074','834','00','005010X220A1','73074','','2013-12-13','13:07:02',0,'2013-12-25 21:36:17',NULL,NULL),(12629,1671,'2544929','834','00','005010X220A1','2544929','','2014-01-02','17:11:35',0,'2014-01-03 02:02:05',NULL,NULL),(2504,447,'637024','834','00','005010X220A1','637024','','2013-10-12','22:51:03',0,'2013-12-25 20:30:10',NULL,NULL),(2290,395,'516998','834','00','005010X220A1','516998','','2013-11-24','16:27:55',0,'2013-12-25 20:00:49',NULL,NULL),(16171,2863,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',1,'2014-01-23 04:17:32',NULL,NULL),(19709,3672,'2112642','834','00','005010X220A1','2112642','','2014-02-14','21:13:15',0,'2014-02-15 22:00:15',NULL,NULL),(19938,3735,'2592224','834','00','005010X220A1','2592224','','2014-02-18','09:39:43',0,'2014-02-18 21:30:10',NULL,NULL),(20706,3893,'2737618','834','00','005010X220A1','2737618','','2014-02-25','13:32:50',0,'2014-02-25 21:00:15',NULL,NULL),(21568,4054,'3802571','834','00','005010X220A1','3802571','','2014-02-26','11:04:08',0,'2014-02-28 07:00:11',NULL,NULL),(22413,4215,'3339974','834','00','005010X220A1','3339974','','2014-03-04','15:11:01',0,'2014-03-04 21:02:31',NULL,NULL),(23101,4340,'3389655','834','00','005010X220A1','3389655','','2014-03-06','19:04:01',0,'2014-03-07 21:30:35',NULL,NULL),(23569,4436,'3305348','834','00','005010X220A1','3305348','','2014-03-10','12:43:06',0,'2014-03-10 21:00:55',NULL,NULL),(23654,4442,'3728721','834','00','005010X220A1','3728721','','2014-03-10','12:08:10',0,'2014-03-10 21:01:54',NULL,NULL),(1314,245,'130318','834','00','005010X220A1','130318','','2013-12-24','10:13:23',0,'2013-12-25 18:51:15',NULL,NULL),(1641,282,'133368','834','00','005010X220A1','133368','','2013-11-20','07:18:58',0,'2013-12-25 19:02:13',NULL,NULL),(2634,496,'472608','834','00','005010X220A1','472608','','2013-11-27','22:16:32',0,'2013-12-25 20:47:04',NULL,NULL),(13160,2004,'0001','999','BE','005010X231A1','749039','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:01',NULL,NULL),(13083,1927,'0001','999','BE','005010X231A1','4258','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:51',NULL,NULL),(4746,858,'264313','834','00','005010X220A1','264313','','2013-12-01','10:10:50',0,'2013-12-26 00:00:09',NULL,NULL),(6107,1166,'418100','834','00','005010X220A1','418100','','2013-12-20','10:09:23',0,'2013-12-26 03:01:32',NULL,NULL),(14105,2343,'2155644','834','00','005010X220A1','2155644','','2014-01-08','15:59:45',0,'2014-01-13 02:22:13',NULL,NULL),(16959,3116,'1914760','834','00','005010X220A1','1914760','','2014-01-29','09:36:19',0,'2014-01-29 21:00:29',NULL,NULL),(18335,3388,'2003519','834','00','005010X220A1','2003519','','2014-02-08','11:43:34',0,'2014-02-08 19:00:57',NULL,NULL),(20568,3864,'3701526','834','00','005010X220A1','3701526','','2014-02-21','17:34:30',0,'2014-02-21 21:30:14',NULL,NULL),(20919,3932,'3339685','834','00','005010X220A1','3339685','','2014-02-23','16:11:52',0,'2014-02-26 08:00:16',NULL,NULL),(21479,4028,'3569397','834','00','005010X220A1','3569397','','2014-02-27','15:47:39',0,'2014-02-28 06:31:12',NULL,NULL),(22027,4158,'2945496','834','00','005010X220A1','2945496','','2014-03-02','14:45:29',0,'2014-03-03 01:00:40',NULL,NULL),(22504,4247,'3198520','834','00','005010X220A1','3198520','','2014-03-04','20:41:44',0,'2014-03-05 21:30:09',NULL,NULL),(23381,4399,'3098369','834','00','005010X220A1','3098369','','2014-03-08','15:42:47',0,'2014-03-08 21:31:21',NULL,NULL),(23575,4436,'3156762','834','00','005010X220A1','3156762','','2014-03-10','15:14:19',0,'2014-03-10 21:00:59',NULL,NULL),(577,103,'991779','834','00','005010X220A1','991779','','2013-12-16','17:58:35',0,'2013-12-25 18:02:52',NULL,NULL),(12728,1682,'2071393','834','00','005010X220A1','2071393','','2014-01-02','11:00:19',0,'2014-01-03 02:05:52',NULL,NULL),(12635,1672,'1438788','834','00','005010X220A1','1438788','','2014-01-02','10:46:19',0,'2014-01-03 02:02:18',NULL,NULL),(12182,1599,'1393219','834','00','005010X220A1','1393219','','2013-12-30','09:18:21',0,'2014-01-01 12:08:36',NULL,NULL),(1841,320,'584097','834','00','005010X220A1','584097','','2013-12-10','16:40:43',0,'2013-12-25 19:20:59',NULL,NULL),(11105,1425,'182764','834','00','005010X220A1','182764','','2013-12-23','14:43:23',0,'2013-12-26 13:14:16',NULL,NULL),(11529,1490,'1446177','834','00','005010X220A1','1446177','','2013-12-27','13:59:52',0,'2013-12-28 03:32:30',NULL,NULL),(11630,1497,'2077260','834','00','005010X220A1','2077260','','2013-12-26','22:32:10',0,'2013-12-28 03:35:39',NULL,NULL),(11913,1565,'1738803','834','00','005010X220A1','1738803','','2013-12-28','20:22:01',0,'2013-12-30 00:01:25',NULL,NULL),(12797,1703,'2114237','834','00','005010X220A1','2114237','','2014-01-03','11:39:40',0,'2014-01-04 02:01:10',NULL,NULL),(12929,1721,'1690956','834','00','005010X220A1','1690956','','2014-01-03','14:56:00',0,'2014-01-04 02:06:01',NULL,NULL),(1522,260,'1710099','834','00','005010X220A1','1710099','','2013-12-24','10:59:06',0,'2013-12-25 18:58:07',NULL,NULL),(13353,2197,'0001','999','BE','005010X231A1','1133346','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:39',NULL,NULL),(13837,2306,'1637210','834','00','005010X220A1','1637210','','2014-01-11','14:40:13',0,'2014-01-13 02:18:40',NULL,NULL),(13916,2313,'2481434','834','00','005010X220A1','2481434','','2014-01-09','13:31:39',0,'2014-01-13 02:19:54',NULL,NULL),(14713,2550,'2147063','834','00','005010X220A1','2147063','','2014-01-14','10:44:55',0,'2014-01-15 02:06:07',NULL,NULL),(16494,3011,'2086309','834','00','005010X220A1','2086309','','2014-01-24','08:18:21',0,'2014-01-24 21:00:37',NULL,NULL),(16791,3087,'1911819','834','00','005010X220A1','1911819','','2014-01-27','17:17:22',0,'2014-01-27 21:01:50',NULL,NULL),(19280,3582,'2915224','834','00','005010X220A1','2915224','','2014-02-13','13:17:12',0,'2014-02-13 22:00:58',NULL,NULL),(19308,3583,'3186916','834','00','005010X220A1','3186916','','2014-02-12','20:56:07',0,'2014-02-13 22:01:20',NULL,NULL),(20128,3772,'3499748','834','00','005010X220A1','3499748','','2014-02-19','14:18:29',0,'2014-02-20 03:56:38',NULL,NULL),(20426,3839,'3090424','834','00','005010X220A1','3090424','','2014-02-20','17:28:09',0,'2014-02-20 21:30:23',NULL,NULL),(20657,3877,'3307518','834','00','005010X220A1','3307518','','2014-02-21','10:35:00',0,'2014-02-21 22:00:57',NULL,NULL),(21041,3977,'3344442','834','00','005010X220A1','3344442','','2014-02-24','13:27:06',0,'2014-02-26 09:30:19',NULL,NULL),(23158,4344,'2685418','834','00','005010X220A1','2685418','','2014-03-06','22:42:55',0,'2014-03-07 21:31:16',NULL,NULL),(4593,826,'76030','834','00','005010X220A1','76030','','2013-12-23','23:24:13',0,'2013-12-25 23:47:03',NULL,NULL),(6286,1172,'1192276','834','00','005010X220A1','1192276','','2013-12-20','15:37:34',0,'2013-12-26 03:07:01',NULL,NULL),(6215,1168,'689706','834','00','005010X220A1','689706','','2013-12-20','09:05:27',0,'2013-12-26 03:04:45',NULL,NULL),(13488,2226,'2469699','834','00','005010X220A1','2469699','','2014-01-06','14:57:02',0,'2014-01-07 04:04:10',NULL,NULL),(5532,1041,'1531606','834','00','005010X220A1','1531606','','2013-12-24','23:18:42',0,'2013-12-26 01:47:26',NULL,NULL),(7372,1289,'384204','834','00','005010X220A1','384204','','2013-11-30','13:10:04',0,'2013-12-26 04:16:18',NULL,NULL),(12451,1639,'2079957','834','00','005010X220A1','2079957','','2013-12-30','20:15:51',1,'2014-01-02 04:31:32',NULL,NULL),(12394,1637,'2307679','834','00','005010X220A1','2307679','','2013-12-31','11:18:41',1,'2014-01-02 04:29:28',NULL,NULL),(11642,1498,'1878701','834','00','005010X220A1','1878701','','2013-12-27','16:38:27',0,'2013-12-28 03:36:00',NULL,NULL),(11511,1490,'2092737','834','00','005010X220A1','2092737','','2013-12-27','08:22:07',0,'2013-12-28 03:31:59',NULL,NULL),(15852,2738,'1666738','834','00','005010X220A1','1666738','','2014-01-21','11:27:57',1,'2014-01-22 03:22:10',NULL,NULL),(17180,3148,'2087424','834','00','005010X220A1','2087424','','2014-01-29','20:03:17',0,'2014-01-30 21:00:57',NULL,NULL),(17664,3258,'2809841','834','00','005010X220A1','2809841','','2014-02-04','13:02:05',0,'2014-02-04 21:00:07',NULL,NULL),(18036,3319,'2867741','834','00','005010X220A1','2867741','','2014-02-06','13:34:31',0,'2014-02-06 21:00:32',NULL,NULL),(18182,3351,'2567734','834','00','005010X220A1','2567734','','2014-02-07','09:15:56',0,'2014-02-07 19:00:22',NULL,NULL),(19616,3636,'2766191','834','00','005010X220A1','2766191','','2014-02-14','08:41:15',0,'2014-02-14 21:31:49',NULL,NULL),(20148,3776,'3641301','834','00','005010X220A1','3641301','','2014-02-18','20:59:49',0,'2014-02-20 04:03:10',NULL,NULL),(20238,3791,'2851497','834','00','005010X220A1','2851497','','2014-02-18','22:51:13',0,'2014-02-20 04:29:39',NULL,NULL),(20713,3894,'3020913','834','00','005010X220A1','3020913','','2014-02-24','21:12:28',0,'2014-02-25 21:00:20',NULL,NULL),(23520,4434,'3389786','834','00','005010X220A1','3389786','','2014-03-10','15:41:44',0,'2014-03-10 21:00:17',NULL,NULL),(4029,731,'7842','834','00','005010X220A1','7842','','2013-12-19','14:25:49',0,'2013-12-25 23:01:01',NULL,NULL),(6358,1180,'831116','834','00','005010X220A1','831116','','2013-12-20','14:50:23',0,'2013-12-26 03:09:07',NULL,NULL),(4855,885,'188104','834','00','005010X220A1','188104','','2013-11-20','22:04:25',0,'2013-12-26 00:15:45',NULL,NULL),(12743,1687,'1697855','834','00','005010X220A1','1697855','','2014-01-02','18:19:11',0,'2014-01-03 02:06:24',NULL,NULL),(4603,826,'1883542','834','00','005010X220A1','1883542','','2013-12-24','01:42:20',0,'2013-12-25 23:47:21',NULL,NULL),(14732,2550,'1755745','834','00','005010X220A1','1755745','','2014-01-14','14:32:20',0,'2014-01-15 02:06:16',NULL,NULL),(14876,2556,'2191453','834','00','005010X220A1','2191453','','2014-01-13','19:37:09',0,'2014-01-15 02:07:18',NULL,NULL),(14918,2559,'2080301','834','00','005010X220A1','2080301','','2014-01-13','20:17:42',0,'2014-01-15 02:07:37',NULL,NULL),(15151,2588,'1520008','834','00','005010X220A1','1520008','','2014-01-15','01:07:55',0,'2014-01-16 08:45:55',NULL,NULL),(16126,2818,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:43:00',1,'2014-01-23 03:47:58',NULL,NULL),(17953,3299,'1664710','834','00','005010X220A1','1664710','','2014-02-05','14:22:48',0,'2014-02-05 21:30:56',NULL,NULL),(17964,3300,'1811757','834','00','005010X220A1','1811757','','2014-02-05','13:23:56',0,'2014-02-05 21:31:02',NULL,NULL),(19965,3746,'2326994','834','00','005010X220A1','2326994','','2014-02-18','10:51:45',0,'2014-02-18 22:00:08',NULL,NULL),(20281,3796,'2592249','834','00','005010X220A1','2592249','','2014-02-19','08:31:05',0,'2014-02-20 04:38:07',NULL,NULL),(21141,3996,'2822463','834','00','005010X220A1','2822463','','2014-02-26','17:27:12',0,'2014-02-26 21:00:38',NULL,NULL),(21514,4034,'3025559','834','00','005010X220A1','3025559','','2014-02-26','21:59:52',0,'2014-02-28 06:31:28',NULL,NULL),(21725,4088,'3311576','834','00','005010X220A1','3311576','','2014-02-28','14:07:13',0,'2014-02-28 21:30:30',NULL,NULL),(348,72,'129405','834','00','005010X220A1','129405','','2013-12-04','10:56:36',0,'2013-12-25 17:46:44',NULL,NULL),(7569,1301,'1237086','834','00','005010X220A1','1237086','','2013-12-21','12:45:06',0,'2013-12-26 04:36:15',NULL,NULL),(10970,1411,'211884','834','00','005010X220A1','211884','','2013-12-22','19:38:16',0,'2013-12-26 13:09:44',NULL,NULL),(5233,955,'41560','834','00','005010X220A1','41560','','2013-12-11','15:20:52',0,'2013-12-26 00:53:29',NULL,NULL),(1271,243,'1149181','834','00','005010X220A1','1149181','','2013-12-24','15:21:25',0,'2013-12-25 18:49:51',NULL,NULL),(11975,1580,'1878768','834','00','005010X220A1','1878768','','2013-12-30','14:58:44',0,'2014-01-01 12:01:11',NULL,NULL),(12270,1623,'1742771','834','00','005010X220A1','1742771','','2014-01-01','10:40:54',1,'2014-01-02 04:24:13',NULL,NULL),(12690,1673,'2040706','834','00','005010X220A1','2040706','','2014-01-02','17:56:19',0,'2014-01-03 02:04:23',NULL,NULL),(13457,2225,'1710491','834','00','005010X220A1','1710491','','2014-01-06','13:07:49',0,'2014-01-07 04:03:03',NULL,NULL),(633,108,'780129','834','00','005010X220A1','780129','','2013-12-16','12:09:49',0,'2013-12-25 18:04:41',NULL,NULL),(13660,2271,'2172491','834','00','005010X220A1','2172491','','2014-01-07','09:09:52',0,'2014-01-08 18:24:14',NULL,NULL),(16304,2980,'2157426','834','00','005010X220A1','2157426','','2014-01-23','17:08:58',0,'2014-01-23 21:00:16',NULL,NULL),(16868,3093,'1897063','834','00','005010X220A1','1897063','','2014-01-28','13:48:22',0,'2014-01-28 21:00:52',NULL,NULL),(18514,3448,'1799320','834','00','005010X220A1','1799320','','2014-02-10','15:16:05',0,'2014-02-10 21:00:12',NULL,NULL),(19822,3679,'2950158','834','00','005010X220A1','2950158','','2014-02-15','14:43:10',0,'2014-02-15 22:01:40',NULL,NULL),(19908,3723,'3543327','834','00','005010X220A1','3543327','','2014-02-16','20:50:01',0,'2014-02-17 19:00:04',NULL,NULL),(20352,3812,'2121264','834','00','005010X220A1','2121264','','2014-02-19','14:28:39',0,'2014-02-20 04:55:10',NULL,NULL),(20547,3861,'3712066','834','00','005010X220A1','3712066','','2014-02-21','10:25:10',0,'2014-02-21 21:30:03',NULL,NULL),(20556,3862,'2415017','834','00','005010X220A1','2415017','','2014-02-21','15:09:18',0,'2014-02-21 21:30:08',NULL,NULL),(20898,3926,'3062944','834','00','005010X220A1','3062944','','2014-02-25','15:44:06',0,'2014-02-25 21:32:07',NULL,NULL),(21064,3980,'3097909','834','00','005010X220A1','3097909','','2014-02-23','23:27:18',0,'2014-02-26 09:30:38',NULL,NULL),(23291,4380,'3085260','834','00','005010X220A1','3085260','','2014-03-08','14:58:19',0,'2014-03-08 21:30:13',NULL,NULL),(23604,4440,'3778614','834','00','005010X220A1','3778614','','2014-03-09','23:38:45',0,'2014-03-10 21:01:20',NULL,NULL),(24,1,'1262648','834','00','005010X220A1','1262648','','2013-12-05','14:53:23',0,'2013-12-25 17:15:44',NULL,NULL),(6161,1167,'412082','834','00','005010X220A1','412082','','2013-12-20','00:24:37',0,'2013-12-26 03:03:10',NULL,NULL),(4129,733,'983129','834','00','005010X220A1','983129','','2013-12-19','14:44:57',0,'2013-12-25 23:04:04',NULL,NULL),(10697,1403,'1595868','834','00','005010X220A1','1595868','','2013-12-23','09:41:23',0,'2013-12-26 13:00:25',NULL,NULL),(11879,1560,'1505583','834','00','005010X220A1','1505583','','2013-12-29','12:36:54',0,'2013-12-30 00:00:20',NULL,NULL),(2578,473,'886756','834','00','005010X220A1','886756','','2013-11-01','12:35:27',0,'2013-12-25 20:45:15',NULL,NULL),(626,108,'890804','834','00','005010X220A1','890804','','2013-12-16','11:10:27',0,'2013-12-25 18:04:28',NULL,NULL),(177,16,'10053','834','00','005010X220A1','10053','','2013-12-05','13:03:46',0,'2013-12-25 17:20:29',NULL,NULL),(13469,2226,'1430154','834','00','005010X220A1','1430154','','2014-01-05','23:44:31',0,'2014-01-07 04:03:28',NULL,NULL),(14721,2550,'1404955','834','00','005010X220A1','1404955','','2014-01-14','11:43:45',0,'2014-01-15 02:06:11',NULL,NULL),(17408,3198,'1975320','834','00','005010X220A1','1975320','','2014-02-01','16:40:18',0,'2014-02-01 19:00:15',NULL,NULL),(17810,3273,'2832243','834','00','005010X220A1','2832243','','2014-02-04','11:15:42',0,'2014-02-04 21:01:39',NULL,NULL),(18202,3355,'2667704','834','00','005010X220A1','2667704','','2014-02-06','20:44:36',0,'2014-02-07 19:00:35',NULL,NULL),(18745,3485,'2783642','834','00','005010X220A1','2783642','','2014-02-11','13:12:04',0,'2014-02-11 21:00:34',NULL,NULL),(18820,3490,'2864035','834','00','005010X220A1','2864035','','2014-02-10','19:35:05',0,'2014-02-11 21:01:31',NULL,NULL),(19027,3539,'2692330','834','00','005010X220A1','2692330','','2014-02-12','16:27:08',0,'2014-02-12 21:30:44',NULL,NULL),(20790,3909,'2940465','834','00','005010X220A1','2940465','','2014-02-24','18:40:20',0,'2014-02-25 21:30:48',NULL,NULL),(22452,4232,'2949467','834','00','005010X220A1','2949467','','2014-03-04','12:53:30',0,'2014-03-04 21:30:17',NULL,NULL),(2159,362,'728661','834','00','005010X220A1','728661','','2013-12-01','20:32:31',0,'2013-12-25 19:46:45',NULL,NULL),(2232,372,'99818','834','00','005010X220A1','99818','','2013-12-02','17:14:07',0,'2013-12-25 19:49:16',NULL,NULL),(2293,396,'982461','834','00','005010X220A1','982461','','2013-11-24','16:23:11',0,'2013-12-25 20:00:56',NULL,NULL),(12821,1704,'1683334','834','00','005010X220A1','1683334','','2014-01-02','22:25:51',0,'2014-01-04 02:02:02',NULL,NULL),(2511,448,'1238639','834','00','005010X220A1','1238639','','2013-10-13','14:46:30',0,'2013-12-25 20:30:22',NULL,NULL),(2668,501,'979585','834','00','005010X220A1','979585','','2013-12-22','16:36:42',0,'2013-12-25 21:16:09',NULL,NULL),(11641,1498,'2168450','834','00','005010X220A1','2168450','','2013-12-27','12:30:11',0,'2013-12-28 03:35:59',NULL,NULL),(2888,529,'641746','834','00','005010X220A1','641746','','2013-12-22','11:38:47',0,'2013-12-25 21:23:17',NULL,NULL),(7246,1244,'819869','834','00','005010X220A1','819869','','2013-12-17','21:30:16',0,'2013-12-26 04:08:05',NULL,NULL),(6403,1194,'768789','834','00','005010X220A1','768789','','2013-12-20','15:18:28',0,'2013-12-26 03:10:34',NULL,NULL),(3341,587,'231933','834','00','005010X220A1','231933','','2013-12-16','19:41:07',0,'2013-12-25 21:49:53',NULL,NULL),(5874,1105,'158386','834','00','005010X220A1','158386','','2013-10-26','21:39:31',0,'2013-12-26 02:17:04',NULL,NULL),(5499,1041,'191807','834','00','005010X220A1','191807','','2013-12-24','19:29:14',0,'2013-12-26 01:46:23',NULL,NULL),(5122,942,'510147','834','00','005010X220A1','510147','','2013-12-11','14:02:01',0,'2013-12-26 00:49:57',NULL,NULL),(3866,692,'1013390','834','00','005010X220A1','1013390','','2013-10-10','01:07:48',0,'2013-12-25 22:31:06',NULL,NULL),(4644,827,'513350','834','00','005010X220A1','513350','','2013-12-24','00:19:06',0,'2013-12-25 23:48:41',NULL,NULL),(14899,2558,'2295512','834','00','005010X220A1','2295512','','2014-01-14','12:04:54',0,'2014-01-15 02:07:29',NULL,NULL),(15936,2754,'2233377','834','00','005010X220A1','2233377','','2014-01-21','17:12:57',1,'2014-01-22 03:23:04',NULL,NULL),(17197,3149,'2408285','834','00','005010X220A1','2408285','','2014-01-30','13:10:20',0,'2014-01-30 21:01:07',NULL,NULL),(17643,3248,'1631495','834','00','005010X220A1','1631495','','2014-02-03','11:41:24',0,'2014-02-03 21:01:25',NULL,NULL),(17882,3294,'2375441','834','00','005010X220A1','2375441','','2014-02-05','12:17:10',0,'2014-02-05 21:30:22',NULL,NULL),(19171,3559,'2458517','834','00','005010X220A1','2458517','','2014-02-12','10:49:14',0,'2014-02-12 21:32:25',NULL,NULL),(20688,3888,'3205213','834','00','005010X220A1','3205213','','2014-02-22','10:10:24',0,'2014-02-22 19:00:11',NULL,NULL),(22261,4200,'3001969','834','00','005010X220A1','3001969','','2014-03-04','11:04:19',0,'2014-03-04 21:00:29',NULL,NULL),(22677,4255,'2874650','834','00','005010X220A1','2874650','','2014-03-05','14:24:19',0,'2014-03-05 21:32:11',NULL,NULL),(22802,4278,'3565670','834','00','005010X220A1','3565670','','2014-03-05','19:06:37',0,'2014-03-06 21:01:05',NULL,NULL),(23011,4323,'3023722','834','00','005010X220A1','3023722','','2014-03-07','09:02:33',0,'2014-03-07 21:00:16',NULL,NULL),(23559,4436,'3010614','834','00','005010X220A1','3010614','','2014-03-09','22:37:17',0,'2014-03-10 21:00:47',NULL,NULL),(398,76,'525478','834','00','005010X220A1','525478','','2013-12-03','21:20:10',0,'2013-12-25 17:48:19',NULL,NULL),(12400,1637,'1661665','834','00','005010X220A1','1661665','','2013-12-31','12:18:08',1,'2014-01-02 04:29:41',NULL,NULL),(1738,293,'799408','834','00','005010X220A1','799408','','2013-12-10','13:00:37',0,'2013-12-25 19:17:38',NULL,NULL),(11738,1520,'2187265','834','00','005010X220A1','2187265','','2013-12-28','09:11:18',1,'2013-12-29 11:09:03',NULL,NULL),(2486,436,'839910','834','00','005010X220A1','839910','','2013-12-06','12:59:07',0,'2013-12-25 20:20:04',NULL,NULL),(2604,484,'1178795','834','00','005010X220A1','1178795','','2013-10-06','06:16:13',0,'2013-12-25 20:46:07',NULL,NULL),(7079,1236,'662348','834','00','005010X220A1','662348','','2013-12-18','09:50:05',0,'2013-12-26 04:02:58',NULL,NULL),(3674,629,'620660','834','00','005010X220A1','620660','','2013-12-11','22:41:12',0,'2013-12-25 22:06:40',NULL,NULL),(5516,1041,'1829840','834','00','005010X220A1','1829840','','2013-12-24','20:52:59',0,'2013-12-26 01:46:54',NULL,NULL),(14795,2551,'1856439','834','00','005010X220A1','1856439','','2014-01-14','17:00:40',0,'2014-01-15 02:06:43',NULL,NULL),(14868,2555,'1988320','834','00','005010X220A1','1988320','','2014-01-13','23:33:09',0,'2014-01-15 02:07:14',NULL,NULL),(15685,2695,'2118380','834','00','005010X220A1','2118380','','2014-01-19','14:45:17',0,'2014-01-21 08:45:16',NULL,NULL),(17902,3295,'2779966','834','00','005010X220A1','2779966','','2014-02-05','13:21:05',0,'2014-02-05 21:30:32',NULL,NULL),(18692,3475,'2972580','834','00','005010X220A1','2972580','','2014-02-10','12:17:43',0,'2014-02-10 21:32:08',NULL,NULL),(20014,3750,'3297641','834','00','005010X220A1','3297641','','2014-02-18','08:26:25',0,'2014-02-18 22:00:43',NULL,NULL),(896,177,'51896','834','00','005010X220A1','51896','','2013-12-03','13:47:10',0,'2013-12-25 18:17:00',NULL,NULL),(13665,2271,'1411159','834','00','005010X220A1','1411159','','2014-01-07','11:38:36',0,'2014-01-08 18:24:16',NULL,NULL),(13573,2254,'2049541','834','00','005010X220A1','2049541','','2014-01-05','15:46:22',1,'2014-01-07 10:21:42',NULL,NULL),(13288,2132,'0001','999','BE','005010X231A1','1174662','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:38',NULL,NULL),(1166,239,'1436093','834','00','005010X220A1','1436093','','2013-12-24','12:33:00',0,'2013-12-25 18:46:41',NULL,NULL),(1847,324,'1160685','834','00','005010X220A1','1160685','','2013-12-08','18:46:00',0,'2013-12-25 19:30:04',NULL,NULL),(2381,414,'1068246','834','00','005010X220A1','1068246','','2013-12-06','14:06:14',0,'2013-12-25 20:16:39',NULL,NULL),(2433,418,'1192838','834','00','005010X220A1','1192838','','2013-12-05','19:34:14',0,'2013-12-25 20:18:16',NULL,NULL),(5865,1101,'883521','834','00','005010X220A1','883521','','2013-10-28','17:27:36',0,'2013-12-26 02:16:43',NULL,NULL),(4823,876,'1028291','834','00','005010X220A1','1028291','','2013-12-01','17:19:20',0,'2013-12-26 00:02:33',NULL,NULL),(4336,755,'837628','834','00','005010X220A1','837628','','2013-12-19','15:55:34',0,'2013-12-25 23:10:19',NULL,NULL),(20857,3911,'3649390','834','00','005010X220A1','3649390','','2014-02-25','16:37:55',0,'2014-02-25 21:31:36',NULL,NULL),(2697,502,'763989','834','00','005010X220A1','763989','','2013-12-22','14:13:04',0,'2013-12-25 21:17:06',NULL,NULL),(2847,511,'211878','834','00','005010X220A1','211878','','2013-12-22','18:23:33',0,'2013-12-25 21:21:55',NULL,NULL),(3892,705,'96909','834','00','005010X220A1','96909','','2013-10-25','18:55:49',0,'2013-12-25 22:31:58',NULL,NULL),(14426,2447,'0001','999','BE','005010X231A1','802181','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:37',NULL,NULL),(14534,2518,'1854083','834','00','005010X220A1','1854083','','2014-01-13','11:39:45',0,'2014-01-14 01:32:25',NULL,NULL),(14860,2553,'1627261','834','00','005010X220A1','1627261','','2014-01-14','18:34:19',0,'2014-01-15 02:07:10',NULL,NULL),(15079,2585,'1539670','834','00','005010X220A1','1539670','','2014-01-15','11:02:28',0,'2014-01-16 08:45:07',NULL,NULL),(15767,2714,'2573866','834','00','005010X220A1','2573866','','2014-01-20','13:26:12',0,'2014-01-21 08:46:27',NULL,NULL),(22877,4281,'3663837','834','00','005010X220A1','3663837','','2014-03-06','15:17:24',0,'2014-03-06 21:01:59',NULL,NULL),(17199,3149,'1412954','834','00','005010X220A1','1412954','','2014-01-30','13:35:02',0,'2014-01-30 21:01:08',NULL,NULL),(17324,3174,'1861734','834','00','005010X220A1','1861734','','2014-01-31','16:12:03',0,'2014-01-31 21:00:57',NULL,NULL),(19967,3746,'3498511','834','00','005010X220A1','3498511','','2014-02-18','11:52:29',0,'2014-02-18 22:00:09',NULL,NULL),(922,178,'17884','834','00','005010X220A1','17884','','2013-12-02','21:58:24',0,'2013-12-25 18:17:45',NULL,NULL),(938,181,'188215','834','00','005010X220A1','188215','','2013-12-03','10:00:41',0,'2013-12-25 18:18:17',NULL,NULL),(13857,2311,'1901468','834','00','005010X220A1','1901468','','2014-01-09','18:12:15',0,'2014-01-13 02:19:17',NULL,NULL),(12608,1671,'2332255','834','00','005010X220A1','2332255','','2014-01-01','21:52:40',0,'2014-01-03 02:01:22',NULL,NULL),(1720,293,'392270','834','00','005010X220A1','392270','','2013-12-09','20:26:22',0,'2013-12-25 19:17:06',NULL,NULL),(2195,364,'773078','834','00','005010X220A1','773078','','2013-12-02','13:37:36',0,'2013-12-25 19:48:00',NULL,NULL),(3418,592,'580517','834','00','005010X220A1','580517','','2013-12-17','17:01:16',0,'2013-12-25 21:52:16',NULL,NULL),(11567,1492,'1109953','834','00','005010X220A1','1109953','','2013-12-27','14:02:44',0,'2013-12-28 03:33:43',NULL,NULL),(3447,605,'840215','834','00','005010X220A1','840215','','2013-12-17','12:51:31',0,'2013-12-25 21:53:14',NULL,NULL),(4953,924,'1127023','834','00','005010X220A1','1127023','','2013-11-18','19:46:43',0,'2013-12-26 00:31:55',NULL,NULL),(6997,1235,'538483','834','00','005010X220A1','538483','','2013-12-17','19:47:55',0,'2013-12-26 04:00:22',NULL,NULL),(23136,4342,'2685439','834','00','005010X220A1','2685439','','2014-03-07','13:23:58',0,'2014-03-07 21:31:00',NULL,NULL),(15013,2584,'2495123','834','00','005010X220A1','2495123','','2014-01-15','12:47:29',0,'2014-01-16 08:44:26',NULL,NULL),(16712,3064,'2114874','834','00','005010X220A1','2114874','','2014-01-27','12:02:43',0,'2014-01-27 21:00:51',NULL,NULL),(18594,3455,'2875202','834','00','005010X220A1','2875202','','2014-02-10','13:02:53',0,'2014-02-10 21:30:59',NULL,NULL),(18709,3485,'3079361','834','00','005010X220A1','3079361','','2014-02-10','18:51:40',0,'2014-02-11 21:00:06',NULL,NULL),(20758,3905,'3101811','834','00','005010X220A1','3101811','','2014-02-24','18:08:44',0,'2014-02-25 21:30:26',NULL,NULL),(23168,4344,'3232591','834','00','005010X220A1','3232591','','2014-03-07','14:57:32',0,'2014-03-07 21:31:23',NULL,NULL),(957,181,'20452','834','00','005010X220A1','20452','','2013-12-03','14:25:01',0,'2013-12-25 18:18:51',NULL,NULL),(14057,2339,'2565953','834','00','005010X220A1','2565953','','2014-01-08','10:25:49',0,'2014-01-13 02:21:41',NULL,NULL),(13699,2274,'2477866','834','00','005010X220A1','2477866','','2014-01-06','20:07:00',0,'2014-01-08 18:24:29',NULL,NULL),(2062,338,'679827','834','00','005010X220A1','679827','','2013-12-09','14:02:38',0,'2013-12-25 19:36:51',NULL,NULL),(11955,1580,'1536518','834','00','005010X220A1','1536518','','2013-12-30','08:02:39',0,'2014-01-01 12:00:23',NULL,NULL),(2935,541,'508969','834','00','005010X220A1','508969','','2013-12-12','20:52:45',0,'2013-12-25 21:31:05',NULL,NULL),(10629,1402,'120276','834','00','005010X220A1','120276','','2013-12-23','16:17:39',0,'2013-12-26 12:58:07',NULL,NULL),(10538,1401,'1726038','834','00','005010X220A1','1726038','','2013-12-23','18:12:07',0,'2013-12-26 12:55:05',NULL,NULL),(3175,565,'655685','834','00','005010X220A1','655685','','2013-12-13','13:38:46',0,'2013-12-25 21:38:38',NULL,NULL),(3230,578,'936817','834','00','005010X220A1','936817','','2013-12-17','12:28:03',0,'2013-12-25 21:46:14',NULL,NULL),(3663,626,'1060613','834','00','005010X220A1','1060613','','2013-12-12','12:58:21',0,'2013-12-25 22:06:19',NULL,NULL),(15821,2735,'1988523','834','00','005010X220A1','1988523','','2014-01-20','17:58:00',0,'2014-01-21 08:47:01',NULL,NULL),(16055,2772,'2147303','834','00','005010X220A1','2147303','','2014-01-22','17:27:22',0,'2014-01-23 03:02:38',NULL,NULL),(17353,3181,'2046023','834','00','005010X220A1','2046023','','2014-01-31','12:57:13',0,'2014-01-31 21:01:19',NULL,NULL),(18640,3463,'1661143','834','00','005010X220A1','1661143','','2014-02-09','23:03:45',0,'2014-02-10 21:31:32',NULL,NULL),(20521,3849,'3164079','834','00','005010X220A1','3164079','','2014-02-20','12:06:35',0,'2014-02-20 22:01:21',NULL,NULL),(21987,4145,'2709044','834','00','005010X220A1','2709044','','2014-03-02','08:22:33',0,'2014-03-03 01:00:16',NULL,NULL),(23490,4430,'3475622','834','00','005010X220A1','3475622','','2014-03-09','17:40:48',0,'2014-03-09 21:30:04',NULL,NULL),(4441,800,'161782','834','00','005010X220A1','161782','','2013-11-25','19:38:47',0,'2013-12-25 23:30:06',NULL,NULL),(4822,875,'577343','834','00','005010X220A1','577343','','2013-12-01','14:38:46',0,'2013-12-26 00:02:32',NULL,NULL),(6414,1200,'1018032','834','00','005010X220A1','1018032','','2013-12-20','17:16:14',0,'2013-12-26 03:11:01',NULL,NULL),(7435,1295,'1248180','834','00','005010X220A1','1248180','','2013-12-21','15:02:48',0,'2013-12-26 04:31:59',NULL,NULL),(2070,341,'745274','834','00','005010X220A1','745274','','2013-12-09','11:02:45',0,'2013-12-25 19:37:05',NULL,NULL),(1653,287,'34946','834','00','005010X220A1','34946','','2013-11-20','15:10:06',0,'2013-12-25 19:02:35',NULL,NULL),(12782,1703,'1975672','834','00','005010X220A1','1975672','','2014-01-02','19:52:56',0,'2014-01-04 02:00:35',NULL,NULL),(13104,1948,'0001','999','BE','005010X231A1','501228','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:49',NULL,NULL),(15046,2584,'2249724','834','00','005010X220A1','2249724','','2014-01-15','18:09:01',0,'2014-01-16 08:44:47',NULL,NULL),(15174,2591,'1890309','834','00','005010X220A1','1890309','','2014-01-15','10:24:52',0,'2014-01-16 08:46:10',NULL,NULL),(15204,2592,'1835883','834','00','005010X220A1','1835883','','2014-01-15','11:56:50',0,'2014-01-16 08:46:27',NULL,NULL),(15249,2599,'1837056','834','00','005010X220A1','1837056','','2014-01-15','11:37:35',0,'2014-01-16 08:46:56',NULL,NULL),(15257,2601,'1597836','834','00','005010X220A1','1597836','','2014-01-14','23:38:13',0,'2014-01-16 08:47:02',NULL,NULL),(16109,2801,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:43:30',NULL,NULL),(17897,3295,'2488049','834','00','005010X220A1','2488049','','2014-02-05','10:42:07',0,'2014-02-05 21:30:29',NULL,NULL),(18954,3531,'1939175','834','00','005010X220A1','1939175','','2014-02-11','19:39:54',0,'2014-02-12 21:00:07',NULL,NULL),(19382,3591,'2736210','834','00','005010X220A1','2736210','','2014-02-13','14:38:11',0,'2014-02-13 22:02:16',NULL,NULL),(19521,3622,'2882234','834','00','005010X220A1','2882234','','2014-02-14','11:08:09',0,'2014-02-14 21:30:40',NULL,NULL),(532,102,'612043','834','00','005010X220A1','612043','','2013-12-16','15:38:38',0,'2013-12-25 18:01:25',NULL,NULL),(7393,1293,'279452','834','00','005010X220A1','279452','','2013-12-21','16:38:21',0,'2013-12-26 04:30:38',NULL,NULL),(6238,1169,'455547','834','00','005010X220A1','455547','','2013-12-19','19:29:01',0,'2013-12-26 03:05:32',NULL,NULL),(5459,1040,'2088762','834','00','005010X220A1','2088762','','2013-12-24','18:55:00',0,'2013-12-26 01:45:07',NULL,NULL),(2513,448,'871971','834','00','005010X220A1','871971','','2013-10-13','14:48:55',0,'2013-12-25 20:30:25',NULL,NULL),(2108,360,'170513','834','00','005010X220A1','170513','','2013-12-01','19:51:52',0,'2013-12-25 19:45:10',NULL,NULL),(2064,339,'818187','834','00','005010X220A1','818187','','2013-12-09','09:05:45',0,'2013-12-25 19:36:54',NULL,NULL),(13856,2311,'2356443','834','00','005010X220A1','2356443','','2014-01-09','16:51:12',0,'2014-01-13 02:19:16',NULL,NULL),(13918,2313,'1777082','834','00','005010X220A1','1777082','','2014-01-09','15:10:59',0,'2014-01-13 02:19:56',NULL,NULL),(14678,2548,'2026615','834','00','005010X220A1','2026615','','2014-01-14','14:09:28',0,'2014-01-15 02:05:52',NULL,NULL),(15887,2740,'1543775','834','00','005010X220A1','1543775','','2014-01-21','13:35:00',1,'2014-01-22 03:22:32',NULL,NULL),(16383,2987,'2564962','834','00','005010X220A1','2564962','','2014-01-22','21:44:30',0,'2014-01-23 21:01:12',NULL,NULL),(16473,3008,'2056539','834','00','005010X220A1','2056539','','2014-01-24','12:38:34',0,'2014-01-24 21:00:25',NULL,NULL),(18601,3456,'1990113','834','00','005010X220A1','1990113','','2014-02-10','09:30:08',0,'2014-02-10 21:31:04',NULL,NULL),(23464,4414,'3374027','834','00','005010X220A1','3374027','','2014-03-09','11:03:34',0,'2014-03-09 21:01:04',NULL,NULL),(109,6,'1075197','834','00','005010X220A1','1075197','','2013-12-04','18:53:30',0,'2013-12-25 17:18:18',NULL,NULL),(7380,1293,'785729','834','00','005010X220A1','785729','','2013-12-20','20:01:55',0,'2013-12-26 04:30:10',NULL,NULL),(12286,1624,'2555540','834','00','005010X220A1','2555540','','2014-01-01','02:09:24',1,'2014-01-02 04:24:46',NULL,NULL),(6232,1168,'1295369','834','00','005010X220A1','1295369','','2013-12-20','17:26:25',0,'2013-12-26 03:05:20',NULL,NULL),(5036,935,'212759','834','00','005010X220A1','212759','','2013-12-11','14:43:30',0,'2013-12-26 00:47:08',NULL,NULL),(12012,1583,'1954006','834','00','005010X220A1','1954006','','2013-12-30','07:32:09',0,'2014-01-01 12:02:33',NULL,NULL),(11971,1580,'1556500','834','00','005010X220A1','1556500','','2013-12-30','13:44:16',0,'2014-01-01 12:01:00',NULL,NULL),(11920,1565,'2394981','834','00','005010X220A1','2394981','','2013-12-29','12:35:58',0,'2013-12-30 00:01:36',NULL,NULL),(11897,1561,'1585532','834','00','005010X220A1','1585532','','2013-12-29','12:05:25',0,'2013-12-30 00:00:54',NULL,NULL),(14815,2552,'2292641','834','00','005010X220A1','2292641','','2014-01-14','12:21:33',0,'2014-01-15 02:06:51',NULL,NULL),(16353,2983,'2069510','834','00','005010X220A1','2069510','','2014-01-23','15:22:05',0,'2014-01-23 21:00:50',NULL,NULL),(17047,3122,'2446902','834','00','005010X220A1','2446902','','2014-01-29','15:11:50',0,'2014-01-29 21:01:24',NULL,NULL),(17147,3144,'2237243','834','00','005010X220A1','2237243','','2014-01-30','13:47:29',0,'2014-01-30 21:00:35',NULL,NULL),(17655,3254,'2534175','834','00','005010X220A1','2534175','','2014-02-03','16:59:23',0,'2014-02-03 21:01:34',NULL,NULL),(18552,3452,'1583864','834','00','005010X220A1','1583864','','2014-02-10','13:58:00',0,'2014-02-10 21:30:30',NULL,NULL),(18732,3485,'3078181','834','00','005010X220A1','3078181','','2014-02-11','11:00:25',0,'2014-02-11 21:00:25',NULL,NULL),(20794,3909,'2762808','834','00','005010X220A1','2762808','','2014-02-24','22:53:56',0,'2014-02-25 21:30:51',NULL,NULL),(21672,4079,'3015769','834','00','005010X220A1','3015769','','2014-02-28','10:43:35',0,'2014-02-28 21:00:15',NULL,NULL),(22365,4205,'3136837','834','00','005010X220A1','3136837','','2014-03-04','15:15:14',0,'2014-03-04 21:01:50',NULL,NULL),(22702,4263,'3314177','834','00','005010X220A1','3314177','','2014-03-05','10:55:01',0,'2014-03-05 21:32:29',NULL,NULL),(23004,4322,'3352870','834','00','005010X220A1','3352870','','2014-03-07','15:24:22',0,'2014-03-07 21:00:13',NULL,NULL),(23506,4434,'3486776','834','00','005010X220A1','3486776','','2014-03-10','11:41:00',0,'2014-03-10 21:00:07',NULL,NULL),(5282,978,'908074','834','00','005010X220A1','908074','','2013-11-16','12:52:37',0,'2013-12-26 01:00:48',NULL,NULL),(6998,1235,'136696','834','00','005010X220A1','136696','','2013-12-17','20:00:14',0,'2013-12-26 04:00:24',NULL,NULL),(10898,1409,'1536168','834','00','005010X220A1','1536168','','2013-12-23','08:49:36',0,'2013-12-26 13:07:34',NULL,NULL),(7515,1300,'1238170','834','00','005010X220A1','1238170','','2013-12-21','11:31:02',0,'2013-12-26 04:34:30',NULL,NULL),(5321,998,'965237','834','00','005010X220A1','965237','','2013-11-05','12:49:26',0,'2013-12-26 01:02:15',NULL,NULL),(13803,2294,'2286092','834','00','005010X220A1','2286092','','2014-01-11','17:14:25',0,'2014-01-13 02:18:16',NULL,NULL),(15646,2680,'2057694','834','00','005010X220A1','2057694','','2014-01-17','19:50:50',0,'2014-01-21 08:44:21',NULL,NULL),(15892,2740,'2377753','834','00','005010X220A1','2377753','','2014-01-21','17:24:37',1,'2014-01-22 03:22:35',NULL,NULL),(16140,2832,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:22:00',1,'2014-01-23 03:54:51',NULL,NULL),(17410,3199,'2286608','834','00','005010X220A1','2286608','','2014-01-31','18:53:44',0,'2014-02-01 19:00:16',NULL,NULL),(20097,3767,'3176531','834','00','005010X220A1','3176531','','2014-02-18','14:03:14',0,'2014-02-18 22:01:43',NULL,NULL),(22403,4214,'3024612','834','00','005010X220A1','3024612','','2014-03-04','12:12:51',0,'2014-03-04 21:02:23',NULL,NULL),(334,72,'612920','834','00','005010X220A1','612920','','2013-12-04','12:09:31',0,'2013-12-25 17:46:16',NULL,NULL),(1159,239,'1547082','834','00','005010X220A1','1547082','','2013-12-24','12:00:03',0,'2013-12-25 18:46:27',NULL,NULL),(11772,1528,'2322268','834','00','005010X220A1','2322268','','2013-12-28','11:45:34',1,'2013-12-29 11:10:04',NULL,NULL),(11805,1539,'1235851','834','00','005010X220A1','1235851','','2013-12-28','20:08:29',1,'2013-12-29 11:13:14',NULL,NULL),(12124,1587,'1813369','834','00','005010X220A1','1813369','','2013-12-30','15:40:00',0,'2014-01-01 12:06:34',NULL,NULL),(7634,1309,'358299','834','00','005010X220A1','358299','','2013-12-21','09:06:43',0,'2013-12-26 04:38:20',NULL,NULL),(7271,1251,'901300','834','00','005010X220A1','901300','','2013-12-18','11:39:08',0,'2013-12-26 04:08:50',NULL,NULL),(1883,325,'1257488','834','00','005010X220A1','1257488','','2013-12-09','07:17:27',0,'2013-12-25 19:31:19',NULL,NULL),(6444,1208,'961683','834','00','005010X220A1','961683','','2013-11-22','07:07:40',0,'2013-12-26 03:15:54',NULL,NULL),(6083,1166,'649355','834','00','005010X220A1','649355','','2013-12-19','19:34:04',0,'2013-12-26 03:00:48',NULL,NULL),(6042,1152,'234762','834','00','005010X220A1','234762','','2013-10-13','22:35:40',0,'2013-12-26 02:46:18',NULL,NULL),(5748,1070,'752830','834','00','005010X220A1','752830','','2013-12-14','15:33:30',0,'2013-12-26 02:01:49',NULL,NULL),(4808,865,'318898','834','00','005010X220A1','318898','','2013-12-01','12:38:22',0,'2013-12-26 00:02:06',NULL,NULL),(2708,502,'592639','834','00','005010X220A1','592639','','2013-12-22','17:15:17',0,'2013-12-25 21:17:27',NULL,NULL),(2919,541,'1127444','834','00','005010X220A1','1127444','','2013-12-12','18:34:11',0,'2013-12-25 21:30:32',NULL,NULL),(14062,2339,'1514851','834','00','005010X220A1','1514851','','2014-01-08','11:10:40',0,'2014-01-13 02:21:44',NULL,NULL),(15890,2740,'2437675','834','00','005010X220A1','2437675','','2014-01-21','17:01:19',1,'2014-01-22 03:22:34',NULL,NULL),(16852,3092,'1429229','834','00','005010X220A1','1429229','','2014-01-28','17:52:45',0,'2014-01-28 21:00:41',NULL,NULL),(18870,3493,'2293294','834','00','005010X220A1','2293294','','2014-02-11','13:53:26',0,'2014-02-11 21:02:09',NULL,NULL),(19369,3590,'3111389','834','00','005010X220A1','3111389','','2014-02-13','08:23:48',0,'2014-02-13 22:02:07',NULL,NULL),(20200,3782,'2607115','834','00','005010X220A1','2607115','','2014-02-19','09:46:47',0,'2014-02-20 04:18:11',NULL,NULL),(20637,3874,'3571604','834','00','005010X220A1','3571604','','2014-02-21','11:49:31',0,'2014-02-21 22:00:43',NULL,NULL),(22679,4255,'2886323','834','00','005010X220A1','2886323','','2014-03-05','14:36:08',0,'2014-03-05 21:32:12',NULL,NULL),(105,4,'758551','834','00','005010X220A1','758551','','2013-12-05','15:55:19',0,'2013-12-25 17:18:10',NULL,NULL),(3792,658,'1208943','834','00','005010X220A1','1208943','','2013-12-08','10:02:27',0,'2013-12-25 22:16:02',NULL,NULL),(3688,631,'1085838','834','00','005010X220A1','1085838','','2013-12-12','16:25:24',0,'2013-12-25 22:07:06',NULL,NULL),(5045,936,'420143','834','00','005010X220A1','420143','','2013-12-10','18:46:22',0,'2013-12-26 00:47:24',NULL,NULL),(5849,1093,'1272404','834','00','005010X220A1','1272404','','2013-11-23','09:50:34',0,'2013-12-26 02:16:06',NULL,NULL),(2319,407,'149853','834','00','005010X220A1','149853','','2013-10-21','18:33:36',0,'2013-12-25 20:01:53',NULL,NULL),(7328,1273,'440096','834','00','005010X220A1','440096','','2013-12-18','15:14:48',0,'2013-12-26 04:10:34',NULL,NULL),(748,134,'363280','834','00','005010X220A1','363280','','2013-12-16','14:52:36',0,'2013-12-25 18:08:16',NULL,NULL),(13982,2325,'1903732','834','00','005010X220A1','1903732','','2014-01-09','10:38:17',0,'2014-01-13 02:20:44',NULL,NULL),(15826,2736,'2321761','834','00','005010X220A1','2321761','','2014-01-20','21:09:09',1,'2014-01-22 03:21:53',NULL,NULL),(17153,3144,'1460164','834','00','005010X220A1','1460164','','2014-01-30','15:47:34',0,'2014-01-30 21:00:39',NULL,NULL),(18174,3350,'2806593','834','00','005010X220A1','2806593','','2014-02-07','17:22:07',0,'2014-02-07 19:00:17',NULL,NULL),(18694,3475,'2702858','834','00','005010X220A1','2702858','','2014-02-10','14:45:58',0,'2014-02-10 21:32:09',NULL,NULL),(18855,3491,'2776516','834','00','005010X220A1','2776516','','2014-02-11','15:26:37',0,'2014-02-11 21:01:57',NULL,NULL),(21679,4080,'3249728','834','00','005010X220A1','3249728','','2014-02-28','12:04:05',0,'2014-02-28 21:00:20',NULL,NULL),(22530,4247,'2884032','834','00','005010X220A1','2884032','','2014-03-05','16:16:06',0,'2014-03-05 21:30:27',NULL,NULL),(22797,4278,'2751187','834','00','005010X220A1','2751187','','2014-03-05','18:14:28',0,'2014-03-06 21:01:03',NULL,NULL),(1361,245,'1464504','834','00','005010X220A1','1464504','','2013-12-24','14:59:18',0,'2013-12-25 18:52:47',NULL,NULL),(7478,1296,'231134','834','00','005010X220A1','231134','','2013-12-21','16:53:01',0,'2013-12-26 04:33:14',NULL,NULL),(6091,1166,'342431','834','00','005010X220A1','342431','','2013-12-19','21:27:45',0,'2013-12-26 03:01:03',NULL,NULL),(5840,1092,'972564','834','00','005010X220A1','972564','','2013-11-23','15:44:29',0,'2013-12-26 02:15:45',NULL,NULL),(5280,977,'541842','834','00','005010X220A1','541842','','2013-11-16','11:24:59',0,'2013-12-26 01:00:44',NULL,NULL),(11287,1455,'529006','834','00','005010X220A1','529006','','2013-12-26','14:51:00',0,'2013-12-27 02:03:07',NULL,NULL),(4115,733,'985690','834','00','005010X220A1','985690','','2013-12-19','13:30:44',0,'2013-12-25 23:03:39',NULL,NULL),(13327,2171,'0001','999','BE','005010X231A1','1194379','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:27',NULL,NULL),(15000,2584,'1411397','834','00','005010X220A1','1411397','','2014-01-14','21:49:23',0,'2014-01-16 08:44:17',NULL,NULL),(16266,2958,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',0,'2014-01-23 09:28:28',NULL,NULL),(18526,3451,'2716083','834','00','005010X220A1','2716083','','2014-02-10','12:10:49',0,'2014-02-10 21:30:12',NULL,NULL),(20779,3907,'3077460','834','00','005010X220A1','3077460','','2014-02-25','14:34:22',0,'2014-02-25 21:30:41',NULL,NULL),(21352,4022,'2800764','834','00','005010X220A1','2800764','','2014-02-27','17:19:16',0,'2014-02-28 06:30:13',NULL,NULL),(43,2,'317746','834','00','005010X220A1','317746','','2013-12-05','15:25:14',0,'2013-12-25 17:16:17',NULL,NULL),(5475,1040,'2009767','834','00','005010X220A1','2009767','','2013-12-24','22:33:30',0,'2013-12-26 01:45:35',NULL,NULL),(5829,1089,'1279250','834','00','005010X220A1','1279250','','2013-11-22','19:57:21',0,'2013-12-26 02:15:22',NULL,NULL),(6208,1168,'1048675','834','00','005010X220A1','1048675','','2013-12-19','21:54:30',0,'2013-12-26 03:04:32',NULL,NULL),(10726,1403,'511787','834','00','005010X220A1','511787','','2013-12-23','14:27:06',0,'2013-12-26 13:01:29',NULL,NULL),(10747,1403,'1418467','834','00','005010X220A1','1418467','','2013-12-23','17:17:09',0,'2013-12-26 13:02:07',NULL,NULL),(11219,1454,'1572696','834','00','005010X220A1','1572696','','2013-12-26','10:18:43',0,'2013-12-27 02:01:03',NULL,NULL),(11374,1460,'2044029','834','00','005010X220A1','2044029','','2013-12-26','12:20:22',0,'2013-12-27 02:05:46',NULL,NULL),(11599,1493,'836614','834','00','005010X220A1','836614','','2013-12-27','11:12:41',0,'2013-12-28 03:34:41',NULL,NULL),(3713,633,'753743','834','00','005010X220A1','753743','','2013-12-12','18:11:31',0,'2013-12-25 22:07:58',NULL,NULL),(12148,1591,'2213786','834','00','005010X220A1','2213786','','2013-12-30','11:07:27',0,'2014-01-01 12:07:22',NULL,NULL),(1764,296,'727521','834','00','005010X220A1','727521','','2013-12-10','10:54:00',0,'2013-12-25 19:18:24',NULL,NULL),(1342,245,'1684546','834','00','005010X220A1','1684546','','2013-12-24','12:56:19',0,'2013-12-25 18:52:08',NULL,NULL),(1335,245,'1395423','834','00','005010X220A1','1395423','','2013-12-24','12:20:56',0,'2013-12-25 18:51:55',NULL,NULL),(14427,2448,'0001','999','BE','005010X231A1','140799','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:38',NULL,NULL),(16015,2767,'1811459','834','00','005010X220A1','1811459','','2014-01-22','14:24:09',0,'2014-01-23 03:02:20',NULL,NULL),(16372,2986,'1673214','834','00','005010X220A1','1673214','','2014-01-23','16:41:42',0,'2014-01-23 21:01:04',NULL,NULL),(16600,3047,'1834819','834','00','005010X220A1','1834819','','2014-01-26','11:02:07',0,'2014-01-26 19:00:03',NULL,NULL),(17619,3243,'2269836','834','00','005010X220A1','2269836','','2014-02-03','13:10:24',0,'2014-02-03 21:01:10',NULL,NULL),(18915,3513,'2978846','834','00','005010X220A1','2978846','','2014-02-11','15:44:01',0,'2014-02-11 21:02:50',NULL,NULL),(20458,3842,'3645458','834','00','005010X220A1','3645458','','2014-02-20','08:39:11',0,'2014-02-20 22:00:29',NULL,NULL),(21340,4022,'2792733','834','00','005010X220A1','2792733','','2014-02-27','04:51:58',0,'2014-02-28 06:30:07',NULL,NULL),(23761,4477,'2820328','834','00','005010X220A1','2820328','','2014-03-10','15:51:02',0,'2014-03-10 21:30:11',NULL,NULL),(805,155,'133226','834','00','005010X220A1','133226','','2013-10-29','10:09:06',0,'2013-12-25 18:10:21',NULL,NULL),(13758,2277,'1591595','834','00','005010X220A1','1591595','','2014-01-06','20:03:37',0,'2014-01-08 18:24:55',NULL,NULL),(5899,1110,'814524','834','00','005010X220A1','814524','','2013-12-15','12:34:49',0,'2013-12-26 02:30:43',NULL,NULL),(5757,1072,'1159780','834','00','005010X220A1','1159780','','2013-12-13','20:49:00',0,'2013-12-26 02:02:08',NULL,NULL),(3770,654,'1090683','834','00','005010X220A1','1090683','','2013-12-08','16:33:45',0,'2013-12-25 22:15:19',NULL,NULL),(7132,1236,'1151243','834','00','005010X220A1','1151243','','2013-12-18','17:08:27',0,'2013-12-26 04:04:33',NULL,NULL),(10532,1401,'271521','834','00','005010X220A1','271521','','2013-12-23','13:31:06',0,'2013-12-26 12:54:53',NULL,NULL),(3504,615,'1183393','834','00','005010X220A1','1183393','','2013-12-12','14:43:05',0,'2013-12-25 22:01:20',NULL,NULL),(3074,545,'326750','834','00','005010X220A1','326750','','2013-12-12','21:53:07',0,'2013-12-25 21:35:24',NULL,NULL),(1794,303,'595804','834','00','005010X220A1','595804','','2013-12-09','21:33:24',0,'2013-12-25 19:19:26',NULL,NULL),(1112,237,'1121596','834','00','005010X220A1','1121596','','2013-10-09','13:14:25',0,'2013-12-25 18:32:29',NULL,NULL),(12658,1672,'1760442','834','00','005010X220A1','1760442','','2014-01-02','17:52:05',0,'2014-01-03 02:03:14',NULL,NULL),(14027,2337,'1378210','834','00','005010X220A1','1378210','','2014-01-08','13:57:15',0,'2014-01-13 02:21:23',NULL,NULL),(14281,2377,'1554076','834','00','005010X220A1','1554076','','2014-01-09','22:41:29',0,'2014-01-13 03:00:16',NULL,NULL),(14635,2527,'1446566','834','00','005010X220A1','1446566','','2014-01-13','13:13:06',0,'2014-01-14 01:33:28',NULL,NULL),(15029,2584,'2490169','834','00','005010X220A1','2490169','','2014-01-15','16:39:45',0,'2014-01-16 08:44:36',NULL,NULL),(15064,2585,'2016826','834','00','005010X220A1','2016826','','2014-01-15','10:38:52',0,'2014-01-16 08:44:58',NULL,NULL),(22772,4277,'3178287','834','00','005010X220A1','3178287','','2014-03-05','22:12:26',0,'2014-03-06 21:00:45',NULL,NULL),(23132,4342,'2999998','834','00','005010X220A1','2999998','','2014-03-07','12:10:00',0,'2014-03-07 21:30:58',NULL,NULL),(17688,3259,'2743586','834','00','005010X220A1','2743586','','2014-02-04','17:13:12',0,'2014-02-04 21:00:22',NULL,NULL),(19562,3626,'2870654','834','00','005010X220A1','2870654','','2014-02-14','15:37:57',0,'2014-02-14 21:31:11',NULL,NULL),(20059,3753,'3170980','834','00','005010X220A1','3170980','','2014-02-18','14:49:14',0,'2014-02-18 22:01:15',NULL,NULL),(20730,3902,'2942938','834','00','005010X220A1','2942938','','2014-02-25','13:47:50',0,'2014-02-25 21:00:33',NULL,NULL),(21243,3999,'3286680','834','00','005010X220A1','3286680','','2014-02-26','12:56:21',0,'2014-02-26 21:01:44',NULL,NULL),(21706,4088,'3558131','834','00','005010X220A1','3558131','','2014-02-27','18:06:55',0,'2014-02-28 21:30:18',NULL,NULL),(179,16,'1254099','834','00','005010X220A1','1254099','','2013-12-05','13:29:19',0,'2013-12-25 17:20:33',NULL,NULL),(13791,2294,'1508579','834','00','005010X220A1','1508579','','2014-01-11','08:34:04',0,'2014-01-13 02:18:08',NULL,NULL),(252,46,'606751','834','00','005010X220A1','606751','','2013-11-12','18:19:38',0,'2013-12-25 17:30:55',NULL,NULL),(272,55,'213249','834','00','005010X220A1','213249','','2013-10-11','11:18:09',0,'2013-12-25 17:31:39',NULL,NULL),(702,114,'55989','834','00','005010X220A1','55989','','2013-12-16','09:37:25',0,'2013-12-25 18:06:47',NULL,NULL),(5804,1079,'574248','834','00','005010X220A1','574248','','2013-12-14','10:46:14',0,'2013-12-26 02:03:41',NULL,NULL),(1482,253,'1540416','834','00','005010X220A1','1540416','','2013-12-24','12:18:24',0,'2013-12-25 18:56:50',NULL,NULL),(5132,943,'469944','834','00','005010X220A1','469944','','2013-12-11','09:47:06',0,'2013-12-26 00:50:17',NULL,NULL),(2558,463,'28353','834','00','005010X220A1','28353','','2013-11-18','09:16:14',0,'2013-12-25 20:31:50',NULL,NULL),(14863,2555,'1416674','834','00','005010X220A1','1416674','','2014-01-13','19:31:53',0,'2014-01-15 02:07:12',NULL,NULL),(16133,2825,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:54:00',1,'2014-01-23 03:50:50',NULL,NULL),(18102,3327,'2805355','834','00','005010X220A1','2805355','','2014-02-06','12:14:43',0,'2014-02-06 21:01:18',NULL,NULL),(19306,3583,'2632832','834','00','005010X220A1','2632832','','2014-02-12','20:23:59',0,'2014-02-13 22:01:18',NULL,NULL),(19687,3667,'3219185','834','00','005010X220A1','3219185','','2014-02-15','11:29:29',0,'2014-02-15 21:00:09',NULL,NULL),(20888,3922,'2986828','834','00','005010X220A1','2986828','','2014-02-25','13:44:56',0,'2014-02-25 21:32:00',NULL,NULL),(21274,4001,'3347804','834','00','005010X220A1','3347804','','2014-02-26','14:05:46',0,'2014-02-26 21:02:05',NULL,NULL),(21471,4028,'3295396','834','00','005010X220A1','3295396','','2014-02-27','14:03:34',0,'2014-02-28 06:31:08',NULL,NULL),(21610,4064,'2795310','834','00','005010X220A1','2795310','','2014-02-27','14:14:31',0,'2014-02-28 07:30:12',NULL,NULL),(22103,4177,'3024551','834','00','005010X220A1','3024551','','2014-03-03','07:28:02',0,'2014-03-03 21:30:21',NULL,NULL),(22420,4220,'2848033','834','00','005010X220A1','2848033','','2014-03-04','16:31:31',0,'2014-03-04 21:02:37',NULL,NULL),(22645,4253,'2960174','834','00','005010X220A1','2960174','','2014-03-05','14:47:55',0,'2014-03-05 21:31:49',NULL,NULL),(76,4,'315196','834','00','005010X220A1','315196','','2013-12-04','18:32:20',0,'2013-12-25 17:17:19',NULL,NULL),(13112,1956,'0001','999','BE','005010X231A1','226590','834','2013-12-27','16:55:00',0,'2014-01-05 16:54:11',NULL,NULL),(13100,1944,'0001','999','BE','005010X231A1','28823','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:38',NULL,NULL),(12844,1705,'2077420','834','00','005010X220A1','2077420','','2014-01-02','23:05:18',0,'2014-01-04 02:02:50',NULL,NULL),(499,102,'88666','834','00','005010X220A1','88666','','2013-12-16','09:13:31',0,'2013-12-25 18:00:26',NULL,NULL),(667,109,'310455','834','00','005010X220A1','310455','','2013-12-15','19:38:22',0,'2013-12-25 18:05:42',NULL,NULL),(1137,238,'2080882','834','00','005010X220A1','2080882','','2013-12-24','17:30:54',0,'2013-12-25 18:45:48',NULL,NULL),(2514,448,'635765','834','00','005010X220A1','635765','','2013-10-13','15:07:11',0,'2013-12-25 20:30:27',NULL,NULL),(3778,656,'785159','834','00','005010X220A1','785159','','2013-12-07','21:22:06',0,'2013-12-25 22:15:36',NULL,NULL),(7460,1296,'361071','834','00','005010X220A1','361071','','2013-12-21','08:21:06',0,'2013-12-26 04:32:40',NULL,NULL),(6192,1167,'684123','834','00','005010X220A1','684123','','2013-12-20','18:03:00',0,'2013-12-26 03:04:03',NULL,NULL),(4949,922,'936224','834','00','005010X220A1','936224','','2013-11-18','20:38:30',0,'2013-12-26 00:31:47',NULL,NULL),(4265,742,'762694','834','00','005010X220A1','762694','','2013-12-19','15:53:33',0,'2013-12-25 23:08:16',NULL,NULL),(14950,2563,'2075399','834','00','005010X220A1','2075399','','2014-01-14','11:16:47',0,'2014-01-15 02:07:52',NULL,NULL),(15402,2626,'2513585','834','00','005010X220A1','2513585','','2014-01-16','14:26:43',0,'2014-01-17 03:35:48',NULL,NULL),(16641,3060,'2303056','834','00','005010X220A1','2303056','','2014-01-26','20:36:01',0,'2014-01-27 21:00:05',NULL,NULL),(16973,3116,'2104796','834','00','005010X220A1','2104796','','2014-01-29','17:06:11',0,'2014-01-29 21:00:37',NULL,NULL),(18075,3322,'1931843','834','00','005010X220A1','1931843','','2014-02-06','09:43:58',0,'2014-02-06 21:00:59',NULL,NULL),(22218,4188,'3725631','834','00','005010X220A1','3725631','','2014-03-03','15:10:50',0,'2014-03-03 21:31:45',NULL,NULL),(22937,4296,'3452691','834','00','005010X220A1','3452691','','2014-03-06','11:44:17',0,'2014-03-06 21:02:43',NULL,NULL),(7582,1301,'969699','834','00','005010X220A1','969699','','2013-12-21','16:23:14',0,'2013-12-26 04:36:41',NULL,NULL),(7662,1316,'263805','834','00','005010X220A1','263805','','2013-12-21','16:38:41',0,'2013-12-26 04:39:13',NULL,NULL),(2536,456,'1042499','834','00','005010X220A1','1042499','','2013-11-18','15:41:40',0,'2013-12-25 20:31:05',NULL,NULL),(10690,1403,'874064','834','00','005010X220A1','874064','','2013-12-23','07:09:37',0,'2013-12-26 13:00:08',NULL,NULL),(11477,1488,'1816961','834','00','005010X220A1','1816961','','2013-12-27','14:55:24',0,'2013-12-28 03:30:57',NULL,NULL),(11502,1489,'1534429','834','00','005010X220A1','1534429','','2013-12-27','13:29:50',0,'2013-12-28 03:31:43',NULL,NULL),(2369,413,'94600','834','00','005010X220A1','94600','','2013-12-06','15:08:13',0,'2013-12-25 20:16:19',NULL,NULL),(2177,363,'874440','834','00','005010X220A1','874440','','2013-12-01','20:02:03',0,'2013-12-25 19:47:23',NULL,NULL),(12511,1643,'1784726','834','00','005010X220A1','1784726','','2013-12-30','20:57:11',1,'2014-01-02 04:33:47',NULL,NULL),(1432,252,'1944264','834','00','005010X220A1','1944264','','2013-12-24','09:47:47',0,'2013-12-25 18:55:07',NULL,NULL),(15479,2634,'2544205','834','00','005010X220A1','2544205','','2014-01-16','10:21:25',0,'2014-01-17 03:36:22',NULL,NULL),(16616,3050,'2387844','834','00','005010X220A1','2387844','','2014-01-25','19:37:59',0,'2014-01-26 19:00:14',NULL,NULL),(16694,3063,'1851094','834','00','005010X220A1','1851094','','2014-01-26','19:34:00',0,'2014-01-27 21:00:39',NULL,NULL),(21238,3999,'3123188','834','00','005010X220A1','3123188','','2014-02-26','12:29:04',0,'2014-02-26 21:01:40',NULL,NULL),(22496,4246,'3165578','834','00','005010X220A1','3165578','','2014-03-05','12:50:57',0,'2014-03-05 21:30:03',NULL,NULL),(18066,3321,'2604511','834','00','005010X220A1','2604511','','2014-02-05','18:32:11',0,'2014-02-06 21:00:53',NULL,NULL),(19160,3555,'3055340','834','00','005010X220A1','3055340','','2014-02-12','12:35:48',0,'2014-02-12 21:32:18',NULL,NULL),(19923,3730,'2865665','834','00','005010X220A1','2865665','','2014-02-17','14:32:00',0,'2014-02-17 19:00:15',NULL,NULL),(23118,4342,'3237459','834','00','005010X220A1','3237459','','2014-03-06','20:58:34',0,'2014-03-07 21:30:48',NULL,NULL),(23750,4473,'3028736','834','00','005010X220A1','3028736','','2014-03-10','13:10:08',0,'2014-03-10 21:30:02',NULL,NULL),(435,79,'1188372','834','00','005010X220A1','1188372','','2013-12-04','07:51:57',0,'2013-12-25 17:49:30',NULL,NULL),(5175,948,'44228','834','00','005010X220A1','44228','','2013-12-11','13:56:02',0,'2013-12-26 00:51:33',NULL,NULL),(3964,716,'130818','834','00','005010X220A1','130818','','2013-12-07','10:35:26',0,'2013-12-25 22:47:03',NULL,NULL),(3565,617,'1027231','834','00','005010X220A1','1027231','','2013-12-11','20:43:18',0,'2013-12-25 22:03:17',NULL,NULL),(2939,541,'140939','834','00','005010X220A1','140939','','2013-12-12','21:53:21',0,'2013-12-25 21:31:13',NULL,NULL),(13491,2226,'1705302','834','00','005010X220A1','1705302','','2014-01-06','17:51:31',0,'2014-01-07 04:04:15',NULL,NULL),(2689,502,'673839','834','00','005010X220A1','673839','','2013-12-22','11:17:26',0,'2013-12-25 21:16:49',NULL,NULL),(11878,1560,'1971539','834','00','005010X220A1','1971539','','2013-12-29','12:17:11',0,'2013-12-30 00:00:18',NULL,NULL),(1313,245,'1758722','834','00','005010X220A1','1758722','','2013-12-24','09:52:31',0,'2013-12-25 18:51:13',NULL,NULL),(1110,237,'433321','834','00','005010X220A1','433321','','2013-10-09','09:27:26',0,'2013-12-25 18:32:26',NULL,NULL),(14067,2339,'2498792','834','00','005010X220A1','2498792','','2014-01-08','13:54:38',0,'2014-01-13 02:21:47',NULL,NULL),(15903,2742,'2152137','834','00','005010X220A1','2152137','','2014-01-21','16:09:06',1,'2014-01-22 03:22:43',NULL,NULL),(15950,2763,'2202996','834','00','005010X220A1','2202996','','2014-01-22','13:52:45',0,'2014-01-23 03:01:50',NULL,NULL),(20053,3753,'3035419','834','00','005010X220A1','3035419','','2014-02-18','08:47:54',0,'2014-02-18 22:01:10',NULL,NULL),(21965,4143,'3849704','834','00','005010X220A1','3849704','','2014-03-01','19:16:26',0,'2014-03-03 01:00:05',NULL,NULL),(169,15,'1060379','834','00','005010X220A1','1060379','','2013-12-04','20:18:39',0,'2013-12-25 17:20:16',NULL,NULL),(7657,1314,'639243','834','00','005010X220A1','639243','','2013-12-21','09:24:37',0,'2013-12-26 04:39:04',NULL,NULL),(1879,325,'782412','834','00','005010X220A1','782412','','2013-12-08','19:35:41',0,'2013-12-25 19:31:11',NULL,NULL),(11191,1453,'1629541','834','00','005010X220A1','1629541','','2013-12-26','11:13:23',0,'2013-12-27 02:00:10',NULL,NULL),(12580,1670,'1628342','834','00','005010X220A1','1628342','','2014-01-02','18:06:59',0,'2014-01-03 02:00:23',NULL,NULL),(13461,2226,'1868460','834','00','005010X220A1','1868460','','2014-01-06','12:39:10',0,'2014-01-07 04:03:12',NULL,NULL),(1454,252,'1878599','834','00','005010X220A1','1878599','','2013-12-24','13:25:52',0,'2013-12-25 18:55:50',NULL,NULL),(13545,2241,'2007693','834','00','005010X220A1','2007693','','2014-01-06','11:38:26',0,'2014-01-07 04:06:13',NULL,NULL),(1916,325,'1295960','834','00','005010X220A1','1295960','','2013-12-09','16:36:30',0,'2013-12-25 19:32:13',NULL,NULL),(6310,1175,'1230044','834','00','005010X220A1','1230044','','2013-12-19','19:39:47',0,'2013-12-26 03:07:42',NULL,NULL),(6097,1166,'1093748','834','00','005010X220A1','1093748','','2013-12-20','09:07:23',0,'2013-12-26 03:01:14',NULL,NULL),(2736,503,'342560','834','00','005010X220A1','342560','','2013-12-22','15:14:45',0,'2013-12-25 21:18:17',NULL,NULL),(15441,2630,'1425417','834','00','005010X220A1','1425417','','2014-01-15','18:44:52',0,'2014-01-17 03:36:06',NULL,NULL),(15664,2684,'1976112','834','00','005010X220A1','1976112','','2014-01-18','12:27:51',0,'2014-01-21 08:44:34',NULL,NULL),(17790,3269,'2877846','834','00','005010X220A1','2877846','','2014-02-04','12:09:52',0,'2014-02-04 21:01:25',NULL,NULL),(17809,3273,'2792125','834','00','005010X220A1','2792125','','2014-02-04','09:49:27',0,'2014-02-04 21:01:39',NULL,NULL),(18610,3456,'2801715','834','00','005010X220A1','2801715','','2014-02-10','14:31:27',0,'2014-02-10 21:31:11',NULL,NULL),(19664,3654,'3306114','834','00','005010X220A1','3306114','','2014-02-14','10:52:48',0,'2014-02-14 21:32:25',NULL,NULL),(20752,3903,'2732213','834','00','005010X220A1','2732213','','2014-02-25','14:54:15',0,'2014-02-25 21:30:21',NULL,NULL),(21252,3999,'3462975','834','00','005010X220A1','3462975','','2014-02-26','15:27:58',0,'2014-02-26 21:01:49',NULL,NULL),(21685,4084,'3801482','834','00','005010X220A1','3801482','','2014-02-28','14:55:43',0,'2014-02-28 21:00:25',NULL,NULL),(3761,654,'961893','834','00','005010X220A1','961893','','2013-12-08','18:03:13',0,'2013-12-25 22:15:02',NULL,NULL),(10616,1402,'969842','834','00','005010X220A1','969842','','2013-12-23','14:42:53',0,'2013-12-26 12:57:42',NULL,NULL),(10518,1401,'1434741','834','00','005010X220A1','1434741','','2013-12-22','22:54:47',0,'2013-12-26 12:54:24',NULL,NULL),(7653,1313,'286396','834','00','005010X220A1','286396','','2013-12-21','06:38:38',0,'2013-12-26 04:38:57',NULL,NULL),(4149,733,'1208194','834','00','005010X220A1','1208194','','2013-12-19','17:53:40',0,'2013-12-25 23:04:39',NULL,NULL),(13905,2313,'2206267','834','00','005010X220A1','2206267','','2014-01-09','16:57:19',0,'2014-01-13 02:19:48',NULL,NULL),(14461,2482,'0001','999','BE','005010X231A1','1133346','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:34',NULL,NULL),(15220,2594,'2026679','834','00','005010X220A1','2026679','','2014-01-15','13:16:37',0,'2014-01-16 08:46:38',NULL,NULL),(15622,2671,'1401289','834','00','005010X220A1','1401289','','2014-01-16','20:01:24',0,'2014-01-20 08:06:42',NULL,NULL),(17044,3122,'2522832','834','00','005010X220A1','2522832','','2014-01-29','12:29:31',0,'2014-01-29 21:01:23',NULL,NULL),(18468,3429,'1460119','834','00','005010X220A1','1460119','','2014-02-10','03:53:39',0,'2014-02-10 11:00:50',NULL,NULL),(18966,3535,'3371774','834','00','005010X220A1','3371774','','2014-02-12','17:22:46',0,'2014-02-12 21:00:16',NULL,NULL),(19599,3631,'2694994','834','00','005010X220A1','2694994','','2014-02-14','17:45:04',0,'2014-02-14 21:31:36',NULL,NULL),(20273,3794,'2592249','834','00','005010X220A1','2592249','','2014-02-19','08:31:05',0,'2014-02-20 04:36:27',NULL,NULL),(21184,3998,'3705658','834','00','005010X220A1','3705658','','2014-02-26','13:05:41',0,'2014-02-26 21:01:06',NULL,NULL),(934,181,'6205','834','00','005010X220A1','6205','','2013-12-02','21:56:27',0,'2013-12-25 18:18:10',NULL,NULL),(5439,1033,'516751','834','00','005010X220A1','516751','','2013-10-05','12:01:17',0,'2013-12-26 01:31:37',NULL,NULL),(7710,1334,'239645','834','00','005010X220A1','239645','','2013-11-14','22:46:30',0,'2013-12-26 04:45:48',NULL,NULL),(7714,1334,'894280','834','00','005010X220A1','894280','','2013-11-15','09:46:07',0,'2013-12-26 04:45:56',NULL,NULL),(5075,936,'878427','834','00','005010X220A1','878427','','2013-12-11','15:57:06',0,'2013-12-26 00:48:24',NULL,NULL),(4460,801,'1263633','834','00','005010X220A1','1263633','','2013-11-26','14:49:51',0,'2013-12-25 23:30:45',NULL,NULL),(12331,1634,'1819857','834','00','005010X220A1','1819857','','2013-12-31','07:59:10',1,'2014-01-02 04:27:14',NULL,NULL),(3619,621,'888391','834','00','005010X220A1','888391','','2013-12-12','13:40:30',0,'2013-12-25 22:04:56',NULL,NULL),(12814,1704,'1576767','834','00','005010X220A1','1576767','','2014-01-02','18:41:55',0,'2014-01-04 02:01:46',NULL,NULL),(1168,239,'458201','834','00','005010X220A1','458201','','2013-12-24','13:04:08',0,'2013-12-25 18:46:44',NULL,NULL),(15217,2594,'2401755','834','00','005010X220A1','2401755','','2014-01-14','21:45:39',0,'2014-01-16 08:46:36',NULL,NULL),(15794,2722,'2482863','834','00','005010X220A1','2482863','','2014-01-20','11:48:27',0,'2014-01-21 08:46:44',NULL,NULL),(16679,3062,'2581234','834','00','005010X220A1','2581234','','2014-01-26','21:27:01',0,'2014-01-27 21:00:30',NULL,NULL),(17211,3151,'1910378','834','00','005010X220A1','1910378','','2014-01-30','12:32:35',0,'2014-01-30 21:01:16',NULL,NULL),(17713,3261,'1941769','834','00','005010X220A1','1941769','','2014-02-04','09:46:09',0,'2014-02-04 21:00:37',NULL,NULL),(17767,3263,'1775301','834','00','005010X220A1','1775301','','2014-02-03','22:12:54',0,'2014-02-04 21:01:10',NULL,NULL),(19041,3540,'2635109','834','00','005010X220A1','2635109','','2014-02-12','12:14:30',0,'2014-02-12 21:30:54',NULL,NULL),(19514,3622,'2913814','834','00','005010X220A1','2913814','','2014-02-13','19:54:01',0,'2014-02-14 21:30:35',NULL,NULL),(21824,4097,'3346640','834','00','005010X220A1','3346640','','2014-02-28','09:57:12',0,'2014-02-28 21:31:38',NULL,NULL),(164,12,'1222511','834','00','005010X220A1','1222511','','2013-12-05','15:49:10',0,'2013-12-25 17:20:06',NULL,NULL),(5706,1069,'315472','834','00','005010X220A1','315472','','2013-12-13','18:44:43',0,'2013-12-26 02:00:39',NULL,NULL),(7473,1296,'632018','834','00','005010X220A1','632018','','2013-12-21','14:17:08',0,'2013-12-26 04:33:02',NULL,NULL),(2490,438,'886079','834','00','005010X220A1','886079','','2013-12-06','12:54:54',0,'2013-12-25 20:20:12',NULL,NULL),(7556,1301,'782986','834','00','005010X220A1','782986','','2013-12-21','09:44:58',0,'2013-12-26 04:35:49',NULL,NULL),(7666,1317,'25069','834','00','005010X220A1','25069','','2013-12-21','12:08:48',0,'2013-12-26 04:39:20',NULL,NULL),(7669,1319,'638007','834','00','005010X220A1','638007','','2013-12-21','11:01:18',0,'2013-12-26 04:39:27',NULL,NULL),(11546,1492,'1629572','834','00','005010X220A1','1629572','','2013-12-26','19:07:34',0,'2013-12-28 03:32:59',NULL,NULL),(2310,403,'375710','834','00','005010X220A1','375710','','2013-11-01','21:45:37',0,'2013-12-25 20:01:35',NULL,NULL),(2019,331,'873486','834','00','005010X220A1','873486','','2013-12-09','14:09:25',0,'2013-12-25 19:35:29',NULL,NULL),(1940,326,'286896','834','00','005010X220A1','286896','','2013-12-09','10:25:06',0,'2013-12-25 19:32:55',NULL,NULL),(832,173,'171705','834','00','005010X220A1','171705','','2013-12-03','00:02:54',0,'2013-12-25 18:15:05',NULL,NULL),(12933,1725,'1566564','834','00','005010X220A1','1566564','','2014-01-03','15:36:34',0,'2014-01-04 02:06:11',NULL,NULL),(16378,2986,'2086294','834','00','005010X220A1','2086294','','2014-01-23','14:52:18',0,'2014-01-23 21:01:08',NULL,NULL),(21176,3998,'3475187','834','00','005010X220A1','3475187','','2014-02-26','10:52:10',0,'2014-02-26 21:01:01',NULL,NULL),(17701,3261,'2290575','834','00','005010X220A1','2290575','','2014-02-03','20:28:30',0,'2014-02-04 21:00:31',NULL,NULL),(19987,3746,'2777819','834','00','005010X220A1','2777819','','2014-02-18','17:16:08',0,'2014-02-18 22:00:24',NULL,NULL),(22690,4258,'2652097','834','00','005010X220A1','2652097','','2014-03-05','17:13:44',0,'2014-03-05 21:32:20',NULL,NULL),(2684,502,'970895','834','00','005010X220A1','970895','','2013-12-22','07:29:45',0,'2013-12-25 21:16:42',NULL,NULL),(2751,504,'1165316','834','00','005010X220A1','1165316','','2013-12-21','18:39:20',0,'2013-12-25 21:18:45',NULL,NULL),(13166,2010,'0001','999','BE','005010X231A1','858759','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:17',NULL,NULL),(3304,584,'642719','834','00','005010X220A1','642719','','2013-12-17','12:37:09',0,'2013-12-25 21:48:37',NULL,NULL),(12557,1658,'2301331','834','00','005010X220A1','2301331','','2013-12-31','12:25:10',1,'2014-01-02 04:35:31',NULL,NULL),(3484,615,'1027244','834','00','005010X220A1','1027244','','2013-12-12','09:47:22',0,'2013-12-25 22:00:40',NULL,NULL),(3774,655,'207248','834','00','005010X220A1','207248','','2013-12-08','13:30:23',0,'2013-12-25 22:15:28',NULL,NULL),(3776,656,'319031','834','00','005010X220A1','319031','','2013-12-07','19:07:47',0,'2013-12-25 22:15:32',NULL,NULL),(11386,1463,'1541875','834','00','005010X220A1','1541875','','2013-12-26','12:28:16',0,'2013-12-27 02:06:06',NULL,NULL),(6385,1185,'444066','834','00','005010X220A1','444066','','2013-12-20','15:07:17',0,'2013-12-26 03:10:01',NULL,NULL),(7738,1343,'1241406','834','00','005010X220A1','1241406','','2013-10-19','22:28:02',0,'2013-12-26 05:00:27',NULL,NULL),(7715,1334,'245933','834','00','005010X220A1','245933','','2013-11-15','15:23:22',0,'2013-12-26 04:45:57',NULL,NULL),(7477,1296,'501873','834','00','005010X220A1','501873','','2013-12-21','16:50:42',0,'2013-12-26 04:33:12',NULL,NULL),(7451,1296,'951951','834','00','005010X220A1','951951','','2013-12-20','22:27:17',0,'2013-12-26 04:32:26',NULL,NULL),(7176,1238,'826935','834','00','005010X220A1','826935','','2013-12-18','16:26:04',0,'2013-12-26 04:05:53',NULL,NULL),(14925,2559,'2478073','834','00','005010X220A1','2478073','','2014-01-14','17:06:29',0,'2014-01-15 02:07:41',NULL,NULL),(22425,4223,'3157713','834','00','005010X220A1','3157713','','2014-03-04','14:35:55',0,'2014-03-04 21:02:41',NULL,NULL),(15051,2585,'1807230','834','00','005010X220A1','1807230','','2014-01-14','20:18:44',0,'2014-01-16 08:44:50',NULL,NULL),(15278,2610,'2480424','834','00','005010X220A1','2480424','','2014-01-15','10:47:36',0,'2014-01-16 08:47:17',NULL,NULL),(15833,2736,'2322907','834','00','005010X220A1','2322907','','2014-01-21','15:56:03',1,'2014-01-22 03:21:58',NULL,NULL),(16861,3093,'1673302','834','00','005010X220A1','1673302','','2014-01-28','12:05:23',0,'2014-01-28 21:00:47',NULL,NULL),(17050,3123,'2323085','834','00','005010X220A1','2323085','','2014-01-28','21:43:56',0,'2014-01-29 21:01:26',NULL,NULL),(17178,3147,'2298281','834','00','005010X220A1','2298281','','2014-01-30','15:21:55',0,'2014-01-30 21:00:55',NULL,NULL),(18199,3354,'2705038','834','00','005010X220A1','2705038','','2014-02-06','19:59:47',0,'2014-02-07 19:00:33',NULL,NULL),(20257,3795,'2402660','834','00','005010X220A1','2402660','','2014-02-18','22:31:44',0,'2014-02-20 04:33:25',NULL,NULL),(20861,3911,'2712923','834','00','005010X220A1','2712923','','2014-02-25','17:37:11',0,'2014-02-25 21:31:39',NULL,NULL),(22699,4261,'2804976','834','00','005010X220A1','2804976','','2014-03-05','14:50:58',0,'2014-03-05 21:32:27',NULL,NULL),(22865,4280,'2730447','834','00','005010X220A1','2730447','','2014-03-06','13:52:48',0,'2014-03-06 21:01:50',NULL,NULL),(13951,2320,'2114392','834','00','005010X220A1','2114392','','2014-01-09','12:03:30',0,'2014-01-13 02:20:21',NULL,NULL),(1308,245,'1289282','834','00','005010X220A1','1289282','','2013-12-24','08:44:33',0,'2013-12-25 18:51:04',NULL,NULL),(2484,435,'970292','834','00','005010X220A1','970292','','2013-12-05','22:44:57',0,'2013-12-25 20:19:59',NULL,NULL),(3314,584,'1036441','834','00','005010X220A1','1036441','','2013-12-17','15:39:49',0,'2013-12-25 21:48:57',NULL,NULL),(5878,1109,'1247864','834','00','005010X220A1','1247864','','2013-12-14','18:14:06',0,'2013-12-26 02:30:03',NULL,NULL),(7314,1264,'185097','834','00','005010X220A1','185097','','2013-12-18','14:18:20',0,'2013-12-26 04:10:07',NULL,NULL),(10974,1412,'99495','834','00','005010X220A1','99495','','2013-12-23','11:17:18',0,'2013-12-26 13:09:52',NULL,NULL),(11564,1492,'2140382','834','00','005010X220A1','2140382','','2013-12-27','13:06:20',0,'2013-12-28 03:33:38',NULL,NULL),(11518,1490,'654960','834','00','005010X220A1','654960','','2013-12-27','11:45:04',0,'2013-12-28 03:32:11',NULL,NULL),(15884,2740,'1595730','834','00','005010X220A1','1595730','','2014-01-21','06:51:59',1,'2014-01-22 03:22:31',NULL,NULL),(17295,3172,'1884582','834','00','005010X220A1','1884582','','2014-01-31','15:14:04',0,'2014-01-31 21:00:38',NULL,NULL),(17979,3306,'1934278','834','00','005010X220A1','1934278','','2014-02-04','22:57:54',0,'2014-02-05 21:31:11',NULL,NULL),(18228,3359,'2278949','834','00','005010X220A1','2278949','','2014-02-06','21:35:55',0,'2014-02-07 19:00:55',NULL,NULL),(18953,3530,'3147351','834','00','005010X220A1','3147351','','2014-02-12','10:42:00',0,'2014-02-12 21:00:06',NULL,NULL),(20002,3748,'2806934','834','00','005010X220A1','2806934','','2014-02-18','13:22:18',0,'2014-02-18 22:00:34',NULL,NULL),(23072,4339,'3845956','834','00','005010X220A1','3845956','','2014-03-07','10:24:53',0,'2014-03-07 21:30:15',NULL,NULL),(23123,4342,'3600753','834','00','005010X220A1','3600753','','2014-03-07','09:29:43',0,'2014-03-07 21:30:52',NULL,NULL),(23226,4357,'2818835','834','00','005010X220A1','2818835','','2014-03-07','08:47:37',0,'2014-03-07 21:32:04',NULL,NULL),(23462,4413,'3070365','834','00','005010X220A1','3070365','','2014-03-09','14:26:30',0,'2014-03-09 21:01:02',NULL,NULL),(23724,4461,'3892253','834','00','005010X220A1','3892253','','2014-03-10','11:33:19',0,'2014-03-10 21:02:47',NULL,NULL),(1604,281,'507168','834','00','005010X220A1','507168','','2013-11-19','22:59:51',0,'2013-12-25 19:01:18',NULL,NULL),(2820,507,'1200930','834','00','005010X220A1','1200930','','2013-12-22','11:09:29',0,'2013-12-25 21:20:57',NULL,NULL),(12577,1670,'1620705','834','00','005010X220A1','1620705','','2014-01-02','16:23:04',0,'2014-01-03 02:00:16',NULL,NULL),(12257,1620,'2167258','834','00','005010X220A1','2167258','','2014-01-01','09:44:22',1,'2014-01-02 04:23:42',NULL,NULL),(3276,583,'276551','834','00','005010X220A1','276551','','2013-12-16','20:31:48',0,'2013-12-25 21:47:42',NULL,NULL),(3417,592,'131151','834','00','005010X220A1','131151','','2013-12-17','13:07:06',0,'2013-12-25 21:52:13',NULL,NULL),(10918,1410,'1202153','834','00','005010X220A1','1202153','','2013-12-23','08:50:10',0,'2013-12-26 13:08:14',NULL,NULL),(3669,627,'1006795','834','00','005010X220A1','1006795','','2013-12-12','12:33:15',0,'2013-12-25 22:06:30',NULL,NULL),(3958,715,'682137','834','00','005010X220A1','682137','','2013-12-07','15:11:05',0,'2013-12-25 22:46:48',NULL,NULL),(6224,1168,'1069975','834','00','005010X220A1','1069975','','2013-12-20','15:23:37',0,'2013-12-26 03:05:04',NULL,NULL),(4468,801,'213518','834','00','005010X220A1','213518','','2013-11-26','15:56:27',0,'2013-12-25 23:31:00',NULL,NULL),(14367,2404,'1988262','834','00','005010X220A1','1988262','','2014-01-12','13:48:36',0,'2014-01-13 03:01:38',NULL,NULL),(14891,2558,'2346425','834','00','005010X220A1','2346425','','2014-01-14','10:50:02',0,'2014-01-15 02:07:26',NULL,NULL),(16574,3036,'1438105','834','00','005010X220A1','1438105','','2014-01-24','21:08:25',0,'2014-01-25 19:00:08',NULL,NULL),(16654,3060,'1960783','834','00','005010X220A1','1960783','','2014-01-27','13:22:17',0,'2014-01-27 21:00:14',NULL,NULL),(17230,3158,'1959526','834','00','005010X220A1','1959526','','2014-01-30','10:21:44',0,'2014-01-30 21:01:29',NULL,NULL),(18293,3380,'1976559','834','00','005010X220A1','1976559','','2014-02-08','11:47:06',0,'2014-02-08 19:00:30',NULL,NULL),(21466,4028,'3728320','834','00','005010X220A1','3728320','','2014-02-27','12:19:44',0,'2014-02-28 06:31:06',NULL,NULL),(21852,4113,'3039534','834','00','005010X220A1','3039534','','2014-03-01','00:27:57',0,'2014-03-01 19:00:04',NULL,NULL),(21958,4140,'2830838','834','00','005010X220A1','2830838','','2014-03-01','16:34:46',0,'2014-03-01 21:01:11',NULL,NULL),(22519,4247,'3065756','834','00','005010X220A1','3065756','','2014-03-05','13:02:26',0,'2014-03-05 21:30:19',NULL,NULL),(18911,3509,'2527058','834','00','005010X220A1','2527058','','2014-02-11','15:55:21',0,'2014-02-11 21:02:46',NULL,NULL),(21050,3977,'3285302','834','00','005010X220A1','3285302','','2014-02-24','17:09:25',0,'2014-02-26 09:30:27',NULL,NULL),(2337,412,'547490','834','00','005010X220A1','547490','','2013-12-06','15:25:00',0,'2013-12-25 20:15:14',NULL,NULL),(13948,2319,'1427641','834','00','005010X220A1','1427641','','2014-01-09','17:55:35',0,'2014-01-13 02:20:19',NULL,NULL),(12975,1734,'1391149','834','00','005010X220A1','1391149','','2014-01-04','13:24:59',0,'2014-01-05 00:01:15',NULL,NULL),(12877,1706,'1727790','834','00','005010X220A1','1727790','','2014-01-03','14:57:01',0,'2014-01-04 02:04:02',NULL,NULL),(12476,1640,'2045288','834','00','005010X220A1','2045288','','2013-12-31','10:46:23',1,'2014-01-02 04:32:23',NULL,NULL),(12340,1634,'1575443','834','00','005010X220A1','1575443','','2013-12-31','11:49:14',1,'2014-01-02 04:27:33',NULL,NULL),(3349,587,'136659','834','00','005010X220A1','136659','','2013-12-17','07:41:13',0,'2013-12-25 21:50:09',NULL,NULL),(11798,1537,'718725','834','00','005010X220A1','718725','','2013-12-28','20:27:00',1,'2013-12-29 11:13:03',NULL,NULL),(4506,810,'875701','834','00','005010X220A1','875701','','2013-11-26','12:13:29',0,'2013-12-25 23:32:16',NULL,NULL),(11501,1489,'428327','834','00','005010X220A1','428327','','2013-12-27','12:48:53',0,'2013-12-28 03:31:41',NULL,NULL),(10889,1409,'1316176','834','00','005010X220A1','1316176','','2013-12-22','21:13:32',0,'2013-12-26 13:07:16',NULL,NULL),(7144,1237,'991851','834','00','005010X220A1','991851','','2013-12-18','10:51:23',0,'2013-12-26 04:04:56',NULL,NULL),(5376,1010,'856276','834','00','005010X220A1','856276','','2013-11-25','08:56:30',0,'2013-12-26 01:16:45',NULL,NULL),(5935,1112,'1067063','834','00','005010X220A1','1067063','','2013-12-15','16:59:56',0,'2013-12-26 02:31:53',NULL,NULL),(14539,2518,'2159866','834','00','005010X220A1','2159866','','2014-01-13','13:51:00',0,'2014-01-14 01:32:27',NULL,NULL),(15347,2623,'1662100','834','00','005010X220A1','1662100','','2014-01-15','18:31:04',0,'2014-01-17 03:35:22',NULL,NULL),(20914,3932,'3093153','834','00','005010X220A1','3093153','','2014-02-22','20:43:34',0,'2014-02-26 08:00:13',NULL,NULL),(21180,3998,'3567916','834','00','005010X220A1','3567916','','2014-02-26','05:34:20',0,'2014-02-26 21:01:04',NULL,NULL),(21571,4054,'3164207','834','00','005010X220A1','3164207','','2014-02-26','15:56:48',0,'2014-02-28 07:00:13',NULL,NULL),(22580,4248,'3875139','834','00','005010X220A1','3875139','','2014-03-05','16:14:20',0,'2014-03-05 21:31:04',NULL,NULL),(1695,292,'268290','834','00','005010X220A1','268290','','2013-12-09','20:02:57',0,'2013-12-25 19:16:21',NULL,NULL),(1990,327,'662016','834','00','005010X220A1','662016','','2013-12-09','17:15:23',0,'2013-12-25 19:34:28',NULL,NULL),(2915,541,'264692','834','00','005010X220A1','264692','','2013-12-13','17:24:58',0,'2013-12-25 21:30:25',NULL,NULL),(13172,2016,'0001','999','BE','005010X231A1','1065194','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:34',NULL,NULL),(14109,2344,'1707852','834','00','005010X220A1','1707852','','2014-01-08','15:17:35',0,'2014-01-13 02:22:16',NULL,NULL),(12590,1671,'1723444','834','00','005010X220A1','1723444','','2014-01-01','23:19:27',0,'2014-01-03 02:00:45',NULL,NULL),(4555,825,'1869493','834','00','005010X220A1','1869493','','2013-12-23','23:38:37',0,'2013-12-25 23:45:51',NULL,NULL),(15911,2743,'1911680','834','00','005010X220A1','1911680','','2014-01-21','11:38:11',1,'2014-01-22 03:22:48',NULL,NULL),(16085,2778,'2151001','834','00','005010X220A1','2151001','','2014-01-21','18:30:59',0,'2014-01-23 03:02:52',NULL,NULL),(18405,3413,'2156414','834','00','005010X220A1','2156414','','2014-02-09','15:54:45',0,'2014-02-09 19:00:39',NULL,NULL),(19329,3583,'2627897','834','00','005010X220A1','2627897','','2014-02-13','13:06:40',0,'2014-02-13 22:01:36',NULL,NULL),(21778,4091,'3803725','834','00','005010X220A1','3803725','','2014-02-28','11:49:11',0,'2014-02-28 21:31:06',NULL,NULL),(22780,4277,'3653332','834','00','005010X220A1','3653332','','2014-03-06','13:04:30',0,'2014-03-06 21:00:51',NULL,NULL),(309,70,'472713','834','00','005010X220A1','472713','','2013-12-04','15:52:14',0,'2013-12-25 17:45:28',NULL,NULL),(1757,293,'794446','834','00','005010X220A1','794446','','2013-12-10','17:53:33',0,'2013-12-25 19:18:11',NULL,NULL),(1954,326,'487921','834','00','005010X220A1','487921','','2013-12-09','12:24:36',0,'2013-12-25 19:33:21',NULL,NULL),(2011,331,'558280','834','00','005010X220A1','558280','','2013-12-08','22:09:59',0,'2013-12-25 19:35:12',NULL,NULL),(2367,413,'143600','834','00','005010X220A1','143600','','2013-12-06','12:15:45',0,'2013-12-25 20:16:15',NULL,NULL),(2547,457,'904549','834','00','005010X220A1','904549','','2013-11-18','13:02:37',0,'2013-12-25 20:31:25',NULL,NULL),(3265,580,'112241','834','00','005010X220A1','112241','','2013-12-17','10:07:33',0,'2013-12-25 21:47:19',NULL,NULL),(3548,616,'1059460','834','00','005010X220A1','1059460','','2013-12-12','13:54:41',0,'2013-12-25 22:02:43',NULL,NULL),(4600,826,'1266148','834','00','005010X220A1','1266148','','2013-12-24','01:19:46',0,'2013-12-25 23:47:16',NULL,NULL),(4696,834,'37319','834','00','005010X220A1','37319','','2013-12-23','21:21:01',0,'2013-12-25 23:50:31',NULL,NULL),(1371,245,'1755198','834','00','005010X220A1','1755198','','2013-12-24','15:29:52',0,'2013-12-25 18:53:04',NULL,NULL),(4740,854,'1083656','834','00','005010X220A1','1083656','','2013-12-24','01:36:02',0,'2013-12-25 23:52:07',NULL,NULL),(4749,858,'24351','834','00','005010X220A1','24351','','2013-11-30','21:03:49',0,'2013-12-26 00:00:15',NULL,NULL),(6128,1166,'781846','834','00','005010X220A1','781846','','2013-12-20','15:26:26',0,'2013-12-26 03:02:11',NULL,NULL),(736,129,'951706','834','00','005010X220A1','951706','','2013-12-16','12:39:28',0,'2013-12-25 18:07:56',NULL,NULL),(632,108,'394789','834','00','005010X220A1','394789','','2013-12-16','11:59:06',0,'2013-12-25 18:04:40',NULL,NULL),(15126,2587,'2017960','834','00','005010X220A1','2017960','','2014-01-15','16:37:59',0,'2014-01-16 08:45:37',NULL,NULL),(16944,3115,'1775165','834','00','005010X220A1','1775165','','2014-01-29','14:38:48',0,'2014-01-29 21:00:18',NULL,NULL),(16952,3115,'2399651','834','00','005010X220A1','2399651','','2014-01-29','16:45:43',0,'2014-01-29 21:00:24',NULL,NULL),(17010,3118,'1958524','834','00','005010X220A1','1958524','','2014-01-29','17:38:22',0,'2014-01-29 21:00:59',NULL,NULL),(17781,3267,'2099856','834','00','005010X220A1','2099856','','2014-02-04','16:23:49',0,'2014-02-04 21:01:20',NULL,NULL),(19245,3580,'2569273','834','00','005010X220A1','2569273','','2014-02-13','15:10:28',0,'2014-02-13 22:00:29',NULL,NULL),(21276,4002,'3667167','834','00','005010X220A1','3667167','','2014-02-26','09:56:06',0,'2014-02-26 21:02:07',NULL,NULL),(21930,4129,'2767662','834','00','005010X220A1','2767662','','2014-02-28','19:20:03',0,'2014-03-01 21:00:49',NULL,NULL),(23206,4347,'2710744','834','00','005010X220A1','2710744','','2014-03-07','10:41:16',0,'2014-03-07 21:31:50',NULL,NULL),(97,4,'810653','834','00','005010X220A1','810653','','2013-12-05','11:59:19',0,'2013-12-25 17:17:56',NULL,NULL),(4490,803,'386777','834','00','005010X220A1','386777','','2013-11-26','15:37:14',0,'2013-12-25 23:31:43',NULL,NULL),(5055,936,'767077','834','00','005010X220A1','767077','','2013-12-11','09:25:56',0,'2013-12-26 00:47:46',NULL,NULL),(5789,1075,'427616','834','00','005010X220A1','427616','','2013-12-14','15:14:43',0,'2013-12-26 02:03:12',NULL,NULL),(3738,641,'372886','834','00','005010X220A1','372886','','2013-12-12','16:54:05',0,'2013-12-25 22:08:49',NULL,NULL),(3678,629,'280095','834','00','005010X220A1','280095','','2013-12-12','11:15:24',0,'2013-12-25 22:06:46',NULL,NULL),(12980,1734,'1491426','834','00','005010X220A1','1491426','','2014-01-04','17:15:22',0,'2014-01-05 00:01:26',NULL,NULL),(13001,1740,'2448833','834','00','005010X220A1','2448833','','2014-01-03','21:56:05',0,'2014-01-05 00:02:09',NULL,NULL),(10721,1403,'197959','834','00','005010X220A1','197959','','2013-12-23','14:01:23',0,'2013-12-26 13:01:18',NULL,NULL),(11332,1456,'1470652','834','00','005010X220A1','1470652','','2013-12-26','14:59:59',0,'2013-12-27 02:04:29',NULL,NULL),(13428,2222,'1422585','834','00','005010X220A1','1422585','','2014-01-06','14:22:36',0,'2014-01-07 04:01:51',NULL,NULL),(16086,2779,'1818999','834','00','005010X220A1','1818999','','2014-01-22','16:46:55',0,'2014-01-23 03:02:53',NULL,NULL),(16129,2821,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 03:49:22',NULL,NULL),(18656,3464,'2501927','834','00','005010X220A1','2501927','','2014-02-10','17:43:21',0,'2014-02-10 21:31:43',NULL,NULL),(19043,3540,'2688513','834','00','005010X220A1','2688513','','2014-02-12','12:32:44',0,'2014-02-12 21:30:55',NULL,NULL),(20387,3827,'3165156','834','00','005010X220A1','3165156','','2014-02-19','13:57:42',0,'2014-02-20 05:39:31',NULL,NULL),(20904,3930,'2676410','834','00','005010X220A1','2676410','','2014-02-22','21:37:48',0,'2014-02-26 08:00:04',NULL,NULL),(21554,4048,'2656972','834','00','005010X220A1','2656972','','2014-02-27','13:31:58',0,'2014-02-28 06:31:46',NULL,NULL),(21601,4064,'3413331','834','00','005010X220A1','3413331','','2014-02-26','18:34:42',0,'2014-02-28 07:30:04',NULL,NULL),(23429,4405,'3881720','834','00','005010X220A1','3881720','','2014-03-09','13:33:54',0,'2014-03-09 21:00:33',NULL,NULL),(1491,254,'1506815','834','00','005010X220A1','1506815','','2013-12-24','16:12:11',0,'2013-12-25 18:57:06',NULL,NULL),(12565,1663,'1592574','834','00','005010X220A1','1592574','','2013-12-31','14:44:03',1,'2014-01-02 04:35:54',NULL,NULL),(2197,365,'320350','834','00','005010X220A1','320350','','2013-12-01','18:55:33',0,'2013-12-25 19:48:04',NULL,NULL),(12467,1640,'1296994','834','00','005010X220A1','1296994','','2013-12-30','19:01:59',1,'2014-01-02 04:32:09',NULL,NULL),(12056,1585,'1371502','834','00','005010X220A1','1371502','','2013-12-30','12:45:39',0,'2014-01-01 12:04:12',NULL,NULL),(13265,2109,'0001','999','BE','005010X231A1','949643','834','2013-12-28','12:25:00',0,'2014-01-05 17:22:34',NULL,NULL),(2416,416,'720875','834','00','005010X220A1','720875','','2013-12-05','18:50:12',0,'2013-12-25 20:17:46',NULL,NULL),(13895,2312,'2170073','834','00','005010X220A1','2170073','','2014-01-09','15:51:56',0,'2014-01-13 02:19:42',NULL,NULL),(14438,2459,'0001','999','BE','005010X231A1','33505','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:10',NULL,NULL),(15138,2588,'2526410','834','00','005010X220A1','2526410','','2014-01-14','19:21:43',0,'2014-01-16 08:45:46',NULL,NULL),(15657,2683,'1879297','834','00','005010X220A1','1879297','','2014-01-18','16:07:11',0,'2014-01-21 08:44:29',NULL,NULL),(16216,2908,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',1,'2014-01-23 05:06:39',NULL,NULL),(16366,2986,'2443057','834','00','005010X220A1','2443057','','2014-01-23','10:19:39',0,'2014-01-23 21:00:59',NULL,NULL),(16464,3006,'1438097','834','00','005010X220A1','1438097','','2014-01-24','14:24:53',0,'2014-01-24 21:00:20',NULL,NULL),(17529,3235,'2152391','834','00','005010X220A1','2152391','','2014-02-03','14:04:46',0,'2014-02-03 21:00:14',NULL,NULL),(19834,3684,'3553046','834','00','005010X220A1','3553046','','2014-02-15','10:42:53',0,'2014-02-15 22:01:51',NULL,NULL),(19883,3710,'3017964','834','00','005010X220A1','3017964','','2014-02-15','20:45:22',0,'2014-02-16 19:00:26',NULL,NULL),(21436,4027,'2944273','834','00','005010X220A1','2944273','','2014-02-27','11:49:32',0,'2014-02-28 06:30:52',NULL,NULL),(22917,4287,'3588285','834','00','005010X220A1','3588285','','2014-03-05','21:56:43',0,'2014-03-06 21:02:28',NULL,NULL),(23603,4440,'2774787','834','00','005010X220A1','2774787','','2014-03-09','22:10:58',0,'2014-03-10 21:01:19',NULL,NULL),(6,1,'171763','834','00','005010X220A1','171763','','2013-12-04','20:39:15',0,'2013-12-25 17:15:11',NULL,NULL),(5902,1110,'354065','834','00','005010X220A1','354065','','2013-12-15','15:58:34',0,'2013-12-26 02:30:51',NULL,NULL),(7177,1238,'1242204','834','00','005010X220A1','1242204','','2013-12-18','16:30:42',0,'2013-12-26 04:05:55',NULL,NULL),(5436,1033,'740308','834','00','005010X220A1','740308','','2013-10-04','19:37:18',0,'2013-12-26 01:31:31',NULL,NULL),(10788,1404,'808702','834','00','005010X220A1','808702','','2013-12-23','11:44:32',0,'2013-12-26 13:03:29',NULL,NULL),(4663,831,'1024335','834','00','005010X220A1','1024335','','2013-12-23','21:40:46',0,'2013-12-25 23:49:20',NULL,NULL),(11816,1539,'28040','834','00','005010X220A1','28040','','2013-12-28','20:22:59',1,'2013-12-29 11:13:35',NULL,NULL),(2286,395,'340496','834','00','005010X220A1','340496','','2013-11-24','10:59:00',0,'2013-12-25 20:00:42',NULL,NULL),(2014,331,'410285','834','00','005010X220A1','410285','','2013-12-09','11:50:06',0,'2013-12-25 19:35:18',NULL,NULL),(476,93,'1048067','834','00','005010X220A1','1048067','','2013-12-04','11:16:47',0,'2013-12-25 17:50:52',NULL,NULL),(13986,2326,'2498809','834','00','005010X220A1','2498809','','2014-01-08','19:53:38',0,'2014-01-13 02:20:47',NULL,NULL),(17517,3234,'2073341','834','00','005010X220A1','2073341','','2014-02-03','13:08:51',0,'2014-02-03 21:00:06',NULL,NULL),(17999,3318,'2560073','834','00','005010X220A1','2560073','','2014-02-06','13:35:03',0,'2014-02-06 21:00:06',NULL,NULL),(18544,3452,'3129903','834','00','005010X220A1','3129903','','2014-02-10','10:12:52',0,'2014-02-10 21:30:25',NULL,NULL),(18546,3452,'2763538','834','00','005010X220A1','2763538','','2014-02-10','11:08:03',0,'2014-02-10 21:30:26',NULL,NULL),(18582,3453,'2030854','834','00','005010X220A1','2030854','','2014-02-10','15:28:09',0,'2014-02-10 21:30:51',NULL,NULL),(18776,3486,'3242817','834','00','005010X220A1','3242817','','2014-02-11','13:44:13',0,'2014-02-11 21:00:58',NULL,NULL),(18904,3506,'3003768','834','00','005010X220A1','3003768','','2014-02-11','10:38:25',0,'2014-02-11 21:02:41',NULL,NULL),(19121,3545,'2160598','834','00','005010X220A1','2160598','','2014-02-12','16:37:15',0,'2014-02-12 21:31:51',NULL,NULL),(19242,3580,'2324641','834','00','005010X220A1','2324641','','2014-02-13','14:49:26',0,'2014-02-13 22:00:27',NULL,NULL),(19766,3675,'3183762','834','00','005010X220A1','3183762','','2014-02-15','09:25:12',0,'2014-02-15 22:00:56',NULL,NULL),(20659,3877,'2647252','834','00','005010X220A1','2647252','','2014-02-21','13:04:24',0,'2014-02-21 22:00:59',NULL,NULL),(21097,3989,'2977889','834','00','005010X220A1','2977889','','2014-02-24','15:06:33',0,'2014-02-26 09:31:03',NULL,NULL),(22909,4286,'2692944','834','00','005010X220A1','2692944','','2014-03-06','10:59:56',0,'2014-03-06 21:02:23',NULL,NULL),(22955,4310,'3568252','834','00','005010X220A1','3568252','','2014-03-06','16:20:35',0,'2014-03-06 21:02:59',NULL,NULL),(23026,4326,'3751586','834','00','005010X220A1','3751586','','2014-03-07','09:27:54',0,'2014-03-07 21:00:23',NULL,NULL),(2018,331,'1106290','834','00','005010X220A1','1106290','','2013-12-09','13:34:00',0,'2013-12-25 19:35:26',NULL,NULL),(5016,935,'160960','834','00','005010X220A1','160960','','2013-12-11','11:22:08',0,'2013-12-26 00:46:28',NULL,NULL),(11698,1517,'1435088','834','00','005010X220A1','1435088','','2013-12-27','20:49:56',1,'2013-12-29 11:07:51',NULL,NULL),(12136,1589,'1888487','834','00','005010X220A1','1888487','','2013-12-29','21:24:48',0,'2014-01-01 12:06:59',NULL,NULL),(12158,1592,'1460648','834','00','005010X220A1','1460648','','2013-12-29','22:39:04',0,'2014-01-01 12:07:43',NULL,NULL),(4914,909,'827514','834','00','005010X220A1','827514','','2013-10-16','02:06:57',0,'2013-12-26 00:30:36',NULL,NULL),(4334,755,'1265762','834','00','005010X220A1','1265762','','2013-12-19','08:40:44',0,'2013-12-25 23:10:16',NULL,NULL),(3295,584,'1079376','834','00','005010X220A1','1079376','','2013-12-16','23:58:04',0,'2013-12-25 21:48:16',NULL,NULL),(13368,2212,'0001','999','BE','005010X231A1','121164','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:21',NULL,NULL),(13450,2224,'1496087','834','00','005010X220A1','1496087','','2014-01-06','12:31:01',0,'2014-01-07 04:02:46',NULL,NULL),(13855,2311,'2354264','834','00','005010X220A1','2354264','','2014-01-09','16:39:31',0,'2014-01-13 02:19:15',NULL,NULL),(13884,2312,'2537222','834','00','005010X220A1','2537222','','2014-01-09','16:38:00',0,'2014-01-13 02:19:35',NULL,NULL),(17674,3259,'1772584','834','00','005010X220A1','1772584','','2014-02-03','22:23:13',0,'2014-02-04 21:00:14',NULL,NULL),(19196,3571,'2209683','834','00','005010X220A1','2209683','','2014-02-13','15:21:35',0,'2014-02-13 21:30:09',NULL,NULL),(20084,3762,'3357274','834','00','005010X220A1','3357274','','2014-02-18','16:00:50',0,'2014-02-18 22:01:33',NULL,NULL),(20798,3909,'2867208','834','00','005010X220A1','2867208','','2014-02-25','14:44:44',0,'2014-02-25 21:30:53',NULL,NULL),(21653,4076,'2915645','834','00','005010X220A1','2915645','','2014-02-28','16:03:06',0,'2014-02-28 21:00:03',NULL,NULL),(21893,4125,'2906154','834','00','005010X220A1','2906154','','2014-03-01','11:05:31',0,'2014-03-01 21:00:25',NULL,NULL),(22172,4180,'3666194','834','00','005010X220A1','3666194','','2014-03-03','14:05:38',0,'2014-03-03 21:31:11',NULL,NULL),(22629,4252,'3743395','834','00','005010X220A1','3743395','','2014-03-05','13:56:37',0,'2014-03-05 21:31:39',NULL,NULL),(23714,4458,'3325458','834','00','005010X220A1','3325458','','2014-03-10','10:53:21',0,'2014-03-10 21:02:38',NULL,NULL),(1074,214,'725848','834','00','005010X220A1','725848','','2013-11-29','11:29:37',0,'2013-12-25 18:31:03',NULL,NULL),(3707,633,'333998','834','00','005010X220A1','333998','','2013-12-12','15:00:17',0,'2013-12-25 22:07:44',NULL,NULL),(3749,645,'43075','834','00','005010X220A1','43075','','2013-12-12','15:37:03',0,'2013-12-25 22:09:09',NULL,NULL),(5492,1041,'791405','834','00','005010X220A1','791405','','2013-12-24','18:36:25',0,'2013-12-26 01:46:08',NULL,NULL),(2650,501,'500759','834','00','005010X220A1','500759','','2013-12-21','23:33:14',0,'2013-12-25 21:15:24',NULL,NULL),(1615,281,'290054','834','00','005010X220A1','290054','','2013-11-19','23:03:18',0,'2013-12-25 19:01:35',NULL,NULL),(7019,1235,'166000','834','00','005010X220A1','166000','','2013-12-18','10:29:47',0,'2013-12-26 04:01:04',NULL,NULL),(7310,1263,'871324','834','00','005010X220A1','871324','','2013-12-18','11:12:38',0,'2013-12-26 04:10:00',NULL,NULL),(7542,1300,'1148905','834','00','005010X220A1','1148905','','2013-12-21','16:25:37',0,'2013-12-26 04:35:22',NULL,NULL),(10585,1402,'1066038','834','00','005010X220A1','1066038','','2013-12-23','12:12:23',0,'2013-12-26 12:56:42',NULL,NULL),(1589,280,'105401','834','00','005010X220A1','105401','','2013-11-19','20:03:09',0,'2013-12-25 19:00:54',NULL,NULL),(11947,1580,'1689466','834','00','005010X220A1','1689466','','2013-12-29','20:49:57',0,'2014-01-01 12:00:06',NULL,NULL),(12514,1643,'2179027','834','00','005010X220A1','2179027','','2013-12-31','10:55:42',1,'2014-01-02 04:33:52',NULL,NULL),(14538,2518,'2087009','834','00','005010X220A1','2087009','','2014-01-13','13:36:15',0,'2014-01-14 01:32:27',NULL,NULL),(15640,2677,'2401876','834','00','005010X220A1','2401876','','2014-01-17','20:00:32',0,'2014-01-21 08:44:17',NULL,NULL),(16416,2997,'2286409','834','00','005010X220A1','2286409','','2014-01-23','17:54:26',0,'2014-01-23 21:01:32',NULL,NULL),(16432,3004,'1953245','834','00','005010X220A1','1953245','','2014-01-23','12:01:00',0,'2014-01-23 21:01:45',NULL,NULL),(16664,3060,'1913238','834','00','005010X220A1','1913238','','2014-01-27','16:23:10',0,'2014-01-27 21:00:20',NULL,NULL),(19609,3635,'2518164','834','00','005010X220A1','2518164','','2014-02-13','23:35:31',0,'2014-02-14 21:31:44',NULL,NULL),(19846,3692,'2862871','834','00','005010X220A1','2862871','','2014-02-15','16:13:21',0,'2014-02-15 22:02:02',NULL,NULL),(20267,3796,'3335583','834','00','005010X220A1','3335583','','2014-02-18','22:31:44',0,'2014-02-20 04:35:11',NULL,NULL),(20395,3830,'3161230','834','00','005010X220A1','3161230','','2014-02-20','17:47:13',0,'2014-02-20 21:30:04',NULL,NULL),(21164,3997,'2933569','834','00','005010X220A1','2933569','','2014-02-26','17:05:50',0,'2014-02-26 21:00:52',NULL,NULL),(23634,4441,'3258182','834','00','005010X220A1','3258182','','2014-03-10','13:11:12',0,'2014-03-10 21:01:39',NULL,NULL),(23752,4473,'3675619','834','00','005010X220A1','3675619','','2014-03-10','16:59:19',0,'2014-03-10 21:30:03',NULL,NULL),(22,1,'179751','834','00','005010X220A1','179751','','2013-12-05','11:44:52',0,'2013-12-25 17:15:40',NULL,NULL),(5894,1110,'501541','834','00','005010X220A1','501541','','2013-12-15','11:23:39',0,'2013-12-26 02:30:34',NULL,NULL),(12365,1634,'1892595','834','00','005010X220A1','1892595','','2013-12-31','15:52:34',1,'2014-01-02 04:28:24',NULL,NULL),(5777,1074,'1303915','834','00','005010X220A1','1303915','','2013-12-14','09:35:13',0,'2013-12-26 02:02:47',NULL,NULL),(5314,993,'275939','834','00','005010X220A1','275939','','2013-11-04','19:59:30',0,'2013-12-26 01:01:57',NULL,NULL),(7292,1256,'1205489','834','00','005010X220A1','1205489','','2013-12-18','12:26:35',0,'2013-12-26 04:09:28',NULL,NULL),(4344,758,'1117122','834','00','005010X220A1','1117122','','2013-12-19','09:18:12',0,'2013-12-25 23:10:34',NULL,NULL),(410,77,'1158325','834','00','005010X220A1','1158325','','2013-12-04','09:44:53',0,'2013-12-25 17:48:42',NULL,NULL),(13473,2226,'2168691','834','00','005010X220A1','2168691','','2014-01-06','10:30:15',0,'2014-01-07 04:03:35',NULL,NULL),(15859,2738,'1470094','834','00','005010X220A1','1470094','','2014-01-21','17:35:54',1,'2014-01-22 03:22:15',NULL,NULL),(18220,3357,'1749675','834','00','005010X220A1','1749675','','2014-02-07','07:39:06',0,'2014-02-07 19:00:49',NULL,NULL),(19810,3679,'1842866','834','00','005010X220A1','1842866','','2014-02-14','18:07:50',0,'2014-02-15 22:01:31',NULL,NULL),(20332,3800,'3415696','834','00','005010X220A1','3415696','','2014-02-18','22:48:37',0,'2014-02-20 04:51:03',NULL,NULL),(21804,4092,'3086419','834','00','005010X220A1','3086419','','2014-02-28','16:04:34',0,'2014-02-28 21:31:23',NULL,NULL),(338,72,'848292','834','00','005010X220A1','848292','','2013-12-04','15:10:43',0,'2013-12-25 17:46:23',NULL,NULL),(3837,681,'209633','834','00','005010X220A1','209633','','2013-11-08','06:36:50',0,'2013-12-25 22:30:09',NULL,NULL),(2735,503,'1354764','834','00','005010X220A1','1354764','','2013-12-22','15:09:23',0,'2013-12-25 21:18:16',NULL,NULL),(7472,1296,'306984','834','00','005010X220A1','306984','','2013-12-21','14:01:19',0,'2013-12-26 04:33:01',NULL,NULL),(10810,1404,'1594886','834','00','005010X220A1','1594886','','2013-12-23','15:17:54',0,'2013-12-26 13:04:12',NULL,NULL),(2613,488,'504575','834','00','005010X220A1','504575','','2013-10-05','23:01:01',0,'2013-12-25 20:46:23',NULL,NULL),(12589,1670,'2396519','834','00','005010X220A1','2396519','','2014-01-02','17:52:13',0,'2014-01-03 02:00:42',NULL,NULL),(2208,365,'555906','834','00','005010X220A1','555906','','2013-12-02','18:07:45',0,'2013-12-25 19:48:26',NULL,NULL),(1723,293,'413043','834','00','005010X220A1','413043','','2013-12-09','22:07:02',0,'2013-12-25 19:17:10',NULL,NULL),(13571,2254,'1478046','834','00','005010X220A1','1478046','','2014-01-05','13:51:03',1,'2014-01-07 10:21:36',NULL,NULL),(15483,2634,'2220600','834','00','005010X220A1','2220600','','2014-01-16','12:03:59',0,'2014-01-17 03:36:23',NULL,NULL),(17597,3240,'1389021','834','00','005010X220A1','1389021','','2014-02-03','11:40:14',0,'2014-02-03 21:00:57',NULL,NULL),(17783,3268,'2187140','834','00','005010X220A1','2187140','','2014-02-03','21:23:03',0,'2014-02-04 21:01:21',NULL,NULL),(18553,3452,'3177580','834','00','005010X220A1','3177580','','2014-02-10','14:04:01',0,'2014-02-10 21:30:30',NULL,NULL),(20806,3910,'3338549','834','00','005010X220A1','3338549','','2014-02-24','23:08:46',0,'2014-02-25 21:30:59',NULL,NULL),(21225,3999,'2977946','834','00','005010X220A1','2977946','','2014-02-26','08:51:30',0,'2014-02-26 21:01:33',NULL,NULL),(21229,3999,'2969245','834','00','005010X220A1','2969245','','2014-02-26','10:06:03',0,'2014-02-26 21:01:35',NULL,NULL),(21402,4025,'2818544','834','00','005010X220A1','2818544','','2014-02-27','10:21:41',0,'2014-02-28 06:30:36',NULL,NULL),(22456,4234,'3098180','834','00','005010X220A1','3098180','','2014-03-04','11:39:16',0,'2014-03-04 21:30:21',NULL,NULL),(23390,4401,'3469334','834','00','005010X220A1','3469334','','2014-03-09','14:28:34',0,'2014-03-09 21:00:03',NULL,NULL),(103,4,'467419','834','00','005010X220A1','467419','','2013-12-05','15:21:10',0,'2013-12-25 17:18:07',NULL,NULL),(13733,2275,'1480562','834','00','005010X220A1','1480562','','2014-01-07','13:26:20',0,'2014-01-08 18:24:43',NULL,NULL),(918,177,'407565','834','00','005010X220A1','407565','','2013-12-03','17:40:45',0,'2013-12-25 18:17:37',NULL,NULL),(1037,199,'1311231','834','00','005010X220A1','1311231','','2013-12-03','11:56:54',0,'2013-12-25 18:21:25',NULL,NULL),(12274,1623,'2052115','834','00','005010X220A1','2052115','','2014-01-01','12:20:11',1,'2014-01-02 04:24:21',NULL,NULL),(3845,682,'687572','834','00','005010X220A1','687572','','2013-11-08','17:55:33',0,'2013-12-25 22:30:26',NULL,NULL),(11536,1490,'1892502','834','00','005010X220A1','1892502','','2013-12-27','16:07:08',0,'2013-12-28 03:32:42',NULL,NULL),(10696,1403,'1117345','834','00','005010X220A1','1117345','','2013-12-23','09:39:10',0,'2013-12-26 13:00:23',NULL,NULL),(10466,1400,'14757','834','00','005010X220A1','14757','','2013-12-23','14:10:47',0,'2013-12-26 12:52:48',NULL,NULL),(7646,1311,'1092731','834','00','005010X220A1','1092731','','2013-12-20','22:28:30',0,'2013-12-26 04:38:43',NULL,NULL),(4917,909,'284036','834','00','005010X220A1','284036','','2013-10-16','20:20:26',0,'2013-12-26 00:30:41',NULL,NULL),(6169,1167,'38370','834','00','005010X220A1','38370','','2013-12-20','14:54:42',0,'2013-12-26 03:03:24',NULL,NULL),(5435,1033,'547103','834','00','005010X220A1','547103','','2013-10-04','19:05:14',0,'2013-12-26 01:31:29',NULL,NULL),(5597,1043,'1439652','834','00','005010X220A1','1439652','','2013-12-25','15:39:14',0,'2013-12-26 01:49:34',NULL,NULL),(16265,2957,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',0,'2014-01-23 09:28:22',NULL,NULL),(17593,3240,'2129967','834','00','005010X220A1','2129967','','2014-02-03','09:48:33',0,'2014-02-03 21:00:54',NULL,NULL),(18241,3368,'2660258','834','00','005010X220A1','2660258','','2014-02-07','16:26:56',0,'2014-02-07 19:01:06',NULL,NULL),(18578,3453,'2569134','834','00','005010X220A1','2569134','','2014-02-10','15:02:08',0,'2014-02-10 21:30:49',NULL,NULL),(20062,3754,'2571724','834','00','005010X220A1','2571724','','2014-02-18','09:00:25',0,'2014-02-18 22:01:18',NULL,NULL),(20155,3777,'2831612','834','00','005010X220A1','2831612','','2014-02-18','20:44:08',0,'2014-02-20 04:05:02',NULL,NULL),(20224,3785,'2864287','834','00','005010X220A1','2864287','','2014-02-19','15:38:15',0,'2014-02-20 04:24:30',NULL,NULL),(20435,3841,'2668055','834','00','005010X220A1','2668055','','2014-02-19','23:43:43',0,'2014-02-20 22:00:10',NULL,NULL),(23435,4405,'3154174','834','00','005010X220A1','3154174','','2014-03-09','16:24:10',0,'2014-03-09 21:00:37',NULL,NULL),(1391,245,'1776658','834','00','005010X220A1','1776658','','2013-12-24','17:48:07',0,'2013-12-25 18:53:44',NULL,NULL),(1676,290,'1220269','834','00','005010X220A1','1220269','','2013-12-10','13:47:40',0,'2013-12-25 19:15:42',NULL,NULL),(1835,316,'24577','834','00','005010X220A1','24577','','2013-12-10','14:33:09',0,'2013-12-25 19:20:44',NULL,NULL),(2440,420,'761125','834','00','005010X220A1','761125','','2013-12-05','21:40:40',0,'2013-12-25 20:18:28',NULL,NULL),(10520,1401,'194140','834','00','005010X220A1','194140','','2013-12-23','00:25:17',0,'2013-12-26 12:54:29',NULL,NULL),(7586,1301,'413620','834','00','005010X220A1','413620','','2013-12-21','17:31:44',0,'2013-12-26 04:36:51',NULL,NULL),(17867,3293,'1814283','834','00','005010X220A1','1814283','','2014-02-05','14:40:39',0,'2014-02-05 21:30:14',NULL,NULL),(15628,2674,'2100629','834','00','005010X220A1','2100629','','2014-01-17','15:26:26',0,'2014-01-20 08:06:46',NULL,NULL),(15231,2596,'1425402','834','00','005010X220A1','1425402','','2014-01-15','14:34:06',0,'2014-01-16 08:46:45',NULL,NULL),(564,103,'1039116','834','00','005010X220A1','1039116','','2013-12-16','12:25:50',0,'2013-12-25 18:02:29',NULL,NULL),(5907,1111,'283621','834','00','005010X220A1','283621','','2013-12-15','16:55:17',0,'2013-12-26 02:31:00',NULL,NULL),(6102,1166,'167263','834','00','005010X220A1','167263','','2013-12-20','09:40:45',0,'2013-12-26 03:01:25',NULL,NULL),(3129,551,'58310','834','00','005010X220A1','58310','','2013-12-13','11:27:16',0,'2013-12-25 21:37:05',NULL,NULL),(2361,413,'317763','834','00','005010X220A1','317763','','2013-12-05','20:52:40',0,'2013-12-25 20:16:01',NULL,NULL),(2135,360,'328619','834','00','005010X220A1','328619','','2013-12-02','12:28:12',0,'2013-12-25 19:45:58',NULL,NULL),(11083,1422,'1146474','834','00','005010X220A1','1146474','','2013-12-23','19:06:08',0,'2013-12-26 13:13:32',NULL,NULL),(1398,246,'2068732','834','00','005010X220A1','2068732','','2013-12-24','17:36:36',0,'2013-12-25 18:53:59',NULL,NULL),(1098,226,'603024','834','00','005010X220A1','603024','','2013-10-25','06:59:27',0,'2013-12-25 18:31:57',NULL,NULL),(3586,617,'790663','834','00','005010X220A1','790663','','2013-12-12','14:33:13',0,'2013-12-25 22:03:55',NULL,NULL),(4194,734,'603889','834','00','005010X220A1','603889','','2013-12-19','17:34:01',0,'2013-12-25 23:06:05',NULL,NULL),(4160,734,'418023','834','00','005010X220A1','418023','','2013-12-18','22:52:51',0,'2013-12-25 23:04:59',NULL,NULL),(13662,2271,'2022768','834','00','005010X220A1','2022768','','2014-01-07','11:12:57',0,'2014-01-08 18:24:14',NULL,NULL),(13854,2311,'1948417','834','00','005010X220A1','1948417','','2014-01-09','16:14:02',0,'2014-01-13 02:19:15',NULL,NULL),(16204,2896,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 04:52:40',NULL,NULL),(17361,3181,'2266303','834','00','005010X220A1','2266303','','2014-01-31','16:47:08',0,'2014-01-31 21:01:24',NULL,NULL),(19044,3540,'3039075','834','00','005010X220A1','3039075','','2014-02-12','12:57:06',0,'2014-02-12 21:30:56',NULL,NULL),(21089,3984,'3107908','834','00','005010X220A1','3107908','','2014-02-24','13:55:05',0,'2014-02-26 09:30:56',NULL,NULL),(23424,4405,'3584882','834','00','005010X220A1','3584882','','2014-03-09','10:15:28',0,'2014-03-09 21:00:28',NULL,NULL),(23436,4405,'3636003','834','00','005010X220A1','3636003','','2014-03-09','17:21:59',0,'2014-03-09 21:00:38',NULL,NULL),(2528,455,'569444','834','00','005010X220A1','569444','','2013-11-18','08:44:13',0,'2013-12-25 20:30:51',NULL,NULL),(4640,827,'737877','834','00','005010X220A1','737877','','2013-12-23','23:59:23',0,'2013-12-25 23:48:34',NULL,NULL),(4089,733,'673658','834','00','005010X220A1','673658','','2013-12-19','10:31:00',0,'2013-12-25 23:02:56',NULL,NULL),(11743,1521,'1646081','834','00','005010X220A1','1646081','','2013-12-28','14:34:02',1,'2013-12-29 11:09:14',NULL,NULL),(11871,1560,'2182451','834','00','005010X220A1','2182451','','2013-12-28','21:07:31',0,'2013-12-30 00:00:06',NULL,NULL),(11961,1580,'1559878','834','00','005010X220A1','1559878','','2013-12-30','11:22:10',0,'2014-01-01 12:00:36',NULL,NULL),(3662,626,'1209084','834','00','005010X220A1','1209084','','2013-12-12','12:32:01',0,'2013-12-25 22:06:17',NULL,NULL),(12439,1638,'2232823','834','00','005010X220A1','2232823','','2013-12-31','15:43:38',1,'2014-01-02 04:31:05',NULL,NULL),(3587,617,'528231','834','00','005010X220A1','528231','','2013-12-12','15:43:40',0,'2013-12-25 22:03:57',NULL,NULL),(7583,1301,'1291713','834','00','005010X220A1','1291713','','2013-12-21','17:04:31',0,'2013-12-26 04:36:44',NULL,NULL),(4681,833,'1469268','834','00','005010X220A1','1469268','','2013-12-23','21:19:23',0,'2013-12-25 23:49:59',NULL,NULL),(7546,1300,'384953','834','00','005010X220A1','384953','','2013-12-21','17:51:25',0,'2013-12-26 04:35:29',NULL,NULL),(4864,886,'504817','834','00','005010X220A1','504817','','2013-11-20','21:48:41',0,'2013-12-26 00:16:03',NULL,NULL),(13195,2039,'0001','999','BE','005010X231A1','1194012','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:38',NULL,NULL),(16912,3108,'2511305','834','00','005010X220A1','2511305','','2014-01-28','14:38:09',0,'2014-01-28 21:01:21',NULL,NULL),(18780,3486,'2184995','834','00','005010X220A1','2184995','','2014-02-11','16:09:00',0,'2014-02-11 21:01:00',NULL,NULL),(19505,3621,'2762562','834','00','005010X220A1','2762562','','2014-02-14','06:08:37',0,'2014-02-14 21:30:29',NULL,NULL),(19994,3748,'2189842','834','00','005010X220A1','2189842','','2014-02-18','06:21:58',0,'2014-02-18 22:00:29',NULL,NULL),(20965,3956,'3637799','834','00','005010X220A1','3637799','','2014-02-21','21:11:34',0,'2014-02-26 08:30:04',NULL,NULL),(22094,4176,'3071263','834','00','005010X220A1','3071263','','2014-03-03','11:35:55',0,'2014-03-03 21:30:14',NULL,NULL),(22289,4200,'3744703','834','00','005010X220A1','3744703','','2014-03-04','17:30:08',0,'2014-03-04 21:00:50',NULL,NULL),(23544,4435,'2953422','834','00','005010X220A1','2953422','','2014-03-10','13:04:26',0,'2014-03-10 21:00:34',NULL,NULL),(339,72,'303823','834','00','005010X220A1','303823','','2013-12-04','15:15:46',0,'2013-12-25 17:46:25',NULL,NULL),(13071,1915,'0001','999','BE','005010X231A1','458447','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:18',NULL,NULL),(1080,216,'443199','834','00','005010X220A1','443199','','2013-11-04','11:36:30',0,'2013-12-25 18:31:15',NULL,NULL),(5067,936,'1326713','834','00','005010X220A1','1326713','','2013-12-11','11:44:39',0,'2013-12-26 00:48:09',NULL,NULL),(5112,941,'252972','834','00','005010X220A1','252972','','2013-12-10','22:20:25',0,'2013-12-26 00:49:35',NULL,NULL),(10762,1404,'1290567','834','00','005010X220A1','1290567','','2013-12-22','19:40:06',0,'2013-12-26 13:02:40',NULL,NULL),(5341,1002,'1312655','834','00','005010X220A1','1312655','','2013-11-25','12:16:44',0,'2013-12-26 01:15:32',NULL,NULL),(5491,1041,'1781702','834','00','005010X220A1','1781702','','2013-12-24','18:25:16',0,'2013-12-26 01:46:06',NULL,NULL),(6262,1172,'875059','834','00','005010X220A1','875059','','2013-12-19','23:11:43',0,'2013-12-26 03:06:16',NULL,NULL),(5682,1060,'1876306','834','00','005010X220A1','1876306','','2013-12-24','21:52:41',0,'2013-12-26 01:52:32',NULL,NULL),(5538,1041,'789910','834','00','005010X220A1','789910','','2013-12-24','23:54:25',0,'2013-12-26 01:47:38',NULL,NULL),(14547,2518,'2275943','834','00','005010X220A1','2275943','','2014-01-13','17:24:07',0,'2014-01-14 01:32:33',NULL,NULL),(14571,2520,'2507128','834','00','005010X220A1','2507128','','2014-01-12','20:21:23',0,'2014-01-14 01:32:49',NULL,NULL),(16608,3048,'1886891','834','00','005010X220A1','1886891','','2014-01-26','18:02:20',0,'2014-01-26 19:00:09',NULL,NULL),(18373,3406,'1672116','834','00','005010X220A1','1672116','','2014-02-09','14:26:35',0,'2014-02-09 19:00:17',NULL,NULL),(18766,3485,'2036187','834','00','005010X220A1','2036187','','2014-02-11','17:59:07',0,'2014-02-11 21:00:50',NULL,NULL),(22307,4201,'2970551','834','00','005010X220A1','2970551','','2014-03-04','12:44:20',0,'2014-03-04 21:01:03',NULL,NULL),(783,145,'165234','834','00','005010X220A1','165234','','2013-10-29','11:23:16',0,'2013-12-25 18:09:32',NULL,NULL),(2889,530,'1052566','834','00','005010X220A1','1052566','','2013-12-22','12:30:19',0,'2013-12-25 21:23:19',NULL,NULL),(6401,1192,'126472','834','00','005010X220A1','126472','','2013-12-20','15:07:46',0,'2013-12-26 03:10:30',NULL,NULL),(2204,365,'243503','834','00','005010X220A1','243503','','2013-12-02','14:49:57',0,'2013-12-25 19:48:18',NULL,NULL),(1108,235,'1074935','834','00','005010X220A1','1074935','','2013-11-06','19:38:58',0,'2013-12-25 18:32:20',NULL,NULL),(12786,1703,'2375998','834','00','005010X220A1','2375998','','2014-01-03','00:05:37',0,'2014-01-04 02:00:45',NULL,NULL),(14240,2372,'1655089','834','00','005010X220A1','1655089','','2014-01-10','13:30:37',0,'2014-01-13 02:24:10',NULL,NULL),(15457,2632,'2011453','834','00','005010X220A1','2011453','','2014-01-16','12:28:58',0,'2014-01-17 03:36:12',NULL,NULL),(15993,2765,'1682402','834','00','005010X220A1','1682402','','2014-01-22','12:24:17',0,'2014-01-23 03:02:10',NULL,NULL),(16610,3049,'1908927','834','00','005010X220A1','1908927','','2014-01-25','19:18:38',0,'2014-01-26 19:00:10',NULL,NULL),(18733,3485,'2407208','834','00','005010X220A1','2407208','','2014-02-11','11:02:23',0,'2014-02-11 21:00:25',NULL,NULL),(18837,3490,'2312020','834','00','005010X220A1','2312020','','2014-02-11','15:39:32',0,'2014-02-11 21:01:42',NULL,NULL),(21629,4067,'3517752','834','00','005010X220A1','3517752','','2014-02-26','19:45:12',0,'2014-02-28 07:30:24',NULL,NULL),(22567,4248,'3051144','834','00','005010X220A1','3051144','','2014-03-05','13:25:20',0,'2014-03-05 21:30:55',NULL,NULL),(22748,4276,'3377919','834','00','005010X220A1','3377919','','2014-03-06','13:01:17',0,'2014-03-06 21:00:28',NULL,NULL),(376,74,'31369','834','00','005010X220A1','31369','','2013-12-04','15:30:22',0,'2013-12-25 17:47:36',NULL,NULL),(5319,996,'442082','834','00','005010X220A1','442082','','2013-11-05','13:56:29',0,'2013-12-26 01:02:10',NULL,NULL),(5826,1088,'347216','834','00','005010X220A1','347216','','2013-11-23','15:54:38',0,'2013-12-26 02:15:16',NULL,NULL),(4959,930,'397705','834','00','005010X220A1','397705','','2013-10-06','20:47:14',0,'2013-12-26 00:32:10',NULL,NULL),(3544,616,'232692','834','00','005010X220A1','232692','','2013-12-12','12:01:14',0,'2013-12-25 22:02:35',NULL,NULL),(7357,1283,'1106091','834','00','005010X220A1','1106091','','2013-11-30','17:41:45',0,'2013-12-26 04:15:43',NULL,NULL),(1920,325,'516162','834','00','005010X220A1','516162','','2013-12-09','17:31:18',0,'2013-12-25 19:32:20',NULL,NULL),(11042,1418,'783127','834','00','005010X220A1','783127','','2013-12-23','11:06:39',0,'2013-12-26 13:12:12',NULL,NULL),(11503,1489,'2256228','834','00','005010X220A1','2256228','','2013-12-27','14:43:35',0,'2013-12-28 03:31:44',NULL,NULL),(1238,243,'926579','834','00','005010X220A1','926579','','2013-12-24','10:49:29',0,'2013-12-25 18:48:52',NULL,NULL),(11997,1581,'1927904','834','00','005010X220A1','1927904','','2013-12-29','20:25:23',0,'2014-01-01 12:01:56',NULL,NULL),(15922,2744,'1876977','834','00','005010X220A1','1876977','','2014-01-21','09:51:55',1,'2014-01-22 03:22:54',NULL,NULL),(19108,3544,'2375627','834','00','005010X220A1','2375627','','2014-02-12','09:30:41',0,'2014-02-12 21:31:43',NULL,NULL),(20054,3753,'3488616','834','00','005010X220A1','3488616','','2014-02-18','09:50:59',0,'2014-02-18 22:01:11',NULL,NULL),(20299,3796,'2452381','834','00','005010X220A1','2452381','','2014-02-19','11:36:05',0,'2014-02-20 04:43:10',NULL,NULL),(22462,4238,'3294609','834','00','005010X220A1','3294609','','2014-03-05','10:34:30',0,'2014-03-05 21:00:11',NULL,NULL),(1012,188,'896988','834','00','005010X220A1','896988','','2013-12-03','17:24:23',0,'2013-12-25 18:20:38',NULL,NULL),(11137,1432,'1460324','834','00','005010X220A1','1460324','','2013-12-23','10:06:18',0,'2013-12-26 13:15:28',NULL,NULL),(11811,1539,'1547016','834','00','005010X220A1','1547016','','2013-12-28','20:14:24',1,'2013-12-29 11:13:24',NULL,NULL),(5658,1051,'1661512','834','00','005010X220A1','1661512','','2013-12-25','09:36:42',0,'2013-12-26 01:51:34',NULL,NULL),(3308,584,'313181','834','00','005010X220A1','313181','','2013-12-17','13:28:56',0,'2013-12-25 21:48:44',NULL,NULL),(13199,2043,'0001','999','BE','005010X231A1','687572','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:49',NULL,NULL),(1976,326,'6387','834','00','005010X220A1','6387','','2013-12-09','16:25:07',0,'2013-12-25 19:34:01',NULL,NULL),(14317,2395,'1923092','834','00','005010X220A1','1923092','','2014-01-10','15:34:48',0,'2014-01-13 03:00:41',NULL,NULL),(14959,2566,'2027679','834','00','005010X220A1','2027679','','2014-01-14','14:49:16',0,'2014-01-15 02:07:56',NULL,NULL),(15015,2584,'2349506','834','00','005010X220A1','2349506','','2014-01-15','12:53:33',0,'2014-01-16 08:44:27',NULL,NULL),(16796,3088,'2524181','834','00','005010X220A1','2524181','','2014-01-28','12:56:59',0,'2014-01-28 21:00:05',NULL,NULL),(19953,3743,'2552268','834','00','005010X220A1','2552268','','2014-02-18','16:04:16',0,'2014-02-18 21:30:21',NULL,NULL),(21307,4008,'2886064','834','00','005010X220A1','2886064','','2014-02-26','16:37:43',0,'2014-02-26 21:02:30',NULL,NULL),(21743,4090,'3451410','834','00','005010X220A1','3451410','','2014-02-27','20:02:56',0,'2014-02-28 21:30:43',NULL,NULL),(22197,4185,'2586030','834','00','005010X220A1','2586030','','2014-03-02','19:30:29',0,'2014-03-03 21:31:30',NULL,NULL),(22411,4215,'2989569','834','00','005010X220A1','2989569','','2014-03-04','14:45:15',0,'2014-03-04 21:02:30',NULL,NULL),(22777,4277,'3875158','834','00','005010X220A1','3875158','','2014-03-06','11:25:02',0,'2014-03-06 21:00:49',NULL,NULL),(23501,4434,'3113217','834','00','005010X220A1','3113217','','2014-03-09','21:42:50',0,'2014-03-10 21:00:04',NULL,NULL),(23650,4441,'3038524','834','00','005010X220A1','3038524','','2014-03-10','17:19:19',0,'2014-03-10 21:01:51',NULL,NULL),(1128,238,'1495759','834','00','005010X220A1','1495759','','2013-12-24','14:30:49',0,'2013-12-25 18:45:31',NULL,NULL),(12197,1608,'1868292','834','00','005010X220A1','1868292','','2013-12-30','12:14:53',0,'2014-01-01 12:09:12',NULL,NULL),(10842,1404,'689976','834','00','005010X220A1','689976','','2013-12-23','19:16:37',0,'2013-12-26 13:05:12',NULL,NULL),(3582,617,'1048311','834','00','005010X220A1','1048311','','2013-12-12','12:36:38',0,'2013-12-25 22:03:48',NULL,NULL),(2563,464,'989773','834','00','005010X220A1','989773','','2013-11-18','17:03:10',0,'2013-12-25 20:32:00',NULL,NULL),(12380,1637,'1932189','834','00','005010X220A1','1932189','','2013-12-30','19:56:45',1,'2014-01-02 04:28:58',NULL,NULL),(12520,1643,'1907029','834','00','005010X220A1','1907029','','2013-12-31','14:14:24',1,'2014-01-02 04:34:03',NULL,NULL),(12773,1702,'2482419','834','00','005010X220A1','2482419','','2014-01-03','11:48:10',0,'2014-01-04 02:00:12',NULL,NULL),(13490,2226,'1502178','834','00','005010X220A1','1502178','','2014-01-06','17:22:20',0,'2014-01-07 04:04:13',NULL,NULL),(5234,955,'432684','834','00','005010X220A1','432684','','2013-12-11','15:41:00',0,'2013-12-26 00:53:30',NULL,NULL),(11587,1492,'1116230','834','00','005010X220A1','1116230','','2013-12-27','17:10:52',0,'2013-12-28 03:34:19',NULL,NULL),(11347,1456,'2211275','834','00','005010X220A1','2211275','','2013-12-26','18:18:43',0,'2013-12-27 02:04:55',NULL,NULL),(5482,1040,'1653548','834','00','005010X220A1','1653548','','2013-12-25','00:08:35',0,'2013-12-26 01:45:49',NULL,NULL),(5848,1092,'1065194','834','00','005010X220A1','1065194','','2013-11-23','16:56:03',0,'2013-12-26 02:16:04',NULL,NULL),(6316,1175,'796112','834','00','005010X220A1','796112','','2013-12-20','13:31:54',0,'2013-12-26 03:07:52',NULL,NULL),(13517,2235,'2379703','834','00','005010X220A1','2379703','','2014-01-06','09:55:41',0,'2014-01-07 04:05:18',NULL,NULL),(13908,2313,'1713000','834','00','005010X220A1','1713000','','2014-01-08','21:04:09',0,'2014-01-13 02:19:50',NULL,NULL),(15848,2738,'1650551','834','00','005010X220A1','1650551','','2014-01-21','00:49:36',1,'2014-01-22 03:22:08',NULL,NULL),(15849,2738,'1836032','834','00','005010X220A1','1836032','','2014-01-21','06:33:14',1,'2014-01-22 03:22:08',NULL,NULL),(18019,3318,'2918571','834','00','005010X220A1','2918571','','2014-02-05','19:31:37',0,'2014-02-06 21:00:20',NULL,NULL),(18714,3485,'2228649','834','00','005010X220A1','2228649','','2014-02-10','20:25:18',0,'2014-02-11 21:00:11',NULL,NULL),(19603,3632,'2644980','834','00','005010X220A1','2644980','','2014-02-14','15:37:57',0,'2014-02-14 21:31:39',NULL,NULL),(20203,3782,'3494494','834','00','005010X220A1','3494494','','2014-02-19','10:38:08',0,'2014-02-20 04:18:42',NULL,NULL),(22841,4279,'2913133','834','00','005010X220A1','2913133','','2014-03-05','18:44:01',0,'2014-03-06 21:01:33',NULL,NULL),(23301,4381,'3391200','834','00','005010X220A1','3391200','','2014-03-07','23:26:42',0,'2014-03-08 21:30:21',NULL,NULL),(23577,4436,'3674131','834','00','005010X220A1','3674131','','2014-03-10','16:32:23',0,'2014-03-10 21:01:00',NULL,NULL),(61,3,'1169631','834','00','005010X220A1','1169631','','2013-12-05','06:39:06',0,'2013-12-25 17:16:50',NULL,NULL),(5669,1053,'1540484','834','00','005010X220A1','1540484','','2013-12-24','23:46:05',0,'2013-12-26 01:52:00',NULL,NULL),(10540,1401,'1353786','834','00','005010X220A1','1353786','','2013-12-23','18:13:23',0,'2013-12-26 12:55:09',NULL,NULL),(3786,656,'49381','834','00','005010X220A1','49381','','2013-12-08','13:56:43',0,'2013-12-25 22:15:50',NULL,NULL),(12396,1637,'1863240','834','00','005010X220A1','1863240','','2013-12-31','11:55:48',1,'2014-01-02 04:29:31',NULL,NULL),(1559,272,'358611','834','00','005010X220A1','358611','','2013-12-24','15:04:23',0,'2013-12-25 18:59:17',NULL,NULL),(12736,1685,'1681904','834','00','005010X220A1','1681904','','2014-01-02','14:33:48',0,'2014-01-03 02:06:09',NULL,NULL),(14619,2524,'1817332','834','00','005010X220A1','1817332','','2014-01-13','09:49:34',0,'2014-01-14 01:33:19',NULL,NULL),(14846,2553,'1983317','834','00','005010X220A1','1983317','','2014-01-14','12:36:39',0,'2014-01-15 02:07:04',NULL,NULL),(15598,2661,'1360736','834','00','005010X220A1','1360736','','2014-01-17','00:50:50',0,'2014-01-20 08:06:25',NULL,NULL),(15753,2714,'2512475','834','00','005010X220A1','2512475','','2014-01-19','19:56:14',0,'2014-01-21 08:46:19',NULL,NULL),(16444,3006,'2527781','834','00','005010X220A1','2527781','','2014-01-23','19:14:48',0,'2014-01-24 21:00:09',NULL,NULL),(17162,3144,'1937873','834','00','005010X220A1','1937873','','2014-01-30','17:35:32',0,'2014-01-30 21:00:44',NULL,NULL),(19499,3621,'2670755','834','00','005010X220A1','2670755','','2014-02-13','18:26:39',0,'2014-02-14 21:30:25',NULL,NULL),(19971,3746,'2592236','834','00','005010X220A1','2592236','','2014-02-18','13:30:08',0,'2014-02-18 22:00:12',NULL,NULL),(20087,3764,'2837380','834','00','005010X220A1','2837380','','2014-02-18','12:11:35',0,'2014-02-18 22:01:36',NULL,NULL),(20633,3873,'2444900','834','00','005010X220A1','2444900','','2014-02-20','18:28:08',0,'2014-02-21 22:00:40',NULL,NULL),(21712,4088,'2965570','834','00','005010X220A1','2965570','','2014-02-28','10:51:48',0,'2014-02-28 21:30:23',NULL,NULL),(22422,4221,'3861287','834','00','005010X220A1','3861287','','2014-03-04','13:06:55',0,'2014-03-04 21:02:39',NULL,NULL),(23478,4422,'3118342','834','00','005010X220A1','3118342','','2014-03-09','14:35:04',0,'2014-03-09 21:01:16',NULL,NULL),(1654,288,'202088','834','00','005010X220A1','202088','','2013-11-19','23:07:52',0,'2013-12-25 19:02:38',NULL,NULL),(11420,1472,'2197141','834','00','005010X220A1','2197141','','2013-12-26','11:52:27',0,'2013-12-27 02:07:12',NULL,NULL),(6394,1188,'111232','834','00','005010X220A1','111232','','2013-12-20','15:06:37',0,'2013-12-26 03:10:16',NULL,NULL),(5489,1040,'1844433','834','00','005010X220A1','1844433','','2013-12-25','14:34:54',0,'2013-12-26 01:46:02',NULL,NULL),(4642,827,'618430','834','00','005010X220A1','618430','','2013-12-24','00:13:38',0,'2013-12-25 23:48:37',NULL,NULL),(3870,693,'82776','834','00','005010X220A1','82776','','2013-10-10','01:54:35',0,'2013-12-25 22:31:13',NULL,NULL),(13568,2254,'1862239','834','00','005010X220A1','1862239','','2014-01-04','23:39:13',1,'2014-01-07 10:21:29',NULL,NULL),(3077,545,'301736','834','00','005010X220A1','301736','','2013-12-13','11:50:03',0,'2013-12-25 21:35:30',NULL,NULL),(15541,2654,'1905164','834','00','005010X220A1','1905164','','2014-01-16','22:09:30',0,'2014-01-20 08:05:42',NULL,NULL),(15713,2706,'2000653','834','00','005010X220A1','2000653','','2014-01-19','10:53:16',0,'2014-01-21 08:45:38',NULL,NULL),(16722,3064,'1714743','834','00','005010X220A1','1714743','','2014-01-27','16:05:07',0,'2014-01-27 21:00:58',NULL,NULL),(17201,3149,'2210753','834','00','005010X220A1','2210753','','2014-01-30','16:30:22',0,'2014-01-30 21:01:09',NULL,NULL),(17489,3220,'2436708','834','00','005010X220A1','2436708','','2014-02-02','10:27:00',0,'2014-02-02 19:00:18',NULL,NULL),(17676,3259,'2151277','834','00','005010X220A1','2151277','','2014-02-04','10:37:49',0,'2014-02-04 21:00:15',NULL,NULL),(18543,3452,'2348613','834','00','005010X220A1','2348613','','2014-02-10','10:12:52',0,'2014-02-10 21:30:24',NULL,NULL),(20791,3909,'2837503','834','00','005010X220A1','2837503','','2014-02-24','18:49:54',0,'2014-02-25 21:30:49',NULL,NULL),(21062,3979,'3732238','834','00','005010X220A1','3732238','','2014-02-24','16:07:03',0,'2014-02-26 09:30:36',NULL,NULL),(21099,3990,'2850567','834','00','005010X220A1','2850567','','2014-02-24','16:09:24',0,'2014-02-26 09:31:05',NULL,NULL),(21319,4013,'3207987','834','00','005010X220A1','3207987','','2014-02-26','12:49:18',0,'2014-02-26 21:02:40',NULL,NULL),(21372,4024,'2659623','834','00','005010X220A1','2659623','','2014-02-27','11:53:43',0,'2014-02-28 06:30:22',NULL,NULL),(21630,4067,'2736570','834','00','005010X220A1','2736570','','2014-02-26','19:45:12',0,'2014-02-28 07:30:25',NULL,NULL),(22030,4161,'2680054','834','00','005010X220A1','2680054','','2014-03-02','11:43:23',0,'2014-03-03 01:29:59',NULL,NULL),(22203,4185,'3615211','834','00','005010X220A1','3615211','','2014-03-03','13:27:40',0,'2014-03-03 21:31:34',NULL,NULL),(2947,541,'490785','834','00','005010X220A1','490785','','2013-12-13','09:35:25',0,'2013-12-25 21:31:28',NULL,NULL),(7027,1235,'694772','834','00','005010X220A1','694772','','2013-12-18','12:31:06',0,'2013-12-26 04:01:19',NULL,NULL),(7243,1243,'142668','834','00','005010X220A1','142668','','2013-12-18','16:04:44',0,'2013-12-26 04:07:59',NULL,NULL),(7722,1338,'746356','834','00','005010X220A1','746356','','2013-11-15','12:19:47',0,'2013-12-26 04:46:14',NULL,NULL),(6337,1176,'1019024','834','00','005010X220A1','1019024','','2013-12-20','14:39:53',0,'2013-12-26 03:08:31',NULL,NULL),(4259,741,'1133910','834','00','005010X220A1','1133910','','2013-12-19','18:01:24',0,'2013-12-25 23:08:05',NULL,NULL),(12129,1587,'2083402','834','00','005010X220A1','2083402','','2013-12-30','17:37:00',0,'2014-01-01 12:06:44',NULL,NULL),(12605,1671,'1624552','834','00','005010X220A1','1624552','','2014-01-02','18:06:09',0,'2014-01-03 02:01:17',NULL,NULL),(4229,738,'329262','834','00','005010X220A1','329262','','2013-12-19','14:09:13',0,'2013-12-25 23:07:08',NULL,NULL),(14856,2553,'1772138','834','00','005010X220A1','1772138','','2014-01-14','16:38:36',0,'2014-01-15 02:07:09',NULL,NULL),(17280,3170,'1678394','834','00','005010X220A1','1678394','','2014-01-31','17:36:29',0,'2014-01-31 21:00:28',NULL,NULL),(18723,3485,'2307334','834','00','005010X220A1','2307334','','2014-02-11','02:54:03',0,'2014-02-11 21:00:17',NULL,NULL),(18789,3487,'2446028','834','00','005010X220A1','2446028','','2014-02-11','09:36:07',0,'2014-02-11 21:01:07',NULL,NULL),(18868,3493,'2717262','834','00','005010X220A1','2717262','','2014-02-11','11:57:22',0,'2014-02-11 21:02:08',NULL,NULL),(19064,3542,'3309636','834','00','005010X220A1','3309636','','2014-02-12','15:43:47',0,'2014-02-12 21:31:11',NULL,NULL),(19101,3543,'2402457','834','00','005010X220A1','2402457','','2014-02-12','14:05:18',0,'2014-02-12 21:31:38',NULL,NULL),(20548,3862,'3630653','834','00','005010X220A1','3630653','','2014-02-20','23:07:46',0,'2014-02-21 21:30:04',NULL,NULL),(20682,3883,'3036784','834','00','005010X220A1','3036784','','2014-02-21','16:32:18',0,'2014-02-21 22:01:14',NULL,NULL),(5179,949,'672005','834','00','005010X220A1','672005','','2013-12-10','21:18:52',0,'2013-12-26 00:51:40',NULL,NULL),(10437,1400,'1631622','834','00','005010X220A1','1631622','','2013-12-23','11:38:09',0,'2013-12-26 12:51:51',NULL,NULL),(10711,1403,'889962','834','00','005010X220A1','889962','','2013-12-23','11:38:28',0,'2013-12-26 13:00:55',NULL,NULL),(10812,1404,'804882','834','00','005010X220A1','804882','','2013-12-23','15:33:15',0,'2013-12-26 13:04:15',NULL,NULL),(11100,1425,'1471619','834','00','005010X220A1','1471619','','2013-12-22','21:59:44',0,'2013-12-26 13:14:06',NULL,NULL),(11239,1454,'1886106','834','00','005010X220A1','1886106','','2013-12-26','13:01:27',0,'2013-12-27 02:01:38',NULL,NULL),(12491,1641,'2429008','834','00','005010X220A1','2429008','','2013-12-31','00:28:51',1,'2014-01-02 04:33:01',NULL,NULL),(5870,1103,'309819','834','00','005010X220A1','309819','','2013-10-28','16:40:34',0,'2013-12-26 02:16:55',NULL,NULL),(4332,754,'423893','834','00','005010X220A1','423893','','2013-12-19','08:19:26',0,'2013-12-25 23:10:12',NULL,NULL),(7141,1237,'148007','834','00','005010X220A1','148007','','2013-12-17','22:12:14',0,'2013-12-26 04:04:48',NULL,NULL),(3446,605,'493209','834','00','005010X220A1','493209','','2013-12-17','12:37:09',0,'2013-12-25 21:53:12',NULL,NULL),(11922,1565,'1437408','834','00','005010X220A1','1437408','','2013-12-29','15:07:38',0,'2013-12-30 00:01:40',NULL,NULL),(3350,587,'751847','834','00','005010X220A1','751847','','2013-12-17','07:59:08',0,'2013-12-25 21:50:11',NULL,NULL),(3019,543,'1022679','834','00','005010X220A1','1022679','','2013-12-13','15:04:37',0,'2013-12-25 21:33:41',NULL,NULL),(15949,2763,'1682396','834','00','005010X220A1','1682396','','2014-01-22','09:07:50',0,'2014-01-23 03:01:50',NULL,NULL),(15999,2766,'1594451','834','00','005010X220A1','1594451','','2014-01-22','13:17:47',0,'2014-01-23 03:02:12',NULL,NULL),(16646,3060,'2351104','834','00','005010X220A1','2351104','','2014-01-27','11:04:34',0,'2014-01-27 21:00:08',NULL,NULL),(19357,3585,'3344136','834','00','005010X220A1','3344136','','2014-02-13','14:09:45',0,'2014-02-13 22:01:57',NULL,NULL),(19798,3677,'2905800','834','00','005010X220A1','2905800','','2014-02-15','12:02:08',0,'2014-02-15 22:01:20',NULL,NULL),(20146,3776,'2793734','834','00','005010X220A1','2793734','','2014-02-18','18:04:54',0,'2014-02-20 04:02:41',NULL,NULL),(20863,3912,'3040710','834','00','005010X220A1','3040710','','2014-02-24','18:37:27',0,'2014-02-25 21:31:40',NULL,NULL),(23276,4380,'3165707','834','00','005010X220A1','3165707','','2014-03-07','21:58:19',0,'2014-03-08 21:30:02',NULL,NULL),(23766,4480,'2976048','834','00','005010X220A1','2976048','','2014-03-10','13:21:23',0,'2014-03-10 21:30:14',NULL,NULL),(809,159,'20194','834','00','005010X220A1','20194','','2013-10-31','15:24:14',0,'2013-12-25 18:10:33',NULL,NULL),(2026,331,'311400','834','00','005010X220A1','311400','','2013-12-09','16:01:56',0,'2013-12-25 19:35:40',NULL,NULL),(5226,954,'1268610','834','00','005010X220A1','1268610','','2013-12-11','13:07:16',0,'2013-12-26 00:53:16',NULL,NULL),(1198,239,'1262113','834','00','005010X220A1','1262113','','2013-12-24','17:56:02',0,'2013-12-25 18:47:42',NULL,NULL),(5508,1041,'687352','834','00','005010X220A1','687352','','2013-12-24','20:19:47',0,'2013-12-26 01:46:42',NULL,NULL),(6245,1170,'782953','834','00','005010X220A1','782953','','2013-12-20','16:34:23',0,'2013-12-26 03:05:45',NULL,NULL),(12137,1589,'2125134','834','00','005010X220A1','2125134','','2013-12-29','22:15:36',0,'2014-01-01 12:07:01',NULL,NULL),(13246,2090,'0001','999','BE','005010X231A1','294252','834','2013-12-28','04:55:00',0,'2014-01-05 17:02:00',NULL,NULL),(886,177,'1233561','834','00','005010X220A1','1233561','','2013-12-03','09:30:30',0,'2013-12-25 18:16:44',NULL,NULL),(14808,2552,'1971958','834','00','005010X220A1','1971958','','2014-01-13','19:18:39',0,'2014-01-15 02:06:48',NULL,NULL),(15135,2587,'1667832','834','00','005010X220A1','1667832','','2014-01-15','17:50:36',0,'2014-01-16 08:45:44',NULL,NULL),(16040,2771,'1787971','834','00','005010X220A1','1787971','','2014-01-22','11:31:30',0,'2014-01-23 03:02:31',NULL,NULL),(16819,3090,'2189313','834','00','005010X220A1','2189313','','2014-01-28','11:05:20',0,'2014-01-28 21:00:20',NULL,NULL),(17490,3220,'2685731','834','00','005010X220A1','2685731','','2014-02-02','12:30:14',0,'2014-02-02 19:00:18',NULL,NULL),(19449,3607,'3126382','834','00','005010X220A1','3126382','','2014-02-13','12:47:27',0,'2014-02-13 22:03:07',NULL,NULL),(19676,3663,'3113964','834','00','005010X220A1','3113964','','2014-02-14','17:08:47',0,'2014-02-14 22:00:08',NULL,NULL),(21832,4099,'3644308','834','00','005010X220A1','3644308','','2014-02-28','15:58:49',0,'2014-02-28 21:31:44',NULL,NULL),(849,175,'1149638','834','00','005010X220A1','1149638','','2013-12-03','15:02:52',0,'2013-12-25 18:15:37',NULL,NULL),(2044,333,'297956','834','00','005010X220A1','297956','','2013-12-08','23:42:16',0,'2013-12-25 19:36:13',NULL,NULL),(3132,551,'8862','834','00','005010X220A1','8862','','2013-12-13','14:06:20',0,'2013-12-25 21:37:10',NULL,NULL),(13121,1965,'0001','999','BE','005010X231A1','848292','834','2013-12-27','16:55:00',0,'2014-01-05 16:54:37',NULL,NULL),(13094,1938,'0001','999','BE','005010X231A1','1241530','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:21',NULL,NULL),(6400,1191,'901447','834','00','005010X220A1','901447','','2013-12-20','15:59:47',0,'2013-12-26 03:10:28',NULL,NULL),(11151,1435,'966237','834','00','005010X220A1','966237','','2013-12-23','10:28:09',0,'2013-12-26 13:15:55',NULL,NULL),(11468,1488,'156794','834','00','005010X220A1','156794','','2013-12-27','12:01:15',0,'2013-12-28 03:30:41',NULL,NULL),(14168,2363,'2162524','834','00','005010X220A1','2162524','','2014-01-10','14:37:32',0,'2014-01-13 02:23:18',NULL,NULL),(14893,2558,'1944872','834','00','005010X220A1','1944872','','2014-01-14','11:28:34',0,'2014-01-15 02:07:27',NULL,NULL),(15953,2763,'1791481','834','00','005010X220A1','1791481','','2014-01-21','18:39:39',0,'2014-01-23 03:01:51',NULL,NULL),(16339,2983,'1646781','834','00','005010X220A1','1646781','','2014-01-23','16:23:59',0,'2014-01-23 21:00:41',NULL,NULL),(17122,3143,'2072108','834','00','005010X220A1','2072108','','2014-01-30','11:53:41',0,'2014-01-30 21:00:19',NULL,NULL),(19298,3582,'2909225','834','00','005010X220A1','2909225','','2014-02-13','17:42:57',0,'2014-02-13 22:01:12',NULL,NULL),(20285,3794,'3461519','834','00','005010X220A1','3461519','','2014-02-19','10:28:22',0,'2014-02-20 04:39:20',NULL,NULL),(20296,3796,'3455961','834','00','005010X220A1','3455961','','2014-02-19','10:36:28',0,'2014-02-20 04:42:19',NULL,NULL),(21889,4125,'3770892','834','00','005010X220A1','3770892','','2014-02-28','19:37:17',0,'2014-03-01 21:00:23',NULL,NULL),(22355,4205,'3606834','834','00','005010X220A1','3606834','','2014-03-04','10:43:12',0,'2014-03-04 21:01:42',NULL,NULL),(22968,4313,'3224244','834','00','005010X220A1','3224244','','2014-03-06','13:24:41',0,'2014-03-06 21:30:09',NULL,NULL),(996,185,'321582','834','00','005010X220A1','321582','','2013-12-02','21:41:47',0,'2013-12-25 18:20:07',NULL,NULL),(13706,2274,'1589162','834','00','005010X220A1','1589162','','2014-01-07','18:14:26',0,'2014-01-08 18:24:32',NULL,NULL),(12501,1642,'2389532','834','00','005010X220A1','2389532','','2013-12-31','12:14:10',1,'2014-01-02 04:33:24',NULL,NULL),(2202,365,'549790','834','00','005010X220A1','549790','','2013-12-02','11:38:04',0,'2013-12-25 19:48:14',NULL,NULL),(12936,1728,'1376630','834','00','005010X220A1','1376630','','2014-01-03','17:10:30',0,'2014-01-04 02:06:20',NULL,NULL),(2725,503,'1435849','834','00','005010X220A1','1435849','','2013-12-22','04:09:18',0,'2013-12-25 21:17:58',NULL,NULL),(3097,546,'1261435','834','00','005010X220A1','1261435','','2013-12-13','09:14:55',0,'2013-12-25 21:36:06',NULL,NULL),(10596,1402,'993521','834','00','005010X220A1','993521','','2013-12-23','12:39:19',0,'2013-12-26 12:57:03',NULL,NULL),(4197,735,'565197','834','00','005010X220A1','565197','','2013-12-18','19:12:17',0,'2013-12-25 23:06:10',NULL,NULL),(7745,1344,'413565','834','00','005010X220A1','413565','','2013-10-20','20:11:41',0,'2013-12-26 05:00:41',NULL,NULL),(7413,1295,'1279991','834','00','005010X220A1','1279991','','2013-12-20','23:49:28',0,'2013-12-26 04:31:17',NULL,NULL),(7194,1239,'282734','834','00','005010X220A1','282734','','2013-12-18','16:51:30',0,'2013-12-26 04:06:27',NULL,NULL),(5881,1109,'1167348','834','00','005010X220A1','1167348','','2013-12-14','19:15:09',0,'2013-12-26 02:30:09',NULL,NULL),(14864,2555,'1375668','834','00','005010X220A1','1375668','','2014-01-13','19:42:59',0,'2014-01-15 02:07:12',NULL,NULL),(15627,2673,'2147221','834','00','005010X220A1','2147221','','2014-01-17','15:26:10',0,'2014-01-20 08:06:46',NULL,NULL),(22985,4318,'2769363','834','00','005010X220A1','2769363','','2014-03-06','14:14:03',0,'2014-03-06 21:30:22',NULL,NULL),(23609,4440,'3205762','834','00','005010X220A1','3205762','','2014-03-10','14:50:41',0,'2014-03-10 21:01:23',NULL,NULL),(15816,2732,'2356735','834','00','005010X220A1','2356735','','2014-01-20','13:47:42',0,'2014-01-21 08:46:58',NULL,NULL),(16026,2768,'2305541','834','00','005010X220A1','2305541','','2014-01-22','14:08:29',0,'2014-01-23 03:02:24',NULL,NULL),(16523,3016,'1500352','834','00','005010X220A1','1500352','','2014-01-24','08:49:22',0,'2014-01-24 21:00:56',NULL,NULL),(16750,3067,'1501466','834','00','005010X220A1','1501466','','2014-01-27','14:54:08',0,'2014-01-27 21:01:18',NULL,NULL),(18323,3385,'2436848','834','00','005010X220A1','2436848','','2014-02-08','12:14:52',0,'2014-02-08 19:00:49',NULL,NULL),(20333,3801,'3415696','834','00','005010X220A1','3415696','','2014-02-18','22:48:37',0,'2014-02-20 04:51:31',NULL,NULL),(20620,3871,'2585759','834','00','005010X220A1','2585759','','2014-02-20','19:26:41',0,'2014-02-21 22:00:30',NULL,NULL),(21684,4083,'3810475','834','00','005010X220A1','3810475','','2014-02-28','14:34:06',0,'2014-02-28 21:00:25',NULL,NULL),(405,76,'170581','834','00','005010X220A1','170581','','2013-12-04','14:36:32',0,'2013-12-25 17:48:32',NULL,NULL),(13605,2261,'1415013','834','00','005010X220A1','1415013','','2014-01-05','12:38:49',1,'2014-01-07 10:23:00',NULL,NULL),(1534,261,'875379','834','00','005010X220A1','875379','','2013-12-24','10:58:14',0,'2013-12-25 18:58:28',NULL,NULL),(3302,584,'99159','834','00','005010X220A1','99159','','2013-12-17','11:44:38',0,'2013-12-25 21:48:32',NULL,NULL),(13239,2083,'0001','999','BE','005010X231A1','1160865','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:41',NULL,NULL),(12822,1704,'1700519','834','00','005010X220A1','1700519','','2014-01-02','22:37:52',0,'2014-01-04 02:02:03',NULL,NULL),(12399,1637,'1656348','834','00','005010X220A1','1656348','','2013-12-31','12:18:08',1,'2014-01-02 04:29:38',NULL,NULL),(11513,1490,'1523296','834','00','005010X220A1','1523296','','2013-12-27','10:43:00',0,'2013-12-28 03:32:02',NULL,NULL),(6389,1186,'507945','834','00','005010X220A1','507945','','2013-12-20','14:25:37',0,'2013-12-26 03:10:07',NULL,NULL),(5749,1070,'1088178','834','00','005010X220A1','1088178','','2013-12-14','16:14:52',0,'2013-12-26 02:01:51',NULL,NULL),(5346,1003,'264280','834','00','005010X220A1','264280','','2013-11-25','11:16:44',0,'2013-12-26 01:15:42',NULL,NULL),(15805,2725,'1580948','834','00','005010X220A1','1580948','','2014-01-20','12:38:17',0,'2014-01-21 08:46:51',NULL,NULL),(16681,3062,'1642042','834','00','005010X220A1','1642042','','2014-01-27','00:49:29',0,'2014-01-27 21:00:31',NULL,NULL),(17272,3170,'2095905','834','00','005010X220A1','2095905','','2014-01-31','14:23:47',0,'2014-01-31 21:00:22',NULL,NULL),(18560,3453,'2847376','834','00','005010X220A1','2847376','','2014-02-09','22:03:28',0,'2014-02-10 21:30:36',NULL,NULL),(18989,3537,'3210102','834','00','005010X220A1','3210102','','2014-02-12','14:41:40',0,'2014-02-12 21:30:20',NULL,NULL),(23012,4323,'3200938','834','00','005010X220A1','3200938','','2014-03-07','09:02:33',0,'2014-03-07 21:00:16',NULL,NULL),(23196,4346,'2675546','834','00','005010X220A1','2675546','','2014-03-07','08:10:36',0,'2014-03-07 21:31:43',NULL,NULL),(23526,4434,'2866358','834','00','005010X220A1','2866358','','2014-03-10','16:57:03',0,'2014-03-10 21:00:21',NULL,NULL),(248,43,'581326','834','00','005010X220A1','581326','','2013-11-13','17:31:54',0,'2013-12-25 17:30:47',NULL,NULL),(586,104,'444836','834','00','005010X220A1','444836','','2013-12-15','23:54:20',0,'2013-12-25 18:03:07',NULL,NULL),(13785,2292,'2150620','834','00','005010X220A1','2150620','','2014-01-07','15:29:32',0,'2014-01-08 18:25:08',NULL,NULL),(2255,379,'211124','834','00','005010X220A1','211124','','2013-12-02','08:41:30',0,'2013-12-25 19:50:04',NULL,NULL),(13456,2225,'2061905','834','00','005010X220A1','2061905','','2014-01-06','12:32:17',0,'2014-01-07 04:02:59',NULL,NULL),(13236,2080,'0001','999','BE','005010X231A1','1124188','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:32',NULL,NULL),(3181,568,'103003','834','00','005010X220A1','103003','','2013-12-13','15:32:19',0,'2013-12-25 21:38:53',NULL,NULL),(11308,1456,'2145409','834','00','005010X220A1','2145409','','2013-12-26','10:39:12',0,'2013-12-27 02:03:45',NULL,NULL),(6076,1164,'510569','834','00','005010X220A1','510569','','2013-12-20','18:32:49',0,'2013-12-26 03:00:33',NULL,NULL),(4592,826,'1730144','834','00','005010X220A1','1730144','','2013-12-23','23:16:34',0,'2013-12-25 23:47:01',NULL,NULL),(5405,1021,'45046','834','00','005010X220A1','45046','','2013-11-13','22:31:43',0,'2013-12-26 01:30:23',NULL,NULL),(15150,2588,'2076733','834','00','005010X220A1','2076733','','2014-01-15','00:53:29',0,'2014-01-16 08:45:54',NULL,NULL),(16255,2947,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:31:00',0,'2014-01-23 07:07:31',NULL,NULL),(16415,2997,'1763785','834','00','005010X220A1','1763785','','2014-01-23','11:42:47',0,'2014-01-23 21:01:31',NULL,NULL),(17862,3293,'2581474','834','00','005010X220A1','2581474','','2014-02-05','11:28:53',0,'2014-02-05 21:30:12',NULL,NULL),(18549,3452,'3066276','834','00','005010X220A1','3066276','','2014-02-10','13:32:28',0,'2014-02-10 21:30:28',NULL,NULL),(20776,3907,'2899458','834','00','005010X220A1','2899458','','2014-02-25','09:53:02',0,'2014-02-25 21:30:37',NULL,NULL),(21875,4122,'2608783','834','00','005010X220A1','2608783','','2014-03-01','10:26:53',0,'2014-03-01 21:00:13',NULL,NULL),(2801,506,'731900','834','00','005010X220A1','731900','','2013-12-22','13:06:12',0,'2013-12-25 21:20:23',NULL,NULL),(5432,1032,'993711','834','00','005010X220A1','993711','','2013-10-04','23:26:05',0,'2013-12-26 01:31:24',NULL,NULL),(11648,1499,'2076218','834','00','005010X220A1','2076218','','2013-12-27','12:08:36',0,'2013-12-28 03:36:13',NULL,NULL),(12740,1686,'2077404','834','00','005010X220A1','2077404','','2014-01-02','15:14:30',0,'2014-01-03 02:06:18',NULL,NULL),(15116,2587,'2430691','834','00','005010X220A1','2430691','','2014-01-15','12:47:56',0,'2014-01-16 08:45:31',NULL,NULL),(15170,2591,'1689900','834','00','005010X220A1','1689900','','2014-01-14','20:28:36',0,'2014-01-16 08:46:08',NULL,NULL),(17377,3186,'1969829','834','00','005010X220A1','1969829','','2014-01-31','17:25:40',0,'2014-01-31 21:01:36',NULL,NULL),(17856,3293,'2038905','834','00','005010X220A1','2038905','','2014-02-04','23:02:58',0,'2014-02-05 21:30:09',NULL,NULL),(18986,3537,'2461064','834','00','005010X220A1','2461064','','2014-02-12','12:47:40',0,'2014-02-12 21:30:17',NULL,NULL),(19263,3581,'1870898','834','00','005010X220A1','1870898','','2014-02-13','15:01:13',0,'2014-02-13 22:00:44',NULL,NULL),(19355,3585,'3344117','834','00','005010X220A1','3344117','','2014-02-13','11:35:05',0,'2014-02-13 22:01:56',NULL,NULL),(22210,4186,'3669749','834','00','005010X220A1','3669749','','2014-03-03','16:23:27',0,'2014-03-03 21:31:39',NULL,NULL),(488,102,'1040432','834','00','005010X220A1','1040432','','2013-12-15','18:20:56',0,'2013-12-25 18:00:05',NULL,NULL),(1150,239,'1417136','834','00','005010X220A1','1417136','','2013-12-24','10:35:38',0,'2013-12-25 18:46:11',NULL,NULL),(12656,1672,'2015440','834','00','005010X220A1','2015440','','2014-01-02','17:52:01',0,'2014-01-03 02:03:09',NULL,NULL),(2651,501,'671105','834','00','005010X220A1','671105','','2013-12-22','00:49:42',0,'2013-12-25 21:15:25',NULL,NULL),(4445,801,'415032','834','00','005010X220A1','415032','','2013-11-25','18:41:13',0,'2013-12-25 23:30:16',NULL,NULL),(5803,1078,'532213','834','00','005010X220A1','532213','','2013-12-14','13:30:42',0,'2013-12-26 02:03:38',NULL,NULL),(15630,2675,'1726872','834','00','005010X220A1','1726872','','2014-01-18','17:34:16',0,'2014-01-21 08:44:12',NULL,NULL),(15877,2739,'1367994','834','00','005010X220A1','1367994','','2014-01-21','14:20:53',1,'2014-01-22 03:22:26',NULL,NULL),(18317,3384,'2189579','834','00','005010X220A1','2189579','','2014-02-08','15:47:22',0,'2014-02-08 19:00:45',NULL,NULL),(19535,3622,'3258659','834','00','005010X220A1','3258659','','2014-02-14','17:41:04',0,'2014-02-14 21:30:51',NULL,NULL),(20538,3855,'3412074','834','00','005010X220A1','3412074','','2014-02-20','11:16:42',0,'2014-02-20 22:01:35',NULL,NULL),(20927,3936,'3140058','834','00','005010X220A1','3140058','','2014-02-23','08:52:56',0,'2014-02-26 08:00:23',NULL,NULL),(21234,3999,'3448705','834','00','005010X220A1','3448705','','2014-02-26','11:28:41',0,'2014-02-26 21:01:38',NULL,NULL),(858,175,'964115','834','00','005010X220A1','964115','','2013-12-03','16:14:59',0,'2013-12-25 18:15:53',NULL,NULL),(13928,2317,'2243572','834','00','005010X220A1','2243572','','2014-01-08','18:50:16',0,'2014-01-13 02:20:03',NULL,NULL),(4169,734,'665049','834','00','005010X220A1','665049','','2013-12-19','10:11:22',0,'2013-12-25 23:05:15',NULL,NULL),(11018,1414,'1450627','834','00','005010X220A1','1450627','','2013-12-23','19:08:26',0,'2013-12-26 13:11:24',NULL,NULL),(10523,1401,'1302079','834','00','005010X220A1','1302079','','2013-12-23','08:54:31',0,'2013-12-26 12:54:34',NULL,NULL),(5959,1117,'1236767','834','00','005010X220A1','1236767','','2013-12-14','22:31:56',0,'2013-12-26 02:32:37',NULL,NULL),(7073,1236,'1227520','834','00','005010X220A1','1227520','','2013-12-18','07:37:57',0,'2013-12-26 04:02:46',NULL,NULL),(6009,1136,'929551','834','00','005010X220A1','929551','','2013-11-17','10:00:21',0,'2013-12-26 02:45:12',NULL,NULL),(5969,1117,'1256670','834','00','005010X220A1','1256670','','2013-12-15','16:36:46',0,'2013-12-26 02:32:57',NULL,NULL),(15319,2622,'1561779','834','00','005010X220A1','1561779','','2014-01-16','10:00:10',0,'2014-01-17 03:35:09',NULL,NULL),(16701,3064,'1512775','834','00','005010X220A1','1512775','','2014-01-26','22:52:28',0,'2014-01-27 21:00:44',NULL,NULL),(18648,3464,'3143302','834','00','005010X220A1','3143302','','2014-02-10','09:50:12',0,'2014-02-10 21:31:38',NULL,NULL),(19800,3677,'2785079','834','00','005010X220A1','2785079','','2014-02-15','13:54:50',0,'2014-02-15 22:01:22',NULL,NULL),(19948,3740,'2908072','834','00','005010X220A1','2908072','','2014-02-18','14:26:58',0,'2014-02-18 21:30:17',NULL,NULL),(20453,3842,'3421038','834','00','005010X220A1','3421038','','2014-02-19','20:14:54',0,'2014-02-20 22:00:25',NULL,NULL),(21077,3980,'2780489','834','00','005010X220A1','2780489','','2014-02-24','16:42:39',0,'2014-02-26 09:30:47',NULL,NULL),(23580,4436,'3434161','834','00','005010X220A1','3434161','','2014-03-10','17:14:07',0,'2014-03-10 21:01:03',NULL,NULL),(461,86,'994064','834','00','005010X220A1','994064','','2013-12-03','19:12:11',0,'2013-12-25 17:50:20',NULL,NULL),(506,102,'493158','834','00','005010X220A1','493158','','2013-12-16','10:29:27',0,'2013-12-25 18:00:39',NULL,NULL),(11576,1492,'2139040','834','00','005010X220A1','2139040','','2013-12-27','15:43:52',0,'2013-12-28 03:34:00',NULL,NULL),(6256,1172,'997226','834','00','005010X220A1','997226','','2013-12-19','21:24:26',0,'2013-12-26 03:06:06',NULL,NULL),(5814,1083,'164817','834','00','005010X220A1','164817','','2013-12-14','16:12:56',0,'2013-12-26 02:04:00',NULL,NULL),(697,113,'1151114','834','00','005010X220A1','1151114','','2013-12-15','22:06:51',0,'2013-12-25 18:06:39',NULL,NULL),(2873,518,'846317','834','00','005010X220A1','846317','','2013-12-22','08:57:25',0,'2013-12-25 21:22:45',NULL,NULL),(3473,615,'1132235','834','00','005010X220A1','1132235','','2013-12-11','23:07:16',0,'2013-12-25 22:00:19',NULL,NULL),(3510,615,'524650','834','00','005010X220A1','524650','','2013-12-12','15:53:56',0,'2013-12-25 22:01:32',NULL,NULL),(4088,733,'644089','834','00','005010X220A1','644089','','2013-12-19','10:27:08',0,'2013-12-25 23:02:55',NULL,NULL),(4846,884,'1043789','834','00','005010X220A1','1043789','','2013-11-20','20:52:46',0,'2013-12-26 00:15:28',NULL,NULL),(16148,2840,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:55:00',1,'2014-01-23 04:00:32',NULL,NULL),(16915,3111,'2234964','834','00','005010X220A1','2234964','','2014-01-28','18:12:17',0,'2014-01-28 21:01:22',NULL,NULL),(18606,3456,'3047995','834','00','005010X220A1','3047995','','2014-02-10','13:36:24',0,'2014-02-10 21:31:08',NULL,NULL),(19431,3601,'2730924','834','00','005010X220A1','2730924','','2014-02-13','13:31:57',0,'2014-02-13 22:02:52',NULL,NULL),(19918,3727,'3275002','834','00','005010X220A1','3275002','','2014-02-17','12:35:56',0,'2014-02-17 19:00:12',NULL,NULL),(23121,4342,'3737053','834','00','005010X220A1','3737053','','2014-03-07','05:02:35',0,'2014-03-07 21:30:50',NULL,NULL),(23622,4441,'3140582','834','00','005010X220A1','3140582','','2014-03-10','10:36:00',0,'2014-03-10 21:01:31',NULL,NULL),(14329,2400,'1856328','834','00','005010X220A1','1856328','','2014-01-12','12:20:40',0,'2014-01-13 03:01:10',NULL,NULL),(14199,2365,'2396711','834','00','005010X220A1','2396711','','2014-01-10','14:12:02',0,'2014-01-13 02:23:43',NULL,NULL),(53,3,'1032362','834','00','005010X220A1','1032362','','2013-12-04','23:36:38',0,'2013-12-25 17:16:36',NULL,NULL),(13410,2222,'2097769','834','00','005010X220A1','2097769','','2014-01-05','19:57:58',0,'2014-01-07 04:01:14',NULL,NULL),(13050,1894,'0001','999','BE','005010X231A1','391883','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:20',NULL,NULL),(4814,867,'1012185','834','00','005010X220A1','1012185','','2013-12-01','07:32:28',0,'2013-12-26 00:02:16',NULL,NULL),(11490,1489,'1453198','834','00','005010X220A1','1453198','','2013-12-26','18:31:32',0,'2013-12-28 03:31:21',NULL,NULL),(5994,1128,'517383','834','00','005010X220A1','517383','','2013-12-15','13:21:31',0,'2013-12-26 02:33:49',NULL,NULL),(12457,1639,'2384780','834','00','005010X220A1','2384780','','2013-12-31','12:45:52',1,'2014-01-02 04:31:46',NULL,NULL),(6260,1172,'869184','834','00','005010X220A1','869184','','2013-12-19','21:41:05',0,'2013-12-26 03:06:13',NULL,NULL),(7142,1237,'1315866','834','00','005010X220A1','1315866','','2013-12-18','10:21:59',0,'2013-12-26 04:04:52',NULL,NULL),(15273,2607,'1879189','834','00','005010X220A1','1879189','','2014-01-15','10:34:46',0,'2014-01-16 08:47:13',NULL,NULL),(15304,2622,'1536012','834','00','005010X220A1','1536012','','2014-01-15','21:37:39',0,'2014-01-17 03:35:03',NULL,NULL),(15584,2659,'1986115','834','00','005010X220A1','1986115','','2014-01-16','21:27:53',0,'2014-01-20 08:06:16',NULL,NULL),(15744,2712,'2548999','834','00','005010X220A1','2548999','','2014-01-20','14:18:45',0,'2014-01-21 08:46:14',NULL,NULL),(16511,3013,'1662285','834','00','005010X220A1','1662285','','2014-01-23','19:56:18',0,'2014-01-24 21:00:49',NULL,NULL),(23319,4382,'3706054','834','00','005010X220A1','3706054','','2014-03-07','22:16:11',0,'2014-03-08 21:30:35',NULL,NULL),(17135,3144,'1697273','834','00','005010X220A1','1697273','','2014-01-29','22:01:43',0,'2014-01-30 21:00:28',NULL,NULL),(17924,3296,'1865352','834','00','005010X220A1','1865352','','2014-02-05','12:49:51',0,'2014-02-05 21:30:42',NULL,NULL),(19232,3580,'2825380','834','00','005010X220A1','2825380','','2014-02-13','12:01:14',0,'2014-02-13 22:00:20',NULL,NULL),(19423,3598,'2639945','834','00','005010X220A1','2639945','','2014-02-13','16:16:50',0,'2014-02-13 22:02:46',NULL,NULL),(19999,3748,'2847615','834','00','005010X220A1','2847615','','2014-02-18','10:39:52',0,'2014-02-18 22:00:32',NULL,NULL),(20134,3772,'3343245','834','00','005010X220A1','3343245','','2014-02-19','16:31:22',0,'2014-02-20 03:59:18',NULL,NULL),(20412,3834,'3511249','834','00','005010X220A1','3511249','','2014-02-20','14:00:56',0,'2014-02-20 21:30:14',NULL,NULL),(172,16,'1206192','834','00','005010X220A1','1206192','','2013-12-04','20:26:17',0,'2013-12-25 17:20:20',NULL,NULL),(14478,2499,'0001','999','BE','005010X231A1','305119','834','2013-12-28','04:55:00',0,'2014-01-13 03:03:50',NULL,NULL),(2991,542,'647776','834','00','005010X220A1','647776','','2013-12-13','12:50:20',0,'2013-12-25 21:32:50',NULL,NULL),(3207,578,'238010','834','00','005010X220A1','238010','','2013-12-17','06:32:38',0,'2013-12-25 21:45:31',NULL,NULL),(13640,2270,'2340589','834','00','005010X220A1','2340589','','2014-01-07','18:05:34',0,'2014-01-08 18:24:06',NULL,NULL),(3222,578,'602554','834','00','005010X220A1','602554','','2013-12-17','10:01:50',0,'2013-12-25 21:45:58',NULL,NULL),(3903,711,'829230','834','00','005010X220A1','829230','','2013-12-07','16:57:43',0,'2013-12-25 22:45:06',NULL,NULL),(20932,3939,'3566628','834','00','005010X220A1','3566628','','2014-02-23','13:34:12',0,'2014-02-26 08:00:27',NULL,NULL),(21728,4088,'3430265','834','00','005010X220A1','3430265','','2014-02-28','15:35:27',0,'2014-02-28 21:30:32',NULL,NULL),(22362,4205,'3271709','834','00','005010X220A1','3271709','','2014-03-04','13:27:38',0,'2014-03-04 21:01:48',NULL,NULL),(313,70,'281118','834','00','005010X220A1','281118','','2013-12-03','23:35:51',0,'2013-12-25 17:45:35',NULL,NULL),(11932,1570,'1858346','834','00','005010X220A1','1858346','','2013-12-29','13:05:23',0,'2013-12-30 00:02:02',NULL,NULL),(606,108,'1039092','834','00','005010X220A1','1039092','','2013-12-15','19:09:28',0,'2013-12-25 18:03:48',NULL,NULL),(7522,1300,'1070040','834','00','005010X220A1','1070040','','2013-12-21','12:56:08',0,'2013-12-26 04:34:44',NULL,NULL),(1231,243,'69502','834','00','005010X220A1','69502','','2013-12-24','10:03:04',0,'2013-12-25 18:48:42',NULL,NULL),(2696,502,'33148','834','00','005010X220A1','33148','','2013-12-22','14:01:05',0,'2013-12-25 21:17:03',NULL,NULL),(3261,579,'485559','834','00','005010X220A1','485559','','2013-12-17','15:29:53',0,'2013-12-25 21:47:09',NULL,NULL),(3409,591,'411873','834','00','005010X220A1','411873','','2013-12-17','11:35:00',0,'2013-12-25 21:51:58',NULL,NULL),(3438,601,'238952','834','00','005010X220A1','238952','','2013-12-17','09:32:10',0,'2013-12-25 21:52:55',NULL,NULL),(16510,3013,'1960736','834','00','005010X220A1','1960736','','2014-01-23','19:27:02',0,'2014-01-24 21:00:48',NULL,NULL),(17385,3193,'2369543','834','00','005010X220A1','2369543','','2014-01-31','16:20:51',0,'2014-01-31 21:01:42',NULL,NULL),(18167,3350,'2458376','834','00','005010X220A1','2458376','','2014-02-07','15:37:30',0,'2014-02-07 19:00:13',NULL,NULL),(18925,3519,'1970089','834','00','005010X220A1','1970089','','2014-02-11','18:20:14',0,'2014-02-11 21:30:05',NULL,NULL),(18985,3537,'1884872','834','00','005010X220A1','1884872','','2014-02-12','12:28:47',0,'2014-02-12 21:30:16',NULL,NULL),(19590,3629,'3256450','834','00','005010X220A1','3256450','','2014-02-14','17:13:16',0,'2014-02-14 21:31:30',NULL,NULL),(19672,3659,'2257432','834','00','005010X220A1','2257432','','2014-02-14','15:48:18',0,'2014-02-14 22:00:04',NULL,NULL),(20622,3871,'2890838','834','00','005010X220A1','2890838','','2014-02-21','13:05:46',0,'2014-02-21 22:00:32',NULL,NULL),(21420,4026,'3201825','834','00','005010X220A1','3201825','','2014-02-27','12:46:02',0,'2014-02-28 06:30:44',NULL,NULL),(21594,4060,'3617442','834','00','005010X220A1','3617442','','2014-02-26','13:57:52',0,'2014-02-28 07:00:36',NULL,NULL),(22773,4277,'2965788','834','00','005010X220A1','2965788','','2014-03-05','23:15:17',0,'2014-03-06 21:00:46',NULL,NULL),(23718,4459,'2662351','834','00','005010X220A1','2662351','','2014-03-10','12:17:53',0,'2014-03-10 21:02:42',NULL,NULL),(23751,4473,'3278201','834','00','005010X220A1','3278201','','2014-03-10','16:59:19',0,'2014-03-10 21:30:02',NULL,NULL),(3078,545,'354011','834','00','005010X220A1','354011','','2013-12-13','12:20:18',0,'2013-12-25 21:35:32',NULL,NULL),(12509,1642,'1925540','834','00','005010X220A1','1925540','','2013-12-31','17:12:16',1,'2014-01-02 04:33:42',NULL,NULL),(12139,1590,'2449979','834','00','005010X220A1','2449979','','2013-12-30','10:44:00',0,'2014-01-01 12:07:04',NULL,NULL),(10491,1400,'396407','834','00','005010X220A1','396407','','2013-12-23','17:02:09',0,'2013-12-26 12:53:35',NULL,NULL),(3179,567,'982882','834','00','005010X220A1','982882','','2013-12-13','14:15:22',0,'2013-12-25 21:38:48',NULL,NULL),(4771,861,'1268348','834','00','005010X220A1','1268348','','2013-12-01','18:03:08',0,'2013-12-26 00:01:02',NULL,NULL),(4112,733,'782864','834','00','005010X220A1','782864','','2013-12-19','12:45:19',0,'2013-12-25 23:03:34',NULL,NULL),(15935,2753,'2018075','834','00','005010X220A1','2018075','','2014-01-21','14:51:44',1,'2014-01-22 03:23:03',NULL,NULL),(15987,2765,'1947745','834','00','005010X220A1','1947745','','2014-01-22','10:48:43',0,'2014-01-23 03:02:07',NULL,NULL),(16061,2772,'1609353','834','00','005010X220A1','1609353','','2014-01-22','12:57:58',0,'2014-01-23 03:02:41',NULL,NULL),(16187,2879,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:53:00',1,'2014-01-23 04:27:53',NULL,NULL),(16842,3092,'1660861','834','00','005010X220A1','1660861','','2014-01-27','19:24:14',0,'2014-01-28 21:00:34',NULL,NULL),(17707,3261,'2526844','834','00','005010X220A1','2526844','','2014-02-03','21:49:19',0,'2014-02-04 21:00:33',NULL,NULL),(19797,3677,'2879624','834','00','005010X220A1','2879624','','2014-02-14','20:04:17',0,'2014-02-15 22:01:20',NULL,NULL),(22013,4150,'3795507','834','00','005010X220A1','3795507','','2014-03-02','14:38:21',0,'2014-03-03 01:00:31',NULL,NULL),(22961,4312,'3518029','834','00','005010X220A1','3518029','','2014-03-05','22:43:46',0,'2014-03-06 21:30:05',NULL,NULL),(23715,4458,'3084112','834','00','005010X220A1','3084112','','2014-03-10','16:08:13',0,'2014-03-10 21:02:39',NULL,NULL),(23746,4472,'3114722','834','00','005010X220A1','3114722','','2014-03-10','11:07:57',0,'2014-03-10 21:29:58',NULL,NULL),(162,11,'55637','834','00','005010X220A1','55637','','2013-12-05','10:26:31',0,'2013-12-25 17:20:00',NULL,NULL),(4805,865,'598293','834','00','005010X220A1','598293','','2013-12-01','12:11:20',0,'2013-12-26 00:02:01',NULL,NULL),(4423,788,'857349','834','00','005010X220A1','857349','','2013-11-06','07:47:18',0,'2013-12-25 23:16:47',NULL,NULL),(1807,309,'1194199','834','00','005010X220A1','1194199','','2013-12-10','10:39:34',0,'2013-12-25 19:19:53',NULL,NULL),(1785,300,'14128','834','00','005010X220A1','14128','','2013-12-09','21:50:10',0,'2013-12-25 19:19:07',NULL,NULL),(1050,204,'15164','834','00','005010X220A1','15164','','2013-11-29','17:16:03',0,'2013-12-25 18:30:16',NULL,NULL),(544,103,'315517','834','00','005010X220A1','315517','','2013-12-15','19:31:54',0,'2013-12-25 18:01:50',NULL,NULL),(12508,1642,'1745228','834','00','005010X220A1','1745228','','2013-12-31','16:37:03',1,'2014-01-02 04:33:40',NULL,NULL),(13060,1904,'0001','999','BE','005010X231A1','974347','834','2013-12-28','04:55:00',0,'2014-01-05 16:51:48',NULL,NULL),(13214,2058,'0001','999','BE','005010X231A1','306736','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:31',NULL,NULL),(14290,2379,'1535820','834','00','005010X220A1','1535820','','2014-01-10','15:36:28',0,'2014-01-13 03:00:21',NULL,NULL),(14430,2451,'0001','999','BE','005010X231A1','644770','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:41',NULL,NULL),(14567,2519,'2129453','834','00','005010X220A1','2129453','','2014-01-13','15:34:18',0,'2014-01-14 01:32:46',NULL,NULL),(14620,2524,'1557851','834','00','005010X220A1','1557851','','2014-01-13','10:14:05',0,'2014-01-14 01:33:20',NULL,NULL),(16258,2950,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:21:00',0,'2014-01-23 08:13:36',NULL,NULL),(16274,2966,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:41:00',0,'2014-01-23 12:00:03',NULL,NULL),(16367,2986,'2435311','834','00','005010X220A1','2435311','','2014-01-23','10:37:49',0,'2014-01-23 21:00:59',NULL,NULL),(16413,2996,'2298126','834','00','005010X220A1','2298126','','2014-01-23','15:56:06',0,'2014-01-23 21:01:30',NULL,NULL),(16997,3118,'1799020','834','00','005010X220A1','1799020','','2014-01-29','10:48:21',0,'2014-01-29 21:00:52',NULL,NULL),(20549,3862,'3711055','834','00','005010X220A1','3711055','','2014-02-20','20:36:29',0,'2014-02-21 21:30:04',NULL,NULL),(21450,4028,'3801421','834','00','005010X220A1','3801421','','2014-02-26','21:16:20',0,'2014-02-28 06:30:59',NULL,NULL),(22430,4227,'2975813','834','00','005010X220A1','2975813','','2014-03-04','16:39:08',0,'2014-03-04 21:02:46',NULL,NULL),(23173,4345,'3279197','834','00','005010X220A1','3279197','','2014-03-06','20:30:59',0,'2014-03-07 21:31:27',NULL,NULL),(18466,3427,'1604668','834','00','005010X220A1','1604668','','2014-02-10','04:14:04',0,'2014-02-10 11:00:48',NULL,NULL),(19322,3583,'2938740','834','00','005010X220A1','2938740','','2014-02-13','11:42:27',0,'2014-02-13 22:01:32',NULL,NULL),(19704,3671,'2783823','834','00','005010X220A1','2783823','','2014-02-15','13:47:43',0,'2014-02-15 22:00:10',NULL,NULL),(5639,1048,'1904509','834','00','005010X220A1','1904509','','2013-12-24','20:50:36',0,'2013-12-26 01:50:57',NULL,NULL),(10529,1401,'227561','834','00','005010X220A1','227561','','2013-12-23','12:48:01',0,'2013-12-26 12:54:48',NULL,NULL),(6357,1180,'375470','834','00','005010X220A1','375470','','2013-12-20','14:24:47',0,'2013-12-26 03:09:06',NULL,NULL),(10848,1405,'528806','834','00','005010X220A1','528806','','2013-12-23','14:28:40',0,'2013-12-26 13:05:26',NULL,NULL),(5993,1128,'78383','834','00','005010X220A1','78383','','2013-12-15','10:44:46',0,'2013-12-26 02:33:47',NULL,NULL),(5940,1113,'496573','834','00','005010X220A1','496573','','2013-12-14','23:05:39',0,'2013-12-26 02:32:01',NULL,NULL),(13892,2312,'1793404','834','00','005010X220A1','1793404','','2014-01-09','13:52:49',0,'2014-01-13 02:19:40',NULL,NULL),(14494,2515,'1569345','834','00','005010X220A1','1569345','','2014-01-12','18:14:08',0,'2014-01-14 01:31:57',NULL,NULL),(14718,2550,'1927207','834','00','005010X220A1','1927207','','2014-01-14','11:16:46',0,'2014-01-15 02:06:10',NULL,NULL),(17574,3236,'2291739','834','00','005010X220A1','2291739','','2014-02-03','16:40:55',0,'2014-02-03 21:00:40',NULL,NULL),(19059,3542,'2090026','834','00','005010X220A1','2090026','','2014-02-12','13:13:38',0,'2014-02-12 21:31:07',NULL,NULL),(19979,3746,'3381556','834','00','005010X220A1','3381556','','2014-02-18','14:36:03',0,'2014-02-18 22:00:18',NULL,NULL),(20627,3871,'3200475','834','00','005010X220A1','3200475','','2014-02-21','16:00:52',0,'2014-02-21 22:00:36',NULL,NULL),(22742,4276,'2820168','834','00','005010X220A1','2820168','','2014-03-06','10:38:46',0,'2014-03-06 21:00:23',NULL,NULL),(733,126,'697434','834','00','005010X220A1','697434','','2013-12-16','11:24:40',0,'2013-12-25 18:07:50',NULL,NULL),(5812,1083,'227085','834','00','005010X220A1','227085','','2013-12-14','15:31:18',0,'2013-12-26 02:03:56',NULL,NULL),(5332,1002,'644700','834','00','005010X220A1','644700','','2013-11-25','15:37:41',0,'2013-12-26 01:15:14',NULL,NULL),(5085,938,'845791','834','00','005010X220A1','845791','','2013-12-11','08:29:13',0,'2013-12-26 00:48:43',NULL,NULL),(11257,1454,'1602524','834','00','005010X220A1','1602524','','2013-12-26','17:39:00',0,'2013-12-27 02:02:10',NULL,NULL),(1032,196,'958947','834','00','005010X220A1','958947','','2013-12-03','10:59:00',0,'2013-12-25 18:21:15',NULL,NULL),(12398,1637,'2526036','834','00','005010X220A1','2526036','','2013-12-31','12:14:11',1,'2014-01-02 04:29:36',NULL,NULL),(14050,2339,'1539448','834','00','005010X220A1','1539448','','2014-01-07','19:18:16',0,'2014-01-13 02:21:37',NULL,NULL),(14147,2356,'2203717','834','00','005010X220A1','2203717','','2014-01-08','16:38:34',0,'2014-01-13 02:22:40',NULL,NULL),(17749,3262,'2617734','834','00','005010X220A1','2617734','','2014-02-04','12:07:56',0,'2014-02-04 21:01:00',NULL,NULL),(18172,3350,'2637252','834','00','005010X220A1','2637252','','2014-02-07','16:35:02',0,'2014-02-07 19:00:15',NULL,NULL),(18183,3351,'1553282','834','00','005010X220A1','1553282','','2014-02-07','09:35:25',0,'2014-02-07 19:00:23',NULL,NULL),(18551,3452,'2357174','834','00','005010X220A1','2357174','','2014-02-10','13:53:23',0,'2014-02-10 21:30:29',NULL,NULL),(19706,3671,'3292724','834','00','005010X220A1','3292724','','2014-02-15','14:36:14',0,'2014-02-15 22:00:12',NULL,NULL),(19875,3709,'2629481','834','00','005010X220A1','2629481','','2014-02-15','22:33:06',0,'2014-02-16 19:00:21',NULL,NULL),(22949,4304,'3140467','834','00','005010X220A1','3140467','','2014-03-06','13:25:32',0,'2014-03-06 21:02:53',NULL,NULL),(1085,218,'313682','834','00','005010X220A1','313682','','2013-11-03','23:59:59',0,'2013-12-25 18:31:28',NULL,NULL),(5602,1044,'705360','834','00','005010X220A1','705360','','2013-12-24','19:19:30',0,'2013-12-26 01:49:42',NULL,NULL),(3775,656,'369254','834','00','005010X220A1','369254','','2013-12-07','18:30:10',0,'2013-12-25 22:15:31',NULL,NULL),(11187,1453,'1442238','834','00','005010X220A1','1442238','','2013-12-25','18:33:15',0,'2013-12-27 02:00:02',NULL,NULL),(3248,578,'700062','834','00','005010X220A1','700062','','2013-12-17','16:24:27',0,'2013-12-25 21:46:48',NULL,NULL),(11629,1496,'1597354','834','00','005010X220A1','1597354','','2013-12-27','15:51:55',0,'2013-12-28 03:35:37',NULL,NULL),(13425,2222,'1475616','834','00','005010X220A1','1475616','','2014-01-05','21:08:55',0,'2014-01-07 04:01:45',NULL,NULL),(16400,2993,'1507574','834','00','005010X220A1','1507574','','2014-01-23','09:44:22',0,'2014-01-23 21:01:22',NULL,NULL),(16853,3092,'1571015','834','00','005010X220A1','1571015','','2014-01-28','18:03:43',0,'2014-01-28 21:00:42',NULL,NULL),(16953,3115,'2695817','834','00','005010X220A1','2695817','','2014-01-29','17:01:48',0,'2014-01-29 21:00:25',NULL,NULL),(18187,3351,'2703865','834','00','005010X220A1','2703865','','2014-02-07','10:17:04',0,'2014-02-07 19:00:26',NULL,NULL),(18787,3487,'2300031','834','00','005010X220A1','2300031','','2014-02-11','00:19:39',0,'2014-02-11 21:01:05',NULL,NULL),(19313,3583,'3227165','834','00','005010X220A1','3227165','','2014-02-12','23:26:00',0,'2014-02-13 22:01:23',NULL,NULL),(21733,4089,'3006894','834','00','005010X220A1','3006894','','2014-02-28','10:09:02',0,'2014-02-28 21:30:35',NULL,NULL),(22246,4200,'3603322','834','00','005010X220A1','3603322','','2014-03-03','18:12:38',0,'2014-03-04 21:00:16',NULL,NULL),(22893,4284,'3506689','834','00','005010X220A1','3506689','','2014-03-06','11:44:13',0,'2014-03-06 21:02:10',NULL,NULL),(22979,4317,'3479474','834','00','005010X220A1','3479474','','2014-03-06','13:52:54',0,'2014-03-06 21:30:18',NULL,NULL),(566,103,'182289','834','00','005010X220A1','182289','','2013-12-16','13:19:50',0,'2013-12-25 18:02:33',NULL,NULL),(13813,2297,'2486390','834','00','005010X220A1','2486390','','2014-01-11','12:48:41',0,'2014-01-13 02:18:24',NULL,NULL),(13710,2275,'2179172','834','00','005010X220A1','2179172','','2014-01-06','21:41:25',0,'2014-01-08 18:24:33',NULL,NULL),(1493,255,'973609','834','00','005010X220A1','973609','','2013-12-24','08:57:34',0,'2013-12-25 18:57:10',NULL,NULL),(12092,1587,'1611598','834','00','005010X220A1','1611598','','2013-12-29','19:51:19',0,'2014-01-01 12:05:27',NULL,NULL),(11814,1539,'1866798','834','00','005010X220A1','1866798','','2013-12-28','20:21:12',1,'2013-12-29 11:13:30',NULL,NULL),(11092,1424,'569042','834','00','005010X220A1','569042','','2013-12-22','22:36:57',0,'2013-12-26 13:13:50',NULL,NULL),(2452,422,'476570','834','00','005010X220A1','476570','','2013-12-06','14:57:41',0,'2013-12-25 20:18:55',NULL,NULL),(3244,578,'116012','834','00','005010X220A1','116012','','2013-12-17','15:45:02',0,'2013-12-25 21:46:40',NULL,NULL),(10583,1402,'1243721','834','00','005010X220A1','1243721','','2013-12-23','12:10:14',0,'2013-12-26 12:56:39',NULL,NULL),(6252,1172,'537431','834','00','005010X220A1','537431','','2013-12-19','20:39:31',0,'2013-12-26 03:05:59',NULL,NULL),(6022,1139,'427144','834','00','005010X220A1','427144','','2013-11-17','11:42:47',0,'2013-12-26 02:45:37',NULL,NULL),(5269,973,'1072593','834','00','005010X220A1','1072593','','2013-11-12','04:16:01',0,'2013-12-26 01:00:18',NULL,NULL),(13836,2306,'1640601','834','00','005010X220A1','1640601','','2014-01-11','12:35:12',0,'2014-01-13 02:18:39',NULL,NULL),(14651,2530,'1919338','834','00','005010X220A1','1919338','','2014-01-13','14:27:42',0,'2014-01-14 01:33:39',NULL,NULL),(15746,2712,'2169074','834','00','005010X220A1','2169074','','2014-01-20','17:10:10',0,'2014-01-21 08:46:15',NULL,NULL),(16792,3088,'1759593','834','00','005010X220A1','1759593','','2014-01-27','18:26:11',0,'2014-01-28 21:00:03',NULL,NULL),(18185,3351,'1609736','834','00','005010X220A1','1609736','','2014-02-07','09:59:41',0,'2014-02-07 19:00:24',NULL,NULL),(18333,3386,'2250243','834','00','005010X220A1','2250243','','2014-02-08','15:44:14',0,'2014-02-08 19:00:55',NULL,NULL),(19545,3626,'3227218','834','00','005010X220A1','3227218','','2014-02-13','18:48:43',0,'2014-02-14 21:30:58',NULL,NULL),(19592,3630,'3013931','834','00','005010X220A1','3013931','','2014-02-13','19:11:21',0,'2014-02-14 21:31:32',NULL,NULL),(21088,3984,'2631954','834','00','005010X220A1','2631954','','2014-02-24','13:24:08',0,'2014-02-26 09:30:55',NULL,NULL),(21747,4090,'2933631','834','00','005010X220A1','2933631','','2014-02-27','22:52:58',0,'2014-02-28 21:30:45',NULL,NULL),(21906,4127,'3013075','834','00','005010X220A1','3013075','','2014-03-01','11:32:06',0,'2014-03-01 21:00:34',NULL,NULL),(23326,4384,'3904210','834','00','005010X220A1','3904210','','2014-03-08','09:42:30',0,'2014-03-08 21:30:41',NULL,NULL),(23343,4386,'2639382','834','00','005010X220A1','2639382','','2014-03-07','19:54:33',0,'2014-03-08 21:30:53',NULL,NULL),(1636,281,'1174356','834','00','005010X220A1','1174356','','2013-11-19','23:07:47',0,'2013-12-25 19:02:05',NULL,NULL),(13439,2223,'1746634','834','00','005010X220A1','1746634','','2014-01-06','15:56:54',0,'2014-01-07 04:02:17',NULL,NULL),(2033,331,'430386','834','00','005010X220A1','430386','','2013-12-09','16:40:12',0,'2013-12-25 19:35:53',NULL,NULL),(13138,1982,'0001','999','BE','005010X231A1','690471','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:28',NULL,NULL),(2419,417,'1194124','834','00','005010X220A1','1194124','','2013-12-06','14:01:44',0,'2013-12-25 20:17:52',NULL,NULL),(3753,647,'756110','834','00','005010X220A1','756110','','2013-12-12','15:12:17',0,'2013-12-25 22:09:19',NULL,NULL),(5903,1110,'828195','834','00','005010X220A1','828195','','2013-12-15','16:02:30',0,'2013-12-26 02:30:52',NULL,NULL),(15388,2624,'1574502','834','00','005010X220A1','1574502','','2014-01-15','20:06:40',0,'2014-01-17 03:35:41',NULL,NULL),(16060,2772,'1374550','834','00','005010X220A1','1374550','','2014-01-22','12:44:02',0,'2014-01-23 03:02:40',NULL,NULL),(16544,3021,'2280986','834','00','005010X220A1','2280986','','2014-01-24','12:14:21',0,'2014-01-24 21:01:08',NULL,NULL),(17421,3201,'2222177','834','00','005010X220A1','2222177','','2014-01-31','20:19:08',0,'2014-02-01 19:00:22',NULL,NULL),(19120,3545,'2622690','834','00','005010X220A1','2622690','','2014-02-12','16:18:31',0,'2014-02-12 21:31:50',NULL,NULL),(20510,3848,'3228570','834','00','005010X220A1','3228570','','2014-02-20','12:58:59',0,'2014-02-20 22:01:11',NULL,NULL),(21660,4077,'2630856','834','00','005010X220A1','2630856','','2014-02-27','22:08:32',0,'2014-02-28 21:00:07',NULL,NULL),(60,3,'1217911','834','00','005010X220A1','1217911','','2013-12-05','06:17:09',0,'2013-12-25 17:16:47',NULL,NULL),(251,45,'1144011','834','00','005010X220A1','1144011','','2013-11-13','10:09:11',0,'2013-12-25 17:30:53',NULL,NULL),(947,181,'283278','834','00','005010X220A1','283278','','2013-12-03','15:14:40',0,'2013-12-25 18:18:33',NULL,NULL),(1306,245,'658933','834','00','005010X220A1','658933','','2013-12-24','05:47:35',0,'2013-12-25 18:51:00',NULL,NULL),(2402,415,'731228','834','00','005010X220A1','731228','','2013-12-06','11:13:46',0,'2013-12-25 20:17:17',NULL,NULL),(2600,483,'17558','834','00','005010X220A1','17558','','2013-10-06','12:16:14',0,'2013-12-25 20:46:01',NULL,NULL),(3005,543,'52214','834','00','005010X220A1','52214','','2013-12-13','17:58:51',0,'2013-12-25 21:33:16',NULL,NULL),(10863,1407,'1209633','834','00','005010X220A1','1209633','','2013-12-23','10:19:35',0,'2013-12-26 13:05:56',NULL,NULL),(5028,935,'1109097','834','00','005010X220A1','1109097','','2013-12-11','12:43:09',0,'2013-12-26 00:46:52',NULL,NULL),(10414,1400,'162650','834','00','005010X220A1','162650','','2013-12-23','09:34:31',0,'2013-12-26 12:51:09',NULL,NULL),(5679,1057,'23945','834','00','005010X220A1','23945','','2013-12-24','21:10:59',0,'2013-12-26 01:52:25',NULL,NULL),(5624,1045,'2111365','834','00','005010X220A1','2111365','','2013-12-25','06:51:22',0,'2013-12-26 01:50:30',NULL,NULL),(5133,943,'558347','834','00','005010X220A1','558347','','2013-12-11','09:47:08',0,'2013-12-26 00:50:18',NULL,NULL),(15269,2604,'1847284','834','00','005010X220A1','1847284','','2014-01-15','01:43:00',0,'2014-01-16 08:47:10',NULL,NULL),(16011,2767,'1900391','834','00','005010X220A1','1900391','','2014-01-22','10:01:01',0,'2014-01-23 03:02:18',NULL,NULL),(17055,3124,'1789377','834','00','005010X220A1','1789377','','2014-01-29','14:05:34',0,'2014-01-29 21:01:30',NULL,NULL),(17112,3142,'2539183','834','00','005010X220A1','2539183','','2014-01-30','14:14:28',0,'2014-01-30 21:00:13',NULL,NULL),(17256,3170,'1832259','834','00','005010X220A1','1832259','','2014-01-30','21:41:46',0,'2014-01-31 21:00:11',NULL,NULL),(18180,3351,'2156373','834','00','005010X220A1','2156373','','2014-02-07','00:34:41',0,'2014-02-07 19:00:21',NULL,NULL),(19248,3580,'2741212','834','00','005010X220A1','2741212','','2014-02-13','16:35:09',0,'2014-02-13 22:00:32',NULL,NULL),(19487,3620,'3360597','834','00','005010X220A1','3360597','','2014-02-14','07:28:21',0,'2014-02-14 21:30:17',NULL,NULL),(19783,3675,'1985314','834','00','005010X220A1','1985314','','2014-02-14','20:56:53',0,'2014-02-15 22:01:08',NULL,NULL),(19881,3710,'2923827','834','00','005010X220A1','2923827','','2014-02-15','20:01:27',0,'2014-02-16 19:00:24',NULL,NULL),(20539,3856,'3215704','834','00','005010X220A1','3215704','','2014-02-20','12:06:35',0,'2014-02-20 22:01:36',NULL,NULL),(21006,3961,'2889718','834','00','005010X220A1','2889718','','2014-02-21','19:38:17',0,'2014-02-26 08:30:43',NULL,NULL),(22314,4201,'3453971','834','00','005010X220A1','3453971','','2014-03-04','14:56:39',0,'2014-03-04 21:01:08',NULL,NULL),(944,181,'1072783','834','00','005010X220A1','1072783','','2013-12-03','13:46:07',0,'2013-12-25 18:18:27',NULL,NULL),(13808,2296,'2286079','834','00','005010X220A1','2286079','','2014-01-10','19:43:14',0,'2014-01-13 02:18:20',NULL,NULL),(13628,2270,'1868491','834','00','005010X220A1','1868491','','2014-01-07','16:57:50',0,'2014-01-08 18:24:01',NULL,NULL),(1620,281,'854730','834','00','005010X220A1','854730','','2013-11-19','23:03:54',0,'2013-12-25 19:01:42',NULL,NULL),(1672,290,'568382','834','00','005010X220A1','568382','','2013-12-10','10:51:40',0,'2013-12-25 19:15:36',NULL,NULL),(4389,774,'980197','834','00','005010X220A1','980197','','2013-11-27','12:35:17',0,'2013-12-25 23:15:37',NULL,NULL),(12842,1705,'2255289','834','00','005010X220A1','2255289','','2014-01-02','20:25:12',0,'2014-01-04 02:02:45',NULL,NULL),(12531,1646,'1886223','834','00','005010X220A1','1886223','','2013-12-31','16:13:06',1,'2014-01-02 04:34:28',NULL,NULL),(5485,1040,'76136','834','00','005010X220A1','76136','','2013-12-25','00:29:36',0,'2013-12-26 01:45:54',NULL,NULL),(12113,1587,'1859719','834','00','005010X220A1','1859719','','2013-12-30','12:59:26',0,'2014-01-01 12:06:08',NULL,NULL),(7266,1249,'20930','834','00','005010X220A1','20930','','2013-12-18','06:18:23',0,'2013-12-26 04:08:39',NULL,NULL),(11810,1539,'1515662','834','00','005010X220A1','1515662','','2013-12-28','20:13:53',1,'2013-12-29 11:13:22',NULL,NULL),(11431,1475,'1036999','834','00','005010X220A1','1036999','','2013-12-26','14:45:30',0,'2013-12-27 02:07:32',NULL,NULL),(7701,1332,'229183','834','00','005010X220A1','229183','','2013-11-14','20:21:46',0,'2013-12-26 04:45:31',NULL,NULL),(10893,1409,'612439','834','00','005010X220A1','612439','','2013-12-22','23:37:34',0,'2013-12-26 13:07:23',NULL,NULL),(15974,2764,'2379048','834','00','005010X220A1','2379048','','2014-01-22','11:40:25',0,'2014-01-23 03:02:01',NULL,NULL),(16743,3066,'1793833','834','00','005010X220A1','1793833','','2014-01-27','11:01:00',0,'2014-01-27 21:01:13',NULL,NULL),(19558,3626,'3029166','834','00','005010X220A1','3029166','','2014-02-14','08:06:24',0,'2014-02-14 21:31:07',NULL,NULL),(20522,3849,'3481500','834','00','005010X220A1','3481500','','2014-02-20','12:54:59',0,'2014-02-20 22:01:22',NULL,NULL),(21911,4127,'3540787','834','00','005010X220A1','3540787','','2014-03-01','13:22:00',0,'2014-03-01 21:00:37',NULL,NULL),(23648,4441,'3294805','834','00','005010X220A1','3294805','','2014-03-10','16:22:01',0,'2014-03-10 21:01:49',NULL,NULL),(23686,4448,'2750067','834','00','005010X220A1','2750067','','2014-03-09','22:36:08',0,'2014-03-10 21:02:18',NULL,NULL),(2123,360,'456158','834','00','005010X220A1','456158','','2013-12-02','11:33:16',0,'2013-12-25 19:45:37',NULL,NULL),(2218,367,'856322','834','00','005010X220A1','856322','','2013-12-01','20:48:15',0,'2013-12-25 19:48:46',NULL,NULL),(11366,1459,'1816932','834','00','005010X220A1','1816932','','2013-12-26','16:36:32',0,'2013-12-27 02:05:31',NULL,NULL),(11362,1459,'1925379','834','00','005010X220A1','1925379','','2013-12-26','12:25:52',0,'2013-12-27 02:05:24',NULL,NULL),(11326,1456,'539027','834','00','005010X220A1','539027','','2013-12-26','13:39:37',0,'2013-12-27 02:04:17',NULL,NULL),(11282,1455,'2023496','834','00','005010X220A1','2023496','','2013-12-26','13:42:37',0,'2013-12-27 02:02:57',NULL,NULL),(10612,1402,'1088656','834','00','005010X220A1','1088656','','2013-12-23','14:04:05',0,'2013-12-26 12:57:34',NULL,NULL),(1986,327,'408804','834','00','005010X220A1','408804','','2013-12-09','14:16:15',0,'2013-12-25 19:34:21',NULL,NULL),(5822,1088,'399287','834','00','005010X220A1','399287','','2013-11-22','18:48:38',0,'2013-12-26 02:15:08',NULL,NULL),(5600,1044,'1934593','834','00','005010X220A1','1934593','','2013-12-24','18:44:16',0,'2013-12-26 01:49:39',NULL,NULL),(5360,1008,'332338','834','00','005010X220A1','332338','','2013-11-25','13:56:29',0,'2013-12-26 01:16:11',NULL,NULL),(2157,362,'533118','834','00','005010X220A1','533118','','2013-12-01','19:20:46',0,'2013-12-25 19:46:41',NULL,NULL),(3292,584,'1116990','834','00','005010X220A1','1116990','','2013-12-16','22:51:44',0,'2013-12-25 21:48:12',NULL,NULL),(3313,584,'246530','834','00','005010X220A1','246530','','2013-12-17','15:18:55',0,'2013-12-25 21:48:54',NULL,NULL),(14218,2366,'1692559','834','00','005010X220A1','1692559','','2014-01-10','12:14:47',0,'2014-01-13 02:23:56',NULL,NULL),(14781,2551,'2359092','834','00','005010X220A1','2359092','','2014-01-14','14:29:33',0,'2014-01-15 02:06:37',NULL,NULL),(16329,2983,'2462002','834','00','005010X220A1','2462002','','2014-01-22','22:00:35',0,'2014-01-23 21:00:34',NULL,NULL),(17040,3121,'2397164','834','00','005010X220A1','2397164','','2014-01-28','21:12:31',0,'2014-01-29 21:01:20',NULL,NULL),(17557,3236,'2367397','834','00','005010X220A1','2367397','','2014-02-03','00:17:32',0,'2014-02-03 21:00:30',NULL,NULL),(21338,4022,'2850673','834','00','005010X220A1','2850673','','2014-02-26','22:56:33',0,'2014-02-28 06:30:06',NULL,NULL),(22300,4201,'3605631','834','00','005010X220A1','3605631','','2014-03-04','10:25:45',0,'2014-03-04 21:00:59',NULL,NULL),(17625,3243,'2400949','834','00','005010X220A1','2400949','','2014-02-03','14:53:08',0,'2014-02-03 21:01:14',NULL,NULL),(249,44,'1091872','834','00','005010X220A1','1091872','','2013-11-13','01:46:59',0,'2013-12-25 17:30:48',NULL,NULL),(1274,243,'2014187','834','00','005010X220A1','2014187','','2013-12-24','16:01:04',0,'2013-12-25 18:49:57',NULL,NULL),(1426,250,'883398','834','00','005010X220A1','883398','','2013-12-24','14:29:11',0,'2013-12-25 18:54:54',NULL,NULL),(13609,2265,'2264390','834','00','005010X220A1','2264390','','2014-01-04','20:22:26',1,'2014-01-07 10:23:12',NULL,NULL),(12279,1624,'2510656','834','00','005010X220A1','2510656','','2013-12-31','20:24:37',1,'2014-01-02 04:24:30',NULL,NULL),(12243,1619,'1892607','834','00','005010X220A1','1892607','','2013-12-31','19:17:06',1,'2014-01-02 04:23:10',NULL,NULL),(11760,1523,'1296933','834','00','005010X220A1','1296933','','2013-12-28','13:57:48',1,'2013-12-29 11:09:43',NULL,NULL),(2808,506,'293320','834','00','005010X220A1','293320','','2013-12-22','14:51:17',0,'2013-12-25 21:20:34',NULL,NULL),(4202,735,'398586','834','00','005010X220A1','398586','','2013-12-19','09:34:28',0,'2013-12-25 23:06:17',NULL,NULL),(4658,830,'254886','834','00','005010X220A1','254886','','2013-12-23','21:09:06',0,'2013-12-25 23:49:11',NULL,NULL),(5107,940,'171939','834','00','005010X220A1','171939','','2013-12-11','17:28:02',0,'2013-12-26 00:49:24',NULL,NULL),(14686,2549,'2438680','834','00','005010X220A1','2438680','','2014-01-14','09:56:57',0,'2014-01-15 02:05:55',NULL,NULL),(15428,2629,'1924779','834','00','005010X220A1','1924779','','2014-01-16','14:42:57',0,'2014-01-17 03:36:00',NULL,NULL),(16399,2993,'2111040','834','00','005010X220A1','2111040','','2014-01-23','09:43:59',0,'2014-01-23 21:01:22',NULL,NULL),(17168,3145,'2358300','834','00','005010X220A1','2358300','','2014-01-30','13:20:45',0,'2014-01-30 21:00:48',NULL,NULL),(17380,3189,'1609575','834','00','005010X220A1','1609575','','2014-01-31','13:35:25',0,'2014-01-31 21:01:38',NULL,NULL),(18646,3463,'2626435','834','00','005010X220A1','2626435','','2014-02-10','16:41:23',0,'2014-02-10 21:31:36',NULL,NULL),(19579,3629,'3462664','834','00','005010X220A1','3462664','','2014-02-13','19:34:25',0,'2014-02-14 21:31:22',NULL,NULL),(19583,3629,'2601200','834','00','005010X220A1','2601200','','2014-02-14','10:19:02',0,'2014-02-14 21:31:25',NULL,NULL),(20004,3748,'3493255','834','00','005010X220A1','3493255','','2014-02-18','13:59:23',0,'2014-02-18 22:00:35',NULL,NULL),(20592,3870,'2592302','834','00','005010X220A1','2592302','','2014-02-21','10:46:06',0,'2014-02-21 22:00:08',NULL,NULL),(22936,4295,'3247334','834','00','005010X220A1','3247334','','2014-03-06','11:40:53',0,'2014-03-06 21:02:43',NULL,NULL),(1766,297,'1028473','834','00','005010X220A1','1028473','','2013-12-09','19:01:17',0,'2013-12-25 19:18:28',NULL,NULL),(13917,2313,'1651520','834','00','005010X220A1','1651520','','2014-01-09','13:55:28',0,'2014-01-13 02:19:55',NULL,NULL),(2372,413,'864789','834','00','005010X220A1','864789','','2013-12-06','13:15:33',0,'2013-12-25 20:16:25',NULL,NULL),(12968,1734,'2120120','834','00','005010X220A1','2120120','','2014-01-04','12:47:25',0,'2014-01-05 00:01:02',NULL,NULL),(12617,1671,'1634202','834','00','005010X220A1','1634202','','2014-01-02','13:24:22',0,'2014-01-03 02:01:41',NULL,NULL),(11835,1543,'1132891','834','00','005010X220A1','1132891','','2013-12-28','20:06:59',1,'2013-12-29 11:14:14',NULL,NULL),(11335,1456,'1681734','834','00','005010X220A1','1681734','','2013-12-26','16:06:10',0,'2013-12-27 02:04:36',NULL,NULL),(10673,1403,'1434728','834','00','005010X220A1','1434728','','2013-12-22','19:34:22',0,'2013-12-26 12:59:30',NULL,NULL),(3204,578,'959368','834','00','005010X220A1','959368','','2013-12-16','23:22:21',0,'2013-12-25 21:45:23',NULL,NULL),(7262,1248,'413373','834','00','005010X220A1','413373','','2013-12-17','21:38:38',0,'2013-12-26 04:08:32',NULL,NULL),(7258,1246,'499184','834','00','005010X220A1','499184','','2013-12-18','15:07:47',0,'2013-12-26 04:08:26',NULL,NULL),(6322,1175,'191436','834','00','005010X220A1','191436','','2013-12-20','14:45:34',0,'2013-12-26 03:08:03',NULL,NULL),(6080,1166,'494361','834','00','005010X220A1','494361','','2013-12-19','19:07:36',0,'2013-12-26 03:00:42',NULL,NULL),(3536,616,'1064226','834','00','005010X220A1','1064226','','2013-12-12','10:01:15',0,'2013-12-25 22:02:20',NULL,NULL),(3607,619,'348917','834','00','005010X220A1','348917','','2013-12-12','10:13:07',0,'2013-12-25 22:04:34',NULL,NULL),(14843,2553,'2459324','834','00','005010X220A1','2459324','','2014-01-14','11:12:47',0,'2014-01-15 02:07:03',NULL,NULL),(15395,2626,'2278467','834','00','005010X220A1','2278467','','2014-01-15','18:35:11',0,'2014-01-17 03:35:45',NULL,NULL),(15663,2684,'1745702','834','00','005010X220A1','1745702','','2014-01-18','10:38:54',0,'2014-01-21 08:44:33',NULL,NULL),(16151,2843,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 04:06:25',NULL,NULL),(16174,2866,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:39:00',1,'2014-01-23 04:17:57',NULL,NULL),(16984,3117,'1721568','834','00','005010X220A1','1721568','','2014-01-29','15:28:02',0,'2014-01-29 21:00:44',NULL,NULL),(17472,3218,'1613674','834','00','005010X220A1','1613674','','2014-02-01','21:03:12',0,'2014-02-02 19:00:08',NULL,NULL),(17740,3262,'2050278','834','00','005010X220A1','2050278','','2014-02-03','23:37:31',0,'2014-02-04 21:00:54',NULL,NULL),(18057,3319,'1602204','834','00','005010X220A1','1602204','','2014-02-06','16:22:59',0,'2014-02-06 21:00:46',NULL,NULL),(19062,3542,'3249285','834','00','005010X220A1','3249285','','2014-02-12','15:00:26',0,'2014-02-12 21:31:10',NULL,NULL),(19188,3569,'2199697','834','00','005010X220A1','2199697','','2014-02-13','13:16:06',0,'2014-02-13 21:30:06',NULL,NULL),(19829,3680,'2838372','834','00','005010X220A1','2838372','','2014-02-15','14:42:59',0,'2014-02-15 22:01:46',NULL,NULL),(20479,3843,'3619909','834','00','005010X220A1','3619909','','2014-02-20','14:08:14',0,'2014-02-20 22:00:47',NULL,NULL),(21116,3994,'3294355','834','00','005010X220A1','3294355','','2014-02-26','13:15:01',0,'2014-02-26 21:00:20',NULL,NULL),(21294,4006,'2621934','834','00','005010X220A1','2621934','','2014-02-26','13:17:41',0,'2014-02-26 21:02:20',NULL,NULL),(21342,4022,'2585915','834','00','005010X220A1','2585915','','2014-02-27','10:15:35',0,'2014-02-28 06:30:08',NULL,NULL),(21591,4058,'3343435','834','00','005010X220A1','3343435','','2014-02-26','12:26:09',0,'2014-02-28 07:00:33',NULL,NULL),(23104,4341,'3359965','834','00','005010X220A1','3359965','','2014-03-06','18:27:08',0,'2014-03-07 21:30:38',NULL,NULL),(948,181,'458600','834','00','005010X220A1','458600','','2013-12-03','15:59:49',0,'2013-12-25 18:18:35',NULL,NULL),(1481,253,'1943248','834','00','005010X220A1','1943248','','2013-12-24','11:33:36',0,'2013-12-25 18:56:48',NULL,NULL),(1573,277,'353605','834','00','005010X220A1','353605','','2013-11-20','13:52:33',0,'2013-12-25 19:00:22',NULL,NULL),(1712,292,'479141','834','00','005010X220A1','479141','','2013-12-10','16:51:43',0,'2013-12-25 19:16:52',NULL,NULL),(7674,1320,'1226236','834','00','005010X220A1','1226236','','2013-12-21','12:43:15',0,'2013-12-26 04:39:38',NULL,NULL),(1777,298,'882649','834','00','005010X220A1','882649','','2013-12-10','17:50:51',0,'2013-12-25 19:18:50',NULL,NULL),(3716,635,'1301560','834','00','005010X220A1','1301560','','2013-12-12','14:41:17',0,'2013-12-25 22:08:04',NULL,NULL),(5786,1075,'156068','834','00','005010X220A1','156068','','2013-12-14','10:28:27',0,'2013-12-26 02:03:06',NULL,NULL),(5707,1069,'521147','834','00','005010X220A1','521147','','2013-12-13','19:09:14',0,'2013-12-26 02:00:40',NULL,NULL),(4895,902,'228651','834','00','005010X220A1','228651','','2013-10-02','07:22:01',0,'2013-12-26 00:17:13',NULL,NULL),(4031,731,'132731','834','00','005010X220A1','132731','','2013-12-19','14:32:31',0,'2013-12-25 23:01:03',NULL,NULL),(14985,2579,'1923199','834','00','005010X220A1','1923199','','2014-01-14','15:23:21',0,'2014-01-15 02:08:09',NULL,NULL),(16157,2849,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:17:00',1,'2014-01-23 04:08:17',NULL,NULL),(17449,3205,'2030673','834','00','005010X220A1','2030673','','2014-02-01','16:46:00',0,'2014-02-01 19:00:40',NULL,NULL),(20083,3762,'1842939','834','00','005010X220A1','1842939','','2014-02-18','14:33:27',0,'2014-02-18 22:01:33',NULL,NULL),(20615,3871,'2869510','834','00','005010X220A1','2869510','','2014-02-21','10:16:14',0,'2014-02-21 22:00:27',NULL,NULL),(20707,3893,'2965447','834','00','005010X220A1','2965447','','2014-02-25','13:51:53',0,'2014-02-25 21:00:16',NULL,NULL),(21135,3996,'3597878','834','00','005010X220A1','3597878','','2014-02-26','11:36:50',0,'2014-02-26 21:00:35',NULL,NULL),(1025,193,'605779','834','00','005010X220A1','605779','','2013-12-03','09:43:48',0,'2013-12-25 18:21:03',NULL,NULL),(4765,860,'1274691','834','00','005010X220A1','1274691','','2013-12-01','10:33:05',0,'2013-12-26 00:00:50',NULL,NULL),(11026,1416,'511761','834','00','005010X220A1','511761','','2013-12-23','12:08:00',0,'2013-12-26 13:11:39',NULL,NULL),(17509,3229,'2273162','834','00','005010X220A1','2273162','','2014-02-02','14:31:53',0,'2014-02-02 19:00:31',NULL,NULL),(22834,4278,'3635919','834','00','005010X220A1','3635919','','2014-03-06','17:10:10',0,'2014-03-06 21:01:27',NULL,NULL),(23007,4323,'3032496','834','00','005010X220A1','3032496','','2014-03-06','18:41:57',0,'2014-03-07 21:00:14',NULL,NULL),(4004,731,'790918','834','00','005010X220A1','790918','','2013-12-18','20:59:06',0,'2013-12-25 23:00:16',NULL,NULL),(281,60,'1087654','834','00','005010X220A1','1087654','','2013-11-09','11:58:11',0,'2013-12-25 17:32:01',NULL,NULL),(11247,1454,'1091592','834','00','005010X220A1','1091592','','2013-12-26','14:17:05',0,'2013-12-27 02:01:54',NULL,NULL),(1245,243,'788441','834','00','005010X220A1','788441','','2013-12-24','11:18:27',0,'2013-12-25 18:49:03',NULL,NULL),(13649,2271,'2341568','834','00','005010X220A1','2341568','','2014-01-07','12:16:00',0,'2014-01-08 18:24:10',NULL,NULL),(13244,2088,'0001','999','BE','005010X231A1','1269622','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:55',NULL,NULL),(16407,2994,'1908888','834','00','005010X220A1','1908888','','2014-01-23','12:30:07',0,'2014-01-23 21:01:27',NULL,NULL),(18862,3493,'3005165','834','00','005010X220A1','3005165','','2014-02-10','22:34:59',0,'2014-02-11 21:02:03',NULL,NULL),(19384,3591,'3168576','834','00','005010X220A1','3168576','','2014-02-13','16:11:47',0,'2014-02-13 22:02:17',NULL,NULL),(19413,3594,'2848933','834','00','005010X220A1','2848933','','2014-02-13','08:34:28',0,'2014-02-13 22:02:39',NULL,NULL),(19960,3746,'2716317','834','00','005010X220A1','2716317','','2014-02-18','09:32:48',0,'2014-02-18 22:00:04',NULL,NULL),(21242,3999,'3174046','834','00','005010X220A1','3174046','','2014-02-26','12:40:46',0,'2014-02-26 21:01:43',NULL,NULL),(22414,4215,'2866124','834','00','005010X220A1','2866124','','2014-03-04','16:45:12',0,'2014-03-04 21:02:32',NULL,NULL),(5345,1002,'999032','834','00','005010X220A1','999032','','2013-11-25','16:57:13',0,'2013-12-26 01:15:40',NULL,NULL),(4759,859,'670355','834','00','005010X220A1','670355','','2013-12-01','14:19:54',0,'2013-12-26 00:00:36',NULL,NULL),(2305,401,'757011','834','00','005010X220A1','757011','','2013-11-02','16:23:27',0,'2013-12-25 20:01:23',NULL,NULL),(10733,1403,'513269','834','00','005010X220A1','513269','','2013-12-23','14:53:40',0,'2013-12-26 13:01:42',NULL,NULL),(4275,742,'677745','834','00','005010X220A1','677745','','2013-12-19','16:30:13',0,'2013-12-25 23:08:34',NULL,NULL),(6330,1175,'550408','834','00','005010X220A1','550408','','2013-12-20','16:31:45',0,'2013-12-26 03:08:19',NULL,NULL),(20125,3772,'3200404','834','00','005010X220A1','3200404','','2014-02-19','12:35:13',0,'2014-02-20 03:54:58',NULL,NULL),(22397,4212,'3231406','834','00','005010X220A1','3231406','','2014-03-04','14:23:03',0,'2014-03-04 21:02:17',NULL,NULL),(23368,4393,'3442713','834','00','005010X220A1','3442713','','2014-03-07','19:56:51',0,'2014-03-08 21:31:12',NULL,NULL),(557,103,'200150','834','00','005010X220A1','200150','','2013-12-16','10:38:47',0,'2013-12-25 18:02:15',NULL,NULL),(12813,1703,'1301176','834','00','005010X220A1','1301176','','2014-01-03','17:49:09',0,'2014-01-04 02:01:44',NULL,NULL),(14059,2339,'2341597','834','00','005010X220A1','2341597','','2014-01-08','10:37:33',0,'2014-01-13 02:21:42',NULL,NULL),(10578,1402,'1276546','834','00','005010X220A1','1276546','','2013-12-23','11:21:17',0,'2013-12-26 12:56:29',NULL,NULL),(10813,1404,'1654550','834','00','005010X220A1','1654550','','2013-12-23','15:34:17',0,'2013-12-26 13:04:17',NULL,NULL),(10771,1404,'1521610','834','00','005010X220A1','1521610','','2013-12-22','23:19:00',0,'2013-12-26 13:02:57',NULL,NULL),(18476,3429,'1394044','834','00','005010X220A1','1394044','','2014-02-10','04:21:56',0,'2014-02-10 11:00:56',NULL,NULL),(19051,3541,'2303445','834','00','005010X220A1','2303445','','2014-02-11','19:43:44',0,'2014-02-12 21:31:01',NULL,NULL),(22360,4205,'2844672','834','00','005010X220A1','2844672','','2014-03-04','12:55:37',0,'2014-03-04 21:01:46',NULL,NULL),(23249,4367,'3452742','834','00','005010X220A1','3452742','','2014-03-07','12:56:03',0,'2014-03-07 21:32:22',NULL,NULL),(5320,997,'1163040','834','00','005010X220A1','1163040','','2013-11-05','12:13:50',0,'2013-12-26 01:02:12',NULL,NULL),(1018,191,'1071671','834','00','005010X220A1','1071671','','2013-12-03','01:07:07',0,'2013-12-25 18:20:48',NULL,NULL),(3636,622,'1256568','834','00','005010X220A1','1256568','','2013-12-12','11:34:01',0,'2013-12-25 22:05:28',NULL,NULL),(5998,1132,'237968','834','00','005010X220A1','237968','','2013-12-15','15:20:59',0,'2013-12-26 02:33:58',NULL,NULL),(17516,3234,'2766925','834','00','005010X220A1','2766925','','2014-02-02','19:37:52',0,'2014-02-03 21:00:06',NULL,NULL),(20590,3870,'2946363','834','00','005010X220A1','2946363','','2014-02-21','10:32:12',0,'2014-02-21 22:00:07',NULL,NULL),(4973,935,'305345','834','00','005010X220A1','305345','','2013-12-10','18:44:20',0,'2013-12-26 00:45:07',NULL,NULL),(4776,861,'860139','834','00','005010X220A1','860139','','2013-12-01','11:27:58',0,'2013-12-26 00:01:08',NULL,NULL),(1744,293,'1065426','834','00','005010X220A1','1065426','','2013-12-10','14:44:26',0,'2013-12-25 19:17:48',NULL,NULL),(4744,857,'549779','834','00','005010X220A1','549779','','2013-12-01','10:07:40',0,'2013-12-26 00:00:04',NULL,NULL),(6007,1136,'735606','834','00','005010X220A1','735606','','2013-11-17','09:21:42',0,'2013-12-26 02:45:10',NULL,NULL),(23663,4444,'2953412','834','00','005010X220A1','2953412','','2014-03-09','23:42:35',0,'2014-03-10 21:02:00',NULL,NULL),(5310,991,'416173','834','00','005010X220A1','416173','','2013-11-04','20:06:40',0,'2013-12-26 01:01:48',NULL,NULL),(12409,1637,'1526366','834','00','005010X220A1','1526366','','2013-12-31','17:22:44',1,'2014-01-02 04:29:59',NULL,NULL),(11676,1509,'961445','834','00','005010X220A1','961445','','2013-12-27','12:23:17',0,'2013-12-28 03:37:07',NULL,NULL),(3332,586,'92400','834','00','005010X220A1','92400','','2013-12-17','14:01:02',0,'2013-12-25 21:49:34',NULL,NULL),(2882,524,'578106','834','00','005010X220A1','578106','','2013-12-22','10:43:03',0,'2013-12-25 21:23:04',NULL,NULL),(4756,859,'593193','834','00','005010X220A1','593193','','2013-11-30','20:15:48',0,'2013-12-26 00:00:31',NULL,NULL),(3672,627,'91174','834','00','005010X220A1','91174','','2013-12-12','15:47:17',0,'2013-12-25 22:06:36',NULL,NULL),(16787,3084,'2536237','834','00','005010X220A1','2536237','','2014-01-27','15:34:19',0,'2014-01-27 21:01:47',NULL,NULL),(2818,506,'80072','834','00','005010X220A1','80072','','2013-12-22','18:17:05',0,'2013-12-25 21:20:52',NULL,NULL),(13132,1976,'0001','999','BE','005010X231A1','1209271','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:08',NULL,NULL),(15597,2660,'1976093','834','00','005010X220A1','1976093','','2014-01-16','22:09:30',0,'2014-01-20 08:06:24',NULL,NULL),(16310,2980,'1948784','834','00','005010X220A1','1948784','','2014-01-23','12:28:24',0,'2014-01-23 21:00:20',NULL,NULL),(22250,4200,'3220833','834','00','005010X220A1','3220833','','2014-03-03','20:54:39',0,'2014-03-04 21:00:19',NULL,NULL),(6143,1166,'1305328','834','00','005010X220A1','1305328','','2013-12-20','16:47:26',0,'2013-12-26 03:02:36',NULL,NULL),(4584,826,'1721715','834','00','005010X220A1','1721715','','2013-12-23','22:34:33',0,'2013-12-25 23:46:47',NULL,NULL),(1020,191,'765693','834','00','005010X220A1','765693','','2013-12-03','17:02:41',0,'2013-12-25 18:20:53',NULL,NULL),(12428,1638,'1818473','834','00','005010X220A1','1818473','','2013-12-31','13:29:29',1,'2014-01-02 04:30:41',NULL,NULL),(7173,1238,'161266','834','00','005010X220A1','161266','','2013-12-18','15:27:58',0,'2013-12-26 04:05:48',NULL,NULL),(2020,331,'564838','834','00','005010X220A1','564838','','2013-12-09','14:13:32',0,'2013-12-25 19:35:30',NULL,NULL),(17329,3176,'2189403','834','00','005010X220A1','2189403','','2014-01-31','12:09:38',0,'2014-01-31 21:01:01',NULL,NULL),(19307,3583,'1837724','834','00','005010X220A1','1837724','','2014-02-12','20:34:26',0,'2014-02-13 22:01:19',NULL,NULL),(19488,3620,'2874089','834','00','005010X220A1','2874089','','2014-02-14','07:30:34',0,'2014-02-14 21:30:18',NULL,NULL),(20041,3751,'2447381','834','00','005010X220A1','2447381','','2014-02-18','10:00:46',0,'2014-02-18 22:01:01',NULL,NULL),(23119,4342,'3635930','834','00','005010X220A1','3635930','','2014-03-06','21:03:26',0,'2014-03-07 21:30:49',NULL,NULL),(379,74,'251307','834','00','005010X220A1','251307','','2013-12-03','21:00:13',0,'2013-12-25 17:47:42',NULL,NULL),(15028,2584,'2460457','834','00','005010X220A1','2460457','','2014-01-15','16:28:49',0,'2014-01-16 08:44:35',NULL,NULL),(12358,1634,'2299039','834','00','005010X220A1','2299039','','2013-12-31','14:47:49',1,'2014-01-02 04:28:08',NULL,NULL),(3781,656,'1133420','834','00','005010X220A1','1133420','','2013-12-08','10:52:42',0,'2013-12-25 22:15:41',NULL,NULL),(10472,1400,'1208463','834','00','005010X220A1','1208463','','2013-12-23','14:34:19',0,'2013-12-26 12:52:59',NULL,NULL),(13253,2097,'0001','999','BE','005010X231A1','86013','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:20',NULL,NULL),(7110,1236,'963347','834','00','005010X220A1','963347','','2013-12-18','13:29:19',0,'2013-12-26 04:03:52',NULL,NULL),(3983,721,'1000648','834','00','005010X220A1','1000648','','2013-12-07','11:18:31',0,'2013-12-25 22:47:39',NULL,NULL),(18470,3429,'2404447','834','00','005010X220A1','2404447','','2014-02-10','04:00:59',0,'2014-02-10 11:00:52',NULL,NULL),(22453,4232,'3110551','834','00','005010X220A1','3110551','','2014-03-04','14:02:06',0,'2014-03-04 21:30:18',NULL,NULL),(6195,1167,'31998','834','00','005010X220A1','31998','','2013-12-20','18:25:02',0,'2013-12-26 03:04:09',NULL,NULL),(14222,2366,'1779956','834','00','005010X220A1','1779956','','2014-01-10','13:19:56',0,'2014-01-13 02:23:58',NULL,NULL),(11696,1517,'1427336','834','00','005010X220A1','1427336','','2013-12-27','20:30:52',1,'2013-12-29 11:07:48',NULL,NULL),(10547,1402,'214356','834','00','005010X220A1','214356','','2013-12-22','19:51:55',0,'2013-12-26 12:55:26',NULL,NULL),(1376,245,'1764007','834','00','005010X220A1','1764007','','2013-12-24','15:51:42',0,'2013-12-25 18:53:13',NULL,NULL),(7631,1308,'78713','834','00','005010X220A1','78713','','2013-12-21','16:07:00',0,'2013-12-26 04:38:16',NULL,NULL),(5681,1059,'1090193','834','00','005010X220A1','1090193','','2013-12-24','21:26:53',0,'2013-12-26 01:52:30',NULL,NULL),(4778,861,'1075110','834','00','005010X220A1','1075110','','2013-11-30','18:41:26',0,'2013-12-26 00:01:12',NULL,NULL),(2065,339,'1032481','834','00','005010X220A1','1032481','','2013-12-09','17:10:25',0,'2013-12-25 19:36:56',NULL,NULL),(4203,736,'899932','834','00','005010X220A1','899932','','2013-12-18','19:12:56',0,'2013-12-25 23:06:19',NULL,NULL),(2162,362,'165484','834','00','005010X220A1','165484','','2013-12-02','09:59:06',0,'2013-12-25 19:46:50',NULL,NULL),(23181,4345,'3370918','834','00','005010X220A1','3370918','','2014-03-07','09:25:58',0,'2014-03-07 21:31:32',NULL,NULL),(1549,266,'1371355','834','00','005010X220A1','1371355','','2013-12-24','15:53:08',0,'2013-12-25 18:58:56',NULL,NULL),(14391,2416,'1480680','834','00','005010X220A1','1480680','','2014-01-12','14:13:21',0,'2014-01-13 03:01:56',NULL,NULL),(13722,2275,'1359426','834','00','005010X220A1','1359426','','2014-01-07','16:52:36',0,'2014-01-08 18:24:38',NULL,NULL),(13336,2180,'0001','999','BE','005010X231A1','86013','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:52',NULL,NULL),(12839,1704,'1944586','834','00','005010X220A1','1944586','','2014-01-03','15:24:56',0,'2014-01-04 02:02:39',NULL,NULL),(11974,1580,'2004848','834','00','005010X220A1','2004848','','2013-12-30','14:23:14',0,'2014-01-01 12:01:08',NULL,NULL),(5293,981,'435951','834','00','005010X220A1','435951','','2013-11-15','20:24:38',0,'2013-12-26 01:01:10',NULL,NULL),(15491,2634,'1853242','834','00','005010X220A1','1853242','','2014-01-16','15:47:39',0,'2014-01-17 03:36:27',NULL,NULL),(17078,3132,'2117168','834','00','005010X220A1','2117168','','2014-01-29','16:26:58',0,'2014-01-29 21:01:44',NULL,NULL),(18513,3448,'2903178','834','00','005010X220A1','2903178','','2014-02-10','14:58:19',0,'2014-02-10 21:00:11',NULL,NULL),(19561,3626,'3296246','834','00','005010X220A1','3296246','','2014-02-14','14:55:41',0,'2014-02-14 21:31:10',NULL,NULL),(7054,1235,'786994','834','00','005010X220A1','786994','','2013-12-18','18:07:28',0,'2013-12-26 04:02:08',NULL,NULL),(5673,1053,'1622888','834','00','005010X220A1','1622888','','2013-12-25','16:53:29',0,'2013-12-26 01:52:09',NULL,NULL),(4777,861,'632322','834','00','005010X220A1','632322','','2013-12-01','11:35:42',0,'2013-12-26 00:01:10',NULL,NULL),(14029,2337,'1369129','834','00','005010X220A1','1369129','','2014-01-08','14:44:47',0,'2014-01-13 02:21:24',NULL,NULL),(1791,301,'851050','834','00','005010X220A1','851050','','2013-12-10','10:17:14',0,'2013-12-25 19:19:19',NULL,NULL),(7481,1296,'930365','834','00','005010X220A1','930365','','2013-12-21','17:42:54',0,'2013-12-26 04:33:20',NULL,NULL),(7625,1308,'1057356','834','00','005010X220A1','1057356','','2013-12-20','21:21:48',0,'2013-12-26 04:38:04',NULL,NULL),(11213,1454,'1719584','834','00','005010X220A1','1719584','','2013-12-26','09:42:55',0,'2013-12-27 02:00:51',NULL,NULL),(14977,2572,'2118248','834','00','005010X220A1','2118248','','2014-01-14','17:15:44',0,'2014-01-15 02:08:05',NULL,NULL),(15222,2594,'1988419','834','00','005010X220A1','1988419','','2014-01-15','16:12:52',0,'2014-01-16 08:46:39',NULL,NULL),(21931,4129,'3294464','834','00','005010X220A1','3294464','','2014-02-28','23:17:36',0,'2014-03-01 21:00:50',NULL,NULL),(22224,4191,'3284226','834','00','005010X220A1','3284226','','2014-03-03','14:31:06',0,'2014-03-03 21:31:50',NULL,NULL),(22892,4284,'3537686','834','00','005010X220A1','3537686','','2014-03-05','19:53:04',0,'2014-03-06 21:02:10',NULL,NULL),(18275,3377,'3019194','834','00','005010X220A1','3019194','','2014-02-08','17:14:24',0,'2014-02-08 19:00:18',NULL,NULL),(20941,3946,'3285296','834','00','005010X220A1','3285296','','2014-02-24','15:01:02',0,'2014-02-26 08:00:36',NULL,NULL),(21108,3994,'3337184','834','00','005010X220A1','3337184','','2014-02-26','10:48:12',0,'2014-02-26 21:00:14',NULL,NULL),(477,94,'1029414','834','00','005010X220A1','1029414','','2013-12-04','16:15:00',0,'2013-12-25 17:50:55',NULL,NULL),(12956,1734,'1693682','834','00','005010X220A1','1693682','','2014-01-03','19:42:29',0,'2014-01-05 00:00:34',NULL,NULL),(11666,1502,'2042697','834','00','005010X220A1','2042697','','2013-12-27','05:29:19',0,'2013-12-28 03:36:47',NULL,NULL),(3166,564,'1262896','834','00','005010X220A1','1262896','','2013-12-13','10:52:49',0,'2013-12-25 21:38:18',NULL,NULL),(11163,1440,'1698777','834','00','005010X220A1','1698777','','2013-12-23','14:36:03',0,'2013-12-26 13:16:25',NULL,NULL),(7734,1342,'1192462','834','00','005010X220A1','1192462','','2013-10-20','20:37:57',0,'2013-12-26 05:00:20',NULL,NULL),(7085,1236,'144006','834','00','005010X220A1','144006','','2013-12-18','10:40:33',0,'2013-12-26 04:03:11',NULL,NULL),(4282,742,'454142','834','00','005010X220A1','454142','','2013-12-19','17:29:34',0,'2013-12-25 23:08:46',NULL,NULL),(5478,1040,'1520690','834','00','005010X220A1','1520690','','2013-12-24','23:27:10',0,'2013-12-26 01:45:42',NULL,NULL),(5082,937,'258180','834','00','005010X220A1','258180','','2013-12-11','11:30:59',0,'2013-12-26 00:48:38',NULL,NULL),(15589,2659,'1558042','834','00','005010X220A1','1558042','','2014-01-17','12:05:05',0,'2014-01-20 08:06:19',NULL,NULL),(16141,2833,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:11:00',1,'2014-01-23 03:55:56',NULL,NULL),(18239,3366,'2545747','834','00','005010X220A1','2545747','','2014-02-07','15:39:48',0,'2014-02-07 19:01:04',NULL,NULL),(19179,3567,'2962196','834','00','005010X220A1','2962196','','2014-02-12','16:27:17',0,'2014-02-12 21:32:31',NULL,NULL),(19462,3615,'3297532','834','00','005010X220A1','3297532','','2014-02-13','16:36:14',0,'2014-02-13 22:03:18',NULL,NULL),(21323,4016,'3468975','834','00','005010X220A1','3468975','','2014-02-26','14:43:58',0,'2014-02-26 21:02:43',NULL,NULL),(21673,4079,'2639069','834','00','005010X220A1','2639069','','2014-02-28','10:43:35',0,'2014-02-28 21:00:16',NULL,NULL),(1795,303,'234091','834','00','005010X220A1','234091','','2013-12-10','15:07:44',0,'2013-12-25 19:19:28',NULL,NULL),(1862,324,'1260060','834','00','005010X220A1','1260060','','2013-12-09','13:27:46',0,'2013-12-25 19:30:36',NULL,NULL),(2180,363,'150118','834','00','005010X220A1','150118','','2013-12-02','14:54:35',0,'2013-12-25 19:47:29',NULL,NULL),(11259,1455,'650947','834','00','005010X220A1','650947','','2013-12-25','20:28:43',0,'2013-12-27 02:02:14',NULL,NULL),(12993,1738,'2222875','834','00','005010X220A1','2222875','','2014-01-04','09:52:27',0,'2014-01-05 00:01:52',NULL,NULL),(12443,1638,'1975617','834','00','005010X220A1','1975617','','2013-12-31','16:13:44',1,'2014-01-02 04:31:14',NULL,NULL),(4422,788,'1100738','834','00','005010X220A1','1100738','','2013-11-05','20:41:46',0,'2013-12-25 23:16:45',NULL,NULL),(4457,801,'437088','834','00','005010X220A1','437088','','2013-11-26','09:57:43',0,'2013-12-25 23:30:39',NULL,NULL),(14867,2555,'1653009','834','00','005010X220A1','1653009','','2014-01-13','20:42:58',0,'2014-01-15 02:07:14',NULL,NULL),(15185,2591,'1996118','834','00','005010X220A1','1996118','','2014-01-15','17:41:35',0,'2014-01-16 08:46:16',NULL,NULL),(15978,2764,'2626024','834','00','005010X220A1','2626024','','2014-01-22','17:10:24',0,'2014-01-23 03:02:02',NULL,NULL),(16707,3064,'2086352','834','00','005010X220A1','2086352','','2014-01-27','10:23:36',0,'2014-01-27 21:00:48',NULL,NULL),(17885,3294,'2060484','834','00','005010X220A1','2060484','','2014-02-05','12:50:45',0,'2014-02-05 21:30:23',NULL,NULL),(18420,3420,'1876979','834','00','005010X220A1','1876979','','2014-02-10','03:52:37',0,'2014-02-10 11:00:09',NULL,NULL),(20127,3772,'2728660','834','00','005010X220A1','2728660','','2014-02-19','13:19:37',0,'2014-02-20 03:56:12',NULL,NULL),(21670,4078,'3182918','834','00','005010X220A1','3182918','','2014-02-28','16:28:25',0,'2014-02-28 21:00:13',NULL,NULL),(23628,4441,'3278176','834','00','005010X220A1','3278176','','2014-03-10','11:54:38',0,'2014-03-10 21:01:35',NULL,NULL),(265,50,'400590','834','00','005010X220A1','400590','','2013-11-12','23:34:49',0,'2013-12-25 17:31:23',NULL,NULL),(1607,281,'207017','834','00','005010X220A1','207017','','2013-11-19','23:00:18',0,'2013-12-25 19:01:23',NULL,NULL),(13549,2243,'1458476','834','00','005010X220A1','1458476','','2014-01-06','13:32:15',0,'2014-01-07 04:06:24',NULL,NULL),(13330,2174,'0001','999','BE','005010X231A1','318898','834','2013-12-27','16:55:00',0,'2014-01-05 17:25:35',NULL,NULL),(1632,281,'895741','834','00','005010X220A1','895741','','2013-11-19','23:06:40',0,'2013-12-25 19:01:59',NULL,NULL),(2398,415,'1196522','834','00','005010X220A1','1196522','','2013-12-05','19:22:44',0,'2013-12-25 20:17:08',NULL,NULL),(3203,578,'1070945','834','00','005010X220A1','1070945','','2013-12-16','22:35:45',0,'2013-12-25 21:45:21',NULL,NULL),(3330,586,'847403','834','00','005010X220A1','847403','','2013-12-17','11:47:00',0,'2013-12-25 21:49:30',NULL,NULL),(3846,682,'143333','834','00','005010X220A1','143333','','2013-11-08','17:58:17',0,'2013-12-25 22:30:28',NULL,NULL),(4788,865,'824918','834','00','005010X220A1','824918','','2013-12-01','13:31:26',0,'2013-12-26 00:01:30',NULL,NULL),(4061,731,'410655','834','00','005010X220A1','410655','','2013-12-18','18:47:41',0,'2013-12-25 23:02:01',NULL,NULL),(15207,2592,'1802474','834','00','005010X220A1','1802474','','2014-01-15','16:49:53',0,'2014-01-16 08:46:29',NULL,NULL),(15702,2700,'1750635','834','00','005010X220A1','1750635','','2014-01-19','17:22:41',0,'2014-01-21 08:45:29',NULL,NULL),(17808,3272,'1877268','834','00','005010X220A1','1877268','','2014-02-04','08:32:26',0,'2014-02-04 21:01:38',NULL,NULL),(19694,3671,'3108877','834','00','005010X220A1','3108877','','2014-02-14','22:46:15',0,'2014-02-15 22:00:04',NULL,NULL),(19722,3672,'3153517','834','00','005010X220A1','3153517','','2014-02-15','13:56:06',0,'2014-02-15 22:00:23',NULL,NULL),(22190,4180,'3259073','834','00','005010X220A1','3259073','','2014-03-03','17:39:02',0,'2014-03-03 21:31:24',NULL,NULL),(23257,4374,'2983200','834','00','005010X220A1','2983200','','2014-03-07','14:52:05',0,'2014-03-07 21:32:28',NULL,NULL),(6391,1186,'714441','834','00','005010X220A1','714441','','2013-12-20','16:59:59',0,'2013-12-26 03:10:10',NULL,NULL),(10486,1400,'254846','834','00','005010X220A1','254846','','2013-12-23','16:23:02',0,'2013-12-26 12:53:28',NULL,NULL),(12229,1617,'1264876','834','00','005010X220A1','1264876','','2014-01-01','17:47:57',1,'2014-01-02 04:22:35',NULL,NULL),(15076,2585,'2279813','834','00','005010X220A1','2279813','','2014-01-15','14:47:31',0,'2014-01-16 08:45:05',NULL,NULL),(15490,2634,'2033314','834','00','005010X220A1','2033314','','2014-01-16','15:46:28',0,'2014-01-17 03:36:26',NULL,NULL),(17038,3120,'1494350','834','00','005010X220A1','1494350','','2014-01-29','17:28:41',0,'2014-01-29 21:01:19',NULL,NULL),(21255,3999,'2831817','834','00','005010X220A1','2831817','','2014-02-26','16:36:39',0,'2014-02-26 21:01:52',NULL,NULL),(21748,4090,'3079880','834','00','005010X220A1','3079880','','2014-02-27','22:54:10',0,'2014-02-28 21:30:46',NULL,NULL),(22665,4254,'2881533','834','00','005010X220A1','2881533','','2014-03-05','14:14:05',0,'2014-03-05 21:32:02',NULL,NULL),(23605,4440,'3632411','834','00','005010X220A1','3632411','','2014-03-10','00:33:51',0,'2014-03-10 21:01:20',NULL,NULL),(23681,4447,'3463433','834','00','005010X220A1','3463433','','2014-03-09','22:32:19',0,'2014-03-10 21:02:14',NULL,NULL),(23723,4460,'2786951','834','00','005010X220A1','2786951','','2014-03-10','15:42:24',0,'2014-03-10 21:02:46',NULL,NULL),(208,25,'820906','834','00','005010X220A1','820906','','2013-12-05','00:08:21',0,'2013-12-25 17:21:32',NULL,NULL),(6008,1136,'531712','834','00','005010X220A1','531712','','2013-11-17','09:23:45',0,'2013-12-26 02:45:11',NULL,NULL),(13313,2157,'0001','999','BE','005010X231A1','984254','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:48',NULL,NULL),(12009,1583,'1677554','834','00','005010X220A1','1677554','','2013-12-29','23:51:33',0,'2014-01-01 12:02:25',NULL,NULL),(11670,1504,'1344696','834','00','005010X220A1','1344696','','2013-12-27','18:21:39',0,'2013-12-28 03:36:55',NULL,NULL),(15052,2585,'1415316','834','00','005010X220A1','1415316','','2014-01-14','20:37:06',0,'2014-01-16 08:44:51',NULL,NULL),(20619,3871,'3649280','834','00','005010X220A1','3649280','','2014-02-20','19:19:44',0,'2014-02-21 22:00:30',NULL,NULL),(20988,3958,'2791449','834','00','005010X220A1','2791449','','2014-02-21','22:35:14',0,'2014-02-26 08:30:28',NULL,NULL),(22436,4230,'3246119','834','00','005010X220A1','3246119','','2014-03-04','11:45:16',0,'2014-03-04 21:30:07',NULL,NULL),(12,1,'749039','834','00','005010X220A1','749039','','2013-12-05','09:47:53',0,'2013-12-25 17:15:24',NULL,NULL),(5540,1041,'1801919','834','00','005010X220A1','1801919','','2013-12-25','00:04:45',0,'2013-12-26 01:47:43',NULL,NULL),(14073,2341,'2166028','834','00','005010X220A1','2166028','','2014-01-07','18:22:26',0,'2014-01-13 02:21:52',NULL,NULL),(2852,512,'1166596','834','00','005010X220A1','1166596','','2013-12-22','09:36:19',0,'2013-12-25 21:22:05',NULL,NULL),(5504,1041,'426902','834','00','005010X220A1','426902','','2013-12-24','20:03:11',0,'2013-12-26 01:46:34',NULL,NULL),(4554,825,'1694826','834','00','005010X220A1','1694826','','2013-12-23','23:23:03',0,'2013-12-25 23:45:50',NULL,NULL),(7297,1259,'92445','834','00','005010X220A1','92445','','2013-12-18','10:37:01',0,'2013-12-26 04:09:37',NULL,NULL),(15735,2711,'2450580','834','00','005010X220A1','2450580','','2014-01-20','17:07:56',0,'2014-01-21 08:46:09',NULL,NULL),(18064,3321,'1992858','834','00','005010X220A1','1992858','','2014-02-06','11:01:36',0,'2014-02-06 21:00:51',NULL,NULL),(20624,3871,'2976483','834','00','005010X220A1','2976483','','2014-02-21','14:26:33',0,'2014-02-21 22:00:34',NULL,NULL),(21149,3997,'3099293','834','00','005010X220A1','3099293','','2014-02-26','10:20:51',0,'2014-02-26 21:00:43',NULL,NULL),(22247,4200,'2910847','834','00','005010X220A1','2910847','','2014-03-03','18:22:50',0,'2014-03-04 21:00:17',NULL,NULL),(4221,738,'398580','834','00','005010X220A1','398580','','2013-12-19','08:27:04',0,'2013-12-25 23:06:52',NULL,NULL),(14169,2364,'1691073','834','00','005010X220A1','1691073','','2014-01-09','18:18:31',0,'2014-01-13 02:23:19',NULL,NULL),(10504,1400,'1833873','834','00','005010X220A1','1833873','','2013-12-23','18:28:24',0,'2013-12-26 12:53:59',NULL,NULL),(18242,3369,'2629197','834','00','005010X220A1','2629197','','2014-02-07','16:55:05',0,'2014-02-07 19:01:07',NULL,NULL),(23154,4344,'3268133','834','00','005010X220A1','3268133','','2014-03-06','19:21:52',0,'2014-03-07 21:31:13',NULL,NULL),(23514,4434,'3528837','834','00','005010X220A1','3528837','','2014-03-10','14:34:20',0,'2014-03-10 21:00:13',NULL,NULL),(5514,1041,'1418612','834','00','005010X220A1','1418612','','2013-12-24','20:30:53',0,'2013-12-26 01:46:51',NULL,NULL),(3720,636,'1054497','834','00','005010X220A1','1054497','','2013-12-12','09:58:38',0,'2013-12-25 22:08:12',NULL,NULL),(16411,2995,'1640953','834','00','005010X220A1','1640953','','2014-01-23','15:29:15',0,'2014-01-23 21:01:29',NULL,NULL),(18676,3467,'2399926','834','00','005010X220A1','2399926','','2014-02-10','16:46:28',0,'2014-02-10 21:31:56',NULL,NULL),(22958,4312,'3373894','834','00','005010X220A1','3373894','','2014-03-05','19:08:25',0,'2014-03-06 21:30:03',NULL,NULL),(23019,4325,'3013291','834','00','005010X220A1','3013291','','2014-03-07','11:27:23',0,'2014-03-07 21:00:20',NULL,NULL),(295,69,'1001731','834','00','005010X220A1','1001731','','2013-12-03','18:15:08',0,'2013-12-25 17:45:04',NULL,NULL),(6992,1234,'789397','834','00','005010X220A1','789397','','2013-12-18','13:48:27',0,'2013-12-26 04:00:13',NULL,NULL),(1638,281,'93037','834','00','005010X220A1','93037','','2013-11-19','23:08:22',0,'2013-12-25 19:02:09',NULL,NULL),(13274,2118,'0001','999','BE','005010X231A1','5366','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:59',NULL,NULL),(2615,489,'1347424','834','00','005010X220A1','1347424','','2013-11-27','19:19:39',0,'2013-12-25 20:46:27',NULL,NULL),(12223,1616,'1760416','834','00','005010X220A1','1760416','','2014-01-01','14:58:13',1,'2014-01-02 04:22:20',NULL,NULL),(10793,1404,'1652307','834','00','005010X220A1','1652307','','2013-12-23','12:53:29',0,'2013-12-26 13:03:38',NULL,NULL),(7675,1320,'730481','834','00','005010X220A1','730481','','2013-12-21','12:45:28',0,'2013-12-26 04:39:40',NULL,NULL),(15425,2629,'2486605','834','00','005010X220A1','2486605','','2014-01-16','12:35:04',0,'2014-01-17 03:35:59',NULL,NULL),(15645,2679,'1466365','834','00','005010X220A1','1466365','','2014-01-17','20:09:04',0,'2014-01-21 08:44:21',NULL,NULL),(18750,3485,'2188296','834','00','005010X220A1','2188296','','2014-02-11','14:37:24',0,'2014-02-11 21:00:38',NULL,NULL),(20233,3790,'3246932','834','00','005010X220A1','3246932','','2014-02-18','20:44:08',0,'2014-02-20 04:27:31',NULL,NULL),(20346,3808,'3553115','834','00','005010X220A1','3553115','','2014-02-19','09:35:47',0,'2014-02-20 04:53:52',NULL,NULL),(21622,4065,'3208038','834','00','005010X220A1','3208038','','2014-02-27','14:51:27',0,'2014-02-28 07:30:20',NULL,NULL),(23102,4340,'3543911','834','00','005010X220A1','3543911','','2014-03-07','10:43:45',0,'2014-03-07 21:30:36',NULL,NULL),(1881,325,'194734','834','00','005010X220A1','194734','','2013-12-08','21:31:30',0,'2013-12-25 19:31:15',NULL,NULL),(5322,999,'1177723','834','00','005010X220A1','1177723','','2013-11-05','13:42:14',0,'2013-12-26 01:02:17',NULL,NULL),(4569,826,'269036','834','00','005010X220A1','269036','','2013-12-23','21:04:01',0,'2013-12-25 23:46:18',NULL,NULL),(3931,714,'598431','834','00','005010X220A1','598431','','2013-12-06','18:34:30',0,'2013-12-25 22:45:58',NULL,NULL),(12563,1662,'1778281','834','00','005010X220A1','1778281','','2013-12-31','13:49:26',1,'2014-01-02 04:35:49',NULL,NULL),(18357,3402,'2399887','834','00','005010X220A1','2399887','','2014-02-09','13:03:40',0,'2014-02-09 19:00:06',NULL,NULL),(19849,3695,'3511141','834','00','005010X220A1','3511141','','2014-02-15','12:01:30',0,'2014-02-15 22:02:05',NULL,NULL),(21599,4063,'3617458','834','00','005010X220A1','3617458','','2014-02-26','18:13:30',0,'2014-02-28 07:30:03',NULL,NULL),(21746,4090,'3826013','834','00','005010X220A1','3826013','','2014-02-27','22:48:29',0,'2014-02-28 21:30:44',NULL,NULL),(22840,4279,'3383341','834','00','005010X220A1','3383341','','2014-03-05','18:43:00',0,'2014-03-06 21:01:32',NULL,NULL),(6261,1172,'1311853','834','00','005010X220A1','1311853','','2013-12-19','23:01:33',0,'2013-12-26 03:06:14',NULL,NULL),(833,173,'1119399','834','00','005010X220A1','1119399','','2013-12-03','13:43:56',0,'2013-12-25 18:15:08',NULL,NULL),(2410,415,'1278354','834','00','005010X220A1','1278354','','2013-12-06','12:03:54',0,'2013-12-25 20:17:33',NULL,NULL),(7179,1238,'1210676','834','00','005010X220A1','1210676','','2013-12-18','17:41:40',0,'2013-12-26 04:05:59',NULL,NULL),(15352,2623,'1852198','834','00','005010X220A1','1852198','','2014-01-16','00:10:40',0,'2014-01-17 03:35:24',NULL,NULL),(15902,2742,'1993640','834','00','005010X220A1','1993640','','2014-01-21','13:15:25',1,'2014-01-22 03:22:42',NULL,NULL),(18300,3382,'1954964','834','00','005010X220A1','1954964','','2014-02-07','19:04:13',0,'2014-02-08 19:00:35',NULL,NULL),(19432,3601,'3095271','834','00','005010X220A1','3095271','','2014-02-13','14:37:09',0,'2014-02-13 22:02:53',NULL,NULL),(244,42,'1198755','834','00','005010X220A1','1198755','','2013-11-13','11:14:20',0,'2013-12-25 17:30:39',NULL,NULL),(4146,733,'863068','834','00','005010X220A1','863068','','2013-12-19','17:01:51',0,'2013-12-25 23:04:34',NULL,NULL),(14906,2558,'1915913','834','00','005010X220A1','1915913','','2014-01-14','14:19:56',0,'2014-01-15 02:07:32',NULL,NULL),(14309,2391,'1409925','834','00','005010X220A1','1409925','','2014-01-10','16:50:04',0,'2014-01-13 03:00:36',NULL,NULL),(13577,2254,'2272504','834','00','005010X220A1','2272504','','2014-01-05','14:01:07',1,'2014-01-07 10:21:54',NULL,NULL),(1390,245,'900361','834','00','005010X220A1','900361','','2013-12-24','17:38:17',0,'2013-12-25 18:53:42',NULL,NULL),(7502,1300,'1132671','834','00','005010X220A1','1132671','','2013-12-20','23:27:35',0,'2013-12-26 04:34:08',NULL,NULL),(2139,360,'490433','834','00','005010X220A1','490433','','2013-12-02','13:07:39',0,'2013-12-25 19:46:07',NULL,NULL),(3899,709,'1216389','834','00','005010X220A1','1216389','','2013-10-25','21:12:23',0,'2013-12-25 22:32:13',NULL,NULL),(15480,2634,'1911601','834','00','005010X220A1','1911601','','2014-01-16','10:29:22',0,'2014-01-17 03:36:22',NULL,NULL),(15547,2655,'1617131','834','00','005010X220A1','1617131','','2014-01-17','11:44:32',0,'2014-01-20 08:05:46',NULL,NULL),(16771,3074,'2232299','834','00','005010X220A1','2232299','','2014-01-27','10:57:53',0,'2014-01-27 21:01:34',NULL,NULL),(17206,3150,'1882183','834','00','005010X220A1','1882183','','2014-01-30','12:11:11',0,'2014-01-30 21:01:13',NULL,NULL),(18295,3380,'2033779','834','00','005010X220A1','2033779','','2014-02-08','13:53:53',0,'2014-02-08 19:00:32',NULL,NULL),(19124,3546,'2792313','834','00','005010X220A1','2792313','','2014-02-11','21:53:15',0,'2014-02-12 21:31:53',NULL,NULL),(21830,4099,'3760315','834','00','005010X220A1','3760315','','2014-02-27','23:51:00',0,'2014-02-28 21:31:43',NULL,NULL),(21877,4122,'3376373','834','00','005010X220A1','3376373','','2014-03-01','11:48:40',0,'2014-03-01 21:00:14',NULL,NULL),(22520,4247,'3667414','834','00','005010X220A1','3667414','','2014-03-05','13:07:08',0,'2014-03-05 21:30:20',NULL,NULL),(22790,4277,'3844612','834','00','005010X220A1','3844612','','2014-03-06','16:09:28',0,'2014-03-06 21:00:58',NULL,NULL),(23152,4343,'3639441','834','00','005010X220A1','3639441','','2014-03-07','11:13:23',0,'2014-03-07 21:31:12',NULL,NULL),(7,1,'22983','834','00','005010X220A1','22983','','2013-12-04','21:53:57',0,'2013-12-25 17:15:13',NULL,NULL),(2315,403,'977629','834','00','005010X220A1','977629','','2013-11-02','15:29:06',0,'2013-12-25 20:01:43',NULL,NULL),(5211,950,'774338','834','00','005010X220A1','774338','','2013-12-11','10:59:30',0,'2013-12-26 00:52:42',NULL,NULL),(11170,1443,'646852','834','00','005010X220A1','646852','','2013-12-23','10:45:58',0,'2013-12-26 13:16:38',NULL,NULL),(16162,2854,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:22:00',1,'2014-01-23 04:12:40',NULL,NULL),(16783,3081,'2604290','834','00','005010X220A1','2604290','','2014-01-27','15:33:55',0,'2014-01-27 21:01:44',NULL,NULL),(18303,3382,'2440607','834','00','005010X220A1','2440607','','2014-02-07','22:37:23',0,'2014-02-08 19:00:37',NULL,NULL),(18527,3451,'1913564','834','00','005010X220A1','1913564','','2014-02-10','12:13:05',0,'2014-02-10 21:30:13',NULL,NULL),(20150,3776,'3367930','834','00','005010X220A1','3367930','','2014-02-19','08:53:17',0,'2014-02-20 04:03:38',NULL,NULL),(20875,3917,'2863064','834','00','005010X220A1','2863064','','2014-02-25','12:25:20',0,'2014-02-25 21:31:50',NULL,NULL),(1755,293,'563451','834','00','005010X220A1','563451','','2013-12-10','16:55:58',0,'2013-12-25 19:18:08',NULL,NULL),(13793,2294,'1645443','834','00','005010X220A1','1645443','','2014-01-11','10:25:50',0,'2014-01-13 02:18:10',NULL,NULL),(13777,2288,'2558187','834','00','005010X220A1','2558187','','2014-01-07','11:33:11',0,'2014-01-08 18:25:04',NULL,NULL),(11044,1418,'312055','834','00','005010X220A1','312055','','2013-12-23','13:11:26',0,'2013-12-26 13:12:16',NULL,NULL),(4178,734,'737504','834','00','005010X220A1','737504','','2013-12-19','12:36:00',0,'2013-12-25 23:05:29',NULL,NULL),(1999,329,'503906','834','00','005010X220A1','503906','','2013-12-09','13:16:36',0,'2013-12-25 19:34:50',NULL,NULL),(16746,3067,'2314406','834','00','005010X220A1','2314406','','2014-01-27','10:57:08',0,'2014-01-27 21:01:15',NULL,NULL),(18071,3321,'2366278','834','00','005010X220A1','2366278','','2014-02-06','14:07:06',0,'2014-02-06 21:00:56',NULL,NULL),(18304,3382,'2747733','834','00','005010X220A1','2747733','','2014-02-08','12:21:16',0,'2014-02-08 19:00:37',NULL,NULL),(23460,4413,'3391223','834','00','005010X220A1','3391223','','2014-03-09','10:58:35',0,'2014-03-09 21:01:00',NULL,NULL),(23461,4413,'3740828','834','00','005010X220A1','3740828','','2014-03-09','11:33:22',0,'2014-03-09 21:01:01',NULL,NULL),(69,3,'79377','834','00','005010X220A1','79377','','2013-12-05','17:36:56',0,'2013-12-25 17:17:06',NULL,NULL),(230,35,'436841','834','00','005010X220A1','436841','','2013-10-12','14:04:07',0,'2013-12-25 17:30:13',NULL,NULL),(470,89,'211185','834','00','005010X220A1','211185','','2013-12-04','10:44:09',0,'2013-12-25 17:50:41',NULL,NULL),(10698,1403,'961170','834','00','005010X220A1','961170','','2013-12-23','09:51:21',0,'2013-12-26 13:00:27',NULL,NULL),(4430,792,'446848','834','00','005010X220A1','446848','','2013-11-06','15:13:59',0,'2013-12-25 23:17:03',NULL,NULL),(7119,1236,'623272','834','00','005010X220A1','623272','','2013-12-18','15:29:01',0,'2013-12-26 04:04:11',NULL,NULL),(19906,3721,'3298897','834','00','005010X220A1','3298897','','2014-02-16','17:22:40',0,'2014-02-16 19:00:43',NULL,NULL),(36,1,'1249085','834','00','005010X220A1','1249085','','2013-12-05','15:14:02',0,'2013-12-25 17:16:03',NULL,NULL),(13592,2258,'2211492','834','00','005010X220A1','2211492','','2014-01-05','10:10:03',1,'2014-01-07 10:22:32',NULL,NULL),(13057,1901,'0001','999','BE','005010X231A1','897194','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:39',NULL,NULL),(1096,225,'145805','834','00','005010X220A1','145805','','2013-10-25','12:11:54',0,'2013-12-25 18:31:52',NULL,NULL),(12028,1583,'2096129','834','00','005010X220A1','2096129','','2013-12-30','13:45:45',0,'2014-01-01 12:03:08',NULL,NULL),(10825,1404,'564067','834','00','005010X220A1','564067','','2013-12-23','17:12:33',0,'2013-12-26 13:04:41',NULL,NULL),(1123,238,'12322','834','00','005010X220A1','12322','','2013-12-24','13:37:50',0,'2013-12-25 18:45:22',NULL,NULL),(3307,584,'885345','834','00','005010X220A1','885345','','2013-12-17','13:21:25',0,'2013-12-25 21:48:42',NULL,NULL),(1529,260,'600486','834','00','005010X220A1','600486','','2013-12-24','16:25:47',0,'2013-12-25 18:58:20',NULL,NULL),(3135,551,'354021','834','00','005010X220A1','354021','','2013-12-13','15:48:41',0,'2013-12-25 21:37:16',NULL,NULL),(2628,493,'1222380','834','00','005010X220A1','1222380','','2013-11-27','18:32:13',0,'2013-12-25 20:46:52',NULL,NULL),(18744,3485,'2828848','834','00','005010X220A1','2828848','','2014-02-11','13:08:35',0,'2014-02-11 21:00:33',NULL,NULL),(19689,3669,'3083358','834','00','005010X220A1','3083358','','2014-02-14','18:03:10',0,'2014-02-15 21:00:11',NULL,NULL),(20834,3911,'3234649','834','00','005010X220A1','3234649','','2014-02-25','10:00:34',0,'2014-02-25 21:31:18',NULL,NULL),(22852,4280,'3055948','834','00','005010X220A1','3055948','','2014-03-05','18:34:45',0,'2014-03-06 21:01:41',NULL,NULL),(23060,4339,'2880235','834','00','005010X220A1','2880235','','2014-03-06','20:57:15',0,'2014-03-07 21:30:06',NULL,NULL),(12249,1620,'2539936','834','00','005010X220A1','2539936','','2013-12-31','19:24:13',1,'2014-01-02 04:23:23',NULL,NULL),(14655,2530,'1578044','834','00','005010X220A1','1578044','','2014-01-13','17:24:07',0,'2014-01-14 01:33:41',NULL,NULL),(23534,4435,'3696993','834','00','005010X220A1','3696993','','2014-03-09','23:46:41',0,'2014-03-10 21:00:26',NULL,NULL),(1295,244,'786013','834','00','005010X220A1','786013','','2013-12-24','12:04:03',0,'2013-12-25 18:50:38',NULL,NULL),(13285,2129,'0001','999','BE','005010X231A1','386713','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:30',NULL,NULL),(13164,2008,'0001','999','BE','005010X231A1','550040','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:12',NULL,NULL),(12058,1585,'1804411','834','00','005010X220A1','1804411','','2013-12-30','14:32:33',0,'2014-01-01 12:04:17',NULL,NULL),(1298,244,'1925301','834','00','005010X220A1','1925301','','2013-12-24','14:06:35',0,'2013-12-25 18:50:43',NULL,NULL),(1588,279,'73656','834','00','005010X220A1','73656','','2013-11-19','19:15:16',0,'2013-12-25 19:00:52',NULL,NULL),(10835,1404,'1484734','834','00','005010X220A1','1484734','','2013-12-23','18:23:55',0,'2013-12-26 13:04:59',NULL,NULL),(10487,1400,'246923','834','00','005010X220A1','246923','','2013-12-23','16:29:24',0,'2013-12-26 12:53:29',NULL,NULL),(7703,1332,'140531','834','00','005010X220A1','140531','','2013-11-14','23:56:44',0,'2013-12-26 04:45:34',NULL,NULL),(13692,2273,'2545035','834','00','005010X220A1','2545035','','2014-01-07','17:30:55',0,'2014-01-08 18:24:26',NULL,NULL),(6364,1182,'466599','834','00','005010X220A1','466599','','2013-12-20','07:54:43',0,'2013-12-26 03:09:21',NULL,NULL),(3079,545,'919563','834','00','005010X220A1','919563','','2013-12-13','12:35:49',0,'2013-12-25 21:35:34',NULL,NULL),(3347,587,'629448','834','00','005010X220A1','629448','','2013-12-16','22:35:27',0,'2013-12-25 21:50:06',NULL,NULL),(5369,1009,'1227963','834','00','005010X220A1','1227963','','2013-11-25','09:35:21',0,'2013-12-26 01:16:30',NULL,NULL),(3384,587,'1193212','834','00','005010X220A1','1193212','','2013-12-17','17:13:14',0,'2013-12-25 21:51:12',NULL,NULL),(3790,657,'247602','834','00','005010X220A1','247602','','2013-12-07','18:33:29',0,'2013-12-25 22:15:58',NULL,NULL),(4008,731,'421816','834','00','005010X220A1','421816','','2013-12-19','00:10:49',0,'2013-12-25 23:00:22',NULL,NULL),(15656,2683,'1377059','834','00','005010X220A1','1377059','','2014-01-18','15:44:26',0,'2014-01-21 08:44:28',NULL,NULL),(15970,2764,'1373140','834','00','005010X220A1','1373140','','2014-01-22','16:33:26',0,'2014-01-23 03:01:59',NULL,NULL),(21809,4093,'2944308','834','00','005010X220A1','2944308','','2014-02-27','20:40:22',0,'2014-02-28 21:31:27',NULL,NULL),(16562,3034,'2481841','834','00','005010X220A1','2481841','','2014-01-24','21:31:07',0,'2014-01-25 19:00:02',NULL,NULL),(17027,3120,'1756112','834','00','005010X220A1','1756112','','2014-01-29','13:14:54',0,'2014-01-29 21:01:11',NULL,NULL),(17237,3164,'2052869','834','00','005010X220A1','2052869','','2014-01-30','13:54:55',0,'2014-01-30 21:01:35',NULL,NULL),(2168,362,'878207','834','00','005010X220A1','878207','','2013-12-02','15:33:40',0,'2013-12-25 19:47:04',NULL,NULL),(13008,1742,'1614177','834','00','005010X220A1','1614177','','2014-01-04','08:35:21',0,'2014-01-05 00:02:26',NULL,NULL),(12346,1634,'1752562','834','00','005010X220A1','1752562','','2013-12-31','12:33:55',1,'2014-01-02 04:27:45',NULL,NULL),(2349,413,'3921','834','00','005010X220A1','3921','','2013-12-06','11:57:01',0,'2013-12-25 20:15:37',NULL,NULL),(11908,1564,'1464621','834','00','005010X220A1','1464621','','2013-12-28','21:59:08',0,'2013-12-30 00:01:17',NULL,NULL),(3524,616,'7498','834','00','005010X220A1','7498','','2013-12-11','18:25:36',0,'2013-12-25 22:01:56',NULL,NULL),(5835,1091,'792737','834','00','005010X220A1','792737','','2013-11-23','17:09:33',0,'2013-12-26 02:15:32',NULL,NULL),(3643,623,'241231','834','00','005010X220A1','241231','','2013-12-12','10:38:38',0,'2013-12-25 22:05:42',NULL,NULL),(4108,733,'684035','834','00','005010X220A1','684035','','2013-12-19','12:33:08',0,'2013-12-25 23:03:27',NULL,NULL),(3743,644,'24662','834','00','005010X220A1','24662','','2013-12-12','13:53:22',0,'2013-12-25 22:08:58',NULL,NULL),(14188,2365,'1809697','834','00','005010X220A1','1809697','','2014-01-10','11:21:00',0,'2014-01-13 02:23:35',NULL,NULL),(14441,2462,'0001','999','BE','005010X231A1','920734','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:12',NULL,NULL),(14771,2551,'1970722','834','00','005010X220A1','1970722','','2014-01-14','11:42:51',0,'2014-01-15 02:06:33',NULL,NULL),(15481,2634,'1662123','834','00','005010X220A1','1662123','','2014-01-16','11:30:26',0,'2014-01-17 03:36:23',NULL,NULL),(15731,2711,'1967195','834','00','005010X220A1','1967195','','2014-01-20','00:01:15',0,'2014-01-21 08:46:07',NULL,NULL),(16775,3076,'1515305','834','00','005010X220A1','1515305','','2014-01-27','12:09:48',0,'2014-01-27 21:01:37',NULL,NULL),(21121,3994,'2707795','834','00','005010X220A1','2707795','','2014-02-26','14:59:01',0,'2014-02-26 21:00:23',NULL,NULL),(21376,4024,'2681320','834','00','005010X220A1','2681320','','2014-02-27','12:31:12',0,'2014-02-28 06:30:24',NULL,NULL),(21836,4102,'3748646','834','00','005010X220A1','3748646','','2014-02-28','11:09:17',0,'2014-02-28 21:31:48',NULL,NULL),(18586,3453,'2604618','834','00','005010X220A1','2604618','','2014-02-10','18:19:14',0,'2014-02-10 21:30:54',NULL,NULL),(19417,3596,'2313470','834','00','005010X220A1','2313470','','2014-02-13','09:42:33',0,'2014-02-13 22:02:41',NULL,NULL),(19623,3640,'2509190','834','00','005010X220A1','2509190','','2014-02-13','22:51:17',0,'2014-02-14 21:31:55',NULL,NULL),(20009,3748,'2980212','834','00','005010X220A1','2980212','','2014-02-18','16:23:48',0,'2014-02-18 22:00:39',NULL,NULL),(119,7,'207179','834','00','005010X220A1','207179','','2013-12-04','23:19:29',0,'2013-12-25 17:18:39',NULL,NULL),(12735,1684,'2232859','834','00','005010X220A1','2232859','','2014-01-02','13:27:31',0,'2014-01-03 02:06:07',NULL,NULL),(12587,1670,'1499778','834','00','005010X220A1','1499778','','2014-01-02','15:00:40',0,'2014-01-03 02:00:38',NULL,NULL),(11822,1540,'1066121','834','00','005010X220A1','1066121','','2013-12-28','20:06:04',1,'2013-12-29 11:13:48',NULL,NULL),(5291,980,'980100','834','00','005010X220A1','980100','','2013-11-15','21:59:45',0,'2013-12-26 01:01:06',NULL,NULL),(15931,2750,'1538530','834','00','005010X220A1','1538530','','2014-01-21','13:20:25',1,'2014-01-22 03:23:00',NULL,NULL),(16042,2771,'2547960','834','00','005010X220A1','2547960','','2014-01-22','17:48:00',0,'2014-01-23 03:02:32',NULL,NULL),(17494,3221,'2055262','834','00','005010X220A1','2055262','','2014-02-01','20:48:32',0,'2014-02-02 19:00:20',NULL,NULL),(19189,3570,'2185050','834','00','005010X220A1','2185050','','2014-02-12','21:11:08',0,'2014-02-13 21:30:07',NULL,NULL),(19385,3592,'3127801','834','00','005010X220A1','3127801','','2014-02-12','23:27:37',0,'2014-02-13 22:02:18',NULL,NULL),(19549,3626,'3019364','834','00','005010X220A1','3019364','','2014-02-13','22:06:29',0,'2014-02-14 21:31:01',NULL,NULL),(4965,930,'956043','834','00','005010X220A1','956043','','2013-10-06','21:15:02',0,'2013-12-26 00:32:17',NULL,NULL),(12315,1633,'1384745','834','00','005010X220A1','1384745','','2014-01-01','17:55:06',1,'2014-01-02 04:25:50',NULL,NULL),(6174,1167,'1265853','834','00','005010X220A1','1265853','','2013-12-20','15:40:28',0,'2013-12-26 03:03:31',NULL,NULL),(11393,1463,'1104682','834','00','005010X220A1','1104682','','2013-12-26','17:08:09',0,'2013-12-27 02:06:19',NULL,NULL),(13696,2274,'2217953','834','00','005010X220A1','2217953','','2014-01-07','12:54:03',0,'2014-01-08 18:24:28',NULL,NULL),(7269,1251,'474296','834','00','005010X220A1','474296','','2013-12-18','08:37:24',0,'2013-12-26 04:08:47',NULL,NULL),(10613,1402,'780565','834','00','005010X220A1','780565','','2013-12-23','14:09:03',0,'2013-12-26 12:57:36',NULL,NULL),(16512,3013,'2048874','834','00','005010X220A1','2048874','','2014-01-23','20:56:14',0,'2014-01-24 21:00:49',NULL,NULL),(18015,3318,'2750394','834','00','005010X220A1','2750394','','2014-02-05','18:55:32',0,'2014-02-06 21:00:18',NULL,NULL),(18587,3453,'3077095','834','00','005010X220A1','3077095','','2014-02-10','18:19:14',0,'2014-02-10 21:30:54',NULL,NULL),(19130,3548,'2028389','834','00','005010X220A1','2028389','','2014-02-11','21:30:52',0,'2014-02-12 21:31:56',NULL,NULL),(19237,3580,'2772713','834','00','005010X220A1','2772713','','2014-02-13','13:42:28',0,'2014-02-13 22:00:24',NULL,NULL),(4118,733,'858149','834','00','005010X220A1','858149','','2013-12-19','13:41:32',0,'2013-12-25 23:03:47',NULL,NULL),(854,175,'1018381','834','00','005010X220A1','1018381','','2013-12-03','11:43:39',0,'2013-12-25 18:15:46',NULL,NULL),(869,176,'778654','834','00','005010X220A1','778654','','2013-12-02','18:49:33',0,'2013-12-25 18:16:17',NULL,NULL),(3034,544,'1139585','834','00','005010X220A1','1139585','','2013-12-13','09:53:57',0,'2013-12-25 21:34:08',NULL,NULL),(10824,1404,'1789619','834','00','005010X220A1','1789619','','2013-12-23','17:07:07',0,'2013-12-26 13:04:40',NULL,NULL),(1913,325,'1310017','834','00','005010X220A1','1310017','','2013-12-09','15:35:28',0,'2013-12-25 19:32:07',NULL,NULL),(21375,4024,'3783428','834','00','005010X220A1','3783428','','2014-02-27','12:27:26',0,'2014-02-28 06:30:23',NULL,NULL),(23439,4407,'3767364','834','00','005010X220A1','3767364','','2014-03-08','21:22:46',0,'2014-03-09 21:00:40',NULL,NULL),(207,25,'826457','834','00','005010X220A1','826457','','2013-12-05','13:45:31',0,'2013-12-25 17:21:31',NULL,NULL),(13925,2314,'1955492','834','00','005010X220A1','1955492','','2014-01-08','19:31:21',0,'2014-01-13 02:20:01',NULL,NULL),(414,77,'142181','834','00','005010X220A1','142181','','2013-12-03','19:37:30',0,'2013-12-25 17:48:49',NULL,NULL),(11729,1520,'1615235','834','00','005010X220A1','1615235','','2013-12-27','18:54:23',1,'2013-12-29 11:08:47',NULL,NULL),(1661,289,'408835','834','00','005010X220A1','408835','','2013-12-10','16:14:45',0,'2013-12-25 19:15:16',NULL,NULL),(16044,2772,'2180947','834','00','005010X220A1','2180947','','2014-01-22','10:02:18',0,'2014-01-23 03:02:33',NULL,NULL),(19465,3618,'3307341','834','00','005010X220A1','3307341','','2014-02-13','17:17:06',0,'2014-02-13 22:03:20',NULL,NULL),(21508,4031,'3134186','834','00','005010X220A1','3134186','','2014-02-27','15:25:48',0,'2014-02-28 06:31:25',NULL,NULL),(22672,4255,'2705821','834','00','005010X220A1','2705821','','2014-03-04','22:01:59',0,'2014-03-05 21:32:07',NULL,NULL),(160,11,'1160601','834','00','005010X220A1','1160601','','2013-12-04','19:36:30',0,'2013-12-25 17:19:57',NULL,NULL),(4672,831,'1818196','834','00','005010X220A1','1818196','','2013-12-23','22:58:11',0,'2013-12-25 23:49:38',NULL,NULL),(17104,3142,'2346780','834','00','005010X220A1','2346780','','2014-01-30','09:33:37',0,'2014-01-30 21:00:08',NULL,NULL),(17418,3200,'2629068','834','00','005010X220A1','2629068','','2014-02-01','00:08:26',0,'2014-02-01 19:00:20',NULL,NULL),(20141,3772,'3635385','834','00','005010X220A1','3635385','','2014-02-19','17:02:13',0,'2014-02-20 04:01:27',NULL,NULL),(22600,4250,'2654592','834','00','005010X220A1','2654592','','2014-03-05','10:56:42',0,'2014-03-05 21:31:18',NULL,NULL),(1178,239,'1659998','834','00','005010X220A1','1659998','','2013-12-24','14:22:04',0,'2013-12-25 18:47:04',NULL,NULL),(14617,2524,'1739167','834','00','005010X220A1','1739167','','2014-01-13','09:30:56',0,'2014-01-14 01:33:18',NULL,NULL),(13483,2226,'1994684','834','00','005010X220A1','1994684','','2014-01-06','11:31:50',0,'2014-01-07 04:04:01',NULL,NULL),(12974,1734,'2012157','834','00','005010X220A1','2012157','','2014-01-04','13:07:39',0,'2014-01-05 00:01:13',NULL,NULL),(1652,286,'934783','834','00','005010X220A1','934783','','2013-11-20','13:32:32',0,'2013-12-25 19:02:33',NULL,NULL),(11820,1539,'891322','834','00','005010X220A1','891322','','2013-12-28','20:29:06',1,'2013-12-29 11:13:44',NULL,NULL),(11659,1500,'1269509','834','00','005010X220A1','1269509','','2013-12-27','12:37:54',0,'2013-12-28 03:36:33',NULL,NULL),(2260,380,'616213','834','00','005010X220A1','616213','','2013-12-02','16:11:39',0,'2013-12-25 19:50:14',NULL,NULL),(4611,827,'1428279','834','00','005010X220A1','1428279','','2013-12-23','21:17:25',0,'2013-12-25 23:47:36',NULL,NULL),(3494,615,'242233','834','00','005010X220A1','242233','','2013-12-12','13:32:43',0,'2013-12-25 22:00:59',NULL,NULL),(3430,598,'832005','834','00','005010X220A1','832005','','2013-12-17','08:40:32',0,'2013-12-25 21:52:39',NULL,NULL),(19194,3571,'2391937','834','00','005010X220A1','2391937','','2014-02-13','11:15:38',0,'2014-02-13 21:30:09',NULL,NULL),(1066,211,'341749','834','00','005010X220A1','341749','','2013-11-29','13:03:21',0,'2013-12-25 18:30:48',NULL,NULL),(14671,2546,'1759257','834','00','005010X220A1','1759257','','2014-01-13','17:57:43',0,'2014-01-14 01:33:53',NULL,NULL),(1174,239,'309654','834','00','005010X220A1','309654','','2013-12-24','13:39:45',0,'2013-12-25 18:46:57',NULL,NULL),(2022,331,'487936','834','00','005010X220A1','487936','','2013-12-09','14:38:25',0,'2013-12-25 19:35:33',NULL,NULL),(15923,2745,'2266060','834','00','005010X220A1','2266060','','2014-01-21','11:00:10',1,'2014-01-22 03:22:55',NULL,NULL),(17515,3234,'2598063','834','00','005010X220A1','2598063','','2014-02-02','18:28:59',0,'2014-02-03 21:00:05',NULL,NULL),(17657,3255,'1738301','834','00','005010X220A1','1738301','','2014-02-03','18:06:41',0,'2014-02-03 21:01:37',NULL,NULL),(18604,3456,'2534327','834','00','005010X220A1','2534327','','2014-02-10','12:25:28',0,'2014-02-10 21:31:06',NULL,NULL),(19420,3596,'2231208','834','00','005010X220A1','2231208','','2014-02-12','18:46:23',0,'2014-02-13 22:02:44',NULL,NULL),(23485,4427,'3145640','834','00','005010X220A1','3145640','','2014-03-08','20:15:32',0,'2014-03-09 21:29:59',NULL,NULL),(766,144,'603039','834','00','005010X220A1','603039','','2013-10-28','19:03:26',0,'2013-12-25 18:08:54',NULL,NULL),(12184,1600,'2034100','834','00','005010X220A1','2034100','','2013-12-30','16:48:33',0,'2014-01-01 12:08:42',NULL,NULL),(5520,1041,'769220','834','00','005010X220A1','769220','','2013-12-24','21:03:29',0,'2013-12-26 01:47:01',NULL,NULL),(11005,1413,'1303328','834','00','005010X220A1','1303328','','2013-12-23','18:49:50',0,'2013-12-26 13:10:57',NULL,NULL),(15111,2587,'1536946','834','00','005010X220A1','1536946','','2014-01-15','10:53:10',0,'2014-01-16 08:45:28',NULL,NULL),(17799,3270,'1844040','834','00','005010X220A1','1844040','','2014-02-04','15:05:16',0,'2014-02-04 21:01:32',NULL,NULL),(18305,3382,'2315868','834','00','005010X220A1','2315868','','2014-02-08','15:59:02',0,'2014-02-08 19:00:38',NULL,NULL),(19421,3597,'2890616','834','00','005010X220A1','2890616','','2014-02-13','09:54:43',0,'2014-02-13 22:02:45',NULL,NULL),(4009,731,'188801','834','00','005010X220A1','188801','','2013-12-19','00:43:14',0,'2013-12-25 23:00:23',NULL,NULL),(3197,578,'422787','834','00','005010X220A1','422787','','2013-12-16','20:19:48',0,'2013-12-25 21:45:13',NULL,NULL),(13291,2135,'0001','999','BE','005010X231A1','719711','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:47',NULL,NULL),(21533,4039,'3449977','834','00','005010X220A1','3449977','','2014-02-27','11:03:50',0,'2014-02-28 06:31:37',NULL,NULL),(22024,4156,'3685548','834','00','005010X220A1','3685548','','2014-03-02','12:40:23',0,'2014-03-03 01:00:38',NULL,NULL),(22627,4252,'3316267','834','00','005010X220A1','3316267','','2014-03-05','10:40:28',0,'2014-03-05 21:31:38',NULL,NULL),(1132,238,'479879','834','00','005010X220A1','479879','','2013-12-24','15:39:44',0,'2013-12-25 18:45:38',NULL,NULL),(3474,615,'920930','834','00','005010X220A1','920930','','2013-12-12','02:17:23',0,'2013-12-25 22:00:21',NULL,NULL),(6383,1185,'725309','834','00','005010X220A1','725309','','2013-12-20','13:16:40',0,'2013-12-26 03:09:56',NULL,NULL),(10495,1400,'645655','834','00','005010X220A1','645655','','2013-12-23','17:30:03',0,'2013-12-26 12:53:42',NULL,NULL),(15567,2657,'1821588','834','00','005010X220A1','1821588','','2014-01-16','21:10:54',0,'2014-01-20 08:06:01',NULL,NULL),(17171,3146,'2314482','834','00','005010X220A1','2314482','','2014-01-29','19:06:59',0,'2014-01-30 21:00:51',NULL,NULL),(17630,3243,'2343343','834','00','005010X220A1','2343343','','2014-02-03','18:20:43',0,'2014-02-03 21:01:16',NULL,NULL),(17646,3250,'2534165','834','00','005010X220A1','2534165','','2014-02-03','13:03:07',0,'2014-02-03 21:01:28',NULL,NULL),(18807,3487,'2054220','834','00','005010X220A1','2054220','','2014-02-11','17:16:33',0,'2014-02-11 21:01:21',NULL,NULL),(19985,3746,'2847640','834','00','005010X220A1','2847640','','2014-02-18','16:35:46',0,'2014-02-18 22:00:23',NULL,NULL),(23271,4379,'2817544','834','00','005010X220A1','2817544','','2014-03-08','13:46:00',0,'2014-03-08 21:00:08',NULL,NULL),(7063,1236,'1234002','834','00','005010X220A1','1234002','','2013-12-17','20:16:10',0,'2013-12-26 04:02:25',NULL,NULL),(14838,2553,'2009203','834','00','005010X220A1','2009203','','2014-01-13','23:13:29',0,'2014-01-15 02:07:01',NULL,NULL),(11767,1528,'1492377','834','00','005010X220A1','1492377','','2013-12-28','16:21:50',1,'2013-12-29 11:09:57',NULL,NULL),(11516,1490,'1637857','834','00','005010X220A1','1637857','','2013-12-27','11:19:42',0,'2013-12-28 03:32:07',NULL,NULL),(10492,1400,'1710017','834','00','005010X220A1','1710017','','2013-12-23','17:05:01',0,'2013-12-26 12:53:37',NULL,NULL),(13600,2261,'1960271','834','00','005010X220A1','1960271','','2014-01-05','15:11:54',1,'2014-01-07 10:22:51',NULL,NULL),(12833,1704,'1264916','834','00','005010X220A1','1264916','','2014-01-03','12:06:22',0,'2014-01-04 02:02:27',NULL,NULL),(17998,3318,'2634960','834','00','005010X220A1','2634960','','2014-02-06','11:30:56',0,'2014-02-06 21:00:05',NULL,NULL),(19058,3542,'3266305','834','00','005010X220A1','3266305','','2014-02-12','11:40:42',0,'2014-02-12 21:31:07',NULL,NULL),(21198,3998,'2659589','834','00','005010X220A1','2659589','','2014-02-26','14:51:50',0,'2014-02-26 21:01:15',NULL,NULL),(23645,4441,'2853375','834','00','005010X220A1','2853375','','2014-03-10','15:10:54',0,'2014-03-10 21:01:47',NULL,NULL),(2179,363,'337997','834','00','005010X220A1','337997','','2013-12-02','07:53:52',0,'2013-12-25 19:47:26',NULL,NULL),(14730,2550,'2149627','834','00','005010X220A1','2149627','','2014-01-14','14:19:23',0,'2014-01-15 02:06:15',NULL,NULL),(7248,1245,'1271502','834','00','005010X220A1','1271502','','2013-12-17','20:37:50',0,'2013-12-26 04:08:09',NULL,NULL),(7337,1279,'568175','834','00','005010X220A1','568175','','2013-11-29','18:17:26',0,'2013-12-26 04:15:02',NULL,NULL),(15476,2634,'2268334','834','00','005010X220A1','2268334','','2014-01-16','00:29:02',0,'2014-01-17 03:36:20',NULL,NULL),(16296,2980,'1759499','834','00','005010X220A1','1759499','','2014-01-23','10:42:21',0,'2014-01-23 21:00:09',NULL,NULL),(18322,3385,'2168111','834','00','005010X220A1','2168111','','2014-02-08','11:25:21',0,'2014-02-08 19:00:48',NULL,NULL),(21212,3998,'3181768','834','00','005010X220A1','3181768','','2014-02-26','16:19:17',0,'2014-02-26 21:01:25',NULL,NULL),(21947,4133,'3800324','834','00','005010X220A1','3800324','','2014-03-01','13:22:49',0,'2014-03-01 21:01:03',NULL,NULL),(23743,4470,'3393568','834','00','005010X220A1','3393568','','2014-03-10','16:42:30',0,'2014-03-10 21:03:03',NULL,NULL),(7018,1235,'91386','834','00','005010X220A1','91386','','2013-12-18','10:10:06',0,'2013-12-26 04:01:03',NULL,NULL),(1125,238,'398981','834','00','005010X220A1','398981','','2013-12-24','13:52:40',0,'2013-12-25 18:45:26',NULL,NULL),(3091,546,'1303860','834','00','005010X220A1','1303860','','2013-12-12','20:27:54',0,'2013-12-25 21:35:56',NULL,NULL),(14024,2337,'2436168','834','00','005010X220A1','2436168','','2014-01-08','12:53:36',0,'2014-01-13 02:21:21',NULL,NULL),(4333,754,'580608','834','00','005010X220A1','580608','','2013-12-19','09:49:26',0,'2013-12-25 23:10:14',NULL,NULL),(4519,814,'731074','834','00','005010X220A1','731074','','2013-11-26','15:56:27',0,'2013-12-25 23:32:43',NULL,NULL),(11380,1462,'1537889','834','00','005010X220A1','1537889','','2013-12-26','13:35:36',0,'2013-12-27 02:05:56',NULL,NULL),(10449,1400,'1717944','834','00','005010X220A1','1717944','','2013-12-23','13:06:54',0,'2013-12-26 12:52:16',NULL,NULL),(17126,3143,'2245396','834','00','005010X220A1','2245396','','2014-01-30','14:56:57',0,'2014-01-30 21:00:22',NULL,NULL),(21655,4076,'3090677','834','00','005010X220A1','3090677','','2014-02-28','16:44:37',0,'2014-02-28 21:00:04',NULL,NULL),(23006,4322,'3042336','834','00','005010X220A1','3042336','','2014-03-07','17:33:48',0,'2014-03-07 21:00:14',NULL,NULL),(664,108,'384637','834','00','005010X220A1','384637','','2013-12-16','17:31:44',0,'2013-12-25 18:05:36',NULL,NULL),(15206,2592,'1992387','834','00','005010X220A1','1992387','','2014-01-15','16:37:59',0,'2014-01-16 08:46:28',NULL,NULL),(1423,250,'1187756','834','00','005010X220A1','1187756','','2013-12-24','08:50:52',0,'2013-12-25 18:54:49',NULL,NULL),(12812,1703,'1724939','834','00','005010X220A1','1724939','','2014-01-03','17:48:51',0,'2014-01-04 02:01:42',NULL,NULL),(15847,2738,'1546558','834','00','005010X220A1','1546558','','2014-01-20','23:48:35',1,'2014-01-22 03:22:07',NULL,NULL),(18751,3485,'2667800','834','00','005010X220A1','2667800','','2014-02-11','14:51:26',0,'2014-02-11 21:00:39',NULL,NULL),(18791,3487,'2869216','834','00','005010X220A1','2869216','','2014-02-11','11:18:40',0,'2014-02-11 21:01:08',NULL,NULL),(19596,3631,'3152220','834','00','005010X220A1','3152220','','2014-02-14','11:18:26',0,'2014-02-14 21:31:35',NULL,NULL),(20569,3865,'3342196','834','00','005010X220A1','3342196','','2014-02-20','18:41:03',0,'2014-02-21 21:30:15',NULL,NULL),(20647,3875,'3369459','834','00','005010X220A1','3369459','','2014-02-21','12:31:27',0,'2014-02-21 22:00:50',NULL,NULL),(345,72,'897005','834','00','005010X220A1','897005','','2013-12-03','23:58:15',0,'2013-12-25 17:46:37',NULL,NULL),(13888,2312,'1670262','834','00','005010X220A1','1670262','','2014-01-09','11:46:47',0,'2014-01-13 02:19:38',NULL,NULL),(11758,1523,'2192281','834','00','005010X220A1','2192281','','2013-12-28','13:06:09',1,'2013-12-29 11:09:40',NULL,NULL),(6407,1196,'180329','834','00','005010X220A1','180329','','2013-12-20','15:38:59',0,'2013-12-26 03:10:43',NULL,NULL),(671,109,'135321','834','00','005010X220A1','135321','','2013-12-16','10:18:38',0,'2013-12-25 18:05:48',NULL,NULL),(16147,2839,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:33:00',1,'2014-01-23 03:59:54',NULL,NULL),(19055,3542,'3246753','834','00','005010X220A1','3246753','','2014-02-12','11:27:43',0,'2014-02-12 21:31:04',NULL,NULL),(19632,3643,'3302099','834','00','005010X220A1','3302099','','2014-02-14','10:35:43',0,'2014-02-14 21:32:02',NULL,NULL),(20115,3772,'3303440','834','00','005010X220A1','3303440','','2014-02-18','22:42:04',0,'2014-02-20 03:49:18',NULL,NULL),(22016,4151,'3234835','834','00','005010X220A1','3234835','','2014-03-01','23:23:17',0,'2014-03-03 01:00:33',NULL,NULL),(23677,4445,'3594712','834','00','005010X220A1','3594712','','2014-03-10','15:19:32',0,'2014-03-10 21:02:10',NULL,NULL),(2001,329,'1169738','834','00','005010X220A1','1169738','','2013-12-09','14:30:08',0,'2013-12-25 19:34:54',NULL,NULL),(15417,2629,'2562061','834','00','005010X220A1','2562061','','2014-01-15','22:25:15',0,'2014-01-17 03:35:55',NULL,NULL),(6059,1163,'850680','834','00','005010X220A1','850680','','2013-11-09','21:08:24',0,'2013-12-26 02:46:54',NULL,NULL),(12601,1671,'1700503','834','00','005010X220A1','1700503','','2014-01-02','16:12:45',0,'2014-01-03 02:01:07',NULL,NULL),(10972,1411,'1009738','834','00','005010X220A1','1009738','','2013-12-23','16:11:37',0,'2013-12-26 13:09:48',NULL,NULL),(17891,3294,'1409079','834','00','005010X220A1','1409079','','2014-02-05','16:49:01',0,'2014-02-05 21:30:26',NULL,NULL),(19235,3580,'2585572','834','00','005010X220A1','2585572','','2014-02-13','12:55:29',0,'2014-02-13 22:00:23',NULL,NULL),(20044,3751,'2800488','834','00','005010X220A1','2800488','','2014-02-18','11:13:38',0,'2014-02-18 22:01:04',NULL,NULL),(734,127,'643919','834','00','005010X220A1','643919','','2013-12-16','11:42:11',0,'2013-12-25 18:07:52',NULL,NULL),(15262,2601,'2459412','834','00','005010X220A1','2459412','','2014-01-15','16:51:41',0,'2014-01-16 08:47:04',NULL,NULL),(931,180,'792853','834','00','005010X220A1','792853','','2013-12-03','17:40:21',0,'2013-12-25 18:18:03',NULL,NULL),(13705,2274,'1543379','834','00','005010X220A1','1543379','','2014-01-07','15:39:26',0,'2014-01-08 18:24:31',NULL,NULL),(11496,1489,'1859651','834','00','005010X220A1','1859651','','2013-12-27','06:47:45',0,'2013-12-28 03:31:31',NULL,NULL),(11711,1517,'1615246','834','00','005010X220A1','1615246','','2013-12-28','17:41:32',1,'2013-12-29 11:08:13',NULL,NULL),(6136,1166,'868117','834','00','005010X220A1','868117','','2013-12-20','16:09:05',0,'2013-12-26 03:02:25',NULL,NULL),(11608,1493,'1727627','834','00','005010X220A1','1727627','','2013-12-27','16:14:57',0,'2013-12-28 03:34:57',NULL,NULL),(11494,1489,'1527490','834','00','005010X220A1','1527490','','2013-12-27','05:53:24',0,'2013-12-28 03:31:28',NULL,NULL),(10797,1404,'503266','834','00','005010X220A1','503266','','2013-12-23','13:43:25',0,'2013-12-26 13:03:46',NULL,NULL),(7100,1236,'45720','834','00','005010X220A1','45720','','2013-12-18','12:11:17',0,'2013-12-26 04:03:36',NULL,NULL),(7590,1302,'827098','834','00','005010X220A1','827098','','2013-12-20','20:00:53',0,'2013-12-26 04:37:01',NULL,NULL),(14731,2550,'2089314','834','00','005010X220A1','2089314','','2014-01-14','14:29:16',0,'2014-01-15 02:06:15',NULL,NULL),(17191,3149,'1542726','834','00','005010X220A1','1542726','','2014-01-30','11:00:30',0,'2014-01-30 21:01:03',NULL,NULL),(17825,3276,'1525754','834','00','005010X220A1','1525754','','2014-02-04','12:28:54',0,'2014-02-04 21:01:50',NULL,NULL),(19498,3621,'2884675','834','00','005010X220A1','2884675','','2014-02-13','18:23:34',0,'2014-02-14 21:30:24',NULL,NULL),(19769,3675,'2584203','834','00','005010X220A1','2584203','','2014-02-15','10:48:39',0,'2014-02-15 22:00:58',NULL,NULL),(20396,3830,'3176614','834','00','005010X220A1','3176614','','2014-02-20','17:47:13',0,'2014-02-20 21:30:04',NULL,NULL),(21046,3977,'2883686','834','00','005010X220A1','2883686','','2014-02-24','16:13:21',0,'2014-02-26 09:30:23',NULL,NULL),(21203,3998,'3808955','834','00','005010X220A1','3808955','','2014-02-26','15:26:21',0,'2014-02-26 21:01:18',NULL,NULL),(14177,2365,'2366843','834','00','005010X220A1','2366843','','2014-01-09','18:18:36',0,'2014-01-13 02:23:26',NULL,NULL),(233,38,'1091714','834','00','005010X220A1','1091714','','2013-10-12','10:27:07',0,'2013-12-25 17:30:19',NULL,NULL),(1325,245,'403868','834','00','005010X220A1','403868','','2013-12-24','11:20:37',0,'2013-12-25 18:51:37',NULL,NULL),(2198,365,'962814','834','00','005010X220A1','962814','','2013-12-01','19:00:12',0,'2013-12-25 19:48:06',NULL,NULL),(4734,848,'271596','834','00','005010X220A1','271596','','2013-12-23','23:32:25',0,'2013-12-25 23:51:55',NULL,NULL),(11830,1541,'252137','834','00','005010X220A1','252137','','2013-12-28','20:22:39',1,'2013-12-29 11:14:03',NULL,NULL),(11124,1428,'907809','834','00','005010X220A1','907809','','2013-12-23','14:46:35',0,'2013-12-26 13:14:57',NULL,NULL),(11021,1416,'807481','834','00','005010X220A1','807481','','2013-12-22','19:38:17',0,'2013-12-26 13:11:32',NULL,NULL),(10740,1403,'1295580','834','00','005010X220A1','1295580','','2013-12-23','16:03:18',0,'2013-12-26 13:01:53',NULL,NULL),(10623,1402,'966286','834','00','005010X220A1','966286','','2013-12-23','15:25:46',0,'2013-12-26 12:57:56',NULL,NULL),(10509,1400,'843498','834','00','005010X220A1','843498','','2013-12-23','19:11:30',0,'2013-12-26 12:54:09',NULL,NULL),(6312,1175,'612248','834','00','005010X220A1','612248','','2013-12-19','20:36:33',0,'2013-12-26 03:07:46',NULL,NULL),(14533,2518,'1466162','834','00','005010X220A1','1466162','','2014-01-13','11:37:17',0,'2014-01-14 01:32:24',NULL,NULL),(16121,2813,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:27:00',1,'2014-01-23 03:46:43',NULL,NULL),(18055,3319,'2563876','834','00','005010X220A1','2563876','','2014-02-06','14:55:44',0,'2014-02-06 21:00:45',NULL,NULL),(18348,3397,'2372069','834','00','005010X220A1','2372069','','2014-02-08','00:24:42',0,'2014-02-08 19:30:07',NULL,NULL),(20699,3892,'3589265','834','00','005010X220A1','3589265','','2014-02-25','13:19:35',0,'2014-02-25 21:00:11',NULL,NULL),(21998,4146,'3274046','834','00','005010X220A1','3274046','','2014-03-02','13:17:10',0,'2014-03-03 01:00:22',NULL,NULL),(22711,4266,'3364764','834','00','005010X220A1','3364764','','2014-03-05','12:53:10',0,'2014-03-05 21:32:36',NULL,NULL),(929,180,'765668','834','00','005010X220A1','765668','','2013-12-02','23:16:36',0,'2013-12-25 18:17:59',NULL,NULL),(13434,2222,'2317716','834','00','005010X220A1','2317716','','2014-01-06','11:10:43',0,'2014-01-07 04:02:05',NULL,NULL),(12586,1670,'1856054','834','00','005010X220A1','1856054','','2014-01-02','11:26:42',0,'2014-01-03 02:00:36',NULL,NULL),(986,184,'692889','834','00','005010X220A1','692889','','2013-12-03','15:33:36',0,'2013-12-25 18:19:46',NULL,NULL),(3554,616,'1204078','834','00','005010X220A1','1204078','','2013-12-12','15:00:23',0,'2013-12-25 22:02:54',NULL,NULL),(4970,934,'51581','834','00','005010X220A1','51581','','2013-10-07','18:31:53',0,'2013-12-26 00:32:26',NULL,NULL),(10986,1413,'964935','834','00','005010X220A1','964935','','2013-12-23','10:33:57',0,'2013-12-26 13:10:17',NULL,NULL),(6034,1144,'827667','834','00','005010X220A1','827667','','2013-11-17','10:20:46',0,'2013-12-26 02:45:59',NULL,NULL),(14612,2522,'1906349','834','00','005010X220A1','1906349','','2014-01-13','15:55:20',0,'2014-01-14 01:33:14',NULL,NULL),(15215,2593,'2514951','834','00','005010X220A1','2514951','','2014-01-15','15:51:45',0,'2014-01-16 08:46:35',NULL,NULL),(15559,2655,'2103189','834','00','005010X220A1','2103189','','2014-01-17','12:29:22',0,'2014-01-20 08:05:55',NULL,NULL),(18152,3348,'2722225','834','00','005010X220A1','2722225','','2014-02-05','23:14:34',0,'2014-02-06 21:30:05',NULL,NULL),(20320,3796,'3480326','834','00','005010X220A1','3480326','','2014-02-19','13:32:54',0,'2014-02-20 04:48:11',NULL,NULL),(22597,4250,'2682739','834','00','005010X220A1','2682739','','2014-03-05','09:28:06',0,'2014-03-05 21:31:16',NULL,NULL),(22943,4299,'2755427','834','00','005010X220A1','2755427','','2014-03-06','11:55:14',0,'2014-03-06 21:02:48',NULL,NULL),(430,78,'916575','834','00','005010X220A1','916575','','2013-12-04','14:13:42',0,'2013-12-25 17:49:21',NULL,NULL),(11893,1561,'1498277','834','00','005010X220A1','1498277','','2013-12-28','22:25:27',0,'2013-12-30 00:00:47',NULL,NULL),(11824,1540,'190233','834','00','005010X220A1','190233','','2013-12-28','20:21:25',1,'2013-12-29 11:13:51',NULL,NULL),(756,139,'36803','834','00','005010X220A1','36803','','2013-12-16','14:17:14',0,'2013-12-25 18:08:32',NULL,NULL),(1126,238,'998700','834','00','005010X220A1','998700','','2013-12-24','13:58:58',0,'2013-12-25 18:45:28',NULL,NULL),(2489,437,'149012','834','00','005010X220A1','149012','','2013-12-06','15:11:24',0,'2013-12-25 20:20:10',NULL,NULL),(3671,627,'1009138','834','00','005010X220A1','1009138','','2013-12-12','15:47:17',0,'2013-12-25 22:06:35',NULL,NULL),(4863,885,'444364','834','00','005010X220A1','444364','','2013-11-21','14:42:58',0,'2013-12-26 00:16:01',NULL,NULL),(4853,885,'1120495','834','00','005010X220A1','1120495','','2013-11-20','20:52:06',0,'2013-12-26 00:15:41',NULL,NULL),(15531,2654,'1741911','834','00','005010X220A1','1741911','','2014-01-16','23:32:54',0,'2014-01-20 08:05:35',NULL,NULL),(18506,3445,'2722310','834','00','005010X220A1','2722310','','2014-02-10','10:44:22',0,'2014-02-10 21:00:07',NULL,NULL),(18902,3504,'2673250','834','00','005010X220A1','2673250','','2014-02-11','10:22:51',0,'2014-02-11 21:02:38',NULL,NULL),(21347,4022,'3606693','834','00','005010X220A1','3606693','','2014-02-27','14:37:09',0,'2014-02-28 06:30:11',NULL,NULL),(21429,4027,'2875638','834','00','005010X220A1','2875638','','2014-02-26','21:46:19',0,'2014-02-28 06:30:48',NULL,NULL),(22281,4200,'3711383','834','00','005010X220A1','3711383','','2014-03-04','15:55:18',0,'2014-03-04 21:00:45',NULL,NULL),(22667,4254,'3603413','834','00','005010X220A1','3603413','','2014-03-05','15:26:40',0,'2014-03-05 21:32:04',NULL,NULL),(23058,4339,'3341515','834','00','005010X220A1','3341515','','2014-03-06','19:50:56',0,'2014-03-07 21:30:05',NULL,NULL),(14299,2384,'2494962','834','00','005010X220A1','2494962','','2014-01-10','14:05:13',0,'2014-01-13 03:00:28',NULL,NULL),(14584,2521,'2286103','834','00','005010X220A1','2286103','','2014-01-12','20:31:26',0,'2014-01-14 01:32:56',NULL,NULL),(744,132,'786846','834','00','005010X220A1','786846','','2013-12-16','12:46:26',0,'2013-12-25 18:08:09',NULL,NULL),(1280,243,'1493419','834','00','005010X220A1','1493419','','2013-12-24','16:55:48',0,'2013-12-25 18:50:10',NULL,NULL),(1606,281,'800562','834','00','005010X220A1','800562','','2013-11-20','15:11:09',0,'2013-12-25 19:01:22',NULL,NULL),(1663,289,'643717','834','00','005010X220A1','643717','','2013-12-10','16:57:57',0,'2013-12-25 19:15:21',NULL,NULL),(2134,360,'700634','834','00','005010X220A1','700634','','2013-12-02','08:53:06',0,'2013-12-25 19:45:56',NULL,NULL),(11169,1442,'1487228','834','00','005010X220A1','1487228','','2013-12-23','10:21:15',0,'2013-12-26 13:16:36',NULL,NULL),(3841,682,'936140','834','00','005010X220A1','936140','','2013-11-08','11:29:17',0,'2013-12-25 22:30:17',NULL,NULL),(3912,712,'28613','834','00','005010X220A1','28613','','2013-12-07','10:29:26',0,'2013-12-25 22:45:25',NULL,NULL),(6282,1172,'1045943','834','00','005010X220A1','1045943','','2013-12-20','15:19:51',0,'2013-12-26 03:06:54',NULL,NULL),(15268,2603,'1437887','834','00','005010X220A1','1437887','','2014-01-15','16:47:40',0,'2014-01-16 08:47:09',NULL,NULL),(16134,2826,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 03:51:41',NULL,NULL),(17003,3118,'1776432','834','00','005010X220A1','1776432','','2014-01-29','13:38:33',0,'2014-01-29 21:00:56',NULL,NULL),(17160,3144,'1469027','834','00','005010X220A1','1469027','','2014-01-30','17:21:15',0,'2014-01-30 21:00:42',NULL,NULL),(18026,3318,'2611861','834','00','005010X220A1','2611861','','2014-02-06','14:01:53',0,'2014-02-06 21:00:25',NULL,NULL),(19304,3583,'3109978','834','00','005010X220A1','3109978','','2014-02-12','19:59:44',0,'2014-02-13 22:01:16',NULL,NULL),(19585,3629,'3231930','834','00','005010X220A1','3231930','','2014-02-14','12:18:01',0,'2014-02-14 21:31:26',NULL,NULL),(20321,3795,'3234539','834','00','005010X220A1','3234539','','2014-02-19','16:54:54',0,'2014-02-20 04:48:27',NULL,NULL),(23151,4343,'2889000','834','00','005010X220A1','2889000','','2014-03-07','09:37:46',0,'2014-03-07 21:31:11',NULL,NULL),(7064,1236,'773547','834','00','005010X220A1','773547','','2013-12-17','20:17:14',0,'2013-12-26 04:02:27',NULL,NULL),(12917,1714,'1781959','834','00','005010X220A1','1781959','','2014-01-03','16:41:15',0,'2014-01-04 02:05:31',NULL,NULL),(12496,1641,'1412247','834','00','005010X220A1','1412247','','2013-12-31','17:09:24',1,'2014-01-02 04:33:13',NULL,NULL),(10909,1409,'398887','834','00','005010X220A1','398887','','2013-12-23','18:11:19',0,'2013-12-26 13:07:56',NULL,NULL),(15292,2616,'2485304','834','00','005010X220A1','2485304','','2014-01-15','15:45:46',0,'2014-01-16 08:47:26',NULL,NULL),(22069,4170,'3568090','834','00','005010X220A1','3568090','','2014-03-03','11:31:04',0,'2014-03-03 21:00:22',NULL,NULL),(2524,455,'358965','834','00','005010X220A1','358965','','2013-11-17','19:21:14',0,'2013-12-25 20:30:45',NULL,NULL),(12364,1634,'1951546','834','00','005010X220A1','1951546','','2013-12-31','15:48:35',1,'2014-01-02 04:28:22',NULL,NULL),(6001,1134,'1237856','834','00','005010X220A1','1237856','','2013-12-15','16:59:06',0,'2013-12-26 02:34:03',NULL,NULL),(4174,734,'960941','834','00','005010X220A1','960941','','2013-12-19','11:18:58',0,'2013-12-25 23:05:23',NULL,NULL),(4646,827,'1778027','834','00','005010X220A1','1778027','','2013-12-24','00:36:35',0,'2013-12-25 23:48:45',NULL,NULL),(19818,3679,'3494446','834','00','005010X220A1','3494446','','2014-02-15','12:57:48',0,'2014-02-15 22:01:37',NULL,NULL),(19857,3702,'3057770','834','00','005010X220A1','3057770','','2014-02-15','21:34:58',0,'2014-02-16 19:00:04',NULL,NULL),(1,1,'1130746','834','00','005010X220A1','1130746','','2013-12-04','18:13:53',0,'2013-12-25 17:15:02',NULL,NULL),(5796,1077,'821203','834','00','005010X220A1','821203','','2013-12-14','02:09:32',0,'2013-12-26 02:03:23',NULL,NULL),(13278,2122,'0001','999','BE','005010X231A1','512367','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:10',NULL,NULL),(5609,1044,'1644995','834','00','005010X220A1','1644995','','2013-12-24','21:26:53',0,'2013-12-26 01:49:55',NULL,NULL),(7656,1314,'145407','834','00','005010X220A1','145407','','2013-12-21','07:17:54',0,'2013-12-26 04:39:03',NULL,NULL),(7489,1299,'395049','834','00','005010X220A1','395049','','2013-12-20','19:05:44',0,'2013-12-26 04:33:39',NULL,NULL),(3578,617,'904909','834','00','005010X220A1','904909','','2013-12-12','11:18:33',0,'2013-12-25 22:03:40',NULL,NULL),(5066,936,'656796','834','00','005010X220A1','656796','','2013-12-11','11:39:35',0,'2013-12-26 00:48:07',NULL,NULL),(16637,3060,'1848650','834','00','005010X220A1','1848650','','2014-01-26','18:07:40',0,'2014-01-27 21:00:02',NULL,NULL),(17683,3259,'2434366','834','00','005010X220A1','2434366','','2014-02-04','15:25:05',0,'2014-02-04 21:00:20',NULL,NULL),(18630,3460,'2652738','834','00','005010X220A1','2652738','','2014-02-10','14:01:55',0,'2014-02-10 21:31:25',NULL,NULL),(21462,4028,'3071159','834','00','005010X220A1','3071159','','2014-02-27','10:54:32',0,'2014-02-28 06:31:04',NULL,NULL),(21964,4143,'3099438','834','00','005010X220A1','3099438','','2014-03-01','18:35:36',0,'2014-03-03 01:00:04',NULL,NULL),(5203,949,'89894','834','00','005010X220A1','89894','','2013-12-11','13:35:24',0,'2013-12-26 00:52:28',NULL,NULL),(14817,2552,'1688702','834','00','005010X220A1','1688702','','2014-01-14','13:10:48',0,'2014-01-15 02:06:52',NULL,NULL),(915,177,'388001','834','00','005010X220A1','388001','','2013-12-03','12:10:41',0,'2013-12-25 18:17:31',NULL,NULL),(14100,2343,'1463431','834','00','005010X220A1','1463431','','2014-01-08','09:14:03',0,'2014-01-13 02:22:10',NULL,NULL),(1100,227,'1013445','834','00','005010X220A1','1013445','','2013-10-25','13:35:54',0,'2013-12-25 18:32:01',NULL,NULL),(3149,557,'463849','834','00','005010X220A1','463849','','2013-12-12','21:26:39',0,'2013-12-25 21:37:44',NULL,NULL),(10801,1404,'526288','834','00','005010X220A1','526288','','2013-12-23','14:24:09',0,'2013-12-26 13:03:54',NULL,NULL),(18088,3323,'1696093','834','00','005010X220A1','1696093','','2014-02-06','16:52:30',0,'2014-02-06 21:01:07',NULL,NULL),(18673,3467,'2410033','834','00','005010X220A1','2410033','','2014-02-10','14:07:50',0,'2014-02-10 21:31:55',NULL,NULL),(19998,3748,'3202599','834','00','005010X220A1','3202599','','2014-02-18','10:02:10',0,'2014-02-18 22:00:31',NULL,NULL),(58,3,'236404','834','00','005010X220A1','236404','','2013-12-05','10:55:55',0,'2013-12-25 17:16:45',NULL,NULL),(14665,2540,'2555799','834','00','005010X220A1','2555799','','2014-01-13','15:42:55',0,'2014-01-14 01:33:49',NULL,NULL),(14187,2365,'1752796','834','00','005010X220A1','1752796','','2014-01-09','23:28:58',0,'2014-01-13 02:23:34',NULL,NULL),(6396,1189,'907575','834','00','005010X220A1','907575','','2013-12-20','13:22:18',0,'2013-12-26 03:10:21',NULL,NULL),(11172,1445,'842027','834','00','005010X220A1','842027','','2013-12-23','11:52:34',0,'2013-12-26 13:16:43',NULL,NULL),(1039,201,'936382','834','00','005010X220A1','936382','','2013-12-03','14:46:04',0,'2013-12-25 18:21:30',NULL,NULL),(3435,600,'709782','834','00','005010X220A1','709782','','2013-12-17','08:49:28',0,'2013-12-25 21:52:50',NULL,NULL),(1851,324,'221871','834','00','005010X220A1','221871','','2013-12-09','08:04:19',0,'2013-12-25 19:30:12',NULL,NULL),(19285,3582,'2452242','834','00','005010X220A1','2452242','','2014-02-13','13:58:52',0,'2014-02-13 22:01:02',NULL,NULL),(6283,1172,'492298','834','00','005010X220A1','492298','','2013-12-20','15:25:41',0,'2013-12-26 03:06:55',NULL,NULL),(14827,2552,'1917090','834','00','005010X220A1','1917090','','2014-01-14','17:15:44',0,'2014-01-15 02:06:56',NULL,NULL),(12953,1733,'1686116','834','00','005010X220A1','1686116','','2014-01-04','17:00:20',0,'2014-01-05 00:00:26',NULL,NULL),(2415,416,'818118','834','00','005010X220A1','818118','','2013-12-05','19:22:44',0,'2013-12-25 20:17:45',NULL,NULL),(12488,1640,'2433530','834','00','005010X220A1','2433530','','2013-12-31','18:32:10',1,'2014-01-02 04:32:51',NULL,NULL),(4580,826,'152530','834','00','005010X220A1','152530','','2013-12-23','22:13:39',0,'2013-12-25 23:46:37',NULL,NULL),(15984,2764,'2513678','834','00','005010X220A1','2513678','','2014-01-22','15:25:42',0,'2014-01-23 03:02:05',NULL,NULL),(17714,3261,'2802883','834','00','005010X220A1','2802883','','2014-02-04','10:08:53',0,'2014-02-04 21:00:37',NULL,NULL),(18680,3469,'2176118','834','00','005010X220A1','2176118','','2014-02-10','09:28:43',0,'2014-02-10 21:31:59',NULL,NULL),(22297,4201,'3265461','834','00','005010X220A1','3265461','','2014-03-04','10:13:23',0,'2014-03-04 21:00:57',NULL,NULL),(141,10,'356148','834','00','005010X220A1','356148','','2013-12-04','20:45:48',0,'2013-12-25 17:19:21',NULL,NULL),(6081,1166,'645377','834','00','005010X220A1','645377','','2013-12-19','19:29:16',0,'2013-12-26 03:00:44',NULL,NULL),(14780,2551,'2269317','834','00','005010X220A1','2269317','','2014-01-14','14:29:33',0,'2014-01-15 02:06:37',NULL,NULL),(5052,936,'430422','834','00','005010X220A1','430422','','2013-12-11','06:30:02',0,'2013-12-26 00:47:40',NULL,NULL),(4944,920,'611507','834','00','005010X220A1','611507','','2013-11-19','12:52:39',0,'2013-12-26 00:31:35',NULL,NULL),(10573,1402,'1264461','834','00','005010X220A1','1264461','','2013-12-23','11:04:10',0,'2013-12-26 12:56:18',NULL,NULL),(16496,3011,'2200463','834','00','005010X220A1','2200463','','2014-01-23','21:36:35',0,'2014-01-24 21:00:38',NULL,NULL),(20393,3830,'3682660','834','00','005010X220A1','3682660','','2014-02-19','18:54:39',0,'2014-02-20 21:30:02',NULL,NULL),(22862,4280,'2888962','834','00','005010X220A1','2888962','','2014-03-06','12:56:36',0,'2014-03-06 21:01:48',NULL,NULL),(6269,1172,'1305301','834','00','005010X220A1','1305301','','2013-12-20','09:21:00',0,'2013-12-26 03:06:30',NULL,NULL),(14130,2351,'2381220','834','00','005010X220A1','2381220','','2014-01-08','15:31:12',0,'2014-01-13 02:22:29',NULL,NULL),(1372,245,'1405452','834','00','005010X220A1','1405452','','2013-12-24','15:37:19',0,'2013-12-25 18:53:05',NULL,NULL),(7317,1267,'1159947','834','00','005010X220A1','1159947','','2013-12-18','12:15:50',0,'2013-12-26 04:10:14',NULL,NULL),(7130,1236,'1023954','834','00','005010X220A1','1023954','','2013-12-18','16:57:23',0,'2013-12-26 04:04:30',NULL,NULL),(5997,1131,'841599','834','00','005010X220A1','841599','','2013-12-15','14:40:04',0,'2013-12-26 02:33:56',NULL,NULL),(5578,1043,'1198561','834','00','005010X220A1','1198561','','2013-12-24','22:19:53',0,'2013-12-26 01:48:57',NULL,NULL),(4785,863,'514927','834','00','005010X220A1','514927','','2013-12-01','13:20:24',0,'2013-12-26 00:01:25',NULL,NULL),(16597,3045,'1636149','834','00','005010X220A1','1636149','','2014-01-25','12:00:11',0,'2014-01-25 19:00:20',NULL,NULL),(16715,3064,'2402051','834','00','005010X220A1','2402051','','2014-01-27','12:53:46',0,'2014-01-27 21:00:53',NULL,NULL),(19170,3558,'2726990','834','00','005010X220A1','2726990','','2014-02-12','08:09:02',0,'2014-02-12 21:32:25',NULL,NULL),(22428,4226,'3010417','834','00','005010X220A1','3010417','','2014-03-04','15:44:21',0,'2014-03-04 21:02:44',NULL,NULL),(23737,4468,'3056106','834','00','005010X220A1','3056106','','2014-03-10','14:28:59',0,'2014-03-10 21:02:57',NULL,NULL),(210,25,'1072842','834','00','005010X220A1','1072842','','2013-12-05','14:16:37',0,'2013-12-25 17:21:36',NULL,NULL),(13761,2278,'2492228','834','00','005010X220A1','2492228','','2014-01-06','21:24:29',0,'2014-01-08 18:24:57',NULL,NULL),(13303,2147,'0001','999','BE','005010X231A1','343366','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:20',NULL,NULL),(12925,1717,'1567735','834','00','005010X220A1','1567735','','2014-01-03','10:38:46',0,'2014-01-04 02:05:51',NULL,NULL),(12377,1637,'1997854','834','00','005010X220A1','1997854','','2013-12-30','18:48:36',1,'2014-01-02 04:28:50',NULL,NULL),(6373,1183,'1051212','834','00','005010X220A1','1051212','','2013-12-20','13:54:59',0,'2013-12-26 03:09:39',NULL,NULL),(1751,293,'278981','834','00','005010X220A1','278981','','2013-12-10','16:47:39',0,'2013-12-25 19:18:00',NULL,NULL),(4371,771,'1078493','834','00','005010X220A1','1078493','','2013-12-19','18:31:53',0,'2013-12-25 23:11:26',NULL,NULL),(2940,541,'802181','834','00','005010X220A1','802181','','2013-12-12','22:25:09',0,'2013-12-25 21:31:14',NULL,NULL),(20156,3778,'2950209','834','00','005010X220A1','2950209','','2014-02-18','18:09:03',0,'2014-02-20 04:05:26',NULL,NULL),(20340,3804,'3443733','834','00','005010X220A1','3443733','','2014-02-19','15:48:43',0,'2014-02-20 04:52:50',NULL,NULL),(20367,3821,'2915408','834','00','005010X220A1','2915408','','2014-02-19','16:20:11',0,'2014-02-20 05:31:55',NULL,NULL),(22948,4303,'2696828','834','00','005010X220A1','2696828','','2014-03-06','12:39:07',0,'2014-03-06 21:02:52',NULL,NULL),(4908,906,'735487','834','00','005010X220A1','735487','','2013-10-23','15:07:18',0,'2013-12-26 00:30:23',NULL,NULL),(14828,2552,'2274870','834','00','005010X220A1','2274870','','2014-01-14','17:46:34',0,'2014-01-15 02:06:56',NULL,NULL),(14019,2337,'1601487','834','00','005010X220A1','1601487','','2014-01-08','11:19:34',0,'2014-01-13 02:21:18',NULL,NULL),(4789,865,'216383','834','00','005010X220A1','216383','','2013-12-01','13:33:16',0,'2013-12-26 00:01:32',NULL,NULL),(11713,1518,'1559840','834','00','005010X220A1','1559840','','2013-12-28','10:27:04',1,'2013-12-29 11:08:17',NULL,NULL),(16506,3011,'1825052','834','00','005010X220A1','1825052','','2014-01-24','14:25:40',0,'2014-01-24 21:00:45',NULL,NULL),(4257,741,'23506','834','00','005010X220A1','23506','','2013-12-19','11:40:36',0,'2013-12-25 23:08:02',NULL,NULL),(13548,2242,'2083564','834','00','005010X220A1','2083564','','2014-01-06','14:09:57',0,'2014-01-07 04:06:21',NULL,NULL),(13861,2311,'2355294','834','00','005010X220A1','2355294','','2014-01-08','23:32:55',0,'2014-01-13 02:19:20',NULL,NULL),(17988,3311,'2407071','834','00','005010X220A1','2407071','','2014-02-05','11:55:58',0,'2014-02-05 21:31:15',NULL,NULL),(18602,3456,'2613257','834','00','005010X220A1','2613257','','2014-02-10','10:15:15',0,'2014-02-10 21:31:05',NULL,NULL),(18965,3535,'2764883','834','00','005010X220A1','2764883','','2014-02-12','17:22:46',0,'2014-02-12 21:00:15',NULL,NULL),(23332,4384,'3089509','834','00','005010X220A1','3089509','','2014-03-08','12:37:30',0,'2014-03-08 21:30:44',NULL,NULL),(92,4,'773165','834','00','005010X220A1','773165','','2013-12-05','16:17:46',0,'2013-12-25 17:17:47',NULL,NULL),(14826,2552,'1924669','834','00','005010X220A1','1924669','','2014-01-14','17:15:10',0,'2014-01-15 02:06:55',NULL,NULL),(12986,1737,'2129233','834','00','005010X220A1','2129233','','2014-01-03','19:19:37',0,'2014-01-05 00:01:38',NULL,NULL),(2094,353,'622931','834','00','005010X220A1','622931','','2013-12-09','16:25:07',0,'2013-12-25 19:37:51',NULL,NULL),(3436,600,'111015','834','00','005010X220A1','111015','','2013-12-17','09:31:51',0,'2013-12-25 21:52:51',NULL,NULL),(4871,887,'3727','834','00','005010X220A1','3727','','2013-11-21','11:54:22',0,'2013-12-26 00:16:17',NULL,NULL),(17304,3173,'1462682','834','00','005010X220A1','1462682','','2014-01-31','09:43:23',0,'2014-01-31 21:00:43',NULL,NULL),(21967,4143,'3789620','834','00','005010X220A1','3789620','','2014-03-01','20:13:52',0,'2014-03-03 01:00:05',NULL,NULL),(22837,4278,'3593400','834','00','005010X220A1','3593400','','2014-03-06','17:36:01',0,'2014-03-06 21:01:29',NULL,NULL),(1133,238,'1416156','834','00','005010X220A1','1416156','','2013-12-24','15:48:04',0,'2013-12-25 18:45:40',NULL,NULL),(7737,1342,'1146632','834','00','005010X220A1','1146632','','2013-10-21','11:50:51',0,'2013-12-26 05:00:25',NULL,NULL),(14530,2518,'2429321','834','00','005010X220A1','2429321','','2014-01-13','10:58:15',0,'2014-01-14 01:32:22',NULL,NULL),(13677,2272,'1719893','834','00','005010X220A1','1719893','','2014-01-07','16:58:55',0,'2014-01-08 18:24:20',NULL,NULL),(12562,1661,'2379609','834','00','005010X220A1','2379609','','2013-12-31','13:31:44',1,'2014-01-02 04:35:47',NULL,NULL),(12078,1586,'1602586','834','00','005010X220A1','1602586','','2013-12-30','13:26:22',0,'2014-01-01 12:04:57',NULL,NULL),(2916,541,'786783','834','00','005010X220A1','786783','','2013-12-13','17:40:00',0,'2013-12-25 21:30:26',NULL,NULL),(1470,252,'1008520','834','00','005010X220A1','1008520','','2013-12-24','16:19:24',0,'2013-12-25 18:56:26',NULL,NULL),(2630,494,'1133249','834','00','005010X220A1','1133249','','2013-11-28','15:48:42',0,'2013-12-25 20:46:57',NULL,NULL),(12164,1594,'1956706','834','00','005010X220A1','1956706','','2013-12-29','23:29:51',0,'2014-01-01 12:07:53',NULL,NULL),(3682,629,'754984','834','00','005010X220A1','754984','','2013-12-12','15:56:29',0,'2013-12-25 22:06:52',NULL,NULL),(4920,910,'742688','834','00','005010X220A1','742688','','2013-10-16','20:09:34',0,'2013-12-26 00:30:49',NULL,NULL),(14183,2365,'2372436','834','00','005010X220A1','2372436','','2014-01-09','21:42:08',0,'2014-01-13 02:23:31',NULL,NULL),(17813,3273,'2561337','834','00','005010X220A1','2561337','','2014-02-04','14:01:42',0,'2014-02-04 21:01:42',NULL,NULL),(17908,3296,'2865285','834','00','005010X220A1','2865285','','2014-02-04','19:42:12',0,'2014-02-05 21:30:35',NULL,NULL),(18081,3323,'1923761','834','00','005010X220A1','1923761','','2014-02-06','17:09:16',0,'2014-02-06 21:01:03',NULL,NULL),(19000,3538,'3274854','834','00','005010X220A1','3274854','','2014-02-12','10:38:09',0,'2014-02-12 21:30:25',NULL,NULL),(19018,3539,'2193364','834','00','005010X220A1','2193364','','2014-02-12','17:36:09',0,'2014-02-12 21:30:39',NULL,NULL),(19209,3577,'2930922','834','00','005010X220A1','2930922','','2014-02-13','13:19:18',0,'2014-02-13 21:30:16',NULL,NULL),(19761,3674,'3351208','834','00','005010X220A1','3351208','','2014-02-14','20:20:31',0,'2014-02-15 22:00:51',NULL,NULL),(20052,3752,'3256503','834','00','005010X220A1','3256503','','2014-02-18','08:28:48',0,'2014-02-18 22:01:09',NULL,NULL),(20187,3779,'3446102','834','00','005010X220A1','3446102','','2014-02-19','11:48:10',0,'2014-02-20 04:14:40',NULL,NULL),(20586,3870,'2601368','834','00','005010X220A1','2601368','','2014-02-20','21:54:20',0,'2014-02-21 22:00:04',NULL,NULL),(21407,4026,'3145272','834','00','005010X220A1','3145272','','2014-02-26','18:37:22',0,'2014-02-28 06:30:38',NULL,NULL),(23155,4344,'3798087','834','00','005010X220A1','3798087','','2014-03-06','21:06:38',0,'2014-03-07 21:31:14',NULL,NULL),(23585,4437,'3028721','834','00','005010X220A1','3028721','','2014-03-09','20:34:26',0,'2014-03-10 21:01:07',NULL,NULL),(711,117,'610939','834','00','005010X220A1','610939','','2013-12-16','15:02:33',0,'2013-12-25 18:07:06',NULL,NULL),(13889,2312,'1382194','834','00','005010X220A1','1382194','','2014-01-09','11:48:40',0,'2014-01-13 02:19:38',NULL,NULL),(12132,1587,'1523370','834','00','005010X220A1','1523370','','2013-12-30','18:02:34',0,'2014-01-01 12:06:50',NULL,NULL),(11884,1560,'1617894','834','00','005010X220A1','1617894','','2013-12-29','15:31:21',0,'2013-12-30 00:00:31',NULL,NULL),(11626,1496,'2074928','834','00','005010X220A1','2074928','','2013-12-27','09:04:47',0,'2013-12-28 03:35:31',NULL,NULL),(11483,1488,'2214954','834','00','005010X220A1','2214954','','2013-12-27','16:14:15',0,'2013-12-28 03:31:09',NULL,NULL),(808,158,'930853','834','00','005010X220A1','930853','','2013-10-31','15:07:53',0,'2013-12-25 18:10:30',NULL,NULL),(10555,1402,'796266','834','00','005010X220A1','796266','','2013-12-22','21:30:58',0,'2013-12-26 12:55:42',NULL,NULL),(7223,1241,'187309','834','00','005010X220A1','187309','','2013-12-18','14:36:52',0,'2013-12-26 04:07:19',NULL,NULL),(2718,503,'78720','834','00','005010X220A1','78720','','2013-12-21','19:46:59',0,'2013-12-25 21:17:45',NULL,NULL),(6423,1203,'903131','834','00','005010X220A1','903131','','2013-11-21','22:15:05',0,'2013-12-26 03:15:14',NULL,NULL),(2742,503,'1462817','834','00','005010X220A1','1462817','','2013-12-22','16:19:31',0,'2013-12-25 21:18:29',NULL,NULL),(5985,1123,'568587','834','00','005010X220A1','568587','','2013-12-15','17:53:08',0,'2013-12-26 02:33:28',NULL,NULL),(5912,1112,'282553','834','00','005010X220A1','282553','','2013-12-14','21:38:51',0,'2013-12-26 02:31:10',NULL,NULL),(3606,619,'721058','834','00','005010X220A1','721058','','2013-12-12','09:08:30',0,'2013-12-25 22:04:33',NULL,NULL),(5484,1040,'1368778','834','00','005010X220A1','1368778','','2013-12-25','00:23:30',0,'2013-12-26 01:45:53',NULL,NULL),(5182,949,'925850','834','00','005010X220A1','925850','','2013-12-10','22:26:21',0,'2013-12-26 00:51:47',NULL,NULL),(3780,656,'995407','834','00','005010X220A1','995407','','2013-12-08','00:02:41',0,'2013-12-25 22:15:40',NULL,NULL),(5000,935,'1192959','834','00','005010X220A1','1192959','','2013-12-11','09:42:39',0,'2013-12-26 00:45:57',NULL,NULL),(4325,750,'877637','834','00','005010X220A1','877637','','2013-12-19','17:19:41',0,'2013-12-25 23:09:59',NULL,NULL),(4295,746,'1157852','834','00','005010X220A1','1157852','','2013-12-19','15:54:22',0,'2013-12-25 23:09:10',NULL,NULL),(14564,2519,'1928257','834','00','005010X220A1','1928257','','2014-01-13','14:47:40',0,'2014-01-14 01:32:43',NULL,NULL),(14632,2525,'1895298','834','00','005010X220A1','1895298','','2014-01-13','13:41:14',0,'2014-01-14 01:33:26',NULL,NULL),(15360,2623,'2501389','834','00','005010X220A1','2501389','','2014-01-16','17:07:58',0,'2014-01-17 03:35:27',NULL,NULL),(18632,3461,'3085850','834','00','005010X220A1','3085850','','2014-02-09','20:58:32',0,'2014-02-10 21:31:27',NULL,NULL),(19686,3666,'2836100','834','00','005010X220A1','2836100','','2014-02-15','11:00:47',0,'2014-02-15 21:00:09',NULL,NULL),(19937,3734,'3324841','834','00','005010X220A1','3324841','','2014-02-18','15:29:02',0,'2014-02-18 21:30:09',NULL,NULL),(20118,3772,'2971547','834','00','005010X220A1','2971547','','2014-02-18','23:19:35',0,'2014-02-20 03:51:33',NULL,NULL),(21010,3962,'2883641','834','00','005010X220A1','2883641','','2014-02-21','19:56:01',0,'2014-02-26 08:30:46',NULL,NULL),(21454,4028,'3795385','834','00','005010X220A1','3795385','','2014-02-26','23:13:16',0,'2014-02-28 06:31:01',NULL,NULL),(245,42,'1241530','834','00','005010X220A1','1241530','','2013-11-13','13:20:01',0,'2013-12-25 17:30:41',NULL,NULL),(13958,2321,'2371371','834','00','005010X220A1','2371371','','2014-01-09','13:11:42',0,'2014-01-13 02:20:26',NULL,NULL),(528,102,'868959','834','00','005010X220A1','868959','','2013-12-16','14:32:03',0,'2013-12-25 18:01:16',NULL,NULL),(1972,326,'189500','834','00','005010X220A1','189500','','2013-12-09','15:55:38',0,'2013-12-25 19:33:51',NULL,NULL),(12705,1677,'2266873','834','00','005010X220A1','2266873','','2014-01-02','14:17:46',0,'2014-01-03 02:04:58',NULL,NULL),(2531,455,'683301','834','00','005010X220A1','683301','','2013-11-18','14:23:52',0,'2013-12-25 20:30:56',NULL,NULL),(2587,475,'753235','834','00','005010X220A1','753235','','2013-10-31','20:27:25',0,'2013-12-25 20:45:33',NULL,NULL),(2685,502,'1091246','834','00','005010X220A1','1091246','','2013-12-22','08:08:29',0,'2013-12-25 21:16:43',NULL,NULL),(11255,1454,'2091279','834','00','005010X220A1','2091279','','2013-12-26','16:46:42',0,'2013-12-27 02:02:07',NULL,NULL),(10944,1410,'1757485','834','00','005010X220A1','1757485','','2013-12-23','15:23:44',0,'2013-12-26 13:09:01',NULL,NULL),(10441,1400,'1528681','834','00','005010X220A1','1528681','','2013-12-23','11:59:13',0,'2013-12-26 12:52:00',NULL,NULL),(7499,1300,'248147','834','00','005010X220A1','248147','','2013-12-20','21:49:04',0,'2013-12-26 04:34:00',NULL,NULL),(3851,686,'164252','834','00','005010X220A1','164252','','2013-11-08','09:53:09',0,'2013-12-25 22:30:38',NULL,NULL),(4237,738,'1282067','834','00','005010X220A1','1282067','','2013-12-19','16:47:41',0,'2013-12-25 23:07:24',NULL,NULL),(5739,1070,'672125','834','00','005010X220A1','672125','','2013-12-13','21:57:15',0,'2013-12-26 02:01:36',NULL,NULL),(4437,798,'169071','834','00','005010X220A1','169071','','2013-11-06','09:59:15',0,'2013-12-25 23:17:17',NULL,NULL),(15405,2626,'2532503','834','00','005010X220A1','2532503','','2014-01-15','19:41:08',0,'2014-01-17 03:35:49',NULL,NULL),(15548,2655,'1587082','834','00','005010X220A1','1587082','','2014-01-17','13:45:54',0,'2014-01-20 08:05:46',NULL,NULL),(17541,3235,'2354871','834','00','005010X220A1','2354871','','2014-02-03','16:38:30',0,'2014-02-03 21:00:21',NULL,NULL),(21055,3979,'3493400','834','00','005010X220A1','3493400','','2014-02-24','12:16:46',0,'2014-02-26 09:30:31',NULL,NULL),(17578,3237,'1739718','834','00','005010X220A1','1739718','','2014-02-02','23:49:14',0,'2014-02-03 21:00:44',NULL,NULL),(20000,3748,'2155151','834','00','005010X220A1','2155151','','2014-02-18','11:02:45',0,'2014-02-18 22:00:32',NULL,NULL),(583,104,'1153820','834','00','005010X220A1','1153820','','2013-12-15','21:04:47',0,'2013-12-25 18:03:02',NULL,NULL),(11253,1454,'1238560','834','00','005010X220A1','1238560','','2013-12-26','16:01:43',0,'2013-12-27 02:02:04',NULL,NULL),(10996,1413,'509552','834','00','005010X220A1','509552','','2013-12-23','14:16:34',0,'2013-12-26 13:10:36',NULL,NULL),(10473,1400,'118816','834','00','005010X220A1','118816','','2013-12-23','14:40:11',0,'2013-12-26 12:53:01',NULL,NULL),(1048,204,'638524','834','00','005010X220A1','638524','','2013-11-29','15:58:20',0,'2013-12-25 18:30:13',NULL,NULL),(4824,876,'824917','834','00','005010X220A1','824917','','2013-12-01','12:26:49',0,'2013-12-26 00:02:36',NULL,NULL),(7034,1235,'175175','834','00','005010X220A1','175175','','2013-12-18','14:12:55',0,'2013-12-26 04:01:34',NULL,NULL),(15345,2622,'1963141','834','00','005010X220A1','1963141','','2014-01-15','20:27:57',0,'2014-01-17 03:35:21',NULL,NULL),(16337,2983,'2065965','834','00','005010X220A1','2065965','','2014-01-23','13:40:12',0,'2014-01-23 21:00:40',NULL,NULL),(18460,3425,'2541768','834','00','005010X220A1','2541768','','2014-02-10','04:20:44',0,'2014-02-10 11:00:42',NULL,NULL),(19477,3620,'2999362','834','00','005010X220A1','2999362','','2014-02-13','21:55:33',0,'2014-02-14 21:30:09',NULL,NULL),(19613,3635,'2913834','834','00','005010X220A1','2913834','','2014-02-14','14:40:25',0,'2014-02-14 21:31:46',NULL,NULL),(21300,4008,'3130329','834','00','005010X220A1','3130329','','2014-02-26','11:47:46',0,'2014-02-26 21:02:25',NULL,NULL),(23416,4404,'3604629','834','00','005010X220A1','3604629','','2014-03-09','14:32:45',0,'2014-03-09 21:00:23',NULL,NULL),(561,103,'1022751','834','00','005010X220A1','1022751','','2013-12-16','11:19:19',0,'2013-12-25 18:02:24',NULL,NULL),(13765,2280,'1687224','834','00','005010X220A1','1687224','','2014-01-07','11:10:09',0,'2014-01-08 18:24:58',NULL,NULL),(13180,2024,'0001','999','BE','005010X231A1','644770','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:56',NULL,NULL),(5783,1075,'320710','834','00','005010X220A1','320710','','2013-12-14','07:53:20',0,'2013-12-26 02:03:02',NULL,NULL),(11733,1520,'1362886','834','00','005010X220A1','1362886','','2013-12-27','22:34:09',1,'2013-12-29 11:08:54',NULL,NULL),(11584,1492,'1452189','834','00','005010X220A1','1452189','','2013-12-27','16:26:24',0,'2013-12-28 03:34:14',NULL,NULL),(11193,1453,'865695','834','00','005010X220A1','865695','','2013-12-26','11:33:37',0,'2013-12-27 02:00:14',NULL,NULL),(1971,326,'825092','834','00','005010X220A1','825092','','2013-12-09','15:55:38',0,'2013-12-25 19:33:50',NULL,NULL),(5922,1112,'953143','834','00','005010X220A1','953143','','2013-12-15','14:07:34',0,'2013-12-26 02:31:28',NULL,NULL),(2396,414,'1210231','834','00','005010X220A1','1210231','','2013-12-05','18:32:23',0,'2013-12-25 20:17:04',NULL,NULL),(22539,4248,'3143962','834','00','005010X220A1','3143962','','2014-03-04','19:36:24',0,'2014-03-05 21:30:35',NULL,NULL),(22947,4302,'2654643','834','00','005010X220A1','2654643','','2014-03-06','12:27:45',0,'2014-03-06 21:02:51',NULL,NULL),(5530,1041,'152652','834','00','005010X220A1','152652','','2013-12-24','22:49:25',0,'2013-12-26 01:47:23',NULL,NULL),(6416,1201,'457888','834','00','005010X220A1','457888','','2013-12-20','17:45:33',0,'2013-12-26 03:11:05',NULL,NULL),(10730,1403,'935738','834','00','005010X220A1','935738','','2013-12-23','14:53:40',0,'2013-12-26 13:01:37',NULL,NULL),(12094,1587,'312355','834','00','005010X220A1','312355','','2013-12-29','21:09:07',0,'2014-01-01 12:05:30',NULL,NULL),(11982,1580,'2120011','834','00','005010X220A1','2120011','','2013-12-30','16:26:29',0,'2014-01-01 12:01:26',NULL,NULL),(11131,1430,'1558231','834','00','005010X220A1','1558231','','2013-12-22','22:54:24',0,'2013-12-26 13:15:13',NULL,NULL),(17303,3173,'2675774','834','00','005010X220A1','2675774','','2014-01-30','19:38:55',0,'2014-01-31 21:00:42',NULL,NULL),(17493,3220,'2291723','834','00','005010X220A1','2291723','','2014-02-02','17:12:01',0,'2014-02-02 19:00:19',NULL,NULL),(18425,3420,'1772562','834','00','005010X220A1','1772562','','2014-02-10','04:10:40',0,'2014-02-10 11:00:13',NULL,NULL),(21354,4023,'3613765','834','00','005010X220A1','3613765','','2014-02-26','23:02:06',0,'2014-02-28 06:30:14',NULL,NULL),(3977,718,'927051','834','00','005010X220A1','927051','','2013-12-07','14:04:26',0,'2013-12-25 22:47:27',NULL,NULL),(14303,2387,'2264508','834','00','005010X220A1','2264508','','2014-01-10','13:04:20',0,'2014-01-13 03:00:31',NULL,NULL),(6459,1216,'659347','834','00','005010X220A1','659347','','2013-11-22','09:48:06',0,'2013-12-26 03:16:26',NULL,NULL),(7643,1309,'1019093','834','00','005010X220A1','1019093','','2013-12-21','18:13:22',0,'2013-12-26 04:38:36',NULL,NULL),(12038,1583,'2061748','834','00','005010X220A1','2061748','','2013-12-30','15:11:55',0,'2014-01-01 12:03:31',NULL,NULL),(14999,2584,'2076721','834','00','005010X220A1','2076721','','2014-01-14','20:57:09',0,'2014-01-16 08:44:17',NULL,NULL),(15682,2693,'2499102','834','00','005010X220A1','2499102','','2014-01-18','16:49:53',0,'2014-01-21 08:44:47',NULL,NULL),(15918,2743,'1957244','834','00','005010X220A1','1957244','','2014-01-21','12:30:00',1,'2014-01-22 03:22:52',NULL,NULL),(22839,4279,'3234964','834','00','005010X220A1','3234964','','2014-03-05','18:16:32',0,'2014-03-06 21:01:32',NULL,NULL),(4950,923,'1236270','834','00','005010X220A1','1236270','','2013-11-19','15:16:07',0,'2013-12-26 00:31:49',NULL,NULL),(12285,1624,'2360235','834','00','005010X220A1','2360235','','2014-01-01','02:09:24',1,'2014-01-02 04:24:44',NULL,NULL),(4436,797,'332220','834','00','005010X220A1','332220','','2013-11-06','07:47:18',0,'2013-12-25 23:17:15',NULL,NULL),(11086,1423,'536396','834','00','005010X220A1','536396','','2013-12-23','07:05:43',0,'2013-12-26 13:13:39',NULL,NULL),(1621,281,'1155868','834','00','005010X220A1','1155868','','2013-11-19','23:04:30',0,'2013-12-25 19:01:44',NULL,NULL),(3125,549,'181151','834','00','005010X220A1','181151','','2013-12-13','09:03:18',0,'2013-12-25 21:36:58',NULL,NULL),(1773,298,'969225','834','00','005010X220A1','969225','','2013-12-10','15:46:39',0,'2013-12-25 19:18:42',NULL,NULL),(17282,3171,'2233606','834','00','005010X220A1','2233606','','2014-01-31','18:26:30',0,'2014-01-31 21:00:29',NULL,NULL),(17456,3210,'1875975','834','00','005010X220A1','1875975','','2014-02-01','11:59:32',0,'2014-02-01 19:00:45',NULL,NULL),(1001,188,'501195','834','00','005010X220A1','501195','','2013-12-03','00:40:10',0,'2013-12-25 18:20:18',NULL,NULL),(1737,293,'36603','834','00','005010X220A1','36603','','2013-12-10','13:00:36',0,'2013-12-25 19:17:37',NULL,NULL),(12610,1671,'2279448','834','00','005010X220A1','2279448','','2014-01-02','11:35:39',0,'2014-01-03 02:01:26',NULL,NULL),(6190,1167,'680362','834','00','005010X220A1','680362','','2013-12-20','17:50:53',0,'2013-12-26 03:04:00',NULL,NULL),(3528,616,'949306','834','00','005010X220A1','949306','','2013-12-11','18:55:02',0,'2013-12-25 22:02:05',NULL,NULL),(5183,949,'442491','834','00','005010X220A1','442491','','2013-12-10','22:40:17',0,'2013-12-26 00:51:49',NULL,NULL),(15338,2622,'1633384','834','00','005010X220A1','1633384','','2014-01-15','19:31:25',0,'2014-01-17 03:35:18',NULL,NULL),(17546,3235,'2510348','834','00','005010X220A1','2510348','','2014-02-03','17:09:20',0,'2014-02-03 21:00:24',NULL,NULL),(20695,3891,'2711501','834','00','005010X220A1','2711501','','2014-02-22','16:13:21',0,'2014-02-22 19:00:15',NULL,NULL),(23372,4395,'3754208','834','00','005010X220A1','3754208','','2014-03-08','13:26:19',0,'2014-03-08 21:31:15',NULL,NULL),(23734,4466,'2794384','834','00','005010X220A1','2794384','','2014-03-10','14:05:15',0,'2014-03-10 21:02:55',NULL,NULL),(3325,586,'645179','834','00','005010X220A1','645179','','2013-12-16','20:52:53',0,'2013-12-25 21:49:21',NULL,NULL),(13174,2018,'0001','999','BE','005010X231A1','714044','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:40',NULL,NULL),(13059,1903,'0001','999','BE','005010X231A1','578605','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:45',NULL,NULL),(7426,1295,'1075834','834','00','005010X220A1','1075834','','2013-12-21','12:33:02',0,'2013-12-26 04:31:41',NULL,NULL),(19031,3540,'2138694','834','00','005010X220A1','2138694','','2014-02-11','20:48:59',0,'2014-02-12 21:30:47',NULL,NULL),(22101,4176,'2745634','834','00','005010X220A1','2745634','','2014-03-03','15:04:30',0,'2014-03-03 21:30:19',NULL,NULL),(6350,1179,'1301919','834','00','005010X220A1','1301919','','2013-12-19','21:00:52',0,'2013-12-26 03:08:54',NULL,NULL),(5370,1009,'981299','834','00','005010X220A1','981299','','2013-11-25','12:01:36',0,'2013-12-26 01:16:31',NULL,NULL),(7391,1293,'653287','834','00','005010X220A1','653287','','2013-12-21','14:18:05',0,'2013-12-26 04:30:33',NULL,NULL),(11491,1489,'72342','834','00','005010X220A1','72342','','2013-12-26','18:40:22',0,'2013-12-28 03:31:22',NULL,NULL),(16016,2767,'1569605','834','00','005010X220A1','1569605','','2014-01-22','17:27:10',0,'2014-01-23 03:02:20',NULL,NULL),(17251,3170,'2325546','834','00','005010X220A1','2325546','','2014-01-30','19:43:52',0,'2014-01-31 21:00:07',NULL,NULL),(20645,3875,'3434944','834','00','005010X220A1','3434944','','2014-02-21','10:09:19',0,'2014-02-21 22:00:49',NULL,NULL),(22735,4276,'2669943','834','00','005010X220A1','2669943','','2014-03-05','21:56:52',0,'2014-03-06 21:00:18',NULL,NULL),(1427,250,'1866882','834','00','005010X220A1','1866882','','2013-12-24','15:40:47',0,'2013-12-25 18:54:55',NULL,NULL),(15077,2585,'2326199','834','00','005010X220A1','2326199','','2014-01-15','09:15:17',0,'2014-01-16 08:45:06',NULL,NULL),(11465,1488,'2169717','834','00','005010X220A1','2169717','','2013-12-27','11:25:17',0,'2013-12-28 03:30:37',NULL,NULL),(14415,2436,'0001','999','BE','005010X231A1','846883','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:27',NULL,NULL),(14344,2401,'2533621','834','00','005010X220A1','2533621','','2014-01-12','09:18:56',0,'2014-01-13 03:01:21',NULL,NULL),(13006,1741,'2259245','834','00','005010X220A1','2259245','','2014-01-04','15:43:28',0,'2014-01-05 00:02:19',NULL,NULL),(18326,3385,'2653945','834','00','005010X220A1','2653945','','2014-02-08','17:16:53',0,'2014-02-08 19:00:50',NULL,NULL),(19619,3638,'2915272','834','00','005010X220A1','2915272','','2014-02-14','14:12:47',0,'2014-02-14 21:31:52',NULL,NULL),(22322,4202,'3714855','834','00','005010X220A1','3714855','','2014-03-03','18:07:40',0,'2014-03-04 21:01:15',NULL,NULL),(6055,1161,'391883','834','00','005010X220A1','391883','','2013-11-10','17:23:37',0,'2013-12-26 02:46:45',NULL,NULL),(15071,2585,'2108345','834','00','005010X220A1','2108345','','2014-01-15','12:49:09',0,'2014-01-16 08:45:02',NULL,NULL),(11869,1560,'1680358','834','00','005010X220A1','1680358','','2013-12-28','18:14:42',0,'2013-12-30 00:00:02',NULL,NULL),(7548,1301,'246749','834','00','005010X220A1','246749','','2013-12-20','19:09:34',0,'2013-12-26 04:35:33',NULL,NULL),(1816,312,'1038869','834','00','005010X220A1','1038869','','2013-12-10','13:06:22',0,'2013-12-25 19:20:08',NULL,NULL),(15803,2724,'1891614','834','00','005010X220A1','1891614','','2014-01-20','12:02:09',0,'2014-01-21 08:46:50',NULL,NULL),(17843,3289,'2375449','834','00','005010X220A1','2375449','','2014-02-05','15:31:19',0,'2014-02-05 21:00:06',NULL,NULL),(21625,4066,'2617193','834','00','005010X220A1','2617193','','2014-02-27','09:08:53',0,'2014-02-28 07:30:22',NULL,NULL),(22998,4322,'3467071','834','00','005010X220A1','3467071','','2014-03-07','12:47:08',0,'2014-03-07 21:00:11',NULL,NULL),(23221,4352,'3728619','834','00','005010X220A1','3728619','','2014-03-06','21:10:04',0,'2014-03-07 21:32:00',NULL,NULL),(32,1,'1163337','834','00','005010X220A1','1163337','','2013-12-05','12:45:22',0,'2013-12-25 17:15:56',NULL,NULL),(11161,1440,'1456678','834','00','005010X220A1','1456678','','2013-12-23','09:47:50',0,'2013-12-26 13:16:20',NULL,NULL),(6046,1154,'484733','834','00','005010X220A1','484733','','2013-10-13','19:03:43',0,'2013-12-26 02:46:26',NULL,NULL),(923,179,'389284','834','00','005010X220A1','389284','','2013-12-02','19:33:08',0,'2013-12-25 18:17:47',NULL,NULL),(2704,502,'85058','834','00','005010X220A1','85058','','2013-12-22','16:53:40',0,'2013-12-25 21:17:19',NULL,NULL),(1026,193,'1241706','834','00','005010X220A1','1241706','','2013-12-03','11:26:19',0,'2013-12-25 18:21:04',NULL,NULL),(2582,473,'643305','834','00','005010X220A1','643305','','2013-11-01','13:54:32',0,'2013-12-25 20:45:23',NULL,NULL),(2579,473,'28241','834','00','005010X220A1','28241','','2013-11-01','15:59:15',0,'2013-12-25 20:45:17',NULL,NULL),(1668,290,'863812','834','00','005010X220A1','863812','','2013-12-09','21:47:16',0,'2013-12-25 19:15:29',NULL,NULL),(16000,2766,'1601855','834','00','005010X220A1','1601855','','2014-01-22','13:41:31',0,'2014-01-23 03:02:13',NULL,NULL),(17146,3144,'2000860','834','00','005010X220A1','2000860','','2014-01-30','13:03:40',0,'2014-01-30 21:00:34',NULL,NULL),(18469,3429,'1454014','834','00','005010X220A1','1454014','','2014-02-10','03:56:36',0,'2014-02-10 11:00:51',NULL,NULL),(21214,3998,'3462980','834','00','005010X220A1','3462980','','2014-02-26','16:40:36',0,'2014-02-26 21:01:26',NULL,NULL),(6241,1169,'1270274','834','00','005010X220A1','1270274','','2013-12-20','15:02:50',0,'2013-12-26 03:05:37',NULL,NULL),(10775,1404,'595300','834','00','005010X220A1','595300','','2013-12-23','07:43:26',0,'2013-12-26 13:03:05',NULL,NULL),(11548,1492,'1810753','834','00','005010X220A1','1810753','','2013-12-26','19:43:20',0,'2013-12-28 03:33:04',NULL,NULL),(17680,3259,'2229920','834','00','005010X220A1','2229920','','2014-02-04','12:21:52',0,'2014-02-04 21:00:17',NULL,NULL),(18352,3400,'2388149','834','00','005010X220A1','2388149','','2014-02-08','18:12:31',0,'2014-02-09 19:00:03',NULL,NULL),(19049,3540,'2818110','834','00','005010X220A1','2818110','','2014-02-12','16:45:21',0,'2014-02-12 21:30:59',NULL,NULL),(21593,4059,'3359648','834','00','005010X220A1','3359648','','2014-02-26','13:55:41',0,'2014-02-28 07:00:35',NULL,NULL),(21859,4115,'3539665','834','00','005010X220A1','3539665','','2014-02-28','18:22:24',0,'2014-03-01 19:00:08',NULL,NULL),(22573,4248,'3177003','834','00','005010X220A1','3177003','','2014-03-05','14:26:08',0,'2014-03-05 21:30:58',NULL,NULL),(23207,4347,'3687217','834','00','005010X220A1','3687217','','2014-03-07','10:56:57',0,'2014-03-07 21:31:50',NULL,NULL),(1097,225,'1117810','834','00','005010X220A1','1117810','','2013-10-25','14:36:17',0,'2013-12-25 18:31:54',NULL,NULL),(12424,1638,'1535584','834','00','005010X220A1','1535584','','2013-12-31','11:06:07',1,'2014-01-02 04:30:33',NULL,NULL),(11206,1454,'746154','834','00','005010X220A1','746154','','2013-12-26','07:43:33',0,'2013-12-27 02:00:38',NULL,NULL),(7296,1258,'930155','834','00','005010X220A1','930155','','2013-12-18','10:18:48',0,'2013-12-26 04:09:35',NULL,NULL),(4264,742,'980800','834','00','005010X220A1','980800','','2013-12-19','14:37:49',0,'2013-12-25 23:08:14',NULL,NULL),(7005,1235,'654389','834','00','005010X220A1','654389','','2013-12-17','21:03:51',0,'2013-12-26 04:00:38',NULL,NULL),(18437,3421,'1824938','834','00','005010X220A1','1824938','','2014-02-10','00:23:28',0,'2014-02-10 11:00:22',NULL,NULL),(19373,3590,'3138787','834','00','005010X220A1','3138787','','2014-02-13','12:04:10',0,'2014-02-13 22:02:10',NULL,NULL),(19974,3746,'3570318','834','00','005010X220A1','3570318','','2014-02-18','13:41:33',0,'2014-02-18 22:00:14',NULL,NULL),(154,10,'529492','834','00','005010X220A1','529492','','2013-12-05','16:44:19',0,'2013-12-25 17:19:46',NULL,NULL),(14911,2558,'2242704','834','00','005010X220A1','2242704','','2014-01-14','16:42:17',0,'2014-01-15 02:07:34',NULL,NULL),(816,161,'1134282','834','00','005010X220A1','1134282','','2013-11-11','15:24:59',0,'2013-12-25 18:10:46',NULL,NULL),(7225,1241,'342334','834','00','005010X220A1','342334','','2013-12-18','15:04:19',0,'2013-12-26 04:07:24',NULL,NULL),(2338,412,'242074','834','00','005010X220A1','242074','','2013-12-06','10:32:40',0,'2013-12-25 20:15:18',NULL,NULL),(11088,1424,'433262','834','00','005010X220A1','433262','','2013-12-22','21:36:47',0,'2013-12-26 13:13:44',NULL,NULL),(12573,1670,'1962735','834','00','005010X220A1','1962735','','2014-01-01','23:08:05',0,'2014-01-03 02:00:03',NULL,NULL),(3142,554,'460179','834','00','005010X220A1','460179','','2013-12-12','19:51:46',0,'2013-12-25 21:37:28',NULL,NULL),(4153,734,'587903','834','00','005010X220A1','587903','','2013-12-18','19:51:54',0,'2013-12-25 23:04:45',NULL,NULL),(14976,2572,'1954421','834','00','005010X220A1','1954421','','2014-01-14','15:17:16',0,'2014-01-15 02:08:04',NULL,NULL),(17448,3205,'1650818','834','00','005010X220A1','1650818','','2014-02-01','14:58:00',0,'2014-02-01 19:00:39',NULL,NULL),(21257,3999,'2929222','834','00','005010X220A1','2929222','','2014-02-26','16:45:20',0,'2014-02-26 21:01:52',NULL,NULL),(1396,246,'1625310','834','00','005010X220A1','1625310','','2013-12-24','05:22:05',0,'2013-12-25 18:53:54',NULL,NULL),(11793,1537,'1814381','834','00','005010X220A1','1814381','','2013-12-28','20:19:20',1,'2013-12-29 11:12:54',NULL,NULL),(7535,1300,'820079','834','00','005010X220A1','820079','','2013-12-21','15:13:58',0,'2013-12-26 04:35:08',NULL,NULL),(14036,2337,'1472236','834','00','005010X220A1','1472236','','2014-01-08','15:07:45',0,'2014-01-13 02:21:28',NULL,NULL),(15739,2712,'1449183','834','00','005010X220A1','1449183','','2014-01-20','18:11:55',0,'2014-01-21 08:46:11',NULL,NULL),(16974,3116,'2548106','834','00','005010X220A1','2548106','','2014-01-29','17:18:23',0,'2014-01-29 21:00:38',NULL,NULL),(21795,4092,'2836420','834','00','005010X220A1','2836420','','2014-02-28','11:41:26',0,'2014-02-28 21:31:18',NULL,NULL),(22324,4202,'3391017','834','00','005010X220A1','3391017','','2014-03-03','23:30:15',0,'2014-03-04 21:01:16',NULL,NULL),(22723,4275,'3567012','834','00','005010X220A1','3567012','','2014-03-05','16:38:26',0,'2014-03-05 21:32:45',NULL,NULL),(4357,763,'702271','834','00','005010X220A1','702271','','2013-12-19','13:26:15',0,'2013-12-25 23:11:00',NULL,NULL),(6287,1172,'1069988','834','00','005010X220A1','1069988','','2013-12-20','17:14:27',0,'2013-12-26 03:07:02',NULL,NULL),(13033,1877,'0001','999','BE','005010X231A1','546147','834','2013-12-27','18:10:00',0,'2014-01-05 16:50:33',NULL,NULL),(17273,3170,'2229857','834','00','005010X220A1','2229857','','2014-01-31','15:41:11',0,'2014-01-31 21:00:22',NULL,NULL),(17606,3240,'2820605','834','00','005010X220A1','2820605','','2014-02-03','15:38:41',0,'2014-02-03 21:01:02',NULL,NULL),(20392,3830,'3139981','834','00','005010X220A1','3139981','','2014-02-19','18:54:39',0,'2014-02-20 21:30:02',NULL,NULL),(20895,3925,'2718911','834','00','005010X220A1','2718911','','2014-02-25','15:16:05',0,'2014-02-25 21:32:05',NULL,NULL),(22086,4175,'3617582','834','00','005010X220A1','3617582','','2014-03-02','18:36:07',0,'2014-03-03 21:30:07',NULL,NULL),(4288,744,'368621','834','00','005010X220A1','368621','','2013-12-18','20:56:10',0,'2013-12-25 23:08:56',NULL,NULL),(12282,1624,'2329874','834','00','005010X220A1','2329874','','2013-12-31','23:15:14',1,'2014-01-02 04:24:36',NULL,NULL),(2957,541,'927235','834','00','005010X220A1','927235','','2013-12-13','10:48:59',0,'2013-12-25 21:31:48',NULL,NULL),(3422,594,'841676','834','00','005010X220A1','841676','','2013-12-17','16:32:12',0,'2013-12-25 21:52:23',NULL,NULL),(14363,2404,'1866124','834','00','005010X220A1','1866124','','2014-01-12','10:26:57',0,'2014-01-13 03:01:35',NULL,NULL),(16879,3093,'2526711','834','00','005010X220A1','2526711','','2014-01-28','17:32:55',0,'2014-01-28 21:00:58',NULL,NULL),(17245,3168,'2686811','834','00','005010X220A1','2686811','','2014-01-30','15:22:45',0,'2014-01-30 21:01:40',NULL,NULL),(20983,3957,'3221554','834','00','005010X220A1','3221554','','2014-02-22','12:58:39',0,'2014-02-26 08:30:22',NULL,NULL),(21464,4028,'3056991','834','00','005010X220A1','3056991','','2014-02-27','12:00:35',0,'2014-02-28 06:31:05',NULL,NULL),(23195,4346,'2931593','834','00','005010X220A1','2931593','','2014-03-06','22:15:22',0,'2014-03-07 21:31:42',NULL,NULL),(643,108,'779051','834','00','005010X220A1','779051','','2013-12-16','14:10:39',0,'2013-12-25 18:05:00',NULL,NULL),(4767,861,'49226','834','00','005010X220A1','49226','','2013-12-01','13:21:20',0,'2013-12-26 00:00:55',NULL,NULL),(12643,1672,'1262375','834','00','005010X220A1','1262375','','2014-01-02','16:52:32',0,'2014-01-03 02:02:38',NULL,NULL),(6213,1168,'938123','834','00','005010X220A1','938123','','2013-12-20','00:13:34',0,'2013-12-26 03:04:41',NULL,NULL),(12397,1637,'2299022','834','00','005010X220A1','2299022','','2013-12-31','12:08:13',1,'2014-01-02 04:29:34',NULL,NULL),(7471,1296,'310799','834','00','005010X220A1','310799','','2013-12-21','13:51:56',0,'2013-12-26 04:33:00',NULL,NULL),(15030,2584,'1578157','834','00','005010X220A1','1578157','','2014-01-15','16:40:51',0,'2014-01-16 08:44:36',NULL,NULL),(16201,2893,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:45:00',1,'2014-01-23 04:47:53',NULL,NULL),(18325,3385,'1876161','834','00','005010X220A1','1876161','','2014-02-08','17:16:53',0,'2014-02-08 19:00:50',NULL,NULL),(20829,3911,'2493400','834','00','005010X220A1','2493400','','2014-02-24','20:26:33',0,'2014-02-25 21:31:14',NULL,NULL),(4963,930,'602968','834','00','005010X220A1','602968','','2013-10-06','21:00:56',0,'2013-12-26 00:32:15',NULL,NULL),(4025,731,'893522','834','00','005010X220A1','893522','','2013-12-19','13:54:04',0,'2013-12-25 23:00:54',NULL,NULL),(12448,1638,'1673742','834','00','005010X220A1','1673742','','2013-12-31','17:09:41',1,'2014-01-02 04:31:25',NULL,NULL),(11673,1507,'1503043','834','00','005010X220A1','1503043','','2013-12-27','11:45:03',0,'2013-12-28 03:37:01',NULL,NULL),(10826,1404,'671264','834','00','005010X220A1','671264','','2013-12-23','17:37:41',0,'2013-12-26 13:04:44',NULL,NULL),(7331,1274,'775657','834','00','005010X220A1','775657','','2013-12-18','17:19:03',0,'2013-12-26 04:10:40',NULL,NULL),(2646,501,'473396','834','00','005010X220A1','473396','','2013-12-21','19:59:11',0,'2013-12-25 21:15:16',NULL,NULL),(2541,457,'559136','834','00','005010X220A1','559136','','2013-11-18','08:28:06',0,'2013-12-25 20:31:14',NULL,NULL),(16877,3093,'2463569','834','00','005010X220A1','2463569','','2014-01-28','16:19:39',0,'2014-01-28 21:00:58',NULL,NULL),(19597,3631,'3466481','834','00','005010X220A1','3466481','','2014-02-14','08:01:49',0,'2014-02-14 21:31:35',NULL,NULL),(21588,4056,'3473708','834','00','005010X220A1','3473708','','2014-02-26','15:04:22',0,'2014-02-28 07:00:29',NULL,NULL),(22719,4272,'3624370','834','00','005010X220A1','3624370','','2014-03-05','14:56:58',0,'2014-03-05 21:32:42',NULL,NULL),(4922,910,'480123','834','00','005010X220A1','480123','','2013-10-16','20:20:25',0,'2013-12-26 00:30:52',NULL,NULL),(13683,2272,'2120198','834','00','005010X220A1','2120198','','2014-01-07','18:14:51',0,'2014-01-08 18:24:22',NULL,NULL),(13597,2260,'2053301','834','00','005010X220A1','2053301','','2014-01-05','13:26:58',1,'2014-01-07 10:22:43',NULL,NULL),(12609,1671,'2538483','834','00','005010X220A1','2538483','','2014-01-02','00:30:20',0,'2014-01-03 02:01:24',NULL,NULL),(6994,1235,'410606','834','00','005010X220A1','410606','','2013-12-17','18:43:40',0,'2013-12-26 04:00:18',NULL,NULL),(14800,2551,'2419118','834','00','005010X220A1','2419118','','2014-01-14','18:26:23',0,'2014-01-15 02:06:45',NULL,NULL),(21346,4022,'2900997','834','00','005010X220A1','2900997','','2014-02-27','13:40:22',0,'2014-02-28 06:30:10',NULL,NULL),(22709,4265,'3841013','834','00','005010X220A1','3841013','','2014-03-05','14:15:20',0,'2014-03-05 21:32:35',NULL,NULL),(1070,213,'28440','834','00','005010X220A1','28440','','2013-11-29','14:54:35',0,'2013-12-25 18:30:57',NULL,NULL),(13206,2050,'0001','999','BE','005010X231A1','1217911','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:09',NULL,NULL),(13154,1998,'0001','999','BE','005010X231A1','27319','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:44',NULL,NULL),(1857,324,'599642','834','00','005010X220A1','599642','','2013-12-09','12:09:33',0,'2013-12-25 19:30:25',NULL,NULL),(2262,382,'102670','834','00','005010X220A1','102670','','2013-12-02','12:51:40',0,'2013-12-25 19:50:19',NULL,NULL),(3120,547,'984306','834','00','005010X220A1','984306','','2013-12-13','15:11:15',0,'2013-12-25 21:36:46',NULL,NULL),(5909,1112,'652959','834','00','005010X220A1','652959','','2013-12-14','19:40:08',0,'2013-12-26 02:31:04',NULL,NULL),(15525,2652,'2319460','834','00','005010X220A1','2319460','','2014-01-15','19:34:26',0,'2014-01-17 03:36:42',NULL,NULL),(17028,3120,'2485609','834','00','005010X220A1','2485609','','2014-01-29','13:35:22',0,'2014-01-29 21:01:12',NULL,NULL),(17315,3174,'2032206','834','00','005010X220A1','2032206','','2014-01-31','07:12:17',0,'2014-01-31 21:00:51',NULL,NULL),(17368,3184,'1804022','834','00','005010X220A1','1804022','','2014-01-31','12:19:29',0,'2014-01-31 21:01:29',NULL,NULL),(22960,4312,'3325305','834','00','005010X220A1','3325305','','2014-03-05','21:27:20',0,'2014-03-06 21:30:05',NULL,NULL),(23107,4341,'3412562','834','00','005010X220A1','3412562','','2014-03-07','12:29:25',0,'2014-03-07 21:30:40',NULL,NULL),(23717,4459,'3274305','834','00','005010X220A1','3274305','','2014-03-10','11:19:39',0,'2014-03-10 21:02:41',NULL,NULL),(5973,1119,'691861','834','00','005010X220A1','691861','','2013-12-14','21:04:21',0,'2013-12-26 02:33:06',NULL,NULL),(1657,289,'785220','834','00','005010X220A1','785220','','2013-12-09','21:02:08',0,'2013-12-25 19:15:06',NULL,NULL),(12065,1586,'2425377','834','00','005010X220A1','2425377','','2013-12-29','23:06:07',0,'2014-01-01 12:04:32',NULL,NULL),(11406,1466,'2125049','834','00','005010X220A1','2125049','','2013-12-26','11:58:49',0,'2013-12-27 02:06:45',NULL,NULL),(15720,2711,'1420283','834','00','005010X220A1','1420283','','2014-01-19','18:28:13',0,'2014-01-21 08:46:00',NULL,NULL),(18394,3411,'1918685','834','00','005010X220A1','1918685','','2014-02-08','22:30:36',0,'2014-02-09 19:00:31',NULL,NULL),(18499,3441,'2547068','834','00','005010X220A1','2547068','','2014-02-10','04:23:10',0,'2014-02-10 11:01:14',NULL,NULL),(21392,4024,'2922926','834','00','005010X220A1','2922926','','2014-02-27','17:29:36',0,'2014-02-28 06:30:31',NULL,NULL),(23256,4373,'3671314','834','00','005010X220A1','3671314','','2014-03-07','14:26:16',0,'2014-03-07 21:32:28',NULL,NULL),(23339,4385,'3799132','834','00','005010X220A1','3799132','','2014-03-07','18:35:45',0,'2014-03-08 21:30:50',NULL,NULL),(5448,1036,'435870','834','00','005010X220A1','435870','','2013-11-03','09:06:26',0,'2013-12-26 01:31:56',NULL,NULL),(14643,2529,'2026563','834','00','005010X220A1','2026563','','2014-01-13','13:42:18',0,'2014-01-14 01:33:34',NULL,NULL),(15381,2624,'2098131','834','00','005010X220A1','2098131','','2014-01-16','16:00:45',0,'2014-01-17 03:35:38',NULL,NULL),(15733,2711,'1545096','834','00','005010X220A1','1545096','','2014-01-20','16:29:13',0,'2014-01-21 08:46:08',NULL,NULL),(15793,2722,'1695652','834','00','005010X220A1','1695652','','2014-01-20','11:14:33',0,'2014-01-21 08:46:44',NULL,NULL),(16721,3064,'2355723','834','00','005010X220A1','2355723','','2014-01-27','15:42:15',0,'2014-01-27 21:00:57',NULL,NULL),(20996,3960,'3447519','834','00','005010X220A1','3447519','','2014-02-21','19:33:34',0,'2014-02-26 08:30:35',NULL,NULL),(100,4,'1075216','834','00','005010X220A1','1075216','','2013-12-05','12:49:11',0,'2013-12-25 17:18:02',NULL,NULL),(13812,2297,'2469822','834','00','005010X220A1','2469822','','2014-01-11','11:49:16',0,'2014-01-13 02:18:23',NULL,NULL),(13602,2261,'2272514','834','00','005010X220A1','2272514','','2014-01-05','17:36:10',1,'2014-01-07 10:22:55',NULL,NULL),(13171,2015,'0001','999','BE','005010X231A1','1137846','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:31',NULL,NULL),(13102,1946,'0001','999','BE','005010X231A1','212659','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:44',NULL,NULL),(4166,734,'577926','834','00','005010X220A1','577926','','2013-12-19','09:55:13',0,'2013-12-25 23:05:09',NULL,NULL),(5265,971,'368944','834','00','005010X220A1','368944','','2013-11-11','19:03:13',0,'2013-12-26 01:00:11',NULL,NULL),(11110,1426,'433285','834','00','005010X220A1','433285','','2013-12-23','08:36:23',0,'2013-12-26 13:14:25',NULL,NULL),(15446,2630,'1887956','834','00','005010X220A1','1887956','','2014-01-16','11:40:33',0,'2014-01-17 03:36:08',NULL,NULL),(15777,2717,'1682358','834','00','005010X220A1','1682358','','2014-01-20','12:59:53',0,'2014-01-21 08:46:34',NULL,NULL),(17562,3236,'1968668','834','00','005010X220A1','1968668','','2014-02-03','11:04:23',0,'2014-02-03 21:00:33',NULL,NULL),(20270,3794,'2597144','834','00','005010X220A1','2597144','','2014-02-19','01:08:58',0,'2014-02-20 04:35:48',NULL,NULL),(21519,4036,'2964030','834','00','005010X220A1','2964030','','2014-02-27','11:25:42',0,'2014-02-28 06:31:30',NULL,NULL),(22087,4175,'3249801','834','00','005010X220A1','3249801','','2014-03-02','19:29:44',0,'2014-03-03 21:30:08',NULL,NULL),(911,177,'55593','834','00','005010X220A1','55593','','2013-12-03','16:20:39',0,'2013-12-25 18:17:24',NULL,NULL),(14473,2494,'0001','999','BE','005010X231A1','1326502','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:45',NULL,NULL),(11384,1463,'1405502','834','00','005010X220A1','1405502','','2013-12-26','12:10:44',0,'2013-12-27 02:06:02',NULL,NULL),(12344,1634,'2489752','834','00','005010X220A1','2489752','','2013-12-31','12:10:25',1,'2014-01-02 04:27:42',NULL,NULL),(15027,2584,'2567223','834','00','005010X220A1','2567223','','2014-01-15','16:20:10',0,'2014-01-16 08:44:34',NULL,NULL),(19054,3542,'2102410','834','00','005010X220A1','2102410','','2014-02-11','20:43:36',0,'2014-02-12 21:31:04',NULL,NULL),(20903,3930,'3283984','834','00','005010X220A1','3283984','','2014-02-22','19:16:18',0,'2014-02-26 08:00:04',NULL,NULL),(21521,4036,'3049901','834','00','005010X220A1','3049901','','2014-02-27','12:19:18',0,'2014-02-28 06:31:31',NULL,NULL),(22006,4149,'2731391','834','00','005010X220A1','2731391','','2014-03-01','21:04:22',0,'2014-03-03 01:00:27',NULL,NULL),(22348,4204,'3358675','834','00','005010X220A1','3358675','','2014-03-04','15:14:44',0,'2014-03-04 21:01:37',NULL,NULL),(519,102,'647851','834','00','005010X220A1','647851','','2013-12-16','12:51:18',0,'2013-12-25 18:01:01',NULL,NULL),(12961,1734,'1488753','834','00','005010X220A1','1488753','','2014-01-03','23:28:23',0,'2014-01-05 00:00:45',NULL,NULL),(7730,1342,'1202056','834','00','005010X220A1','1202056','','2013-10-20','17:18:43',0,'2013-12-26 05:00:13',NULL,NULL),(6988,1234,'670873','834','00','005010X220A1','670873','','2013-12-18','07:50:48',0,'2013-12-26 04:00:06',NULL,NULL),(15306,2622,'2592842','834','00','005010X220A1','2592842','','2014-01-15','22:05:31',0,'2014-01-17 03:35:04',NULL,NULL),(16390,2989,'1377161','834','00','005010X220A1','1377161','','2014-01-23','15:29:43',0,'2014-01-23 21:01:16',NULL,NULL),(18424,3420,'1884480','834','00','005010X220A1','1884480','','2014-02-10','04:08:15',0,'2014-02-10 11:00:12',NULL,NULL),(19591,3629,'2629428','834','00','005010X220A1','2629428','','2014-02-14','17:18:04',0,'2014-02-14 21:31:31',NULL,NULL),(21480,4028,'3133012','834','00','005010X220A1','3133012','','2014-02-27','15:58:49',0,'2014-02-28 06:31:13',NULL,NULL),(22467,4238,'3688233','834','00','005010X220A1','3688233','','2014-03-05','12:23:35',0,'2014-03-05 21:00:15',NULL,NULL),(136,8,'445999','834','00','005010X220A1','445999','','2013-12-05','15:02:34',0,'2013-12-25 17:19:12',NULL,NULL),(7468,1296,'65389','834','00','005010X220A1','65389','','2013-12-21','13:12:30',0,'2013-12-26 04:32:54',NULL,NULL),(6026,1141,'1150600','834','00','005010X220A1','1150600','','2013-11-17','09:24:51',0,'2013-12-26 02:45:45',NULL,NULL),(2762,505,'408312','834','00','005010X220A1','408312','','2013-12-22','13:14:48',0,'2013-12-25 21:19:06',NULL,NULL),(3116,547,'686661','834','00','005010X220A1','686661','','2013-12-13','14:01:00',0,'2013-12-25 21:36:41',NULL,NULL),(4342,757,'216980','834','00','005010X220A1','216980','','2013-12-19','09:06:13',0,'2013-12-25 23:10:32',NULL,NULL),(15532,2654,'1490406','834','00','005010X220A1','1490406','','2014-01-17','07:00:07',0,'2014-01-20 08:05:35',NULL,NULL),(16075,2775,'1550277','834','00','005010X220A1','1550277','','2014-01-21','23:03:37',0,'2014-01-23 03:02:47',NULL,NULL),(17195,3149,'2123369','834','00','005010X220A1','2123369','','2014-01-30','12:17:18',0,'2014-01-30 21:01:06',NULL,NULL),(18859,3491,'2348681','834','00','005010X220A1','2348681','','2014-02-11','17:43:17',0,'2014-02-11 21:02:00',NULL,NULL),(19436,3602,'2669310','834','00','005010X220A1','2669310','','2014-02-13','12:34:22',0,'2014-02-13 22:02:56',NULL,NULL),(22447,4231,'3149041','834','00','005010X220A1','3149041','','2014-03-04','14:59:47',0,'2014-03-04 21:30:14',NULL,NULL),(289,64,'961593','834','00','005010X220A1','961593','','2013-11-09','13:27:51',0,'2013-12-25 17:32:17',NULL,NULL),(371,73,'1054281','834','00','005010X220A1','1054281','','2013-12-03','18:31:21',0,'2013-12-25 17:47:26',NULL,NULL),(853,175,'1144179','834','00','005010X220A1','1144179','','2013-12-03','11:38:04',0,'2013-12-25 18:15:44',NULL,NULL),(12548,1655,'1610193','834','00','005010X220A1','1610193','','2013-12-31','16:06:03',1,'2014-01-02 04:35:11',NULL,NULL),(3286,584,'271115','834','00','005010X220A1','271115','','2013-12-16','20:23:26',0,'2013-12-25 21:48:00',NULL,NULL),(11248,1454,'2177507','834','00','005010X220A1','2177507','','2013-12-26','14:18:01',0,'2013-12-27 02:01:55',NULL,NULL),(1814,310,'453735','834','00','005010X220A1','453735','','2013-12-10','16:25:50',0,'2013-12-25 19:20:04',NULL,NULL),(20879,3920,'2974315','834','00','005010X220A1','2974315','','2014-02-25','12:35:26',0,'2014-02-25 21:31:53',NULL,NULL),(21155,3997,'3565399','834','00','005010X220A1','3565399','','2014-02-26','13:33:20',0,'2014-02-26 21:00:46',NULL,NULL),(22080,4174,'2751054','834','00','005010X220A1','2751054','','2014-03-03','10:40:05',0,'2014-03-03 21:30:02',NULL,NULL),(7407,1295,'288569','834','00','005010X220A1','288569','','2013-12-20','22:09:08',0,'2013-12-26 04:31:04',NULL,NULL),(15050,2585,'2203910','834','00','005010X220A1','2203910','','2014-01-14','20:04:06',0,'2014-01-16 08:44:49',NULL,NULL),(13047,1891,'0001','999','BE','005010X231A1','139453','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:12',NULL,NULL),(12815,1704,'2156897','834','00','005010X220A1','2156897','','2014-01-02','20:36:26',0,'2014-01-04 02:01:48',NULL,NULL),(6220,1168,'530029','834','00','005010X220A1','530029','','2013-12-20','10:06:21',0,'2013-12-26 03:04:54',NULL,NULL),(2754,505,'561455','834','00','005010X220A1','561455','','2013-12-21','18:54:40',0,'2013-12-25 21:18:52',NULL,NULL),(15810,2727,'2009391','834','00','005010X220A1','2009391','','2014-01-19','20:01:46',0,'2014-01-21 08:46:54',NULL,NULL),(17276,3170,'1687857','834','00','005010X220A1','1687857','','2014-01-31','16:18:00',0,'2014-01-31 21:00:25',NULL,NULL),(22994,4322,'3638247','834','00','005010X220A1','3638247','','2014-03-07','10:03:38',0,'2014-03-07 21:00:09',NULL,NULL),(23456,4410,'2838981','834','00','005010X220A1','2838981','','2014-03-09','16:42:09',0,'2014-03-09 21:00:56',NULL,NULL),(1008,188,'239798','834','00','005010X220A1','239798','','2013-12-03','14:32:38',0,'2013-12-25 18:20:31',NULL,NULL),(14531,2518,'1751784','834','00','005010X220A1','1751784','','2014-01-13','11:19:05',0,'2014-01-14 01:32:22',NULL,NULL),(6365,1182,'405999','834','00','005010X220A1','405999','','2013-12-20','08:08:40',0,'2013-12-26 03:09:22',NULL,NULL),(10502,1400,'1179946','834','00','005010X220A1','1179946','','2013-12-23','18:25:55',0,'2013-12-26 12:53:57',NULL,NULL),(4442,800,'1304641','834','00','005010X220A1','1304641','','2013-11-25','21:36:36',0,'2013-12-25 23:30:08',NULL,NULL),(16898,3100,'1490638','834','00','005010X220A1','1490638','','2014-01-28','15:25:27',0,'2014-01-28 21:01:12',NULL,NULL),(45,2,'98764','834','00','005010X220A1','98764','','2013-12-05','15:45:08',0,'2013-12-25 17:16:21',NULL,NULL),(15083,2585,'2290147','834','00','005010X220A1','2290147','','2014-01-15','13:31:11',0,'2014-01-16 08:45:10',NULL,NULL),(14640,2528,'2197578','834','00','005010X220A1','2197578','','2014-01-13','12:17:29',0,'2014-01-14 01:33:31',NULL,NULL),(1175,239,'1945782','834','00','005010X220A1','1945782','','2013-12-24','13:56:36',0,'2013-12-25 18:46:59',NULL,NULL),(14094,2341,'1569257','834','00','005010X220A1','1569257','','2014-01-08','17:07:07',0,'2014-01-13 02:22:06',NULL,NULL),(13127,1971,'0001','999','BE','005010X231A1','5366','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:53',NULL,NULL),(12445,1638,'2118999','834','00','005010X220A1','2118999','','2013-12-31','16:31:00',1,'2014-01-02 04:31:18',NULL,NULL),(1684,291,'465019','834','00','005010X220A1','465019','','2013-12-09','20:24:32',0,'2013-12-25 19:15:58',NULL,NULL),(20562,3864,'3497342','834','00','005010X220A1','3497342','','2014-02-21','14:00:04',0,'2014-02-21 21:30:11',NULL,NULL),(21766,4090,'3734460','834','00','005010X220A1','3734460','','2014-02-28','15:53:32',0,'2014-02-28 21:30:57',NULL,NULL),(21846,4111,'3048572','834','00','005010X220A1','3048572','','2014-02-28','16:18:41',0,'2014-02-28 21:31:57',NULL,NULL),(23338,4384,'3565783','834','00','005010X220A1','3565783','','2014-03-08','16:36:10',0,'2014-03-08 21:30:48',NULL,NULL),(4881,891,'934796','834','00','005010X220A1','934796','','2013-11-21','15:22:18',0,'2013-12-26 00:16:38',NULL,NULL),(15004,2584,'1671531','834','00','005010X220A1','1671531','','2014-01-14','22:04:31',0,'2014-01-16 08:44:20',NULL,NULL),(14913,2558,'1431624','834','00','005010X220A1','1431624','','2014-01-14','17:04:04',0,'2014-01-15 02:07:35',NULL,NULL),(4563,825,'827322','834','00','005010X220A1','827322','','2013-12-24','01:13:48',0,'2013-12-25 23:46:07',NULL,NULL),(1051,205,'1128160','834','00','005010X220A1','1128160','','2013-11-28','20:10:48',0,'2013-12-25 18:30:19',NULL,NULL),(3133,551,'922393','834','00','005010X220A1','922393','','2013-12-13','15:18:05',0,'2013-12-25 21:37:12',NULL,NULL),(10957,1410,'579547','834','00','005010X220A1','579547','','2013-12-23','18:22:28',0,'2013-12-26 13:09:24',NULL,NULL),(4122,733,'205228','834','00','005010X220A1','205228','','2013-12-19','14:10:10',0,'2013-12-25 23:03:53',NULL,NULL),(4204,737,'1003376','834','00','005010X220A1','1003376','','2013-12-18','19:19:06',0,'2013-12-25 23:06:21',NULL,NULL),(16351,2983,'2464726','834','00','005010X220A1','2464726','','2014-01-23','15:10:36',0,'2014-01-23 21:00:49',NULL,NULL),(16439,3006,'2345279','834','00','005010X220A1','2345279','','2014-01-24','15:34:17',0,'2014-01-24 21:00:06',NULL,NULL),(18522,3451,'3085851','834','00','005010X220A1','3085851','','2014-02-10','09:16:11',0,'2014-02-10 21:30:08',NULL,NULL),(637,108,'1272897','834','00','005010X220A1','1272897','','2013-12-16','12:37:05',0,'2013-12-25 18:04:49',NULL,NULL),(6206,1168,'697637','834','00','005010X220A1','697637','','2013-12-19','20:11:39',0,'2013-12-26 03:04:29',NULL,NULL),(6199,1168,'653189','834','00','005010X220A1','653189','','2013-12-19','19:02:05',0,'2013-12-26 03:04:19',NULL,NULL),(13978,2323,'1993345','834','00','005010X220A1','1993345','','2014-01-09','15:05:33',0,'2014-01-13 02:20:41',NULL,NULL),(12676,1673,'2573378','834','00','005010X220A1','2573378','','2014-01-02','11:14:00',0,'2014-01-03 02:03:52',NULL,NULL),(12534,1646,'1734144','834','00','005010X220A1','1734144','','2013-12-31','17:21:25',1,'2014-01-02 04:34:35',NULL,NULL),(3862,690,'341463','834','00','005010X220A1','341463','','2013-10-10','10:23:32',0,'2013-12-25 22:30:59',NULL,NULL),(4135,733,'890996','834','00','005010X220A1','890996','','2013-12-19','15:55:43',0,'2013-12-25 23:04:15',NULL,NULL),(2505,447,'1180032','834','00','005010X220A1','1180032','','2013-10-13','15:58:05',0,'2013-12-25 20:30:12',NULL,NULL),(4190,734,'1257944','834','00','005010X220A1','1257944','','2013-12-19','16:03:20',0,'2013-12-25 23:05:57',NULL,NULL),(15117,2587,'2559589','834','00','005010X220A1','2559589','','2014-01-15','14:05:23',0,'2014-01-16 08:45:32',NULL,NULL),(15062,2585,'1374391','834','00','005010X220A1','1374391','','2014-01-15','10:14:34',0,'2014-01-16 08:44:56',NULL,NULL),(2299,398,'189106','834','00','005010X220A1','189106','','2013-11-02','04:08:48',0,'2013-12-25 20:01:09',NULL,NULL),(12222,1616,'1947186','834','00','005010X220A1','1947186','','2014-01-01','09:35:56',1,'2014-01-02 04:22:19',NULL,NULL),(2441,420,'1071774','834','00','005010X220A1','1071774','','2013-12-06','17:22:25',0,'2013-12-25 20:18:31',NULL,NULL),(11371,1460,'2072349','834','00','005010X220A1','2072349','','2013-12-26','11:14:07',0,'2013-12-27 02:05:40',NULL,NULL),(12710,1677,'1356486','834','00','005010X220A1','1356486','','2014-01-02','18:17:53',0,'2014-01-03 02:05:08',NULL,NULL),(11970,1580,'2449992','834','00','005010X220A1','2449992','','2013-12-30','13:40:07',0,'2014-01-01 12:00:56',NULL,NULL),(11063,1421,'1352639','834','00','005010X220A1','1352639','','2013-12-23','10:00:34',0,'2013-12-26 13:12:55',NULL,NULL),(7025,1235,'129859','834','00','005010X220A1','129859','','2013-12-18','11:35:00',0,'2013-12-26 04:01:16',NULL,NULL),(15379,2624,'2446636','834','00','005010X220A1','2446636','','2014-01-16','08:46:32',0,'2014-01-17 03:35:37',NULL,NULL),(17479,3218,'2673047','834','00','005010X220A1','2673047','','2014-02-02','17:31:40',0,'2014-02-02 19:00:12',NULL,NULL),(17668,3258,'2380438','834','00','005010X220A1','2380438','','2014-02-04','17:02:33',0,'2014-02-04 21:00:09',NULL,NULL),(18195,3353,'2315841','834','00','005010X220A1','2315841','','2014-02-07','07:33:22',0,'2014-02-07 19:00:31',NULL,NULL),(19240,3580,'1965045','834','00','005010X220A1','1965045','','2014-02-13','13:57:45',0,'2014-02-13 22:00:26',NULL,NULL),(19552,3626,'1930542','834','00','005010X220A1','1930542','','2014-02-13','22:37:32',0,'2014-02-14 21:31:03',NULL,NULL),(20827,3911,'3424928','834','00','005010X220A1','3424928','','2014-02-24','18:36:23',0,'2014-02-25 21:31:13',NULL,NULL),(22133,4179,'3509318','834','00','005010X220A1','3509318','','2014-03-03','11:29:31',0,'2014-03-03 21:30:43',NULL,NULL),(23688,4449,'2908708','834','00','005010X220A1','2908708','','2014-03-09','22:40:55',0,'2014-03-10 21:02:19',NULL,NULL),(290,65,'86884','834','00','005010X220A1','86884','','2013-11-09','00:19:58',0,'2013-12-25 17:32:20',NULL,NULL),(4270,742,'591422','834','00','005010X220A1','591422','','2013-12-19','15:58:20',0,'2013-12-25 23:08:24',NULL,NULL),(11677,1510,'1713983','834','00','005010X220A1','1713983','','2013-12-27','12:37:52',0,'2013-12-28 03:37:09',NULL,NULL),(11411,1467,'1890974','834','00','005010X220A1','1890974','','2013-12-26','15:17:05',0,'2013-12-27 02:06:54',NULL,NULL),(11309,1456,'1967769','834','00','005010X220A1','1967769','','2013-12-26','10:53:02',0,'2013-12-27 02:03:47',NULL,NULL),(5769,1072,'465205','834','00','005010X220A1','465205','','2013-12-14','15:58:07',0,'2013-12-26 02:02:31',NULL,NULL),(10462,1400,'634585','834','00','005010X220A1','634585','','2013-12-23','13:59:25',0,'2013-12-26 12:52:39',NULL,NULL),(6334,1176,'298404','834','00','005010X220A1','298404','','2013-12-19','22:33:37',0,'2013-12-26 03:08:26',NULL,NULL),(7103,1236,'521297','834','00','005010X220A1','521297','','2013-12-18','12:23:22',0,'2013-12-26 04:03:40',NULL,NULL),(16865,3093,'2354731','834','00','005010X220A1','2354731','','2014-01-28','12:58:34',0,'2014-01-28 21:00:50',NULL,NULL),(16947,3115,'2389153','834','00','005010X220A1','2389153','','2014-01-29','15:58:54',0,'2014-01-29 21:00:21',NULL,NULL),(17460,3213,'1841332','834','00','005010X220A1','1841332','','2014-02-01','14:27:50',0,'2014-02-01 19:00:49',NULL,NULL),(20272,3796,'2635309','834','00','005010X220A1','2635309','','2014-02-19','00:03:44',0,'2014-02-20 04:35:54',NULL,NULL),(22007,4149,'3277878','834','00','005010X220A1','3277878','','2014-03-02','08:22:33',0,'2014-03-03 01:00:27',NULL,NULL),(22819,4278,'3438044','834','00','005010X220A1','3438044','','2014-03-06','12:20:20',0,'2014-03-06 21:01:17',NULL,NULL),(868,175,'1092068','834','00','005010X220A1','1092068','','2013-12-03','17:43:30',0,'2013-12-25 18:16:15',NULL,NULL),(14766,2551,'1483031','834','00','005010X220A1','1483031','','2014-01-14','10:58:35',0,'2014-01-15 02:06:31',NULL,NULL),(1214,243,'1389448','834','00','005010X220A1','1389448','','2013-12-24','08:07:05',0,'2013-12-25 18:48:12',NULL,NULL),(1614,281,'446955','834','00','005010X220A1','446955','','2013-11-19','23:03:08',0,'2013-12-25 19:01:34',NULL,NULL),(13150,1994,'0001','999','BE','005010X231A1','1040265','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:33',NULL,NULL),(1758,294,'982723','834','00','005010X220A1','982723','','2013-12-09','18:43:24',0,'2013-12-25 19:18:13',NULL,NULL),(2003,330,'325637','834','00','005010X220A1','325637','','2013-12-09','12:41:06',0,'2013-12-25 19:34:57',NULL,NULL),(2281,393,'212465','834','00','005010X220A1','212465','','2013-11-24','11:44:16',0,'2013-12-25 20:00:31',NULL,NULL),(12026,1583,'1705129','834','00','005010X220A1','1705129','','2013-12-30','13:37:49',0,'2014-01-01 12:03:03',NULL,NULL),(7665,1317,'722758','834','00','005010X220A1','722758','','2013-12-21','08:59:50',0,'2013-12-26 04:39:19',NULL,NULL),(7620,1306,'652029','834','00','005010X220A1','652029','','2013-12-21','14:17:33',0,'2013-12-26 04:37:55',NULL,NULL),(11987,1580,'1649979','834','00','005010X220A1','1649979','','2013-12-30','17:28:46',0,'2014-01-01 12:01:37',NULL,NULL),(11962,1580,'1373970','834','00','005010X220A1','1373970','','2013-12-30','11:38:57',0,'2014-01-01 12:00:38',NULL,NULL),(11744,1521,'1780750','834','00','005010X220A1','1780750','','2013-12-28','16:10:58',1,'2013-12-29 11:09:16',NULL,NULL),(7234,1241,'466493','834','00','005010X220A1','466493','','2013-12-18','17:36:47',0,'2013-12-26 04:07:41',NULL,NULL),(6230,1168,'590379','834','00','005010X220A1','590379','','2013-12-20','17:13:31',0,'2013-12-26 03:05:16',NULL,NULL),(5264,970,'1213913','834','00','005010X220A1','1213913','','2013-11-12','17:53:28',0,'2013-12-26 01:00:09',NULL,NULL),(15149,2588,'1785122','834','00','005010X220A1','1785122','','2014-01-15','00:48:41',0,'2014-01-16 08:45:54',NULL,NULL),(15758,2714,'2216885','834','00','005010X220A1','2216885','','2014-01-20','11:41:30',0,'2014-01-21 08:46:22',NULL,NULL),(16059,2772,'1914626','834','00','005010X220A1','1914626','','2014-01-22','12:33:25',0,'2014-01-23 03:02:40',NULL,NULL),(16222,2914,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:25:00',0,'2014-01-23 06:00:02',NULL,NULL),(16261,2953,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:42:00',0,'2014-01-23 08:38:31',NULL,NULL),(16466,3006,'1423074','834','00','005010X220A1','1423074','','2014-01-24','14:30:23',0,'2014-01-24 21:00:21',NULL,NULL),(17466,3216,'1573619','834','00','005010X220A1','1573619','','2014-02-01','21:03:24',0,'2014-02-02 19:00:03',NULL,NULL),(17770,3264,'2340044','834','00','005010X220A1','2340044','','2014-02-04','12:26:48',0,'2014-02-04 21:01:12',NULL,NULL),(19939,3735,'2750703','834','00','005010X220A1','2750703','','2014-02-18','09:39:43',0,'2014-02-18 21:30:10',NULL,NULL),(21112,3994,'2672450','834','00','005010X220A1','2672450','','2014-02-26','12:04:06',0,'2014-02-26 21:00:17',NULL,NULL),(21847,4112,'2954209','834','00','005010X220A1','2954209','','2014-02-28','16:57:31',0,'2014-02-28 21:31:57',NULL,NULL),(22592,4250,'3725675','834','00','005010X220A1','3725675','','2014-03-04','19:08:52',0,'2014-03-05 21:31:13',NULL,NULL),(22732,4276,'3599391','834','00','005010X220A1','3599391','','2014-03-05','21:28:16',0,'2014-03-06 21:00:15',NULL,NULL),(22764,4276,'3373949','834','00','005010X220A1','3373949','','2014-03-06','17:54:57',0,'2014-03-06 21:00:39',NULL,NULL),(23422,4405,'3497846','834','00','005010X220A1','3497846','','2014-03-08','22:32:35',0,'2014-03-09 21:00:27',NULL,NULL),(1586,278,'1179032','834','00','005010X220A1','1179032','','2013-11-20','12:50:41',0,'2013-12-25 19:00:49',NULL,NULL),(14279,2376,'1679170','834','00','005010X220A1','1679170','','2014-01-10','13:15:35',0,'2014-01-13 03:00:15',NULL,NULL),(13311,2155,'0001','999','BE','005010X231A1','1122903','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:42',NULL,NULL),(12500,1642,'1693569','834','00','005010X220A1','1693569','','2013-12-30','22:35:46',1,'2014-01-02 04:33:21',NULL,NULL),(10567,1402,'1494530','834','00','005010X220A1','1494530','','2013-12-23','08:45:26',0,'2013-12-26 12:56:06',NULL,NULL),(16587,3040,'1992601','834','00','005010X220A1','1992601','','2014-01-25','17:41:06',0,'2014-01-25 19:00:15',NULL,NULL),(17259,3170,'1463990','834','00','005010X220A1','1463990','','2014-01-31','09:11:15',0,'2014-01-31 21:00:13',NULL,NULL),(17660,3258,'1817843','834','00','005010X220A1','1817843','','2014-02-03','18:30:00',0,'2014-02-04 21:00:04',NULL,NULL),(22934,4294,'3097155','834','00','005010X220A1','3097155','','2014-03-06','15:53:02',0,'2014-03-06 21:02:41',NULL,NULL),(431,79,'606959','834','00','005010X220A1','606959','','2013-12-03','20:50:27',0,'2013-12-25 17:49:24',NULL,NULL),(693,111,'444827','834','00','005010X220A1','444827','','2013-12-15','21:08:43',0,'2013-12-25 18:06:31',NULL,NULL),(14450,2471,'0001','999','BE','005010X231A1','578605','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:24',NULL,NULL),(914,177,'436103','834','00','005010X220A1','436103','','2013-12-03','12:04:53',0,'2013-12-25 18:17:29',NULL,NULL),(1514,258,'1359079','834','00','005010X220A1','1359079','','2013-12-24','16:57:18',0,'2013-12-25 18:57:50',NULL,NULL),(14232,2369,'1719963','834','00','005010X220A1','1719963','','2014-01-09','19:12:32',0,'2014-01-13 02:24:05',NULL,NULL),(5141,943,'585379','834','00','005010X220A1','585379','','2013-12-11','12:17:23',0,'2013-12-26 00:50:33',NULL,NULL),(4926,912,'292249','834','00','005010X220A1','292249','','2013-10-15','19:57:27',0,'2013-12-26 00:31:00',NULL,NULL),(10418,1400,'1459007','834','00','005010X220A1','1459007','','2013-12-23','10:11:33',0,'2013-12-26 12:51:16',NULL,NULL),(4912,909,'1198617','834','00','005010X220A1','1198617','','2013-10-15','22:57:09',0,'2013-12-26 00:30:33',NULL,NULL),(15264,2601,'1439176','834','00','005010X220A1','1439176','','2014-01-15','15:43:21',0,'2014-01-16 08:47:06',NULL,NULL),(16335,2983,'2539030','834','00','005010X220A1','2539030','','2014-01-23','10:24:47',0,'2014-01-23 21:00:38',NULL,NULL),(20433,3841,'3110172','834','00','005010X220A1','3110172','','2014-02-19','19:05:20',0,'2014-02-20 22:00:09',NULL,NULL),(21444,4028,'2575812','834','00','005010X220A1','2575812','','2014-02-26','18:46:32',0,'2014-02-28 06:30:56',NULL,NULL),(22526,4247,'3263085','834','00','005010X220A1','3263085','','2014-03-05','14:29:56',0,'2014-03-05 21:30:25',NULL,NULL),(22594,4250,'2685317','834','00','005010X220A1','2685317','','2014-03-05','01:08:50',0,'2014-03-05 21:31:14',NULL,NULL),(22981,4317,'3535263','834','00','005010X220A1','3535263','','2014-03-06','15:30:36',0,'2014-03-06 21:30:20',NULL,NULL),(23358,4390,'3122297','834','00','005010X220A1','3122297','','2014-03-08','11:55:20',0,'2014-03-08 21:31:04',NULL,NULL),(4250,739,'473275','834','00','005010X220A1','473275','','2013-12-19','17:20:49',0,'2013-12-25 23:07:47',NULL,NULL),(2656,501,'770337','834','00','005010X220A1','770337','','2013-12-22','11:07:01',0,'2013-12-25 21:15:36',NULL,NULL),(10950,1410,'1742452','834','00','005010X220A1','1742452','','2013-12-23','17:29:38',0,'2013-12-26 13:09:13',NULL,NULL),(13723,2275,'2275806','834','00','005010X220A1','2275806','','2014-01-07','16:53:39',0,'2014-01-08 18:24:39',NULL,NULL),(2366,413,'303875','834','00','005010X220A1','303875','','2013-12-06','12:00:05',0,'2013-12-25 20:16:13',NULL,NULL),(12088,1586,'2444970','834','00','005010X220A1','2444970','','2013-12-30','17:17:45',0,'2014-01-01 12:05:20',NULL,NULL),(19406,3593,'2842977','834','00','005010X220A1','2842977','','2014-02-13','13:26:46',0,'2014-02-13 22:02:34',NULL,NULL),(5399,1020,'327396','834','00','005010X220A1','327396','','2013-11-13','18:28:58',0,'2013-12-26 01:30:10',NULL,NULL),(11113,1426,'1242490','834','00','005010X220A1','1242490','','2013-12-23','10:15:34',0,'2013-12-26 13:14:31',NULL,NULL),(18645,3463,'2387104','834','00','005010X220A1','2387104','','2014-02-10','15:07:59',0,'2014-02-10 21:31:36',NULL,NULL),(21561,4053,'3410992','834','00','005010X220A1','3410992','','2014-02-26','13:55:41',0,'2014-02-28 07:00:06',NULL,NULL),(327,72,'1054285','834','00','005010X220A1','1054285','','2013-12-03','20:18:09',0,'2013-12-25 17:46:04',NULL,NULL),(13462,2226,'1635633','834','00','005010X220A1','1635633','','2014-01-06','12:55:00',0,'2014-01-07 04:03:14',NULL,NULL),(12464,1639,'2165875','834','00','005010X220A1','2165875','','2013-12-31','16:04:37',1,'2014-01-02 04:32:02',NULL,NULL),(12177,1596,'2038030','834','00','005010X220A1','2038030','','2013-12-30','15:55:41',0,'2014-01-01 12:08:23',NULL,NULL),(11785,1537,'1228848','834','00','005010X220A1','1228848','','2013-12-28','20:08:17',1,'2013-12-29 11:12:39',NULL,NULL),(4634,827,'358548','834','00','005010X220A1','358548','','2013-12-23','23:20:21',0,'2013-12-25 23:48:23',NULL,NULL),(10987,1413,'1283741','834','00','005010X220A1','1283741','','2013-12-23','10:41:05',0,'2013-12-26 13:10:19',NULL,NULL),(16098,2790,'0001','999','BE','005010X231A1','1359079','834','2014-01-15','23:00:00',0,'2014-01-23 03:39:38',NULL,NULL),(21822,4096,'3507805','834','00','005010X220A1','3507805','','2014-02-28','10:10:32',0,'2014-02-28 21:31:36',NULL,NULL),(333,72,'303809','834','00','005010X220A1','303809','','2013-12-04','09:58:16',0,'2013-12-25 17:46:14',NULL,NULL),(597,107,'1143241','834','00','005010X220A1','1143241','','2013-12-16','10:38:12',0,'2013-12-25 18:03:29',NULL,NULL),(5207,949,'851090','834','00','005010X220A1','851090','','2013-12-11','15:16:21',0,'2013-12-26 00:52:35',NULL,NULL),(13752,2277,'2310089','834','00','005010X220A1','2310089','','2014-01-06','21:33:16',0,'2014-01-08 18:24:53',NULL,NULL),(13411,2222,'2095274','834','00','005010X220A1','2095274','','2014-01-05','20:36:08',0,'2014-01-07 04:01:16',NULL,NULL),(11660,1500,'2126263','834','00','005010X220A1','2126263','','2013-12-27','14:24:06',0,'2013-12-28 03:36:36',NULL,NULL),(3266,580,'20891','834','00','005010X220A1','20891','','2013-12-17','10:50:21',0,'2013-12-25 21:47:21',NULL,NULL),(11150,1435,'692286','834','00','005010X220A1','692286','','2013-12-23','07:30:13',0,'2013-12-26 13:15:54',NULL,NULL),(10750,1403,'1602337','834','00','005010X220A1','1602337','','2013-12-23','17:34:07',0,'2013-12-26 13:02:13',NULL,NULL),(7336,1278,'1187362','834','00','005010X220A1','1187362','','2013-12-18','18:04:45',0,'2013-12-26 04:10:50',NULL,NULL),(22249,4200,'3357651','834','00','005010X220A1','3357651','','2014-03-03','20:36:54',0,'2014-03-04 21:00:18',NULL,NULL),(22759,4276,'3512802','834','00','005010X220A1','3512802','','2014-03-06','16:22:01',0,'2014-03-06 21:00:36',NULL,NULL),(2473,428,'1250426','834','00','005010X220A1','1250426','','2013-12-06','11:58:12',0,'2013-12-25 20:19:38',NULL,NULL),(5982,1123,'1132347','834','00','005010X220A1','1132347','','2013-12-14','22:31:45',0,'2013-12-26 02:33:25',NULL,NULL),(3479,615,'857823','834','00','005010X220A1','857823','','2013-12-12','08:34:26',0,'2013-12-25 22:00:31',NULL,NULL),(4743,856,'184553','834','00','005010X220A1','184553','','2013-12-01','10:05:29',0,'2013-12-26 00:00:02',NULL,NULL),(7606,1303,'1143550','834','00','005010X220A1','1143550','','2013-12-21','13:02:29',0,'2013-12-26 04:37:27',NULL,NULL),(15789,2719,'2331600','834','00','005010X220A1','2331600','','2014-01-20','13:55:54',0,'2014-01-21 08:46:41',NULL,NULL),(15840,2737,'1757252','834','00','005010X220A1','1757252','','2014-01-21','13:11:08',1,'2014-01-22 03:22:03',NULL,NULL),(18062,3320,'2416027','834','00','005010X220A1','2416027','','2014-02-05','22:07:09',0,'2014-02-06 21:00:50',NULL,NULL),(20227,3786,'3249470','834','00','005010X220A1','3249470','','2014-02-19','15:53:22',0,'2014-02-20 04:25:20',NULL,NULL),(6275,1172,'1354643','834','00','005010X220A1','1354643','','2013-12-20','13:57:07',0,'2013-12-26 03:06:41',NULL,NULL),(14927,2559,'2522476','834','00','005010X220A1','2522476','','2014-01-14','18:27:23',0,'2014-01-15 02:07:41',NULL,NULL),(11715,1519,'2172281','834','00','005010X220A1','2172281','','2013-12-28','14:00:15',1,'2013-12-29 11:08:22',NULL,NULL),(10670,1403,'990596','834','00','005010X220A1','990596','','2013-12-22','19:56:15',0,'2013-12-26 12:59:25',NULL,NULL),(5512,1041,'1437277','834','00','005010X220A1','1437277','','2013-12-24','20:25:36',0,'2013-12-26 01:46:47',NULL,NULL),(607,108,'1276141','834','00','005010X220A1','1276141','','2013-12-15','19:10:36',0,'2013-12-25 18:03:49',NULL,NULL),(3831,679,'320174','834','00','005010X220A1','320174','','2013-11-07','19:14:01',0,'2013-12-25 22:30:02',NULL,NULL),(18675,3467,'3017761','834','00','005010X220A1','3017761','','2014-02-10','16:02:12',0,'2014-02-10 21:31:56',NULL,NULL),(19586,3629,'3396114','834','00','005010X220A1','3396114','','2014-02-14','14:27:15',0,'2014-02-14 21:31:27',NULL,NULL),(19608,3635,'3409368','834','00','005010X220A1','3409368','','2014-02-13','22:36:15',0,'2014-02-14 21:31:43',NULL,NULL),(67,3,'1261197','834','00','005010X220A1','1261197','','2013-12-05','17:09:19',0,'2013-12-25 17:17:01',NULL,NULL),(13859,2311,'2135532','834','00','005010X220A1','2135532','','2014-01-08','19:20:47',0,'2014-01-13 02:19:18',NULL,NULL),(99,4,'1195370','834','00','005010X220A1','1195370','','2013-12-05','17:34:25',0,'2013-12-25 17:18:00',NULL,NULL),(13797,2294,'1426597','834','00','005010X220A1','1426597','','2014-01-11','13:16:51',0,'2014-01-13 02:18:13',NULL,NULL),(13192,2036,'0001','999','BE','005010X231A1','119443','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:30',NULL,NULL),(1425,250,'1474023','834','00','005010X220A1','1474023','','2013-12-24','12:54:34',0,'2013-12-25 18:54:52',NULL,NULL),(16970,3116,'2218510','834','00','005010X220A1','2218510','','2014-01-29','16:08:35',0,'2014-01-29 21:00:36',NULL,NULL),(22482,4242,'3241066','834','00','005010X220A1','3241066','','2014-03-05','09:24:59',0,'2014-03-05 21:00:24',NULL,NULL),(23376,4397,'3752731','834','00','005010X220A1','3752731','','2014-03-08','15:05:49',0,'2014-03-08 21:31:17',NULL,NULL),(23656,4442,'3346071','834','00','005010X220A1','3346071','','2014-03-10','13:30:33',0,'2014-03-10 21:01:56',NULL,NULL),(23665,4444,'3093665','834','00','005010X220A1','3093665','','2014-03-10','12:59:50',0,'2014-03-10 21:02:01',NULL,NULL),(44,2,'544926','834','00','005010X220A1','544926','','2013-12-05','15:45:09',0,'2013-12-25 17:16:19',NULL,NULL),(1440,252,'1681637','834','00','005010X220A1','1681637','','2013-12-24','10:59:37',0,'2013-12-25 18:55:21',NULL,NULL),(11859,1554,'780615','834','00','005010X220A1','780615','','2013-12-28','20:27:28',1,'2013-12-29 11:15:07',NULL,NULL),(11426,1472,'2068790','834','00','005010X220A1','2068790','','2013-12-26','16:58:24',0,'2013-12-27 02:07:23',NULL,NULL),(10635,1402,'1780498','834','00','005010X220A1','1780498','','2013-12-23','16:37:25',0,'2013-12-26 12:58:20',NULL,NULL),(3183,570,'949387','834','00','005010X220A1','949387','','2013-12-13','14:05:18',0,'2013-12-25 21:38:58',NULL,NULL),(16195,2887,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 04:35:25',NULL,NULL),(17145,3144,'2624862','834','00','005010X220A1','2624862','','2014-01-30','12:37:13',0,'2014-01-30 21:00:34',NULL,NULL),(19136,3548,'3142304','834','00','005010X220A1','3142304','','2014-02-12','12:59:59',0,'2014-02-12 21:32:00',NULL,NULL),(22312,4201,'3744691','834','00','005010X220A1','3744691','','2014-03-04','14:30:51',0,'2014-03-04 21:01:07',NULL,NULL),(22417,4218,'2689110','834','00','005010X220A1','2689110','','2014-03-04','11:13:06',0,'2014-03-04 21:02:35',NULL,NULL),(1201,240,'1846719','834','00','005010X220A1','1846719','','2013-12-24','16:21:40',0,'2013-12-25 18:47:47',NULL,NULL),(1311,245,'130312','834','00','005010X220A1','130312','','2013-12-24','09:09:27',0,'2013-12-25 18:51:09',NULL,NULL),(13621,2270,'2307827','834','00','005010X220A1','2307827','','2014-01-07','12:31:40',0,'2014-01-08 18:23:58',NULL,NULL),(2106,360,'505965','834','00','005010X220A1','505965','','2013-12-01','18:46:05',0,'2013-12-25 19:45:04',NULL,NULL),(4021,731,'901377','834','00','005010X220A1','901377','','2013-12-19','13:04:02',0,'2013-12-25 23:00:46',NULL,NULL),(6447,1209,'1057930','834','00','005010X220A1','1057930','','2013-11-22','10:18:30',0,'2013-12-26 03:16:00',NULL,NULL),(17363,3181,'1509070','834','00','005010X220A1','1509070','','2014-01-31','17:13:43',0,'2014-01-31 21:01:26',NULL,NULL),(23063,4339,'3275563','834','00','005010X220A1','3275563','','2014-03-07','00:24:33',0,'2014-03-07 21:30:08',NULL,NULL),(6246,1171,'113679','834','00','005010X220A1','113679','','2013-12-19','19:13:29',0,'2013-12-26 03:05:47',NULL,NULL),(3107,546,'222043','834','00','005010X220A1','222043','','2013-12-13','13:40:15',0,'2013-12-25 21:36:22',NULL,NULL),(15439,2629,'1853212','834','00','005010X220A1','1853212','','2014-01-15','20:29:06',0,'2014-01-17 03:36:05',NULL,NULL),(4215,738,'1047077','834','00','005010X220A1','1047077','','2013-12-18','19:42:23',0,'2013-12-25 23:06:41',NULL,NULL),(14961,2567,'2518820','834','00','005010X220A1','2518820','','2014-01-14','08:46:46',0,'2014-01-15 02:07:57',NULL,NULL),(14484,2505,'0001','999','BE','005010X231A1','796827','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:55',NULL,NULL),(13219,2063,'0001','999','BE','005010X231A1','399465','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:45',NULL,NULL),(17777,3267,'1910475','834','00','005010X220A1','1910475','','2014-02-03','21:30:32',0,'2014-02-04 21:01:17',NULL,NULL),(21925,4128,'3535073','834','00','005010X220A1','3535073','','2014-03-01','09:43:55',0,'2014-03-01 21:00:46',NULL,NULL),(1211,243,'1537753','834','00','005010X220A1','1537753','','2013-12-24','07:56:12',0,'2013-12-25 18:48:06',NULL,NULL),(15537,2654,'1539760','834','00','005010X220A1','1539760','','2014-01-17','11:14:37',0,'2014-01-20 08:05:39',NULL,NULL),(14764,2551,'2096505','834','00','005010X220A1','2096505','','2014-01-14','10:12:33',0,'2014-01-15 02:06:30',NULL,NULL),(14449,2470,'0001','999','BE','005010X231A1','392138','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:23',NULL,NULL),(6029,1141,'386713','834','00','005010X220A1','386713','','2013-11-17','14:20:18',0,'2013-12-26 02:45:50',NULL,NULL),(13670,2271,'1747765','834','00','005010X220A1','1747765','','2014-01-07','11:55:58',0,'2014-01-08 18:24:17',NULL,NULL),(13369,2213,'0001','999','BE','005010X231A1','1117840','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:24',NULL,NULL),(12832,1704,'1771857','834','00','005010X220A1','1771857','','2014-01-03','11:26:32',0,'2014-01-04 02:02:24',NULL,NULL),(12444,1638,'1404616','834','00','005010X220A1','1404616','','2013-12-31','16:30:05',1,'2014-01-02 04:31:16',NULL,NULL),(11840,1544,'1167897','834','00','005010X220A1','1167897','','2013-12-28','20:07:23',1,'2013-12-29 11:14:24',NULL,NULL),(11542,1491,'2180352','834','00','005010X220A1','2180352','','2013-12-27','17:19:15',0,'2013-12-28 03:32:53',NULL,NULL),(11415,1469,'1444675','834','00','005010X220A1','1444675','','2013-12-26','11:06:01',0,'2013-12-27 02:07:02',NULL,NULL),(11328,1456,'2211264','834','00','005010X220A1','2211264','','2013-12-26','14:11:34',0,'2013-12-27 02:04:21',NULL,NULL),(19675,3662,'2887001','834','00','005010X220A1','2887001','','2014-02-14','17:06:30',0,'2014-02-14 22:00:07',NULL,NULL),(1230,243,'508298','834','00','005010X220A1','508298','','2013-12-24','09:54:26',0,'2013-12-25 18:48:41',NULL,NULL),(13095,1939,'0001','999','BE','005010X231A1','1169631','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:24',NULL,NULL),(1511,258,'1798131','834','00','005010X220A1','1798131','','2013-12-24','13:24:30',0,'2013-12-25 18:57:44',NULL,NULL),(6018,1137,'1190523','834','00','005010X220A1','1190523','','2013-11-16','19:51:44',0,'2013-12-26 02:45:29',NULL,NULL),(10830,1404,'892564','834','00','005010X220A1','892564','','2013-12-23','18:15:58',0,'2013-12-26 13:04:50',NULL,NULL),(5457,1040,'1544420','834','00','005010X220A1','1544420','','2013-12-24','18:20:15',0,'2013-12-26 01:45:02',NULL,NULL),(17589,3237,'2626250','834','00','005010X220A1','2626250','','2014-02-03','16:57:49',0,'2014-02-03 21:00:51',NULL,NULL),(18049,3319,'2788644','834','00','005010X220A1','2788644','','2014-02-06','12:14:43',0,'2014-02-06 21:00:41',NULL,NULL),(22182,4180,'3634663','834','00','005010X220A1','3634663','','2014-03-03','16:18:24',0,'2014-03-03 21:31:18',NULL,NULL),(23571,4436,'3532792','834','00','005010X220A1','3532792','','2014-03-10','13:10:40',0,'2014-03-10 21:00:56',NULL,NULL),(2949,541,'1255497','834','00','005010X220A1','1255497','','2013-12-13','10:09:45',0,'2013-12-25 21:31:32',NULL,NULL),(14127,2351,'1312527','834','00','005010X220A1','1312527','','2014-01-08','10:49:39',0,'2014-01-13 02:22:28',NULL,NULL),(16724,3064,'1785414','834','00','005010X220A1','1785414','','2014-01-27','17:14:18',0,'2014-01-27 21:01:00',NULL,NULL),(19408,3593,'2141587','834','00','005010X220A1','2141587','','2014-02-13','13:46:53',0,'2014-02-13 22:02:35',NULL,NULL),(13332,2176,'0001','999','BE','005010X231A1','154309','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:41',NULL,NULL),(12686,1673,'2135388','834','00','005010X220A1','2135388','','2014-01-02','15:48:38',0,'2014-01-03 02:04:11',NULL,NULL),(12423,1638,'1486346','834','00','005010X220A1','1486346','','2013-12-31','10:24:30',1,'2014-01-02 04:30:30',NULL,NULL),(7679,1323,'362110','834','00','005010X220A1','362110','','2013-12-21','12:50:09',0,'2013-12-26 04:39:47',NULL,NULL),(14498,2515,'2327492','834','00','005010X220A1','2327492','','2014-01-13','10:11:24',0,'2014-01-14 01:32:00',NULL,NULL),(14737,2550,'2452816','834','00','005010X220A1','2452816','','2014-01-14','15:25:54',0,'2014-01-15 02:06:18',NULL,NULL),(15248,2599,'1744446','834','00','005010X220A1','1744446','','2014-01-15','10:52:03',0,'2014-01-16 08:46:55',NULL,NULL),(15661,2684,'1656886','834','00','005010X220A1','1656886','','2014-01-18','15:20:51',0,'2014-01-21 08:44:32',NULL,NULL),(16064,2773,'1434247','834','00','005010X220A1','1434247','','2014-01-22','16:22:58',0,'2014-01-23 03:02:42',NULL,NULL),(16537,3020,'1576029','834','00','005010X220A1','1576029','','2014-01-24','16:47:17',0,'2014-01-24 21:01:05',NULL,NULL),(17899,3295,'2567688','834','00','005010X220A1','2567688','','2014-02-05','12:25:23',0,'2014-02-05 21:30:30',NULL,NULL),(18478,3430,'2614076','834','00','005010X220A1','2614076','','2014-02-10','03:56:19',0,'2014-02-10 11:00:58',NULL,NULL),(20024,3750,'2539650','834','00','005010X220A1','2539650','','2014-02-18','13:19:19',0,'2014-02-18 22:00:49',NULL,NULL),(20163,3778,'2417518','834','00','005010X220A1','2417518','','2014-02-18','22:04:54',0,'2014-02-20 04:07:40',NULL,NULL),(21872,4122,'3743241','834','00','005010X220A1','3743241','','2014-02-28','22:23:50',0,'2014-03-01 21:00:11',NULL,NULL),(22533,4247,'3780943','834','00','005010X220A1','3780943','','2014-03-05','16:36:31',0,'2014-03-05 21:30:30',NULL,NULL),(325,72,'211174','834','00','005010X220A1','211174','','2013-12-03','20:00:57',0,'2013-12-25 17:46:00',NULL,NULL),(13845,2311,'1622107','834','00','005010X220A1','1622107','','2014-01-08','22:03:57',0,'2014-01-13 02:19:08',NULL,NULL),(1223,243,'334639','834','00','005010X220A1','334639','','2013-12-24','09:09:05',0,'2013-12-25 18:48:29',NULL,NULL),(12906,1713,'1624583','834','00','005010X220A1','1624583','','2014-01-03','15:26:00',0,'2014-01-04 02:05:05',NULL,NULL),(1553,268,'1658776','834','00','005010X220A1','1658776','','2013-12-24','13:00:04',0,'2013-12-25 18:59:04',NULL,NULL),(2786,506,'371047','834','00','005010X220A1','371047','','2013-12-22','08:49:39',0,'2013-12-25 21:19:54',NULL,NULL),(4377,773,'394344','834','00','005010X220A1','394344','','2013-11-27','13:33:39',0,'2013-12-25 23:15:14',NULL,NULL),(7373,1290,'627600','834','00','005010X220A1','627600','','2013-11-30','13:28:23',0,'2013-12-26 04:16:20',NULL,NULL),(6348,1178,'173728','834','00','005010X220A1','173728','','2013-12-20','15:39:13',0,'2013-12-26 03:08:51',NULL,NULL),(6179,1167,'516623','834','00','005010X220A1','516623','','2013-12-20','16:23:16',0,'2013-12-26 03:03:40',NULL,NULL),(5537,1041,'1577576','834','00','005010X220A1','1577576','','2013-12-24','23:38:46',0,'2013-12-26 01:47:36',NULL,NULL),(14277,2376,'2530947','834','00','005010X220A1','2530947','','2014-01-09','20:29:11',0,'2014-01-13 03:00:14',NULL,NULL),(14888,2558,'2415501','834','00','005010X220A1','2415501','','2014-01-14','10:20:56',0,'2014-01-15 02:07:25',NULL,NULL),(18660,3467,'2789735','834','00','005010X220A1','2789735','','2014-02-10','08:56:41',0,'2014-02-10 21:31:46',NULL,NULL),(20401,3832,'3574431','834','00','005010X220A1','3574431','','2014-02-20','15:51:16',0,'2014-02-20 21:30:08',NULL,NULL),(22832,4278,'2774696','834','00','005010X220A1','2774696','','2014-03-06','16:50:52',0,'2014-03-06 21:01:26',NULL,NULL),(20638,3874,'2783948','834','00','005010X220A1','2783948','','2014-02-20','18:42:31',0,'2014-02-21 22:00:44',NULL,NULL),(1521,260,'89237','834','00','005010X220A1','89237','','2013-12-24','10:41:23',0,'2013-12-25 18:58:05',NULL,NULL),(2527,455,'1189197','834','00','005010X220A1','1189197','','2013-11-18','08:44:13',0,'2013-12-25 20:30:49',NULL,NULL),(14072,2340,'1569249','834','00','005010X220A1','1569249','','2014-01-08','14:09:51',0,'2014-01-13 02:21:51',NULL,NULL),(13476,2226,'2094105','834','00','005010X220A1','2094105','','2014-01-06','13:11:15',0,'2014-01-07 04:03:44',NULL,NULL),(13053,1897,'0001','999','BE','005010X231A1','647463','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:28',NULL,NULL),(12912,1714,'2034195','834','00','005010X220A1','2034195','','2014-01-03','11:49:18',0,'2014-01-04 02:05:20',NULL,NULL),(10643,1402,'508209','834','00','005010X220A1','508209','','2013-12-23','17:28:31',0,'2013-12-26 12:58:35',NULL,NULL),(4450,801,'437085','834','00','005010X220A1','437085','','2013-11-25','20:50:28',0,'2013-12-25 23:30:26',NULL,NULL),(6410,1197,'479578','834','00','005010X220A1','479578','','2013-12-20','17:54:00',0,'2013-12-26 03:10:51',NULL,NULL),(4518,814,'943675','834','00','005010X220A1','943675','','2013-11-26','14:23:15',0,'2013-12-25 23:32:41',NULL,NULL),(5661,1052,'671409','834','00','005010X220A1','671409','','2013-12-24','22:58:01',0,'2013-12-26 01:51:41',NULL,NULL),(5268,973,'82924','834','00','005010X220A1','82924','','2013-11-12','02:17:04',0,'2013-12-26 01:00:17',NULL,NULL),(4775,861,'1092010','834','00','005010X220A1','1092010','','2013-11-30','23:49:20',0,'2013-12-26 00:01:07',NULL,NULL),(15341,2622,'1941409','834','00','005010X220A1','1941409','','2014-01-15','20:00:07',0,'2014-01-17 03:35:19',NULL,NULL),(15740,2712,'2610185','834','00','005010X220A1','2610185','','2014-01-19','20:05:53',0,'2014-01-21 08:46:12',NULL,NULL),(19605,3634,'2858905','834','00','005010X220A1','2858905','','2014-02-13','19:43:20',0,'2014-02-14 21:31:41',NULL,NULL),(22240,4199,'2936391','834','00','005010X220A1','2936391','','2014-03-04','14:11:25',0,'2014-03-04 21:00:12',NULL,NULL),(22435,4230,'2916859','834','00','005010X220A1','2916859','','2014-03-03','19:44:25',0,'2014-03-04 21:30:06',NULL,NULL),(23125,4342,'2912112','834','00','005010X220A1','2912112','','2014-03-07','10:12:13',0,'2014-03-07 21:30:53',NULL,NULL),(1210,243,'905564','834','00','005010X220A1','905564','','2013-12-24','07:16:55',0,'2013-12-25 18:48:04',NULL,NULL),(14012,2337,'2558204','834','00','005010X220A1','2558204','','2014-01-07','21:36:39',0,'2014-01-13 02:21:13',NULL,NULL),(13896,2312,'1457283','834','00','005010X220A1','1457283','','2014-01-09','15:54:38',0,'2014-01-13 02:19:42',NULL,NULL),(3333,586,'1109320','834','00','005010X220A1','1109320','','2013-12-17','14:34:11',0,'2013-12-25 21:49:35',NULL,NULL),(3970,716,'768281','834','00','005010X220A1','768281','','2013-12-06','23:40:31',0,'2013-12-25 22:47:14',NULL,NULL),(4006,731,'939294','834','00','005010X220A1','939294','','2013-12-18','22:26:50',0,'2013-12-25 23:00:19',NULL,NULL),(5348,1003,'274813','834','00','005010X220A1','274813','','2013-11-25','13:23:45',0,'2013-12-26 01:15:47',NULL,NULL),(10440,1400,'1680054','834','00','005010X220A1','1680054','','2013-12-23','11:53:03',0,'2013-12-26 12:51:58',NULL,NULL),(7667,1317,'887677','834','00','005010X220A1','887677','','2013-12-21','15:58:57',0,'2013-12-26 04:39:23',NULL,NULL),(15939,2756,'2570038','834','00','005010X220A1','2570038','','2014-01-21','12:00:42',1,'2014-01-22 03:23:06',NULL,NULL),(17599,3240,'1564813','834','00','005010X220A1','1564813','','2014-02-03','11:46:01',0,'2014-02-03 21:00:58',NULL,NULL),(18726,3485,'3189019','834','00','005010X220A1','3189019','','2014-02-11','09:57:19',0,'2014-02-11 21:00:20',NULL,NULL),(19005,3539,'2303444','834','00','005010X220A1','2303444','','2014-02-11','18:36:51',0,'2014-02-12 21:30:29',NULL,NULL),(21315,4010,'3497439','834','00','005010X220A1','3497439','','2014-02-26','11:19:45',0,'2014-02-26 21:02:36',NULL,NULL),(21437,4027,'3091974','834','00','005010X220A1','3091974','','2014-02-27','12:31:01',0,'2014-02-28 06:30:53',NULL,NULL),(22081,4174,'3376412','834','00','005010X220A1','3376412','','2014-03-03','13:53:53',0,'2014-03-03 21:30:03',NULL,NULL),(22423,4221,'2623266','834','00','005010X220A1','2623266','','2014-03-04','13:53:16',0,'2014-03-04 21:02:40',NULL,NULL),(1802,305,'743177','834','00','005010X220A1','743177','','2013-12-10','15:54:53',0,'2013-12-25 19:19:42',NULL,NULL),(7402,1295,'1088465','834','00','005010X220A1','1088465','','2013-12-20','20:04:57',0,'2013-12-26 04:30:55',NULL,NULL),(7256,1246,'229828','834','00','005010X220A1','229828','','2013-12-18','13:01:05',0,'2013-12-26 04:08:23',NULL,NULL),(3201,578,'997043','834','00','005010X220A1','997043','','2013-12-16','21:13:57',0,'2013-12-25 21:45:18',NULL,NULL),(5215,951,'186984','834','00','005010X220A1','186984','','2013-12-10','20:28:15',0,'2013-12-26 00:52:51',NULL,NULL),(4906,906,'183091','834','00','005010X220A1','183091','','2013-10-23','02:41:28',0,'2013-12-26 00:30:20',NULL,NULL),(4884,892,'1208727','834','00','005010X220A1','1208727','','2013-11-21','15:29:40',0,'2013-12-26 00:16:44',NULL,NULL),(3966,716,'1156108','834','00','005010X220A1','1156108','','2013-12-07','12:32:07',0,'2013-12-25 22:47:07',NULL,NULL),(3918,712,'1268492','834','00','005010X220A1','1268492','','2013-12-07','13:00:16',0,'2013-12-25 22:45:35',NULL,NULL),(3497,615,'984254','834','00','005010X220A1','984254','','2013-12-12','13:45:21',0,'2013-12-25 22:01:05',NULL,NULL),(3460,611,'631760','834','00','005010X220A1','631760','','2013-12-17','13:41:24',0,'2013-12-25 21:53:38',NULL,NULL),(14077,2341,'1693772','834','00','005010X220A1','1693772','','2014-01-07','20:30:10',0,'2014-01-13 02:21:55',NULL,NULL),(16289,2980,'1442949','834','00','005010X220A1','1442949','','2014-01-22','18:58:39',0,'2014-01-23 21:00:04',NULL,NULL),(17051,3123,'2370619','834','00','005010X220A1','2370619','','2014-01-29','15:11:59',0,'2014-01-29 21:01:27',NULL,NULL),(17689,3259,'2443337','834','00','005010X220A1','2443337','','2014-02-04','17:31:16',0,'2014-02-04 21:00:23',NULL,NULL),(20893,3924,'2930141','834','00','005010X220A1','2930141','','2014-02-25','13:21:43',0,'2014-02-25 21:32:03',NULL,NULL),(21430,4027,'2671101','834','00','005010X220A1','2671101','','2014-02-27','09:41:06',0,'2014-02-28 06:30:49',NULL,NULL),(21782,4091,'3798853','834','00','005010X220A1','3798853','','2014-02-28','14:38:39',0,'2014-02-28 21:31:09',NULL,NULL),(22244,4200,'3052109','834','00','005010X220A1','3052109','','2014-03-03','18:02:48',0,'2014-03-04 21:00:15',NULL,NULL),(1705,292,'97384','834','00','005010X220A1','97384','','2013-12-10','11:35:05',0,'2013-12-25 19:16:39',NULL,NULL),(14389,2415,'1862428','834','00','005010X220A1','1862428','','2014-01-12','14:03:15',0,'2014-01-13 03:01:54',NULL,NULL),(14164,2363,'2277174','834','00','005010X220A1','2277174','','2014-01-10','11:23:45',0,'2014-01-13 02:23:15',NULL,NULL),(1822,312,'961958','834','00','005010X220A1','961958','','2013-12-10','15:54:56',0,'2013-12-25 19:20:19',NULL,NULL),(4874,887,'495033','834','00','005010X220A1','495033','','2013-11-21','10:24:51',0,'2013-12-26 00:16:22',NULL,NULL),(4732,846,'1908024','834','00','005010X220A1','1908024','','2013-12-24','01:12:55',0,'2013-12-25 23:51:49',NULL,NULL),(10784,1404,'294812','834','00','005010X220A1','294812','','2013-12-23','10:52:46',0,'2013-12-26 13:03:22',NULL,NULL),(7273,1253,'902493','834','00','005010X220A1','902493','','2013-12-18','08:52:55',0,'2013-12-26 04:08:54',NULL,NULL),(7170,1238,'1349361','834','00','005010X220A1','1349361','','2013-12-18','15:04:28',0,'2013-12-26 04:05:42',NULL,NULL),(16278,2970,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:28:00',0,'2014-01-23 14:00:02',NULL,NULL),(16821,3090,'1855625','834','00','005010X220A1','1855625','','2014-01-28','16:01:58',0,'2014-01-28 21:00:21',NULL,NULL),(17699,3261,'2789616','834','00','005010X220A1','2789616','','2014-02-03','19:43:11',0,'2014-02-04 21:00:30',NULL,NULL),(18025,3318,'1866710','834','00','005010X220A1','1866710','','2014-02-06','12:18:27',0,'2014-02-06 21:00:25',NULL,NULL),(19804,3677,'3228487','834','00','005010X220A1','3228487','','2014-02-15','16:11:16',0,'2014-02-15 22:01:26',NULL,NULL),(19983,3746,'3489682','834','00','005010X220A1','3489682','','2014-02-18','16:21:04',0,'2014-02-18 22:00:21',NULL,NULL),(20947,3949,'3157438','834','00','005010X220A1','3157438','','2014-02-23','22:56:22',0,'2014-02-26 08:00:39',NULL,NULL),(23208,4347,'3786030','834','00','005010X220A1','3786030','','2014-03-07','12:38:24',0,'2014-03-07 21:31:51',NULL,NULL),(4245,739,'447682','834','00','005010X220A1','447682','','2013-12-19','15:07:22',0,'2013-12-25 23:07:38',NULL,NULL),(13667,2271,'1858531','834','00','005010X220A1','1858531','','2014-01-07','11:42:47',0,'2014-01-08 18:24:16',NULL,NULL),(10602,1402,'158035','834','00','005010X220A1','158035','','2013-12-23','13:06:37',0,'2013-12-26 12:57:15',NULL,NULL),(3297,584,'499075','834','00','005010X220A1','499075','','2013-12-17','08:13:03',0,'2013-12-25 21:48:20',NULL,NULL),(16321,2982,'1832082','834','00','005010X220A1','1832082','','2014-01-23','08:47:48',0,'2014-01-23 21:00:29',NULL,NULL),(18968,3537,'2672057','834','00','005010X220A1','2672057','','2014-02-11','18:28:58',0,'2014-02-12 21:30:03',NULL,NULL),(19344,3583,'3419479','834','00','005010X220A1','3419479','','2014-02-13','16:02:39',0,'2014-02-13 22:01:48',NULL,NULL),(21092,3985,'3539507','834','00','005010X220A1','3539507','','2014-02-24','14:57:54',0,'2014-02-26 09:30:58',NULL,NULL),(21286,4005,'2633187','834','00','005010X220A1','2633187','','2014-02-26','13:04:38',0,'2014-02-26 21:02:14',NULL,NULL),(247,42,'19227','834','00','005010X220A1','19227','','2013-11-13','17:34:31',0,'2013-12-25 17:30:44',NULL,NULL),(6191,1167,'802518','834','00','005010X220A1','802518','','2013-12-20','17:53:20',0,'2013-12-26 03:04:02',NULL,NULL),(18124,3331,'1910554','834','00','005010X220A1','1910554','','2014-02-06','14:48:52',0,'2014-02-06 21:01:33',NULL,NULL),(22767,4277,'3391094','834','00','005010X220A1','3391094','','2014-03-05','18:21:30',0,'2014-03-06 21:00:42',NULL,NULL),(135,8,'374903','834','00','005010X220A1','374903','','2013-12-05','12:42:41',0,'2013-12-25 17:19:10',NULL,NULL),(14814,2552,'1691169','834','00','005010X220A1','1691169','','2014-01-14','12:13:57',0,'2014-01-15 02:06:50',NULL,NULL),(165,13,'1001772','834','00','005010X220A1','1001772','','2013-12-04','20:07:03',0,'2013-12-25 17:20:07',NULL,NULL),(234,39,'295098','834','00','005010X220A1','295098','','2013-10-12','12:21:04',0,'2013-12-25 17:30:21',NULL,NULL),(5078,936,'1147165','834','00','005010X220A1','1147165','','2013-12-11','18:13:15',0,'2013-12-26 00:48:29',NULL,NULL),(2857,512,'902764','834','00','005010X220A1','902764','','2013-12-22','14:01:55',0,'2013-12-25 21:22:14',NULL,NULL),(16048,2772,'1407342','834','00','005010X220A1','1407342','','2014-01-22','16:09:19',0,'2014-01-23 03:02:34',NULL,NULL),(16540,3020,'1467619','834','00','005010X220A1','1467619','','2014-01-24','13:05:38',0,'2014-01-24 21:01:06',NULL,NULL),(23265,4377,'3187625','834','00','005010X220A1','3187625','','2014-03-08','14:16:39',0,'2014-03-08 21:00:05',NULL,NULL),(23541,4435,'3441585','834','00','005010X220A1','3441585','','2014-03-10','12:48:13',0,'2014-03-10 21:00:32',NULL,NULL),(1281,243,'1488449','834','00','005010X220A1','1488449','','2013-12-24','17:03:36',0,'2013-12-25 18:50:12',NULL,NULL),(2199,365,'1158267','834','00','005010X220A1','1158267','','2013-12-01','19:36:47',0,'2013-12-25 19:48:09',NULL,NULL),(14783,2551,'1693966','834','00','005010X220A1','1693966','','2014-01-14','15:08:58',0,'2014-01-15 02:06:38',NULL,NULL),(15289,2615,'1624869','834','00','005010X220A1','1624869','','2014-01-15','11:20:44',0,'2014-01-16 08:47:24',NULL,NULL),(15451,2632,'1878072','834','00','005010X220A1','1878072','','2014-01-15','21:00:53',0,'2014-01-17 03:36:10',NULL,NULL),(19607,3635,'3321919','834','00','005010X220A1','3321919','','2014-02-13','22:24:46',0,'2014-02-14 21:31:42',NULL,NULL),(20544,3860,'3181604','834','00','005010X220A1','3181604','','2014-02-20','17:14:55',0,'2014-02-20 22:01:41',NULL,NULL),(10500,1400,'400218','834','00','005010X220A1','400218','','2013-12-23','18:12:21',0,'2013-12-26 12:53:53',NULL,NULL),(11141,1432,'479782','834','00','005010X220A1','479782','','2013-12-23','18:31:24',0,'2013-12-26 13:15:37',NULL,NULL),(16628,3051,'2533996','834','00','005010X220A1','2533996','','2014-01-26','17:57:35',0,'2014-01-26 19:00:23',NULL,NULL),(23093,4339,'2719314','834','00','005010X220A1','2719314','','2014-03-07','15:40:34',0,'2014-03-07 21:30:30',NULL,NULL),(23295,4381,'3229106','834','00','005010X220A1','3229106','','2014-03-07','18:22:18',0,'2014-03-08 21:30:16',NULL,NULL),(5977,1120,'701032','834','00','005010X220A1','701032','','2013-12-15','12:58:38',0,'2013-12-26 02:33:14',NULL,NULL),(14684,2549,'1653020','834','00','005010X220A1','1653020','','2014-01-14','02:00:04',0,'2014-01-15 02:05:55',NULL,NULL),(1291,244,'1829772','834','00','005010X220A1','1829772','','2013-12-24','07:52:42',0,'2013-12-25 18:50:30',NULL,NULL),(2753,505,'985833','834','00','005010X220A1','985833','','2013-12-21','18:46:24',0,'2013-12-25 21:18:50',NULL,NULL),(13504,2232,'2564502','834','00','005010X220A1','2564502','','2014-01-05','19:11:02',0,'2014-01-07 04:04:50',NULL,NULL),(11108,1426,'1406370','834','00','005010X220A1','1406370','','2013-12-22','22:01:01',0,'2013-12-26 13:14:21',NULL,NULL),(2158,362,'746482','834','00','005010X220A1','746482','','2013-12-01','19:58:59',0,'2013-12-25 19:46:43',NULL,NULL),(16181,2873,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:08:00',1,'2014-01-23 04:21:47',NULL,NULL),(18687,3472,'2839158','834','00','005010X220A1','2839158','','2014-02-10','13:24:01',0,'2014-02-10 21:32:04',NULL,NULL),(19433,3601,'3212746','834','00','005010X220A1','3212746','','2014-02-13','17:20:19',0,'2014-02-13 22:02:54',NULL,NULL),(19452,3608,'2423516','834','00','005010X220A1','2423516','','2014-02-13','12:48:29',0,'2014-02-13 22:03:09',NULL,NULL),(20929,3936,'3350273','834','00','005010X220A1','3350273','','2014-02-23','17:52:05',0,'2014-02-26 08:00:24',NULL,NULL),(21691,4087,'2737726','834','00','005010X220A1','2737726','','2014-02-27','18:46:27',0,'2014-02-28 21:30:04',NULL,NULL),(3715,635,'43047','834','00','005010X220A1','43047','','2013-12-12','08:27:49',0,'2013-12-25 22:08:02',NULL,NULL),(14820,2552,'2396826','834','00','005010X220A1','2396826','','2014-01-14','15:56:59',0,'2014-01-15 02:06:53',NULL,NULL),(14038,2337,'1739068','834','00','005010X220A1','1739068','','2014-01-08','15:48:49',0,'2014-01-13 02:21:29',NULL,NULL),(6324,1175,'642893','834','00','005010X220A1','642893','','2013-12-20','15:01:43',0,'2013-12-26 03:08:07',NULL,NULL),(13231,2075,'0001','999','BE','005010X231A1','461156','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:18',NULL,NULL),(11950,1580,'1688304','834','00','005010X220A1','1688304','','2013-12-29','21:52:39',0,'2014-01-01 12:00:11',NULL,NULL),(11901,1562,'1720781','834','00','005010X220A1','1720781','','2013-12-28','18:20:28',0,'2013-12-30 00:01:03',NULL,NULL),(10675,1403,'333174','834','00','005010X220A1','333174','','2013-12-22','20:06:02',0,'2013-12-26 12:59:35',NULL,NULL),(15757,2714,'1885686','834','00','005010X220A1','1885686','','2014-01-20','11:17:03',0,'2014-01-21 08:46:22',NULL,NULL),(15973,2764,'1976174','834','00','005010X220A1','1976174','','2014-01-21','18:52:25',0,'2014-01-23 03:02:00',NULL,NULL),(16318,2981,'2027907','834','00','005010X220A1','2027907','','2014-01-22','18:42:41',0,'2014-01-23 21:00:26',NULL,NULL),(18206,3356,'2345566','834','00','005010X220A1','2345566','','2014-02-06','18:47:05',0,'2014-02-07 19:00:38',NULL,NULL),(19035,3540,'2406154','834','00','005010X220A1','2406154','','2014-02-12','13:14:27',0,'2014-02-12 21:30:51',NULL,NULL),(20371,3822,'2911574','834','00','005010X220A1','2911574','','2014-02-19','11:20:34',0,'2014-02-20 05:33:40',NULL,NULL),(20545,3861,'3366523','834','00','005010X220A1','3366523','','2014-02-20','21:53:18',0,'2014-02-21 21:30:02',NULL,NULL),(1265,243,'53997','834','00','005010X220A1','53997','','2013-12-24','14:22:50',0,'2013-12-25 18:49:39',NULL,NULL),(5077,936,'624039','834','00','005010X220A1','624039','','2013-12-11','17:49:13',0,'2013-12-26 00:48:27',NULL,NULL),(14216,2366,'1592797','834','00','005010X220A1','1592797','','2014-01-09','19:29:52',0,'2014-01-13 02:23:54',NULL,NULL),(11281,1455,'334769','834','00','005010X220A1','334769','','2013-12-26','13:36:57',0,'2013-12-27 02:02:56',NULL,NULL),(12646,1672,'2524929','834','00','005010X220A1','2524929','','2014-01-02','09:54:16',0,'2014-01-03 02:02:46',NULL,NULL),(23521,4434,'3698075','834','00','005010X220A1','3698075','','2014-03-10','15:42:11',0,'2014-03-10 21:00:17',NULL,NULL),(4015,731,'83667','834','00','005010X220A1','83667','','2013-12-19','10:58:27',0,'2013-12-25 23:00:35',NULL,NULL),(10654,1402,'1556234','834','00','005010X220A1','1556234','','2013-12-23','18:25:47',0,'2013-12-26 12:58:56',NULL,NULL),(10901,1409,'74628','834','00','005010X220A1','74628','','2013-12-23','11:28:10',0,'2013-12-26 13:07:40',NULL,NULL),(12404,1637,'1818474','834','00','005010X220A1','1818474','','2013-12-31','13:55:13',1,'2014-01-02 04:29:47',NULL,NULL),(11492,1489,'1513158','834','00','005010X220A1','1513158','','2013-12-26','19:54:03',0,'2013-12-28 03:31:25',NULL,NULL),(22102,4176,'3742023','834','00','005010X220A1','3742023','','2014-03-03','17:53:36',0,'2014-03-03 21:30:20',NULL,NULL),(22350,4205,'3246100','834','00','005010X220A1','3246100','','2014-03-03','18:37:51',0,'2014-03-04 21:01:38',NULL,NULL),(229,35,'274542','834','00','005010X220A1','274542','','2013-10-12','13:34:31',0,'2013-12-25 17:30:11',NULL,NULL),(14300,2384,'2064231','834','00','005010X220A1','2064231','','2014-01-10','14:20:53',0,'2014-01-13 03:00:29',NULL,NULL),(2570,471,'568869','834','00','005010X220A1','568869','','2013-10-02','18:06:45',0,'2013-12-25 20:32:15',NULL,NULL),(13470,2226,'1574193','834','00','005010X220A1','1574193','','2014-01-06','10:16:32',0,'2014-01-07 04:03:29',NULL,NULL),(12680,1673,'1383315','834','00','005010X220A1','1383315','','2014-01-02','11:49:13',0,'2014-01-03 02:03:59',NULL,NULL),(7608,1303,'1258065','834','00','005010X220A1','1258065','','2013-12-21','13:30:32',0,'2013-12-26 04:37:31',NULL,NULL),(3106,546,'1263947','834','00','005010X220A1','1263947','','2013-12-13','13:40:10',0,'2013-12-25 21:36:21',NULL,NULL),(7159,1238,'886456','834','00','005010X220A1','886456','','2013-12-17','21:59:12',0,'2013-12-26 04:05:22',NULL,NULL),(16342,2983,'1678209','834','00','005010X220A1','1678209','','2014-01-23','18:21:02',0,'2014-01-23 21:00:43',NULL,NULL),(16408,2994,'2308258','834','00','005010X220A1','2308258','','2014-01-23','12:35:10',0,'2014-01-23 21:01:28',NULL,NULL),(16502,3011,'2132331','834','00','005010X220A1','2132331','','2014-01-24','17:27:57',0,'2014-01-24 21:00:42',NULL,NULL),(17812,3273,'1555974','834','00','005010X220A1','1555974','','2014-02-04','12:59:04',0,'2014-02-04 21:01:41',NULL,NULL),(7006,1235,'697516','834','00','005010X220A1','697516','','2013-12-17','21:35:35',0,'2013-12-26 04:00:41',NULL,NULL),(14688,2549,'1732212','834','00','005010X220A1','1732212','','2014-01-14','10:23:49',0,'2014-01-15 02:05:56',NULL,NULL),(1691,291,'1303775','834','00','005010X220A1','1303775','','2013-12-10','16:46:24',0,'2013-12-25 19:16:13',NULL,NULL),(13784,2291,'1809628','834','00','005010X220A1','1809628','','2014-01-07','15:48:29',0,'2014-01-08 18:25:08',NULL,NULL),(4240,739,'1058570','834','00','005010X220A1','1058570','','2013-12-18','21:09:30',0,'2013-12-25 23:07:29',NULL,NULL),(20743,3903,'2849239','834','00','005010X220A1','2849239','','2014-02-25','12:20:39',0,'2014-02-25 21:30:13',NULL,NULL),(21590,4057,'2673683','834','00','005010X220A1','2673683','','2014-02-26','12:22:33',0,'2014-02-28 07:00:32',NULL,NULL),(4735,849,'1489623','834','00','005010X220A1','1489623','','2013-12-23','23:36:58',0,'2013-12-25 23:51:57',NULL,NULL),(3525,616,'19628','834','00','005010X220A1','19628','','2013-12-11','18:40:38',0,'2013-12-25 22:01:58',NULL,NULL),(12161,1593,'1601290','834','00','005010X220A1','1601290','','2013-12-30','09:40:32',0,'2014-01-01 12:07:48',NULL,NULL),(11302,1456,'859793','834','00','005010X220A1','859793','','2013-12-26','01:34:44',0,'2013-12-27 02:03:34',NULL,NULL),(11280,1455,'1818334','834','00','005010X220A1','1818334','','2013-12-26','13:27:08',0,'2013-12-27 02:02:53',NULL,NULL),(19997,3748,'2803226','834','00','005010X220A1','2803226','','2014-02-18','09:57:59',0,'2014-02-18 22:00:31',NULL,NULL),(17845,3290,'2890399','834','00','005010X220A1','2890399','','2014-02-05','15:47:25',0,'2014-02-05 21:00:07',NULL,NULL),(18716,3485,'2490727','834','00','005010X220A1','2490727','','2014-02-10','20:46:55',0,'2014-02-11 21:00:12',NULL,NULL),(20754,3903,'3145216','834','00','005010X220A1','3145216','','2014-02-25','15:15:44',0,'2014-02-25 21:30:23',NULL,NULL),(22942,4298,'3520540','834','00','005010X220A1','3520540','','2014-03-06','16:59:59',0,'2014-03-06 21:02:47',NULL,NULL),(23077,4339,'3417472','834','00','005010X220A1','3417472','','2014-03-07','11:34:21',0,'2014-03-07 21:30:18',NULL,NULL),(875,177,'524361','834','00','005010X220A1','524361','','2013-12-03','07:01:26',0,'2013-12-25 18:16:27',NULL,NULL),(15234,2598,'1975996','834','00','005010X220A1','1975996','','2014-01-14','21:55:11',0,'2014-01-16 08:46:47',NULL,NULL),(14376,2407,'2206310','834','00','005010X220A1','2206310','','2014-01-12','11:07:00',0,'2014-01-13 03:01:45',NULL,NULL),(12837,1704,'1719800','834','00','005010X220A1','1719800','','2014-01-03','14:09:44',0,'2014-01-04 02:02:35',NULL,NULL),(10530,1401,'53853','834','00','005010X220A1','53853','','2013-12-23','12:50:48',0,'2013-12-26 12:54:49',NULL,NULL),(12077,1586,'1791990','834','00','005010X220A1','1791990','','2013-12-30','13:23:36',0,'2014-01-01 12:04:56',NULL,NULL),(11911,1565,'1791953','834','00','005010X220A1','1791953','','2013-12-28','19:10:36',0,'2013-12-30 00:01:23',NULL,NULL),(20900,3927,'3697591','834','00','005010X220A1','3697591','','2014-02-25','16:24:29',0,'2014-02-25 21:32:08',NULL,NULL),(23297,4381,'3059451','834','00','005010X220A1','3059451','','2014-03-07','21:46:05',0,'2014-03-08 21:30:18',NULL,NULL),(1035,198,'231528','834','00','005010X220A1','231528','','2013-12-03','11:49:27',0,'2013-12-25 18:21:23',NULL,NULL),(14074,2341,'1748928','834','00','005010X220A1','1748928','','2014-01-07','19:24:23',0,'2014-01-13 02:21:52',NULL,NULL),(1109,236,'639279','834','00','005010X220A1','639279','','2013-10-09','09:49:45',0,'2013-12-25 18:32:24',NULL,NULL),(13096,1940,'0001','999','BE','005010X231A1','654131','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:27',NULL,NULL),(1399,247,'1475255','834','00','005010X220A1','1475255','','2013-12-24','05:40:34',0,'2013-12-25 18:54:01',NULL,NULL),(7038,1235,'1131215','834','00','005010X220A1','1131215','','2013-12-18','14:32:43',0,'2013-12-26 04:01:42',NULL,NULL),(11571,1492,'1315127','834','00','005010X220A1','1315127','','2013-12-27','14:39:41',0,'2013-12-28 03:33:52',NULL,NULL),(5726,1069,'739750','834','00','005010X220A1','739750','','2013-12-14','14:38:03',0,'2013-12-26 02:01:11',NULL,NULL),(5531,1041,'1986639','834','00','005010X220A1','1986639','','2013-12-24','23:05:28',0,'2013-12-26 01:47:24',NULL,NULL),(4645,827,'1016917','834','00','005010X220A1','1016917','','2013-12-24','00:20:37',0,'2013-12-25 23:48:43',NULL,NULL),(3187,573,'1050963','834','00','005010X220A1','1050963','','2013-12-13','15:05:29',0,'2013-12-25 21:39:06',NULL,NULL),(2245,375,'938756','834','00','005010X220A1','938756','','2013-12-02','17:26:59',0,'2013-12-25 19:49:44',NULL,NULL),(18229,3359,'2429990','834','00','005010X220A1','2429990','','2014-02-07','16:39:26',0,'2014-02-07 19:00:56',NULL,NULL),(18920,3516,'2721023','834','00','005010X220A1','2721023','','2014-02-11','16:12:32',0,'2014-02-11 21:02:54',NULL,NULL),(21844,4109,'2871006','834','00','005010X220A1','2871006','','2014-02-28','15:10:04',0,'2014-02-28 21:31:55',NULL,NULL),(22366,4205,'3693493','834','00','005010X220A1','3693493','','2014-03-04','15:20:43',0,'2014-03-04 21:01:51',NULL,NULL),(454,83,'805536','834','00','005010X220A1','805536','','2013-12-04','00:09:07',0,'2013-12-25 17:50:06',NULL,NULL),(13931,2317,'2463136','834','00','005010X220A1','2463136','','2014-01-09','10:24:13',0,'2014-01-13 02:20:07',NULL,NULL),(4497,804,'965382','834','00','005010X220A1','965382','','2013-11-26','13:55:38',0,'2013-12-25 23:31:57',NULL,NULL),(15144,2588,'1912964','834','00','005010X220A1','1912964','','2014-01-14','23:26:14',0,'2014-01-16 08:45:50',NULL,NULL),(13479,2226,'1586750','834','00','005010X220A1','1586750','','2014-01-06','16:31:39',0,'2014-01-07 04:03:52',NULL,NULL),(4050,731,'448775','834','00','005010X220A1','448775','','2013-12-19','18:03:55',0,'2013-12-25 23:01:40',NULL,NULL),(1574,277,'1144070','834','00','005010X220A1','1144070','','2013-11-19','23:31:23',0,'2013-12-25 19:00:25',NULL,NULL),(2448,422,'558226','834','00','005010X220A1','558226','','2013-12-05','21:46:37',0,'2013-12-25 20:18:48',NULL,NULL),(17241,3166,'2639581','834','00','005010X220A1','2639581','','2014-01-30','14:23:42',0,'2014-01-30 21:01:37',NULL,NULL),(19415,3595,'2946145','834','00','005010X220A1','2946145','','2014-02-13','08:35:02',0,'2014-02-13 22:02:40',NULL,NULL),(21482,4028,'2642711','834','00','005010X220A1','2642711','','2014-02-27','16:00:13',0,'2014-02-28 06:31:13',NULL,NULL),(22820,4278,'2920528','834','00','005010X220A1','2920528','','2014-03-06','12:33:02',0,'2014-03-06 21:01:18',NULL,NULL),(7303,1262,'488293','834','00','005010X220A1','488293','','2013-12-18','12:46:37',0,'2013-12-26 04:09:48',NULL,NULL),(15166,2588,'2241674','834','00','005010X220A1','2241674','','2014-01-15','18:12:54',0,'2014-01-16 08:46:04',NULL,NULL),(261,49,'1185584','834','00','005010X220A1','1185584','','2013-11-12','21:08:00',0,'2013-12-25 17:31:15',NULL,NULL),(13321,2165,'0001','999','BE','005010X231A1','717888','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:10',NULL,NULL),(11907,1564,'1672562','834','00','005010X220A1','1672562','','2013-12-28','19:01:50',0,'2013-12-30 00:01:15',NULL,NULL),(15747,2713,'1386166','834','00','005010X220A1','1386166','','2014-01-19','19:16:53',0,'2014-01-21 08:46:16',NULL,NULL),(20416,3834,'2568098','834','00','005010X220A1','2568098','','2014-02-20','14:25:27',0,'2014-02-20 21:30:16',NULL,NULL),(20643,3874,'3077399','834','00','005010X220A1','3077399','','2014-02-21','17:00:55',0,'2014-02-21 22:00:47',NULL,NULL),(21812,4093,'3692134','834','00','005010X220A1','3692134','','2014-02-28','00:15:07',0,'2014-02-28 21:31:29',NULL,NULL),(1058,207,'1236325','834','00','005010X220A1','1236325','','2013-11-29','09:39:39',0,'2013-12-25 18:30:31',NULL,NULL),(15274,2607,'2399371','834','00','005010X220A1','2399371','','2014-01-15','14:50:44',0,'2014-01-16 08:47:14',NULL,NULL),(14805,2551,'2232012','834','00','005010X220A1','2232012','','2014-01-14','18:36:30',0,'2014-01-15 02:06:46',NULL,NULL),(13885,2312,'2564606','834','00','005010X220A1','2564606','','2014-01-09','16:38:00',0,'2014-01-13 02:19:36',NULL,NULL),(4456,801,'173076','834','00','005010X220A1','173076','','2013-11-26','08:38:29',0,'2013-12-25 23:30:37',NULL,NULL),(4066,732,'1188963','834','00','005010X220A1','1188963','','2013-12-19','11:28:09',0,'2013-12-25 23:02:12',NULL,NULL),(11895,1561,'1359199','834','00','005010X220A1','1359199','','2013-12-29','11:25:52',0,'2013-12-30 00:00:51',NULL,NULL),(10706,1403,'1252235','834','00','005010X220A1','1252235','','2013-12-23','11:07:41',0,'2013-12-26 13:00:44',NULL,NULL),(2153,361,'157208','834','00','005010X220A1','157208','','2013-12-02','15:35:51',0,'2013-12-25 19:46:34',NULL,NULL),(2877,520,'1073485','834','00','005010X220A1','1073485','','2013-12-22','09:50:29',0,'2013-12-25 21:22:52',NULL,NULL),(16933,3115,'1623740','834','00','005010X220A1','1623740','','2014-01-28','23:12:19',0,'2014-01-29 21:00:12',NULL,NULL),(21876,4122,'2836454','834','00','005010X220A1','2836454','','2014-03-01','11:18:04',0,'2014-03-01 21:00:14',NULL,NULL),(3901,711,'1268478','834','00','005010X220A1','1268478','','2013-12-06','18:15:19',0,'2013-12-25 22:45:02',NULL,NULL),(14283,2377,'1864737','834','00','005010X220A1','1864737','','2014-01-10','17:14:33',0,'2014-01-13 03:00:17',NULL,NULL),(674,109,'944102','834','00','005010X220A1','944102','','2013-12-16','10:58:37',0,'2013-12-25 18:05:54',NULL,NULL),(13481,2226,'2096295','834','00','005010X220A1','2096295','','2014-01-06','16:42:48',0,'2014-01-07 04:03:57',NULL,NULL),(3696,633,'898265','834','00','005010X220A1','898265','','2013-12-12','11:54:26',0,'2013-12-25 22:07:22',NULL,NULL),(12538,1649,'2255214','834','00','005010X220A1','2255214','','2013-12-31','10:04:11',1,'2014-01-02 04:34:46',NULL,NULL),(16524,3017,'2424515','834','00','005010X220A1','2424515','','2014-01-23','20:13:08',0,'2014-01-24 21:00:57',NULL,NULL),(19788,3675,'2390758','834','00','005010X220A1','2390758','','2014-02-15','17:11:58',0,'2014-02-15 22:01:12',NULL,NULL),(20873,3916,'2352889','834','00','005010X220A1','2352889','','2014-02-25','17:35:33',0,'2014-02-25 21:31:48',NULL,NULL),(21330,4022,'3242096','834','00','005010X220A1','3242096','','2014-02-26','18:00:48',0,'2014-02-28 06:30:03',NULL,NULL),(22242,4199,'2761792','834','00','005010X220A1','2761792','','2014-03-04','15:44:01',0,'2014-03-04 21:00:14',NULL,NULL),(22344,4204,'3176943','834','00','005010X220A1','3176943','','2014-03-04','10:34:24',0,'2014-03-04 21:01:32',NULL,NULL),(22515,4247,'3502900','834','00','005010X220A1','3502900','','2014-03-05','12:14:30',0,'2014-03-05 21:30:17',NULL,NULL),(23511,4434,'3900635','834','00','005010X220A1','3900635','','2014-03-10','13:17:21',0,'2014-03-10 21:00:11',NULL,NULL),(402,76,'245016','834','00','005010X220A1','245016','','2013-12-04','13:48:45',0,'2013-12-25 17:48:25',NULL,NULL),(2581,473,'165244','834','00','005010X220A1','165244','','2013-11-01','10:04:34',0,'2013-12-25 20:45:21',NULL,NULL),(3825,673,'99959','834','00','005010X220A1','99959','','2013-12-08','14:42:48',0,'2013-12-25 22:17:15',NULL,NULL),(17986,3310,'2617757','834','00','005010X220A1','2617757','','2014-02-05','11:12:43',0,'2014-02-05 21:31:14',NULL,NULL),(21348,4022,'3744552','834','00','005010X220A1','3744552','','2014-02-27','15:04:37',0,'2014-02-28 06:30:11',NULL,NULL),(7378,1293,'1146234','834','00','005010X220A1','1146234','','2013-12-20','19:40:53',0,'2013-12-26 04:30:06',NULL,NULL),(15161,2588,'2473785','834','00','005010X220A1','2473785','','2014-01-15','15:26:34',0,'2014-01-16 08:46:01',NULL,NULL),(884,177,'235068','834','00','005010X220A1','235068','','2013-12-03','09:23:45',0,'2013-12-25 18:16:41',NULL,NULL),(14560,2519,'1801046','834','00','005010X220A1','1801046','','2014-01-13','12:27:23',0,'2014-01-14 01:32:41',NULL,NULL),(13996,2329,'2383808','834','00','005010X220A1','2383808','','2014-01-09','13:55:26',0,'2014-01-13 02:20:54',NULL,NULL),(1443,252,'1780591','834','00','005010X220A1','1780591','','2013-12-24','11:06:18',0,'2013-12-25 18:55:29',NULL,NULL),(12806,1703,'1557660','834','00','005010X220A1','1557660','','2014-01-03','15:32:34',0,'2014-01-04 02:01:27',NULL,NULL),(5158,944,'1093374','834','00','005010X220A1','1093374','','2013-12-11','09:09:02',0,'2013-12-26 00:51:02',NULL,NULL),(4690,833,'1597188','834','00','005010X220A1','1597188','','2013-12-24','00:54:34',0,'2013-12-25 23:50:18',NULL,NULL),(11396,1464,'1145223','834','00','005010X220A1','1145223','','2013-12-26','10:01:53',0,'2013-12-27 02:06:25',NULL,NULL),(16309,2980,'1533885','834','00','005010X220A1','1533885','','2014-01-23','12:26:48',0,'2014-01-23 21:00:20',NULL,NULL),(19192,3571,'3360537','834','00','005010X220A1','3360537','','2014-02-13','00:26:13',0,'2014-02-13 21:30:08',NULL,NULL),(7319,1268,'1010681','834','00','005010X220A1','1010681','','2013-12-18','12:22:51',0,'2013-12-26 04:10:17',NULL,NULL),(14379,2407,'2090603','834','00','005010X220A1','2090603','','2014-01-12','17:51:22',0,'2014-01-13 03:01:47',NULL,NULL),(14142,2355,'2351720','834','00','005010X220A1','2351720','','2014-01-08','17:16:31',0,'2014-01-13 02:22:37',NULL,NULL),(13377,2221,'1632101','834','00','005010X220A1','1632101','','2014-01-06','12:01:25',0,'2014-01-07 04:00:02',NULL,NULL),(5131,943,'1258969','834','00','005010X220A1','1258969','','2013-12-11','08:41:17',0,'2013-12-26 00:50:16',NULL,NULL),(3872,694,'111502','834','00','005010X220A1','111502','','2013-10-10','03:56:01',0,'2013-12-25 22:31:16',NULL,NULL),(3321,585,'833144','834','00','005010X220A1','833144','','2013-12-16','19:24:13',0,'2013-12-25 21:49:14',NULL,NULL),(18689,3474,'3107540','834','00','005010X220A1','3107540','','2014-02-10','12:15:51',0,'2014-02-10 21:32:06',NULL,NULL),(19554,3626,'2246767','834','00','005010X220A1','2246767','','2014-02-14','00:29:39',0,'2014-02-14 21:31:04',NULL,NULL),(19629,3642,'2727084','834','00','005010X220A1','2727084','','2014-02-13','23:18:46',0,'2014-02-14 21:31:59',NULL,NULL),(21619,4065,'3468010','834','00','005010X220A1','3468010','','2014-02-27','13:06:31',0,'2014-02-28 07:30:18',NULL,NULL),(415,77,'1238949','834','00','005010X220A1','1238949','','2013-12-03','19:45:36',0,'2013-12-25 17:48:51',NULL,NULL),(13183,2027,'0001','999','BE','005010X231A1','669242','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:05',NULL,NULL),(1204,241,'458223','834','00','005010X220A1','458223','','2013-12-24','16:23:24',0,'2013-12-25 18:47:54',NULL,NULL),(11925,1566,'1835409','834','00','005010X220A1','1835409','','2013-12-29','08:43:00',0,'2013-12-30 00:01:46',NULL,NULL),(1495,256,'191757','834','00','005010X220A1','191757','','2013-12-24','11:43:20',0,'2013-12-25 18:57:13',NULL,NULL),(3922,712,'477801','834','00','005010X220A1','477801','','2013-12-07','16:32:55',0,'2013-12-25 22:45:41',NULL,NULL),(17412,3199,'1664630','834','00','005010X220A1','1664630','','2014-02-01','14:50:48',0,'2014-02-01 19:00:17',NULL,NULL),(19454,3608,'2742541','834','00','005010X220A1','2742541','','2014-02-13','16:42:19',0,'2014-02-13 22:03:10',NULL,NULL),(22878,4281,'3852210','834','00','005010X220A1','3852210','','2014-03-06','15:34:32',0,'2014-03-06 21:02:00',NULL,NULL),(7501,1300,'740059','834','00','005010X220A1','740059','','2013-12-20','22:43:12',0,'2013-12-26 04:34:06',NULL,NULL),(15954,2763,'1444316','834','00','005010X220A1','1444316','','2014-01-22','11:23:48',0,'2014-01-23 03:01:52',NULL,NULL),(14477,2498,'0001','999','BE','005010X231A1','534285','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:49',NULL,NULL),(4673,831,'1612615','834','00','005010X220A1','1612615','','2013-12-23','23:12:28',0,'2013-12-25 23:49:39',NULL,NULL),(12748,1690,'1846964','834','00','005010X220A1','1846964','','2014-01-02','16:27:57',0,'2014-01-03 02:06:37',NULL,NULL),(10911,1410,'112574','834','00','005010X220A1','112574','','2013-12-22','19:56:15',0,'2013-12-26 13:08:00',NULL,NULL),(18836,3490,'1899527','834','00','005010X220A1','1899527','','2014-02-11','15:05:03',0,'2014-02-11 21:01:41',NULL,NULL),(18894,3500,'3207603','834','00','005010X220A1','3207603','','2014-02-11','09:08:04',0,'2014-02-11 21:02:30',NULL,NULL),(18901,3503,'2724756','834','00','005010X220A1','2724756','','2014-02-11','15:35:51',0,'2014-02-11 21:02:37',NULL,NULL),(5221,952,'835765','834','00','005010X220A1','835765','','2013-12-11','12:21:26',0,'2013-12-26 00:53:04',NULL,NULL),(16341,2983,'1734749','834','00','005010X220A1','1734749','','2014-01-23','16:50:50',0,'2014-01-23 21:00:43',NULL,NULL),(15822,2736,'2401917','834','00','005010X220A1','2401917','','2014-01-20','18:35:09',1,'2014-01-22 03:21:51',NULL,NULL),(15183,2591,'2500280','834','00','005010X220A1','2500280','','2014-01-15','17:06:57',0,'2014-01-16 08:46:15',NULL,NULL),(5027,935,'706017','834','00','005010X220A1','706017','','2013-12-11','12:21:09',0,'2013-12-26 00:46:50',NULL,NULL),(13921,2314,'2522305','834','00','005010X220A1','2522305','','2014-01-08','20:48:42',0,'2014-01-13 02:19:58',NULL,NULL),(3195,578,'109942','834','00','005010X220A1','109942','','2013-12-16','19:04:43',0,'2013-12-25 21:45:09',NULL,NULL),(4582,826,'29414','834','00','005010X220A1','29414','','2013-12-23','22:29:27',0,'2013-12-25 23:46:41',NULL,NULL),(3690,633,'754957','834','00','005010X220A1','754957','','2013-12-12','04:03:17',0,'2013-12-25 22:07:10',NULL,NULL),(4495,804,'764583','834','00','005010X220A1','764583','','2013-11-26','16:05:59',0,'2013-12-25 23:31:54',NULL,NULL),(16110,2802,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:56:00',1,'2014-01-23 03:43:33',NULL,NULL),(19066,3542,'3027913','834','00','005010X220A1','3027913','','2014-02-12','15:44:37',0,'2014-02-12 21:31:13',NULL,NULL),(6057,1162,'719120','834','00','005010X220A1','719120','','2013-11-10','11:14:13',0,'2013-12-26 02:46:49',NULL,NULL),(16069,2773,'2409616','834','00','005010X220A1','2409616','','2014-01-22','17:47:28',0,'2014-01-23 03:02:44',NULL,NULL),(14115,2347,'2327387','834','00','005010X220A1','2327387','','2014-01-07','22:47:56',0,'2014-01-13 02:22:20',NULL,NULL),(3844,682,'534086','834','00','005010X220A1','534086','','2013-11-08','14:36:57',0,'2013-12-25 22:30:23',NULL,NULL),(18671,3467,'2720965','834','00','005010X220A1','2720965','','2014-02-10','13:32:28',0,'2014-02-10 21:31:53',NULL,NULL),(19641,3644,'3335494','834','00','005010X220A1','3335494','','2014-02-14','15:37:03',0,'2014-02-14 21:32:07',NULL,NULL),(20485,3844,'3574409','834','00','005010X220A1','3574409','','2014-02-19','19:25:44',0,'2014-02-20 22:00:52',NULL,NULL),(20542,3858,'2721291','834','00','005010X220A1','2721291','','2014-02-20','13:00:02',0,'2014-02-20 22:01:39',NULL,NULL),(11189,1453,'1603803','834','00','005010X220A1','1603803','','2013-12-25','20:06:36',0,'2013-12-27 02:00:06',NULL,NULL),(14886,2558,'2101716','834','00','005010X220A1','2101716','','2014-01-14','09:13:21',0,'2014-01-15 02:07:24',NULL,NULL),(11627,1496,'2246842','834','00','005010X220A1','2246842','','2013-12-27','11:29:10',0,'2013-12-28 03:35:33',NULL,NULL),(12483,1640,'1315229','834','00','005010X220A1','1315229','','2013-12-31','15:23:08',1,'2014-01-02 04:32:38',NULL,NULL),(19720,3672,'3051732','834','00','005010X220A1','3051732','','2014-02-15','12:37:32',0,'2014-02-15 22:00:22',NULL,NULL),(22501,4247,'3318554','834','00','005010X220A1','3318554','','2014-03-04','19:12:11',0,'2014-03-05 21:30:07',NULL,NULL),(22512,4247,'3451584','834','00','005010X220A1','3451584','','2014-03-05','11:48:48',0,'2014-03-05 21:30:15',NULL,NULL),(22751,4276,'3837174','834','00','005010X220A1','3837174','','2014-03-06','13:41:57',0,'2014-03-06 21:00:30',NULL,NULL),(11082,1422,'1362687','834','00','005010X220A1','1362687','','2013-12-23','18:51:45',0,'2013-12-26 13:13:30',NULL,NULL),(1864,324,'523396','834','00','005010X220A1','523396','','2013-12-09','14:03:58',0,'2013-12-25 19:30:40',NULL,NULL),(6369,1182,'782948','834','00','005010X220A1','782948','','2013-12-20','15:41:09',0,'2013-12-26 03:09:31',NULL,NULL),(2316,404,'152851','834','00','005010X220A1','152851','','2013-11-01','21:02:01',0,'2013-12-25 20:01:46',NULL,NULL),(5815,1083,'1202900','834','00','005010X220A1','1202900','','2013-12-14','16:24:42',0,'2013-12-26 02:04:03',NULL,NULL),(2943,541,'210107','834','00','005010X220A1','210107','','2013-12-13','08:45:42',0,'2013-12-25 21:31:21',NULL,NULL),(17536,3235,'1905499','834','00','005010X220A1','1905499','','2014-02-03','15:20:06',0,'2014-02-03 21:00:17',NULL,NULL),(17752,3262,'2344498','834','00','005010X220A1','2344498','','2014-02-04','12:45:02',0,'2014-02-04 21:01:02',NULL,NULL),(19776,3675,'3437466','834','00','005010X220A1','3437466','','2014-02-15','11:01:52',0,'2014-02-15 22:01:02',NULL,NULL),(21970,4143,'2696666','834','00','005010X220A1','2696666','','2014-03-02','12:51:30',0,'2014-03-03 01:00:07',NULL,NULL),(22575,4248,'3654650','834','00','005010X220A1','3654650','','2014-03-05','14:58:25',0,'2014-03-05 21:30:59',NULL,NULL),(10405,1400,'820172','834','00','005010X220A1','820172','','2013-12-23','09:04:04',0,'2013-12-26 12:50:51',NULL,NULL),(4294,746,'1344178','834','00','005010X220A1','1344178','','2013-12-19','13:29:47',0,'2013-12-25 23:09:07',NULL,NULL),(7719,1336,'21579','834','00','005010X220A1','21579','','2013-11-15','16:15:06',0,'2013-12-26 04:46:07',NULL,NULL),(15100,2587,'2567174','834','00','005010X220A1','2567174','','2014-01-14','19:43:18',0,'2014-01-16 08:45:20',NULL,NULL),(13282,2126,'0001','999','BE','005010X231A1','906097','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:22',NULL,NULL),(13040,1884,'0001','999','BE','005010X231A1','750299','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:53',NULL,NULL),(4991,935,'915454','834','00','005010X220A1','915454','','2013-12-11','07:55:31',0,'2013-12-26 00:45:42',NULL,NULL),(5637,1048,'2060523','834','00','005010X220A1','2060523','','2013-12-24','19:37:23',0,'2013-12-26 01:50:54',NULL,NULL),(21373,4024,'2756445','834','00','005010X220A1','2756445','','2014-02-27','11:53:43',0,'2014-02-28 06:30:22',NULL,NULL),(23706,4454,'2914585','834','00','005010X220A1','2914585','','2014-03-10','10:20:16',0,'2014-03-10 21:02:32',NULL,NULL),(110,6,'246146','834','00','005010X220A1','246146','','2013-12-05','10:39:20',0,'2013-12-25 17:18:20',NULL,NULL),(5761,1072,'224396','834','00','005010X220A1','224396','','2013-12-14','00:22:38',0,'2013-12-26 02:02:15',NULL,NULL),(16454,3006,'2398403','834','00','005010X220A1','2398403','','2014-01-23','21:38:55',0,'2014-01-24 21:00:14',NULL,NULL),(5173,948,'1184549','834','00','005010X220A1','1184549','','2013-12-10','19:41:39',0,'2013-12-26 00:51:29',NULL,NULL),(15801,2723,'1586103','834','00','005010X220A1','1586103','','2014-01-20','11:34:10',0,'2014-01-21 08:46:49',NULL,NULL),(15104,2587,'1890300','834','00','005010X220A1','1890300','','2014-01-14','22:00:40',0,'2014-01-16 08:45:23',NULL,NULL),(14515,2517,'1885447','834','00','005010X220A1','1885447','','2014-01-12','20:33:49',0,'2014-01-14 01:32:12',NULL,NULL),(14378,2407,'1562987','834','00','005010X220A1','1562987','','2014-01-12','17:37:11',0,'2014-01-13 03:01:47',NULL,NULL),(2885,526,'658751','834','00','005010X220A1','658751','','2013-12-22','11:30:11',0,'2013-12-25 21:23:10',NULL,NULL),(17173,3146,'2647860','834','00','005010X220A1','2647860','','2014-01-30','10:42:00',0,'2014-01-30 21:00:52',NULL,NULL),(18126,3332,'2712397','834','00','005010X220A1','2712397','','2014-02-05','19:25:15',0,'2014-02-06 21:01:34',NULL,NULL),(19500,3621,'2837267','834','00','005010X220A1','2837267','','2014-02-13','19:25:37',0,'2014-02-14 21:30:25',NULL,NULL),(7160,1238,'1091014','834','00','005010X220A1','1091014','','2013-12-18','09:22:22',0,'2013-12-26 04:05:24',NULL,NULL),(3387,588,'443848','834','00','005010X220A1','443848','','2013-12-16','19:39:01',0,'2013-12-25 21:51:18',NULL,NULL),(15115,2587,'2604019','834','00','005010X220A1','2604019','','2014-01-15','12:45:15',0,'2014-01-16 08:45:30',NULL,NULL),(4431,793,'341573','834','00','005010X220A1','341573','','2013-11-05','18:29:41',0,'2013-12-25 23:17:05',NULL,NULL),(12757,1694,'2559213','834','00','005010X220A1','2559213','','2014-01-01','20:19:55',0,'2014-01-03 02:06:59',NULL,NULL),(18928,3519,'2623717','834','00','005010X220A1','2623717','','2014-02-11','05:25:17',0,'2014-02-11 21:30:08',NULL,NULL),(21072,3980,'2770287','834','00','005010X220A1','2770287','','2014-02-24','15:44:47',0,'2014-02-26 09:30:44',NULL,NULL),(232,37,'366656','834','00','005010X220A1','366656','','2013-10-12','08:53:31',0,'2013-12-25 17:30:17',NULL,NULL),(977,184,'663333','834','00','005010X220A1','663333','','2013-12-03','09:38:01',0,'2013-12-25 18:19:30',NULL,NULL),(13515,2235,'2092937','834','00','005010X220A1','2092937','','2014-01-05','21:50:30',0,'2014-01-07 04:05:15',NULL,NULL),(13380,2221,'2497412','834','00','005010X220A1','2497412','','2014-01-06','15:14:52',0,'2014-01-07 04:00:09',NULL,NULL),(1356,245,'86606','834','00','005010X220A1','86606','','2013-12-24','13:58:45',0,'2013-12-25 18:52:37',NULL,NULL),(4461,801,'637293','834','00','005010X220A1','637293','','2013-11-26','14:55:34',0,'2013-12-25 23:30:46',NULL,NULL),(6002,1134,'492055','834','00','005010X220A1','492055','','2013-12-15','17:55:28',0,'2013-12-26 02:34:06',NULL,NULL),(1909,325,'610681','834','00','005010X220A1','610681','','2013-12-09','14:01:25',0,'2013-12-25 19:32:02',NULL,NULL),(1945,326,'891826','834','00','005010X220A1','891826','','2013-12-09','11:07:26',0,'2013-12-25 19:33:05',NULL,NULL),(3558,616,'225571','834','00','005010X220A1','225571','','2013-12-12','15:50:10',0,'2013-12-25 22:03:04',NULL,NULL),(21017,3966,'3650417','834','00','005010X220A1','3650417','','2014-02-22','11:00:14',0,'2014-02-26 08:30:53',NULL,NULL),(23137,4342,'3059415','834','00','005010X220A1','3059415','','2014-03-07','13:34:28',0,'2014-03-07 21:31:01',NULL,NULL),(1775,298,'1178152','834','00','005010X220A1','1178152','','2013-12-10','17:34:18',0,'2013-12-25 19:18:46',NULL,NULL),(16450,3006,'1706750','834','00','005010X220A1','1706750','','2014-01-24','12:14:51',0,'2014-01-24 21:00:12',NULL,NULL),(10497,1400,'1618958','834','00','005010X220A1','1618958','','2013-12-23','17:34:23',0,'2013-12-26 12:53:46',NULL,NULL),(14097,2343,'1832958','834','00','005010X220A1','1832958','','2014-01-07','21:50:37',0,'2014-01-13 02:22:08',NULL,NULL),(13120,1964,'0001','999','BE','005010X231A1','18034','834','2013-12-28','12:25:00',0,'2014-01-05 16:54:34',NULL,NULL),(19529,3622,'1913740','834','00','005010X220A1','1913740','','2014-02-14','15:53:14',0,'2014-02-14 21:30:46',NULL,NULL),(21026,3974,'2758917','834','00','005010X220A1','2758917','','2014-02-24','12:53:01',0,'2014-02-26 09:30:05',NULL,NULL),(10374,1400,'349434','834','00','005010X220A1','349434','','2013-12-22','19:18:46',0,'2013-12-26 12:49:54',NULL,NULL),(15662,2684,'1552907','834','00','005010X220A1','1552907','','2014-01-17','20:40:24',0,'2014-01-21 08:44:32',NULL,NULL),(15339,2622,'2220574','834','00','005010X220A1','2220574','','2014-01-15','19:37:50',0,'2014-01-17 03:35:18',NULL,NULL),(14442,2463,'0001','999','BE','005010X231A1','385746','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:13',NULL,NULL),(13543,2241,'1422573','834','00','005010X220A1','1422573','','2014-01-06','11:12:02',0,'2014-01-07 04:06:10',NULL,NULL),(12894,1709,'2437184','834','00','005010X220A1','2437184','','2014-01-03','10:39:39',0,'2014-01-04 02:04:40',NULL,NULL),(3972,716,'460009','834','00','005010X220A1','460009','','2013-12-07','17:19:41',0,'2013-12-25 22:47:17',NULL,NULL),(5580,1043,'1603784','834','00','005010X220A1','1603784','','2013-12-24','22:26:44',0,'2013-12-26 01:49:00',NULL,NULL),(17029,3120,'1412931','834','00','005010X220A1','1412931','','2014-01-29','14:03:30',0,'2014-01-29 21:01:12',NULL,NULL),(17994,3316,'2512814','834','00','005010X220A1','2512814','','2014-02-05','15:48:57',0,'2014-02-05 21:31:19',NULL,NULL),(20995,3960,'2922772','834','00','005010X220A1','2922772','','2014-02-21','19:33:34',0,'2014-02-26 08:30:35',NULL,NULL),(21211,3998,'2790239','834','00','005010X220A1','2790239','','2014-02-26','16:11:57',0,'2014-02-26 21:01:24',NULL,NULL),(22542,4248,'3743359','834','00','005010X220A1','3743359','','2014-03-04','20:21:50',0,'2014-03-05 21:30:37',NULL,NULL),(2242,373,'530625','834','00','005010X220A1','530625','','2013-12-02','13:10:02',0,'2013-12-25 19:49:38',NULL,NULL),(2577,473,'761821','834','00','005010X220A1','761821','','2013-11-01','08:19:03',0,'2013-12-25 20:45:13',NULL,NULL),(6413,1199,'171145','834','00','005010X220A1','171145','','2013-12-20','16:18:33',0,'2013-12-26 03:10:59',NULL,NULL),(5722,1069,'749327','834','00','005010X220A1','749327','','2013-12-14','12:12:12',0,'2013-12-26 02:01:05',NULL,NULL),(5063,936,'45454','834','00','005010X220A1','45454','','2013-12-11','11:10:33',0,'2013-12-26 00:48:01',NULL,NULL),(4010,731,'946940','834','00','005010X220A1','946940','','2013-12-19','07:20:03',0,'2013-12-25 23:00:25',NULL,NULL),(22283,4200,'2971957','834','00','005010X220A1','2971957','','2014-03-04','16:23:25',0,'2014-03-04 21:00:46',NULL,NULL),(831,173,'792826','834','00','005010X220A1','792826','','2013-12-02','20:46:14',0,'2013-12-25 18:15:04',NULL,NULL),(14219,2366,'2330065','834','00','005010X220A1','2330065','','2014-01-10','12:37:17',0,'2014-01-13 02:23:57',NULL,NULL),(1682,291,'89853','834','00','005010X220A1','89853','','2013-12-09','19:06:23',0,'2013-12-25 19:15:55',NULL,NULL),(2360,413,'528050','834','00','005010X220A1','528050','','2013-12-05','20:48:06',0,'2013-12-25 20:15:57',NULL,NULL),(11585,1492,'2288529','834','00','005010X220A1','2288529','','2013-12-27','16:56:34',0,'2013-12-28 03:34:15',NULL,NULL),(2393,414,'67199','834','00','005010X220A1','67199','','2013-12-06','13:02:06',0,'2013-12-25 20:16:58',NULL,NULL),(16431,3004,'1513910','834','00','005010X220A1','1513910','','2014-01-23','17:47:49',0,'2014-01-23 21:01:45',NULL,NULL),(19327,3583,'3046794','834','00','005010X220A1','3046794','','2014-02-13','12:42:12',0,'2014-02-13 22:01:35',NULL,NULL),(19438,3602,'3274910','834','00','005010X220A1','3274910','','2014-02-13','14:47:05',0,'2014-02-13 22:02:57',NULL,NULL),(20410,3833,'3102835','834','00','005010X220A1','3102835','','2014-02-20','15:38:49',0,'2014-02-20 21:30:13',NULL,NULL),(20536,3854,'2444888','834','00','005010X220A1','2444888','','2014-02-20','11:12:10',0,'2014-02-20 22:01:33',NULL,NULL),(20970,3956,'2760235','834','00','005010X220A1','2760235','','2014-02-22','09:46:32',0,'2014-02-26 08:30:08',NULL,NULL),(21624,4066,'2869658','834','00','005010X220A1','2869658','','2014-02-26','22:07:22',0,'2014-02-28 07:30:21',NULL,NULL),(22572,4248,'3457818','834','00','005010X220A1','3457818','','2014-03-05','14:05:59',0,'2014-03-05 21:30:57',NULL,NULL),(23727,4462,'2915996','834','00','005010X220A1','2915996','','2014-03-10','11:46:30',0,'2014-03-10 21:02:49',NULL,NULL),(6164,1167,'949685','834','00','005010X220A1','949685','','2013-12-20','09:00:22',0,'2013-12-26 03:03:15',NULL,NULL),(7706,1332,'206971','834','00','005010X220A1','206971','','2013-11-15','14:17:26',0,'2013-12-26 04:45:40',NULL,NULL),(5629,1046,'840771','834','00','005010X220A1','840771','','2013-12-24','23:31:56',0,'2013-12-26 01:50:40',NULL,NULL),(14685,2549,'1711867','834','00','005010X220A1','1711867','','2014-01-14','09:38:53',0,'2014-01-15 02:05:55',NULL,NULL),(4598,826,'23867','834','00','005010X220A1','23867','','2013-12-24','00:26:28',0,'2013-12-25 23:47:13',NULL,NULL),(1255,243,'1707441','834','00','005010X220A1','1707441','','2013-12-24','12:29:21',0,'2013-12-25 18:49:22',NULL,NULL),(11880,1560,'2059528','834','00','005010X220A1','2059528','','2013-12-29','12:51:00',0,'2013-12-30 00:00:23',NULL,NULL),(2642,500,'318467','834','00','005010X220A1','318467','','2013-12-22','14:43:39',0,'2013-12-25 21:15:08',NULL,NULL),(3798,660,'320484','834','00','005010X220A1','320484','','2013-12-07','19:17:58',0,'2013-12-25 22:16:13',NULL,NULL),(20906,3930,'3717241','834','00','005010X220A1','3717241','','2014-02-23','10:35:01',0,'2014-02-26 08:00:06',NULL,NULL),(20990,3958,'3431235','834','00','005010X220A1','3431235','','2014-02-22','14:13:15',0,'2014-02-26 08:30:30',NULL,NULL),(21073,3980,'3556835','834','00','005010X220A1','3556835','','2014-02-24','15:48:53',0,'2014-02-26 09:30:45',NULL,NULL),(22331,4203,'3599303','834','00','005010X220A1','3599303','','2014-03-04','11:30:08',0,'2014-03-04 21:01:22',NULL,NULL),(22588,4249,'2799605','834','00','005010X220A1','2799605','','2014-03-04','18:08:31',0,'2014-03-05 21:31:10',NULL,NULL),(157,10,'989924','834','00','005010X220A1','989924','','2013-12-05','12:11:51',0,'2013-12-25 17:19:51',NULL,NULL),(666,108,'1254403','834','00','005010X220A1','1254403','','2013-12-16','18:21:56',0,'2013-12-25 18:05:40',NULL,NULL),(13509,2233,'1426469','834','00','005010X220A1','1426469','','2014-01-06','17:02:53',0,'2014-01-07 04:05:02',NULL,NULL),(768,144,'787265','834','00','005010X220A1','787265','','2013-10-28','21:54:18',0,'2013-12-25 18:08:57',NULL,NULL),(11552,1492,'346839','834','00','005010X220A1','346839','','2013-12-26','21:31:33',0,'2013-12-28 03:33:13',NULL,NULL),(11112,1426,'1573692','834','00','005010X220A1','1573692','','2013-12-23','09:21:07',0,'2013-12-26 13:14:29',NULL,NULL),(3915,712,'1227150','834','00','005010X220A1','1227150','','2013-12-07','12:42:14',0,'2013-12-25 22:45:29',NULL,NULL),(10556,1402,'1591046','834','00','005010X220A1','1591046','','2013-12-22','21:57:10',0,'2013-12-26 12:55:45',NULL,NULL),(17325,3175,'2703727','834','00','005010X220A1','2703727','','2014-01-30','19:18:18',0,'2014-01-31 21:00:58',NULL,NULL),(17437,3205,'2547092','834','00','005010X220A1','2547092','','2014-01-31','22:19:55',0,'2014-02-01 19:00:32',NULL,NULL),(21289,4005,'3058006','834','00','005010X220A1','3058006','','2014-02-26','16:24:30',0,'2014-02-26 21:02:16',NULL,NULL),(22556,4248,'3813066','834','00','005010X220A1','3813066','','2014-03-05','11:52:57',0,'2014-03-05 21:30:48',NULL,NULL),(369,72,'1049220','834','00','005010X220A1','1049220','','2013-12-04','17:50:36',0,'2013-12-25 17:47:22',NULL,NULL),(1073,213,'797791','834','00','005010X220A1','797791','','2013-11-29','15:58:51',0,'2013-12-25 18:31:01',NULL,NULL),(11509,1490,'1455819','834','00','005010X220A1','1455819','','2013-12-26','19:35:40',0,'2013-12-28 03:31:56',NULL,NULL),(1285,243,'619957','834','00','005010X220A1','619957','','2013-12-24','17:45:02',0,'2013-12-25 18:50:19',NULL,NULL),(4877,889,'288835','834','00','005010X220A1','288835','','2013-11-21','11:08:42',0,'2013-12-26 00:16:30',NULL,NULL),(3389,588,'1033789','834','00','005010X220A1','1033789','','2013-12-16','22:49:24',0,'2013-12-25 21:51:21',NULL,NULL),(2687,502,'1259497','834','00','005010X220A1','1259497','','2013-12-22','08:16:42',0,'2013-12-25 21:16:45',NULL,NULL),(10415,1400,'1534154','834','00','005010X220A1','1534154','','2013-12-23','09:44:01',0,'2013-12-26 12:51:11',NULL,NULL),(16519,3015,'2564985','834','00','005010X220A1','2564985','','2014-01-23','20:10:09',0,'2014-01-24 21:00:53',NULL,NULL),(19801,3677,'2723505','834','00','005010X220A1','2723505','','2014-02-15','14:09:20',0,'2014-02-15 22:01:23',NULL,NULL),(21623,4066,'3081113','834','00','005010X220A1','3081113','','2014-02-26','18:47:18',0,'2014-02-28 07:30:20',NULL,NULL),(21641,4071,'3811401','834','00','005010X220A1','3811401','','2014-02-27','12:38:20',0,'2014-02-28 07:30:33',NULL,NULL),(22274,4200,'3387127','834','00','005010X220A1','3387127','','2014-03-04','14:05:06',0,'2014-03-04 21:00:39',NULL,NULL),(1729,293,'483771','834','00','005010X220A1','483771','','2013-12-10','10:25:37',0,'2013-12-25 19:17:22',NULL,NULL),(14747,2550,'2049802','834','00','005010X220A1','2049802','','2014-01-14','18:06:20',0,'2014-01-15 02:06:22',NULL,NULL),(14701,2550,'2598968','834','00','005010X220A1','2598968','','2014-01-13','19:35:46',0,'2014-01-15 02:06:02',NULL,NULL),(13159,2003,'0001','999','BE','005010X231A1','121164','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:58',NULL,NULL),(11575,1492,'1351914','834','00','005010X220A1','1351914','','2013-12-27','15:42:35',0,'2013-12-28 03:33:59',NULL,NULL),(7452,1296,'748223','834','00','005010X220A1','748223','','2013-12-20','22:36:49',0,'2013-12-26 04:32:27',NULL,NULL),(7361,1285,'252731','834','00','005010X220A1','252731','','2013-11-30','11:46:37',0,'2013-12-26 04:15:52',NULL,NULL),(20945,3948,'3212967','834','00','005010X220A1','3212967','','2014-02-24','07:54:49',0,'2014-02-26 08:00:38',NULL,NULL),(21040,3977,'2637695','834','00','005010X220A1','2637695','','2014-02-24','12:49:54',0,'2014-02-26 09:30:18',NULL,NULL),(21515,4034,'3393153','834','00','005010X220A1','3393153','','2014-02-27','09:44:36',0,'2014-02-28 06:31:28',NULL,NULL),(22236,4199,'3082296','834','00','005010X220A1','3082296','','2014-03-03','18:00:04',0,'2014-03-04 21:00:09',NULL,NULL),(156,10,'1157321','834','00','005010X220A1','1157321','','2013-12-05','12:11:51',0,'2013-12-25 17:19:50',NULL,NULL),(15165,2588,'2110895','834','00','005010X220A1','2110895','','2014-01-15','17:25:33',0,'2014-01-16 08:46:04',NULL,NULL),(3223,578,'129805','834','00','005010X220A1','129805','','2013-12-17','11:11:21',0,'2013-12-25 21:46:00',NULL,NULL),(10789,1404,'197941','834','00','005010X220A1','197941','','2013-12-23','12:11:30',0,'2013-12-26 13:03:30',NULL,NULL),(4954,925,'560625','834','00','005010X220A1','560625','','2013-11-19','17:08:52',0,'2013-12-26 00:31:58',NULL,NULL),(12595,1671,'2235422','834','00','005010X220A1','2235422','','2014-01-02','12:34:19',0,'2014-01-03 02:00:55',NULL,NULL),(10461,1400,'292147','834','00','005010X220A1','292147','','2013-12-23','13:54:28',0,'2013-12-26 12:52:37',NULL,NULL),(17187,3148,'1698550','834','00','005010X220A1','1698550','','2014-01-30','14:21:48',0,'2014-01-30 21:01:01',NULL,NULL),(17901,3295,'2139916','834','00','005010X220A1','2139916','','2014-02-05','12:50:48',0,'2014-02-05 21:30:32',NULL,NULL),(19074,3542,'2484714','834','00','005010X220A1','2484714','','2014-02-12','17:30:09',0,'2014-02-12 21:31:20',NULL,NULL),(23691,4450,'2954510','834','00','005010X220A1','2954510','','2014-03-10','11:28:54',0,'2014-03-10 21:02:21',NULL,NULL),(14694,2549,'1492803','834','00','005010X220A1','1492803','','2014-01-14','14:21:02',0,'2014-01-15 02:05:59',NULL,NULL),(16362,2985,'2418279','834','00','005010X220A1','2418279','','2014-01-23','14:34:40',0,'2014-01-23 21:00:56',NULL,NULL),(19416,3596,'3191543','834','00','005010X220A1','3191543','','2014-02-13','09:29:49',0,'2014-02-13 22:02:41',NULL,NULL),(21478,4028,'3098051','834','00','005010X220A1','3098051','','2014-02-27','15:47:12',0,'2014-02-28 06:31:12',NULL,NULL),(23165,4344,'3536694','834','00','005010X220A1','3536694','','2014-03-07','12:27:50',0,'2014-03-07 21:31:21',NULL,NULL),(1555,269,'1458140','834','00','005010X220A1','1458140','','2013-12-24','13:11:36',0,'2013-12-25 18:59:09',NULL,NULL),(2039,331,'886154','834','00','005010X220A1','886154','','2013-12-09','17:52:22',0,'2013-12-25 19:36:03',NULL,NULL),(14986,2579,'1413947','834','00','005010X220A1','1413947','','2014-01-14','15:50:08',0,'2014-01-15 02:08:10',NULL,NULL),(15283,2612,'2454144','834','00','005010X220A1','2454144','','2014-01-15','16:53:40',0,'2014-01-16 08:47:20',NULL,NULL),(18483,3432,'1805135','834','00','005010X220A1','1805135','','2014-02-10','04:09:11',0,'2014-02-10 11:01:01',NULL,NULL),(358,72,'1203839','834','00','005010X220A1','1203839','','2013-12-04','08:56:50',0,'2013-12-25 17:47:02',NULL,NULL),(7261,1247,'31815','834','00','005010X220A1','31815','','2013-12-17','22:37:39',0,'2013-12-26 04:08:30',NULL,NULL),(7108,1236,'280338','834','00','005010X220A1','280338','','2013-12-18','13:11:18',0,'2013-12-26 04:03:50',NULL,NULL),(5910,1112,'807096','834','00','005010X220A1','807096','','2013-12-14','19:52:55',0,'2013-12-26 02:31:06',NULL,NULL),(4045,731,'898577','834','00','005010X220A1','898577','','2013-12-19','17:12:57',0,'2013-12-25 23:01:31',NULL,NULL),(4689,833,'277093','834','00','005010X220A1','277093','','2013-12-24','00:51:15',0,'2013-12-25 23:50:16',NULL,NULL),(4868,886,'816744','834','00','005010X220A1','816744','','2013-11-21','17:43:18',0,'2013-12-26 00:16:12',NULL,NULL),(20108,3772,'3350179','834','00','005010X220A1','3350179','','2014-02-18','18:41:09',0,'2014-02-20 03:45:25',NULL,NULL),(1071,213,'1157216','834','00','005010X220A1','1157216','','2013-11-29','13:36:29',0,'2013-12-25 18:30:58',NULL,NULL),(16734,3065,'1995224','834','00','005010X220A1','1995224','','2014-01-27','12:33:47',0,'2014-01-27 21:01:06',NULL,NULL),(15393,2625,'1885616','834','00','005010X220A1','1885616','','2014-01-16','05:28:13',0,'2014-01-17 03:35:44',NULL,NULL),(12689,1673,'2077412','834','00','005010X220A1','2077412','','2014-01-02','17:51:56',0,'2014-01-03 02:04:18',NULL,NULL),(12045,1583,'1448609','834','00','005010X220A1','1448609','','2013-12-30','18:08:46',0,'2014-01-01 12:03:47',NULL,NULL),(10729,1403,'1658651','834','00','005010X220A1','1658651','','2013-12-23','14:53:41',0,'2013-12-26 13:01:36',NULL,NULL),(6270,1172,'482118','834','00','005010X220A1','482118','','2013-12-20','09:21:07',0,'2013-12-26 03:06:33',NULL,NULL),(5793,1075,'49604','834','00','005010X220A1','49604','','2013-12-14','17:23:21',0,'2013-12-26 02:03:18',NULL,NULL),(20810,3910,'2807098','834','00','005010X220A1','2807098','','2014-02-25','06:57:25',0,'2014-02-25 21:31:02',NULL,NULL),(22131,4179,'3140314','834','00','005010X220A1','3140314','','2014-03-03','08:40:38',0,'2014-03-03 21:30:41',NULL,NULL),(86,4,'788950','834','00','005010X220A1','788950','','2013-12-05','09:45:07',0,'2013-12-25 17:17:36',NULL,NULL),(7155,1238,'647929','834','00','005010X220A1','647929','','2013-12-17','19:26:47',0,'2013-12-26 04:05:14',NULL,NULL),(14791,2551,'2525254','834','00','005010X220A1','2525254','','2014-01-14','16:23:35',0,'2014-01-15 02:06:41',NULL,NULL),(11668,1504,'1452167','834','00','005010X220A1','1452167','','2013-12-27','10:27:23',0,'2013-12-28 03:36:52',NULL,NULL),(4075,733,'658541','834','00','005010X220A1','658541','','2013-12-18','20:31:30',0,'2013-12-25 23:02:32',NULL,NULL),(2595,481,'317405','834','00','005010X220A1','317405','','2013-11-01','06:35:27',0,'2013-12-25 20:45:50',NULL,NULL),(2423,417,'506099','834','00','005010X220A1','506099','','2013-12-06','18:09:08',0,'2013-12-25 20:17:58',NULL,NULL),(1953,326,'586378','834','00','005010X220A1','586378','','2013-12-09','12:16:16',0,'2013-12-25 19:33:18',NULL,NULL),(19573,3627,'3473408','834','00','005010X220A1','3473408','','2014-02-14','12:50:55',0,'2014-02-14 21:31:18',NULL,NULL),(21546,4043,'2725221','834','00','005010X220A1','2725221','','2014-02-27','11:12:07',0,'2014-02-28 06:31:42',NULL,NULL),(23010,4323,'3357807','834','00','005010X220A1','3357807','','2014-03-06','19:19:45',0,'2014-03-07 21:00:15',NULL,NULL),(11262,1455,'1289376','834','00','005010X220A1','1289376','','2013-12-26','08:41:05',0,'2013-12-27 02:02:21',NULL,NULL),(16288,2980,'1675329','834','00','005010X220A1','1675329','','2014-01-22','18:32:01',0,'2014-01-23 21:00:03',NULL,NULL),(7123,1236,'1249553','834','00','005010X220A1','1249553','','2013-12-18','15:56:21',0,'2013-12-26 04:04:18',NULL,NULL),(13498,2230,'1553940','834','00','005010X220A1','1553940','','2014-01-06','13:19:46',0,'2014-01-07 04:04:34',NULL,NULL),(13256,2100,'0001','999','BE','005010X231A1','647463','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:28',NULL,NULL),(1512,258,'1982762','834','00','005010X220A1','1982762','','2013-12-24','15:23:48',0,'2013-12-25 18:57:46',NULL,NULL),(2379,414,'377358','834','00','005010X220A1','377358','','2013-12-06','11:38:36',0,'2013-12-25 20:16:36',NULL,NULL),(18430,3420,'2304200','834','00','005010X220A1','2304200','','2014-02-10','04:23:55',0,'2014-02-10 11:00:16',NULL,NULL),(19084,3542,'2958514','834','00','005010X220A1','2958514','','2014-02-12','16:16:45',0,'2014-02-12 21:31:28',NULL,NULL),(21349,4022,'3106979','834','00','005010X220A1','3106979','','2014-02-27','15:12:23',0,'2014-02-28 06:30:12',NULL,NULL),(23142,4342,'3283396','834','00','005010X220A1','3283396','','2014-03-07','14:28:25',0,'2014-03-07 21:31:04',NULL,NULL),(1235,243,'1565040','834','00','005010X220A1','1565040','','2013-12-24','10:27:57',0,'2013-12-25 18:48:47',NULL,NULL),(5242,958,'339318','834','00','005010X220A1','339318','','2013-12-11','10:00:56',0,'2013-12-26 00:53:46',NULL,NULL),(13304,2148,'0001','999','BE','005010X231A1','1009870','834','2013-12-27','16:55:00',0,'2014-01-05 17:24:23',NULL,NULL),(16391,2990,'1436916','834','00','005010X220A1','1436916','','2014-01-23','10:45:02',0,'2014-01-23 21:01:17',NULL,NULL),(15831,2736,'2075598','834','00','005010X220A1','2075598','','2014-01-21','17:48:50',1,'2014-01-22 03:21:56',NULL,NULL),(13727,2275,'2278161','834','00','005010X220A1','2278161','','2014-01-06','22:05:40',0,'2014-01-08 18:24:41',NULL,NULL),(18404,3413,'2648078','834','00','005010X220A1','2648078','','2014-02-09','15:45:21',0,'2014-02-09 19:00:38',NULL,NULL),(18488,3433,'2163065','834','00','005010X220A1','2163065','','2014-02-10','04:07:01',0,'2014-02-10 11:01:05',NULL,NULL),(19982,3746,'2518284','834','00','005010X220A1','2518284','','2014-02-18','16:02:23',0,'2014-02-18 22:00:21',NULL,NULL),(442,81,'912783','834','00','005010X220A1','912783','','2013-12-04','18:06:52',0,'2013-12-25 17:49:42',NULL,NULL),(16718,3064,'2624789','834','00','005010X220A1','2624789','','2014-01-27','14:05:11',0,'2014-01-27 21:00:54',NULL,NULL),(1420,249,'479857','834','00','005010X220A1','479857','','2013-12-24','11:54:15',0,'2013-12-25 18:54:43',NULL,NULL),(16514,3014,'1476102','834','00','005010X220A1','1476102','','2014-01-24','15:20:15',0,'2014-01-24 21:00:51',NULL,NULL),(14456,2477,'0001','999','BE','005010X231A1','1065194','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:30',NULL,NULL),(13442,2223,'1843329','834','00','005010X220A1','1843329','','2014-01-06','07:22:28',0,'2014-01-07 04:02:26',NULL,NULL),(10849,1405,'1407931','834','00','005010X220A1','1407931','','2013-12-23','17:20:32',0,'2013-12-26 13:05:28',NULL,NULL),(11636,1497,'1047619','834','00','005010X220A1','1047619','','2013-12-27','17:03:31',0,'2013-12-28 03:35:50',NULL,NULL),(5356,1006,'1215395','834','00','005010X220A1','1215395','','2013-11-25','13:07:19',0,'2013-12-26 01:16:03',NULL,NULL),(22589,4249,'2713195','834','00','005010X220A1','2713195','','2014-03-05','13:38:22',0,'2014-03-05 21:31:11',NULL,NULL),(23419,4404,'3852320','834','00','005010X220A1','3852320','','2014-03-09','15:22:26',0,'2014-03-09 21:00:24',NULL,NULL),(1796,303,'324408','834','00','005010X220A1','324408','','2013-12-10','15:15:51',0,'2013-12-25 19:19:30',NULL,NULL),(15119,2587,'1674138','834','00','005010X220A1','1674138','','2014-01-15','14:58:43',0,'2014-01-16 08:45:33',NULL,NULL),(14377,2407,'2307955','834','00','005010X220A1','2307955','','2014-01-12','13:08:31',0,'2014-01-13 03:01:46',NULL,NULL),(13768,2281,'1553977','834','00','005010X220A1','1553977','','2014-01-07','13:50:59',0,'2014-01-08 18:25:00',NULL,NULL),(10915,1410,'1451857','834','00','005010X220A1','1451857','','2013-12-22','21:28:59',0,'2013-12-26 13:08:08',NULL,NULL),(4268,742,'730381','834','00','005010X220A1','730381','','2013-12-19','15:56:39',0,'2013-12-25 23:08:21',NULL,NULL),(7581,1301,'1073465','834','00','005010X220A1','1073465','','2013-12-21','16:15:05',0,'2013-12-26 04:36:39',NULL,NULL),(19169,3557,'2271141','834','00','005010X220A1','2271141','','2014-02-12','18:00:35',0,'2014-02-12 21:32:24',NULL,NULL),(22706,4264,'3007070','834','00','005010X220A1','3007070','','2014-03-05','11:06:57',0,'2014-03-05 21:32:32',NULL,NULL),(11948,1580,'2170972','834','00','005010X220A1','2170972','','2013-12-29','21:18:54',0,'2014-01-01 12:00:08',NULL,NULL),(7270,1251,'669734','834','00','005010X220A1','669734','','2013-12-18','11:01:56',0,'2013-12-26 04:08:48',NULL,NULL),(17235,3162,'1741037','834','00','005010X220A1','1741037','','2014-01-30','17:46:14',0,'2014-01-30 21:01:33',NULL,NULL),(15957,2763,'1884368','834','00','005010X220A1','1884368','','2014-01-22','15:34:58',0,'2014-01-23 03:01:53',NULL,NULL),(14149,2357,'2395211','834','00','005010X220A1','2395211','','2014-01-08','12:50:40',0,'2014-01-13 02:22:41',NULL,NULL),(18511,3447,'3079346','834','00','005010X220A1','3079346','','2014-02-10','14:35:29',0,'2014-02-10 21:00:10',NULL,NULL),(19006,3539,'2875249','834','00','005010X220A1','2875249','','2014-02-11','19:23:11',0,'2014-02-12 21:30:30',NULL,NULL),(20726,3898,'2830672','834','00','005010X220A1','2830672','','2014-02-25','16:09:39',0,'2014-02-25 21:00:30',NULL,NULL),(21926,4128,'3812955','834','00','005010X220A1','3812955','','2014-03-01','13:16:55',0,'2014-03-01 21:00:47',NULL,NULL),(22675,4255,'2850889','834','00','005010X220A1','2850889','','2014-03-05','13:28:58',0,'2014-03-05 21:32:09',NULL,NULL),(487,102,'1301678','834','00','005010X220A1','1301678','','2013-12-15','18:20:56',0,'2013-12-25 18:00:04',NULL,NULL),(17065,3126,'2008280','834','00','005010X220A1','2008280','','2014-01-29','11:15:20',0,'2014-01-29 21:01:36',NULL,NULL),(16194,2886,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:19:00',1,'2014-01-23 04:35:14',NULL,NULL),(15330,2622,'2411725','834','00','005010X220A1','2411725','','2014-01-16','16:13:20',0,'2014-01-17 03:35:14',NULL,NULL),(15178,2591,'2383984','834','00','005010X220A1','2383984','','2014-01-15','09:50:07',0,'2014-01-16 08:46:12',NULL,NULL),(536,102,'1311624','834','00','005010X220A1','1311624','','2013-12-16','16:27:16',0,'2013-12-25 18:01:34',NULL,NULL),(7521,1300,'259984','834','00','005010X220A1','259984','','2013-12-21','12:38:07',0,'2013-12-26 04:34:42',NULL,NULL),(5044,936,'773275','834','00','005010X220A1','773275','','2013-12-10','18:26:18',0,'2013-12-26 00:47:23',NULL,NULL),(19311,3583,'2685982','834','00','005010X220A1','2685982','','2014-02-12','21:26:51',0,'2014-02-13 22:01:21',NULL,NULL),(11790,1537,'1601024','834','00','005010X220A1','1601024','','2013-12-28','20:15:14',1,'2013-12-29 11:12:49',NULL,NULL),(16640,3060,'1510213','834','00','005010X220A1','1510213','','2014-01-26','19:24:31',0,'2014-01-27 21:00:05',NULL,NULL),(11486,1488,'1965269','834','00','005010X220A1','1965269','','2013-12-27','17:45:51',0,'2013-12-28 03:31:14',NULL,NULL),(14998,2584,'2592778','834','00','005010X220A1','2592778','','2014-01-14','20:48:00',0,'2014-01-16 08:44:16',NULL,NULL),(14605,2521,'1672941','834','00','005010X220A1','1672941','','2014-01-13','17:14:29',0,'2014-01-14 01:33:09',NULL,NULL),(14511,2515,'1811192','834','00','005010X220A1','1811192','','2014-01-13','18:32:33',0,'2014-01-14 01:32:09',NULL,NULL),(1996,329,'581631','834','00','005010X220A1','581631','','2013-12-08','22:47:30',0,'2013-12-25 19:34:42',NULL,NULL),(11031,1418,'758023','834','00','005010X220A1','758023','','2013-12-22','20:11:58',0,'2013-12-26 13:11:50',NULL,NULL),(7219,1241,'1277520','834','00','005010X220A1','1277520','','2013-12-18','12:22:31',0,'2013-12-26 04:07:12',NULL,NULL),(5195,949,'538248','834','00','005010X220A1','538248','','2013-12-11','12:44:50',0,'2013-12-26 00:52:12',NULL,NULL),(4062,732,'1232742','834','00','005010X220A1','1232742','','2013-12-18','19:05:55',0,'2013-12-25 23:02:03',NULL,NULL),(4798,865,'587328','834','00','005010X220A1','587328','','2013-11-30','18:23:54',0,'2013-12-26 00:01:48',NULL,NULL),(4263,742,'1300483','834','00','005010X220A1','1300483','','2013-12-19','13:49:08',0,'2013-12-25 23:08:12',NULL,NULL),(7202,1241,'323241','834','00','005010X220A1','323241','','2013-12-17','19:16:24',0,'2013-12-26 04:06:40',NULL,NULL),(15730,2711,'2283494','834','00','005010X220A1','2283494','','2014-01-19','22:10:27',0,'2014-01-21 08:46:06',NULL,NULL),(16515,3014,'2414304','834','00','005010X220A1','2414304','','2014-01-23','20:04:00',0,'2014-01-24 21:00:51',NULL,NULL),(19443,3603,'3249326','834','00','005010X220A1','3249326','','2014-02-13','13:40:19',0,'2014-02-13 22:03:02',NULL,NULL),(21396,4024,'2945415','834','00','005010X220A1','2945415','','2014-02-27','17:57:03',0,'2014-02-28 06:30:33',NULL,NULL),(21997,4146,'2874511','834','00','005010X220A1','2874511','','2014-03-02','11:04:40',0,'2014-03-03 01:00:21',NULL,NULL),(22466,4238,'3679339','834','00','005010X220A1','3679339','','2014-03-05','12:23:35',0,'2014-03-05 21:00:14',NULL,NULL),(1218,243,'1156886','834','00','005010X220A1','1156886','','2013-12-24','08:53:49',0,'2013-12-25 18:48:19',NULL,NULL),(15374,2624,'1791391','834','00','005010X220A1','1791391','','2014-01-15','23:17:03',0,'2014-01-17 03:35:34',NULL,NULL),(15327,2622,'1667871','834','00','005010X220A1','1667871','','2014-01-16','14:45:39',0,'2014-01-17 03:35:13',NULL,NULL),(14949,2563,'2211698','834','00','005010X220A1','2211698','','2014-01-13','22:09:15',0,'2014-01-15 02:07:51',NULL,NULL),(7008,1235,'568695','834','00','005010X220A1','568695','','2013-12-17','22:10:47',0,'2013-12-26 04:00:45',NULL,NULL),(4602,826,'1547051','834','00','005010X220A1','1547051','','2013-12-24','01:42:20',0,'2013-12-25 23:47:19',NULL,NULL),(3943,715,'588593','834','00','005010X220A1','588593','','2013-12-06','18:44:27',0,'2013-12-25 22:46:18',NULL,NULL),(15979,2764,'2563570','834','00','005010X220A1','2563570','','2014-01-22','17:23:06',0,'2014-01-23 03:02:03',NULL,NULL),(18545,3452,'2033803','834','00','005010X220A1','2033803','','2014-02-10','10:42:38',0,'2014-02-10 21:30:25',NULL,NULL),(19372,3590,'3296200','834','00','005010X220A1','3296200','','2014-02-13','11:59:38',0,'2014-02-13 22:02:09',NULL,NULL),(19532,3622,'2806838','834','00','005010X220A1','2806838','','2014-02-14','16:22:49',0,'2014-02-14 21:30:48',NULL,NULL),(20482,3843,'2849127','834','00','005010X220A1','2849127','','2014-02-20','14:21:18',0,'2014-02-20 22:00:50',NULL,NULL),(192,16,'1026059','834','00','005010X220A1','1026059','','2013-12-05','18:13:53',0,'2013-12-25 17:20:58',NULL,NULL),(15554,2655,'1908763','834','00','005010X220A1','1908763','','2014-01-16','22:36:36',0,'2014-01-20 08:05:52',NULL,NULL),(7092,1236,'171000','834','00','005010X220A1','171000','','2013-12-18','10:56:27',0,'2013-12-26 04:03:23',NULL,NULL),(1494,256,'1921232','834','00','005010X220A1','1921232','','2013-12-24','09:24:10',0,'2013-12-25 18:57:11',NULL,NULL),(12884,1706,'2343709','834','00','005010X220A1','2343709','','2014-01-03','18:05:39',0,'2014-01-04 02:04:18',NULL,NULL),(6127,1166,'150783','834','00','005010X220A1','150783','','2013-12-20','15:21:24',0,'2013-12-26 03:02:09',NULL,NULL),(12474,1640,'1282653','834','00','005010X220A1','1282653','','2013-12-30','21:22:16',1,'2014-01-02 04:32:21',NULL,NULL),(4516,813,'56883','834','00','005010X220A1','56883','','2013-11-25','23:13:07',0,'2013-12-25 23:32:37',NULL,NULL),(10395,1400,'1483390','834','00','005010X220A1','1483390','','2013-12-23','06:29:30',0,'2013-12-26 12:50:33',NULL,NULL),(2822,508,'331712','834','00','005010X220A1','331712','','2013-12-22','07:43:10',0,'2013-12-25 21:21:03',NULL,NULL),(2872,517,'242712','834','00','005010X220A1','242712','','2013-12-22','08:50:14',0,'2013-12-25 21:22:41',NULL,NULL),(19730,3672,'3285119','834','00','005010X220A1','3285119','','2014-02-15','15:39:30',0,'2014-02-15 22:00:29',NULL,NULL),(22534,4247,'3283304','834','00','005010X220A1','3283304','','2014-03-05','16:50:02',0,'2014-03-05 21:30:30',NULL,NULL),(22659,4254,'3053369','834','00','005010X220A1','3053369','','2014-03-05','09:59:47',0,'2014-03-05 21:31:59',NULL,NULL),(7392,1293,'1093842','834','00','005010X220A1','1093842','','2013-12-21','16:11:21',0,'2013-12-26 04:30:35',NULL,NULL),(13064,1908,'0001','999','BE','005010X231A1','768681','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:59',NULL,NULL),(12106,1587,'1803173','834','00','005010X220A1','1803173','','2013-12-30','11:58:56',0,'2014-01-01 12:05:55',NULL,NULL),(5266,972,'434844','834','00','005010X220A1','434844','','2013-11-11','19:13:11',0,'2013-12-26 01:00:13',NULL,NULL),(11317,1456,'660464','834','00','005010X220A1','660464','','2013-12-26','12:51:19',0,'2013-12-27 02:04:01',NULL,NULL),(19959,3746,'2518261','834','00','005010X220A1','2518261','','2014-02-17','21:35:52',0,'2014-02-18 22:00:03',NULL,NULL),(23767,4480,'2912234','834','00','005010X220A1','2912234','','2014-03-10','16:29:02',0,'2014-03-10 21:30:15',NULL,NULL),(3852,686,'906748','834','00','005010X220A1','906748','','2013-11-08','12:39:27',0,'2013-12-25 22:30:40',NULL,NULL),(3684,630,'372854','834','00','005010X220A1','372854','','2013-12-11','22:52:17',0,'2013-12-25 22:06:57',NULL,NULL),(14408,2429,'0001','999','BE','005010X231A1','1197349','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:21',NULL,NULL),(10819,1404,'999956','834','00','005010X220A1','999956','','2013-12-23','16:36:49',0,'2013-12-26 13:04:29',NULL,NULL),(3214,578,'202650','834','00','005010X220A1','202650','','2013-12-17','09:06:37',0,'2013-12-25 21:45:46',NULL,NULL),(18706,3485,'2428871','834','00','005010X220A1','2428871','','2014-02-11','18:07:37',0,'2014-02-11 21:00:03',NULL,NULL),(20836,3911,'3570491','834','00','005010X220A1','3570491','','2014-02-25','11:18:42',0,'2014-02-25 21:31:20',NULL,NULL),(21592,4059,'2857730','834','00','005010X220A1','2857730','','2014-02-26','13:55:41',0,'2014-02-28 07:00:34',NULL,NULL),(21697,4087,'3009272','834','00','005010X220A1','3009272','','2014-02-28','12:20:45',0,'2014-02-28 21:30:09',NULL,NULL),(5575,1043,'1215113','834','00','005010X220A1','1215113','','2013-12-24','21:43:28',0,'2013-12-26 01:48:50',NULL,NULL),(12055,1585,'1518436','834','00','005010X220A1','1518436','','2013-12-30','11:05:46',0,'2014-01-01 12:04:10',NULL,NULL),(14122,2349,'1835662','834','00','005010X220A1','1835662','','2014-01-07','23:04:01',0,'2014-01-13 02:22:24',NULL,NULL),(16118,2810,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:04:00',1,'2014-01-23 03:45:43',NULL,NULL),(20467,3842,'2967624','834','00','005010X220A1','2967624','','2014-02-20','13:30:03',0,'2014-02-20 22:00:36',NULL,NULL),(22259,4200,'3811565','834','00','005010X220A1','3811565','','2014-03-04','09:35:59',0,'2014-03-04 21:00:27',NULL,NULL),(23386,4401,'3317572','834','00','005010X220A1','3317572','','2014-03-09','12:11:22',0,'2014-03-09 21:00:01',NULL,NULL),(1587,278,'41239','834','00','005010X220A1','41239','','2013-11-20','16:14:47',0,'2013-12-25 19:00:51',NULL,NULL),(16053,2772,'1975096','834','00','005010X220A1','1975096','','2014-01-22','14:23:35',0,'2014-01-23 03:02:36',NULL,NULL),(5823,1088,'516990','834','00','005010X220A1','516990','','2013-11-22','18:51:57',0,'2013-12-26 02:15:09',NULL,NULL),(10625,1402,'1573743','834','00','005010X220A1','1573743','','2013-12-23','15:32:24',0,'2013-12-26 12:57:59',NULL,NULL),(11166,1440,'532720','834','00','005010X220A1','532720','','2013-12-23','15:20:41',0,'2013-12-26 13:16:30',NULL,NULL),(14193,2365,'1457301','834','00','005010X220A1','1457301','','2014-01-10','12:54:54',0,'2014-01-13 02:23:39',NULL,NULL),(13357,2201,'0001','999','BE','005010X231A1','1301191','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:50',NULL,NULL),(12723,1680,'1385740','834','00','005010X220A1','1385740','','2014-01-02','14:52:59',0,'2014-01-03 02:05:40',NULL,NULL),(12660,1673,'2375966','834','00','005010X220A1','2375966','','2014-01-01','23:55:40',0,'2014-01-03 02:03:20',NULL,NULL),(11667,1503,'1673616','834','00','005010X220A1','1673616','','2013-12-27','08:38:18',0,'2013-12-28 03:36:50',NULL,NULL),(11405,1466,'1924193','834','00','005010X220A1','1924193','','2013-12-26','10:33:45',0,'2013-12-27 02:06:43',NULL,NULL),(16220,2912,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:05:00',0,'2014-01-23 05:30:02',NULL,NULL),(17651,3251,'1682606','834','00','005010X220A1','1682606','','2014-02-03','12:35:06',0,'2014-02-03 21:01:31',NULL,NULL),(18741,3485,'2369765','834','00','005010X220A1','2369765','','2014-02-11','12:37:08',0,'2014-02-11 21:00:31',NULL,NULL),(21086,3984,'3069886','834','00','005010X220A1','3069886','','2014-02-24','12:41:28',0,'2014-02-26 09:30:53',NULL,NULL),(21481,4028,'2722832','834','00','005010X220A1','2722832','','2014-02-27','15:59:07',0,'2014-02-28 06:31:13',NULL,NULL),(1717,293,'378477','834','00','005010X220A1','378477','','2013-12-09','20:09:37',0,'2013-12-25 19:17:01',NULL,NULL),(15788,2719,'2386708','834','00','005010X220A1','2386708','','2014-01-20','13:42:54',0,'2014-01-21 08:46:41',NULL,NULL),(3469,615,'1317057','834','00','005010X220A1','1317057','','2013-12-11','19:43:23',0,'2013-12-25 22:00:12',NULL,NULL),(13146,1990,'0001','999','BE','005010X231A1','1052121','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:22',NULL,NULL),(17775,3266,'1668212','834','00','005010X220A1','1668212','','2014-02-03','21:04:15',0,'2014-02-04 21:01:16',NULL,NULL),(19340,3583,'2312100','834','00','005010X220A1','2312100','','2014-02-13','14:59:38',0,'2014-02-13 22:01:43',NULL,NULL),(19405,3593,'3279991','834','00','005010X220A1','3279991','','2014-02-13','13:06:35',0,'2014-02-13 22:02:33',NULL,NULL),(22338,4204,'2987059','834','00','005010X220A1','2987059','','2014-03-03','21:31:19',0,'2014-03-04 21:01:28',NULL,NULL),(4548,825,'12270','834','00','005010X220A1','12270','','2013-12-23','22:48:54',0,'2013-12-25 23:45:38',NULL,NULL),(13974,2323,'1642640','834','00','005010X220A1','1642640','','2014-01-09','10:39:30',0,'2014-01-13 02:20:38',NULL,NULL),(13583,2256,'1859895','834','00','005010X220A1','1859895','','2014-01-04','23:43:35',1,'2014-01-07 10:22:09',NULL,NULL),(3887,703,'240656','834','00','005010X220A1','240656','','2013-10-26','06:17:01',0,'2013-12-25 22:31:47',NULL,NULL),(12774,1702,'1744137','834','00','005010X220A1','1744137','','2014-01-03','13:23:49',0,'2014-01-04 02:00:15',NULL,NULL),(16788,3085,'2040172','834','00','005010X220A1','2040172','','2014-01-27','15:45:46',0,'2014-01-27 21:01:48',NULL,NULL),(16913,3109,'2222086','834','00','005010X220A1','2222086','','2014-01-28','16:05:24',0,'2014-01-28 21:01:21',NULL,NULL),(17161,3144,'1950104','834','00','005010X220A1','1950104','','2014-01-30','17:28:12',0,'2014-01-30 21:00:43',NULL,NULL),(17571,3236,'2447007','834','00','005010X220A1','2447007','','2014-02-03','14:39:19',0,'2014-02-03 21:00:39',NULL,NULL),(17611,3241,'2410956','834','00','005010X220A1','2410956','','2014-02-03','16:59:19',0,'2014-02-03 21:01:05',NULL,NULL),(20915,3932,'2621838','834','00','005010X220A1','2621838','','2014-02-22','20:56:44',0,'2014-02-26 08:00:13',NULL,NULL),(5650,1050,'1738688','834','00','005010X220A1','1738688','','2013-12-24','19:23:06',0,'2013-12-26 01:51:18',NULL,NULL),(15546,2655,'1940002','834','00','005010X220A1','1940002','','2014-01-17','10:34:24',0,'2014-01-20 08:05:45',NULL,NULL),(5496,1041,'1112385','834','00','005010X220A1','1112385','','2013-12-24','19:16:42',0,'2013-12-26 01:46:17',NULL,NULL),(16850,3092,'2516268','834','00','005010X220A1','2516268','','2014-01-28','17:06:18',0,'2014-01-28 21:00:39',NULL,NULL),(17459,3212,'2127158','834','00','005010X220A1','2127158','','2014-02-01','14:59:59',0,'2014-02-01 19:00:48',NULL,NULL),(18332,3386,'2434448','834','00','005010X220A1','2434448','','2014-02-08','14:32:50',0,'2014-02-08 19:00:54',NULL,NULL),(19418,3596,'2365058','834','00','005010X220A1','2365058','','2014-02-13','12:34:50',0,'2014-02-13 22:02:42',NULL,NULL),(21596,4061,'2688940','834','00','005010X220A1','2688940','','2014-02-26','15:36:13',0,'2014-02-28 07:00:39',NULL,NULL),(126,7,'925713','834','00','005010X220A1','925713','','2013-12-05','15:25:00',0,'2013-12-25 17:18:53',NULL,NULL),(15466,2632,'1639779','834','00','005010X220A1','1639779','','2014-01-15','20:30:28',0,'2014-01-17 03:36:16',NULL,NULL),(6326,1175,'731812','834','00','005010X220A1','731812','','2013-12-20','15:26:26',0,'2013-12-26 03:08:11',NULL,NULL),(1369,245,'1843037','834','00','005010X220A1','1843037','','2013-12-24','15:22:50',0,'2013-12-25 18:53:01',NULL,NULL),(2101,357,'1053237','834','00','005010X220A1','1053237','','2013-12-09','17:24:58',0,'2013-12-25 19:38:06',NULL,NULL),(20284,3796,'3457376','834','00','005010X220A1','3457376','','2014-02-19','09:35:47',0,'2014-02-20 04:39:02',NULL,NULL),(21205,3998,'3109179','834','00','005010X220A1','3109179','','2014-02-26','15:41:03',0,'2014-02-26 21:01:19',NULL,NULL),(10569,1402,'947200','834','00','005010X220A1','947200','','2013-12-23','09:19:58',0,'2013-12-26 12:56:10',NULL,NULL),(15258,2601,'2478093','834','00','005010X220A1','2478093','','2014-01-15','10:07:06',0,'2014-01-16 08:47:02',NULL,NULL),(14818,2552,'2022968','834','00','005010X220A1','2022968','','2014-01-14','14:53:55',0,'2014-01-15 02:06:52',NULL,NULL),(2705,502,'656107','834','00','005010X220A1','656107','','2013-12-22','17:02:13',0,'2013-12-25 21:17:21',NULL,NULL),(12130,1587,'1674717','834','00','005010X220A1','1674717','','2013-12-30','17:50:37',0,'2014-01-01 12:06:45',NULL,NULL),(11826,1540,'881922','834','00','005010X220A1','881922','','2013-12-28','20:29:01',1,'2013-12-29 11:13:56',NULL,NULL),(5950,1113,'595979','834','00','005010X220A1','595979','','2013-12-15','17:13:39',0,'2013-12-26 02:32:18',NULL,NULL),(20229,3786,'2560450','834','00','005010X220A1','2560450','','2014-02-19','17:40:22',0,'2014-02-20 04:25:54',NULL,NULL),(20770,3907,'3717262','834','00','005010X220A1','3717262','','2014-02-24','18:43:46',0,'2014-02-25 21:30:34',NULL,NULL),(23398,4403,'3172976','834','00','005010X220A1','3172976','','2014-03-09','10:51:38',0,'2014-03-09 21:00:10',NULL,NULL),(679,109,'521211','834','00','005010X220A1','521211','','2013-12-16','13:27:10',0,'2013-12-25 18:06:04',NULL,NULL),(1924,326,'834226','834','00','005010X220A1','834226','','2013-12-09','06:36:19',0,'2013-12-25 19:32:27',NULL,NULL),(13557,2250,'2069055','834','00','005010X220A1','2069055','','2014-01-06','14:27:18',0,'2014-01-07 04:06:48',NULL,NULL),(2622,489,'750196','834','00','005010X220A1','750196','','2013-11-28','17:43:06',0,'2013-12-25 20:46:39',NULL,NULL),(5951,1114,'690852','834','00','005010X220A1','690852','','2013-12-14','19:54:53',0,'2013-12-26 02:32:21',NULL,NULL),(19349,3583,'2306086','834','00','005010X220A1','2306086','','2014-02-13','17:48:08',0,'2014-02-13 22:01:51',NULL,NULL),(20663,3877,'2646179','834','00','005010X220A1','2646179','','2014-02-21','15:35:31',0,'2014-02-21 22:01:02',NULL,NULL),(21687,4085,'3318421','834','00','005010X220A1','3318421','','2014-02-28','16:04:26',0,'2014-02-28 21:00:27',NULL,NULL),(21794,4092,'2597442','834','00','005010X220A1','2597442','','2014-02-28','10:54:02',0,'2014-02-28 21:31:17',NULL,NULL),(23244,4365,'3516881','834','00','005010X220A1','3516881','','2014-03-07','12:01:19',0,'2014-03-07 21:32:18',NULL,NULL),(23657,4442,'3085331','834','00','005010X220A1','3085331','','2014-03-10','16:48:44',0,'2014-03-10 21:01:56',NULL,NULL),(6006,1136,'1197349','834','00','005010X220A1','1197349','','2013-11-17','07:28:08',0,'2013-12-26 02:45:08',NULL,NULL),(16573,3035,'1901825','834','00','005010X220A1','1901825','','2014-01-25','15:15:00',0,'2014-01-25 19:00:07',NULL,NULL),(15818,2734,'2196791','834','00','005010X220A1','2196791','','2014-01-20','16:16:37',0,'2014-01-21 08:46:59',NULL,NULL),(728,124,'401152','834','00','005010X220A1','401152','','2013-12-16','12:00:06',0,'2013-12-25 18:07:42',NULL,NULL),(5834,1091,'360330','834','00','005010X220A1','360330','','2013-11-23','00:54:23',0,'2013-12-26 02:15:31',NULL,NULL),(2346,413,'343357','834','00','005010X220A1','343357','','2013-12-06','11:24:08',0,'2013-12-25 20:15:32',NULL,NULL),(2952,541,'79605','834','00','005010X220A1','79605','','2013-12-13','10:29:41',0,'2013-12-25 21:31:38',NULL,NULL),(5781,1074,'87435','834','00','005010X220A1','87435','','2013-12-14','16:08:16',0,'2013-12-26 02:02:58',NULL,NULL),(17553,3236,'1983744','834','00','005010X220A1','1983744','','2014-02-02','22:28:49',0,'2014-02-03 21:00:29',NULL,NULL),(19252,3581,'2842954','834','00','005010X220A1','2842954','','2014-02-12','19:04:11',0,'2014-02-13 22:00:36',NULL,NULL),(19807,3679,'2664354','834','00','005010X220A1','2664354','','2014-02-14','23:17:37',0,'2014-02-15 22:01:29',NULL,NULL),(21758,4090,'2909648','834','00','005010X220A1','2909648','','2014-02-28','12:08:13',0,'2014-02-28 21:30:52',NULL,NULL),(4933,917,'527673','834','00','005010X220A1','527673','','2013-10-16','20:30:21',0,'2013-12-26 00:31:12',NULL,NULL),(645,108,'280246','834','00','005010X220A1','280246','','2013-12-16','15:02:22',0,'2013-12-25 18:05:04',NULL,NULL),(2815,506,'619694','834','00','005010X220A1','619694','','2013-12-22','17:22:05',0,'2013-12-25 21:20:47',NULL,NULL),(12060,1585,'1932185','834','00','005010X220A1','1932185','','2013-12-30','18:40:14',0,'2014-01-01 12:04:20',NULL,NULL),(12633,1672,'2515600','834','00','005010X220A1','2515600','','2014-01-01','23:29:00',0,'2014-01-03 02:02:13',NULL,NULL),(18618,3457,'2224765','834','00','005010X220A1','2224765','','2014-02-10','09:30:27',0,'2014-02-10 21:31:16',NULL,NULL),(20232,3789,'3246932','834','00','005010X220A1','3246932','','2014-02-18','20:44:08',0,'2014-02-20 04:27:19',NULL,NULL),(22750,4276,'3408695','834','00','005010X220A1','3408695','','2014-03-06','13:27:32',0,'2014-03-06 21:00:29',NULL,NULL),(10897,1409,'1258156','834','00','005010X220A1','1258156','','2013-12-23','07:17:44',0,'2013-12-26 13:07:31',NULL,NULL),(10886,1409,'783080','834','00','005010X220A1','783080','','2013-12-22','19:42:27',0,'2013-12-26 13:07:10',NULL,NULL),(6087,1166,'790991','834','00','005010X220A1','790991','','2013-12-19','20:50:01',0,'2013-12-26 03:00:56',NULL,NULL),(12718,1678,'2565806','834','00','005010X220A1','2565806','','2014-01-02','11:23:30',0,'2014-01-03 02:05:26',NULL,NULL),(17963,3300,'2563832','834','00','005010X220A1','2563832','','2014-02-04','19:32:04',0,'2014-02-05 21:31:02',NULL,NULL),(19038,3540,'2564047','834','00','005010X220A1','2564047','','2014-02-12','17:07:36',0,'2014-02-12 21:30:52',NULL,NULL),(20043,3751,'2442333','834','00','005010X220A1','2442333','','2014-02-18','10:51:26',0,'2014-02-18 22:01:03',NULL,NULL),(21351,4022,'2702003','834','00','005010X220A1','2702003','','2014-02-27','16:02:38',0,'2014-02-28 06:30:12',NULL,NULL),(21729,4088,'3791051','834','00','005010X220A1','3791051','','2014-02-28','16:04:28',0,'2014-02-28 21:30:32',NULL,NULL),(22262,4200,'3047253','834','00','005010X220A1','3047253','','2014-03-04','11:21:58',0,'2014-03-04 21:00:30',NULL,NULL),(22815,4278,'3750243','834','00','005010X220A1','3750243','','2014-03-06','11:43:17',0,'2014-03-06 21:01:14',NULL,NULL),(23583,4436,'3346088','834','00','005010X220A1','3346088','','2014-03-10','17:28:06',0,'2014-03-10 21:01:05',NULL,NULL),(319,71,'1233585','834','00','005010X220A1','1233585','','2013-12-03','18:22:46',0,'2013-12-25 17:45:48',NULL,NULL),(16557,3030,'1504868','834','00','005010X220A1','1504868','','2014-01-24','10:42:15',0,'2014-01-24 21:01:17',NULL,NULL),(15557,2655,'1670520','834','00','005010X220A1','1670520','','2014-01-16','22:59:54',0,'2014-01-20 08:05:54',NULL,NULL),(15308,2622,'1521251','834','00','005010X220A1','1521251','','2014-01-15','22:41:42',0,'2014-01-17 03:35:05',NULL,NULL),(612,108,'936746','834','00','005010X220A1','936746','','2013-12-15','21:52:26',0,'2013-12-25 18:03:58',NULL,NULL),(7154,1238,'405855','834','00','005010X220A1','405855','','2013-12-17','19:02:25',0,'2013-12-26 04:05:13',NULL,NULL),(14465,2486,'0001','999','BE','005010X231A1','113072','834','2013-12-28','04:55:00',0,'2014-01-13 03:03:38',NULL,NULL),(12334,1634,'2482336','834','00','005010X220A1','2482336','','2013-12-31','10:57:55',1,'2014-01-02 04:27:22',NULL,NULL),(11931,1570,'1512073','834','00','005010X220A1','1512073','','2013-12-29','12:30:01',0,'2013-12-30 00:02:00',NULL,NULL),(4225,738,'542518','834','00','005010X220A1','542518','','2013-12-19','11:18:58',0,'2013-12-25 23:07:01',NULL,NULL),(6071,1164,'668773','834','00','005010X220A1','668773','','2013-12-20','15:23:21',0,'2013-12-26 03:00:23',NULL,NULL),(16887,3096,'1484481','834','00','005010X220A1','1484481','','2014-01-28','12:49:50',0,'2014-01-28 21:01:04',NULL,NULL),(18581,3453,'1553342','834','00','005010X220A1','1553342','','2014-02-10','15:16:02',0,'2014-02-10 21:30:51',NULL,NULL),(19291,3582,'2788832','834','00','005010X220A1','2788832','','2014-02-13','14:55:16',0,'2014-02-13 22:01:05',NULL,NULL),(20304,3795,'2720209','834','00','005010X220A1','2720209','','2014-02-19','12:55:08',0,'2014-02-20 04:44:02',NULL,NULL),(343,72,'173161','834','00','005010X220A1','173161','','2013-12-03','21:12:28',0,'2013-12-25 17:46:33',NULL,NULL),(15934,2752,'2573896','834','00','005010X220A1','2573896','','2014-01-21','13:49:28',1,'2014-01-22 03:23:02',NULL,NULL),(13636,2270,'1569211','834','00','005010X220A1','1569211','','2014-01-07','13:51:36',0,'2014-01-08 18:24:05',NULL,NULL),(2191,363,'1032293','834','00','005010X220A1','1032293','','2013-12-02','16:25:33',0,'2013-12-25 19:47:50',NULL,NULL),(7193,1239,'558630','834','00','005010X220A1','558630','','2013-12-18','15:30:46',0,'2013-12-26 04:06:25',NULL,NULL),(11720,1519,'2153893','834','00','005010X220A1','2153893','','2013-12-27','19:24:35',1,'2013-12-29 11:08:31',NULL,NULL),(4575,826,'1621611','834','00','005010X220A1','1621611','','2013-12-23','21:51:52',0,'2013-12-25 23:46:29',NULL,NULL),(5638,1048,'1825520','834','00','005010X220A1','1825520','','2013-12-24','19:46:56',0,'2013-12-26 01:50:56',NULL,NULL),(6058,1162,'559069','834','00','005010X220A1','559069','','2013-11-10','14:47:47',0,'2013-12-26 02:46:51',NULL,NULL),(4713,838,'918780','834','00','005010X220A1','918780','','2013-12-23','21:51:42',0,'2013-12-25 23:51:05',NULL,NULL),(17024,3120,'1399117','834','00','005010X220A1','1399117','','2014-01-29','11:10:17',0,'2014-01-29 21:01:09',NULL,NULL),(18212,3356,'2848755','834','00','005010X220A1','2848755','','2014-02-06','22:35:34',0,'2014-02-07 19:00:42',NULL,NULL),(21837,4103,'3475284','834','00','005010X220A1','3475284','','2014-02-28','11:37:52',0,'2014-02-28 21:31:49',NULL,NULL),(21874,4122,'2611315','834','00','005010X220A1','2611315','','2014-03-01','00:49:05',0,'2014-03-01 21:00:12',NULL,NULL),(21935,4130,'3338703','834','00','005010X220A1','3338703','','2014-03-01','00:42:35',0,'2014-03-01 21:00:52',NULL,NULL),(22419,4220,'2918043','834','00','005010X220A1','2918043','','2014-03-04','12:37:19',0,'2014-03-04 21:02:37',NULL,NULL),(23117,4342,'3344848','834','00','005010X220A1','3344848','','2014-03-06','20:12:39',0,'2014-03-07 21:30:48',NULL,NULL),(10795,1404,'83900','834','00','005010X220A1','83900','','2013-12-23','13:11:29',0,'2013-12-26 13:03:42',NULL,NULL),(13744,2276,'2354198','834','00','005010X220A1','2354198','','2014-01-07','14:12:04',0,'2014-01-08 18:24:48',NULL,NULL),(5488,1040,'554340','834','00','005010X220A1','554340','','2013-12-25','14:12:22',0,'2013-12-26 01:46:00',NULL,NULL),(12539,1649,'1561349','834','00','005010X220A1','1561349','','2013-12-31','16:54:56',1,'2014-01-02 04:34:47',NULL,NULL),(3769,654,'385728','834','00','005010X220A1','385728','','2013-12-08','15:38:09',0,'2013-12-25 22:15:17',NULL,NULL),(3573,617,'553538','834','00','005010X220A1','553538','','2013-12-11','23:12:26',0,'2013-12-25 22:03:31',NULL,NULL),(921,178,'1202535','834','00','005010X220A1','1202535','','2013-12-02','19:19:54',0,'2013-12-25 18:17:43',NULL,NULL),(3162,563,'173429','834','00','005010X220A1','173429','','2013-12-13','10:44:42',0,'2013-12-25 21:38:11',NULL,NULL),(3202,578,'989292','834','00','005010X220A1','989292','','2013-12-16','22:35:34',0,'2013-12-25 21:45:19',NULL,NULL),(20696,3891,'3221558','834','00','005010X220A1','3221558','','2014-02-22','16:13:21',0,'2014-02-22 19:00:15',NULL,NULL),(4354,761,'338545','834','00','005010X220A1','338545','','2013-12-19','09:44:47',0,'2013-12-25 23:10:54',NULL,NULL),(13607,2263,'1561445','834','00','005010X220A1','1561445','','2014-01-05','17:31:19',1,'2014-01-07 10:23:07',NULL,NULL),(12863,1706,'2350536','834','00','005010X220A1','2350536','','2014-01-03','10:34:08',0,'2014-01-04 02:03:31',NULL,NULL),(21690,4087,'2823661','834','00','005010X220A1','2823661','','2014-02-27','18:02:13',0,'2014-02-28 21:30:02',NULL,NULL),(22696,4261,'2631032','834','00','005010X220A1','2631032','','2014-03-05','10:46:51',0,'2014-03-05 21:32:25',NULL,NULL),(22721,4273,'3821550','834','00','005010X220A1','3821550','','2014-03-05','16:07:11',0,'2014-03-05 21:32:44',NULL,NULL),(22739,4276,'3288225','834','00','005010X220A1','3288225','','2014-03-05','23:26:57',0,'2014-03-06 21:00:21',NULL,NULL),(23023,4325,'3385970','834','00','005010X220A1','3385970','','2014-03-07','13:54:32',0,'2014-03-07 21:00:22',NULL,NULL),(30,1,'1156059','834','00','005010X220A1','1156059','','2013-12-05','12:35:56',0,'2013-12-25 17:15:54',NULL,NULL),(2469,426,'507390','834','00','005010X220A1','507390','','2013-12-06','00:02:24',0,'2013-12-25 20:19:30',NULL,NULL),(16509,3013,'1999719','834','00','005010X220A1','1999719','','2014-01-24','15:14:06',0,'2014-01-24 21:00:47',NULL,NULL),(15346,2622,'2101826','834','00','005010X220A1','2101826','','2014-01-15','20:31:53',0,'2014-01-17 03:35:21',NULL,NULL),(14955,2565,'1824779','834','00','005010X220A1','1824779','','2014-01-14','12:13:54',0,'2014-01-15 02:07:54',NULL,NULL),(17451,3206,'2244197','834','00','005010X220A1','2244197','','2014-02-01','14:03:59',0,'2014-02-01 19:00:41',NULL,NULL),(20572,3865,'3542018','834','00','005010X220A1','3542018','','2014-02-21','16:03:05',0,'2014-02-21 21:30:17',NULL,NULL),(21405,4025,'3664840','834','00','005010X220A1','3664840','','2014-02-27','13:38:38',0,'2014-02-28 06:30:37',NULL,NULL),(21888,4125,'3081205','834','00','005010X220A1','3081205','','2014-02-28','18:40:01',0,'2014-03-01 21:00:22',NULL,NULL),(14336,2400,'1622187','834','00','005010X220A1','1622187','','2014-01-12','15:27:55',0,'2014-01-13 03:01:15',NULL,NULL),(15494,2634,'1743181','834','00','005010X220A1','1743181','','2014-01-16','17:48:43',0,'2014-01-17 03:36:28',NULL,NULL),(19748,3673,'2252809','834','00','005010X220A1','2252809','','2014-02-15','12:33:43',0,'2014-02-15 22:00:42',NULL,NULL),(20507,3847,'2637624','834','00','005010X220A1','2637624','','2014-02-20','15:34:53',0,'2014-02-20 22:01:09',NULL,NULL),(21614,4065,'3064418','834','00','005010X220A1','3064418','','2014-02-27','07:41:50',0,'2014-02-28 07:30:15',NULL,NULL),(1866,324,'639780','834','00','005010X220A1','639780','','2013-12-09','14:09:19',0,'2013-12-25 19:30:43',NULL,NULL),(2677,502,'949764','834','00','005010X220A1','949764','','2013-12-21','19:01:14',0,'2013-12-25 21:16:26',NULL,NULL),(16917,3113,'0001','999','BE','005010X231A1','556140','834','2014-01-29','14:05:00',0,'2014-01-29 15:00:03',NULL,NULL),(7340,1279,'130669','834','00','005010X220A1','130669','','2013-11-30','13:43:14',0,'2013-12-26 04:15:08',NULL,NULL),(7046,1235,'534800','834','00','005010X220A1','534800','','2013-12-18','16:40:16',0,'2013-12-26 04:01:54',NULL,NULL),(19651,3648,'2412397','834','00','005010X220A1','2412397','','2014-02-14','13:24:01',0,'2014-02-14 21:32:14',NULL,NULL),(292,66,'874293','834','00','005010X220A1','874293','','2013-11-09','15:04:03',0,'2013-12-25 17:32:23',NULL,NULL),(16161,2853,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:55:00',1,'2014-01-23 04:10:28',NULL,NULL),(2230,372,'284296','834','00','005010X220A1','284296','','2013-12-02','14:53:27',0,'2013-12-25 19:49:13',NULL,NULL),(15545,2655,'2278512','834','00','005010X220A1','2278512','','2014-01-17','00:34:32',0,'2014-01-20 08:05:45',NULL,NULL),(3593,617,'621904','834','00','005010X220A1','621904','','2013-12-12','16:48:42',0,'2013-12-25 22:04:07',NULL,NULL),(5219,952,'1080535','834','00','005010X220A1','1080535','','2013-12-11','08:05:37',0,'2013-12-26 00:53:00',NULL,NULL),(5497,1041,'1171681','834','00','005010X220A1','1171681','','2013-12-24','19:16:42',0,'2013-12-26 01:46:19',NULL,NULL),(876,177,'1190667','834','00','005010X220A1','1190667','','2013-12-03','07:25:26',0,'2013-12-25 18:16:29',NULL,NULL),(2453,422,'1085651','834','00','005010X220A1','1085651','','2013-12-06','17:12:43',0,'2013-12-25 20:18:57',NULL,NULL),(16934,3115,'2348343','834','00','005010X220A1','2348343','','2014-01-28','23:37:48',0,'2014-01-29 21:00:12',NULL,NULL),(15208,2592,'1362069','834','00','005010X220A1','1362069','','2014-01-15','15:01:12',0,'2014-01-16 08:46:30',NULL,NULL),(12960,1734,'1824512','834','00','005010X220A1','1824512','','2014-01-03','23:00:06',0,'2014-01-05 00:00:43',NULL,NULL),(4755,859,'351269','834','00','005010X220A1','351269','','2013-12-01','13:53:23',0,'2013-12-26 00:00:29',NULL,NULL),(18328,3386,'1649511','834','00','005010X220A1','1649511','','2014-02-08','11:35:42',0,'2014-02-08 19:00:52',NULL,NULL),(20071,3758,'2357389','834','00','005010X220A1','2357389','','2014-02-18','12:21:05',0,'2014-02-18 22:01:25',NULL,NULL),(20114,3772,'2831614','834','00','005010X220A1','2831614','','2014-02-18','21:30:35',0,'2014-02-20 03:48:38',NULL,NULL),(22275,4200,'3366869','834','00','005010X220A1','3366869','','2014-03-04','14:06:52',0,'2014-03-04 21:00:39',NULL,NULL),(11106,1425,'248358','834','00','005010X220A1','248358','','2013-12-23','17:16:57',0,'2013-12-26 13:14:17',NULL,NULL),(14625,2524,'2563249','834','00','005010X220A1','2563249','','2014-01-13','15:04:30',0,'2014-01-14 01:33:22',NULL,NULL),(13582,2255,'2362689','834','00','005010X220A1','2362689','','2014-01-05','12:59:10',1,'2014-01-07 10:22:06',NULL,NULL),(12846,1705,'2532132','834','00','005010X220A1','2532132','','2014-01-02','23:35:37',0,'2014-01-04 02:02:54',NULL,NULL),(5431,1031,'221383','834','00','005010X220A1','221383','','2013-10-05','16:08:30',0,'2013-12-26 01:31:21',NULL,NULL),(5583,1043,'1607610','834','00','005010X220A1','1607610','','2013-12-24','23:21:36',0,'2013-12-26 01:49:06',NULL,NULL),(10444,1400,'233255','834','00','005010X220A1','233255','','2013-12-23','12:43:12',0,'2013-12-26 12:52:07',NULL,NULL),(17961,3299,'1973933','834','00','005010X220A1','1973933','','2014-02-05','16:49:30',0,'2014-02-05 21:31:01',NULL,NULL),(19321,3583,'3002440','834','00','005010X220A1','3002440','','2014-02-13','11:38:50',0,'2014-02-13 22:01:31',NULL,NULL),(21700,4087,'2783050','834','00','005010X220A1','2783050','','2014-02-28','14:23:51',0,'2014-02-28 21:30:12',NULL,NULL),(22765,4276,'3800528','834','00','005010X220A1','3800528','','2014-03-06','17:55:31',0,'2014-03-06 21:00:40',NULL,NULL),(11532,1490,'1735085','834','00','005010X220A1','1735085','','2013-12-27','14:37:04',0,'2013-12-28 03:32:35',NULL,NULL),(1804,307,'871021','834','00','005010X220A1','871021','','2013-12-10','09:42:32',0,'2013-12-25 19:19:46',NULL,NULL),(4586,826,'1918779','834','00','005010X220A1','1918779','','2013-12-23','22:41:10',0,'2013-12-25 23:46:50',NULL,NULL),(13909,2313,'1937319','834','00','005010X220A1','1937319','','2014-01-08','21:21:08',0,'2014-01-13 02:19:50',NULL,NULL),(4890,898,'315786','834','00','005010X220A1','315786','','2013-10-02','08:21:01',0,'2013-12-26 00:17:02',NULL,NULL),(13075,1919,'0001','999','BE','005010X231A1','1194012','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:29',NULL,NULL),(18374,3406,'3065033','834','00','005010X220A1','3065033','','2014-02-09','15:46:36',0,'2014-02-09 19:00:17',NULL,NULL),(18503,3443,'2106110','834','00','005010X220A1','2106110','','2014-02-10','12:39:47',0,'2014-02-10 21:00:04',NULL,NULL),(23391,4401,'3542497','834','00','005010X220A1','3542497','','2014-03-09','15:07:13',0,'2014-03-09 21:00:04',NULL,NULL),(2468,426,'1186920','834','00','005010X220A1','1186920','','2013-12-06','17:54:04',0,'2013-12-25 20:19:29',NULL,NULL),(14311,2392,'2422710','834','00','005010X220A1','2422710','','2014-01-10','14:12:07',0,'2014-01-13 03:00:37',NULL,NULL),(15023,2584,'2090724','834','00','005010X220A1','2090724','','2014-01-15','11:30:35',0,'2014-01-16 08:44:31',NULL,NULL),(12126,1587,'1960140','834','00','005010X220A1','1960140','','2013-12-30','16:12:31',0,'2014-01-01 12:06:39',NULL,NULL),(7731,1342,'328274','834','00','005010X220A1','328274','','2013-10-20','18:42:31',0,'2013-12-26 05:00:15',NULL,NULL),(7070,1236,'401228','834','00','005010X220A1','401228','','2013-12-18','00:21:45',0,'2013-12-26 04:02:39',NULL,NULL),(13309,2153,'0001','999','BE','005010X231A1','1183065','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:37',NULL,NULL),(12804,1703,'1388317','834','00','005010X220A1','1388317','','2014-01-03','14:12:24',0,'2014-01-04 02:01:24',NULL,NULL),(3630,622,'62095','834','00','005010X220A1','62095','','2013-12-12','07:39:23',0,'2013-12-25 22:05:17',NULL,NULL),(6228,1168,'1104268','834','00','005010X220A1','1104268','','2013-12-20','16:21:20',0,'2013-12-26 03:05:13',NULL,NULL),(4710,836,'1814397','834','00','005010X220A1','1814397','','2013-12-23','21:37:50',0,'2013-12-25 23:50:58',NULL,NULL),(18530,3451,'2098662','834','00','005010X220A1','2098662','','2014-02-10','13:32:28',0,'2014-02-10 21:30:15',NULL,NULL),(1180,239,'1672416','834','00','005010X220A1','1672416','','2013-12-24','15:04:18',0,'2013-12-25 18:47:09',NULL,NULL),(17807,3271,'2071083','834','00','005010X220A1','2071083','','2014-02-04','12:21:26',0,'2014-02-04 21:01:37',NULL,NULL),(2406,415,'343366','834','00','005010X220A1','343366','','2013-12-06','14:53:28',0,'2013-12-25 20:17:24',NULL,NULL),(2741,503,'1371119','834','00','005010X220A1','1371119','','2013-12-22','16:12:48',0,'2013-12-25 21:18:27',NULL,NULL),(7104,1236,'51062','834','00','005010X220A1','51062','','2013-12-18','12:23:49',0,'2013-12-26 04:03:42',NULL,NULL),(5049,936,'55808','834','00','005010X220A1','55808','','2013-12-10','22:47:58',0,'2013-12-26 00:47:32',NULL,NULL),(18453,3423,'1545218','834','00','005010X220A1','1545218','','2014-02-10','04:13:58',0,'2014-02-10 11:00:36',NULL,NULL),(18825,3490,'2078372','834','00','005010X220A1','2078372','','2014-02-11','11:12:57',0,'2014-02-11 21:01:34',NULL,NULL),(22642,4253,'3684542','834','00','005010X220A1','3684542','','2014-03-05','12:40:00',0,'2014-03-05 21:31:47',NULL,NULL),(336,72,'389345','834','00','005010X220A1','389345','','2013-12-04','15:06:38',0,'2013-12-25 17:46:19',NULL,NULL),(18006,3318,'2434420','834','00','005010X220A1','2434420','','2014-02-06','15:49:52',0,'2014-02-06 21:00:11',NULL,NULL),(17878,3294,'2554883','834','00','005010X220A1','2554883','','2014-02-04','20:09:50',0,'2014-02-05 21:30:20',NULL,NULL),(17717,3261,'2837003','834','00','005010X220A1','2837003','','2014-02-04','13:44:07',0,'2014-02-04 21:00:39',NULL,NULL),(2077,342,'750397','834','00','005010X220A1','750397','','2013-12-09','11:27:41',0,'2013-12-25 19:37:18',NULL,NULL),(15718,2709,'1639847','834','00','005010X220A1','1639847','','2014-01-19','11:54:06',0,'2014-01-21 08:45:42',NULL,NULL),(6235,1168,'600133','834','00','005010X220A1','600133','','2013-12-20','17:55:23',0,'2013-12-26 03:05:25',NULL,NULL),(15090,2585,'2026706','834','00','005010X220A1','2026706','','2014-01-15','17:05:45',0,'2014-01-16 08:45:13',NULL,NULL),(2580,473,'949854','834','00','005010X220A1','949854','','2013-10-31','23:29:50',0,'2013-12-25 20:45:19',NULL,NULL),(3355,587,'66239','834','00','005010X220A1','66239','','2013-12-17','09:22:07',0,'2013-12-25 21:50:18',NULL,NULL),(20497,3845,'3667048','834','00','005010X220A1','3667048','','2014-02-20','17:19:13',0,'2014-02-20 22:01:01',NULL,NULL),(22785,4277,'3411265','834','00','005010X220A1','3411265','','2014-03-06','14:25:01',0,'2014-03-06 21:00:54',NULL,NULL),(11312,1456,'2072353','834','00','005010X220A1','2072353','','2013-12-26','12:00:22',0,'2013-12-27 02:03:53',NULL,NULL),(18054,3319,'2921141','834','00','005010X220A1','2921141','','2014-02-06','14:52:53',0,'2014-02-06 21:00:44',NULL,NULL),(16695,3063,'2070903','834','00','005010X220A1','2070903','','2014-01-27','16:07:06',0,'2014-01-27 21:00:40',NULL,NULL),(13550,2243,'2225106','834','00','005010X220A1','2225106','','2014-01-06','14:28:17',0,'2014-01-07 04:06:26',NULL,NULL),(4326,751,'738920','834','00','005010X220A1','738920','','2013-12-18','22:24:15',0,'2013-12-25 23:10:01',NULL,NULL),(4478,802,'555861','834','00','005010X220A1','555861','','2013-11-26','11:35:57',0,'2013-12-25 23:31:19',NULL,NULL),(7376,1293,'13366','834','00','005010X220A1','13366','','2013-12-20','18:47:26',0,'2013-12-26 04:30:02',NULL,NULL),(4784,863,'982510','834','00','005010X220A1','982510','','2013-12-01','13:12:27',0,'2013-12-26 00:01:24',NULL,NULL),(4783,862,'1172006','834','00','005010X220A1','1172006','','2013-12-01','12:23:36',0,'2013-12-26 00:01:22',NULL,NULL),(18236,3363,'2996440','834','00','005010X220A1','2996440','','2014-02-07','09:08:36',0,'2014-02-07 19:01:02',NULL,NULL),(12272,1623,'1587897','834','00','005010X220A1','1587897','','2014-01-01','10:48:24',1,'2014-01-02 04:24:18',NULL,NULL),(6052,1159,'1169387','834','00','005010X220A1','1169387','','2013-11-10','14:21:12',0,'2013-12-26 02:46:40',NULL,NULL),(15315,2622,'2243844','834','00','005010X220A1','2243844','','2014-01-16','01:08:53',0,'2014-01-17 03:35:08',NULL,NULL),(20370,3822,'2557862','834','00','005010X220A1','2557862','','2014-02-19','10:59:05',0,'2014-02-20 05:33:27',NULL,NULL),(22888,4282,'3843460','834','00','005010X220A1','3843460','','2014-03-06','15:31:55',0,'2014-03-06 21:02:07',NULL,NULL),(13086,1930,'0001','999','BE','005010X231A1','1262648','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:59',NULL,NULL),(17600,3240,'2512767','834','00','005010X220A1','2512767','','2014-02-03','12:13:10',0,'2014-02-03 21:00:58',NULL,NULL),(7549,1301,'1169021','834','00','005010X220A1','1169021','','2013-12-20','19:14:41',0,'2013-12-26 04:35:34',NULL,NULL),(13524,2237,'2342661','834','00','005010X220A1','2342661','','2014-01-06','09:43:06',0,'2014-01-07 04:05:32',NULL,NULL),(13182,2026,'0001','999','BE','005010X231A1','853860','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:02',NULL,NULL),(5299,986,'384021','834','00','005010X220A1','384021','','2013-11-04','21:10:39',0,'2013-12-26 01:01:23',NULL,NULL),(5449,1036,'160542','834','00','005010X220A1','160542','','2013-11-03','14:00:01',0,'2013-12-26 01:31:59',NULL,NULL),(18639,3463,'2788705','834','00','005010X220A1','2788705','','2014-02-09','21:55:01',0,'2014-02-10 21:31:31',NULL,NULL),(18895,3500,'2164376','834','00','005010X220A1','2164376','','2014-02-11','10:06:48',0,'2014-02-11 21:02:31',NULL,NULL),(18977,3537,'2676108','834','00','005010X220A1','2676108','','2014-02-12','09:25:05',0,'2014-02-12 21:30:12',NULL,NULL),(19290,3582,'2710077','834','00','005010X220A1','2710077','','2014-02-13','14:49:36',0,'2014-02-13 22:01:05',NULL,NULL),(12985,1736,'2126470','834','00','005010X220A1','2126470','','2014-01-04','00:49:37',0,'2014-01-05 00:01:35',NULL,NULL),(12707,1677,'1469597','834','00','005010X220A1','1469597','','2014-01-02','14:36:16',0,'2014-01-03 02:05:01',NULL,NULL),(7637,1309,'1361213','834','00','005010X220A1','1361213','','2013-12-21','11:55:42',0,'2013-12-26 04:38:25',NULL,NULL),(17182,3148,'1969778','834','00','005010X220A1','1969778','','2014-01-29','22:41:18',0,'2014-01-30 21:00:58',NULL,NULL),(16115,2807,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:44:43',NULL,NULL),(13510,2233,'1493772','834','00','005010X220A1','1493772','','2014-01-06','17:02:53',0,'2014-01-07 04:05:04',NULL,NULL),(4701,834,'396450','834','00','005010X220A1','396450','','2013-12-23','22:47:56',0,'2013-12-25 23:50:41',NULL,NULL),(7518,1300,'239222','834','00','005010X220A1','239222','','2013-12-21','11:51:11',0,'2013-12-26 04:34:38',NULL,NULL),(3080,545,'1098459','834','00','005010X220A1','1098459','','2013-12-13','12:35:49',0,'2013-12-25 21:35:36',NULL,NULL),(5022,935,'80660','834','00','005010X220A1','80660','','2013-12-11','11:44:47',0,'2013-12-26 00:46:39',NULL,NULL),(19559,3626,'2959662','834','00','005010X220A1','2959662','','2014-02-14','08:36:01',0,'2014-02-14 21:31:08',NULL,NULL),(20445,3841,'3388067','834','00','005010X220A1','3388067','','2014-02-20','16:21:00',0,'2014-02-20 22:00:19',NULL,NULL),(23292,4380,'3403743','834','00','005010X220A1','3403743','','2014-03-08','15:29:21',0,'2014-03-08 21:30:13',NULL,NULL),(394,76,'661887','834','00','005010X220A1','661887','','2013-12-04','12:00:16',0,'2013-12-25 17:48:11',NULL,NULL),(18269,3377,'2608189','834','00','005010X220A1','2608189','','2014-02-07','18:17:07',0,'2014-02-08 19:00:15',NULL,NULL),(17566,3236,'2806471','834','00','005010X220A1','2806471','','2014-02-03','12:23:20',0,'2014-02-03 21:00:36',NULL,NULL),(10962,1410,'1544295','834','00','005010X220A1','1544295','','2013-12-23','18:23:10',0,'2013-12-26 13:09:31',NULL,NULL),(15461,2632,'1816354','834','00','005010X220A1','1816354','','2014-01-15','19:01:41',0,'2014-01-17 03:36:14',NULL,NULL),(14877,2556,'1822543','834','00','005010X220A1','1822543','','2014-01-14','15:24:11',0,'2014-01-15 02:07:19',NULL,NULL),(5972,1118,'529785','834','00','005010X220A1','529785','','2013-12-14','20:50:58',0,'2013-12-26 02:33:04',NULL,NULL),(3444,604,'1204236','834','00','005010X220A1','1204236','','2013-12-17','10:52:01',0,'2013-12-25 21:53:07',NULL,NULL),(4168,734,'1295269','834','00','005010X220A1','1295269','','2013-12-19','10:05:41',0,'2013-12-25 23:05:12',NULL,NULL),(19326,3583,'2837241','834','00','005010X220A1','2837241','','2014-02-13','12:40:15',0,'2014-02-13 22:01:34',NULL,NULL),(2838,511,'260014','834','00','005010X220A1','260014','','2013-12-22','09:34:35',0,'2013-12-25 21:21:36',NULL,NULL),(16972,3116,'1790603','834','00','005010X220A1','1790603','','2014-01-29','16:40:18',0,'2014-01-29 21:00:37',NULL,NULL),(7387,1293,'215634','834','00','005010X220A1','215634','','2013-12-21','12:37:47',0,'2013-12-26 04:30:24',NULL,NULL),(5854,1097,'69896','834','00','005010X220A1','69896','','2013-11-23','08:09:06',0,'2013-12-26 02:16:17',NULL,NULL),(15773,2717,'2292795','834','00','005010X220A1','2292795','','2014-01-20','01:55:50',0,'2014-01-21 08:46:31',NULL,NULL),(15572,2657,'2264720','834','00','005010X220A1','2264720','','2014-01-17','13:47:15',0,'2014-01-20 08:06:05',NULL,NULL),(15114,2587,'2052504','834','00','005010X220A1','2052504','','2014-01-15','12:33:25',0,'2014-01-16 08:45:30',NULL,NULL),(5743,1070,'561085','834','00','005010X220A1','561085','','2013-12-14','11:37:58',0,'2013-12-26 02:01:42',NULL,NULL),(4397,775,'444401','834','00','005010X220A1','444401','','2013-11-26','18:57:18',0,'2013-12-25 23:15:50',NULL,NULL),(19681,3664,'1930582','834','00','005010X220A1','1930582','','2014-02-14','18:29:12',0,'2014-02-15 21:00:04',NULL,NULL),(19871,3708,'2698952','834','00','005010X220A1','2698952','','2014-02-15','23:29:13',0,'2014-02-16 19:00:17',NULL,NULL),(22202,4185,'2615942','834','00','005010X220A1','2615942','','2014-03-03','12:01:43',0,'2014-03-03 21:31:33',NULL,NULL),(23423,4405,'2836736','834','00','005010X220A1','2836736','','2014-03-09','09:47:16',0,'2014-03-09 21:00:28',NULL,NULL),(13388,2221,'1844706','834','00','005010X220A1','1844706','','2014-01-06','13:47:17',0,'2014-01-07 04:00:26',NULL,NULL),(18516,3449,'3139709','834','00','005010X220A1','3139709','','2014-02-10','15:14:05',0,'2014-02-10 21:00:13',NULL,NULL),(12701,1677,'2534562','834','00','005010X220A1','2534562','','2014-01-02','12:30:03',0,'2014-01-03 02:04:47',NULL,NULL),(12288,1624,'2548509','834','00','005010X220A1','2548509','','2014-01-01','11:48:52',1,'2014-01-02 04:24:49',NULL,NULL),(15340,2622,'1662107','834','00','005010X220A1','1662107','','2014-01-15','19:58:12',0,'2014-01-17 03:35:18',NULL,NULL),(15196,2592,'2200259','834','00','005010X220A1','2200259','','2014-01-15','14:03:05',0,'2014-01-16 08:46:23',NULL,NULL),(15034,2584,'1786422','834','00','005010X220A1','1786422','','2014-01-15','15:58:54',0,'2014-01-16 08:44:39',NULL,NULL),(13594,2259,'1735301','834','00','005010X220A1','1735301','','2014-01-05','13:19:57',1,'2014-01-07 10:22:37',NULL,NULL),(5975,1119,'73120','834','00','005010X220A1','73120','','2013-12-15','10:59:40',0,'2013-12-26 02:33:11',NULL,NULL),(2271,390,'425612','834','00','005010X220A1','425612','','2013-10-15','02:31:15',0,'2013-12-25 20:00:12',NULL,NULL),(2729,503,'1445840','834','00','005010X220A1','1445840','','2013-12-22','10:47:44',0,'2013-12-25 21:18:05',NULL,NULL),(5587,1043,'1975447','834','00','005010X220A1','1975447','','2013-12-24','23:50:55',0,'2013-12-26 01:49:14',NULL,NULL),(4588,826,'155345','834','00','005010X220A1','155345','','2013-12-23','22:55:25',0,'2013-12-25 23:46:52',NULL,NULL),(4939,919,'81749','834','00','005010X220A1','81749','','2013-11-19','10:25:39',0,'2013-12-26 00:31:26',NULL,NULL),(21616,4065,'3242125','834','00','005010X220A1','3242125','','2014-02-27','11:33:12',0,'2014-02-28 07:30:17',NULL,NULL),(22122,4178,'3128249','834','00','005010X220A1','3128249','','2014-03-03','09:22:12',0,'2014-03-03 21:30:36',NULL,NULL),(13292,2136,'0001','999','BE','005010X231A1','1227970','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:49',NULL,NULL),(12792,1703,'2057263','834','00','005010X220A1','2057263','','2014-01-03','10:50:22',0,'2014-01-04 02:00:57',NULL,NULL),(2054,336,'1315504','834','00','005010X220A1','1315504','','2013-12-09','12:43:02',0,'2013-12-25 19:36:32',NULL,NULL),(2583,474,'1019546','834','00','005010X220A1','1019546','','2013-11-01','08:34:08',0,'2013-12-25 20:45:25',NULL,NULL),(14026,2337,'1874048','834','00','005010X220A1','1874048','','2014-01-08','13:56:24',0,'2014-01-13 02:21:22',NULL,NULL),(20137,3773,'3615965','834','00','005010X220A1','3615965','','2014-02-18','18:02:56',0,'2014-02-20 04:00:20',NULL,NULL),(21311,4008,'3672244','834','00','005010X220A1','3672244','','2014-02-26','17:58:40',0,'2014-02-26 21:02:33',NULL,NULL),(21848,4113,'3758921','834','00','005010X220A1','3758921','','2014-02-28','18:00:30',0,'2014-03-01 19:00:02',NULL,NULL),(13227,2071,'0001','999','BE','005010X231A1','1260060','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:07',NULL,NULL),(5417,1025,'817898','834','00','005010X220A1','817898','','2013-11-14','09:19:13',0,'2013-12-26 01:30:52',NULL,NULL),(17512,3232,'2243127','834','00','005010X220A1','2243127','','2014-02-02','17:47:11',0,'2014-02-02 19:00:33',NULL,NULL),(16808,3089,'1650724','834','00','005010X220A1','1650724','','2014-01-28','15:13:27',0,'2014-01-28 21:00:12',NULL,NULL),(12237,1618,'1746517','834','00','005010X220A1','1746517','','2014-01-01','12:58:30',1,'2014-01-02 04:22:55',NULL,NULL),(15872,2739,'1467514','834','00','005010X220A1','1467514','','2014-01-21','09:52:35',1,'2014-01-22 03:22:23',NULL,NULL),(15458,2632,'1712007','834','00','005010X220A1','1712007','','2014-01-16','14:23:44',0,'2014-01-17 03:36:13',NULL,NULL),(19711,3672,'2746625','834','00','005010X220A1','2746625','','2014-02-15','09:28:08',0,'2014-02-15 22:00:16',NULL,NULL),(23451,4410,'2729218','834','00','005010X220A1','2729218','','2014-03-09','09:45:51',0,'2014-03-09 21:00:51',NULL,NULL),(717,120,'1169950','834','00','005010X220A1','1169950','','2013-12-16','09:47:37',0,'2013-12-25 18:07:19',NULL,NULL),(16848,3092,'2369461','834','00','005010X220A1','2369461','','2014-01-28','13:38:49',0,'2014-01-28 21:00:38',NULL,NULL),(16363,2985,'1637504','834','00','005010X220A1','1637504','','2014-01-23','09:43:59',0,'2014-01-23 21:00:57',NULL,NULL),(2420,417,'700754','834','00','005010X220A1','700754','','2013-12-06','14:33:05',0,'2013-12-25 20:17:54',NULL,NULL),(3275,583,'474238','834','00','005010X220A1','474238','','2013-12-16','20:28:06',0,'2013-12-25 21:47:39',NULL,NULL),(3146,556,'254289','834','00','005010X220A1','254289','','2013-12-13','12:57:36',0,'2013-12-25 21:37:37',NULL,NULL),(19789,3676,'2453687','834','00','005010X220A1','2453687','','2014-02-14','22:58:11',0,'2014-02-15 22:01:13',NULL,NULL),(20759,3905,'2737598','834','00','005010X220A1','2737598','','2014-02-24','18:34:16',0,'2014-02-25 21:30:27',NULL,NULL),(22946,4301,'3361189','834','00','005010X220A1','3361189','','2014-03-06','12:12:25',0,'2014-03-06 21:02:50',NULL,NULL),(12450,1639,'2115442','834','00','005010X220A1','2115442','','2013-12-30','19:56:45',1,'2014-01-02 04:31:30',NULL,NULL),(18972,3537,'2442157','834','00','005010X220A1','2442157','','2014-02-11','21:53:07',0,'2014-02-12 21:30:07',NULL,NULL),(18387,3407,'2633987','834','00','005010X220A1','2633987','','2014-02-09','17:16:04',0,'2014-02-09 19:00:26',NULL,NULL),(11592,1492,'2155380','834','00','005010X220A1','2155380','','2013-12-27','18:08:49',0,'2013-12-28 03:34:29',NULL,NULL),(23002,4322,'3807934','834','00','005010X220A1','3807934','','2014-03-07','13:17:25',0,'2014-03-07 21:00:12',NULL,NULL),(5838,1092,'488995','834','00','005010X220A1','488995','','2013-11-23','09:44:29',0,'2013-12-26 02:15:41',NULL,NULL),(3704,633,'385871','834','00','005010X220A1','385871','','2013-12-12','14:34:20',0,'2013-12-25 22:07:38',NULL,NULL),(15536,2654,'1426806','834','00','005010X220A1','1426806','','2014-01-17','11:09:22',0,'2014-01-20 08:05:38',NULL,NULL),(3411,591,'1259223','834','00','005010X220A1','1259223','','2013-12-17','13:41:14',0,'2013-12-25 21:52:04',NULL,NULL),(11903,1563,'2332134','834','00','005010X220A1','2332134','','2013-12-28','18:20:57',0,'2013-12-30 00:01:07',NULL,NULL),(17407,3198,'2572783','834','00','005010X220A1','2572783','','2014-02-01','16:10:27',0,'2014-02-01 19:00:14',NULL,NULL),(19482,3620,'2806818','834','00','005010X220A1','2806818','','2014-02-13','23:23:46',0,'2014-02-14 21:30:13',NULL,NULL),(19501,3621,'2882227','834','00','005010X220A1','2882227','','2014-02-13','22:28:39',0,'2014-02-14 21:30:26',NULL,NULL),(22295,4201,'3281941','834','00','005010X220A1','3281941','','2014-03-04','08:22:39',0,'2014-03-04 21:00:55',NULL,NULL),(22687,4257,'3527344','834','00','005010X220A1','3527344','','2014-03-05','09:08:34',0,'2014-03-05 21:32:18',NULL,NULL),(1843,321,'1065432','834','00','005010X220A1','1065432','','2013-12-10','16:52:05',0,'2013-12-25 19:21:03',NULL,NULL),(2390,414,'771957','834','00','005010X220A1','771957','','2013-12-06','12:03:42',0,'2013-12-25 20:16:53',NULL,NULL),(16644,3060,'1578394','834','00','005010X220A1','1578394','','2014-01-27','09:59:55',0,'2014-01-27 21:00:07',NULL,NULL),(12153,1591,'1753894','834','00','005010X220A1','1753894','','2013-12-30','16:18:11',0,'2014-01-01 12:07:34',NULL,NULL),(3379,587,'594975','834','00','005010X220A1','594975','','2013-12-17','16:35:10',0,'2013-12-25 21:51:03',NULL,NULL),(5675,1055,'425430','834','00','005010X220A1','425430','','2013-12-24','20:23:08',0,'2013-12-26 01:52:13',NULL,NULL),(5061,936,'1236618','834','00','005010X220A1','1236618','','2013-12-11','10:25:42',0,'2013-12-26 00:47:56',NULL,NULL),(4185,734,'755266','834','00','005010X220A1','755266','','2013-12-19','14:45:00',0,'2013-12-25 23:05:46',NULL,NULL),(11613,1494,'1066307','834','00','005010X220A1','1066307','','2013-12-27','11:25:51',0,'2013-12-28 03:35:08',NULL,NULL),(19853,3698,'3162507','834','00','005010X220A1','3162507','','2014-02-15','13:08:25',0,'2014-02-15 22:02:09',NULL,NULL),(19927,3733,'3524516','834','00','005010X220A1','3524516','','2014-02-17','20:56:33',0,'2014-02-18 21:30:02',NULL,NULL),(20149,3775,'3215690','834','00','005010X220A1','3215690','','2014-02-19','15:59:40',0,'2014-02-20 04:03:36',NULL,NULL),(20977,3956,'3439712','834','00','005010X220A1','3439712','','2014-02-22','14:32:27',0,'2014-02-26 08:30:16',NULL,NULL),(5640,1048,'1370102','834','00','005010X220A1','1370102','','2013-12-24','21:31:45',0,'2013-12-26 01:50:59',NULL,NULL),(17060,3125,'2181107','834','00','005010X220A1','2181107','','2014-01-29','12:10:40',0,'2014-01-29 21:01:33',NULL,NULL),(1733,293,'1215637','834','00','005010X220A1','1215637','','2013-12-10','10:53:21',0,'2013-12-25 19:17:29',NULL,NULL),(15197,2592,'2392680','834','00','005010X220A1','2392680','','2014-01-15','14:58:34',0,'2014-01-16 08:46:24',NULL,NULL),(2777,506,'1255916','834','00','005010X220A1','1255916','','2013-12-21','22:44:21',0,'2013-12-25 21:19:33',NULL,NULL),(2021,331,'75282','834','00','005010X220A1','75282','','2013-12-09','14:36:40',0,'2013-12-25 19:35:32',NULL,NULL),(12896,1710,'2219147','834','00','005010X220A1','2219147','','2014-01-02','21:46:31',0,'2014-01-04 02:04:44',NULL,NULL),(12607,1671,'1755407','834','00','005010X220A1','1755407','','2014-01-01','20:45:55',0,'2014-01-03 02:01:21',NULL,NULL),(21865,4119,'3125522','834','00','005010X220A1','3125522','','2014-03-01','13:41:10',0,'2014-03-01 19:00:12',NULL,NULL),(1679,290,'853589','834','00','005010X220A1','853589','','2013-12-10','17:47:47',0,'2013-12-25 19:15:48',NULL,NULL),(17290,3172,'2660090','834','00','005010X220A1','2660090','','2014-01-31','13:06:41',0,'2014-01-31 21:00:35',NULL,NULL),(4652,828,'1104540','834','00','005010X220A1','1104540','','2013-12-23','21:46:05',0,'2013-12-25 23:48:58',NULL,NULL),(3733,640,'235328','834','00','005010X220A1','235328','','2013-12-12','11:10:27',0,'2013-12-25 22:08:39',NULL,NULL),(14034,2337,'1741618','834','00','005010X220A1','1741618','','2014-01-08','14:50:32',0,'2014-01-13 02:21:27',NULL,NULL),(12053,1585,'1835420','834','00','005010X220A1','1835420','','2013-12-30','09:17:17',0,'2014-01-01 12:04:06',NULL,NULL),(20251,3793,'2916472','834','00','005010X220A1','2916472','','2014-02-19','00:10:24',0,'2014-02-20 04:32:26',NULL,NULL),(21497,4030,'2667200','834','00','005010X220A1','2667200','','2014-02-27','10:37:09',0,'2014-02-28 06:31:20',NULL,NULL),(22092,4176,'3206939','834','00','005010X220A1','3206939','','2014-03-02','22:22:23',0,'2014-03-03 21:30:12',NULL,NULL),(682,109,'782686','834','00','005010X220A1','782686','','2013-12-16','15:00:01',0,'2013-12-25 18:06:10',NULL,NULL),(11245,1454,'1980304','834','00','005010X220A1','1980304','','2013-12-26','14:15:04',0,'2013-12-27 02:01:48',NULL,NULL),(3316,584,'154889','834','00','005010X220A1','154889','','2013-12-17','16:09:14',0,'2013-12-25 21:49:03',NULL,NULL),(4330,753,'1279849','834','00','005010X220A1','1279849','','2013-12-19','07:25:00',0,'2013-12-25 23:10:09',NULL,NULL),(14308,2391,'1557813','834','00','005010X220A1','1557813','','2014-01-10','16:17:07',0,'2014-01-13 03:00:35',NULL,NULL),(13943,2318,'1980662','834','00','005010X220A1','1980662','','2014-01-08','23:32:40',0,'2014-01-13 02:20:15',NULL,NULL),(13016,1744,'2434838','834','00','005010X220A1','2434838','','2014-01-04','13:44:15',0,'2014-01-05 00:02:48',NULL,NULL),(5498,1041,'2021258','834','00','005010X220A1','2021258','','2013-12-24','19:22:58',0,'2013-12-26 01:46:21',NULL,NULL),(12661,1673,'2064030','834','00','005010X220A1','2064030','','2014-01-02','10:03:08',0,'2014-01-03 02:03:22',NULL,NULL),(18040,3319,'2032371','834','00','005010X220A1','2032371','','2014-02-06','17:03:42',0,'2014-02-06 21:00:35',NULL,NULL),(18509,3446,'2988857','834','00','005010X220A1','2988857','','2014-02-10','14:38:22',0,'2014-02-10 21:00:09',NULL,NULL),(19673,3660,'1913728','834','00','005010X220A1','1913728','','2014-02-14','12:44:38',0,'2014-02-14 22:00:05',NULL,NULL),(20581,3868,'3076034','834','00','005010X220A1','3076034','','2014-02-21','12:55:21',0,'2014-02-21 21:30:23',NULL,NULL),(20781,3907,'3268960','834','00','005010X220A1','3268960','','2014-02-25','14:51:12',0,'2014-02-25 21:30:42',NULL,NULL),(22085,4175,'2663443','834','00','005010X220A1','2663443','','2014-03-03','06:45:13',0,'2014-03-03 21:30:06',NULL,NULL),(22340,4204,'3289534','834','00','005010X220A1','3289534','','2014-03-04','01:59:49',0,'2014-03-04 21:01:30',NULL,NULL),(22614,4251,'3848332','834','00','005010X220A1','3848332','','2014-03-04','18:32:42',0,'2014-03-05 21:31:28',NULL,NULL),(194,17,'1170710','834','00','005010X220A1','1170710','','2013-12-05','15:47:21',0,'2013-12-25 17:21:01',NULL,NULL),(2727,503,'1166598','834','00','005010X220A1','1166598','','2013-12-22','10:08:48',0,'2013-12-25 21:18:02',NULL,NULL),(14284,2378,'2355323','834','00','005010X220A1','2355323','','2014-01-09','21:59:11',0,'2014-01-13 03:00:18',NULL,NULL),(17784,3268,'1731229','834','00','005010X220A1','1731229','','2014-02-04','11:32:25',0,'2014-02-04 21:01:22',NULL,NULL),(20761,3906,'3292915','834','00','005010X220A1','3292915','','2014-02-24','18:12:25',0,'2014-02-25 21:30:28',NULL,NULL),(21249,3999,'2585885','834','00','005010X220A1','2585885','','2014-02-26','14:37:39',0,'2014-02-26 21:01:47',NULL,NULL),(21920,4127,'2645369','834','00','005010X220A1','2645369','','2014-03-01','17:21:11',0,'2014-03-01 21:00:42',NULL,NULL),(23431,4405,'2704744','834','00','005010X220A1','2704744','','2014-03-09','14:34:22',0,'2014-03-09 21:00:34',NULL,NULL),(2911,540,'532162','834','00','005010X220A1','532162','','2013-12-13','11:22:14',0,'2013-12-25 21:30:17',NULL,NULL),(14385,2413,'1721117','834','00','005010X220A1','1721117','','2014-01-12','13:35:07',0,'2014-01-13 03:01:52',NULL,NULL),(3043,544,'259568','834','00','005010X220A1','259568','','2013-12-13','11:51:02',0,'2013-12-25 21:34:23',NULL,NULL),(11321,1456,'1293408','834','00','005010X220A1','1293408','','2013-12-26','13:07:29',0,'2013-12-27 02:04:07',NULL,NULL),(19002,3538,'3100220','834','00','005010X220A1','3100220','','2014-02-12','16:11:20',0,'2014-02-12 21:30:27',NULL,NULL),(19809,3679,'3326189','834','00','005010X220A1','3326189','','2014-02-15','11:36:03',0,'2014-02-15 22:01:30',NULL,NULL),(22316,4201,'3628587','834','00','005010X220A1','3628587','','2014-03-04','15:59:22',0,'2014-03-04 21:01:09',NULL,NULL),(22545,4248,'2678833','834','00','005010X220A1','2678833','','2014-03-05','02:20:24',0,'2014-03-05 21:30:40',NULL,NULL),(11320,1456,'1894846','834','00','005010X220A1','1894846','','2013-12-26','13:05:18',0,'2013-12-27 02:04:06',NULL,NULL),(5855,1097,'819318','834','00','005010X220A1','819318','','2013-11-23','10:31:07',0,'2013-12-26 02:16:19',NULL,NULL),(15905,2743,'2026818','834','00','005010X220A1','2026818','','2014-01-21','09:51:55',1,'2014-01-22 03:22:44',NULL,NULL),(2870,516,'586941','834','00','005010X220A1','586941','','2013-12-22','08:49:39',0,'2013-12-25 21:22:38',NULL,NULL),(2342,413,'1272573','834','00','005010X220A1','1272573','','2013-12-05','23:13:48',0,'2013-12-25 20:15:26',NULL,NULL),(20226,3785,'3249470','834','00','005010X220A1','3249470','','2014-02-19','15:53:22',0,'2014-02-20 04:25:02',NULL,NULL),(22631,4252,'2698062','834','00','005010X220A1','2698062','','2014-03-05','15:05:59',0,'2014-03-05 21:31:40',NULL,NULL),(22951,4306,'3784725','834','00','005010X220A1','3784725','','2014-03-06','14:06:02',0,'2014-03-06 21:02:55',NULL,NULL),(12069,1586,'1730355','834','00','005010X220A1','1730355','','2013-12-30','09:00:14',0,'2014-01-01 12:04:41',NULL,NULL),(1626,281,'596826','834','00','005010X220A1','596826','','2013-11-19','23:05:12',0,'2013-12-25 19:01:50',NULL,NULL),(15705,2700,'2409534','834','00','005010X220A1','2409534','','2014-01-19','11:14:43',0,'2014-01-21 08:45:31',NULL,NULL),(15324,2622,'2084932','834','00','005010X220A1','2084932','','2014-01-16','14:21:14',0,'2014-01-17 03:35:12',NULL,NULL),(15318,2622,'2240314','834','00','005010X220A1','2240314','','2014-01-16','09:24:45',0,'2014-01-17 03:35:09',NULL,NULL),(3048,544,'691821','834','00','005010X220A1','691821','','2013-12-13','12:41:58',0,'2013-12-25 21:34:32',NULL,NULL),(18473,3429,'1484376','834','00','005010X220A1','1484376','','2014-02-10','04:16:53',0,'2014-02-10 11:00:54',NULL,NULL),(19439,3602,'3024111','834','00','005010X220A1','3024111','','2014-02-13','16:07:43',0,'2014-02-13 22:02:58',NULL,NULL),(23539,4435,'3737132','834','00','005010X220A1','3737132','','2014-03-10','10:06:20',0,'2014-03-10 21:00:30',NULL,NULL),(549,103,'949450','834','00','005010X220A1','949450','','2013-12-16','08:45:42',0,'2013-12-25 18:01:58',NULL,NULL),(4547,825,'1050097','834','00','005010X220A1','1050097','','2013-12-23','22:44:40',0,'2013-12-25 23:45:36',NULL,NULL),(2631,495,'185573','834','00','005010X220A1','185573','','2013-11-28','16:06:54',0,'2013-12-25 20:46:59',NULL,NULL),(15127,2587,'1878053','834','00','005010X220A1','1878053','','2014-01-15','16:45:36',0,'2014-01-16 08:45:37',NULL,NULL),(13500,2231,'1746633','834','00','005010X220A1','1746633','','2014-01-06','15:38:06',0,'2014-01-07 04:04:40',NULL,NULL),(20683,3884,'3091809','834','00','005010X220A1','3091809','','2014-02-21','14:00:47',0,'2014-02-21 22:01:14',NULL,NULL),(22179,4180,'3622883','834','00','005010X220A1','3622883','','2014-03-03','15:58:49',0,'2014-03-03 21:31:16',NULL,NULL),(22622,4251,'3170316','834','00','005010X220A1','3170316','','2014-03-05','16:11:46',0,'2014-03-05 21:31:34',NULL,NULL),(22794,4277,'3345949','834','00','005010X220A1','3345949','','2014-03-06','17:07:45',0,'2014-03-06 21:01:01',NULL,NULL),(22995,4322,'3067117','834','00','005010X220A1','3067117','','2014-03-07','10:03:38',0,'2014-03-07 21:00:09',NULL,NULL),(23031,4328,'3148116','834','00','005010X220A1','3148116','','2014-03-07','11:58:30',0,'2014-03-07 21:00:26',NULL,NULL),(11348,1456,'2191027','834','00','005010X220A1','2191027','','2013-12-26','18:26:18',0,'2013-12-27 02:04:57',NULL,NULL),(17440,3205,'2257077','834','00','005010X220A1','2257077','','2014-02-01','11:14:41',0,'2014-02-01 19:00:34',NULL,NULL),(349,72,'471248','834','00','005010X220A1','471248','','2013-12-04','13:49:56',0,'2013-12-25 17:46:46',NULL,NULL),(15632,2675,'1419291','834','00','005010X220A1','1419291','','2014-01-18','16:32:09',0,'2014-01-21 08:44:13',NULL,NULL),(15033,2584,'1624894','834','00','005010X220A1','1624894','','2014-01-15','15:30:21',0,'2014-01-16 08:44:38',NULL,NULL),(1608,281,'322658','834','00','005010X220A1','322658','','2013-11-19','23:00:18',0,'2013-12-25 19:01:25',NULL,NULL),(5737,1070,'532198','834','00','005010X220A1','532198','','2013-12-13','19:41:08',0,'2013-12-26 02:01:32',NULL,NULL),(22747,4276,'3675448','834','00','005010X220A1','3675448','','2014-03-06','12:49:07',0,'2014-03-06 21:00:27',NULL,NULL),(10501,1400,'354572','834','00','005010X220A1','354572','','2013-12-23','18:20:54',0,'2013-12-26 12:53:56',NULL,NULL),(17100,3142,'2599410','834','00','005010X220A1','2599410','','2014-01-29','20:44:51',0,'2014-01-30 21:00:06',NULL,NULL),(1237,243,'1811989','834','00','005010X220A1','1811989','','2013-12-24','10:46:24',0,'2013-12-25 18:48:51',NULL,NULL),(16164,2856,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:26:00',1,'2014-01-23 04:13:53',NULL,NULL),(1535,261,'1088764','834','00','005010X220A1','1088764','','2013-12-24','10:58:34',0,'2013-12-25 18:58:29',NULL,NULL),(3465,615,'716920','834','00','005010X220A1','716920','','2013-12-11','19:03:16',0,'2013-12-25 22:00:04',NULL,NULL),(1896,325,'778781','834','00','005010X220A1','778781','','2013-12-09','11:54:15',0,'2013-12-25 19:31:39',NULL,NULL),(1781,299,'463755','834','00','005010X220A1','463755','','2013-12-10','15:31:04',0,'2013-12-25 19:18:59',NULL,NULL),(18132,3335,'2465032','834','00','005010X220A1','2465032','','2014-02-06','10:34:48',0,'2014-02-06 21:01:39',NULL,NULL),(14823,2552,'1739250','834','00','005010X220A1','1739250','','2014-01-14','16:47:17',0,'2014-01-15 02:06:54',NULL,NULL),(17530,3235,'2417079','834','00','005010X220A1','2417079','','2014-02-03','14:23:46',0,'2014-02-03 21:00:15',NULL,NULL),(1899,325,'162014','834','00','005010X220A1','162014','','2013-12-09','12:27:46',0,'2013-12-25 19:31:44',NULL,NULL),(16790,3086,'2506431','834','00','005010X220A1','2506431','','2014-01-27','17:15:44',0,'2014-01-27 21:01:50',NULL,NULL),(2132,360,'119443','834','00','005010X220A1','119443','','2013-12-02','18:02:31',0,'2013-12-25 19:45:52',NULL,NULL),(3173,565,'410460','834','00','005010X220A1','410460','','2013-12-13','12:24:16',0,'2013-12-25 21:38:36',NULL,NULL),(14739,2550,'2288976','834','00','005010X220A1','2288976','','2014-01-14','15:37:23',0,'2014-01-15 02:06:19',NULL,NULL),(14500,2515,'2149583','834','00','005010X220A1','2149583','','2014-01-13','13:02:51',0,'2014-01-14 01:32:01',NULL,NULL),(12857,1706,'1479421','834','00','005010X220A1','1479421','','2014-01-03','09:14:57',0,'2014-01-04 02:03:20',NULL,NULL),(7044,1235,'394910','834','00','005010X220A1','394910','','2013-12-18','15:55:07',0,'2013-12-26 04:01:51',NULL,NULL),(11129,1429,'1368588','834','00','005010X220A1','1368588','','2013-12-23','14:31:31',0,'2013-12-26 13:15:10',NULL,NULL),(20309,3794,'3480326','834','00','005010X220A1','3480326','','2014-02-19','13:32:54',0,'2014-02-20 04:45:35',NULL,NULL),(20363,3821,'2934758','834','00','005010X220A1','2934758','','2014-02-18','23:19:22',0,'2014-02-20 05:30:46',NULL,NULL),(20944,3947,'3604185','834','00','005010X220A1','3604185','','2014-02-24','13:11:04',0,'2014-02-26 08:00:38',NULL,NULL),(10641,1402,'643157','834','00','005010X220A1','643157','','2013-12-23','17:24:23',0,'2013-12-26 12:58:31',NULL,NULL),(18361,3405,'2581565','834','00','005010X220A1','2581565','','2014-02-09','11:06:08',0,'2014-02-09 19:00:09',NULL,NULL),(17588,3237,'1935549','834','00','005010X220A1','1935549','','2014-02-03','16:57:07',0,'2014-02-03 21:00:50',NULL,NULL),(16794,3088,'2494200','834','00','005010X220A1','2494200','','2014-01-28','02:51:13',0,'2014-01-28 21:00:04',NULL,NULL),(7197,1239,'39608','834','00','005010X220A1','39608','','2013-12-18','17:00:45',0,'2013-12-26 04:06:32',NULL,NULL),(16155,2847,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 04:07:06',NULL,NULL),(18482,3432,'1614854','834','00','005010X220A1','1614854','','2014-02-10','04:04:00',0,'2014-02-10 11:01:00',NULL,NULL),(20413,3834,'3475046','834','00','005010X220A1','3475046','','2014-02-20','14:00:56',0,'2014-02-20 21:30:15',NULL,NULL),(20720,3897,'2965446','834','00','005010X220A1','2965446','','2014-02-25','13:42:55',0,'2014-02-25 21:00:26',NULL,NULL),(22944,4300,'2716866','834','00','005010X220A1','2716866','','2014-03-06','11:59:16',0,'2014-03-06 21:02:49',NULL,NULL),(23454,4410,'3809390','834','00','005010X220A1','3809390','','2014-03-09','11:43:34',0,'2014-03-09 21:00:54',NULL,NULL),(1865,324,'128466','834','00','005010X220A1','128466','','2013-12-09','14:04:25',0,'2013-12-25 19:30:41',NULL,NULL),(15904,2743,'1728244','834','00','005010X220A1','1728244','','2014-01-21','09:13:56',1,'2014-01-22 03:22:44',NULL,NULL),(17763,3262,'2288089','834','00','005010X220A1','2288089','','2014-02-04','15:50:03',0,'2014-02-04 21:01:08',NULL,NULL),(17262,3170,'2182248','834','00','005010X220A1','2182248','','2014-01-31','10:07:29',0,'2014-01-31 21:00:15',NULL,NULL),(19577,3629,'2178746','834','00','005010X220A1','2178746','','2014-02-13','19:16:59',0,'2014-02-14 21:31:21',NULL,NULL),(20263,3794,'2635309','834','00','005010X220A1','2635309','','2014-02-19','00:03:44',0,'2014-02-20 04:34:15',NULL,NULL),(7621,1306,'949760','834','00','005010X220A1','949760','','2013-12-21','18:06:56',0,'2013-12-26 04:37:57',NULL,NULL),(6120,1166,'760584','834','00','005010X220A1','760584','','2013-12-20','14:29:16',0,'2013-12-26 03:01:53',NULL,NULL),(2903,539,'1317163','834','00','005010X220A1','1317163','','2013-12-13','17:58:57',0,'2013-12-25 21:30:04',NULL,NULL),(2945,541,'940320','834','00','005010X220A1','940320','','2013-12-13','09:15:53',0,'2013-12-25 21:31:25',NULL,NULL),(3864,691,'618648','834','00','005010X220A1','618648','','2013-10-10','07:52:23',0,'2013-12-25 22:31:03',NULL,NULL),(5727,1069,'1266667','834','00','005010X220A1','1266667','','2013-12-14','15:43:13',0,'2013-12-26 02:01:13',NULL,NULL),(5932,1112,'488154','834','00','005010X220A1','488154','','2013-12-15','15:37:40',0,'2013-12-26 02:31:48',NULL,NULL),(5415,1025,'1104901','834','00','005010X220A1','1104901','','2013-11-14','07:42:20',0,'2013-12-26 01:30:49',NULL,NULL),(5390,1012,'109431','834','00','005010X220A1','109431','','2013-11-24','19:20:14',0,'2013-12-26 01:17:12',NULL,NULL),(11936,1572,'1719664','834','00','005010X220A1','1719664','','2013-12-29','15:54:31',0,'2013-12-30 00:02:10',NULL,NULL),(12522,1643,'2281671','834','00','005010X220A1','2281671','','2013-12-31','16:55:02',1,'2014-01-02 04:34:07',NULL,NULL),(21382,4024,'3785719','834','00','005010X220A1','3785719','','2014-02-27','13:55:54',0,'2014-02-28 06:30:28',NULL,NULL),(22088,4175,'3463154','834','00','005010X220A1','3463154','','2014-03-03','15:24:02',0,'2014-03-03 21:30:09',NULL,NULL),(12992,1738,'2207370','834','00','005010X220A1','2207370','','2014-01-04','08:39:50',0,'2014-01-05 00:01:50',NULL,NULL),(1719,293,'268291','834','00','005010X220A1','268291','','2013-12-09','20:12:10',0,'2013-12-25 19:17:05',NULL,NULL),(17644,3249,'2609503','834','00','005010X220A1','2609503','','2014-02-03','11:41:54',0,'2014-02-03 21:01:26',NULL,NULL),(15232,2596,'2432697','834','00','005010X220A1','2432697','','2014-01-15','16:22:12',0,'2014-01-16 08:46:45',NULL,NULL),(12367,1634,'1529071','834','00','005010X220A1','1529071','','2013-12-31','16:57:18',1,'2014-01-02 04:28:28',NULL,NULL),(7728,1342,'1198637','834','00','005010X220A1','1198637','','2013-10-20','14:26:25',0,'2013-12-26 05:00:08',NULL,NULL),(7615,1304,'876397','834','00','005010X220A1','876397','','2013-12-20','20:03:14',0,'2013-12-26 04:37:44',NULL,NULL),(7516,1300,'586904','834','00','005010X220A1','586904','','2013-12-21','11:31:50',0,'2013-12-26 04:34:33',NULL,NULL),(3226,578,'1033796','834','00','005010X220A1','1033796','','2013-12-17','11:21:07',0,'2013-12-25 21:46:06',NULL,NULL),(11757,1523,'1731799','834','00','005010X220A1','1731799','','2013-12-27','18:37:33',1,'2013-12-29 11:09:39',NULL,NULL),(11919,1565,'1857340','834','00','005010X220A1','1857340','','2013-12-29','12:02:21',0,'2013-12-30 00:01:35',NULL,NULL),(4641,827,'846498','834','00','005010X220A1','846498','','2013-12-24','00:12:49',0,'2013-12-25 23:48:35',NULL,NULL),(23248,4366,'3199792','834','00','005010X220A1','3199792','','2014-03-07','11:54:58',0,'2014-03-07 21:32:21',NULL,NULL),(23254,4371,'3851086','834','00','005010X220A1','3851086','','2014-03-07','13:58:54',0,'2014-03-07 21:32:26',NULL,NULL),(12808,1703,'2278098','834','00','005010X220A1','2278098','','2014-01-03','15:49:35',0,'2014-01-04 02:01:33',NULL,NULL),(18628,3459,'1972627','834','00','005010X220A1','1972627','','2014-02-10','16:38:07',0,'2014-02-10 21:31:23',NULL,NULL),(17698,3261,'2335927','834','00','005010X220A1','2335927','','2014-02-03','19:41:16',0,'2014-02-04 21:00:29',NULL,NULL),(123,7,'1032381','834','00','005010X220A1','1032381','','2013-12-05','17:06:52',0,'2013-12-25 17:18:46',NULL,NULL),(17001,3118,'2139772','834','00','005010X220A1','2139772','','2014-01-29','11:56:31',0,'2014-01-29 21:00:54',NULL,NULL),(1701,292,'989035','834','00','005010X220A1','989035','','2013-12-09','23:31:51',0,'2013-12-25 19:16:31',NULL,NULL),(15699,2700,'2456738','834','00','005010X220A1','2456738','','2014-01-18','22:44:37',0,'2014-01-21 08:45:27',NULL,NULL),(12568,1665,'2406228','834','00','005010X220A1','2406228','','2013-12-31','15:51:37',1,'2014-01-02 04:36:02',NULL,NULL),(14813,2552,'1767026','834','00','005010X220A1','1767026','','2014-01-14','11:50:21',0,'2014-01-15 02:06:50',NULL,NULL),(14670,2545,'1845975','834','00','005010X220A1','1845975','','2014-01-13','17:01:24',0,'2014-01-14 01:33:53',NULL,NULL),(14649,2530,'1504551','834','00','005010X220A1','1504551','','2014-01-13','14:05:24',0,'2014-01-14 01:33:38',NULL,NULL),(5218,952,'1228197','834','00','005010X220A1','1228197','','2013-12-10','21:07:23',0,'2013-12-26 00:52:58',NULL,NULL),(13511,2234,'1868447','834','00','005010X220A1','1868447','','2014-01-05','18:31:59',0,'2014-01-07 04:05:05',NULL,NULL),(6415,1201,'1136314','834','00','005010X220A1','1136314','','2013-12-20','17:29:30',0,'2013-12-26 03:11:04',NULL,NULL),(13595,2259,'2283107','834','00','005010X220A1','2283107','','2014-01-05','15:11:54',1,'2014-01-07 10:22:39',NULL,NULL),(20704,3893,'3350314','834','00','005010X220A1','3350314','','2014-02-24','23:50:04',0,'2014-02-25 21:00:14',NULL,NULL),(23150,4343,'3178330','834','00','005010X220A1','3178330','','2014-03-06','19:45:55',0,'2014-03-07 21:31:10',NULL,NULL),(2040,331,'1255362','834','00','005010X220A1','1255362','','2013-12-09','17:54:08',0,'2013-12-25 19:36:06',NULL,NULL),(16935,3115,'2511318','834','00','005010X220A1','2511318','','2014-01-29','00:09:49',0,'2014-01-29 21:00:13',NULL,NULL),(16237,2929,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:33:00',0,'2014-01-23 06:42:09',NULL,NULL),(3053,544,'625409','834','00','005010X220A1','625409','','2013-12-13','14:01:00',0,'2013-12-25 21:34:43',NULL,NULL),(15303,2622,'2263505','834','00','005010X220A1','2263505','','2014-01-15','21:34:26',0,'2014-01-17 03:35:02',NULL,NULL),(13603,2261,'2469680','834','00','005010X220A1','2469680','','2014-01-05','17:36:10',1,'2014-01-07 10:22:57',NULL,NULL),(3802,660,'804198','834','00','005010X220A1','804198','','2013-12-08','15:08:40',0,'2013-12-25 22:16:23',NULL,NULL),(10822,1404,'812676','834','00','005010X220A1','812676','','2013-12-23','16:56:32',0,'2013-12-26 13:04:36',NULL,NULL),(4662,831,'996152','834','00','005010X220A1','996152','','2013-12-23','21:11:44',0,'2013-12-25 23:49:18',NULL,NULL),(12973,1734,'1436416','834','00','005010X220A1','1436416','','2014-01-04','13:06:40',0,'2014-01-05 00:01:11',NULL,NULL),(2224,369,'317652','834','00','005010X220A1','317652','','2013-12-01','20:27:33',0,'2013-12-25 19:48:59',NULL,NULL),(5542,1041,'1368779','834','00','005010X220A1','1368779','','2013-12-25','00:26:18',0,'2013-12-26 01:47:48',NULL,NULL),(20855,3911,'2588644','834','00','005010X220A1','2588644','','2014-02-25','16:19:25',0,'2014-02-25 21:31:34',NULL,NULL),(5145,943,'179912','834','00','005010X220A1','179912','','2013-12-11','13:41:08',0,'2013-12-26 00:50:38',NULL,NULL),(15768,2714,'1362181','834','00','005010X220A1','1362181','','2014-01-20','14:22:54',0,'2014-01-21 08:46:28',NULL,NULL),(1310,245,'1776597','834','00','005010X220A1','1776597','','2013-12-24','08:50:40',0,'2013-12-25 18:51:07',NULL,NULL),(3878,697,'883432','834','00','005010X220A1','883432','','2013-10-04','15:21:11',0,'2013-12-25 22:31:28',NULL,NULL),(1964,326,'707222','834','00','005010X220A1','707222','','2013-12-09','14:13:17',0,'2013-12-25 19:33:37',NULL,NULL),(3724,636,'804338','834','00','005010X220A1','804338','','2013-12-12','16:46:41',0,'2013-12-25 22:08:19',NULL,NULL),(2325,408,'358821','834','00','005010X220A1','358821','','2013-10-21','20:48:22',0,'2013-12-25 20:02:05',NULL,NULL),(17916,3296,'2203310','834','00','005010X220A1','2203310','','2014-02-05','09:40:43',0,'2014-02-05 21:30:38',NULL,NULL),(18997,3538,'2145103','834','00','005010X220A1','2145103','','2014-02-12','15:40:21',0,'2014-02-12 21:30:24',NULL,NULL),(21850,4113,'3712283','834','00','005010X220A1','3712283','','2014-02-28','20:08:58',0,'2014-03-01 19:00:03',NULL,NULL),(21863,4118,'2980507','834','00','005010X220A1','2980507','','2014-02-28','20:41:50',0,'2014-03-01 19:00:11',NULL,NULL),(22812,4278,'3584747','834','00','005010X220A1','3584747','','2014-03-06','10:36:42',0,'2014-03-06 21:01:12',NULL,NULL),(5970,1117,'960756','834','00','005010X220A1','960756','','2013-12-15','17:29:41',0,'2013-12-26 02:32:59',NULL,NULL),(14735,2550,'2492430','834','00','005010X220A1','2492430','','2014-01-14','15:00:13',0,'2014-01-15 02:06:17',NULL,NULL),(5155,944,'1153633','834','00','005010X220A1','1153633','','2013-12-10','19:35:23',0,'2013-12-26 00:50:57',NULL,NULL),(2550,458,'982404','834','00','005010X220A1','982404','','2013-11-18','07:29:21',0,'2013-12-25 20:31:33',NULL,NULL),(4807,865,'957839','834','00','005010X220A1','957839','','2013-12-01','12:31:20',0,'2013-12-26 00:02:04',NULL,NULL),(3030,544,'799523','834','00','005010X220A1','799523','','2013-12-13','00:00:17',0,'2013-12-25 21:34:00',NULL,NULL),(5632,1047,'1749948','834','00','005010X220A1','1749948','','2013-12-24','18:53:37',0,'2013-12-26 01:50:44',NULL,NULL),(14727,2550,'2315273','834','00','005010X220A1','2315273','','2014-01-14','13:23:33',0,'2014-01-15 02:06:13',NULL,NULL),(2629,493,'531793','834','00','005010X220A1','531793','','2013-11-28','05:08:25',0,'2013-12-25 20:46:55',NULL,NULL),(13766,2280,'2144221','834','00','005010X220A1','2144221','','2014-01-07','15:43:46',0,'2014-01-08 18:24:59',NULL,NULL),(16762,3071,'2109899','834','00','005010X220A1','2109899','','2014-01-27','09:31:08',0,'2014-01-27 21:01:27',NULL,NULL),(18924,3518,'2452141','834','00','005010X220A1','2452141','','2014-02-11','08:18:53',0,'2014-02-11 21:30:04',NULL,NULL),(19239,3580,'2438232','834','00','005010X220A1','2438232','','2014-02-13','13:51:19',0,'2014-02-13 22:00:26',NULL,NULL),(20171,3778,'3221466','834','00','005010X220A1','3221466','','2014-02-19','13:13:31',0,'2014-02-20 04:10:06',NULL,NULL),(20193,3781,'2946288','834','00','005010X220A1','2946288','','2014-02-18','18:33:10',0,'2014-02-20 04:16:32',NULL,NULL),(7399,1295,'463058','834','00','005010X220A1','463058','','2013-12-20','18:58:20',0,'2013-12-26 04:30:50',NULL,NULL),(14831,2553,'2006558','834','00','005010X220A1','2006558','','2014-01-13','20:30:23',0,'2014-01-15 02:06:58',NULL,NULL),(14528,2518,'2341712','834','00','005010X220A1','2341712','','2014-01-13','10:06:51',0,'2014-01-14 01:32:21',NULL,NULL),(6237,1169,'1067306','834','00','005010X220A1','1067306','','2013-12-19','19:00:24',0,'2013-12-26 03:05:30',NULL,NULL),(11789,1537,'1587569','834','00','005010X220A1','1587569','','2013-12-28','20:15:02',1,'2013-12-29 11:12:47',NULL,NULL),(4341,757,'186203','834','00','005010X220A1','186203','','2013-12-19','09:06:13',0,'2013-12-25 23:10:30',NULL,NULL),(5313,993,'1146696','834','00','005010X220A1','1146696','','2013-11-04','19:47:15',0,'2013-12-26 01:01:56',NULL,NULL),(204,22,'818092','834','00','005010X220A1','818092','','2013-12-05','10:33:25',0,'2013-12-25 17:21:22',NULL,NULL),(14221,2366,'1825982','834','00','005010X220A1','1825982','','2014-01-10','13:16:10',0,'2014-01-13 02:23:58',NULL,NULL),(1666,290,'101462','834','00','005010X220A1','101462','','2013-12-09','21:40:04',0,'2013-12-25 19:15:27',NULL,NULL),(13440,2223,'2263208','834','00','005010X220A1','2263208','','2014-01-06','18:03:58',0,'2014-01-07 04:02:20',NULL,NULL),(13360,2204,'0001','999','BE','005010X231A1','891466','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:59',NULL,NULL),(13187,2031,'0001','999','BE','005010X231A1','623433','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:16',NULL,NULL),(12921,1716,'1906106','834','00','005010X220A1','1906106','','2014-01-03','12:36:51',0,'2014-01-04 02:05:40',NULL,NULL),(6082,1166,'868076','834','00','005010X220A1','868076','','2013-12-19','19:29:16',0,'2013-12-26 03:00:47',NULL,NULL),(3462,613,'354155','834','00','005010X220A1','354155','','2013-12-17','17:04:59',0,'2013-12-25 21:53:42',NULL,NULL),(5545,1041,'1760228','834','00','005010X220A1','1760228','','2013-12-25','11:30:01',0,'2013-12-26 01:47:53',NULL,NULL),(22891,4283,'3636958','834','00','005010X220A1','3636958','','2014-03-05','19:45:12',0,'2014-03-06 21:02:09',NULL,NULL),(22962,4312,'3551373','834','00','005010X220A1','3551373','','2014-03-06','10:39:55',0,'2014-03-06 21:30:06',NULL,NULL),(23172,4345,'3828915','834','00','005010X220A1','3828915','','2014-03-06','20:27:02',0,'2014-03-07 21:31:27',NULL,NULL),(246,42,'88159','834','00','005010X220A1','88159','','2013-11-13','15:28:34',0,'2013-12-25 17:30:43',NULL,NULL),(815,161,'1061226','834','00','005010X220A1','1061226','','2013-11-11','13:06:49',0,'2013-12-25 18:10:44',NULL,NULL),(14048,2338,'2455422','834','00','005010X220A1','2455422','','2014-01-08','17:49:15',0,'2014-01-13 02:21:35',NULL,NULL),(12466,1639,'1982983','834','00','005010X220A1','1982983','','2013-12-31','17:46:27',1,'2014-01-02 04:32:07',NULL,NULL),(1392,245,'1660018','834','00','005010X220A1','1660018','','2013-12-24','17:49:41',0,'2013-12-25 18:53:46',NULL,NULL),(5610,1044,'1796948','834','00','005010X220A1','1796948','','2013-12-24','21:31:51',0,'2013-12-26 01:49:57',NULL,NULL),(5614,1044,'1824269','834','00','005010X220A1','1824269','','2013-12-24','23:11:31',0,'2013-12-26 01:50:07',NULL,NULL),(3288,584,'1228402','834','00','005010X220A1','1228402','','2013-12-16','20:43:40',0,'2013-12-25 21:48:03',NULL,NULL),(2895,532,'18602','834','00','005010X220A1','18602','','2013-12-22','15:52:38',0,'2013-12-25 21:23:33',NULL,NULL),(1630,281,'63227','834','00','005010X220A1','63227','','2013-11-19','23:06:23',0,'2013-12-25 19:01:56',NULL,NULL),(17166,3145,'1531154','834','00','005010X220A1','1531154','','2014-01-30','10:32:35',0,'2014-01-30 21:00:47',NULL,NULL),(18749,3485,'2608276','834','00','005010X220A1','2608276','','2014-02-11','14:22:33',0,'2014-02-11 21:00:37',NULL,NULL),(21074,3980,'3503931','834','00','005010X220A1','3503931','','2014-02-24','16:29:39',0,'2014-02-26 09:30:45',NULL,NULL),(22446,4231,'3086525','834','00','005010X220A1','3086525','','2014-03-04','14:59:47',0,'2014-03-04 21:30:13',NULL,NULL),(22615,4251,'3757589','834','00','005010X220A1','3757589','','2014-03-04','23:45:43',0,'2014-03-05 21:31:29',NULL,NULL),(243,42,'274713','834','00','005010X220A1','274713','','2013-11-13','10:58:58',0,'2013-12-25 17:30:37',NULL,NULL),(439,80,'894441','834','00','005010X220A1','894441','','2013-12-04','11:22:31',0,'2013-12-25 17:49:37',NULL,NULL),(7077,1236,'331457','834','00','005010X220A1','331457','','2013-12-18','09:22:28',0,'2013-12-26 04:02:54',NULL,NULL),(3516,615,'375140','834','00','005010X220A1','375140','','2013-12-12','16:53:17',0,'2013-12-25 22:01:41',NULL,NULL),(15888,2740,'1895546','834','00','005010X220A1','1895546','','2014-01-21','13:56:01',1,'2014-01-22 03:22:33',NULL,NULL),(17386,3194,'2441883','834','00','005010X220A1','2441883','','2014-01-31','16:28:02',0,'2014-01-31 21:01:43',NULL,NULL),(17434,3204,'1978825','834','00','005010X220A1','1978825','','2014-02-01','14:00:51',0,'2014-02-01 19:00:30',NULL,NULL),(17917,3296,'2160383','834','00','005010X220A1','2160383','','2014-02-05','09:56:48',0,'2014-02-05 21:30:39',NULL,NULL),(18657,3465,'1389156','834','00','005010X220A1','1389156','','2014-02-09','23:49:44',0,'2014-02-10 21:31:44',NULL,NULL),(18772,3486,'3051532','834','00','005010X220A1','3051532','','2014-02-10','22:53:57',0,'2014-02-11 21:00:55',NULL,NULL),(19566,3626,'2195978','834','00','005010X220A1','2195978','','2014-02-14','17:27:57',0,'2014-02-14 21:31:14',NULL,NULL),(21123,3994,'3700500','834','00','005010X220A1','3700500','','2014-02-26','16:07:29',0,'2014-02-26 21:00:25',NULL,NULL),(601,107,'1124925','834','00','005010X220A1','1124925','','2013-12-16','15:30:51',0,'2013-12-25 18:03:37',NULL,NULL),(616,108,'837414','834','00','005010X220A1','837414','','2013-12-16','00:44:32',0,'2013-12-25 18:04:06',NULL,NULL),(14636,2527,'2315223','834','00','005010X220A1','2315223','','2014-01-13','13:14:39',0,'2014-01-14 01:33:29',NULL,NULL),(3285,584,'981763','834','00','005010X220A1','981763','','2013-12-16','19:23:56',0,'2013-12-25 21:47:58',NULL,NULL),(11842,1544,'646945','834','00','005010X220A1','646945','','2013-12-28','20:26:13',1,'2013-12-29 11:14:28',NULL,NULL),(20351,3811,'2121264','834','00','005010X220A1','2121264','','2014-02-19','14:28:39',0,'2014-02-20 04:55:05',NULL,NULL),(20697,3892,'3368060','834','00','005010X220A1','3368060','','2014-02-24','19:15:01',0,'2014-02-25 21:00:09',NULL,NULL),(88,4,'669316','834','00','005010X220A1','669316','','2013-12-05','13:05:38',0,'2013-12-25 17:17:40',NULL,NULL),(16128,2820,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:11:00',1,'2014-01-23 03:49:11',NULL,NULL),(16003,2766,'1789239','834','00','005010X220A1','1789239','','2014-01-22','15:53:24',0,'2014-01-23 03:02:15',NULL,NULL),(14139,2353,'2582014','834','00','005010X220A1','2582014','','2014-01-08','16:25:52',0,'2014-01-13 02:22:35',NULL,NULL),(4996,935,'1175776','834','00','005010X220A1','1175776','','2013-12-11','09:01:29',0,'2013-12-26 00:45:50',NULL,NULL),(12253,1620,'2197295','834','00','005010X220A1','2197295','','2013-12-31','21:27:06',1,'2014-01-02 04:23:32',NULL,NULL),(12102,1587,'1630641','834','00','005010X220A1','1630641','','2013-12-30','09:24:06',0,'2014-01-01 12:05:46',NULL,NULL),(12019,1583,'1849086','834','00','005010X220A1','1849086','','2013-12-30','12:15:19',0,'2014-01-01 12:02:48',NULL,NULL),(2771,506,'642981','834','00','005010X220A1','642981','','2013-12-21','21:40:41',0,'2013-12-25 21:19:23',NULL,NULL),(17554,3236,'2262416','834','00','005010X220A1','2262416','','2014-02-02','22:48:42',0,'2014-02-03 21:00:29',NULL,NULL),(17596,3240,'1995365','834','00','005010X220A1','1995365','','2014-02-03','10:41:00',0,'2014-02-03 21:00:56',NULL,NULL),(21999,4146,'2749793','834','00','005010X220A1','2749793','','2014-03-02','14:46:41',0,'2014-03-03 01:00:22',NULL,NULL),(1957,326,'874630','834','00','005010X220A1','874630','','2013-12-09','13:28:24',0,'2013-12-25 19:33:26',NULL,NULL),(4434,795,'1215269','834','00','005010X220A1','1215269','','2013-11-05','23:42:46',0,'2013-12-25 23:17:11',NULL,NULL),(17391,3198,'2236176','834','00','005010X220A1','2236176','','2014-01-31','18:36:16',0,'2014-02-01 19:00:03',NULL,NULL),(21256,3999,'3472677','834','00','005010X220A1','3472677','','2014-02-26','16:38:05',0,'2014-02-26 21:01:52',NULL,NULL),(5225,954,'581701','834','00','005010X220A1','581701','','2013-12-11','08:56:20',0,'2013-12-26 00:53:14',NULL,NULL),(2252,378,'588467','834','00','005010X220A1','588467','','2013-12-02','16:19:36',0,'2013-12-25 19:50:00',NULL,NULL),(12653,1672,'2543773','834','00','005010X220A1','2543773','','2014-01-02','15:06:21',0,'2014-01-03 02:03:02',NULL,NULL),(13273,2117,'0001','999','BE','005010X231A1','457234','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:56',NULL,NULL),(18316,3384,'2066315','834','00','005010X220A1','2066315','','2014-02-08','12:14:52',0,'2014-02-08 19:00:45',NULL,NULL),(18701,3480,'2884539','834','00','005010X220A1','2884539','','2014-02-10','14:03:42',0,'2014-02-10 21:32:14',NULL,NULL),(19348,3583,'2576930','834','00','005010X220A1','2576930','','2014-02-13','16:48:40',0,'2014-02-13 22:01:51',NULL,NULL),(21235,3999,'3410983','834','00','005010X220A1','3410983','','2014-02-26','11:55:30',0,'2014-02-26 21:01:38',NULL,NULL),(22676,4255,'3125637','834','00','005010X220A1','3125637','','2014-03-05','13:28:58',0,'2014-03-05 21:32:10',NULL,NULL),(1217,243,'1862994','834','00','005010X220A1','1862994','','2013-12-24','08:29:01',0,'2013-12-25 18:48:17',NULL,NULL),(16837,3091,'2330488','834','00','005010X220A1','2330488','','2014-01-28','16:04:21',0,'2014-01-28 21:00:30',NULL,NULL),(2422,417,'553405','834','00','005010X220A1','553405','','2013-12-06','18:06:53',0,'2013-12-25 20:17:56',NULL,NULL),(16675,3061,'1378645','834','00','005010X220A1','1378645','','2014-01-27','15:44:52',0,'2014-01-27 21:00:27',NULL,NULL),(15349,2623,'1897872','834','00','005010X220A1','1897872','','2014-01-15','23:13:05',0,'2014-01-17 03:35:23',NULL,NULL),(15291,2616,'2495142','834','00','005010X220A1','2495142','','2014-01-15','15:30:08',0,'2014-01-16 08:47:26',NULL,NULL),(7612,1303,'356814','834','00','005010X220A1','356814','','2013-12-21','16:35:31',0,'2013-12-26 04:37:38',NULL,NULL),(13655,2271,'2280539','834','00','005010X220A1','2280539','','2014-01-07','14:47:59',0,'2014-01-08 18:24:12',NULL,NULL),(5070,936,'1094621','834','00','005010X220A1','1094621','','2013-12-11','12:35:39',0,'2013-12-26 00:48:15',NULL,NULL),(22587,4248,'3229981','834','00','005010X220A1','3229981','','2014-03-05','17:58:20',0,'2014-03-05 21:31:09',NULL,NULL),(490,102,'414404','834','00','005010X220A1','414404','','2013-12-15','19:51:30',0,'2013-12-25 18:00:10',NULL,NULL),(11249,1454,'61430','834','00','005010X220A1','61430','','2013-12-26','14:24:51',0,'2013-12-27 02:01:56',NULL,NULL),(14273,2375,'1750361','834','00','005010X220A1','1750361','','2014-01-10','15:14:18',0,'2014-01-13 03:00:12',NULL,NULL),(16246,2938,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:53:00',0,'2014-01-23 06:48:31',NULL,NULL),(15946,2761,'2103248','834','00','005010X220A1','2103248','','2014-01-21','15:36:58',1,'2014-01-22 03:23:11',NULL,NULL),(15865,2738,'2562162','834','00','005010X220A1','2562162','','2014-01-21','15:40:27',1,'2014-01-22 03:22:18',NULL,NULL),(4218,738,'185131','834','00','005010X220A1','185131','','2013-12-18','21:43:09',0,'2013-12-25 23:06:46',NULL,NULL),(14362,2404,'1405926','834','00','005010X220A1','1405926','','2014-01-12','10:26:57',0,'2014-01-13 03:01:35',NULL,NULL),(4485,802,'63269','834','00','005010X220A1','63269','','2013-11-26','15:52:15',0,'2013-12-25 23:31:34',NULL,NULL),(4804,865,'647463','834','00','005010X220A1','647463','','2013-12-01','12:01:19',0,'2013-12-26 00:01:59',NULL,NULL),(18277,3377,'2636176','834','00','005010X220A1','2636176','','2014-02-08','17:48:36',0,'2014-02-08 19:00:20',NULL,NULL),(18449,3423,'2478466','834','00','005010X220A1','2478466','','2014-02-10','04:04:39',0,'2014-02-10 11:00:32',NULL,NULL),(22349,4205,'2696707','834','00','005010X220A1','2696707','','2014-03-03','18:29:22',0,'2014-03-04 21:01:38',NULL,NULL),(22858,4280,'3526413','834','00','005010X220A1','3526413','','2014-03-06','11:48:34',0,'2014-03-06 21:01:45',NULL,NULL),(6171,1167,'770249','834','00','005010X220A1','770249','','2013-12-20','15:21:59',0,'2013-12-26 03:03:27',NULL,NULL),(2322,407,'391772','834','00','005010X220A1','391772','','2013-10-22','00:17:20',0,'2013-12-25 20:01:58',NULL,NULL),(15314,2622,'1356849','834','00','005010X220A1','1356849','','2014-01-16','00:33:02',0,'2014-01-17 03:35:07',NULL,NULL),(22635,4253,'3635824','834','00','005010X220A1','3635824','','2014-03-04','18:45:55',0,'2014-03-05 21:31:42',NULL,NULL),(23096,4339,'3710191','834','00','005010X220A1','3710191','','2014-03-07','16:24:00',0,'2014-03-07 21:30:32',NULL,NULL),(23527,4434,'3161839','834','00','005010X220A1','3161839','','2014-03-10','17:06:01',0,'2014-03-10 21:00:22',NULL,NULL),(782,145,'370081','834','00','005010X220A1','370081','','2013-10-29','00:31:08',0,'2013-12-25 18:09:30',NULL,NULL),(16829,3091,'2173044','834','00','005010X220A1','2173044','','2014-01-28','11:32:39',0,'2014-01-28 21:00:26',NULL,NULL),(1296,244,'789843','834','00','005010X220A1','789843','','2013-12-24','12:36:00',0,'2013-12-25 18:50:39',NULL,NULL),(11115,1426,'1473882','834','00','005010X220A1','1473882','','2013-12-23','14:12:04',0,'2013-12-26 13:14:35',NULL,NULL),(15361,2623,'1560367','834','00','005010X220A1','1560367','','2014-01-15','19:38:34',0,'2014-01-17 03:35:28',NULL,NULL),(6056,1162,'351112','834','00','005010X220A1','351112','','2013-11-09','23:49:17',0,'2013-12-26 02:46:47',NULL,NULL),(4047,731,'872871','834','00','005010X220A1','872871','','2013-12-19','17:30:31',0,'2013-12-25 23:01:35',NULL,NULL),(5467,1040,'1286484','834','00','005010X220A1','1286484','','2013-12-24','21:25:28',0,'2013-12-26 01:45:21',NULL,NULL),(18934,3522,'2547300','834','00','005010X220A1','2547300','','2014-02-10','19:59:47',0,'2014-02-11 21:30:13',NULL,NULL),(21057,3979,'3724151','834','00','005010X220A1','3724151','','2014-02-24','13:20:16',0,'2014-02-26 09:30:32',NULL,NULL),(22491,4244,'2723985','834','00','005010X220A1','2723985','','2014-03-05','12:43:52',0,'2014-03-05 21:00:31',NULL,NULL),(23660,4443,'2849706','834','00','005010X220A1','2849706','','2014-03-10','16:11:22',0,'2014-03-10 21:01:58',NULL,NULL),(7686,1327,'343967','834','00','005010X220A1','343967','','2013-12-21','15:42:52',0,'2013-12-26 04:40:02',NULL,NULL),(7060,1236,'1250801','834','00','005010X220A1','1250801','','2013-12-17','19:59:26',0,'2013-12-26 04:02:20',NULL,NULL),(12002,1581,'2136467','834','00','005010X220A1','2136467','','2013-12-30','15:23:27',0,'2014-01-01 12:02:06',NULL,NULL),(2181,363,'343252','834','00','005010X220A1','343252','','2013-12-02','17:07:05',0,'2013-12-25 19:47:31',NULL,NULL),(17822,3274,'2621366','834','00','005010X220A1','2621366','','2014-02-04','14:07:40',0,'2014-02-04 21:01:47',NULL,NULL),(20644,3874,'3094360','834','00','005010X220A1','3094360','','2014-02-21','17:27:40',0,'2014-02-21 22:00:48',NULL,NULL),(11839,1543,'46105','834','00','005010X220A1','46105','','2013-12-28','20:24:22',1,'2013-12-29 11:14:21',NULL,NULL),(17020,3120,'1743394','834','00','005010X220A1','1743394','','2014-01-28','22:23:05',0,'2014-01-29 21:01:06',NULL,NULL),(13477,2226,'1628402','834','00','005010X220A1','1628402','','2014-01-06','13:43:14',0,'2014-01-07 04:03:47',NULL,NULL),(12873,1706,'2358812','834','00','005010X220A1','2358812','','2014-01-03','12:58:41',0,'2014-01-04 02:03:53',NULL,NULL),(12752,1690,'1576761','834','00','005010X220A1','1576761','','2014-01-02','15:05:51',0,'2014-01-03 02:06:44',NULL,NULL),(1686,291,'72932','834','00','005010X220A1','72932','','2013-12-10','12:57:58',0,'2013-12-25 19:16:02',NULL,NULL),(3159,562,'902318','834','00','005010X220A1','902318','','2013-12-13','10:39:49',0,'2013-12-25 21:38:04',NULL,NULL),(4821,874,'208497','834','00','005010X220A1','208497','','2013-12-01','14:32:29',0,'2013-12-26 00:02:30',NULL,NULL),(11533,1490,'1963882','834','00','005010X220A1','1963882','','2013-12-27','14:45:25',0,'2013-12-28 03:32:37',NULL,NULL),(17959,3299,'2775172','834','00','005010X220A1','2775172','','2014-02-05','16:29:23',0,'2014-02-05 21:30:59',NULL,NULL),(19090,3543,'2566826','834','00','005010X220A1','2566826','','2014-02-11','20:34:33',0,'2014-02-12 21:31:31',NULL,NULL),(20374,3823,'3117767','834','00','005010X220A1','3117767','','2014-02-19','09:22:05',0,'2014-02-20 05:34:26',NULL,NULL),(21071,3980,'3448655','834','00','005010X220A1','3448655','','2014-02-24','15:27:32',0,'2014-02-26 09:30:43',NULL,NULL),(23105,4341,'3110683','834','00','005010X220A1','3110683','','2014-03-07','09:50:58',0,'2014-03-07 21:30:38',NULL,NULL),(7281,1255,'1018888','834','00','005010X220A1','1018888','','2013-12-18','12:02:14',0,'2013-12-26 04:09:08',NULL,NULL),(14673,2548,'1522331','834','00','005010X220A1','1522331','','2014-01-13','18:36:29',0,'2014-01-15 02:05:50',NULL,NULL),(12322,1634,'2057185','834','00','005010X220A1','2057185','','2013-12-30','20:18:18',1,'2014-01-02 04:26:54',NULL,NULL),(3647,625,'576445','834','00','005010X220A1','576445','','2013-12-11','20:10:22',0,'2013-12-25 22:05:49',NULL,NULL),(2906,539,'1073091','834','00','005010X220A1','1073091','','2013-12-13','16:10:00',0,'2013-12-25 21:30:09',NULL,NULL),(1675,290,'1113016','834','00','005010X220A1','1113016','','2013-12-10','13:29:21',0,'2013-12-25 19:15:41',NULL,NULL),(17951,3299,'2208088','834','00','005010X220A1','2208088','','2014-02-05','13:22:33',0,'2014-02-05 21:30:55',NULL,NULL),(18109,3330,'1611056','834','00','005010X220A1','1611056','','2014-02-06','13:47:46',0,'2014-02-06 21:01:22',NULL,NULL),(19537,3624,'2923746','834','00','005010X220A1','2923746','','2014-02-13','18:31:54',0,'2014-02-14 21:30:52',NULL,NULL),(1872,324,'658187','834','00','005010X220A1','658187','','2013-12-09','16:53:26',0,'2013-12-25 19:30:55',NULL,NULL),(17132,3144,'2366089','834','00','005010X220A1','2366089','','2014-01-29','19:27:48',0,'2014-01-30 21:00:26',NULL,NULL),(14296,2383,'1660437','834','00','005010X220A1','1660437','','2014-01-10','11:22:40',0,'2014-01-13 03:00:26',NULL,NULL),(2205,365,'1014893','834','00','005010X220A1','1014893','','2013-12-02','17:06:21',0,'2013-12-25 19:48:21',NULL,NULL),(12764,1697,'1740371','834','00','005010X220A1','1740371','','2014-01-02','17:11:36',0,'2014-01-03 02:07:15',NULL,NULL),(2944,541,'38043','834','00','005010X220A1','38043','','2013-12-13','09:13:39',0,'2013-12-25 21:31:23',NULL,NULL),(11852,1549,'156604','834','00','005010X220A1','156604','','2013-12-28','20:14:42',1,'2013-12-29 11:14:52',NULL,NULL),(11637,1497,'2277912','834','00','005010X220A1','2277912','','2013-12-27','17:34:54',0,'2013-12-28 03:35:52',NULL,NULL),(18451,3423,'2356750','834','00','005010X220A1','2356750','','2014-02-10','04:10:04',0,'2014-02-10 11:00:34',NULL,NULL),(18538,3451,'2529218','834','00','005010X220A1','2529218','','2014-02-10','16:44:37',0,'2014-02-10 21:30:20',NULL,NULL),(22683,4255,'3639364','834','00','005010X220A1','3639364','','2014-03-05','17:08:52',0,'2014-03-05 21:32:16',NULL,NULL),(10815,1404,'239393','834','00','005010X220A1','239393','','2013-12-23','15:51:44',0,'2013-12-26 13:04:21',NULL,NULL),(17083,3133,'2332899','834','00','005010X220A1','2332899','','2014-01-29','13:07:57',0,'2014-01-29 21:01:47',NULL,NULL),(17037,3120,'2506488','834','00','005010X220A1','2506488','','2014-01-29','17:06:51',0,'2014-01-29 21:01:18',NULL,NULL),(16063,2773,'2182035','834','00','005010X220A1','2182035','','2014-01-22','09:37:30',0,'2014-01-23 03:02:42',NULL,NULL),(16033,2770,'2537549','834','00','005010X220A1','2537549','','2014-01-22','09:55:13',0,'2014-01-23 03:02:28',NULL,NULL),(15223,2594,'2353395','834','00','005010X220A1','2353395','','2014-01-15','16:48:34',0,'2014-01-16 08:46:40',NULL,NULL),(381,74,'456222','834','00','005010X220A1','456222','','2013-12-04','10:57:16',0,'2013-12-25 17:47:45',NULL,NULL),(988,184,'468537','834','00','005010X220A1','468537','','2013-12-03','01:36:23',0,'2013-12-25 18:19:49',NULL,NULL),(2025,331,'821011','834','00','005010X220A1','821011','','2013-12-09','15:38:56',0,'2013-12-25 19:35:39',NULL,NULL),(13042,1886,'0001','999','BE','005010X231A1','27319','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:58',NULL,NULL),(12683,1673,'1567719','834','00','005010X220A1','1567719','','2014-01-02','13:53:09',0,'2014-01-03 02:04:05',NULL,NULL),(4373,773,'64597','834','00','005010X220A1','64597','','2013-11-26','18:22:35',0,'2013-12-25 23:15:05',NULL,NULL),(4797,865,'380697','834','00','005010X220A1','380697','','2013-12-01','14:34:54',0,'2013-12-26 00:01:47',NULL,NULL),(23327,4384,'3557271','834','00','005010X220A1','3557271','','2014-03-08','10:10:25',0,'2014-03-08 21:30:41',NULL,NULL),(23345,4387,'2674043','834','00','005010X220A1','2674043','','2014-03-07','21:10:19',0,'2014-03-08 21:30:54',NULL,NULL),(5819,1086,'452092','834','00','005010X220A1','452092','','2013-11-22','18:24:08',0,'2013-12-26 02:15:02',NULL,NULL),(7678,1322,'694963','834','00','005010X220A1','694963','','2013-12-21','12:07:54',0,'2013-12-26 04:39:45',NULL,NULL),(3791,658,'239915','834','00','005010X220A1','239915','','2013-12-07','18:41:06',0,'2013-12-25 22:16:00',NULL,NULL),(23262,4377,'3832631','834','00','005010X220A1','3832631','','2014-03-08','11:21:39',0,'2014-03-08 21:00:03',NULL,NULL),(279,60,'99650','834','00','005010X220A1','99650','','2013-11-08','20:10:03',0,'2013-12-25 17:31:56',NULL,NULL),(17313,3174,'1759668','834','00','005010X220A1','1759668','','2014-01-30','22:22:06',0,'2014-01-31 21:00:50',NULL,NULL),(14381,2409,'1397167','834','00','005010X220A1','1397167','','2014-01-12','12:14:58',0,'2014-01-13 03:01:48',NULL,NULL),(13724,2275,'1896540','834','00','005010X220A1','1896540','','2014-01-07','16:56:09',0,'2014-01-08 18:24:39',NULL,NULL),(2093,352,'490635','834','00','005010X220A1','490635','','2013-12-09','16:03:34',0,'2013-12-25 19:37:49',NULL,NULL),(12147,1591,'1671137','834','00','005010X220A1','1671137','','2013-12-30','11:01:29',0,'2014-01-01 12:07:20',NULL,NULL),(3562,617,'968175','834','00','005010X220A1','968175','','2013-12-11','19:04:18',0,'2013-12-25 22:03:13',NULL,NULL),(4892,899,'93820','834','00','005010X220A1','93820','','2013-10-02','10:42:27',0,'2013-12-26 00:17:06',NULL,NULL),(3270,581,'1205409','834','00','005010X220A1','1205409','','2013-12-16','21:31:49',0,'2013-12-25 21:47:29',NULL,NULL),(2832,511,'923822','834','00','005010X220A1','923822','','2013-12-21','21:21:09',0,'2013-12-25 21:21:22',NULL,NULL),(2733,503,'226011','834','00','005010X220A1','226011','','2013-12-22','14:32:57',0,'2013-12-25 21:18:13',NULL,NULL),(17838,3285,'2074535','834','00','005010X220A1','2074535','','2014-02-04','07:50:48',0,'2014-02-04 21:30:03',NULL,NULL),(21318,4012,'3402068','834','00','005010X220A1','3402068','','2014-02-26','14:00:16',0,'2014-02-26 21:02:39',NULL,NULL),(21460,4028,'3724264','834','00','005010X220A1','3724264','','2014-02-27','10:07:47',0,'2014-02-28 06:31:04',NULL,NULL),(21634,4069,'2876997','834','00','005010X220A1','2876997','','2014-02-27','10:19:06',0,'2014-02-28 07:30:28',NULL,NULL),(11457,1488,'2129054','834','00','005010X220A1','2129054','','2013-12-27','00:17:08',0,'2013-12-28 03:30:23',NULL,NULL),(7061,1236,'556376','834','00','005010X220A1','556376','','2013-12-17','19:59:26',0,'2013-12-26 04:02:21',NULL,NULL),(16369,2986,'1373161','834','00','005010X220A1','1373161','','2014-01-23','13:04:48',0,'2014-01-23 21:01:01',NULL,NULL),(4472,802,'105447','834','00','005010X220A1','105447','','2013-11-25','21:18:49',0,'2013-12-25 23:31:07',NULL,NULL),(14779,2551,'2396819','834','00','005010X220A1','2396819','','2014-01-14','14:17:17',0,'2014-01-15 02:06:36',NULL,NULL),(18286,3379,'2594341','834','00','005010X220A1','2594341','','2014-02-08','17:41:58',0,'2014-02-08 19:00:25',NULL,NULL),(19411,3593,'2673349','834','00','005010X220A1','2673349','','2014-02-13','15:50:33',0,'2014-02-13 22:02:37',NULL,NULL),(23729,4463,'3552650','834','00','005010X220A1','3552650','','2014-03-10','12:34:28',0,'2014-03-10 21:02:51',NULL,NULL),(12296,1626,'1798351','834','00','005010X220A1','1798351','','2014-01-01','14:13:23',1,'2014-01-02 04:25:08',NULL,NULL),(993,184,'165514','834','00','005010X220A1','165514','','2013-12-03','14:53:07',0,'2013-12-25 18:20:00',NULL,NULL),(17715,3261,'2273194','834','00','005010X220A1','2273194','','2014-02-04','10:26:21',0,'2014-02-04 21:00:38',NULL,NULL),(16271,2963,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:12:00',0,'2014-01-23 10:30:02',NULL,NULL),(1316,245,'1280268','834','00','005010X220A1','1280268','','2013-12-24','10:28:35',0,'2013-12-25 18:51:19',NULL,NULL),(14598,2521,'2278334','834','00','005010X220A1','2278334','','2014-01-13','13:45:31',0,'2014-01-14 01:33:06',NULL,NULL),(5523,1041,'1489731','834','00','005010X220A1','1489731','','2013-12-24','21:47:50',0,'2013-12-26 01:47:07',NULL,NULL),(2207,365,'32385','834','00','005010X220A1','32385','','2013-12-02','17:59:58',0,'2013-12-25 19:48:24',NULL,NULL),(12602,1671,'2420206','834','00','005010X220A1','2420206','','2014-01-02','16:16:24',0,'2014-01-03 02:01:09',NULL,NULL),(4171,734,'657143','834','00','005010X220A1','657143','','2013-12-19','10:58:15',0,'2013-12-25 23:05:18',NULL,NULL),(2734,503,'1059923','834','00','005010X220A1','1059923','','2013-12-22','14:40:45',0,'2013-12-25 21:18:14',NULL,NULL),(18550,3452,'2217325','834','00','005010X220A1','2217325','','2014-02-10','13:53:23',0,'2014-02-10 21:30:29',NULL,NULL),(23503,4434,'3656230','834','00','005010X220A1','3656230','','2014-03-10','11:20:29',0,'2014-03-10 21:00:05',NULL,NULL),(214,26,'55652','834','00','005010X220A1','55652','','2013-12-05','16:52:59',0,'2013-12-25 17:21:45',NULL,NULL),(12324,1634,'1859763','834','00','005010X220A1','1859763','','2013-12-30','23:16:54',1,'2014-01-02 04:26:58',NULL,NULL),(7205,1241,'1236898','834','00','005010X220A1','1236898','','2013-12-17','22:42:17',0,'2013-12-26 04:06:48',NULL,NULL),(14306,2390,'2379846','834','00','005010X220A1','2379846','','2014-01-10','14:02:43',0,'2014-01-13 03:00:33',NULL,NULL),(3530,616,'999326','834','00','005010X220A1','999326','','2013-12-11','21:07:50',0,'2013-12-25 22:02:08',NULL,NULL),(18495,3437,'1756075','834','00','005010X220A1','1756075','','2014-02-10','04:24:49',0,'2014-02-10 11:01:10',NULL,NULL),(19128,3547,'2959582','834','00','005010X220A1','2959582','','2014-02-12','14:11:11',0,'2014-02-12 21:31:55',NULL,NULL),(22151,4179,'3364678','834','00','005010X220A1','3364678','','2014-03-03','15:31:36',0,'2014-03-03 21:30:55',NULL,NULL),(22814,4278,'3164477','834','00','005010X220A1','3164477','','2014-03-06','11:28:03',0,'2014-03-06 21:01:14',NULL,NULL),(12093,1587,'1831432','834','00','005010X220A1','1831432','','2013-12-29','20:43:46',0,'2014-01-01 12:05:28',NULL,NULL),(17495,3221,'2742213','834','00','005010X220A1','2742213','','2014-02-02','17:02:05',0,'2014-02-02 19:00:21',NULL,NULL),(7102,1236,'634253','834','00','005010X220A1','634253','','2013-12-18','12:23:19',0,'2013-12-26 04:03:39',NULL,NULL),(2627,492,'61802','834','00','005010X220A1','61802','','2013-11-27','19:39:17',0,'2013-12-25 20:46:50',NULL,NULL),(13162,2006,'0001','999','BE','005010X231A1','802181','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:06',NULL,NULL),(12913,1714,'1615379','834','00','005010X220A1','1615379','','2014-01-03','12:04:05',0,'2014-01-04 02:05:23',NULL,NULL),(5462,1040,'1403143','834','00','005010X220A1','1403143','','2013-12-24','19:42:44',0,'2013-12-26 01:45:13',NULL,NULL),(3144,555,'1148475','834','00','005010X220A1','1148475','','2013-12-12','20:35:12',0,'2013-12-25 21:37:32',NULL,NULL),(18782,3487,'2092364','834','00','005010X220A1','2092364','','2014-02-10','18:57:07',0,'2014-02-11 21:01:01',NULL,NULL),(21288,4005,'3407322','834','00','005010X220A1','3407322','','2014-02-26','13:31:20',0,'2014-02-26 21:02:15',NULL,NULL),(12425,1638,'1545992','834','00','005010X220A1','1545992','','2013-12-31','12:29:32',1,'2014-01-02 04:30:35',NULL,NULL),(17452,3207,'1950136','834','00','005010X220A1','1950136','','2014-01-31','23:04:25',0,'2014-02-01 19:00:42',NULL,NULL),(2986,542,'538340','834','00','005010X220A1','538340','','2013-12-13','10:40:25',0,'2013-12-25 21:32:42',NULL,NULL),(2761,505,'595245','834','00','005010X220A1','595245','','2013-12-22','12:41:44',0,'2013-12-25 21:19:04',NULL,NULL),(12905,1713,'1599974','834','00','005010X220A1','1599974','','2014-01-03','15:18:38',0,'2014-01-04 02:05:03',NULL,NULL),(18533,3451,'2261136','834','00','005010X220A1','2261136','','2014-02-10','13:50:15',0,'2014-02-10 21:30:18',NULL,NULL),(22305,4201,'2894805','834','00','005010X220A1','2894805','','2014-03-04','12:07:41',0,'2014-03-04 21:01:02',NULL,NULL),(3993,728,'1208937','834','00','005010X220A1','1208937','','2013-12-07','17:10:18',0,'2013-12-25 22:48:03',NULL,NULL),(13038,1882,'0001','999','BE','005010X231A1','392138','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:47',NULL,NULL),(22939,4298,'3663813','834','00','005010X220A1','3663813','','2014-03-06','11:51:02',0,'2014-03-06 21:02:45',NULL,NULL),(23228,4359,'2985891','834','00','005010X220A1','2985891','','2014-03-07','09:35:00',0,'2014-03-07 21:32:06',NULL,NULL),(11618,1494,'1651209','834','00','005010X220A1','1651209','','2013-12-27','12:29:02',0,'2013-12-28 03:35:17',NULL,NULL),(2995,542,'249092','834','00','005010X220A1','249092','','2013-12-13','13:47:06',0,'2013-12-25 21:32:58',NULL,NULL),(15614,2666,'2572485','834','00','005010X220A1','2572485','','2014-01-17','12:43:00',0,'2014-01-20 08:06:35',NULL,NULL),(3824,672,'659543','834','00','005010X220A1','659543','','2013-12-08','13:58:59',0,'2013-12-25 22:17:12',NULL,NULL),(4106,733,'974698','834','00','005010X220A1','974698','','2013-12-19','11:55:34',0,'2013-12-25 23:03:24',NULL,NULL),(5059,936,'897194','834','00','005010X220A1','897194','','2013-12-11','10:13:21',0,'2013-12-26 00:47:53',NULL,NULL),(20603,3870,'2976481','834','00','005010X220A1','2976481','','2014-02-21','14:05:45',0,'2014-02-21 22:00:18',NULL,NULL),(20896,3925,'3016935','834','00','005010X220A1','3016935','','2014-02-25','17:03:10',0,'2014-02-25 21:32:05',NULL,NULL),(21683,4082,'3486438','834','00','005010X220A1','3486438','','2014-02-28','14:37:58',0,'2014-02-28 21:00:24',NULL,NULL),(1513,258,'1616459','834','00','005010X220A1','1616459','','2013-12-24','16:17:30',0,'2013-12-25 18:57:48',NULL,NULL),(12604,1671,'1951587','834','00','005010X220A1','1951587','','2014-01-02','16:52:11',0,'2014-01-03 02:01:15',NULL,NULL),(16556,3029,'1825042','834','00','005010X220A1','1825042','','2014-01-24','10:14:06',0,'2014-01-24 21:01:17',NULL,NULL),(10451,1400,'538812','834','00','005010X220A1','538812','','2013-12-23','13:13:51',0,'2013-12-26 12:52:19',NULL,NULL),(22003,4148,'2706709','834','00','005010X220A1','2706709','','2014-03-01','20:32:11',0,'2014-03-03 01:00:25',NULL,NULL),(22469,4238,'2910932','834','00','005010X220A1','2910932','','2014-03-05','16:22:51',0,'2014-03-05 21:00:16',NULL,NULL),(11307,1456,'990867','834','00','005010X220A1','990867','','2013-12-26','10:37:03',0,'2013-12-27 02:03:44',NULL,NULL),(12990,1738,'2144163','834','00','005010X220A1','2144163','','2014-01-03','21:19:13',0,'2014-01-05 00:01:46',NULL,NULL),(15962,2764,'2427075','834','00','005010X220A1','2427075','','2014-01-21','21:51:40',0,'2014-01-23 03:01:55',NULL,NULL),(15828,2736,'1721383','834','00','005010X220A1','1721383','','2014-01-21','11:24:13',1,'2014-01-22 03:21:55',NULL,NULL),(15590,2659,'1615768','834','00','005010X220A1','1615768','','2014-01-17','12:05:05',0,'2014-01-20 08:06:19',NULL,NULL),(18769,3486,'2507806','834','00','005010X220A1','2507806','','2014-02-10','20:05:54',0,'2014-02-11 21:00:52',NULL,NULL),(19699,3671,'3449660','834','00','005010X220A1','3449660','','2014-02-14','18:14:48',0,'2014-02-15 22:00:06',NULL,NULL),(20848,3911,'2922839','834','00','005010X220A1','2922839','','2014-02-25','14:19:26',0,'2014-02-25 21:31:29',NULL,NULL),(21056,3979,'3472591','834','00','005010X220A1','3472591','','2014-02-24','13:15:43',0,'2014-02-26 09:30:31',NULL,NULL),(277,60,'707986','834','00','005010X220A1','707986','','2013-11-09','17:14:42',0,'2013-12-25 17:31:52',NULL,NULL),(650,108,'630698','834','00','005010X220A1','630698','','2013-12-16','15:44:30',0,'2013-12-25 18:05:13',NULL,NULL),(17614,3243,'2806467','834','00','005010X220A1','2806467','','2014-02-03','10:17:28',0,'2014-02-03 21:01:07',NULL,NULL),(10905,1409,'1643384','834','00','005010X220A1','1643384','','2013-12-23','15:23:49',0,'2013-12-26 13:07:47',NULL,NULL),(3712,633,'197440','834','00','005010X220A1','197440','','2013-12-12','17:38:17',0,'2013-12-25 22:07:56',NULL,NULL),(4285,743,'984495','834','00','005010X220A1','984495','','2013-12-18','20:32:05',0,'2013-12-25 23:08:51',NULL,NULL),(4395,774,'1274677','834','00','005010X220A1','1274677','','2013-11-27','17:54:43',0,'2013-12-25 23:15:46',NULL,NULL),(18890,3498,'2755983','834','00','005010X220A1','2755983','','2014-02-11','12:31:02',0,'2014-02-11 21:02:26',NULL,NULL),(19244,3580,'2433383','834','00','005010X220A1','2433383','','2014-02-13','15:08:38',0,'2014-02-13 22:00:29',NULL,NULL),(19878,3709,'2208414','834','00','005010X220A1','2208414','','2014-02-16','17:00:22',0,'2014-02-16 19:00:23',NULL,NULL),(20328,3798,'3143562','834','00','005010X220A1','3143562','','2014-02-18','22:45:14',0,'2014-02-20 04:49:49',NULL,NULL),(20714,3895,'2777991','834','00','005010X220A1','2777991','','2014-02-24','21:21:44',0,'2014-02-25 21:00:21',NULL,NULL),(21186,3998,'3008083','834','00','005010X220A1','3008083','','2014-02-26','13:22:08',0,'2014-02-26 21:01:08',NULL,NULL),(21501,4030,'3311519','834','00','005010X220A1','3311519','','2014-02-27','11:51:41',0,'2014-02-28 06:31:22',NULL,NULL),(22887,4282,'3024720','834','00','005010X220A1','3024720','','2014-03-06','14:35:14',0,'2014-03-06 21:02:07',NULL,NULL),(23489,4430,'3039818','834','00','005010X220A1','3039818','','2014-03-09','13:14:28',0,'2014-03-09 21:30:03',NULL,NULL),(330,72,'279868','834','00','005010X220A1','279868','','2013-12-04','09:09:52',0,'2013-12-25 17:46:09',NULL,NULL),(901,177,'498647','834','00','005010X220A1','498647','','2013-12-03','08:24:35',0,'2013-12-25 18:17:09',NULL,NULL),(10806,1404,'184225','834','00','005010X220A1','184225','','2013-12-23','15:10:53',0,'2013-12-26 13:04:04',NULL,NULL),(16477,3008,'2289246','834','00','005010X220A1','2289246','','2014-01-24','10:15:03',0,'2014-01-24 21:00:27',NULL,NULL),(15924,2745,'2085021','834','00','005010X220A1','2085021','','2014-01-21','17:09:50',1,'2014-01-22 03:22:55',NULL,NULL),(5900,1110,'563608','834','00','005010X220A1','563608','','2013-12-15','13:10:49',0,'2013-12-26 02:30:47',NULL,NULL),(3728,638,'528210','834','00','005010X220A1','528210','','2013-12-12','10:46:58',0,'2013-12-25 22:08:29',NULL,NULL),(22685,4256,'3554635','834','00','005010X220A1','3554635','','2014-03-04','20:12:40',0,'2014-03-05 21:32:17',NULL,NULL),(7539,1300,'176747','834','00','005010X220A1','176747','','2013-12-21','15:38:47',0,'2013-12-26 04:35:17',NULL,NULL),(17675,3259,'1494448','834','00','005010X220A1','1494448','','2014-02-04','10:23:15',0,'2014-02-04 21:00:15',NULL,NULL),(17564,3236,'1690325','834','00','005010X220A1','1690325','','2014-02-03','11:41:24',0,'2014-02-03 21:00:35',NULL,NULL),(17497,3222,'1987544','834','00','005010X220A1','1987544','','2014-02-02','00:09:38',0,'2014-02-02 19:00:22',NULL,NULL),(2898,535,'1396475','834','00','005010X220A1','1396475','','2013-12-22','16:14:48',0,'2013-12-25 21:23:40',NULL,NULL),(3242,578,'381174','834','00','005010X220A1','381174','','2013-12-17','15:42:07',0,'2013-12-25 21:46:36',NULL,NULL),(5717,1069,'268478','834','00','005010X220A1','268478','','2013-12-14','11:09:25',0,'2013-12-26 02:00:58',NULL,NULL),(5841,1092,'604551','834','00','005010X220A1','604551','','2013-11-23','17:14:28',0,'2013-12-26 02:15:47',NULL,NULL),(20372,3822,'3232051','834','00','005010X220A1','3232051','','2014-02-19','11:20:34',0,'2014-02-20 05:33:55',NULL,NULL),(22337,4204,'3456311','834','00','005010X220A1','3456311','','2014-03-03','18:53:36',0,'2014-03-04 21:01:28',NULL,NULL),(22502,4247,'2664831','834','00','005010X220A1','2664831','','2014-03-04','19:46:57',0,'2014-03-05 21:30:08',NULL,NULL),(23089,4339,'3720258','834','00','005010X220A1','3720258','','2014-03-07','14:15:03',0,'2014-03-07 21:30:27',NULL,NULL),(23185,4345,'3291850','834','00','005010X220A1','3291850','','2014-03-07','14:13:03',0,'2014-03-07 21:31:36',NULL,NULL),(1977,326,'1249181','834','00','005010X220A1','1249181','','2013-12-09','16:59:02',0,'2013-12-25 19:34:03',NULL,NULL),(17872,3293,'1912033','834','00','005010X220A1','1912033','','2014-02-05','16:40:08',0,'2014-02-05 21:30:17',NULL,NULL),(16567,3035,'2241882','834','00','005010X220A1','2241882','','2014-01-24','18:31:35',0,'2014-01-25 19:00:05',NULL,NULL),(14626,2524,'2070529','834','00','005010X220A1','2070529','','2014-01-13','15:28:39',0,'2014-01-14 01:33:23',NULL,NULL),(11808,1539,'1419507','834','00','005010X220A1','1419507','','2013-12-28','20:12:00',1,'2013-12-29 11:13:18',NULL,NULL),(5446,1035,'199584','834','00','005010X220A1','199584','','2013-11-03','17:16:09',0,'2013-12-26 01:31:51',NULL,NULL),(3867,693,'196896','834','00','005010X220A1','196896','','2013-10-10','01:37:42',0,'2013-12-25 22:31:08',NULL,NULL),(22775,4277,'2837825','834','00','005010X220A1','2837825','','2014-03-06','10:32:07',0,'2014-03-06 21:00:47',NULL,NULL),(23641,4441,'3927183','834','00','005010X220A1','3927183','','2014-03-10','14:17:16',0,'2014-03-10 21:01:44',NULL,NULL),(578,104,'1182169','834','00','005010X220A1','1182169','','2013-12-15','18:43:44',0,'2013-12-25 18:02:53',NULL,NULL),(16680,3062,'1524042','834','00','005010X220A1','1524042','','2014-01-26','21:43:53',0,'2014-01-27 21:00:30',NULL,NULL),(16545,3022,'1440421','834','00','005010X220A1','1440421','','2014-01-24','12:40:36',0,'2014-01-24 21:01:09',NULL,NULL),(14624,2524,'2509812','834','00','005010X220A1','2509812','','2014-01-13','12:22:15',0,'2014-01-14 01:33:22',NULL,NULL),(14434,2455,'0001','999','BE','005010X231A1','89853','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:06',NULL,NULL),(11383,1463,'1238544','834','00','005010X220A1','1238544','','2013-12-26','08:52:28',0,'2013-12-27 02:06:00',NULL,NULL),(13726,2275,'1852950','834','00','005010X220A1','1852950','','2014-01-06','20:39:23',0,'2014-01-08 18:24:40',NULL,NULL),(2659,501,'672522','834','00','005010X220A1','672522','','2013-12-22','12:45:37',0,'2013-12-25 21:15:45',NULL,NULL),(21522,4036,'3284116','834','00','005010X220A1','3284116','','2014-02-27','12:33:10',0,'2014-02-28 06:31:32',NULL,NULL),(21532,4039,'3769477','834','00','005010X220A1','3769477','','2014-02-27','09:55:21',0,'2014-02-28 06:31:36',NULL,NULL),(23596,4437,'3644666','834','00','005010X220A1','3644666','','2014-03-10','15:55:20',0,'2014-03-10 21:01:14',NULL,NULL),(10757,1403,'1231667','834','00','005010X220A1','1231667','','2013-12-23','19:04:14',0,'2013-12-26 13:02:29',NULL,NULL),(17025,3120,'1493168','834','00','005010X220A1','1493168','','2014-01-29','11:32:51',0,'2014-01-29 21:01:10',NULL,NULL),(16749,3067,'1938805','834','00','005010X220A1','1938805','','2014-01-27','13:37:45',0,'2014-01-27 21:01:17',NULL,NULL),(2142,360,'54547','834','00','005010X220A1','54547','','2013-12-02','13:37:36',0,'2013-12-25 19:46:11',NULL,NULL),(2783,506,'927659','834','00','005010X220A1','927659','','2013-12-22','06:48:10',0,'2013-12-25 21:19:46',NULL,NULL),(16541,3020,'1867712','834','00','005010X220A1','1867712','','2014-01-24','13:23:39',0,'2014-01-24 21:01:07',NULL,NULL),(16142,2834,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:56:07',NULL,NULL),(3008,543,'294308','834','00','005010X220A1','294308','','2013-12-13','09:15:53',0,'2013-12-25 21:33:22',NULL,NULL),(7091,1236,'1271518','834','00','005010X220A1','1271518','','2013-12-18','10:55:24',0,'2013-12-26 04:03:21',NULL,NULL),(4300,749,'262295','834','00','005010X220A1','262295','','2013-12-18','22:05:33',0,'2013-12-25 23:09:18',NULL,NULL),(4714,838,'1016910','834','00','005010X220A1','1016910','','2013-12-23','23:29:39',0,'2013-12-25 23:51:07',NULL,NULL),(5196,949,'844294','834','00','005010X220A1','844294','','2013-12-11','12:53:29',0,'2013-12-26 00:52:14',NULL,NULL),(22993,4322,'2741890','834','00','005010X220A1','2741890','','2014-03-07','10:03:38',0,'2014-03-07 21:00:09',NULL,NULL),(23484,4426,'2964395','834','00','005010X220A1','2964395','','2014-03-09','16:23:56',0,'2014-03-09 21:01:21',NULL,NULL),(23593,4437,'3588440','834','00','005010X220A1','3588440','','2014-03-10','14:41:15',0,'2014-03-10 21:01:12',NULL,NULL),(1448,252,'1238461','834','00','005010X220A1','1238461','','2013-12-24','12:16:41',0,'2013-12-25 18:55:37',NULL,NULL),(10838,1404,'1138833','834','00','005010X220A1','1138833','','2013-12-23','18:57:12',0,'2013-12-26 13:05:05',NULL,NULL),(16292,2980,'1820431','834','00','005010X220A1','1820431','','2014-01-23','07:37:06',0,'2014-01-23 21:00:06',NULL,NULL),(1975,326,'216574','834','00','005010X220A1','216574','','2013-12-09','16:18:55',0,'2013-12-25 19:33:58',NULL,NULL),(7175,1238,'1128715','834','00','005010X220A1','1128715','','2013-12-18','15:39:47',0,'2013-12-26 04:05:51',NULL,NULL),(14716,2550,'1974890','834','00','005010X220A1','1974890','','2014-01-14','11:01:17',0,'2014-01-15 02:06:09',NULL,NULL),(3451,607,'1090975','834','00','005010X220A1','1090975','','2013-12-17','11:46:14',0,'2013-12-25 21:53:22',NULL,NULL),(19474,3620,'3091628','834','00','005010X220A1','3091628','','2014-02-13','20:29:50',0,'2014-02-14 21:30:08',NULL,NULL),(20540,3857,'3343270','834','00','005010X220A1','3343270','','2014-02-20','12:42:26',0,'2014-02-20 22:01:37',NULL,NULL),(22449,4231,'2668463','834','00','005010X220A1','2668463','','2014-03-04','16:07:13',0,'2014-03-04 21:30:15',NULL,NULL),(3336,586,'583297','834','00','005010X220A1','583297','','2013-12-17','16:11:46',0,'2013-12-25 21:49:42',NULL,NULL),(3375,587,'584334','834','00','005010X220A1','584334','','2013-12-17','15:09:13',0,'2013-12-25 21:50:55',NULL,NULL),(3610,619,'1040328','834','00','005010X220A1','1040328','','2013-12-12','15:40:42',0,'2013-12-25 22:04:39',NULL,NULL),(13610,2266,'2163519','834','00','005010X220A1','2163519','','2014-01-04','20:46:28',1,'2014-01-07 10:23:17',NULL,NULL),(4819,872,'351270','834','00','005010X220A1','351270','','2013-12-01','14:06:01',0,'2013-12-26 00:02:26',NULL,NULL),(5455,1038,'1024493','834','00','005010X220A1','1024493','','2013-11-03','17:10:13',0,'2013-12-26 01:32:10',NULL,NULL),(13238,2082,'0001','999','BE','005010X231A1','873258','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:38',NULL,NULL),(20042,3751,'2440883','834','00','005010X220A1','2440883','','2014-02-18','10:27:39',0,'2014-02-18 22:01:02',NULL,NULL),(2170,362,'751392','834','00','005010X220A1','751392','','2013-12-02','13:08:55',0,'2013-12-25 19:47:09',NULL,NULL),(11055,1420,'772649','834','00','005010X220A1','772649','','2013-12-22','20:20:58',0,'2013-12-26 13:12:38',NULL,NULL),(14757,2551,'2405433','834','00','005010X220A1','2405433','','2014-01-13','20:26:24',0,'2014-01-15 02:06:27',NULL,NULL),(13882,2312,'1650224','834','00','005010X220A1','1650224','','2014-01-09','14:56:26',0,'2014-01-13 02:19:34',NULL,NULL),(14380,2408,'1569340','834','00','005010X220A1','1569340','','2014-01-12','11:11:45',0,'2014-01-13 03:01:48',NULL,NULL),(21904,4127,'2878553','834','00','005010X220A1','2878553','','2014-03-01','00:21:03',0,'2014-03-01 21:00:33',NULL,NULL),(21986,4145,'3166557','834','00','005010X220A1','3166557','','2014-03-02','07:47:24',0,'2014-03-03 01:00:15',NULL,NULL),(22509,4247,'2848057','834','00','005010X220A1','2848057','','2014-03-05','10:50:26',0,'2014-03-05 21:30:13',NULL,NULL),(22607,4250,'3480774','834','00','005010X220A1','3480774','','2014-03-05','13:51:19',0,'2014-03-05 21:31:23',NULL,NULL),(239,40,'280785','834','00','005010X220A1','280785','','2013-10-12','15:51:14',0,'2013-12-25 17:30:29',NULL,NULL),(18319,3384,'2503035','834','00','005010X220A1','2503035','','2014-02-08','16:19:31',0,'2014-02-08 19:00:46',NULL,NULL),(323,72,'1236396','834','00','005010X220A1','1236396','','2013-12-03','18:25:11',0,'2013-12-25 17:45:56',NULL,NULL),(11345,1456,'312291','834','00','005010X220A1','312291','','2013-12-26','18:13:27',0,'2013-12-27 02:04:50',NULL,NULL),(11201,1454,'215971','834','00','005010X220A1','215971','','2013-12-25','19:03:13',0,'2013-12-27 02:00:28',NULL,NULL),(4927,913,'851595','834','00','005010X220A1','851595','','2013-10-15','21:31:43',0,'2013-12-26 00:31:02',NULL,NULL),(20250,3793,'3539395','834','00','005010X220A1','3539395','','2014-02-18','23:03:10',0,'2014-02-20 04:32:05',NULL,NULL),(20297,3794,'3657036','834','00','005010X220A1','3657036','','2014-02-19','11:59:08',0,'2014-02-20 04:42:27',NULL,NULL),(20512,3849,'3621358','834','00','005010X220A1','3621358','','2014-02-19','19:53:55',0,'2014-02-20 22:01:13',NULL,NULL),(21428,4027,'3165359','834','00','005010X220A1','3165359','','2014-02-26','19:29:38',0,'2014-02-28 06:30:48',NULL,NULL),(1380,245,'16186','834','00','005010X220A1','16186','','2013-12-24','16:30:13',0,'2013-12-25 18:53:22',NULL,NULL),(3580,617,'226991','834','00','005010X220A1','226991','','2013-12-12','11:58:18',0,'2013-12-25 22:03:44',NULL,NULL),(16433,3005,'2418272','834','00','005010X220A1','2418272','','2014-01-23','12:13:00',0,'2014-01-23 21:01:46',NULL,NULL),(5136,943,'817021','834','00','005010X220A1','817021','','2013-12-11','10:26:18',0,'2013-12-26 00:50:24',NULL,NULL),(1572,277,'303664','834','00','005010X220A1','303664','','2013-11-20','13:46:14',0,'2013-12-25 19:00:21',NULL,NULL),(12801,1703,'1371606','834','00','005010X220A1','1371606','','2014-01-03','13:31:47',0,'2014-01-04 02:01:17',NULL,NULL),(13247,2091,'0001','999','BE','005010X231A1','71475','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:03',NULL,NULL),(16365,2986,'1730969','834','00','005010X220A1','1730969','','2014-01-22','21:42:15',0,'2014-01-23 21:00:58',NULL,NULL),(19037,3540,'3061468','834','00','005010X220A1','3061468','','2014-02-12','15:59:18',0,'2014-02-12 21:30:52',NULL,NULL),(19437,3602,'3217971','834','00','005010X220A1','3217971','','2014-02-13','13:00:51',0,'2014-02-13 22:02:56',NULL,NULL),(20068,3757,'3282829','834','00','005010X220A1','3282829','','2014-02-18','15:54:44',0,'2014-02-18 22:01:23',NULL,NULL),(21432,4027,'2628262','834','00','005010X220A1','2628262','','2014-02-27','10:54:34',0,'2014-02-28 06:30:50',NULL,NULL),(21773,4090,'2780643','834','00','005010X220A1','2780643','','2014-02-28','17:36:55',0,'2014-02-28 21:31:01',NULL,NULL),(7178,1238,'736298','834','00','005010X220A1','736298','','2013-12-18','17:40:49',0,'2013-12-26 04:05:58',NULL,NULL),(14476,2497,'0001','999','BE','005010X231A1','1241530','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:48',NULL,NULL),(11236,1454,'453160','834','00','005010X220A1','453160','','2013-12-26','12:03:45',0,'2013-12-27 02:01:32',NULL,NULL),(10785,1404,'1442008','834','00','005010X220A1','1442008','','2013-12-23','10:59:13',0,'2013-12-26 13:03:24',NULL,NULL),(7648,1311,'1278937','834','00','005010X220A1','1278937','','2013-12-21','14:47:58',0,'2013-12-26 04:38:46',NULL,NULL),(7055,1235,'867994','834','00','005010X220A1','867994','','2013-12-18','18:33:00',0,'2013-12-26 04:02:10',NULL,NULL),(4552,825,'1051489','834','00','005010X220A1','1051489','','2013-12-23','23:01:31',0,'2013-12-25 23:45:46',NULL,NULL),(2925,541,'802174','834','00','005010X220A1','802174','','2013-12-12','19:26:59',0,'2013-12-25 21:30:44',NULL,NULL),(3367,587,'933983','834','00','005010X220A1','933983','','2013-12-17','12:56:19',0,'2013-12-25 21:50:38',NULL,NULL),(6051,1158,'1155788','834','00','005010X220A1','1155788','','2013-11-10','11:38:36',0,'2013-12-26 02:46:37',NULL,NULL),(17842,3288,'2434392','834','00','005010X220A1','2434392','','2014-02-05','12:55:40',0,'2014-02-05 21:00:05',NULL,NULL),(20104,3772,'2933381','834','00','005010X220A1','2933381','','2014-02-18','18:04:03',0,'2014-02-20 03:43:13',NULL,NULL),(22272,4200,'2696736','834','00','005010X220A1','2696736','','2014-03-04','13:47:54',0,'2014-03-04 21:00:38',NULL,NULL),(441,81,'1080372','834','00','005010X220A1','1080372','','2013-12-04','15:49:43',0,'2013-12-25 17:49:40',NULL,NULL),(15701,2700,'2513622','834','00','005010X220A1','2513622','','2014-01-18','23:55:03',0,'2014-01-21 08:45:28',NULL,NULL),(15507,2639,'1858805','834','00','005010X220A1','1858805','','2014-01-15','23:56:06',0,'2014-01-17 03:36:34',NULL,NULL),(970,183,'79284','834','00','005010X220A1','79284','','2013-12-02','20:07:03',0,'2013-12-25 18:19:17',NULL,NULL),(4055,731,'892272','834','00','005010X220A1','892272','','2013-12-19','18:26:44',0,'2013-12-25 23:01:50',NULL,NULL),(22015,4151,'2935098','834','00','005010X220A1','2935098','','2014-03-01','22:18:09',0,'2014-03-03 01:00:32',NULL,NULL),(22874,4281,'3628659','834','00','005010X220A1','3628659','','2014-03-06','13:09:51',0,'2014-03-06 21:01:57',NULL,NULL),(5843,1092,'1094302','834','00','005010X220A1','1094302','','2013-11-22','23:39:24',0,'2013-12-26 02:15:51',NULL,NULL),(16035,2770,'2184515','834','00','005010X220A1','2184515','','2014-01-22','14:18:19',0,'2014-01-23 03:02:29',NULL,NULL),(10531,1401,'1616307','834','00','005010X220A1','1616307','','2013-12-23','13:16:29',0,'2013-12-26 12:54:51',NULL,NULL),(19893,3711,'2972789','834','00','005010X220A1','2972789','','2014-02-16','14:04:19',0,'2014-02-16 19:00:33',NULL,NULL),(22605,4250,'3118194','834','00','005010X220A1','3118194','','2014-03-05','13:10:10',0,'2014-03-05 21:31:22',NULL,NULL),(6011,1136,'814041','834','00','005010X220A1','814041','','2013-11-17','11:22:30',0,'2013-12-26 02:45:15',NULL,NULL),(15790,2719,'1530947','834','00','005010X220A1','1530947','','2014-01-20','17:46:29',0,'2014-01-21 08:46:42',NULL,NULL),(14816,2552,'1897774','834','00','005010X220A1','1897774','','2014-01-14','12:29:48',0,'2014-01-15 02:06:51',NULL,NULL),(12886,1707,'2144140','834','00','005010X220A1','2144140','','2014-01-03','10:52:16',0,'2014-01-04 02:04:22',NULL,NULL),(4253,741,'801218','834','00','005010X220A1','801218','','2013-12-18','20:58:45',0,'2013-12-25 23:07:55',NULL,NULL),(10852,1406,'1235742','834','00','005010X220A1','1235742','','2013-12-23','08:48:08',0,'2013-12-26 13:05:35',NULL,NULL),(16651,3060,'2273027','834','00','005010X220A1','2273027','','2014-01-27','12:33:34',0,'2014-01-27 21:00:12',NULL,NULL),(17886,3294,'1623913','834','00','005010X220A1','1623913','','2014-02-05','13:03:13',0,'2014-02-05 21:30:24',NULL,NULL),(19621,3639,'2852645','834','00','005010X220A1','2852645','','2014-02-14','09:03:11',0,'2014-02-14 21:31:53',NULL,NULL),(19795,3677,'2345805','834','00','005010X220A1','2345805','','2014-02-14','19:07:22',0,'2014-02-15 22:01:18',NULL,NULL),(20100,3770,'2767354','834','00','005010X220A1','2767354','','2014-02-18','17:18:58',0,'2014-02-18 22:01:47',NULL,NULL),(20958,3952,'3249563','834','00','005010X220A1','3249563','','2014-02-24','15:07:44',0,'2014-02-26 08:00:47',NULL,NULL),(22012,4150,'3010348','834','00','005010X220A1','3010348','','2014-03-02','14:27:45',0,'2014-03-03 01:00:31',NULL,NULL),(22054,4167,'3193272','834','00','005010X220A1','3193272','','2014-03-03','16:25:10',0,'2014-03-03 21:00:14',NULL,NULL),(7513,1300,'517720','834','00','005010X220A1','517720','','2013-12-21','10:51:15',0,'2013-12-26 04:34:27',NULL,NULL),(11338,1456,'952323','834','00','005010X220A1','952323','','2013-12-26','16:34:43',0,'2013-12-27 02:04:40',NULL,NULL),(15230,2596,'1564386','834','00','005010X220A1','1564386','','2014-01-14','21:28:01',0,'2014-01-16 08:46:44',NULL,NULL),(13848,2311,'1742937','834','00','005010X220A1','1742937','','2014-01-09','10:26:46',0,'2014-01-13 02:19:10',NULL,NULL),(11732,1520,'2185126','834','00','005010X220A1','2185126','','2013-12-27','21:30:50',1,'2013-12-29 11:08:52',NULL,NULL),(12719,1678,'1414953','834','00','005010X220A1','1414953','','2014-01-02','13:26:58',0,'2014-01-03 02:05:29',NULL,NULL),(12393,1637,'1481596','834','00','005010X220A1','1481596','','2013-12-31','10:43:59',1,'2014-01-02 04:29:25',NULL,NULL),(20489,3844,'2883610','834','00','005010X220A1','2883610','','2014-02-20','17:47:44',0,'2014-02-20 22:00:56',NULL,NULL),(20901,3928,'3396387','834','00','005010X220A1','3396387','','2014-02-25','17:15:58',0,'2014-02-25 21:32:10',NULL,NULL),(741,130,'774522','834','00','005010X220A1','774522','','2013-12-16','13:25:26',0,'2013-12-25 18:08:04',NULL,NULL),(10645,1402,'654762','834','00','005010X220A1','654762','','2013-12-23','17:54:38',0,'2013-12-26 12:58:38',NULL,NULL),(13844,2311,'1852991','834','00','005010X220A1','1852991','','2014-01-08','20:03:37',0,'2014-01-13 02:19:08',NULL,NULL),(3574,617,'1009107','834','00','005010X220A1','1009107','','2013-12-12','00:16:49',0,'2013-12-25 22:03:32',NULL,NULL),(10960,1410,'1563671','834','00','005010X220A1','1563671','','2013-12-23','18:23:00',0,'2013-12-26 13:09:28',NULL,NULL),(16438,3006,'2070858','834','00','005010X220A1','2070858','','2014-01-24','15:32:33',0,'2014-01-24 21:00:05',NULL,NULL),(19135,3548,'2916305','834','00','005010X220A1','2916305','','2014-02-12','17:33:32',0,'2014-02-12 21:31:59',NULL,NULL),(19661,3653,'2865587','834','00','005010X220A1','2865587','','2014-02-14','10:52:08',0,'2014-02-14 21:32:23',NULL,NULL),(21285,4005,'2675198','834','00','005010X220A1','2675198','','2014-02-26','13:03:28',0,'2014-02-26 21:02:14',NULL,NULL),(23354,4389,'3258127','834','00','005010X220A1','3258127','','2014-03-08','12:35:50',0,'2014-03-08 21:31:01',NULL,NULL),(769,144,'206837','834','00','005010X220A1','206837','','2013-10-28','23:21:10',0,'2013-12-25 18:08:59',NULL,NULL),(14761,2551,'1773416','834','00','005010X220A1','1773416','','2014-01-13','23:17:33',0,'2014-01-15 02:06:28',NULL,NULL),(10664,1402,'12250','834','00','005010X220A1','12250','','2013-12-23','19:21:10',0,'2013-12-26 12:59:14',NULL,NULL),(14518,2517,'1407076','834','00','005010X220A1','1407076','','2014-01-13','16:48:21',0,'2014-01-14 01:32:14',NULL,NULL),(7508,1300,'263784','834','00','005010X220A1','263784','','2013-12-21','09:23:51',0,'2013-12-26 04:34:16',NULL,NULL),(13201,2045,'0001','999','BE','005010X231A1','212515','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:55',NULL,NULL),(12245,1619,'1767943','834','00','005010X220A1','1767943','','2014-01-01','04:31:03',1,'2014-01-02 04:23:15',NULL,NULL),(7086,1236,'4303','834','00','005010X220A1','4303','','2013-12-18','10:45:20',0,'2013-12-26 04:03:13',NULL,NULL),(11101,1425,'1364698','834','00','005010X220A1','1364698','','2013-12-22','22:12:52',0,'2013-12-26 13:14:09',NULL,NULL),(4907,906,'746243','834','00','005010X220A1','746243','','2013-10-23','02:41:28',0,'2013-12-26 00:30:22',NULL,NULL),(6449,1209,'1082684','834','00','005010X220A1','1082684','','2013-11-22','11:15:41',0,'2013-12-26 03:16:03',NULL,NULL),(4661,830,'633275','834','00','005010X220A1','633275','','2013-12-23','23:59:15',0,'2013-12-25 23:49:17',NULL,NULL),(4246,739,'1094994','834','00','005010X220A1','1094994','','2013-12-19','15:55:00',0,'2013-12-25 23:07:40',NULL,NULL),(17436,3204,'2602228','834','00','005010X220A1','2602228','','2014-02-01','14:07:49',0,'2014-02-01 19:00:32',NULL,NULL),(20360,3820,'3006652','834','00','005010X220A1','3006652','','2014-02-19','17:48:15',0,'2014-02-20 04:56:40',NULL,NULL),(21469,4028,'3625541','834','00','005010X220A1','3625541','','2014-02-27','13:43:15',0,'2014-02-28 06:31:07',NULL,NULL),(559,103,'584276','834','00','005010X220A1','584276','','2013-12-16','10:49:58',0,'2013-12-25 18:02:20',NULL,NULL),(10611,1402,'1359950','834','00','005010X220A1','1359950','','2013-12-23','13:53:35',0,'2013-12-26 12:57:32',NULL,NULL),(1192,239,'1800528','834','00','005010X220A1','1800528','','2013-12-24','17:13:33',0,'2013-12-25 18:47:31',NULL,NULL),(14463,2484,'0001','999','BE','005010X231A1','5245','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:36',NULL,NULL),(10413,1400,'1389298','834','00','005010X220A1','1389298','','2013-12-23','09:31:37',0,'2013-12-26 12:51:06',NULL,NULL),(12333,1634,'2106400','834','00','005010X220A1','2106400','','2013-12-31','10:36:13',1,'2014-01-02 04:27:19',NULL,NULL),(6079,1166,'788106','834','00','005010X220A1','788106','','2013-12-19','19:04:37',0,'2013-12-26 03:00:40',NULL,NULL),(3598,617,'1003129','834','00','005010X220A1','1003129','','2013-12-12','17:28:46',0,'2013-12-25 22:04:16',NULL,NULL),(5867,1103,'1071395','834','00','005010X220A1','1071395','','2013-10-28','08:00:22',0,'2013-12-26 02:16:49',NULL,NULL),(4792,865,'1273583','834','00','005010X220A1','1273583','','2013-12-01','16:25:07',0,'2013-12-26 00:01:39',NULL,NULL),(5594,1043,'1658847','834','00','005010X220A1','1658847','','2013-12-25','01:57:07',0,'2013-12-26 01:49:28',NULL,NULL),(19667,3656,'3101608','834','00','005010X220A1','3101608','','2014-02-14','16:10:29',0,'2014-02-14 21:32:27',NULL,NULL),(22194,4182,'3574723','834','00','005010X220A1','3574723','','2014-03-03','10:52:46',0,'2014-03-03 21:31:27',NULL,NULL),(10,1,'576283','834','00','005010X220A1','576283','','2013-12-05','07:41:08',0,'2013-12-25 17:15:20',NULL,NULL),(906,177,'411454','834','00','005010X220A1','411454','','2013-12-03','14:14:27',0,'2013-12-25 18:17:17',NULL,NULL),(6229,1168,'1344266','834','00','005010X220A1','1344266','','2013-12-20','16:21:20',0,'2013-12-26 03:05:14',NULL,NULL),(13552,2245,'1570463','834','00','005010X220A1','1570463','','2014-01-06','16:20:32',0,'2014-01-07 04:06:33',NULL,NULL),(5695,1067,'1042958','834','00','005010X220A1','1042958','','2013-12-14','11:41:56',0,'2013-12-26 02:00:14',NULL,NULL),(5647,1049,'1621724','834','00','005010X220A1','1621724','','2013-12-24','20:39:28',0,'2013-12-26 01:51:12',NULL,NULL),(18937,3523,'2575352','834','00','005010X220A1','2575352','','2014-02-11','12:05:28',0,'2014-02-11 21:30:16',NULL,NULL),(23415,4404,'2958135','834','00','005010X220A1','2958135','','2014-03-09','14:30:01',0,'2014-03-09 21:00:22',NULL,NULL),(10475,1400,'1641094','834','00','005010X220A1','1641094','','2013-12-23','15:02:16',0,'2013-12-26 12:53:04',NULL,NULL),(16614,3049,'2143668','834','00','005010X220A1','2143668','','2014-01-26','14:51:02',0,'2014-01-26 19:00:12',NULL,NULL),(16406,2994,'2487777','834','00','005010X220A1','2487777','','2014-01-23','14:13:01',0,'2014-01-23 21:01:26',NULL,NULL),(16185,2877,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:50:00',1,'2014-01-23 04:25:54',NULL,NULL),(2257,380,'240921','834','00','005010X220A1','240921','','2013-12-02','12:11:35',0,'2013-12-25 19:50:09',NULL,NULL),(14470,2491,'0001','999','BE','005010X231A1','457321','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:42',NULL,NULL),(5505,1041,'470769','834','00','005010X220A1','470769','','2013-12-24','20:03:50',0,'2013-12-26 01:46:36',NULL,NULL),(21412,4026,'2903650','834','00','005010X220A1','2903650','','2014-02-26','20:17:04',0,'2014-02-28 06:30:40',NULL,NULL),(5151,943,'651553','834','00','005010X220A1','651553','','2013-12-11','16:06:06',0,'2013-12-26 00:50:50',NULL,NULL),(5083,937,'834294','834','00','005010X220A1','834294','','2013-12-11','13:34:19',0,'2013-12-26 00:48:39',NULL,NULL),(3138,552,'1082029','834','00','005010X220A1','1082029','','2013-12-13','10:00:14',0,'2013-12-25 21:37:20',NULL,NULL),(3184,571,'403279','834','00','005010X220A1','403279','','2013-12-13','14:31:51',0,'2013-12-25 21:39:00',NULL,NULL),(3156,560,'50891','834','00','005010X220A1','50891','','2013-12-13','11:09:15',0,'2013-12-25 21:37:57',NULL,NULL),(19497,3620,'2766213','834','00','005010X220A1','2766213','','2014-02-14','17:38:28',0,'2014-02-14 21:30:23',NULL,NULL),(19625,3640,'3035355','834','00','005010X220A1','3035355','','2014-02-14','13:22:34',0,'2014-02-14 21:31:56',NULL,NULL),(20022,3750,'3187033','834','00','005010X220A1','3187033','','2014-02-18','11:55:49',0,'2014-02-18 22:00:48',NULL,NULL),(22082,4174,'3142824','834','00','005010X220A1','3142824','','2014-03-03','15:32:31',0,'2014-03-03 21:30:04',NULL,NULL),(302,70,'823446','834','00','005010X220A1','823446','','2013-12-03','22:15:28',0,'2013-12-25 17:45:16',NULL,NULL),(617,108,'805930','834','00','005010X220A1','805930','','2013-12-16','00:48:42',0,'2013-12-25 18:04:09',NULL,NULL),(15412,2629,'1655270','834','00','005010X220A1','1655270','','2014-01-15','21:36:04',0,'2014-01-17 03:35:53',NULL,NULL),(2407,415,'150222','834','00','005010X220A1','150222','','2013-12-06','14:57:47',0,'2013-12-25 20:17:26',NULL,NULL),(5413,1025,'497474','834','00','005010X220A1','497474','','2013-11-13','23:00:49',0,'2013-12-26 01:30:45',NULL,NULL),(12994,1738,'2211482','834','00','005010X220A1','2211482','','2014-01-04','11:48:05',0,'2014-01-05 00:01:53',NULL,NULL),(12489,1641,'1993101','834','00','005010X220A1','1993101','','2013-12-30','20:11:13',1,'2014-01-02 04:32:54',NULL,NULL),(4503,808,'287855','834','00','005010X220A1','287855','','2013-11-26','17:37:10',0,'2013-12-25 23:32:11',NULL,NULL),(17159,3144,'2485644','834','00','005010X220A1','2485644','','2014-01-30','17:04:31',0,'2014-01-30 21:00:42',NULL,NULL),(18806,3487,'2952598','834','00','005010X220A1','2952598','','2014-02-11','17:14:05',0,'2014-02-11 21:01:20',NULL,NULL),(19069,3542,'1913652','834','00','005010X220A1','1913652','','2014-02-12','15:54:33',0,'2014-02-12 21:31:15',NULL,NULL),(20844,3911,'2613663','834','00','005010X220A1','2613663','','2014-02-25','13:38:48',0,'2014-02-25 21:31:26',NULL,NULL),(22608,4250,'3358728','834','00','005010X220A1','3358728','','2014-03-05','13:54:02',0,'2014-03-05 21:31:24',NULL,NULL),(7002,1235,'666202','834','00','005010X220A1','666202','','2013-12-17','20:39:30',0,'2013-12-26 04:00:33',NULL,NULL),(1499,257,'1044822','834','00','005010X220A1','1044822','','2013-12-24','09:41:24',0,'2013-12-25 18:57:21',NULL,NULL),(13576,2254,'1757926','834','00','005010X220A1','1757926','','2014-01-05','12:54:10',1,'2014-01-07 10:21:52',NULL,NULL),(14717,2550,'2469891','834','00','005010X220A1','2469891','','2014-01-14','11:16:46',0,'2014-01-15 02:06:09',NULL,NULL),(20823,3910,'2423832','834','00','005010X220A1','2423832','','2014-02-25','17:01:57',0,'2014-02-25 21:31:10',NULL,NULL),(21799,4092,'3063050','834','00','005010X220A1','3063050','','2014-02-28','12:23:13',0,'2014-02-28 21:31:20',NULL,NULL),(1101,228,'666713','834','00','005010X220A1','666713','','2013-10-25','12:19:49',0,'2013-12-25 18:32:03',NULL,NULL),(17058,3125,'1785450','834','00','005010X220A1','1785450','','2014-01-28','23:07:56',0,'2014-01-29 21:01:32',NULL,NULL),(1155,239,'1277946','834','00','005010X220A1','1277946','','2013-12-24','11:14:24',0,'2013-12-25 18:46:21',NULL,NULL),(2472,427,'142260','834','00','005010X220A1','142260','','2013-12-06','11:54:20',0,'2013-12-25 20:19:36',NULL,NULL),(4023,731,'279323','834','00','005010X220A1','279323','','2013-12-19','13:39:36',0,'2013-12-25 23:00:51',NULL,NULL),(4752,858,'665720','834','00','005010X220A1','665720','','2013-12-01','11:22:52',0,'2013-12-26 00:00:22',NULL,NULL),(2826,509,'1297944','834','00','005010X220A1','1297944','','2013-12-21','20:26:00',0,'2013-12-25 21:21:10',NULL,NULL),(17503,3224,'2404671','834','00','005010X220A1','2404671','','2014-02-01','22:38:26',0,'2014-02-02 19:00:26',NULL,NULL),(17637,3245,'2289453','834','00','005010X220A1','2289453','','2014-02-03','10:39:28',0,'2014-02-03 21:01:20',NULL,NULL),(18306,3383,'2235212','834','00','005010X220A1','2235212','','2014-02-07','19:38:54',0,'2014-02-08 19:00:39',NULL,NULL),(21185,3998,'2817162','834','00','005010X220A1','2817162','','2014-02-26','13:16:18',0,'2014-02-26 21:01:07',NULL,NULL),(23135,4342,'3267044','834','00','005010X220A1','3267044','','2014-03-07','12:56:20',0,'2014-03-07 21:31:00',NULL,NULL),(301,70,'3850','834','00','005010X220A1','3850','','2013-12-03','22:15:28',0,'2013-12-25 17:45:15',NULL,NULL),(16405,2994,'2274056','834','00','005010X220A1','2274056','','2014-01-23','11:59:08',0,'2014-01-23 21:01:26',NULL,NULL),(10807,1404,'440430','834','00','005010X220A1','440430','','2013-12-23','15:10:51',0,'2013-12-26 13:04:06',NULL,NULL),(14207,2365,'1702974','834','00','005010X220A1','1702974','','2014-01-10','16:02:06',0,'2014-01-13 02:23:48',NULL,NULL),(735,128,'773471','834','00','005010X220A1','773471','','2013-12-16','12:16:35',0,'2013-12-25 18:07:54',NULL,NULL),(1467,252,'921652','834','00','005010X220A1','921652','','2013-12-24','15:16:30',0,'2013-12-25 18:56:21',NULL,NULL),(12233,1618,'2344706','834','00','005010X220A1','2344706','','2013-12-31','19:53:54',1,'2014-01-02 04:22:44',NULL,NULL),(4512,812,'194525','834','00','005010X220A1','194525','','2013-11-26','17:34:08',0,'2013-12-25 23:32:26',NULL,NULL),(1750,293,'760159','834','00','005010X220A1','760159','','2013-12-10','16:38:33',0,'2013-12-25 19:17:58',NULL,NULL),(10577,1402,'388774','834','00','005010X220A1','388774','','2013-12-23','11:20:26',0,'2013-12-26 12:56:27',NULL,NULL),(10454,1400,'900188','834','00','005010X220A1','900188','','2013-12-23','13:25:23',0,'2013-12-26 12:52:25',NULL,NULL),(18463,3426,'2079219','834','00','005010X220A1','2079219','','2014-02-10','03:57:11',0,'2014-02-10 11:00:45',NULL,NULL),(21731,4088,'3509260','834','00','005010X220A1','3509260','','2014-02-28','17:58:16',0,'2014-02-28 21:30:33',NULL,NULL),(22299,4201,'3660181','834','00','005010X220A1','3660181','','2014-03-04','10:14:16',0,'2014-03-04 21:00:58',NULL,NULL),(7457,1296,'436745','834','00','005010X220A1','436745','','2013-12-21','00:34:35',0,'2013-12-26 04:32:35',NULL,NULL),(20409,3833,'2693998','834','00','005010X220A1','2693998','','2014-02-20','14:51:27',0,'2014-02-20 21:30:13',NULL,NULL),(20654,3876,'3117825','834','00','005010X220A1','3117825','','2014-02-20','19:20:50',0,'2014-02-21 22:00:55',NULL,NULL),(22445,4231,'2983047','834','00','005010X220A1','2983047','','2014-03-04','12:57:15',0,'2014-03-04 21:30:13',NULL,NULL),(10945,1410,'250633','834','00','005010X220A1','250633','','2013-12-23','15:36:25',0,'2013-12-26 13:09:04',NULL,NULL),(15776,2717,'1943987','834','00','005010X220A1','1943987','','2014-01-20','12:47:59',0,'2014-01-21 08:46:33',NULL,NULL),(16314,2980,'1878230','834','00','005010X220A1','1878230','','2014-01-23','15:33:21',0,'2014-01-23 21:00:24',NULL,NULL),(18223,3357,'2988802','834','00','005010X220A1','2988802','','2014-02-07','10:00:09',0,'2014-02-07 19:00:52',NULL,NULL),(19174,3562,'2678234','834','00','005010X220A1','2678234','','2014-02-12','14:23:41',0,'2014-02-12 21:32:28',NULL,NULL),(19507,3621,'2977677','834','00','005010X220A1','2977677','','2014-02-14','17:34:20',0,'2014-02-14 21:30:30',NULL,NULL),(20860,3911,'3526093','834','00','005010X220A1','3526093','','2014-02-25','17:36:02',0,'2014-02-25 21:31:38',NULL,NULL),(21574,4054,'3153775','834','00','005010X220A1','3153775','','2014-02-26','17:28:57',0,'2014-02-28 07:00:16',NULL,NULL),(23255,4372,'3065850','834','00','005010X220A1','3065850','','2014-03-07','14:00:53',0,'2014-03-07 21:32:26',NULL,NULL),(23670,4444,'3816991','834','00','005010X220A1','3816991','','2014-03-10','17:35:47',0,'2014-03-10 21:02:05',NULL,NULL),(11549,1492,'2013100','834','00','005010X220A1','2013100','','2013-12-26','20:22:42',0,'2013-12-28 03:33:07',NULL,NULL),(17358,3181,'2247679','834','00','005010X220A1','2247679','','2014-01-31','15:38:44',0,'2014-01-31 21:01:22',NULL,NULL),(522,102,'1095880','834','00','005010X220A1','1095880','','2013-12-16','13:00:13',0,'2013-12-25 18:01:06',NULL,NULL),(14191,2365,'1707913','834','00','005010X220A1','1707913','','2014-01-10','12:06:30',0,'2014-01-13 02:23:37',NULL,NULL),(11089,1424,'1496613','834','00','005010X220A1','1496613','','2013-12-22','21:47:40',0,'2013-12-26 13:13:46',NULL,NULL),(1694,292,'1029540','834','00','005010X220A1','1029540','','2013-12-09','18:28:16',0,'2013-12-25 19:16:19',NULL,NULL),(6185,1167,'702348','834','00','005010X220A1','702348','','2013-12-20','17:31:27',0,'2013-12-26 03:03:51',NULL,NULL),(18720,3485,'1731387','834','00','005010X220A1','1731387','','2014-02-10','23:08:35',0,'2014-02-11 21:00:15',NULL,NULL),(19375,3590,'3348794','834','00','005010X220A1','3348794','','2014-02-13','12:58:33',0,'2014-02-13 22:02:11',NULL,NULL),(20762,3906,'3028209','834','00','005010X220A1','3028209','','2014-02-24','22:09:21',0,'2014-02-25 21:30:28',NULL,NULL),(21341,4022,'3529881','834','00','005010X220A1','3529881','','2014-02-27','10:01:21',0,'2014-02-28 06:30:08',NULL,NULL),(10774,1404,'735296','834','00','005010X220A1','735296','','2013-12-23','00:16:28',0,'2013-12-26 13:03:04',NULL,NULL),(15906,2743,'2411787','834','00','005010X220A1','2411787','','2014-01-21','09:56:04',1,'2014-01-22 03:22:45',NULL,NULL),(1104,231,'281932','834','00','005010X220A1','281932','','2013-10-25','16:06:38',0,'2013-12-25 18:32:10',NULL,NULL),(3644,624,'413102','834','00','005010X220A1','413102','','2013-12-11','19:44:58',0,'2013-12-25 22:05:44',NULL,NULL),(5767,1072,'757599','834','00','005010X220A1','757599','','2013-12-14','12:50:02',0,'2013-12-26 02:02:26',NULL,NULL),(5381,1011,'599445','834','00','005010X220A1','599445','','2013-11-25','17:56:52',0,'2013-12-26 01:16:56',NULL,NULL),(904,177,'690471','834','00','005010X220A1','690471','','2013-12-03','11:34:47',0,'2013-12-25 18:17:14',NULL,NULL),(17526,3235,'2275314','834','00','005010X220A1','2275314','','2014-02-03','12:21:40',0,'2014-02-03 21:00:13',NULL,NULL),(15574,2657,'2058836','834','00','005010X220A1','2058836','','2014-01-17','09:46:40',0,'2014-01-20 08:06:07',NULL,NULL),(14787,2551,'2569854','834','00','005010X220A1','2569854','','2014-01-14','15:42:34',0,'2014-01-15 02:06:40',NULL,NULL),(925,179,'153118','834','00','005010X220A1','153118','','2013-12-03','15:35:19',0,'2013-12-25 18:17:52',NULL,NULL),(12385,1637,'1479320','834','00','005010X220A1','1479320','','2013-12-31','05:13:47',1,'2014-01-02 04:29:08',NULL,NULL),(1007,188,'931115','834','00','005010X220A1','931115','','2013-12-03','14:05:13',0,'2013-12-25 18:20:29',NULL,NULL),(11354,1458,'1452138','834','00','005010X220A1','1452138','','2013-12-26','13:29:14',0,'2013-12-27 02:05:09',NULL,NULL),(19935,3734,'2819630','834','00','005010X220A1','2819630','','2014-02-17','22:56:02',0,'2014-02-18 21:30:07',NULL,NULL),(20681,3883,'2998205','834','00','005010X220A1','2998205','','2014-02-21','15:13:15',0,'2014-02-21 22:01:13',NULL,NULL),(775,144,'709148','834','00','005010X220A1','709148','','2013-10-31','12:32:37',0,'2013-12-25 18:09:12',NULL,NULL),(4968,933,'606591','834','00','005010X220A1','606591','','2013-10-07','09:29:38',0,'2013-12-26 00:32:23',NULL,NULL),(13755,2277,'2431438','834','00','005010X220A1','2431438','','2014-01-07','12:02:56',0,'2014-01-08 18:24:54',NULL,NULL),(13741,2276,'2120175','834','00','005010X220A1','2120175','','2014-01-07','10:07:31',0,'2014-01-08 18:24:47',NULL,NULL),(13125,1969,'0001','999','BE','005010X231A1','615292','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:48',NULL,NULL),(12550,1656,'2151587','834','00','005010X220A1','2151587','','2013-12-31','11:39:43',1,'2014-01-02 04:35:15',NULL,NULL),(10553,1402,'196586','834','00','005010X220A1','196586','','2013-12-22','21:13:23',0,'2013-12-26 12:55:38',NULL,NULL),(4848,884,'1127049','834','00','005010X220A1','1127049','','2013-11-21','09:43:53',0,'2013-12-26 00:15:32',NULL,NULL),(16175,2867,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:12:00',1,'2014-01-23 04:18:35',NULL,NULL),(17877,3294,'2151297','834','00','005010X220A1','2151297','','2014-02-04','19:15:27',0,'2014-02-05 21:30:19',NULL,NULL),(18454,3423,'1690046','834','00','005010X220A1','1690046','','2014-02-10','04:20:01',0,'2014-02-10 11:00:37',NULL,NULL),(19370,3590,'1762843','834','00','005010X220A1','1762843','','2014-02-13','10:32:09',0,'2014-02-13 22:02:08',NULL,NULL),(19397,3593,'2658050','834','00','005010X220A1','2658050','','2014-02-13','12:07:41',0,'2014-02-13 22:02:27',NULL,NULL),(22357,4205,'2788108','834','00','005010X220A1','2788108','','2014-03-04','11:55:18',0,'2014-03-04 21:01:44',NULL,NULL),(22786,4277,'3285674','834','00','005010X220A1','3285674','','2014-03-06','15:11:54',0,'2014-03-06 21:00:55',NULL,NULL),(23599,4438,'3524103','834','00','005010X220A1','3524103','','2014-03-09','18:58:48',0,'2014-03-10 21:01:15',NULL,NULL),(5766,1072,'6575','834','00','005010X220A1','6575','','2013-12-14','11:27:16',0,'2013-12-26 02:02:24',NULL,NULL),(12591,1671,'2266860','834','00','005010X220A1','2266860','','2014-01-02','10:59:35',0,'2014-01-03 02:00:47',NULL,NULL),(12041,1583,'1493597','834','00','005010X220A1','1493597','','2013-12-30','15:55:47',0,'2014-01-01 12:03:38',NULL,NULL),(11695,1517,'1868251','834','00','005010X220A1','1868251','','2013-12-27','20:24:41',1,'2013-12-29 11:07:46',NULL,NULL),(5564,1043,'1778114','834','00','005010X220A1','1778114','','2013-12-24','19:42:23',0,'2013-12-26 01:48:29',NULL,NULL),(3661,626,'498883','834','00','005010X220A1','498883','','2013-12-12','11:20:14',0,'2013-12-25 22:06:15',NULL,NULL),(17214,3152,'2203161','834','00','005010X220A1','2203161','','2014-01-30','01:44:06',0,'2014-01-30 21:01:19',NULL,NULL),(17260,3170,'2418445','834','00','005010X220A1','2418445','','2014-01-31','09:17:48',0,'2014-01-31 21:00:13',NULL,NULL),(18043,3319,'2666654','834','00','005010X220A1','2666654','','2014-02-05','21:52:48',0,'2014-02-06 21:00:36',NULL,NULL),(21378,4024,'3758855','834','00','005010X220A1','3758855','','2014-02-27','12:38:22',0,'2014-02-28 06:30:26',NULL,NULL),(4044,731,'172287','834','00','005010X220A1','172287','','2013-12-19','17:03:56',0,'2013-12-25 23:01:28',NULL,NULL),(16091,2783,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:47:00',0,'2014-01-23 03:39:20',NULL,NULL),(14953,2565,'2010293','834','00','005010X220A1','2010293','','2014-01-13','22:31:44',0,'2014-01-15 02:07:53',NULL,NULL),(1346,245,'1946963','834','00','005010X220A1','1946963','','2013-12-24','13:07:28',0,'2013-12-25 18:52:17',NULL,NULL),(13850,2311,'2159760','834','00','005010X220A1','2159760','','2014-01-09','12:04:07',0,'2014-01-13 02:19:12',NULL,NULL),(13373,2217,'0001','999','BE','005010X231A1','385746','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:35',NULL,NULL),(18631,3460,'1865474','834','00','005010X220A1','1865474','','2014-02-10','17:56:18',0,'2014-02-10 21:31:26',NULL,NULL),(23192,4345,'3172941','834','00','005010X220A1','3172941','','2014-03-07','17:23:30',0,'2014-03-07 21:31:40',NULL,NULL),(1616,281,'122041','834','00','005010X220A1','122041','','2013-11-19','23:03:18',0,'2013-12-25 19:01:36',NULL,NULL),(12665,1673,'2075076','834','00','005010X220A1','2075076','','2014-01-02','12:19:55',0,'2014-01-03 02:03:30',NULL,NULL),(12598,1671,'1509674','834','00','005010X220A1','1509674','','2014-01-02','14:21:51',0,'2014-01-03 02:01:00',NULL,NULL),(11597,1493,'2280294','834','00','005010X220A1','2280294','','2013-12-26','23:57:12',0,'2013-12-28 03:34:38',NULL,NULL),(13580,2254,'1481722','834','00','005010X220A1','1481722','','2014-01-05','16:43:37',1,'2014-01-07 10:22:00',NULL,NULL),(4039,731,'557578','834','00','005010X220A1','557578','','2013-12-19','15:55:56',0,'2013-12-25 23:01:19',NULL,NULL),(5651,1050,'420922','834','00','005010X220A1','420922','','2013-12-24','19:35:12',0,'2013-12-26 01:51:20',NULL,NULL),(5869,1103,'873049','834','00','005010X220A1','873049','','2013-10-28','15:37:37',0,'2013-12-26 02:16:53',NULL,NULL),(18413,3419,'2674704','834','00','005010X220A1','2674704','','2014-02-09','17:47:17',0,'2014-02-09 19:00:45',NULL,NULL),(22291,4201,'2889966','834','00','005010X220A1','2889966','','2014-03-03','19:11:58',0,'2014-03-04 21:00:52',NULL,NULL),(22292,4201,'2665979','834','00','005010X220A1','2665979','','2014-03-03','20:10:33',0,'2014-03-04 21:00:52',NULL,NULL),(23487,4429,'2745885','834','00','005010X220A1','2745885','','2014-03-09','12:31:44',0,'2014-03-09 21:30:01',NULL,NULL),(7531,1300,'721523','834','00','005010X220A1','721523','','2013-12-21','14:19:19',0,'2013-12-26 04:35:02',NULL,NULL),(5895,1110,'78385','834','00','005010X220A1','78385','','2013-12-15','11:50:25',0,'2013-12-26 02:30:36',NULL,NULL),(17638,3246,'2644662','834','00','005010X220A1','2644662','','2014-02-03','11:14:53',0,'2014-02-03 21:01:21',NULL,NULL),(18445,3422,'2120629','834','00','005010X220A1','2120629','','2014-02-10','04:28:14',0,'2014-02-10 11:00:29',NULL,NULL),(19833,3683,'2408753','834','00','005010X220A1','2408753','','2014-02-15','10:13:44',0,'2014-02-15 22:01:50',NULL,NULL),(20555,3862,'2854090','834','00','005010X220A1','2854090','','2014-02-21','15:06:56',0,'2014-02-21 21:30:07',NULL,NULL),(22649,4253,'3403625','834','00','005010X220A1','3403625','','2014-03-05','16:06:50',0,'2014-03-05 21:31:52',NULL,NULL),(23711,4456,'2828242','834','00','005010X220A1','2828242','','2014-03-10','10:51:37',0,'2014-03-10 21:02:36',NULL,NULL),(55,3,'1006557','834','00','005010X220A1','1006557','','2013-12-05','10:04:04',0,'2013-12-25 17:16:40',NULL,NULL),(7106,1236,'732790','834','00','005010X220A1','732790','','2013-12-18','12:40:46',0,'2013-12-26 04:03:46',NULL,NULL),(15799,2722,'2452991','834','00','005010X220A1','2452991','','2014-01-20','16:03:57',0,'2014-01-21 08:46:47',NULL,NULL),(14088,2341,'1408431','834','00','005010X220A1','1408431','','2014-01-08','12:58:04',0,'2014-01-13 02:22:02',NULL,NULL),(5810,1082,'511327','834','00','005010X220A1','511327','','2013-12-14','12:48:24',0,'2013-12-26 02:03:53',NULL,NULL),(11710,1517,'2290881','834','00','005010X220A1','2290881','','2013-12-28','17:30:34',1,'2013-12-29 11:08:11',NULL,NULL),(18798,3487,'2142832','834','00','005010X220A1','2142832','','2014-02-11','15:13:03',0,'2014-02-11 21:01:14',NULL,NULL),(7220,1241,'364804','834','00','005010X220A1','364804','','2013-12-18','13:51:19',0,'2013-12-26 04:07:13',NULL,NULL),(1394,245,'784555','834','00','005010X220A1','784555','','2013-12-24','17:58:54',0,'2013-12-25 18:53:49',NULL,NULL),(1748,293,'1174662','834','00','005010X220A1','1174662','','2013-12-10','16:07:22',0,'2013-12-25 19:17:55',NULL,NULL),(17833,3281,'2136199','834','00','005010X220A1','2136199','','2014-02-04','17:22:56',0,'2014-02-04 21:01:56',NULL,NULL),(18891,3498,'1935761','834','00','005010X220A1','1935761','','2014-02-11','15:38:16',0,'2014-02-11 21:02:27',NULL,NULL),(21011,3962,'3294251','834','00','005010X220A1','3294251','','2014-02-21','23:48:29',0,'2014-02-26 08:30:47',NULL,NULL),(21534,4039,'2605088','834','00','005010X220A1','2605088','','2014-02-27','11:08:55',0,'2014-02-28 06:31:37',NULL,NULL),(1090,219,'876832','834','00','005010X220A1','876832','','2013-11-04','10:12:20',0,'2013-12-25 18:31:38',NULL,NULL),(16232,2924,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:22:00',0,'2014-01-23 06:40:34',NULL,NULL),(12043,1583,'1623003','834','00','005010X220A1','1623003','','2013-12-30','16:48:11',0,'2014-01-01 12:03:42',NULL,NULL),(12006,1583,'1854887','834','00','005010X220A1','1854887','','2013-12-29','20:39:24',0,'2014-01-01 12:02:18',NULL,NULL),(11954,1580,'54152','834','00','005010X220A1','54152','','2013-12-30','07:41:15',0,'2014-01-01 12:00:21',NULL,NULL),(11651,1500,'1109936','834','00','005010X220A1','1109936','','2013-12-27','06:31:05',0,'2013-12-28 03:36:19',NULL,NULL),(4921,910,'275854','834','00','005010X220A1','275854','','2013-10-16','20:13:07',0,'2013-12-26 00:30:51',NULL,NULL),(4469,801,'52987','834','00','005010X220A1','52987','','2013-11-26','15:56:27',0,'2013-12-25 23:31:02',NULL,NULL),(4425,789,'148715','834','00','005010X220A1','148715','','2013-11-05','21:29:17',0,'2013-12-25 23:16:51',NULL,NULL),(6204,1168,'1037960','834','00','005010X220A1','1037960','','2013-12-19','20:10:55',0,'2013-12-26 03:04:26',NULL,NULL),(7096,1236,'1296280','834','00','005010X220A1','1296280','','2013-12-18','11:08:54',0,'2013-12-26 04:03:29',NULL,NULL),(11128,1429,'33236','834','00','005010X220A1','33236','','2013-12-23','13:43:32',0,'2013-12-26 13:15:07',NULL,NULL),(2470,426,'247574','834','00','005010X220A1','247574','','2013-12-06','12:32:08',0,'2013-12-25 20:19:32',NULL,NULL),(10843,1404,'1228841','834','00','005010X220A1','1228841','','2013-12-23','19:22:39',0,'2013-12-26 13:05:15',NULL,NULL),(18365,3405,'2058152','834','00','005010X220A1','2058152','','2014-02-09','16:56:29',0,'2014-02-09 19:00:11',NULL,NULL),(19181,3569,'2627883','834','00','005010X220A1','2627883','','2014-02-12','21:11:08',0,'2014-02-13 21:30:03',NULL,NULL),(21058,3979,'3539502','834','00','005010X220A1','3539502','','2014-02-24','13:40:25',0,'2014-02-26 09:30:33',NULL,NULL),(22052,4167,'2940663','834','00','005010X220A1','2940663','','2014-03-03','13:26:56',0,'2014-03-03 21:00:11',NULL,NULL),(189,16,'1152059','834','00','005010X220A1','1152059','','2013-12-05','14:36:10',0,'2013-12-25 17:20:52',NULL,NULL),(228,35,'1073761','834','00','005010X220A1','1073761','','2013-10-12','12:44:19',0,'2013-12-25 17:30:09',NULL,NULL),(13798,2294,'1369201','834','00','005010X220A1','1369201','','2014-01-11','13:24:44',0,'2014-01-13 02:18:13',NULL,NULL),(7433,1295,'1244807','834','00','005010X220A1','1244807','','2013-12-21','14:27:24',0,'2013-12-26 04:31:55',NULL,NULL),(7309,1262,'935421','834','00','005010X220A1','935421','','2013-12-18','18:20:15',0,'2013-12-26 04:09:58',NULL,NULL),(5129,943,'203744','834','00','005010X220A1','203744','','2013-12-10','23:35:38',0,'2013-12-26 00:50:11',NULL,NULL),(21448,4028,'3385629','834','00','005010X220A1','3385629','','2014-02-26','20:58:04',0,'2014-02-28 06:30:58',NULL,NULL),(545,103,'354071','834','00','005010X220A1','354071','','2013-12-15','20:17:47',0,'2013-12-25 18:01:51',NULL,NULL),(11010,1414,'342605','834','00','005010X220A1','342605','','2013-12-23','09:44:16',0,'2013-12-26 13:11:08',NULL,NULL),(1625,281,'526818','834','00','005010X220A1','526818','','2013-11-19','23:05:12',0,'2013-12-25 19:01:49',NULL,NULL),(15245,2598,'1467407','834','00','005010X220A1','1467407','','2014-01-15','15:51:32',0,'2014-01-16 08:46:53',NULL,NULL),(14709,2550,'2538797','834','00','005010X220A1','2538797','','2014-01-14','09:07:18',0,'2014-01-15 02:06:06',NULL,NULL),(10551,1402,'1216235','834','00','005010X220A1','1216235','','2013-12-22','21:03:23',0,'2013-12-26 12:55:34',NULL,NULL),(4671,831,'1280245','834','00','005010X220A1','1280245','','2013-12-23','22:45:51',0,'2013-12-25 23:49:37',NULL,NULL),(5816,1084,'772205','834','00','005010X220A1','772205','','2013-12-14','15:54:59',0,'2013-12-26 02:04:06',NULL,NULL),(11721,1519,'1781800','834','00','005010X220A1','1781800','','2013-12-28','00:28:37',1,'2013-12-29 11:08:33',NULL,NULL),(5592,1043,'72306','834','00','005010X220A1','72306','','2013-12-25','00:51:03',0,'2013-12-26 01:49:25',NULL,NULL),(18976,3537,'2573038','834','00','005010X220A1','2573038','','2014-02-12','09:19:00',0,'2014-02-12 21:30:11',NULL,NULL),(20579,3867,'2742702','834','00','005010X220A1','2742702','','2014-02-20','20:30:02',0,'2014-02-21 21:30:22',NULL,NULL),(20921,3933,'2867149','834','00','005010X220A1','2867149','','2014-02-22','22:50:59',0,'2014-02-26 08:00:17',NULL,NULL),(21939,4132,'2647458','834','00','005010X220A1','2647458','','2014-02-28','20:01:22',0,'2014-03-01 21:00:57',NULL,NULL),(23259,4376,'3809351','834','00','005010X220A1','3809351','','2014-03-07','17:36:47',0,'2014-03-07 21:32:30',NULL,NULL),(23393,4402,'3471867','834','00','005010X220A1','3471867','','2014-03-08','18:15:24',0,'2014-03-09 21:00:06',NULL,NULL),(5893,1110,'742117','834','00','005010X220A1','742117','','2013-12-15','11:10:01',0,'2013-12-26 02:30:32',NULL,NULL),(3854,686,'19191','834','00','005010X220A1','19191','','2013-11-08','16:03:07',0,'2013-12-25 22:30:43',NULL,NULL),(5586,1043,'1976730','834','00','005010X220A1','1976730','','2013-12-24','23:44:56',0,'2013-12-26 01:49:12',NULL,NULL),(14231,2368,'1409927','834','00','005010X220A1','1409927','','2014-01-10','17:59:55',0,'2014-01-13 02:24:04',NULL,NULL),(14083,2341,'1912754','834','00','005010X220A1','1912754','','2014-01-08','10:00:46',0,'2014-01-13 02:21:59',NULL,NULL),(4880,890,'781099','834','00','005010X220A1','781099','','2013-11-21','13:09:10',0,'2013-12-26 00:16:37',NULL,NULL),(12304,1630,'2155483','834','00','005010X220A1','2155483','','2014-01-01','10:32:10',1,'2014-01-02 04:25:25',NULL,NULL),(17761,3262,'1524251','834','00','005010X220A1','1524251','','2014-02-04','15:28:57',0,'2014-02-04 21:01:06',NULL,NULL),(18063,3321,'2901887','834','00','005010X220A1','2901887','','2014-02-06','06:31:42',0,'2014-02-06 21:00:51',NULL,NULL),(22651,4254,'2698034','834','00','005010X220A1','2698034','','2014-03-04','18:45:55',0,'2014-03-05 21:31:53',NULL,NULL),(22697,4261,'3160355','834','00','005010X220A1','3160355','','2014-03-05','11:20:58',0,'2014-03-05 21:32:26',NULL,NULL),(7622,1307,'188916','834','00','005010X220A1','188916','','2013-12-20','20:02:36',0,'2013-12-26 04:37:59',NULL,NULL),(16119,2811,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 03:45:53',NULL,NULL),(7619,1306,'280493','834','00','005010X220A1','280493','','2013-12-20','21:10:27',0,'2013-12-26 04:37:53',NULL,NULL),(15403,2626,'2061129','834','00','005010X220A1','2061129','','2014-01-16','17:16:51',0,'2014-01-17 03:35:48',NULL,NULL),(13763,2279,'1665313','834','00','005010X220A1','1665313','','2014-01-07','10:24:21',0,'2014-01-08 18:24:57',NULL,NULL),(2540,457,'739284','834','00','005010X220A1','739284','','2013-11-18','00:20:48',0,'2013-12-25 20:31:12',NULL,NULL),(5126,943,'1154990','834','00','005010X220A1','1154990','','2013-12-10','19:54:49',0,'2013-12-26 00:50:05',NULL,NULL),(6236,1168,'474464','834','00','005010X220A1','474464','','2013-12-20','18:45:01',0,'2013-12-26 03:05:28',NULL,NULL),(1532,260,'69552','834','00','005010X220A1','69552','','2013-12-24','17:13:12',0,'2013-12-25 18:58:24',NULL,NULL),(17506,3226,'2119759','834','00','005010X220A1','2119759','','2014-02-02','09:15:34',0,'2014-02-02 19:00:28',NULL,NULL),(18045,3319,'2925922','834','00','005010X220A1','2925922','','2014-02-05','23:29:41',0,'2014-02-06 21:00:38',NULL,NULL),(19085,3542,'3143388','834','00','005010X220A1','3143388','','2014-02-12','16:31:38',0,'2014-02-12 21:31:28',NULL,NULL),(19567,3627,'2378342','834','00','005010X220A1','2378342','','2014-02-13','18:45:50',0,'2014-02-14 21:31:14',NULL,NULL),(20222,3785,'3436187','834','00','005010X220A1','3436187','','2014-02-18','21:51:59',0,'2014-02-20 04:24:00',NULL,NULL),(23131,4342,'3572064','834','00','005010X220A1','3572064','','2014-03-07','11:20:39',0,'2014-03-07 21:30:57',NULL,NULL),(14,1,'1180395','834','00','005010X220A1','1180395','','2013-12-05','10:30:53',0,'2013-12-25 17:15:26',NULL,NULL),(13466,2226,'1534657','834','00','005010X220A1','1534657','','2014-01-05','20:07:14',0,'2014-01-07 04:03:22',NULL,NULL),(13387,2221,'2532197','834','00','005010X220A1','2532197','','2014-01-06','13:46:15',0,'2014-01-07 04:00:23',NULL,NULL),(13213,2057,'0001','999','BE','005010X231A1','1169631','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:28',NULL,NULL),(2380,414,'64738','834','00','005010X220A1','64738','','2013-12-06','11:40:27',0,'2013-12-25 20:16:37',NULL,NULL),(18814,3489,'2590846','834','00','005010X220A1','2590846','','2014-02-11','14:58:35',0,'2014-02-11 21:01:26',NULL,NULL),(19039,3540,'3011229','834','00','005010X220A1','3011229','','2014-02-12','17:54:48',0,'2014-02-12 21:30:53',NULL,NULL),(20074,3760,'2279269','834','00','005010X220A1','2279269','','2014-02-18','11:08:09',0,'2014-02-18 22:01:27',NULL,NULL),(2900,537,'145483','834','00','005010X220A1','145483','','2013-12-22','17:31:36',0,'2013-12-25 21:23:46',NULL,NULL),(15643,2678,'1993608','834','00','005010X220A1','1993608','','2014-01-18','16:07:11',0,'2014-01-21 08:44:19',NULL,NULL),(14964,2568,'2056264','834','00','005010X220A1','2056264','','2014-01-14','10:12:25',0,'2014-01-15 02:07:59',NULL,NULL),(14445,2466,'0001','999','BE','005010X231A1','1201205','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:18',NULL,NULL),(1164,239,'1047478','834','00','005010X220A1','1047478','','2013-12-24','12:25:04',0,'2013-12-25 18:46:37',NULL,NULL),(17208,3151,'1948914','834','00','005010X220A1','1948914','','2014-01-29','20:14:22',0,'2014-01-30 21:01:14',NULL,NULL),(15408,2627,'1558016','834','00','005010X220A1','1558016','','2014-01-16','13:23:32',0,'2014-01-17 03:35:51',NULL,NULL),(13366,2210,'0001','999','BE','005010X231A1','159929','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:15',NULL,NULL),(12008,1583,'2329793','834','00','005010X220A1','2329793','','2013-12-29','22:14:14',0,'2014-01-01 12:02:23',NULL,NULL),(4382,774,'1024659','834','00','005010X220A1','1024659','','2013-11-26','18:58:49',0,'2013-12-25 23:15:25',NULL,NULL),(10985,1413,'1187625','834','00','005010X220A1','1187625','','2013-12-23','10:33:40',0,'2013-12-26 13:10:15',NULL,NULL),(21474,4028,'3763020','834','00','005010X220A1','3763020','','2014-02-27','15:05:08',0,'2014-02-28 06:31:09',NULL,NULL),(716,119,'774527','834','00','005010X220A1','774527','','2013-12-16','15:31:12',0,'2013-12-25 18:07:16',NULL,NULL),(17042,3122,'1571022','834','00','005010X220A1','1571022','','2014-01-28','21:43:20',0,'2014-01-29 21:01:21',NULL,NULL),(16902,3103,'2374028','834','00','005010X220A1','2374028','','2014-01-28','11:38:45',0,'2014-01-28 21:01:15',NULL,NULL),(16199,2891,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','09:49:00',1,'2014-01-23 04:46:06',NULL,NULL),(2831,510,'83827','834','00','005010X220A1','83827','','2013-12-22','14:02:48',0,'2013-12-25 21:21:19',NULL,NULL),(10631,1402,'1772754','834','00','005010X220A1','1772754','','2013-12-23','16:20:37',0,'2013-12-26 12:58:11',NULL,NULL),(14524,2518,'1674005','834','00','005010X220A1','1674005','','2014-01-12','21:03:37',0,'2014-01-14 01:32:18',NULL,NULL),(13806,2295,'1768198','834','00','005010X220A1','1768198','','2014-01-11','11:56:36',0,'2014-01-13 02:18:18',NULL,NULL),(10372,1400,'86397','834','00','005010X220A1','86397','','2013-12-22','19:34:36',0,'2013-12-26 12:49:51',NULL,NULL),(7764,1351,'1195019','834','00','005010X220A1','1195019','','2013-10-21','00:03:38',0,'2013-12-26 05:01:19',NULL,NULL),(6104,1166,'1002357','834','00','005010X220A1','1002357','','2013-12-20','09:55:15',0,'2013-12-26 03:01:27',NULL,NULL),(20255,3794,'2402660','834','00','005010X220A1','2402660','','2014-02-18','22:31:44',0,'2014-02-20 04:33:16',NULL,NULL),(20630,3872,'2635385','834','00','005010X220A1','2635385','','2014-02-21','11:46:34',0,'2014-02-21 22:00:38',NULL,NULL),(21353,4023,'2769059','834','00','005010X220A1','2769059','','2014-02-26','18:10:17',0,'2014-02-28 06:30:13',NULL,NULL),(11986,1580,'1641397','834','00','005010X220A1','1641397','','2013-12-30','17:28:46',0,'2014-01-01 12:01:34',NULL,NULL),(16995,3118,'1997475','834','00','005010X220A1','1997475','','2014-01-29','10:18:26',0,'2014-01-29 21:00:51',NULL,NULL),(16254,2946,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',0,'2014-01-23 07:07:12',NULL,NULL),(11799,1538,'1040956','834','00','005010X220A1','1040956','','2013-12-28','20:05:37',1,'2013-12-29 11:13:05',NULL,NULL),(15563,2655,'2576292','834','00','005010X220A1','2576292','','2014-01-17','15:17:21',0,'2014-01-20 08:05:58',NULL,NULL),(14714,2550,'2128155','834','00','005010X220A1','2128155','','2014-01-14','10:55:34',0,'2014-01-15 02:06:08',NULL,NULL),(10480,1400,'64161','834','00','005010X220A1','64161','','2013-12-23','15:43:01',0,'2013-12-26 12:53:16',NULL,NULL),(7576,1301,'1138653','834','00','005010X220A1','1138653','','2013-12-21','15:12:21',0,'2013-12-26 04:36:28',NULL,NULL),(13098,1942,'0001','999','BE','005010X231A1','1173637','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:32',NULL,NULL),(2666,501,'1356033','834','00','005010X220A1','1356033','','2013-12-22','16:02:04',0,'2013-12-25 21:16:04',NULL,NULL),(3793,658,'182033','834','00','005010X220A1','182033','','2013-12-08','10:02:27',0,'2013-12-25 22:16:03',NULL,NULL),(20484,3843,'3682687','834','00','005010X220A1','3682687','','2014-02-20','16:30:11',0,'2014-02-20 22:00:51',NULL,NULL),(23013,4323,'3644574','834','00','005010X220A1','3644574','','2014-03-07','16:28:09',0,'2014-03-07 21:00:17',NULL,NULL),(872,177,'623782','834','00','005010X220A1','623782','','2013-12-02','19:23:29',0,'2013-12-25 18:16:22',NULL,NULL),(16277,2969,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:05:00',0,'2014-01-23 13:30:02',NULL,NULL),(15779,2717,'2081564','834','00','005010X220A1','2081564','','2014-01-20','10:02:43',0,'2014-01-21 08:46:35',NULL,NULL),(1667,290,'800871','834','00','005010X220A1','800871','','2013-12-09','21:40:04',0,'2013-12-25 19:15:28',NULL,NULL),(14063,2339,'1431433','834','00','005010X220A1','1431433','','2014-01-08','11:25:55',0,'2014-01-13 02:21:45',NULL,NULL),(2339,412,'870936','834','00','005010X220A1','870936','','2013-12-06','13:52:00',0,'2013-12-25 20:15:20',NULL,NULL),(5047,936,'1175759','834','00','005010X220A1','1175759','','2013-12-10','19:24:01',0,'2013-12-26 00:47:28',NULL,NULL),(3546,616,'550040','834','00','005010X220A1','550040','','2013-12-12','13:53:22',0,'2013-12-25 22:02:40',NULL,NULL),(3096,546,'336849','834','00','005010X220A1','336849','','2013-12-13','09:14:55',0,'2013-12-25 21:36:05',NULL,NULL),(21498,4030,'3622761','834','00','005010X220A1','3622761','','2014-02-27','10:52:26',0,'2014-02-28 06:31:20',NULL,NULL),(22150,4179,'3690830','834','00','005010X220A1','3690830','','2014-03-03','15:29:27',0,'2014-03-03 21:30:55',NULL,NULL),(12127,1587,'2057176','834','00','005010X220A1','2057176','','2013-12-30','16:31:37',0,'2014-01-01 12:06:40',NULL,NULL),(12067,1586,'1493573','834','00','005010X220A1','1493573','','2013-12-30','07:40:29',0,'2014-01-01 12:04:36',NULL,NULL),(14223,2366,'2086948','834','00','005010X220A1','2086948','','2014-01-10','14:03:28',0,'2014-01-13 02:23:59',NULL,NULL),(10677,1403,'14689','834','00','005010X220A1','14689','','2013-12-22','20:15:25',0,'2013-12-26 12:59:39',NULL,NULL),(6370,1183,'362046','834','00','005010X220A1','362046','','2013-12-20','07:24:53',0,'2013-12-26 03:09:33',NULL,NULL),(18634,3461,'2749218','834','00','005010X220A1','2749218','','2014-02-10','15:20:00',0,'2014-02-10 21:31:28',NULL,NULL),(20532,3850,'3073496','834','00','005010X220A1','3073496','','2014-02-19','23:50:20',0,'2014-02-20 22:01:29',NULL,NULL),(20940,3946,'3240737','834','00','005010X220A1','3240737','','2014-02-24','14:01:33',0,'2014-02-26 08:00:35',NULL,NULL),(21575,4055,'2887266','834','00','005010X220A1','2887266','','2014-02-26','11:38:14',0,'2014-02-28 07:00:17',NULL,NULL),(22399,4213,'2954284','834','00','005010X220A1','2954284','','2014-03-04','07:56:44',0,'2014-03-04 21:02:19',NULL,NULL),(1172,239,'1865602','834','00','005010X220A1','1865602','','2013-12-24','13:26:10',0,'2013-12-25 18:46:53',NULL,NULL),(18086,3323,'2318462','834','00','005010X220A1','2318462','','2014-02-06','14:59:33',0,'2014-02-06 21:01:06',NULL,NULL),(18433,3420,'2152294','834','00','005010X220A1','2152294','','2014-02-10','04:30:07',0,'2014-02-10 11:00:19',NULL,NULL),(22068,4169,'2863267','834','00','005010X220A1','2863267','','2014-03-03','11:54:51',0,'2014-03-03 21:00:22',NULL,NULL),(7491,1300,'1199634','834','00','005010X220A1','1199634','','2013-12-20','19:08:11',0,'2013-12-26 04:33:44',NULL,NULL),(7395,1294,'814843','834','00','005010X220A1','814843','','2013-12-20','18:52:44',0,'2013-12-26 04:30:41',NULL,NULL),(7166,1238,'661308','834','00','005010X220A1','661308','','2013-12-18','11:20:29',0,'2013-12-26 04:05:33',NULL,NULL),(13719,2275,'1752717','834','00','005010X220A1','1752717','','2014-01-07','14:38:22',0,'2014-01-08 18:24:37',NULL,NULL),(12856,1706,'2171103','834','00','005010X220A1','2171103','','2014-01-03','00:36:07',0,'2014-01-04 02:03:18',NULL,NULL),(12749,1690,'2044200','834','00','005010X220A1','2044200','','2014-01-02','09:41:13',0,'2014-01-03 02:06:39',NULL,NULL),(12429,1638,'2543738','834','00','005010X220A1','2543738','','2013-12-31','13:34:21',1,'2014-01-02 04:30:43',NULL,NULL),(11709,1517,'2407493','834','00','005010X220A1','2407493','','2013-12-28','17:18:08',1,'2013-12-29 11:08:09',NULL,NULL),(5802,1078,'259605','834','00','005010X220A1','259605','','2013-12-14','10:59:04',0,'2013-12-26 02:03:35',NULL,NULL),(11436,1479,'895451','834','00','005010X220A1','895451','','2013-12-26','14:13:25',0,'2013-12-27 02:07:44',NULL,NULL),(4898,904,'601881','834','00','005010X220A1','601881','','2013-10-22','20:01:48',0,'2013-12-26 00:30:02',NULL,NULL),(15706,2701,'2234753','834','00','005010X220A1','2234753','','2014-01-18','19:44:33',0,'2014-01-21 08:45:32',NULL,NULL),(15908,2743,'1366863','834','00','005010X220A1','1366863','','2014-01-21','11:00:44',1,'2014-01-22 03:22:47',NULL,NULL),(16303,2980,'2524081','834','00','005010X220A1','2524081','','2014-01-23','14:22:42',0,'2014-01-23 21:00:15',NULL,NULL),(17837,3285,'2466026','834','00','005010X220A1','2466026','','2014-02-04','07:50:48',0,'2014-02-04 21:30:02',NULL,NULL),(18133,3336,'2845023','834','00','005010X220A1','2845023','','2014-02-05','20:23:26',0,'2014-02-06 21:01:40',NULL,NULL),(21902,4127,'2912960','834','00','005010X220A1','2912960','','2014-02-28','23:50:55',0,'2014-03-01 21:00:31',NULL,NULL),(21955,4137,'2775851','834','00','005010X220A1','2775851','','2014-03-01','14:04:41',0,'2014-03-01 21:01:09',NULL,NULL),(23114,4342,'2721768','834','00','005010X220A1','2721768','','2014-03-06','18:29:46',0,'2014-03-07 21:30:46',NULL,NULL),(237,40,'836697','834','00','005010X220A1','836697','','2013-10-12','14:25:52',0,'2013-12-25 17:30:25',NULL,NULL),(871,177,'841248','834','00','005010X220A1','841248','','2013-12-02','19:19:01',0,'2013-12-25 18:16:20',NULL,NULL),(3527,616,'1123346','834','00','005010X220A1','1123346','','2013-12-11','18:55:02',0,'2013-12-25 22:02:03',NULL,NULL),(15043,2584,'1791376','834','00','005010X220A1','1791376','','2014-01-15','17:59:29',0,'2014-01-16 08:44:44',NULL,NULL),(11231,1454,'961418','834','00','005010X220A1','961418','','2013-12-26','11:15:44',0,'2013-12-27 02:01:23',NULL,NULL),(11593,1492,'2337985','834','00','005010X220A1','2337985','','2013-12-27','18:16:45',0,'2013-12-28 03:34:31',NULL,NULL),(16333,2983,'2232221','834','00','005010X220A1','2232221','','2014-01-22','22:26:30',0,'2014-01-23 21:00:37',NULL,NULL),(22643,4253,'3506650','834','00','005010X220A1','3506650','','2014-03-05','12:45:51',0,'2014-03-05 21:31:48',NULL,NULL),(10419,1400,'1004888','834','00','005010X220A1','1004888','','2013-12-23','10:15:48',0,'2013-12-26 12:51:18',NULL,NULL),(15342,2622,'1855382','834','00','005010X220A1','1855382','','2014-01-15','20:08:23',0,'2014-01-17 03:35:19',NULL,NULL),(15243,2598,'2386579','834','00','005010X220A1','2386579','','2014-01-15','09:39:35',0,'2014-01-16 08:46:52',NULL,NULL),(13886,2312,'2540127','834','00','005010X220A1','2540127','','2014-01-09','11:14:46',0,'2014-01-13 02:19:36',NULL,NULL),(1076,216,'292319','834','00','005010X220A1','292319','','2013-11-03','20:25:59',0,'2013-12-25 18:31:08',NULL,NULL),(16653,3060,'2549129','834','00','005010X220A1','2549129','','2014-01-27','13:16:56',0,'2014-01-27 21:00:13',NULL,NULL),(18929,3519,'2549464','834','00','005010X220A1','2549464','','2014-02-11','09:23:07',0,'2014-02-11 21:30:09',NULL,NULL),(19744,3673,'3324792','834','00','005010X220A1','3324792','','2014-02-15','11:56:15',0,'2014-02-15 22:00:39',NULL,NULL),(20687,3887,'2360048','834','00','005010X220A1','2360048','','2014-02-21','18:30:11',0,'2014-02-22 19:00:10',NULL,NULL),(20849,3911,'3446250','834','00','005010X220A1','3446250','','2014-02-25','14:22:59',0,'2014-02-25 21:31:30',NULL,NULL),(23229,4359,'2902813','834','00','005010X220A1','2902813','','2014-03-07','11:06:21',0,'2014-03-07 21:32:06',NULL,NULL),(186,16,'560798','834','00','005010X220A1','560798','','2013-12-05','11:39:41',0,'2013-12-25 17:20:46',NULL,NULL),(15225,2594,'1550128','834','00','005010X220A1','1550128','','2014-01-15','17:21:16',0,'2014-01-16 08:46:41',NULL,NULL),(14997,2584,'1852121','834','00','005010X220A1','1852121','','2014-01-14','19:49:46',0,'2014-01-16 08:44:15',NULL,NULL),(13852,2311,'2580831','834','00','005010X220A1','2580831','','2014-01-09','12:31:07',0,'2014-01-13 02:19:14',NULL,NULL),(12969,1734,'1858488','834','00','005010X220A1','1858488','','2014-01-04','12:50:50',0,'2014-01-05 00:01:04',NULL,NULL),(12647,1672,'1378044','834','00','005010X220A1','1378044','','2014-01-02','09:54:56',0,'2014-01-03 02:02:49',NULL,NULL),(11402,1465,'1785859','834','00','005010X220A1','1785859','','2013-12-26','12:43:12',0,'2013-12-27 02:06:37',NULL,NULL),(4279,742,'297372','834','00','005010X220A1','297372','','2013-12-19','16:46:32',0,'2013-12-25 23:08:41',NULL,NULL),(10754,1403,'1711224','834','00','005010X220A1','1711224','','2013-12-23','18:04:30',0,'2013-12-26 13:02:20',NULL,NULL),(6464,1221,'380639','834','00','005010X220A1','380639','','2013-11-22','13:03:37',0,'2013-12-26 03:16:35',NULL,NULL),(2069,340,'1225736','834','00','005010X220A1','1225736','','2013-12-09','15:54:35',0,'2013-12-25 19:37:04',NULL,NULL),(5098,940,'215190','834','00','005010X220A1','215190','','2013-12-11','12:38:08',0,'2013-12-26 00:49:06',NULL,NULL),(18052,3319,'2550657','834','00','005010X220A1','2550657','','2014-02-06','14:15:38',0,'2014-02-06 21:00:43',NULL,NULL),(429,78,'1227074','834','00','005010X220A1','1227074','','2013-12-04','11:39:43',0,'2013-12-25 17:49:20',NULL,NULL),(10522,1401,'1131483','834','00','005010X220A1','1131483','','2013-12-23','01:01:29',0,'2013-12-26 12:54:33',NULL,NULL),(12726,1682,'1635534','834','00','005010X220A1','1635534','','2014-01-01','18:47:43',0,'2014-01-03 02:05:48',NULL,NULL),(12085,1586,'835216','834','00','005010X220A1','835216','','2013-12-30','15:51:28',0,'2014-01-01 12:05:12',NULL,NULL),(11272,1455,'36073','834','00','005010X220A1','36073','','2013-12-26','12:17:16',0,'2013-12-27 02:02:39',NULL,NULL),(4533,824,'208048','834','00','005010X220A1','208048','','2013-12-23','22:34:03',0,'2013-12-25 23:45:07',NULL,NULL),(4513,812,'509854','834','00','005010X220A1','509854','','2013-11-26','11:36:29',0,'2013-12-25 23:32:28',NULL,NULL),(4813,867,'1257327','834','00','005010X220A1','1257327','','2013-11-30','20:22:39',0,'2013-12-26 00:02:14',NULL,NULL),(23234,4361,'3365985','834','00','005010X220A1','3365985','','2014-03-07','12:13:23',0,'2014-03-07 21:32:10',NULL,NULL),(23486,4428,'3694721','834','00','005010X220A1','3694721','','2014-03-09','12:25:22',0,'2014-03-09 21:30:00',NULL,NULL),(629,108,'1115518','834','00','005010X220A1','1115518','','2013-12-16','11:30:52',0,'2013-12-25 18:04:34',NULL,NULL),(1049,204,'1265131','834','00','005010X220A1','1265131','','2013-11-29','17:16:03',0,'2013-12-25 18:30:15',NULL,NULL),(5731,1069,'592255','834','00','005010X220A1','592255','','2013-12-14','16:10:14',0,'2013-12-26 02:01:19',NULL,NULL),(1854,324,'1102311','834','00','005010X220A1','1102311','','2013-12-09','10:03:16',0,'2013-12-25 19:30:21',NULL,NULL),(14211,2365,'1740555','834','00','005010X220A1','1740555','','2014-01-10','17:38:55',0,'2014-01-13 02:23:51',NULL,NULL),(14185,2365,'1755604','834','00','005010X220A1','1755604','','2014-01-09','21:59:24',0,'2014-01-13 02:23:32',NULL,NULL),(4694,833,'56511','834','00','005010X220A1','56511','','2013-12-24','01:27:27',0,'2013-12-25 23:50:26',NULL,NULL),(11813,1539,'1758665','834','00','005010X220A1','1758665','','2013-12-28','20:18:13',1,'2013-12-29 11:13:28',NULL,NULL),(16313,2980,'1369515','834','00','005010X220A1','1369515','','2014-01-23','15:30:12',0,'2014-01-23 21:00:23',NULL,NULL),(16458,3006,'2499227','834','00','005010X220A1','2499227','','2014-01-24','13:29:27',0,'2014-01-24 21:00:16',NULL,NULL),(18232,3360,'1933133','834','00','005010X220A1','1933133','','2014-02-07','17:27:42',0,'2014-02-07 19:00:58',NULL,NULL),(20199,3781,'2607115','834','00','005010X220A1','2607115','','2014-02-19','09:46:47',0,'2014-02-20 04:17:52',NULL,NULL),(10790,1404,'592710','834','00','005010X220A1','592710','','2013-12-23','12:26:21',0,'2013-12-26 13:03:32',NULL,NULL),(866,175,'36449','834','00','005010X220A1','36449','','2013-12-03','17:37:42',0,'2013-12-25 18:16:11',NULL,NULL),(13994,2329,'2000351','834','00','005010X220A1','2000351','','2014-01-09','16:02:45',0,'2014-01-13 02:20:53',NULL,NULL),(13350,2194,'0001','999','BE','005010X231A1','8664','834','2013-12-27','16:55:00',0,'2014-01-05 17:26:31',NULL,NULL),(17125,3143,'1499089','834','00','005010X220A1','1499089','','2014-01-30','14:50:08',0,'2014-01-30 21:00:21',NULL,NULL),(37,1,'320437','834','00','005010X220A1','320437','','2013-12-05','15:51:14',0,'2013-12-25 17:16:05',NULL,NULL),(14334,2400,'2256578','834','00','005010X220A1','2256578','','2014-01-12','14:10:16',0,'2014-01-13 03:01:14',NULL,NULL),(5991,1126,'128671','834','00','005010X220A1','128671','','2013-12-15','12:53:29',0,'2013-12-26 02:33:40',NULL,NULL),(10704,1403,'1291794','834','00','005010X220A1','1291794','','2013-12-23','10:49:17',0,'2013-12-26 13:00:40',NULL,NULL),(7057,1236,'721292','834','00','005010X220A1','721292','','2013-12-17','18:38:31',0,'2013-12-26 04:02:14',NULL,NULL),(10385,1400,'1217471','834','00','005010X220A1','1217471','','2013-12-22','22:25:38',0,'2013-12-26 12:50:15',NULL,NULL),(17234,3162,'2274196','834','00','005010X220A1','2274196','','2014-01-30','11:30:20',0,'2014-01-30 21:01:33',NULL,NULL),(22149,4179,'2860719','834','00','005010X220A1','2860719','','2014-03-03','14:51:54',0,'2014-03-03 21:30:54',NULL,NULL),(10453,1400,'1161405','834','00','005010X220A1','1161405','','2013-12-23','13:21:49',0,'2013-12-26 12:52:23',NULL,NULL),(5526,1041,'1440803','834','00','005010X220A1','1440803','','2013-12-24','22:20:51',0,'2013-12-26 01:47:14',NULL,NULL),(11456,1488,'1292034','834','00','005010X220A1','1292034','','2013-12-26','21:37:15',0,'2013-12-28 03:30:20',NULL,NULL),(14332,2400,'1682144','834','00','005010X220A1','1682144','','2014-01-12','12:30:35',0,'2014-01-13 03:01:12',NULL,NULL),(11683,1516,'2229027','834','00','005010X220A1','2229027','','2013-12-28','08:28:35',1,'2013-12-29 11:07:22',NULL,NULL),(12859,1706,'1499790','834','00','005010X220A1','1499790','','2014-01-03','09:15:41',0,'2014-01-04 02:03:24',NULL,NULL),(18089,3324,'1476404','834','00','005010X220A1','1476404','','2014-02-06','11:07:31',0,'2014-02-06 21:01:08',NULL,NULL),(20782,3907,'2611182','834','00','005010X220A1','2611182','','2014-02-25','15:44:26',0,'2014-02-25 21:30:42',NULL,NULL),(22757,4276,'2624466','834','00','005010X220A1','2624466','','2014-03-06','15:24:50',0,'2014-03-06 21:00:34',NULL,NULL),(23215,4348,'3138188','834','00','005010X220A1','3138188','','2014-03-06','20:49:47',0,'2014-03-07 21:31:56',NULL,NULL),(658,108,'75551','834','00','005010X220A1','75551','','2013-12-16','16:51:16',0,'2013-12-25 18:05:26',NULL,NULL),(15344,2622,'1471224','834','00','005010X220A1','1471224','','2014-01-15','20:27:23',0,'2014-01-17 03:35:20',NULL,NULL),(14561,2519,'1425295','834','00','005010X220A1','1425295','','2014-01-13','12:43:48',0,'2014-01-14 01:32:41',NULL,NULL),(7520,1300,'562677','834','00','005010X220A1','562677','','2013-12-21','12:33:36',0,'2013-12-26 04:34:41',NULL,NULL),(2073,341,'1203954','834','00','005010X220A1','1203954','','2013-12-09','13:05:01',0,'2013-12-25 19:37:10',NULL,NULL),(2647,501,'426603','834','00','005010X220A1','426603','','2013-12-21','21:51:19',0,'2013-12-25 21:15:18',NULL,NULL),(20891,3922,'2980383','834','00','005010X220A1','2980383','','2014-02-25','17:00:11',0,'2014-02-25 21:32:02',NULL,NULL),(112,6,'185710','834','00','005010X220A1','185710','','2013-12-05','15:58:58',0,'2013-12-25 17:18:25',NULL,NULL),(15294,2616,'2037015','834','00','005010X220A1','2037015','','2014-01-15','17:46:10',0,'2014-01-16 08:47:27',NULL,NULL),(7741,1343,'219934','834','00','005010X220A1','219934','','2013-10-20','18:38:57',0,'2013-12-26 05:00:33',NULL,NULL),(13134,1978,'0001','999','BE','005010X231A1','1187003','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:14',NULL,NULL),(5476,1040,'1944346','834','00','005010X220A1','1944346','','2013-12-24','22:38:01',0,'2013-12-26 01:45:37',NULL,NULL),(12486,1640,'1400862','834','00','005010X220A1','1400862','','2013-12-31','17:32:21',1,'2014-01-02 04:32:46',NULL,NULL),(3369,587,'980669','834','00','005010X220A1','980669','','2013-12-17','13:03:49',0,'2013-12-25 21:50:42',NULL,NULL),(4364,765,'567395','834','00','005010X220A1','567395','','2013-12-19','16:02:20',0,'2013-12-25 23:11:12',NULL,NULL),(11388,1463,'1577606','834','00','005010X220A1','1577606','','2013-12-26','15:28:30',0,'2013-12-27 02:06:10',NULL,NULL),(18262,3376,'1907972','834','00','005010X220A1','1907972','','2014-02-08','13:06:37',0,'2014-02-08 19:00:10',NULL,NULL),(20763,3906,'2740100','834','00','005010X220A1','2740100','','2014-02-25','01:03:34',0,'2014-02-25 21:30:29',NULL,NULL),(21166,3997,'3704463','834','00','005010X220A1','3704463','','2014-02-26','17:32:42',0,'2014-02-26 21:00:53',NULL,NULL),(11093,1424,'742526','834','00','005010X220A1','742526','','2013-12-23','08:45:24',0,'2013-12-26 13:13:52',NULL,NULL),(5686,1064,'1741277','834','00','005010X220A1','1741277','','2013-12-25','00:00:36',0,'2013-12-26 01:52:41',NULL,NULL),(4017,731,'116112','834','00','005010X220A1','116112','','2013-12-19','11:14:04',0,'2013-12-25 23:00:37',NULL,NULL),(3909,712,'560847','834','00','005010X220A1','560847','','2013-12-06','19:23:35',0,'2013-12-25 22:45:20',NULL,NULL),(2345,413,'917982','834','00','005010X220A1','917982','','2013-12-06','11:21:39',0,'2013-12-25 20:15:30',NULL,NULL),(2643,501,'234613','834','00','005010X220A1','234613','','2013-12-21','18:28:15',0,'2013-12-25 21:15:10',NULL,NULL),(12089,1586,'2319009','834','00','005010X220A1','2319009','','2013-12-30','17:30:49',0,'2014-01-01 12:05:21',NULL,NULL),(3264,580,'474232','834','00','005010X220A1','474232','','2013-12-16','18:46:57',0,'2013-12-25 21:47:17',NULL,NULL),(5425,1028,'832549','834','00','005010X220A1','832549','','2013-11-14','11:46:50',0,'2013-12-26 01:31:08',NULL,NULL),(4000,731,'590274','834','00','005010X220A1','590274','','2013-12-18','20:15:22',0,'2013-12-25 23:00:10',NULL,NULL),(2226,370,'139519','834','00','005010X220A1','139519','','2013-12-02','09:27:25',0,'2013-12-25 19:49:02',NULL,NULL),(14940,2561,'2600448','834','00','005010X220A1','2600448','','2014-01-14','15:22:45',0,'2014-01-15 02:07:47',NULL,NULL),(14920,2559,'1856402','834','00','005010X220A1','1856402','','2014-01-14','09:54:55',0,'2014-01-15 02:07:39',NULL,NULL),(14794,2551,'2294180','834','00','005010X220A1','2294180','','2014-01-14','16:57:33',0,'2014-01-15 02:06:42',NULL,NULL),(3378,587,'1117029','834','00','005010X220A1','1117029','','2013-12-17','16:03:35',0,'2013-12-25 21:51:01',NULL,NULL),(3848,684,'225073','834','00','005010X220A1','225073','','2013-11-08','08:36:11',0,'2013-12-25 22:30:33',NULL,NULL),(3874,695,'25410','834','00','005010X220A1','25410','','2013-10-04','13:26:06',0,'2013-12-25 22:31:20',NULL,NULL),(16508,3012,'1829404','834','00','005010X220A1','1829404','','2014-01-24','11:44:57',0,'2014-01-24 21:00:46',NULL,NULL),(16828,3091,'2319698','834','00','005010X220A1','2319698','','2014-01-28','09:35:17',0,'2014-01-28 21:00:25',NULL,NULL),(19270,3582,'1709927','834','00','005010X220A1','1709927','','2014-02-12','19:05:52',0,'2014-02-13 22:00:50',NULL,NULL),(22824,4278,'2680211','834','00','005010X220A1','2680211','','2014-03-06','14:21:52',0,'2014-03-06 21:01:20',NULL,NULL),(22959,4312,'2940787','834','00','005010X220A1','2940787','','2014-03-05','19:08:25',0,'2014-03-06 21:30:04',NULL,NULL),(64,3,'445994','834','00','005010X220A1','445994','','2013-12-05','14:18:36',0,'2013-12-25 17:16:56',NULL,NULL),(498,102,'259658','834','00','005010X220A1','259658','','2013-12-16','09:10:16',0,'2013-12-25 18:00:24',NULL,NULL),(12885,1707,'1379555','834','00','005010X220A1','1379555','','2014-01-02','19:50:56',0,'2014-01-04 02:04:20',NULL,NULL),(676,109,'378710','834','00','005010X220A1','378710','','2013-12-16','12:33:27',0,'2013-12-25 18:05:57',NULL,NULL),(12373,1636,'2079956','834','00','005010X220A1','2079956','','2013-12-30','18:45:13',1,'2014-01-02 04:28:42',NULL,NULL),(4629,827,'1182713','834','00','005010X220A1','1182713','','2013-12-23','23:13:38',0,'2013-12-25 23:48:13',NULL,NULL),(20979,3956,'3129188','834','00','005010X220A1','3129188','','2014-02-22','16:05:21',0,'2014-02-26 08:30:18',NULL,NULL),(22168,4180,'2822610','834','00','005010X220A1','2822610','','2014-03-03','13:04:39',0,'2014-03-03 21:31:08',NULL,NULL),(158,10,'692938','834','00','005010X220A1','692938','','2013-12-05','12:29:40',0,'2013-12-25 17:19:53',NULL,NULL),(16183,2875,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:04:00',1,'2014-01-23 04:25:12',NULL,NULL),(5102,940,'1080547','834','00','005010X220A1','1080547','','2013-12-11','13:38:22',0,'2013-12-26 00:49:13',NULL,NULL),(15383,2624,'1496450','834','00','005010X220A1','1496450','','2014-01-16','16:53:38',0,'2014-01-17 03:35:39',NULL,NULL),(15092,2585,'1508720','834','00','005010X220A1','1508720','','2014-01-15','17:12:50',0,'2014-01-16 08:45:14',NULL,NULL),(2186,363,'558132','834','00','005010X220A1','558132','','2013-12-02','15:48:51',0,'2013-12-25 19:47:40',NULL,NULL),(12241,1618,'1706192','834','00','005010X220A1','1706192','','2014-01-01','17:31:22',1,'2014-01-02 04:23:04',NULL,NULL),(4657,829,'1489634','834','00','005010X220A1','1489634','','2013-12-24','01:07:03',0,'2013-12-25 23:49:10',NULL,NULL),(2972,541,'348984','834','00','005010X220A1','348984','','2013-12-13','14:59:19',0,'2013-12-25 21:32:16',NULL,NULL),(20737,3903,'3022334','834','00','005010X220A1','3022334','','2014-02-24','22:17:14',0,'2014-02-25 21:30:08',NULL,NULL),(21125,3994,'3402079','834','00','005010X220A1','3402079','','2014-02-26','16:29:33',0,'2014-02-26 21:00:26',NULL,NULL),(22364,4205,'3047271','834','00','005010X220A1','3047271','','2014-03-04','14:34:24',0,'2014-03-04 21:01:49',NULL,NULL),(356,72,'856369','834','00','005010X220A1','856369','','2013-12-04','08:06:25',0,'2013-12-25 17:46:58',NULL,NULL),(509,102,'930050','834','00','005010X220A1','930050','','2013-12-16','11:18:26',0,'2013-12-25 18:00:44',NULL,NULL),(16125,2817,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:47:40',NULL,NULL),(2291,395,'60299','834','00','005010X220A1','60299','','2013-11-24','17:25:44',0,'2013-12-25 20:00:51',NULL,NULL),(7444,1296,'1203185','834','00','005010X220A1','1203185','','2013-12-20','19:57:08',0,'2013-12-26 04:32:15',NULL,NULL),(11722,1520,'1187924','834','00','005010X220A1','1187924','','2013-12-28','12:08:04',1,'2013-12-29 11:08:35',NULL,NULL),(17196,3149,'1485798','834','00','005010X220A1','1485798','','2014-01-30','12:26:38',0,'2014-01-30 21:01:06',NULL,NULL),(17432,3204,'2500621','834','00','005010X220A1','2500621','','2014-02-01','12:07:55',0,'2014-02-01 19:00:30',NULL,NULL),(17520,3235,'2462233','834','00','005010X220A1','2462233','','2014-02-02','18:47:27',0,'2014-02-03 21:00:08',NULL,NULL),(18484,3432,'1918349','834','00','005010X220A1','1918349','','2014-02-10','04:13:49',0,'2014-02-10 11:01:02',NULL,NULL),(19316,3583,'2608343','834','00','005010X220A1','2608343','','2014-02-13','09:41:22',0,'2014-02-13 22:01:26',NULL,NULL),(19652,3649,'2198430','834','00','005010X220A1','2198430','','2014-02-14','08:08:19',0,'2014-02-14 21:32:16',NULL,NULL),(22549,4248,'3531228','834','00','005010X220A1','3531228','','2014-03-05','09:52:42',0,'2014-03-05 21:30:43',NULL,NULL),(23349,4388,'3757744','834','00','005010X220A1','3757744','','2014-03-07','21:36:18',0,'2014-03-08 21:30:57',NULL,NULL),(168,14,'1022399','834','00','005010X220A1','1022399','','2013-12-05','11:36:51',0,'2013-12-25 17:20:13',NULL,NULL),(1746,293,'775317','834','00','005010X220A1','775317','','2013-12-10','14:49:21',0,'2013-12-25 19:17:51',NULL,NULL),(15427,2629,'1359731','834','00','005010X220A1','1359731','','2014-01-16','13:44:31',0,'2014-01-17 03:36:00',NULL,NULL),(15145,2588,'1759317','834','00','005010X220A1','1759317','','2014-01-14','23:48:29',0,'2014-01-16 08:45:51',NULL,NULL),(3018,543,'1172342','834','00','005010X220A1','1172342','','2013-12-13','15:04:37',0,'2013-12-25 21:33:40',NULL,NULL),(14832,2553,'1664198','834','00','005010X220A1','1664198','','2014-01-13','20:38:35',0,'2014-01-15 02:06:58',NULL,NULL),(18230,3360,'2930751','834','00','005010X220A1','2930751','','2014-02-06','21:47:28',0,'2014-02-07 19:00:57',NULL,NULL),(21637,4070,'2908324','834','00','005010X220A1','2908324','','2014-02-27','11:37:54',0,'2014-02-28 07:30:30',NULL,NULL),(22014,4150,'2994566','834','00','005010X220A1','2994566','','2014-03-02','15:45:37',0,'2014-03-03 01:00:32',NULL,NULL),(11717,1519,'1513191','834','00','005010X220A1','1513191','','2013-12-27','18:58:40',1,'2013-12-29 11:08:25',NULL,NULL),(15002,2584,'2120397','834','00','005010X220A1','2120397','','2014-01-14','21:58:23',0,'2014-01-16 08:44:18',NULL,NULL),(560,103,'145107','834','00','005010X220A1','145107','','2013-12-16','10:56:30',0,'2013-12-25 18:02:23',NULL,NULL),(11455,1488,'1528940','834','00','005010X220A1','1528940','','2013-12-26','21:00:54',0,'2013-12-28 03:30:18',NULL,NULL),(1569,276,'226590','834','00','005010X220A1','226590','','2013-11-20','12:49:20',0,'2013-12-25 19:00:13',NULL,NULL),(3910,712,'747673','834','00','005010X220A1','747673','','2013-12-06','19:29:41',0,'2013-12-25 22:45:21',NULL,NULL),(1983,327,'173275','834','00','005010X220A1','173275','','2013-12-09','11:56:42',0,'2013-12-25 19:34:16',NULL,NULL),(5205,949,'990070','834','00','005010X220A1','990070','','2013-12-11','14:04:26',0,'2013-12-26 00:52:31',NULL,NULL),(7458,1296,'806249','834','00','005010X220A1','806249','','2013-12-21','00:51:08',0,'2013-12-26 04:32:36',NULL,NULL),(17612,3242,'1368266','834','00','005010X220A1','1368266','','2014-02-03','09:11:59',0,'2014-02-03 21:01:06',NULL,NULL),(19422,3598,'3228377','834','00','005010X220A1','3228377','','2014-02-13','09:56:57',0,'2014-02-13 22:02:46',NULL,NULL),(20520,3849,'3256562','834','00','005010X220A1','3256562','','2014-02-20','10:11:27',0,'2014-02-20 22:01:20',NULL,NULL),(593,107,'693240','834','00','005010X220A1','693240','','2013-12-15','18:55:50',0,'2013-12-25 18:03:22',NULL,NULL),(3820,669,'553426','834','00','005010X220A1','553426','','2013-12-08','11:18:02',0,'2013-12-25 22:17:03',NULL,NULL),(6388,1186,'558761','834','00','005010X220A1','558761','','2013-12-20','13:07:47',0,'2013-12-26 03:10:06',NULL,NULL),(13702,2274,'1371694','834','00','005010X220A1','1371694','','2014-01-07','13:51:07',0,'2014-01-08 18:24:30',NULL,NULL),(10939,1410,'837871','834','00','005010X220A1','837871','','2013-12-23','14:01:00',0,'2013-12-26 13:08:54',NULL,NULL),(20865,3914,'3728215','834','00','005010X220A1','3728215','','2014-02-24','18:46:28',0,'2014-02-25 21:31:42',NULL,NULL),(20897,3925,'2922845','834','00','005010X220A1','2922845','','2014-02-25','17:17:34',0,'2014-02-25 21:32:06',NULL,NULL),(22791,4277,'3132207','834','00','005010X220A1','3132207','','2014-03-06','16:14:08',0,'2014-03-06 21:00:58',NULL,NULL),(23086,4339,'3865207','834','00','005010X220A1','3865207','','2014-03-07','13:41:06',0,'2014-03-07 21:30:25',NULL,NULL),(1256,243,'657559','834','00','005010X220A1','657559','','2013-12-24','12:33:15',0,'2013-12-25 18:49:23',NULL,NULL),(11782,1536,'1388177','834','00','005010X220A1','1388177','','2013-12-28','17:56:20',1,'2013-12-29 11:10:27',NULL,NULL),(17789,3269,'1806497','834','00','005010X220A1','1806497','','2014-02-04','11:57:42',0,'2014-02-04 21:01:25',NULL,NULL),(19940,3736,'2402634','834','00','005010X220A1','2402634','','2014-02-18','10:03:58',0,'2014-02-18 21:30:11',NULL,NULL),(22118,4177,'3281908','834','00','005010X220A1','3281908','','2014-03-03','13:12:01',0,'2014-03-03 21:30:33',NULL,NULL),(306,70,'105567','834','00','005010X220A1','105567','','2013-12-04','15:08:24',0,'2013-12-25 17:45:23',NULL,NULL),(14880,2557,'1907395','834','00','005010X220A1','1907395','','2014-01-14','16:43:04',0,'2014-01-15 02:07:20',NULL,NULL),(13840,2309,'1395883','834','00','005010X220A1','1395883','','2014-01-11','14:41:55',0,'2014-01-13 02:18:42',NULL,NULL),(5308,989,'667958','834','00','005010X220A1','667958','','2013-11-04','20:06:41',0,'2013-12-26 01:01:43',NULL,NULL),(1368,245,'1896133','834','00','005010X220A1','1896133','','2013-12-24','15:21:54',0,'2013-12-25 18:53:00',NULL,NULL),(10591,1402,'1231598','834','00','005010X220A1','1231598','','2013-12-23','12:24:20',0,'2013-12-26 12:56:51',NULL,NULL),(1480,253,'1479088','834','00','005010X220A1','1479088','','2013-12-24','10:28:37',0,'2013-12-25 18:56:46',NULL,NULL),(20496,3845,'2772897','834','00','005010X220A1','2772897','','2014-02-20','15:05:03',0,'2014-02-20 22:01:00',NULL,NULL),(23637,4441,'3208413','834','00','005010X220A1','3208413','','2014-03-10','13:40:17',0,'2014-03-10 21:01:42',NULL,NULL),(4192,734,'623348','834','00','005010X220A1','623348','','2013-12-19','16:47:41',0,'2013-12-25 23:06:00',NULL,NULL),(14749,2550,'1355558','834','00','005010X220A1','1355558','','2014-01-14','18:20:21',0,'2014-01-15 02:06:23',NULL,NULL),(16989,3118,'2637035','834','00','005010X220A1','2637035','','2014-01-29','07:38:15',0,'2014-01-29 21:00:47',NULL,NULL),(18032,3319,'1724286','834','00','005010X220A1','1724286','','2014-02-06','06:05:55',0,'2014-02-06 21:00:30',NULL,NULL),(20158,3778,'2831612','834','00','005010X220A1','2831612','','2014-02-18','20:44:08',0,'2014-02-20 04:05:44',NULL,NULL),(20378,3824,'3582926','834','00','005010X220A1','3582926','','2014-02-19','10:20:11',0,'2014-02-20 05:35:48',NULL,NULL),(20937,3943,'3716040','834','00','005010X220A1','3716040','','2014-02-23','14:28:06',0,'2014-02-26 08:00:31',NULL,NULL),(22298,4201,'3145427','834','00','005010X220A1','3145427','','2014-03-04','10:13:23',0,'2014-03-04 21:00:57',NULL,NULL),(22470,4238,'2649859','834','00','005010X220A1','2649859','','2014-03-05','16:38:18',0,'2014-03-05 21:00:16',NULL,NULL),(7023,1235,'934029','834','00','005010X220A1','934029','','2013-12-18','10:49:35',0,'2013-12-26 04:01:12',NULL,NULL),(834,173,'398028','834','00','005010X220A1','398028','','2013-12-02','23:44:14',0,'2013-12-25 18:15:09',NULL,NULL),(13835,2305,'2436226','834','00','005010X220A1','2436226','','2014-01-11','12:11:11',0,'2014-01-13 02:18:38',NULL,NULL),(3396,588,'753904','834','00','005010X220A1','753904','','2013-12-17','13:14:58',0,'2013-12-25 21:51:32',NULL,NULL),(3532,616,'121164','834','00','005010X220A1','121164','','2013-12-12','00:09:02',0,'2013-12-25 22:02:13',NULL,NULL),(5618,1044,'2019812','834','00','005010X220A1','2019812','','2013-12-25','00:46:42',0,'2013-12-26 01:50:17',NULL,NULL),(18739,3485,'1738502','834','00','005010X220A1','1738502','','2014-02-11','12:02:38',0,'2014-02-11 21:00:29',NULL,NULL),(19078,3542,'2582897','834','00','005010X220A1','2582897','','2014-02-12','12:21:23',0,'2014-02-12 21:31:23',NULL,NULL),(19830,3680,'3230962','834','00','005010X220A1','3230962','','2014-02-15','15:16:21',0,'2014-02-15 22:01:47',NULL,NULL),(21110,3994,'3670945','834','00','005010X220A1','3670945','','2014-02-26','11:32:34',0,'2014-02-26 21:00:16',NULL,NULL),(23512,4434,'3178455','834','00','005010X220A1','3178455','','2014-03-10','13:56:34',0,'2014-03-10 21:00:12',NULL,NULL),(62,3,'150189','834','00','005010X220A1','150189','','2013-12-05','11:24:27',0,'2013-12-25 17:16:51',NULL,NULL),(5775,1073,'1137063','834','00','005010X220A1','1137063','','2013-12-13','19:52:21',0,'2013-12-26 02:02:42',NULL,NULL),(14460,2481,'0001','999','BE','005010X231A1','796564','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:33',NULL,NULL),(5694,1067,'849803','834','00','005010X220A1','849803','','2013-12-14','10:33:31',0,'2013-12-26 02:00:12',NULL,NULL),(12149,1591,'1645122','834','00','005010X220A1','1645122','','2013-12-30','11:13:00',0,'2014-01-01 12:07:23',NULL,NULL),(17722,3261,'2343370','834','00','005010X220A1','2343370','','2014-02-04','14:35:58',0,'2014-02-04 21:00:42',NULL,NULL),(17732,3261,'2797315','834','00','005010X220A1','2797315','','2014-02-04','17:43:55',0,'2014-02-04 21:00:49',NULL,NULL),(17841,3287,'2247764','834','00','005010X220A1','2247764','','2014-02-05','12:55:40',0,'2014-02-05 21:00:04',NULL,NULL),(20506,3847,'2669511','834','00','005010X220A1','2669511','','2014-02-20','08:38:01',0,'2014-02-20 22:01:08',NULL,NULL),(5507,1041,'1869590','834','00','005010X220A1','1869590','','2013-12-24','20:15:43',0,'2013-12-26 01:46:39',NULL,NULL),(5395,1017,'525390','834','00','005010X220A1','525390','','2013-11-25','10:09:15',0,'2013-12-26 01:17:23',NULL,NULL),(1400,247,'50159','834','00','005010X220A1','50159','','2013-12-24','08:54:41',0,'2013-12-25 18:54:03',NULL,NULL),(14520,2518,'1812522','834','00','005010X220A1','1812522','','2014-01-12','19:20:08',0,'2014-01-14 01:32:15',NULL,NULL),(4764,859,'915213','834','00','005010X220A1','915213','','2013-12-01','12:12:47',0,'2013-12-26 00:00:47',NULL,NULL),(12240,1618,'1427456','834','00','005010X220A1','1427456','','2014-01-01','15:59:38',1,'2014-01-02 04:23:02',NULL,NULL),(4675,831,'1354941','834','00','005010X220A1','1354941','','2013-12-23','23:36:58',0,'2013-12-25 23:49:46',NULL,NULL),(10966,1410,'682906','834','00','005010X220A1','682906','','2013-12-23','18:56:30',0,'2013-12-26 13:09:36',NULL,NULL),(4277,742,'335743','834','00','005010X220A1','335743','','2013-12-19','16:41:36',0,'2013-12-25 23:08:37',NULL,NULL),(16756,3068,'2443121','834','00','005010X220A1','2443121','','2014-01-26','23:46:52',0,'2014-01-27 21:01:22',NULL,NULL),(17022,3120,'2213217','834','00','005010X220A1','2213217','','2014-01-29','09:43:56',0,'2014-01-29 21:01:08',NULL,NULL),(18389,3408,'2439282','834','00','005010X220A1','2439282','','2014-02-09','14:24:32',0,'2014-02-09 19:00:27',NULL,NULL),(19004,3538,'2605779','834','00','005010X220A1','2605779','','2014-02-12','16:56:53',0,'2014-02-12 21:30:28',NULL,NULL),(19070,3542,'2157923','834','00','005010X220A1','2157923','','2014-02-12','17:00:02',0,'2014-02-12 21:31:16',NULL,NULL),(23556,4436,'3636008','834','00','005010X220A1','3636008','','2014-03-09','20:54:30',0,'2014-03-10 21:00:45',NULL,NULL),(500,102,'1167368','834','00','005010X220A1','1167368','','2013-12-16','09:18:51',0,'2013-12-25 18:00:27',NULL,NULL),(7353,1283,'406388','834','00','005010X220A1','406388','','2013-11-30','11:19:14',0,'2013-12-26 04:15:34',NULL,NULL),(14268,2375,'2316531','834','00','005010X220A1','2316531','','2014-01-10','11:57:25',0,'2014-01-13 03:00:09',NULL,NULL),(13147,1991,'0001','999','BE','005010X231A1','237598','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:24',NULL,NULL),(12007,1583,'2421306','834','00','005010X220A1','2421306','','2013-12-29','21:46:06',0,'2014-01-01 12:02:21',NULL,NULL),(11854,1551,'1630386','834','00','005010X220A1','1630386','','2013-12-28','20:15:49',1,'2013-12-29 11:14:57',NULL,NULL),(11759,1523,'1533199','834','00','005010X220A1','1533199','','2013-12-28','13:57:27',1,'2013-12-29 11:09:41',NULL,NULL),(11512,1490,'2143962','834','00','005010X220A1','2143962','','2013-12-27','09:21:03',0,'2013-12-28 03:32:00',NULL,NULL),(11487,1488,'1376466','834','00','005010X220A1','1376466','','2013-12-27','17:46:58',0,'2013-12-28 03:31:16',NULL,NULL),(3351,587,'432895','834','00','005010X220A1','432895','','2013-12-17','07:59:08',0,'2013-12-25 21:50:12',NULL,NULL),(5659,1052,'1729033','834','00','005010X220A1','1729033','','2013-12-24','19:33:05',0,'2013-12-26 01:51:37',NULL,NULL),(20578,3867,'3601693','834','00','005010X220A1','3601693','','2014-02-20','20:30:02',0,'2014-02-21 21:30:22',NULL,NULL),(21775,4091,'3010272','834','00','005010X220A1','3010272','','2014-02-27','18:36:31',0,'2014-02-28 21:31:03',NULL,NULL),(22153,4179,'2659758','834','00','005010X220A1','2659758','','2014-03-03','16:50:54',0,'2014-03-03 21:30:57',NULL,NULL),(23357,4390,'3451732','834','00','005010X220A1','3451732','','2014-03-07','22:20:24',0,'2014-03-08 21:31:04',NULL,NULL),(23408,4404,'3803001','834','00','005010X220A1','3803001','','2014-03-09','00:02:33',0,'2014-03-09 21:00:17',NULL,NULL),(6075,1164,'1015544','834','00','005010X220A1','1015544','','2013-12-20','18:10:58',0,'2013-12-26 03:00:30',NULL,NULL),(1827,312,'456398','834','00','005010X220A1','456398','','2013-12-10','17:22:11',0,'2013-12-25 19:20:26',NULL,NULL),(14330,2400,'1903816','834','00','005010X220A1','1903816','','2014-01-12','12:24:37',0,'2014-01-13 03:01:11',NULL,NULL),(2121,360,'983967','834','00','005010X220A1','983967','','2013-12-02','11:09:26',0,'2013-12-25 19:45:33',NULL,NULL),(12923,1716,'2308878','834','00','005010X220A1','2308878','','2014-01-03','13:07:41',0,'2014-01-04 02:05:45',NULL,NULL),(2454,422,'8655','834','00','005010X220A1','8655','','2013-12-06','17:18:35',0,'2013-12-25 20:18:59',NULL,NULL),(16786,3083,'2658821','834','00','005010X220A1','2658821','','2014-01-27','14:36:52',0,'2014-01-27 21:01:47',NULL,NULL),(16857,3093,'2022103','834','00','005010X220A1','2022103','','2014-01-28','10:30:04',0,'2014-01-28 21:00:45',NULL,NULL),(17138,3144,'1650776','834','00','005010X220A1','1650776','','2014-01-30','06:10:40',0,'2014-01-30 21:00:29',NULL,NULL),(17242,3167,'1891864','834','00','005010X220A1','1891864','','2014-01-30','15:11:30',0,'2014-01-30 21:01:38',NULL,NULL),(20425,3839,'2851564','834','00','005010X220A1','2851564','','2014-02-20','17:28:09',0,'2014-02-20 21:30:23',NULL,NULL),(20987,3958,'3294248','834','00','005010X220A1','3294248','','2014-02-21','18:21:57',0,'2014-02-26 08:30:26',NULL,NULL),(21061,3979,'3768035','834','00','005010X220A1','3768035','','2014-02-24','15:43:39',0,'2014-02-26 09:30:35',NULL,NULL),(21157,3997,'3813929','834','00','005010X220A1','3813929','','2014-02-26','14:22:23',0,'2014-02-26 21:00:47',NULL,NULL),(1117,238,'1903319','834','00','005010X220A1','1903319','','2013-12-24','12:20:10',0,'2013-12-25 18:45:11',NULL,NULL),(10463,1400,'1274457','834','00','005010X220A1','1274457','','2013-12-23','14:01:36',0,'2013-12-26 12:52:41',NULL,NULL),(2785,506,'85031','834','00','005010X220A1','85031','','2013-12-22','07:48:45',0,'2013-12-25 21:19:51',NULL,NULL),(2791,506,'652071','834','00','005010X220A1','652071','','2013-12-22','10:56:06',0,'2013-12-25 21:20:04',NULL,NULL),(14889,2558,'1598784','834','00','005010X220A1','1598784','','2014-01-14','10:32:52',0,'2014-01-15 02:07:26',NULL,NULL),(3782,656,'1191766','834','00','005010X220A1','1191766','','2013-12-08','11:41:07',0,'2013-12-25 22:15:43',NULL,NULL),(11148,1434,'1411840','834','00','005010X220A1','1411840','','2013-12-23','09:42:57',0,'2013-12-26 13:15:50',NULL,NULL),(17170,3145,'1877188','834','00','005010X220A1','1877188','','2014-01-30','17:37:15',0,'2014-01-30 21:00:50',NULL,NULL),(21646,4073,'3178056','834','00','005010X220A1','3178056','','2014-02-27','13:25:35',0,'2014-02-28 07:30:36',NULL,NULL),(1092,221,'996410','834','00','005010X220A1','996410','','2013-11-04','07:32:48',0,'2013-12-25 18:31:43',NULL,NULL),(14844,2553,'2537341','834','00','005010X220A1','2537341','','2014-01-14','11:33:33',0,'2014-01-15 02:07:03',NULL,NULL),(13574,2254,'1751615','834','00','005010X220A1','1751615','','2014-01-05','17:28:14',1,'2014-01-07 10:21:47',NULL,NULL),(17344,3181,'1754684','834','00','005010X220A1','1754684','','2014-01-31','09:14:26',0,'2014-01-31 21:01:13',NULL,NULL),(22033,4163,'3661098','834','00','005010X220A1','3661098','','2014-03-03','07:44:51',0,'2014-03-03 21:00:00',NULL,NULL),(1863,324,'1271176','834','00','005010X220A1','1271176','','2013-12-09','13:45:46',0,'2013-12-25 19:30:38',NULL,NULL),(14954,2565,'2486480','834','00','005010X220A1','2486480','','2014-01-14','11:33:43',0,'2014-01-15 02:07:54',NULL,NULL),(3147,556,'519914','834','00','005010X220A1','519914','','2013-12-13','13:39:43',0,'2013-12-25 21:37:39',NULL,NULL),(13547,2242,'2235513','834','00','005010X220A1','2235513','','2014-01-06','13:10:07',0,'2014-01-07 04:06:19',NULL,NULL),(16711,3064,'2443126','834','00','005010X220A1','2443126','','2014-01-27','11:27:28',0,'2014-01-27 21:00:50',NULL,NULL),(20077,3761,'3316959','834','00','005010X220A1','3316959','','2014-02-18','11:20:53',0,'2014-02-18 22:01:29',NULL,NULL),(20157,3777,'3351296','834','00','005010X220A1','3351296','','2014-02-18','20:59:48',0,'2014-02-20 04:05:42',NULL,NULL),(21806,4092,'3653135','834','00','005010X220A1','3653135','','2014-02-28','17:31:51',0,'2014-02-28 21:31:25',NULL,NULL),(4200,735,'145260','834','00','005010X220A1','145260','','2013-12-18','22:03:23',0,'2013-12-25 23:06:15',NULL,NULL),(15844,2738,'2599204','834','00','005010X220A1','2599204','','2014-01-20','22:03:18',1,'2014-01-22 03:22:05',NULL,NULL),(12194,1607,'2481187','834','00','005010X220A1','2481187','','2013-12-30','12:28:51',0,'2014-01-01 12:09:07',NULL,NULL),(11349,1457,'2024664','834','00','005010X220A1','2024664','','2013-12-25','20:06:36',0,'2013-12-27 02:04:59',NULL,NULL),(2609,485,'600614','834','00','005010X220A1','600614','','2013-10-06','12:09:12',0,'2013-12-25 20:46:15',NULL,NULL),(17074,3131,'1959504','834','00','005010X220A1','1959504','','2014-01-29','11:07:01',0,'2014-01-29 21:01:42',NULL,NULL),(17277,3170,'1753372','834','00','005010X220A1','1753372','','2014-01-31','16:33:26',0,'2014-01-31 21:00:26',NULL,NULL),(17796,3270,'2179920','834','00','005010X220A1','2179920','','2014-02-04','13:08:44',0,'2014-02-04 21:01:30',NULL,NULL),(19103,3543,'2356088','834','00','005010X220A1','2356088','','2014-02-12','14:32:10',0,'2014-02-12 21:31:39',NULL,NULL),(81,4,'251341','834','00','005010X220A1','251341','','2013-12-04','20:42:35',0,'2013-12-25 17:17:26',NULL,NULL),(7660,1316,'1232896','834','00','005010X220A1','1232896','','2013-12-21','07:29:31',0,'2013-12-26 04:39:09',NULL,NULL),(7488,1298,'1265914','834','00','005010X220A1','1265914','','2013-12-21','17:42:36',0,'2013-12-26 04:33:37',NULL,NULL),(5232,955,'385829','834','00','005010X220A1','385829','','2013-12-11','15:20:52',0,'2013-12-26 00:53:27',NULL,NULL),(11479,1488,'1496925','834','00','005010X220A1','1496925','','2013-12-27','15:06:47',0,'2013-12-28 03:31:01',NULL,NULL),(18918,3515,'2102399','834','00','005010X220A1','2102399','','2014-02-11','16:07:56',0,'2014-02-11 21:02:52',NULL,NULL),(20377,3824,'2679759','834','00','005010X220A1','2679759','','2014-02-19','10:20:11',0,'2014-02-20 05:35:34',NULL,NULL),(23,1,'638619','834','00','005010X220A1','638619','','2013-12-05','14:03:03',0,'2013-12-25 17:15:42',NULL,NULL),(16479,3009,'2570117','834','00','005010X220A1','2570117','','2014-01-24','11:19:33',0,'2014-01-24 21:00:29',NULL,NULL),(16344,2983,'2242929','834','00','005010X220A1','2242929','','2014-01-23','11:59:01',0,'2014-01-23 21:00:44',NULL,NULL),(190,16,'430311','834','00','005010X220A1','430311','','2013-12-05','14:42:18',0,'2013-12-25 17:20:54',NULL,NULL),(3980,719,'351426','834','00','005010X220A1','351426','','2013-12-07','14:46:03',0,'2013-12-25 22:47:33',NULL,NULL),(12356,1634,'2446171','834','00','005010X220A1','2446171','','2013-12-31','14:18:14',1,'2014-01-02 04:28:04',NULL,NULL),(12351,1634,'1461930','834','00','005010X220A1','1461930','','2013-12-31','13:41:44',1,'2014-01-02 04:27:55',NULL,NULL),(2100,356,'751560','834','00','005010X220A1','751560','','2013-12-09','17:19:02',0,'2013-12-25 19:38:03',NULL,NULL),(17307,3173,'2283741','834','00','005010X220A1','2283741','','2014-01-31','13:31:32',0,'2014-01-31 21:00:45',NULL,NULL),(21076,3980,'3760181','834','00','005010X220A1','3760181','','2014-02-24','16:41:35',0,'2014-02-26 09:30:46',NULL,NULL),(10470,1400,'85149','834','00','005010X220A1','85149','','2013-12-23','14:25:08',0,'2013-12-26 12:52:56',NULL,NULL),(15964,2764,'1641944','834','00','005010X220A1','1641944','','2014-01-21','23:18:05',0,'2014-01-23 03:01:56',NULL,NULL),(7093,1236,'1187314','834','00','005010X220A1','1187314','','2013-12-18','11:01:39',0,'2013-12-26 04:03:24',NULL,NULL),(12502,1642,'2143028','834','00','005010X220A1','2143028','','2013-12-31','12:39:43',1,'2014-01-02 04:33:27',NULL,NULL),(11606,1493,'2160929','834','00','005010X220A1','2160929','','2013-12-27','15:03:14',0,'2013-12-28 03:34:54',NULL,NULL),(4530,823,'165438','834','00','005010X220A1','165438','','2013-11-26','15:23:05',0,'2013-12-25 23:33:06',NULL,NULL),(4911,908,'509633','834','00','005010X220A1','509633','','2013-10-23','15:41:18',0,'2013-12-26 00:30:31',NULL,NULL),(5664,1053,'827405','834','00','005010X220A1','827405','','2013-12-24','19:50:28',0,'2013-12-26 01:51:48',NULL,NULL),(20623,3871,'3192942','834','00','005010X220A1','3192942','','2014-02-21','13:26:03',0,'2014-02-21 22:00:33',NULL,NULL),(242,42,'1078779','834','00','005010X220A1','1078779','','2013-11-13','07:58:40',0,'2013-12-25 17:30:36',NULL,NULL),(3564,617,'733583','834','00','005010X220A1','733583','','2013-12-11','20:19:40',0,'2013-12-25 22:03:15',NULL,NULL),(15419,2629,'1998352','834','00','005010X220A1','1998352','','2014-01-16','09:05:57',0,'2014-01-17 03:35:56',NULL,NULL),(15038,2584,'2306757','834','00','005010X220A1','2306757','','2014-01-15','17:30:07',0,'2014-01-16 08:44:42',NULL,NULL),(14851,2553,'1768288','834','00','005010X220A1','1768288','','2014-01-14','14:03:52',0,'2014-01-15 02:07:07',NULL,NULL),(11655,1500,'1446166','834','00','005010X220A1','1446166','','2013-12-27','11:42:17',0,'2013-12-28 03:36:25',NULL,NULL),(17248,3170,'1399173','834','00','005010X220A1','1399173','','2014-01-30','18:44:58',0,'2014-01-31 21:00:05',NULL,NULL),(23209,4347,'3047401','834','00','005010X220A1','3047401','','2014-03-07','12:39:39',0,'2014-03-07 21:31:52',NULL,NULL),(1065,211,'90844','834','00','005010X220A1','90844','','2013-11-29','14:20:02',0,'2013-12-25 18:30:46',NULL,NULL),(2586,475,'876811','834','00','005010X220A1','876811','','2013-11-01','14:01:01',0,'2013-12-25 20:45:32',NULL,NULL),(15307,2622,'1993549','834','00','005010X220A1','1993549','','2014-01-15','22:25:59',0,'2014-01-17 03:35:04',NULL,NULL),(14700,2550,'1372905','834','00','005010X220A1','1372905','','2014-01-13','19:32:38',0,'2014-01-15 02:06:01',NULL,NULL),(3196,578,'702117','834','00','005010X220A1','702117','','2013-12-16','19:37:59',0,'2013-12-25 21:45:12',NULL,NULL),(14095,2342,'1680589','834','00','005010X220A1','1680589','','2014-01-07','18:44:16',0,'2014-01-13 02:22:07',NULL,NULL),(13674,2272,'1778438','834','00','005010X220A1','1778438','','2014-01-06','18:30:00',0,'2014-01-08 18:24:19',NULL,NULL),(5852,1095,'1303530','834','00','005010X220A1','1303530','','2013-11-23','17:23:10',0,'2013-12-26 02:16:12',NULL,NULL),(12850,1705,'2483780','834','00','005010X220A1','2483780','','2014-01-03','18:09:54',0,'2014-01-04 02:03:03',NULL,NULL),(12381,1637,'1930893','834','00','005010X220A1','1930893','','2013-12-30','20:26:49',1,'2014-01-02 04:29:01',NULL,NULL),(4967,932,'803727','834','00','005010X220A1','803727','','2013-10-07','18:22:59',0,'2013-12-26 00:32:21',NULL,NULL),(17467,3216,'2811192','834','00','005010X220A1','2811192','','2014-02-01','22:16:23',0,'2014-02-02 19:00:04',NULL,NULL),(20207,3782,'3511201','834','00','005010X220A1','3511201','','2014-02-19','11:21:20',0,'2014-02-20 04:19:37',NULL,NULL),(20564,3864,'3507623','834','00','005010X220A1','3507623','','2014-02-21','15:31:08',0,'2014-02-21 21:30:12',NULL,NULL),(23282,4380,'2797094','834','00','005010X220A1','2797094','','2014-03-08','10:01:49',0,'2014-03-08 21:30:06',NULL,NULL),(13430,2222,'2072630','834','00','005010X220A1','2072630','','2014-01-06','17:18:16',0,'2014-01-07 04:01:56',NULL,NULL),(14819,2552,'1937471','834','00','005010X220A1','1937471','','2014-01-14','15:52:11',0,'2014-01-15 02:06:53',NULL,NULL),(19557,3626,'3183726','834','00','005010X220A1','3183726','','2014-02-14','11:21:29',0,'2014-02-14 21:31:06',NULL,NULL),(20345,3807,'3553115','834','00','005010X220A1','3553115','','2014-02-19','09:35:47',0,'2014-02-20 04:53:43',NULL,NULL),(23601,4439,'2754216','834','00','005010X220A1','2754216','','2014-03-10','15:01:09',0,'2014-03-10 21:01:17',NULL,NULL),(1187,239,'385228','834','00','005010X220A1','385228','','2013-12-24','16:10:08',0,'2013-12-25 18:47:22',NULL,NULL),(1882,325,'598457','834','00','005010X220A1','598457','','2013-12-08','23:01:57',0,'2013-12-25 19:31:17',NULL,NULL),(1950,326,'708339','834','00','005010X220A1','708339','','2013-12-09','11:59:10',0,'2013-12-25 19:33:13',NULL,NULL),(15213,2593,'2507217','834','00','005010X220A1','2507217','','2014-01-15','10:52:07',0,'2014-01-16 08:46:33',NULL,NULL),(6189,1167,'113741','834','00','005010X220A1','113741','','2013-12-20','17:45:56',0,'2013-12-26 03:03:58',NULL,NULL),(13519,2235,'1719849','834','00','005010X220A1','1719849','','2014-01-06','14:42:45',0,'2014-01-07 04:05:21',NULL,NULL),(4844,883,'724618','834','00','005010X220A1','724618','','2013-11-21','14:28:25',0,'2013-12-26 00:15:23',NULL,NULL),(11965,1580,'2284342','834','00','005010X220A1','2284342','','2013-12-30','12:06:25',0,'2014-01-01 12:00:45',NULL,NULL),(20854,3911,'3347772','834','00','005010X220A1','3347772','','2014-02-25','15:55:59',0,'2014-02-25 21:31:33',NULL,NULL),(22252,4200,'2998526','834','00','005010X220A1','2998526','','2014-03-03','21:47:03',0,'2014-03-04 21:00:21',NULL,NULL),(786,145,'581236','834','00','005010X220A1','581236','','2013-10-31','15:46:12',0,'2013-12-25 18:09:39',NULL,NULL),(16727,3064,'2311684','834','00','005010X220A1','2311684','','2014-01-27','17:43:44',0,'2014-01-27 21:01:02',NULL,NULL),(15244,2598,'2233240','834','00','005010X220A1','2233240','','2014-01-15','13:12:10',0,'2014-01-16 08:46:53',NULL,NULL),(12216,1615,'1724893','834','00','005010X220A1','1724893','','2014-01-01','15:32:57',1,'2014-01-02 04:22:03',NULL,NULL),(20668,3878,'2474651','834','00','005010X220A1','2474651','','2014-02-21','16:22:08',0,'2014-02-21 22:01:04',NULL,NULL),(3968,716,'1281608','834','00','005010X220A1','1281608','','2013-12-07','13:41:37',0,'2013-12-25 22:47:10',NULL,NULL),(16218,2910,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:40:00',1,'2014-01-23 05:06:59',NULL,NULL),(4323,750,'218362','834','00','005010X220A1','218362','','2013-12-19','17:03:59',0,'2013-12-25 23:09:56',NULL,NULL),(17535,3235,'1834999','834','00','005010X220A1','1834999','','2014-02-03','15:06:15',0,'2014-02-03 21:00:17',NULL,NULL),(18861,3493,'2293269','834','00','005010X220A1','2293269','','2014-02-10','21:01:15',0,'2014-02-11 21:02:02',NULL,NULL),(21659,4077,'2775799','834','00','005010X220A1','2775799','','2014-02-27','20:43:00',0,'2014-02-28 21:00:06',NULL,NULL),(21950,4135,'2853040','834','00','005010X220A1','2853040','','2014-02-28','21:43:27',0,'2014-03-01 21:01:05',NULL,NULL),(22351,4205,'2933769','834','00','005010X220A1','2933769','','2014-03-03','21:36:25',0,'2014-03-04 21:01:39',NULL,NULL),(665,108,'908626','834','00','005010X220A1','908626','','2013-12-16','18:20:32',0,'2013-12-25 18:05:38',NULL,NULL),(10761,1404,'1008301','834','00','005010X220A1','1008301','','2013-12-22','18:54:02',0,'2013-12-26 13:02:37',NULL,NULL),(1469,252,'1304575','834','00','005010X220A1','1304575','','2013-12-24','16:18:32',0,'2013-12-25 18:56:25',NULL,NULL),(13841,2310,'1618191','834','00','005010X220A1','1618191','','2014-01-11','15:13:03',0,'2014-01-13 02:18:42',NULL,NULL),(4345,758,'727913','834','00','005010X220A1','727913','','2013-12-19','17:28:35',0,'2013-12-25 23:10:36',NULL,NULL),(2373,413,'1263753','834','00','005010X220A1','1263753','','2013-12-06','13:57:51',0,'2013-12-25 20:16:26',NULL,NULL),(3037,544,'432763','834','00','005010X220A1','432763','','2013-12-13','10:44:26',0,'2013-12-25 21:34:13',NULL,NULL),(19139,3549,'2404915','834','00','005010X220A1','2404915','','2014-02-11','22:01:41',0,'2014-02-12 21:32:02',NULL,NULL),(19350,3584,'2889465','834','00','005010X220A1','2889465','','2014-02-12','19:26:42',0,'2014-02-13 22:01:52',NULL,NULL),(1251,243,'1636713','834','00','005010X220A1','1636713','','2013-12-24','11:33:36',0,'2013-12-25 18:49:12',NULL,NULL),(17257,3170,'1767438','834','00','005010X220A1','1767438','','2014-01-30','21:43:31',0,'2014-01-31 21:00:11',NULL,NULL),(16859,3093,'1567117','834','00','005010X220A1','1567117','','2014-01-28','11:05:39',0,'2014-01-28 21:00:46',NULL,NULL),(11185,1451,'971029','834','00','005010X220A1','971029','','2013-12-23','15:50:10',0,'2013-12-26 13:17:08',NULL,NULL),(16243,2935,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:11:00',0,'2014-01-23 06:46:11',NULL,NULL),(15134,2587,'1658212','834','00','005010X220A1','1658212','','2014-01-15','17:23:46',0,'2014-01-16 08:45:43',NULL,NULL),(5199,949,'787759','834','00','005010X220A1','787759','','2013-12-11','13:20:52',0,'2013-12-26 00:52:20',NULL,NULL),(2844,511,'824191','834','00','005010X220A1','824191','','2013-12-22','16:17:02',0,'2013-12-25 21:21:48',NULL,NULL),(13926,2315,'1620852','834','00','005010X220A1','1620852','','2014-01-08','18:35:06',0,'2014-01-13 02:20:02',NULL,NULL),(22429,4227,'3576278','834','00','005010X220A1','3576278','','2014-03-04','16:36:13',0,'2014-03-04 21:02:45',NULL,NULL),(23595,4437,'3648702','834','00','005010X220A1','3648702','','2014-03-10','15:09:14',0,'2014-03-10 21:01:13',NULL,NULL),(1418,248,'940985','834','00','005010X220A1','940985','','2013-12-24','13:36:56',0,'2013-12-25 18:54:38',NULL,NULL),(1837,317,'543556','834','00','005010X220A1','543556','','2013-12-10','16:24:19',0,'2013-12-25 19:20:49',NULL,NULL),(2437,419,'1244155','834','00','005010X220A1','1244155','','2013-12-05','22:35:57',0,'2013-12-25 20:18:23',NULL,NULL),(15566,2657,'1920800','834','00','005010X220A1','1920800','','2014-01-16','19:57:07',0,'2014-01-20 08:06:00',NULL,NULL),(20260,3794,'3187054','834','00','005010X220A1','3187054','','2014-02-18','22:31:44',0,'2014-02-20 04:33:57',NULL,NULL),(20287,3796,'2603864','834','00','005010X220A1','2603864','','2014-02-19','10:16:12',0,'2014-02-20 04:39:52',NULL,NULL),(21921,4128,'3756243','834','00','005010X220A1','3756243','','2014-02-28','19:08:20',0,'2014-03-01 21:00:43',NULL,NULL),(22231,4194,'2873418','834','00','005010X220A1','2873418','','2014-03-03','16:50:54',0,'2014-03-03 21:31:55',NULL,NULL),(94,4,'160824','834','00','005010X220A1','160824','','2013-12-05','11:34:06',0,'2013-12-25 17:17:51',NULL,NULL),(216,27,'372655','834','00','005010X220A1','372655','','2013-12-05','12:17:58',0,'2013-12-25 17:21:49',NULL,NULL),(624,108,'1034873','834','00','005010X220A1','1034873','','2013-12-16','11:00:56',0,'2013-12-25 18:04:24',NULL,NULL),(12215,1615,'2084532','834','00','005010X220A1','2084532','','2014-01-01','14:31:32',1,'2014-01-02 04:22:01',NULL,NULL),(7268,1250,'590219','834','00','005010X220A1','590219','','2013-12-18','10:19:45',0,'2013-12-26 04:08:44',NULL,NULL),(6234,1168,'771467','834','00','005010X220A1','771467','','2013-12-20','17:39:56',0,'2013-12-26 03:05:24',NULL,NULL),(4941,919,'283160','834','00','005010X220A1','283160','','2013-11-19','11:51:57',0,'2013-12-26 00:31:29',NULL,NULL),(5891,1110,'905018','834','00','005010X220A1','905018','','2013-12-14','21:15:31',0,'2013-12-26 02:30:29',NULL,NULL),(21995,4146,'3116981','834','00','005010X220A1','3116981','','2014-03-01','21:15:49',0,'2014-03-03 01:00:20',NULL,NULL),(23120,4342,'3341521','834','00','005010X220A1','3341521','','2014-03-06','23:15:25',0,'2014-03-07 21:30:50',NULL,NULL),(1140,238,'1473023','834','00','005010X220A1','1473023','','2013-12-24','18:00:47',0,'2013-12-25 18:45:54',NULL,NULL),(19347,3583,'2317410','834','00','005010X220A1','2317410','','2014-02-13','16:41:12',0,'2014-02-13 22:01:50',NULL,NULL),(2140,360,'421323','834','00','005010X220A1','421323','','2013-12-02','13:10:27',0,'2013-12-25 19:46:08',NULL,NULL),(12376,1637,'1767905','834','00','005010X220A1','1767905','','2013-12-30','18:45:13',1,'2014-01-02 04:28:49',NULL,NULL),(14750,2551,'2504874','834','00','005010X220A1','2504874','','2014-01-13','18:45:00',0,'2014-01-15 02:06:23',NULL,NULL),(22569,4248,'3041022','834','00','005010X220A1','3041022','','2014-03-05','13:47:05',0,'2014-03-05 21:30:56',NULL,NULL),(23590,4437,'2988610','834','00','005010X220A1','2988610','','2014-03-10','09:41:22',0,'2014-03-10 21:01:10',NULL,NULL),(13735,2275,'1845820','834','00','005010X220A1','1845820','','2014-01-07','15:34:48',0,'2014-01-08 18:24:45',NULL,NULL),(19472,3620,'2585599','834','00','005010X220A1','2585599','','2014-02-13','19:56:14',0,'2014-02-14 21:30:06',NULL,NULL),(13382,2221,'2161154','834','00','005010X220A1','2161154','','2014-01-05','19:20:36',0,'2014-01-07 04:00:13',NULL,NULL),(3065,544,'517348','834','00','005010X220A1','517348','','2013-12-13','16:00:46',0,'2013-12-25 21:35:05',NULL,NULL),(16057,2772,'1977478','834','00','005010X220A1','1977478','','2014-01-22','12:11:24',0,'2014-01-23 03:02:39',NULL,NULL),(14910,2558,'2049792','834','00','005010X220A1','2049792','','2014-01-14','16:36:04',0,'2014-01-15 02:07:34',NULL,NULL),(14403,2424,'0001','999','BE','005010X231A1','714044','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:16',NULL,NULL),(13868,2311,'1984400','834','00','005010X220A1','1984400','','2014-01-09','13:10:29',0,'2014-01-13 02:19:24',NULL,NULL),(10498,1400,'988463','834','00','005010X220A1','988463','','2013-12-23','17:19:57',0,'2013-12-26 12:53:48',NULL,NULL),(19705,3671,'3236871','834','00','005010X220A1','3236871','','2014-02-15','14:07:44',0,'2014-02-15 22:00:11',NULL,NULL),(48,3,'1316875','834','00','005010X220A1','1316875','','2013-12-04','19:11:17',0,'2013-12-25 17:16:26',NULL,NULL),(19185,3569,'1910736','834','00','005010X220A1','1910736','','2014-02-13','09:29:16',0,'2014-02-13 21:30:05',NULL,NULL),(227,35,'718999','834','00','005010X220A1','718999','','2013-10-12','08:28:08',0,'2013-12-25 17:30:08',NULL,NULL),(17077,3132,'2380305','834','00','005010X220A1','2380305','','2014-01-29','16:19:57',0,'2014-01-29 21:01:44',NULL,NULL),(7550,1301,'202916','834','00','005010X220A1','202916','','2013-12-20','19:57:13',0,'2013-12-26 04:35:36',NULL,NULL),(5080,937,'679870','834','00','005010X220A1','679870','','2013-12-10','18:29:36',0,'2013-12-26 00:48:34',NULL,NULL),(2792,506,'4523','834','00','005010X220A1','4523','','2013-12-22','11:02:08',0,'2013-12-25 21:20:06',NULL,NULL),(4994,935,'991569','834','00','005010X220A1','991569','','2013-12-11','08:34:37',0,'2013-12-26 00:45:47',NULL,NULL),(19815,3679,'3410716','834','00','005010X220A1','3410716','','2014-02-14','20:18:35',0,'2014-02-15 22:01:34',NULL,NULL),(15575,2657,'1541134','834','00','005010X220A1','1541134','','2014-01-17','12:12:55',0,'2014-01-20 08:06:07',NULL,NULL),(17731,3261,'1996530','834','00','005010X220A1','1996530','','2014-02-04','17:43:54',0,'2014-02-04 21:00:48',NULL,NULL),(6421,1203,'673009','834','00','005010X220A1','673009','','2013-11-21','19:41:11',0,'2013-12-26 03:15:11',NULL,NULL),(3032,544,'1200507','834','00','005010X220A1','1200507','','2013-12-13','09:01:28',0,'2013-12-25 21:34:04',NULL,NULL),(2965,541,'1622','834','00','005010X220A1','1622','','2013-12-13','14:21:03',0,'2013-12-25 21:32:04',NULL,NULL),(2929,541,'10289','834','00','005010X220A1','10289','','2013-12-12','20:21:13',0,'2013-12-25 21:30:53',NULL,NULL),(13828,2300,'2393858','834','00','005010X220A1','2393858','','2014-01-11','10:51:09',0,'2014-01-13 02:18:33',NULL,NULL),(1329,245,'1898281','834','00','005010X220A1','1898281','','2013-12-24','11:43:40',0,'2013-12-25 18:51:44',NULL,NULL),(13666,2271,'1619392','834','00','005010X220A1','1619392','','2014-01-07','11:38:36',0,'2014-01-08 18:24:16',NULL,NULL),(19376,3590,'2746545','834','00','005010X220A1','2746545','','2014-02-13','16:05:40',0,'2014-02-13 22:02:12',NULL,NULL),(5204,949,'863868','834','00','005010X220A1','863868','','2013-12-11','13:58:00',0,'2013-12-26 00:52:30',NULL,NULL),(18821,3490,'2590827','834','00','005010X220A1','2590827','','2014-02-10','21:22:45',0,'2014-02-11 21:01:31',NULL,NULL),(14509,2515,'2550073','834','00','005010X220A1','2550073','','2014-01-13','16:30:02',0,'2014-01-14 01:32:08',NULL,NULL),(20464,3842,'3446131','834','00','005010X220A1','3446131','','2014-02-20','12:02:46',0,'2014-02-20 22:00:34',NULL,NULL),(21934,4130,'2742955','834','00','005010X220A1','2742955','','2014-02-28','19:20:03',0,'2014-03-01 21:00:52',NULL,NULL),(22646,4253,'3735808','834','00','005010X220A1','3735808','','2014-03-05','14:49:11',0,'2014-03-05 21:31:50',NULL,NULL),(19691,3670,'2872978','834','00','005010X220A1','2872978','','2014-02-14','20:47:08',0,'2014-02-15 21:00:13',NULL,NULL),(18215,3356,'2977427','834','00','005010X220A1','2977427','','2014-02-07','15:29:40',0,'2014-02-07 19:00:44',NULL,NULL),(13335,2179,'0001','999','BE','005010X231A1','623433','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:49',NULL,NULL),(10521,1401,'1192415','834','00','005010X220A1','1192415','','2013-12-23','00:56:40',0,'2013-12-26 12:54:31',NULL,NULL),(7287,1255,'873802','834','00','005010X220A1','873802','','2013-12-18','15:39:28',0,'2013-12-26 04:09:17',NULL,NULL),(22188,4180,'3079966','834','00','005010X220A1','3079966','','2014-03-03','17:31:51',0,'2014-03-03 21:31:22',NULL,NULL),(22566,4248,'2690406','834','00','005010X220A1','2690406','','2014-03-05','13:13:34',0,'2014-03-05 21:30:54',NULL,NULL),(22584,4248,'2855639','834','00','005010X220A1','2855639','','2014-03-05','16:55:12',0,'2014-03-05 21:31:07',NULL,NULL),(4883,891,'209736','834','00','005010X220A1','209736','','2013-11-21','17:51:03',0,'2013-12-26 00:16:42',NULL,NULL),(1946,326,'8701','834','00','005010X220A1','8701','','2013-12-09','11:19:50',0,'2013-12-25 19:33:07',NULL,NULL),(18002,3318,'2353877','834','00','005010X220A1','2353877','','2014-02-06','15:13:27',0,'2014-02-06 21:00:08',NULL,NULL),(17742,3262,'2644689','834','00','005010X220A1','2644689','','2014-02-04','09:27:39',0,'2014-02-04 21:00:55',NULL,NULL),(3023,543,'932777','834','00','005010X220A1','932777','','2013-12-13','16:18:04',0,'2013-12-25 21:33:48',NULL,NULL),(14975,2572,'2416639','834','00','005010X220A1','2416639','','2014-01-14','13:33:20',0,'2014-01-15 02:08:04',NULL,NULL),(273,56,'1231813','834','00','005010X220A1','1231813','','2013-10-11','12:17:40',0,'2013-12-25 17:31:41',NULL,NULL),(2074,341,'1277164','834','00','005010X220A1','1277164','','2013-12-09','13:25:47',0,'2013-12-25 19:37:12',NULL,NULL),(530,102,'1302856','834','00','005010X220A1','1302856','','2013-12-16','14:56:01',0,'2013-12-25 18:01:22',NULL,NULL),(18141,3341,'1644610','834','00','005010X220A1','1644610','','2014-02-06','12:20:05',0,'2014-02-06 21:01:48',NULL,NULL),(4117,733,'272694','834','00','005010X220A1','272694','','2013-12-19','13:35:53',0,'2013-12-25 23:03:45',NULL,NULL),(863,175,'213595','834','00','005010X220A1','213595','','2013-12-03','12:23:49',0,'2013-12-25 18:16:04',NULL,NULL),(11446,1488,'2259029','834','00','005010X220A1','2259029','','2013-12-26','18:31:00',0,'2013-12-28 03:30:02',NULL,NULL),(13995,2329,'1672856','834','00','005010X220A1','1672856','','2014-01-09','16:54:28',0,'2014-01-13 02:20:54',NULL,NULL),(21290,4006,'2621922','834','00','005010X220A1','2621922','','2014-02-26','10:54:09',0,'2014-02-26 21:02:17',NULL,NULL),(23237,4363,'3008442','834','00','005010X220A1','3008442','','2014-03-07','12:30:21',0,'2014-03-07 21:32:12',NULL,NULL),(23608,4440,'3350765','834','00','005010X220A1','3350765','','2014-03-10','14:50:41',0,'2014-03-10 21:01:22',NULL,NULL),(1189,239,'842195','834','00','005010X220A1','842195','','2013-12-24','16:54:51',0,'2013-12-25 18:47:26',NULL,NULL),(2248,377,'1203798','834','00','005010X220A1','1203798','','2013-12-02','14:31:30',0,'2013-12-25 19:49:51',NULL,NULL),(15017,2584,'2171424','834','00','005010X220A1','2171424','','2014-01-15','14:30:39',0,'2014-01-16 08:44:28',NULL,NULL),(14490,2511,'0001','999','BE','005010X231A1','292504','834','2013-12-28','11:05:00',0,'2014-01-13 03:04:00',NULL,NULL),(5246,960,'314118','834','00','005010X220A1','314118','','2013-12-11','11:31:44',0,'2013-12-26 00:53:52',NULL,NULL),(13216,2060,'0001','999','BE','005010X231A1','552645','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:37',NULL,NULL),(11690,1517,'1475413','834','00','005010X220A1','1475413','','2013-12-28','12:19:35',1,'2013-12-29 11:07:36',NULL,NULL),(11285,1455,'1487480','834','00','005010X220A1','1487480','','2013-12-26','14:18:04',0,'2013-12-27 02:03:02',NULL,NULL),(3675,629,'500287','834','00','005010X220A1','500287','','2013-12-12','09:50:46',0,'2013-12-25 22:06:42',NULL,NULL),(23383,4401,'2984540','834','00','005010X220A1','2984540','','2014-03-08','18:04:02',0,'2014-03-09 20:59:58',NULL,NULL),(148,10,'11427','834','00','005010X220A1','11427','','2013-12-05','10:42:21',0,'2013-12-25 17:19:37',NULL,NULL),(2395,414,'509994','834','00','005010X220A1','509994','','2013-12-05','18:30:55',0,'2013-12-25 20:17:02',NULL,NULL),(19295,3582,'2705239','834','00','005010X220A1','2705239','','2014-02-13','15:56:26',0,'2014-02-13 22:01:09',NULL,NULL),(18802,3487,'1731407','834','00','005010X220A1','1731407','','2014-02-11','15:53:14',0,'2014-02-11 21:01:17',NULL,NULL),(18704,3483,'2531665','834','00','005010X220A1','2531665','','2014-02-10','16:30:58',0,'2014-02-10 21:32:18',NULL,NULL),(2551,458,'1180214','834','00','005010X220A1','1180214','','2013-11-18','14:46:36',0,'2013-12-25 20:31:35',NULL,NULL),(7505,1300,'1264322','834','00','005010X220A1','1264322','','2013-12-21','00:12:09',0,'2013-12-26 04:34:12',NULL,NULL),(12847,1705,'1788740','834','00','005010X220A1','1788740','','2014-01-03','13:25:56',0,'2014-01-04 02:02:56',NULL,NULL),(20495,3845,'3026691','834','00','005010X220A1','3026691','','2014-02-20','14:25:53',0,'2014-02-20 22:00:59',NULL,NULL),(20815,3910,'3567904','834','00','005010X220A1','3567904','','2014-02-25','13:47:20',0,'2014-02-25 21:31:05',NULL,NULL),(21783,4091,'3265364','834','00','005010X220A1','3265364','','2014-02-28','14:41:30',0,'2014-02-28 21:31:10',NULL,NULL),(22465,4238,'3060699','834','00','005010X220A1','3060699','','2014-03-05','10:55:02',0,'2014-03-05 21:00:13',NULL,NULL),(13078,1922,'0001','999','BE','005010X231A1','927012','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:37',NULL,NULL),(12276,1623,'2307723','834','00','005010X220A1','2307723','','2014-01-01','14:47:46',1,'2014-01-02 04:24:24',NULL,NULL),(2063,339,'564820','834','00','005010X220A1','564820','','2013-12-09','09:05:45',0,'2013-12-25 19:36:53',NULL,NULL),(19159,3555,'2626525','834','00','005010X220A1','2626525','','2014-02-12','17:36:57',0,'2014-02-12 21:32:17',NULL,NULL),(5065,936,'367204','834','00','005010X220A1','367204','','2013-12-11','11:30:12',0,'2013-12-26 00:48:04',NULL,NULL),(17705,3261,'2278867','834','00','005010X220A1','2278867','','2014-02-03','20:42:32',0,'2014-02-04 21:00:32',NULL,NULL),(5256,967,'634006','834','00','005010X220A1','634006','','2013-12-11','17:45:05',0,'2013-12-26 00:54:15',NULL,NULL),(1363,245,'1541809','834','00','005010X220A1','1541809','','2013-12-24','15:06:03',0,'2013-12-25 18:52:50',NULL,NULL),(23557,4436,'2721861','834','00','005010X220A1','2721861','','2014-03-09','21:08:35',0,'2014-03-10 21:00:46',NULL,NULL),(10890,1409,'1172787','834','00','005010X220A1','1172787','','2013-12-22','21:40:15',0,'2013-12-26 13:07:18',NULL,NULL),(6098,1166,'120023','834','00','005010X220A1','120023','','2013-12-20','09:09:50',0,'2013-12-26 03:01:15',NULL,NULL),(3103,546,'472998','834','00','005010X220A1','472998','','2013-12-13','12:10:25',0,'2013-12-25 21:36:16',NULL,NULL),(546,103,'1219286','834','00','005010X220A1','1219286','','2013-12-15','23:07:23',0,'2013-12-25 18:01:52',NULL,NULL),(15795,2722,'1954587','834','00','005010X220A1','1954587','','2014-01-20','11:53:15',0,'2014-01-21 08:46:45',NULL,NULL),(14895,2558,'1699415','834','00','005010X220A1','1699415','','2014-01-14','11:35:05',0,'2014-01-15 02:07:28',NULL,NULL),(21291,4006,'2717693','834','00','005010X220A1','2717693','','2014-02-26','11:37:34',0,'2014-02-26 21:02:17',NULL,NULL),(12795,1703,'1416408','834','00','005010X220A1','1416408','','2014-01-03','11:28:25',0,'2014-01-04 02:01:04',NULL,NULL),(20079,3761,'3392924','834','00','005010X220A1','3392924','','2014-02-18','15:10:14',0,'2014-02-18 22:01:30',NULL,NULL),(17176,3147,'2402121','834','00','005010X220A1','2402121','','2014-01-29','20:31:54',0,'2014-01-30 21:00:55',NULL,NULL),(11251,1454,'1915401','834','00','005010X220A1','1915401','','2013-12-26','15:03:30',0,'2013-12-27 02:01:59',NULL,NULL),(16993,3118,'1951262','834','00','005010X220A1','1951262','','2014-01-29','09:53:23',0,'2014-01-29 21:00:50',NULL,NULL),(3655,625,'1167261','834','00','005010X220A1','1167261','','2013-12-12','16:31:39',0,'2013-12-25 22:06:05',NULL,NULL),(15530,2654,'1496461','834','00','005010X220A1','1496461','','2014-01-16','21:27:18',0,'2014-01-20 08:05:34',NULL,NULL),(3764,654,'456324','834','00','005010X220A1','456324','','2013-12-08','08:41:45',0,'2013-12-25 22:15:08',NULL,NULL),(12989,1738,'1370366','834','00','005010X220A1','1370366','','2014-01-03','20:44:23',0,'2014-01-05 00:01:44',NULL,NULL),(20247,3792,'2775540','834','00','005010X220A1','2775540','','2014-02-19','14:24:54',0,'2014-02-20 04:31:23',NULL,NULL),(21936,4131,'3504110','834','00','005010X220A1','3504110','','2014-02-28','19:34:35',0,'2014-03-01 21:00:53',NULL,NULL),(22200,4185,'3162872','834','00','005010X220A1','3162872','','2014-03-03','11:12:39',0,'2014-03-03 21:31:32',NULL,NULL),(22902,4284,'2925542','834','00','005010X220A1','2925542','','2014-03-06','17:40:37',0,'2014-03-06 21:02:17',NULL,NULL),(23080,4339,'2913194','834','00','005010X220A1','2913194','','2014-03-07','12:32:31',0,'2014-03-07 21:30:21',NULL,NULL),(23218,4350,'3095956','834','00','005010X220A1','3095956','','2014-03-06','20:58:34',0,'2014-03-07 21:31:58',NULL,NULL),(23421,4405,'3214805','834','00','005010X220A1','3214805','','2014-03-08','20:21:21',0,'2014-03-09 21:00:26',NULL,NULL),(6178,1167,'531314','834','00','005010X220A1','531314','','2013-12-20','16:18:47',0,'2013-12-26 03:03:38',NULL,NULL),(3235,578,'752927','834','00','005010X220A1','752927','','2013-12-17','14:19:34',0,'2013-12-25 21:46:23',NULL,NULL),(20129,3772,'3561573','834','00','005010X220A1','3561573','','2014-02-19','14:31:23',0,'2014-02-20 03:57:06',NULL,NULL),(19767,3675,'3508942','834','00','005010X220A1','3508942','','2014-02-15','10:03:04',0,'2014-02-15 22:00:56',NULL,NULL),(19495,3620,'3366366','834','00','005010X220A1','3366366','','2014-02-14','15:29:35',0,'2014-02-14 21:30:22',NULL,NULL),(1763,296,'1261298','834','00','005010X220A1','1261298','','2013-12-09','18:49:32',0,'2013-12-25 19:18:22',NULL,NULL),(16361,2985,'1725435','834','00','005010X220A1','1725435','','2014-01-22','19:49:27',0,'2014-01-23 21:00:55',NULL,NULL),(7430,1295,'666418','834','00','005010X220A1','666418','','2013-12-21','12:44:42',0,'2013-12-26 04:31:48',NULL,NULL),(15595,2660,'2116930','834','00','005010X220A1','2116930','','2014-01-16','23:27:22',0,'2014-01-20 08:06:23',NULL,NULL),(13933,2317,'2148122','834','00','005010X220A1','2148122','','2014-01-09','16:42:10',0,'2014-01-13 02:20:08',NULL,NULL),(10407,1400,'1532869','834','00','005010X220A1','1532869','','2013-12-23','09:15:00',0,'2013-12-26 12:50:55',NULL,NULL),(13077,1921,'0001','999','BE','005010X231A1','799523','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:35',NULL,NULL),(12711,1677,'1536621','834','00','005010X220A1','1536621','','2014-01-02','11:36:37',0,'2014-01-03 02:05:10',NULL,NULL),(10656,1402,'726767','834','00','005010X220A1','726767','','2013-12-23','18:40:22',0,'2013-12-26 12:59:00',NULL,NULL),(11066,1421,'1400520','834','00','005010X220A1','1400520','','2013-12-23','13:00:39',0,'2013-12-26 13:13:01',NULL,NULL),(11039,1418,'692296','834','00','005010X220A1','692296','','2013-12-23','09:36:19',0,'2013-12-26 13:12:07',NULL,NULL),(20717,3897,'2287163','834','00','005010X220A1','2287163','','2014-02-25','08:39:10',0,'2014-02-25 21:00:24',NULL,NULL),(942,181,'355136','834','00','005010X220A1','355136','','2013-12-03','13:36:34',0,'2013-12-25 18:18:25',NULL,NULL),(20040,3751,'3299989','834','00','005010X220A1','3299989','','2014-02-18','09:51:24',0,'2014-02-18 22:01:00',NULL,NULL),(4318,750,'420531','834','00','005010X220A1','420531','','2013-12-19','16:42:05',0,'2013-12-25 23:09:47',NULL,NULL),(19669,3658,'2909229','834','00','005010X220A1','2909229','','2014-02-13','19:02:38',0,'2014-02-14 22:00:02',NULL,NULL),(1749,293,'965625','834','00','005010X220A1','965625','','2013-12-10','16:25:50',0,'2013-12-25 19:17:57',NULL,NULL),(2983,542,'562277','834','00','005010X220A1','562277','','2013-12-12','23:34:57',0,'2013-12-25 21:32:36',NULL,NULL),(18777,3486,'2617936','834','00','005010X220A1','2617936','','2014-02-11','15:39:38',0,'2014-02-11 21:00:58',NULL,NULL),(18729,3485,'2709965','834','00','005010X220A1','2709965','','2014-02-11','10:16:22',0,'2014-02-11 21:00:22',NULL,NULL),(7394,1293,'505597','834','00','005010X220A1','505597','','2013-12-21','17:37:32',0,'2013-12-26 04:30:39',NULL,NULL),(14835,2553,'2410488','834','00','005010X220A1','2410488','','2014-01-13','21:34:42',0,'2014-01-15 02:06:59',NULL,NULL),(21034,3977,'3134040','834','00','005010X220A1','3134040','','2014-02-23','20:44:52',0,'2014-02-26 09:30:13',NULL,NULL),(21849,4113,'3642919','834','00','005010X220A1','3642919','','2014-02-28','20:08:58',0,'2014-03-01 19:00:02',NULL,NULL),(1171,239,'1708643','834','00','005010X220A1','1708643','','2013-12-24','13:12:59',0,'2013-12-25 18:46:50',NULL,NULL),(7438,1295,'1313418','834','00','005010X220A1','1313418','','2013-12-21','17:19:17',0,'2013-12-26 04:32:03',NULL,NULL),(16553,3026,'2175739','834','00','005010X220A1','2175739','','2014-01-24','13:33:55',0,'2014-01-24 21:01:14',NULL,NULL),(16525,3017,'1538579','834','00','005010X220A1','1538579','','2014-01-23','20:16:01',0,'2014-01-24 21:00:58',NULL,NULL),(14984,2578,'2552886','834','00','005010X220A1','2552886','','2014-01-14','15:15:12',0,'2014-01-15 02:08:09',NULL,NULL),(14743,2550,'2254530','834','00','005010X220A1','2254530','','2014-01-14','16:54:38',0,'2014-01-15 02:06:20',NULL,NULL),(14596,2521,'2070520','834','00','005010X220A1','2070520','','2014-01-13','13:42:35',0,'2014-01-14 01:33:04',NULL,NULL),(14402,2423,'0001','999','BE','005010X231A1','614257','834','2013-12-28','04:55:00',0,'2014-01-13 03:02:16',NULL,NULL),(13901,2313,'1666423','834','00','005010X220A1','1666423','','2014-01-09','10:55:42',0,'2014-01-13 02:19:46',NULL,NULL),(4467,801,'862405','834','00','005010X220A1','862405','','2013-11-26','11:54:58',0,'2013-12-25 23:30:58',NULL,NULL),(5703,1067,'283608','834','00','005010X220A1','283608','','2013-12-14','17:44:59',0,'2013-12-26 02:00:32',NULL,NULL),(20858,3911,'3784380','834','00','005010X220A1','3784380','','2014-02-25','17:09:56',0,'2014-02-25 21:31:37',NULL,NULL),(23695,4450,'2974832','834','00','005010X220A1','2974832','','2014-03-10','15:24:42',0,'2014-03-10 21:02:24',NULL,NULL),(5391,1013,'925577','834','00','005010X220A1','925577','','2013-11-25','17:30:42',0,'2013-12-26 01:17:14',NULL,NULL),(5051,936,'23133','834','00','005010X220A1','23133','','2013-12-11','05:39:30',0,'2013-12-26 00:47:36',NULL,NULL),(6121,1166,'831115','834','00','005010X220A1','831115','','2013-12-20','14:38:58',0,'2013-12-26 03:01:55',NULL,NULL),(13991,2327,'2367842','834','00','005010X220A1','2367842','','2014-01-09','14:50:44',0,'2014-01-13 02:20:50',NULL,NULL),(17320,3174,'2175900','834','00','005010X220A1','2175900','','2014-01-31','13:00:46',0,'2014-01-31 21:00:54',NULL,NULL),(21948,4133,'2721548','834','00','005010X220A1','2721548','','2014-03-01','16:18:49',0,'2014-03-01 21:01:04',NULL,NULL),(2662,501,'804757','834','00','005010X220A1','804757','','2013-12-22','14:18:27',0,'2013-12-25 21:15:54',NULL,NULL),(5428,1031,'236004','834','00','005010X220A1','236004','','2013-10-04','18:59:27',0,'2013-12-26 01:31:16',NULL,NULL),(3807,661,'302806','834','00','005010X220A1','302806','','2013-12-08','16:53:23',0,'2013-12-25 22:16:34',NULL,NULL),(12355,1634,'1975608','834','00','005010X220A1','1975608','','2013-12-31','14:12:45',1,'2014-01-02 04:28:02',NULL,NULL),(15515,2645,'2274937','834','00','005010X220A1','2274937','','2014-01-15','19:32:02',0,'2014-01-17 03:36:38',NULL,NULL),(21385,4024,'3227576','834','00','005010X220A1','3227576','','2014-02-27','14:54:27',0,'2014-02-28 06:30:29',NULL,NULL),(630,108,'230817','834','00','005010X220A1','230817','','2013-12-16','11:31:06',0,'2013-12-25 18:04:36',NULL,NULL),(19446,3604,'3387841','834','00','005010X220A1','3387841','','2014-02-13','12:45:53',0,'2014-02-13 22:03:04',NULL,NULL),(18494,3437,'1664603','834','00','005010X220A1','1664603','','2014-02-10','04:17:03',0,'2014-02-10 11:01:10',NULL,NULL),(18436,3421,'1942678','834','00','005010X220A1','1942678','','2014-02-10','00:23:12',0,'2014-02-10 11:00:21',NULL,NULL),(18354,3400,'2556498','834','00','005010X220A1','2556498','','2014-02-09','15:26:25',0,'2014-02-09 19:00:04',NULL,NULL),(20746,3903,'3713478','834','00','005010X220A1','3713478','','2014-02-25','12:50:30',0,'2014-02-25 21:30:15',NULL,NULL),(11223,1454,'2057068','834','00','005010X220A1','2057068','','2013-12-26','10:32:15',0,'2013-12-27 02:01:08',NULL,NULL),(7098,1236,'23443','834','00','005010X220A1','23443','','2013-12-18','11:43:19',0,'2013-12-26 04:03:33',NULL,NULL),(17470,3217,'2236197','834','00','005010X220A1','2236197','','2014-02-01','18:58:18',0,'2014-02-02 19:00:06',NULL,NULL),(14158,2363,'2526278','834','00','005010X220A1','2526278','','2014-01-09','19:32:39',0,'2014-01-13 02:23:10',NULL,NULL),(1473,252,'74815','834','00','005010X220A1','74815','','2013-12-24','16:53:53',0,'2013-12-25 18:56:35',NULL,NULL),(3361,587,'1317301','834','00','005010X220A1','1317301','','2013-12-17','10:56:54',0,'2013-12-25 21:50:28',NULL,NULL),(3836,680,'394186','834','00','005010X220A1','394186','','2013-11-07','19:51:31',0,'2013-12-25 22:30:08',NULL,NULL),(19281,3582,'2948903','834','00','005010X220A1','2948903','','2014-02-13','13:33:14',0,'2014-02-13 22:00:59',NULL,NULL),(20702,3893,'3120389','834','00','005010X220A1','3120389','','2014-02-24','19:56:49',0,'2014-02-25 21:00:13',NULL,NULL),(705,116,'973079','834','00','005010X220A1','973079','','2013-12-16','16:11:43',0,'2013-12-25 18:06:53',NULL,NULL),(18734,3485,'2611959','834','00','005010X220A1','2611959','','2014-02-11','11:02:23',0,'2014-02-11 21:00:26',NULL,NULL),(6085,1166,'69148','834','00','005010X220A1','69148','','2013-12-19','20:12:15',0,'2013-12-26 03:00:51',NULL,NULL),(17061,3125,'1884517','834','00','005010X220A1','1884517','','2014-01-29','14:07:43',0,'2014-01-29 21:01:33',NULL,NULL),(1789,301,'693042','834','00','005010X220A1','693042','','2013-12-10','09:58:04',0,'2013-12-25 19:19:16',NULL,NULL),(3432,598,'91358','834','00','005010X220A1','91358','','2013-12-17','16:55:24',0,'2013-12-25 21:52:44',NULL,NULL),(14155,2361,'1466040','834','00','005010X220A1','1466040','','2014-01-08','15:43:51',0,'2014-01-13 02:22:47',NULL,NULL),(21708,4088,'2702021','834','00','005010X220A1','2702021','','2014-02-27','23:02:12',0,'2014-02-28 21:30:20',NULL,NULL),(23346,4387,'2653543','834','00','005010X220A1','2653543','','2014-03-08','06:47:30',0,'2014-03-08 21:30:55',NULL,NULL),(648,108,'848619','834','00','005010X220A1','848619','','2013-12-16','15:30:29',0,'2013-12-25 18:05:10',NULL,NULL),(12754,1691,'2350524','834','00','005010X220A1','2350524','','2014-01-02','16:46:40',0,'2014-01-03 02:06:50',NULL,NULL),(17218,3152,'2615145','834','00','005010X220A1','2615145','','2014-01-30','14:08:31',0,'2014-01-30 21:01:20',NULL,NULL),(16784,3082,'2668875','834','00','005010X220A1','2668875','','2014-01-27','14:16:47',0,'2014-01-27 21:01:45',NULL,NULL),(2185,363,'816816','834','00','005010X220A1','816816','','2013-12-02','15:41:11',0,'2013-12-25 19:47:38',NULL,NULL),(4474,802,'468479','834','00','005010X220A1','468479','','2013-11-26','12:12:41',0,'2013-12-25 23:31:12',NULL,NULL),(5062,936,'247699','834','00','005010X220A1','247699','','2013-12-11','11:06:19',0,'2013-12-26 00:47:58',NULL,NULL),(7543,1300,'1407765','834','00','005010X220A1','1407765','','2013-12-21','16:42:14',0,'2013-12-26 04:35:23',NULL,NULL),(13117,1961,'0001','999','BE','005010X231A1','103765','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:25',NULL,NULL),(18990,3537,'2469262','834','00','005010X220A1','2469262','','2014-02-12','18:15:28',0,'2014-02-12 21:30:20',NULL,NULL),(18973,3537,'2609727','834','00','005010X220A1','2609727','','2014-02-11','21:53:15',0,'2014-02-12 21:30:08',NULL,NULL),(98,4,'322847','834','00','005010X220A1','322847','','2013-12-05','14:30:24',0,'2013-12-25 17:17:58',NULL,NULL),(17756,3262,'1866664','834','00','005010X220A1','1866664','','2014-02-04','13:56:31',0,'2014-02-04 21:01:04',NULL,NULL),(844,175,'621620','834','00','005010X220A1','621620','','2013-12-03','09:37:58',0,'2013-12-25 18:15:28',NULL,NULL),(12982,1735,'2492168','834','00','005010X220A1','2492168','','2014-01-03','18:47:10',0,'2014-01-05 00:01:30',NULL,NULL),(16124,2816,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 03:47:36',NULL,NULL),(11654,1500,'835144','834','00','005010X220A1','835144','','2013-12-27','11:05:22',0,'2013-12-28 03:36:23',NULL,NULL),(5692,1067,'303027','834','00','005010X220A1','303027','','2013-12-13','23:01:30',0,'2013-12-26 02:00:09',NULL,NULL),(4866,886,'269313','834','00','005010X220A1','269313','','2013-11-21','15:09:55',0,'2013-12-26 00:16:08',NULL,NULL),(21369,4024,'3266716','834','00','005010X220A1','3266716','','2014-02-27','10:17:39',0,'2014-02-28 06:30:20',NULL,NULL),(193,17,'7325','834','00','005010X220A1','7325','','2013-12-04','20:39:15',0,'2013-12-25 17:21:00',NULL,NULL),(11359,1459,'1171721','834','00','005010X220A1','1171721','','2013-12-26','11:08:27',0,'2013-12-27 02:05:20',NULL,NULL),(11183,1450,'56471','834','00','005010X220A1','56471','','2013-12-23','19:14:19',0,'2013-12-26 13:17:04',NULL,NULL),(7024,1235,'304275','834','00','005010X220A1','304275','','2013-12-18','11:09:49',0,'2013-12-26 04:01:14',NULL,NULL),(6090,1166,'56190','834','00','005010X220A1','56190','','2013-12-19','21:20:42',0,'2013-12-26 03:01:01',NULL,NULL),(14580,2520,'2007895','834','00','005010X220A1','2007895','','2014-01-13','15:13:50',0,'2014-01-14 01:32:54',NULL,NULL),(14536,2518,'2062061','834','00','005010X220A1','2062061','','2014-01-13','12:28:07',0,'2014-01-14 01:32:26',NULL,NULL),(5981,1122,'352674','834','00','005010X220A1','352674','','2013-12-14','22:04:42',0,'2013-12-26 02:33:22',NULL,NULL),(14080,2341,'2451341','834','00','005010X220A1','2451341','','2014-01-07','23:37:09',0,'2014-01-13 02:21:57',NULL,NULL),(20660,3877,'3154724','834','00','005010X220A1','3154724','','2014-02-21','13:16:11',0,'2014-02-21 22:01:00',NULL,NULL),(20913,3931,'2837480','834','00','005010X220A1','2837480','','2014-02-23','15:33:28',0,'2014-02-26 08:00:12',NULL,NULL),(21717,4088,'3480591','834','00','005010X220A1','3480591','','2014-02-28','11:31:27',0,'2014-02-28 21:30:25',NULL,NULL),(23227,4358,'3731118','834','00','005010X220A1','3731118','','2014-03-07','09:20:42',0,'2014-03-07 21:32:05',NULL,NULL),(10421,1400,'1279044','834','00','005010X220A1','1279044','','2013-12-23','10:24:28',0,'2013-12-26 12:51:21',NULL,NULL),(19129,3547,'1974081','834','00','005010X220A1','1974081','','2014-02-12','14:41:17',0,'2014-02-12 21:31:56',NULL,NULL),(18178,3351,'2131422','834','00','005010X220A1','2131422','','2014-02-06','20:07:33',0,'2014-02-07 19:00:19',NULL,NULL),(20599,3870,'2594693','834','00','005010X220A1','2594693','','2014-02-21','12:36:06',0,'2014-02-21 22:00:14',NULL,NULL),(23198,4346,'3033593','834','00','005010X220A1','3033593','','2014-03-07','16:16:59',0,'2014-03-07 21:31:45',NULL,NULL),(23633,4441,'3057388','834','00','005010X220A1','3057388','','2014-03-10','12:36:21',0,'2014-03-10 21:01:38',NULL,NULL),(11856,1552,'173983','834','00','005010X220A1','173983','','2013-12-28','20:17:38',1,'2013-12-29 11:15:00',NULL,NULL),(19374,3590,'2739818','834','00','005010X220A1','2739818','','2014-02-13','12:17:19',0,'2014-02-13 22:02:11',NULL,NULL),(2364,413,'571081','834','00','005010X220A1','571081','','2013-12-06','07:05:51',0,'2013-12-25 20:16:08',NULL,NULL),(2714,502,'62567','834','00','005010X220A1','62567','','2013-12-22','18:22:10',0,'2013-12-25 21:17:37',NULL,NULL),(15624,2671,'1356875','834','00','005010X220A1','1356875','','2014-01-17','12:55:50',0,'2014-01-20 08:06:43',NULL,NULL),(16583,3040,'2453124','834','00','005010X220A1','2453124','','2014-01-25','10:21:33',0,'2014-01-25 19:00:13',NULL,NULL),(19228,3580,'2240934','834','00','005010X220A1','2240934','','2014-02-13','07:34:12',0,'2014-02-13 22:00:15',NULL,NULL),(4094,733,'1327042','834','00','005010X220A1','1327042','','2013-12-19','10:44:49',0,'2013-12-25 23:03:05',NULL,NULL),(5210,950,'326652','834','00','005010X220A1','326652','','2013-12-10','20:08:39',0,'2013-12-26 00:52:40',NULL,NULL),(19331,3583,'2899168','834','00','005010X220A1','2899168','','2014-02-13','13:13:29',0,'2014-02-13 22:01:37',NULL,NULL),(3050,544,'1032630','834','00','005010X220A1','1032630','','2013-12-13','13:25:56',0,'2013-12-25 21:34:36',NULL,NULL),(19336,3583,'2117548','834','00','005010X220A1','2117548','','2014-02-13','14:13:08',0,'2014-02-13 22:01:41',NULL,NULL),(753,136,'807143','834','00','005010X220A1','807143','','2013-12-16','13:27:25',0,'2013-12-25 18:08:28',NULL,NULL),(6284,1172,'1287546','834','00','005010X220A1','1287546','','2013-12-20','15:27:27',0,'2013-12-26 03:06:58',NULL,NULL),(11342,1456,'2265404','834','00','005010X220A1','2265404','','2013-12-26','17:05:26',0,'2013-12-27 02:04:47',NULL,NULL),(11849,1547,'1809170','834','00','005010X220A1','1809170','','2013-12-28','20:19:05',1,'2013-12-29 11:14:43',NULL,NULL),(1241,243,'1958580','834','00','005010X220A1','1958580','','2013-12-24','10:59:52',0,'2013-12-25 18:48:57',NULL,NULL),(1078,216,'119217','834','00','005010X220A1','119217','','2013-11-03','22:31:36',0,'2013-12-25 18:31:11',NULL,NULL),(21264,4000,'2875626','834','00','005010X220A1','2875626','','2014-02-26','16:35:56',0,'2014-02-26 21:01:58',NULL,NULL),(21359,4024,'3265282','834','00','005010X220A1','3265282','','2014-02-26','19:35:55',0,'2014-02-28 06:30:16',NULL,NULL),(12207,1615,'2354052','834','00','005010X220A1','2354052','','2013-12-31','18:59:07',1,'2014-01-02 04:21:44',NULL,NULL),(19178,3566,'2222463','834','00','005010X220A1','2222463','','2014-02-12','16:12:03',0,'2014-02-12 21:32:31',NULL,NULL),(5009,935,'909428','834','00','005010X220A1','909428','','2013-12-11','10:59:19',0,'2013-12-26 00:46:15',NULL,NULL),(16113,2805,'0001','999','BE','005010X231A1','1747511','834','2014-01-15','22:50:00',1,'2014-01-23 03:44:35',NULL,NULL),(23061,4339,'3220992','834','00','005010X220A1','3220992','','2014-03-06','23:09:10',0,'2014-03-07 21:30:07',NULL,NULL),(23320,4382,'2735458','834','00','005010X220A1','2735458','','2014-03-08','14:45:06',0,'2014-03-08 21:30:36',NULL,NULL),(2678,502,'868186','834','00','005010X220A1','868186','','2013-12-21','19:17:49',0,'2013-12-25 21:16:28',NULL,NULL),(16975,3116,'2539160','834','00','005010X220A1','2539160','','2014-01-29','17:21:25',0,'2014-01-29 21:00:38',NULL,NULL),(11311,1456,'337601','834','00','005010X220A1','337601','','2013-12-26','11:44:31',0,'2013-12-27 02:03:51',NULL,NULL),(6455,1213,'413929','834','00','005010X220A1','413929','','2013-11-22','12:57:38',0,'2013-12-26 03:16:18',NULL,NULL),(5260,970,'1133101','834','00','005010X220A1','1133101','','2013-11-11','18:07:26',0,'2013-12-26 01:00:02',NULL,NULL),(14322,2399,'2083715','834','00','005010X220A1','2083715','','2014-01-11','18:38:56',0,'2014-01-13 03:01:04',NULL,NULL),(14174,2364,'1795943','834','00','005010X220A1','1795943','','2014-01-10','13:28:52',0,'2014-01-13 02:23:24',NULL,NULL),(21175,3998,'3029444','834','00','005010X220A1','3029444','','2014-02-26','10:48:43',0,'2014-02-26 21:01:00',NULL,NULL),(21492,4030,'3431359','834','00','005010X220A1','3431359','','2014-02-26','20:09:16',0,'2014-02-28 06:31:18',NULL,NULL),(7555,1301,'701334','834','00','005010X220A1','701334','','2013-12-21','09:20:35',0,'2013-12-26 04:35:47',NULL,NULL),(3085,546,'1219241','834','00','005010X220A1','1219241','','2013-12-13','18:05:08',0,'2013-12-25 21:35:45',NULL,NULL),(3082,545,'1014033','834','00','005010X220A1','1014033','','2013-12-13','14:09:30',0,'2013-12-25 21:35:39',NULL,NULL),(14022,2337,'1673910','834','00','005010X220A1','1673910','','2014-01-08','12:07:03',0,'2014-01-13 02:21:20',NULL,NULL),(20552,3862,'3667060','834','00','005010X220A1','3667060','','2014-02-21','12:40:44',0,'2014-02-21 21:30:06',NULL,NULL),(22320,4201,'3226300','834','00','005010X220A1','3226300','','2014-03-04','17:45:19',0,'2014-03-04 21:01:12',NULL,NULL),(23696,4450,'2835690','834','00','005010X220A1','2835690','','2014-03-10','16:58:45',0,'2014-03-10 21:02:25',NULL,NULL),(23725,4461,'3025976','834','00','005010X220A1','3025976','','2014-03-10','11:40:42',0,'2014-03-10 21:02:48',NULL,NULL),(699,114,'1065610','834','00','005010X220A1','1065610','','2013-12-15','23:52:21',0,'2013-12-25 18:06:42',NULL,NULL),(18722,3485,'2807653','834','00','005010X220A1','2807653','','2014-02-11','00:18:59',0,'2014-02-11 21:00:17',NULL,NULL),(12471,1640,'1612849','834','00','005010X220A1','1612849','','2013-12-30','19:35:10',1,'2014-01-02 04:32:15',NULL,NULL),(10992,1413,'1049997','834','00','005010X220A1','1049997','','2013-12-23','12:29:19',0,'2013-12-26 13:10:28',NULL,NULL),(15736,2712,'1838628','834','00','005010X220A1','1838628','','2014-01-19','19:08:38',0,'2014-01-21 08:46:10',NULL,NULL),(3206,578,'224479','834','00','005010X220A1','224479','','2013-12-17','01:42:54',0,'2013-12-25 21:45:28',NULL,NULL),(14190,2365,'2085919','834','00','005010X220A1','2085919','','2014-01-10','11:32:20',0,'2014-01-13 02:23:36',NULL,NULL),(20649,3875,'3503873','834','00','005010X220A1','3503873','','2014-02-21','14:40:37',0,'2014-02-21 22:00:52',NULL,NULL),(200,20,'1267375','834','00','005010X220A1','1267375','','2013-12-04','22:49:56',0,'2013-12-25 17:21:15',NULL,NULL),(12517,1643,'1527605','834','00','005010X220A1','1527605','','2013-12-31','12:53:28',1,'2014-01-02 04:33:57',NULL,NULL),(19330,3583,'2307445','834','00','005010X220A1','2307445','','2014-02-13','13:11:43',0,'2014-02-13 22:01:37',NULL,NULL),(10620,1402,'850320','834','00','005010X220A1','850320','','2013-12-23','14:57:36',0,'2013-12-26 12:57:50',NULL,NULL),(17000,3118,'2037279','834','00','005010X220A1','2037279','','2014-01-29','11:52:10',0,'2014-01-29 21:00:54',NULL,NULL),(5845,1092,'329821','834','00','005010X220A1','329821','','2013-11-23','10:53:47',0,'2013-12-26 02:15:55',NULL,NULL),(5601,1044,'1998942','834','00','005010X220A1','1998942','','2013-12-24','19:11:31',0,'2013-12-26 01:49:41',NULL,NULL),(618,108,'181228','834','00','005010X220A1','181228','','2013-12-16','00:56:56',0,'2013-12-25 18:04:11',NULL,NULL),(4870,887,'1006425','834','00','005010X220A1','1006425','','2013-11-20','22:38:26',0,'2013-12-26 00:16:15',NULL,NULL),(4042,731,'998314','834','00','005010X220A1','998314','','2013-12-19','16:46:17',0,'2013-12-25 23:01:24',NULL,NULL),(2845,511,'705089','834','00','005010X220A1','705089','','2013-12-22','17:13:50',0,'2013-12-25 21:21:50',NULL,NULL),(20051,3751,'3088929','834','00','005010X220A1','3088929','','2014-02-18','17:57:35',0,'2014-02-18 22:01:08',NULL,NULL),(18922,3518,'2706163','834','00','005010X220A1','2706163','','2014-02-11','18:13:49',0,'2014-02-11 21:30:02',NULL,NULL),(16603,3047,'2282290','834','00','005010X220A1','2282290','','2014-01-26','11:45:32',0,'2014-01-26 19:00:05',NULL,NULL),(16453,3006,'2318179','834','00','005010X220A1','2318179','','2014-01-24','16:59:20',0,'2014-01-24 21:00:14',NULL,NULL),(10977,1413,'1290568','834','00','005010X220A1','1290568','','2013-12-22','19:55:41',0,'2013-12-26 13:09:58',NULL,NULL),(6210,1168,'1061970','834','00','005010X220A1','1061970','','2013-12-19','23:05:20',0,'2013-12-26 03:04:37',NULL,NULL),(15631,2675,'1976114','834','00','005010X220A1','1976114','','2014-01-18','14:37:23',0,'2014-01-21 08:44:12',NULL,NULL),(14085,2341,'1468498','834','00','005010X220A1','1468498','','2014-01-08','11:00:31',0,'2014-01-13 02:22:00',NULL,NULL),(3691,633,'78288','834','00','005010X220A1','78288','','2013-12-12','09:13:00',0,'2013-12-25 22:07:13',NULL,NULL),(3865,691,'138153','834','00','005010X220A1','138153','','2013-10-10','07:53:20',0,'2013-12-25 22:31:05',NULL,NULL),(4557,825,'1066147','834','00','005010X220A1','1066147','','2013-12-23','23:55:44',0,'2013-12-25 23:45:56',NULL,NULL),(21224,3999,'3231177','834','00','005010X220A1','3231177','','2014-02-26','08:43:01',0,'2014-02-26 21:01:32',NULL,NULL),(392,76,'1029394','834','00','005010X220A1','1029394','','2013-12-03','22:24:15',0,'2013-12-25 17:48:07',NULL,NULL),(13452,2224,'2015511','834','00','005010X220A1','2015511','','2014-01-06','11:00:40',0,'2014-01-07 04:02:50',NULL,NULL),(12287,1624,'1812257','834','00','005010X220A1','1812257','','2014-01-01','10:09:01',1,'2014-01-02 04:24:47',NULL,NULL),(17400,3198,'2303195','834','00','005010X220A1','2303195','','2014-02-01','15:04:21',0,'2014-02-01 19:00:09',NULL,NULL),(15110,2587,'1792399','834','00','005010X220A1','1792399','','2014-01-15','10:16:22',0,'2014-01-16 08:45:28',NULL,NULL),(14160,2363,'1855177','834','00','005010X220A1','1855177','','2014-01-10','09:26:58',0,'2014-01-13 02:23:12',NULL,NULL),(7147,1237,'913206','834','00','005010X220A1','913206','','2013-12-18','13:18:06',0,'2013-12-26 04:05:01',NULL,NULL),(20209,3782,'3600266','834','00','005010X220A1','3600266','','2014-02-19','11:34:08',0,'2014-02-20 04:20:07',NULL,NULL),(554,103,'1300297','834','00','005010X220A1','1300297','','2013-12-16','09:53:30',0,'2013-12-25 18:02:08',NULL,NULL),(12584,1670,'2538486','834','00','005010X220A1','2538486','','2014-01-02','09:43:50',0,'2014-01-03 02:00:32',NULL,NULL),(4827,877,'1289766','834','00','005010X220A1','1289766','','2013-11-30','18:51:09',0,'2013-12-26 00:02:42',NULL,NULL),(6197,1167,'310765','834','00','005010X220A1','310765','','2013-12-20','18:40:45',0,'2013-12-26 03:04:14',NULL,NULL),(919,177,'380729','834','00','005010X220A1','380729','','2013-12-03','17:44:44',0,'2013-12-25 18:17:38',NULL,NULL),(21345,4022,'2656969','834','00','005010X220A1','2656969','','2014-02-27','13:14:32',0,'2014-02-28 06:30:09',NULL,NULL),(21726,4088,'2721520','834','00','005010X220A1','2721520','','2014-02-28','14:57:15',0,'2014-02-28 21:30:30',NULL,NULL),(22497,4246,'3565654','834','00','005010X220A1','3565654','','2014-03-05','13:59:15',0,'2014-03-05 21:30:04',NULL,NULL),(1105,232,'216205','834','00','005010X220A1','216205','','2013-11-06','20:22:37',0,'2013-12-25 18:32:13',NULL,NULL),(19845,3692,'3177757','834','00','005010X220A1','3177757','','2014-02-14','20:17:20',0,'2014-02-15 22:02:01',NULL,NULL),(18804,3487,'2214832','834','00','005010X220A1','2214832','','2014-02-11','16:31:36',0,'2014-02-11 21:01:18',NULL,NULL),(13544,2241,'1409794','834','00','005010X220A1','1409794','','2014-01-06','11:35:21',0,'2014-01-07 04:06:11',NULL,NULL),(10561,1402,'177938','834','00','005010X220A1','177938','','2013-12-22','23:00:25',0,'2013-12-26 12:55:54',NULL,NULL),(5590,1043,'2060543','834','00','005010X220A1','2060543','','2013-12-25','00:17:33',0,'2013-12-26 01:49:20',NULL,NULL),(7250,1246,'1057168','834','00','005010X220A1','1057168','','2013-12-18','08:38:05',0,'2013-12-26 04:08:12',NULL,NULL),(5177,949,'41537','834','00','005010X220A1','41537','','2013-12-10','20:03:24',0,'2013-12-26 00:51:37',NULL,NULL),(4261,742,'741193','834','00','005010X220A1','741193','','2013-12-19','13:05:57',0,'2013-12-25 23:08:08',NULL,NULL),(1639,281,'438058','834','00','005010X220A1','438058','','2013-11-19','23:08:35',0,'2013-12-25 19:02:10',NULL,NULL),(20359,3819,'3006652','834','00','005010X220A1','3006652','','2014-02-19','17:48:15',0,'2014-02-20 04:56:31',NULL,NULL),(22058,4168,'3349311','834','00','005010X220A1','3349311','','2014-03-03','14:13:25',0,'2014-03-03 21:00:15',NULL,NULL),(22333,4203,'3227715','834','00','005010X220A1','3227715','','2014-03-04','16:04:18',0,'2014-03-04 21:01:24',NULL,NULL),(23618,4441,'3101004','834','00','005010X220A1','3101004','','2014-03-10','09:12:37',0,'2014-03-10 21:01:28',NULL,NULL),(997,185,'806762','834','00','005010X220A1','806762','','2013-12-03','09:04:22',0,'2013-12-25 18:20:10',NULL,NULL),(12613,1671,'2418772','834','00','005010X220A1','2418772','','2014-01-02','13:05:08',0,'2014-01-03 02:01:32',NULL,NULL),(19479,3620,'2846548','834','00','005010X220A1','2846548','','2014-02-13','22:43:22',0,'2014-02-14 21:30:11',NULL,NULL),(11194,1453,'1813266','834','00','005010X220A1','1813266','','2013-12-26','13:09:27',0,'2013-12-27 02:00:15',NULL,NULL),(4403,777,'248709','834','00','005010X220A1','248709','','2013-11-26','19:42:37',0,'2013-12-25 23:16:02',NULL,NULL),(5622,1045,'1103181','834','00','005010X220A1','1103181','','2013-12-24','22:00:38',0,'2013-12-26 01:50:27',NULL,NULL),(21878,4122,'2872142','834','00','005010X220A1','2872142','','2014-03-01','14:27:43',0,'2014-03-01 21:00:15',NULL,NULL),(22416,4217,'3520412','834','00','005010X220A1','3520412','','2014-03-04','10:40:43',0,'2014-03-04 21:02:34',NULL,NULL),(23573,4436,'2674118','834','00','005010X220A1','2674118','','2014-03-10','13:53:19',0,'2014-03-10 21:00:57',NULL,NULL),(1891,325,'543509','834','00','005010X220A1','543509','','2013-12-09','08:33:02',0,'2013-12-25 19:31:29',NULL,NULL),(19774,3675,'3386672','834','00','005010X220A1','3386672','','2014-02-15','10:51:21',0,'2014-02-15 22:01:01',NULL,NULL),(13698,2274,'1607922','834','00','005010X220A1','1607922','','2014-01-07','14:48:31',0,'2014-01-08 18:24:28',NULL,NULL),(11315,1456,'1940809','834','00','005010X220A1','1940809','','2013-12-26','12:45:54',0,'2013-12-27 02:03:57',NULL,NULL),(7400,1295,'510574','834','00','005010X220A1','510574','','2013-12-20','19:42:51',0,'2013-12-26 04:30:52',NULL,NULL),(4925,911,'408339','834','00','005010X220A1','408339','','2013-10-15','22:12:14',0,'2013-12-26 00:30:57',NULL,NULL),(5864,1101,'783326','834','00','005010X220A1','783326','','2013-10-28','17:08:46',0,'2013-12-26 02:16:41',NULL,NULL),(5782,1075,'53374','834','00','005010X220A1','53374','','2013-12-13','22:25:41',0,'2013-12-26 02:03:00',NULL,NULL),(2227,371,'723580','834','00','005010X220A1','723580','','2013-12-01','23:49:34',0,'2013-12-25 19:49:05',NULL,NULL),(2706,502,'1389259','834','00','005010X220A1','1389259','','2013-12-22','17:04:24',0,'2013-12-25 21:17:22',NULL,NULL),(5552,1043,'2118804','834','00','005010X220A1','2118804','','2013-12-24','18:35:15',0,'2013-12-26 01:48:07',NULL,NULL),(5354,1005,'413952','834','00','005010X220A1','413952','','2013-11-25','11:37:40',0,'2013-12-26 01:15:59',NULL,NULL),(23067,4339,'3230038','834','00','005010X220A1','3230038','','2014-03-07','01:09:20',0,'2014-03-07 21:30:11',NULL,NULL),(217,28,'8625','834','00','005010X220A1','8625','','2013-12-05','14:12:22',0,'2013-12-25 17:21:51',NULL,NULL),(11224,1454,'1403177','834','00','005010X220A1','1403177','','2013-12-26','10:32:17',0,'2013-12-27 02:01:10',NULL,NULL),(18811,3488,'2789800','834','00','005010X220A1','2789800','','2014-02-11','16:37:35',0,'2014-02-11 21:01:23',NULL,NULL),(18489,3433,'1784061','834','00','005010X220A1','1784061','','2014-02-10','04:09:18',0,'2014-02-10 11:01:06',NULL,NULL),(10713,1403,'190150','834','00','005010X220A1','190150','','2013-12-23','12:03:03',0,'2013-12-26 13:00:59',NULL,NULL),(17498,3222,'2738143','834','00','005010X220A1','2738143','','2014-02-02','10:50:26',0,'2014-02-02 19:00:23',NULL,NULL),(16613,3049,'1694284','834','00','005010X220A1','1694284','','2014-01-26','09:37:28',0,'2014-01-26 19:00:12',NULL,NULL),(10560,1402,'75895','834','00','005010X220A1','75895','','2013-12-22','22:59:05',0,'2013-12-26 12:55:52',NULL,NULL),(2657,501,'1300634','834','00','005010X220A1','1300634','','2013-12-22','12:30:53',0,'2013-12-25 21:15:38',NULL,NULL),(1413,248,'1527365','834','00','005010X220A1','1527365','','2013-12-24','07:13:29',0,'2013-12-25 18:54:27',NULL,NULL),(21161,3997,'3319360','834','00','005010X220A1','3319360','','2014-02-26','15:52:51',0,'2014-02-26 21:00:50',NULL,NULL),(21602,4064,'3030855','834','00','005010X220A1','3030855','','2014-02-26','20:06:24',0,'2014-02-28 07:30:05',NULL,NULL),(13764,2280,'1642582','834','00','005010X220A1','1642582','','2014-01-07','10:42:58',0,'2014-01-08 18:24:58',NULL,NULL),(11615,1494,'1871130','834','00','005010X220A1','1871130','','2013-12-27','12:01:15',0,'2013-12-28 03:35:12',NULL,NULL),(10930,1410,'600302','834','00','005010X220A1','600302','','2013-12-23','12:11:07',0,'2013-12-26 13:08:38',NULL,NULL),(3309,584,'449840','834','00','005010X220A1','449840','','2013-12-17','14:01:46',0,'2013-12-25 21:48:46',NULL,NULL),(16983,3117,'2433008','834','00','005010X220A1','2433008','','2014-01-29','14:59:23',0,'2014-01-29 21:00:44',NULL,NULL),(16127,2819,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:24:00',1,'2014-01-23 03:48:35',NULL,NULL),(14510,2515,'2188933','834','00','005010X220A1','2188933','','2014-01-13','17:06:31',0,'2014-01-14 01:32:09',NULL,NULL),(1650,285,'1010051','834','00','005010X220A1','1010051','','2013-11-20','14:03:10',0,'2013-12-25 19:02:29',NULL,NULL),(6105,1166,'1113463','834','00','005010X220A1','1113463','','2013-12-20','10:01:54',0,'2013-12-26 03:01:29',NULL,NULL),(1887,325,'63430','834','00','005010X220A1','63430','','2013-12-09','07:38:08',0,'2013-12-25 19:31:25',NULL,NULL),(4024,731,'239108','834','00','005010X220A1','239108','','2013-12-19','13:39:36',0,'2013-12-25 23:00:53',NULL,NULL),(20551,3862,'2155248','834','00','005010X220A1','2155248','','2014-02-20','20:52:26',0,'2014-02-21 21:30:05',NULL,NULL),(21419,4026,'2899540','834','00','005010X220A1','2899540','','2014-02-27','12:34:32',0,'2014-02-28 06:30:43',NULL,NULL),(201,20,'586298','834','00','005010X220A1','586298','','2013-12-05','13:45:25',0,'2013-12-25 17:21:17',NULL,NULL),(13124,1968,'0001','999','BE','005010X231A1','247699','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:45',NULL,NULL),(16281,2973,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','10:03:00',0,'2014-01-23 15:30:03',NULL,NULL),(2251,378,'368100','834','00','005010X220A1','368100','','2013-12-02','13:35:58',0,'2013-12-25 19:49:58',NULL,NULL),(4674,831,'1286385','834','00','005010X220A1','1286385','','2013-12-23','23:36:47',0,'2013-12-25 23:49:42',NULL,NULL),(6133,1166,'1074665','834','00','005010X220A1','1074665','','2013-12-20','15:46:23',0,'2013-12-26 03:02:21',NULL,NULL),(7301,1262,'476982','834','00','005010X220A1','476982','','2013-12-18','11:02:11',0,'2013-12-26 04:09:45',NULL,NULL),(12165,1594,'1943435','834','00','005010X220A1','1943435','','2013-12-29','23:34:00',0,'2014-01-01 12:07:56',NULL,NULL),(10396,1400,'319731','834','00','005010X220A1','319731','','2013-12-23','07:00:39',0,'2013-12-26 12:50:35',NULL,NULL),(20415,3834,'3045498','834','00','005010X220A1','3045498','','2014-02-20','14:00:56',0,'2014-02-20 21:30:15',NULL,NULL),(12262,1620,'1815952','834','00','005010X220A1','1815952','','2014-01-01','15:01:38',1,'2014-01-02 04:23:53',NULL,NULL),(19440,3602,'2975232','834','00','005010X220A1','2975232','','2014-02-13','17:02:04',0,'2014-02-13 22:02:58',NULL,NULL),(11719,1519,'1838032','834','00','005010X220A1','1838032','','2013-12-27','19:19:13',1,'2013-12-29 11:08:29',NULL,NULL),(18415,3420,'1822923','834','00','005010X220A1','1822923','','2014-02-10','00:08:00',0,'2014-02-10 11:00:05',NULL,NULL),(19838,3685,'2153731','834','00','005010X220A1','2153731','','2014-02-15','11:06:59',0,'2014-02-15 22:01:55',NULL,NULL),(21587,4056,'3170056','834','00','005010X220A1','3170056','','2014-02-26','14:11:39',0,'2014-02-28 07:00:28',NULL,NULL),(22111,4177,'3537521','834','00','005010X220A1','3537521','','2014-03-02','23:53:58',0,'2014-03-03 21:30:28',NULL,NULL),(22267,4200,'3833581','834','00','005010X220A1','3833581','','2014-03-04','13:27:24',0,'2014-03-04 21:00:34',NULL,NULL),(23099,4339,'3848470','834','00','005010X220A1','3848470','','2014-03-07','17:58:49',0,'2014-03-07 21:30:34',NULL,NULL),(270,55,'306002','834','00','005010X220A1','306002','','2013-10-11','09:11:52',0,'2013-12-25 17:31:35',NULL,NULL),(1696,292,'636230','834','00','005010X220A1','636230','','2013-12-09','20:02:57',0,'2013-12-25 19:16:22',NULL,NULL),(19052,3541,'2603631','834','00','005010X220A1','2603631','','2014-02-12','11:18:42',0,'2014-02-12 21:31:02',NULL,NULL),(10383,1400,'940796','834','00','005010X220A1','940796','','2013-12-22','22:01:00',0,'2013-12-26 12:50:11',NULL,NULL),(21329,4021,'3245939','834','00','005010X220A1','3245939','','2014-02-26','17:47:41',0,'2014-02-26 21:02:47',NULL,NULL),(19183,3569,'2037653','834','00','005010X220A1','2037653','','2014-02-12','22:36:24',0,'2014-02-13 21:30:04',NULL,NULL),(5396,1018,'252614','834','00','005010X220A1','252614','','2013-11-13','18:23:54',0,'2013-12-26 01:30:02',NULL,NULL),(13971,2322,'1838314','834','00','005010X220A1','1838314','','2014-01-09','13:42:32',0,'2014-01-13 02:20:36',NULL,NULL),(12174,1595,'2365343','834','00','005010X220A1','2365343','','2013-12-30','09:34:49',0,'2014-01-01 12:08:17',NULL,NULL),(11136,1432,'1377611','834','00','005010X220A1','1377611','','2013-12-22','23:54:23',0,'2013-12-26 13:15:26',NULL,NULL),(2597,483,'231159','834','00','005010X220A1','231159','','2013-10-05','19:40:22',0,'2013-12-25 20:45:56',NULL,NULL),(2311,403,'1117840','834','00','005010X220A1','1117840','','2013-11-02','07:44:22',0,'2013-12-25 20:01:37',NULL,NULL),(11595,1493,'2230012','834','00','005010X220A1','2230012','','2013-12-26','20:06:18',0,'2013-12-28 03:34:35',NULL,NULL),(11973,1580,'573533','834','00','005010X220A1','573533','','2013-12-30','14:16:10',0,'2014-01-01 12:01:05',NULL,NULL),(933,181,'646078','834','00','005010X220A1','646078','','2013-12-02','21:33:04',0,'2013-12-25 18:18:08',NULL,NULL),(1903,325,'19532','834','00','005010X220A1','19532','','2013-12-09','12:39:56',0,'2013-12-25 19:31:51',NULL,NULL),(4761,859,'1252544','834','00','005010X220A1','1252544','','2013-12-01','14:55:51',0,'2013-12-26 00:00:41',NULL,NULL),(10803,1404,'322420','834','00','005010X220A1','322420','','2013-12-23','14:49:12',0,'2013-12-26 13:03:57',NULL,NULL),(7335,1277,'1157800','834','00','005010X220A1','1157800','','2013-12-18','17:20:45',0,'2013-12-26 04:10:48',NULL,NULL),(15394,2625,'2499064','834','00','005010X220A1','2499064','','2014-01-16','12:04:24',0,'2014-01-17 03:35:44',NULL,NULL),(15277,2609,'1555512','834','00','005010X220A1','1555512','','2014-01-15','10:56:09',0,'2014-01-16 08:47:16',NULL,NULL),(14237,2371,'2466960','834','00','005010X220A1','2466960','','2014-01-10','14:05:08',0,'2014-01-13 02:24:08',NULL,NULL),(1338,245,'1850262','834','00','005010X220A1','1850262','','2013-12-24','12:39:47',0,'2013-12-25 18:52:00',NULL,NULL),(17219,3153,'1462648','834','00','005010X220A1','1462648','','2014-01-29','20:36:57',0,'2014-01-30 21:01:21',NULL,NULL),(11351,1458,'1611497','834','00','005010X220A1','1611497','','2013-12-25','22:18:54',0,'2013-12-27 02:05:04',NULL,NULL),(11829,1541,'1470489','834','00','005010X220A1','1470489','','2013-12-28','20:13:05',1,'2013-12-29 11:14:01',NULL,NULL),(2183,363,'1303592','834','00','005010X220A1','1303592','','2013-12-02','17:24:39',0,'2013-12-25 19:47:35',NULL,NULL),(7375,1292,'1006483','834','00','005010X220A1','1006483','','2013-11-30','18:00:31',0,'2013-12-26 04:16:25',NULL,NULL),(12876,1706,'1376627','834','00','005010X220A1','1376627','','2014-01-03','14:21:18',0,'2014-01-04 02:03:59',NULL,NULL),(3429,597,'91326','834','00','005010X220A1','91326','','2013-12-17','07:29:55',0,'2013-12-25 21:52:36',NULL,NULL),(5434,1032,'282935','834','00','005010X220A1','282935','','2013-10-05','17:46:14',0,'2013-12-26 01:31:27',NULL,NULL),(4083,733,'1143420','834','00','005010X220A1','1143420','','2013-12-19','09:49:26',0,'2013-12-25 23:02:46',NULL,NULL),(13502,2231,'1969209','834','00','005010X220A1','1969209','','2014-01-06','13:51:53',0,'2014-01-07 04:04:45',NULL,NULL),(19655,3650,'2581765','834','00','005010X220A1','2581765','','2014-02-14','08:38:32',0,'2014-02-14 21:32:18',NULL,NULL),(15184,2591,'1608188','834','00','005010X220A1','1608188','','2014-01-15','17:17:45',0,'2014-01-16 08:46:15',NULL,NULL),(20608,3870,'3188340','834','00','005010X220A1','3188340','','2014-02-21','17:39:16',0,'2014-02-21 22:00:22',NULL,NULL),(22063,4168,'3795536','834','00','005010X220A1','3795536','','2014-03-03','15:40:36',0,'2014-03-03 21:00:19',NULL,NULL),(787,146,'521851','834','00','005010X220A1','521851','','2013-10-28','19:06:34',0,'2013-12-25 18:09:42',NULL,NULL),(4477,802,'669178','834','00','005010X220A1','669178','','2013-11-26','11:09:44',0,'2013-12-25 23:31:18',NULL,NULL),(3090,546,'100132','834','00','005010X220A1','100132','','2013-12-12','20:27:54',0,'2013-12-25 21:35:54',NULL,NULL),(3666,627,'620659','834','00','005010X220A1','620659','','2013-12-11','20:56:29',0,'2013-12-25 22:06:24',NULL,NULL),(13385,2221,'2236587','834','00','005010X220A1','2236587','','2014-01-06','10:54:47',0,'2014-01-07 04:00:20',NULL,NULL),(16330,2983,'2370468','834','00','005010X220A1','2370468','','2014-01-22','22:03:41',0,'2014-01-23 21:00:35',NULL,NULL),(21158,3997,'2758988','834','00','005010X220A1','2758988','','2014-02-26','14:51:45',0,'2014-02-26 21:00:48',NULL,NULL),(23442,4407,'2834437','834','00','005010X220A1','2834437','','2014-03-09','14:40:59',0,'2014-03-09 21:00:43',NULL,NULL),(14361,2404,'2449019','834','00','005010X220A1','2449019','','2014-01-12','10:07:59',0,'2014-01-13 03:01:34',NULL,NULL),(15162,2588,'1875614','834','00','005010X220A1','1875614','','2014-01-15','15:26:34',0,'2014-01-16 08:46:02',NULL,NULL),(18897,3501,'2678186','834','00','005010X220A1','2678186','','2014-02-11','11:31:22',0,'2014-02-11 21:02:33',NULL,NULL),(4452,801,'622683','834','00','005010X220A1','622683','','2013-11-25','22:26:49',0,'2013-12-25 23:30:30',NULL,NULL),(16412,2996,'1918315','834','00','005010X220A1','1918315','','2014-01-23','16:25:32',0,'2014-01-23 21:01:29',NULL,NULL),(17940,3299,'2367448','834','00','005010X220A1','2367448','','2014-02-04','20:13:25',0,'2014-02-05 21:30:49',NULL,NULL),(7153,1238,'193819','834','00','005010X220A1','193819','','2013-12-17','18:45:36',0,'2013-12-26 04:05:09',NULL,NULL),(2002,330,'1300062','834','00','005010X220A1','1300062','','2013-12-08','21:08:20',0,'2013-12-25 19:34:55',NULL,NULL),(40,2,'557030','834','00','005010X220A1','557030','','2013-12-04','18:21:19',0,'2013-12-25 17:16:10',NULL,NULL),(517,102,'319330','834','00','005010X220A1','319330','','2013-12-16','12:34:53',0,'2013-12-25 18:00:58',NULL,NULL),(1254,243,'1428345','834','00','005010X220A1','1428345','','2013-12-24','12:27:00',0,'2013-12-25 18:49:19',NULL,NULL),(966,182,'495125','834','00','005010X220A1','495125','','2013-12-03','13:04:50',0,'2013-12-25 18:19:10',NULL,NULL),(7318,1267,'821357','834','00','005010X220A1','821357','','2013-12-18','12:57:36',0,'2013-12-26 04:10:15',NULL,NULL),(19671,3659,'2963680','834','00','005010X220A1','2963680','','2014-02-13','23:40:35',0,'2014-02-14 22:00:03',NULL,NULL),(7156,1238,'196324','834','00','005010X220A1','196324','','2013-12-17','20:43:32',0,'2013-12-26 04:05:17',NULL,NULL),(15255,2600,'2310385','834','00','005010X220A1','2310385','','2014-01-15','17:38:34',0,'2014-01-16 08:47:00',NULL,NULL),(1772,298,'1078095','834','00','005010X220A1','1078095','','2013-12-09','21:46:41',0,'2013-12-25 19:18:40',NULL,NULL),(3414,592,'630723','834','00','005010X220A1','630723','','2013-12-17','10:25:59',0,'2013-12-25 21:52:10',NULL,NULL),(6259,1172,'1061966','834','00','005010X220A1','1061966','','2013-12-19','21:39:07',0,'2013-12-26 03:06:10',NULL,NULL),(6061,1164,'249364','834','00','005010X220A1','249364','','2013-12-19','19:31:08',0,'2013-12-26 03:00:04',NULL,NULL),(2538,457,'1125574','834','00','005010X220A1','1125574','','2013-11-17','20:56:04',0,'2013-12-25 20:31:09',NULL,NULL),(4346,759,'1131261','834','00','005010X220A1','1131261','','2013-12-19','09:32:45',0,'2013-12-25 23:10:38',NULL,NULL),(4562,825,'1527360','834','00','005010X220A1','1527360','','2013-12-24','01:04:15',0,'2013-12-25 23:46:05',NULL,NULL),(7486,1298,'171170','834','00','005010X220A1','171170','','2013-12-20','19:34:56',0,'2013-12-26 04:33:33',NULL,NULL),(18647,3464,'2362283','834','00','005010X220A1','2362283','','2014-02-09','23:09:37',0,'2014-02-10 21:31:37',NULL,NULL),(11800,1538,'545715','834','00','005010X220A1','545715','','2013-12-28','20:25:15',1,'2013-12-29 11:13:07',NULL,NULL),(12681,1673,'1629747','834','00','005010X220A1','1629747','','2014-01-02','13:10:44',0,'2014-01-03 02:04:02',NULL,NULL),(15286,2614,'2394026','834','00','005010X220A1','2394026','','2014-01-15','12:35:40',0,'2014-01-16 08:47:22',NULL,NULL),(22036,4163,'3599251','834','00','005010X220A1','3599251','','2014-03-03','08:58:13',0,'2014-03-03 21:00:02',NULL,NULL),(284,61,'327372','834','00','005010X220A1','327372','','2013-11-09','00:22:52',0,'2013-12-25 17:32:08',NULL,NULL),(18531,3451,'2384607','834','00','005010X220A1','2384607','','2014-02-10','13:33:52',0,'2014-02-10 21:30:16',NULL,NULL),(360,72,'467373','834','00','005010X220A1','467373','','2013-12-04','11:00:17',0,'2013-12-25 17:47:05',NULL,NULL),(5598,1043,'2116319','834','00','005010X220A1','2116319','','2013-12-25','18:14:45',0,'2013-12-26 01:49:35',NULL,NULL),(5380,1011,'477612','834','00','005010X220A1','477612','','2013-11-25','17:52:09',0,'2013-12-26 01:16:53',NULL,NULL),(7401,1295,'1297901','834','00','005010X220A1','1297901','','2013-12-20','19:53:35',0,'2013-12-26 04:30:54',NULL,NULL),(1518,259,'675450','834','00','005010X220A1','675450','','2013-12-24','15:38:52',0,'2013-12-25 18:57:58',NULL,NULL),(21612,4065,'2959951','834','00','005010X220A1','2959951','','2014-02-26','18:46:55',0,'2014-02-28 07:30:14',NULL,NULL),(2455,422,'1206246','834','00','005010X220A1','1206246','','2013-12-06','17:24:01',0,'2013-12-25 20:19:01',NULL,NULL),(10614,1402,'268985','834','00','005010X220A1','268985','','2013-12-23','14:22:27',0,'2013-12-26 12:57:38',NULL,NULL),(10735,1403,'797477','834','00','005010X220A1','797477','','2013-12-23','15:16:42',0,'2013-12-26 13:01:44',NULL,NULL),(10760,1403,'1030200','834','00','005010X220A1','1030200','','2013-12-23','07:13:00',0,'2013-12-26 13:02:35',NULL,NULL),(16482,3010,'2116135','834','00','005010X220A1','2116135','','2014-01-24','15:20:35',0,'2014-01-24 21:00:30',NULL,NULL),(11203,1454,'1935956','834','00','005010X220A1','1935956','','2013-12-25','21:59:13',0,'2013-12-27 02:00:32',NULL,NULL),(12582,1670,'2495972','834','00','005010X220A1','2495972','','2014-01-02','06:13:17',0,'2014-01-03 02:00:27',NULL,NULL),(12706,1677,'2426537','834','00','005010X220A1','2426537','','2014-01-02','14:21:00',0,'2014-01-03 02:04:59',NULL,NULL),(14162,2363,'1645423','834','00','005010X220A1','1645423','','2014-01-10','11:21:32',0,'2014-01-13 02:23:13',NULL,NULL),(13775,2286,'1793333','834','00','005010X220A1','1793333','','2014-01-07','11:34:10',0,'2014-01-08 18:25:03',NULL,NULL),(12825,1704,'1827821','834','00','005010X220A1','1827821','','2014-01-03','07:25:04',0,'2014-01-04 02:02:09',NULL,NULL),(23289,4380,'3826325','834','00','005010X220A1','3826325','','2014-03-08','14:17:20',0,'2014-03-08 21:30:12',NULL,NULL),(4691,833,'354620','834','00','005010X220A1','354620','','2013-12-24','01:05:43',0,'2013-12-25 23:50:21',NULL,NULL),(20292,3794,'2452381','834','00','005010X220A1','2452381','','2014-02-19','11:36:05',0,'2014-02-20 04:41:01',NULL,NULL),(20049,3751,'2603837','834','00','005010X220A1','2603837','','2014-02-18','16:18:01',0,'2014-02-18 22:01:07',NULL,NULL),(4561,825,'640535','834','00','005010X220A1','640535','','2013-12-24','00:44:02',0,'2013-12-25 23:46:03',NULL,NULL),(14775,2551,'2164897','834','00','005010X220A1','2164897','','2014-01-14','12:52:38',0,'2014-01-15 02:06:34',NULL,NULL),(14215,2366,'2247171','834','00','005010X220A1','2247171','','2014-01-09','19:15:11',0,'2014-01-13 02:23:54',NULL,NULL),(7362,1285,'708154','834','00','005010X220A1','708154','','2013-11-30','13:28:23',0,'2013-12-26 04:15:55',NULL,NULL),(10423,1400,'1642059','834','00','005010X220A1','1642059','','2013-12-23','10:29:18',0,'2013-12-26 12:51:24',NULL,NULL),(22475,4239,'2677675','834','00','005010X220A1','2677675','','2014-03-05','09:03:23',0,'2014-03-05 21:00:20',NULL,NULL),(25,1,'1190733','834','00','005010X220A1','1190733','','2013-12-05','14:59:20',0,'2013-12-25 17:15:46',NULL,NULL),(1942,326,'140799','834','00','005010X220A1','140799','','2013-12-09','10:26:19',0,'2013-12-25 19:32:59',NULL,NULL),(6288,1172,'136874','834','00','005010X220A1','136874','','2013-12-20','17:20:47',0,'2013-12-26 03:07:04',NULL,NULL),(10604,1402,'1454442','834','00','005010X220A1','1454442','','2013-12-23','13:11:32',0,'2013-12-26 12:57:19',NULL,NULL),(17861,3293,'1415785','834','00','005010X220A1','1415785','','2014-02-05','11:23:18',0,'2014-02-05 21:30:11',NULL,NULL),(16900,3101,'2674444','834','00','005010X220A1','2674444','','2014-01-28','17:04:48',0,'2014-01-28 21:01:13',NULL,NULL),(11495,1489,'1373902','834','00','005010X220A1','1373902','','2013-12-27','06:35:40',0,'2013-12-28 03:31:30',NULL,NULL),(21826,4098,'2964069','834','00','005010X220A1','2964069','','2014-02-28','10:20:34',0,'2014-02-28 21:31:40',NULL,NULL),(22136,4179,'3303760','834','00','005010X220A1','3303760','','2014-03-03','12:00:06',0,'2014-03-03 21:30:45',NULL,NULL),(23753,4474,'3264327','834','00','005010X220A1','3264327','','2014-03-10','10:41:32',0,'2014-03-10 21:30:05',NULL,NULL),(2283,394,'951241','834','00','005010X220A1','951241','','2013-11-23','18:36:59',0,'2013-12-25 20:00:35',NULL,NULL),(6426,1203,'1146824','834','00','005010X220A1','1146824','','2013-11-22','14:25:35',0,'2013-12-26 03:15:20',NULL,NULL),(19886,3710,'3468744','834','00','005010X220A1','3468744','','2014-02-16','10:46:52',0,'2014-02-16 19:00:29',NULL,NULL),(19213,3579,'2733363','834','00','005010X220A1','2733363','','2014-02-13','15:49:02',0,'2014-02-13 21:30:18',NULL,NULL),(6363,1182,'1042137','834','00','005010X220A1','1042137','','2013-12-19','21:25:44',0,'2013-12-26 03:09:18',NULL,NULL),(19193,3571,'2615448','834','00','005010X220A1','2615448','','2014-02-13','11:15:38',0,'2014-02-13 21:30:08',NULL,NULL),(17946,3299,'2759801','834','00','005010X220A1','2759801','','2014-02-05','11:14:23',0,'2014-02-05 21:30:52',NULL,NULL),(2893,530,'1394148','834','00','005010X220A1','1394148','','2013-12-22','18:15:57',0,'2013-12-25 21:23:28',NULL,NULL),(15787,2719,'2256811','834','00','005010X220A1','2256811','','2014-01-19','22:27:30',0,'2014-01-21 08:46:40',NULL,NULL),(15253,2600,'1983392','834','00','005010X220A1','1983392','','2014-01-15','15:59:24',0,'2014-01-16 08:46:59',NULL,NULL),(5185,949,'466186','834','00','005010X220A1','466186','','2013-12-10','23:16:47',0,'2013-12-26 00:51:52',NULL,NULL),(3425,595,'1300350','834','00','005010X220A1','1300350','','2013-12-17','07:29:55',0,'2013-12-25 21:52:30',NULL,NULL),(12540,1650,'1978014','834','00','005010X220A1','1978014','','2013-12-31','10:34:25',1,'2014-01-02 04:34:51',NULL,NULL),(11081,1422,'785922','834','00','005010X220A1','785922','','2013-12-23','18:05:52',0,'2013-12-26 13:13:29',NULL,NULL),(23430,4405,'3522876','834','00','005010X220A1','3522876','','2014-03-09','13:37:36',0,'2014-03-09 21:00:33',NULL,NULL),(6453,1211,'297739','834','00','005010X220A1','297739','','2013-11-22','10:39:23',0,'2013-12-26 03:16:13',NULL,NULL),(20473,3842,'2852784','834','00','005010X220A1','2852784','','2014-02-20','15:07:06',0,'2014-02-20 22:00:41',NULL,NULL),(6032,1143,'1017245','834','00','005010X220A1','1017245','','2013-11-17','10:24:55',0,'2013-12-26 02:45:56',NULL,NULL),(14990,2582,'1376933','834','00','005010X220A1','1376933','','2014-01-14','17:22:33',0,'2014-01-15 02:08:12',NULL,NULL),(16766,3071,'2047412','834','00','005010X220A1','2047412','','2014-01-27','11:33:14',0,'2014-01-27 21:01:30',NULL,NULL),(17442,3205,'2223574','834','00','005010X220A1','2223574','','2014-02-01','13:40:23',0,'2014-02-01 19:00:35',NULL,NULL),(21147,3997,'3107949','834','00','005010X220A1','3107949','','2014-02-26','09:41:48',0,'2014-02-26 21:00:42',NULL,NULL),(21667,4077,'3501235','834','00','005010X220A1','3501235','','2014-02-28','17:48:09',0,'2014-02-28 21:00:12',NULL,NULL),(22795,4277,'3442655','834','00','005010X220A1','3442655','','2014-03-06','17:07:52',0,'2014-03-06 21:01:01',NULL,NULL),(2253,378,'37728','834','00','005010X220A1','37728','','2013-12-02','16:34:08',0,'2013-12-25 19:50:01',NULL,NULL),(3211,578,'1219338','834','00','005010X220A1','1219338','','2013-12-17','08:39:49',0,'2013-12-25 21:45:39',NULL,NULL),(2356,413,'649977','834','00','005010X220A1','649977','','2013-12-06','17:44:09',0,'2013-12-25 20:15:49',NULL,NULL),(10431,1400,'1488265','834','00','005010X220A1','1488265','','2013-12-23','11:11:42',0,'2013-12-26 12:51:39',NULL,NULL),(10973,1412,'1291761','834','00','005010X220A1','1291761','','2013-12-22','19:08:54',0,'2013-12-26 13:09:51',NULL,NULL),(16152,2844,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',1,'2014-01-23 04:06:35',NULL,NULL),(12178,1597,'1385643','834','00','005010X220A1','1385643','','2013-12-30','06:33:18',0,'2014-01-01 12:08:26',NULL,NULL),(15006,2584,'1621058','834','00','005010X220A1','1621058','','2014-01-14','23:30:59',0,'2014-01-16 08:44:21',NULL,NULL),(12481,1640,'2508083','834','00','005010X220A1','2508083','','2013-12-31','14:25:15',1,'2014-01-02 04:32:32',NULL,NULL),(12659,1672,'2564455','834','00','005010X220A1','2564455','','2014-01-02','17:52:19',0,'2014-01-03 02:03:17',NULL,NULL),(23397,4403,'3656211','834','00','005010X220A1','3656211','','2014-03-09','09:49:46',0,'2014-03-09 21:00:09',NULL,NULL),(238,40,'664198','834','00','005010X220A1','664198','','2013-10-12','14:50:40',0,'2013-12-25 17:30:27',NULL,NULL),(20631,3873,'2946360','834','00','005010X220A1','2946360','','2014-02-20','23:16:07',0,'2014-02-21 22:00:39',NULL,NULL),(19885,3710,'3282788','834','00','005010X220A1','3282788','','2014-02-16','01:05:11',0,'2014-02-16 19:00:28',NULL,NULL),(1278,243,'1263566','834','00','005010X220A1','1263566','','2013-12-24','16:23:24',0,'2013-12-25 18:50:06',NULL,NULL),(19180,3568,'3013880','834','00','005010X220A1','3013880','','2014-02-12','19:12:16',0,'2014-02-13 21:30:03',NULL,NULL),(18951,3529,'2384665','834','00','005010X220A1','2384665','','2014-02-11','19:17:07',0,'2014-02-12 21:00:03',NULL,NULL),(1629,281,'465873','834','00','005010X220A1','465873','','2013-11-19','23:06:23',0,'2013-12-25 19:01:55',NULL,NULL),(13957,2321,'1482901','834','00','005010X220A1','1482901','','2014-01-08','22:43:44',0,'2014-01-13 02:20:25',NULL,NULL),(2968,541,'851181','834','00','005010X220A1','851181','','2013-12-13','14:26:56',0,'2013-12-25 21:32:09',NULL,NULL),(7716,1334,'317515','834','00','005010X220A1','317515','','2013-11-15','16:27:59',0,'2013-12-26 04:45:59',NULL,NULL),(11656,1500,'2204597','834','00','005010X220A1','2204597','','2013-12-27','12:07:48',0,'2013-12-28 03:36:28',NULL,NULL),(2397,414,'254062','834','00','005010X220A1','254062','','2013-12-05','18:44:09',0,'2013-12-25 20:17:06',NULL,NULL),(19511,3622,'2862787','834','00','005010X220A1','2862787','','2014-02-13','19:08:07',0,'2014-02-14 21:30:33',NULL,NULL),(5187,949,'239994','834','00','005010X220A1','239994','','2013-12-11','10:44:02',0,'2013-12-26 00:51:57',NULL,NULL),(17873,3293,'2595567','834','00','005010X220A1','2595567','','2014-02-05','16:54:56',0,'2014-02-05 21:30:17',NULL,NULL),(7671,1319,'1361217','834','00','005010X220A1','1361217','','2013-12-21','12:03:14',0,'2013-12-26 04:39:32',NULL,NULL),(10786,1404,'8104','834','00','005010X220A1','8104','','2013-12-23','11:25:09',0,'2013-12-26 13:03:26',NULL,NULL),(14272,2375,'2407812','834','00','005010X220A1','2407812','','2014-01-10','14:37:34',0,'2014-01-13 03:00:11',NULL,NULL),(13534,2241,'2533479','834','00','005010X220A1','2533479','','2014-01-06','13:07:30',0,'2014-01-07 04:05:53',NULL,NULL),(21364,4024,'3693303','834','00','005010X220A1','3693303','','2014-02-26','23:18:08',0,'2014-02-28 06:30:18',NULL,NULL),(22705,4264,'3639335','834','00','005010X220A1','3639335','','2014-03-05','11:03:54',0,'2014-03-05 21:32:31',NULL,NULL),(510,102,'989257','834','00','005010X220A1','989257','','2013-12-16','11:27:40',0,'2013-12-25 18:00:46',NULL,NULL),(973,184,'1071666','834','00','005010X220A1','1071666','','2013-12-02','21:19:57',0,'2013-12-25 18:19:23',NULL,NULL),(984,184,'244976','834','00','005010X220A1','244976','','2013-12-03','13:15:01',0,'2013-12-25 18:19:42',NULL,NULL),(5161,944,'250069','834','00','005010X220A1','250069','','2013-12-11','15:06:52',0,'2013-12-26 00:51:07',NULL,NULL),(5127,943,'1015103','834','00','005010X220A1','1015103','','2013-12-10','20:22:50',0,'2013-12-26 00:50:07',NULL,NULL),(1823,312,'617704','834','00','005010X220A1','617704','','2013-12-10','16:37:09',0,'2013-12-25 19:20:20',NULL,NULL),(4705,834,'350934','834','00','005010X220A1','350934','','2013-12-24','00:22:20',0,'2013-12-25 23:50:48',NULL,NULL),(2289,395,'515903','834','00','005010X220A1','515903','','2013-11-24','16:27:55',0,'2013-12-25 20:00:48',NULL,NULL),(13983,2325,'1531975','834','00','005010X220A1','1531975','','2014-01-09','11:05:44',0,'2014-01-13 02:20:45',NULL,NULL),(3869,693,'965120','834','00','005010X220A1','965120','','2013-10-10','01:38:25',0,'2013-12-25 22:31:12',NULL,NULL),(3228,578,'141098','834','00','005010X220A1','141098','','2013-12-17','11:34:25',0,'2013-12-25 21:46:10',NULL,NULL),(22784,4277,'2808418','834','00','005010X220A1','2808418','','2014-03-06','13:28:06',0,'2014-03-06 21:00:54',NULL,NULL),(28,1,'573975','834','00','005010X220A1','573975','','2013-12-05','12:35:45',0,'2013-12-25 17:15:50',NULL,NULL),(609,108,'45582','834','00','005010X220A1','45582','','2013-12-15','20:31:18',0,'2013-12-25 18:03:53',NULL,NULL),(1849,324,'198848','834','00','005010X220A1','198848','','2013-12-09','00:03:00',0,'2013-12-25 19:30:09',NULL,NULL),(23494,4433,'3696978','834','00','005010X220A1','3696978','','2014-03-09','16:40:13',0,'2014-03-09 21:30:07',NULL,NULL),(1326,245,'1599677','834','00','005010X220A1','1599677','','2013-12-24','11:30:33',0,'2013-12-25 18:51:38',NULL,NULL),(17476,3218,'2189433','834','00','005010X220A1','2189433','','2014-02-02','10:56:24',0,'2014-02-02 19:00:10',NULL,NULL),(14523,2518,'2274779','834','00','005010X220A1','2274779','','2014-01-12','21:00:14',0,'2014-01-14 01:32:17',NULL,NULL),(14358,2404,'1740574','834','00','005010X220A1','1740574','','2014-01-12','10:03:40',0,'2014-01-13 03:01:32',NULL,NULL),(3491,615,'384495','834','00','005010X220A1','384495','','2013-12-12','11:46:50',0,'2013-12-25 22:00:53',NULL,NULL),(17848,3291,'2507677','834','00','005010X220A1','2507677','','2014-02-04','19:31:43',0,'2014-02-05 21:30:04',NULL,NULL),(18765,3485,'1831022','834','00','005010X220A1','1831022','','2014-02-11','17:31:26',0,'2014-02-11 21:00:49',NULL,NULL),(19772,3675,'3521218','834','00','005010X220A1','3521218','','2014-02-15','10:51:11',0,'2014-02-15 22:01:00',NULL,NULL),(20312,3796,'2720209','834','00','005010X220A1','2720209','','2014-02-19','12:55:08',0,'2014-02-20 04:46:12',NULL,NULL),(21605,4064,'3314950','834','00','005010X220A1','3314950','','2014-02-27','10:55:32',0,'2014-02-28 07:30:08',NULL,NULL),(23446,4408,'3166835','834','00','005010X220A1','3166835','','2014-03-09','10:14:31',0,'2014-03-09 21:00:47',NULL,NULL),(11539,1491,'1883684','834','00','005010X220A1','1883684','','2013-12-26','18:48:51',0,'2013-12-28 03:32:49',NULL,NULL),(1485,254,'1736015','834','00','005010X220A1','1736015','','2013-12-24','08:48:28',0,'2013-12-25 18:56:56',NULL,NULL),(16338,2983,'2134588','834','00','005010X220A1','2134588','','2014-01-23','13:52:27',0,'2014-01-23 21:00:41',NULL,NULL),(15279,2610,'1659406','834','00','005010X220A1','1659406','','2014-01-15','11:30:15',0,'2014-01-16 08:47:17',NULL,NULL),(14869,2555,'1430344','834','00','005010X220A1','1430344','','2014-01-14','00:17:53',0,'2014-01-15 02:07:15',NULL,NULL),(14601,2521,'1838405','834','00','005010X220A1','1838405','','2014-01-13','14:46:58',0,'2014-01-14 01:33:07',NULL,NULL),(2603,483,'366647','834','00','005010X220A1','366647','','2013-10-06','12:16:25',0,'2013-12-25 20:46:05',NULL,NULL),(12834,1704,'1712868','834','00','005010X220A1','1712868','','2014-01-03','13:16:10',0,'2014-01-04 02:02:29',NULL,NULL),(18622,3459,'1922432','834','00','005010X220A1','1922432','','2014-02-09','19:44:58',0,'2014-02-10 21:31:19',NULL,NULL),(18823,3490,'2739734','834','00','005010X220A1','2739734','','2014-02-11','08:41:13',0,'2014-02-11 21:01:33',NULL,NULL),(18960,3534,'2553618','834','00','005010X220A1','2553618','','2014-02-12','11:51:50',0,'2014-02-12 21:00:12',NULL,NULL),(21880,4122,'3580436','834','00','005010X220A1','3580436','','2014-03-01','17:21:01',0,'2014-03-01 21:00:16',NULL,NULL),(22176,4180,'2771984','834','00','005010X220A1','2771984','','2014-03-03','15:38:08',0,'2014-03-03 21:31:14',NULL,NULL),(23299,4381,'2772195','834','00','005010X220A1','2772195','','2014-03-07','22:58:33',0,'2014-03-08 21:30:20',NULL,NULL),(23566,4436,'3134524','834','00','005010X220A1','3134524','','2014-03-10','11:21:45',0,'2014-03-10 21:00:52',NULL,NULL),(42,2,'762182','834','00','005010X220A1','762182','','2013-12-05','14:55:38',0,'2013-12-25 17:16:15',NULL,NULL),(15326,2622,'1820324','834','00','005010X220A1','1820324','','2014-01-16','14:31:25',0,'2014-01-17 03:35:13',NULL,NULL),(13669,2271,'1404742','834','00','005010X220A1','1404742','','2014-01-07','11:54:07',0,'2014-01-08 18:24:17',NULL,NULL),(13554,2247,'2194997','834','00','005010X220A1','2194997','','2014-01-06','09:56:29',0,'2014-01-07 04:06:40',NULL,NULL),(12637,1672,'2129192','834','00','005010X220A1','2129192','','2014-01-02','12:25:37',0,'2014-01-03 02:02:24',NULL,NULL),(963,181,'449392','834','00','005010X220A1','449392','','2013-12-03','17:31:39',0,'2013-12-25 18:19:03',NULL,NULL),(6454,1212,'1212490','834','00','005010X220A1','1212490','','2013-11-22','12:27:24',0,'2013-12-26 03:16:15',NULL,NULL),(1136,238,'2010816','834','00','005010X220A1','2010816','','2013-12-24','17:22:33',0,'2013-12-25 18:45:46',NULL,NULL),(1143,239,'592814','834','00','005010X220A1','592814','','2013-12-24','08:31:51',0,'2013-12-25 18:46:00',NULL,NULL),(1612,281,'873219','834','00','005010X220A1','873219','','2013-11-19','23:01:10',0,'2013-12-25 19:01:31',NULL,NULL),(18822,3490,'3133710','834','00','005010X220A1','3133710','','2014-02-10','23:22:02',0,'2014-02-11 21:01:32',NULL,NULL),(19527,3622,'2724870','834','00','005010X220A1','2724870','','2014-02-14','13:28:32',0,'2014-02-14 21:30:45',NULL,NULL),(21324,4017,'2985525','834','00','005010X220A1','2985525','','2014-02-26','16:00:34',0,'2014-02-26 21:02:43',NULL,NULL),(23495,4434,'2616194','834','00','005010X220A1','2616194','','2014-03-09','18:20:52',0,'2014-03-10 20:59:59',NULL,NULL),(4180,734,'1059761','834','00','005010X220A1','1059761','','2013-12-19','13:21:59',0,'2013-12-25 23:05:35',NULL,NULL),(17409,3199,'1864043','834','00','005010X220A1','1864043','','2014-01-31','18:41:23',0,'2014-02-01 19:00:16',NULL,NULL),(16156,2848,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:27:00',1,'2014-01-23 04:07:28',NULL,NULL),(13947,2319,'1936277','834','00','005010X220A1','1936277','','2014-01-08','20:53:20',0,'2014-01-13 02:20:18',NULL,NULL),(15715,2707,'2428321','834','00','005010X220A1','2428321','','2014-01-19','17:42:13',0,'2014-01-21 08:45:40',NULL,NULL),(15316,2622,'1574515','834','00','005010X220A1','1574515','','2014-01-16','01:25:10',0,'2014-01-17 03:35:08',NULL,NULL),(23293,4380,'2960311','834','00','005010X220A1','2960311','','2014-03-08','15:31:34',0,'2014-03-08 21:30:14',NULL,NULL),(11762,1525,'1857332','834','00','005010X220A1','1857332','','2013-12-28','14:13:07',1,'2013-12-29 11:09:47',NULL,NULL),(180,16,'200942','834','00','005010X220A1','200942','','2013-12-05','06:04:20',0,'2013-12-25 17:20:35',NULL,NULL),(363,72,'658045','834','00','005010X220A1','658045','','2013-12-04','11:15:04',0,'2013-12-25 17:47:10',NULL,NULL),(6996,1235,'539833','834','00','005010X220A1','539833','','2013-12-17','19:02:59',0,'2013-12-26 04:00:20',NULL,NULL),(959,181,'898014','834','00','005010X220A1','898014','','2013-12-03','16:46:06',0,'2013-12-25 18:18:54',NULL,NULL),(14452,2473,'0001','999','BE','005010X231A1','790585','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:26',NULL,NULL),(14723,2550,'1405980','834','00','005010X220A1','1405980','','2014-01-14','12:30:50',0,'2014-01-15 02:06:12',NULL,NULL),(19190,3570,'2808745','834','00','005010X220A1','2808745','','2014-02-12','21:11:08',0,'2014-02-13 21:30:07',NULL,NULL),(21417,4026,'3105543','834','00','005010X220A1','3105543','','2014-02-27','11:36:58',0,'2014-02-28 06:30:42',NULL,NULL),(568,103,'347700','834','00','005010X220A1','347700','','2013-12-16','14:50:25',0,'2013-12-25 18:02:36',NULL,NULL),(17141,3144,'2075792','834','00','005010X220A1','2075792','','2014-01-30','11:30:30',0,'2014-01-30 21:00:31',NULL,NULL),(15524,2651,'2067064','834','00','005010X220A1','2067064','','2014-01-15','19:30:34',0,'2014-01-17 03:36:42',NULL,NULL),(14287,2379,'2015635','834','00','005010X220A1','2015635','','2014-01-10','12:04:06',0,'2014-01-13 03:00:19',NULL,NULL),(749,134,'673498','834','00','005010X220A1','673498','','2013-12-16','17:50:35',0,'2013-12-25 18:08:19',NULL,NULL),(4076,733,'157745','834','00','005010X220A1','157745','','2013-12-18','20:46:44',0,'2013-12-25 23:02:34',NULL,NULL),(3827,675,'58133','834','00','005010X220A1','58133','','2013-12-08','15:38:53',0,'2013-12-25 22:17:20',NULL,NULL),(3735,641,'11624','834','00','005010X220A1','11624','','2013-12-12','13:52:18',0,'2013-12-25 22:08:43',NULL,NULL),(7053,1235,'1174980','834','00','005010X220A1','1174980','','2013-12-18','18:06:23',0,'2013-12-26 04:02:07',NULL,NULL),(1973,326,'373928','834','00','005010X220A1','373928','','2013-12-09','16:03:01',0,'2013-12-25 19:33:53',NULL,NULL),(7365,1285,'974095','834','00','005010X220A1','974095','','2013-11-30','17:00:08',0,'2013-12-26 04:16:01',NULL,NULL),(11497,1489,'1351887','834','00','005010X220A1','1351887','','2013-12-27','06:47:45',0,'2013-12-28 03:31:33',NULL,NULL),(18564,3453,'2797437','834','00','005010X220A1','2797437','','2014-02-10','09:30:36',0,'2014-02-10 21:30:39',NULL,NULL),(21606,4064,'3426295','834','00','005010X220A1','3426295','','2014-02-27','10:55:32',0,'2014-02-28 07:30:09',NULL,NULL),(818,162,'329725','834','00','005010X220A1','329725','','2013-11-11','13:07:37',0,'2013-12-25 18:10:50',NULL,NULL),(17686,3259,'2376745','834','00','005010X220A1','2376745','','2014-02-04','16:51:01',0,'2014-02-04 21:00:21',NULL,NULL),(1962,326,'50752','834','00','005010X220A1','50752','','2013-12-09','14:02:38',0,'2013-12-25 19:33:33',NULL,NULL),(16682,3062,'2152241','834','00','005010X220A1','2152241','','2014-01-27','10:25:07',0,'2014-01-27 21:00:32',NULL,NULL),(15107,2587,'1426718','834','00','005010X220A1','1426718','','2014-01-15','01:42:59',0,'2014-01-16 08:45:25',NULL,NULL),(12252,1620,'2238566','834','00','005010X220A1','2238566','','2013-12-31','20:48:28',1,'2014-01-02 04:23:30',NULL,NULL),(4193,734,'1148793','834','00','005010X220A1','1148793','','2013-12-19','17:33:23',0,'2013-12-25 23:06:02',NULL,NULL),(21085,3983,'2610035','834','00','005010X220A1','2610035','','2014-02-24','17:44:31',0,'2014-02-26 09:30:52',NULL,NULL),(1416,248,'944720','834','00','005010X220A1','944720','','2013-12-24','11:55:29',0,'2013-12-25 18:54:34',NULL,NULL),(17389,3196,'2651159','834','00','005010X220A1','2651159','','2014-01-31','16:57:07',0,'2014-01-31 21:01:46',NULL,NULL),(15678,2690,'2239027','834','00','005010X220A1','2239027','','2014-01-18','15:25:41',0,'2014-01-21 08:44:44',NULL,NULL),(2764,505,'926393','834','00','005010X220A1','926393','','2013-12-22','17:25:19',0,'2013-12-25 21:19:09',NULL,NULL),(15397,2626,'1694056','834','00','005010X220A1','1694056','','2014-01-15','18:57:40',0,'2014-01-17 03:35:46',NULL,NULL),(13623,2270,'2549912','834','00','005010X220A1','2549912','','2014-01-07','16:05:31',0,'2014-01-08 18:23:59',NULL,NULL),(7090,1236,'1196957','834','00','005010X220A1','1196957','','2013-12-18','10:52:37',0,'2013-12-26 04:03:19',NULL,NULL),(3566,617,'629257','834','00','005010X220A1','629257','','2013-12-11','20:52:32',0,'2013-12-25 22:03:18',NULL,NULL),(20474,3842,'3614921','834','00','005010X220A1','3614921','','2014-02-20','15:11:38',0,'2014-02-20 22:00:42',NULL,NULL),(12599,1671,'2478881','834','00','005010X220A1','2478881','','2014-01-02','14:26:41',0,'2014-01-03 02:01:03',NULL,NULL),(2894,531,'645517','834','00','005010X220A1','645517','','2013-12-22','13:49:14',0,'2013-12-25 21:23:31',NULL,NULL),(14577,2520,'1408569','834','00','005010X220A1','1408569','','2014-01-13','13:20:47',0,'2014-01-14 01:32:52',NULL,NULL),(14178,2365,'1554068','834','00','005010X220A1','1554068','','2014-01-09','18:27:37',0,'2014-01-13 02:23:26',NULL,NULL),(10799,1404,'1557242','834','00','005010X220A1','1557242','','2013-12-23','14:08:26',0,'2013-12-26 13:03:50',NULL,NULL),(13034,1878,'0001','999','BE','005010X231A1','935224','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:36',NULL,NULL),(5670,1053,'684468','834','00','005010X220A1','684468','','2013-12-25','00:09:17',0,'2013-12-26 01:52:02',NULL,NULL),(12301,1629,'1569092','834','00','005010X220A1','1569092','','2014-01-01','10:29:48',1,'2014-01-02 04:25:19',NULL,NULL),(17378,3187,'1937887','834','00','005010X220A1','1937887','','2014-01-31','12:02:10',0,'2014-01-31 21:01:37',NULL,NULL),(17373,3185,'2429822','834','00','005010X220A1','2429822','','2014-01-31','11:45:40',0,'2014-01-31 21:01:33',NULL,NULL),(1918,325,'527068','834','00','005010X220A1','527068','','2013-12-09','17:20:13',0,'2013-12-25 19:32:17',NULL,NULL),(13301,2145,'0001','999','BE','005010X231A1','637212','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:14',NULL,NULL),(13233,2077,'0001','999','BE','005010X231A1','328619','834','2013-12-28','04:55:00',0,'2014-01-05 17:01:24',NULL,NULL),(13175,2019,'0001','999','BE','005010X231A1','319022','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:42',NULL,NULL),(7207,1241,'1301785','834','00','005010X220A1','1301785','','2013-12-18','08:48:53',0,'2013-12-26 04:06:52',NULL,NULL),(6428,1203,'878129','834','00','005010X220A1','878129','','2013-11-22','09:05:15',0,'2013-12-26 03:15:24',NULL,NULL),(19581,3629,'3249351','834','00','005010X220A1','3249351','','2014-02-14','09:42:25',0,'2014-02-14 21:31:24',NULL,NULL),(20007,3748,'2440903','834','00','005010X220A1','2440903','','2014-02-18','15:49:54',0,'2014-02-18 22:00:38',NULL,NULL),(774,144,'869296','834','00','005010X220A1','869296','','2013-10-31','11:37:51',0,'2013-12-25 18:09:11',NULL,NULL),(12984,1736,'1473312','834','00','005010X220A1','1473312','','2014-01-03','22:14:56',0,'2014-01-05 00:01:34',NULL,NULL),(16683,3062,'1731044','834','00','005010X220A1','1731044','','2014-01-27','11:18:55',0,'2014-01-27 21:00:32',NULL,NULL),(21971,4143,'3343568','834','00','005010X220A1','3343568','','2014-03-02','15:24:12',0,'2014-03-03 01:00:07',NULL,NULL),(240,41,'720488','834','00','005010X220A1','720488','','2013-10-12','16:10:38',0,'2013-12-25 17:30:31',NULL,NULL),(952,181,'524375','834','00','005010X220A1','524375','','2013-12-03','14:12:57',0,'2013-12-25 18:18:42',NULL,NULL),(1848,324,'212659','834','00','005010X220A1','212659','','2013-12-08','19:49:23',0,'2013-12-25 19:30:06',NULL,NULL),(12447,1638,'1344783','834','00','005010X220A1','1344783','','2013-12-31','16:40:06',1,'2014-01-02 04:31:23',NULL,NULL),(15835,2737,'2401918','834','00','005010X220A1','2401918','','2014-01-20','18:37:09',1,'2014-01-22 03:21:59',NULL,NULL),(15510,2642,'1699544','834','00','005010X220A1','1699544','','2014-01-16','11:27:41',0,'2014-01-17 03:36:35',NULL,NULL),(11688,1516,'1898441','834','00','005010X220A1','1898441','','2013-12-27','21:46:57',1,'2013-12-29 11:07:33',NULL,NULL),(11365,1459,'1883667','834','00','005010X220A1','1883667','','2013-12-26','13:51:48',0,'2013-12-27 02:05:29',NULL,NULL),(11040,1418,'438940','834','00','005010X220A1','438940','','2013-12-23','09:38:23',0,'2013-12-26 13:12:09',NULL,NULL),(20476,3842,'2637632','834','00','005010X220A1','2637632','','2014-02-20','17:08:59',0,'2014-02-20 22:00:44',NULL,NULL),(23149,4343,'3029784','834','00','005010X220A1','3029784','','2014-03-06','18:37:07',0,'2014-03-07 21:31:09',NULL,NULL),(1190,239,'1742561','834','00','005010X220A1','1742561','','2013-12-24','16:58:10',0,'2013-12-25 18:47:27',NULL,NULL),(17450,3206,'2501722','834','00','005010X220A1','2501722','','2014-01-31','22:51:04',0,'2014-02-01 19:00:41',NULL,NULL),(16851,3092,'1682492','834','00','005010X220A1','1682492','','2014-01-28','17:51:12',0,'2014-01-28 21:00:40',NULL,NULL),(15513,2645,'1458822','834','00','005010X220A1','1458822','','2014-01-16','14:51:58',0,'2014-01-17 03:36:37',NULL,NULL),(14481,2502,'0001','999','BE','005010X231A1','1199099','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:52',NULL,NULL),(11994,1580,'2004865','834','00','005010X220A1','2004865','','2013-12-30','18:38:14',0,'2014-01-01 12:01:50',NULL,NULL),(4737,851,'1420771','834','00','005010X220A1','1420771','','2013-12-24','00:44:18',0,'2013-12-25 23:52:01',NULL,NULL),(11401,1465,'295027','834','00','005010X220A1','295027','','2013-12-26','12:38:10',0,'2013-12-27 02:06:35',NULL,NULL),(19856,3701,'2539621','834','00','005010X220A1','2539621','','2014-02-15','23:25:27',0,'2014-02-16 19:00:02',NULL,NULL),(20109,3772,'3084676','834','00','005010X220A1','3084676','','2014-02-18','18:56:05',0,'2014-02-20 03:45:58',NULL,NULL),(21230,3999,'3805010','834','00','005010X220A1','3805010','','2014-02-26','10:27:00',0,'2014-02-26 21:01:35',NULL,NULL),(21754,4090,'3421297','834','00','005010X220A1','3421297','','2014-02-28','11:17:20',0,'2014-02-28 21:30:49',NULL,NULL),(23707,4454,'3910673','834','00','005010X220A1','3910673','','2014-03-10','10:36:00',0,'2014-03-10 21:02:33',NULL,NULL),(574,103,'192643','834','00','005010X220A1','192643','','2013-12-16','15:38:59',0,'2013-12-25 18:02:47',NULL,NULL),(1165,239,'1826467','834','00','005010X220A1','1826467','','2013-12-24','12:30:05',0,'2013-12-25 18:46:39',NULL,NULL),(11862,1555,'74700','834','00','005010X220A1','74700','','2013-12-28','20:27:14',1,'2013-12-29 11:15:13',NULL,NULL),(7035,1235,'886485','834','00','005010X220A1','886485','','2013-12-18','14:18:13',0,'2013-12-26 04:01:35',NULL,NULL),(21059,3979,'3320687','834','00','005010X220A1','3320687','','2014-02-24','14:22:47',0,'2014-02-26 09:30:34',NULL,NULL),(21379,4024,'2883802','834','00','005010X220A1','2883802','','2014-02-27','12:43:52',0,'2014-02-28 06:30:26',NULL,NULL),(23562,4436,'2784480','834','00','005010X220A1','2784480','','2014-03-10','00:10:57',0,'2014-03-10 21:00:49',NULL,NULL),(117,7,'110614','834','00','005010X220A1','110614','','2013-12-04','20:55:38',0,'2013-12-25 17:18:34',NULL,NULL),(18502,3443,'2038999','834','00','005010X220A1','2038999','','2014-02-10','08:53:51',0,'2014-02-10 21:00:04',NULL,NULL),(17884,3294,'2636100','834','00','005010X220A1','2636100','','2014-02-05','12:50:45',0,'2014-02-05 21:30:23',NULL,NULL),(17098,3142,'2528956','834','00','005010X220A1','2528956','','2014-01-29','20:29:28',0,'2014-01-30 21:00:05',NULL,NULL),(3575,617,'395788','834','00','005010X220A1','395788','','2013-12-12','06:34:10',0,'2013-12-25 22:03:33',NULL,NULL),(7587,1301,'644250','834','00','005010X220A1','644250','','2013-12-21','17:53:05',0,'2013-12-26 04:36:53',NULL,NULL),(20252,3794,'3602959','834','00','005010X220A1','3602959','','2014-02-18','21:38:45',0,'2014-02-20 04:32:41',NULL,NULL),(393,76,'1233592','834','00','005010X220A1','1233592','','2013-12-03','22:29:22',0,'2013-12-25 17:48:09',NULL,NULL),(16505,3011,'2169157','834','00','005010X220A1','2169157','','2014-01-24','10:55:47',0,'2014-01-24 21:00:44',NULL,NULL),(15235,2598,'1818813','834','00','005010X220A1','1818813','','2014-01-15','00:09:21',0,'2014-01-16 08:46:47',NULL,NULL),(1524,260,'1852587','834','00','005010X220A1','1852587','','2013-12-24','12:23:23',0,'2013-12-25 18:58:11',NULL,NULL),(5930,1112,'919616','834','00','005010X220A1','919616','','2013-12-15','15:21:41',0,'2013-12-26 02:31:45',NULL,NULL),(12086,1586,'1926828','834','00','005010X220A1','1926828','','2013-12-30','16:30:33',0,'2014-01-01 12:05:15',NULL,NULL),(21649,4074,'2669727','834','00','005010X220A1','2669727','','2014-02-27','15:56:03',0,'2014-02-28 07:30:39',NULL,NULL),(11998,1581,'1757756','834','00','005010X220A1','1757756','','2013-12-30','10:08:50',0,'2014-01-01 12:01:59',NULL,NULL),(11737,1520,'1846827','834','00','005010X220A1','1846827','','2013-12-28','07:58:53',1,'2013-12-29 11:09:01',NULL,NULL),(7742,1344,'713543','834','00','005010X220A1','713543','','2013-10-19','22:53:40',0,'2013-12-26 05:00:36',NULL,NULL),(17603,3240,'2609512','834','00','005010X220A1','2609512','','2014-02-03','14:52:57',0,'2014-02-03 21:01:00',NULL,NULL),(5646,1049,'1272036','834','00','005010X220A1','1272036','','2013-12-24','19:21:34',0,'2013-12-26 01:51:11',NULL,NULL),(3188,574,'621944','834','00','005010X220A1','621944','','2013-12-13','15:18:51',0,'2013-12-25 21:39:09',NULL,NULL),(15845,2738,'2270610','834','00','005010X220A1','2270610','','2014-01-20','22:17:56',1,'2014-01-22 03:22:06',NULL,NULL),(15609,2665,'1772244','834','00','005010X220A1','1772244','','2014-01-16','20:02:49',0,'2014-01-20 08:06:32',NULL,NULL),(15424,2629,'2391311','834','00','005010X220A1','2391311','','2014-01-16','11:49:49',0,'2014-01-17 03:35:59',NULL,NULL),(15380,2624,'2320556','834','00','005010X220A1','2320556','','2014-01-16','14:04:58',0,'2014-01-17 03:35:38',NULL,NULL),(19460,3613,'1782991','834','00','005010X220A1','1782991','','2014-02-13','14:51:20',0,'2014-02-13 22:03:15',NULL,NULL),(19736,3673,'3378740','834','00','005010X220A1','3378740','','2014-02-15','10:24:30',0,'2014-02-15 22:00:34',NULL,NULL),(19949,3741,'2650622','834','00','005010X220A1','2650622','','2014-02-18','14:34:32',0,'2014-02-18 21:30:17',NULL,NULL),(20509,3848,'3212895','834','00','005010X220A1','3212895','','2014-02-19','19:50:28',0,'2014-02-20 22:01:10',NULL,NULL),(20942,3946,'2971664','834','00','005010X220A1','2971664','','2014-02-24','15:47:40',0,'2014-02-26 08:00:36',NULL,NULL),(12335,1634,'1652635','834','00','005010X220A1','1652635','','2013-12-31','11:25:30',1,'2014-01-02 04:27:24',NULL,NULL),(2466,426,'597034','834','00','005010X220A1','597034','','2013-12-06','11:26:25',0,'2013-12-25 20:19:24',NULL,NULL),(7099,1236,'547844','834','00','005010X220A1','547844','','2013-12-18','11:58:05',0,'2013-12-26 04:03:35',NULL,NULL),(6139,1166,'806224','834','00','005010X220A1','806224','','2013-12-20','16:24:07',0,'2013-12-26 03:02:30',NULL,NULL),(4233,738,'691076','834','00','005010X220A1','691076','','2013-12-19','14:53:00',0,'2013-12-25 23:07:14',NULL,NULL),(5714,1069,'90015','834','00','005010X220A1','90015','','2013-12-14','00:17:20',0,'2013-12-26 02:00:54',NULL,NULL),(5992,1127,'1244447','834','00','005010X220A1','1244447','','2013-12-15','10:22:36',0,'2013-12-26 02:33:43',NULL,NULL),(23162,4344,'3138194','834','00','005010X220A1','3138194','','2014-03-07','11:05:22',0,'2014-03-07 21:31:19',NULL,NULL),(13507,2233,'2487286','834','00','005010X220A1','2487286','','2014-01-06','14:03:06',0,'2014-01-07 04:04:58',NULL,NULL),(11037,1418,'1313505','834','00','005010X220A1','1313505','','2013-12-23','01:41:43',0,'2013-12-26 13:12:00',NULL,NULL),(16221,2913,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',0,'2014-01-23 05:30:13',NULL,NULL),(6448,1209,'916446','834','00','005010X220A1','916446','','2013-11-22','16:28:24',0,'2013-12-26 03:16:01',NULL,NULL),(4488,803,'766787','834','00','005010X220A1','766787','','2013-11-26','16:25:49',0,'2013-12-25 23:31:40',NULL,NULL),(5273,973,'332246','834','00','005010X220A1','332246','','2013-11-12','11:19:23',0,'2013-12-26 01:00:25',NULL,NULL),(2655,501,'771551','834','00','005010X220A1','771551','','2013-12-22','10:01:25',0,'2013-12-25 21:15:34',NULL,NULL),(2247,376,'791795','834','00','005010X220A1','791795','','2013-12-02','14:22:54',0,'2013-12-25 19:49:49',NULL,NULL),(20058,3753,'3365455','834','00','005010X220A1','3365455','','2014-02-18','13:51:32',0,'2014-02-18 22:01:14',NULL,NULL),(21007,3961,'3068800','834','00','005010X220A1','3068800','','2014-02-22','11:36:02',0,'2014-02-26 08:30:43',NULL,NULL),(23078,4339,'3275574','834','00','005010X220A1','3275574','','2014-03-07','11:44:11',0,'2014-03-07 21:30:19',NULL,NULL),(11550,1492,'1987834','834','00','005010X220A1','1987834','','2013-12-26','20:23:02',0,'2013-12-28 03:33:09',NULL,NULL),(18597,3456,'2357156','834','00','005010X220A1','2357156','','2014-02-09','20:40:58',0,'2014-02-10 21:31:01',NULL,NULL),(11521,1490,'1952563','834','00','005010X220A1','1952563','','2013-12-27','12:12:22',0,'2013-12-28 03:32:16',NULL,NULL),(4750,858,'128276','834','00','005010X220A1','128276','','2013-11-30','21:23:35',0,'2013-12-26 00:00:17',NULL,NULL),(7280,1255,'5678','834','00','005010X220A1','5678','','2013-12-18','09:53:46',0,'2013-12-26 04:09:06',NULL,NULL),(15433,2629,'1935216','834','00','005010X220A1','1935216','','2014-01-16','16:54:21',0,'2014-01-17 03:36:03',NULL,NULL),(14965,2568,'2442823','834','00','005010X220A1','2442823','','2014-01-14','14:51:58',0,'2014-01-15 02:07:59',NULL,NULL),(11353,1458,'1961234','834','00','005010X220A1','1961234','','2013-12-26','13:00:59',0,'2013-12-27 02:05:07',NULL,NULL),(12518,1643,'1468332','834','00','005010X220A1','1468332','','2013-12-31','13:44:18',1,'2014-01-02 04:34:00',NULL,NULL),(20975,3956,'3054166','834','00','005010X220A1','3054166','','2014-02-22','11:54:46',0,'2014-02-26 08:30:13',NULL,NULL),(205,23,'1058081','834','00','005010X220A1','1058081','','2013-12-05','13:41:55',0,'2013-12-25 17:21:24',NULL,NULL),(16052,2772,'1807424','834','00','005010X220A1','1807424','','2014-01-22','14:21:58',0,'2014-01-23 03:02:36',NULL,NULL),(15896,2741,'2096687','834','00','005010X220A1','2096687','','2014-01-20','21:20:39',1,'2014-01-22 03:22:38',NULL,NULL),(14373,2405,'1944793','834','00','005010X220A1','1944793','','2014-01-12','10:18:23',0,'2014-01-13 03:01:43',NULL,NULL),(7127,1236,'322123','834','00','005010X220A1','322123','','2013-12-18','16:23:04',0,'2013-12-26 04:04:25',NULL,NULL),(12964,1734,'1995778','834','00','005010X220A1','1995778','','2014-01-04','08:22:58',0,'2014-01-05 00:00:53',NULL,NULL),(12384,1637,'2165856','834','00','005010X220A1','2165856','','2013-12-31','01:24:25',1,'2014-01-02 04:29:06',NULL,NULL),(16758,3069,'2302000','834','00','005010X220A1','2302000','','2014-01-27','11:17:57',0,'2014-01-27 21:01:24',NULL,NULL),(15240,2598,'2455638','834','00','005010X220A1','2455638','','2014-01-15','14:46:38',0,'2014-01-16 08:46:50',NULL,NULL),(14634,2527,'1485362','834','00','005010X220A1','1485362','','2014-01-13','11:13:12',0,'2014-01-14 01:33:28',NULL,NULL),(12441,1638,'1579063','834','00','005010X220A1','1579063','','2013-12-31','16:03:38',1,'2014-01-02 04:31:10',NULL,NULL),(2405,415,'826490','834','00','005010X220A1','826490','','2013-12-06','14:19:38',0,'2013-12-25 20:17:23',NULL,NULL),(4320,750,'877633','834','00','005010X220A1','877633','','2013-12-19','16:55:12',0,'2013-12-25 23:09:51',NULL,NULL),(2462,422,'739519','834','00','005010X220A1','739519','','2013-12-06','16:39:03',0,'2013-12-25 20:19:15',NULL,NULL),(2720,503,'1209536','834','00','005010X220A1','1209536','','2013-12-21','21:46:55',0,'2013-12-25 21:17:49',NULL,NULL),(18148,3345,'2955997','834','00','005010X220A1','2955997','','2014-02-06','14:48:38',0,'2014-02-06 21:01:53',NULL,NULL),(18419,3420,'2409836','834','00','005010X220A1','2409836','','2014-02-10','00:22:55',0,'2014-02-10 11:00:08',NULL,NULL),(18558,3453,'2523088','834','00','005010X220A1','2523088','','2014-02-09','18:40:52',0,'2014-02-10 21:30:34',NULL,NULL),(18848,3491,'3037656','834','00','005010X220A1','3037656','','2014-02-11','13:01:15',0,'2014-02-11 21:01:51',NULL,NULL),(23627,4441,'3144166','834','00','005010X220A1','3144166','','2014-03-10','11:46:42',0,'2014-03-10 21:01:35',NULL,NULL),(23671,4445,'3496509','834','00','005010X220A1','3496509','','2014-03-09','21:26:37',0,'2014-03-10 21:02:06',NULL,NULL),(5740,1070,'783912','834','00','005010X220A1','783912','','2013-12-13','22:18:18',0,'2013-12-26 02:01:37',NULL,NULL),(14992,2584,'1370657','834','00','005010X220A1','1370657','','2014-01-14','19:00:36',0,'2014-01-16 08:44:12',NULL,NULL),(4654,829,'1635229','834','00','005010X220A1','1635229','','2013-12-23','21:08:59',0,'2013-12-25 23:49:03',NULL,NULL),(2178,363,'969023','834','00','005010X220A1','969023','','2013-12-02','07:46:56',0,'2013-12-25 19:47:25',NULL,NULL),(18092,3325,'2798858','834','00','005010X220A1','2798858','','2014-02-06','13:02:53',0,'2014-02-06 21:01:10',NULL,NULL),(18458,3425,'2805282','834','00','005010X220A1','2805282','','2014-02-10','00:22:41',0,'2014-02-10 11:00:41',NULL,NULL),(20089,3765,'3431115','834','00','005010X220A1','3431115','','2014-02-18','13:24:34',0,'2014-02-18 22:01:38',NULL,NULL),(22733,4276,'2759253','834','00','005010X220A1','2759253','','2014-03-05','21:45:55',0,'2014-03-06 21:00:16',NULL,NULL),(23153,4344,'2993279','834','00','005010X220A1','2993279','','2014-03-06','18:45:55',0,'2014-03-07 21:31:13',NULL,NULL),(1118,238,'854357','834','00','005010X220A1','854357','','2013-12-24','12:45:46',0,'2013-12-25 18:45:12',NULL,NULL),(2115,360,'1144146','834','00','005010X220A1','1144146','','2013-12-02','07:00:57',0,'2013-12-25 19:45:23',NULL,NULL),(4779,862,'1042601','834','00','005010X220A1','1042601','','2013-12-01','13:10:03',0,'2013-12-26 00:01:14',NULL,NULL),(10935,1410,'1327314','834','00','005010X220A1','1327314','','2013-12-23','13:02:37',0,'2013-12-26 13:08:47',NULL,NULL),(20085,3763,'2704137','834','00','005010X220A1','2704137','','2014-02-18','12:11:07',0,'2014-02-18 22:01:34',NULL,NULL),(385,75,'655395','834','00','005010X220A1','655395','','2013-12-03','18:51:04',0,'2013-12-25 17:47:53',NULL,NULL),(11776,1531,'1973010','834','00','005010X220A1','1973010','','2013-12-27','20:36:38',1,'2013-12-29 11:10:14',NULL,NULL),(17672,3259,'2664008','834','00','005010X220A1','2664008','','2014-02-03','21:49:51',0,'2014-02-04 21:00:13',NULL,NULL),(7167,1238,'572878','834','00','005010X220A1','572878','','2013-12-18','12:07:19',0,'2013-12-26 04:05:35',NULL,NULL),(16102,2794,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:41:32',NULL,NULL),(2533,455,'72627','834','00','005010X220A1','72627','','2013-11-18','13:04:55',0,'2013-12-25 20:31:00',NULL,NULL),(3134,551,'157548','834','00','005010X220A1','157548','','2013-12-13','15:48:41',0,'2013-12-25 21:37:14',NULL,NULL),(5452,1037,'1164311','834','00','005010X220A1','1164311','','2013-11-03','11:12:25',0,'2013-12-26 01:32:05',NULL,NULL),(3812,664,'58126','834','00','005010X220A1','58126','','2013-12-08','11:29:39',0,'2013-12-25 22:16:44',NULL,NULL),(18795,3487,'2706149','834','00','005010X220A1','2706149','','2014-02-11','13:09:55',0,'2014-02-11 21:01:11',NULL,NULL),(21240,3999,'3143716','834','00','005010X220A1','3143716','','2014-02-26','12:40:39',0,'2014-02-26 21:01:42',NULL,NULL),(22158,4180,'3237274','834','00','005010X220A1','3237274','','2014-03-03','10:28:28',0,'2014-03-03 21:31:00',NULL,NULL),(3423,595,'299334','834','00','005010X220A1','299334','','2013-12-16','23:28:07',0,'2013-12-25 21:52:26',NULL,NULL),(18009,3318,'2697229','834','00','005010X220A1','2697229','','2014-02-06','17:52:46',0,'2014-02-06 21:00:14',NULL,NULL),(17648,3250,'1516791','834','00','005010X220A1','1516791','','2014-02-03','15:59:04',0,'2014-02-03 21:01:29',NULL,NULL),(15305,2622,'1958245','834','00','005010X220A1','1958245','','2014-01-15','22:01:02',0,'2014-01-17 03:35:03',NULL,NULL),(7659,1315,'1374852','834','00','005010X220A1','1374852','','2013-12-21','12:13:23',0,'2013-12-26 04:39:07',NULL,NULL),(16139,2831,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:37:00',1,'2014-01-23 03:54:11',NULL,NULL),(4931,915,'736661','834','00','005010X220A1','736661','','2013-10-16','10:11:18',0,'2013-12-26 00:31:09',NULL,NULL),(18889,3498,'2157867','834','00','005010X220A1','2157867','','2014-02-11','12:17:17',0,'2014-02-11 21:02:26',NULL,NULL),(20080,3762,'2871814','834','00','005010X220A1','2871814','','2014-02-18','12:06:36',0,'2014-02-18 22:01:30',NULL,NULL),(20669,3878,'3344400','834','00','005010X220A1','3344400','','2014-02-21','17:13:50',0,'2014-02-21 22:01:05',NULL,NULL),(20740,3903,'2600031','834','00','005010X220A1','2600031','','2014-02-25','10:10:04',0,'2014-02-25 21:30:10',NULL,NULL),(21828,4098,'3810478','834','00','005010X220A1','3810478','','2014-02-28','15:19:18',0,'2014-02-28 21:31:41',NULL,NULL),(21960,4141,'3120592','834','00','005010X220A1','3120592','','2014-03-02','15:31:44',0,'2014-03-03 01:00:02',NULL,NULL),(22680,4255,'2784325','834','00','005010X220A1','2784325','','2014-03-05','15:44:01',0,'2014-03-05 21:32:14',NULL,NULL),(12479,1640,'2542365','834','00','005010X220A1','2542365','','2013-12-31','12:04:53',1,'2014-01-02 04:32:29',NULL,NULL),(16745,3067,'1759575','834','00','005010X220A1','1759575','','2014-01-27','10:21:02',0,'2014-01-27 21:01:14',NULL,NULL),(16703,3064,'2017076','834','00','005010X220A1','2017076','','2014-01-27','08:54:24',0,'2014-01-27 21:00:46',NULL,NULL),(4541,825,'42192','834','00','005010X220A1','42192','','2013-12-23','21:32:44',0,'2013-12-25 23:45:22',NULL,NULL),(4524,817,'1041501','834','00','005010X220A1','1041501','','2013-11-26','16:03:01',0,'2013-12-25 23:32:52',NULL,NULL),(4189,734,'1118656','834','00','005010X220A1','1118656','','2013-12-19','15:56:15',0,'2013-12-25 23:05:55',NULL,NULL),(2409,415,'1199024','834','00','005010X220A1','1199024','','2013-12-05','20:01:45',0,'2013-12-25 20:17:30',NULL,NULL),(4003,731,'146594','834','00','005010X220A1','146594','','2013-12-18','20:54:54',0,'2013-12-25 23:00:15',NULL,NULL),(6349,1178,'84955','834','00','005010X220A1','84955','','2013-12-20','17:13:50',0,'2013-12-26 03:08:52',NULL,NULL),(18788,3487,'2505595','834','00','005010X220A1','2505595','','2014-02-11','06:47:56',0,'2014-02-11 21:01:06',NULL,NULL),(19640,3644,'2282795','834','00','005010X220A1','2282795','','2014-02-14','11:08:17',0,'2014-02-14 21:32:07',NULL,NULL),(20745,3903,'2888614','834','00','005010X220A1','2888614','','2014-02-25','12:42:54',0,'2014-02-25 21:30:14',NULL,NULL),(20884,3921,'2588616','834','00','005010X220A1','2588616','','2014-02-25','10:12:50',0,'2014-02-25 21:31:57',NULL,NULL),(21905,4127,'2806039','834','00','005010X220A1','2806039','','2014-03-01','11:14:45',0,'2014-03-01 21:00:33',NULL,NULL),(1786,300,'597128','834','00','005010X220A1','597128','','2013-12-10','14:07:48',0,'2013-12-25 19:19:09',NULL,NULL),(11628,1496,'1893477','834','00','005010X220A1','1893477','','2013-12-27','12:37:54',0,'2013-12-28 03:35:35',NULL,NULL),(11482,1488,'1402129','834','00','005010X220A1','1402129','','2013-12-27','16:02:34',0,'2013-12-28 03:31:08',NULL,NULL),(15538,2654,'1449135','834','00','005010X220A1','1449135','','2014-01-17','13:47:07',0,'2014-01-20 08:05:40',NULL,NULL),(5213,950,'1204025','834','00','005010X220A1','1204025','','2013-12-11','12:40:58',0,'2013-12-26 00:52:47',NULL,NULL),(15048,2585,'1590339','834','00','005010X220A1','1590339','','2014-01-14','19:48:45',0,'2014-01-16 08:44:48',NULL,NULL),(13969,2322,'2235611','834','00','005010X220A1','2235611','','2014-01-09','13:08:53',0,'2014-01-13 02:20:34',NULL,NULL),(19630,3643,'3141139','834','00','005010X220A1','3141139','','2014-02-14','00:30:09',0,'2014-02-14 21:32:00',NULL,NULL),(20175,3777,'3510172','834','00','005010X220A1','3510172','','2014-02-19','15:31:40',0,'2014-02-20 04:11:18',NULL,NULL),(1358,245,'1486135','834','00','005010X220A1','1486135','','2013-12-24','14:07:25',0,'2013-12-25 18:52:42',NULL,NULL),(10588,1402,'758081','834','00','005010X220A1','758081','','2013-12-23','12:16:23',0,'2013-12-26 12:56:45',NULL,NULL),(7494,1300,'1019056','834','00','005010X220A1','1019056','','2013-12-20','19:50:31',0,'2013-12-26 04:33:51',NULL,NULL),(22017,4151,'3663657','834','00','005010X220A1','3663657','','2014-03-02','00:39:10',0,'2014-03-03 01:00:34',NULL,NULL),(22901,4284,'3760549','834','00','005010X220A1','3760549','','2014-03-06','16:54:26',0,'2014-03-06 21:02:16',NULL,NULL),(839,174,'500039','834','00','005010X220A1','500039','','2013-12-03','12:43:24',0,'2013-12-25 18:15:19',NULL,NULL),(18372,3406,'1910598','834','00','005010X220A1','1910598','','2014-02-09','13:52:43',0,'2014-02-09 19:00:16',NULL,NULL),(11419,1471,'1643567','834','00','005010X220A1','1643567','','2013-12-26','11:38:48',0,'2013-12-27 02:07:10',NULL,NULL),(15839,2737,'1949906','834','00','005010X220A1','1949906','','2014-01-21','13:01:05',1,'2014-01-22 03:22:02',NULL,NULL),(14993,2584,'1478303','834','00','005010X220A1','1478303','','2014-01-14','19:16:58',0,'2014-01-16 08:44:13',NULL,NULL),(14410,2431,'0001','999','BE','005010X231A1','940340','834','2013-12-28','04:55:00',0,'2014-01-13 03:02:23',NULL,NULL),(5057,936,'85886','834','00','005010X220A1','85886','','2013-12-11','09:47:29',0,'2013-12-26 00:47:49',NULL,NULL),(4424,788,'624887','834','00','005010X220A1','624887','','2013-11-06','14:24:42',0,'2013-12-25 23:16:49',NULL,NULL),(5674,1054,'1724693','834','00','005010X220A1','1724693','','2013-12-24','20:17:45',0,'2013-12-26 01:52:11',NULL,NULL),(7579,1301,'113785','834','00','005010X220A1','113785','','2013-12-21','16:03:14',0,'2013-12-26 04:36:33',NULL,NULL),(17690,3259,'2435555','834','00','005010X220A1','2435555','','2014-02-04','17:46:44',0,'2014-02-04 21:00:24',NULL,NULL),(15106,2587,'1794940','834','00','005010X220A1','1794940','','2014-01-14','22:51:29',0,'2014-01-16 08:45:24',NULL,NULL),(1583,278,'365569','834','00','005010X220A1','365569','','2013-11-20','02:29:56',0,'2013-12-25 19:00:44',NULL,NULL),(2641,500,'1231487','834','00','005010X220A1','1231487','','2013-12-21','23:07:24',0,'2013-12-25 21:15:06',NULL,NULL),(4111,733,'1003412','834','00','005010X220A1','1003412','','2013-12-19','12:41:06',0,'2013-12-25 23:03:32',NULL,NULL),(21251,3999,'3272661','834','00','005010X220A1','3272661','','2014-02-26','15:06:13',0,'2014-02-26 21:01:49',NULL,NULL),(22051,4167,'3019758','834','00','005010X220A1','3019758','','2014-03-03','10:49:32',0,'2014-03-03 21:00:11',NULL,NULL),(256,47,'546151','834','00','005010X220A1','546151','','2013-11-13','13:29:01',0,'2013-12-25 17:31:04',NULL,NULL),(18758,3485,'3144845','834','00','005010X220A1','3144845','','2014-02-11','16:11:55',0,'2014-02-11 21:00:44',NULL,NULL),(18422,3420,'1855447','834','00','005010X220A1','1855447','','2014-02-10','04:05:59',0,'2014-02-10 11:00:11',NULL,NULL),(18136,3338,'2304434','834','00','005010X220A1','2304434','','2014-02-05','22:00:21',0,'2014-02-06 21:01:43',NULL,NULL),(15853,2738,'1649121','834','00','005010X220A1','1649121','','2014-01-21','11:37:48',1,'2014-01-22 03:22:11',NULL,NULL),(15564,2656,'2084940','834','00','005010X220A1','2084940','','2014-01-16','18:52:04',0,'2014-01-20 08:05:59',NULL,NULL),(15502,2636,'1506100','834','00','005010X220A1','1506100','','2014-01-16','16:39:12',0,'2014-01-17 03:36:31',NULL,NULL),(4585,826,'246976','834','00','005010X220A1','246976','','2013-12-23','22:40:43',0,'2013-12-25 23:46:48',NULL,NULL),(21882,4123,'2608780','834','00','005010X220A1','2608780','','2014-02-28','20:55:32',0,'2014-03-01 21:00:17',NULL,NULL),(22119,4177,'3546339','834','00','005010X220A1','3546339','','2014-03-03','13:16:41',0,'2014-03-03 21:30:34',NULL,NULL),(23084,4339,'3187578','834','00','005010X220A1','3187578','','2014-03-07','13:34:08',0,'2014-03-07 21:30:24',NULL,NULL),(23199,4346,'3573524','834','00','005010X220A1','3573524','','2014-03-07','16:34:42',0,'2014-03-07 21:31:45',NULL,NULL),(23722,4460,'2839006','834','00','005010X220A1','2839006','','2014-03-10','12:38:11',0,'2014-03-10 21:02:46',NULL,NULL),(12696,1674,'1639384','834','00','005010X220A1','1639384','','2014-01-02','11:21:10',0,'2014-01-03 02:04:36',NULL,NULL),(18809,3487,'2655187','834','00','005010X220A1','2655187','','2014-02-11','17:56:24',0,'2014-02-11 21:01:21',NULL,NULL),(18390,3408,'2051612','834','00','005010X220A1','2051612','','2014-02-09','17:17:42',0,'2014-02-09 19:00:28',NULL,NULL),(11724,1520,'1945920','834','00','005010X220A1','1945920','','2013-12-28','12:14:45',1,'2013-12-29 11:08:39',NULL,NULL),(17819,3273,'1737123','834','00','005010X220A1','1737123','','2014-02-04','17:53:25',0,'2014-02-04 21:01:45',NULL,NULL),(17101,3142,'1521536','834','00','005010X220A1','1521536','','2014-01-29','20:49:42',0,'2014-01-30 21:00:07',NULL,NULL),(16420,3000,'1368056','834','00','005010X220A1','1368056','','2014-01-23','11:48:56',0,'2014-01-23 21:01:35',NULL,NULL),(5105,940,'6452','834','00','005010X220A1','6452','','2013-12-11','16:28:52',0,'2013-12-26 00:49:19',NULL,NULL),(12716,1678,'2381115','834','00','005010X220A1','2381115','','2014-01-02','18:02:03',0,'2014-01-03 02:05:22',NULL,NULL),(2922,541,'790681','834','00','005010X220A1','790681','','2013-12-12','18:54:27',0,'2013-12-25 21:30:37',NULL,NULL),(17433,3204,'2144825','834','00','005010X220A1','2144825','','2014-02-01','12:07:55',0,'2014-02-01 19:00:30',NULL,NULL),(17346,3181,'1469035','834','00','005010X220A1','1469035','','2014-01-31','10:23:37',0,'2014-01-31 21:01:14',NULL,NULL),(3875,696,'1052738','834','00','005010X220A1','1052738','','2013-10-04','12:59:20',0,'2013-12-25 22:31:22',NULL,NULL),(16753,3067,'1570981','834','00','005010X220A1','1570981','','2014-01-27','16:01:29',0,'2014-01-27 21:01:19',NULL,NULL),(16229,2921,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',0,'2014-01-23 06:39:41',NULL,NULL),(15649,2682,'1902869','834','00','005010X220A1','1902869','','2014-01-18','15:56:15',0,'2014-01-21 08:44:23',NULL,NULL),(15556,2655,'1424424','834','00','005010X220A1','1424424','','2014-01-16','22:52:54',0,'2014-01-20 08:05:53',NULL,NULL),(14227,2368,'2342756','834','00','005010X220A1','2342756','','2014-01-09','18:46:31',0,'2014-01-13 02:24:02',NULL,NULL),(4132,733,'1128785','834','00','005010X220A1','1128785','','2013-12-19','15:53:49',0,'2013-12-25 23:04:10',NULL,NULL),(20718,3897,'2998277','834','00','005010X220A1','2998277','','2014-02-25','10:51:09',0,'2014-02-25 21:00:25',NULL,NULL),(20833,3911,'3365617','834','00','005010X220A1','3365617','','2014-02-25','01:08:06',0,'2014-02-25 21:31:18',NULL,NULL),(10516,1401,'1456657','834','00','005010X220A1','1456657','','2013-12-22','22:33:07',0,'2013-12-26 12:54:21',NULL,NULL),(6380,1184,'714416','834','00','005010X220A1','714416','','2013-12-20','13:24:38',0,'2013-12-26 03:09:52',NULL,NULL),(17627,3243,'2303232','834','00','005010X220A1','2303232','','2014-02-03','15:43:50',0,'2014-02-03 21:01:15',NULL,NULL),(4195,734,'1077233','834','00','005010X220A1','1077233','','2013-12-19','17:49:59',0,'2013-12-25 23:06:06',NULL,NULL),(22071,4171,'3703153','834','00','005010X220A1','3703153','','2014-03-03','11:35:45',0,'2014-03-03 21:00:24',NULL,NULL),(23528,4434,'3398264','834','00','005010X220A1','3398264','','2014-03-10','17:21:43',0,'2014-03-10 21:00:22',NULL,NULL),(810,160,'539206','834','00','005010X220A1','539206','','2013-11-11','11:21:24',0,'2013-12-25 18:10:36',NULL,NULL),(14079,2341,'1531946','834','00','005010X220A1','1531946','','2014-01-07','22:51:32',0,'2014-01-13 02:21:57',NULL,NULL),(1970,326,'284476','834','00','005010X220A1','284476','','2013-12-09','15:54:40',0,'2013-12-25 19:33:48',NULL,NULL),(2371,413,'1172130','834','00','005010X220A1','1172130','','2013-12-06','13:09:13',0,'2013-12-25 20:16:23',NULL,NULL),(16357,2983,'1730990','834','00','005010X220A1','1730990','','2014-01-23','15:55:59',0,'2014-01-23 21:00:53',NULL,NULL),(3004,543,'885237','834','00','005010X220A1','885237','','2013-12-13','17:40:00',0,'2013-12-25 21:33:14',NULL,NULL),(4475,802,'467289','834','00','005010X220A1','467289','','2013-11-26','12:15:12',0,'2013-12-25 23:31:14',NULL,NULL),(5690,1067,'694604','834','00','005010X220A1','694604','','2013-12-13','20:55:49',0,'2013-12-26 02:00:03',NULL,NULL),(12260,1620,'1781901','834','00','005010X220A1','1781901','','2014-01-01','13:58:34',1,'2014-01-02 04:23:48',NULL,NULL),(20980,3957,'3068795','834','00','005010X220A1','3068795','','2014-02-21','18:13:13',0,'2014-02-26 08:30:19',NULL,NULL),(22753,4276,'3833685','834','00','005010X220A1','3833685','','2014-03-06','13:47:00',0,'2014-03-06 21:00:32',NULL,NULL),(125,7,'1316887','834','00','005010X220A1','1316887','','2013-12-05','12:08:01',0,'2013-12-25 17:18:50',NULL,NULL),(18881,3496,'2520529','834','00','005010X220A1','2520529','','2014-02-11','14:28:15',0,'2014-02-11 21:02:19',NULL,NULL),(1053,207,'165452','834','00','005010X220A1','165452','','2013-11-28','20:25:49',0,'2013-12-25 18:30:23',NULL,NULL),(3130,551,'142479','834','00','005010X220A1','142479','','2013-12-13','11:56:47',0,'2013-12-25 21:37:07',NULL,NULL),(15132,2587,'1853198','834','00','005010X220A1','1853198','','2014-01-15','17:19:43',0,'2014-01-16 08:45:42',NULL,NULL),(4412,782,'408574','834','00','005010X220A1','408574','','2013-11-27','12:53:23',0,'2013-12-25 23:16:20',NULL,NULL),(11209,1454,'174155','834','00','005010X220A1','174155','','2013-12-26','08:51:49',0,'2013-12-27 02:00:43',NULL,NULL),(13188,2032,'0001','999','BE','005010X231A1','1170605','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:19',NULL,NULL),(3329,586,'264795','834','00','005010X220A1','264795','','2013-12-17','10:26:06',0,'2013-12-25 21:49:29',NULL,NULL),(7217,1241,'892152','834','00','005010X220A1','892152','','2013-12-18','11:42:41',0,'2013-12-26 04:07:08',NULL,NULL),(17659,3257,'2278861','834','00','005010X220A1','2278861','','2014-02-03','18:28:37',0,'2014-02-04 21:00:03',NULL,NULL),(17615,3243,'2335907','834','00','005010X220A1','2335907','','2014-02-03','10:39:28',0,'2014-02-03 21:01:08',NULL,NULL),(17337,3178,'1998632','834','00','005010X220A1','1998632','','2014-01-30','20:59:29',0,'2014-01-31 21:01:07',NULL,NULL),(16522,3016,'1423051','834','00','005010X220A1','1423051','','2014-01-23','20:08:22',0,'2014-01-24 21:00:55',NULL,NULL),(16030,2769,'1546577','834','00','005010X220A1','1546577','','2014-01-22','09:39:21',0,'2014-01-23 03:02:26',NULL,NULL),(6151,1167,'250412','834','00','005010X220A1','250412','','2013-12-19','18:52:43',0,'2013-12-26 03:02:51',NULL,NULL),(4287,743,'546861','834','00','005010X220A1','546861','','2013-12-19','16:11:01',0,'2013-12-25 23:08:55',NULL,NULL),(5728,1069,'1281818','834','00','005010X220A1','1281818','','2013-12-14','15:49:03',0,'2013-12-26 02:01:14',NULL,NULL),(13584,2256,'1681966','834','00','005010X220A1','1681966','','2014-01-05','17:42:21',1,'2014-01-07 10:22:12',NULL,NULL),(1079,216,'1217611','834','00','005010X220A1','1217611','','2013-11-04','06:12:50',0,'2013-12-25 18:31:13',NULL,NULL),(14340,2401,'1715774','834','00','005010X220A1','1715774','','2014-01-11','18:51:41',0,'2014-01-13 03:01:19',NULL,NULL),(3060,544,'602435','834','00','005010X220A1','602435','','2013-12-13','14:50:30',0,'2013-12-25 21:34:57',NULL,NULL),(20972,3956,'3694190','834','00','005010X220A1','3694190','','2014-02-22','11:18:23',0,'2014-02-26 08:30:10',NULL,NULL),(21047,3977,'3552122','834','00','005010X220A1','3552122','','2014-02-24','16:31:36',0,'2014-02-26 09:30:24',NULL,NULL),(22844,4279,'3343724','834','00','005010X220A1','3343724','','2014-03-05','20:45:23',0,'2014-03-06 21:01:35',NULL,NULL),(23450,4410,'3638319','834','00','005010X220A1','3638319','','2014-03-09','09:11:48',0,'2014-03-09 21:00:50',NULL,NULL),(23635,4441,'3407792','834','00','005010X220A1','3407792','','2014-03-10','13:16:44',0,'2014-03-10 21:01:40',NULL,NULL),(13794,2294,'2555768','834','00','005010X220A1','2555768','','2014-01-11','11:21:42',0,'2014-01-13 02:18:10',NULL,NULL),(2500,446,'830235','834','00','005010X220A1','830235','','2013-10-12','18:25:25',0,'2013-12-25 20:30:02',NULL,NULL),(7105,1236,'149419','834','00','005010X220A1','149419','','2013-12-18','12:38:04',0,'2013-12-26 04:03:45',NULL,NULL),(18961,3534,'2414739','834','00','005010X220A1','2414739','','2014-02-12','13:30:45',0,'2014-02-12 21:00:13',NULL,NULL),(18342,3394,'1434622','834','00','005010X220A1','1434622','','2014-02-08','17:58:04',0,'2014-02-08 19:01:02',NULL,NULL),(15916,2743,'1861545','834','00','005010X220A1','1861545','','2014-01-21','17:45:05',1,'2014-01-22 03:22:51',NULL,NULL),(10680,1403,'1549340','834','00','005010X220A1','1549340','','2013-12-22','21:24:51',0,'2013-12-26 12:59:44',NULL,NULL),(12175,1596,'1825643','834','00','005010X220A1','1825643','','2013-12-30','01:42:04',0,'2014-01-01 12:08:20',NULL,NULL),(12436,1638,'1957802','834','00','005010X220A1','1957802','','2013-12-31','14:42:53',1,'2014-01-02 04:30:58',NULL,NULL),(11001,1413,'1697485','834','00','005010X220A1','1697485','','2013-12-23','16:44:52',0,'2013-12-26 13:10:49',NULL,NULL),(19803,3677,'3143518','834','00','005010X220A1','3143518','','2014-02-15','14:30:51',0,'2014-02-15 22:01:25',NULL,NULL),(22828,4278,'3098299','834','00','005010X220A1','3098299','','2014-03-06','15:31:05',0,'2014-03-06 21:01:23',NULL,NULL),(23202,4347,'3722338','834','00','005010X220A1','3722338','','2014-03-06','20:30:51',0,'2014-03-07 21:31:47',NULL,NULL),(114,7,'124855','834','00','005010X220A1','124855','','2013-12-04','19:07:56',0,'2013-12-25 17:18:28',NULL,NULL),(352,72,'863677','834','00','005010X220A1','863677','','2013-12-04','16:33:30',0,'2013-12-25 17:46:51',NULL,NULL),(17194,3149,'1381398','834','00','005010X220A1','1381398','','2014-01-30','12:01:52',0,'2014-01-30 21:01:05',NULL,NULL),(16768,3072,'1947835','834','00','005010X220A1','1947835','','2014-01-27','10:19:22',0,'2014-01-27 21:01:32',NULL,NULL),(1761,294,'752662','834','00','005010X220A1','752662','','2013-12-10','17:20:34',0,'2013-12-25 19:18:18',NULL,NULL),(1860,324,'18034','834','00','005010X220A1','18034','','2013-12-09','12:30:00',0,'2013-12-25 19:30:32',NULL,NULL),(14525,2518,'1651595','834','00','005010X220A1','1651595','','2014-01-12','21:49:25',0,'2014-01-14 01:32:19',NULL,NULL),(5362,1008,'708119','834','00','005010X220A1','708119','','2013-11-25','06:56:23',0,'2013-12-26 01:16:15',NULL,NULL),(18142,3341,'1544152','834','00','005010X220A1','1544152','','2014-02-06','16:13:36',0,'2014-02-06 21:01:49',NULL,NULL),(13495,2229,'1799824','834','00','005010X220A1','1799824','','2014-01-06','15:18:36',0,'2014-01-07 04:04:26',NULL,NULL),(21940,4132,'3565513','834','00','005010X220A1','3565513','','2014-03-01','00:29:03',0,'2014-03-01 21:00:57',NULL,NULL),(22358,4205,'3189607','834','00','005010X220A1','3189607','','2014-03-04','12:09:16',0,'2014-03-04 21:01:45',NULL,NULL),(14506,2515,'2393912','834','00','005010X220A1','2393912','','2014-01-13','14:22:05',0,'2014-01-14 01:32:05',NULL,NULL),(18724,3485,'2627807','834','00','005010X220A1','2627807','','2014-02-11','07:16:39',0,'2014-02-11 21:00:18',NULL,NULL),(17598,3240,'1807647','834','00','005010X220A1','1807647','','2014-02-03','11:40:45',0,'2014-02-03 21:00:57',NULL,NULL),(16892,3098,'2248587','834','00','005010X220A1','2248587','','2014-01-28','10:18:09',0,'2014-01-28 21:01:08',NULL,NULL),(3882,700,'494809','834','00','005010X220A1','494809','','2013-10-04','12:02:51',0,'2013-12-25 22:31:36',NULL,NULL),(7551,1301,'540018','834','00','005010X220A1','540018','','2013-12-20','20:15:42',0,'2013-12-26 04:35:39',NULL,NULL),(21043,3977,'3498637','834','00','005010X220A1','3498637','','2014-02-24','14:53:30',0,'2014-02-26 09:30:21',NULL,NULL),(21312,4009,'3329187','834','00','005010X220A1','3329187','','2014-02-26','11:11:18',0,'2014-02-26 21:02:34',NULL,NULL),(22207,4186,'3784537','834','00','005010X220A1','3784537','','2014-03-02','20:45:26',0,'2014-03-03 21:31:36',NULL,NULL),(22817,4278,'2793013','834','00','005010X220A1','2793013','','2014-03-06','12:04:08',0,'2014-03-06 21:01:16',NULL,NULL),(22978,4317,'3202090','834','00','005010X220A1','3202090','','2014-03-06','13:52:54',0,'2014-03-06 21:30:18',NULL,NULL),(65,3,'498713','834','00','005010X220A1','498713','','2013-12-05','14:18:36',0,'2013-12-25 17:16:57',NULL,NULL),(17086,3136,'2099727','834','00','005010X220A1','2099727','','2014-01-29','13:14:56',0,'2014-01-29 21:01:49',NULL,NULL),(917,177,'542009','834','00','005010X220A1','542009','','2013-12-03','17:27:27',0,'2013-12-25 18:17:34',NULL,NULL),(7744,1344,'752126','834','00','005010X220A1','752126','','2013-10-20','18:42:52',0,'2013-12-26 05:00:40',NULL,NULL),(1820,312,'691694','834','00','005010X220A1','691694','','2013-12-10','14:21:25',0,'2013-12-25 19:20:15',NULL,NULL),(18834,3490,'2475911','834','00','005010X220A1','2475911','','2014-02-11','13:53:26',0,'2014-02-11 21:01:40',NULL,NULL),(19492,3620,'2575491','834','00','005010X220A1','2575491','','2014-02-14','13:09:10',0,'2014-02-14 21:30:20',NULL,NULL),(21858,4115,'2628328','834','00','005010X220A1','2628328','','2014-02-28','18:22:24',0,'2014-03-01 19:00:08',NULL,NULL),(881,177,'1237495','834','00','005010X220A1','1237495','','2013-12-03','09:09:13',0,'2013-12-25 18:16:36',NULL,NULL),(16797,3088,'2526694','834','00','005010X220A1','2526694','','2014-01-28','13:21:37',0,'2014-01-28 21:00:06',NULL,NULL),(13776,2287,'1388366','834','00','005010X220A1','1388366','','2014-01-06','20:42:13',0,'2014-01-08 18:25:03',NULL,NULL),(1162,239,'993652','834','00','005010X220A1','993652','','2013-12-24','12:20:12',0,'2013-12-25 18:46:33',NULL,NULL),(2241,373,'1166979','834','00','005010X220A1','1166979','','2013-12-02','11:38:54',0,'2013-12-25 19:49:36',NULL,NULL),(12309,1630,'1360285','834','00','005010X220A1','1360285','','2014-01-01','11:34:08',1,'2014-01-02 04:25:37',NULL,NULL),(18012,3318,'2586809','834','00','005010X220A1','2586809','','2014-02-05','18:34:00',0,'2014-02-06 21:00:16',NULL,NULL),(19956,3745,'3609171','834','00','005010X220A1','3609171','','2014-02-18','17:30:25',0,'2014-02-18 21:30:23',NULL,NULL),(19962,3746,'2826642','834','00','005010X220A1','2826642','','2014-02-18','10:27:16',0,'2014-02-18 22:00:05',NULL,NULL),(20016,3750,'3443662','834','00','005010X220A1','3443662','','2014-02-18','10:12:41',0,'2014-02-18 22:00:44',NULL,NULL),(22920,4288,'2897234','834','00','005010X220A1','2897234','','2014-03-06','16:37:28',0,'2014-03-06 21:02:31',NULL,NULL),(752,136,'1046951','834','00','005010X220A1','1046951','','2013-12-16','13:27:26',0,'2013-12-25 18:08:26',NULL,NULL),(1821,312,'1287104','834','00','005010X220A1','1287104','','2013-12-10','15:54:56',0,'2013-12-25 19:20:17',NULL,NULL),(14892,2558,'2005230','834','00','005010X220A1','2005230','','2014-01-14','11:09:29',0,'2014-01-15 02:07:27',NULL,NULL),(14663,2538,'1979611','834','00','005010X220A1','1979611','','2014-01-13','15:30:41',0,'2014-01-14 01:33:48',NULL,NULL),(7267,1250,'542458','834','00','005010X220A1','542458','','2013-12-18','07:49:45',0,'2013-12-26 04:08:43',NULL,NULL),(6331,1175,'1051233','834','00','005010X220A1','1051233','','2013-12-20','16:34:58',0,'2013-12-26 03:08:21',NULL,NULL),(2042,332,'413002','834','00','005010X220A1','413002','','2013-12-08','23:25:40',0,'2013-12-25 19:36:09',NULL,NULL),(5194,949,'726142','834','00','005010X220A1','726142','','2013-12-11','12:14:16',0,'2013-12-26 00:52:09',NULL,NULL),(2463,423,'1267410','834','00','005010X220A1','1267410','','2013-12-05','23:35:03',0,'2013-12-25 20:19:17',NULL,NULL),(5778,1074,'801008','834','00','005010X220A1','801008','','2013-12-14','10:26:09',0,'2013-12-26 02:02:50',NULL,NULL),(4581,826,'783227','834','00','005010X220A1','783227','','2013-12-23','22:18:11',0,'2013-12-25 23:46:39',NULL,NULL),(4142,733,'129956','834','00','005010X220A1','129956','','2013-12-19','16:09:38',0,'2013-12-25 23:04:26',NULL,NULL),(18882,3496,'3164901','834','00','005010X220A1','3164901','','2014-02-11','15:20:04',0,'2014-02-11 21:02:20',NULL,NULL),(21500,4030,'3697676','834','00','005010X220A1','3697676','','2014-02-27','11:12:04',0,'2014-02-28 06:31:21',NULL,NULL),(221,32,'249906','834','00','005010X220A1','249906','','2013-12-05','12:56:34',0,'2013-12-25 17:22:01',NULL,NULL),(17992,3314,'1889381','834','00','005010X220A1','1889381','','2014-02-05','14:25:07',0,'2014-02-05 21:31:17',NULL,NULL),(761,140,'1228385','834','00','005010X220A1','1228385','','2013-12-16','16:03:17',0,'2013-12-25 18:08:40',NULL,NULL),(1417,248,'1384479','834','00','005010X220A1','1384479','','2013-12-24','13:06:53',0,'2013-12-25 18:54:36',NULL,NULL),(10622,1402,'901656','834','00','005010X220A1','901656','','2013-12-23','15:22:52',0,'2013-12-26 12:57:53',NULL,NULL),(2071,341,'98842','834','00','005010X220A1','98842','','2013-12-09','11:18:26',0,'2013-12-25 19:37:07',NULL,NULL),(14161,2363,'2215295','834','00','005010X220A1','2215295','','2014-01-10','11:20:31',0,'2014-01-13 02:23:12',NULL,NULL),(6165,1167,'999714','834','00','005010X220A1','999714','','2013-12-20','14:10:24',0,'2013-12-26 03:03:16',NULL,NULL),(3550,616,'295695','834','00','005010X220A1','295695','','2013-12-12','14:52:50',0,'2013-12-25 22:02:45',NULL,NULL),(75,3,'927012','834','00','005010X220A1','927012','','2013-12-05','15:14:56',0,'2013-12-25 17:17:17',NULL,NULL),(202,20,'952880','834','00','005010X220A1','952880','','2013-12-05','17:38:44',0,'2013-12-25 17:21:18',NULL,NULL),(17128,3143,'1942811','834','00','005010X220A1','1942811','','2014-01-30','17:20:17',0,'2014-01-30 21:00:23',NULL,NULL),(16532,3019,'1690158','834','00','005010X220A1','1690158','','2014-01-24','00:06:19',0,'2014-01-24 21:01:01',NULL,NULL),(7591,1302,'721491','834','00','005010X220A1','721491','','2013-12-20','20:01:12',0,'2013-12-26 04:37:02',NULL,NULL),(14165,2363,'2097916','834','00','005010X220A1','2097916','','2014-01-10','12:37:28',0,'2014-01-13 02:23:15',NULL,NULL),(13825,2300,'2556877','834','00','005010X220A1','2556877','','2014-01-11','08:07:42',0,'2014-01-13 02:18:31',NULL,NULL),(5924,1112,'783942','834','00','005010X220A1','783942','','2013-12-15','14:39:01',0,'2013-12-26 02:31:31',NULL,NULL),(3995,730,'458701','834','00','005010X220A1','458701','','2013-12-07','15:29:54',0,'2013-12-25 22:48:08',NULL,NULL),(3737,641,'689366','834','00','005010X220A1','689366','','2013-12-12','15:49:44',0,'2013-12-25 22:08:46',NULL,NULL),(20151,3776,'3215690','834','00','005010X220A1','3215690','','2014-02-19','15:59:40',0,'2014-02-20 04:04:11',NULL,NULL),(21146,3997,'3211598','834','00','005010X220A1','3211598','','2014-02-26','09:32:12',0,'2014-02-26 21:00:41',NULL,NULL),(21543,4042,'3263930','834','00','005010X220A1','3263930','','2014-02-27','10:44:31',0,'2014-02-28 06:31:41',NULL,NULL),(21714,4088,'2665885','834','00','005010X220A1','2665885','','2014-02-28','11:04:44',0,'2014-02-28 21:30:24',NULL,NULL),(13818,2298,'1614332','834','00','005010X220A1','1614332','','2014-01-11','11:01:46',0,'2014-01-13 02:18:28',NULL,NULL),(18112,3330,'2381940','834','00','005010X220A1','2381940','','2014-02-05','22:07:19',0,'2014-02-06 21:01:25',NULL,NULL),(16818,3090,'2316990','834','00','005010X220A1','2316990','','2014-01-27','23:28:52',0,'2014-01-28 21:00:19',NULL,NULL),(16708,3064,'1542651','834','00','005010X220A1','1542651','','2014-01-27','10:54:28',0,'2014-01-27 21:00:48',NULL,NULL),(13870,2311,'2254387','834','00','005010X220A1','2254387','','2014-01-09','15:31:56',0,'2014-01-13 02:19:26',NULL,NULL),(14341,2401,'2230443','834','00','005010X220A1','2230443','','2014-01-11','20:43:51',0,'2014-01-13 03:01:19',NULL,NULL),(18683,3470,'3001309','834','00','005010X220A1','3001309','','2014-02-10','11:54:53',0,'2014-02-10 21:32:01',NULL,NULL),(20184,3780,'2851488','834','00','005010X220A1','2851488','','2014-02-18','18:28:46',0,'2014-02-20 04:14:06',NULL,NULL),(20967,3956,'3366549','834','00','005010X220A1','3366549','','2014-02-21','23:02:37',0,'2014-02-26 08:30:05',NULL,NULL),(11292,1455,'2209878','834','00','005010X220A1','2209878','','2013-12-26','16:48:54',0,'2013-12-27 02:03:16',NULL,NULL),(972,184,'272100','834','00','005010X220A1','272100','','2013-12-02','21:19:57',0,'2013-12-25 18:19:21',NULL,NULL),(1648,285,'90780','834','00','005010X220A1','90780','','2013-11-20','10:22:13',0,'2013-12-25 19:02:25',NULL,NULL),(4158,734,'264916','834','00','005010X220A1','264916','','2013-12-18','21:54:04',0,'2013-12-25 23:04:57',NULL,NULL),(2884,525,'584637','834','00','005010X220A1','584637','','2013-12-22','10:49:26',0,'2013-12-25 21:23:08',NULL,NULL),(22309,4201,'3861290','834','00','005010X220A1','3861290','','2014-03-04','13:28:10',0,'2014-03-04 21:01:05',NULL,NULL),(23632,4441,'2982170','834','00','005010X220A1','2982170','','2014-03-10','12:32:42',0,'2014-03-10 21:01:38',NULL,NULL),(474,92,'160788','834','00','005010X220A1','160788','','2013-12-04','07:57:12',0,'2013-12-25 17:50:48',NULL,NULL),(1279,243,'1792988','834','00','005010X220A1','1792988','','2013-12-24','16:40:39',0,'2013-12-25 18:50:08',NULL,NULL),(17263,3170,'2150061','834','00','005010X220A1','2150061','','2014-01-31','10:37:08',0,'2014-01-31 21:00:15',NULL,NULL),(16012,2767,'2225523','834','00','005010X220A1','2225523','','2014-01-21','18:59:46',0,'2014-01-23 03:02:18',NULL,NULL),(14696,2549,'1720105','834','00','005010X220A1','1720105','','2014-01-14','16:06:08',0,'2014-01-15 02:06:00',NULL,NULL),(11560,1492,'2049308','834','00','005010X220A1','2049308','','2013-12-27','11:00:29',0,'2013-12-28 03:33:30',NULL,NULL),(11679,1512,'2125087','834','00','005010X220A1','2125087','','2013-12-27','14:08:08',0,'2013-12-28 03:37:13',NULL,NULL),(10468,1400,'1121399','834','00','005010X220A1','1121399','','2013-12-23','14:24:23',0,'2013-12-26 12:52:53',NULL,NULL),(4932,916,'575946','834','00','005010X220A1','575946','','2013-10-16','19:09:19',0,'2013-12-26 00:31:11',NULL,NULL),(11730,1520,'1599811','834','00','005010X220A1','1599811','','2013-12-27','19:18:27',1,'2013-12-29 11:08:49',NULL,NULL),(12039,1583,'2221382','834','00','005010X220A1','2221382','','2013-12-30','15:14:14',0,'2014-01-01 12:03:33',NULL,NULL),(4107,733,'586780','834','00','005010X220A1','586780','','2013-12-19','12:30:59',0,'2013-12-25 23:03:25',NULL,NULL),(20190,3780,'3096655','834','00','005010X220A1','3096655','','2014-02-19','11:50:25',0,'2014-02-20 04:15:29',NULL,NULL),(21411,4026,'3441162','834','00','005010X220A1','3441162','','2014-02-26','20:07:23',0,'2014-02-28 06:30:40',NULL,NULL),(87,4,'1164622','834','00','005010X220A1','1164622','','2013-12-05','10:05:44',0,'2013-12-25 17:17:38',NULL,NULL),(11293,1455,'1769150','834','00','005010X220A1','1769150','','2013-12-26','17:21:37',0,'2013-12-27 02:03:17',NULL,NULL),(2007,330,'400909','834','00','005010X220A1','400909','','2013-12-09','15:46:10',0,'2013-12-25 19:35:05',NULL,NULL),(4856,885,'616132','834','00','005010X220A1','616132','','2013-11-21','09:56:33',0,'2013-12-26 00:15:47',NULL,NULL),(16182,2874,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:44:00',1,'2014-01-23 04:22:25',NULL,NULL),(4148,733,'860746','834','00','005010X220A1','860746','','2013-12-19','17:52:15',0,'2013-12-25 23:04:38',NULL,NULL),(14744,2550,'2452821','834','00','005010X220A1','2452821','','2014-01-14','16:56:35',0,'2014-01-15 02:06:21',NULL,NULL),(14862,2554,'2511004','834','00','005010X220A1','2511004','','2014-01-14','17:15:41',0,'2014-01-15 02:07:11',NULL,NULL),(19677,3663,'3313654','834','00','005010X220A1','3313654','','2014-02-14','17:08:47',0,'2014-02-14 22:00:09',NULL,NULL),(19696,3671,'2822193','834','00','005010X220A1','2822193','','2014-02-15','10:36:46',0,'2014-02-15 22:00:04',NULL,NULL),(20597,3870,'3057873','834','00','005010X220A1','3057873','','2014-02-21','12:10:10',0,'2014-02-21 22:00:12',NULL,NULL),(21932,4129,'3750061','834','00','005010X220A1','3750061','','2014-03-01','12:45:30',0,'2014-03-01 21:00:50',NULL,NULL),(12541,1650,'1621909','834','00','005010X220A1','1621909','','2013-12-31','13:43:22',1,'2014-01-02 04:34:53',NULL,NULL),(282,60,'610343','834','00','005010X220A1','610343','','2013-11-09','14:26:59',0,'2013-12-25 17:32:03',NULL,NULL),(11765,1527,'47569','834','00','005010X220A1','47569','','2013-12-28','16:20:41',1,'2013-12-29 11:09:54',NULL,NULL),(5361,1008,'1111298','834','00','005010X220A1','1111298','','2013-11-24','21:01:02',0,'2013-12-26 01:16:13',NULL,NULL),(5254,966,'333953','834','00','005010X220A1','333953','','2013-12-11','16:05:27',0,'2013-12-26 00:54:10',NULL,NULL),(4896,903,'498303','834','00','005010X220A1','498303','','2013-10-02','16:16:35',0,'2013-12-26 00:17:15',NULL,NULL),(4857,885,'95830','834','00','005010X220A1','95830','','2013-11-21','15:23:57',0,'2013-12-26 00:15:49',NULL,NULL),(4572,826,'1269320','834','00','005010X220A1','1269320','','2013-12-23','21:29:55',0,'2013-12-25 23:46:23',NULL,NULL),(10765,1404,'775912','834','00','005010X220A1','775912','','2013-12-22','21:20:43',0,'2013-12-26 13:02:46',NULL,NULL),(6258,1172,'1259377','834','00','005010X220A1','1259377','','2013-12-19','21:39:07',0,'2013-12-26 03:06:09',NULL,NULL),(15068,2585,'2095549','834','00','005010X220A1','2095549','','2014-01-15','12:16:43',0,'2014-01-16 08:45:00',NULL,NULL),(14462,2483,'0001','999','BE','005010X231A1','864853','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:35',NULL,NULL),(12166,1594,'1658959','834','00','005010X220A1','1658959','','2013-12-30','12:41:52',0,'2014-01-01 12:07:59',NULL,NULL),(20735,3903,'3594219','834','00','005010X220A1','3594219','','2014-02-24','21:50:32',0,'2014-02-25 21:30:06',NULL,NULL),(23504,4434,'3145670','834','00','005010X220A1','3145670','','2014-03-10','11:27:46',0,'2014-03-10 21:00:06',NULL,NULL),(183,16,'716733','834','00','005010X220A1','716733','','2013-12-05','11:03:58',0,'2013-12-25 17:20:40',NULL,NULL),(7283,1255,'1270155','834','00','005010X220A1','1270155','','2013-12-18','15:24:38',0,'2013-12-26 04:09:11',NULL,NULL),(2759,505,'1205747','834','00','005010X220A1','1205747','','2013-12-22','12:33:47',0,'2013-12-25 21:19:01',NULL,NULL),(14676,2548,'1415272','834','00','005010X220A1','1415272','','2014-01-14','11:24:47',0,'2014-01-15 02:05:51',NULL,NULL),(3105,546,'1063024','834','00','005010X220A1','1063024','','2013-12-13','13:19:11',0,'2013-12-25 21:36:19',NULL,NULL),(7136,1236,'768681','834','00','005010X220A1','768681','','2013-12-18','17:57:55',0,'2013-12-26 04:04:38',NULL,NULL),(5451,1037,'896745','834','00','005010X220A1','896745','','2013-11-02','19:35:44',0,'2013-12-26 01:32:03',NULL,NULL),(21406,4025,'3103041','834','00','005010X220A1','3103041','','2014-02-27','17:12:25',0,'2014-02-28 06:30:37',NULL,NULL),(23286,4380,'3356727','834','00','005010X220A1','3356727','','2014-03-07','19:02:56',0,'2014-03-08 21:30:09',NULL,NULL),(2176,363,'765650','834','00','005010X220A1','765650','','2013-12-01','19:15:58',0,'2013-12-25 19:47:21',NULL,NULL),(3071,545,'1184699','834','00','005010X220A1','1184699','','2013-12-13','18:05:08',0,'2013-12-25 21:35:19',NULL,NULL),(16736,3065,'2242998','834','00','005010X220A1','2242998','','2014-01-27','12:47:24',0,'2014-01-27 21:01:07',NULL,NULL),(5908,1112,'1225923','834','00','005010X220A1','1225923','','2013-12-14','19:06:24',0,'2013-12-26 02:31:02',NULL,NULL),(5152,943,'273643','834','00','005010X220A1','273643','','2013-12-11','17:02:18',0,'2013-12-26 00:50:51',NULL,NULL),(5873,1105,'585956','834','00','005010X220A1','585956','','2013-10-26','20:48:27',0,'2013-12-26 02:17:02',NULL,NULL),(5162,944,'1089406','834','00','005010X220A1','1089406','','2013-12-11','15:07:31',0,'2013-12-26 00:51:09',NULL,NULL),(21540,4040,'3700528','834','00','005010X220A1','3700528','','2014-02-27','10:13:08',0,'2014-02-28 06:31:40',NULL,NULL),(22818,4278,'3699303','834','00','005010X220A1','3699303','','2014-03-06','12:11:03',0,'2014-03-06 21:01:16',NULL,NULL),(13277,2121,'0001','999','BE','005010X231A1','386713','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:08',NULL,NULL),(15459,2632,'1984636','834','00','005010X220A1','1984636','','2014-01-16','14:33:50',0,'2014-01-17 03:36:13',NULL,NULL),(14318,2396,'1420027','834','00','005010X220A1','1420027','','2014-01-10','16:40:18',0,'2014-01-13 03:00:42',NULL,NULL),(1176,239,'2006039','834','00','005010X220A1','2006039','','2013-12-24','14:09:43',0,'2013-12-25 18:47:01',NULL,NULL),(12890,1708,'2331159','834','00','005010X220A1','2331159','','2014-01-02','20:10:41',0,'2014-01-04 02:04:32',NULL,NULL),(11981,1580,'1973069','834','00','005010X220A1','1973069','','2013-12-30','16:12:49',0,'2014-01-01 12:01:22',NULL,NULL),(22167,4180,'3703156','834','00','005010X220A1','3703156','','2014-03-03','12:37:29',0,'2014-03-03 21:31:08',NULL,NULL),(791,146,'939797','834','00','005010X220A1','939797','','2013-10-29','11:14:52',0,'2013-12-25 18:09:50',NULL,NULL),(13399,2221,'2081208','834','00','005010X220A1','2081208','','2014-01-06','17:45:16',0,'2014-01-07 04:00:52',NULL,NULL),(13289,2133,'0001','999','BE','005010X231A1','717888','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:41',NULL,NULL),(17626,3243,'2276404','834','00','005010X220A1','2276404','','2014-02-03','15:43:50',0,'2014-02-03 21:01:14',NULL,NULL),(17531,3235,'1695989','834','00','005010X220A1','1695989','','2014-02-03','14:24:33',0,'2014-02-03 21:00:15',NULL,NULL),(17285,3172,'1941699','834','00','005010X220A1','1941699','','2014-01-30','19:03:33',0,'2014-01-31 21:00:31',NULL,NULL),(13108,1952,'0001','999','BE','005010X231A1','367204','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:00',NULL,NULL),(16253,2945,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:48:00',0,'2014-01-23 07:07:03',NULL,NULL),(12220,1616,'1943511','834','00','005010X220A1','1943511','','2013-12-31','19:06:56',1,'2014-01-02 04:22:14',NULL,NULL),(10928,1410,'209363','834','00','005010X220A1','209363','','2013-12-23','11:46:18',0,'2013-12-26 13:08:34',NULL,NULL),(10792,1404,'1572495','834','00','005010X220A1','1572495','','2013-12-23','12:48:54',0,'2013-12-26 13:03:36',NULL,NULL),(19168,3557,'2466255','834','00','005010X220A1','2466255','','2014-02-12','16:37:38',0,'2014-02-12 21:32:23',NULL,NULL),(21456,4028,'3338625','834','00','005010X220A1','3338625','','2014-02-27','00:22:39',0,'2014-02-28 06:31:02',NULL,NULL),(22638,4253,'3783594','834','00','005010X220A1','3783594','','2014-03-04','21:46:23',0,'2014-03-05 21:31:45',NULL,NULL),(22689,4258,'3743369','834','00','005010X220A1','3743369','','2014-03-05','05:47:54',0,'2014-03-05 21:32:20',NULL,NULL),(12018,1583,'1372531','834','00','005010X220A1','1372531','','2013-12-30','11:59:48',0,'2014-01-01 12:02:45',NULL,NULL),(18942,3525,'2581635','834','00','005010X220A1','2581635','','2014-02-11','12:38:28',0,'2014-02-11 21:30:21',NULL,NULL),(5807,1080,'1218208','834','00','005010X220A1','1218208','','2013-12-14','12:43:52',0,'2013-12-26 02:03:45',NULL,NULL),(16931,3115,'2229789','834','00','005010X220A1','2229789','','2014-01-28','20:56:31',0,'2014-01-29 21:00:11',NULL,NULL),(13939,2317,'2064210','834','00','005010X220A1','2064210','','2014-01-09','17:12:47',0,'2014-01-13 02:20:12',NULL,NULL),(1466,252,'94054','834','00','005010X220A1','94054','','2013-12-24','15:12:22',0,'2013-12-25 18:56:19',NULL,NULL),(4222,738,'655925','834','00','005010X220A1','655925','','2013-12-19','08:42:48',0,'2013-12-25 23:06:53',NULL,NULL),(19490,3620,'3377361','834','00','005010X220A1','3377361','','2014-02-14','12:46:31',0,'2014-02-14 21:30:19',NULL,NULL),(908,177,'919270','834','00','005010X220A1','919270','','2013-12-03','14:21:15',0,'2013-12-25 18:17:19',NULL,NULL),(3805,661,'1249141','834','00','005010X220A1','1249141','','2013-12-08','09:09:23',0,'2013-12-25 22:16:29',NULL,NULL),(14089,2341,'1821282','834','00','005010X220A1','1821282','','2014-01-08','13:22:57',0,'2014-01-13 02:22:03',NULL,NULL),(16158,2850,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:06:00',1,'2014-01-23 04:08:58',NULL,NULL),(15725,2711,'1636014','834','00','005010X220A1','1636014','','2014-01-20','11:58:41',0,'2014-01-21 08:46:03',NULL,NULL),(14656,2531,'1466166','834','00','005010X220A1','1466166','','2014-01-13','12:15:28',0,'2014-01-14 01:33:42',NULL,NULL),(20732,3903,'2607236','834','00','005010X220A1','2607236','','2014-02-24','18:09:22',0,'2014-02-25 21:30:04',NULL,NULL),(22098,4176,'2827035','834','00','005010X220A1','2827035','','2014-03-03','13:08:39',0,'2014-03-03 21:30:17',NULL,NULL),(3257,579,'430643','834','00','005010X220A1','430643','','2013-12-17','09:57:26',0,'2013-12-25 21:47:02',NULL,NULL),(3388,588,'1187236','834','00','005010X220A1','1187236','','2013-12-16','19:39:02',0,'2013-12-25 21:51:19',NULL,NULL),(17067,3126,'2367312','834','00','005010X220A1','2367312','','2014-01-29','17:17:49',0,'2014-01-29 21:01:37',NULL,NULL),(3699,633,'1115390','834','00','005010X220A1','1115390','','2013-12-12','12:58:25',0,'2013-12-25 22:07:28',NULL,NULL),(1486,254,'1584080','834','00','005010X220A1','1584080','','2013-12-24','10:34:19',0,'2013-12-25 18:56:57',NULL,NULL),(18717,3485,'2169532','834','00','005010X220A1','2169532','','2014-02-10','21:26:56',0,'2014-02-11 21:00:13',NULL,NULL),(17977,3305,'2397366','834','00','005010X220A1','2397366','','2014-02-05','12:50:38',0,'2014-02-05 21:31:09',NULL,NULL),(17967,3302,'1771156','834','00','005010X220A1','1771156','','2014-02-04','20:23:38',0,'2014-02-05 21:31:04',NULL,NULL),(16131,2823,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:21:00',1,'2014-01-23 03:50:22',NULL,NULL),(2261,381,'560717','834','00','005010X220A1','560717','','2013-12-02','12:24:21',0,'2013-12-25 19:50:16',NULL,NULL),(4070,732,'1074620','834','00','005010X220A1','1074620','','2013-12-19','17:48:15',0,'2013-12-25 23:02:21',NULL,NULL),(13157,2001,'0001','999','BE','005010X231A1','294252','834','2013-12-28','04:55:00',0,'2014-01-05 16:57:52',NULL,NULL),(6450,1209,'1140460','834','00','005010X220A1','1140460','','2013-11-22','13:01:45',0,'2013-12-26 03:16:05',NULL,NULL),(10458,1400,'1469186','834','00','005010X220A1','1469186','','2013-12-23','13:38:09',0,'2013-12-26 12:52:33',NULL,NULL),(12940,1731,'139953','834','00','005010X220A1','139953','','2014-01-03','18:33:48',0,'2014-01-04 06:00:08',NULL,NULL),(11120,1428,'672562','834','00','005010X220A1','672562','','2013-12-22','22:27:49',0,'2013-12-26 13:14:48',NULL,NULL),(22001,4146,'3598017','834','00','005010X220A1','3598017','','2014-03-02','17:20:58',0,'2014-03-03 01:00:24',NULL,NULL),(646,108,'1058440','834','00','005010X220A1','1058440','','2013-12-16','15:12:43',0,'2013-12-25 18:05:06',NULL,NULL),(18189,3351,'2977428','834','00','005010X220A1','2977428','','2014-02-07','15:37:16',0,'2014-02-07 19:00:26',NULL,NULL),(17936,3298,'1731253','834','00','005010X220A1','1731253','','2014-02-04','19:25:59',0,'2014-02-05 21:30:48',NULL,NULL),(6209,1168,'1098777','834','00','005010X220A1','1098777','','2013-12-19','22:50:26',0,'2013-12-26 03:04:34',NULL,NULL),(16677,3061,'2397128','834','00','005010X220A1','2397128','','2014-01-27','16:35:48',0,'2014-01-27 21:00:28',NULL,NULL),(1299,244,'1429804','834','00','005010X220A1','1429804','','2013-12-24','14:11:27',0,'2013-12-25 18:50:45',NULL,NULL),(5921,1112,'1195680','834','00','005010X220A1','1195680','','2013-12-15','13:53:20',0,'2013-12-26 02:31:25',NULL,NULL),(2066,340,'1221390','834','00','005010X220A1','1221390','','2013-12-09','09:53:44',0,'2013-12-25 19:36:59',NULL,NULL),(2612,488,'237174','834','00','005010X220A1','237174','','2013-10-05','23:01:00',0,'2013-12-25 20:46:21',NULL,NULL),(4151,733,'534868','834','00','005010X220A1','534868','','2013-12-19','18:33:51',0,'2013-12-25 23:04:42',NULL,NULL),(2731,503,'1013027','834','00','005010X220A1','1013027','','2013-12-22','14:11:58',0,'2013-12-25 21:18:09',NULL,NULL),(3009,543,'48271','834','00','005010X220A1','48271','','2013-12-13','10:20:41',0,'2013-12-25 21:33:24',NULL,NULL),(2811,506,'381432','834','00','005010X220A1','381432','','2013-12-22','16:08:18',0,'2013-12-25 21:20:40',NULL,NULL),(7324,1270,'193885','834','00','005010X220A1','193885','','2013-12-18','18:07:45',0,'2013-12-26 04:10:27',NULL,NULL),(6295,1172,'1226203','834','00','005010X220A1','1226203','','2013-12-20','18:43:02',0,'2013-12-26 03:07:16',NULL,NULL),(3102,546,'11682','834','00','005010X220A1','11682','','2013-12-13','12:07:51',0,'2013-12-25 21:36:14',NULL,NULL),(4865,886,'276051','834','00','005010X220A1','276051','','2013-11-21','09:10:38',0,'2013-12-26 00:16:05',NULL,NULL),(3721,636,'290410','834','00','005010X220A1','290410','','2013-12-12','10:31:27',0,'2013-12-25 22:08:13',NULL,NULL),(6276,1172,'886583','834','00','005010X220A1','886583','','2013-12-20','14:06:05',0,'2013-12-26 03:06:43',NULL,NULL),(18426,3420,'2165057','834','00','005010X220A1','2165057','','2014-02-10','04:11:09',0,'2014-02-10 11:00:14',NULL,NULL),(10432,1400,'837839','834','00','005010X220A1','837839','','2013-12-23','11:13:26',0,'2013-12-26 12:51:41',NULL,NULL),(16922,3114,'1954762','834','00','005010X220A1','1954762','','2014-01-29','09:40:02',0,'2014-01-29 21:00:05',NULL,NULL),(16698,3064,'2436579','834','00','005010X220A1','2436579','','2014-01-26','20:54:38',0,'2014-01-27 21:00:42',NULL,NULL),(2234,372,'236320','834','00','005010X220A1','236320','','2013-12-02','08:55:28',0,'2013-12-25 19:49:21',NULL,NULL),(4340,756,'673678','834','00','005010X220A1','673678','','2013-12-19','14:16:54',0,'2013-12-25 23:10:29',NULL,NULL),(15692,2698,'2236983','834','00','005010X220A1','2236983','','2014-01-19','16:57:02',0,'2014-01-21 08:45:22',NULL,NULL),(5456,1039,'1051615','834','00','005010X220A1','1051615','','2013-11-02','19:35:44',0,'2013-12-26 01:32:12',NULL,NULL),(7431,1295,'770302','834','00','005010X220A1','770302','','2013-12-21','13:13:01',0,'2013-12-26 04:31:50',NULL,NULL),(18370,3406,'2581566','834','00','005010X220A1','2581566','','2014-02-09','12:33:11',0,'2014-02-09 19:00:15',NULL,NULL),(23140,4342,'3617787','834','00','005010X220A1','3617787','','2014-03-07','14:18:01',0,'2014-03-07 21:31:03',NULL,NULL),(11448,1488,'1474143','834','00','005010X220A1','1474143','','2013-12-26','18:48:51',0,'2013-12-28 03:30:05',NULL,NULL),(16013,2767,'2368185','834','00','005010X220A1','2368185','','2014-01-22','11:39:42',0,'2014-01-23 03:02:19',NULL,NULL),(15944,2759,'1972179','834','00','005010X220A1','1972179','','2014-01-21','12:38:20',1,'2014-01-22 03:23:09',NULL,NULL),(322,71,'1041607','834','00','005010X220A1','1041607','','2013-12-04','11:39:39',0,'2013-12-25 17:45:53',NULL,NULL),(12828,1704,'1488732','834','00','005010X220A1','1488732','','2014-01-03','10:36:32',0,'2014-01-04 02:02:15',NULL,NULL),(11410,1467,'1926695','834','00','005010X220A1','1926695','','2013-12-26','11:26:26',0,'2013-12-27 02:06:53',NULL,NULL),(4620,827,'428146','834','00','005010X220A1','428146','','2013-12-23','21:56:50',0,'2013-12-25 23:47:52',NULL,NULL),(5693,1067,'1272835','834','00','005010X220A1','1272835','','2013-12-14','09:23:15',0,'2013-12-26 02:00:11',NULL,NULL),(10471,1400,'1040895','834','00','005010X220A1','1040895','','2013-12-23','14:25:51',0,'2013-12-26 12:52:58',NULL,NULL),(2829,510,'731898','834','00','005010X220A1','731898','','2013-12-22','12:16:39',0,'2013-12-25 21:21:16',NULL,NULL),(11038,1418,'762911','834','00','005010X220A1','762911','','2013-12-23','09:17:54',0,'2013-12-26 13:12:03',NULL,NULL),(10724,1403,'1572512','834','00','005010X220A1','1572512','','2013-12-23','14:09:31',0,'2013-12-26 13:01:25',NULL,NULL),(17955,3299,'1713680','834','00','005010X220A1','1713680','','2014-02-05','15:12:41',0,'2014-02-05 21:30:57',NULL,NULL),(18221,3357,'2819346','834','00','005010X220A1','2819346','','2014-02-07','08:23:39',0,'2014-02-07 19:00:50',NULL,NULL),(19732,3673,'3462710','834','00','005010X220A1','3462710','','2014-02-14','22:21:26',0,'2014-02-15 22:00:31',NULL,NULL),(23518,4434,'3332042','834','00','005010X220A1','3332042','','2014-03-10','15:18:13',0,'2014-03-10 21:00:15',NULL,NULL),(12255,1620,'2322369','834','00','005010X220A1','2322369','','2013-12-31','22:24:01',1,'2014-01-02 04:23:37',NULL,NULL),(10525,1401,'99476','834','00','005010X220A1','99476','','2013-12-23','09:46:36',0,'2013-12-26 12:54:39',NULL,NULL),(1292,244,'800128','834','00','005010X220A1','800128','','2013-12-24','08:24:51',0,'2013-12-25 18:50:32',NULL,NULL),(6114,1166,'1263217','834','00','005010X220A1','1263217','','2013-12-20','13:46:52',0,'2013-12-26 03:01:43',NULL,NULL),(7000,1235,'1092503','834','00','005010X220A1','1092503','','2013-12-17','20:08:48',0,'2013-12-26 04:00:27',NULL,NULL),(2038,331,'55763','834','00','005010X220A1','55763','','2013-12-09','17:52:22',0,'2013-12-25 19:36:02',NULL,NULL),(1774,298,'663524','834','00','005010X220A1','663524','','2013-12-10','16:20:37',0,'2013-12-25 19:18:44',NULL,NULL),(7759,1347,'870569','834','00','005010X220A1','870569','','2013-10-21','09:54:40',0,'2013-12-26 05:01:10',NULL,NULL),(17696,3261,'2060448','834','00','005010X220A1','2060448','','2014-02-03','18:46:27',0,'2014-02-04 21:00:28',NULL,NULL),(20777,3907,'3536310','834','00','005010X220A1','3536310','','2014-02-25','11:38:35',0,'2014-02-25 21:30:38',NULL,NULL),(12023,1583,'2136454','834','00','005010X220A1','2136454','','2013-12-30','12:57:12',0,'2014-01-01 12:02:57',NULL,NULL),(16730,3065,'2351099','834','00','005010X220A1','2351099','','2014-01-26','21:57:37',0,'2014-01-27 21:01:04',NULL,NULL),(16067,2773,'2326345','834','00','005010X220A1','2326345','','2014-01-22','11:06:55',0,'2014-01-23 03:02:43',NULL,NULL),(611,108,'334105','834','00','005010X220A1','334105','','2013-12-15','20:49:10',0,'2013-12-25 18:03:56',NULL,NULL),(1516,259,'1805409','834','00','005010X220A1','1805409','','2013-12-24','10:27:19',0,'2013-12-25 18:57:54',NULL,NULL),(12944,1733,'1437553','834','00','005010X220A1','1437553','','2014-01-03','18:52:25',0,'2014-01-05 00:00:07',NULL,NULL),(14594,2521,'1459715','834','00','005010X220A1','1459715','','2014-01-13','13:38:49',0,'2014-01-14 01:33:02',NULL,NULL),(13103,1947,'0001','999','BE','005010X231A1','910292','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:46',NULL,NULL),(21790,4092,'2917927','834','00','005010X220A1','2917927','','2014-02-27','21:52:24',0,'2014-02-28 21:31:15',NULL,NULL),(23411,4404,'2913260','834','00','005010X220A1','2913260','','2014-03-09','11:53:23',0,'2014-03-09 21:00:19',NULL,NULL),(23726,4461,'3720362','834','00','005010X220A1','3720362','','2014-03-10','17:35:37',0,'2014-03-10 21:02:48',NULL,NULL),(1200,240,'825865','834','00','005010X220A1','825865','','2013-12-24','11:08:20',0,'2013-12-25 18:47:45',NULL,NULL),(15938,2755,'2563515','834','00','005010X220A1','2563515','','2014-01-21','10:31:16',1,'2014-01-22 03:23:05',NULL,NULL),(5035,935,'542207','834','00','005010X220A1','542207','','2013-12-11','14:10:01',0,'2013-12-26 00:47:06',NULL,NULL),(2037,331,'925817','834','00','005010X220A1','925817','','2013-12-09','17:45:13',0,'2013-12-25 19:36:01',NULL,NULL),(13811,2297,'1907276','834','00','005010X220A1','1907276','','2014-01-10','20:57:24',0,'2014-01-13 02:18:22',NULL,NULL),(13405,2222,'1966801','834','00','005010X220A1','1966801','','2014-01-06','15:43:18',0,'2014-01-07 04:01:04',NULL,NULL),(13323,2167,'0001','999','BE','005010X231A1','437088','834','2013-12-28','04:55:00',0,'2014-01-05 17:25:16',NULL,NULL),(2122,360,'504904','834','00','005010X220A1','504904','','2013-12-02','11:25:12',0,'2013-12-25 19:45:35',NULL,NULL),(12507,1642,'2022632','834','00','005010X220A1','2022632','','2013-12-31','15:49:01',1,'2014-01-02 04:33:38',NULL,NULL),(12366,1634,'1766699','834','00','005010X220A1','1766699','','2013-12-31','16:06:29',1,'2014-01-02 04:28:27',NULL,NULL),(19396,3593,'2976262','834','00','005010X220A1','2976262','','2014-02-13','11:46:19',0,'2014-02-13 22:02:27',NULL,NULL),(19813,3679,'2760101','834','00','005010X220A1','2760101','','2014-02-14','19:02:56',0,'2014-02-15 22:01:33',NULL,NULL),(20812,3910,'3339717','834','00','005010X220A1','3339717','','2014-02-25','12:11:20',0,'2014-02-25 21:31:03',NULL,NULL),(1414,248,'1291907','834','00','005010X220A1','1291907','','2013-12-24','07:24:03',0,'2013-12-25 18:54:30',NULL,NULL),(1431,252,'1400631','834','00','005010X220A1','1400631','','2013-12-24','09:47:47',0,'2013-12-25 18:55:05',NULL,NULL),(2432,417,'446014','834','00','005010X220A1','446014','','2013-12-06','10:45:07',0,'2013-12-25 20:18:14',NULL,NULL),(14972,2571,'2256674','834','00','005010X220A1','2256674','','2014-01-14','17:28:21',0,'2014-01-15 02:08:03',NULL,NULL),(14807,2552,'1898854','834','00','005010X220A1','1898854','','2014-01-13','19:11:56',0,'2014-01-15 02:06:47',NULL,NULL),(2515,449,'463206','834','00','005010X220A1','463206','','2013-10-12','22:17:49',0,'2013-12-25 20:30:28',NULL,NULL),(12654,1672,'2548540','834','00','005010X220A1','2548540','','2014-01-02','15:50:29',0,'2014-01-03 02:03:06',NULL,NULL),(3273,582,'714236','834','00','005010X220A1','714236','','2013-12-17','13:06:38',0,'2013-12-25 21:47:35',NULL,NULL),(3538,616,'446165','834','00','005010X220A1','446165','','2013-12-12','10:29:25',0,'2013-12-25 22:02:24',NULL,NULL),(3859,689,'1013393','834','00','005010X220A1','1013393','','2013-10-10','16:59:34',0,'2013-12-25 22:30:54',NULL,NULL),(18417,3420,'1843813','834','00','005010X220A1','1843813','','2014-02-10','00:09:22',0,'2014-02-10 11:00:07',NULL,NULL),(22996,4322,'2866230','834','00','005010X220A1','2866230','','2014-03-07','10:03:38',0,'2014-03-07 21:00:10',NULL,NULL),(23525,4434,'3208436','834','00','005010X220A1','3208436','','2014-03-10','16:37:15',0,'2014-03-10 21:00:20',NULL,NULL),(12171,1594,'1880144','834','00','005010X220A1','1880144','','2013-12-30','18:33:33',0,'2014-01-01 12:08:09',NULL,NULL),(16358,2984,'1729820','834','00','005010X220A1','1729820','','2014-01-22','19:34:19',0,'2014-01-23 21:00:54',NULL,NULL),(2266,385,'199774','834','00','005010X220A1','199774','','2013-12-02','10:19:10',0,'2013-12-25 19:50:29',NULL,NULL),(2467,426,'863735','834','00','005010X220A1','863735','','2013-12-06','17:16:14',0,'2013-12-25 20:19:25',NULL,NULL),(3857,688,'413809','834','00','005010X220A1','413809','','2013-11-08','13:56:37',0,'2013-12-25 22:30:49',NULL,NULL),(18395,3411,'2687030','834','00','005010X220A1','2687030','','2014-02-09','12:40:36',0,'2014-02-09 19:00:32',NULL,NULL),(18844,3491,'2323423','834','00','005010X220A1','2323423','','2014-02-11','11:59:22',0,'2014-02-11 21:01:48',NULL,NULL),(22532,4247,'3014512','834','00','005010X220A1','3014512','','2014-03-05','16:27:52',0,'2014-03-05 21:30:29',NULL,NULL),(12412,1638,'1987932','834','00','005010X220A1','1987932','','2013-12-30','18:45:25',1,'2014-01-02 04:30:06',NULL,NULL),(12190,1605,'2353978','834','00','005010X220A1','2353978','','2013-12-30','15:01:51',0,'2014-01-01 12:08:58',NULL,NULL),(10794,1404,'1514288','834','00','005010X220A1','1514288','','2013-12-23','13:03:23',0,'2013-12-26 13:03:40',NULL,NULL),(10708,1403,'47274','834','00','005010X220A1','47274','','2013-12-23','11:19:28',0,'2013-12-26 13:00:49',NULL,NULL),(14176,2364,'1573071','834','00','005010X220A1','1573071','','2014-01-10','14:39:10',0,'2014-01-13 02:23:25',NULL,NULL),(5227,954,'962005','834','00','005010X220A1','962005','','2013-12-11','16:28:50',0,'2013-12-26 00:53:18',NULL,NULL),(13084,1928,'0001','999','BE','005010X231A1','160713','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:54',NULL,NULL),(13020,1746,'2190189','834','00','005010X220A1','2190189','','2014-01-04','13:18:47',0,'2014-01-05 00:02:58',NULL,NULL),(3233,578,'876167','834','00','005010X220A1','876167','','2013-12-17','13:20:10',0,'2013-12-25 21:46:19',NULL,NULL),(3842,682,'1188127','834','00','005010X220A1','1188127','','2013-11-08','14:11:26',0,'2013-12-25 22:30:19',NULL,NULL),(18162,3350,'2342343','834','00','005010X220A1','2342343','','2014-02-06','20:49:01',0,'2014-02-07 19:00:09',NULL,NULL),(20582,3869,'2668091','834','00','005010X220A1','2668091','','2014-02-21','13:01:13',0,'2014-02-21 21:30:24',NULL,NULL),(20618,3871,'3499798','834','00','005010X220A1','3499798','','2014-02-20','18:33:57',0,'2014-02-21 22:00:29',NULL,NULL),(20917,3932,'3591781','834','00','005010X220A1','3591781','','2014-02-23','13:36:41',0,'2014-02-26 08:00:14',NULL,NULL),(235,39,'269094','834','00','005010X220A1','269094','','2013-10-12','12:24:07',0,'2013-12-25 17:30:23',NULL,NULL),(12386,1637,'2487116','834','00','005010X220A1','2487116','','2013-12-31','08:59:59',1,'2014-01-02 04:29:09',NULL,NULL),(16205,2897,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 04:52:47',NULL,NULL),(1517,259,'1784553','834','00','005010X220A1','1784553','','2013-12-24','13:34:14',0,'2013-12-25 18:57:56',NULL,NULL),(11741,1521,'2230056','834','00','005010X220A1','2230056','','2013-12-28','12:18:44',1,'2013-12-29 11:09:10',NULL,NULL),(14405,2426,'0001','999','BE','005010X231A1','119443','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:18',NULL,NULL),(14018,2337,'2547561','834','00','005010X220A1','2547561','','2014-01-08','10:34:16',0,'2014-01-13 02:21:17',NULL,NULL),(13563,2253,'1786108','834','00','005010X220A1','1786108','','2014-01-05','12:40:58',1,'2014-01-07 10:21:18',NULL,NULL),(2085,346,'534411','834','00','005010X220A1','534411','','2013-12-09','11:55:30',0,'2013-12-25 19:37:33',NULL,NULL),(4398,776,'505943','834','00','005010X220A1','505943','','2013-11-26','19:38:34',0,'2013-12-25 23:15:52',NULL,NULL),(2352,413,'660937','834','00','005010X220A1','660937','','2013-12-06','17:05:34',0,'2013-12-25 20:15:42',NULL,NULL),(23666,4444,'3875301','834','00','005010X220A1','3875301','','2014-03-10','13:19:02',0,'2014-03-10 21:02:02',NULL,NULL),(382,74,'723661','834','00','005010X220A1','723661','','2013-12-04','16:30:06',0,'2013-12-25 17:47:48',NULL,NULL),(465,87,'1273647','834','00','005010X220A1','1273647','','2013-12-04','14:31:24',0,'2013-12-25 17:50:28',NULL,NULL),(1622,281,'1179028','834','00','005010X220A1','1179028','','2013-11-19','23:04:30',0,'2013-12-25 19:01:45',NULL,NULL),(16593,3042,'2361947','834','00','005010X220A1','2361947','','2014-01-25','13:06:20',0,'2014-01-25 19:00:18',NULL,NULL),(4140,733,'462966','834','00','005010X220A1','462966','','2013-12-19','15:57:22',0,'2013-12-25 23:04:22',NULL,NULL),(16043,2772,'2604186','834','00','005010X220A1','2604186','','2014-01-21','21:25:48',0,'2014-01-23 03:02:32',NULL,NULL),(13894,2312,'1844808','834','00','005010X220A1','1844808','','2014-01-09','15:43:58',0,'2014-01-13 02:19:41',NULL,NULL),(14230,2368,'1979551','834','00','005010X220A1','1979551','','2014-01-10','17:26:24',0,'2014-01-13 02:24:04',NULL,NULL),(18290,3380,'2855830','834','00','005010X220A1','2855830','','2014-02-07','21:01:13',0,'2014-02-08 19:00:28',NULL,NULL),(12305,1630,'1798347','834','00','005010X220A1','1798347','','2014-01-01','10:39:31',1,'2014-01-02 04:25:28',NULL,NULL),(10455,1400,'318552','834','00','005010X220A1','318552','','2013-12-23','13:25:32',0,'2013-12-26 12:52:27',NULL,NULL),(2673,501,'1192390','834','00','005010X220A1','1192390','','2013-12-22','18:08:40',0,'2013-12-25 21:16:17',NULL,NULL),(14468,2489,'0001','999','BE','005010X231A1','375710','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:41',NULL,NULL),(3049,544,'377585','834','00','005010X220A1','377585','','2013-12-13','13:18:52',0,'2013-12-25 21:34:34',NULL,NULL),(18308,3383,'2603519','834','00','005010X220A1','2603519','','2014-02-08','15:08:36',0,'2014-02-08 19:00:40',NULL,NULL),(19530,3622,'2408730','834','00','005010X220A1','2408730','','2014-02-14','16:07:21',0,'2014-02-14 21:30:47',NULL,NULL),(23073,4339,'3112088','834','00','005010X220A1','3112088','','2014-03-07','10:38:14',0,'2014-03-07 21:30:16',NULL,NULL),(23243,4365,'3892172','834','00','005010X220A1','3892172','','2014-03-07','11:25:56',0,'2014-03-07 21:32:18',NULL,NULL),(777,144,'512204','834','00','005010X220A1','512204','','2013-10-31','16:58:40',0,'2013-12-25 18:09:18',NULL,NULL),(7228,1241,'232944','834','00','005010X220A1','232944','','2013-12-18','15:31:44',0,'2013-12-26 04:07:29',NULL,NULL),(12360,1634,'141820','834','00','005010X220A1','141820','','2013-12-31','14:49:50',1,'2014-01-02 04:28:12',NULL,NULL),(12049,1585,'1948139','834','00','005010X220A1','1948139','','2013-12-29','19:27:40',0,'2014-01-01 12:03:59',NULL,NULL),(5468,1040,'1366197','834','00','005010X220A1','1366197','','2013-12-24','21:30:32',0,'2013-12-26 01:45:23',NULL,NULL),(18572,3453,'2879447','834','00','005010X220A1','2879447','','2014-02-10','13:53:40',0,'2014-02-10 21:30:44',NULL,NULL),(19753,3673,'2427708','834','00','005010X220A1','2427708','','2014-02-15','15:02:48',0,'2014-02-15 22:00:46',NULL,NULL),(22327,4202,'3759027','834','00','005010X220A1','3759027','','2014-03-04','17:10:12',0,'2014-03-04 21:01:19',NULL,NULL),(4360,763,'4383','834','00','005010X220A1','4383','','2013-12-19','14:55:51',0,'2013-12-25 23:11:04',NULL,NULL),(7043,1235,'629553','834','00','005010X220A1','629553','','2013-12-18','15:49:59',0,'2013-12-26 04:01:50',NULL,NULL),(13343,2187,'0001','999','BE','005010X231A1','457234','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:11',NULL,NULL),(15242,2598,'1838481','834','00','005010X220A1','1838481','','2014-01-14','18:50:23',0,'2014-01-16 08:46:51',NULL,NULL),(14658,2533,'1989438','834','00','005010X220A1','1989438','','2014-01-13','13:26:37',0,'2014-01-14 01:33:43',NULL,NULL),(19033,3540,'2505627','834','00','005010X220A1','2505627','','2014-02-11','23:14:35',0,'2014-02-12 21:30:49',NULL,NULL),(22897,4284,'3644510','834','00','005010X220A1','3644510','','2014-03-06','15:30:00',0,'2014-03-06 21:02:13',NULL,NULL),(835,173,'652607','834','00','005010X220A1','652607','','2013-12-03','14:04:40',0,'2013-12-25 18:15:12',NULL,NULL),(11204,1454,'2090166','834','00','005010X220A1','2090166','','2013-12-25','23:48:58',0,'2013-12-27 02:00:33',NULL,NULL),(10536,1401,'545678','834','00','005010X220A1','545678','','2013-12-23','15:52:19',0,'2013-12-26 12:55:00',NULL,NULL),(2803,506,'248223','834','00','005010X220A1','248223','','2013-12-22','14:05:26',0,'2013-12-25 21:20:26',NULL,NULL),(17093,3140,'1576144','834','00','005010X220A1','1576144','','2014-01-29','17:36:23',0,'2014-01-29 21:01:54',NULL,NULL),(15528,2654,'2176886','834','00','005010X220A1','2176886','','2014-01-16','19:10:12',0,'2014-01-20 08:05:33',NULL,NULL),(3953,715,'670494','834','00','005010X220A1','670494','','2013-12-07','16:42:03',0,'2013-12-25 22:46:38',NULL,NULL),(3639,622,'1101242','834','00','005010X220A1','1101242','','2013-12-12','15:42:20',0,'2013-12-25 22:05:34',NULL,NULL),(4612,827,'1780549','834','00','005010X220A1','1780549','','2013-12-23','21:17:40',0,'2013-12-25 23:47:37',NULL,NULL),(18839,3491,'2798966','834','00','005010X220A1','2798966','','2014-02-10','19:56:10',0,'2014-02-11 21:01:43',NULL,NULL),(18984,3537,'2930880','834','00','005010X220A1','2930880','','2014-02-12','12:27:15',0,'2014-02-12 21:30:16',NULL,NULL),(21217,3998,'3099322','834','00','005010X220A1','3099322','','2014-02-26','16:51:38',0,'2014-02-26 21:01:29',NULL,NULL),(22700,4261,'2695530','834','00','005010X220A1','2695530','','2014-03-05','15:35:30',0,'2014-03-05 21:32:28',NULL,NULL),(23039,4331,'2779680','834','00','005010X220A1','2779680','','2014-03-07','11:14:35',0,'2014-03-07 21:00:30',NULL,NULL),(23532,4435,'3251186','834','00','005010X220A1','3251186','','2014-03-09','19:44:20',0,'2014-03-10 21:00:25',NULL,NULL),(524,102,'963237','834','00','005010X220A1','963237','','2013-12-16','13:19:03',0,'2013-12-25 18:01:10',NULL,NULL),(16530,3018,'1655426','834','00','005010X220A1','1655426','','2014-01-23','20:20:49',0,'2014-01-24 21:01:00',NULL,NULL),(12091,1586,'1654838','834','00','005010X220A1','1654838','','2013-12-30','17:49:13',0,'2014-01-01 12:05:24',NULL,NULL),(11016,1414,'9373','834','00','005010X220A1','9373','','2013-12-23','12:45:47',0,'2013-12-26 13:11:21',NULL,NULL),(3759,652,'737239','834','00','005010X220A1','737239','','2013-12-12','16:34:33',0,'2013-12-25 22:09:33',NULL,NULL),(7578,1301,'237049','834','00','005010X220A1','237049','','2013-12-21','15:32:36',0,'2013-12-26 04:36:32',NULL,NULL),(19343,3583,'3036569','834','00','005010X220A1','3036569','','2014-02-13','15:43:41',0,'2014-02-13 22:01:46',NULL,NULL),(19637,3643,'2285438','834','00','005010X220A1','2285438','','2014-02-14','13:27:24',0,'2014-02-14 21:32:05',NULL,NULL),(20778,3907,'2992906','834','00','005010X220A1','2992906','','2014-02-25','13:48:29',0,'2014-02-25 21:30:40',NULL,NULL),(21187,3998,'3749950','834','00','005010X220A1','3749950','','2014-02-26','13:41:18',0,'2014-02-26 21:01:08',NULL,NULL),(21671,4078,'3193179','834','00','005010X220A1','3193179','','2014-02-28','16:28:26',0,'2014-02-28 21:00:14',NULL,NULL),(12892,1709,'2151659','834','00','005010X220A1','2151659','','2014-01-03','08:24:28',0,'2014-01-04 02:04:36',NULL,NULL),(12823,1704,'2390916','834','00','005010X220A1','2390916','','2014-01-03','00:04:30',0,'2014-01-04 02:02:06',NULL,NULL),(16896,3099,'1652019','834','00','005010X220A1','1652019','','2014-01-28','12:05:35',0,'2014-01-28 21:01:11',NULL,NULL),(11403,1465,'959972','834','00','005010X220A1','959972','','2013-12-26','16:01:43',0,'2013-12-27 02:06:39',NULL,NULL),(10456,1400,'1473875','834','00','005010X220A1','1473875','','2013-12-23','13:30:07',0,'2013-12-26 12:52:30',NULL,NULL),(15095,2585,'1992394','834','00','005010X220A1','1992394','','2014-01-15','17:45:51',0,'2014-01-16 08:45:16',NULL,NULL),(6360,1180,'10672','834','00','005010X220A1','10672','','2013-12-20','18:10:43',0,'2013-12-26 03:09:11',NULL,NULL),(18831,3490,'3157106','834','00','005010X220A1','3157106','','2014-02-11','13:06:18',0,'2014-02-11 21:01:38',NULL,NULL),(21137,3996,'3511369','834','00','005010X220A1','3511369','','2014-02-26','07:54:46',0,'2014-02-26 21:00:36',NULL,NULL),(21884,4123,'3480634','834','00','005010X220A1','3480634','','2014-03-01','15:23:01',0,'2014-03-01 21:00:19',NULL,NULL),(22621,4251,'3414671','834','00','005010X220A1','3414671','','2014-03-05','14:18:53',0,'2014-03-05 21:31:33',NULL,NULL),(23471,4419,'3631203','834','00','005010X220A1','3631203','','2014-03-09','14:08:20',0,'2014-03-09 21:01:10',NULL,NULL),(12593,1671,'1893610','834','00','005010X220A1','1893610','','2014-01-02','12:22:18',0,'2014-01-03 02:00:51',NULL,NULL),(1024,192,'503761','834','00','005010X220A1','503761','','2013-12-03','11:09:38',0,'2013-12-25 18:21:01',NULL,NULL),(11553,1492,'1908182','834','00','005010X220A1','1908182','','2013-12-26','21:33:17',0,'2013-12-28 03:33:15',NULL,NULL),(1852,324,'1195420','834','00','005010X220A1','1195420','','2013-12-09','09:27:05',0,'2013-12-25 19:30:15',NULL,NULL),(13734,2275,'1809623','834','00','005010X220A1','1809623','','2014-01-07','15:00:00',0,'2014-01-08 18:24:44',NULL,NULL),(13810,2297,'1685039','834','00','005010X220A1','1685039','','2014-01-10','18:47:04',0,'2014-01-13 02:18:22',NULL,NULL),(13760,2277,'2296426','834','00','005010X220A1','2296426','','2014-01-07','17:59:53',0,'2014-01-08 18:24:56',NULL,NULL),(21609,4064,'3625540','834','00','005010X220A1','3625540','','2014-02-27','13:33:31',0,'2014-02-28 07:30:12',NULL,NULL),(11586,1492,'1913988','834','00','005010X220A1','1913988','','2013-12-27','16:57:29',0,'2013-12-28 03:34:17',NULL,NULL),(413,77,'1043918','834','00','005010X220A1','1043918','','2013-12-04','12:23:53',0,'2013-12-25 17:48:47',NULL,NULL),(16166,2858,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:42:00',1,'2014-01-23 04:15:07',NULL,NULL),(10984,1413,'652146','834','00','005010X220A1','652146','','2013-12-23','10:03:39',0,'2013-12-26 13:10:13',NULL,NULL),(5589,1043,'95567','834','00','005010X220A1','95567','','2013-12-25','00:17:11',0,'2013-12-26 01:49:18',NULL,NULL),(1678,290,'72943','834','00','005010X220A1','72943','','2013-12-10','17:04:35',0,'2013-12-25 19:15:47',NULL,NULL),(3628,622,'556140','834','00','005010X220A1','556140','','2013-12-11','22:42:03',0,'2013-12-25 22:05:14',NULL,NULL),(19888,3711,'2981514','834','00','005010X220A1','2981514','','2014-02-15','20:29:10',0,'2014-02-16 19:00:30',NULL,NULL),(20845,3911,'3419772','834','00','005010X220A1','3419772','','2014-02-25','14:00:31',0,'2014-02-25 21:31:26',NULL,NULL),(22695,4260,'3811640','834','00','005010X220A1','3811640','','2014-03-05','15:54:47',0,'2014-03-05 21:32:24',NULL,NULL),(23070,4339,'3329553','834','00','005010X220A1','3329553','','2014-03-07','09:25:22',0,'2014-03-07 21:30:13',NULL,NULL),(26,1,'920734','834','00','005010X220A1','920734','','2013-12-05','17:06:52',0,'2013-12-25 17:15:48',NULL,NULL),(16500,3011,'2495353','834','00','005010X220A1','2495353','','2014-01-24','13:17:52',0,'2014-01-24 21:00:41',NULL,NULL),(1359,245,'1567461','834','00','005010X220A1','1567461','','2013-12-24','14:24:02',0,'2013-12-25 18:52:43',NULL,NULL),(4297,747,'655941','834','00','005010X220A1','655941','','2013-12-19','12:46:35',0,'2013-12-25 23:09:13',NULL,NULL),(15814,2730,'2304089','834','00','005010X220A1','2304089','','2014-01-20','13:26:21',0,'2014-01-21 08:46:57',NULL,NULL),(2056,336,'927077','834','00','005010X220A1','927077','','2013-12-09','13:53:16',0,'2013-12-25 19:36:37',NULL,NULL),(2561,463,'656481','834','00','005010X220A1','656481','','2013-11-18','17:50:33',0,'2013-12-25 20:31:57',NULL,NULL),(18539,3452,'1956218','834','00','005010X220A1','1956218','','2014-02-09','18:35:17',0,'2014-02-10 21:30:21',NULL,NULL),(18575,3453,'2066361','834','00','005010X220A1','2066361','','2014-02-10','14:44:58',0,'2014-02-10 21:30:46',NULL,NULL),(23355,4389,'2782178','834','00','005010X220A1','2782178','','2014-03-08','15:19:10',0,'2014-03-08 21:31:02',NULL,NULL),(7029,1235,'856865','834','00','005010X220A1','856865','','2013-12-18','12:42:27',0,'2013-12-26 04:01:23',NULL,NULL),(17269,3170,'2022173','834','00','005010X220A1','2022173','','2014-01-31','12:34:04',0,'2014-01-31 21:00:20',NULL,NULL),(6354,1180,'1127725','834','00','005010X220A1','1127725','','2013-12-19','21:33:39',0,'2013-12-26 03:09:00',NULL,NULL),(14922,2559,'1533634','834','00','005010X220A1','1533634','','2014-01-14','13:17:30',0,'2014-01-15 02:07:39',NULL,NULL),(18345,3396,'2215992','834','00','005010X220A1','2215992','','2014-02-07','18:47:34',0,'2014-02-08 19:30:04',NULL,NULL),(18570,3453,'3167075','834','00','005010X220A1','3167075','','2014-02-10','13:17:31',0,'2014-02-10 21:30:43',NULL,NULL),(18600,3456,'2934495','834','00','005010X220A1','2934495','','2014-02-10','08:43:30',0,'2014-02-10 21:31:03',NULL,NULL),(18838,3490,'2590857','834','00','005010X220A1','2590857','','2014-02-11','17:11:14',0,'2014-02-11 21:01:43',NULL,NULL),(19486,3620,'3115267','834','00','005010X220A1','3115267','','2014-02-14','01:16:05',0,'2014-02-14 21:30:16',NULL,NULL),(21380,4024,'2624213','834','00','005010X220A1','2624213','','2014-02-27','13:38:28',0,'2014-02-28 06:30:26',NULL,NULL),(21805,4092,'3168988','834','00','005010X220A1','3168988','','2014-02-28','16:22:54',0,'2014-02-28 21:31:24',NULL,NULL),(22134,4179,'2713084','834','00','005010X220A1','2713084','','2014-03-03','11:35:55',0,'2014-03-03 21:30:44',NULL,NULL),(22957,4311,'2895926','834','00','005010X220A1','2895926','','2014-03-05','18:19:29',0,'2014-03-06 21:30:03',NULL,NULL),(23213,4347,'3070315','834','00','005010X220A1','3070315','','2014-03-07','15:28:43',0,'2014-03-07 21:31:54',NULL,NULL),(11395,1463,'2236331','834','00','005010X220A1','2236331','','2013-12-26','17:21:54',0,'2013-12-27 02:06:24',NULL,NULL),(3191,577,'170927','834','00','005010X220A1','170927','','2013-12-16','18:28:23',0,'2013-12-25 21:45:03',NULL,NULL),(6347,1178,'947017','834','00','005010X220A1','947017','','2013-12-20','14:29:55',0,'2013-12-26 03:08:49',NULL,NULL),(15825,2736,'2025353','834','00','005010X220A1','2025353','','2014-01-20','20:00:56',1,'2014-01-22 03:21:52',NULL,NULL),(14133,2352,'1615478','834','00','005010X220A1','1615478','','2014-01-08','10:39:03',0,'2014-01-13 02:22:31',NULL,NULL),(13897,2313,'2382438','834','00','005010X220A1','2382438','','2014-01-08','18:28:28',0,'2014-01-13 02:19:43',NULL,NULL),(13076,1920,'0001','999','BE','005010X231A1','984254','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:32',NULL,NULL),(13068,1912,'0001','999','BE','005010X231A1','483505','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:10',NULL,NULL),(3908,712,'222823','834','00','005010X220A1','222823','','2013-12-06','18:59:50',0,'2013-12-25 22:45:16',NULL,NULL),(6211,1168,'1217310','834','00','005010X220A1','1217310','','2013-12-19','23:10:27',0,'2013-12-26 03:04:39',NULL,NULL),(20402,3832,'2518356','834','00','005010X220A1','2518356','','2014-02-20','17:01:37',0,'2014-02-20 21:30:08',NULL,NULL),(11331,1456,'1531641','834','00','005010X220A1','1531641','','2013-12-26','14:57:34',0,'2013-12-27 02:04:27',NULL,NULL),(1304,245,'1850217','834','00','005010X220A1','1850217','','2013-12-24','05:08:59',0,'2013-12-25 18:50:55',NULL,NULL),(13286,2130,'0001','999','BE','005010X231A1','690471','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:33',NULL,NULL),(4440,800,'148859','834','00','005010X220A1','148859','','2013-11-25','18:22:35',0,'2013-12-25 23:30:04',NULL,NULL),(19701,3671,'3280090','834','00','005010X220A1','3280090','','2014-02-15','13:02:49',0,'2014-02-15 22:00:08',NULL,NULL),(22807,4278,'3752598','834','00','005010X220A1','3752598','','2014-03-05','20:06:45',0,'2014-03-06 21:01:09',NULL,NULL),(298,70,'263108','834','00','005010X220A1','263108','','2013-12-03','18:34:07',0,'2013-12-25 17:45:09',NULL,NULL),(17403,3198,'1919784','834','00','005010X220A1','1919784','','2014-02-01','17:36:18',0,'2014-02-01 19:00:11',NULL,NULL),(17142,3144,'2646661','834','00','005010X220A1','2646661','','2014-01-30','11:33:46',0,'2014-01-30 21:00:32',NULL,NULL),(1016,191,'21728','834','00','005010X220A1','21728','','2013-12-03','09:08:04',0,'2013-12-25 18:20:46',NULL,NULL),(15930,2749,'1396150','834','00','005010X220A1','1396150','','2014-01-21','12:08:21',1,'2014-01-22 03:22:59',NULL,NULL),(7552,1301,'438798','834','00','005010X220A1','438798','','2013-12-20','20:28:05',0,'2013-12-26 04:35:40',NULL,NULL),(15533,2654,'2457959','834','00','005010X220A1','2457959','','2014-01-17','10:08:09',0,'2014-01-20 08:05:36',NULL,NULL),(20048,3751,'3233310','834','00','005010X220A1','3233310','','2014-02-18','13:59:20',0,'2014-02-18 22:01:06',NULL,NULL),(11665,1501,'2302277','834','00','005010X220A1','2302277','','2013-12-27','15:04:54',0,'2013-12-28 03:36:45',NULL,NULL),(15812,2728,'1642943','834','00','005010X220A1','1642943','','2014-01-20','10:35:23',0,'2014-01-21 08:46:55',NULL,NULL),(7117,1236,'1246852','834','00','005010X220A1','1246852','','2013-12-18','15:24:38',0,'2013-12-26 04:04:08',NULL,NULL),(19891,3711,'3589076','834','00','005010X220A1','3589076','','2014-02-16','10:24:50',0,'2014-02-16 19:00:32',NULL,NULL),(1047,204,'1246302','834','00','005010X220A1','1246302','','2013-11-29','11:37:20',0,'2013-12-25 18:30:11',NULL,NULL),(17768,3264,'1910473','834','00','005010X220A1','1910473','','2014-02-03','19:36:08',0,'2014-02-04 21:01:11',NULL,NULL),(16130,2822,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:32:00',1,'2014-01-23 03:49:40',NULL,NULL),(7348,1281,'1314026','834','00','005010X220A1','1314026','','2013-11-29','20:48:14',0,'2013-12-26 04:15:24',NULL,NULL),(14058,2339,'2034295','834','00','005010X220A1','2034295','','2014-01-08','10:37:01',0,'2014-01-13 02:21:42',NULL,NULL),(14002,2334,'1560134','834','00','005010X220A1','1560134','','2014-01-09','11:17:00',0,'2014-01-13 02:20:59',NULL,NULL),(13389,2221,'2492217','834','00','005010X220A1','2492217','','2014-01-06','16:05:14',0,'2014-01-07 04:00:29',NULL,NULL),(12901,1713,'1783404','834','00','005010X220A1','1783404','','2014-01-03','10:30:48',0,'2014-01-04 02:04:56',NULL,NULL),(19951,3741,'3431124','834','00','005010X220A1','3431124','','2014-02-18','17:05:30',0,'2014-02-18 21:30:19',NULL,NULL),(22043,4163,'3663703','834','00','005010X220A1','3663703','','2014-03-03','17:15:40',0,'2014-03-03 21:00:06',NULL,NULL),(22577,4248,'3638178','834','00','005010X220A1','3638178','','2014-03-05','15:13:33',0,'2014-03-05 21:31:01',NULL,NULL),(23418,4404,'2788307','834','00','005010X220A1','2788307','','2014-03-09','15:22:00',0,'2014-03-09 21:00:24',NULL,NULL),(1014,189,'673102','834','00','005010X220A1','673102','','2013-12-03','09:23:45',0,'2013-12-25 18:20:43',NULL,NULL),(17148,3144,'2707104','834','00','005010X220A1','2707104','','2014-01-30','13:54:21',0,'2014-01-30 21:00:35',NULL,NULL),(11990,1580,'2396452','834','00','005010X220A1','2396452','','2013-12-30','18:12:02',0,'2014-01-01 12:01:42',NULL,NULL),(7682,1324,'1289046','834','00','005010X220A1','1289046','','2013-12-21','15:20:13',0,'2013-12-26 04:39:54',NULL,NULL),(13361,2205,'0001','999','BE','005010X231A1','1271176','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:02',NULL,NULL),(6293,1172,'1165261','834','00','005010X220A1','1165261','','2013-12-20','18:18:25',0,'2013-12-26 03:07:12',NULL,NULL),(21220,3998,'3520222','834','00','005010X220A1','3520222','','2014-02-26','17:23:41',0,'2014-02-26 21:01:30',NULL,NULL),(2214,365,'540628','834','00','005010X220A1','540628','','2013-12-02','16:04:51',0,'2013-12-25 19:48:37',NULL,NULL),(16820,3090,'2541825','834','00','005010X220A1','2541825','','2014-01-28','11:35:54',0,'2014-01-28 21:00:20',NULL,NULL),(15579,2658,'1706627','834','00','005010X220A1','1706627','','2014-01-17','11:52:21',0,'2014-01-20 08:06:11',NULL,NULL),(6202,1168,'37019','834','00','005010X220A1','37019','','2013-12-19','20:05:27',0,'2013-12-26 03:04:23',NULL,NULL),(6188,1167,'87734','834','00','005010X220A1','87734','','2013-12-20','17:45:07',0,'2013-12-26 03:03:56',NULL,NULL),(2370,413,'1233659','834','00','005010X220A1','1233659','','2013-12-06','10:30:40',0,'2013-12-25 20:16:20',NULL,NULL),(10541,1401,'304684','834','00','005010X220A1','304684','','2013-12-23','19:15:19',0,'2013-12-26 12:55:11',NULL,NULL),(23309,4381,'2950773','834','00','005010X220A1','2950773','','2014-03-07','19:14:14',0,'2014-03-08 21:30:27',NULL,NULL),(23545,4435,'2750095','834','00','005010X220A1','2750095','','2014-03-10','13:47:23',0,'2014-03-10 21:00:35',NULL,NULL),(11450,1488,'716289','834','00','005010X220A1','716289','','2013-12-26','19:07:29',0,'2013-12-28 03:30:09',NULL,NULL),(18184,3351,'2560083','834','00','005010X220A1','2560083','','2014-02-07','09:50:56',0,'2014-02-07 19:00:24',NULL,NULL),(10606,1402,'173912','834','00','005010X220A1','173912','','2013-12-23','13:22:14',0,'2013-12-26 12:57:23',NULL,NULL),(4415,784,'467299','834','00','005010X220A1','467299','','2013-11-27','16:05:07',0,'2013-12-25 23:16:26',NULL,NULL),(14488,2509,'0001','999','BE','005010X231A1','1169549','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:59',NULL,NULL),(5948,1113,'398399','834','00','005010X220A1','398399','','2013-12-15','13:25:54',0,'2013-12-26 02:32:15',NULL,NULL),(18535,3451,'2979964','834','00','005010X220A1','2979964','','2014-02-10','14:56:55',0,'2014-02-10 21:30:19',NULL,NULL),(22160,4180,'2843438','834','00','005010X220A1','2843438','','2014-03-03','00:33:38',0,'2014-03-03 21:31:02',NULL,NULL),(1052,206,'606890','834','00','005010X220A1','606890','','2013-11-28','20:20:36',0,'2013-12-25 18:30:21',NULL,NULL),(6405,1195,'107386','834','00','005010X220A1','107386','','2013-12-20','18:31:04',0,'2013-12-26 03:10:37',NULL,NULL),(5756,1072,'557340','834','00','005010X220A1','557340','','2013-12-13','19:45:48',0,'2013-12-26 02:02:06',NULL,NULL),(14683,2549,'2392601','834','00','005010X220A1','2392601','','2014-01-13','19:43:46',0,'2014-01-15 02:05:54',NULL,NULL),(4782,862,'770774','834','00','005010X220A1','770774','','2013-11-30','21:00:14',0,'2013-12-26 00:01:20',NULL,NULL),(3741,643,'868819','834','00','005010X220A1','868819','','2013-12-12','15:23:39',0,'2013-12-25 22:08:54',NULL,NULL),(18992,3538,'1831027','834','00','005010X220A1','1831027','','2014-02-11','18:32:36',0,'2014-02-12 21:30:21',NULL,NULL),(19930,3733,'2599897','834','00','005010X220A1','2599897','','2014-02-18','13:07:43',0,'2014-02-18 21:30:04',NULL,NULL),(21718,4088,'3337256','834','00','005010X220A1','3337256','','2014-02-28','11:48:38',0,'2014-02-28 21:30:26',NULL,NULL),(22941,4298,'3054555','834','00','005010X220A1','3054555','','2014-03-06','15:40:25',0,'2014-03-06 21:02:46',NULL,NULL),(13052,1896,'0001','999','BE','005010X231A1','589789','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:26',NULL,NULL),(11545,1492,'2340','834','00','005010X220A1','2340','','2013-12-26','19:03:03',0,'2013-12-28 03:32:58',NULL,NULL),(5342,1002,'269335','834','00','005010X220A1','269335','','2013-11-25','12:38:40',0,'2013-12-26 01:15:33',NULL,NULL),(13678,2272,'1727851','834','00','005010X220A1','1727851','','2014-01-06','20:56:01',0,'2014-01-08 18:24:20',NULL,NULL),(18429,3420,'2451914','834','00','005010X220A1','2451914','','2014-02-10','04:23:24',0,'2014-02-10 11:00:16',NULL,NULL),(19296,3582,'2623837','834','00','005010X220A1','2623837','','2014-02-13','17:22:16',0,'2014-02-13 22:01:10',NULL,NULL),(23551,4435,'2858191','834','00','005010X220A1','2858191','','2014-03-10','17:13:28',0,'2014-03-10 21:00:41',NULL,NULL),(3296,584,'545270','834','00','005010X220A1','545270','','2013-12-17','05:02:37',0,'2013-12-25 21:48:19',NULL,NULL),(18047,3319,'1865373','834','00','005010X220A1','1865373','','2014-02-06','08:42:02',0,'2014-02-06 21:00:40',NULL,NULL),(12965,1734,'1808096','834','00','005010X220A1','1808096','','2014-01-04','10:38:15',0,'2014-01-05 00:00:55',NULL,NULL),(16899,3101,'1596937','834','00','005010X220A1','1596937','','2014-01-28','11:27:08',0,'2014-01-28 21:01:13',NULL,NULL),(16497,3011,'1663454','834','00','005010X220A1','1663454','','2014-01-24','09:22:46',0,'2014-01-24 21:00:39',NULL,NULL),(16114,2806,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 03:44:38',NULL,NULL),(15509,2641,'2182942','834','00','005010X220A1','2182942','','2014-01-16','11:24:03',0,'2014-01-17 03:36:35',NULL,NULL),(12688,1673,'2020008','834','00','005010X220A1','2020008','','2014-01-02','17:21:04',0,'2014-01-03 02:04:16',NULL,NULL),(10699,1403,'1445895','834','00','005010X220A1','1445895','','2013-12-23','09:56:34',0,'2013-12-26 13:00:29',NULL,NULL),(14416,2437,'0001','999','BE','005010X231A1','790585','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:28',NULL,NULL),(10508,1400,'840654','834','00','005010X220A1','840654','','2013-12-23','18:57:09',0,'2013-12-26 12:54:06',NULL,NULL),(7221,1241,'775637','834','00','005010X220A1','775637','','2013-12-18','14:10:22',0,'2013-12-26 04:07:15',NULL,NULL),(18943,3525,'2505610','834','00','005010X220A1','2505610','','2014-02-11','15:21:46',0,'2014-02-11 21:30:22',NULL,NULL),(21409,4026,'3774448','834','00','005010X220A1','3774448','','2014-02-26','19:17:37',0,'2014-02-28 06:30:39',NULL,NULL),(22077,4174,'3655973','834','00','005010X220A1','3655973','','2014-03-03','09:17:49',0,'2014-03-03 21:30:00',NULL,NULL),(842,175,'37739','834','00','005010X220A1','37739','','2013-12-02','22:41:38',0,'2013-12-25 18:15:25',NULL,NULL),(1830,314,'1122085','834','00','005010X220A1','1122085','','2013-12-10','14:32:17',0,'2013-12-25 19:20:34',NULL,NULL),(14260,2375,'1475747','834','00','005010X220A1','1475747','','2014-01-09','20:13:41',0,'2014-01-13 03:00:03',NULL,NULL),(13645,2271,'2532216','834','00','005010X220A1','2532216','','2014-01-07','10:04:10',0,'2014-01-08 18:24:08',NULL,NULL),(13624,2270,'2287424','834','00','005010X220A1','2287424','','2014-01-07','16:13:04',0,'2014-01-08 18:23:59',NULL,NULL),(13604,2261,'1622003','834','00','005010X220A1','1622003','','2014-01-04','20:25:03',1,'2014-01-07 10:22:58',NULL,NULL),(3127,551,'423624','834','00','005010X220A1','423624','','2013-12-12','19:16:04',0,'2013-12-25 21:37:01',NULL,NULL),(5671,1053,'1076181','834','00','005010X220A1','1076181','','2013-12-25','00:33:51',0,'2013-12-26 01:52:05',NULL,NULL),(21193,3998,'3624095','834','00','005010X220A1','3624095','','2014-02-26','14:30:26',0,'2014-02-26 21:01:12',NULL,NULL),(22347,4204,'2892584','834','00','005010X220A1','2892584','','2014-03-04','14:56:25',0,'2014-03-04 21:01:35',NULL,NULL),(23128,4342,'3041101','834','00','005010X220A1','3041101','','2014-03-07','11:09:22',0,'2014-03-07 21:30:55',NULL,NULL),(23170,4344,'3019990','834','00','005010X220A1','3019990','','2014-03-07','15:37:47',0,'2014-03-07 21:31:25',NULL,NULL),(12051,1585,'1448575','834','00','005010X220A1','1448575','','2013-12-29','19:38:37',0,'2014-01-01 12:04:01',NULL,NULL),(17278,3170,'1499130','834','00','005010X220A1','1499130','','2014-01-31','16:56:39',0,'2014-01-31 21:00:27',NULL,NULL),(11718,1519,'1936007','834','00','005010X220A1','1936007','','2013-12-27','19:13:19',1,'2013-12-29 11:08:28',NULL,NULL),(16903,3104,'1776394','834','00','005010X220A1','1776394','','2014-01-28','11:41:20',0,'2014-01-28 21:01:15',NULL,NULL),(3657,625,'465129','834','00','005010X220A1','465129','','2013-12-12','17:52:15',0,'2013-12-25 22:06:08',NULL,NULL),(13542,2241,'1493750','834','00','005010X220A1','1493750','','2014-01-06','11:09:28',0,'2014-01-07 04:06:07',NULL,NULL),(5625,1046,'1171677','834','00','005010X220A1','1171677','','2013-12-24','18:51:51',0,'2013-12-26 01:50:32',NULL,NULL),(6030,1142,'938634','834','00','005010X220A1','938634','','2013-11-17','10:00:24',0,'2013-12-26 02:45:53',NULL,NULL),(6221,1168,'503044','834','00','005010X220A1','503044','','2013-12-20','14:00:47',0,'2013-12-26 03:04:55',NULL,NULL),(7492,1300,'1317530','834','00','005010X220A1','1317530','','2013-12-20','19:08:52',0,'2013-12-26 04:33:46',NULL,NULL),(10954,1410,'1420723','834','00','005010X220A1','1420723','','2013-12-23','18:19:23',0,'2013-12-26 13:09:20',NULL,NULL),(19341,3583,'2669323','834','00','005010X220A1','2669323','','2014-02-13','15:03:36',0,'2014-02-13 22:01:44',NULL,NULL),(20817,3910,'2641438','834','00','005010X220A1','2641438','','2014-02-25','14:19:25',0,'2014-02-25 21:31:06',NULL,NULL),(22034,4163,'3535109','834','00','005010X220A1','3535109','','2014-03-02','22:54:15',0,'2014-03-03 21:00:01',NULL,NULL),(22710,4265,'3778477','834','00','005010X220A1','3778477','','2014-03-05','15:09:29',0,'2014-03-05 21:32:36',NULL,NULL),(23433,4405,'3704846','834','00','005010X220A1','3704846','','2014-03-09','16:12:11',0,'2014-03-09 21:00:35',NULL,NULL),(11771,1528,'2289657','834','00','005010X220A1','2289657','','2013-12-27','20:18:09',1,'2013-12-29 11:10:03',NULL,NULL),(18285,3379,'2232602','834','00','005010X220A1','2232602','','2014-02-08','12:59:45',0,'2014-02-08 19:00:25',NULL,NULL),(1561,274,'1795537','834','00','005010X220A1','1795537','','2013-12-24','17:24:06',0,'2013-12-25 18:59:21',NULL,NULL),(17492,3220,'2737057','834','00','005010X220A1','2737057','','2014-02-02','13:34:23',0,'2014-02-02 19:00:19',NULL,NULL),(1836,317,'1010353','834','00','005010X220A1','1010353','','2013-12-10','14:34:49',0,'2013-12-25 19:20:47',NULL,NULL),(15687,2696,'2116014','834','00','005010X220A1','2116014','','2014-01-19','16:02:15',0,'2014-01-21 08:45:17',NULL,NULL),(15681,2692,'1829281','834','00','005010X220A1','1829281','','2014-01-18','10:04:00',0,'2014-01-21 08:44:46',NULL,NULL),(1961,326,'1163424','834','00','005010X220A1','1163424','','2013-12-09','13:52:24',0,'2013-12-25 19:33:32',NULL,NULL),(13250,2094,'0001','999','BE','005010X231A1','1160865','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:11',NULL,NULL),(13344,2188,'0001','999','BE','005010X231A1','235583','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:14',NULL,NULL),(4699,834,'1103064','834','00','005010X220A1','1103064','','2013-12-23','22:16:00',0,'2013-12-25 23:50:38',NULL,NULL),(14994,2584,'1621044','834','00','005010X220A1','1621044','','2014-01-14','19:35:00',0,'2014-01-16 08:44:14',NULL,NULL),(14175,2364,'1925776','834','00','005010X220A1','1925776','','2014-01-10','14:37:32',0,'2014-01-13 02:23:24',NULL,NULL),(3635,622,'456453','834','00','005010X220A1','456453','','2013-12-12','11:32:55',0,'2013-12-25 22:05:27',NULL,NULL),(3363,587,'1000959','834','00','005010X220A1','1000959','','2013-12-17','11:16:15',0,'2013-12-25 21:50:31',NULL,NULL),(3140,553,'276432','834','00','005010X220A1','276432','','2013-12-12','19:45:23',0,'2013-12-25 21:37:24',NULL,NULL),(2772,506,'654598','834','00','005010X220A1','654598','','2013-12-21','21:40:41',0,'2013-12-25 21:19:24',NULL,NULL),(18931,3520,'3148453','834','00','005010X220A1','3148453','','2014-02-11','18:20:14',0,'2014-02-11 21:30:10',NULL,NULL),(20671,3880,'3646697','834','00','005010X220A1','3646697','','2014-02-21','11:41:59',0,'2014-02-21 22:01:07',NULL,NULL),(22524,4247,'3269219','834','00','005010X220A1','3269219','','2014-03-05','13:31:05',0,'2014-03-05 21:30:24',NULL,NULL),(15626,2672,'1831980','834','00','005010X220A1','1831980','','2014-01-17','15:13:14',0,'2014-01-20 08:06:45',NULL,NULL),(16066,2773,'2572571','834','00','005010X220A1','2572571','','2014-01-22','16:36:53',0,'2014-01-23 03:02:43',NULL,NULL),(23094,4339,'2754119','834','00','005010X220A1','2754119','','2014-03-07','15:52:01',0,'2014-03-07 21:30:30',NULL,NULL),(12874,1706,'1496031','834','00','005010X220A1','1496031','','2014-01-03','13:11:49',0,'2014-01-04 02:03:55',NULL,NULL),(7012,1235,'1283414','834','00','005010X220A1','1283414','','2013-12-18','07:18:55',0,'2013-12-26 04:00:53',NULL,NULL),(4729,844,'1828511','834','00','005010X220A1','1828511','','2013-12-23','22:44:16',0,'2013-12-25 23:51:41',NULL,NULL),(20208,3781,'2579223','834','00','005010X220A1','2579223','','2014-02-19','12:20:31',0,'2014-02-20 04:20:02',NULL,NULL),(22479,4240,'3117098','834','00','005010X220A1','3117098','','2014-03-05','08:01:03',0,'2014-03-05 21:00:22',NULL,NULL),(486,102,'103054','834','00','005010X220A1','103054','','2013-12-15','18:09:59',0,'2013-12-25 18:00:02',NULL,NULL),(18643,3463,'2818038','834','00','005010X220A1','2818038','','2014-02-10','13:33:41',0,'2014-02-10 21:31:34',NULL,NULL),(18235,3362,'2634975','834','00','005010X220A1','2634975','','2014-02-07','08:24:52',0,'2014-02-07 19:01:01',NULL,NULL),(873,177,'669242','834','00','005010X220A1','669242','','2013-12-02','22:37:41',0,'2013-12-25 18:16:24',NULL,NULL),(18008,3318,'2620334','834','00','005010X220A1','2620334','','2014-02-06','17:37:07',0,'2014-02-06 21:00:13',NULL,NULL),(14274,2375,'1944764','834','00','005010X220A1','1944764','','2014-01-10','16:18:44',0,'2014-01-13 03:00:12',NULL,NULL),(12789,1703,'1478016','834','00','005010X220A1','1478016','','2014-01-03','10:06:23',0,'2014-01-04 02:00:51',NULL,NULL),(5209,949,'1084458','834','00','005010X220A1','1084458','','2013-12-11','16:13:19',0,'2013-12-26 00:52:39',NULL,NULL),(4619,827,'1024339','834','00','005010X220A1','1024339','','2013-12-23','21:55:36',0,'2013-12-25 23:47:50',NULL,NULL),(4511,812,'84223','834','00','005010X220A1','84223','','2013-11-25','22:47:14',0,'2013-12-25 23:32:24',NULL,NULL),(20986,3957,'3228624','834','00','005010X220A1','3228624','','2014-02-22','17:45:01',0,'2014-02-26 08:30:25',NULL,NULL),(22493,4245,'2881548','834','00','005010X220A1','2881548','','2014-03-05','17:53:00',0,'2014-03-05 21:00:32',NULL,NULL),(4005,731,'597479','834','00','005010X220A1','597479','','2013-12-18','21:04:40',0,'2013-12-25 23:00:18',NULL,NULL),(7233,1241,'114739','834','00','005010X220A1','114739','','2013-12-18','17:31:27',0,'2013-12-26 04:07:39',NULL,NULL),(16227,2919,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',0,'2014-01-23 06:39:29',NULL,NULL),(14370,2404,'2486407','834','00','005010X220A1','2486407','','2014-01-12','14:23:30',0,'2014-01-13 03:01:41',NULL,NULL),(13753,2277,'2154117','834','00','005010X220A1','2154117','','2014-01-07','08:24:40',0,'2014-01-08 18:24:53',NULL,NULL),(13533,2241,'1774605','834','00','005010X220A1','1774605','','2014-01-06','10:59:32',0,'2014-01-07 04:05:51',NULL,NULL),(5762,1072,'1242034','834','00','005010X220A1','1242034','','2013-12-14','03:33:19',0,'2013-12-26 02:02:17',NULL,NULL),(4742,855,'1124074','834','00','005010X220A1','1124074','','2013-12-24','01:51:57',0,'2013-12-25 23:52:10',NULL,NULL),(22540,4248,'2736781','834','00','005010X220A1','2736781','','2014-03-04','20:02:49',0,'2014-03-05 21:30:36',NULL,NULL),(1005,188,'566794','834','00','005010X220A1','566794','','2013-12-03','11:13:16',0,'2013-12-25 18:20:26',NULL,NULL),(18061,3320,'2827320','834','00','005010X220A1','2827320','','2014-02-05','19:34:27',0,'2014-02-06 21:00:49',NULL,NULL),(2896,533,'1004843','834','00','005010X220A1','1004843','','2013-12-22','16:05:11',0,'2013-12-25 21:23:35',NULL,NULL),(12996,1739,'2011090','834','00','005010X220A1','2011090','','2014-01-03','20:34:47',0,'2014-01-05 00:01:58',NULL,NULL),(4247,739,'148125','834','00','005010X220A1','148125','','2013-12-19','16:14:47',0,'2013-12-25 23:07:42',NULL,NULL),(14728,2550,'2490098','834','00','005010X220A1','2490098','','2014-01-14','13:57:08',0,'2014-01-15 02:06:14',NULL,NULL),(7347,1280,'383109','834','00','005010X220A1','383109','','2013-11-30','17:50:31',0,'2013-12-26 04:15:23',NULL,NULL),(12673,1673,'2564451','834','00','005010X220A1','2564451','','2014-01-02','16:50:39',0,'2014-01-03 02:03:46',NULL,NULL),(4409,780,'1176897','834','00','005010X220A1','1176897','','2013-11-27','11:41:46',0,'2013-12-25 23:16:14',NULL,NULL),(19258,3581,'2595772','834','00','005010X220A1','2595772','','2014-02-13','11:53:42',0,'2014-02-13 22:00:41',NULL,NULL),(985,184,'15221','834','00','005010X220A1','15221','','2013-12-03','13:30:56',0,'2013-12-25 18:19:44',NULL,NULL),(17753,3262,'1728565','834','00','005010X220A1','1728565','','2014-02-04','13:07:38',0,'2014-02-04 21:01:02',NULL,NULL),(5410,1024,'311098','834','00','005010X220A1','311098','','2013-11-13','22:31:43',0,'2013-12-26 01:30:37',NULL,NULL),(14282,2377,'2383824','834','00','005010X220A1','2383824','','2014-01-09','23:32:46',0,'2014-01-13 03:00:17',NULL,NULL),(1459,252,'1637754','834','00','005010X220A1','1637754','','2013-12-24','14:17:30',0,'2013-12-25 18:56:04',NULL,NULL),(3881,699,'11038','834','00','005010X220A1','11038','','2013-10-04','16:41:54',0,'2013-12-25 22:31:34',NULL,NULL),(11838,1543,'398909','834','00','005010X220A1','398909','','2013-12-28','20:23:52',1,'2013-12-29 11:14:18',NULL,NULL),(11310,1456,'1287979','834','00','005010X220A1','1287979','','2013-12-26','11:23:20',0,'2013-12-27 02:03:49',NULL,NULL),(2790,506,'1027751','834','00','005010X220A1','1027751','','2013-12-22','10:52:40',0,'2013-12-25 21:20:02',NULL,NULL),(2810,506,'298548','834','00','005010X220A1','298548','','2013-12-22','16:05:11',0,'2013-12-25 21:20:37',NULL,NULL),(2330,411,'238219','834','00','005010X220A1','238219','','2013-10-08','11:02:47',0,'2013-12-25 20:02:17',NULL,NULL),(3421,594,'371917','834','00','005010X220A1','371917','','2013-12-17','11:12:37',0,'2013-12-25 21:52:22',NULL,NULL),(21565,4053,'3069971','834','00','005010X220A1','3069971','','2014-02-26','15:27:17',0,'2014-02-28 07:00:09',NULL,NULL),(133,8,'55641','834','00','005010X220A1','55641','','2013-12-05','12:42:19',0,'2013-12-25 17:19:08',NULL,NULL),(19493,3620,'3148546','834','00','005010X220A1','3148546','','2014-02-14','13:09:10',0,'2014-02-14 21:30:21',NULL,NULL),(17925,3296,'2261024','834','00','005010X220A1','2261024','','2014-02-05','12:57:23',0,'2014-02-05 21:30:42',NULL,NULL),(1318,245,'1806599','834','00','005010X220A1','1806599','','2013-12-24','10:32:03',0,'2013-12-25 18:51:22',NULL,NULL),(15927,2748,'1963236','834','00','005010X220A1','1963236','','2014-01-21','11:30:07',1,'2014-01-22 03:22:57',NULL,NULL),(2238,372,'268123','834','00','005010X220A1','268123','','2013-12-02','13:37:36',0,'2013-12-25 19:49:28',NULL,NULL),(142,10,'745184','834','00','005010X220A1','745184','','2013-12-04','21:19:34',0,'2013-12-25 17:19:23',NULL,NULL),(14973,2572,'2186634','834','00','005010X220A1','2186634','','2014-01-14','11:22:27',0,'2014-01-15 02:08:03',NULL,NULL),(5114,942,'8752','834','00','005010X220A1','8752','','2013-12-10','18:46:22',0,'2013-12-26 00:49:41',NULL,NULL),(5779,1074,'151976','834','00','005010X220A1','151976','','2013-12-14','10:27:40',0,'2013-12-26 02:02:53',NULL,NULL),(6194,1167,'530069','834','00','005010X220A1','530069','','2013-12-20','18:16:35',0,'2013-12-26 03:04:08',NULL,NULL),(22216,4188,'2926675','834','00','005010X220A1','2926675','','2014-03-03','13:38:32',0,'2014-03-03 21:31:43',NULL,NULL),(22895,4284,'3218569','834','00','005010X220A1','3218569','','2014-03-06','13:27:35',0,'2014-03-06 21:02:12',NULL,NULL),(11984,1580,'1859743','834','00','005010X220A1','1859743','','2013-12-30','16:31:00',0,'2014-01-01 12:01:31',NULL,NULL),(19954,3744,'2394819','834','00','005010X220A1','2394819','','2014-02-18','16:35:38',0,'2014-02-18 21:30:22',NULL,NULL),(1936,326,'1124648','834','00','005010X220A1','1124648','','2013-12-09','09:47:27',0,'2013-12-25 19:32:49',NULL,NULL),(15322,2622,'1969524','834','00','005010X220A1','1969524','','2014-01-16','13:10:56',0,'2014-01-17 03:35:11',NULL,NULL),(19088,3542,'2717317','834','00','005010X220A1','2717317','','2014-02-12','16:37:38',0,'2014-02-12 21:31:30',NULL,NULL),(18995,3538,'3138726','834','00','005010X220A1','3138726','','2014-02-11','22:23:48',0,'2014-02-12 21:30:22',NULL,NULL),(15883,2740,'2110990','834','00','005010X220A1','2110990','','2014-01-20','21:47:38',1,'2014-01-22 03:22:31',NULL,NULL),(21791,4092,'3353995','834','00','005010X220A1','3353995','','2014-02-27','21:57:40',0,'2014-02-28 21:31:15',NULL,NULL),(21922,4128,'3158783','834','00','005010X220A1','3158783','','2014-02-28','20:42:37',0,'2014-03-01 21:00:44',NULL,NULL),(23378,4398,'3125786','834','00','005010X220A1','3125786','','2014-03-08','14:20:27',0,'2014-03-08 21:31:19',NULL,NULL),(709,117,'146457','834','00','005010X220A1','146457','','2013-12-16','12:23:54',0,'2013-12-25 18:07:00',NULL,NULL),(5958,1117,'844447','834','00','005010X220A1','844447','','2013-12-14','20:49:14',0,'2013-12-26 02:32:34',NULL,NULL),(20185,3779,'2780357','834','00','005010X220A1','2780357','','2014-02-18','20:02:50',0,'2014-02-20 04:14:17',NULL,NULL),(4292,746,'955812','834','00','005010X220A1','955812','','2013-12-18','22:03:01',0,'2013-12-25 23:09:03',NULL,NULL),(3985,722,'1235080','834','00','005010X220A1','1235080','','2013-12-07','16:34:26',0,'2013-12-25 22:47:43',NULL,NULL),(19010,3539,'2286851','834','00','005010X220A1','2286851','','2014-02-12','11:03:16',0,'2014-02-12 21:30:33',NULL,NULL),(3689,632,'651568','834','00','005010X220A1','651568','','2013-12-11','23:26:54',0,'2013-12-25 22:07:08',NULL,NULL),(10552,1402,'703657','834','00','005010X220A1','703657','','2013-12-22','21:06:41',0,'2013-12-26 12:55:36',NULL,NULL),(16172,2864,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 04:17:38',NULL,NULL),(15675,2688,'2592889','834','00','005010X220A1','2592889','','2014-01-18','11:36:35',0,'2014-01-21 08:44:42',NULL,NULL),(12025,1583,'2403809','834','00','005010X220A1','2403809','','2013-12-30','13:35:18',0,'2014-01-01 12:03:01',NULL,NULL),(14600,2521,'2126674','834','00','005010X220A1','2126674','','2014-01-13','14:15:18',0,'2014-01-14 01:33:06',NULL,NULL),(13431,2222,'1574210','834','00','005010X220A1','1574210','','2014-01-06','17:29:12',0,'2014-01-07 04:01:58',NULL,NULL),(21661,4077,'2697844','834','00','005010X220A1','2697844','','2014-02-27','22:40:39',0,'2014-02-28 21:00:08',NULL,NULL),(22585,4248,'2910939','834','00','005010X220A1','2910939','','2014-03-05','17:21:01',0,'2014-03-05 21:31:07',NULL,NULL),(39,1,'46580','834','00','005010X220A1','46580','','2013-12-05','18:02:38',0,'2013-12-25 17:16:09',NULL,NULL),(21188,3998,'3358468','834','00','005010X220A1','3358468','','2014-02-26','13:45:52',0,'2014-02-26 21:01:09',NULL,NULL),(19494,3620,'1755033','834','00','005010X220A1','1755033','','2014-02-14','13:14:59',0,'2014-02-14 21:30:21',NULL,NULL),(17189,3149,'1660904','834','00','005010X220A1','1660904','','2014-01-29','19:55:17',0,'2014-01-30 21:01:02',NULL,NULL),(16470,3008,'2402017','834','00','005010X220A1','2402017','','2014-01-24','15:51:15',0,'2014-01-24 21:00:23',NULL,NULL),(219,30,'105601','834','00','005010X220A1','105601','','2013-12-05','17:22:23',0,'2013-12-25 17:21:55',NULL,NULL),(15660,2684,'2111998','834','00','005010X220A1','2111998','','2014-01-18','13:47:08',0,'2014-01-21 08:44:31',NULL,NULL),(13863,2311,'2267042','834','00','005010X220A1','2267042','','2014-01-09','09:48:06',0,'2014-01-13 02:19:21',NULL,NULL),(1510,258,'503375','834','00','005010X220A1','503375','','2013-12-24','12:17:33',0,'2013-12-25 18:57:40',NULL,NULL),(10971,1411,'705192','834','00','005010X220A1','705192','','2013-12-23','15:43:01',0,'2013-12-26 13:09:46',NULL,NULL),(2529,455,'1021154','834','00','005010X220A1','1021154','','2013-11-18','10:22:02',0,'2013-12-25 20:30:52',NULL,NULL),(4407,778,'1301208','834','00','005010X220A1','1301208','','2013-11-26','22:17:22',0,'2013-12-25 23:16:10',NULL,NULL),(21511,4032,'3161392','834','00','005010X220A1','3161392','','2014-02-27','10:38:28',0,'2014-02-28 06:31:26',NULL,NULL),(22541,4248,'3022617','834','00','005010X220A1','3022617','','2014-03-04','20:21:40',0,'2014-03-05 21:30:37',NULL,NULL),(23649,4441,'3809431','834','00','005010X220A1','3809431','','2014-03-10','16:34:44',0,'2014-03-10 21:01:50',NULL,NULL),(715,119,'1204182','834','00','005010X220A1','1204182','','2013-12-16','09:34:55',0,'2013-12-25 18:07:15',NULL,NULL),(1156,239,'1356239','834','00','005010X220A1','1356239','','2013-12-24','11:23:17',0,'2013-12-25 18:46:23',NULL,NULL),(1890,325,'83251','834','00','005010X220A1','83251','','2013-12-09','08:13:33',0,'2013-12-25 19:31:28',NULL,NULL),(19816,3679,'3156074','834','00','005010X220A1','3156074','','2014-02-14','20:30:57',0,'2014-02-15 22:01:35',NULL,NULL),(3243,578,'708644','834','00','005010X220A1','708644','','2013-12-17','15:43:10',0,'2013-12-25 21:46:38',NULL,NULL),(17595,3240,'2683003','834','00','005010X220A1','2683003','','2014-02-03','10:24:28',0,'2014-02-03 21:00:55',NULL,NULL),(14131,2351,'1355386','834','00','005010X220A1','1355386','','2014-01-08','16:54:10',0,'2014-01-13 02:22:30',NULL,NULL),(21487,4028,'3049927','834','00','005010X220A1','3049927','','2014-02-27','17:41:42',0,'2014-02-28 06:31:15',NULL,NULL),(13198,2042,'0001','999','BE','005010X231A1','1197949','834','2013-12-27','16:55:00',0,'2014-01-05 16:59:46',NULL,NULL),(11915,1565,'1721929','834','00','005010X220A1','1721929','','2013-12-28','20:40:56',0,'2013-12-30 00:01:28',NULL,NULL),(11132,1430,'1668301','834','00','005010X220A1','1668301','','2013-12-23','17:40:42',0,'2013-12-26 13:15:16',NULL,NULL),(7272,1252,'514390','834','00','005010X220A1','514390','','2013-12-18','08:48:13',0,'2013-12-26 04:08:52',NULL,NULL),(14662,2537,'2089266','834','00','005010X220A1','2089266','','2014-01-13','15:26:47',0,'2014-01-14 01:33:47',NULL,NULL),(22115,4177,'3078771','834','00','005010X220A1','3078771','','2014-03-03','13:08:39',0,'2014-03-03 21:30:31',NULL,NULL),(1582,278,'295309','834','00','005010X220A1','295309','','2013-11-20','11:42:40',0,'2013-12-25 19:00:42',NULL,NULL),(2804,506,'1491984','834','00','005010X220A1','1491984','','2013-12-22','14:12:44',0,'2013-12-25 21:20:28',NULL,NULL),(19850,3696,'3385375','834','00','005010X220A1','3385375','','2014-02-15','12:01:37',0,'2014-02-15 22:02:06',NULL,NULL),(6078,1166,'1245794','834','00','005010X220A1','1245794','','2013-12-19','18:52:29',0,'2013-12-26 03:00:39',NULL,NULL),(17379,3188,'1559358','834','00','005010X220A1','1559358','','2014-01-31','12:51:59',0,'2014-01-31 21:01:37',NULL,NULL),(14366,2404,'1498608','834','00','005010X220A1','1498608','','2014-01-12','12:14:58',0,'2014-01-13 03:01:38',NULL,NULL),(14345,2401,'2278306','834','00','005010X220A1','2278306','','2014-01-12','09:18:59',0,'2014-01-13 03:01:22',NULL,NULL),(5181,949,'104270','834','00','005010X220A1','104270','','2013-12-10','22:24:30',0,'2013-12-26 00:51:44',NULL,NULL),(3959,716,'1196553','834','00','005010X220A1','1196553','','2013-12-06','19:55:36',0,'2013-12-25 22:46:50',NULL,NULL),(10705,1403,'1643332','834','00','005010X220A1','1643332','','2013-12-23','10:55:23',0,'2013-12-26 13:00:42',NULL,NULL),(541,103,'851224','834','00','005010X220A1','851224','','2013-12-15','18:33:22',0,'2013-12-25 18:01:43',NULL,NULL),(18783,3487,'2922449','834','00','005010X220A1','2922449','','2014-02-10','20:24:58',0,'2014-02-11 21:01:02',NULL,NULL),(18135,3337,'2318454','834','00','005010X220A1','2318454','','2014-02-06','12:27:03',0,'2014-02-06 21:01:42',NULL,NULL),(2090,349,'331145','834','00','005010X220A1','331145','','2013-12-09','15:08:32',0,'2013-12-25 19:37:43',NULL,NULL),(16650,3060,'1718979','834','00','005010X220A1','1718979','','2014-01-27','11:56:31',0,'2014-01-27 21:00:11',NULL,NULL),(6319,1175,'445077','834','00','005010X220A1','445077','','2013-12-20','14:10:07',0,'2013-12-26 03:07:57',NULL,NULL),(2695,502,'72025','834','00','005010X220A1','72025','','2013-12-22','13:42:12',0,'2013-12-25 21:17:01',NULL,NULL),(13984,2326,'2287483','834','00','005010X220A1','2287483','','2014-01-09','14:12:28',0,'2014-01-13 02:20:46',NULL,NULL),(13954,2320,'1788891','834','00','005010X220A1','1788891','','2014-01-09','11:19:05',0,'2014-01-13 02:20:23',NULL,NULL),(4408,779,'284262','834','00','005010X220A1','284262','','2013-11-27','07:15:08',0,'2013-12-25 23:16:12',NULL,NULL),(21699,4087,'3396504','834','00','005010X220A1','3396504','','2014-02-28','13:43:53',0,'2014-02-28 21:30:10',NULL,NULL),(23075,4339,'3329557','834','00','005010X220A1','3329557','','2014-03-07','11:02:25',0,'2014-03-07 21:30:17',NULL,NULL),(50,3,'181959','834','00','005010X220A1','181959','','2013-12-04','20:43:59',0,'2013-12-25 17:16:29',NULL,NULL),(21151,3997,'2830687','834','00','005010X220A1','2830687','','2014-02-26','10:25:31',0,'2014-02-26 21:00:44',NULL,NULL),(12016,1583,'2428971','834','00','005010X220A1','2428971','','2013-12-30','11:38:16',0,'2014-01-01 12:02:41',NULL,NULL),(20382,3825,'2681083','834','00','005010X220A1','2681083','','2014-02-19','10:31:40',0,'2014-02-20 05:37:51',NULL,NULL),(20221,3786,'2541144','834','00','005010X220A1','2541144','','2014-02-18','19:26:05',0,'2014-02-20 04:23:37',NULL,NULL),(4951,923,'540522','834','00','005010X220A1','540522','','2013-11-19','17:59:46',0,'2013-12-26 00:31:51',NULL,NULL),(19107,3544,'2571571','834','00','005010X220A1','2571571','','2014-02-12','09:07:51',0,'2014-02-12 21:31:42',NULL,NULL),(17291,3172,'1972397','834','00','005010X220A1','1972397','','2014-01-31','13:27:10',0,'2014-01-31 21:00:35',NULL,NULL),(16870,3093,'2034791','834','00','005010X220A1','2034791','','2014-01-28','13:55:30',0,'2014-01-28 21:00:53',NULL,NULL),(16655,3060,'2240519','834','00','005010X220A1','2240519','','2014-01-27','13:35:04',0,'2014-01-27 21:00:14',NULL,NULL),(16423,3001,'1601875','834','00','005010X220A1','1601875','','2014-01-23','11:44:08',0,'2014-01-23 21:01:38',NULL,NULL),(2913,540,'1626','834','00','005010X220A1','1626','','2013-12-13','15:05:50',0,'2013-12-25 21:30:21',NULL,NULL),(2318,406,'209593','834','00','005010X220A1','209593','','2013-11-02','16:58:27',0,'2013-12-25 20:01:50',NULL,NULL),(15091,2585,'2511066','834','00','005010X220A1','2511066','','2014-01-15','17:10:49',0,'2014-01-16 08:45:13',NULL,NULL),(14861,2554,'1492778','834','00','005010X220A1','1492778','','2014-01-13','19:19:04',0,'2014-01-15 02:07:11',NULL,NULL),(6297,1173,'907614','834','00','005010X220A1','907614','','2013-12-20','18:06:05',0,'2013-12-26 03:07:20',NULL,NULL),(2556,462,'116515','834','00','005010X220A1','116515','','2013-11-17','19:46:50',0,'2013-12-25 20:31:46',NULL,NULL),(19480,3620,'2916359','834','00','005010X220A1','2916359','','2014-02-13','23:04:14',0,'2014-02-14 21:30:12',NULL,NULL),(18658,3466,'3132498','834','00','005010X220A1','3132498','','2014-02-10','00:34:31',0,'2014-02-10 21:31:45',NULL,NULL),(15410,2628,'2237857','834','00','005010X220A1','2237857','','2014-01-15','18:52:55',0,'2014-01-17 03:35:52',NULL,NULL),(14755,2551,'2588976','834','00','005010X220A1','2588976','','2014-01-13','20:00:59',0,'2014-01-15 02:06:26',NULL,NULL),(13927,2316,'2216591','834','00','005010X220A1','2216591','','2014-01-08','18:40:42',0,'2014-01-13 02:20:03',NULL,NULL),(2732,503,'875165','834','00','005010X220A1','875165','','2013-12-22','14:18:37',0,'2013-12-25 21:18:12',NULL,NULL),(3397,588,'164935','834','00','005010X220A1','164935','','2013-12-17','15:42:40',0,'2013-12-25 21:51:34',NULL,NULL),(4296,747,'438687','834','00','005010X220A1','438687','','2013-12-18','22:03:23',0,'2013-12-25 23:09:12',NULL,NULL),(3934,714,'144830','834','00','005010X220A1','144830','','2013-12-06','21:10:09',0,'2013-12-25 22:46:03',NULL,NULL),(3823,671,'549927','834','00','005010X220A1','549927','','2013-12-08','12:53:25',0,'2013-12-25 22:17:10',NULL,NULL),(1692,291,'1187003','834','00','005010X220A1','1187003','','2013-12-10','17:40:02',0,'2013-12-25 19:16:14',NULL,NULL),(21226,3999,'3460417','834','00','005010X220A1','3460417','','2014-02-26','09:23:12',0,'2014-02-26 21:01:33',NULL,NULL),(21078,3980,'2469511','834','00','005010X220A1','2469511','','2014-02-24','17:43:27',0,'2014-02-26 09:30:47',NULL,NULL),(13703,2274,'2538630','834','00','005010X220A1','2538630','','2014-01-07','15:03:37',0,'2014-01-08 18:24:30',NULL,NULL),(20589,3870,'3697480','834','00','005010X220A1','3697480','','2014-02-21','09:55:26',0,'2014-02-21 22:00:06',NULL,NULL),(20373,3823,'2838438','834','00','005010X220A1','2838438','','2014-02-19','09:22:05',0,'2014-02-20 05:34:14',NULL,NULL),(13531,2241,'2530837','834','00','005010X220A1','2530837','','2014-01-06','10:57:16',0,'2014-01-07 04:05:48',NULL,NULL),(14845,2553,'1739226','834','00','005010X220A1','1739226','','2014-01-14','12:29:28',0,'2014-01-15 02:07:04',NULL,NULL),(12652,1672,'1565315','834','00','005010X220A1','1565315','','2014-01-02','13:35:51',0,'2014-01-03 02:03:00',NULL,NULL),(10401,1400,'855607','834','00','005010X220A1','855607','','2013-12-23','08:35:27',0,'2013-12-26 12:50:45',NULL,NULL),(2446,421,'83180','834','00','005010X220A1','83180','','2013-12-05','21:45:10',0,'2013-12-25 20:18:44',NULL,NULL),(2971,541,'552645','834','00','005010X220A1','552645','','2013-12-13','14:38:09',0,'2013-12-25 21:32:14',NULL,NULL),(11847,1547,'1704871','834','00','005010X220A1','1704871','','2013-12-28','20:17:02',1,'2013-12-29 11:14:38',NULL,NULL),(3234,578,'623224','834','00','005010X220A1','623224','','2013-12-17','13:33:44',0,'2013-12-25 21:46:21',NULL,NULL),(21899,4127,'3320854','834','00','005010X220A1','3320854','','2014-02-28','18:52:24',0,'2014-03-01 21:00:30',NULL,NULL),(20511,3849,'3442234','834','00','005010X220A1','3442234','','2014-02-19','19:50:28',0,'2014-02-20 22:01:12',NULL,NULL),(1803,306,'312913','834','00','005010X220A1','312913','','2013-12-10','09:27:13',0,'2013-12-25 19:19:44',NULL,NULL),(17661,3258,'2062539','834','00','005010X220A1','2062539','','2014-02-03','19:36:55',0,'2014-02-04 21:00:05',NULL,NULL),(16930,3115,'2015068','834','00','005010X220A1','2015068','','2014-01-28','20:51:57',0,'2014-01-29 21:00:10',NULL,NULL),(16447,3006,'2311615','834','00','005010X220A1','2311615','','2014-01-23','20:37:33',0,'2014-01-24 21:00:10',NULL,NULL),(15437,2629,'1408681','834','00','005010X220A1','1408681','','2014-01-15','19:53:18',0,'2014-01-17 03:36:04',NULL,NULL),(14763,2551,'1800038','834','00','005010X220A1','1800038','','2014-01-14','01:10:44',0,'2014-01-15 02:06:29',NULL,NULL),(13827,2300,'1839762','834','00','005010X220A1','1839762','','2014-01-11','10:09:40',0,'2014-01-13 02:18:33',NULL,NULL),(12219,1616,'2226366','834','00','005010X220A1','2226366','','2013-12-31','18:49:02',1,'2014-01-02 04:22:11',NULL,NULL),(1160,239,'1057661','834','00','005010X220A1','1057661','','2013-12-24','12:19:24',0,'2013-12-25 18:46:29',NULL,NULL),(1290,244,'1710073','834','00','005010X220A1','1710073','','2013-12-24','05:04:46',0,'2013-12-25 18:50:28',NULL,NULL),(5818,1085,'996974','834','00','005010X220A1','996974','','2013-12-14','16:57:31',0,'2013-12-26 02:04:09',NULL,NULL),(851,175,'1135708','834','00','005010X220A1','1135708','','2013-12-03','15:33:48',0,'2013-12-25 18:15:40',NULL,NULL),(20508,3847,'3473580','834','00','005010X220A1','3473580','','2014-02-20','15:34:53',0,'2014-02-20 22:01:10',NULL,NULL),(19231,3580,'2726060','834','00','005010X220A1','2726060','','2014-02-13','11:28:29',0,'2014-02-13 22:00:18',NULL,NULL),(18803,3487,'1963723','834','00','005010X220A1','1963723','','2014-02-11','16:00:56',0,'2014-02-11 21:01:17',NULL,NULL),(1699,292,'1076792','834','00','005010X220A1','1076792','','2013-12-09','21:44:38',0,'2013-12-25 19:16:27',NULL,NULL),(3326,586,'1196882','834','00','005010X220A1','1196882','','2013-12-16','22:35:57',0,'2013-12-25 21:49:24',NULL,NULL),(15421,2629,'1721307','834','00','005010X220A1','1721307','','2014-01-16','10:20:34',0,'2014-01-17 03:35:57',NULL,NULL),(3461,612,'520025','834','00','005010X220A1','520025','','2013-12-17','13:42:18',0,'2013-12-25 21:53:40',NULL,NULL),(11068,1421,'1577369','834','00','005010X220A1','1577369','','2013-12-23','13:32:15',0,'2013-12-26 13:13:04',NULL,NULL),(12054,1585,'1761711','834','00','005010X220A1','1761711','','2013-12-30','09:17:20',0,'2014-01-01 12:04:09',NULL,NULL),(1902,325,'512620','834','00','005010X220A1','512620','','2013-12-09','12:36:01',0,'2013-12-25 19:31:49',NULL,NULL),(20294,3794,'2879706','834','00','005010X220A1','2879706','','2014-02-19','11:52:37',0,'2014-02-20 04:41:49',NULL,NULL),(4893,900,'229985','834','00','005010X220A1','229985','','2013-10-02','07:22:01',0,'2013-12-26 00:17:08',NULL,NULL),(5576,1043,'1466813','834','00','005010X220A1','1466813','','2013-12-24','21:51:35',0,'2013-12-26 01:48:53',NULL,NULL),(5657,1051,'1559774','834','00','005010X220A1','1559774','','2013-12-25','00:45:23',0,'2013-12-26 01:51:32',NULL,NULL),(6028,1141,'594419','834','00','005010X220A1','594419','','2013-11-17','11:38:29',0,'2013-12-26 02:45:48',NULL,NULL),(14343,2401,'2391131','834','00','005010X220A1','2391131','','2014-01-11','22:01:29',0,'2014-01-13 03:01:20',NULL,NULL),(10964,1410,'1701196','834','00','005010X220A1','1701196','','2013-12-23','18:30:07',0,'2013-12-26 13:09:33',NULL,NULL),(23241,4364,'3271866','834','00','005010X220A1','3271866','','2014-03-07','11:46:20',0,'2014-03-07 21:32:16',NULL,NULL),(23400,4403,'2873647','834','00','005010X220A1','2873647','','2014-03-09','15:13:56',0,'2014-03-09 21:00:11',NULL,NULL),(2036,331,'691673','834','00','005010X220A1','691673','','2013-12-09','17:45:13',0,'2013-12-25 19:35:59',NULL,NULL),(2394,414,'940120','834','00','005010X220A1','940120','','2013-12-06','13:58:47',0,'2013-12-25 20:17:00',NULL,NULL),(17729,3261,'2534193','834','00','005010X220A1','2534193','','2014-02-04','16:56:28',0,'2014-02-04 21:00:47',NULL,NULL),(17193,3149,'1655563','834','00','005010X220A1','1655563','','2014-01-30','11:38:42',0,'2014-01-30 21:01:04',NULL,NULL),(15756,2714,'1863762','834','00','005010X220A1','1863762','','2014-01-20','09:41:08',0,'2014-01-21 08:46:21',NULL,NULL),(2567,468,'176692','834','00','005010X220A1','176692','','2013-10-03','06:51:37',0,'2013-12-25 20:32:09',NULL,NULL),(2699,502,'1286207','834','00','005010X220A1','1286207','','2013-12-22','15:24:19',0,'2013-12-25 21:17:10',NULL,NULL),(10910,1410,'915973','834','00','005010X220A1','915973','','2013-12-22','19:46:26',0,'2013-12-26 13:07:58',NULL,NULL),(3614,620,'1022590','834','00','005010X220A1','1022590','','2013-12-11','19:17:35',0,'2013-12-25 22:04:46',NULL,NULL),(6158,1167,'859387','834','00','005010X220A1','859387','','2013-12-19','23:02:22',0,'2013-12-26 03:03:05',NULL,NULL),(3800,660,'286879','834','00','005010X220A1','286879','','2013-12-08','13:23:57',0,'2013-12-25 22:16:18',NULL,NULL),(22914,4286,'2774691','834','00','005010X220A1','2774691','','2014-03-06','15:30:29',0,'2014-03-06 21:02:26',NULL,NULL),(23505,4434,'3050294','834','00','005010X220A1','3050294','','2014-03-10','11:38:55',0,'2014-03-10 21:00:07',NULL,NULL),(2526,455,'724586','834','00','005010X220A1','724586','','2013-11-18','06:34:42',0,'2013-12-25 20:30:48',NULL,NULL),(20912,3931,'3476245','834','00','005010X220A1','3476245','','2014-02-23','14:28:06',0,'2014-02-26 08:00:11',NULL,NULL),(2314,403,'1091800','834','00','005010X220A1','1091800','','2013-11-02','13:40:13',0,'2013-12-25 20:01:41',NULL,NULL),(2263,383,'727344','834','00','005010X220A1','727344','','2013-12-02','15:04:19',0,'2013-12-25 19:50:23',NULL,NULL),(3723,636,'697327','834','00','005010X220A1','697327','','2013-12-12','14:25:19',0,'2013-12-25 22:08:17',NULL,NULL),(12487,1640,'2227666','834','00','005010X220A1','2227666','','2013-12-31','18:30:17',1,'2014-01-02 04:32:49',NULL,NULL),(23018,4325,'3584802','834','00','005010X220A1','3584802','','2014-03-07','00:24:12',0,'2014-03-07 21:00:19',NULL,NULL),(4399,776,'1176895','834','00','005010X220A1','1176895','','2013-11-26','20:28:03',0,'2013-12-25 23:15:54',NULL,NULL),(22375,4206,'3294588','834','00','005010X220A1','3294588','','2014-03-04','17:45:19',0,'2014-03-04 21:01:59',NULL,NULL),(22199,4185,'3311628','834','00','005010X220A1','3311628','','2014-03-02','20:32:25',0,'2014-03-03 21:31:31',NULL,NULL),(22165,4180,'3063110','834','00','005010X220A1','3063110','','2014-03-03','11:44:37',0,'2014-03-03 21:31:06',NULL,NULL),(21951,4136,'3040892','834','00','005010X220A1','3040892','','2014-02-28','22:48:57',0,'2014-03-01 21:01:06',NULL,NULL),(19975,3746,'2959753','834','00','005010X220A1','2959753','','2014-02-18','14:02:14',0,'2014-02-18 22:00:15',NULL,NULL),(19358,3585,'3178917','834','00','005010X220A1','3178917','','2014-02-13','14:17:05',0,'2014-02-13 22:01:58',NULL,NULL),(7209,1241,'195055','834','00','005010X220A1','195055','','2013-12-18','09:34:21',0,'2013-12-26 04:06:55',NULL,NULL),(7183,1239,'11853','834','00','005010X220A1','11853','','2013-12-17','20:15:23',0,'2013-12-26 04:06:06',NULL,NULL),(15943,2758,'1704281','834','00','005010X220A1','1704281','','2014-01-21','12:56:40',1,'2014-01-22 03:23:08',NULL,NULL),(6462,1219,'317590','834','00','005010X220A1','317590','','2013-11-22','11:27:54',0,'2013-12-26 03:16:31',NULL,NULL),(19864,3707,'2294993','834','00','005010X220A1','2294993','','2014-02-15','19:22:45',0,'2014-02-16 19:00:11',NULL,NULL),(2326,409,'210817','834','00','005010X220A1','210817','','2013-10-08','09:28:57',0,'2013-12-25 20:02:08',NULL,NULL),(19083,3542,'2518097','834','00','005010X220A1','2518097','','2014-02-12','14:37:31',0,'2014-02-12 21:31:27',NULL,NULL),(13530,2241,'2465328','834','00','005010X220A1','2465328','','2014-01-06','10:34:44',0,'2014-01-07 04:05:47',NULL,NULL),(16578,3037,'2298160','834','00','005010X220A1','2298160','','2014-01-25','11:17:07',0,'2014-01-25 19:00:10',NULL,NULL),(16135,2827,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:19:00',1,'2014-01-23 03:51:46',NULL,NULL),(6112,1166,'484199','834','00','005010X220A1','484199','','2013-12-20','13:28:32',0,'2013-12-26 03:01:40',NULL,NULL),(12427,1638,'2235375','834','00','005010X220A1','2235375','','2013-12-31','13:27:12',1,'2014-01-02 04:30:39',NULL,NULL),(15786,2719,'1890430','834','00','005010X220A1','1890430','','2014-01-20','11:37:37',0,'2014-01-21 08:46:40',NULL,NULL),(16826,3091,'2214463','834','00','005010X220A1','2214463','','2014-01-27','19:41:14',0,'2014-01-28 21:00:24',NULL,NULL),(18888,3498,'2121009','834','00','005010X220A1','2121009','','2014-02-11','12:16:24',0,'2014-02-11 21:02:25',NULL,NULL),(21391,4024,'3452460','834','00','005010X220A1','3452460','','2014-02-27','17:23:05',0,'2014-02-28 06:30:31',NULL,NULL),(21871,4122,'3314032','834','00','005010X220A1','3314032','','2014-02-28','21:04:35',0,'2014-03-01 21:00:10',NULL,NULL),(12650,1672,'1593911','834','00','005010X220A1','1593911','','2014-01-02','11:47:43',0,'2014-01-03 02:02:56',NULL,NULL),(11704,1517,'1270769','834','00','005010X220A1','1270769','','2013-12-27','23:29:50',1,'2013-12-29 11:08:00',NULL,NULL),(20223,3786,'3436187','834','00','005010X220A1','3436187','','2014-02-18','21:51:59',0,'2014-02-20 04:24:10',NULL,NULL),(11703,1517,'2200948','834','00','005010X220A1','2200948','','2013-12-27','23:08:56',1,'2013-12-29 11:07:59',NULL,NULL),(10851,1406,'1529970','834','00','005010X220A1','1529970','','2013-12-22','18:59:47',0,'2013-12-26 13:05:32',NULL,NULL),(10496,1400,'1739978','834','00','005010X220A1','1739978','','2013-12-23','17:30:03',0,'2013-12-26 12:53:44',NULL,NULL),(12869,1706,'1590048','834','00','005010X220A1','1590048','','2014-01-03','11:48:10',0,'2014-01-04 02:03:46',NULL,NULL),(21992,4145,'3590524','834','00','005010X220A1','3590524','','2014-03-02','16:40:59',0,'2014-03-03 01:00:19',NULL,NULL),(22535,4248,'3794123','834','00','005010X220A1','3794123','','2014-03-04','18:07:56',0,'2014-03-05 21:30:31',NULL,NULL),(2424,417,'925751','834','00','005010X220A1','925751','','2013-12-06','18:09:08',0,'2013-12-25 20:18:00',NULL,NULL),(5683,1061,'1463093','834','00','005010X220A1','1463093','','2013-12-24','22:03:57',0,'2013-12-26 01:52:34',NULL,NULL),(14406,2427,'0001','999','BE','005010X231A1','581641','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:19',NULL,NULL),(19693,3671,'2285470','834','00','005010X220A1','2285470','','2014-02-14','21:12:29',0,'2014-02-15 22:00:03',NULL,NULL),(7765,1352,'1055051','834','00','005010X220A1','1055051','','2013-10-21','07:45:58',0,'2013-12-26 05:01:21',NULL,NULL),(17791,3269,'1742269','834','00','005010X220A1','1742269','','2014-02-04','12:15:23',0,'2014-02-04 21:01:26',NULL,NULL),(17286,3172,'1810197','834','00','005010X220A1','1810197','','2014-01-31','08:26:03',0,'2014-01-31 21:00:32',NULL,NULL),(16137,2829,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:16:00',1,'2014-01-23 03:52:37',NULL,NULL),(12943,1733,'1638060','834','00','005010X220A1','1638060','','2014-01-03','18:32:22',0,'2014-01-05 00:00:04',NULL,NULL),(2799,506,'665225','834','00','005010X220A1','665225','','2013-12-22','12:07:42',0,'2013-12-25 21:20:18',NULL,NULL),(5013,935,'1114117','834','00','005010X220A1','1114117','','2013-12-11','11:16:50',0,'2013-12-26 00:46:24',NULL,NULL),(11610,1494,'2066487','834','00','005010X220A1','2066487','','2013-12-26','19:49:41',0,'2013-12-28 03:35:02',NULL,NULL),(7636,1309,'1139926','834','00','005010X220A1','1139926','','2013-12-21','10:32:48',0,'2013-12-26 04:38:24',NULL,NULL),(21560,4053,'3355075','834','00','005010X220A1','3355075','','2014-02-26','10:29:15',0,'2014-02-28 07:00:05',NULL,NULL),(20757,3904,'3679029','834','00','005010X220A1','3679029','','2014-02-24','18:03:40',0,'2014-02-25 21:30:25',NULL,NULL),(7601,1303,'1051271','834','00','005010X220A1','1051271','','2013-12-21','07:59:39',0,'2013-12-26 04:37:18',NULL,NULL),(18653,3464,'2853748','834','00','005010X220A1','2853748','','2014-02-10','12:49:50',0,'2014-02-10 21:31:41',NULL,NULL),(18035,3319,'1522917','834','00','005010X220A1','1522917','','2014-02-06','13:07:54',0,'2014-02-06 21:00:31',NULL,NULL),(6239,1169,'473288','834','00','005010X220A1','473288','','2013-12-19','21:46:57',0,'2013-12-26 03:05:34',NULL,NULL),(16324,2983,'1453885','834','00','005010X220A1','1453885','','2014-01-22','18:59:33',0,'2014-01-23 21:00:31',NULL,NULL),(1450,252,'1810653','834','00','005010X220A1','1810653','','2013-12-24','12:24:11',0,'2013-12-25 18:55:42',NULL,NULL),(10732,1403,'293426','834','00','005010X220A1','293426','','2013-12-23','14:21:16',0,'2013-12-26 13:01:41',NULL,NULL),(13512,2235,'1869879','834','00','005010X220A1','1869879','','2014-01-05','23:11:53',0,'2014-01-07 04:05:08',NULL,NULL),(11200,1453,'2126230','834','00','005010X220A1','2126230','','2013-12-26','16:22:59',0,'2013-12-27 02:00:26',NULL,NULL),(5634,1047,'1616491','834','00','005010X220A1','1616491','','2013-12-24','23:05:28',0,'2013-12-26 01:50:48',NULL,NULL),(19958,3746,'3100378','834','00','005010X220A1','3100378','','2014-02-17','20:55:29',0,'2014-02-18 22:00:03',NULL,NULL),(19144,3549,'3314573','834','00','005010X220A1','3314573','','2014-02-12','14:46:13',0,'2014-02-12 21:32:05',NULL,NULL),(19087,3542,'2825355','834','00','005010X220A1','2825355','','2014-02-12','16:37:38',0,'2014-02-12 21:31:29',NULL,NULL),(19008,3539,'2544743','834','00','005010X220A1','2544743','','2014-02-11','22:50:55',0,'2014-02-12 21:30:31',NULL,NULL),(18786,3487,'3030396','834','00','005010X220A1','3030396','','2014-02-10','22:54:08',0,'2014-02-11 21:01:04',NULL,NULL),(15770,2715,'1393800','834','00','005010X220A1','1393800','','2014-01-20','10:02:13',0,'2014-01-21 08:46:29',NULL,NULL),(14033,2337,'1687273','834','00','005010X220A1','1687273','','2014-01-08','14:50:32',0,'2014-01-13 02:21:26',NULL,NULL),(1038,200,'588490','834','00','005010X220A1','588490','','2013-12-03','14:39:54',0,'2013-12-25 18:21:28',NULL,NULL),(5261,970,'1174292','834','00','005010X220A1','1174292','','2013-11-12','07:57:49',0,'2013-12-26 01:00:03',NULL,NULL),(1040,202,'195885','834','00','005010X220A1','195885','','2013-12-03','16:43:22',0,'2013-12-25 18:21:31',NULL,NULL),(4638,827,'1176489','834','00','005010X220A1','1176489','','2013-12-23','23:38:59',0,'2013-12-25 23:48:30',NULL,NULL),(4052,731,'1275363','834','00','005010X220A1','1275363','','2013-12-19','18:15:48',0,'2013-12-25 23:01:44',NULL,NULL),(21399,4025,'3067870','834','00','005010X220A1','3067870','','2014-02-26','20:12:13',0,'2014-02-28 06:30:34',NULL,NULL),(21254,3999,'3381795','834','00','005010X220A1','3381795','','2014-02-26','16:31:21',0,'2014-02-26 21:01:51',NULL,NULL),(4960,930,'676844','834','00','005010X220A1','676844','','2013-10-06','20:53:40',0,'2013-12-26 00:32:11',NULL,NULL),(5042,935,'764857','834','00','005010X220A1','764857','','2013-12-11','17:31:04',0,'2013-12-26 00:47:18',NULL,NULL),(15683,2694,'2071858','834','00','005010X220A1','2071858','','2014-01-19','13:18:30',0,'2014-01-21 08:45:15',NULL,NULL),(11517,1490,'1505545','834','00','005010X220A1','1505545','','2013-12-27','11:39:52',0,'2013-12-28 03:32:08',NULL,NULL),(12154,1591,'2470942','834','00','005010X220A1','2470942','','2013-12-30','16:30:59',0,'2014-01-01 12:07:37',NULL,NULL),(11958,1580,'312360','834','00','005010X220A1','312360','','2013-12-30','10:40:35',0,'2014-01-01 12:00:30',NULL,NULL),(22031,4162,'2892502','834','00','005010X220A1','2892502','','2014-03-02','15:43:30',0,'2014-03-03 01:30:00',NULL,NULL),(2963,541,'785348','834','00','005010X220A1','785348','','2013-12-13','13:38:42',0,'2013-12-25 21:32:00',NULL,NULL),(11978,1580,'2492056','834','00','005010X220A1','2492056','','2013-12-30','15:23:38',0,'2014-01-01 12:01:17',NULL,NULL),(15172,2591,'2215445','834','00','005010X220A1','2215445','','2014-01-14','21:44:55',0,'2014-01-16 08:46:09',NULL,NULL),(18933,3521,'2112472','834','00','005010X220A1','2112472','','2014-02-10','19:38:29',0,'2014-02-11 21:30:12',NULL,NULL),(17776,3267,'2272191','834','00','005010X220A1','2272191','','2014-02-03','21:05:44',0,'2014-02-04 21:01:17',NULL,NULL),(21686,4084,'3019703','834','00','005010X220A1','3019703','','2014-02-28','14:55:44',0,'2014-02-28 21:00:26',NULL,NULL),(15863,2738,'1743244','834','00','005010X220A1','1743244','','2014-01-21','12:20:57',1,'2014-01-22 03:22:16',NULL,NULL),(22508,4247,'3062091','834','00','005010X220A1','3062091','','2014-03-05','09:58:32',0,'2014-03-05 21:30:12',NULL,NULL),(3745,644,'701992','834','00','005010X220A1','701992','','2013-12-12','16:22:24',0,'2013-12-25 22:09:02',NULL,NULL),(14023,2337,'1723598','834','00','005010X220A1','1723598','','2014-01-08','12:21:52',0,'2014-01-13 02:21:20',NULL,NULL),(20792,3909,'2894557','834','00','005010X220A1','2894557','','2014-02-24','19:06:56',0,'2014-02-25 21:30:49',NULL,NULL),(18341,3394,'2025722','834','00','005010X220A1','2025722','','2014-02-08','16:06:16',0,'2014-02-08 19:01:01',NULL,NULL),(17510,3230,'2550560','834','00','005010X220A1','2550560','','2014-02-02','15:35:39',0,'2014-02-02 19:00:32',NULL,NULL),(14433,2454,'0001','999','BE','005010X231A1','244976','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:44',NULL,NULL),(16340,2983,'2225570','834','00','005010X220A1','2225570','','2014-01-23','16:43:01',0,'2014-01-23 21:00:42',NULL,NULL),(19611,3635,'2597027','834','00','005010X220A1','2597027','','2014-02-14','02:15:56',0,'2014-02-14 21:31:45',NULL,NULL),(22754,4276,'2801026','834','00','005010X220A1','2801026','','2014-03-06','14:11:09',0,'2014-03-06 21:00:32',NULL,NULL),(253,46,'711422','834','00','005010X220A1','711422','','2013-11-13','01:00:06',0,'2013-12-25 17:30:58',NULL,NULL),(21845,4110,'3806340','834','00','005010X220A1','3806340','','2014-02-28','15:58:37',0,'2014-02-28 21:31:55',NULL,NULL),(21580,4056,'3802573','834','00','005010X220A1','3802573','','2014-02-26','11:43:01',0,'2014-02-28 07:00:22',NULL,NULL),(13107,1951,'0001','999','BE','005010X231A1','1084759','834','2013-12-27','16:55:00',0,'2014-01-05 16:53:58',NULL,NULL),(21195,3998,'3620057','834','00','005010X220A1','3620057','','2014-02-26','14:44:51',0,'2014-02-26 21:01:13',NULL,NULL),(19587,3629,'2069997','834','00','005010X220A1','2069997','','2014-02-14','13:19:55',0,'2014-02-14 21:31:28',NULL,NULL),(17650,3251,'1511628','834','00','005010X220A1','1511628','','2014-02-03','11:54:25',0,'2014-02-03 21:01:30',NULL,NULL),(2840,511,'146792','834','00','005010X220A1','146792','','2013-12-22','11:35:43',0,'2013-12-25 21:21:40',NULL,NULL),(427,77,'324257','834','00','005010X220A1','324257','','2013-12-04','14:14:44',0,'2013-12-25 17:49:14',NULL,NULL),(10702,1403,'1386455','834','00','005010X220A1','1386455','','2013-12-23','10:44:16',0,'2013-12-26 13:00:37',NULL,NULL),(6336,1176,'412103','834','00','005010X220A1','412103','','2013-12-20','14:03:49',0,'2013-12-26 03:08:29',NULL,NULL),(23279,4380,'3247448','834','00','005010X220A1','3247448','','2014-03-08','00:01:31',0,'2014-03-08 21:30:04',NULL,NULL),(161,11,'1081810','834','00','005010X220A1','1081810','','2013-12-04','19:50:17',0,'2013-12-25 17:19:59',NULL,NULL),(22241,4199,'3145436','834','00','005010X220A1','3145436','','2014-03-04','14:28:50',0,'2014-03-04 21:00:13',NULL,NULL),(21704,4087,'3286787','834','00','005010X220A1','3286787','','2014-02-28','15:58:37',0,'2014-02-28 21:30:16',NULL,NULL),(20408,3833,'2818354','834','00','005010X220A1','2818354','','2014-02-20','14:51:27',0,'2014-02-20 21:30:12',NULL,NULL),(19627,3641,'3222382','834','00','005010X220A1','3222382','','2014-02-14','11:41:00',0,'2014-02-14 21:31:57',NULL,NULL),(10701,1403,'745932','834','00','005010X220A1','745932','','2013-12-23','10:06:19',0,'2013-12-26 13:00:35',NULL,NULL),(396,76,'1119414','834','00','005010X220A1','1119414','','2013-12-03','21:07:38',0,'2013-12-25 17:48:16',NULL,NULL),(12456,1639,'2433509','834','00','005010X220A1','2433509','','2013-12-31','12:44:00',1,'2014-01-02 04:31:43',NULL,NULL),(10426,1400,'628482','834','00','005010X220A1','628482','','2013-12-23','10:40:24',0,'2013-12-26 12:51:29',NULL,NULL),(11787,1537,'1420744','834','00','005010X220A1','1420744','','2013-12-28','20:12:03',1,'2013-12-29 11:12:44',NULL,NULL),(11252,1454,'1955180','834','00','005010X220A1','1955180','','2013-12-26','15:16:17',0,'2013-12-27 02:02:02',NULL,NULL),(949,181,'1286914','834','00','005010X220A1','1286914','','2013-12-02','23:39:32',0,'2013-12-25 18:18:37',NULL,NULL),(3493,615,'525689','834','00','005010X220A1','525689','','2013-12-12','13:13:38',0,'2013-12-25 22:00:57',NULL,NULL),(4367,767,'205237','834','00','005010X220A1','205237','','2013-12-19','16:03:36',0,'2013-12-25 23:11:19',NULL,NULL),(22361,4205,'2736749','834','00','005010X220A1','2736749','','2014-03-04','13:19:21',0,'2014-03-04 21:01:47',NULL,NULL),(23059,4339,'2862008','834','00','005010X220A1','2862008','','2014-03-06','19:58:35',0,'2014-03-07 21:30:05',NULL,NULL),(1195,239,'1303456','834','00','005010X220A1','1303456','','2013-12-24','17:38:58',0,'2013-12-25 18:47:36',NULL,NULL),(22279,4200,'2740392','834','00','005010X220A1','2740392','','2014-03-04','14:54:20',0,'2014-03-04 21:00:43',NULL,NULL),(20334,3802,'3415696','834','00','005010X220A1','3415696','','2014-02-18','22:48:37',0,'2014-02-20 04:51:40',NULL,NULL),(19266,3581,'2710087','834','00','005010X220A1','2710087','','2014-02-13','16:06:35',0,'2014-02-13 22:00:47',NULL,NULL),(1444,252,'786006','834','00','005010X220A1','786006','','2013-12-24','11:07:31',0,'2013-12-25 18:55:31',NULL,NULL),(17034,3120,'1358595','834','00','005010X220A1','1358595','','2014-01-29','16:29:04',0,'2014-01-29 21:01:16',NULL,NULL),(3117,547,'1163598','834','00','005010X220A1','1163598','','2013-12-13','14:24:46',0,'2013-12-25 21:36:42',NULL,NULL),(16668,3060,'2038706','834','00','005010X220A1','2038706','','2014-01-27','17:49:28',0,'2014-01-27 21:00:23',NULL,NULL),(6257,1172,'607577','834','00','005010X220A1','607577','','2013-12-19','21:30:27',0,'2013-12-26 03:06:08',NULL,NULL),(11692,1517,'2256239','834','00','005010X220A1','2256239','','2013-12-27','18:43:52',1,'2013-12-29 11:07:40',NULL,NULL),(15018,2584,'2062154','834','00','005010X220A1','2062154','','2014-01-15','14:51:35',0,'2014-01-16 08:44:29',NULL,NULL),(13935,2317,'1853007','834','00','005010X220A1','1853007','','2014-01-09','13:38:57',0,'2014-01-13 02:20:10',NULL,NULL),(14382,2410,'1882802','834','00','005010X220A1','1882802','','2014-01-12','12:16:21',0,'2014-01-13 03:01:49',NULL,NULL),(23043,4333,'2748557','834','00','005010X220A1','2748557','','2014-03-07','14:08:31',0,'2014-03-07 21:00:32',NULL,NULL),(10499,1400,'1595960','834','00','005010X220A1','1595960','','2013-12-23','18:01:49',0,'2013-12-26 12:53:51',NULL,NULL),(22374,4206,'3128313','834','00','005010X220A1','3128313','','2014-03-04','16:57:06',0,'2014-03-04 21:01:58',NULL,NULL),(21547,4043,'3051994','834','00','005010X220A1','3051994','','2014-02-27','13:55:53',0,'2014-02-28 06:31:43',NULL,NULL),(11774,1530,'428341','834','00','005010X220A1','428341','','2013-12-27','19:35:37',1,'2013-12-29 11:10:09',NULL,NULL),(13866,2311,'1999304','834','00','005010X220A1','1999304','','2014-01-09','11:37:47',0,'2014-01-13 02:19:23',NULL,NULL),(20573,3865,'3386825','834','00','005010X220A1','3386825','','2014-02-21','16:03:05',0,'2014-02-21 21:30:17',NULL,NULL),(18580,3453,'2384612','834','00','005010X220A1','2384612','','2014-02-10','15:16:02',0,'2014-02-10 21:30:50',NULL,NULL),(15680,2691,'1730896','834','00','005010X220A1','1730896','','2014-01-18','15:30:36',0,'2014-01-21 08:44:46',NULL,NULL),(22591,4250,'3059294','834','00','005010X220A1','3059294','','2014-03-04','18:24:45',0,'2014-03-05 21:31:12',NULL,NULL),(22668,4254,'2987157','834','00','005010X220A1','2987157','','2014-03-05','15:43:17',0,'2014-03-05 21:32:04',NULL,NULL),(23579,4436,'3240230','834','00','005010X220A1','3240230','','2014-03-10','16:56:34',0,'2014-03-10 21:01:02',NULL,NULL),(250,45,'546147','834','00','005010X220A1','546147','','2013-11-13','09:02:27',0,'2013-12-25 17:30:51',NULL,NULL),(5696,1067,'1075471','834','00','005010X220A1','1075471','','2013-12-14','11:42:23',0,'2013-12-26 02:00:17',NULL,NULL),(2620,489,'1268326','834','00','005010X220A1','1268326','','2013-11-28','15:24:43',0,'2013-12-25 20:46:36',NULL,NULL),(20691,3889,'3388104','834','00','005010X220A1','3388104','','2014-02-22','15:29:34',0,'2014-02-22 19:00:13',NULL,NULL),(19115,3545,'3072183','834','00','005010X220A1','3072183','','2014-02-12','15:59:26',0,'2014-02-12 21:31:47',NULL,NULL),(14037,2337,'1883977','834','00','005010X220A1','1883977','','2014-01-08','15:26:59',0,'2014-01-13 02:21:29',NULL,NULL),(23040,4331,'3826284','834','00','005010X220A1','3826284','','2014-03-07','11:14:35',0,'2014-03-07 21:00:31',NULL,NULL),(13156,2000,'0001','999','BE','005010X231A1','1055543','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:49',NULL,NULL),(12321,1634,'1648590','834','00','005010X220A1','1648590','','2013-12-30','20:10:58',1,'2014-01-02 04:26:51',NULL,NULL),(19799,3677,'3285103','834','00','005010X220A1','3285103','','2014-02-15','12:10:40',0,'2014-02-15 22:01:21',NULL,NULL),(19642,3644,'2584180','834','00','005010X220A1','2584180','','2014-02-14','16:04:17',0,'2014-02-14 21:32:08',NULL,NULL),(10485,1400,'1741112','834','00','005010X220A1','1741112','','2013-12-23','16:22:29',0,'2013-12-26 12:53:25',NULL,NULL),(1334,245,'788452','834','00','005010X220A1','788452','','2013-12-24','12:19:29',0,'2013-12-25 18:51:54',NULL,NULL),(18246,3372,'2747719','834','00','005010X220A1','2747719','','2014-02-07','17:33:37',0,'2014-02-07 19:01:09',NULL,NULL),(18164,3350,'2136262','834','00','005010X220A1','2136262','','2014-02-07','08:57:11',0,'2014-02-07 19:00:10',NULL,NULL),(13802,2294,'1847181','834','00','005010X220A1','1847181','','2014-01-11','16:12:54',0,'2014-01-13 02:18:16',NULL,NULL),(14517,2517,'1750416','834','00','005010X220A1','1750416','','2014-01-13','13:17:58',0,'2014-01-14 01:32:13',NULL,NULL),(23513,4434,'3598325','834','00','005010X220A1','3598325','','2014-03-10','14:21:46',0,'2014-03-10 21:00:12',NULL,NULL),(3238,578,'804490','834','00','005010X220A1','804490','','2013-12-17','15:12:55',0,'2013-12-25 21:46:29',NULL,NULL),(19638,3643,'3077248','834','00','005010X220A1','3077248','','2014-02-14','16:12:54',0,'2014-02-14 21:32:05',NULL,NULL),(20843,3911,'3244585','834','00','005010X220A1','3244585','','2014-02-25','13:32:36',0,'2014-02-25 21:31:25',NULL,NULL),(3744,644,'394667','834','00','005010X220A1','394667','','2013-12-12','15:05:17',0,'2013-12-25 22:09:00',NULL,NULL),(21344,4022,'2961436','834','00','005010X220A1','2961436','','2014-02-27','12:18:19',0,'2014-02-28 06:30:09',NULL,NULL),(20628,3872,'3550951','834','00','005010X220A1','3550951','','2014-02-20','22:53:37',0,'2014-02-21 22:00:37',NULL,NULL),(3796,659,'683565','834','00','005010X220A1','683565','','2013-12-07','21:32:12',0,'2013-12-25 22:16:09',NULL,NULL),(6440,1205,'83014','834','00','005010X220A1','83014','','2013-11-21','22:15:05',0,'2013-12-26 03:15:43',NULL,NULL),(17766,3263,'2370737','834','00','005010X220A1','2370737','','2014-02-03','19:30:07',0,'2014-02-04 21:01:10',NULL,NULL),(14266,2375,'1866085','834','00','005010X220A1','1866085','','2014-01-10','11:22:46',0,'2014-01-13 03:00:08',NULL,NULL),(16549,3024,'1609399','834','00','005010X220A1','1609399','','2014-01-23','21:39:30',0,'2014-01-24 21:01:12',NULL,NULL),(16599,3047,'2502710','834','00','005010X220A1','2502710','','2014-01-26','18:02:15',0,'2014-01-26 19:00:02',NULL,NULL),(1547,265,'439111','834','00','005010X220A1','439111','','2013-12-24','12:15:31',0,'2013-12-25 18:58:50',NULL,NULL),(22431,4228,'3484232','834','00','005010X220A1','3484232','','2014-03-04','16:45:36',0,'2014-03-04 21:02:46',NULL,NULL),(22336,4204,'3102037','834','00','005010X220A1','3102037','','2014-03-03','18:44:38',0,'2014-03-04 21:01:27',NULL,NULL),(21713,4088,'2704422','834','00','005010X220A1','2704422','','2014-02-28','10:57:39',0,'2014-02-28 21:30:24',NULL,NULL),(20349,3809,'3365485','834','00','005010X220A1','3365485','','2014-02-19','13:33:15',0,'2014-02-20 04:54:34',NULL,NULL),(20256,3793,'2608503','834','00','005010X220A1','2608503','','2014-02-19','17:35:56',0,'2014-02-20 04:33:21',NULL,NULL),(20211,3782,'2579223','834','00','005010X220A1','2579223','','2014-02-19','12:20:31',0,'2014-02-20 04:20:37',NULL,NULL),(13299,2143,'0001','999','BE','005010X231A1','3727','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:09',NULL,NULL),(19746,3673,'3510076','834','00','005010X220A1','3510076','','2014-02-14','20:13:34',0,'2014-02-15 22:00:40',NULL,NULL),(19200,3573,'2590933','834','00','005010X220A1','2590933','','2014-02-13','14:33:36',0,'2014-02-13 21:30:11',NULL,NULL),(5323,999,'786236','834','00','005010X220A1','786236','','2013-11-05','15:43:23',0,'2013-12-26 01:02:18',NULL,NULL),(18753,3485,'3035245','834','00','005010X220A1','3035245','','2014-02-11','15:16:07',0,'2014-02-11 21:00:41',NULL,NULL),(4324,750,'642853','834','00','005010X220A1','642853','','2013-12-19','17:03:59',0,'2013-12-25 23:09:57',NULL,NULL),(17954,3299,'2854772','834','00','005010X220A1','2854772','','2014-02-05','14:51:49',0,'2014-02-05 21:30:57',NULL,NULL),(7626,1308,'393985','834','00','005010X220A1','393985','','2013-12-20','22:52:44',0,'2013-12-26 04:38:06',NULL,NULL),(7685,1326,'1144882','834','00','005010X220A1','1144882','','2013-12-21','15:12:54',0,'2013-12-26 04:39:59',NULL,NULL),(22046,4165,'3098137','834','00','005010X220A1','3098137','','2014-03-03','10:33:56',0,'2014-03-03 21:00:08',NULL,NULL),(22029,4160,'3510492','834','00','005010X220A1','3510492','','2014-03-02','17:09:01',0,'2014-03-03 01:00:41',NULL,NULL),(11095,1424,'1354855','834','00','005010X220A1','1354855','','2013-12-23','13:52:44',0,'2013-12-26 13:13:55',NULL,NULL),(11792,1537,'1728921','834','00','005010X220A1','1728921','','2013-12-28','20:17:25',1,'2013-12-29 11:12:52',NULL,NULL),(20099,3769,'2788970','834','00','005010X220A1','2788970','','2014-02-18','16:09:58',0,'2014-02-18 22:01:45',NULL,NULL),(16747,3067,'1875838','834','00','005010X220A1','1875838','','2014-01-27','12:47:55',0,'2014-01-27 21:01:15',NULL,NULL),(2568,469,'598983','834','00','005010X220A1','598983','','2013-10-03','08:48:13',0,'2013-12-25 20:32:11',NULL,NULL),(21555,4049,'3597941','834','00','005010X220A1','3597941','','2014-02-27','14:27:53',0,'2014-02-28 06:31:47',NULL,NULL),(20153,3777,'2950209','834','00','005010X220A1','2950209','','2014-02-18','18:09:03',0,'2014-02-20 04:04:47',NULL,NULL),(5607,1044,'1581398','834','00','005010X220A1','1581398','','2013-12-24','20:57:39',0,'2013-12-26 01:49:52',NULL,NULL),(19184,3569,'2721081','834','00','005010X220A1','2721081','','2014-02-13','09:29:16',0,'2014-02-13 21:30:04',NULL,NULL),(17673,3259,'2693572','834','00','005010X220A1','2693572','','2014-02-03','22:19:45',0,'2014-02-04 21:00:13',NULL,NULL),(16581,3038,'2234894','834','00','005010X220A1','2234894','','2014-01-24','23:06:12',0,'2014-01-25 19:00:12',NULL,NULL),(10719,1403,'1678585','834','00','005010X220A1','1678585','','2013-12-23','13:24:52',0,'2013-12-26 13:01:11',NULL,NULL),(13920,2314,'1686214','834','00','005010X220A1','1686214','','2014-01-08','18:30:44',0,'2014-01-13 02:19:57',NULL,NULL),(5954,1115,'246446','834','00','005010X220A1','246446','','2013-12-14','20:18:27',0,'2013-12-26 02:32:26',NULL,NULL),(5288,979,'393191','834','00','005010X220A1','393191','','2013-11-16','14:51:27',0,'2013-12-26 01:01:00',NULL,NULL);
INSERT INTO `EdiTransaction` VALUES (21386,4024,'2761652','834','00','005010X220A1','2761652','','2014-02-27','15:03:53',0,'2014-02-28 06:30:29',NULL,NULL),(20421,3836,'3472525','834','00','005010X220A1','3472525','','2014-02-20','16:08:20',0,'2014-02-20 21:30:20',NULL,NULL),(20176,3778,'2209833','834','00','005010X220A1','2209833','','2014-02-19','14:41:41',0,'2014-02-20 04:11:23',NULL,NULL),(2111,360,'543352','834','00','005010X220A1','543352','','2013-12-01','20:39:17',0,'2013-12-25 19:45:16',NULL,NULL),(4095,733,'1254512','834','00','005010X220A1','1254512','','2013-12-19','10:49:06',0,'2013-12-25 23:03:07',NULL,NULL),(21570,4054,'2612367','834','00','005010X220A1','2612367','','2014-02-26','15:56:48',0,'2014-02-28 07:00:12',NULL,NULL),(153,10,'987663','834','00','005010X220A1','987663','','2013-12-05','16:26:34',0,'2013-12-25 17:19:45',NULL,NULL),(20152,3775,'3602983','834','00','005010X220A1','3602983','','2014-02-19','16:00:55',0,'2014-02-20 04:04:16',NULL,NULL),(12234,1618,'1885185','834','00','005010X220A1','1885185','','2013-12-31','20:04:01',1,'2014-01-02 04:22:47',NULL,NULL),(13805,2295,'1413844','834','00','005010X220A1','1413844','','2014-01-10','18:34:09',0,'2014-01-13 02:18:18',NULL,NULL),(1177,239,'1527410','834','00','005010X220A1','1527410','','2013-12-24','14:21:50',0,'2013-12-25 18:47:03',NULL,NULL),(22910,4286,'3684587','834','00','005010X220A1','3684587','','2014-03-06','11:36:25',0,'2014-03-06 21:02:23',NULL,NULL),(77,4,'473863','834','00','005010X220A1','473863','','2013-12-04','18:54:53',0,'2013-12-25 17:17:20',NULL,NULL),(20065,3755,'2705350','834','00','005010X220A1','2705350','','2014-02-18','10:00:46',0,'2014-02-18 22:01:20',NULL,NULL),(19781,3675,'3517470','834','00','005010X220A1','3517470','','2014-02-14','20:03:46',0,'2014-02-15 22:01:06',NULL,NULL),(18830,3490,'3228312','834','00','005010X220A1','3228312','','2014-02-11','12:25:46',0,'2014-02-11 21:01:37',NULL,NULL),(17922,3296,'1617524','834','00','005010X220A1','1617524','','2014-02-05','11:51:19',0,'2014-02-05 21:30:41',NULL,NULL),(11669,1504,'820453','834','00','005010X220A1','820453','','2013-12-27','10:43:13',0,'2013-12-28 03:36:53',NULL,NULL),(16962,3116,'1894263','834','00','005010X220A1','1894263','','2014-01-29','10:48:28',0,'2014-01-29 21:00:31',NULL,NULL),(16926,3114,'1532461','834','00','005010X220A1','1532461','','2014-01-29','16:48:59',0,'2014-01-29 21:00:08',NULL,NULL),(15728,2711,'2015928','834','00','005010X220A1','2015928','','2014-01-20','12:55:10',0,'2014-01-21 08:46:05',NULL,NULL),(4984,935,'1016144','834','00','005010X220A1','1016144','','2013-12-10','20:38:43',0,'2013-12-26 00:45:27',NULL,NULL),(5741,1070,'236678','834','00','005010X220A1','236678','','2013-12-14','10:43:00',0,'2013-12-26 02:01:39',NULL,NULL),(7084,1236,'367485','834','00','005010X220A1','367485','','2013-12-18','10:29:47',0,'2013-12-26 04:03:09',NULL,NULL),(13902,2313,'2049623','834','00','005010X220A1','2049623','','2014-01-09','10:55:42',0,'2014-01-13 02:19:46',NULL,NULL),(21162,3997,'3024439','834','00','005010X220A1','3024439','','2014-02-26','16:17:55',0,'2014-02-26 21:00:51',NULL,NULL),(22606,4250,'3053382','834','00','005010X220A1','3053382','','2014-03-05','13:24:02',0,'2014-03-05 21:31:22',NULL,NULL),(13728,2275,'2022764','834','00','005010X220A1','2022764','','2014-01-06','22:36:02',0,'2014-01-08 18:24:41',NULL,NULL),(13464,2226,'1344918','834','00','005010X220A1','1344918','','2014-01-06','15:51:50',0,'2014-01-07 04:03:18',NULL,NULL),(18559,3453,'2714577','834','00','005010X220A1','2714577','','2014-02-09','20:02:52',0,'2014-02-10 21:30:35',NULL,NULL),(18377,3406,'2626399','834','00','005010X220A1','2626399','','2014-02-09','16:44:27',0,'2014-02-09 19:00:19',NULL,NULL),(10959,1410,'1099051','834','00','005010X220A1','1099051','','2013-12-23','18:23:00',0,'2013-12-26 13:09:26',NULL,NULL),(15754,2714,'1393796','834','00','005010X220A1','1393796','','2014-01-19','21:16:06',0,'2014-01-21 08:46:20',NULL,NULL),(7743,1344,'1239671','834','00','005010X220A1','1239671','','2013-10-20','17:36:46',0,'2013-12-26 05:00:38',NULL,NULL),(14238,2372,'2080210','834','00','005010X220A1','2080210','','2014-01-09','20:13:14',0,'2014-01-13 02:24:09',NULL,NULL),(7664,1317,'141313','834','00','005010X220A1','141313','','2013-12-21','08:55:40',0,'2013-12-26 04:39:17',NULL,NULL),(4214,738,'753011','834','00','005010X220A1','753011','','2013-12-18','19:42:23',0,'2013-12-25 23:06:38',NULL,NULL),(5648,1049,'1463101','834','00','005010X220A1','1463101','','2013-12-24','23:46:57',0,'2013-12-26 01:51:14',NULL,NULL),(6084,1166,'875051','834','00','005010X220A1','875051','','2013-12-19','19:35:29',0,'2013-12-26 03:00:50',NULL,NULL),(21213,3998,'3491040','834','00','005010X220A1','3491040','','2014-02-26','16:32:17',0,'2014-02-26 21:01:25',NULL,NULL),(21915,4127,'3651680','834','00','005010X220A1','3651680','','2014-03-01','14:37:07',0,'2014-03-01 21:00:39',NULL,NULL),(1203,241,'1103111','834','00','005010X220A1','1103111','','2013-12-24','11:15:23',0,'2013-12-25 18:47:52',NULL,NULL),(12337,1634,'1553808','834','00','005010X220A1','1553808','','2013-12-31','11:32:24',1,'2014-01-02 04:27:28',NULL,NULL),(5500,1041,'1599725','834','00','005010X220A1','1599725','','2013-12-24','19:33:43',0,'2013-12-26 01:46:25',NULL,NULL),(2565,466,'66992','834','00','005010X220A1','66992','','2013-11-18','11:51:10',0,'2013-12-25 20:32:04',NULL,NULL),(17021,3120,'2154636','834','00','005010X220A1','2154636','','2014-01-29','05:05:48',0,'2014-01-29 21:01:07',NULL,NULL),(16803,3089,'1631370','834','00','005010X220A1','1631370','','2014-01-28','02:48:57',0,'2014-01-28 21:00:10',NULL,NULL),(16740,3065,'1808631','834','00','005010X220A1','1808631','','2014-01-27','16:07:39',0,'2014-01-27 21:01:10',NULL,NULL),(13960,2322,'1849346','834','00','005010X220A1','1849346','','2014-01-08','22:59:38',0,'2014-01-13 02:20:27',NULL,NULL),(14650,2530,'2500159','834','00','005010X220A1','2500159','','2014-01-13','14:25:15',0,'2014-01-14 01:33:38',NULL,NULL),(21833,4100,'2757848','834','00','005010X220A1','2757848','','2014-02-28','09:15:34',0,'2014-02-28 21:31:45',NULL,NULL),(11631,1497,'1742647','834','00','005010X220A1','1742647','','2013-12-27','09:48:26',0,'2013-12-28 03:35:41',NULL,NULL),(20639,3874,'3073530','834','00','005010X220A1','3073530','','2014-02-21','12:21:41',0,'2014-02-21 22:00:44',NULL,NULL),(7600,1303,'141306','834','00','005010X220A1','141306','','2013-12-21','00:07:34',0,'2013-12-26 04:37:17',NULL,NULL),(4733,847,'1718041','834','00','005010X220A1','1718041','','2013-12-23','23:09:40',0,'2013-12-25 23:51:52',NULL,NULL),(5315,993,'1161541','834','00','005010X220A1','1161541','','2013-11-04','23:52:57',0,'2013-12-26 01:02:00',NULL,NULL),(714,118,'926047','834','00','005010X220A1','926047','','2013-12-16','08:45:42',0,'2013-12-25 18:07:13',NULL,NULL),(20471,3842,'2524781','834','00','005010X220A1','2524781','','2014-02-20','14:49:04',0,'2014-02-20 22:00:39',NULL,NULL),(19754,3673,'2703100','834','00','005010X220A1','2703100','','2014-02-15','15:03:33',0,'2014-02-15 22:00:46',NULL,NULL),(12210,1615,'2116496','834','00','005010X220A1','2116496','','2013-12-31','21:25:59',1,'2014-01-02 04:21:52',NULL,NULL),(3126,550,'841528','834','00','005010X220A1','841528','','2013-12-12','18:58:13',0,'2013-12-25 21:37:00',NULL,NULL),(2016,331,'1181941','834','00','005010X220A1','1181941','','2013-12-09','13:20:00',0,'2013-12-25 19:35:22',NULL,NULL),(14028,2337,'1932380','834','00','005010X220A1','1932380','','2014-01-08','14:23:37',0,'2014-01-13 02:21:24',NULL,NULL),(1959,326,'282355','834','00','005010X220A1','282355','','2013-12-09','13:44:28',0,'2013-12-25 19:33:29',NULL,NULL),(22484,4243,'3154017','834','00','005010X220A1','3154017','','2014-03-05','12:14:34',0,'2014-03-05 21:00:26',NULL,NULL),(22611,4250,'2902746','834','00','005010X220A1','2902746','','2014-03-05','16:48:14',0,'2014-03-05 21:31:26',NULL,NULL),(446,81,'866216','834','00','005010X220A1','866216','','2013-12-03','23:26:26',0,'2013-12-25 17:49:50',NULL,NULL),(3601,617,'430497','834','00','005010X220A1','430497','','2013-12-12','18:25:59',0,'2013-12-25 22:04:21',NULL,NULL),(2297,397,'710518','834','00','005010X220A1','710518','','2013-11-24','15:59:48',0,'2013-12-25 20:01:04',NULL,NULL),(16555,3028,'1595803','834','00','005010X220A1','1595803','','2014-01-24','10:03:00',0,'2014-01-24 21:01:16',NULL,NULL),(4448,801,'1297220','834','00','005010X220A1','1297220','','2013-11-25','20:36:32',0,'2013-12-25 23:30:22',NULL,NULL),(3225,578,'384659','834','00','005010X220A1','384659','','2013-12-17','11:19:24',0,'2013-12-25 21:46:05',NULL,NULL),(5615,1044,'1945837','834','00','005010X220A1','1945837','','2013-12-24','23:14:14',0,'2013-12-26 01:50:10',NULL,NULL),(7384,1293,'186336','834','00','005010X220A1','186336','','2013-12-21','11:17:58',0,'2013-12-26 04:30:17',NULL,NULL),(1375,245,'1710143','834','00','005010X220A1','1710143','','2013-12-24','15:51:42',0,'2013-12-25 18:53:12',NULL,NULL),(18754,3485,'2894214','834','00','005010X220A1','2894214','','2014-02-11','15:20:16',0,'2014-02-11 21:00:41',NULL,NULL),(21764,4090,'3308999','834','00','005010X220A1','3308999','','2014-02-28','14:28:59',0,'2014-02-28 21:30:56',NULL,NULL),(22402,4214,'3516730','834','00','005010X220A1','3516730','','2014-03-04','11:51:43',0,'2014-03-04 21:02:22',NULL,NULL),(13409,2222,'1890020','834','00','005010X220A1','1890020','','2014-01-05','19:41:23',0,'2014-01-07 04:01:12',NULL,NULL),(20523,3849,'2944082','834','00','005010X220A1','2944082','','2014-02-20','13:00:02',0,'2014-02-20 22:01:22',NULL,NULL),(20326,3797,'3143562','834','00','005010X220A1','3143562','','2014-02-18','22:45:14',0,'2014-02-20 04:49:23',NULL,NULL),(2747,503,'89032','834','00','005010X220A1','89032','','2013-12-22','17:56:51',0,'2013-12-25 21:18:38',NULL,NULL),(14822,2552,'1622284','834','00','005010X220A1','1622284','','2014-01-14','16:39:31',0,'2014-01-15 02:06:54',NULL,NULL),(1683,291,'1044058','834','00','005010X220A1','1044058','','2013-12-09','19:48:06',0,'2013-12-25 19:15:56',NULL,NULL),(3522,615,'1307862','834','00','005010X220A1','1307862','','2013-12-12','18:11:28',0,'2013-12-25 22:01:52',NULL,NULL),(7052,1235,'782829','834','00','005010X220A1','782829','','2013-12-18','18:06:23',0,'2013-12-26 04:02:06',NULL,NULL),(685,109,'1244495','834','00','005010X220A1','1244495','','2013-12-16','15:29:45',0,'2013-12-25 18:06:15',NULL,NULL),(4879,889,'88221','834','00','005010X220A1','88221','','2013-11-21','15:59:23',0,'2013-12-26 00:16:35',NULL,NULL),(4510,811,'651245','834','00','005010X220A1','651245','','2013-11-26','12:52:50',0,'2013-12-25 23:32:23',NULL,NULL),(21719,4088,'3750034','834','00','005010X220A1','3750034','','2014-02-28','12:26:39',0,'2014-02-28 21:30:26',NULL,NULL),(2340,413,'1393','834','00','005010X220A1','1393','','2013-12-05','19:11:49',0,'2013-12-25 20:15:23',NULL,NULL),(19806,3678,'2140249','834','00','005010X220A1','2140249','','2014-02-14','23:17:06',0,'2014-02-15 22:01:28',NULL,NULL),(17226,3156,'2191861','834','00','005010X220A1','2191861','','2014-01-30','13:16:06',0,'2014-01-30 21:01:26',NULL,NULL),(12717,1678,'1974577','834','00','005010X220A1','1974577','','2014-01-02','09:45:40',0,'2014-01-03 02:05:24',NULL,NULL),(11812,1539,'1756424','834','00','005010X220A1','1756424','','2013-12-28','20:18:08',1,'2013-12-29 11:13:26',NULL,NULL),(5464,1040,'1248509','834','00','005010X220A1','1248509','','2013-12-24','20:29:51',0,'2013-12-26 01:45:17',NULL,NULL),(3485,615,'936631','834','00','005010X220A1','936631','','2013-12-12','10:29:21',0,'2013-12-25 22:00:42',NULL,NULL),(2691,502,'1484590','834','00','005010X220A1','1484590','','2013-12-22','12:27:56',0,'2013-12-25 21:16:54',NULL,NULL),(4048,731,'11959','834','00','005010X220A1','11959','','2013-12-19','17:39:55',0,'2013-12-25 23:01:37',NULL,NULL),(4667,831,'1469277','834','00','005010X220A1','1469277','','2013-12-23','22:38:08',0,'2013-12-25 23:49:27',NULL,NULL),(20705,3893,'3315931','834','00','005010X220A1','3315931','','2014-02-25','11:11:43',0,'2014-02-25 21:00:15',NULL,NULL),(17911,3296,'1531289','834','00','005010X220A1','1531289','','2014-02-04','20:14:02',0,'2014-02-05 21:30:36',NULL,NULL),(16845,3092,'1802743','834','00','005010X220A1','1802743','','2014-01-28','10:59:20',0,'2014-01-28 21:00:36',NULL,NULL),(2045,334,'632508','834','00','005010X220A1','632508','','2013-12-08','23:53:24',0,'2013-12-25 19:36:15',NULL,NULL),(13876,2312,'1983169','834','00','005010X220A1','1983169','','2014-01-08','18:40:42',0,'2014-01-13 02:19:29',NULL,NULL),(21615,4065,'3083661','834','00','005010X220A1','3083661','','2014-02-27','11:25:50',0,'2014-02-28 07:30:16',NULL,NULL),(23507,4434,'2644261','834','00','005010X220A1','2644261','','2014-03-10','12:09:43',0,'2014-03-10 21:00:08',NULL,NULL),(829,172,'899087','834','00','005010X220A1','899087','','2013-10-16','21:26:35',0,'2013-12-25 18:11:18',NULL,NULL),(21503,4030,'3313963','834','00','005010X220A1','3313963','','2014-02-27','14:09:08',0,'2014-02-28 06:31:23',NULL,NULL),(20701,3892,'3020927','834','00','005010X220A1','3020927','','2014-02-25','15:09:33',0,'2014-02-25 21:00:12',NULL,NULL),(3437,600,'724058','834','00','005010X220A1','724058','','2013-12-17','15:38:38',0,'2013-12-25 21:52:53',NULL,NULL),(17547,3235,'1697385','834','00','005010X220A1','1697385','','2014-02-03','17:59:00',0,'2014-02-03 21:00:24',NULL,NULL),(4455,801,'586172','834','00','005010X220A1','586172','','2013-11-26','08:16:51',0,'2013-12-25 23:30:35',NULL,NULL),(2098,355,'669417','834','00','005010X220A1','669417','','2013-12-09','16:53:58',0,'2013-12-25 19:37:59',NULL,NULL),(1300,244,'692483','834','00','005010X220A1','692483','','2013-12-24','15:31:33',0,'2013-12-25 18:50:47',NULL,NULL),(6233,1168,'875093','834','00','005010X220A1','875093','','2013-12-20','17:29:30',0,'2013-12-26 03:05:22',NULL,NULL),(21821,4096,'3283093','834','00','005010X220A1','3283093','','2014-02-28','09:31:29',0,'2014-02-28 21:31:35',NULL,NULL),(10575,1402,'840596','834','00','005010X220A1','840596','','2013-12-23','11:15:14',0,'2013-12-26 12:56:22',NULL,NULL),(21208,3998,'3609377','834','00','005010X220A1','3609377','','2014-02-26','15:51:26',0,'2014-02-26 21:01:21',NULL,NULL),(1019,191,'61865','834','00','005010X220A1','61865','','2013-12-03','16:20:28',0,'2013-12-25 18:20:51',NULL,NULL),(21122,3994,'3543549','834','00','005010X220A1','3543549','','2014-02-26','15:31:19',0,'2014-02-26 21:00:24',NULL,NULL),(13044,1888,'0001','999','BE','005010X231A1','687572','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:04',NULL,NULL),(2621,489,'585142','834','00','005010X220A1','585142','','2013-11-28','17:43:05',0,'2013-12-25 20:46:37',NULL,NULL),(5326,1002,'1166929','834','00','005010X220A1','1166929','','2013-11-25','11:16:44',0,'2013-12-26 01:15:03',NULL,NULL),(5330,1002,'1239','834','00','005010X220A1','1239','','2013-11-25','13:40:30',0,'2013-12-26 01:15:10',NULL,NULL),(14762,2551,'1500062','834','00','005010X220A1','1500062','','2014-01-14','00:21:09',0,'2014-01-15 02:06:29',NULL,NULL),(2557,462,'453405','834','00','005010X220A1','453405','','2013-11-18','11:46:47',0,'2013-12-25 20:31:48',NULL,NULL),(10748,1403,'1103024','834','00','005010X220A1','1103024','','2013-12-23','17:17:43',0,'2013-12-26 13:02:08',NULL,NULL),(7500,1300,'65368','834','00','005010X220A1','65368','','2013-12-20','22:20:29',0,'2013-12-26 04:34:03',NULL,NULL),(22196,4184,'2931403','834','00','005010X220A1','2931403','','2014-03-02','18:49:08',0,'2014-03-03 21:31:28',NULL,NULL),(11691,1517,'2031359','834','00','005010X220A1','2031359','','2013-12-28','14:47:26',1,'2013-12-29 11:07:38',NULL,NULL),(2189,363,'1306087','834','00','005010X220A1','1306087','','2013-12-02','16:09:45',0,'2013-12-25 19:47:46',NULL,NULL),(4079,733,'7813','834','00','005010X220A1','7813','','2013-12-19','08:08:44',0,'2013-12-25 23:02:39',NULL,NULL),(19580,3629,'2762555','834','00','005010X220A1','2762555','','2014-02-13','22:27:23',0,'2014-02-14 21:31:23',NULL,NULL),(17521,3235,'1916381','834','00','005010X220A1','1916381','','2014-02-02','18:51:15',0,'2014-02-03 21:00:09',NULL,NULL),(4483,802,'425872','834','00','005010X220A1','425872','','2013-11-26','13:11:48',0,'2013-12-25 23:31:29',NULL,NULL),(16686,3062,'1423111','834','00','005010X220A1','1423111','','2014-01-27','12:57:37',0,'2014-01-27 21:00:34',NULL,NULL),(16354,2983,'2386761','834','00','005010X220A1','2386761','','2014-01-23','15:38:36',0,'2014-01-23 21:00:51',NULL,NULL),(5955,1116,'604991','834','00','005010X220A1','604991','','2013-12-14','20:18:46',0,'2013-12-26 02:32:29',NULL,NULL),(14316,2395,'2225231','834','00','005010X220A1','2225231','','2014-01-10','15:34:48',0,'2014-01-13 03:00:41',NULL,NULL),(12849,1705,'2466813','834','00','005010X220A1','2466813','','2014-01-03','16:58:33',0,'2014-01-04 02:03:01',NULL,NULL),(355,72,'457321','834','00','005010X220A1','457321','','2013-12-04','16:37:34',0,'2013-12-25 17:46:56',NULL,NULL),(6296,1173,'1172626','834','00','005010X220A1','1172626','','2013-12-19','19:29:21',0,'2013-12-26 03:07:19',NULL,NULL),(13453,2224,'2518622','834','00','005010X220A1','2518622','','2014-01-06','11:27:05',0,'2014-01-07 04:02:53',NULL,NULL),(21839,4105,'3463065','834','00','005010X220A1','3463065','','2014-02-28','13:33:41',0,'2014-02-28 21:31:51',NULL,NULL),(21705,4087,'3266789','834','00','005010X220A1','3266789','','2014-02-28','16:05:19',0,'2014-02-28 21:30:17',NULL,NULL),(12363,1634,'2198640','834','00','005010X220A1','2198640','','2013-12-31','15:18:17',1,'2014-01-02 04:28:19',NULL,NULL),(11540,1491,'1420940','834','00','005010X220A1','1420940','','2013-12-27','13:41:55',0,'2013-12-28 03:32:50',NULL,NULL),(6227,1168,'909850','834','00','005010X220A1','909850','','2013-12-20','16:09:05',0,'2013-12-26 03:05:11',NULL,NULL),(16112,2804,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:32:00',1,'2014-01-23 03:44:00',NULL,NULL),(14078,2341,'1485226','834','00','005010X220A1','1485226','','2014-01-07','21:57:00',0,'2014-01-13 02:21:56',NULL,NULL),(2942,541,'306591','834','00','005010X220A1','306591','','2013-12-13','08:41:34',0,'2013-12-25 21:31:19',NULL,NULL),(22072,4172,'2903776','834','00','005010X220A1','2903776','','2014-03-03','12:07:46',0,'2014-03-03 21:00:25',NULL,NULL),(22408,4215,'2692853','834','00','005010X220A1','2692853','','2014-03-04','12:47:11',0,'2014-03-04 21:02:27',NULL,NULL),(23134,4342,'3446633','834','00','005010X220A1','3446633','','2014-03-07','12:47:51',0,'2014-03-07 21:30:59',NULL,NULL),(837,174,'611625','834','00','005010X220A1','611625','','2013-12-02','20:36:07',0,'2013-12-25 18:15:15',NULL,NULL),(13133,1977,'0001','999','BE','005010X231A1','897194','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:11',NULL,NULL),(21818,4095,'2797955','834','00','005010X220A1','2797955','','2014-02-27','19:02:46',0,'2014-02-28 21:31:33',NULL,NULL),(12406,1637,'1308717','834','00','005010X220A1','1308717','','2013-12-31','14:37:02',1,'2014-01-02 04:29:50',NULL,NULL),(19563,3626,'3025241','834','00','005010X220A1','3025241','','2014-02-14','16:21:15',0,'2014-02-14 21:31:12',NULL,NULL),(11556,1492,'357175','834','00','005010X220A1','357175','','2013-12-27','08:39:26',0,'2013-12-28 03:33:21',NULL,NULL),(13881,2312,'2061991','834','00','005010X220A1','2061991','','2014-01-09','14:22:23',0,'2014-01-13 02:19:33',NULL,NULL),(2975,541,'709667','834','00','005010X220A1','709667','','2013-12-13','15:44:00',0,'2013-12-25 21:32:23',NULL,NULL),(7448,1296,'608994','834','00','005010X220A1','608994','','2013-12-20','20:46:11',0,'2013-12-26 04:32:22',NULL,NULL),(7288,1255,'329211','834','00','005010X220A1','329211','','2013-12-18','17:50:19',0,'2013-12-26 04:09:20',NULL,NULL),(4267,742,'332994','834','00','005010X220A1','332994','','2013-12-19','15:55:41',0,'2013-12-25 23:08:19',NULL,NULL),(4781,862,'1183072','834','00','005010X220A1','1183072','','2013-11-30','20:54:30',0,'2013-12-26 00:01:18',NULL,NULL),(11006,1414,'1006011','834','00','005010X220A1','1006011','','2013-12-22','19:55:58',0,'2013-12-26 13:10:59',NULL,NULL),(317,70,'722151','834','00','005010X220A1','722151','','2013-12-04','11:46:33',0,'2013-12-25 17:45:44',NULL,NULL),(21281,4004,'2635502','834','00','005010X220A1','2635502','','2014-02-26','12:33:05',0,'2014-02-26 21:02:11',NULL,NULL),(19015,3539,'3250369','834','00','005010X220A1','3250369','','2014-02-12','15:11:42',0,'2014-02-12 21:30:36',NULL,NULL),(15796,2722,'2234770','834','00','005010X220A1','2234770','','2014-01-20','10:18:34',0,'2014-01-21 08:46:46',NULL,NULL),(14887,2558,'1639680','834','00','005010X220A1','1639680','','2014-01-14','09:46:52',0,'2014-01-15 02:07:25',NULL,NULL),(7525,1300,'125503','834','00','005010X220A1','125503','','2013-12-21','13:14:33',0,'2013-12-26 04:34:50',NULL,NULL),(6180,1167,'1084894','834','00','005010X220A1','1084894','','2013-12-20','16:27:14',0,'2013-12-26 03:03:42',NULL,NULL),(12935,1727,'1405744','834','00','005010X220A1','1405744','','2014-01-03','16:23:33',0,'2014-01-04 02:06:17',NULL,NULL),(2057,336,'371643','834','00','005010X220A1','371643','','2013-12-09','16:18:52',0,'2013-12-25 19:36:39',NULL,NULL),(12063,1586,'1966615','834','00','005010X220A1','1966615','','2013-12-29','21:14:00',0,'2014-01-01 12:04:27',NULL,NULL),(4184,734,'337142','834','00','005010X220A1','337142','','2013-12-19','14:41:15',0,'2013-12-25 23:05:44',NULL,NULL),(23629,4441,'3407787','834','00','005010X220A1','3407787','','2014-03-10','12:06:15',0,'2014-03-10 21:01:36',NULL,NULL),(639,108,'738770','834','00','005010X220A1','738770','','2013-12-16','12:43:31',0,'2013-12-25 18:04:51',NULL,NULL),(4077,733,'516523','834','00','005010X220A1','516523','','2013-12-18','21:48:36',0,'2013-12-25 23:02:35',NULL,NULL),(7089,1236,'511474','834','00','005010X220A1','511474','','2013-12-18','10:51:02',0,'2013-12-26 04:03:17',NULL,NULL),(21236,3999,'2632031','834','00','005010X220A1','2632031','','2014-02-26','12:02:41',0,'2014-02-26 21:01:39',NULL,NULL),(10683,1403,'618296','834','00','005010X220A1','618296','','2013-12-22','22:57:59',0,'2013-12-26 12:59:54',NULL,NULL),(10780,1404,'121714','834','00','005010X220A1','121714','','2013-12-23','10:12:58',0,'2013-12-26 13:03:14',NULL,NULL),(19876,3709,'2402617','834','00','005010X220A1','2402617','','2014-02-16','00:30:46',0,'2014-02-16 19:00:21',NULL,NULL),(19823,3679,'3220425','834','00','005010X220A1','3220425','','2014-02-15','15:43:18',0,'2014-02-15 22:01:41',NULL,NULL),(10821,1404,'1450610','834','00','005010X220A1','1450610','','2013-12-23','16:53:22',0,'2013-12-26 13:04:34',NULL,NULL),(16582,3039,'1812870','834','00','005010X220A1','1812870','','2014-01-25','06:04:07',0,'2014-01-25 19:00:13',NULL,NULL),(4144,733,'763824','834','00','005010X220A1','763824','','2013-12-19','16:38:43',0,'2013-12-25 23:04:30',NULL,NULL),(22219,4188,'2584610','834','00','005010X220A1','2584610','','2014-03-03','15:31:40',0,'2014-03-03 21:31:45',NULL,NULL),(21425,4026,'3717356','834','00','005010X220A1','3717356','','2014-02-27','16:24:50',0,'2014-02-28 06:30:46',NULL,NULL),(4121,733,'1088375','834','00','005010X220A1','1088375','','2013-12-19','13:52:13',0,'2013-12-25 23:03:51',NULL,NULL),(17853,3292,'2685783','834','00','005010X220A1','2685783','','2014-02-04','18:44:25',0,'2014-02-05 21:30:07',NULL,NULL),(3929,713,'1172149','834','00','005010X220A1','1172149','','2013-12-07','15:49:41',0,'2013-12-25 22:45:55',NULL,NULL),(6168,1167,'1168984','834','00','005010X220A1','1168984','','2013-12-20','14:43:42',0,'2013-12-26 03:03:22',NULL,NULL),(6249,1172,'381293','834','00','005010X220A1','381293','','2013-12-19','19:28:20',0,'2013-12-26 03:05:54',NULL,NULL),(17634,3244,'1962159','834','00','005010X220A1','1962159','','2014-02-03','13:57:19',0,'2014-02-03 21:01:18',NULL,NULL),(16726,3064,'2513783','834','00','005010X220A1','2513783','','2014-01-27','17:34:55',0,'2014-01-27 21:01:01',NULL,NULL),(3280,583,'930092','834','00','005010X220A1','930092','','2013-12-17','07:48:46',0,'2013-12-25 21:47:49',NULL,NULL),(7289,1256,'378797','834','00','005010X220A1','378797','','2013-12-18','10:03:52',0,'2013-12-26 04:09:22',NULL,NULL),(3039,544,'638856','834','00','005010X220A1','638856','','2013-12-13','10:51:54',0,'2013-12-25 21:34:17',NULL,NULL),(13945,2318,'1827974','834','00','005010X220A1','1827974','','2014-01-09','11:48:47',0,'2014-01-13 02:20:17',NULL,NULL),(689,109,'338419','834','00','005010X220A1','338419','','2013-12-16','18:22:33',0,'2013-12-25 18:06:23',NULL,NULL),(592,106,'1249394','834','00','005010X220A1','1249394','','2013-12-15','18:53:20',0,'2013-12-25 18:03:20',NULL,NULL),(20722,3897,'3548272','834','00','005010X220A1','3548272','','2014-02-25','15:37:21',0,'2014-02-25 21:00:27',NULL,NULL),(20593,3870,'2731154','834','00','005010X220A1','2731154','','2014-02-21','11:26:30',0,'2014-02-21 22:00:09',NULL,NULL),(20168,3778,'2905872','834','00','005010X220A1','2905872','','2014-02-19','10:44:24',0,'2014-02-20 04:09:04',NULL,NULL),(1938,326,'447200','834','00','005010X220A1','447200','','2013-12-09','10:17:14',0,'2013-12-25 19:32:52',NULL,NULL),(12269,1623,'1514692','834','00','005010X220A1','1514692','','2014-01-01','10:40:54',1,'2014-01-02 04:24:12',NULL,NULL),(375,74,'1222462','834','00','005010X220A1','1222462','','2013-12-04','05:17:48',0,'2013-12-25 17:47:34',NULL,NULL),(16636,3059,'2151086','834','00','005010X220A1','2151086','','2014-01-26','15:21:13',0,'2014-01-26 19:00:30',NULL,NULL),(10820,1404,'541518','834','00','005010X220A1','541518','','2013-12-23','16:47:34',0,'2013-12-26 13:04:31',NULL,NULL),(16403,2994,'2547984','834','00','005010X220A1','2547984','','2014-01-23','16:01:28',0,'2014-01-23 21:01:24',NULL,NULL),(7547,1300,'1052534','834','00','005010X220A1','1052534','','2013-12-21','18:02:51',0,'2013-12-26 04:35:31',NULL,NULL),(5811,1083,'960731','834','00','005010X220A1','960731','','2013-12-14','13:55:55',0,'2013-12-26 02:03:55',NULL,NULL),(21358,4024,'2899517','834','00','005010X220A1','2899517','','2014-02-26','19:04:09',0,'2014-02-28 06:30:15',NULL,NULL),(22451,4232,'3402259','834','00','005010X220A1','3402259','','2014-03-04','11:13:23',0,'2014-03-04 21:30:16',NULL,NULL),(22908,4286,'3175519','834','00','005010X220A1','3175519','','2014-03-06','10:17:26',0,'2014-03-06 21:02:22',NULL,NULL),(1930,326,'611756','834','00','005010X220A1','611756','','2013-12-09','08:34:40',0,'2013-12-25 19:32:37',NULL,NULL),(13210,2054,'0001','999','BE','005010X231A1','461070','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:20',NULL,NULL),(18264,3376,'2835868','834','00','005010X220A1','2835868','','2014-02-08','13:48:23',0,'2014-02-08 19:00:11',NULL,NULL),(18161,3350,'2087588','834','00','005010X220A1','2087588','','2014-02-06','20:36:39',0,'2014-02-07 19:00:08',NULL,NULL),(13126,1970,'0001','999','BE','005010X231A1','41239','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:50',NULL,NULL),(12250,1620,'1781897','834','00','005010X220A1','1781897','','2013-12-31','19:49:18',1,'2014-01-02 04:23:25',NULL,NULL),(7112,1236,'176537','834','00','005010X220A1','176537','','2013-12-18','14:26:30',0,'2013-12-26 04:03:56',NULL,NULL),(12214,1615,'1690897','834','00','005010X220A1','1690897','','2014-01-01','13:38:42',1,'2014-01-02 04:22:00',NULL,NULL),(5250,964,'907190','834','00','005010X220A1','907190','','2013-12-11','12:20:49',0,'2013-12-26 00:54:00',NULL,NULL),(11992,1580,'1855993','834','00','005010X220A1','1855993','','2013-12-30','18:15:00',0,'2014-01-01 12:01:46',NULL,NULL),(21302,4008,'2619432','834','00','005010X220A1','2619432','','2014-02-26','14:24:42',0,'2014-02-26 21:02:26',NULL,NULL),(23277,4380,'3069254','834','00','005010X220A1','3069254','','2014-03-07','22:10:21',0,'2014-03-08 21:30:02',NULL,NULL),(14120,2348,'1421228','834','00','005010X220A1','1421228','','2014-01-08','12:00:43',0,'2014-01-13 02:22:23',NULL,NULL),(10772,1404,'205457','834','00','005010X220A1','205457','','2013-12-23','00:07:20',0,'2013-12-26 13:02:59',NULL,NULL),(12047,1584,'2444975','834','00','005010X220A1','2444975','','2013-12-30','18:14:53',0,'2014-01-01 12:03:51',NULL,NULL),(12201,1610,'1562659','834','00','005010X220A1','1562659','','2013-12-30','14:34:48',0,'2014-01-01 12:09:19',NULL,NULL),(18000,3318,'1877334','834','00','005010X220A1','1877334','','2014-02-06','13:55:03',0,'2014-02-06 21:00:07',NULL,NULL),(3443,603,'636505','834','00','005010X220A1','636505','','2013-12-17','11:32:13',0,'2013-12-25 21:53:05',NULL,NULL),(895,177,'1259935','834','00','005010X220A1','1259935','','2013-12-03','13:37:38',0,'2013-12-25 18:16:58',NULL,NULL),(12741,1687,'1689570','834','00','005010X220A1','1689570','','2014-01-02','14:48:13',0,'2014-01-03 02:06:20',NULL,NULL),(12916,1714,'1872624','834','00','005010X220A1','1872624','','2014-01-03','15:53:42',0,'2014-01-04 02:05:29',NULL,NULL),(20119,3772,'2816971','834','00','005010X220A1','2816971','','2014-02-19','01:35:27',0,'2014-02-20 03:52:02',NULL,NULL),(23312,4381,'3346948','834','00','005010X220A1','3346948','','2014-03-08','12:30:08',0,'2014-03-08 21:30:29',NULL,NULL),(13435,2223,'1773204','834','00','005010X220A1','1773204','','2014-01-06','12:16:49',0,'2014-01-07 04:02:08',NULL,NULL),(2175,363,'238475','834','00','005010X220A1','238475','','2013-12-01','19:04:33',0,'2013-12-25 19:47:19',NULL,NULL),(2752,504,'1245907','834','00','005010X220A1','1245907','','2013-12-22','10:32:03',0,'2013-12-25 21:18:48',NULL,NULL),(10543,1402,'915966','834','00','005010X220A1','915966','','2013-12-22','18:42:15',0,'2013-12-26 12:55:15',NULL,NULL),(18909,3508,'3012553','834','00','005010X220A1','3012553','','2014-02-11','16:30:19',0,'2014-02-11 21:02:45',NULL,NULL),(15499,2636,'1660641','834','00','005010X220A1','1660641','','2014-01-15','23:11:53',0,'2014-01-17 03:36:30',NULL,NULL),(14052,2339,'1790071','834','00','005010X220A1','1790071','','2014-01-07','20:07:52',0,'2014-01-13 02:21:38',NULL,NULL),(11473,1488,'1464594','834','00','005010X220A1','1464594','','2013-12-27','14:08:08',0,'2013-12-28 03:30:50',NULL,NULL),(11558,1492,'2039393','834','00','005010X220A1','2039393','','2013-12-27','10:14:25',0,'2013-12-28 03:33:25',NULL,NULL),(3113,547,'581798','834','00','005010X220A1','581798','','2013-12-13','11:11:38',0,'2013-12-25 21:36:33',NULL,NULL),(22912,4286,'3526417','834','00','005010X220A1','3526417','','2014-03-06','12:39:24',0,'2014-03-06 21:02:25',NULL,NULL),(16976,3116,'1846369','834','00','005010X220A1','1846369','','2014-01-29','17:41:07',0,'2014-01-29 21:00:39',NULL,NULL),(5518,1041,'1727556','834','00','005010X220A1','1727556','','2013-12-24','20:58:44',0,'2013-12-26 01:46:57',NULL,NULL),(572,103,'388404','834','00','005010X220A1','388404','','2013-12-16','15:08:53',0,'2013-12-25 18:02:43',NULL,NULL),(6341,1176,'413572','834','00','005010X220A1','413572','','2013-12-20','18:31:12',0,'2013-12-26 03:08:37',NULL,NULL),(1966,326,'28654','834','00','005010X220A1','28654','','2013-12-09','14:34:49',0,'2013-12-25 19:33:40',NULL,NULL),(13780,2290,'1885307','834','00','005010X220A1','1885307','','2014-01-07','13:26:39',0,'2014-01-08 18:25:06',NULL,NULL),(6446,1208,'516985','834','00','005010X220A1','516985','','2013-11-22','13:36:34',0,'2013-12-26 03:15:57',NULL,NULL),(7753,1346,'1131677','834','00','005010X220A1','1131677','','2013-10-20','13:16:00',0,'2013-12-26 05:00:58',NULL,NULL),(1939,326,'631459','834','00','005010X220A1','631459','','2013-12-09','10:21:48',0,'2013-12-25 19:32:54',NULL,NULL),(5929,1112,'378676','834','00','005010X220A1','378676','','2013-12-15','15:06:06',0,'2013-12-26 02:31:41',NULL,NULL),(12947,1733,'1608894','834','00','005010X220A1','1608894','','2014-01-03','20:59:21',0,'2014-01-05 00:00:13',NULL,NULL),(5303,986,'727139','834','00','005010X220A1','727139','','2013-11-05','15:03:34',0,'2013-12-26 01:01:34',NULL,NULL),(11725,1520,'2026181','834','00','005010X220A1','2026181','','2013-12-28','12:17:24',1,'2013-12-29 11:08:41',NULL,NULL),(16280,2972,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:20:00',0,'2014-01-23 15:00:02',NULL,NULL),(14931,2560,'2574718','834','00','005010X220A1','2574718','','2014-01-14','17:34:33',0,'2014-01-15 02:07:43',NULL,NULL),(12931,1723,'2477792','834','00','005010X220A1','2477792','','2014-01-03','15:22:44',0,'2014-01-04 02:06:04',NULL,NULL),(12561,1660,'2045302','834','00','005010X220A1','2045302','','2013-12-31','14:01:13',1,'2014-01-02 04:35:44',NULL,NULL),(1873,324,'1279468','834','00','005010X220A1','1279468','','2013-12-09','16:58:47',0,'2013-12-25 19:30:57',NULL,NULL),(2053,336,'139670','834','00','005010X220A1','139670','','2013-12-09','01:09:00',0,'2013-12-25 19:36:30',NULL,NULL),(12000,1581,'1652598','834','00','005010X220A1','1652598','','2013-12-30','11:08:06',0,'2014-01-01 12:02:02',NULL,NULL),(12554,1657,'1758919','834','00','005010X220A1','1758919','','2013-12-31','12:16:02',1,'2014-01-02 04:35:23',NULL,NULL),(11831,1541,'273042','834','00','005010X220A1','273042','','2013-12-28','20:22:54',1,'2013-12-29 11:14:05',NULL,NULL),(11274,1455,'2178894','834','00','005010X220A1','2178894','','2013-12-26','12:37:02',0,'2013-12-27 02:02:43',NULL,NULL),(17569,3236,'2802861','834','00','005010X220A1','2802861','','2014-02-03','14:22:11',0,'2014-02-03 21:00:38',NULL,NULL),(7030,1235,'1109361','834','00','005010X220A1','1109361','','2013-12-18','12:47:47',0,'2013-12-26 04:01:26',NULL,NULL),(4421,788,'1022138','834','00','005010X220A1','1022138','','2013-11-05','20:41:34',0,'2013-12-25 23:16:43',NULL,NULL),(4517,814,'553255','834','00','005010X220A1','553255','','2013-11-26','00:29:00',0,'2013-12-25 23:32:40',NULL,NULL),(4859,885,'911560','834','00','005010X220A1','911560','','2013-11-21','15:59:00',0,'2013-12-26 00:15:53',NULL,NULL),(21784,4091,'3365761','834','00','005010X220A1','3365761','','2014-02-28','14:47:18',0,'2014-02-28 21:31:10',NULL,NULL),(16462,3006,'1769835','834','00','005010X220A1','1769835','','2014-01-24','17:52:40',0,'2014-01-24 21:00:18',NULL,NULL),(16982,3117,'1914775','834','00','005010X220A1','1914775','','2014-01-29','14:59:23',0,'2014-01-29 21:00:43',NULL,NULL),(13351,2195,'0001','999','BE','005010X231A1','1192756','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:34',NULL,NULL),(4736,850,'658924','834','00','005010X220A1','658924','','2013-12-24','00:25:32',0,'2013-12-25 23:52:00',NULL,NULL),(11145,1433,'239367','834','00','005010X220A1','239367','','2013-12-23','13:13:09',0,'2013-12-26 13:15:45',NULL,NULL),(2671,501,'66556','834','00','005010X220A1','66556','','2013-12-22','17:24:59',0,'2013-12-25 21:16:14',NULL,NULL),(2648,501,'426605','834','00','005010X220A1','426605','','2013-12-21','23:12:22',0,'2013-12-25 21:15:20',NULL,NULL),(18214,3356,'2539348','834','00','005010X220A1','2539348','','2014-02-07','10:25:01',0,'2014-02-07 19:00:43',NULL,NULL),(6160,1167,'386204','834','00','005010X220A1','386204','','2013-12-19','23:39:26',0,'2013-12-26 03:03:09',NULL,NULL),(1963,326,'428887','834','00','005010X220A1','428887','','2013-12-09','14:08:49',0,'2013-12-25 19:33:35',NULL,NULL),(785,145,'942287','834','00','005010X220A1','942287','','2013-10-31','15:00:35',0,'2013-12-25 18:09:37',NULL,NULL),(22009,4150,'2997084','834','00','005010X220A1','2997084','','2014-03-01','21:31:29',0,'2014-03-03 01:00:28',NULL,NULL),(12783,1703,'1452342','834','00','005010X220A1','1452342','','2014-01-02','21:04:56',0,'2014-01-04 02:00:37',NULL,NULL),(4728,843,'385175','834','00','005010X220A1','385175','','2013-12-24','02:21:12',0,'2013-12-25 23:51:39',NULL,NULL),(15205,2592,'1921900','834','00','005010X220A1','1921900','','2014-01-15','16:19:38',0,'2014-01-16 08:46:28',NULL,NULL),(17734,3262,'2301119','834','00','005010X220A1','2301119','','2014-02-03','18:58:28',0,'2014-02-04 21:00:50',NULL,NULL),(19045,3540,'2683240','834','00','005010X220A1','2683240','','2014-02-12','14:08:58',0,'2014-02-12 21:30:57',NULL,NULL),(1351,245,'260244','834','00','005010X220A1','260244','','2013-12-24','13:15:43',0,'2013-12-25 18:52:27',NULL,NULL),(11499,1489,'2162172','834','00','005010X220A1','2162172','','2013-12-27','10:33:47',0,'2013-12-28 03:31:37',NULL,NULL),(4579,826,'1024343','834','00','005010X220A1','1024343','','2013-12-23','22:13:25',0,'2013-12-25 23:46:35',NULL,NULL),(20266,3794,'2334948','834','00','005010X220A1','2334948','','2014-02-19','00:11:09',0,'2014-02-20 04:35:03',NULL,NULL),(19412,3593,'2039144','834','00','005010X220A1','2039144','','2014-02-13','15:51:30',0,'2014-02-13 22:02:38',NULL,NULL),(5644,1048,'293629','834','00','005010X220A1','293629','','2013-12-25','00:48:22',0,'2013-12-26 01:51:08',NULL,NULL),(13540,2241,'2191256','834','00','005010X220A1','2191256','','2014-01-06','05:19:10',0,'2014-01-07 04:06:04',NULL,NULL),(17832,3281,'2534191','834','00','005010X220A1','2534191','','2014-02-04','15:14:40',0,'2014-02-04 21:01:55',NULL,NULL),(13961,2322,'1897641','834','00','005010X220A1','1897641','','2014-01-09','08:33:03',0,'2014-01-13 02:20:28',NULL,NULL),(20905,3930,'3549613','834','00','005010X220A1','3549613','','2014-02-23','00:49:44',0,'2014-02-26 08:00:05',NULL,NULL),(22568,4248,'3080051','834','00','005010X220A1','3080051','','2014-03-05','13:28:58',0,'2014-03-05 21:30:55',NULL,NULL),(22988,4320,'3801749','834','00','005010X220A1','3801749','','2014-03-06','17:21:46',0,'2014-03-06 21:30:24',NULL,NULL),(23115,4342,'3331904','834','00','005010X220A1','3331904','','2014-03-06','18:36:18',0,'2014-03-07 21:30:46',NULL,NULL),(4470,802,'237468','834','00','005010X220A1','237468','','2013-11-25','18:39:20',0,'2013-12-25 23:31:03',NULL,NULL),(20329,3797,'3472488','834','00','005010X220A1','3472488','','2014-02-19','14:25:57',0,'2014-02-20 04:50:22',NULL,NULL),(6253,1172,'825557','834','00','005010X220A1','825557','','2013-12-19','21:06:13',0,'2013-12-26 03:06:01',NULL,NULL),(10633,1402,'28006','834','00','005010X220A1','28006','','2013-12-23','16:34:22',0,'2013-12-26 12:58:15',NULL,NULL),(16002,2766,'2061238','834','00','005010X220A1','2061238','','2014-01-22','18:19:14',0,'2014-01-23 03:02:14',NULL,NULL),(182,16,'593284','834','00','005010X220A1','593284','','2013-12-05','06:27:22',0,'2013-12-25 17:20:38',NULL,NULL),(19728,3672,'3117719','834','00','005010X220A1','3117719','','2014-02-15','15:10:47',0,'2014-02-15 22:00:28',NULL,NULL),(5423,1027,'557978','834','00','005010X220A1','557978','','2013-11-14','07:29:28',0,'2013-12-26 01:31:03',NULL,NULL),(17393,3198,'2558798','834','00','005010X220A1','2558798','','2014-01-31','19:31:10',0,'2014-02-01 19:00:05',NULL,NULL),(15462,2632,'1624921','834','00','005010X220A1','1624921','','2014-01-15','19:05:16',0,'2014-01-17 03:36:14',NULL,NULL),(203,21,'873400','834','00','005010X220A1','873400','','2013-12-05','05:51:36',0,'2013-12-25 17:21:20',NULL,NULL),(5270,973,'362677','834','00','005010X220A1','362677','','2013-11-12','04:16:01',0,'2013-12-26 01:00:19',NULL,NULL),(19426,3599,'2317400','834','00','005010X220A1','2317400','','2014-02-13','13:19:24',0,'2014-02-13 22:02:49',NULL,NULL),(17134,3144,'2308399','834','00','005010X220A1','2308399','','2014-01-29','19:58:44',0,'2014-01-30 21:00:27',NULL,NULL),(16233,2925,'0001','999','BE','005010X231A1','1747511','834','2014-01-15','23:00:00',0,'2014-01-23 06:40:46',NULL,NULL),(1317,245,'29445','834','00','005010X220A1','29445','','2013-12-24','10:29:13',0,'2013-12-25 18:51:21',NULL,NULL),(12897,1711,'2065448','834','00','005010X220A1','2065448','','2014-01-02','21:57:30',0,'2014-01-04 02:04:46',NULL,NULL),(15179,2591,'2200243','834','00','005010X220A1','2200243','','2014-01-15','11:35:40',0,'2014-01-16 08:46:12',NULL,NULL),(15085,2585,'1437874','834','00','005010X220A1','1437874','','2014-01-15','13:43:33',0,'2014-01-16 08:45:11',NULL,NULL),(22075,4174,'3427433','834','00','005010X220A1','3427433','','2014-03-03','06:25:17',0,'2014-03-03 21:29:58',NULL,NULL),(7036,1235,'672297','834','00','005010X220A1','672297','','2013-12-18','14:23:42',0,'2013-12-26 04:01:38',NULL,NULL),(18916,3513,'3233107','834','00','005010X220A1','3233107','','2014-02-11','15:45:46',0,'2014-02-11 21:02:51',NULL,NULL),(3799,660,'528085','834','00','005010X220A1','528085','','2013-12-08','08:42:07',0,'2013-12-25 22:16:15',NULL,NULL),(17806,3271,'1600697','834','00','005010X220A1','1600697','','2014-02-04','12:12:37',0,'2014-02-04 21:01:37',NULL,NULL),(5404,1021,'325295','834','00','005010X220A1','325295','','2013-11-13','18:33:34',0,'2013-12-26 01:30:20',NULL,NULL),(17089,3137,'2670358','834','00','005010X220A1','2670358','','2014-01-29','15:45:33',0,'2014-01-29 21:01:51',NULL,NULL),(15271,2606,'1614461','834','00','005010X220A1','1614461','','2014-01-15','02:13:51',0,'2014-01-16 08:47:12',NULL,NULL),(15147,2588,'2386573','834','00','005010X220A1','2386573','','2014-01-15','00:02:09',0,'2014-01-16 08:45:52',NULL,NULL),(11519,1490,'2111419','834','00','005010X220A1','2111419','','2013-12-27','11:46:41',0,'2013-12-28 03:32:12',NULL,NULL),(11186,1452,'16081','834','00','005010X220A1','16081','','2013-12-23','17:42:58',0,'2013-12-26 13:17:11',NULL,NULL),(4558,825,'1628018','834','00','005010X220A1','1628018','','2013-12-24','00:38:09',0,'2013-12-25 23:45:58',NULL,NULL),(3809,663,'690593','834','00','005010X220A1','690593','','2013-12-07','19:55:20',0,'2013-12-25 22:16:38',NULL,NULL),(19894,3712,'3505086','834','00','005010X220A1','3505086','','2014-02-15','20:37:42',0,'2014-02-16 19:00:34',NULL,NULL),(4384,774,'993982','834','00','005010X220A1','993982','','2013-11-26','20:53:40',0,'2013-12-25 23:15:29',NULL,NULL),(7559,1301,'949736','834','00','005010X220A1','949736','','2013-12-21','11:01:18',0,'2013-12-26 04:35:56',NULL,NULL),(7755,1347,'772823','834','00','005010X220A1','772823','','2013-10-20','13:30:38',0,'2013-12-26 05:01:02',NULL,NULL),(18360,3404,'2275461','834','00','005010X220A1','2275461','','2014-02-09','16:55:03',0,'2014-02-09 19:00:08',NULL,NULL),(18155,3350,'2336013','834','00','005010X220A1','2336013','','2014-02-06','18:21:53',0,'2014-02-07 19:00:04',NULL,NULL),(17560,3236,'2735882','834','00','005010X220A1','2735882','','2014-02-03','09:43:07',0,'2014-02-03 21:00:33',NULL,NULL),(12167,1594,'1521960','834','00','005010X220A1','1521960','','2013-12-30','13:45:29',0,'2014-01-01 12:08:00',NULL,NULL),(12971,1734,'2397892','834','00','005010X220A1','2397892','','2014-01-04','14:59:31',0,'2014-01-05 00:01:08',NULL,NULL),(865,175,'1037381','834','00','005010X220A1','1037381','','2013-12-03','17:31:59',0,'2013-12-25 18:16:09',NULL,NULL),(21012,3962,'2808994','834','00','005010X220A1','2808994','','2014-02-22','11:59:54',0,'2014-02-26 08:30:48',NULL,NULL),(20117,3772,'2536824','834','00','005010X220A1','2536824','','2014-02-18','23:06:53',0,'2014-02-20 03:50:54',NULL,NULL),(19386,3592,'2284039','834','00','005010X220A1','2284039','','2014-02-13','11:26:25',0,'2014-02-13 22:02:19',NULL,NULL),(19118,3545,'2281447','834','00','005010X220A1','2281447','','2014-02-12','10:00:02',0,'2014-02-12 21:31:49',NULL,NULL),(6137,1166,'754087','834','00','005010X220A1','754087','','2013-12-20','16:20:46',0,'2013-12-26 03:02:26',NULL,NULL),(18186,3351,'2102294','834','00','005010X220A1','2102294','','2014-02-07','09:59:41',0,'2014-02-07 19:00:25',NULL,NULL),(7595,1302,'1175137','834','00','005010X220A1','1175137','','2013-12-21','16:00:24',0,'2013-12-26 04:37:08',NULL,NULL),(12909,1714,'1711607','834','00','005010X220A1','1711607','','2014-01-03','00:09:10',0,'2014-01-04 02:05:13',NULL,NULL),(11485,1488,'2063884','834','00','005010X220A1','2063884','','2013-12-27','17:06:45',0,'2013-12-28 03:31:13',NULL,NULL),(21654,4076,'3262923','834','00','005010X220A1','3262923','','2014-02-28','16:03:06',0,'2014-02-28 21:00:03',NULL,NULL),(4349,759,'1064551','834','00','005010X220A1','1064551','','2013-12-19','11:04:28',0,'2013-12-25 23:10:45',NULL,NULL),(11125,1428,'28003','834','00','005010X220A1','28003','','2013-12-23','16:24:43',0,'2013-12-26 13:14:59',NULL,NULL),(16047,2772,'1745783','834','00','005010X220A1','1745783','','2014-01-22','13:28:42',0,'2014-01-23 03:02:34',NULL,NULL),(19782,3675,'3510075','834','00','005010X220A1','3510075','','2014-02-14','20:04:17',0,'2014-02-15 22:01:07',NULL,NULL),(16050,2772,'2354599','834','00','005010X220A1','2354599','','2014-01-22','00:32:06',0,'2014-01-23 03:02:35',NULL,NULL),(17064,3126,'1529745','834','00','005010X220A1','1529745','','2014-01-28','23:27:09',0,'2014-01-29 21:01:35',NULL,NULL),(22162,4180,'2999796','834','00','005010X220A1','2999796','','2014-03-03','11:23:16',0,'2014-03-03 21:31:04',NULL,NULL),(620,108,'825311','834','00','005010X220A1','825311','','2013-12-16','09:17:34',0,'2013-12-25 18:04:15',NULL,NULL),(20870,3916,'3790921','834','00','005010X220A1','3790921','','2014-02-25','12:06:10',0,'2014-02-25 21:31:46',NULL,NULL),(845,175,'50589','834','00','005010X220A1','50589','','2013-12-03','10:35:06',0,'2013-12-25 18:15:29',NULL,NULL),(19793,3677,'3414150','834','00','005010X220A1','3414150','','2014-02-15','09:43:06',0,'2014-02-15 22:01:16',NULL,NULL),(19132,3548,'2533055','834','00','005010X220A1','2533055','','2014-02-11','22:40:33',0,'2014-02-12 21:31:58',NULL,NULL),(17532,3235,'2071059','834','00','005010X220A1','2071059','','2014-02-03','14:31:19',0,'2014-02-03 21:00:15',NULL,NULL),(3946,715,'893066','834','00','005010X220A1','893066','','2013-12-06','19:00:50',0,'2013-12-25 22:46:24',NULL,NULL),(4206,737,'148073','834','00','005010X220A1','148073','','2013-12-18','23:49:48',0,'2013-12-25 23:06:25',NULL,NULL),(15855,2738,'2386721','834','00','005010X220A1','2386721','','2014-01-21','13:16:09',1,'2014-01-22 03:22:13',NULL,NULL),(7530,1300,'1210833','834','00','005010X220A1','1210833','','2013-12-21','14:16:36',0,'2013-12-26 04:35:00',NULL,NULL),(22836,4278,'3665136','834','00','005010X220A1','3665136','','2014-03-06','17:25:59',0,'2014-03-06 21:01:28',NULL,NULL),(22983,4317,'3521811','834','00','005010X220A1','3521811','','2014-03-06','15:47:59',0,'2014-03-06 21:30:20',NULL,NULL),(231,36,'1116266','834','00','005010X220A1','1116266','','2013-10-12','07:40:55',0,'2013-12-25 17:30:15',NULL,NULL),(7374,1291,'1262539','834','00','005010X220A1','1262539','','2013-11-30','16:36:20',0,'2013-12-26 04:16:22',NULL,NULL),(19981,3746,'2818280','834','00','005010X220A1','2818280','','2014-02-18','15:59:39',0,'2014-02-18 22:00:20',NULL,NULL),(4982,935,'866366','834','00','005010X220A1','866366','','2013-12-10','20:21:23',0,'2013-12-26 00:45:24',NULL,NULL),(2061,338,'996767','834','00','005010X220A1','996767','','2013-12-09','08:59:23',0,'2013-12-25 19:36:48',NULL,NULL),(2418,417,'441079','834','00','005010X220A1','441079','','2013-12-05','19:45:03',0,'2013-12-25 20:17:50',NULL,NULL),(15012,2584,'1598847','834','00','005010X220A1','1598847','','2014-01-15','12:39:26',0,'2014-01-16 08:44:25',NULL,NULL),(916,177,'1027001','834','00','005010X220A1','1027001','','2013-12-03','17:00:13',0,'2013-12-25 18:17:33',NULL,NULL),(19778,3675,'2723491','834','00','005010X220A1','2723491','','2014-02-15','11:36:25',0,'2014-02-15 22:01:04',NULL,NULL),(19656,3650,'3201486','834','00','005010X220A1','3201486','','2014-02-14','13:54:52',0,'2014-02-14 21:32:19',NULL,NULL),(2215,366,'994019','834','00','005010X220A1','994019','','2013-12-01','19:51:52',0,'2013-12-25 19:48:39',NULL,NULL),(11622,1495,'2236341','834','00','005010X220A1','2236341','','2013-12-27','00:27:54',0,'2013-12-28 03:35:25',NULL,NULL),(16942,3115,'1900551','834','00','005010X220A1','1900551','','2014-01-29','13:03:46',0,'2014-01-29 21:00:17',NULL,NULL),(6460,1217,'983915','834','00','005010X220A1','983915','','2013-11-22','11:21:05',0,'2013-12-26 03:16:27',NULL,NULL),(2681,502,'628409','834','00','005010X220A1','628409','','2013-12-21','23:40:21',0,'2013-12-25 21:16:35',NULL,NULL),(2953,541,'1288666','834','00','005010X220A1','1288666','','2013-12-13','10:39:50',0,'2013-12-25 21:31:40',NULL,NULL),(3612,619,'249061','834','00','005010X220A1','249061','','2013-12-12','17:46:41',0,'2013-12-25 22:04:43',NULL,NULL),(17816,3273,'2432129','834','00','005010X220A1','2432129','','2014-02-04','15:21:58',0,'2014-02-04 21:01:43',NULL,NULL),(13193,2037,'0001','999','BE','005010X231A1','764857','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:33',NULL,NULL),(13633,2270,'1481770','834','00','005010X220A1','1481770','','2014-01-07','13:13:21',0,'2014-01-08 18:24:03',NULL,NULL),(14214,2366,'1942290','834','00','005010X220A1','1942290','','2014-01-09','18:26:26',0,'2014-01-13 02:23:53',NULL,NULL),(21626,4066,'3498747','834','00','005010X220A1','3498747','','2014-02-27','09:08:53',0,'2014-02-28 07:30:22',NULL,NULL),(23148,4342,'2716924','834','00','005010X220A1','2716924','','2014-03-07','17:13:13',0,'2014-03-07 21:31:08',NULL,NULL),(23467,4417,'3096022','834','00','005010X220A1','3096022','','2014-03-09','11:39:37',0,'2014-03-09 21:01:06',NULL,NULL),(1144,239,'1554873','834','00','005010X220A1','1554873','','2013-12-24','08:33:57',0,'2013-12-25 18:46:01',NULL,NULL),(6099,1166,'657206','834','00','005010X220A1','657206','','2013-12-20','09:10:07',0,'2013-12-26 03:01:18',NULL,NULL),(20908,3931,'2902358','834','00','005010X220A1','2902358','','2014-02-22','19:48:22',0,'2014-02-26 08:00:08',NULL,NULL),(2429,417,'866274','834','00','005010X220A1','866274','','2013-12-06','12:42:17',0,'2013-12-25 20:18:08',NULL,NULL),(18267,3376,'2605668','834','00','005010X220A1','2605668','','2014-02-08','15:24:12',0,'2014-02-08 19:00:13',NULL,NULL),(17317,3174,'1936822','834','00','005010X220A1','1936822','','2014-01-31','09:42:39',0,'2014-01-31 21:00:53',NULL,NULL),(5414,1025,'1050474','834','00','005010X220A1','1050474','','2013-11-13','23:02:49',0,'2013-12-26 01:30:47',NULL,NULL),(13985,2326,'2058571','834','00','005010X220A1','2058571','','2014-01-08','19:38:00',0,'2014-01-13 02:20:46',NULL,NULL),(3440,602,'222153','834','00','005010X220A1','222153','','2013-12-17','09:36:00',0,'2013-12-25 21:52:59',NULL,NULL),(260,48,'897847','834','00','005010X220A1','897847','','2013-11-13','16:20:01',0,'2013-12-25 17:31:12',NULL,NULL),(2682,502,'1253271','834','00','005010X220A1','1253271','','2013-12-22','00:55:45',0,'2013-12-25 21:16:38',NULL,NULL),(20398,3831,'3678925','834','00','005010X220A1','3678925','','2014-02-19','19:15:29',0,'2014-02-20 21:30:05',NULL,NULL),(20890,3922,'3189406','834','00','005010X220A1','3189406','','2014-02-25','15:49:08',0,'2014-02-25 21:32:01',NULL,NULL),(21139,3996,'2690155','834','00','005010X220A1','2690155','','2014-02-26','14:24:53',0,'2014-02-26 21:00:38',NULL,NULL),(1161,239,'1519392','834','00','005010X220A1','1519392','','2013-12-24','12:20:02',0,'2013-12-25 18:46:31',NULL,NULL),(13820,2298,'1394826','834','00','005010X220A1','1394826','','2014-01-11','13:44:14',0,'2014-01-13 02:18:29',NULL,NULL),(2976,541,'862803','834','00','005010X220A1','862803','','2013-12-13','16:18:04',0,'2013-12-25 21:32:24',NULL,NULL),(13365,2209,'0001','999','BE','005010X231A1','1117810','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:13',NULL,NULL),(4613,827,'658906','834','00','005010X220A1','658906','','2013-12-23','21:28:45',0,'2013-12-25 23:47:39',NULL,NULL),(21328,4020,'3058010','834','00','005010X220A1','3058010','','2014-02-26','17:38:32',0,'2014-02-26 21:02:46',NULL,NULL),(22148,4179,'3295516','834','00','005010X220A1','3295516','','2014-03-03','14:37:19',0,'2014-03-03 21:30:53',NULL,NULL),(16748,3067,'2079297','834','00','005010X220A1','2079297','','2014-01-27','13:24:46',0,'2014-01-27 21:01:17',NULL,NULL),(12325,1634,'1284096','834','00','005010X220A1','1284096','','2013-12-30','23:17:59',1,'2014-01-02 04:27:00',NULL,NULL),(12099,1587,'2042758','834','00','005010X220A1','2042758','','2013-12-30','07:41:49',0,'2014-01-01 12:05:40',NULL,NULL),(7504,1300,'461661','834','00','005010X220A1','461661','','2013-12-20','23:35:00',0,'2013-12-26 04:34:11',NULL,NULL),(4183,734,'1137294','834','00','005010X220A1','1137294','','2013-12-19','14:38:58',0,'2013-12-25 23:05:42',NULL,NULL),(4074,733,'579223','834','00','005010X220A1','579223','','2013-12-18','20:11:14',0,'2013-12-25 23:02:30',NULL,NULL),(22654,4254,'3092157','834','00','005010X220A1','3092157','','2014-03-05','01:18:41',0,'2014-03-05 21:31:56',NULL,NULL),(266,51,'553148','834','00','005010X220A1','553148','','2013-11-13','11:11:37',0,'2013-12-25 17:31:25',NULL,NULL),(14960,2566,'1461077','834','00','005010X220A1','1461077','','2014-01-14','16:23:42',0,'2014-01-15 02:07:57',NULL,NULL),(19206,3576,'2573094','834','00','005010X220A1','2573094','','2014-02-13','11:59:10',0,'2014-02-13 21:30:14',NULL,NULL),(2388,414,'188330','834','00','005010X220A1','188330','','2013-12-06','00:26:19',0,'2013-12-25 20:16:50',NULL,NULL),(3754,647,'1074350','834','00','005010X220A1','1074350','','2013-12-12','15:23:54',0,'2013-12-25 22:09:21',NULL,NULL),(20111,3772,'2827651','834','00','005010X220A1','2827651','','2014-02-18','19:36:07',0,'2014-02-20 03:47:11',NULL,NULL),(21477,4028,'3006870','834','00','005010X220A1','3006870','','2014-02-27','15:42:21',0,'2014-02-28 06:31:11',NULL,NULL),(21620,4065,'2737706','834','00','005010X220A1','2737706','','2014-02-27','14:03:45',0,'2014-02-28 07:30:19',NULL,NULL),(21856,4114,'2956606','834','00','005010X220A1','2956606','','2014-02-28','18:36:16',0,'2014-03-01 19:00:06',NULL,NULL),(23201,4347,'3494964','834','00','005010X220A1','3494964','','2014-03-06','20:26:57',0,'2014-03-07 21:31:47',NULL,NULL),(5656,1051,'319960','834','00','005010X220A1','319960','','2013-12-24','19:29:35',0,'2013-12-26 01:51:31',NULL,NULL),(2017,331,'10142','834','00','005010X220A1','10142','','2013-12-09','13:26:21',0,'2013-12-25 19:35:24',NULL,NULL),(2150,361,'647476','834','00','005010X220A1','647476','','2013-12-02','14:46:53',0,'2013-12-25 19:46:27',NULL,NULL),(5384,1011,'241918','834','00','005010X220A1','241918','','2013-11-24','23:34:10',0,'2013-12-26 01:17:01',NULL,NULL),(15163,2588,'1584778','834','00','005010X220A1','1584778','','2014-01-15','17:00:20',0,'2014-01-16 08:46:02',NULL,NULL),(4383,774,'21674','834','00','005010X220A1','21674','','2013-11-26','19:38:44',0,'2013-12-25 23:15:26',NULL,NULL),(19253,3581,'2036234','834','00','005010X220A1','2036234','','2014-02-12','19:44:04',0,'2014-02-13 22:00:37',NULL,NULL),(22749,4276,'2625857','834','00','005010X220A1','2625857','','2014-03-06','13:24:25',0,'2014-03-06 21:00:28',NULL,NULL),(23705,4453,'2767996','834','00','005010X220A1','2767996','','2014-03-10','09:36:08',0,'2014-03-10 21:02:31',NULL,NULL),(14007,2337,'2371321','834','00','005010X220A1','2371321','','2014-01-07','18:48:58',0,'2014-01-13 02:21:10',NULL,NULL),(15039,2584,'1951935','834','00','005010X220A1','1951935','','2014-01-15','17:30:07',0,'2014-01-16 08:44:42',NULL,NULL),(19425,3599,'3263536','834','00','005010X220A1','3263536','','2014-02-13','10:40:11',0,'2014-02-13 22:02:48',NULL,NULL),(18073,3321,'2307232','834','00','005010X220A1','2307232','','2014-02-06','16:29:45',0,'2014-02-06 21:00:57',NULL,NULL),(15367,2624,'2045721','834','00','005010X220A1','2045721','','2014-01-15','21:40:06',0,'2014-01-17 03:35:31',NULL,NULL),(16045,2772,'1490492','834','00','005010X220A1','1490492','','2014-01-22','10:17:47',0,'2014-01-23 03:02:33',NULL,NULL),(3089,546,'436367','834','00','005010X220A1','436367','','2013-12-12','19:49:46',0,'2013-12-25 21:35:51',NULL,NULL),(22293,4201,'2726578','834','00','005010X220A1','2726578','','2014-03-03','21:30:32',0,'2014-03-04 21:00:53',NULL,NULL),(22474,4239,'2953223','834','00','005010X220A1','2953223','','2014-03-05','09:03:23',0,'2014-03-05 21:00:19',NULL,NULL),(14447,2468,'0001','999','BE','005010X231A1','1199099','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:20',NULL,NULL),(19604,3633,'2980109','834','00','005010X220A1','2980109','','2014-02-13','19:30:25',0,'2014-02-14 21:31:40',NULL,NULL),(353,72,'888164','834','00','005010X220A1','888164','','2013-12-04','16:34:34',0,'2013-12-25 17:46:53',NULL,NULL),(18738,3485,'3045207','834','00','005010X220A1','3045207','','2014-02-11','11:45:49',0,'2014-02-11 21:00:29',NULL,NULL),(2921,541,'616512','834','00','005010X220A1','616512','','2013-12-12','18:49:00',0,'2013-12-25 21:30:36',NULL,NULL),(18309,3383,'3042604','834','00','005010X220A1','3042604','','2014-02-08','17:01:37',0,'2014-02-08 19:00:40',NULL,NULL),(17976,3305,'2713377','834','00','005010X220A1','2713377','','2014-02-04','21:51:51',0,'2014-02-05 21:31:09',NULL,NULL),(14393,2417,'2389810','834','00','005010X220A1','2389810','','2014-01-12','14:45:47',0,'2014-01-13 03:01:57',NULL,NULL),(17684,3259,'2797308','834','00','005010X220A1','2797308','','2014-02-04','15:26:30',0,'2014-02-04 21:00:20',NULL,NULL),(17580,3237,'1713610','834','00','005010X220A1','1713610','','2014-02-03','00:14:39',0,'2014-02-03 21:00:45',NULL,NULL),(12836,1704,'2417778','834','00','005010X220A1','2417778','','2014-01-03','14:04:56',0,'2014-01-04 02:02:34',NULL,NULL),(15972,2764,'1625049','834','00','005010X220A1','1625049','','2014-01-21','18:42:42',0,'2014-01-23 03:02:00',NULL,NULL),(11009,1414,'1595854','834','00','005010X220A1','1595854','','2013-12-23','00:30:42',0,'2013-12-26 13:11:06',NULL,NULL),(20432,3841,'2860383','834','00','005010X220A1','2860383','','2014-02-19','18:16:26',0,'2014-02-20 22:00:08',NULL,NULL),(20811,3910,'2741493','834','00','005010X220A1','2741493','','2014-02-25','10:52:47',0,'2014-02-25 21:31:03',NULL,NULL),(22171,4180,'3666191','834','00','005010X220A1','3666191','','2014-03-03','13:33:16',0,'2014-03-03 21:31:10',NULL,NULL),(22521,4247,'3450205','834','00','005010X220A1','3450205','','2014-03-05','13:17:32',0,'2014-03-05 21:30:21',NULL,NULL),(17143,3144,'2707096','834','00','005010X220A1','2707096','','2014-01-30','11:45:31',0,'2014-01-30 21:00:32',NULL,NULL),(19710,3672,'3386654','834','00','005010X220A1','3386654','','2014-02-14','22:15:36',0,'2014-02-15 22:00:15',NULL,NULL),(19518,3622,'3087446','834','00','005010X220A1','3087446','','2014-02-14','00:19:24',0,'2014-02-14 21:30:38',NULL,NULL),(18661,3467,'1926531','834','00','005010X220A1','1926531','','2014-02-10','09:27:49',0,'2014-02-10 21:31:47',NULL,NULL),(13354,2198,'0001','999','BE','005010X231A1','719711','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:42',NULL,NULL),(20400,3832,'3566575','834','00','005010X220A1','3566575','','2014-02-20','11:15:54',0,'2014-02-20 21:30:07',NULL,NULL),(20878,3920,'3304866','834','00','005010X220A1','3304866','','2014-02-25','09:19:08',0,'2014-02-25 21:31:52',NULL,NULL),(21005,3960,'2584372','834','00','005010X220A1','2584372','','2014-02-22','16:53:15',0,'2014-02-26 08:30:42',NULL,NULL),(95,4,'1221315','834','00','005010X220A1','1221315','','2013-12-05','11:47:03',0,'2013-12-25 17:17:53',NULL,NULL),(19858,3703,'3235634','834','00','005010X220A1','3235634','','2014-02-15','18:01:57',0,'2014-02-16 19:00:05',NULL,NULL),(18491,3435,'2482954','834','00','005010X220A1','2482954','','2014-02-10','04:11:26',0,'2014-02-10 11:01:07',NULL,NULL),(17852,3291,'1768814','834','00','005010X220A1','1768814','','2014-02-05','14:35:31',0,'2014-02-05 21:30:06',NULL,NULL),(1017,191,'853383','834','00','005010X220A1','853383','','2013-12-03','15:36:28',0,'2013-12-25 18:20:47',NULL,NULL),(15910,2743,'1580970','834','00','005010X220A1','1580970','','2014-01-21','11:34:45',1,'2014-01-22 03:22:47',NULL,NULL),(15798,2722,'2147244','834','00','005010X220A1','2147244','','2014-01-20','13:38:02',0,'2014-01-21 08:46:47',NULL,NULL),(13386,2221,'1448779','834','00','005010X220A1','1448779','','2014-01-06','13:22:10',0,'2014-01-07 04:00:21',NULL,NULL),(12549,1655,'1538041','834','00','005010X220A1','1538041','','2013-12-31','17:51:39',1,'2014-01-02 04:35:12',NULL,NULL),(1908,325,'630472','834','00','005010X220A1','630472','','2013-12-09','13:47:28',0,'2013-12-25 19:32:01',NULL,NULL),(1944,326,'1267470','834','00','005010X220A1','1267470','','2013-12-09','10:40:21',0,'2013-12-25 19:33:03',NULL,NULL),(5784,1075,'516341','834','00','005010X220A1','516341','','2013-12-14','09:41:07',0,'2013-12-26 02:03:03',NULL,NULL),(22277,4200,'2690364','834','00','005010X220A1','2690364','','2014-03-04','14:44:10',0,'2014-03-04 21:00:41',NULL,NULL),(22880,4281,'2675527','834','00','005010X220A1','2675527','','2014-03-06','17:09:54',0,'2014-03-06 21:02:02',NULL,NULL),(1412,247,'1975418','834','00','005010X220A1','1975418','','2013-12-24','17:55:35',0,'2013-12-25 18:54:25',NULL,NULL),(20385,3826,'2852750','834','00','005010X220A1','2852750','','2014-02-19','12:19:23',0,'2014-02-20 05:38:43',NULL,NULL),(4307,749,'517624','834','00','005010X220A1','517624','','2013-12-19','15:57:09',0,'2013-12-25 23:09:29',NULL,NULL),(20951,3949,'3566644','834','00','005010X220A1','3566644','','2014-02-24','14:34:27',0,'2014-02-26 08:00:42',NULL,NULL),(21082,3983,'3150197','834','00','005010X220A1','3150197','','2014-02-24','12:10:28',0,'2014-02-26 09:30:50',NULL,NULL),(21586,4056,'2909565','834','00','005010X220A1','2909565','','2014-02-26','14:11:39',0,'2014-02-28 07:00:28',NULL,NULL),(5795,1076,'314243','834','00','005010X220A1','314243','','2013-12-14','00:09:39',0,'2013-12-26 02:03:21',NULL,NULL),(20519,3849,'3227396','834','00','005010X220A1','3227396','','2014-02-20','10:08:00',0,'2014-02-20 22:01:19',NULL,NULL),(1577,277,'449282','834','00','005010X220A1','449282','','2013-11-20','12:13:35',0,'2013-12-25 19:00:31',NULL,NULL),(17375,3186,'2230907','834','00','005010X220A1','2230907','','2014-01-31','11:50:08',0,'2014-01-31 21:01:35',NULL,NULL),(1732,293,'889328','834','00','005010X220A1','889328','','2013-12-10','10:51:23',0,'2013-12-25 19:17:27',NULL,NULL),(16122,2814,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:47:25',NULL,NULL),(2270,389,'1066361','834','00','005010X220A1','1066361','','2013-10-14','23:26:11',0,'2013-12-25 20:00:10',NULL,NULL),(4730,845,'1145095','834','00','005010X220A1','1145095','','2013-12-23','22:52:53',0,'2013-12-25 23:51:44',NULL,NULL),(14770,2551,'2220475','834','00','005010X220A1','2220475','','2014-01-14','11:39:20',0,'2014-01-15 02:06:32',NULL,NULL),(2740,503,'362163','834','00','005010X220A1','362163','','2013-12-22','15:56:40',0,'2013-12-25 21:18:25',NULL,NULL),(2775,506,'1001241','834','00','005010X220A1','1001241','','2013-12-21','22:04:57',0,'2013-12-25 21:19:30',NULL,NULL),(12829,1704,'2271466','834','00','005010X220A1','2271466','','2014-01-03','10:36:46',0,'2014-01-04 02:02:17',NULL,NULL),(21640,4070,'2688976','834','00','005010X220A1','2688976','','2014-02-27','15:14:56',0,'2014-02-28 07:30:32',NULL,NULL),(23305,4381,'2793091','834','00','005010X220A1','2793091','','2014-03-08','11:05:46',0,'2014-03-08 21:30:24',NULL,NULL),(898,177,'1249013','834','00','005010X220A1','1249013','','2013-12-03','15:23:48',0,'2013-12-25 18:17:04',NULL,NULL),(20466,3842,'2546122','834','00','005010X220A1','2546122','','2014-02-20','12:31:34',0,'2014-02-20 22:00:35',NULL,NULL),(7410,1295,'994717','834','00','005010X220A1','994717','','2013-12-20','23:19:04',0,'2013-12-26 04:31:10',NULL,NULL),(18775,3486,'1709829','834','00','005010X220A1','1709829','','2014-02-11','09:27:21',0,'2014-02-11 21:00:57',NULL,NULL),(14055,2339,'2108116','834','00','005010X220A1','2108116','','2014-01-07','22:48:19',0,'2014-01-13 02:21:40',NULL,NULL),(20946,3948,'3346505','834','00','005010X220A1','3346505','','2014-02-24','07:54:49',0,'2014-02-26 08:00:39',NULL,NULL),(22121,4177,'3150486','834','00','005010X220A1','3150486','','2014-03-03','16:18:02',0,'2014-03-03 21:30:35',NULL,NULL),(22945,4300,'3359936','834','00','005010X220A1','3359936','','2014-03-06','12:38:51',0,'2014-03-06 21:02:49',NULL,NULL),(23251,4369,'2919425','834','00','005010X220A1','2919425','','2014-03-07','13:24:31',0,'2014-03-07 21:32:24',NULL,NULL),(698,114,'736164','834','00','005010X220A1','736164','','2013-12-15','23:02:34',0,'2013-12-25 18:06:40',NULL,NULL),(20674,3881,'3696477','834','00','005010X220A1','3696477','','2014-02-20','20:15:31',0,'2014-02-21 22:01:09',NULL,NULL),(19238,3580,'2884659','834','00','005010X220A1','2884659','','2014-02-13','13:47:39',0,'2014-02-13 22:00:25',NULL,NULL),(1845,323,'1132177','834','00','005010X220A1','1132177','','2013-12-10','17:49:09',0,'2013-12-25 19:21:10',NULL,NULL),(18835,3490,'3073227','834','00','005010X220A1','3073227','','2014-02-11','14:39:37',0,'2014-02-11 21:01:41',NULL,NULL),(7251,1246,'893434','834','00','005010X220A1','893434','','2013-12-18','09:36:28',0,'2013-12-26 04:08:15',NULL,NULL),(17765,3262,'2750358','834','00','005010X220A1','2750358','','2014-02-04','17:02:31',0,'2014-02-04 21:01:09',NULL,NULL),(17362,3181,'1671944','834','00','005010X220A1','1671944','','2014-01-31','16:56:35',0,'2014-01-31 21:01:25',NULL,NULL),(14857,2553,'1701876','834','00','005010X220A1','1701876','','2014-01-14','17:56:24',0,'2014-01-15 02:07:09',NULL,NULL),(7758,1347,'1208537','834','00','005010X220A1','1208537','','2013-10-21','07:26:27',0,'2013-12-26 05:01:08',NULL,NULL),(6327,1175,'1297870','834','00','005010X220A1','1297870','','2013-12-20','15:26:49',0,'2013-12-26 03:08:14',NULL,NULL),(20885,3921,'3391993','834','00','005010X220A1','3391993','','2014-02-25','11:06:40',0,'2014-02-25 21:31:57',NULL,NULL),(20144,3775,'2793734','834','00','005010X220A1','2793734','','2014-02-18','18:04:54',0,'2014-02-20 04:02:07',NULL,NULL),(18418,3420,'1921081','834','00','005010X220A1','1921081','','2014-02-10','00:22:47',0,'2014-02-10 11:00:08',NULL,NULL),(6094,1166,'31957','834','00','005010X220A1','31957','','2013-12-20','00:10:45',0,'2013-12-26 03:01:08',NULL,NULL),(10763,1404,'279516','834','00','005010X220A1','279516','','2013-12-22','19:48:37',0,'2013-12-26 13:02:41',NULL,NULL),(15247,2599,'1844969','834','00','005010X220A1','1844969','','2014-01-14','22:06:20',0,'2014-01-16 08:46:55',NULL,NULL),(5666,1053,'1588823','834','00','005010X220A1','1588823','','2013-12-24','21:55:07',0,'2013-12-26 01:51:54',NULL,NULL),(19899,3715,'3480265','834','00','005010X220A1','3480265','','2014-02-15','21:56:58',0,'2014-02-16 19:00:39',NULL,NULL),(3137,552,'808193','834','00','005010X220A1','808193','','2013-12-12','19:39:19',0,'2013-12-25 21:37:19',NULL,NULL),(16153,2845,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','02:00:00',1,'2014-01-23 04:06:53',NULL,NULL),(14204,2365,'2040900','834','00','005010X220A1','2040900','','2014-01-10','14:53:07',0,'2014-01-13 02:23:46',NULL,NULL),(13815,2298,'2090578','834','00','005010X220A1','2090578','','2014-01-10','18:51:45',0,'2014-01-13 02:18:26',NULL,NULL),(12851,1705,'2264376','834','00','005010X220A1','2264376','','2014-01-03','17:58:35',0,'2014-01-04 02:03:05',NULL,NULL),(7439,1295,'1444332','834','00','005010X220A1','1444332','','2013-12-21','17:38:18',0,'2013-12-26 04:32:05',NULL,NULL),(6443,1207,'546232','834','00','005010X220A1','546232','','2013-11-22','17:48:36',0,'2013-12-26 03:15:52',NULL,NULL),(21018,3967,'2782882','834','00','005010X220A1','2782882','','2014-02-22','11:47:25',0,'2014-02-26 08:30:53',NULL,NULL),(19471,3620,'2805564','834','00','005010X220A1','2805564','','2014-02-13','19:25:28',0,'2014-02-14 21:30:05',NULL,NULL),(3131,551,'163614','834','00','005010X220A1','163614','','2013-12-13','11:56:48',0,'2013-12-25 21:37:08',NULL,NULL),(3646,624,'1045566','834','00','005010X220A1','1045566','','2013-12-11','21:23:31',0,'2013-12-25 22:05:47',NULL,NULL),(3829,677,'192346','834','00','005010X220A1','192346','','2013-12-08','16:54:47',0,'2013-12-25 22:17:25',NULL,NULL),(4538,824,'1566228','834','00','005010X220A1','1566228','','2013-12-24','01:10:52',0,'2013-12-25 23:45:16',NULL,NULL),(21636,4070,'2850682','834','00','005010X220A1','2850682','','2014-02-27','10:37:23',0,'2014-02-28 07:30:29',NULL,NULL),(22507,4247,'3128334','834','00','005010X220A1','3128334','','2014-03-05','09:46:04',0,'2014-03-05 21:30:12',NULL,NULL),(218,29,'1027044','834','00','005010X220A1','1027044','','2013-12-05','14:42:15',0,'2013-12-25 17:21:53',NULL,NULL),(7496,1300,'1121247','834','00','005010X220A1','1121247','','2013-12-20','20:47:39',0,'2013-12-26 04:33:54',NULL,NULL),(16662,3060,'2446846','834','00','005010X220A1','2446846','','2014-01-27','15:09:26',0,'2014-01-27 21:00:19',NULL,NULL),(12046,1584,'1379439','834','00','005010X220A1','1379439','','2013-12-29','19:13:37',0,'2014-01-01 12:03:49',NULL,NULL),(23329,4384,'3260488','834','00','005010X220A1','3260488','','2014-03-07','19:31:12',0,'2014-03-08 21:30:43',NULL,NULL),(5591,1043,'1601183','834','00','005010X220A1','1601183','','2013-12-25','00:20:57',0,'2013-12-26 01:49:23',NULL,NULL),(19146,3549,'3035295','834','00','005010X220A1','3035295','','2014-02-12','18:01:46',0,'2014-02-12 21:32:06',NULL,NULL),(1624,281,'716553','834','00','005010X220A1','716553','','2013-11-19','23:04:58',0,'2013-12-25 19:01:48',NULL,NULL),(17830,3279,'2247742','834','00','005010X220A1','2247742','','2014-02-04','13:57:50',0,'2014-02-04 21:01:54',NULL,NULL),(3579,617,'584169','834','00','005010X220A1','584169','','2013-12-12','11:19:39',0,'2013-12-25 22:03:42',NULL,NULL),(3160,562,'371787','834','00','005010X220A1','371787','','2013-12-13','10:43:25',0,'2013-12-25 21:38:06',NULL,NULL),(12463,1639,'1592577','834','00','005010X220A1','1592577','','2013-12-31','15:28:16',1,'2014-01-02 04:31:58',NULL,NULL),(12134,1588,'1941996','834','00','005010X220A1','1941996','','2013-12-30','08:37:08',0,'2014-01-01 12:06:53',NULL,NULL),(12004,1582,'1284039','834','00','005010X220A1','1284039','','2013-12-29','19:01:30',0,'2014-01-01 12:02:12',NULL,NULL),(10764,1404,'324970','834','00','005010X220A1','324970','','2013-12-22','20:00:13',0,'2013-12-26 13:02:44',NULL,NULL),(21584,4056,'3422676','834','00','005010X220A1','3422676','','2014-02-26','13:08:35',0,'2014-02-28 07:00:26',NULL,NULL),(23330,4384,'3199827','834','00','005010X220A1','3199827','','2014-03-07','19:39:15',0,'2014-03-08 21:30:43',NULL,NULL),(6166,1167,'410750','834','00','005010X220A1','410750','','2013-12-20','14:12:56',0,'2013-12-26 03:03:18',NULL,NULL),(5255,967,'204878','834','00','005010X220A1','204878','','2013-12-11','15:57:06',0,'2013-12-26 00:54:13',NULL,NULL),(20173,3777,'2209833','834','00','005010X220A1','2209833','','2014-02-19','14:41:41',0,'2014-02-20 04:10:45',NULL,NULL),(19345,3583,'3315674','834','00','005010X220A1','3315674','','2014-02-13','16:23:09',0,'2014-02-13 22:01:48',NULL,NULL),(4594,826,'1820862','834','00','005010X220A1','1820862','','2013-12-23','23:32:25',0,'2013-12-25 23:47:06',NULL,NULL),(13718,2275,'1705330','834','00','005010X220A1','1705330','','2014-01-07','14:33:02',0,'2014-01-08 18:24:37',NULL,NULL),(14738,2550,'2415516','834','00','005010X220A1','2415516','','2014-01-14','15:27:43',0,'2014-01-15 02:06:18',NULL,NULL),(16008,2767,'1453862','834','00','005010X220A1','1453862','','2014-01-21','22:24:04',0,'2014-01-23 03:02:17',NULL,NULL),(15540,2654,'1537025','834','00','005010X220A1','1537025','','2014-01-16','20:46:27',0,'2014-01-20 08:05:41',NULL,NULL),(23348,4387,'3531385','834','00','005010X220A1','3531385','','2014-03-08','13:36:51',0,'2014-03-08 21:30:57',NULL,NULL),(3148,556,'1204122','834','00','005010X220A1','1204122','','2013-12-13','15:02:12',0,'2013-12-25 21:37:42',NULL,NULL),(21127,3994,'3102997','834','00','005010X220A1','3102997','','2014-02-26','16:42:17',0,'2014-02-26 21:00:27',NULL,NULL),(13249,2093,'0001','999','BE','005010X231A1','154309','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:09',NULL,NULL),(19624,3640,'3036597','834','00','005010X220A1','3036597','','2014-02-14','09:14:46',0,'2014-02-14 21:31:55',NULL,NULL),(13264,2108,'0001','999','BE','005010X231A1','399465','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:51',NULL,NULL),(19175,3563,'2082092','834','00','005010X220A1','2082092','','2014-02-12','14:27:06',0,'2014-02-12 21:32:28',NULL,NULL),(18534,3451,'2339093','834','00','005010X220A1','2339093','','2014-02-10','14:26:52',0,'2014-02-10 21:30:18',NULL,NULL),(16760,3069,'2571208','834','00','005010X220A1','2571208','','2014-01-27','14:40:38',0,'2014-01-27 21:01:25',NULL,NULL),(2984,542,'656883','834','00','005010X220A1','656883','','2013-12-13','00:18:00',0,'2013-12-25 21:32:38',NULL,NULL),(21552,4046,'3482906','834','00','005010X220A1','3482906','','2014-02-27','17:11:25',0,'2014-02-28 06:31:45',NULL,NULL),(20692,3889,'3534870','834','00','005010X220A1','3534870','','2014-02-22','15:29:34',0,'2014-02-22 19:00:13',NULL,NULL),(20662,3877,'2539734','834','00','005010X220A1','2539734','','2014-02-21','15:12:51',0,'2014-02-21 22:01:01',NULL,NULL),(20275,3796,'2334948','834','00','005010X220A1','2334948','','2014-02-19','00:11:09',0,'2014-02-20 04:36:38',NULL,NULL),(19936,3734,'3439601','834','00','005010X220A1','3439601','','2014-02-18','15:29:02',0,'2014-02-18 21:30:08',NULL,NULL),(19663,3653,'3049590','834','00','005010X220A1','3049590','','2014-02-14','17:08:19',0,'2014-02-14 21:32:24',NULL,NULL),(19334,3583,'2919897','834','00','005010X220A1','2919897','','2014-02-13','14:01:05',0,'2014-02-13 22:01:39',NULL,NULL),(18917,3514,'2463894','834','00','005010X220A1','2463894','','2014-02-11','15:59:24',0,'2014-02-11 21:02:51',NULL,NULL),(10991,1413,'920068','834','00','005010X220A1','920068','','2013-12-23','12:29:19',0,'2013-12-26 13:10:27',NULL,NULL),(11013,1414,'1001322','834','00','005010X220A1','1001322','','2013-12-23','11:07:34',0,'2013-12-26 13:11:13',NULL,NULL),(15996,2766,'2508607','834','00','005010X220A1','2508607','','2014-01-21','19:17:24',0,'2014-01-23 03:02:11',NULL,NULL),(14647,2530,'1453587','834','00','005010X220A1','1453587','','2014-01-13','12:08:50',0,'2014-01-14 01:33:36',NULL,NULL),(21879,4122,'2841227','834','00','005010X220A1','2841227','','2014-03-01','16:41:53',0,'2014-03-01 21:00:16',NULL,NULL),(22756,4276,'3166742','834','00','005010X220A1','3166742','','2014-03-06','15:15:05',0,'2014-03-06 21:00:34',NULL,NULL),(7713,1334,'521957','834','00','005010X220A1','521957','','2013-11-15','09:46:07',0,'2013-12-26 04:45:55',NULL,NULL),(16160,2852,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:35:00',1,'2014-01-23 04:10:00',NULL,NULL),(17575,3236,'1451705','834','00','005010X220A1','1451705','','2014-02-03','16:59:23',0,'2014-02-03 21:00:41',NULL,NULL),(20342,3804,'3499759','834','00','005010X220A1','3499759','','2014-02-19','17:15:41',0,'2014-02-20 04:53:08',NULL,NULL),(1557,271,'1366145','834','00','005010X220A1','1366145','','2013-12-24','13:44:14',0,'2013-12-25 18:59:13',NULL,NULL),(3165,564,'247791','834','00','005010X220A1','247791','','2013-12-13','10:48:23',0,'2013-12-25 21:38:15',NULL,NULL),(7746,1344,'623433','834','00','005010X220A1','623433','','2013-10-20','20:15:21',0,'2013-12-26 05:00:43',NULL,NULL),(16336,2983,'1581026','834','00','005010X220A1','1581026','','2014-01-23','13:09:42',0,'2014-01-23 21:00:39',NULL,NULL),(4745,857,'51846','834','00','005010X220A1','51846','','2013-12-01','09:37:41',0,'2013-12-26 00:00:06',NULL,NULL),(15990,2765,'1667969','834','00','005010X220A1','1667969','','2014-01-22','14:52:46',0,'2014-01-23 03:02:08',NULL,NULL),(21301,4008,'3518745','834','00','005010X220A1','3518745','','2014-02-26','12:18:22',0,'2014-02-26 21:02:25',NULL,NULL),(22499,4247,'2644038','834','00','005010X220A1','2644038','','2014-03-04','18:06:16',0,'2014-03-05 21:30:06',NULL,NULL),(23321,4383,'3376645','834','00','005010X220A1','3376645','','2014-03-07','18:28:29',0,'2014-03-08 21:30:37',NULL,NULL),(23344,4386,'3486734','834','00','005010X220A1','3486734','','2014-03-08','14:47:45',0,'2014-03-08 21:30:53',NULL,NULL),(23479,4423,'3816938','834','00','005010X220A1','3816938','','2014-03-09','15:04:11',0,'2014-03-09 21:01:17',NULL,NULL),(278,60,'282001','834','00','005010X220A1','282001','','2013-11-08','20:09:21',0,'2013-12-25 17:31:54',NULL,NULL),(17271,3170,'1652110','834','00','005010X220A1','1652110','','2014-01-31','13:59:18',0,'2014-01-31 21:00:21',NULL,NULL),(16957,3116,'2291629','834','00','005010X220A1','2291629','','2014-01-28','22:38:00',0,'2014-01-29 21:00:27',NULL,NULL),(16186,2878,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:01:00',1,'2014-01-23 04:26:58',NULL,NULL),(15977,2764,'2521207','834','00','005010X220A1','2521207','','2014-01-22','17:08:46',0,'2014-01-23 03:02:02',NULL,NULL),(10746,1403,'876601','834','00','005010X220A1','876601','','2013-12-23','17:05:40',0,'2013-12-26 13:02:05',NULL,NULL),(14213,2365,'1722262','834','00','005010X220A1','1722262','','2014-01-10','18:08:27',0,'2014-01-13 02:23:52',NULL,NULL),(4924,910,'594246','834','00','005010X220A1','594246','','2013-10-16','20:32:00',0,'2013-12-26 00:30:56',NULL,NULL),(20640,3874,'3686745','834','00','005010X220A1','3686745','','2014-02-21','13:08:12',0,'2014-02-21 22:00:45',NULL,NULL),(21929,4128,'2749778','834','00','005010X220A1','2749778','','2014-03-01','15:16:20',0,'2014-03-01 21:00:48',NULL,NULL),(1347,245,'1000061','834','00','005010X220A1','1000061','','2013-12-24','13:08:06',0,'2013-12-25 18:52:19',NULL,NULL),(5724,1069,'993041','834','00','005010X220A1','993041','','2013-12-14','13:15:22',0,'2013-12-26 02:01:08',NULL,NULL),(15606,2663,'1679413','834','00','005010X220A1','1679413','','2014-01-17','15:56:56',0,'2014-01-20 08:06:30',NULL,NULL),(33,1,'1004162','834','00','005010X220A1','1004162','','2013-12-05','12:56:34',0,'2013-12-25 17:15:58',NULL,NULL),(12411,1637,'2151612','834','00','005010X220A1','2151612','','2013-12-31','18:20:46',1,'2014-01-02 04:30:03',NULL,NULL),(19199,3573,'2217423','834','00','005010X220A1','2217423','','2014-02-13','07:27:11',0,'2014-02-13 21:30:11',NULL,NULL),(11032,1418,'859553','834','00','005010X220A1','859553','','2013-12-22','20:32:38',0,'2013-12-26 13:11:53',NULL,NULL),(3476,615,'999339','834','00','005010X220A1','999339','','2013-12-12','07:50:20',0,'2013-12-25 22:00:25',NULL,NULL),(3124,549,'53323','834','00','005010X220A1','53323','','2013-12-12','18:52:54',0,'2013-12-25 21:36:55',NULL,NULL),(22898,4284,'2675520','834','00','005010X220A1','2675520','','2014-03-06','15:37:01',0,'2014-03-06 21:02:13',NULL,NULL),(3645,624,'565952','834','00','005010X220A1','565952','','2013-12-11','21:23:31',0,'2013-12-25 22:05:46',NULL,NULL),(18093,3326,'2146438','834','00','005010X220A1','2146438','','2014-02-06','11:38:36',0,'2014-02-06 21:01:11',NULL,NULL),(17465,3216,'2038851','834','00','005010X220A1','2038851','','2014-02-01','18:39:49',0,'2014-02-02 19:00:03',NULL,NULL),(17014,3119,'2185893','834','00','005010X220A1','2185893','','2014-01-29','10:48:21',0,'2014-01-29 21:01:02',NULL,NULL),(4793,865,'212515','834','00','005010X220A1','212515','','2013-12-01','16:32:50',0,'2013-12-26 00:01:41',NULL,NULL),(15549,2655,'2220629','834','00','005010X220A1','2220629','','2014-01-17','13:47:23',0,'2014-01-20 08:05:47',NULL,NULL),(11162,1440,'540186','834','00','005010X220A1','540186','','2013-12-23','14:32:55',0,'2013-12-26 13:16:22',NULL,NULL),(5092,940,'1138174','834','00','005010X220A1','1138174','','2013-12-10','19:29:05',0,'2013-12-26 00:48:56',NULL,NULL),(11939,1575,'703996','834','00','005010X220A1','703996','','2013-12-29','13:07:14',0,'2013-12-30 00:02:16',NULL,NULL),(21526,4037,'2575825','834','00','005010X220A1','2575825','','2014-02-27','09:49:24',0,'2014-02-28 06:31:34',NULL,NULL),(21698,4087,'3291569','834','00','005010X220A1','3291569','','2014-02-28','13:38:08',0,'2014-02-28 21:30:10',NULL,NULL),(15198,2592,'1427819','834','00','005010X220A1','1427819','','2014-01-15','14:58:43',0,'2014-01-16 08:46:24',NULL,NULL),(15985,2764,'2512537','834','00','005010X220A1','2512537','','2014-01-22','15:25:50',0,'2014-01-23 03:02:06',NULL,NULL),(18665,3467,'2037548','834','00','005010X220A1','2037548','','2014-02-10','11:45:15',0,'2014-02-10 21:31:49',NULL,NULL),(3834,679,'1176743','834','00','005010X220A1','1176743','','2013-11-07','19:23:19',0,'2013-12-25 22:30:05',NULL,NULL),(16617,3050,'1806294','834','00','005010X220A1','1806294','','2014-01-25','19:38:44',0,'2014-01-26 19:00:15',NULL,NULL),(3408,591,'452568','834','00','005010X220A1','452568','','2013-12-16','21:05:41',0,'2013-12-25 21:51:56',NULL,NULL),(17645,3250,'1873340','834','00','005010X220A1','1873340','','2014-02-03','11:44:52',0,'2014-02-03 21:01:27',NULL,NULL),(13379,2221,'1365239','834','00','005010X220A1','1365239','','2014-01-06','12:54:05',0,'2014-01-07 04:00:07',NULL,NULL),(20003,3748,'2695067','834','00','005010X220A1','2695067','','2014-02-18','13:53:17',0,'2014-02-18 22:00:35',NULL,NULL),(20491,3845,'3332753','834','00','005010X220A1','3332753','','2014-02-19','20:52:34',0,'2014-02-20 22:00:57',NULL,NULL),(12329,1634,'1911108','834','00','005010X220A1','1911108','','2013-12-31','01:26:32',1,'2014-01-02 04:27:09',NULL,NULL),(12107,1587,'2068873','834','00','005010X220A1','2068873','','2013-12-30','12:04:20',0,'2014-01-01 12:05:57',NULL,NULL),(19636,3643,'2992651','834','00','005010X220A1','2992651','','2014-02-14','13:09:32',0,'2014-02-14 21:32:04',NULL,NULL),(15195,2592,'2338491','834','00','005010X220A1','2338491','','2014-01-15','12:12:37',0,'2014-01-16 08:46:22',NULL,NULL),(15456,2632,'2029112','834','00','005010X220A1','2029112','','2014-01-16','12:11:34',0,'2014-01-17 03:36:12',NULL,NULL),(17069,3127,'1765966','834','00','005010X220A1','1765966','','2014-01-29','10:05:19',0,'2014-01-29 21:01:38',NULL,NULL),(17700,3261,'2049119','834','00','005010X220A1','2049119','','2014-02-03','20:21:26',0,'2014-02-04 21:00:30',NULL,NULL),(5572,1043,'385257','834','00','005010X220A1','385257','','2013-12-24','20:37:57',0,'2013-12-26 01:48:44',NULL,NULL),(3305,584,'956768','834','00','005010X220A1','956768','','2013-12-17','12:46:21',0,'2013-12-25 21:48:39',NULL,NULL),(21635,4070,'2889830','834','00','005010X220A1','2889830','','2014-02-27','10:37:23',0,'2014-02-28 07:30:29',NULL,NULL),(22404,4214,'3718563','834','00','005010X220A1','3718563','','2014-03-04','13:02:12',0,'2014-03-04 21:02:23',NULL,NULL),(14371,2404,'2058645','834','00','005010X220A1','2058645','','2014-01-12','17:40:12',0,'2014-01-13 03:01:41',NULL,NULL),(2035,331,'496388','834','00','005010X220A1','496388','','2013-12-09','17:34:31',0,'2013-12-25 19:35:57',NULL,NULL),(10481,1400,'1748437','834','00','005010X220A1','1748437','','2013-12-23','15:55:38',0,'2013-12-26 12:53:17',NULL,NULL),(19444,3603,'2780226','834','00','005010X220A1','2780226','','2014-02-13','17:10:35',0,'2014-02-13 22:03:03',NULL,NULL),(2636,498,'625056','834','00','005010X220A1','625056','','2013-11-27','19:49:01',0,'2013-12-25 20:47:09',NULL,NULL),(2937,541,'458877','834','00','005010X220A1','458877','','2013-12-12','21:09:06',0,'2013-12-25 21:31:09',NULL,NULL),(22763,4276,'3471792','834','00','005010X220A1','3471792','','2014-03-06','17:40:16',0,'2014-03-06 21:00:39',NULL,NULL),(23232,4360,'3237487','834','00','005010X220A1','3237487','','2014-03-07','13:29:17',0,'2014-03-07 21:32:09',NULL,NULL),(14437,2458,'0001','999','BE','005010X231A1','911391','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:09',NULL,NULL),(16117,2809,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:34:00',1,'2014-01-23 03:45:04',NULL,NULL),(18479,3430,'1736885','834','00','005010X220A1','1736885','','2014-02-10','04:29:05',0,'2014-02-10 11:00:59',NULL,NULL),(18356,3402,'1661132','834','00','005010X220A1','1661132','','2014-02-09','13:03:40',0,'2014-02-09 19:00:06',NULL,NULL),(6342,1177,'829725','834','00','005010X220A1','829725','','2013-12-19','20:48:12',0,'2013-12-26 03:08:40',NULL,NULL),(16345,2983,'2250992','834','00','005010X220A1','2250992','','2014-01-23','14:27:12',0,'2014-01-23 21:00:45',NULL,NULL),(10366,1400,'335918','834','00','005010X220A1','335918','','2013-12-22','18:32:41',0,'2013-12-26 12:49:40',NULL,NULL),(16739,3065,'2408205','834','00','005010X220A1','2408205','','2014-01-27','15:39:53',0,'2014-01-27 21:01:09',NULL,NULL),(11288,1455,'1289397','834','00','005010X220A1','1289397','','2013-12-26','15:29:29',0,'2013-12-27 02:03:08',NULL,NULL),(11439,1482,'2247827','834','00','005010X220A1','2247827','','2013-12-26','15:09:56',0,'2013-12-27 02:07:49',NULL,NULL),(12600,1671,'1916773','834','00','005010X220A1','1916773','','2014-01-02','14:48:05',0,'2014-01-03 02:01:05',NULL,NULL),(13372,2216,'0001','999','BE','005010X231A1','8664','834','2013-12-27','16:55:00',0,'2014-01-05 17:27:32',NULL,NULL),(20324,3796,'3179072','834','00','005010X220A1','3179072','','2014-02-19','15:26:36',0,'2014-02-20 04:49:01',NULL,NULL),(20734,3903,'3708382','834','00','005010X220A1','3708382','','2014-02-24','21:12:13',0,'2014-02-25 21:30:05',NULL,NULL),(21246,3999,'3377643','834','00','005010X220A1','3377643','','2014-02-26','13:32:55',0,'2014-02-26 21:01:46',NULL,NULL),(22443,4231,'3363570','834','00','005010X220A1','3363570','','2014-03-03','20:29:16',0,'2014-03-04 21:30:11',NULL,NULL),(22628,4252,'2622189','834','00','005010X220A1','2622189','','2014-03-05','13:12:52',0,'2014-03-05 21:31:38',NULL,NULL),(22755,4276,'3814236','834','00','005010X220A1','3814236','','2014-03-06','14:13:13',0,'2014-03-06 21:00:33',NULL,NULL),(1382,245,'1967720','834','00','005010X220A1','1967720','','2013-12-24','16:38:55',0,'2013-12-25 18:53:25',NULL,NULL),(20021,3750,'2776722','834','00','005010X220A1','2776722','','2014-02-18','11:51:29',0,'2014-02-18 22:00:47',NULL,NULL),(19277,3582,'3286343','834','00','005010X220A1','3286343','','2014-02-13','10:23:28',0,'2014-02-13 22:00:56',NULL,NULL),(1665,290,'345982','834','00','005010X220A1','345982','','2013-12-09','20:35:04',0,'2013-12-25 19:15:25',NULL,NULL),(18467,3428,'2099673','834','00','005010X220A1','2099673','','2014-02-10','03:52:41',0,'2014-02-10 11:00:49',NULL,NULL),(5374,1010,'1258687','834','00','005010X220A1','1258687','','2013-11-25','15:36:41',0,'2013-12-26 01:16:39',NULL,NULL),(2592,478,'798989','834','00','005010X220A1','798989','','2013-10-31','18:37:14',0,'2013-12-25 20:45:43',NULL,NULL),(16249,2941,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:52:00',0,'2014-01-23 07:05:50',NULL,NULL),(14679,2548,'1433046','834','00','005010X220A1','1433046','','2014-01-14','14:49:00',0,'2014-01-15 02:05:52',NULL,NULL),(3239,578,'480874','834','00','005010X220A1','480874','','2013-12-17','15:13:05',0,'2013-12-25 21:46:31',NULL,NULL),(2781,506,'197845','834','00','005010X220A1','197845','','2013-12-22','01:52:28',0,'2013-12-25 21:19:42',NULL,NULL),(22762,4276,'3059384','834','00','005010X220A1','3059384','','2014-03-06','17:02:50',0,'2014-03-06 21:00:38',NULL,NULL),(11612,1494,'1505543','834','00','005010X220A1','1505543','','2013-12-27','11:19:18',0,'2013-12-28 03:35:06',NULL,NULL),(15045,2584,'1680834','834','00','005010X220A1','1680834','','2014-01-15','18:07:22',0,'2014-01-16 08:44:46',NULL,NULL),(16440,3006,'1894167','834','00','005010X220A1','1894167','','2014-01-24','15:34:39',0,'2014-01-24 21:00:07',NULL,NULL),(20867,3915,'3507681','834','00','005010X220A1','3507681','','2014-02-24','19:53:00',0,'2014-02-25 21:31:43',NULL,NULL),(22437,4230,'3724440','834','00','005010X220A1','3724440','','2014-03-04','11:56:34',0,'2014-03-04 21:30:07',NULL,NULL),(23409,4404,'2948307','834','00','005010X220A1','2948307','','2014-03-09','10:57:53',0,'2014-03-09 21:00:18',NULL,NULL),(660,108,'1298951','834','00','005010X220A1','1298951','','2013-12-16','16:56:33',0,'2013-12-25 18:05:30',NULL,NULL),(18541,3452,'2173304','834','00','005010X220A1','2173304','','2014-02-09','22:07:26',0,'2014-02-10 21:30:23',NULL,NULL),(4981,935,'393522','834','00','005010X220A1','393522','','2013-12-10','20:12:55',0,'2013-12-26 00:45:22',NULL,NULL),(15282,2612,'2441509','834','00','005010X220A1','2441509','','2014-01-15','12:18:23',0,'2014-01-16 08:47:20',NULL,NULL),(843,175,'602136','834','00','005010X220A1','602136','','2013-12-03','09:01:27',0,'2013-12-25 18:15:26',NULL,NULL),(3591,617,'1009139','834','00','005010X220A1','1009139','','2013-12-12','16:00:02',0,'2013-12-25 22:04:04',NULL,NULL),(13642,2271,'2295287','834','00','005010X220A1','2295287','','2014-01-06','18:29:02',0,'2014-01-08 18:24:07',NULL,NULL),(12011,1583,'1990531','834','00','005010X220A1','1990531','','2013-12-30','06:09:09',0,'2014-01-01 12:02:31',NULL,NULL),(12034,1583,'2356208','834','00','005010X220A1','2356208','','2013-12-30','14:50:18',0,'2014-01-01 12:03:23',NULL,NULL),(21465,4028,'3013004','834','00','005010X220A1','3013004','','2014-02-27','12:01:40',0,'2014-02-28 06:31:05',NULL,NULL),(23109,4341,'3675513','834','00','005010X220A1','3675513','','2014-03-07','15:19:02',0,'2014-03-07 21:30:41',NULL,NULL),(23177,4345,'3171522','834','00','005010X220A1','3171522','','2014-03-06','22:53:31',0,'2014-03-07 21:31:29',NULL,NULL),(23283,4380,'3310368','834','00','005010X220A1','3310368','','2014-03-08','10:05:23',0,'2014-03-08 21:30:07',NULL,NULL),(5550,1043,'2073578','834','00','005010X220A1','2073578','','2013-12-24','18:28:54',0,'2013-12-26 01:48:02',NULL,NULL),(5490,1041,'1300904','834','00','005010X220A1','1300904','','2013-12-24','18:20:49',0,'2013-12-26 01:46:04',NULL,NULL),(3045,544,'575448','834','00','005010X220A1','575448','','2013-12-13','11:56:30',0,'2013-12-25 21:34:27',NULL,NULL),(10925,1410,'1019201','834','00','005010X220A1','1019201','','2013-12-23','11:09:37',0,'2013-12-26 13:08:29',NULL,NULL),(16571,3035,'1720383','834','00','005010X220A1','1720383','','2014-01-25','11:31:07',0,'2014-01-25 19:00:06',NULL,NULL),(11791,1537,'1636639','834','00','005010X220A1','1636639','','2013-12-28','20:15:56',1,'2013-12-29 11:12:50',NULL,NULL),(21093,3985,'3609305','834','00','005010X220A1','3609305','','2014-02-24','16:05:33',0,'2014-02-26 09:30:59',NULL,NULL),(22868,4280,'3043420','834','00','005010X220A1','3043420','','2014-03-06','16:49:16',0,'2014-03-06 21:01:52',NULL,NULL),(23336,4384,'3096011','834','00','005010X220A1','3096011','','2014-03-08','15:46:16',0,'2014-03-08 21:30:47',NULL,NULL),(23438,4406,'3180856','834','00','005010X220A1','3180856','','2014-03-09','14:04:08',0,'2014-03-09 21:00:40',NULL,NULL),(23708,4454,'3799214','834','00','005010X220A1','3799214','','2014-03-10','15:22:55',0,'2014-03-10 21:02:33',NULL,NULL),(1619,281,'424314','834','00','005010X220A1','424314','','2013-11-19','23:03:54',0,'2013-12-25 19:01:41',NULL,NULL),(22716,4270,'3500178','834','00','005010X220A1','3500178','','2014-03-05','13:59:17',0,'2014-03-05 21:32:40',NULL,NULL),(5393,1015,'773020','834','00','005010X220A1','773020','','2013-11-24','23:34:05',0,'2013-12-26 01:17:19',NULL,NULL),(6281,1172,'1165233','834','00','005010X220A1','1165233','','2013-12-20','15:17:05',0,'2013-12-26 03:06:52',NULL,NULL),(15143,2588,'1706530','834','00','005010X220A1','1706530','','2014-01-14','21:49:05',0,'2014-01-16 08:45:49',NULL,NULL),(19076,3542,'3116502','834','00','005010X220A1','3116502','','2014-02-12','10:50:34',0,'2014-02-12 21:31:22',NULL,NULL),(18590,3455,'2697282','834','00','005010X220A1','2697282','','2014-02-09','18:54:24',0,'2014-02-10 21:30:56',NULL,NULL),(18209,3356,'2918607','834','00','005010X220A1','2918607','','2014-02-06','21:05:38',0,'2014-02-07 19:00:40',NULL,NULL),(16001,2766,'2554598','834','00','005010X220A1','2554598','','2014-01-22','13:58:56',0,'2014-01-23 03:02:14',NULL,NULL),(15899,2741,'1498885','834','00','005010X220A1','1498885','','2014-01-21','17:17:54',1,'2014-01-22 03:22:40',NULL,NULL),(21245,3999,'3446287','834','00','005010X220A1','3446287','','2014-02-26','13:31:22',0,'2014-02-26 21:01:45',NULL,NULL),(21966,4143,'2860679','834','00','005010X220A1','2860679','','2014-03-01','19:45:56',0,'2014-03-03 01:00:05',NULL,NULL),(23316,4381,'3559707','834','00','005010X220A1','3559707','','2014-03-08','15:35:49',0,'2014-03-08 21:30:32',NULL,NULL),(23351,4388,'3660394','834','00','005010X220A1','3660394','','2014-03-08','16:39:35',0,'2014-03-08 21:30:59',NULL,NULL),(5732,1069,'223046','834','00','005010X220A1','223046','','2013-12-14','16:18:25',0,'2013-12-26 02:01:22',NULL,NULL),(4414,784,'396964','834','00','005010X220A1','396964','','2013-11-27','17:13:11',0,'2013-12-25 23:16:24',NULL,NULL),(888,177,'108075','834','00','005010X220A1','108075','','2013-12-03','10:14:55',0,'2013-12-25 18:16:47',NULL,NULL),(14210,2365,'2007835','834','00','005010X220A1','2007835','','2014-01-10','17:36:36',0,'2014-01-13 02:23:50',NULL,NULL),(16577,3037,'2000777','834','00','005010X220A1','2000777','','2014-01-25','13:22:22',0,'2014-01-25 19:00:10',NULL,NULL),(17558,3236,'2650172','834','00','005010X220A1','2650172','','2014-02-03','09:11:59',0,'2014-02-03 21:00:31',NULL,NULL),(16923,3114,'2338816','834','00','005010X220A1','2338816','','2014-01-29','10:56:39',0,'2014-01-29 21:00:06',NULL,NULL),(23510,4434,'2779775','834','00','005010X220A1','2779775','','2014-03-10','12:41:36',0,'2014-03-10 21:00:10',NULL,NULL),(1031,195,'1159432','834','00','005010X220A1','1159432','','2013-12-03','11:38:01',0,'2013-12-25 18:21:13',NULL,NULL),(2763,505,'1158999','834','00','005010X220A1','1158999','','2013-12-22','14:47:23',0,'2013-12-25 21:19:08',NULL,NULL),(13079,1923,'0001','999','BE','005010X231A1','318898','834','2013-12-27','16:55:00',0,'2014-01-05 16:52:40',NULL,NULL),(13251,2095,'0001','999','BE','005010X231A1','1267879','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:14',NULL,NULL),(17063,3125,'2599403','834','00','005010X220A1','2599403','','2014-01-29','17:08:39',0,'2014-01-29 21:01:35',NULL,NULL),(3,1,'668212','834','00','005010X220A1','668212','','2013-12-04','20:17:38',0,'2013-12-25 17:15:06',NULL,NULL),(5623,1045,'650935','834','00','005010X220A1','650935','','2013-12-24','23:45:48',0,'2013-12-26 01:50:28',NULL,NULL),(19980,3746,'3275028','834','00','005010X220A1','3275028','','2014-02-18','15:21:48',0,'2014-02-18 22:00:19',NULL,NULL),(16343,2983,'2142417','834','00','005010X220A1','2142417','','2014-01-22','23:07:30',0,'2014-01-23 21:00:44',NULL,NULL),(15919,2743,'1862697','834','00','005010X220A1','1862697','','2014-01-21','12:51:15',1,'2014-01-22 03:22:53',NULL,NULL),(4656,829,'959852','834','00','005010X220A1','959852','','2013-12-24','00:17:43',0,'2013-12-25 23:49:08',NULL,NULL),(4137,733,'1075737','834','00','005010X220A1','1075737','','2013-12-19','15:56:54',0,'2013-12-25 23:04:18',NULL,NULL),(10737,1403,'1137555','834','00','005010X220A1','1137555','','2013-12-23','15:20:40',0,'2013-12-26 13:01:47',NULL,NULL),(7069,1236,'383666','834','00','005010X220A1','383666','','2013-12-17','23:42:15',0,'2013-12-26 04:02:37',NULL,NULL),(2109,360,'1169549','834','00','005010X220A1','1169549','','2013-12-01','19:57:46',0,'2013-12-25 19:45:12',NULL,NULL),(20136,3772,'2736387','834','00','005010X220A1','2736387','','2014-02-19','16:54:00',0,'2014-02-20 04:00:19',NULL,NULL),(6150,1166,'1245835','834','00','005010X220A1','1245835','','2013-12-20','18:46:11',0,'2013-12-26 03:02:50',NULL,NULL),(16619,3050,'2495371','834','00','005010X220A1','2495371','','2014-01-25','22:20:13',0,'2014-01-26 19:00:16',NULL,NULL),(16170,2862,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:17:00',1,'2014-01-23 04:17:26',NULL,NULL),(2368,413,'717888','834','00','005010X220A1','717888','','2013-12-06','12:36:13',0,'2013-12-25 20:16:17',NULL,NULL),(4096,733,'32966','834','00','005010X220A1','32966','','2013-12-19','10:49:06',0,'2013-12-25 23:03:09',NULL,NULL),(12407,1637,'1593872','834','00','005010X220A1','1593872','','2013-12-31','14:43:48',1,'2014-01-02 04:29:51',NULL,NULL),(21197,3998,'2949266','834','00','005010X220A1','2949266','','2014-02-26','14:50:04',0,'2014-02-26 21:01:14',NULL,NULL),(21470,4028,'3225040','834','00','005010X220A1','3225040','','2014-02-27','13:50:13',0,'2014-02-28 06:31:08',NULL,NULL),(2821,508,'215658','834','00','005010X220A1','215658','','2013-12-21','19:53:17',0,'2013-12-25 21:21:00',NULL,NULL),(20880,3920,'3179201','834','00','005010X220A1','3179201','','2014-02-25','12:46:06',0,'2014-02-25 21:31:54',NULL,NULL),(5511,1041,'1952505','834','00','005010X220A1','1952505','','2013-12-24','20:25:10',0,'2013-12-26 01:46:46',NULL,NULL),(19905,3720,'3228499','834','00','005010X220A1','3228499','','2014-02-16','14:49:12',0,'2014-02-16 19:00:43',NULL,NULL),(5106,940,'1274964','834','00','005010X220A1','1274964','','2013-12-11','16:31:21',0,'2013-12-26 00:49:21',NULL,NULL),(19053,3542,'2488225','834','00','005010X220A1','2488225','','2014-02-11','19:43:44',0,'2014-02-12 21:31:03',NULL,NULL),(3626,622,'741993','834','00','005010X220A1','741993','','2013-12-11','19:22:27',0,'2013-12-25 22:05:09',NULL,NULL),(4244,739,'433059','834','00','005010X220A1','433059','','2013-12-19','14:38:22',0,'2013-12-25 23:07:37',NULL,NULL),(10938,1410,'108936','834','00','005010X220A1','108936','','2013-12-23','13:42:20',0,'2013-12-26 13:08:52',NULL,NULL),(22678,4255,'3839978','834','00','005010X220A1','3839978','','2014-03-05','14:29:46',0,'2014-03-05 21:32:12',NULL,NULL),(2774,506,'930373','834','00','005010X220A1','930373','','2013-12-21','21:50:29',0,'2013-12-25 21:19:28',NULL,NULL),(7749,1344,'921739','834','00','005010X220A1','921739','','2013-10-21','12:15:52',0,'2013-12-26 05:00:48',NULL,NULL),(13337,2181,'0001','999','BE','005010X231A1','1129316','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:55',NULL,NULL),(19126,3547,'2656537','834','00','005010X220A1','2656537','','2014-02-11','20:59:52',0,'2014-02-12 21:31:54',NULL,NULL),(21693,4087,'3330565','834','00','005010X220A1','3330565','','2014-02-27','19:52:48',0,'2014-02-28 21:30:05',NULL,NULL),(3263,579,'317023','834','00','005010X220A1','317023','','2013-12-17','16:38:34',0,'2013-12-25 21:47:15',NULL,NULL),(20490,3845,'2469427','834','00','005010X220A1','2469427','','2014-02-19','19:30:36',0,'2014-02-20 22:00:56',NULL,NULL),(20235,3790,'2359973','834','00','005010X220A1','2359973','','2014-02-19','10:40:44',0,'2014-02-20 04:28:19',NULL,NULL),(19221,3580,'3233176','834','00','005010X220A1','3233176','','2014-02-12','23:40:02',0,'2014-02-13 22:00:10',NULL,NULL),(5011,935,'893173','834','00','005010X220A1','893173','','2013-12-11','11:05:05',0,'2013-12-26 00:46:20',NULL,NULL),(4337,755,'914560','834','00','005010X220A1','914560','','2013-12-19','17:11:16',0,'2013-12-25 23:10:21',NULL,NULL),(11107,1425,'51443','834','00','005010X220A1','51443','','2013-12-23','18:37:38',0,'2013-12-26 13:14:19',NULL,NULL),(11883,1560,'1826641','834','00','005010X220A1','1826641','','2013-12-29','15:20:04',0,'2013-12-30 00:00:30',NULL,NULL),(23730,4463,'3287144','834','00','005010X220A1','3287144','','2014-03-10','14:54:51',0,'2014-03-10 21:02:52',NULL,NULL),(241,42,'340398','834','00','005010X220A1','340398','','2013-11-12','20:10:05',0,'2013-12-25 17:30:34',NULL,NULL),(760,140,'785439','834','00','005010X220A1','785439','','2013-12-16','15:06:36',0,'2013-12-25 18:08:38',NULL,NULL),(4947,921,'1241588','834','00','005010X220A1','1241588','','2013-11-19','13:48:59',0,'2013-12-26 00:31:42',NULL,NULL),(4269,742,'75711','834','00','005010X220A1','75711','','2013-12-19','15:57:36',0,'2013-12-25 23:08:22',NULL,NULL),(12687,1673,'1961418','834','00','005010X220A1','1961418','','2014-01-02','17:12:12',0,'2014-01-03 02:04:13',NULL,NULL),(20832,3911,'2748146','834','00','005010X220A1','2748146','','2014-02-25','00:53:27',0,'2014-02-25 21:31:17',NULL,NULL),(21275,4001,'3364530','834','00','005010X220A1','3364530','','2014-02-26','17:10:46',0,'2014-02-26 21:02:06',NULL,NULL),(22922,4289,'3090874','834','00','005010X220A1','3090874','','2014-03-06','09:10:51',0,'2014-03-06 21:02:32',NULL,NULL),(11607,1493,'1745141','834','00','005010X220A1','1745141','','2013-12-27','15:59:52',0,'2013-12-28 03:34:56',NULL,NULL),(18670,3467,'3015251','834','00','005010X220A1','3015251','','2014-02-10','13:01:55',0,'2014-02-10 21:31:52',NULL,NULL),(6017,1136,'458447','834','00','005010X220A1','458447','','2013-11-17','15:05:37',0,'2013-12-26 02:45:27',NULL,NULL),(17896,3295,'1368324','834','00','005010X220A1','1368324','','2014-02-05','10:33:19',0,'2014-02-05 21:30:29',NULL,NULL),(13966,2322,'2433731','834','00','005010X220A1','2433731','','2014-01-09','11:13:55',0,'2014-01-13 02:20:32',NULL,NULL),(21723,4088,'3272757','834','00','005010X220A1','3272757','','2014-02-28','13:34:14',0,'2014-02-28 21:30:29',NULL,NULL),(1301,244,'2092645','834','00','005010X220A1','2092645','','2013-12-24','16:12:27',0,'2013-12-25 18:50:50',NULL,NULL),(3428,596,'729185','834','00','005010X220A1','729185','','2013-12-17','14:32:00',0,'2013-12-25 21:52:34',NULL,NULL),(16100,2792,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 03:41:22',NULL,NULL),(15366,2624,'2065826','834','00','005010X220A1','2065826','','2014-01-15','21:19:48',0,'2014-01-17 03:35:30',NULL,NULL),(5978,1121,'818386','834','00','005010X220A1','818386','','2013-12-14','21:41:43',0,'2013-12-26 02:33:17',NULL,NULL),(20093,3765,'3562810','834','00','005010X220A1','3562810','','2014-02-18','17:12:31',0,'2014-02-18 22:01:40',NULL,NULL),(21613,4065,'2626940','834','00','005010X220A1','2626940','','2014-02-27','07:41:50',0,'2014-02-28 07:30:15',NULL,NULL),(21883,4123,'2680034','834','00','005010X220A1','2680034','','2014-03-01','12:14:45',0,'2014-03-01 21:00:18',NULL,NULL),(23697,4451,'3094883','834','00','005010X220A1','3094883','','2014-03-10','09:00:32',0,'2014-03-10 21:02:26',NULL,NULL),(13315,2159,'0001','999','BE','005010X231A1','341749','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:53',NULL,NULL),(13152,1996,'0001','999','BE','005010X231A1','750299','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:38',NULL,NULL),(16564,3034,'1977546','834','00','005010X220A1','1977546','','2014-01-25','10:47:08',0,'2014-01-25 19:00:03',NULL,NULL),(14203,2365,'2101628','834','00','005010X220A1','2101628','','2014-01-10','14:49:28',0,'2014-01-13 02:23:46',NULL,NULL),(2350,413,'697127','834','00','005010X220A1','697127','','2013-12-06','14:10:15',0,'2013-12-25 20:15:38',NULL,NULL),(2517,450,'1165531','834','00','005010X220A1','1165531','','2013-10-13','13:05:24',0,'2013-12-25 20:30:32',NULL,NULL),(19665,3654,'2894328','834','00','005010X220A1','2894328','','2014-02-14','15:03:43',0,'2014-02-14 21:32:25',NULL,NULL),(21549,4045,'3447658','834','00','005010X220A1','3447658','','2014-02-27','11:47:03',0,'2014-02-28 06:31:44',NULL,NULL),(23341,4386,'3102226','834','00','005010X220A1','3102226','','2014-03-07','21:05:06',0,'2014-03-08 21:30:51',NULL,NULL),(73,3,'985195','834','00','005010X220A1','985195','','2013-12-05','12:40:31',0,'2013-12-25 17:17:13',NULL,NULL),(18993,3538,'2688493','834','00','005010X220A1','2688493','','2014-02-11','18:57:00',0,'2014-02-12 21:30:21',NULL,NULL),(12435,1638,'1408259','834','00','005010X220A1','1408259','','2013-12-31','14:41:48',1,'2014-01-02 04:30:56',NULL,NULL),(16498,3011,'1873134','834','00','005010X220A1','1873134','','2014-01-24','09:46:41',0,'2014-01-24 21:00:40',NULL,NULL),(16449,3006,'2519066','834','00','005010X220A1','2519066','','2014-01-24','12:10:22',0,'2014-01-24 21:00:12',NULL,NULL),(15442,2630,'2052541','834','00','005010X220A1','2052541','','2014-01-15','18:47:16',0,'2014-01-17 03:36:06',NULL,NULL),(976,184,'64656','834','00','005010X220A1','64656','','2013-12-03','09:18:57',0,'2013-12-25 18:19:27',NULL,NULL),(2427,417,'608429','834','00','005010X220A1','608429','','2013-12-06','12:29:31',0,'2013-12-25 20:18:05',NULL,NULL),(5606,1044,'1861955','834','00','005010X220A1','1861955','','2013-12-24','20:42:57',0,'2013-12-26 01:49:50',NULL,NULL),(3169,564,'750549','834','00','005010X220A1','750549','','2013-12-13','16:02:42',0,'2013-12-25 21:38:25',NULL,NULL),(7602,1303,'639244','834','00','005010X220A1','639244','','2013-12-21','09:33:07',0,'2013-12-26 04:37:20',NULL,NULL),(4125,733,'527516','834','00','005010X220A1','527516','','2013-12-19','14:19:35',0,'2013-12-25 23:03:58',NULL,NULL),(14314,2393,'2403007','834','00','005010X220A1','2403007','','2014-01-10','14:33:34',0,'2014-01-13 03:00:39',NULL,NULL),(15562,2655,'2531174','834','00','005010X220A1','2531174','','2014-01-17','12:46:25',0,'2014-01-20 08:05:57',NULL,NULL),(696,112,'1303984','834','00','005010X220A1','1303984','','2013-12-16','14:35:09',0,'2013-12-25 18:06:37',NULL,NULL),(16495,3011,'2646530','834','00','005010X220A1','2646530','','2014-01-24','12:14:21',0,'2014-01-24 21:00:38',NULL,NULL),(6138,1166,'114855','834','00','005010X220A1','114855','','2013-12-20','16:21:09',0,'2013-12-26 03:02:28',NULL,NULL),(3932,714,'1062810','834','00','005010X220A1','1062810','','2013-12-06','18:48:44',0,'2013-12-25 22:45:59',NULL,NULL),(941,181,'240954','834','00','005010X220A1','240954','','2013-12-03','13:36:34',0,'2013-12-25 18:18:23',NULL,NULL),(7007,1235,'119891','834','00','005010X220A1','119891','','2013-12-17','22:02:26',0,'2013-12-26 04:00:43',NULL,NULL),(3563,617,'714045','834','00','005010X220A1','714045','','2013-12-11','20:19:40',0,'2013-12-25 22:03:14',NULL,NULL),(3420,594,'222147','834','00','005010X220A1','222147','','2013-12-16','22:35:55',0,'2013-12-25 21:52:20',NULL,NULL),(13693,2274,'2543847','834','00','005010X220A1','2543847','','2014-01-06','18:35:42',0,'2014-01-08 18:24:26',NULL,NULL),(12162,1593,'1733073','834','00','005010X220A1','1733073','','2013-12-30','14:35:08',0,'2014-01-01 12:07:50',NULL,NULL),(13392,2221,'2069043','834','00','005010X220A1','2069043','','2014-01-06','11:05:05',0,'2014-01-07 04:00:36',NULL,NULL),(11027,1416,'1231624','834','00','005010X220A1','1231624','','2013-12-23','15:05:28',0,'2013-12-26 13:11:42',NULL,NULL),(1703,292,'171870','834','00','005010X220A1','171870','','2013-12-09','23:47:47',0,'2013-12-25 19:16:35',NULL,NULL),(21167,3997,'3642824','834','00','005010X220A1','3642824','','2014-02-26','17:35:06',0,'2014-02-26 21:00:54',NULL,NULL),(22616,4251,'3589526','834','00','005010X220A1','3589526','','2014-03-05','10:25:27',0,'2014-03-05 21:31:30',NULL,NULL),(11269,1455,'1909540','834','00','005010X220A1','1909540','','2013-12-26','11:50:11',0,'2013-12-27 02:02:32',NULL,NULL),(6427,1203,'578605','834','00','005010X220A1','578605','','2013-11-22','14:32:36',0,'2013-12-26 03:15:22',NULL,NULL),(18846,3491,'3042664','834','00','005010X220A1','3042664','','2014-02-11','12:10:33',0,'2014-02-11 21:01:49',NULL,NULL),(14039,2337,'2279593','834','00','005010X220A1','2279593','','2014-01-08','15:48:49',0,'2014-01-13 02:21:30',NULL,NULL),(14319,2396,'1777117','834','00','005010X220A1','1777117','','2014-01-10','16:57:57',0,'2014-01-13 03:00:42',NULL,NULL),(5689,1067,'115884','834','00','005010X220A1','115884','','2013-12-13','18:25:35',0,'2013-12-26 02:00:02',NULL,NULL),(14499,2515,'1656662','834','00','005010X220A1','1656662','','2014-01-13','12:17:29',0,'2014-01-14 01:32:01',NULL,NULL),(18234,3361,'2498186','834','00','005010X220A1','2498186','','2014-02-07','15:56:49',0,'2014-02-07 19:01:00',NULL,NULL),(20938,3944,'3728194','834','00','005010X220A1','3728194','','2014-02-23','15:37:26',0,'2014-02-26 08:00:32',NULL,NULL),(13950,2320,'2519726','834','00','005010X220A1','2519726','','2014-01-09','10:44:26',0,'2014-01-13 02:20:20',NULL,NULL),(19469,3620,'3067538','834','00','005010X220A1','3067538','','2014-02-13','18:24:51',0,'2014-02-14 21:30:03',NULL,NULL),(1163,239,'1825464','834','00','005010X220A1','1825464','','2013-12-24','12:22:28',0,'2013-12-25 18:46:35',NULL,NULL),(12186,1602,'2298969','834','00','005010X220A1','2298969','','2013-12-30','10:23:13',0,'2014-01-01 12:08:47',NULL,NULL),(17113,3142,'1660926','834','00','005010X220A1','1660926','','2014-01-30','14:15:44',0,'2014-01-30 21:00:14',NULL,NULL),(16889,3097,'1453973','834','00','005010X220A1','1453973','','2014-01-28','14:59:18',0,'2014-01-28 21:01:05',NULL,NULL),(20468,3842,'3691911','834','00','005010X220A1','3691911','','2014-02-20','13:57:27',0,'2014-02-20 22:00:37',NULL,NULL),(21363,4024,'3669602','834','00','005010X220A1','3669602','','2014-02-26','23:18:08',0,'2014-02-28 06:30:18',NULL,NULL),(14312,2393,'2309044','834','00','005010X220A1','2309044','','2014-01-10','14:21:09',0,'2014-01-13 03:00:38',NULL,NULL),(6024,1140,'505860','834','00','005010X220A1','505860','','2013-11-17','11:21:05',0,'2013-12-26 02:45:41',NULL,NULL),(14543,2518,'2508370','834','00','005010X220A1','2508370','','2014-01-13','15:24:19',0,'2014-01-14 01:32:30',NULL,NULL),(7033,1235,'440085','834','00','005010X220A1','440085','','2013-12-18','13:32:26',0,'2013-12-26 04:01:32',NULL,NULL),(4799,865,'792783','834','00','005010X220A1','792783','','2013-12-01','09:35:39',0,'2013-12-26 00:01:51',NULL,NULL),(3253,578,'674925','834','00','005010X220A1','674925','','2013-12-17','17:36:28',0,'2013-12-25 21:46:55',NULL,NULL),(19698,3671,'2992694','834','00','005010X220A1','2992694','','2014-02-15','11:36:37',0,'2014-02-15 22:00:06',NULL,NULL),(57,3,'351366','834','00','005010X220A1','351366','','2013-12-05','10:51:56',0,'2013-12-25 17:16:42',NULL,NULL),(7200,1240,'908714','834','00','005010X220A1','908714','','2013-12-18','14:39:59',0,'2013-12-26 04:06:36',NULL,NULL),(2034,331,'951494','834','00','005010X220A1','951494','','2013-12-09','17:29:02',0,'2013-12-25 19:35:55',NULL,NULL),(19889,3711,'3007892','834','00','005010X220A1','3007892','','2014-02-15','22:52:01',0,'2014-02-16 19:00:31',NULL,NULL),(18864,3493,'2124904','834','00','005010X220A1','2124904','','2014-02-11','10:00:07',0,'2014-02-11 21:02:05',NULL,NULL),(18854,3491,'3249237','834','00','005010X220A1','3249237','','2014-02-11','15:05:58',0,'2014-02-11 21:01:56',NULL,NULL),(18532,3451,'2411098','834','00','005010X220A1','2411098','','2014-02-10','13:36:24',0,'2014-02-10 21:30:17',NULL,NULL),(2092,351,'399518','834','00','005010X220A1','399518','','2013-12-09','16:00:45',0,'2013-12-25 19:37:47',NULL,NULL),(17105,3142,'2413355','834','00','005010X220A1','2413355','','2014-01-30','09:57:25',0,'2014-01-30 21:00:09',NULL,NULL),(17017,3119,'1958521','834','00','005010X220A1','1958521','','2014-01-29','16:13:43',0,'2014-01-29 21:01:04',NULL,NULL),(2308,402,'435867','834','00','005010X220A1','435867','','2013-11-02','11:01:48',0,'2013-12-25 20:01:30',NULL,NULL),(10657,1402,'1517019','834','00','005010X220A1','1517019','','2013-12-23','18:49:12',0,'2013-12-26 12:59:02',NULL,NULL),(14746,2550,'2578380','834','00','005010X220A1','2578380','','2014-01-14','17:31:43',0,'2014-01-15 02:06:21',NULL,NULL),(11314,1456,'1661531','834','00','005010X220A1','1661531','','2013-12-26','12:24:46',0,'2013-12-27 02:03:56',NULL,NULL),(13241,2085,'0001','999','BE','005010X231A1','749039','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:46',NULL,NULL),(20711,3893,'3174030','834','00','005010X220A1','3174030','','2014-02-25','17:38:06',0,'2014-02-25 21:00:19',NULL,NULL),(340,72,'512512','834','00','005010X220A1','512512','','2013-12-04','15:27:03',0,'2013-12-25 17:46:26',NULL,NULL),(19976,3746,'3451144','834','00','005010X220A1','3451144','','2014-02-18','14:07:09',0,'2014-02-18 22:00:16',NULL,NULL),(5685,1063,'1889740','834','00','005010X220A1','1889740','','2013-12-24','22:22:08',0,'2013-12-26 01:52:40',NULL,NULL),(16880,3093,'1928620','834','00','005010X220A1','1928620','','2014-01-28','18:02:24',0,'2014-01-28 21:00:59',NULL,NULL),(16299,2980,'1917299','834','00','005010X220A1','1917299','','2014-01-23','08:22:59',0,'2014-01-23 21:00:12',NULL,NULL),(2114,360,'653896','834','00','005010X220A1','653896','','2013-12-01','21:32:01',0,'2013-12-25 19:45:22',NULL,NULL),(3817,666,'1012342','834','00','005010X220A1','1012342','','2013-12-07','21:58:27',0,'2013-12-25 22:16:54',NULL,NULL),(2414,415,'652686','834','00','005010X220A1','652686','','2013-12-06','13:42:42',0,'2013-12-25 20:17:42',NULL,NULL),(15081,2585,'2277316','834','00','005010X220A1','2277316','','2014-01-15','11:35:00',0,'2014-01-16 08:45:08',NULL,NULL),(15019,2584,'2517432','834','00','005010X220A1','2517432','','2014-01-15','14:53:14',0,'2014-01-16 08:44:29',NULL,NULL),(14719,2550,'2490088','834','00','005010X220A1','2490088','','2014-01-14','11:22:44',0,'2014-01-15 02:06:10',NULL,NULL),(10519,1401,'1131480','834','00','005010X220A1','1131480','','2013-12-22','23:03:01',0,'2013-12-26 12:54:27',NULL,NULL),(11036,1418,'907750','834','00','005010X220A1','907750','','2013-12-23','01:41:44',0,'2013-12-26 13:11:59',NULL,NULL),(20925,3935,'2408929','834','00','005010X220A1','2408929','','2014-02-23','08:34:50',0,'2014-02-26 08:00:20',NULL,NULL),(23197,4346,'2704694','834','00','005010X220A1','2704694','','2014-03-07','12:53:46',0,'2014-03-07 21:31:44',NULL,NULL),(23272,4379,'3662503','834','00','005010X220A1','3662503','','2014-03-08','13:46:00',0,'2014-03-08 21:00:09',NULL,NULL),(5987,1125,'118348','834','00','005010X220A1','118348','','2013-12-15','09:24:20',0,'2013-12-26 02:33:33',NULL,NULL),(7003,1235,'44489','834','00','005010X220A1','44489','','2013-12-17','20:51:50',0,'2013-12-26 04:00:34',NULL,NULL),(17496,3222,'2802840','834','00','005010X220A1','2802840','','2014-02-01','21:17:24',0,'2014-02-02 19:00:22',NULL,NULL),(16716,3064,'1769874','834','00','005010X220A1','1769874','','2014-01-27','13:24:46',0,'2014-01-27 21:00:53',NULL,NULL),(20291,3795,'2452381','834','00','005010X220A1','2452381','','2014-02-19','11:36:05',0,'2014-02-20 04:40:59',NULL,NULL),(21033,3976,'3585403','834','00','005010X220A1','3585403','','2014-02-23','20:33:41',0,'2014-02-26 09:30:12',NULL,NULL),(23709,4454,'3706133','834','00','005010X220A1','3706133','','2014-03-10','15:41:26',0,'2014-03-10 21:02:34',NULL,NULL),(315,70,'724738','834','00','005010X220A1','724738','','2013-12-04','13:30:41',0,'2013-12-25 17:45:40',NULL,NULL),(19548,3626,'2889531','834','00','005010X220A1','2889531','','2014-02-13','20:09:48',0,'2014-02-14 21:31:00',NULL,NULL),(5240,957,'1094611','834','00','005010X220A1','1094611','','2013-12-11','10:33:52',0,'2013-12-26 00:53:41',NULL,NULL),(1539,261,'1872319','834','00','005010X220A1','1872319','','2013-12-24','15:38:24',0,'2013-12-25 18:58:34',NULL,NULL),(16572,3035,'2468829','834','00','005010X220A1','2468829','','2014-01-25','15:04:50',0,'2014-01-25 19:00:07',NULL,NULL),(15047,2585,'2000522','834','00','005010X220A1','2000522','','2014-01-14','19:03:19',0,'2014-01-16 08:44:47',NULL,NULL),(13493,2228,'2321337','834','00','005010X220A1','2321337','','2014-01-06','15:09:39',0,'2014-01-07 04:04:20',NULL,NULL),(11867,1558,'905532','834','00','005010X220A1','905532','','2013-12-28','20:29:26',1,'2013-12-29 11:15:23',NULL,NULL),(11207,1454,'2217652','834','00','005010X220A1','2217652','','2013-12-26','08:28:24',0,'2013-12-27 02:00:39',NULL,NULL),(4889,897,'1004008','834','00','005010X220A1','1004008','','2013-11-21','14:50:51',0,'2013-12-26 00:16:58',NULL,NULL),(4305,749,'669801','834','00','005010X220A1','669801','','2013-12-19','10:37:39',0,'2013-12-25 23:09:26',NULL,NULL),(21734,4089,'3672310','834','00','005010X220A1','3672310','','2014-02-28','12:21:37',0,'2014-02-28 21:30:36',NULL,NULL),(22476,4239,'3319612','834','00','005010X220A1','3319612','','2014-03-05','12:12:39',0,'2014-03-05 21:00:20',NULL,NULL),(22558,4248,'3609606','834','00','005010X220A1','3609606','','2014-03-05','12:03:52',0,'2014-03-05 21:30:49',NULL,NULL),(23673,4445,'2876050','834','00','005010X220A1','2876050','','2014-03-10','09:51:25',0,'2014-03-10 21:02:08',NULL,NULL),(7445,1296,'633024','834','00','005010X220A1','633024','','2013-12-20','20:07:54',0,'2013-12-26 04:32:17',NULL,NULL),(11440,1482,'726963','834','00','005010X220A1','726963','','2013-12-26','16:59:12',0,'2013-12-27 02:07:51',NULL,NULL),(21644,4072,'3717346','834','00','005010X220A1','3717346','','2014-02-27','13:06:31',0,'2014-02-28 07:30:35',NULL,NULL),(23182,4345,'3470390','834','00','005010X220A1','3470390','','2014-03-07','10:30:20',0,'2014-03-07 21:31:33',NULL,NULL),(173,16,'24439','834','00','005010X220A1','24439','','2013-12-04','20:40:07',0,'2013-12-25 17:20:22',NULL,NULL),(19863,3706,'2771566','834','00','005010X220A1','2771566','','2014-02-15','18:25:20',0,'2014-02-16 19:00:10',NULL,NULL),(1002,188,'827795','834','00','005010X220A1','827795','','2013-12-03','09:57:45',0,'2013-12-25 18:20:20',NULL,NULL),(17244,3167,'2049029','834','00','005010X220A1','2049029','','2014-01-30','17:09:07',0,'2014-01-30 21:01:39',NULL,NULL),(14924,2559,'1495318','834','00','005010X220A1','1495318','','2014-01-14','16:26:18',0,'2014-01-15 02:07:40',NULL,NULL),(15599,2661,'2541621','834','00','005010X220A1','2541621','','2014-01-17','11:28:22',0,'2014-01-20 08:06:25',NULL,NULL),(16435,3006,'2314372','834','00','005010X220A1','2314372','','2014-01-24','11:42:30',0,'2014-01-24 21:00:03',NULL,NULL),(21759,4090,'3096915','834','00','005010X220A1','3096915','','2014-02-28','12:36:05',0,'2014-02-28 21:30:52',NULL,NULL),(22005,4148,'3725601','834','00','005010X220A1','3725601','','2014-03-02','16:40:50',0,'2014-03-03 01:00:26',NULL,NULL),(22517,4247,'3218519','834','00','005010X220A1','3218519','','2014-03-05','12:35:45',0,'2014-03-05 21:30:18',NULL,NULL),(432,79,'361476','834','00','005010X220A1','361476','','2013-12-04','18:03:08',0,'2013-12-25 17:49:25',NULL,NULL),(19827,3680,'2159277','834','00','005010X220A1','2159277','','2014-02-15','13:22:57',0,'2014-02-15 22:01:44',NULL,NULL),(13449,2223,'2192482','834','00','005010X220A1','2192482','','2014-01-06','17:56:40',0,'2014-01-07 04:02:45',NULL,NULL),(10617,1402,'1410664','834','00','005010X220A1','1410664','','2013-12-23','14:50:39',0,'2013-12-26 12:57:44',NULL,NULL),(10368,1400,'1027793','834','00','005010X220A1','1027793','','2013-12-22','19:55:31',0,'2013-12-26 12:49:44',NULL,NULL),(17928,3296,'2916109','834','00','005010X220A1','2916109','','2014-02-05','14:02:41',0,'2014-02-05 21:30:44',NULL,NULL),(17866,3293,'2809882','834','00','005010X220A1','2809882','','2014-02-05','14:17:13',0,'2014-02-05 21:30:14',NULL,NULL),(20167,3777,'3536173','834','00','005010X220A1','3536173','','2014-02-19','11:31:31',0,'2014-02-20 04:08:51',NULL,NULL),(16920,3114,'2500542','834','00','005010X220A1','2500542','','2014-01-28','19:24:23',0,'2014-01-29 21:00:04',NULL,NULL),(16800,3088,'2119653','834','00','005010X220A1','2119653','','2014-01-28','17:14:11',0,'2014-01-28 21:00:08',NULL,NULL),(7329,1274,'784098','834','00','005010X220A1','784098','','2013-12-18','15:51:07',0,'2013-12-26 04:10:36',NULL,NULL),(16200,2892,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','09:37:00',1,'2014-01-23 04:47:05',NULL,NULL),(15281,2611,'2490143','834','00','005010X220A1','2490143','','2014-01-15','12:00:26',0,'2014-01-16 08:47:19',NULL,NULL),(3075,545,'757539','834','00','005010X220A1','757539','','2013-12-13','09:02:16',0,'2013-12-25 21:35:26',NULL,NULL),(5513,1041,'1952506','834','00','005010X220A1','1952506','','2013-12-24','20:29:55',0,'2013-12-26 01:46:50',NULL,NULL),(2249,378,'1111342','834','00','005010X220A1','1111342','','2013-12-02','14:38:21',0,'2013-12-25 19:49:53',NULL,NULL),(2933,541,'275185','834','00','005010X220A1','275185','','2013-12-12','20:40:24',0,'2013-12-25 21:31:02',NULL,NULL),(5290,980,'772951','834','00','005010X220A1','772951','','2013-11-15','21:11:20',0,'2013-12-26 01:01:04',NULL,NULL),(20480,3843,'3574427','834','00','005010X220A1','3574427','','2014-02-20','14:12:42',0,'2014-02-20 22:00:48',NULL,NULL),(20721,3897,'3335733','834','00','005010X220A1','3335733','','2014-02-25','13:42:55',0,'2014-02-25 21:00:26',NULL,NULL),(4351,759,'419526','834','00','005010X220A1','419526','','2013-12-19','17:09:49',0,'2013-12-25 23:10:48',NULL,NULL),(18748,3485,'2921240','834','00','005010X220A1','2921240','','2014-02-11','13:47:21',0,'2014-02-11 21:00:36',NULL,NULL),(10860,1407,'1541589','834','00','005010X220A1','1541589','','2013-12-22','19:40:28',0,'2013-12-26 13:05:51',NULL,NULL),(15851,2738,'2334217','834','00','005010X220A1','2334217','','2014-01-21','11:01:09',1,'2014-01-22 03:22:10',NULL,NULL),(14748,2550,'2220504','834','00','005010X220A1','2220504','','2014-01-14','18:09:00',0,'2014-01-15 02:06:22',NULL,NULL),(20574,3866,'2846710','834','00','005010X220A1','2846710','','2014-02-20','20:09:48',0,'2014-02-21 21:30:18',NULL,NULL),(23587,4437,'2993379','834','00','005010X220A1','2993379','','2014-03-10','09:20:08',0,'2014-03-10 21:01:08',NULL,NULL),(6294,1172,'176699','834','00','005010X220A1','176699','','2013-12-20','18:34:20',0,'2013-12-26 03:07:14',NULL,NULL),(1244,243,'1934520','834','00','005010X220A1','1934520','','2013-12-24','11:17:47',0,'2013-12-25 18:49:01',NULL,NULL),(18427,3420,'2167896','834','00','005010X220A1','2167896','','2014-02-10','04:14:07',0,'2014-02-10 11:00:15',NULL,NULL),(3727,637,'547619','834','00','005010X220A1','547619','','2013-12-12','11:20:32',0,'2013-12-25 22:08:26',NULL,NULL),(14128,2351,'1872709','834','00','005010X220A1','1872709','','2014-01-08','11:03:19',0,'2014-01-13 02:22:28',NULL,NULL),(13252,2096,'0001','999','BE','005010X231A1','311098','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:17',NULL,NULL),(7180,1238,'1248020','834','00','005010X220A1','1248020','','2013-12-18','18:08:01',0,'2013-12-26 04:06:01',NULL,NULL),(12649,1672,'1288188','834','00','005010X220A1','1288188','','2014-01-02','11:29:35',0,'2014-01-03 02:02:54',NULL,NULL),(7750,1345,'1153155','834','00','005010X220A1','1153155','','2013-10-20','11:42:29',0,'2013-12-26 05:00:52',NULL,NULL),(21831,4099,'3740505','834','00','005010X220A1','3740505','','2014-02-28','10:58:32',0,'2014-02-28 21:31:44',NULL,NULL),(23466,4416,'3883090','834','00','005010X220A1','3883090','','2014-03-09','11:21:03',0,'2014-03-09 21:01:05',NULL,NULL),(852,175,'671813','834','00','005010X220A1','671813','','2013-12-02','23:35:22',0,'2013-12-25 18:15:42',NULL,NULL),(20596,3870,'3311343','834','00','005010X220A1','3311343','','2014-02-21','12:07:05',0,'2014-02-21 22:00:11',NULL,NULL),(18312,3384,'1731332','834','00','005010X220A1','1731332','','2014-02-08','11:25:21',0,'2014-02-08 19:00:43',NULL,NULL),(15717,2708,'2197782','834','00','005010X220A1','2197782','','2014-01-19','00:13:53',0,'2014-01-21 08:45:41',NULL,NULL),(20956,3950,'3471413','834','00','005010X220A1','3471413','','2014-02-24','16:27:56',0,'2014-02-26 08:00:45',NULL,NULL),(23515,4434,'3892270','834','00','005010X220A1','3892270','','2014-03-10','14:43:14',0,'2014-03-10 21:00:13',NULL,NULL),(23546,4435,'3375259','834','00','005010X220A1','3375259','','2014-03-10','14:26:28',0,'2014-03-10 21:00:37',NULL,NULL),(12469,1640,'2453722','834','00','005010X220A1','2453722','','2013-12-30','19:25:45',1,'2014-01-02 04:32:12',NULL,NULL),(12432,1638,'2417714','834','00','005010X220A1','2417714','','2013-12-31','14:03:23',1,'2014-01-02 04:30:49',NULL,NULL),(11438,1481,'2112900','834','00','005010X220A1','2112900','','2013-12-26','14:57:37',0,'2013-12-27 02:07:47',NULL,NULL),(3334,586,'1090988','834','00','005010X220A1','1090988','','2013-12-17','14:51:26',0,'2013-12-25 21:49:38',NULL,NULL),(7298,1259,'104573','834','00','005010X220A1','104573','','2013-12-18','14:05:51',0,'2013-12-26 04:09:39',NULL,NULL),(5163,944,'634007','834','00','005010X220A1','634007','','2013-12-11','17:51:11',0,'2013-12-26 00:51:10',NULL,NULL),(1805,307,'1196626','834','00','005010X220A1','1196626','','2013-12-10','09:50:02',0,'2013-12-25 19:19:49',NULL,NULL),(11263,1455,'1226594','834','00','005010X220A1','1226594','','2013-12-26','09:38:05',0,'2013-12-27 02:02:23',NULL,NULL),(18900,3503,'2990380','834','00','005010X220A1','2990380','','2014-02-11','13:16:37',0,'2014-02-11 21:02:36',NULL,NULL),(18114,3330,'1644599','834','00','005010X220A1','1644599','','2014-02-05','22:34:42',0,'2014-02-06 21:01:27',NULL,NULL),(17995,3317,'2820657','834','00','005010X220A1','2820657','','2014-02-05','15:57:40',0,'2014-02-05 21:31:19',NULL,NULL),(15493,2634,'1355674','834','00','005010X220A1','1355674','','2014-01-16','17:19:52',0,'2014-01-17 03:36:28',NULL,NULL),(11071,1421,'1520486','834','00','005010X220A1','1520486','','2013-12-23','13:38:10',0,'2013-12-26 13:13:09',NULL,NULL),(7446,1296,'500702','834','00','005010X220A1','500702','','2013-12-20','20:25:04',0,'2013-12-26 04:32:19',NULL,NULL),(11205,1454,'1487467','834','00','005010X220A1','1487467','','2013-12-26','00:01:20',0,'2013-12-27 02:00:35',NULL,NULL),(4712,837,'1591195','834','00','005010X220A1','1591195','','2013-12-23','23:52:57',0,'2013-12-25 23:51:02',NULL,NULL),(3373,587,'946841','834','00','005010X220A1','946841','','2013-12-17','14:07:27',0,'2013-12-25 21:50:51',NULL,NULL),(11906,1564,'1539191','834','00','005010X220A1','1539191','','2013-12-28','18:44:49',0,'2013-12-30 00:01:13',NULL,NULL),(2560,463,'1227906','834','00','005010X220A1','1227906','','2013-11-18','17:34:18',0,'2013-12-25 20:31:54',NULL,NULL),(2555,461,'288803','834','00','005010X220A1','288803','','2013-11-17','22:44:03',0,'2013-12-25 20:31:44',NULL,NULL),(1091,220,'563048','834','00','005010X220A1','563048','','2013-11-03','21:05:44',0,'2013-12-25 18:31:41',NULL,NULL),(1297,244,'2002402','834','00','005010X220A1','2002402','','2013-12-24','14:01:36',0,'2013-12-25 18:50:41',NULL,NULL),(20766,3906,'2614815','834','00','005010X220A1','2614815','','2014-02-25','11:52:34',0,'2014-02-25 21:30:31',NULL,NULL),(21887,4124,'3785787','834','00','005010X220A1','3785787','','2014-03-01','16:53:58',0,'2014-03-01 21:00:21',NULL,NULL),(23005,4322,'3284445','834','00','005010X220A1','3284445','','2014-03-07','17:33:48',0,'2014-03-07 21:00:13',NULL,NULL),(262,49,'835391','834','00','005010X220A1','835391','','2013-11-12','21:28:07',0,'2013-12-25 17:31:17',NULL,NULL),(18443,3421,'1639871','834','00','005010X220A1','1639871','','2014-02-10','04:24:54',0,'2014-02-10 11:00:27',NULL,NULL),(580,104,'1036358','834','00','005010X220A1','1036358','','2013-12-15','19:23:09',0,'2013-12-25 18:02:56',NULL,NULL),(14069,2339,'1696752','834','00','005010X220A1','1696752','','2014-01-08','17:58:10',0,'2014-01-13 02:21:49',NULL,NULL),(747,134,'927318','834','00','005010X220A1','927318','','2013-12-16','13:09:12',0,'2013-12-25 18:08:14',NULL,NULL),(12294,1626,'1383301','834','00','005010X220A1','1383301','','2013-12-31','22:24:33',1,'2014-01-02 04:25:05',NULL,NULL),(7440,1296,'27795','834','00','005010X220A1','27795','','2013-12-20','18:58:38',0,'2013-12-26 04:32:07',NULL,NULL),(2477,431,'1149720','834','00','005010X220A1','1149720','','2013-12-06','14:50:04',0,'2013-12-25 20:19:45',NULL,NULL),(12125,1587,'1939502','834','00','005010X220A1','1939502','','2013-12-30','15:53:56',0,'2014-01-01 12:06:37',NULL,NULL),(11015,1414,'162674','834','00','005010X220A1','162674','','2013-12-23','12:21:11',0,'2013-12-26 13:11:19',NULL,NULL),(2569,470,'7936','834','00','005010X220A1','7936','','2013-10-02','23:49:15',0,'2013-12-25 20:32:13',NULL,NULL),(21350,4022,'3356412','834','00','005010X220A1','3356412','','2014-02-27','15:45:40',0,'2014-02-28 06:30:12',NULL,NULL),(21898,4126,'3620181','834','00','005010X220A1','3620181','','2014-03-01','12:07:18',0,'2014-03-01 21:00:29',NULL,NULL),(22886,4282,'3107238','834','00','005010X220A1','3107238','','2014-03-06','12:49:46',0,'2014-03-06 21:02:06',NULL,NULL),(12413,1638,'2292328','834','00','005010X220A1','2292328','','2013-12-30','19:04:51',1,'2014-01-02 04:30:09',NULL,NULL),(17640,3247,'2032267','834','00','005010X220A1','2032267','','2014-02-03','11:29:30',0,'2014-02-03 21:01:23',NULL,NULL),(1526,260,'1999926','834','00','005010X220A1','1999926','','2013-12-24','14:29:15',0,'2013-12-25 18:58:15',NULL,NULL),(11566,1492,'1899700','834','00','005010X220A1','1899700','','2013-12-27','14:00:13',0,'2013-12-28 03:33:41',NULL,NULL),(14349,2401,'1812521','834','00','005010X220A1','1812521','','2014-01-12','17:43:13',0,'2014-01-13 03:01:24',NULL,NULL),(3215,578,'606208','834','00','005010X220A1','606208','','2013-12-17','09:10:28',0,'2013-12-25 21:45:47',NULL,NULL),(4036,731,'1260465','834','00','005010X220A1','1260465','','2013-12-19','15:55:33',0,'2013-12-25 23:01:14',NULL,NULL),(13656,2271,'1733290','834','00','005010X220A1','1733290','','2014-01-07','14:56:56',0,'2014-01-08 18:24:12',NULL,NULL),(13644,2271,'2353106','834','00','005010X220A1','2353106','','2014-01-06','19:28:55',0,'2014-01-08 18:24:07',NULL,NULL),(21339,4022,'3491063','834','00','005010X220A1','3491063','','2014-02-26','23:29:56',0,'2014-02-28 06:30:07',NULL,NULL),(23732,4464,'3844777','834','00','005010X220A1','3844777','','2014-03-10','17:44:54',0,'2014-03-10 21:02:54',NULL,NULL),(1275,243,'357090','834','00','005010X220A1','357090','','2013-12-24','16:02:34',0,'2013-12-25 18:50:00',NULL,NULL),(18431,3420,'2465781','834','00','005010X220A1','2465781','','2014-02-10','04:25:49',0,'2014-02-10 11:00:17',NULL,NULL),(18353,3400,'1717819','834','00','005010X220A1','1717819','','2014-02-08','18:12:31',0,'2014-02-09 19:00:03',NULL,NULL),(16875,3093,'1429224','834','00','005010X220A1','1429224','','2014-01-28','15:34:21',0,'2014-01-28 21:00:57',NULL,NULL),(12949,1733,'2472273','834','00','005010X220A1','2472273','','2014-01-04','12:41:57',0,'2014-01-05 00:00:16',NULL,NULL),(3555,616,'1062982','834','00','005010X220A1','1062982','','2013-12-12','15:17:06',0,'2013-12-25 22:02:57',NULL,NULL),(4038,731,'334316','834','00','005010X220A1','334316','','2013-12-19','15:55:52',0,'2013-12-25 23:01:16',NULL,NULL),(12766,1699,'2484953','834','00','005010X220A1','2484953','','2014-01-02','11:49:21',0,'2014-01-03 02:07:20',NULL,NULL),(19019,3539,'2140144','834','00','005010X220A1','2140144','','2014-02-12','17:46:52',0,'2014-02-12 21:30:39',NULL,NULL),(19155,3554,'2561563','834','00','005010X220A1','2561563','','2014-02-12','14:55:33',0,'2014-02-12 21:32:14',NULL,NULL),(21765,4090,'3650628','834','00','005010X220A1','3650628','','2014-02-28','14:38:05',0,'2014-02-28 21:30:57',NULL,NULL),(22318,4201,'2687766','834','00','005010X220A1','2687766','','2014-03-04','17:21:58',0,'2014-03-04 21:01:11',NULL,NULL),(23630,4441,'3179678','834','00','005010X220A1','3179678','','2014-03-10','12:21:25',0,'2014-03-10 21:01:37',NULL,NULL),(2610,486,'487459','834','00','005010X220A1','487459','','2013-10-06','10:49:13',0,'2013-12-25 20:46:18',NULL,NULL),(2917,541,'494114','834','00','005010X220A1','494114','','2013-12-13','18:05:23',0,'2013-12-25 21:30:28',NULL,NULL),(18654,3464,'2822009','834','00','005010X220A1','2822009','','2014-02-10','14:53:09',0,'2014-02-10 21:31:42',NULL,NULL),(3537,616,'1143098','834','00','005010X220A1','1143098','','2013-12-12','10:01:16',0,'2013-12-25 22:02:21',NULL,NULL),(12115,1587,'2406192','834','00','005010X220A1','2406192','','2013-12-30','13:49:28',0,'2014-01-01 12:06:11',NULL,NULL),(15334,2622,'1717347','834','00','005010X220A1','1717347','','2014-01-16','18:20:19',0,'2014-01-17 03:35:16',NULL,NULL),(15285,2613,'1512527','834','00','005010X220A1','1512527','','2014-01-15','12:35:16',0,'2014-01-16 08:47:21',NULL,NULL),(11623,1495,'1413478','834','00','005010X220A1','1413478','','2013-12-27','12:26:56',0,'2013-12-28 03:35:26',NULL,NULL),(21692,4087,'2836398','834','00','005010X220A1','2836398','','2014-02-27','19:18:33',0,'2014-02-28 21:30:04',NULL,NULL),(22256,4200,'3549910','834','00','005010X220A1','3549910','','2014-03-04','04:00:13',0,'2014-03-04 21:00:25',NULL,NULL),(22363,4205,'2645438','834','00','005010X220A1','2645438','','2014-03-04','13:57:05',0,'2014-03-04 21:01:49',NULL,NULL),(11256,1454,'428309','834','00','005010X220A1','428309','','2013-12-26','16:58:24',0,'2013-12-27 02:02:09',NULL,NULL),(18971,3537,'2661529','834','00','005010X220A1','2661529','','2014-02-11','21:14:22',0,'2014-02-12 21:30:07',NULL,NULL),(18737,3485,'2928760','834','00','005010X220A1','2928760','','2014-02-11','11:44:51',0,'2014-02-11 21:00:28',NULL,NULL),(18238,3365,'2843945','834','00','005010X220A1','2843945','','2014-02-07','14:36:00',0,'2014-02-07 19:01:04',NULL,NULL),(11153,1436,'1293141','834','00','005010X220A1','1293141','','2013-12-23','07:40:47',0,'2013-12-26 13:16:00',NULL,NULL),(314,70,'1177973','834','00','005010X220A1','1177973','','2013-12-04','03:54:13',0,'2013-12-25 17:45:38',NULL,NULL),(4338,755,'469093','834','00','005010X220A1','469093','','2013-12-19','17:58:47',0,'2013-12-25 23:10:24',NULL,NULL),(10467,1400,'1344436','834','00','005010X220A1','1344436','','2013-12-23','14:17:24',0,'2013-12-26 12:52:50',NULL,NULL),(6393,1188,'909831','834','00','005010X220A1','909831','','2013-12-20','13:00:36',0,'2013-12-26 03:10:15',NULL,NULL),(3553,616,'284596','834','00','005010X220A1','284596','','2013-12-12','15:00:22',0,'2013-12-25 22:02:53',NULL,NULL),(3489,615,'106994','834','00','005010X220A1','106994','','2013-12-12','11:12:45',0,'2013-12-25 22:00:48',NULL,NULL),(22057,4168,'3008253','834','00','005010X220A1','3008253','','2014-03-03','13:16:00',0,'2014-03-03 21:00:15',NULL,NULL),(13189,2033,'0001','999','BE','005010X231A1','1040265','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:21',NULL,NULL),(18980,3537,'2559076','834','00','005010X220A1','2559076','','2014-02-12','15:46:41',0,'2014-02-12 21:30:13',NULL,NULL),(17858,3293,'2847302','834','00','005010X220A1','2847302','','2014-02-05','09:19:43',0,'2014-02-05 21:30:10',NULL,NULL),(12527,1645,'2177650','834','00','005010X220A1','2177650','','2013-12-31','15:49:07',1,'2014-01-02 04:34:19',NULL,NULL),(11788,1537,'145629','834','00','005010X220A1','145629','','2013-12-28','20:12:52',1,'2013-12-29 11:12:45',NULL,NULL),(11343,1456,'1775646','834','00','005010X220A1','1775646','','2013-12-26','17:16:42',0,'2013-12-27 02:04:48',NULL,NULL),(10433,1400,'629862','834','00','005010X220A1','629862','','2013-12-23','11:16:26',0,'2013-12-26 12:51:42',NULL,NULL),(13347,2191,'0001','999','BE','005010X231A1','1267470','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:23',NULL,NULL),(4339,756,'206609','834','00','005010X220A1','206609','','2013-12-19','09:03:45',0,'2013-12-25 23:10:26',NULL,NULL),(4885,893,'951224','834','00','005010X220A1','951224','','2013-11-21','15:38:42',0,'2013-12-26 00:16:47',NULL,NULL),(3637,622,'651586','834','00','005010X220A1','651586','','2013-12-12','12:50:54',0,'2013-12-25 22:05:30',NULL,NULL),(2956,541,'302982','834','00','005010X220A1','302982','','2013-12-13','10:45:31',0,'2013-12-25 21:31:47',NULL,NULL),(19466,3619,'3436043','834','00','005010X220A1','3436043','','2014-02-13','17:34:51',0,'2014-02-13 22:03:21',NULL,NULL),(20428,3840,'3101737','834','00','005010X220A1','3101737','','2014-02-19','20:15:58',0,'2014-02-20 22:00:04',NULL,NULL),(22211,4186,'2871080','834','00','005010X220A1','2871080','','2014-03-03','16:23:27',0,'2014-03-03 21:31:40',NULL,NULL),(22977,4316,'2928118','834','00','005010X220A1','2928118','','2014-03-06','17:17:21',0,'2014-03-06 21:30:17',NULL,NULL),(23662,4444,'3579237','834','00','005010X220A1','3579237','','2014-03-09','21:23:53',0,'2014-03-10 21:01:59',NULL,NULL),(3100,546,'874773','834','00','005010X220A1','874773','','2013-12-13','11:38:30',0,'2013-12-25 21:36:12',NULL,NULL),(18866,3493,'2787505','834','00','005010X220A1','2787505','','2014-02-11','10:41:40',0,'2014-02-11 21:02:06',NULL,NULL),(18347,3397,'1876147','834','00','005010X220A1','1876147','','2014-02-08','00:24:42',0,'2014-02-08 19:30:06',NULL,NULL),(17855,3293,'2678036','834','00','005010X220A1','2678036','','2014-02-04','19:53:02',0,'2014-02-05 21:30:08',NULL,NULL),(5868,1103,'626001','834','00','005010X220A1','626001','','2013-10-28','14:42:44',0,'2013-12-26 02:16:51',NULL,NULL),(11818,1539,'548233','834','00','005010X220A1','548233','','2013-12-28','20:25:16',1,'2013-12-29 11:13:39',NULL,NULL),(7332,1275,'26224','834','00','005010X220A1','26224','','2013-12-18','17:07:24',0,'2013-12-26 04:10:42',NULL,NULL),(20073,3759,'3206555','834','00','005010X220A1','3206555','','2014-02-18','10:40:13',0,'2014-02-18 22:01:26',NULL,NULL),(22280,4200,'3845838','834','00','005010X220A1','3845838','','2014-03-04','15:28:23',0,'2014-03-04 21:00:44',NULL,NULL),(965,182,'255301','834','00','005010X220A1','255301','','2013-12-02','19:47:19',0,'2013-12-25 18:19:07',NULL,NULL),(19114,3545,'2312054','834','00','005010X220A1','2312054','','2014-02-12','15:29:21',0,'2014-02-12 21:31:47',NULL,NULL),(16907,3105,'2254884','834','00','005010X220A1','2254884','','2014-01-28','14:03:41',0,'2014-01-28 21:01:18',NULL,NULL),(15498,2635,'2021896','834','00','005010X220A1','2021896','','2014-01-15','22:44:50',0,'2014-01-17 03:36:29',NULL,NULL),(13031,1875,'0001','999','BE','005010X231A1','864853','834','2013-12-28','11:05:00',0,'2014-01-05 16:50:28',NULL,NULL),(5438,1033,'257659','834','00','005010X220A1','257659','','2013-10-05','09:30:15',0,'2013-12-26 01:31:35',NULL,NULL),(968,182,'193380','834','00','005010X220A1','193380','','2013-12-03','16:22:05',0,'2013-12-25 18:19:14',NULL,NULL),(3757,650,'1037641','834','00','005010X220A1','1037641','','2013-12-12','16:09:37',0,'2013-12-25 22:09:29',NULL,NULL),(2854,512,'1401745','834','00','005010X220A1','1401745','','2013-12-22','11:01:33',0,'2013-12-25 21:22:08',NULL,NULL),(4179,734,'506541','834','00','005010X220A1','506541','','2013-12-19','12:40:39',0,'2013-12-25 23:05:30',NULL,NULL),(4491,804,'1128146','834','00','005010X220A1','1128146','','2013-11-25','19:41:52',0,'2013-12-25 23:31:45',NULL,NULL),(6986,1234,'722559','834','00','005010X220A1','722559','','2013-12-17','18:32:09',0,'2013-12-26 04:00:02',NULL,NULL),(11035,1418,'768958','834','00','005010X220A1','768958','','2013-12-23','01:34:43',0,'2013-12-26 13:11:58',NULL,NULL),(18291,3380,'2953656','834','00','005010X220A1','2953656','','2014-02-08','05:18:29',0,'2014-02-08 19:00:28',NULL,NULL),(12648,1672,'1538064','834','00','005010X220A1','1538064','','2014-01-02','09:58:53',0,'2014-01-03 02:02:51',NULL,NULL),(14733,2550,'1978375','834','00','005010X220A1','1978375','','2014-01-14','14:37:06',0,'2014-01-15 02:06:16',NULL,NULL),(15351,2623,'1521254','834','00','005010X220A1','1521254','','2014-01-15','23:18:40',0,'2014-01-17 03:35:24',NULL,NULL),(19796,3677,'2720116','834','00','005010X220A1','2720116','','2014-02-14','19:15:27',0,'2014-02-15 22:01:18',NULL,NULL),(22883,4282,'2832093','834','00','005010X220A1','2832093','','2014-03-06','10:29:36',0,'2014-03-06 21:02:04',NULL,NULL),(23091,4339,'3715041','834','00','005010X220A1','3715041','','2014-03-07','15:36:56',0,'2014-03-07 21:30:29',NULL,NULL),(23144,4342,'3243578','834','00','005010X220A1','3243578','','2014-03-07','15:14:43',0,'2014-03-07 21:31:06',NULL,NULL),(1558,271,'2004708','834','00','005010X220A1','2004708','','2013-12-24','17:51:56',0,'2013-12-25 18:59:15',NULL,NULL),(18703,3482,'2311992','834','00','005010X220A1','2311992','','2014-02-10','14:31:27',0,'2014-02-10 21:32:17',NULL,NULL),(6012,1136,'807785','834','00','005010X220A1','807785','','2013-11-17','11:30:41',0,'2013-12-26 02:45:17',NULL,NULL),(5149,943,'516229','834','00','005010X220A1','516229','','2013-12-11','15:49:07',0,'2013-12-26 00:50:46',NULL,NULL),(15254,2600,'1968323','834','00','005010X220A1','1968323','','2014-01-15','17:16:46',0,'2014-01-16 08:46:59',NULL,NULL),(14348,2401,'1698069','834','00','005010X220A1','1698069','','2014-01-12','15:30:23',0,'2014-01-13 03:01:23',NULL,NULL),(13716,2275,'1529211','834','00','005010X220A1','1529211','','2014-01-07','14:03:27',0,'2014-01-08 18:24:36',NULL,NULL),(13536,2241,'2283125','834','00','005010X220A1','2283125','','2014-01-06','13:24:37',0,'2014-01-07 04:05:56',NULL,NULL),(10607,1402,'1454448','834','00','005010X220A1','1454448','','2013-12-23','13:30:13',0,'2013-12-26 12:57:25',NULL,NULL),(7647,1311,'628350','834','00','005010X220A1','628350','','2013-12-20','22:28:30',0,'2013-12-26 04:38:44',NULL,NULL),(2382,414,'882544','834','00','005010X220A1','882544','','2013-12-06','17:04:33',0,'2013-12-25 20:16:41',NULL,NULL),(4787,864,'406393','834','00','005010X220A1','406393','','2013-12-01','13:31:26',0,'2013-12-26 00:01:28',NULL,NULL),(19919,3727,'3376034','834','00','005010X220A1','3376034','','2014-02-17','15:23:17',0,'2014-02-17 19:00:12',NULL,NULL),(22783,4277,'3716391','834','00','005010X220A1','3716391','','2014-03-06','13:22:33',0,'2014-03-06 21:00:53',NULL,NULL),(1234,243,'798756','834','00','005010X220A1','798756','','2013-12-24','10:27:57',0,'2013-12-25 18:48:46',NULL,NULL),(18833,3490,'2290768','834','00','005010X220A1','2290768','','2014-02-11','13:22:24',0,'2014-02-11 21:01:40',NULL,NULL),(1597,281,'1015810','834','00','005010X220A1','1015810','','2013-11-19','22:58:36',0,'2013-12-25 19:01:08',NULL,NULL),(16925,3114,'2074434','834','00','005010X220A1','2074434','','2014-01-29','13:04:05',0,'2014-01-29 21:00:07',NULL,NULL),(14754,2551,'1790223','834','00','005010X220A1','1790223','','2014-01-13','19:11:24',0,'2014-01-15 02:06:25',NULL,NULL),(14025,2337,'2447631','834','00','005010X220A1','2447631','','2014-01-08','13:03:36',0,'2014-01-13 02:21:22',NULL,NULL),(12528,1645,'1688373','834','00','005010X220A1','1688373','','2013-12-31','16:16:41',1,'2014-01-02 04:34:22',NULL,NULL),(12110,1587,'2216356','834','00','005010X220A1','2216356','','2013-12-30','12:44:05',0,'2014-01-01 12:06:03',NULL,NULL),(2458,422,'263178','834','00','005010X220A1','263178','','2013-12-06','15:20:58',0,'2013-12-25 20:19:07',NULL,NULL),(10439,1400,'1473855','834','00','005010X220A1','1473855','','2013-12-23','11:43:55',0,'2013-12-26 12:51:55',NULL,NULL),(7371,1288,'954072','834','00','005010X220A1','954072','','2013-11-30','14:05:11',0,'2013-12-26 04:16:17',NULL,NULL),(20751,3903,'3745783','834','00','005010X220A1','3745783','','2014-02-25','14:35:45',0,'2014-02-25 21:30:20',NULL,NULL),(21114,3994,'3134127','834','00','005010X220A1','3134127','','2014-02-26','13:01:41',0,'2014-02-26 21:00:18',NULL,NULL),(22980,4317,'2909871','834','00','005010X220A1','2909871','','2014-03-06','15:30:36',0,'2014-03-06 21:30:19',NULL,NULL),(3128,551,'557307','834','00','005010X220A1','557307','','2013-12-13','10:05:02',0,'2013-12-25 21:37:03',NULL,NULL),(12118,1587,'1384677','834','00','005010X220A1','1384677','','2013-12-30','14:29:03',0,'2014-01-01 12:06:18',NULL,NULL),(18688,3473,'2076030','834','00','005010X220A1','2076030','','2014-02-10','11:42:05',0,'2014-02-10 21:32:05',NULL,NULL),(18423,3420,'2377975','834','00','005010X220A1','2377975','','2014-02-10','04:06:44',0,'2014-02-10 11:00:11',NULL,NULL),(18351,3399,'1866757','834','00','005010X220A1','1866757','','2014-02-08','15:37:00',0,'2014-02-08 19:30:10',NULL,NULL),(11488,1488,'1253632','834','00','005010X220A1','1253632','','2013-12-27','17:53:59',0,'2013-12-28 03:31:19',NULL,NULL),(10483,1400,'1472867','834','00','005010X220A1','1472867','','2013-12-23','16:00:31',0,'2013-12-26 12:53:21',NULL,NULL),(7341,1279,'88277','834','00','005010X220A1','88277','','2013-11-30','16:14:47',0,'2013-12-26 04:15:10',NULL,NULL),(4242,739,'1229998','834','00','005010X220A1','1229998','','2013-12-19','10:50:50',0,'2013-12-25 23:07:33',NULL,NULL),(15871,2739,'2093334','834','00','005010X220A1','2093334','','2014-01-20','19:33:37',1,'2014-01-22 03:22:22',NULL,NULL),(11875,1560,'1571399','834','00','005010X220A1','1571399','','2013-12-29','11:16:19',0,'2013-12-30 00:00:12',NULL,NULL),(11023,1416,'1062164','834','00','005010X220A1','1062164','','2013-12-23','01:43:45',0,'2013-12-26 13:11:35',NULL,NULL),(18001,3318,'2201963','834','00','005010X220A1','2201963','','2014-02-06','15:09:04',0,'2014-02-06 21:00:08',NULL,NULL),(7574,1301,'923790','834','00','005010X220A1','923790','','2013-12-21','14:32:50',0,'2013-12-26 04:36:24',NULL,NULL),(14693,2549,'2322692','834','00','005010X220A1','2322692','','2014-01-14','14:20:19',0,'2014-01-15 02:05:58',NULL,NULL),(14666,2541,'2120332','834','00','005010X220A1','2120332','','2014-01-13','15:52:51',0,'2014-01-14 01:33:50',NULL,NULL),(3962,716,'490584','834','00','005010X220A1','490584','','2013-12-06','21:49:16',0,'2013-12-25 22:47:00',NULL,NULL),(5297,984,'368988','834','00','005010X220A1','368988','','2013-11-16','14:55:35',0,'2013-12-26 01:01:17',NULL,NULL),(21538,4039,'2834085','834','00','005010X220A1','2834085','','2014-02-27','16:33:56',0,'2014-02-28 06:31:39',NULL,NULL),(6451,1209,'964028','834','00','005010X220A1','964028','','2013-11-22','15:04:58',0,'2013-12-26 03:16:07',NULL,NULL),(19879,3709,'2363770','834','00','005010X220A1','2363770','','2014-02-16','17:21:52',0,'2014-02-16 19:00:23',NULL,NULL),(19670,3658,'3375947','834','00','005010X220A1','3375947','','2014-02-13','19:02:38',0,'2014-02-14 22:00:03',NULL,NULL),(18272,3377,'2724669','834','00','005010X220A1','2724669','','2014-02-07','21:35:07',0,'2014-02-08 19:00:17',NULL,NULL),(17088,3136,'1567153','834','00','005010X220A1','1567153','','2014-01-29','15:06:16',0,'2014-01-29 21:01:50',NULL,NULL),(802,153,'1146657','834','00','005010X220A1','1146657','','2013-10-28','23:35:46',0,'2013-12-25 18:10:15',NULL,NULL),(14806,2551,'1525261','834','00','005010X220A1','1525261','','2014-01-14','18:39:53',0,'2014-01-15 02:06:47',NULL,NULL),(4817,870,'1234934','834','00','005010X220A1','1234934','','2013-12-01','11:00:25',0,'2013-12-26 00:02:21',NULL,NULL),(2607,485,'363960','834','00','005010X220A1','363960','','2013-10-05','19:55:24',0,'2013-12-25 20:46:12',NULL,NULL),(7237,1242,'215419','834','00','005010X220A1','215419','','2013-12-17','19:26:03',0,'2013-12-26 04:07:49',NULL,NULL),(13627,2270,'2313921','834','00','005010X220A1','2313921','','2014-01-07','16:45:43',0,'2014-01-08 18:24:01',NULL,NULL),(21838,4104,'3750038','834','00','005010X220A1','3750038','','2014-02-28','12:50:19',0,'2014-02-28 21:31:50',NULL,NULL),(22067,4169,'2980542','834','00','005010X220A1','2980542','','2014-03-03','11:19:19',0,'2014-03-03 21:00:21',NULL,NULL),(22323,4202,'2821352','834','00','005010X220A1','2821352','','2014-03-03','18:55:05',0,'2014-03-04 21:01:15',NULL,NULL),(23607,4440,'3534276','834','00','005010X220A1','3534276','','2014-03-10','12:42:47',0,'2014-03-10 21:01:21',NULL,NULL),(4433,795,'1174267','834','00','005010X220A1','1174267','','2013-11-05','19:28:50',0,'2013-12-25 23:17:09',NULL,NULL),(19717,3672,'3294080','834','00','005010X220A1','3294080','','2014-02-14','18:45:27',0,'2014-02-15 22:00:20',NULL,NULL),(11855,1551,'965030','834','00','005010X220A1','965030','','2013-12-28','20:30:26',1,'2013-12-29 11:14:58',NULL,NULL),(15108,2587,'2383978','834','00','005010X220A1','2383978','','2014-01-15','02:13:51',0,'2014-01-16 08:45:26',NULL,NULL),(15302,2622,'1650462','834','00','005010X220A1','1650462','','2014-01-15','18:23:14',0,'2014-01-17 03:35:02',NULL,NULL),(15542,2654,'1547788','834','00','005010X220A1','1547788','','2014-01-17','12:19:08',0,'2014-01-20 08:05:42',NULL,NULL),(56,3,'1218986','834','00','005010X220A1','1218986','','2013-12-05','10:04:04',0,'2013-12-25 17:16:41',NULL,NULL),(11298,1456,'705399','834','00','005010X220A1','705399','','2013-12-25','19:44:06',0,'2013-12-27 02:03:26',NULL,NULL),(18440,3421,'2416945','834','00','005010X220A1','2416945','','2014-02-10','04:00:57',0,'2014-02-10 11:00:25',NULL,NULL),(10707,1403,'1680046','834','00','005010X220A1','1680046','','2013-12-23','11:14:33',0,'2013-12-26 13:00:46',NULL,NULL),(1222,243,'1931972','834','00','005010X220A1','1931972','','2013-12-24','09:05:09',0,'2013-12-25 18:48:26',NULL,NULL),(14392,2417,'1985895','834','00','005010X220A1','1985895','','2014-01-12','14:33:39',0,'2014-01-13 03:01:57',NULL,NULL),(17266,3170,'1697311','834','00','005010X220A1','1697311','','2014-01-31','11:11:13',0,'2014-01-31 21:00:18',NULL,NULL),(15623,2671,'1637406','834','00','005010X220A1','1637406','','2014-01-17','12:48:22',0,'2014-01-20 08:06:42',NULL,NULL),(22714,4268,'2667405','834','00','005010X220A1','2667405','','2014-03-05','13:03:30',0,'2014-03-05 21:32:38',NULL,NULL),(631,108,'1189721','834','00','005010X220A1','1189721','','2013-12-16','11:55:14',0,'2013-12-25 18:04:38',NULL,NULL),(18842,3491,'2184969','834','00','005010X220A1','2184969','','2014-02-11','10:38:25',0,'2014-02-11 21:01:46',NULL,NULL),(12181,1598,'1315187','834','00','005010X220A1','1315187','','2013-12-30','11:49:32',0,'2014-01-01 12:08:33',NULL,NULL),(16885,3096,'1634823','834','00','005010X220A1','1634823','','2014-01-28','09:35:17',0,'2014-01-28 21:01:03',NULL,NULL),(16472,3008,'2464739','834','00','005010X220A1','2464739','','2014-01-24','12:36:41',0,'2014-01-24 21:00:24',NULL,NULL),(11858,1554,'316036','834','00','005010X220A1','316036','','2013-12-28','20:23:14',1,'2013-12-29 11:15:04',NULL,NULL),(15952,2763,'1450331','834','00','005010X220A1','1450331','','2014-01-22','16:00:59',0,'2014-01-23 03:01:51',NULL,NULL),(4850,884,'889021','834','00','005010X220A1','889021','','2013-11-21','12:12:38',0,'2013-12-26 00:15:36',NULL,NULL),(13004,1741,'1529147','834','00','005010X220A1','1529147','','2014-01-04','12:01:26',0,'2014-01-05 00:02:15',NULL,NULL),(2598,483,'1017069','834','00','005010X220A1','1017069','','2013-10-06','08:57:01',0,'2013-12-25 20:45:58',NULL,NULL),(3499,615,'834354','834','00','005010X220A1','834354','','2013-12-12','14:15:33',0,'2013-12-25 22:01:09',NULL,NULL),(18607,3456,'3138677','834','00','005010X220A1','3138677','','2014-02-10','13:59:28',0,'2014-02-10 21:31:08',NULL,NULL),(2246,375,'59276','834','00','005010X220A1','59276','','2013-12-02','18:07:47',0,'2013-12-25 19:49:46',NULL,NULL),(2004,330,'877206','834','00','005010X220A1','877206','','2013-12-09','14:39:49',0,'2013-12-25 19:34:59',NULL,NULL),(18150,3346,'1872169','834','00','005010X220A1','1872169','','2014-02-06','15:55:21',0,'2014-02-06 21:30:03',NULL,NULL),(879,177,'230452','834','00','005010X220A1','230452','','2013-12-03','09:08:25',0,'2013-12-25 18:16:34',NULL,NULL),(16176,2868,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:28:00',1,'2014-01-23 04:19:09',NULL,NULL),(23731,4464,'3336180','834','00','005010X220A1','3336180','','2014-03-10','13:16:44',0,'2014-03-10 21:02:52',NULL,NULL),(655,108,'324634','834','00','005010X220A1','324634','','2013-12-16','16:35:47',0,'2013-12-25 18:05:22',NULL,NULL),(13401,2222,'1370398','834','00','005010X220A1','1370398','','2014-01-06','12:13:47',0,'2014-01-07 04:00:57',NULL,NULL),(21674,4079,'3394376','834','00','005010X220A1','3394376','','2014-02-28','15:49:57',0,'2014-02-28 21:00:17',NULL,NULL),(4311,750,'396089','834','00','005010X220A1','396089','','2013-12-18','22:23:50',0,'2013-12-25 23:09:35',NULL,NULL),(18826,3490,'2928758','834','00','005010X220A1','2928758','','2014-02-11','11:32:06',0,'2014-02-11 21:01:34',NULL,NULL),(17797,3270,'1864108','834','00','005010X220A1','1864108','','2014-02-04','13:58:58',0,'2014-02-04 21:01:30',NULL,NULL),(17236,3163,'1877173','834','00','005010X220A1','1877173','','2014-01-30','13:42:59',0,'2014-01-30 21:01:34',NULL,NULL),(5150,943,'1317046','834','00','005010X220A1','1317046','','2013-12-11','15:55:55',0,'2013-12-26 00:50:48',NULL,NULL),(15837,2737,'2501460','834','00','005010X220A1','2501460','','2014-01-21','11:20:39',1,'2014-01-22 03:22:01',NULL,NULL),(7464,1296,'550447','834','00','005010X220A1','550447','','2013-12-21','11:24:44',0,'2013-12-26 04:32:47',NULL,NULL),(1507,258,'8238','834','00','005010X220A1','8238','','2013-12-24','11:43:14',0,'2013-12-25 18:57:35',NULL,NULL),(13480,2226,'2390990','834','00','005010X220A1','2390990','','2014-01-06','16:32:45',0,'2014-01-07 04:03:54',NULL,NULL),(21136,3996,'2829267','834','00','005010X220A1','2829267','','2014-02-26','07:06:03',0,'2014-02-26 21:00:35',NULL,NULL),(20186,3780,'2780357','834','00','005010X220A1','2780357','','2014-02-18','20:02:50',0,'2014-02-20 04:14:39',NULL,NULL),(3810,664,'1031004','834','00','005010X220A1','1031004','','2013-12-07','20:14:18',0,'2013-12-25 22:16:40',NULL,NULL),(11344,1456,'1864342','834','00','005010X220A1','1864342','','2013-12-26','17:34:07',0,'2013-12-27 02:04:49',NULL,NULL),(19644,3645,'2896659','834','00','005010X220A1','2896659','','2014-02-14','17:57:43',0,'2014-02-14 21:32:09',NULL,NULL),(14315,2394,'2068000','834','00','005010X220A1','2068000','','2014-01-10','14:24:48',0,'2014-01-13 03:00:40',NULL,NULL),(23712,4456,'3094902','834','00','005010X220A1','3094902','','2014-03-10','13:51:00',0,'2014-03-10 21:02:37',NULL,NULL),(7584,1301,'947108','834','00','005010X220A1','947108','','2013-12-21','17:13:20',0,'2013-12-26 04:36:47',NULL,NULL),(3456,609,'856837','834','00','005010X220A1','856837','','2013-12-17','17:33:59',0,'2013-12-25 21:53:32',NULL,NULL),(7553,1301,'1263251','834','00','005010X220A1','1263251','','2013-12-20','22:05:30',0,'2013-12-26 04:35:43',NULL,NULL),(16822,3090,'2109949','834','00','005010X220A1','2109949','','2014-01-28','16:15:51',0,'2014-01-28 21:00:21',NULL,NULL),(15723,2711,'2199110','834','00','005010X220A1','2199110','','2014-01-20','11:49:53',0,'2014-01-21 08:46:02',NULL,NULL),(21942,4132,'3409810','834','00','005010X220A1','3409810','','2014-03-01','12:11:33',0,'2014-03-01 21:00:59',NULL,NULL),(7172,1238,'375362','834','00','005010X220A1','375362','','2013-12-18','15:27:32',0,'2013-12-26 04:05:46',NULL,NULL),(11951,1580,'1977976','834','00','005010X220A1','1977976','','2013-12-29','23:15:29',0,'2014-01-01 12:00:14',NULL,NULL),(3779,656,'655511','834','00','005010X220A1','655511','','2013-12-07','22:53:42',0,'2013-12-25 22:15:38',NULL,NULL),(13579,2254,'1828895','834','00','005010X220A1','1828895','','2014-01-05','16:43:37',1,'2014-01-07 10:21:59',NULL,NULL),(14890,2558,'1667735','834','00','005010X220A1','1667735','','2014-01-14','10:48:36',0,'2014-01-15 02:07:26',NULL,NULL),(15309,2622,'1913027','834','00','005010X220A1','1913027','','2014-01-15','23:06:00',0,'2014-01-17 03:35:05',NULL,NULL),(17945,3299,'2858645','834','00','005010X220A1','2858645','','2014-02-05','11:07:46',0,'2014-02-05 21:30:52',NULL,NULL),(17090,3138,'1758512','834','00','005010X220A1','1758512','','2014-01-29','16:43:28',0,'2014-01-29 21:01:52',NULL,NULL),(23334,4384,'2625948','834','00','005010X220A1','2625948','','2014-03-08','15:37:19',0,'2014-03-08 21:30:46',NULL,NULL),(23619,4441,'3614142','834','00','005010X220A1','3614142','','2014-03-10','10:11:56',0,'2014-03-10 21:01:29',NULL,NULL),(12552,1656,'2223820','834','00','005010X220A1','2223820','','2013-12-31','17:23:49',1,'2014-01-02 04:35:19',NULL,NULL),(22394,4212,'3632166','834','00','005010X220A1','3632166','','2014-03-04','00:46:14',0,'2014-03-04 21:02:15',NULL,NULL),(21750,4090,'3711233','834','00','005010X220A1','3711233','','2014-02-28','00:01:11',0,'2014-02-28 21:30:47',NULL,NULL),(12492,1641,'2378488','834','00','005010X220A1','2378488','','2013-12-31','10:24:45',1,'2014-01-02 04:33:03',NULL,NULL),(2596,482,'861084','834','00','005010X220A1','861084','','2013-11-01','16:24:48',0,'2013-12-25 20:45:52',NULL,NULL),(729,124,'835942','834','00','005010X220A1','835942','','2013-12-16','15:57:45',0,'2013-12-25 18:07:43',NULL,NULL),(15094,2585,'2164982','834','00','005010X220A1','2164982','','2014-01-15','17:38:34',0,'2014-01-16 08:45:15',NULL,NULL),(198,18,'1223558','834','00','005010X220A1','1223558','','2013-12-05','15:25:31',0,'2013-12-25 17:21:11',NULL,NULL),(21228,3999,'3054249','834','00','005010X220A1','3054249','','2014-02-26','10:04:24',0,'2014-02-26 21:01:34',NULL,NULL),(13141,1985,'0001','999','BE','005010X231A1','1055543','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:08',NULL,NULL),(20459,3842,'2531928','834','00','005010X220A1','2531928','','2014-02-20','09:08:13',0,'2014-02-20 22:00:30',NULL,NULL),(19989,3746,'2821022','834','00','005010X220A1','2821022','','2014-02-18','17:28:17',0,'2014-02-18 22:00:26',NULL,NULL),(4986,935,'790585','834','00','005010X220A1','790585','','2013-12-10','22:26:19',0,'2013-12-26 00:45:31',NULL,NULL),(3294,584,'463964','834','00','005010X220A1','463964','','2013-12-16','22:54:18',0,'2013-12-25 21:48:15',NULL,NULL),(17556,3236,'2335905','834','00','005010X220A1','2335905','','2014-02-02','23:06:34',0,'2014-02-03 21:00:30',NULL,NULL),(17019,3120,'2492774','834','00','005010X220A1','2492774','','2014-01-28','20:18:20',0,'2014-01-29 21:01:06',NULL,NULL),(1988,327,'562124','834','00','005010X220A1','562124','','2013-12-09','16:00:20',0,'2013-12-25 19:34:24',NULL,NULL),(3042,544,'19690','834','00','005010X220A1','19690','','2013-12-13','11:45:29',0,'2013-12-25 21:34:22',NULL,NULL),(20785,3907,'3571690','834','00','005010X220A1','3571690','','2014-02-25','16:22:07',0,'2014-02-25 21:30:45',NULL,NULL),(7074,1236,'680184','834','00','005010X220A1','680184','','2013-12-18','07:49:45',0,'2013-12-26 04:02:48',NULL,NULL),(19205,3575,'2037665','834','00','005010X220A1','2037665','','2014-02-13','12:03:11',0,'2014-02-13 21:30:14',NULL,NULL),(18664,3467,'3031710','834','00','005010X220A1','3031710','','2014-02-10','11:05:18',0,'2014-02-10 21:31:48',NULL,NULL),(3512,615,'227013','834','00','005010X220A1','227013','','2013-12-12','16:23:56',0,'2013-12-25 22:01:36',NULL,NULL),(12306,1630,'1663910','834','00','005010X220A1','1663910','','2014-01-01','10:44:25',1,'2014-01-02 04:25:30',NULL,NULL),(13972,2322,'1882740','834','00','005010X220A1','1882740','','2014-01-09','15:26:50',0,'2014-01-13 02:20:37',NULL,NULL),(17709,3261,'2236230','834','00','005010X220A1','2236230','','2014-02-03','22:28:05',0,'2014-02-04 21:00:34',NULL,NULL),(1036,198,'1302464','834','00','005010X220A1','1302464','','2013-12-03','14:50:28',0,'2013-12-25 18:21:24',NULL,NULL),(11278,1455,'800248','834','00','005010X220A1','800248','','2013-12-26','13:06:22',0,'2013-12-27 02:02:49',NULL,NULL),(13139,1983,'0001','999','BE','005010X231A1','430422','834','2013-12-28','11:05:00',0,'2014-01-05 16:55:31',NULL,NULL),(16776,3076,'1789319','834','00','005010X220A1','1789319','','2014-01-27','12:15:33',0,'2014-01-27 21:01:38',NULL,NULL),(17370,3184,'2553327','834','00','005010X220A1','2553327','','2014-01-31','16:50:39',0,'2014-01-31 21:01:31',NULL,NULL),(17463,3215,'2758350','834','00','005010X220A1','2758350','','2014-02-01','16:38:06',0,'2014-02-01 19:00:51',NULL,NULL),(17962,3299,'2705003','834','00','005010X220A1','2705003','','2014-02-05','17:17:18',0,'2014-02-05 21:31:01',NULL,NULL),(346,72,'1133346','834','00','005010X220A1','1133346','','2013-12-04','10:00:17',0,'2013-12-25 17:46:39',NULL,NULL),(20023,3750,'2568031','834','00','005010X220A1','2568031','','2014-02-18','12:58:12',0,'2014-02-18 22:00:48',NULL,NULL),(18878,3495,'1583890','834','00','005010X220A1','1583890','','2014-02-10','23:17:35',0,'2014-02-11 21:02:16',NULL,NULL),(12289,1624,'1517336','834','00','005010X220A1','1517336','','2014-01-01','12:45:21',1,'2014-01-02 04:24:52',NULL,NULL),(11290,1455,'1099220','834','00','005010X220A1','1099220','','2013-12-26','16:11:23',0,'2013-12-27 02:03:12',NULL,NULL),(15031,2584,'2444110','834','00','005010X220A1','2444110','','2014-01-15','16:47:15',0,'2014-01-16 08:44:37',NULL,NULL),(13629,2270,'1711675','834','00','005010X220A1','1711675','','2014-01-06','20:24:11',0,'2014-01-08 18:24:01',NULL,NULL),(13115,1959,'0001','999','BE','005010X231A1','51896','834','2013-12-28','11:05:00',0,'2014-01-05 16:54:20',NULL,NULL),(423,77,'1311273','834','00','005010X220A1','1311273','','2013-12-04','16:28:45',0,'2013-12-25 17:49:07',NULL,NULL),(11098,1424,'924011','834','00','005010X220A1','924011','','2013-12-23','18:54:50',0,'2013-12-26 13:14:01',NULL,NULL),(4102,733,'380222','834','00','005010X220A1','380222','','2013-12-19','11:22:52',0,'2013-12-25 23:03:18',NULL,NULL),(5539,1041,'1784598','834','00','005010X220A1','1784598','','2013-12-24','23:54:45',0,'2013-12-26 01:47:41',NULL,NULL),(6379,1184,'358257','834','00','005010X220A1','358257','','2013-12-20','13:21:21',0,'2013-12-26 03:09:50',NULL,NULL),(7315,1265,'493258','834','00','005010X220A1','493258','','2013-12-18','11:19:14',0,'2013-12-26 04:10:09',NULL,NULL),(21388,4024,'3334369','834','00','005010X220A1','3334369','','2014-02-27','15:52:05',0,'2014-02-28 06:30:30',NULL,NULL),(19026,3539,'2916298','834','00','005010X220A1','2916298','','2014-02-12','16:13:35',0,'2014-02-12 21:30:44',NULL,NULL),(18686,3472,'2348616','834','00','005010X220A1','2348616','','2014-02-10','12:08:08',0,'2014-02-10 21:32:04',NULL,NULL),(13255,2099,'0001','999','BE','005010X231A1','391883','834','2013-12-28','11:05:00',0,'2014-01-05 17:02:25',NULL,NULL),(3971,716,'1190786','834','00','005010X220A1','1190786','','2013-12-07','14:24:15',0,'2013-12-25 22:47:16',NULL,NULL),(21709,4088,'3470127','834','00','005010X220A1','3470127','','2014-02-27','23:15:54',0,'2014-02-28 21:30:20',NULL,NULL),(3274,583,'1201767','834','00','005010X220A1','1201767','','2013-12-16','19:18:08',0,'2013-12-25 21:47:37',NULL,NULL),(20922,3933,'3001687','834','00','005010X220A1','3001687','','2014-02-23','15:52:55',0,'2014-02-26 08:00:18',NULL,NULL),(20862,3911,'3005583','834','00','005010X220A1','3005583','','2014-02-25','17:50:24',0,'2014-02-25 21:31:40',NULL,NULL),(1788,301,'276312','834','00','005010X220A1','276312','','2013-12-09','20:34:23',0,'2013-12-25 19:19:13',NULL,NULL),(11753,1523,'1439736','834','00','005010X220A1','1439736','','2013-12-28','12:25:18',1,'2013-12-29 11:09:32',NULL,NULL),(5033,935,'1007761','834','00','005010X220A1','1007761','','2013-12-11','13:34:19',0,'2013-12-26 00:47:02',NULL,NULL),(22137,4179,'2885144','834','00','005010X220A1','2885144','','2014-03-03','12:51:33',0,'2014-03-03 21:30:46',NULL,NULL),(20215,3781,'2992785','834','00','005010X220A1','2992785','','2014-02-19','15:30:53',0,'2014-02-20 04:21:35',NULL,NULL),(4916,909,'954965','834','00','005010X220A1','954965','','2013-10-16','20:13:06',0,'2013-12-26 00:30:39',NULL,NULL),(1736,293,'906097','834','00','005010X220A1','906097','','2013-12-10','12:59:10',0,'2013-12-25 19:17:35',NULL,NULL),(10417,1400,'798599','834','00','005010X220A1','798599','','2013-12-23','10:07:18',0,'2013-12-26 12:51:15',NULL,NULL),(16165,2857,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:37:00',1,'2014-01-23 04:14:29',NULL,NULL),(1584,278,'501093','834','00','005010X220A1','501093','','2013-11-20','02:29:56',0,'2013-12-25 19:00:45',NULL,NULL),(12510,1643,'2203483','834','00','005010X220A1','2203483','','2013-12-30','20:49:41',1,'2014-01-02 04:33:45',NULL,NULL),(13684,2273,'2566933','834','00','005010X220A1','2566933','','2014-01-06','18:31:38',0,'2014-01-08 18:24:22',NULL,NULL),(13513,2235,'2040773','834','00','005010X220A1','2040773','','2014-01-06','10:18:23',0,'2014-01-07 04:05:10',NULL,NULL),(5566,1043,'1248505','834','00','005010X220A1','1248505','','2013-12-24','19:58:46',0,'2013-12-26 01:48:33',NULL,NULL),(1229,243,'935832','834','00','005010X220A1','935832','','2013-12-24','09:53:26',0,'2013-12-25 18:48:38',NULL,NULL),(23324,4384,'3150678','834','00','005010X220A1','3150678','','2014-03-07','18:33:08',0,'2014-03-08 21:30:39',NULL,NULL),(21996,4146,'2950526','834','00','005010X220A1','2950526','','2014-03-02','10:05:18',0,'2014-03-03 01:00:21',NULL,NULL),(5595,1043,'1479171','834','00','005010X220A1','1479171','','2013-12-25','08:43:16',0,'2013-12-26 01:49:31',NULL,NULL),(5716,1069,'955625','834','00','005010X220A1','955625','','2013-12-14','06:14:25',0,'2013-12-26 02:00:57',NULL,NULL),(13178,2022,'0001','999','BE','005010X231A1','33505','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:51',NULL,NULL),(15615,2667,'2387700','834','00','005010X220A1','2387700','','2014-01-17','13:48:28',0,'2014-01-20 08:06:36',NULL,NULL),(12835,1704,'1718388','834','00','005010X220A1','1718388','','2014-01-03','14:00:12',0,'2014-01-04 02:02:31',NULL,NULL),(22663,4254,'3393359','834','00','005010X220A1','3393359','','2014-03-05','10:44:25',0,'2014-03-05 21:32:01',NULL,NULL),(3863,691,'627339','834','00','005010X220A1','627339','','2013-10-09','18:59:16',0,'2013-12-25 22:31:01',NULL,NULL),(4766,861,'799198','834','00','005010X220A1','799198','','2013-12-01','13:07:52',0,'2013-12-26 00:00:53',NULL,NULL),(19688,3668,'3110068','834','00','005010X220A1','3110068','','2014-02-15','11:51:49',0,'2014-02-15 21:00:10',NULL,NULL),(5243,959,'632575','834','00','005010X220A1','632575','','2013-12-11','10:29:02',0,'2013-12-26 00:53:48',NULL,NULL),(2479,432,'1112943','834','00','005010X220A1','1112943','','2013-12-06','15:25:38',0,'2013-12-25 20:19:48',NULL,NULL),(13862,2311,'2255440','834','00','005010X220A1','2255440','','2014-01-09','06:54:26',0,'2014-01-13 02:19:20',NULL,NULL),(14051,2339,'1611822','834','00','005010X220A1','1611822','','2014-01-07','19:22:00',0,'2014-01-13 02:21:38',NULL,NULL),(14951,2564,'2430612','834','00','005010X220A1','2430612','','2014-01-13','22:19:04',0,'2014-01-15 02:07:52',NULL,NULL),(19903,3718,'2721201','834','00','005010X220A1','2721201','','2014-02-16','14:10:37',0,'2014-02-16 19:00:42',NULL,NULL),(18858,3491,'2598289','834','00','005010X220A1','2598289','','2014-02-11','17:03:34',0,'2014-02-11 21:01:59',NULL,NULL),(4286,743,'187355','834','00','005010X220A1','187355','','2013-12-19','11:32:03',0,'2013-12-25 23:08:53',NULL,NULL),(18042,3319,'1684106','834','00','005010X220A1','1684106','','2014-02-05','21:35:20',0,'2014-02-06 21:00:36',NULL,NULL),(3391,588,'59701','834','00','005010X220A1','59701','','2013-12-17','10:58:22',0,'2013-12-25 21:51:24',NULL,NULL),(3218,578,'1105487','834','00','005010X220A1','1105487','','2013-12-17','09:34:31',0,'2013-12-25 21:45:52',NULL,NULL),(2635,497,'132123','834','00','005010X220A1','132123','','2013-11-27','19:35:52',0,'2013-12-25 20:47:06',NULL,NULL),(1269,243,'120402','834','00','005010X220A1','120402','','2013-12-24','15:01:14',0,'2013-12-25 18:49:48',NULL,NULL),(1273,243,'567785','834','00','005010X220A1','567785','','2013-12-24','16:00:45',0,'2013-12-25 18:49:56',NULL,NULL),(23045,4334,'3294691','834','00','005010X220A1','3294691','','2014-03-07','14:48:10',0,'2014-03-07 21:00:33',NULL,NULL),(5800,1077,'1143204','834','00','005010X220A1','1143204','','2013-12-14','16:36:13',0,'2013-12-26 02:03:31',NULL,NULL),(20716,3896,'3343380','834','00','005010X220A1','3343380','','2014-02-25','08:33:38',0,'2014-02-25 21:00:23',NULL,NULL),(15113,2587,'2497687','834','00','005010X220A1','2497687','','2014-01-15','12:23:35',0,'2014-01-16 08:45:29',NULL,NULL),(12772,1702,'2249367','834','00','005010X220A1','2249367','','2014-01-02','23:44:54',0,'2014-01-04 02:00:10',NULL,NULL),(12616,1671,'2489798','834','00','005010X220A1','2489798','','2014-01-02','13:15:15',0,'2014-01-03 02:01:39',NULL,NULL),(4443,800,'517010','834','00','005010X220A1','517010','','2013-11-26','12:32:13',0,'2013-12-25 23:30:10',NULL,NULL),(11526,1490,'94159','834','00','005010X220A1','94159','','2013-12-27','13:20:58',0,'2013-12-28 03:32:25',NULL,NULL),(1792,301,'620594','834','00','005010X220A1','620594','','2013-12-10','12:51:24',0,'2013-12-25 19:19:21',NULL,NULL),(3806,661,'511099','834','00','005010X220A1','511099','','2013-12-08','10:22:05',0,'2013-12-25 22:16:31',NULL,NULL),(3399,589,'391121','834','00','005010X220A1','391121','','2013-12-16','20:37:49',0,'2013-12-25 21:51:40',NULL,NULL),(23374,4396,'3213404','834','00','005010X220A1','3213404','','2014-03-08','13:12:29',0,'2014-03-08 21:31:16',NULL,NULL),(542,103,'855217','834','00','005010X220A1','855217','','2013-12-15','19:09:58',0,'2013-12-25 18:01:45',NULL,NULL),(12678,1673,'1660255','834','00','005010X220A1','1660255','','2014-01-02','11:25:52',0,'2014-01-03 02:03:55',NULL,NULL),(3948,715,'84393','834','00','005010X220A1','84393','','2013-12-06','19:26:00',0,'2013-12-25 22:46:27',NULL,NULL),(5621,1045,'466997','834','00','005010X220A1','466997','','2013-12-24','21:43:25',0,'2013-12-26 01:50:23',NULL,NULL),(22045,4164,'3193240','834','00','005010X220A1','3193240','','2014-03-03','10:06:00',0,'2014-03-03 21:00:07',NULL,NULL),(6352,1179,'282867','834','00','005010X220A1','282867','','2013-12-20','16:42:47',0,'2013-12-26 03:08:57',NULL,NULL),(2807,506,'959682','834','00','005010X220A1','959682','','2013-12-22','14:44:58',0,'2013-12-25 21:20:33',NULL,NULL),(673,109,'156129','834','00','005010X220A1','156129','','2013-12-16','10:26:44',0,'2013-12-25 18:05:52',NULL,NULL),(4,1,'933572','834','00','005010X220A1','933572','','2013-12-04','20:18:06',0,'2013-12-25 17:15:08',NULL,NULL),(23377,4397,'3588381','834','00','005010X220A1','3588381','','2014-03-08','16:58:40',0,'2014-03-08 21:31:18',NULL,NULL),(23231,4360,'3211976','834','00','005010X220A1','3211976','','2014-03-07','10:41:46',0,'2014-03-07 21:32:08',NULL,NULL),(12612,1671,'2302414','834','00','005010X220A1','2302414','','2014-01-02','11:51:51',0,'2014-01-03 02:01:30',NULL,NULL),(2068,340,'1037514','834','00','005010X220A1','1037514','','2013-12-09','14:13:49',0,'2013-12-25 19:37:02',NULL,NULL),(21192,3998,'2721434','834','00','005010X220A1','2721434','','2014-02-26','14:19:04',0,'2014-02-26 21:01:11',NULL,NULL),(7683,1324,'1423459','834','00','005010X220A1','1423459','','2013-12-21','16:11:48',0,'2013-12-26 04:39:55',NULL,NULL),(10917,1410,'289673','834','00','005010X220A1','289673','','2013-12-22','21:59:22',0,'2013-12-26 13:08:11',NULL,NULL),(19292,3582,'2691335','834','00','005010X220A1','2691335','','2014-02-13','15:16:42',0,'2014-02-13 22:01:06',NULL,NULL),(18569,3453,'2966240','834','00','005010X220A1','2966240','','2014-02-10','13:12:36',0,'2014-02-10 21:30:42',NULL,NULL),(18474,3429,'2448249','834','00','005010X220A1','2448249','','2014-02-10','04:17:06',0,'2014-02-10 11:00:55',NULL,NULL),(1591,281,'433522','834','00','005010X220A1','433522','','2013-11-19','22:42:09',0,'2013-12-25 19:00:58',NULL,NULL),(17835,3283,'1841393','834','00','005010X220A1','1841393','','2014-02-04','16:00:59',0,'2014-02-04 21:01:57',NULL,NULL),(13893,2312,'2191351','834','00','005010X220A1','2191351','','2014-01-09','15:38:42',0,'2014-01-13 02:19:41',NULL,NULL),(16461,3006,'2005511','834','00','005010X220A1','2005511','','2014-01-24','17:40:48',0,'2014-01-24 21:00:18',NULL,NULL),(823,166,'1186542','834','00','005010X220A1','1186542','','2013-10-19','11:20:21',0,'2013-12-25 18:11:02',NULL,NULL),(23141,4342,'2640611','834','00','005010X220A1','2640611','','2014-03-07','14:28:25',0,'2014-03-07 21:31:04',NULL,NULL),(22722,4274,'3635868','834','00','005010X220A1','3635868','','2014-03-05','16:24:43',0,'2014-03-05 21:32:44',NULL,NULL),(7605,1303,'1273161','834','00','005010X220A1','1273161','','2013-12-21','11:35:06',0,'2013-12-26 04:37:26',NULL,NULL),(7184,1239,'585640','834','00','005010X220A1','585640','','2013-12-17','22:03:52',0,'2013-12-26 04:06:09',NULL,NULL),(19588,3629,'3200276','834','00','005010X220A1','3200276','','2014-02-14','13:19:55',0,'2014-02-14 21:31:29',NULL,NULL),(15287,2614,'1870187','834','00','005010X220A1','1870187','','2014-01-15','13:17:01',0,'2014-01-16 08:47:23',NULL,NULL),(15969,2764,'1988578','834','00','005010X220A1','1988578','','2014-01-22','16:22:09',0,'2014-01-23 03:01:58',NULL,NULL),(17811,3273,'2108787','834','00','005010X220A1','2108787','','2014-02-04','12:09:21',0,'2014-02-04 21:01:40',NULL,NULL),(17023,3120,'1828445','834','00','005010X220A1','1828445','','2014-01-29','10:01:16',0,'2014-01-29 21:01:08',NULL,NULL),(2899,536,'233180','834','00','005010X220A1','233180','','2013-12-22','16:21:58',0,'2013-12-25 21:23:42',NULL,NULL),(20575,3866,'2965366','834','00','005010X220A1','2965366','','2014-02-20','20:09:48',0,'2014-02-21 21:30:19',NULL,NULL),(20383,3825,'3356162','834','00','005010X220A1','3356162','','2014-02-19','10:59:05',0,'2014-02-20 05:38:11',NULL,NULL),(2212,365,'447045','834','00','005010X220A1','447045','','2013-12-02','15:36:22',0,'2013-12-25 19:48:33',NULL,NULL),(19325,3583,'3102645','834','00','005010X220A1','3102645','','2014-02-13','12:16:04',0,'2014-02-13 22:01:33',NULL,NULL),(10605,1402,'350843','834','00','005010X220A1','350843','','2013-12-23','13:17:15',0,'2013-12-26 12:57:21',NULL,NULL),(17152,3144,'1384028','834','00','005010X220A1','1384028','','2014-01-30','15:34:35',0,'2014-01-30 21:00:38',NULL,NULL),(17092,3139,'1967410','834','00','005010X220A1','1967410','','2014-01-29','17:35:52',0,'2014-01-29 21:01:53',NULL,NULL),(2145,360,'46478','834','00','005010X220A1','46478','','2013-12-02','16:28:15',0,'2013-12-25 19:46:19',NULL,NULL),(14565,2519,'2436277','834','00','005010X220A1','2436277','','2014-01-13','15:06:40',0,'2014-01-14 01:32:44',NULL,NULL),(107,5,'1268438','834','00','005010X220A1','1268438','','2013-12-05','13:22:17',0,'2013-12-25 17:18:14',NULL,NULL),(13197,2041,'0001','999','BE','005010X231A1','889328','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:44',NULL,NULL),(2780,506,'1160173','834','00','005010X220A1','1160173','','2013-12-22','01:04:39',0,'2013-12-25 21:19:39',NULL,NULL),(5386,1011,'93079','834','00','005010X220A1','93079','','2013-11-25','16:05:34',0,'2013-12-26 01:17:03',NULL,NULL),(19819,3679,'2774129','834','00','005010X220A1','2774129','','2014-02-15','13:23:29',0,'2014-02-15 22:01:38',NULL,NULL),(7152,1237,'173622','834','00','005010X220A1','173622','','2013-12-18','16:50:36',0,'2013-12-26 04:05:07',NULL,NULL),(11605,1493,'1377916','834','00','005010X220A1','1377916','','2013-12-27','14:40:14',0,'2013-12-28 03:34:51',NULL,NULL),(18051,3319,'2201960','834','00','005010X220A1','2201960','','2014-02-06','14:15:15',0,'2014-02-06 21:00:42',NULL,NULL),(2510,448,'556658','834','00','005010X220A1','556658','','2013-10-13','14:06:17',0,'2013-12-25 20:30:20',NULL,NULL),(22821,4278,'3515593','834','00','005010X220A1','3515593','','2014-03-06','13:37:42',0,'2014-03-06 21:01:19',NULL,NULL),(22105,4177,'3221775','834','00','005010X220A1','3221775','','2014-03-03','09:56:19',0,'2014-03-03 21:30:23',NULL,NULL),(3731,639,'1164833','834','00','005010X220A1','1164833','','2013-12-12','10:56:51',0,'2013-12-25 22:08:36',NULL,NULL),(3893,705,'443159','834','00','005010X220A1','443159','','2013-10-26','16:45:08',0,'2013-12-25 22:31:59',NULL,NULL),(17524,3235,'2163133','834','00','005010X220A1','2163133','','2014-02-03','10:43:24',0,'2014-02-03 21:00:11',NULL,NULL),(17136,3144,'1762481','834','00','005010X220A1','1762481','','2014-01-29','22:05:14',0,'2014-01-30 21:00:28',NULL,NULL),(5635,1047,'865678','834','00','005010X220A1','865678','','2013-12-24','23:28:24',0,'2013-12-26 01:50:50',NULL,NULL),(12720,1678,'2013248','834','00','005010X220A1','2013248','','2014-01-02','17:15:22',0,'2014-01-03 02:05:32',NULL,NULL),(1282,243,'1103158','834','00','005010X220A1','1103158','','2013-12-24','17:11:39',0,'2013-12-25 18:50:13',NULL,NULL),(11244,1454,'2046643','834','00','005010X220A1','2046643','','2013-12-26','14:11:48',0,'2013-12-27 02:01:46',NULL,NULL),(7673,1320,'430914','834','00','005010X220A1','430914','','2013-12-21','12:37:55',0,'2013-12-26 04:39:37',NULL,NULL),(19324,3583,'2890624','834','00','005010X220A1','2890624','','2014-02-13','11:51:55',0,'2014-02-13 22:01:33',NULL,NULL),(19283,3582,'3032882','834','00','005010X220A1','3032882','','2014-02-13','13:46:35',0,'2014-02-13 22:01:00',NULL,NULL),(18364,3405,'2659124','834','00','005010X220A1','2659124','','2014-02-09','15:37:47',0,'2014-02-09 19:00:11',NULL,NULL),(17586,3237,'1804081','834','00','005010X220A1','1804081','','2014-02-03','14:50:45',0,'2014-02-03 21:00:48',NULL,NULL),(16452,3006,'2027947','834','00','005010X220A1','2027947','','2014-01-24','12:39:20',0,'2014-01-24 21:00:13',NULL,NULL),(15948,2763,'1484344','834','00','005010X220A1','1484344','','2014-01-21','19:01:38',0,'2014-01-23 03:01:49',NULL,NULL),(663,108,'137704','834','00','005010X220A1','137704','','2013-12-16','17:29:08',0,'2013-12-25 18:05:34',NULL,NULL),(3531,616,'642510','834','00','005010X220A1','642510','','2013-12-11','23:03:55',0,'2013-12-25 22:02:11',NULL,NULL),(7603,1303,'1148883','834','00','005010X220A1','1148883','','2013-12-21','10:16:39',0,'2013-12-26 04:37:22',NULL,NULL),(1021,191,'1152003','834','00','005010X220A1','1152003','','2013-12-03','17:41:09',0,'2013-12-25 18:20:55',NULL,NULL),(2837,511,'97887','834','00','005010X220A1','97887','','2013-12-21','23:55:50',0,'2013-12-25 21:21:34',NULL,NULL),(6077,1165,'993292','834','00','005010X220A1','993292','','2013-12-19','18:52:16',0,'2013-12-26 03:00:35',NULL,NULL),(2703,502,'1425941','834','00','005010X220A1','1425941','','2013-12-22','16:51:33',0,'2013-12-25 21:17:18',NULL,NULL),(23380,4398,'3291898','834','00','005010X220A1','3291898','','2014-03-08','16:52:46',0,'2014-03-08 21:31:20',NULL,NULL),(11770,1528,'76210','834','00','005010X220A1','76210','','2013-12-27','19:30:00',1,'2013-12-29 11:10:01',NULL,NULL),(11751,1522,'1939459','834','00','005010X220A1','1939459','','2013-12-28','12:12:33',1,'2013-12-29 11:09:29',NULL,NULL),(6170,1167,'1021886','834','00','005010X220A1','1021886','','2013-12-20','15:18:44',0,'2013-12-26 03:03:25',NULL,NULL),(20943,3946,'3561671','834','00','005010X220A1','3561671','','2014-02-24','15:47:40',0,'2014-02-26 08:00:37',NULL,NULL),(19589,3629,'3455860','834','00','005010X220A1','3455860','','2014-02-14','15:54:48',0,'2014-02-14 21:31:29',NULL,NULL),(2520,453,'544547','834','00','005010X220A1','544547','','2013-10-13','17:16:00',0,'2013-12-25 20:30:37',NULL,NULL),(18869,3493,'2839203','834','00','005010X220A1','2839203','','2014-02-11','13:15:49',0,'2014-02-11 21:02:08',NULL,NULL),(17935,3297,'2177278','834','00','005010X220A1','2177278','','2014-02-04','19:23:18',0,'2014-02-05 21:30:47',NULL,NULL),(17550,3236,'2052932','834','00','005010X220A1','2052932','','2014-02-02','20:32:57',0,'2014-02-03 21:00:27',NULL,NULL),(16311,2980,'1550318','834','00','005010X220A1','1550318','','2014-01-23','12:55:28',0,'2014-01-23 21:00:21',NULL,NULL),(4768,861,'437125','834','00','005010X220A1','437125','','2013-12-01','16:21:51',0,'2013-12-26 00:00:56',NULL,NULL),(2363,413,'264429','834','00','005010X220A1','264429','','2013-12-05','22:44:57',0,'2013-12-25 20:16:06',NULL,NULL),(19634,3643,'3120186','834','00','005010X220A1','3120186','','2014-02-14','14:33:13',0,'2014-02-14 21:32:03',NULL,NULL),(5668,1053,'1953886','834','00','005010X220A1','1953886','','2013-12-24','23:27:06',0,'2013-12-26 01:51:58',NULL,NULL),(15650,2682,'1919501','834','00','005010X220A1','1919501','','2014-01-17','23:19:33',0,'2014-01-21 08:44:24',NULL,NULL),(15602,2661,'1679408','834','00','005010X220A1','1679408','','2014-01-17','12:09:24',0,'2014-01-20 08:06:27',NULL,NULL),(5770,1072,'985480','834','00','005010X220A1','985480','','2013-12-14','16:31:56',0,'2013-12-26 02:02:33',NULL,NULL),(6290,1172,'868132','834','00','005010X220A1','868132','','2013-12-20','17:53:32',0,'2013-12-26 03:07:07',NULL,NULL),(10847,1405,'268980','834','00','005010X220A1','268980','','2013-12-23','13:37:08',0,'2013-12-26 13:05:23',NULL,NULL),(859,175,'603325','834','00','005010X220A1','603325','','2013-12-03','16:58:08',0,'2013-12-25 18:15:55',NULL,NULL),(710,117,'556309','834','00','005010X220A1','556309','','2013-12-16','15:00:04',0,'2013-12-25 18:07:02',NULL,NULL),(22000,4146,'3172708','834','00','005010X220A1','3172708','','2014-03-02','15:37:07',0,'2014-03-03 01:00:23',NULL,NULL),(11067,1421,'1314890','834','00','005010X220A1','1314890','','2013-12-23','13:23:07',0,'2013-12-26 13:13:03',NULL,NULL),(5202,949,'1088051','834','00','005010X220A1','1088051','','2013-12-11','13:23:51',0,'2013-12-26 00:52:26',NULL,NULL),(20948,3949,'3520126','834','00','005010X220A1','3520126','','2014-02-23','22:56:22',0,'2014-02-26 08:00:40',NULL,NULL),(19660,3652,'2768760','834','00','005010X220A1','2768760','','2014-02-14','10:32:48',0,'2014-02-14 21:32:22',NULL,NULL),(1465,252,'304764','834','00','005010X220A1','304764','','2013-12-24','15:02:57',0,'2013-12-25 18:56:17',NULL,NULL),(2303,400,'747333','834','00','005010X220A1','747333','','2013-11-01','21:34:02',0,'2013-12-25 20:01:19',NULL,NULL),(17397,3198,'2128593','834','00','005010X220A1','2128593','','2014-02-01','13:00:06',0,'2014-02-01 19:00:07',NULL,NULL),(12200,1609,'2171004','834','00','005010X220A1','2171004','','2013-12-30','18:00:49',0,'2014-01-01 12:09:17',NULL,NULL),(14428,2449,'0001','999','BE','005010X231A1','378477','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:39',NULL,NULL),(11596,1493,'233510','834','00','005010X220A1','233510','','2013-12-26','23:54:03',0,'2013-12-28 03:34:37',NULL,NULL),(22505,4247,'3463229','834','00','005010X220A1','3463229','','2014-03-04','23:45:43',0,'2014-03-05 21:30:10',NULL,NULL),(15521,2649,'2082785','834','00','005010X220A1','2082785','','2014-01-16','17:16:20',0,'2014-01-17 03:36:40',NULL,NULL),(16838,3091,'2674439','834','00','005010X220A1','2674439','','2014-01-28','16:08:37',0,'2014-01-28 21:00:31',NULL,NULL),(18589,3454,'2602397','834','00','005010X220A1','2602397','','2014-02-10','12:32:07',0,'2014-02-10 21:30:55',NULL,NULL),(5397,1019,'1042457','834','00','005010X220A1','1042457','','2013-11-13','18:26:48',0,'2013-12-26 01:30:05',NULL,NULL),(1892,325,'1053212','834','00','005010X220A1','1053212','','2013-12-09','10:58:48',0,'2013-12-25 19:31:31',NULL,NULL),(19167,3557,'2358629','834','00','005010X220A1','2358629','','2014-02-12','16:28:21',0,'2014-02-12 21:32:22',NULL,NULL),(18721,3485,'2889370','834','00','005010X220A1','2889370','','2014-02-11','00:09:46',0,'2014-02-11 21:00:16',NULL,NULL),(7097,1236,'152132','834','00','005010X220A1','152132','','2013-12-18','11:41:22',0,'2013-12-26 04:03:30',NULL,NULL),(18406,3414,'2498222','834','00','005010X220A1','2498222','','2014-02-09','13:07:05',0,'2014-02-09 19:00:40',NULL,NULL),(17068,3127,'2492780','834','00','005010X220A1','2492780','','2014-01-29','10:02:07',0,'2014-01-29 21:01:38',NULL,NULL),(2167,362,'1286901','834','00','005010X220A1','1286901','','2013-12-02','15:08:47',0,'2013-12-25 19:47:01',NULL,NULL),(12144,1591,'1985558','834','00','005010X220A1','1985558','','2013-12-30','10:01:14',0,'2014-01-01 12:07:15',NULL,NULL),(13553,2246,'1569192','834','00','005010X220A1','1569192','','2014-01-06','16:52:32',0,'2014-01-07 04:06:36',NULL,NULL),(1888,325,'1258897','834','00','005010X220A1','1258897','','2013-12-09','08:00:19',0,'2013-12-25 19:31:26',NULL,NULL),(22073,4172,'2895803','834','00','005010X220A1','2895803','','2014-03-03','12:07:48',0,'2014-03-03 21:00:25',NULL,NULL),(21981,4145,'3419947','834','00','005010X220A1','3419947','','2014-03-01','19:30:56',0,'2014-03-03 01:00:13',NULL,NULL),(21656,4076,'3219551','834','00','005010X220A1','3219551','','2014-02-28','17:55:05',0,'2014-02-28 21:00:04',NULL,NULL),(20747,3903,'2989319','834','00','005010X220A1','2989319','','2014-02-25','13:45:32',0,'2014-02-25 21:30:16',NULL,NULL),(10544,1402,'315898','834','00','005010X220A1','315898','','2013-12-22','18:52:34',0,'2013-12-26 12:55:18',NULL,NULL),(19402,3593,'2165658','834','00','005010X220A1','2165658','','2014-02-13','12:34:14',0,'2014-02-13 22:02:31',NULL,NULL),(18318,3384,'1905636','834','00','005010X220A1','1905636','','2014-02-08','16:03:42',0,'2014-02-08 19:00:46',NULL,NULL),(2295,397,'139453','834','00','005010X220A1','139453','','2013-11-24','14:41:19',0,'2013-12-25 20:01:01',NULL,NULL),(16527,3017,'2295794','834','00','005010X220A1','2295794','','2014-01-24','13:06:27',0,'2014-01-24 21:00:58',NULL,NULL),(15049,2585,'2502434','834','00','005010X220A1','2502434','','2014-01-14','20:01:10',0,'2014-01-16 08:44:49',NULL,NULL),(14777,2551,'1787755','834','00','005010X220A1','1787755','','2014-01-14','13:15:43',0,'2014-01-15 02:06:35',NULL,NULL),(12932,1724,'1745292','834','00','005010X220A1','1745292','','2014-01-03','15:35:51',0,'2014-01-04 02:06:08',NULL,NULL),(4216,738,'831036','834','00','005010X220A1','831036','','2013-12-18','20:02:40',0,'2013-12-25 23:06:42',NULL,NULL),(4037,731,'245571','834','00','005010X220A1','245571','','2013-12-19','15:55:52',0,'2013-12-25 23:01:15',NULL,NULL),(694,111,'801062','834','00','005010X220A1','801062','','2013-12-15','21:08:43',0,'2013-12-25 18:06:33',NULL,NULL),(20831,3911,'3686806','834','00','005010X220A1','3686806','','2014-02-25','00:43:11',0,'2014-02-25 21:31:16',NULL,NULL),(20727,3899,'3384419','834','00','005010X220A1','3384419','','2014-02-25','10:54:50',0,'2014-02-25 21:00:30',NULL,NULL),(4979,935,'320569','834','00','005010X220A1','320569','','2013-12-10','20:10:54',0,'2013-12-26 00:45:19',NULL,NULL),(1411,247,'935885','834','00','005010X220A1','935885','','2013-12-24','17:27:26',0,'2013-12-25 18:54:23',NULL,NULL),(22108,4177,'3624247','834','00','005010X220A1','3624247','','2014-03-02','18:42:44',0,'2014-03-03 21:30:26',NULL,NULL),(12904,1713,'1311099','834','00','005010X220A1','1311099','','2014-01-03','12:38:42',0,'2014-01-04 02:05:02',NULL,NULL),(12966,1734,'1316706','834','00','005010X220A1','1316706','','2014-01-04','11:00:09',0,'2014-01-05 00:00:57',NULL,NULL),(16419,3000,'1878222','834','00','005010X220A1','1878222','','2014-01-23','11:34:13',0,'2014-01-23 21:01:34',NULL,NULL),(16213,2905,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:00:00',1,'2014-01-23 05:03:21',NULL,NULL),(15007,2584,'1910040','834','00','005010X220A1','1910040','','2014-01-15','10:29:10',0,'2014-01-16 08:44:22',NULL,NULL),(11945,1580,'1528993','834','00','005010X220A1','1528993','','2013-12-29','18:40:46',0,'2014-01-01 12:00:02',NULL,NULL),(1771,298,'395712','834','00','005010X220A1','395712','','2013-12-09','20:29:30',0,'2013-12-25 19:18:38',NULL,NULL),(20120,3772,'3096650','834','00','005010X220A1','3096650','','2014-02-19','07:57:41',0,'2014-02-20 03:52:28',NULL,NULL),(6432,1203,'610449','834','00','005010X220A1','610449','','2013-11-22','11:15:29',0,'2013-12-26 03:15:29',NULL,NULL),(2768,506,'641727','834','00','005010X220A1','641727','','2013-12-21','20:37:52',0,'2013-12-25 21:19:17',NULL,NULL),(4391,774,'165448','834','00','005010X220A1','165448','','2013-11-27','14:39:22',0,'2013-12-25 23:15:40',NULL,NULL),(4087,733,'326035','834','00','005010X220A1','326035','','2013-12-19','10:27:08',0,'2013-12-25 23:02:53',NULL,NULL),(3729,638,'1055587','834','00','005010X220A1','1055587','','2013-12-12','13:47:18',0,'2013-12-25 22:08:32',NULL,NULL),(23274,4380,'3161756','834','00','005010X220A1','3161756','','2014-03-07','21:18:34',0,'2014-03-08 21:30:00',NULL,NULL),(12954,1734,'2062921','834','00','005010X220A1','2062921','','2014-01-03','18:43:13',0,'2014-01-05 00:00:27',NULL,NULL),(22927,4292,'2736838','834','00','005010X220A1','2736838','','2014-03-06','10:37:23',0,'2014-03-06 21:02:36',NULL,NULL),(21022,3971,'2974260','834','00','005010X220A1','2974260','','2014-02-22','16:32:56',0,'2014-02-26 08:30:57',NULL,NULL),(7697,1331,'1201205','834','00','005010X220A1','1201205','','2013-11-15','12:37:52',0,'2013-12-26 04:45:21',NULL,NULL),(16795,3088,'2228324','834','00','005010X220A1','2228324','','2014-01-28','04:44:01',0,'2014-01-28 21:00:05',NULL,NULL),(16778,3078,'1380124','834','00','005010X220A1','1380124','','2014-01-27','12:39:51',0,'2014-01-27 21:01:40',NULL,NULL),(16143,2835,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:56:32',NULL,NULL),(16106,2798,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:42:09',NULL,NULL),(7068,1236,'608805','834','00','005010X220A1','608805','','2013-12-17','21:16:38',0,'2013-12-26 04:02:34',NULL,NULL),(11866,1557,'466869','834','00','005010X220A1','466869','','2013-12-28','20:24:27',1,'2013-12-29 11:15:21',NULL,NULL),(602,107,'380065','834','00','005010X220A1','380065','','2013-12-16','15:53:48',0,'2013-12-25 18:03:39',NULL,NULL),(21857,4114,'3520317','834','00','005010X220A1','3520317','','2014-02-28','18:36:16',0,'2014-03-01 19:00:07',NULL,NULL),(21316,4011,'3183981','834','00','005010X220A1','3183981','','2014-02-26','00:05:13',0,'2014-02-26 21:02:37',NULL,NULL),(4210,737,'461572','834','00','005010X220A1','461572','','2013-12-19','14:37:53',0,'2013-12-25 23:06:32',NULL,NULL),(19097,3543,'2649249','834','00','005010X220A1','2649249','','2014-02-12','12:03:04',0,'2014-02-12 21:31:36',NULL,NULL),(17774,3265,'1859167','834','00','005010X220A1','1859167','','2014-02-04','01:00:01',0,'2014-02-04 21:01:15',NULL,NULL),(16615,3049,'2024260','834','00','005010X220A1','2024260','','2014-01-26','15:54:48',0,'2014-01-26 19:00:13',NULL,NULL),(16563,3034,'2204129','834','00','005010X220A1','2204129','','2014-01-24','23:02:23',0,'2014-01-25 19:00:03',NULL,NULL),(16070,2773,'1923427','834','00','005010X220A1','1923427','','2014-01-22','12:15:52',0,'2014-01-23 03:02:45',NULL,NULL),(4820,873,'660800','834','00','005010X220A1','660800','','2013-12-01','14:06:09',0,'2013-12-26 00:02:28',NULL,NULL),(5473,1040,'730795','834','00','005010X220A1','730795','','2013-12-24','22:07:30',0,'2013-12-26 01:45:32',NULL,NULL),(11827,1541,'1067611','834','00','005010X220A1','1067611','','2013-12-28','20:06:05',1,'2013-12-29 11:13:58',NULL,NULL),(1181,239,'1269404','834','00','005010X220A1','1269404','','2013-12-24','15:06:44',0,'2013-12-25 18:47:10',NULL,NULL),(23572,4436,'3563450','834','00','005010X220A1','3563450','','2014-03-10','13:36:54',0,'2014-03-10 21:00:57',NULL,NULL),(452,82,'652628','834','00','005010X220A1','652628','','2013-12-04','12:46:23',0,'2013-12-25 17:50:01',NULL,NULL),(22427,4225,'3514017','834','00','005010X220A1','3514017','','2014-03-04','15:42:29',0,'2014-03-04 21:02:43',NULL,NULL),(17724,3261,'1879644','834','00','005010X220A1','1879644','','2014-02-04','15:58:01',0,'2014-02-04 21:00:43',NULL,NULL),(4429,792,'872072','834','00','005010X220A1','872072','','2013-11-05','18:05:15',0,'2013-12-25 23:17:01',NULL,NULL),(2147,360,'1194012','834','00','005010X220A1','1194012','','2013-12-02','16:53:18',0,'2013-12-25 19:46:22',NULL,NULL),(943,181,'1042640','834','00','005010X220A1','1042640','','2013-12-03','13:46:07',0,'2013-12-25 18:18:26',NULL,NULL),(5239,957,'1026184','834','00','005010X220A1','1026184','','2013-12-11','09:42:39',0,'2013-12-26 00:53:39',NULL,NULL),(11493,1489,'1692185','834','00','005010X220A1','1692185','','2013-12-26','21:31:57',0,'2013-12-28 03:31:27',NULL,NULL),(1598,281,'1098060','834','00','005010X220A1','1098060','','2013-11-19','22:58:36',0,'2013-12-25 19:01:09',NULL,NULL),(2237,372,'1053066','834','00','005010X220A1','1053066','','2013-12-02','10:36:39',0,'2013-12-25 19:49:26',NULL,NULL),(20588,3870,'3342202','834','00','005010X220A1','3342202','','2014-02-20','23:41:02',0,'2014-02-21 22:00:06',NULL,NULL),(20217,3782,'2992785','834','00','005010X220A1','2992785','','2014-02-19','15:30:53',0,'2014-02-20 04:22:18',NULL,NULL),(19491,3620,'3167261','834','00','005010X220A1','3167261','','2014-02-14','14:48:21',0,'2014-02-14 21:30:20',NULL,NULL),(18886,3497,'2364985','834','00','005010X220A1','2364985','','2014-02-11','13:07:45',0,'2014-02-11 21:02:23',NULL,NULL),(4449,801,'883700','834','00','005010X220A1','883700','','2013-11-25','20:44:52',0,'2013-12-25 23:30:24',NULL,NULL),(13878,2312,'1516158','834','00','005010X220A1','1516158','','2014-01-09','10:38:05',0,'2014-01-13 02:19:31',NULL,NULL),(257,47,'1140382','834','00','005010X220A1','1140382','','2013-11-13','16:47:41',0,'2013-12-25 17:31:06',NULL,NULL),(2874,518,'18581','834','00','005010X220A1','18581','','2013-12-22','11:20:19',0,'2013-12-25 21:22:46',NULL,NULL),(23370,4394,'2924478','834','00','005010X220A1','2924478','','2014-03-07','20:33:48',0,'2014-03-08 21:31:13',NULL,NULL),(2891,530,'865422','834','00','005010X220A1','865422','','2013-12-22','17:29:53',0,'2013-12-25 21:23:24',NULL,NULL),(21854,4113,'3802699','834','00','005010X220A1','3802699','','2014-03-01','17:48:27',0,'2014-03-01 19:00:04',NULL,NULL),(20013,3750,'2425113','834','00','005010X220A1','2425113','','2014-02-18','08:13:04',0,'2014-02-18 22:00:42',NULL,NULL),(19012,3539,'2991472','834','00','005010X220A1','2991472','','2014-02-12','11:49:30',0,'2014-02-12 21:30:34',NULL,NULL),(3483,615,'560990','834','00','005010X220A1','560990','','2013-12-12','09:39:40',0,'2013-12-25 22:00:38',NULL,NULL),(18204,3355,'2767052','834','00','005010X220A1','2767052','','2014-02-07','17:07:31',0,'2014-02-07 19:00:36',NULL,NULL),(17890,3294,'2277811','834','00','005010X220A1','2277811','','2014-02-05','16:13:52',0,'2014-02-05 21:30:25',NULL,NULL),(16393,2991,'1559193','834','00','005010X220A1','1559193','','2014-01-23','13:27:01',0,'2014-01-23 21:01:18',NULL,NULL),(3545,616,'1054510','834','00','005010X220A1','1054510','','2013-12-12','12:50:54',0,'2013-12-25 22:02:38',NULL,NULL),(12298,1627,'2461459','834','00','005010X220A1','2461459','','2014-01-01','09:04:30',1,'2014-01-02 04:25:13',NULL,NULL),(4596,826,'1681612','834','00','005010X220A1','1681612','','2013-12-23','23:47:37',0,'2013-12-25 23:47:08',NULL,NULL),(15280,2610,'1765684','834','00','005010X220A1','1765684','','2014-01-15','16:52:32',0,'2014-01-16 08:47:18',NULL,NULL),(22928,4292,'3283325','834','00','005010X220A1','3283325','','2014-03-06','11:37:40',0,'2014-03-06 21:02:36',NULL,NULL),(23741,4469,'2943436','834','00','005010X220A1','2943436','','2014-03-10','16:56:01',0,'2014-03-10 21:03:00',NULL,NULL),(1240,243,'1589744','834','00','005010X220A1','1589744','','2013-12-24','10:58:11',0,'2013-12-25 18:48:55',NULL,NULL),(1670,290,'819580','834','00','005010X220A1','819580','','2013-12-09','22:42:30',0,'2013-12-25 19:15:33',NULL,NULL),(19014,3539,'2330855','834','00','005010X220A1','2330855','','2014-02-12','13:08:14',0,'2014-02-12 21:30:36',NULL,NULL),(2507,448,'37416','834','00','005010X220A1','37416','','2013-10-12','19:39:45',0,'2013-12-25 20:30:15',NULL,NULL),(18280,3378,'2776436','834','00','005010X220A1','2776436','','2014-02-08','17:52:33',0,'2014-02-08 19:00:22',NULL,NULL),(3205,578,'1059626','834','00','005010X220A1','1059626','','2013-12-16','23:28:07',0,'2013-12-25 21:45:26',NULL,NULL),(17760,3262,'2473009','834','00','005010X220A1','2473009','','2014-02-04','15:11:26',0,'2014-02-04 21:01:06',NULL,NULL),(17757,3262,'2163170','834','00','005010X220A1','2163170','','2014-02-04','13:56:31',0,'2014-02-04 21:01:04',NULL,NULL),(3632,622,'489316','834','00','005010X220A1','489316','','2013-12-12','10:38:06',0,'2013-12-25 22:05:21',NULL,NULL),(11889,1561,'1626840','834','00','005010X220A1','1626840','','2013-12-28','19:10:25',0,'2013-12-30 00:00:40',NULL,NULL),(16757,3069,'2047408','834','00','005010X220A1','2047408','','2014-01-27','00:47:12',0,'2014-01-27 21:01:23',NULL,NULL),(14599,2521,'1672929','834','00','005010X220A1','1672929','','2014-01-13','14:12:02',0,'2014-01-14 01:33:06',NULL,NULL),(14292,2380,'2494966','834','00','005010X220A1','2494966','','2014-01-10','11:21:48',0,'2014-01-13 03:00:23',NULL,NULL),(14041,2337,'1670249','834','00','005010X220A1','1670249','','2014-01-08','16:28:54',0,'2014-01-13 02:21:31',NULL,NULL),(13012,1742,'2510743','834','00','005010X220A1','2510743','','2014-01-04','15:18:37',0,'2014-01-05 00:02:36',NULL,NULL),(12594,1671,'1726389','834','00','005010X220A1','1726389','','2014-01-02','12:32:49',0,'2014-01-03 02:00:53',NULL,NULL),(10388,1400,'235881','834','00','005010X220A1','235881','','2013-12-22','23:11:55',0,'2013-12-26 12:50:21',NULL,NULL),(18876,3494,'3227077','834','00','005010X220A1','3227077','','2014-02-11','12:00:49',0,'2014-02-11 21:02:15',NULL,NULL),(2537,456,'637212','834','00','005010X220A1','637212','','2013-11-18','15:47:08',0,'2013-12-25 20:31:06',NULL,NULL),(15846,2738,'2492604','834','00','005010X220A1','2492604','','2014-01-20','22:40:44',1,'2014-01-22 03:22:06',NULL,NULL),(2654,501,'1003575','834','00','005010X220A1','1003575','','2013-12-22','08:50:14',0,'2013-12-25 21:15:31',NULL,NULL),(3056,544,'28823','834','00','005010X220A1','28823','','2013-12-13','14:22:27',0,'2013-12-25 21:34:49',NULL,NULL),(3828,676,'437285','834','00','005010X220A1','437285','','2013-12-08','16:12:09',0,'2013-12-25 22:17:22',NULL,NULL),(23314,4381,'3041157','834','00','005010X220A1','3041157','','2014-03-08','15:10:28',0,'2014-03-08 21:30:30',NULL,NULL),(12920,1716,'2212598','834','00','005010X220A1','2212598','','2014-01-03','09:49:29',0,'2014-01-04 02:05:38',NULL,NULL),(21928,4128,'3205441','834','00','005010X220A1','3205441','','2014-03-01','14:52:01',0,'2014-03-01 21:00:48',NULL,NULL),(12575,1670,'1871271','834','00','005010X220A1','1871271','','2014-01-02','08:29:56',0,'2014-01-03 02:00:08',NULL,NULL),(2336,412,'1030978','834','00','005010X220A1','1030978','','2013-12-06','14:23:12',0,'2013-12-25 20:15:11',NULL,NULL),(4454,801,'444394','834','00','005010X220A1','444394','','2013-11-25','23:15:09',0,'2013-12-25 23:30:33',NULL,NULL),(15180,2591,'2014771','834','00','005010X220A1','2014771','','2014-01-15','16:36:20',0,'2014-01-16 08:46:13',NULL,NULL),(1309,245,'1016933','834','00','005010X220A1','1016933','','2013-12-24','08:46:28',0,'2013-12-25 18:51:05',NULL,NULL),(7642,1309,'824143','834','00','005010X220A1','824143','','2013-12-21','15:54:07',0,'2013-12-26 04:38:35',NULL,NULL),(23481,4424,'2655977','834','00','005010X220A1','2655977','','2014-03-09','15:14:05',0,'2014-03-09 21:01:18',NULL,NULL),(803,153,'337756','834','00','005010X220A1','337756','','2013-10-28','23:35:46',0,'2013-12-25 18:10:16',NULL,NULL),(16471,3008,'1917318','834','00','005010X220A1','1917318','','2014-01-23','20:42:32',0,'2014-01-24 21:00:24',NULL,NULL),(13486,2226,'1479475','834','00','005010X220A1','1479475','','2014-01-06','14:41:50',0,'2014-01-07 04:04:07',NULL,NULL),(13058,1902,'0001','999','BE','005010X231A1','846883','834','2013-12-28','11:05:00',0,'2014-01-05 16:51:42',NULL,NULL),(224,34,'52723','834','00','005010X220A1','52723','','2013-10-11','19:48:16',0,'2013-12-25 17:30:02',NULL,NULL),(14346,2401,'2468455','834','00','005010X220A1','2468455','','2014-01-12','09:25:03',0,'2014-01-13 03:01:22',NULL,NULL),(18250,3376,'2334635','834','00','005010X220A1','2334635','','2014-02-07','18:13:40',0,'2014-02-08 19:00:03',NULL,NULL),(22612,4250,'2890066','834','00','005010X220A1','2890066','','2014-03-05','16:56:07',0,'2014-03-05 21:31:27',NULL,NULL),(3508,615,'227009','834','00','005010X220A1','227009','','2013-12-12','15:44:00',0,'2013-12-25 22:01:28',NULL,NULL),(21786,4092,'3684348','834','00','005010X220A1','3684348','','2014-02-27','18:46:00',0,'2014-02-28 21:31:12',NULL,NULL),(21237,3999,'3404826','834','00','005010X220A1','3404826','','2014-02-26','12:19:27',0,'2014-02-26 21:01:39',NULL,NULL),(18638,3462,'1922449','834','00','005010X220A1','1922449','','2014-02-10','10:46:15',0,'2014-02-10 21:31:31',NULL,NULL),(5130,943,'1267547','834','00','005010X220A1','1267547','','2013-12-11','00:46:26',0,'2013-12-26 00:50:14',NULL,NULL),(12280,1624,'2373339','834','00','005010X220A1','2373339','','2013-12-31','21:54:19',1,'2014-01-02 04:24:32',NULL,NULL),(17785,3268,'2017291','834','00','005010X220A1','2017291','','2014-02-04','11:56:14',0,'2014-02-04 21:01:22',NULL,NULL),(14793,2551,'2143381','834','00','005010X220A1','2143381','','2014-01-14','16:57:33',0,'2014-01-15 02:06:42',NULL,NULL),(15785,2719,'1958319','834','00','005010X220A1','1958319','','2014-01-19','23:41:45',0,'2014-01-21 08:46:39',NULL,NULL),(745,133,'107142','834','00','005010X220A1','107142','','2013-12-16','12:52:24',0,'2013-12-25 18:08:11',NULL,NULL),(19898,3714,'3344250','834','00','005010X220A1','3344250','','2014-02-15','21:33:07',0,'2014-02-16 19:00:38',NULL,NULL),(6406,1196,'374364','834','00','005010X220A1','374364','','2013-12-20','15:29:46',0,'2013-12-26 03:10:41',NULL,NULL),(4007,731,'629579','834','00','005010X220A1','629579','','2013-12-18','22:41:07',0,'2013-12-25 23:00:20',NULL,NULL),(17079,3132,'2027012','834','00','005010X220A1','2027012','','2014-01-29','16:56:49',0,'2014-01-29 21:01:45',NULL,NULL),(3767,654,'1314200','834','00','005010X220A1','1314200','','2013-12-08','11:05:30',0,'2013-12-25 22:15:14',NULL,NULL),(16259,2951,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:48:00',0,'2014-01-23 08:22:15',NULL,NULL),(16250,2942,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',0,'2014-01-23 07:05:59',NULL,NULL),(15937,2754,'2163929','834','00','005010X220A1','2163929','','2014-01-21','16:59:41',1,'2014-01-22 03:23:04',NULL,NULL),(940,181,'460988','834','00','005010X220A1','460988','','2013-12-03','10:52:16',0,'2013-12-25 18:18:21',NULL,NULL),(1429,251,'1290804','834','00','005010X220A1','1290804','','2013-12-24','15:12:17',0,'2013-12-25 18:55:00',NULL,NULL),(22619,4251,'3697896','834','00','005010X220A1','3697896','','2014-03-05','12:35:46',0,'2014-03-05 21:31:32',NULL,NULL),(22872,4281,'2992131','834','00','005010X220A1','2992131','','2014-03-05','21:03:10',0,'2014-03-06 21:01:55',NULL,NULL),(1708,292,'292767','834','00','005010X220A1','292767','','2013-12-10','15:03:08',0,'2013-12-25 19:16:45',NULL,NULL),(21393,4024,'2736615','834','00','005010X220A1','2736615','','2014-02-27','17:39:49',0,'2014-02-28 06:30:32',NULL,NULL),(7748,1344,'364008','834','00','005010X220A1','364008','','2013-10-21','12:03:34',0,'2013-12-26 05:00:47',NULL,NULL),(2028,331,'782448','834','00','005010X220A1','782448','','2013-12-09','16:12:24',0,'2013-12-25 19:35:45',NULL,NULL),(18932,3520,'2816775','834','00','005010X220A1','2816775','','2014-02-11','18:20:14',0,'2014-02-11 21:30:11',NULL,NULL),(17876,3293,'2265103','834','00','005010X220A1','2265103','','2014-02-05','17:27:11',0,'2014-02-05 21:30:18',NULL,NULL),(15629,2675,'1965860','834','00','005010X220A1','1965860','','2014-01-17','18:25:04',0,'2014-01-21 08:44:11',NULL,NULL),(14616,2524,'2426779','834','00','005010X220A1','2426779','','2014-01-13','07:35:57',0,'2014-01-14 01:33:17',NULL,NULL),(13914,2313,'1628496','834','00','005010X220A1','1628496','','2014-01-09','11:48:49',0,'2014-01-13 02:19:53',NULL,NULL),(12349,1634,'2517034','834','00','005010X220A1','2517034','','2013-12-31','13:09:10',1,'2014-01-02 04:27:51',NULL,NULL),(3470,615,'1020042','834','00','005010X220A1','1020042','','2013-12-11','19:43:38',0,'2013-12-25 22:00:13',NULL,NULL),(3517,615,'715513','834','00','005010X220A1','715513','','2013-12-12','16:54:23',0,'2013-12-25 22:01:43',NULL,NULL),(7423,1295,'714470','834','00','005010X220A1','714470','','2013-12-21','11:13:52',0,'2013-12-26 04:31:36',NULL,NULL),(10488,1400,'485961','834','00','005010X220A1','485961','','2013-12-23','16:29:23',0,'2013-12-26 12:53:30',NULL,NULL),(6243,1170,'383789','834','00','005010X220A1','383789','','2013-12-19','19:10:13',0,'2013-12-26 03:05:42',NULL,NULL),(19346,3583,'3400299','834','00','005010X220A1','3400299','','2014-02-13','16:29:14',0,'2014-02-13 22:01:49',NULL,NULL),(17649,3250,'2610540','834','00','005010X220A1','2610540','','2014-02-03','18:04:10',0,'2014-02-03 21:01:29',NULL,NULL),(17360,3181,'1948963','834','00','005010X220A1','1948963','','2014-01-31','16:45:26',0,'2014-01-31 21:01:24',NULL,NULL),(5040,935,'517263','834','00','005010X220A1','517263','','2013-12-11','17:10:24',0,'2013-12-26 00:47:15',NULL,NULL),(17255,3170,'1952265','834','00','005010X220A1','1952265','','2014-01-30','21:36:44',0,'2014-01-31 21:00:10',NULL,NULL),(3278,583,'1088253','834','00','005010X220A1','1088253','','2013-12-16','22:50:11',0,'2013-12-25 21:47:45',NULL,NULL),(12042,1583,'2169801','834','00','005010X220A1','2169801','','2013-12-30','16:11:49',0,'2014-01-01 12:03:40',NULL,NULL),(14824,2552,'2574714','834','00','005010X220A1','2574714','','2014-01-14','16:54:06',0,'2014-01-15 02:06:55',NULL,NULL),(14021,2337,'2316457','834','00','005010X220A1','2316457','','2014-01-08','11:44:31',0,'2014-01-13 02:21:19',NULL,NULL),(13308,2152,'0001','999','BE','005010X231A1','226590','834','2013-12-27','16:55:00',0,'2014-01-05 17:24:34',NULL,NULL),(22647,4253,'3710104','834','00','005010X220A1','3710104','','2014-03-05','15:34:03',0,'2014-03-05 21:31:51',NULL,NULL),(22873,4281,'3452674','834','00','005010X220A1','3452674','','2014-03-05','22:01:24',0,'2014-03-06 21:01:56',NULL,NULL),(23694,4450,'3171639','834','00','005010X220A1','3171639','','2014-03-10','15:16:55',0,'2014-03-10 21:02:24',NULL,NULL),(3340,587,'1070941','834','00','005010X220A1','1070941','','2013-12-16','19:33:36',0,'2013-12-25 21:49:51',NULL,NULL),(6356,1180,'40754','834','00','005010X220A1','40754','','2013-12-20','09:55:06',0,'2013-12-26 03:09:05',NULL,NULL),(12512,1643,'2336592','834','00','005010X220A1','2336592','','2013-12-31','09:23:38',1,'2014-01-02 04:33:48',NULL,NULL),(20959,3953,'3239711','834','00','005010X220A1','3239711','','2014-02-24','16:23:50',0,'2014-02-26 08:00:47',NULL,NULL),(19093,3543,'3253036','834','00','005010X220A1','3253036','','2014-02-12','11:21:38',0,'2014-02-12 21:31:33',NULL,NULL),(12883,1706,'2235474','834','00','005010X220A1','2235474','','2014-01-03','16:53:38',0,'2014-01-04 02:04:16',NULL,NULL),(17365,3182,'1938927','834','00','005010X220A1','1938927','','2014-01-31','11:42:39',0,'2014-01-31 21:01:27',NULL,NULL),(16886,3096,'2154615','834','00','005010X220A1','2154615','','2014-01-28','12:33:16',0,'2014-01-28 21:01:03',NULL,NULL),(475,93,'306337','834','00','005010X220A1','306337','','2013-12-04','13:12:16',0,'2013-12-25 17:50:50',NULL,NULL),(21579,4055,'2791556','834','00','005010X220A1','2791556','','2014-02-26','15:30:41',0,'2014-02-28 07:00:20',NULL,NULL),(3192,578,'680118','834','00','005010X220A1','680118','','2013-12-16','18:39:29',0,'2013-12-25 21:45:05',NULL,NULL),(18259,3376,'2742361','834','00','005010X220A1','2742361','','2014-02-08','12:19:18',0,'2014-02-08 19:00:09',NULL,NULL),(15216,2594,'1472431','834','00','005010X220A1','1472431','','2014-01-14','21:17:01',0,'2014-01-16 08:46:35',NULL,NULL),(1337,245,'1670954','834','00','005010X220A1','1670954','','2013-12-24','12:32:07',0,'2013-12-25 18:51:59',NULL,NULL),(13981,2324,'2001544','834','00','005010X220A1','2001544','','2014-01-09','10:30:58',0,'2014-01-13 02:20:43',NULL,NULL),(1242,243,'1521773','834','00','005010X220A1','1521773','','2013-12-24','11:06:52',0,'2013-12-25 18:48:58',NULL,NULL),(727,124,'378697','834','00','005010X220A1','378697','','2013-12-16','10:16:01',0,'2013-12-25 18:07:40',NULL,NULL),(6999,1235,'397547','834','00','005010X220A1','397547','','2013-12-17','20:06:22',0,'2013-12-26 04:00:25',NULL,NULL),(370,72,'22973','834','00','005010X220A1','22973','','2013-12-04','17:54:18',0,'2013-12-25 17:47:23',NULL,NULL),(7048,1235,'537341','834','00','005010X220A1','537341','','2013-12-18','17:09:26',0,'2013-12-26 04:01:59',NULL,NULL),(20081,3762,'3511175','834','00','005010X220A1','3511175','','2014-02-18','12:43:06',0,'2014-02-18 22:01:31',NULL,NULL),(16421,3000,'1449232','834','00','005010X220A1','1449232','','2014-01-23','00:42:21',0,'2014-01-23 21:01:36',NULL,NULL),(16434,3006,'2589250','834','00','005010X220A1','2589250','','2014-01-23','23:36:04',0,'2014-01-24 21:00:03',NULL,NULL),(17462,3215,'2358355','834','00','005010X220A1','2358355','','2014-02-01','16:02:36',0,'2014-02-01 19:00:51',NULL,NULL),(17169,3145,'2330543','834','00','005010X220A1','2330543','','2014-01-30','13:29:34',0,'2014-01-30 21:00:49',NULL,NULL),(16517,3014,'1429148','834','00','005010X220A1','1429148','','2014-01-24','13:40:51',0,'2014-01-24 21:00:52',NULL,NULL),(1250,243,'1437212','834','00','005010X220A1','1437212','','2013-12-24','11:32:05',0,'2013-12-25 18:49:10',NULL,NULL),(6144,1166,'1314706','834','00','005010X220A1','1314706','','2013-12-20','16:47:26',0,'2013-12-26 03:02:37',NULL,NULL),(3556,616,'995544','834','00','005010X220A1','995544','','2013-12-12','15:35:26',0,'2013-12-25 22:02:59',NULL,NULL),(20105,3772,'3022184','834','00','005010X220A1','3022184','','2014-02-18','18:06:17',0,'2014-02-20 03:43:58',NULL,NULL),(19859,3703,'3488602','834','00','005010X220A1','3488602','','2014-02-15','23:40:33',0,'2014-02-16 19:00:06',NULL,NULL),(10756,1403,'1364791','834','00','005010X220A1','1364791','','2013-12-23','18:37:15',0,'2013-12-26 13:02:28',NULL,NULL),(17238,3164,'2056670','834','00','005010X220A1','2056670','','2014-01-30','14:30:08',0,'2014-01-30 21:01:35',NULL,NULL),(18529,3451,'3151061','834','00','005010X220A1','3151061','','2014-02-10','13:21:53',0,'2014-02-10 21:30:14',NULL,NULL),(1364,245,'1980225','834','00','005010X220A1','1980225','','2013-12-24','15:07:03',0,'2013-12-25 18:52:51',NULL,NULL),(22010,4150,'2842229','834','00','005010X220A1','2842229','','2014-03-02','12:09:14',0,'2014-03-03 01:00:29',NULL,NULL),(20366,3821,'2598501','834','00','005010X220A1','2598501','','2014-02-19','16:20:11',0,'2014-02-20 05:31:42',NULL,NULL),(17062,3125,'1516686','834','00','005010X220A1','1516686','','2014-01-29','15:30:18',0,'2014-01-29 21:01:34',NULL,NULL),(1784,300,'906086','834','00','005010X220A1','906086','','2013-12-09','19:54:19',0,'2013-12-25 19:19:05',NULL,NULL),(2302,400,'1168122','834','00','005010X220A1','1168122','','2013-11-01','18:34:20',0,'2013-12-25 20:01:17',NULL,NULL),(23190,4345,'3319730','834','00','005010X220A1','3319730','','2014-03-07','16:29:52',0,'2014-03-07 21:31:38',NULL,NULL),(3252,578,'402267','834','00','005010X220A1','402267','','2013-12-17','17:34:17',0,'2013-12-25 21:46:53',NULL,NULL),(20219,3784,'2766292','834','00','005010X220A1','2766292','','2014-02-18','18:55:26',0,'2014-02-20 04:23:00',NULL,NULL),(19301,3582,'3369240','834','00','005010X220A1','3369240','','2014-02-12','18:38:38',0,'2014-02-13 22:01:14',NULL,NULL),(3310,584,'375311','834','00','005010X220A1','375311','','2013-12-17','14:37:59',0,'2013-12-25 21:48:48',NULL,NULL),(4033,731,'836116','834','00','005010X220A1','836116','','2013-12-19','14:37:33',0,'2013-12-25 23:01:09',NULL,NULL),(17322,3174,'2507595','834','00','005010X220A1','2507595','','2014-01-31','15:07:35',0,'2014-01-31 21:00:55',NULL,NULL),(7408,1295,'681584','834','00','005010X220A1','681584','','2013-12-20','23:02:29',0,'2013-12-26 04:31:07',NULL,NULL),(4643,827,'1581296','834','00','005010X220A1','1581296','','2013-12-24','00:15:36',0,'2013-12-25 23:48:39',NULL,NULL),(5146,943,'507542','834','00','005010X220A1','507542','','2013-12-11','14:33:39',0,'2013-12-26 00:50:40',NULL,NULL),(13613,2268,'1770423','834','00','005010X220A1','1770423','','2014-01-05','00:11:54',1,'2014-01-07 10:23:26',NULL,NULL),(22712,4267,'3406323','834','00','005010X220A1','3406323','','2014-03-05','12:55:19',0,'2014-03-05 21:32:37',NULL,NULL),(13191,2035,'0001','999','BE','005010X231A1','306163','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:27',NULL,NULL),(3209,578,'623213','834','00','005010X220A1','623213','','2013-12-17','08:08:47',0,'2013-12-25 21:45:36',NULL,NULL),(21298,4007,'3257740','834','00','005010X220A1','3257740','','2014-02-26','10:58:12',0,'2014-02-26 21:02:23',NULL,NULL),(20493,3845,'3413148','834','00','005010X220A1','3413148','','2014-02-20','10:19:29',0,'2014-02-20 22:00:58',NULL,NULL),(19457,3611,'3388998','834','00','005010X220A1','3388998','','2014-02-13','14:19:22',0,'2014-02-13 22:03:13',NULL,NULL),(18157,3350,'2659083','834','00','005010X220A1','2659083','','2014-02-06','18:51:46',0,'2014-02-07 19:00:05',NULL,NULL),(3229,578,'476940','834','00','005010X220A1','476940','','2013-12-17','12:27:45',0,'2013-12-25 21:46:12',NULL,NULL),(3506,615,'350301','834','00','005010X220A1','350301','','2013-12-12','14:56:37',0,'2013-12-25 22:01:24',NULL,NULL),(15429,2629,'1589428','834','00','005010X220A1','1589428','','2014-01-16','14:48:50',0,'2014-01-17 03:36:01',NULL,NULL),(13993,2328,'2075269','834','00','005010X220A1','2075269','','2014-01-09','14:55:51',0,'2014-01-13 02:20:52',NULL,NULL),(3620,621,'760219','834','00','005010X220A1','760219','','2013-12-12','14:09:02',0,'2013-12-25 22:04:58',NULL,NULL),(3927,712,'348771','834','00','005010X220A1','348771','','2013-12-07','15:30:23',0,'2013-12-25 22:45:51',NULL,NULL),(763,142,'1033773','834','00','005010X220A1','1033773','','2013-12-16','17:38:01',0,'2013-12-25 18:08:46',NULL,NULL),(10572,1402,'1669671','834','00','005010X220A1','1669671','','2013-12-23','10:57:33',0,'2013-12-26 12:56:16',NULL,NULL),(3026,544,'376245','834','00','005010X220A1','376245','','2013-12-12','19:24:39',0,'2013-12-25 21:33:53',NULL,NULL),(2969,541,'1263954','834','00','005010X220A1','1263954','','2013-12-13','14:33:59',0,'2013-12-25 21:32:10',NULL,NULL),(2946,541,'1307871','834','00','005010X220A1','1307871','','2013-12-13','09:17:58',0,'2013-12-25 21:31:27',NULL,NULL),(311,70,'1070552','834','00','005010X220A1','1070552','','2013-12-03','19:20:08',0,'2013-12-25 17:45:32',NULL,NULL),(13416,2222,'2478973','834','00','005010X220A1','2478973','','2014-01-06','16:14:02',0,'2014-01-07 04:01:26',NULL,NULL),(21321,4014,'2956503','834','00','005010X220A1','2956503','','2014-02-26','14:03:31',0,'2014-02-26 21:02:41',NULL,NULL),(12995,1738,'1399860','834','00','005010X220A1','1399860','','2014-01-04','16:10:42',0,'2014-01-05 00:01:55',NULL,NULL),(20795,3909,'3497405','834','00','005010X220A1','3497405','','2014-02-25','10:31:15',0,'2014-02-25 21:30:51',NULL,NULL),(19365,3589,'3055375','834','00','005010X220A1','3055375','','2014-02-13','09:36:42',0,'2014-02-13 22:02:04',NULL,NULL),(12919,1715,'2052170','834','00','005010X220A1','2052170','','2014-01-03','15:25:21',0,'2014-01-04 02:05:36',NULL,NULL),(4187,734,'868047','834','00','005010X220A1','868047','','2013-12-19','15:53:44',0,'2013-12-25 23:05:50',NULL,NULL),(4843,883,'341697','834','00','005010X220A1','341697','','2013-11-21','14:28:25',0,'2013-12-26 00:15:22',NULL,NULL),(15982,2764,'1690110','834','00','005010X220A1','1690110','','2014-01-22','12:50:24',0,'2014-01-23 03:02:04',NULL,NULL),(6131,1166,'275520','834','00','005010X220A1','275520','','2013-12-20','15:43:38',0,'2013-12-26 03:02:17',NULL,NULL),(15391,2625,'1479777','834','00','005010X220A1','1479777','','2014-01-15','21:34:40',0,'2014-01-17 03:35:43',NULL,NULL),(7344,1280,'190750','834','00','005010X220A1','190750','','2013-11-29','18:25:54',0,'2013-12-26 04:15:16',NULL,NULL),(14788,2551,'2322703','834','00','005010X220A1','2322703','','2014-01-14','15:47:07',0,'2014-01-15 02:06:40',NULL,NULL),(419,77,'667011','834','00','005010X220A1','667011','','2013-12-04','07:52:49',0,'2013-12-25 17:49:00',NULL,NULL),(2585,474,'387765','834','00','005010X220A1','387765','','2013-10-31','18:39:44',0,'2013-12-25 20:45:28',NULL,NULL),(10902,1409,'1120222','834','00','005010X220A1','1120222','','2013-12-23','12:33:48',0,'2013-12-26 13:07:42',NULL,NULL),(11123,1428,'785874','834','00','005010X220A1','785874','','2013-12-23','12:07:46',0,'2013-12-26 13:14:53',NULL,NULL),(1483,253,'581018','834','00','005010X220A1','581018','','2013-12-24','16:14:52',0,'2013-12-25 18:56:51',NULL,NULL),(22478,4239,'2830986','834','00','005010X220A1','2830986','','2014-03-05','15:40:16',0,'2014-03-05 21:00:21',NULL,NULL),(2930,541,'645053','834','00','005010X220A1','645053','','2013-12-12','20:21:41',0,'2013-12-25 21:30:55',NULL,NULL),(6109,1166,'994664','834','00','005010X220A1','994664','','2013-12-20','13:00:36',0,'2013-12-26 03:01:35',NULL,NULL),(23552,4435,'3654848','834','00','005010X220A1','3654848','','2014-03-10','17:37:00',0,'2014-03-10 21:00:42',NULL,NULL),(3386,587,'1292835','834','00','005010X220A1','1292835','','2013-12-17','14:22:28',0,'2013-12-25 21:51:16',NULL,NULL),(11985,1580,'1690851','834','00','005010X220A1','1690851','','2013-12-30','16:48:40',0,'2014-01-01 12:01:32',NULL,NULL),(22644,4253,'3768334','834','00','005010X220A1','3768334','','2014-03-05','13:01:22',0,'2014-03-05 21:31:48',NULL,NULL),(3814,664,'857705','834','00','005010X220A1','857705','','2013-12-08','15:04:03',0,'2013-12-25 22:16:48',NULL,NULL),(13561,2253,'2254274','834','00','005010X220A1','2254274','','2014-01-05','15:50:02',1,'2014-01-07 10:21:13',NULL,NULL),(21505,4030,'3484070','834','00','005010X220A1','3484070','','2014-02-27','16:33:31',0,'2014-02-28 06:31:24',NULL,NULL),(14030,2337,'2547568','834','00','005010X220A1','2547568','','2014-01-08','14:45:20',0,'2014-01-13 02:21:25',NULL,NULL),(15233,2597,'2552908','834','00','005010X220A1','2552908','','2014-01-14','21:46:27',0,'2014-01-16 08:46:46',NULL,NULL),(16323,2982,'2591625','834','00','005010X220A1','2591625','','2014-01-23','15:10:43',0,'2014-01-23 21:00:30',NULL,NULL),(18548,3452,'2934511','834','00','005010X220A1','2934511','','2014-02-10','13:26:49',0,'2014-02-10 21:30:27',NULL,NULL),(13237,2081,'0001','999','BE','005010X231A1','200150','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:35',NULL,NULL),(21901,4127,'2980508','834','00','005010X220A1','2980508','','2014-02-28','22:01:25',0,'2014-03-01 21:00:31',NULL,NULL),(13205,2049,'0001','999','BE','005010X231A1','200150','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:06',NULL,NULL),(12238,1618,'1642474','834','00','005010X220A1','1642474','','2014-01-01','14:45:49',1,'2014-01-02 04:22:57',NULL,NULL),(21170,3997,'3729776','834','00','005010X220A1','3729776','','2014-02-26','17:52:34',0,'2014-02-26 21:00:57',NULL,NULL),(12003,1581,'2457466','834','00','005010X220A1','2457466','','2013-12-30','18:03:18',0,'2014-01-01 12:02:08',NULL,NULL),(17639,3246,'2825119','834','00','005010X220A1','2825119','','2014-02-03','16:02:02',0,'2014-02-03 21:01:21',NULL,NULL),(4682,833,'1429734','834','00','005010X220A1','1429734','','2013-12-23','22:08:17',0,'2013-12-25 23:50:01',NULL,NULL),(4014,731,'305696','834','00','005010X220A1','305696','','2013-12-19','10:41:04',0,'2013-12-25 23:00:33',NULL,NULL),(15843,2738,'1993628','834','00','005010X220A1','1993628','','2014-01-20','19:13:36',1,'2014-01-22 03:22:04',NULL,NULL),(2087,347,'370473','834','00','005010X220A1','370473','','2013-12-09','14:04:39',0,'2013-12-25 19:37:37',NULL,NULL),(14900,2558,'1970725','834','00','005010X220A1','1970725','','2014-01-14','12:19:42',0,'2014-01-15 02:07:30',NULL,NULL),(14527,2518,'1778606','834','00','005010X220A1','1778606','','2014-01-13','00:18:49',0,'2014-01-14 01:32:20',NULL,NULL),(20448,3841,'2752219','834','00','005010X220A1','2752219','','2014-02-20','17:52:02',0,'2014-02-20 22:00:21',NULL,NULL),(22459,4237,'3034573','834','00','005010X220A1','3034573','','2014-03-04','15:25:50',0,'2014-03-04 21:30:23',NULL,NULL),(1428,251,'1317791','834','00','005010X220A1','1317791','','2013-12-24','07:56:12',0,'2013-12-25 18:54:58',NULL,NULL),(7618,1306,'614737','834','00','005010X220A1','614737','','2013-12-20','19:57:13',0,'2013-12-26 04:37:50',NULL,NULL),(17475,3218,'1997559','834','00','005010X220A1','1997559','','2014-02-02','09:05:23',0,'2014-02-02 19:00:10',NULL,NULL),(16448,3006,'1807463','834','00','005010X220A1','1807463','','2014-01-24','12:04:55',0,'2014-01-24 21:00:11',NULL,NULL),(5914,1112,'1228346','834','00','005010X220A1','1228346','','2013-12-15','08:31:38',0,'2013-12-26 02:31:14',NULL,NULL),(3982,721,'200999','834','00','005010X220A1','200999','','2013-12-07','12:43:15',0,'2013-12-25 22:47:38',NULL,NULL),(20822,3910,'2924032','834','00','005010X220A1','2924032','','2014-02-25','15:55:38',0,'2014-02-25 21:31:09',NULL,NULL),(737,129,'624213','834','00','005010X220A1','624213','','2013-12-16','14:24:17',0,'2013-12-25 18:07:57',NULL,NULL),(17491,3220,'1694453','834','00','005010X220A1','1694453','','2014-02-02','12:44:41',0,'2014-02-02 19:00:19',NULL,NULL),(14915,2558,'2529705','834','00','005010X220A1','2529705','','2014-01-14','18:10:12',0,'2014-01-15 02:07:36',NULL,NULL),(5974,1119,'228398','834','00','005010X220A1','228398','','2013-12-15','10:16:11',0,'2013-12-26 02:33:09',NULL,NULL),(3888,703,'765393','834','00','005010X220A1','765393','','2013-10-26','11:25:28',0,'2013-12-25 22:31:49',NULL,NULL),(3271,582,'709766','834','00','005010X220A1','709766','','2013-12-16','18:50:05',0,'2013-12-25 21:47:32',NULL,NULL),(2058,336,'321762','834','00','005010X220A1','321762','','2013-12-09','16:53:26',0,'2013-12-25 19:36:40',NULL,NULL),(2994,542,'38057','834','00','005010X220A1','38057','','2013-12-13','13:40:22',0,'2013-12-25 21:32:56',NULL,NULL),(22376,4207,'3532534','834','00','005010X220A1','3532534','','2014-03-03','19:36:51',0,'2014-03-04 21:02:00',NULL,NULL),(2499,445,'934967','834','00','005010X220A1','934967','','2013-12-05','18:55:01',0,'2013-12-25 20:20:32',NULL,NULL),(3012,543,'1259078','834','00','005010X220A1','1259078','','2013-12-13','12:23:53',0,'2013-12-25 21:33:30',NULL,NULL),(16282,2974,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:20:00',0,'2014-01-23 16:00:02',NULL,NULL),(21221,3998,'2664610','834','00','005010X220A1','2664610','','2014-02-26','17:32:43',0,'2014-02-26 21:01:30',NULL,NULL),(22857,4280,'3338871','834','00','005010X220A1','3338871','','2014-03-06','11:13:34',0,'2014-03-06 21:01:44',NULL,NULL),(12970,1734,'2353074','834','00','005010X220A1','2353074','','2014-01-04','14:59:31',0,'2014-01-05 00:01:05',NULL,NULL),(11337,1456,'1489786','834','00','005010X220A1','1489786','','2013-12-26','16:27:32',0,'2013-12-27 02:04:38',NULL,NULL),(11097,1424,'121785','834','00','005010X220A1','121785','','2013-12-23','17:06:01',0,'2013-12-26 13:13:59',NULL,NULL),(17751,3262,'2671868','834','00','005010X220A1','2671868','','2014-02-04','12:19:45',0,'2014-02-04 21:01:01',NULL,NULL),(17056,3124,'2344385','834','00','005010X220A1','2344385','','2014-01-29','16:15:51',0,'2014-01-29 21:01:31',NULL,NULL),(10728,1403,'1658649','834','00','005010X220A1','1658649','','2013-12-23','14:43:23',0,'2013-12-26 13:01:35',NULL,NULL),(7282,1255,'932959','834','00','005010X220A1','932959','','2013-12-18','12:31:44',0,'2013-12-26 04:09:10',NULL,NULL),(2149,361,'1218887','834','00','005010X220A1','1218887','','2013-12-01','18:27:05',0,'2013-12-25 19:46:25',NULL,NULL),(22315,4201,'3369792','834','00','005010X220A1','3369792','','2014-03-04','15:04:39',0,'2014-03-04 21:01:09',NULL,NULL),(642,108,'1326877','834','00','005010X220A1','1326877','','2013-12-16','13:51:58',0,'2013-12-25 18:04:58',NULL,NULL),(12339,1634,'2320082','834','00','005010X220A1','2320082','','2013-12-31','11:41:18',1,'2014-01-02 04:27:32',NULL,NULL),(17308,3173,'1399198','834','00','005010X220A1','1399198','','2014-01-31','15:48:25',0,'2014-01-31 21:00:46',NULL,NULL),(17179,3148,'2567532','834','00','005010X220A1','2567532','','2014-01-29','19:47:59',0,'2014-01-30 21:00:56',NULL,NULL),(10494,1400,'749846','834','00','005010X220A1','749846','','2013-12-23','17:29:30',0,'2013-12-26 12:53:41',NULL,NULL),(16866,3093,'2291609','834','00','005010X220A1','2291609','','2014-01-28','13:48:00',0,'2014-01-28 21:00:51',NULL,NULL),(2851,512,'1213335','834','00','005010X220A1','1213335','','2013-12-22','09:28:50',0,'2013-12-25 21:22:03',NULL,NULL),(1525,260,'1190284','834','00','005010X220A1','1190284','','2013-12-24','12:33:05',0,'2013-12-25 18:58:13',NULL,NULL),(1267,243,'1921275','834','00','005010X220A1','1921275','','2013-12-24','14:51:34',0,'2013-12-25 18:49:43',NULL,NULL),(3706,633,'416627','834','00','005010X220A1','416627','','2013-12-12','14:41:57',0,'2013-12-25 22:07:42',NULL,NULL),(407,77,'992726','834','00','005010X220A1','992726','','2013-12-03','20:08:04',0,'2013-12-25 17:48:36',NULL,NULL),(7076,1236,'146529','834','00','005010X220A1','146529','','2013-12-18','09:08:06',0,'2013-12-26 04:02:51',NULL,NULL),(878,177,'60372','834','00','005010X220A1','60372','','2013-12-03','09:08:25',0,'2013-12-25 18:16:32',NULL,NULL),(4578,826,'319848','834','00','005010X220A1','319848','','2013-12-23','22:11:56',0,'2013-12-25 23:46:34',NULL,NULL),(3372,587,'1214521','834','00','005010X220A1','1214521','','2013-12-17','14:04:25',0,'2013-12-25 21:50:49',NULL,NULL),(3725,636,'87369','834','00','005010X220A1','87369','','2013-12-12','18:14:12',0,'2013-12-25 22:08:20',NULL,NULL),(13106,1950,'0001','999','BE','005010X231A1','1209271','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:55',NULL,NULL),(12621,1671,'2313791','834','00','005010X220A1','2313791','','2014-01-02','13:57:55',0,'2014-01-03 02:01:50',NULL,NULL),(11390,1463,'1951418','834','00','005010X220A1','1951418','','2013-12-26','15:57:04',0,'2013-12-27 02:06:15',NULL,NULL),(10465,1400,'270276','834','00','005010X220A1','270276','','2013-12-23','14:07:40',0,'2013-12-26 12:52:46',NULL,NULL),(7698,1331,'270520','834','00','005010X220A1','270520','','2013-11-15','14:52:30',0,'2013-12-26 04:45:23',NULL,NULL),(5543,1041,'1894830','834','00','005010X220A1','1894830','','2013-12-25','00:43:49',0,'2013-12-26 01:47:50',NULL,NULL),(10628,1402,'737819','834','00','005010X220A1','737819','','2013-12-23','16:06:46',0,'2013-12-26 12:58:05',NULL,NULL),(13929,2317,'2122838','834','00','005010X220A1','2122838','','2014-01-09','08:33:03',0,'2014-01-13 02:20:04',NULL,NULL),(12868,1706,'1512179','834','00','005010X220A1','1512179','','2014-01-03','11:15:34',0,'2014-01-04 02:03:44',NULL,NULL),(13463,2226,'2012185','834','00','005010X220A1','2012185','','2014-01-06','15:05:03',0,'2014-01-07 04:03:16',NULL,NULL),(22021,4153,'3741980','834','00','005010X220A1','3741980','','2014-03-02','11:04:02',0,'2014-03-03 01:00:36',NULL,NULL),(274,57,'238226','834','00','005010X220A1','238226','','2013-10-11','15:54:42',0,'2013-12-25 17:31:44',NULL,NULL),(18969,3537,'2982476','834','00','005010X220A1','2982476','','2014-02-11','18:32:00',0,'2014-02-12 21:30:04',NULL,NULL),(15958,2764,'2122022','834','00','005010X220A1','2122022','','2014-01-21','19:06:12',0,'2014-01-23 03:01:54',NULL,NULL),(21216,3998,'3788495','834','00','005010X220A1','3788495','','2014-02-26','16:45:56',0,'2014-02-26 21:01:28',NULL,NULL),(21853,4113,'2606236','834','00','005010X220A1','2606236','','2014-03-01','17:48:27',0,'2014-03-01 19:00:04',NULL,NULL),(23347,4387,'3459393','834','00','005010X220A1','3459393','','2014-03-07','19:42:50',0,'2014-03-08 21:30:56',NULL,NULL),(13398,2221,'2364127','834','00','005010X220A1','2364127','','2014-01-06','17:13:24',0,'2014-01-07 04:00:50',NULL,NULL),(12722,1680,'1559964','834','00','005010X220A1','1559964','','2014-01-02','12:19:03',0,'2014-01-03 02:05:37',NULL,NULL),(12422,1638,'1548378','834','00','005010X220A1','1548378','','2013-12-31','10:07:55',1,'2014-01-02 04:30:27',NULL,NULL),(20301,3795,'2365222','834','00','005010X220A1','2365222','','2014-02-19','12:40:43',0,'2014-02-20 04:43:20',NULL,NULL),(11885,1560,'1631912','834','00','005010X220A1','1631912','','2013-12-29','15:59:49',0,'2013-12-30 00:00:33',NULL,NULL),(18298,3380,'2445974','834','00','005010X220A1','2445974','','2014-02-08','15:44:14',0,'2014-02-08 19:00:34',NULL,NULL),(17579,3237,'2357011','834','00','005010X220A1','2357011','','2014-02-03','00:14:39',0,'2014-02-03 21:00:44',NULL,NULL),(4380,774,'962778','834','00','005010X220A1','962778','','2013-11-26','18:29:11',0,'2013-12-25 23:15:21',NULL,NULL),(3596,617,'1118361','834','00','005010X220A1','1118361','','2013-12-12','17:15:19',0,'2013-12-25 22:04:13',NULL,NULL),(16346,2983,'1503766','834','00','005010X220A1','1503766','','2014-01-23','17:54:48',0,'2014-01-23 21:00:46',NULL,NULL),(7450,1296,'657268','834','00','005010X220A1','657268','','2013-12-20','22:03:12',0,'2013-12-26 04:32:24',NULL,NULL),(23124,4342,'3246267','834','00','005010X220A1','3246267','','2014-03-07','10:00:09',0,'2014-03-07 21:30:52',NULL,NULL),(2686,502,'520254','834','00','005010X220A1','520254','','2013-12-22','08:16:42',0,'2013-12-25 21:16:44',NULL,NULL),(7412,1295,'29155','834','00','005010X220A1','29155','','2013-12-20','23:38:35',0,'2013-12-26 04:31:15',NULL,NULL),(20327,3799,'3143562','834','00','005010X220A1','3143562','','2014-02-18','22:45:14',0,'2014-02-20 04:49:47',NULL,NULL),(18816,3489,'2905643','834','00','005010X220A1','2905643','','2014-02-11','16:23:23',0,'2014-02-11 21:01:27',NULL,NULL),(18637,3462,'2195816','834','00','005010X220A1','2195816','','2014-02-10','10:10:01',0,'2014-02-10 21:31:30',NULL,NULL),(17697,3261,'2853596','834','00','005010X220A1','2853596','','2014-02-03','18:57:47',0,'2014-02-04 21:00:29',NULL,NULL),(6214,1168,'666340','834','00','005010X220A1','666340','','2013-12-20','08:57:45',0,'2013-12-26 03:04:43',NULL,NULL),(3581,617,'823691','834','00','005010X220A1','823691','','2013-12-12','12:32:43',0,'2013-12-25 22:03:45',NULL,NULL),(14288,2379,'1898772','834','00','005010X220A1','1898772','','2014-01-10','12:50:31',0,'2014-01-13 03:00:20',NULL,NULL),(13748,2276,'1444945','834','00','005010X220A1','1444945','','2014-01-07','11:24:56',0,'2014-01-08 18:24:51',NULL,NULL),(13269,2113,'0001','999','BE','005010X231A1','615635','834','2013-12-28','11:05:00',0,'2014-01-05 17:22:45',NULL,NULL),(22097,4176,'3035792','834','00','005010X220A1','3035792','','2014-03-03','13:04:12',0,'2014-03-03 21:30:16',NULL,NULL),(23302,4381,'2890193','834','00','005010X220A1','2890193','','2014-03-08','09:35:52',0,'2014-03-08 21:30:22',NULL,NULL),(137,9,'1084277','834','00','005010X220A1','1084277','','2013-12-04','19:08:26',0,'2013-12-25 17:19:14',NULL,NULL),(20066,3756,'2504317','834','00','005010X220A1','2504317','','2014-02-18','10:10:00',0,'2014-02-18 22:01:21',NULL,NULL),(981,184,'1026986','834','00','005010X220A1','1026986','','2013-12-03','10:44:22',0,'2013-12-25 18:19:37',NULL,NULL),(18841,3491,'2431237','834','00','005010X220A1','2431237','','2014-02-11','09:05:51',0,'2014-02-11 21:01:45',NULL,NULL),(17445,3205,'1874648','834','00','005010X220A1','1874648','','2014-02-01','10:47:24',0,'2014-02-01 19:00:38',NULL,NULL),(7041,1235,'1015417','834','00','005010X220A1','1015417','','2013-12-18','15:23:37',0,'2013-12-26 04:01:46',NULL,NULL),(5089,939,'810801','834','00','005010X220A1','810801','','2013-12-10','18:37:09',0,'2013-12-26 00:48:49',NULL,NULL),(1367,245,'1289326','834','00','005010X220A1','1289326','','2013-12-24','15:17:00',0,'2013-12-25 18:52:57',NULL,NULL),(11306,1456,'1987811','834','00','005010X220A1','1987811','','2013-12-26','10:22:26',0,'2013-12-27 02:03:42',NULL,NULL),(636,108,'732687','834','00','005010X220A1','732687','','2013-12-16','12:34:00',0,'2013-12-25 18:04:47',NULL,NULL),(21263,4000,'3482847','834','00','005010X220A1','3482847','','2014-02-26','14:35:45',0,'2014-02-26 21:01:57',NULL,NULL),(1087,218,'57786','834','00','005010X220A1','57786','','2013-11-04','08:40:56',0,'2013-12-25 18:31:31',NULL,NULL),(16706,3064,'1914708','834','00','005010X220A1','1914708','','2014-01-27','10:20:33',0,'2014-01-27 21:00:47',NULL,NULL),(16101,2793,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:41:26',NULL,NULL),(7358,1283,'1065232','834','00','005010X220A1','1065232','','2013-11-30','14:53:38',0,'2013-12-26 04:15:45',NULL,NULL),(3413,592,'455364','834','00','005010X220A1','455364','','2013-12-16','22:34:58',0,'2013-12-25 21:52:08',NULL,NULL),(5725,1069,'753805','834','00','005010X220A1','753805','','2013-12-14','13:55:55',0,'2013-12-26 02:01:10',NULL,NULL),(11949,1580,'1360210','834','00','005010X220A1','1360210','','2013-12-29','21:22:48',0,'2014-01-01 12:00:10',NULL,NULL),(11735,1520,'1995630','834','00','005010X220A1','1995630','','2013-12-28','00:37:34',1,'2013-12-29 11:08:58',NULL,NULL),(5357,1007,'514879','834','00','005010X220A1','514879','','2013-11-25','13:14:49',0,'2013-12-26 01:16:05',NULL,NULL),(3961,716,'319022','834','00','005010X220A1','319022','','2013-12-06','21:42:50',0,'2013-12-25 22:46:56',NULL,NULL),(5343,1002,'238425','834','00','005010X220A1','238425','','2013-11-25','12:48:52',0,'2013-12-26 01:15:37',NULL,NULL),(21866,4120,'3197241','834','00','005010X220A1','3197241','','2014-03-01','15:07:10',0,'2014-03-01 19:00:13',NULL,NULL),(5365,1009,'315065','834','00','005010X220A1','315065','','2013-11-25','13:18:37',0,'2013-12-26 01:16:22',NULL,NULL),(5559,1043,'1381812','834','00','005010X220A1','1381812','','2013-12-24','19:19:51',0,'2013-12-26 01:48:19',NULL,NULL),(4131,733,'205232','834','00','005010X220A1','205232','','2013-12-19','15:02:15',0,'2013-12-25 23:04:08',NULL,NULL),(17921,3296,'2449576','834','00','005010X220A1','2449576','','2014-02-05','11:14:01',0,'2014-02-05 21:30:40',NULL,NULL),(17913,3296,'2184803','834','00','005010X220A1','2184803','','2014-02-05','01:17:47',0,'2014-02-05 21:30:37',NULL,NULL),(17773,3265,'2781196','834','00','005010X220A1','2781196','','2014-02-03','23:16:58',0,'2014-02-04 21:01:14',NULL,NULL),(11917,1565,'2040583','834','00','005010X220A1','2040583','','2013-12-28','22:14:22',0,'2013-12-30 00:01:32',NULL,NULL),(13829,2300,'2433782','834','00','005010X220A1','2433782','','2014-01-11','18:07:01',0,'2014-01-13 02:18:34',NULL,NULL),(14369,2404,'1463540','834','00','005010X220A1','1463540','','2014-01-12','14:16:36',0,'2014-01-13 03:01:40',NULL,NULL),(19784,3675,'2661673','834','00','005010X220A1','2661673','','2014-02-15','14:05:13',0,'2014-02-15 22:01:09',NULL,NULL),(15960,2764,'2460585','834','00','005010X220A1','2460585','','2014-01-21','20:06:41',0,'2014-01-23 03:01:54',NULL,NULL),(19368,3590,'2266615','834','00','005010X220A1','2266615','','2014-02-13','00:25:27',0,'2014-02-13 22:02:06',NULL,NULL),(19152,3553,'2393348','834','00','005010X220A1','2393348','','2014-02-12','13:33:13',0,'2014-02-12 21:32:11',NULL,NULL),(16217,2909,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:15:00',1,'2014-01-23 05:06:42',NULL,NULL),(21869,4122,'3224049','834','00','005010X220A1','3224049','','2014-02-28','19:07:08',0,'2014-03-01 21:00:09',NULL,NULL),(23755,4475,'3319833','834','00','005010X220A1','3319833','','2014-03-10','17:37:12',0,'2014-03-10 21:30:06',NULL,NULL),(1718,293,'282372','834','00','005010X220A1','282372','','2013-12-09','20:12:10',0,'2013-12-25 19:17:03',NULL,NULL),(20641,3874,'3629357','834','00','005010X220A1','3629357','','2014-02-21','13:24:37',0,'2014-02-21 22:00:45',NULL,NULL),(20277,3795,'3457376','834','00','005010X220A1','3457376','','2014-02-19','09:35:47',0,'2014-02-20 04:37:16',NULL,NULL),(21518,4036,'3352577','834','00','005010X220A1','3352577','','2014-02-27','00:21:39',0,'2014-02-28 06:31:30',NULL,NULL),(7404,1295,'699009','834','00','005010X220A1','699009','','2013-12-20','20:45:27',0,'2013-12-26 04:30:59',NULL,NULL),(7368,1286,'600906','834','00','005010X220A1','600906','','2013-11-30','12:02:33',0,'2013-12-26 04:16:10',NULL,NULL),(18198,3354,'1675678','834','00','005010X220A1','1675678','','2014-02-06','18:33:24',0,'2014-02-07 19:00:32',NULL,NULL),(5654,1050,'1557421','834','00','005010X220A1','1557421','','2013-12-25','00:31:55',0,'2013-12-26 01:51:26',NULL,NULL),(15024,2584,'1989558','834','00','005010X220A1','1989558','','2014-01-15','13:21:07',0,'2014-01-16 08:44:32',NULL,NULL),(22062,4168,'3179427','834','00','005010X220A1','3179427','','2014-03-03','15:22:41',0,'2014-03-03 21:00:18',NULL,NULL),(5986,1124,'1033717','834','00','005010X220A1','1033717','','2013-12-14','23:50:23',0,'2013-12-26 02:33:31',NULL,NULL),(21045,3977,'2594743','834','00','005010X220A1','2594743','','2014-02-24','15:49:25',0,'2014-02-26 09:30:22',NULL,NULL),(18887,3498,'3115151','834','00','005010X220A1','3115151','','2014-02-10','22:22:06',0,'2014-02-11 21:02:24',NULL,NULL),(3542,616,'724964','834','00','005010X220A1','724964','','2013-12-12','11:08:07',0,'2013-12-25 22:02:31',NULL,NULL),(18017,3318,'2309722','834','00','005010X220A1','2309722','','2014-02-05','19:30:52',0,'2014-02-06 21:00:19',NULL,NULL),(15981,2764,'2449279','834','00','005010X220A1','2449279','','2014-01-22','12:44:50',0,'2014-01-23 03:02:04',NULL,NULL),(4627,827,'1356202','834','00','005010X220A1','1356202','','2013-12-23','23:04:46',0,'2013-12-25 23:48:09',NULL,NULL),(14487,2508,'0001','999','BE','005010X231A1','306163','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:58',NULL,NULL),(13505,2233,'2289868','834','00','005010X220A1','2289868','','2014-01-06','15:53:17',0,'2014-01-07 04:04:53',NULL,NULL),(22845,4279,'3067064','834','00','005010X220A1','3067064','','2014-03-05','23:28:27',0,'2014-03-06 21:01:36',NULL,NULL),(23174,4345,'3440138','834','00','005010X220A1','3440138','','2014-03-06','20:30:59',0,'2014-03-07 21:31:28',NULL,NULL),(621,108,'776767','834','00','005010X220A1','776767','','2013-12-16','09:47:41',0,'2013-12-25 18:04:17',NULL,NULL),(4700,834,'580948','834','00','005010X220A1','580948','','2013-12-23','22:20:46',0,'2013-12-25 23:50:39',NULL,NULL),(20103,3771,'2806975','834','00','005010X220A1','2806975','','2014-02-19','15:10:40',0,'2014-02-20 03:42:37',NULL,NULL),(19342,3583,'3202486','834','00','005010X220A1','3202486','','2014-02-13','15:25:22',0,'2014-02-13 22:01:45',NULL,NULL),(11264,1455,'1929301','834','00','005010X220A1','1929301','','2013-12-26','09:50:34',0,'2013-12-27 02:02:25',NULL,NULL),(19050,3540,'3288967','834','00','005010X220A1','3288967','','2014-02-12','16:52:20',0,'2014-02-12 21:31:00',NULL,NULL),(17708,3261,'1397730','834','00','005010X220A1','1397730','','2014-02-03','22:19:25',0,'2014-02-04 21:00:34',NULL,NULL),(13506,2233,'1670182','834','00','005010X220A1','1670182','','2014-01-06','15:57:07',0,'2014-01-07 04:04:55',NULL,NULL),(16260,2952,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:09:00',0,'2014-01-23 08:30:02',NULL,NULL),(80,4,'831652','834','00','005010X220A1','831652','','2013-12-04','20:27:34',0,'2013-12-25 17:17:25',NULL,NULL),(12206,1615,'2441140','834','00','005010X220A1','2441140','','2013-12-31','18:34:41',1,'2014-01-02 04:21:43',NULL,NULL),(19794,3677,'2836093','834','00','005010X220A1','2836093','','2014-02-15','09:54:59',0,'2014-02-15 22:01:17',NULL,NULL),(18865,3493,'2251404','834','00','005010X220A1','2251404','','2014-02-11','10:02:45',0,'2014-02-11 21:02:05',NULL,NULL),(18797,3487,'2921242','834','00','005010X220A1','2921242','','2014-02-11','13:55:43',0,'2014-02-11 21:01:13',NULL,NULL),(5715,1069,'561080','834','00','005010X220A1','561080','','2013-12-14','06:14:25',0,'2013-12-26 02:00:56',NULL,NULL),(6072,1164,'755334','834','00','005010X220A1','755334','','2013-12-20','15:34:33',0,'2013-12-26 03:00:24',NULL,NULL),(15783,2718,'1508797','834','00','005010X220A1','1508797','','2014-01-19','21:47:37',0,'2014-01-21 08:46:37',NULL,NULL),(15290,2616,'2045689','834','00','005010X220A1','2045689','','2014-01-15','14:07:46',0,'2014-01-16 08:47:25',NULL,NULL),(13809,2296,'1605642','834','00','005010X220A1','1605642','','2014-01-11','12:53:28',0,'2014-01-13 02:18:21',NULL,NULL),(11155,1437,'624565','834','00','005010X220A1','624565','','2013-12-23','08:33:54',0,'2013-12-26 13:16:05',NULL,NULL),(1540,261,'1746287','834','00','005010X220A1','1746287','','2013-12-24','15:50:21',0,'2013-12-25 18:58:36',NULL,NULL),(22657,4254,'2886301','834','00','005010X220A1','2886301','','2014-03-05','09:59:47',0,'2014-03-05 21:31:58',NULL,NULL),(3658,626,'1294974','834','00','005010X220A1','1294974','','2013-12-11','20:15:55',0,'2013-12-25 22:06:10',NULL,NULL),(11562,1492,'2067654','834','00','005010X220A1','2067654','','2013-12-27','12:23:46',0,'2013-12-28 03:33:33',NULL,NULL),(21559,4053,'2906018','834','00','005010X220A1','2906018','','2014-02-26','09:50:46',0,'2014-02-28 07:00:03',NULL,NULL),(21360,4024,'2959956','834','00','005010X220A1','2959956','','2014-02-26','20:05:01',0,'2014-02-28 06:30:17',NULL,NULL),(13179,2023,'0001','999','BE','005010X231A1','71475','834','2013-12-28','11:05:00',0,'2014-01-05 16:58:54',NULL,NULL),(16247,2939,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','10:28:00',0,'2014-01-23 07:00:02',NULL,NULL),(16552,3026,'2611552','834','00','005010X220A1','2611552','','2014-01-24','09:52:23',0,'2014-01-24 21:01:14',NULL,NULL),(18565,3453,'1560888','834','00','005010X220A1','1560888','','2014-02-10','11:05:58',0,'2014-02-10 21:30:39',NULL,NULL),(19942,3737,'2587136','834','00','005010X220A1','2587136','','2014-02-18','10:14:36',0,'2014-02-18 21:30:12',NULL,NULL),(1084,218,'406203','834','00','005010X220A1','406203','','2013-11-03','18:18:00',0,'2013-12-25 18:31:25',NULL,NULL),(21178,3998,'3281747','834','00','005010X220A1','3281747','','2014-02-26','11:00:21',0,'2014-02-26 21:01:02',NULL,NULL),(1496,256,'845070','834','00','005010X220A1','845070','','2013-12-24','14:19:38',0,'2013-12-25 18:57:15',NULL,NULL),(19362,3587,'3105094','834','00','005010X220A1','3105094','','2014-02-12','20:30:01',0,'2014-02-13 22:02:01',NULL,NULL),(18662,3467,'2317255','834','00','005010X220A1','2317255','','2014-02-10','09:34:56',0,'2014-02-10 21:31:47',NULL,NULL),(7065,1236,'1048526','834','00','005010X220A1','1048526','','2013-12-17','20:31:04',0,'2013-12-26 04:02:29',NULL,NULL),(2509,448,'111512','834','00','005010X220A1','111512','','2013-10-13','13:13:46',0,'2013-12-25 20:30:18',NULL,NULL),(11368,1460,'2140342','834','00','005010X220A1','2140342','','2013-12-26','09:00:01',0,'2013-12-27 02:05:35',NULL,NULL),(16849,3092,'1425670','834','00','005010X220A1','1425670','','2014-01-28','13:51:35',0,'2014-01-28 21:00:39',NULL,NULL),(12709,1677,'2412680','834','00','005010X220A1','2412680','','2014-01-02','16:39:10',0,'2014-01-03 02:05:05',NULL,NULL),(16580,3037,'1584998','834','00','005010X220A1','1584998','','2014-01-25','15:24:04',0,'2014-01-25 19:00:11',NULL,NULL),(14148,2356,'1822369','834','00','005010X220A1','1822369','','2014-01-08','16:50:46',0,'2014-01-13 02:22:41',NULL,NULL),(23242,4364,'3113174','834','00','005010X220A1','3113174','','2014-03-07','16:20:05',0,'2014-03-07 21:32:16',NULL,NULL),(131,8,'1241777','834','00','005010X220A1','1241777','','2013-12-05','17:17:08',0,'2013-12-25 17:19:04',NULL,NULL),(19007,3539,'2317345','834','00','005010X220A1','2317345','','2014-02-11','22:05:23',0,'2014-02-12 21:30:30',NULL,NULL),(18938,3523,'2676064','834','00','005010X220A1','2676064','','2014-02-11','12:05:28',0,'2014-02-11 21:30:17',NULL,NULL),(16503,3011,'2295807','834','00','005010X220A1','2295807','','2014-01-24','17:37:58',0,'2014-01-24 21:00:43',NULL,NULL),(10535,1401,'309540','834','00','005010X220A1','309540','','2013-12-23','15:34:05',0,'2013-12-26 12:54:58',NULL,NULL),(936,181,'947598','834','00','005010X220A1','947598','','2013-12-03','09:10:32',0,'2013-12-25 18:18:14',NULL,NULL),(3158,561,'964401','834','00','005010X220A1','964401','','2013-12-13','10:00:53',0,'2013-12-25 21:38:00',NULL,NULL),(1765,296,'676089','834','00','005010X220A1','676089','','2013-12-10','17:10:28',0,'2013-12-25 19:18:26',NULL,NULL),(6043,1152,'883458','834','00','005010X220A1','883458','','2013-10-14','12:06:41',0,'2013-12-26 02:46:20',NULL,NULL),(21567,4054,'2760316','834','00','005010X220A1','2760316','','2014-02-26','11:04:08',0,'2014-02-28 07:00:10',NULL,NULL),(23022,4325,'2994772','834','00','005010X220A1','2994772','','2014-03-07','12:09:06',0,'2014-03-07 21:00:21',NULL,NULL),(23747,4472,'2702385','834','00','005010X220A1','2702385','','2014-03-10','11:11:13',0,'2014-03-10 21:29:59',NULL,NULL),(780,145,'736705','834','00','005010X220A1','736705','','2013-10-28','22:38:26',0,'2013-12-25 18:09:24',NULL,NULL),(20882,3920,'3613700','834','00','005010X220A1','3613700','','2014-02-25','13:55:11',0,'2014-02-25 21:31:55',NULL,NULL),(7411,1295,'1133976','834','00','005010X220A1','1133976','','2013-12-20','23:36:38',0,'2013-12-26 04:31:12',NULL,NULL),(18378,3406,'2882052','834','00','005010X220A1','2882052','','2014-02-09','17:45:04',0,'2014-02-09 19:00:20',NULL,NULL),(7592,1302,'613564','834','00','005010X220A1','613564','','2013-12-21','10:39:39',0,'2013-12-26 04:37:04',NULL,NULL),(17538,3235,'1789480','834','00','005010X220A1','1789480','','2014-02-03','15:48:02',0,'2014-02-03 21:00:19',NULL,NULL),(17424,3202,'1505042','834','00','005010X220A1','1505042','','2014-01-31','21:03:03',0,'2014-02-01 19:00:24',NULL,NULL),(12747,1689,'2486180','834','00','005010X220A1','2486180','','2014-01-02','16:16:34',0,'2014-01-03 02:06:34',NULL,NULL),(16914,3110,'1650730','834','00','005010X220A1','1650730','','2014-01-28','17:15:11',0,'2014-01-28 21:01:22',NULL,NULL),(2169,362,'161828','834','00','005010X220A1','161828','','2013-12-02','10:36:16',0,'2013-12-25 19:47:07',NULL,NULL),(2758,505,'1056072','834','00','005010X220A1','1056072','','2013-12-22','11:57:25',0,'2013-12-25 21:18:59',NULL,NULL),(16123,2815,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 03:47:31',NULL,NULL),(15263,2601,'1767103','834','00','005010X220A1','1767103','','2014-01-15','15:31:48',0,'2014-01-16 08:47:05',NULL,NULL),(15136,2587,'2049866','834','00','005010X220A1','2049866','','2014-01-15','18:02:57',0,'2014-01-16 08:45:45',NULL,NULL),(13729,2275,'1840716','834','00','005010X220A1','1840716','','2014-01-06','22:47:19',0,'2014-01-08 18:24:42',NULL,NULL),(14365,2404,'2255518','834','00','005010X220A1','2255518','','2014-01-12','11:32:39',0,'2014-01-13 03:01:37',NULL,NULL),(22356,4205,'3463181','834','00','005010X220A1','3463181','','2014-03-04','11:14:43',0,'2014-03-04 21:01:43',NULL,NULL),(10923,1410,'448984','834','00','005010X220A1','448984','','2013-12-23','10:41:46',0,'2013-12-26 13:08:24',NULL,NULL),(20029,3750,'3088916','834','00','005010X220A1','3088916','','2014-02-18','14:18:32',0,'2014-02-18 22:00:53',NULL,NULL),(18068,3321,'2547205','834','00','005010X220A1','2547205','','2014-02-06','12:14:23',0,'2014-02-06 21:00:54',NULL,NULL),(4164,734,'152181','834','00','005010X220A1','152181','','2013-12-19','09:28:26',0,'2013-12-25 23:05:06',NULL,NULL),(17306,3173,'2224563','834','00','005010X220A1','2224563','','2014-01-31','12:34:27',0,'2014-01-31 21:00:45',NULL,NULL),(2814,506,'1461536','834','00','005010X220A1','1461536','','2013-12-22','17:16:15',0,'2013-12-25 21:20:45',NULL,NULL),(22381,4208,'3241016','834','00','005010X220A1','3241016','','2014-03-04','12:07:17',0,'2014-03-04 21:02:04',NULL,NULL),(531,102,'984387','834','00','005010X220A1','984387','','2013-12-16','15:28:58',0,'2013-12-25 18:01:23',NULL,NULL),(1215,243,'17496','834','00','005010X220A1','17496','','2013-12-24','08:11:05',0,'2013-12-25 18:48:14',NULL,NULL),(19912,3725,'3350145','834','00','005010X220A1','3350145','','2014-02-16','20:39:02',0,'2014-02-17 19:00:07',NULL,NULL),(4679,831,'1726085','834','00','005010X220A1','1726085','','2013-12-24','00:42:31',0,'2013-12-25 23:49:53',NULL,NULL),(16671,3061,'2098314','834','00','005010X220A1','2098314','','2014-01-26','20:32:20',0,'2014-01-27 21:00:25',NULL,NULL),(15570,2657,'1876921','834','00','005010X220A1','1876921','','2014-01-17','00:45:42',0,'2014-01-20 08:06:03',NULL,NULL),(14768,2551,'2404183','834','00','005010X220A1','2404183','','2014-01-14','11:23:47',0,'2014-01-15 02:06:32',NULL,NULL),(14049,2339,'1758017','834','00','005010X220A1','1758017','','2014-01-08','18:17:20',0,'2014-01-13 02:21:36',NULL,NULL),(11768,1528,'1909606','834','00','005010X220A1','1909606','','2013-12-28','16:52:44',1,'2013-12-29 11:09:58',NULL,NULL),(4626,827,'1659922','834','00','005010X220A1','1659922','','2013-12-23','22:55:56',0,'2013-12-25 23:48:06',NULL,NULL),(3335,586,'669701','834','00','005010X220A1','669701','','2013-12-17','16:11:21',0,'2013-12-25 21:49:40',NULL,NULL),(3701,633,'1064240','834','00','005010X220A1','1064240','','2013-12-12','13:55:43',0,'2013-12-25 22:07:31',NULL,NULL),(22083,4174,'3417304','834','00','005010X220A1','3417304','','2014-03-03','16:04:59',0,'2014-03-03 21:30:04',NULL,NULL),(23412,4404,'3376685','834','00','005010X220A1','3376685','','2014-03-09','12:16:52',0,'2014-03-09 21:00:20',NULL,NULL),(23621,4441,'3627324','834','00','005010X220A1','3627324','','2014-03-10','10:27:45',0,'2014-03-10 21:01:30',NULL,NULL),(23639,4441,'2624596','834','00','005010X220A1','2624596','','2014-03-10','13:58:11',0,'2014-03-10 21:01:43',NULL,NULL),(10416,1400,'621256','834','00','005010X220A1','621256','','2013-12-23','09:50:33',0,'2013-12-26 12:51:13',NULL,NULL),(2275,391,'1133209','834','00','005010X220A1','1133209','','2013-11-24','11:50:33',0,'2013-12-25 20:00:19',NULL,NULL),(4100,733,'852493','834','00','005010X220A1','852493','','2013-12-19','11:16:11',0,'2013-12-25 23:03:14',NULL,NULL),(14040,2337,'1988178','834','00','005010X220A1','1988178','','2014-01-08','16:22:22',0,'2014-01-13 02:21:30',NULL,NULL),(19887,3710,'2604841','834','00','005010X220A1','2604841','','2014-02-16','10:54:15',0,'2014-02-16 19:00:29',NULL,NULL),(18391,3409,'2910186','834','00','005010X220A1','2910186','','2014-02-08','18:47:20',0,'2014-02-09 19:00:29',NULL,NULL),(23308,4381,'2863505','834','00','005010X220A1','2863505','','2014-03-07','19:03:35',0,'2014-03-08 21:30:26',NULL,NULL),(1055,207,'1256276','834','00','005010X220A1','1256276','','2013-11-29','16:01:39',0,'2013-12-25 18:30:26',NULL,NULL),(21308,4008,'2865906','834','00','005010X220A1','2865906','','2014-02-26','16:58:22',0,'2014-02-26 21:02:31',NULL,NULL),(21067,3980,'2936145','834','00','005010X220A1','2936145','','2014-02-24','13:57:05',0,'2014-02-26 09:30:40',NULL,NULL),(5611,1044,'973701','834','00','005010X220A1','973701','','2013-12-24','22:07:55',0,'2013-12-26 01:49:59',NULL,NULL),(20164,3777,'2926318','834','00','005010X220A1','2926318','','2014-02-18','23:42:30',0,'2014-02-20 04:07:42',NULL,NULL),(19540,3624,'3225775','834','00','005010X220A1','3225775','','2014-02-14','16:45:08',0,'2014-02-14 21:30:54',NULL,NULL),(4435,796,'25526','834','00','005010X220A1','25526','','2013-11-05','21:31:54',0,'2013-12-25 23:17:13',NULL,NULL),(18416,3420,'1900406','834','00','005010X220A1','1900406','','2014-02-10','00:08:15',0,'2014-02-10 11:00:06',NULL,NULL),(16550,3025,'2206634','834','00','005010X220A1','2206634','','2014-01-24','09:24:48',0,'2014-01-24 21:01:12',NULL,NULL),(13922,2314,'1560126','834','00','005010X220A1','1560126','','2014-01-08','20:51:26',0,'2014-01-13 02:19:59',NULL,NULL),(3063,544,'77001','834','00','005010X220A1','77001','','2013-12-13','15:13:30',0,'2013-12-25 21:35:02',NULL,NULL),(2083,344,'1130845','834','00','005010X220A1','1130845','','2013-12-09','16:09:03',0,'2013-12-25 19:37:29',NULL,NULL),(23264,4377,'3881705','834','00','005010X220A1','3881705','','2014-03-08','13:07:04',0,'2014-03-08 21:00:04',NULL,NULL),(11138,1432,'677953','834','00','005010X220A1','677953','','2013-12-23','11:07:36',0,'2013-12-26 13:15:30',NULL,NULL),(11802,1538,'844990','834','00','005010X220A1','844990','','2013-12-28','20:28:35',1,'2013-12-29 11:13:10',NULL,NULL),(20658,3877,'2635384','834','00','005010X220A1','2635384','','2014-02-21','11:26:44',0,'2014-02-21 22:00:58',NULL,NULL),(19617,3637,'3320465','834','00','005010X220A1','3320465','','2014-02-13','21:27:06',0,'2014-02-14 21:31:50',NULL,NULL),(19515,3622,'2306097','834','00','005010X220A1','2306097','','2014-02-13','20:24:21',0,'2014-02-14 21:30:35',NULL,NULL),(12418,1638,'1512110','834','00','005010X220A1','1512110','','2013-12-30','20:06:13',1,'2014-01-02 04:30:20',NULL,NULL),(18097,3327,'1819336','834','00','005010X220A1','1819336','','2014-02-06','13:11:50',0,'2014-02-06 21:01:14',NULL,NULL),(17250,3170,'2309549','834','00','005010X220A1','2309549','','2014-01-30','18:57:50',0,'2014-01-31 21:00:07',NULL,NULL),(893,177,'674447','834','00','005010X220A1','674447','','2013-12-03','13:27:00',0,'2013-12-25 18:16:56',NULL,NULL),(7763,1350,'690183','834','00','005010X220A1','690183','','2013-10-20','20:37:57',0,'2013-12-26 05:01:17',NULL,NULL),(21909,4127,'3246044','834','00','005010X220A1','3246044','','2014-03-01','12:34:48',0,'2014-03-01 21:00:36',NULL,NULL),(21797,4092,'2978070','834','00','005010X220A1','2978070','','2014-02-28','11:55:10',0,'2014-02-28 21:31:19',NULL,NULL),(20095,3766,'3327570','834','00','005010X220A1','3327570','','2014-02-18','14:05:08',0,'2014-02-18 22:01:42',NULL,NULL),(7566,1301,'864304','834','00','005010X220A1','864304','','2013-12-21','12:13:23',0,'2013-12-26 04:36:10',NULL,NULL),(3017,543,'449712','834','00','005010X220A1','449712','','2013-12-13','14:57:44',0,'2013-12-25 21:33:38',NULL,NULL),(3174,565,'668459','834','00','005010X220A1','668459','','2013-12-13','13:20:50',0,'2013-12-25 21:38:37',NULL,NULL),(4127,733,'60938','834','00','005010X220A1','60938','','2013-12-19','14:24:12',0,'2013-12-25 23:04:00',NULL,NULL),(5188,949,'585369','834','00','005010X220A1','585369','','2013-12-11','10:44:02',0,'2013-12-26 00:51:59',NULL,NULL),(1731,293,'830697','834','00','005010X220A1','830697','','2013-12-10','10:43:35',0,'2013-12-25 19:17:25',NULL,NULL),(19972,3746,'3451140','834','00','005010X220A1','3451140','','2014-02-18','13:30:08',0,'2014-02-18 22:00:12',NULL,NULL),(3773,655,'800821','834','00','005010X220A1','800821','','2013-12-08','11:32:27',0,'2013-12-25 22:15:26',NULL,NULL),(3797,660,'829232','834','00','005010X220A1','829232','','2013-12-07','19:10:06',0,'2013-12-25 22:16:10',NULL,NULL),(13376,2220,'0001','999','BE','005010X231A1','1227970','834','2013-12-28','11:05:00',0,'2014-01-05 17:27:43',NULL,NULL),(22554,4248,'3192126','834','00','005010X220A1','3192126','','2014-03-05','11:48:19',0,'2014-03-05 21:30:46',NULL,NULL),(13599,2261,'1952773','834','00','005010X220A1','1952773','','2014-01-05','15:04:43',1,'2014-01-07 10:22:49',NULL,NULL),(20961,3954,'3460348','834','00','005010X220A1','3460348','','2014-02-23','13:02:15',0,'2014-02-26 08:00:49',NULL,NULL),(19964,3746,'3327562','834','00','005010X220A1','3327562','','2014-02-18','10:50:09',0,'2014-02-18 22:00:07',NULL,NULL),(19255,3581,'3391688','834','00','005010X220A1','3391688','','2014-02-13','09:17:02',0,'2014-02-13 22:00:39',NULL,NULL),(18785,3487,'2530289','834','00','005010X220A1','2530289','','2014-02-10','22:38:36',0,'2014-02-11 21:01:04',NULL,NULL),(16179,2871,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',1,'2014-01-23 04:21:11',NULL,NULL),(15928,2748,'1445353','834','00','005010X220A1','1445353','','2014-01-21','17:48:38',1,'2014-01-22 03:22:58',NULL,NULL),(10857,1406,'557804','834','00','005010X220A1','557804','','2013-12-23','15:21:30',0,'2013-12-26 13:05:43',NULL,NULL),(2117,360,'452147','834','00','005010X220A1','452147','','2013-12-02','09:06:20',0,'2013-12-25 19:45:27',NULL,NULL),(5759,1072,'162216','834','00','005010X220A1','162216','','2013-12-13','22:17:24',0,'2013-12-26 02:02:11',NULL,NULL),(5400,1020,'158512','834','00','005010X220A1','158512','','2013-11-14','09:27:41',0,'2013-12-26 01:30:12',NULL,NULL),(4317,750,'460470','834','00','005010X220A1','460470','','2013-12-19','16:15:17',0,'2013-12-25 23:09:45',NULL,NULL),(2211,365,'231501','834','00','005010X220A1','231501','','2013-12-02','12:45:17',0,'2013-12-25 19:48:31',NULL,NULL),(5214,950,'4049','834','00','005010X220A1','4049','','2013-12-11','15:21:35',0,'2013-12-26 00:52:49',NULL,NULL),(5729,1069,'165855','834','00','005010X220A1','165855','','2013-12-14','15:49:03',0,'2013-12-26 02:01:15',NULL,NULL),(20166,3778,'2926318','834','00','005010X220A1','2926318','','2014-02-18','23:42:30',0,'2014-02-20 04:08:32',NULL,NULL),(4105,733,'449957','834','00','005010X220A1','449957','','2013-12-19','11:53:34',0,'2013-12-25 23:03:23',NULL,NULL),(19215,3580,'2997963','834','00','005010X220A1','2997963','','2014-02-12','19:24:53',0,'2014-02-13 22:00:04',NULL,NULL),(19151,3552,'2483384','834','00','005010X220A1','2483384','','2014-02-12','17:47:55',0,'2014-02-12 21:32:10',NULL,NULL),(18800,3487,'2688481','834','00','005010X220A1','2688481','','2014-02-11','15:46:09',0,'2014-02-11 21:01:15',NULL,NULL),(5420,1025,'690308','834','00','005010X220A1','690308','','2013-11-14','14:21:47',0,'2013-12-26 01:30:57',NULL,NULL),(13635,2270,'2556768','834','00','005010X220A1','2556768','','2014-01-07','13:23:41',0,'2014-01-08 18:24:04',NULL,NULL),(16937,3115,'1849821','834','00','005010X220A1','1849821','','2014-01-29','11:48:55',0,'2014-01-29 21:00:14',NULL,NULL),(14611,2522,'2151903','834','00','005010X220A1','2151903','','2014-01-13','15:10:55',0,'2014-01-14 01:33:13',NULL,NULL),(23318,4382,'3417507','834','00','005010X220A1','3417507','','2014-03-07','18:23:06',0,'2014-03-08 21:30:34',NULL,NULL),(746,133,'1113213','834','00','005010X220A1','1113213','','2013-12-16','13:07:52',0,'2013-12-25 18:08:12',NULL,NULL),(6119,1166,'386216','834','00','005010X220A1','386216','','2013-12-20','14:25:13',0,'2013-12-26 03:01:51',NULL,NULL),(5937,1112,'497961','834','00','005010X220A1','497961','','2013-12-15','17:33:47',0,'2013-12-26 02:31:56',NULL,NULL),(840,174,'146076','834','00','005010X220A1','146076','','2013-12-03','12:52:18',0,'2013-12-25 18:15:20',NULL,NULL),(3220,578,'612066','834','00','005010X220A1','612066','','2013-12-17','10:00:29',0,'2013-12-25 21:45:55',NULL,NULL),(17376,3186,'2132492','834','00','005010X220A1','2132492','','2014-01-31','17:09:20',0,'2014-01-31 21:01:35',NULL,NULL),(16804,3089,'1554547','834','00','005010X220A1','1554547','','2014-01-28','09:31:31',0,'2014-01-28 21:00:10',NULL,NULL),(16773,3075,'2450703','834','00','005010X220A1','2450703','','2014-01-27','15:32:56',0,'2014-01-27 21:01:36',NULL,NULL),(16376,2986,'2093385','834','00','005010X220A1','2093385','','2014-01-23','11:36:53',0,'2014-01-23 21:01:07',NULL,NULL),(14401,2422,'0001','999','BE','005010X231A1','412866','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:15',NULL,NULL),(22653,4254,'3179481','834','00','005010X220A1','3179481','','2014-03-04','21:12:34',0,'2014-03-05 21:31:55',NULL,NULL),(11000,1413,'999957','834','00','005010X220A1','999957','','2013-12-23','16:41:25',0,'2013-12-26 13:10:48',NULL,NULL),(19476,3620,'3429849','834','00','005010X220A1','3429849','','2014-02-13','20:54:54',0,'2014-02-14 21:30:09',NULL,NULL),(7599,1303,'909873','834','00','005010X220A1','909873','','2013-12-20','21:50:55',0,'2013-12-26 04:37:15',NULL,NULL),(17084,3134,'2478412','834','00','005010X220A1','2478412','','2014-01-29','12:50:49',0,'2014-01-29 21:01:48',NULL,NULL),(16905,3105,'1719007','834','00','005010X220A1','1719007','','2014-01-28','12:44:10',0,'2014-01-28 21:01:16',NULL,NULL),(16847,3092,'2419416','834','00','005010X220A1','2419416','','2014-01-28','12:12:27',0,'2014-01-28 21:00:37',NULL,NULL),(3466,615,'889395','834','00','005010X220A1','889395','','2013-12-11','19:13:26',0,'2013-12-25 22:00:06',NULL,NULL),(90,4,'916604','834','00','005010X220A1','916604','','2013-12-05','13:42:00',0,'2013-12-25 17:17:43',NULL,NULL),(21053,3979,'2813127','834','00','005010X220A1','2813127','','2014-02-23','21:40:03',0,'2014-02-26 09:30:29',NULL,NULL),(18510,3446,'2709938','834','00','005010X220A1','2709938','','2014-02-10','14:38:23',0,'2014-02-10 21:00:10',NULL,NULL),(18294,3380,'1844139','834','00','005010X220A1','1844139','','2014-02-08','11:47:09',0,'2014-02-08 19:00:31',NULL,NULL),(17968,3302,'1904393','834','00','005010X220A1','1904393','','2014-02-04','21:42:31',0,'2014-02-05 21:31:05',NULL,NULL),(17507,3227,'2349911','834','00','005010X220A1','2349911','','2014-02-02','13:35:48',0,'2014-02-02 19:00:29',NULL,NULL),(13639,2270,'1513453','834','00','005010X220A1','1513453','','2014-01-07','17:37:01',0,'2014-01-08 18:24:06',NULL,NULL),(683,109,'669657','834','00','005010X220A1','669657','','2013-12-16','15:08:49',0,'2013-12-25 18:06:11',NULL,NULL),(13294,2138,'0001','999','BE','005010X231A1','1169549','834','2013-12-28','11:05:00',0,'2014-01-05 17:23:55',NULL,NULL),(12895,1709,'2551143','834','00','005010X220A1','2551143','','2014-01-03','15:22:55',0,'2014-01-04 02:04:41',NULL,NULL),(848,175,'727365','834','00','005010X220A1','727365','','2013-12-03','13:04:25',0,'2013-12-25 18:15:34',NULL,NULL),(3011,543,'327873','834','00','005010X220A1','327873','','2013-12-13','10:59:48',0,'2013-12-25 21:33:28',NULL,NULL),(6132,1166,'347929','834','00','005010X220A1','347929','','2013-12-20','15:46:23',0,'2013-12-26 03:02:19',NULL,NULL),(3381,587,'300744','834','00','005010X220A1','300744','','2013-12-17','16:51:35',0,'2013-12-25 21:51:06',NULL,NULL),(2401,415,'285783','834','00','005010X220A1','285783','','2013-12-06','08:57:57',0,'2013-12-25 20:17:14',NULL,NULL),(4411,781,'301367','834','00','005010X220A1','301367','','2013-11-27','12:35:13',0,'2013-12-25 23:16:18',NULL,NULL),(4997,935,'63501','834','00','005010X220A1','63501','','2013-12-11','09:22:36',0,'2013-12-26 00:45:52',NULL,NULL),(11300,1456,'81480','834','00','005010X220A1','81480','','2013-12-25','22:17:50',0,'2013-12-27 02:03:30',NULL,NULL),(4361,763,'827015','834','00','005010X220A1','827015','','2013-12-19','16:58:29',0,'2013-12-25 23:11:05',NULL,NULL),(6267,1172,'631934','834','00','005010X220A1','631934','','2013-12-20','09:07:11',0,'2013-12-26 03:06:26',NULL,NULL),(1232,243,'376930','834','00','005010X220A1','376930','','2013-12-24','10:03:40',0,'2013-12-25 18:48:43',NULL,NULL),(13913,2313,'2137905','834','00','005010X220A1','2137905','','2014-01-09','11:04:26',0,'2014-01-13 02:19:52',NULL,NULL),(14046,2338,'2172548','834','00','005010X220A1','2172548','','2014-01-08','18:14:47',0,'2014-01-13 02:21:34',NULL,NULL),(14229,2368,'2367868','834','00','005010X220A1','2367868','','2014-01-10','14:39:02',0,'2014-01-13 02:24:03',NULL,NULL),(17636,3244,'2127189','834','00','005010X220A1','2127189','','2014-02-03','16:22:59',0,'2014-02-03 21:01:19',NULL,NULL),(23203,4347,'3676819','834','00','005010X220A1','3676819','','2014-03-06','20:30:51',0,'2014-03-07 21:31:48',NULL,NULL),(23382,4400,'3509588','834','00','005010X220A1','3509588','','2014-03-08','16:21:20',0,'2014-03-08 21:31:22',NULL,NULL),(35,1,'174732','834','00','005010X220A1','174732','','2013-12-05','12:58:29',0,'2013-12-25 17:16:01',NULL,NULL),(695,112,'561115','834','00','005010X220A1','561115','','2013-12-15','21:55:03',0,'2013-12-25 18:06:34',NULL,NULL),(19946,3739,'2862912','834','00','005010X220A1','2862912','','2014-02-18','14:00:42',0,'2014-02-18 21:30:15',NULL,NULL),(19186,3569,'3371793','834','00','005010X220A1','3371793','','2014-02-13','10:41:40',0,'2014-02-13 21:30:05',NULL,NULL),(18279,3378,'2591961','834','00','005010X220A1','2591961','','2014-02-08','16:05:23',0,'2014-02-08 19:00:21',NULL,NULL),(17570,3236,'2726770','834','00','005010X220A1','2726770','','2014-02-03','14:26:38',0,'2014-02-03 21:00:38',NULL,NULL),(1897,325,'774266','834','00','005010X220A1','774266','','2013-12-09','12:21:10',0,'2013-12-25 19:31:41',NULL,NULL),(15658,2684,'2505040','834','00','005010X220A1','2505040','','2014-01-17','22:52:00',0,'2014-01-21 08:44:30',NULL,NULL),(13088,1932,'0001','999','BE','005010X231A1','305119','834','2013-12-28','04:55:00',0,'2014-01-05 16:53:05',NULL,NULL),(12903,1713,'2204765','834','00','005010X220A1','2204765','','2014-01-03','11:43:56',0,'2014-01-04 02:05:00',NULL,NULL),(11299,1456,'1684615','834','00','005010X220A1','1684615','','2013-12-25','21:55:10',0,'2013-12-27 02:03:28',NULL,NULL),(5971,1117,'553673','834','00','005010X220A1','553673','','2013-12-15','18:03:51',0,'2013-12-26 02:33:01',NULL,NULL),(3240,578,'903637','834','00','005010X220A1','903637','','2013-12-17','15:14:24',0,'2013-12-25 21:46:33',NULL,NULL),(2936,541,'845870','834','00','005010X220A1','845870','','2013-12-12','20:55:28',0,'2013-12-25 21:31:07',NULL,NULL),(23392,4401,'3366065','834','00','005010X220A1','3366065','','2014-03-09','16:20:13',0,'2014-03-09 21:00:05',NULL,NULL),(118,7,'15273','834','00','005010X220A1','15273','','2013-12-04','21:08:03',0,'2013-12-25 17:18:37',NULL,NULL),(22481,4242,'3865104','834','00','005010X220A1','3865104','','2014-03-05','09:24:59',0,'2014-03-05 21:00:24',NULL,NULL),(21403,4025,'3441183','834','00','005010X220A1','3441183','','2014-02-27','11:39:45',0,'2014-02-28 06:30:36',NULL,NULL),(20632,3873,'3682693','834','00','005010X220A1','3682693','','2014-02-20','18:18:24',0,'2014-02-21 22:00:40',NULL,NULL),(20423,3838,'2918990','834','00','005010X220A1','2918990','','2014-02-20','16:48:54',0,'2014-02-20 21:30:22',NULL,NULL),(19364,3589,'2880959','834','00','005010X220A1','2880959','','2014-02-12','21:05:47',0,'2014-02-13 22:02:03',NULL,NULL),(18779,3486,'1715071','834','00','005010X220A1','1715071','','2014-02-11','16:09:00',0,'2014-02-11 21:00:59',NULL,NULL),(3357,587,'989304','834','00','005010X220A1','989304','','2013-12-17','10:39:41',0,'2013-12-25 21:50:21',NULL,NULL),(13297,2141,'0001','999','BE','005010X231A1','919448','834','2013-12-28','11:05:00',0,'2014-01-05 17:24:03',NULL,NULL),(15743,2712,'1490452','834','00','005010X220A1','1490452','','2014-01-20','16:40:08',0,'2014-01-21 08:46:13',NULL,NULL),(14710,2550,'1517645','834','00','005010X220A1','1517645','','2014-01-14','09:58:01',0,'2014-01-15 02:06:06',NULL,NULL),(2079,343,'681105','834','00','005010X220A1','681105','','2013-12-09','13:54:17',0,'2013-12-25 19:37:22',NULL,NULL),(3660,626,'67352','834','00','005010X220A1','67352','','2013-12-12','10:51:25',0,'2013-12-25 22:06:13',NULL,NULL),(20934,3940,'3267756','834','00','005010X220A1','3267756','','2014-02-23','13:36:41',0,'2014-02-26 08:00:29',NULL,NULL),(20139,3772,'3303456','834','00','005010X220A1','3303456','','2014-02-19','16:56:47',0,'2014-02-20 04:00:59',NULL,NULL),(19910,3725,'3448498','834','00','005010X220A1','3448498','','2014-02-16','19:39:08',0,'2014-02-17 19:00:06',NULL,NULL),(19201,3573,'3201455','834','00','005010X220A1','3201455','','2014-02-13','14:33:36',0,'2014-02-13 21:30:12',NULL,NULL),(17903,3295,'1801607','834','00','005010X220A1','1801607','','2014-02-05','13:27:20',0,'2014-02-05 21:30:33',NULL,NULL),(17225,3156,'2092112','834','00','005010X220A1','2092112','','2014-01-30','10:34:05',0,'2014-01-30 21:01:26',NULL,NULL),(7300,1261,'1098651','834','00','005010X220A1','1098651','','2013-12-18','11:01:39',0,'2013-12-26 04:09:43',NULL,NULL),(17057,3124,'2175851','834','00','005010X220A1','2175851','','2014-01-29','17:31:46',0,'2014-01-29 21:01:31',NULL,NULL),(16456,3006,'1410252','834','00','005010X220A1','1410252','','2014-01-24','13:05:16',0,'2014-01-24 21:00:15',NULL,NULL),(16072,2774,'2470133','834','00','005010X220A1','2470133','','2014-01-22','13:56:18',0,'2014-01-23 03:02:46',NULL,NULL),(14555,2519,'1968186','834','00','005010X220A1','1968186','','2014-01-13','09:55:06',0,'2014-01-14 01:32:37',NULL,NULL),(14486,2507,'0001','999','BE','005010X231A1','889328','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:57',NULL,NULL),(13787,2293,'2084747','834','00','005010X220A1','2084747','','2014-01-11','09:26:45',0,'2014-01-13 02:18:05',NULL,NULL),(13196,2040,'0001','999','BE','005010X231A1','1255497','834','2013-12-28','11:05:00',0,'2014-01-05 16:59:41',NULL,NULL),(5663,1053,'2112836','834','00','005010X220A1','2112836','','2013-12-24','19:42:27',0,'2013-12-26 01:51:45',NULL,NULL),(5382,1011,'347226','834','00','005010X220A1','347226','','2013-11-24','18:28:38',0,'2013-12-26 01:16:57',NULL,NULL),(11763,1525,'654987','834','00','005010X220A1','654987','','2013-12-28','14:13:07',1,'2013-12-29 11:09:50',NULL,NULL),(5251,965,'554940','834','00','005010X220A1','554940','','2013-12-11','13:10:44',0,'2013-12-26 00:54:02',NULL,NULL),(2301,399,'806515','834','00','005010X220A1','806515','','2013-11-02','08:26:50',0,'2013-12-25 20:01:13',NULL,NULL),(22354,4205,'2789364','834','00','005010X220A1','2789364','','2014-03-04','09:12:46',0,'2014-03-04 21:01:41',NULL,NULL),(22040,4163,'3767141','834','00','005010X220A1','3767141','','2014-03-03','14:46:57',0,'2014-03-03 21:00:04',NULL,NULL),(15449,2630,'1821551','834','00','005010X220A1','1821551','','2014-01-15','19:43:50',0,'2014-01-17 03:36:09',NULL,NULL),(15192,2592,'1876840','834','00','005010X220A1','1876840','','2014-01-14','21:34:52',0,'2014-01-16 08:46:19',NULL,NULL),(2737,503,'535019','834','00','005010X220A1','535019','','2013-12-22','15:24:25',0,'2013-12-25 21:18:19',NULL,NULL),(6328,1175,'516614','834','00','005010X220A1','516614','','2013-12-20','15:39:45',0,'2013-12-26 03:08:16',NULL,NULL),(21954,4136,'3172686','834','00','005010X220A1','3172686','','2014-03-01','15:06:12',0,'2014-03-01 21:01:08',NULL,NULL),(2050,335,'852080','834','00','005010X220A1','852080','','2013-12-09','13:26:05',0,'2013-12-25 19:36:24',NULL,NULL),(2236,372,'1065252','834','00','005010X220A1','1065252','','2013-12-02','15:13:51',0,'2013-12-25 19:49:25',NULL,NULL),(19207,3577,'2534438','834','00','005010X220A1','2534438','','2014-02-13','12:03:47',0,'2014-02-13 21:30:15',NULL,NULL),(17859,3293,'1506490','834','00','005010X220A1','1506490','','2014-02-05','09:50:28',0,'2014-02-05 21:30:10',NULL,NULL),(16300,2980,'2296846','834','00','005010X220A1','2296846','','2014-01-23','11:24:12',0,'2014-01-23 21:00:12',NULL,NULL),(16038,2771,'1416894','834','00','005010X220A1','1416894','','2014-01-22','13:12:20',0,'2014-01-23 03:02:30',NULL,NULL),(10955,1410,'784426','834','00','005010X220A1','784426','','2013-12-23','18:22:06',0,'2013-12-26 13:09:21',NULL,NULL),(13654,2271,'1435319','834','00','005010X220A1','1435319','','2014-01-07','14:17:05',0,'2014-01-08 18:24:12',NULL,NULL),(13293,2137,'0001','999','BE','005010X231A1','974347','834','2013-12-28','04:55:00',0,'2014-01-05 17:23:52',NULL,NULL),(21395,4024,'3133021','834','00','005010X220A1','3133021','','2014-02-27','17:54:33',0,'2014-02-28 06:30:33',NULL,NULL),(22798,4278,'3555769','834','00','005010X220A1','3555769','','2014-03-05','18:20:28',0,'2014-03-06 21:01:03',NULL,NULL),(22816,4278,'2899791','834','00','005010X220A1','2899791','','2014-03-06','11:44:50',0,'2014-03-06 21:01:15',NULL,NULL),(23676,4445,'3340195','834','00','005010X220A1','3340195','','2014-03-10','14:52:21',0,'2014-03-10 21:02:10',NULL,NULL),(3136,551,'901140','834','00','005010X220A1','901140','','2013-12-13','16:51:00',0,'2013-12-25 21:37:17',NULL,NULL),(13503,2232,'1696696','834','00','005010X220A1','1696696','','2014-01-06','15:52:19',0,'2014-01-07 04:04:47',NULL,NULL),(15535,2654,'1635974','834','00','005010X220A1','1635974','','2014-01-17','11:02:05',0,'2014-01-20 08:05:37',NULL,NULL),(17217,3152,'2604364','834','00','005010X220A1','2604364','','2014-01-30','13:08:34',0,'2014-01-30 21:01:20',NULL,NULL),(21434,4027,'3788515','834','00','005010X220A1','3788515','','2014-02-27','11:37:14',0,'2014-02-28 06:30:51',NULL,NULL),(21741,4090,'2809169','834','00','005010X220A1','2809169','','2014-02-27','19:15:10',0,'2014-02-28 21:30:41',NULL,NULL),(23287,4380,'3546568','834','00','005010X220A1','3546568','','2014-03-08','13:25:34',0,'2014-03-08 21:30:10',NULL,NULL),(23492,4431,'3576462','834','00','005010X220A1','3576462','','2014-03-09','13:52:47',0,'2014-03-09 21:30:06',NULL,NULL),(308,70,'739463','834','00','005010X220A1','739463','','2013-12-04','15:36:50',0,'2013-12-25 17:45:26',NULL,NULL),(12533,1646,'2263084','834','00','005010X220A1','2263084','','2013-12-31','16:56:07',1,'2014-01-02 04:34:32',NULL,NULL),(20527,3849,'3358322','834','00','005010X220A1','3358322','','2014-02-20','14:16:32',0,'2014-02-20 22:01:25',NULL,NULL),(11620,1494,'1673642','834','00','005010X220A1','1673642','','2013-12-27','16:44:36',0,'2013-12-28 03:35:21',NULL,NULL),(19695,3671,'2448637','834','00','005010X220A1','2448637','','2014-02-14','23:28:49',0,'2014-02-15 22:00:04',NULL,NULL),(19214,3580,'2954912','834','00','005010X220A1','2954912','','2014-02-12','19:04:11',0,'2014-02-13 22:00:03',NULL,NULL),(11449,1488,'2091285','834','00','005010X220A1','2091285','','2013-12-26','19:03:34',0,'2013-12-28 03:30:07',NULL,NULL),(18459,3425,'2358214','834','00','005010X220A1','2358214','','2014-02-10','04:14:41',0,'2014-02-10 11:00:42',NULL,NULL),(4854,885,'503652','834','00','005010X220A1','503652','','2013-11-20','21:57:58',0,'2013-12-26 00:15:43',NULL,NULL),(7343,1279,'50556','834','00','005010X220A1','50556','','2013-11-30','16:53:12',0,'2013-12-26 04:15:14',NULL,NULL),(318,70,'552358','834','00','005010X220A1','552358','','2013-12-04','17:59:46',0,'2013-12-25 17:45:46',NULL,NULL),(10397,1400,'844878','834','00','005010X220A1','844878','','2013-12-23','07:00:43',0,'2013-12-26 12:50:37',NULL,NULL),(18629,3460,'1694614','834','00','005010X220A1','1694614','','2014-02-09','19:52:29',0,'2014-02-10 21:31:24',NULL,NULL),(18512,3448,'1600822','834','00','005010X220A1','1600822','','2014-02-10','14:58:19',0,'2014-02-10 21:00:11',NULL,NULL),(18125,3332,'2075969','834','00','005010X220A1','2075969','','2014-02-06','15:16:24',0,'2014-02-06 21:01:34',NULL,NULL),(18123,3331,'1655715','834','00','005010X220A1','1655715','','2014-02-05','20:42:29',0,'2014-02-06 21:01:32',NULL,NULL),(6359,1180,'1228605','834','00','005010X220A1','1228605','','2013-12-20','15:11:40',0,'2013-12-26 03:09:09',NULL,NULL),(17289,3172,'2591788','834','00','005010X220A1','2591788','','2014-01-31','12:51:48',0,'2014-01-31 21:00:34',NULL,NULL),(13877,2312,'2145768','834','00','005010X220A1','2145768','','2014-01-08','20:35:42',0,'2014-01-13 02:19:30',NULL,NULL),(14578,2520,'1422766','834','00','005010X220A1','1422766','','2014-01-13','13:34:53',0,'2014-01-14 01:32:52',NULL,NULL),(21675,4079,'3101961','834','00','005010X220A1','3101961','','2014-02-28','15:49:57',0,'2014-02-28 21:00:18',NULL,NULL),(22869,4280,'3583454','834','00','005010X220A1','3583454','','2014-03-06','16:49:16',0,'2014-03-06 21:01:53',NULL,NULL),(740,130,'979268','834','00','005010X220A1','979268','','2013-12-16','12:42:34',0,'2013-12-25 18:08:02',NULL,NULL),(21305,4008,'2648571','834','00','005010X220A1','2648571','','2014-02-26','15:19:22',0,'2014-02-26 21:02:29',NULL,NULL),(13232,2076,'0001','999','BE','005010X231A1','308784','834','2013-12-28','11:05:00',0,'2014-01-05 17:01:21',NULL,NULL),(18815,3489,'3084459','834','00','005010X220A1','3084459','','2014-02-11','15:24:03',0,'2014-02-11 21:01:27',NULL,NULL),(10862,1407,'524015','834','00','005010X220A1','524015','','2013-12-23','09:19:35',0,'2013-12-26 13:05:55',NULL,NULL),(5876,1107,'379394','834','00','005010X220A1','379394','','2013-10-28','14:31:49',0,'2013-12-26 02:17:09',NULL,NULL),(16693,3062,'2526673','834','00','005010X220A1','2526673','','2014-01-27','16:31:28',0,'2014-01-27 21:00:39',NULL,NULL),(21820,4096,'2687614','834','00','005010X220A1','2687614','','2014-02-27','20:37:01',0,'2014-02-28 21:31:34',NULL,NULL),(443,81,'1080355','834','00','005010X220A1','1080355','','2013-12-03','19:54:59',0,'2013-12-25 17:49:45',NULL,NULL),(3311,584,'341041','834','00','005010X220A1','341041','','2013-12-17','14:50:09',0,'2013-12-25 21:48:50',NULL,NULL),(20993,3959,'2619340','834','00','005010X220A1','2619340','','2014-02-22','17:41:36',0,'2014-02-26 08:30:32',NULL,NULL),(20840,3911,'3680219','834','00','005010X220A1','3680219','','2014-02-25','12:26:32',0,'2014-02-25 21:31:23',NULL,NULL),(4810,865,'1250303','834','00','005010X220A1','1250303','','2013-12-01','15:30:02',0,'2013-12-26 00:02:09',NULL,NULL),(5287,979,'1105985','834','00','005010X220A1','1105985','','2013-11-16','14:08:12',0,'2013-12-26 01:00:58',NULL,NULL),(5480,1040,'900393','834','00','005010X220A1','900393','','2013-12-24','23:46:53',0,'2013-12-26 01:45:46',NULL,NULL),(7572,1301,'294696','834','00','005010X220A1','294696','','2013-12-21','14:04:35',0,'2013-12-26 04:36:21',NULL,NULL),(17399,3198,'2274257','834','00','005010X220A1','2274257','','2014-02-01','13:26:46',0,'2014-02-01 19:00:08',NULL,NULL),(13013,1743,'2497379','834','00','005010X220A1','2497379','','2014-01-04','09:38:51',0,'2014-01-05 00:02:40',NULL,NULL),(12583,1670,'1549768','834','00','005010X220A1','1549768','','2014-01-02','09:43:50',0,'2014-01-03 02:00:30',NULL,NULL),(12291,1624,'1570350','834','00','005010X220A1','1570350','','2014-01-01','14:54:07',1,'2014-01-02 04:24:56',NULL,NULL),(4315,750,'700179','834','00','005010X220A1','700179','','2013-12-19','15:57:06',0,'2013-12-25 23:09:42',NULL,NULL),(10659,1402,'791269','834','00','005010X220A1','791269','','2013-12-23','18:57:38',0,'2013-12-26 12:59:05',NULL,NULL),(4043,731,'1299113','834','00','005010X220A1','1299113','','2013-12-19','16:50:14',0,'2013-12-25 23:01:26',NULL,NULL),(5235,956,'1236607','834','00','005010X220A1','1236607','','2013-12-11','08:55:04',0,'2013-12-26 00:53:32',NULL,NULL),(18642,3463,'2895239','834','00','005010X220A1','2895239','','2014-02-10','09:31:45',0,'2014-02-10 21:31:34',NULL,NULL),(18400,3412,'2262556','834','00','005010X220A1','2262556','','2014-02-09','14:57:39',0,'2014-02-09 19:00:35',NULL,NULL),(18140,3340,'2551947','834','00','005010X220A1','2551947','','2014-02-06','10:31:58',0,'2014-02-06 21:01:47',NULL,NULL),(14075,2341,'1602776','834','00','005010X220A1','1602776','','2014-01-07','20:16:36',0,'2014-01-13 02:21:53',NULL,NULL),(22004,4148,'2873376','834','00','005010X220A1','2873376','','2014-03-02','13:26:13',0,'2014-03-03 01:00:26',NULL,NULL),(10700,1403,'278308','834','00','005010X220A1','278308','','2013-12-23','10:05:56',0,'2013-12-26 13:00:31',NULL,NULL),(20379,3824,'3598890','834','00','005010X220A1','3598890','','2014-02-19','12:49:50',0,'2014-02-20 05:36:21',NULL,NULL),(3254,578,'1094868','834','00','005010X220A1','1094868','','2013-12-17','18:00:13',0,'2013-12-25 21:46:56',NULL,NULL),(4420,787,'991157','834','00','005010X220A1','991157','','2013-11-06','16:37:09',0,'2013-12-25 23:16:41',NULL,NULL),(17576,3236,'2294634','834','00','005010X220A1','2294634','','2014-02-03','17:09:49',0,'2014-02-03 21:00:42',NULL,NULL),(16604,3047,'2529956','834','00','005010X220A1','2529956','','2014-01-26','13:18:09',0,'2014-01-26 19:00:06',NULL,NULL),(4664,831,'1573794','834','00','005010X220A1','1573794','','2013-12-23','22:07:10',0,'2013-12-25 23:49:22',NULL,NULL),(15913,2743,'2600626','834','00','005010X220A1','2600626','','2014-01-21','11:56:31',1,'2014-01-22 03:22:50',NULL,NULL),(14451,2472,'0001','999','BE','005010X231A1','937485','834','2013-12-28','11:05:00',0,'2014-01-13 03:03:25',NULL,NULL),(6271,1172,'1088424','834','00','005010X220A1','1088424','','2013-12-20','09:21:12',0,'2013-12-26 03:06:35',NULL,NULL),(7526,1300,'1405165','834','00','005010X220A1','1405165','','2013-12-21','13:26:15',0,'2013-12-26 04:34:52',NULL,NULL),(11972,1580,'2423893','834','00','005010X220A1','2423893','','2013-12-30','13:56:31',0,'2014-01-01 12:01:03',NULL,NULL),(11454,1488,'1428449','834','00','005010X220A1','1428449','','2013-12-26','20:05:13',0,'2013-12-28 03:30:16',NULL,NULL),(11210,1454,'1530257','834','00','005010X220A1','1530257','','2013-12-26','08:58:09',0,'2013-12-27 02:00:45',NULL,NULL),(22490,4244,'3200849','834','00','005010X220A1','3200849','','2014-03-05','12:43:52',0,'2014-03-05 21:00:30',NULL,NULL),(5939,1113,'15586','834','00','005010X220A1','15586','','2013-12-14','21:25:05',0,'2013-12-26 02:32:00',NULL,NULL),(3952,715,'202316','834','00','005010X220A1','202316','','2013-12-06','22:53:16',0,'2013-12-25 22:46:37',NULL,NULL),(3925,712,'580188','834','00','005010X220A1','580188','','2013-12-07','14:26:51',0,'2013-12-25 22:45:47',NULL,NULL),(11996,1581,'1597399','834','00','005010X220A1','1597399','','2013-12-29','19:51:19',0,'2014-01-01 12:01:55',NULL,NULL),(17428,3202,'1541438','834','00','005010X220A1','1541438','','2014-02-01','14:09:53',0,'2014-02-01 19:00:27',NULL,NULL),(16231,2923,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:03:00',0,'2014-01-23 06:40:05',NULL,NULL),(13567,2254,'2232918','834','00','005010X220A1','2232918','','2014-01-04','21:59:13',1,'2014-01-07 10:21:27',NULL,NULL),(14952,2564,'2550112','834','00','005010X220A1','2550112','','2014-01-14','15:09:35',0,'2014-01-15 02:07:53',NULL,NULL),(22486,4243,'3596781','834','00','005010X220A1','3596781','','2014-03-05','17:37:26',0,'2014-03-05 21:00:28',NULL,NULL),(22598,4250,'3661193','834','00','005010X220A1','3661193','','2014-03-05','10:09:20',0,'2014-03-05 21:31:16',NULL,NULL),(23175,4345,'3814260','834','00','005010X220A1','3814260','','2014-03-06','20:43:14',0,'2014-03-07 21:31:29',NULL,NULL),(7305,1262,'730320','834','00','005010X220A1','730320','','2013-12-18','15:15:54',0,'2013-12-26 04:09:51',NULL,NULL),(21253,3999,'2845561','834','00','005010X220A1','2845561','','2014-02-26','16:27:22',0,'2014-02-26 21:01:50',NULL,NULL),(19003,3538,'2694907','834','00','005010X220A1','2694907','','2014-02-12','16:33:56',0,'2014-02-12 21:30:28',NULL,NULL),(17545,3235,'2743553','834','00','005010X220A1','2743553','','2014-02-03','16:43:00',0,'2014-02-03 21:00:23',NULL,NULL),(16629,3052,'1438118','834','00','005010X220A1','1438118','','2014-01-25','22:49:40',0,'2014-01-26 19:00:24',NULL,NULL),(16178,2870,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:18:00',1,'2014-01-23 04:21:04',NULL,NULL),(5271,973,'823251','834','00','005010X220A1','823251','','2013-11-12','09:25:02',0,'2013-12-26 01:00:21',NULL,NULL),(15625,2671,'2190575','834','00','005010X220A1','2190575','','2014-01-17','15:41:19',0,'2014-01-20 08:06:44',NULL,NULL),(14170,2364,'2466952','834','00','005010X220A1','2466952','','2014-01-09','18:52:12',0,'2014-01-13 02:23:20',NULL,NULL),(22595,4250,'3427530','834','00','005010X220A1','3427530','','2014-03-05','05:10:01',0,'2014-03-05 21:31:15',NULL,NULL),(449,82,'785063','834','00','005010X220A1','785063','','2013-12-03','22:55:18',0,'2013-12-25 17:49:56',NULL,NULL),(7349,1281,'677131','834','00','005010X220A1','677131','','2013-11-30','14:36:30',0,'2013-12-26 04:15:26',NULL,NULL),(3298,584,'844507','834','00','005010X220A1','844507','','2013-12-17','08:51:56',0,'2013-12-25 21:48:22',NULL,NULL),(13630,2270,'2058518','834','00','005010X220A1','2058518','','2014-01-07','07:24:44',0,'2014-01-08 18:24:02',NULL,NULL),(15959,2764,'1406166','834','00','005010X220A1','1406166','','2014-01-21','20:02:45',0,'2014-01-23 03:01:54',NULL,NULL),(991,184,'644770','834','00','005010X220A1','644770','','2013-12-03','11:33:39',0,'2013-12-25 18:19:56',NULL,NULL),(20513,3849,'3236974','834','00','005010X220A1','3236974','','2014-02-19','20:05:01',0,'2014-02-20 22:01:13',NULL,NULL),(20437,3841,'3281615','834','00','005010X220A1','3281615','','2014-02-20','06:32:36',0,'2014-02-20 22:00:12',NULL,NULL),(19615,3636,'2803132','834','00','005010X220A1','2803132','','2014-02-13','20:39:50',0,'2014-02-14 21:31:48',NULL,NULL),(18196,3353,'1731317','834','00','005010X220A1','1731317','','2014-02-07','07:33:22',0,'2014-02-07 19:00:31',NULL,NULL),(6050,1158,'1146731','834','00','005010X220A1','1146731','','2013-11-10','08:44:03',0,'2013-12-26 02:46:35',NULL,NULL),(4829,879,'892940','834','00','005010X220A1','892940','','2013-12-01','12:37:21',0,'2013-12-26 00:02:46',NULL,NULL),(23745,4472,'3779790','834','00','005010X220A1','3779790','','2014-03-09','22:21:32',0,'2014-03-10 21:29:57',NULL,NULL),(687,109,'8960','834','00','005010X220A1','8960','','2013-12-16','16:38:09',0,'2013-12-25 18:06:19',NULL,NULL),(13611,2266,'1601428','834','00','005010X220A1','1601428','','2014-01-05','12:14:46',1,'2014-01-07 10:23:20',NULL,NULL),(18962,3534,'2326849','834','00','005010X220A1','2326849','','2014-02-12','17:22:46',0,'2014-02-12 21:00:14',NULL,NULL),(11712,1517,'1761686','834','00','005010X220A1','1761686','','2013-12-28','17:51:48',1,'2013-12-29 11:08:14',NULL,NULL),(4739,853,'209472','834','00','005010X220A1','209472','','2013-12-24','01:17:51',0,'2013-12-25 23:52:05',NULL,NULL),(17468,3216,'1732688','834','00','005010X220A1','1732688','','2014-02-01','22:18:51',0,'2014-02-02 19:00:05',NULL,NULL),(4722,842,'1310743','834','00','005010X220A1','1310743','','2013-12-23','22:11:20',0,'2013-12-25 23:51:25',NULL,NULL),(16230,2922,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:16:00',0,'2014-01-23 06:39:43',NULL,NULL),(13871,2311,'1616891','834','00','005010X220A1','1616891','','2014-01-09','15:47:30',0,'2014-01-13 02:19:26',NULL,NULL),(3714,634,'543632','834','00','005010X220A1','543632','','2013-12-12','07:37:36',0,'2013-12-25 22:08:00',NULL,NULL),(3679,629,'466242','834','00','005010X220A1','466242','','2013-12-12','12:17:35',0,'2013-12-25 22:06:48',NULL,NULL),(2602,483,'957537','834','00','005010X220A1','957537','','2013-10-06','12:16:25',0,'2013-12-25 20:46:04',NULL,NULL),(5979,1121,'437515','834','00','005010X220A1','437515','','2013-12-15','09:10:49',0,'2013-12-26 02:33:19',NULL,NULL),(13092,1936,'0001','999','BE','005010X231A1','1169440','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:16',NULL,NULL),(11581,1492,'1883710','834','00','005010X220A1','1883710','','2013-12-27','16:18:15',0,'2013-12-28 03:34:08',NULL,NULL),(3739,642,'557255','834','00','005010X220A1','557255','','2013-12-12','12:23:49',0,'2013-12-25 22:08:50',NULL,NULL),(21523,4036,'3168923','834','00','005010X220A1','3168923','','2014-02-27','12:41:33',0,'2014-02-28 06:31:32',NULL,NULL),(16425,3002,'2033420','834','00','005010X220A1','2033420','','2014-01-23','09:44:22',0,'2014-01-23 21:01:39',NULL,NULL),(21083,3983,'2658304','834','00','005010X220A1','2658304','','2014-02-24','13:12:40',0,'2014-02-26 09:30:51',NULL,NULL),(16586,3040,'1709451','834','00','005010X220A1','1709451','','2014-01-25','17:27:05',0,'2014-01-25 19:00:15',NULL,NULL),(16967,3116,'1714796','834','00','005010X220A1','1714796','','2014-01-29','12:49:08',0,'2014-01-29 21:00:34',NULL,NULL),(19131,3548,'2814243','834','00','005010X220A1','2814243','','2014-02-11','21:34:32',0,'2014-02-12 21:31:57',NULL,NULL),(890,177,'816835','834','00','005010X220A1','816835','','2013-12-03','13:12:51',0,'2013-12-25 18:16:51',NULL,NULL),(19366,3590,'2584113','834','00','005010X220A1','2584113','','2014-02-12','22:08:07',0,'2014-02-13 22:02:04',NULL,NULL),(19267,3581,'1818124','834','00','005010X220A1','1818124','','2014-02-13','16:39:37',0,'2014-02-13 22:00:48',NULL,NULL),(10914,1410,'715986','834','00','005010X220A1','715986','','2013-12-22','20:26:01',0,'2013-12-26 13:08:06',NULL,NULL),(12516,1643,'2301330','834','00','005010X220A1','2301330','','2013-12-31','12:18:18',1,'2014-01-02 04:33:56',NULL,NULL),(18149,3345,'2142728','834','00','005010X220A1','2142728','','2014-02-06','16:14:05',0,'2014-02-06 21:01:53',NULL,NULL),(17985,3309,'2274309','834','00','005010X220A1','2274309','','2014-02-05','09:25:06',0,'2014-02-05 21:31:13',NULL,NULL),(12817,1704,'2295214','834','00','005010X220A1','2295214','','2014-01-02','20:53:11',0,'2014-01-04 02:01:52',NULL,NULL),(16404,2994,'2177053','834','00','005010X220A1','2177053','','2014-01-23','18:15:06',0,'2014-01-23 21:01:25',NULL,NULL),(22379,4208,'3516725','834','00','005010X220A1','3516725','','2014-03-04','11:00:18',0,'2014-03-04 21:02:02',NULL,NULL),(1362,245,'1729011','834','00','005010X220A1','1729011','','2013-12-24','15:05:49',0,'2013-12-25 18:52:48',NULL,NULL),(1637,281,'255202','834','00','005010X220A1','255202','','2013-11-19','23:08:22',0,'2013-12-25 19:02:07',NULL,NULL),(7654,1313,'715923','834','00','005010X220A1','715923','','2013-12-21','15:24:26',0,'2013-12-26 04:38:58',NULL,NULL),(21080,3981,'3207917','834','00','005010X220A1','3207917','','2014-02-24','00:15:47',0,'2014-02-26 09:30:48',NULL,NULL),(18554,3452,'3077089','834','00','005010X220A1','3077089','','2014-02-10','15:00:14',0,'2014-02-10 21:30:31',NULL,NULL),(15813,2729,'2266045','834','00','005010X220A1','2266045','','2014-01-20','13:05:53',0,'2014-01-21 08:46:56',NULL,NULL),(14968,2570,'1850807','834','00','005010X220A1','1850807','','2014-01-14','10:44:15',0,'2014-01-15 02:08:01',NULL,NULL),(13736,2275,'2101546','834','00','005010X220A1','2101546','','2014-01-07','15:43:51',0,'2014-01-08 18:24:45',NULL,NULL),(6135,1166,'471795','834','00','005010X220A1','471795','','2013-12-20','16:03:49',0,'2013-12-26 03:02:24',NULL,NULL),(12630,1671,'1458416','834','00','005010X220A1','1458416','','2014-01-02','17:51:37',0,'2014-01-03 02:02:07',NULL,NULL),(11480,1488,'1296911','834','00','005010X220A1','1296911','','2013-12-27','15:53:17',0,'2013-12-28 03:31:03',NULL,NULL),(2182,363,'1055316','834','00','005010X220A1','1055316','','2013-12-02','17:19:27',0,'2013-12-25 19:47:33',NULL,NULL),(4278,742,'713387','834','00','005010X220A1','713387','','2013-12-19','16:46:10',0,'2013-12-25 23:08:39',NULL,NULL),(22662,4254,'3692305','834','00','005010X220A1','3692305','','2014-03-05','10:44:25',0,'2014-03-05 21:32:00',NULL,NULL),(11276,1455,'1962567','834','00','005010X220A1','1962567','','2013-12-26','12:50:52',0,'2013-12-27 02:02:46',NULL,NULL),(4988,935,'553500','834','00','005010X220A1','553500','','2013-12-11','00:03:51',0,'2013-12-26 00:45:35',NULL,NULL),(4802,865,'1295777','834','00','005010X220A1','1295777','','2013-12-01','09:43:21',0,'2013-12-26 00:01:56',NULL,NULL),(17246,3169,'2535279','834','00','005010X220A1','2535279','','2014-01-30','17:26:10',0,'2014-01-30 21:01:40',NULL,NULL),(18273,3377,'2678114','834','00','005010X220A1','2678114','','2014-02-08','13:24:32',0,'2014-02-08 19:00:17',NULL,NULL),(18129,3335,'2281302','834','00','005010X220A1','2281302','','2014-02-06','17:24:54',0,'2014-02-06 21:01:37',NULL,NULL),(12937,1729,'2322415','834','00','005010X220A1','2322415','','2014-01-03','17:11:05',0,'2014-01-04 02:06:22',NULL,NULL),(12771,1702,'1895049','834','00','005010X220A1','1895049','','2014-01-02','22:43:13',0,'2014-01-04 02:00:07',NULL,NULL),(12628,1671,'2426551','834','00','005010X220A1','2426551','','2014-01-02','17:10:55',0,'2014-01-03 02:02:04',NULL,NULL),(19657,3650,'2779059','834','00','005010X220A1','2779059','','2014-02-14','16:00:18',0,'2014-02-14 21:32:19',NULL,NULL),(19141,3549,'2780165','834','00','005010X220A1','2780165','','2014-02-12','13:20:49',0,'2014-02-12 21:32:03',NULL,NULL),(18299,3381,'2821954','834','00','005010X220A1','2821954','','2014-02-07','18:58:11',0,'2014-02-08 19:00:34',NULL,NULL),(3752,646,'161020','834','00','005010X220A1','161020','','2013-12-12','14:25:38',0,'2013-12-25 22:09:16',NULL,NULL),(4709,836,'1727446','834','00','005010X220A1','1727446','','2013-12-23','21:37:50',0,'2013-12-25 23:50:57',NULL,NULL),(17228,3157,'2574084','834','00','005010X220A1','2574084','','2014-01-30','09:48:58',0,'2014-01-30 21:01:28',NULL,NULL),(16316,2980,'2216952','834','00','005010X220A1','2216952','','2014-01-23','15:45:56',0,'2014-01-23 21:00:25',NULL,NULL),(5088,938,'316771','834','00','005010X220A1','316771','','2013-12-11','13:58:43',0,'2013-12-26 00:48:46',NULL,NULL),(16097,2789,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','11:28:00',0,'2014-01-23 03:39:37',NULL,NULL),(6037,1147,'379518','834','00','005010X220A1','379518','','2013-11-17','13:49:50',0,'2013-12-26 02:46:06',NULL,NULL),(15311,2622,'2332659','834','00','005010X220A1','2332659','','2014-01-15','23:27:05',0,'2014-01-17 03:35:06',NULL,NULL),(15057,2585,'1872906','834','00','005010X220A1','1872906','','2014-01-14','21:47:32',0,'2014-01-16 08:44:54',NULL,NULL),(2853,512,'1056068','834','00','005010X220A1','1056068','','2013-12-22','10:48:01',0,'2013-12-25 21:22:07',NULL,NULL),(7425,1295,'167323','834','00','005010X220A1','167323','','2013-12-21','11:26:01',0,'2013-12-26 04:31:39',NULL,NULL),(6065,1164,'707699','834','00','005010X220A1','707699','','2013-12-20','09:40:12',0,'2013-12-26 03:00:12',NULL,NULL),(12437,1638,'1828795','834','00','005010X220A1','1828795','','2013-12-31','14:57:35',1,'2014-01-02 04:31:00',NULL,NULL),(11941,1576,'1523341','834','00','005010X220A1','1523341','','2013-12-29','14:45:42',0,'2013-12-30 00:02:19',NULL,NULL),(22421,4220,'3029664','834','00','005010X220A1','3029664','','2014-03-04','16:45:12',0,'2014-03-04 21:02:38',NULL,NULL),(2243,374,'958934','834','00','005010X220A1','958934','','2013-12-02','14:06:46',0,'2013-12-25 19:49:41',NULL,NULL),(2133,360,'155725','834','00','005010X220A1','155725','','2013-12-02','06:58:27',0,'2013-12-25 19:45:54',NULL,NULL),(19725,3672,'2812960','834','00','005010X220A1','2812960','','2014-02-15','14:47:32',0,'2014-02-15 22:00:25',NULL,NULL),(14293,2381,'1398666','834','00','005010X220A1','1398666','','2014-01-10','11:16:05',0,'2014-01-13 03:00:23',NULL,NULL),(19407,3593,'3215535','834','00','005010X220A1','3215535','','2014-02-13','13:46:48',0,'2014-02-13 22:02:34',NULL,NULL),(19262,3581,'3035325','834','00','005010X220A1','3035325','','2014-02-13','14:50:46',0,'2014-02-13 22:00:43',NULL,NULL),(13695,2274,'2254315','834','00','005010X220A1','2254315','','2014-01-06','23:59:55',0,'2014-01-08 18:24:27',NULL,NULL),(23453,4410,'3439173','834','00','005010X220A1','3439173','','2014-03-09','11:06:46',0,'2014-03-09 21:00:53',NULL,NULL),(23273,4380,'2959294','834','00','005010X220A1','2959294','','2014-03-07','18:00:29',0,'2014-03-08 21:29:59',NULL,NULL),(22999,4322,'3306773','834','00','005010X220A1','3306773','','2014-03-07','12:47:09',0,'2014-03-07 21:00:11',NULL,NULL),(13564,2254,'2219191','834','00','005010X220A1','2219191','','2014-01-04','19:05:08',1,'2014-01-07 10:21:20',NULL,NULL),(12951,1733,'2296351','834','00','005010X220A1','2296351','','2014-01-04','16:26:34',0,'2014-01-05 00:00:22',NULL,NULL),(2985,542,'313028','834','00','005010X220A1','313028','','2013-12-13','10:20:26',0,'2013-12-25 21:32:40',NULL,NULL),(1594,281,'1222305','834','00','005010X220A1','1222305','','2013-11-19','22:58:05',0,'2013-12-25 19:01:04',NULL,NULL),(19760,3674,'2646045','834','00','005010X220A1','2646045','','2014-02-15','11:29:20',0,'2014-02-15 22:00:51',NULL,NULL),(23770,4482,'2866351','834','00','005010X220A1','2866351','','2014-03-10','15:51:02',0,'2014-03-10 21:30:17',NULL,NULL),(691,110,'906319','834','00','005010X220A1','906319','','2013-12-15','19:43:38',0,'2013-12-25 18:06:28',NULL,NULL),(21582,4056,'3533819','834','00','005010X220A1','3533819','','2014-02-26','12:37:35',0,'2014-02-28 07:00:24',NULL,NULL),(21227,3999,'3571697','834','00','005010X220A1','3571697','','2014-02-26','09:33:46',0,'2014-02-26 21:01:34',NULL,NULL),(12733,1684,'2117915','834','00','005010X220A1','2117915','','2014-01-01','19:14:01',0,'2014-01-03 02:06:04',NULL,NULL),(21048,3977,'3374760','834','00','005010X220A1','3374760','','2014-02-24','16:37:54',0,'2014-02-26 09:30:24',NULL,NULL),(21000,3960,'3049761','834','00','005010X220A1','3049761','','2014-02-22','11:56:41',0,'2014-02-26 08:30:38',NULL,NULL),(20736,3903,'2620818','834','00','005010X220A1','2620818','','2014-02-24','22:15:45',0,'2014-02-25 21:30:07',NULL,NULL),(12401,1637,'1592562','834','00','005010X220A1','1592562','','2013-12-31','12:23:20',1,'2014-01-02 04:29:43',NULL,NULL),(7161,1238,'1109349','834','00','005010X220A1','1109349','','2013-12-18','09:48:25',0,'2013-12-26 04:05:25',NULL,NULL),(10618,1402,'983407','834','00','005010X220A1','983407','','2013-12-23','14:55:01',0,'2013-12-26 12:57:46',NULL,NULL),(2481,433,'1048136','834','00','005010X220A1','1048136','','2013-12-06','12:43:07',0,'2013-12-25 20:19:52',NULL,NULL),(13936,2317,'2407787','834','00','005010X220A1','2407787','','2014-01-09','15:05:15',0,'2014-01-13 02:20:10',NULL,NULL),(12235,1618,'2227670','834','00','005010X220A1','2227670','','2013-12-31','23:15:10',1,'2014-01-02 04:22:51',NULL,NULL),(1579,278,'373653','834','00','005010X220A1','373653','','2013-11-19','20:28:07',0,'2013-12-25 19:00:35',NULL,NULL),(1167,239,'1547087','834','00','005010X220A1','1547087','','2013-12-24','12:42:49',0,'2013-12-25 18:46:42',NULL,NULL),(11843,1545,'1276621','834','00','005010X220A1','1276621','','2013-12-28','20:09:08',1,'2013-12-29 11:14:30',NULL,NULL),(22624,4252,'3275454','834','00','005010X220A1','3275454','','2014-03-04','19:26:21',0,'2014-03-05 21:31:35',NULL,NULL),(567,103,'529826','834','00','005010X220A1','529826','','2013-12-16','14:45:30',0,'2013-12-25 18:02:34',NULL,NULL),(867,175,'870861','834','00','005010X220A1','870861','','2013-12-03','17:42:09',0,'2013-12-25 18:16:13',NULL,NULL),(1889,325,'1149759','834','00','005010X220A1','1149759','','2013-12-09','08:00:19',0,'2013-12-25 19:31:27',NULL,NULL),(3047,544,'1036293','834','00','005010X220A1','1036293','','2013-12-13','12:39:22',0,'2013-12-25 21:34:30',NULL,NULL),(3928,713,'35130','834','00','005010X220A1','35130','','2013-12-06','18:21:26',0,'2013-12-25 22:45:53',NULL,NULL),(5289,979,'526791','834','00','005010X220A1','526791','','2013-11-16','15:03:18',0,'2013-12-26 01:01:02',NULL,NULL),(11301,1456,'1428414','834','00','005010X220A1','1428414','','2013-12-25','23:01:32',0,'2013-12-27 02:03:32',NULL,NULL),(22372,4206,'3184189','834','00','005010X220A1','3184189','','2014-03-04','09:00:49',0,'2014-03-04 21:01:56',NULL,NULL),(23281,4380,'2816236','834','00','005010X220A1','2816236','','2014-03-08','09:44:28',0,'2014-03-08 21:30:06',NULL,NULL),(2638,499,'117929','834','00','005010X220A1','117929','','2013-11-28','08:22:06',0,'2013-12-25 20:47:13',NULL,NULL),(21218,3998,'3743143','834','00','005010X220A1','3743143','','2014-02-26','16:58:32',0,'2014-02-26 21:01:29',NULL,NULL),(21009,3961,'3626817','834','00','005010X220A1','3626817','','2014-02-22','15:53:40',0,'2014-02-26 08:30:45',NULL,NULL),(18746,3485,'3084451','834','00','005010X220A1','3084451','','2014-02-11','13:21:20',0,'2014-02-11 21:00:35',NULL,NULL),(17804,3271,'2841544','834','00','005010X220A1','2841544','','2014-02-04','11:23:24',0,'2014-02-04 21:01:36',NULL,NULL),(5820,1087,'483525','834','00','005010X220A1','483525','','2013-11-22','18:28:12',0,'2013-12-26 02:15:04',NULL,NULL),(16424,3002,'1841137','834','00','005010X220A1','1841137','','2014-01-23','14:05:11',0,'2014-01-23 21:01:38',NULL,NULL),(10805,1404,'1585291','834','00','005010X220A1','1585291','','2013-12-23','14:53:53',0,'2013-12-26 13:04:01',NULL,NULL),(14507,2515,'2357868','834','00','005010X220A1','2357868','','2014-01-13','15:04:30',0,'2014-01-14 01:32:06',NULL,NULL),(1139,238,'1417182','834','00','005010X220A1','1417182','','2013-12-24','17:45:30',0,'2013-12-25 18:45:52',NULL,NULL),(20375,3823,'2651633','834','00','005010X220A1','2651633','','2014-02-19','13:10:24',0,'2014-02-20 05:34:50',NULL,NULL),(7519,1300,'1053754','834','00','005010X220A1','1053754','','2013-12-21','12:20:02',0,'2013-12-26 04:34:39',NULL,NULL),(19028,3539,'2366459','834','00','005010X220A1','2366459','','2014-02-12','16:50:58',0,'2014-02-12 21:30:45',NULL,NULL),(17607,3240,'1650856','834','00','005010X220A1','1650856','','2014-02-03','16:00:09',0,'2014-02-03 21:01:03',NULL,NULL),(2856,512,'83821','834','00','005010X220A1','83821','','2013-12-22','12:39:55',0,'2013-12-25 21:22:12',NULL,NULL),(13975,2323,'1457271','834','00','005010X220A1','1457271','','2014-01-09','12:42:34',0,'2014-01-13 02:20:39',NULL,NULL),(12532,1646,'1488673','834','00','005010X220A1','1488673','','2013-12-31','16:38:03',1,'2014-01-02 04:34:30',NULL,NULL),(12402,1637,'2001342','834','00','005010X220A1','2001342','','2013-12-31','13:39:25',1,'2014-01-02 04:29:44',NULL,NULL),(11953,1580,'2322295','834','00','005010X220A1','2322295','','2013-12-30','03:34:50',0,'2014-01-01 12:00:19',NULL,NULL),(11033,1418,'976112','834','00','005010X220A1','976112','','2013-12-22','22:35:09',0,'2013-12-26 13:11:55',NULL,NULL),(3041,544,'1250632','834','00','005010X220A1','1250632','','2013-12-13','11:02:59',0,'2013-12-25 21:34:20',NULL,NULL),(3583,617,'562244','834','00','005010X220A1','562244','','2013-12-12','13:03:44',0,'2013-12-25 22:03:50',NULL,NULL),(4888,896,'395440','834','00','005010X220A1','395440','','2013-11-21','14:41:21',0,'2013-12-26 00:16:55',NULL,NULL),(22864,4280,'2964286','834','00','005010X220A1','2964286','','2014-03-06','13:22:03',0,'2014-03-06 21:01:49',NULL,NULL),(23235,4362,'3354260','834','00','005010X220A1','3354260','','2014-03-07','11:03:20',0,'2014-03-07 21:32:11',NULL,NULL),(463,87,'1262609','834','00','005010X220A1','1262609','','2013-12-03','19:28:24',0,'2013-12-25 17:50:24',NULL,NULL),(1646,284,'313789','834','00','005010X220A1','313789','','2013-11-20','13:20:34',0,'2013-12-25 19:02:22',NULL,NULL),(16287,2979,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:07:00',0,'2014-01-23 18:30:02',NULL,NULL),(2491,439,'639710','834','00','005010X220A1','639710','','2013-12-06','15:14:39',0,'2013-12-25 20:20:15',NULL,NULL),(15488,2634,'1435631','834','00','005010X220A1','1435631','','2014-01-16','14:42:58',0,'2014-01-17 03:36:26',NULL,NULL),(13910,2313,'2216596','834','00','005010X220A1','2216596','','2014-01-08','21:21:08',0,'2014-01-13 02:19:51',NULL,NULL),(2680,502,'1404149','834','00','005010X220A1','1404149','','2013-12-21','23:19:31',0,'2013-12-25 21:16:34',NULL,NULL),(13158,2002,'0001','999','BE','005010X231A1','773275','834','2013-12-28','11:05:00',0,'2014-01-05 16:57:55',NULL,NULL),(12928,1720,'1577825','834','00','005010X220A1','1577825','','2014-01-03','12:43:09',0,'2014-01-04 02:05:58',NULL,NULL),(12775,1702,'2400254','834','00','005010X220A1','2400254','','2014-01-03','13:39:16',0,'2014-01-04 02:00:18',NULL,NULL),(12560,1660,'1404606','834','00','005010X220A1','1404606','','2013-12-31','12:49:38',1,'2014-01-02 04:35:40',NULL,NULL),(23364,4392,'3843532','834','00','005010X220A1','3843532','','2014-03-08','10:00:52',0,'2014-03-08 21:31:09',NULL,NULL),(21,1,'972690','834','00','005010X220A1','972690','','2013-12-05','11:33:33',0,'2013-12-25 17:15:38',NULL,NULL),(19164,3556,'3094098','834','00','005010X220A1','3094098','','2014-02-12','17:18:56',0,'2014-02-12 21:32:20',NULL,NULL),(10686,1403,'1415946','834','00','005010X220A1','1415946','','2013-12-23','01:30:56',0,'2013-12-26 13:00:02',NULL,NULL),(18014,3318,'2713403','834','00','005010X220A1','2713403','','2014-02-05','18:55:32',0,'2014-02-06 21:00:17',NULL,NULL),(6339,1176,'533766','834','00','005010X220A1','533766','','2013-12-20','16:02:05',0,'2013-12-26 03:08:35',NULL,NULL),(13325,2169,'0001','999','BE','005010X231A1','873258','834','2013-12-28','11:05:00',0,'2014-01-05 17:25:21',NULL,NULL),(4616,827,'684351','834','00','005010X220A1','684351','','2013-12-23','21:42:09',0,'2013-12-25 23:47:44',NULL,NULL),(12246,1619,'1499755','834','00','005010X220A1','1499755','','2014-01-01','09:54:57',1,'2014-01-02 04:23:16',NULL,NULL),(11956,1580,'2282942','834','00','005010X220A1','2282942','','2013-12-30','09:02:46',0,'2014-01-01 12:00:26',NULL,NULL),(2868,515,'227466','834','00','005010X220A1','227466','','2013-12-22','07:24:14',0,'2013-12-25 21:22:33',NULL,NULL),(1644,283,'909130','834','00','005010X220A1','909130','','2013-11-20','10:03:28',0,'2013-12-25 19:02:18',NULL,NULL),(2723,503,'915919','834','00','005010X220A1','915919','','2013-12-22','00:52:15',0,'2013-12-25 21:17:55',NULL,NULL),(20994,3960,'2942858','834','00','005010X220A1','2942858','','2014-02-21','18:40:08',0,'2014-02-26 08:30:34',NULL,NULL),(3944,715,'316656','834','00','005010X220A1','316656','','2013-12-06','18:54:23',0,'2013-12-25 22:46:20',NULL,NULL),(18477,3429,'2313105','834','00','005010X220A1','2313105','','2014-02-10','04:29:13',0,'2014-02-10 11:00:57',NULL,NULL),(17667,3258,'1413064','834','00','005010X220A1','1413064','','2014-02-04','15:46:38',0,'2014-02-04 21:00:09',NULL,NULL),(16093,2785,'0001','999','BE','005010X231A1','229985','834','2014-01-13','22:20:00',0,'2014-01-23 03:39:34',NULL,NULL),(11192,1453,'1857252','834','00','005010X220A1','1857252','','2013-12-26','11:18:55',0,'2013-12-27 02:00:12',NULL,NULL),(15128,2587,'1546451','834','00','005010X220A1','1546451','','2014-01-15','15:38:57',0,'2014-01-16 08:45:38',NULL,NULL),(12898,1711,'2561700','834','00','005010X220A1','2561700','','2014-01-02','22:43:13',0,'2014-01-04 02:04:48',NULL,NULL),(23098,4339,'2741931','834','00','005010X220A1','2741931','','2014-03-07','17:44:38',0,'2014-03-07 21:30:33',NULL,NULL),(4622,827,'1296721','834','00','005010X220A1','1296721','','2013-12-23','22:11:26',0,'2013-12-25 23:47:58',NULL,NULL),(7490,1299,'1020507','834','00','005010X220A1','1020507','','2013-12-21','12:44:24',0,'2013-12-26 04:33:40',NULL,NULL),(5237,957,'828024','834','00','005010X220A1','828024','','2013-12-11','09:01:29',0,'2013-12-26 00:53:37',NULL,NULL),(17747,3262,'2385605','834','00','005010X220A1','2385605','','2014-02-04','11:29:25',0,'2014-02-04 21:00:59',NULL,NULL),(5339,1002,'1316746','834','00','005010X220A1','1316746','','2013-11-25','09:21:26',0,'2013-12-26 01:15:28',NULL,NULL),(16107,2799,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','01:52:00',1,'2014-01-23 03:42:31',NULL,NULL),(14159,2363,'2058594','834','00','005010X220A1','2058594','','2014-01-09','20:36:29',0,'2014-01-13 02:23:11',NULL,NULL),(15362,2624,'2502494','834','00','005010X220A1','2502494','','2014-01-15','18:31:55',0,'2014-01-17 03:35:28',NULL,NULL),(15266,2603,'1521198','834','00','005010X220A1','1521198','','2014-01-15','00:40:57',0,'2014-01-16 08:47:07',NULL,NULL),(15142,2588,'1906413','834','00','005010X220A1','1906413','','2014-01-14','21:11:50',0,'2014-01-16 08:45:49',NULL,NULL),(14842,2553,'1858704','834','00','005010X220A1','1858704','','2014-01-14','11:00:48',0,'2014-01-15 02:07:02',NULL,NULL),(23613,4441,'2873654','834','00','005010X220A1','2873654','','2014-03-09','21:49:13',0,'2014-03-10 21:01:25',NULL,NULL),(23616,4441,'2968199','834','00','005010X220A1','2968199','','2014-03-10','07:28:18',0,'2014-03-10 21:01:27',NULL,NULL),(11111,1426,'1595864','834','00','005010X220A1','1595864','','2013-12-23','09:06:57',0,'2013-12-26 13:14:28',NULL,NULL),(5960,1117,'762489','834','00','005010X220A1','762489','','2013-12-14','23:22:39',0,'2013-12-26 02:32:38',NULL,NULL),(20609,3871,'2761490','834','00','005010X220A1','2761490','','2014-02-20','21:47:00',0,'2014-02-21 22:00:23',NULL,NULL),(20411,3833,'2292228','834','00','005010X220A1','2292228','','2014-02-20','15:38:49',0,'2014-02-20 21:30:13',NULL,NULL),(19991,3746,'3257545','834','00','005010X220A1','3257545','','2014-02-18','13:01:22',0,'2014-02-18 22:00:27',NULL,NULL),(13215,2059,'0001','999','BE','005010X231A1','303809','834','2013-12-28','11:05:00',0,'2014-01-05 17:00:34',NULL,NULL),(18428,3420,'1716134','834','00','005010X220A1','1716134','','2014-02-10','04:20:34',0,'2014-02-10 11:00:15',NULL,NULL),(1366,245,'293575','834','00','005010X220A1','293575','','2013-12-24','15:10:21',0,'2013-12-25 18:52:55',NULL,NULL),(1838,317,'825124','834','00','005010X220A1','825124','','2013-12-10','17:47:55',0,'2013-12-25 19:20:53',NULL,NULL),(21735,4089,'3112901','834','00','005010X220A1','3112901','','2014-02-28','15:23:54',0,'2014-02-28 21:30:37',NULL,NULL),(21278,4003,'2962553','834','00','005010X220A1','2962553','','2014-02-26','10:16:23',0,'2014-02-26 21:02:08',NULL,NULL),(17522,3235,'2726757','834','00','005010X220A1','2726757','','2014-02-03','01:48:54',0,'2014-02-03 21:00:10',NULL,NULL),(16659,3060,'1790560','834','00','005010X220A1','1790560','','2014-01-27','14:11:55',0,'2014-01-27 21:00:17',NULL,NULL),(1998,329,'449517','834','00','005010X220A1','449517','','2013-12-09','12:23:19',0,'2013-12-25 19:34:48',NULL,NULL),(14724,2550,'2273813','834','00','005010X220A1','2273813','','2014-01-14','12:56:28',0,'2014-01-15 02:06:12',NULL,NULL),(14692,2549,'1632326','834','00','005010X220A1','1632326','','2014-01-14','13:56:19',0,'2014-01-15 02:05:58',NULL,NULL),(2052,335,'130874','834','00','005010X220A1','130874','','2013-12-09','16:47:05',0,'2013-12-25 19:36:28',NULL,NULL),(2959,541,'624105','834','00','005010X220A1','624105','','2013-12-13','11:38:45',0,'2013-12-25 21:31:52',NULL,NULL),(23017,4325,'2817499','834','00','005010X220A1','2817499','','2014-03-07','00:24:11',0,'2014-03-07 21:00:19',NULL,NULL),(3815,665,'70077','834','00','005010X220A1','70077','','2013-12-07','20:41:14',0,'2013-12-25 22:16:50',NULL,NULL),(22330,4203,'3784594','834','00','005010X220A1','3784594','','2014-03-03','23:28:07',0,'2014-03-04 21:01:22',NULL,NULL),(22243,4199,'3837081','834','00','005010X220A1','3837081','','2014-03-04','16:01:46',0,'2014-03-04 21:00:14',NULL,NULL),(4054,731,'1068720','834','00','005010X220A1','1068720','','2013-12-19','18:19:16',0,'2013-12-25 23:01:48',NULL,NULL),(21808,4093,'3671033','834','00','005010X220A1','3671033','','2014-02-27','19:17:25',0,'2014-02-28 21:31:26',NULL,NULL),(20872,3916,'3033177','834','00','005010X220A1','3033177','','2014-02-25','13:43:00',0,'2014-02-25 21:31:48',NULL,NULL),(6409,1197,'1150243','834','00','005010X220A1','1150243','','2013-12-20','16:46:18',0,'2013-12-26 03:10:49',NULL,NULL),(12682,1673,'2303630','834','00','005010X220A1','2303630','','2014-01-02','13:17:04',0,'2014-01-03 02:04:03',NULL,NULL),(15301,2622,'2278466','834','00','005010X220A1','2278466','','2014-01-15','18:19:35',0,'2014-01-17 03:35:01',NULL,NULL),(17213,3152,'1776441','834','00','005010X220A1','1776441','','2014-01-29','20:23:35',0,'2014-01-30 21:01:18',NULL,NULL),(15875,2739,'1495513','834','00','005010X220A1','1495513','','2014-01-21','14:02:17',1,'2014-01-22 03:22:24',NULL,NULL),(2323,407,'109209','834','00','005010X220A1','109209','','2013-10-22','13:59:30',0,'2013-12-25 20:02:01',NULL,NULL),(6088,1166,'745733','834','00','005010X220A1','745733','','2013-12-19','21:04:07',0,'2013-12-26 03:00:57',NULL,NULL),(3633,622,'599756','834','00','005010X220A1','599756','','2013-12-12','10:42:44',0,'2013-12-25 22:05:23',NULL,NULL),(4316,750,'1040642','834','00','005010X220A1','1040642','','2013-12-19','16:07:16',0,'2013-12-25 23:09:44',NULL,NULL),(18759,3485,'3236704','834','00','005010X220A1','3236704','','2014-02-11','16:20:12',0,'2014-02-11 21:00:45',NULL,NULL),(22266,4200,'2970560','834','00','005010X220A1','2970560','','2014-03-04','13:25:10',0,'2014-03-04 21:00:33',NULL,NULL),(21075,3980,'3764385','834','00','005010X220A1','3764385','','2014-02-24','16:29:39',0,'2014-02-26 09:30:46',NULL,NULL),(15156,2588,'1846072','834','00','005010X220A1','1846072','','2014-01-15','14:50:05',0,'2014-01-16 08:45:58',NULL,NULL),(14830,2553,'2197598','834','00','005010X220A1','2197598','','2014-01-13','19:11:56',0,'2014-01-15 02:06:57',NULL,NULL),(12721,1679,'1980487','834','00','005010X220A1','1980487','','2014-01-02','12:19:00',0,'2014-01-03 02:05:35',NULL,NULL),(23220,4351,'3003139','834','00','005010X220A1','3003139','','2014-03-06','21:02:21',0,'2014-03-07 21:31:59',NULL,NULL),(1102,229,'110307','834','00','005010X220A1','110307','','2013-10-24','18:27:56',0,'2013-12-25 18:32:05',NULL,NULL),(22186,4180,'3763145','834','00','005010X220A1','3763145','','2014-03-03','17:18:37',0,'2014-03-03 21:31:21',NULL,NULL),(11663,1500,'2135237','834','00','005010X220A1','2135237','','2013-12-27','17:06:46',0,'2013-12-28 03:36:40',NULL,NULL),(4826,876,'467320','834','00','005010X220A1','467320','','2013-12-01','15:18:11',0,'2013-12-26 00:02:40',NULL,NULL),(19393,3593,'2213599','834','00','005010X220A1','2213599','','2014-02-13','10:33:59',0,'2014-02-13 22:02:24',NULL,NULL),(18446,3423,'2515082','834','00','005010X220A1','2515082','','2014-02-10','00:08:19',0,'2014-02-10 11:00:30',NULL,NULL),(23214,4347,'3362696','834','00','005010X220A1','3362696','','2014-03-07','17:56:51',0,'2014-03-07 21:31:55',NULL,NULL),(1734,293,'5366','834','00','005010X220A1','5366','','2013-12-10','11:25:27',0,'2013-12-25 19:17:31',NULL,NULL),(22601,4250,'3428898','834','00','005010X220A1','3428898','','2014-03-05','11:19:21',0,'2014-03-05 21:31:19',NULL,NULL),(12266,1622,'1763205','834','00','005010X220A1','1763205','','2013-12-31','20:00:49',1,'2014-01-02 04:24:04',NULL,NULL),(14711,2550,'1994913','834','00','005010X220A1','1994913','','2014-01-14','10:33:39',0,'2014-01-15 02:06:06',NULL,NULL),(15991,2765,'2618576','834','00','005010X220A1','2618576','','2014-01-22','17:09:27',0,'2014-01-23 03:02:09',NULL,NULL),(18946,3527,'1884836','834','00','005010X220A1','1884836','','2014-02-11','11:42:22',0,'2014-02-11 21:30:25',NULL,NULL),(18153,3349,'1604872','834','00','005010X220A1','1604872','','2014-02-06','16:40:31',0,'2014-02-06 21:30:05',NULL,NULL),(288,63,'81674','834','00','005010X220A1','81674','','2013-11-08','20:31:03',0,'2013-12-25 17:32:16',NULL,NULL),(7696,1331,'1137846','834','00','005010X220A1','1137846','','2013-11-15','11:31:13',0,'2013-12-26 04:45:19',NULL,NULL),(1978,326,'129528','834','00','005010X220A1','129528','','2013-12-09','17:28:12',0,'2013-12-25 19:34:04',NULL,NULL),(4196,734,'709948','834','00','005010X220A1','709948','','2013-12-19','18:12:58',0,'2013-12-25 23:06:08',NULL,NULL),(12651,1672,'1654909','834','00','005010X220A1','1654909','','2014-01-02','13:06:05',0,'2014-01-03 02:02:58',NULL,NULL),(14934,2561,'1500055','834','00','005010X220A1','1500055','','2014-01-13','22:39:54',0,'2014-01-15 02:07:45',NULL,NULL),(13720,2275,'2502215','834','00','005010X220A1','2502215','','2014-01-07','16:10:40',0,'2014-01-08 18:24:38',NULL,NULL),(841,175,'365664','834','00','005010X220A1','365664','','2013-12-02','18:47:59',0,'2013-12-25 18:15:23',NULL,NULL),(22369,4205,'2702162','834','00','005010X220A1','2702162','','2014-03-04','15:53:57',0,'2014-03-04 21:01:54',NULL,NULL),(22260,4200,'3358654','834','00','005010X220A1','3358654','','2014-03-04','10:26:42',0,'2014-03-04 21:00:28',NULL,NULL),(22204,4185,'3397951','834','00','005010X220A1','3397951','','2014-03-03','14:36:22',0,'2014-03-03 21:31:35',NULL,NULL),(18249,3375,'2417188','834','00','005010X220A1','2417188','','2014-02-06','23:14:13',0,'2014-02-07 19:30:05',NULL,NULL),(16827,3091,'2269655','834','00','005010X220A1','2269655','','2014-01-27','19:56:17',0,'2014-01-28 21:00:24',NULL,NULL),(16283,2975,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:20:00',0,'2014-01-23 16:30:02',NULL,NULL),(16188,2880,'0001','999','BE','005010X231A1','1040956','834','2014-01-14','23:40:00',1,'2014-01-23 04:29:33',NULL,NULL),(7304,1262,'901318','834','00','005010X220A1','901318','','2013-12-18','14:25:52',0,'2013-12-26 04:09:50',NULL,NULL),(14589,2521,'1581850','834','00','005010X220A1','1581850','','2014-01-13','11:46:26',0,'2014-01-14 01:32:59',NULL,NULL),(14104,2343,'2483861','834','00','005010X220A1','2483861','','2014-01-08','12:51:33',0,'2014-01-13 02:22:12',NULL,NULL),(3897,708,'905673','834','00','005010X220A1','905673','','2013-10-26','00:02:13',0,'2013-12-25 22:32:08',NULL,NULL),(13339,2183,'0001','999','BE','005010X231A1','308784','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:00',NULL,NULL),(12926,1718,'1706220','834','00','005010X220A1','1706220','','2014-01-03','10:42:20',0,'2014-01-04 02:05:53',NULL,NULL),(3382,587,'1159910','834','00','005010X220A1','1159910','','2013-12-17','16:59:14',0,'2013-12-25 21:51:08',NULL,NULL),(4252,741,'419469','834','00','005010X220A1','419469','','2013-12-18','19:52:46',0,'2013-12-25 23:07:52',NULL,NULL),(1707,292,'1113017','834','00','005010X220A1','1113017','','2013-12-10','13:43:33',0,'2013-12-25 19:16:43',NULL,NULL),(15832,2736,'1954612','834','00','005010X220A1','1954612','','2014-01-21','10:45:21',1,'2014-01-22 03:21:57',NULL,NULL),(11177,1447,'1384353','834','00','005010X220A1','1384353','','2013-12-23','14:56:26',0,'2013-12-26 13:16:52',NULL,NULL),(11357,1458,'1696450','834','00','005010X220A1','1696450','','2013-12-26','16:19:04',0,'2013-12-27 02:05:16',NULL,NULL),(7339,1279,'43985','834','00','005010X220A1','43985','','2013-11-30','13:05:09',0,'2013-12-26 04:15:06',NULL,NULL),(1186,239,'1352843','834','00','005010X220A1','1352843','','2013-12-24','16:05:00',0,'2013-12-25 18:47:20',NULL,NULL),(23100,4340,'3398121','834','00','005010X220A1','3398121','','2014-03-06','18:25:54',0,'2014-03-07 21:30:34',NULL,NULL),(12317,1634,'2215032','834','00','005010X220A1','2215032','','2013-12-30','19:26:04',1,'2014-01-02 04:26:42',NULL,NULL),(3656,625,'1255478','834','00','005010X220A1','1255478','','2013-12-12','17:37:45',0,'2013-12-25 22:06:07',NULL,NULL),(7169,1238,'324718','834','00','005010X220A1','324718','','2013-12-18','14:22:55',0,'2013-12-26 04:05:39',NULL,NULL),(3651,625,'173373','834','00','005010X220A1','173373','','2013-12-12','09:49:26',0,'2013-12-25 22:05:56',NULL,NULL),(22564,4248,'3004429','834','00','005010X220A1','3004429','','2014-03-05','12:52:13',0,'2014-03-05 21:30:53',NULL,NULL),(2639,500,'1254660','834','00','005010X220A1','1254660','','2013-12-21','18:28:15',0,'2013-12-25 21:15:02',NULL,NULL),(1853,324,'226851','834','00','005010X220A1','226851','','2013-12-09','09:53:59',0,'2013-12-25 19:30:18',NULL,NULL),(1348,245,'1505433','834','00','005010X220A1','1505433','','2013-12-24','13:08:22',0,'2013-12-25 18:52:21',NULL,NULL),(21394,4024,'2695322','834','00','005010X220A1','2695322','','2014-02-27','17:49:02',0,'2014-02-28 06:30:32',NULL,NULL),(20177,3777,'3300041','834','00','005010X220A1','3300041','','2014-02-19','16:01:26',0,'2014-02-20 04:11:52',NULL,NULL),(19371,3590,'2824344','834','00','005010X220A1','2824344','','2014-02-13','10:54:26',0,'2014-02-13 22:02:08',NULL,NULL),(17628,3243,'2627628','834','00','005010X220A1','2627628','','2014-02-03','17:07:45',0,'2014-02-03 21:01:15',NULL,NULL),(2926,541,'723884','834','00','005010X220A1','723884','','2013-12-12','19:45:23',0,'2013-12-25 21:30:47',NULL,NULL),(22855,4280,'3047341','834','00','005010X220A1','3047341','','2014-03-05','23:05:52',0,'2014-03-06 21:01:43',NULL,NULL),(21813,4093,'3600514','834','00','005010X220A1','3600514','','2014-02-28','12:12:31',0,'2014-02-28 21:31:30',NULL,NULL),(21270,4001,'2732238','834','00','005010X220A1','2732238','','2014-02-26','11:24:23',0,'2014-02-26 21:02:02',NULL,NULL),(11846,1547,'1523117','834','00','005010X220A1','1523117','','2013-12-28','20:13:59',1,'2013-12-29 11:14:36',NULL,NULL),(3576,617,'202467','834','00','005010X220A1','202467','','2013-12-12','09:58:14',0,'2013-12-25 22:03:35',NULL,NULL),(13875,2312,'1575626','834','00','005010X220A1','1575626','','2014-01-08','18:20:00',0,'2014-01-13 02:19:29',NULL,NULL),(17920,3296,'1903226','834','00','005010X220A1','1903226','','2014-02-05','10:33:23',0,'2014-02-05 21:30:40',NULL,NULL),(17415,3200,'2582609','834','00','005010X220A1','2582609','','2014-01-31','22:46:40',0,'2014-02-01 19:00:19',NULL,NULL),(15889,2740,'1593094','834','00','005010X220A1','1593094','','2014-01-21','14:47:32',1,'2014-01-22 03:22:34',NULL,NULL),(108,5,'1257425','834','00','005010X220A1','1257425','','2013-12-05','17:35:41',0,'2013-12-25 17:18:16',NULL,NULL),(2457,422,'490563','834','00','005010X220A1','490563','','2013-12-06','12:39:19',0,'2013-12-25 20:19:05',NULL,NULL),(10537,1401,'1392952','834','00','005010X220A1','1392952','','2013-12-23','17:32:54',0,'2013-12-26 12:55:02',NULL,NULL),(6378,1184,'753103','834','00','005010X220A1','753103','','2013-12-20','09:52:54',0,'2013-12-26 03:09:48',NULL,NULL),(12867,1706,'2221504','834','00','005010X220A1','2221504','','2014-01-03','10:52:55',0,'2014-01-04 02:03:40',NULL,NULL),(18926,3519,'3079410','834','00','005010X220A1','3079410','','2014-02-11','18:20:14',0,'2014-02-11 21:30:06',NULL,NULL),(13310,2154,'0001','999','BE','005010X231A1','432763','834','2013-12-27','16:55:00',0,'2014-01-05 17:24:39',NULL,NULL),(18288,3380,'2969864','834','00','005010X220A1','2969864','','2014-02-07','18:58:11',0,'2014-02-08 19:00:27',NULL,NULL),(18143,3342,'2200729','834','00','005010X220A1','2200729','','2014-02-06','12:56:35',0,'2014-02-06 21:01:49',NULL,NULL),(18074,3321,'3008633','834','00','005010X220A1','3008633','','2014-02-06','16:35:15',0,'2014-02-06 21:00:58',NULL,NULL),(14883,2558,'1957055','834','00','005010X220A1','1957055','','2014-01-14','01:04:30',0,'2014-01-15 02:07:23',NULL,NULL),(16665,3060,'1958470','834','00','005010X220A1','1958470','','2014-01-27','16:46:40',0,'2014-01-27 21:00:21',NULL,NULL),(798,149,'391793','834','00','005010X220A1','391793','','2013-10-29','09:56:12',0,'2013-12-25 18:10:06',NULL,NULL),(2616,489,'1311184','834','00','005010X220A1','1311184','','2013-11-27','19:43:13',0,'2013-12-25 20:46:29',NULL,NULL),(4683,833,'1857136','834','00','005010X220A1','1857136','','2013-12-23','22:52:54',0,'2013-12-25 23:50:04',NULL,NULL),(20214,3782,'3051802','834','00','005010X220A1','3051802','','2014-02-19','14:25:47',0,'2014-02-20 04:21:34',NULL,NULL),(3853,686,'337823','834','00','005010X220A1','337823','','2013-11-08','15:18:22',0,'2013-12-25 22:30:42',NULL,NULL),(3150,558,'1037660','834','00','005010X220A1','1037660','','2013-12-13','09:01:28',0,'2013-12-25 21:37:46',NULL,NULL),(7483,1297,'1287581','834','00','005010X220A1','1287581','','2013-12-20','18:58:54',0,'2013-12-26 04:33:24',NULL,NULL),(10814,1404,'961221','834','00','005010X220A1','961221','','2013-12-23','15:43:17',0,'2013-12-26 13:04:19',NULL,NULL),(20308,3796,'2365222','834','00','005010X220A1','2365222','','2014-02-19','12:40:43',0,'2014-02-20 04:45:35',NULL,NULL),(20082,3762,'3088912','834','00','005010X220A1','3088912','','2014-02-18','13:54:16',0,'2014-02-18 22:01:32',NULL,NULL),(11048,1418,'1030256','834','00','005010X220A1','1030256','','2013-12-23','15:10:49',0,'2013-12-26 13:12:23',NULL,NULL),(19142,3549,'3002416','834','00','005010X220A1','3002416','','2014-02-12','15:20:01',0,'2014-02-12 21:32:03',NULL,NULL),(19071,3542,'1869316','834','00','005010X220A1','1869316','','2014-02-12','17:08:54',0,'2014-02-12 21:31:18',NULL,NULL),(17004,3118,'1728430','834','00','005010X220A1','1728430','','2014-01-29','13:57:47',0,'2014-01-29 21:00:56',NULL,NULL),(11130,1429,'589311','834','00','005010X220A1','589311','','2013-12-23','16:26:55',0,'2013-12-26 13:15:12',NULL,NULL),(657,108,'1214474','834','00','005010X220A1','1214474','','2013-12-16','16:51:16',0,'2013-12-25 18:05:25',NULL,NULL),(7635,1309,'463081','834','00','005010X220A1','463081','','2013-12-21','09:44:58',0,'2013-12-26 04:38:22',NULL,NULL),(2298,397,'1229413','834','00','005010X220A1','1229413','','2013-11-24','16:44:55',0,'2013-12-25 20:01:06',NULL,NULL),(5510,1041,'1447272','834','00','005010X220A1','1447272','','2013-12-24','20:25:10',0,'2013-12-26 01:46:45',NULL,NULL),(4545,825,'262647','834','00','005010X220A1','262647','','2013-12-23','22:36:58',0,'2013-12-25 23:45:30',NULL,NULL),(19847,3693,'3122910','834','00','005010X220A1','3122910','','2014-02-14','20:17:42',0,'2014-02-15 22:02:03',NULL,NULL),(19731,3673,'2650543','834','00','005010X220A1','2650543','','2014-02-14','21:17:54',0,'2014-02-15 22:00:30',NULL,NULL),(12455,1639,'1474266','834','00','005010X220A1','1474266','','2013-12-31','12:42:24',1,'2014-01-02 04:31:42',NULL,NULL),(12620,1671,'2143080','834','00','005010X220A1','2143080','','2014-01-02','13:45:51',0,'2014-01-03 02:01:47',NULL,NULL),(1858,324,'1021421','834','00','005010X220A1','1021421','','2013-12-09','12:27:41',0,'2013-12-25 19:30:28',NULL,NULL),(19866,3707,'3395102','834','00','005010X220A1','3395102','','2014-02-15','23:14:59',0,'2014-02-16 19:00:13',NULL,NULL),(1915,325,'97368','834','00','005010X220A1','97368','','2013-12-09','16:34:22',0,'2013-12-25 19:32:11',NULL,NULL),(17505,3225,'2618793','834','00','005010X220A1','2618793','','2014-02-02','15:59:58',0,'2014-02-02 19:00:28',NULL,NULL),(13990,2326,'2514766','834','00','005010X220A1','2514766','','2014-01-09','13:44:57',0,'2014-01-13 02:20:50',NULL,NULL),(3442,603,'833158','834','00','005010X220A1','833158','','2013-12-17','10:47:48',0,'2013-12-25 21:53:04',NULL,NULL),(3143,554,'1015209','834','00','005010X220A1','1015209','','2013-12-13','15:01:25',0,'2013-12-25 21:37:30',NULL,NULL),(7517,1300,'681603','834','00','005010X220A1','681603','','2013-12-21','11:35:06',0,'2013-12-26 04:34:36',NULL,NULL),(5790,1075,'998071','834','00','005010X220A1','998071','','2013-12-14','16:07:24',0,'2013-12-26 02:03:14',NULL,NULL),(23574,4436,'2662368','834','00','005010X220A1','2662368','','2014-03-10','14:21:25',0,'2014-03-10 21:00:58',NULL,NULL),(4861,885,'15108','834','00','005010X220A1','15108','','2013-11-21','17:40:24',0,'2013-12-26 00:15:57',NULL,NULL),(5535,1041,'2183807','834','00','005010X220A1','2183807','','2013-12-24','23:27:56',0,'2013-12-26 01:47:32',NULL,NULL),(13754,2277,'1502191','834','00','005010X220A1','1502191','','2014-01-07','10:53:52',0,'2014-01-08 18:24:54',NULL,NULL),(14044,2337,'2374822','834','00','005010X220A1','2374822','','2014-01-08','17:26:46',0,'2014-01-13 02:21:33',NULL,NULL),(17183,3148,'1721589','834','00','005010X220A1','1721589','','2014-01-30','11:12:04',0,'2014-01-30 21:00:58',NULL,NULL),(478,95,'305193','834','00','005010X220A1','305193','','2013-12-04','16:38:41',0,'2013-12-25 17:50:57',NULL,NULL),(1613,281,'468416','834','00','005010X220A1','468416','','2013-11-19','23:03:08',0,'2013-12-25 19:01:32',NULL,NULL),(19668,3657,'2507953','834','00','005010X220A1','2507953','','2014-02-14','16:44:53',0,'2014-02-14 21:32:28',NULL,NULL),(21200,3998,'3547285','834','00','005010X220A1','3547285','','2014-02-26','14:58:37',0,'2014-02-26 21:01:16',NULL,NULL),(2254,378,'932448','834','00','005010X220A1','932448','','2013-12-02','16:35:55',0,'2013-12-25 19:50:03',NULL,NULL),(11804,1539,'1064868','834','00','005010X220A1','1064868','','2013-12-28','20:06:01',1,'2013-12-29 11:13:12',NULL,NULL),(11400,1465,'1112423','834','00','005010X220A1','1112423','','2013-12-26','11:43:56',0,'2013-12-27 02:06:33',NULL,NULL),(18731,3485,'2838201','834','00','005010X220A1','2838201','','2014-02-11','10:48:41',0,'2014-02-11 21:00:24',NULL,NULL),(11017,1414,'938392','834','00','005010X220A1','938392','','2013-12-23','18:49:29',0,'2013-12-26 13:11:23',NULL,NULL),(6437,1204,'961688','834','00','005010X220A1','961688','','2013-11-22','15:21:45',0,'2013-12-26 03:15:38',NULL,NULL),(14166,2363,'1383496','834','00','005010X220A1','1383496','','2014-01-10','12:40:28',0,'2014-01-13 02:23:16',NULL,NULL),(16027,2768,'2106977','834','00','005010X220A1','2106977','','2014-01-22','15:52:13',0,'2014-01-23 03:02:25',NULL,NULL),(16729,3065,'1449298','834','00','005010X220A1','1449298','','2014-01-26','20:45:22',0,'2014-01-27 21:01:03',NULL,NULL),(2031,331,'327717','834','00','005010X220A1','327717','','2013-12-09','16:33:12',0,'2013-12-25 19:35:51',NULL,NULL),(23369,4393,'2871306','834','00','005010X220A1','2871306','','2014-03-08','16:24:44',0,'2014-03-08 21:31:12',NULL,NULL),(11600,1493,'2331009','834','00','005010X220A1','2331009','','2013-12-27','11:42:39',0,'2013-12-28 03:34:42',NULL,NULL),(10924,1410,'1242497','834','00','005010X220A1','1242497','','2013-12-23','10:56:00',0,'2013-12-26 13:08:26',NULL,NULL),(19299,3582,'1783005','834','00','005010X220A1','1783005','','2014-02-13','17:59:44',0,'2014-02-13 22:01:13',NULL,NULL),(4676,831,'68051','834','00','005010X220A1','68051','','2013-12-23','23:53:14',0,'2013-12-25 23:49:48',NULL,NULL),(4754,859,'105481','834','00','005010X220A1','105481','','2013-12-01','10:29:17',0,'2013-12-26 00:00:26',NULL,NULL),(5295,982,'188062','834','00','005010X220A1','188062','','2013-11-16','11:51:56',0,'2013-12-26 01:01:14',NULL,NULL),(13721,2275,'1770479','834','00','005010X220A1','1770479','','2014-01-07','16:11:34',0,'2014-01-08 18:24:38',NULL,NULL),(2724,503,'1452873','834','00','005010X220A1','1452873','','2013-12-22','03:45:02',0,'2013-12-25 21:17:57',NULL,NULL),(22950,4305,'2747193','834','00','005010X220A1','2747193','','2014-03-06','13:50:41',0,'2014-03-06 21:02:54',NULL,NULL),(21239,3999,'2909553','834','00','005010X220A1','2909553','','2014-02-26','12:30:56',0,'2014-02-26 21:01:40',NULL,NULL),(7644,1310,'108796','834','00','005010X220A1','108796','','2013-12-20','22:14:12',0,'2013-12-26 04:38:39',NULL,NULL),(20805,3910,'3287852','834','00','005010X220A1','3287852','','2014-02-24','18:48:30',0,'2014-02-25 21:30:58',NULL,NULL),(22095,4176,'3432494','834','00','005010X220A1','3432494','','2014-03-03','11:49:23',0,'2014-03-03 21:30:15',NULL,NULL),(3190,576,'187108','834','00','005010X220A1','187108','','2013-12-13','15:59:02',0,'2013-12-25 21:39:13',NULL,NULL),(21607,4064,'2640326','834','00','005010X220A1','2640326','','2014-02-27','12:25:14',0,'2014-02-28 07:30:10',NULL,NULL),(19154,3554,'2463930','834','00','005010X220A1','2463930','','2014-02-12','14:33:27',0,'2014-02-12 21:32:12',NULL,NULL),(6223,1168,'873907','834','00','005010X220A1','873907','','2013-12-20','14:41:48',0,'2013-12-26 03:05:01',NULL,NULL),(5186,949,'276352','834','00','005010X220A1','276352','','2013-12-11','10:38:18',0,'2013-12-26 00:51:54',NULL,NULL),(15141,2588,'1623414','834','00','005010X220A1','1623414','','2014-01-14','20:52:36',0,'2014-01-16 08:45:48',NULL,NULL),(14957,2566,'2086015','834','00','005010X220A1','2086015','','2014-01-14','10:33:03',0,'2014-01-15 02:07:55',NULL,NULL),(13832,2302,'2187563','834','00','005010X220A1','2187563','','2014-01-11','10:30:29',0,'2014-01-13 02:18:36',NULL,NULL),(4964,930,'896670','834','00','005010X220A1','896670','','2013-10-06','21:11:09',0,'2013-12-26 00:32:16',NULL,NULL),(14372,2405,'1601569','834','00','005010X220A1','1601569','','2014-01-11','22:44:13',0,'2014-01-13 03:01:42',NULL,NULL),(17030,3120,'2023316','834','00','005010X220A1','2023316','','2014-01-29','14:27:20',0,'2014-01-29 21:01:13',NULL,NULL),(17519,3234,'2235077','834','00','005010X220A1','2235077','','2014-02-03','15:09:33',0,'2014-02-03 21:00:08',NULL,NULL),(885,177,'569565','834','00','005010X220A1','569565','','2013-12-03','09:30:30',0,'2013-12-25 18:16:43',NULL,NULL),(22648,4253,'2914408','834','00','005010X220A1','2914408','','2014-03-05','15:48:05',0,'2014-03-05 21:31:51',NULL,NULL),(4379,774,'846874','834','00','005010X220A1','846874','','2013-11-26','18:29:11',0,'2013-12-25 23:15:19',NULL,NULL),(22341,4204,'3507931','834','00','005010X220A1','3507931','','2014-03-04','01:59:49',0,'2014-03-04 21:01:31',NULL,NULL),(10621,1402,'1648268','834','00','005010X220A1','1648268','','2013-12-23','15:01:33',0,'2013-12-26 12:57:51',NULL,NULL),(7456,1296,'1053739','834','00','005010X220A1','1053739','','2013-12-21','00:34:35',0,'2013-12-26 04:32:33',NULL,NULL),(19211,3578,'2216166','834','00','005010X220A1','2216166','','2014-02-13','13:05:53',0,'2014-02-13 21:30:17',NULL,NULL),(18265,3376,'2547256','834','00','005010X220A1','2547256','','2014-02-08','14:48:00',0,'2014-02-08 19:00:12',NULL,NULL),(15321,2622,'1984630','834','00','005010X220A1','1984630','','2014-01-16','11:06:54',0,'2014-01-17 03:35:10',NULL,NULL),(1811,310,'118163','834','00','005010X220A1','118163','','2013-12-10','14:49:21',0,'2013-12-25 19:19:59',NULL,NULL),(22771,4277,'2730428','834','00','005010X220A1','2730428','','2014-03-05','20:40:56',0,'2014-03-06 21:00:44',NULL,NULL),(11779,1533,'1794490','834','00','005010X220A1','1794490','','2013-12-27','22:06:21',1,'2013-12-29 11:10:19',NULL,NULL),(19726,3672,'2434670','834','00','005010X220A1','2434670','','2014-02-15','14:57:51',0,'2014-02-15 22:00:26',NULL,NULL),(19315,3583,'1965029','834','00','005010X220A1','1965029','','2014-02-13','07:35:43',0,'2014-02-13 22:01:25',NULL,NULL),(6152,1167,'774741','834','00','005010X220A1','774741','','2013-12-19','18:58:16',0,'2013-12-26 03:02:54',NULL,NULL),(18563,3453,'2824219','834','00','005010X220A1','2824219','','2014-02-10','08:56:48',0,'2014-02-10 21:30:38',NULL,NULL),(16096,2788,'0001','999','BE','005010X231A1','1359079','834','2014-01-15','22:50:00',0,'2014-01-23 03:39:37',NULL,NULL),(15140,2588,'1571835','834','00','005010X220A1','1571835','','2014-01-14','20:50:28',0,'2014-01-16 08:45:47',NULL,NULL),(2137,360,'1019787','834','00','005010X220A1','1019787','','2013-12-02','15:04:48',0,'2013-12-25 19:46:02',NULL,NULL),(23001,4322,'3323896','834','00','005010X220A1','3323896','','2014-03-07','13:03:07',0,'2014-03-07 21:00:12',NULL,NULL),(3547,616,'468800','834','00','005010X220A1','468800','','2013-12-12','13:54:41',0,'2013-12-25 22:02:42',NULL,NULL),(20290,3796,'3528213','834','00','005010X220A1','3528213','','2014-02-19','10:21:42',0,'2014-02-20 04:40:29',NULL,NULL),(2525,455,'449251','834','00','005010X220A1','449251','','2013-11-17','20:26:12',0,'2013-12-25 20:30:46',NULL,NULL),(4608,826,'990762','834','00','005010X220A1','990762','','2013-12-24','02:20:38',0,'2013-12-25 23:47:28',NULL,NULL),(5798,1077,'1281811','834','00','005010X220A1','1281811','','2013-12-14','12:28:17',0,'2013-12-26 02:03:27',NULL,NULL),(18144,3342,'2798862','834','00','005010X220A1','2798862','','2014-02-06','14:02:08',0,'2014-02-06 21:01:50',NULL,NULL),(23113,4342,'3828907','834','00','005010X220A1','3828907','','2014-03-06','18:29:46',0,'2014-03-07 21:30:45',NULL,NULL),(23692,4450,'3309321','834','00','005010X220A1','3309321','','2014-03-10','14:04:43',0,'2014-03-10 21:02:22',NULL,NULL),(1336,245,'1792965','834','00','005010X220A1','1792965','','2013-12-24','12:30:50',0,'2013-12-25 18:51:57',NULL,NULL),(19969,3746,'2889623','834','00','005010X220A1','2889623','','2014-02-18','13:05:14',0,'2014-02-18 22:00:11',NULL,NULL),(19310,3583,'2378304','834','00','005010X220A1','2378304','','2014-02-12','21:13:20',0,'2014-02-13 22:01:21',NULL,NULL),(18461,3425,'2287952','834','00','005010X220A1','2287952','','2014-02-10','04:23:36',0,'2014-02-10 11:00:43',NULL,NULL),(3306,584,'392538','834','00','005010X220A1','392538','','2013-12-17','12:46:21',0,'2013-12-25 21:48:41',NULL,NULL),(16945,3115,'2682916','834','00','005010X220A1','2682916','','2014-01-29','14:46:03',0,'2014-01-29 21:00:19',NULL,NULL),(4020,731,'232082','834','00','005010X220A1','232082','','2013-12-19','12:59:01',0,'2013-12-25 23:00:45',NULL,NULL),(15534,2654,'2519979','834','00','005010X220A1','2519979','','2014-01-17','10:32:41',0,'2014-01-20 08:05:37',NULL,NULL),(3171,565,'365989','834','00','005010X220A1','365989','','2013-12-13','11:19:33',0,'2013-12-25 21:38:31',NULL,NULL),(4915,909,'60070','834','00','005010X220A1','60070','','2013-10-16','10:09:13',0,'2013-12-26 00:30:37',NULL,NULL),(14102,2343,'1674950','834','00','005010X220A1','1674950','','2014-01-08','10:19:45',0,'2014-01-13 02:22:11',NULL,NULL),(1455,252,'1279206','834','00','005010X220A1','1279206','','2013-12-24','13:37:27',0,'2013-12-25 18:55:53',NULL,NULL),(5335,1002,'866131','834','00','005010X220A1','866131','','2013-11-25','17:57:03',0,'2013-12-26 01:15:20',NULL,NULL),(2043,332,'1129683','834','00','005010X220A1','1129683','','2013-12-09','16:04:38',0,'2013-12-25 19:36:11',NULL,NULL),(4628,827,'1406516','834','00','005010X220A1','1406516','','2013-12-23','23:06:32',0,'2013-12-25 23:48:11',NULL,NULL),(21983,4145,'3130470','834','00','005010X220A1','3130470','','2014-03-01','19:35:15',0,'2014-03-03 01:00:14',NULL,NULL),(20971,3956,'3254413','834','00','005010X220A1','3254413','','2014-02-22','09:52:10',0,'2014-02-26 08:30:09',NULL,NULL),(20964,3956,'2912737','834','00','005010X220A1','2912737','','2014-02-21','18:21:44',0,'2014-02-26 08:30:03',NULL,NULL),(4901,904,'274590','834','00','005010X220A1','274590','','2013-10-23','09:35:10',0,'2013-12-26 00:30:08',NULL,NULL),(19666,3655,'3127861','834','00','005010X220A1','3127861','','2014-02-14','15:55:13',0,'2014-02-14 21:32:26',NULL,NULL),(17929,3296,'2091185','834','00','005010X220A1','2091185','','2014-02-05','14:14:51',0,'2014-02-05 21:30:44',NULL,NULL),(5014,935,'432665','834','00','005010X220A1','432665','','2013-12-11','11:16:50',0,'2013-12-26 00:46:25',NULL,NULL),(1979,327,'183504','834','00','005010X220A1','183504','','2013-12-08','19:45:19',0,'2013-12-25 19:34:08',NULL,NULL),(13418,2222,'1996907','834','00','005010X220A1','1996907','','2014-01-06','16:33:06',0,'2014-01-07 04:01:30',NULL,NULL),(5730,1069,'1247862','834','00','005010X220A1','1247862','','2013-12-14','16:03:02',0,'2013-12-26 02:01:16',NULL,NULL),(10958,1410,'722943','834','00','005010X220A1','722943','','2013-12-23','18:22:28',0,'2013-12-26 13:09:25',NULL,NULL),(675,109,'950502','834','00','005010X220A1','950502','','2013-12-16','11:42:36',0,'2013-12-25 18:05:55',NULL,NULL),(930,180,'260705','834','00','005010X220A1','260705','','2013-12-03','14:52:36',0,'2013-12-25 18:18:01',NULL,NULL),(5021,935,'183582','834','00','005010X220A1','183582','','2013-12-11','11:36:18',0,'2013-12-26 00:46:37',NULL,NULL),(22192,4181,'3100739','834','00','005010X220A1','3100739','','2014-03-03','11:47:25',0,'2014-03-03 21:31:25',NULL,NULL),(4617,827,'1548118','834','00','005010X220A1','1548118','','2013-12-23','21:51:06',0,'2013-12-25 23:47:46',NULL,NULL),(6398,1191,'1069972','834','00','005010X220A1','1069972','','2013-12-20','14:51:18',0,'2013-12-26 03:10:24',NULL,NULL),(18276,3377,'2526961','834','00','005010X220A1','2526961','','2014-02-08','17:19:48',0,'2014-02-08 19:00:19',NULL,NULL),(10940,1410,'898815','834','00','005010X220A1','898815','','2013-12-23','14:15:29',0,'2013-12-26 13:08:55',NULL,NULL),(13039,1883,'0001','999','BE','005010X231A1','658045','834','2013-12-28','04:55:00',0,'2014-01-05 16:50:50',NULL,NULL),(3755,648,'52144','834','00','005010X220A1','52144','','2013-12-12','15:16:38',0,'2013-12-25 22:09:23',NULL,NULL),(3208,578,'1310285','834','00','005010X220A1','1310285','','2013-12-17','08:08:47',0,'2013-12-25 21:45:34',NULL,NULL),(15988,2765,'2172925','834','00','005010X220A1','2172925','','2014-01-22','11:48:15',0,'2014-01-23 03:02:07',NULL,NULL),(16082,2776,'1671729','834','00','005010X220A1','1671729','','2014-01-22','15:34:52',0,'2014-01-23 03:02:51',NULL,NULL),(16801,3088,'1646883','834','00','005010X220A1','1646883','','2014-01-28','17:49:27',0,'2014-01-28 21:00:08',NULL,NULL),(18500,3442,'2431209','834','00','005010X220A1','2431209','','2014-02-10','07:18:08',0,'2014-02-10 21:00:02',NULL,NULL),(3991,727,'874587','834','00','005010X220A1','874587','','2013-12-07','14:31:03',0,'2013-12-25 22:47:58',NULL,NULL),(21994,4146,'3312867','834','00','005010X220A1','3312867','','2014-03-01','19:21:34',0,'2014-03-03 01:00:20',NULL,NULL),(3975,718,'803100','834','00','005010X220A1','803100','','2013-12-07','05:47:55',0,'2013-12-25 22:47:25',NULL,NULL),(19542,3625,'2378341','834','00','005010X220A1','2378341','','2014-02-13','18:37:51',0,'2014-02-14 21:30:56',NULL,NULL),(2344,413,'277592','834','00','005010X220A1','277592','','2013-12-06','11:12:54',0,'2013-12-25 20:15:29',NULL,NULL),(14091,2341,'2174002','834','00','005010X220A1','2174002','','2014-01-08','15:42:01',0,'2014-01-13 02:22:04',NULL,NULL),(12744,1687,'1581588','834','00','005010X220A1','1581588','','2014-01-01','21:37:07',0,'2014-01-03 02:06:28',NULL,NULL),(6219,1168,'542578','834','00','005010X220A1','542578','','2013-12-20','09:45:55',0,'2013-12-26 03:04:53',NULL,NULL),(4650,827,'697968','834','00','005010X220A1','697968','','2013-12-24','01:26:14',0,'2013-12-25 23:48:53',NULL,NULL),(22041,4163,'3319518','834','00','005010X220A1','3319518','','2014-03-03','14:46:57',0,'2014-03-03 21:00:05',NULL,NULL),(21843,4108,'3404909','834','00','005010X220A1','3404909','','2014-02-28','14:07:13',0,'2014-02-28 21:31:54',NULL,NULL),(21771,4090,'3387023','834','00','005010X220A1','3387023','','2014-02-28','17:27:40',0,'2014-02-28 21:31:00',NULL,NULL),(4012,731,'981894','834','00','005010X220A1','981894','','2013-12-19','09:21:14',0,'2013-12-25 23:00:28',NULL,NULL),(19961,3746,'3488615','834','00','005010X220A1','3488615','','2014-02-18','09:46:24',0,'2014-02-18 22:00:05',NULL,NULL),(10447,1400,'271513','834','00','005010X220A1','271513','','2013-12-23','13:04:33',0,'2013-12-26 12:52:12',NULL,NULL),(17221,3154,'2480731','834','00','005010X220A1','2480731','','2014-01-30','11:40:39',0,'2014-01-30 21:01:23',NULL,NULL),(3412,592,'557437','834','00','005010X220A1','557437','','2013-12-16','22:34:56',0,'2013-12-25 21:52:07',NULL,NULL),(12972,1734,'1700553','834','00','005010X220A1','1700553','','2014-01-04','16:47:02',0,'2014-01-05 00:01:09',NULL,NULL),(1138,238,'1765051','834','00','005010X220A1','1765051','','2013-12-24','17:31:27',0,'2013-12-25 18:45:50',NULL,NULL),(4526,819,'535545','834','00','005010X220A1','535545','','2013-11-26','16:00:05',0,'2013-12-25 23:32:57',NULL,NULL),(5833,1091,'226621','834','00','005010X220A1','226621','','2013-11-23','00:23:34',0,'2013-12-26 02:15:29',NULL,NULL),(19839,3686,'3528145','834','00','005010X220A1','3528145','','2014-02-15','11:27:25',0,'2014-02-15 22:01:56',NULL,NULL),(17284,3172,'1841288','834','00','005010X220A1','1841288','','2014-01-30','18:37:39',0,'2014-01-31 21:00:30',NULL,NULL),(5931,1112,'1053457','834','00','005010X220A1','1053457','','2013-12-15','15:21:41',0,'2013-12-26 02:31:47',NULL,NULL),(6068,1164,'1014337','834','00','005010X220A1','1014337','','2013-12-20','14:18:50',0,'2013-12-26 03:00:18',NULL,NULL),(2835,511,'498311','834','00','005010X220A1','498311','','2013-12-21','23:43:31',0,'2013-12-25 21:21:29',NULL,NULL),(7016,1235,'67588','834','00','005010X220A1','67588','','2013-12-18','09:50:24',0,'2013-12-26 04:00:59',NULL,NULL),(10753,1403,'1614994','834','00','005010X220A1','1614994','','2013-12-23','17:52:33',0,'2013-12-26 13:02:18',NULL,NULL),(13358,2202,'0001','999','BE','005010X231A1','752811','834','2013-12-28','11:05:00',0,'2014-01-05 17:26:53',NULL,NULL),(3895,707,'277234','834','00','005010X220A1','277234','','2013-10-26','12:40:56',0,'2013-12-25 22:32:04',NULL,NULL),(10817,1404,'825773','834','00','005010X220A1','825773','','2013-12-23','16:21:46',0,'2013-12-26 13:04:25',NULL,NULL),(16798,3088,'2413304','834','00','005010X220A1','2413304','','2014-01-28','14:25:59',0,'2014-01-28 21:00:07',NULL,NULL),(13903,2313,'2257954','834','00','005010X220A1','2257954','','2014-01-09','16:05:21',0,'2014-01-13 02:19:47',NULL,NULL),(7059,1236,'563713','834','00','005010X220A1','563713','','2013-12-17','19:50:17',0,'2013-12-26 04:02:17',NULL,NULL),(7163,1238,'1156456','834','00','005010X220A1','1156456','','2013-12-18','10:30:57',0,'2013-12-26 04:05:29',NULL,NULL),(19456,3610,'3134963','834','00','005010X220A1','3134963','','2014-02-13','13:58:52',0,'2014-02-13 22:03:13',NULL,NULL),(16971,3116,'2537705','834','00','005010X220A1','2537705','','2014-01-29','16:37:26',0,'2014-01-29 21:00:36',NULL,NULL),(6395,1188,'583471','834','00','005010X220A1','583471','','2013-12-20','15:21:02',0,'2013-12-26 03:10:19',NULL,NULL),(14502,2515,'2074046','834','00','005010X220A1','2074046','','2014-01-13','13:27:53',0,'2014-01-14 01:32:02',NULL,NULL),(14852,2553,'2538822','834','00','005010X220A1','2538822','','2014-01-14','15:23:21',0,'2014-01-15 02:07:07',NULL,NULL),(14882,2558,'1648932','834','00','005010X220A1','1648932','','2014-01-13','23:18:25',0,'2014-01-15 02:07:22',NULL,NULL),(562,103,'899785','834','00','005010X220A1','899785','','2013-12-16','11:19:19',0,'2013-12-25 18:02:25',NULL,NULL),(22183,4180,'3803819','834','00','005010X220A1','3803819','','2014-03-03','16:25:22',0,'2014-03-03 21:31:18',NULL,NULL),(7291,1256,'287263','834','00','005010X220A1','287263','','2013-12-18','11:03:27',0,'2013-12-26 04:09:25',NULL,NULL),(21668,4078,'3098082','834','00','005010X220A1','3098082','','2014-02-28','10:32:37',0,'2014-02-28 21:00:12',NULL,NULL),(20553,3862,'2796601','834','00','005010X220A1','2796601','','2014-02-21','14:46:29',0,'2014-02-21 21:30:06',NULL,NULL),(4520,814,'775091','834','00','005010X220A1','775091','','2013-11-26','15:56:27',0,'2013-12-25 23:32:44',NULL,NULL),(16864,3093,'1465343','834','00','005010X220A1','1465343','','2014-01-28','12:58:34',0,'2014-01-28 21:00:50',NULL,NULL),(3705,633,'1042880','834','00','005010X220A1','1042880','','2013-12-12','14:36:43',0,'2013-12-25 22:07:40',NULL,NULL),(2059,336,'900984','834','00','005010X220A1','900984','','2013-12-09','17:59:12',0,'2013-12-25 19:36:42',NULL,NULL),(826,169,'180538','834','00','005010X220A1','180538','','2013-10-19','15:00:18',0,'2013-12-25 18:11:09',NULL,NULL),(13967,2322,'1493862','834','00','005010X220A1','1493862','','2014-01-09','11:15:03',0,'2014-01-13 02:20:33',NULL,NULL),(5097,940,'437373','834','00','005010X220A1','437373','','2013-12-11','12:36:08',0,'2013-12-26 00:49:05',NULL,NULL),(1599,281,'259185','834','00','005010X220A1','259185','','2013-11-19','22:59:04',0,'2013-12-25 19:01:11',NULL,NULL),(6033,1143,'412717','834','00','005010X220A1','412717','','2013-11-17','13:08:03',0,'2013-12-26 02:45:58',NULL,NULL),(22114,4177,'3180599','834','00','005010X220A1','3180599','','2014-03-03','13:04:12',0,'2014-03-03 21:30:30',NULL,NULL),(22276,4200,'3151682','834','00','005010X220A1','3151682','','2014-03-04','14:07:17',0,'2014-03-04 21:00:40',NULL,NULL),(22434,4230,'3345804','834','00','005010X220A1','3345804','','2014-03-03','18:01:26',0,'2014-03-04 21:30:05',NULL,NULL),(11541,1491,'2296173','834','00','005010X220A1','2296173','','2013-12-27','14:49:53',0,'2013-12-28 03:32:51',NULL,NULL),(2287,395,'1175480','834','00','005010X220A1','1175480','','2013-11-24','14:30:15',0,'2013-12-25 20:00:44',NULL,NULL),(13839,2308,'1774758','834','00','005010X220A1','1774758','','2014-01-11','14:30:33',0,'2014-01-13 02:18:41',NULL,NULL),(20807,3910,'3312695','834','00','005010X220A1','3312695','','2014-02-24','23:18:56',0,'2014-02-25 21:31:00',NULL,NULL),(14263,2375,'2529569','834','00','005010X220A1','2529569','','2014-01-09','23:17:55',0,'2014-01-13 03:00:06',NULL,NULL),(15061,2585,'2060026','834','00','005010X220A1','2060026','','2014-01-15','10:07:17',0,'2014-01-16 08:44:56',NULL,NULL),(19048,3540,'2822086','834','00','005010X220A1','2822086','','2014-02-12','14:56:56',0,'2014-02-12 21:30:59',NULL,NULL),(15674,2687,'2422955','834','00','005010X220A1','2422955','','2014-01-18','11:25:21',0,'2014-01-21 08:44:42',NULL,NULL),(23700,4451,'3370993','834','00','005010X220A1','3370993','','2014-03-10','12:13:27',0,'2014-03-10 21:02:27',NULL,NULL),(23728,4462,'2872419','834','00','005010X220A1','2872419','','2014-03-10','12:18:53',0,'2014-03-10 21:02:50',NULL,NULL),(11649,1499,'2112946','834','00','005010X220A1','2112946','','2013-12-27','14:53:50',0,'2013-12-28 03:36:14',NULL,NULL),(21029,3974,'2885977','834','00','005010X220A1','2885977','','2014-02-24','15:53:18',0,'2014-02-26 09:30:08',NULL,NULL),(2492,440,'23035','834','00','005010X220A1','23035','','2013-12-06','15:32:22',0,'2013-12-25 20:20:17',NULL,NULL),(11557,1492,'1828683','834','00','005010X220A1','1828683','','2013-12-27','09:11:07',0,'2013-12-28 03:33:23',NULL,NULL),(14639,2528,'2287556','834','00','005010X220A1','2287556','','2014-01-13','11:15:16',0,'2014-01-14 01:33:31',NULL,NULL),(23508,4434,'3829037','834','00','005010X220A1','3829037','','2014-03-10','12:33:59',0,'2014-03-10 21:00:09',NULL,NULL),(23517,4434,'3923860','834','00','005010X220A1','3923860','','2014-03-10','15:18:13',0,'2014-03-10 21:00:15',NULL,NULL),(1633,281,'1113822','834','00','005010X220A1','1113822','','2013-11-19','23:07:36',0,'2013-12-25 19:02:01',NULL,NULL),(10517,1401,'860933','834','00','005010X220A1','860933','','2013-12-22','22:36:29',0,'2013-12-26 12:54:22',NULL,NULL),(21183,3998,'3218272','834','00','005010X220A1','3218272','','2014-02-26','13:02:42',0,'2014-02-26 21:01:06',NULL,NULL),(20289,3794,'3455961','834','00','005010X220A1','3455961','','2014-02-19','10:36:28',0,'2014-02-20 04:40:15',NULL,NULL),(13422,2222,'1404729','834','00','005010X220A1','1404729','','2014-01-06','16:55:51',0,'2014-01-07 04:01:38',NULL,NULL),(18244,3370,'2812701','834','00','005010X220A1','2812701','','2014-02-07','17:13:34',0,'2014-02-07 19:01:08',NULL,NULL),(17314,3174,'2338865','834','00','005010X220A1','2338865','','2014-01-30','23:18:56',0,'2014-01-31 21:00:50',NULL,NULL),(17224,3156,'2005626','834','00','005010X220A1','2005626','','2014-01-30','09:32:40',0,'2014-01-30 21:01:25',NULL,NULL),(13475,2226,'1606669','834','00','005010X220A1','1606669','','2014-01-06','13:00:04',0,'2014-01-07 04:03:42',NULL,NULL),(22495,4246,'3690887','834','00','005010X220A1','3690887','','2014-03-04','18:03:51',0,'2014-03-05 21:30:03',NULL,NULL),(22500,4247,'3418807','834','00','005010X220A1','3418807','','2014-03-04','18:10:10',0,'2014-03-05 21:30:06',NULL,NULL),(22536,4248,'3507973','834','00','005010X220A1','3507973','','2014-03-04','18:28:04',0,'2014-03-05 21:30:32',NULL,NULL),(765,144,'911391','834','00','005010X220A1','911391','','2013-10-28','18:10:37',0,'2013-12-25 18:08:52',NULL,NULL),(21757,4090,'3676565','834','00','005010X220A1','3676565','','2014-02-28','11:53:03',0,'2014-02-28 21:30:51',NULL,NULL),(15508,2640,'2161511','834','00','005010X220A1','2161511','','2014-01-16','08:50:42',0,'2014-01-17 03:36:34',NULL,NULL),(1914,325,'295581','834','00','005010X220A1','295581','','2013-12-09','16:32:56',0,'2013-12-25 19:32:10',NULL,NULL),(15259,2601,'2499003','834','00','005010X220A1','2499003','','2014-01-15','12:41:20',0,'2014-01-16 08:47:03',NULL,NULL),(14885,2558,'2321570','834','00','005010X220A1','2321570','','2014-01-14','08:37:53',0,'2014-01-15 02:07:24',NULL,NULL),(14275,2375,'1457312','834','00','005010X220A1','1457312','','2014-01-10','16:40:12',0,'2014-01-13 03:00:13',NULL,NULL),(12261,1620,'1987978','834','00','005010X220A1','1987978','','2014-01-01','14:09:11',1,'2014-01-02 04:23:50',NULL,NULL),(11909,1564,'1761695','834','00','005010X220A1','1761695','','2013-12-29','15:35:58',0,'2013-12-30 00:01:19',NULL,NULL),(10693,1403,'141429','834','00','005010X220A1','141429','','2013-12-23','08:48:53',0,'2013-12-26 13:00:16',NULL,NULL),(23127,4342,'3573501','834','00','005010X220A1','3573501','','2014-03-07','11:01:56',0,'2014-03-07 21:30:54',NULL,NULL),(20,1,'1289869','834','00','005010X220A1','1289869','','2013-12-05','16:29:36',0,'2013-12-25 17:15:36',NULL,NULL),(22264,4200,'3142863','834','00','005010X220A1','3142863','','2014-03-04','12:27:57',0,'2014-03-04 21:00:32',NULL,NULL),(21495,4030,'3395353','834','00','005010X220A1','3395353','','2014-02-26','23:26:01',0,'2014-02-28 06:31:19',NULL,NULL),(1270,243,'597926','834','00','005010X220A1','597926','','2013-12-24','15:19:26',0,'2013-12-25 18:49:49',NULL,NULL),(19475,3620,'2737356','834','00','005010X220A1','2737356','','2014-02-13','20:54:54',0,'2014-02-14 21:30:08',NULL,NULL),(16083,2777,'1374553','834','00','005010X220A1','1374553','','2014-01-22','13:43:07',0,'2014-01-23 03:02:51',NULL,NULL),(7733,1342,'376982','834','00','005010X220A1','376982','','2013-10-20','20:37:01',0,'2013-12-26 05:00:18',NULL,NULL),(6103,1166,'1112006','834','00','005010X220A1','1112006','','2013-12-20','09:54:06',0,'2013-12-26 03:01:26',NULL,NULL),(13963,2322,'2377453','834','00','005010X220A1','2377453','','2014-01-09','16:02:45',0,'2014-01-13 02:20:30',NULL,NULL),(6045,1153,'487479','834','00','005010X220A1','487479','','2013-10-14','10:20:07',0,'2013-12-26 02:46:24',NULL,NULL),(18,1,'136277','834','00','005010X220A1','136277','','2013-12-05','13:29:00',0,'2013-12-25 17:15:33',NULL,NULL),(3747,644,'884020','834','00','005010X220A1','884020','','2013-12-12','17:04:17',0,'2013-12-25 22:09:06',NULL,NULL),(19633,3643,'2588366','834','00','005010X220A1','2588366','','2014-02-14','10:35:43',0,'2014-02-14 21:32:03',NULL,NULL),(7523,1300,'1138647','834','00','005010X220A1','1138647','','2013-12-21','12:57:30',0,'2013-12-26 04:34:46',NULL,NULL),(18331,3386,'2691142','834','00','005010X220A1','2691142','','2014-02-08','12:32:25',0,'2014-02-08 19:00:53',NULL,NULL),(758,139,'369585','834','00','005010X220A1','369585','','2013-12-16','17:42:59',0,'2013-12-25 18:08:35',NULL,NULL),(16272,2964,'0001','999','BE','005010X231A1','1040956','834','2014-01-15','00:08:00',0,'2014-01-23 11:00:02',NULL,NULL),(3794,659,'1161885','834','00','005010X220A1','1161885','','2013-12-07','19:08:23',0,'2013-12-25 22:16:05',NULL,NULL),(5911,1112,'928770','834','00','005010X220A1','928770','','2013-12-14','20:12:26',0,'2013-12-26 02:31:08',NULL,NULL),(4501,807,'589669','834','00','005010X220A1','589669','','2013-11-25','20:36:32',0,'2013-12-25 23:32:07',NULL,NULL),(5857,1098,'328557','834','00','005010X220A1','328557','','2013-11-23','08:24:49',0,'2013-12-26 02:16:25',NULL,NULL),(677,109,'153511','834','00','005010X220A1','153511','','2013-12-16','13:10:50',0,'2013-12-25 18:05:59',NULL,NULL),(3157,560,'970525','834','00','005010X220A1','970525','','2013-12-13','16:58:59',0,'2013-12-25 21:37:58',NULL,NULL),(5616,1044,'1861966','834','00','005010X220A1','1861966','','2013-12-24','23:53:56',0,'2013-12-26 01:50:12',NULL,NULL),(19574,3627,'3428371','834','00','005010X220A1','3428371','','2014-02-14','13:18:53',0,'2014-02-14 21:31:19',NULL,NULL),(18375,3406,'2276537','834','00','005010X220A1','2276537','','2014-02-09','15:50:55',0,'2014-02-09 19:00:18',NULL,NULL),(11373,1460,'1753768','834','00','005010X220A1','1753768','','2013-12-26','12:05:50',0,'2013-12-27 02:05:44',NULL,NULL),(13804,2294,'2431551','834','00','005010X220A1','2431551','','2014-01-11','17:19:45',0,'2014-01-13 02:18:17',NULL,NULL),(23260,4377,'3734715','834','00','005010X220A1','3734715','','2014-03-07','18:29:07',0,'2014-03-08 21:00:01',NULL,NULL),(1533,260,'1355013','834','00','005010X220A1','1355013','','2013-12-24','17:46:52',0,'2013-12-25 18:58:26',NULL,NULL),(21715,4088,'3057025','834','00','005010X220A1','3057025','','2014-02-28','11:04:44',0,'2014-02-28 21:30:24',NULL,NULL),(2229,372,'831593','834','00','005010X220A1','831593','','2013-12-02','14:06:46',0,'2013-12-25 19:49:11',NULL,NULL),(19934,3733,'3269976','834','00','005010X220A1','3269976','','2014-02-18','17:04:23',0,'2014-02-18 21:30:07',NULL,NULL),(11284,1455,'859807','834','00','005010X220A1','859807','','2013-12-26','14:10:17',0,'2013-12-27 02:03:00',NULL,NULL),(18829,3490,'2549475','834','00','005010X220A1','2549475','','2014-02-11','12:03:35',0,'2014-02-11 21:01:37',NULL,NULL),(17814,3273,'1529884','834','00','005010X220A1','1529884','','2014-02-04','14:26:26',0,'2014-02-04 21:01:42',NULL,NULL),(16332,2983,'2632354','834','00','005010X220A1','2632354','','2014-01-22','22:07:35',0,'2014-01-23 21:00:36',NULL,NULL),(7717,1335,'970063','834','00','005010X220A1','970063','','2013-11-14','21:20:29',0,'2013-12-26 04:46:03',NULL,NULL),(14422,2443,'0001','999','BE','005010X231A1','347193','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:33',NULL,NULL),(5412,1024,'857408','834','00','005010X220A1','857408','','2013-11-14','17:51:34',0,'2013-12-26 01:30:42',NULL,NULL),(11624,1495,'1270763','834','00','005010X220A1','1270763','','2013-12-27','17:06:46',0,'2013-12-28 03:35:28',NULL,NULL),(21426,4027,'3566722','834','00','005010X220A1','3566722','','2014-02-26','18:45:19',0,'2014-02-28 06:30:47',NULL,NULL),(1468,252,'748524','834','00','005010X220A1','748524','','2013-12-24','15:36:06',0,'2013-12-25 18:56:23',NULL,NULL),(17163,3144,'2472911','834','00','005010X220A1','2472911','','2014-01-30','17:35:32',0,'2014-01-30 21:00:45',NULL,NULL),(14516,2517,'2323872','834','00','005010X220A1','2323872','','2014-01-13','13:00:08',0,'2014-01-14 01:32:13',NULL,NULL),(16772,3075,'2177101','834','00','005010X220A1','2177101','','2014-01-27','11:17:43',0,'2014-01-27 21:01:35',NULL,NULL),(22866,4280,'3521802','834','00','005010X220A1','3521802','','2014-03-06','14:03:04',0,'2014-03-06 21:01:51',NULL,NULL),(4123,733,'773658','834','00','005010X220A1','773658','','2013-12-19','14:11:17',0,'2013-12-25 23:03:55',NULL,NULL),(22826,4278,'3542390','834','00','005010X220A1','3542390','','2014-03-06','15:18:58',0,'2014-03-06 21:01:21',NULL,NULL),(5754,1071,'1083105','834','00','005010X220A1','1083105','','2013-12-13','23:27:24',0,'2013-12-26 02:02:01',NULL,NULL),(22510,4247,'3092164','834','00','005010X220A1','3092164','','2014-03-05','10:51:22',0,'2014-03-05 21:30:13',NULL,NULL),(21796,4092,'2766565','834','00','005010X220A1','2766565','','2014-02-28','11:48:16',0,'2014-02-28 21:31:18',NULL,NULL),(21736,4089,'3393225','834','00','005010X220A1','3393225','','2014-02-28','15:35:27',0,'2014-02-28 21:30:38',NULL,NULL),(21608,4064,'3805071','834','00','005010X220A1','3805071','','2014-02-27','13:09:45',0,'2014-02-28 07:30:11',NULL,NULL),(7702,1332,'956214','834','00','005010X220A1','956214','','2013-11-14','23:56:44',0,'2013-12-26 04:45:32',NULL,NULL),(21066,3980,'2793855','834','00','005010X220A1','2793855','','2014-02-24','13:03:38',0,'2014-02-26 09:30:40',NULL,NULL),(19649,3647,'3230919','834','00','005010X220A1','3230919','','2014-02-14','16:39:46',0,'2014-02-14 21:32:13',NULL,NULL),(19105,3543,'3228365','834','00','005010X220A1','3228365','','2014-02-12','16:40:43',0,'2014-02-12 21:31:40',NULL,NULL),(18044,3319,'2661378','834','00','005010X220A1','2661378','','2014-02-05','22:51:11',0,'2014-02-06 21:00:37',NULL,NULL),(17119,3142,'2004638','834','00','005010X220A1','2004638','','2014-01-30','17:03:19',0,'2014-01-30 21:00:17',NULL,NULL),(15055,2585,'1403683','834','00','005010X220A1','1403683','','2014-01-14','21:44:18',0,'2014-01-16 08:44:53',NULL,NULL),(3073,545,'931419','834','00','005010X220A1','931419','','2013-12-13','18:07:17',0,'2013-12-25 21:35:22',NULL,NULL),(11686,1516,'2007461','834','00','005010X220A1','2007461','','2013-12-27','19:15:52',1,'2013-12-29 11:07:28',NULL,NULL),(11121,1428,'542749','834','00','005010X220A1','542749','','2013-12-23','08:26:14',0,'2013-12-26 13:14:49',NULL,NULL),(1556,270,'571970','834','00','005010X220A1','571970','','2013-12-24','13:40:31',0,'2013-12-25 18:59:11',NULL,NULL),(23082,4339,'3025884','834','00','005010X220A1','3025884','','2014-03-07','13:06:12',0,'2014-03-07 21:30:23',NULL,NULL),(236,40,'1022034','834','00','005010X220A1','1022034','','2013-10-12','13:19:31',0,'2013-12-25 17:30:24',NULL,NULL),(2088,347,'230607','834','00','005010X220A1','230607','','2013-12-09','17:03:56',0,'2013-12-25 19:37:38',NULL,NULL),(1355,245,'2028408','834','00','005010X220A1','2028408','','2013-12-24','13:53:52',0,'2013-12-25 18:52:35',NULL,NULL),(18699,3478,'1434654','834','00','005010X220A1','1434654','','2014-02-10','14:11:54',0,'2014-02-10 21:32:13',NULL,NULL),(18574,3453,'2228633','834','00','005010X220A1','2228633','','2014-02-10','14:34:03',0,'2014-02-10 21:30:45',NULL,NULL),(17960,3299,'2182370','834','00','005010X220A1','2182370','','2014-02-05','16:45:26',0,'2014-02-05 21:31:00',NULL,NULL),(10961,1410,'538860','834','00','005010X220A1','538860','','2013-12-23','18:23:10',0,'2013-12-26 13:09:29',NULL,NULL),(16977,3117,'1516668','834','00','005010X220A1','1516668','','2014-01-28','19:19:05',0,'2014-01-29 21:00:40',NULL,NULL),(16409,2995,'2349699','834','00','005010X220A1','2349699','','2014-01-23','16:11:17',0,'2014-01-23 21:01:28',NULL,NULL),(11437,1480,'2087683','834','00','005010X220A1','2087683','','2013-12-26','14:23:04',0,'2013-12-27 02:07:45',NULL,NULL),(4328,751,'1101555','834','00','005010X220A1','1101555','','2013-12-19','16:12:57',0,'2013-12-25 23:10:05',NULL,NULL),(15227,2595,'1954476','834','00','005010X220A1','1954476','','2014-01-15','12:50:29',0,'2014-01-16 08:46:42',NULL,NULL),(12506,1642,'2137684','834','00','005010X220A1','2137684','','2013-12-31','15:43:25',1,'2014-01-02 04:33:36',NULL,NULL),(102,4,'125956','834','00','005010X220A1','125956','','2013-12-05','15:21:11',0,'2013-12-25 17:18:06',NULL,NULL),(12117,1587,'1991924','834','00','005010X220A1','1991924','','2013-12-30','14:26:30',0,'2014-01-01 12:06:17',NULL,NULL),(11851,1548,'1550687','834','00','005010X220A1','1550687','','2013-12-28','20:14:26',1,'2013-12-29 11:14:49',NULL,NULL),(3051,544,'727659','834','00','005010X220A1','727659','','2013-12-13','13:43:14',0,'2013-12-25 21:34:39',NULL,NULL),(19895,3712,'3419573','834','00','005010X220A1','3419573','','2014-02-15','20:37:42',0,'2014-02-16 19:00:35',NULL,NULL),(5882,1109,'518685','834','00','005010X220A1','518685','','2013-12-14','19:15:09',0,'2013-12-26 02:30:10',NULL,NULL),(19768,3675,'2733429','834','00','005010X220A1','2733429','','2014-02-15','10:37:14',0,'2014-02-15 22:00:57',NULL,NULL),(17488,3220,'1934210','834','00','005010X220A1','1934210','','2014-02-01','22:43:08',0,'2014-02-02 19:00:17',NULL,NULL),(18388,3408,'2402345','834','00','005010X220A1','2402345','','2014-02-08','20:56:52',0,'2014-02-09 19:00:27',NULL,NULL),(23057,4339,'3279195','834','00','005010X220A1','3279195','','2014-03-06','19:31:41',0,'2014-03-07 21:30:04',NULL,NULL),(147,10,'148966','834','00','005010X220A1','148966','','2013-12-05','10:20:12',0,'2013-12-25 17:19:35',NULL,NULL),(347,72,'10013','834','00','005010X220A1','10013','','2013-12-04','10:46:45',0,'2013-12-25 17:46:42',NULL,NULL),(21219,3998,'3103001','834','00','005010X220A1','3103001','','2014-02-26','17:05:34',0,'2014-02-26 21:01:29',NULL,NULL),(654,108,'760365','834','00','005010X220A1','760365','','2013-12-16','16:35:47',0,'2013-12-25 18:05:20',NULL,NULL),(5008,935,'1285673','834','00','005010X220A1','1285673','','2013-12-11','10:57:50',0,'2013-12-26 00:46:13',NULL,NULL),(14417,2438,'0001','999','BE','005010X231A1','46580','834','2013-12-28','11:05:00',0,'2014-01-13 03:02:29',NULL,NULL),(19986,3746,'3165131','834','00','005010X220A1','3165131','','2014-02-18','17:11:34',0,'2014-02-18 22:00:24',NULL,NULL),(19606,3635,'2266656','834','00','005010X220A1','2266656','','2014-02-13','20:38:57',0,'2014-02-14 21:31:42',NULL,NULL),(19230,3580,'3122837','834','00','005010X220A1','3122837','','2014-02-13','10:51:39',0,'2014-02-13 22:00:17',NULL,NULL),(17294,3172,'1600632','834','00','005010X220A1','1600632','','2014-01-31','14:57:17',0,'2014-01-31 21:00:37',NULL,NULL),(17026,3120,'2369491','834','00','005010X220A1','2369491','','2014-01-29','13:11:15',0,'2014-01-29 21:01:11',NULL,NULL),(15986,2765,'1450313','834','00','005010X220A1','1450313','','2014-01-21','19:10:43',0,'2014-01-23 03:02:06',NULL,NULL),(3795,659,'1289925','834','00','005010X220A1','1289925','','2013-12-07','19:57:20',0,'2013-12-25 22:16:06',NULL,NULL),(22371,4206,'3086497','834','00','005010X220A1','3086497','','2014-03-03','20:25:04',0,'2014-03-04 21:01:56',NULL,NULL),(21044,3977,'3636615','834','00','005010X220A1','3636615','','2014-02-24','15:48:48',0,'2014-02-26 09:30:21',NULL,NULL),(20935,3941,'3698933','834','00','005010X220A1','3698933','','2014-02-23','13:40:02',0,'2014-02-26 08:00:29',NULL,NULL),(5403,1020,'121984','834','00','005010X220A1','121984','','2013-11-14','14:49:01',0,'2013-12-26 01:30:18',NULL,NULL),(19398,3593,'3077193','834','00','005010X220A1','3077193','','2014-02-13','12:13:11',0,'2014-02-13 22:02:28',NULL,NULL),(18810,3488,'2366380','834','00','005010X220A1','2366380','','2014-02-10','19:10:15',0,'2014-02-11 21:01:22',NULL,NULL),(14870,2555,'1925888','834','00','005010X220A1','1925888','','2014-01-14','09:53:18',0,'2014-01-15 02:07:15',NULL,NULL),(11921,1565,'2238481','834','00','005010X220A1','2238481','','2013-12-29','13:31:41',0,'2013-12-30 00:01:38',NULL,NULL),(11085,1423,'254760','834','00','005010X220A1','254760','','2013-12-22','23:16:11',0,'2013-12-26 13:13:37',NULL,NULL),(12168,1594,'1985572','834','00','005010X220A1','1985572','','2013-12-30','14:00:37',0,'2014-01-01 12:08:03',NULL,NULL),(3035,544,'1265503','834','00','005010X220A1','1265503','','2013-12-13','09:53:57',0,'2013-12-25 21:34:09',NULL,NULL),(22061,4168,'3400781','834','00','005010X220A1','3400781','','2014-03-03','15:22:41',0,'2014-03-03 21:00:18',NULL,NULL),(14294,2381,'2073981','834','00','005010X220A1','2073981','','2014-01-10','11:21:37',0,'2014-01-13 03:00:24',NULL,NULL),(18156,3350,'2952459','834','00','005010X220A1','2952459','','2014-02-06','18:42:18',0,'2014-02-07 19:00:04',NULL,NULL),(3876,697,'986139','834','00','005010X220A1','986139','','2013-10-04','15:17:52',0,'2013-12-25 22:31:25',NULL,NULL),(23095,4339,'2958083','834','00','005010X220A1','2958083','','2014-03-07','16:15:30',0,'2014-03-07 21:30:31',NULL,NULL),(22652,4254,'3452621','834','00','005010X220A1','3452621','','2014-03-04','19:19:44',0,'2014-03-05 21:31:54',NULL,NULL),(3217,578,'789320','834','00','005010X220A1','789320','','2013-12-17','09:31:10',0,'2013-12-25 21:45:50',NULL,NULL),(1395,245,'2101186','834','00','005010X220A1','2101186','','2013-12-24','18:13:58',0,'2013-12-25 18:53:52',NULL,NULL),(994,184,'93158','834','00','005010X220A1','93158','','2013-12-03','16:21:25',0,'2013-12-25 18:20:02',NULL,NULL),(19099,3543,'3157144','834','00','005010X220A1','3157144','','2014-02-12','12:13:13',0,'2014-02-12 21:31:37',NULL,NULL),(784,145,'341533','834','00','005010X220A1','341533','','2013-10-31','11:26:20',0,'2013-12-25 18:09:34',NULL,NULL),(12572,1669,'2008854','834','00','005010X220A1','2008854','','2013-12-31','18:30:35',1,'2014-01-02 04:36:13',NULL,NULL),(13712,2275,'1408402','834','00','005010X220A1','1408402','','2014-01-07','12:46:40',0,'2014-01-08 18:24:34',NULL,NULL),(15343,2622,'1406063','834','00','005010X220A1','1406063','','2014-01-15','20:11:38',0,'2014-01-17 03:35:20',NULL,NULL),(14001,2333,'1643920','834','00','005010X220A1','1643920','','2014-01-09','18:00:50',0,'2014-01-13 02:20:58',NULL,NULL),(13714,2275,'2438477','834','00','005010X220A1','2438477','','2014-01-07','12:56:23',0,'2014-01-08 18:24:35',NULL,NULL),(2333,412,'283350','834','00','005010X220A1','283350','','2013-12-06','11:40:30',0,'2013-12-25 20:15:05',NULL,NULL),(4098,733,'1291560','834','00','005010X220A1','1291560','','2013-12-19','10:57:29',0,'2013-12-25 23:03:12',NULL,NULL),(22513,4247,'2828068','834','00','005010X220A1','2828068','','2014-03-05','11:51:00',0,'2014-03-05 21:30:16',NULL,NULL),(6422,1203,'193275','834','00','005010X220A1','193275','','2013-11-21','22:05:54',0,'2013-12-26 03:15:13',NULL,NULL),(21990,4145,'2936313','834','00','005010X220A1','2936313','','2014-03-02','13:35:20',0,'2014-03-03 01:00:17',NULL,NULL),(15377,2624,'2128243','834','00','005010X220A1','2128243','','2014-01-15','23:46:47',0,'2014-01-17 03:35:36',NULL,NULL),(15734,2711,'2409550','834','00','005010X220A1','2409550','','2014-01-20','14:15:32',0,'2014-01-21 08:46:09',NULL,NULL),(17012,3119,'2489267','834','00','005010X220A1','2489267','','2014-01-28','21:00:39',0,'2014-01-29 21:01:01',NULL,NULL),(23685,4447,'3245081','834','00','005010X220A1','3245081','','2014-03-10','16:53:53',0,'2014-03-10 21:02:17',NULL,NULL),(13772,2285,'2115652','834','00','005010X220A1','2115652','','2014-01-07','16:37:42',0,'2014-01-08 18:25:01',NULL,NULL),(13427,2222,'1727830','834','00','005010X220A1','1727830','','2014-01-06','09:55:22',0,'2014-01-07 04:01:49',NULL,NULL),(12769,1702,'1912634','834','00','005010X220A1','1912634','','2014-01-02','18:29:54',0,'2014-01-04 02:00:03',NULL,NULL),(19153,3554,'2968852','834','00','005010X220A1','2968852','','2014-02-12','13:55:53',0,'2014-02-12 21:32:12',NULL,NULL),(16807,3089,'1788094','834','00','005010X220A1','1788094','','2014-01-28','15:00:12',0,'2014-01-28 21:00:12',NULL,NULL),(10434,1400,'1106967','834','00','005010X220A1','1106967','','2013-12-23','11:24:25',0,'2013-12-26 12:51:45',NULL,NULL),(10610,1402,'1654533','834','00','005010X220A1','1654533','','2013-12-23','13:42:44',0,'2013-12-26 12:57:29',NULL,NULL),(7436,1295,'7977','834','00','005010X220A1','7977','','2013-12-21','15:36:47',0,'2013-12-26 04:32:00',NULL,NULL),(1492,255,'1357634','834','00','005010X220A1','1357634','','2013-12-24','08:53:54',0,'2013-12-25 18:57:08',NULL,NULL),(14006,2337,'1512303','834','00','005010X220A1','1512303','','2014-01-08','18:14:47',0,'2014-01-13 02:21:09',NULL,NULL),(1397,246,'1677382','834','00','005010X220A1','1677382','','2013-12-24','07:48:23',0,'2013-12-25 18:53:57',NULL,NULL),(3838,682,'200673','834','00','005010X220A1','200673','','2013-11-08','07:10:06',0,'2013-12-25 22:30:11',NULL,NULL),(22639,4253,'3731032','834','00','005010X220A1','3731032','','2014-03-04','21:54:30',0,'2014-03-05 21:31:45',NULL,NULL),(5765,1072,'1055671','834','00','005010X220A1','1055671','','2013-12-14','10:18:04',0,'2013-12-26 02:02:23',NULL,NULL),(18171,3350,'2267707','834','00','005010X220A1','2267707','','2014-02-07','16:22:30',0,'2014-02-07 19:00:14',NULL,NULL),(17957,3299,'2937105','834','00','005010X220A1','2937105','','2014-02-05','16:15:28',0,'2014-02-05 21:30:59',NULL,NULL),(17300,3172,'1414361','834','00','005010X220A1','1414361','','2014-01-31','17:52:18',0,'2014-01-31 21:00:41',NULL,NULL),(15901,2742,'1991134','834','00','005010X220A1','1991134','','2014-01-20','22:03:18',1,'2014-01-22 03:22:41',NULL,NULL),(5440,1033,'752119','834','00','005010X220A1','752119','','2013-10-05','17:26:17',0,'2013-12-26 01:31:40',NULL,NULL),(21917,4127,'2874505','834','00','005010X220A1','2874505','','2014-03-01','14:51:48',0,'2014-03-01 21:00:40',NULL,NULL),(21834,4100,'2629754','834','00','005010X220A1','2629754','','2014-02-28','09:19:00',0,'2014-02-28 21:31:46',NULL,NULL),(13638,2270,'2446338','834','00','005010X220A1','2446338','','2014-01-07','15:15:01',0,'2014-01-08 18:24:05',NULL,NULL),(14969,2570,'1635849','834','00','005010X220A1','1635849','','2014-01-14','11:53:51',0,'2014-01-15 02:08:01',NULL,NULL),(15384,2624,'2507301','834','00','005010X220A1','2507301','','2014-01-16','18:07:44',0,'2014-01-17 03:35:39',NULL,NULL),(16382,2986,'2473946','834','00','005010X220A1','2473946','','2014-01-23','15:47:42',0,'2014-01-23 21:01:11',NULL,NULL),(13770,2283,'2328713','834','00','005010X220A1','2328713','','2014-01-07','12:16:00',0,'2014-01-08 18:25:00',NULL,NULL),(13769,2282,'2341567','834','00','005010X220A1','2341567','','2014-01-07','12:13:04',0,'2014-01-08 18:25:00',NULL,NULL),(7171,1238,'677685','834','00','005010X220A1','677685','','2013-12-18','15:08:28',0,'2013-12-26 04:05:43',NULL,NULL),(20514,3849,'3468821','834','00','005010X220A1','3468821','','2014-02-19','21:46:06',0,'2014-02-20 22:01:14',NULL,NULL),(17139,3144,'1467728','834','00','005010X220A1','1467728','','2014-01-30','10:36:02',0,'2014-01-30 21:00:30',NULL,NULL),(16020,2767,'1968449','834','00','005010X220A1','1968449','','2014-01-22','15:13:54',0,'2014-01-23 03:02:22',NULL,NULL),(3176,566,'411748','834','00','005010X220A1','411748','','2013-12-13','11:51:02',0,'2013-12-25 21:38:41',NULL,NULL),(793,146,'653674','834','00','005010X220A1','653674','','2013-10-31','14:55:00',0,'2013-12-25 18:09:54',NULL,NULL),(7498,1300,'457903','834','00','005010X220A1','457903','','2013-12-20','21:44:55',0,'2013-12-26 04:33:57',NULL,NULL),(20317,3796,'3124175','834','00','005010X220A1','3124175','','2014-02-19','13:17:30',0,'2014-02-20 04:47:24',NULL,NULL),(19690,3669,'2279223','834','00','005010X220A1','2279223','','2014-02-15','13:08:15',0,'2014-02-15 21:00:12',NULL,NULL),(18824,3490,'1696192','834','00','005010X220A1','1696192','','2014-02-11','11:03:09',0,'2014-02-11 21:01:33',NULL,NULL),(2748,503,'412247','834','00','005010X220A1','412247','','2013-12-22','18:13:59',0,'2013-12-25 21:18:40',NULL,NULL),(5247,961,'199983','834','00','005010X220A1','199983','','2013-12-11','10:55:24',0,'2013-12-26 00:53:54',NULL,NULL),(14872,2555,'2345042','834','00','005010X220A1','2345042','','2014-01-14','12:25:53',0,'2014-01-15 02:07:16',NULL,NULL),(3760,653,'185926','834','00','005010X220A1','185926','','2013-12-12','18:25:25',0,'2013-12-25 22:09:35',NULL,NULL),(14351,2402,'2124190','834','00','005010X220A1','2124190','','2014-01-12','16:49:03',0,'2014-01-13 03:01:25',NULL,NULL),(4060,731,'1152513','834','00','005010X220A1','1152513','','2013-12-18','18:42:57',0,'2013-12-25 23:01:59',NULL,NULL),(13087,1931,'0001','999','BE','005010X231A1','752811','834','2013-12-28','11:05:00',0,'2014-01-05 16:53:02',NULL,NULL),(12619,1671,'2425476','834','00','005010X220A1','2425476','','2014-01-02','13:34:40',0,'2014-01-03 02:01:46',NULL,NULL),(78,4,'37786','834','00','005010X220A1','37786','','2013-12-04','19:06:28',0,'2013-12-25 17:17:22',NULL,NULL),(23304,4381,'3830111','834','00','005010X220A1','3830111','','2014-03-08','11:04:36',0,'2014-03-08 21:30:23',NULL,NULL),(22793,4277,'3271836','834','00','005010X220A1','3271836','','2014-03-06','16:40:32',0,'2014-03-06 21:01:00',NULL,NULL),(1818,312,'277701','834','00','005010X220A1','277701','','2013-12-10','13:42:03',0,'2013-12-25 19:20:11',NULL,NULL),(10580,1402,'1414543','834','00','005010X220A1','1414543','','2013-12-23','11:41:46',0,'2013-12-26 12:56:33',NULL,NULL),(7485,1298,'1289006','834','00','005010X220A1','1289006','','2013-12-20','18:59:30',0,'2013-12-26 04:33:30',NULL,NULL),(13743,2276,'2196437','834','00','005010X220A1','2196437','','2014-01-07','14:02:29',0,'2014-01-08 18:24:48',NULL,NULL),(15210,2592,'2314172','834','00','005010X220A1','2314172','','2014-01-15','15:40:02',0,'2014-01-16 08:46:31',NULL,NULL),(14152,2358,'2486325','834','00','005010X220A1','2486325','','2014-01-08','17:30:41',0,'2014-01-13 02:22:44',NULL,NULL),(5481,1040,'1915377','834','00','005010X220A1','1915377','','2013-12-24','23:53:45',0,'2013-12-26 01:45:47',NULL,NULL),(5806,1080,'683804','834','00','005010X220A1','683804','','2013-12-14','11:51:10',0,'2013-12-26 02:03:44',NULL,NULL),(5961,1117,'1149962','834','00','005010X220A1','1149962','','2013-12-15','10:58:16',0,'2013-12-26 02:32:40',NULL,NULL),(19096,3543,'3006370','834','00','005010X220A1','3006370','','2014-02-12','10:23:58',0,'2014-02-12 21:31:35',NULL,NULL),(19024,3539,'2724796','834','00','005010X220A1','2724796','','2014-02-12','14:17:04',0,'2014-02-12 21:30:43',NULL,NULL),(2166,362,'157204','834','00','005010X220A1','157204','','2013-12-02','12:51:40',0,'2013-12-25 19:46:58',NULL,NULL),(1261,243,'1517106','834','00','005010X220A1','1517106','','2013-12-24','13:22:37',0,'2013-12-25 18:49:32',NULL,NULL),(18121,3331,'2567720','834','00','005010X220A1','2567720','','2014-02-06','13:49:06',0,'2014-02-06 21:01:31',NULL,NULL),(18080,3323,'2103586','834','00','005010X220A1','2103586','','2014-02-06','15:57:42',0,'2014-02-06 21:01:02',NULL,NULL),(17656,3255,'2194468','834','00','005010X220A1','2194468','','2014-02-03','17:45:42',0,'2014-02-03 21:01:36',NULL,NULL),(15506,2638,'2387667','834','00','005010X220A1','2387667','','2014-01-15','23:46:15',0,'2014-01-17 03:36:33',NULL,NULL),(15219,2594,'2420531','834','00','005010X220A1','2420531','','2014-01-15','00:05:34',0,'2014-01-16 08:46:37',NULL,NULL),(690,109,'119839','834','00','005010X220A1','119839','','2013-12-16','18:23:16',0,'2013-12-25 18:06:25',NULL,NULL),(23250,4368,'3764773','834','00','005010X220A1','3764773','','2014-03-07','12:58:19',0,'2014-03-07 21:32:23',NULL,NULL),(22885,4282,'3163003','834','00','005010X220A1','3163003','','2014-03-06','11:08:55',0,'2014-03-06 21:02:05',NULL,NULL),(22230,4194,'3017124','834','00','005010X220A1','3017124','','2014-03-03','14:44:20',0,'2014-03-03 21:31:54',NULL,NULL),(11361,1459,'2152455','834','00','005010X220A1','2152455','','2013-12-26','11:58:23',0,'2013-12-27 02:05:23',NULL,NULL),(20414,3834,'2688772','834','00','005010X220A1','2688772','','2014-02-20','14:00:56',0,'2014-02-20 21:30:15',NULL,NULL),(13065,1909,'0001','999','BE','005010X231A1','1187003','834','2013-12-28','11:05:00',0,'2014-01-05 16:52:02',NULL,NULL),(18981,3537,'2923686','834','00','005010X220A1','2923686','','2014-02-12','08:49:14',0,'2014-02-12 21:30:14',NULL,NULL),(10579,1402,'1657433','834','00','005010X220A1','1657433','','2013-12-23','11:30:20',0,'2013-12-26 12:56:30',NULL,NULL),(13672,2271,'1705335','834','00','005010X220A1','1705335','','2014-01-07','15:41:02',0,'2014-01-08 18:24:18',NULL,NULL),(14339,2400,'1765527','834','00','005010X220A1','1765527','','2014-01-12','17:58:27',0,'2014-01-13 03:01:18',NULL,NULL),(14642,2529,'2031732','834','00','005010X220A1','2031732','','2014-01-13','12:35:14',0,'2014-01-14 01:33:33',NULL,NULL);
/*!40000 ALTER TABLE `EdiTransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmergencyContact`
--

DROP TABLE IF EXISTS `EmergencyContact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmergencyContact` (
  `EmergencyContactId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `FullName` varchar(100) NOT NULL,
  `Relationship` varchar(200) NOT NULL,
  `ContactType` enum('Primary','Secondary') NOT NULL DEFAULT 'Primary',
  `Address` varchar(45) NOT NULL,
  `City` varchar(45) NOT NULL,
  `State` char(2) NOT NULL,
  `HomePhone` varchar(45) DEFAULT NULL,
  `CellPhone` varchar(45) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`EmergencyContactId`),
  KEY `EmergencyContactRefUser_fk_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmergencyContact`
--

LOCK TABLES `EmergencyContact` WRITE;
/*!40000 ALTER TABLE `EmergencyContact` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmergencyContact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerAgeRate`
--

DROP TABLE IF EXISTS `EmployerAgeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerAgeRate` (
  `EmployerAgeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `BeginAge` int(11) DEFAULT NULL,
  `EndAge` int(11) DEFAULT NULL,
  `Cost` decimal(10,2) DEFAULT NULL,
  `SpouseCost` decimal(10,2) DEFAULT NULL,
  `SmokerCost` decimal(10,2) DEFAULT NULL,
  `TierNameValueId` bigint(64) DEFAULT NULL,
  `ContributaryCost` decimal(10,2) DEFAULT NULL,
  `MaleCost` decimal(10,2) DEFAULT NULL,
  `FemaleCost` decimal(10,2) DEFAULT NULL,
  `SpouseFemaleCost` decimal(10,2) DEFAULT NULL,
  `SpouseMaleCost` decimal(10,2) DEFAULT NULL,
  `FemaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `MaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `LifeCoverageAmount` decimal(10,0) DEFAULT NULL,
  `LifeCostPerThousand` decimal(10,4) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerAgeRateId`),
  KEY `EmployerAgeRateRefEmployerPlan_fk_idx` (`EmployerPlanId`),
  KEY `EmployerAgeRateRefTierNameValue_fk_idx` (`TierNameValueId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerAgeRate`
--

LOCK TABLES `EmployerAgeRate` WRITE;
/*!40000 ALTER TABLE `EmployerAgeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerAgeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerChildAgeRate`
--

DROP TABLE IF EXISTS `EmployerChildAgeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerChildAgeRate` (
  `EmployerChildAgeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `ChildNumber` int(11) NOT NULL DEFAULT '0',
  `MaleCost` decimal(10,2) NOT NULL,
  `FemaleCost` decimal(10,2) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerChildAgeRateId`),
  KEY `EmployerChildAgeRateRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerChildAgeRate`
--

LOCK TABLES `EmployerChildAgeRate` WRITE;
/*!40000 ALTER TABLE `EmployerChildAgeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerChildAgeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClass`
--

DROP TABLE IF EXISTS `EmployerClass`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClass` (
  `EmployerClassId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ClassName` varchar(100) NOT NULL,
  `ClassCode` char(20) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassId`),
  KEY `DomainClassRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClass`
--

LOCK TABLES `EmployerClass` WRITE;
/*!40000 ALTER TABLE `EmployerClass` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClass` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassAgeRate`
--

DROP TABLE IF EXISTS `EmployerClassAgeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassAgeRate` (
  `EmployerClassAgeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassPlanId` bigint(64) NOT NULL,
  `EmployerClassDetailId` bigint(64) NOT NULL,
  `RateTypeNameId` bigint(64) DEFAULT NULL,
  `EmployeeCost` decimal(10,2) DEFAULT NULL,
  `EmployeePercentage` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassAgeRateId`),
  KEY `EmployerClassCompositeRateRefEmployerClassPlan_fk_idx` (`EmployerClassPlanId`),
  KEY `EmployerClassAgeRateRefRateTypeName_fk_idx` (`RateTypeNameId`),
  KEY `EmployerClassAgeRateRefEmployerClassDetail_fk_idx` (`EmployerClassDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassAgeRate`
--

LOCK TABLES `EmployerClassAgeRate` WRITE;
/*!40000 ALTER TABLE `EmployerClassAgeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassAgeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassCompositeRate`
--

DROP TABLE IF EXISTS `EmployerClassCompositeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassCompositeRate` (
  `EmployerClassCompositeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassPlanId` bigint(64) NOT NULL,
  `TierNameValueId` bigint(64) NOT NULL,
  `EmployeeCost` decimal(10,2) DEFAULT NULL,
  `EmployeePercentage` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassCompositeRateId`),
  KEY `EmployerClassCompositeRateRefTierNameValue_fk_idx` (`TierNameValueId`),
  KEY `EmployerClassCompositeRateRefEmployerClassPlan_fk_idx` (`EmployerClassPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassCompositeRate`
--

LOCK TABLES `EmployerClassCompositeRate` WRITE;
/*!40000 ALTER TABLE `EmployerClassCompositeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassCompositeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassDetail`
--

DROP TABLE IF EXISTS `EmployerClassDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassDetail` (
  `EmployerClassDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassId` bigint(64) NOT NULL,
  `MakeDefinedContributionsForAllPlans` tinyint(1) NOT NULL DEFAULT '0',
  `ContributionAmount` decimal(10,2) DEFAULT NULL,
  `ContributionFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') DEFAULT NULL,
  `PayFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') DEFAULT NULL,
  `EligibleForOverTime` tinyint(1) DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassDetailId`),
  KEY `EmployerClassDetailRefEmployerClassId_fk_idx` (`EmployerClassId`)
) ENGINE=innodb AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassDetail`
--

LOCK TABLES `EmployerClassDetail` WRITE;
/*!40000 ALTER TABLE `EmployerClassDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassDocument`
--

DROP TABLE IF EXISTS `EmployerClassDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassDocument` (
  `EmployerClassDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassId` bigint(64) NOT NULL,
  `DocumentId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassDocumentId`),
  KEY `EmployerClassDocumentRefDocument_fk_idx` (`DocumentId`),
  KEY `EmployerClassDocumentRefEmployerClass_fk_idx` (`EmployerClassId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassDocument`
--

LOCK TABLES `EmployerClassDocument` WRITE;
/*!40000 ALTER TABLE `EmployerClassDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassPlan`
--

DROP TABLE IF EXISTS `EmployerClassPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassPlan` (
  `EmployerClassPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `EmployerClassPlanTypeId` bigint(64) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `ContributionType` enum('Defined Contribution','Buy Up','Percentage','Dollar') DEFAULT NULL,
  `MaximumAmount` decimal(10,2) DEFAULT NULL,
  `MinimumAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassPlanId`),
  KEY `EmployerClassPlanRefEmployerClassPlanType_fk_idx` (`EmployerClassPlanTypeId`),
  KEY `EmployerClassPlanRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassPlan`
--

LOCK TABLES `EmployerClassPlan` WRITE;
/*!40000 ALTER TABLE `EmployerClassPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerClassPlanType`
--

DROP TABLE IF EXISTS `EmployerClassPlanType`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerClassPlanType` (
  `EmployerClassPlanTypeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerClassDetailId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `FSAAndHSAId` bigint(64) DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `NewHireWaitingPeriod` enum('0 Days','30 Days','60 Days','90 Days','1st of Month after 0 days','1st of Month after 30 days','1st of Month after 60 days','1st of Month after 90 days') DEFAULT NULL,
  `RehireWaitingPeriod` enum('0 Days','30 Days','60 Days','90 Days','1st of Month after 0 days','1st of Month after 30 days','1st of Month after 60 days','1st of Month after 90 days') DEFAULT NULL,
  `BenefitsEndDate` enum('End of Month','Date of Termination','Other') DEFAULT NULL,
  `TaxStatus` enum('Post-Tax','Pre-Tax') DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerClassPlanTypeId`),
  KEY `DomainClassDetailRefDomainPlanType_fk_idx` (`LineOfCoverageId`),
  KEY `EmployerClassPlanTypeRefEmployerClass_fk_idx` (`EmployerClassDetailId`),
  KEY `EmployerClassPlanTypeRefFSAAndHSA_fk_idx` (`FSAAndHSAId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerClassPlanType`
--

LOCK TABLES `EmployerClassPlanType` WRITE;
/*!40000 ALTER TABLE `EmployerClassPlanType` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerClassPlanType` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerCompositeRate`
--

DROP TABLE IF EXISTS `EmployerCompositeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerCompositeRate` (
  `EmployerCompositeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `TierNameValueId` bigint(64) DEFAULT NULL,
  `Cost` decimal(10,2) DEFAULT NULL,
  `ContributaryCost` decimal(10,2) DEFAULT NULL,
  `LifeCostPerThousand` decimal(10,4) DEFAULT NULL,
  `LifeCoverageAmount` decimal(10,0) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerCompositeRateId`),
  KEY `EmployerCompositeRateRefEmployerPlan_fk_idx` (`EmployerPlanId`),
  KEY `EmployerCompositeRateRefTierNameValue_fk_idx` (`TierNameValueId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerCompositeRate`
--

LOCK TABLES `EmployerCompositeRate` WRITE;
/*!40000 ALTER TABLE `EmployerCompositeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerCompositeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerCountyBaseRate`
--

DROP TABLE IF EXISTS `EmployerCountyBaseRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerCountyBaseRate` (
  `EmployerCountyBaseRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `CountyName` varchar(100) NOT NULL,
  `CountyFactor` decimal(10,6) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerCountyBaseRateId`),
  UNIQUE KEY `EmployerCountyBaseRateCounty_uq` (`CountyName`),
  KEY `EmployerCountyBaseRateRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerCountyBaseRate`
--

LOCK TABLES `EmployerCountyBaseRate` WRITE;
/*!40000 ALTER TABLE `EmployerCountyBaseRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerCountyBaseRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerLifeCoverage`
--

DROP TABLE IF EXISTS `EmployerLifeCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerLifeCoverage` (
  `EmployerLifeCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `FixCoverageAmount` decimal(10,0) DEFAULT NULL,
  `PercentageOfSalary` int(11) DEFAULT NULL,
  `TypeCoverage` enum('Percentage','Dollar') DEFAULT NULL,
  `TypeIndividual` enum('Employee','Spouse','Child') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerLifeCoverageId`),
  KEY `EmployerLifeCoverageRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerLifeCoverage`
--

LOCK TABLES `EmployerLifeCoverage` WRITE;
/*!40000 ALTER TABLE `EmployerLifeCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerLifeCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerOpenEnrollment`
--

DROP TABLE IF EXISTS `EmployerOpenEnrollment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerOpenEnrollment` (
  `EmployerOpenEnrollmentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `OpenStartDate` date DEFAULT NULL,
  `OpenStopDate` date DEFAULT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `OpenHeader` varchar(500) DEFAULT NULL,
  `OpenBody` varchar(1500) DEFAULT NULL,
  `ClosedHeader` varchar(500) DEFAULT NULL,
  `ClosedBody` varchar(1500) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerOpenEnrollmentId`),
  KEY `EmployerOpenEnrollmentPeriodRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerOpenEnrollment`
--

LOCK TABLES `EmployerOpenEnrollment` WRITE;
/*!40000 ALTER TABLE `EmployerOpenEnrollment` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerOpenEnrollment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerOpenEnrollmentPlan`
--

DROP TABLE IF EXISTS `EmployerOpenEnrollmentPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerOpenEnrollmentPlan` (
  `EmployerOpenEnrollmentPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerOpenEnrollmentId` bigint(64) NOT NULL,
  `EmployerPlanId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerOpenEnrollmentPlanId`),
  KEY `EmployerOpenEnrollmentPlanRefOpenEnrollment_fk_idx` (`EmployerOpenEnrollmentId`),
  KEY `EmployerOpenEnrollmentPlanRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerOpenEnrollmentPlan`
--

LOCK TABLES `EmployerOpenEnrollmentPlan` WRITE;
/*!40000 ALTER TABLE `EmployerOpenEnrollmentPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerOpenEnrollmentPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerPlan`
--

DROP TABLE IF EXISTS `EmployerPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerPlan` (
  `EmployerPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `PlanNetworkId` bigint(64) DEFAULT NULL,
  `PlanAssociationId` bigint(64) DEFAULT NULL,
  `PlanERContributionId` bigint(64) DEFAULT NULL,
  `PlanOrthodontiaId` bigint(64) DEFAULT NULL,
  `PlanRxRiderId` bigint(64) DEFAULT NULL,
  `PlanDependentLifeId` bigint(64) DEFAULT NULL,
  `PlanEliminationPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitMaxId` bigint(64) DEFAULT NULL,
  `PlanPercentageOfSalaryId` bigint(64) DEFAULT NULL,
  `IncludeADandD` tinyint(1) NOT NULL DEFAULT '0',
  `GroupNumber` varchar(50) NOT NULL,
  `StartDate` date DEFAULT NULL,
  `StopDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `RateType` enum('Composite','Age Banded','Base Rates') DEFAULT NULL,
  `IsSmokerPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsGenderPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsTierPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForChild` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForSpouse` tinyint(1) NOT NULL DEFAULT '0',
  `IsContributaryPlan` tinyint(1) NOT NULL DEFAULT '0',
  `TierNameId` bigint(64) DEFAULT NULL,
  `IsCurrentlyAQuote` tinyint(1) NOT NULL DEFAULT '0',
  `BrokerDomainQuoteId` bigint(64) DEFAULT NULL,
  `MaxNumberOfChildren` int(11) NOT NULL DEFAULT '0',
  `MaxChildAge` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerPlanId`),
  KEY `EmployerPlanRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `EmployerPlanRefTierName_fk_idx` (`TierNameId`),
  KEY `EmployerPlanRefDomain_fk_idx` (`DomainId`),
  KEY `EmployerPlanRefPlanNetwork_fk_idx` (`PlanNetworkId`),
  KEY `EmployerPlanRefPlanAssociation_fk_idx` (`PlanAssociationId`),
  KEY `EmployerPlanRefPlanERContribution_fk_idx` (`PlanERContributionId`),
  KEY `EmployerPlanRefPlanOrthodontiaId_fk_idx` (`PlanOrthodontiaId`),
  KEY `EmployerPlanRefPlanRxRider_fk_idx` (`PlanRxRiderId`),
  KEY `EmployerPlanRefPlanDependentLife_fk_idx` (`PlanDependentLifeId`),
  KEY `EmployerPlanRefPlanEliminationPeriod_fk_idx` (`PlanEliminationPeriodId`),
  KEY `EmployerPlanRefPlanBenefitPeriod_fk_idx` (`PlanBenefitPeriodId`),
  KEY `EmployerPlanRefPlanBenefitMax_fk_idx` (`PlanBenefitMaxId`),
  KEY `EmployerPlanRefPlanPercentageOfSalary_fk_idx` (`PlanPercentageOfSalaryId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerPlan`
--

LOCK TABLES `EmployerPlan` WRITE;
/*!40000 ALTER TABLE `EmployerPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EmployerlLifeRule`
--

DROP TABLE IF EXISTS `EmployerlLifeRule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EmployerlLifeRule` (
  `EmployerLifeRuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `OfferSpouseCoverage` tinyint(1) NOT NULL DEFAULT '0',
  `OfferDependentCoverage` tinyint(1) NOT NULL DEFAULT '0',
  `ReducesBy50PercentAtAge65` tinyint(1) NOT NULL DEFAULT '0',
  `ReducesBy50PercentAtAge70` tinyint(1) NOT NULL DEFAULT '0',
  `RoundUpToTheNearest1000` tinyint(1) NOT NULL DEFAULT '0',
  `RoundDownToTheNearest1000` tinyint(1) NOT NULL DEFAULT '0',
  `RoundToTheNearestDollar` tinyint(1) NOT NULL DEFAULT '0',
  `AmountsIncludeAD&D` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ChildrenEligibleToAge` int(11) DEFAULT NULL,
  `MaximumEmployeeCoverageAmount` decimal(10,0) DEFAULT NULL,
  `MaximumSpouseCoveragePercent` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EmployerLifeRuleId`),
  KEY `EmployerOptionalLifeRuleRefEmployerPlan_fk_idx` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EmployerlLifeRule`
--

LOCK TABLES `EmployerlLifeRule` WRITE;
/*!40000 ALTER TABLE `EmployerlLifeRule` DISABLE KEYS */;
/*!40000 ALTER TABLE `EmployerlLifeRule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EnrollmentOtherCoverage`
--

DROP TABLE IF EXISTS `EnrollmentOtherCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EnrollmentOtherCoverage` (
  `EnrollmentOtherCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EnrollmentPlanId` bigint(64) NOT NULL,
  `EnrollmentPersonId` bigint(64) DEFAULT NULL,
  `OtherCoverageType` enum('Group Medical','Medicare','Medicaid/CHIP','Individual Medical','Retiree Coverage','COBRA','Other') DEFAULT NULL,
  `MedicareReason` enum('Age','ESRD','Disability','Other') DEFAULT NULL,
  `MedicareOtherReason` varchar(200) DEFAULT NULL,
  `MedicareClaimNumber` varchar(50) DEFAULT NULL,
  `MedicarePartAEffectiveDate` date DEFAULT NULL,
  `MedicarePartBEffectiveDate` date DEFAULT NULL,
  `InsuranceCompany` varchar(100) DEFAULT NULL,
  `PolicyNumber` varchar(50) DEFAULT NULL,
  `MemberId` varchar(100) DEFAULT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `MedicaidIdNumber` varchar(50) DEFAULT NULL,
  `MedicaidEffectiveDate` date DEFAULT NULL,
  `MedicaidState` varchar(2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EnrollmentOtherCoverageId`),
  KEY `EnrollmentOtherCoverageRefEnrollmentPlan_fk_idx` (`EnrollmentPlanId`),
  KEY `EnrollmentOtherCoverageRefEnrollmentPerson_fk_idx` (`EnrollmentPersonId`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EnrollmentOtherCoverage`
--

LOCK TABLES `EnrollmentOtherCoverage` WRITE;
/*!40000 ALTER TABLE `EnrollmentOtherCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `EnrollmentOtherCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EnrollmentPerson`
--

DROP TABLE IF EXISTS `EnrollmentPerson`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EnrollmentPerson` (
  `EnrollmentPersonId` bigint(64) NOT NULL AUTO_INCREMENT,
  `OwnerUserId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `ClientNumber` varchar(45) DEFAULT NULL,
  `IsSubscriber` tinyint(1) NOT NULL DEFAULT '0',
  `RelationshipToSubscriber` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EnrollmentPersonId`),
  KEY `EnrollmentPersonRefUser_fk_idx` (`OwnerUserId`),
  KEY `EnrollmentPersonRefContactDetail_fk_idx` (`ContactDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EnrollmentPerson`
--

LOCK TABLES `EnrollmentPerson` WRITE;
/*!40000 ALTER TABLE `EnrollmentPerson` DISABLE KEYS */;
/*!40000 ALTER TABLE `EnrollmentPerson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EnrollmentPlan`
--

DROP TABLE IF EXISTS `EnrollmentPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EnrollmentPlan` (
  `EnrollmentPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) DEFAULT NULL,
  `Edi834Id` bigint(64) DEFAULT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `ProducerUserId` bigint(64) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `NPN` varchar(45) DEFAULT NULL,
  `ProducerName` varchar(100) DEFAULT NULL,
  `PolicyNumber` varchar(45) DEFAULT NULL,
  `PlanVariant` varchar(45) DEFAULT NULL,
  `PlanNumber` varchar(45) DEFAULT NULL,
  `DateSubmitted` date DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `PremiumAmount` decimal(10,2) DEFAULT NULL,
  `APTCAmount` decimal(10,2) DEFAULT NULL,
  `TotalAmount` decimal(10,2) DEFAULT NULL,
  `RatingAreaCode` varchar(45) DEFAULT NULL,
  `ApplicationId` varchar(45) DEFAULT NULL,
  `PaymentTransactionId` varchar(45) DEFAULT NULL,
  `ProviderPaymentDate` date DEFAULT NULL,
  `ProviderPolicyNumber` varchar(45) DEFAULT NULL,
  `ProviderStatus` enum('Submitted','Submitted and Paid','Cancelled','Error','Pending','Approved','Active') NOT NULL DEFAULT 'Submitted',
  `Comment` varchar(1000) DEFAULT NULL,
  `SyncStatus` enum('Received','Sync Success','Sync Failed') NOT NULL DEFAULT 'Received',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EnrollmentPlanId`),
  KEY `EnrollmentPlanRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `EnrollmentPlanRefUser_fk_idx` (`UserId`),
  KEY `EnrollmentPlan_PaymentTransactionId` (`PaymentTransactionId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EnrollmentPlan`
--

LOCK TABLES `EnrollmentPlan` WRITE;
/*!40000 ALTER TABLE `EnrollmentPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `EnrollmentPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EnrollmentPlanPerson`
--

DROP TABLE IF EXISTS `EnrollmentPlanPerson`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EnrollmentPlanPerson` (
  `EnrollmentPlanPersonId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EnrollmentPlanId` bigint(64) NOT NULL,
  `EnrollmentPersonId` bigint(64) NOT NULL,
  `ProviderMemberNumber` varchar(45) DEFAULT NULL,
  `ClientNumber` varchar(45) DEFAULT NULL,
  `IsSubscriber` tinyint(1) NOT NULL DEFAULT '0',
  `RelationshipToSubscriber` varchar(45) DEFAULT NULL,
  `DentistCode` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`EnrollmentPlanPersonId`),
  KEY `EnrollPlanPersonRefEnrollmentPlanId_fk_idx` (`EnrollmentPlanId`),
  KEY `EnrollmentPlanPersonRefEnrollmentPerson_fk_idx` (`EnrollmentPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EnrollmentPlanPerson`
--

LOCK TABLES `EnrollmentPlanPerson` WRITE;
/*!40000 ALTER TABLE `EnrollmentPlanPerson` DISABLE KEYS */;
/*!40000 ALTER TABLE `EnrollmentPlanPerson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `EnrollmentQuestionnaireResponse`
--

DROP TABLE IF EXISTS `EnrollmentQuestionnaireResponse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `EnrollmentQuestionnaireResponse` (
  `EnrollmentQuestionnaireResponseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteQuestionnaireId` bigint(64) NOT NULL,
  `EnrollmentPersonId` bigint(64) DEFAULT NULL,
  `BooleanResponse` varchar(45) DEFAULT NULL,
  `InputResponse` varchar(2000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`EnrollmentQuestionnaireResponseId`),
  KEY `EnrollmentQuestionaireResponseRefPublicQuoteQuestionaire_fk_idx` (`PublicQuoteQuestionnaireId`),
  KEY `EnrollmentQuestionnaireResponseRefEnrollmentPerson_fk_idx` (`EnrollmentPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `EnrollmentQuestionnaireResponse`
--

LOCK TABLES `EnrollmentQuestionnaireResponse` WRITE;
/*!40000 ALTER TABLE `EnrollmentQuestionnaireResponse` DISABLE KEYS */;
/*!40000 ALTER TABLE `EnrollmentQuestionnaireResponse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMAPTCAttestation`
--

DROP TABLE IF EXISTS `FFMAPTCAttestation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMAPTCAttestation` (
  `FFMAPTCAttestationId` bigint(64) NOT NULL,
  `FFMEnrollmentDisenrollChangeId` bigint(64) NOT NULL,
  `FFMTaxFilerInformationId` bigint(64) DEFAULT NULL,
  `FFEAssignedPolicyNumber` varchar(50) DEFAULT NULL,
  `IssuerPolicyNumber` varchar(50) DEFAULT NULL,
  `APTCAttestation` char(1) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMAPTCAttestationId`),
  KEY `FFMAPTCAttestationRefFFMTaxFilerInformation_fk_idx` (`FFMTaxFilerInformationId`),
  KEY `FFMAPTCAttestationRefFFMEnrollDisenrollChange_fk_idx` (`FFMEnrollmentDisenrollChangeId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMAPTCAttestation`
--

LOCK TABLES `FFMAPTCAttestation` WRITE;
/*!40000 ALTER TABLE `FFMAPTCAttestation` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMAPTCAttestation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMActiveErrorQueue`
--

DROP TABLE IF EXISTS `FFMActiveErrorQueue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMActiveErrorQueue` (
  `FFMActiveErrorQueueId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `FFMEnrollmentGroupId` bigint(64) DEFAULT NULL,
  `FFMApplicantId` bigint(64) DEFAULT NULL,
  `QueueTimestamp` timestamp NULL DEFAULT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `Status` enum('New','Working','Fixed') NOT NULL,
  `FFMTypeError` enum('System Down','TransferUserBack','TransactionResponseCode','ActionResponseCode') NOT NULL,
  `UserRequest` enum('Email When FFM Back Up') DEFAULT NULL,
  `TransferUserBackExceptionReason` varchar(100) DEFAULT NULL,
  `TransactionResponseCode` char(100) DEFAULT NULL,
  `ActionResponseCode` char(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMActiveErrorQueueId`),
  KEY `FFMActiveErrorQueueRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMActiveErrorQueueRefFFMEnrollmentGroup_fk_idx` (`FFMEnrollmentGroupId`),
  KEY `FFMActiveErrorQueueRefFFMApplicant_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMActiveErrorQueue`
--

LOCK TABLES `FFMActiveErrorQueue` WRITE;
/*!40000 ALTER TABLE `FFMActiveErrorQueue` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMActiveErrorQueue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMActivityErrorLog`
--

DROP TABLE IF EXISTS `FFMActivityErrorLog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMActivityErrorLog` (
  `FFMActivityErrorLogId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) DEFAULT NULL,
  `UserId` bigint(64) NOT NULL,
  `PublicQuoteId` bigint(64) DEFAULT NULL,
  `ErrorType` enum('SAML','FetchEligibility','Enrollment') NOT NULL,
  `UserType` enum('Consumer','Partner Call Center Rep','Agent','Broker') NOT NULL,
  `PartnerAssignedConsumerId` varchar(32) NOT NULL,
  `FFEAssignedConsumerId` varchar(32) DEFAULT NULL,
  `ErrorMessage` varchar(1000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMActivityErrorLogId`),
  KEY `FFMActivityErrorLogRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMActivityErrorLogRefUser_fk_idx` (`UserId`),
  KEY `FFMActivityErrorLogRefPublicQuote_idx` (`PublicQuoteId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMActivityErrorLog`
--

LOCK TABLES `FFMActivityErrorLog` WRITE;
/*!40000 ALTER TABLE `FFMActivityErrorLog` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMActivityErrorLog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMApplicant`
--

DROP TABLE IF EXISTS `FFMApplicant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMApplicant` (
  `FFMApplicantId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `FFMEnrollmentGroupId` bigint(64) NOT NULL,
  `IsSubscriber` char(1) NOT NULL,
  `ContactDetailId` bigint(64) DEFAULT NULL,
  `IssuerAssignedMemberId` varchar(50) DEFAULT NULL,
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `MaritalStatus` varchar(45) DEFAULT NULL,
  `StudentStatus` char(1) NOT NULL,
  `EligibilityChangeEffectiveDate` date NOT NULL,
  `MedicaidEligibilityIndicator` char(1) NOT NULL,
  `MedicaidEligibilityStartDate` date DEFAULT NULL,
  `MedicaidEligibilityEndDate` date DEFAULT NULL,
  `CHIPEligibilityIndicator` char(1) NOT NULL,
  `CHIPEligibilityStartDate` date DEFAULT NULL,
  `CHIPEligibilityEndDate` date DEFAULT NULL,
  `QHPEligibilityIndicator` char(1) NOT NULL,
  `QHPEligibilityStartDate` date DEFAULT NULL,
  `QHPEligibilityEndDate` date DEFAULT NULL,
  `APTCEligibilityIndicator` char(1) NOT NULL,
  `APTCEligibilityStartDate` date DEFAULT NULL,
  `APTCEligibilityEndDate` date DEFAULT NULL,
  `MonthlyAPTCAmount` decimal(10,2) DEFAULT NULL,
  `CSREligibilityIndicator` char(1) NOT NULL,
  `CSREligibilityStartDate` date DEFAULT NULL,
  `CSREligibilityEndDate` date DEFAULT NULL,
  `CSRLevel` char(2) DEFAULT NULL,
  `QHPEligibilityStatusChange` varchar(18) DEFAULT NULL,
  `APTCEligibilityStatusChange` varchar(18) DEFAULT NULL,
  `CSREligibilityStatusChange` varchar(18) DEFAULT NULL,
  `IEPandAEPEligibilityIndicator` char(1) NOT NULL,
  `IEPandAEPType` char(1) DEFAULT NULL,
  `IEPandAEPStartDate` date DEFAULT NULL,
  `IEPandAEPEndDate` date DEFAULT NULL,
  `IEPandAEPEarliestQPHEffectiveDate` date DEFAULT NULL,
  `SEPEligibilityIndicator` char(1) NOT NULL,
  `SETEligibilityReason` char(2) DEFAULT NULL,
  `SEPStartDate` date DEFAULT NULL,
  `SEPEndDate` date DEFAULT NULL,
  `SEPEarliestQHPEffectiveDate` date DEFAULT NULL,
  `SEPLatestQHPEffectiveDate` date DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMApplicantId`),
  KEY `FFMApplicantRefContactDetail_fk_idx` (`ContactDetailId`),
  KEY `FFMApplicantRefFFMEnrollmentGroup_fk_idx` (`FFMEnrollmentGroupId`),
  KEY `FFMApplicantRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMApplicantFFMAssignedMemberId_idx` (`FFEAssignedMemberId`),
  KEY `FFMApplicantFFEAssignedApplicantId_uq` (`FFEAssignedApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMApplicant`
--

LOCK TABLES `FFMApplicant` WRITE;
/*!40000 ALTER TABLE `FFMApplicant` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMApplicant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMApplicantDetail`
--

DROP TABLE IF EXISTS `FFMApplicantDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMApplicantDetail` (
  `FFMApplicantDetailId` bigint(64) NOT NULL,
  `FFMApplicantId` bigint(64) NOT NULL,
  `FFMEnrollmentDetailId` bigint(64) NOT NULL,
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `StartDate` date NOT NULL,
  `EndDate` date DEFAULT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `SubscriberIndicator` char(1) NOT NULL,
  `TobaccoUseIndicator` char(1) NOT NULL,
  `LastDateOfTobaccoUse` date DEFAULT NULL,
  `EnrollmentPeriodType` char(1) NOT NULL,
  `SpecialEnrollmentReasonCode` char(2) DEFAULT NULL,
  `CancelationTerminationReasonCode` char(2) DEFAULT NULL,
  `AutoDisenrollmentPendingIndicator` char(1) DEFAULT NULL,
  `AutoDisenrollmentReason` varchar(50) DEFAULT NULL,
  `AutoDisenrollmentEffectiveDate` date DEFAULT NULL,
  `AutoDisenrollmentScheduledDate` date DEFAULT NULL,
  `AutoDisenrollmentCancelledIndicator` char(1) DEFAULT NULL,
  `AutoDisenrollmentCancelledDate` date DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMApplicantDetailId`),
  KEY `FFMAppplicantDetailRefFFMEnrollmentDetail_fk_idx` (`FFMEnrollmentDetailId`),
  KEY `FFMApplicantDetailFFEAssignedApplicantId_uq` (`FFEAssignedApplicantId`),
  KEY `FFMApplicantDetailRefFFMApplicant_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMApplicantDetail`
--

LOCK TABLES `FFMApplicantDetail` WRITE;
/*!40000 ALTER TABLE `FFMApplicantDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMApplicantDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMApplicantFFMResponse`
--

DROP TABLE IF EXISTS `FFMApplicantFFMResponse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMApplicantFFMResponse` (
  `FFMApplicantFFMResponseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMApplicantId` bigint(64) NOT NULL,
  `LastResponseTimestamp` timestamp NULL DEFAULT NULL,
  `MaintTypeCode` char(3) DEFAULT NULL,
  `MaintReasonCode` char(2) DEFAULT NULL,
  `ActionEffectiveDate` date DEFAULT NULL,
  `ActionResponseCode` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMApplicantFFMResponseId`),
  KEY `FFMApplicantFFMResponseRefFFMApplicant_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMApplicantFFMResponse`
--

LOCK TABLES `FFMApplicantFFMResponse` WRITE;
/*!40000 ALTER TABLE `FFMApplicantFFMResponse` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMApplicantFFMResponse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMAutoDisenrollmentActivity`
--

DROP TABLE IF EXISTS `FFMAutoDisenrollmentActivity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMAutoDisenrollmentActivity` (
  `FFMAutoDisenrollmentActivityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsuranceMemberId` bigint(64) NOT NULL,
  `ActivityDate` date DEFAULT NULL,
  `AutoDisenrollmentReasonCode` enum('MedicaidOrCHIPEligibilityRevokedAPTCEligibility','OtherEligibilityRevokedAPTCOrCSREligibility') DEFAULT NULL,
  `AutoDisenrollmentPendingIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `AutoDisenrollmentScheduledDate` date DEFAULT NULL,
  `AutoEnrollmentCancellationIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `AutoEnrollmentCancellationDate` date DEFAULT NULL,
  `AutoDisenrollmentEffectiveDate` date DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMAutoDisenrollmentActivityId`),
  KEY `fk_FFMAutoDisenrollmentActivity_FFMInsuranceMember1_idx` (`FFMInsuranceMemberId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMAutoDisenrollmentActivity`
--

LOCK TABLES `FFMAutoDisenrollmentActivity` WRITE;
/*!40000 ALTER TABLE `FFMAutoDisenrollmentActivity` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMAutoDisenrollmentActivity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMContactInformation`
--

DROP TABLE IF EXISTS `FFMContactInformation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMContactInformation` (
  `FFMContactInformationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `ContactType` enum('ContactMailingAddress','ContactTelephoneNumber','ContactEmailID') DEFAULT NULL,
  `ContactEmailID` varchar(100) DEFAULT NULL,
  `TelephoneType` enum('Main','Mobile') DEFAULT NULL,
  `TelephoneNumberFullID` varchar(20) DEFAULT NULL,
  `TelephoneSuffixID` varchar(6) DEFAULT NULL,
  `LocationStreet` varchar(75) DEFAULT NULL,
  `AddressSecondaryUnitText` varchar(75) DEFAULT NULL,
  `CityName` varchar(100) DEFAULT NULL,
  `CountyName` varchar(256) DEFAULT NULL,
  `CountyCode` varchar(5) DEFAULT NULL,
  `StateUSPostalServiceCode` varchar(2) DEFAULT NULL,
  `PostalCode` varchar(9) DEFAULT NULL,
  `CreatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMContactInformationId`),
  KEY `fk_FFMContactInformation_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMContactInformation`
--

LOCK TABLES `FFMContactInformation` WRITE;
/*!40000 ALTER TABLE `FFMContactInformation` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMContactInformation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMDetail`
--

DROP TABLE IF EXISTS `FFMDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMDetail` (
  `FFMDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) DEFAULT NULL,
  `FFMPersonId` bigint(64) DEFAULT NULL,
  `Status` enum('Enrolled','Disenrolled','Error') DEFAULT NULL,
  `UserType` enum('Consumer','Partner Call Center Rep','Agent','Broker') NOT NULL,
  `StateExchangeCode` varchar(3) DEFAULT NULL,
  `ExchangeSystemId` varchar(32) DEFAULT NULL,
  `ExchangeSystemSourceText` varchar(45) DEFAULT NULL,
  `PartnerAssignedConsumerId` varchar(32) NOT NULL,
  `FFEAssignedConsumerId` varchar(32) DEFAULT NULL,
  `TransferType` varchar(100) DEFAULT NULL,
  `LastTransferType` varchar(100) DEFAULT NULL,
  `HadException` tinyint(1) DEFAULT '0',
  `LastExceptionReason` enum('Consumer failed Identity Proofing','Application in Pend Status','Application not completed','System Unavailable. Retry later.','Data Sources Unavailable. Retry later.') DEFAULT NULL,
  `ContactElectronicNoticeIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `ContactElectronicNoticePreferenceCode` enum('TextMessage','Email') DEFAULT NULL,
  `ContactMethodType` varchar(18) DEFAULT NULL,
  `ContactPaperNoticesIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `NotificationCellPhone` varchar(45) DEFAULT NULL,
  `NotificationEmailAddress` varchar(63) DEFAULT NULL,
  `APTCAttestationProvidedIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `SpokenLanguage` varchar(18) DEFAULT NULL,
  `WrittenLanguage` varchar(18) DEFAULT NULL,
  `RequestingFinancialAssistance` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMDetailId`),
  UNIQUE KEY `FFMDetailFFMAssignedConsumerId_uq` (`FFEAssignedConsumerId`),
  KEY `FFMDetailRefUser_idx` (`UserId`),
  KEY `FFMDetailRefContactDetail_fk_idx` (`ContactDetailId`),
  KEY `fk_FFMDetail_FFMPerson1_idx` (`FFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMDetail`
--

LOCK TABLES `FFMDetail` WRITE;
/*!40000 ALTER TABLE `FFMDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENActivity`
--

DROP TABLE IF EXISTS `FFMENActivity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENActivity` (
  `FFMENActivityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `ActivityType` enum('PolicyCreationActivity','MembersMaintenanceActivity','PolicyPremiumChangeActivity','PolicyCancellationActivity','PolicyTerminationActivity','MembersAdditionActivity') NOT NULL,
  `ActionEffectiveDate` date DEFAULT NULL,
  `AIPInsurancePremiumAmount` decimal(10,2) DEFAULT NULL,
  `AIPInsurancePremiumElectedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `AIPInsurancePremiumAppliedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `AIPRateAreaId` varchar(45) DEFAULT NULL,
  `AIPRateAreaSourceText` varchar(100) DEFAULT NULL,
  `AIPInsurancePlanVariantCategoryNumericCode` enum('00','01','02','03','04','05','06') NOT NULL,
  `AIPInsurancePremiumIndividualResponsibilityTotalAmount` decimal(10,2) DEFAULT NULL,
  `EGInsurancePlanStandardComponentId` varchar(45) DEFAULT NULL,
  `EGInsurancePlanStandardComponentSourceText` varchar(100) DEFAULT NULL,
  `EGInsurancePlanVariantId` varchar(45) DEFAULT NULL,
  `EGInsurancePlanVariantSourceText` varchar(100) DEFAULT NULL,
  `EGIssuerId` varchar(45) DEFAULT NULL,
  `EGIssuerSourceText` varchar(100) DEFAULT NULL,
  `EGInsurancePolicyEffectiveDate` date DEFAULT NULL,
  `EGInsurancePolicyExpirationDate` date DEFAULT NULL,
  `FFMENMaintainedInsurancePolicyId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENActivityId`),
  KEY `fk_FFMENActivity_FFMENMaintainedInsurancePolicy1_idx` (`FFMENMaintainedInsurancePolicyId`),
  KEY `fk_FFMENActivity_FFMDetail2_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENActivity`
--

LOCK TABLES `FFMENActivity` WRITE;
/*!40000 ALTER TABLE `FFMENActivity` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENActivity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENCorrectedInsurancePremium`
--

DROP TABLE IF EXISTS `FFMENCorrectedInsurancePremium`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENCorrectedInsurancePremium` (
  `FFMENCorrectedInsurancePremiumId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENPolicyActivityMetadataId` bigint(64) NOT NULL,
  `InsurancePremiumAmount` decimal(10,2) DEFAULT NULL,
  `InsurancePremiumElectedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `InsurancePremiumAppliedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `RateAreaId` varchar(45) DEFAULT NULL,
  `RateAreaSourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanVariantCategoryNumericCode` varchar(45) DEFAULT NULL,
  `InsurancePremiumIndividualResponsibilityTotalAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENCorrectedInsurancePremiumId`),
  KEY `fk_FFMENCorrectedInsurancePremium_FFMENPolicyActivityMetada_idx` (`FFMENPolicyActivityMetadataId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENCorrectedInsurancePremium`
--

LOCK TABLES `FFMENCorrectedInsurancePremium` WRITE;
/*!40000 ALTER TABLE `FFMENCorrectedInsurancePremium` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENCorrectedInsurancePremium` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENCreatedInsurancePolicy`
--

DROP TABLE IF EXISTS `FFMENCreatedInsurancePolicy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENCreatedInsurancePolicy` (
  `FFMENCreatedInsurancePolicyId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENPolicyActivityMetadataId` bigint(64) NOT NULL,
  `InsurancePolicyEffectiveDate` date DEFAULT NULL,
  `InsurancePolicyExpirationDate` date DEFAULT NULL,
  `IssuerAssignedInsurancePolicyId` varchar(45) DEFAULT NULL,
  `IssuerAssignedInsurancePolicySourceText` varchar(100) DEFAULT NULL,
  `FFEAssignedInsurancePolicyId` varchar(45) DEFAULT NULL,
  `FFEAssignedInsurancePolicySourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanStandardComponentId` varchar(45) DEFAULT NULL,
  `InsurancePlanStandardComponentSourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanVariantId` varchar(45) DEFAULT NULL,
  `InsurancePlanVariantSourceText` varchar(100) DEFAULT NULL,
  `IssuerId` varchar(45) DEFAULT NULL,
  `IssuerSourceText` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENCreatedInsurancePolicyId`),
  KEY `fk_FFMENCreatedInsurancePolicyActivityMetadata_FFMENPolicyA_idx` (`FFMENPolicyActivityMetadataId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENCreatedInsurancePolicy`
--

LOCK TABLES `FFMENCreatedInsurancePolicy` WRITE;
/*!40000 ALTER TABLE `FFMENCreatedInsurancePolicy` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENCreatedInsurancePolicy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENInsuranceApplicant`
--

DROP TABLE IF EXISTS `FFMENInsuranceApplicant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENInsuranceApplicant` (
  `FFMENInsuranceApplicantId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENActivityId` bigint(64) NOT NULL,
  `FFMPersonId` bigint(64) NOT NULL,
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `FFEAssignedApplicantSourceText` varchar(100) DEFAULT NULL,
  `TobaccoUseIndicator` tinyint(1) DEFAULT NULL,
  `TobaccoLastUsageDate` date NOT NULL,
  `ProposedSubscriberIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `EnrollmentPeriodCode` enum('Initial','Annual','Special') DEFAULT NULL,
  `RelationshipToSubscriberCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `SpecialEnrollmentReasonCode` enum('TerminationOfBenefits','Marriage','Birth','Adoption','NewlyEligible','ExchangeError','Dissatisfaction','FInancialChange','ChangeOfLocation','ExceptionalCircumstance') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENInsuranceApplicantId`),
  KEY `fk_FFMENInsuranceApplicant_FFMENActivity1_idx` (`FFMENActivityId`),
  KEY `fk_FFMENInsuranceApplicant_FFMPerson1_idx1` (`FFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENInsuranceApplicant`
--

LOCK TABLES `FFMENInsuranceApplicant` WRITE;
/*!40000 ALTER TABLE `FFMENInsuranceApplicant` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENInsuranceApplicant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENInsuranceMember`
--

DROP TABLE IF EXISTS `FFMENInsuranceMember`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENInsuranceMember` (
  `FFMENInsuranceMemberId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENMaintainedInsurancePolicyId` bigint(64) NOT NULL,
  `FFMPersonId` bigint(64) NOT NULL,
  `OriginatingInsuranceApplicantId` bigint(64) NOT NULL,
  `IssuerAssignedMemberId` varchar(50) DEFAULT NULL,
  `IssuerAssignedMemberSourceText` varchar(100) DEFAULT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `FFEAssignedMemberSourceText` varchar(100) DEFAULT NULL,
  `TobaccoUseIndicator` tinyint(1) NOT NULL,
  `TobaccoLastUsageDate` date DEFAULT NULL,
  `RelationshipToSubscriberCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENInsuranceMemberId`),
  KEY `fk_FFMENInsuranceMember_FFMENMaintainedInsurancePolicy1_idx` (`FFMENMaintainedInsurancePolicyId`),
  KEY `fk_FFMENInsuranceMember_FFMPerson1_idx1` (`FFMPersonId`),
  KEY `fk_FFMENInsuranceMember_FFMInsuranceApplicant_fk_idx` (`OriginatingInsuranceApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENInsuranceMember`
--

LOCK TABLES `FFMENInsuranceMember` WRITE;
/*!40000 ALTER TABLE `FFMENInsuranceMember` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENInsuranceMember` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENInsuranceMemberActivity`
--

DROP TABLE IF EXISTS `FFMENInsuranceMemberActivity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENInsuranceMemberActivity` (
  `FFMENInsuranceMemberActivityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENActivityId` bigint(64) NOT NULL,
  `ActionEffectiveDate` date DEFAULT NULL,
  `InsuranceMemberMaintenanceCode` enum('Change','CancellationOrTermination','Reinstatement','ChangePendingAutoDisenrollmentDueToLossOfAPTCorCSR') DEFAULT NULL,
  `InsuranceMemberMaintenanceReasonCode` enum('Divorce','Birth','Death','Adoption','Strike','COBRA','COBRAPremiumPaid','VoluntaryWithdrawal','PlanChange','IdentifyingDataElementsChange','InitialEnrollment','BenefitSelection','Re-Enrollment','LocationChange','NonPayment','NoReasonGiven','MemberBenefotSelection') DEFAULT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `FFEAssignedMemberSourceText` varchar(100) DEFAULT NULL,
  `IssuerAssignedMemberId` varchar(50) DEFAULT NULL,
  `IssuerAssignedMemberSourceText` varchar(100) DEFAULT NULL,
  `FFMPersonId` bigint(64) DEFAULT NULL,
  `OriginatingInsuranceApplicantFFMPersonId` bigint(64) DEFAULT NULL,
  `TobaccoUseIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `TobaccoLastUsageDate` date DEFAULT NULL,
  `RelationshipToSubscriberCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENInsuranceMemberActivityId`),
  KEY `fk_FFMENInsuranceMemberActivity_FFMENActivity1_idx` (`FFMENActivityId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENInsuranceMemberActivity`
--

LOCK TABLES `FFMENInsuranceMemberActivity` WRITE;
/*!40000 ALTER TABLE `FFMENInsuranceMemberActivity` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENInsuranceMemberActivity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENInsuranceMemberActivityMetadata`
--

DROP TABLE IF EXISTS `FFMENInsuranceMemberActivityMetadata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENInsuranceMemberActivityMetadata` (
  `FFMENInsuranceMemberActivityMetadataId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `InsurancePlanNumber` varchar(45) DEFAULT NULL,
  `InsuranceMemberActivityResponseCode` enum('NoError','MemberNotOnApplication','NoAvailableEnrollmentPeriod','InvalidEnrollmentPeriod','InvalidEffectiveDateForEnrollmentPeriod','InvalidRelationship','InvalidMaintenanceReasonCode','InvalidTobaccoUseIndicator') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENInsuranceMemberActivityMetadataId`),
  KEY `fk_FFMENInsuranceMemberActivityMetadata_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENInsuranceMemberActivityMetadata`
--

LOCK TABLES `FFMENInsuranceMemberActivityMetadata` WRITE;
/*!40000 ALTER TABLE `FFMENInsuranceMemberActivityMetadata` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENInsuranceMemberActivityMetadata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENInsuranceMemberCI`
--

DROP TABLE IF EXISTS `FFMENInsuranceMemberCI`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENInsuranceMemberCI` (
  `FFMENInsuranceMemberCIId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMENCreatedInsurancePolicyId` bigint(64) NOT NULL,
  `FFMPersonId` bigint(64) NOT NULL,
  `OriginatingInsuranceApplicantId` bigint(64) DEFAULT NULL,
  `IssuerAssignedPolicyId` varchar(50) DEFAULT NULL,
  `IssuerAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `FFEAssignedPolicyId` varchar(50) DEFAULT NULL,
  `FFEAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `TobaccoUseIndicator` tinyint(1) NOT NULL,
  `TobaccoLastUsageDate` date DEFAULT NULL,
  `RelationshipToSubscriberCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENInsuranceMemberCIId`),
  KEY `fk_FFMENInsuranceMemberCI_FFMENCreatedInsurancePolicy1_idx` (`FFMENCreatedInsurancePolicyId`),
  KEY `fk_FFMENInsuranceMemberCI_FFMPerson1_idx` (`FFMPersonId`),
  KEY `fk_FFMENInsuranceMemberCI_FFMInsuranceApplicant1_idx` (`OriginatingInsuranceApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENInsuranceMemberCI`
--

LOCK TABLES `FFMENInsuranceMemberCI` WRITE;
/*!40000 ALTER TABLE `FFMENInsuranceMemberCI` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENInsuranceMemberCI` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENMaintainedInsurancePolicy`
--

DROP TABLE IF EXISTS `FFMENMaintainedInsurancePolicy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENMaintainedInsurancePolicy` (
  `FFMENMaintainedInsurancePolicyId` bigint(64) NOT NULL,
  `FFMDetailId` bigint(64) NOT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `ExpirationDate` date DEFAULT NULL,
  `IssuerAssignedPolicyId` varchar(50) DEFAULT NULL,
  `IssuerAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `FFEAssignedPolicyId` varchar(50) DEFAULT NULL,
  `FFEAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanStandardComponentId` varchar(45) DEFAULT NULL,
  `InsurancePlanStandardComponentSourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanVariantId` varchar(45) DEFAULT NULL,
  `InsurancePlanVariantSourceText` varchar(100) DEFAULT NULL,
  `IssuerId` varchar(45) DEFAULT NULL,
  `IssuerSourceText` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENMaintainedInsurancePolicyId`),
  KEY `fk_FFMENMaintainedInsurancePolicy_FFMDetail1_idx1` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENMaintainedInsurancePolicy`
--

LOCK TABLES `FFMENMaintainedInsurancePolicy` WRITE;
/*!40000 ALTER TABLE `FFMENMaintainedInsurancePolicy` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENMaintainedInsurancePolicy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENPolicyActivityMetadata`
--

DROP TABLE IF EXISTS `FFMENPolicyActivityMetadata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENPolicyActivityMetadata` (
  `FFMENPolicyActivityMetadataId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `PolicyActivityResponseCode` enum('Accepted','UserNotAuthorized','SubscriberNotSpecified','InvalidIssuerID','InvalidPlanID','InvalidIssuerAndPlanCombination','InvalidMemberInformation','IncorrectPremiumAmount','IncorrectAPTCAmount','ElectedAPTCExceedsEHBPortionOfQHPPremium','InvalidCSRLevelForHousehold','InvalildCSRLevel','IncorrectCSRLevel','InvalidPolicyId','InvalidCancellationDate','InvalidTerminationDate','MissingPolicyEndDate','NotAuthorizedToSubmitTransactionForIssuerId','InvalidPlanVariant','DependentTypeNotAllowed','PlanNotInZipCode','UnspecifiedError','InvalidRatingArea','IncorrectIndividualResponsibilityAmount') DEFAULT NULL,
  `PaymentTransactionID` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENPolicyActivityMetadataId`),
  KEY `fk_FFMENPolicyActivityMetadata_FFMDetail1_idx` (`FFMDetailId`),
  KEY `FFMENPolicyActivityMetadata_PaymentTransactionId_idx` (`PaymentTransactionID`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENPolicyActivityMetadata`
--

LOCK TABLES `FFMENPolicyActivityMetadata` WRITE;
/*!40000 ALTER TABLE `FFMENPolicyActivityMetadata` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENPolicyActivityMetadata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMENReferencedInsuranceApplicant`
--

DROP TABLE IF EXISTS `FFMENReferencedInsuranceApplicant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMENReferencedInsuranceApplicant` (
  `FFMENReferencedInsuranceApplicantId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `InsurancePlanNumber` varchar(45) DEFAULT NULL,
  `FFMPersonId` bigint(64) NOT NULL,
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `FFEAssignedApplicantSourceText` varchar(100) DEFAULT NULL,
  `TobaccoUseIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `TobaccoLastUsageDate` date NOT NULL,
  `ProposedSubscriberIndicator` tinyint(1) NOT NULL,
  `EnrollmentPeriodCode` enum('Initial','Annual','Special') DEFAULT NULL,
  `RelationshipToSubscriberCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `SpecialEnrollmentReasonCode` enum('TerminationOfBenefits','Marriage','Birth','Adoption','NewlyEligible','ExchangeError','Dissatisfaction','FInancialChange','ChangeOfLocation','ExceptionalCircumstance') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMENReferencedInsuranceApplicantId`),
  UNIQUE KEY `FFMApplicantFFEAssignedApplicantId_uq` (`FFEAssignedApplicantId`),
  KEY `fk_FFMENReferencedInsuranceApplicant_FFMPerson1_idx` (`FFMPersonId`),
  KEY `fk_FFMENReferencedInsuranceApplicant_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMENReferencedInsuranceApplicant`
--

LOCK TABLES `FFMENReferencedInsuranceApplicant` WRITE;
/*!40000 ALTER TABLE `FFMENReferencedInsuranceApplicant` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMENReferencedInsuranceApplicant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEligibilityDetail`
--

DROP TABLE IF EXISTS `FFMEligibilityDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEligibilityDetail` (
  `FFMEligibilityDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsuranceApplicantId` bigint(64) NOT NULL,
  `ActivityDate` date DEFAULT NULL,
  `EligibilityType` enum('Exchange','CSR','CHIP','APTC','Medicaid') NOT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `EligibilityIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `EligibilityStatusCode` enum('New','NoChange','Change','Gain','Loss') NOT NULL DEFAULT 'New',
  `PlanVariantCategoyNumericCode` enum('00','01','02','03','04','05','06') NOT NULL DEFAULT '00',
  `MonthlyAPTCAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEligibilityDetailId`),
  KEY `FFMEligibilityDetailRefFFMInsuranceApplicant_fk_idx` (`FFMInsuranceApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEligibilityDetail`
--

LOCK TABLES `FFMEligibilityDetail` WRITE;
/*!40000 ALTER TABLE `FFMEligibilityDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEligibilityDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollDisenrollChange`
--

DROP TABLE IF EXISTS `FFMEnrollDisenrollChange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollDisenrollChange` (
  `FFMEnrollDisenrollChangeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserTransactionLogId` bigint(64) DEFAULT NULL,
  `FFMDetailId` bigint(64) NOT NULL,
  `ProducerId` bigint(64) DEFAULT NULL,
  `DateSubmitted` date NOT NULL,
  `FirstName` varchar(50) DEFAULT NULL,
  `MiddleName` varchar(50) DEFAULT NULL,
  `LastName` varchar(50) DEFAULT NULL,
  `AgentOrBrokerIndicator` varchar(18) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollDisenrollChangeId`),
  KEY `FFMEnrollDisenrollChangeRefProducer_fk_idx` (`ProducerId`),
  KEY `FFMEnrollDisenrollChangeRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMEnrollmentDisenrollChangeRefUserTransactionLog_fk_idx` (`UserTransactionLogId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollDisenrollChange`
--

LOCK TABLES `FFMEnrollDisenrollChange` WRITE;
/*!40000 ALTER TABLE `FFMEnrollDisenrollChange` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollDisenrollChange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollmentDetail`
--

DROP TABLE IF EXISTS `FFMEnrollmentDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollmentDetail` (
  `FFMEnrollmentDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMEnrollmentGroupId` bigint(64) NOT NULL,
  `FFEAssignedPolicyNumber` varchar(50) NOT NULL,
  `IssuerPolicyNumber` varchar(50) DEFAULT NULL,
  `StartDate` date NOT NULL,
  `EndDate` date DEFAULT NULL,
  `EnrollmentStatus` varchar(50) NOT NULL,
  `IssuerId` varchar(50) DEFAULT NULL,
  `AssignedQHPId` varchar(10) DEFAULT NULL,
  `AssignedQHPVariation` varchar(6) DEFAULT NULL,
  `PremiumStartDate` date DEFAULT NULL,
  `PremiumEndDate` date DEFAULT NULL,
  `TotalPremiumAmount` decimal(10,2) DEFAULT NULL,
  `MaximumEnrollmentGroupEligibleAPTC` decimal(10,2) DEFAULT NULL,
  `APTCElectedAmount` decimal(10,2) DEFAULT NULL,
  `APTCAppliedAmount` decimal(10,2) DEFAULT NULL,
  `TotalIndividualResponsibilityAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollmentDetailId`),
  KEY `FFMEnrollmentDetailRefFFMEnrollmentGroup_fk_idx` (`FFMEnrollmentGroupId`),
  KEY `FFMEnrollmentDetailAssignedQHPId_idx` (`AssignedQHPId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollmentDetail`
--

LOCK TABLES `FFMEnrollmentDetail` WRITE;
/*!40000 ALTER TABLE `FFMEnrollmentDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollmentDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollmentGroup`
--

DROP TABLE IF EXISTS `FFMEnrollmentGroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollmentGroup` (
  `FFMEnrollmentGroupId` bigint(64) NOT NULL AUTO_INCREMENT,
  `IndividualPlanId` bigint(64) DEFAULT NULL,
  `PaymentId` bigint(64) DEFAULT NULL,
  `FFMDetailId` bigint(64) NOT NULL,
  `IssuerPolicyNumber` varchar(50) NOT NULL,
  `FFEAssignedPolicyNumber` varchar(50) DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `IssuerId` varchar(5) DEFAULT NULL,
  `PlanId` varchar(16) DEFAULT NULL,
  `LatestTransactionType` char(1) DEFAULT NULL,
  `LatestTransactionResponseCode` char(5) DEFAULT NULL,
  `PaymentTransactionId` char(20) DEFAULT NULL,
  `RatingArea` char(5) DEFAULT NULL,
  `TotalPremiumAmount` decimal(10,2) DEFAULT NULL,
  `APTCAppliedAmount` decimal(10,2) DEFAULT NULL,
  `TotalIndividualResponsibilityAmount` decimal(10,2) DEFAULT NULL,
  `ApplicableCSRLevel` char(2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollmentGroupId`),
  KEY `FFMEnrollmentGroupRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMEnrollmentGroupRefIndividualPlan_fk_idx` (`IndividualPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollmentGroup`
--

LOCK TABLES `FFMEnrollmentGroup` WRITE;
/*!40000 ALTER TABLE `FFMEnrollmentGroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollmentGroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollmentGroupApplicant`
--

DROP TABLE IF EXISTS `FFMEnrollmentGroupApplicant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollmentGroupApplicant` (
  `FFMEnrollmentGroupApplicant` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMEnrollmentGroupDetailId` bigint(64) NOT NULL,
  `FFMApplicantId` bigint(64) NOT NULL,
  `TransactionType` char(1) NOT NULL,
  `FFEAssignedPolicyNumber` varchar(50) DEFAULT NULL,
  `IssuerId` varchar(5) DEFAULT NULL,
  `AssignedPlanId` varchar(16) DEFAULT NULL,
  `StartDate` varchar(45) DEFAULT NULL,
  `StopDate` varchar(45) DEFAULT NULL,
  `EnrollmentPeriodType` char(1) DEFAULT NULL,
  `TypeCode` char(3) NOT NULL,
  `ReasonCode` char(2) NOT NULL,
  `ActionEffectiveDate` date NOT NULL,
  `RatingArea` char(5) NOT NULL,
  `TotalPremiumAmount` decimal(10,2) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `APTCElectedAmount` decimal(10,2) DEFAULT NULL,
  `APTCAppliedAmount` decimal(10,2) DEFAULT NULL,
  `TotalIndividualResponsibilityAmount` decimal(10,2) NOT NULL,
  `CSRLevelApplicable` char(2) DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollmentGroupApplicant`),
  KEY `FFMEnrollmentGroupApplicantRefFFMEnrollmentGroupDetailId_fk_idx` (`FFMEnrollmentGroupDetailId`),
  KEY `FFMEnrollmentGroupApplicantRefFFMApplicantId_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollmentGroupApplicant`
--

LOCK TABLES `FFMEnrollmentGroupApplicant` WRITE;
/*!40000 ALTER TABLE `FFMEnrollmentGroupApplicant` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollmentGroupApplicant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollmentGroupDetail`
--

DROP TABLE IF EXISTS `FFMEnrollmentGroupDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollmentGroupDetail` (
  `FFMEnrollmentGroupDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMEnrollmentGroupId` bigint(64) NOT NULL,
  `FFMEnrollDisenrollChangeId` bigint(64) NOT NULL,
  `TransactionType` char(1) NOT NULL,
  `FFEAssignedPolicyNumber` varchar(50) DEFAULT NULL,
  `IssuerId` varchar(5) DEFAULT NULL,
  `AssignedPlanId` varchar(16) DEFAULT NULL,
  `StartDate` varchar(45) DEFAULT NULL,
  `StopDate` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollmentGroupDetailId`),
  KEY `FFMEnrollmentGroupDetailRefFFMEnrollDisenrollChange_fk_idx` (`FFMEnrollDisenrollChangeId`),
  KEY `FFMEnrollmentGroupDetailRefFFMEnrollmentGroup_fk_idx` (`FFMEnrollmentGroupId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollmentGroupDetail`
--

LOCK TABLES `FFMEnrollmentGroupDetail` WRITE;
/*!40000 ALTER TABLE `FFMEnrollmentGroupDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollmentGroupDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMEnrollmentRelationship`
--

DROP TABLE IF EXISTS `FFMEnrollmentRelationship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMEnrollmentRelationship` (
  `FFMEnrollmentRelationshipId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMApplicantId` bigint(64) NOT NULL,
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `FFMRelationshipCode` varchar(18) DEFAULT NULL,
  `FFMMultipleTaxHouseholdIndicator` char(1) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMEnrollmentRelationshipId`),
  KEY `FFMEnrollmentRelationshipRefFFMApplicant_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMEnrollmentRelationship`
--

LOCK TABLES `FFMEnrollmentRelationship` WRITE;
/*!40000 ALTER TABLE `FFMEnrollmentRelationship` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMEnrollmentRelationship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMErrorLog`
--

DROP TABLE IF EXISTS `FFMErrorLog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMErrorLog` (
  `FFMErrorLogId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `ErrorMessage` varchar(1000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMErrorLogId`),
  KEY `FFMErrorLogRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMErrorLogRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMErrorLog`
--

LOCK TABLES `FFMErrorLog` WRITE;
/*!40000 ALTER TABLE `FFMErrorLog` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMErrorLog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMInsuranceApplicant`
--

DROP TABLE IF EXISTS `FFMInsuranceApplicant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMInsuranceApplicant` (
  `FFMInsuranceApplicantId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsuranceApplicationId` bigint(64) NOT NULL,
  `FFMPersonId` bigint(64) NOT NULL,
  `IsSubscriber` char(1) NOT NULL,
  `FinancialAssistanceIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `StudentStatus` tinyint(1) NOT NULL DEFAULT '0',
  `FFEAssignedApplicantId` varchar(50) NOT NULL,
  `FFEAssignedApplicantSourceText` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMInsuranceApplicantId`),
  KEY `fk_FFMInsuranceApplicant_FFMInsuranceApplication1_idx` (`FFMInsuranceApplicationId`),
  KEY `FFMInsuranceApplicantRefFFMPersonId_fk_idx` (`FFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMInsuranceApplicant`
--

LOCK TABLES `FFMInsuranceApplicant` WRITE;
/*!40000 ALTER TABLE `FFMInsuranceApplicant` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMInsuranceApplicant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMInsuranceApplication`
--

DROP TABLE IF EXISTS `FFMInsuranceApplication`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMInsuranceApplication` (
  `FFMInsuranceApplicationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `PrimaryFFMPersonId` bigint(64) NOT NULL,
  `PrimaryTaxFilerFFMPersonId` bigint(64) DEFAULT NULL,
  `JointTaxFilerFFMPersonId` bigint(64) DEFAULT NULL,
  `MultipleTaxHouseholdIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMInsuranceApplicationId`),
  KEY `fk_FFMInsuranceApplication_FFMDetail1_idx` (`FFMDetailId`),
  KEY `FFMInsuranceApplication_FFMPerson1_fk_idx` (`PrimaryFFMPersonId`),
  KEY `FFMInsuranceApplication_FFMPerson2_fk_idx` (`PrimaryTaxFilerFFMPersonId`),
  KEY `FFMInsuranceApplication_FFMPerson3_fk_idx` (`JointTaxFilerFFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMInsuranceApplication`
--

LOCK TABLES `FFMInsuranceApplication` WRITE;
/*!40000 ALTER TABLE `FFMInsuranceApplication` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMInsuranceApplication` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMInsuranceMember`
--

DROP TABLE IF EXISTS `FFMInsuranceMember`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMInsuranceMember` (
  `FFMInsuranceMemberId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsurancePolicyId` bigint(64) NOT NULL,
  `FFEAssignedPolicyId` varchar(50) DEFAULT NULL,
  `FFEAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `IssuerAssignedPolicyId` varchar(50) DEFAULT NULL,
  `IssuerAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `SubscriberFFMInsuranceMemberId` bigint(64) NOT NULL,
  `SubscriberFamilyRelationshipHIPAACode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `OriginatingInsuranceFFMInsuranceApplicantId` bigint(64) NOT NULL,
  `TobaccoUseIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `TobaccoLastUsageDate` date DEFAULT NULL,
  `EnrollmentPeriodCode` enum('Initial','Annual','Special') NOT NULL DEFAULT 'Initial',
  `SpecialEnrollmentReasonCode` enum('TerminationOfBenefits','Marriage','Birth','Adoption','NewlyEligible','ExchangeError','Dissatisfaction','FInancialChange','ChangeOfLocation','ExceptionalCircumstance') DEFAULT NULL,
  `DisenrollmentReasonCode` enum('Divorce','Birth','Death','Adoption','Strike','COBRA','COBRAPremiumPaid','VoluntaryWithdrawal','PlanChange','IdentifyingDataElementsChange','InitialEnrollment','BenefitSelection','Re-Enrollment','LocationChange','NonPayment','NoReasonGiven','MemberBenefotSelection') DEFAULT NULL,
  `MemberCoverageStartDate` date DEFAULT NULL,
  `MemberCoverageEndDate` date DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMInsuranceMemberId`),
  KEY `fk_FFMInsuranceMember_FFMInsurancePolicy1_idx` (`FFMInsurancePolicyId`),
  KEY `fk_FFMInsuranceMember_FFMInsuranceApplicant1_idx` (`OriginatingInsuranceFFMInsuranceApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMInsuranceMember`
--

LOCK TABLES `FFMInsuranceMember` WRITE;
/*!40000 ALTER TABLE `FFMInsuranceMember` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMInsuranceMember` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMInsurancePolicy`
--

DROP TABLE IF EXISTS `FFMInsurancePolicy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMInsurancePolicy` (
  `FFMInsurancePolicyId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `ExpirationDate` date DEFAULT NULL,
  `IssuerAssignedPolicyId` varchar(50) DEFAULT NULL,
  `IssuerAssignedPolicySourceText` varchar(100) DEFAULT NULL,
  `FFEAssignedPolicyId` varchar(50) NOT NULL,
  `FFEAssignedPolicySourceText` varchar(100) NOT NULL,
  `InsurancePlanStandardComponentId` varchar(50) DEFAULT NULL,
  `InsurancePlanStandardComponentSourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanVariantId` varchar(50) DEFAULT NULL,
  `InsurancePlanVariantSourceText` varchar(100) DEFAULT NULL,
  `IssuerId` varchar(5) DEFAULT NULL,
  `IssuerSourceText` varchar(100) DEFAULT NULL,
  `PolicyStatus` enum('Effectuated','PendingEffectuation','Canceled','Terminated') NOT NULL DEFAULT 'PendingEffectuation',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMInsurancePolicyId`),
  KEY `fk_FFMInsurancePolicy_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMInsurancePolicy`
--

LOCK TABLES `FFMInsurancePolicy` WRITE;
/*!40000 ALTER TABLE `FFMInsurancePolicy` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMInsurancePolicy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMInsurancePremium`
--

DROP TABLE IF EXISTS `FFMInsurancePremium`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMInsurancePremium` (
  `FFMInsurancePremiumId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsurancePolicyId` bigint(64) NOT NULL,
  `Amount` decimal(10,2) DEFAULT NULL,
  `Frequency` enum('Weekly','Monthly','Annually','BiWeekly','Quarterly','SemiMonthly','Hourly','Daily') DEFAULT NULL,
  `MonthlyMaximumAllowedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `ElectedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `AppliedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `IndividualResponsibilityTotalAmount` decimal(10,2) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMInsurancePremiumId`),
  KEY `fk_FFMInsurancePremium_FFMInsurancePolicy1_idx` (`FFMInsurancePolicyId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMInsurancePremium`
--

LOCK TABLES `FFMInsurancePremium` WRITE;
/*!40000 ALTER TABLE `FFMInsurancePremium` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMInsurancePremium` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPaymentDetail`
--

DROP TABLE IF EXISTS `FFMPaymentDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPaymentDetail` (
  `FFMPaymentDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) DEFAULT NULL,
  `FFMEnrollmentGroupId` bigint(64) DEFAULT NULL,
  `PaymentDate` timestamp NULL DEFAULT NULL,
  `Type` enum('Payment','Refund') NOT NULL,
  `Amount` decimal(10,2) NOT NULL,
  `PaymentTransactionId` varchar(20) DEFAULT NULL,
  `MarketIndicator` varchar(20) DEFAULT NULL,
  `EnrollmentGroupId` varchar(45) DEFAULT NULL,
  `TotalAmountOwed` decimal(10,2) DEFAULT NULL,
  `PremiumAmountTotal` decimal(10,2) DEFAULT NULL,
  `APTCAmount` decimal(10,2) DEFAULT NULL,
  `FFEAssignedMemberId` varchar(40) DEFAULT NULL,
  `ProposedCoverageEffectiveDate` date DEFAULT NULL,
  `AdditionalDetail` varchar(500) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPaymentDetailId`),
  KEY `FFMPaymenDetailRefFFMDetail_fk_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPaymentDetail`
--

LOCK TABLES `FFMPaymentDetail` WRITE;
/*!40000 ALTER TABLE `FFMPaymentDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPaymentDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPaymentHistory`
--

DROP TABLE IF EXISTS `FFMPaymentHistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPaymentHistory` (
  `FFMPaymentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMPaymentDetailId` bigint(64) NOT NULL,
  `DateOfAction` timestamp NULL DEFAULT NULL,
  `TypeOfAction` enum('Payment','Refund','Rejected','Did Not Pay') NOT NULL,
  `Amount` decimal(10,2) NOT NULL,
  `PaymentObjectName` bigint(64) DEFAULT NULL,
  `PaymentTransactionId` varchar(20) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPaymentId`),
  KEY `FFMPaymentHistoryRefFFMPaymentDetail_fk_idx` (`FFMPaymentDetailId`),
  KEY `FFMPaymentHistoryFFMPaymentDetailDateOfAction_idx` (`FFMPaymentDetailId`,`DateOfAction`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPaymentHistory`
--

LOCK TABLES `FFMPaymentHistory` WRITE;
/*!40000 ALTER TABLE `FFMPaymentHistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPaymentHistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPeriodEligibility`
--

DROP TABLE IF EXISTS `FFMPeriodEligibility`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPeriodEligibility` (
  `FFMPeriodEligibilityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMInsuranceApplicantId` bigint(64) NOT NULL,
  `EnrollmentPeriodCode` enum('Initial','Annual','Special') NOT NULL,
  `StartDate` date DEFAULT NULL,
  `EndDate` date DEFAULT NULL,
  `EligibilityIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `EarliestQHPEffectiveDate` date DEFAULT NULL,
  `LatestQHPEffectiveDate` date DEFAULT NULL,
  `SpecialEnrollmentReasonCode` enum('TerminationOfBenefits','Marriage','Birth','Adoption','NewlyEligible','ExchangeError','Dissatisfaction','FInancialChange','ChangeOfLocation','ExceptionalCircumstance') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPeriodEligibilityId`),
  KEY `fk_FFMPeriodEligibility_FFMInsuranceApplicant1_idx` (`FFMInsuranceApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPeriodEligibility`
--

LOCK TABLES `FFMPeriodEligibility` WRITE;
/*!40000 ALTER TABLE `FFMPeriodEligibility` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPeriodEligibility` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPerson`
--

DROP TABLE IF EXISTS `FFMPerson`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPerson` (
  `FFMPersonId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `BirthDate` date DEFAULT NULL,
  `GivenName` char(100) DEFAULT NULL,
  `MiddleName` char(100) DEFAULT NULL,
  `SuffixText` varchar(50) DEFAULT NULL,
  `SurName` char(100) DEFAULT NULL,
  `SexCode` enum('U','M','F') DEFAULT NULL,
  `SSNId` varchar(108) DEFAULT NULL,
  `SSNSourceText` varchar(100) DEFAULT NULL,
  `MarriedIndicator` tinyint(1) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPersonId`),
  KEY `fk_FFMPerson_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPerson`
--

LOCK TABLES `FFMPerson` WRITE;
/*!40000 ALTER TABLE `FFMPerson` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPerson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPersonAssociation`
--

DROP TABLE IF EXISTS `FFMPersonAssociation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPersonAssociation` (
  `FFMPersonAssociationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMPersonId` bigint(64) NOT NULL,
  `PersonIdReference` bigint(64) NOT NULL,
  `FamilyRelationshipCode` enum('01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','23','24','25','26','31','38','53','60','D2') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPersonAssociationId`),
  KEY `fk_FFMPersonAssociation_FFMPerson1_idx` (`FFMPersonId`),
  KEY `fk_FFMPersonAssociation_FFMPerson2_idx` (`PersonIdReference`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPersonAssociation`
--

LOCK TABLES `FFMPersonAssociation` WRITE;
/*!40000 ALTER TABLE `FFMPersonAssociation` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPersonAssociation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPersonContactAssociation`
--

DROP TABLE IF EXISTS `FFMPersonContactAssociation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPersonContactAssociation` (
  `FFMPersonContactAssociationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMPersonId` bigint(64) NOT NULL,
  `FFMContactInformationId` bigint(64) NOT NULL,
  `PrimaryIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `HomeIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `WorkIndicator` tinyint(1) NOT NULL DEFAULT '0',
  `AddressTypeCode` varchar(45) DEFAULT NULL,
  `CategoryCode` enum('DesignatedOrganization','DesignatedPerson','Self') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPersonContactAssociationId`),
  KEY `fk_FFMPersonContactAssociation_FFMPerson1_idx` (`FFMPersonId`),
  KEY `fk_FFMPersonContactAssociation_FFMContactInformation1_idx` (`FFMContactInformationId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPersonContactAssociation`
--

LOCK TABLES `FFMPersonContactAssociation` WRITE;
/*!40000 ALTER TABLE `FFMPersonContactAssociation` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPersonContactAssociation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPersonPreferredLanguage`
--

DROP TABLE IF EXISTS `FFMPersonPreferredLanguage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPersonPreferredLanguage` (
  `FFMPersonPreferredLanguageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMPersonId` bigint(64) NOT NULL,
  `LanguageName` varchar(100) DEFAULT NULL,
  `SpeaksLanguageIndicator` tinyint(1) DEFAULT NULL,
  `WritesLanguageIndicator` tinyint(1) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMPersonPreferredLanguageId`),
  KEY `fk_FFMPersonPreferredLanguage_FFMPerson1_idx` (`FFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPersonPreferredLanguage`
--

LOCK TABLES `FFMPersonPreferredLanguage` WRITE;
/*!40000 ALTER TABLE `FFMPersonPreferredLanguage` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPersonPreferredLanguage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMPolicyPremiumChangeActivity`
--

DROP TABLE IF EXISTS `FFMPolicyPremiumChangeActivity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMPolicyPremiumChangeActivity` (
  `FFMPolicyPremiumChangeActivityId` bigint(64) NOT NULL,
  `FFMDetailId` bigint(64) NOT NULL,
  `ActionEffectiveDate` date DEFAULT NULL,
  `InsurancePremiumAmount` decimal(10,2) DEFAULT NULL,
  `InsurancePremiumElectedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `InsurancePremiumAppliedAPTCAmount` decimal(10,2) DEFAULT NULL,
  `RateAreaId` varchar(45) DEFAULT NULL,
  `RateAreaSourceText` varchar(100) DEFAULT NULL,
  `InsurancePlanVariantCategoryNumericCode` varchar(45) DEFAULT NULL,
  `InsurancePremiumIndividualResponsibilityTotalAmount` decimal(10,2) DEFAULT NULL,
  `MaintainedInsurancePolicyId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`FFMPolicyPremiumChangeActivityId`),
  KEY `fk_FFMPolicyCreationActivity_FFMDetail1_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMPolicyPremiumChangeActivity`
--

LOCK TABLES `FFMPolicyPremiumChangeActivity` WRITE;
/*!40000 ALTER TABLE `FFMPolicyPremiumChangeActivity` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMPolicyPremiumChangeActivity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMProcessedErrorQueue`
--

DROP TABLE IF EXISTS `FFMProcessedErrorQueue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMProcessedErrorQueue` (
  `FFMProcessedErrorQueueId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `FFMEnrollmentGroupId` bigint(64) DEFAULT NULL,
  `FFMApplicantId` bigint(64) DEFAULT NULL,
  `QueueTimestamp` timestamp NULL DEFAULT NULL,
  `FFEAssignedMemberId` varchar(50) DEFAULT NULL,
  `Status` enum('New','Working','Fixed') NOT NULL,
  `FFMTypeError` enum('System Down','TransferUserBack','TransactionResponseCode','ActionResponseCode') NOT NULL,
  `UserRequest` enum('Email When FFM Back Up') DEFAULT NULL,
  `TransferUserBackExceptionReason` varchar(100) DEFAULT NULL,
  `TransactionResponseCode` char(100) DEFAULT NULL,
  `ActionResponseCode` char(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMProcessedErrorQueueId`),
  KEY `FFMProcessedErrorQueueRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `FFMProcessedErrorQueueRefFFMEnrollmentGroup_fk_idx` (`FFMEnrollmentGroupId`),
  KEY `FFMProcessedErrorQueueRefFFMApplicant_fk_idx` (`FFMApplicantId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMProcessedErrorQueue`
--

LOCK TABLES `FFMProcessedErrorQueue` WRITE;
/*!40000 ALTER TABLE `FFMProcessedErrorQueue` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMProcessedErrorQueue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMTaxFilerInformation`
--

DROP TABLE IF EXISTS `FFMTaxFilerInformation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMTaxFilerInformation` (
  `FFMTaxFilerInformationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) DEFAULT NULL,
  `PrimaryFirstName` varchar(50) NOT NULL,
  `PrimaryMiddleName` varchar(50) DEFAULT NULL,
  `PrimaryLastName` varchar(50) NOT NULL,
  `PrimarySuffixName` varchar(18) DEFAULT NULL,
  `SecondaryFirstName` varchar(50) NOT NULL,
  `SecondaryMiddleName` varchar(50) DEFAULT NULL,
  `SecondaryLastName` varchar(50) NOT NULL,
  `SecondarySuffixName` varchar(18) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMTaxFilerInformationId`),
  KEY `FFMTaxFilerInformationRefFFMDetail_fk_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMTaxFilerInformation`
--

LOCK TABLES `FFMTaxFilerInformation` WRITE;
/*!40000 ALTER TABLE `FFMTaxFilerInformation` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMTaxFilerInformation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FFMTransaction`
--

DROP TABLE IF EXISTS `FFMTransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FFMTransaction` (
  `FFMTransactionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `FFMDetailId` bigint(64) NOT NULL,
  `Type` varchar(45) DEFAULT NULL,
  `Status` enum('Send Request','Completed Eligibility Application','Exception on eligibility application','User initiated return') NOT NULL DEFAULT 'Send Request',
  `ExceptionReason` enum('Consumer failed Identity Proofing','Application in Pend Status','Application not completed','System Unavailable. Retry later.','Data Sources Unavailable. Retry later.') DEFAULT NULL,
  `SAMLFilename` varchar(255) DEFAULT NULL,
  `SAMLExceptionReason` varchar(255) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FFMTransactionId`),
  KEY `FFMTransaction_FFMDetail_fk0_idx` (`FFMDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FFMTransaction`
--

LOCK TABLES `FFMTransaction` WRITE;
/*!40000 ALTER TABLE `FFMTransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `FFMTransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `FSAAndHSA`
--

DROP TABLE IF EXISTS `FSAAndHSA`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `FSAAndHSA` (
  `FSAAndHSAId` bigint(64) NOT NULL AUTO_INCREMENT,
  `EmployerPlanId` bigint(64) NOT NULL,
  `NewHireWaitingPeriod` enum('0 Days','30 Days','60 Days','90 Days','1st of Month after 0 days','1st of Month after 30 days','1st of Month after 60 days','1st of Month after 90 days') DEFAULT NULL,
  `RehireWaitingPeriod` enum('0 Days','30 Days','60 Days','90 Days','1st of Month after 0 days','1st of Month after 30 days','1st of Month after 60 days','1st of Month after 90 days') DEFAULT NULL,
  `BenefitsEndDate` enum('End of Month','Date of Termination','Other') DEFAULT NULL,
  `FSAMinimumContribution` decimal(10,2) DEFAULT NULL,
  `FSAMaximumContribution` decimal(10,2) DEFAULT NULL,
  `FilingSeparateMinimum` decimal(10,2) DEFAULT NULL,
  `FilingSeparateMaximum` decimal(10,2) DEFAULT NULL,
  `SingleLimitAmount` decimal(10,2) DEFAULT NULL,
  `SingleEmployerAmount` decimal(10,2) DEFAULT NULL,
  `FamilyEmployerAmount` decimal(10,2) DEFAULT NULL,
  `FamilyLimitAmount` decimal(10,2) DEFAULT NULL,
  `Over55CatchupAmount` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`FSAAndHSAId`),
  KEY `FSAAndHSARefEmployerPlan_fk` (`EmployerPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `FSAAndHSA`
--

LOCK TABLES `FSAAndHSA` WRITE;
/*!40000 ALTER TABLE `FSAAndHSA` DISABLE KEYS */;
/*!40000 ALTER TABLE `FSAAndHSA` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `IndividualPlan`
--

DROP TABLE IF EXISTS `IndividualPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `IndividualPlan` (
  `IndividualPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `GroupNumber` varchar(50) NOT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `RateType` enum('Composite','Age Banded') DEFAULT NULL,
  `IsSmokerPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsGenderPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsTierPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForChild` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForSpouse` tinyint(1) NOT NULL DEFAULT '0',
  `IsContributaryPlan` tinyint(1) NOT NULL DEFAULT '0',
  `TierNameId` bigint(64) DEFAULT NULL,
  `IsCurrentlyAQuote` tinyint(1) NOT NULL DEFAULT '0',
  `BrokerDomainQuoteId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`IndividualPlanId`),
  KEY `IndividualPlanRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `IndividualPlanRefTierName_fk_idx` (`TierNameId`),
  KEY `IndividualPlanRefDomain_fk_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `IndividualPlan`
--

LOCK TABLES `IndividualPlan` WRITE;
/*!40000 ALTER TABLE `IndividualPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `IndividualPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `JobTitle`
--

DROP TABLE IF EXISTS `JobTitle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `JobTitle` (
  `JobTitleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `JobTitleName` varchar(200) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`JobTitleId`),
  KEY `JobTitleRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `JobTitle`
--

LOCK TABLES `JobTitle` WRITE;
/*!40000 ALTER TABLE `JobTitle` DISABLE KEYS */;
/*!40000 ALTER TABLE `JobTitle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `LicenseVerification`
--

DROP TABLE IF EXISTS `LicenseVerification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `LicenseVerification` (
  `LicenseVerificationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) DEFAULT NULL,
  `ProducerId` bigint(64) DEFAULT NULL,
  `NIPR` enum('Verified','Pending','Not Found') DEFAULT NULL,
  `NIPRDate` date DEFAULT NULL,
  `BackgroundCheck` enum('Approved','Pending','Denied') DEFAULT NULL,
  `BackgroundCheckDate` date DEFAULT NULL,
  `FFM` enum('Verified','Pending','Not Found') DEFAULT NULL,
  `FFMDate` date DEFAULT NULL,
  `Appointment` enum('Approved','Pending','Denied') DEFAULT NULL,
  `AppointmentDate` date DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`LicenseVerificationId`),
  KEY `LicenseVerificationRefDomain_fk_idx` (`DomainId`),
  KEY `LicenseVerificationRefProducer_fk_idx` (`ProducerId`)
) ENGINE=innodb AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `LicenseVerification`
--

LOCK TABLES `LicenseVerification` WRITE;
/*!40000 ALTER TABLE `LicenseVerification` DISABLE KEYS */;
/*!40000 ALTER TABLE `LicenseVerification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `LineOfCoverage`
--

DROP TABLE IF EXISTS `LineOfCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `LineOfCoverage` (
  `LineOfCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `Name` varchar(100) NOT NULL,
  `SubPlanTypeName` varchar(100) DEFAULT NULL,
  `IsSubPlanType` tinyint(1) NOT NULL DEFAULT '0',
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`LineOfCoverageId`),
  KEY `LineOfCoverage_Name_uq` (`Name`)
) ENGINE=innodb AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `LineOfCoverage`
--

LOCK TABLES `LineOfCoverage` WRITE;
/*!40000 ALTER TABLE `LineOfCoverage` DISABLE KEYS */;
INSERT INTO `LineOfCoverage` VALUES (11,'Worksite','Accident',1,13,'Active',1,'2013-06-26 14:34:17',NULL,NULL),(15,'FSA','Limited Purpose FSA',1,11,'Active',1,'2013-10-31 16:12:45',NULL,NULL),(13,'Pediatric Dental',NULL,0,3,'Active',1,'2013-08-06 08:01:23',NULL,NULL),(12,'Worksite','Cancer',1,14,'Active',1,'2013-06-26 14:34:27',NULL,NULL),(7,'Long-term DI',NULL,0,8,'Active',1,'2013-06-13 04:40:50',NULL,NULL),(4,'Basic Life AD&D',NULL,0,5,'Active',1,'2013-06-13 04:39:47',NULL,NULL),(8,'HSA',NULL,0,9,'Active',1,'2013-06-13 04:41:00',NULL,NULL),(1,'Medical',NULL,0,1,'Active',1,'2013-05-30 21:39:00',NULL,NULL),(5,'Optional Life',NULL,0,6,'Active',1,'2013-06-13 04:40:09',NULL,NULL),(6,'Short-term DI',NULL,0,7,'Active',1,'2013-06-13 04:40:45',NULL,NULL),(3,'Vision',NULL,0,4,'Active',1,'2013-06-05 23:38:48',NULL,NULL),(10,'FSA','Dependent Care FSA',1,12,'Active',1,'2013-06-26 14:33:02',NULL,NULL),(14,'Worksite','Critical Illness',1,15,'Active',1,'2013-08-06 08:01:23',NULL,NULL),(9,'FSA','Medical FSA',1,10,'Active',1,'2013-06-13 04:40:56',NULL,NULL),(2,'Dental',NULL,0,2,'Active',1,'2013-05-30 23:36:18',NULL,NULL);
/*!40000 ALTER TABLE `LineOfCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Location`
--

DROP TABLE IF EXISTS `Location`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Location` (
  `LocationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `AddressId` bigint(64) NOT NULL,
  `LocationName` varchar(200) NOT NULL,
  `TaxId` varchar(40) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `AdjustForDaylightSavings` tinyint(1) NOT NULL DEFAULT '1',
  `TimeZone` enum('Eastern','Central','Mountain','Western') NOT NULL DEFAULT 'Eastern',
  `LocationCode` varchar(40) NOT NULL,
  `IsPrimaryLocation` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`LocationId`),
  KEY `LocationtRefDomain_fk_idx` (`DomainId`),
  KEY `LocationRefAddress_fk_idx` (`AddressId`),
  KEY `LocationDomainIdAndTaxId_idx` (`DomainId`,`TaxId`)
) ENGINE=innodb AUTO_INCREMENT=48 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Location`
--

LOCK TABLES `Location` WRITE;
/*!40000 ALTER TABLE `Location` DISABLE KEYS */;
/*!40000 ALTER TABLE `Location` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `LoginResult`
--

DROP TABLE IF EXISTS `LoginResult`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `LoginResult` (
  `LoginResultId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `LoginTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `NumberOfLoginAttempts` smallint(16) NOT NULL,
  `LogoffTimestamp` timestamp NULL DEFAULT NULL,
  `UserWasLockedOut` tinyint(1) NOT NULL DEFAULT '0',
  `WasLoggedOffForInactivity` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`LoginResultId`),
  KEY `LoginResultsRefUser_fk_idx` (`UserId`),
  KEY `LoginResult_UserId_LoginTimestamp_idx` (`UserId`,`LoginTimestamp`)
) ENGINE=innodb AUTO_INCREMENT=930 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `LoginResult`
--

LOCK TABLES `LoginResult` WRITE;
/*!40000 ALTER TABLE `LoginResult` DISABLE KEYS */;
INSERT INTO `LoginResult` VALUES (874,1,'2014-01-07 08:44:30',3,NULL,0,0),(875,1,'2014-01-07 08:45:38',1,NULL,0,0),(884,1,'2014-01-07 23:55:44',1,NULL,0,0),(879,1,'2014-01-07 14:23:35',1,NULL,0,0),(876,1,'2014-01-07 11:14:21',1,NULL,0,0),(909,1,'2014-01-17 07:59:24',1,NULL,0,0),(899,1,'2014-01-14 13:32:28',2,NULL,0,0),(901,1,'2014-01-15 04:11:14',1,NULL,0,0),(896,1,'2014-01-14 03:06:57',2,NULL,0,0),(922,1,'2014-02-09 15:19:15',1,NULL,0,0),(869,80,'2013-09-26 14:50:17',3,NULL,0,0),(919,1,'2014-02-03 14:10:32',2,NULL,0,0),(892,1,'2014-01-10 22:26:55',1,NULL,0,0),(921,1,'2014-02-07 13:45:02',2,NULL,0,0),(920,1,'2014-02-03 14:19:15',1,NULL,0,0),(902,1,'2014-01-15 05:08:36',1,NULL,0,0),(870,1,'2013-09-26 14:50:31',4,NULL,0,0),(915,1,'2014-01-27 08:23:07',1,NULL,0,0),(910,1,'2014-01-20 10:44:03',2,NULL,0,0),(916,1,'2014-01-27 08:57:07',1,NULL,0,0),(900,1,'2014-01-15 03:47:19',1,NULL,0,0),(913,1,'2014-01-24 10:16:20',1,NULL,0,0),(895,1,'2014-01-13 10:22:18',1,NULL,0,0),(929,1,'2014-03-10 19:56:59',1,NULL,0,0),(914,1,'2014-01-24 10:20:16',1,NULL,0,0),(898,1,'2014-01-14 13:19:31',1,NULL,0,0),(887,1,'2014-01-08 23:25:50',2,NULL,0,0),(903,1,'2014-01-15 07:10:26',1,NULL,0,0),(872,1,'2014-01-07 08:33:15',1,'2014-01-07 03:45:34',0,0),(894,1,'2014-01-13 08:22:49',1,NULL,0,0),(905,1,'2014-01-15 14:02:05',1,NULL,0,0),(886,1,'2014-01-08 23:25:24',1,NULL,0,0),(928,1,'2014-03-10 16:45:12',1,NULL,0,0),(883,1,'2014-01-07 19:01:19',1,NULL,0,0),(911,1,'2014-01-22 08:21:01',1,NULL,0,0),(880,1,'2014-01-07 15:25:21',1,'2014-01-07 11:04:30',0,0),(889,1,'2014-01-09 15:10:54',1,NULL,0,0),(912,1,'2014-01-23 08:39:51',1,NULL,0,0),(927,1,'2014-03-01 02:17:45',1,'2014-02-28 21:26:06',0,0),(878,1,'2014-01-07 12:35:02',1,NULL,0,0),(871,1,'2014-01-06 15:47:54',1,NULL,0,0),(926,1,'2014-02-25 16:56:51',2,NULL,0,0),(923,1,'2014-02-20 09:06:43',2,NULL,0,0),(882,1,'2014-01-07 17:14:40',1,NULL,0,0),(877,1,'2014-01-07 12:12:12',1,NULL,0,0),(907,1,'2014-01-16 03:20:56',2,NULL,0,0),(890,1,'2014-01-09 15:19:45',1,NULL,0,0),(885,1,'2014-01-08 10:18:35',1,NULL,0,0),(873,80,'2014-01-07 08:43:54',2,NULL,0,0),(918,1,'2014-01-29 18:38:23',1,NULL,0,0),(888,1,'2014-01-09 14:45:46',1,NULL,0,0),(891,1,'2014-01-09 16:58:02',1,NULL,0,0),(897,1,'2014-01-14 12:11:10',1,NULL,0,0),(893,1,'2014-01-13 06:57:02',1,NULL,0,0),(906,1,'2014-01-15 21:34:37',1,NULL,0,0),(924,1,'2014-02-20 15:45:10',1,NULL,0,0),(904,1,'2014-01-15 08:35:32',1,NULL,0,0),(925,1,'2014-02-24 14:09:21',1,NULL,0,0),(917,1,'2014-01-29 17:07:05',1,NULL,0,0),(881,1,'2014-01-07 16:05:59',1,NULL,0,0),(908,1,'2014-01-16 13:33:24',1,NULL,0,0);
/*!40000 ALTER TABLE `LoginResult` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Manager`
--

DROP TABLE IF EXISTS `Manager`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Manager` (
  `ManagerId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DepartmentId` bigint(64) DEFAULT NULL,
  `DirectReportUserId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ManagerId`),
  KEY `ManagerRefDepartment_idx` (`DepartmentId`),
  KEY `ManagerToUserId_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Manager`
--

LOCK TABLES `Manager` WRITE;
/*!40000 ALTER TABLE `Manager` DISABLE KEYS */;
/*!40000 ALTER TABLE `Manager` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PayStub`
--

DROP TABLE IF EXISTS `PayStub`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PayStub` (
  `PayStubId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `StartDate` date NOT NULL,
  `EndDate` date NOT NULL,
  `CheckDate` date NOT NULL,
  `ObjectName` varchar(255) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PayStubId`),
  KEY `PabStubRefUser_fk_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PayStub`
--

LOCK TABLES `PayStub` WRITE;
/*!40000 ALTER TABLE `PayStub` DISABLE KEYS */;
/*!40000 ALTER TABLE `PayStub` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanAssociation`
--

DROP TABLE IF EXISTS `PlanAssociation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanAssociation` (
  `PlanAssociationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `DisplayName` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanAssociationId`),
  KEY `PlanAssociationRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `PlanAssociationRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanAssociation`
--

LOCK TABLES `PlanAssociation` WRITE;
/*!40000 ALTER TABLE `PlanAssociation` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanAssociation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanBenefitMax`
--

DROP TABLE IF EXISTS `PlanBenefitMax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanBenefitMax` (
  `PlanBenefitMaxId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `Amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `PayFrequency` enum('Weekly','Monthly') NOT NULL DEFAULT 'Weekly',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`PlanBenefitMaxId`),
  KEY `PlanBenefitMaxRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanBenefitMaxRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanBenefitMax`
--

LOCK TABLES `PlanBenefitMax` WRITE;
/*!40000 ALTER TABLE `PlanBenefitMax` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanBenefitMax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanBenefitPeriod`
--

DROP TABLE IF EXISTS `PlanBenefitPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanBenefitPeriod` (
  `PlanBenefitPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `Days` int(11) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`PlanBenefitPeriodId`),
  KEY `PlanBenefitPeriodRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanBenefitPeriodRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanBenefitPeriod`
--

LOCK TABLES `PlanBenefitPeriod` WRITE;
/*!40000 ALTER TABLE `PlanBenefitPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanBenefitPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanDependentLife`
--

DROP TABLE IF EXISTS `PlanDependentLife`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanDependentLife` (
  `PlanDependentLifeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `SpouseAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `ChildAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanDependentLifeId`),
  KEY `PlanDepenedentLifeRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanDependentLifeRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanDependentLife`
--

LOCK TABLES `PlanDependentLife` WRITE;
/*!40000 ALTER TABLE `PlanDependentLife` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanDependentLife` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanDetailCategory`
--

DROP TABLE IF EXISTS `PlanDetailCategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanDetailCategory` (
  `PlanDetailCategoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceNameDomainId` bigint(64) DEFAULT NULL,
  `CategoryName` varchar(100) NOT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanDetailCategoryId`),
  KEY `PlanDetailCategoryRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanDetailCategoryRefDomain_fk_idx` (`InsuranceNameDomainId`)
) ENGINE=innodb AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanDetailCategory`
--

LOCK TABLES `PlanDetailCategory` WRITE;
/*!40000 ALTER TABLE `PlanDetailCategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanDetailCategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanDetailsSortingInterval`
--

DROP TABLE IF EXISTS `PlanDetailsSortingInterval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanDetailsSortingInterval` (
  `PlanDetailsSortingIntervalId` bigint(64) unsigned NOT NULL AUTO_INCREMENT,
  `DomainPlanDetailNameId` bigint(64) NOT NULL,
  `From` bigint(64) NOT NULL DEFAULT '0',
  `To` bigint(64) NOT NULL DEFAULT '0',
  `DisplayValue` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanDetailsSortingIntervalId`),
  KEY `PlanDetailSortingIntervalRefDomainPlanDetailName_fk_idx` (`DomainPlanDetailNameId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanDetailsSortingInterval`
--

LOCK TABLES `PlanDetailsSortingInterval` WRITE;
/*!40000 ALTER TABLE `PlanDetailsSortingInterval` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanDetailsSortingInterval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanERContribution`
--

DROP TABLE IF EXISTS `PlanERContribution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanERContribution` (
  `PlanERContributionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `PercentFrom` int(11) NOT NULL,
  `PercentTo` int(11) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PlanERContributionId`),
  KEY `PlanERContributionRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanERContributionReDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanERContribution`
--

LOCK TABLES `PlanERContribution` WRITE;
/*!40000 ALTER TABLE `PlanERContribution` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanERContribution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanEliminationPeriod`
--

DROP TABLE IF EXISTS `PlanEliminationPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanEliminationPeriod` (
  `PlanEliminationPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `AccidentDays` int(11) NOT NULL DEFAULT '0',
  `IllnessDays` int(11) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`PlanEliminationPeriodId`),
  KEY `PlanEliminationPeriodRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanEliminationPeriodRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanEliminationPeriod`
--

LOCK TABLES `PlanEliminationPeriod` WRITE;
/*!40000 ALTER TABLE `PlanEliminationPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanEliminationPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanIndustry`
--

DROP TABLE IF EXISTS `PlanIndustry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanIndustry` (
  `PlanIndustryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `IndustryName` varchar(100) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`PlanIndustryId`),
  KEY `PlanIndustryRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanIndustryRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanIndustry`
--

LOCK TABLES `PlanIndustry` WRITE;
/*!40000 ALTER TABLE `PlanIndustry` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanIndustry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanMarketSize`
--

DROP TABLE IF EXISTS `PlanMarketSize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanMarketSize` (
  `PlanMarketSizeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `FromSize` int(11) NOT NULL,
  `ToSize` int(11) NOT NULL,
  `DisplayName` varchar(50) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanMarketSizeId`),
  KEY `PlanMarketSizeRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `PlanMarketSizeRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=35 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanMarketSize`
--

LOCK TABLES `PlanMarketSize` WRITE;
/*!40000 ALTER TABLE `PlanMarketSize` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanMarketSize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanNetwork`
--

DROP TABLE IF EXISTS `PlanNetwork`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanNetwork` (
  `PlanNetworkId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `PlanTypeNameId` bigint(64) NOT NULL,
  `DisplayName` varchar(50) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanNetworkId`),
  KEY `PlanNetworkRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `PlanNetworkRefPlanTypeName_fk_idx` (`PlanTypeNameId`),
  KEY `PlanNetworkRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanNetwork`
--

LOCK TABLES `PlanNetwork` WRITE;
/*!40000 ALTER TABLE `PlanNetwork` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanNetwork` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanOption`
--

DROP TABLE IF EXISTS `PlanOption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanOption` (
  `PlanOptionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `DisplayName` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanOptionId`),
  KEY `PlanOptionRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanOptionRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanOption`
--

LOCK TABLES `PlanOption` WRITE;
/*!40000 ALTER TABLE `PlanOption` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanOption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanOrthodontia`
--

DROP TABLE IF EXISTS `PlanOrthodontia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanOrthodontia` (
  `PlanOrthodontiaId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `OrthodontiaName` varchar(100) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanOrthodontiaId`),
  KEY `PlanOrthodontiaRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanOrthodontiaRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanOrthodontia`
--

LOCK TABLES `PlanOrthodontia` WRITE;
/*!40000 ALTER TABLE `PlanOrthodontia` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanOrthodontia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanPercentageOfSalary`
--

DROP TABLE IF EXISTS `PlanPercentageOfSalary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanPercentageOfSalary` (
  `PlanPercentageOfSalaryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `PercentageOfSalary` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PlanPercentageOfSalaryId`),
  KEY `PlanPercentageOfSalaryRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `PlanPercentageOfSalaryRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanPercentageOfSalary`
--

LOCK TABLES `PlanPercentageOfSalary` WRITE;
/*!40000 ALTER TABLE `PlanPercentageOfSalary` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanPercentageOfSalary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanRxRider`
--

DROP TABLE IF EXISTS `PlanRxRider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanRxRider` (
  `PlanRxRiderId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) DEFAULT NULL,
  `RxName` varchar(50) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanRxRiderId`),
  KEY `PlanRxRiderRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanRxRiderRefDomain_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanRxRider`
--

LOCK TABLES `PlanRxRider` WRITE;
/*!40000 ALTER TABLE `PlanRxRider` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanRxRider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanTierName`
--

DROP TABLE IF EXISTS `PlanTierName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanTierName` (
  `PlanTierNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `TierNameId` bigint(64) NOT NULL,
  `DisplayName` varchar(100) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanTierNameId`),
  KEY `PlanTierNameRefProviderLineOfCoverageId_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanTierNameRefTierName_fk_idx` (`TierNameId`)
) ENGINE=innodb AUTO_INCREMENT=33 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanTierName`
--

LOCK TABLES `PlanTierName` WRITE;
/*!40000 ALTER TABLE `PlanTierName` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanTierName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanTierNameValue`
--

DROP TABLE IF EXISTS `PlanTierNameValue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanTierNameValue` (
  `PlanTierNameValueId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PlanTierNameId` bigint(64) NOT NULL,
  `TierNameValueId` bigint(64) NOT NULL,
  `DisplayName` varchar(100) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `SortKey` int(11) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PlanTierNameValueId`),
  KEY `PlanTierNameValueRefTierNameValue_fk_idx` (`TierNameValueId`),
  KEY `PlanTierNameValueRefPlanTierName_fk_idx` (`PlanTierNameId`)
) ENGINE=innodb AUTO_INCREMENT=94 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanTierNameValue`
--

LOCK TABLES `PlanTierNameValue` WRITE;
/*!40000 ALTER TABLE `PlanTierNameValue` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanTierNameValue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PlanTypeName`
--

DROP TABLE IF EXISTS `PlanTypeName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PlanTypeName` (
  `PlanTypeNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `PlanTypeName` varchar(100) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PlanTypeNameId`),
  KEY `PlanTypeNameRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `PlanTypeNameRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PlanTypeName`
--

LOCK TABLES `PlanTypeName` WRITE;
/*!40000 ALTER TABLE `PlanTypeName` DISABLE KEYS */;
/*!40000 ALTER TABLE `PlanTypeName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Producer`
--

DROP TABLE IF EXISTS `Producer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Producer` (
  `ProducerId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `IsMainProducer` tinyint(1) NOT NULL DEFAULT '0',
  `License` varchar(50) DEFAULT NULL,
  `LicenseState` varchar(2) DEFAULT NULL,
  `NPN` varchar(20) DEFAULT NULL,
  `ProviderParentEntityId` bigint(64) DEFAULT NULL,
  `SignaturePath` varchar(100) DEFAULT NULL,
  `SubmittedTimestamp` timestamp NULL DEFAULT NULL,
  `AgreedToAssignCommissions` tinyint(1) NOT NULL DEFAULT '0',
  `PaymentObjectName` varchar(50) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `FFEUserId` varchar(50) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProducerId`),
  KEY `ProducerRefUser_fk_idx` (`UserId`),
  KEY `ProducerRefDomain_fk_idx` (`DomainId`),
  KEY `ProducerRefProviderParentEntityId_fk_idx` (`ProviderParentEntityId`)
) ENGINE=innodb AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Producer`
--

LOCK TABLES `Producer` WRITE;
/*!40000 ALTER TABLE `Producer` DISABLE KEYS */;
/*!40000 ALTER TABLE `Producer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProducerCustomer`
--

DROP TABLE IF EXISTS `ProducerCustomer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProducerCustomer` (
  `ProducerCustomerId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ProducerId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProducerCustomerId`),
  KEY `ProducerCustomerRefProducer_fk_idx` (`ProducerId`),
  KEY `ProducerCustomerRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProducerCustomer`
--

LOCK TABLES `ProducerCustomer` WRITE;
/*!40000 ALTER TABLE `ProducerCustomer` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProducerCustomer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProducerDocument`
--

DROP TABLE IF EXISTS `ProducerDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProducerDocument` (
  `ProducerDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProducerId` bigint(64) NOT NULL,
  `FolderId` bigint(64) DEFAULT NULL,
  `DocumentName` varchar(200) NOT NULL,
  `ObjectName` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProducerDocumentId`),
  KEY `ProducerDocumentRefProducer_fk_idx` (`ProducerId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProducerDocument`
--

LOCK TABLES `ProducerDocument` WRITE;
/*!40000 ALTER TABLE `ProducerDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProducerDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProducerIndividual`
--

DROP TABLE IF EXISTS `ProducerIndividual`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProducerIndividual` (
  `ProducerIndividualId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProducerId` bigint(64) DEFAULT NULL,
  `IndividualUserId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProducerIndividualId`),
  KEY `ProducerCustomerRefProducer_fk_idx` (`ProducerId`),
  KEY `ProducerIndividualRefUser_fk_idx` (`IndividualUserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProducerIndividual`
--

LOCK TABLES `ProducerIndividual` WRITE;
/*!40000 ALTER TABLE `ProducerIndividual` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProducerIndividual` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderChildAgeRate`
--

DROP TABLE IF EXISTS `ProviderChildAgeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderChildAgeRate` (
  `ProviderChildAgeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `ChildNumber` int(11) NOT NULL DEFAULT '0',
  `MaleCost` decimal(10,2) NOT NULL,
  `FemaleCost` decimal(10,2) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderChildAgeRateId`),
  KEY `ProviderChildAgeRateRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderChildAgeRate`
--

LOCK TABLES `ProviderChildAgeRate` WRITE;
/*!40000 ALTER TABLE `ProviderChildAgeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderChildAgeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderCompositeRate`
--

DROP TABLE IF EXISTS `ProviderCompositeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderCompositeRate` (
  `ProviderCompositeRateId` int(11) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `TierNameValueId` bigint(64) DEFAULT NULL,
  `Cost` decimal(10,2) DEFAULT NULL,
  `TierDisplayName` varchar(100) DEFAULT NULL,
  `LifeCoverageAmount` decimal(10,0) DEFAULT NULL,
  `LifeCostPerThousand` decimal(10,4) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderCompositeRateId`),
  KEY `ProviderCompositeRateRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `ProviderCompositeRateRefTierNameValue_fk_idx` (`TierNameValueId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderCompositeRate`
--

LOCK TABLES `ProviderCompositeRate` WRITE;
/*!40000 ALTER TABLE `ProviderCompositeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderCompositeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderCountyBaseRate`
--

DROP TABLE IF EXISTS `ProviderCountyBaseRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderCountyBaseRate` (
  `ProviderCountyBaseRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `CountyName` varchar(100) NOT NULL,
  `CountyFactor` decimal(10,6) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderCountyBaseRateId`),
  UNIQUE KEY `EmployerCountyBaseRateCounty_uq` (`CountyName`,`ProviderPlanId`),
  KEY `ProviderCountyBaseRateRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderCountyBaseRate`
--

LOCK TABLES `ProviderCountyBaseRate` WRITE;
/*!40000 ALTER TABLE `ProviderCountyBaseRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderCountyBaseRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderInsuranceCompany`
--

DROP TABLE IF EXISTS `ProviderInsuranceCompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderInsuranceCompany` (
  `ProviderInsuranceCompanyId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `LookupDoctorUrl` varchar(200) DEFAULT NULL,
  `LookupRxUrl` varchar(200) DEFAULT NULL,
  `LookupDentistUrl` varchar(200) DEFAULT NULL,
  `TermsAndConditions` varchar(200) DEFAULT NULL,
  `PaymentConfirmationMessage` varchar(200) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`ProviderInsuranceCompanyId`),
  KEY `ProviderInsuranceCompanyRefDomain_fk_idx` (`DomainId`),
  KEY `ProviderInsuranceCompanyRefDomain_insurance_domain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `ProviderInsuranceCompanyRefLineOfCoverage_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderInsuranceCompany`
--

LOCK TABLES `ProviderInsuranceCompany` WRITE;
/*!40000 ALTER TABLE `ProviderInsuranceCompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderInsuranceCompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCAssociation`
--

DROP TABLE IF EXISTS `ProviderLOCAssociation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCAssociation` (
  `ProviderLOCAssociationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanAssociationId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCAssociationId`),
  KEY `ProviderLOCAssociationRefProviderLineOfCoverageDetailId_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCAssociationRefPlanAssociation_fk_idx` (`PlanAssociationId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCAssociation`
--

LOCK TABLES `ProviderLOCAssociation` WRITE;
/*!40000 ALTER TABLE `ProviderLOCAssociation` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCAssociation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCBenefitMax`
--

DROP TABLE IF EXISTS `ProviderLOCBenefitMax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCBenefitMax` (
  `ProviderLOCBenefitMaxId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PlanBenefitMaxId` bigint(64) NOT NULL,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCBenefitMaxId`),
  KEY `ProviderLOCBenefitMaxRefPlanBenefitMax_fk_idx` (`PlanBenefitMaxId`),
  KEY `ProviderLOCBenefitMaxRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCBenefitMax`
--

LOCK TABLES `ProviderLOCBenefitMax` WRITE;
/*!40000 ALTER TABLE `ProviderLOCBenefitMax` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCBenefitMax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCBenefitPeriod`
--

DROP TABLE IF EXISTS `ProviderLOCBenefitPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCBenefitPeriod` (
  `ProviderLOCBenefitPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanBenefitPeriodId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCBenefitPeriodId`),
  KEY `ProviderLOCBenefitPeriodRefBenefitPeriod_fk_idx` (`PlanBenefitPeriodId`),
  KEY `ProviderLOCBenefitPeriodRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCBenefitPeriod`
--

LOCK TABLES `ProviderLOCBenefitPeriod` WRITE;
/*!40000 ALTER TABLE `ProviderLOCBenefitPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCBenefitPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCCategory`
--

DROP TABLE IF EXISTS `ProviderLOCCategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCCategory` (
  `ProviderLOCCategoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanDetailCategoryId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCCategoryId`),
  KEY `ProviderLOCCategoryRefProviderLineOfCoverageDetailId_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCCategoryRefPlanDetailCategory_fk_idx` (`PlanDetailCategoryId`)
) ENGINE=innodb AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCCategory`
--

LOCK TABLES `ProviderLOCCategory` WRITE;
/*!40000 ALTER TABLE `ProviderLOCCategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCCategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCDependentLife`
--

DROP TABLE IF EXISTS `ProviderLOCDependentLife`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCDependentLife` (
  `ProviderLOCDependentLifeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanDependentLifeId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCDependentLifeId`),
  KEY `ProviderLOCDependentLiferRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCDependentLifeRefDomain_fk_idx` (`PlanDependentLifeId`),
  KEY `ProviderLOCDependentLifeRefPlanDependentLife_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCDependentLife`
--

LOCK TABLES `ProviderLOCDependentLife` WRITE;
/*!40000 ALTER TABLE `ProviderLOCDependentLife` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCDependentLife` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCDetailName`
--

DROP TABLE IF EXISTS `ProviderLOCDetailName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCDetailName` (
  `ProviderLOCDetailNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLOCCategoryId` bigint(64) NOT NULL,
  `DomainPlanDetailNameId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCDetailNameId`),
  KEY `ProviderLOCDetailNameRefProviderLocCategory_fk_idx` (`ProviderLOCCategoryId`)
) ENGINE=innodb AUTO_INCREMENT=129 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCDetailName`
--

LOCK TABLES `ProviderLOCDetailName` WRITE;
/*!40000 ALTER TABLE `ProviderLOCDetailName` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCDetailName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCERContribution`
--

DROP TABLE IF EXISTS `ProviderLOCERContribution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCERContribution` (
  `ProviderLOCERContributionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanERContributionId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCERContributionId`),
  KEY `ProviderLOCERContributionRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCERContributionRefPlanERContribution_fk_idx` (`PlanERContributionId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCERContribution`
--

LOCK TABLES `ProviderLOCERContribution` WRITE;
/*!40000 ALTER TABLE `ProviderLOCERContribution` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCERContribution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCEliminationPeriod`
--

DROP TABLE IF EXISTS `ProviderLOCEliminationPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCEliminationPeriod` (
  `ProviderLOCEliminationPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanEliminationPeriodId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCEliminationPeriodId`),
  KEY `ProviderLOCEliminationPeriodRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCEliminationPeriodRefEliminationPeriod_idx` (`PlanEliminationPeriodId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCEliminationPeriod`
--

LOCK TABLES `ProviderLOCEliminationPeriod` WRITE;
/*!40000 ALTER TABLE `ProviderLOCEliminationPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCEliminationPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCIndustry`
--

DROP TABLE IF EXISTS `ProviderLOCIndustry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCIndustry` (
  `ProviderLOCIndustryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanIndustryId` bigint(64) NOT NULL,
  `SicCodeValues` varchar(2000) DEFAULT NULL,
  `NumberOfDigits` int(11) NOT NULL DEFAULT '3',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCIndustryId`),
  KEY `ProviderLOCIndustryRefPlanIndustry_fk_idx` (`PlanIndustryId`),
  KEY `ProviderLOCIndustryRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCIndustry`
--

LOCK TABLES `ProviderLOCIndustry` WRITE;
/*!40000 ALTER TABLE `ProviderLOCIndustry` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCIndustry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCMarketSize`
--

DROP TABLE IF EXISTS `ProviderLOCMarketSize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCMarketSize` (
  `ProviderLOCMarketSizeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanMarketSizeId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCMarketSizeId`),
  KEY `ProviderLOCMarketSizeRefProviderLineOfCoverageDetaill_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCMarketSizeRefPlanMarketSize_fk_idx` (`PlanMarketSizeId`)
) ENGINE=innodb AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCMarketSize`
--

LOCK TABLES `ProviderLOCMarketSize` WRITE;
/*!40000 ALTER TABLE `ProviderLOCMarketSize` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCMarketSize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCNetwork`
--

DROP TABLE IF EXISTS `ProviderLOCNetwork`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCNetwork` (
  `ProviderLOCNetworkId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanNetworkId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCNetworkId`),
  KEY `ProviderLOCNetworkRefProviderLineOfCoverageDetailId_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCNetworkRefPlanAssociation_fk_idx` (`PlanNetworkId`)
) ENGINE=innodb AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCNetwork`
--

LOCK TABLES `ProviderLOCNetwork` WRITE;
/*!40000 ALTER TABLE `ProviderLOCNetwork` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCNetwork` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCOption`
--

DROP TABLE IF EXISTS `ProviderLOCOption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCOption` (
  `ProviderLOCOptionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanOptionId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCOptionId`),
  KEY `ProviderLOCOptionRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCOptionRefPlanOption_fk_idx` (`PlanOptionId`)
) ENGINE=innodb AUTO_INCREMENT=32 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCOption`
--

LOCK TABLES `ProviderLOCOption` WRITE;
/*!40000 ALTER TABLE `ProviderLOCOption` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCOption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCOrthodontia`
--

DROP TABLE IF EXISTS `ProviderLOCOrthodontia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCOrthodontia` (
  `ProviderLOCOrthodontiaId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanOrthodontiaId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCOrthodontiaId`),
  KEY `ProviderLOCOrthodontiaRefProviderLineOfCoverageDetailId_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCOrthodontiaRefPlanOrthodontia_fk_idx` (`PlanOrthodontiaId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCOrthodontia`
--

LOCK TABLES `ProviderLOCOrthodontia` WRITE;
/*!40000 ALTER TABLE `ProviderLOCOrthodontia` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCOrthodontia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCPercentageOfSalary`
--

DROP TABLE IF EXISTS `ProviderLOCPercentageOfSalary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCPercentageOfSalary` (
  `ProviderLOCPercentageOfSalaryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanPercentageOfSalaryId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCPercentageOfSalaryId`),
  KEY `ProviderLOCPercentageOfSalaryRefLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCPercentageOfSalaryRefPercentageOfSalary_fk_idx` (`PlanPercentageOfSalaryId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCPercentageOfSalary`
--

LOCK TABLES `ProviderLOCPercentageOfSalary` WRITE;
/*!40000 ALTER TABLE `ProviderLOCPercentageOfSalary` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCPercentageOfSalary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCPlanType`
--

DROP TABLE IF EXISTS `ProviderLOCPlanType`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCPlanType` (
  `ProviderLOCPlanTypeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanTypeNameId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCPlanTypeId`),
  KEY `ProviderLOCPlanTypeRefProviderLineOfCoverageDetailId_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCPlanTypeRefPlanTypeName_fk_idx` (`PlanTypeNameId`)
) ENGINE=innodb AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCPlanType`
--

LOCK TABLES `ProviderLOCPlanType` WRITE;
/*!40000 ALTER TABLE `ProviderLOCPlanType` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCPlanType` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCRXRider`
--

DROP TABLE IF EXISTS `ProviderLOCRXRider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCRXRider` (
  `ProviderLocRxRiderId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanRxRiderId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLocRxRiderId`),
  KEY `ProviderLOCRxRiderRefPlanRxRiderId_fk_idx` (`PlanRxRiderId`),
  KEY `ProviderLOCRxRiderRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCRXRider`
--

LOCK TABLES `ProviderLOCRXRider` WRITE;
/*!40000 ALTER TABLE `ProviderLOCRXRider` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCRXRider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCServiceArea`
--

DROP TABLE IF EXISTS `ProviderLOCServiceArea`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCServiceArea` (
  `ProviderLOCServiceAreaId` bigint(64) NOT NULL AUTO_INCREMENT,
  `StateId` bigint(64) NOT NULL,
  `ProviderLOCNetworkId` bigint(64) DEFAULT NULL,
  `ProviderLOCAssociationId` bigint(64) DEFAULT NULL,
  `DisplayValue` varchar(2000) DEFAULT NULL COMMENT 'ZipCodeId points to the Mu',
  `ServiceAreaType` enum('County','ZipCode') NOT NULL DEFAULT 'County',
  `NumberOfZipCodeDigits` int(11) NOT NULL DEFAULT '0',
  `County` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCServiceAreaId`),
  KEY `ProviderLOCServiceAreaRefProviderLOCAssociation_fk_idx` (`ProviderLOCAssociationId`),
  KEY `ProviderLOCServiceAreaRefProviderLOCNetwork_fk_idx` (`ProviderLOCNetworkId`),
  KEY `ProviderLOCServiceAreaRefState_fk_idx` (`StateId`)
) ENGINE=innodb AUTO_INCREMENT=405 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCServiceArea`
--

LOCK TABLES `ProviderLOCServiceArea` WRITE;
/*!40000 ALTER TABLE `ProviderLOCServiceArea` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCServiceArea` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLOCTierName`
--

DROP TABLE IF EXISTS `ProviderLOCTierName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLOCTierName` (
  `ProviderLOCTierNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL,
  `PlanTierNameId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLOCTierNameId`),
  KEY `ProviderLOCTierRefProviderLineOfCoverageDetail_fk_idx` (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLOCTierRefPlanTierName_fk_idx` (`PlanTierNameId`),
  KEY `ProviderLOCTierNameRefDomain_fk_idx` (`InsuranceCompanyDomainId`)
) ENGINE=innodb AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLOCTierName`
--

LOCK TABLES `ProviderLOCTierName` WRITE;
/*!40000 ALTER TABLE `ProviderLOCTierName` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLOCTierName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLicensedState`
--

DROP TABLE IF EXISTS `ProviderLicensedState`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLicensedState` (
  `ProviderLicensedStateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `StateCode` char(2) NOT NULL,
  `State` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLicensedStateId`),
  UNIQUE KEY `ProviderLicensedState_StateCode_fk` (`StateCode`),
  KEY `ProviderLicensedStateRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLicensedState`
--

LOCK TABLES `ProviderLicensedState` WRITE;
/*!40000 ALTER TABLE `ProviderLicensedState` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLicensedState` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLifeCoverage`
--

DROP TABLE IF EXISTS `ProviderLifeCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLifeCoverage` (
  `ProviderLifeCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `FixCoverageAmount` decimal(10,0) DEFAULT NULL,
  `PercentageOfSalary` int(11) DEFAULT NULL,
  `TypeCoverage` enum('Percentage','Dollar') DEFAULT NULL,
  `TypeIndividual` enum('Employee','Spouse','Child') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLifeCoverageId`),
  KEY `ProviderLifeCoverageRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLifeCoverage`
--

LOCK TABLES `ProviderLifeCoverage` WRITE;
/*!40000 ALTER TABLE `ProviderLifeCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLifeCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLifeRule`
--

DROP TABLE IF EXISTS `ProviderLifeRule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLifeRule` (
  `ProviderLifeRuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `OfferSpouseCoverage` tinyint(1) NOT NULL DEFAULT '0',
  `OfferDependentCoverage` tinyint(1) NOT NULL DEFAULT '0',
  `ReducesBy50PercentAtAge65` tinyint(1) NOT NULL DEFAULT '0',
  `ReducesBy50PercentAtAge70` tinyint(1) NOT NULL DEFAULT '0',
  `RoundUpToTheNearest1000` tinyint(1) NOT NULL DEFAULT '0',
  `RoundDownToTheNearest1000` tinyint(1) NOT NULL DEFAULT '0',
  `RoundToTheNearestDollar` tinyint(1) NOT NULL DEFAULT '0',
  `AmountsIncludeADandD` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ChildrenEligibleToAge` int(11) DEFAULT NULL,
  `MaximumEmployeeCoverageAmount` decimal(10,0) DEFAULT NULL,
  `MaximumSpouseCoveragePercent` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLifeRuleId`),
  KEY `ProviderLifeRuleRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLifeRule`
--

LOCK TABLES `ProviderLifeRule` WRITE;
/*!40000 ALTER TABLE `ProviderLifeRule` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLifeRule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLineOfCoverage`
--

DROP TABLE IF EXISTS `ProviderLineOfCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLineOfCoverage` (
  `ProviderLineOfCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CannotChangeName` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderLineOfCoverageId`),
  KEY `ProviderLineOfCoverageRefDomain_fk` (`DomainId`),
  KEY `ProviderLineOfCoverageRefLineOfCoverage_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=46 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLineOfCoverage`
--

LOCK TABLES `ProviderLineOfCoverage` WRITE;
/*!40000 ALTER TABLE `ProviderLineOfCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLineOfCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderLineOfCoverageDetail`
--

DROP TABLE IF EXISTS `ProviderLineOfCoverageDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderLineOfCoverageDetail` (
  `ProviderLineOfCoverageDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderLineOfCoverageDetailId`),
  KEY `ProviderLineOfCoverageDetailRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderLineOfCoverageDetail`
--

LOCK TABLES `ProviderLineOfCoverageDetail` WRITE;
/*!40000 ALTER TABLE `ProviderLineOfCoverageDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderLineOfCoverageDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderParentEntity`
--

DROP TABLE IF EXISTS `ProviderParentEntity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderParentEntity` (
  `ProviderParentEntityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `EntityName` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderParentEntityId`),
  KEY `ProviderParentEntityRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderParentEntity`
--

LOCK TABLES `ProviderParentEntity` WRITE;
/*!40000 ALTER TABLE `ProviderParentEntity` DISABLE KEYS */;
INSERT INTO `ProviderParentEntity` VALUES (1,2,'Cornerstone',1,'2013-07-23 07:48:51',NULL,NULL),(2,2,'Western Southern',1,'2013-07-23 07:48:51',NULL,NULL),(3,2,'None',1,'2013-07-23 07:49:22',NULL,NULL);
/*!40000 ALTER TABLE `ProviderParentEntity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlan`
--

DROP TABLE IF EXISTS `ProviderPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlan` (
  `ProviderPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) DEFAULT NULL,
  `LineOfCoverageId` bigint(64) DEFAULT NULL,
  `ProviderLineOfCoverageId` bigint(64) DEFAULT NULL,
  `PlanMarketSizeId` bigint(64) DEFAULT NULL,
  `PlanTypeNameId` bigint(64) DEFAULT NULL,
  `PlanName` varchar(100) NOT NULL,
  `IsIndividualPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsQualifiedPlan` tinyint(1) NOT NULL DEFAULT '0',
  `HSACompatible` tinyint(1) NOT NULL DEFAULT '0',
  `MetalTier` enum('Platinum','Gold','Silver','Bronze','Catastrophic') DEFAULT NULL,
  `CSR` enum('73','87','94') DEFAULT NULL,
  `PlanNumber` varchar(100) DEFAULT NULL,
  `IsMocPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsCustomPlan` tinyint(1) NOT NULL DEFAULT '0',
  `IsEmbeddedDeductible` tinyint(1) NOT NULL DEFAULT '0',
  `IsPrimaryDentistPlan` tinyint(1) NOT NULL DEFAULT '0',
  `SortKey` int(11) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanId`),
  KEY `ProviderPlanRefProviderLineOfCoverage_fk_idx` (`ProviderLineOfCoverageId`),
  KEY `ProviderPlanRefLineOfCoverage_fk_idx` (`LineOfCoverageId`),
  KEY `ProviderPlanRefPlanrMarketSize_fk_idx` (`PlanMarketSizeId`),
  KEY `ProviderPlanRefDomain_fk_idx` (`DomainId`),
  KEY `ProviderPlanRefPlanTypeName_fk_idx` (`PlanTypeNameId`)
) ENGINE=innodb AUTO_INCREMENT=92 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlan`
--

LOCK TABLES `ProviderPlan` WRITE;
/*!40000 ALTER TABLE `ProviderPlan` DISABLE KEYS */;
INSERT INTO `ProviderPlan` VALUES (88,2,NULL,9,NULL,NULL,NULL,'Medical FSA',0,0,0,NULL,NULL,NULL,0,0,0,0,1,'Active',1,'2013-10-31 11:13:27',NULL,NULL),(89,2,NULL,8,NULL,NULL,NULL,'Medical HSA',0,0,0,NULL,NULL,NULL,0,0,0,0,1,'Active',1,'2013-10-31 12:14:31',NULL,NULL),(91,2,NULL,15,NULL,NULL,NULL,'Limited Purpose FSA',0,0,0,NULL,NULL,NULL,0,0,0,0,1,'Active',1,'2013-10-31 12:15:52',NULL,NULL),(90,2,NULL,10,NULL,NULL,NULL,'Dependent Care FSA',0,0,0,NULL,NULL,NULL,0,0,0,0,1,'Active',1,'2013-10-31 12:15:08',NULL,NULL);
/*!40000 ALTER TABLE `ProviderPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlan4Digit`
--

DROP TABLE IF EXISTS `ProviderPlan4Digit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlan4Digit` (
  `ProviderPlan4DigitId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `RatingArea` varchar(20) DEFAULT NULL,
  `PlanNumber4Digit` char(4) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlan4DigitId`),
  KEY `ProviderPlan4DigitRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlan4Digit`
--

LOCK TABLES `ProviderPlan4Digit` WRITE;
/*!40000 ALTER TABLE `ProviderPlan4Digit` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlan4Digit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanBenefitMax`
--

DROP TABLE IF EXISTS `ProviderPlanBenefitMax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanBenefitMax` (
  `ProviderPlanBenefitMaxId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `PlanBenefitMaxId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanBenefitMaxId`),
  KEY `ProviderPlanBenefitMaxRefPlanDetail_fk_idx` (`ProviderPlanDetailId`),
  KEY `ProviderPlanBenefitMaxRefBenefitMax_fk_idx` (`PlanBenefitMaxId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanBenefitMax`
--

LOCK TABLES `ProviderPlanBenefitMax` WRITE;
/*!40000 ALTER TABLE `ProviderPlanBenefitMax` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanBenefitMax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanBenefitPeriod`
--

DROP TABLE IF EXISTS `ProviderPlanBenefitPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanBenefitPeriod` (
  `ProviderPlanBenefitPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `PlanBenefitPeriodId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanBenefitPeriodId`),
  KEY `ProviderPlanBenefitPeriodRefPlanDetail_fk_idx` (`ProviderPlanDetailId`),
  KEY `ProviderPlanBenefitPeriodRefPlanBenefitPeriod_fk_idx` (`PlanBenefitPeriodId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanBenefitPeriod`
--

LOCK TABLES `ProviderPlanBenefitPeriod` WRITE;
/*!40000 ALTER TABLE `ProviderPlanBenefitPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanBenefitPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanCompositeTier`
--

DROP TABLE IF EXISTS `ProviderPlanCompositeTier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanCompositeTier` (
  `ProviderPlanCompositeTierId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `PlanTierNameValueId` bigint(64) NOT NULL,
  `MonthlyCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanCompositeTierId`),
  KEY `ProviderPlanCompositeTierRefProviderPlanRatingSetDet_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanCompositeTierRefPlanTierNameValue_fk_idx` (`PlanTierNameValueId`),
  KEY `ProviderPlanCompositeTierRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb AUTO_INCREMENT=125 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanCompositeTier`
--

LOCK TABLES `ProviderPlanCompositeTier` WRITE;
/*!40000 ALTER TABLE `ProviderPlanCompositeTier` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanCompositeTier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanDetail`
--

DROP TABLE IF EXISTS `ProviderPlanDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanDetail` (
  `ProviderPlanDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `ProviderPlanTemplateId` bigint(64) DEFAULT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `SortKey` int(11) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanDetailId`),
  KEY `ProviderPlanDetailRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb AUTO_INCREMENT=88 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanDetail`
--

LOCK TABLES `ProviderPlanDetail` WRITE;
/*!40000 ALTER TABLE `ProviderPlanDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanDisplayValue`
--

DROP TABLE IF EXISTS `ProviderPlanDisplayValue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanDisplayValue` (
  `ProviderPlanDisplayValueId` int(11) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `DomainPlanDetailNameId` bigint(64) NOT NULL,
  `Value1` varchar(100) DEFAULT NULL,
  `Value2` varchar(100) DEFAULT NULL,
  `Value3` varchar(100) DEFAULT NULL,
  `Value4` varchar(100) DEFAULT NULL,
  `SortValue` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanDisplayValueId`),
  KEY `ProviderPlanDisplayValueRefProviderPlanDetailId_fk_idx` (`ProviderPlanDetailId`),
  KEY `ProviderPlanDisplayValueRefDomainPlanDetailNameId_fk_idx` (`DomainPlanDetailNameId`)
) ENGINE=innodb AUTO_INCREMENT=1878 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanDisplayValue`
--

LOCK TABLES `ProviderPlanDisplayValue` WRITE;
/*!40000 ALTER TABLE `ProviderPlanDisplayValue` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanDisplayValue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanDocument`
--

DROP TABLE IF EXISTS `ProviderPlanDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanDocument` (
  `ProviderPlanDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `DocumentName` varchar(100) NOT NULL,
  `ObjectName` varchar(200) NOT NULL,
  `IsExternalUrl` tinyint(1) NOT NULL DEFAULT '0',
  `DocumentUrl` varchar(255) DEFAULT NULL,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanDocumentId`),
  KEY `ProviderPlanDocumentRefProviderPlanDetail_fk_idx` (`ProviderPlanDetailId`)
) ENGINE=innodb AUTO_INCREMENT=161 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanDocument`
--

LOCK TABLES `ProviderPlanDocument` WRITE;
/*!40000 ALTER TABLE `ProviderPlanDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanEliminationPeriod`
--

DROP TABLE IF EXISTS `ProviderPlanEliminationPeriod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanEliminationPeriod` (
  `ProviderPlanEliminationPeriodId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `PlanEliminationPeriodId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanEliminationPeriodId`),
  KEY `ProviderPlanEliminationPeriodRefPlanDetail_fk_idx` (`ProviderPlanDetailId`),
  KEY `ProviderPlanEliminationPeriodRefPlanEliminationPeriod_fk_idx` (`PlanEliminationPeriodId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanEliminationPeriod`
--

LOCK TABLES `ProviderPlanEliminationPeriod` WRITE;
/*!40000 ALTER TABLE `ProviderPlanEliminationPeriod` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanEliminationPeriod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanLifePlan`
--

DROP TABLE IF EXISTS `ProviderPlanLifePlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanLifePlan` (
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `FaceAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `FaceAmountType` enum('Flat Dollar','Percentage of Salary') NOT NULL DEFAULT 'Flat Dollar',
  `SpouseMaximumPercentage` decimal(10,2) NOT NULL DEFAULT '0.00',
  `ChildMaxAge` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanLifePlan`
--

LOCK TABLES `ProviderPlanLifePlan` WRITE;
/*!40000 ALTER TABLE `ProviderPlanLifePlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanLifePlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanOptionalLifeAmount`
--

DROP TABLE IF EXISTS `ProviderPlanOptionalLifeAmount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanOptionalLifeAmount` (
  `ProviderPlanOptionalLifeAmountId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanDetailId` bigint(64) NOT NULL,
  `PersonType` enum('Employee','Spouse','Child') NOT NULL DEFAULT 'Employee',
  `PlanAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`ProviderPlanOptionalLifeAmountId`),
  KEY `ProviderPlanOptionalLifeAmountRefProviderPlanDetail_fk_idx` (`ProviderPlanDetailId`)
) ENGINE=innodb AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanOptionalLifeAmount`
--

LOCK TABLES `ProviderPlanOptionalLifeAmount` WRITE;
/*!40000 ALTER TABLE `ProviderPlanOptionalLifeAmount` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanOptionalLifeAmount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSADandD`
--

DROP TABLE IF EXISTS `ProviderPlanRSADandD`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSADandD` (
  `ProviderPlanRSADandDId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PricePerThousand` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSADandDId`),
  KEY `ProviderPlanRSADandDRefProviderPlanRatingSetDetailId_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSADandD`
--

LOCK TABLES `ProviderPlanRSADandD` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSADandD` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSADandD` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSAgeInterval`
--

DROP TABLE IF EXISTS `ProviderPlanRSAgeInterval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSAgeInterval` (
  `ProviderPlanRSAgeIntervalId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL COMMENT 'This is a Unique Key with a Unique Index',
  `BeginAge` int(11) NOT NULL DEFAULT '0' COMMENT 'For Medicare set to 9999 to 9999',
  `EndAge` int(11) NOT NULL DEFAULT '999',
  `AgeFactor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`ProviderPlanRSAgeIntervalId`),
  KEY `ProviderPlanRSAgeIntervalRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=245 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSAgeInterval`
--

LOCK TABLES `ProviderPlanRSAgeInterval` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSAgeInterval` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSAgeInterval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSAgeRate`
--

DROP TABLE IF EXISTS `ProviderPlanRSAgeRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSAgeRate` (
  `ProviderPlanRSAgeRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `ProviderPlanRSAgeIntervalId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `PlanTierNameValueId` bigint(64) DEFAULT NULL,
  `PlanEliminationPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitPeriodId` bigint(64) DEFAULT NULL,
  `PlanIndustryId` bigint(64) DEFAULT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SmokerCost` decimal(10,2) DEFAULT NULL,
  `MaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `FemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseMaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseFemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `MaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `FemaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSAgeRateId`),
  KEY `ProviderPlanRSAgeRateRefPlanTierNameValue_fk_idx` (`PlanTierNameValueId`),
  KEY `ProviderPlanRSAgeRateRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `ProviderPlanRSAgeRateRefProvPlanRatingSetDetail_f_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=187 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSAgeRate`
--

LOCK TABLES `ProviderPlanRSAgeRate` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSAgeRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSAgeRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSAssociation`
--

DROP TABLE IF EXISTS `ProviderPlanRSAssociation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSAssociation` (
  `ProviderPlanRSAssociationId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanAssociationId` bigint(64) NOT NULL,
  `AssociationFactor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `AssociationCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSAssociationId`),
  KEY `ProviderPlanRSAssociationRefProviderPlanRatingsSetDetl_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSAssociationRefPlanAssociation_fk_idx` (`PlanAssociationId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSAssociation`
--

LOCK TABLES `ProviderPlanRSAssociation` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSAssociation` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSAssociation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSChildRate`
--

DROP TABLE IF EXISTS `ProviderPlanRSChildRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSChildRate` (
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PricePerThousand` decimal(10,2) NOT NULL DEFAULT '0.00',
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSChildRateRefRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSChildRate`
--

LOCK TABLES `ProviderPlanRSChildRate` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSChildRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSChildRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSChildren`
--

DROP TABLE IF EXISTS `ProviderPlanRSChildren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSChildren` (
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `MaxNumberOfChildren` int(11) NOT NULL DEFAULT '0',
  `MaxChildAge` int(11) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSChildrenRefProviderPlanRatingSetDet_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSChildren`
--

LOCK TABLES `ProviderPlanRSChildren` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSChildren` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSChildren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSChildrenRate`
--

DROP TABLE IF EXISTS `ProviderPlanRSChildrenRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSChildrenRate` (
  `ProviderPlanRSChildrenRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `PlanTierNameValueId` bigint(64) DEFAULT NULL,
  `ChildNumber` int(11) NOT NULL DEFAULT '1',
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SmokerCost` decimal(10,2) DEFAULT NULL,
  `MaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `FemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseMaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseFemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `MaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `FemaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSChildrenRateId`),
  KEY `ProviderPlanRSChildrenRateRefPlanTierNameValue_fk_idx` (`PlanTierNameValueId`),
  KEY `ProviderPlanRSChildrenRateRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `ProviderPlanRSChildrenRateRefProvPlanRatingSetDetail_f_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSChildrenRate`
--

LOCK TABLES `ProviderPlanRSChildrenRate` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSChildrenRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSChildrenRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSCounty`
--

DROP TABLE IF EXISTS `ProviderPlanRSCounty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSCounty` (
  `ProviderPlanRSCountyId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `County` varchar(100) NOT NULL,
  `StateId` bigint(64) NOT NULL,
  `NetworkId` bigint(64) DEFAULT NULL,
  `PlanNetworkId` bigint(64) DEFAULT NULL,
  `CountyFactor` decimal(25,15) NOT NULL DEFAULT '1.000000000000000',
  `CountyCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `QualifiedType` enum('Qualified','Non-Qualified','Both') NOT NULL DEFAULT 'Both',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSCountyId`),
  KEY `ProviderPlanRSCountyRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSCountyRefState_fk_idx` (`StateId`)
) ENGINE=innodb AUTO_INCREMENT=241 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSCounty`
--

LOCK TABLES `ProviderPlanRSCounty` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSCounty` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSCounty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSDependentLife`
--

DROP TABLE IF EXISTS `ProviderPlanRSDependentLife`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSDependentLife` (
  `ProviderPlanRSDependentLifeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanDependentLifeId` bigint(64) NOT NULL,
  `MonthlyCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSDependentLifeId`),
  KEY `ProviderPlanRSDependentLifeRefProviderPlanRatingSetDetail_f_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSDependentLifeRefDependentLife_fk_idx` (`PlanDependentLifeId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSDependentLife`
--

LOCK TABLES `ProviderPlanRSDependentLife` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSDependentLife` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSDependentLife` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSERContribution`
--

DROP TABLE IF EXISTS `ProviderPlanRSERContribution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSERContribution` (
  `ProviderPlanRSERContributionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL COMMENT 'This is a Unique Key with a Unique Index',
  `PlanERContributionId` bigint(64) NOT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `Factor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `IsFactor` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSERContributionId`),
  KEY `ProviderPlanRSERContributionRefPlanERContribution_fk_idx` (`PlanERContributionId`),
  KEY `ProviderPlanRSERContributionRefProvPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSERContribution`
--

LOCK TABLES `ProviderPlanRSERContribution` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSERContribution` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSERContribution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSFactors`
--

DROP TABLE IF EXISTS `ProviderPlanRSFactors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSFactors` (
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL COMMENT 'This is a Unique Key with a Unique Index',
  `IsPlanOptions` tinyint(1) NOT NULL DEFAULT '0',
  `IsContribution` tinyint(1) NOT NULL DEFAULT '0',
  `IsOrthodontia` tinyint(1) NOT NULL DEFAULT '0',
  `IsTobaccoUse` tinyint(1) NOT NULL DEFAULT '0',
  `IsRxRiders` tinyint(1) DEFAULT '0',
  `IsZipCode` tinyint(1) NOT NULL DEFAULT '0',
  `IsCounty` tinyint(1) NOT NULL DEFAULT '0',
  `IsAssociation` tinyint(1) NOT NULL DEFAULT '0',
  `IsNetwork` tinyint(1) NOT NULL DEFAULT '0',
  `IsAgeBased` tinyint(1) NOT NULL DEFAULT '0',
  `IsSICCode` tinyint(1) NOT NULL DEFAULT '0',
  `IsADandD` tinyint(1) NOT NULL DEFAULT '0',
  `IsDependentLife` tinyint(1) NOT NULL DEFAULT '0',
  `IsChildRates` tinyint(1) NOT NULL DEFAULT '0',
  `IsChildrenMax` tinyint(1) NOT NULL DEFAULT '0',
  `IsRateStructure` tinyint(1) NOT NULL DEFAULT '0',
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  KEY `ProviderPlanRSFactorsRefRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSFactors`
--

LOCK TABLES `ProviderPlanRSFactors` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSFactors` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSFactors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSMedicareRate`
--

DROP TABLE IF EXISTS `ProviderPlanRSMedicareRate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSMedicareRate` (
  `ProviderPlanRSMedicareRateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `PlanTierNameValueId` bigint(64) DEFAULT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SmokerCost` decimal(10,2) DEFAULT NULL,
  `MaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `FemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseMaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SpouseFemaleCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `MaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `FemaleSmokerCost` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSMedicareRateId`),
  KEY `ProviderPlanRSAgeRateRefPlanTierNameValue_fk_idx` (`PlanTierNameValueId`),
  KEY `ProviderPlanRSAgeRateRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `ProviderPlanRSAgeRateRefProvPlanRatingSetDetail_f_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSMedicareRate`
--

LOCK TABLES `ProviderPlanRSMedicareRate` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSMedicareRate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSMedicareRate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSNetwork`
--

DROP TABLE IF EXISTS `ProviderPlanRSNetwork`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSNetwork` (
  `ProviderPlanRSNetworkId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanNetworkId` bigint(64) NOT NULL,
  `NetworkFactor` decimal(25,15) NOT NULL DEFAULT '1.000000000000000',
  `NetworkCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSNetworkId`),
  KEY `ProviderPlanRSNetworkRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSNetworkRefPlanNetworkId_fk_idx` (`PlanNetworkId`)
) ENGINE=innodb AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSNetwork`
--

LOCK TABLES `ProviderPlanRSNetwork` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSNetwork` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSNetwork` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSOption`
--

DROP TABLE IF EXISTS `ProviderPlanRSOption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSOption` (
  `ProviderPlanRSOptionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL COMMENT 'This is a Unique Key with a Unique Index',
  `PlanOptionId` bigint(64) NOT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `Factor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `IsFactor` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSOptionId`),
  KEY `ProviderPlanRSOptionRefPlanOption_fk_idx` (`PlanOptionId`),
  KEY `ProviderPlanRSOptionRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=79 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSOption`
--

LOCK TABLES `ProviderPlanRSOption` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSOption` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSOption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSOptionOverride`
--

DROP TABLE IF EXISTS `ProviderPlanRSOptionOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSOptionOverride` (
  `ProviderPlanRSOptionOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanOptionId` bigint(64) NOT NULL,
  `DomainPlanDetailNameId` bigint(64) NOT NULL,
  `Value1` varchar(100) DEFAULT NULL,
  `Value2` varchar(100) DEFAULT NULL,
  `Value3` varchar(100) DEFAULT NULL,
  `Value4` varchar(100) DEFAULT NULL,
  `SortValue` decimal(10,2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSOptionOverrideId`),
  KEY `ProviderPlanRSOptionOverrideRefRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSOptionOverrideRefDomainPlanDetail_fk_idx` (`DomainPlanDetailNameId`),
  KEY `ProviderPlanRSOptionOverrideRefRSPlanOption_fk_idx` (`PlanOptionId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSOptionOverride`
--

LOCK TABLES `ProviderPlanRSOptionOverride` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSOptionOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSOptionOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSOrthodontia`
--

DROP TABLE IF EXISTS `ProviderPlanRSOrthodontia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSOrthodontia` (
  `ProviderPlanRSOrthodontiaId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanOrthodontiaId` bigint(64) NOT NULL,
  `RateType` enum('Dollar Amount','Factor') NOT NULL DEFAULT 'Dollar Amount',
  `Apply` enum('Before Factors','After Factors') NOT NULL DEFAULT 'Before Factors',
  `MinimumEnrolled` int(11) NOT NULL DEFAULT '1',
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`ProviderPlanRSOrthodontiaId`),
  KEY `ProviderPlanRSOrthodontiaRefProvPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSOrhodontiaRefPlanOrthodontia_fk_idx` (`PlanOrthodontiaId`)
) ENGINE=innodb AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSOrthodontia`
--

LOCK TABLES `ProviderPlanRSOrthodontia` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSOrthodontia` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSOrthodontia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSOrthodontiaTier`
--

DROP TABLE IF EXISTS `ProviderPlanRSOrthodontiaTier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSOrthodontiaTier` (
  `ProviderPlanRSOrthodontiaTierId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRSOrthodontiaId` bigint(64) NOT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `Factor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `PlanTierNameValueId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`ProviderPlanRSOrthodontiaTierId`),
  KEY `ProviderPlanRSOrthodontiaTierRefProviderPlanRSOrthodontia_f_idx` (`ProviderPlanRSOrthodontiaId`),
  KEY `ProviderPlanRSOrthodontiaTierRefPlanTierNameValue_fk_idx` (`PlanTierNameValueId`)
) ENGINE=innodb AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSOrthodontiaTier`
--

LOCK TABLES `ProviderPlanRSOrthodontiaTier` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSOrthodontiaTier` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSOrthodontiaTier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSRateStructure`
--

DROP TABLE IF EXISTS `ProviderPlanRSRateStructure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSRateStructure` (
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL COMMENT 'This is a Unique Key with a Unique Index',
  `IsCostBasedOnTier` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForGender` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForSpouse` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForSmoker` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForBenefitPeriod` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForEliminationPeriod` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostForIndustry` tinyint(1) NOT NULL DEFAULT '0',
  `IsCostBasedOnNumberOfChildren` tinyint(1) NOT NULL DEFAULT '0',
  `MaxNumberOfChildren` int(11) NOT NULL DEFAULT '0',
  `IsMedicare` tinyint(1) NOT NULL DEFAULT '0',
  `RatesBasedOn` enum('1000','100','10','Monthly Cost') NOT NULL DEFAULT 'Monthly Cost',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSRateStructureRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSRateStructure`
--

LOCK TABLES `ProviderPlanRSRateStructure` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSRateStructure` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSRateStructure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSRxRider`
--

DROP TABLE IF EXISTS `ProviderPlanRSRxRider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSRxRider` (
  `ProviderPlanRSRxRiderId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `PlanRxRiderId` bigint(64) NOT NULL,
  `RateType` enum('Dollar Amount','Factor') NOT NULL DEFAULT 'Dollar Amount',
  `Apply` enum('Before Factors','After Factors') NOT NULL DEFAULT 'Before Factors',
  `MinimumEnrolled` int(11) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSRxRiderId`),
  KEY `ProviderPlanRSRxRiderRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSRxRiderRefPlanRxRider_fk_idx` (`PlanRxRiderId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSRxRider`
--

LOCK TABLES `ProviderPlanRSRxRider` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSRxRider` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSRxRider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSRxTier`
--

DROP TABLE IF EXISTS `ProviderPlanRSRxTier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSRxTier` (
  `ProviderPlanRSRxTierId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRSRxRiderId` bigint(64) NOT NULL,
  `PlanTierNameValueId` bigint(64) NOT NULL,
  `Cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `Factor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSRxTierId`),
  KEY `ProviderPlanRSRXTierRefProviderPlanRSRXRider_fk_idx` (`ProviderPlanRSRxRiderId`),
  KEY `ProviderPlanRSRXTierRefPlanTierValue_fk_idx` (`PlanTierNameValueId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSRxTier`
--

LOCK TABLES `ProviderPlanRSRxTier` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSRxTier` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSRxTier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSSicCode`
--

DROP TABLE IF EXISTS `ProviderPlanRSSicCode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSSicCode` (
  `ProviderPlanRSSicCodeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `SicCodeValues` varchar(2000) DEFAULT NULL,
  `NumberOfDigits` int(11) NOT NULL DEFAULT '3',
  `SicCodeFactor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `SicCodeCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSSicCodeId`),
  KEY `ProviderPlanRSSicCodeRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSSicCode`
--

LOCK TABLES `ProviderPlanRSSicCode` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSSicCode` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSSicCode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSTobaccoUse`
--

DROP TABLE IF EXISTS `ProviderPlanRSTobaccoUse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSTobaccoUse` (
  `ProviderPlanRSTobaccoUseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `BeginAge` int(11) NOT NULL,
  `EndAge` int(11) NOT NULL,
  `AgeCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `AgeFactor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  PRIMARY KEY (`ProviderPlanRSTobaccoUseId`),
  KEY `ProviderPlanRSTobaccoUseRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSTobaccoUse`
--

LOCK TABLES `ProviderPlanRSTobaccoUse` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSTobaccoUse` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSTobaccoUse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRSZipCode`
--

DROP TABLE IF EXISTS `ProviderPlanRSZipCode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRSZipCode` (
  `ProviderPlanRSZipCodeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `StateId` bigint(64) NOT NULL,
  `ZipCodeValues` varchar(2000) DEFAULT NULL,
  `QualifiedType` enum('Qualified','Non-Qualified','Both') NOT NULL DEFAULT 'Both',
  `NumberOfZipCodeDigits` int(11) NOT NULL DEFAULT '5',
  `ZipCodeCost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `ZipCodeFactor` decimal(10,6) NOT NULL DEFAULT '1.000000',
  `IsFactorBased` tinyint(1) NOT NULL DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRSZipCodeId`),
  KEY `ProviderPlanRSZipCodeRefProviderPlanRatingSetDetailId_fk_idx` (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRSZipCodeRefState_fk_idx` (`StateId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRSZipCode`
--

LOCK TABLES `ProviderPlanRSZipCode` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRSZipCode` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRSZipCode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRatingSet`
--

DROP TABLE IF EXISTS `ProviderPlanRatingSet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRatingSet` (
  `ProviderPlanRatingSetId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `ProviderPlanSetName` varchar(100) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRatingSetId`),
  KEY `ProviderPlanRatingSetRefDomainId_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRatingSet`
--

LOCK TABLES `ProviderPlanRatingSet` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRatingSet` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRatingSet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRatingSetDetail`
--

DROP TABLE IF EXISTS `ProviderPlanRatingSetDetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRatingSetDetail` (
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanRatingSetId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `ProviderLineOfCoverageId` bigint(64) NOT NULL,
  `PlanTypeNameId` bigint(64) DEFAULT NULL,
  `PlanMarketSizeId` bigint(64) DEFAULT NULL,
  `PlanTierNameId` bigint(64) DEFAULT NULL,
  `IsIndividual` tinyint(1) NOT NULL DEFAULT '0',
  `IsQualified` tinyint(1) NOT NULL DEFAULT '0',
  `IsCustomRate` tinyint(1) NOT NULL DEFAULT '0',
  `RateType` enum('Composite','Age Banded','Base Rates') NOT NULL,
  `StartDate` date NOT NULL,
  `StopDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRatingSetDetailId`),
  KEY `ProviderPlanRatingSetDetailRefPlanTypeName_fk_idx` (`PlanTypeNameId`),
  KEY `ProviderPlanRatingSetDetailRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `ProviderPlanRatingSetDetailRefPlanMarketSize_fk_idx` (`PlanMarketSizeId`),
  KEY `ProviderPlanRatingSetDetailRefLineOfCoverage_fk_idx` (`LineOfCoverageId`),
  KEY `ProviderPlanRatingSetDetailRefPlanTierName_fk_idx` (`PlanTierNameId`),
  KEY `ProviderPlanRatingSetDetailRefProvLineOfCoverage_fx_idx` (`ProviderLineOfCoverageId`),
  KEY `ProviderPlanRatingSetDetailRefProviderPlanRatingSet_fk_idx` (`ProviderPlanRatingSetId`)
) ENGINE=innodb AUTO_INCREMENT=22 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRatingSetDetail`
--

LOCK TABLES `ProviderPlanRatingSetDetail` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRatingSetDetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRatingSetDetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanRatingSetList`
--

DROP TABLE IF EXISTS `ProviderPlanRatingSetList`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanRatingSetList` (
  `ProviderPlanRatingSetListId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `ProviderPlanRatingSetDetailId` bigint(64) NOT NULL,
  `BaseRate` decimal(25,15) NOT NULL DEFAULT '0.000000000000000',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanRatingSetListId`),
  KEY `ProviderPlanRatingSetListRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `ProviderPlanRatingSetListRefProviderPlanRatingSetDetail_fk_idx` (`ProviderPlanRatingSetDetailId`)
) ENGINE=innodb AUTO_INCREMENT=94 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanRatingSetList`
--

LOCK TABLES `ProviderPlanRatingSetList` WRITE;
/*!40000 ALTER TABLE `ProviderPlanRatingSetList` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanRatingSetList` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderPlanTemplate`
--

DROP TABLE IF EXISTS `ProviderPlanTemplate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderPlanTemplate` (
  `ProviderPlanTemplateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ProviderPlanId` bigint(64) NOT NULL,
  `DocumentName` varchar(100) NOT NULL,
  `ObjectName` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderPlanTemplateId`),
  KEY `ProviderPlanTemplateRefProviderPlan_fk_idx` (`ProviderPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderPlanTemplate`
--

LOCK TABLES `ProviderPlanTemplate` WRITE;
/*!40000 ALTER TABLE `ProviderPlanTemplate` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderPlanTemplate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ProviderQuestionnaire`
--

DROP TABLE IF EXISTS `ProviderQuestionnaire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ProviderQuestionnaire` (
  `ProviderQuestionnaireId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `QuestionNumber` int(11) NOT NULL,
  `Question` varchar(2000) NOT NULL,
  `QuestionTarget` enum('Agency','Producer') NOT NULL DEFAULT 'Agency',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ProviderQuestionnaireId`),
  KEY `ProviderQuestionnaireRefDomain_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ProviderQuestionnaire`
--

LOCK TABLES `ProviderQuestionnaire` WRITE;
/*!40000 ALTER TABLE `ProviderQuestionnaire` DISABLE KEYS */;
/*!40000 ALTER TABLE `ProviderQuestionnaire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuote`
--

DROP TABLE IF EXISTS `PublicQuote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuote` (
  `PublicQuoteId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `QuoteDisplayName` varchar(100) DEFAULT NULL,
  `IsIndividualQuote` tinyint(1) NOT NULL DEFAULT '0',
  `QuoteDate` date NOT NULL,
  `SpecialEnrollmentDate` date DEFAULT NULL,
  `ProducerName` varchar(100) DEFAULT NULL,
  `NPN` varchar(100) DEFAULT NULL,
  `ProducerWhoQuotedUserId` bigint(64) DEFAULT NULL,
  `SicCode` varchar(100) DEFAULT NULL,
  `LifePhoneNumber` varchar(100) DEFAULT NULL,
  `LifeCallAvailableStart` varchar(100) DEFAULT NULL,
  `LifeCallAvailableStop` varchar(100) DEFAULT NULL,
  `IndividualAnnualIncome` decimal(10,2) DEFAULT NULL,
  `IsEmployeeCoverageAvailable` tinyint(1) NOT NULL DEFAULT '0',
  `TotalAnnualEmployeeWages` decimal(10,2) DEFAULT NULL,
  `TotalHoursWorkedByEmployee` int(11) DEFAULT NULL,
  `TotalAnnualMedicalPremiumPaid` decimal(10,2) DEFAULT NULL,
  `IsCompanyTaxExempt` tinyint(1) NOT NULL DEFAULT '0',
  `CalculatedResult` decimal(12,6) DEFAULT NULL,
  `TotalAPTCAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `MembersInHousehold` int(11) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteId`),
  KEY `PublicQuoteRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=114 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuote`
--

LOCK TABLES `PublicQuote` WRITE;
/*!40000 ALTER TABLE `PublicQuote` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteBeneficiary`
--

DROP TABLE IF EXISTS `PublicQuoteBeneficiary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteBeneficiary` (
  `PublicQuoteBeneficiaryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuotePlanId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) DEFAULT NULL,
  `PercentageAssigned` smallint(16) NOT NULL,
  `Relationship` tinytext,
  `BeneficiaryType` enum('Primary','Contingent') NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteBeneficiaryId`),
  KEY `PublicQuoteBeneficiaryRefPublicQuotePlan_fk_idx` (`PublicQuotePlanId`),
  KEY `PublicQuoteBeneficiaryRefContactDetail_fk_idx` (`ContactDetailId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteBeneficiary`
--

LOCK TABLES `PublicQuoteBeneficiary` WRITE;
/*!40000 ALTER TABLE `PublicQuoteBeneficiary` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteBeneficiary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteDomainInfo`
--

DROP TABLE IF EXISTS `PublicQuoteDomainInfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteDomainInfo` (
  `PublicQuoteDomainInfoId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `DomainId` bigint(64) DEFAULT NULL,
  `UserId` bigint(64) DEFAULT NULL,
  `CompanyName` varchar(100) DEFAULT NULL,
  `NumberOfEmployees` int(11) DEFAULT NULL,
  `ZipCode` varchar(10) DEFAULT NULL,
  `County` varchar(100) DEFAULT NULL,
  `ContactFirstName` varchar(45) DEFAULT NULL,
  `ContactLastName` varchar(45) DEFAULT NULL,
  `ContactEmailAddress` varchar(45) DEFAULT NULL,
  `ContactPhone` varchar(45) DEFAULT NULL,
  `ObjectName` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteDomainInfoId`),
  KEY `PublicQuoteDomainInfoRefPublicQuote_fk_idx` (`PublicQuoteId`),
  KEY `PublicQuoteDomainInfoRefDomain_fk_idx` (`DomainId`),
  KEY `PublicQuoteDomainInfoRefUser_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteDomainInfo`
--

LOCK TABLES `PublicQuoteDomainInfo` WRITE;
/*!40000 ALTER TABLE `PublicQuoteDomainInfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteDomainInfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteHousehold`
--

DROP TABLE IF EXISTS `PublicQuoteHousehold`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteHousehold` (
  `PublicQuoteHouseholdId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `MemberType` enum('Applicant','Spouse','Dependent') NOT NULL DEFAULT 'Applicant',
  `MemberAge` int(11) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteHouseholdId`),
  KEY `PublicQuoteHouseholdRefPublicQuote_idx` (`PublicQuoteId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteHousehold`
--

LOCK TABLES `PublicQuoteHousehold` WRITE;
/*!40000 ALTER TABLE `PublicQuoteHousehold` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteHousehold` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteLineOfCoverage`
--

DROP TABLE IF EXISTS `PublicQuoteLineOfCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteLineOfCoverage` (
  `PublicQuoteLineOfCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `SavedFilter` varchar(1000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteLineOfCoverageId`),
  KEY `PublicQuoteLineOfCoverageRefLineOfCoverage_fk_idx` (`LineOfCoverageId`),
  KEY `PublicQuoteLineOfCoverageRefPublicQuote_fk_idx` (`PublicQuoteId`)
) ENGINE=innodb AUTO_INCREMENT=264 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteLineOfCoverage`
--

LOCK TABLES `PublicQuoteLineOfCoverage` WRITE;
/*!40000 ALTER TABLE `PublicQuoteLineOfCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteLineOfCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteOtherCoverage`
--

DROP TABLE IF EXISTS `PublicQuoteOtherCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteOtherCoverage` (
  `PublicQuoteOtherCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuotePlanId` bigint(64) NOT NULL,
  `PublicQuoteUserDependentCensusId` bigint(64) DEFAULT NULL,
  `OtherCoverageType` enum('Group Medical','Medicare','Medicaid/CHIP','Individual Medical','Retiree Coverage','COBRA','Other') CHARACTER SET latin1 DEFAULT NULL,
  `MedicareReason` enum('Age','ESRD','Disability','Other') DEFAULT NULL,
  `MedicareOtherReason` varchar(200) DEFAULT NULL,
  `MedicareClaimNumber` varchar(50) DEFAULT NULL,
  `MedicarePartAEffectiveDate` date DEFAULT NULL,
  `MedicarePartBEffectiveDate` date DEFAULT NULL,
  `InsuranceCompany` varchar(100) DEFAULT NULL,
  `PolicyNumber` varchar(50) DEFAULT NULL,
  `MemberId` varchar(100) DEFAULT NULL,
  `EffectiveDate` date DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `MedicaidIdNumber` varchar(50) DEFAULT NULL,
  `MedicaidEffectiveDate` date DEFAULT NULL,
  `MedicaidState` varchar(2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteOtherCoverageId`),
  KEY `PublicQuoteOtherRefPublicQuotePlan_fk_idx` (`PublicQuotePlanId`),
  KEY `PublicQuoteOtherCoverageRefPublicQuoteUserDependentCensus_fk_idx` (`PublicQuoteUserDependentCensusId`)
) ENGINE=innodb AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteOtherCoverage`
--

LOCK TABLES `PublicQuoteOtherCoverage` WRITE;
/*!40000 ALTER TABLE `PublicQuoteOtherCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteOtherCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuotePlan`
--

DROP TABLE IF EXISTS `PublicQuotePlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuotePlan` (
  `PublicQuotePlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `IsApplicantCovered` tinyint(1) NOT NULL DEFAULT '1',
  `PlanNetworkId` bigint(64) DEFAULT NULL,
  `PlanAssociationId` bigint(64) DEFAULT NULL,
  `PlanERContributionId` bigint(64) DEFAULT NULL,
  `PlanOrthodontiaId` bigint(64) DEFAULT NULL,
  `PlanRxRiderId` bigint(64) DEFAULT NULL,
  `PlanDependentLifeId` bigint(64) DEFAULT NULL,
  `IncludeADandD` tinyint(1) NOT NULL DEFAULT '0',
  `PlanEliminationPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitMaxId` bigint(64) DEFAULT NULL,
  `PlanPercentageOfSalaryId` bigint(64) DEFAULT NULL,
  `PlanCost` decimal(10,2) DEFAULT NULL,
  `AppliedAPTCAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `DentistCode` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuotePlanId`),
  KEY `PublicQuotePlanRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `PublicQuotePlanRefLineOfCoverageId_idx` (`LineOfCoverageId`),
  KEY `PublicQuotePlanRefPublicQuote_fk_idx` (`PublicQuoteId`)
) ENGINE=innodb AUTO_INCREMENT=53 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuotePlan`
--

LOCK TABLES `PublicQuotePlan` WRITE;
/*!40000 ALTER TABLE `PublicQuotePlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuotePlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuotePlanDependent`
--

DROP TABLE IF EXISTS `PublicQuotePlanDependent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuotePlanDependent` (
  `PublicQuotePlanDependentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuotePlanId` bigint(64) NOT NULL,
  `PublicQuoteUserDependentCensusId` bigint(64) NOT NULL,
  `DentistCode` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuotePlanDependentId`),
  KEY `PublicQuotePlanDependentRefDependentCensus_fk_idx` (`PublicQuoteUserDependentCensusId`),
  KEY `PublicQuotePlanDependentRefPublicQuotePlan_fk_idx` (`PublicQuotePlanId`)
) ENGINE=innodb AUTO_INCREMENT=30 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuotePlanDependent`
--

LOCK TABLES `PublicQuotePlanDependent` WRITE;
/*!40000 ALTER TABLE `PublicQuotePlanDependent` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuotePlanDependent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuotePlanPlanOption`
--

DROP TABLE IF EXISTS `PublicQuotePlanPlanOption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuotePlanPlanOption` (
  `PublicQuotePlanPlanOptionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuotePlanId` bigint(64) NOT NULL,
  `PlanOptionId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PublicQuotePlanPlanOptionId`),
  KEY `PublicQuotePlanPlanOptionRefPlanOption_fk_idx` (`PlanOptionId`),
  KEY `PublicQuotePlanPlanOptionRefPublicQuotePlan_fk_idx` (`PublicQuotePlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuotePlanPlanOption`
--

LOCK TABLES `PublicQuotePlanPlanOption` WRITE;
/*!40000 ALTER TABLE `PublicQuotePlanPlanOption` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuotePlanPlanOption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuotePlanSuggestion`
--

DROP TABLE IF EXISTS `PublicQuotePlanSuggestion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuotePlanSuggestion` (
  `PublicQuotePlanSuggestionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `IsApplicantCovered` tinyint(1) NOT NULL DEFAULT '1',
  `PlanNetworkId` bigint(64) DEFAULT NULL,
  `PlanAssociationId` bigint(64) DEFAULT NULL,
  `PlanERContributionId` bigint(64) DEFAULT NULL,
  `PlanOrthodontiaId` bigint(64) DEFAULT NULL,
  `PlanRxRiderId` bigint(64) DEFAULT NULL,
  `PlanDependentLifeId` bigint(64) DEFAULT NULL,
  `IncludeADandD` tinyint(1) NOT NULL DEFAULT '0',
  `PlanEliminationPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitMaxId` bigint(64) DEFAULT NULL,
  `PlanPercentageOfSalaryId` bigint(64) DEFAULT NULL,
  `PlanCost` decimal(10,2) DEFAULT NULL,
  `AppliedAPTCAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuotePlanSuggestionId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuotePlanSuggestion`
--

LOCK TABLES `PublicQuotePlanSuggestion` WRITE;
/*!40000 ALTER TABLE `PublicQuotePlanSuggestion` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuotePlanSuggestion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteQuestionnaire`
--

DROP TABLE IF EXISTS `PublicQuoteQuestionnaire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteQuestionnaire` (
  `PublicQuoteQuestionnaireId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `QuestionName` varchar(2000) NOT NULL,
  `SortKey` int(11) NOT NULL,
  `QuestionType` enum('Boolean','Dependents Boollean','Input','Textarea','Dropdown') NOT NULL DEFAULT 'Input',
  `DefaultValue` tinyint(1) NOT NULL DEFAULT '1',
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteQuestionnaireId`),
  KEY `PulicQuoteQuestionnaireRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteQuestionnaire`
--

LOCK TABLES `PublicQuoteQuestionnaire` WRITE;
/*!40000 ALTER TABLE `PublicQuoteQuestionnaire` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteQuestionnaire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteQuestionnaireResponse`
--

DROP TABLE IF EXISTS `PublicQuoteQuestionnaireResponse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteQuestionnaireResponse` (
  `PublicQuoteQuestionnaireResponseId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteQuestionnaireId` bigint(64) NOT NULL,
  `PublicQuoteId` bigint(64) NOT NULL,
  `PublicQuoteUserDependentCensusId` bigint(64) DEFAULT NULL,
  `BooleanResponse` varchar(45) DEFAULT NULL,
  `InputResponse` varchar(2000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteQuestionnaireResponseId`),
  KEY `ProviderQuoteQuestionnaireResponseRefPubliQuote_fk_idx` (`PublicQuoteId`),
  KEY `ProviderQuoteQuestionnaireResponseRefQuoteQuestionnaire_fk_idx` (`PublicQuoteQuestionnaireId`),
  KEY `PublicQuoteQuestionnaireResponseRefQuoteDependents_fk_idx` (`PublicQuoteUserDependentCensusId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteQuestionnaireResponse`
--

LOCK TABLES `PublicQuoteQuestionnaireResponse` WRITE;
/*!40000 ALTER TABLE `PublicQuoteQuestionnaireResponse` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteQuestionnaireResponse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteUserCensus`
--

DROP TABLE IF EXISTS `PublicQuoteUserCensus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteUserCensus` (
  `PublicQuoteUserCensusId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) NOT NULL,
  `UserId` bigint(64) DEFAULT NULL,
  `FFMInsuranceApplicantId` bigint(64) DEFAULT NULL,
  `FirstName` varchar(100) DEFAULT NULL,
  `MiddleName` varchar(100) DEFAULT NULL,
  `LastName` varchar(100) DEFAULT NULL,
  `Gender` enum('Male','Female') DEFAULT 'Male',
  `BirthDate` datetime NOT NULL,
  `Smoker` tinyint(1) NOT NULL DEFAULT '0',
  `ZipCode` varchar(10) DEFAULT NULL,
  `County` varchar(100) NOT NULL,
  `PhoneNumber` varchar(45) DEFAULT NULL,
  `UserEmailAddress` varchar(200) DEFAULT NULL,
  `Salary` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SalaryType` enum('Hourly Rate','Weekly Salary','Monthly Salary','Annual Salary') DEFAULT NULL,
  `IsMedicare` tinyint(1) NOT NULL DEFAULT '0',
  `HouseHoldIncome` decimal(10,2) NOT NULL DEFAULT '0.00',
  `ObjectName` varchar(200) DEFAULT NULL,
  `APTCAmount` decimal(10,2) DEFAULT NULL,
  `APTCElectionType` enum('All of it','None of it','Dollar Amount') NOT NULL DEFAULT 'All of it',
  `PrimaryTaxFilerId` bigint(64) DEFAULT NULL COMMENT 'Either the PublicQuoteUserCensusId or the PublicQuoteUserDependentCensusId depending on PrimaryTaxFilerIsDependent setting',
  `PrimaryTaxFilerIsDependent` tinyint(1) NOT NULL DEFAULT '0',
  `MustRedirectForChanges` tinyint(1) NOT NULL DEFAULT '0',
  `CSRLevelApplicable` char(2) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteUserCensusId`),
  KEY `PublicQuoteUserCensusRefUserId_fk_idx` (`UserId`),
  KEY `PublicQuoteUserCensusRefPublicQuote_fk_idx` (`PublicQuoteId`),
  KEY `PublicQuoteUserCensusRefFFMInsuranceApplicant_idx` (`FFMInsuranceApplicantId`)
) ENGINE=innodb AUTO_INCREMENT=164 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteUserCensus`
--

LOCK TABLES `PublicQuoteUserCensus` WRITE;
/*!40000 ALTER TABLE `PublicQuoteUserCensus` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteUserCensus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `PublicQuoteUserDependentCensus`
--

DROP TABLE IF EXISTS `PublicQuoteUserDependentCensus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `PublicQuoteUserDependentCensus` (
  `PublicQuoteUserDependentCensusId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteUserCensusId` bigint(64) NOT NULL,
  `FirstName` varchar(100) DEFAULT NULL,
  `FFMInsuranceApplicantId` bigint(64) DEFAULT NULL,
  `LastName` varchar(100) DEFAULT NULL,
  `MiddleName` char(100) DEFAULT NULL,
  `Suffix` varchar(10) DEFAULT NULL,
  `Gender` enum('Male','Female') DEFAULT 'Male',
  `BirthDate` datetime NOT NULL,
  `DependentType` enum('Spouse','Niece','Nephew','Son','Daughter','Other') NOT NULL DEFAULT 'Spouse',
  `Smoker` tinyint(1) NOT NULL DEFAULT '0',
  `LastDateSmoking` date DEFAULT NULL,
  `LivesAtDifferentAddress` tinyint(1) NOT NULL DEFAULT '0',
  `AddressLine1` varchar(100) DEFAULT NULL,
  `AddressLine2` varchar(100) DEFAULT NULL,
  `ZipCode` varchar(10) DEFAULT NULL,
  `City` varchar(100) DEFAULT NULL,
  `County` varchar(100) NOT NULL,
  `State` char(2) DEFAULT NULL,
  `IsMedicare` tinyint(1) NOT NULL DEFAULT '0',
  `IsFullTimeStudent` tinyint(1) DEFAULT '0',
  `SchoolName` varchar(200) DEFAULT NULL,
  `IsDisabled` tinyint(1) NOT NULL DEFAULT '0',
  `SSN` varchar(108) DEFAULT NULL,
  `LastFourSSN` varchar(4) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`PublicQuoteUserDependentCensusId`),
  KEY `PublicQuoteUserDependentCensusRefQuoteUserCensus_fk_idx` (`PublicQuoteUserCensusId`),
  KEY `PublicQuoteUserDependentCensusRefFFMInsuranceApplicant_fk_idx` (`FFMInsuranceApplicantId`)
) ENGINE=innodb AUTO_INCREMENT=62 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `PublicQuoteUserDependentCensus`
--

LOCK TABLES `PublicQuoteUserDependentCensus` WRITE;
/*!40000 ALTER TABLE `PublicQuoteUserDependentCensus` DISABLE KEYS */;
/*!40000 ALTER TABLE `PublicQuoteUserDependentCensus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuoteDomainInfo`
--

DROP TABLE IF EXISTS `QuoteDomainInfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuoteDomainInfo` (
  `QuoteDomainInfoId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BrokerQuoteId` bigint(64) NOT NULL,
  `DomainId` bigint(64) DEFAULT NULL,
  `CompanyName` varchar(100) DEFAULT NULL,
  `NumberOfEmployees` int(11) DEFAULT NULL,
  `ZipCode` varchar(10) DEFAULT NULL,
  `County` varchar(100) DEFAULT NULL,
  `ContactFirstName` varchar(45) DEFAULT NULL,
  `ContactLastName` varchar(45) DEFAULT NULL,
  `ContactEmailAddress` varchar(45) DEFAULT NULL,
  `ContactPhone` varchar(45) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`QuoteDomainInfoId`),
  UNIQUE KEY `QuoteDomainInfoBrokerQuoteId_ix_uq` (`BrokerQuoteId`),
  KEY `QuoteDomainInfoRefBrokerQuote_fk_idx` (`BrokerQuoteId`),
  KEY `QuoteDomainInfoRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuoteDomainInfo`
--

LOCK TABLES `QuoteDomainInfo` WRITE;
/*!40000 ALTER TABLE `QuoteDomainInfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuoteDomainInfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuoteLineOfCoverage`
--

DROP TABLE IF EXISTS `QuoteLineOfCoverage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuoteLineOfCoverage` (
  `QuoteLineOfCoverageId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BrokerQuoteId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`QuoteLineOfCoverageId`),
  KEY `QuoteLineOfCoverageRefLineOfCoverage_fk_idx` (`LineOfCoverageId`),
  KEY `QuoteLineOfCoverageRefBrokerQuote_fk_idx` (`BrokerQuoteId`)
) ENGINE=innodb AUTO_INCREMENT=62 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuoteLineOfCoverage`
--

LOCK TABLES `QuoteLineOfCoverage` WRITE;
/*!40000 ALTER TABLE `QuoteLineOfCoverage` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuoteLineOfCoverage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuotePlan`
--

DROP TABLE IF EXISTS `QuotePlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuotePlan` (
  `QuotePlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BrokerQuoteId` bigint(64) NOT NULL,
  `InsuranceCompanyDomainId` bigint(64) NOT NULL,
  `LineOfCoverageId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) NOT NULL,
  `IsApplicantCovered` tinyint(1) NOT NULL DEFAULT '1',
  `PlanNetworkId` bigint(64) DEFAULT NULL,
  `PlanAssociationId` bigint(64) DEFAULT NULL,
  `PlanERContributionId` bigint(64) DEFAULT NULL,
  `PlanOrthodontiaId` bigint(64) DEFAULT NULL,
  `PlanRxRiderId` bigint(64) DEFAULT NULL,
  `PlanDependentLifeId` bigint(64) DEFAULT NULL,
  `IncludeADandD` tinyint(1) NOT NULL DEFAULT '0',
  `PlanEliminationPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitPeriodId` bigint(64) DEFAULT NULL,
  `PlanBenefitMaxId` bigint(64) DEFAULT NULL,
  `PlanPercentageOfSalaryId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`QuotePlanId`),
  KEY `QuotePlanRefBrokerQuote_fk_idx` (`BrokerQuoteId`),
  KEY `QuotePlanRefProviderPlan_fk_idx` (`ProviderPlanId`),
  KEY `QuotePlanRefLineOfCoverageId_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=68 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuotePlan`
--

LOCK TABLES `QuotePlan` WRITE;
/*!40000 ALTER TABLE `QuotePlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuotePlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuotePlanPlanOption`
--

DROP TABLE IF EXISTS `QuotePlanPlanOption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuotePlanPlanOption` (
  `QuotePlanPlanOptionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `QuotePlanId` bigint(64) NOT NULL,
  `PlanOptionId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`QuotePlanPlanOptionId`),
  KEY `QuotePlanPlanOptionRefQuotePlan_fk_idx` (`QuotePlanId`),
  KEY `QuotePlanPlanOptionRefPlanOption_fk_idx` (`PlanOptionId`)
) ENGINE=innodb AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuotePlanPlanOption`
--

LOCK TABLES `QuotePlanPlanOption` WRITE;
/*!40000 ALTER TABLE `QuotePlanPlanOption` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuotePlanPlanOption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuoteProvider`
--

DROP TABLE IF EXISTS `QuoteProvider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuoteProvider` (
  `QuoteProviderId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BrokerQuoteId` bigint(64) DEFAULT NULL,
  `InsuranceCompanyDomainId` bigint(64) DEFAULT NULL,
  `LineOfCoverageId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`QuoteProviderId`),
  KEY `QuoteProviderRefDomain_fk_idx` (`InsuranceCompanyDomainId`),
  KEY `QuoteProviderRefBrokerQuote_fk_idx` (`BrokerQuoteId`),
  KEY `QuoteProviderRefLineOfCoverage_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb AUTO_INCREMENT=37 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuoteProvider`
--

LOCK TABLES `QuoteProvider` WRITE;
/*!40000 ALTER TABLE `QuoteProvider` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuoteProvider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuoteUserCensus`
--

DROP TABLE IF EXISTS `QuoteUserCensus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuoteUserCensus` (
  `QuoteUserCensusId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BrokerQuoteId` bigint(64) NOT NULL,
  `UserId` bigint(64) DEFAULT NULL,
  `FirstName` varchar(100) DEFAULT NULL,
  `LastName` varchar(100) DEFAULT NULL,
  `Gender` enum('Male','Female') DEFAULT 'Male',
  `BirthDate` datetime NOT NULL,
  `Smoker` tinyint(1) NOT NULL DEFAULT '0',
  `ZipCode` varchar(10) DEFAULT NULL,
  `County` varchar(100) NOT NULL,
  `PhoneNumber` varchar(45) DEFAULT NULL,
  `UserEmailAddress` varchar(200) DEFAULT NULL,
  `Salary` decimal(10,2) NOT NULL DEFAULT '0.00',
  `SalaryType` enum('Hourly Rate','Weekly Salary','Monthly Salary','Annual Salary') DEFAULT NULL,
  `IsMedicare` tinyint(1) NOT NULL DEFAULT '0',
  `HouseHoldIncome` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`QuoteUserCensusId`),
  KEY `BrokerUserCensusRefBrokerQuote_fk_idx` (`BrokerQuoteId`),
  KEY `QuoteUserCensusRefUserId_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuoteUserCensus`
--

LOCK TABLES `QuoteUserCensus` WRITE;
/*!40000 ALTER TABLE `QuoteUserCensus` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuoteUserCensus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `QuoteUserDependentCensus`
--

DROP TABLE IF EXISTS `QuoteUserDependentCensus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `QuoteUserDependentCensus` (
  `QuoteUserDependentCensusId` bigint(64) NOT NULL AUTO_INCREMENT,
  `QuoteUserCensusId` bigint(64) NOT NULL,
  `FirstName` varchar(100) DEFAULT NULL,
  `LastName` varchar(100) DEFAULT NULL,
  `Gender` enum('Male','Female') DEFAULT 'Male',
  `BirthDate` datetime NOT NULL,
  `DependentType` enum('Spouse','Niece','Nephew','Son','Daughter','Other') NOT NULL DEFAULT 'Spouse',
  `Smoker` tinyint(1) NOT NULL DEFAULT '0',
  `ZipCode` varchar(10) DEFAULT NULL,
  `County` varchar(100) NOT NULL,
  `IsMedicare` tinyint(1) NOT NULL DEFAULT '0',
  `IsFullTimeStudent` tinyint(1) DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CreatedByUserId` bigint(64) NOT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`QuoteUserDependentCensusId`),
  KEY `EmployerUserDependentQuoteRefEmployerUserQuote_Fk_idx` (`QuoteUserCensusId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `QuoteUserDependentCensus`
--

LOCK TABLES `QuoteUserDependentCensus` WRITE;
/*!40000 ALTER TABLE `QuoteUserDependentCensus` DISABLE KEYS */;
/*!40000 ALTER TABLE `QuoteUserDependentCensus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RateTypeName`
--

DROP TABLE IF EXISTS `RateTypeName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RateTypeName` (
  `RateTypeNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RateTypeName` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RateTypeNameId`)
) ENGINE=innodb AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RateTypeName`
--

LOCK TABLES `RateTypeName` WRITE;
/*!40000 ALTER TABLE `RateTypeName` DISABLE KEYS */;
INSERT INTO `RateTypeName` VALUES (4,'Child >26',1,'2013-07-03 05:45:16',NULL,NULL),(1,'Employee',1,'2013-07-03 05:45:04',NULL,NULL),(2,'Spouse',1,'2013-07-03 05:45:04',NULL,NULL),(3,'Child <26',1,'2013-07-03 05:45:16',NULL,NULL);
/*!40000 ALTER TABLE `RateTypeName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RatingArea`
--

DROP TABLE IF EXISTS `RatingArea`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RatingArea` (
  `RatingAreaId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RatingAreaCode` varchar(20) NOT NULL,
  `County` varchar(50) NOT NULL,
  `StateAbbreviation` char(2) NOT NULL,
  `Year` int(11) NOT NULL,
  `SecondLowestPlanAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RatingAreaId`),
  UNIQUE KEY `RatingAreaCountyStateCodeYear_uq` (`County`,`StateAbbreviation`,`Year`),
  KEY `RatingAreaStateRatingAreaCodeCountyYear` (`StateAbbreviation`,`RatingAreaCode`,`County`,`Year`)
) ENGINE=innodb AUTO_INCREMENT=1145 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RatingArea`
--

LOCK TABLES `RatingArea` WRITE;
/*!40000 ALTER TABLE `RatingArea` DISABLE KEYS */;
INSERT INTO `RatingArea` VALUES (208,'GA015','Clinch','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(284,'LA008','Caddo','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(360,'MI015','Roscommon','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(399,'MS005','Jackson','MS',2014,316.69,1,'2014-03-07 18:42:30',NULL,NULL),(12,'FL012','Columbia','FL',2014,217.12,1,'2014-03-07 18:42:27',NULL,NULL),(493,'NC006','Forsyth','NC',2014,241.72,1,'2014-03-07 18:42:30',NULL,NULL),(855,'TX026','Coleman','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(25,'FL025','Hendry','FL',2014,222.69,1,'2014-03-07 18:42:27',NULL,NULL),(550,'NC016','Hyde','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(295,'MI003','Saint Clair','MI',2014,207.69,1,'2014-03-07 18:42:29',NULL,NULL),(494,'NC006','Stokes','NC',2014,241.72,1,'2014-03-07 18:42:30',NULL,NULL),(286,'LA008','De Soto','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(380,'MS002','Lee','MS',2014,271.58,1,'2014-03-07 18:42:30',NULL,NULL),(833,'TX025','Wichita','TX',2014,215.86,1,'2014-03-07 18:42:32',NULL,NULL),(238,'LA003','Acadia','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(244,'LA003','Saint Mary','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(411,'MS006','Clarke','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(7,'FL007','Calhoun','FL',2014,225.25,1,'2014-03-07 18:42:27',NULL,NULL),(614,'OH011','Cuyahoga','OH',2014,194.46,1,'2014-03-07 18:42:31',NULL,NULL),(510,'NC010','Granville','NC',2014,239.79,1,'2014-03-07 18:42:30',NULL,NULL),(973,'TX026','Sabine','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(984,'TX026','Sterling','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(28,'FL028','Hillsborough','FL',2014,190.07,1,'2014-03-07 18:42:27',NULL,NULL),(69,'GA001','Calhoun','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(230,'LA001','Saint Bernard','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(470,'NC001','Swain','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(609,'OH010','Pike','OH',2014,280.90,1,'2014-03-07 18:42:31',NULL,NULL),(36,'FL036','Leon','FL',2014,229.59,1,'2014-03-07 18:42:27',NULL,NULL),(440,'MS006','Prentiss','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(1096,'VA012','Brunswick','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1123,'VA012','Middlesex','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(104,'GA003','Newton','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(712,'SC002','Aiken','SC',2014,243.29,1,'2014-03-07 18:42:32',NULL,NULL),(899,'TX026','Haskell','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(831,'TX025','Archer','TX',2014,215.86,1,'2014-03-07 18:42:32',NULL,NULL),(1062,'VA009','Isle of Wight','VA',2014,212.48,1,'2014-03-07 18:42:34',NULL,NULL),(85,'GA002','Madison','GA',2014,191.09,1,'2014-03-07 18:42:28',NULL,NULL),(181,'GA012','Jones','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(619,'OH012','Medina','OH',2014,204.39,1,'2014-03-07 18:42:31',NULL,NULL),(1038,'VA007','Cumberland','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1040,'VA007','Goochland','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(157,'GA010','Hall','GA',2014,230.97,1,'2014-03-07 18:42:28',NULL,NULL),(666,'PA003','Wayne','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(768,'TX003','Williamson','TX',2014,195.32,1,'2014-03-07 18:42:32',NULL,NULL),(54,'FL054','Putnam','FL',2014,253.11,1,'2014-03-07 18:42:28',NULL,NULL),(369,'MI016','Luce','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(1073,'VA009','York','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(1115,'VA012','King George','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(124,'GA005','Wilkes','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(156,'GA010','Habersham','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(253,'LA005','East Feliciana','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(294,'MI002','Oakland','MI',2014,175.33,1,'2014-03-07 18:42:29',NULL,NULL),(427,'MS006','Leake','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(161,'GA010','Stephens','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(396,'MS005','George','MS',2014,316.69,1,'2014-03-07 18:42:30',NULL,NULL),(949,'TX026','Montague','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(358,'MI015','Otsego','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(263,'LA006','Catahoula','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(813,'TX017','Ector','TX',2014,171.06,1,'2014-03-07 18:42:32',NULL,NULL),(1071,'VA009','Virginia Beach City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(86,'GA002','Morgan','GA',2014,242.90,1,'2014-03-07 18:42:28',NULL,NULL),(250,'LA004','Jefferson Davis','LA',2014,245.96,1,'2014-03-07 18:42:29',NULL,NULL),(321,'MI011','Allegan','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(366,'MI016','Houghton','MI',2014,261.47,1,'2014-03-07 18:42:29',NULL,NULL),(442,'MS006','Scott','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(129,'GA006','Glynn','GA',2014,318.41,1,'2014-03-07 18:42:28',NULL,NULL),(47,'FL047','Okeechobee','FL',2014,248.86,1,'2014-03-07 18:42:27',NULL,NULL),(487,'NC004','Union','NC',2014,239.84,1,'2014-03-07 18:42:30',NULL,NULL),(536,'NC014','Nash','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(730,'SC020','Fairfield','SC',2014,212.86,1,'2014-03-07 18:42:32',NULL,NULL),(122,'GA005','Taliaferro','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(279,'LA007','Tensas','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(939,'TX026','Martin','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(542,'NC015','Duplin','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(673,'PA004','Greene','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(4,'FL004','Bradford','FL',2014,191.19,1,'2014-03-07 18:42:27',NULL,NULL),(993,'TX026','Tyler','TX',2014,180.25,1,'2014-03-07 18:42:33',NULL,NULL),(214,'GA015','Grady','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(823,'TX019','Wilson','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(428,'MS006','Leflore','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(107,'GA003','Rockdale','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(569,'OH002','Van Wert','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(1023,'VA004','Rockingham','VA',2014,161.64,1,'2014-03-07 18:42:34',NULL,NULL),(821,'TX019','Kendall','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(581,'OH005','Adams','OH',2014,224.18,1,'2014-03-07 18:42:31',NULL,NULL),(277,'LA007','Ouachita','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(650,'PA001','Venango','PA',2014,184.57,1,'2014-03-07 18:42:31',NULL,NULL),(806,'TX013','Gregg','TX',2014,186.92,1,'2014-03-07 18:42:32',NULL,NULL),(1059,'VA009','Chesapeake City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(1077,'VA010','Fairfax','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(330,'MI012','Newaygo','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(901,'TX026','Henderson','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(287,'LA008','Natchitoches','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(457,'NC001','Buncombe','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(672,'PA004','Fayette','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(578,'OH004','Butler','OH',2014,186.61,1,'2014-03-07 18:42:31',NULL,NULL),(647,'PA001','Forest','PA',2014,184.57,1,'2014-03-07 18:42:31',NULL,NULL),(239,'LA003','Evangeline','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(323,'MI012','Ionia','MI',2014,217.44,1,'2014-03-07 18:42:29',NULL,NULL),(348,'MI015','Alcona','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(633,'OH016','Jefferson','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(24,'FL024','Hardee','FL',2014,257.72,1,'2014-03-07 18:42:27',NULL,NULL),(177,'GA012','Crawford','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(523,'NC012','Currituck','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(626,'OH014','Wayne','OH',2014,213.70,1,'2014-03-07 18:42:31',NULL,NULL),(201,'GA014','Liberty','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(398,'MS005','Harrison','MS',2014,316.69,1,'2014-03-07 18:42:30',NULL,NULL),(270,'LA007','Caldwell','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(896,'TX026','Hardeman','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(922,'TX026','Kinney','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(938,'TX026','Marion','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(933,'TX026','Live Oak','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(957,'TX026','Ochittree','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(477,'NC002','Iredell','NC',2014,244.95,1,'2014-03-07 18:42:30',NULL,NULL),(787,'TX008','Parker','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(40,'FL040','Manatee','FL',2014,216.88,1,'2014-03-07 18:42:27',NULL,NULL),(223,'GA016','Baldwin','GA',2014,259.63,1,'2014-03-07 18:42:29',NULL,NULL),(479,'NC003','Ashe','NC',2014,259.91,1,'2014-03-07 18:42:30',NULL,NULL),(517,'NC011','Lee','NC',2014,218.70,1,'2014-03-07 18:42:30',NULL,NULL),(526,'NC012','Hertford','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(966,'TX026','Reagan','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(265,'LA006','Grant','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(16,'FL016','Escambia','FL',2014,208.16,1,'2014-03-07 18:42:27',NULL,NULL),(1025,'VA005','Scott','VA',2014,165.41,1,'2014-03-07 18:42:34',NULL,NULL),(273,'LA007','Jackson','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(281,'LA007','West Carroll','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(530,'NC012','Perquimans','NC',2014,228.04,1,'2014-03-07 18:42:31',NULL,NULL),(863,'TX026','Crockett','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1029,'VA006','Bedford','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(417,'MS006','Holmes','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(482,'NC004','Anson','NC',2014,239.84,1,'2014-03-07 18:42:30',NULL,NULL),(846,'TX026','Brown','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(874,'TX026','Edwards','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(148,'GA008','Upson','GA',2014,262.30,1,'2014-03-07 18:42:28',NULL,NULL),(557,'OH001','Fulton','OH',2014,189.97,1,'2014-03-07 18:42:31',NULL,NULL),(52,'FL052','Pinellas','FL',2014,200.17,1,'2014-03-07 18:42:27',NULL,NULL),(628,'OH015','Stark','OH',2014,191.31,1,'2014-03-07 18:42:31',NULL,NULL),(1018,'VA002','Greene','VA',2014,130.10,1,'2014-03-07 18:42:34',NULL,NULL),(41,'FL041','Marion','FL',2014,193.29,1,'2014-03-07 18:42:27',NULL,NULL),(46,'FL046','Okaloosa','FL',2014,188.45,1,'2014-03-07 18:42:27',NULL,NULL),(297,'MI004','Livingston','MI',2014,207.69,1,'2014-03-07 18:42:29',NULL,NULL),(546,'NC016','Beaufort','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(820,'TX019','Guadalupe','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(1093,'VA012','Augusta','VA',2014,143.97,1,'2014-03-07 18:42:34',NULL,NULL),(751,'SC041','Saluda','SC',2014,228.97,1,'2014-03-07 18:42:32',NULL,NULL),(101,'GA003','Henry','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(421,'MS006','Jefferson','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(773,'TX006','Brazos','TX',2014,187.34,1,'2014-03-07 18:42:32',NULL,NULL),(942,'TX026','Maverick','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(969,'TX026','Reeves','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1020,'VA003','Danville City','VA',2014,145.38,1,'2014-03-07 18:42:34',NULL,NULL),(379,'MS002','Itawamba','MS',2014,267.72,1,'2014-03-07 18:42:30',NULL,NULL),(404,'MS006','Attala','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(535,'NC014','Greene','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(630,'OH016','Coshocton','OH',2014,246.39,1,'2014-03-07 18:42:31',NULL,NULL),(985,'TX026','Stonewall','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(133,'GA006','Wayne','GA',2014,318.41,1,'2014-03-07 18:42:28',NULL,NULL),(142,'GA008','Muscogee','GA',2014,199.56,1,'2014-03-07 18:42:28',NULL,NULL),(342,'MI014','Grand Traverse','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(875,'TX026','Erath','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(11,'FL011','Collier','FL',2014,208.15,1,'2014-03-07 18:42:27',NULL,NULL),(779,'TX008','Collin','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(1035,'VA007','Charles City','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1109,'VA012','Galax City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(454,'MS006','Yalobusha','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(680,'PA005','Cambria','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(709,'PA009','Lebanon','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(932,'TX026','Lipscomb','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1034,'VA007','Caroline','VA',2014,151.28,1,'2014-03-07 18:42:34',NULL,NULL),(39,'FL039','Madison','FL',2014,226.78,1,'2014-03-07 18:42:27',NULL,NULL),(219,'GA015','Seminole','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(261,'LA005','West Feliciana','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(653,'PA002','Elk','PA',2014,184.57,1,'2014-03-07 18:42:31',NULL,NULL),(668,'PA004','Allegheny','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(686,'PA006','Columbia','PA',2014,152.69,1,'2014-03-07 18:42:31',NULL,NULL),(715,'SC005','Bamberg','SC',2014,187.12,1,'2014-03-07 18:42:32',NULL,NULL),(1058,'VA008','Salem City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(1075,'VA010','Arlington','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(558,'OH001','Henry','OH',2014,203.63,1,'2014-03-07 18:42:31',NULL,NULL),(674,'PA004','Indiana','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(402,'MS006','Alcorn','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(641,'OH017','Hocking','OH',2014,281.17,1,'2014-03-07 18:42:31',NULL,NULL),(483,'NC004','Cabarrus','NC',2014,239.84,1,'2014-03-07 18:42:30',NULL,NULL),(541,'NC015','Columbus','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(884,'TX026','Frio','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(50,'FL050','Palm Beach','FL',2014,210.04,1,'2014-03-07 18:42:27',NULL,NULL),(527,'NC012','Martin','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(828,'TX023','Goliad','TX',2014,190.35,1,'2014-03-07 18:42:32',NULL,NULL),(415,'MS006','Franklin','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(954,'TX026','Navarro','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(226,'GA016','Wilkinson','GA',2014,248.64,1,'2014-03-07 18:42:29',NULL,NULL),(255,'LA005','Livingston','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(851,'TX026','Cherokee','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(534,'NC014','Edgecombe','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(1063,'VA009','James City','VA',2014,128.00,1,'2014-03-07 18:42:34',NULL,NULL),(708,'PA009','Juniata','PA',2014,149.76,1,'2014-03-07 18:42:32',NULL,NULL),(149,'GA008','Webster','GA',2014,251.19,1,'2014-03-07 18:42:28',NULL,NULL),(220,'GA015','Thomas','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(856,'TX026','Collingsworth','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(553,'NC016','Pamlico','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(801,'TX010','Waller','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(110,'GA004','Carroll','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(473,'NC002','Alexander','NC',2014,244.95,1,'2014-03-07 18:42:30',NULL,NULL),(792,'TX010','Austin','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(879,'TX026','Fisher','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1089,'VA011','Frederick','VA',2014,162.17,1,'2014-03-07 18:42:34',NULL,NULL),(516,'NC011','Durham','NC',2014,210.47,1,'2014-03-07 18:42:30',NULL,NULL),(655,'PA003','Bradford','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(232,'LA001','Saint James','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(977,'TX026','Scurry','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(30,'FL030','Indian River','FL',2014,200.07,1,'2014-03-07 18:42:27',NULL,NULL),(508,'NC009','Sampson','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(591,'OH006','Wyandot','OH',2014,242.58,1,'2014-03-07 18:42:31',NULL,NULL),(359,'MI015','Presque Isle','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(692,'PA006','Schuylkill','PA',2014,152.69,1,'2014-03-07 18:42:32',NULL,NULL),(729,'SC019','Edgefield','SC',2014,240.60,1,'2014-03-07 18:42:32',NULL,NULL),(198,'GA014','Chatham','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(292,'MI001','Wayne','MI',2014,175.33,1,'2014-03-07 18:42:29',NULL,NULL),(213,'GA015','Echols','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(876,'TX026','Falls','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1036,'VA007','Chesterfield','VA',2014,131.66,1,'2014-03-07 18:42:34',NULL,NULL),(1099,'VA012','Buena Vista City','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(151,'GA009','Murray','GA',2014,262.59,1,'2014-03-07 18:42:28',NULL,NULL),(346,'MI014','Missaukee','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(423,'MS006','Kemper','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(150,'GA009','Fannin','GA',2014,262.59,1,'2014-03-07 18:42:28',NULL,NULL),(377,'MS001','Tunica','MS',2014,264.88,1,'2014-03-07 18:42:30',NULL,NULL),(459,'NC001','Clay','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(796,'TX010','Galveston','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(336,'MI013','Isabella','MI',2014,212.85,1,'2014-03-07 18:42:29',NULL,NULL),(978,'TX026','Shackelford','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(700,'PA008','Chester','PA',2014,234.85,1,'2014-03-07 18:42:32',NULL,NULL),(960,'TX026','Panola','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(15,'FL015','Duval','FL',2014,200.40,1,'2014-03-07 18:42:27',NULL,NULL),(652,'PA002','Cameron','PA',2014,163.75,1,'2014-03-07 18:42:31',NULL,NULL),(706,'PA009','Franklin','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(909,'TX026','Hutchinson','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(962,'TX026','Pecos','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(212,'GA015','Early','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(469,'NC001','Rutherford','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(13,'FL013','Desoto','FL',2014,220.27,1,'2014-03-07 18:42:27',NULL,NULL),(394,'MS004','Pearl River','MS',2014,285.71,1,'2014-03-07 18:42:30',NULL,NULL),(397,'MS005','Hancock','MS',2014,355.61,1,'2014-03-07 18:42:30',NULL,NULL),(453,'MS006','Winston','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(584,'OH005','Clinton','OH',2014,224.18,1,'2014-03-07 18:42:31',NULL,NULL),(1086,'VA010','Spotsylvania','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(84,'GA002','Jackson','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(788,'TX008','Rockwall','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(1107,'VA012','Floyd','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(717,'SC007','Beaufort','SC',2014,180.01,1,'2014-03-07 18:42:32',NULL,NULL),(754,'SC044','Union','SC',2014,210.87,1,'2014-03-07 18:42:32',NULL,NULL),(316,'MI009','Saint Joseph','MI',2014,250.03,1,'2014-03-07 18:42:29',NULL,NULL),(640,'OH017','Athens','OH',2014,278.30,1,'2014-03-07 18:42:31',NULL,NULL),(951,'TX026','Morris','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1060,'VA009','Gloucester','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(94,'GA003','Coweta','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(216,'GA015','Lanier','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(433,'MS006','Montgomery','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(624,'OH013','Trumbull','OH',2014,222.54,1,'2014-03-07 18:42:31',NULL,NULL),(713,'SC003','Allendale','SC',2014,235.60,1,'2014-03-07 18:42:32',NULL,NULL),(1140,'VA012','Tazewell','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(48,'FL048','Orange','FL',2014,214.97,1,'2014-03-07 18:42:27',NULL,NULL),(227,'LA001','Jefferson','LA',2014,230.65,1,'2014-03-07 18:42:29',NULL,NULL),(577,'OH003','Shelby','OH',2014,237.70,1,'2014-03-07 18:42:31',NULL,NULL),(249,'LA004','Cameron','LA',2014,245.33,1,'2014-03-07 18:42:29',NULL,NULL),(361,'MI016','Alger','MI',2014,261.47,1,'2014-03-07 18:42:29',NULL,NULL),(174,'GA011','Wheeler','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(59,'FL059','Saint Lucie','FL',2014,230.62,1,'2014-03-07 18:42:28',NULL,NULL),(948,'TX026','Mitchell','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(119,'GA005','Lincoln','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(699,'PA008','Bucks','PA',2014,234.85,1,'2014-03-07 18:42:32',NULL,NULL),(778,'TX007','San Patricio','TX',2014,185.96,1,'2014-03-07 18:42:32',NULL,NULL),(854,'TX026','Coke','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(869,'TX026','Dickens','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1120,'VA012','Madison','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1127,'VA012','Nottoway','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(200,'GA014','Evans','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(207,'GA015','Brooks','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(414,'MS006','Covington','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(604,'OH009','Pickaway','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(618,'OH012','Ashland','OH',2014,224.87,1,'2014-03-07 18:42:31',NULL,NULL),(795,'TX010','Fort Bend','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(8,'FL008','Charlotte','FL',2014,202.52,1,'2014-03-07 18:42:27',NULL,NULL),(160,'GA010','Rabun','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(392,'MS004','Jones','MS',2014,285.71,1,'2014-03-07 18:42:30',NULL,NULL),(357,'MI015','Oscoda','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(554,'NC016','Tyrrell','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(919,'TX026','Kerr','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1066,'VA009','Norfolk City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(766,'TX003','Hays','TX',2014,195.32,1,'2014-03-07 18:42:32',NULL,NULL),(1105,'VA012','Emporia City','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(997,'TX026','Van Zandt','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1132,'VA012','Rappahannock','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(178,'GA012','Dodge','GA',2014,257.36,1,'2014-03-07 18:42:28',NULL,NULL),(217,'GA015','Lowndes','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(153,'GA010','Banks','GA',2014,230.97,1,'2014-03-07 18:42:28',NULL,NULL),(1125,'VA012','Northumberland','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(77,'GA001','Sumter','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(329,'MI012','Muskegon','MI',2014,199.03,1,'2014-03-07 18:42:29',NULL,NULL),(395,'MS004','Perry','MS',2014,308.54,1,'2014-03-07 18:42:30',NULL,NULL),(603,'OH009','Madison','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(664,'PA003','Susquehanna','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(1095,'VA012','Bland','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(345,'MI014','Manistee','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(481,'NC003','Wilkes','NC',2014,259.91,1,'2014-03-07 18:42:30',NULL,NULL),(671,'PA004','Butler','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(539,'NC014','Wilson','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(734,'SC024','Greenwood','SC',2014,248.25,1,'2014-03-07 18:42:32',NULL,NULL),(931,'TX026','Limestone','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1083,'VA010','Manassas City','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(211,'GA015','Decatur','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(714,'SC004','Anderson','SC',2014,228.43,1,'2014-03-07 18:42:32',NULL,NULL),(192,'GA013','Pickens','GA',2014,209.14,1,'2014-03-07 18:42:28',NULL,NULL),(446,'MS006','Tallahatchie','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(1022,'VA004','Harrisonburg City','VA',2014,161.64,1,'2014-03-07 18:42:34',NULL,NULL),(762,'TX002','Potter','TX',2014,176.77,1,'2014-03-07 18:42:32',NULL,NULL),(31,'FL031','Jackson','FL',2014,215.02,1,'2014-03-07 18:42:27',NULL,NULL),(448,'MS006','Walthall','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(685,'PA006','Centre','PA',2014,151.59,1,'2014-03-07 18:42:31',NULL,NULL),(337,'MI013','Midland','MI',2014,212.85,1,'2014-03-07 18:42:29',NULL,NULL),(987,'TX026','Swisher','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(829,'TX023','Victoria','TX',2014,190.35,1,'2014-03-07 18:42:32',NULL,NULL),(956,'TX026','Nolan','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1019,'VA002','Nelson','VA',2014,130.10,1,'2014-03-07 18:42:34',NULL,NULL),(126,'GA006','Brantley','GA',2014,318.41,1,'2014-03-07 18:42:28',NULL,NULL),(299,'MI005','Genesee','MI',2014,194.23,1,'2014-03-07 18:42:29',NULL,NULL),(355,'MI015','Montmorency','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(389,'MS003','Warren','MS',2014,325.14,1,'2014-03-07 18:42:30',NULL,NULL),(271,'LA007','East Carroll','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(838,'TX026','Baylor','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(679,'PA005','Blair','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(837,'TX026','Bailey','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(1003,'TX026','Wilbarger','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(317,'MI009','Van Buren','MI',2014,218.81,1,'2014-03-07 18:42:29',NULL,NULL),(505,'NC009','Hoke','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(728,'SC018','Dorchester','SC',2014,189.24,1,'2014-03-07 18:42:32',NULL,NULL),(979,'TX026','Shelby','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(51,'FL051','Pasco','FL',2014,196.41,1,'2014-03-07 18:42:27',NULL,NULL),(639,'OH016','Tuscarawas','OH',2014,195.33,1,'2014-03-07 18:42:31',NULL,NULL),(645,'PA001','Crawford','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(724,'SC014','Clarendon','SC',2014,200.06,1,'2014-03-07 18:42:32',NULL,NULL),(222,'GA015','Turner','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(689,'PA006','Montour','PA',2014,152.69,1,'2014-03-07 18:42:31',NULL,NULL),(892,'TX026','Hale','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(961,'TX026','Parmer','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(71,'GA001','Crisp','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(319,'MI010','Calhoun','MI',2014,212.63,1,'2014-03-07 18:42:29',NULL,NULL),(592,'OH007','Crawford','OH',2014,246.21,1,'2014-03-07 18:42:31',NULL,NULL),(612,'OH010','Vinton','OH',2014,274.94,1,'2014-03-07 18:42:31',NULL,NULL),(663,'PA003','Sullivan','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(1021,'VA003','Pittsylvania','VA',2014,145.38,1,'2014-03-07 18:42:34',NULL,NULL),(343,'MI014','Kalkaska','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(547,'NC016','Carteret','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(458,'NC001','Cherokee','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(859,'TX026','Concho','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(921,'TX026','King','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(704,'PA009','Cumberland','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(710,'PA009','Perry','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(1030,'VA006','Bedford City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(1094,'VA012','Bath','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1142,'VA012','Westmoreland','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(688,'PA006','Mifflin','PA',2014,152.69,1,'2014-03-07 18:42:31',NULL,NULL),(1041,'VA007','Hanover','VA',2014,131.66,1,'2014-03-07 18:42:34',NULL,NULL),(920,'TX026','Kimble','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(682,'PA005','Huntingdon','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(694,'PA006','Union','PA',2014,152.69,1,'2014-03-07 18:42:32',NULL,NULL),(194,'GA014','Appling','GA',2014,279.50,1,'2014-03-07 18:42:28',NULL,NULL),(367,'MI016','Iron','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(723,'SC013','Chesterfield','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(374,'MS001','DeSoto','MS',2014,261.12,1,'2014-03-07 18:42:30',NULL,NULL),(602,'OH009','Logan','OH',2014,255.56,1,'2014-03-07 18:42:31',NULL,NULL),(1114,'VA012','Highland','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(320,'MI010','Kalamazoo','MI',2014,212.63,1,'2014-03-07 18:42:29',NULL,NULL),(452,'MS006','Wilkinson','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(943,'TX026','McCulloch','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(197,'GA014','Candler','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(549,'NC016','Dare','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(257,'LA005','Saint Helena','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(349,'MI015','Alpena','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(29,'FL029','Holmes','FL',2014,213.49,1,'2014-03-07 18:42:27',NULL,NULL),(195,'GA014','Bryan','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(471,'NC001','Transylvania','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(649,'PA001','Mercer','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(1000,'TX026','Washington','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(139,'GA008','Macon','GA',2014,262.30,1,'2014-03-07 18:42:28',NULL,NULL),(185,'GA012','Putnam','GA',2014,257.36,1,'2014-03-07 18:42:28',NULL,NULL),(537,'NC014','Pitt','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(49,'FL049','Osceola','FL',2014,221.55,1,'2014-03-07 18:42:27',NULL,NULL),(532,'NC013','Johnston','NC',2014,225.61,1,'2014-03-07 18:42:31',NULL,NULL),(109,'GA003','Walton','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(123,'GA005','Warren','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(444,'MS006','Smith','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(334,'MI013','Clare','MI',2014,212.85,1,'2014-03-07 18:42:29',NULL,NULL),(105,'GA003','Paulding','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(705,'PA009','Dauphin','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(748,'SC038','Orangeburg','SC',2014,187.12,1,'2014-03-07 18:42:32',NULL,NULL),(648,'PA001','McKean','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(43,'FL043','Miami-Dade','FL',2014,210.68,1,'2014-03-07 18:42:27',NULL,NULL),(98,'GA003','Forsyth','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(468,'NC001','Polk','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(844,'TX026','Briscoe','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(193,'GA013','Polk','GA',2014,288.85,1,'2014-03-07 18:42:28',NULL,NULL),(805,'TX012','Webb','TX',2014,166.37,1,'2014-03-07 18:42:32',NULL,NULL),(1112,'VA012','Halifax','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(179,'GA012','Dooly','GA',2014,257.36,1,'2014-03-07 18:42:28',NULL,NULL),(252,'LA005','East Baton Rouge','LA',2014,228.00,1,'2014-03-07 18:42:29',NULL,NULL),(272,'LA007','Franklin','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(702,'PA008','Montgomery','PA',2014,234.85,1,'2014-03-07 18:42:32',NULL,NULL),(76,'GA001','Schley','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(499,'NC007','Rockingham','NC',2014,220.68,1,'2014-03-07 18:42:30',NULL,NULL),(667,'PA003','Wyoming','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(1137,'VA012','Smyth','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(753,'SC043','Sumter','SC',2014,200.06,1,'2014-03-07 18:42:32',NULL,NULL),(1078,'VA010','Fairfax City','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(902,'TX026','Hill','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1,'FL001','Alachua','FL',2014,210.33,1,'2014-03-07 18:42:27',NULL,NULL),(182,'GA012','Monroe','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(634,'OH016','Monroe','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(789,'TX008','Tarrant','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(870,'TX026','Dimmit','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(203,'GA014','Screven','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(794,'TX010','Chambers','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(915,'TX026','Jim Wells','TX',2014,184.99,1,'2014-03-07 18:42:33',NULL,NULL),(1100,'VA012','Carroll','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(58,'FL058','Saint Johns','FL',2014,219.69,1,'2014-03-07 18:42:28',NULL,NULL),(120,'GA005','McDuffie','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(678,'PA005','Bedford','PA',2014,184.57,1,'2014-03-07 18:42:31',NULL,NULL),(910,'TX026','Jack','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1039,'VA007','Dinwiddie','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(514,'NC011','Caswell','NC',2014,218.70,1,'2014-03-07 18:42:30',NULL,NULL),(533,'NC013','Wake','NC',2014,211.73,1,'2014-03-07 18:42:31',NULL,NULL),(141,'GA008','Meriwether','GA',2014,246.00,1,'2014-03-07 18:42:28',NULL,NULL),(865,'TX026','Dallam','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(425,'MS006','Lauderdale','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(210,'GA015','Cook','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(620,'OH012','Portage','OH',2014,204.39,1,'2014-03-07 18:42:31',NULL,NULL),(661,'PA003','Monroe','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(845,'TX026','Brooks','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(231,'LA001','Saint Charles','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(916,'TX026','Karnes','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(92,'GA003','Clayton','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(585,'OH005','Highland','OH',2014,224.18,1,'2014-03-07 18:42:31',NULL,NULL),(1133,'VA012','Richmond','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1144,'VA012','Wythe','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(146,'GA008','Taylor','GA',2014,262.30,1,'2014-03-07 18:42:28',NULL,NULL),(354,'MI015','Mackinac','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(627,'OH015','Carroll','OH',2014,191.31,1,'2014-03-07 18:42:31',NULL,NULL),(790,'TX008','Wise','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(803,'TX011','Coryell','TX',2014,174.70,1,'2014-03-07 18:42:32',NULL,NULL),(1044,'VA007','King and Queen','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1111,'VA012','Greensville','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(204,'GA014','Tattnall','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(224,'GA016','Hancock','GA',2014,248.64,1,'2014-03-07 18:42:29',NULL,NULL),(246,'LA004','Allen','LA',2014,245.33,1,'2014-03-07 18:42:29',NULL,NULL),(815,'TX018','Tom Green','TX',2014,193.05,1,'2014-03-07 18:42:32',NULL,NULL),(1129,'VA012','Page','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(243,'LA003','Saint Martin','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(439,'MS006','Pike','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(496,'NC006','Yadkin','NC',2014,241.72,1,'2014-03-07 18:42:30',NULL,NULL),(745,'SC035','Marlboro','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(900,'TX026','Hemphill','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(940,'TX026','Mason','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1069,'VA009','Suffolk City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(601,'OH009','Licking','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(616,'OH011','Lake','OH',2014,194.46,1,'2014-03-07 18:42:31',NULL,NULL),(88,'GA002','Oglethorpe','GA',2014,242.90,1,'2014-03-07 18:42:28',NULL,NULL),(913,'TX026','Jeff Davis','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(475,'NC002','Caldwell','NC',2014,244.95,1,'2014-03-07 18:42:30',NULL,NULL),(727,'SC017','Dillon','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(269,'LA006','Winn','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(370,'MI016','Marquette','MI',2014,261.47,1,'2014-03-07 18:42:29',NULL,NULL),(579,'OH004','Hamilton','OH',2014,186.61,1,'2014-03-07 18:42:31',NULL,NULL),(490,'NC005','Lincoln','NC',2014,226.76,1,'2014-03-07 18:42:30',NULL,NULL),(598,'OH009','Fayette','OH',2014,255.56,1,'2014-03-07 18:42:31',NULL,NULL),(776,'TX007','Aransas','TX',2014,185.96,1,'2014-03-07 18:42:32',NULL,NULL),(209,'GA015','Colquitt','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(998,'TX026','Walker','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(782,'TX008','Denton','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(492,'NC006','Davie','NC',2014,241.72,1,'2014-03-07 18:42:30',NULL,NULL),(763,'TX002','Randall','TX',2014,176.77,1,'2014-03-07 18:42:32',NULL,NULL),(937,'TX026','Madison','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(311,'MI008','Bay','MI',2014,206.66,1,'2014-03-07 18:42:29',NULL,NULL),(419,'MS006','Issaquena','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(145,'GA008','Talbot','GA',2014,206.75,1,'2014-03-07 18:42:28',NULL,NULL),(456,'NC001','Avery','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(529,'NC012','Pasquotank','NC',2014,228.04,1,'2014-03-07 18:42:31',NULL,NULL),(983,'TX026','Stephens','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(312,'MI008','Gratiot','MI',2014,212.85,1,'2014-03-07 18:42:29',NULL,NULL),(381,'MS002','Pontotoc','MS',2014,271.58,1,'2014-03-07 18:42:30',NULL,NULL),(720,'SC010','Charleston','SC',2014,189.24,1,'2014-03-07 18:42:32',NULL,NULL),(988,'TX026','Terrell','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(362,'MI016','Baraga','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(755,'SC045','Williamsburg','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(861,'TX026','Cottle','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(691,'PA006','Northumberland','PA',2014,152.69,1,'2014-03-07 18:42:32',NULL,NULL),(42,'FL042','Martin','FL',2014,212.91,1,'2014-03-07 18:42:27',NULL,NULL),(293,'MI002','Macomb','MI',2014,175.33,1,'2014-03-07 18:42:29',NULL,NULL),(757,'TX001','Callahan','TX',2014,193.26,1,'2014-03-07 18:42:32',NULL,NULL),(963,'TX026','Polk','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1136,'VA012','Shenandoah','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1143,'VA012','Wise','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1006,'TX026','Wood','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(138,'GA008','Harris','GA',2014,206.75,1,'2014-03-07 18:42:28',NULL,NULL),(180,'GA012','Houston','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(363,'MI016','Delta','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(623,'OH013','Mahoning','OH',2014,222.54,1,'2014-03-07 18:42:31',NULL,NULL),(651,'PA001','Warren','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(953,'TX026','Nacogdoches','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(959,'TX026','Palo Pinto','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1064,'VA009','Mathews','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(568,'OH002','Putnam','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(749,'SC039','Pickens','SC',2014,228.43,1,'2014-03-07 18:42:32',NULL,NULL),(818,'TX019','Bexar','TX',2014,187.25,1,'2014-03-07 18:42:32',NULL,NULL),(1004,'TX026','Willacy','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(34,'FL034','Lake','FL',2014,192.81,1,'2014-03-07 18:42:27',NULL,NULL),(515,'NC011','Chatham','NC',2014,210.47,1,'2014-03-07 18:42:30',NULL,NULL),(800,'TX010','San Jacinto','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(307,'MI007','Hillsdale','MI',2014,243.36,1,'2014-03-07 18:42:29',NULL,NULL),(555,'NC016','Washington','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(1135,'VA012','Russell','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(774,'TX006','Burleson','TX',2014,187.34,1,'2014-03-07 18:42:32',NULL,NULL),(240,'LA003','Iberia','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(952,'TX026','Motley','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(401,'MS006','Adams','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(574,'OH003','Miami','OH',2014,213.70,1,'2014-03-07 18:42:31',NULL,NULL),(117,'GA005','Jefferson','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(406,'MS006','Calhoun','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(163,'GA010','Union','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(393,'MS004','Lamar','MS',2014,308.54,1,'2014-03-07 18:42:30',NULL,NULL),(497,'NC007','Guilford','NC',2014,217.72,1,'2014-03-07 18:42:30',NULL,NULL),(435,'MS006','Newton','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(1110,'VA012','Grayson','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(169,'GA011','Laurens','GA',2014,297.52,1,'2014-03-07 18:42:28',NULL,NULL),(280,'LA007','Union','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(176,'GA012','Bleckley','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(205,'GA015','Ben Hill','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(934,'TX026','Llano','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(992,'TX026','Trinity','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(164,'GA010','White','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(375,'MS001','Marshall','MS',2014,264.88,1,'2014-03-07 18:42:30',NULL,NULL),(832,'TX025','Clay','TX',2014,215.86,1,'2014-03-07 18:42:32',NULL,NULL),(350,'MI015','Cheboygan','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(895,'TX026','Hansford','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(480,'NC003','Watauga','NC',2014,259.91,1,'2014-03-07 18:42:30',NULL,NULL),(572,'OH003','Darke','OH',2014,237.70,1,'2014-03-07 18:42:31',NULL,NULL),(587,'OH006','Huron','OH',2014,203.63,1,'2014-03-07 18:42:31',NULL,NULL),(233,'LA001','Saint John the Baptist','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(739,'SC029','Lancaster','SC',2014,240.09,1,'2014-03-07 18:42:32',NULL,NULL),(929,'TX026','Lee','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(986,'TX026','Sutton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(27,'FL027','Highlands','FL',2014,213.88,1,'2014-03-07 18:42:27',NULL,NULL),(430,'MS006','Lowndes','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(756,'SC046','York','SC',2014,233.19,1,'2014-03-07 18:42:32',NULL,NULL),(785,'TX008','Johnson','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(1126,'VA012','Norton City','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(276,'LA007','Morehouse','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(744,'SC034','Marion','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(561,'OH001','Wood','OH',2014,189.97,1,'2014-03-07 18:42:31',NULL,NULL),(340,'MI014','Charlevoix','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(669,'PA004','Armstrong','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(811,'TX015','Hidalgo','TX',2014,147.66,1,'2014-03-07 18:42:32',NULL,NULL),(812,'TX016','Midland','TX',2014,181.58,1,'2014-03-07 18:42:32',NULL,NULL),(315,'MI009','Cass','MI',2014,250.03,1,'2014-03-07 18:42:29',NULL,NULL),(1001,'TX026','Wharton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(111,'GA004','Heard','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(173,'GA011','Treutlen','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(390,'MS004','Forrest','MS',2014,308.54,1,'2014-03-07 18:42:30',NULL,NULL),(622,'OH013','Columbiana','OH',2014,222.54,1,'2014-03-07 18:42:31',NULL,NULL),(1002,'TX026','Wheiler','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(432,'MS006','Monroe','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(409,'MS006','Choctaw','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(5,'FL005','Brevard','FL',2014,203.69,1,'2014-03-07 18:42:27',NULL,NULL),(32,'FL032','Jefferson','FL',2014,253.88,1,'2014-03-07 18:42:27',NULL,NULL),(464,'NC001','Macon','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(852,'TX026','Childress','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(923,'TX026','Kleberg','TX',2014,184.99,1,'2014-03-07 18:42:33',NULL,NULL),(1026,'VA005','Washington','VA',2014,161.61,1,'2014-03-07 18:42:34',NULL,NULL),(1097,'VA012','Buchanan','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(113,'GA005','Burke','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(154,'GA010','Dawson','GA',2014,191.66,1,'2014-03-07 18:42:28',NULL,NULL),(599,'OH009','Franklin','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(816,'TX019','Atascosa','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(306,'MI007','Eaton','MI',2014,210.37,1,'2014-03-07 18:42:29',NULL,NULL),(310,'MI008','Arenac','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(308,'MI007','Ingham','MI',2014,210.37,1,'2014-03-07 18:42:29',NULL,NULL),(725,'SC015','Colleton','SC',2014,189.24,1,'2014-03-07 18:42:32',NULL,NULL),(318,'MI010','Branch','MI',2014,240.97,1,'2014-03-07 18:42:29',NULL,NULL),(489,'NC005','Gaston','NC',2014,226.76,1,'2014-03-07 18:42:30',NULL,NULL),(726,'SC016','Darlington','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(834,'TX026','Anderson','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(62,'FL062','Taylor','FL',2014,225.76,1,'2014-03-07 18:42:28',NULL,NULL),(740,'SC030','Laurens','SC',2014,228.00,1,'2014-03-07 18:42:32',NULL,NULL),(799,'TX010','Montgomery','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(443,'MS006','Sharkey','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(882,'TX026','Franklin','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(500,'NC008','Montgomery','NC',2014,230.49,1,'2014-03-07 18:42:30',NULL,NULL),(1116,'VA012','Lancaster','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(877,'TX026','Fannin','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1117,'VA012','Lee','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(434,'MS006','Neshoba','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(520,'NC012','Bertie','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(1092,'VA012','Alleghany','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(449,'MS006','Washington','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(1113,'VA012','Henry','VA',2014,143.97,1,'2014-03-07 18:42:34',NULL,NULL),(991,'TX026','Titus','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(81,'GA002','Clarke','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(116,'GA005','Glascock','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(687,'PA006','Lehigh','PA',2014,159.99,1,'2014-03-07 18:42:31',NULL,NULL),(23,'FL023','Hamilton','FL',2014,218.85,1,'2014-03-07 18:42:27',NULL,NULL),(190,'GA013','Gilmer','GA',2014,289.47,1,'2014-03-07 18:42:28',NULL,NULL),(191,'GA013','Gordon','GA',2014,289.47,1,'2014-03-07 18:42:28',NULL,NULL),(451,'MS006','Webster','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(907,'TX026','Howard','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(548,'NC016','Craven','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(890,'TX026','Gray','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(242,'LA003','Saint Landry','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(300,'MI005','Lapeer','MI',2014,210.98,1,'2014-03-07 18:42:29',NULL,NULL),(1065,'VA009','Newport News City','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(862,'TX026','Crane','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(786,'TX008','Kaufman','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(885,'TX026','Gaines','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(681,'PA005','Clearfield','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(804,'TX011','Lampasas','TX',2014,174.70,1,'2014-03-07 18:42:32',NULL,NULL),(638,'OH016','Perry','OH',2014,246.39,1,'2014-03-07 18:42:31',NULL,NULL),(665,'PA003','Tioga','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(1072,'VA009','Williamsburg City','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(1141,'VA012','Waynesboro City','VA',2014,143.97,1,'2014-03-07 18:42:34',NULL,NULL),(324,'MI012','Kent','MI',2014,199.03,1,'2014-03-07 18:42:29',NULL,NULL),(675,'PA004','Lawrence','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(930,'TX026','Leon','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(450,'MS006','Wayne','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(331,'MI012','Oceana','MI',2014,199.03,1,'2014-03-07 18:42:29',NULL,NULL),(613,'OH011','Ashtabula','OH',2014,250.29,1,'2014-03-07 18:42:31',NULL,NULL),(298,'MI004','Washtenaw','MI',2014,207.69,1,'2014-03-07 18:42:29',NULL,NULL),(1016,'VA002','Charlottesville City','VA',2014,130.10,1,'2014-03-07 18:42:34',NULL,NULL),(722,'SC012','Chester','SC',2014,239.81,1,'2014-03-07 18:42:32',NULL,NULL),(1047,'VA007','New Kent','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1138,'VA012','Southampton','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(1014,'VA001','Radford City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(562,'OH002','Allen','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(826,'TX022','Smith','TX',2014,183.83,1,'2014-03-07 18:42:32',NULL,NULL),(267,'LA006','Rapides','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(1052,'VA007','Sussex','VA',2014,151.28,1,'2014-03-07 18:42:34',NULL,NULL),(140,'GA008','Marion','GA',2014,206.75,1,'2014-03-07 18:42:28',NULL,NULL),(958,'TX026','Oldham','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(989,'TX026','Terry','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1042,'VA007','Henrico','VA',2014,131.66,1,'2014-03-07 18:42:34',NULL,NULL),(460,'NC001','Graham','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(842,'TX026','Bosque','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(857,'TX026','Colorado','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(130,'GA006','McIntosh','GA',2014,318.41,1,'2014-03-07 18:42:28',NULL,NULL),(466,'NC001','McDowell','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(309,'MI007','Jackson','MI',2014,210.37,1,'2014-03-07 18:42:29',NULL,NULL),(608,'OH010','Lawrence','OH',2014,274.94,1,'2014-03-07 18:42:31',NULL,NULL),(632,'OH016','Harrison','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(736,'SC026','Horry','SC',2014,207.14,1,'2014-03-07 18:42:32',NULL,NULL),(1068,'VA009','Portsmouth City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(97,'GA003','Fayette','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(206,'GA015','Berrien','GA',2014,345.14,1,'2014-03-07 18:42:28',NULL,NULL),(486,'NC004','Stanly','NC',2014,239.84,1,'2014-03-07 18:42:30',NULL,NULL),(873,'TX026','Eastland','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(6,'FL006','Broward','FL',2014,190.34,1,'2014-03-07 18:42:27',NULL,NULL),(96,'GA003','Douglas','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(341,'MI014','Emmet','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(365,'MI016','Gogebic','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(476,'NC002','Catawba','NC',2014,244.95,1,'2014-03-07 18:42:30',NULL,NULL),(1124,'VA012','Northampton','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(719,'SC009','Calhoun','SC',2014,187.12,1,'2014-03-07 18:42:32',NULL,NULL),(1005,'TX026','Winkler','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(771,'TX004','Orange','TX',2014,212.30,1,'2014-03-07 18:42:32',NULL,NULL),(1074,'VA010','Alexandria City','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(1121,'VA012','Martinsville City','VA',2014,143.97,1,'2014-03-07 18:42:34',NULL,NULL),(22,'FL022','Gulf','FL',2014,182.15,1,'2014-03-07 18:42:27',NULL,NULL),(410,'MS006','Claiborne','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(338,'MI014','Antrim','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(615,'OH011','Geauga','OH',2014,194.46,1,'2014-03-07 18:42:31',NULL,NULL),(73,'GA001','Lee','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(103,'GA003','Lamar','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(472,'NC001','Yancey','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(918,'TX026','Kent','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(976,'TX026','Schleicher','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1037,'VA007','Colonial Heights City','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(368,'MI016','Keweenaw','MI',2014,261.47,1,'2014-03-07 18:42:29',NULL,NULL),(696,'PA007','Berks','PA',2014,159.99,1,'2014-03-07 18:42:32',NULL,NULL),(941,'TX026','Matagorda','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1013,'VA001','Pulaski','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(491,'NC006','Davidson','NC',2014,234.75,1,'2014-03-07 18:42:30',NULL,NULL),(600,'OH009','Knox','OH',2014,248.20,1,'2014-03-07 18:42:31',NULL,NULL),(711,'SC001','Abbeville','SC',2014,228.97,1,'2014-03-07 18:42:32',NULL,NULL),(808,'TX013','Upshur','TX',2014,186.92,1,'2014-03-07 18:42:32',NULL,NULL),(245,'LA003','Vermillion','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(528,'NC012','Northampton','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(57,'FL057','Seminole','FL',2014,225.48,1,'2014-03-07 18:42:28',NULL,NULL),(583,'OH005','Clermont','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(797,'TX010','Harris','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(1048,'VA007','Petersburg City','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(588,'OH006','Ottawa','OH',2014,203.63,1,'2014-03-07 18:42:31',NULL,NULL),(975,'TX026','San Saba','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(152,'GA009','Whitfield','GA',2014,262.59,1,'2014-03-07 18:42:28',NULL,NULL),(431,'MS006','Marion','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(503,'NC009','Cumberland','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(521,'NC012','Camden','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(693,'PA006','Snyder','PA',2014,152.69,1,'2014-03-07 18:42:32',NULL,NULL),(914,'TX026','Jim Hogg','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(134,'GA007','Catoosa','GA',2014,273.64,1,'2014-03-07 18:42:28',NULL,NULL),(259,'LA005','Washington','LA',2014,228.00,1,'2014-03-07 18:42:29',NULL,NULL),(898,'TX026','Hartley','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(184,'GA012','Pulaski','GA',2014,257.36,1,'2014-03-07 18:42:28',NULL,NULL),(698,'PA007','York','PA',2014,159.99,1,'2014-03-07 18:42:32',NULL,NULL),(327,'MI012','Mecosta','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(455,'MS006','Yazoo','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(743,'SC033','McCormick','SC',2014,241.62,1,'2014-03-07 18:42:32',NULL,NULL),(333,'MI012','Ottawa','MI',2014,199.03,1,'2014-03-07 18:42:29',NULL,NULL),(597,'OH009','Fairfield','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(335,'MI013','Gladwin','MI',2014,212.85,1,'2014-03-07 18:42:29',NULL,NULL),(218,'GA015','Miller','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(254,'LA005','Iberville','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(607,'OH010','Jackson','OH',2014,274.94,1,'2014-03-07 18:42:31',NULL,NULL),(67,'FL067','Washington','FL',2014,227.04,1,'2014-03-07 18:42:28',NULL,NULL),(89,'GA003','Bartow','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(99,'GA003','Fulton','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(44,'FL044','Monroe','FL',2014,276.12,1,'2014-03-07 18:42:27',NULL,NULL),(1131,'VA012','Prince Edward','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(772,'TX005','Cameron','TX',2014,151.42,1,'2014-03-07 18:42:32',NULL,NULL),(1011,'VA001','Giles','VA',2014,148.00,1,'2014-03-07 18:42:33',NULL,NULL),(82,'GA002','Elbert','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(703,'PA008','Philadelphia','PA',2014,234.85,1,'2014-03-07 18:42:32',NULL,NULL),(551,'NC016','Jones','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(684,'PA005','Somerset','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(1119,'VA012','Lunenburg','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(567,'OH002','Paulding','OH',2014,268.20,1,'2014-03-07 18:42:31',NULL,NULL),(867,'TX026','Deaf Smith','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(610,'OH010','Ross','OH',2014,280.90,1,'2014-03-07 18:42:31',NULL,NULL),(775,'TX006','Robertson','TX',2014,187.34,1,'2014-03-07 18:42:32',NULL,NULL),(1139,'VA012','Staunton City','VA',2014,143.97,1,'2014-03-07 18:42:34',NULL,NULL),(463,'NC001','Jackson','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(721,'SC011','Cherokee','SC',2014,210.87,1,'2014-03-07 18:42:32',NULL,NULL),(21,'FL021','Glades','FL',2014,238.54,1,'2014-03-07 18:42:27',NULL,NULL),(887,'TX026','Gillespie','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(847,'TX026','Burnet','TX',2014,180.25,1,'2014-03-07 18:42:32',NULL,NULL),(55,'FL055','Santa Rosa','FL',2014,211.94,1,'2014-03-07 18:42:28',NULL,NULL),(827,'TX023','Calhoun','TX',2014,190.35,1,'2014-03-07 18:42:32',NULL,NULL),(167,'GA011','Jeff Davis','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(822,'TX019','Medina','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(1082,'VA010','Loudoun','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(1090,'VA011','Winchester City','VA',2014,162.17,1,'2014-03-07 18:42:34',NULL,NULL),(189,'GA013','Floyd','GA',2014,288.85,1,'2014-03-07 18:42:28',NULL,NULL),(228,'LA001','Orleans','LA',2014,243.25,1,'2014-03-07 18:42:29',NULL,NULL),(383,'MS002','Union','MS',2014,271.58,1,'2014-03-07 18:42:30',NULL,NULL),(485,'NC004','Rowan','NC',2014,250.93,1,'2014-03-07 18:42:30',NULL,NULL),(545,'NC015','Pender','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(571,'OH003','Clark','OH',2014,213.70,1,'2014-03-07 18:42:31',NULL,NULL),(1102,'VA012','Covington City','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(288,'LA008','Red River','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(903,'TX026','Hockley','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1088,'VA010','Warren','VA',2014,172.85,1,'2014-03-07 18:42:34',NULL,NULL),(14,'FL014','Dixie','FL',2014,212.27,1,'2014-03-07 18:42:27',NULL,NULL),(750,'SC040','Richland','SC',2014,210.23,1,'2014-03-07 18:42:32',NULL,NULL),(841,'TX026','Borden','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(128,'GA006','Charlton','GA',2014,332.49,1,'2014-03-07 18:42:28',NULL,NULL),(1046,'VA007','Louisa','VA',2014,151.28,1,'2014-03-07 18:42:34',NULL,NULL),(127,'GA006','Camden','GA',2014,318.41,1,'2014-03-07 18:42:28',NULL,NULL),(716,'SC006','Barnwell','SC',2014,243.29,1,'2014-03-07 18:42:32',NULL,NULL),(860,'TX026','Cooke','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(108,'GA003','Spalding','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(326,'MI012','Mason','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(364,'MI016','Dickinson','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(718,'SC008','Berkeley','SC',2014,189.24,1,'2014-03-07 18:42:32',NULL,NULL),(1056,'VA008','Roanoke','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(386,'MS003','Madison','MS',2014,320.52,1,'2014-03-07 18:42:30',NULL,NULL),(798,'TX010','Liberty','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(872,'TX026','Duval','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(187,'GA012','Wilcox','GA',2014,257.36,1,'2014-03-07 18:42:28',NULL,NULL),(215,'GA015','Irwin','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(495,'NC006','Surry','NC',2014,241.72,1,'2014-03-07 18:42:30',NULL,NULL),(793,'TX010','Brazoria','TX',2014,191.89,1,'2014-03-07 18:42:32',NULL,NULL),(1033,'VA007','Amelia','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(78,'GA001','Terrell','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(1118,'VA012','Lexington City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(385,'MS003','Hinds','MS',2014,320.52,1,'2014-03-07 18:42:30',NULL,NULL),(707,'PA009','Fulton','PA',2014,156.92,1,'2014-03-07 18:42:32',NULL,NULL),(1057,'VA008','Roanoke City','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(1134,'VA012','Rockbridge','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(121,'GA005','Richmond','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(132,'GA006','Ware','GA',2014,332.49,1,'2014-03-07 18:42:28',NULL,NULL),(565,'OH002','Hardin','OH',2014,268.20,1,'2014-03-07 18:42:31',NULL,NULL),(17,'FL017','Flagler','FL',2014,224.63,1,'2014-03-07 18:42:27',NULL,NULL),(814,'TX018','Irion','TX',2014,193.05,1,'2014-03-07 18:42:32',NULL,NULL),(283,'LA008','Bossier','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(839,'TX026','Bee','TX',2014,184.99,1,'2014-03-07 18:42:32',NULL,NULL),(1010,'TX026','Zavala','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1067,'VA009','Poquoson City','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(543,'NC015','New Hanover','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(894,'TX026','Hamilton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(945,'TX026','Menard','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(256,'LA005','Pointe Coupee','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(594,'OH008','Marion','OH',2014,243.91,1,'2014-03-07 18:42:31',NULL,NULL),(731,'SC021','Florence','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(1054,'VA008','Craig','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(9,'FL009','Citrus','FL',2014,192.40,1,'2014-03-07 18:42:27',NULL,NULL),(590,'OH006','Seneca','OH',2014,203.63,1,'2014-03-07 18:42:31',NULL,NULL),(905,'TX026','Hopkins','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(971,'TX026','Roberts','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(570,'OH003','Champaign','OH',2014,237.70,1,'2014-03-07 18:42:31',NULL,NULL),(810,'TX014','Lubbock','TX',2014,191.99,1,'2014-03-07 18:42:32',NULL,NULL),(125,'GA006','Bacon','GA',2014,332.49,1,'2014-03-07 18:42:28',NULL,NULL),(504,'NC009','Harnett','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(1053,'VA008','Botetourt','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(2,'FL002','Baker','FL',2014,212.18,1,'2014-03-07 18:42:27',NULL,NULL),(809,'TX014','Crosby','TX',2014,191.99,1,'2014-03-07 18:42:32',NULL,NULL),(886,'TX026','Garza','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1079,'VA010','Falls Church City','VA',2014,123.00,1,'2014-03-07 18:42:34',NULL,NULL),(849,'TX026','Cass','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(114,'GA005','Columbia','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(352,'MI015','Crawford','MI',2014,215.87,1,'2014-03-07 18:42:29',NULL,NULL),(996,'TX026','Val Verde','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(405,'MS006','Bolivar','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(248,'LA004','Calcasieu','LA',2014,245.33,1,'2014-03-07 18:42:29',NULL,NULL),(260,'LA005','West Baton Rouge','LA',2014,245.82,1,'2014-03-07 18:42:29',NULL,NULL),(586,'OH006','Erie','OH',2014,242.58,1,'2014-03-07 18:42:31',NULL,NULL),(488,'NC005','Cleveland','NC',2014,226.76,1,'2014-03-07 18:42:30',NULL,NULL),(950,'TX026','Moore','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(266,'LA006','La Salle','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(858,'TX026','Comanche','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(426,'MS006','Lawrence','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(461,'NC001','Haywood','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(506,'NC009','Richmond','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(697,'PA007','Lancaster','PA',2014,159.99,1,'2014-03-07 18:42:32',NULL,NULL),(53,'FL053','Polk','FL',2014,231.42,1,'2014-03-07 18:42:27',NULL,NULL),(175,'GA012','Bibb','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(172,'GA011','Toombs','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(353,'MI015','Iosco','MI',2014,208.31,1,'2014-03-07 18:42:29',NULL,NULL),(928,'TX026','Lavaca','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(290,'LA008','Webster','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(95,'GA003','DeKalb','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(388,'MS003','Simpson','MS',2014,325.14,1,'2014-03-07 18:42:30',NULL,NULL),(868,'TX026','DeWitt','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(883,'TX026','Freestone','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(974,'TX026','San Augustine','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1017,'VA002','Fluvanna','VA',2014,130.10,1,'2014-03-07 18:42:34',NULL,NULL),(91,'GA003','Cherokee','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(303,'MI006','Sanilac','MI',2014,203.16,1,'2014-03-07 18:42:29',NULL,NULL),(314,'MI009','Berrien','MI',2014,262.05,1,'2014-03-07 18:42:29',NULL,NULL),(437,'MS006','Oktibbeha','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(552,'NC016','Lenoir','NC',2014,247.65,1,'2014-03-07 18:42:31',NULL,NULL),(670,'PA004','Beaver','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(304,'MI006','Tuscola','MI',2014,203.16,1,'2014-03-07 18:42:29',NULL,NULL),(225,'GA016','Washington','GA',2014,248.64,1,'2014-03-07 18:42:29',NULL,NULL),(965,'TX026','Rains','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(968,'TX026','Red River','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(990,'TX026','Throckmorton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(643,'OH017','Washington','OH',2014,278.30,1,'2014-03-07 18:42:31',NULL,NULL),(582,'OH005','Brown','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(819,'TX019','Comal','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(275,'LA007','Madison','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(1070,'VA009','Surry','VA',2014,159.22,1,'2014-03-07 18:42:34',NULL,NULL),(412,'MS006','Clay','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(511,'NC010','Vance','NC',2014,239.79,1,'2014-03-07 18:42:30',NULL,NULL),(1061,'VA009','Hampton City','VA',2014,144.66,1,'2014-03-07 18:42:34',NULL,NULL),(378,'MS002','Benton','MS',2014,271.58,1,'2014-03-07 18:42:30',NULL,NULL),(802,'TX011','Bell','TX',2014,174.70,1,'2014-03-07 18:42:32',NULL,NULL),(967,'TX026','Real','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(63,'FL063','Union','FL',2014,227.80,1,'2014-03-07 18:42:28',NULL,NULL),(100,'GA003','Gwinnett','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(56,'FL056','Sarasota','FL',2014,206.51,1,'2014-03-07 18:42:28',NULL,NULL),(911,'TX026','Jackson','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(519,'NC011','Person','NC',2014,210.47,1,'2014-03-07 18:42:30',NULL,NULL),(631,'OH016','Guernsey','OH',2014,246.39,1,'2014-03-07 18:42:31',NULL,NULL),(136,'GA007','Walker','GA',2014,273.64,1,'2014-03-07 18:42:28',NULL,NULL),(817,'TX019','Bandera','TX',2014,193.07,1,'2014-03-07 18:42:32',NULL,NULL),(289,'LA008','Sabine','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(371,'MI016','Menominee','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(737,'SC027','Jasper','SC',2014,180.01,1,'2014-03-07 18:42:32',NULL,NULL),(836,'TX026','Angelina','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(853,'TX026','Cochran','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(880,'TX026','Floyd','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(889,'TX026','Gonzales','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(166,'GA011','Coffee','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(912,'TX026','Jasper','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(927,'TX026','Lamb','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(305,'MI007','Clinton','MI',2014,210.37,1,'2014-03-07 18:42:29',NULL,NULL),(1008,'TX026','Young','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(45,'FL045','Nassau','FL',2014,242.56,1,'2014-03-07 18:42:27',NULL,NULL),(642,'OH017','Meigs','OH',2014,278.30,1,'2014-03-07 18:42:31',NULL,NULL),(770,'TX004','Jefferson','TX',2014,212.30,1,'2014-03-07 18:42:32',NULL,NULL),(407,'MS006','Carroll','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(878,'TX026','Fayette','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1051,'VA007','Richmond City','VA',2014,131.66,1,'2014-03-07 18:42:34',NULL,NULL),(637,'OH016','Noble','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(980,'TX026','Sherman','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(258,'LA005','Tangipahoa','LA',2014,245.82,1,'2014-03-07 18:42:29',NULL,NULL),(274,'LA007','Lincoln','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(422,'MS006','Jefferson Davis','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(66,'FL066','Walton','FL',2014,207.58,1,'2014-03-07 18:42:28',NULL,NULL),(332,'MI012','Osceola','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(525,'NC012','Halifax','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(662,'PA003','Pike','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(143,'GA008','Quitman','GA',2014,262.30,1,'2014-03-07 18:42:28',NULL,NULL),(237,'LA002','Terrebonne','LA',2014,238.35,1,'2014-03-07 18:42:29',NULL,NULL),(871,'TX026','Donley','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(137,'GA008','Chattahoochee','GA',2014,209.35,1,'2014-03-07 18:42:28',NULL,NULL),(824,'TX020','Grayson','TX',2014,211.23,1,'2014-03-07 18:42:32',NULL,NULL),(981,'TX026','Somervell','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1076,'VA010','Clarke','VA',2014,172.85,1,'2014-03-07 18:42:34',NULL,NULL),(186,'GA012','Twiggs','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(199,'GA014','Effingham','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(636,'OH016','Muskingum','OH',2014,246.39,1,'2014-03-07 18:42:31',NULL,NULL),(1087,'VA010','Stafford','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(391,'MS004','Greene','MS',2014,308.54,1,'2014-03-07 18:42:30',NULL,NULL),(429,'MS006','Lincoln','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(629,'OH016','Belmont','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(742,'SC032','Lexington','SC',2014,212.86,1,'2014-03-07 18:42:32',NULL,NULL),(1049,'VA007','Powhatan','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(447,'MS006','Tishomingo','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(807,'TX013','Rusk','TX',2014,186.92,1,'2014-03-07 18:42:32',NULL,NULL),(866,'TX026','Dawson','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(37,'FL037','Levy','FL',2014,207.67,1,'2014-03-07 18:42:27',NULL,NULL),(589,'OH006','Sandusky','OH',2014,242.58,1,'2014-03-07 18:42:31',NULL,NULL),(621,'OH012','Summit','OH',2014,204.39,1,'2014-03-07 18:42:31',NULL,NULL),(80,'GA002','Barrow','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(656,'PA003','Carbon','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(658,'PA003','Lackawanna','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(767,'TX003','Travis','TX',2014,195.32,1,'2014-03-07 18:42:32',NULL,NULL),(83,'GA002','Greene','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(112,'GA004','Heralson','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(1027,'VA006','Amherst','VA',2014,167.02,1,'2014-03-07 18:42:34',NULL,NULL),(1043,'VA007','Hopewell City','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1084,'VA010','Manassas Park City','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(131,'GA006','Pierce','GA',2014,332.49,1,'2014-03-07 18:42:28',NULL,NULL),(936,'TX026','Lynn','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(291,'MI001','Monroe','MI',2014,207.69,1,'2014-03-07 18:42:29',NULL,NULL),(64,'FL064','Volusia','FL',2014,214.21,1,'2014-03-07 18:42:28',NULL,NULL),(498,'NC007','Randolph','NC',2014,217.72,1,'2014-03-07 18:42:30',NULL,NULL),(676,'PA004','Washington','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(1009,'TX026','Zapata','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(158,'GA010','Hart','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(356,'MI015','Ogemaw','MI',2014,191.82,1,'2014-03-07 18:42:29',NULL,NULL),(509,'NC009','Scotland','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(605,'OH009','Union','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(765,'TX003','Caldwell','TX',2014,199.18,1,'2014-03-07 18:42:32',NULL,NULL),(20,'FL020','Gilchrist','FL',2014,211.55,1,'2014-03-07 18:42:27',NULL,NULL),(168,'GA011','Johnson','GA',2014,297.52,1,'2014-03-07 18:42:28',NULL,NULL),(635,'OH016','Morgan','OH',2014,239.30,1,'2014-03-07 18:42:31',NULL,NULL),(1081,'VA010','Fredericksburg City','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(18,'FL018','Franklin','FL',2014,227.04,1,'2014-03-07 18:42:27',NULL,NULL),(436,'MS006','Noxubee','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(560,'OH001','Williams','OH',2014,248.75,1,'2014-03-07 18:42:31',NULL,NULL),(563,'OH002','Auglaize','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(758,'TX001','Jones','TX',2014,193.26,1,'2014-03-07 18:42:32',NULL,NULL),(593,'OH007','Richland','OH',2014,246.21,1,'2014-03-07 18:42:31',NULL,NULL),(677,'PA004','Westmoreland','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(1103,'VA012','Culpeper','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(72,'GA001','Dougherty','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(322,'MI011','Barry','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(556,'OH001','Defiance','OH',2014,203.63,1,'2014-03-07 18:42:31',NULL,NULL),(236,'LA002','Lafourche','LA',2014,238.35,1,'2014-03-07 18:42:29',NULL,NULL),(964,'TX026','Presidio','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(102,'GA003','Jasper','GA',2014,254.02,1,'2014-03-07 18:42:28',NULL,NULL),(344,'MI014','Leelanau','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(611,'OH010','Scioto','OH',2014,274.94,1,'2014-03-07 18:42:31',NULL,NULL),(147,'GA008','Troup','GA',2014,251.19,1,'2014-03-07 18:42:28',NULL,NULL),(347,'MI014','Wexford','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(654,'PA002','Potter','PA',2014,163.75,1,'2014-03-07 18:42:31',NULL,NULL),(781,'TX008','Delta','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(1106,'VA012','Essex','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(659,'PA003','Luzerne','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(171,'GA011','Telfair','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(738,'SC028','Kershaw','SC',2014,210.23,1,'2014-03-07 18:42:32',NULL,NULL),(764,'TX003','Bastrop','TX',2014,199.18,1,'2014-03-07 18:42:32',NULL,NULL),(784,'TX008','Hunt','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(994,'TX026','Upton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(235,'LA002','Assumption','LA',2014,238.35,1,'2014-03-07 18:42:29',NULL,NULL),(573,'OH003','Greene','OH',2014,213.70,1,'2014-03-07 18:42:31',NULL,NULL),(382,'MS002','Tippah','MS',2014,271.58,1,'2014-03-07 18:42:30',NULL,NULL),(465,'NC001','Madison','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(926,'TX026','Lamar','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(115,'GA005','Emanuel','GA',2014,198.59,1,'2014-03-07 18:42:28',NULL,NULL),(400,'MS005','Stone','MS',2014,316.69,1,'2014-03-07 18:42:30',NULL,NULL),(777,'TX007','Nueces','TX',2014,185.96,1,'2014-03-07 18:42:32',NULL,NULL),(690,'PA006','Northampton','PA',2014,159.99,1,'2014-03-07 18:42:32',NULL,NULL),(564,'OH002','Hancock','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(835,'TX026','Andrews','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(1098,'VA012','Buckingham','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(524,'NC012','Gates','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(1015,'VA002','Albemarle','VA',2014,130.10,1,'2014-03-07 18:42:34',NULL,NULL),(144,'GA008','Stewart','GA',2014,251.19,1,'2014-03-07 18:42:28',NULL,NULL),(339,'MI014','Benzie','MI',2014,211.65,1,'2014-03-07 18:42:29',NULL,NULL),(1080,'VA010','Fauquier','VA',2014,170.19,1,'2014-03-07 18:42:34',NULL,NULL),(783,'TX008','Ellis','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(1024,'VA005','Bristol City','VA',2014,165.41,1,'2014-03-07 18:42:34',NULL,NULL),(1108,'VA012','Franklin City','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(376,'MS001','Tate','MS',2014,264.88,1,'2014-03-07 18:42:30',NULL,NULL),(387,'MS003','Rankin','MS',2014,320.52,1,'2014-03-07 18:42:30',NULL,NULL),(413,'MS006','Coahoma','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(596,'OH009','Delaware','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(26,'FL026','Hernando','FL',2014,194.50,1,'2014-03-07 18:42:27',NULL,NULL),(70,'GA001','Clay','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(1012,'VA001','Montgomery','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(1091,'VA012','Accomack','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(262,'LA006','Avoyelles','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(580,'OH004','Warren','OH',2014,186.61,1,'2014-03-07 18:42:31',NULL,NULL),(747,'SC037','Oconee','SC',2014,228.43,1,'2014-03-07 18:42:32',NULL,NULL),(1128,'VA012','Orange','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(61,'FL061','Suwannee','FL',2014,214.45,1,'2014-03-07 18:42:28',NULL,NULL),(403,'MS006','Amite','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(445,'MS006','Sunflower','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(575,'OH003','Montgomery','OH',2014,202.41,1,'2014-03-07 18:42:31',NULL,NULL),(93,'GA003','Cobb','GA',2014,195.98,1,'2014-03-07 18:42:28',NULL,NULL),(538,'NC014','Wayne','NC',2014,232.95,1,'2014-03-07 18:42:31',NULL,NULL),(595,'OH008','Morrow','OH',2014,197.90,1,'2014-03-07 18:42:31',NULL,NULL),(660,'PA003','Lycoming','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(843,'TX026','Brewster','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(247,'LA004','Beauregard','LA',2014,245.33,1,'2014-03-07 18:42:29',NULL,NULL),(79,'GA001','Worth','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(135,'GA007','Dade','GA',2014,273.64,1,'2014-03-07 18:42:28',NULL,NULL),(165,'GA011','Atkinson','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(234,'LA001','Saint Tammany','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(296,'MI004','Lenawee','MI',2014,245.22,1,'2014-03-07 18:42:29',NULL,NULL),(188,'GA013','Chattooga','GA',2014,289.47,1,'2014-03-07 18:42:28',NULL,NULL),(759,'TX001','Taylor','TX',2014,193.26,1,'2014-03-07 18:42:32',NULL,NULL),(888,'TX026','Glasscock','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(513,'NC011','Alamance','NC',2014,210.47,1,'2014-03-07 18:42:30',NULL,NULL),(644,'PA001','Clarion','PA',2014,184.57,1,'2014-03-07 18:42:31',NULL,NULL),(1031,'VA006','Campbell','VA',2014,167.02,1,'2014-03-07 18:42:34',NULL,NULL),(3,'FL003','Bay','FL',2014,187.48,1,'2014-03-07 18:42:27',NULL,NULL),(732,'SC022','Georgetown','SC',2014,207.14,1,'2014-03-07 18:42:32',NULL,NULL),(229,'LA001','Plaquemines','LA',2014,245.20,1,'2014-03-07 18:42:29',NULL,NULL),(420,'MS006','Jasper','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(501,'NC008','Moore','NC',2014,230.49,1,'2014-03-07 18:42:30',NULL,NULL),(935,'TX026','Loving','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(241,'LA003','Lafayette','LA',2014,242.80,1,'2014-03-07 18:42:29',NULL,NULL),(760,'TX002','Armstrong','TX',2014,176.77,1,'2014-03-07 18:42:32',NULL,NULL),(74,'GA001','Mitchell','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(780,'TX008','Dallas','TX',2014,213.07,1,'2014-03-07 18:42:32',NULL,NULL),(891,'TX026','Grimes','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(897,'TX026','Harrison','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(441,'MS006','Quitman','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(576,'OH003','Preble','OH',2014,213.70,1,'2014-03-07 18:42:31',NULL,NULL),(701,'PA008','Delaware','PA',2014,234.85,1,'2014-03-07 18:42:32',NULL,NULL),(970,'TX026','Refugio','TX',2014,184.99,1,'2014-03-07 18:42:33',NULL,NULL),(531,'NC013','Franklin','NC',2014,225.61,1,'2014-03-07 18:42:31',NULL,NULL),(825,'TX021','Bowie','TX',2014,179.30,1,'2014-03-07 18:42:32',NULL,NULL),(1055,'VA008','Franklin','VA',2014,148.00,1,'2014-03-07 18:42:34',NULL,NULL),(741,'SC031','Lee','SC',2014,223.18,1,'2014-03-07 18:42:32',NULL,NULL),(769,'TX004','Hardin','TX',2014,212.30,1,'2014-03-07 18:42:32',NULL,NULL),(850,'TX026','Castro','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(893,'TX026','Hall','TX',2014,180.25,1,'2014-03-07 18:42:33',NULL,NULL),(559,'OH001','Lucas','OH',2014,189.97,1,'2014-03-07 18:42:31',NULL,NULL),(10,'FL010','Clay','FL',2014,205.40,1,'2014-03-07 18:42:27',NULL,NULL),(484,'NC004','Mecklenburg','NC',2014,239.84,1,'2014-03-07 18:42:30',NULL,NULL),(906,'TX026','Houston','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(418,'MS006','Humphreys','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(424,'MS006','Lafayette','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(746,'SC036','Newberry','SC',2014,212.86,1,'2014-03-07 18:42:32',NULL,NULL),(840,'TX026','Blanco','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(955,'TX026','Newton','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(302,'MI006','Huron','MI',2014,203.16,1,'2014-03-07 18:42:29',NULL,NULL),(372,'MI016','Ontonagon','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(462,'NC001','Henderson','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(617,'OH011','Lorain','OH',2014,194.46,1,'2014-03-07 18:42:31',NULL,NULL),(1130,'VA012','Patrick','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(90,'GA003','Butts','GA',2014,232.00,1,'2014-03-07 18:42:28',NULL,NULL),(328,'MI012','Montcalm','MI',2014,217.44,1,'2014-03-07 18:42:29',NULL,NULL),(683,'PA005','Jefferson','PA',2014,167.43,1,'2014-03-07 18:42:31',NULL,NULL),(848,'TX026','Camp','TX',2014,185.86,1,'2014-03-07 18:42:32',NULL,NULL),(155,'GA010','Franklin','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(518,'NC011','Orange','NC',2014,210.47,1,'2014-03-07 18:42:30',NULL,NULL),(1045,'VA007','King William','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(1101,'VA012','Charlotte','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(35,'FL035','Lee','FL',2014,234.57,1,'2014-03-07 18:42:27',NULL,NULL),(301,'MI005','Shiawassee','MI',2014,195.27,1,'2014-03-07 18:42:29',NULL,NULL),(695,'PA007','Adams','PA',2014,159.99,1,'2014-03-07 18:42:32',NULL,NULL),(735,'SC025','Hampton','SC',2014,180.01,1,'2014-03-07 18:42:32',NULL,NULL),(118,'GA005','Jenkins','GA',2014,251.30,1,'2014-03-07 18:42:28',NULL,NULL),(373,'MI016','Schoolcraft','MI',2014,280.02,1,'2014-03-07 18:42:29',NULL,NULL),(438,'MS006','Panola','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(522,'NC012','Chowan','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(830,'TX024','McLennan','TX',2014,185.38,1,'2014-03-07 18:42:32',NULL,NULL),(924,'TX026','Knox','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(264,'LA006','Concordia','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(657,'PA003','Clinton','PA',2014,177.84,1,'2014-03-07 18:42:31',NULL,NULL),(1104,'VA012','Dickenson','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(904,'TX026','Hood','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(925,'TX026','La Salle','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(1007,'TX026','Yoakum','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(65,'FL065','Wakulla','FL',2014,250.81,1,'2014-03-07 18:42:28',NULL,NULL),(540,'NC015','Brunswick','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(917,'TX026','Kenedy','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(946,'TX026','Milam','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(478,'NC003','Alleghany','NC',2014,259.91,1,'2014-03-07 18:42:30',NULL,NULL),(881,'TX026','Foard','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(68,'GA001','Baker','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(752,'SC042','Spartanburg','SC',2014,210.87,1,'2014-03-07 18:42:32',NULL,NULL),(159,'GA010','Lumpkin','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(221,'GA015','Tift','GA',2014,345.14,1,'2014-03-07 18:42:29',NULL,NULL),(761,'TX002','Carson','TX',2014,176.77,1,'2014-03-07 18:42:32',NULL,NULL),(75,'GA001','Randolph','GA',2014,376.55,1,'2014-03-07 18:42:28',NULL,NULL),(202,'GA014','Long','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(507,'NC009','Robeson','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(864,'TX026','Culbertson','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(38,'FL038','Liberty','FL',2014,243.40,1,'2014-03-07 18:42:27',NULL,NULL),(384,'MS003','Copiah','MS',2014,325.14,1,'2014-03-07 18:42:30',NULL,NULL),(972,'TX026','Runnels','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(474,'NC002','Burke','NC',2014,244.95,1,'2014-03-07 18:42:30',NULL,NULL),(87,'GA002','Oconee','GA',2014,189.94,1,'2014-03-07 18:42:28',NULL,NULL),(106,'GA003','Pike','GA',2014,243.27,1,'2014-03-07 18:42:28',NULL,NULL),(285,'LA008','Claiborne','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(999,'TX026','Ward','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(268,'LA006','Vernon','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(282,'LA008','Bienville','LA',2014,255.67,1,'2014-03-07 18:42:29',NULL,NULL),(183,'GA012','Peach','GA',2014,246.47,1,'2014-03-07 18:42:28',NULL,NULL),(408,'MS006','Chickasaw','MS',2014,255.57,1,'2014-03-07 18:42:30',NULL,NULL),(1122,'VA012','Mecklenburg','VA',2014,165.42,1,'2014-03-07 18:42:34',NULL,NULL),(416,'MS006','Grenada','MS',2014,287.37,1,'2014-03-07 18:42:30',NULL,NULL),(351,'MI015','Chippewa','MI',2014,232.29,1,'2014-03-07 18:42:29',NULL,NULL),(791,'TX009','El Paso','TX',2014,166.13,1,'2014-03-07 18:42:32',NULL,NULL),(313,'MI008','Saginaw','MI',2014,206.66,1,'2014-03-07 18:42:29',NULL,NULL),(606,'OH010','Galia','OH',2014,274.94,1,'2014-03-07 18:42:31',NULL,NULL),(908,'TX026','Hudspeth','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(162,'GA010','Towns','GA',2014,241.18,1,'2014-03-07 18:42:28',NULL,NULL),(544,'NC015','Onslow','NC',2014,237.42,1,'2014-03-07 18:42:31',NULL,NULL),(1050,'VA007','Prince George','VA',2014,151.00,1,'2014-03-07 18:42:34',NULL,NULL),(646,'PA001','Erie','PA',2014,133.00,1,'2014-03-07 18:42:31',NULL,NULL),(733,'SC023','Greenville','SC',2014,225.61,1,'2014-03-07 18:42:32',NULL,NULL),(1032,'VA006','Lynchburg City','VA',2014,167.02,1,'2014-03-07 18:42:34',NULL,NULL),(467,'NC001','Mitchell','NC',2014,228.04,1,'2014-03-07 18:42:30',NULL,NULL),(1028,'VA006','Appomattox','VA',2014,167.02,1,'2014-03-07 18:42:34',NULL,NULL),(1085,'VA010','Prince William','VA',2014,137.61,1,'2014-03-07 18:42:34',NULL,NULL),(19,'FL019','Gadsden','FL',2014,256.69,1,'2014-03-07 18:42:27',NULL,NULL),(278,'LA007','Richland','LA',2014,250.62,1,'2014-03-07 18:42:29',NULL,NULL),(566,'OH002','Mercer','OH',2014,229.83,1,'2014-03-07 18:42:31',NULL,NULL),(995,'TX026','Uvalde','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(33,'FL033','Lafayette','FL',2014,237.52,1,'2014-03-07 18:42:27',NULL,NULL),(60,'FL060','Sumter','FL',2014,185.54,1,'2014-03-07 18:42:28',NULL,NULL),(251,'LA005','Ascension','LA',2014,228.00,1,'2014-03-07 18:42:29',NULL,NULL),(502,'NC009','Bladen','NC',2014,257.46,1,'2014-03-07 18:42:30',NULL,NULL),(947,'TX026','Mills','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(944,'TX026','McMullen','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(170,'GA011','Montgomery','GA',2014,310.67,1,'2014-03-07 18:42:28',NULL,NULL),(196,'GA014','Bulloch','GA',2014,267.67,1,'2014-03-07 18:42:28',NULL,NULL),(512,'NC010','Warren','NC',2014,247.65,1,'2014-03-07 18:42:30',NULL,NULL),(325,'MI012','Lake','MI',2014,226.66,1,'2014-03-07 18:42:29',NULL,NULL),(982,'TX026','Starr','TX',2014,185.86,1,'2014-03-07 18:42:33',NULL,NULL),(625,'OH014','Holmes','OH',2014,223.01,1,'2014-03-07 18:42:31',NULL,NULL);
/*!40000 ALTER TABLE `RatingArea` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Role`
--

DROP TABLE IF EXISTS `Role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Role` (
  `RoleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RoleName` varchar(100) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CannotDelete` tinyint(1) NOT NULL DEFAULT '0',
  `IsReadOnly` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleId`),
  KEY `RoleRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=148 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Role`
--

LOCK TABLES `Role` WRITE;
/*!40000 ALTER TABLE `Role` DISABLE KEYS */;
INSERT INTO `Role` VALUES (77,'Broker',2,'Active',1,1,1,'2008-01-08 10:27:41',NULL,NULL),(1,'Administrator',1,'Active',1,1,1,'2013-08-13 11:27:16',NULL,NULL),(78,'Employer',2,'Active',1,1,1,'2008-01-08 10:27:55',NULL,NULL),(81,'Get Licensed',2,'Active',1,1,1,'2008-01-08 10:28:36',NULL,NULL),(79,'Employee',2,'Active',1,1,1,'2008-01-08 10:28:10',NULL,NULL),(75,'Admin',2,'Active',1,1,1,'2008-01-08 10:26:52',NULL,NULL),(80,'Individual',2,'Active',1,1,1,'2008-01-08 10:28:21',NULL,NULL);
/*!40000 ALTER TABLE `Role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RoleCustomField`
--

DROP TABLE IF EXISTS `RoleCustomField`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RoleCustomField` (
  `RoleCustomFieldId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainCustomFieldId` bigint(64) NOT NULL,
  `RoleId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleCustomFieldId`),
  KEY `RoleCustomFieldRefRole_fk_idx` (`RoleId`),
  KEY `RoleCustomFieldRefDomainCustomField_fk_idx` (`DomainCustomFieldId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RoleCustomField`
--

LOCK TABLES `RoleCustomField` WRITE;
/*!40000 ALTER TABLE `RoleCustomField` DISABLE KEYS */;
/*!40000 ALTER TABLE `RoleCustomField` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RoleDocument`
--

DROP TABLE IF EXISTS `RoleDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RoleDocument` (
  `RoleDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RoleId` bigint(64) NOT NULL,
  `DocumentId` bigint(64) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleDocumentId`),
  KEY `RoleDocumentRefDocument_fk_idx` (`DocumentId`),
  KEY `RoleDocumentRefRole_fk_idx` (`RoleId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RoleDocument`
--

LOCK TABLES `RoleDocument` WRITE;
/*!40000 ALTER TABLE `RoleDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `RoleDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RoleFunctionOverride`
--

DROP TABLE IF EXISTS `RoleFunctionOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RoleFunctionOverride` (
  `RoleFunctionOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ViewId` bigint(64) DEFAULT NULL,
  `RoleModuleId` bigint(64) NOT NULL,
  `FunctionId` bigint(64) NOT NULL,
  `IsReadOnly` tinyint(1) NOT NULL DEFAULT '0',
  `FunctionName` varchar(200) DEFAULT NULL,
  `Sortkey` int(11) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `FunctionEntryURL` varchar(200) DEFAULT NULL,
  `AllowToAdd` tinyint(1) DEFAULT '1',
  `AllowToDelete` tinyint(1) DEFAULT '1',
  `AllowToUpdate` tinyint(1) DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleFunctionOverrideId`),
  KEY `RoleFunctionOverrideRefRoleModule_fk_idx` (`RoleModuleId`),
  KEY `RoleFunctionOverrideRefAppView_fk_idx` (`ViewId`),
  KEY `RoleFunctionOverrideRefAppFunction_fk_idx` (`FunctionId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RoleFunctionOverride`
--

LOCK TABLES `RoleFunctionOverride` WRITE;
/*!40000 ALTER TABLE `RoleFunctionOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `RoleFunctionOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RoleModule`
--

DROP TABLE IF EXISTS `RoleModule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RoleModule` (
  `RoleModuleId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RoleId` bigint(64) NOT NULL,
  `AppModuleId` bigint(64) NOT NULL,
  `ModuleName` varchar(100) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `SortKey` int(11) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleModuleId`),
  KEY `RoleModuleRefRole_fk_idx` (`RoleId`),
  KEY `RoleModuleRefAppModule_fk_idx` (`AppModuleId`)
) ENGINE=innodb AUTO_INCREMENT=285 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RoleModule`
--

LOCK TABLES `RoleModule` WRITE;
/*!40000 ALTER TABLE `RoleModule` DISABLE KEYS */;
INSERT INTO `RoleModule` VALUES (148,78,4,'Employer',0,1,1,'2008-01-08 10:50:45',NULL,NULL),(149,78,2,'Admin',0,2,1,'2008-01-08 10:51:10',NULL,NULL),(151,80,8,'Individual',0,1,1,'2008-01-08 10:51:36',NULL,NULL),(150,79,3,'Employee',0,1,1,'2008-01-08 10:51:23',NULL,NULL),(1,1,1,NULL,0,1,1,'2013-08-13 11:27:39',NULL,NULL),(146,75,6,'Provider',0,1,1,'2008-01-08 10:48:07',NULL,NULL),(152,81,9,'Get Licensed',0,1,1,'2008-01-08 10:51:53',NULL,NULL),(147,77,5,'Broker',0,1,1,'2008-01-08 10:49:15',NULL,NULL);
/*!40000 ALTER TABLE `RoleModule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `RoleViewOverride`
--

DROP TABLE IF EXISTS `RoleViewOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `RoleViewOverride` (
  `RoleViewOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ViewId` bigint(64) NOT NULL,
  `RoleModuleId` bigint(64) NOT NULL,
  `ViewName` varchar(200) DEFAULT NULL,
  `SortKey` int(11) NOT NULL DEFAULT '0',
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`RoleViewOverrideId`),
  KEY `RoleViewOverrideRefRole_fk_idx` (`RoleModuleId`),
  KEY `RoleViewOverrideRefAppView_fk_idx` (`ViewId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `RoleViewOverride`
--

LOCK TABLES `RoleViewOverride` WRITE;
/*!40000 ALTER TABLE `RoleViewOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `RoleViewOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `SilverPlan`
--

DROP TABLE IF EXISTS `SilverPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `SilverPlan` (
  `SilverPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `Year` int(11) NOT NULL,
  `RatingAreaCode` varchar(20) NOT NULL,
  `SecondLowestPlanAmount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`SilverPlanId`),
  UNIQUE KEY `SilverPlanRatingAreaBeginAgeEndAgeYear_Uq` (`RatingAreaCode`,`Year`)
) ENGINE=innodb AUTO_INCREMENT=117 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `SilverPlan`
--

LOCK TABLES `SilverPlan` WRITE;
/*!40000 ALTER TABLE `SilverPlan` DISABLE KEYS */;
INSERT INTO `SilverPlan` VALUES (16,2014,'OH016',195.33,0,'2013-09-30 09:26:49',NULL,NULL),(52,2014,'SC007',180.01,0,'2013-11-09 16:30:00',NULL,NULL),(41,2014,'NC012',228.04,0,'2013-11-09 16:30:00',NULL,NULL),(46,2014,'SC001',228.97,0,'2013-11-09 16:30:00',NULL,NULL),(101,2014,'GA001',376.55,0,'2014-02-04 16:44:48',NULL,NULL),(11,2014,'OH011',194.46,0,'2013-09-30 09:26:49',NULL,NULL),(39,2014,'NC010',239.79,0,'2013-11-09 16:30:00',NULL,NULL),(50,2014,'SC005',187.12,0,'2013-11-09 16:30:00',NULL,NULL),(110,2014,'GA010',191.66,0,'2014-02-04 16:44:48',NULL,NULL),(30,2014,'NC001',228.04,0,'2013-11-09 16:30:00',NULL,NULL),(15,2014,'OH015',191.31,0,'2013-09-30 09:26:49',NULL,NULL),(13,2014,'OH013',222.54,0,'2013-09-30 09:26:49',NULL,NULL),(84,2014,'SC039',228.43,0,'2013-11-09 16:30:00',NULL,NULL),(94,2014,'PA003',177.84,0,'2014-02-04 16:44:48',NULL,NULL),(48,2014,'SC003',235.60,0,'2013-11-09 16:30:00',NULL,NULL),(59,2014,'SC014',200.06,0,'2013-11-09 16:30:00',NULL,NULL),(12,2014,'OH012',202.41,0,'2013-09-30 09:26:49',NULL,NULL),(25,2014,'VA008',223.87,0,'2013-09-30 09:35:46',NULL,NULL),(7,2014,'OH007',246.21,0,'2013-09-30 09:26:49',NULL,NULL),(28,2014,'VA011',214.48,0,'2013-09-30 09:35:46',NULL,NULL),(69,2014,'SC024',248.25,0,'2013-11-09 16:30:00',NULL,NULL),(36,2014,'NC007',217.72,0,'2013-11-09 16:30:00',NULL,NULL),(104,2014,'GA004',203.96,0,'2014-02-04 16:44:48',NULL,NULL),(85,2014,'SC040',210.23,0,'2013-11-09 16:30:00',NULL,NULL),(54,2014,'SC009',187.12,0,'2013-11-09 16:30:00',NULL,NULL),(86,2014,'SC041',228.97,0,'2013-11-09 16:30:00',NULL,NULL),(47,2014,'SC002',243.29,0,'2013-11-09 16:30:00',NULL,NULL),(4,2014,'OH004',186.61,0,'2013-09-30 09:26:49',NULL,NULL),(107,2014,'GA007',273.64,0,'2014-02-04 16:44:48',NULL,NULL),(24,2014,'VA007',198.01,0,'2013-09-30 09:35:46',NULL,NULL),(40,2014,'NC011',210.47,0,'2013-11-09 16:30:00',NULL,NULL),(8,2014,'OH008',197.90,0,'2013-09-30 09:26:49',NULL,NULL),(77,2014,'SC032',212.86,0,'2013-11-09 16:30:00',NULL,NULL),(31,2014,'NC002',244.95,0,'2013-11-09 16:30:00',NULL,NULL),(51,2014,'SC006',243.29,0,'2013-11-09 16:30:00',NULL,NULL),(71,2014,'SC026',207.14,0,'2013-11-09 16:30:00',NULL,NULL),(29,2014,'VA012',208.63,0,'2013-09-30 09:35:46',NULL,NULL),(49,2014,'SC004',228.43,0,'2013-11-09 16:30:00',NULL,NULL),(109,2014,'GA009',262.59,0,'2014-02-04 16:44:48',NULL,NULL),(105,2014,'GA005',198.59,0,'2014-02-04 16:44:48',NULL,NULL),(43,2014,'NC014',232.95,0,'2013-11-09 16:30:00',NULL,NULL),(98,2014,'PA007',159.99,0,'2014-02-04 16:44:48',NULL,NULL),(76,2014,'SC031',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(1,2014,'OH001',189.97,0,'2013-09-30 09:26:49',NULL,NULL),(58,2014,'SC013',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(92,2014,'PA001',133.00,0,'2014-02-04 16:44:48',NULL,NULL),(88,2014,'SC043',200.06,0,'2013-11-09 16:30:00',NULL,NULL),(42,2014,'NC013',211.73,0,'2013-11-09 16:30:00',NULL,NULL),(34,2014,'NC005',226.76,0,'2013-11-09 16:30:00',NULL,NULL),(27,2014,'VA010',212.76,0,'2013-09-30 09:35:46',NULL,NULL),(67,2014,'SC022',207.14,0,'2013-11-09 16:30:00',NULL,NULL),(89,2014,'SC044',210.87,0,'2013-11-09 16:30:00',NULL,NULL),(99,2014,'PA008',234.85,0,'2014-02-04 16:44:48',NULL,NULL),(44,2014,'NC015',237.42,0,'2013-11-09 16:30:00',NULL,NULL),(82,2014,'SC037',228.43,0,'2013-11-09 16:30:00',NULL,NULL),(21,2014,'VA004',213.78,0,'2013-09-30 09:35:45',NULL,NULL),(55,2014,'SC010',189.24,0,'2013-11-09 16:30:00',NULL,NULL),(14,2014,'OH014',213.70,0,'2013-09-30 09:26:49',NULL,NULL),(108,2014,'GA008',199.56,0,'2014-02-04 16:44:48',NULL,NULL),(78,2014,'SC033',241.62,0,'2013-11-09 16:30:00',NULL,NULL),(17,2014,'OH017',278.30,0,'2013-09-30 09:26:49',NULL,NULL),(9,2014,'OH009',249.00,0,'2013-09-30 09:26:49',NULL,NULL),(2,2014,'OH002',229.83,0,'2013-09-30 09:26:49',NULL,NULL),(114,2014,'GA014',192.41,0,'2014-02-04 16:44:48',NULL,NULL),(53,2014,'SC008',189.24,0,'2013-11-09 16:30:00',NULL,NULL),(95,2014,'PA004',133.00,0,'2014-02-04 16:44:48',NULL,NULL),(91,2014,'SC046',233.19,0,'2013-11-09 16:30:00',NULL,NULL),(63,2014,'SC018',189.24,0,'2013-11-09 16:30:00',NULL,NULL),(100,2014,'PA009',148.86,0,'2014-02-04 16:44:48',NULL,NULL),(56,2014,'SC011',210.87,0,'2013-11-09 16:30:00',NULL,NULL),(45,2014,'NC016',247.65,0,'2013-11-09 16:30:00',NULL,NULL),(66,2014,'SC021',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(37,2014,'NC008',230.49,0,'2013-11-09 16:30:00',NULL,NULL),(80,2014,'SC035',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(83,2014,'SC038',187.12,0,'2013-11-09 16:30:00',NULL,NULL),(112,2014,'GA012',234.25,0,'2014-02-04 16:44:48',NULL,NULL),(64,2014,'SC019',240.60,0,'2013-11-09 16:30:00',NULL,NULL),(20,2014,'VA003',218.64,0,'2013-09-30 09:35:45',NULL,NULL),(18,2014,'VA001',231.37,0,'2013-09-30 09:35:45',NULL,NULL),(72,2014,'SC027',180.01,0,'2013-11-09 16:30:00',NULL,NULL),(102,2014,'GA002',189.94,0,'2014-02-04 16:44:48',NULL,NULL),(115,2014,'GA015',345.14,0,'2014-02-04 16:44:48',NULL,NULL),(26,2014,'VA009',212.48,0,'2013-09-30 09:35:46',NULL,NULL),(70,2014,'SC025',180.01,0,'2013-11-09 16:30:00',NULL,NULL),(61,2014,'SC016',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(111,2014,'GA011',186.73,0,'2014-02-04 16:44:48',NULL,NULL),(5,2014,'OH005',197.90,0,'2013-09-30 09:26:49',NULL,NULL),(32,2014,'NC003',259.91,0,'2013-11-09 16:30:00',NULL,NULL),(113,2014,'GA013',209.14,0,'2014-02-04 16:44:48',NULL,NULL),(62,2014,'SC017',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(81,2014,'SC036',212.86,0,'2013-11-09 16:30:00',NULL,NULL),(116,2014,'GA016',195.77,0,'2014-02-04 16:44:48',NULL,NULL),(23,2014,'VA006',220.96,0,'2013-09-30 09:35:46',NULL,NULL),(97,2014,'PA006',151.59,0,'2014-02-04 16:44:48',NULL,NULL),(6,2014,'OH006',203.63,0,'2013-09-30 09:26:49',NULL,NULL),(96,2014,'PA005',167.43,0,'2014-02-04 16:44:48',NULL,NULL),(22,2014,'VA005',216.50,0,'2013-09-30 09:35:45',NULL,NULL),(73,2014,'SC028',210.23,0,'2013-11-09 16:30:00',NULL,NULL),(103,2014,'GA003',195.98,0,'2014-02-04 16:44:48',NULL,NULL),(57,2014,'SC012',239.81,0,'2013-11-09 16:30:00',NULL,NULL),(93,2014,'PA002',163.75,0,'2014-02-04 16:44:48',NULL,NULL),(79,2014,'SC034',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(3,2014,'OH003',202.41,0,'2013-09-30 09:26:49',NULL,NULL),(74,2014,'SC029',239.81,0,'2013-11-09 16:30:00',NULL,NULL),(10,2014,'OH010',274.94,0,'2013-09-30 09:26:49',NULL,NULL),(90,2014,'SC045',223.18,0,'2013-11-09 16:30:00',NULL,NULL),(35,2014,'NC006',234.75,0,'2013-11-09 16:30:00',NULL,NULL),(65,2014,'SC020',212.86,0,'2013-11-09 16:30:00',NULL,NULL),(68,2014,'SC023',225.61,0,'2013-11-09 16:30:00',NULL,NULL),(75,2014,'SC030',228.00,0,'2013-11-09 16:30:00',NULL,NULL),(38,2014,'NC009',257.46,0,'2013-11-09 16:30:00',NULL,NULL),(87,2014,'SC042',210.87,0,'2013-11-09 16:30:00',NULL,NULL),(106,2014,'GA006',189.56,0,'2014-02-04 16:44:48',NULL,NULL),(19,2014,'VA002',197.69,0,'2013-09-30 09:35:45',NULL,NULL),(33,2014,'NC004',239.84,0,'2013-11-09 16:30:00',NULL,NULL),(60,2014,'SC015',189.24,0,'2013-11-09 16:30:00',NULL,NULL);
/*!40000 ALTER TABLE `SilverPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `SilverPlanAgeFactor`
--

DROP TABLE IF EXISTS `SilverPlanAgeFactor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `SilverPlanAgeFactor` (
  `SilverPlanAgeFactorId` bigint(64) NOT NULL AUTO_INCREMENT,
  `BeginAge` int(11) NOT NULL,
  `EndAge` int(11) NOT NULL,
  `SilverPlanFactor` decimal(10,5) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`SilverPlanAgeFactorId`),
  UNIQUE KEY `SilverPlanAgeFactor_idx` (`BeginAge`,`EndAge`)
) ENGINE=innodb AUTO_INCREMENT=46 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `SilverPlanAgeFactor`
--

LOCK TABLES `SilverPlanAgeFactor` WRITE;
/*!40000 ALTER TABLE `SilverPlanAgeFactor` DISABLE KEYS */;
INSERT INTO `SilverPlanAgeFactor` VALUES (16,35,35,1.22200,0,'2013-09-30 09:26:47',NULL,NULL),(41,60,60,2.71400,0,'2013-09-30 09:26:49',NULL,NULL),(11,30,30,1.13500,0,'2013-09-30 09:26:47',NULL,NULL),(39,58,58,2.54800,0,'2013-09-30 09:26:49',NULL,NULL),(30,49,49,1.70600,0,'2013-09-30 09:26:48',NULL,NULL),(15,34,34,1.21400,0,'2013-09-30 09:26:47',NULL,NULL),(13,32,32,1.18300,0,'2013-09-30 09:26:47',NULL,NULL),(12,31,31,1.15900,0,'2013-09-30 09:26:47',NULL,NULL),(25,44,44,1.39700,0,'2013-09-30 09:26:48',NULL,NULL),(7,26,26,1.02400,0,'2013-09-30 09:26:47',NULL,NULL),(28,47,47,1.56300,0,'2013-09-30 09:26:48',NULL,NULL),(36,55,55,2.23000,0,'2013-09-30 09:26:48',NULL,NULL),(4,23,23,1.00000,0,'2013-09-30 09:26:47',NULL,NULL),(24,43,43,1.35700,0,'2013-09-30 09:26:48',NULL,NULL),(40,59,59,2.60300,0,'2013-09-30 09:26:49',NULL,NULL),(8,27,27,1.04800,0,'2013-09-30 09:26:47',NULL,NULL),(31,50,50,1.78600,0,'2013-09-30 09:26:48',NULL,NULL),(29,48,48,1.63500,0,'2013-09-30 09:26:48',NULL,NULL),(43,62,62,2.87300,0,'2013-09-30 09:26:49',NULL,NULL),(1,0,20,0.63500,0,'2013-09-30 09:26:46',NULL,NULL),(42,61,61,2.81000,0,'2013-09-30 09:26:49',NULL,NULL),(34,53,53,2.04000,0,'2013-09-30 09:26:48',NULL,NULL),(27,46,46,1.50000,0,'2013-09-30 09:26:48',NULL,NULL),(44,63,63,2.95200,0,'2013-09-30 09:26:49',NULL,NULL),(21,40,40,1.27800,0,'2013-09-30 09:26:48',NULL,NULL),(14,33,33,1.19800,0,'2013-09-30 09:26:47',NULL,NULL),(17,36,36,1.23000,0,'2013-09-30 09:26:47',NULL,NULL),(9,28,28,1.08700,0,'2013-09-30 09:26:47',NULL,NULL),(2,21,21,1.00000,0,'2013-09-30 09:26:46',NULL,NULL),(45,64,999,3.00000,0,'2013-09-30 09:26:49',NULL,NULL),(37,56,56,2.33300,0,'2013-09-30 09:26:49',NULL,NULL),(20,39,39,1.26200,0,'2013-09-30 09:26:48',NULL,NULL),(18,37,37,1.23800,0,'2013-09-30 09:26:47',NULL,NULL),(26,45,45,1.44400,0,'2013-09-30 09:26:48',NULL,NULL),(5,24,24,1.00400,0,'2013-09-30 09:26:47',NULL,NULL),(32,51,51,1.86500,0,'2013-09-30 09:26:48',NULL,NULL),(23,42,42,1.32500,0,'2013-09-30 09:26:48',NULL,NULL),(6,25,25,1.00400,0,'2013-09-30 09:26:47',NULL,NULL),(22,41,41,1.30200,0,'2013-09-30 09:26:48',NULL,NULL),(3,22,22,1.00000,0,'2013-09-30 09:26:47',NULL,NULL),(10,29,29,1.11900,0,'2013-09-30 09:26:47',NULL,NULL),(35,54,54,2.13500,0,'2013-09-30 09:26:48',NULL,NULL),(38,57,57,2.43700,0,'2013-09-30 09:26:49',NULL,NULL),(19,38,38,1.24600,0,'2013-09-30 09:26:48',NULL,NULL),(33,52,52,1.95200,0,'2013-09-30 09:26:48',NULL,NULL);
/*!40000 ALTER TABLE `SilverPlanAgeFactor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `State`
--

DROP TABLE IF EXISTS `State`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `State` (
  `StateId` bigint(64) NOT NULL AUTO_INCREMENT,
  `StateAbbreviation` char(2) NOT NULL,
  `State` varchar(100) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`StateId`),
  UNIQUE KEY `StateTable_StateAbbreviation_uq` (`StateAbbreviation`)
) ENGINE=innodb AUTO_INCREMENT=60 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `State`
--

LOCK TABLES `State` WRITE;
/*!40000 ALTER TABLE `State` DISABLE KEYS */;
INSERT INTO `State` VALUES (16,'IA','Iowa',1,'2013-07-31 19:28:20',NULL,NULL),(52,'UT','Utah',1,'2013-07-31 19:28:22',NULL,NULL),(41,'OH','Ohio',1,'2013-07-31 19:28:21',NULL,NULL),(46,'PW','Palau',1,'2013-07-31 19:28:22',NULL,NULL),(11,'FL','Florida',1,'2013-07-31 19:28:20',NULL,NULL),(39,'NV','Nevada',1,'2013-07-31 19:28:21',NULL,NULL),(50,'TN','Tennessee',1,'2013-07-31 19:28:22',NULL,NULL),(30,'MP','Northern Mariana Islands',1,'2013-07-31 19:28:21',NULL,NULL),(15,'HI','Hawaii',1,'2013-07-31 19:28:20',NULL,NULL),(13,'GA','Georgia',1,'2013-07-31 19:28:20',NULL,NULL),(48,'SC','South Carolina',1,'2013-07-31 19:28:22',NULL,NULL),(59,'WY','Wyoming',1,'2013-07-31 19:28:22',NULL,NULL),(12,'FM','Federated States of Micronesia',1,'2013-07-31 19:28:20',NULL,NULL),(25,'ME','Maine',1,'2013-07-31 19:28:21',NULL,NULL),(7,'CO','Colorado',1,'2013-07-31 19:28:20',NULL,NULL),(28,'MN','Minnesota',1,'2013-07-31 19:28:21',NULL,NULL),(36,'NH','New Hampshire',1,'2013-07-31 19:28:21',NULL,NULL),(54,'VI','U.S. Virgin Islands',1,'2013-07-31 19:28:22',NULL,NULL),(47,'RI','Rhode Island',1,'2013-07-31 19:28:22',NULL,NULL),(4,'AS','American Samoa',1,'2013-07-31 19:28:19',NULL,NULL),(24,'MD','Maryland',1,'2013-07-31 19:28:21',NULL,NULL),(40,'NY','New York',1,'2013-07-31 19:28:21',NULL,NULL),(8,'CT','Connecticut',1,'2013-07-31 19:28:20',NULL,NULL),(31,'MS','Mississippi',1,'2013-07-31 19:28:21',NULL,NULL),(51,'TX','Texas',1,'2013-07-31 19:28:22',NULL,NULL),(29,'MO','Missouri',1,'2013-07-31 19:28:21',NULL,NULL),(49,'SD','South Dakota',1,'2013-07-31 19:28:22',NULL,NULL),(43,'OR','Oregon',1,'2013-07-31 19:28:21',NULL,NULL),(1,'AK','Alaska',1,'2013-07-31 19:28:19',NULL,NULL),(58,'WV','West Virginia',1,'2013-07-31 19:28:22',NULL,NULL),(42,'OK','Oklahoma',1,'2013-07-31 19:28:21',NULL,NULL),(34,'ND','North Dakota',1,'2013-07-31 19:28:21',NULL,NULL),(27,'MI','Michigan',1,'2013-07-31 19:28:21',NULL,NULL),(5,'AZ','Arizona',1,'2013-07-31 19:28:19',NULL,NULL),(32,'MT','Montana',1,'2013-07-31 19:28:21',NULL,NULL),(23,'MA','Massachusetts',1,'2013-07-31 19:28:21',NULL,NULL),(6,'CA','California',1,'2013-07-31 19:28:20',NULL,NULL),(22,'LA','Louisiana',1,'2013-07-31 19:28:21',NULL,NULL),(57,'WI','Wisconsin',1,'2013-07-31 19:28:22',NULL,NULL),(3,'AR','Arkansas',1,'2013-07-31 19:28:19',NULL,NULL),(10,'DE','Delaware',1,'2013-07-31 19:28:20',NULL,NULL),(35,'NE','Nebraska',1,'2013-07-31 19:28:21',NULL,NULL),(38,'NM','New Mexico',1,'2013-07-31 19:28:21',NULL,NULL),(19,'IN','Indiana',1,'2013-07-31 19:28:20',NULL,NULL),(33,'NC','North Carolina',1,'2013-07-31 19:28:21',NULL,NULL),(56,'WA','Washington',1,'2013-07-31 19:28:22',NULL,NULL),(45,'PR','Puerto Rico',1,'2013-07-31 19:28:22',NULL,NULL),(37,'NJ','New Jersey',1,'2013-07-31 19:28:21',NULL,NULL),(20,'KS','Kansas',1,'2013-07-31 19:28:21',NULL,NULL),(18,'IL','Illinois',1,'2013-07-31 19:28:20',NULL,NULL),(26,'MH','Marshall Islands',1,'2013-07-31 19:28:21',NULL,NULL),(44,'PA','Pennsylvania',1,'2013-07-31 19:28:21',NULL,NULL),(21,'KY','Kentucky',1,'2013-07-31 19:28:21',NULL,NULL),(55,'VT','Vermont',1,'2013-07-31 19:28:22',NULL,NULL),(14,'GU','Guam',1,'2013-07-31 19:28:20',NULL,NULL),(17,'ID','Idaho',1,'2013-07-31 19:28:20',NULL,NULL),(9,'DC','District of Columbia',1,'2013-07-31 19:28:20',NULL,NULL),(2,'AL','Alabama',1,'2013-07-31 19:28:19',NULL,NULL),(53,'VA','Virginia',1,'2013-07-31 19:28:22',NULL,NULL);
/*!40000 ALTER TABLE `State` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `TechnicalSupport`
--

DROP TABLE IF EXISTS `TechnicalSupport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `TechnicalSupport` (
  `TechnicalSupportId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DisplayTitle` varchar(200) NOT NULL,
  `SortOrder` int(11) NOT NULL,
  `Row1` varchar(200) DEFAULT NULL,
  `Row2` varchar(200) DEFAULT NULL,
  `Row3` varchar(200) DEFAULT NULL,
  `Row4` varchar(200) DEFAULT NULL,
  `Row5` varchar(200) DEFAULT NULL,
  `Email` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`TechnicalSupportId`)
) ENGINE=innodb AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `TechnicalSupport`
--

LOCK TABLES `TechnicalSupport` WRITE;
/*!40000 ALTER TABLE `TechnicalSupport` DISABLE KEYS */;
/*!40000 ALTER TABLE `TechnicalSupport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `TierName`
--

DROP TABLE IF EXISTS `TierName`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `TierName` (
  `TierNameId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RatingTierValue` varchar(100) DEFAULT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`TierNameId`)
) ENGINE=innodb AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `TierName`
--

LOCK TABLES `TierName` WRITE;
/*!40000 ALTER TABLE `TierName` DISABLE KEYS */;
INSERT INTO `TierName` VALUES (7,'8-Tier',7,'Active',1,'2013-06-27 07:13:32',1,'2013-07-22 13:09:02'),(4,'4-Tier',4,'Active',1,'2013-06-27 07:12:48',1,'2013-07-22 09:43:21'),(8,'Pediatric Only 2-Tier',8,'Active',1,'2013-08-06 11:33:58',1,'2013-07-31 18:00:00'),(1,'1-Tier',1,'Active',1,'2013-06-21 18:34:03',1,'2013-07-22 09:42:59'),(9,'3-Tier WS',10,'Active',1,'2013-09-02 04:03:05',NULL,NULL),(2,'2-Tier',2,'Active',1,'2013-06-21 18:34:03',1,'2013-07-22 09:43:06'),(3,'3-Tier',3,'Active',1,'2013-06-27 07:12:48',1,'2013-07-22 09:43:13'),(10,'Pediatric Only 3-Tier',9,'Active',1,'2013-09-29 14:45:38',NULL,NULL),(5,'5-Tier',5,'Active',1,'2013-06-27 07:12:59',1,'2013-07-22 09:42:53'),(6,'6-Tier',6,'Active',1,'2013-06-27 07:12:59',1,'2013-07-22 09:42:43');
/*!40000 ALTER TABLE `TierName` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `TierNameValue`
--

DROP TABLE IF EXISTS `TierNameValue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `TierNameValue` (
  `TierNameValueId` bigint(64) NOT NULL AUTO_INCREMENT,
  `TierNameId` bigint(64) NOT NULL,
  `TierNameValue` varchar(100) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `SortKey` int(11) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`TierNameValueId`),
  KEY `TierNameValueRefTierName_fk_idx` (`TierNameId`)
) ENGINE=innodb AUTO_INCREMENT=41 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `TierNameValue`
--

LOCK TABLES `TierNameValue` WRITE;
/*!40000 ALTER TABLE `TierNameValue` DISABLE KEYS */;
INSERT INTO `TierNameValue` VALUES (16,6,'Single','Active',1,1,'2013-06-27 07:15:49',NULL,NULL),(11,5,'Single','Active',1,1,'2013-06-27 07:15:05',NULL,NULL),(15,5,'Family','Active',5,1,'2013-06-27 07:15:32',NULL,NULL),(13,5,'EE+CH','Active',3,1,'2013-06-27 07:15:14',NULL,NULL),(8,4,'EE+SP','Active',2,1,'2013-06-27 07:14:35',NULL,NULL),(31,8,'Pediatric Only 1 CH','Active',1,1,'2013-08-13 08:42:51',NULL,NULL),(29,7,'F3+CH','Active',8,1,'2013-06-27 07:17:46',NULL,NULL),(1,1,'Single','Active',1,1,'2013-06-21 18:34:23',NULL,NULL),(34,9,'Single Parent Family','Active',2,1,'2013-09-02 04:04:00',NULL,NULL),(27,7,'Family','Active',6,1,'2013-06-27 07:17:36',NULL,NULL),(12,5,'EE+SP','Active',2,1,'2013-06-27 07:15:10',NULL,NULL),(25,7,'EE2CH','Active',4,1,'2013-06-27 07:17:25',NULL,NULL),(7,4,'Single','Active',1,1,'2013-06-27 07:14:22',NULL,NULL),(28,7,'F2CH','Active',7,1,'2013-06-27 07:17:41',NULL,NULL),(36,10,'Pediatric Only 1 CH','Active',1,1,'2013-09-29 14:45:47',NULL,NULL),(4,3,'Single','Active',1,1,'2013-06-27 07:14:02',NULL,NULL),(24,7,'EE+CH','Active',3,1,'2013-06-27 07:17:08',NULL,NULL),(40,10,'Pediatric Only 3+ CH','Active',3,1,'2013-09-29 15:06:27',NULL,NULL),(21,6,'F2+CH','Active',6,1,'2013-06-27 07:16:31',NULL,NULL),(14,5,'EE2+CH','Active',4,1,'2013-06-27 07:15:26',NULL,NULL),(17,6,'EE+SP','Active',2,1,'2013-06-27 07:15:56',NULL,NULL),(9,4,'EE+CH','Active',3,1,'2013-06-27 07:14:39',NULL,NULL),(2,2,'Single','Active',1,1,'2013-06-21 18:34:35',NULL,NULL),(3,2,'Family','Active',2,1,'2013-06-21 18:34:41',NULL,NULL),(10,4,'Family','Active',4,1,'2013-06-27 07:14:45',NULL,NULL),(35,9,'Family','Active',3,1,'2013-09-02 04:04:21',NULL,NULL),(19,6,'EE2+CH','Active',4,1,'2013-06-27 07:16:04',NULL,NULL),(33,9,'Individual','Active',1,1,'2013-09-02 04:03:33',NULL,NULL),(5,3,'2-Person','Active',2,1,'2013-06-27 07:14:09',NULL,NULL),(32,8,'Pediatric Only 2+ CH','Active',2,1,'2013-08-13 08:43:04',NULL,NULL),(23,7,'EE+SP','Active',2,1,'2013-06-27 07:17:04',NULL,NULL),(6,3,'Family','Active',3,1,'2013-06-27 07:14:16',NULL,NULL),(22,7,'Single','Active',1,1,'2013-06-27 07:17:00',NULL,NULL),(37,10,'Pediatric Only 2 CH','Active',2,1,'2013-09-29 14:45:47',NULL,NULL),(20,6,'Family','Active',5,1,'2013-06-27 07:16:12',NULL,NULL),(18,6,'EE+CH','Active',3,1,'2013-06-27 07:16:01',NULL,NULL),(26,7,'EE3+CH','Active',5,1,'2013-06-27 07:17:31',NULL,NULL);
/*!40000 ALTER TABLE `TierNameValue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `User`
--

DROP TABLE IF EXISTS `User`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `User` (
  `UserId` bigint(64) NOT NULL AUTO_INCREMENT,
  `RoleId` bigint(64) NOT NULL,
  `ContactDetailId` bigint(64) NOT NULL,
  `DomainId` bigint(64) NOT NULL,
  `DomainTerminationReasonId` bigint(64) DEFAULT NULL,
  `DepartmentId` bigint(64) DEFAULT NULL,
  `LocationId` bigint(64) DEFAULT NULL,
  `JobTitleId` bigint(64) DEFAULT NULL,
  `EmployerClassId` bigint(64) DEFAULT NULL,
  `UserName` varchar(60) NOT NULL,
  `Password` varchar(255) NOT NULL,
  `LastPasswordChangeDate` date DEFAULT NULL,
  `LoginAttemptsCount` smallint(16) NOT NULL DEFAULT '0',
  `Status` enum('Active','Locked','Suspended','MustChgPswrd','Deleted','MustSignAgreement') NOT NULL DEFAULT 'MustSignAgreement',
  `EnrollmentStatus` enum('Enrolled','Pending','Transmitted','Not Enrolled') NOT NULL DEFAULT 'Pending',
  `AgreementAcceptedDate` timestamp NULL DEFAULT NULL,
  `Theme` enum('orange','blue','green','yellow','red','pink','purple','darkcyan','darkblue','gray','mediumblue','lightblue','lightbrown') NOT NULL DEFAULT 'blue',
  `EmployeeId` varchar(60) DEFAULT NULL,
  `HireDate` date DEFAULT NULL,
  `Token` varchar(60) DEFAULT NULL,
  `SignaturePath` varchar(100) DEFAULT NULL,
  `MaritalStatus` enum('Single','Married','Divorced','Widowed','Legally Separated') DEFAULT NULL,
  `IsUserOnly` tinyint(1) NOT NULL DEFAULT '0',
  `Salary` varchar(200) DEFAULT NULL,
  `SalaryEffectiveDate` date DEFAULT NULL,
  `SalaryType` enum('Hourly Rate','Annual Salary') DEFAULT NULL,
  `IncomeType` enum('W-2','1099','Other') DEFAULT NULL,
  `UserStatus` enum('Active','Terminated') NOT NULL DEFAULT 'Active',
  `IsIndividual` tinyint(1) NOT NULL DEFAULT '0',
  `IsQuoteIndividualOnly` tinyint(1) NOT NULL DEFAULT '0',
  `IsFFM` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserId`),
  UNIQUE KEY `User_UserName_uq` (`UserName`),
  UNIQUE KEY `UserRefContactDetail_fk_idx` (`ContactDetailId`),
  KEY `UserRefRole_fk_idx` (`RoleId`),
  KEY `UserRefDomain_fk_idx` (`DomainId`),
  KEY `UserRefDepartment_fk_idx` (`DepartmentId`),
  KEY `UserRefLocation_fk_idx` (`LocationId`),
  KEY `UserRefDomainTerminationReason_fk_idx` (`DomainTerminationReasonId`),
  KEY `UserRefJobTitle_fk_idx` (`JobTitleId`),
  KEY `UserRefEmployerClass_fk_idx` (`EmployerClassId`)
) ENGINE=innodb AUTO_INCREMENT=130 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `User`
--

LOCK TABLES `User` WRITE;
/*!40000 ALTER TABLE `User` DISABLE KEYS */;
INSERT INTO `User` VALUES (1,1,1,1,NULL,NULL,NULL,NULL,NULL,'administrator','891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-03-10',0,'Active','Pending','2013-07-31 21:00:00','blue',NULL,NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2013-08-13 11:30:28',1,'2014-03-10 15:57:00'),(82,78,4,2,NULL,21,NULL,11,NULL,'employer','891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a',NULL,0,'Active','Pending',NULL,'blue',NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2008-01-08 10:56:29',NULL,NULL),(81,77,3,2,NULL,21,NULL,11,NULL,'broker','891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a',NULL,0,'Active','Pending',NULL,'blue',NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2008-01-08 10:55:58',NULL,NULL),(80,75,2,2,NULL,21,NULL,11,NULL,'provider','891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2008-01-08',1,'MustChgPswrd','Pending',NULL,'blue',NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2008-01-08 10:55:01',80,'2013-09-26 17:50:17');
/*!40000 ALTER TABLE `User` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserBankAccount`
--

DROP TABLE IF EXISTS `UserBankAccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserBankAccount` (
  `UserBankAccountId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `AddressId` bigint(64) DEFAULT NULL,
  `BankAccountType` enum('Checking','Savings') NOT NULL,
  `BankName` varchar(100) NOT NULL,
  `AccountNumber` varchar(50) NOT NULL,
  `AccountNumberLastFour` char(4) NOT NULL,
  `AccountRoutingNumber` varchar(40) NOT NULL,
  `AccountRoutingNumberLastFour` char(4) NOT NULL,
  `StartDate` date NOT NULL,
  `PercentSplit` int(32) NOT NULL,
  `PercentSplitType` enum('Dollars','Percentage') NOT NULL DEFAULT 'Percentage',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserBankAccountId`),
  KEY `UserBankAccountRefUser_fk_idx` (`UserId`),
  KEY `UserBankAccountRefAddress_fk_idx` (`AddressId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserBankAccount`
--

LOCK TABLES `UserBankAccount` WRITE;
/*!40000 ALTER TABLE `UserBankAccount` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserBankAccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserCustomValue`
--

DROP TABLE IF EXISTS `UserCustomValue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserCustomValue` (
  `UserCustomValuesId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DomainCustomFieldId` bigint(64) NOT NULL,
  `NumericValue` int(32) DEFAULT NULL,
  `TextValue` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `CurrencyValue` decimal(10,2) DEFAULT NULL,
  `DateValue` date DEFAULT NULL,
  `DateTimeValue` datetime DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserCustomValuesId`),
  KEY `UserCustomValueRefUser_fk_idx` (`UserId`),
  KEY `UserCustomValueRefDomainCustomField_fk_idx` (`DomainCustomFieldId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserCustomValue`
--

LOCK TABLES `UserCustomValue` WRITE;
/*!40000 ALTER TABLE `UserCustomValue` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserCustomValue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserDocument`
--

DROP TABLE IF EXISTS `UserDocument`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserDocument` (
  `UserDocumentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DocumentName` varchar(100) NOT NULL,
  `ObjectName` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserDocumentId`),
  KEY `UserDocumentRefUser_fk_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserDocument`
--

LOCK TABLES `UserDocument` WRITE;
/*!40000 ALTER TABLE `UserDocument` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserDocument` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserEmploymentHistory`
--

DROP TABLE IF EXISTS `UserEmploymentHistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserEmploymentHistory` (
  `UserEmploymentHistoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `TerminationDate` date DEFAULT NULL,
  `HiringDate` date DEFAULT NULL,
  `EmployerClassId` bigint(64) DEFAULT NULL,
  `DomainTerminationReasonId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserEmploymentHistoryId`),
  KEY `UserEmploymentHistoryRefUser_fk_idx` (`UserId`),
  KEY `UserEmploymentHistoryRefDomainTerminationReason_fk_idx` (`DomainTerminationReasonId`),
  KEY `UserEmploymentHistoryRefEmployerClass_fk_idx` (`EmployerClassId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserEmploymentHistory`
--

LOCK TABLES `UserEmploymentHistory` WRITE;
/*!40000 ALTER TABLE `UserEmploymentHistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserEmploymentHistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserFunctionOverride`
--

DROP TABLE IF EXISTS `UserFunctionOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserFunctionOverride` (
  `UserFunctionOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ViewId` bigint(64) NOT NULL,
  `FunctionId` bigint(64) NOT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `FunctionName` varchar(200) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `FunctionEntryURL` varchar(200) DEFAULT NULL,
  `AllowToAdd` tinyint(1) DEFAULT '1',
  `AllowToDelete` tinyint(1) DEFAULT '1',
  `AllowToUpdate` tinyint(1) DEFAULT '1',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserFunctionOverrideId`),
  KEY `UserFunctionOverrideRefUser_fk_idx` (`UserId`),
  KEY `UserFunctionOverrideRefAppView_fk_idx` (`ViewId`),
  KEY `UserFunctionOverrideRefFunction_fk_idx` (`FunctionId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserFunctionOverride`
--

LOCK TABLES `UserFunctionOverride` WRITE;
/*!40000 ALTER TABLE `UserFunctionOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserFunctionOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserH`
--

DROP TABLE IF EXISTS `UserH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserH` (
  `UserHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `InsertDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `UserId` bigint(64) NOT NULL,
  `RoleId` bigint(64) NOT NULL,
  `ContactDetailHId` bigint(64) NOT NULL,
  `PrimaryManagerUserId` bigint(64) DEFAULT NULL,
  `UserName` varchar(60) NOT NULL,
  `DomainClassId` bigint(64) DEFAULT NULL,
  `Password` varchar(255) NOT NULL,
  `LastPasswordChangeDate` date DEFAULT NULL,
  `LoginAttemptsCount` smallint(16) NOT NULL DEFAULT '0',
  `DepartmentId` bigint(64) DEFAULT NULL,
  `LocationId` bigint(64) DEFAULT NULL,
  `DomainId` bigint(64) NOT NULL,
  `Status` enum('Active','Locked','Suspended','MustChgPswrd','Deleted','MustSignAgreement') NOT NULL DEFAULT 'MustSignAgreement',
  `AgreementAcceptedDate` timestamp NULL DEFAULT NULL,
  `SubDepartmentId` bigint(64) DEFAULT NULL,
  `Theme` enum('orange','blue','green','yellow','red','pink','purple','darkcyan','darkblue','gray','mediumblue','lightblue','lightbrown') NOT NULL DEFAULT 'blue',
  `EmployeeId` varchar(60) DEFAULT NULL,
  `HireDate` date DEFAULT NULL,
  `TerminationDate` date DEFAULT NULL,
  `JobTitleId` bigint(64) DEFAULT NULL,
  `IsUserOnly` tinyint(1) NOT NULL DEFAULT '0',
  `SignaturePath` varchar(100) DEFAULT NULL,
  `Token` varchar(60) DEFAULT NULL,
  `MaritalStatus` enum('Married','Single','Divorced','Widowed','Legally Separated') DEFAULT NULL,
  `Salary` varchar(200) DEFAULT NULL,
  `SalaryEffectiveDate` date DEFAULT NULL,
  `SalaryType` enum('Hourly Rate','Annual Salary') DEFAULT NULL,
  `IncomeType` enum('W2','1099','Other') DEFAULT NULL,
  `DomainTerminationReasonId` bigint(64) DEFAULT NULL,
  `UserStatus` enum('Active','Terminated') DEFAULT NULL,
  `IsQuoteIndividualOnly` tinyint(1) NOT NULL DEFAULT '0',
  `IsIndividual` tinyint(1) NOT NULL DEFAULT '0',
  `IsFFM` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserHId`),
  KEY `UserHRefUser_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=61 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserH`
--

LOCK TABLES `UserH` WRITE;
/*!40000 ALTER TABLE `UserH` DISABLE KEYS */;
INSERT INTO `UserH` VALUES (16,'2014-01-08 23:25:25',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-08 18:25:25',1,'2014-01-08 05:18:35'),(52,'2014-02-09 15:19:16',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-09 10:19:16',1,'2014-02-07 08:45:03'),(41,'2014-01-22 08:21:02',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-22 03:21:02',1,'2014-01-20 05:44:03'),(46,'2014-01-27 08:57:08',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-27 03:57:08',1,'2014-01-27 03:23:07'),(11,'2014-01-07 16:06:00',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 11:06:00',1,'2014-01-07 10:25:21'),(39,'2014-01-17 07:59:24',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-17 02:59:24',1,'2014-01-16 08:33:24'),(50,'2014-02-03 14:19:15',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-03 09:19:15',1,'2014-02-03 09:10:33'),(30,'2014-01-15 03:47:20',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-14 22:47:20',1,'2014-01-14 08:32:28'),(15,'2014-01-08 10:18:35',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-08 05:18:35',1,'2014-01-07 18:55:45'),(13,'2014-01-07 19:01:19',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 14:01:19',1,'2014-01-07 12:14:40'),(48,'2014-01-29 18:38:23',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-29 13:38:23',1,'2014-01-29 12:07:06'),(59,'2014-03-10 16:45:36',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',0,NULL,NULL,1,'MustChgPswrd','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-03-10 12:45:36',1,'2014-03-10 12:45:13'),(12,'2014-01-07 17:14:40',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 12:14:40',1,'2014-01-07 11:06:00'),(25,'2014-01-13 10:22:19',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-13 05:22:19',1,'2014-01-13 03:22:49'),(7,'2014-01-07 12:12:12',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 07:12:12',1,'2014-01-07 06:14:21'),(28,'2014-01-14 13:19:32',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-14 08:19:32',1,'2014-01-14 07:11:10'),(36,'2014-01-15 21:34:38',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 16:34:38',1,'2014-01-15 09:02:06'),(54,'2014-02-20 15:45:10',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-20 10:45:10',1,'2014-02-20 04:06:55'),(47,'2014-01-29 17:07:06',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-29 12:07:06',1,'2014-01-27 03:57:08'),(4,'2014-01-07 08:44:30',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 03:44:30',1,'2014-01-07 03:33:15'),(24,'2014-01-13 08:22:49',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-13 03:22:49',1,'2014-01-13 01:57:02'),(40,'2014-01-20 10:44:03',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-20 05:44:03',1,'2014-01-17 02:59:24'),(8,'2014-01-07 12:35:02',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 07:35:02',1,'2014-01-07 07:12:12'),(31,'2014-01-15 04:11:14',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-14 23:11:14',1,'2014-01-14 22:47:20'),(51,'2014-02-07 13:45:03',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-07 08:45:03',1,'2014-02-03 09:19:15'),(29,'2014-01-14 13:32:28',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-14 08:32:28',1,'2014-01-14 08:19:32'),(49,'2014-02-03 14:10:33',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-03 09:10:33',1,'2014-01-29 13:38:23'),(43,'2014-01-24 10:16:21',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-24 05:16:21',1,'2014-01-23 03:39:51'),(1,'2014-01-06 15:47:54',1,1,0,NULL,'administrator',NULL,'bc547750b92797f955b36112cc9bdd5cddf7d0862151d03a167ada8995aa24a9ad24610b36a68bc02da24141ee51670aea13ed6469099a4453f335cb239db5da','2013-08-01',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-06 10:47:54',1,'2013-09-26 17:50:31'),(58,'2014-03-10 16:45:13',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-03-10 12:45:13',1,'2014-02-28 21:17:46'),(42,'2014-01-23 08:39:51',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-23 03:39:51',1,'2014-01-22 03:21:02'),(34,'2014-01-15 08:35:33',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 03:35:33',1,'2014-01-15 02:10:27'),(27,'2014-01-14 12:11:10',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-14 07:11:10',1,'2014-01-13 22:06:58'),(5,'2014-01-07 08:45:38',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 03:45:38',1,'2014-01-07 03:44:30'),(32,'2014-01-15 05:08:37',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 00:08:37',1,'2014-01-14 23:11:14'),(23,'2014-01-13 06:57:02',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-13 01:57:02',1,'2014-01-10 17:26:56'),(6,'2014-01-07 11:14:21',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 06:14:21',1,'2014-01-07 03:45:38'),(22,'2014-01-10 22:26:56',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-10 17:26:56',1,'2014-01-09 11:58:02'),(57,'2014-03-01 02:17:46',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-28 21:17:46',1,'2014-02-25 11:56:51'),(44,'2014-01-24 10:20:17',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-24 05:20:17',1,'2014-01-24 05:16:21'),(21,'2014-01-09 16:58:02',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-09 11:58:02',1,'2014-01-09 10:19:45'),(55,'2014-02-24 14:09:21',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-24 09:09:21',1,'2014-02-20 10:45:11'),(14,'2014-01-07 23:55:44',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 18:55:44',1,'2014-01-07 14:01:19'),(17,'2014-01-08 23:25:51',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-08 18:25:51',1,'2014-01-08 18:25:25'),(9,'2014-01-07 14:23:35',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 09:23:35',1,'2014-01-07 07:35:02'),(2,'2014-01-06 15:48:13',1,1,0,NULL,'administrator',NULL,'bc547750b92797f955b36112cc9bdd5cddf7d0862151d03a167ada8995aa24a9ad24610b36a68bc02da24141ee51670aea13ed6469099a4453f335cb239db5da','2013-08-01',0,NULL,NULL,1,'MustChgPswrd','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-06 10:48:13',1,'2014-01-06 10:47:54'),(53,'2014-02-20 09:06:50',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-20 04:06:50',1,'2014-02-09 10:19:16'),(56,'2014-02-25 16:56:51',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-02-25 11:56:51',1,'2014-02-24 09:09:21'),(45,'2014-01-27 08:23:07',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-27 03:23:07',1,'2014-01-24 05:20:17'),(37,'2014-01-16 03:20:57',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 22:20:57',1,'2014-01-15 16:34:38'),(20,'2014-01-09 15:19:45',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-09 10:19:45',1,'2014-01-09 10:10:54'),(18,'2014-01-09 14:45:46',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-09 09:45:46',1,'2014-01-08 18:25:51'),(26,'2014-01-14 03:06:58',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',1,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-13 22:06:58',1,'2014-01-13 05:22:19'),(3,'2014-01-07 08:33:15',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 03:33:15',1,'2014-01-06 10:48:13'),(10,'2014-01-07 15:25:21',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-07 10:25:21',1,'2014-01-07 09:23:35'),(35,'2014-01-15 14:02:05',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 09:02:05',1,'2014-01-15 03:35:33'),(38,'2014-01-16 13:33:24',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-16 08:33:24',1,'2014-01-15 22:20:57'),(19,'2014-01-09 15:10:54',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-09 10:10:54',1,'2014-01-09 09:45:46'),(33,'2014-01-15 07:10:27',1,1,0,NULL,'administrator',NULL,'92a891f888e79d1c2e8b82663c0f37cc6d61466c508ec62b8132588afe354712b20bb75429aa20aa3ab7cfcc58836c734306b43efd368080a2250831bf7f363f','2014-01-06',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-01-15 02:10:27',1,'2014-01-15 00:08:37'),(60,'2014-03-10 19:56:59',1,1,0,NULL,'administrator',NULL,'891425d548628b89dc101a70c0ad1d1684397936efe62d7c52832d34e6b2ec2ad3fa2e265015478d96604384c0781c9ec30e432fac602633aa3475f5b1d9076a','2014-03-10',0,NULL,NULL,1,'Active','2013-07-31 21:00:00',NULL,'blue',NULL,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Active',0,0,0,1,'2014-03-10 15:56:59',1,'2014-03-10 12:45:36');
/*!40000 ALTER TABLE `UserH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserHomePageUrl`
--

DROP TABLE IF EXISTS `UserHomePageUrl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserHomePageUrl` (
  `UserHomePageUrlId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `FunctionEntryUrl` varchar(200) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserHomePageUrlId`),
  KEY `UserHomePageUrlRefUser_fk_idx` (`UserId`)
) ENGINE=innodb AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserHomePageUrl`
--

LOCK TABLES `UserHomePageUrl` WRITE;
/*!40000 ALTER TABLE `UserHomePageUrl` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserHomePageUrl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserModuleOverride`
--

DROP TABLE IF EXISTS `UserModuleOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserModuleOverride` (
  `UserModuleOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) DEFAULT NULL,
  `AppModuleId` bigint(64) NOT NULL,
  `ModuleName` varchar(100) DEFAULT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `IsHidden` tinyint(1) NOT NULL DEFAULT '0',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserModuleOverrideId`),
  KEY `UserModuleOverrideRefUser_fk_idx` (`UserId`),
  KEY `UserModuleOverrideRefAppModule_fk_idx` (`AppModuleId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserModuleOverride`
--

LOCK TABLES `UserModuleOverride` WRITE;
/*!40000 ALTER TABLE `UserModuleOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserModuleOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserPayment`
--

DROP TABLE IF EXISTS `UserPayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserPayment` (
  `UserPaymentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `PublicQuoteId` bigint(64) DEFAULT NULL,
  `PaymentDate` timestamp NULL DEFAULT NULL,
  `Type` enum('Payment','Refund') NOT NULL,
  `PaymentStatus` enum('Accepted','Declined','Did Not Pay','Error') NOT NULL,
  `DayOfMonthDue` int(11) NOT NULL DEFAULT '15',
  `NumberOfPayments` int(11) NOT NULL DEFAULT '12',
  `PaymentSchedule` enum('Monthly','Paid In Full') DEFAULT NULL,
  `Amount` decimal(10,2) NOT NULL,
  `PaymentTransactionId` varchar(20) DEFAULT NULL,
  `ResponseReferenceId` varchar(50) DEFAULT NULL,
  `PaymentProvider` varchar(100) DEFAULT NULL,
  `ErrorMessage` varchar(1000) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserPaymentId`),
  KEY `UserPaymentRefUser_fk_idx` (`UserId`),
  KEY `UserPaymentRefPublicQuote_fk_idx` (`PublicQuoteId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserPayment`
--

LOCK TABLES `UserPayment` WRITE;
/*!40000 ALTER TABLE `UserPayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserPayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserPaymentH`
--

DROP TABLE IF EXISTS `UserPaymentH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserPaymentH` (
  `UserPaymentHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserPaymentId` bigint(64) NOT NULL,
  `UserId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `PublicQuoteId` bigint(64) DEFAULT NULL,
  `PaymentDate` timestamp NULL DEFAULT NULL,
  `Type` enum('Payment','Refund') NOT NULL,
  `PaymentStatus` enum('Accepted','Declined','Did Not Pay','Error') NOT NULL,
  `DayOfMonthDue` int(11) NOT NULL DEFAULT '15',
  `NumberOfPayments` int(11) NOT NULL DEFAULT '12',
  `PaymentSchedule` enum('Monthly','Paid In Full') DEFAULT 'Monthly',
  `Amount` decimal(10,2) NOT NULL,
  `PaymentTransactionId` varchar(20) DEFAULT NULL,
  `ResponseReferenceId` varchar(50) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `PaymentProvider` varchar(100) DEFAULT NULL,
  `ErrorMessage` varchar(1000) DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserPaymentHId`),
  KEY `UserPaymentHRefUserPayment_fk_idx` (`UserPaymentId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserPaymentH`
--

LOCK TABLES `UserPaymentH` WRITE;
/*!40000 ALTER TABLE `UserPaymentH` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserPaymentH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserPaymentTracking`
--

DROP TABLE IF EXISTS `UserPaymentTracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserPaymentTracking` (
  `UserPaymentTrackingId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserPaymentId` bigint(64) DEFAULT NULL,
  `Url` varchar(500) DEFAULT NULL,
  `PostText` varchar(500) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL DEFAULT '0',
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserPaymentTrackingId`),
  KEY `UserPaymentTrackingRefUserPayment_fk_idx` (`UserPaymentId`)
) ENGINE=innodb DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserPaymentTracking`
--

LOCK TABLES `UserPaymentTracking` WRITE;
/*!40000 ALTER TABLE `UserPaymentTracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserPaymentTracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserPayrollAddition`
--

DROP TABLE IF EXISTS `UserPayrollAddition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserPayrollAddition` (
  `UserPayrollAdditionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DomainPayrollAdditionCategoryId` bigint(64) NOT NULL,
  `DomainPayrollAdditionSubCategoryId` bigint(64) DEFAULT NULL,
  `TaxableStatus` enum('Taxable','Non-Taxable') NOT NULL,
  `AdditionsDate` date NOT NULL,
  `AdditionsAmount` decimal(10,2) NOT NULL,
  `DeductionAmount` decimal(10,2) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserPayrollAdditionId`),
  KEY `UserPayrollAdditionRefUser_fk_idx` (`UserId`),
  KEY `UserPayrollAdditionRefDomainPayrollAdditionsCategory_fk_idx` (`DomainPayrollAdditionCategoryId`),
  KEY `UserPayrollAdditionRefDomainPayrollAdditionsSubCategory_fk_idx` (`DomainPayrollAdditionSubCategoryId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserPayrollAddition`
--

LOCK TABLES `UserPayrollAddition` WRITE;
/*!40000 ALTER TABLE `UserPayrollAddition` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserPayrollAddition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserPayrollDeduction`
--

DROP TABLE IF EXISTS `UserPayrollDeduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserPayrollDeduction` (
  `UserPayrollDeductionId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `DomainPayrollDeductionTypeId` bigint(64) NOT NULL,
  `StartDate` datetime NOT NULL,
  `EndDate` datetime NOT NULL,
  `TaxStatus` enum('Post-Tax','Pre-Tax') NOT NULL,
  `DeductionFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') NOT NULL,
  `DeductionAmount` decimal(10,2) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserPayrollDeductionId`),
  KEY `UserPayrollDeductionRefUser_fk_idx` (`UserId`),
  KEY `UserPayrollDeductionRefDomainPayrollDeductionTypeId_idx` (`DomainPayrollDeductionTypeId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserPayrollDeduction`
--

LOCK TABLES `UserPayrollDeduction` WRITE;
/*!40000 ALTER TABLE `UserPayrollDeduction` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserPayrollDeduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserSalaryHistory`
--

DROP TABLE IF EXISTS `UserSalaryHistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserSalaryHistory` (
  `UserSalaryHistoryId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `SalaryEffectiveDate` date NOT NULL,
  `SalaryType` enum('Hourly Rate','Weekly Salary','Monthly Salary','Annual Salary') DEFAULT NULL,
  `PayFrequency` enum('Weekly','Bi-Weekly','Semi-Monthly','Monthly') DEFAULT NULL,
  `IncomeType` enum('W-2','1099','Other') DEFAULT NULL,
  `Salary` decimal(10,2) NOT NULL DEFAULT '0.00',
  `EmployerClassId` bigint(64) DEFAULT NULL,
  `JobTitleId` bigint(64) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserSalaryHistoryId`),
  KEY `UserSalaryHistoryRefUser_fk_idx` (`UserId`),
  KEY `UserSalaryHistoryRefJobTitle_fk_idx` (`JobTitleId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserSalaryHistory`
--

LOCK TABLES `UserSalaryHistory` WRITE;
/*!40000 ALTER TABLE `UserSalaryHistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserSalaryHistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTracking`
--

DROP TABLE IF EXISTS `UserTracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTracking` (
  `UserTrackingId` bigint(64) NOT NULL AUTO_INCREMENT,
  `PublicQuoteId` bigint(64) DEFAULT NULL,
  `FFMDetailId` bigint(64) DEFAULT NULL,
  `DomainId` bigint(64) DEFAULT NULL,
  `UserId` bigint(64) DEFAULT NULL,
  `ProducerUserId` bigint(64) DEFAULT NULL,
  `SourceType` enum('Individual','Group','Employee') DEFAULT NULL,
  `SourceModule` enum('834','Public Quote',' Employer','Employee','Payment') DEFAULT NULL,
  `Status` enum('Active','Deleted') DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTrackingId`),
  KEY `UserTrackingRefUser_fk_idx` (`UserId`),
  KEY `UserTrackingRefDomain_fk_idx` (`DomainId`),
  KEY `UserTrackingRefPublicQuote_fk_idx` (`PublicQuoteId`),
  KEY `UserTrackingRefFFMDetail_fk_idx` (`FFMDetailId`),
  KEY `fk_UserTracking_User1_idx` (`ProducerUserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTracking`
--

LOCK TABLES `UserTracking` WRITE;
/*!40000 ALTER TABLE `UserTracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserTracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTrackingPlan`
--

DROP TABLE IF EXISTS `UserTrackingPlan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTrackingPlan` (
  `UserTrackingPlanId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserTrackingId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `Edi834Id` bigint(64) DEFAULT NULL,
  `DateSubmitted` date DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `PlanNumber` varchar(100) DEFAULT NULL,
  `ProviderStatus` enum('Submitted','Submitted and Paid','Cancelled','Error','Pending','Approved') DEFAULT NULL,
  `InternalStatus` enum('Selected','SAML Sent','SAML Success','SAML Error','Fetch Sent','Fetch Success','Fetch Error','Enroll Submitted','Enroll Approved','Enroll Cancelled','Enroll Error','Submitted and Paid') DEFAULT NULL,
  `ErrorMessage` varchar(500) DEFAULT NULL,
  `Comment` varchar(1000) DEFAULT NULL,
  `PaymentDate` date DEFAULT NULL,
  `PolicyAssignedId` varchar(150) DEFAULT NULL,
  `Status` enum('Active','Deleted') DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTrackingPlanId`),
  KEY `UserTrackingPlanRefUserTracking_fk_idx` (`UserTrackingId`),
  KEY `UserTrackingPlanRefEdi834_fk_idx` (`Edi834Id`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTrackingPlan`
--

LOCK TABLES `UserTrackingPlan` WRITE;
/*!40000 ALTER TABLE `UserTrackingPlan` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserTrackingPlan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTrackingPlanDependent`
--

DROP TABLE IF EXISTS `UserTrackingPlanDependent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTrackingPlanDependent` (
  `UserTrackingPlanDependentId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserTrackingPlanId` bigint(64) NOT NULL,
  `PublicQuoteUserDependentCensusId` bigint(64) DEFAULT NULL,
  `FFMPersonId` bigint(64) DEFAULT NULL,
  `MemberNumber` varchar(45) DEFAULT NULL,
  `Status` enum('Active','Deleted') DEFAULT 'Active',
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTrackingPlanDependentId`),
  KEY `UserTrackingPlanDependentRefUserTrackingPlan_fk_idx` (`UserTrackingPlanId`),
  KEY `UserTrackingPlanDependentRefDependentCensus_fk_idx` (`PublicQuoteUserDependentCensusId`),
  KEY `UserTrackingPlanDependentRefFFMPerson_fk_idx` (`FFMPersonId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTrackingPlanDependent`
--

LOCK TABLES `UserTrackingPlanDependent` WRITE;
/*!40000 ALTER TABLE `UserTrackingPlanDependent` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserTrackingPlanDependent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTrackingPlanH`
--

DROP TABLE IF EXISTS `UserTrackingPlanH`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTrackingPlanH` (
  `UserTrackingPlanHId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserTrackingPlanId` bigint(64) NOT NULL,
  `UserTrackingId` bigint(64) NOT NULL,
  `ProviderPlanId` bigint(64) DEFAULT NULL,
  `DateSubmitted` date DEFAULT NULL,
  `StartDate` date DEFAULT NULL,
  `PlanNumber` varchar(100) DEFAULT NULL,
  `ProviderStatus` enum('Submitted','Submitted and Paid','Cancelled','Error','Pending','Approved') DEFAULT NULL,
  `InternalStatus` enum('Selected','SAML Sent','SAML Success','SAML Error','Fetch Sent','Fetch Success','Fetch Error','Enroll Submitted','Enroll Approved','Enroll Cancelled','Enroll Error','Submitted and Paid') DEFAULT NULL,
  `ErrorMessage` varchar(500) DEFAULT NULL,
  `Comment` varchar(1000) DEFAULT NULL,
  `Status` enum('Active','Deleted') DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTrackingPlanHId`),
  KEY `fk_UserTrackingPlanH_UserTrackingPlan1_idx` (`UserTrackingPlanId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTrackingPlanH`
--

LOCK TABLES `UserTrackingPlanH` WRITE;
/*!40000 ALTER TABLE `UserTrackingPlanH` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserTrackingPlanH` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTransactionLog`
--

DROP TABLE IF EXISTS `UserTransactionLog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTransactionLog` (
  `UserTransactionLogId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserTransactionLogTypeId` bigint(64) DEFAULT NULL,
  `LineOfCoverageId` bigint(64) DEFAULT NULL,
  `UserId` bigint(64) NOT NULL,
  `Status` enum('Active','Deleted') NOT NULL DEFAULT 'Active',
  `EmployerStatus` enum('Pending','Submitted','Approved','Deny') NOT NULL DEFAULT 'Pending',
  `HistoryId` bigint(64) DEFAULT NULL,
  `CurrentId` bigint(64) DEFAULT NULL,
  `ProviderStatus` enum('Not Sent','Queued','Sent','Confirmed','Deny','No Notifications') NOT NULL DEFAULT 'Not Sent',
  `EventDate` date DEFAULT NULL,
  `Reason` varchar(100) DEFAULT NULL,
  `ProviderDenyReason` varchar(200) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTransactionLogId`),
  KEY `UserTransactionLogRefUser_fk_idx` (`UserId`),
  KEY `UserTransactionLogRefUserTransactionLogType_fk_idx` (`UserTransactionLogTypeId`),
  KEY `UserTransactionLogRefLineOfCoverage_fk_idx` (`LineOfCoverageId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTransactionLog`
--

LOCK TABLES `UserTransactionLog` WRITE;
/*!40000 ALTER TABLE `UserTransactionLog` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserTransactionLog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserTransactionLogType`
--

DROP TABLE IF EXISTS `UserTransactionLogType`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserTransactionLogType` (
  `UserTransactionLogTypeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ChangeType` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) DEFAULT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserTransactionLogTypeId`),
  KEY `UserTransactionLogTypeChangeType_idx` (`ChangeType`)
) ENGINE=innodb AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserTransactionLogType`
--

LOCK TABLES `UserTransactionLogType` WRITE;
/*!40000 ALTER TABLE `UserTransactionLogType` DISABLE KEYS */;
INSERT INTO `UserTransactionLogType` VALUES (4,'BeneficiaryChange',1,'2013-07-08 02:04:06',NULL,NULL),(1,'NameChange',1,'2013-07-08 02:03:45',NULL,NULL),(5,'PlanChange',1,'2013-07-18 13:47:03',NULL,NULL),(2,'AddressChange',1,'2013-07-08 02:03:51',NULL,NULL),(3,'DependentChange',1,'2013-07-08 02:03:59',NULL,NULL);
/*!40000 ALTER TABLE `UserTransactionLogType` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UserViewOverride`
--

DROP TABLE IF EXISTS `UserViewOverride`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `UserViewOverride` (
  `UserViewOverrideId` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `ViewId` bigint(64) NOT NULL,
  `SortKey` int(11) DEFAULT NULL,
  `IsHidden` tinyint(1) DEFAULT '0',
  `ViewName` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`UserViewOverrideId`),
  KEY `UserViewOverrideRefUser_fk_idx` (`UserId`),
  KEY `UserViewOverrideRefAppView_fk_idx` (`ViewId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `UserViewOverride`
--

LOCK TABLES `UserViewOverride` WRITE;
/*!40000 ALTER TABLE `UserViewOverride` DISABLE KEYS */;
/*!40000 ALTER TABLE `UserViewOverride` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `W2`
--

DROP TABLE IF EXISTS `W2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `W2` (
  `W2Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `UserId` bigint(64) NOT NULL,
  `W2Year` int(32) NOT NULL,
  `ObjectName` varchar(255) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`W2Id`),
  KEY `W2RefUser_fk_idx` (`UserId`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `W2`
--

LOCK TABLES `W2` WRITE;
/*!40000 ALTER TABLE `W2` DISABLE KEYS */;
/*!40000 ALTER TABLE `W2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `W9Data`
--

DROP TABLE IF EXISTS `W9Data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `W9Data` (
  `W9DataId` bigint(64) NOT NULL AUTO_INCREMENT,
  `DomainId` bigint(64) NOT NULL,
  `BusinessName` varchar(200) NOT NULL,
  `IndividualName` varchar(200) DEFAULT NULL,
  `AccountNumbers` varchar(200) DEFAULT NULL,
  `Other` varchar(200) DEFAULT NULL,
  `TypeOfEntity` enum('Individual/Sole Proprietor','Partnership','C Corporation','S Corporation','Limited Liability Company','Trust/Estate','Other') NOT NULL,
  `LLCTypeEntity` enum('C','S','P') DEFAULT NULL,
  `AgreedToW9` tinyint(1) NOT NULL DEFAULT '0',
  `IsExemptPayee` tinyint(1) NOT NULL DEFAULT '0',
  `TINType` enum('Social Security Number','Employer Identification Number') NOT NULL,
  `TaxId` varchar(40) DEFAULT NULL,
  `SSN` varchar(108) DEFAULT NULL,
  `LastFourSSN` varchar(4) DEFAULT NULL,
  `BusinessAddress` varchar(100) DEFAULT NULL,
  `BusinessAddressLine2` varchar(100) DEFAULT NULL,
  `BusinessCity` varchar(100) DEFAULT NULL,
  `BusinessStateCode` char(2) DEFAULT NULL,
  `BusinessZipCode` char(5) DEFAULT NULL,
  `RequestorAddress` varchar(100) DEFAULT NULL,
  `RequestorAddressLine2` varchar(100) DEFAULT NULL,
  `RequestiorCity` varchar(100) DEFAULT NULL,
  `RequestorStateCode` char(2) DEFAULT NULL,
  `RequestorZipCode` char(5) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  PRIMARY KEY (`W9DataId`),
  KEY `W9DataRefDomain_fk_idx` (`DomainId`)
) ENGINE=innodb AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `W9Data`
--

LOCK TABLES `W9Data` WRITE;
/*!40000 ALTER TABLE `W9Data` DISABLE KEYS */;
/*!40000 ALTER TABLE `W9Data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `W9Document`
--

DROP TABLE IF EXISTS `W9Document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `W9Document` (
  `W9Id` bigint(64) NOT NULL AUTO_INCREMENT,
  `W9Year` smallint(16) NOT NULL DEFAULT '2013',
  `TypeDocument` enum('W9','W9 Instructions') NOT NULL,
  `ObjectName` varchar(150) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`W9Id`)
) ENGINE=innodb DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `W9Document`
--

LOCK TABLES `W9Document` WRITE;
/*!40000 ALTER TABLE `W9Document` DISABLE KEYS */;
/*!40000 ALTER TABLE `W9Document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ZipCodeMultiCity`
--

DROP TABLE IF EXISTS `ZipCodeMultiCity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ZipCodeMultiCity` (
  `ZipCodeMultiCityId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ZipCode` char(5) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `ZipType` char(1) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `City` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `CityType` char(1) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `County` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `CountyFIPS` char(5) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `State` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `StateAbbreviation` char(2) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `StateFIPS` varchar(2) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `MSACode` char(4) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `AreaCode` varchar(16) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `TimeZone` varchar(16) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `UTC` decimal(3,1) NOT NULL,
  `DST` char(1) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `Latitute` decimal(9,6) NOT NULL,
  `Longitude` decimal(9,6) NOT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ZipCodeMultiCityId`),
  KEY `ZipCodeMultiCity_StateAbbreviationCounty_idx` (`StateAbbreviation`,`County`),
  KEY `ZipCodeMultiCity_StateAbbreviationZipCode_idx` (`ZipCode`)
) ENGINE=innodb AUTO_INCREMENT=80206 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ZipCodeMultiCity`
--

LOCK TABLES `ZipCodeMultiCity` WRITE;
/*!40000 ALTER TABLE `ZipCodeMultiCity` DISABLE KEYS */;
INSERT INTO `ZipCodeMultiCity` VALUES (33252,'37079','S','Indian Mound','D','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.466021,-87.574984,0,'2013-07-06 12:44:32',NULL,NULL),(31843,'35089','S','Kellyton','D','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.968451,-85.961235,0,'2013-07-06 12:44:32',NULL,NULL),(5990,'05352','S','Stamford','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.775380,-73.068420,0,'2013-07-06 12:44:30',NULL,NULL),(22660,'24273','S','Esserville','N','Norton City','51720','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.936315,-82.622842,0,'2013-07-06 12:44:31',NULL,NULL),(51566,'59752','S','Trident','N','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.880020,-111.576240,0,'2013-07-06 12:44:33',NULL,NULL),(72737,'89506','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(14752,'15322','S','Clarksville','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.964498,-80.049715,0,'2013-07-06 12:44:31',NULL,NULL),(22967,'24714','S','Beeson','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.496536,-81.185210,0,'2013-07-06 12:44:31',NULL,NULL),(12352,'12885','S','The Glen','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.500656,-73.787701,0,'2013-07-06 12:44:30',NULL,NULL),(1798,'00783','S','Urb Monteverde','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(21362,'22443','S','Oak Grove','A','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.248998,-76.962438,0,'2013-07-06 12:44:31',NULL,NULL),(16,'00603','S','Bda Caban','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(42406,'47750','U','Saint Marys Medical Center','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.961584,-87.508593,0,'2013-07-06 12:44:32',NULL,NULL),(51696,'60002','S','Old Mill Crk','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.468500,-88.109296,0,'2013-07-06 12:44:33',NULL,NULL),(72461,'89118','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.080056,-115.213988,0,'2013-07-06 12:44:34',NULL,NULL),(51432,'59461','S','Lothair','D','Liberty','30051','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.471787,-111.232307,0,'2013-07-06 12:44:33',NULL,NULL),(10549,'11001','S','Bellerose Vil','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(6301,'05656','S','East Johnson','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.642580,-72.669900,0,'2013-07-06 12:44:30',NULL,NULL),(33222,'37060','S','Eagleville','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.748245,-86.640746,0,'2013-07-06 12:44:32',NULL,NULL),(28365,'31211','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.867714,-83.605178,0,'2013-07-06 12:44:32',NULL,NULL),(18252,'19002','S','Ambler','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.190760,-75.206580,0,'2013-07-06 12:44:31',NULL,NULL),(23401,'25321','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.350847,-81.630639,0,'2013-07-06 12:44:31',NULL,NULL),(17762,'18328','S','Lehman','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.227695,-74.945839,0,'2013-07-06 12:44:31',NULL,NULL),(51591,'59808','S','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.849245,-114.014432,0,'2013-07-06 12:44:33',NULL,NULL),(67764,'80634','S','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.408834,-104.760402,0,'2013-07-06 12:44:34',NULL,NULL),(67908,'80903','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.831839,-104.818927,0,'2013-07-06 12:44:34',NULL,NULL),(71523,'87121','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.016799,-106.755725,0,'2013-07-06 12:44:34',NULL,NULL),(69017,'83211','S','American Fls','A','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(62519,'74402','P','Muskogee','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.761119,-95.375475,0,'2013-07-06 12:44:33',NULL,NULL),(23482,'25507','P','Ceredo','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.390929,-82.557214,0,'2013-07-06 12:44:31',NULL,NULL),(25819,'28612','S','Connelly Spg','A','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.819784,-81.615772,0,'2013-07-06 12:44:31',NULL,NULL),(5509,'04768','S','Portage','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.789204,-68.541710,0,'2013-07-06 12:44:30',NULL,NULL),(3200,'01350','P','Monroe Bridge','D','Franklin','25011','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.716667,-72.983333,0,'2013-07-06 12:44:30',NULL,NULL),(20064,'20675','S','Pomfret','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.580323,-77.022464,0,'2013-07-06 12:44:31',NULL,NULL),(14513,'15202','S','Ben Avon Heights','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(2267,'00926','S','Urb Rivieras De Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(10450,'10919','S','Circleville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.513113,-74.376160,0,'2013-07-06 12:44:30',NULL,NULL),(40837,'46217','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.667568,-86.198814,0,'2013-07-06 12:44:32',NULL,NULL),(29195,'32406','P','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.152705,-85.737314,0,'2013-07-06 12:44:32',NULL,NULL),(70205,'84401','S','Marriott Slaterville','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(78341,'98004','S','Hunts Point','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(69457,'83648','S','Mtn Home AFB','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.059898,-115.854735,0,'2013-07-06 12:44:34',NULL,NULL),(62096,'73573','S','Sugden','A','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.167818,-97.995767,0,'2013-07-06 12:44:33',NULL,NULL),(61413,'72560','S','Mountain View','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.867456,-92.123865,0,'2013-07-06 12:44:33',NULL,NULL),(35130,'39215','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.297171,-90.183699,0,'2013-07-06 12:44:32',NULL,NULL),(42825,'48063','S','Columbus','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.847910,-82.676031,0,'2013-07-06 12:44:32',NULL,NULL),(44143,'49518','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.875823,-85.625787,0,'2013-07-06 12:44:32',NULL,NULL),(26992,'29625','S','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.536322,-82.732656,0,'2013-07-06 12:44:31',NULL,NULL),(16469,'17241','S','Upper Frankfd','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(77470,'96817','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.334849,-157.856702,0,'2013-07-06 12:44:34',NULL,NULL),(74453,'92587','S','Menifee','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.695760,-117.239280,0,'2013-07-06 12:44:34',NULL,NULL),(73969,'92072','P','Santee','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.832358,-117.038812,0,'2013-07-06 12:44:34',NULL,NULL),(58119,'68128','S','La Vista','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.183889,-96.030833,0,'2013-07-06 12:44:33',NULL,NULL),(628,'00682','S','Parc Soledad','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(22234,'23609','P','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.976958,-76.428558,0,'2013-07-06 12:44:31',NULL,NULL),(37461,'41858','S','Dongola','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(9273,'09620','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33143,'36915','S','Needham','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.014975,-88.336031,0,'2013-07-06 12:44:32',NULL,NULL),(49737,'57051','S','Oldham','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.440043,-97.550634,0,'2013-07-06 12:44:33',NULL,NULL),(54372,'62809','S','Barnhill','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.275356,-88.388782,0,'2013-07-06 12:44:33',NULL,NULL),(63025,'75185','P','Mesquite','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.771611,-96.616492,0,'2013-07-06 12:44:33',NULL,NULL),(78920,'98366','S','Colchester','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(76200,'95355','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.675966,-120.944878,0,'2013-07-06 12:44:34',NULL,NULL),(46,'00603','S','Vista Alegre','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(8802,'08607','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.221850,-74.769727,0,'2013-07-06 12:44:30',NULL,NULL),(32491,'36053','S','Three Notch','N','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.107979,-85.526910,0,'2013-07-06 12:44:32',NULL,NULL),(55231,'63437','S','Clarence','D','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738419,-92.263023,0,'2013-07-06 12:44:33',NULL,NULL),(59812,'71229','S','Collinston','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.686654,-91.816401,0,'2013-07-06 12:44:33',NULL,NULL),(72173,'88345','S','Ruidoso','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.341149,-105.667861,0,'2013-07-06 12:44:34',NULL,NULL),(69766,'84056','S','Hill AFB','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.120889,-111.982055,0,'2013-07-06 12:44:34',NULL,NULL),(67517,'80243','U','CO Dmv Dept Of Rev','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.686348,-104.961946,0,'2013-07-06 12:44:34',NULL,NULL),(29999,'33119','P','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.786672,-80.133513,0,'2013-07-06 12:44:32',NULL,NULL),(25677,'28513','S','Ayden','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.470300,-77.423119,0,'2013-07-06 12:44:31',NULL,NULL),(49477,'56655','S','Longville','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(63982,'76108','S','Lakeside','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.781540,-97.503780,0,'2013-07-06 12:44:34',NULL,NULL),(22189,'23501','P','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.899082,-76.206445,0,'2013-07-06 12:44:31',NULL,NULL),(6476,'05764','S','Rareville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.518045,-73.236985,0,'2013-07-06 12:44:30',NULL,NULL),(40937,'46291','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.782399,-86.047878,0,'2013-07-06 12:44:32',NULL,NULL),(6717,'06069','S','Sharon','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.865139,-73.455872,0,'2013-07-06 12:44:30',NULL,NULL),(42887,'48095','S','Washingtn Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.783484,-83.041714,0,'2013-07-06 12:44:32',NULL,NULL),(773,'00692','S','Urb Treasure Pt','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(12691,'13137','P','Plainville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.151646,-76.446002,0,'2013-07-06 12:44:30',NULL,NULL),(31424,'34251','S','Myakka City','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.338184,-82.195127,0,'2013-07-06 12:44:32',NULL,NULL),(62918,'75077','S','Highland Village','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.047969,-96.994857,0,'2013-07-06 12:44:33',NULL,NULL),(30780,'33587','P','Sydney','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.978498,-82.200446,0,'2013-07-06 12:44:32',NULL,NULL),(32982,'36613','S','Prichard','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.834480,-88.194240,0,'2013-07-06 12:44:32',NULL,NULL),(34665,'38801','S','Mount Vernon','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.233855,-88.738853,0,'2013-07-06 12:44:32',NULL,NULL),(24034,'26386','S','Lumberport','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.379361,-80.353385,0,'2013-07-06 12:44:31',NULL,NULL),(18697,'19192','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955297,-75.184537,0,'2013-07-06 12:44:31',NULL,NULL),(9707,'10060','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748746,-73.997962,0,'2013-07-06 12:44:30',NULL,NULL),(64551,'76653','S','Alto Springs','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.314780,-96.621000,0,'2013-07-06 12:44:34',NULL,NULL),(66946,'79367','P','Smyer','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.586042,-102.161581,0,'2013-07-06 12:44:34',NULL,NULL),(69291,'83445','S','Egin','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(45892,'52306','S','Mechanicsvlle','A','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.902291,-91.254990,0,'2013-07-06 12:44:32',NULL,NULL),(27351,'30055','S','Mansfield','D','Newton','13217','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.493766,-83.750336,0,'2013-07-06 12:44:31',NULL,NULL),(20116,'20714','S','Rose Haven','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.711654,-76.537211,0,'2013-07-06 12:44:31',NULL,NULL),(41047,'46405','S','Lake Station','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.568530,-87.270213,0,'2013-07-06 12:44:32',NULL,NULL),(37724,'42276','S','Cooperstown','N','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(4243,'02872','P','Prudence Isl','A','Bristol','44001','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.614191,-71.315427,0,'2013-07-06 12:44:30',NULL,NULL),(35582,'39573','S','Daisy Vestry','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(1981,'00906','P','Pta De Tierra','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405503,-66.062657,0,'2013-07-06 12:44:30',NULL,NULL),(29591,'32828','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.545909,-81.181177,0,'2013-07-06 12:44:32',NULL,NULL),(31799,'35043','S','Chelsea','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.319654,-86.646309,0,'2013-07-06 12:44:32',NULL,NULL),(32687,'36272','S','Piedmont','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.916629,-85.632561,0,'2013-07-06 12:44:32',NULL,NULL),(33791,'37881','S','Thorn Hill','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.395156,-83.365973,0,'2013-07-06 12:44:32',NULL,NULL),(45610,'51564','S','Pisgah','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.833133,-95.922603,0,'2013-07-06 12:44:32',NULL,NULL),(61992,'73401','S','Pooleville','A','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.332490,-97.335320,0,'2013-07-06 12:44:33',NULL,NULL),(74331,'92403','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.102131,-117.269257,0,'2013-07-06 12:44:34',NULL,NULL),(72635,'89421','P','Mc Dermitt','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.990819,-117.712764,0,'2013-07-06 12:44:34',NULL,NULL),(3677,'02128','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.383079,-71.018049,0,'2013-07-06 12:44:30',NULL,NULL),(18409,'19056','S','Levittown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.150296,-74.888025,0,'2013-07-06 12:44:31',NULL,NULL),(43376,'48421','S','Columbiaville','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.150828,-83.382321,0,'2013-07-06 12:44:32',NULL,NULL),(40005,'45244','S','Newtown','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118320,-84.337680,0,'2013-07-06 12:44:32',NULL,NULL),(25923,'28650','S','Maiden','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.574796,-81.207730,0,'2013-07-06 12:44:31',NULL,NULL),(25252,'28112','S','Monroe','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.940983,-80.540648,0,'2013-07-06 12:44:31',NULL,NULL),(6272,'05620','U','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262683,-72.583905,0,'2013-07-06 12:44:30',NULL,NULL),(56946,'66091','S','Welda','D','Anderson','20003','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.169440,-95.295590,0,'2013-07-06 12:44:33',NULL,NULL),(64431,'76558','P','Mound','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.307996,-97.569666,0,'2013-07-06 12:44:34',NULL,NULL),(69554,'83812','S','Clarkia','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.041600,-116.259100,0,'2013-07-06 12:44:34',NULL,NULL),(43496,'48622','S','Farwell','D','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.863136,-84.868062,0,'2013-07-06 12:44:32',NULL,NULL),(6564,'05850','S','Lyndon Center','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.534562,-72.010872,0,'2013-07-06 12:44:30',NULL,NULL),(32359,'35893','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.732440,-86.584594,0,'2013-07-06 12:44:32',NULL,NULL),(20039,'20645','S','Swan Point','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.305493,-76.920407,0,'2013-07-06 12:44:31',NULL,NULL),(49425,'56630','S','Summit','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(56697,'65660','S','Graff','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.114647,-92.315813,0,'2013-07-06 12:44:33',NULL,NULL),(70210,'84401','S','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(50381,'57760','S','Newell','D','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.718125,-103.420575,0,'2013-07-06 12:44:33',NULL,NULL),(56386,'65233','S','Overton','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(72335,'89013','S','Gold Point','N','Esmeralda','32009','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.766010,-117.423544,0,'2013-07-06 12:44:34',NULL,NULL),(72738,'89506','S','Sierra','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(73215,'90622','P','Buena Park','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.846186,-118.003132,0,'2013-07-06 12:44:34',NULL,NULL),(18755,'19346','P','Kelton','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.794027,-75.888510,0,'2013-07-06 12:44:31',NULL,NULL),(14680,'15243','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.383333,-80.066667,0,'2013-07-06 12:44:31',NULL,NULL),(46827,'54013','S','Emerald','A','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.064774,-92.196624,0,'2013-07-06 12:44:32',NULL,NULL),(53449,'61883','S','Westville','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.044517,-87.640012,0,'2013-07-06 12:44:33',NULL,NULL),(62211,'73848','S','Logan','A','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.716580,-99.880538,0,'2013-07-06 12:44:33',NULL,NULL),(73321,'90832','P','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.765894,-118.198595,0,'2013-07-06 12:44:34',NULL,NULL),(77302,'96669','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(78001,'97408','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.054100,-123.091980,0,'2013-07-06 12:44:34',NULL,NULL),(10269,'10509','S','Sears Corners','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422678,-73.599511,0,'2013-07-06 12:44:30',NULL,NULL),(43037,'48174','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.215215,-83.344726,0,'2013-07-06 12:44:32',NULL,NULL),(27219,'29913','P','Crocketville','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.913225,-81.074130,0,'2013-07-06 12:44:31',NULL,NULL),(61769,'73058','S','Meridian','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.806872,-97.250642,0,'2013-07-06 12:44:33',NULL,NULL),(3969,'02493','S','Kendal Green','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(35244,'39336','S','Lawrence','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.295244,-89.267534,0,'2013-07-06 12:44:32',NULL,NULL),(48015,'55171','U','US Bank Visa','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.943845,-93.093553,0,'2013-07-06 12:44:33',NULL,NULL),(67294,'80013','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.660246,-104.779822,0,'2013-07-06 12:44:34',NULL,NULL),(67318,'80026','S','Lafayette','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.000519,-105.098843,0,'2013-07-06 12:44:34',NULL,NULL),(67788,'80720','S','Akron','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.054042,-103.205127,0,'2013-07-06 12:44:34',NULL,NULL),(72921,'90027','S','Los Feliz','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.123560,-118.287840,0,'2013-07-06 12:44:34',NULL,NULL),(44894,'50320','S','South Des Moines','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.541390,-93.582000,0,'2013-07-06 12:44:32',NULL,NULL),(1768,'00780','S','Urb Laurel Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(9254,'09589','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(55015,'63133','S','Wellston','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.678252,-90.305602,0,'2013-07-06 12:44:33',NULL,NULL),(57786,'67476','P','Roxbury','D','McPherson','20113','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.490858,-97.437793,0,'2013-07-06 12:44:33',NULL,NULL),(63394,'75644','S','Union Hill','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(73739,'91710','S','Chino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.016105,-117.686207,0,'2013-07-06 12:44:34',NULL,NULL),(7255,'06515','S','Westville','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.327559,-72.966874,0,'2013-07-06 12:44:30',NULL,NULL),(3698,'02137','P','Hyde Park','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.235076,-71.134469,0,'2013-07-06 12:44:30',NULL,NULL),(43069,'48193','S','Brownstown TWP','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(28899,'32130','S','De Leon Springs','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.126886,-81.329806,0,'2013-07-06 12:44:32',NULL,NULL),(59098,'70128','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.051625,-89.957703,0,'2013-07-06 12:44:33',NULL,NULL),(64180,'76230','S','Postoak','N','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.561402,-97.838818,0,'2013-07-06 12:44:34',NULL,NULL),(77732,'97068','S','Willamette','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.366874,-122.650360,0,'2013-07-06 12:44:34',NULL,NULL),(79042,'98406','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.263195,-122.507387,0,'2013-07-06 12:44:34',NULL,NULL),(35959,'40066','P','Shelbyville','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.211321,-85.225568,0,'2013-07-06 12:44:32',NULL,NULL),(33387,'37217','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.103283,-86.655886,0,'2013-07-06 12:44:32',NULL,NULL),(3216,'01364','S','North Orange','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(73300,'90804','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.776725,-118.146150,0,'2013-07-06 12:44:34',NULL,NULL),(76572,'95673','S','Rio Linda','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.690505,-121.454859,0,'2013-07-06 12:44:34',NULL,NULL),(8,'00601','S','Urb San Joaquin','N','Adjuntas','72001','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.165950,-66.723627,0,'2013-07-06 12:44:30',NULL,NULL),(5019,'04236','S','Greene','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.190377,-70.144586,0,'2013-07-06 12:44:30',NULL,NULL),(29160,'32346','S','Ochlockonee Bay','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023822,-84.391553,0,'2013-07-06 12:44:32',NULL,NULL),(15941,'17022','S','Elizabthtwn','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(13532,'13825','S','Otego','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.394454,-75.172478,0,'2013-07-06 12:44:31',NULL,NULL),(6473,'05764','S','Blissville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.518045,-73.236985,0,'2013-07-06 12:44:30',NULL,NULL),(8286,'08016','S','Burlington Township','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.070260,-74.841534,0,'2013-07-06 12:44:30',NULL,NULL),(58996,'70058','S','Harvey','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.878094,-90.069635,0,'2013-07-06 12:44:33',NULL,NULL),(23042,'24859','P','Marianna','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.617318,-81.578242,0,'2013-07-06 12:44:31',NULL,NULL),(23956,'26287','S','Saint George','A','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.093406,-79.681282,0,'2013-07-06 12:44:31',NULL,NULL),(46906,'54130','S','Freedom','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.291186,-88.273071,0,'2013-07-06 12:44:32',NULL,NULL),(66419,'78636','S','Johnson City','D','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.276140,-98.408543,0,'2013-07-06 12:44:34',NULL,NULL),(77833,'97216','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.514785,-122.556713,0,'2013-07-06 12:44:34',NULL,NULL),(50838,'58479','S','Rogers','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.054040,-98.211954,0,'2013-07-06 12:44:33',NULL,NULL),(54498,'62864','S','Mount Vernon Outland Airport','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(61981,'73194','U','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.517415,-97.503803,0,'2013-07-06 12:44:33',NULL,NULL),(74229,'92320','S','Calimesa','D','Riverside','06065','California','CA','06','6780','909','Pacific',-8.0,'Y',33.992450,-117.043277,0,'2013-07-06 12:44:34',NULL,NULL),(78239,'97820','S','Canyon City','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.387513,-118.945978,0,'2013-07-06 12:44:34',NULL,NULL),(3949,'02474','S','E Arlington','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420728,-71.158189,0,'2013-07-06 12:44:30',NULL,NULL),(17334,'17865','P','Potts Grove','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.996303,-76.789962,0,'2013-07-06 12:44:31',NULL,NULL),(12442,'12961','S','Moriah Center','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.053032,-73.535270,0,'2013-07-06 12:44:30',NULL,NULL),(7442,'06840','S','New Canaan','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.151963,-73.496253,0,'2013-07-06 12:44:30',NULL,NULL),(23047,'24866','P','Newhall','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.261429,-81.615283,0,'2013-07-06 12:44:31',NULL,NULL),(38966,'44128','S','Highland Hills','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(37316,'41649','S','Hite','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.545706,-82.758667,0,'2013-07-06 12:44:32',NULL,NULL),(77718,'97060','S','Troutdale','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.527631,-122.397778,0,'2013-07-06 12:44:34',NULL,NULL),(30146,'33166','S','Virginia Gdns','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(27016,'29644','S','Fountain Inn','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.682989,-82.217533,0,'2013-07-06 12:44:31',NULL,NULL),(11797,'12224','P','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.664656,-73.841729,0,'2013-07-06 12:44:30',NULL,NULL),(45270,'50671','S','Stanley','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.641692,-91.809785,0,'2013-07-06 12:44:32',NULL,NULL),(56652,'65616','S','Marvel Cav Pk','A','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(64857,'77054','S','Gridiron','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.682326,-95.400410,0,'2013-07-06 12:44:34',NULL,NULL),(71615,'87328','P','Crystal','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.899177,-109.030882,0,'2013-07-06 12:44:34',NULL,NULL),(77119,'96150','S','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.886415,-120.035272,0,'2013-07-06 12:44:34',NULL,NULL),(13872,'14241','U','Buffalo Airport Retail','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927923,-78.747650,0,'2013-07-06 12:44:31',NULL,NULL),(33383,'37215','S','Forest Hills','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.093978,-86.824688,0,'2013-07-06 12:44:32',NULL,NULL),(48322,'55446','S','Plymouth','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.043463,-93.491662,0,'2013-07-06 12:44:33',NULL,NULL),(59299,'70508','S','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.157004,-92.027490,0,'2013-07-06 12:44:33',NULL,NULL),(34111,'38182','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145303,-89.970637,0,'2013-07-06 12:44:32',NULL,NULL),(25849,'28624','S','Darby','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.156660,-81.393840,0,'2013-07-06 12:44:31',NULL,NULL),(59019,'70075','S','Meraux','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948870,-89.898600,0,'2013-07-06 12:44:33',NULL,NULL),(31656,'34743','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.328203,-81.354643,0,'2013-07-06 12:44:32',NULL,NULL),(62958,'75117','S','Edgewood','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.697255,-95.884524,0,'2013-07-06 12:44:33',NULL,NULL),(12308,'12855','S','North Hudson','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.002417,-73.800350,0,'2013-07-06 12:44:30',NULL,NULL),(42395,'47732','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.973198,-87.572339,0,'2013-07-06 12:44:32',NULL,NULL),(32560,'36114','S','Maxwell AFB Gunter Annex','A','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405544,-86.248050,0,'2013-07-06 12:44:32',NULL,NULL),(15504,'16508','S','South Erie','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.097111,-80.094070,0,'2013-07-06 12:44:31',NULL,NULL),(34310,'38551','S','Celina','D','Clay','47027','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.619354,-85.431418,0,'2013-07-06 12:44:32',NULL,NULL),(66469,'78657','S','Marble Falls','A','Llano','48299','Texas','TX','48','0000','830','Central',-6.0,'Y',30.579706,-98.271069,0,'2013-07-06 12:44:34',NULL,NULL),(68112,'80947','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832634,-104.819249,0,'2013-07-06 12:44:34',NULL,NULL),(76954,'96038','S','Grenada','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.620351,-122.519640,0,'2013-07-06 12:44:34',NULL,NULL),(16487,'17256','P','Shady Grove','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.777763,-77.668729,0,'2013-07-06 12:44:31',NULL,NULL),(24485,'27249','S','Gibsonville','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.127366,-79.587855,0,'2013-07-06 12:44:31',NULL,NULL),(5103,'04349','S','Kents Hill','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.436832,-70.070204,0,'2013-07-06 12:44:30',NULL,NULL),(39101,'44235','S','Homerville','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.037145,-82.120441,0,'2013-07-06 12:44:32',NULL,NULL),(3886,'02375','S','South Easton','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.028515,-71.100880,0,'2013-07-06 12:44:30',NULL,NULL),(4002,'02542','S','Otis ANGB','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.658720,-70.567260,0,'2013-07-06 12:44:30',NULL,NULL),(16088,'17050','S','Wertzville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(46007,'52535','S','Birmingham','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.854186,-91.948242,0,'2013-07-06 12:44:32',NULL,NULL),(54989,'63127','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.541300,-90.407963,0,'2013-07-06 12:44:33',NULL,NULL),(72683,'89445','S','Bottle Creek','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(73446,'91301','S','calabasas hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(69778,'84058','S','Orem','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(66961,'79383','P','New Home','D','Lynn','48305','Texas','TX','48','0000','806','Central',-6.0,'Y',33.205420,-101.843641,0,'2013-07-06 12:44:34',NULL,NULL),(54283,'62694','S','Riggston','A','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.550556,-90.480000,0,'2013-07-06 12:44:33',NULL,NULL),(49014,'56260','S','Maynard','D','Chippewa','27023','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.904798,-95.466408,0,'2013-07-06 12:44:33',NULL,NULL),(36072,'40210','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.232274,-85.787541,0,'2013-07-06 12:44:32',NULL,NULL),(37105,'41352','S','Mize','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.859190,-83.372286,0,'2013-07-06 12:44:32',NULL,NULL),(8834,'08629','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218249,-74.730652,0,'2013-07-06 12:44:30',NULL,NULL),(6864,'06133','P','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753216,-72.704041,0,'2013-07-06 12:44:30',NULL,NULL),(50550,'58204','S','Grand Forks','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.960971,-97.370375,0,'2013-07-06 12:44:33',NULL,NULL),(78253,'97836','S','Heppner','D','Morrow','41049','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.356421,-119.556835,0,'2013-07-06 12:44:34',NULL,NULL),(74419,'92553','S','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.908611,-117.238598,0,'2013-07-06 12:44:34',NULL,NULL),(49921,'57319','S','Silver Lake','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.529100,-97.446420,0,'2013-07-06 12:44:33',NULL,NULL),(45163,'50594','S','Vincent','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.589884,-94.018840,0,'2013-07-06 12:44:32',NULL,NULL),(38572,'43782','S','Shawnee','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.613693,-82.214228,0,'2013-07-06 12:44:32',NULL,NULL),(7611,'07052','S','Town Center','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.784909,-74.257646,0,'2013-07-06 12:44:30',NULL,NULL),(47418,'54658','S','Stoddard','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.663195,-91.218401,0,'2013-07-06 12:44:32',NULL,NULL),(17847,'18425','S','Greeley','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.448362,-75.040583,0,'2013-07-06 12:44:31',NULL,NULL),(493,'00674','S','Bo Cantera','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(35810,'39759','S','Oktoc','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(32830,'36470','P','Claiborne','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.525703,-87.324291,0,'2013-07-06 12:44:32',NULL,NULL),(65548,'77833','S','Independence','N','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.216840,-96.396420,0,'2013-07-06 12:44:34',NULL,NULL),(78328,'97918','S','Vale','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.013408,-117.288795,0,'2013-07-06 12:44:34',NULL,NULL),(77522,'96844','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.295954,-157.813874,0,'2013-07-06 12:44:34',NULL,NULL),(52683,'61084','S','Stillman Vly','A','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.114831,-89.191478,0,'2013-07-06 12:44:33',NULL,NULL),(45299,'50833','S','Bedford','D','Taylor','19173','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.705800,-94.758900,0,'2013-07-06 12:44:32',NULL,NULL),(5309,'04558','S','Pemaquid','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.875833,-69.490556,0,'2013-07-06 12:44:30',NULL,NULL),(44873,'50311','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.603992,-93.684345,0,'2013-07-06 12:44:32',NULL,NULL),(13061,'13442','P','Rome','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.217615,-75.447424,0,'2013-07-06 12:44:30',NULL,NULL),(28101,'30753','S','Trion','D','Chattooga','13055','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.543448,-85.309856,0,'2013-07-06 12:44:31',NULL,NULL),(43819,'49079','S','Paw Paw','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.231265,-85.902785,0,'2013-07-06 12:44:32',NULL,NULL),(50005,'57380','S','Greenwood','N','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.078076,-98.292700,0,'2013-07-06 12:44:33',NULL,NULL),(74267,'92345','S','Hesperia','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.416478,-117.307226,0,'2013-07-06 12:44:34',NULL,NULL),(74805,'93206','S','Buttonwillow','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.399946,-119.443058,0,'2013-07-06 12:44:34',NULL,NULL),(64617,'76691','S','Rogers Hill','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.775460,-97.104060,0,'2013-07-06 12:44:34',NULL,NULL),(15409,'16347','S','Sheffield','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.699399,-79.036324,0,'2013-07-06 12:44:31',NULL,NULL),(28079,'30728','S','Lafayette','N','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.708605,-85.286695,0,'2013-07-06 12:44:31',NULL,NULL),(32393,'35954','S','Attalla','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.083060,-86.060280,0,'2013-07-06 12:44:32',NULL,NULL),(17970,'18612','S','Monroe Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.332973,-75.961823,0,'2013-07-06 12:44:31',NULL,NULL),(21576,'22834','S','Linville','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.558265,-78.898288,0,'2013-07-06 12:44:31',NULL,NULL),(42941,'48118','S','Lima Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(37601,'42128','P','Drake','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.834323,-86.406391,0,'2013-07-06 12:44:32',NULL,NULL),(36390,'40488','P','Waneta','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.474812,-84.038292,0,'2013-07-06 12:44:32',NULL,NULL),(46430,'53195','P','Zenda','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.512623,-88.481385,0,'2013-07-06 12:44:32',NULL,NULL),(46895,'54123','S','Forest Jct','A','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.207672,-88.144352,0,'2013-07-06 12:44:32',NULL,NULL),(53865,'62338','S','Fowler','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.988120,-91.236325,0,'2013-07-06 12:44:33',NULL,NULL),(57228,'66508','S','Herkimer','A','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.846378,-96.645294,0,'2013-07-06 12:44:33',NULL,NULL),(76755,'95923','S','Canyondam','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.208520,-121.155480,0,'2013-07-06 12:44:34',NULL,NULL),(76011,'95122','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.325993,-121.832012,0,'2013-07-06 12:44:34',NULL,NULL),(65877,'78222','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.386912,-98.391814,0,'2013-07-06 12:44:34',NULL,NULL),(4975,'04109','S','Grt Dia Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(14904,'15522','S','Bedford','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.018179,-78.506817,0,'2013-07-06 12:44:31',NULL,NULL),(40734,'46129','P','Finly','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.705783,-85.823391,0,'2013-07-06 12:44:32',NULL,NULL),(51404,'59434','P','E Glacier Park','A','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(494,'00674','S','Brisas De Mar Chiquita','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(6896,'06146','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788567,-72.665122,0,'2013-07-06 12:44:30',NULL,NULL),(7133,'06389','P','Yantic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.562601,-72.122592,0,'2013-07-06 12:44:30',NULL,NULL),(7475,'06889','U','Websters Unified','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.142373,-73.360124,0,'2013-07-06 12:44:30',NULL,NULL),(56467,'65301','S','Sedalia','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.695080,-93.242160,0,'2013-07-06 12:44:33',NULL,NULL),(68831,'82514','S','Fort Washakie','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999395,-108.880770,0,'2013-07-06 12:44:34',NULL,NULL),(17590,'18031','S','Breinigsville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.555364,-75.660049,0,'2013-07-06 12:44:31',NULL,NULL),(10534,'10989','S','Valley Cottage','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.123270,-73.942049,0,'2013-07-06 12:44:30',NULL,NULL),(26103,'28719','S','Ocono Lufty','N','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.474495,-83.341234,0,'2013-07-06 12:44:31',NULL,NULL),(58712,'68935','S','Edgar','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.371362,-97.974067,0,'2013-07-06 12:44:33',NULL,NULL),(63616,'75831','S','Lanely','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.461433,-96.074604,0,'2013-07-06 12:44:34',NULL,NULL),(14751,'15321','S','Cecil','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.317508,-80.190389,0,'2013-07-06 12:44:31',NULL,NULL),(21780,'23066','P','Gwyme','N','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.500030,-76.289392,0,'2013-07-06 12:44:31',NULL,NULL),(16685,'17366','S','Windsor','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.923540,-76.574778,0,'2013-07-06 12:44:31',NULL,NULL),(62884,'75052','S','Grand Prairie','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.679596,-97.013708,0,'2013-07-06 12:44:33',NULL,NULL),(71698,'87522','S','Cundiyo','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(73067,'90099','U','Bar Code Term Annex','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062936,-118.236227,0,'2013-07-06 12:44:34',NULL,NULL),(59140,'70167','U','New Orleans Pub Serv','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.964802,-90.084829,0,'2013-07-06 12:44:33',NULL,NULL),(1212,'00728','S','Sect Playita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(14455,'15106','S','Rennerdale','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405231,-80.093696,0,'2013-07-06 12:44:31',NULL,NULL),(27293,'30007','P','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.963312,-84.551056,0,'2013-07-06 12:44:31',NULL,NULL),(43249,'48320','S','Sylvan Lake','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.609351,-83.345619,0,'2013-07-06 12:44:32',NULL,NULL),(7848,'07470','S','Packanack Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(14978,'15637','S','Herminie','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.262202,-79.715588,0,'2013-07-06 12:44:31',NULL,NULL),(61576,'72738','S','Hindsville','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.141271,-93.868502,0,'2013-07-06 12:44:33',NULL,NULL),(69905,'84107','S','S Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(72783,'89701','S','Carson Colony','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(76920,'96007','S','Olinda','N','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.468980,-122.299500,0,'2013-07-06 12:44:34',NULL,NULL),(69536,'83756','U','Idaho State Tax Commission','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.611127,-116.215521,0,'2013-07-06 12:44:34',NULL,NULL),(62591,'74472','S','Hoyt','A','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.250058,-95.226723,0,'2013-07-06 12:44:33',NULL,NULL),(53441,'61874','S','Savoy','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.063921,-88.250201,0,'2013-07-06 12:44:33',NULL,NULL),(44209,'49633','S','Fife Lake','D','Kalkaska','26079','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.564228,-85.190900,0,'2013-07-06 12:44:32',NULL,NULL),(48865,'56081','S','Saint James','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.984257,-94.625393,0,'2013-07-06 12:44:33',NULL,NULL),(61882,'73132','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.545017,-97.635324,0,'2013-07-06 12:44:33',NULL,NULL),(60303,'71454','S','Odra','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(35756,'39737','S','Bellefontaine','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.609442,-89.366939,0,'2013-07-06 12:44:32',NULL,NULL),(38374,'43467','P','West Millgrove','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.240434,-83.490982,0,'2013-07-06 12:44:32',NULL,NULL),(40119,'45324','S','Beavercrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.807279,-84.019499,0,'2013-07-06 12:44:32',NULL,NULL),(17894,'18445','S','S Sterling','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.289870,-75.399598,0,'2013-07-06 12:44:31',NULL,NULL),(37814,'42410','S','Earlington','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.270969,-87.511680,0,'2013-07-06 12:44:32',NULL,NULL),(24906,'27712','S','Eno Valley','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.086887,-78.923696,0,'2013-07-06 12:44:31',NULL,NULL),(18168,'18913','S','Carversville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.382046,-75.045566,0,'2013-07-06 12:44:31',NULL,NULL),(59312,'70517','S','Henderson','A','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.279139,-91.898037,0,'2013-07-06 12:44:33',NULL,NULL),(71540,'87158','U','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084393,-106.647676,0,'2013-07-06 12:44:34',NULL,NULL),(67325,'80034','P','Wheat Ridge','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.777375,-105.081686,0,'2013-07-06 12:44:34',NULL,NULL),(65036,'77327','S','Rayburn','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(57836,'67548','S','La Crosse','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.529748,-99.305953,0,'2013-07-06 12:44:33',NULL,NULL),(3141,'01253','S','Otis','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.192300,-73.068480,0,'2013-07-06 12:44:30',NULL,NULL),(9333,'09747','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28042,'30656','S','Between','A','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.847484,-83.717624,0,'2013-07-06 12:44:31',NULL,NULL),(21320,'22407','S','Fred','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(55163,'63367','S','Lake Saint Louis','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.793015,-90.782477,0,'2013-07-06 12:44:33',NULL,NULL),(27983,'30572','S','Suches','D','Union','13291','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.730746,-84.069126,0,'2013-07-06 12:44:31',NULL,NULL),(19601,'20228','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887710,-77.031420,0,'2013-07-06 12:44:31',NULL,NULL),(46237,'52803','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.539303,-90.554210,0,'2013-07-06 12:44:32',NULL,NULL),(3108,'01230','S','N Egremont','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(33263,'37089','U','La Vergne','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.998042,-86.574564,0,'2013-07-06 12:44:32',NULL,NULL),(10926,'11432','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715744,-73.794362,0,'2013-07-06 12:44:30',NULL,NULL),(49802,'57197','U','Augustana College','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.521917,-96.740725,0,'2013-07-06 12:44:33',NULL,NULL),(66960,'79382','S','Wolfforth','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.505467,-102.009006,0,'2013-07-06 12:44:34',NULL,NULL),(78446,'98061','P','Manitou Beach','N','Kitsap','53035','Washington','WA','53','1150','206/564','Pacific',-8.0,'Y',47.652184,-122.548994,0,'2013-07-06 12:44:34',NULL,NULL),(59168,'70341','S','Magnolia','N','Assumption','22007','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.041700,-91.067400,0,'2013-07-06 12:44:33',NULL,NULL),(48016,'55172','P','Bar Code','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.963635,-93.085354,0,'2013-07-06 12:44:33',NULL,NULL),(30294,'33269','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.944760,-80.213994,0,'2013-07-06 12:44:32',NULL,NULL),(15707,'16856','P','Mingoville','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.910906,-77.781305,0,'2013-07-06 12:44:31',NULL,NULL),(44316,'49740','S','Harbor Springs','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.531470,-85.004593,0,'2013-07-06 12:44:32',NULL,NULL),(16672,'17358','P','Rossville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.074374,-76.929624,0,'2013-07-06 12:44:31',NULL,NULL),(41445,'46868','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069873,-85.166649,0,'2013-07-06 12:44:32',NULL,NULL),(25298,'28144','S','Correll Park','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.664520,-80.474091,0,'2013-07-06 12:44:31',NULL,NULL),(57606,'67114','S','Zimmerdale','N','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.046304,-97.350600,0,'2013-07-06 12:44:33',NULL,NULL),(77403,'96782','S','Pearl City','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.410205,-157.964616,0,'2013-07-06 12:44:34',NULL,NULL),(74037,'92139','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.675725,-117.049586,0,'2013-07-06 12:44:34',NULL,NULL),(68925,'82901','S','Bitter Creek','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.597550,-109.234183,0,'2013-07-06 12:44:34',NULL,NULL),(58012,'67871','S','Scott City','D','Scott','20171','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.479020,-100.891440,0,'2013-07-06 12:44:33',NULL,NULL),(46879,'54107','S','Navarino','A','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.695751,-88.437835,0,'2013-07-06 12:44:32',NULL,NULL),(31670,'34759','S','Kissimmee','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.142963,-81.453023,0,'2013-07-06 12:44:32',NULL,NULL),(2329,'00934','S','Urb Las Colinas','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413161,-66.131635,0,'2013-07-06 12:44:30',NULL,NULL),(11601,'12085','S','Guildrlnd Ctr','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.702864,-73.968446,0,'2013-07-06 12:44:30',NULL,NULL),(37808,'42408','S','Beulah','N','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.189860,-87.687240,0,'2013-07-06 12:44:32',NULL,NULL),(36900,'41121','S','Argillite','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.511728,-82.873744,0,'2013-07-06 12:44:32',NULL,NULL),(24465,'27237','P','Cumnock','D','Lee','37105','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',35.554722,-79.238056,0,'2013-07-06 12:44:31',NULL,NULL),(23610,'25706','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.397383,-82.448716,0,'2013-07-06 12:44:31',NULL,NULL),(69537,'83799','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.613913,-116.200919,0,'2013-07-06 12:44:34',NULL,NULL),(69570,'83825','P','Dover','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.252165,-116.600833,0,'2013-07-06 12:44:34',NULL,NULL),(67377,'80121','S','Cherry Hills Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(15668,'16804','P','State College','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.795681,-77.836790,0,'2013-07-06 12:44:31',NULL,NULL),(40001,'45243','S','Madeira','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.185697,-84.352352,0,'2013-07-06 12:44:32',NULL,NULL),(11523,'12036','S','Charlotteville','D','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.541441,-74.657149,0,'2013-07-06 12:44:30',NULL,NULL),(22984,'24739','S','Princeton','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.330040,-80.967203,0,'2013-07-06 12:44:31',NULL,NULL),(40909,'46260','S','Meridian Hills','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892649,-86.180844,0,'2013-07-06 12:44:32',NULL,NULL),(28263,'31072','S','Pitts','D','Wilcox','13315','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.007175,-83.616832,0,'2013-07-06 12:44:31',NULL,NULL),(53757,'62263','S','Beaucoup','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441389,-89.370278,0,'2013-07-06 12:44:33',NULL,NULL),(61273,'72383','P','Turner','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.544090,-90.983569,0,'2013-07-06 12:44:33',NULL,NULL),(62522,'74421','S','Beggs','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.743595,-96.068230,0,'2013-07-06 12:44:33',NULL,NULL),(71309,'86503','S','Tahchee','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(56343,'65111','U','Scholastics Inc','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.551103,-92.118815,0,'2013-07-06 12:44:33',NULL,NULL),(50956,'58622','S','Fryburg','A','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.884720,-103.180800,0,'2013-07-06 12:44:33',NULL,NULL),(910,'00705','S','Villa de la Rosa','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(36779,'41044','S','Abegall','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.624615,-83.978515,0,'2013-07-06 12:44:32',NULL,NULL),(9999,'10167','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(50792,'58441','S','Maple','N','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.195764,-98.379125,0,'2013-07-06 12:44:33',NULL,NULL),(21598,'22847','S','Shendoah Cvrn','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.725788,-78.712644,0,'2013-07-06 12:44:31',NULL,NULL),(24788,'27577','S','Smithfield','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.512172,-78.347308,0,'2013-07-06 12:44:31',NULL,NULL),(66379,'78621','S','Type','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(57162,'66282','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.953539,-94.688284,0,'2013-07-06 12:44:33',NULL,NULL),(2196,'00926','S','Paseo Las Vistas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(38528,'43733','P','Derwent','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.930089,-81.499768,0,'2013-07-06 12:44:32',NULL,NULL),(43745,'49004','S','Parchment','A','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.347100,-85.547460,0,'2013-07-06 12:44:32',NULL,NULL),(32823,'36460','S','Mville','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.514812,-87.327625,0,'2013-07-06 12:44:32',NULL,NULL),(1825,'00784','S','Urb Algarrobos','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(21120,'22095','U','Business Reply Mail','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.968942,-77.388697,0,'2013-07-06 12:44:31',NULL,NULL),(50863,'58503','S','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.859748,-100.767872,0,'2013-07-06 12:44:33',NULL,NULL),(77570,'96910','S','Sinajana','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(53241,'61653','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.679996,-89.604273,0,'2013-07-06 12:44:33',NULL,NULL),(25420,'28301','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(16714,'17404','S','West York','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.971839,-76.774584,0,'2013-07-06 12:44:31',NULL,NULL),(30833,'33626','S','Northdale','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.056858,-82.605871,0,'2013-07-06 12:44:32',NULL,NULL),(10999,'11552','S','Lakeview','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685278,-73.653056,0,'2013-07-06 12:44:30',NULL,NULL),(43930,'49274','S','Reading','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.845656,-84.760742,0,'2013-07-06 12:44:32',NULL,NULL),(3231,'01373','S','So Deerfield','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.486240,-72.610200,0,'2013-07-06 12:44:30',NULL,NULL),(3427,'01742','S','Concord','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.456444,-71.370954,0,'2013-07-06 12:44:30',NULL,NULL),(67465,'80221','S','Federal Heights','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(78415,'98042','S','Lake Sawyer','N','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.376480,-122.099400,0,'2013-07-06 12:44:34',NULL,NULL),(78713,'98272','S','Monroe','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.857085,-121.937678,0,'2013-07-06 12:44:34',NULL,NULL),(66451,'78653','S','Gregg','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(5340,'04605','S','Osborn','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(28990,'32214','U','JAX Naval Hos','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.216694,-81.684003,0,'2013-07-06 12:44:32',NULL,NULL),(29831,'33030','S','Everglades National Park','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.481403,-80.505418,0,'2013-07-06 12:44:32',NULL,NULL),(11424,'11965','P','Shelter Is Ht','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.075213,-72.354368,0,'2013-07-06 12:44:30',NULL,NULL),(38184,'43195','U','Gap Inc Direct','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.854672,-82.883640,0,'2013-07-06 12:44:32',NULL,NULL),(16049,'17045','S','Liverpool','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.574018,-76.985771,0,'2013-07-06 12:44:31',NULL,NULL),(54993,'63128','S','Sappington','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.502540,-90.381840,0,'2013-07-06 12:44:33',NULL,NULL),(66245,'78572','S','Chihuahua','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(66409,'78631','S','Knoxville','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.317834,-99.222875,0,'2013-07-06 12:44:34',NULL,NULL),(73514,'91342','S','Lake View Ter','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.303046,-118.421940,0,'2013-07-06 12:44:34',NULL,NULL),(75214,'93633','P','Wilsonia','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(69631,'84001','S','Altamont','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.398937,-110.465521,0,'2013-07-06 12:44:34',NULL,NULL),(51863,'60077','S','Skokie','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.034146,-87.756196,0,'2013-07-06 12:44:33',NULL,NULL),(11423,'11964','P','Shelter Island','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.067294,-72.337204,0,'2013-07-06 12:44:30',NULL,NULL),(45205,'50628','S','Elma','D','Howard','19089','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.245347,-92.439097,0,'2013-07-06 12:44:32',NULL,NULL),(19692,'20374','S','Navy Yard','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.828906,-77.015495,0,'2013-07-06 12:44:31',NULL,NULL),(17824,'18414','S','N Abingtn Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.532124,-75.732122,0,'2013-07-06 12:44:31',NULL,NULL),(36258,'40322','S','Mariba','A','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.957240,-83.618623,0,'2013-07-06 12:44:32',NULL,NULL),(27882,'30454','S','Rockledge','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.365859,-82.744912,0,'2013-07-06 12:44:31',NULL,NULL),(57065,'66213','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(62755,'74848','S','Spaulding','A','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.083745,-96.399050,0,'2013-07-06 12:44:33',NULL,NULL),(68817,'82443','S','Grass Creek','N','Hot Springs','56017','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.772510,-108.575150,0,'2013-07-06 12:44:34',NULL,NULL),(68052,'80931','P','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.752720,-104.731586,0,'2013-07-06 12:44:34',NULL,NULL),(51691,'59936','P','West Glacier','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.497200,-113.989197,0,'2013-07-06 12:44:33',NULL,NULL),(13740,'14109','P','Niagara University','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.134350,-79.035930,0,'2013-07-06 12:44:31',NULL,NULL),(22455,'24029','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271593,-79.952695,0,'2013-07-06 12:44:31',NULL,NULL),(9180,'09367','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(12632,'13093','P','Lycoming','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.501366,-76.388574,0,'2013-07-06 12:44:30',NULL,NULL),(50656,'58327','S','Crary','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.013856,-98.604066,0,'2013-07-06 12:44:33',NULL,NULL),(55721,'64078','S','Peculiar','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.725247,-94.455413,0,'2013-07-06 12:44:33',NULL,NULL),(61387,'72533','S','Fifty Six','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.012180,-92.215500,0,'2013-07-06 12:44:33',NULL,NULL),(64662,'76802','S','Early','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.753994,-98.924325,0,'2013-07-06 12:44:34',NULL,NULL),(43245,'48318','P','Shelby Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.624463,-83.033255,0,'2013-07-06 12:44:32',NULL,NULL),(38335,'43435','S','Millersville','A','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.311944,-83.281389,0,'2013-07-06 12:44:32',NULL,NULL),(37116,'41390','S','Whick','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.408235,-83.372612,0,'2013-07-06 12:44:32',NULL,NULL),(33687,'37748','S','Emory Gap','N','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.942220,-84.500460,0,'2013-07-06 12:44:32',NULL,NULL),(27976,'30566','S','Oakwood','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.236484,-83.894790,0,'2013-07-06 12:44:31',NULL,NULL),(17591,'18032','S','Catasauqua','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.650574,-75.468644,0,'2013-07-06 12:44:31',NULL,NULL),(55634,'64012','S','Village of Loch Lloyd','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.806411,-94.535486,0,'2013-07-06 12:44:33',NULL,NULL),(41801,'47327','S','Mount Auburn','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.822189,-85.164134,0,'2013-07-06 12:44:32',NULL,NULL),(19752,'20411','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885195,-77.023632,0,'2013-07-06 12:44:31',NULL,NULL),(34047,'38137','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.110214,-89.891356,0,'2013-07-06 12:44:32',NULL,NULL),(31095,'33877','P','Waverly','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.980169,-81.614641,0,'2013-07-06 12:44:32',NULL,NULL),(73990,'92096','U','Ca State Univ San Marcos','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.133957,-117.175047,0,'2013-07-06 12:44:34',NULL,NULL),(50878,'58529','S','Leith','A','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.502100,-101.502900,0,'2013-07-06 12:44:33',NULL,NULL),(45422,'51056','S','Smithland','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.225253,-95.934391,0,'2013-07-06 12:44:32',NULL,NULL),(437,'00662','S','Sect Villa Luna','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(10874,'11419','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.688921,-73.823304,0,'2013-07-06 12:44:30',NULL,NULL),(4527,'03431','S','North Swanzey','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.938975,-72.285756,0,'2013-07-06 12:44:30',NULL,NULL),(4549,'03450','S','Harrisville','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.939286,-72.088989,0,'2013-07-06 12:44:30',NULL,NULL),(25549,'28408','P','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.226075,-77.946552,0,'2013-07-06 12:44:31',NULL,NULL),(71554,'87194','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.103356,-106.676611,0,'2013-07-06 12:44:34',NULL,NULL),(78174,'97639','S','Sprague River','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.455534,-121.503033,0,'2013-07-06 12:44:34',NULL,NULL),(79968,'99643','P','Old Harbor','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.415091,-153.531873,0,'2013-07-06 12:44:34',NULL,NULL),(75553,'94247','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586431,-121.495039,0,'2013-07-06 12:44:34',NULL,NULL),(57659,'67209','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.663190,-97.422577,0,'2013-07-06 12:44:33',NULL,NULL),(22830,'24513','U','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.403695,-79.189857,0,'2013-07-06 12:44:31',NULL,NULL),(37331,'41655','S','Hunter','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.505207,-82.707164,0,'2013-07-06 12:44:32',NULL,NULL),(670,'00683','S','Urb El Real','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(10327,'10547','S','Lake Mohegan','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.317149,-73.846680,0,'2013-07-06 12:44:30',NULL,NULL),(6016,'05363','S','Medburyville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.883215,-72.898726,0,'2013-07-06 12:44:30',NULL,NULL),(32112,'35402','P','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.148495,-87.609658,0,'2013-07-06 12:44:32',NULL,NULL),(75434,'94040','S','Blossom Valley','N','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.380469,-122.081870,0,'2013-07-06 12:44:34',NULL,NULL),(40461,'45746','S','Elba','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.608280,-81.441502,0,'2013-07-06 12:44:32',NULL,NULL),(2376,'00949','S','Urb Altagracia','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(33285,'37119','P','Mitchellville','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.632593,-86.537098,0,'2013-07-06 12:44:32',NULL,NULL),(62846,'75019','S','Coppell','D','Dallas','48113','Texas','TX','48','1920','940','Central',-6.0,'Y',32.964510,-96.984901,0,'2013-07-06 12:44:33',NULL,NULL),(75605,'94306','S','Palo Alto','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.417097,-122.131989,0,'2013-07-06 12:44:34',NULL,NULL),(77773,'97122','S','Hebo','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.193212,-123.832506,0,'2013-07-06 12:44:34',NULL,NULL),(72013,'88043','S','Hurley','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.701595,-108.130863,0,'2013-07-06 12:44:34',NULL,NULL),(59187,'70358','S','Grand Isle','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.212841,-90.036496,0,'2013-07-06 12:44:33',NULL,NULL),(56962,'66111','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.089580,-94.739700,0,'2013-07-06 12:44:33',NULL,NULL),(41789,'47324','P','Boston','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.740984,-84.852765,0,'2013-07-06 12:44:32',NULL,NULL),(2661,'00966','S','Urb Los Frailes Norte','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(31404,'34231','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.271652,-82.516843,0,'2013-07-06 12:44:32',NULL,NULL),(8704,'08360','S','Vineland','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.480900,-75.010192,0,'2013-07-06 12:44:30',NULL,NULL),(26790,'29455','S','Kiawah Island','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.691291,-80.091155,0,'2013-07-06 12:44:31',NULL,NULL),(33400,'37224','P','Nashvle','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.151112,-86.795584,0,'2013-07-06 12:44:32',NULL,NULL),(49639,'56945','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(68168,'81008','S','Pinon','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.327052,-104.625950,0,'2013-07-06 12:44:34',NULL,NULL),(63205,'75440','S','Emory','D','Rains','48379','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.876644,-95.756763,0,'2013-07-06 12:44:33',NULL,NULL),(61356,'72476','S','Wms College','A','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.090720,-90.959580,0,'2013-07-06 12:44:33',NULL,NULL),(44246,'49670','S','North Port','N','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.132456,-85.611687,0,'2013-07-06 12:44:32',NULL,NULL),(30543,'33410','S','North Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(26838,'29493','P','Williams','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.032888,-80.841541,0,'2013-07-06 12:44:31',NULL,NULL),(23183,'25044','S','Clear Creek','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.896461,-81.321466,0,'2013-07-06 12:44:31',NULL,NULL),(51685,'59932','S','Somers','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.079312,-114.238947,0,'2013-07-06 12:44:33',NULL,NULL),(52982,'61434','S','Galva','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.168134,-90.041316,0,'2013-07-06 12:44:33',NULL,NULL),(65524,'77713','S','Bevil Oaks','A','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.146443,-94.222869,0,'2013-07-06 12:44:34',NULL,NULL),(67816,'80750','S','Snyder','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.385974,-103.615588,0,'2013-07-06 12:44:34',NULL,NULL),(62971,'75132','P','Fate','D','Rockwall','48397','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.969939,-96.374664,0,'2013-07-06 12:44:33',NULL,NULL),(62095,'73572','S','Walters','D','Cotton','40033','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.350544,-98.306032,0,'2013-07-06 12:44:33',NULL,NULL),(35031,'39162','S','Satartia','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.616651,-90.625798,0,'2013-07-06 12:44:32',NULL,NULL),(13558,'13835','S','Harford Mills','A','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.409488,-76.227768,0,'2013-07-06 12:44:31',NULL,NULL),(16813,'17545','S','Lancaster Junction','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(44817,'50241','S','Saint Marys','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.306977,-93.733755,0,'2013-07-06 12:44:32',NULL,NULL),(7293,'06537','U','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.431433,-72.910481,0,'2013-07-06 12:44:30',NULL,NULL),(28410,'31321','S','Nevils','A','Bryan','13029','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.134586,-81.628588,0,'2013-07-06 12:44:32',NULL,NULL),(4559,'03461','S','Rindge','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.745423,-72.019047,0,'2013-07-06 12:44:30',NULL,NULL),(14347,'15012','S','Belle Vernon','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(62235,'73950','S','Baker','A','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.876600,-100.851600,0,'2013-07-06 12:44:33',NULL,NULL),(62305,'74030','S','Drumright','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.990679,-96.602438,0,'2013-07-06 12:44:33',NULL,NULL),(74824,'93225','S','Frazier Park','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.830583,-119.037797,0,'2013-07-06 12:44:34',NULL,NULL),(74822,'93223','S','Farmersville','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.300204,-119.205963,0,'2013-07-06 12:44:34',NULL,NULL),(70871,'85603','S','Winwood','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(59362,'70581','S','Roanoke','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.344861,-92.738491,0,'2013-07-06 12:44:33',NULL,NULL),(54612,'62912','S','Lick Creek','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.464327,-88.986086,0,'2013-07-06 12:44:33',NULL,NULL),(28874,'32119','S','S Daytona','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.139694,-81.012938,0,'2013-07-06 12:44:32',NULL,NULL),(31282,'34033','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(52093,'60411','S','Chicago Heights','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(67027,'79536','S','Stith','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.449860,-99.988740,0,'2013-07-06 12:44:34',NULL,NULL),(73341,'90895','U','Lakeshore Learning','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.839680,-118.259590,0,'2013-07-06 12:44:34',NULL,NULL),(74335,'92404','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.148310,-117.257233,0,'2013-07-06 12:44:34',NULL,NULL),(62932,'75090','S','Tom Bean','A','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.642018,-96.607173,0,'2013-07-06 12:44:33',NULL,NULL),(32588,'36124','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.393633,-86.175738,0,'2013-07-06 12:44:32',NULL,NULL),(23388,'25311','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351903,-81.592292,0,'2013-07-06 12:44:31',NULL,NULL),(30065,'33151','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.831870,-80.209513,0,'2013-07-06 12:44:32',NULL,NULL),(52435,'60656','S','Norridge','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.975199,-87.825937,0,'2013-07-06 12:44:33',NULL,NULL),(61419,'72566','S','Pineville','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.174282,-92.092744,0,'2013-07-06 12:44:33',NULL,NULL),(74341,'92407','S','Arrowhed Farm','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(68345,'81130','S','Creede','D','Mineral','08079','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.843042,-106.926914,0,'2013-07-06 12:44:34',NULL,NULL),(41620,'47125','S','Valeene','A','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.466102,-86.323493,0,'2013-07-06 12:44:32',NULL,NULL),(31257,'33983','S','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.003613,-82.013836,0,'2013-07-06 12:44:32',NULL,NULL),(49879,'57262','S','Dry Wood Lake','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.664922,-97.048055,0,'2013-07-06 12:44:33',NULL,NULL),(42985,'48150','S','Livonia','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.366557,-83.370612,0,'2013-07-06 12:44:32',NULL,NULL),(7415,'06804','S','Brookfld Ctr','A','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.466931,-73.395508,0,'2013-07-06 12:44:30',NULL,NULL),(19226,'19898','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.742451,-75.549413,0,'2013-07-06 12:44:31',NULL,NULL),(37780,'42352','S','Nuckols','N','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.496597,-87.125805,0,'2013-07-06 12:44:32',NULL,NULL),(63930,'76063','S','Mansfield','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.580527,-97.138872,0,'2013-07-06 12:44:34',NULL,NULL),(66836,'79108','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.276377,-101.830355,0,'2013-07-06 12:44:34',NULL,NULL),(68257,'81064','S','Utleyville','A','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.237984,-103.164023,0,'2013-07-06 12:44:34',NULL,NULL),(50265,'57640','S','Lodgepole','D','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.842233,-102.752770,0,'2013-07-06 12:44:33',NULL,NULL),(39355,'44627','S','Fredericksburg','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.689496,-81.854261,0,'2013-07-06 12:44:32',NULL,NULL),(7211,'06492','S','Yalesville','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.459922,-72.818029,0,'2013-07-06 12:44:30',NULL,NULL),(3868,'02357','U','Stonehill College','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.059436,-71.080861,0,'2013-07-06 12:44:30',NULL,NULL),(11171,'11729','S','Deerpark','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.759058,-73.325501,0,'2013-07-06 12:44:30',NULL,NULL),(3000,'01071','S','Russell','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.171278,-72.863130,0,'2013-07-06 12:44:30',NULL,NULL),(39750,'45103','S','Batavia','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.097260,-84.147060,0,'2013-07-06 12:44:32',NULL,NULL),(36096,'40219','S','South Park Vw','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(58137,'68145','P','Millard','A','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.257619,-95.936656,0,'2013-07-06 12:44:33',NULL,NULL),(66734,'78957','S','Smithville','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.013892,-97.156138,0,'2013-07-06 12:44:34',NULL,NULL),(73066,'90096','U','Shared Firm Zip Code','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.967004,-118.172186,0,'2013-07-06 12:44:34',NULL,NULL),(73240,'90670','S','Santa Fe Springs','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.935015,-118.068892,0,'2013-07-06 12:44:34',NULL,NULL),(70022,'84128','S','West Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(67121,'79742','P','Grandfalls','D','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.374995,-102.887887,0,'2013-07-06 12:44:34',NULL,NULL),(51402,'59433','S','Dutton','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.846215,-111.709429,0,'2013-07-06 12:44:33',NULL,NULL),(28904,'32134','S','Salt Springs','A','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.365867,-81.885231,0,'2013-07-06 12:44:32',NULL,NULL),(11929,'12427','S','Elka Park','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.185227,-74.132120,0,'2013-07-06 12:44:30',NULL,NULL),(24734,'27522','S','Creedmoor','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.120342,-78.690685,0,'2013-07-06 12:44:31',NULL,NULL),(42200,'47550','S','Lamar','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.052420,-86.966520,0,'2013-07-06 12:44:32',NULL,NULL),(37985,'42733','S','Elk Horn','D','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.332813,-85.197664,0,'2013-07-06 12:44:32',NULL,NULL),(44343,'49770','S','Bay View','A','Emmet','26047','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.356561,-84.930304,0,'2013-07-06 12:44:32',NULL,NULL),(29625,'32878','P','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.526291,-81.170878,0,'2013-07-06 12:44:32',NULL,NULL),(58791,'68979','S','School Creek','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.605438,-97.861006,0,'2013-07-06 12:44:33',NULL,NULL),(66094,'78405','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.776027,-97.428025,0,'2013-07-06 12:44:34',NULL,NULL),(75494,'94129','S','Presidio','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.795400,-122.463998,0,'2013-07-06 12:44:34',NULL,NULL),(75269,'93702','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.740431,-119.756053,0,'2013-07-06 12:44:34',NULL,NULL),(3076,'01144','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.101625,-72.594817,0,'2013-07-06 12:44:30',NULL,NULL),(21739,'23027','S','Cartersville','D','Cumberland','51049','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.656780,-78.108900,0,'2013-07-06 12:44:31',NULL,NULL),(5344,'04606','S','Addison','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.584808,-67.703926,0,'2013-07-06 12:44:30',NULL,NULL),(152,'00617','S','Urb City Paradise','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(14387,'15043','S','Georgetown','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.686564,-80.355979,0,'2013-07-06 12:44:31',NULL,NULL),(41165,'46703','S','Nevada Mills','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(28533,'31553','S','Lulaton','N','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.216716,-81.956732,0,'2013-07-06 12:44:32',NULL,NULL),(51862,'60076','S','Skokie','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.033599,-87.729142,0,'2013-07-06 12:44:33',NULL,NULL),(54131,'62558','S','Sicily','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.592339,-89.581873,0,'2013-07-06 12:44:33',NULL,NULL),(50873,'58524','S','Braddock','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.591605,-100.266823,0,'2013-07-06 12:44:33',NULL,NULL),(46889,'54115','S','De Pere','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.434457,-88.070098,0,'2013-07-06 12:44:32',NULL,NULL),(32863,'36515','S','Carlton','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.327687,-87.834868,0,'2013-07-06 12:44:32',NULL,NULL),(6762,'06093','S','West Suffield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',42.011488,-72.735632,0,'2013-07-06 12:44:30',NULL,NULL),(11334,'11791','S','Muttontown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.813797,-73.502844,0,'2013-07-06 12:44:30',NULL,NULL),(21371,'22456','P','Edwardsville','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.908540,-76.367144,0,'2013-07-06 12:44:31',NULL,NULL),(39547,'44840','S','Jeromesville','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.810987,-82.189201,0,'2013-07-06 12:44:32',NULL,NULL),(13679,'14040','S','Darien Center','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.893560,-78.377354,0,'2013-07-06 12:44:31',NULL,NULL),(9322,'09734','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(57434,'66783','S','Vernon','N','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.881629,-95.728588,0,'2013-07-06 12:44:33',NULL,NULL),(61089,'72132','S','Redfield','D','Jefferson','05069','Arkansas','AR','05','6240','501','Central',-6.0,'Y',34.460182,-92.177190,0,'2013-07-06 12:44:33',NULL,NULL),(70382,'84660','S','Spanish Fork','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(73074,'90201','S','Bell Gardens','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.969157,-118.172903,0,'2013-07-06 12:44:34',NULL,NULL),(80128,'99770','P','Selawik','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.293138,-158.964170,0,'2013-07-06 12:44:34',NULL,NULL),(27758,'30361','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.789903,-84.378744,0,'2013-07-06 12:44:31',NULL,NULL),(34171,'38303','P','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.639272,-88.823732,0,'2013-07-06 12:44:32',NULL,NULL),(30380,'33319','S','Laud Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(29693,'32934','S','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.142973,-80.696349,0,'2013-07-06 12:44:32',NULL,NULL),(17927,'18466','S','Tobyhanna','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.183409,-75.377541,0,'2013-07-06 12:44:31',NULL,NULL),(12378,'12916','S','Brushton','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.827852,-74.530013,0,'2013-07-06 12:44:30',NULL,NULL),(72177,'88347','S','Sacramento','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.784443,-105.642462,0,'2013-07-06 12:44:34',NULL,NULL),(53153,'61560','S','Lake Thunderbird','N','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.203217,-89.441455,0,'2013-07-06 12:44:33',NULL,NULL),(18698,'19193','U','Ford Motor Credit Corp','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955683,-75.184056,0,'2013-07-06 12:44:31',NULL,NULL),(34677,'38824','S','Bethany','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(21732,'23018','P','Bena','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.270084,-76.458519,0,'2013-07-06 12:44:31',NULL,NULL),(8570,'08215','S','Devonshire','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(22132,'23443','P','Townsend','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.280198,-75.958655,0,'2013-07-06 12:44:31',NULL,NULL),(21701,'22968','S','Ruckersville','D','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.218427,-78.382009,0,'2013-07-06 12:44:31',NULL,NULL),(18693,'19191','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952279,-75.165967,0,'2013-07-06 12:44:31',NULL,NULL),(63512,'75751','S','Cardinal Hall','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(73554,'91361','S','Thousand Oaks','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.152136,-118.846704,0,'2013-07-06 12:44:34',NULL,NULL),(79941,'99623','S','Houston','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593459,-149.414728,0,'2013-07-06 12:44:34',NULL,NULL),(58719,'68939','S','Ash Grove','N','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.097909,-98.951170,0,'2013-07-06 12:44:33',NULL,NULL),(33039,'36742','S','Providence','A','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.541822,-87.706622,0,'2013-07-06 12:44:32',NULL,NULL),(2049,'00919','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410997,-66.064914,0,'2013-07-06 12:44:30',NULL,NULL),(28492,'31522','S','Brunswick','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.165091,-81.384700,0,'2013-07-06 12:44:32',NULL,NULL),(23146,'24986','S','Wht Sphr Spgs','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797867,-80.296195,0,'2013-07-06 12:44:31',NULL,NULL),(51188,'59025','S','Decker','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.129792,-106.695652,0,'2013-07-06 12:44:33',NULL,NULL),(57163,'66283','P','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861823,-94.670864,0,'2013-07-06 12:44:33',NULL,NULL),(61789,'73079','S','Pocasset','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.159277,-98.001409,0,'2013-07-06 12:44:33',NULL,NULL),(67551,'80265','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.750730,-104.995441,0,'2013-07-06 12:44:34',NULL,NULL),(79478,'98859','S','Wauconda','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.716453,-118.950457,0,'2013-07-06 12:44:34',NULL,NULL),(69941,'84115','S','Ssl','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(66154,'78504','S','Mc Allen','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.255155,-98.226059,0,'2013-07-06 12:44:34',NULL,NULL),(65648,'77973','P','McFaddin','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.720049,-97.048372,0,'2013-07-06 12:44:34',NULL,NULL),(30881,'33686','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.868507,-82.526473,0,'2013-07-06 12:44:32',NULL,NULL),(18207,'18949','P','Plumsteadville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.378478,-75.145192,0,'2013-07-06 12:44:31',NULL,NULL),(6025,'05402','P','Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.505696,-73.126648,0,'2013-07-06 12:44:30',NULL,NULL),(22547,'24131','S','Paint Bank','D','Craig','51045','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.567936,-80.251529,0,'2013-07-06 12:44:31',NULL,NULL),(20899,'21713','S','Boonsboro','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.524532,-77.669246,0,'2013-07-06 12:44:31',NULL,NULL),(12640,'13108','S','Marcellus','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.970080,-76.324080,0,'2013-07-06 12:44:30',NULL,NULL),(14939,'15563','S','Stoystown','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.242859,-78.844748,0,'2013-07-06 12:44:31',NULL,NULL),(50518,'58078','S','West Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.886111,-96.900000,0,'2013-07-06 12:44:33',NULL,NULL),(68674,'82001','S','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.143114,-104.792918,0,'2013-07-06 12:44:34',NULL,NULL),(76163,'95316','S','Denair','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.544007,-120.792057,0,'2013-07-06 12:44:34',NULL,NULL),(58267,'68380','S','Lewiston','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.242026,-96.406983,0,'2013-07-06 12:44:33',NULL,NULL),(36019,'40165','S','Hebron Ests','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(5824,'05075','S','Thetford Ctr','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.823651,-72.272568,0,'2013-07-06 12:44:30',NULL,NULL),(2973,'01050','S','South Worthington','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(9302,'09713','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19517,'20178','P','Leesburg','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.118779,-77.566448,0,'2013-07-06 12:44:31',NULL,NULL),(4753,'03845','S','Intervale','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.075687,-71.131772,0,'2013-07-06 12:44:30',NULL,NULL),(37630,'42156','S','Lucas','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.846642,-86.047312,0,'2013-07-06 12:44:32',NULL,NULL),(72272,'88550','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.772931,-106.428174,0,'2013-07-06 12:44:34',NULL,NULL),(73293,'90755','S','Signal Hl','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.779826,-118.150529,0,'2013-07-06 12:44:34',NULL,NULL),(52082,'60403','S','Crest Hill','D','Will','17197','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.839745,-87.790481,0,'2013-07-06 12:44:33',NULL,NULL),(32846,'36483','S','Wing','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.123075,-86.584525,0,'2013-07-06 12:44:32',NULL,NULL),(43722,'48918','U','Secretary of State','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.674828,-84.678438,0,'2013-07-06 12:44:32',NULL,NULL),(39220,'44410','S','West Mecca','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.331036,-80.729796,0,'2013-07-06 12:44:32',NULL,NULL),(34737,'38849','S','Ratliff','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(57960,'67758','S','Sharon Spgs','A','Wallace','20199','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',38.901914,-101.747317,0,'2013-07-06 12:44:33',NULL,NULL),(77636,'97008','S','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.458293,-122.796743,0,'2013-07-06 12:44:34',NULL,NULL),(71899,'87747','S','Springer','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.383580,-104.344020,0,'2013-07-06 12:44:34',NULL,NULL),(9391,'09853','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(12244,'12824','S','Diamond Point','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.485300,-73.691940,0,'2013-07-06 12:44:30',NULL,NULL),(43622,'48816','P','Cohoctah','D','Livingston','26093','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.758825,-83.948518,0,'2013-07-06 12:44:32',NULL,NULL),(27449,'30122','S','Lithia Spgs','A','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.773697,-84.637899,0,'2013-07-06 12:44:31',NULL,NULL),(36952,'41169','S','Russell','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.520060,-82.724160,0,'2013-07-06 12:44:32',NULL,NULL),(36159,'40241','S','Ten Broeck','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(8230,'07979','P','Pottersville','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.713533,-74.712032,0,'2013-07-06 12:44:30',NULL,NULL),(1011,'00717','S','Villa Grillasca','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(42114,'47469','S','Northwest','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(19911,'20548','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900712,-77.019624,0,'2013-07-06 12:44:31',NULL,NULL),(25929,'28654','S','Moravian Falls','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.099261,-81.174660,0,'2013-07-06 12:44:31',NULL,NULL),(35229,'39309','U','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.537503,-88.567935,0,'2013-07-06 12:44:32',NULL,NULL),(47210,'54492','U','Herrschners','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.491605,-89.529732,0,'2013-07-06 12:44:32',NULL,NULL),(48655,'55910','S','Bethany','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(59558,'70826','P','GMF','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.401161,-91.077146,0,'2013-07-06 12:44:33',NULL,NULL),(74646,'92825','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.835647,-117.913197,0,'2013-07-06 12:44:34',NULL,NULL),(79208,'98537','S','Cosmopolis','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.954004,-123.777105,0,'2013-07-06 12:44:34',NULL,NULL),(65997,'78342','P','Alice','A','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.751944,-98.069444,0,'2013-07-06 12:44:34',NULL,NULL),(64001,'76114','S','Westworth Village','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(9787,'10107','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(42722,'48005','S','Armada','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.847253,-82.919999,0,'2013-07-06 12:44:32',NULL,NULL),(15585,'16662','S','Martinsburg','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.312769,-78.328001,0,'2013-07-06 12:44:31',NULL,NULL),(26186,'28760','P','Naples','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.392606,-82.502999,0,'2013-07-06 12:44:31',NULL,NULL),(60107,'71365','P','Ruby','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.189844,-92.246366,0,'2013-07-06 12:44:33',NULL,NULL),(20804,'21556','P','Pinto','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.569323,-78.842825,0,'2013-07-06 12:44:31',NULL,NULL),(27262,'29936','S','Coosawhatchie','A','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481598,-80.984342,0,'2013-07-06 12:44:31',NULL,NULL),(48199,'55397','S','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.803025,-93.930766,0,'2013-07-06 12:44:33',NULL,NULL),(48298,'55439','S','Bloomington','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.875459,-93.374350,0,'2013-07-06 12:44:33',NULL,NULL),(78943,'98368','S','Beckett Point','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(49669,'57007','U','Brookings','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.306715,-96.786041,0,'2013-07-06 12:44:33',NULL,NULL),(22332,'23868','S','Lawrenceville','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.610278,-77.766111,0,'2013-07-06 12:44:31',NULL,NULL),(20138,'20723','S','Laurel','D','Howard','24027','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.133677,-76.861876,0,'2013-07-06 12:44:31',NULL,NULL),(3785,'02205','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348750,-71.056940,0,'2013-07-06 12:44:30',NULL,NULL),(3069,'01128','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.094006,-72.494830,0,'2013-07-06 12:44:30',NULL,NULL),(3118,'01236','S','Housatonic','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.274740,-73.370400,0,'2013-07-06 12:44:30',NULL,NULL),(68047,'80930','S','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.830904,-104.513630,0,'2013-07-06 12:44:34',NULL,NULL),(69386,'83611','S','Warm Lake','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.393460,-115.981260,0,'2013-07-06 12:44:34',NULL,NULL),(74073,'92173','S','San Ysidro','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.560130,-116.974360,0,'2013-07-06 12:44:34',NULL,NULL),(69994,'84122','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.798588,-111.960684,0,'2013-07-06 12:44:34',NULL,NULL),(68032,'80927','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.664269,-104.909568,0,'2013-07-06 12:44:34',NULL,NULL),(62717,'74760','S','Spencerville','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.132245,-95.393533,0,'2013-07-06 12:44:33',NULL,NULL),(26621,'29316','S','Boiling Springs','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.056379,-81.964009,0,'2013-07-06 12:44:31',NULL,NULL),(13329,'13682','S','E Rodman','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.847382,-75.859853,0,'2013-07-06 12:44:30',NULL,NULL),(23873,'26160','S','Blue Goose','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(812,'00693','S','Urb Guarico','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(16688,'17370','S','Cly','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.117401,-76.775929,0,'2013-07-06 12:44:31',NULL,NULL),(29401,'32628','S','Cross City','D','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.634988,-83.111485,0,'2013-07-06 12:44:32',NULL,NULL),(22718,'24354','S','Stony Battery','N','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(54828,'63026','S','Fenton','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.501758,-90.456792,0,'2013-07-06 12:44:33',NULL,NULL),(76844,'95965','S','Honcut','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(60819,'72032','S','Saltillo','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(13853,'14226','S','Snyder','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.969504,-78.798576,0,'2013-07-06 12:44:31',NULL,NULL),(45324,'50853','S','Massena','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.253389,-94.768718,0,'2013-07-06 12:44:32',NULL,NULL),(15010,'15670','S','New Alexandria','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.414581,-79.384148,0,'2013-07-06 12:44:31',NULL,NULL),(17702,'18221','P','Drifton','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.005641,-75.904610,0,'2013-07-06 12:44:31',NULL,NULL),(3954,'02476','S','Arlington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.411936,-71.176546,0,'2013-07-06 12:44:30',NULL,NULL),(39452,'44704','S','McKinley','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.800224,-81.353797,0,'2013-07-06 12:44:32',NULL,NULL),(34428,'38642','S','Lamar','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.988460,-89.374740,0,'2013-07-06 12:44:32',NULL,NULL),(48071,'55330','S','Burns Twnshp','A','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(48259,'55427','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996340,-93.379980,0,'2013-07-06 12:44:33',NULL,NULL),(68896,'82721','S','Oshoto','A','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.588080,-104.937920,0,'2013-07-06 12:44:34',NULL,NULL),(31499,'34447','P','Homosassa Spg','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.796554,-82.550226,0,'2013-07-06 12:44:32',NULL,NULL),(33297,'37129','S','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.871995,-86.435491,0,'2013-07-06 12:44:32',NULL,NULL),(7668,'07092','S','Mountainside','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.675275,-74.358365,0,'2013-07-06 12:44:30',NULL,NULL),(1725,'00778','S','Parq Las Americas','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(6069,'05445','S','Charlotte','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.309280,-73.238700,0,'2013-07-06 12:44:30',NULL,NULL),(4427,'03235','S','W Franklin','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.437900,-71.664660,0,'2013-07-06 12:44:30',NULL,NULL),(15129,'15829','S','Corsica','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.189361,-79.172819,0,'2013-07-06 12:44:31',NULL,NULL),(23859,'26143','S','Standing Stone','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(50357,'57748','S','Bridger','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.541189,-102.211846,0,'2013-07-06 12:44:33',NULL,NULL),(72020,'88045','S','Separ','N','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.347258,-108.708739,0,'2013-07-06 12:44:34',NULL,NULL),(67061,'79563','S','Tye','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.450724,-99.867551,0,'2013-07-06 12:44:34',NULL,NULL),(40414,'45686','S','Ewington','N','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.003900,-82.369140,0,'2013-07-06 12:44:32',NULL,NULL),(36736,'41033','S','De Mossville','D','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.749457,-84.473187,0,'2013-07-06 12:44:32',NULL,NULL),(18905,'19477','S','Springhouse','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.210833,-75.278611,0,'2013-07-06 12:44:31',NULL,NULL),(29924,'33062','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.234821,-80.093841,0,'2013-07-06 12:44:32',NULL,NULL),(28044,'30660','S','Philomath','A','Wilkes','13317','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.724162,-82.762010,0,'2013-07-06 12:44:31',NULL,NULL),(75191,'93615','S','Cutler','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.529881,-119.298658,0,'2013-07-06 12:44:34',NULL,NULL),(74875,'93270','S','Terra Bella','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',35.963052,-119.038932,0,'2013-07-06 12:44:34',NULL,NULL),(55793,'64126','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.092631,-94.497302,0,'2013-07-06 12:44:33',NULL,NULL),(50836,'58478','S','Robinson','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.157419,-99.686502,0,'2013-07-06 12:44:33',NULL,NULL),(44665,'50111','S','Herrold','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.685291,-93.782087,0,'2013-07-06 12:44:32',NULL,NULL),(26077,'28701','S','Alexander','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.705795,-82.640881,0,'2013-07-06 12:44:31',NULL,NULL),(34805,'38878','S','Loyd','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(28284,'31091','S','Unadilla','D','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.259597,-83.746979,0,'2013-07-06 12:44:31',NULL,NULL),(67481,'80228','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.697980,-105.155880,0,'2013-07-06 12:44:34',NULL,NULL),(73097,'90230','S','Los Angeles','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.001758,-118.394799,0,'2013-07-06 12:44:34',NULL,NULL),(72957,'90043','S','La Tijera','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.990206,-118.335759,0,'2013-07-06 12:44:34',NULL,NULL),(18007,'18636','S','Monroe Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.418188,-76.075214,0,'2013-07-06 12:44:31',NULL,NULL),(32354,'35813','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.645609,-86.750533,0,'2013-07-06 12:44:32',NULL,NULL),(20874,'21673','S','Trappe','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.655520,-76.057179,0,'2013-07-06 12:44:31',NULL,NULL),(41766,'47303','S','Cook Acres','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(5306,'04555','S','Nobleboro','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.104064,-69.479517,0,'2013-07-06 12:44:30',NULL,NULL),(61363,'72512','S','Horseshoe Bend','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.228348,-91.752774,0,'2013-07-06 12:44:33',NULL,NULL),(71873,'87729','S','Miami','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.361111,-104.594722,0,'2013-07-06 12:44:34',NULL,NULL),(79734,'99216','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.664576,-117.214772,0,'2013-07-06 12:44:34',NULL,NULL),(76654,'95728','P','Soda Springs','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.320782,-120.408004,0,'2013-07-06 12:44:34',NULL,NULL),(3458,'01778','S','Cochituate','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.361200,-71.363880,0,'2013-07-06 12:44:30',NULL,NULL),(50228,'57601','S','Promise','N','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.538190,-100.429946,0,'2013-07-06 12:44:33',NULL,NULL),(57123,'66224','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(60933,'72086','S','Pettus','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.788120,-91.948860,0,'2013-07-06 12:44:33',NULL,NULL),(74794,'93160','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.434059,-119.802492,0,'2013-07-06 12:44:34',NULL,NULL),(78900,'98361','S','Packwood','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639263,-121.666784,0,'2013-07-06 12:44:34',NULL,NULL),(78127,'97526','S','Hugo','N','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.468747,-123.348364,0,'2013-07-06 12:44:34',NULL,NULL),(57753,'67445','S','Glasco','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.359529,-97.836641,0,'2013-07-06 12:44:33',NULL,NULL),(57017,'66206','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(4897,'04054','P','Moody','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.330629,-70.605751,0,'2013-07-06 12:44:30',NULL,NULL),(51554,'59741','S','Amsterdam','N','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.764880,-111.338940,0,'2013-07-06 12:44:33',NULL,NULL),(18248,'18991','U','Warminster','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.218695,-75.075680,0,'2013-07-06 12:44:31',NULL,NULL),(18170,'18915','S','Colmar','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.261490,-75.248416,0,'2013-07-06 12:44:31',NULL,NULL),(6264,'05602','S','Montpelier Jct','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(16643,'17340','S','Littlestown','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.763200,-77.117160,0,'2013-07-06 12:44:31',NULL,NULL),(5325,'04575','P','W Boothbay Harbor','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.848039,-69.651327,0,'2013-07-06 12:44:30',NULL,NULL),(61917,'73148','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.452945,-97.551956,0,'2013-07-06 12:44:33',NULL,NULL),(58140,'68147','S','Omaha','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.177581,-95.955671,0,'2013-07-06 12:44:33',NULL,NULL),(48319,'55445','S','Brooklyn Pk','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.106330,-93.384070,0,'2013-07-06 12:44:33',NULL,NULL),(4319,'02914','S','E Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.814172,-71.373425,0,'2013-07-06 12:44:30',NULL,NULL),(50174,'57555','S','Mission','D','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.194176,-100.477794,0,'2013-07-06 12:44:33',NULL,NULL),(50984,'58644','S','Marshall','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.136433,-102.333475,0,'2013-07-06 12:44:33',NULL,NULL),(12888,'13331','S','Big Moose','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.841882,-74.878424,0,'2013-07-06 12:44:30',NULL,NULL),(40086,'45304','S','Castine','A','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.989474,-84.534278,0,'2013-07-06 12:44:32',NULL,NULL),(17528,'17972','S','Adamsdale','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.632720,-76.155120,0,'2013-07-06 12:44:31',NULL,NULL),(2174,'00926','S','Cupey','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(36595,'40962','S','Wildcat','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(6619,'05901','P','Averill','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.942849,-71.679618,0,'2013-07-06 12:44:30',NULL,NULL),(48561,'55765','S','Toivola','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.101666,-92.758853,0,'2013-07-06 12:44:33',NULL,NULL),(56024,'64671','S','Mirabile','N','Caldwell','29025','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.556678,-94.038416,0,'2013-07-06 12:44:33',NULL,NULL),(59108,'70143','U','Naval Air New Orleans','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.822294,-90.011918,0,'2013-07-06 12:44:33',NULL,NULL),(69212,'83354','P','Sun Valley','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.726589,-114.262377,0,'2013-07-06 12:44:34',NULL,NULL),(52880,'61345','S','Neponset','D','Bureau','17011','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.301070,-89.795298,0,'2013-07-06 12:44:33',NULL,NULL),(37466,'41858','S','Whitesburg','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(52242,'60512','S','Bristol','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.710574,-88.413874,0,'2013-07-06 12:44:33',NULL,NULL),(34946,'39054','S','Cary','D','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.802891,-90.928947,0,'2013-07-06 12:44:32',NULL,NULL),(14110,'14638','U','Bank of America','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157140,-77.606676,0,'2013-07-06 12:44:31',NULL,NULL),(61498,'72645','S','Leslie','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.826780,-92.575020,0,'2013-07-06 12:44:33',NULL,NULL),(64823,'77031','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.655163,-95.546135,0,'2013-07-06 12:44:34',NULL,NULL),(13497,'13803','S','Texas Valley','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(38952,'44126','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.446483,-81.856757,0,'2013-07-06 12:44:32',NULL,NULL),(4940,'04090','S','Wells','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.303207,-70.575370,0,'2013-07-06 12:44:30',NULL,NULL),(50980,'58640','S','Killdeer','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.367775,-102.755571,0,'2013-07-06 12:44:33',NULL,NULL),(51979,'60151','S','Virgil','A','Kane','17089','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.903604,-88.594699,0,'2013-07-06 12:44:33',NULL,NULL),(60471,'71655','S','Florence','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(62067,'73548','S','Hastings','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.218401,-98.105249,0,'2013-07-06 12:44:33',NULL,NULL),(73523,'91345','S','San Fernando','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.281944,-118.438056,0,'2013-07-06 12:44:34',NULL,NULL),(47468,'54738','S','Cleghorn','N','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.572874,-91.472242,0,'2013-07-06 12:44:32',NULL,NULL),(24368,'27052','S','Meadow','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.313380,-80.155080,0,'2013-07-06 12:44:31',NULL,NULL),(11644,'12125','S','Lebanon Springs','A','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.483586,-73.377729,0,'2013-07-06 12:44:30',NULL,NULL),(4041,'02584','P','Nantucket','D','Nantucket','25019','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.263318,-70.052567,0,'2013-07-06 12:44:30',NULL,NULL),(43176,'48278','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.326390,-83.060061,0,'2013-07-06 12:44:32',NULL,NULL),(41236,'46738','S','Garrett','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(15401,'16340','S','Pittsfield','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.936865,-79.383061,0,'2013-07-06 12:44:31',NULL,NULL),(36649,'41006','S','Carntown','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.791002,-84.321560,0,'2013-07-06 12:44:32',NULL,NULL),(35603,'39601','S','Brookhaven','D','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(23550,'25630','P','Lorado','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.798699,-81.716346,0,'2013-07-06 12:44:31',NULL,NULL),(52182,'60464','S','Palos Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.671566,-87.859791,0,'2013-07-06 12:44:33',NULL,NULL),(60885,'72066','P','Hickory Plains','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.976537,-91.747656,0,'2013-07-06 12:44:33',NULL,NULL),(65832,'78151','S','Runge','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.876350,-97.704928,0,'2013-07-06 12:44:34',NULL,NULL),(69040,'83221','S','Rose','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(70899,'85620','P','Naco','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.340161,-109.941367,0,'2013-07-06 12:44:34',NULL,NULL),(52778,'61265','S','Moline','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.491529,-90.495895,0,'2013-07-06 12:44:33',NULL,NULL),(48743,'55970','S','Rose Creek','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.569828,-92.721229,0,'2013-07-06 12:44:33',NULL,NULL),(48483,'55726','S','Cromwell','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.651117,-92.904256,0,'2013-07-06 12:44:33',NULL,NULL),(10292,'10521','P','Croton Hdsn','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.234521,-73.924343,0,'2013-07-06 12:44:30',NULL,NULL),(36734,'41031','S','Shawhan','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(34445,'38652','S','Ingomar','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(63125,'75326','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.867626,-96.982402,0,'2013-07-06 12:44:33',NULL,NULL),(71881,'87732','S','North Carmen','N','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.059286,-105.288077,0,'2013-07-06 12:44:34',NULL,NULL),(73621,'91405','S','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201681,-118.446452,0,'2013-07-06 12:44:34',NULL,NULL),(13484,'13796','S','West Laurens','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.543720,-75.140700,0,'2013-07-06 12:44:31',NULL,NULL),(13275,'13655','S','Akwesasne','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.982946,-74.655861,0,'2013-07-06 12:44:30',NULL,NULL),(31917,'35161','P','Waldo','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.437647,-86.103133,0,'2013-07-06 12:44:32',NULL,NULL),(75116,'93546','S','Toms Place','A','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.564380,-118.744510,0,'2013-07-06 12:44:34',NULL,NULL),(70708,'85269','P','Scottsdale','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.603722,-111.720365,0,'2013-07-06 12:44:34',NULL,NULL),(52101,'60411','S','Sauk Village','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(48890,'56111','S','Alpha','D','Jackson','27063','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.585344,-94.914793,0,'2013-07-06 12:44:33',NULL,NULL),(37476,'42001','S','Lone Oak','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(40134,'45337','S','Laura','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.996855,-84.410254,0,'2013-07-06 12:44:32',NULL,NULL),(12068,'12543','S','Maybrook','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.486349,-74.212862,0,'2013-07-06 12:44:30',NULL,NULL),(44352,'49779','S','Rogers City','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.416207,-83.857620,0,'2013-07-06 12:44:32',NULL,NULL),(42155,'47522','S','Crane','D','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(14797,'15376','S','W Alexander','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.112468,-80.489517,0,'2013-07-06 12:44:31',NULL,NULL),(31405,'34232','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.321096,-82.476578,0,'2013-07-06 12:44:32',NULL,NULL),(50126,'57523','S','Lucas','A','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.244820,-99.239220,0,'2013-07-06 12:44:33',NULL,NULL),(57136,'66226','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.004920,-94.858860,0,'2013-07-06 12:44:33',NULL,NULL),(73307,'90807','S','Signal Hill','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.827641,-118.179228,0,'2013-07-06 12:44:34',NULL,NULL),(75428,'94035','P','Moffett Field','A','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.412894,-122.049891,0,'2013-07-06 12:44:34',NULL,NULL),(78918,'98366','S','Annapolis','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(74100,'92203','S','Indio','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.755580,-116.226718,0,'2013-07-06 12:44:34',NULL,NULL),(22463,'24037','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.280233,-79.935704,0,'2013-07-06 12:44:31',NULL,NULL),(18414,'19060','S','Boothwyn','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.846163,-75.445489,0,'2013-07-06 12:44:31',NULL,NULL),(38865,'44099','S','Windsor','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.561142,-80.966990,0,'2013-07-06 12:44:32',NULL,NULL),(58182,'68310','S','Beatrice','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(66269,'78578','S','Laguna Hts','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(66707,'78947','S','Lexington','D','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.391667,-97.147222,0,'2013-07-06 12:44:34',NULL,NULL),(10816,'11377','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.743107,-73.906134,0,'2013-07-06 12:44:30',NULL,NULL),(3665,'02124','S','Dorchester','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.286139,-71.070555,0,'2013-07-06 12:44:30',NULL,NULL),(24959,'27835','P','Greenville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.607000,-77.371771,0,'2013-07-06 12:44:31',NULL,NULL),(73129,'90270','S','Maywood','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.977500,-118.186111,0,'2013-07-06 12:44:34',NULL,NULL),(64920,'77205','P','Humble','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.955096,-95.335741,0,'2013-07-06 12:44:34',NULL,NULL),(61518,'72658','S','Norfork','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.208500,-92.266680,0,'2013-07-06 12:44:33',NULL,NULL),(49690,'57025','S','Elk Point','D','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.785700,-96.696900,0,'2013-07-06 12:44:33',NULL,NULL),(35262,'39356','S','Rose Hill','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.135619,-89.012567,0,'2013-07-06 12:44:32',NULL,NULL),(29390,'32615','S','Alachua','D','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.784372,-82.477314,0,'2013-07-06 12:44:32',NULL,NULL),(52397,'60633','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.653807,-87.559353,0,'2013-07-06 12:44:33',NULL,NULL),(67542,'80260','S','Thornton','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(77357,'96737','P','Ocean View','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.061249,-155.716967,0,'2013-07-06 12:44:34',NULL,NULL),(60037,'71343','S','Quaid','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(56552,'65463','S','Eldridge','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.821140,-92.773551,0,'2013-07-06 12:44:33',NULL,NULL),(7040,'06269','U','Storrs/Mansfield','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.811419,-72.247553,0,'2013-07-06 12:44:30',NULL,NULL),(16214,'17073','S','Millbach Sprs','N','Lebanon','42075','Pennsylvania','PA','42','3240','610/484','Eastern',-5.0,'Y',40.308720,-76.252800,0,'2013-07-06 12:44:31',NULL,NULL),(35264,'39358','S','Scooba','D','Kemper','28069','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.840314,-88.517252,0,'2013-07-06 12:44:32',NULL,NULL),(42802,'48050','S','Lenox','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.784440,-82.916880,0,'2013-07-06 12:44:32',NULL,NULL),(41764,'47302','S','Progress','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(41211,'46725','S','Wilson Lake','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(38246,'43268','U','Huntington National Bank','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.964398,-82.994319,0,'2013-07-06 12:44:32',NULL,NULL),(28805,'32064','S','Dowling Park','A','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.295480,-82.987712,0,'2013-07-06 12:44:32',NULL,NULL),(51346,'59318','S','Brusett','D','Garfield','30033','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.311150,-107.626383,0,'2013-07-06 12:44:33',NULL,NULL),(56595,'65559','S','Rosati','N','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.998771,-91.613832,0,'2013-07-06 12:44:33',NULL,NULL),(65891,'78232','S','Hl Cntry Vlg','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584537,-98.475424,0,'2013-07-06 12:44:34',NULL,NULL),(64685,'76834','S','Silver Valley','N','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.833600,-99.415500,0,'2013-07-06 12:44:34',NULL,NULL),(61584,'72749','S','Morrow','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.852571,-94.430226,0,'2013-07-06 12:44:33',NULL,NULL),(25147,'28021','S','Cherryville','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.381411,-81.375643,0,'2013-07-06 12:44:31',NULL,NULL),(8415,'08073','P','Rancocas','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.009777,-74.869986,0,'2013-07-06 12:44:30',NULL,NULL),(7514,'07002','S','Bergen Point','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.664207,-74.122276,0,'2013-07-06 12:44:30',NULL,NULL),(8427,'08077','S','Riverton','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.008345,-75.010068,0,'2013-07-06 12:44:30',NULL,NULL),(9676,'10041','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(23420,'25350','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352825,-81.629965,0,'2013-07-06 12:44:31',NULL,NULL),(63862,'75980','S','Nancy','N','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.160640,-94.402200,0,'2013-07-06 12:44:34',NULL,NULL),(73956,'92064','S','Poway','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.980878,-117.036369,0,'2013-07-06 12:44:34',NULL,NULL),(15025,'15684','S','Slickville','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.465750,-79.504047,0,'2013-07-06 12:44:31',NULL,NULL),(39945,'45231','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.244265,-84.540628,0,'2013-07-06 12:44:32',NULL,NULL),(31727,'34982','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.391390,-80.332087,0,'2013-07-06 12:44:32',NULL,NULL),(26863,'29536','S','Floyd Dl','N','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.414774,-79.364457,0,'2013-07-06 12:44:31',NULL,NULL),(25744,'28570','S','Newport','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.770637,-76.870770,0,'2013-07-06 12:44:31',NULL,NULL),(10969,'11530','S','Garden City','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(26337,'29058','S','Stoneboro','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.544700,-80.751780,0,'2013-07-06 12:44:31',NULL,NULL),(12292,'12847','S','Long Lake','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.968517,-74.418773,0,'2013-07-06 12:44:30',NULL,NULL),(47479,'54747','S','Elk Creek','N','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.358587,-91.422932,0,'2013-07-06 12:44:32',NULL,NULL),(64319,'76481','S','South Bend','D','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',32.960083,-98.760290,0,'2013-07-06 12:44:34',NULL,NULL),(65017,'77304','S','Panorama Vlg','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.342840,-95.477880,0,'2013-07-06 12:44:34',NULL,NULL),(62422,'74141','U','United States Postal Service','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.133837,-95.876959,0,'2013-07-06 12:44:33',NULL,NULL),(57195,'66423','S','Eskridge','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.858181,-96.104822,0,'2013-07-06 12:44:33',NULL,NULL),(55830,'64152','S','Weatherby Lake','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.218160,-94.730700,0,'2013-07-06 12:44:33',NULL,NULL),(8885,'08723','S','Brick','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.051680,-74.106780,0,'2013-07-06 12:44:30',NULL,NULL),(6066,'05444','S','Fletcher','N','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(23476,'25503','S','Ashton','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.596993,-82.108884,0,'2013-07-06 12:44:31',NULL,NULL),(4406,'03222','S','Bristol','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.606641,-71.739886,0,'2013-07-06 12:44:30',NULL,NULL),(49798,'57186','U','Paytrust','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.549300,-96.726635,0,'2013-07-06 12:44:33',NULL,NULL),(3180,'01337','S','Leyden','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.689880,-72.583740,0,'2013-07-06 12:44:30',NULL,NULL),(10291,'10520','S','Croton on Hudson','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.216760,-73.896720,0,'2013-07-06 12:44:30',NULL,NULL),(20047,'20656','S','Loveville','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.351300,-76.680493,0,'2013-07-06 12:44:31',NULL,NULL),(19367,'20056','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906628,-76.986151,0,'2013-07-06 12:44:31',NULL,NULL),(41267,'46750','S','Mahon','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(50202,'57571','S','St Charles','A','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.108303,-99.115247,0,'2013-07-06 12:44:33',NULL,NULL),(66199,'78545','P','Falcon Heights','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.581595,-98.985987,0,'2013-07-06 12:44:34',NULL,NULL),(53208,'61616','S','Peoria','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.751710,-89.600183,0,'2013-07-06 12:44:33',NULL,NULL),(30327,'33308','S','Laud By Sea','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(54226,'62651','P','Jacksonville','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.727574,-90.264027,0,'2013-07-06 12:44:33',NULL,NULL),(54621,'62917','S','Carrier Mills','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.690197,-88.627956,0,'2013-07-06 12:44:33',NULL,NULL),(15164,'15915','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.308331,-78.859292,0,'2013-07-06 12:44:31',NULL,NULL),(24180,'26624','S','Gassaway','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.686020,-80.772214,0,'2013-07-06 12:44:31',NULL,NULL),(20206,'20757','P','Temple Hills','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.806795,-76.947183,0,'2013-07-06 12:44:31',NULL,NULL),(2383,'00949','S','Urb La Inmaculada','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(40571,'45867','S','Mount Blanchard','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.905474,-83.535045,0,'2013-07-06 12:44:32',NULL,NULL),(31254,'33982','S','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.971236,-81.962313,0,'2013-07-06 12:44:32',NULL,NULL),(57953,'67752','S','Quinter','D','Gove','20063','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.915534,-100.242238,0,'2013-07-06 12:44:33',NULL,NULL),(64362,'76524','S','Blevins','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.335720,-97.277820,0,'2013-07-06 12:44:34',NULL,NULL),(65634,'77964','S','Hallettsville','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(38727,'44023','S','Auburn Township','A','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.390948,-81.336689,0,'2013-07-06 12:44:32',NULL,NULL),(10791,'11370','S','East Elmhurst','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760333,-73.890833,0,'2013-07-06 12:44:30',NULL,NULL),(1593,'00769','S','Jard de Santa Ana','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(24955,'27834','S','East Carolina Univ','N','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.626380,-77.438580,0,'2013-07-06 12:44:31',NULL,NULL),(1994,'00909','S','Minillas','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(38504,'43702','P','South Zanesville','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.940823,-82.006789,0,'2013-07-06 12:44:32',NULL,NULL),(13248,'13642','S','Natural Dam','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(41158,'46703','S','Berlien','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(13116,'13486','S','Westernville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.347210,-75.324999,0,'2013-07-06 12:44:30',NULL,NULL),(6813,'06110','S','W Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(49507,'56667','S','Nebish','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(55063,'63163','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.597345,-90.242181,0,'2013-07-06 12:44:33',NULL,NULL),(45461,'51245','S','Gaza','N','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.083360,-95.641200,0,'2013-07-06 12:44:32',NULL,NULL),(23362,'25268','S','Orma','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.709444,-81.098333,0,'2013-07-06 12:44:31',NULL,NULL),(4878,'04037','S','N Fryeburg','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.014772,-70.967645,0,'2013-07-06 12:44:30',NULL,NULL),(39770,'45121','S','Brown County','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(10082,'10199','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(18784,'19374','S','Toughkenamon','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835395,-75.760821,0,'2013-07-06 12:44:31',NULL,NULL),(2719,'00969','S','Urb Alto Apolo States','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(31267,'33994','P','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.630413,-81.852216,0,'2013-07-06 12:44:32',NULL,NULL),(70504,'84781','S','Pine Valley','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.326961,-113.405734,0,'2013-07-06 12:44:34',NULL,NULL),(59020,'70075','S','St Bernard Grove','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948870,-89.898600,0,'2013-07-06 12:44:33',NULL,NULL),(50013,'57383','S','White Lake','D','Aurora','46003','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.804787,-98.684321,0,'2013-07-06 12:44:33',NULL,NULL),(28188,'31013','P','Clinchfield','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.337684,-83.731445,0,'2013-07-06 12:44:31',NULL,NULL),(16998,'17730','P','Dewart','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.110074,-76.875058,0,'2013-07-06 12:44:31',NULL,NULL),(42372,'47711','S','Knight','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(13122,'13491','S','East Winfield','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(46694,'53785','U','Wi Dept Revenue BOX 59','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075404,-89.383079,0,'2013-07-06 12:44:32',NULL,NULL),(70513,'84790','S','Saint George','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.080345,-113.575391,0,'2013-07-06 12:44:34',NULL,NULL),(72589,'89406','S','Peterson','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(57684,'67228','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.765407,-97.207113,0,'2013-07-06 12:44:33',NULL,NULL),(55770,'64116','S','No Kansas City','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(25982,'28663','S','Piney Creek','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.563107,-81.281762,0,'2013-07-06 12:44:31',NULL,NULL),(42238,'47567','S','West Petersburg','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(16985,'17727','S','Leetonia','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.497301,-77.490054,0,'2013-07-06 12:44:31',NULL,NULL),(44456,'49874','S','Powers','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.690289,-87.499966,0,'2013-07-06 12:44:32',NULL,NULL),(38250,'43271','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.970935,-83.026273,0,'2013-07-06 12:44:32',NULL,NULL),(13615,'13864','S','Gridleyville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.276942,-76.378237,0,'2013-07-06 12:44:31',NULL,NULL),(13396,'13749','P','Corbettsville','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.018867,-75.790964,0,'2013-07-06 12:44:31',NULL,NULL),(51889,'60095','P','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.098083,-88.010648,0,'2013-07-06 12:44:33',NULL,NULL),(66148,'78501','S','Mc Allen','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.213590,-98.235546,0,'2013-07-06 12:44:34',NULL,NULL),(70339,'84632','P','Fountain Green','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.536945,-111.680191,0,'2013-07-06 12:44:34',NULL,NULL),(77508,'96838','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.348058,-157.876862,0,'2013-07-06 12:44:34',NULL,NULL),(74445,'92584','S','Menifee','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.679800,-117.189480,0,'2013-07-06 12:44:34',NULL,NULL),(71111,'86005','S','Flagstaff','D','Coconino','04005','Arizona','AZ','04','0000','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(65668,'77982','P','Port O\' Connor','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.225330,-96.643456,0,'2013-07-06 12:44:34',NULL,NULL),(64093,'76162','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.663309,-97.377859,0,'2013-07-06 12:44:34',NULL,NULL),(25119,'27986','S','Winton','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.385231,-76.942476,0,'2013-07-06 12:44:31',NULL,NULL),(9205,'09470','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(44428,'49841','S','Princeton','A','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.323840,-87.480360,0,'2013-07-06 12:44:32',NULL,NULL),(13560,'13838','S','Sidney','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.305400,-75.390406,0,'2013-07-06 12:44:31',NULL,NULL),(33771,'37867','P','Shawanee','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.579916,-83.639506,0,'2013-07-06 12:44:32',NULL,NULL),(40736,'46131','S','Amity','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.488252,-86.054873,0,'2013-07-06 12:44:32',NULL,NULL),(48289,'55436','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.901982,-93.372906,0,'2013-07-06 12:44:33',NULL,NULL),(53098,'61533','S','Glasford','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.591944,-89.815159,0,'2013-07-06 12:44:33',NULL,NULL),(80026,'99687','P','Wasilla','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.591714,-149.416478,0,'2013-07-06 12:44:34',NULL,NULL),(46126,'52644','S','Mt Union','A','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.032332,-91.426886,0,'2013-07-06 12:44:32',NULL,NULL),(28729,'31906','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.470086,-84.953402,0,'2013-07-06 12:44:32',NULL,NULL),(27995,'30598','P','Toccoa Falls','D','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.591475,-83.356490,0,'2013-07-06 12:44:31',NULL,NULL),(31754,'34990','S','Palm City','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.166551,-80.292470,0,'2013-07-06 12:44:32',NULL,NULL),(69063,'83236','S','Lower Presto','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.286660,-112.129557,0,'2013-07-06 12:44:34',NULL,NULL),(75505,'94139','U','Wells Fargo Bank','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794865,-122.406188,0,'2013-07-06 12:44:34',NULL,NULL),(74007,'92114','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.707130,-117.051153,0,'2013-07-06 12:44:34',NULL,NULL),(66175,'78521','S','Brownsville','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.939204,-97.447349,0,'2013-07-06 12:44:34',NULL,NULL),(53575,'62060','S','Cloverleaf','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.686572,-90.153079,0,'2013-07-06 12:44:33',NULL,NULL),(44080,'49452','S','Rothbury','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.513627,-86.305428,0,'2013-07-06 12:44:32',NULL,NULL),(43256,'48324','S','Orchard Lake','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595440,-83.383020,0,'2013-07-06 12:44:32',NULL,NULL),(10545,'10997','P','U S C C','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.361500,-74.027051,0,'2013-07-06 12:44:30',NULL,NULL),(30640,'33448','P','W Delray Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.461111,-80.073056,0,'2013-07-06 12:44:32',NULL,NULL),(50923,'58564','S','Freda','N','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.337217,-101.260167,0,'2013-07-06 12:44:33',NULL,NULL),(36211,'40280','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.247902,-85.684110,0,'2013-07-06 12:44:32',NULL,NULL),(11969,'12461','S','Krumville','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.898780,-74.257380,0,'2013-07-06 12:44:30',NULL,NULL),(32139,'35457','S','Echola','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.322469,-87.809615,0,'2013-07-06 12:44:32',NULL,NULL),(55091,'63301','S','Orchard Farm','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(77093,'96137','S','Lake Almanor','A','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.349400,-121.071420,0,'2013-07-06 12:44:34',NULL,NULL),(59941,'71301','S','Alex','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(30286,'33261','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.891214,-80.181179,0,'2013-07-06 12:44:32',NULL,NULL),(45448,'51234','S','Boyden','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.194052,-96.004160,0,'2013-07-06 12:44:32',NULL,NULL),(20583,'21157','S','Westminster','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.555120,-76.990560,0,'2013-07-06 12:44:31',NULL,NULL),(22571,'24153','S','Fort Lewis','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(60109,'71366','S','Mayflower','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(61685,'72941','S','Lavaca','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.336949,-94.170533,0,'2013-07-06 12:44:33',NULL,NULL),(75422,'94027','S','Menlo Park','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.456184,-122.204497,0,'2013-07-06 12:44:34',NULL,NULL),(73431,'91209','P','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144640,-118.250262,0,'2013-07-06 12:44:34',NULL,NULL),(72748,'89510','S','Cannon International Airport','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(52226,'60499','P','Bedford Pk','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782323,-87.767936,0,'2013-07-06 12:44:33',NULL,NULL),(48874,'56087','S','Springfield','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.239012,-94.979096,0,'2013-07-06 12:44:33',NULL,NULL),(30281,'33257','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.613248,-80.347422,0,'2013-07-06 12:44:32',NULL,NULL),(17839,'18421','S','Vandling','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(17937,'18503','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.411047,-75.665541,0,'2013-07-06 12:44:31',NULL,NULL),(6225,'05490','P','Underhill Center','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.527965,-72.896952,0,'2013-07-06 12:44:30',NULL,NULL),(42713,'48001','S','Russell Island','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(5906,'05161','S','Weston','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.284563,-72.793543,0,'2013-07-06 12:44:30',NULL,NULL),(41794,'47326','S','Fiat','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.536527,-84.963031,0,'2013-07-06 12:44:32',NULL,NULL),(36417,'40536','U','University of Ky Med Ctr','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.030056,-84.507951,0,'2013-07-06 12:44:32',NULL,NULL),(77238,'96531','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(59191,'70360','S','Houma','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.607360,-90.782400,0,'2013-07-06 12:44:33',NULL,NULL),(54380,'62812','S','Steel City','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(46974,'54214','P','Francis Creek','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.205072,-87.719250,0,'2013-07-06 12:44:32',NULL,NULL),(35653,'39647','S','Eddiceton','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.510920,-90.772920,0,'2013-07-06 12:44:32',NULL,NULL),(41559,'47022','S','Dover','N','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.206304,-84.952322,0,'2013-07-06 12:44:32',NULL,NULL),(9056,'08902','S','N Brunswick','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.446660,-74.488980,0,'2013-07-06 12:44:30',NULL,NULL),(14602,'15224','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465933,-79.946627,0,'2013-07-06 12:44:31',NULL,NULL),(63067,'75234','S','Farmers Branch','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.915750,-96.896140,0,'2013-07-06 12:44:33',NULL,NULL),(67876,'80836','S','Stratton','D','Kit Carson','08063','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.311476,-102.580991,0,'2013-07-06 12:44:34',NULL,NULL),(76225,'95376','S','Tracy','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.732544,-121.418973,0,'2013-07-06 12:44:34',NULL,NULL),(70888,'85615','S','Miracle Valley','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.402920,-110.207340,0,'2013-07-06 12:44:34',NULL,NULL),(68408,'81157','P','Pagosa Springs','D','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.268072,-107.088673,0,'2013-07-06 12:44:34',NULL,NULL),(14519,'15203','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.424202,-79.975101,0,'2013-07-06 12:44:31',NULL,NULL),(6130,'05460','P','Highgate Sprg','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.979819,-73.105448,0,'2013-07-06 12:44:30',NULL,NULL),(14907,'15532','P','Boynton','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.788051,-79.016618,0,'2013-07-06 12:44:31',NULL,NULL),(49226,'56469','S','Libby','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(71749,'87544','S','Bandelier National Monument','N','Los Alamos','35028','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.866912,-106.265556,0,'2013-07-06 12:44:34',NULL,NULL),(76311,'95449','S','Hopland','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.983549,-123.114740,0,'2013-07-06 12:44:34',NULL,NULL),(62136,'73701','S','Enid','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.405255,-97.874299,0,'2013-07-06 12:44:33',NULL,NULL),(51943,'60129','S','Esmond','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.025271,-88.934243,0,'2013-07-06 12:44:33',NULL,NULL),(15741,'16901','S','Stonyfork','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(603,'00680','S','Urb Ponce de Leon','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(20389,'20892','U','National Institute of Health','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008260,-77.100290,0,'2013-07-06 12:44:31',NULL,NULL),(9214,'09506','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(17623,'18050','P','Bangor','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.864578,-75.207134,0,'2013-07-06 12:44:31',NULL,NULL),(6742,'06081','S','Tariffville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.906091,-72.769185,0,'2013-07-06 12:44:30',NULL,NULL),(30403,'33323','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.162098,-80.306679,0,'2013-07-06 12:44:32',NULL,NULL),(30285,'33261','P','Keystone Islands','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.891214,-80.181179,0,'2013-07-06 12:44:32',NULL,NULL),(22801,'24473','S','Rockbdge Bath','A','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.899159,-79.396696,0,'2013-07-06 12:44:31',NULL,NULL),(45436,'51105','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.503888,-96.372206,0,'2013-07-06 12:44:32',NULL,NULL),(46315,'53070','S','Oostburg','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.627466,-87.792764,0,'2013-07-06 12:44:32',NULL,NULL),(54572,'62896','S','Stiritz','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(78746,'98290','S','Snohomish','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.939532,-122.016706,0,'2013-07-06 12:44:34',NULL,NULL),(79929,'99613','P','Igiugig','A','Bristol Bay','02060','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.709924,-156.656310,0,'2013-07-06 12:44:34',NULL,NULL),(79048,'98411','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.219564,-122.474047,0,'2013-07-06 12:44:34',NULL,NULL),(63657,'75846','S','Robbins','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.375296,-96.221448,0,'2013-07-06 12:44:34',NULL,NULL),(45846,'52225','S','Elberon','D','Tama','19171','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.011650,-92.350272,0,'2013-07-06 12:44:32',NULL,NULL),(4119,'02725','S','Somerset','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.723826,-71.177660,0,'2013-07-06 12:44:30',NULL,NULL),(34065,'38147','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142153,-90.054546,0,'2013-07-06 12:44:32',NULL,NULL),(50775,'58425','S','Cooperstown','D','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.445786,-98.118678,0,'2013-07-06 12:44:33',NULL,NULL),(60276,'71447','S','Taylor Hill','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(66528,'78719','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.127369,-97.672339,0,'2013-07-06 12:44:34',NULL,NULL),(77329,'96710','P','Hakalau','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.882209,-155.152535,0,'2013-07-06 12:44:34',NULL,NULL),(69021,'83212','S','Arbon','D','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.550969,-112.520939,0,'2013-07-06 12:44:34',NULL,NULL),(59276,'70459','P','Slidell','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.286348,-89.772643,0,'2013-07-06 12:44:33',NULL,NULL),(48212,'55410','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.913077,-93.319293,0,'2013-07-06 12:44:33',NULL,NULL),(25270,'28126','P','Newell','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.275939,-80.736607,0,'2013-07-06 12:44:31',NULL,NULL),(37487,'42021','S','Arlington','D','Carlisle','21039','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.791078,-89.005986,0,'2013-07-06 12:44:32',NULL,NULL),(7990,'07716','S','Atlantic Highlands','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.404595,-74.035623,0,'2013-07-06 12:44:30',NULL,NULL),(29802,'33023','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(16737,'17502','S','Stack Town','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.121860,-76.654353,0,'2013-07-06 12:44:31',NULL,NULL),(14394,'15050','S','Hookstown','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.580261,-80.458899,0,'2013-07-06 12:44:31',NULL,NULL),(1871,'00791','S','Urb La Patagonia','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(52637,'61050','S','McConnell','N','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.439584,-89.731064,0,'2013-07-06 12:44:33',NULL,NULL),(64855,'77052','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756932,-95.358959,0,'2013-07-06 12:44:34',NULL,NULL),(79146,'98501','S','South Sound','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(55243,'63446','S','Forest Springs','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.127713,-92.003683,0,'2013-07-06 12:44:33',NULL,NULL),(17677,'18106','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.581600,-75.527580,0,'2013-07-06 12:44:31',NULL,NULL),(6062,'05444','S','Binghamville','N','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(39457,'44706','S','Richville','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.771402,-81.413102,0,'2013-07-06 12:44:32',NULL,NULL),(27249,'29927','S','Limehouse','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.281300,-81.071015,0,'2013-07-06 12:44:31',NULL,NULL),(60590,'71832','S','De Queen','D','Sevier','05133','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.044054,-94.343484,0,'2013-07-06 12:44:33',NULL,NULL),(79238,'98554','P','Lebam','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.558298,-123.549845,0,'2013-07-06 12:44:34',NULL,NULL),(42620,'47905','S','Colburn','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.322083,-86.910463,0,'2013-07-06 12:44:32',NULL,NULL),(3353,'01562','S','Lambs Grove','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.248647,-71.995246,0,'2013-07-06 12:44:30',NULL,NULL),(20784,'21539','S','Lonaconing','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.596680,-79.013567,0,'2013-07-06 12:44:31',NULL,NULL),(32995,'36628','U','U S Corps of Engineers','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.693855,-88.045183,0,'2013-07-06 12:44:32',NULL,NULL),(27159,'29834','P','Breeze Hill','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.513651,-81.847009,0,'2013-07-06 12:44:31',NULL,NULL),(60969,'72104','S','Rockport','A','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(68194,'81034','U','Ordway','D','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.192350,-103.856264,0,'2013-07-06 12:44:34',NULL,NULL),(71701,'87522','S','Rio Chiquito','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(75965,'95053','U','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.347920,-121.936525,0,'2013-07-06 12:44:34',NULL,NULL),(71238,'86339','P','Sedona','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.868999,-111.766051,0,'2013-07-06 12:44:34',NULL,NULL),(58013,'67876','S','Spearville','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.846187,-99.756989,0,'2013-07-06 12:44:33',NULL,NULL),(14412,'15067','S','Courtney','N','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.205814,-79.953185,0,'2013-07-06 12:44:31',NULL,NULL),(22440,'24018','S','Poages Mill','N','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.226453,-80.026824,0,'2013-07-06 12:44:31',NULL,NULL),(19106,'19606','S','Lorane','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(5453,'04730','S','Littleton','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(43821,'49081','P','Portage','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.205616,-85.566785,0,'2013-07-06 12:44:32',NULL,NULL),(42964,'48131','S','Rea','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.965760,-83.668534,0,'2013-07-06 12:44:32',NULL,NULL),(42042,'47441','S','Wright','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(51024,'58711','S','Kuroki','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.948044,-101.362952,0,'2013-07-06 12:44:33',NULL,NULL),(68675,'82001','S','Fe Warren Afb','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.143114,-104.792918,0,'2013-07-06 12:44:34',NULL,NULL),(74178,'92274','S','Vista Santa Rosa','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(76423,'95568','S','Somesbar','N','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.435199,-123.488452,0,'2013-07-06 12:44:34',NULL,NULL),(74901,'93306','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.390652,-118.930410,0,'2013-07-06 12:44:34',NULL,NULL),(41816,'47336','S','Crumley Crossing','N','Jay','18075','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.374187,-85.208851,0,'2013-07-06 12:44:32',NULL,NULL),(36672,'41011','S','Park Hills','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(17270,'17844','S','Cowan','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(44844,'50265','S','West Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.583232,-93.756888,0,'2013-07-06 12:44:32',NULL,NULL),(38823,'44077','S','Fairport Hbr','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.750000,-81.283333,0,'2013-07-06 12:44:32',NULL,NULL),(56659,'65619','S','Brookline Sta','A','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.129140,-93.386700,0,'2013-07-06 12:44:33',NULL,NULL),(60839,'72040','S','Hayley','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(63755,'75939','S','Snow Hill','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(79912,'99603','S','Halibut Cove','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(58274,'68403','P','Manley','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.919042,-96.164769,0,'2013-07-06 12:44:33',NULL,NULL),(56191,'65016','S','Bonnots Mill','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.562513,-91.919760,0,'2013-07-06 12:44:33',NULL,NULL),(26261,'29006','S','Samaria','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(21680,'22960','S','Madison Mills','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.245110,-78.108521,0,'2013-07-06 12:44:31',NULL,NULL),(2669,'00966','S','Urb Tintillo Gdns','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(42358,'47701','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.977344,-87.572423,0,'2013-07-06 12:44:32',NULL,NULL),(37603,'42129','S','Cave Ridge','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(4260,'02879','S','Wakefield','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(31081,'33859','S','Lake Wales','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.794590,-81.400121,0,'2013-07-06 12:44:32',NULL,NULL),(57254,'66535','S','St George','N','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.224971,-96.438051,0,'2013-07-06 12:44:33',NULL,NULL),(69314,'83464','S','Leadore','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.601224,-113.355918,0,'2013-07-06 12:44:34',NULL,NULL),(55779,'64118','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.215793,-94.572799,0,'2013-07-06 12:44:33',NULL,NULL),(53528,'62031','S','Fieldon','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.101331,-90.556238,0,'2013-07-06 12:44:33',NULL,NULL),(12655,'13118','S','Moravia','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.730440,-76.380600,0,'2013-07-06 12:44:30',NULL,NULL),(43756,'49015','S','Battle Creek','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.301020,-85.229100,0,'2013-07-06 12:44:32',NULL,NULL),(22640,'24251','S','Snowflake','N','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.633269,-82.573483,0,'2013-07-06 12:44:31',NULL,NULL),(24286,'27006','S','Bixby','N','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(25707,'28540','S','Jacksonville','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.764003,-77.434331,0,'2013-07-06 12:44:31',NULL,NULL),(60505,'71665','S','Rye','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(62087,'73565','S','Ryan','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.031354,-97.874536,0,'2013-07-06 12:44:33',NULL,NULL),(73667,'91522','U','Burbank Studios','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.146904,-118.337574,0,'2013-07-06 12:44:34',NULL,NULL),(77135,'96157','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.940824,-119.980263,0,'2013-07-06 12:44:34',NULL,NULL),(34312,'38552','S','Chestnut Mound','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.187343,-85.842629,0,'2013-07-06 12:44:32',NULL,NULL),(36630,'41003','S','Berry','D','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.358271,-84.280361,0,'2013-07-06 12:44:32',NULL,NULL),(7222,'06502','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.308684,-72.924444,0,'2013-07-06 12:44:30',NULL,NULL),(4509,'03298','U','BRM J Jill','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.634856,-71.531507,0,'2013-07-06 12:44:30',NULL,NULL),(30985,'33758','P','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.974259,-82.749702,0,'2013-07-06 12:44:32',NULL,NULL),(29737,'32963','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.647905,-80.360668,0,'2013-07-06 12:44:32',NULL,NULL),(58196,'68318','S','Blue Springs','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.139141,-96.666383,0,'2013-07-06 12:44:33',NULL,NULL),(52185,'60466','S','University Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.464740,-87.699000,0,'2013-07-06 12:44:33',NULL,NULL),(25329,'28206','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.250840,-80.822041,0,'2013-07-06 12:44:31',NULL,NULL),(4120,'02726','S','Somerset','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.753713,-71.146572,0,'2013-07-06 12:44:30',NULL,NULL),(31916,'35161','P','Talladega','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.437647,-86.103133,0,'2013-07-06 12:44:32',NULL,NULL),(7899,'07602','P','Hackensack','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.890436,-74.047813,0,'2013-07-06 12:44:30',NULL,NULL),(22302,'23830','S','Carson','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.020904,-77.397114,0,'2013-07-06 12:44:31',NULL,NULL),(37440,'41836','S','Bath','N','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.301259,-82.915491,0,'2013-07-06 12:44:32',NULL,NULL),(30027,'33138','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849350,-80.181844,0,'2013-07-06 12:44:32',NULL,NULL),(79470,'98855','S','Tonasket','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.704499,-119.439348,0,'2013-07-06 12:44:34',NULL,NULL),(77943,'97345','S','Foster','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.424688,-122.571043,0,'2013-07-06 12:44:34',NULL,NULL),(57066,'66213','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(53976,'62439','S','Allison','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(45784,'52161','S','Ossian','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.172563,-91.818637,0,'2013-07-06 12:44:32',NULL,NULL),(23914,'26215','S','Rock Cave','A','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.836483,-80.340000,0,'2013-07-06 12:44:31',NULL,NULL),(13390,'13746','S','Chenango Fks','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.269580,-75.839580,0,'2013-07-06 12:44:31',NULL,NULL),(41857,'47354','S','Losantville','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.039740,-85.201920,0,'2013-07-06 12:44:32',NULL,NULL),(17694,'18212','P','Ashfield','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.836142,-75.710075,0,'2013-07-06 12:44:31',NULL,NULL),(24864,'27656','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.848805,-78.692264,0,'2013-07-06 12:44:31',NULL,NULL),(61909,'73145','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.415801,-97.392307,0,'2013-07-06 12:44:33',NULL,NULL),(62465,'74335','P','Cardin','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.971642,-94.852373,0,'2013-07-06 12:44:33',NULL,NULL),(66256,'78573','S','Mission','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214239,-98.325921,0,'2013-07-06 12:44:34',NULL,NULL),(75177,'93605','P','Big Creek','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.211790,-119.243574,0,'2013-07-06 12:44:34',NULL,NULL),(74963,'93428','S','Cambria','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.558529,-121.081282,0,'2013-07-06 12:44:34',NULL,NULL),(72406,'89045','S','Round Mountain','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.808300,-117.156300,0,'2013-07-06 12:44:34',NULL,NULL),(67415,'80135','S','Deckers','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.257643,-105.225649,0,'2013-07-06 12:44:34',NULL,NULL),(28781,'32038','S','Fort White','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.923210,-82.714080,0,'2013-07-06 12:44:32',NULL,NULL),(34270,'38468','S','Leoma','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.229730,-87.339983,0,'2013-07-06 12:44:32',NULL,NULL),(44247,'49670','S','Northport','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.132456,-85.611687,0,'2013-07-06 12:44:32',NULL,NULL),(28377,'31296','U','Geico Claims','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.808701,-83.569496,0,'2013-07-06 12:44:32',NULL,NULL),(7345,'06722','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.556468,-73.038582,0,'2013-07-06 12:44:30',NULL,NULL),(25958,'28657','S','Three Mile','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(47008,'54302','S','Preble','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.505133,-87.971774,0,'2013-07-06 12:44:32',NULL,NULL),(67509,'80238','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.736803,-104.982989,0,'2013-07-06 12:44:34',NULL,NULL),(54555,'62890','S','Parrish','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(27534,'30222','S','Stovall','A','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.025339,-84.720335,0,'2013-07-06 12:44:31',NULL,NULL),(3624,'02062','S','Norwood','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.185459,-71.202181,0,'2013-07-06 12:44:30',NULL,NULL),(4065,'02648','S','Marstons Mills','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.671089,-70.408963,0,'2013-07-06 12:44:30',NULL,NULL),(27861,'30441','S','Green Way','N','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(53785,'62278','S','Red Bud','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.179200,-89.979600,0,'2013-07-06 12:44:33',NULL,NULL),(60982,'72110','S','Morrilton','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(77725,'97065','S','Biggs Junction','N','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.593945,-120.695798,0,'2013-07-06 12:44:34',NULL,NULL),(75231,'93645','S','O Neals','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.098562,-119.716499,0,'2013-07-06 12:44:34',NULL,NULL),(55490,'63769','S','Apple Creek','N','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.517100,-89.721600,0,'2013-07-06 12:44:33',NULL,NULL),(48663,'55912','S','Nicolville','A','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667498,-92.979475,0,'2013-07-06 12:44:33',NULL,NULL),(14084,'14615','S','Greece','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.207456,-77.649511,0,'2013-07-06 12:44:31',NULL,NULL),(26806,'29468','S','Pineville','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.415669,-80.085088,0,'2013-07-06 12:44:31',NULL,NULL),(37902,'42633','S','Betsey','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(10514,'10977','S','Chestnut Ridge','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(17741,'18302','S','E Stroudsburg','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024159,-75.185836,0,'2013-07-06 12:44:31',NULL,NULL),(3194,'01344','S','Stoneville','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.605957,-72.410738,0,'2013-07-06 12:44:30',NULL,NULL),(12452,'12967','S','N Lawrence','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.761693,-74.654141,0,'2013-07-06 12:44:30',NULL,NULL),(13883,'14263','U','Roswell Park Memorial Instit','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.873378,-78.869243,0,'2013-07-06 12:44:31',NULL,NULL),(45057,'50501','S','West Fort Dodge','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(17577,'18014','S','Bath','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.757035,-75.401241,0,'2013-07-06 12:44:31',NULL,NULL),(16326,'17124','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266009,-76.881673,0,'2013-07-06 12:44:31',NULL,NULL),(17326,'17861','P','Paxtonville','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.769110,-77.084627,0,'2013-07-06 12:44:31',NULL,NULL),(26254,'29003','S','Midway','N','Bamberg','45009','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.287100,-81.022920,0,'2013-07-06 12:44:31',NULL,NULL),(43123,'48229','S','River Rouge','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.252273,-83.144669,0,'2013-07-06 12:44:32',NULL,NULL),(73333,'90846','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.825962,-118.120925,0,'2013-07-06 12:44:34',NULL,NULL),(39996,'45242','S','Sycamore Twp','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.245232,-84.353209,0,'2013-07-06 12:44:32',NULL,NULL),(4943,'04093','S','Buxton','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.650262,-70.620203,0,'2013-07-06 12:44:30',NULL,NULL),(41066,'46511','S','Culver','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.226198,-86.415220,0,'2013-07-06 12:44:32',NULL,NULL),(15607,'16677','P','Sandy Ridge','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.901849,-78.083555,0,'2013-07-06 12:44:31',NULL,NULL),(30312,'33304','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140780,-80.124434,0,'2013-07-06 12:44:32',NULL,NULL),(46632,'53586','S','Shullsberg','N','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.577863,-90.225429,0,'2013-07-06 12:44:32',NULL,NULL),(47300,'54550','S','Pence','A','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.415615,-90.262829,0,'2013-07-06 12:44:32',NULL,NULL),(52709,'61115','S','Loves Park','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.354402,-89.040130,0,'2013-07-06 12:44:33',NULL,NULL),(68632,'81635','S','Grand Valley','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.460598,-108.009596,0,'2013-07-06 12:44:34',NULL,NULL),(69807,'84070','S','Sherwood Park','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.571551,-111.884711,0,'2013-07-06 12:44:34',NULL,NULL),(61620,'72824','S','Belleville','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.106480,-93.451980,0,'2013-07-06 12:44:33',NULL,NULL),(28775,'32034','S','Fernandina','A','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.636954,-81.461340,0,'2013-07-06 12:44:32',NULL,NULL),(19320,'20020','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.864390,-76.971958,0,'2013-07-06 12:44:31',NULL,NULL),(22237,'23628','U','Us Army Trng Support Ctr','N','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.146056,-76.578123,0,'2013-07-06 12:44:31',NULL,NULL),(49619,'56902','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(60033,'71343','S','Lismore','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(58698,'68929','S','Bloomington','D','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.135092,-99.009196,0,'2013-07-06 12:44:33',NULL,NULL),(46614,'53572','S','Mount Horeb','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.981166,-89.729689,0,'2013-07-06 12:44:32',NULL,NULL),(17716,'18235','S','Weissport','A','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.843037,-75.694426,0,'2013-07-06 12:44:31',NULL,NULL),(1846,'00785','P','Guayama','D','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.978900,-66.110228,0,'2013-07-06 12:44:30',NULL,NULL),(1115,'00725','S','Urb Santa Juana 2','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(29218,'32417','P','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.184300,-85.811156,0,'2013-07-06 12:44:32',NULL,NULL),(25253,'28114','S','Mooresboro','D','Cleveland','37045','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.251745,-81.717075,0,'2013-07-06 12:44:31',NULL,NULL),(29035,'32233','S','Atlantic Bch','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355620,-81.518460,0,'2013-07-06 12:44:32',NULL,NULL),(56546,'65456','S','Davisville','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.803075,-91.140020,0,'2013-07-06 12:44:33',NULL,NULL),(75142,'93561','S','Alpine Forest','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(36580,'40953','S','Hinkle','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.876856,-83.777945,0,'2013-07-06 12:44:32',NULL,NULL),(37430,'41825','S','Jackhorn','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.166083,-82.690959,0,'2013-07-06 12:44:32',NULL,NULL),(23771,'25972','P','Bellburn','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.040659,-80.746855,0,'2013-07-06 12:44:31',NULL,NULL),(124,'00612','S','Villa Lucia','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(9745,'10095','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748793,-73.989926,0,'2013-07-06 12:44:30',NULL,NULL),(34542,'38703','S','Lamont','A','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.421500,-91.019400,0,'2013-07-06 12:44:32',NULL,NULL),(30032,'33140','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.815316,-80.130710,0,'2013-07-06 12:44:32',NULL,NULL),(18877,'19455','U','North Wales','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.211065,-75.277900,0,'2013-07-06 12:44:31',NULL,NULL),(46408,'53176','P','Springfield','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.643270,-88.412240,0,'2013-07-06 12:44:32',NULL,NULL),(50259,'57636','P','Lantry','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.020239,-101.433441,0,'2013-07-06 12:44:33',NULL,NULL),(79306,'98591','S','Toledo','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.438939,-122.817048,0,'2013-07-06 12:44:34',NULL,NULL),(59963,'71307','P','Alex','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284883,-92.452270,0,'2013-07-06 12:44:33',NULL,NULL),(59741,'71135','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.442002,-93.707741,0,'2013-07-06 12:44:33',NULL,NULL),(18945,'19508','S','Lincoln Heights','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(42533,'47861','S','Riverton','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.014376,-87.525993,0,'2013-07-06 12:44:32',NULL,NULL),(38057,'43055','S','Hanover','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.116667,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(26433,'29128','S','Dunkins Mill','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(46299,'53057','S','Mount Calvary','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.822404,-88.246314,0,'2013-07-06 12:44:32',NULL,NULL),(64695,'76849','S','Junction','D','Kimble','48267','Texas','TX','48','0000','325','Central',-6.0,'Y',30.462840,-99.710040,0,'2013-07-06 12:44:34',NULL,NULL),(78105,'97493','S','Westlake','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.908045,-124.068901,0,'2013-07-06 12:44:34',NULL,NULL),(57414,'66772','S','Savonburg','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.755780,-95.159662,0,'2013-07-06 12:44:33',NULL,NULL),(34772,'38863','S','Rough Edge','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(33494,'37351','S','Lupton City','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.103193,-85.262378,0,'2013-07-06 12:44:32',NULL,NULL),(41751,'47282','P','Vernon','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.984510,-85.609420,0,'2013-07-06 12:44:32',NULL,NULL),(43889,'49234','S','Clarklake','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.119931,-84.348549,0,'2013-07-06 12:44:32',NULL,NULL),(57016,'66206','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(62104,'73627','S','Carter','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.214475,-99.455448,0,'2013-07-06 12:44:33',NULL,NULL),(46346,'53094','S','Johnson Creek','A','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.187721,-88.723178,0,'2013-07-06 12:44:32',NULL,NULL),(20196,'20752','P','Suitland','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.849336,-76.925085,0,'2013-07-06 12:44:31',NULL,NULL),(43807,'49066','S','Leonidas','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.033923,-85.355288,0,'2013-07-06 12:44:32',NULL,NULL),(29775,'33014','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.901437,-80.306472,0,'2013-07-06 12:44:32',NULL,NULL),(51098,'58775','S','Roseglen','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.696198,-101.679686,0,'2013-07-06 12:44:33',NULL,NULL),(61218,'72320','S','Brickeys','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.844026,-90.528188,0,'2013-07-06 12:44:33',NULL,NULL),(74834,'93239','S','Kettleman City','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.025098,-119.977456,0,'2013-07-06 12:44:34',NULL,NULL),(77143,'96161','S','Donner Lake','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(68214,'81047','S','Holly','D','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.982565,-102.140804,0,'2013-07-06 12:44:34',NULL,NULL),(67684,'80513','S','Berthoud','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.294990,-105.123816,0,'2013-07-06 12:44:34',NULL,NULL),(60050,'71346','S','Meeker','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(4873,'04033','U','Freeport','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.856471,-70.102326,0,'2013-07-06 12:44:30',NULL,NULL),(40708,'46110','S','Boggstown','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.564800,-85.921392,0,'2013-07-06 12:44:32',NULL,NULL),(26531,'29203','S','Farrow Terrace','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(28725,'31905','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.430120,-84.918180,0,'2013-07-06 12:44:32',NULL,NULL),(3890,'02381','P','Wht Horse Bch','A','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.930035,-70.559004,0,'2013-07-06 12:44:30',NULL,NULL),(49993,'57369','S','Eagle','N','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.405260,-98.888040,0,'2013-07-06 12:44:33',NULL,NULL),(57576,'67059','S','Trousdale','N','Kiowa','20097','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.616471,-99.104840,0,'2013-07-06 12:44:33',NULL,NULL),(64357,'76520','S','Maysfield','A','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(63241,'75475','P','Randolph','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.553789,-96.201365,0,'2013-07-06 12:44:33',NULL,NULL),(54695,'62950','S','Fountain Bluff','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.747337,-89.546002,0,'2013-07-06 12:44:33',NULL,NULL),(24670,'27408','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.106359,-79.817365,0,'2013-07-06 12:44:31',NULL,NULL),(35751,'39735','S','Ackerman','D','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.336060,-89.186940,0,'2013-07-06 12:44:32',NULL,NULL),(13867,'14233','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.875099,-78.869022,0,'2013-07-06 12:44:31',NULL,NULL),(45519,'51432','P','Aspinwall','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.911651,-95.135035,0,'2013-07-06 12:44:32',NULL,NULL),(43439,'48504','S','Northwest','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.035862,-83.742760,0,'2013-07-06 12:44:32',NULL,NULL),(45040,'50476','S','Stacyville','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.441918,-92.782398,0,'2013-07-06 12:44:32',NULL,NULL),(74700,'93004','S','San Buenaventura','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.280121,-119.168207,0,'2013-07-06 12:44:34',NULL,NULL),(77801,'97137','S','St Paul','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.220766,-122.953219,0,'2013-07-06 12:44:34',NULL,NULL),(71918,'87825','S','Magdalena','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.420830,-107.510280,0,'2013-07-06 12:44:34',NULL,NULL),(31948,'35208','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.493638,-86.883796,0,'2013-07-06 12:44:32',NULL,NULL),(8755,'08533','S','Plumsted Twp','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.083333,-74.500000,0,'2013-07-06 12:44:30',NULL,NULL),(14144,'14710','S','Ashville','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.078716,-79.373737,0,'2013-07-06 12:44:31',NULL,NULL),(30896,'33705','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742211,-82.643117,0,'2013-07-06 12:44:32',NULL,NULL),(27269,'29939','P','Estill','A','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.681996,-81.245041,0,'2013-07-06 12:44:31',NULL,NULL),(50028,'57424','S','Athol','A','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.021900,-98.494500,0,'2013-07-06 12:44:33',NULL,NULL),(58057,'68039','S','Macy','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.013041,-96.574982,0,'2013-07-06 12:44:33',NULL,NULL),(78662,'98232','S','Edison','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.562380,-122.444940,0,'2013-07-06 12:44:34',NULL,NULL),(60046,'71346','S','Chickama','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(7145,'06411','U','Cheshire','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.499696,-72.901815,0,'2013-07-06 12:44:30',NULL,NULL),(19995,'20603','S','Saint Charles','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.628435,-76.968736,0,'2013-07-06 12:44:31',NULL,NULL),(44322,'49747','S','Hubbard Lake','D','Alpena','26007','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.892056,-83.611057,0,'2013-07-06 12:44:32',NULL,NULL),(37941,'42702','P','E Town','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.694060,-85.860654,0,'2013-07-06 12:44:32',NULL,NULL),(34488,'38668','S','Crockett','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(3907,'02455','P','Waltham','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.357184,-71.059255,0,'2013-07-06 12:44:30',NULL,NULL),(6589,'05859','S','North Troy','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.000000,-72.400000,0,'2013-07-06 12:44:30',NULL,NULL),(22146,'23456','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.775899,-76.075614,0,'2013-07-06 12:44:31',NULL,NULL),(45070,'50520','S','Bradgate','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.793234,-94.385221,0,'2013-07-06 12:44:32',NULL,NULL),(35532,'39558','P','Ansley','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.241870,-89.434728,0,'2013-07-06 12:44:32',NULL,NULL),(64544,'76649','S','Iredell','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.973779,-97.869839,0,'2013-07-06 12:44:34',NULL,NULL),(74973,'93437','S','Vandenberg AFB','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.738800,-120.525060,0,'2013-07-06 12:44:34',NULL,NULL),(79456,'98848','S','Winchester','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.210850,-119.861652,0,'2013-07-06 12:44:34',NULL,NULL),(14124,'14649','U','Roch Gas & Elec Corp','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157109,-77.604365,0,'2013-07-06 12:44:31',NULL,NULL),(42832,'48065','S','Romeo','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.840846,-83.032465,0,'2013-07-06 12:44:32',NULL,NULL),(1519,'00754','S','Paseo de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(57290,'66614','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.016655,-95.766357,0,'2013-07-06 12:44:33',NULL,NULL),(59942,'71301','S','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(68822,'82501','S','Lucky Maccamp','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(75708,'94574','S','Saint Helena','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.509798,-122.450863,0,'2013-07-06 12:44:34',NULL,NULL),(73818,'91765','S','Pomona','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.001426,-117.815685,0,'2013-07-06 12:44:34',NULL,NULL),(69070,'83241','S','Grace','D','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(47848,'55075','S','South Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.892636,-93.040178,0,'2013-07-06 12:44:33',NULL,NULL),(29055,'32240','P','Jacksonville Beach','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.278240,-81.411680,0,'2013-07-06 12:44:32',NULL,NULL),(44863,'50302','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.605801,-93.634877,0,'2013-07-06 12:44:32',NULL,NULL),(42020,'47434','P','Harrodsburg','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.015056,-86.542106,0,'2013-07-06 12:44:32',NULL,NULL),(34969,'39080','P','Harperville','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.496002,-89.489832,0,'2013-07-06 12:44:32',NULL,NULL),(19955,'20580','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894121,-77.024126,0,'2013-07-06 12:44:31',NULL,NULL),(20178,'20746','S','Hillcrest Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(57130,'66225','P','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.888339,-94.686133,0,'2013-07-06 12:44:33',NULL,NULL),(78065,'97458','S','Norway','A','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.114800,-124.156800,0,'2013-07-06 12:44:34',NULL,NULL),(9590,'10029','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(900,'00705','S','Colinas de San Francisco','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(26549,'29206','S','Sandwood','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(16290,'17105','P','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299869,-76.799562,0,'2013-07-06 12:44:31',NULL,NULL),(17543,'17976','S','Shenandoah Junction','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(19770,'20420','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902553,-77.028688,0,'2013-07-06 12:44:31',NULL,NULL),(1680,'00777','S','Est De La Ceiba','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(66975,'79413','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.543755,-101.890228,0,'2013-07-06 12:44:34',NULL,NULL),(59349,'70559','S','Midland','A','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.098183,-92.502091,0,'2013-07-06 12:44:33',NULL,NULL),(58725,'68941','S','Hanover','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.483464,-98.219562,0,'2013-07-06 12:44:33',NULL,NULL),(58563,'68825','S','Custer','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(50189,'57567','S','Philip','D','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.039632,-101.663435,0,'2013-07-06 12:44:33',NULL,NULL),(10891,'11423','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.716723,-73.768410,0,'2013-07-06 12:44:30',NULL,NULL),(27227,'29918','S','Estill','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.744520,-81.240120,0,'2013-07-06 12:44:31',NULL,NULL),(5454,'04730','S','Ludlow','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(38338,'43436','P','Isle St George','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.715585,-82.819135,0,'2013-07-06 12:44:32',NULL,NULL),(3014,'01083','P','Warren','D','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.212656,-72.194116,0,'2013-07-06 12:44:30',NULL,NULL),(27823,'30410','S','McGregor','N','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210400,-82.483320,0,'2013-07-06 12:44:31',NULL,NULL),(12762,'13208','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.072766,-76.147309,0,'2013-07-06 12:44:30',NULL,NULL),(48718,'55951','S','Le Roy','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.514128,-92.501068,0,'2013-07-06 12:44:33',NULL,NULL),(48843,'56057','S','Le Center','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.392242,-93.735328,0,'2013-07-06 12:44:33',NULL,NULL),(54964,'63121','S','Beverly Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(56790,'65759','S','Taneyville','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.751275,-93.011754,0,'2013-07-06 12:44:33',NULL,NULL),(71473,'87062','S','Las Nutrias','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.488921,-106.725214,0,'2013-07-06 12:44:34',NULL,NULL),(71672,'87506','S','San Ildefonso Pueblo','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.585314,-106.024436,0,'2013-07-06 12:44:34',NULL,NULL),(69270,'83436','S','Clementsville','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.860779,-111.515462,0,'2013-07-06 12:44:34',NULL,NULL),(55433,'63670','S','Coffman','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(20611,'21208','S','Pikesville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.377640,-76.705980,0,'2013-07-06 12:44:31',NULL,NULL),(31953,'35210','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(46473,'53217','S','Whitefish Bay','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(22551,'24134','S','Pearisburg','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.323127,-80.730504,0,'2013-07-06 12:44:31',NULL,NULL),(58359,'68514','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.917763,-96.648637,0,'2013-07-06 12:44:33',NULL,NULL),(58864,'69151','S','Bignell','N','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.081286,-100.523552,0,'2013-07-06 12:44:33',NULL,NULL),(74407,'92532','S','Lk Elsinore','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.661456,-117.278423,0,'2013-07-06 12:44:34',NULL,NULL),(77418,'96797','S','Waipahu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.393173,-158.011282,0,'2013-07-06 12:44:34',NULL,NULL),(79422,'98826','S','Leavenworth','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(46230,'52776','S','West Liberty','D','Muscatine','19139','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.575495,-91.261347,0,'2013-07-06 12:44:32',NULL,NULL),(14898,'15501','S','Somerset','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.012148,-79.124952,0,'2013-07-06 12:44:31',NULL,NULL),(37942,'42702','P','Elizabethtown','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.694060,-85.860654,0,'2013-07-06 12:44:32',NULL,NULL),(20449,'21013','S','Baldwin','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.499777,-76.493431,0,'2013-07-06 12:44:31',NULL,NULL),(4902,'04061','S','N Waterboro','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.652363,-70.725533,0,'2013-07-06 12:44:30',NULL,NULL),(16077,'17050','S','Hampden Twp','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(35085,'39203','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.309387,-90.196952,0,'2013-07-06 12:44:32',NULL,NULL),(59744,'71138','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.405769,-93.796006,0,'2013-07-06 12:44:33',NULL,NULL),(61302,'72425','S','Delaplaine','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.192222,-90.730252,0,'2013-07-06 12:44:33',NULL,NULL),(64713,'76866','S','Paint Rock','D','Concho','48095','Texas','TX','48','0000','325','Central',-6.0,'Y',31.499721,-99.896856,0,'2013-07-06 12:44:34',NULL,NULL),(40887,'46242','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.701310,-86.257374,0,'2013-07-06 12:44:32',NULL,NULL),(14834,'15433','S','East Millsboro','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.971652,-79.964711,0,'2013-07-06 12:44:31',NULL,NULL),(21284,'22332','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.804593,-77.059273,0,'2013-07-06 12:44:31',NULL,NULL),(41178,'46713','P','Bippus','D','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.943414,-85.619752,0,'2013-07-06 12:44:32',NULL,NULL),(50692,'58353','S','Mylo','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.635764,-99.621503,0,'2013-07-06 12:44:33',NULL,NULL),(53043,'61480','S','Hopper','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.746561,-90.908216,0,'2013-07-06 12:44:33',NULL,NULL),(75410,'94021','S','Loma Mar','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.242646,-122.254745,0,'2013-07-06 12:44:34',NULL,NULL),(76883,'95977','S','French Corral','N','Nevada','06057','California','CA','06','9340','530','Pacific',-8.0,'Y',39.197157,-121.253817,0,'2013-07-06 12:44:34',NULL,NULL),(10715,'11242','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.692087,-73.988815,0,'2013-07-06 12:44:30',NULL,NULL),(43822,'49082','S','Quincy','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.945571,-84.885960,0,'2013-07-06 12:44:32',NULL,NULL),(8108,'07806','S','Picatinny Ars','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.939389,-74.558453,0,'2013-07-06 12:44:30',NULL,NULL),(7663,'07087','S','Summit Avenue','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.770419,-74.030901,0,'2013-07-06 12:44:30',NULL,NULL),(880,'00703','S','Aguas Buenas','D','Aguas Buenas','72007','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.261636,-66.103857,0,'2013-07-06 12:44:30',NULL,NULL),(57037,'66208','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(62778,'74871','S','Stonewall','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.658077,-96.523130,0,'2013-07-06 12:44:33',NULL,NULL),(36775,'41043','S','Foster','D','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(21442,'22577','P','Sandy Point','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.065301,-76.559160,0,'2013-07-06 12:44:31',NULL,NULL),(21910,'23192','S','Montpelier','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.811538,-77.593495,0,'2013-07-06 12:44:31',NULL,NULL),(58351,'68505','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.839250,-96.624615,0,'2013-07-06 12:44:33',NULL,NULL),(78877,'98355','S','Carlson','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.715218,-122.184152,0,'2013-07-06 12:44:34',NULL,NULL),(6713,'06066','S','Vernon Rockvl','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(912,'00705','S','Villas del Coqui','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(67085,'79608','P','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.418222,-99.748423,0,'2013-07-06 12:44:34',NULL,NULL),(32168,'35476','S','N Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.255087,-87.586136,0,'2013-07-06 12:44:32',NULL,NULL),(26909,'29581','S','Nichols','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.227737,-79.147719,0,'2013-07-06 12:44:31',NULL,NULL),(23194,'25057','P','Deep Water','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.121436,-81.259320,0,'2013-07-06 12:44:31',NULL,NULL),(47394,'54639','S','La Farge','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.616403,-90.624741,0,'2013-07-06 12:44:32',NULL,NULL),(56761,'65734','S','Purdy','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.816767,-93.920454,0,'2013-07-06 12:44:33',NULL,NULL),(63221,'75456','P','Mount Pleasant','D','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.158187,-94.968045,0,'2013-07-06 12:44:33',NULL,NULL),(66778,'79035','S','Friona','D','Parmer','48369','Texas','TX','48','0000','806','Central',-6.0,'Y',34.637034,-102.723022,0,'2013-07-06 12:44:34',NULL,NULL),(22278,'23708','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.829941,-76.312654,0,'2013-07-06 12:44:31',NULL,NULL),(36541,'40874','S','Warbranch','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.990654,-83.391027,0,'2013-07-06 12:44:32',NULL,NULL),(15737,'16901','S','Kennedy','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(72262,'88540','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.851513,-106.438229,0,'2013-07-06 12:44:34',NULL,NULL),(5776,'05050','P','Mc Indoe Falls','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262531,-72.058292,0,'2013-07-06 12:44:30',NULL,NULL),(28180,'31007','S','Byromville','D','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.171788,-83.926088,0,'2013-07-06 12:44:31',NULL,NULL),(24167,'26611','S','Cedarville','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.838066,-80.849384,0,'2013-07-06 12:44:31',NULL,NULL),(14119,'14644','U','Xerox','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.153845,-77.603654,0,'2013-07-06 12:44:31',NULL,NULL),(48092,'55340','S','Corcoran','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.072108,-93.576508,0,'2013-07-06 12:44:33',NULL,NULL),(53508,'62017','S','Coffeen','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.090493,-89.394809,0,'2013-07-06 12:44:33',NULL,NULL),(64090,'76161','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.805706,-97.353001,0,'2013-07-06 12:44:34',NULL,NULL),(77679,'97034','S','Lake Oswego','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.410367,-122.689055,0,'2013-07-06 12:44:34',NULL,NULL),(22744,'24401','S','Western State Hospital','N','Staunton City','51790','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.153156,-79.078684,0,'2013-07-06 12:44:31',NULL,NULL),(1276,'00730','S','Ext La Guadalupe','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(8773,'08550','S','W Windsor','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(41111,'46567','S','Syracuse','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.423554,-85.740790,0,'2013-07-06 12:44:32',NULL,NULL),(27930,'30519','S','Buford','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.103295,-83.973195,0,'2013-07-06 12:44:31',NULL,NULL),(52436,'60657','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.940734,-87.654198,0,'2013-07-06 12:44:33',NULL,NULL),(64529,'76642','S','Lake Limestone','A','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.546200,-96.529080,0,'2013-07-06 12:44:34',NULL,NULL),(71079,'85924','S','Concho Valley','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.428600,-109.689120,0,'2013-07-06 12:44:34',NULL,NULL),(18078,'18705','S','Plains Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(52428,'60654','S','Merchandise Mart','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.887141,-87.636511,0,'2013-07-06 12:44:33',NULL,NULL),(54559,'62892','S','Vernon','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.805000,-89.082950,0,'2013-07-06 12:44:33',NULL,NULL),(66773,'79031','S','Earth','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.228607,-102.449215,0,'2013-07-06 12:44:34',NULL,NULL),(18999,'19525','S','Layfield','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.311960,-75.589380,0,'2013-07-06 12:44:31',NULL,NULL),(2954,'01035','S','Hadley','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.359966,-72.577472,0,'2013-07-06 12:44:30',NULL,NULL),(44082,'49454','S','Scottville','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.941651,-86.286813,0,'2013-07-06 12:44:32',NULL,NULL),(30940,'33715','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.687120,-82.712580,0,'2013-07-06 12:44:32',NULL,NULL),(78305,'97905','P','Weatherby','N','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.582418,-117.462964,0,'2013-07-06 12:44:34',NULL,NULL),(44540,'49971','P','White Pine','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.757263,-89.581095,0,'2013-07-06 12:44:32',NULL,NULL),(14664,'15239','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.479721,-79.749820,0,'2013-07-06 12:44:31',NULL,NULL),(9129,'09177','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(25389,'28270','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.117679,-80.760144,0,'2013-07-06 12:44:31',NULL,NULL),(65596,'77879','S','Somerville','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.335725,-96.571420,0,'2013-07-06 12:44:34',NULL,NULL),(70066,'84147','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758841,-111.883105,0,'2013-07-06 12:44:34',NULL,NULL),(11926,'12423','S','East Durham','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.388331,-74.136710,0,'2013-07-06 12:44:30',NULL,NULL),(422,'00662','S','Res Lomas del Sol','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(34907,'38955','P','Sabougla','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(47909,'55110','S','Dellwood','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(52398,'60633','S','Hegewisch','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.653807,-87.559353,0,'2013-07-06 12:44:33',NULL,NULL),(52652,'61064','S','Brookville','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.993531,-89.587964,0,'2013-07-06 12:44:33',NULL,NULL),(59491,'70765','P','Plaquemine','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.288255,-91.233565,0,'2013-07-06 12:44:33',NULL,NULL),(14483,'15133','S','McKeesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.332947,-79.865183,0,'2013-07-06 12:44:31',NULL,NULL),(49197,'56447','S','Emily','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761467,-93.903243,0,'2013-07-06 12:44:33',NULL,NULL),(63290,'75559','S','De Kalb','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(64978,'77266','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.746626,-95.391501,0,'2013-07-06 12:44:34',NULL,NULL),(68180,'81020','S','Aguilar','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.400582,-104.642190,0,'2013-07-06 12:44:34',NULL,NULL),(22164,'23463','U','Chrstn Brdcst Network','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.801576,-76.176454,0,'2013-07-06 12:44:31',NULL,NULL),(17572,'18011','S','Alburtis','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.510612,-75.604922,0,'2013-07-06 12:44:31',NULL,NULL),(5949,'05261','S','Pownal Center','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.797700,-73.216680,0,'2013-07-06 12:44:30',NULL,NULL),(1205,'00728','S','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(41543,'47006','S','Cross Roads','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.328406,-85.199126,0,'2013-07-06 12:44:32',NULL,NULL),(47856,'55077','S','South Saint Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.839723,-93.076930,0,'2013-07-06 12:44:33',NULL,NULL),(24159,'26590','S','Wadestown','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.705862,-80.314650,0,'2013-07-06 12:44:31',NULL,NULL),(33150,'36925','S','Whitfield','N','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.466360,-88.269480,0,'2013-07-06 12:44:32',NULL,NULL),(37371,'41731','S','Ulvah','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.124133,-83.036516,0,'2013-07-06 12:44:32',NULL,NULL),(5157,'04424','S','Danforth','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.659444,-67.867287,0,'2013-07-06 12:44:30',NULL,NULL),(32342,'35803','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.616542,-86.549318,0,'2013-07-06 12:44:32',NULL,NULL),(8816,'08618','S','Ewing Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.221900,-74.733600,0,'2013-07-06 12:44:30',NULL,NULL),(15265,'16102','S','Castle','N','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.972448,-80.371590,0,'2013-07-06 12:44:31',NULL,NULL),(59480,'70756','S','Lottie','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.520831,-91.688091,0,'2013-07-06 12:44:33',NULL,NULL),(20457,'21022','P','Brooklandvl','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.407526,-76.667451,0,'2013-07-06 12:44:31',NULL,NULL),(18847,'19430','P','Creamery','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.212934,-75.415802,0,'2013-07-06 12:44:31',NULL,NULL),(5093,'04343','P','East Winthrop','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.313439,-69.978557,0,'2013-07-06 12:44:30',NULL,NULL),(7467,'06879','U','Promotion Systems Inc','N','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.272541,-73.497016,0,'2013-07-06 12:44:30',NULL,NULL),(113,'00612','S','Urb San Daniel','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(43152,'48244','P','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.329735,-83.081635,0,'2013-07-06 12:44:32',NULL,NULL),(39677,'45014','S','West Chester','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.334440,-84.562260,0,'2013-07-06 12:44:32',NULL,NULL),(41104,'46556','P','St Marys','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.693901,-86.239284,0,'2013-07-06 12:44:32',NULL,NULL),(2506,'00957','S','Urb Alhambra','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(27841,'30424','P','Dover','D','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.576781,-81.715789,0,'2013-07-06 12:44:31',NULL,NULL),(20405,'20903','S','Hillandale','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.012780,-76.981200,0,'2013-07-06 12:44:31',NULL,NULL),(54324,'62739','U','Central IL Public Service','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.798125,-89.646516,0,'2013-07-06 12:44:33',NULL,NULL),(51865,'60079','P','Waukegan','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.370220,-87.868544,0,'2013-07-06 12:44:33',NULL,NULL),(1605,'00769','S','Urb Monte Flores','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(42197,'47549','U','Kimball Intl','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.392247,-86.955378,0,'2013-07-06 12:44:32',NULL,NULL),(43198,'48303','P','Bloomfld Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(9540,'10021','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(7593,'07040','S','Maplecrest','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.725322,-74.265292,0,'2013-07-06 12:44:30',NULL,NULL),(26057,'28691','P','Valle Crucis','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.207601,-81.885029,0,'2013-07-06 12:44:31',NULL,NULL),(3099,'01226','S','Dalton','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.469716,-73.162714,0,'2013-07-06 12:44:30',NULL,NULL),(12712,'13148','S','Tyre','N','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.920280,-76.784880,0,'2013-07-06 12:44:30',NULL,NULL),(2155,'00925','S','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(50649,'58318','S','Lake Metigoshe','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.905100,-100.424520,0,'2013-07-06 12:44:33',NULL,NULL),(72831,'89826','P','Jarbidge','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.852420,-115.417537,0,'2013-07-06 12:44:34',NULL,NULL),(70802,'85365','S','Yuma Proving Ground','A','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.672337,-114.502398,0,'2013-07-06 12:44:34',NULL,NULL),(57724,'67401','S','Bavaria','A','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.829855,-97.616195,0,'2013-07-06 12:44:33',NULL,NULL),(13420,'13755','S','Downsville','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.067456,-75.036591,0,'2013-07-06 12:44:31',NULL,NULL),(53739,'62253','S','Keyesport','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.739872,-89.312992,0,'2013-07-06 12:44:33',NULL,NULL),(55987,'64631','S','Bucklin','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.784881,-92.887121,0,'2013-07-06 12:44:33',NULL,NULL),(61220,'72321','P','Tukertown','N','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.816597,-89.939769,0,'2013-07-06 12:44:33',NULL,NULL),(77261,'96562','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79171,'98520','S','Aberdeen','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(24813,'27603','S','McCullers','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.714307,-78.660593,0,'2013-07-06 12:44:31',NULL,NULL),(22717,'24354','S','Seven Mile Ford','A','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(19648,'20277','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882540,-77.017002,0,'2013-07-06 12:44:31',NULL,NULL),(6387,'05701','S','Rutland','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(43855,'49107','S','Glendora','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.831760,-86.402880,0,'2013-07-06 12:44:32',NULL,NULL),(31568,'34614','S','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.623474,-82.533927,0,'2013-07-06 12:44:32',NULL,NULL),(48111,'55350','S','Hutchinson','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.890688,-94.370230,0,'2013-07-06 12:44:33',NULL,NULL),(70560,'85044','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.324040,-112.001214,0,'2013-07-06 12:44:34',NULL,NULL),(79617,'99116','S','Mason City','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.972127,-118.972135,0,'2013-07-06 12:44:34',NULL,NULL),(37497,'42028','S','Burna','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.028417,-88.284400,0,'2013-07-06 12:44:32',NULL,NULL),(39305,'44511','S','Cornersburg','N','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.071321,-80.698827,0,'2013-07-06 12:44:32',NULL,NULL),(13089,'13469','S','Stittville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.221220,-75.285717,0,'2013-07-06 12:44:30',NULL,NULL),(5168,'04428','S','Eddington','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.800839,-68.562980,0,'2013-07-06 12:44:30',NULL,NULL),(16968,'17720','P','Antes Fort','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.239683,-77.050439,0,'2013-07-06 12:44:31',NULL,NULL),(3087,'01201','S','Pittsfield','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.455451,-73.249993,0,'2013-07-06 12:44:30',NULL,NULL),(20742,'21298','U','Baltimore Brm','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.297780,-76.608993,0,'2013-07-06 12:44:31',NULL,NULL),(11198,'11743','S','Bay Hills','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(9029,'08873','S','Zarepath','N','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.499340,-74.521380,0,'2013-07-06 12:44:30',NULL,NULL),(52703,'61110','P','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.267481,-89.081654,0,'2013-07-06 12:44:33',NULL,NULL),(66045,'78371','P','Oilton','D','Webb','48479','Texas','TX','48','4080','361','Central',-6.0,'Y',27.420360,-98.856030,0,'2013-07-06 12:44:34',NULL,NULL),(76547,'95663','S','Penryn','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.860301,-121.182507,0,'2013-07-06 12:44:34',NULL,NULL),(79704,'99210','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.650884,-117.421886,0,'2013-07-06 12:44:34',NULL,NULL),(59422,'70657','S','Ragley','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.435901,-93.113078,0,'2013-07-06 12:44:33',NULL,NULL),(19109,'19606','S','Pennside','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(37916,'42633','S','Ritner','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(24084,'26463','P','Wyatt','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.432820,-80.353233,0,'2013-07-06 12:44:31',NULL,NULL),(15194,'15953','S','Seanor','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.207425,-78.897450,0,'2013-07-06 12:44:31',NULL,NULL),(15666,'16802','S','University Pk','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.870717,-77.834150,0,'2013-07-06 12:44:31',NULL,NULL),(50186,'57564','S','Onida','D','Sully','46119','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.703712,-100.063844,0,'2013-07-06 12:44:33',NULL,NULL),(18663,'19178','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953092,-75.184961,0,'2013-07-06 12:44:31',NULL,NULL),(63367,'75641','P','Longview','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.373227,-94.588435,0,'2013-07-06 12:44:33',NULL,NULL),(63995,'76113','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.746555,-97.328024,0,'2013-07-06 12:44:34',NULL,NULL),(40072,'45275','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138322,-84.504469,0,'2013-07-06 12:44:32',NULL,NULL),(40547,'45849','S','Grover Hill','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.016949,-84.486111,0,'2013-07-06 12:44:32',NULL,NULL),(45243,'50653','S','Oakwood','N','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.966180,-92.880960,0,'2013-07-06 12:44:32',NULL,NULL),(10920,'11430','S','Jf Kennedy Ap','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.661453,-73.811830,0,'2013-07-06 12:44:30',NULL,NULL),(53615,'62086','S','Reno','N','Bond','17005','Illinois','IL','17','0000','217','Central',-6.0,'Y',38.977320,-89.600100,0,'2013-07-06 12:44:33',NULL,NULL),(54201,'62635','S','Emden','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.298491,-89.484616,0,'2013-07-06 12:44:33',NULL,NULL),(54720,'62960','S','Round Knob','N','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.154433,-88.723675,0,'2013-07-06 12:44:33',NULL,NULL),(49183,'56436','P','Benedict','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.157652,-94.690431,0,'2013-07-06 12:44:33',NULL,NULL),(32853,'36505','S','Axis','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.903562,-88.047940,0,'2013-07-06 12:44:32',NULL,NULL),(13619,'13865','S','West Windsor','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.064020,-75.640380,0,'2013-07-06 12:44:31',NULL,NULL),(31283,'34034','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(20670,'21228','S','Catonsville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.327900,-76.743960,0,'2013-07-06 12:44:31',NULL,NULL),(7527,'07005','S','Meriden','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(26050,'28685','S','Traphill','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.346465,-81.027968,0,'2013-07-06 12:44:31',NULL,NULL),(13234,'13639','S','Fine','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.242623,-75.140161,0,'2013-07-06 12:44:30',NULL,NULL),(4966,'04107','S','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.610918,-70.232964,0,'2013-07-06 12:44:30',NULL,NULL),(12146,'12734','S','Ferndale','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.726667,-74.762909,0,'2013-07-06 12:44:30',NULL,NULL),(15167,'15922','P','Belsano','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.520963,-78.870228,0,'2013-07-06 12:44:31',NULL,NULL),(55172,'63368','S','Ofallon','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.757000,-90.724700,0,'2013-07-06 12:44:33',NULL,NULL),(56403,'65247','S','Ardmore','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.651110,-92.451199,0,'2013-07-06 12:44:33',NULL,NULL),(69847,'84084','S','West Jordan','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618542,-111.967531,0,'2013-07-06 12:44:34',NULL,NULL),(70633,'85141','S','Picacho','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.713145,-111.498506,0,'2013-07-06 12:44:34',NULL,NULL),(80095,'99746','P','Huslia','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.563396,-156.474369,0,'2013-07-06 12:44:34',NULL,NULL),(13270,'13651','P','Henderson Harbor','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.869440,-76.193826,0,'2013-07-06 12:44:30',NULL,NULL),(15102,'15771','S','Rochester Mills','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.821250,-79.006895,0,'2013-07-06 12:44:31',NULL,NULL),(17455,'17944','P','Llewellyn','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.677452,-76.276883,0,'2013-07-06 12:44:31',NULL,NULL),(36385,'40484','S','Stanford','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.515657,-84.679979,0,'2013-07-06 12:44:32',NULL,NULL),(37329,'41653','S','Sloan','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(45408,'51046','S','Paullina','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.974580,-95.706300,0,'2013-07-06 12:44:32',NULL,NULL),(7459,'06860','U','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.086401,-73.475590,0,'2013-07-06 12:44:30',NULL,NULL),(21400,'22511','S','Lottsburg','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.976560,-76.515670,0,'2013-07-06 12:44:31',NULL,NULL),(8416,'08074','P','Richwood','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722829,-75.164757,0,'2013-07-06 12:44:30',NULL,NULL),(7126,'06385','S','Jordan Village','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.347357,-72.147670,0,'2013-07-06 12:44:30',NULL,NULL),(43710,'48908','P','Lansing','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.731046,-84.645869,0,'2013-07-06 12:44:32',NULL,NULL),(35087,'39204','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.285241,-90.230923,0,'2013-07-06 12:44:32',NULL,NULL),(28799,'32060','S','Live Oak','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.244980,-83.212850,0,'2013-07-06 12:44:32',NULL,NULL),(53773,'62272','S','Percy','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.011598,-89.636794,0,'2013-07-06 12:44:33',NULL,NULL),(58767,'68967','S','Oxford','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(62949,'75104','S','Cedar Hill','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.588560,-96.943285,0,'2013-07-06 12:44:33',NULL,NULL),(7509,'06927','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.043828,-73.548111,0,'2013-07-06 12:44:30',NULL,NULL),(25177,'28052','S','Crowders','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(35757,'39739','S','Bigbee Valley','A','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.234567,-88.580798,0,'2013-07-06 12:44:32',NULL,NULL),(45599,'51555','S','Missouri Vly','A','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.562303,-95.890364,0,'2013-07-06 12:44:32',NULL,NULL),(49222,'56468','S','Lake Edwards','N','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.504936,-94.283424,0,'2013-07-06 12:44:33',NULL,NULL),(68376,'81143','S','Mirage','N','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.079015,-105.894520,0,'2013-07-06 12:44:34',NULL,NULL),(76869,'95971','S','Spanish Ranch','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(24303,'27013','S','Cool Spring','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.745026,-80.676769,0,'2013-07-06 12:44:31',NULL,NULL),(59281,'70462','S','Springfield','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.383769,-90.574931,0,'2013-07-06 12:44:33',NULL,NULL),(66691,'78944','S','Welcome','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989859,-96.530885,0,'2013-07-06 12:44:34',NULL,NULL),(38233,'43231','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.080299,-82.937800,0,'2013-07-06 12:44:32',NULL,NULL),(37557,'42066','S','Mayfield','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.736513,-88.638158,0,'2013-07-06 12:44:32',NULL,NULL),(45707,'52060','S','Ironhills','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.071208,-90.660765,0,'2013-07-06 12:44:32',NULL,NULL),(64740,'76903','S','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.467826,-100.436224,0,'2013-07-06 12:44:34',NULL,NULL),(69504,'83713','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.637663,-116.304201,0,'2013-07-06 12:44:34',NULL,NULL),(79539,'98950','P','Doris','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.946109,-119.985319,0,'2013-07-06 12:44:34',NULL,NULL),(79776,'99337','S','Kennewick','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.185947,-119.164247,0,'2013-07-06 12:44:34',NULL,NULL),(75409,'94020','S','La Honda','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.285795,-122.226668,0,'2013-07-06 12:44:34',NULL,NULL),(60484,'71658','S','Snyder','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.306540,-91.515180,0,'2013-07-06 12:44:33',NULL,NULL),(52499,'60707','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.923558,-87.816578,0,'2013-07-06 12:44:33',NULL,NULL),(47349,'54610','S','Alma','D','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.325050,-91.912041,0,'2013-07-06 12:44:32',NULL,NULL),(31629,'34698','S','Dunedin','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.023417,-82.767613,0,'2013-07-06 12:44:32',NULL,NULL),(12603,'13081','S','Goodyears Corners','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.662592,-76.626770,0,'2013-07-06 12:44:30',NULL,NULL),(31643,'34731','S','Fruitland Pk','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.864889,-81.898909,0,'2013-07-06 12:44:32',NULL,NULL),(10663,'11106','S','Astoria','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761688,-73.930747,0,'2013-07-06 12:44:30',NULL,NULL),(5875,'05149','S','Lake Rescue','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.392420,-72.697140,0,'2013-07-06 12:44:30',NULL,NULL),(9045,'08884','S','Spotswood','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.388768,-74.392244,0,'2013-07-06 12:44:30',NULL,NULL),(28181,'31008','S','Bryon','N','Peach','13225','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.646227,-83.754589,0,'2013-07-06 12:44:31',NULL,NULL),(54901,'63074','S','St Anne','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.727416,-90.387327,0,'2013-07-06 12:44:33',NULL,NULL),(58507,'68770','S','Ponca','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.581657,-96.725252,0,'2013-07-06 12:44:33',NULL,NULL),(58801,'69001','S','McCook','A','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.176361,-100.653340,0,'2013-07-06 12:44:33',NULL,NULL),(77221,'96401','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(48850,'56068','S','Minnesota Lk','A','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.840609,-93.831847,0,'2013-07-06 12:44:33',NULL,NULL),(26199,'28773','S','Saluda','D','Polk','37149','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.246540,-82.309619,0,'2013-07-06 12:44:31',NULL,NULL),(25799,'28605','S','Mayview Park','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.116573,-81.678226,0,'2013-07-06 12:44:31',NULL,NULL),(14482,'15132','S','McKeesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.339533,-79.842159,0,'2013-07-06 12:44:31',NULL,NULL),(44727,'50155','S','Macksburg','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.213003,-94.184371,0,'2013-07-06 12:44:32',NULL,NULL),(36382,'40475','S','Richmond','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.763410,-84.300058,0,'2013-07-06 12:44:32',NULL,NULL),(24157,'26587','S','Rachel','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.522724,-80.296322,0,'2013-07-06 12:44:31',NULL,NULL),(19519,'20181','S','Nokesville','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.666955,-77.536389,0,'2013-07-06 12:44:31',NULL,NULL),(7695,'07108','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.722703,-74.202491,0,'2013-07-06 12:44:30',NULL,NULL),(63117,'75303','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.780372,-96.776012,0,'2013-07-06 12:44:33',NULL,NULL),(71386,'87006','S','Bernardo','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.561472,-106.781071,0,'2013-07-06 12:44:34',NULL,NULL),(79265,'98568','S','Oakville','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.843134,-123.246221,0,'2013-07-06 12:44:34',NULL,NULL),(66896,'79250','S','Petersburg','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',33.873156,-101.597301,0,'2013-07-06 12:44:34',NULL,NULL),(3615,'02055','P','Minot','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.238834,-70.761576,0,'2013-07-06 12:44:30',NULL,NULL),(35113,'39210','U','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.276055,-90.218261,0,'2013-07-06 12:44:32',NULL,NULL),(2096,'00923','S','Repto San Jose','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(8313,'08031','S','Gloucester','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.867047,-75.089079,0,'2013-07-06 12:44:30',NULL,NULL),(56676,'65634','S','Cross Timbers','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.020364,-93.203182,0,'2013-07-06 12:44:33',NULL,NULL),(74,'00612','S','Ext Marisol','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(35928,'40041','P','Masonic Home','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.252308,-85.665637,0,'2013-07-06 12:44:32',NULL,NULL),(28089,'30739','S','Rock Spring','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.900531,-85.283287,0,'2013-07-06 12:44:31',NULL,NULL),(51677,'59923','S','Libby','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.354099,-115.518696,0,'2013-07-06 12:44:33',NULL,NULL),(75137,'93558','P','Red Mountain','D','Kern','06029','California','CA','06','6780','760','Pacific',-8.0,'Y',35.351568,-117.627031,0,'2013-07-06 12:44:34',NULL,NULL),(78104,'97492','S','Westfir','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.754861,-122.503722,0,'2013-07-06 12:44:34',NULL,NULL),(9763,'10103','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(14697,'15259','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441403,-79.998160,0,'2013-07-06 12:44:31',NULL,NULL),(26731,'29418','S','No Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(9051,'08889','S','White Hse Sta','A','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.599026,-74.758720,0,'2013-07-06 12:44:30',NULL,NULL),(2386,'00949','S','Urb Lagos de Plata','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(36403,'40511','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.097510,-84.497054,0,'2013-07-06 12:44:32',NULL,NULL),(5549,'04849','S','Lincolnville','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.312909,-69.092133,0,'2013-07-06 12:44:30',NULL,NULL),(44492,'49916','S','Chassell','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.026576,-88.527737,0,'2013-07-06 12:44:32',NULL,NULL),(2962,'01039','S','West Whately','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.379586,-72.696757,0,'2013-07-06 12:44:30',NULL,NULL),(38843,'44089','S','Vermilion','D','Erie','39043','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.406313,-82.382678,0,'2013-07-06 12:44:32',NULL,NULL),(20454,'21018','P','Benson','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.504167,-76.386472,0,'2013-07-06 12:44:31',NULL,NULL),(57785,'67475','S','Ramona','D','Marion','20115','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.566326,-97.097596,0,'2013-07-06 12:44:33',NULL,NULL),(59545,'70820','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.375696,-91.170416,0,'2013-07-06 12:44:33',NULL,NULL),(62885,'75053','P','Grand Prairie','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.752686,-97.024986,0,'2013-07-06 12:44:33',NULL,NULL),(62953,'75110','S','Corsicana','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.060160,-96.431160,0,'2013-07-06 12:44:33',NULL,NULL),(73050,'90088','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.055128,-118.261962,0,'2013-07-06 12:44:34',NULL,NULL),(52761,'61252','S','East Fulton','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.855867,-90.142898,0,'2013-07-06 12:44:33',NULL,NULL),(50153,'57544','S','Iron Mountain','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.891020,-99.847320,0,'2013-07-06 12:44:33',NULL,NULL),(47918,'55110','S','White Bear Lk','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(2559,'00959','S','Urb Flamboyan Gdns','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(26316,'29044','S','Congaree','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.918360,-80.732160,0,'2013-07-06 12:44:31',NULL,NULL),(897,'00705','S','Bda San Luis','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(20741,'21298','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.297780,-76.608993,0,'2013-07-06 12:44:31',NULL,NULL),(41161,'46703','S','Fox Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(37749,'42320','S','Taylor Mines','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(58769,'68967','S','Spring Grove','N','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(69265,'83433','P','Island Park','A','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.499167,-111.336944,0,'2013-07-06 12:44:34',NULL,NULL),(46882,'54112','S','Coleman','D','Marinette','55075','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.036382,-88.139933,0,'2013-07-06 12:44:32',NULL,NULL),(38380,'43505','P','Blakeslee','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.522576,-84.749395,0,'2013-07-06 12:44:32',NULL,NULL),(9848,'10118','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(45803,'52172','S','Waukon','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.271393,-91.477245,0,'2013-07-06 12:44:32',NULL,NULL),(44614,'50058','S','Coon Rapids','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.877941,-94.680284,0,'2013-07-06 12:44:32',NULL,NULL),(34814,'38901','S','Geeslin Corner','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(53562,'62052','S','McClusky','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.135780,-90.333000,0,'2013-07-06 12:44:33',NULL,NULL),(68427,'81212','S','Ilse','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(67069,'79567','S','Drasco','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(39814,'45142','S','Lynchburg','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.204471,-83.787626,0,'2013-07-06 12:44:32',NULL,NULL),(29174,'32358','S','Sopchoppy','D','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.122839,-84.522762,0,'2013-07-06 12:44:32',NULL,NULL),(3426,'01741','S','Carlisle','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.530569,-71.348298,0,'2013-07-06 12:44:30',NULL,NULL),(9480,'10011','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(47444,'54726','S','Boyd','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.951426,-91.041064,0,'2013-07-06 12:44:32',NULL,NULL),(60506,'71665','S','Staves','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(67504,'80236','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.655391,-105.022433,0,'2013-07-06 12:44:34',NULL,NULL),(74598,'92704','S','Fountain Valley','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.724888,-117.908994,0,'2013-07-06 12:44:34',NULL,NULL),(79731,'99216','S','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.664576,-117.214772,0,'2013-07-06 12:44:34',NULL,NULL),(72212,'88424','S','Grenville','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.737332,-103.457179,0,'2013-07-06 12:44:34',NULL,NULL),(58467,'68735','S','Ewing','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.257906,-98.346574,0,'2013-07-06 12:44:33',NULL,NULL),(54554,'62890','S','Corinth','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(23661,'25823','S','Jonben','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.666111,-81.184444,0,'2013-07-06 12:44:31',NULL,NULL),(44317,'49740','S','Wequetonsing','A','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.531470,-85.004593,0,'2013-07-06 12:44:32',NULL,NULL),(34379,'38617','S','Birdie','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.393358,-90.490310,0,'2013-07-06 12:44:32',NULL,NULL),(32473,'36039','S','Hardaway','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.307753,-85.807747,0,'2013-07-06 12:44:32',NULL,NULL),(42658,'47951','S','Kentland','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.777097,-87.446288,0,'2013-07-06 12:44:32',NULL,NULL),(15464,'16421','S','Harborcreek','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.170427,-79.942330,0,'2013-07-06 12:44:31',NULL,NULL),(52784,'61270','S','Morrison','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(74401,'92522','U','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.940256,-117.397192,0,'2013-07-06 12:44:34',NULL,NULL),(57509,'66958','S','Morrowville','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.842905,-97.169596,0,'2013-07-06 12:44:33',NULL,NULL),(39491,'44767','U','Suarez Corporation','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.894428,-81.422107,0,'2013-07-06 12:44:32',NULL,NULL),(41015,'46374','S','San Pierre','D','Starke','18149','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.197538,-86.894413,0,'2013-07-06 12:44:32',NULL,NULL),(10598,'11040','S','Herricks','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(9414,'10001','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(41442,'46865','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.065607,-85.166533,0,'2013-07-06 12:44:32',NULL,NULL),(34125,'38193','U','Sharp Electronic Manufac','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.055189,-89.862910,0,'2013-07-06 12:44:32',NULL,NULL),(27621,'30308','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.769731,-84.377217,0,'2013-07-06 12:44:31',NULL,NULL),(75816,'94808','P','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.935999,-122.341431,0,'2013-07-06 12:44:34',NULL,NULL),(78006,'97412','S','Eugene','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.185860,-123.533340,0,'2013-07-06 12:44:34',NULL,NULL),(76472,'95621','S','Citrus Heights','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.697816,-121.311197,0,'2013-07-06 12:44:34',NULL,NULL),(71232,'86333','S','Spring Valley','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.316282,-112.121385,0,'2013-07-06 12:44:34',NULL,NULL),(68718,'82072','S','Foxpark','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.061360,-106.014750,0,'2013-07-06 12:44:34',NULL,NULL),(76300,'95437','S','Sherwood Valley Rancheria','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(48872,'56085','S','Evan','A','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.296100,-94.723907,0,'2013-07-06 12:44:33',NULL,NULL),(30228,'33189','S','Cutler Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.568606,-80.342890,0,'2013-07-06 12:44:32',NULL,NULL),(23932,'26254','S','Bowden','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.893333,-79.618889,0,'2013-07-06 12:44:31',NULL,NULL),(9491,'10012','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(40477,'45770','S','Portland','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.990357,-81.800654,0,'2013-07-06 12:44:32',NULL,NULL),(24357,'27045','S','Stanleyville','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.226761,-80.291133,0,'2013-07-06 12:44:31',NULL,NULL),(1119,'00725','S','Urb Santo Domingo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(59040,'70085','S','Delacroix','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(67204,'79911','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.837558,-106.562277,0,'2013-07-06 12:44:34',NULL,NULL),(61614,'72821','S','Altus','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.439891,-93.763349,0,'2013-07-06 12:44:33',NULL,NULL),(6489,'05773','S','South Wallingford','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.463580,-72.990360,0,'2013-07-06 12:44:30',NULL,NULL),(23535,'25601','S','West Logan','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.868777,-81.988500,0,'2013-07-06 12:44:31',NULL,NULL),(17759,'18328','S','Dingmans Fry','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.227695,-74.945839,0,'2013-07-06 12:44:31',NULL,NULL),(39964,'45236','S','Taft','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(36609,'40977','S','E Pineville','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(28482,'31516','S','Blackshear','D','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.299595,-82.255180,0,'2013-07-06 12:44:32',NULL,NULL),(64739,'76902','P','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.453553,-100.424771,0,'2013-07-06 12:44:34',NULL,NULL),(70048,'84138','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.752433,-111.880834,0,'2013-07-06 12:44:34',NULL,NULL),(77974,'97380','S','Siletz','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.730625,-123.911269,0,'2013-07-06 12:44:34',NULL,NULL),(10927,'11432','S','Jamaica Est','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715744,-73.794362,0,'2013-07-06 12:44:30',NULL,NULL),(27105,'29724','P','Lando','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.778471,-81.012826,0,'2013-07-06 12:44:31',NULL,NULL),(27042,'29666','S','Ninety Six','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.173267,-82.019642,0,'2013-07-06 12:44:31',NULL,NULL),(69857,'84091','P','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.584648,-111.821231,0,'2013-07-06 12:44:34',NULL,NULL),(71641,'87418','S','La Plata','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.960696,-108.167011,0,'2013-07-06 12:44:34',NULL,NULL),(2552,'00959','S','Repto Davila','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(40395,'45669','S','Athalia','A','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.435220,-82.381444,0,'2013-07-06 12:44:32',NULL,NULL),(30841,'33633','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.977884,-82.487078,0,'2013-07-06 12:44:32',NULL,NULL),(7691,'07106','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.740457,-74.232487,0,'2013-07-06 12:44:30',NULL,NULL),(9975,'10162','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(24569,'27310','S','Oak Ridge','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.165515,-79.983154,0,'2013-07-06 12:44:31',NULL,NULL),(9576,'10027','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(50492,'58056','S','Luverne','D','Steele','38091','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.311519,-97.738327,0,'2013-07-06 12:44:33',NULL,NULL),(55418,'63655','S','Big Creek','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.403467,-90.197360,0,'2013-07-06 12:44:33',NULL,NULL),(5046,'04266','P','North Turner','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.329732,-70.257159,0,'2013-07-06 12:44:30',NULL,NULL),(23496,'25521','S','Griffithsvle','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.246530,-81.989476,0,'2013-07-06 12:44:31',NULL,NULL),(51082,'58762','S','Newburg','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.687180,-100.942800,0,'2013-07-06 12:44:33',NULL,NULL),(44141,'49516','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.919062,-85.527056,0,'2013-07-06 12:44:32',NULL,NULL),(42149,'47520','S','Magnet','A','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(31912,'35151','S','Oak Grove','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.176529,-86.262153,0,'2013-07-06 12:44:32',NULL,NULL),(16240,'17080','P','Pillow','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.641215,-76.804700,0,'2013-07-06 12:44:31',NULL,NULL),(74872,'93266','S','Stratford','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.179906,-119.817144,0,'2013-07-06 12:44:34',NULL,NULL),(3119,'01237','S','Hancock','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.539340,-73.246200,0,'2013-07-06 12:44:30',NULL,NULL),(36955,'41171','S','Culver','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(7885,'07514','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.923819,-74.146829,0,'2013-07-06 12:44:30',NULL,NULL),(33481,'37339','S','Gruetli Laagr','A','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.372500,-85.598889,0,'2013-07-06 12:44:32',NULL,NULL),(53683,'62222','P','Belleville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.468453,-89.981456,0,'2013-07-06 12:44:33',NULL,NULL),(54465,'62856','P','Logan','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.954367,-88.836731,0,'2013-07-06 12:44:33',NULL,NULL),(60248,'71435','S','Grayson','D','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.008428,-91.951004,0,'2013-07-06 12:44:33',NULL,NULL),(63569,'75771','S','Mt Sylvan','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(69883,'84101','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756416,-111.899070,0,'2013-07-06 12:44:34',NULL,NULL),(75838,'94920','S','Tiburon','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.893723,-122.471124,0,'2013-07-06 12:44:34',NULL,NULL),(73428,'91206','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.160263,-118.219189,0,'2013-07-06 12:44:34',NULL,NULL),(4482,'03272','P','South Newbury','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.296387,-71.995639,0,'2013-07-06 12:44:30',NULL,NULL),(74032,'92135','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.699246,-117.185174,0,'2013-07-06 12:44:34',NULL,NULL),(37109,'41366','S','Rousseau','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.601971,-83.209842,0,'2013-07-06 12:44:32',NULL,NULL),(5385,'04644','P','Hulls Cove','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.414398,-68.250836,0,'2013-07-06 12:44:30',NULL,NULL),(14010,'14529','P','Perkinsville','D','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.533783,-77.626665,0,'2013-07-06 12:44:31',NULL,NULL),(75166,'93592','P','Trona','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.760853,-117.369077,0,'2013-07-06 12:44:34',NULL,NULL),(6555,'05845','S','East Albany','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.820600,-72.278400,0,'2013-07-06 12:44:30',NULL,NULL),(34425,'38641','S','Lake Cormorant','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.925340,-90.159840,0,'2013-07-06 12:44:32',NULL,NULL),(29769,'33009','S','Pembroke Park','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(48307,'55442','S','Plymouth','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.050500,-93.428851,0,'2013-07-06 12:44:33',NULL,NULL),(50209,'57577','S','Hisle','N','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.551517,-101.805742,0,'2013-07-06 12:44:33',NULL,NULL),(51115,'58787','S','Greene','N','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.819983,-101.869920,0,'2013-07-06 12:44:33',NULL,NULL),(59554,'70825','S','One Amer Pl','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.427794,-91.021838,0,'2013-07-06 12:44:33',NULL,NULL),(65820,'78147','P','Recycle','N','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.035954,-98.100932,0,'2013-07-06 12:44:34',NULL,NULL),(74228,'92318','S','Bryn Mawr','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.048366,-117.233667,0,'2013-07-06 12:44:34',NULL,NULL),(79391,'98801','S','Appleyard','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(42024,'47436','S','Pleasant Run','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003996,-86.436004,0,'2013-07-06 12:44:32',NULL,NULL),(23881,'26162','S','Porters Falls','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.579087,-80.776218,0,'2013-07-06 12:44:31',NULL,NULL),(25841,'28622','S','Elk Park','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(27805,'30396','U','Georgia Power','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647672,-84.393744,0,'2013-07-06 12:44:31',NULL,NULL),(69611,'83858','S','Twin Lakes','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.840040,-116.903100,0,'2013-07-06 12:44:34',NULL,NULL),(20960,'21781','P','Saint James','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.562227,-77.759294,0,'2013-07-06 12:44:31',NULL,NULL),(74595,'92703','S','Bristol','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.748904,-117.907165,0,'2013-07-06 12:44:34',NULL,NULL),(38680,'43968','S','Wellsville','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.625250,-80.668590,0,'2013-07-06 12:44:32',NULL,NULL),(37852,'42501','S','Ruth','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(59820,'71234','S','Eureka','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.581980,-92.345100,0,'2013-07-06 12:44:33',NULL,NULL),(5710,'04985','S','The Forks Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(9694,'10045','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(6697,'06058','S','Norfolk','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.990342,-73.197249,0,'2013-07-06 12:44:30',NULL,NULL),(37124,'41459','P','Ophir','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.887314,-83.032318,0,'2013-07-06 12:44:32',NULL,NULL),(23949,'26276','S','Kerens','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.022674,-79.751220,0,'2013-07-06 12:44:31',NULL,NULL),(77817,'97149','S','Neskowin','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.104953,-123.972179,0,'2013-07-06 12:44:34',NULL,NULL),(42436,'47805','S','Burnett','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(3475,'01824','S','Kates Corner','A','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.623280,-71.364720,0,'2013-07-06 12:44:30',NULL,NULL),(38625,'43916','P','Colerain','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.070010,-80.740280,0,'2013-07-06 12:44:32',NULL,NULL),(9373,'09831','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(49532,'56679','P','S Int Falls','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.587388,-93.399406,0,'2013-07-06 12:44:33',NULL,NULL),(68686,'82009','S','Archer','N','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.207382,-104.827712,0,'2013-07-06 12:44:34',NULL,NULL),(12141,'12729','S','Cuddebackville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.485047,-74.627581,0,'2013-07-06 12:44:30',NULL,NULL),(22666,'24280','S','Rosedale','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.965018,-81.897825,0,'2013-07-06 12:44:31',NULL,NULL),(41696,'47223','S','Nebraska','A','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.120056,-85.492249,0,'2013-07-06 12:44:32',NULL,NULL),(19928,'20559','U','Us Copyright Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887950,-77.005785,0,'2013-07-06 12:44:31',NULL,NULL),(10266,'10506','S','Bedford','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.185200,-73.640880,0,'2013-07-06 12:44:30',NULL,NULL),(47530,'54810','S','Balsam Lake','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.470233,-92.457874,0,'2013-07-06 12:44:32',NULL,NULL),(74113,'92230','S','Cabazon','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.913050,-116.780677,0,'2013-07-06 12:44:34',NULL,NULL),(8431,'08079','S','Salem','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.548542,-75.452329,0,'2013-07-06 12:44:30',NULL,NULL),(5407,'04660','S','Mount Desert','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.315723,-68.366705,0,'2013-07-06 12:44:30',NULL,NULL),(39683,'45018','P','Fairfield','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.430238,-84.492982,0,'2013-07-06 12:44:32',NULL,NULL),(38128,'43116','S','Commercial Pt','A','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.770313,-83.058340,0,'2013-07-06 12:44:32',NULL,NULL),(69662,'84015','S','Clinton','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(76220,'95373','P','Sonora','A','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.966620,-120.310800,0,'2013-07-06 12:44:34',NULL,NULL),(42414,'47802','S','Lake Noji','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(30271,'33243','P','South Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.701397,-80.299020,0,'2013-07-06 12:44:32',NULL,NULL),(34062,'38145','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142373,-90.050604,0,'2013-07-06 12:44:32',NULL,NULL),(51212,'59046','S','Belmont','N','Golden Valley','30037','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.227533,-108.713743,0,'2013-07-06 12:44:33',NULL,NULL),(52928,'61373','S','North Utica','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.386940,-88.997371,0,'2013-07-06 12:44:33',NULL,NULL),(72688,'89445','S','Sulphur','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(37045,'41267','S','Warfield','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.854000,-82.435020,0,'2013-07-06 12:44:32',NULL,NULL),(8850,'08646','U','Division of Revenue','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217893,-74.763424,0,'2013-07-06 12:44:30',NULL,NULL),(26468,'29150','S','Brogdon','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(53801,'62288','S','Steeleville','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.005855,-89.658943,0,'2013-07-06 12:44:33',NULL,NULL),(54414,'62831','S','Du Bois','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.256590,-89.203710,0,'2013-07-06 12:44:33',NULL,NULL),(63799,'75961','S','Nacogdoches','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.609182,-94.650569,0,'2013-07-06 12:44:34',NULL,NULL),(65618,'77954','S','Stratton','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(69361,'83552','S','Harpster','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.120893,-115.974113,0,'2013-07-06 12:44:34',NULL,NULL),(70309,'84602','S','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.226908,-111.691400,0,'2013-07-06 12:44:34',NULL,NULL),(71385,'87006','S','Abeytas','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.561472,-106.781071,0,'2013-07-06 12:44:34',NULL,NULL),(27807,'30398','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.650336,-84.389036,0,'2013-07-06 12:44:31',NULL,NULL),(226,'00624','S','Urb Sagrado Corazon','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(43609,'48787','U','Frankenmuth Mutual Ins Co','N','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.331555,-83.741778,0,'2013-07-06 12:44:32',NULL,NULL),(41096,'46546','P','Mishawaka','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.662647,-86.157621,0,'2013-07-06 12:44:32',NULL,NULL),(31557,'34608','S','Spring Hill','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.480569,-82.554386,0,'2013-07-06 12:44:32',NULL,NULL),(23554,'25632','S','Taplin','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.773567,-81.951589,0,'2013-07-06 12:44:31',NULL,NULL),(23870,'26155','S','N Martinsvlle','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.659451,-80.861572,0,'2013-07-06 12:44:31',NULL,NULL),(63963,'76098','P','Azle','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.898709,-97.540906,0,'2013-07-06 12:44:34',NULL,NULL),(71969,'88011','S','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.330111,-106.709053,0,'2013-07-06 12:44:34',NULL,NULL),(67510,'80238','S','Montbello','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.736803,-104.982989,0,'2013-07-06 12:44:34',NULL,NULL),(62698,'74735','S','Ft Towson','A','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.049200,-95.260121,0,'2013-07-06 12:44:33',NULL,NULL),(53055,'61488','S','Wataga','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.023137,-90.276172,0,'2013-07-06 12:44:33',NULL,NULL),(36196,'40259','P','Okolona','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254480,-85.759321,0,'2013-07-06 12:44:32',NULL,NULL),(39994,'45242','S','Hazelwood','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.245232,-84.353209,0,'2013-07-06 12:44:32',NULL,NULL),(5020,'04237','S','Hanover','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.497120,-70.726840,0,'2013-07-06 12:44:30',NULL,NULL),(30144,'33166','S','Milam Dairy','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(53102,'61535','S','Northern Oaks','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.593891,-89.535053,0,'2013-07-06 12:44:33',NULL,NULL),(70585,'85078','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.623985,-112.005782,0,'2013-07-06 12:44:34',NULL,NULL),(74496,'92624','S','Dana Point','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.459976,-117.663169,0,'2013-07-06 12:44:34',NULL,NULL),(29395,'32619','S','Bell','D','Gilchrist','12041','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.616466,-82.816722,0,'2013-07-06 12:44:32',NULL,NULL),(28882,'32123','P','Daytona Beach','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.149529,-81.031180,0,'2013-07-06 12:44:32',NULL,NULL),(43422,'48467','S','Pointe Aux Barques','N','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.008740,-82.980780,0,'2013-07-06 12:44:32',NULL,NULL),(26524,'29203','S','Bendale','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(1917,'00795','S','Juana Diaz','D','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(40187,'45378','P','Verona','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.900394,-84.489382,0,'2013-07-06 12:44:32',NULL,NULL),(9536,'10020','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(39099,'44233','S','Hinckley','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.239897,-81.729713,0,'2013-07-06 12:44:32',NULL,NULL),(49952,'57345','S','Highmore','D','Hyde','46069','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.520425,-99.443461,0,'2013-07-06 12:44:33',NULL,NULL),(79896,'99586','S','Gulkana','N','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.714253,-143.985789,0,'2013-07-06 12:44:34',NULL,NULL),(75944,'95035','S','Milpitas','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.438136,-121.888801,0,'2013-07-06 12:44:34',NULL,NULL),(61385,'72531','S','Elizabeth','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.314549,-92.098610,0,'2013-07-06 12:44:33',NULL,NULL),(19703,'20380','U','Dept Navy Hq Marines Arl','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876916,-76.994080,0,'2013-07-06 12:44:31',NULL,NULL),(33290,'37127','S','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.775581,-86.328633,0,'2013-07-06 12:44:32',NULL,NULL),(9984,'10164','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751519,-73.977272,0,'2013-07-06 12:44:30',NULL,NULL),(29708,'32948','S','Fellsmere','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.769713,-80.601532,0,'2013-07-06 12:44:32',NULL,NULL),(29440,'32693','S','Trenton','D','Gilchrist','12041','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.613522,-82.814668,0,'2013-07-06 12:44:32',NULL,NULL),(77965,'97370','S','Philomath','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.548384,-123.409200,0,'2013-07-06 12:44:34',NULL,NULL),(72820,'89820','S','Rixie','N','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.619494,-116.936088,0,'2013-07-06 12:44:34',NULL,NULL),(39093,'44224','S','Stow','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.173500,-81.449700,0,'2013-07-06 12:44:32',NULL,NULL),(12734,'13162','P','Verona Beach','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.192705,-75.728282,0,'2013-07-06 12:44:30',NULL,NULL),(40135,'45337','S','Potsdm','A','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.996855,-84.410254,0,'2013-07-06 12:44:32',NULL,NULL),(63053,'75221','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.691806,-96.824376,0,'2013-07-06 12:44:33',NULL,NULL),(78428,'98052','S','Adelaide','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.683648,-122.121837,0,'2013-07-06 12:44:34',NULL,NULL),(70497,'84775','S','Capitol Reef','N','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.302647,-111.367243,0,'2013-07-06 12:44:34',NULL,NULL),(63425,'75661','S','Karnack','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.628300,-94.175280,0,'2013-07-06 12:44:33',NULL,NULL),(59178,'70346','S','McCall','N','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.100345,-91.001444,0,'2013-07-06 12:44:33',NULL,NULL),(23931,'26253','S','Beverly','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.848735,-79.871311,0,'2013-07-06 12:44:31',NULL,NULL),(15765,'16915','S','Oswayo','A','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(18536,'19111','S','Lawndale','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057937,-75.081966,0,'2013-07-06 12:44:31',NULL,NULL),(42615,'47902','P','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.416378,-86.851288,0,'2013-07-06 12:44:32',NULL,NULL),(44395,'49812','S','Carney','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.581636,-87.559163,0,'2013-07-06 12:44:32',NULL,NULL),(3697,'02137','P','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.235076,-71.134469,0,'2013-07-06 12:44:30',NULL,NULL),(53072,'61523','S','Chillicothe','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(53357,'61764','S','Pontiac','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(77214,'96382','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(52809,'61279','S','Reynolds','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.342093,-90.705564,0,'2013-07-06 12:44:33',NULL,NULL),(49640,'56945','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(46281,'53037','S','Jackson','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.319801,-88.162627,0,'2013-07-06 12:44:32',NULL,NULL),(23735,'25918','S','Abraham','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.704600,-81.102000,0,'2013-07-06 12:44:31',NULL,NULL),(6537,'05833','S','East Charleston','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.823299,-71.986472,0,'2013-07-06 12:44:30',NULL,NULL),(7224,'06503','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309366,-72.928189,0,'2013-07-06 12:44:30',NULL,NULL),(20871,'21670','P','Templeville','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.135447,-75.767885,0,'2013-07-06 12:44:31',NULL,NULL),(58249,'68362','P','Gilead','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.166389,-97.585556,0,'2013-07-06 12:44:33',NULL,NULL),(78538,'98136','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.535393,-122.386977,0,'2013-07-06 12:44:34',NULL,NULL),(74097,'92201','S','Indio','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.707812,-116.231849,0,'2013-07-06 12:44:34',NULL,NULL),(59446,'70723','S','Convent','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.064945,-90.835684,0,'2013-07-06 12:44:33',NULL,NULL),(37077,'41317','S','Clayhole','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.465096,-83.231860,0,'2013-07-06 12:44:32',NULL,NULL),(45665,'52033','S','Fillmore','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.310784,-91.005487,0,'2013-07-06 12:44:32',NULL,NULL),(12320,'12863','S','Rock City Falls','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.062610,-73.924524,0,'2013-07-06 12:44:30',NULL,NULL),(10678,'11203','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.649673,-73.937666,0,'2013-07-06 12:44:30',NULL,NULL),(26946,'29602','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.855034,-82.408153,0,'2013-07-06 12:44:31',NULL,NULL),(63986,'76109','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.701611,-97.382250,0,'2013-07-06 12:44:34',NULL,NULL),(68057,'80933','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.934825,-105.004782,0,'2013-07-06 12:44:34',NULL,NULL),(77976,'97383','S','Stayton','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.803277,-122.757865,0,'2013-07-06 12:44:34',NULL,NULL),(62392,'74101','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.072287,-95.902002,0,'2013-07-06 12:44:33',NULL,NULL),(50054,'57438','S','Burkmere','N','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.035596,-99.120562,0,'2013-07-06 12:44:33',NULL,NULL),(25863,'28630','S','Grace Chapel','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.816100,-81.457140,0,'2013-07-06 12:44:31',NULL,NULL),(37132,'41465','S','Cutuno','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(8321,'08034','S','Cherry Hill Township','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908086,-75.004604,0,'2013-07-06 12:44:30',NULL,NULL),(3481,'01832','S','Haverhill','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.781791,-71.117351,0,'2013-07-06 12:44:30',NULL,NULL),(45114,'50559','S','Lone Rock','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.223405,-94.320812,0,'2013-07-06 12:44:32',NULL,NULL),(6854,'06128','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.781773,-72.622460,0,'2013-07-06 12:44:30',NULL,NULL),(26270,'29010','S','Mechanicsville','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(1697,'00777','S','Urb Lirios','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(56287,'65075','S','St Elizabeth','A','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.286194,-92.274802,0,'2013-07-06 12:44:33',NULL,NULL),(64231,'76305','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(75582,'94286','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.554006,-121.498140,0,'2013-07-06 12:44:34',NULL,NULL),(65851,'78202','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.421825,-98.465817,0,'2013-07-06 12:44:34',NULL,NULL),(1552,'00765','S','Bo Tortuguero','N','Vieques','72147','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.123576,-65.438423,0,'2013-07-06 12:44:30',NULL,NULL),(50644,'58311','S','Moscow','N','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629815,-98.589847,0,'2013-07-06 12:44:33',NULL,NULL),(55396,'63633','S','Centerville','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.440471,-90.995157,0,'2013-07-06 12:44:33',NULL,NULL),(34827,'38916','S','Calhoun City','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.883888,-89.326351,0,'2013-07-06 12:44:32',NULL,NULL),(26085,'28708','S','Balsam Grove','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.224044,-82.885192,0,'2013-07-06 12:44:31',NULL,NULL),(49231,'56469','S','Waukenabo','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(57141,'66227','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.980518,-94.869055,0,'2013-07-06 12:44:33',NULL,NULL),(59416,'70653','S','Fields','A','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.709468,-93.552030,0,'2013-07-06 12:44:33',NULL,NULL),(65373,'77541','S','Freeport','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(69482,'83672','S','Jonathan','N','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.279700,-116.985420,0,'2013-07-06 12:44:34',NULL,NULL),(77666,'97026','S','Saint Louis','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.112684,-122.921660,0,'2013-07-06 12:44:34',NULL,NULL),(75904,'94998','U','Novato','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.099734,-122.571446,0,'2013-07-06 12:44:34',NULL,NULL),(75398,'94010','S','Hillsborough','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.570237,-122.360344,0,'2013-07-06 12:44:34',NULL,NULL),(73935,'92039','P','La Jolla','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.847122,-117.275759,0,'2013-07-06 12:44:34',NULL,NULL),(47046,'54411','S','Hamburg','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.034525,-90.084577,0,'2013-07-06 12:44:32',NULL,NULL),(59465,'70739','S','Greenwel Spgs','A','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.539595,-91.000712,0,'2013-07-06 12:44:33',NULL,NULL),(58930,'69343','S','Gordon','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.808801,-102.202166,0,'2013-07-06 12:44:33',NULL,NULL),(19022,'19530','S','Kutztown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.533780,-75.789540,0,'2013-07-06 12:44:31',NULL,NULL),(19150,'19710','P','Montchanin','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.794599,-75.585633,0,'2013-07-06 12:44:31',NULL,NULL),(76779,'95939','S','Grindstone Creek Rancheria','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.600336,-122.565896,0,'2013-07-06 12:44:34',NULL,NULL),(64160,'76208','S','Shady Shores','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.194850,-97.056584,0,'2013-07-06 12:44:34',NULL,NULL),(61140,'72160','S','Stuttgart','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(14325,'14905','S','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.090047,-76.839445,0,'2013-07-06 12:44:31',NULL,NULL),(44582,'50035','S','Bondurant','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.724657,-93.447145,0,'2013-07-06 12:44:32',NULL,NULL),(38096,'43083','P','Westville','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.108381,-83.836233,0,'2013-07-06 12:44:32',NULL,NULL),(4489,'03276','S','Northfield','A','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.456440,-71.570040,0,'2013-07-06 12:44:30',NULL,NULL),(32911,'36548','S','Carson','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.516479,-87.896552,0,'2013-07-06 12:44:32',NULL,NULL),(7327,'06705','S','East End','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.549583,-72.995890,0,'2013-07-06 12:44:30',NULL,NULL),(31450,'34281','P','Trailer Estates','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.489556,-82.579608,0,'2013-07-06 12:44:32',NULL,NULL),(22106,'23421','S','Parksley','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.788179,-75.655317,0,'2013-07-06 12:44:31',NULL,NULL),(16017,'17042','S','Cornwall Boro','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(25467,'28339','S','Erwin','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.327232,-78.673753,0,'2013-07-06 12:44:31',NULL,NULL),(30685,'33472','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.553316,-80.221672,0,'2013-07-06 12:44:32',NULL,NULL),(60566,'71753','S','Village','A','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.264345,-93.233796,0,'2013-07-06 12:44:33',NULL,NULL),(49944,'57339','S','Fort Thompson','D','Buffalo','46017','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.065203,-99.326450,0,'2013-07-06 12:44:33',NULL,NULL),(5799,'05062','S','Felchville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.494300,-72.584520,0,'2013-07-06 12:44:30',NULL,NULL),(45002,'50447','S','Kanawha','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.935696,-93.790461,0,'2013-07-06 12:44:32',NULL,NULL),(11180,'11732','S','Upper Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.846511,-73.536189,0,'2013-07-06 12:44:30',NULL,NULL),(53760,'62263','S','Pilot Knob','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441389,-89.370278,0,'2013-07-06 12:44:33',NULL,NULL),(65626,'77963','S','Ander','N','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(73738,'91709','S','Chino Hills','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',33.986640,-117.683220,0,'2013-07-06 12:44:34',NULL,NULL),(78994,'98382','S','Blyn','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(67777,'80649','S','Orchard','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.371009,-104.099016,0,'2013-07-06 12:44:34',NULL,NULL),(64786,'77008','S','Houston Heights','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.796325,-95.417235,0,'2013-07-06 12:44:34',NULL,NULL),(58562,'68825','S','Callaway','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(57007,'66205','S','Mission Woods','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(21873,'23161','S','Stevensville','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.706038,-76.936507,0,'2013-07-06 12:44:31',NULL,NULL),(14897,'15492','P','Wickhaven','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.120343,-79.771040,0,'2013-07-06 12:44:31',NULL,NULL),(10019,'10170','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(55531,'63829','S','Cardwell','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.045006,-90.292385,0,'2013-07-06 12:44:33',NULL,NULL),(78724,'98278','U','Oak Harbor','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.281520,-122.625637,0,'2013-07-06 12:44:34',NULL,NULL),(67971,'80914','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(53238,'61650','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.637504,-89.496844,0,'2013-07-06 12:44:33',NULL,NULL),(33314,'37134','S','New Johsonvle','A','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.010324,-87.967812,0,'2013-07-06 12:44:32',NULL,NULL),(21207,'22202','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.861338,-77.056739,0,'2013-07-06 12:44:31',NULL,NULL),(24865,'27658','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.850975,-78.593286,0,'2013-07-06 12:44:31',NULL,NULL),(1487,'00751','S','Bo Santa Ana Ii','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(8023,'07727','S','Tinton Falls','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.199657,-74.163542,0,'2013-07-06 12:44:30',NULL,NULL),(59674,'71061','S','Caddo','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.749688,-93.980602,0,'2013-07-06 12:44:33',NULL,NULL),(72810,'89801','S','Elko','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.834645,-115.757583,0,'2013-07-06 12:44:34',NULL,NULL),(79696,'99206','S','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.651979,-117.275650,0,'2013-07-06 12:44:34',NULL,NULL),(59060,'70092','S','Violet','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.915069,-89.862837,0,'2013-07-06 12:44:33',NULL,NULL),(55161,'63366','S','Saint Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(29890,'33042','S','Summrlnd Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(49486,'56661','S','Ardenhurst','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(63641,'75844','S','Grapeland','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(77689,'97038','S','Molalla','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.121182,-122.569308,0,'2013-07-06 12:44:34',NULL,NULL),(71465,'87053','S','Zia Pueblo','A','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.543280,-106.757400,0,'2013-07-06 12:44:34',NULL,NULL),(68022,'80925','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739647,-104.635922,0,'2013-07-06 12:44:34',NULL,NULL),(58964,'70030','S','Des Allemands','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.822943,-90.464715,0,'2013-07-06 12:44:33',NULL,NULL),(55760,'64116','S','Kans Cty','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(2773,'00976','S','Alt Interamericana','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(7350,'06724','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.559608,-73.041406,0,'2013-07-06 12:44:30',NULL,NULL),(57385,'66753','S','Monmouth','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.352484,-95.021069,0,'2013-07-06 12:44:33',NULL,NULL),(63644,'75844','S','Refuge','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(72329,'89008','S','Carp','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.655453,-114.504832,0,'2013-07-06 12:44:34',NULL,NULL),(73437,'91222','P','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.159220,-118.262561,0,'2013-07-06 12:44:34',NULL,NULL),(72316,'89001','S','Rachel','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.481400,-115.488420,0,'2013-07-06 12:44:34',NULL,NULL),(47907,'55109','S','Vadnais Heights','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(43607,'48770','S','Whittemore','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.234603,-83.811373,0,'2013-07-06 12:44:32',NULL,NULL),(31881,'35127','S','Pl Grove','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489447,-86.973348,0,'2013-07-06 12:44:32',NULL,NULL),(31767,'35007','S','Alabaster','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.241465,-86.821286,0,'2013-07-06 12:44:32',NULL,NULL),(39635,'44902','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.761375,-82.513115,0,'2013-07-06 12:44:32',NULL,NULL),(16673,'17360','S','Seven Valleys','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.856827,-76.768562,0,'2013-07-06 12:44:31',NULL,NULL),(7677,'07096','P','Secaucus','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.781235,-74.064580,0,'2013-07-06 12:44:30',NULL,NULL),(38447,'43604','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.653385,-83.530339,0,'2013-07-06 12:44:32',NULL,NULL),(9518,'10017','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(1829,'00784','S','Urb Costa Azul','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(64510,'76634','S','Laguna Park','A','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(68457,'81230','S','Iola','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.453420,-106.609860,0,'2013-07-06 12:44:34',NULL,NULL),(61797,'73090','S','Union City','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.395797,-97.935310,0,'2013-07-06 12:44:33',NULL,NULL),(28931,'32169','S','New Smyrna','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.999132,-80.877818,0,'2013-07-06 12:44:32',NULL,NULL),(10270,'10509','S','Southeast','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422678,-73.599511,0,'2013-07-06 12:44:30',NULL,NULL),(20335,'20850','S','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.085920,-77.174389,0,'2013-07-06 12:44:31',NULL,NULL),(42798,'48049','S','Clyde','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.036320,-82.574580,0,'2013-07-06 12:44:32',NULL,NULL),(47649,'54930','S','Pleasant Lake','N','Waushara','55137','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.024459,-89.636788,0,'2013-07-06 12:44:33',NULL,NULL),(69150,'83314','S','Bliss','D','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.946860,-114.934200,0,'2013-07-06 12:44:34',NULL,NULL),(73363,'91017','P','Monrovia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.131442,-117.987304,0,'2013-07-06 12:44:34',NULL,NULL),(75700,'94567','S','Pope Valley','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.676832,-122.407523,0,'2013-07-06 12:44:34',NULL,NULL),(80203,'99950','P','Edna Bay','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.340000,-131.640000,0,'2013-07-06 12:44:34',NULL,NULL),(71487,'87101','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.200486,-106.643175,0,'2013-07-06 12:44:34',NULL,NULL),(61691,'72947','S','Mulberry','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.501887,-94.056353,0,'2013-07-06 12:44:33',NULL,NULL),(53866,'62339','S','Golden','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.110170,-91.019598,0,'2013-07-06 12:44:33',NULL,NULL),(2542,'00959','S','Ext Villa Rica','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(18760,'19351','P','Lewisville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.722789,-75.875297,0,'2013-07-06 12:44:31',NULL,NULL),(12484,'12992','S','Ingraham','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.780960,-73.505322,0,'2013-07-06 12:44:30',NULL,NULL),(11114,'11702','S','Oak Island','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(44532,'49963','P','South Range','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.067439,-88.642845,0,'2013-07-06 12:44:32',NULL,NULL),(30861,'33662','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.971741,-82.348435,0,'2013-07-06 12:44:32',NULL,NULL),(19646,'20270','U','Presidential Transition Team','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900588,-77.022082,0,'2013-07-06 12:44:31',NULL,NULL),(29716,'32951','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.024675,-80.539219,0,'2013-07-06 12:44:32',NULL,NULL),(26858,'29528','P','Conway','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.840173,-79.060795,0,'2013-07-06 12:44:31',NULL,NULL),(69874,'84096','S','Herriman','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569038,-111.966550,0,'2013-07-06 12:44:34',NULL,NULL),(74769,'93106','U','Univ of Cal Santa Barbara','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.431306,-119.834277,0,'2013-07-06 12:44:34',NULL,NULL),(23169,'25024','S','Bloomingrose','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.155799,-81.625292,0,'2013-07-06 12:44:31',NULL,NULL),(15155,'15870','S','Wilcox','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.573931,-78.622841,0,'2013-07-06 12:44:31',NULL,NULL),(30749,'33556','S','Odessa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.138540,-82.607174,0,'2013-07-06 12:44:32',NULL,NULL),(47169,'54476','S','Kelly','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.906068,-89.571594,0,'2013-07-06 12:44:32',NULL,NULL),(64010,'76117','S','Haltom City','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(76212,'95364','S','Pinecrest','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.320730,-119.823875,0,'2013-07-06 12:44:34',NULL,NULL),(77966,'97371','S','Rickreall','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.985103,-123.202540,0,'2013-07-06 12:44:34',NULL,NULL),(27090,'29710','S','Clover','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.105301,-81.184746,0,'2013-07-06 12:44:31',NULL,NULL),(730,'00687','S','Villa Roca','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(4576,'03574','S','Bethlehem','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.290117,-71.662463,0,'2013-07-06 12:44:30',NULL,NULL),(44373,'49788','S','Sault S Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.495278,-84.345278,0,'2013-07-06 12:44:32',NULL,NULL),(3331,'01536','S','N Grafton','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.229493,-71.703587,0,'2013-07-06 12:44:30',NULL,NULL),(76805,'95947','S','Greenville','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.154340,-120.924326,0,'2013-07-06 12:44:34',NULL,NULL),(39210,'44402','S','Bristolville','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.380390,-80.859104,0,'2013-07-06 12:44:32',NULL,NULL),(337,'00653','S','Urb Bahia','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(39690,'45032','P','Massie','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.504357,-84.009988,0,'2013-07-06 12:44:32',NULL,NULL),(36491,'40808','S','Big Laurel','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.997932,-83.164976,0,'2013-07-06 12:44:32',NULL,NULL),(7071,'06339','S','Gales Ferry','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.444713,-71.995991,0,'2013-07-06 12:44:30',NULL,NULL),(48725,'55957','S','Millville','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.244314,-92.296084,0,'2013-07-06 12:44:33',NULL,NULL),(69312,'83463','S','Gibbonsville','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.518343,-113.983536,0,'2013-07-06 12:44:34',NULL,NULL),(53220,'61634','U','Il Mutual Life & Casualty','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.691385,-89.588711,0,'2013-07-06 12:44:33',NULL,NULL),(48647,'55903','P','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.000259,-92.533630,0,'2013-07-06 12:44:33',NULL,NULL),(42671,'47964','P','Mount Ayr','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.953169,-87.295031,0,'2013-07-06 12:44:32',NULL,NULL),(43542,'48674','U','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.707462,-84.228673,0,'2013-07-06 12:44:32',NULL,NULL),(3111,'01230','S','New Marlborough','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(15310,'16154','S','Delaware Twp','N','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.330766,-80.441553,0,'2013-07-06 12:44:31',NULL,NULL),(28659,'31779','S','Pelham','D','Mitchell','13205','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.125607,-84.154630,0,'2013-07-06 12:44:32',NULL,NULL),(63395,'75644','S','Willow Oak','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(5887,'05153','S','Proctorsville','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.474167,-72.589722,0,'2013-07-06 12:44:30',NULL,NULL),(11706,'12166','S','Rural Grove','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.849600,-74.476380,0,'2013-07-06 12:44:30',NULL,NULL),(44167,'49546','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(21978,'23250','S','Rich','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(40990,'46356','S','Creston','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.284559,-87.416071,0,'2013-07-06 12:44:32',NULL,NULL),(16395,'17215','S','Burnt Cabins','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.063310,-77.905418,0,'2013-07-06 12:44:31',NULL,NULL),(29841,'33033','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.494244,-80.432291,0,'2013-07-06 12:44:32',NULL,NULL),(55394,'63631','S','Caledonia','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.773412,-90.799689,0,'2013-07-06 12:44:33',NULL,NULL),(13508,'13810','S','Mount Vision','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.612677,-75.133564,0,'2013-07-06 12:44:31',NULL,NULL),(21295,'22401','S','Fredericksburg','D','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.296176,-77.485335,0,'2013-07-06 12:44:31',NULL,NULL),(19848,'20509','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892273,-77.037823,0,'2013-07-06 12:44:31',NULL,NULL),(57160,'66282','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.953539,-94.688284,0,'2013-07-06 12:44:33',NULL,NULL),(65035,'77327','S','Plum Grove','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(71165,'86039','P','Kykotsmovi Village','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(17343,'17868','P','Wolverton','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.957337,-76.628912,0,'2013-07-06 12:44:31',NULL,NULL),(65948,'78263','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.354295,-98.331761,0,'2013-07-06 12:44:34',NULL,NULL),(72734,'89506','S','Panther Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(63310,'75567','S','Carbondale','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.364200,-94.472220,0,'2013-07-06 12:44:33',NULL,NULL),(62541,'74434','S','Fort Gibson','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.801850,-95.250930,0,'2013-07-06 12:44:33',NULL,NULL),(60269,'71447','S','Galbraith','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(56636,'65608','S','Ava','D','Douglas','29067','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.960651,-92.661201,0,'2013-07-06 12:44:33',NULL,NULL),(34536,'38701','S','Greenville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.288780,-90.990720,0,'2013-07-06 12:44:32',NULL,NULL),(38147,'43143','S','Mount Sterling','D','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.741372,-83.306744,0,'2013-07-06 12:44:32',NULL,NULL),(44848,'50268','S','Coal Creek','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.377924,-92.353635,0,'2013-07-06 12:44:32',NULL,NULL),(22066,'23337','S','Chincoteague Island','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.862571,-75.462907,0,'2013-07-06 12:44:31',NULL,NULL),(29926,'33063','S','Margate','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.248973,-80.206871,0,'2013-07-06 12:44:32',NULL,NULL),(34565,'38731','S','Greenville','A','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.087531,-91.084410,0,'2013-07-06 12:44:32',NULL,NULL),(19243,'19934','S','Camden Wyo','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(44065,'49443','P','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.211349,-86.228675,0,'2013-07-06 12:44:32',NULL,NULL),(10682,'11207','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.669311,-73.895528,0,'2013-07-06 12:44:30',NULL,NULL),(37062,'41311','S','Fillmore','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(34891,'38949','S','Bruce','A','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.176213,-89.373249,0,'2013-07-06 12:44:32',NULL,NULL),(47334,'54566','S','Carter','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.438000,-88.631280,0,'2013-07-06 12:44:32',NULL,NULL),(54680,'62942','S','Howardton','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.639885,-89.467041,0,'2013-07-06 12:44:33',NULL,NULL),(59630,'71037','S','Koran','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(64409,'76544','S','McNair Village','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(78694,'98253','S','Greenbank','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.087525,-122.577441,0,'2013-07-06 12:44:34',NULL,NULL),(80038,'99695','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.215515,-149.866023,0,'2013-07-06 12:44:34',NULL,NULL),(72655,'89431','S','Sparks','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.548066,-119.734394,0,'2013-07-06 12:44:34',NULL,NULL),(65309,'77502','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.679942,-95.198440,0,'2013-07-06 12:44:34',NULL,NULL),(60666,'71921','S','Point Cedar','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(53647,'62204','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.633044,-90.101683,0,'2013-07-06 12:44:33',NULL,NULL),(1776,'00780','S','Villas Del Laurel 2','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(7919,'07640','S','Harrington Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.991196,-73.980288,0,'2013-07-06 12:44:30',NULL,NULL),(23589,'25674','S','Kermit','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.838915,-82.407867,0,'2013-07-06 12:44:31',NULL,NULL),(27996,'30599','U','Baker-Taylor','N','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.205200,-83.460610,0,'2013-07-06 12:44:31',NULL,NULL),(53565,'62053','S','Kampsville','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.323201,-90.645352,0,'2013-07-06 12:44:33',NULL,NULL),(38564,'43768','P','Old Washington','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.032494,-81.411187,0,'2013-07-06 12:44:32',NULL,NULL),(10744,'11358','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760434,-73.799188,0,'2013-07-06 12:44:30',NULL,NULL),(21337,'22412','U','Fredericksbrg','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299924,-77.488208,0,'2013-07-06 12:44:31',NULL,NULL),(19504,'20166','S','Sterling','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.995686,-77.435025,0,'2013-07-06 12:44:31',NULL,NULL),(37484,'42003','S','Paducah','D','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.031534,-88.587966,0,'2013-07-06 12:44:32',NULL,NULL),(28516,'31542','S','Hoboken','D','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.185514,-82.117732,0,'2013-07-06 12:44:32',NULL,NULL),(67227,'79927','S','Ysleta Sur','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.655220,-106.228260,0,'2013-07-06 12:44:34',NULL,NULL),(63609,'75801','S','Elmwood','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.789440,-95.632020,0,'2013-07-06 12:44:34',NULL,NULL),(17107,'17771','S','Cogan House','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(22405,'23960','S','Prospect','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.318317,-78.553389,0,'2013-07-06 12:44:31',NULL,NULL),(15700,'16850','S','Lecontes Mls','A','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.081857,-78.280359,0,'2013-07-06 12:44:31',NULL,NULL),(13657,'14020','S','Bushville','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.994565,-78.190625,0,'2013-07-06 12:44:31',NULL,NULL),(5763,'05042','S','Mosquitoville','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270278,-72.144444,0,'2013-07-06 12:44:30',NULL,NULL),(7801,'07438','S','Jefferson Township','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.033460,-74.499840,0,'2013-07-06 12:44:30',NULL,NULL),(979,'00716','S','Villa de Juan','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(9920,'10151','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(70572,'85064','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.508942,-112.032374,0,'2013-07-06 12:44:34',NULL,NULL),(79923,'99608','P','Karluk','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.558010,-154.476650,0,'2013-07-06 12:44:34',NULL,NULL),(56775,'65744','S','Rueter','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.638557,-92.912454,0,'2013-07-06 12:44:33',NULL,NULL),(56379,'65231','S','Hatton','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.015325,-91.894565,0,'2013-07-06 12:44:33',NULL,NULL),(54681,'62942','S','Red Town','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.639885,-89.467041,0,'2013-07-06 12:44:33',NULL,NULL),(30717,'33511','S','Brandon','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.912173,-82.296703,0,'2013-07-06 12:44:32',NULL,NULL),(32592,'36130','U','AL State Govt Mail','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.373160,-86.311027,0,'2013-07-06 12:44:32',NULL,NULL),(11731,'12180','S','Troy','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(4834,'04004','P','Bar Mills','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.664860,-70.601219,0,'2013-07-06 12:44:30',NULL,NULL),(53632,'62097','S','Worden','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.957880,-89.870040,0,'2013-07-06 12:44:33',NULL,NULL),(60091,'71359','U','Louisiana College','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.323914,-92.427031,0,'2013-07-06 12:44:33',NULL,NULL),(71708,'87527','P','Dixon','D','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.198611,-105.861667,0,'2013-07-06 12:44:34',NULL,NULL),(78491,'98105','S','University','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.661442,-122.292906,0,'2013-07-06 12:44:34',NULL,NULL),(18939,'19506','S','Upper Bern','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.448100,-76.133040,0,'2013-07-06 12:44:31',NULL,NULL),(16241,'17081','P','Plainfield','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204234,-77.290805,0,'2013-07-06 12:44:31',NULL,NULL),(27094,'29712','S','Edgemoor','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.829331,-81.012395,0,'2013-07-06 12:44:31',NULL,NULL),(40567,'45864','P','Miller City','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.105717,-84.130775,0,'2013-07-06 12:44:32',NULL,NULL),(22827,'24505','P','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.416254,-79.141791,0,'2013-07-06 12:44:31',NULL,NULL),(43924,'49268','S','Palmyra','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.871803,-83.932716,0,'2013-07-06 12:44:32',NULL,NULL),(21772,'23062','S','Gloucester Point','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.256502,-76.493791,0,'2013-07-06 12:44:31',NULL,NULL),(20368,'20878','S','No Potomac','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.105531,-77.240190,0,'2013-07-06 12:44:31',NULL,NULL),(15087,'15757','S','Mahaffey','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.900980,-78.725700,0,'2013-07-06 12:44:31',NULL,NULL),(43755,'49014','S','Battle Creek','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.312625,-85.106599,0,'2013-07-06 12:44:32',NULL,NULL),(28710,'31830','S','Warm Springs','D','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.887296,-84.688156,0,'2013-07-06 12:44:32',NULL,NULL),(13356,'13699','U','Potsdam','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.671160,-74.986199,0,'2013-07-06 12:44:31',NULL,NULL),(51519,'59707','U','Butte','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.005208,-112.534930,0,'2013-07-06 12:44:33',NULL,NULL),(53438,'61871','P','Royal','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.192021,-87.968846,0,'2013-07-06 12:44:33',NULL,NULL),(73297,'90803','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.759309,-118.125598,0,'2013-07-06 12:44:34',NULL,NULL),(67711,'80530','S','Frederick','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.101205,-104.935223,0,'2013-07-06 12:44:34',NULL,NULL),(29165,'32351','S','Quincy','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.581537,-84.581395,0,'2013-07-06 12:44:32',NULL,NULL),(31246,'33976','S','Leehigh Acres','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.612085,-81.663866,0,'2013-07-06 12:44:32',NULL,NULL),(43910,'49254','S','Michigan Ctr','A','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.227720,-84.324707,0,'2013-07-06 12:44:32',NULL,NULL),(22776,'24445','S','Healing Springs','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(71,'00612','S','Comunidad Buenos Aires','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(21652,'22938','S','Faber','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.857512,-78.759743,0,'2013-07-06 12:44:31',NULL,NULL),(38396,'43524','S','Hamler','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.229092,-84.033359,0,'2013-07-06 12:44:32',NULL,NULL),(5060,'04276','S','Rumford Center','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.546376,-70.554444,0,'2013-07-06 12:44:30',NULL,NULL),(37376,'41740','S','Bearville','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.324933,-83.068260,0,'2013-07-06 12:44:32',NULL,NULL),(8942,'08757','S','Berkeley','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(15830,'16935','S','Crooked Creek','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(52723,'61231','S','Mercer','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(54149,'62568','S','Jeiseyville','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(54570,'62896','S','Ezra','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(59006,'70067','S','Jean Lafitte','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.721001,-90.123913,0,'2013-07-06 12:44:33',NULL,NULL),(59124,'70157','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944867,-90.082037,0,'2013-07-06 12:44:33',NULL,NULL),(56361,'65203','S','Sapp','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.929931,-92.372948,0,'2013-07-06 12:44:33',NULL,NULL),(50686,'58348','S','Maddock','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.932284,-99.553226,0,'2013-07-06 12:44:33',NULL,NULL),(19685,'20373','U','Anacostia','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(36478,'40769','S','Cumberland College','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.744037,-84.165125,0,'2013-07-06 12:44:32',NULL,NULL),(37837,'42455','S','Sebree','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.607747,-87.532668,0,'2013-07-06 12:44:32',NULL,NULL),(22254,'23668','U','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.023786,-76.339698,0,'2013-07-06 12:44:31',NULL,NULL),(25171,'28041','P','Faith','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.589483,-80.466689,0,'2013-07-06 12:44:31',NULL,NULL),(25421,'28301','S','Vander','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(51238,'59069','S','Reed Point','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.704228,-109.542867,0,'2013-07-06 12:44:33',NULL,NULL),(58941,'69354','S','Marsland','D','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.527744,-103.106295,0,'2013-07-06 12:44:33',NULL,NULL),(60093,'71360','S','Camp Beauregard','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(75506,'94140','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.757800,-122.412697,0,'2013-07-06 12:44:34',NULL,NULL),(69836,'84081','S','West Valley','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(37839,'42457','P','Smith Mills','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.807995,-87.771357,0,'2013-07-06 12:44:32',NULL,NULL),(35373,'39452','S','Harleston','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(68215,'81049','S','Kim','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.306177,-103.387984,0,'2013-07-06 12:44:34',NULL,NULL),(38445,'43601','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.647294,-83.547631,0,'2013-07-06 12:44:32',NULL,NULL),(16692,'17372','S','York Springs','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.003154,-77.111235,0,'2013-07-06 12:44:31',NULL,NULL),(56802,'65767','S','Urbana','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.840810,-93.169080,0,'2013-07-06 12:44:33',NULL,NULL),(60921,'72082','S','Kenseh','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.232917,-91.670949,0,'2013-07-06 12:44:33',NULL,NULL),(72056,'88112','S','Broadview','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.821111,-103.107222,0,'2013-07-06 12:44:34',NULL,NULL),(65902,'78235','S','Brooks Cb','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.341979,-98.442498,0,'2013-07-06 12:44:34',NULL,NULL),(51351,'59324','S','Mill Iron','A','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.853140,-104.217350,0,'2013-07-06 12:44:33',NULL,NULL),(12955,'13357','S','North Columbia','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(9644,'10037','S','Lincolnton','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(43782,'49039','P','Hagar Shores','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.200000,-86.333333,0,'2013-07-06 12:44:32',NULL,NULL),(7437,'06830','S','Greenwich','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.035494,-73.628183,0,'2013-07-06 12:44:30',NULL,NULL),(60804,'72031','S','Culpeper','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(61834,'73114','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.566667,-97.522044,0,'2013-07-06 12:44:33',NULL,NULL),(72981,'90051','P','August F Haw','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062744,-118.243140,0,'2013-07-06 12:44:34',NULL,NULL),(77013,'96089','P','Summit City','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.683097,-122.400465,0,'2013-07-06 12:44:34',NULL,NULL),(80188,'99901','S','Saxman','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.373751,-131.692560,0,'2013-07-06 12:44:34',NULL,NULL),(80014,'99678','P','Togiak','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.206606,-160.502473,0,'2013-07-06 12:44:34',NULL,NULL),(53315,'61740','S','Nebraska Township','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.876326,-88.861363,0,'2013-07-06 12:44:33',NULL,NULL),(28764,'32011','S','Callahan','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.558939,-81.835699,0,'2013-07-06 12:44:32',NULL,NULL),(20566,'21136','S','Glyndon','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.465347,-76.809770,0,'2013-07-06 12:44:31',NULL,NULL),(44036,'49421','S','Hesperia','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.612946,-86.063543,0,'2013-07-06 12:44:32',NULL,NULL),(9818,'10112','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(70134,'84302','S','Brigham City','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.536080,-112.048800,0,'2013-07-06 12:44:34',NULL,NULL),(77049,'96113','P','Herlong','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.138912,-120.156585,0,'2013-07-06 12:44:34',NULL,NULL),(73287,'90747','U','Long Beach','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.866528,-118.253036,0,'2013-07-06 12:44:34',NULL,NULL),(68962,'83002','P','Jackson Hole','A','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472865,-110.763529,0,'2013-07-06 12:44:34',NULL,NULL),(25878,'28637','S','Hildebran','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.718235,-81.426789,0,'2013-07-06 12:44:31',NULL,NULL),(13676,'14037','S','Cowlesville','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.818365,-78.455883,0,'2013-07-06 12:44:31',NULL,NULL),(42497,'47842','S','Clinton','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(19381,'20063','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903209,-77.044386,0,'2013-07-06 12:44:31',NULL,NULL),(39562,'44847','S','Steuben','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.214505,-82.714432,0,'2013-07-06 12:44:32',NULL,NULL),(48027,'55303','S','Anoka','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.261223,-93.440539,0,'2013-07-06 12:44:33',NULL,NULL),(54969,'63121','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(75968,'95055','P','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.336569,-121.983835,0,'2013-07-06 12:44:34',NULL,NULL),(65406,'77565','S','Kemah','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.540679,-95.030712,0,'2013-07-06 12:44:34',NULL,NULL),(63673,'75856','S','Pennington','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.157608,-95.160082,0,'2013-07-06 12:44:34',NULL,NULL),(14495,'15142','S','Presto','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.378033,-80.121426,0,'2013-07-06 12:44:31',NULL,NULL),(15543,'16617','S','Antis','N','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.603182,-78.332859,0,'2013-07-06 12:44:31',NULL,NULL),(22926,'24619','P','Horsepen','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.227452,-81.517321,0,'2013-07-06 12:44:31',NULL,NULL),(55215,'63401','S','Ilasco','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(55741,'64090','P','Strasburg','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.760880,-94.166075,0,'2013-07-06 12:44:33',NULL,NULL),(77083,'96132','S','Termo','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.920826,-120.610412,0,'2013-07-06 12:44:34',NULL,NULL),(67029,'79538','S','Content','N','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',32.006901,-99.564507,0,'2013-07-06 12:44:34',NULL,NULL),(55813,'64146','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.871759,-94.572443,0,'2013-07-06 12:44:33',NULL,NULL),(38232,'43230','S','Gahanna','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.044616,-82.856435,0,'2013-07-06 12:44:32',NULL,NULL),(2190,'00926','S','Parq Senorial','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(45775,'52156','S','Luana','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.056418,-91.392347,0,'2013-07-06 12:44:32',NULL,NULL),(37298,'41635','S','Craynor','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(65866,'78213','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.512114,-98.523892,0,'2013-07-06 12:44:34',NULL,NULL),(70448,'84745','S','La Verkin','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.210385,-113.272861,0,'2013-07-06 12:44:34',NULL,NULL),(78398,'98033','S','Totem Lake','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.687703,-122.192053,0,'2013-07-06 12:44:34',NULL,NULL),(68878,'82646','S','Casper','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.029483,-106.809656,0,'2013-07-06 12:44:34',NULL,NULL),(66544,'78731','S','Camp Mabry','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.345829,-97.765628,0,'2013-07-06 12:44:34',NULL,NULL),(49933,'57326','U','St Joseph Indian School','N','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.808959,-99.317832,0,'2013-07-06 12:44:33',NULL,NULL),(61207,'72301','S','West Memphis','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.146563,-90.177352,0,'2013-07-06 12:44:33',NULL,NULL),(42577,'47879','S','East Shelburn','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(456,'00662','S','Villa Gamal','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(73833,'91778','P','San Gabriel','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.101551,-118.103851,0,'2013-07-06 12:44:34',NULL,NULL),(71483,'87070','P','Clines Cors','A','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.960483,-105.561423,0,'2013-07-06 12:44:34',NULL,NULL),(69221,'83401','S','Lincoln','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(57722,'67363','P','Sycamore','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.328779,-95.714544,0,'2013-07-06 12:44:33',NULL,NULL),(54393,'62820','S','Burnt Prairie','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.190633,-88.210081,0,'2013-07-06 12:44:33',NULL,NULL),(49246,'56474','S','Blind Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(33564,'37412','S','East Ridge','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',34.997779,-85.233796,0,'2013-07-06 12:44:32',NULL,NULL),(43279,'48332','P','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465819,-83.378683,0,'2013-07-06 12:44:32',NULL,NULL),(45161,'50592','P','Truesdale','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.730416,-95.181613,0,'2013-07-06 12:44:32',NULL,NULL),(43939,'49284','S','Duck Lake','N','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.379037,-84.666199,0,'2013-07-06 12:44:32',NULL,NULL),(23540,'25608','S','Baisden','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.586285,-81.948951,0,'2013-07-06 12:44:31',NULL,NULL),(48447,'55707','S','Mahtowa','A','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.576488,-92.717904,0,'2013-07-06 12:44:33',NULL,NULL),(47451,'54729','S','Chippewa Fls','A','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(27433,'30113','S','Buchanan','D','Haralson','13143','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.833164,-85.193198,0,'2013-07-06 12:44:31',NULL,NULL),(25965,'28658','S','Propst Crossroads','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(40525,'45830','S','Cols Grove','N','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.872082,-84.028336,0,'2013-07-06 12:44:32',NULL,NULL),(6424,'05742','S','E Wallingford','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.433994,-72.877559,0,'2013-07-06 12:44:30',NULL,NULL),(1642,'00771','S','Urb Olympic Ville','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(5934,'05255','S','Barnumville','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.194892,-73.065620,0,'2013-07-06 12:44:30',NULL,NULL),(44025,'49411','S','Free Soil','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.110189,-86.238527,0,'2013-07-06 12:44:32',NULL,NULL),(38798,'44062','S','Middlefield','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.446501,-81.015275,0,'2013-07-06 12:44:32',NULL,NULL),(14557,'15213','S','Oakland','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.444993,-79.952662,0,'2013-07-06 12:44:31',NULL,NULL),(46704,'53791','U','Madison Business Reply Mail','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077245,-89.454359,0,'2013-07-06 12:44:32',NULL,NULL),(44187,'49611','P','Alba','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.958047,-84.899828,0,'2013-07-06 12:44:32',NULL,NULL),(31507,'34452','S','Inverness','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.777209,-82.390990,0,'2013-07-06 12:44:32',NULL,NULL),(28282,'31089','S','Tennille','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.940199,-82.811114,0,'2013-07-06 12:44:31',NULL,NULL),(57966,'67764','S','Russell Spgs','N','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046384,-101.228293,0,'2013-07-06 12:44:33',NULL,NULL),(75376,'93933','S','Marina','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.683535,-121.792949,0,'2013-07-06 12:44:34',NULL,NULL),(70707,'85269','P','Fountain Hls','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.603722,-111.720365,0,'2013-07-06 12:44:34',NULL,NULL),(56384,'65233','S','Gooch Mill','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(11267,'11770','P','Fire Island','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.647098,-73.151777,0,'2013-07-06 12:44:30',NULL,NULL),(12784,'13215','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.975120,-76.226340,0,'2013-07-06 12:44:30',NULL,NULL),(22787,'24460','S','Milboro Sprgs','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.020620,-79.650900,0,'2013-07-06 12:44:31',NULL,NULL),(37971,'42726','S','Rock Creek','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.413206,-86.157634,0,'2013-07-06 12:44:32',NULL,NULL),(25287,'28136','P','Polkville','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.414631,-81.618702,0,'2013-07-06 12:44:31',NULL,NULL),(78152,'97602','P','Klamath Falls','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.194576,-121.655694,0,'2013-07-06 12:44:34',NULL,NULL),(64238,'76311','S','Sheppard AFB','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',34.014000,-98.497380,0,'2013-07-06 12:44:34',NULL,NULL),(61263,'72367','P','Mellwood','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.199650,-91.039272,0,'2013-07-06 12:44:33',NULL,NULL),(8675,'08328','S','Malaga','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.575220,-75.056455,0,'2013-07-06 12:44:30',NULL,NULL),(28225,'31037','S','Helena','D','Telfair','13271','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.060166,-82.936560,0,'2013-07-06 12:44:31',NULL,NULL),(5258,'04487','S','Carroll Plt','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.393599,-68.101456,0,'2013-07-06 12:44:30',NULL,NULL),(21248,'22245','U','Space & Naval Warfare System','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.852066,-77.051486,0,'2013-07-06 12:44:31',NULL,NULL),(24397,'27106','S','Mount Tabor','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.149640,-80.322600,0,'2013-07-06 12:44:31',NULL,NULL),(39424,'44678','P','Somerdale','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.565943,-81.362676,0,'2013-07-06 12:44:32',NULL,NULL),(32629,'36177','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.378975,-86.303722,0,'2013-07-06 12:44:32',NULL,NULL),(31649,'34739','S','Kenansville','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',27.858419,-80.976211,0,'2013-07-06 12:44:32',NULL,NULL),(48704,'55943','S','Houston','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.762527,-91.571590,0,'2013-07-06 12:44:33',NULL,NULL),(48903,'56127','S','Dunnell','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.544606,-94.794035,0,'2013-07-06 12:44:33',NULL,NULL),(71818,'87573','S','Cowles','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.775048,-105.625041,0,'2013-07-06 12:44:34',NULL,NULL),(73426,'91204','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.133450,-118.262119,0,'2013-07-06 12:44:34',NULL,NULL),(72794,'89703','S','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.170644,-119.781930,0,'2013-07-06 12:44:34',NULL,NULL),(71761,'87552','S','East Pecos','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(58135,'68144','S','Millard','A','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.233210,-96.113706,0,'2013-07-06 12:44:33',NULL,NULL),(54840,'63037','S','Gerald','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.398981,-91.330048,0,'2013-07-06 12:44:33',NULL,NULL),(3359,'01568','S','W Upton','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.171445,-71.604409,0,'2013-07-06 12:44:30',NULL,NULL),(1713,'00778','S','Ciudad Jardin','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(33875,'38018','S','Cordova','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.138320,-89.758273,0,'2013-07-06 12:44:32',NULL,NULL),(20830,'21634','S','Fishing Creek','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.299500,-76.204800,0,'2013-07-06 12:44:31',NULL,NULL),(75416,'94025','S','Menlo Park','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.436934,-122.193602,0,'2013-07-06 12:44:34',NULL,NULL),(72616,'89415','S','Whiskey Flats','N','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(54886,'63068','S','Lyon','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(53088,'61528','S','Edwards','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.790000,-89.751111,0,'2013-07-06 12:44:33',NULL,NULL),(3289,'01504','S','East Blackstone','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.026266,-71.528483,0,'2013-07-06 12:44:30',NULL,NULL),(13977,'14482','S','Leroy','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.964320,-77.980800,0,'2013-07-06 12:44:31',NULL,NULL),(1745,'00778','S','Urb Reina de los Angeles','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(55493,'63771','S','Haywood City','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.085317,-89.648175,0,'2013-07-06 12:44:33',NULL,NULL),(58878,'69160','U','Cabelas Inc','N','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.141884,-102.978079,0,'2013-07-06 12:44:33',NULL,NULL),(62694,'74731','S','Cartwright','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.885022,-96.547185,0,'2013-07-06 12:44:33',NULL,NULL),(69137,'83301','S','Three Creek','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.447360,-114.538200,0,'2013-07-06 12:44:34',NULL,NULL),(63559,'75766','S','Tecula','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:34',NULL,NULL),(62117,'73648','P','Elk City','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.407089,-99.420825,0,'2013-07-06 12:44:33',NULL,NULL),(54589,'62901','S','CDALE','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(51774,'60038','U','Ww Grainger Inc','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.096596,-88.011307,0,'2013-07-06 12:44:33',NULL,NULL),(50514,'58076','U','ND State College of Science','N','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.268399,-96.607702,0,'2013-07-06 12:44:33',NULL,NULL),(27438,'30116','S','Carrollton','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.493045,-85.031651,0,'2013-07-06 12:44:31',NULL,NULL),(18885,'19464','S','Pottstown','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.242360,-75.636660,0,'2013-07-06 12:44:31',NULL,NULL),(43314,'48356','S','Highland','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.650009,-83.582556,0,'2013-07-06 12:44:32',NULL,NULL),(7014,'06260','S','East Putnam','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(56051,'64734','S','Cleveland','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.678619,-94.592674,0,'2013-07-06 12:44:33',NULL,NULL),(66542,'78730','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.364835,-97.825721,0,'2013-07-06 12:44:34',NULL,NULL),(62225,'73937','S','Felt','D','Cimarron','40025','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.554028,-102.838653,0,'2013-07-06 12:44:33',NULL,NULL),(62042,'73523','S','Altus','A','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.682908,-99.344706,0,'2013-07-06 12:44:33',NULL,NULL),(61622,'72826','P','Blue Mountain','D','Logan','05083','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.145286,-93.721189,0,'2013-07-06 12:44:33',NULL,NULL),(53219,'61633','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.708280,-89.662648,0,'2013-07-06 12:44:33',NULL,NULL),(28471,'31501','S','Waycross','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.223540,-82.355739,0,'2013-07-06 12:44:32',NULL,NULL),(36025,'40165','S','Shepherdsvlle','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(20055,'20661','P','Mt Victoria','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.359153,-76.896668,0,'2013-07-06 12:44:31',NULL,NULL),(16294,'17107','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.296479,-76.874607,0,'2013-07-06 12:44:31',NULL,NULL),(36294,'40358','S','Olympia','D','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.049641,-83.759266,0,'2013-07-06 12:44:32',NULL,NULL),(15870,'16950','S','Elmer','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(62437,'74170','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.042184,-95.947467,0,'2013-07-06 12:44:33',NULL,NULL),(76644,'95721','P','Twin Bridges','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.914913,-120.009699,0,'2013-07-06 12:44:34',NULL,NULL),(75973,'95060','S','Scotts Valley','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.989018,-122.057824,0,'2013-07-06 12:44:34',NULL,NULL),(66313,'78592','P','Bluetown','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.073889,-97.822778,0,'2013-07-06 12:44:34',NULL,NULL),(47069,'54426','S','Edgar','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.892081,-89.992307,0,'2013-07-06 12:44:32',NULL,NULL),(21900,'23186','U','Williamsburg','D','Williamsburg City','51830','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.272593,-76.682518,0,'2013-07-06 12:44:31',NULL,NULL),(35367,'39443','S','Laurel','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.693490,-89.130537,0,'2013-07-06 12:44:32',NULL,NULL),(34342,'38575','S','Moss','D','Clay','47027','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.599606,-85.688062,0,'2013-07-06 12:44:32',NULL,NULL),(44039,'49424','S','Holland','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.821709,-86.146908,0,'2013-07-06 12:44:32',NULL,NULL),(42916,'48108','S','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.240869,-83.719353,0,'2013-07-06 12:44:32',NULL,NULL),(67744,'80603','S','Lochbuie','A','Weld','08123','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.991590,-104.696847,0,'2013-07-06 12:44:34',NULL,NULL),(70176,'84327','P','Newton','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.863903,-111.989872,0,'2013-07-06 12:44:34',NULL,NULL),(35834,'39772','S','Weir','D','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.266100,-89.282520,0,'2013-07-06 12:44:32',NULL,NULL),(40449,'45734','S','Rinard Mills','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.656927,-81.187313,0,'2013-07-06 12:44:32',NULL,NULL),(12848,'13317','S','Browns Hollow','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(9166,'09343','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30558,'33412','S','Royal Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(1023,'00718','S','Urb Diplo','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(20966,'21787','S','Taneytown','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.678105,-77.157129,0,'2013-07-06 12:44:31',NULL,NULL),(53184,'61606','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.698588,-89.609827,0,'2013-07-06 12:44:33',NULL,NULL),(67463,'80220','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.735435,-104.917507,0,'2013-07-06 12:44:34',NULL,NULL),(71674,'87507','S','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.676786,-105.957578,0,'2013-07-06 12:44:34',NULL,NULL),(76326,'95461','S','Anderson Springs','N','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.785860,-122.620200,0,'2013-07-06 12:44:34',NULL,NULL),(64895,'77082','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.720866,-95.627625,0,'2013-07-06 12:44:34',NULL,NULL),(57624,'67137','S','Climax','A','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.647180,-96.226920,0,'2013-07-06 12:44:33',NULL,NULL),(47484,'54751','S','Cedar Falls','N','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.877251,-91.923866,0,'2013-07-06 12:44:32',NULL,NULL),(44489,'49913','S','Centennial Hts','N','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.241904,-88.450576,0,'2013-07-06 12:44:32',NULL,NULL),(39478,'44720','S','Lake Slagle','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.897320,-81.433440,0,'2013-07-06 12:44:32',NULL,NULL),(31429,'34266','S','Arcadia','D','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.199150,-81.847982,0,'2013-07-06 12:44:32',NULL,NULL),(17174,'17815','S','Bloomsburg','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(29580,'32820','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.588392,-81.123204,0,'2013-07-06 12:44:32',NULL,NULL),(67170,'79838','P','Fabens','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.496203,-106.154272,0,'2013-07-06 12:44:34',NULL,NULL),(75362,'93923','S','Carmel Highlands','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.359760,-121.796280,0,'2013-07-06 12:44:34',NULL,NULL),(60511,'71666','P','Possum Fork','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.659552,-91.194003,0,'2013-07-06 12:44:33',NULL,NULL),(25274,'28128','S','Aquadale','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.237400,-80.166240,0,'2013-07-06 12:44:31',NULL,NULL),(26848,'29512','S','Bennettsville','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.613793,-79.686703,0,'2013-07-06 12:44:31',NULL,NULL),(18778,'19367','P','Pomeroy','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.967490,-75.928117,0,'2013-07-06 12:44:31',NULL,NULL),(21325,'22407','S','Fredericksbrg','A','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(13406,'13753','S','Lake Delaware','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.282872,-74.910178,0,'2013-07-06 12:44:31',NULL,NULL),(42135,'47513','S','Birdseye','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.283320,-86.714517,0,'2013-07-06 12:44:32',NULL,NULL),(44513,'49945','S','Gay','A','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.174820,-88.410780,0,'2013-07-06 12:44:32',NULL,NULL),(9487,'10012','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(33370,'37205','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.111030,-86.864958,0,'2013-07-06 12:44:32',NULL,NULL),(52594,'61015','S','Honey Creek','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.989953,-89.208021,0,'2013-07-06 12:44:33',NULL,NULL),(58502,'68766','S','Page','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.430282,-98.374931,0,'2013-07-06 12:44:33',NULL,NULL),(61402,'72545','U','Mays Mission','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.487914,-92.055731,0,'2013-07-06 12:44:33',NULL,NULL),(16710,'17403','S','Windsor Park','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(46871,'54102','S','Amberg','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.496805,-87.929331,0,'2013-07-06 12:44:32',NULL,NULL),(66948,'79370','S','Spur','D','Dickens','48125','Texas','TX','48','0000','806','Central',-6.0,'Y',33.478932,-100.858511,0,'2013-07-06 12:44:34',NULL,NULL),(46438,'53207','S','Bayview','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.980668,-87.892825,0,'2013-07-06 12:44:32',NULL,NULL),(28646,'31765','S','Hinsonton','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.060680,-84.079500,0,'2013-07-06 12:44:32',NULL,NULL),(11029,'11566','S','Merrick','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685085,-73.560710,0,'2013-07-06 12:44:30',NULL,NULL),(1828,'00784','S','Urb Caribe Mar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(2864,'00985','S','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(47159,'54469','S','Port Edwards','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.350304,-89.868238,0,'2013-07-06 12:44:32',NULL,NULL),(51646,'59870','S','Stevensville','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.517886,-114.053727,0,'2013-07-06 12:44:33',NULL,NULL),(54330,'62761','U','IL Dept Public Health','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.804222,-89.660644,0,'2013-07-06 12:44:33',NULL,NULL),(58717,'68937','S','Johnson LK','N','Gosper','31073','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.557840,-99.856380,0,'2013-07-06 12:44:33',NULL,NULL),(59880,'71269','S','Girard','A','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(73513,'91342','S','Kagel Canyon','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.303046,-118.421940,0,'2013-07-06 12:44:34',NULL,NULL),(72936,'90035','S','Preuss','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.051619,-118.383580,0,'2013-07-06 12:44:34',NULL,NULL),(7244,'06512','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.285640,-72.863580,0,'2013-07-06 12:44:30',NULL,NULL),(19116,'19606','S','Stony Creek Mills','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(19739,'20405','U','Gen Services Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901076,-77.022171,0,'2013-07-06 12:44:31',NULL,NULL),(59138,'70166','U','South Central Bell','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948632,-90.073740,0,'2013-07-06 12:44:33',NULL,NULL),(74363,'92415','U','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.127706,-117.266443,0,'2013-07-06 12:44:34',NULL,NULL),(72061,'88118','S','Floyd','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.290375,-103.752434,0,'2013-07-06 12:44:34',NULL,NULL),(55573,'63874','P','Risco','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.548426,-89.819413,0,'2013-07-06 12:44:33',NULL,NULL),(48699,'55939','S','Granger','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.557088,-92.010857,0,'2013-07-06 12:44:33',NULL,NULL),(547,'00677','S','Comunidad Estella','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(51880,'60087','S','Waukegan','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.405095,-87.859493,0,'2013-07-06 12:44:33',NULL,NULL),(65184,'77418','S','Nelsonville','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(25245,'28107','S','Midland','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.246152,-80.533020,0,'2013-07-06 12:44:31',NULL,NULL),(34374,'38614','S','King and Anderson','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(42650,'47941','P','Dayton','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.373449,-86.766894,0,'2013-07-06 12:44:32',NULL,NULL),(18781,'19372','S','Downingtown','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.992760,-75.758760,0,'2013-07-06 12:44:31',NULL,NULL),(44951,'50391','U','Allied Group','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585461,-93.622417,0,'2013-07-06 12:44:32',NULL,NULL),(75668,'94544','S','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.634255,-122.063172,0,'2013-07-06 12:44:34',NULL,NULL),(74441,'92582','S','San Jacinto','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.819546,-117.012729,0,'2013-07-06 12:44:34',NULL,NULL),(63123,'75320','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.777839,-96.798630,0,'2013-07-06 12:44:33',NULL,NULL),(32382,'35906','S','Gadsden','A','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.942000,-86.103720,0,'2013-07-06 12:44:32',NULL,NULL),(37470,'41862','S','Topmost','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.324722,-82.768056,0,'2013-07-06 12:44:32',NULL,NULL),(21583,'22840','S','McGaheysville','A','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.404045,-78.719342,0,'2013-07-06 12:44:31',NULL,NULL),(1142,'00727','S','Caguas','D','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(40351,'45629','S','Franklin Furnace','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.657779,-82.807843,0,'2013-07-06 12:44:32',NULL,NULL),(3095,'01223','S','Washington','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.381306,-73.143709,0,'2013-07-06 12:44:30',NULL,NULL),(70173,'84325','S','Mendon','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.749980,-111.981060,0,'2013-07-06 12:44:34',NULL,NULL),(76613,'95693','S','Wilton','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.390614,-121.225678,0,'2013-07-06 12:44:34',NULL,NULL),(36133,'40225','U','General Electric Co','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.188651,-85.651479,0,'2013-07-06 12:44:32',NULL,NULL),(43265,'48328','S','W Bloomfld Tw','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.644305,-83.356394,0,'2013-07-06 12:44:32',NULL,NULL),(16359,'17201','S','Duffield','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(14582,'15220','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425951,-80.048689,0,'2013-07-06 12:44:31',NULL,NULL),(36093,'40219','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(47556,'54834','P','Edgewater','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.742045,-91.477826,0,'2013-07-06 12:44:32',NULL,NULL),(53642,'62202','P','East St Louis','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.616644,-90.160951,0,'2013-07-06 12:44:33',NULL,NULL),(37940,'42701','S','Elizabethtown','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.707586,-85.861867,0,'2013-07-06 12:44:32',NULL,NULL),(25586,'28442','S','Hallsboro','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.293827,-78.599687,0,'2013-07-06 12:44:31',NULL,NULL),(42657,'47950','S','Idaville','D','White','18181','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.800350,-86.654431,0,'2013-07-06 12:44:32',NULL,NULL),(8411,'08069','S','Penns Grove','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.707040,-75.446700,0,'2013-07-06 12:44:30',NULL,NULL),(920,'00714','S','Brisas del Mar','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(38040,'43035','S','Lewis Center','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.179771,-83.009937,0,'2013-07-06 12:44:32',NULL,NULL),(14098,'14622','S','Irondequoit','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.216211,-77.562561,0,'2013-07-06 12:44:31',NULL,NULL),(15445,'16401','S','Pont','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(28134,'30817','S','New Hope','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(18627,'19152','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057073,-75.047092,0,'2013-07-06 12:44:31',NULL,NULL),(63875,'76008','S','Annetta N','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699617,-97.628794,0,'2013-07-06 12:44:34',NULL,NULL),(61838,'73115','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.438660,-97.439577,0,'2013-07-06 12:44:33',NULL,NULL),(26332,'29055','S','Beckhamville','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.570485,-80.902059,0,'2013-07-06 12:44:31',NULL,NULL),(18718,'19310','S','Steelville','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.948925,-75.972001,0,'2013-07-06 12:44:31',NULL,NULL),(44031,'49417','S','Grand Haven','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.035526,-86.183808,0,'2013-07-06 12:44:32',NULL,NULL),(5946,'05260','S','No Pownal','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.821495,-73.250086,0,'2013-07-06 12:44:30',NULL,NULL),(12685,'13134','P','Peterboro','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968836,-75.687569,0,'2013-07-06 12:44:30',NULL,NULL),(18708,'19196','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.957442,-75.184264,0,'2013-07-06 12:44:31',NULL,NULL),(51148,'58845','S','Alkabo','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.602400,-103.917180,0,'2013-07-06 12:44:33',NULL,NULL),(63722,'75930','S','Rosevine','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.328700,-94.019700,0,'2013-07-06 12:44:34',NULL,NULL),(73487,'91324','S','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.243279,-118.545849,0,'2013-07-06 12:44:34',NULL,NULL),(74922,'93401','S','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.259509,-120.652522,0,'2013-07-06 12:44:34',NULL,NULL),(29822,'33027','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.978093,-80.330196,0,'2013-07-06 12:44:32',NULL,NULL),(10443,'10915','P','Bullville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.541982,-74.362554,0,'2013-07-06 12:44:30',NULL,NULL),(23112,'24946','S','Droop','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.132820,-80.243820,0,'2013-07-06 12:44:31',NULL,NULL),(12185,'12770','S','Pond Eddy','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.454785,-74.852456,0,'2013-07-06 12:44:30',NULL,NULL),(56404,'65247','S','College Mound','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.651110,-92.451199,0,'2013-07-06 12:44:33',NULL,NULL),(6566,'05851','S','Lyndonville','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544120,-72.021300,0,'2013-07-06 12:44:30',NULL,NULL),(41019,'46379','P','Sumava Resorts','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.166140,-87.438854,0,'2013-07-06 12:44:32',NULL,NULL),(12133,'12722','P','Burlingham','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.589021,-74.383635,0,'2013-07-06 12:44:30',NULL,NULL),(4536,'03444','S','Dublin','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.896912,-72.042493,0,'2013-07-06 12:44:30',NULL,NULL),(37467,'41859','S','Dema','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.431745,-82.851394,0,'2013-07-06 12:44:32',NULL,NULL),(29600,'32833','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.486350,-81.084730,0,'2013-07-06 12:44:32',NULL,NULL),(58855,'69143','S','Hershey','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.150252,-101.004063,0,'2013-07-06 12:44:33',NULL,NULL),(71571,'87302','U','Gallup','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.431205,-108.728509,0,'2013-07-06 12:44:34',NULL,NULL),(75902,'94979','P','San Anselmo','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.971976,-122.562039,0,'2013-07-06 12:44:34',NULL,NULL),(45018,'50459','S','Silver Lake','N','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.444547,-93.217706,0,'2013-07-06 12:44:32',NULL,NULL),(20559,'21130','P','Perryman','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.470616,-76.200436,0,'2013-07-06 12:44:31',NULL,NULL),(65696,'78006','S','Fair Oaks Ranch','A','Kendall','48259','Texas','TX','48','7240','830','Central',-6.0,'Y',29.718030,-98.651343,0,'2013-07-06 12:44:34',NULL,NULL),(76080,'95210','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.026084,-121.295564,0,'2013-07-06 12:44:34',NULL,NULL),(79219,'98541','S','South Elma','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.010231,-123.411051,0,'2013-07-06 12:44:34',NULL,NULL),(8527,'08107','S','Woodlynne','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(1387,'00738','S','Fajardo','D','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(34524,'38680','S','Poplar Corners','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.961644,-90.119278,0,'2013-07-06 12:44:32',NULL,NULL),(10647,'11102','S','Astoria','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770391,-73.923967,0,'2013-07-06 12:44:30',NULL,NULL),(320,'00646','S','Villa Santa','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(45058,'50510','S','Albert City','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.784863,-94.962813,0,'2013-07-06 12:44:32',NULL,NULL),(41159,'46703','S','Crooked Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(74757,'93066','S','Somis','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.273793,-119.011368,0,'2013-07-06 12:44:34',NULL,NULL),(79417,'98822','S','Entiat','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.721297,-120.295625,0,'2013-07-06 12:44:34',NULL,NULL),(63811,'75965','S','Nacogdoches','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.612825,-94.649551,0,'2013-07-06 12:44:34',NULL,NULL),(63810,'75964','S','Nacogdoches','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.599177,-94.666841,0,'2013-07-06 12:44:34',NULL,NULL),(2987,'01062','S','Bay State Vlg','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.331578,-72.692571,0,'2013-07-06 12:44:30',NULL,NULL),(45096,'50540','S','Industry','N','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.586237,-94.844066,0,'2013-07-06 12:44:32',NULL,NULL),(18668,'19179','U','Veterans Administration','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.032062,-75.177546,0,'2013-07-06 12:44:31',NULL,NULL),(53042,'61480','S','Decorra','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.746561,-90.908216,0,'2013-07-06 12:44:33',NULL,NULL),(15684,'16833','S','Curwensville','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.974008,-78.526450,0,'2013-07-06 12:44:31',NULL,NULL),(27801,'30394','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.752800,-84.392638,0,'2013-07-06 12:44:31',NULL,NULL),(50161,'57551','S','Vetal','A','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.218780,-101.666700,0,'2013-07-06 12:44:33',NULL,NULL),(76386,'95531','S','Northcrest','N','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.784192,-124.168263,0,'2013-07-06 12:44:34',NULL,NULL),(27843,'30426','S','Girard','D','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.042559,-81.995343,0,'2013-07-06 12:44:31',NULL,NULL),(40204,'45388','S','Yorkshire','D','Darke','39037','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.325904,-84.482044,0,'2013-07-06 12:44:32',NULL,NULL),(43667,'48858','S','Mt Pleasant','A','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.601402,-84.787107,0,'2013-07-06 12:44:32',NULL,NULL),(44571,'50025','S','Fiscus','N','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.726100,-94.918560,0,'2013-07-06 12:44:32',NULL,NULL),(27678,'30332','U','Georgia Tech','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.777293,-84.396568,0,'2013-07-06 12:44:31',NULL,NULL),(42717,'48002','S','Berlin Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.908333,-82.883056,0,'2013-07-06 12:44:32',NULL,NULL),(31512,'34465','S','Beverly Hills','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.936160,-82.450412,0,'2013-07-06 12:44:32',NULL,NULL),(54650,'62930','S','Cottagegrove','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(30384,'33319','S','Ldhl','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(26557,'29209','S','Cedar Terrace','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(53407,'61833','S','Danville','A','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.124444,-87.630000,0,'2013-07-06 12:44:33',NULL,NULL),(71832,'87579','S','Pine View','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(71906,'87801','S','Campus','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.006320,-106.793820,0,'2013-07-06 12:44:34',NULL,NULL),(46193,'52748','S','Park View','N','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.663915,-90.556726,0,'2013-07-06 12:44:32',NULL,NULL),(10283,'10516','S','North Highland','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422380,-73.950720,0,'2013-07-06 12:44:30',NULL,NULL),(10157,'10278','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(19506,'20168','P','Haymarket','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.810991,-77.635632,0,'2013-07-06 12:44:31',NULL,NULL),(3990,'02537','S','E Sandwich','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.726548,-70.440357,0,'2013-07-06 12:44:30',NULL,NULL),(64308,'76466','P','Olden','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.420630,-98.748842,0,'2013-07-06 12:44:34',NULL,NULL),(40608,'45894','S','Venedocia','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.750319,-84.517876,0,'2013-07-06 12:44:32',NULL,NULL),(36627,'41001','S','Grants Lick','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.915760,-84.395700,0,'2013-07-06 12:44:32',NULL,NULL),(32025,'35242','S','Meadowbrook','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(30626,'33438','S','Canal Point','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.860317,-80.632842,0,'2013-07-06 12:44:32',NULL,NULL),(60434,'71646','S','Fountain Prairie','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(64133,'76193','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.747377,-97.330613,0,'2013-07-06 12:44:34',NULL,NULL),(67895,'80901','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834608,-104.822550,0,'2013-07-06 12:44:34',NULL,NULL),(78281,'97867','S','North Powder','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.035797,-117.937934,0,'2013-07-06 12:44:34',NULL,NULL),(11430,'11967','S','Smiths Point','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.795028,-72.869264,0,'2013-07-06 12:44:30',NULL,NULL),(3650,'02118','S','Roxbury','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.336960,-71.063760,0,'2013-07-06 12:44:30',NULL,NULL),(19622,'20242','U','National Park Service','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.960013,-77.043563,0,'2013-07-06 12:44:31',NULL,NULL),(31505,'34450','S','Inverness','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.824261,-82.257899,0,'2013-07-06 12:44:32',NULL,NULL),(19524,'20186','S','Opal','N','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.694065,-77.852222,0,'2013-07-06 12:44:31',NULL,NULL),(19361,'20052','U','G W Univ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898075,-77.043933,0,'2013-07-06 12:44:31',NULL,NULL),(51577,'59772','P','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.661420,-111.113994,0,'2013-07-06 12:44:33',NULL,NULL),(66804,'79070','S','Perryton','D','Ochiltree','48357','Texas','TX','48','0000','806','Central',-6.0,'Y',36.390481,-100.804889,0,'2013-07-06 12:44:34',NULL,NULL),(12228,'12814','S','Bolton Landing','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.589700,-73.668480,0,'2013-07-06 12:44:30',NULL,NULL),(27667,'30328','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.933854,-84.386944,0,'2013-07-06 12:44:31',NULL,NULL),(907,'00705','S','Urb Buena Vista','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(1408,'00738','S','Urb Naranjo Valley','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(74343,'92407','S','Devore Heights','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(20665,'21227','S','Arbutus','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252540,-76.696380,0,'2013-07-06 12:44:31',NULL,NULL),(11147,'11716','S','Bohemia','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.770237,-73.112442,0,'2013-07-06 12:44:30',NULL,NULL),(57621,'67133','S','Rosehill','N','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.574951,-97.131651,0,'2013-07-06 12:44:33',NULL,NULL),(67017,'79528','S','Jayton','D','Kent','48263','Texas','TX','48','0000','806','Central',-6.0,'Y',33.264461,-100.581108,0,'2013-07-06 12:44:34',NULL,NULL),(9814,'10112','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(44550,'50007','S','Alleman','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.817830,-93.610934,0,'2013-07-06 12:44:32',NULL,NULL),(1779,'00782','S','Urb Ariel','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(39278,'44481','S','Lordstown','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.241420,-80.857080,0,'2013-07-06 12:44:32',NULL,NULL),(26248,'28905','S','Marble','D','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.130869,-83.947014,0,'2013-07-06 12:44:31',NULL,NULL),(28536,'31554','S','Beach','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(32681,'36267','P','Millerville','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.159088,-85.961771,0,'2013-07-06 12:44:32',NULL,NULL),(50211,'57579','S','Cedarbutte','A','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.564463,-100.748538,0,'2013-07-06 12:44:33',NULL,NULL),(70511,'84790','S','Bloomington','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.080345,-113.575391,0,'2013-07-06 12:44:34',NULL,NULL),(79258,'98563','S','South Montesano','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(3459,'01778','S','Wayland','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.361200,-71.363880,0,'2013-07-06 12:44:30',NULL,NULL),(21150,'22119','U','Merrifield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.876851,-77.235738,0,'2013-07-06 12:44:31',NULL,NULL),(23032,'24848','P','Jenkinjones','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.292770,-81.427872,0,'2013-07-06 12:44:31',NULL,NULL),(69531,'83732','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.546838,-116.288502,0,'2013-07-06 12:44:34',NULL,NULL),(71629,'87402','S','Farmington','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.774143,-108.140409,0,'2013-07-06 12:44:34',NULL,NULL),(21038,'21869','S','Vienna','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.432760,-75.893700,0,'2013-07-06 12:44:31',NULL,NULL),(37877,'42558','P','Tateville','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.948689,-84.576670,0,'2013-07-06 12:44:32',NULL,NULL),(33675,'37733','P','Elgin','A','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.360310,-84.698278,0,'2013-07-06 12:44:32',NULL,NULL),(48530,'55749','S','Holyoke','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.472378,-92.392209,0,'2013-07-06 12:44:33',NULL,NULL),(57488,'66935','S','Belleville','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.822698,-97.630773,0,'2013-07-06 12:44:33',NULL,NULL),(67698,'80523','U','Colorado State University','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.572240,-105.086088,0,'2013-07-06 12:44:34',NULL,NULL),(15738,'16901','S','Knapp','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(27911,'30502','P','Chestnut Mountain','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.176858,-83.907840,0,'2013-07-06 12:44:31',NULL,NULL),(35330,'39428','S','McRaney','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(47366,'54620','P','Cataract','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.091177,-90.842545,0,'2013-07-06 12:44:32',NULL,NULL),(60699,'71941','S','Donaldson','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.199333,-92.931422,0,'2013-07-06 12:44:33',NULL,NULL),(68929,'82922','S','Bondurant','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.160717,-110.344275,0,'2013-07-06 12:44:34',NULL,NULL),(69271,'83436','S','Newdale','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.860779,-111.515462,0,'2013-07-06 12:44:34',NULL,NULL),(69966,'84119','S','So Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(76463,'95615','S','Sutter Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.316277,-121.553829,0,'2013-07-06 12:44:34',NULL,NULL),(6692,'06052','S','New Britain','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.657801,-72.802874,0,'2013-07-06 12:44:30',NULL,NULL),(300,'00646','S','Urb Los Montes','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(32893,'36535','S','Huggers Landing','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.398083,-87.704195,0,'2013-07-06 12:44:32',NULL,NULL),(31003,'33773','S','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.886791,-82.755307,0,'2013-07-06 12:44:32',NULL,NULL),(66052,'78376','S','Sejita','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.518196,-98.637460,0,'2013-07-06 12:44:34',NULL,NULL),(9725,'10087','U','JP Morgan Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(43482,'48608','P','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.439672,-84.029446,0,'2013-07-06 12:44:32',NULL,NULL),(42125,'47501','S','Capehart','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(54281,'62692','S','Waverly','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.591043,-89.956391,0,'2013-07-06 12:44:33',NULL,NULL),(58390,'68620','S','Boone','A','Boone','31011','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.709480,-98.002200,0,'2013-07-06 12:44:33',NULL,NULL),(63161,'75392','U','GTE','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768860,-96.824914,0,'2013-07-06 12:44:33',NULL,NULL),(45248,'50659','S','Boyd','N','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.062151,-92.314419,0,'2013-07-06 12:44:32',NULL,NULL),(41094,'46544','S','Mishawaka','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.652480,-86.158744,0,'2013-07-06 12:44:32',NULL,NULL),(31865,'35121','S','Hoods Crossroads','N','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.948154,-86.470543,0,'2013-07-06 12:44:32',NULL,NULL),(38618,'43910','S','Bloomingdale','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.340971,-80.806712,0,'2013-07-06 12:44:32',NULL,NULL),(58584,'68836','S','Elm Creek','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.718701,-99.373782,0,'2013-07-06 12:44:33',NULL,NULL),(69441,'83645','S','Midvale','D','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.389678,-116.611081,0,'2013-07-06 12:44:34',NULL,NULL),(18028,'18644','S','Pittston','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.330100,-75.853680,0,'2013-07-06 12:44:31',NULL,NULL),(17426,'17923','P','Reilly','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.674527,-76.324675,0,'2013-07-06 12:44:31',NULL,NULL),(43809,'49068','S','Marshall','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.268198,-84.942961,0,'2013-07-06 12:44:32',NULL,NULL),(42426,'47802','S','Wonder Lake','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(35584,'39573','S','Necaise','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(58519,'68780','S','Stuart','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.605196,-99.142770,0,'2013-07-06 12:44:33',NULL,NULL),(62387,'74082','P','Vera','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.451834,-95.881907,0,'2013-07-06 12:44:33',NULL,NULL),(5502,'04761','P','New Limerick','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.128321,-67.971164,0,'2013-07-06 12:44:30',NULL,NULL),(3608,'02048','S','Mansfield','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.023917,-71.218787,0,'2013-07-06 12:44:30',NULL,NULL),(15359,'16249','S','Rural Valley','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.797436,-79.320877,0,'2013-07-06 12:44:31',NULL,NULL),(55150,'63363','S','Big Springs','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.894700,-91.517100,0,'2013-07-06 12:44:33',NULL,NULL),(56638,'65610','S','Billings','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.063707,-93.556821,0,'2013-07-06 12:44:33',NULL,NULL),(58536,'68812','S','Amherst','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.872675,-99.252513,0,'2013-07-06 12:44:33',NULL,NULL),(70706,'85269','P','Fountain Hills','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.603722,-111.720365,0,'2013-07-06 12:44:34',NULL,NULL),(7011,'06259','S','Pomfret Ctr','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.876521,-72.011578,0,'2013-07-06 12:44:30',NULL,NULL),(54103,'62539','S','Illiopolis','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.854937,-89.246577,0,'2013-07-06 12:44:33',NULL,NULL),(70195,'84337','S','Tremonton','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.676420,-112.267800,0,'2013-07-06 12:44:34',NULL,NULL),(72110,'88242','S','Hobbs','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.813605,-103.145549,0,'2013-07-06 12:44:34',NULL,NULL),(20610,'21208','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.377640,-76.705980,0,'2013-07-06 12:44:31',NULL,NULL),(5747,'05035','S','West Bridgewater','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(73087,'90221','S','Compton','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.879540,-118.200540,0,'2013-07-06 12:44:34',NULL,NULL),(77300,'96667','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(3788,'02210','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.345728,-71.042554,0,'2013-07-06 12:44:30',NULL,NULL),(10946,'11436','S','S Ozone Pk','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678055,-73.797848,0,'2013-07-06 12:44:30',NULL,NULL),(32251,'35614','S','Athens','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.782615,-87.076620,0,'2013-07-06 12:44:32',NULL,NULL),(27549,'30250','P','Lovejoy','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.441429,-84.317728,0,'2013-07-06 12:44:31',NULL,NULL),(3092,'01223','S','Becket','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.381306,-73.143709,0,'2013-07-06 12:44:30',NULL,NULL),(60736,'71961','S','Whitetown','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.604027,-93.831820,0,'2013-07-06 12:44:33',NULL,NULL),(60858,'72051','S','Fox','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.762178,-92.304721,0,'2013-07-06 12:44:33',NULL,NULL),(37350,'41719','S','Bonnyman','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.309817,-83.218287,0,'2013-07-06 12:44:32',NULL,NULL),(9118,'09131','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(25122,'28001','S','North Albemarle','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(54548,'62887','S','Springerton','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.164229,-88.374663,0,'2013-07-06 12:44:33',NULL,NULL),(65829,'78150','S','Randolph Air Force Base','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(4918,'04074','S','Pine Point','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.584960,-70.370640,0,'2013-07-06 12:44:30',NULL,NULL),(52960,'61421','S','Lombardville','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.177575,-89.653011,0,'2013-07-06 12:44:33',NULL,NULL),(8120,'07825','S','Johnsonburg','A','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.982604,-74.950757,0,'2013-07-06 12:44:30',NULL,NULL),(6491,'05773','S','Wallingford','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.463580,-72.990360,0,'2013-07-06 12:44:30',NULL,NULL),(36954,'41171','S','Burke','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(45279,'50677','S','Bremer','A','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.716220,-92.425620,0,'2013-07-06 12:44:32',NULL,NULL),(24992,'27863','S','Pikeville','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.492476,-77.983300,0,'2013-07-06 12:44:31',NULL,NULL),(6803,'06109','S','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(4281,'02892','S','West Kingston','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.502011,-71.593784,0,'2013-07-06 12:44:30',NULL,NULL),(39928,'45224','S','College Hl','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.201250,-84.531566,0,'2013-07-06 12:44:32',NULL,NULL),(9280,'09627','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(49861,'57248','S','Lake Norden','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.581820,-97.211073,0,'2013-07-06 12:44:33',NULL,NULL),(50856,'58495','S','Wishek','D','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.255140,-99.554676,0,'2013-07-06 12:44:33',NULL,NULL),(52656,'61065','S','Candlewick Lake','N','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.380237,-88.844362,0,'2013-07-06 12:44:33',NULL,NULL),(61104,'72140','S','Saint Charles','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.337740,-91.181444,0,'2013-07-06 12:44:33',NULL,NULL),(18163,'18901','S','New Britain','A','Bucks','42017','Pennsylvania','PA','42','6160','215','Eastern',-5.0,'Y',40.332324,-75.116759,0,'2013-07-06 12:44:31',NULL,NULL),(43739,'48980','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.671821,-84.675469,0,'2013-07-06 12:44:32',NULL,NULL),(24800,'27592','S','Willow Spring','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.568335,-78.706810,0,'2013-07-06 12:44:31',NULL,NULL),(54064,'62479','S','Wheeler','D','Jasper','17079','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.018789,-88.311313,0,'2013-07-06 12:44:33',NULL,NULL),(15354,'16244','P','Nu Mine','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.800793,-79.272037,0,'2013-07-06 12:44:31',NULL,NULL),(29518,'32776','S','Mt Plymouth','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.804779,-81.535369,0,'2013-07-06 12:44:32',NULL,NULL),(48738,'55965','S','Greenleafton','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667591,-92.079343,0,'2013-07-06 12:44:33',NULL,NULL),(49995,'57370','S','Pukwana','D','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.777669,-99.173379,0,'2013-07-06 12:44:33',NULL,NULL),(77039,'96107','S','Coleville','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.478060,-119.477040,0,'2013-07-06 12:44:34',NULL,NULL),(33882,'38025','P','Dyersburg','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.036078,-89.383313,0,'2013-07-06 12:44:32',NULL,NULL),(50646,'58316','S','Belcourt','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.664977,-99.841349,0,'2013-07-06 12:44:33',NULL,NULL),(50693,'58355','S','Nekoma','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.578015,-98.368658,0,'2013-07-06 12:44:33',NULL,NULL),(55918,'64455','S','Graham','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.204423,-95.043228,0,'2013-07-06 12:44:33',NULL,NULL),(71318,'86505','S','Klagetoh','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(8241,'08003','S','Cherry Hill Township','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.881958,-74.970489,0,'2013-07-06 12:44:30',NULL,NULL),(40136,'45338','S','Lewisburg','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.845072,-84.542576,0,'2013-07-06 12:44:32',NULL,NULL),(36901,'41124','S','Blaine','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.035564,-82.858564,0,'2013-07-06 12:44:32',NULL,NULL),(46932,'54156','S','Pembine','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.610380,-87.944100,0,'2013-07-06 12:44:32',NULL,NULL),(68965,'83012','S','Moose','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.602951,-110.740568,0,'2013-07-06 12:44:34',NULL,NULL),(10722,'11251','U','Brooklyn Navy Yard','N','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702428,-73.967410,0,'2013-07-06 12:44:30',NULL,NULL),(23056,'24868','S','Worth','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(50017,'57399','U','Dakota Central Mpc','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.363185,-98.218918,0,'2013-07-06 12:44:33',NULL,NULL),(52387,'60629','S','Chicago Lawn','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.777493,-87.709271,0,'2013-07-06 12:44:33',NULL,NULL),(60001,'71333','S','Evergreen','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.946851,-92.094994,0,'2013-07-06 12:44:33',NULL,NULL),(76381,'95526','S','Mad River','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.467480,-123.693420,0,'2013-07-06 12:44:34',NULL,NULL),(77321,'96704','S','Ocean View','A','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.415684,-155.876176,0,'2013-07-06 12:44:34',NULL,NULL),(34287,'38487','S','Williamsport','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.646374,-87.234310,0,'2013-07-06 12:44:32',NULL,NULL),(27950,'30540','S','Ellijay','D','Gilmer','13123','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.685591,-84.485193,0,'2013-07-06 12:44:31',NULL,NULL),(12642,'13108','S','Martisco','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.970080,-76.324080,0,'2013-07-06 12:44:30',NULL,NULL),(1284,'00730','S','Sect Clausell','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(51651,'59873','S','Thompson Falls','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.621869,-115.341150,0,'2013-07-06 12:44:33',NULL,NULL),(53763,'62265','S','New Baden','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.497891,-89.664427,0,'2013-07-06 12:44:33',NULL,NULL),(42723,'48005','S','Armada Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.847253,-82.919999,0,'2013-07-06 12:44:32',NULL,NULL),(39644,'44905','S','East Mansfield','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.775298,-82.476807,0,'2013-07-06 12:44:32',NULL,NULL),(48685,'55927','S','Dodge Center','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.033819,-92.866730,0,'2013-07-06 12:44:33',NULL,NULL),(60886,'72066','P','Hickory Plns','A','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.976537,-91.747656,0,'2013-07-06 12:44:33',NULL,NULL),(70642,'85145','S','Red Rock','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.559128,-111.367378,0,'2013-07-06 12:44:34',NULL,NULL),(71219,'86323','S','Chino Valley','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.770256,-112.472328,0,'2013-07-06 12:44:34',NULL,NULL),(74818,'93221','S','Exeter','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.299541,-119.126188,0,'2013-07-06 12:44:34',NULL,NULL),(75393,'93962','P','Salinas','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.677778,-121.654444,0,'2013-07-06 12:44:34',NULL,NULL),(77287,'96624','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(68982,'83116','P','Diamondville','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.778944,-110.537592,0,'2013-07-06 12:44:34',NULL,NULL),(71211,'86313','P','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.537042,-112.469214,0,'2013-07-06 12:44:34',NULL,NULL),(73721,'91616','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.184197,-118.396049,0,'2013-07-06 12:44:34',NULL,NULL),(10988,'11548','S','E Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(20926,'21746','U','Md Correctional System','N','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.564137,-77.718312,0,'2013-07-06 12:44:31',NULL,NULL),(24595,'27326','S','Casville','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(47915,'55110','S','Vadnais Heights','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(55452,'63730','S','Greenbrier','N','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.094820,-89.910060,0,'2013-07-06 12:44:33',NULL,NULL),(61094,'72134','S','Roe','D','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.603333,-91.341667,0,'2013-07-06 12:44:33',NULL,NULL),(68810,'82435','S','Mantua','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(65090,'77356','S','Montgomery','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.457345,-95.673436,0,'2013-07-06 12:44:34',NULL,NULL),(77316,'96687','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(22859,'24543','P','Danville','D','Danville City','51590','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.584238,-79.513765,0,'2013-07-06 12:44:31',NULL,NULL),(27803,'30396','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647672,-84.393744,0,'2013-07-06 12:44:31',NULL,NULL),(51722,'60010','S','North Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(18456,'19079','S','Sharon Hill','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.902980,-75.269580,0,'2013-07-06 12:44:31',NULL,NULL),(14669,'15240','P','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445977,-79.962428,0,'2013-07-06 12:44:31',NULL,NULL),(34415,'38633','S','Pinegrove','N','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.638021,-89.177255,0,'2013-07-06 12:44:32',NULL,NULL),(49674,'57012','S','Rumpus Ridge','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.596280,-97.293355,0,'2013-07-06 12:44:33',NULL,NULL),(51795,'60046','S','Old Mill Crk','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(63197,'75432','S','Cooper','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.370458,-95.689502,0,'2013-07-06 12:44:33',NULL,NULL),(67132,'79756','S','Monahans','D','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.581630,-102.896507,0,'2013-07-06 12:44:34',NULL,NULL),(74410,'92539','S','Anza','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.588602,-116.742955,0,'2013-07-06 12:44:34',NULL,NULL),(42917,'48109','S','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.289849,-83.715145,0,'2013-07-06 12:44:32',NULL,NULL),(15811,'16928','S','Deerfield','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.954882,-77.440143,0,'2013-07-06 12:44:31',NULL,NULL),(14205,'14777','S','Rushford','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.387916,-78.242115,0,'2013-07-06 12:44:31',NULL,NULL),(53360,'61764','S','Rugby','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(61939,'73159','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.390690,-97.553870,0,'2013-07-06 12:44:33',NULL,NULL),(64781,'77005','S','West University Place','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.718966,-95.421416,0,'2013-07-06 12:44:34',NULL,NULL),(364,'00659','S','Sect Aviles','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(59643,'71040','S','Arizona','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.787891,-93.059930,0,'2013-07-06 12:44:33',NULL,NULL),(68101,'80944','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832646,-104.822595,0,'2013-07-06 12:44:34',NULL,NULL),(73638,'91426','P','Encino','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.155006,-118.515946,0,'2013-07-06 12:44:34',NULL,NULL),(78129,'97528','P','Grants Pass','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.439686,-123.324718,0,'2013-07-06 12:44:34',NULL,NULL),(7545,'07011','S','Clifton','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.877054,-74.145198,0,'2013-07-06 12:44:30',NULL,NULL),(24000,'26347','S','Astor','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.269476,-80.125327,0,'2013-07-06 12:44:31',NULL,NULL),(59130,'70162','U','First Natl Bank Commerce','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.958855,-90.074910,0,'2013-07-06 12:44:33',NULL,NULL),(13620,'13865','S','Windsor','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.064020,-75.640380,0,'2013-07-06 12:44:31',NULL,NULL),(1388,'00738','S','Jard De Monte Brisas','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(30795,'33605','S','Ybor City','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.962333,-82.428868,0,'2013-07-06 12:44:32',NULL,NULL),(57125,'66224','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(71195,'86047','S','Winslow','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.275380,-110.315820,0,'2013-07-06 12:44:34',NULL,NULL),(79817,'99505','S','Ft Richardson','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.255993,-149.689138,0,'2013-07-06 12:44:34',NULL,NULL),(13136,'13494','S','Woodgate','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.540179,-75.120878,0,'2013-07-06 12:44:30',NULL,NULL),(5184,'04442','S','Greenville Junction','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.460833,-69.616667,0,'2013-07-06 12:44:30',NULL,NULL),(26059,'28692','S','Sherwood','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273369,-81.786913,0,'2013-07-06 12:44:31',NULL,NULL),(39260,'44446','S','Niles','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.184692,-80.748967,0,'2013-07-06 12:44:32',NULL,NULL),(38255,'43287','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.961425,-82.999386,0,'2013-07-06 12:44:32',NULL,NULL),(63790,'75956','S','Roganville','A','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(67249,'79948','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761851,-106.479879,0,'2013-07-06 12:44:34',NULL,NULL),(78101,'97489','S','Walterville','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.126309,-122.633452,0,'2013-07-06 12:44:34',NULL,NULL),(58695,'68927','S','Westside','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.526584,-99.632651,0,'2013-07-06 12:44:33',NULL,NULL),(55709,'64068','S','Pleasant Valley','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.276480,-94.423260,0,'2013-07-06 12:44:33',NULL,NULL),(33496,'37353','S','Mc Donald','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.076691,-85.010002,0,'2013-07-06 12:44:32',NULL,NULL),(12163,'12749','P','Kauneonga Lk','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.690769,-74.844513,0,'2013-07-06 12:44:30',NULL,NULL),(55147,'63361','S','Montgomery Cy','A','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(63497,'75705','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.361239,-95.084145,0,'2013-07-06 12:44:33',NULL,NULL),(73525,'91346','P','San Fernando','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.267980,-118.466280,0,'2013-07-06 12:44:34',NULL,NULL),(4769,'03859','P','Newton Jct','A','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.867214,-71.065993,0,'2013-07-06 12:44:30',NULL,NULL),(26174,'28749','P','Ltl Switzrlnd','A','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.847794,-82.097662,0,'2013-07-06 12:44:31',NULL,NULL),(75172,'93602','S','Auberry','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.074481,-119.455209,0,'2013-07-06 12:44:34',NULL,NULL),(17411,'17921','S','Ashland','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(36137,'40228','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.139470,-85.630403,0,'2013-07-06 12:44:32',NULL,NULL),(47945,'55117','S','Maplewood','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.000144,-93.083067,0,'2013-07-06 12:44:33',NULL,NULL),(57316,'66699','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.053504,-95.673075,0,'2013-07-06 12:44:33',NULL,NULL),(69215,'83401','S','Beachs Corner','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(44530,'49961','P','Sidnaw','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.505314,-88.731360,0,'2013-07-06 12:44:32',NULL,NULL),(4498,'03284','S','W Springfield','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.486437,-72.056353,0,'2013-07-06 12:44:30',NULL,NULL),(35750,'39730','S','Wren','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(72215,'88424','S','Sofia','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.737332,-103.457179,0,'2013-07-06 12:44:34',NULL,NULL),(74642,'92817','P','Anaheim Hills','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.851223,-117.791464,0,'2013-07-06 12:44:34',NULL,NULL),(45630,'51636','S','Coin','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.658476,-95.234115,0,'2013-07-06 12:44:32',NULL,NULL),(25370,'28247','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.105930,-80.822517,0,'2013-07-06 12:44:31',NULL,NULL),(67800,'80735','S','Hale','A','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.719760,-102.254640,0,'2013-07-06 12:44:34',NULL,NULL),(76272,'95420','S','Caspar','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.366694,-123.810276,0,'2013-07-06 12:44:34',NULL,NULL),(19390,'20068','U','Pepco','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901054,-77.046743,0,'2013-07-06 12:44:31',NULL,NULL),(11028,'11565','S','Malverne','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.678396,-73.671004,0,'2013-07-06 12:44:30',NULL,NULL),(40869,'46235','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.768333,-86.158056,0,'2013-07-06 12:44:32',NULL,NULL),(59253,'70444','S','Kentwood','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.936684,-90.517939,0,'2013-07-06 12:44:33',NULL,NULL),(63075,'75242','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.775963,-96.803741,0,'2013-07-06 12:44:33',NULL,NULL),(70821,'85383','S','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.658608,-112.247236,0,'2013-07-06 12:44:34',NULL,NULL),(75238,'93650','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.838859,-119.800966,0,'2013-07-06 12:44:34',NULL,NULL),(37857,'42503','S','Somerset','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.084666,-84.611545,0,'2013-07-06 12:44:32',NULL,NULL),(33224,'37062','S','Fairview','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.970047,-87.127121,0,'2013-07-06 12:44:32',NULL,NULL),(26015,'28677','S','Charles','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(56218,'65037','S','Gravois Mills','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.201920,-92.837190,0,'2013-07-06 12:44:33',NULL,NULL),(74772,'93108','S','Montecito','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.433903,-119.629863,0,'2013-07-06 12:44:34',NULL,NULL),(21578,'22835','S','Shenandoah National Park','N','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.665612,-78.456879,0,'2013-07-06 12:44:31',NULL,NULL),(1151,'00727','S','Mans De Ciudad Jardin Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(38002,'42764','S','Mount Sherman','D','Larue','21123','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.417506,-85.632078,0,'2013-07-06 12:44:32',NULL,NULL),(21179,'22160','U','National Right to Work Comm','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.811286,-77.221189,0,'2013-07-06 12:44:31',NULL,NULL),(30464,'33337','U','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110891,-80.274099,0,'2013-07-06 12:44:32',NULL,NULL),(6914,'06153','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688148,-72.728859,0,'2013-07-06 12:44:30',NULL,NULL),(49172,'56401','S','Baxter','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341720,-94.142280,0,'2013-07-06 12:44:33',NULL,NULL),(424,'00662','S','Sect California','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(29299,'32513','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.460225,-87.215056,0,'2013-07-06 12:44:32',NULL,NULL),(50729,'58382','S','Webster','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.329263,-98.875167,0,'2013-07-06 12:44:33',NULL,NULL),(20242,'20781','S','Edmonston','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(42556,'47872','S','Nyesville','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(40074,'45277','U','Fidelity Investments','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.028390,-84.519831,0,'2013-07-06 12:44:32',NULL,NULL),(4329,'02919','S','Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.820830,-71.505188,0,'2013-07-06 12:44:30',NULL,NULL),(56296,'65082','S','Tuscumbia','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.238110,-92.482845,0,'2013-07-06 12:44:33',NULL,NULL),(56504,'65344','S','Miami','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.321331,-93.226168,0,'2013-07-06 12:44:33',NULL,NULL),(63396,'75645','S','Gilmer','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.721056,-94.930677,0,'2013-07-06 12:44:33',NULL,NULL),(72307,'88588','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768459,-106.427740,0,'2013-07-06 12:44:34',NULL,NULL),(77716,'97058','S','The Dalles','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.598999,-121.193323,0,'2013-07-06 12:44:34',NULL,NULL),(4989,'04123','U','Union Mutual Life Ins','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.659527,-70.306000,0,'2013-07-06 12:44:30',NULL,NULL),(8801,'08606','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220185,-74.576017,0,'2013-07-06 12:44:30',NULL,NULL),(462,'00662','S','VISTAS del Atlantico','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(46743,'53920','S','Briggsville','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.662100,-89.616601,0,'2013-07-06 12:44:32',NULL,NULL),(50300,'57702','S','Pactola Lake','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.063037,-103.280916,0,'2013-07-06 12:44:33',NULL,NULL),(76853,'95965','S','Robinsons Corner','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(22059,'23326','U','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.763676,-76.252135,0,'2013-07-06 12:44:31',NULL,NULL),(45427,'51062','S','Adaville','N','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.710245,-96.486217,0,'2013-07-06 12:44:32',NULL,NULL),(29618,'32861','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.516161,-81.444050,0,'2013-07-06 12:44:32',NULL,NULL),(24505,'27278','S','Hillsboro','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.074580,-79.077660,0,'2013-07-06 12:44:31',NULL,NULL),(41241,'46742','S','Alvarado','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(38415,'43542','S','Monclova','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.571329,-83.764702,0,'2013-07-06 12:44:32',NULL,NULL),(24442,'27212','S','Blanche','N','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.529874,-79.302902,0,'2013-07-06 12:44:31',NULL,NULL),(35398,'39460','P','Moss','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.815040,-89.177480,0,'2013-07-06 12:44:32',NULL,NULL),(53132,'61548','S','Partridge','N','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.788480,-89.427180,0,'2013-07-06 12:44:33',NULL,NULL),(5486,'04746','S','Lille','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.296352,-68.162290,0,'2013-07-06 12:44:30',NULL,NULL),(42068,'47452','S','Orangeville','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(49462,'56651','S','Lengby','D','Mahnomen','27087','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.544425,-95.618999,0,'2013-07-06 12:44:33',NULL,NULL),(49857,'57246','S','Labolt','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.026627,-96.698717,0,'2013-07-06 12:44:33',NULL,NULL),(62343,'74056','S','Nelagony','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.823412,-96.367170,0,'2013-07-06 12:44:33',NULL,NULL),(4913,'04070','P','West Scarborough','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.570278,-70.388333,0,'2013-07-06 12:44:30',NULL,NULL),(11073,'11596','S','Williston Pk','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757885,-73.644633,0,'2013-07-06 12:44:30',NULL,NULL),(1381,'00738','S','Bo Jerusalem','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(45173,'50602','S','Allison','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.758290,-92.799014,0,'2013-07-06 12:44:32',NULL,NULL),(36587,'40962','S','Fogertown','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(71310,'86503','S','Tsail','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(73200,'90601','S','Pico Rivera','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',34.005998,-118.032175,0,'2013-07-06 12:44:34',NULL,NULL),(20446,'21010','S','Edgewood Arsenal','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404700,-76.288320,0,'2013-07-06 12:44:31',NULL,NULL),(50941,'58575','S','Turtle Lk','N','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.518146,-100.890776,0,'2013-07-06 12:44:33',NULL,NULL),(77567,'96910','S','Maite','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(6362,'05676','S','Bolton','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.345220,-72.785100,0,'2013-07-06 12:44:30',NULL,NULL),(25115,'27982','P','Waves','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.553565,-75.465694,0,'2013-07-06 12:44:31',NULL,NULL),(15474,'16430','S','N Springfield','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.999861,-80.428728,0,'2013-07-06 12:44:31',NULL,NULL),(25697,'28531','S','Harkers Is','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.726336,-76.570940,0,'2013-07-06 12:44:31',NULL,NULL),(11052,'11576','S','East Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.774722,-73.656111,0,'2013-07-06 12:44:30',NULL,NULL),(9979,'10163','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755007,-73.967791,0,'2013-07-06 12:44:30',NULL,NULL),(28838,'32085','P','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.886854,-81.343718,0,'2013-07-06 12:44:32',NULL,NULL),(61007,'72114','S','N L R','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(78145,'97543','S','Wilderville','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.439167,-123.327222,0,'2013-07-06 12:44:34',NULL,NULL),(35693,'39663','S','Arm','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.577100,-90.022800,0,'2013-07-06 12:44:32',NULL,NULL),(38400,'43528','S','Holland','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.619650,-83.726811,0,'2013-07-06 12:44:32',NULL,NULL),(53371,'61774','S','Stanford','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.435071,-89.223520,0,'2013-07-06 12:44:33',NULL,NULL),(68508,'81325','S','Egnar','D','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.910000,-108.930000,0,'2013-07-06 12:44:34',NULL,NULL),(17406,'17901','S','Pottsville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(69708,'84034','S','Ibapah','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.037817,-113.985828,0,'2013-07-06 12:44:34',NULL,NULL),(18649,'19171','U','Wachovia Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955628,-75.155260,0,'2013-07-06 12:44:31',NULL,NULL),(55858,'64171','P','Ks City','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.050940,-94.588104,0,'2013-07-06 12:44:33',NULL,NULL),(68050,'80931','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.752720,-104.731586,0,'2013-07-06 12:44:34',NULL,NULL),(69209,'83352','S','West Magic','A','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.939059,-114.405702,0,'2013-07-06 12:44:34',NULL,NULL),(76497,'95634','S','Wentworth Springs','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917770,-120.790653,0,'2013-07-06 12:44:34',NULL,NULL),(35024,'39157','S','Ridgeland','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.419743,-90.125726,0,'2013-07-06 12:44:32',NULL,NULL),(33554,'37404','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.027912,-85.272196,0,'2013-07-06 12:44:32',NULL,NULL),(77422,'96801','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.325480,-157.831334,0,'2013-07-06 12:44:34',NULL,NULL),(78878,'98355','S','Mineral','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.715218,-122.184152,0,'2013-07-06 12:44:34',NULL,NULL),(8562,'08210','S','Clermont','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(28030,'30639','P','Franklin Springs','D','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.274158,-83.172001,0,'2013-07-06 12:44:31',NULL,NULL),(7866,'07503','S','South Paterson','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.897944,-74.156957,0,'2013-07-06 12:44:30',NULL,NULL),(29567,'32815','P','Orlando','D','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.592290,-80.656063,0,'2013-07-06 12:44:32',NULL,NULL),(4983,'04116','P','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.659977,-70.267197,0,'2013-07-06 12:44:30',NULL,NULL),(68935,'82930','S','Evanston','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.249255,-110.959297,0,'2013-07-06 12:44:34',NULL,NULL),(40330,'45501','P','Spfld','N','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.925818,-83.854004,0,'2013-07-06 12:44:32',NULL,NULL),(17144,'17801','S','Mile Hill','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(16862,'17564','P','Penryn','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162890,-76.367850,0,'2013-07-06 12:44:31',NULL,NULL),(16867,'17565','S','Mount Nebo','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(2798,'00976','S','Urb Lantigua','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(47052,'54414','S','Birnamwood','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.932433,-89.211831,0,'2013-07-06 12:44:32',NULL,NULL),(54121,'62551','S','Niantic','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.852509,-89.167148,0,'2013-07-06 12:44:33',NULL,NULL),(64691,'76844','S','Caradan','N','Mills','48333','Texas','TX','48','0000','325','Central',-6.0,'Y',31.438800,-98.575140,0,'2013-07-06 12:44:34',NULL,NULL),(72521,'89159','U','Shared Firm Zip Code','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.069731,-115.143235,0,'2013-07-06 12:44:34',NULL,NULL),(77373,'96751','P','Kealia','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.107201,-159.308621,0,'2013-07-06 12:44:34',NULL,NULL),(38669,'43950','S','St Clairsvle','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.082971,-80.912626,0,'2013-07-06 12:44:32',NULL,NULL),(22346,'23882','S','Stony Creek','D','Sussex','51183','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.938046,-77.427530,0,'2013-07-06 12:44:31',NULL,NULL),(16779,'17528','P','Goodville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.125083,-76.006228,0,'2013-07-06 12:44:31',NULL,NULL),(3787,'02206','U','State Street Corporation','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344450,-71.042166,0,'2013-07-06 12:44:30',NULL,NULL),(16422,'17225','S','Worleytown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(68724,'82082','S','Pine Bluffs','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.188380,-104.076480,0,'2013-07-06 12:44:34',NULL,NULL),(21730,'23014','S','Beaumont','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.677729,-77.895170,0,'2013-07-06 12:44:31',NULL,NULL),(18608,'19144','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.031925,-75.173958,0,'2013-07-06 12:44:31',NULL,NULL),(45662,'52031','S','Bellevue','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.259183,-90.429039,0,'2013-07-06 12:44:32',NULL,NULL),(43933,'49277','S','Rives Junction','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.388466,-84.466414,0,'2013-07-06 12:44:32',NULL,NULL),(9145,'09265','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(46374,'53128','S','Genoa City','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.536232,-88.294642,0,'2013-07-06 12:44:32',NULL,NULL),(10649,'11102','S','Long Island City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770391,-73.923967,0,'2013-07-06 12:44:30',NULL,NULL),(3464,'01805','U','Lahey Clinic Med Ctr','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.506346,-71.198244,0,'2013-07-06 12:44:30',NULL,NULL),(15369,'16261','S','Widnoon','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.964275,-79.469826,0,'2013-07-06 12:44:31',NULL,NULL),(26800,'29464','S','Mount Pleasant','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.820260,-79.846061,0,'2013-07-06 12:44:31',NULL,NULL),(25987,'28665','S','Walsh','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.221121,-81.387906,0,'2013-07-06 12:44:31',NULL,NULL),(25657,'28479','S','Winnabow','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.205993,-78.105518,0,'2013-07-06 12:44:31',NULL,NULL),(71816,'87571','S','Taos Pueblo','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(11002,'11553','S','Mitchell Field','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.703352,-73.590714,0,'2013-07-06 12:44:30',NULL,NULL),(21142,'22107','U','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.933696,-77.179240,0,'2013-07-06 12:44:31',NULL,NULL),(15523,'16541','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.124753,-80.089452,0,'2013-07-06 12:44:31',NULL,NULL),(40819,'46205','S','Uptown','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.827486,-86.133117,0,'2013-07-06 12:44:32',NULL,NULL),(37161,'41472','S','Caney','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(28785,'32042','P','Graham','D','Bradford','12007','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.966711,-82.122266,0,'2013-07-06 12:44:32',NULL,NULL),(50290,'57658','S','Standing Rock','N','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.786177,-100.514830,0,'2013-07-06 12:44:33',NULL,NULL),(70745,'85312','P','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.623634,-112.180873,0,'2013-07-06 12:44:34',NULL,NULL),(75059,'93523','S','North Edwards','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.950022,-117.901246,0,'2013-07-06 12:44:34',NULL,NULL),(27317,'30025','S','Social Circle','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.654242,-83.686948,0,'2013-07-06 12:44:31',NULL,NULL),(51938,'60124','S','Plato Center','A','Kane','17089','Illinois','IL','17','1600','847','Central',-6.0,'Y',42.040262,-88.310402,0,'2013-07-06 12:44:33',NULL,NULL),(65506,'77665','S','Winnie','D','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.797771,-94.351190,0,'2013-07-06 12:44:34',NULL,NULL),(2220,'00926','S','Urb Crown Hls','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(5355,'04617','S','Brooksville','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.370771,-68.732922,0,'2013-07-06 12:44:30',NULL,NULL),(48392,'55580','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.280616,-93.807588,0,'2013-07-06 12:44:33',NULL,NULL),(49166,'56396','U','Fingerhut (Pre Paid)','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.568127,-94.214279,0,'2013-07-06 12:44:33',NULL,NULL),(53548,'62040','S','Pontoon Beach','A','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.761356,-90.096335,0,'2013-07-06 12:44:33',NULL,NULL),(62703,'74740','S','Tom','A','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.845727,-94.648373,0,'2013-07-06 12:44:33',NULL,NULL),(63385,'75644','S','New Mountain','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(23288,'25168','S','Red House','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.558202,-81.895822,0,'2013-07-06 12:44:31',NULL,NULL),(39577,'44855','S','North Fairfield','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.103830,-82.597828,0,'2013-07-06 12:44:32',NULL,NULL),(19513,'20176','S','Lansdowne','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.201977,-77.535473,0,'2013-07-06 12:44:31',NULL,NULL),(54963,'63121','S','Bellerive','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(6562,'05849','P','Lyndon','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.532888,-72.000285,0,'2013-07-06 12:44:30',NULL,NULL),(28272,'31083','P','Scotland','D','Telfair','13271','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.982026,-82.870144,0,'2013-07-06 12:44:31',NULL,NULL),(57062,'66213','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(65228,'77447','S','Hockley Mine','N','Harris','48201','Texas','TX','48','3360','936','Central',-6.0,'Y',30.028362,-95.819420,0,'2013-07-06 12:44:34',NULL,NULL),(18065,'18704','S','Edwardsville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(43015,'48164','S','New Boston','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(17620,'18045','S','Tatamy Borough','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(6064,'05444','S','Cambridgeboro','N','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(34852,'38925','S','Alva','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.633238,-89.715693,0,'2013-07-06 12:44:32',NULL,NULL),(28141,'30820','S','Shoals','N','Glascock','13125','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.187247,-82.669971,0,'2013-07-06 12:44:31',NULL,NULL),(65149,'77389','S','Klein','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.047500,-95.532222,0,'2013-07-06 12:44:34',NULL,NULL),(36433,'40583','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.136537,-84.473757,0,'2013-07-06 12:44:32',NULL,NULL),(10734,'11355','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.754005,-73.821132,0,'2013-07-06 12:44:30',NULL,NULL),(48163,'55375','S','Bible College','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.904785,-93.749054,0,'2013-07-06 12:44:33',NULL,NULL),(49566,'56721','S','E Grand Forks','A','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.929448,-97.017008,0,'2013-07-06 12:44:33',NULL,NULL),(22842,'24526','S','Snowden','N','Bedford','51019','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.533900,-79.385220,0,'2013-07-06 12:44:31',NULL,NULL),(36633,'41004','S','Cumminsville','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(7107,'06371','S','North Lyme','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.328807,-72.309397,0,'2013-07-06 12:44:30',NULL,NULL),(51908,'60105','U','Bensenville','D','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.956863,-87.941819,0,'2013-07-06 12:44:33',NULL,NULL),(10689,'11214','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.598480,-73.996892,0,'2013-07-06 12:44:30',NULL,NULL),(6575,'05855','S','Newport','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(42055,'47448','S','Belmont','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(40577,'45871','S','New Knoxville','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.495497,-84.302052,0,'2013-07-06 12:44:32',NULL,NULL),(32452,'36023','P','East Tallassee','D','Tallapoosa','01123','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.609580,-85.810369,0,'2013-07-06 12:44:32',NULL,NULL),(27032,'29654','S','Honea Path','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.446826,-82.404793,0,'2013-07-06 12:44:31',NULL,NULL),(57900,'67645','S','New Almelo','A','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610537,-100.001449,0,'2013-07-06 12:44:33',NULL,NULL),(61568,'72730','S','Fayetteville','A','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.043692,-94.238565,0,'2013-07-06 12:44:33',NULL,NULL),(61640,'72845','S','Knoxville','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.369083,-93.364086,0,'2013-07-06 12:44:33',NULL,NULL),(43174,'48277','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.325731,-83.056878,0,'2013-07-06 12:44:32',NULL,NULL),(8486,'08093','S','Westville Grove','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.859740,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(34875,'38941','S','Mississippi Valley State Col','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(33979,'38112','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145279,-89.979378,0,'2013-07-06 12:44:32',NULL,NULL),(5791,'05059','P','Quechee','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.656557,-72.427413,0,'2013-07-06 12:44:30',NULL,NULL),(72075,'88130','S','Portales','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.154940,-103.335720,0,'2013-07-06 12:44:34',NULL,NULL),(9210,'09502','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(34901,'38954','S','Roebuck','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.461906,-90.211639,0,'2013-07-06 12:44:32',NULL,NULL),(13123,'13491','S','Millers Mills','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(23187,'25045','S','Quick','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.460480,-81.335520,0,'2013-07-06 12:44:31',NULL,NULL),(44807,'50236','S','Roland','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.165862,-93.499209,0,'2013-07-06 12:44:32',NULL,NULL),(13144,'13505','P','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.100405,-75.230473,0,'2013-07-06 12:44:30',NULL,NULL),(7779,'07421','S','Hewitt','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.157420,-74.352660,0,'2013-07-06 12:44:30',NULL,NULL),(67366,'80112','S','Lone Tree','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.575499,-104.861971,0,'2013-07-06 12:44:34',NULL,NULL),(69901,'84106','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(41239,'46740','S','Geneva','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.595413,-84.959127,0,'2013-07-06 12:44:32',NULL,NULL),(38743,'44030','S','Kelloggsville','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(35421,'39470','S','Fords Creek','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(31781,'35022','S','Bessemer','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.342582,-86.962361,0,'2013-07-06 12:44:32',NULL,NULL),(1806,'00784','S','Bda Marin','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(68946,'82937','S','Urie','A','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.317669,-110.299141,0,'2013-07-06 12:44:34',NULL,NULL),(70922,'85634','S','Cowlic','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(12417,'12942','S','Keene','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.257018,-73.784256,0,'2013-07-06 12:44:30',NULL,NULL),(19312,'20012','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.973853,-77.030348,0,'2013-07-06 12:44:31',NULL,NULL),(14782,'15352','S','Pine Bank','A','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.757908,-80.461303,0,'2013-07-06 12:44:31',NULL,NULL),(58882,'69162','S','Colton','N','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.131320,-103.031580,0,'2013-07-06 12:44:33',NULL,NULL),(63126,'75326','U','Wells Fargo Bank','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.867626,-96.982402,0,'2013-07-06 12:44:33',NULL,NULL),(18376,'19046','S','Jenkintown','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(1148,'00727','S','Hacienda San Jose','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(30950,'33731','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.708024,-82.676949,0,'2013-07-06 12:44:32',NULL,NULL),(11260,'11768','S','Crab Meadow','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(18256,'19002','S','Prospectville','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.190760,-75.206580,0,'2013-07-06 12:44:31',NULL,NULL),(16963,'17702','S','Sylvan Dell','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(47754,'55025','S','Columbus','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.277195,-92.990033,0,'2013-07-06 12:44:33',NULL,NULL),(58809,'69025','S','Curtis','D','Frontier','31063','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.632762,-100.512458,0,'2013-07-06 12:44:33',NULL,NULL),(74188,'92278','S','Twentynin Plm','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.273320,-116.102460,0,'2013-07-06 12:44:34',NULL,NULL),(78288,'97876','S','Summerville','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.513390,-118.018653,0,'2013-07-06 12:44:34',NULL,NULL),(55826,'64151','S','Platte Woods','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(49805,'57198','U','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.733737,-96.628269,0,'2013-07-06 12:44:33',NULL,NULL),(10280,'10514','S','Chappaqua','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.173209,-73.769220,0,'2013-07-06 12:44:30',NULL,NULL),(33880,'38023','S','Drummonds','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.468977,-89.955354,0,'2013-07-06 12:44:32',NULL,NULL),(692,'00685','S','Jard Guatemala','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(25544,'28405','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.281720,-77.824740,0,'2013-07-06 12:44:31',NULL,NULL),(13177,'13617','S','Bucks Bridge','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(52393,'60631','S','Norwood Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.989117,-87.805412,0,'2013-07-06 12:44:33',NULL,NULL),(56903,'66046','S','Laurence','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.943832,-95.255319,0,'2013-07-06 12:44:33',NULL,NULL),(17918,'18460','S','S Sterling','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.274485,-75.396065,0,'2013-07-06 12:44:31',NULL,NULL),(11404,'11954','S','Hither Plains','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.041068,-71.950598,0,'2013-07-06 12:44:30',NULL,NULL),(42897,'48097','S','Lynn Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.116201,-82.794016,0,'2013-07-06 12:44:32',NULL,NULL),(46544,'53405','S','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.716356,-87.823291,0,'2013-07-06 12:44:32',NULL,NULL),(73698,'91607','S','Studio City','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(79152,'98503','S','Olympia','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.026260,-122.795460,0,'2013-07-06 12:44:34',NULL,NULL),(46875,'54104','S','Silver Cliff','A','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.460174,-88.241372,0,'2013-07-06 12:44:32',NULL,NULL),(8185,'07885','S','Wharton','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.915230,-74.602507,0,'2013-07-06 12:44:30',NULL,NULL),(21231,'22226','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.883884,-77.094284,0,'2013-07-06 12:44:31',NULL,NULL),(16585,'17322','S','Felton','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.860272,-76.566178,0,'2013-07-06 12:44:31',NULL,NULL),(11815,'12234','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.671814,-73.736501,0,'2013-07-06 12:44:30',NULL,NULL),(10015,'10169','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(17900,'18447','S','Dickson Cty','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(10688,'11213','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671767,-73.935934,0,'2013-07-06 12:44:30',NULL,NULL),(40925,'46278','S','New Augusta','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.883333,-86.238611,0,'2013-07-06 12:44:32',NULL,NULL),(15745,'16910','S','Snydertwn','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.705551,-76.828782,0,'2013-07-06 12:44:31',NULL,NULL),(31589,'34655','S','Trinity','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210274,-82.682809,0,'2013-07-06 12:44:32',NULL,NULL),(55514,'63782','S','Sturdivant','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.071576,-90.008984,0,'2013-07-06 12:44:33',NULL,NULL),(76091,'95219','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.004042,-121.354917,0,'2013-07-06 12:44:34',NULL,NULL),(67313,'80023','S','Thornton','A','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.953501,-105.036717,0,'2013-07-06 12:44:34',NULL,NULL),(66014,'78355','S','Flowella','N','Brooks','48047','Texas','TX','48','0000','361','Central',-6.0,'Y',27.225360,-98.143700,0,'2013-07-06 12:44:34',NULL,NULL),(45347,'50950','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.580273,-93.628420,0,'2013-07-06 12:44:32',NULL,NULL),(44981,'50424','S','Buffalo Ctr','A','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.388034,-93.950119,0,'2013-07-06 12:44:32',NULL,NULL),(42803,'48050','S','Lenox Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.784440,-82.916880,0,'2013-07-06 12:44:32',NULL,NULL),(41825,'47340','S','Brinckley','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.181057,-85.113281,0,'2013-07-06 12:44:32',NULL,NULL),(30379,'33319','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(32908,'36545','S','Walker Spgs','A','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.527175,-87.891357,0,'2013-07-06 12:44:32',NULL,NULL),(54170,'62613','S','Fancy Prairie','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.945060,-89.725020,0,'2013-07-06 12:44:33',NULL,NULL),(65106,'77367','P','Riverside','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.843263,-95.370764,0,'2013-07-06 12:44:34',NULL,NULL),(11142,'11713','S','Bellport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.769052,-72.942600,0,'2013-07-06 12:44:30',NULL,NULL),(23838,'26121','U','Coldwater Creek','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.172142,-81.494887,0,'2013-07-06 12:44:31',NULL,NULL),(5366,'04625','P','Cranberry Isles','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.245487,-68.257422,0,'2013-07-06 12:44:30',NULL,NULL),(48049,'55314','S','Buffalo Lake','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.737743,-94.625994,0,'2013-07-06 12:44:33',NULL,NULL),(67614,'80435','S','Dillon','D','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.618708,-106.041714,0,'2013-07-06 12:44:34',NULL,NULL),(73272,'90731','S','Terminal Island','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.743520,-118.279440,0,'2013-07-06 12:44:34',NULL,NULL),(7212,'06493','U','Ct Gen Med Claims Office','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.486804,-72.822757,0,'2013-07-06 12:44:30',NULL,NULL),(51919,'60115','S','Dekalb','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.929327,-88.750764,0,'2013-07-06 12:44:33',NULL,NULL),(54524,'62878','S','Rinard','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.583362,-88.476223,0,'2013-07-06 12:44:33',NULL,NULL),(60593,'71835','S','Emmet','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.669520,-93.401070,0,'2013-07-06 12:44:33',NULL,NULL),(40738,'46131','S','Franklin','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.488252,-86.054873,0,'2013-07-06 12:44:32',NULL,NULL),(30303,'33299','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.775355,-80.208792,0,'2013-07-06 12:44:32',NULL,NULL),(17782,'18348','P','Pocono Lake','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106882,-75.479231,0,'2013-07-06 12:44:31',NULL,NULL),(8474,'08090','S','Wenonah','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.799114,-75.150975,0,'2013-07-06 12:44:30',NULL,NULL),(18827,'19415','U','Shared Return Zip','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.159802,-75.408718,0,'2013-07-06 12:44:31',NULL,NULL),(55283,'63471','S','West Quincy','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.913920,-91.510680,0,'2013-07-06 12:44:33',NULL,NULL),(52266,'60525','S','Ind Head Pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(50706,'58365','S','Rocklake','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.857949,-99.129655,0,'2013-07-06 12:44:33',NULL,NULL),(8667,'08321','P','Fortescue','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.239708,-75.169233,0,'2013-07-06 12:44:30',NULL,NULL),(11091,'11693','S','Rockaway Beach','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.589797,-73.813567,0,'2013-07-06 12:44:30',NULL,NULL),(45689,'52047','S','Froelich','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.947298,-91.311574,0,'2013-07-06 12:44:32',NULL,NULL),(10360,'10579','S','Oscawana Lake','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.390553,-73.846426,0,'2013-07-06 12:44:30',NULL,NULL),(3354,'01562','S','Spencer','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.248647,-71.995246,0,'2013-07-06 12:44:30',NULL,NULL),(23749,'25942','P','Winona','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.044933,-80.994160,0,'2013-07-06 12:44:31',NULL,NULL),(20404,'20902','S','Wheaton','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.037324,-77.049792,0,'2013-07-06 12:44:31',NULL,NULL),(54873,'63052','S','Sulphur Springs','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.390733,-90.422015,0,'2013-07-06 12:44:33',NULL,NULL),(61081,'72130','S','Prim','D','Cleburne','05023','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.689015,-92.144913,0,'2013-07-06 12:44:33',NULL,NULL),(61457,'72623','S','Clarkridge','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.449082,-92.349269,0,'2013-07-06 12:44:33',NULL,NULL),(74110,'92225','S','Ripley','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609354,-114.615439,0,'2013-07-06 12:44:34',NULL,NULL),(60937,'72088','S','Fairfield Bay','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.594100,-92.277720,0,'2013-07-06 12:44:33',NULL,NULL),(51143,'58838','S','Cartwright','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.613409,-103.839867,0,'2013-07-06 12:44:33',NULL,NULL),(34951,'39059','S','Crystal Spgs','A','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.983819,-90.358823,0,'2013-07-06 12:44:32',NULL,NULL),(35144,'39218','S','Jksn','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.237700,-90.154800,0,'2013-07-06 12:44:32',NULL,NULL),(54061,'62476','S','West Salem','D','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.520000,-88.020660,0,'2013-07-06 12:44:33',NULL,NULL),(71436,'87034','P','Acoma','A','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084674,-107.598482,0,'2013-07-06 12:44:34',NULL,NULL),(34900,'38954','S','Rising Sun','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.461906,-90.211639,0,'2013-07-06 12:44:32',NULL,NULL),(9835,'10115','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(22143,'23455','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.888297,-76.144677,0,'2013-07-06 12:44:31',NULL,NULL),(6367,'05677','S','Waterbury Center','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.392439,-72.715938,0,'2013-07-06 12:44:30',NULL,NULL),(20282,'20791','P','Capitol Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.817650,-76.943769,0,'2013-07-06 12:44:31',NULL,NULL),(24410,'27113','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.101917,-80.247264,0,'2013-07-06 12:44:31',NULL,NULL),(62435,'74159','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147599,-95.954697,0,'2013-07-06 12:44:33',NULL,NULL),(78066,'97458','S','Remote','A','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.114800,-124.156800,0,'2013-07-06 12:44:34',NULL,NULL),(53765,'62268','S','Elkton','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.263313,-89.588808,0,'2013-07-06 12:44:33',NULL,NULL),(48835,'56048','S','Janesville','D','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.116681,-93.707000,0,'2013-07-06 12:44:33',NULL,NULL),(48280,'55432','S','Spring Lake Park','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.098640,-93.254963,0,'2013-07-06 12:44:33',NULL,NULL),(27454,'30126','S','Mableton','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.813468,-84.548054,0,'2013-07-06 12:44:31',NULL,NULL),(1437,'00739','S','Urb Domingo Alejandro','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(796,'00693','S','Haciendas De Monteverde','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(41980,'47421','S','Hartleyville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(14016,'14534','S','Pittsford','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.069507,-77.514294,0,'2013-07-06 12:44:31',NULL,NULL),(22671,'24292','S','Whitetop','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.616137,-81.574642,0,'2013-07-06 12:44:31',NULL,NULL),(19451,'20119','S','Catlett','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.656521,-77.641059,0,'2013-07-06 12:44:31',NULL,NULL),(50737,'58386','S','York','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.329524,-99.526269,0,'2013-07-06 12:44:33',NULL,NULL),(68251,'81059','S','Tyrone','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.498583,-104.151083,0,'2013-07-06 12:44:34',NULL,NULL),(72007,'88041','S','Fierro','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.746667,-107.885833,0,'2013-07-06 12:44:34',NULL,NULL),(76087,'95213','P','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.955793,-121.438557,0,'2013-07-06 12:44:34',NULL,NULL),(58669,'68883','S','Prosser','A','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.819408,-98.597850,0,'2013-07-06 12:44:33',NULL,NULL),(54114,'62548','S','Mount Pulaski','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.009094,-89.284725,0,'2013-07-06 12:44:33',NULL,NULL),(6966,'06235','S','Mansfield Center','A','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.808838,-72.115007,0,'2013-07-06 12:44:30',NULL,NULL),(43516,'48640','S','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.630483,-84.274746,0,'2013-07-06 12:44:32',NULL,NULL),(24051,'26422','P','Reynoldsville','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.290355,-80.434245,0,'2013-07-06 12:44:31',NULL,NULL),(46817,'54009','S','Dresser','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.362975,-92.621521,0,'2013-07-06 12:44:32',NULL,NULL),(11392,'11946','S','Hampton Bays','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.883963,-72.532083,0,'2013-07-06 12:44:30',NULL,NULL),(18110,'18767','U','Social Security Admin','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.249950,-75.875977,0,'2013-07-06 12:44:31',NULL,NULL),(52106,'60416','S','Carbon Hill','A','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.291648,-88.285221,0,'2013-07-06 12:44:33',NULL,NULL),(10341,'10553','S','Mt Vernon','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.904734,-73.824600,0,'2013-07-06 12:44:30',NULL,NULL),(1874,'00791','S','Urb Los Rosales','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(22593,'24177','P','Vesta','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.722656,-80.400262,0,'2013-07-06 12:44:31',NULL,NULL),(24917,'27804','S','Rocky Mount','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.974314,-77.831514,0,'2013-07-06 12:44:31',NULL,NULL),(39636,'44903','S','Little Washington','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.760320,-82.520048,0,'2013-07-06 12:44:32',NULL,NULL),(61642,'72847','S','London','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.341599,-93.239244,0,'2013-07-06 12:44:33',NULL,NULL),(70860,'85602','S','Benson','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.965389,-110.296656,0,'2013-07-06 12:44:34',NULL,NULL),(17502,'17961','S','West Brunswick','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(39233,'44422','P','Greenford','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.945019,-80.792061,0,'2013-07-06 12:44:32',NULL,NULL),(38155,'43147','S','Etna','A','Fairfield','39045','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.903244,-82.750689,0,'2013-07-06 12:44:32',NULL,NULL),(22707,'24343','S','Littlevine','N','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.764206,-80.736826,0,'2013-07-06 12:44:31',NULL,NULL),(46794,'53969','P','Wyocena','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.495865,-89.307819,0,'2013-07-06 12:44:32',NULL,NULL),(52930,'61374','P','Van Orin','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.550875,-89.355170,0,'2013-07-06 12:44:33',NULL,NULL),(78076,'97467','S','Winchester Bay','A','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.709940,-123.973740,0,'2013-07-06 12:44:34',NULL,NULL),(66794,'79058','S','Masterson','D','Moore','48341','Texas','TX','48','0000','806','Central',-6.0,'Y',35.638349,-101.959682,0,'2013-07-06 12:44:34',NULL,NULL),(46831,'54015','S','Hammond','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.964112,-92.465156,0,'2013-07-06 12:44:32',NULL,NULL),(46462,'53214','S','West Allis','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.020816,-88.017337,0,'2013-07-06 12:44:32',NULL,NULL),(22833,'24515','U','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.349450,-79.157075,0,'2013-07-06 12:44:31',NULL,NULL),(19473,'20141','S','Round Hill','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.123098,-77.785374,0,'2013-07-06 12:44:31',NULL,NULL),(60517,'71667','S','Nebo','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(59590,'71008','S','Bear Creek','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(18094,'18708','S','Jackson Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.300280,-75.965880,0,'2013-07-06 12:44:31',NULL,NULL),(29844,'33034','S','Flamingo Ldge','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.450256,-80.489973,0,'2013-07-06 12:44:32',NULL,NULL),(37703,'42261','S','Brooklyn','A','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(6726,'06073','S','South Glastonbury','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.663072,-72.573262,0,'2013-07-06 12:44:30',NULL,NULL),(39493,'44799','U','Canton Brm','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.811856,-81.373368,0,'2013-07-06 12:44:32',NULL,NULL),(15375,'16311','S','Carlton','D','Mercer','42085','Pennsylvania','PA','42','7610','814','Eastern',-5.0,'Y',41.481763,-80.032308,0,'2013-07-06 12:44:31',NULL,NULL),(47812,'55056','S','North Branch','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.504480,-92.877900,0,'2013-07-06 12:44:33',NULL,NULL),(54244,'62668','S','Murrayville','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.586700,-90.247679,0,'2013-07-06 12:44:33',NULL,NULL),(70956,'85643','S','Sunset','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(71227,'86332','S','Peeples Valley','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.433099,-112.599720,0,'2013-07-06 12:44:34',NULL,NULL),(38812,'44072','S','Russell Township','N','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.472300,-81.335220,0,'2013-07-06 12:44:32',NULL,NULL),(23841,'26134','S','Belmont','D','Pleasants','54073','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.379129,-81.264578,0,'2013-07-06 12:44:31',NULL,NULL),(50102,'57474','S','Randolph','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.286060,-98.280146,0,'2013-07-06 12:44:33',NULL,NULL),(55585,'63902','P','Poplar Bluff','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.755596,-90.395196,0,'2013-07-06 12:44:33',NULL,NULL),(74115,'92231','S','Mount Signal','N','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.691821,-115.504813,0,'2013-07-06 12:44:34',NULL,NULL),(64218,'76268','P','Southmayd','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.622991,-96.719300,0,'2013-07-06 12:44:34',NULL,NULL),(61612,'72812','P','Russellville','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.223193,-93.120324,0,'2013-07-06 12:44:33',NULL,NULL),(60413,'71639','S','Pendleton','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(47084,'54434','P','Jump River','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.329087,-90.742860,0,'2013-07-06 12:44:32',NULL,NULL),(3600,'02040','P','Scituate','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.179589,-70.749679,0,'2013-07-06 12:44:30',NULL,NULL),(49135,'56367','S','Rice','D','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.753912,-94.154601,0,'2013-07-06 12:44:33',NULL,NULL),(61130,'72157','S','Bird Town','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.280120,-92.536920,0,'2013-07-06 12:44:33',NULL,NULL),(72989,'90056','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.984248,-118.364182,0,'2013-07-06 12:44:34',NULL,NULL),(2990,'01062','S','Northampton','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.331578,-72.692571,0,'2013-07-06 12:44:30',NULL,NULL),(25027,'27891','S','Whitakers','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',36.101004,-77.723888,0,'2013-07-06 12:44:31',NULL,NULL),(11175,'11731','S','East Northport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.864288,-73.317866,0,'2013-07-06 12:44:30',NULL,NULL),(4535,'03443','S','Chesterfield','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.889809,-72.462899,0,'2013-07-06 12:44:30',NULL,NULL),(32684,'36271','S','Ohatchee','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.791846,-86.011796,0,'2013-07-06 12:44:32',NULL,NULL),(10030,'10172','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(37176,'41477','P','Wrigley','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.986260,-83.302388,0,'2013-07-06 12:44:32',NULL,NULL),(67455,'80214','S','Wheat Ridge','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745789,-105.059616,0,'2013-07-06 12:44:34',NULL,NULL),(31528,'34481','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.134462,-82.331561,0,'2013-07-06 12:44:32',NULL,NULL),(515,'00674','S','Urb Camino del Sol Ii','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(12114,'12588','P','Walker Valley','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.633499,-74.377182,0,'2013-07-06 12:44:30',NULL,NULL),(13393,'13746','S','Quinneville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.269580,-75.839580,0,'2013-07-06 12:44:31',NULL,NULL),(10312,'10536','S','Katonah','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.272380,-73.689240,0,'2013-07-06 12:44:30',NULL,NULL),(63720,'75929','S','Broaddus','D','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.332978,-94.226451,0,'2013-07-06 12:44:34',NULL,NULL),(65282,'77482','S','Van Vleck','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',29.025542,-95.885096,0,'2013-07-06 12:44:34',NULL,NULL),(52018,'60175','S','Lily Lake','N','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.952674,-88.346033,0,'2013-07-06 12:44:33',NULL,NULL),(27071,'29693','S','Westminster','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.642443,-83.088445,0,'2013-07-06 12:44:31',NULL,NULL),(4894,'04049','S','Limington','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.723689,-70.677750,0,'2013-07-06 12:44:30',NULL,NULL),(23164,'25015','S','Witcher','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(42970,'48134','S','Flat Rock','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.107811,-83.281359,0,'2013-07-06 12:44:32',NULL,NULL),(12264,'12833','S','Greenfld Ctr','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.141920,-73.855860,0,'2013-07-06 12:44:30',NULL,NULL),(40520,'45822','S','Celina','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.549433,-84.578000,0,'2013-07-06 12:44:32',NULL,NULL),(1135,'00725','S','Villa Victoria','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(52883,'61348','S','Oglesby','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.291493,-89.048588,0,'2013-07-06 12:44:33',NULL,NULL),(56654,'65616','S','Silver Dollar City','N','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(68705,'82060','P','Hillsdale','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.210850,-104.479294,0,'2013-07-06 12:44:34',NULL,NULL),(74119,'92234','S','Cathedral Cty','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.822485,-116.462762,0,'2013-07-06 12:44:34',NULL,NULL),(52801,'61277','S','Leon Corners','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(52667,'61071','S','Yeoward Addition','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.758470,-89.690648,0,'2013-07-06 12:44:33',NULL,NULL),(5328,'04576','S','Newagen','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.816792,-69.663987,0,'2013-07-06 12:44:30',NULL,NULL),(7824,'07458','S','Saddle River','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.045460,-74.099880,0,'2013-07-06 12:44:30',NULL,NULL),(28394,'31313','S','Ft Stewart','N','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.843745,-81.603148,0,'2013-07-06 12:44:32',NULL,NULL),(34896,'38952','S','Schlater','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.610890,-90.375689,0,'2013-07-06 12:44:32',NULL,NULL),(41340,'46785','S','St Joe','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.320866,-84.892900,0,'2013-07-06 12:44:32',NULL,NULL),(16769,'17522','S','Ephrata','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(43484,'48610','S','Alger','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.124868,-84.088232,0,'2013-07-06 12:44:32',NULL,NULL),(27561,'30261','P','Mountville','A','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.061746,-84.890953,0,'2013-07-06 12:44:31',NULL,NULL),(29929,'33064','S','Lighthouse Point','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.277900,-80.147820,0,'2013-07-06 12:44:32',NULL,NULL),(53075,'61523','S','Holmes Center','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(61923,'73151','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.567203,-97.404773,0,'2013-07-06 12:44:33',NULL,NULL),(48311,'55443','S','Brooklyn Pk','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.076111,-93.332500,0,'2013-07-06 12:44:33',NULL,NULL),(29368,'32579','S','Shalimar','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.448064,-86.572977,0,'2013-07-06 12:44:32',NULL,NULL),(14873,'15468','S','New Salem','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.937191,-79.822519,0,'2013-07-06 12:44:31',NULL,NULL),(2445,'00953','S','Urb Palacios Reales','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(68081,'80938','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.797690,-104.837067,0,'2013-07-06 12:44:34',NULL,NULL),(29790,'33018','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.942320,-80.390400,0,'2013-07-06 12:44:32',NULL,NULL),(11012,'11557','S','Hewlett Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.638779,-73.693176,0,'2013-07-06 12:44:30',NULL,NULL),(34999,'39117','S','Morton','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.352309,-89.654064,0,'2013-07-06 12:44:32',NULL,NULL),(7969,'07702','S','Red Bank','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.346944,-74.064722,0,'2013-07-06 12:44:30',NULL,NULL),(15907,'17014','S','Cocolamus','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.659121,-77.103424,0,'2013-07-06 12:44:31',NULL,NULL),(16398,'17219','S','Fannett','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.217940,-77.713500,0,'2013-07-06 12:44:31',NULL,NULL),(58099,'68111','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.290325,-95.967165,0,'2013-07-06 12:44:33',NULL,NULL),(64923,'77208','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.758968,-95.365940,0,'2013-07-06 12:44:34',NULL,NULL),(23934,'26257','S','Coalton','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.905438,-80.001020,0,'2013-07-06 12:44:31',NULL,NULL),(28584,'31634','S','Cogdell','A','Clinch','13065','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.037475,-82.752207,0,'2013-07-06 12:44:32',NULL,NULL),(20271,'20785','S','North Englewood','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(53742,'62255','S','Darmstadt','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.312685,-89.764727,0,'2013-07-06 12:44:33',NULL,NULL),(14226,'14806','S','Andover','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.155375,-77.804776,0,'2013-07-06 12:44:31',NULL,NULL),(26813,'29476','P','Russellville','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.397957,-79.974782,0,'2013-07-06 12:44:31',NULL,NULL),(69558,'83814','S','Fernan Lk Vlg','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.687824,-116.779638,0,'2013-07-06 12:44:34',NULL,NULL),(21421,'22546','S','Ruther Glen','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.007807,-77.545616,0,'2013-07-06 12:44:31',NULL,NULL),(5073,'04288','P','West Minot','D','Androscoggin','23001','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.056988,-70.413466,0,'2013-07-06 12:44:30',NULL,NULL),(37832,'42445','S','Princeton','D','Caldwell','21033','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.108540,-87.880111,0,'2013-07-06 12:44:32',NULL,NULL),(7974,'07704','S','Red Bank','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.371420,-74.035620,0,'2013-07-06 12:44:30',NULL,NULL),(52589,'61011','S','Caledonia','D','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.387191,-88.893272,0,'2013-07-06 12:44:33',NULL,NULL),(57552,'67035','S','Cunningham','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.666740,-98.402580,0,'2013-07-06 12:44:33',NULL,NULL),(77765,'97115','S','Dundee','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.276746,-123.018550,0,'2013-07-06 12:44:34',NULL,NULL),(26425,'29126','S','Glympville','N','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.323669,-81.444178,0,'2013-07-06 12:44:31',NULL,NULL),(25348,'28224','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.151064,-80.873427,0,'2013-07-06 12:44:31',NULL,NULL),(47899,'55108','S','Lauderdale','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.982543,-93.179571,0,'2013-07-06 12:44:33',NULL,NULL),(50825,'58472','S','Millarton','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.666944,-98.759167,0,'2013-07-06 12:44:33',NULL,NULL),(61740,'73032','P','Dougherty','D','Murray','40099','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.401782,-97.051471,0,'2013-07-06 12:44:33',NULL,NULL),(20524,'21093','S','Lutherville','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.434940,-76.654860,0,'2013-07-06 12:44:31',NULL,NULL),(41399,'46807','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.048761,-85.145583,0,'2013-07-06 12:44:32',NULL,NULL),(18225,'18966','S','Holland','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.186800,-75.009660,0,'2013-07-06 12:44:31',NULL,NULL),(28784,'32041','P','Yulee','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.635970,-81.573116,0,'2013-07-06 12:44:32',NULL,NULL),(63701,'75884','U','Tenn Colony','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.834403,-95.840540,0,'2013-07-06 12:44:34',NULL,NULL),(23524,'25567','S','Sumerco','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.198154,-81.892436,0,'2013-07-06 12:44:31',NULL,NULL),(25776,'28602','S','Long View','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.661600,-81.370320,0,'2013-07-06 12:44:31',NULL,NULL),(54594,'62902','S','Carbondale','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.721102,-89.194086,0,'2013-07-06 12:44:33',NULL,NULL),(56097,'64779','S','Rich Hill','D','Bates','29013','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.096590,-94.366330,0,'2013-07-06 12:44:33',NULL,NULL),(67229,'79928','S','Horizon City','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.757176,-106.486005,0,'2013-07-06 12:44:34',NULL,NULL),(68898,'82723','S','Osage','D','Weston','56045','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.986823,-104.417332,0,'2013-07-06 12:44:34',NULL,NULL),(7278,'06530','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318176,-72.923918,0,'2013-07-06 12:44:30',NULL,NULL),(35906,'40014','S','Crestwood','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.337990,-85.443424,0,'2013-07-06 12:44:32',NULL,NULL),(53821,'62298','S','New Hanover','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(64404,'76543','S','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.089660,-97.642260,0,'2013-07-06 12:44:34',NULL,NULL),(67742,'80602','S','Thornton','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.960305,-104.910703,0,'2013-07-06 12:44:34',NULL,NULL),(79777,'99338','S','Kennewick','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.211673,-119.138070,0,'2013-07-06 12:44:34',NULL,NULL),(44216,'49640','S','Honor','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.703782,-86.060239,0,'2013-07-06 12:44:32',NULL,NULL),(42347,'47639','S','Warrenton','N','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.184600,-87.625920,0,'2013-07-06 12:44:32',NULL,NULL),(26617,'29306','S','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.928003,-81.908736,0,'2013-07-06 12:44:31',NULL,NULL),(58934,'69348','S','Dunlap','N','Box Butte','31013','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.316869,-103.075882,0,'2013-07-06 12:44:33',NULL,NULL),(65965,'78285','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.422258,-98.525584,0,'2013-07-06 12:44:34',NULL,NULL),(8271,'08009','S','Tansboro','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.759420,-74.927340,0,'2013-07-06 12:44:30',NULL,NULL),(26165,'28743','S','Trust','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(68983,'83118','S','Etna','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.052486,-111.009860,0,'2013-07-06 12:44:34',NULL,NULL),(52760,'61252','S','East Clinton','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.855867,-90.142898,0,'2013-07-06 12:44:33',NULL,NULL),(62983,'75146','S','Lancaster','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.579465,-96.747249,0,'2013-07-06 12:44:33',NULL,NULL),(11633,'12118','S','Mechanicville','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.913913,-73.707978,0,'2013-07-06 12:44:30',NULL,NULL),(25907,'28645','S','Gamewell','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(64012,'76117','S','N Richlnd Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(35170,'39271','U','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289835,-90.180840,0,'2013-07-06 12:44:32',NULL,NULL),(56777,'65746','S','Cedar Gap','N','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.147408,-92.767863,0,'2013-07-06 12:44:33',NULL,NULL),(61366,'72515','S','Bexar','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.302450,-91.978351,0,'2013-07-06 12:44:33',NULL,NULL),(70601,'85117','P','Apache Junction','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.421692,-111.548959,0,'2013-07-06 12:44:34',NULL,NULL),(49219,'56467','S','Mantrap','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.876449,-94.807054,0,'2013-07-06 12:44:33',NULL,NULL),(57005,'66205','S','Fairway','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(70278,'84530','P','La Sal','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.311013,-109.255668,0,'2013-07-06 12:44:34',NULL,NULL),(22141,'23454','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.837731,-76.025953,0,'2013-07-06 12:44:31',NULL,NULL),(63454,'75683','S','Ore City','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.790463,-94.654091,0,'2013-07-06 12:44:33',NULL,NULL),(79774,'99336','S','Kenn','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.194720,-119.133240,0,'2013-07-06 12:44:34',NULL,NULL),(26778,'29448','S','Harleyville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.185687,-80.577757,0,'2013-07-06 12:44:31',NULL,NULL),(65854,'78205','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.423472,-98.487398,0,'2013-07-06 12:44:34',NULL,NULL),(76502,'95638','S','Herald','D','Sacramento','06067','California','CA','06','6920','209','Pacific',-8.0,'Y',38.347884,-121.109377,0,'2013-07-06 12:44:34',NULL,NULL),(77995,'97404','S','Santa Clara','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.103156,-123.135275,0,'2013-07-06 12:44:34',NULL,NULL),(79633,'99130','S','Garfield','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.006983,-117.140454,0,'2013-07-06 12:44:34',NULL,NULL),(36746,'41040','S','Brownings Corner','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(61592,'72760','S','Saint Paul','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.855662,-93.723204,0,'2013-07-06 12:44:33',NULL,NULL),(64132,'76193','U','Federal Aviation Administrat','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.747377,-97.330613,0,'2013-07-06 12:44:34',NULL,NULL),(71815,'87571','S','Taos','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(23897,'26201','S','Buckhannon','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.983537,-80.225375,0,'2013-07-06 12:44:31',NULL,NULL),(22407,'23963','S','Red House','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.200250,-78.809699,0,'2013-07-06 12:44:31',NULL,NULL),(39833,'45157','S','Laurel','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.955180,-84.219600,0,'2013-07-06 12:44:32',NULL,NULL),(19414,'20082','U','Natl Repub Cong Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896423,-77.008777,0,'2013-07-06 12:44:31',NULL,NULL),(36184,'40253','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.242117,-85.529319,0,'2013-07-06 12:44:32',NULL,NULL),(31816,'35057','S','Good Hope','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.213486,-86.865502,0,'2013-07-06 12:44:32',NULL,NULL),(68418,'81210','S','Rainbow','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(71300,'86502','P','Wide Ruins','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.419444,-109.495833,0,'2013-07-06 12:44:34',NULL,NULL),(72814,'89802','P','Elko','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.859699,-115.714950,0,'2013-07-06 12:44:34',NULL,NULL),(41969,'47421','S','Bedford','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(38223,'43222','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.956475,-83.029361,0,'2013-07-06 12:44:32',NULL,NULL),(6340,'05669','S','Roxbury Flat','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(35108,'39209','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.324026,-90.252348,0,'2013-07-06 12:44:32',NULL,NULL),(33338,'37161','U','Shelbyville','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.484443,-86.461170,0,'2013-07-06 12:44:32',NULL,NULL),(51912,'60108','S','Bloomingdale','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.950862,-88.080804,0,'2013-07-06 12:44:33',NULL,NULL),(57697,'67332','S','Bartlett','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.062529,-95.210812,0,'2013-07-06 12:44:33',NULL,NULL),(67931,'80909','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.852846,-104.761164,0,'2013-07-06 12:44:34',NULL,NULL),(70098,'84170','P','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701243,-112.010773,0,'2013-07-06 12:44:34',NULL,NULL),(77554,'96860','S','Joint Base Pearl Hbr Hickam','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353536,-157.966185,0,'2013-07-06 12:44:34',NULL,NULL),(20767,'21505','P','Cresaptown','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.658048,-78.746255,0,'2013-07-06 12:44:31',NULL,NULL),(9925,'10152','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759241,-73.971816,0,'2013-07-06 12:44:30',NULL,NULL),(39088,'44223','S','Cuyahoga Fls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.145747,-81.518239,0,'2013-07-06 12:44:32',NULL,NULL),(38886,'44109','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.450419,-81.701900,0,'2013-07-06 12:44:32',NULL,NULL),(15819,'16932','S','Mainesburg','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.785028,-76.962034,0,'2013-07-06 12:44:31',NULL,NULL),(70831,'85501','S','Globe','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.394116,-110.783011,0,'2013-07-06 12:44:34',NULL,NULL),(7210,'06492','S','Wallingford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.459922,-72.818029,0,'2013-07-06 12:44:30',NULL,NULL),(2294,'00927','S','Bda Villamil','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(12170,'12758','S','Livingstn Mnr','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.912654,-74.754347,0,'2013-07-06 12:44:30',NULL,NULL),(42507,'47847','S','Dana','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.807913,-87.490923,0,'2013-07-06 12:44:32',NULL,NULL),(14208,'14778','P','St Bonaventure','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.080151,-78.474616,0,'2013-07-06 12:44:31',NULL,NULL),(9964,'10159','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(52754,'61244','S','Merry Oaks','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(13572,'13843','S','Holmesville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(54475,'62859','S','Knight Prairie','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(59498,'70773','S','Rougon','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.597677,-91.373909,0,'2013-07-06 12:44:33',NULL,NULL),(43746,'49005','P','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.291162,-85.582601,0,'2013-07-06 12:44:32',NULL,NULL),(42632,'47909','S','Shadeland','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.323451,-86.883198,0,'2013-07-06 12:44:32',NULL,NULL),(48036,'55305','S','Hopkins','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952480,-93.426660,0,'2013-07-06 12:44:33',NULL,NULL),(56045,'64725','S','Austin','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.482614,-94.355052,0,'2013-07-06 12:44:33',NULL,NULL),(37677,'42214','S','Center','D','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.130336,-85.689134,0,'2013-07-06 12:44:32',NULL,NULL),(13338,'13685','S','Hounsfield','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.943471,-76.111664,0,'2013-07-06 12:44:30',NULL,NULL),(5364,'04624','S','Corea','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.417193,-67.992754,0,'2013-07-06 12:44:30',NULL,NULL),(12570,'13061','S','Erieville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.866074,-75.751527,0,'2013-07-06 12:44:30',NULL,NULL),(78401,'98034','S','Kirkland','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.718053,-122.198946,0,'2013-07-06 12:44:34',NULL,NULL),(5889,'05154','S','Saxtons River','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.136924,-72.507023,0,'2013-07-06 12:44:30',NULL,NULL),(42444,'47805','S','Rose Hill Gardens','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(23818,'26062','S','Weirton','D','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.415665,-80.563410,0,'2013-07-06 12:44:31',NULL,NULL),(32369,'35898','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.628936,-86.651129,0,'2013-07-06 12:44:32',NULL,NULL),(20452,'21017','S','Belcamp','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.472249,-76.237972,0,'2013-07-06 12:44:31',NULL,NULL),(25942,'28656','U','Lowes Co Inc','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.203290,-81.076593,0,'2013-07-06 12:44:31',NULL,NULL),(50330,'57730','S','Sanator','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(51926,'60118','S','Sleepy Hollow','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.110280,-88.296540,0,'2013-07-06 12:44:33',NULL,NULL),(54204,'62638','S','Rees','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.621696,-90.042782,0,'2013-07-06 12:44:33',NULL,NULL),(59420,'70656','S','Fullerton','A','Vernon','22115','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.939362,-92.772121,0,'2013-07-06 12:44:33',NULL,NULL),(73124,'90266','S','Manhattan Bch','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.889584,-118.399020,0,'2013-07-06 12:44:34',NULL,NULL),(18396,'19050','S','Lansdowne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936540,-75.263580,0,'2013-07-06 12:44:31',NULL,NULL),(52279,'60526','S','La Grng Pk','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.831029,-87.873348,0,'2013-07-06 12:44:33',NULL,NULL),(72884,'90014','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.041273,-118.252399,0,'2013-07-06 12:44:34',NULL,NULL),(1502,'00751','S','Urb Monserrate','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(63294,'75560','S','Union Chapel','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.190651,-94.354656,0,'2013-07-06 12:44:33',NULL,NULL),(73808,'91756','U','Monterey Pk','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.047565,-118.132799,0,'2013-07-06 12:44:34',NULL,NULL),(80053,'99710','P','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.916817,-147.567476,0,'2013-07-06 12:44:34',NULL,NULL),(79653,'99148','S','Deer Lake','N','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.055306,-117.616975,0,'2013-07-06 12:44:34',NULL,NULL),(77396,'96774','P','Ookala','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.003285,-155.275133,0,'2013-07-06 12:44:34',NULL,NULL),(68824,'82501','S','Morton','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(59457,'70730','S','Ethel','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.814852,-91.118263,0,'2013-07-06 12:44:33',NULL,NULL),(58974,'70040','S','Carlisle','A','Plaquemines','22075','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.827869,-89.963279,0,'2013-07-06 12:44:33',NULL,NULL),(40639,'46034','S','Cicero','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.129985,-86.018106,0,'2013-07-06 12:44:32',NULL,NULL),(26051,'28687','P','Statesville','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.776465,-80.910513,0,'2013-07-06 12:44:31',NULL,NULL),(43467,'48555','U','Delphi West','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.059116,-83.744242,0,'2013-07-06 12:44:32',NULL,NULL),(44131,'49510','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.022059,-85.612581,0,'2013-07-06 12:44:32',NULL,NULL),(25855,'28627','S','Cherry Lane','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.440899,-81.017500,0,'2013-07-06 12:44:31',NULL,NULL),(17097,'17765','S','Roaring Branch','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(76886,'95979','S','Fouts Springs','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.308210,-122.511314,0,'2013-07-06 12:44:34',NULL,NULL),(77574,'96913','S','Harmon','N','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(48446,'55707','S','Barnum','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.576488,-92.717904,0,'2013-07-06 12:44:33',NULL,NULL),(21941,'23231','S','Montrose','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(10379,'10591','S','Sleepy Hollow','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(31742,'34986','S','Saint Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.321528,-80.418405,0,'2013-07-06 12:44:32',NULL,NULL),(3322,'01527','S','Millbury','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.197286,-71.770146,0,'2013-07-06 12:44:30',NULL,NULL),(11313,'11780','S','Nissequogue','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(46201,'52754','S','Cranston','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.328289,-91.235037,0,'2013-07-06 12:44:32',NULL,NULL),(38818,'44074','S','Oberlin','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.286311,-82.234157,0,'2013-07-06 12:44:32',NULL,NULL),(21335,'22408','S','Fredericksburg','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(46652,'53702','U','State Capitol','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.074862,-89.380795,0,'2013-07-06 12:44:32',NULL,NULL),(2701,'00969','S','Est del Parque','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(29738,'32964','P','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.637858,-80.399918,0,'2013-07-06 12:44:32',NULL,NULL),(14245,'14821','S','Campbell','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.243643,-77.195401,0,'2013-07-06 12:44:31',NULL,NULL),(59813,'71230','P','Crowville','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.142357,-91.701688,0,'2013-07-06 12:44:33',NULL,NULL),(79119,'98481','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.222822,-122.472110,0,'2013-07-06 12:44:34',NULL,NULL),(17695,'18214','S','Barnesville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.828007,-76.045192,0,'2013-07-06 12:44:31',NULL,NULL),(40746,'46135','S','Mount Meridian','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(12468,'12980','S','St Regis Fls','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.656564,-74.564467,0,'2013-07-06 12:44:30',NULL,NULL),(32749,'36340','S','Geneva','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.038911,-85.879322,0,'2013-07-06 12:44:32',NULL,NULL),(34909,'38957','P','Sumner','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.986878,-90.345320,0,'2013-07-06 12:44:32',NULL,NULL),(55407,'63645','S','Womack','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.559762,-90.292995,0,'2013-07-06 12:44:33',NULL,NULL),(60860,'72052','P','Garner','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.121614,-91.729578,0,'2013-07-06 12:44:33',NULL,NULL),(75039,'93514','S','Laws','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(65074,'77349','U','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.721806,-95.551140,0,'2013-07-06 12:44:34',NULL,NULL),(55285,'63473','S','Williamstown','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.203555,-91.867788,0,'2013-07-06 12:44:33',NULL,NULL),(19814,'20451','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894433,-77.046676,0,'2013-07-06 12:44:31',NULL,NULL),(15008,'15668','S','Murrysville','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.449365,-79.681960,0,'2013-07-06 12:44:31',NULL,NULL),(6463,'05761','S','North Pawlet','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(25162,'28035','S','Davidson','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.499205,-80.846577,0,'2013-07-06 12:44:31',NULL,NULL),(31029,'33786','S','Indian Rks Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(54354,'62791','P','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.851073,-89.631848,0,'2013-07-06 12:44:33',NULL,NULL),(74785,'93118','P','Goleta','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.435471,-119.824927,0,'2013-07-06 12:44:34',NULL,NULL),(61279,'72391','P','West Ridge','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.595321,-90.214914,0,'2013-07-06 12:44:33',NULL,NULL),(55350,'63559','S','Midland','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(19802,'20439','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904771,-77.030231,0,'2013-07-06 12:44:31',NULL,NULL),(19643,'20266','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882442,-77.020708,0,'2013-07-06 12:44:31',NULL,NULL),(17312,'17857','S','Lithia Sprs','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893520,-76.797765,0,'2013-07-06 12:44:31',NULL,NULL),(25688,'28524','P','Davis','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.795464,-76.456798,0,'2013-07-06 12:44:31',NULL,NULL),(31362,'34205','S','West Bradenton','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.484977,-82.585541,0,'2013-07-06 12:44:32',NULL,NULL),(48481,'55724','S','Kelsey','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.154803,-92.576170,0,'2013-07-06 12:44:33',NULL,NULL),(57053,'66211','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(76594,'95685','S','Sutter Creek','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.424660,-120.753360,0,'2013-07-06 12:44:34',NULL,NULL),(17987,'18622','S','Huntington Mills','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.198934,-76.198272,0,'2013-07-06 12:44:31',NULL,NULL),(45065,'50516','S','Badger','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.602811,-94.150516,0,'2013-07-06 12:44:32',NULL,NULL),(50817,'58463','S','Pickardville','N','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.483889,-100.443661,0,'2013-07-06 12:44:33',NULL,NULL),(54751,'62979','S','Ridgway','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.804440,-88.260000,0,'2013-07-06 12:44:33',NULL,NULL),(46682,'53777','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.107649,-89.339418,0,'2013-07-06 12:44:32',NULL,NULL),(24290,'27007','S','Ararat','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.383368,-80.601678,0,'2013-07-06 12:44:31',NULL,NULL),(1592,'00769','S','Jard de Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(8748,'08527','S','Jackson Twp','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.106820,-74.341020,0,'2013-07-06 12:44:30',NULL,NULL),(29084,'32259','S','Jacksonville','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(34851,'38924','S','Kerin','N','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.293145,-90.230924,0,'2013-07-06 12:44:32',NULL,NULL),(47633,'54914','S','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.271885,-88.437781,0,'2013-07-06 12:44:33',NULL,NULL),(75840,'94923','S','Bodega Bay','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.349015,-123.047387,0,'2013-07-06 12:44:34',NULL,NULL),(66959,'79381','S','Wilson','D','Lynn','48305','Texas','TX','48','0000','806','Central',-6.0,'Y',33.321238,-101.724872,0,'2013-07-06 12:44:34',NULL,NULL),(58157,'68178','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.266599,-95.946811,0,'2013-07-06 12:44:33',NULL,NULL),(27591,'30290','S','Tyrone','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.474391,-84.588880,0,'2013-07-06 12:44:31',NULL,NULL),(46661,'53711','S','Fitchburg','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.030573,-89.444075,0,'2013-07-06 12:44:32',NULL,NULL),(56277,'65068','S','Prairie Home','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.827855,-92.602120,0,'2013-07-06 12:44:33',NULL,NULL),(8224,'07974','S','Murray Hill','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.700446,-74.405937,0,'2013-07-06 12:44:30',NULL,NULL),(49452,'56644','S','Winsor','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.849231,-95.480640,0,'2013-07-06 12:44:33',NULL,NULL),(60482,'71658','S','Boydell','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.306540,-91.515180,0,'2013-07-06 12:44:33',NULL,NULL),(50701,'58362','S','Penn','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.233319,-99.049103,0,'2013-07-06 12:44:33',NULL,NULL),(9544,'10022','S','Franklin D Roosevelt','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(12159,'12747','S','Hurleyville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.769272,-74.658509,0,'2013-07-06 12:44:30',NULL,NULL),(38200,'43210','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.007855,-83.021452,0,'2013-07-06 12:44:32',NULL,NULL),(17321,'17859','S','Pealertown','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(68868,'82638','S','Hiland','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.161514,-107.722759,0,'2013-07-06 12:44:34',NULL,NULL),(73963,'92068','P','Oceanside','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.276757,-117.272701,0,'2013-07-06 12:44:34',NULL,NULL),(70603,'85118','S','Apache Junction','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(15580,'16657','S','James Creek','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.339173,-78.185610,0,'2013-07-06 12:44:31',NULL,NULL),(6353,'05674','S','Sugarbush Valley','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.129916,-72.879337,0,'2013-07-06 12:44:30',NULL,NULL),(28287,'31093','S','Centerville','N','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.636119,-83.641763,0,'2013-07-06 12:44:31',NULL,NULL),(38175,'43160','S','Washingtn C H','N','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.536064,-83.442724,0,'2013-07-06 12:44:32',NULL,NULL),(20587,'21161','S','Norrisville','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.651440,-76.571490,0,'2013-07-06 12:44:31',NULL,NULL),(10376,'10591','S','North Tarrytown','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(2355,'00949','S','Bo Palo Seco','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(25451,'28325','P','Calypso','D','Duplin','37061','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',34.999323,-77.992330,0,'2013-07-06 12:44:31',NULL,NULL),(44835,'50257','S','Truro','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.209459,-93.846687,0,'2013-07-06 12:44:32',NULL,NULL),(41000,'46360','S','Potawatami Pk','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(78346,'98006','S','Newport Hills','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.564251,-122.150636,0,'2013-07-06 12:44:34',NULL,NULL),(65437,'77586','S','Taylor Lake Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(64990,'77279','P','Memorial Park','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.768115,-95.510337,0,'2013-07-06 12:44:34',NULL,NULL),(45653,'52001','S','Massey','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(32654,'36255','S','Cragford','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.217353,-85.689925,0,'2013-07-06 12:44:32',NULL,NULL),(18096,'18708','S','Trucksville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.300280,-75.965880,0,'2013-07-06 12:44:31',NULL,NULL),(53481,'61944','S','Paris','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.613075,-87.697934,0,'2013-07-06 12:44:33',NULL,NULL),(55071,'63171','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.597715,-90.326395,0,'2013-07-06 12:44:33',NULL,NULL),(61266,'72370','S','Osceola','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.703523,-89.974581,0,'2013-07-06 12:44:33',NULL,NULL),(60597,'71839','S','Garland City','D','Miller','05091','Arkansas','AR','05','8360','870','Central',-6.0,'Y',33.317011,-93.760241,0,'2013-07-06 12:44:33',NULL,NULL),(34114,'38184','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.185496,-89.864856,0,'2013-07-06 12:44:32',NULL,NULL),(14004,'14521','S','Hayt Corners','A','Seneca','36099','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.672490,-76.808623,0,'2013-07-06 12:44:31',NULL,NULL),(10023,'10171','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(15080,'15748','S','Waterman','A','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.525920,-79.162140,0,'2013-07-06 12:44:31',NULL,NULL),(28415,'31323','S','Riceboro','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.726286,-81.469983,0,'2013-07-06 12:44:32',NULL,NULL),(33493,'37350','S','Lookout Mtn','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',34.999753,-85.353348,0,'2013-07-06 12:44:32',NULL,NULL),(26869,'29544','S','Galivants Fry','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.127280,-79.108380,0,'2013-07-06 12:44:31',NULL,NULL),(68583,'81521','S','Colorado National Monument','N','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.165497,-108.720895,0,'2013-07-06 12:44:34',NULL,NULL),(72807,'89714','U','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.135730,-119.664200,0,'2013-07-06 12:44:34',NULL,NULL),(68201,'81040','S','Farisita','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.786005,-105.182854,0,'2013-07-06 12:44:34',NULL,NULL),(7279,'06530','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318176,-72.923918,0,'2013-07-06 12:44:30',NULL,NULL),(2219,'00926','S','Urb Carmen Hls','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(59528,'70807','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.536692,-91.174565,0,'2013-07-06 12:44:33',NULL,NULL),(79351,'98635','S','Lyle','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.726290,-121.258918,0,'2013-07-06 12:44:34',NULL,NULL),(78940,'98366','S','Wye Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(53578,'62060','S','Newport','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.686572,-90.153079,0,'2013-07-06 12:44:33',NULL,NULL),(11211,'11743','S','Wincoma','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(33455,'37320','P','Cleveland','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.157670,-84.877175,0,'2013-07-06 12:44:32',NULL,NULL),(9143,'09263','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(1194,'00728','S','Ext Punto Oro','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(71769,'87553','S','Rio Lucio','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.172500,-105.745200,0,'2013-07-06 12:44:34',NULL,NULL),(78760,'98303','S','Villa Beach','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164386,-122.695768,0,'2013-07-06 12:44:34',NULL,NULL),(78407,'98038','S','Four Corners','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.398201,-122.032234,0,'2013-07-06 12:44:34',NULL,NULL),(19984,'20598','U','Lorton','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(25104,'27968','P','Rodanthe','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.583210,-75.467676,0,'2013-07-06 12:44:31',NULL,NULL),(23223,'25083','S','Gallagher','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(73788,'91746','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.049002,-117.979948,0,'2013-07-06 12:44:34',NULL,NULL),(18659,'19176','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','0000','215/267','Eastern',-5.0,'Y',39.952222,-75.164167,0,'2013-07-06 12:44:31',NULL,NULL),(44173,'49548','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866570,-85.660484,0,'2013-07-06 12:44:32',NULL,NULL),(36637,'41004','S','Stonewall','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(74393,'92518','S','March Air Reserve Base','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.896243,-117.267131,0,'2013-07-06 12:44:34',NULL,NULL),(76453,'95610','S','Citrus Hts','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.696835,-121.265911,0,'2013-07-06 12:44:34',NULL,NULL),(5275,'04496','S','Winterport','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.657860,-68.915747,0,'2013-07-06 12:44:30',NULL,NULL),(24186,'26636','S','Nicut','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.782250,-80.899765,0,'2013-07-06 12:44:31',NULL,NULL),(24171,'26619','S','Exchange','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.798217,-80.764455,0,'2013-07-06 12:44:31',NULL,NULL),(43830,'49087','S','Schoolcraft','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.119650,-85.673540,0,'2013-07-06 12:44:32',NULL,NULL),(40513,'45816','P','Benton Ridge','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.004596,-83.796175,0,'2013-07-06 12:44:32',NULL,NULL),(25978,'28660','S','Olin','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.954635,-80.852343,0,'2013-07-06 12:44:31',NULL,NULL),(38121,'43110','S','Cnl Wnchstr','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.827570,-82.794186,0,'2013-07-06 12:44:32',NULL,NULL),(51208,'59041','S','Joliet','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.499020,-108.989580,0,'2013-07-06 12:44:33',NULL,NULL),(66705,'78947','S','Blue','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.391667,-97.147222,0,'2013-07-06 12:44:34',NULL,NULL),(75017,'93463','S','Ballard','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.632120,-120.116581,0,'2013-07-06 12:44:34',NULL,NULL),(27062,'29686','S','Tamassee','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.902168,-82.978665,0,'2013-07-06 12:44:31',NULL,NULL),(17887,'18444','S','Madison Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(18103,'18762','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.237393,-75.897191,0,'2013-07-06 12:44:31',NULL,NULL),(4209,'02833','S','Hopkinton','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.470453,-71.776086,0,'2013-07-06 12:44:30',NULL,NULL),(13280,'13656','S','Stone Mills','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.191020,-75.955560,0,'2013-07-06 12:44:30',NULL,NULL),(42269,'47581','S','Ironton','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(34599,'38748','S','Darlove','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(27748,'30358','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.934524,-84.388655,0,'2013-07-06 12:44:31',NULL,NULL),(35465,'39503','S','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.473100,-89.153820,0,'2013-07-06 12:44:32',NULL,NULL),(25588,'28444','S','Harrells','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.725227,-78.191649,0,'2013-07-06 12:44:31',NULL,NULL),(62891,'75060','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.798903,-96.950146,0,'2013-07-06 12:44:33',NULL,NULL),(32092,'35293','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463859,-86.823031,0,'2013-07-06 12:44:32',NULL,NULL),(45300,'50833','S','Conway','N','Taylor','19173','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.705800,-94.758900,0,'2013-07-06 12:44:32',NULL,NULL),(20397,'20897','U','Suburban MD BRM','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.087874,-77.054787,0,'2013-07-06 12:44:31',NULL,NULL),(18224,'18966','S','Churchville','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.186800,-75.009660,0,'2013-07-06 12:44:31',NULL,NULL),(2512,'00957','S','Urb Los Dominicos','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(44127,'49509','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.883860,-85.706160,0,'2013-07-06 12:44:32',NULL,NULL),(28487,'31519','S','Pridgen','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.627081,-82.891582,0,'2013-07-06 12:44:32',NULL,NULL),(48593,'55781','S','Side Lake','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.679777,-92.999655,0,'2013-07-06 12:44:33',NULL,NULL),(66635,'78830','S','Big Wells','D','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.553553,-99.556489,0,'2013-07-06 12:44:34',NULL,NULL),(73556,'91361','S','Westlake Vlg','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.152136,-118.846704,0,'2013-07-06 12:44:34',NULL,NULL),(12907,'13338','S','Forestport','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(17439,'17934','S','Gilberton','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.800835,-76.217462,0,'2013-07-06 12:44:31',NULL,NULL),(46980,'54221','P','Manitowoc','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.128906,-87.605902,0,'2013-07-06 12:44:32',NULL,NULL),(25598,'28451','S','Leland','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.213760,-78.038355,0,'2013-07-06 12:44:31',NULL,NULL),(11054,'11576','S','Roslyn Estates','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.774722,-73.656111,0,'2013-07-06 12:44:30',NULL,NULL),(8761,'08536','S','Plainsboro','D','Middlesex','34023','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.335503,-74.577831,0,'2013-07-06 12:44:30',NULL,NULL),(47503,'54764','P','Mondovi','A','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.718965,-91.691873,0,'2013-07-06 12:44:32',NULL,NULL),(68953,'82942','P','Rock Springs','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.680884,-108.784929,0,'2013-07-06 12:44:34',NULL,NULL),(70437,'84739','S','Joseph','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.620592,-112.216866,0,'2013-07-06 12:44:34',NULL,NULL),(11020,'11560','S','Locust Valley','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.877100,-73.611420,0,'2013-07-06 12:44:30',NULL,NULL),(5001,'04219','S','Milton Twp','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.383477,-70.617546,0,'2013-07-06 12:44:30',NULL,NULL),(10380,'10591','S','Sleepy Hollow Manor','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(25281,'28130','P','Paw Creek','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.290852,-80.929304,0,'2013-07-06 12:44:31',NULL,NULL),(77519,'96843','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.302740,-157.850969,0,'2013-07-06 12:44:34',NULL,NULL),(16699,'17402','S','Longstown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(18492,'19092','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952579,-75.181778,0,'2013-07-06 12:44:31',NULL,NULL),(29757,'33002','P','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.901949,-80.305033,0,'2013-07-06 12:44:32',NULL,NULL),(30366,'33315','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.097086,-80.154360,0,'2013-07-06 12:44:32',NULL,NULL),(21002,'21836','P','Manokin','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.330727,-75.806390,0,'2013-07-06 12:44:31',NULL,NULL),(20541,'21108','S','Millersville','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.094433,-76.621588,0,'2013-07-06 12:44:31',NULL,NULL),(39555,'44844','S','McCutchenville','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.981166,-83.270538,0,'2013-07-06 12:44:32',NULL,NULL),(49969,'57353','S','Iroquois','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365169,-97.849047,0,'2013-07-06 12:44:33',NULL,NULL),(53009,'61458','S','Hermon','N','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.794691,-90.166255,0,'2013-07-06 12:44:33',NULL,NULL),(53726,'62246','S','Dudleyville','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(42202,'47551','S','Oriole','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.100381,-86.605274,0,'2013-07-06 12:44:32',NULL,NULL),(31860,'35118','S','Sylvan Springs','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.538080,-87.039240,0,'2013-07-06 12:44:32',NULL,NULL),(53550,'62044','S','Greenfield','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.340418,-90.214125,0,'2013-07-06 12:44:33',NULL,NULL),(69581,'83836','S','Hope','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.241015,-116.292794,0,'2013-07-06 12:44:34',NULL,NULL),(77428,'96803','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308655,-157.858561,0,'2013-07-06 12:44:34',NULL,NULL),(74569,'92688','S','Rancho Santa Margarita','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.651232,-117.593834,0,'2013-07-06 12:44:34',NULL,NULL),(33456,'37320','P','Cleveld','N','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.157670,-84.877175,0,'2013-07-06 12:44:32',NULL,NULL),(41109,'46563','S','Plymouth','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.348915,-86.328202,0,'2013-07-06 12:44:32',NULL,NULL),(46252,'53007','S','Butler','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.106178,-88.070608,0,'2013-07-06 12:44:32',NULL,NULL),(46620,'53577','S','Plain','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.278134,-90.043068,0,'2013-07-06 12:44:32',NULL,NULL),(9966,'10160','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.739111,-73.983857,0,'2013-07-06 12:44:30',NULL,NULL),(43235,'48314','S','Sterling Hts','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.603554,-83.056445,0,'2013-07-06 12:44:32',NULL,NULL),(59864,'71260','S','Oakland','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.909183,-92.241002,0,'2013-07-06 12:44:33',NULL,NULL),(72592,'89406','S','Stillwater','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(39359,'44630','P','Greentown','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.928064,-81.405022,0,'2013-07-06 12:44:32',NULL,NULL),(10358,'10579','S','Adams Corners','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.390553,-73.846426,0,'2013-07-06 12:44:30',NULL,NULL),(4368,'03071','S','New Ipswich','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.776285,-71.884984,0,'2013-07-06 12:44:30',NULL,NULL),(59203,'70381','P','Morgan City','D','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.697242,-91.195094,0,'2013-07-06 12:44:33',NULL,NULL),(76364,'95493','S','Witter Springs','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.186429,-122.962942,0,'2013-07-06 12:44:34',NULL,NULL),(59326,'70532','S','Elton','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.445573,-92.706131,0,'2013-07-06 12:44:33',NULL,NULL),(49461,'56650','S','Shotley','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.957836,-94.483902,0,'2013-07-06 12:44:33',NULL,NULL),(47482,'54749','S','Knapp','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.962067,-92.073568,0,'2013-07-06 12:44:32',NULL,NULL),(39481,'44721','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.882563,-81.346759,0,'2013-07-06 12:44:32',NULL,NULL),(45117,'50560','S','Hanna','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.912847,-94.084571,0,'2013-07-06 12:44:32',NULL,NULL),(28477,'31512','S','Ambrose','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.511182,-83.016275,0,'2013-07-06 12:44:32',NULL,NULL),(12504,'13021','S','Throop','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(50269,'57642','S','Mc Laughlin','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.810968,-100.813494,0,'2013-07-06 12:44:33',NULL,NULL),(53322,'61744','S','Waldo','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.742252,-88.880157,0,'2013-07-06 12:44:33',NULL,NULL),(70892,'85616','S','Huachuca City','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.680383,-110.316970,0,'2013-07-06 12:44:34',NULL,NULL),(3390,'01609','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.276415,-71.819491,0,'2013-07-06 12:44:30',NULL,NULL),(41315,'46773','S','Tillman','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(11572,'12066','S','Burtonsville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.794700,-74.334660,0,'2013-07-06 12:44:30',NULL,NULL),(401,'00662','S','Ext Villa Espana','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(20738,'21290','U','Social Security Admin','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.292820,-76.623790,0,'2013-07-06 12:44:31',NULL,NULL),(36612,'40977','S','Jenson','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(35051,'39179','S','Pickens','A','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.811569,-90.093514,0,'2013-07-06 12:44:32',NULL,NULL),(54136,'62563','S','Breckenridge','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748414,-89.542262,0,'2013-07-06 12:44:33',NULL,NULL),(66916,'79326','S','Fieldton','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.090937,-102.277811,0,'2013-07-06 12:44:34',NULL,NULL),(27857,'30439','S','Excelsior','N','Candler','13043','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.402027,-82.061386,0,'2013-07-06 12:44:31',NULL,NULL),(48911,'56136','S','Hendricks','D','Lincoln','27081','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.504854,-96.411555,0,'2013-07-06 12:44:33',NULL,NULL),(64670,'76821','S','Pony','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.734120,-99.961500,0,'2013-07-06 12:44:34',NULL,NULL),(44659,'50107','S','Grand Junction','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.032301,-94.232040,0,'2013-07-06 12:44:32',NULL,NULL),(36527,'40847','P','Kenvir','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.773063,-83.157662,0,'2013-07-06 12:44:32',NULL,NULL),(24130,'26554','S','Pleasant Vly','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(3762,'02186','S','East Milton','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.249317,-71.074516,0,'2013-07-06 12:44:30',NULL,NULL),(57310,'66636','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.056337,-95.675658,0,'2013-07-06 12:44:33',NULL,NULL),(65257,'77468','S','Pledger','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',29.178450,-95.907313,0,'2013-07-06 12:44:34',NULL,NULL),(71148,'86031','P','Indian Wells','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.404662,-110.085614,0,'2013-07-06 12:44:34',NULL,NULL),(77186,'96326','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(43766,'49024','S','Portage','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.201972,-85.592387,0,'2013-07-06 12:44:32',NULL,NULL),(22703,'24333','S','Galax','D','Galax City','51640','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.660590,-80.923683,0,'2013-07-06 12:44:31',NULL,NULL),(12880,'13327','S','Belfort','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.899822,-75.381978,0,'2013-07-06 12:44:30',NULL,NULL),(12882,'13327','S','Indian River','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.899822,-75.381978,0,'2013-07-06 12:44:30',NULL,NULL),(27633,'30314','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755847,-84.427174,0,'2013-07-06 12:44:31',NULL,NULL),(43328,'48362','S','Orion Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.782837,-83.269237,0,'2013-07-06 12:44:32',NULL,NULL),(37336,'41666','S','Estill','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.456944,-82.818889,0,'2013-07-06 12:44:32',NULL,NULL),(49816,'57212','S','Lake Poinsett','N','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365792,-97.151109,0,'2013-07-06 12:44:33',NULL,NULL),(62946,'75101','P','Bardwell','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.308557,-96.798879,0,'2013-07-06 12:44:33',NULL,NULL),(79405,'98812','S','Monse','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.167400,-119.790720,0,'2013-07-06 12:44:34',NULL,NULL),(163,'00622','S','Villa Taina','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.017976,-67.170627,0,'2013-07-06 12:44:30',NULL,NULL),(27888,'30460','U','GA Southern University','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.444047,-81.745328,0,'2013-07-06 12:44:31',NULL,NULL),(35408,'39464','S','Ovett','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.403056,-89.093336,0,'2013-07-06 12:44:32',NULL,NULL),(63288,'75559','S','College Hill','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(66943,'79364','S','Slaton','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.436854,-101.646192,0,'2013-07-06 12:44:34',NULL,NULL),(73927,'92028','S','Rainbow','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.368660,-117.219178,0,'2013-07-06 12:44:34',NULL,NULL),(75981,'95067','P','Santa Cruz','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.974167,-122.029722,0,'2013-07-06 12:44:34',NULL,NULL),(44024,'49410','S','Fountain','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.016476,-86.135206,0,'2013-07-06 12:44:32',NULL,NULL),(71041,'85743','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.297571,-111.149041,0,'2013-07-06 12:44:34',NULL,NULL),(35284,'39401','S','Dixie','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(57428,'66781','S','Lawton','A','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.298040,-94.755000,0,'2013-07-06 12:44:33',NULL,NULL),(80087,'99740','P','Fort Yukon','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.435007,-145.825007,0,'2013-07-06 12:44:34',NULL,NULL),(44965,'50398','U','West Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.577582,-93.708707,0,'2013-07-06 12:44:32',NULL,NULL),(37359,'41722','S','Tribbey','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(36156,'40241','S','Lyndon','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(11582,'12074','S','Galway','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.032199,-74.036378,0,'2013-07-06 12:44:30',NULL,NULL),(15297,'16137','S','Mercer','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.246287,-80.227378,0,'2013-07-06 12:44:31',NULL,NULL),(13952,'14456','S','Geneva','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.862982,-76.997939,0,'2013-07-06 12:44:31',NULL,NULL),(35891,'40004','S','Bardstown','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.814398,-85.466471,0,'2013-07-06 12:44:32',NULL,NULL),(55908,'64442','S','Eagleville','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.519342,-94.028691,0,'2013-07-06 12:44:33',NULL,NULL),(66615,'78772','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.224319,-97.750289,0,'2013-07-06 12:44:34',NULL,NULL),(20204,'20755','S','Ft George G Meade','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.109680,-76.736935,0,'2013-07-06 12:44:31',NULL,NULL),(31027,'33786','S','Belleair Shrs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(32374,'35901','S','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.008240,-85.944240,0,'2013-07-06 12:44:32',NULL,NULL),(58633,'68866','S','Rusco','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.971884,-99.085142,0,'2013-07-06 12:44:33',NULL,NULL),(61532,'72675','S','Saint Joe','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.965276,-92.812156,0,'2013-07-06 12:44:33',NULL,NULL),(77204,'96370','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(20261,'20784','S','Landover Hills','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(70100,'84170','P','West Valley','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701243,-112.010773,0,'2013-07-06 12:44:34',NULL,NULL),(43806,'49065','S','Lawton','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.148970,-85.838671,0,'2013-07-06 12:44:32',NULL,NULL),(41089,'46538','S','Leesburg','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.333442,-85.842384,0,'2013-07-06 12:44:32',NULL,NULL),(25983,'28664','P','Plumtree','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.027479,-82.004487,0,'2013-07-06 12:44:31',NULL,NULL),(61976,'73190','U','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.458463,-97.516594,0,'2013-07-06 12:44:33',NULL,NULL),(72965,'90045','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.957494,-118.397884,0,'2013-07-06 12:44:34',NULL,NULL),(79443,'98841','S','Disautel','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.360556,-119.236111,0,'2013-07-06 12:44:34',NULL,NULL),(28790,'32050','P','Middleburg','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.072061,-81.861423,0,'2013-07-06 12:44:32',NULL,NULL),(6117,'05457','S','Shawville','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(58259,'68372','S','Holland','A','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.588620,-96.617700,0,'2013-07-06 12:44:33',NULL,NULL),(73766,'91734','P','El Monte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.071829,-118.033314,0,'2013-07-06 12:44:34',NULL,NULL),(79132,'98499','S','Joint Base Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(79674,'99166','S','Republic','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.689698,-118.688669,0,'2013-07-06 12:44:34',NULL,NULL),(16596,'17325','S','Bonneauville','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.851653,-77.260693,0,'2013-07-06 12:44:31',NULL,NULL),(30544,'33410','S','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(55769,'64116','S','Nkc','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(1339,'00736','S','Bo Mogote','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(47440,'54724','S','Bloomer','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.100309,-91.483314,0,'2013-07-06 12:44:32',NULL,NULL),(37429,'41824','S','Isom','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.193878,-82.907404,0,'2013-07-06 12:44:32',NULL,NULL),(55983,'64628','S','Brookfield','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.788893,-93.073091,0,'2013-07-06 12:44:33',NULL,NULL),(56057,'64741','S','Deerfield','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.810088,-94.512447,0,'2013-07-06 12:44:33',NULL,NULL),(22377,'23930','S','Crewe','D','Nottoway','51135','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.178317,-78.120232,0,'2013-07-06 12:44:31',NULL,NULL),(21984,'23255','P','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.588723,-77.567833,0,'2013-07-06 12:44:31',NULL,NULL),(43403,'48450','S','Lexington','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.247918,-82.529194,0,'2013-07-06 12:44:32',NULL,NULL),(20802,'21550','S','Oakland','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(50928,'58566','S','Saint Anthony','D','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.577847,-100.891742,0,'2013-07-06 12:44:33',NULL,NULL),(79225,'98547','S','Heather','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.743694,-124.084377,0,'2013-07-06 12:44:34',NULL,NULL),(32942,'36569','S','St Stephens','A','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.542499,-88.050964,0,'2013-07-06 12:44:32',NULL,NULL),(30998,'33770','S','Belleair Blf','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.920852,-82.799669,0,'2013-07-06 12:44:32',NULL,NULL),(16467,'17241','S','Newville','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(54807,'63020','S','De Soto','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.090460,-90.566700,0,'2013-07-06 12:44:33',NULL,NULL),(64051,'76131','S','Saginaw','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.858146,-97.330601,0,'2013-07-06 12:44:34',NULL,NULL),(74392,'92517','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.964237,-117.432566,0,'2013-07-06 12:44:34',NULL,NULL),(33084,'36790','S','Stanton','D','Chilton','01021','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.707163,-86.917886,0,'2013-07-06 12:44:32',NULL,NULL),(10921,'11430','S','JFK Airport','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.661453,-73.811830,0,'2013-07-06 12:44:30',NULL,NULL),(32446,'36016','S','Clayton','D','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.883510,-85.451006,0,'2013-07-06 12:44:32',NULL,NULL),(58561,'68824','S','South Loup','N','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.999381,-98.612998,0,'2013-07-06 12:44:33',NULL,NULL),(75020,'93465','S','Templeton','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.542784,-120.696367,0,'2013-07-06 12:44:34',NULL,NULL),(32983,'36615','S','Brookley Field','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.628884,-88.072632,0,'2013-07-06 12:44:32',NULL,NULL),(50847,'58487','S','Tappen','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.808647,-99.573506,0,'2013-07-06 12:44:33',NULL,NULL),(77826,'97209','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.531800,-122.681256,0,'2013-07-06 12:44:34',NULL,NULL),(8238,'08002','S','Ellisburg','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.933589,-75.018781,0,'2013-07-06 12:44:30',NULL,NULL),(52188,'60468','S','Peotone','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.335735,-87.792013,0,'2013-07-06 12:44:33',NULL,NULL),(40574,'45868','S','Mt Cory','N','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.968598,-83.837304,0,'2013-07-06 12:44:32',NULL,NULL),(26685,'29404','S','No Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(38781,'44054','S','Sheffield Vlg','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(73093,'90224','P','Compton','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.871965,-118.266771,0,'2013-07-06 12:44:34',NULL,NULL),(53876,'62347','S','Chestline','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.891780,-91.045020,0,'2013-07-06 12:44:33',NULL,NULL),(55488,'63766','S','Millersville','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.445388,-89.810383,0,'2013-07-06 12:44:33',NULL,NULL),(63705,'75886','U','Tenn Colony Prison Michael','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.836617,-95.838882,0,'2013-07-06 12:44:34',NULL,NULL),(44521,'49950','S','Eagle Harbor','A','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.316535,-88.344835,0,'2013-07-06 12:44:32',NULL,NULL),(5708,'04985','S','Moxie Gore','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(9450,'10006','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(40355,'45631','S','Gallipolis','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.821555,-82.196836,0,'2013-07-06 12:44:32',NULL,NULL),(50336,'57735','S','Burdock','A','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(65574,'77857','P','Gause','D','Milam','48331','Texas','TX','48','0000','979','Central',-6.0,'Y',30.783830,-96.722237,0,'2013-07-06 12:44:34',NULL,NULL),(24673,'27409','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.093667,-79.927798,0,'2013-07-06 12:44:31',NULL,NULL),(72841,'89835','S','Arthur','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(11657,'12136','S','Old Chatham','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.469547,-73.556410,0,'2013-07-06 12:44:30',NULL,NULL),(681,'00683','S','Villa Auxerre','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(7814,'07450','S','Ridgewood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.981234,-74.113580,0,'2013-07-06 12:44:30',NULL,NULL),(3259,'01453','S','Leominster','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.525279,-71.753473,0,'2013-07-06 12:44:30',NULL,NULL),(1523,'00754','S','Urb Masso','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(31698,'34947','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.450262,-80.369969,0,'2013-07-06 12:44:32',NULL,NULL),(50920,'58563','S','Hannover','A','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.853700,-101.435580,0,'2013-07-06 12:44:33',NULL,NULL),(55034,'63137','S','Riverview','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748404,-90.218419,0,'2013-07-06 12:44:33',NULL,NULL),(63431,'75666','P','Laird Hill','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.354875,-94.903025,0,'2013-07-06 12:44:33',NULL,NULL),(75275,'93707','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.730268,-119.786943,0,'2013-07-06 12:44:34',NULL,NULL),(30474,'33345','P','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.178308,-80.278398,0,'2013-07-06 12:44:32',NULL,NULL),(47808,'55054','S','Elko New Mrkt','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.571168,-93.354431,0,'2013-07-06 12:44:33',NULL,NULL),(63397,'75647','S','Gladewater','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.528514,-94.941835,0,'2013-07-06 12:44:33',NULL,NULL),(69182,'83335','S','Hazelton','D','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.589603,-114.084730,0,'2013-07-06 12:44:34',NULL,NULL),(46468,'53217','S','Bayside','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(32226,'35576','S','Millport','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.557280,-88.190520,0,'2013-07-06 12:44:32',NULL,NULL),(12357,'12887','S','Low Hampton','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.554480,-73.401960,0,'2013-07-06 12:44:30',NULL,NULL),(30009,'33126','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.774119,-80.290919,0,'2013-07-06 12:44:32',NULL,NULL),(47064,'54423','S','Polonia','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.582844,-89.419872,0,'2013-07-06 12:44:32',NULL,NULL),(79300,'98587','P','Taholah','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.388467,-124.207752,0,'2013-07-06 12:44:34',NULL,NULL),(638,'00682','S','Urb Hostos','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(23588,'25672','S','Vulcan','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.578967,-82.106525,0,'2013-07-06 12:44:31',NULL,NULL),(21215,'22209','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.894486,-77.074049,0,'2013-07-06 12:44:31',NULL,NULL),(42460,'47833','S','Bowling Green','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.475140,-87.107054,0,'2013-07-06 12:44:32',NULL,NULL),(41140,'46660','P','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.695627,-86.214440,0,'2013-07-06 12:44:32',NULL,NULL),(14928,'15552','S','Meyersdale','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.807027,-79.028327,0,'2013-07-06 12:44:31',NULL,NULL),(3771,'02190','S','South Weymouth','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.171028,-70.948119,0,'2013-07-06 12:44:30',NULL,NULL),(25916,'28646','P','Linville','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.067758,-81.877449,0,'2013-07-06 12:44:31',NULL,NULL),(25247,'28108','P','Mineral Springs','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.930216,-80.675564,0,'2013-07-06 12:44:31',NULL,NULL),(50458,'58030','S','Fairmount','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.054050,-96.603632,0,'2013-07-06 12:44:33',NULL,NULL),(75778,'94666','U','Kaiser Services','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.809816,-122.265531,0,'2013-07-06 12:44:34',NULL,NULL),(18762,'19352','S','Lincoln University','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.769645,-75.890630,0,'2013-07-06 12:44:31',NULL,NULL),(21443,'22578','S','White Stone','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.650000,-76.383333,0,'2013-07-06 12:44:31',NULL,NULL),(48755,'55974','S','Spring Grove','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.562636,-91.635986,0,'2013-07-06 12:44:33',NULL,NULL),(22731,'24368','S','Rural Retreat','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.899249,-81.271748,0,'2013-07-06 12:44:31',NULL,NULL),(53226,'61636','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700195,-89.598587,0,'2013-07-06 12:44:33',NULL,NULL),(76564,'95669','S','Plymouth','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.492195,-120.861610,0,'2013-07-06 12:44:34',NULL,NULL),(12353,'12885','S','Thurman','A','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.500656,-73.787701,0,'2013-07-06 12:44:30',NULL,NULL),(14809,'15413','S','Allison','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.986358,-79.879281,0,'2013-07-06 12:44:31',NULL,NULL),(5056,'04275','S','Byron','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.688667,-70.639514,0,'2013-07-06 12:44:30',NULL,NULL),(15644,'16734','P','James City','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.545864,-78.880068,0,'2013-07-06 12:44:31',NULL,NULL),(56593,'65557','S','Roby','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.496161,-92.114035,0,'2013-07-06 12:44:33',NULL,NULL),(71724,'87532','S','Guachupangue','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(20362,'20877','S','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.141703,-77.193419,0,'2013-07-06 12:44:31',NULL,NULL),(16789,'17536','S','Colerain','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.849151,-76.087262,0,'2013-07-06 12:44:31',NULL,NULL),(49042,'56288','S','Spicer','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.246236,-94.950221,0,'2013-07-06 12:44:33',NULL,NULL),(54965,'63121','S','Normandy','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(51817,'60051','S','Johnsburg','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.342172,-88.289042,0,'2013-07-06 12:44:33',NULL,NULL),(45428,'51062','S','Millnerville','N','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.710245,-96.486217,0,'2013-07-06 12:44:32',NULL,NULL),(17261,'17842','S','Coon Hunter','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(12939,'13348','S','Patent','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695880,-75.066180,0,'2013-07-06 12:44:30',NULL,NULL),(48106,'55346','S','Eden Prairie','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.881077,-93.482453,0,'2013-07-06 12:44:33',NULL,NULL),(62823,'74959','S','Fort Coffee','A','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.243226,-94.611070,0,'2013-07-06 12:44:33',NULL,NULL),(72409,'89046','S','Nelson','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.466505,-114.918847,0,'2013-07-06 12:44:34',NULL,NULL),(77879,'97267','S','Oak Grove','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(6810,'06110','S','Elmwood','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(6266,'05603','U','Dept Motor Vehicles','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262128,-72.584362,0,'2013-07-06 12:44:30',NULL,NULL),(71630,'87410','S','Aztec','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.839533,-107.992684,0,'2013-07-06 12:44:34',NULL,NULL),(24093,'26505','S','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.636473,-79.951111,0,'2013-07-06 12:44:31',NULL,NULL),(41478,'46931','P','Fulton','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.948398,-86.265871,0,'2013-07-06 12:44:32',NULL,NULL),(30127,'33162','S','North Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(48724,'55956','S','Mazeppa','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.276489,-92.544678,0,'2013-07-06 12:44:33',NULL,NULL),(69194,'83343','P','Minidoka','D','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.753889,-113.489444,0,'2013-07-06 12:44:34',NULL,NULL),(73344,'90899','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.767496,-118.187712,0,'2013-07-06 12:44:34',NULL,NULL),(26459,'29143','P','Sardinia','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.836621,-80.080723,0,'2013-07-06 12:44:31',NULL,NULL),(24343,'27040','S','Pfafftown','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.167058,-80.376170,0,'2013-07-06 12:44:31',NULL,NULL),(13690,'14052','S','East Aurora','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.771162,-78.563272,0,'2013-07-06 12:44:31',NULL,NULL),(16078,'17050','S','Hogestown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(2830,'00979','S','Villa La Marina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(10767,'11364','S','Bayside Hills','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(6193,'05483','S','Crow Hill','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(38071,'43066','S','Radnor','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.396842,-83.162111,0,'2013-07-06 12:44:32',NULL,NULL),(47359,'54615','S','Black River Falls','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.290491,-90.846708,0,'2013-07-06 12:44:32',NULL,NULL),(72868,'90007','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.026525,-118.282408,0,'2013-07-06 12:44:34',NULL,NULL),(7083,'06349','P','Sub Base New London','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.401943,-72.089280,0,'2013-07-06 12:44:30',NULL,NULL),(34198,'38338','P','Gibson','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.870429,-88.847930,0,'2013-07-06 12:44:32',NULL,NULL),(35546,'39563','S','Pascagoula','A','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(44410,'49826','P','Rumely','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.342560,-86.920968,0,'2013-07-06 12:44:32',NULL,NULL),(10892,'11424','P','Borough Hall','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.706550,-73.828147,0,'2013-07-06 12:44:30',NULL,NULL),(27061,'29685','S','Sunset','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.920954,-82.821687,0,'2013-07-06 12:44:31',NULL,NULL),(30866,'33664','U','Time Cs Brm Unique','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.967760,-82.518250,0,'2013-07-06 12:44:32',NULL,NULL),(43734,'48937','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.783292,-84.571296,0,'2013-07-06 12:44:32',NULL,NULL),(43483,'48609','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.410854,-84.090410,0,'2013-07-06 12:44:32',NULL,NULL),(52313,'60551','S','Sheridan','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.516340,-88.716780,0,'2013-07-06 12:44:33',NULL,NULL),(52940,'61379','S','Wyanet','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.363337,-89.578893,0,'2013-07-06 12:44:33',NULL,NULL),(63611,'75802','P','Palestine','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.761164,-95.633435,0,'2013-07-06 12:44:34',NULL,NULL),(65925,'78244','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.479985,-98.352567,0,'2013-07-06 12:44:34',NULL,NULL),(66538,'78727','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.424886,-97.713998,0,'2013-07-06 12:44:34',NULL,NULL),(67533,'80256','U','Us Bank','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.750699,-104.989735,0,'2013-07-06 12:44:34',NULL,NULL),(67024,'79536','S','Blair','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.449860,-99.988740,0,'2013-07-06 12:44:34',NULL,NULL),(78530,'98129','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.615110,-122.338189,0,'2013-07-06 12:44:34',NULL,NULL),(45491,'51354','S','Allendorf','A','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.415978,-95.533305,0,'2013-07-06 12:44:32',NULL,NULL),(33244,'37074','S','Hartsville','D','Trousdale','47169','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.387273,-86.159417,0,'2013-07-06 12:44:32',NULL,NULL),(15729,'16881','S','Woodland','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.016750,-78.326243,0,'2013-07-06 12:44:31',NULL,NULL),(20786,'21540','S','Westernport','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.479099,-79.055699,0,'2013-07-06 12:44:31',NULL,NULL),(29062,'32245','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.247865,-81.549311,0,'2013-07-06 12:44:32',NULL,NULL),(60297,'71454','S','Montgomery','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(64359,'76522','S','Copperas Cove','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.138380,-97.934220,0,'2013-07-06 12:44:34',NULL,NULL),(35006,'39130','P','Madison','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.462957,-90.114896,0,'2013-07-06 12:44:32',NULL,NULL),(63325,'75572','S','Domino','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.175260,-94.152300,0,'2013-07-06 12:44:33',NULL,NULL),(33607,'37642','S','Church Hill','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.528984,-82.698396,0,'2013-07-06 12:44:32',NULL,NULL),(21037,'21869','S','Salem','N','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.432760,-75.893700,0,'2013-07-06 12:44:31',NULL,NULL),(53767,'62268','S','Oakdale','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.263313,-89.588808,0,'2013-07-06 12:44:33',NULL,NULL),(75933,'95021','P','Gilroy','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.014460,-121.549589,0,'2013-07-06 12:44:34',NULL,NULL),(32024,'35242','S','Birmingham','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(27690,'30338','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(23991,'26335','S','Burnsville','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.848620,-80.650380,0,'2013-07-06 12:44:31',NULL,NULL),(19218,'19894','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.748520,-75.544089,0,'2013-07-06 12:44:31',NULL,NULL),(75969,'95056','P','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.400588,-121.963467,0,'2013-07-06 12:44:34',NULL,NULL),(6155,'05471','S','Alpine Haven','N','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.860467,-72.593608,0,'2013-07-06 12:44:30',NULL,NULL),(42677,'47970','S','Otterbein','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.487792,-87.096309,0,'2013-07-06 12:44:32',NULL,NULL),(5091,'04341','P','Coopers Mills','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.274799,-69.495465,0,'2013-07-06 12:44:30',NULL,NULL),(43017,'48164','S','Willow','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(48143,'55365','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.277823,-93.805566,0,'2013-07-06 12:44:33',NULL,NULL),(67802,'80736','S','Iliff','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.808431,-103.046988,0,'2013-07-06 12:44:34',NULL,NULL),(49288,'56520','S','Brushvale','N','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.268423,-96.587538,0,'2013-07-06 12:44:33',NULL,NULL),(49859,'57247','S','Red Iron Lake','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.698550,-97.352584,0,'2013-07-06 12:44:33',NULL,NULL),(2806,'00976','S','Urb Rio Cristal','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(5353,'04614','S','Blue Hill','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.317750,-68.632382,0,'2013-07-06 12:44:30',NULL,NULL),(23678,'25840','S','Gatewood','N','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(41451,'46897','U','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069224,-85.161465,0,'2013-07-06 12:44:32',NULL,NULL),(29220,'32420','S','Alford','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.643610,-85.377228,0,'2013-07-06 12:44:32',NULL,NULL),(39334,'44615','S','Kilgore','N','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(38927,'44122','S','Orange Village','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(38455,'43609','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.630611,-83.576936,0,'2013-07-06 12:44:32',NULL,NULL),(65495,'77659','S','Sour Lake','D','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.164700,-94.350960,0,'2013-07-06 12:44:34',NULL,NULL),(77137,'96157','P','Stateline','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.940824,-119.980263,0,'2013-07-06 12:44:34',NULL,NULL),(26427,'29127','S','Prosperity','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.182431,-81.520940,0,'2013-07-06 12:44:31',NULL,NULL),(31762,'35004','S','Acmar','A','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.592120,-86.497541,0,'2013-07-06 12:44:32',NULL,NULL),(48456,'55711','S','Brookston','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.856672,-92.673076,0,'2013-07-06 12:44:33',NULL,NULL),(54456,'62851','S','Stratton','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.364300,-88.656120,0,'2013-07-06 12:44:33',NULL,NULL),(71985,'88026','P','Central','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.776365,-108.150858,0,'2013-07-06 12:44:34',NULL,NULL),(73365,'91021','P','Montrose','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.206931,-118.225323,0,'2013-07-06 12:44:34',NULL,NULL),(79730,'99215','P','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.690874,-117.209831,0,'2013-07-06 12:44:34',NULL,NULL),(42163,'47523','S','Pigeon','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.173260,-86.999460,0,'2013-07-06 12:44:32',NULL,NULL),(30615,'33433','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.348386,-80.157870,0,'2013-07-06 12:44:32',NULL,NULL),(5201,'04453','S','Lagrange','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.211211,-68.824655,0,'2013-07-06 12:44:30',NULL,NULL),(75193,'93618','S','Dinuba','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.546422,-119.388990,0,'2013-07-06 12:44:34',NULL,NULL),(22633,'24246','P','E Stone Gap','A','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.847723,-82.759128,0,'2013-07-06 12:44:31',NULL,NULL),(11515,'12032','S','Wheelerville','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.161683,-74.493710,0,'2013-07-06 12:44:30',NULL,NULL),(17795,'18357','P','Skytop','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.225145,-75.236122,0,'2013-07-06 12:44:31',NULL,NULL),(39530,'44827','S','Crestline','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.799552,-82.760593,0,'2013-07-06 12:44:32',NULL,NULL),(5117,'04360','S','Vienna','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.535941,-69.982382,0,'2013-07-06 12:44:30',NULL,NULL),(57090,'66217','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(72540,'89178','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.997544,-115.270936,0,'2013-07-06 12:44:34',NULL,NULL),(74833,'93238','S','River Kern','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.752376,-118.424275,0,'2013-07-06 12:44:34',NULL,NULL),(30515,'33404','S','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(5406,'04658','S','Milbridge','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.531702,-67.885557,0,'2013-07-06 12:44:30',NULL,NULL),(26187,'28761','S','Nebo','D','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.665956,-81.912008,0,'2013-07-06 12:44:31',NULL,NULL),(1134,'00725','S','Villa Turabo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(55538,'63837','S','Clarkton','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.450728,-89.964168,0,'2013-07-06 12:44:33',NULL,NULL),(56731,'65707','S','Miller','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.231449,-93.849869,0,'2013-07-06 12:44:33',NULL,NULL),(65768,'78104','P','Beeville','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.410830,-97.760692,0,'2013-07-06 12:44:34',NULL,NULL),(78301,'97902','P','Arock','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.915800,-117.480396,0,'2013-07-06 12:44:34',NULL,NULL),(9905,'10131','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.785617,-73.949816,0,'2013-07-06 12:44:30',NULL,NULL),(11778,'12205','S','Colonie','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.714746,-73.821155,0,'2013-07-06 12:44:30',NULL,NULL),(45207,'50629','S','Fairbank','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.639336,-92.048600,0,'2013-07-06 12:44:32',NULL,NULL),(44013,'49357','U','Amway Corp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.950385,-85.487478,0,'2013-07-06 12:44:32',NULL,NULL),(17513,'17963','S','Stanhope','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(6653,'06020','S','Cherry Brook','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.849426,-72.922674,0,'2013-07-06 12:44:30',NULL,NULL),(4692,'03811','S','Atkinson','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.838549,-71.159313,0,'2013-07-06 12:44:30',NULL,NULL),(26822,'29483','S','Knightsville','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.017824,-80.211350,0,'2013-07-06 12:44:31',NULL,NULL),(5631,'04945','S','Jackman','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(50924,'58564','S','Raleigh','D','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.337217,-101.260167,0,'2013-07-06 12:44:33',NULL,NULL),(56668,'65626','S','Caulfield','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.597540,-92.075058,0,'2013-07-06 12:44:33',NULL,NULL),(46623,'53579','S','Reeseville','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.303699,-88.844663,0,'2013-07-06 12:44:32',NULL,NULL),(37426,'41821','S','Skyline','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.075833,-82.981667,0,'2013-07-06 12:44:32',NULL,NULL),(74697,'93002','P','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.280703,-119.286797,0,'2013-07-06 12:44:34',NULL,NULL),(17357,'17872','S','Gowen City','A','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(40770,'46154','P','Maxwell','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.858357,-85.767408,0,'2013-07-06 12:44:32',NULL,NULL),(13915,'14305','S','Niagara Falls','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.117629,-79.029190,0,'2013-07-06 12:44:31',NULL,NULL),(5515,'04774','S','Saint Francis','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.101533,-69.051562,0,'2013-07-06 12:44:30',NULL,NULL),(1833,'00784','S','Urb Guayama Valley','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(34243,'38388','S','Parker Xroads','A','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.721022,-88.390326,0,'2013-07-06 12:44:32',NULL,NULL),(49906,'57279','S','Wilmot','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.414998,-96.867332,0,'2013-07-06 12:44:33',NULL,NULL),(53263,'61709','U','State Farm Ins Il Region Ofc','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.458619,-88.961117,0,'2013-07-06 12:44:33',NULL,NULL),(58069,'68056','S','St Columbans','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.091485,-96.053536,0,'2013-07-06 12:44:33',NULL,NULL),(69029,'83215','S','Atomic City','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.444204,-112.811672,0,'2013-07-06 12:44:34',NULL,NULL),(77404,'96783','S','Pepeekeo','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.830916,-155.112189,0,'2013-07-06 12:44:34',NULL,NULL),(44265,'49689','S','Wellston','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.212918,-85.937123,0,'2013-07-06 12:44:32',NULL,NULL),(39732,'45066','S','Springboro','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.558963,-84.223222,0,'2013-07-06 12:44:32',NULL,NULL),(51383,'59414','S','Black Eagle','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.514757,-111.298086,0,'2013-07-06 12:44:33',NULL,NULL),(53929,'62401','S','Lillyville','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(55719,'64076','S','Odessa','D','Lafayette','29107','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.996451,-93.953938,0,'2013-07-06 12:44:33',NULL,NULL),(58683,'68923','P','Atlanta','D','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.453315,-99.343230,0,'2013-07-06 12:44:33',NULL,NULL),(61889,'73135','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.391618,-97.423072,0,'2013-07-06 12:44:33',NULL,NULL),(8644,'08302','S','Fairfield Twp','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.438881,-75.228175,0,'2013-07-06 12:44:30',NULL,NULL),(2890,'00987','S','Parq Ecuestre','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(71359,'86540','P','Ganado','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.607281,-109.461036,0,'2013-07-06 12:44:34',NULL,NULL),(17559,'17981','S','Tremont','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(46203,'52755','S','Lone Tree','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.483617,-91.428653,0,'2013-07-06 12:44:32',NULL,NULL),(31831,'35073','S','Graysville','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.621087,-86.958247,0,'2013-07-06 12:44:32',NULL,NULL),(46448,'53210','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.068996,-87.978957,0,'2013-07-06 12:44:32',NULL,NULL),(62914,'75076','S','Pottsboro','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.772595,-96.668922,0,'2013-07-06 12:44:33',NULL,NULL),(23522,'25565','S','Morrisvale','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.077916,-81.994264,0,'2013-07-06 12:44:31',NULL,NULL),(5699,'04982','S','Stratton','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.094714,-70.467559,0,'2013-07-06 12:44:30',NULL,NULL),(24898,'27710','U','Duke Medical Ctr','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.001767,-78.940724,0,'2013-07-06 12:44:31',NULL,NULL),(45230,'50645','S','Ionia','D','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.047060,-92.485200,0,'2013-07-06 12:44:32',NULL,NULL),(38439,'43566','S','Waterville','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.501296,-83.738531,0,'2013-07-06 12:44:32',NULL,NULL),(52651,'61063','S','Pecatonica','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.308534,-89.332123,0,'2013-07-06 12:44:33',NULL,NULL),(74066,'92167','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.746726,-117.244389,0,'2013-07-06 12:44:34',NULL,NULL),(37269,'41572','S','Hartley','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.341120,-82.650600,0,'2013-07-06 12:44:32',NULL,NULL),(71584,'87313','P','Lake Valley','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.798788,-107.923273,0,'2013-07-06 12:44:34',NULL,NULL),(11756,'12194','S','W Fulton','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.538560,-74.454716,0,'2013-07-06 12:44:30',NULL,NULL),(40619,'46011','S','Country Club Heights','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(36459,'40729','S','East Bernstadt','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.204331,-84.118241,0,'2013-07-06 12:44:32',NULL,NULL),(34096,'38168','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229844,-89.924595,0,'2013-07-06 12:44:32',NULL,NULL),(8098,'07764','S','W Long Branch','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.289869,-74.022463,0,'2013-07-06 12:44:30',NULL,NULL),(14151,'14716','S','Brocton','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.387620,-79.435150,0,'2013-07-06 12:44:31',NULL,NULL),(61952,'73165','S','Oklahoma City','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.334300,-97.345860,0,'2013-07-06 12:44:33',NULL,NULL),(70981,'85706','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.117700,-110.894100,0,'2013-07-06 12:44:34',NULL,NULL),(77481,'96822','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312545,-157.821044,0,'2013-07-06 12:44:34',NULL,NULL),(74666,'92859','P','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.802656,-117.786690,0,'2013-07-06 12:44:34',NULL,NULL),(62379,'74078','U','OK St Unv Adm','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.115627,-97.058038,0,'2013-07-06 12:44:33',NULL,NULL),(12076,'12550','S','Newburgh','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.517480,-74.060220,0,'2013-07-06 12:44:30',NULL,NULL),(7265,'06518','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.415836,-72.912377,0,'2013-07-06 12:44:30',NULL,NULL),(7242,'06512','S','East Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.285640,-72.863580,0,'2013-07-06 12:44:30',NULL,NULL),(21272,'22310','S','Franconia','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.782980,-77.119980,0,'2013-07-06 12:44:31',NULL,NULL),(13819,'14215','S','Cheektowaga','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.933454,-78.811840,0,'2013-07-06 12:44:31',NULL,NULL),(49889,'57269','S','Twin Brooks','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.212479,-97.022662,0,'2013-07-06 12:44:33',NULL,NULL),(11407,'11956','P','New Suffolk','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.992282,-72.477555,0,'2013-07-06 12:44:30',NULL,NULL),(7313,'06650','S','Stratmar Fulfillment Corp','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.175730,-73.198823,0,'2013-07-06 12:44:30',NULL,NULL),(55571,'63873','S','Point Pleasant','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.430781,-89.697849,0,'2013-07-06 12:44:33',NULL,NULL),(62652,'74601','S','Ponca City','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.709082,-97.087737,0,'2013-07-06 12:44:33',NULL,NULL),(13340,'13685','S','Sackets Hbr','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.943471,-76.111664,0,'2013-07-06 12:44:30',NULL,NULL),(20075,'20684','S','Saint Inigoes','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.152561,-76.413819,0,'2013-07-06 12:44:31',NULL,NULL),(79277,'98576','S','Vail','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.880851,-122.677494,0,'2013-07-06 12:44:34',NULL,NULL),(23684,'25845','S','Glen Fork','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.653271,-81.528241,0,'2013-07-06 12:44:31',NULL,NULL),(45831,'52212','S','Center Junction','D','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.078396,-91.073294,0,'2013-07-06 12:44:32',NULL,NULL),(52745,'61241','S','Colona','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.481385,-90.329909,0,'2013-07-06 12:44:33',NULL,NULL),(53224,'61635','U','Peoria','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.708299,-89.522384,0,'2013-07-06 12:44:33',NULL,NULL),(15772,'16921','S','Elk','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(44445,'49862','S','Munising','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.416420,-86.623980,0,'2013-07-06 12:44:32',NULL,NULL),(47223,'54498','S','Longwood','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953103,-90.595538,0,'2013-07-06 12:44:32',NULL,NULL),(71982,'88024','P','Anthony','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.068056,-106.623056,0,'2013-07-06 12:44:34',NULL,NULL),(79974,'99649','P','Pilot Point','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.594513,-157.486964,0,'2013-07-06 12:44:34',NULL,NULL),(46582,'53535','P','Edmund','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.969874,-90.262851,0,'2013-07-06 12:44:32',NULL,NULL),(13526,'13815','S','Woods Corners','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.530787,-75.524876,0,'2013-07-06 12:44:31',NULL,NULL),(54593,'62901','S','Triple Lake Heights','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(71916,'87824','P','Luna','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.653596,-108.763903,0,'2013-07-06 12:44:34',NULL,NULL),(38047,'43041','U','O M Scott Co','N','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.238271,-83.368023,0,'2013-07-06 12:44:32',NULL,NULL),(70832,'85502','P','Globe','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.390002,-110.784264,0,'2013-07-06 12:44:34',NULL,NULL),(27473,'30145','S','Kingston','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.236623,-84.966540,0,'2013-07-06 12:44:31',NULL,NULL),(27429,'30109','P','Bowdon Junction','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.567436,-85.081472,0,'2013-07-06 12:44:31',NULL,NULL),(54890,'63069','S','Pacific','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.491435,-90.765094,0,'2013-07-06 12:44:33',NULL,NULL),(4606,'03590','S','Columbia','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.719190,-71.465831,0,'2013-07-06 12:44:30',NULL,NULL),(45795,'52170','S','Dalby','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.271561,-91.258309,0,'2013-07-06 12:44:32',NULL,NULL),(35992,'40140','S','Garfield','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.814276,-86.321436,0,'2013-07-06 12:44:32',NULL,NULL),(30196,'33180','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.961901,-80.140608,0,'2013-07-06 12:44:32',NULL,NULL),(22225,'23603','S','Lee Hall','N','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.190578,-76.562567,0,'2013-07-06 12:44:31',NULL,NULL),(24146,'26572','P','Four States','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.480390,-80.309372,0,'2013-07-06 12:44:31',NULL,NULL),(9336,'09750','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(64057,'76134','S','Edgecliff Village','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.642955,-97.327416,0,'2013-07-06 12:44:34',NULL,NULL),(66750,'79007','S','Phillips','A','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.677980,-101.416380,0,'2013-07-06 12:44:34',NULL,NULL),(9681,'10043','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(8978,'08827','S','Hampton','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.678752,-74.963414,0,'2013-07-06 12:44:30',NULL,NULL),(72968,'90046','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105576,-118.366794,0,'2013-07-06 12:44:34',NULL,NULL),(35200,'39288','P','Pearl','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.300020,-90.145549,0,'2013-07-06 12:44:32',NULL,NULL),(23284,'25164','S','Ovapa','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.470869,-81.222751,0,'2013-07-06 12:44:31',NULL,NULL),(31057,'33839','S','Eagle Lake','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.979013,-81.758014,0,'2013-07-06 12:44:32',NULL,NULL),(57261,'66539','S','Silver Lake','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.142234,-95.865541,0,'2013-07-06 12:44:33',NULL,NULL),(65019,'77306','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.323320,-95.471373,0,'2013-07-06 12:44:34',NULL,NULL),(73674,'91601','S','Toluca Ter','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(75856,'94938','P','Lagunitas','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.011317,-122.696447,0,'2013-07-06 12:44:34',NULL,NULL),(11156,'11720','S','Centereach','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.871518,-73.084611,0,'2013-07-06 12:44:30',NULL,NULL),(35667,'39653','S','Bunkley','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.455600,-90.879660,0,'2013-07-06 12:44:32',NULL,NULL),(9977,'10162','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(3498,'01851','S','Lowell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.631561,-71.333924,0,'2013-07-06 12:44:30',NULL,NULL),(16169,'17064','P','Mt Gretna Hts','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.245217,-76.468668,0,'2013-07-06 12:44:31',NULL,NULL),(49130,'56362','S','Spring Hill','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.407807,-94.699248,0,'2013-07-06 12:44:33',NULL,NULL),(70233,'84404','S','Slaterville','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(35164,'39250','U','Regions Bank','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291319,-90.185931,0,'2013-07-06 12:44:32',NULL,NULL),(31469,'34290','P','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.043504,-82.236065,0,'2013-07-06 12:44:32',NULL,NULL),(18134,'18828','S','Lawton','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.764619,-76.094363,0,'2013-07-06 12:44:31',NULL,NULL),(27761,'30362','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.900867,-84.276425,0,'2013-07-06 12:44:31',NULL,NULL),(31215,'33954','S','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.023295,-82.107696,0,'2013-07-06 12:44:32',NULL,NULL),(57796,'67490','S','Wilson','D','Ellsworth','20053','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.822228,-98.476081,0,'2013-07-06 12:44:33',NULL,NULL),(77853,'97227','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.545380,-122.675530,0,'2013-07-06 12:44:34',NULL,NULL),(78834,'98335','S','Rosedale','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(45990,'52501','S','Bladensburg','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(18498,'19096','S','Carroll Park','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002510,-75.273155,0,'2013-07-06 12:44:31',NULL,NULL),(60752,'71998','U','Arkadelphia','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.129042,-93.051992,0,'2013-07-06 12:44:33',NULL,NULL),(67089,'79698','U','Hardin Simmons University','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.474862,-99.732695,0,'2013-07-06 12:44:34',NULL,NULL),(12470,'12983','S','Harrietstown','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.316720,-74.133540,0,'2013-07-06 12:44:30',NULL,NULL),(14790,'15363','S','Strabane','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.249108,-80.198615,0,'2013-07-06 12:44:31',NULL,NULL),(10391,'10601','S','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.030604,-73.763940,0,'2013-07-06 12:44:30',NULL,NULL),(11225,'11749','S','Ronkonkoma','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.809863,-73.179536,0,'2013-07-06 12:44:30',NULL,NULL),(55355,'63559','S','Youngstown','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(71209,'86312','P','Prescott Valley','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.616549,-112.325635,0,'2013-07-06 12:44:34',NULL,NULL),(22904,'24599','S','Wingina','D','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.623270,-78.759548,0,'2013-07-06 12:44:31',NULL,NULL),(39443,'44695','S','Bowerston','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.415653,-81.173846,0,'2013-07-06 12:44:32',NULL,NULL),(6752,'06087','U','Accr A Data','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756912,-72.885302,0,'2013-07-06 12:44:30',NULL,NULL),(8002,'07719','S','W Belmar','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(50217,'57580','S','Millboro','A','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(50237,'57622','S','Elwood','N','Ziebach','46137','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.611279,-101.796280,0,'2013-07-06 12:44:33',NULL,NULL),(56149,'64853','P','Neosho','A','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.877158,-94.187271,0,'2013-07-06 12:44:33',NULL,NULL),(59290,'70471','S','Mandeville','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.415777,-90.010249,0,'2013-07-06 12:44:33',NULL,NULL),(19338,'20035','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905389,-77.039447,0,'2013-07-06 12:44:31',NULL,NULL),(39378,'44645','S','Marshallville','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.906247,-81.727510,0,'2013-07-06 12:44:32',NULL,NULL),(34300,'38542','S','Allred','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.366955,-85.194450,0,'2013-07-06 12:44:32',NULL,NULL),(64471,'76577','S','Lilac','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(66226,'78563','S','Puerto Rico','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.581920,-98.171520,0,'2013-07-06 12:44:34',NULL,NULL),(73807,'91756','U','Monterey Park','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.047565,-118.132799,0,'2013-07-06 12:44:34',NULL,NULL),(77448,'96810','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304604,-157.858316,0,'2013-07-06 12:44:34',NULL,NULL),(38,'00603','S','Urb San Carlos','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(19869,'20526','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900668,-77.045582,0,'2013-07-06 12:44:31',NULL,NULL),(35791,'39751','S','Hohenlinden','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.733333,-89.066667,0,'2013-07-06 12:44:32',NULL,NULL),(52538,'60930','S','Danforth','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.824845,-87.981206,0,'2013-07-06 12:44:33',NULL,NULL),(4900,'04057','P','N Bridgton','A','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.042997,-70.737469,0,'2013-07-06 12:44:30',NULL,NULL),(4816,'03902','S','Cape Neddick','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.211238,-70.614151,0,'2013-07-06 12:44:30',NULL,NULL),(9279,'09626','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(23171,'25026','P','Blue Creek','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.439374,-81.460289,0,'2013-07-06 12:44:31',NULL,NULL),(17947,'18510','S','Dunmore','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.413287,-75.639206,0,'2013-07-06 12:44:31',NULL,NULL),(60270,'71447','S','Gooberville','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(72538,'89177','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.083659,-115.148315,0,'2013-07-06 12:44:34',NULL,NULL),(5372,'04629','P','E Blue Hill','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.415507,-68.521466,0,'2013-07-06 12:44:30',NULL,NULL),(14138,'14701','S','West Ellicott','A','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.094174,-79.251081,0,'2013-07-06 12:44:31',NULL,NULL),(39991,'45241','S','West Chester','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267662,-84.405863,0,'2013-07-06 12:44:32',NULL,NULL),(23069,'24879','S','Raysal','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.349167,-81.762778,0,'2013-07-06 12:44:31',NULL,NULL),(31051,'33831','P','Bartow','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.895368,-81.842203,0,'2013-07-06 12:44:32',NULL,NULL),(30353,'33313','S','City of Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(47117,'54451','S','Chelsea','A','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(67495,'80234','S','Broomfield','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(25197,'28074','P','Harris','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.243572,-81.876734,0,'2013-07-06 12:44:31',NULL,NULL),(4058,'02645','S','E Harwich','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.703441,-70.062208,0,'2013-07-06 12:44:30',NULL,NULL),(58211,'68332','S','Crab Orchard','D','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.305568,-96.406515,0,'2013-07-06 12:44:33',NULL,NULL),(13051,'13440','S','Greenway','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(11297,'11777','S','P J S','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(26711,'29412','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.719260,-79.951080,0,'2013-07-06 12:44:31',NULL,NULL),(4304,'02908','S','N Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.847393,-71.449537,0,'2013-07-06 12:44:30',NULL,NULL),(20455,'21020','P','Boring','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.523939,-76.816901,0,'2013-07-06 12:44:31',NULL,NULL),(68114,'80947','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832634,-104.819249,0,'2013-07-06 12:44:34',NULL,NULL),(23644,'25778','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.418340,-82.474262,0,'2013-07-06 12:44:31',NULL,NULL),(39409,'44665','P','North Georgetown','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.839273,-80.986030,0,'2013-07-06 12:44:32',NULL,NULL),(48961,'56183','S','Dovray','A','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.043900,-95.436643,0,'2013-07-06 12:44:33',NULL,NULL),(58800,'69001','S','Mc Cook','D','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.176361,-100.653340,0,'2013-07-06 12:44:33',NULL,NULL),(16193,'17070','S','Fair Acres','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(42755,'48028','S','Harsens Is','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.577729,-82.602065,0,'2013-07-06 12:44:32',NULL,NULL),(71548,'87185','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.983749,-106.516060,0,'2013-07-06 12:44:34',NULL,NULL),(74753,'93064','U','Brandeis','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.283831,-118.688394,0,'2013-07-06 12:44:34',NULL,NULL),(78055,'97452','S','Lowell','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.913554,-122.765716,0,'2013-07-06 12:44:34',NULL,NULL),(44685,'50125','S','Medora','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.315040,-93.572040,0,'2013-07-06 12:44:32',NULL,NULL),(54623,'62917','S','Dallasania','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.690197,-88.627956,0,'2013-07-06 12:44:33',NULL,NULL),(55234,'63437','S','Maud','N','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738419,-92.263023,0,'2013-07-06 12:44:33',NULL,NULL),(61999,'73433','S','Pernell','A','Garvin','40049','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.615413,-97.404541,0,'2013-07-06 12:44:33',NULL,NULL),(68435,'81223','S','Cotopaxi','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.362980,-105.495600,0,'2013-07-06 12:44:34',NULL,NULL),(79654,'99148','S','Loon Lake','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.055306,-117.616975,0,'2013-07-06 12:44:34',NULL,NULL),(8344,'08043','S','Kirkwd Voorhs','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(34549,'38722','P','Arcola','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.267536,-90.881204,0,'2013-07-06 12:44:32',NULL,NULL),(46956,'54180','S','Wrightstown','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.325104,-88.169588,0,'2013-07-06 12:44:32',NULL,NULL),(66902,'79257','S','Silverton','D','Briscoe','48045','Texas','TX','48','0000','806','Central',-6.0,'Y',34.471610,-101.308331,0,'2013-07-06 12:44:34',NULL,NULL),(69328,'83523','S','Craigmont','D','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.243004,-116.470910,0,'2013-07-06 12:44:34',NULL,NULL),(27790,'30384','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.897456,-84.451548,0,'2013-07-06 12:44:31',NULL,NULL),(54312,'62719','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.801546,-89.652704,0,'2013-07-06 12:44:33',NULL,NULL),(75453,'94070','S','San Carlos','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.494512,-122.269775,0,'2013-07-06 12:44:34',NULL,NULL),(20182,'20746','S','Suitland','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(56286,'65075','S','Saint Elizabeth','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.286194,-92.274802,0,'2013-07-06 12:44:33',NULL,NULL),(59374,'70593','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.214310,-92.028589,0,'2013-07-06 12:44:33',NULL,NULL),(71423,'87026','S','Laguna','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(78821,'98335','S','Artondale','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(37595,'42122','S','Allen Springs','N','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.866581,-86.361492,0,'2013-07-06 12:44:32',NULL,NULL),(72134,'88301','S','Oscuro','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(75844,'94926','U','Cotati','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.326476,-122.712308,0,'2013-07-06 12:44:34',NULL,NULL),(45671,'52038','S','Dundee','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.578159,-91.549181,0,'2013-07-06 12:44:32',NULL,NULL),(42837,'48069','S','Pleasant Ridge','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.471590,-83.141547,0,'2013-07-06 12:44:32',NULL,NULL),(15780,'16922','S','Galeton','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.712840,-77.662020,0,'2013-07-06 12:44:31',NULL,NULL),(15581,'16659','S','Loysburg','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.177999,-78.379120,0,'2013-07-06 12:44:31',NULL,NULL),(71581,'87312','S','Coolidge','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.468748,-108.455845,0,'2013-07-06 12:44:34',NULL,NULL),(76921,'96008','S','Bella Vista','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.668572,-122.196037,0,'2013-07-06 12:44:34',NULL,NULL),(18219,'18960','S','Sellersville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.351221,-75.297364,0,'2013-07-06 12:44:31',NULL,NULL),(30301,'33296','P','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656259,-80.357036,0,'2013-07-06 12:44:32',NULL,NULL),(28178,'31005','S','Bonaire','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.557405,-83.617919,0,'2013-07-06 12:44:31',NULL,NULL),(55823,'64151','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(64458,'76573','P','Schwertner','D','Williamson','48491','Texas','TX','48','0640','254','Central',-6.0,'Y',30.722403,-97.434814,0,'2013-07-06 12:44:34',NULL,NULL),(64790,'77012','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.718212,-95.201945,0,'2013-07-06 12:44:34',NULL,NULL),(67686,'80514','S','Erie','A','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.084772,-104.929982,0,'2013-07-06 12:44:34',NULL,NULL),(77351,'96729','P','Hoolehua','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.164136,-157.085991,0,'2013-07-06 12:44:34',NULL,NULL),(12259,'12832','S','Slateville','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(11780,'12205','S','Roessleville','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.714746,-73.821155,0,'2013-07-06 12:44:30',NULL,NULL),(17662,'18086','P','Treichlers','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.738471,-75.546571,0,'2013-07-06 12:44:31',NULL,NULL),(24059,'26430','S','Sand Fork','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.892107,-80.741255,0,'2013-07-06 12:44:31',NULL,NULL),(67709,'80528','S','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.583017,-105.082450,0,'2013-07-06 12:44:34',NULL,NULL),(21788,'23072','S','Glass','N','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.283333,-76.500000,0,'2013-07-06 12:44:31',NULL,NULL),(39650,'45002','S','Cleves','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.181017,-84.720886,0,'2013-07-06 12:44:32',NULL,NULL),(30163,'33170','S','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(27824,'30411','S','Alamo','D','Wheeler','13309','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.153584,-82.779628,0,'2013-07-06 12:44:31',NULL,NULL),(1081,'00725','S','Urb Bonneville Gdns','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(73320,'90831','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.770410,-118.200783,0,'2013-07-06 12:44:34',NULL,NULL),(78580,'98170','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.606323,-122.328863,0,'2013-07-06 12:44:34',NULL,NULL),(436,'00662','S','Sect Verdum','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(28816,'32073','S','Orange Pk','N','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.174663,-81.758375,0,'2013-07-06 12:44:32',NULL,NULL),(7351,'06725','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.552662,-73.040934,0,'2013-07-06 12:44:30',NULL,NULL),(66147,'78480','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.797353,-97.396512,0,'2013-07-06 12:44:34',NULL,NULL),(73052,'90089','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.017658,-118.284157,0,'2013-07-06 12:44:34',NULL,NULL),(9365,'09823','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7849,'07470','S','Packanack Lk','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(30874,'33677','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.966235,-82.520188,0,'2013-07-06 12:44:32',NULL,NULL),(29771,'33010','S','Hialeah Gardens','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.828980,-80.285640,0,'2013-07-06 12:44:32',NULL,NULL),(13300,'13668','S','North Stockholm','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.762820,-74.991240,0,'2013-07-06 12:44:30',NULL,NULL),(62031,'73491','P','Velma','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.461264,-97.671275,0,'2013-07-06 12:44:33',NULL,NULL),(45595,'51552','S','Marne','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.450556,-95.107889,0,'2013-07-06 12:44:32',NULL,NULL),(28628,'31735','S','Cobb','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.964001,-83.968585,0,'2013-07-06 12:44:32',NULL,NULL),(55179,'63373','S','Portage des Sioux','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.924848,-90.364053,0,'2013-07-06 12:44:33',NULL,NULL),(7905,'07606','S','South Hackensack','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.867994,-74.049082,0,'2013-07-06 12:44:30',NULL,NULL),(5832,'05083','S','W Fairlee','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.936397,-72.248387,0,'2013-07-06 12:44:30',NULL,NULL),(6990,'06249','S','Lebanon','D','New London','09011','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.627884,-72.237773,0,'2013-07-06 12:44:30',NULL,NULL),(33398,'37224','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.151112,-86.795584,0,'2013-07-06 12:44:32',NULL,NULL),(24610,'27330','S','Tramway','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(59180,'70352','S','Donner','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.693839,-90.952049,0,'2013-07-06 12:44:33',NULL,NULL),(72259,'88536','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.808441,-106.419865,0,'2013-07-06 12:44:34',NULL,NULL),(74927,'93402','S','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.301420,-120.825000,0,'2013-07-06 12:44:34',NULL,NULL),(76372,'95518','P','Arcata','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.866107,-124.080793,0,'2013-07-06 12:44:34',NULL,NULL),(16588,'17324','S','Gardners','D','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(28224,'31036','S','Klondike','N','Pulaski','13235','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.281988,-83.473610,0,'2013-07-06 12:44:31',NULL,NULL),(35217,'39301','S','Russell','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.372903,-88.696221,0,'2013-07-06 12:44:32',NULL,NULL),(58506,'68770','S','Martinsburg','N','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.581657,-96.725252,0,'2013-07-06 12:44:33',NULL,NULL),(64578,'76667','S','Fallon','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(19419,'20090','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878902,-77.015978,0,'2013-07-06 12:44:31',NULL,NULL),(17725,'18246','P','Rock Glen','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.953322,-76.162773,0,'2013-07-06 12:44:31',NULL,NULL),(70367,'84653','S','Salem','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.032330,-111.658857,0,'2013-07-06 12:44:34',NULL,NULL),(72232,'88436','S','Sedan','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.249519,-103.145018,0,'2013-07-06 12:44:34',NULL,NULL),(75533,'94204','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.602817,-121.445876,0,'2013-07-06 12:44:34',NULL,NULL),(43578,'48742','S','Lincoln','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.729167,-83.439572,0,'2013-07-06 12:44:32',NULL,NULL),(34335,'38568','S','Hilham','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.403331,-85.439307,0,'2013-07-06 12:44:32',NULL,NULL),(60884,'72065','S','Hensley','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.529520,-92.222460,0,'2013-07-06 12:44:33',NULL,NULL),(71021,'85732','P','Coronado','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.215610,-110.881959,0,'2013-07-06 12:44:34',NULL,NULL),(46463,'53214','S','West Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.020816,-88.017337,0,'2013-07-06 12:44:32',NULL,NULL),(12952,'13357','S','Columbia','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(556,'00677','S','Villas de la Pradera','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(20174,'20745','S','National Harbor','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.807841,-76.989145,0,'2013-07-06 12:44:31',NULL,NULL),(19680,'20355','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896255,-77.034270,0,'2013-07-06 12:44:31',NULL,NULL),(8059,'07746','S','Bradevelt','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.319065,-74.263182,0,'2013-07-06 12:44:30',NULL,NULL),(31744,'34987','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308771,-80.453062,0,'2013-07-06 12:44:32',NULL,NULL),(55321,'63544','S','Green Castle','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.312191,-92.880950,0,'2013-07-06 12:44:33',NULL,NULL),(76663,'95746','S','Roseville','A','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.744190,-121.191175,0,'2013-07-06 12:44:34',NULL,NULL),(41090,'46539','S','Mentone','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.171247,-86.037685,0,'2013-07-06 12:44:32',NULL,NULL),(50753,'58413','S','Ashley','D','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.036030,-99.371223,0,'2013-07-06 12:44:33',NULL,NULL),(74288,'92364','S','Baker','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.466595,-115.482713,0,'2013-07-06 12:44:34',NULL,NULL),(28731,'31907','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.477304,-84.903608,0,'2013-07-06 12:44:32',NULL,NULL),(69302,'83450','S','Terreton','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.859400,-112.435380,0,'2013-07-06 12:44:34',NULL,NULL),(16891,'17579','S','Edisonville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.967797,-76.177226,0,'2013-07-06 12:44:31',NULL,NULL),(31236,'33973','S','Leehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.610303,-81.691774,0,'2013-07-06 12:44:32',NULL,NULL),(57215,'66442','S','Fort Riley','D','Geary','20061','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.056640,-96.770220,0,'2013-07-06 12:44:33',NULL,NULL),(58933,'69347','S','Hay Springs','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.682114,-102.690841,0,'2013-07-06 12:44:33',NULL,NULL),(76400,'95546','S','Hoopa','D','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',41.168795,-123.727286,0,'2013-07-06 12:44:34',NULL,NULL),(76630,'95713','S','Colfax','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(37712,'42266','S','St Elmo','N','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.779266,-87.364735,0,'2013-07-06 12:44:32',NULL,NULL),(34380,'38617','S','Coahoma','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.393358,-90.490310,0,'2013-07-06 12:44:32',NULL,NULL),(26491,'29164','S','Wagener','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(47948,'55118','S','Mendota Heights','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(56916,'66054','S','Mc Louth','D','Jefferson','20087','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.192952,-95.206733,0,'2013-07-06 12:44:33',NULL,NULL),(63403,'75652','S','Craig','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(5331,'04578','S','Westport Island','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.996053,-69.671510,0,'2013-07-06 12:44:30',NULL,NULL),(24289,'27006','S','Redland','N','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(9587,'10028','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(7575,'07030','S','Hoboken','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.747748,-74.033860,0,'2013-07-06 12:44:30',NULL,NULL),(43383,'48429','S','Vernon City','A','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.909481,-83.991837,0,'2013-07-06 12:44:32',NULL,NULL),(18464,'19082','S','Kirklyn','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.956267,-75.274357,0,'2013-07-06 12:44:31',NULL,NULL),(54197,'62633','S','Easton','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.234297,-89.847735,0,'2013-07-06 12:44:33',NULL,NULL),(54696,'62950','S','Jacob','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.747337,-89.546002,0,'2013-07-06 12:44:33',NULL,NULL),(58172,'68301','S','Adams','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.456355,-96.510084,0,'2013-07-06 12:44:33',NULL,NULL),(59600,'71019','S','Armistead','N','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(17390,'17901','S','Buck Run','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(20789,'21541','S','Sang Run','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.556671,-79.350980,0,'2013-07-06 12:44:31',NULL,NULL),(40068,'45274','U','Commercial Accounts','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138138,-84.536318,0,'2013-07-06 12:44:32',NULL,NULL),(64638,'76708','S','Rock Creek','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.609500,-97.213440,0,'2013-07-06 12:44:34',NULL,NULL),(72973,'90048','S','Bicentennial','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.073253,-118.377034,0,'2013-07-06 12:44:34',NULL,NULL),(77595,'96931','P','Tamuning','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.494724,144.777071,0,'2013-07-06 12:44:34',NULL,NULL),(53340,'61755','S','Lilly','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.540609,-89.340753,0,'2013-07-06 12:44:33',NULL,NULL),(63508,'75713','P','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.324098,-95.293736,0,'2013-07-06 12:44:33',NULL,NULL),(74475,'92606','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.695115,-117.822380,0,'2013-07-06 12:44:34',NULL,NULL),(74988,'93446','S','Paso Robles','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(76160,'95312','P','Cressey','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.397581,-120.618353,0,'2013-07-06 12:44:34',NULL,NULL),(78907,'98362','S','Physt','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(64055,'76133','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.652107,-97.377051,0,'2013-07-06 12:44:34',NULL,NULL),(64828,'77036','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.701008,-95.536659,0,'2013-07-06 12:44:34',NULL,NULL),(16799,'17540','S','Rockrimmin Ridge','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.095709,-76.185401,0,'2013-07-06 12:44:31',NULL,NULL),(56843,'65890','U','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.205863,-93.354799,0,'2013-07-06 12:44:33',NULL,NULL),(42737,'48015','S','Center Line','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.480245,-83.025107,0,'2013-07-06 12:44:32',NULL,NULL),(35007,'39140','S','Newhebron','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.730280,-90.017520,0,'2013-07-06 12:44:32',NULL,NULL),(13539,'13827','S','Gaskill','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(26063,'28694','S','Baldwin','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(75922,'95012','S','Castroville','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.780991,-121.735888,0,'2013-07-06 12:44:34',NULL,NULL),(38665,'43947','S','Shadyside','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.968088,-80.754883,0,'2013-07-06 12:44:32',NULL,NULL),(21913,'23219','S','Capitol','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.541877,-77.436280,0,'2013-07-06 12:44:31',NULL,NULL),(19119,'19607','S','Shillington','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.311120,-75.923820,0,'2013-07-06 12:44:31',NULL,NULL),(68979,'83114','S','Cokeville','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.294901,-111.093695,0,'2013-07-06 12:44:34',NULL,NULL),(78863,'98346','S','Kingston','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.805964,-122.524971,0,'2013-07-06 12:44:34',NULL,NULL),(46680,'53774','U','WI Lottery','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.072549,-89.402181,0,'2013-07-06 12:44:32',NULL,NULL),(17473,'17948','S','Trenton','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(1634,'00771','S','Urb La Estancia','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(53787,'62278','S','Ruma','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.179200,-89.979600,0,'2013-07-06 12:44:33',NULL,NULL),(5733,'05033','S','Lower Plain','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.999980,-72.137700,0,'2013-07-06 12:44:30',NULL,NULL),(42069,'47452','S','Orleans','D','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(1948,'00802','S','Charlotte Amalie','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.348771,-64.935409,0,'2013-07-06 12:44:30',NULL,NULL),(55733,'64086','S','Lake Lotawana','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.919180,-94.320840,0,'2013-07-06 12:44:33',NULL,NULL),(11507,'12025','S','Vail Mills','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(31056,'33838','S','Dundee','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.018703,-81.618485,0,'2013-07-06 12:44:32',NULL,NULL),(36464,'40737','S','Keavy','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.017673,-84.159300,0,'2013-07-06 12:44:32',NULL,NULL),(62803,'74937','S','Heavener','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.886869,-94.603696,0,'2013-07-06 12:44:33',NULL,NULL),(73091,'90222','S','Rosewood','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.911837,-118.235008,0,'2013-07-06 12:44:34',NULL,NULL),(9211,'09503','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(47085,'54435','S','Bloomville','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.400965,-89.462214,0,'2013-07-06 12:44:32',NULL,NULL),(33064,'36765','S','Newbern','D','Hale','01065','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.546000,-87.586759,0,'2013-07-06 12:44:32',NULL,NULL),(61821,'73108','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.447049,-97.564806,0,'2013-07-06 12:44:33',NULL,NULL),(5976,'05343','S','Pikes Falls','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.104420,-72.807180,0,'2013-07-06 12:44:30',NULL,NULL),(223,'00624','S','Urb Penuelas Valley','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(18950,'19508','S','Stonetown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(10213,'10455','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.812989,-73.903711,0,'2013-07-06 12:44:30',NULL,NULL),(63924,'76054','S','Hurst','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.860151,-97.177784,0,'2013-07-06 12:44:34',NULL,NULL),(30086,'33156','S','Richmond Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(29203,'32409','S','Southport','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.348960,-85.676400,0,'2013-07-06 12:44:32',NULL,NULL),(28483,'31516','S','Jot Em Down Store','N','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.299595,-82.255180,0,'2013-07-06 12:44:32',NULL,NULL),(479,'00667','S','Lajas','D','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(70131,'84301','P','Bear River City','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.594870,-112.127635,0,'2013-07-06 12:44:34',NULL,NULL),(45201,'50624','S','Dike','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.405761,-92.684255,0,'2013-07-06 12:44:32',NULL,NULL),(41908,'47374','S','Gateway Shopping Ctr','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(34175,'38311','S','Bath Springs','D','Decatur','47039','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.441131,-88.103977,0,'2013-07-06 12:44:32',NULL,NULL),(9703,'10055','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(26225,'28801','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.594571,-82.555747,0,'2013-07-06 12:44:31',NULL,NULL),(1209,'00728','S','Sect La Cotorra','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(73924,'92026','S','Hidden Meadows','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.174100,-117.101925,0,'2013-07-06 12:44:34',NULL,NULL),(14011,'14530','S','Perry','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.735814,-78.015498,0,'2013-07-06 12:44:31',NULL,NULL),(57006,'66205','S','Mission','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(29701,'32937','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(22741,'24382','S','Wytheville','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.945260,-81.089071,0,'2013-07-06 12:44:31',NULL,NULL),(45983,'52497','U','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.005872,-91.641725,0,'2013-07-06 12:44:32',NULL,NULL),(25628,'28463','S','Tabor City','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.147085,-78.875878,0,'2013-07-06 12:44:31',NULL,NULL),(41022,'46380','P','Wheatfield','A','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.199044,-86.972303,0,'2013-07-06 12:44:32',NULL,NULL),(33795,'37886','S','Walland','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.776507,-83.821306,0,'2013-07-06 12:44:32',NULL,NULL),(20558,'21128','S','Perryhall','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.401633,-76.446100,0,'2013-07-06 12:44:31',NULL,NULL),(18137,'18829','S','Leraysville','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.845364,-76.179080,0,'2013-07-06 12:44:31',NULL,NULL),(79981,'99655','P','Quinhagak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.477794,-161.149803,0,'2013-07-06 12:44:34',NULL,NULL),(78987,'98377','S','Randle','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.521842,-121.903538,0,'2013-07-06 12:44:34',NULL,NULL),(76520,'95646','P','Buckhorn','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(59474,'70750','S','Krotz Springs','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.541914,-91.758543,0,'2013-07-06 12:44:33',NULL,NULL),(48383,'55572','P','Greenfield','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996060,-93.708483,0,'2013-07-06 12:44:33',NULL,NULL),(26137,'28734','S','Union','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(42097,'47460','S','New Hope','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(40638,'46033','S','Carmel','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.975924,-86.080320,0,'2013-07-06 12:44:32',NULL,NULL),(26579,'29218','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.007301,-81.036586,0,'2013-07-06 12:44:31',NULL,NULL),(2562,'00959','S','Urb La Milagrosa','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(21025,'21861','P','Sharptown','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.540825,-75.719907,0,'2013-07-06 12:44:31',NULL,NULL),(36673,'41012','P','Covington','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068847,-84.532930,0,'2013-07-06 12:44:32',NULL,NULL),(7804,'07438','S','Oak Ridge','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.033460,-74.499840,0,'2013-07-06 12:44:30',NULL,NULL),(399,'00662','S','Est del Paraiso','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(58266,'68379','S','Julian','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.522306,-95.868586,0,'2013-07-06 12:44:33',NULL,NULL),(71532,'87131','U','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.089423,-106.619821,0,'2013-07-06 12:44:34',NULL,NULL),(14540,'15209','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.496241,-79.979064,0,'2013-07-06 12:44:31',NULL,NULL),(15667,'16803','S','State College','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.804602,-77.897038,0,'2013-07-06 12:44:31',NULL,NULL),(14734,'15290','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.508153,-80.076287,0,'2013-07-06 12:44:31',NULL,NULL),(63060,'75228','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.825581,-96.681423,0,'2013-07-06 12:44:33',NULL,NULL),(67756,'80622','S','Galeton','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.504673,-104.623046,0,'2013-07-06 12:44:34',NULL,NULL),(76052,'95191','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.324072,-121.917236,0,'2013-07-06 12:44:34',NULL,NULL),(42272,'47581','S','Trinity Sprgs','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(2471,'00956','S','Haciendas el Zorzal','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(47057,'54418','S','Bryant','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.220320,-88.968660,0,'2013-07-06 12:44:32',NULL,NULL),(33561,'37411','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.025075,-85.237257,0,'2013-07-06 12:44:32',NULL,NULL),(41920,'47380','S','Ridgeville','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.292380,-85.028052,0,'2013-07-06 12:44:32',NULL,NULL),(50254,'57632','S','Herreid','D','Campbell','46021','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.853332,-100.024984,0,'2013-07-06 12:44:33',NULL,NULL),(50595,'58241','S','Hensel','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.674622,-97.600004,0,'2013-07-06 12:44:33',NULL,NULL),(62924,'75082','S','Richardson','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.995373,-96.682873,0,'2013-07-06 12:44:33',NULL,NULL),(67137,'79761','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.854911,-102.352859,0,'2013-07-06 12:44:34',NULL,NULL),(67818,'80754','S','Stoneham','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.597586,-103.648467,0,'2013-07-06 12:44:34',NULL,NULL),(33665,'37724','S','Cumberland Gap','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.542300,-83.689657,0,'2013-07-06 12:44:32',NULL,NULL),(46164,'52730','S','Folletts','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.785818,-90.261710,0,'2013-07-06 12:44:32',NULL,NULL),(10624,'11050','S','Sands Point','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(56864,'66012','S','Lk Of the Fst','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.073262,-94.884623,0,'2013-07-06 12:44:33',NULL,NULL),(75852,'94930','S','Fairfax','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.964981,-122.618571,0,'2013-07-06 12:44:34',NULL,NULL),(60144,'71375','S','Consuella','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(36856,'41076','S','Wilder','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(14579,'15218','S','Swissvale','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426383,-79.888677,0,'2013-07-06 12:44:31',NULL,NULL),(8191,'07921','S','Bedminster','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.656519,-74.654789,0,'2013-07-06 12:44:30',NULL,NULL),(21870,'23156','S','Plainview','N','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.576680,-76.729380,0,'2013-07-06 12:44:31',NULL,NULL),(29970,'33082','P','South Florida','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.013469,-80.203516,0,'2013-07-06 12:44:32',NULL,NULL),(26520,'29201','S','Market Center','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998223,-81.032546,0,'2013-07-06 12:44:31',NULL,NULL),(49524,'56676','S','Alida','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.383450,-95.232970,0,'2013-07-06 12:44:33',NULL,NULL),(55199,'63383','S','Truesdail','N','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.771220,-91.224360,0,'2013-07-06 12:44:33',NULL,NULL),(63596,'75789','S','Troup','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(79082,'98438','P','JBLM','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(49262,'56479','S','Staples','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.353921,-94.795227,0,'2013-07-06 12:44:33',NULL,NULL),(18090,'18707','S','Mountain Top','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.144606,-75.925343,0,'2013-07-06 12:44:31',NULL,NULL),(468,'00664','S','Urb La Colina','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(45922,'52328','S','Robins','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.074811,-91.665381,0,'2013-07-06 12:44:32',NULL,NULL),(39938,'45229','S','Avondale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.149736,-84.487866,0,'2013-07-06 12:44:32',NULL,NULL),(2403,'00953','S','Alt de Bucabarones','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(10215,'10456','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.830175,-73.906791,0,'2013-07-06 12:44:30',NULL,NULL),(10304,'10530','S','Hartsdale','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.021378,-73.805692,0,'2013-07-06 12:44:30',NULL,NULL),(34517,'38677','P','Univ of Miss','N','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.367390,-89.528956,0,'2013-07-06 12:44:32',NULL,NULL),(14464,'15112','S','East Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403876,-79.837675,0,'2013-07-06 12:44:31',NULL,NULL),(15511,'16514','P','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.109107,-79.957242,0,'2013-07-06 12:44:31',NULL,NULL),(74400,'92522','U','City of Riverside','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.940256,-117.397192,0,'2013-07-06 12:44:34',NULL,NULL),(77369,'96747','P','Kaumakani','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.933335,-159.629261,0,'2013-07-06 12:44:34',NULL,NULL),(69888,'84103','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.783965,-111.876047,0,'2013-07-06 12:44:34',NULL,NULL),(19273,'19961','P','Little Creek','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.164886,-75.452048,0,'2013-07-06 12:44:31',NULL,NULL),(26194,'28771','S','Lake Santeetlah','A','Graham','37075','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.346072,-83.874306,0,'2013-07-06 12:44:31',NULL,NULL),(45226,'50644','S','Independence','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.468967,-91.895783,0,'2013-07-06 12:44:32',NULL,NULL),(34315,'38555','S','Crossville','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951220,-85.029780,0,'2013-07-06 12:44:32',NULL,NULL),(8342,'08042','P','Juliustown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.013114,-74.670629,0,'2013-07-06 12:44:30',NULL,NULL),(20424,'20912','S','Silver Spring','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.985658,-77.005547,0,'2013-07-06 12:44:31',NULL,NULL),(22047,'23313','P','Capeville','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.204036,-75.975851,0,'2013-07-06 12:44:31',NULL,NULL),(60273,'71447','S','Monette Ferry','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(64432,'76559','S','Nolanville','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.077418,-97.601807,0,'2013-07-06 12:44:34',NULL,NULL),(73245,'90701','S','Cerritos','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.869028,-118.081967,0,'2013-07-06 12:44:34',NULL,NULL),(76165,'95318','P','El Portal','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.648397,-119.854301,0,'2013-07-06 12:44:34',NULL,NULL),(77229,'96510','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(67838,'80812','S','Cope','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.686758,-102.877262,0,'2013-07-06 12:44:34',NULL,NULL),(16163,'17063','S','Milroy','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.716078,-77.590384,0,'2013-07-06 12:44:31',NULL,NULL),(2978,'01056','S','Ludlow','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.171237,-72.472507,0,'2013-07-06 12:44:30',NULL,NULL),(11387,'11940','S','East Moriches','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.808490,-72.752280,0,'2013-07-06 12:44:30',NULL,NULL),(11902,'12404','S','Lyonsville','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810460,-74.249820,0,'2013-07-06 12:44:30',NULL,NULL),(10751,'11360','S','Bayside','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.776438,-73.780380,0,'2013-07-06 12:44:30',NULL,NULL),(2313,'00927','S','Villas de San Francisco','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(17888,'18444','S','Moscow','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(50570,'58220','S','Concrete','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.782525,-97.607866,0,'2013-07-06 12:44:33',NULL,NULL),(53365,'61769','S','Scovel','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.893501,-88.404022,0,'2013-07-06 12:44:33',NULL,NULL),(56729,'65707','S','Capps Creek','N','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.231449,-93.849869,0,'2013-07-06 12:44:33',NULL,NULL),(67980,'80916','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.803293,-104.707538,0,'2013-07-06 12:44:34',NULL,NULL),(68498,'81303','S','Durango','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.275776,-107.876808,0,'2013-07-06 12:44:34',NULL,NULL),(62141,'73706','P','Enid','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.398528,-97.931390,0,'2013-07-06 12:44:33',NULL,NULL),(1995,'00909','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(14633,'15233','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.457777,-80.026332,0,'2013-07-06 12:44:31',NULL,NULL),(10409,'10702','P','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.932578,-73.902251,0,'2013-07-06 12:44:30',NULL,NULL),(44497,'49920','S','Crystal Falls','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.104755,-88.349027,0,'2013-07-06 12:44:32',NULL,NULL),(35649,'39641','S','Topeka','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(35189,'39284','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.275332,-90.218859,0,'2013-07-06 12:44:32',NULL,NULL),(21721,'23002','S','Amelia Ct Hse','A','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.390980,-77.904720,0,'2013-07-06 12:44:31',NULL,NULL),(42778,'48041','S','Riley Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.924364,-82.781340,0,'2013-07-06 12:44:32',NULL,NULL),(69362,'83552','S','Stites','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.120893,-115.974113,0,'2013-07-06 12:44:34',NULL,NULL),(76270,'95418','P','Ukiah','A','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.151320,-123.208800,0,'2013-07-06 12:44:34',NULL,NULL),(78705,'98262','S','Lummi Island','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.708719,-122.676490,0,'2013-07-06 12:44:34',NULL,NULL),(62528,'74426','S','Checotah','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.417700,-95.553780,0,'2013-07-06 12:44:33',NULL,NULL),(57371,'66743','S','Brazilton','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(50404,'57775','S','Cottonwood','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.097300,-102.109920,0,'2013-07-06 12:44:33',NULL,NULL),(48304,'55441','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.004561,-93.426516,0,'2013-07-06 12:44:33',NULL,NULL),(27859,'30441','S','Coleman Lake','N','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(20194,'20750','P','Oxon Hill','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.801416,-76.991109,0,'2013-07-06 12:44:31',NULL,NULL),(36841,'41074','S','Newport','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.110380,-84.468431,0,'2013-07-06 12:44:32',NULL,NULL),(22206,'23511','S','Norfolk Naval Station','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(25291,'28138','S','Rockwell','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.540209,-80.430167,0,'2013-07-06 12:44:31',NULL,NULL),(59345,'70554','S','Mamou','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.635111,-92.414083,0,'2013-07-06 12:44:33',NULL,NULL),(73491,'91326','S','Northridge','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.276626,-118.543741,0,'2013-07-06 12:44:34',NULL,NULL),(61618,'72823','S','Atkins','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.244334,-92.936881,0,'2013-07-06 12:44:33',NULL,NULL),(45854,'52236','S','Homestead','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.725449,-91.886548,0,'2013-07-06 12:44:32',NULL,NULL),(68920,'82840','P','Saddlestring','D','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.344040,-106.620111,0,'2013-07-06 12:44:34',NULL,NULL),(62378,'74077','U','STW','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.118222,-97.062130,0,'2013-07-06 12:44:33',NULL,NULL),(61876,'73129','S','Valley Brook','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.429134,-97.486641,0,'2013-07-06 12:44:33',NULL,NULL),(60442,'71647','S','Mount Olive','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(6000,'05356','S','Mt Snow','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.933333,-72.833333,0,'2013-07-06 12:44:30',NULL,NULL),(46954,'54175','S','Townsend','D','Oconto','55083','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.315886,-88.616239,0,'2013-07-06 12:44:32',NULL,NULL),(57995,'67857','S','Kendall','D','Hamilton','20075','Kansas','KS','20','0000','620','Mountain',-7.0,'Y',37.933701,-101.541951,0,'2013-07-06 12:44:33',NULL,NULL),(52999,'61450','S','La Crosse','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.584041,-90.968298,0,'2013-07-06 12:44:33',NULL,NULL),(26584,'29220','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.004320,-81.032526,0,'2013-07-06 12:44:31',NULL,NULL),(23414,'25334','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.349486,-81.627305,0,'2013-07-06 12:44:31',NULL,NULL),(61977,'73190','U','Okla Univ Health Sci Ctr','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.458463,-97.516594,0,'2013-07-06 12:44:33',NULL,NULL),(59390,'70612','P','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.241086,-93.179996,0,'2013-07-06 12:44:33',NULL,NULL),(46555,'53504','S','Argyle','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.704144,-89.901971,0,'2013-07-06 12:44:32',NULL,NULL),(41539,'47001','S','Aurora','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.094860,-84.981900,0,'2013-07-06 12:44:32',NULL,NULL),(18058,'18702','S','Plains Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(77928,'97329','S','Cascadia','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.390734,-122.505607,0,'2013-07-06 12:44:34',NULL,NULL),(73140,'90275','S','Palos Verdes Peninsula','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(16104,'17055','S','Andersontown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(65642,'77967','P','Hochheim','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.241199,-97.069618,0,'2013-07-06 12:44:34',NULL,NULL),(79480,'98862','S','Winthrop','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.476221,-120.181254,0,'2013-07-06 12:44:34',NULL,NULL),(56125,'64833','P','Avilla','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.193512,-94.132474,0,'2013-07-06 12:44:33',NULL,NULL),(27932,'30521','S','Carnesville','D','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.383201,-83.286493,0,'2013-07-06 12:44:31',NULL,NULL),(28718,'31902','P','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.500152,-84.973827,0,'2013-07-06 12:44:32',NULL,NULL),(1120,'00725','S','Urb Verde Sur','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(9721,'10081','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(66645,'78839','S','Crystal City','D','Zavala','48507','Texas','TX','48','0000','830','Central',-6.0,'Y',28.682775,-99.829297,0,'2013-07-06 12:44:34',NULL,NULL),(60183,'71417','S','Bagdad','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(2404,'00953','S','Alts de Montecasino','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(12934,'13345','S','Greig','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.679971,-75.311066,0,'2013-07-06 12:44:30',NULL,NULL),(11603,'12087','S','Hannacroix','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.422544,-73.886598,0,'2013-07-06 12:44:30',NULL,NULL),(34426,'38641','S','Lk Cormorant','A','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.925340,-90.159840,0,'2013-07-06 12:44:32',NULL,NULL),(28753,'32003','S','Fleming Isle','A','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.106435,-81.711499,0,'2013-07-06 12:44:32',NULL,NULL),(31738,'34985','P','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.295090,-80.349568,0,'2013-07-06 12:44:32',NULL,NULL),(48884,'56097','S','Wells','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.741740,-93.728328,0,'2013-07-06 12:44:33',NULL,NULL),(54616,'62914','S','Klondike','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.009840,-89.180112,0,'2013-07-06 12:44:33',NULL,NULL),(61956,'73169','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.394847,-97.644712,0,'2013-07-06 12:44:33',NULL,NULL),(62020,'73456','S','Cornish','A','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.179287,-97.610720,0,'2013-07-06 12:44:33',NULL,NULL),(77967,'97373','P','Saint Benedict','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.056509,-122.784435,0,'2013-07-06 12:44:34',NULL,NULL),(73185,'90409','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.003022,-118.485621,0,'2013-07-06 12:44:34',NULL,NULL),(31233,'33971','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.597681,-81.699773,0,'2013-07-06 12:44:32',NULL,NULL),(23186,'25045','S','Corton','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.460480,-81.335520,0,'2013-07-06 12:44:31',NULL,NULL),(45709,'52060','S','Nashville','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.071208,-90.660765,0,'2013-07-06 12:44:32',NULL,NULL),(70782,'85348','S','Salome','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.846500,-113.607319,0,'2013-07-06 12:44:34',NULL,NULL),(76390,'95534','P','Eureka','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.793242,-124.158139,0,'2013-07-06 12:44:34',NULL,NULL),(79705,'99211','P','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.665303,-117.310120,0,'2013-07-06 12:44:34',NULL,NULL),(62334,'74050','P','Oakhurst','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.076749,-96.069276,0,'2013-07-06 12:44:33',NULL,NULL),(27858,'30439','S','Metter','D','Candler','13043','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.402027,-82.061386,0,'2013-07-06 12:44:31',NULL,NULL),(36696,'41017','S','Crestview Hills','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(41299,'46765','S','Leo-Cedarville','A','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(22296,'23821','S','Alberta','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.836440,-77.853091,0,'2013-07-06 12:44:31',NULL,NULL),(2413,'00953','S','Haciendas De Borinquen','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(23385,'25309','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.339160,-81.753480,0,'2013-07-06 12:44:31',NULL,NULL),(74412,'92544','S','Hemet','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.652188,-116.899445,0,'2013-07-06 12:44:34',NULL,NULL),(54540,'62885','S','Augsburg','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842965,-89.082598,0,'2013-07-06 12:44:33',NULL,NULL),(31007,'33776','S','Seminole','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.850818,-82.829083,0,'2013-07-06 12:44:32',NULL,NULL),(24751,'27532','P','Goldsboro','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.381183,-77.953396,0,'2013-07-06 12:44:31',NULL,NULL),(9195,'09403','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(27310,'30019','S','Dacula','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975719,-83.873930,0,'2013-07-06 12:44:31',NULL,NULL),(37389,'41759','S','Anco','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.239124,-83.035289,0,'2013-07-06 12:44:32',NULL,NULL),(77350,'96728','P','Honomu','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.857107,-155.135995,0,'2013-07-06 12:44:34',NULL,NULL),(62735,'74827','S','Atwood','D','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.930129,-96.347737,0,'2013-07-06 12:44:33',NULL,NULL),(58431,'68665','S','Spalding','D','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.698700,-98.395511,0,'2013-07-06 12:44:33',NULL,NULL),(58219,'68339','S','Denton','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.737195,-96.848512,0,'2013-07-06 12:44:33',NULL,NULL),(21104,'22044','S','7 Corners','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856209,-77.157020,0,'2013-07-06 12:44:31',NULL,NULL),(48974,'56215','S','Benson','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.314278,-95.601862,0,'2013-07-06 12:44:33',NULL,NULL),(53814,'62297','S','Walsh','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.018461,-89.827173,0,'2013-07-06 12:44:33',NULL,NULL),(57360,'66738','S','Barnesville','N','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.009208,-94.718191,0,'2013-07-06 12:44:33',NULL,NULL),(69447,'83647','S','Mtn Home','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(79943,'99623','S','Wasilla','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593459,-149.414728,0,'2013-07-06 12:44:34',NULL,NULL),(68968,'83014','S','Wilson','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.476928,-110.856179,0,'2013-07-06 12:44:34',NULL,NULL),(60569,'71759','P','Norphlet','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.324963,-92.666277,0,'2013-07-06 12:44:33',NULL,NULL),(11844,'12248','U','NY Assembly','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653981,-73.758374,0,'2013-07-06 12:44:30',NULL,NULL),(24386,'27101','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.104297,-80.214816,0,'2013-07-06 12:44:31',NULL,NULL),(42695,'47990','S','Waynetown','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.089875,-87.062026,0,'2013-07-06 12:44:32',NULL,NULL),(10043,'10174','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(34537,'38701','S','Lamont','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.288780,-90.990720,0,'2013-07-06 12:44:32',NULL,NULL),(41771,'47303','S','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(20076,'20684','S','St Inigoes','N','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.152561,-76.413819,0,'2013-07-06 12:44:31',NULL,NULL),(65515,'77705','S','Taylor Landing','A','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.969400,-94.155300,0,'2013-07-06 12:44:34',NULL,NULL),(18412,'19057','S','Levittown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.140756,-74.860963,0,'2013-07-06 12:44:31',NULL,NULL),(33907,'38050','P','Maury City','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.815031,-89.222697,0,'2013-07-06 12:44:32',NULL,NULL),(33862,'38007','P','Bogota','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.216148,-89.477327,0,'2013-07-06 12:44:32',NULL,NULL),(47073,'54427','S','Eland','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.821512,-89.266141,0,'2013-07-06 12:44:32',NULL,NULL),(16805,'17543','S','Lime Rock','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(72387,'89040','S','Echo Bay','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(69632,'84001','S','Boneta','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.398937,-110.465521,0,'2013-07-06 12:44:34',NULL,NULL),(64406,'76544','S','Clear Creek','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(52515,'60827','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.647040,-87.620670,0,'2013-07-06 12:44:33',NULL,NULL),(22011,'23286','U','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557404,-77.447536,0,'2013-07-06 12:44:31',NULL,NULL),(39585,'44860','P','Oceola','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.851887,-83.096404,0,'2013-07-06 12:44:32',NULL,NULL),(40235,'45422','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.760595,-84.186625,0,'2013-07-06 12:44:32',NULL,NULL),(69112,'83272','S','Saint Charles','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.077452,-111.314009,0,'2013-07-06 12:44:34',NULL,NULL),(47993,'55133','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944520,-93.005804,0,'2013-07-06 12:44:33',NULL,NULL),(8853,'08647','U','Nj Income Tax','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218571,-74.768936,0,'2013-07-06 12:44:30',NULL,NULL),(874,'00698','S','Villas del Cafetal','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(9041,'08879','S','South Amboy','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.463991,-74.275843,0,'2013-07-06 12:44:30',NULL,NULL),(76125,'95246','S','Sheep Ranch','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.242296,-120.533316,0,'2013-07-06 12:44:34',NULL,NULL),(63886,'76014','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.696281,-97.088027,0,'2013-07-06 12:44:34',NULL,NULL),(60880,'72064','S','Center Point','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.797715,-91.570184,0,'2013-07-06 12:44:33',NULL,NULL),(52247,'60516','S','Downers Grove','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.759097,-88.015319,0,'2013-07-06 12:44:33',NULL,NULL),(36293,'40357','P','North Middletown','D','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.144609,-84.108627,0,'2013-07-06 12:44:32',NULL,NULL),(35027,'39159','S','Onward','N','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.897670,-90.882023,0,'2013-07-06 12:44:32',NULL,NULL),(69736,'84043','S','Saratoga Springs','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(61857,'73121','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.509891,-97.446247,0,'2013-07-06 12:44:33',NULL,NULL),(28690,'31806','S','Ellaville','D','Schley','13249','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.238191,-84.308815,0,'2013-07-06 12:44:32',NULL,NULL),(28048,'30664','P','Sharon','D','Taliaferro','13265','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.563799,-82.879775,0,'2013-07-06 12:44:31',NULL,NULL),(53799,'62286','S','Schulines','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.151540,-89.723160,0,'2013-07-06 12:44:33',NULL,NULL),(14736,'15301','S','Wash','N','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.175267,-80.251514,0,'2013-07-06 12:44:31',NULL,NULL),(19824,'20468','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894581,-77.036348,0,'2013-07-06 12:44:31',NULL,NULL),(30938,'33714','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.819947,-82.679529,0,'2013-07-06 12:44:32',NULL,NULL),(68768,'82301','S','Riner','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.788870,-107.199009,0,'2013-07-06 12:44:34',NULL,NULL),(63081,'75246','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.796315,-96.773453,0,'2013-07-06 12:44:33',NULL,NULL),(29547,'32804','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.573780,-81.397190,0,'2013-07-06 12:44:32',NULL,NULL),(33990,'38116','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.036558,-90.009010,0,'2013-07-06 12:44:32',NULL,NULL),(44365,'49785','U','Kincheloe','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.264580,-84.449270,0,'2013-07-06 12:44:32',NULL,NULL),(6942,'06176','U','IRS','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768415,-72.669185,0,'2013-07-06 12:44:30',NULL,NULL),(63949,'76086','S','Willow Park','N','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.787926,-97.817546,0,'2013-07-06 12:44:34',NULL,NULL),(59167,'70341','S','Bruly Saint Martin','N','Assumption','22007','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.041700,-91.067400,0,'2013-07-06 12:44:33',NULL,NULL),(27742,'30356','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.947356,-84.330786,0,'2013-07-06 12:44:31',NULL,NULL),(34848,'38923','S','Black Hawk','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.371212,-89.976844,0,'2013-07-06 12:44:32',NULL,NULL),(9772,'10105','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(32582,'36121','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386094,-86.146989,0,'2013-07-06 12:44:32',NULL,NULL),(30734,'33538','S','Lk Panasoffke','A','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.885081,-82.192820,0,'2013-07-06 12:44:32',NULL,NULL),(18845,'19429','U','Bell Telephone Co','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.080514,-75.300080,0,'2013-07-06 12:44:31',NULL,NULL),(56270,'65066','S','Brush Creek','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348543,-91.499030,0,'2013-07-06 12:44:33',NULL,NULL),(50946,'58580','S','Zap','D','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.300840,-101.931572,0,'2013-07-06 12:44:33',NULL,NULL),(32443,'36010','S','Brundidge','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.721929,-85.819591,0,'2013-07-06 12:44:32',NULL,NULL),(5262,'04487','S','Webster Plt','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.393599,-68.101456,0,'2013-07-06 12:44:30',NULL,NULL),(13097,'13475','S','Van Hornesville','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.895000,-74.828056,0,'2013-07-06 12:44:30',NULL,NULL),(24538,'27292','S','Cotton Grove','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(76138,'95257','S','Wilseyville','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.375120,-120.486751,0,'2013-07-06 12:44:34',NULL,NULL),(67987,'80917','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.887640,-104.738816,0,'2013-07-06 12:44:34',NULL,NULL),(63470,'75686','S','Faker','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(62518,'74402','P','Musk','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.761119,-95.375475,0,'2013-07-06 12:44:33',NULL,NULL),(8688,'08343','S','Monroeville','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.639113,-75.164190,0,'2013-07-06 12:44:30',NULL,NULL),(7311,'06615','S','Stratford','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.185034,-73.140150,0,'2013-07-06 12:44:30',NULL,NULL),(3858,'02351','S','Abington','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.117783,-70.954203,0,'2013-07-06 12:44:30',NULL,NULL),(22856,'24540','S','Danville','D','Danville City','51590','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.614911,-79.389142,0,'2013-07-06 12:44:31',NULL,NULL),(58651,'68873','S','Saint Paul','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.234520,-98.450520,0,'2013-07-06 12:44:33',NULL,NULL),(56959,'66109','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.143284,-94.799949,0,'2013-07-06 12:44:33',NULL,NULL),(55441,'63673','S','Saint Mary','D','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.827600,-90.039600,0,'2013-07-06 12:44:33',NULL,NULL),(3177,'01331','S','Phillipston','A','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.588860,-72.224089,0,'2013-07-06 12:44:30',NULL,NULL),(43779,'49037','S','Springfield','A','Calhoun','26025','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.237105,-85.203233,0,'2013-07-06 12:44:32',NULL,NULL),(32232,'35580','S','Parrish','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.708726,-87.256908,0,'2013-07-06 12:44:32',NULL,NULL),(51120,'58789','S','Upham','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.591119,-100.734209,0,'2013-07-06 12:44:33',NULL,NULL),(54988,'63126','S','Sappington','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550063,-90.377582,0,'2013-07-06 12:44:33',NULL,NULL),(65667,'77982','P','Port o Connor','D','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.225330,-96.643456,0,'2013-07-06 12:44:34',NULL,NULL),(11675,'12148','S','Vischer Ferry','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.845640,-73.849020,0,'2013-07-06 12:44:30',NULL,NULL),(16941,'17701','S','Grampian Hls','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(23176,'25035','S','Cabin Creek','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.195408,-81.486710,0,'2013-07-06 12:44:31',NULL,NULL),(6004,'05357','P','West Dummerston','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.928208,-72.614048,0,'2013-07-06 12:44:30',NULL,NULL),(47924,'55112','S','Arden Hills','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079380,-93.187200,0,'2013-07-06 12:44:33',NULL,NULL),(75521,'94160','U','Bank of America','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.718015,-122.404390,0,'2013-07-06 12:44:34',NULL,NULL),(76338,'95468','S','Point Arena','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.895072,-123.653344,0,'2013-07-06 12:44:34',NULL,NULL),(2104,'00923','S','Urb Matienzo Cintron','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(61103,'72139','P','Russell','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.361358,-91.509058,0,'2013-07-06 12:44:33',NULL,NULL),(78941,'98367','S','Port Orchard','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.531216,-122.640364,0,'2013-07-06 12:44:34',NULL,NULL),(24032,'26385','S','McWhorter','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.170160,-80.387280,0,'2013-07-06 12:44:31',NULL,NULL),(23586,'25672','S','Edgarton','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.578967,-82.106525,0,'2013-07-06 12:44:31',NULL,NULL),(11609,'12092','S','Bramanville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.711693,-74.363530,0,'2013-07-06 12:44:30',NULL,NULL),(20567,'21136','S','Reisterstown','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.465347,-76.809770,0,'2013-07-06 12:44:31',NULL,NULL),(20032,'20636','S','Hollywood','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.357259,-76.573388,0,'2013-07-06 12:44:31',NULL,NULL),(80079,'99733','P','Circle','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.824411,-144.065198,0,'2013-07-06 12:44:34',NULL,NULL),(739,'00690','S','San Antonio','D','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(20463,'21030','S','Cockysvil','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.491520,-76.660860,0,'2013-07-06 12:44:31',NULL,NULL),(15518,'16531','U','General Electric Co','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.156495,-80.011362,0,'2013-07-06 12:44:31',NULL,NULL),(28244,'31058','S','Mauk','D','Marion','13197','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.510143,-84.375453,0,'2013-07-06 12:44:31',NULL,NULL),(9140,'09245','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(50470,'58041','S','Hankinson','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.073429,-96.899282,0,'2013-07-06 12:44:33',NULL,NULL),(50735,'58385','S','Wolford','D','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.457960,-99.630438,0,'2013-07-06 12:44:33',NULL,NULL),(72672,'89440','P','Virginia City','D','Storey','32029','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.345624,-119.648752,0,'2013-07-06 12:44:34',NULL,NULL),(21761,'23059','S','Gln Alln','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.716392,-77.578346,0,'2013-07-06 12:44:31',NULL,NULL),(35869,'39841','S','Damascus','D','Early','13099','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.347599,-84.731813,0,'2013-07-06 12:44:32',NULL,NULL),(31955,'35210','S','Jefferson Park','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(5636,'04945','S','Parlin Pd TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(48373,'55562','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814406,-93.919449,0,'2013-07-06 12:44:33',NULL,NULL),(72402,'89043','S','Ursine','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(73262,'90716','S','Lakewood','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.853611,-118.133056,0,'2013-07-06 12:44:34',NULL,NULL),(77429,'96804','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306209,-157.860153,0,'2013-07-06 12:44:34',NULL,NULL),(1649,'00771','S','Villas De San Cristobal II','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(39982,'45239','S','White Oak','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(32434,'35988','S','Sylvania','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.560198,-85.787476,0,'2013-07-06 12:44:32',NULL,NULL),(32810,'36445','S','Frisco City','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.416123,-87.417902,0,'2013-07-06 12:44:32',NULL,NULL),(59235,'70431','S','Bush','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.599866,-89.983285,0,'2013-07-06 12:44:33',NULL,NULL),(60755,'71999','U','Henderson State University','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.124529,-93.072399,0,'2013-07-06 12:44:33',NULL,NULL),(61767,'73056','S','Marshall','D','Logan','40083','Oklahoma','OK','40','5880','580','Central',-6.0,'Y',36.125463,-97.591610,0,'2013-07-06 12:44:33',NULL,NULL),(63848,'75975','S','Timpson','D','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(68231,'81052','S','May Valley','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(22093,'23409','S','Mears','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.878182,-75.650443,0,'2013-07-06 12:44:31',NULL,NULL),(21383,'22485','S','Owens','N','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299944,-77.147624,0,'2013-07-06 12:44:31',NULL,NULL),(59766,'71166','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.505253,-93.741197,0,'2013-07-06 12:44:33',NULL,NULL),(67188,'79855','P','Kent','A','Culberson','48109','Texas','TX','48','0000','915','Central',-6.0,'Y',31.060000,-104.210000,0,'2013-07-06 12:44:34',NULL,NULL),(78389,'98029','S','Issaquah','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.555872,-122.001514,0,'2013-07-06 12:44:34',NULL,NULL),(60979,'72110','S','Hickory Hill','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(57513,'66962','S','Palmer','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610430,-97.089539,0,'2013-07-06 12:44:33',NULL,NULL),(9834,'10115','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(32056,'35260','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.399765,-86.838955,0,'2013-07-06 12:44:32',NULL,NULL),(3360,'01568','S','West Upton','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.171445,-71.604409,0,'2013-07-06 12:44:30',NULL,NULL),(28868,'32117','S','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.236440,-81.057780,0,'2013-07-06 12:44:32',NULL,NULL),(51261,'59086','S','Wilsall','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.055668,-110.692681,0,'2013-07-06 12:44:33',NULL,NULL),(59587,'71006','S','Benton','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.679257,-93.707187,0,'2013-07-06 12:44:33',NULL,NULL),(61004,'72113','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.852398,-92.404691,0,'2013-07-06 12:44:33',NULL,NULL),(74623,'92803','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.839709,-117.938825,0,'2013-07-06 12:44:34',NULL,NULL),(74459,'92591','S','Rancho California','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.531454,-117.100268,0,'2013-07-06 12:44:34',NULL,NULL),(55376,'63601','S','Park Hills','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(3301,'01515','S','E Brookfield','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.222612,-72.053004,0,'2013-07-06 12:44:30',NULL,NULL),(19112,'19606','S','Reading Station','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(25372,'28250','U','Charlotte Water Dept','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.223868,-80.839089,0,'2013-07-06 12:44:31',NULL,NULL),(77268,'96602','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69101,'83254','S','Wardboro','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(56587,'65552','S','Evening Shade','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.494347,-92.183812,0,'2013-07-06 12:44:33',NULL,NULL),(14702,'15261','U','Univ of Pittsburgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441907,-79.956393,0,'2013-07-06 12:44:31',NULL,NULL),(30132,'33164','P','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.929334,-80.176758,0,'2013-07-06 12:44:32',NULL,NULL),(35836,'39773','S','Mary Holmes','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.629580,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(12725,'13158','S','East Homer','A','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695444,-76.014250,0,'2013-07-06 12:44:30',NULL,NULL),(46745,'53923','S','Cambria','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.546952,-89.105675,0,'2013-07-06 12:44:32',NULL,NULL),(77431,'96804','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306209,-157.860153,0,'2013-07-06 12:44:34',NULL,NULL),(74563,'92679','S','Trabuco','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(24848,'27623','P','Westgate','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.859066,-78.790232,0,'2013-07-06 12:44:31',NULL,NULL),(53491,'62001','S','Kaufman','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.880319,-89.747069,0,'2013-07-06 12:44:33',NULL,NULL),(28965,'32204','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.326112,-81.680064,0,'2013-07-06 12:44:32',NULL,NULL),(8281,'08012','S','Turnersville','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(8701,'08353','P','Shiloh','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.454802,-75.297076,0,'2013-07-06 12:44:30',NULL,NULL),(70452,'84749','P','Lyman','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.434907,-111.611696,0,'2013-07-06 12:44:34',NULL,NULL),(63082,'75247','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.814097,-96.879621,0,'2013-07-06 12:44:33',NULL,NULL),(4289,'02898','S','Richmond','A','Washington','44009','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.523074,-71.691005,0,'2013-07-06 12:44:30',NULL,NULL),(10047,'10175','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(22091,'23407','P','Mappsville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.835028,-75.576362,0,'2013-07-06 12:44:31',NULL,NULL),(10408,'10701','S','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.941652,-73.877562,0,'2013-07-06 12:44:30',NULL,NULL),(634,'00682','S','Urb Ensanche Ramirez','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(64155,'76205','S','Shady Shores','N','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.165180,-97.105380,0,'2013-07-06 12:44:34',NULL,NULL),(63761,'75942','P','Doucette','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.818426,-94.431567,0,'2013-07-06 12:44:34',NULL,NULL),(62421,'74141','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.133837,-95.876959,0,'2013-07-06 12:44:33',NULL,NULL),(24983,'27853','S','Margarettsvl','A','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.525209,-77.292806,0,'2013-07-06 12:44:31',NULL,NULL),(38072,'43067','S','Raymond','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.247220,-83.366580,0,'2013-07-06 12:44:32',NULL,NULL),(789,'00693','S','Brisas del Mar','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(5191,'04444','S','Hampden','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.726340,-68.928540,0,'2013-07-06 12:44:30',NULL,NULL),(19337,'20033','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905164,-77.041426,0,'2013-07-06 12:44:31',NULL,NULL),(53864,'62336','P','Ferris','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.503256,-91.134894,0,'2013-07-06 12:44:33',NULL,NULL),(21440,'22572','S','Warsaw','D','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.957415,-76.762507,0,'2013-07-06 12:44:31',NULL,NULL),(57568,'67053','P','Goessel','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.247761,-97.352728,0,'2013-07-06 12:44:33',NULL,NULL),(53860,'62330','S','Dallas City','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.632034,-91.172512,0,'2013-07-06 12:44:33',NULL,NULL),(48419,'55603','S','Murphy City','N','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.469373,-91.279679,0,'2013-07-06 12:44:33',NULL,NULL),(44797,'50229','S','Prole','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.361538,-93.718608,0,'2013-07-06 12:44:32',NULL,NULL),(28932,'32169','S','New Smyrna Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.999132,-80.877818,0,'2013-07-06 12:44:32',NULL,NULL),(45401,'51040','S','Onawa','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.028935,-96.098207,0,'2013-07-06 12:44:32',NULL,NULL),(79757,'99301','S','Pasco','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.286919,-119.092773,0,'2013-07-06 12:44:34',NULL,NULL),(57948,'67747','S','Monument','D','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.960076,-101.064031,0,'2013-07-06 12:44:33',NULL,NULL),(45266,'50668','S','Readlyn','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.703803,-92.225832,0,'2013-07-06 12:44:32',NULL,NULL),(31376,'34211','S','Lakewood Rch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(2359,'00949','S','Ext Lagos de Plata','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(10089,'10211','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.731775,-73.989953,0,'2013-07-06 12:44:30',NULL,NULL),(54032,'62460','S','St Francisville','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.591789,-87.646603,0,'2013-07-06 12:44:33',NULL,NULL),(65540,'77808','S','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.704715,-96.335583,0,'2013-07-06 12:44:34',NULL,NULL),(59049,'70085','S','Verret','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(49230,'56469','S','Verdon','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(47745,'55017','S','Dalbo','D','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.664916,-93.403636,0,'2013-07-06 12:44:33',NULL,NULL),(19468,'20136','S','Bristow','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.721168,-77.535341,0,'2013-07-06 12:44:31',NULL,NULL),(34146,'38235','P','McLemoresville','N','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.985579,-88.581792,0,'2013-07-06 12:44:32',NULL,NULL),(13637,'13905','S','Choconut Center','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(17076,'17758','S','Sonestown','A','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(63832,'75973','S','Jordans Store','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(62856,'75027','P','Flower Mound','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.026466,-97.093775,0,'2013-07-06 12:44:33',NULL,NULL),(62238,'73960','P','Texhoma','D','Sherman','48421','Texas','TX','48','0000','806','Central',-6.0,'Y',36.505537,-101.782938,0,'2013-07-06 12:44:33',NULL,NULL),(11500,'12025','S','Broadalbin','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(1054,'00725','S','Alt del Turabo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(2875,'00987','S','Bo Colo','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(35136,'39216','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.335115,-90.166439,0,'2013-07-06 12:44:32',NULL,NULL),(23647,'25801','S','East Beckley','N','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.786941,-81.191873,0,'2013-07-06 12:44:31',NULL,NULL),(41287,'46761','S','Mt Pisgah','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(905,'00705','S','Repto Robles','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(40823,'46208','S','Rocky Ripple','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.820704,-86.169262,0,'2013-07-06 12:44:32',NULL,NULL),(69335,'83531','P','Grangeville','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.926329,-116.125155,0,'2013-07-06 12:44:34',NULL,NULL),(69444,'83647','S','Featherville','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(78262,'97845','S','John Day','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.427485,-118.948196,0,'2013-07-06 12:44:34',NULL,NULL),(71851,'87654','U','Spaceport City','D','Sierra','35051','New Mexico','NM','35','0000','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(68865,'82637','S','Parkerton','A','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.831726,-105.843281,0,'2013-07-06 12:44:34',NULL,NULL),(32083,'35290','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.550093,-86.741320,0,'2013-07-06 12:44:32',NULL,NULL),(47605,'54874','S','Wentworth','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.558560,-91.920960,0,'2013-07-06 12:44:33',NULL,NULL),(48940,'56164','S','Hatfield','A','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.994823,-96.317095,0,'2013-07-06 12:44:33',NULL,NULL),(67488,'80231','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.675732,-104.886871,0,'2013-07-06 12:44:34',NULL,NULL),(35660,'39648','S','Holmesville','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(31827,'35071','S','Gardendale','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.669561,-86.827977,0,'2013-07-06 12:44:32',NULL,NULL),(29102,'32303','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.483064,-84.324340,0,'2013-07-06 12:44:32',NULL,NULL),(47642,'54923','S','Berlin','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.969316,-88.947033,0,'2013-07-06 12:44:33',NULL,NULL),(55639,'64015','S','Lake Tapawingo','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.017700,-94.310640,0,'2013-07-06 12:44:33',NULL,NULL),(72470,'89124','S','Corn Creek','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(67403,'80128','S','Littleton','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.599307,-105.128459,0,'2013-07-06 12:44:34',NULL,NULL),(56276,'65068','S','Gouch Mill','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.827855,-92.602120,0,'2013-07-06 12:44:33',NULL,NULL),(32683,'36269','S','Muscadine','D','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.744532,-85.379277,0,'2013-07-06 12:44:32',NULL,NULL),(45760,'52146','S','Egan','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.201376,-91.147423,0,'2013-07-06 12:44:32',NULL,NULL),(43934,'49279','S','Sand Creek','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.781146,-84.102103,0,'2013-07-06 12:44:32',NULL,NULL),(4234,'02859','S','Pascoag','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.963364,-71.717450,0,'2013-07-06 12:44:30',NULL,NULL),(46494,'53226','S','Wawatosa','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.047262,-88.044347,0,'2013-07-06 12:44:32',NULL,NULL),(504,'00674','S','Jard de Monaco 2','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(53571,'62058','P','Livingston','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.967135,-89.759212,0,'2013-07-06 12:44:33',NULL,NULL),(61849,'73120','S','Nichols Hills','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.584064,-97.574272,0,'2013-07-06 12:44:33',NULL,NULL),(78716,'98274','S','Mount Vernon','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.418364,-122.312369,0,'2013-07-06 12:44:34',NULL,NULL),(78921,'98366','S','East Port Orchard','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(72141,'88314','S','Bent','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.153515,-105.883199,0,'2013-07-06 12:44:34',NULL,NULL),(57975,'67836','P','Coolidge','D','Hamilton','20075','Kansas','KS','20','0000','620','Mountain',-7.0,'Y',38.037855,-102.009987,0,'2013-07-06 12:44:33',NULL,NULL),(56602,'65560','S','Shannondale','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(52957,'61420','S','Blandinsville','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.556556,-90.829213,0,'2013-07-06 12:44:33',NULL,NULL),(49542,'56683','S','Tenstrike','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.661284,-94.681663,0,'2013-07-06 12:44:33',NULL,NULL),(33597,'37615','S','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.373920,-82.445040,0,'2013-07-06 12:44:32',NULL,NULL),(49653,'56999','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8872','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(59103,'70139','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.949141,-90.071942,0,'2013-07-06 12:44:33',NULL,NULL),(73448,'91301','S','Oak Park','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(76098,'95223','S','Bear Valley','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.263800,-120.332640,0,'2013-07-06 12:44:34',NULL,NULL),(54196,'62633','S','Biggs','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.234297,-89.847735,0,'2013-07-06 12:44:33',NULL,NULL),(39550,'44841','S','Kansas','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.246255,-83.299949,0,'2013-07-06 12:44:32',NULL,NULL),(4688,'03805','S','Portsmouth','A','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.239099,-70.824153,0,'2013-07-06 12:44:30',NULL,NULL),(44383,'49801','S','East Kingsford','N','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.817870,-88.066576,0,'2013-07-06 12:44:32',NULL,NULL),(54015,'62451','S','Lamotte','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.002766,-87.615625,0,'2013-07-06 12:44:33',NULL,NULL),(56590,'65555','S','Raymondville','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.362406,-91.771692,0,'2013-07-06 12:44:33',NULL,NULL),(67633,'80451','P','Hot Sulphur Springs','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.074422,-106.104276,0,'2013-07-06 12:44:34',NULL,NULL),(69666,'84017','S','Coalville','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.804680,-111.296340,0,'2013-07-06 12:44:34',NULL,NULL),(74144,'92254','S','Mecca','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.553183,-116.050757,0,'2013-07-06 12:44:34',NULL,NULL),(79395,'98801','S','Pearcot','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(53367,'61771','S','Secor','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.740576,-89.133676,0,'2013-07-06 12:44:33',NULL,NULL),(29119,'32313','U','Fl State Univ Student','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430000,-84.280000,0,'2013-07-06 12:44:32',NULL,NULL),(3746,'02170','S','Wollaston','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.268871,-71.020060,0,'2013-07-06 12:44:30',NULL,NULL),(43391,'48438','S','Goodrich','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.910423,-83.507861,0,'2013-07-06 12:44:32',NULL,NULL),(7264,'06518','S','Mount Carmel','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.415836,-72.912377,0,'2013-07-06 12:44:30',NULL,NULL),(26309,'29038','S','Cope','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.370991,-80.963626,0,'2013-07-06 12:44:31',NULL,NULL),(20760,'21501','P','Cumberland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.649676,-78.757756,0,'2013-07-06 12:44:31',NULL,NULL),(60874,'72060','S','Griffithville','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.121245,-91.647567,0,'2013-07-06 12:44:33',NULL,NULL),(12860,'13320','S','Cherry Valley','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.796521,-74.756366,0,'2013-07-06 12:44:30',NULL,NULL),(13750,'14120','S','No Tonawanda','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.071240,-78.814140,0,'2013-07-06 12:44:31',NULL,NULL),(41497,'46952','S','Marion','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.573842,-85.666492,0,'2013-07-06 12:44:32',NULL,NULL),(7158,'06423','S','East Haddam','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.472792,-72.399917,0,'2013-07-06 12:44:30',NULL,NULL),(10393,'10603','S','N White Plains','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.050315,-73.777527,0,'2013-07-06 12:44:30',NULL,NULL),(68783,'82331','S','Ryan Park','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.321340,-106.502710,0,'2013-07-06 12:44:34',NULL,NULL),(70595,'85087','S','Phoenix','A','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.915238,-112.136717,0,'2013-07-06 12:44:34',NULL,NULL),(63526,'75755','S','Pritchett','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.583260,-95.112002,0,'2013-07-06 12:44:33',NULL,NULL),(62699,'74736','S','Garvin','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.922045,-94.933085,0,'2013-07-06 12:44:33',NULL,NULL),(25530,'28398','S','Warsaw','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.980540,-78.094560,0,'2013-07-06 12:44:31',NULL,NULL),(19647,'20270','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900588,-77.022082,0,'2013-07-06 12:44:31',NULL,NULL),(56621,'65584','S','St Roberts','N','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.828919,-92.200348,0,'2013-07-06 12:44:33',NULL,NULL),(57329,'66713','S','Baxter Springs','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.022713,-94.739150,0,'2013-07-06 12:44:33',NULL,NULL),(69298,'83446','S','Spencer','D','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.352939,-112.002532,0,'2013-07-06 12:44:34',NULL,NULL),(58006,'67867','S','Montezuma','D','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.593985,-100.442446,0,'2013-07-06 12:44:33',NULL,NULL),(54278,'62690','S','Virden','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.503887,-89.767276,0,'2013-07-06 12:44:33',NULL,NULL),(28844,'32086','S','St Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.759403,-81.303970,0,'2013-07-06 12:44:32',NULL,NULL),(44983,'50427','S','Chapin','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.839158,-93.222003,0,'2013-07-06 12:44:32',NULL,NULL),(33925,'38055','U','Naval Personel Commnd','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.340560,-89.894343,0,'2013-07-06 12:44:32',NULL,NULL),(29239,'32434','P','Defuniak Spgs','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.742338,-86.314609,0,'2013-07-06 12:44:32',NULL,NULL),(22799,'24471','S','Pt Republic','N','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.318464,-78.812924,0,'2013-07-06 12:44:31',NULL,NULL),(28430,'31331','S','Townsend','D','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(65627,'77963','S','Charco','N','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(73646,'91495','U','Sherman Oaks','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151111,-118.448333,0,'2013-07-06 12:44:34',NULL,NULL),(67872,'80832','S','Ramah','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.088054,-104.081653,0,'2013-07-06 12:44:34',NULL,NULL),(62709,'74748','S','Kenefic','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.124931,-96.409322,0,'2013-07-06 12:44:33',NULL,NULL),(55802,'64133','S','Raytown','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.022020,-94.464540,0,'2013-07-06 12:44:33',NULL,NULL),(55108,'63332','S','Schluersburg','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.595378,-90.883880,0,'2013-07-06 12:44:33',NULL,NULL),(5604,'04930','S','Dexter','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.025984,-69.285426,0,'2013-07-06 12:44:30',NULL,NULL),(31757,'34994','S','Stuart','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.197528,-80.253111,0,'2013-07-06 12:44:32',NULL,NULL),(30183,'33176','S','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(5144,'04416','S','Verona Island','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.575891,-68.787997,0,'2013-07-06 12:44:30',NULL,NULL),(76551,'95666','S','Silver Lake','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.458140,-120.520020,0,'2013-07-06 12:44:34',NULL,NULL),(56535,'65439','S','Bixby','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.665087,-91.069445,0,'2013-07-06 12:44:33',NULL,NULL),(49252,'56474','S','Walden','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(17863,'18435','S','Lackawaxen','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.511845,-75.077607,0,'2013-07-06 12:44:31',NULL,NULL),(30900,'33706','S','Saint Pete Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(23940,'26264','S','Durbin','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.649083,-79.776011,0,'2013-07-06 12:44:31',NULL,NULL),(27940,'30531','S','Cornelia','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.514324,-83.524800,0,'2013-07-06 12:44:31',NULL,NULL),(48377,'55567','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814948,-93.921565,0,'2013-07-06 12:44:33',NULL,NULL),(51681,'59928','S','Polebridge','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.901396,-114.402528,0,'2013-07-06 12:44:33',NULL,NULL),(60331,'71462','S','Vines Loop','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.692840,-93.699360,0,'2013-07-06 12:44:33',NULL,NULL),(14475,'15123','S','West Mifflin Century Mall','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.342320,-79.954680,0,'2013-07-06 12:44:31',NULL,NULL),(40955,'46307','S','Palmer','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.419705,-87.354291,0,'2013-07-06 12:44:32',NULL,NULL),(53035,'61476','S','Seaton','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.100178,-90.797496,0,'2013-07-06 12:44:33',NULL,NULL),(54384,'62816','S','Bonnie','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.196392,-88.939503,0,'2013-07-06 12:44:33',NULL,NULL),(54469,'62858','S','Hord','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(41829,'47341','S','Bethel','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.967634,-84.910903,0,'2013-07-06 12:44:32',NULL,NULL),(62515,'74401','S','Summit','A','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(41363,'46794','S','Brimfield','A','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(37736,'42301','S','St Joseph','A','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.747812,-87.178813,0,'2013-07-06 12:44:32',NULL,NULL),(35370,'39451','S','Leakesville','D','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.152091,-88.563411,0,'2013-07-06 12:44:32',NULL,NULL),(59833,'71241','S','Farmerville','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.771520,-92.332620,0,'2013-07-06 12:44:33',NULL,NULL),(43696,'48887','P','Smyrna','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',43.062420,-85.262729,0,'2013-07-06 12:44:32',NULL,NULL),(32786,'36420','S','Rome','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(52782,'61270','S','Genesee','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(72583,'89406','S','Cold Spring','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(19470,'20138','P','Calverton','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.631396,-77.672550,0,'2013-07-06 12:44:31',NULL,NULL),(45753,'52141','S','Elgin','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.958838,-91.636493,0,'2013-07-06 12:44:32',NULL,NULL),(38672,'43952','S','Wintersville','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.369140,-80.712600,0,'2013-07-06 12:44:32',NULL,NULL),(27188,'29851','S','Stiefeltown','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.518108,-81.820849,0,'2013-07-06 12:44:31',NULL,NULL),(32774,'36375','S','Slocomb','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.110702,-85.590295,0,'2013-07-06 12:44:32',NULL,NULL),(58689,'68924','S','Mirage','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.480326,-99.125483,0,'2013-07-06 12:44:33',NULL,NULL),(77750,'97102','S','Arch Cape','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.885137,-123.944278,0,'2013-07-06 12:44:34',NULL,NULL),(45231,'50647','S','Finchford','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.632632,-92.495481,0,'2013-07-06 12:44:32',NULL,NULL),(29665,'32910','P','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.997533,-80.691463,0,'2013-07-06 12:44:32',NULL,NULL),(17991,'18625','P','Lake Winola','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.514755,-75.842759,0,'2013-07-06 12:44:31',NULL,NULL),(14566,'15215','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.503780,-79.912020,0,'2013-07-06 12:44:31',NULL,NULL),(47667,'54942','S','Greenville','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.308055,-88.550927,0,'2013-07-06 12:44:33',NULL,NULL),(50548,'58203','S','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.929943,-97.071986,0,'2013-07-06 12:44:33',NULL,NULL),(57761,'67450','S','Holyrood','D','Ellsworth','20053','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.588065,-98.414179,0,'2013-07-06 12:44:33',NULL,NULL),(64053,'76132','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.671991,-97.432311,0,'2013-07-06 12:44:34',NULL,NULL),(66238,'78569','S','Stockholm','N','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.410500,-97.764420,0,'2013-07-06 12:44:34',NULL,NULL),(21638,'22922','S','Tye River','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.692180,-78.914700,0,'2013-07-06 12:44:31',NULL,NULL),(21008,'21838','S','Marion Station','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.025060,-75.729060,0,'2013-07-06 12:44:31',NULL,NULL),(31009,'33777','S','Seminole','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.853863,-82.762036,0,'2013-07-06 12:44:32',NULL,NULL),(20133,'20722','S','Cottage City','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(5667,'04961','S','Pierce Pond','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(23441,'25410','P','Bakerton','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.326988,-77.780046,0,'2013-07-06 12:44:31',NULL,NULL),(17871,'18436','S','Roaring Brook Twp','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(51144,'58843','S','Epping','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.242437,-103.343766,0,'2013-07-06 12:44:33',NULL,NULL),(51678,'59925','S','Marion','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.110021,-114.757542,0,'2013-07-06 12:44:33',NULL,NULL),(19447,'20115','S','Marshall','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.811100,-77.918330,0,'2013-07-06 12:44:31',NULL,NULL),(46713,'53802','P','Beetown','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.761754,-90.891946,0,'2013-07-06 12:44:32',NULL,NULL),(39496,'44802','S','Alvada','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.041557,-83.446098,0,'2013-07-06 12:44:32',NULL,NULL),(3455,'01776','S','N Sudbury','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.382955,-71.427696,0,'2013-07-06 12:44:30',NULL,NULL),(10061,'10177','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(7386,'06779','S','Oakville','D','Litchfield','09005','Connecticut','CT','09','8880','860/959','Eastern',-5.0,'Y',41.593909,-73.087086,0,'2013-07-06 12:44:30',NULL,NULL),(60243,'71433','S','Glenmora','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(2447,'00953','S','Urb Portobello','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(32921,'36558','S','Aquilla','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(46681,'53777','U','American Family Ins Co','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.107649,-89.339418,0,'2013-07-06 12:44:32',NULL,NULL),(54604,'62909','P','Boles','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.465808,-88.996359,0,'2013-07-06 12:44:33',NULL,NULL),(73983,'92091','S','Rcho Santa Fe','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.014160,-117.241081,0,'2013-07-06 12:44:34',NULL,NULL),(78200,'97737','S','Gilchrist','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.423495,-121.702823,0,'2013-07-06 12:44:34',NULL,NULL),(57241,'66521','S','Wheaton','A','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.491343,-96.171545,0,'2013-07-06 12:44:33',NULL,NULL),(69532,'83732','U','Intermountain Gas Co','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.546838,-116.288502,0,'2013-07-06 12:44:34',NULL,NULL),(74259,'92339','S','Forest Falls','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.064027,-117.035983,0,'2013-07-06 12:44:34',NULL,NULL),(41861,'47355','S','Crete','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(35026,'39159','S','Fitler','A','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.897670,-90.882023,0,'2013-07-06 12:44:32',NULL,NULL),(64979,'77267','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.953948,-95.444857,0,'2013-07-06 12:44:34',NULL,NULL),(13711,'14068','S','Getzville','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.023243,-78.753686,0,'2013-07-06 12:44:31',NULL,NULL),(44947,'50380','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582496,-93.639304,0,'2013-07-06 12:44:32',NULL,NULL),(44888,'50317','S','Pleasant Hill','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(42628,'47907','S','Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.368719,-86.877988,0,'2013-07-06 12:44:32',NULL,NULL),(28991,'32216','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.279875,-81.583037,0,'2013-07-06 12:44:32',NULL,NULL),(35360,'39440','S','Pineview','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(29470,'32720','S','Deland','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.028004,-81.325835,0,'2013-07-06 12:44:32',NULL,NULL),(33600,'37618','S','Bluff City','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.469676,-82.239010,0,'2013-07-06 12:44:32',NULL,NULL),(57891,'67638','S','Gaylord','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.657956,-98.781531,0,'2013-07-06 12:44:33',NULL,NULL),(64982,'77270','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.798454,-95.419010,0,'2013-07-06 12:44:34',NULL,NULL),(72602,'89410','S','Topaz Lodge','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(75586,'94290','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.555426,-121.499265,0,'2013-07-06 12:44:34',NULL,NULL),(44841,'50264','S','Weldon','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.857694,-93.728115,0,'2013-07-06 12:44:32',NULL,NULL),(26490,'29164','S','Seivern','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(41958,'47405','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.172055,-86.523157,0,'2013-07-06 12:44:32',NULL,NULL),(28220,'31036','S','Grovania','N','Pulaski','13235','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.281988,-83.473610,0,'2013-07-06 12:44:31',NULL,NULL),(36330,'40390','S','Versailles','A','Jessamine','21113','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.862373,-84.648746,0,'2013-07-06 12:44:32',NULL,NULL),(34411,'38631','P','Amistead','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.359895,-90.635937,0,'2013-07-06 12:44:32',NULL,NULL),(58828,'69044','S','Trenton','D','Hitchcock','31087','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.134519,-101.039622,0,'2013-07-06 12:44:33',NULL,NULL),(60914,'72079','S','Jefferson','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.385634,-92.168401,0,'2013-07-06 12:44:33',NULL,NULL),(1826,'00784','S','Urb Bello Horizonte','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(26710,'29412','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.719260,-79.951080,0,'2013-07-06 12:44:31',NULL,NULL),(40282,'45439','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(33677,'37737','S','Friendsville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.769900,-84.158597,0,'2013-07-06 12:44:32',NULL,NULL),(47188,'54484','S','Stratford','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.797647,-90.067948,0,'2013-07-06 12:44:32',NULL,NULL),(40681,'46062','S','Westfield','A','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.038530,-86.005091,0,'2013-07-06 12:44:32',NULL,NULL),(31787,'35031','S','Blountsville','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',34.080060,-86.594331,0,'2013-07-06 12:44:32',NULL,NULL),(69059,'83234','S','Virginia','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.451890,-112.157149,0,'2013-07-06 12:44:34',NULL,NULL),(75595,'94299','U','Ca State Govt Brm','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.564429,-121.469141,0,'2013-07-06 12:44:34',NULL,NULL),(79546,'98953','S','Zillah','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.420015,-120.259025,0,'2013-07-06 12:44:34',NULL,NULL),(59723,'71108','S','Summer Grove','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.441723,-93.787148,0,'2013-07-06 12:44:33',NULL,NULL),(68294,'81090','S','Walsh','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.351772,-102.260430,0,'2013-07-06 12:44:34',NULL,NULL),(21816,'23105','P','Mannboro','D','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.255087,-77.826024,0,'2013-07-06 12:44:31',NULL,NULL),(49556,'56710','S','Alvarado','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.228671,-96.955952,0,'2013-07-06 12:44:33',NULL,NULL),(61416,'72562','S','Newark','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.727707,-91.435632,0,'2013-07-06 12:44:33',NULL,NULL),(63845,'75975','S','Eulalie','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(76875,'95973','S','Richardson Springs','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.737451,-121.830460,0,'2013-07-06 12:44:34',NULL,NULL),(27565,'30265','S','Newnan','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.405124,-84.710418,0,'2013-07-06 12:44:31',NULL,NULL),(76123,'95246','S','Mountain Ranch','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.242296,-120.533316,0,'2013-07-06 12:44:34',NULL,NULL),(6273,'05620','U','State of Vermont','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262683,-72.583905,0,'2013-07-06 12:44:30',NULL,NULL),(34885,'38944','S','Sunnyside','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.696389,-90.295000,0,'2013-07-06 12:44:32',NULL,NULL),(14054,'14569','S','Warsaw','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.739675,-78.164650,0,'2013-07-06 12:44:31',NULL,NULL),(47846,'55075','S','S Saint Paul','N','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.892636,-93.040178,0,'2013-07-06 12:44:33',NULL,NULL),(57154,'66276','U','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.002659,-94.669998,0,'2013-07-06 12:44:33',NULL,NULL),(78977,'98373','S','South Hill','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.131712,-122.323280,0,'2013-07-06 12:44:34',NULL,NULL),(61688,'72944','S','Mansfield','D','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.017534,-94.201396,0,'2013-07-06 12:44:33',NULL,NULL),(52439,'60660','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.990183,-87.664800,0,'2013-07-06 12:44:33',NULL,NULL),(47910,'55110','S','Gem Lake','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(1974,'00901','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.463862,-66.109811,0,'2013-07-06 12:44:30',NULL,NULL),(30248,'33199','U','Flinternational Univ','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.759145,-80.372492,0,'2013-07-06 12:44:32',NULL,NULL),(74744,'93043','U','Prt Hueneme','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.162390,-119.201182,0,'2013-07-06 12:44:34',NULL,NULL),(78913,'98363','S','Pt Angeles','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.118410,-123.480610,0,'2013-07-06 12:44:34',NULL,NULL),(5957,'05301','S','Brattleboro Center','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(6485,'05769','S','West Salisbury','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.903320,-73.095300,0,'2013-07-06 12:44:30',NULL,NULL),(6644,'06016','S','Broad Brook','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.908366,-72.542144,0,'2013-07-06 12:44:30',NULL,NULL),(53517,'62025','S','Dunlap Lake','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.808317,-89.950081,0,'2013-07-06 12:44:33',NULL,NULL),(53970,'62432','S','Rose Hill','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.117001,-88.129813,0,'2013-07-06 12:44:33',NULL,NULL),(67579,'80309','U','University of Colorado','N','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.009437,-105.269917,0,'2013-07-06 12:44:34',NULL,NULL),(10993,'11549','U','Hempstead','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705686,-73.618785,0,'2013-07-06 12:44:30',NULL,NULL),(26562,'29209','S','Leesburg','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(44969,'50401','S','Hanford','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(11498,'12023','S','West Berne','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.606360,-74.143800,0,'2013-07-06 12:44:30',NULL,NULL),(5713,'04986','S','Thorndike','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.579334,-69.243569,0,'2013-07-06 12:44:30',NULL,NULL),(49087,'56329','S','Ronneby','N','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.689579,-93.912459,0,'2013-07-06 12:44:33',NULL,NULL),(61938,'73159','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.390690,-97.553870,0,'2013-07-06 12:44:33',NULL,NULL),(66783,'79042','S','Happy','D','Swisher','48437','Texas','TX','48','0000','806','Central',-6.0,'Y',34.744043,-101.856272,0,'2013-07-06 12:44:34',NULL,NULL),(4887,'04043','S','Kennebunk','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.373725,-70.528249,0,'2013-07-06 12:44:30',NULL,NULL),(16832,'17555','S','Beartown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.133056,-75.965000,0,'2013-07-06 12:44:31',NULL,NULL),(49109,'56347','S','Little Sauk','A','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.863889,-94.918056,0,'2013-07-06 12:44:33',NULL,NULL),(75229,'93643','S','North Fork','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.233523,-119.500796,0,'2013-07-06 12:44:34',NULL,NULL),(77008,'96086','S','Seiad Valley','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.846180,-123.213116,0,'2013-07-06 12:44:34',NULL,NULL),(78103,'97491','P','Wedderburn','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.456811,-124.402213,0,'2013-07-06 12:44:34',NULL,NULL),(43331,'48363','S','Oakland Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.764292,-83.166518,0,'2013-07-06 12:44:32',NULL,NULL),(34691,'38828','S','Endville','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(24888,'27705','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.017812,-78.948419,0,'2013-07-06 12:44:31',NULL,NULL),(19202,'19884','U','Greenville','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743248,-75.545385,0,'2013-07-06 12:44:31',NULL,NULL),(51253,'59079','S','Shepherd','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.946810,-108.354720,0,'2013-07-06 12:44:33',NULL,NULL),(1419,'00738','S','Villa Clarita','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(4081,'02662','P','South Orleans','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.747448,-69.991477,0,'2013-07-06 12:44:30',NULL,NULL),(10660,'11105','S','Astoria','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.778285,-73.910175,0,'2013-07-06 12:44:30',NULL,NULL),(5541,'04786','S','Washburn','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.786601,-68.147503,0,'2013-07-06 12:44:30',NULL,NULL),(56541,'65444','S','Ellis Prairie','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.399403,-92.038861,0,'2013-07-06 12:44:33',NULL,NULL),(66534,'78724','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.294200,-97.628001,0,'2013-07-06 12:44:34',NULL,NULL),(78852,'98339','S','Oak Bay','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.027885,-122.759844,0,'2013-07-06 12:44:34',NULL,NULL),(66746,'79002','P','Alanreed','D','Gray','48179','Texas','TX','48','0000','806','Central',-6.0,'Y',35.433010,-100.743604,0,'2013-07-06 12:44:34',NULL,NULL),(69674,'84021','S','Bridgeland','A','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.169700,-110.398451,0,'2013-07-06 12:44:34',NULL,NULL),(76256,'95407','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.405151,-122.735183,0,'2013-07-06 12:44:34',NULL,NULL),(41112,'46570','S','Tippecanoe','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.212477,-86.124053,0,'2013-07-06 12:44:32',NULL,NULL),(38636,'43930','S','Hammondsville','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.612105,-80.783966,0,'2013-07-06 12:44:32',NULL,NULL),(62574,'74460','P','Schulter','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.512604,-95.958850,0,'2013-07-06 12:44:33',NULL,NULL),(45828,'52211','S','Brooklyn','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.729084,-92.445540,0,'2013-07-06 12:44:32',NULL,NULL),(16074,'17050','S','Goodhope','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(5503,'04762','S','New Sweden','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.968188,-68.118442,0,'2013-07-06 12:44:30',NULL,NULL),(39818,'45144','S','Wrightsville','N','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.702000,-83.612593,0,'2013-07-06 12:44:32',NULL,NULL),(49325,'56551','S','Henning','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.322593,-95.346305,0,'2013-07-06 12:44:33',NULL,NULL),(51704,'60007','S','Elk Grove Vlg','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.008834,-88.001385,0,'2013-07-06 12:44:33',NULL,NULL),(61711,'73008','S','Bethany','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.502940,-97.644790,0,'2013-07-06 12:44:33',NULL,NULL),(78238,'97819','S','Bridgeport','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.483048,-117.743386,0,'2013-07-06 12:44:34',NULL,NULL),(7150,'06416','S','Cromwell','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.609671,-72.663331,0,'2013-07-06 12:44:30',NULL,NULL),(37032,'41256','S','Barnetts Crk','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.836517,-82.861342,0,'2013-07-06 12:44:32',NULL,NULL),(41962,'47407','P','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.170043,-86.495005,0,'2013-07-06 12:44:32',NULL,NULL),(50807,'58454','S','Nortonville','A','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.488265,-98.813122,0,'2013-07-06 12:44:33',NULL,NULL),(62221,'73931','S','Balko','D','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.588033,-100.680630,0,'2013-07-06 12:44:33',NULL,NULL),(70329,'84628','P','Mammoth','A','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.953450,-112.113013,0,'2013-07-06 12:44:34',NULL,NULL),(30669,'33467','S','Greenacres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.606929,-80.177700,0,'2013-07-06 12:44:32',NULL,NULL),(52131,'60432','S','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.535383,-88.053442,0,'2013-07-06 12:44:33',NULL,NULL),(60369,'71479','S','Flat Creek','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.858786,-92.289315,0,'2013-07-06 12:44:33',NULL,NULL),(62431,'74155','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.098789,-95.876661,0,'2013-07-06 12:44:33',NULL,NULL),(78924,'98366','S','Harper','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(46619,'53576','S','Orfordville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.623722,-89.244316,0,'2013-07-06 12:44:32',NULL,NULL),(42590,'47885','S','Champion','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(39188,'44320','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081335,-81.573558,0,'2013-07-06 12:44:32',NULL,NULL),(58760,'68961','S','Nelson','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.198823,-98.070094,0,'2013-07-06 12:44:33',NULL,NULL),(61855,'73121','S','Lake Aluma','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.509891,-97.446247,0,'2013-07-06 12:44:33',NULL,NULL),(8315,'08032','S','Grenloch','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.780413,-75.059170,0,'2013-07-06 12:44:30',NULL,NULL),(25515,'28386','S','Rennert','A','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.904009,-79.166196,0,'2013-07-06 12:44:31',NULL,NULL),(54311,'62716','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748155,-89.611770,0,'2013-07-06 12:44:33',NULL,NULL),(61330,'72455','S','Pocahontas','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.310500,-91.038780,0,'2013-07-06 12:44:33',NULL,NULL),(63158,'75391','U','Chase Bank','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.949228,-96.825524,0,'2013-07-06 12:44:33',NULL,NULL),(66262,'78575','S','Rancho Viejo','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.021280,-97.533780,0,'2013-07-06 12:44:34',NULL,NULL),(29881,'33042','S','Lwr Sugarloaf','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(48277,'55431','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.824971,-93.316218,0,'2013-07-06 12:44:33',NULL,NULL),(56365,'65212','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.909422,-92.247037,0,'2013-07-06 12:44:33',NULL,NULL),(15398,'16335','S','Blooming Valley','N','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.640960,-80.169720,0,'2013-07-06 12:44:31',NULL,NULL),(45674,'52040','S','Petersburg','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.492540,-91.080300,0,'2013-07-06 12:44:32',NULL,NULL),(11327,'11788','S','Smithtown','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.816902,-73.210989,0,'2013-07-06 12:44:30',NULL,NULL),(6374,'05680','S','Pottersville','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.546700,-72.497820,0,'2013-07-06 12:44:30',NULL,NULL),(29588,'32826','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.580464,-81.186488,0,'2013-07-06 12:44:32',NULL,NULL),(55248,'63448','S','La Grange','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.038368,-91.501988,0,'2013-07-06 12:44:33',NULL,NULL),(74968,'93434','S','Guadalupe','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.957417,-120.572565,0,'2013-07-06 12:44:34',NULL,NULL),(76206,'95361','S','Oakdale','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.781218,-120.835377,0,'2013-07-06 12:44:34',NULL,NULL),(42958,'48130','S','Four Mile Lk','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(26326,'29048','S','Eutawville','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.408960,-80.328420,0,'2013-07-06 12:44:31',NULL,NULL),(39241,'44429','S','Craig Beach','N','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.101255,-80.981944,0,'2013-07-06 12:44:32',NULL,NULL),(61446,'72611','S','Carrollton','N','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.300437,-93.274506,0,'2013-07-06 12:44:33',NULL,NULL),(13284,'13659','S','Lorraine','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.791138,-75.824986,0,'2013-07-06 12:44:30',NULL,NULL),(28400,'31315','S','Hinesville','A','Liberty','13179','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.887737,-81.600923,0,'2013-07-06 12:44:32',NULL,NULL),(30705,'33487','S','Highland Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.399700,-80.101680,0,'2013-07-06 12:44:32',NULL,NULL),(48967,'56207','S','Alberta','D','Stevens','27149','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.540417,-96.053822,0,'2013-07-06 12:44:33',NULL,NULL),(71019,'85730','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.177877,-110.803001,0,'2013-07-06 12:44:34',NULL,NULL),(47420,'54660','S','Tomah','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.994100,-90.459720,0,'2013-07-06 12:44:32',NULL,NULL),(5034,'04256','S','Mechanic Fls','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.104531,-70.370014,0,'2013-07-06 12:44:30',NULL,NULL),(4969,'04109','S','Cushing Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(49880,'57262','S','Sisseton','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.664922,-97.048055,0,'2013-07-06 12:44:33',NULL,NULL),(51168,'59004','U','Ashland','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.621966,-106.314153,0,'2013-07-06 12:44:33',NULL,NULL),(57438,'66833','S','Allen','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.641500,-96.253620,0,'2013-07-06 12:44:33',NULL,NULL),(64936,'77220','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772371,-95.315090,0,'2013-07-06 12:44:34',NULL,NULL),(67129,'79752','S','McCamey','A','Upton','48461','Texas','TX','48','0000','432','Central',-6.0,'Y',31.131143,-102.220417,0,'2013-07-06 12:44:34',NULL,NULL),(16427,'17229','S','Hustontown','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.120009,-77.992025,0,'2013-07-06 12:44:31',NULL,NULL),(44155,'49528','P','Kentwood','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881100,-85.623900,0,'2013-07-06 12:44:32',NULL,NULL),(10359,'10579','S','Crofts Corners','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.390553,-73.846426,0,'2013-07-06 12:44:30',NULL,NULL),(50094,'57471','S','Glen','N','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.429120,-99.336780,0,'2013-07-06 12:44:33',NULL,NULL),(57417,'66773','S','Scammon','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.267281,-94.853706,0,'2013-07-06 12:44:33',NULL,NULL),(14572,'15216','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(42809,'48054','S','China Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767172,-82.540934,0,'2013-07-06 12:44:32',NULL,NULL),(40468,'45766','S','New Marshfld','A','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.333878,-82.244068,0,'2013-07-06 12:44:32',NULL,NULL),(39589,'44865','S','New Pittsburgh','N','Huron','39077','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.995780,-82.670280,0,'2013-07-06 12:44:32',NULL,NULL),(27964,'30555','S','Fry','N','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.978674,-84.372632,0,'2013-07-06 12:44:31',NULL,NULL),(52414,'60643','S','Calumet Park','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.699379,-87.659992,0,'2013-07-06 12:44:33',NULL,NULL),(64848,'77046','S','Greenway Plaza','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.737380,-95.393776,0,'2013-07-06 12:44:34',NULL,NULL),(73642,'91470','U','Blue Cross of So Calif','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.177794,-118.614680,0,'2013-07-06 12:44:34',NULL,NULL),(4980,'04110','S','Cumberland Foreside','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.759193,-70.202112,0,'2013-07-06 12:44:30',NULL,NULL),(11422,'11964','P','Shelter Is','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.067294,-72.337204,0,'2013-07-06 12:44:30',NULL,NULL),(10776,'11365','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738549,-73.790001,0,'2013-07-06 12:44:30',NULL,NULL),(48122,'55357','S','Independence','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.100321,-93.661093,0,'2013-07-06 12:44:33',NULL,NULL),(50814,'58461','S','Litchville','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.718067,-98.207019,0,'2013-07-06 12:44:33',NULL,NULL),(61370,'72520','S','Camp','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.391882,-91.727113,0,'2013-07-06 12:44:33',NULL,NULL),(64166,'76226','S','Bartonville','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.104830,-97.164815,0,'2013-07-06 12:44:34',NULL,NULL),(68034,'80928','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.588656,-104.442148,0,'2013-07-06 12:44:34',NULL,NULL),(4716,'03821','P','Dover','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.188748,-70.902833,0,'2013-07-06 12:44:30',NULL,NULL),(11358,'11815','U','Hicksville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.768318,-73.514148,0,'2013-07-06 12:44:30',NULL,NULL),(24779,'27565','S','Oxford','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.309269,-78.591202,0,'2013-07-06 12:44:31',NULL,NULL),(15105,'15773','S','Saint Benedict','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.608504,-78.736951,0,'2013-07-06 12:44:31',NULL,NULL),(53478,'61941','P','Murdock','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.799954,-88.080692,0,'2013-07-06 12:44:33',NULL,NULL),(6038,'05407','P','S Burlington','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446346,-73.175684,0,'2013-07-06 12:44:30',NULL,NULL),(781,'00693','S','Bo Algarrobo','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(55487,'63764','S','Scopus','A','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.303440,-89.971980,0,'2013-07-06 12:44:33',NULL,NULL),(71312,'86504','P','White Clay','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.747110,-109.070940,0,'2013-07-06 12:44:34',NULL,NULL),(22065,'23337','S','Chincoteague','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.862571,-75.462907,0,'2013-07-06 12:44:31',NULL,NULL),(14173,'14739','S','Friendship','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.203341,-78.139046,0,'2013-07-06 12:44:31',NULL,NULL),(73820,'91766','S','Phillips Rnch','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.041268,-117.761339,0,'2013-07-06 12:44:34',NULL,NULL),(78531,'98131','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.468588,-122.291881,0,'2013-07-06 12:44:34',NULL,NULL),(75900,'94977','P','Larkspur','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.938018,-122.535263,0,'2013-07-06 12:44:34',NULL,NULL),(18801,'19399','P','Southeastern','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.986656,-75.510127,0,'2013-07-06 12:44:31',NULL,NULL),(29053,'32239','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.330986,-81.577906,0,'2013-07-06 12:44:32',NULL,NULL),(25094,'27957','S','Merry Hill','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.082996,-76.767953,0,'2013-07-06 12:44:31',NULL,NULL),(67914,'80905','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.836829,-104.837659,0,'2013-07-06 12:44:34',NULL,NULL),(76090,'95215','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.971031,-121.203236,0,'2013-07-06 12:44:34',NULL,NULL),(24951,'27831','S','Garysburg','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.474201,-77.596465,0,'2013-07-06 12:44:31',NULL,NULL),(40238,'45424','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.845640,-84.111720,0,'2013-07-06 12:44:32',NULL,NULL),(74286,'92363','S','Havasu Lake','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.833512,-114.602406,0,'2013-07-06 12:44:34',NULL,NULL),(15917,'17018','S','Singersville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.370886,-76.931434,0,'2013-07-06 12:44:31',NULL,NULL),(32702,'36278','S','Haywood','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.325381,-85.506798,0,'2013-07-06 12:44:32',NULL,NULL),(76701,'95830','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.492676,-121.272115,0,'2013-07-06 12:44:34',NULL,NULL),(76859,'95966','S','Oroville','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.484101,-121.486755,0,'2013-07-06 12:44:34',NULL,NULL),(46972,'54212','S','Fish Creek','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.105511,-87.217607,0,'2013-07-06 12:44:32',NULL,NULL),(66811,'79080','S','Skellytown','D','Carson','48065','Texas','TX','48','0000','806','Central',-6.0,'Y',35.574356,-101.172571,0,'2013-07-06 12:44:34',NULL,NULL),(78599,'98188','S','Seatac','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(20461,'21029','S','Clarksville','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.201943,-76.948075,0,'2013-07-06 12:44:31',NULL,NULL),(18612,'19146','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.936445,-75.183641,0,'2013-07-06 12:44:31',NULL,NULL),(40358,'45634','S','Dundas','N','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.160870,-82.524305,0,'2013-07-06 12:44:32',NULL,NULL),(34702,'38829','S','Osborne Creek','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(16936,'17699','U','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.041872,-76.300120,0,'2013-07-06 12:44:31',NULL,NULL),(26177,'28752','S','Marion','D','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.674582,-82.017112,0,'2013-07-06 12:44:31',NULL,NULL),(55111,'63333','S','Liege','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.001005,-91.334577,0,'2013-07-06 12:44:33',NULL,NULL),(59169,'70342','S','Berwick','D','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.694615,-91.225759,0,'2013-07-06 12:44:33',NULL,NULL),(70124,'84199','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725101,-111.939531,0,'2013-07-06 12:44:34',NULL,NULL),(7614,'07054','S','Parsippany Troy Hills','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.859388,-74.413425,0,'2013-07-06 12:44:30',NULL,NULL),(15228,'16027','P','Connoqunsg','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.814001,-80.014343,0,'2013-07-06 12:44:31',NULL,NULL),(35907,'40014','S','Orchard Grass','A','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.337990,-85.443424,0,'2013-07-06 12:44:32',NULL,NULL),(8256,'08008','S','Harvey Cedars Boro','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(25653,'28470','S','South Brunswick','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.959446,-78.395981,0,'2013-07-06 12:44:31',NULL,NULL),(62375,'74076','P','STW','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.123420,-97.031945,0,'2013-07-06 12:44:33',NULL,NULL),(79726,'99215','P','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.690874,-117.209831,0,'2013-07-06 12:44:34',NULL,NULL),(21868,'23155','P','Severn','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.294733,-76.416395,0,'2013-07-06 12:44:31',NULL,NULL),(17293,'17851','S','Connersville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(15201,'15957','S','Strongstown','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.559611,-78.917699,0,'2013-07-06 12:44:31',NULL,NULL),(2728,'00969','S','Urb Collegeville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(58238,'68352','S','Thompson','N','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.156080,-97.171800,0,'2013-07-06 12:44:33',NULL,NULL),(67984,'80917','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.887640,-104.738816,0,'2013-07-06 12:44:34',NULL,NULL),(16418,'17225','S','Milnor','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(45344,'50947','U','Communications Data Service','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582042,-93.629331,0,'2013-07-06 12:44:32',NULL,NULL),(33038,'36742','S','Gallion','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.541822,-87.706622,0,'2013-07-06 12:44:32',NULL,NULL),(59863,'71260','S','Marion','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.909183,-92.241002,0,'2013-07-06 12:44:33',NULL,NULL),(67401,'80127','S','Denver','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.593034,-105.138642,0,'2013-07-06 12:44:34',NULL,NULL),(11461,'12009','S','Altamont','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.697778,-74.025728,0,'2013-07-06 12:44:30',NULL,NULL),(9762,'10103','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(69272,'83438','P','Parker','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.960290,-111.763921,0,'2013-07-06 12:44:34',NULL,NULL),(72877,'90010','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.063478,-118.314966,0,'2013-07-06 12:44:34',NULL,NULL),(46066,'52577','S','Oskaloosa','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.286600,-92.600280,0,'2013-07-06 12:44:32',NULL,NULL),(41871,'47362','S','Cadiz','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(70120,'84190','U','Salt Lake County Complex','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725005,-111.886915,0,'2013-07-06 12:44:34',NULL,NULL),(25400,'28282','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.226719,-80.844957,0,'2013-07-06 12:44:31',NULL,NULL),(60060,'71351','S','Moncla','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.161480,-92.095020,0,'2013-07-06 12:44:33',NULL,NULL),(22064,'23336','S','Chincoteague Island','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.929948,-75.376428,0,'2013-07-06 12:44:31',NULL,NULL),(60938,'72088','S','Shirley','A','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.594100,-92.277720,0,'2013-07-06 12:44:33',NULL,NULL),(23882,'26164','S','Murraysville','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.952720,-81.756120,0,'2013-07-06 12:44:31',NULL,NULL),(7649,'07076','S','Scotch Plains','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.619819,-74.375205,0,'2013-07-06 12:44:30',NULL,NULL),(35389,'39456','S','Benndale','A','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.073880,-88.816080,0,'2013-07-06 12:44:32',NULL,NULL),(14020,'14538','P','Pultneyville','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.278042,-77.172200,0,'2013-07-06 12:44:31',NULL,NULL),(7570,'07027','S','Garwood','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.651917,-74.323185,0,'2013-07-06 12:44:30',NULL,NULL),(30578,'33415','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.663672,-80.126382,0,'2013-07-06 12:44:32',NULL,NULL),(26821,'29483','S','Carnes Crossroads','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.017824,-80.211350,0,'2013-07-06 12:44:31',NULL,NULL),(9853,'10119','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(66365,'78617','S','Del Valle','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.151020,-97.594440,0,'2013-07-06 12:44:34',NULL,NULL),(75618,'94503','S','American Canyon','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.116667,-122.233333,0,'2013-07-06 12:44:34',NULL,NULL),(77355,'96733','P','Kahului','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.894396,-156.466524,0,'2013-07-06 12:44:34',NULL,NULL),(3998,'02542','S','Buzzards Bay','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.658720,-70.567260,0,'2013-07-06 12:44:30',NULL,NULL),(48515,'55746','S','Hibbing','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(50810,'58458','S','Grand Rapids','A','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.397400,-98.283240,0,'2013-07-06 12:44:33',NULL,NULL),(65215,'77437','S','West Payne','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(11520,'12033','S','South Schodack','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535438,-73.709070,0,'2013-07-06 12:44:30',NULL,NULL),(39610,'44880','S','Sullivan','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.031976,-82.214181,0,'2013-07-06 12:44:32',NULL,NULL),(6431,'05743','S','West Haven','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(17231,'17835','P','Laurelton','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.951972,-77.192721,0,'2013-07-06 12:44:31',NULL,NULL),(68224,'81050','S','North La Junta','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(5124,'04402','P','Bangor','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.832972,-68.789265,0,'2013-07-06 12:44:30',NULL,NULL),(10306,'10532','S','Hawthorne','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.107363,-73.793734,0,'2013-07-06 12:44:30',NULL,NULL),(51564,'59751','S','Silver Star','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.695744,-112.271489,0,'2013-07-06 12:44:33',NULL,NULL),(55202,'63384','S','Wellsville','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.073540,-91.567092,0,'2013-07-06 12:44:33',NULL,NULL),(55438,'63670','S','Ste Genevieve','A','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(76234,'95386','S','Waterford','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.657157,-120.735523,0,'2013-07-06 12:44:34',NULL,NULL),(22557,'24141','S','Radford','D','Radford City','51750','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136700,-80.608200,0,'2013-07-06 12:44:31',NULL,NULL),(51183,'59018','P','Clyde Park','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.707497,-110.456916,0,'2013-07-06 12:44:33',NULL,NULL),(63573,'75773','S','Hainesville','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.646900,-95.516460,0,'2013-07-06 12:44:34',NULL,NULL),(68490,'81290','U','Federal Correctional Complex','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.388104,-105.118653,0,'2013-07-06 12:44:34',NULL,NULL),(72840,'89834','S','Tuscarora','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.114995,-116.642583,0,'2013-07-06 12:44:34',NULL,NULL),(74220,'92312','P','Barstow','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.976965,-117.060012,0,'2013-07-06 12:44:34',NULL,NULL),(23636,'25770','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.338984,-82.518431,0,'2013-07-06 12:44:31',NULL,NULL),(26930,'29587','P','Surfside Beach','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.617875,-78.987929,0,'2013-07-06 12:44:31',NULL,NULL),(65337,'77520','S','Beach City','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(18740,'19339','U','Concordville','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.899120,-75.504198,0,'2013-07-06 12:44:31',NULL,NULL),(1445,'00739','S','VISTA Monte','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(31980,'35217','S','Tarrant','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.608700,-86.752620,0,'2013-07-06 12:44:32',NULL,NULL),(53046,'61482','S','Table Grove','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.404264,-90.393296,0,'2013-07-06 12:44:33',NULL,NULL),(71860,'87711','S','Upper Anton Chico','N','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.084468,-105.060585,0,'2013-07-06 12:44:34',NULL,NULL),(70039,'84134','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.774204,-111.946340,0,'2013-07-06 12:44:34',NULL,NULL),(67941,'80911','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(63994,'76112','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.749775,-97.211509,0,'2013-07-06 12:44:34',NULL,NULL),(37401,'41773','S','Kodak','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.157727,-83.095710,0,'2013-07-06 12:44:32',NULL,NULL),(36286,'40351','S','Morehead','D','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.194098,-83.439956,0,'2013-07-06 12:44:32',NULL,NULL),(43100,'48216','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.329264,-83.080548,0,'2013-07-06 12:44:32',NULL,NULL),(10436,'10910','P','Arden','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.388790,-74.165439,0,'2013-07-06 12:44:30',NULL,NULL),(26100,'28718','S','Cedar Mountain','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.137445,-82.682532,0,'2013-07-06 12:44:31',NULL,NULL),(33608,'37643','S','Elizabethton','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.342259,-82.225665,0,'2013-07-06 12:44:32',NULL,NULL),(38573,'43783','S','Somerset','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.804837,-82.290922,0,'2013-07-06 12:44:32',NULL,NULL),(49506,'56667','S','Maple Ridge','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(20684,'21237','S','Rosedale','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.340320,-76.505100,0,'2013-07-06 12:44:31',NULL,NULL),(14031,'14546','S','Scottsville','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.029866,-77.765882,0,'2013-07-06 12:44:31',NULL,NULL),(72818,'89820','S','Battle Mountain','D','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.619494,-116.936088,0,'2013-07-06 12:44:34',NULL,NULL),(53718,'62241','S','Ellisgrove','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.004300,-89.898760,0,'2013-07-06 12:44:33',NULL,NULL),(48983,'56224','S','Clements','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.409578,-95.046022,0,'2013-07-06 12:44:33',NULL,NULL),(6571,'05853','S','Morgan Ctr','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.909167,-71.979444,0,'2013-07-06 12:44:30',NULL,NULL),(8246,'08005','S','Barnegat','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.758880,-74.283480,0,'2013-07-06 12:44:30',NULL,NULL),(46444,'53209','S','Brown Deer','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.125920,-87.946764,0,'2013-07-06 12:44:32',NULL,NULL),(64514,'76634','S','Womack','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(32193,'35543','S','Bear Creek','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.195102,-87.714476,0,'2013-07-06 12:44:32',NULL,NULL),(29278,'32462','S','Vernon','D','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.504954,-85.867382,0,'2013-07-06 12:44:32',NULL,NULL),(68067,'80935','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.833696,-104.818441,0,'2013-07-06 12:44:34',NULL,NULL),(47805,'55053','S','Nerstrand','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.346698,-93.090205,0,'2013-07-06 12:44:33',NULL,NULL),(16810,'17543','S','Speedwell','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(286,'00646','S','Paseo Las Olas','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(63178,'75410','S','Alba','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.792512,-95.634414,0,'2013-07-06 12:44:33',NULL,NULL),(59430,'70665','S','Sulphur','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.235020,-93.374336,0,'2013-07-06 12:44:33',NULL,NULL),(16785,'17534','P','Intercourse','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.055420,-76.123247,0,'2013-07-06 12:44:31',NULL,NULL),(58599,'68849','U','Univ Of Ne Kearney','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.702013,-99.099483,0,'2013-07-06 12:44:33',NULL,NULL),(53744,'62256','P','Maeystown','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.233238,-90.221839,0,'2013-07-06 12:44:33',NULL,NULL),(27268,'29938','P','Hilton Head Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.161530,-80.752119,0,'2013-07-06 12:44:31',NULL,NULL),(12231,'12815','S','Horicon','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.671550,-73.769240,0,'2013-07-06 12:44:30',NULL,NULL),(72136,'88310','S','Alamogordo','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.899416,-105.951065,0,'2013-07-06 12:44:34',NULL,NULL),(19674,'20330','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(13403,'13752','S','Delancey','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.164722,-74.910240,0,'2013-07-06 12:44:31',NULL,NULL),(78562,'98155','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(75693,'94563','S','Orinda','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.879005,-122.177633,0,'2013-07-06 12:44:34',NULL,NULL),(69035,'83220','S','Bern','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.328080,-111.387480,0,'2013-07-06 12:44:34',NULL,NULL),(61615,'72821','S','Wiederkehr Vg','A','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.439891,-93.763349,0,'2013-07-06 12:44:33',NULL,NULL),(28513,'31537','S','Homeland','A','Charlton','13049','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.840664,-82.010728,0,'2013-07-06 12:44:32',NULL,NULL),(39764,'45118','S','Marathon','A','Brown','39015','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.183132,-83.951736,0,'2013-07-06 12:44:32',NULL,NULL),(31794,'35036','P','Cardiff','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.633971,-86.917920,0,'2013-07-06 12:44:32',NULL,NULL),(30947,'33730','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.822536,-82.827888,0,'2013-07-06 12:44:32',NULL,NULL),(55670,'64037','S','Aullville','N','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.033181,-93.707924,0,'2013-07-06 12:44:33',NULL,NULL),(56720,'65686','S','Kimberling Cy','A','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.640893,-93.423901,0,'2013-07-06 12:44:33',NULL,NULL),(52507,'60803','S','Merrionett pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.667210,-87.740131,0,'2013-07-06 12:44:33',NULL,NULL),(35302,'39401','S','Rawls Springs','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(1618,'00769','S','VISTA del Sol','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(43936,'49282','S','Somerset Center','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.052162,-84.418064,0,'2013-07-06 12:44:32',NULL,NULL),(8146,'07844','P','Hope','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.911267,-74.966051,0,'2013-07-06 12:44:30',NULL,NULL),(47409,'54652','S','Readstown','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.454272,-90.762950,0,'2013-07-06 12:44:32',NULL,NULL),(74745,'93044','P','Naval Base Ventura County','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.154211,-119.187956,0,'2013-07-06 12:44:34',NULL,NULL),(29928,'33064','S','Lghthse Point','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.277900,-80.147820,0,'2013-07-06 12:44:32',NULL,NULL),(40019,'45247','S','Dent','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(17687,'18202','S','Hazleton','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(22104,'23420','S','Painter','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.575832,-75.794935,0,'2013-07-06 12:44:31',NULL,NULL),(65303,'77494','S','Katy','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.753968,-95.810176,0,'2013-07-06 12:44:34',NULL,NULL),(59823,'71234','S','Willhite','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.581980,-92.345100,0,'2013-07-06 12:44:33',NULL,NULL),(16612,'17331','S','Gitts Run','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(17864,'18436','S','Cobbs Lake Preserve','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(31042,'33812','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.962476,-82.008918,0,'2013-07-06 12:44:32',NULL,NULL),(10841,'11405','U','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699453,-73.788562,0,'2013-07-06 12:44:30',NULL,NULL),(24302,'27013','S','Cleveland','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.745026,-80.676769,0,'2013-07-06 12:44:31',NULL,NULL),(76435,'95603','S','Auburn','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.921820,-121.098120,0,'2013-07-06 12:44:34',NULL,NULL),(57541,'67023','S','Cambridge','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.181533,-96.717333,0,'2013-07-06 12:44:33',NULL,NULL),(52302,'60543','S','Oswego','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.666294,-88.319681,0,'2013-07-06 12:44:33',NULL,NULL),(33967,'38107','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.168302,-90.028300,0,'2013-07-06 12:44:32',NULL,NULL),(20625,'21214','S','Hamilton','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.354090,-76.560840,0,'2013-07-06 12:44:31',NULL,NULL),(47553,'54830','S','Webb Lake','A','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.998019,-92.252388,0,'2013-07-06 12:44:32',NULL,NULL),(40357,'45633','P','Hallsville','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.455574,-82.788111,0,'2013-07-06 12:44:32',NULL,NULL),(43897,'49241','S','Hanover','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.105922,-84.604392,0,'2013-07-06 12:44:32',NULL,NULL),(79101,'98446','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.149046,-122.377224,0,'2013-07-06 12:44:34',NULL,NULL),(52373,'60619','S','Grand Crossing','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.745767,-87.607643,0,'2013-07-06 12:44:33',NULL,NULL),(50560,'58210','S','Adams','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.412292,-98.121800,0,'2013-07-06 12:44:33',NULL,NULL),(10171,'10281','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(43081,'48202','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.371987,-83.076406,0,'2013-07-06 12:44:32',NULL,NULL),(7072,'06339','S','Ledyard','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.444713,-71.995991,0,'2013-07-06 12:44:30',NULL,NULL),(56336,'65109','S','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.555400,-92.280540,0,'2013-07-06 12:44:33',NULL,NULL),(21949,'23233','S','Ridge','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.622840,-77.613493,0,'2013-07-06 12:44:31',NULL,NULL),(77719,'97060','S','Wood Village','A','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.527631,-122.397778,0,'2013-07-06 12:44:34',NULL,NULL),(58114,'68123','S','Capehart','N','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.112120,-95.957400,0,'2013-07-06 12:44:33',NULL,NULL),(19249,'19936','P','Cheswold','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.215385,-75.587941,0,'2013-07-06 12:44:31',NULL,NULL),(6465,'05761','S','Pawlet','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(2278,'00926','S','Urb Tulipan','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(57818,'67521','S','Brownell','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.622656,-99.697491,0,'2013-07-06 12:44:33',NULL,NULL),(44152,'49525','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.012830,-85.601883,0,'2013-07-06 12:44:32',NULL,NULL),(20113,'20714','S','Holland Point','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.711654,-76.537211,0,'2013-07-06 12:44:31',NULL,NULL),(38758,'44040','S','Gates Mills','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.527765,-81.412458,0,'2013-07-06 12:44:32',NULL,NULL),(74737,'93042','U','Point Mugu NAWC','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.122182,-119.092865,0,'2013-07-06 12:44:34',NULL,NULL),(72095,'88210','S','Atoka','N','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.835208,-104.413737,0,'2013-07-06 12:44:34',NULL,NULL),(67329,'80038','P','Broomfield','D','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.919548,-105.085569,0,'2013-07-06 12:44:34',NULL,NULL),(64200,'76250','S','Lindsay','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.637342,-97.210865,0,'2013-07-06 12:44:34',NULL,NULL),(32466,'36033','S','Bolling','N','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.640900,-86.734286,0,'2013-07-06 12:44:32',NULL,NULL),(78276,'97862','S','Milton-Freewater','N','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.932608,-118.389207,0,'2013-07-06 12:44:34',NULL,NULL),(60527,'71671','S','McKinney','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.609178,-92.070158,0,'2013-07-06 12:44:33',NULL,NULL),(12714,'13152','S','Niles','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.884340,-76.351260,0,'2013-07-06 12:44:30',NULL,NULL),(33539,'37388','S','Dickel','A','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.371202,-86.213117,0,'2013-07-06 12:44:32',NULL,NULL),(26808,'29470','S','Ravenel','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.791062,-80.221919,0,'2013-07-06 12:44:31',NULL,NULL),(19538,'20192','U','Herndon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.946349,-77.363143,0,'2013-07-06 12:44:31',NULL,NULL),(21777,'23064','P','Grimstead','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.498933,-76.304462,0,'2013-07-06 12:44:31',NULL,NULL),(32862,'36513','P','Calvert','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',30.802230,-88.234419,0,'2013-07-06 12:44:32',NULL,NULL),(44670,'50115','S','Guthrie Ctr','A','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.677381,-94.500012,0,'2013-07-06 12:44:32',NULL,NULL),(33446,'37312','S','Cleveland','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.199530,-84.863073,0,'2013-07-06 12:44:32',NULL,NULL),(41011,'46372','P','Roselawn','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.142111,-87.310237,0,'2013-07-06 12:44:32',NULL,NULL),(33103,'36854','S','Lake Harding','A','Chambers','01017','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.810093,-85.181624,0,'2013-07-06 12:44:32',NULL,NULL),(15856,'16943','S','Hector','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843054,-77.545629,0,'2013-07-06 12:44:31',NULL,NULL),(21271,'22310','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.782980,-77.119980,0,'2013-07-06 12:44:31',NULL,NULL),(7724,'07201','S','Elizabeth','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.664256,-74.179890,0,'2013-07-06 12:44:30',NULL,NULL),(22713,'24351','S','Lambsburg','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.579012,-80.780164,0,'2013-07-06 12:44:31',NULL,NULL),(24435,'27204','P','Asheboro','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.668436,-79.808474,0,'2013-07-06 12:44:31',NULL,NULL),(55242,'63445','S','Medill','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.434444,-91.775833,0,'2013-07-06 12:44:33',NULL,NULL),(30119,'33161','S','North Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(42535,'47862','S','Montezuma','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.789289,-87.373004,0,'2013-07-06 12:44:32',NULL,NULL),(50988,'58647','S','Havelock','N','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.538980,-102.864983,0,'2013-07-06 12:44:33',NULL,NULL),(751,'00692','S','Ext La Inmaculada','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(69576,'83834','S','Harvard','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.943273,-116.583704,0,'2013-07-06 12:44:34',NULL,NULL),(64676,'76825','S','Katemcy','N','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.390710,-99.384310,0,'2013-07-06 12:44:34',NULL,NULL),(45509,'51364','S','Terril','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.299433,-94.969970,0,'2013-07-06 12:44:32',NULL,NULL),(27789,'30380','U','Atlanta Postal Credit Union','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.646308,-84.389514,0,'2013-07-06 12:44:31',NULL,NULL),(40797,'46173','S','Rushville','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.615609,-85.446541,0,'2013-07-06 12:44:32',NULL,NULL),(32067,'35282','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.495620,-86.794338,0,'2013-07-06 12:44:32',NULL,NULL),(29424,'32666','S','Melrose','D','Putnam','12107','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.746789,-82.010428,0,'2013-07-06 12:44:32',NULL,NULL),(53875,'62347','S','Adams','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.891780,-91.045020,0,'2013-07-06 12:44:33',NULL,NULL),(48804,'56016','S','Clarks Grove','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.762656,-93.317911,0,'2013-07-06 12:44:33',NULL,NULL),(28096,'30747','S','Summerville','D','Chattooga','13055','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.486025,-85.345875,0,'2013-07-06 12:44:31',NULL,NULL),(40822,'46208','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.820704,-86.169262,0,'2013-07-06 12:44:32',NULL,NULL),(4833,'04003','S','Bailey Island','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.682169,-70.153983,0,'2013-07-06 12:44:30',NULL,NULL),(13999,'14517','S','Nunda','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.587711,-77.911103,0,'2013-07-06 12:44:31',NULL,NULL),(13725,'14092','S','Stela Niagara','A','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.171111,-79.018833,0,'2013-07-06 12:44:31',NULL,NULL),(22494,'24069','S','Cascade','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.586350,-79.660137,0,'2013-07-06 12:44:31',NULL,NULL),(77077,'96129','S','Portola','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.818308,-120.376409,0,'2013-07-06 12:44:34',NULL,NULL),(71015,'85725','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.199047,-111.013265,0,'2013-07-06 12:44:34',NULL,NULL),(63150,'75379','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.991318,-96.803012,0,'2013-07-06 12:44:33',NULL,NULL),(4097,'02672','P','W Hyannisprt','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.633467,-70.326399,0,'2013-07-06 12:44:30',NULL,NULL),(22263,'23691','S','Naval Weapons Station','A','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.244023,-76.551905,0,'2013-07-06 12:44:31',NULL,NULL),(6420,'05740','P','East Middlebury','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.972989,-73.102731,0,'2013-07-06 12:44:30',NULL,NULL),(24611,'27330','S','White Hill','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(79582,'99026','S','Nine Mile Fls','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.784513,-117.599788,0,'2013-07-06 12:44:34',NULL,NULL),(51968,'60145','S','Herbert','N','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.111420,-88.800360,0,'2013-07-06 12:44:33',NULL,NULL),(39855,'45171','S','Sardinia','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.969796,-83.793965,0,'2013-07-06 12:44:32',NULL,NULL),(50607,'58255','S','Maida','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.943927,-98.395342,0,'2013-07-06 12:44:33',NULL,NULL),(69028,'83214','S','Robin','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.554001,-112.229068,0,'2013-07-06 12:44:34',NULL,NULL),(51963,'60140','S','Pingree Grove','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.116520,-88.502220,0,'2013-07-06 12:44:33',NULL,NULL),(36755,'41040','S','Pendletn Cnty','A','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(4198,'02827','S','Greene','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.697997,-71.733673,0,'2013-07-06 12:44:30',NULL,NULL),(33871,'38016','S','Cordova','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.179164,-89.762665,0,'2013-07-06 12:44:32',NULL,NULL),(11428,'11967','S','Shirley','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.795028,-72.869264,0,'2013-07-06 12:44:30',NULL,NULL),(64280,'76435','S','Carbon','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.094721,-98.965524,0,'2013-07-06 12:44:34',NULL,NULL),(53611,'62082','S','Roodhouse','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.479516,-90.373279,0,'2013-07-06 12:44:33',NULL,NULL),(33256,'37083','S','La Fayette','N','Macon','47111','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.524054,-86.024892,0,'2013-07-06 12:44:32',NULL,NULL),(42458,'47832','S','Bloomingdale','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.844258,-87.267425,0,'2013-07-06 12:44:32',NULL,NULL),(24323,'27021','S','King','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.287280,-80.356209,0,'2013-07-06 12:44:31',NULL,NULL),(70247,'84409','P','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.189279,-111.946572,0,'2013-07-06 12:44:34',NULL,NULL),(66414,'78633','S','Georgetown','D','Williamson','48491','Texas','TX','48','0000','830','Central',-6.0,'Y',30.753944,-97.655586,0,'2013-07-06 12:44:34',NULL,NULL),(48205,'55404','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.961027,-93.263429,0,'2013-07-06 12:44:33',NULL,NULL),(27157,'29831','S','Savannah River Plant','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.343729,-81.807960,0,'2013-07-06 12:44:31',NULL,NULL),(1993,'00909','S','Fernandez Juncos','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(44897,'50322','S','Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.629345,-93.732012,0,'2013-07-06 12:44:32',NULL,NULL),(33891,'38034','S','Friendship','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.909116,-89.195058,0,'2013-07-06 12:44:32',NULL,NULL),(16529,'17268','S','Roadside','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(12030,'12517','S','Copake Falls','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.139997,-73.500933,0,'2013-07-06 12:44:30',NULL,NULL),(40766,'46151','S','Lake Edgewood','N','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(1671,'00773','S','Villa Angelina','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(18314,'19020','S','Cornwells Hts','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.102797,-74.929344,0,'2013-07-06 12:44:31',NULL,NULL),(74730,'93040','P','Piru','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.422467,-118.784610,0,'2013-07-06 12:44:34',NULL,NULL),(62537,'74431','P','Dewar','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.447591,-95.964150,0,'2013-07-06 12:44:33',NULL,NULL),(53723,'62245','S','Germantown','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.561065,-89.582763,0,'2013-07-06 12:44:33',NULL,NULL),(2328,'00934','S','Urb Coqui Gdns','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413161,-66.131635,0,'2013-07-06 12:44:30',NULL,NULL),(20954,'21777','S','Pt of Rocks','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.279637,-77.532881,0,'2013-07-06 12:44:31',NULL,NULL),(40657,'46041','S','Frankfort','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.264620,-86.528460,0,'2013-07-06 12:44:32',NULL,NULL),(32290,'35673','S','Trinity','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.554774,-87.158240,0,'2013-07-06 12:44:32',NULL,NULL),(29586,'32825','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.522353,-81.227289,0,'2013-07-06 12:44:32',NULL,NULL),(72401,'89043','S','Rose Valley','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(50368,'57755','S','Ludlow','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.848971,-103.364264,0,'2013-07-06 12:44:33',NULL,NULL),(8780,'08551','S','Ringoes','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.441298,-74.836215,0,'2013-07-06 12:44:30',NULL,NULL),(61485,'72639','S','Cozahome','A','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.045000,-92.501389,0,'2013-07-06 12:44:33',NULL,NULL),(14715,'15274','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.440293,-79.954512,0,'2013-07-06 12:44:31',NULL,NULL),(4374,'03079','S','Salem','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.790395,-71.219808,0,'2013-07-06 12:44:30',NULL,NULL),(5665,'04961','S','New Portland','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(15550,'16624','P','Chest Springs','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.577027,-78.606818,0,'2013-07-06 12:44:31',NULL,NULL),(47031,'54402','P','Wausau','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.020657,-89.647204,0,'2013-07-06 12:44:32',NULL,NULL),(67866,'80829','S','Crystal Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855979,-104.906332,0,'2013-07-06 12:44:34',NULL,NULL),(65692,'78004','S','Bergheim','D','Kendall','48259','Texas','TX','48','0000','830','Central',-6.0,'Y',29.841567,-98.582498,0,'2013-07-06 12:44:34',NULL,NULL),(63030,'75203','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.743356,-96.806968,0,'2013-07-06 12:44:33',NULL,NULL),(19914,'20551','U','Federal Reserve Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893288,-77.043093,0,'2013-07-06 12:44:31',NULL,NULL),(33262,'37089','U','Ingram Entertainment Group','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.998042,-86.574564,0,'2013-07-06 12:44:32',NULL,NULL),(67655,'80477','P','Steamboat','N','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.477411,-106.845470,0,'2013-07-06 12:44:34',NULL,NULL),(53010,'61458','S','Maquon','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.794691,-90.166255,0,'2013-07-06 12:44:33',NULL,NULL),(52368,'60616','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.844775,-87.626719,0,'2013-07-06 12:44:33',NULL,NULL),(1645,'00771','S','Urb Park Hurst','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(1462,'00745','S','Rio Grande','D','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(68374,'81140','S','Richfield','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.308960,-106.035240,0,'2013-07-06 12:44:34',NULL,NULL),(65858,'78209','S','Alamo Heights','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.484722,-98.465556,0,'2013-07-06 12:44:34',NULL,NULL),(61878,'73130','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.467400,-97.336500,0,'2013-07-06 12:44:33',NULL,NULL),(54639,'62922','S','Egyptian Shores','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.618809,-88.837781,0,'2013-07-06 12:44:33',NULL,NULL),(7891,'07538','P','North Haledon','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.936601,-74.189611,0,'2013-07-06 12:44:30',NULL,NULL),(5996,'05355','S','South Wardsboro','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.029480,-72.811620,0,'2013-07-06 12:44:30',NULL,NULL),(4335,'03033','S','Brookline','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.739053,-71.677821,0,'2013-07-06 12:44:30',NULL,NULL),(33164,'37022','S','Bethpage','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.514694,-86.324530,0,'2013-07-06 12:44:32',NULL,NULL),(11928,'12424','S','Tannersville','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.235000,-74.145833,0,'2013-07-06 12:44:30',NULL,NULL),(19635,'20260','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880340,-77.015833,0,'2013-07-06 12:44:31',NULL,NULL),(42399,'47736','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.953320,-87.561824,0,'2013-07-06 12:44:32',NULL,NULL),(75929,'95018','S','Felton','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.063973,-122.063202,0,'2013-07-06 12:44:34',NULL,NULL),(66189,'78539','S','Faysville','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(62060,'73541','S','Fletcher','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.822949,-98.234952,0,'2013-07-06 12:44:33',NULL,NULL),(49812,'57201','S','Watertown','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(37325,'41653','S','Endicott','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(60088,'71357','S','Westwood','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(34649,'38772','P','Scott','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.598674,-91.080131,0,'2013-07-06 12:44:32',NULL,NULL),(48052,'55317','S','Chanhassen','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.855238,-93.551193,0,'2013-07-06 12:44:33',NULL,NULL),(42175,'47529','S','Elmore','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.875867,-87.084533,0,'2013-07-06 12:44:32',NULL,NULL),(43635,'48829','S','Edmore','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.398784,-85.028071,0,'2013-07-06 12:44:32',NULL,NULL),(34193,'38332','S','Enville','D','Chester','47023','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.472931,-88.417941,0,'2013-07-06 12:44:32',NULL,NULL),(47627,'54911','S','Little Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.275220,-88.395755,0,'2013-07-06 12:44:33',NULL,NULL),(3368,'01583','S','West Boylston','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.360502,-71.787608,0,'2013-07-06 12:44:30',NULL,NULL),(80199,'99926','P','Metlakatla','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.130608,-131.490702,0,'2013-07-06 12:44:34',NULL,NULL),(57415,'66773','S','Carona','A','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.267281,-94.853706,0,'2013-07-06 12:44:33',NULL,NULL),(49594,'56750','S','Rl Falls','A','Red Lake','27125','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.882061,-96.271559,0,'2013-07-06 12:44:33',NULL,NULL),(41417,'46819','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.996887,-85.132630,0,'2013-07-06 12:44:32',NULL,NULL),(40445,'45729','S','Fleming','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.402882,-81.652843,0,'2013-07-06 12:44:32',NULL,NULL),(47734,'55011','S','Cedar East Bethel','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.348975,-93.246677,0,'2013-07-06 12:44:33',NULL,NULL),(54415,'62831','S','Dubois','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.256590,-89.203710,0,'2013-07-06 12:44:33',NULL,NULL),(68354,'81133','S','Forbes Park','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.413562,-105.393706,0,'2013-07-06 12:44:34',NULL,NULL),(64480,'76597','U','Alfred P Hughes Unit','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.434052,-97.746657,0,'2013-07-06 12:44:34',NULL,NULL),(39392,'44656','S','Zoarville','A','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.609320,-81.358200,0,'2013-07-06 12:44:32',NULL,NULL),(27496,'30170','S','Ephesus','N','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.418873,-85.174117,0,'2013-07-06 12:44:31',NULL,NULL),(63389,'75644','S','Seven Pines','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(68138,'80970','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848525,-104.717700,0,'2013-07-06 12:44:34',NULL,NULL),(65289,'77487','P','Sugar Land','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.618596,-95.636871,0,'2013-07-06 12:44:34',NULL,NULL),(54547,'62887','S','Bungay','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.164229,-88.374663,0,'2013-07-06 12:44:33',NULL,NULL),(19855,'20515','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891068,-77.011322,0,'2013-07-06 12:44:31',NULL,NULL),(42846,'48074','S','Kimball Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.944217,-82.559913,0,'2013-07-06 12:44:32',NULL,NULL),(15722,'16873','P','Shawville','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.068825,-78.356857,0,'2013-07-06 12:44:31',NULL,NULL),(54079,'62517','S','Bulpitt','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.595675,-89.426448,0,'2013-07-06 12:44:33',NULL,NULL),(45906,'52317','S','North Liberty','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.743269,-91.600530,0,'2013-07-06 12:44:32',NULL,NULL),(16242,'17081','P','Wolfs X Rds','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204234,-77.290805,0,'2013-07-06 12:44:31',NULL,NULL),(12519,'13031','S','Camillus','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.044375,-76.289134,0,'2013-07-06 12:44:30',NULL,NULL),(41375,'46795','S','Wolcottville','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(8088,'07760','S','Locust','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.368572,-74.000172,0,'2013-07-06 12:44:30',NULL,NULL),(4621,'03601','S','Acworth','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.242247,-72.386160,0,'2013-07-06 12:44:30',NULL,NULL),(46807,'54004','S','Clayton','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.330762,-92.170455,0,'2013-07-06 12:44:32',NULL,NULL),(20584,'21158','S','Westminster','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.640380,-77.029680,0,'2013-07-06 12:44:31',NULL,NULL),(39897,'45215','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(52658,'61067','S','Ridott','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.304197,-89.487101,0,'2013-07-06 12:44:33',NULL,NULL),(25066,'27936','P','Frisco','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.238474,-75.618039,0,'2013-07-06 12:44:31',NULL,NULL),(62800,'74932','S','Cameron','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.150200,-94.494784,0,'2013-07-06 12:44:33',NULL,NULL),(33390,'37219','S','Nashvle','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.167252,-86.786435,0,'2013-07-06 12:44:32',NULL,NULL),(33633,'37682','P','Milligan College','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.302307,-82.296008,0,'2013-07-06 12:44:32',NULL,NULL),(13465,'13783','S','Kelsey','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(38416,'43543','S','Holiday City','A','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.590070,-84.611596,0,'2013-07-06 12:44:32',NULL,NULL),(24195,'26671','S','Gilboa','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.295354,-80.963835,0,'2013-07-06 12:44:31',NULL,NULL),(3604,'02044','U','Shared Firm Zip Code','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.242484,-70.892883,0,'2013-07-06 12:44:30',NULL,NULL),(18875,'19454','S','North Wales','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.215532,-75.258606,0,'2013-07-06 12:44:31',NULL,NULL),(48032,'55304','S','Anoka','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.254700,-93.240480,0,'2013-07-06 12:44:33',NULL,NULL),(48274,'55430','S','Brooklyn Ctr','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.056240,-93.301390,0,'2013-07-06 12:44:33',NULL,NULL),(53090,'61529','S','Cramers','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.778521,-89.950179,0,'2013-07-06 12:44:33',NULL,NULL),(54407,'62827','S','Phillipstown','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.169678,-88.066046,0,'2013-07-06 12:44:33',NULL,NULL),(60559,'71747','S','Huttig','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.057457,-92.182408,0,'2013-07-06 12:44:33',NULL,NULL),(71847,'87583','P','Villanueva','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.232598,-105.520380,0,'2013-07-06 12:44:34',NULL,NULL),(79965,'99639','S','Ninilchik','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.989648,-151.697929,0,'2013-07-06 12:44:34',NULL,NULL),(79790,'99350','S','North Prosser','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.203527,-119.766249,0,'2013-07-06 12:44:34',NULL,NULL),(46759,'53936','S','Grand Marsh','D','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.855188,-89.732392,0,'2013-07-06 12:44:32',NULL,NULL),(77837,'97220','S','Maywood Park','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.543396,-122.553975,0,'2013-07-06 12:44:34',NULL,NULL),(71234,'86335','S','Rimrock','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.642522,-111.781844,0,'2013-07-06 12:44:34',NULL,NULL),(74079,'92178','P','San Diego','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.681525,-117.175900,0,'2013-07-06 12:44:34',NULL,NULL),(56515,'65351','S','Dunksburg','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964117,-93.418774,0,'2013-07-06 12:44:33',NULL,NULL),(48421,'55604','S','Grand Marais','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.800000,-90.300000,0,'2013-07-06 12:44:33',NULL,NULL),(45369,'51010','S','Castana','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.071125,-95.911358,0,'2013-07-06 12:44:32',NULL,NULL),(22053,'23321','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.797907,-76.425462,0,'2013-07-06 12:44:31',NULL,NULL),(47565,'54839','S','Grand View','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.347438,-91.104130,0,'2013-07-06 12:44:33',NULL,NULL),(27909,'30501','S','Gainesville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.286057,-83.820309,0,'2013-07-06 12:44:31',NULL,NULL),(28059,'30673','S','Washington','D','Wilkes','13317','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.735939,-82.742819,0,'2013-07-06 12:44:31',NULL,NULL),(32192,'35542','S','Bankston','D','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.705822,-87.688940,0,'2013-07-06 12:44:32',NULL,NULL),(54073,'62512','S','Beason','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.141151,-89.200183,0,'2013-07-06 12:44:33',NULL,NULL),(68701,'82058','S','Rock River','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.196069,-105.678821,0,'2013-07-06 12:44:34',NULL,NULL),(68735,'82201','S','Uva','A','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031976,-104.976675,0,'2013-07-06 12:44:34',NULL,NULL),(64868,'77060','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.926865,-95.395351,0,'2013-07-06 12:44:34',NULL,NULL),(51221,'59054','P','Melstone','D','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.600643,-107.866709,0,'2013-07-06 12:44:33',NULL,NULL),(9191,'09387','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(29262,'32456','S','Mexico Beach','A','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.819214,-85.299275,0,'2013-07-06 12:44:32',NULL,NULL),(19578,'20216','U','Labor Management Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891861,-77.012777,0,'2013-07-06 12:44:31',NULL,NULL),(38348,'43441','P','Lemoyne','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.498038,-83.471932,0,'2013-07-06 12:44:32',NULL,NULL),(36972,'41179','S','Glen Springs','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(47824,'55063','S','West Rock','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.910278,-92.955000,0,'2013-07-06 12:44:33',NULL,NULL),(40550,'45853','P','Kalida','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.982658,-84.200776,0,'2013-07-06 12:44:32',NULL,NULL),(18455,'19078','S','Ridley Park','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.877221,-75.322215,0,'2013-07-06 12:44:31',NULL,NULL),(12368,'12911','S','Ausable Chasm','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.533729,-73.500290,0,'2013-07-06 12:44:30',NULL,NULL),(27420,'30101','S','Oak Grove','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.035593,-84.708375,0,'2013-07-06 12:44:31',NULL,NULL),(17584,'18017','S','Freemansburg','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.653231,-75.336849,0,'2013-07-06 12:44:31',NULL,NULL),(50220,'57580','S','Wewela','A','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(55085,'63199','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.645844,-90.331287,0,'2013-07-06 12:44:33',NULL,NULL),(78783,'98312','S','Marine Drive','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(67749,'80614','P','Eastlake','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.933629,-104.958201,0,'2013-07-06 12:44:34',NULL,NULL),(64295,'76453','S','Gordon','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.575298,-98.352459,0,'2013-07-06 12:44:34',NULL,NULL),(21303,'22404','P','Fred','N','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.297717,-77.456462,0,'2013-07-06 12:44:31',NULL,NULL),(35813,'39759','S','Rocky Hill','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(21827,'23113','S','Sycamore Square','N','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.535176,-77.670301,0,'2013-07-06 12:44:31',NULL,NULL),(52521,'60912','S','Beaverville','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.947997,-87.671577,0,'2013-07-06 12:44:33',NULL,NULL),(59475,'70752','S','Lakeland','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.571113,-91.428625,0,'2013-07-06 12:44:33',NULL,NULL),(10783,'11367','S','Kew Gardens Hills','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728160,-73.818582,0,'2013-07-06 12:44:30',NULL,NULL),(59309,'70516','S','Branch','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.334327,-92.340085,0,'2013-07-06 12:44:33',NULL,NULL),(42670,'47963','S','Morocco','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.944059,-87.450207,0,'2013-07-06 12:44:32',NULL,NULL),(8244,'08004','S','Waterford Township','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.776340,-74.870640,0,'2013-07-06 12:44:30',NULL,NULL),(27802,'30394','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.752800,-84.392638,0,'2013-07-06 12:44:31',NULL,NULL),(39638,'44903','S','Ontario','A','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.760320,-82.520048,0,'2013-07-06 12:44:32',NULL,NULL),(37108,'41365','S','Rogers','D','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.708373,-83.629588,0,'2013-07-06 12:44:32',NULL,NULL),(75918,'95008','S','Campbell','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.278271,-121.955198,0,'2013-07-06 12:44:34',NULL,NULL),(66491,'78672','S','Tow','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.871549,-98.514047,0,'2013-07-06 12:44:34',NULL,NULL),(58523,'68785','S','Waterbury','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.459205,-96.743675,0,'2013-07-06 12:44:33',NULL,NULL),(17616,'18045','S','Palmer','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(39693,'45034','S','Kings Mills','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.355219,-84.244219,0,'2013-07-06 12:44:32',NULL,NULL),(56459,'65285','S','Thompson','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.201379,-92.039616,0,'2013-07-06 12:44:33',NULL,NULL),(45206,'50628','S','Lourdes','N','Howard','19089','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.245347,-92.439097,0,'2013-07-06 12:44:32',NULL,NULL),(35356,'39440','S','Myrick','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(53934,'62411','S','Altamont','D','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.084206,-88.746416,0,'2013-07-06 12:44:33',NULL,NULL),(54464,'62856','P','Hanaford','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.954367,-88.836731,0,'2013-07-06 12:44:33',NULL,NULL),(77458,'96813','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.314718,-157.853702,0,'2013-07-06 12:44:34',NULL,NULL),(67982,'80916','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.803293,-104.707538,0,'2013-07-06 12:44:34',NULL,NULL),(62904,'75069','S','Mc Kinney','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.179280,-96.601020,0,'2013-07-06 12:44:33',NULL,NULL),(48978,'56219','S','Browns Valley','D','Traverse','27155','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.649970,-96.722741,0,'2013-07-06 12:44:33',NULL,NULL),(8270,'08009','S','East Berlin','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.759420,-74.927340,0,'2013-07-06 12:44:30',NULL,NULL),(43547,'48705','S','Barton City','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.678735,-83.632265,0,'2013-07-06 12:44:32',NULL,NULL),(8859,'08648','S','Trenton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.265940,-74.695860,0,'2013-07-06 12:44:30',NULL,NULL),(30235,'33190','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556771,-80.336864,0,'2013-07-06 12:44:32',NULL,NULL),(13119,'13489','S','West Leyden','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.473901,-75.532770,0,'2013-07-06 12:44:30',NULL,NULL),(4841,'04009','S','Bridgton','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',44.056766,-70.719822,0,'2013-07-06 12:44:30',NULL,NULL),(46845,'54020','S','East Farmington','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.320122,-92.699523,0,'2013-07-06 12:44:32',NULL,NULL),(80108,'99757','P','Lake Minchumina','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.804795,-152.415256,0,'2013-07-06 12:44:34',NULL,NULL),(73076,'90202','P','Bell','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.969924,-118.152353,0,'2013-07-06 12:44:34',NULL,NULL),(49501,'56663','S','Pennington','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.455328,-94.478035,0,'2013-07-06 12:44:33',NULL,NULL),(7236,'06509','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.319000,-72.927115,0,'2013-07-06 12:44:30',NULL,NULL),(329,'00650','S','Urb Las Flores','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(15695,'16845','S','Karthaus','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.137729,-78.016718,0,'2013-07-06 12:44:31',NULL,NULL),(42747,'48025','S','Beverly Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.523195,-83.265758,0,'2013-07-06 12:44:32',NULL,NULL),(10288,'10520','S','Croton','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.216760,-73.896720,0,'2013-07-06 12:44:30',NULL,NULL),(72976,'90048','S','W Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.073253,-118.377034,0,'2013-07-06 12:44:34',NULL,NULL),(62364,'74068','P','Shamrock','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.909019,-96.575047,0,'2013-07-06 12:44:33',NULL,NULL),(61632,'72838','S','Gravelly','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.890905,-93.674751,0,'2013-07-06 12:44:33',NULL,NULL),(46835,'54016','S','Hudson','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.981880,-92.690820,0,'2013-07-06 12:44:32',NULL,NULL),(18652,'19172','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.945336,-75.151079,0,'2013-07-06 12:44:31',NULL,NULL),(78543,'98141','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.614953,-122.345794,0,'2013-07-06 12:44:34',NULL,NULL),(73912,'92019','S','El Cajon','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.782189,-116.908056,0,'2013-07-06 12:44:34',NULL,NULL),(67721,'80539','P','Loveland','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.396427,-105.074380,0,'2013-07-06 12:44:34',NULL,NULL),(64526,'76641','S','Frost','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.029561,-96.778412,0,'2013-07-06 12:44:34',NULL,NULL),(13037,'13437','S','Redfield','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.595477,-75.813913,0,'2013-07-06 12:44:30',NULL,NULL),(9580,'10027','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(72725,'89503','S','Lawton','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.538980,-119.838457,0,'2013-07-06 12:44:34',NULL,NULL),(51890,'60096','S','Winthrop Harbor','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.478195,-87.831505,0,'2013-07-06 12:44:33',NULL,NULL),(24822,'27606','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.754707,-78.722559,0,'2013-07-06 12:44:31',NULL,NULL),(9346,'09801','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7495,'06913','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.050068,-73.538971,0,'2013-07-06 12:44:30',NULL,NULL),(71998,'88036','P','Fort Bayard','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.768885,-108.143971,0,'2013-07-06 12:44:34',NULL,NULL),(44924,'50335','U','Midamerican Energy','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595639,-93.621050,0,'2013-07-06 12:44:32',NULL,NULL),(58522,'68784','S','Wakefield','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.268578,-96.866526,0,'2013-07-06 12:44:33',NULL,NULL),(36418,'40544','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.042496,-84.541577,0,'2013-07-06 12:44:32',NULL,NULL),(44933,'50360','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.594905,-93.764562,0,'2013-07-06 12:44:32',NULL,NULL),(10301,'10527','S','Granite Spgs','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.317032,-73.764490,0,'2013-07-06 12:44:30',NULL,NULL),(77749,'97101','S','Amity','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.098528,-123.207387,0,'2013-07-06 12:44:34',NULL,NULL),(7049,'06279','S','Willington','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.895780,-72.264300,0,'2013-07-06 12:44:30',NULL,NULL),(5466,'04737','P','Clayton Lake','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.619729,-69.520207,0,'2013-07-06 12:44:30',NULL,NULL),(15838,'16936','S','Daggett','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.931667,-76.936111,0,'2013-07-06 12:44:31',NULL,NULL),(27652,'30321','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.756316,-84.389551,0,'2013-07-06 12:44:31',NULL,NULL),(20673,'21230','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.270522,-76.626796,0,'2013-07-06 12:44:31',NULL,NULL),(46860,'54024','S','Wolfcreek','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.412894,-92.633615,0,'2013-07-06 12:44:32',NULL,NULL),(4693,'03812','S','Bartlett','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.088653,-71.280179,0,'2013-07-06 12:44:30',NULL,NULL),(42158,'47522','S','Crane Naval Depot','A','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(7330,'06705','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.549583,-72.995890,0,'2013-07-06 12:44:30',NULL,NULL),(79367,'98650','S','Troutlake','N','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.986684,-121.511092,0,'2013-07-06 12:44:34',NULL,NULL),(58381,'68544','U','Nebraska Book Co','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(71593,'87319','P','Defiance','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.493375,-108.855190,0,'2013-07-06 12:44:34',NULL,NULL),(67961,'80913','S','Ft Carson','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(26876,'29550','S','Hartsville','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.368444,-80.081896,0,'2013-07-06 12:44:31',NULL,NULL),(24838,'27614','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.938157,-78.631847,0,'2013-07-06 12:44:31',NULL,NULL),(69935,'84114','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775628,-111.891834,0,'2013-07-06 12:44:34',NULL,NULL),(66159,'78505','P','McColl','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.200156,-98.232966,0,'2013-07-06 12:44:34',NULL,NULL),(60133,'71373','S','Deer Park','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(50442,'58008','S','Barney','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.265510,-96.999489,0,'2013-07-06 12:44:33',NULL,NULL),(5755,'05039','S','Corinth Corners','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(17369,'17877','P','Snydertown','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.876221,-76.666737,0,'2013-07-06 12:44:31',NULL,NULL),(50600,'58249','S','Langdon','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.763045,-98.375077,0,'2013-07-06 12:44:33',NULL,NULL),(3279,'01474','S','Townsend','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.671160,-71.713080,0,'2013-07-06 12:44:30',NULL,NULL),(42824,'48062','S','Richmond Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.843791,-82.798308,0,'2013-07-06 12:44:32',NULL,NULL),(1596,'00769','S','Paseo Real','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(18439,'19066','S','Merion Park','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002386,-75.253465,0,'2013-07-06 12:44:31',NULL,NULL),(2805,'00976','S','Urb Rincon Espanol','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(14302,'14882','S','Ithaca','A','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.563160,-76.554840,0,'2013-07-06 12:44:31',NULL,NULL),(56669,'65627','S','Cedarcreek','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.560928,-93.017530,0,'2013-07-06 12:44:33',NULL,NULL),(11484,'12020','S','East Line','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(64251,'76370','P','Megargel','D','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.357592,-98.760534,0,'2013-07-06 12:44:34',NULL,NULL),(31664,'34749','P','Leesburg','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.807861,-81.875946,0,'2013-07-06 12:44:32',NULL,NULL),(24997,'27868','P','Red Oak','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',36.038485,-77.908840,0,'2013-07-06 12:44:31',NULL,NULL),(76302,'95441','S','Geyserville','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.705500,-122.885073,0,'2013-07-06 12:44:34',NULL,NULL),(66519,'78712','S','University of Texas','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.285130,-97.737776,0,'2013-07-06 12:44:34',NULL,NULL),(59264,'70450','S','Mount Hermon','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.953068,-90.275705,0,'2013-07-06 12:44:33',NULL,NULL),(41589,'47043','S','Vevay','D','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750187,-85.066805,0,'2013-07-06 12:44:32',NULL,NULL),(37927,'42634','S','Parkers Lake','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.845915,-84.451334,0,'2013-07-06 12:44:32',NULL,NULL),(15571,'16650','S','Hopewell','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.111339,-78.301938,0,'2013-07-06 12:44:31',NULL,NULL),(20783,'21538','S','Shallmar','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.379444,-79.205000,0,'2013-07-06 12:44:31',NULL,NULL),(6218,'05488','S','Maquam','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(46307,'53062','U','Salvtrian Ctr','N','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.947498,-88.101978,0,'2013-07-06 12:44:32',NULL,NULL),(8554,'08204','S','West Cape May','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(78481,'98102','S','Broadway','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.632744,-122.321885,0,'2013-07-06 12:44:34',NULL,NULL),(76195,'95350','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.664246,-120.992352,0,'2013-07-06 12:44:34',NULL,NULL),(70319,'84623','S','Chester','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.475304,-111.561202,0,'2013-07-06 12:44:34',NULL,NULL),(62790,'74881','S','Warwick','A','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.691700,-97.065941,0,'2013-07-06 12:44:33',NULL,NULL),(10968,'11520','S','Freeport','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.652023,-73.588242,0,'2013-07-06 12:44:30',NULL,NULL),(6298,'05653','S','Eden Mills','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.707222,-72.546111,0,'2013-07-06 12:44:30',NULL,NULL),(15842,'16937','S','Mills','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.904583,-77.756618,0,'2013-07-06 12:44:31',NULL,NULL),(29032,'32231','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.289991,-81.633454,0,'2013-07-06 12:44:32',NULL,NULL),(42050,'47446','S','River Vale','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(40210,'45401','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.774630,-84.198398,0,'2013-07-06 12:44:32',NULL,NULL),(14810,'15415','P','Brier Hill','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.977744,-79.828860,0,'2013-07-06 12:44:31',NULL,NULL),(41431,'46854','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.148996,-85.073748,0,'2013-07-06 12:44:32',NULL,NULL),(2663,'00966','S','Urb Novas CT','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(28156,'30901','S','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.460973,-81.974866,0,'2013-07-06 12:44:31',NULL,NULL),(30012,'33129','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.755934,-80.204659,0,'2013-07-06 12:44:32',NULL,NULL),(30818,'33619','S','Clair Mel','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.933359,-82.378210,0,'2013-07-06 12:44:32',NULL,NULL),(24593,'27325','S','Robbins','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.429683,-79.581817,0,'2013-07-06 12:44:31',NULL,NULL),(18154,'18847','S','Susquehanna','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.944417,-75.603491,0,'2013-07-06 12:44:31',NULL,NULL),(9263,'09604','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(2307,'00927','S','Urb Santa Ana','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(26131,'28734','S','Franklin','D','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(6898,'06147','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791110,-72.668684,0,'2013-07-06 12:44:30',NULL,NULL),(38426,'43551','S','Perrysburg','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.542639,-83.597702,0,'2013-07-06 12:44:32',NULL,NULL),(31558,'34609','S','Brooksville','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.479491,-82.499987,0,'2013-07-06 12:44:32',NULL,NULL),(78284,'97870','S','Richland','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.766508,-117.168196,0,'2013-07-06 12:44:34',NULL,NULL),(63580,'75779','P','Neches','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.866880,-95.495787,0,'2013-07-06 12:44:34',NULL,NULL),(72774,'89557','U','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.539719,-119.818005,0,'2013-07-06 12:44:34',NULL,NULL),(71994,'88032','P','Dona Ana','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.388663,-106.782440,0,'2013-07-06 12:44:34',NULL,NULL),(3503,'01862','S','N Billerica','A','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.567360,-71.291220,0,'2013-07-06 12:44:30',NULL,NULL),(8742,'08525','S','Hopewell','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.386966,-74.765926,0,'2013-07-06 12:44:30',NULL,NULL),(39309,'44513','P','Boardman','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.024672,-80.675960,0,'2013-07-06 12:44:32',NULL,NULL),(13496,'13803','S','Messengerville','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(73288,'90748','P','Wilmington','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.784149,-118.263982,0,'2013-07-06 12:44:34',NULL,NULL),(65339,'77520','S','Cove','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(3652,'02119','S','Roxbury','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.288240,-71.047440,0,'2013-07-06 12:44:30',NULL,NULL),(79419,'98824','P','George','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.079715,-119.854072,0,'2013-07-06 12:44:34',NULL,NULL),(53049,'61483','S','Saxton','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.092649,-89.863127,0,'2013-07-06 12:44:33',NULL,NULL),(40037,'45251','S','Colerain TWP','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.255230,-84.589734,0,'2013-07-06 12:44:32',NULL,NULL),(23280,'25160','S','Amelia','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.284577,-81.285850,0,'2013-07-06 12:44:31',NULL,NULL),(5257,'04485','P','Shirley Mills','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.503846,-69.469162,0,'2013-07-06 12:44:30',NULL,NULL),(42873,'48083','S','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.559552,-83.123208,0,'2013-07-06 12:44:32',NULL,NULL),(71650,'87499','P','Farmington','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.729928,-108.152321,0,'2013-07-06 12:44:34',NULL,NULL),(67297,'80015','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.624696,-104.788800,0,'2013-07-06 12:44:34',NULL,NULL),(9943,'10155','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(40963,'46319','S','New Elliott','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.532140,-87.421913,0,'2013-07-06 12:44:32',NULL,NULL),(19618,'20240','U','Dept Interior','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894680,-77.041752,0,'2013-07-06 12:44:31',NULL,NULL),(40907,'46259','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.656811,-85.996975,0,'2013-07-06 12:44:32',NULL,NULL),(38887,'44110','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.565195,-81.567100,0,'2013-07-06 12:44:32',NULL,NULL),(72689,'89445','S','Weso','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(77616,'96951','P','Rota','D','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',14.147930,145.245515,0,'2013-07-06 12:44:34',NULL,NULL),(63699,'75882','U','Palestine','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.757811,-95.644004,0,'2013-07-06 12:44:34',NULL,NULL),(40969,'46323','S','Hammond','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.584786,-87.451351,0,'2013-07-06 12:44:32',NULL,NULL),(950,'00716','S','Jard Fagot','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(13015,'13421','S','Merrillsville','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.064220,-75.648180,0,'2013-07-06 12:44:30',NULL,NULL),(18508,'19102','S','Middle City East','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952547,-75.163950,0,'2013-07-06 12:44:31',NULL,NULL),(30020,'33134','S','Coconut Grove','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753678,-80.272023,0,'2013-07-06 12:44:32',NULL,NULL),(55092,'63301','S','Saint Charles','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(67093,'79702','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.974932,-102.078660,0,'2013-07-06 12:44:34',NULL,NULL),(48871,'56085','S','Cobden','A','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.296100,-94.723907,0,'2013-07-06 12:44:33',NULL,NULL),(28686,'31803','S','Buena Vista','D','Marion','13197','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.312777,-84.511370,0,'2013-07-06 12:44:32',NULL,NULL),(15074,'15744','S','Hamilton','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.920264,-79.095187,0,'2013-07-06 12:44:31',NULL,NULL),(43605,'48768','S','Tuscola','A','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.368767,-83.574866,0,'2013-07-06 12:44:32',NULL,NULL),(43450,'48529','S','Burton','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.974171,-83.664604,0,'2013-07-06 12:44:32',NULL,NULL),(42128,'47501','S','South Washington','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(23923,'26229','P','Lorentz','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.009338,-80.301560,0,'2013-07-06 12:44:31',NULL,NULL),(13190,'13619','S','Herrings','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(35607,'39601','S','Fair River','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(31949,'35209','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.460200,-86.809200,0,'2013-07-06 12:44:32',NULL,NULL),(19978,'20598','U','Chantilly','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(22382,'23936','S','Sprouses Corner','A','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.520399,-78.476570,0,'2013-07-06 12:44:31',NULL,NULL),(26255,'29006','S','Batesburg','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(57389,'66755','S','Moran','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.943643,-95.150312,0,'2013-07-06 12:44:33',NULL,NULL),(70127,'84201','U','Internal Revenue Service','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.244252,-112.000722,0,'2013-07-06 12:44:34',NULL,NULL),(63003,'75156','S','Mabank','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295960,-96.118738,0,'2013-07-06 12:44:33',NULL,NULL),(17499,'17961','S','Molino','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(36182,'40252','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.261193,-85.604564,0,'2013-07-06 12:44:32',NULL,NULL),(32646,'36251','S','Ashland','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(31175,'33919','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.561274,-81.905205,0,'2013-07-06 12:44:32',NULL,NULL),(48010,'55170','U','First Bank St Paul','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944443,-93.092404,0,'2013-07-06 12:44:33',NULL,NULL),(51429,'59457','S','Heath','N','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.049780,-109.425300,0,'2013-07-06 12:44:33',NULL,NULL),(65183,'77418','S','Cochran','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(73062,'90094','S','Playa Vista','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.974553,-118.425643,0,'2013-07-06 12:44:34',NULL,NULL),(73569,'91372','P','Calabasas','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.154498,-118.643170,0,'2013-07-06 12:44:34',NULL,NULL),(77762,'97113','S','Cornelius','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.522520,-123.050458,0,'2013-07-06 12:44:34',NULL,NULL),(68177,'81012','U','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.272962,-104.609114,0,'2013-07-06 12:44:34',NULL,NULL),(65906,'78236','S','Kelly USA','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(56252,'65058','S','Meta','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.270435,-92.133364,0,'2013-07-06 12:44:33',NULL,NULL),(6471,'05763','S','Pittsford','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.767228,-72.969037,0,'2013-07-06 12:44:30',NULL,NULL),(19539,'20192','U','Hundon','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.946349,-77.363143,0,'2013-07-06 12:44:31',NULL,NULL),(28761,'32007','P','Bostwick','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.774403,-81.640224,0,'2013-07-06 12:44:32',NULL,NULL),(14945,'15605','U','Bureau of Voc Rehab','N','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.348276,-79.518797,0,'2013-07-06 12:44:31',NULL,NULL),(61617,'72823','S','Appleton','A','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.244334,-92.936881,0,'2013-07-06 12:44:33',NULL,NULL),(62184,'73759','S','Renfrow','A','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.807871,-97.741275,0,'2013-07-06 12:44:33',NULL,NULL),(59012,'70069','P','Laplace','N','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.064380,-90.482520,0,'2013-07-06 12:44:33',NULL,NULL),(18382,'19047','S','Parkland','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.179301,-74.905397,0,'2013-07-06 12:44:31',NULL,NULL),(26139,'28735','S','Gerton','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.474017,-82.307894,0,'2013-07-06 12:44:31',NULL,NULL),(15885,'17003','S','West Annville','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(75106,'93544','S','Crystalaire','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.493353,-117.787760,0,'2013-07-06 12:44:34',NULL,NULL),(62764,'74856','S','Mill Creek','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.338856,-96.821143,0,'2013-07-06 12:44:33',NULL,NULL),(8609,'08240','P','Pomona','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.479928,-74.565410,0,'2013-07-06 12:44:30',NULL,NULL),(15608,'16678','S','Saxton','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.216087,-78.247370,0,'2013-07-06 12:44:31',NULL,NULL),(45267,'50669','S','Dinsdale','N','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.316980,-92.571000,0,'2013-07-06 12:44:32',NULL,NULL),(30706,'33488','P','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.355907,-80.171604,0,'2013-07-06 12:44:32',NULL,NULL),(39037,'44146','S','Oakwood Vlg','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(29467,'32719','P','Casselberry','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.683684,-81.276404,0,'2013-07-06 12:44:32',NULL,NULL),(4715,'03820','S','Dover','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.185660,-70.913640,0,'2013-07-06 12:44:30',NULL,NULL),(14587,'15221','S','Churchill','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(49244,'56473','S','Sylvan','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.295738,-94.330254,0,'2013-07-06 12:44:33',NULL,NULL),(69443,'83647','S','Anderson Dam','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(67856,'80823','S','Karval','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.697405,-103.421350,0,'2013-07-06 12:44:34',NULL,NULL),(35057,'39181','P','Vicksburg','D','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.343713,-90.857460,0,'2013-07-06 12:44:32',NULL,NULL),(36216,'40281','U','Rr Donnelly','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.145981,-85.867083,0,'2013-07-06 12:44:32',NULL,NULL),(22882,'24577','S','Lennig','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.942263,-78.970967,0,'2013-07-06 12:44:31',NULL,NULL),(13940,'14437','S','Dansville','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.572707,-77.731377,0,'2013-07-06 12:44:31',NULL,NULL),(79122,'98493','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.053364,-122.551238,0,'2013-07-06 12:44:34',NULL,NULL),(55620,'63964','S','Silva','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.225980,-90.441900,0,'2013-07-06 12:44:33',NULL,NULL),(16189,'17068','S','Paradise Park','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.418905,-77.189502,0,'2013-07-06 12:44:31',NULL,NULL),(11652,'12132','P','North Chatham','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.471422,-73.633263,0,'2013-07-06 12:44:30',NULL,NULL),(18542,'19113','S','Lester','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868191,-75.284889,0,'2013-07-06 12:44:31',NULL,NULL),(7596,'07042','S','Montclair','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.812954,-74.215386,0,'2013-07-06 12:44:30',NULL,NULL),(521,'00674','S','Urb Monte Verde','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(69506,'83714','S','Garden City','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.641900,-116.293500,0,'2013-07-06 12:44:34',NULL,NULL),(58024,'67953','S','Richfield','D','Morton','20129','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.283220,-101.736158,0,'2013-07-06 12:44:33',NULL,NULL),(49932,'57326','U','Chamberlain','D','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.808959,-99.317832,0,'2013-07-06 12:44:33',NULL,NULL),(14331,'15001','S','W Aliquippa','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(10900,'11426','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.733204,-73.722052,0,'2013-07-06 12:44:30',NULL,NULL),(29837,'33032','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526149,-80.406867,0,'2013-07-06 12:44:32',NULL,NULL),(29852,'33036','S','Plantation Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(73614,'91401','S','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.176265,-118.427626,0,'2013-07-06 12:44:34',NULL,NULL),(68364,'81137','S','Indian Agency','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(20950,'21774','S','New Market','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.406320,-77.296380,0,'2013-07-06 12:44:31',NULL,NULL),(30455,'33334','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181067,-80.138938,0,'2013-07-06 12:44:32',NULL,NULL),(66554,'78734','S','Hudson Bend','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371100,-97.869900,0,'2013-07-06 12:44:34',NULL,NULL),(36065,'40207','S','Rolling Fields','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(79199,'98532','S','Littell','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(77994,'97404','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.103156,-123.135275,0,'2013-07-06 12:44:34',NULL,NULL),(18079,'18705','S','Plains Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(44014,'49401','S','Allendale','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.974447,-85.930121,0,'2013-07-06 12:44:32',NULL,NULL),(29072,'32250','S','JAX Beach','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.281220,-81.416820,0,'2013-07-06 12:44:32',NULL,NULL),(50839,'58480','S','Sanborn','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.890564,-98.248569,0,'2013-07-06 12:44:33',NULL,NULL),(71912,'87820','S','Datil','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.949373,-108.678540,0,'2013-07-06 12:44:34',NULL,NULL),(76156,'95307','S','Ceres','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.585454,-120.956323,0,'2013-07-06 12:44:34',NULL,NULL),(74651,'92835','S','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.899369,-117.906333,0,'2013-07-06 12:44:34',NULL,NULL),(50008,'57381','S','Vayland','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.373351,-98.680654,0,'2013-07-06 12:44:33',NULL,NULL),(35222,'39304','P','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.364295,-88.686990,0,'2013-07-06 12:44:32',NULL,NULL),(18852,'19436','S','Spring House','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.206010,-75.247779,0,'2013-07-06 12:44:31',NULL,NULL),(18757,'19348','S','Kennett Sq','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.860730,-75.704389,0,'2013-07-06 12:44:31',NULL,NULL),(2575,'00959','S','Villa Verde','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(35331,'39428','S','Ora','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(63951,'76087','S','Hudson Oaks','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699394,-97.772650,0,'2013-07-06 12:44:34',NULL,NULL),(22400,'23955','P','Nottoway','D','Nottoway','51135','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.125076,-78.075336,0,'2013-07-06 12:44:31',NULL,NULL),(40324,'45479','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.723956,-84.192405,0,'2013-07-06 12:44:32',NULL,NULL),(63694,'75862','S','Westville','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(38481,'43657','U','Chrysler Corp Toledo Assy','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.676827,-83.561778,0,'2013-07-06 12:44:32',NULL,NULL),(57821,'67524','S','Chase','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.358620,-98.318064,0,'2013-07-06 12:44:33',NULL,NULL),(56428,'65263','S','Ash','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.473290,-92.214390,0,'2013-07-06 12:44:33',NULL,NULL),(53386,'61810','S','Allerton','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.912526,-87.933420,0,'2013-07-06 12:44:33',NULL,NULL),(3967,'02493','S','Cherry Brook','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(39558,'44847','S','Kimball','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.214505,-82.714432,0,'2013-07-06 12:44:32',NULL,NULL),(13578,'13844','S','Kirk','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.608333,-75.701944,0,'2013-07-06 12:44:31',NULL,NULL),(45475,'51334','S','Estherville','D','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.407540,-94.824120,0,'2013-07-06 12:44:32',NULL,NULL),(96,'00612','S','Urb College Park IV','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(12626,'13090','S','Lpool','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(75722,'94587','S','Union City','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.594129,-122.047013,0,'2013-07-06 12:44:34',NULL,NULL),(79333,'98613','S','Centerville','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.753779,-120.938232,0,'2013-07-06 12:44:34',NULL,NULL),(67333,'80044','P','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.749887,-104.827068,0,'2013-07-06 12:44:34',NULL,NULL),(49607,'56761','S','Skime','N','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.630234,-95.733971,0,'2013-07-06 12:44:33',NULL,NULL),(25184,'28052','S','Victory','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(38131,'43123','S','Darbydale','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.881816,-83.091047,0,'2013-07-06 12:44:32',NULL,NULL),(13345,'13692','P','Thous Is Pk','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.284887,-76.029920,0,'2013-07-06 12:44:30',NULL,NULL),(9919,'10151','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(13346,'13692','P','Thousand Island Park','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.284887,-76.029920,0,'2013-07-06 12:44:30',NULL,NULL),(61181,'72205','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.751922,-92.345672,0,'2013-07-06 12:44:33',NULL,NULL),(55727,'64082','S','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.860336,-94.400056,0,'2013-07-06 12:44:33',NULL,NULL),(52064,'60209','U','Northwestern Univ Residental','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.046820,-87.695708,0,'2013-07-06 12:44:33',NULL,NULL),(32100,'35296','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.414914,-86.809475,0,'2013-07-06 12:44:32',NULL,NULL),(719,'00687','S','Repto Los Torres','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(11167,'11726','S','Copiague','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.680826,-73.393642,0,'2013-07-06 12:44:30',NULL,NULL),(37846,'42464','S','White Plains','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.188655,-87.391351,0,'2013-07-06 12:44:32',NULL,NULL),(23470,'25442','S','Shendoah Jct','A','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.359284,-77.838178,0,'2013-07-06 12:44:31',NULL,NULL),(22973,'24726','S','Herndon','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.517748,-81.346153,0,'2013-07-06 12:44:31',NULL,NULL),(63212,'75448','S','Klondike','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.297945,-95.805253,0,'2013-07-06 12:44:33',NULL,NULL),(73960,'92066','S','Warner Springs','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.219240,-116.528880,0,'2013-07-06 12:44:34',NULL,NULL),(78349,'98008','S','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.609195,-122.113604,0,'2013-07-06 12:44:34',NULL,NULL),(73434,'91214','S','Glendale','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.232506,-118.245761,0,'2013-07-06 12:44:34',NULL,NULL),(71114,'86015','P','Bellemont','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.198056,-111.650556,0,'2013-07-06 12:44:34',NULL,NULL),(771,'00692','S','Urb Santa Rita','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(57604,'67112','S','Nashville','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.425589,-98.411320,0,'2013-07-06 12:44:33',NULL,NULL),(20020,'20622','S','Charlotte Hall','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.497286,-76.765851,0,'2013-07-06 12:44:31',NULL,NULL),(10430,'10804','S','New Rochelle','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.949073,-73.785808,0,'2013-07-06 12:44:30',NULL,NULL),(34424,'38639','P','Jonestown','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.324642,-90.453025,0,'2013-07-06 12:44:32',NULL,NULL),(55956,'64491','S','Tarkio','D','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.437869,-95.386243,0,'2013-07-06 12:44:33',NULL,NULL),(74375,'92504','S','Casa Blanca','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.924842,-117.397533,0,'2013-07-06 12:44:34',NULL,NULL),(73000,'90061','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.922433,-118.275162,0,'2013-07-06 12:44:34',NULL,NULL),(72123,'88262','P','Mc Donald','N','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.142688,-103.319739,0,'2013-07-06 12:44:34',NULL,NULL),(32828,'36467','S','Onycha','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.285500,-86.264760,0,'2013-07-06 12:44:32',NULL,NULL),(21397,'22508','S','Mine Run','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.333379,-77.762530,0,'2013-07-06 12:44:31',NULL,NULL),(39257,'44444','S','Braceville','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.185982,-80.967610,0,'2013-07-06 12:44:32',NULL,NULL),(8359,'08050','S','Stafford Township','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.698720,-74.257382,0,'2013-07-06 12:44:30',NULL,NULL),(50626,'58270','S','Park River','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.399566,-97.744639,0,'2013-07-06 12:44:33',NULL,NULL),(71377,'87004','S','Bernalillo','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(74472,'92604','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.689885,-117.786783,0,'2013-07-06 12:44:34',NULL,NULL),(72623,'89418','S','Tungsten','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(62212,'73851','S','May','D','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.635502,-99.683794,0,'2013-07-06 12:44:33',NULL,NULL),(58252,'68366','S','Greenwood','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.962494,-96.441281,0,'2013-07-06 12:44:33',NULL,NULL),(29357,'32567','S','Laurel Hill','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.933464,-86.418718,0,'2013-07-06 12:44:32',NULL,NULL),(8545,'08203','S','Brigantine','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.400502,-74.382819,0,'2013-07-06 12:44:30',NULL,NULL),(40874,'46237','S','Southport','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.656220,-86.100300,0,'2013-07-06 12:44:32',NULL,NULL),(19453,'20120','S','Sully Station','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.850947,-77.461130,0,'2013-07-06 12:44:31',NULL,NULL),(7381,'06777','S','Washington','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(7884,'07513','S','Peoples Park','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.907163,-74.148803,0,'2013-07-06 12:44:30',NULL,NULL),(13708,'14065','S','Sandusky','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.476640,-78.316440,0,'2013-07-06 12:44:31',NULL,NULL),(12014,'12504','P','Annandale','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.012397,-73.898328,0,'2013-07-06 12:44:30',NULL,NULL),(35828,'39769','S','Craig Springs','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.357720,-89.050020,0,'2013-07-06 12:44:32',NULL,NULL),(34758,'38858','S','Van Buren','N','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.076707,-88.619807,0,'2013-07-06 12:44:32',NULL,NULL),(30241,'33194','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.758515,-80.391867,0,'2013-07-06 12:44:32',NULL,NULL),(53234,'61641','U','Keystone Steel and Wire','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.653063,-89.683748,0,'2013-07-06 12:44:33',NULL,NULL),(65558,'77842','P','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.629960,-96.333212,0,'2013-07-06 12:44:34',NULL,NULL),(70794,'85360','P','Wikieup','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.655225,-113.755225,0,'2013-07-06 12:44:34',NULL,NULL),(71668,'87505','S','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.621141,-105.967103,0,'2013-07-06 12:44:34',NULL,NULL),(65052,'77338','S','Bordersville','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.003446,-95.277832,0,'2013-07-06 12:44:34',NULL,NULL),(51666,'59914','S','Dayton','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.862589,-114.305026,0,'2013-07-06 12:44:33',NULL,NULL),(30099,'33158','S','Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(4567,'03468','P','W Peterboro','A','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871737,-71.969706,0,'2013-07-06 12:44:30',NULL,NULL),(3480,'01831','P','Haverhill','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.785760,-71.084665,0,'2013-07-06 12:44:30',NULL,NULL),(40642,'46036','S','Curtisville','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(24133,'26555','P','Monongah','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.470255,-80.150258,0,'2013-07-06 12:44:31',NULL,NULL),(30563,'33413','S','Green Acres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.678715,-80.141603,0,'2013-07-06 12:44:32',NULL,NULL),(45480,'51342','S','Graettinger','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.237283,-94.753901,0,'2013-07-06 12:44:32',NULL,NULL),(43024,'48169','S','Dexter Twp','N','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.459080,-83.934013,0,'2013-07-06 12:44:32',NULL,NULL),(65168,'77411','P','Howellville','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.730802,-95.592618,0,'2013-07-06 12:44:34',NULL,NULL),(68522,'81334','P','Ute Mountain Indian Reservat','N','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.191688,-108.741033,0,'2013-07-06 12:44:34',NULL,NULL),(50733,'58384','S','Overly','A','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617340,-100.299168,0,'2013-07-06 12:44:33',NULL,NULL),(32733,'36318','S','Coffee Spgs','A','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.169648,-85.910785,0,'2013-07-06 12:44:32',NULL,NULL),(33318,'37138','S','Lakewood','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.245160,-86.632377,0,'2013-07-06 12:44:32',NULL,NULL),(36383,'40476','P','Richmond','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.748985,-84.293512,0,'2013-07-06 12:44:32',NULL,NULL),(18678,'19184','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953202,-75.183899,0,'2013-07-06 12:44:31',NULL,NULL),(491,'00674','S','Alts de Manati','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(25352,'28228','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.099604,-80.771417,0,'2013-07-06 12:44:31',NULL,NULL),(6292,'05650','S','North Calais','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.351384,-72.439832,0,'2013-07-06 12:44:30',NULL,NULL),(2955,'01035','S','North Hadley','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.359966,-72.577472,0,'2013-07-06 12:44:30',NULL,NULL),(58138,'68145','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.257619,-95.936656,0,'2013-07-06 12:44:33',NULL,NULL),(5038,'04260','S','New Gloucester','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.973580,-70.325340,0,'2013-07-06 12:44:30',NULL,NULL),(45626,'51603','U','Shenandoah','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.766701,-95.371715,0,'2013-07-06 12:44:32',NULL,NULL),(15601,'16673','S','Bakers Summit','A','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.334211,-78.396280,0,'2013-07-06 12:44:31',NULL,NULL),(9438,'10004','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(59760,'71156','U','Swepco','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.511335,-93.748082,0,'2013-07-06 12:44:33',NULL,NULL),(62436,'74169','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.127872,-95.868871,0,'2013-07-06 12:44:33',NULL,NULL),(13701,'14060','S','Farmersville','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.436740,-78.302220,0,'2013-07-06 12:44:31',NULL,NULL),(28390,'31312','S','Guyton','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.319023,-81.394389,0,'2013-07-06 12:44:32',NULL,NULL),(77414,'96792','S','Waianae','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.440282,-158.186378,0,'2013-07-06 12:44:34',NULL,NULL),(66402,'78629','S','Hamon','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(63558,'75766','S','Reese','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:34',NULL,NULL),(61395,'72540','S','Guion','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.957204,-91.938344,0,'2013-07-06 12:44:33',NULL,NULL),(58948,'69358','S','Stegall','N','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.962994,-103.926289,0,'2013-07-06 12:44:33',NULL,NULL),(8608,'08234','S','Steelmanville','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(7453,'06857','U','Mbi Inc','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.094752,-73.434074,0,'2013-07-06 12:44:30',NULL,NULL),(44439,'49855','S','Harvey','A','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.550000,-87.400000,0,'2013-07-06 12:44:32',NULL,NULL),(42966,'48134','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.107811,-83.281359,0,'2013-07-06 12:44:32',NULL,NULL),(2449,'00953','S','Urb Toa Alta Hts','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(14234,'14810','S','Veterans Administration','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.342030,-77.318938,0,'2013-07-06 12:44:31',NULL,NULL),(14923,'15547','P','Jennerstown','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.161553,-79.066352,0,'2013-07-06 12:44:31',NULL,NULL),(29464,'32716','P','Altamonte Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.663807,-81.403206,0,'2013-07-06 12:44:32',NULL,NULL),(75440,'94044','S','Pacifica','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.602347,-122.485548,0,'2013-07-06 12:44:34',NULL,NULL),(76896,'95980','P','Tobin','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(64862,'77057','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.745957,-95.490821,0,'2013-07-06 12:44:34',NULL,NULL),(28863,'32114','S','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.198356,-81.042354,0,'2013-07-06 12:44:32',NULL,NULL),(24307,'27016','S','Hartman','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.466460,-80.251279,0,'2013-07-06 12:44:31',NULL,NULL),(6708,'06066','S','Rockville','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(1196,'00728','S','Hacienda La Matilde','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(40029,'45249','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.290580,-84.334690,0,'2013-07-06 12:44:32',NULL,NULL),(25086,'27953','S','East Lake','A','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.865180,-75.919020,0,'2013-07-06 12:44:31',NULL,NULL),(36991,'41204','S','Boons Camp','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.816767,-82.674355,0,'2013-07-06 12:44:32',NULL,NULL),(63346,'75606','P','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.495736,-94.738464,0,'2013-07-06 12:44:33',NULL,NULL),(75173,'93602','S','Pineridge','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.074481,-119.455209,0,'2013-07-06 12:44:34',NULL,NULL),(75637,'94518','S','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.950267,-122.021455,0,'2013-07-06 12:44:34',NULL,NULL),(23285,'25164','S','Pigeon','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.470869,-81.222751,0,'2013-07-06 12:44:31',NULL,NULL),(42411,'47802','S','Honey Creek Square','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(53806,'62293','S','St Morgan','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.607272,-89.683388,0,'2013-07-06 12:44:33',NULL,NULL),(64027,'76121','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.722031,-97.449860,0,'2013-07-06 12:44:34',NULL,NULL),(43770,'49029','S','Burlington','D','Calhoun','26025','Michigan','MI','26','3720','517','Eastern',-5.0,'Y',42.135098,-85.088963,0,'2013-07-06 12:44:32',NULL,NULL),(69002,'83203','P','Fort Hall','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.990305,-112.424758,0,'2013-07-06 12:44:34',NULL,NULL),(13891,'14269','U','Harlequin Books','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.865140,-78.869492,0,'2013-07-06 12:44:31',NULL,NULL),(18039,'18657','S','Forkston Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(58652,'68873','S','St Paul','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.234520,-98.450520,0,'2013-07-06 12:44:33',NULL,NULL),(64575,'76664','S','Watt','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.548099,-96.837534,0,'2013-07-06 12:44:34',NULL,NULL),(65001,'77297','U','Chase Bank','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.762572,-95.364143,0,'2013-07-06 12:44:34',NULL,NULL),(73379,'91066','P','Arcadia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.142937,-118.031242,0,'2013-07-06 12:44:34',NULL,NULL),(78355,'98011','S','Queensgate','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.755500,-122.191349,0,'2013-07-06 12:44:34',NULL,NULL),(64497,'76629','S','Bremond','D','Robertson','48395','Texas','TX','48','0000','254','Central',-6.0,'Y',31.149300,-96.676320,0,'2013-07-06 12:44:34',NULL,NULL),(21068,'21930','P','Georgetown','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.368126,-75.889063,0,'2013-07-06 12:44:31',NULL,NULL),(45074,'50524','S','Clare','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.588872,-94.344666,0,'2013-07-06 12:44:32',NULL,NULL),(995,'00717','S','Ext Salazar','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(12150,'12737','S','Glen Spey','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.476622,-74.789321,0,'2013-07-06 12:44:30',NULL,NULL),(10994,'11549','U','Hofstra Univ','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705686,-73.618785,0,'2013-07-06 12:44:30',NULL,NULL),(21861,'23148','S','St Stephens Church','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.914841,-77.076387,0,'2013-07-06 12:44:31',NULL,NULL),(20110,'20711','S','Lothian','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.806456,-76.650233,0,'2013-07-06 12:44:31',NULL,NULL),(3900,'02451','S','Waltham','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.399203,-71.262490,0,'2013-07-06 12:44:30',NULL,NULL),(40058,'45268','U','Envir Pro Agency','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.148449,-84.519895,0,'2013-07-06 12:44:32',NULL,NULL),(18936,'19506','S','Garfield','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.448100,-76.133040,0,'2013-07-06 12:44:31',NULL,NULL),(11051,'11576','S','E Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.774722,-73.656111,0,'2013-07-06 12:44:30',NULL,NULL),(10739,'11357','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.783792,-73.812287,0,'2013-07-06 12:44:30',NULL,NULL),(2119,'00924','S','Bda Santo Domingo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(1967,'00831','P','Cruz Bay','A','Saint John','78020','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.333472,-64.792955,0,'2013-07-06 12:44:30',NULL,NULL),(26509,'29172','S','West Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.898509,-81.092152,0,'2013-07-06 12:44:31',NULL,NULL),(30804,'33611','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.888949,-82.507598,0,'2013-07-06 12:44:32',NULL,NULL),(48091,'55339','S','Hamburg','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.733143,-93.968679,0,'2013-07-06 12:44:33',NULL,NULL),(53789,'62280','S','Glenn','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.829257,-89.624565,0,'2013-07-06 12:44:33',NULL,NULL),(75617,'94502','S','Alameda','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.739355,-122.242485,0,'2013-07-06 12:44:34',NULL,NULL),(65271,'77475','P','Sheridan','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.494031,-96.668751,0,'2013-07-06 12:44:34',NULL,NULL),(62811,'74945','P','Marble City','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.579795,-94.821443,0,'2013-07-06 12:44:33',NULL,NULL),(32053,'35259','P','Homewood','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.520556,-86.802500,0,'2013-07-06 12:44:32',NULL,NULL),(42874,'48084','S','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.556928,-83.172840,0,'2013-07-06 12:44:32',NULL,NULL),(24795,'27588','P','Wake Forest','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.967355,-78.517816,0,'2013-07-06 12:44:31',NULL,NULL),(22905,'24601','P','Amonate','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.190202,-81.640645,0,'2013-07-06 12:44:31',NULL,NULL),(39839,'45160','S','Owensville','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.124142,-84.139513,0,'2013-07-06 12:44:32',NULL,NULL),(39123,'44264','S','Everett','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.232420,-81.553757,0,'2013-07-06 12:44:32',NULL,NULL),(13181,'13617','S','Langdon Corners','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(31618,'34690','S','Holiday','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.191092,-82.728081,0,'2013-07-06 12:44:32',NULL,NULL),(2284,'00926','S','Villa Colinas de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(52525,'60917','S','Buckingham','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.044008,-88.170607,0,'2013-07-06 12:44:33',NULL,NULL),(55554,'63853','P','Holland','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.054895,-89.870395,0,'2013-07-06 12:44:33',NULL,NULL),(62622,'74546','P','Haileyville','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.845081,-95.566691,0,'2013-07-06 12:44:33',NULL,NULL),(65661,'77979','S','Long Mott','A','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(77500,'96830','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286315,-157.834651,0,'2013-07-06 12:44:34',NULL,NULL),(64632,'76705','S','Northcrest','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(63437,'75669','S','Dotson','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.072778,-94.567778,0,'2013-07-06 12:44:33',NULL,NULL),(61360,'72501','S','Batesville','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.773469,-91.638100,0,'2013-07-06 12:44:33',NULL,NULL),(29577,'32819','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.460252,-81.475492,0,'2013-07-06 12:44:32',NULL,NULL),(13035,'13436','S','Brightside','N','Hamilton','36041','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.780901,-74.669391,0,'2013-07-06 12:44:30',NULL,NULL),(4860,'04021','S','Cumberland Center','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.811530,-70.263280,0,'2013-07-06 12:44:30',NULL,NULL),(41558,'47021','P','Friendship','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.119473,-85.207959,0,'2013-07-06 12:44:32',NULL,NULL),(5081,'04330','S','Augusta','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.353599,-69.731361,0,'2013-07-06 12:44:30',NULL,NULL),(48172,'55379','S','Shakopee','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.791430,-93.516743,0,'2013-07-06 12:44:33',NULL,NULL),(61879,'73130','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.467400,-97.336500,0,'2013-07-06 12:44:33',NULL,NULL),(79311,'98596','S','Evaline','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.496928,-122.919210,0,'2013-07-06 12:44:34',NULL,NULL),(74547,'92674','P','San Clemente','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.440938,-117.621134,0,'2013-07-06 12:44:34',NULL,NULL),(70302,'84540','S','Green River','A','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.035892,-109.696213,0,'2013-07-06 12:44:34',NULL,NULL),(196,'00623','S','Urb Kofresi','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(14491,'15137','S','North Versailles','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.392941,-79.833489,0,'2013-07-06 12:44:31',NULL,NULL),(13149,'13601','S','Wtown','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.984440,-75.900540,0,'2013-07-06 12:44:30',NULL,NULL),(26727,'29418','S','Charleston Hts','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(65379,'77542','P','Freeport','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951160,-95.363282,0,'2013-07-06 12:44:34',NULL,NULL),(1460,'00745','S','Parc La Dolores','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(14157,'14722','P','Chautauqua','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.207332,-79.466845,0,'2013-07-06 12:44:31',NULL,NULL),(18296,'19015','S','Chester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868688,-75.385721,0,'2013-07-06 12:44:31',NULL,NULL),(10233,'10464','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.852713,-73.790565,0,'2013-07-06 12:44:30',NULL,NULL),(47028,'54344','U','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.419190,-88.104737,0,'2013-07-06 12:44:32',NULL,NULL),(24140,'26562','S','Coburn','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.665640,-80.419500,0,'2013-07-06 12:44:31',NULL,NULL),(6111,'05456','S','Ferrisburgh','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.214705,-73.268043,0,'2013-07-06 12:44:30',NULL,NULL),(76482,'95630','S','Folsom','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.683096,-121.160535,0,'2013-07-06 12:44:34',NULL,NULL),(66264,'78577','S','Las Milpas','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.187450,-98.183954,0,'2013-07-06 12:44:34',NULL,NULL),(57072,'66214','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(52533,'60924','S','Cissna Park','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.568326,-87.896441,0,'2013-07-06 12:44:33',NULL,NULL),(48684,'55926','S','Dexter','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.720070,-92.750013,0,'2013-07-06 12:44:33',NULL,NULL),(3732,'02155','S','W Medford','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.421320,-71.113443,0,'2013-07-06 12:44:30',NULL,NULL),(15587,'16664','S','New Enterprise','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.193674,-78.423234,0,'2013-07-06 12:44:31',NULL,NULL),(35544,'39563','S','Moss Point','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(34802,'38877','P','Van Vleet','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.910569,-88.931385,0,'2013-07-06 12:44:32',NULL,NULL),(29990,'33109','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796586,-80.286950,0,'2013-07-06 12:44:32',NULL,NULL),(60318,'71457','S','Natch','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(67678,'80504','S','Frederick','A','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.160065,-104.966226,0,'2013-07-06 12:44:34',NULL,NULL),(18756,'19347','P','Kemblesville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.887483,-75.647655,0,'2013-07-06 12:44:31',NULL,NULL),(23088,'24916','S','Alta','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.834853,-80.573425,0,'2013-07-06 12:44:31',NULL,NULL),(47638,'54919','U','Thrivent Finan For Lutherans','N','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.268304,-88.396324,0,'2013-07-06 12:44:33',NULL,NULL),(625,'00682','S','Mayaguez','D','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(16291,'17106','P','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.233872,-76.819088,0,'2013-07-06 12:44:31',NULL,NULL),(39647,'44906','S','Ontario','A','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.764961,-82.565848,0,'2013-07-06 12:44:32',NULL,NULL),(67206,'79913','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.839613,-106.564487,0,'2013-07-06 12:44:34',NULL,NULL),(59332,'70538','S','Cypremort Pt','A','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.796186,-91.507053,0,'2013-07-06 12:44:33',NULL,NULL),(50032,'57428','S','Bowdle','D','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.452252,-99.657884,0,'2013-07-06 12:44:33',NULL,NULL),(30570,'33414','S','Village of Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(16355,'17201','S','Beautiful','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(9594,'10029','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(11697,'12159','S','Slingerlands','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.642796,-73.877696,0,'2013-07-06 12:44:30',NULL,NULL),(20283,'20792','P','Largo','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.815289,-76.749621,0,'2013-07-06 12:44:31',NULL,NULL),(63500,'75707','S','Chapel Hill','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.297280,-95.202900,0,'2013-07-06 12:44:33',NULL,NULL),(55518,'63787','S','Arab','A','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.131892,-90.084809,0,'2013-07-06 12:44:33',NULL,NULL),(33196,'37042','S','Clarksville','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.562140,-87.405720,0,'2013-07-06 12:44:32',NULL,NULL),(51692,'59937','S','Whitefish','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.408343,-114.352231,0,'2013-07-06 12:44:33',NULL,NULL),(2051,'00920','S','Caparra','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(60479,'71656','P','Monticello','D','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.630719,-91.791081,0,'2013-07-06 12:44:33',NULL,NULL),(43602,'48765','S','Turner','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.130949,-83.720491,0,'2013-07-06 12:44:32',NULL,NULL),(8491,'08096','S','Almonesson','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(45483,'51346','S','Hartley','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.183529,-95.478433,0,'2013-07-06 12:44:32',NULL,NULL),(44690,'50127','S','Ira','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.734534,-93.170294,0,'2013-07-06 12:44:32',NULL,NULL),(15774,'16921','S','Manhattan','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(57701,'67336','S','Chetopa','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.037596,-95.090918,0,'2013-07-06 12:44:33',NULL,NULL),(67613,'80434','P','Cowdrey','D','Jackson','08057','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.858108,-106.310219,0,'2013-07-06 12:44:34',NULL,NULL),(77933,'97333','S','Corvallis','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.521146,-123.295667,0,'2013-07-06 12:44:34',NULL,NULL),(68320,'81120','S','Fox Creek','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(52824,'61301','S','La Salle','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.355630,-89.094865,0,'2013-07-06 12:44:33',NULL,NULL),(2354,'00949','S','Bo Candelaria','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(9673,'10041','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(5884,'05151','S','Weathersfield','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.416944,-72.518333,0,'2013-07-06 12:44:30',NULL,NULL),(21627,'22908','U','Univ of Va Med Ctr','N','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.035452,-78.514913,0,'2013-07-06 12:44:31',NULL,NULL),(59621,'71032','S','Holly','N','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.117220,-93.776940,0,'2013-07-06 12:44:33',NULL,NULL),(72665,'89435','P','Sparks','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.544276,-119.735636,0,'2013-07-06 12:44:34',NULL,NULL),(61442,'72601','S','Harrison','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.238821,-93.114328,0,'2013-07-06 12:44:33',NULL,NULL),(51996,'60163','S','Berkeley','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.884020,-87.908634,0,'2013-07-06 12:44:33',NULL,NULL),(9904,'10131','U','Lenox Hill','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.785617,-73.949816,0,'2013-07-06 12:44:30',NULL,NULL),(18996,'19525','S','Douglass','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.311960,-75.589380,0,'2013-07-06 12:44:31',NULL,NULL),(25817,'28610','S','Claremont','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.707009,-81.148762,0,'2013-07-06 12:44:31',NULL,NULL),(55617,'63961','S','Qulin','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.566301,-90.271861,0,'2013-07-06 12:44:33',NULL,NULL),(56620,'65584','S','St Robert','N','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.828919,-92.200348,0,'2013-07-06 12:44:33',NULL,NULL),(63735,'75935','S','Center','D','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(65477,'77640','S','Port Acres','A','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(74754,'93064','U','Brandeis Univ','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.283831,-118.688394,0,'2013-07-06 12:44:34',NULL,NULL),(12345,'12879','S','Tahawus','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.018002,-74.128990,0,'2013-07-06 12:44:30',NULL,NULL),(45135,'50575','S','Pomeroy','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.517470,-94.763370,0,'2013-07-06 12:44:32',NULL,NULL),(73373,'91040','S','Shadow Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.260030,-118.332661,0,'2013-07-06 12:44:34',NULL,NULL),(80060,'99716','P','Fairbanks','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.875857,-146.876181,0,'2013-07-06 12:44:34',NULL,NULL),(51635,'59859','S','Plains','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.481940,-114.882862,0,'2013-07-06 12:44:33',NULL,NULL),(7114,'06376','P','South Lyme','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.294573,-72.259086,0,'2013-07-06 12:44:30',NULL,NULL),(14607,'15226','S','Brookline','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.396692,-80.015390,0,'2013-07-06 12:44:31',NULL,NULL),(45791,'52166','P','Saint Lucas','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.065027,-91.932103,0,'2013-07-06 12:44:32',NULL,NULL),(75024,'93501','S','Mojave','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.024023,-118.177512,0,'2013-07-06 12:44:34',NULL,NULL),(75485,'94121','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.779770,-122.489312,0,'2013-07-06 12:44:34',NULL,NULL),(76557,'95667','S','Newtown','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(79019,'98391','S','Driftwood','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(445,'00662','S','Urb Las 3t','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(23474,'25501','S','Alkol','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.169706,-81.995693,0,'2013-07-06 12:44:31',NULL,NULL),(36084,'40217','S','Parkway Village','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.217903,-85.741113,0,'2013-07-06 12:44:32',NULL,NULL),(575,'00680','S','Bo Buena Vista','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(62074,'73554','S','Reed','A','Greer','40055','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.876209,-99.504161,0,'2013-07-06 12:44:33',NULL,NULL),(64425,'76557','S','Meador Grove','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(77842,'97222','S','Milwaukie','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.437695,-122.614273,0,'2013-07-06 12:44:34',NULL,NULL),(75776,'94662','P','Emeryville','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.840484,-122.293762,0,'2013-07-06 12:44:34',NULL,NULL),(47792,'55047','S','Marine on Saint Croix','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(1545,'00757','S','Urb Buenos Aires','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(12826,'13308','S','Blossvale','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.241534,-75.652043,0,'2013-07-06 12:44:30',NULL,NULL),(11747,'12188','S','Waterford','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.819540,-73.702620,0,'2013-07-06 12:44:30',NULL,NULL),(41987,'47421','S','Shawswick','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(27630,'30312','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.743314,-84.378489,0,'2013-07-06 12:44:31',NULL,NULL),(71479,'87064','S','Youngsville','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188010,-106.557600,0,'2013-07-06 12:44:34',NULL,NULL),(54972,'63122','S','Kirkwood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.584479,-90.414020,0,'2013-07-06 12:44:33',NULL,NULL),(54257,'62675','S','Atterberry','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.003483,-89.851315,0,'2013-07-06 12:44:33',NULL,NULL),(5919,'05251','S','Dorset','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.222500,-73.073889,0,'2013-07-06 12:44:30',NULL,NULL),(51772,'60037','S','Highland Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.209412,-87.806565,0,'2013-07-06 12:44:33',NULL,NULL),(51820,'60051','S','Volo','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.342172,-88.289042,0,'2013-07-06 12:44:33',NULL,NULL),(79145,'98501','S','South Bay','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(75942,'95032','S','Los Gatos','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.231042,-121.949002,0,'2013-07-06 12:44:34',NULL,NULL),(58674,'68901','S','Hastings Imperial Mall','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(52495,'60706','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.962443,-87.817391,0,'2013-07-06 12:44:33',NULL,NULL),(78932,'98366','S','Pt Orchard','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(59274,'70458','S','North Shore','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.272675,-89.772151,0,'2013-07-06 12:44:33',NULL,NULL),(56095,'64778','S','Horton','A','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.941915,-94.557009,0,'2013-07-06 12:44:33',NULL,NULL),(7963,'07699','U','Nnj Metro P&Dc','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.859722,-74.059722,0,'2013-07-06 12:44:30',NULL,NULL),(9229,'09545','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(78211,'97754','S','Prineville','D','Crook','41013','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.300941,-120.838053,0,'2013-07-06 12:44:34',NULL,NULL),(55945,'64482','S','Rockport','N','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.411278,-95.516834,0,'2013-07-06 12:44:33',NULL,NULL),(53127,'61547','S','Mapleton','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613781,-89.743465,0,'2013-07-06 12:44:33',NULL,NULL),(1600,'00769','S','Urb El Eden','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(35018,'39153','S','Burns','N','Smith','28129','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.064420,-89.507100,0,'2013-07-06 12:44:32',NULL,NULL),(4872,'04032','S','Freeport','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.853954,-70.102420,0,'2013-07-06 12:44:30',NULL,NULL),(67411,'80132','S','Monument','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.100182,-104.849748,0,'2013-07-06 12:44:34',NULL,NULL),(53699,'62231','S','Shatuc','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(13355,'13699','U','Clarkson University','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.671160,-74.986199,0,'2013-07-06 12:44:31',NULL,NULL),(15555,'16631','P','Curryville','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.276636,-78.338693,0,'2013-07-06 12:44:31',NULL,NULL),(5712,'04986','S','Knox','A','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.579334,-69.243569,0,'2013-07-06 12:44:30',NULL,NULL),(44708,'50141','S','Laurel','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.888202,-92.942663,0,'2013-07-06 12:44:32',NULL,NULL),(13742,'14110','P','North Boston','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.684526,-78.774487,0,'2013-07-06 12:44:31',NULL,NULL),(47525,'54806','S','Oneida Indian Reservation','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(11678,'12150','S','Rotterdam Jct','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.876680,-74.043438,0,'2013-07-06 12:44:30',NULL,NULL),(76414,'95558','S','Petrolia','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.260403,-124.189620,0,'2013-07-06 12:44:34',NULL,NULL),(35433,'39476','S','East Side','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(26179,'28754','S','Mars Hill','D','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.876794,-82.540355,0,'2013-07-06 12:44:31',NULL,NULL),(20974,'21794','S','W Friendship','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295986,-76.972906,0,'2013-07-06 12:44:31',NULL,NULL),(33048,'36751','S','Lwr Pch Tree','A','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.848577,-87.569570,0,'2013-07-06 12:44:32',NULL,NULL),(44556,'50010','S','Ames','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.029583,-93.640161,0,'2013-07-06 12:44:32',NULL,NULL),(43742,'49002','S','Portage','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.204383,-85.598689,0,'2013-07-06 12:44:32',NULL,NULL),(35454,'39483','S','Foxworth','D','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(990,'00717','S','Bda Salazar','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(26748,'29424','U','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.783715,-79.939185,0,'2013-07-06 12:44:31',NULL,NULL),(59459,'70733','S','Fr Settlement','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.311150,-90.799661,0,'2013-07-06 12:44:33',NULL,NULL),(73281,'90745','S','Long Beach','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.820353,-118.266179,0,'2013-07-06 12:44:34',NULL,NULL),(73370,'91030','S','South Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.111870,-118.155784,0,'2013-07-06 12:44:34',NULL,NULL),(78015,'97416','S','Camas Valley','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.039108,-123.682959,0,'2013-07-06 12:44:34',NULL,NULL),(49658,'57001','S','Nora','N','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.021930,-96.622613,0,'2013-07-06 12:44:33',NULL,NULL),(30511,'33403','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(225,'00624','S','Urb Riverside','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(74240,'92326','P','Crest Park','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.242853,-117.199485,0,'2013-07-06 12:44:34',NULL,NULL),(65286,'77485','S','Wallis','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.605967,-96.028147,0,'2013-07-06 12:44:34',NULL,NULL),(3496,'01845','S','North Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.686182,-71.105718,0,'2013-07-06 12:44:30',NULL,NULL),(32601,'36132','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380100,-86.181883,0,'2013-07-06 12:44:32',NULL,NULL),(72843,'89835','S','Cover City','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(64103,'76179','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.906400,-97.433220,0,'2013-07-06 12:44:34',NULL,NULL),(17175,'17815','S','Buckhorn','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(5094,'04344','S','Farmingdale','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.254156,-69.782143,0,'2013-07-06 12:44:30',NULL,NULL),(18368,'19043','S','Holmes','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.901622,-75.311519,0,'2013-07-06 12:44:31',NULL,NULL),(46039,'52557','U','Fairfield','D','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005913,-91.964200,0,'2013-07-06 12:44:32',NULL,NULL),(21907,'23190','P','Woods Cross Rds','N','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.483538,-76.620692,0,'2013-07-06 12:44:31',NULL,NULL),(24061,'26431','S','Adamsville','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(77387,'96765','P','Lawai','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.926579,-159.508429,0,'2013-07-06 12:44:34',NULL,NULL),(31292,'34050','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(31612,'34688','S','Tarpon Spgs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143822,-82.680110,0,'2013-07-06 12:44:32',NULL,NULL),(37932,'42642','S','Russell Springs','D','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.055440,-85.091503,0,'2013-07-06 12:44:32',NULL,NULL),(18301,'19017','P','Chester Hts','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.888886,-75.471423,0,'2013-07-06 12:44:31',NULL,NULL),(75207,'93631','S','Kingsburg','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.521236,-119.555095,0,'2013-07-06 12:44:34',NULL,NULL),(60698,'71940','S','Tobin','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(27037,'29659','P','Lowndesville','D','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.257916,-82.583408,0,'2013-07-06 12:44:31',NULL,NULL),(19543,'20194','S','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.980241,-77.339946,0,'2013-07-06 12:44:31',NULL,NULL),(36583,'40962','S','Bluehole','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(25889,'28643','S','Ball','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(29915,'33056','S','Carol City','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.946322,-80.247066,0,'2013-07-06 12:44:32',NULL,NULL),(78475,'98089','P','Midway','N','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.393200,-122.257900,0,'2013-07-06 12:44:34',NULL,NULL),(5378,'04634','S','Franklin','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.624794,-68.218829,0,'2013-07-06 12:44:30',NULL,NULL),(21336,'22412','U','Falmouth','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299924,-77.488208,0,'2013-07-06 12:44:31',NULL,NULL),(57357,'66736','S','Fredonia','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.535127,-95.823027,0,'2013-07-06 12:44:33',NULL,NULL),(2637,'00965','S','Villa Concepcion 1','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(55966,'64502','P','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.763607,-94.849982,0,'2013-07-06 12:44:33',NULL,NULL),(22438,'24017','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.295707,-79.989389,0,'2013-07-06 12:44:31',NULL,NULL),(68571,'81503','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.039000,-108.496612,0,'2013-07-06 12:44:34',NULL,NULL),(60358,'71471','P','St Maurice','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.757113,-92.962011,0,'2013-07-06 12:44:33',NULL,NULL),(59739,'71133','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.488715,-93.768133,0,'2013-07-06 12:44:33',NULL,NULL),(15413,'16352','P','Tiona','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846172,-79.145309,0,'2013-07-06 12:44:31',NULL,NULL),(47669,'54944','S','Hortonville','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.320068,-88.622498,0,'2013-07-06 12:44:33',NULL,NULL),(48187,'55390','S','Waverly','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.066530,-93.968140,0,'2013-07-06 12:44:33',NULL,NULL),(8272,'08010','S','Beverly','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.058892,-74.910433,0,'2013-07-06 12:44:30',NULL,NULL),(7913,'07628','S','Dumont','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.945165,-73.993651,0,'2013-07-06 12:44:30',NULL,NULL),(16041,'17044','S','Lewistown','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(29489,'32739','P','Deltona','D','Volusia','12127','Florida','FL','12','2020','407/321/689','Eastern',-5.0,'Y',28.910030,-81.207277,0,'2013-07-06 12:44:32',NULL,NULL),(3467,'01812','U','Internal Revenue Service','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.648594,-71.182543,0,'2013-07-06 12:44:30',NULL,NULL),(22099,'23415','S','New Church','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.960394,-75.510149,0,'2013-07-06 12:44:31',NULL,NULL),(63676,'75859','S','Streetman','D','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.921560,-96.280920,0,'2013-07-06 12:44:34',NULL,NULL),(58641,'68870','S','Gardner','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.784307,-99.160939,0,'2013-07-06 12:44:33',NULL,NULL),(20535,'21104','S','Henryton','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.343680,-76.907220,0,'2013-07-06 12:44:31',NULL,NULL),(19177,'19736','S','Yorklyn','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.802285,-75.665154,0,'2013-07-06 12:44:31',NULL,NULL),(12545,'13040','S','East Freetown','A','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.562547,-75.928525,0,'2013-07-06 12:44:30',NULL,NULL),(62494,'74361','S','Pryor Creek','N','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.298940,-95.310823,0,'2013-07-06 12:44:33',NULL,NULL),(31196,'33938','P','Murdock','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.010988,-82.162362,0,'2013-07-06 12:44:32',NULL,NULL),(22529,'24104','S','Huddleston','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.064524,-79.545301,0,'2013-07-06 12:44:31',NULL,NULL),(44400,'49817','S','Cooks','D','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.910863,-86.524784,0,'2013-07-06 12:44:32',NULL,NULL),(25569,'28428','S','Carolina Bch','A','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.037053,-77.901405,0,'2013-07-06 12:44:31',NULL,NULL),(77760,'97112','S','Beaver','A','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.219748,-123.926658,0,'2013-07-06 12:44:34',NULL,NULL),(73659,'91506','S','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.175519,-118.322799,0,'2013-07-06 12:44:34',NULL,NULL),(73019,'90069','S','W Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091537,-118.382020,0,'2013-07-06 12:44:34',NULL,NULL),(46751,'53928','P','Doylestown','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.429315,-89.149580,0,'2013-07-06 12:44:32',NULL,NULL),(69788,'84062','S','Pleasant Grv','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.384620,-111.736380,0,'2013-07-06 12:44:34',NULL,NULL),(53323,'61745','S','Heyworth','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.318102,-88.971388,0,'2013-07-06 12:44:33',NULL,NULL),(8014,'07723','S','Deal Park','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.247668,-74.001279,0,'2013-07-06 12:44:30',NULL,NULL),(46002,'52531','S','Hiteman','A','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.086920,-92.728800,0,'2013-07-06 12:44:32',NULL,NULL),(69201,'83348','S','Picabo','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.301478,-114.095160,0,'2013-07-06 12:44:34',NULL,NULL),(76036,'95153','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.248008,-121.845139,0,'2013-07-06 12:44:34',NULL,NULL),(43488,'48614','S','Brant','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.246726,-84.294606,0,'2013-07-06 12:44:32',NULL,NULL),(34768,'38863','S','Nixon','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(255,'00638','S','Urb Dos Rios','N','Ciales','72039','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.338774,-66.466418,0,'2013-07-06 12:44:30',NULL,NULL),(12191,'12777','S','Forestburgh','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.565300,-74.605980,0,'2013-07-06 12:44:30',NULL,NULL),(28915,'32145','S','Hastings','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.677524,-81.418611,0,'2013-07-06 12:44:32',NULL,NULL),(67291,'80011','S','Buckley Ang','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741650,-104.791421,0,'2013-07-06 12:44:34',NULL,NULL),(47636,'54915','S','Grand Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.282485,-88.412760,0,'2013-07-06 12:44:33',NULL,NULL),(42702,'47995','S','Wolcott','D','White','18181','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.759453,-87.040583,0,'2013-07-06 12:44:32',NULL,NULL),(59874,'71268','S','Quitman','D','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.363260,-92.650820,0,'2013-07-06 12:44:33',NULL,NULL),(34383,'38618','S','Bowman','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(15053,'15717','S','Blairsville','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.437223,-79.250535,0,'2013-07-06 12:44:31',NULL,NULL),(12284,'12843','S','Johnsburg','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.593550,-73.974572,0,'2013-07-06 12:44:30',NULL,NULL),(16319,'17121','U','State Employment Security','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.314697,-76.874265,0,'2013-07-06 12:44:31',NULL,NULL),(78792,'98315','S','Silverdale','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.697060,-122.722320,0,'2013-07-06 12:44:34',NULL,NULL),(64728,'76882','S','Talpa','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.779442,-99.663049,0,'2013-07-06 12:44:34',NULL,NULL),(25460,'28332','P','Dublin','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.656992,-78.728566,0,'2013-07-06 12:44:31',NULL,NULL),(47983,'55127','S','White Bear Lk','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(41813,'47331','S','Orange','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(26251,'29001','S','Alcolu','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.860717,-80.211061,0,'2013-07-06 12:44:31',NULL,NULL),(66780,'79039','S','Groom','D','Carson','48065','Texas','TX','48','0000','806','Central',-6.0,'Y',35.205874,-101.114366,0,'2013-07-06 12:44:34',NULL,NULL),(57466,'66859','S','Lost Springs','D','Marion','20115','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.566381,-96.986853,0,'2013-07-06 12:44:33',NULL,NULL),(52653,'61064','S','Polo','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.993531,-89.587964,0,'2013-07-06 12:44:33',NULL,NULL),(39544,'44839','S','Mitiwanga','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388818,-82.561774,0,'2013-07-06 12:44:32',NULL,NULL),(40899,'46254','S','Eagle Creek','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.840838,-86.265101,0,'2013-07-06 12:44:32',NULL,NULL),(76279,'95424','P','Clearlake Pk','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.968797,-122.661577,0,'2013-07-06 12:44:34',NULL,NULL),(71782,'87558','P','Querinda Park','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.731350,-105.591316,0,'2013-07-06 12:44:34',NULL,NULL),(60637,'71901','S','Pleasant Hill','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(55808,'64139','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.969393,-94.413070,0,'2013-07-06 12:44:33',NULL,NULL),(53094,'61531','S','Farmington','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.704444,-90.099444,0,'2013-07-06 12:44:33',NULL,NULL),(22100,'23416','S','Oak Hall','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.952374,-75.616004,0,'2013-07-06 12:44:31',NULL,NULL),(18038,'18657','S','Forkston Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(29511,'32768','P','Plymouth','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.697511,-81.555408,0,'2013-07-06 12:44:32',NULL,NULL),(66165,'78520','S','Brownsville','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(64464,'76574','S','Normans Crossing','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(54535,'62882','S','Junction City','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.612584,-89.121037,0,'2013-07-06 12:44:33',NULL,NULL),(51868,'60083','S','Beach Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.429918,-87.932049,0,'2013-07-06 12:44:33',NULL,NULL),(76818,'95955','P','Maxwell','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.276388,-122.132647,0,'2013-07-06 12:44:34',NULL,NULL),(76018,'95129','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.306098,-121.999017,0,'2013-07-06 12:44:34',NULL,NULL),(61410,'72556','S','Melbourne','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.062170,-91.899240,0,'2013-07-06 12:44:33',NULL,NULL),(55613,'63960','S','Acornridge','N','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.952919,-90.157210,0,'2013-07-06 12:44:33',NULL,NULL),(53797,'62286','S','Eden','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.151540,-89.723160,0,'2013-07-06 12:44:33',NULL,NULL),(32653,'36254','P','Choccolocco','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.657930,-85.699195,0,'2013-07-06 12:44:32',NULL,NULL),(2461,'00956','S','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(25732,'28553','S','Marshallberg','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.729019,-76.510873,0,'2013-07-06 12:44:31',NULL,NULL),(38203,'43212','S','Grandview','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(13782,'14166','P','Van Buren Bay','N','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.450113,-79.417318,0,'2013-07-06 12:44:31',NULL,NULL),(74096,'92201','S','Chiriaco Summit','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.707812,-116.231849,0,'2013-07-06 12:44:34',NULL,NULL),(66627,'78799','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.267104,-97.744615,0,'2013-07-06 12:44:34',NULL,NULL),(7284,'06533','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.317731,-72.929215,0,'2013-07-06 12:44:30',NULL,NULL),(20037,'20643','P','Ironsides','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.491426,-77.158284,0,'2013-07-06 12:44:31',NULL,NULL),(6123,'05459','S','East Highgate','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(46641,'53595','U','Dodgeville','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.967480,-90.132036,0,'2013-07-06 12:44:32',NULL,NULL),(17594,'18036','S','Coopersburg','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.515752,-75.396205,0,'2013-07-06 12:44:31',NULL,NULL),(71774,'87557','S','Llano Quemado','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(64333,'76501','S','Zabcikville','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(14228,'14808','S','Atlanta','D','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.552703,-77.480345,0,'2013-07-06 12:44:31',NULL,NULL),(27880,'30452','S','Register','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.319837,-81.877050,0,'2013-07-06 12:44:31',NULL,NULL),(41931,'47386','S','Luray','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.046633,-85.394207,0,'2013-07-06 12:44:32',NULL,NULL),(33764,'37862','S','Sevierville','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.871495,-83.533150,0,'2013-07-06 12:44:32',NULL,NULL),(37778,'42351','S','Lewisport','D','Hancock','21091','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.859038,-86.928438,0,'2013-07-06 12:44:32',NULL,NULL),(63915,'76048','S','Brazos Bend','A','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.431238,-97.762143,0,'2013-07-06 12:44:34',NULL,NULL),(48428,'55613','S','Schroeder','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.690229,-90.961245,0,'2013-07-06 12:44:33',NULL,NULL),(72805,'89713','U','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.160959,-119.765544,0,'2013-07-06 12:44:34',NULL,NULL),(9955,'10158','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(65143,'77386','S','Oak Ridge North','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.131735,-95.416441,0,'2013-07-06 12:44:34',NULL,NULL),(13807,'14210','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.863725,-78.827208,0,'2013-07-06 12:44:31',NULL,NULL),(51470,'59530','S','Inverness','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.625245,-110.686243,0,'2013-07-06 12:44:33',NULL,NULL),(15912,'17016','P','Cornwall Ctr','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.276374,-76.408476,0,'2013-07-06 12:44:31',NULL,NULL),(8766,'08541','U','Princeton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.348381,-74.659016,0,'2013-07-06 12:44:30',NULL,NULL),(4595,'03583','S','Northumberland','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.394373,-71.432883,0,'2013-07-06 12:44:30',NULL,NULL),(27114,'29732','S','Rock Hill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.970453,-81.060985,0,'2013-07-06 12:44:31',NULL,NULL),(20580,'21155','S','Upperco','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.565851,-76.800573,0,'2013-07-06 12:44:31',NULL,NULL),(37864,'42533','S','Ferguson','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.071800,-84.597600,0,'2013-07-06 12:44:32',NULL,NULL),(2097,'00923','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(11481,'12019','S','Malta','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.921720,-73.890600,0,'2013-07-06 12:44:30',NULL,NULL),(51179,'59015','S','Broadview','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',46.197479,-108.913459,0,'2013-07-06 12:44:33',NULL,NULL),(47828,'55068','S','Rosemount','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.746607,-93.077394,0,'2013-07-06 12:44:33',NULL,NULL),(74656,'92841','S','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.781704,-117.976590,0,'2013-07-06 12:44:34',NULL,NULL),(62753,'74848','S','Holdenville','D','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.083745,-96.399050,0,'2013-07-06 12:44:33',NULL,NULL),(34576,'38737','S','Brooks','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(32746,'36331','P','Enterprise','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.326065,-85.854309,0,'2013-07-06 12:44:32',NULL,NULL),(2357,'00949','S','Comunidad Punta Salinas','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(15418,'16361','P','Tylersburg','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.385417,-79.323079,0,'2013-07-06 12:44:31',NULL,NULL),(63370,'75643','S','Gary','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.031808,-94.395253,0,'2013-07-06 12:44:33',NULL,NULL),(22704,'24333','S','Meadowcreek','N','Galax City','51640','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.660590,-80.923683,0,'2013-07-06 12:44:31',NULL,NULL),(78386,'98027','S','Pine Lake','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.533481,-122.068701,0,'2013-07-06 12:44:34',NULL,NULL),(64018,'76118','S','North Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(40680,'46062','S','Noblesville','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.038530,-86.005091,0,'2013-07-06 12:44:32',NULL,NULL),(21760,'23059','S','Glenallen','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.716392,-77.578346,0,'2013-07-06 12:44:31',NULL,NULL),(8078,'07754','P','Neptune','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.201984,-74.033686,0,'2013-07-06 12:44:30',NULL,NULL),(3935,'02466','S','Auburndale','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.345147,-71.247889,0,'2013-07-06 12:44:30',NULL,NULL),(42617,'47903','P','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.417333,-86.855216,0,'2013-07-06 12:44:32',NULL,NULL),(36908,'41135','S','Emerson','D','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.380556,-83.260136,0,'2013-07-06 12:44:32',NULL,NULL),(57912,'67659','S','Penokee','D','Graham','20065','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.392678,-99.928880,0,'2013-07-06 12:44:33',NULL,NULL),(72371,'89031','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.256036,-115.140687,0,'2013-07-06 12:44:34',NULL,NULL),(66874,'79226','S','Clarendon','D','Donley','48129','Texas','TX','48','0000','806','Central',-6.0,'Y',34.936209,-100.888972,0,'2013-07-06 12:44:34',NULL,NULL),(59247,'70438','S','Sheridan','A','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.848512,-90.146024,0,'2013-07-06 12:44:33',NULL,NULL),(52246,'60515','S','Downers Grove','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.807564,-88.019241,0,'2013-07-06 12:44:33',NULL,NULL),(29498,'32752','P','Longwood','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.712149,-81.391509,0,'2013-07-06 12:44:32',NULL,NULL),(7420,'06813','P','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.397769,-73.455230,0,'2013-07-06 12:44:30',NULL,NULL),(16235,'17077','P','Ono','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.404310,-76.534928,0,'2013-07-06 12:44:31',NULL,NULL),(24752,'27533','P','Goldsboro','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.383574,-77.951066,0,'2013-07-06 12:44:31',NULL,NULL),(28789,'32046','S','Hilliard','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.726368,-81.887850,0,'2013-07-06 12:44:32',NULL,NULL),(40793,'46172','S','Barnard','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.847885,-86.799339,0,'2013-07-06 12:44:32',NULL,NULL),(66488,'78670','P','Staples','D','Guadalupe','48187','Texas','TX','48','7240','512/737','Central',-6.0,'Y',29.780717,-97.836673,0,'2013-07-06 12:44:34',NULL,NULL),(48841,'56055','S','Lake Crystal','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.114990,-94.215898,0,'2013-07-06 12:44:33',NULL,NULL),(4352,'03048','S','Mason','A','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.745620,-71.782200,0,'2013-07-06 12:44:30',NULL,NULL),(42754,'48027','S','Wales Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.981737,-82.660493,0,'2013-07-06 12:44:32',NULL,NULL),(24605,'27330','S','Osgood','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(47241,'54511','S','Newald','A','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.724974,-88.860373,0,'2013-07-06 12:44:32',NULL,NULL),(17919,'18460','S','South Sterling','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.274485,-75.396065,0,'2013-07-06 12:44:31',NULL,NULL),(8924,'08750','S','Sea Girt','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.134492,-74.045049,0,'2013-07-06 12:44:30',NULL,NULL),(17328,'17864','S','Dundore','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(58565,'68825','S','Elim','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(64504,'76632','S','Chilton','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.300172,-97.109830,0,'2013-07-06 12:44:34',NULL,NULL),(48751,'55972','S','Saratoga','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.967246,-92.063039,0,'2013-07-06 12:44:33',NULL,NULL),(2152,'00924','S','Villa Rosales','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(22779,'24450','S','East Lexington','N','Lexington City','51678','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.779731,-79.444573,0,'2013-07-06 12:44:31',NULL,NULL),(78112,'97498','S','Yachats','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.321470,-124.089215,0,'2013-07-06 12:44:34',NULL,NULL),(56776,'65745','S','Seligman','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.526601,-93.938072,0,'2013-07-06 12:44:33',NULL,NULL),(56686,'65647','S','Exeter','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.670764,-93.933797,0,'2013-07-06 12:44:33',NULL,NULL),(4976,'04109','S','Little Diamond Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(7958,'07676','S','Washington Twps','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(20710,'21273','U','Bank of America','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.287419,-76.611265,0,'2013-07-06 12:44:31',NULL,NULL),(24318,'27020','S','Cycle','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(38316,'43403','U','Bowling Green St University','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.376437,-83.650803,0,'2013-07-06 12:44:32',NULL,NULL),(3883,'02370','S','Rockland','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.131755,-70.907783,0,'2013-07-06 12:44:30',NULL,NULL),(80178,'99836','P','Prt Alexander','A','Sitka','02220','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.039187,-132.563950,0,'2013-07-06 12:44:34',NULL,NULL),(72005,'88039','S','Pleasanton','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.327720,-108.813300,0,'2013-07-06 12:44:34',NULL,NULL),(78879,'98356','S','Lindberg','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.560848,-122.287340,0,'2013-07-06 12:44:34',NULL,NULL),(75858,'94940','S','Marshall','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.198063,-122.891072,0,'2013-07-06 12:44:34',NULL,NULL),(75031,'93512','S','Benton','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.810000,-118.470000,0,'2013-07-06 12:44:34',NULL,NULL),(54864,'63049','S','High Ridge','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.470505,-90.523777,0,'2013-07-06 12:44:33',NULL,NULL),(64690,'76842','S','Fredonia','D','Mason','48319','Texas','TX','48','0000','325','Central',-6.0,'Y',30.914652,-99.138440,0,'2013-07-06 12:44:34',NULL,NULL),(29095,'32266','S','Jacksonville','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.315188,-81.404431,0,'2013-07-06 12:44:32',NULL,NULL),(53317,'61741','S','Pleasant Ridge','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.751704,-88.412200,0,'2013-07-06 12:44:33',NULL,NULL),(26939,'29596','S','Wallace','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.728935,-79.862910,0,'2013-07-06 12:44:31',NULL,NULL),(27625,'30310','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.725127,-84.422754,0,'2013-07-06 12:44:31',NULL,NULL),(5172,'04430','S','E Millinocket','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.626046,-68.571668,0,'2013-07-06 12:44:30',NULL,NULL),(12121,'12592','S','Wassaic','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.781980,-73.545429,0,'2013-07-06 12:44:30',NULL,NULL),(42698,'47993','S','Marshfield','A','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.300200,-87.317520,0,'2013-07-06 12:44:32',NULL,NULL),(47837,'55072','S','Groningen','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.126511,-92.866999,0,'2013-07-06 12:44:33',NULL,NULL),(77471,'96818','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353640,-157.931659,0,'2013-07-06 12:44:34',NULL,NULL),(70220,'84403','S','Uintah','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.178180,-111.963540,0,'2013-07-06 12:44:34',NULL,NULL),(33011,'36685','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.690171,-88.297518,0,'2013-07-06 12:44:32',NULL,NULL),(30054,'33146','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(16622,'17331','S','Park Hills','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(36777,'41043','S','Wellsburg','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(70571,'85063','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.502937,-112.171819,0,'2013-07-06 12:44:34',NULL,NULL),(55762,'64116','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(39917,'45219','S','Mt Auburn','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.126100,-84.517318,0,'2013-07-06 12:44:32',NULL,NULL),(14342,'15009','S','West Bridgewater','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.702800,-80.355660,0,'2013-07-06 12:44:31',NULL,NULL),(10981,'11545','S','Muttontown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(64277,'76431','S','Chico','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.345712,-97.814572,0,'2013-07-06 12:44:34',NULL,NULL),(2709,'00969','S','Mans de Santa Paula','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(35858,'39827','S','Cario','N','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.876043,-84.206528,0,'2013-07-06 12:44:32',NULL,NULL),(65730,'78043','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.491910,-99.471710,0,'2013-07-06 12:44:34',NULL,NULL),(60851,'72044','S','Edgemont','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.645789,-92.190482,0,'2013-07-06 12:44:33',NULL,NULL),(60115,'71367','S','Saint Landry','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.850864,-92.412602,0,'2013-07-06 12:44:33',NULL,NULL),(24709,'27499','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.070576,-79.766148,0,'2013-07-06 12:44:31',NULL,NULL),(30247,'33197','P','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.595047,-80.363125,0,'2013-07-06 12:44:32',NULL,NULL),(30416,'33326','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(31049,'33827','S','Babson Park','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.830226,-81.534299,0,'2013-07-06 12:44:32',NULL,NULL),(4962,'04106','S','South Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.620751,-70.291117,0,'2013-07-06 12:44:30',NULL,NULL),(57373,'66743','S','Girard','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(40049,'45262','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.122089,-84.544130,0,'2013-07-06 12:44:32',NULL,NULL),(15299,'16141','S','New Galilee','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.832918,-80.398275,0,'2013-07-06 12:44:31',NULL,NULL),(58300,'68424','S','Plymouth','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.303913,-96.989490,0,'2013-07-06 12:44:33',NULL,NULL),(28696,'31814','P','Louvale','D','Stewart','13259','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.145716,-84.901377,0,'2013-07-06 12:44:32',NULL,NULL),(72103,'88230','S','Dexter','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.226907,-104.407794,0,'2013-07-06 12:44:34',NULL,NULL),(27944,'30536','S','Ellijay','D','Gilmer','13123','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.694722,-84.482222,0,'2013-07-06 12:44:31',NULL,NULL),(27568,'30268','S','Chatt Hills','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.533450,-84.690866,0,'2013-07-06 12:44:31',NULL,NULL),(33682,'37743','S','Tusculum Coll','A','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.162752,-82.818898,0,'2013-07-06 12:44:32',NULL,NULL),(37796,'42374','P','S Carrollton','A','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.335929,-87.142259,0,'2013-07-06 12:44:32',NULL,NULL),(44961,'50396','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587997,-93.609801,0,'2013-07-06 12:44:32',NULL,NULL),(75235,'93647','S','Orosi','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.548019,-119.262283,0,'2013-07-06 12:44:34',NULL,NULL),(58239,'68354','S','Burress','N','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.632986,-97.584084,0,'2013-07-06 12:44:33',NULL,NULL),(24642,'27373','P','Wallburg','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.012769,-80.139199,0,'2013-07-06 12:44:31',NULL,NULL),(712,'00687','S','Jard De Romany','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(45972,'52403','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.982434,-91.607252,0,'2013-07-06 12:44:32',NULL,NULL),(63682,'75860','S','Teague','D','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.624665,-96.281615,0,'2013-07-06 12:44:34',NULL,NULL),(63184,'75416','S','Blossom','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.647332,-95.419532,0,'2013-07-06 12:44:33',NULL,NULL),(10590,'11024','S','Kings Point','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.804080,-73.740120,0,'2013-07-06 12:44:30',NULL,NULL),(28427,'31331','S','Ridgeville','N','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(3926,'02462','S','Newton L F','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.331200,-71.258208,0,'2013-07-06 12:44:30',NULL,NULL),(12336,'12871','S','Quaker Springs','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.088460,-73.622760,0,'2013-07-06 12:44:30',NULL,NULL),(44078,'49450','S','Pullman','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.480878,-86.077307,0,'2013-07-06 12:44:32',NULL,NULL),(899,'00705','S','Brisas de Aibonito','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(75742,'94606','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.791270,-122.243159,0,'2013-07-06 12:44:34',NULL,NULL),(7424,'06816','U','Grolier Entrprz Inc','N','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.410366,-73.406983,0,'2013-07-06 12:44:30',NULL,NULL),(22140,'23453','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.774472,-76.075562,0,'2013-07-06 12:44:31',NULL,NULL),(29828,'33029','S','Miramar','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.006742,-80.428893,0,'2013-07-06 12:44:32',NULL,NULL),(45380,'51022','S','Granville','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.983744,-95.903558,0,'2013-07-06 12:44:32',NULL,NULL),(54352,'62786','U','Il Dept Reg and Educ','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803138,-89.658075,0,'2013-07-06 12:44:33',NULL,NULL),(1062,'00725','S','Ext El Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(41169,'46705','S','Ashley','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.514265,-85.072002,0,'2013-07-06 12:44:32',NULL,NULL),(77264,'96595','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(70744,'85311','P','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.533405,-112.179559,0,'2013-07-06 12:44:34',NULL,NULL),(67348,'80110','S','Cherry Hills','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(43863,'49117','S','New Buffalo','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.786972,-86.754132,0,'2013-07-06 12:44:32',NULL,NULL),(85,'00612','S','Parq de Jardines','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(79009,'98388','S','Ketron Is','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.170637,-122.588055,0,'2013-07-06 12:44:34',NULL,NULL),(52433,'60656','S','Harwood Heights','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.975199,-87.825937,0,'2013-07-06 12:44:33',NULL,NULL),(48785,'56001','S','Mankato','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.160927,-93.995246,0,'2013-07-06 12:44:33',NULL,NULL),(30788,'33597','S','Webster','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.582156,-82.172936,0,'2013-07-06 12:44:32',NULL,NULL),(11850,'12252','U','NY State Lottery','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.648263,-73.761928,0,'2013-07-06 12:44:30',NULL,NULL),(13168,'13608','S','Oxbow','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.198498,-75.607636,0,'2013-07-06 12:44:30',NULL,NULL),(22123,'23437','S','Holland','N','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.627139,-76.791066,0,'2013-07-06 12:44:31',NULL,NULL),(70323,'84624','S','Sugarville','A','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(51319,'59252','S','Outlook','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.896471,-104.739387,0,'2013-07-06 12:44:33',NULL,NULL),(62265,'74010','S','Tuskegee','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.831459,-96.387712,0,'2013-07-06 12:44:33',NULL,NULL),(19434,'20105','S','Stone Ridge','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.954967,-77.598321,0,'2013-07-06 12:44:31',NULL,NULL),(31937,'35186','S','Wilsonville','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.239586,-86.517708,0,'2013-07-06 12:44:32',NULL,NULL),(59940,'71295','S','Winnsboro','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.158360,-91.723430,0,'2013-07-06 12:44:33',NULL,NULL),(22727,'24363','S','Mouth Wilson','A','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.612187,-81.384826,0,'2013-07-06 12:44:31',NULL,NULL),(29068,'32250','S','Jacksonville','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.281220,-81.416820,0,'2013-07-06 12:44:32',NULL,NULL),(71124,'86020','P','Cedar Ridge','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',35.848183,-111.431257,0,'2013-07-06 12:44:34',NULL,NULL),(19234,'19904','S','Dover','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.159797,-75.526960,0,'2013-07-06 12:44:31',NULL,NULL),(8005,'07719','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(26080,'28704','S','Oak Park','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.473046,-82.519301,0,'2013-07-06 12:44:31',NULL,NULL),(67973,'80914','P','Peterson AFB','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(51251,'59077','S','Sand Springs','D','Garfield','30033','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.013392,-107.275528,0,'2013-07-06 12:44:33',NULL,NULL),(50767,'58421','S','Dover','N','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(29003,'32221','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.291357,-81.811864,0,'2013-07-06 12:44:32',NULL,NULL),(69661,'84015','S','Clearfield','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(57460,'66855','S','Madison','A','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.116882,-96.022522,0,'2013-07-06 12:44:33',NULL,NULL),(51296,'59218','S','McCabe','A','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.143909,-104.518570,0,'2013-07-06 12:44:33',NULL,NULL),(2494,'00956','S','Villas de Santa Juanita','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(20877,'21677','S','Madison','N','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.512230,-76.187230,0,'2013-07-06 12:44:31',NULL,NULL),(41429,'46852','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069242,-85.168962,0,'2013-07-06 12:44:32',NULL,NULL),(4082,'02663','P','S Wellfleet','A','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.742515,-70.060551,0,'2013-07-06 12:44:30',NULL,NULL),(17755,'18326','S','Paradise Vly','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.160326,-75.252633,0,'2013-07-06 12:44:31',NULL,NULL),(28293,'31098','S','Robins A F B','A','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.611973,-83.596726,0,'2013-07-06 12:44:31',NULL,NULL),(78018,'97420','S','Charleston','A','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.332900,-124.233900,0,'2013-07-06 12:44:34',NULL,NULL),(50811,'58458','S','La Moure','N','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.397400,-98.283240,0,'2013-07-06 12:44:33',NULL,NULL),(15455,'16411','S','E Springfield','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.983870,-80.436629,0,'2013-07-06 12:44:31',NULL,NULL),(5383,'04642','S','Harborside','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.338181,-68.797521,0,'2013-07-06 12:44:30',NULL,NULL),(35399,'39461','S','Neely','D','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.186218,-88.736886,0,'2013-07-06 12:44:32',NULL,NULL),(11241,'11757','S','N Lindenhurst','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.688951,-73.376317,0,'2013-07-06 12:44:30',NULL,NULL),(73311,'90810','S','Cabrillo','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.817980,-118.223280,0,'2013-07-06 12:44:34',NULL,NULL),(15251,'16053','S','Renfrew','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.813319,-79.980066,0,'2013-07-06 12:44:31',NULL,NULL),(10400,'10604','S','Westchester County Airport','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.035020,-73.743600,0,'2013-07-06 12:44:30',NULL,NULL),(4110,'02715','S','Dighton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.819013,-71.135314,0,'2013-07-06 12:44:30',NULL,NULL),(25015,'27882','S','Spring Hope','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.938033,-78.119372,0,'2013-07-06 12:44:31',NULL,NULL),(25068,'27938','S','Gatesville','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.391635,-76.720068,0,'2013-07-06 12:44:31',NULL,NULL),(76555,'95667','S','Gold Hill','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(75625,'94507','S','Alamo','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.852539,-122.019112,0,'2013-07-06 12:44:34',NULL,NULL),(68914,'82836','S','Dayton','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.878388,-107.258812,0,'2013-07-06 12:44:34',NULL,NULL),(67758,'80624','S','Gill','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.475625,-104.525590,0,'2013-07-06 12:44:34',NULL,NULL),(56704,'65667','S','Hartville','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.295466,-92.507359,0,'2013-07-06 12:44:33',NULL,NULL),(30323,'33307','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181193,-80.277948,0,'2013-07-06 12:44:32',NULL,NULL),(48910,'56134','S','Hardwick','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.776007,-96.201761,0,'2013-07-06 12:44:33',NULL,NULL),(67221,'79925','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.779280,-106.365646,0,'2013-07-06 12:44:34',NULL,NULL),(41833,'47344','P','Greensboro','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.876621,-85.461392,0,'2013-07-06 12:44:32',NULL,NULL),(73962,'92067','P','Rcho Santa Fe','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.011798,-117.201867,0,'2013-07-06 12:44:34',NULL,NULL),(73046,'90084','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.056524,-118.265252,0,'2013-07-06 12:44:34',NULL,NULL),(38065,'43061','S','Ostrander','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.285125,-83.202729,0,'2013-07-06 12:44:32',NULL,NULL),(43224,'48311','P','St Heights','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.578334,-83.028442,0,'2013-07-06 12:44:32',NULL,NULL),(14179,'14743','S','Ischua','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.201120,-78.409800,0,'2013-07-06 12:44:31',NULL,NULL),(50655,'58325','S','Churchs Ferry','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.317148,-99.084451,0,'2013-07-06 12:44:33',NULL,NULL),(11065,'11581','S','North Woodmere','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655430,-73.712757,0,'2013-07-06 12:44:30',NULL,NULL),(16697,'17402','S','Glades','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(5652,'04956','S','New Vineyard','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.808206,-70.113262,0,'2013-07-06 12:44:30',NULL,NULL),(71093,'85936','S','Richville','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.506335,-109.378069,0,'2013-07-06 12:44:34',NULL,NULL),(50152,'57544','S','Houston','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.891020,-99.847320,0,'2013-07-06 12:44:33',NULL,NULL),(49313,'56543','S','Foxhome','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.255126,-96.324827,0,'2013-07-06 12:44:33',NULL,NULL),(8268,'08009','S','Berlin','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.759420,-74.927340,0,'2013-07-06 12:44:30',NULL,NULL),(4001,'02542','S','Otis ANG','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.658720,-70.567260,0,'2013-07-06 12:44:30',NULL,NULL),(16228,'17074','S','Saville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(2738,'00969','S','Urb Los Frailes Sur','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(78685,'98247','S','Van Buren','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.906641,-122.329968,0,'2013-07-06 12:44:34',NULL,NULL),(74041,'92143','P','San Diego','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.567534,-116.974021,0,'2013-07-06 12:44:34',NULL,NULL),(37283,'41605','S','Justell','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.542142,-82.692771,0,'2013-07-06 12:44:32',NULL,NULL),(40287,'45440','S','Beaver Creek','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(53686,'62223','S','Swansea','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.535955,-90.002379,0,'2013-07-06 12:44:33',NULL,NULL),(27775,'30370','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.752250,-84.388990,0,'2013-07-06 12:44:31',NULL,NULL),(37944,'42713','S','Bonnieville','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.375384,-85.889297,0,'2013-07-06 12:44:32',NULL,NULL),(40386,'45661','S','Elm Grove','N','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.037860,-83.101200,0,'2013-07-06 12:44:32',NULL,NULL),(66113,'78415','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.733183,-97.414174,0,'2013-07-06 12:44:34',NULL,NULL),(16373,'17201','S','Red Bridge','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(28952,'32192','P','Sparr','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.341432,-82.091915,0,'2013-07-06 12:44:32',NULL,NULL),(70650,'85191','P','Valley Farms','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.988404,-111.449661,0,'2013-07-06 12:44:34',NULL,NULL),(63990,'76111','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779783,-97.302729,0,'2013-07-06 12:44:34',NULL,NULL),(42187,'47542','S','Johnsburg','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.297169,-86.956690,0,'2013-07-06 12:44:32',NULL,NULL),(45602,'51557','S','Mondamin','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.710092,-96.024526,0,'2013-07-06 12:44:32',NULL,NULL),(8066,'07748','S','New Monmouth','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.395074,-74.109292,0,'2013-07-06 12:44:30',NULL,NULL),(63193,'75426','S','Clarksville','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.610301,-95.049800,0,'2013-07-06 12:44:33',NULL,NULL),(62681,'74721','P','Albany','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.879118,-96.163390,0,'2013-07-06 12:44:33',NULL,NULL),(11796,'12223','S','Empire State Plaza','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651781,-73.757949,0,'2013-07-06 12:44:30',NULL,NULL),(33860,'38004','S','Crosstown','N','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.433070,-89.796386,0,'2013-07-06 12:44:32',NULL,NULL),(12544,'13040','S','E Freetwn','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.562547,-75.928525,0,'2013-07-06 12:44:30',NULL,NULL),(42373,'47711','S','McCutchanville','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(47769,'55038','S','Columbus','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.163580,-92.956430,0,'2013-07-06 12:44:33',NULL,NULL),(43843,'49099','S','White Pigeon','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.793351,-85.661168,0,'2013-07-06 12:44:32',NULL,NULL),(65247,'77459','S','Sienna Plantation','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.525902,-95.531735,0,'2013-07-06 12:44:34',NULL,NULL),(64541,'76645','S','Woodbury','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(58902,'69211','S','Cody','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.935880,-101.253460,0,'2013-07-06 12:44:33',NULL,NULL),(72154,'88325','P','High Rolls Mountain Park','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.076011,-106.025093,0,'2013-07-06 12:44:34',NULL,NULL),(11561,'12061','S','East Greenbush','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.595189,-73.693628,0,'2013-07-06 12:44:30',NULL,NULL),(18585,'19133','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.992137,-75.143289,0,'2013-07-06 12:44:31',NULL,NULL),(54510,'62869','S','Norris City','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.977903,-88.328317,0,'2013-07-06 12:44:33',NULL,NULL),(39299,'44504','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.122820,-80.656988,0,'2013-07-06 12:44:32',NULL,NULL),(28218,'31034','P','Hardwick','D','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.053908,-83.230381,0,'2013-07-06 12:44:31',NULL,NULL),(18362,'19038','S','North Hills','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(73796,'91748','S','Rowland Hgts','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(64236,'76309','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.893069,-98.535802,0,'2013-07-06 12:44:34',NULL,NULL),(59887,'71270','S','Ruston','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(68501,'81321','S','Cortez','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.347000,-108.736320,0,'2013-07-06 12:44:34',NULL,NULL),(19658,'20306','U','Armed Forces Inst Pathology','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.974169,-77.033759,0,'2013-07-06 12:44:31',NULL,NULL),(10411,'10704','S','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.919089,-73.861638,0,'2013-07-06 12:44:30',NULL,NULL),(35148,'39225','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291456,-90.183510,0,'2013-07-06 12:44:32',NULL,NULL),(56199,'65023','S','Centertown','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.612674,-92.385139,0,'2013-07-06 12:44:33',NULL,NULL),(50339,'57735','S','Lauzen','N','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(27889,'30460','U','Statesboro','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.444047,-81.745328,0,'2013-07-06 12:44:31',NULL,NULL),(51439,'59466','S','Oilmont','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.754167,-111.774167,0,'2013-07-06 12:44:33',NULL,NULL),(5458,'04732','S','Nashville Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.626925,-68.418941,0,'2013-07-06 12:44:30',NULL,NULL),(39856,'45172','P','Sinking Spg','A','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.055787,-83.352014,0,'2013-07-06 12:44:32',NULL,NULL),(47343,'54601','S','La Crosse','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.795836,-91.221089,0,'2013-07-06 12:44:32',NULL,NULL),(69358,'83548','S','Reubens','D','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.344720,-116.541900,0,'2013-07-06 12:44:34',NULL,NULL),(60508,'71666','P','Duce','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.659552,-91.194003,0,'2013-07-06 12:44:33',NULL,NULL),(59743,'71137','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.592995,-93.854112,0,'2013-07-06 12:44:33',NULL,NULL),(76931,'96017','S','Sweet Brier','N','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',41.141859,-122.318402,0,'2013-07-06 12:44:34',NULL,NULL),(74147,'92256','S','Morongo Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.080121,-116.552087,0,'2013-07-06 12:44:34',NULL,NULL),(46966,'54208','S','Denmark','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.368075,-87.854079,0,'2013-07-06 12:44:32',NULL,NULL),(17356,'17872','S','Dunkelbergers','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(67360,'80111','S','Greenwood Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(913,'00707','S','Brisas de Emajaguas','N','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(49569,'56723','S','Fisher','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.800325,-96.797924,0,'2013-07-06 12:44:33',NULL,NULL),(62413,'74130','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.239610,-95.954496,0,'2013-07-06 12:44:33',NULL,NULL),(33266,'37095','S','Gassaway','A','DeKalb','47041','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.006120,-85.970822,0,'2013-07-06 12:44:32',NULL,NULL),(42164,'47523','S','Selvin','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.173260,-86.999460,0,'2013-07-06 12:44:32',NULL,NULL),(21485,'22649','S','Reliance','A','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.005182,-78.258327,0,'2013-07-06 12:44:31',NULL,NULL),(43676,'48866','S','Ovid','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.005897,-84.399452,0,'2013-07-06 12:44:32',NULL,NULL),(76532,'95654','P','Martell','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.366807,-120.794619,0,'2013-07-06 12:44:34',NULL,NULL),(7792,'07428','P','McAfee','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.185381,-74.551549,0,'2013-07-06 12:44:30',NULL,NULL),(24894,'27708','U','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.997189,-78.938612,0,'2013-07-06 12:44:31',NULL,NULL),(74134,'92243','S','El Centro','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.784553,-115.571017,0,'2013-07-06 12:44:34',NULL,NULL),(28046,'30662','S','Royston','D','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.287277,-83.116360,0,'2013-07-06 12:44:31',NULL,NULL),(5719,'05001','S','Lyman','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.662310,-72.359191,0,'2013-07-06 12:44:30',NULL,NULL),(78228,'97810','S','Adams','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.768850,-118.559394,0,'2013-07-06 12:44:34',NULL,NULL),(74324,'92398','P','Yermo','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.909791,-116.809901,0,'2013-07-06 12:44:34',NULL,NULL),(73170,'90306','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.960821,-118.350130,0,'2013-07-06 12:44:34',NULL,NULL),(33287,'37121','P','Mt Juliet','N','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.205060,-86.520664,0,'2013-07-06 12:44:32',NULL,NULL),(41187,'46714','S','Vera Cruz','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(76008,'95119','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.230749,-121.786095,0,'2013-07-06 12:44:34',NULL,NULL),(15806,'16927','S','Harrison Twp','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.951385,-77.702976,0,'2013-07-06 12:44:31',NULL,NULL),(78881,'98357','P','Cape Flattery','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.369349,-124.626924,0,'2013-07-06 12:44:34',NULL,NULL),(76067,'95204','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.973809,-121.317740,0,'2013-07-06 12:44:34',NULL,NULL),(23085,'24910','S','Alderson','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.732200,-80.660640,0,'2013-07-06 12:44:31',NULL,NULL),(3415,'01719','S','Acton','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.484999,-71.518519,0,'2013-07-06 12:44:30',NULL,NULL),(2476,'00956','S','Urb Bayamon Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(25903,'28645','S','Cajahs Mountain','A','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(10130,'10261','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(13128,'13491','S','West Exeter','A','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(70533,'85017','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.510589,-112.122065,0,'2013-07-06 12:44:34',NULL,NULL),(56721,'65688','P','Brandsville','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.578766,-91.730231,0,'2013-07-06 12:44:33',NULL,NULL),(28855,'32097','S','Yulee','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.661181,-81.638360,0,'2013-07-06 12:44:32',NULL,NULL),(18975,'19519','P','Athol','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.314999,-75.738387,0,'2013-07-06 12:44:31',NULL,NULL),(40200,'45385','S','Sugarcrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.691445,-83.953106,0,'2013-07-06 12:44:32',NULL,NULL),(2434,'00953','S','Urb Monte Lago Est','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(16890,'17578','S','Stevens','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.241389,-76.174444,0,'2013-07-06 12:44:31',NULL,NULL),(23296,'25181','S','Prenter','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.089680,-81.643862,0,'2013-07-06 12:44:31',NULL,NULL),(1611,'00769','S','Urb Vistamar','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(49058,'56304','S','Saint Cloud','D','Sherburne','27141','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.527177,-94.067207,0,'2013-07-06 12:44:33',NULL,NULL),(70723,'85287','U','ASU','N','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.428352,-111.932123,0,'2013-07-06 12:44:34',NULL,NULL),(57683,'67227','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.583944,-97.448223,0,'2013-07-06 12:44:33',NULL,NULL),(56201,'65024','S','Freedom','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.664240,-91.769160,0,'2013-07-06 12:44:33',NULL,NULL),(10714,'11241','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.696629,-73.993851,0,'2013-07-06 12:44:30',NULL,NULL),(75917,'95007','P','Brookdale','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.107721,-122.109557,0,'2013-07-06 12:44:34',NULL,NULL),(69275,'83440','S','Edmonds','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(67773,'80645','S','Evans','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.336011,-104.686585,0,'2013-07-06 12:44:34',NULL,NULL),(62032,'73501','S','Lawton','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.611240,-98.395990,0,'2013-07-06 12:44:33',NULL,NULL),(1554,'00765','S','Urb Lucila Franco','N','Vieques','72147','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.123576,-65.438423,0,'2013-07-06 12:44:30',NULL,NULL),(13668,'14032','S','Clarence Ctr','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.045445,-78.631521,0,'2013-07-06 12:44:31',NULL,NULL),(209,'00623','S','Villas De Plan Bonito','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(31747,'34987','S','Saint Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308771,-80.453062,0,'2013-07-06 12:44:32',NULL,NULL),(45479,'51341','P','Gillett Grove','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.037826,-95.032004,0,'2013-07-06 12:44:32',NULL,NULL),(64587,'76671','S','Morgan','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.020833,-97.493611,0,'2013-07-06 12:44:34',NULL,NULL),(34682,'38825','P','Becker','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.987917,-88.470181,0,'2013-07-06 12:44:32',NULL,NULL),(39717,'45052','S','North Bend','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.141720,-84.756600,0,'2013-07-06 12:44:32',NULL,NULL),(32866,'36521','S','Fellowship','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.974220,-88.126860,0,'2013-07-06 12:44:32',NULL,NULL),(18770,'19355','S','Malvern','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041360,-75.537060,0,'2013-07-06 12:44:31',NULL,NULL),(57602,'67110','S','Mulvane','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.488321,-97.249776,0,'2013-07-06 12:44:33',NULL,NULL),(937,'00715','S','Central Mercedita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(21892,'23181','S','Eltham','N','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.556161,-76.810679,0,'2013-07-06 12:44:31',NULL,NULL),(32436,'35989','S','Valley Head','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.504625,-85.681555,0,'2013-07-06 12:44:32',NULL,NULL),(27334,'30036','P','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.774347,-84.291903,0,'2013-07-06 12:44:31',NULL,NULL),(23395,'25315','S','Chesapeake','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.235874,-81.555983,0,'2013-07-06 12:44:31',NULL,NULL),(36042,'40205','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(18588,'19134','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.994605,-75.113258,0,'2013-07-06 12:44:31',NULL,NULL),(44827,'50250','S','Howe','N','Guthrie','19077','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.502010,-94.316481,0,'2013-07-06 12:44:32',NULL,NULL),(10073,'10185','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(15897,'17009','S','Burnham','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.636910,-77.568491,0,'2013-07-06 12:44:31',NULL,NULL),(77187,'96328','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69670,'84017','S','Wanship','A','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.804680,-111.296340,0,'2013-07-06 12:44:34',NULL,NULL),(51779,'60041','S','Stanton Point','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.357735,-88.163789,0,'2013-07-06 12:44:33',NULL,NULL),(34403,'38626','S','Dundee','D','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.534380,-90.396000,0,'2013-07-06 12:44:32',NULL,NULL),(50634,'58277','S','Sharon','D','Steele','38091','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.632977,-97.921048,0,'2013-07-06 12:44:33',NULL,NULL),(42584,'47882','S','Lake Sullivan','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.098637,-87.402599,0,'2013-07-06 12:44:32',NULL,NULL),(71885,'87734','S','Ocate','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.018378,-105.001748,0,'2013-07-06 12:44:34',NULL,NULL),(71905,'87753','P','Watrous','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.014894,-105.000961,0,'2013-07-06 12:44:34',NULL,NULL),(61226,'72327','S','Crawfordsville','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.207580,-90.343980,0,'2013-07-06 12:44:33',NULL,NULL),(59709,'71105','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.454589,-93.712715,0,'2013-07-06 12:44:33',NULL,NULL),(11894,'12345','U','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.815656,-73.942324,0,'2013-07-06 12:44:30',NULL,NULL),(8911,'08738','S','Mantoloking','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.019646,-74.059485,0,'2013-07-06 12:44:30',NULL,NULL),(26469,'29150','S','Frens','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(30454,'33334','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181067,-80.138938,0,'2013-07-06 12:44:32',NULL,NULL),(72800,'89706','S','Mound House','A','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.186004,-119.745390,0,'2013-07-06 12:44:34',NULL,NULL),(20450,'21014','S','Bel Air','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.536791,-76.357326,0,'2013-07-06 12:44:31',NULL,NULL),(5336,'04605','S','Fletchers Landing Twp','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(69785,'84062','S','Cedar Hills','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.384620,-111.736380,0,'2013-07-06 12:44:34',NULL,NULL),(8503,'08097','S','Woodbury Hts','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.831240,-75.151020,0,'2013-07-06 12:44:30',NULL,NULL),(72984,'90053','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.055647,-118.240465,0,'2013-07-06 12:44:34',NULL,NULL),(4502,'03287','S','Wilmot','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.443972,-71.912264,0,'2013-07-06 12:44:30',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (41401,'46808','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.101060,-85.170092,0,'2013-07-06 12:44:32',NULL,NULL),(75862,'94941','S','Tamalpais Valley','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.890300,-122.567640,0,'2013-07-06 12:44:34',NULL,NULL),(60004,'71334','S','Delta Garden','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(39287,'44486','U','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.300597,-80.844183,0,'2013-07-06 12:44:32',NULL,NULL),(44419,'49835','S','Garden','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.736897,-86.591583,0,'2013-07-06 12:44:32',NULL,NULL),(10703,'11229','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.598356,-73.939325,0,'2013-07-06 12:44:30',NULL,NULL),(10676,'11201','S','Brooklyn Hgts','A','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.695472,-73.992723,0,'2013-07-06 12:44:30',NULL,NULL),(52570,'60962','S','Roberts','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.615108,-88.180646,0,'2013-07-06 12:44:33',NULL,NULL),(39303,'44509','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.105989,-80.695488,0,'2013-07-06 12:44:32',NULL,NULL),(58392,'68622','S','Bartlett','D','Wheeler','31183','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.863327,-98.544854,0,'2013-07-06 12:44:33',NULL,NULL),(53588,'62069','S','Mt Olive','N','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.072236,-89.724462,0,'2013-07-06 12:44:33',NULL,NULL),(33996,'38118','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.048583,-89.925961,0,'2013-07-06 12:44:32',NULL,NULL),(29017,'32227','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(35687,'39661','S','Leesdale','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(2353,'00949','S','Bo Campanilla','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(79151,'98503','S','Lacey','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.026260,-122.795460,0,'2013-07-06 12:44:34',NULL,NULL),(63438,'75669','S','Long Branch','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.072778,-94.567778,0,'2013-07-06 12:44:33',NULL,NULL),(20931,'21754','S','Ijamsville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.333698,-77.300785,0,'2013-07-06 12:44:31',NULL,NULL),(63243,'75477','S','Roxton','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.545748,-95.724221,0,'2013-07-06 12:44:33',NULL,NULL),(25436,'28308','S','Pope Army AF','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.052500,-78.878611,0,'2013-07-06 12:44:31',NULL,NULL),(69138,'83301','S','Twin Falls','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.447360,-114.538200,0,'2013-07-06 12:44:34',NULL,NULL),(68559,'81434','S','Bear Mine','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.963810,-107.296606,0,'2013-07-06 12:44:34',NULL,NULL),(3028,'01092','P','West Warren','D','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.212500,-72.191667,0,'2013-07-06 12:44:30',NULL,NULL),(52437,'60657','S','Graceland','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.940734,-87.654198,0,'2013-07-06 12:44:33',NULL,NULL),(42516,'47850','S','Farmersburg','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.251872,-87.378230,0,'2013-07-06 12:44:32',NULL,NULL),(29754,'33001','P','Fiesta Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.816667,-80.816667,0,'2013-07-06 12:44:32',NULL,NULL),(23048,'24867','P','New Richmond','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.546054,-81.472850,0,'2013-07-06 12:44:31',NULL,NULL),(79948,'99627','P','McGrath','N','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.912644,-154.944297,0,'2013-07-06 12:44:34',NULL,NULL),(73528,'91350','S','Green Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(49687,'57021','S','Davis','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.289557,-96.986298,0,'2013-07-06 12:44:33',NULL,NULL),(8950,'08759','S','Manchester','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.952064,-74.365653,0,'2013-07-06 12:44:30',NULL,NULL),(5298,'04548','S','Mac Mahan','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.806783,-69.763606,0,'2013-07-06 12:44:30',NULL,NULL),(7793,'07430','S','Mahwah','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.074187,-74.153515,0,'2013-07-06 12:44:30',NULL,NULL),(9550,'10022','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(27127,'29803','S','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.504406,-81.724533,0,'2013-07-06 12:44:31',NULL,NULL),(17186,'17820','S','Locust','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(36833,'41071','S','Woodlawn','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(46666,'53714','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.099135,-89.312700,0,'2013-07-06 12:44:32',NULL,NULL),(63303,'75563','S','Lanier','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.009734,-94.366056,0,'2013-07-06 12:44:33',NULL,NULL),(59555,'70825','S','One American Place','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.427794,-91.021838,0,'2013-07-06 12:44:33',NULL,NULL),(54242,'62667','S','Modesto','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.478096,-89.981342,0,'2013-07-06 12:44:33',NULL,NULL),(1286,'00730','S','Sect Las Canitas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(22805,'24476','S','Spottswood','A','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.926887,-79.200418,0,'2013-07-06 12:44:31',NULL,NULL),(41456,'46902','S','Kokomo','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.455097,-86.134088,0,'2013-07-06 12:44:32',NULL,NULL),(52453,'60673','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.887505,-87.628813,0,'2013-07-06 12:44:33',NULL,NULL),(12779,'13214','S','Dewitt','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.036965,-76.073608,0,'2013-07-06 12:44:30',NULL,NULL),(23317,'25209','S','Garrison','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.970938,-81.529874,0,'2013-07-06 12:44:31',NULL,NULL),(7854,'07480','S','Gordon Lakes','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.090615,-74.369917,0,'2013-07-06 12:44:30',NULL,NULL),(43730,'48930','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734929,-84.559370,0,'2013-07-06 12:44:32',NULL,NULL),(7286,'06534','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318581,-72.927510,0,'2013-07-06 12:44:30',NULL,NULL),(72046,'88081','S','Anthony','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.010850,-106.570172,0,'2013-07-06 12:44:34',NULL,NULL),(60628,'71901','S','Hot Springs National','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(43001,'48160','S','Mooreville','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(65601,'77901','S','Da Costa','N','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.706750,-97.181430,0,'2013-07-06 12:44:34',NULL,NULL),(57218,'66449','S','Leonardville','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.360412,-96.832043,0,'2013-07-06 12:44:33',NULL,NULL),(26381,'29101','S','Clyde','N','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.489200,-80.248200,0,'2013-07-06 12:44:31',NULL,NULL),(23129,'24970','S','Organ Cave','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.752172,-80.467326,0,'2013-07-06 12:44:31',NULL,NULL),(34547,'38721','S','Nitta Yuma','A','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.974616,-90.831462,0,'2013-07-06 12:44:32',NULL,NULL),(73138,'90274','S','Rolling Hills Estates','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(68208,'81044','S','Hasty','D','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.061389,-102.926667,0,'2013-07-06 12:44:34',NULL,NULL),(4372,'03076','S','Pelham','D','Hillsborough','33011','New Hampshire','NH','33','4560','603','Eastern',-5.0,'Y',42.733541,-71.324077,0,'2013-07-06 12:44:30',NULL,NULL),(23939,'26263','S','Dryfork','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.946186,-79.436366,0,'2013-07-06 12:44:31',NULL,NULL),(10773,'11365','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738549,-73.790001,0,'2013-07-06 12:44:30',NULL,NULL),(25856,'28627','S','Glade Valley','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.440899,-81.017500,0,'2013-07-06 12:44:31',NULL,NULL),(14631,'15233','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.457777,-80.026332,0,'2013-07-06 12:44:31',NULL,NULL),(36522,'40840','S','Harlan','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.952639,-83.391566,0,'2013-07-06 12:44:32',NULL,NULL),(76359,'95488','S','Westport','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.641401,-123.785539,0,'2013-07-06 12:44:34',NULL,NULL),(75943,'95033','S','Los Gatos','D','Santa Cruz','06087','California','CA','06','7400','408','Pacific',-8.0,'Y',37.229886,-121.958736,0,'2013-07-06 12:44:34',NULL,NULL),(22313,'23837','S','Courtland','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.704339,-77.059688,0,'2013-07-06 12:44:31',NULL,NULL),(48427,'55612','S','Lutsen','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.699223,-90.623254,0,'2013-07-06 12:44:33',NULL,NULL),(12537,'13037','S','Lakeport','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(24013,'26354','S','White Day','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.343632,-80.022519,0,'2013-07-06 12:44:31',NULL,NULL),(71864,'87714','S','Cimarron','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.574377,-105.053005,0,'2013-07-06 12:44:34',NULL,NULL),(58052,'68033','S','Ithaca','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.164062,-96.542654,0,'2013-07-06 12:44:33',NULL,NULL),(57755,'67447','S','Green','D','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.429270,-97.002267,0,'2013-07-06 12:44:33',NULL,NULL),(62450,'74193','U','First Natl Bank Mail Service','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.061650,-95.923301,0,'2013-07-06 12:44:33',NULL,NULL),(33560,'37410','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',34.999255,-85.317893,0,'2013-07-06 12:44:32',NULL,NULL),(32179,'35485','P','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.165360,-87.614641,0,'2013-07-06 12:44:32',NULL,NULL),(35312,'39407','U','Camp Shelby','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.313533,-89.305394,0,'2013-07-06 12:44:32',NULL,NULL),(52227,'60499','P','South Suburban','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782323,-87.767936,0,'2013-07-06 12:44:33',NULL,NULL),(37422,'41817','S','Larkslane','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.376981,-82.888568,0,'2013-07-06 12:44:32',NULL,NULL),(48084,'55333','S','Franklin','D','Renville','27129','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.526881,-94.883318,0,'2013-07-06 12:44:33',NULL,NULL),(28469,'31421','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.082183,-81.123407,0,'2013-07-06 12:44:32',NULL,NULL),(58992,'70056','S','Gretna','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.890719,-90.030182,0,'2013-07-06 12:44:33',NULL,NULL),(58008,'67868','S','Pierceville','D','Finney','20055','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.832760,-100.695287,0,'2013-07-06 12:44:33',NULL,NULL),(30411,'33325','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110796,-80.317912,0,'2013-07-06 12:44:32',NULL,NULL),(33304,'37131','U','State Farm Ins Co','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.853243,-86.396024,0,'2013-07-06 12:44:32',NULL,NULL),(44054,'49436','S','Silver Lake','A','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.681967,-86.464667,0,'2013-07-06 12:44:32',NULL,NULL),(46762,'53940','P','Lake Delton','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.594441,-89.797130,0,'2013-07-06 12:44:32',NULL,NULL),(13713,'14070','S','Gowanda','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.453020,-78.939188,0,'2013-07-06 12:44:31',NULL,NULL),(33349,'37178','S','Tennessee Ridge','D','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.313167,-87.764653,0,'2013-07-06 12:44:32',NULL,NULL),(9287,'09645','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(74673,'92865','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.826298,-117.851140,0,'2013-07-06 12:44:34',NULL,NULL),(72761,'89513','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.504939,-119.856253,0,'2013-07-06 12:44:34',NULL,NULL),(70115,'84189','U','Key Bank','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.764906,-111.886965,0,'2013-07-06 12:44:34',NULL,NULL),(57147,'66251','U','Lenexa','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(69007,'83204','S','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.838617,-112.426137,0,'2013-07-06 12:44:34',NULL,NULL),(68786,'82334','S','Sinclair','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.777516,-107.115829,0,'2013-07-06 12:44:34',NULL,NULL),(72613,'89415','S','Hawthorne Army Ammunition Pl','N','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(48739,'55965','S','Preston','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667591,-92.079343,0,'2013-07-06 12:44:33',NULL,NULL),(9714,'10080','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(28677,'31794','S','Tifton','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.460118,-83.509086,0,'2013-07-06 12:44:32',NULL,NULL),(30531,'33407','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.760988,-80.085606,0,'2013-07-06 12:44:32',NULL,NULL),(455,'00662','S','Villa Acevedo','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(42989,'48154','S','Livonia','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.397134,-83.377371,0,'2013-07-06 12:44:32',NULL,NULL),(2444,'00953','S','Urb Palacios del Rio II','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(69518,'83722','U','Idaho State Tax Commission','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.614327,-116.216254,0,'2013-07-06 12:44:34',NULL,NULL),(64808,'77024','S','Memorial Park','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(41959,'47405','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.172055,-86.523157,0,'2013-07-06 12:44:32',NULL,NULL),(28810,'32067','P','Orange Park','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.032559,-81.791988,0,'2013-07-06 12:44:32',NULL,NULL),(45859,'52241','S','Iowa City','A','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.680235,-91.577652,0,'2013-07-06 12:44:32',NULL,NULL),(24271,'26847','S','Dorcas','A','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.996532,-79.123849,0,'2013-07-06 12:44:31',NULL,NULL),(7186,'06470','S','Newtown','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.396689,-73.313985,0,'2013-07-06 12:44:30',NULL,NULL),(335,'00653','S','Bo La Luna','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(75658,'94535','S','Fairfield','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.249444,-122.038889,0,'2013-07-06 12:44:34',NULL,NULL),(67362,'80112','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.575499,-104.861971,0,'2013-07-06 12:44:34',NULL,NULL),(65583,'77866','P','Millican','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.465939,-96.203773,0,'2013-07-06 12:44:34',NULL,NULL),(63486,'75693','S','Clarksvle Cty','A','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.540043,-94.857003,0,'2013-07-06 12:44:33',NULL,NULL),(60382,'71497','U','Natchitoches','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.755063,-93.101240,0,'2013-07-06 12:44:33',NULL,NULL),(21817,'23106','S','Manquin','D','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.709531,-77.192156,0,'2013-07-06 12:44:31',NULL,NULL),(44188,'49612','S','Alden','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.893479,-85.265659,0,'2013-07-06 12:44:32',NULL,NULL),(22796,'24468','S','Mustoe','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.286593,-79.659825,0,'2013-07-06 12:44:31',NULL,NULL),(58648,'68872','S','St Libory','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.082458,-98.362472,0,'2013-07-06 12:44:33',NULL,NULL),(55249,'63450','S','Lentner','D','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.720412,-92.145558,0,'2013-07-06 12:44:33',NULL,NULL),(54624,'62917','S','Mitchellsville','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.690197,-88.627956,0,'2013-07-06 12:44:33',NULL,NULL),(48524,'55746','S','Silica','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(18004,'18636','S','Forkston Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.418188,-76.075214,0,'2013-07-06 12:44:31',NULL,NULL),(9683,'10043','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(7655,'07081','S','Springfield','D','Union','34039','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.700489,-74.322044,0,'2013-07-06 12:44:30',NULL,NULL),(63494,'75704','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.405184,-95.432727,0,'2013-07-06 12:44:33',NULL,NULL),(62854,'75025','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.082934,-96.752101,0,'2013-07-06 12:44:33',NULL,NULL),(15526,'16544','U','Saint Vincent Health','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.110099,-80.103108,0,'2013-07-06 12:44:31',NULL,NULL),(33807,'37914','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.992378,-83.825982,0,'2013-07-06 12:44:32',NULL,NULL),(46539,'53404','S','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.740654,-87.809611,0,'2013-07-06 12:44:32',NULL,NULL),(6876,'06138','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.761680,-72.612610,0,'2013-07-06 12:44:30',NULL,NULL),(39508,'44807','S','Reedtown','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(14060,'14586','S','W Henrietta','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.043209,-77.679662,0,'2013-07-06 12:44:31',NULL,NULL),(36892,'41101','S','Westwood','A','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(57537,'67020','S','Burrton','D','Harvey','20079','Kansas','KS','20','9040','620','Central',-6.0,'Y',38.027977,-97.557538,0,'2013-07-06 12:44:33',NULL,NULL),(3818,'02302','S','Brockton','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.083088,-70.999902,0,'2013-07-06 12:44:30',NULL,NULL),(30344,'33311','S','Lauderdale Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(30718,'33513','S','Bushnell','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.661872,-82.114026,0,'2013-07-06 12:44:32',NULL,NULL),(29959,'33075','P','Coral Springs','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.244645,-80.262760,0,'2013-07-06 12:44:32',NULL,NULL),(53919,'62380','S','Stillwell','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.243500,-91.251600,0,'2013-07-06 12:44:33',NULL,NULL),(16881,'17572','S','Ronks','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014588,-76.149820,0,'2013-07-06 12:44:31',NULL,NULL),(44967,'50401','S','Emery','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(13790,'14171','S','W Valley','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.417525,-78.638025,0,'2013-07-06 12:44:31',NULL,NULL),(19820,'20460','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878225,-77.020008,0,'2013-07-06 12:44:31',NULL,NULL),(46732,'53825','S','Stitzer','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.913560,-90.588319,0,'2013-07-06 12:44:32',NULL,NULL),(5143,'04416','S','Bucksport','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.575891,-68.787997,0,'2013-07-06 12:44:30',NULL,NULL),(27518,'30205','S','Brooks','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.268083,-84.464021,0,'2013-07-06 12:44:31',NULL,NULL),(48128,'55359','S','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.997812,-93.687245,0,'2013-07-06 12:44:33',NULL,NULL),(8303,'08027','S','Gibbstown','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.826648,-75.273257,0,'2013-07-06 12:44:30',NULL,NULL),(66847,'79119','S','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.066563,-101.925375,0,'2013-07-06 12:44:34',NULL,NULL),(60968,'72104','S','Perla','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(37017,'41234','S','Meally','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.799520,-82.732821,0,'2013-07-06 12:44:32',NULL,NULL),(17387,'17889','S','Dry Valley','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.918340,-76.860052,0,'2013-07-06 12:44:31',NULL,NULL),(41832,'47342','S','Wheeling','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.310795,-85.502413,0,'2013-07-06 12:44:32',NULL,NULL),(41986,'47421','S','Pinhook','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(74075,'92175','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.765448,-117.059897,0,'2013-07-06 12:44:34',NULL,NULL),(62480,'74347','S','Kansas','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.240107,-94.821653,0,'2013-07-06 12:44:33',NULL,NULL),(58058,'68040','S','Malmo','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.302222,-96.731630,0,'2013-07-06 12:44:33',NULL,NULL),(53999,'62444','S','Mode','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.278154,-88.636713,0,'2013-07-06 12:44:33',NULL,NULL),(53440,'61873','S','Saint Joseph','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.113531,-88.044951,0,'2013-07-06 12:44:33',NULL,NULL),(38524,'43730','S','Hemlock','A','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.630644,-82.090365,0,'2013-07-06 12:44:32',NULL,NULL),(43075,'48197','S','Ypsilanti','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.233132,-83.623767,0,'2013-07-06 12:44:32',NULL,NULL),(24564,'27302','S','Mebane','D','Alamance','37001','North Carolina','NC','37','3120','919/984','Eastern',-5.0,'Y',36.089915,-79.285944,0,'2013-07-06 12:44:31',NULL,NULL),(56854,'66002','S','Potter','A','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.562045,-95.129084,0,'2013-07-06 12:44:33',NULL,NULL),(12662,'13120','S','S Onon','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(13148,'13601','S','Watertown','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.984440,-75.900540,0,'2013-07-06 12:44:30',NULL,NULL),(14909,'15534','S','Buffalo Mills','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.922098,-78.709191,0,'2013-07-06 12:44:31',NULL,NULL),(14186,'14751','P','Leon','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.293682,-79.017978,0,'2013-07-06 12:44:31',NULL,NULL),(38883,'44108','S','Bratenahl','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.539143,-81.611674,0,'2013-07-06 12:44:32',NULL,NULL),(37495,'42025','S','Sharpe','N','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.877980,-88.333200,0,'2013-07-06 12:44:32',NULL,NULL),(62495,'74361','S','Sportsmen Acres','A','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.298940,-95.310823,0,'2013-07-06 12:44:33',NULL,NULL),(18082,'18706','S','Hanover Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(80194,'99919','P','Thorne Bay','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.689470,-132.524280,0,'2013-07-06 12:44:34',NULL,NULL),(68387,'81148','P','Romeo','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173951,-105.983484,0,'2013-07-06 12:44:34',NULL,NULL),(26328,'29052','S','Gadsden','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.849444,-80.763680,0,'2013-07-06 12:44:31',NULL,NULL),(60683,'71932','P','Board Camp','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.552927,-94.204398,0,'2013-07-06 12:44:33',NULL,NULL),(65191,'77422','S','Wild Peach Village','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.043342,-95.567119,0,'2013-07-06 12:44:34',NULL,NULL),(38790,'44057','S','South Madison','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.770970,-81.058712,0,'2013-07-06 12:44:32',NULL,NULL),(49416,'56630','S','Battle River','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(17140,'17801','S','Fishers Ferry','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(59850,'71254','S','Hollybrook','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(29957,'33074','P','Lighthouse Pt','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.238998,-80.124146,0,'2013-07-06 12:44:32',NULL,NULL),(36742,'41035','S','Sherman','N','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.707527,-84.655201,0,'2013-07-06 12:44:32',NULL,NULL),(14848,'15447','P','Isabella','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.944876,-79.936449,0,'2013-07-06 12:44:31',NULL,NULL),(7901,'07604','S','Hasbrouck Heights','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.865727,-74.076151,0,'2013-07-06 12:44:30',NULL,NULL),(78350,'98009','P','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.618020,-122.201830,0,'2013-07-06 12:44:34',NULL,NULL),(71697,'87522','S','Chimayo','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(62134,'73669','S','Thomas','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.748255,-98.744954,0,'2013-07-06 12:44:33',NULL,NULL),(9445,'10005','S','Wall Street','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(36733,'41031','S','Shadynook','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(62791,'74881','S','Wellston','D','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.691700,-97.065941,0,'2013-07-06 12:44:33',NULL,NULL),(28535,'31553','S','Raybon','N','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.216716,-81.956732,0,'2013-07-06 12:44:32',NULL,NULL),(31875,'35125','S','Eden','N','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573051,-86.276572,0,'2013-07-06 12:44:32',NULL,NULL),(44140,'49515','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.962887,-85.654539,0,'2013-07-06 12:44:32',NULL,NULL),(41164,'46703','S','Metz','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(40156,'45354','P','Phillipsburg','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.900931,-84.400434,0,'2013-07-06 12:44:32',NULL,NULL),(69046,'83226','S','Challis','D','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.502833,-114.224223,0,'2013-07-06 12:44:34',NULL,NULL),(64071,'76137','S','Watauga','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.859978,-97.293430,0,'2013-07-06 12:44:34',NULL,NULL),(59179,'70346','S','Modeste','A','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.100345,-91.001444,0,'2013-07-06 12:44:33',NULL,NULL),(52838,'61315','P','Bureau Junction','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.286868,-89.369862,0,'2013-07-06 12:44:33',NULL,NULL),(45247,'50658','S','Nashua','D','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.949099,-92.539914,0,'2013-07-06 12:44:32',NULL,NULL),(45896,'52309','S','Canton','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.082257,-90.870603,0,'2013-07-06 12:44:32',NULL,NULL),(27891,'30464','P','Stillmore','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.455746,-82.223616,0,'2013-07-06 12:44:31',NULL,NULL),(5472,'04740','S','Easton','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.655132,-67.937688,0,'2013-07-06 12:44:30',NULL,NULL),(11940,'12435','S','Greenfld Park','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.748780,-74.523180,0,'2013-07-06 12:44:30',NULL,NULL),(63398,'75650','S','Hallsville','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.500539,-94.575687,0,'2013-07-06 12:44:33',NULL,NULL),(55430,'63665','S','Redford','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.314885,-90.916174,0,'2013-07-06 12:44:33',NULL,NULL),(33447,'37312','S','Cleveld','N','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.199530,-84.863073,0,'2013-07-06 12:44:32',NULL,NULL),(29842,'33033','S','Leisure City','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.494244,-80.432291,0,'2013-07-06 12:44:32',NULL,NULL),(35438,'39476','S','Richton','D','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(28364,'31210','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.876518,-83.739134,0,'2013-07-06 12:44:32',NULL,NULL),(79532,'98942','S','Selah','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.691124,-120.554600,0,'2013-07-06 12:44:34',NULL,NULL),(71992,'88030','S','Sunshine','N','Luna','35029','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.263005,-107.754054,0,'2013-07-06 12:44:34',NULL,NULL),(55205,'63385','S','Wentzville','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.798044,-90.860524,0,'2013-07-06 12:44:33',NULL,NULL),(25480,'28352','S','E Laurinburg','N','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.767212,-79.468392,0,'2013-07-06 12:44:31',NULL,NULL),(41269,'46750','S','Mount Etna','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(28548,'31561','P','Sea Island','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.205555,-81.329738,0,'2013-07-06 12:44:32',NULL,NULL),(45793,'52168','P','Spillville','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.201837,-91.948183,0,'2013-07-06 12:44:32',NULL,NULL),(71505,'87112','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.098578,-106.513879,0,'2013-07-06 12:44:34',NULL,NULL),(36668,'41011','S','Ft Mitchell','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(27931,'30520','S','Canon','D','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.285002,-83.105264,0,'2013-07-06 12:44:31',NULL,NULL),(63469,'75686','S','Ebenezer','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(57712,'67351','S','Liberty','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.159662,-95.600773,0,'2013-07-06 12:44:33',NULL,NULL),(55792,'64125','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.102846,-94.491598,0,'2013-07-06 12:44:33',NULL,NULL),(2148,'00924','S','Villa Capri','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(68592,'81527','S','Whitewater','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',38.958952,-108.364465,0,'2013-07-06 12:44:34',NULL,NULL),(51875,'60085','S','Park City','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.360907,-87.862378,0,'2013-07-06 12:44:33',NULL,NULL),(43631,'48824','S','East Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.653979,-84.492032,0,'2013-07-06 12:44:32',NULL,NULL),(29420,'32662','P','Lochloosa','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.511440,-82.099001,0,'2013-07-06 12:44:32',NULL,NULL),(63090,'75253','S','Kleberg','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.687055,-96.602168,0,'2013-07-06 12:44:33',NULL,NULL),(63035,'75205','S','Village','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.836236,-96.794663,0,'2013-07-06 12:44:33',NULL,NULL),(44436,'49853','S','McMillan','N','Luce','26095','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.371164,-85.738692,0,'2013-07-06 12:44:32',NULL,NULL),(27425,'30106','S','Austell','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.835384,-84.630102,0,'2013-07-06 12:44:31',NULL,NULL),(58531,'68801','S','Grand Island','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.923320,-98.336430,0,'2013-07-06 12:44:33',NULL,NULL),(56693,'65655','S','Gainesville','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.574662,-92.412396,0,'2013-07-06 12:44:33',NULL,NULL),(19933,'20565','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904899,-76.984842,0,'2013-07-06 12:44:31',NULL,NULL),(44747,'50167','S','Minburn','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.757699,-94.024564,0,'2013-07-06 12:44:32',NULL,NULL),(53110,'61539','P','Kingston Mines','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.557947,-89.769951,0,'2013-07-06 12:44:33',NULL,NULL),(53111,'61540','S','Lacon','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.020963,-89.405973,0,'2013-07-06 12:44:33',NULL,NULL),(76933,'96019','S','Central Vly','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.681560,-122.377440,0,'2013-07-06 12:44:34',NULL,NULL),(68265,'81069','S','San Isabel','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.927576,-104.902916,0,'2013-07-06 12:44:34',NULL,NULL),(66324,'78597','S','S Padre Isle','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.109550,-97.168003,0,'2013-07-06 12:44:34',NULL,NULL),(65308,'77501','P','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.684464,-95.169800,0,'2013-07-06 12:44:34',NULL,NULL),(63831,'75973','S','Huxley','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(15955,'17025','S','Enola','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(10076,'10185','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(33838,'37934','S','Concord Farragut','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(69108,'83262','S','Pingree','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.148550,-112.629588,0,'2013-07-06 12:44:34',NULL,NULL),(34240,'38382','S','Trenton','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.973792,-88.968578,0,'2013-07-06 12:44:32',NULL,NULL),(47908,'55110','S','Birchwood','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(19268,'19955','P','Kenton','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.228201,-75.665752,0,'2013-07-06 12:44:31',NULL,NULL),(48262,'55428','S','Brooklyn Ctr','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(79765,'99323','S','Burbank','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.198868,-119.010103,0,'2013-07-06 12:44:34',NULL,NULL),(57864,'67576','S','Saint John','D','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.003667,-98.761543,0,'2013-07-06 12:44:33',NULL,NULL),(18033,'18653','P','Ransom','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.393995,-75.824614,0,'2013-07-06 12:44:31',NULL,NULL),(36989,'41201','S','Louisa','A','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.001190,-82.716339,0,'2013-07-06 12:44:32',NULL,NULL),(11590,'12078','S','Gloversville','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.054502,-74.338330,0,'2013-07-06 12:44:30',NULL,NULL),(13208,'13626','S','South Rutland','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.895883,-75.707121,0,'2013-07-06 12:44:30',NULL,NULL),(4283,'02893','S','West Warwick','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.692019,-71.516302,0,'2013-07-06 12:44:30',NULL,NULL),(5120,'04401','S','Bangor','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.814135,-68.778574,0,'2013-07-06 12:44:30',NULL,NULL),(72515,'89155','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.172209,-115.120274,0,'2013-07-06 12:44:34',NULL,NULL),(55176,'63369','S','Old Monroe','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.942597,-90.763542,0,'2013-07-06 12:44:33',NULL,NULL),(42305,'47601','S','Boonville','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(3449,'01770','S','Sherborn','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.232964,-71.381395,0,'2013-07-06 12:44:30',NULL,NULL),(38077,'43069','U','Victorias Secret','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.963450,-82.782984,0,'2013-07-06 12:44:32',NULL,NULL),(77882,'97268','P','Oak Grove','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.416944,-122.638889,0,'2013-07-06 12:44:34',NULL,NULL),(58937,'69351','S','Lakeside','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.073311,-102.407964,0,'2013-07-06 12:44:33',NULL,NULL),(14905,'15530','S','Berlin','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.918162,-78.954499,0,'2013-07-06 12:44:31',NULL,NULL),(36877,'41097','S','Williamstown','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.608858,-84.580873,0,'2013-07-06 12:44:32',NULL,NULL),(79958,'99635','P','Kenai','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.690180,-151.288800,0,'2013-07-06 12:44:34',NULL,NULL),(14756,'15327','S','Dilliner','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.755215,-79.996804,0,'2013-07-06 12:44:31',NULL,NULL),(46436,'53206','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.074967,-87.932138,0,'2013-07-06 12:44:32',NULL,NULL),(23452,'25422','S','Great Cacapon','D','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.616120,-78.390186,0,'2013-07-06 12:44:31',NULL,NULL),(7627,'07061','P','Plainfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.615053,-74.414487,0,'2013-07-06 12:44:30',NULL,NULL),(7421,'06814','U','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.377300,-73.488123,0,'2013-07-06 12:44:30',NULL,NULL),(70212,'84401','S','Taylor','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(61297,'72417','S','Brookland','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.901357,-90.580880,0,'2013-07-06 12:44:33',NULL,NULL),(59693,'71073','S','Noles Landing','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.525220,-93.295020,0,'2013-07-06 12:44:33',NULL,NULL),(57987,'67846','S','Garden City','D','Finney','20055','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.973430,-100.849523,0,'2013-07-06 12:44:33',NULL,NULL),(57396,'66757','S','Hilford','N','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.428154,-95.680875,0,'2013-07-06 12:44:33',NULL,NULL),(27372,'30070','P','Porterdale','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.575459,-83.897275,0,'2013-07-06 12:44:31',NULL,NULL),(71770,'87554','P','Petaca','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.697135,-106.133000,0,'2013-07-06 12:44:34',NULL,NULL),(68903,'82731','S','Gillette','A','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.756810,-105.296341,0,'2013-07-06 12:44:34',NULL,NULL),(15093,'15761','S','Mentcle','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.637950,-78.884940,0,'2013-07-06 12:44:31',NULL,NULL),(27587,'30286','S','Thomaston','D','Upson','13293','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.905189,-84.334376,0,'2013-07-06 12:44:31',NULL,NULL),(32991,'36619','S','Theodore','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.593684,-88.184484,0,'2013-07-06 12:44:32',NULL,NULL),(22743,'24401','S','Staunton Park','N','Staunton City','51790','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.153156,-79.078684,0,'2013-07-06 12:44:31',NULL,NULL),(44559,'50012','U','Ames','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.023294,-93.647478,0,'2013-07-06 12:44:32',NULL,NULL),(20143,'20724','S','Russett','A','Anne Arundel','24003','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.090999,-76.818955,0,'2013-07-06 12:44:31',NULL,NULL),(61471,'72632','S','Elk Ranch','N','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.444978,-93.740676,0,'2013-07-06 12:44:33',NULL,NULL),(54238,'62665','S','Meredosia','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.829660,-90.559448,0,'2013-07-06 12:44:33',NULL,NULL),(49071,'56315','S','Brandon','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.966274,-95.593817,0,'2013-07-06 12:44:33',NULL,NULL),(42477,'47834','S','Turner','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(41537,'46996','S','Winamac','D','Pulaski','18131','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.054144,-86.603068,0,'2013-07-06 12:44:32',NULL,NULL),(17868,'18436','S','Lake Ariel','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(16430,'17232','S','Lurgan','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.093194,-77.632098,0,'2013-07-06 12:44:31',NULL,NULL),(32484,'36049','S','Luverne','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.713452,-86.263994,0,'2013-07-06 12:44:32',NULL,NULL),(77285,'96621','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76879,'95976','U','Blue Shield of Cal','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.753844,-121.870112,0,'2013-07-06 12:44:34',NULL,NULL),(56396,'65240','S','Centralia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.199769,-92.146039,0,'2013-07-06 12:44:33',NULL,NULL),(49735,'57049','S','North Sioux City','D','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.528060,-96.503280,0,'2013-07-06 12:44:33',NULL,NULL),(49092,'56333','P','Gilman','D','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.743733,-93.965639,0,'2013-07-06 12:44:33',NULL,NULL),(43967,'49316','S','Dutton','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.787020,-85.546320,0,'2013-07-06 12:44:32',NULL,NULL),(77979,'97386','S','Sweet Home','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.393111,-122.735453,0,'2013-07-06 12:44:34',NULL,NULL),(37392,'41762','S','Hyden','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164104,-83.438462,0,'2013-07-06 12:44:32',NULL,NULL),(39253,'44442','S','New Middletown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.965625,-80.556678,0,'2013-07-06 12:44:32',NULL,NULL),(42472,'47834','S','Hoosierville','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(47880,'55089','S','Welch','D','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.619771,-92.651690,0,'2013-07-06 12:44:33',NULL,NULL),(16103,'17054','P','Mattawana','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.495215,-77.730114,0,'2013-07-06 12:44:31',NULL,NULL),(21035,'21867','P','Upper Hill','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.102657,-75.794628,0,'2013-07-06 12:44:31',NULL,NULL),(17943,'18508','S','North Scranton','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.437061,-75.663443,0,'2013-07-06 12:44:31',NULL,NULL),(14948,'15606','U','Greensburg','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.301688,-79.538092,0,'2013-07-06 12:44:31',NULL,NULL),(26847,'29511','S','Aynor','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.990448,-79.191606,0,'2013-07-06 12:44:31',NULL,NULL),(46660,'53708','P','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.100954,-89.312327,0,'2013-07-06 12:44:32',NULL,NULL),(68765,'82301','S','Fort Steele','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.788870,-107.199009,0,'2013-07-06 12:44:34',NULL,NULL),(55126,'63343','S','New Hope','N','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.157945,-90.815451,0,'2013-07-06 12:44:33',NULL,NULL),(31327,'34134','S','Barefoot Beach','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.362812,-81.822980,0,'2013-07-06 12:44:32',NULL,NULL),(3172,'01301','S','Leyden','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.602912,-72.598574,0,'2013-07-06 12:44:30',NULL,NULL),(7165,'06440','P','Hawleyville','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.433021,-73.353694,0,'2013-07-06 12:44:30',NULL,NULL),(7707,'07188','U','Jp Morgan Chase','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.730949,-74.175440,0,'2013-07-06 12:44:30',NULL,NULL),(49957,'57348','S','Hitchcock','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.631361,-98.408782,0,'2013-07-06 12:44:33',NULL,NULL),(40024,'45248','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159624,-84.661853,0,'2013-07-06 12:44:32',NULL,NULL),(47591,'54861','P','Odanah','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.564580,-90.658043,0,'2013-07-06 12:44:33',NULL,NULL),(17691,'18210','S','Albrightsville','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.996515,-75.572713,0,'2013-07-06 12:44:31',NULL,NULL),(38955,'44126','S','Parkview','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.446483,-81.856757,0,'2013-07-06 12:44:32',NULL,NULL),(48185,'55388','S','Watertown','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.954544,-93.846907,0,'2013-07-06 12:44:33',NULL,NULL),(45066,'50517','S','Bancroft','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.292754,-94.216400,0,'2013-07-06 12:44:32',NULL,NULL),(12017,'12506','P','Bangall','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.875132,-73.690376,0,'2013-07-06 12:44:30',NULL,NULL),(16980,'17724','S','Ward','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(26854,'29525','S','Clio','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.577486,-79.542351,0,'2013-07-06 12:44:31',NULL,NULL),(28568,'31603','P','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.872061,-83.285374,0,'2013-07-06 12:44:32',NULL,NULL),(47902,'55109','S','Maplewood','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(2239,'00926','S','Urb Hucares','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(44954,'50392','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.590370,-93.629659,0,'2013-07-06 12:44:32',NULL,NULL),(30293,'33266','P','Miami Springs','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.827127,-80.313971,0,'2013-07-06 12:44:32',NULL,NULL),(20228,'20774','S','Upper Marlboro','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(30458,'33335','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181775,-80.138566,0,'2013-07-06 12:44:32',NULL,NULL),(36213,'40281','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.145981,-85.867083,0,'2013-07-06 12:44:32',NULL,NULL),(37174,'41472','S','White Oak','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(78118,'97503','S','White City','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.418373,-122.814932,0,'2013-07-06 12:44:34',NULL,NULL),(77639,'97010','P','Bridal Veil','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.549954,-122.272013,0,'2013-07-06 12:44:34',NULL,NULL),(64630,'76705','S','Hallsburg','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(64091,'76161','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.805706,-97.353001,0,'2013-07-06 12:44:34',NULL,NULL),(36090,'40218','S','West Buechel','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192865,-85.653204,0,'2013-07-06 12:44:32',NULL,NULL),(16481,'17251','P','Roxbury','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.110564,-77.660331,0,'2013-07-06 12:44:31',NULL,NULL),(19197,'19810','S','Edgemoor','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.820580,-75.508102,0,'2013-07-06 12:44:31',NULL,NULL),(64800,'77020','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772705,-95.312443,0,'2013-07-06 12:44:34',NULL,NULL),(57104,'66220','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.968891,-94.817860,0,'2013-07-06 12:44:33',NULL,NULL),(53862,'62330','S','Pontoosuc','A','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.632034,-91.172512,0,'2013-07-06 12:44:33',NULL,NULL),(26532,'29203','S','Greenview','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(34759,'38859','S','New Site','D','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.557966,-88.415093,0,'2013-07-06 12:44:32',NULL,NULL),(76915,'96001','S','Redding','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.564869,-122.421215,0,'2013-07-06 12:44:34',NULL,NULL),(57662,'67211','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.667341,-97.314775,0,'2013-07-06 12:44:33',NULL,NULL),(10976,'11531','P','Garden City','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.721588,-73.632436,0,'2013-07-06 12:44:30',NULL,NULL),(24247,'26764','S','Terra Alta','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.444161,-79.544620,0,'2013-07-06 12:44:31',NULL,NULL),(24925,'27809','S','Battleboro','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',36.048686,-77.749014,0,'2013-07-06 12:44:31',NULL,NULL),(68093,'80942','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834659,-104.822936,0,'2013-07-06 12:44:34',NULL,NULL),(57448,'66843','S','Clements','A','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.287465,-96.749099,0,'2013-07-06 12:44:33',NULL,NULL),(52688,'61089','S','Winslow','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.470476,-89.804771,0,'2013-07-06 12:44:33',NULL,NULL),(51362,'59341','S','Mildred','D','Prairie','30079','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.741221,-104.782243,0,'2013-07-06 12:44:33',NULL,NULL),(967,'00716','S','Urb Costa Caribe','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(21881,'23173','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.577785,-77.534555,0,'2013-07-06 12:44:31',NULL,NULL),(73615,'91402','S','Panorama City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.222187,-118.442663,0,'2013-07-06 12:44:34',NULL,NULL),(69360,'83552','S','Clearwater','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.120893,-115.974113,0,'2013-07-06 12:44:34',NULL,NULL),(21461,'22623','P','Chester Gap','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.854561,-78.133314,0,'2013-07-06 12:44:31',NULL,NULL),(21355,'22438','S','Champlain','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.029503,-76.962492,0,'2013-07-06 12:44:31',NULL,NULL),(21524,'22727','S','Aylor','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(74825,'93226','S','Glennville','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.727787,-118.695937,0,'2013-07-06 12:44:34',NULL,NULL),(63550,'75765','S','Holly Lk Rnch','A','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.655720,-95.197003,0,'2013-07-06 12:44:33',NULL,NULL),(63225,'75458','P','Merit','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.282104,-96.209391,0,'2013-07-06 12:44:33',NULL,NULL),(9286,'09643','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9583,'10028','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(12119,'12590','S','Wappingers Fl','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.595832,-73.887450,0,'2013-07-06 12:44:30',NULL,NULL),(44378,'49795','S','Vanderbilt','D','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.144939,-84.626232,0,'2013-07-06 12:44:32',NULL,NULL),(17904,'18447','S','Sturges','N','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(57184,'66411','S','Blue Rapids','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.683914,-96.659363,0,'2013-07-06 12:44:33',NULL,NULL),(57152,'66251','U','Sprint Corporation','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(35442,'39478','S','Sandy Hook','D','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.047598,-89.810405,0,'2013-07-06 12:44:32',NULL,NULL),(37816,'42413','S','Hanson','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.437638,-87.479402,0,'2013-07-06 12:44:32',NULL,NULL),(54853,'63042','S','Vigus','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.777796,-90.371867,0,'2013-07-06 12:44:33',NULL,NULL),(30326,'33308','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(28369,'31217','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.840243,-83.538862,0,'2013-07-06 12:44:32',NULL,NULL),(10566,'11010','S','Franklin Sq','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705094,-73.674202,0,'2013-07-06 12:44:30',NULL,NULL),(7352,'06725','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.552662,-73.040934,0,'2013-07-06 12:44:30',NULL,NULL),(37986,'42740','S','Glendale','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.591766,-85.939730,0,'2013-07-06 12:44:32',NULL,NULL),(41483,'46936','S','Greentown','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.476073,-85.970909,0,'2013-07-06 12:44:32',NULL,NULL),(18573,'19127','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.029648,-75.223171,0,'2013-07-06 12:44:31',NULL,NULL),(23066,'24874','S','Pineville','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.556987,-81.529921,0,'2013-07-06 12:44:31',NULL,NULL),(12138,'12726','S','Cochecton','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.759640,-74.792880,0,'2013-07-06 12:44:30',NULL,NULL),(59632,'71037','S','Sligo','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(3434,'01747','S','Hopedale','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.128675,-71.536023,0,'2013-07-06 12:44:30',NULL,NULL),(28651,'31769','P','Mystic','D','Irwin','13155','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.563068,-83.270421,0,'2013-07-06 12:44:32',NULL,NULL),(70508,'84783','S','Dammeron Valley','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.313820,-113.668620,0,'2013-07-06 12:44:34',NULL,NULL),(68582,'81520','S','Clifton','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.085313,-108.445806,0,'2013-07-06 12:44:34',NULL,NULL),(11291,'11776','S','Port Jeff Sta','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(39513,'44813','S','North Woodbury','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.610016,-82.517930,0,'2013-07-06 12:44:32',NULL,NULL),(28770,'32030','P','Doctors Inlet','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.105007,-81.780508,0,'2013-07-06 12:44:32',NULL,NULL),(64966,'77253','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756169,-95.368198,0,'2013-07-06 12:44:34',NULL,NULL),(52803,'61277','S','Portland Corners','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(27406,'30092','S','Parkway','N','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.973773,-84.238127,0,'2013-07-06 12:44:31',NULL,NULL),(10859,'11414','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.658635,-73.843765,0,'2013-07-06 12:44:30',NULL,NULL),(13570,'13842','S','South Kortright','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.381469,-74.724897,0,'2013-07-06 12:44:31',NULL,NULL),(76519,'95646','P','Black Station','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(65467,'77627','S','Nederland','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.975858,-93.995675,0,'2013-07-06 12:44:34',NULL,NULL),(63377,'75644','S','Gilmer','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(55616,'63960','S','Puxico','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.952919,-90.157210,0,'2013-07-06 12:44:33',NULL,NULL),(13911,'14304','S','N Falls','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.100160,-78.955200,0,'2013-07-06 12:44:31',NULL,NULL),(29688,'32927','S','Port Saint John','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.470183,-80.797492,0,'2013-07-06 12:44:32',NULL,NULL),(77613,'96944','P','Kosrae Caroline Islands','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',5.310246,162.962756,0,'2013-07-06 12:44:34',NULL,NULL),(21569,'22827','S','Elkton','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.409979,-78.620915,0,'2013-07-06 12:44:31',NULL,NULL),(37193,'41514','S','Goody','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(22956,'24658','P','Wolford','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.352536,-81.991717,0,'2013-07-06 12:44:31',NULL,NULL),(11235,'11755','S','Lk Grove','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.858261,-73.117533,0,'2013-07-06 12:44:30',NULL,NULL),(13352,'13696','S','W Stockholm','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.734551,-74.887585,0,'2013-07-06 12:44:30',NULL,NULL),(38503,'43702','P','S Zanesville','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.940823,-82.006789,0,'2013-07-06 12:44:32',NULL,NULL),(889,'00704','S','Paseo Costa Del Sur','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(166,'00623','S','Bo Ballaja','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(53619,'62088','S','Williamson','N','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.011425,-89.787070,0,'2013-07-06 12:44:33',NULL,NULL),(5963,'05301','S','Halifax','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(5920,'05251','S','S Dorset','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.222500,-73.073889,0,'2013-07-06 12:44:30',NULL,NULL),(74814,'93218','P','Ducor','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',35.889584,-119.097731,0,'2013-07-06 12:44:34',NULL,NULL),(62139,'73703','S','Enid','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.397422,-97.917494,0,'2013-07-06 12:44:33',NULL,NULL),(61533,'72675','S','St Joe','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.965276,-92.812156,0,'2013-07-06 12:44:33',NULL,NULL),(12579,'13069','S','Granby','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(33017,'36695','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.647608,-88.237461,0,'2013-07-06 12:44:32',NULL,NULL),(25384,'28263','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.151538,-80.873152,0,'2013-07-06 12:44:31',NULL,NULL),(14233,'14810','S','Bath','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.342030,-77.318938,0,'2013-07-06 12:44:31',NULL,NULL),(46596,'53550','S','Juda','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.502945,-89.510157,0,'2013-07-06 12:44:32',NULL,NULL),(14466,'15120','S','Homestead','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.394809,-79.903215,0,'2013-07-06 12:44:31',NULL,NULL),(19427,'20102','U','Dulles','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.956561,-77.450321,0,'2013-07-06 12:44:31',NULL,NULL),(71468,'87059','S','Escobosa','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.015760,-106.279680,0,'2013-07-06 12:44:34',NULL,NULL),(35363,'39440','S','Strengthford','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(14118,'14644','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.153845,-77.603654,0,'2013-07-06 12:44:31',NULL,NULL),(31523,'34477','P','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.187714,-82.129017,0,'2013-07-06 12:44:32',NULL,NULL),(15209,'16001','S','Meridian','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.858537,-79.902516,0,'2013-07-06 12:44:31',NULL,NULL),(41527,'46988','S','Twelve Mile','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.858248,-86.204585,0,'2013-07-06 12:44:32',NULL,NULL),(66288,'78582','S','Santa Cruz','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(40198,'45385','S','Beavercrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.691445,-83.953106,0,'2013-07-06 12:44:32',NULL,NULL),(45439,'51108','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.550920,-96.390240,0,'2013-07-06 12:44:32',NULL,NULL),(74663,'92850','U','Household Finance','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.844215,-117.955546,0,'2013-07-06 12:44:34',NULL,NULL),(47980,'55127','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(23578,'25665','P','Borderland','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.713816,-82.306041,0,'2013-07-06 12:44:31',NULL,NULL),(54628,'62918','S','Dewmaine','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.789020,-89.096520,0,'2013-07-06 12:44:33',NULL,NULL),(37570,'42078','S','Lola','A','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.242613,-88.281093,0,'2013-07-06 12:44:32',NULL,NULL),(23313,'25206','S','Van','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.955990,-81.693339,0,'2013-07-06 12:44:31',NULL,NULL),(25757,'28582','S','Stella','D','Carteret','37031','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.751786,-77.152727,0,'2013-07-06 12:44:31',NULL,NULL),(75265,'93673','P','Traver','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.455162,-119.485438,0,'2013-07-06 12:44:34',NULL,NULL),(74600,'92705','S','Cowan Heights','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.753989,-117.791852,0,'2013-07-06 12:44:34',NULL,NULL),(40847,'46224','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.792960,-86.257080,0,'2013-07-06 12:44:32',NULL,NULL),(76829,'95959','S','North Columbia','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.273440,-121.022061,0,'2013-07-06 12:44:34',NULL,NULL),(40620,'46011','S','Ctry Clb Hgts','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(10090,'10212','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713127,-74.010130,0,'2013-07-06 12:44:30',NULL,NULL),(48339,'55472','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.980177,-93.268143,0,'2013-07-06 12:44:33',NULL,NULL),(16547,'17307','S','Beecherstown','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(72842,'89835','S','Cobre','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(5561,'04859','S','Spruce Head','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.013030,-69.171205,0,'2013-07-06 12:44:30',NULL,NULL),(6089,'05450','S','Hill West','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(24068,'26434','P','Shirley','D','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.397058,-80.766413,0,'2013-07-06 12:44:31',NULL,NULL),(6222,'05488','S','West Swanton','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(24117,'26541','S','Core','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.705779,-79.993492,0,'2013-07-06 12:44:31',NULL,NULL),(17342,'17868','P','Riverside','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.957337,-76.628912,0,'2013-07-06 12:44:31',NULL,NULL),(33219,'37058','S','Dover','D','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.482869,-87.833627,0,'2013-07-06 12:44:32',NULL,NULL),(10978,'11542','S','Glen Cove','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.865104,-73.627060,0,'2013-07-06 12:44:30',NULL,NULL),(10584,'11022','P','Lake Gardens','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.787695,-73.731862,0,'2013-07-06 12:44:30',NULL,NULL),(36339,'40403','S','Berea','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.582920,-84.274023,0,'2013-07-06 12:44:32',NULL,NULL),(38716,'44022','S','Chagrin Falls','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(40665,'46051','S','Lapel','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.061719,-85.834745,0,'2013-07-06 12:44:32',NULL,NULL),(12029,'12516','S','Copake','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.118527,-73.556302,0,'2013-07-06 12:44:30',NULL,NULL),(67119,'79740','S','Girvin','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',31.061833,-102.390693,0,'2013-07-06 12:44:34',NULL,NULL),(17349,'17870','S','Penn Avon','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(25257,'28115','S','Mooresville','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.575801,-80.819083,0,'2013-07-06 12:44:31',NULL,NULL),(74049,'92152','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.691593,-117.247143,0,'2013-07-06 12:44:34',NULL,NULL),(62843,'75015','P','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.895571,-96.973722,0,'2013-07-06 12:44:33',NULL,NULL),(49634,'56935','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(38742,'44030','S','Farnham','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(61914,'73147','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483574,-97.582013,0,'2013-07-06 12:44:33',NULL,NULL),(1743,'00778','S','Urb Paraiso de Gurabo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(28313,'31139','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.748107,-84.384924,0,'2013-07-06 12:44:31',NULL,NULL),(8347,'08043','S','Voorhees','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(46810,'54005','S','Black Brook','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.249537,-92.272632,0,'2013-07-06 12:44:32',NULL,NULL),(39704,'45042','S','Liberty Twp','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.545160,-84.439260,0,'2013-07-06 12:44:32',NULL,NULL),(16521,'17268','S','Eastland Hill','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(4719,'03823','S','Madbury','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.191006,-70.892244,0,'2013-07-06 12:44:30',NULL,NULL),(30337,'33309','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(38753,'44035','S','Sheffield Vlg','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(47987,'55128','S','Pine Springs','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.007260,-92.964120,0,'2013-07-06 12:44:33',NULL,NULL),(19931,'20560','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885489,-77.026296,0,'2013-07-06 12:44:31',NULL,NULL),(42930,'48115','P','Bridgewater','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.160506,-83.921332,0,'2013-07-06 12:44:32',NULL,NULL),(25037,'27906','P','Elizabeth City','D','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.286618,-76.216871,0,'2013-07-06 12:44:31',NULL,NULL),(53160,'61565','S','Hopewell','A','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.995506,-89.451602,0,'2013-07-06 12:44:33',NULL,NULL),(5897,'05156','S','Orchard Lane','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.289460,-72.474780,0,'2013-07-06 12:44:30',NULL,NULL),(31294,'34058','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(42280,'47586','S','Burglen Hills','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(75762,'94620','P','Oakland','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.777570,-122.214747,0,'2013-07-06 12:44:34',NULL,NULL),(5470,'04739','S','Winterville Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.040052,-68.589901,0,'2013-07-06 12:44:30',NULL,NULL),(39800,'45135','S','Hglnd County','A','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(44339,'49766','S','Ossineke','D','Alpena','26007','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.921005,-83.461892,0,'2013-07-06 12:44:32',NULL,NULL),(19941,'20572','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905845,-77.030192,0,'2013-07-06 12:44:31',NULL,NULL),(77714,'97058','S','Celilo','N','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.598999,-121.193323,0,'2013-07-06 12:44:34',NULL,NULL),(67057,'79556','S','Sweetwater','D','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.465940,-100.386240,0,'2013-07-06 12:44:34',NULL,NULL),(39829,'45154','S','Five Mile','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',39.046508,-83.928470,0,'2013-07-06 12:44:32',NULL,NULL),(5424,'04669','S','Prospect Hbr','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.422425,-68.036636,0,'2013-07-06 12:44:30',NULL,NULL),(18641,'19162','U','Firm Zip Concept (Courtesy)','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955702,-75.181007,0,'2013-07-06 12:44:31',NULL,NULL),(72830,'89825','S','San Jacinto','N','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',41.763600,-115.074720,0,'2013-07-06 12:44:34',NULL,NULL),(33498,'37355','S','Manchester','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.474428,-86.106025,0,'2013-07-06 12:44:32',NULL,NULL),(39731,'45065','S','South Lebanon','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.372350,-84.213694,0,'2013-07-06 12:44:32',NULL,NULL),(18344,'19033','S','Folsom','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889987,-75.326801,0,'2013-07-06 12:44:31',NULL,NULL),(1099,'00725','S','Urb Machin','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(24035,'26404','S','Meadowbrook','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.344669,-80.314209,0,'2013-07-06 12:44:31',NULL,NULL),(2623,'00962','S','Urb Bajo Costo','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(65861,'78210','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.399131,-98.470390,0,'2013-07-06 12:44:34',NULL,NULL),(64776,'77003','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.749706,-95.346364,0,'2013-07-06 12:44:34',NULL,NULL),(58503,'68767','S','Pierce','D','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.199417,-97.528592,0,'2013-07-06 12:44:33',NULL,NULL),(3717,'02144','S','W Somerville','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.399028,-71.123138,0,'2013-07-06 12:44:30',NULL,NULL),(39380,'44647','S','Massillon','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.797699,-81.552259,0,'2013-07-06 12:44:32',NULL,NULL),(37922,'42633','S','Susie','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(42129,'47501','S','Veale','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(47449,'54729','S','Bateman','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(2909,'00988','P','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.406651,-65.980313,0,'2013-07-06 12:44:30',NULL,NULL),(4163,'02783','U','Chadwicks','N','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.018670,-71.053316,0,'2013-07-06 12:44:30',NULL,NULL),(25415,'28301','S','E Fayetteville','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(9693,'10045','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(48503,'55736','S','Prairie Lake','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(77597,'96932','P','Hagatna','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.475530,144.748524,0,'2013-07-06 12:44:34',NULL,NULL),(69899,'84106','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(52103,'60412','P','Chicago Heights','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.510829,-87.636167,0,'2013-07-06 12:44:33',NULL,NULL),(4392,'03110','S','Bedford','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.943642,-71.521201,0,'2013-07-06 12:44:30',NULL,NULL),(63675,'75859','S','Stewards Mill','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.921560,-96.280920,0,'2013-07-06 12:44:34',NULL,NULL),(51451,'59482','S','Sunburst','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.879734,-111.911966,0,'2013-07-06 12:44:33',NULL,NULL),(1562,'00766','S','Urb Las Alondras','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(4876,'04034','U','LL Bean Co','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.856581,-70.102589,0,'2013-07-06 12:44:30',NULL,NULL),(26693,'29406','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.928960,-80.028420,0,'2013-07-06 12:44:31',NULL,NULL),(45442,'51111','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.425511,-96.375133,0,'2013-07-06 12:44:32',NULL,NULL),(26655,'29369','S','Moore','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.874823,-82.020790,0,'2013-07-06 12:44:31',NULL,NULL),(13007,'13416','S','Newport','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.189629,-75.018362,0,'2013-07-06 12:44:30',NULL,NULL),(7137,'06403','S','Beacon Falls','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.436391,-73.065016,0,'2013-07-06 12:44:30',NULL,NULL),(37452,'41845','S','Premium','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.147265,-82.892244,0,'2013-07-06 12:44:32',NULL,NULL),(52958,'61421','S','Bradford','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.177575,-89.653011,0,'2013-07-06 12:44:33',NULL,NULL),(21189,'22183','P','Vienna','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.897446,-77.254343,0,'2013-07-06 12:44:31',NULL,NULL),(27513,'30187','S','Winston','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.670933,-84.838664,0,'2013-07-06 12:44:31',NULL,NULL),(34592,'38744','S','Valewood','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.035500,-91.016167,0,'2013-07-06 12:44:32',NULL,NULL),(12103,'12577','S','Salisbury Mls','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.433031,-74.121400,0,'2013-07-06 12:44:30',NULL,NULL),(46621,'53578','S','Pr du Sac','A','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.289654,-89.736826,0,'2013-07-06 12:44:32',NULL,NULL),(150,'00617','S','Urb Cataluna','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(72391,'89040','S','Stewarts Point','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(62159,'73731','S','Dacoma','D','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.660848,-98.566763,0,'2013-07-06 12:44:33',NULL,NULL),(51905,'60103','S','Cloverdale','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.966534,-88.165433,0,'2013-07-06 12:44:33',NULL,NULL),(38828,'44082','S','Pierpont','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.762768,-80.563672,0,'2013-07-06 12:44:32',NULL,NULL),(13474,'13787','S','South Nineveh','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.189300,-75.684780,0,'2013-07-06 12:44:31',NULL,NULL),(2664,'00966','S','Urb Prado Alto','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(70952,'85643','S','Kansas Settlement','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(70166,'84321','S','Logan','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.736480,-111.673800,0,'2013-07-06 12:44:34',NULL,NULL),(66568,'78738','S','Lakeway','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(51424,'59452','S','Hobson','D','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.869446,-110.205075,0,'2013-07-06 12:44:33',NULL,NULL),(31024,'33786','S','Belleair Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(39843,'45162','S','Pleasant Pln','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.296640,-84.086520,0,'2013-07-06 12:44:32',NULL,NULL),(42160,'47523','S','Carter','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.173260,-86.999460,0,'2013-07-06 12:44:32',NULL,NULL),(16463,'17241','S','Heberlig','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(23889,'26178','S','Burnt House','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.067760,-81.069659,0,'2013-07-06 12:44:31',NULL,NULL),(14250,'14826','S','Cohocton','D','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.498624,-77.510139,0,'2013-07-06 12:44:31',NULL,NULL),(35123,'39212','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.243548,-90.263734,0,'2013-07-06 12:44:32',NULL,NULL),(64880,'77068','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.002024,-95.486495,0,'2013-07-06 12:44:34',NULL,NULL),(17926,'18466','S','Coolbaugh Twp','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.183409,-75.377541,0,'2013-07-06 12:44:31',NULL,NULL),(62292,'74020','S','Shady Grove','A','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.273480,-96.430080,0,'2013-07-06 12:44:33',NULL,NULL),(19017,'19529','S','Stony Run','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(5928,'05253','S','E Dorset','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.283889,-73.002778,0,'2013-07-06 12:44:30',NULL,NULL),(39190,'44321','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.104382,-81.650553,0,'2013-07-06 12:44:32',NULL,NULL),(15312,'16154','S','Transfer','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.330766,-80.441553,0,'2013-07-06 12:44:31',NULL,NULL),(63507,'75712','P','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.323638,-95.293056,0,'2013-07-06 12:44:33',NULL,NULL),(60430,'71646','S','Beech Creek','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(51415,'59443','S','Fort Shaw','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.557372,-111.809255,0,'2013-07-06 12:44:33',NULL,NULL),(60663,'71921','S','Caney Valley','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(34981,'39096','S','Alcorn State University','N','Jefferson','28063','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.817159,-91.197038,0,'2013-07-06 12:44:32',NULL,NULL),(33630,'37681','S','Limestone','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.212327,-82.585503,0,'2013-07-06 12:44:32',NULL,NULL),(8560,'08210','S','Cape May Ch','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(50859,'58497','S','Ypsilanti','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.761553,-98.437967,0,'2013-07-06 12:44:33',NULL,NULL),(15475,'16430','S','North Springfield','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.999861,-80.428728,0,'2013-07-06 12:44:31',NULL,NULL),(6846,'06120','S','Unity Plaza','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.782640,-72.671860,0,'2013-07-06 12:44:30',NULL,NULL),(59109,'70143','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.822294,-90.011918,0,'2013-07-06 12:44:33',NULL,NULL),(58811,'69027','S','Enders','D','Chase','31029','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.480349,-101.515048,0,'2013-07-06 12:44:33',NULL,NULL),(57941,'67740','S','Hoxie','D','Sheridan','20179','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.352780,-100.163780,0,'2013-07-06 12:44:33',NULL,NULL),(5401,'04655','S','Bucks Harbor','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.669643,-67.408725,0,'2013-07-06 12:44:30',NULL,NULL),(74122,'92236','S','Coachella','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.680360,-116.178246,0,'2013-07-06 12:44:34',NULL,NULL),(72903,'90022','S','East Los Angeles','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.022686,-118.152363,0,'2013-07-06 12:44:34',NULL,NULL),(60501,'71665','S','Pansy','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(47570,'54843','S','Lco Commercial Cent','N','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.018712,-91.462960,0,'2013-07-06 12:44:33',NULL,NULL),(24483,'27248','S','Grays Chapel','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.749129,-79.701339,0,'2013-07-06 12:44:31',NULL,NULL),(4794,'03875','S','Silver Lake','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.849568,-71.176176,0,'2013-07-06 12:44:30',NULL,NULL),(9402,'09875','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9477,'10010','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(52835,'61313','S','Sunbury','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.063846,-88.642597,0,'2013-07-06 12:44:33',NULL,NULL),(19631,'20251','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886154,-77.021863,0,'2013-07-06 12:44:31',NULL,NULL),(19650,'20289','U','Universal Postal Union Congr','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.883057,-77.018850,0,'2013-07-06 12:44:31',NULL,NULL),(25131,'28009','P','Badin Air National Guard Sta','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.405852,-80.114436,0,'2013-07-06 12:44:31',NULL,NULL),(3339,'01542','S','Rochdale','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.198886,-71.905902,0,'2013-07-06 12:44:30',NULL,NULL),(70197,'84339','S','College Ward','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.645040,-111.918060,0,'2013-07-06 12:44:34',NULL,NULL),(50832,'58476','S','Edmunds','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.134183,-99.032822,0,'2013-07-06 12:44:33',NULL,NULL),(59135,'70165','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944694,-90.071602,0,'2013-07-06 12:44:33',NULL,NULL),(1149,'00727','S','Jard de Caguas','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(19840,'20505','U','Central Intelligence Agency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896385,-77.041564,0,'2013-07-06 12:44:31',NULL,NULL),(67902,'80902','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(66074,'78385','P','Sarita','D','Kenedy','48261','Texas','TX','48','0000','361','Central',-6.0,'Y',27.153295,-97.691283,0,'2013-07-06 12:44:34',NULL,NULL),(29100,'32301','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.429300,-84.257100,0,'2013-07-06 12:44:32',NULL,NULL),(77033,'96103','S','Cromberg','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(68939,'82933','S','Fort Bridger','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.299522,-110.390080,0,'2013-07-06 12:44:34',NULL,NULL),(48254,'55426','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952405,-93.377860,0,'2013-07-06 12:44:33',NULL,NULL),(68380,'81144','S','Monte Vista','D','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.566562,-106.148089,0,'2013-07-06 12:44:34',NULL,NULL),(56446,'65278','P','Renick','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.291553,-92.346488,0,'2013-07-06 12:44:33',NULL,NULL),(4651,'03752','S','Goshen','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.286343,-72.113495,0,'2013-07-06 12:44:30',NULL,NULL),(4910,'04069','S','Pownal','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.894744,-70.215812,0,'2013-07-06 12:44:30',NULL,NULL),(33632,'37682','P','Milligan Coll','A','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.302307,-82.296008,0,'2013-07-06 12:44:32',NULL,NULL),(75084,'93534','S','Lane','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(63340,'75603','S','Lakeport','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.435729,-94.725812,0,'2013-07-06 12:44:33',NULL,NULL),(54897,'63074','S','Northwest Plaza','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.727416,-90.387327,0,'2013-07-06 12:44:33',NULL,NULL),(51851,'60073','S','Round Lake Beach','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(5872,'05148','S','Landgrove','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.224333,-72.797903,0,'2013-07-06 12:44:30',NULL,NULL),(11565,'12064','S','E Worcester','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.557719,-74.644350,0,'2013-07-06 12:44:30',NULL,NULL),(50663,'58332','S','Esmond','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.099480,-99.705600,0,'2013-07-06 12:44:33',NULL,NULL),(29667,'32911','P','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.018087,-80.682599,0,'2013-07-06 12:44:32',NULL,NULL),(53984,'62440','S','Janesville','A','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.417463,-88.287007,0,'2013-07-06 12:44:33',NULL,NULL),(72372,'89031','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.256036,-115.140687,0,'2013-07-06 12:44:34',NULL,NULL),(66494,'78675','S','Willow City','D','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.449825,-98.726331,0,'2013-07-06 12:44:34',NULL,NULL),(59906,'71279','P','Start','D','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.489072,-91.858583,0,'2013-07-06 12:44:33',NULL,NULL),(53485,'61951','S','Sullivan','D','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.597396,-88.609239,0,'2013-07-06 12:44:33',NULL,NULL),(44237,'49659','S','Mancelona','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.913539,-85.039556,0,'2013-07-06 12:44:32',NULL,NULL),(22285,'23803','S','S Chesterfld','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.213860,-77.455680,0,'2013-07-06 12:44:31',NULL,NULL),(19697,'20375','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.941368,-77.089841,0,'2013-07-06 12:44:31',NULL,NULL),(19388,'20067','U','Pepco','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898458,-77.043288,0,'2013-07-06 12:44:31',NULL,NULL),(27501,'30175','S','Talking Rock','D','Pickens','13227','Georgia','GA','13','0520','706/762','Eastern',-5.0,'Y',34.545086,-84.527119,0,'2013-07-06 12:44:31',NULL,NULL),(79160,'98508','P','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.035520,-122.936595,0,'2013-07-06 12:44:34',NULL,NULL),(68484,'81252','S','Rosita','N','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.114881,-105.429189,0,'2013-07-06 12:44:34',NULL,NULL),(60560,'71748','P','Ivan','D','Dallas','05039','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.908253,-92.443094,0,'2013-07-06 12:44:33',NULL,NULL),(22472,'24050','U','Roanoke','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.346218,-79.957184,0,'2013-07-06 12:44:31',NULL,NULL),(32987,'36617','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.715635,-88.087882,0,'2013-07-06 12:44:32',NULL,NULL),(16145,'17059','S','Walker','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(23960,'26288','S','Webster Springs','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.497260,-80.369280,0,'2013-07-06 12:44:31',NULL,NULL),(11322,'11784','S','Selden','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.871531,-73.043571,0,'2013-07-06 12:44:30',NULL,NULL),(47791,'55047','S','Marine','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(67233,'79930','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.806169,-106.468363,0,'2013-07-06 12:44:34',NULL,NULL),(1252,'00729','S','Urb Loiza Valley','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(59447,'70725','S','Darrow','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.133676,-90.966684,0,'2013-07-06 12:44:33',NULL,NULL),(52632,'61047','S','Leaf River','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.165240,-89.401260,0,'2013-07-06 12:44:33',NULL,NULL),(52480,'60691','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875911,-87.614720,0,'2013-07-06 12:44:33',NULL,NULL),(2862,'00985','S','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(22385,'23939','P','Evergreen','D','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.320391,-78.764202,0,'2013-07-06 12:44:31',NULL,NULL),(46168,'52731','S','Sugar Creek','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.963040,-90.471130,0,'2013-07-06 12:44:32',NULL,NULL),(12388,'12921','S','Chazy Landing','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.889987,-73.466593,0,'2013-07-06 12:44:30',NULL,NULL),(17075,'17758','S','Nordmont','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(14708,'15267','U','Duguesne','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.467425,-80.037466,0,'2013-07-06 12:44:31',NULL,NULL),(15411,'16350','S','Sugargrove','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.956020,-79.332720,0,'2013-07-06 12:44:31',NULL,NULL),(24656,'27405','S','Mount Zion','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(80122,'99765','P','Nulato','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.612432,-159.209452,0,'2013-07-06 12:44:34',NULL,NULL),(38359,'43452','S','Middle Bass','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.536800,-82.908000,0,'2013-07-06 12:44:32',NULL,NULL),(39480,'44720','S','North Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.897320,-81.433440,0,'2013-07-06 12:44:32',NULL,NULL),(14045,'14559','S','Ogden','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.189174,-77.807274,0,'2013-07-06 12:44:31',NULL,NULL),(5984,'05346','S','Westminster W','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.955143,-72.565046,0,'2013-07-06 12:44:30',NULL,NULL),(3025,'01090','P','W Springfield','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.121280,-72.654857,0,'2013-07-06 12:44:30',NULL,NULL),(78035,'97434','S','Dorena','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.739244,-122.888624,0,'2013-07-06 12:44:34',NULL,NULL),(56298,'65084','S','Glensted','N','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.432613,-92.844180,0,'2013-07-06 12:44:33',NULL,NULL),(10869,'11417','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674260,-73.843796,0,'2013-07-06 12:44:30',NULL,NULL),(2652,'00966','S','Parq Mediterraneo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(39067,'44203','S','Barb','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.014711,-81.614500,0,'2013-07-06 12:44:32',NULL,NULL),(19533,'20189','S','Dulles','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.010055,-77.441171,0,'2013-07-06 12:44:31',NULL,NULL),(69140,'83302','S','Three Creek','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.208715,-114.593476,0,'2013-07-06 12:44:34',NULL,NULL),(59641,'71038','S','Ruple','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(1472,'00745','S','Urb Pedregales','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(42304,'47598','S','Winslow','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(15815,'16929','S','Somers Lane','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.993999,-77.123186,0,'2013-07-06 12:44:31',NULL,NULL),(64847,'77045','S','Trammells','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.632758,-95.424060,0,'2013-07-06 12:44:34',NULL,NULL),(9076,'09010','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(23103,'24938','S','Anthony','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.909770,-80.357408,0,'2013-07-06 12:44:31',NULL,NULL),(78823,'98335','S','Cromwell','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(65030,'77327','S','Cleveland','D','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(20719,'21281','P','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290875,-76.567741,0,'2013-07-06 12:44:31',NULL,NULL),(31349,'34201','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.390254,-82.481246,0,'2013-07-06 12:44:32',NULL,NULL),(3649,'02118','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.336960,-71.063760,0,'2013-07-06 12:44:30',NULL,NULL),(8847,'08645','U','Nj Income Tax','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217190,-74.769632,0,'2013-07-06 12:44:30',NULL,NULL),(47833,'55071','S','Saint Paul Park','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.826000,-92.990100,0,'2013-07-06 12:44:33',NULL,NULL),(12015,'12504','P','Annandale on Hudson','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.012397,-73.898328,0,'2013-07-06 12:44:30',NULL,NULL),(13228,'13637','S','Evans Mills','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.090947,-75.804665,0,'2013-07-06 12:44:30',NULL,NULL),(76655,'95728','P','The Cedars','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.320782,-120.408004,0,'2013-07-06 12:44:34',NULL,NULL),(65868,'78215','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.437563,-98.481061,0,'2013-07-06 12:44:34',NULL,NULL),(57579,'67061','S','Hazelton','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.124251,-98.404243,0,'2013-07-06 12:44:33',NULL,NULL),(33101,'36853','S','Dadeville','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.826979,-85.765591,0,'2013-07-06 12:44:32',NULL,NULL),(33575,'37424','P','Chatta','N','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.030239,-85.148472,0,'2013-07-06 12:44:32',NULL,NULL),(33014,'36689','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.688637,-88.169832,0,'2013-07-06 12:44:32',NULL,NULL),(271,'00646','S','Bo Saldinera','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(78641,'98222','S','Blakely Island','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.609071,-122.921563,0,'2013-07-06 12:44:34',NULL,NULL),(59335,'70541','P','Grand Coteau','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.417494,-92.045151,0,'2013-07-06 12:44:33',NULL,NULL),(57178,'66403','S','Axtell','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.871651,-96.258115,0,'2013-07-06 12:44:33',NULL,NULL),(16368,'17201','S','Kerrstown Sq','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(41297,'46765','S','Cedarville','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(75475,'94110','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.748224,-122.415699,0,'2013-07-06 12:44:34',NULL,NULL),(61483,'72638','S','Green Forest','D','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.331200,-93.423600,0,'2013-07-06 12:44:33',NULL,NULL),(20768,'21505','P','Cumberland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.658048,-78.746255,0,'2013-07-06 12:44:31',NULL,NULL),(76114,'95233','P','Hathaway Pnes','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.185926,-120.372735,0,'2013-07-06 12:44:34',NULL,NULL),(39955,'45235','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.274405,-84.398910,0,'2013-07-06 12:44:32',NULL,NULL),(45989,'52499','U','Life Investors Inc','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.974943,-91.655103,0,'2013-07-06 12:44:32',NULL,NULL),(57060,'66212','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955997,-94.682048,0,'2013-07-06 12:44:33',NULL,NULL),(49122,'56357','S','Ronneby','A','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.664722,-93.909444,0,'2013-07-06 12:44:33',NULL,NULL),(37572,'42079','S','Sedalia','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.566550,-88.586948,0,'2013-07-06 12:44:32',NULL,NULL),(11370,'11930','P','Beach Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.976299,-72.133670,0,'2013-07-06 12:44:30',NULL,NULL),(60371,'71480','P','Urania','D','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.863803,-92.290883,0,'2013-07-06 12:44:33',NULL,NULL),(37396,'41766','S','Thousandsticks','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.184094,-83.430195,0,'2013-07-06 12:44:32',NULL,NULL),(27981,'30571','S','Sautee','A','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.743332,-83.716475,0,'2013-07-06 12:44:31',NULL,NULL),(1706,'00777','S','Urb Virginia Vly','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(18116,'18801','S','Montrose','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.835677,-75.875138,0,'2013-07-06 12:44:31',NULL,NULL),(20894,'21709','U','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.427762,-77.415493,0,'2013-07-06 12:44:31',NULL,NULL),(6183,'05477','S','Richmond','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.383440,-72.973560,0,'2013-07-06 12:44:30',NULL,NULL),(21381,'22482','S','Kilmarnock','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.708103,-76.382222,0,'2013-07-06 12:44:31',NULL,NULL),(7945,'07666','S','West Englewood','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.891901,-74.008379,0,'2013-07-06 12:44:30',NULL,NULL),(47708,'54990','U','Iola','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.507553,-89.128307,0,'2013-07-06 12:44:33',NULL,NULL),(13276,'13655','S','Hogansburg','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.982946,-74.655861,0,'2013-07-06 12:44:30',NULL,NULL),(222,'00624','S','Urb Monte Verde','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(59663,'71051','S','Taylortown','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.362958,-93.497801,0,'2013-07-06 12:44:33',NULL,NULL),(56566,'65473','S','Ft Leonard Wd','A','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.826765,-92.218586,0,'2013-07-06 12:44:33',NULL,NULL),(41650,'47137','S','Leavenworth','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.209645,-86.365045,0,'2013-07-06 12:44:32',NULL,NULL),(22373,'23923','S','Charlotte Ch','N','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.091464,-78.658894,0,'2013-07-06 12:44:31',NULL,NULL),(15084,'15754','P','Lucernemines','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.544689,-79.156200,0,'2013-07-06 12:44:31',NULL,NULL),(69654,'84011','P','Bountiful','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.875659,-111.865622,0,'2013-07-06 12:44:34',NULL,NULL),(46874,'54104','S','Athelstane','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.460174,-88.241372,0,'2013-07-06 12:44:32',NULL,NULL),(77683,'97035','S','Lake Oswego','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.411593,-122.725222,0,'2013-07-06 12:44:34',NULL,NULL),(76485,'95630','S','Pine Bluff','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.683096,-121.160535,0,'2013-07-06 12:44:34',NULL,NULL),(29528,'32783','P','Titusville','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.543118,-80.855534,0,'2013-07-06 12:44:32',NULL,NULL),(37499,'42031','S','Clinton','D','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(62722,'74801','S','Johnson','A','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.309893,-96.920802,0,'2013-07-06 12:44:33',NULL,NULL),(51751,'60020','S','Fox Lake','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.394881,-88.176816,0,'2013-07-06 12:44:33',NULL,NULL),(46421,'53186','S','Waukesha','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.013231,-88.214586,0,'2013-07-06 12:44:32',NULL,NULL),(32314,'35759','S','Meridianville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.866627,-86.569504,0,'2013-07-06 12:44:32',NULL,NULL),(6299,'05654','S','Graniteville','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.149872,-72.473991,0,'2013-07-06 12:44:30',NULL,NULL),(26868,'29544','S','Galivants Ferry','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.127280,-79.108380,0,'2013-07-06 12:44:31',NULL,NULL),(1907,'00795','S','Est de Juana Diaz','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(55673,'64048','S','Holt','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.426632,-94.377199,0,'2013-07-06 12:44:33',NULL,NULL),(52459,'60677','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881607,-87.639724,0,'2013-07-06 12:44:33',NULL,NULL),(21535,'22731','S','Pratts','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.356136,-78.274541,0,'2013-07-06 12:44:31',NULL,NULL),(44714,'50145','P','Liberty Ctr','A','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.206742,-93.498722,0,'2013-07-06 12:44:32',NULL,NULL),(68848,'82604','S','Mills','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.826825,-106.381639,0,'2013-07-06 12:44:34',NULL,NULL),(61508,'72650','S','Marshall','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.940312,-92.656563,0,'2013-07-06 12:44:33',NULL,NULL),(7417,'06810','S','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.389689,-73.454963,0,'2013-07-06 12:44:30',NULL,NULL),(69881,'84101','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756416,-111.899070,0,'2013-07-06 12:44:34',NULL,NULL),(61764,'73055','S','Bray','A','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.644252,-97.961450,0,'2013-07-06 12:44:33',NULL,NULL),(21384,'22485','S','Shiloh','A','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299944,-77.147624,0,'2013-07-06 12:44:31',NULL,NULL),(33125,'36872','P','Valley','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.817410,-85.173370,0,'2013-07-06 12:44:32',NULL,NULL),(8963,'08810','S','Dayton','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.375752,-74.513413,0,'2013-07-06 12:44:30',NULL,NULL),(58311,'68437','S','Shubert','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.236902,-95.683475,0,'2013-07-06 12:44:33',NULL,NULL),(14388,'15044','S','Gibsonia','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.625976,-79.953769,0,'2013-07-06 12:44:31',NULL,NULL),(3590,'02025','S','Cohasset','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.237751,-70.809991,0,'2013-07-06 12:44:30',NULL,NULL),(8890,'08724','S','Wall','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.086348,-74.118215,0,'2013-07-06 12:44:30',NULL,NULL),(24646,'27376','S','West End','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.249640,-79.529160,0,'2013-07-06 12:44:31',NULL,NULL),(33658,'37716','S','Clinton','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.100413,-84.140862,0,'2013-07-06 12:44:32',NULL,NULL),(11821,'12237','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.645888,-73.797658,0,'2013-07-06 12:44:30',NULL,NULL),(49286,'56519','S','Borup','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.196075,-96.561026,0,'2013-07-06 12:44:33',NULL,NULL),(18621,'19150','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.070910,-75.171390,0,'2013-07-06 12:44:31',NULL,NULL),(79664,'99156','S','Newport','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.166272,-117.178085,0,'2013-07-06 12:44:34',NULL,NULL),(51271,'59104','P','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.772090,-108.581076,0,'2013-07-06 12:44:33',NULL,NULL),(38315,'43403','U','Bowling Green','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.376437,-83.650803,0,'2013-07-06 12:44:32',NULL,NULL),(5416,'04667','S','Perry','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983450,-67.107224,0,'2013-07-06 12:44:30',NULL,NULL),(3956,'02477','U','Watertown','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.377202,-71.153710,0,'2013-07-06 12:44:30',NULL,NULL),(3015,'01084','S','W Chesterfld','A','Hampshire','25015','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.408674,-72.889157,0,'2013-07-06 12:44:30',NULL,NULL),(38987,'44131','S','Valley View','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(6825,'06114','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.741050,-72.669085,0,'2013-07-06 12:44:30',NULL,NULL),(43731,'48930','U','State of Mich Dept Treasury','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734929,-84.559370,0,'2013-07-06 12:44:32',NULL,NULL),(14982,'15641','S','Hyde Park','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.631488,-79.590143,0,'2013-07-06 12:44:31',NULL,NULL),(46212,'52761','S','Muscatine','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.435833,-90.904444,0,'2013-07-06 12:44:32',NULL,NULL),(9488,'10012','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(80018,'99680','P','Tuntutuliak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.360000,-162.630000,0,'2013-07-06 12:44:34',NULL,NULL),(56469,'65302','P','Sedalia','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.708185,-93.222337,0,'2013-07-06 12:44:33',NULL,NULL),(28944,'32181','S','Pomona Park','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.472883,-81.615343,0,'2013-07-06 12:44:32',NULL,NULL),(71367,'86556','P','Tsaile','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.326278,-109.268065,0,'2013-07-06 12:44:34',NULL,NULL),(57262,'66540','S','Soldier','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.536330,-95.965460,0,'2013-07-06 12:44:33',NULL,NULL),(9761,'10103','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(9870,'10122','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(36678,'41015','S','Latonia','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(15482,'16438','S','Union City','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.924956,-79.856530,0,'2013-07-06 12:44:31',NULL,NULL),(145,'00617','S','Parc Magueyes','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(40197,'45384','P','Wilberforce','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.709101,-83.883356,0,'2013-07-06 12:44:32',NULL,NULL),(76884,'95977','S','Smartsville','D','Nevada','06057','California','CA','06','9340','530','Pacific',-8.0,'Y',39.197157,-121.253817,0,'2013-07-06 12:44:34',NULL,NULL),(62514,'74401','S','Muskogee','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(10965,'11516','S','Cedarhurst','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.627307,-73.720608,0,'2013-07-06 12:44:30',NULL,NULL),(33409,'37234','U','Lifeway Christian Resources','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.150333,-86.790926,0,'2013-07-06 12:44:32',NULL,NULL),(33886,'38027','P','Fisherville','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056954,-89.676442,0,'2013-07-06 12:44:32',NULL,NULL),(58026,'68001','P','Abie','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.345618,-96.964103,0,'2013-07-06 12:44:33',NULL,NULL),(56320,'65104','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.575066,-92.173635,0,'2013-07-06 12:44:33',NULL,NULL),(28828,'32081','S','Town of Nocatee','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173581,-81.395627,0,'2013-07-06 12:44:32',NULL,NULL),(29576,'32818','S','Pine Hills','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.577550,-81.496134,0,'2013-07-06 12:44:32',NULL,NULL),(30859,'33661','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.971525,-82.348109,0,'2013-07-06 12:44:32',NULL,NULL),(22169,'23464','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.798333,-76.177537,0,'2013-07-06 12:44:31',NULL,NULL),(35401,'39462','S','Hintonville','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.291608,-89.067446,0,'2013-07-06 12:44:32',NULL,NULL),(31343,'34142','S','Immokalee','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.327612,-81.313729,0,'2013-07-06 12:44:32',NULL,NULL),(58958,'70004','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.999438,-90.179568,0,'2013-07-06 12:44:33',NULL,NULL),(17298,'17851','S','Mt Carmel','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(17511,'17963','S','Pine Grove','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(62254,'74005','P','Bartlesville','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.748499,-95.980696,0,'2013-07-06 12:44:33',NULL,NULL),(53749,'62259','P','Menard','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.910186,-89.839804,0,'2013-07-06 12:44:33',NULL,NULL),(49852,'57241','S','Hayti','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.677517,-97.250132,0,'2013-07-06 12:44:33',NULL,NULL),(37898,'42631','P','Marshes Sdng','A','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.742909,-84.481254,0,'2013-07-06 12:44:32',NULL,NULL),(26216,'28788','P','Webster','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.351992,-83.213222,0,'2013-07-06 12:44:31',NULL,NULL),(57279,'66601','P','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.057109,-95.676547,0,'2013-07-06 12:44:33',NULL,NULL),(28436,'31404','S','State College','N','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.044042,-81.068991,0,'2013-07-06 12:44:32',NULL,NULL),(77820,'97203','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.590951,-122.740358,0,'2013-07-06 12:44:34',NULL,NULL),(73580,'91381','S','Stevenson Ranch','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.381783,-118.573262,0,'2013-07-06 12:44:34',NULL,NULL),(39583,'44857','S','Olena','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.238868,-82.602595,0,'2013-07-06 12:44:32',NULL,NULL),(62923,'75081','S','Richardson','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.950190,-96.710942,0,'2013-07-06 12:44:33',NULL,NULL),(50591,'58237','S','Nash','A','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.415200,-97.411740,0,'2013-07-06 12:44:33',NULL,NULL),(4481,'03272','P','S Newbury','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.296387,-71.995639,0,'2013-07-06 12:44:30',NULL,NULL),(13211,'13630','S','De Kalb Jct','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.483181,-75.298577,0,'2013-07-06 12:44:30',NULL,NULL),(46025,'52550','S','Delta','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.301976,-92.351351,0,'2013-07-06 12:44:32',NULL,NULL),(22227,'23604','S','Fort Eustis','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.978927,-76.426918,0,'2013-07-06 12:44:31',NULL,NULL),(62044,'73526','S','Blair','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.777382,-99.331725,0,'2013-07-06 12:44:33',NULL,NULL),(16991,'17728','S','Hepburn Hts','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(73980,'92086','S','Warner Springs','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.301094,-116.673009,0,'2013-07-06 12:44:34',NULL,NULL),(37207,'41522','S','Road Creek Junction','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(24705,'27497','U','USPS Hr Shared Svcs','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.044200,-79.859900,0,'2013-07-06 12:44:31',NULL,NULL),(26582,'29219','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.067593,-80.920837,0,'2013-07-06 12:44:31',NULL,NULL),(18940,'19507','S','Bethel','D','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.492547,-76.295435,0,'2013-07-06 12:44:31',NULL,NULL),(1969,'00840','S','Frederiksted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.712448,-64.882821,0,'2013-07-06 12:44:30',NULL,NULL),(19217,'19894','U','Hercules Incorporated','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.748520,-75.544089,0,'2013-07-06 12:44:31',NULL,NULL),(3511,'01866','P','Pinehurst','D','Middlesex','25017','Massachusetts','MA','25','4560','781/339','Eastern',-5.0,'Y',42.525394,-71.227935,0,'2013-07-06 12:44:30',NULL,NULL),(60131,'71373','S','Black Hawk','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(51157,'58853','P','Trenton','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.047911,-103.897497,0,'2013-07-06 12:44:33',NULL,NULL),(28171,'30919','P','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.470809,-82.067346,0,'2013-07-06 12:44:31',NULL,NULL),(41093,'46543','S','Millersburg','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.520705,-85.699646,0,'2013-07-06 12:44:32',NULL,NULL),(25121,'28001','S','Millingport','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(8459,'08087','S','Tuckerton Boro','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(35985,'40119','S','Falls Rough','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.587960,-86.493600,0,'2013-07-06 12:44:32',NULL,NULL),(32370,'35898','U','Redstone Arsenal','A','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.628936,-86.651129,0,'2013-07-06 12:44:32',NULL,NULL),(29069,'32250','S','Jacksonville Beach','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.281220,-81.416820,0,'2013-07-06 12:44:32',NULL,NULL),(62396,'74105','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.099428,-95.959689,0,'2013-07-06 12:44:33',NULL,NULL),(60772,'72015','S','Tull','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.566563,-92.583045,0,'2013-07-06 12:44:33',NULL,NULL),(59967,'71315','P','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.255060,-92.471756,0,'2013-07-06 12:44:33',NULL,NULL),(56183,'65013','S','Paydown','N','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(80002,'99669','S','Soldotna','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.493644,-151.078542,0,'2013-07-06 12:44:34',NULL,NULL),(70463,'84755','P','Mount Carmel','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.222039,-112.743904,0,'2013-07-06 12:44:34',NULL,NULL),(57859,'67572','S','Ransom','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.636320,-99.934490,0,'2013-07-06 12:44:33',NULL,NULL),(6289,'05648','S','Calais','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.398091,-72.480629,0,'2013-07-06 12:44:30',NULL,NULL),(11746,'12187','S','Warnerville','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.614747,-74.475755,0,'2013-07-06 12:44:30',NULL,NULL),(50664,'58332','S','Fillmore','A','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.099480,-99.705600,0,'2013-07-06 12:44:33',NULL,NULL),(52002,'60165','S','Stone Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.900556,-87.856667,0,'2013-07-06 12:44:33',NULL,NULL),(8892,'08724','S','Wall Twp','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.086348,-74.118215,0,'2013-07-06 12:44:30',NULL,NULL),(45449,'51235','S','Doon','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.276098,-96.229124,0,'2013-07-06 12:44:32',NULL,NULL),(40765,'46151','S','Centerton','A','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(32274,'35647','S','Lester','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.925555,-87.136408,0,'2013-07-06 12:44:32',NULL,NULL),(22090,'23405','S','Machipongo','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.403672,-75.910923,0,'2013-07-06 12:44:31',NULL,NULL),(39666,'45011','S','West Chester','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(9574,'10026','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(40383,'45658','S','Patriot','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.775857,-82.438825,0,'2013-07-06 12:44:32',NULL,NULL),(23906,'26206','S','Cowen','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.442060,-80.530200,0,'2013-07-06 12:44:31',NULL,NULL),(67974,'80914','P','Peterson Air Force Base','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(51706,'60008','S','Rolling Meadows','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.077830,-88.032318,0,'2013-07-06 12:44:33',NULL,NULL),(37092,'41339','S','Lambric','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(38407,'43534','S','Grelton','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.373000,-83.939975,0,'2013-07-06 12:44:32',NULL,NULL),(5525,'04777','S','Stacyville','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.896021,-68.492070,0,'2013-07-06 12:44:30',NULL,NULL),(42488,'47840','S','Ashboro','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.376944,-87.100716,0,'2013-07-06 12:44:32',NULL,NULL),(48030,'55303','S','Ramsey','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.261223,-93.440539,0,'2013-07-06 12:44:33',NULL,NULL),(78676,'98243','P','Deer Harbor','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.621122,-123.006088,0,'2013-07-06 12:44:34',NULL,NULL),(64805,'77024','S','Hedwig Village','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(52409,'60639','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.918417,-87.755959,0,'2013-07-06 12:44:33',NULL,NULL),(50954,'58621','S','Trotters','A','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.931605,-104.007445,0,'2013-07-06 12:44:33',NULL,NULL),(32877,'36526','S','Daphne','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.622635,-87.891959,0,'2013-07-06 12:44:32',NULL,NULL),(45826,'52209','S','Blairstown','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.907050,-92.081962,0,'2013-07-06 12:44:32',NULL,NULL),(41411,'46816','S','Maples','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(51298,'59221','S','Fairview','D','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.853273,-104.048590,0,'2013-07-06 12:44:33',NULL,NULL),(62987,'75148','S','Log Cabin','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.186698,-96.026721,0,'2013-07-06 12:44:33',NULL,NULL),(8613,'08243','S','Townsend Inlt','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.152160,-74.693700,0,'2013-07-06 12:44:30',NULL,NULL),(30930,'33711','S','Gulfport','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.751284,-82.687336,0,'2013-07-06 12:44:32',NULL,NULL),(48136,'55362','S','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.303033,-93.798977,0,'2013-07-06 12:44:33',NULL,NULL),(77786,'97130','P','Manzanita','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.720221,-123.934279,0,'2013-07-06 12:44:34',NULL,NULL),(7470,'06880','S','Westport','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.138856,-73.347965,0,'2013-07-06 12:44:30',NULL,NULL),(66806,'79073','P','Plainview','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',34.190366,-101.695464,0,'2013-07-06 12:44:34',NULL,NULL),(55737,'64088','S','Ft Osage','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.160798,-94.188480,0,'2013-07-06 12:44:33',NULL,NULL),(33275,'37110','S','Centertown','A','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.683587,-85.776477,0,'2013-07-06 12:44:32',NULL,NULL),(18988,'19522','S','Moselem Springs','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(22730,'24368','S','Grosclose','N','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.899249,-81.271748,0,'2013-07-06 12:44:31',NULL,NULL),(4313,'02911','S','No Providence','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(74808,'93208','P','Camp Nelson','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.137286,-118.611308,0,'2013-07-06 12:44:34',NULL,NULL),(65290,'77488','S','Burr','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(55021,'63135','S','Calverton Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748900,-90.303899,0,'2013-07-06 12:44:33',NULL,NULL),(22177,'23467','P','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.801711,-76.174222,0,'2013-07-06 12:44:31',NULL,NULL),(5159,'04426','S','Atkinson','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(19148,'19708','P','Kirkwood','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.498425,-75.684892,0,'2013-07-06 12:44:31',NULL,NULL),(599,'00680','S','Urb Flor del Valle','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(26982,'29617','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.921125,-82.476529,0,'2013-07-06 12:44:31',NULL,NULL),(41454,'46899','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.998617,-85.234375,0,'2013-07-06 12:44:32',NULL,NULL),(34551,'38723','P','Avon','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.263218,-91.025221,0,'2013-07-06 12:44:32',NULL,NULL),(32536,'36105','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.323522,-86.313946,0,'2013-07-06 12:44:32',NULL,NULL),(23033,'24849','S','Jesse','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.669558,-81.558865,0,'2013-07-06 12:44:31',NULL,NULL),(5054,'04274','S','Poland','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.018700,-70.371000,0,'2013-07-06 12:44:30',NULL,NULL),(33548,'37397','S','Powells Crsrd','A','Sequatchie','47153','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.198597,-85.514246,0,'2013-07-06 12:44:32',NULL,NULL),(25264,'28123','P','Mt Mourne','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.543985,-80.846555,0,'2013-07-06 12:44:31',NULL,NULL),(21084,'22034','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855963,-77.260199,0,'2013-07-06 12:44:31',NULL,NULL),(30238,'33193','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.693575,-80.445767,0,'2013-07-06 12:44:32',NULL,NULL),(38178,'43160','S','Wshngtn Ct Hs','A','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.536064,-83.442724,0,'2013-07-06 12:44:32',NULL,NULL),(8428,'08078','S','Runnemede','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.848224,-75.074135,0,'2013-07-06 12:44:30',NULL,NULL),(9271,'09617','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(40325,'45481','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.757610,-84.178798,0,'2013-07-06 12:44:32',NULL,NULL),(41968,'47421','S','Bartlettsville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(59844,'71250','S','Jones','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.939158,-91.554592,0,'2013-07-06 12:44:33',NULL,NULL),(73802,'91752','S','Riverside','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995007,-117.528742,0,'2013-07-06 12:44:34',NULL,NULL),(39288,'44488','U','Business Reply','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.240195,-80.819390,0,'2013-07-06 12:44:32',NULL,NULL),(31135,'33905','S','Tice','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.670910,-81.802140,0,'2013-07-06 12:44:32',NULL,NULL),(28228,'31039','P','Howard','D','Taylor','13269','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.595605,-84.249396,0,'2013-07-06 12:44:31',NULL,NULL),(1421,'00738','S','Vistas del Convento','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(13471,'13787','S','Centre Village','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.189300,-75.684780,0,'2013-07-06 12:44:31',NULL,NULL),(57758,'67449','S','Delavan','A','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.689020,-96.992160,0,'2013-07-06 12:44:33',NULL,NULL),(55099,'63304','S','Cottleville','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(57851,'67565','S','Galatia','A','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.534948,-99.052096,0,'2013-07-06 12:44:33',NULL,NULL),(28684,'31801','S','Box Springs','D','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.570820,-84.621720,0,'2013-07-06 12:44:32',NULL,NULL),(46382,'53141','P','Kenosha','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.583868,-87.822442,0,'2013-07-06 12:44:32',NULL,NULL),(16079,'17050','S','Mech','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(11408,'11957','S','Orient','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.154240,-72.249750,0,'2013-07-06 12:44:30',NULL,NULL),(50364,'57751','S','Keystone','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.942765,-103.362425,0,'2013-07-06 12:44:33',NULL,NULL),(6278,'05641','S','Barre','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(66910,'79314','P','Bledsoe','D','Cochran','48079','Texas','TX','48','0000','806','Central',-6.0,'Y',33.638888,-102.875067,0,'2013-07-06 12:44:34',NULL,NULL),(59662,'71051','S','Poole','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.362958,-93.497801,0,'2013-07-06 12:44:33',NULL,NULL),(32424,'35980','S','Horton','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.185171,-86.323300,0,'2013-07-06 12:44:32',NULL,NULL),(80185,'99901','S','Kasaan','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.373751,-131.692560,0,'2013-07-06 12:44:34',NULL,NULL),(66211,'78550','S','Kayare','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(64775,'77002','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757918,-95.361884,0,'2013-07-06 12:44:34',NULL,NULL),(17850,'18428','S','Blooming Grove','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.473980,-75.205080,0,'2013-07-06 12:44:31',NULL,NULL),(3801,'02238','P','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.374067,-71.117136,0,'2013-07-06 12:44:30',NULL,NULL),(28796,'32058','S','Lawtey','D','Bradford','12007','Florida','FL','12','0000','904','Eastern',-5.0,'Y',30.084190,-82.106221,0,'2013-07-06 12:44:32',NULL,NULL),(27008,'29638','S','Shoals Jct','A','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.374350,-82.272156,0,'2013-07-06 12:44:31',NULL,NULL),(40332,'45502','S','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.925374,-83.824327,0,'2013-07-06 12:44:32',NULL,NULL),(63113,'75285','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.767941,-96.827934,0,'2013-07-06 12:44:33',NULL,NULL),(63073,'75240','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.931962,-96.789191,0,'2013-07-06 12:44:33',NULL,NULL),(22326,'23856','S','Freeman','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.710889,-77.555557,0,'2013-07-06 12:44:31',NULL,NULL),(78937,'98366','S','View Park','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(55460,'63737','S','Brazeau','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.659303,-89.654551,0,'2013-07-06 12:44:33',NULL,NULL),(882,'00703','S','Mans de Aguas Buenas','N','Aguas Buenas','72007','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.261636,-66.103857,0,'2013-07-06 12:44:30',NULL,NULL),(20124,'20718','P','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.985875,-76.754152,0,'2013-07-06 12:44:31',NULL,NULL),(9250,'09582','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(40890,'46247','P','Southport','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.675539,-86.129380,0,'2013-07-06 12:44:32',NULL,NULL),(32892,'36535','S','Foley','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.398083,-87.704195,0,'2013-07-06 12:44:32',NULL,NULL),(18616,'19148','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.922429,-75.158025,0,'2013-07-06 12:44:31',NULL,NULL),(9055,'08901','S','New Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.487990,-74.447033,0,'2013-07-06 12:44:30',NULL,NULL),(68599,'81602','P','Glenwood Spgs','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.494181,-107.328253,0,'2013-07-06 12:44:34',NULL,NULL),(37354,'41722','S','Bulan','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(7241,'06511','S','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.327048,-72.940381,0,'2013-07-06 12:44:30',NULL,NULL),(76934,'96019','S','Shasta Lake','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.681560,-122.377440,0,'2013-07-06 12:44:34',NULL,NULL),(73094,'90224','P','Rancho Dominguez','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.871965,-118.266771,0,'2013-07-06 12:44:34',NULL,NULL),(41849,'47353','S','Cottagegrove','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(4199,'02828','S','Greenville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.874239,-71.552403,0,'2013-07-06 12:44:30',NULL,NULL),(16954,'17702','S','Bastress','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(14933,'15557','S','Rockwood','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.916771,-79.153621,0,'2013-07-06 12:44:31',NULL,NULL),(7398,'06792','U','Harwinton','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.754900,-73.058200,0,'2013-07-06 12:44:30',NULL,NULL),(1490,'00751','S','Est De Evelymar','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(67073,'79567','S','Winters','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(55961,'64497','S','Weatherby','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.889149,-94.261031,0,'2013-07-06 12:44:33',NULL,NULL),(35666,'39652','S','Magnolia','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.144640,-90.458735,0,'2013-07-06 12:44:32',NULL,NULL),(42391,'47725','S','McCutchanville','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974596,-87.555538,0,'2013-07-06 12:44:32',NULL,NULL),(42861,'48080','S','St Clr Shrs','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465933,-82.903852,0,'2013-07-06 12:44:32',NULL,NULL),(57340,'66720','S','Earlton','N','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.640820,-95.464980,0,'2013-07-06 12:44:33',NULL,NULL),(31206,'33949','P','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.975820,-82.090800,0,'2013-07-06 12:44:32',NULL,NULL),(17780,'18346','S','Pocono Summit','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.108809,-75.415877,0,'2013-07-06 12:44:31',NULL,NULL),(6654,'06021','S','Colbrook','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.999755,-73.098758,0,'2013-07-06 12:44:30',NULL,NULL),(12307,'12854','S','North Granville','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.507018,-73.335407,0,'2013-07-06 12:44:30',NULL,NULL),(43919,'49263','P','Norvell','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.159227,-84.184591,0,'2013-07-06 12:44:32',NULL,NULL),(43018,'48165','S','New Hudson','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.506178,-83.626234,0,'2013-07-06 12:44:32',NULL,NULL),(19764,'20417','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885642,-77.021833,0,'2013-07-06 12:44:31',NULL,NULL),(12116,'12590','S','New Hamburg','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.595832,-73.887450,0,'2013-07-06 12:44:30',NULL,NULL),(1955,'00804','P','St Thomas','D','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.349002,-64.932125,0,'2013-07-06 12:44:30',NULL,NULL),(76840,'95963','S','Newville','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.745762,-122.190763,0,'2013-07-06 12:44:34',NULL,NULL),(73675,'91601','S','Toluca Terrace','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(55480,'63752','P','Gordonville','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.313943,-89.678711,0,'2013-07-06 12:44:33',NULL,NULL),(32322,'35763','S','Owens X Rds','A','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.610433,-86.463316,0,'2013-07-06 12:44:32',NULL,NULL),(38932,'44122','S','University Ht','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(17849,'18427','S','Hamlin','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.397513,-75.350190,0,'2013-07-06 12:44:31',NULL,NULL),(43349,'48382','S','Commerce Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.583560,-83.500320,0,'2013-07-06 12:44:32',NULL,NULL),(37055,'41301','S','Leeco','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(68130,'80960','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.810217,-104.816961,0,'2013-07-06 12:44:34',NULL,NULL),(4487,'03275','S','Pembroke','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.173240,-71.403720,0,'2013-07-06 12:44:30',NULL,NULL),(7810,'07444','S','Pompton Plains','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.965391,-74.307529,0,'2013-07-06 12:44:30',NULL,NULL),(79207,'98536','S','Copalis Xing','A','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.141395,-124.099068,0,'2013-07-06 12:44:34',NULL,NULL),(64897,'77084','S','Addicks Barker','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.821140,-95.640017,0,'2013-07-06 12:44:34',NULL,NULL),(62810,'74944','S','McCurtain','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.130662,-95.024409,0,'2013-07-06 12:44:33',NULL,NULL),(47821,'55063','S','Beroun','A','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.910278,-92.955000,0,'2013-07-06 12:44:33',NULL,NULL),(46020,'52544','S','Numa','A','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.727537,-92.865109,0,'2013-07-06 12:44:32',NULL,NULL),(31579,'34653','S','New Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.248579,-82.701991,0,'2013-07-06 12:44:32',NULL,NULL),(55929,'64469','S','Fairport','A','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.888652,-94.356601,0,'2013-07-06 12:44:33',NULL,NULL),(46668,'53715','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.063624,-89.394312,0,'2013-07-06 12:44:32',NULL,NULL),(77956,'97364','S','Neotsu','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.996636,-123.985765,0,'2013-07-06 12:44:34',NULL,NULL),(36381,'40473','P','Renfro Vly','A','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.388535,-84.330442,0,'2013-07-06 12:44:32',NULL,NULL),(72411,'89047','P','Silverpeak','D','Esmeralda','32009','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.804091,-117.875942,0,'2013-07-06 12:44:34',NULL,NULL),(19996,'20603','S','Waldorf','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.628435,-76.968736,0,'2013-07-06 12:44:31',NULL,NULL),(24020,'26369','P','Hepzibah','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.331489,-80.336714,0,'2013-07-06 12:44:31',NULL,NULL),(8267,'08009','S','Albion','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.759420,-74.927340,0,'2013-07-06 12:44:30',NULL,NULL),(24826,'27607','S','State University','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.804021,-78.697656,0,'2013-07-06 12:44:31',NULL,NULL),(45937,'52338','S','Shueyville','A','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.848730,-91.697035,0,'2013-07-06 12:44:32',NULL,NULL),(70536,'85020','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.558755,-112.056402,0,'2013-07-06 12:44:34',NULL,NULL),(67905,'80903','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.831839,-104.818927,0,'2013-07-06 12:44:34',NULL,NULL),(60730,'71958','S','Murfreesboro','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.060950,-93.689939,0,'2013-07-06 12:44:33',NULL,NULL),(58287,'68410','S','Wyoming','N','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.674994,-95.861844,0,'2013-07-06 12:44:33',NULL,NULL),(53974,'62436','S','Jewett','D','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.201079,-88.247263,0,'2013-07-06 12:44:33',NULL,NULL),(52737,'61237','P','Buffalo Prairie','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.384604,-90.911022,0,'2013-07-06 12:44:33',NULL,NULL),(41792,'47325','S','Springersville','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.717506,-84.963353,0,'2013-07-06 12:44:32',NULL,NULL),(31771,'35011','P','Alexander City','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.927018,-85.937364,0,'2013-07-06 12:44:32',NULL,NULL),(30313,'33305','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.156150,-80.122239,0,'2013-07-06 12:44:32',NULL,NULL),(28833,'32084','S','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.885160,-81.313980,0,'2013-07-06 12:44:32',NULL,NULL),(887,'00704','S','Parc Cabasa','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(70020,'84128','S','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(69242,'83420','S','Warm River','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.042760,-111.375420,0,'2013-07-06 12:44:34',NULL,NULL),(65354,'77523','S','Old River-Winfree','A','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(52603,'61021','S','Grand Detour','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.838841,-89.492572,0,'2013-07-06 12:44:33',NULL,NULL),(44676,'50119','S','Harvey','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.317591,-92.930643,0,'2013-07-06 12:44:32',NULL,NULL),(78033,'97432','P','Dillard','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.167162,-123.448322,0,'2013-07-06 12:44:34',NULL,NULL),(60383,'71497','U','Nsu','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.755063,-93.101240,0,'2013-07-06 12:44:33',NULL,NULL),(55599,'63941','S','Fremont','D','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.855192,-91.124656,0,'2013-07-06 12:44:33',NULL,NULL),(5010,'04225','P','Dryden','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.584996,-70.215655,0,'2013-07-06 12:44:30',NULL,NULL),(29899,'33050','S','Duck Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(33317,'37137','S','Nunnelly','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.833500,-87.445662,0,'2013-07-06 12:44:32',NULL,NULL),(41101,'46554','S','North Liberty','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.552550,-86.407096,0,'2013-07-06 12:44:32',NULL,NULL),(77887,'97281','P','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.441124,-122.779329,0,'2013-07-06 12:44:34',NULL,NULL),(60264,'71446','S','Sandy Hill','N','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(5628,'04943','S','Hartland','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.887826,-69.455219,0,'2013-07-06 12:44:30',NULL,NULL),(7778,'07421','S','Greenwood Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.157420,-74.352660,0,'2013-07-06 12:44:30',NULL,NULL),(38566,'43772','S','Pleasant City','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.906705,-81.552435,0,'2013-07-06 12:44:32',NULL,NULL),(39265,'44450','S','North Bloomfield','D','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.460780,-80.830440,0,'2013-07-06 12:44:32',NULL,NULL),(39533,'44830','S','Amsden','A','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.185277,-83.406022,0,'2013-07-06 12:44:32',NULL,NULL),(14327,'15001','S','Aliq','N','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(25575,'28433','S','Clarkton','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.518659,-78.643650,0,'2013-07-06 12:44:31',NULL,NULL),(76192,'95346','S','Mi Wuk Vlg','A','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.067102,-120.180965,0,'2013-07-06 12:44:34',NULL,NULL),(60523,'71670','S','Tillar','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.672180,-91.540620,0,'2013-07-06 12:44:33',NULL,NULL),(56249,'65054','S','Loose Creek','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.462264,-91.955107,0,'2013-07-06 12:44:33',NULL,NULL),(27856,'30438','P','Manassas','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.088685,-82.052572,0,'2013-07-06 12:44:31',NULL,NULL),(79536,'98946','S','Thorp','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.034110,-120.933721,0,'2013-07-06 12:44:34',NULL,NULL),(60252,'71438','S','Leander','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.149021,-92.748532,0,'2013-07-06 12:44:33',NULL,NULL),(15569,'16647','S','Hesston','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.391110,-78.113027,0,'2013-07-06 12:44:31',NULL,NULL),(31806,'35049','S','Nectar','A','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.969191,-86.598370,0,'2013-07-06 12:44:32',NULL,NULL),(17803,'18373','P','Unity House','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.148666,-75.009201,0,'2013-07-06 12:44:31',NULL,NULL),(29344,'32550','S','Sandestin','A','Walton','12131','Florida','FL','12','2750','850','Central',-6.0,'Y',30.393333,-86.495833,0,'2013-07-06 12:44:32',NULL,NULL),(6919,'06154','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.773119,-72.707051,0,'2013-07-06 12:44:30',NULL,NULL),(14916,'15539','S','Fishertown','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.125076,-78.587631,0,'2013-07-06 12:44:31',NULL,NULL),(15759,'16915','S','Eulalia','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(65587,'77870','P','New Baden','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',31.049013,-96.425612,0,'2013-07-06 12:44:34',NULL,NULL),(33343,'37171','S','Southside','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.362704,-87.304340,0,'2013-07-06 12:44:32',NULL,NULL),(2981,'01059','P','North Amherst','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.413287,-72.530513,0,'2013-07-06 12:44:30',NULL,NULL),(72962,'90044','S','Hancock','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.956268,-118.290701,0,'2013-07-06 12:44:34',NULL,NULL),(57077,'66215','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(3981,'02535','S','Aquinnah','A','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.334586,-70.746397,0,'2013-07-06 12:44:30',NULL,NULL),(4034,'02573','P','West Chop','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.441817,-70.600178,0,'2013-07-06 12:44:30',NULL,NULL),(75278,'93710','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.828337,-119.763080,0,'2013-07-06 12:44:34',NULL,NULL),(59357,'70575','P','Perry','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.946075,-92.158608,0,'2013-07-06 12:44:33',NULL,NULL),(51051,'58737','S','Flaxton','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.916096,-102.296386,0,'2013-07-06 12:44:33',NULL,NULL),(27078,'29702','S','Cherokee Fls','A','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.115670,-81.513969,0,'2013-07-06 12:44:31',NULL,NULL),(28457,'31411','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.942043,-81.033866,0,'2013-07-06 12:44:32',NULL,NULL),(6543,'05839','S','Glover','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.702820,-72.209220,0,'2013-07-06 12:44:30',NULL,NULL),(35255,'39347','S','Pachuta','D','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.004817,-88.865821,0,'2013-07-06 12:44:32',NULL,NULL),(66106,'78411','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.743325,-97.390984,0,'2013-07-06 12:44:34',NULL,NULL),(32923,'36558','S','Bigbee','A','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(24743,'27530','S','Goldsboro','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.379960,-78.097860,0,'2013-07-06 12:44:31',NULL,NULL),(25366,'28243','U','AT&T','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.221435,-80.837627,0,'2013-07-06 12:44:31',NULL,NULL),(72030,'88054','P','Radium Spgs','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.641333,-107.073950,0,'2013-07-06 12:44:34',NULL,NULL),(70077,'84151','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.787872,-111.938789,0,'2013-07-06 12:44:34',NULL,NULL),(68336,'81122','S','Chimney Rock','A','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.314420,-107.612280,0,'2013-07-06 12:44:34',NULL,NULL),(38977,'44130','S','Middleburg Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(51982,'60153','S','Broadview','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.872080,-87.847320,0,'2013-07-06 12:44:33',NULL,NULL),(8670,'08323','S','Greenwich Township','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.390568,-75.341496,0,'2013-07-06 12:44:30',NULL,NULL),(383,'00660','S','Urb Verdun Ii','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(14839,'15438','S','Fayette City','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.098910,-79.838617,0,'2013-07-06 12:44:31',NULL,NULL),(33441,'37308','S','Birchwood','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.304557,-85.011238,0,'2013-07-06 12:44:32',NULL,NULL),(17154,'17810','S','Gregg','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.117860,-77.022795,0,'2013-07-06 12:44:31',NULL,NULL),(21042,'21871','S','Westover','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.097540,-75.760560,0,'2013-07-06 12:44:31',NULL,NULL),(53490,'62001','S','Alhambra','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.880319,-89.747069,0,'2013-07-06 12:44:33',NULL,NULL),(52967,'61425','S','Carthage Lake','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.764786,-91.060793,0,'2013-07-06 12:44:33',NULL,NULL),(26360,'29070','S','Steedman','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(26990,'29624','S','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.478216,-82.681650,0,'2013-07-06 12:44:31',NULL,NULL),(35637,'39638','S','Bewelcome','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(73572,'91376','P','Agoura','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140438,-118.751567,0,'2013-07-06 12:44:34',NULL,NULL),(65907,'78236','S','Lackland','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(58183,'68310','S','Ellis','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(57766,'67455','S','Lincoln','D','Lincoln','20105','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.035880,-98.144640,0,'2013-07-06 12:44:33',NULL,NULL),(49464,'56652','S','Dudley','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.638080,-95.383500,0,'2013-07-06 12:44:33',NULL,NULL),(70954,'85643','S','Rucker','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(68922,'82844','S','Ranchester','A','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.704782,-107.303285,0,'2013-07-06 12:44:34',NULL,NULL),(62001,'73435','P','Fox','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.365777,-97.490050,0,'2013-07-06 12:44:33',NULL,NULL),(15703,'16853','P','Milesburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.941151,-77.791263,0,'2013-07-06 12:44:31',NULL,NULL),(34529,'38683','S','Walnut','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.947755,-88.899821,0,'2013-07-06 12:44:32',NULL,NULL),(35477,'39520','S','Mississippi Test Facility','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(45329,'50858','S','Orient','D','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204707,-94.422418,0,'2013-07-06 12:44:32',NULL,NULL),(1088,'00725','S','Urb Caribe Gdns','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(18130,'18824','S','Hop Bottom','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.692682,-75.807152,0,'2013-07-06 12:44:31',NULL,NULL),(3123,'01238','S','Lee','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.301320,-73.231980,0,'2013-07-06 12:44:30',NULL,NULL),(32285,'35661','S','Muscle Shoals','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.751695,-87.644366,0,'2013-07-06 12:44:32',NULL,NULL),(32472,'36038','P','Gantt','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.422368,-86.416458,0,'2013-07-06 12:44:32',NULL,NULL),(23738,'25920','S','Slab Fork','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.676207,-81.274295,0,'2013-07-06 12:44:31',NULL,NULL),(52147,'60441','S','Lockport','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.608015,-88.013188,0,'2013-07-06 12:44:33',NULL,NULL),(29332,'32547','S','Ft Walton Beach','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.446373,-86.626191,0,'2013-07-06 12:44:32',NULL,NULL),(8504,'08098','S','Pilesgrove','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.651717,-75.330001,0,'2013-07-06 12:44:30',NULL,NULL),(58251,'68365','S','Grafton','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.626754,-97.713563,0,'2013-07-06 12:44:33',NULL,NULL),(57586,'67068','S','Kingman','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.588441,-98.072269,0,'2013-07-06 12:44:33',NULL,NULL),(52114,'60422','S','Flossmoor','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.540319,-87.682222,0,'2013-07-06 12:44:33',NULL,NULL),(5443,'04693','S','Winter Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.379711,-68.063757,0,'2013-07-06 12:44:30',NULL,NULL),(5836,'05086','S','East Orange','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.094722,-72.341944,0,'2013-07-06 12:44:30',NULL,NULL),(16099,'17052','S','Knightsville','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(50724,'58379','P','Wood Lake','N','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.921485,-98.817673,0,'2013-07-06 12:44:33',NULL,NULL),(50853,'58494','S','Arena','A','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',47.152140,-100.332354,0,'2013-07-06 12:44:33',NULL,NULL),(79530,'98941','P','Rocklyn','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.221722,-120.993619,0,'2013-07-06 12:44:34',NULL,NULL),(66440,'78646','P','Leander','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.579561,-97.849263,0,'2013-07-06 12:44:34',NULL,NULL),(62554,'74441','S','Hulbert','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.946670,-95.230030,0,'2013-07-06 12:44:33',NULL,NULL),(1501,'00751','S','Urb Marbella','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(59151,'70183','P','New Orleans','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.954215,-90.204675,0,'2013-07-06 12:44:33',NULL,NULL),(1046,'00723','S','Urb San Benito','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(24510,'27281','S','Foxfire Vlg','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(31295,'34060','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(5660,'04961','S','Dead Rvr Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(15465,'16422','P','Harmonsburg','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.660739,-80.316811,0,'2013-07-06 12:44:31',NULL,NULL),(49434,'56634','S','Eddy','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.831879,-95.319135,0,'2013-07-06 12:44:33',NULL,NULL),(49069,'56314','S','Bowlus','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.770146,-94.355231,0,'2013-07-06 12:44:33',NULL,NULL),(43130,'48231','P','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331232,-83.048801,0,'2013-07-06 12:44:32',NULL,NULL),(79506,'98922','S','Cle Elum','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.163120,-120.849600,0,'2013-07-06 12:44:34',NULL,NULL),(71680,'87511','P','Alcalde','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.103333,-106.047500,0,'2013-07-06 12:44:34',NULL,NULL),(68304,'81092','S','Wiley','D','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.158784,-102.714060,0,'2013-07-06 12:44:34',NULL,NULL),(48320,'55445','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.106330,-93.384070,0,'2013-07-06 12:44:33',NULL,NULL),(36889,'41101','S','Rockdale','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(14501,'15147','S','Verona','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.492029,-79.833802,0,'2013-07-06 12:44:31',NULL,NULL),(23044,'24860','S','Matheny','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.683186,-81.587399,0,'2013-07-06 12:44:31',NULL,NULL),(41747,'47274','S','Lutheran Lake','N','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.959237,-85.892632,0,'2013-07-06 12:44:32',NULL,NULL),(64869,'77061','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.659716,-95.284114,0,'2013-07-06 12:44:34',NULL,NULL),(16248,'17082','S','Pt Royal','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(6539,'05837','S','East Haven','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.655307,-71.826045,0,'2013-07-06 12:44:30',NULL,NULL),(8480,'08092','S','Mayetta','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.653280,-74.280720,0,'2013-07-06 12:44:30',NULL,NULL),(891,'00704','S','Urb Eugene Rice','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(44001,'49346','S','Canadian Lakes','A','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.590116,-85.361863,0,'2013-07-06 12:44:32',NULL,NULL),(2264,'00926','S','Urb Purple Tree','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(10402,'10605','S','Gedney','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.006687,-73.746222,0,'2013-07-06 12:44:30',NULL,NULL),(32928,'36558','S','Yarbo','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(38803,'44067','S','Northfield Center','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(29229,'32426','S','Campbellton','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.942431,-85.357503,0,'2013-07-06 12:44:32',NULL,NULL),(71940,'87935','P','Elephant Btte','A','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.195236,-107.218449,0,'2013-07-06 12:44:34',NULL,NULL),(70996,'85714','S','Mission','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.175070,-110.966248,0,'2013-07-06 12:44:34',NULL,NULL),(42113,'47469','S','Abbey Dell','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(4928,'04079','S','South Harpswell','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.825960,-69.953763,0,'2013-07-06 12:44:30',NULL,NULL),(41670,'47162','S','New Washingtn','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.545267,-85.478896,0,'2013-07-06 12:44:32',NULL,NULL),(41507,'46967','P','Onward','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.694940,-86.196524,0,'2013-07-06 12:44:32',NULL,NULL),(49426,'56631','P','Bowstring','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.541969,-93.798456,0,'2013-07-06 12:44:33',NULL,NULL),(71990,'88030','S','Deming','D','Luna','35029','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.263005,-107.754054,0,'2013-07-06 12:44:34',NULL,NULL),(52998,'61449','S','La Fayette','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.110846,-89.970143,0,'2013-07-06 12:44:33',NULL,NULL),(79829,'99515','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.120854,-149.893143,0,'2013-07-06 12:44:34',NULL,NULL),(56928,'66067','S','Ottawa','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.607557,-95.267627,0,'2013-07-06 12:44:33',NULL,NULL),(18056,'18702','S','Korn Krest','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(32812,'36449','P','Goodway','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.336620,-87.425820,0,'2013-07-06 12:44:32',NULL,NULL),(6836,'06118','S','E Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.748563,-72.609938,0,'2013-07-06 12:44:30',NULL,NULL),(38046,'43041','U','Marysville','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.238271,-83.368023,0,'2013-07-06 12:44:32',NULL,NULL),(78935,'98366','S','South Park Village','A','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(54229,'62659','S','Lincoln Nw Sl','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.010060,-89.849840,0,'2013-07-06 12:44:33',NULL,NULL),(52900,'61358','S','Rutland','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.983610,-89.037660,0,'2013-07-06 12:44:33',NULL,NULL),(6458,'05760','S','North Orwell','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.785111,-73.276135,0,'2013-07-06 12:44:30',NULL,NULL),(33843,'37934','S','Kville','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(36795,'41053','P','Kenton','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.867056,-84.458582,0,'2013-07-06 12:44:32',NULL,NULL),(50551,'58204','S','Grand Forks AFB','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.960971,-97.370375,0,'2013-07-06 12:44:33',NULL,NULL),(3700,'02138','S','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.377465,-71.131249,0,'2013-07-06 12:44:30',NULL,NULL),(7367,'06758','S','Lakeside','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.684167,-73.196667,0,'2013-07-06 12:44:30',NULL,NULL),(17310,'17856','S','W Milton','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.043720,-76.884900,0,'2013-07-06 12:44:31',NULL,NULL),(74638,'92814','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.817347,-117.960729,0,'2013-07-06 12:44:34',NULL,NULL),(1158,'00727','S','Sect Altos de La Fuente','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(38869,'44103','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.511131,-81.637887,0,'2013-07-06 12:44:32',NULL,NULL),(60081,'71357','S','Flowers Landing','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(57453,'66849','S','Dwight','D','Morris','20127','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.828275,-96.563586,0,'2013-07-06 12:44:33',NULL,NULL),(8880,'08720','P','Allenwood','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.141423,-74.109975,0,'2013-07-06 12:44:30',NULL,NULL),(43624,'48818','S','Crystal','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.271074,-84.909865,0,'2013-07-06 12:44:32',NULL,NULL),(41186,'46714','S','Travisville','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(825,'00693','S','Urb Vega Serena','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(12639,'13107','P','Maple View','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.460480,-76.147002,0,'2013-07-06 12:44:30',NULL,NULL),(11619,'12106','S','Kinderhook','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.395508,-73.711549,0,'2013-07-06 12:44:30',NULL,NULL),(16022,'17042','S','Heilmandale','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(1263,'00729','S','Villas Doradas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(5164,'04426','S','Sebec','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(49613,'56763','S','Warroad','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.908263,-95.317658,0,'2013-07-06 12:44:33',NULL,NULL),(55824,'64151','S','Lake Waukomis','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(62247,'74003','S','Glenoak','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(43117,'48225','S','Harper Woods','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.437669,-82.940907,0,'2013-07-06 12:44:32',NULL,NULL),(25172,'28042','P','Fallston','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.429789,-81.505251,0,'2013-07-06 12:44:31',NULL,NULL),(47372,'54624','S','De Soto','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.485556,-91.212500,0,'2013-07-06 12:44:32',NULL,NULL),(72094,'88210','S','Artesia','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.835208,-104.413737,0,'2013-07-06 12:44:34',NULL,NULL),(79457,'98849','S','Riverside','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.480603,-119.617296,0,'2013-07-06 12:44:34',NULL,NULL),(74466,'92596','S','Menifee','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.625979,-117.068531,0,'2013-07-06 12:44:34',NULL,NULL),(28886,'32125','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.234976,-81.055403,0,'2013-07-06 12:44:32',NULL,NULL),(40215,'45406','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.794210,-84.270110,0,'2013-07-06 12:44:32',NULL,NULL),(23558,'25635','S','Man','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.744662,-81.878847,0,'2013-07-06 12:44:31',NULL,NULL),(24787,'27576','S','Selma','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.541368,-78.284629,0,'2013-07-06 12:44:31',NULL,NULL),(35413,'39466','S','Goodyear','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(19042,'19540','S','Alleghenyville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(10894,'11424','P','Kew Gardens','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.706550,-73.828147,0,'2013-07-06 12:44:30',NULL,NULL),(65226,'77446','P','Prairie View','D','Waller','48473','Texas','TX','48','3360','979','Central',-6.0,'Y',30.081335,-95.992865,0,'2013-07-06 12:44:34',NULL,NULL),(63823,'75972','S','Sexton','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(62685,'74724','S','Bethel','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.354735,-94.843908,0,'2013-07-06 12:44:33',NULL,NULL),(59133,'70164','U','La Power Light','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.003600,-90.002730,0,'2013-07-06 12:44:33',NULL,NULL),(9789,'10108','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(42270,'47581','S','Rollins','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(67018,'79529','S','Knox City','D','Knox','48275','Texas','TX','48','0000','940','Central',-6.0,'Y',33.415280,-99.812074,0,'2013-07-06 12:44:34',NULL,NULL),(58578,'68832','S','South Platte','N','Hall','31079','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.772243,-98.370227,0,'2013-07-06 12:44:33',NULL,NULL),(57642,'67155','S','Wilmore','D','Comanche','20033','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.335100,-99.209536,0,'2013-07-06 12:44:33',NULL,NULL),(28610,'31705','S','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.558731,-84.090313,0,'2013-07-06 12:44:32',NULL,NULL),(36957,'41171','S','Lytten','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(13170,'13611','P','Belleville','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.788347,-76.114594,0,'2013-07-06 12:44:30',NULL,NULL),(39323,'44609','S','Westville Lake','N','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.931159,-80.988990,0,'2013-07-06 12:44:32',NULL,NULL),(17082,'17764','S','Drocton','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(44703,'50138','S','Knoxville','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.320318,-93.103486,0,'2013-07-06 12:44:32',NULL,NULL),(45611,'51565','S','Portsmouth','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.646859,-95.500172,0,'2013-07-06 12:44:32',NULL,NULL),(5389,'04648','S','Jonesboro','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.667992,-67.588823,0,'2013-07-06 12:44:30',NULL,NULL),(2495,'00956','S','Villas Del Caribe','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(1182,'00727','S','Villa del Rey 4','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(63531,'75757','S','Emerald Bay','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.150666,-95.372322,0,'2013-07-06 12:44:33',NULL,NULL),(13796,'14202','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.882757,-78.877245,0,'2013-07-06 12:44:31',NULL,NULL),(26230,'28804','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.637430,-82.558381,0,'2013-07-06 12:44:31',NULL,NULL),(2611,'00961','S','Valle Verde 3','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(49776,'57072','S','Volin','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.998394,-97.222124,0,'2013-07-06 12:44:33',NULL,NULL),(38244,'43266','U','State Departments of Ohio','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.056417,-82.968199,0,'2013-07-06 12:44:32',NULL,NULL),(27697,'30339','S','Atlanta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(38734,'44024','S','Kirtland','N','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.569436,-81.203372,0,'2013-07-06 12:44:32',NULL,NULL),(4463,'03258','S','Chichester','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.279404,-71.410433,0,'2013-07-06 12:44:30',NULL,NULL),(5619,'04939','S','Garland','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.041484,-69.158676,0,'2013-07-06 12:44:30',NULL,NULL),(65950,'78265','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.536959,-98.421181,0,'2013-07-06 12:44:34',NULL,NULL),(5701,'04983','S','Salem Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.868494,-70.234780,0,'2013-07-06 12:44:30',NULL,NULL),(41665,'47150','S','New Albany','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.307855,-85.826843,0,'2013-07-06 12:44:32',NULL,NULL),(73359,'91012','P','La Canada','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203774,-118.191187,0,'2013-07-06 12:44:34',NULL,NULL),(64437,'76565','S','Pottsville','D','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.685832,-98.358306,0,'2013-07-06 12:44:34',NULL,NULL),(47229,'54499','S','Wittenberg','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.825108,-89.169054,0,'2013-07-06 12:44:32',NULL,NULL),(35671,'39653','S','Monroe','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.455600,-90.879660,0,'2013-07-06 12:44:32',NULL,NULL),(36690,'41017','S','Bromley','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(2072,'00921','S','Repto Landrau','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(79925,'99610','S','Kasilof','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.420179,-151.072033,0,'2013-07-06 12:44:34',NULL,NULL),(72102,'88221','P','Carlsbad','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.421580,-104.275688,0,'2013-07-06 12:44:34',NULL,NULL),(68789,'82336','P','Tipton','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.629570,-108.264820,0,'2013-07-06 12:44:34',NULL,NULL),(57652,'67205','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.747829,-97.431522,0,'2013-07-06 12:44:33',NULL,NULL),(44000,'49346','S','Canadian Lake','A','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.590116,-85.361863,0,'2013-07-06 12:44:32',NULL,NULL),(79380,'98671','S','Washougal','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.598919,-122.333228,0,'2013-07-06 12:44:34',NULL,NULL),(78114,'97501','S','Medford','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.314227,-122.881634,0,'2013-07-06 12:44:34',NULL,NULL),(65921,'78241','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.376814,-98.546634,0,'2013-07-06 12:44:34',NULL,NULL),(65219,'77442','S','Garwood','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.448898,-96.397286,0,'2013-07-06 12:44:34',NULL,NULL),(41189,'46721','S','Artic','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.413936,-84.885428,0,'2013-07-06 12:44:32',NULL,NULL),(6952,'06199','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.926830,-72.654423,0,'2013-07-06 12:44:30',NULL,NULL),(36056,'40207','S','Maryhill Estates','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(69725,'84040','S','East Layton','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.075677,-111.891767,0,'2013-07-06 12:44:34',NULL,NULL),(69095,'83254','S','Bennington','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(58394,'68624','S','Bellwood','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.345741,-97.254735,0,'2013-07-06 12:44:33',NULL,NULL),(59152,'70184','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.006203,-90.107282,0,'2013-07-06 12:44:33',NULL,NULL),(57174,'66286','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.993781,-94.871495,0,'2013-07-06 12:44:33',NULL,NULL),(47211,'54492','U','Stevens Point','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.491605,-89.529732,0,'2013-07-06 12:44:32',NULL,NULL),(21912,'23218','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.538272,-77.439111,0,'2013-07-06 12:44:31',NULL,NULL),(77757,'97109','S','Buxton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.688031,-123.190696,0,'2013-07-06 12:44:34',NULL,NULL),(26367,'29072','S','Red Bank','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.979860,-81.260520,0,'2013-07-06 12:44:31',NULL,NULL),(19791,'20433','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906462,-77.044928,0,'2013-07-06 12:44:31',NULL,NULL),(41564,'47023','S','New Marion','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.021348,-85.387979,0,'2013-07-06 12:44:32',NULL,NULL),(29057,'32240','P','JAX Bch','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.278240,-81.411680,0,'2013-07-06 12:44:32',NULL,NULL),(24994,'27865','S','Pinetown','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.606200,-76.828860,0,'2013-07-06 12:44:31',NULL,NULL),(74185,'92277','S','Twentynin Plm','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.161757,-116.045717,0,'2013-07-06 12:44:34',NULL,NULL),(65403,'77564','S','Hull','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.135928,-94.652305,0,'2013-07-06 12:44:34',NULL,NULL),(33533,'37383','U','Sewanee','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.201422,-85.923515,0,'2013-07-06 12:44:32',NULL,NULL),(16606,'17329','S','Sticks','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.757860,-76.871220,0,'2013-07-06 12:44:31',NULL,NULL),(64564,'76656','S','Travis','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(36244,'40297','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254499,-85.761600,0,'2013-07-06 12:44:32',NULL,NULL),(18366,'19040','S','Uppr Moreland','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.178137,-75.108926,0,'2013-07-06 12:44:31',NULL,NULL),(56163,'64865','S','Hart','N','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.839888,-94.609979,0,'2013-07-06 12:44:33',NULL,NULL),(36060,'40207','S','Norbourne Est','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(75183,'93609','S','Caruthers','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.534467,-119.840977,0,'2013-07-06 12:44:34',NULL,NULL),(49561,'56715','S','Brooks','D','Red Lake','27125','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.803547,-96.030632,0,'2013-07-06 12:44:33',NULL,NULL),(662,'00683','S','Parc Sabana Eneas','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(15711,'16861','S','New Millport','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.884741,-78.486115,0,'2013-07-06 12:44:31',NULL,NULL),(27348,'30052','S','Loganville','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.810339,-83.891909,0,'2013-07-06 12:44:31',NULL,NULL),(9403,'09880','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(37293,'41630','S','Garrett','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.483546,-82.856443,0,'2013-07-06 12:44:32',NULL,NULL),(44329,'49756','S','Lewiston','D','Montmorency','26119','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.807644,-84.273894,0,'2013-07-06 12:44:32',NULL,NULL),(3766,'02188','S','Weymouth','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.213792,-70.959371,0,'2013-07-06 12:44:30',NULL,NULL),(14707,'15265','U','Pnc Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.442380,-79.999942,0,'2013-07-06 12:44:31',NULL,NULL),(64832,'77039','S','Aldine','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.909223,-95.334826,0,'2013-07-06 12:44:34',NULL,NULL),(64414,'76548','S','Killeen','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.116944,-97.727500,0,'2013-07-06 12:44:34',NULL,NULL),(63943,'76078','S','Aurora','A','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.046961,-97.472602,0,'2013-07-06 12:44:34',NULL,NULL),(64361,'76523','P','Davilla','D','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.766149,-97.183525,0,'2013-07-06 12:44:34',NULL,NULL),(5285,'04535','S','Alna','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.080729,-69.617902,0,'2013-07-06 12:44:30',NULL,NULL),(3036,'01098','S','Worthington','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.307673,-72.878084,0,'2013-07-06 12:44:30',NULL,NULL),(42082,'47455','P','Patricksburg','D','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.247894,-86.988727,0,'2013-07-06 12:44:32',NULL,NULL),(43378,'48423','S','Davison','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.029997,-83.523986,0,'2013-07-06 12:44:32',NULL,NULL),(56664,'65624','S','Cape Fair','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.675135,-93.528191,0,'2013-07-06 12:44:33',NULL,NULL),(27553,'30253','S','McDonough','D','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.443757,-84.181882,0,'2013-07-06 12:44:31',NULL,NULL),(37709,'42262','S','Oak Grove','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.677845,-87.447679,0,'2013-07-06 12:44:32',NULL,NULL),(9552,'10023','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(23909,'26208','S','Gauley Mills','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.375220,-80.572320,0,'2013-07-06 12:44:31',NULL,NULL),(63666,'75853','S','Blackfoot','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.941780,-95.763120,0,'2013-07-06 12:44:34',NULL,NULL),(27812,'30401','S','Dellwood','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(22395,'23950','S','Blackridge','A','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.752222,-78.046389,0,'2013-07-06 12:44:31',NULL,NULL),(75205,'93628','S','Miramonte','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.692500,-119.051389,0,'2013-07-06 12:44:34',NULL,NULL),(72687,'89445','S','Paradise Hill','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(70748,'85321','S','Ajo','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.385764,-112.866344,0,'2013-07-06 12:44:34',NULL,NULL),(40458,'45744','S','Lowell','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.528014,-81.504494,0,'2013-07-06 12:44:32',NULL,NULL),(16539,'17302','S','Kyleville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(13437,'13760','S','West Corners','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(13685,'14048','S','Dunkirk','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.479473,-79.328465,0,'2013-07-06 12:44:31',NULL,NULL),(41218,'46732','S','Indian Village','N','Noble','18113','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.401608,-85.666412,0,'2013-07-06 12:44:32',NULL,NULL),(46111,'52635','S','Four Corners','N','Jefferson','19101','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.997720,-91.752281,0,'2013-07-06 12:44:32',NULL,NULL),(38620,'43912','S','Bridgeport','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.074874,-80.764849,0,'2013-07-06 12:44:32',NULL,NULL),(77341,'96719','P','Hawi','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.237133,-155.850200,0,'2013-07-06 12:44:34',NULL,NULL),(15860,'16946','S','Tioga','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.913008,-77.143380,0,'2013-07-06 12:44:31',NULL,NULL),(63595,'75789','S','Sinclair City','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(9944,'10155','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(6438,'05748','S','Hancock','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.918448,-72.916704,0,'2013-07-06 12:44:30',NULL,NULL),(12930,'13343','S','Chase Lake','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.737780,-75.327900,0,'2013-07-06 12:44:30',NULL,NULL),(8691,'08345','S','Gandys Beach','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.288657,-75.149130,0,'2013-07-06 12:44:30',NULL,NULL),(28064,'30701','S','Calhoun','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.495946,-84.931056,0,'2013-07-06 12:44:31',NULL,NULL),(75482,'94118','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.780181,-122.458762,0,'2013-07-06 12:44:34',NULL,NULL),(15288,'16127','S','Grove City','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.162731,-80.085407,0,'2013-07-06 12:44:31',NULL,NULL),(8807,'08610','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.215600,-74.739600,0,'2013-07-06 12:44:30',NULL,NULL),(18029,'18644','S','West Wyoming','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.330100,-75.853680,0,'2013-07-06 12:44:31',NULL,NULL),(77692,'97041','S','Mount Hood','N','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(75255,'93662','S','Selma','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.541105,-119.637973,0,'2013-07-06 12:44:34',NULL,NULL),(74031,'92135','S','Nas North Island','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.699246,-117.185174,0,'2013-07-06 12:44:34',NULL,NULL),(57964,'67764','S','Monument','A','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046384,-101.228293,0,'2013-07-06 12:44:33',NULL,NULL),(55937,'64475','S','Parnell','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497440,-94.682353,0,'2013-07-06 12:44:33',NULL,NULL),(21094,'22039','S','Fairfax Station','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.763405,-77.314652,0,'2013-07-06 12:44:31',NULL,NULL),(51977,'60151','S','Lily Lake','N','Kane','17089','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.903604,-88.594699,0,'2013-07-06 12:44:33',NULL,NULL),(52733,'61235','S','Atkinson','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.417664,-90.016623,0,'2013-07-06 12:44:33',NULL,NULL),(31914,'35160','S','Talladega','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.439294,-86.102326,0,'2013-07-06 12:44:32',NULL,NULL),(76032,'95148','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.329994,-121.792353,0,'2013-07-06 12:44:34',NULL,NULL),(79140,'98501','S','Nisqually','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(76065,'95203','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.954003,-121.309883,0,'2013-07-06 12:44:34',NULL,NULL),(74366,'92418','U','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.104145,-117.290746,0,'2013-07-06 12:44:34',NULL,NULL),(34773,'38863','S','Springville','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(11303,'11777','S','Pt Jefferson Station','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(70751,'85323','S','Avondale-Goodyear','N','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.429286,-112.345055,0,'2013-07-06 12:44:34',NULL,NULL),(13000,'13411','S','Pittsfield','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(47477,'54745','S','Lake Holcombe','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.243772,-91.204691,0,'2013-07-06 12:44:32',NULL,NULL),(43728,'48929','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734857,-84.556883,0,'2013-07-06 12:44:32',NULL,NULL),(45034,'50471','S','Rudd','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.127601,-92.905238,0,'2013-07-06 12:44:32',NULL,NULL),(73398,'91118','P','San Marino','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.125011,-118.092416,0,'2013-07-06 12:44:34',NULL,NULL),(62802,'74936','S','Gans','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.389562,-94.693076,0,'2013-07-06 12:44:33',NULL,NULL),(56251,'65058','S','Babbtown','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.270435,-92.133364,0,'2013-07-06 12:44:33',NULL,NULL),(15376,'16312','P','Chandlers Valley','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.932606,-79.304327,0,'2013-07-06 12:44:31',NULL,NULL),(41525,'46987','P','Sweetser','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.569508,-85.766779,0,'2013-07-06 12:44:32',NULL,NULL),(52058,'60202','S','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.030528,-87.691792,0,'2013-07-06 12:44:33',NULL,NULL),(21779,'23065','S','Gumspring','N','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.802864,-77.934501,0,'2013-07-06 12:44:31',NULL,NULL),(70654,'85194','S','Casa Grande','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.908923,-111.627289,0,'2013-07-06 12:44:34',NULL,NULL),(77199,'96351','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72430,'89074','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.040063,-115.077340,0,'2013-07-06 12:44:34',NULL,NULL),(66812,'79081','S','Spearman','D','Hansford','48195','Texas','TX','48','0000','806','Central',-6.0,'Y',36.191789,-101.193662,0,'2013-07-06 12:44:34',NULL,NULL),(57275,'66549','S','Westmoreland','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.474166,-96.415994,0,'2013-07-06 12:44:33',NULL,NULL),(45526,'51441','S','Deloit','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.094805,-95.343672,0,'2013-07-06 12:44:32',NULL,NULL),(16019,'17042','S','Ebenezer','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(5917,'05250','S','West Arlingtn','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(49697,'57028','S','Flandreau','D','Moody','46101','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.045537,-96.595757,0,'2013-07-06 12:44:33',NULL,NULL),(70719,'85285','P','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.395328,-111.929313,0,'2013-07-06 12:44:34',NULL,NULL),(66971,'79409','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.586056,-101.853812,0,'2013-07-06 12:44:34',NULL,NULL),(64501,'76630','S','Bruceville','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.331159,-97.249823,0,'2013-07-06 12:44:34',NULL,NULL),(52350,'60606','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.883784,-87.637668,0,'2013-07-06 12:44:33',NULL,NULL),(30421,'33327','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118498,-80.436434,0,'2013-07-06 12:44:32',NULL,NULL),(61398,'72543','S','Eden Isle','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.493501,-92.031852,0,'2013-07-06 12:44:33',NULL,NULL),(3933,'02465','S','W Newton','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348882,-71.225607,0,'2013-07-06 12:44:30',NULL,NULL),(6774,'06101','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788224,-72.665673,0,'2013-07-06 12:44:30',NULL,NULL),(35071,'39194','S','Eden','N','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.857919,-90.405161,0,'2013-07-06 12:44:32',NULL,NULL),(37974,'42728','S','Columbia','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(41494,'46950','S','Lucerne','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.867470,-86.413408,0,'2013-07-06 12:44:32',NULL,NULL),(1647,'00771','S','Villa Las Mercedes','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(49699,'57030','S','Garretson','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.714740,-96.519420,0,'2013-07-06 12:44:33',NULL,NULL),(22328,'23860','S','Hopewell','D','Hopewell City','51670','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.286042,-77.289149,0,'2013-07-06 12:44:31',NULL,NULL),(8082,'07757','S','Monmouth Park','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315089,-74.017467,0,'2013-07-06 12:44:30',NULL,NULL),(44086,'49457','S','Lakewood Club','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.359781,-86.176186,0,'2013-07-06 12:44:32',NULL,NULL),(72741,'89507','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.547923,-119.819079,0,'2013-07-06 12:44:34',NULL,NULL),(64716,'76871','S','Richland Spgs','A','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.304072,-98.817416,0,'2013-07-06 12:44:34',NULL,NULL),(50413,'57785','S','Bear Butte','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(3061,'01116','P','E Longmeadow','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.064444,-72.513056,0,'2013-07-06 12:44:30',NULL,NULL),(2692,'00969','S','Alt de Santa Maria','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(29504,'32762','P','Oviedo','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.658287,-81.181302,0,'2013-07-06 12:44:32',NULL,NULL),(33526,'37380','S','New Hope','A','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.009705,-85.711704,0,'2013-07-06 12:44:32',NULL,NULL),(26717,'29415','P','Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.027502,-80.046168,0,'2013-07-06 12:44:31',NULL,NULL),(47961,'55120','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.873820,-93.140700,0,'2013-07-06 12:44:33',NULL,NULL),(77390,'96768','S','Makawao','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.847667,-156.329587,0,'2013-07-06 12:44:34',NULL,NULL),(76094,'95221','P','Altaville','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.083800,-120.560820,0,'2013-07-06 12:44:34',NULL,NULL),(4310,'02911','S','Centerdale','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(17081,'17763','P','Ralston','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.507838,-76.966963,0,'2013-07-06 12:44:31',NULL,NULL),(20063,'20674','S','Piney Pt','N','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.141300,-76.510191,0,'2013-07-06 12:44:31',NULL,NULL),(75999,'95109','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.337284,-121.893454,0,'2013-07-06 12:44:34',NULL,NULL),(75792,'94708','S','Kensington','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.906115,-122.273476,0,'2013-07-06 12:44:34',NULL,NULL),(25306,'28150','S','Patterson Springs','N','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.304225,-81.551791,0,'2013-07-06 12:44:31',NULL,NULL),(14604,'15225','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.515120,-80.087760,0,'2013-07-06 12:44:31',NULL,NULL),(700,'00685','S','Urb Olivencia','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(39389,'44656','S','Lindentree','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.609320,-81.358200,0,'2013-07-06 12:44:32',NULL,NULL),(22911,'24605','S','Yards','A','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.263360,-81.288780,0,'2013-07-06 12:44:31',NULL,NULL),(65597,'77880','S','Washington','D','Washington','48477','Texas','TX','48','0000','936','Central',-6.0,'Y',30.332626,-96.226060,0,'2013-07-06 12:44:34',NULL,NULL),(72081,'88134','S','Tolar','N','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.352414,-104.034639,0,'2013-07-06 12:44:34',NULL,NULL),(75896,'94973','P','Woodacre','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.007689,-122.640149,0,'2013-07-06 12:44:34',NULL,NULL),(75324,'93774','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.748057,-119.788731,0,'2013-07-06 12:44:34',NULL,NULL),(66820,'79088','S','Vigo Park','A','Swisher','48437','Texas','TX','48','0000','806','Central',-6.0,'Y',34.651640,-101.498380,0,'2013-07-06 12:44:34',NULL,NULL),(61319,'72441','P','Mc Dougal','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.385775,-90.394279,0,'2013-07-06 12:44:33',NULL,NULL),(52304,'60545','S','Little Rock','N','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.668485,-88.531045,0,'2013-07-06 12:44:33',NULL,NULL),(13271,'13651','P','Henderson Hbr','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.869440,-76.193826,0,'2013-07-06 12:44:30',NULL,NULL),(3889,'02381','P','White Horse Beach','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.930035,-70.559004,0,'2013-07-06 12:44:30',NULL,NULL),(24439,'27208','S','Bennett','D','Chatham','37037','North Carolina','NC','37','6640','336','Eastern',-5.0,'Y',35.574999,-79.524083,0,'2013-07-06 12:44:31',NULL,NULL),(22550,'24133','S','Patrick Springs','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.689216,-80.149261,0,'2013-07-06 12:44:31',NULL,NULL),(19314,'20015','S','Chevy Chase','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.963203,-77.065176,0,'2013-07-06 12:44:31',NULL,NULL),(48232,'55421','S','Columbia Heights','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(45997,'52501','S','South Ottumwa','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(20353,'20866','S','Burtonsville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.098463,-76.936128,0,'2013-07-06 12:44:31',NULL,NULL),(21770,'23061','S','Zanoni','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.435603,-76.547405,0,'2013-07-06 12:44:31',NULL,NULL),(63040,'75209','S','Highland Park','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.848647,-96.825080,0,'2013-07-06 12:44:33',NULL,NULL),(61919,'73149','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.392069,-97.490844,0,'2013-07-06 12:44:33',NULL,NULL),(652,'00682','S','Villas del Oeste','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(909,'00705','S','Urb La Providencia','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(49020,'56266','S','Evan','A','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.415886,-94.924541,0,'2013-07-06 12:44:33',NULL,NULL),(42388,'47725','S','Daylight','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974596,-87.555538,0,'2013-07-06 12:44:32',NULL,NULL),(32723,'36310','S','Abbeville','D','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.554960,-85.265460,0,'2013-07-06 12:44:32',NULL,NULL),(65188,'77420','S','Iago','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.267160,-95.944320,0,'2013-07-06 12:44:34',NULL,NULL),(47013,'54305','P','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.533152,-88.096245,0,'2013-07-06 12:44:32',NULL,NULL),(6822,'06112','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.794394,-72.696348,0,'2013-07-06 12:44:30',NULL,NULL),(72933,'90034','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.028026,-118.399267,0,'2013-07-06 12:44:34',NULL,NULL),(42960,'48130','S','Scio','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(68438,'81224','S','Crested Butte','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.860596,-106.956766,0,'2013-07-06 12:44:34',NULL,NULL),(65566,'77845','S','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.583511,-96.294277,0,'2013-07-06 12:44:34',NULL,NULL),(64515,'76635','S','Coolidge','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.742700,-96.672420,0,'2013-07-06 12:44:34',NULL,NULL),(397,'00662','S','Comunidad Sonuco','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(25809,'28607','S','Perkinsville','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(15529,'16550','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.133326,-80.087856,0,'2013-07-06 12:44:31',NULL,NULL),(77535,'96850','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308944,-157.861150,0,'2013-07-06 12:44:34',NULL,NULL),(72786,'89701','S','Jacks Valley','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(71707,'87527','P','Apodaca','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.198611,-105.861667,0,'2013-07-06 12:44:34',NULL,NULL),(64259,'76380','S','Red Springs','A','Baylor','48023','Texas','TX','48','0000','940','Central',-6.0,'Y',33.591147,-99.263331,0,'2013-07-06 12:44:34',NULL,NULL),(35814,'39759','S','Sessums','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(18021,'18642','S','Duryea','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.325833,-75.789722,0,'2013-07-06 12:44:31',NULL,NULL),(70314,'84605','P','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.226387,-111.677308,0,'2013-07-06 12:44:34',NULL,NULL),(64380,'76528','S','South Mtn','A','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(53018,'61466','S','N Henderson','A','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.105464,-90.476855,0,'2013-07-06 12:44:33',NULL,NULL),(43487,'48613','S','Bentley','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.935665,-84.112013,0,'2013-07-06 12:44:32',NULL,NULL),(44741,'50163','P','Melcher Dallas','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.225249,-93.238708,0,'2013-07-06 12:44:32',NULL,NULL),(28431,'31333','P','Walthourville','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.774554,-81.633207,0,'2013-07-06 12:44:32',NULL,NULL),(15378,'16313','S','Clarendon','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.812195,-79.157992,0,'2013-07-06 12:44:31',NULL,NULL),(44182,'49588','P','Kentwood','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963544,-85.656222,0,'2013-07-06 12:44:32',NULL,NULL),(37168,'41472','S','Mima','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(66520,'78712','S','UT','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.285130,-97.737776,0,'2013-07-06 12:44:34',NULL,NULL),(33023,'36720','S','Alberta','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.114094,-87.326683,0,'2013-07-06 12:44:32',NULL,NULL),(9492,'10012','S','Prince','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(13907,'14302','P','N Falls','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.087809,-79.061883,0,'2013-07-06 12:44:31',NULL,NULL),(47111,'54448','S','Marathon City','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.930712,-89.834421,0,'2013-07-06 12:44:32',NULL,NULL),(70829,'85395','S','Goodyear','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.489384,-112.392612,0,'2013-07-06 12:44:34',NULL,NULL),(70182,'84331','S','Portage','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.975569,-112.191160,0,'2013-07-06 12:44:34',NULL,NULL),(40344,'45619','S','Chesapeake','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.430677,-82.454715,0,'2013-07-06 12:44:32',NULL,NULL),(14135,'14694','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.088842,-77.599683,0,'2013-07-06 12:44:31',NULL,NULL),(78159,'97624','S','Chiloquin','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.592349,-121.872422,0,'2013-07-06 12:44:34',NULL,NULL),(77633,'97006','S','Hillsboro','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.516558,-122.858874,0,'2013-07-06 12:44:34',NULL,NULL),(52068,'60302','S','Oak Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.897775,-87.788982,0,'2013-07-06 12:44:33',NULL,NULL),(29282,'32465','S','White City','N','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',30.056707,-85.159531,0,'2013-07-06 12:44:32',NULL,NULL),(46046,'52565','S','Keosauqua','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.734954,-91.960982,0,'2013-07-06 12:44:32',NULL,NULL),(26757,'29429','S','Awendaw','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.950528,-79.680316,0,'2013-07-06 12:44:31',NULL,NULL),(27412,'30096','S','Duluth','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.985868,-84.163754,0,'2013-07-06 12:44:31',NULL,NULL),(79201,'98532','S','Napavine','A','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(78790,'98315','S','Bangor','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.697060,-122.722320,0,'2013-07-06 12:44:34',NULL,NULL),(8192,'07922','S','Berkeley Heights','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.678984,-74.432692,0,'2013-07-06 12:44:30',NULL,NULL),(5533,'04781','S','Soldier Pond','N','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.145899,-68.632982,0,'2013-07-06 12:44:30',NULL,NULL),(27314,'30023','P','Alpharetta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',34.067631,-84.271155,0,'2013-07-06 12:44:31',NULL,NULL),(1947,'00802','S','Charlotte Ama','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.348771,-64.935409,0,'2013-07-06 12:44:30',NULL,NULL),(75641,'94521','S','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.962765,-121.962736,0,'2013-07-06 12:44:34',NULL,NULL),(66551,'78734','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371100,-97.869900,0,'2013-07-06 12:44:34',NULL,NULL),(36763,'41041','S','Martha Mills','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(76545,'95662','S','Orangevale','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.684510,-121.225634,0,'2013-07-06 12:44:34',NULL,NULL),(64131,'76192','U','Kenneth Copeland Ministries','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.932938,-97.435253,0,'2013-07-06 12:44:34',NULL,NULL),(56851,'65899','U','American Nat Prop & Casualty','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.150347,-93.248417,0,'2013-07-06 12:44:33',NULL,NULL),(18243,'18977','S','Wshngtn Xing','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.291900,-74.884277,0,'2013-07-06 12:44:31',NULL,NULL),(37101,'41348','S','Lost Creek','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480000,-83.320000,0,'2013-07-06 12:44:32',NULL,NULL),(22028,'23293','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.441334,-77.322755,0,'2013-07-06 12:44:31',NULL,NULL),(26962,'29609','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.897521,-82.398093,0,'2013-07-06 12:44:31',NULL,NULL),(61077,'72127','S','Plumerville','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.160737,-92.634377,0,'2013-07-06 12:44:33',NULL,NULL),(14505,'15201','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.470679,-79.954348,0,'2013-07-06 12:44:31',NULL,NULL),(48416,'55602','S','Fairbanks','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.309551,-91.835899,0,'2013-07-06 12:44:33',NULL,NULL),(40121,'45325','S','Farmersville','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.698340,-84.417900,0,'2013-07-06 12:44:32',NULL,NULL),(32108,'35298','U','Blue Cross-Shield','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.499493,-86.800795,0,'2013-07-06 12:44:32',NULL,NULL),(21277,'22314','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.799917,-77.051663,0,'2013-07-06 12:44:31',NULL,NULL),(24374,'27055','S','Center','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(569,'00678','S','Urb La Romana','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(31342,'34142','S','Ave Maria','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.327612,-81.313729,0,'2013-07-06 12:44:32',NULL,NULL),(33883,'38027','P','Collierville','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056954,-89.676442,0,'2013-07-06 12:44:32',NULL,NULL),(40604,'45889','S','Van Buren','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.138307,-83.636176,0,'2013-07-06 12:44:32',NULL,NULL),(68502,'81321','S','Hovenweep National Monument','N','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.347000,-108.736320,0,'2013-07-06 12:44:34',NULL,NULL),(50077,'57451','S','Powell','N','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.448625,-99.029411,0,'2013-07-06 12:44:33',NULL,NULL),(31201,'33947','S','Cape Haze','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.890856,-82.289031,0,'2013-07-06 12:44:32',NULL,NULL),(16389,'17213','S','Richvale','N','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(39894,'45214','S','Queen City','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.120751,-84.543703,0,'2013-07-06 12:44:32',NULL,NULL),(68905,'82732','P','Gillette','A','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.291111,-105.501667,0,'2013-07-06 12:44:34',NULL,NULL),(52795,'61275','S','Byron Hills','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.598088,-90.317110,0,'2013-07-06 12:44:33',NULL,NULL),(27546,'30240','S','Lagrange','D','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.030882,-85.036970,0,'2013-07-06 12:44:31',NULL,NULL),(69315,'83464','S','Lone Pine','N','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.601224,-113.355918,0,'2013-07-06 12:44:34',NULL,NULL),(50011,'57382','S','Wessington Springs','D','Jerauld','46073','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.084850,-98.568185,0,'2013-07-06 12:44:33',NULL,NULL),(69076,'83244','S','Howe','D','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.797498,-113.093060,0,'2013-07-06 12:44:34',NULL,NULL),(57846,'67559','S','Nekoma','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.415103,-99.417488,0,'2013-07-06 12:44:33',NULL,NULL),(34206,'38344','S','Leach','N','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.997060,-88.422900,0,'2013-07-06 12:44:32',NULL,NULL),(22543,'24127','S','New Castle','D','Craig','51045','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.504495,-80.111684,0,'2013-07-06 12:44:31',NULL,NULL),(27116,'29733','U','Winthrop University','N','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.890601,-81.024567,0,'2013-07-06 12:44:31',NULL,NULL),(581,'00680','S','Bo Mineral','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(70554,'85038','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.466583,-111.988162,0,'2013-07-06 12:44:34',NULL,NULL),(65682,'77994','S','Westhoff','D','De Witt','48123','Texas','TX','48','0000','830','Central',-6.0,'Y',29.080804,-97.358612,0,'2013-07-06 12:44:34',NULL,NULL),(32553,'36112','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.366580,-86.299980,0,'2013-07-06 12:44:32',NULL,NULL),(77466,'96816','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286442,-157.801992,0,'2013-07-06 12:44:34',NULL,NULL),(50158,'57551','S','Martin','D','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.218780,-101.666700,0,'2013-07-06 12:44:33',NULL,NULL),(46072,'52583','S','Promise City','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.765798,-93.155233,0,'2013-07-06 12:44:32',NULL,NULL),(20241,'20781','S','Cheverly','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(2997,'01068','S','Oakham','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.346443,-72.049242,0,'2013-07-06 12:44:30',NULL,NULL),(28255,'31066','S','Musella','D','Crawford','13079','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.841603,-83.886065,0,'2013-07-06 12:44:31',NULL,NULL),(69260,'83429','S','Island Park','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.459589,-111.345873,0,'2013-07-06 12:44:34',NULL,NULL),(8828,'08625','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.205903,-74.757064,0,'2013-07-06 12:44:30',NULL,NULL),(21550,'22747','S','Wash','N','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.719068,-78.166901,0,'2013-07-06 12:44:31',NULL,NULL),(24557,'27294','U','National Wholesale Co Inc','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.821157,-80.250582,0,'2013-07-06 12:44:31',NULL,NULL),(75887,'94963','P','San Geronimo','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.012786,-122.663972,0,'2013-07-06 12:44:34',NULL,NULL),(50052,'57437','S','Hills','N','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.802620,-99.618600,0,'2013-07-06 12:44:33',NULL,NULL),(20546,'21117','S','Garrison','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.428406,-76.769758,0,'2013-07-06 12:44:31',NULL,NULL),(15610,'16680','S','Smithmill','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.758358,-78.398916,0,'2013-07-06 12:44:31',NULL,NULL),(37872,'42544','S','Nancy','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(43128,'48230','S','Grosse Pointe Shores','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(43332,'48366','P','Lakeville','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.821685,-83.152182,0,'2013-07-06 12:44:32',NULL,NULL),(49578,'56731','P','Humboldt','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.920986,-97.092786,0,'2013-07-06 12:44:33',NULL,NULL),(1183,'00727','S','Villa del Rey 5','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(39670,'45013','S','Millville','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.408216,-84.617598,0,'2013-07-06 12:44:32',NULL,NULL),(79848,'99548','P','Chignik Lake','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.233333,-158.783333,0,'2013-07-06 12:44:34',NULL,NULL),(60443,'71647','S','Patsville','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(54163,'62610','P','Alsey','D','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.557166,-90.433258,0,'2013-07-06 12:44:33',NULL,NULL),(33123,'36871','S','Pittsview','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.188403,-85.223329,0,'2013-07-06 12:44:32',NULL,NULL),(21357,'22438','S','Elevon','N','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.029503,-76.962492,0,'2013-07-06 12:44:31',NULL,NULL),(3245,'01432','S','Fort Devens','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.559756,-71.575320,0,'2013-07-06 12:44:30',NULL,NULL),(31278,'34025','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(45834,'52214','S','Waubeek','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.181140,-91.491360,0,'2013-07-06 12:44:32',NULL,NULL),(75598,'94302','P','Palo Alto','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.447087,-122.156083,0,'2013-07-06 12:44:34',NULL,NULL),(65932,'78249','S','Shavano Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.567119,-98.605723,0,'2013-07-06 12:44:34',NULL,NULL),(59896,'71275','S','Montcalm','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.530470,-92.786586,0,'2013-07-06 12:44:33',NULL,NULL),(31844,'35091','S','Kimberly','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.767665,-86.807616,0,'2013-07-06 12:44:32',NULL,NULL),(73269,'90731','S','Fort Macarthur','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.743520,-118.279440,0,'2013-07-06 12:44:34',NULL,NULL),(58763,'68966','S','Orleans','D','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.176268,-99.461273,0,'2013-07-06 12:44:33',NULL,NULL),(29982,'33093','P','Pompano Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.252723,-80.209522,0,'2013-07-06 12:44:32',NULL,NULL),(48244,'55423','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.876412,-93.286850,0,'2013-07-06 12:44:33',NULL,NULL),(79330,'98611','S','Castle Rock','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.286716,-122.900412,0,'2013-07-06 12:44:34',NULL,NULL),(75455,'94080','S','S San Fran','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.652366,-122.430543,0,'2013-07-06 12:44:34',NULL,NULL),(6889,'06143','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790844,-72.668920,0,'2013-07-06 12:44:30',NULL,NULL),(75802,'94801','S','Pt Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.942278,-122.355347,0,'2013-07-06 12:44:34',NULL,NULL),(58753,'68958','S','Laird','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.475637,-99.508161,0,'2013-07-06 12:44:33',NULL,NULL),(8652,'08313','P','Deerfield St','A','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.530646,-75.231010,0,'2013-07-06 12:44:30',NULL,NULL),(39531,'44827','S','North Robinson','A','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.799552,-82.760593,0,'2013-07-06 12:44:32',NULL,NULL),(44720,'50150','S','Lovilia','D','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.132809,-92.906584,0,'2013-07-06 12:44:32',NULL,NULL),(13965,'14470','S','Hulberton','A','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.253056,-78.066111,0,'2013-07-06 12:44:31',NULL,NULL),(68097,'80943','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837361,-104.823078,0,'2013-07-06 12:44:34',NULL,NULL),(62801,'74935','P','Fanshawe','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.952107,-94.906017,0,'2013-07-06 12:44:33',NULL,NULL),(31590,'34656','P','New Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.243613,-82.709068,0,'2013-07-06 12:44:32',NULL,NULL),(11427,'11967','S','East Yaphank','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.795028,-72.869264,0,'2013-07-06 12:44:30',NULL,NULL),(79715,'99212','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(79595,'99037','S','City of Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.644452,-117.195238,0,'2013-07-06 12:44:34',NULL,NULL),(69960,'84119','S','Granger','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(23294,'25177','S','Saint Albans','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.381638,-81.823224,0,'2013-07-06 12:44:31',NULL,NULL),(32447,'36017','S','Blue Springs','N','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.711536,-85.661259,0,'2013-07-06 12:44:32',NULL,NULL),(58491,'68760','S','Niobrara','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.768480,-98.009880,0,'2013-07-06 12:44:33',NULL,NULL),(65349,'77522','P','Baytown','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756389,-94.968370,0,'2013-07-06 12:44:34',NULL,NULL),(51586,'59804','S','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.854972,-114.192637,0,'2013-07-06 12:44:33',NULL,NULL),(13916,'14410','P','Adams Basin','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.192205,-77.855545,0,'2013-07-06 12:44:31',NULL,NULL),(76085,'95212','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.039880,-121.237899,0,'2013-07-06 12:44:34',NULL,NULL),(68009,'80922','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.898824,-104.700007,0,'2013-07-06 12:44:34',NULL,NULL),(12797,'13224','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.042678,-76.101087,0,'2013-07-06 12:44:30',NULL,NULL),(5267,'04490','S','Waite','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.452605,-67.717492,0,'2013-07-06 12:44:30',NULL,NULL),(11913,'12411','S','Bloomington','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.847960,-74.079060,0,'2013-07-06 12:44:30',NULL,NULL),(21041,'21871','S','Rumbley','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.097540,-75.760560,0,'2013-07-06 12:44:31',NULL,NULL),(8555,'08205','S','Absecon','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.420254,-74.502031,0,'2013-07-06 12:44:30',NULL,NULL),(79612,'99111','S','Diamond','A','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.878924,-117.356883,0,'2013-07-06 12:44:34',NULL,NULL),(57170,'66285','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.016846,-94.663276,0,'2013-07-06 12:44:33',NULL,NULL),(28589,'31637','S','El Dorado','N','Cook','13075','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.268413,-83.464912,0,'2013-07-06 12:44:32',NULL,NULL),(23867,'26150','S','Mineral Wells','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.192369,-81.520828,0,'2013-07-06 12:44:31',NULL,NULL),(25301,'28146','S','Granite Qry','A','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.630497,-80.432818,0,'2013-07-06 12:44:31',NULL,NULL),(69081,'83250','S','McCammon','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.643759,-112.195942,0,'2013-07-06 12:44:34',NULL,NULL),(15836,'16935','S','Niles Valley','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(33861,'38006','S','Bells','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.730519,-89.089584,0,'2013-07-06 12:44:32',NULL,NULL),(34079,'38151','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.149052,-89.977749,0,'2013-07-06 12:44:32',NULL,NULL),(14201,'14772','S','Randolph','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.146804,-78.981588,0,'2013-07-06 12:44:31',NULL,NULL),(47487,'54751','S','Rusk','N','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.877251,-91.923866,0,'2013-07-06 12:44:32',NULL,NULL),(77386,'96764','P','Laupahoehoe','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.965424,-155.234398,0,'2013-07-06 12:44:34',NULL,NULL),(49535,'56680','S','Oslund','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.633333,-93.966667,0,'2013-07-06 12:44:33',NULL,NULL),(1293,'00730','S','Urb La Guadalupe','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(15453,'16407','S','Corry','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.923367,-79.657272,0,'2013-07-06 12:44:31',NULL,NULL),(57088,'66217','S','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(2400,'00951','P','Toa Baja','D','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.443138,-66.255769,0,'2013-07-06 12:44:30',NULL,NULL),(41528,'46989','S','Upland','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.469833,-85.504988,0,'2013-07-06 12:44:32',NULL,NULL),(18624,'19151','S','Overbrook Hls','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.977579,-75.254673,0,'2013-07-06 12:44:31',NULL,NULL),(11836,'12244','U','NY Empl Retirement','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651521,-73.761175,0,'2013-07-06 12:44:30',NULL,NULL),(40083,'45302','S','Anna','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.399636,-84.202593,0,'2013-07-06 12:44:32',NULL,NULL),(50296,'57701','S','Old Town','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.080920,-103.172940,0,'2013-07-06 12:44:33',NULL,NULL),(33833,'37933','P','Concord Farragut','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.866070,-84.124099,0,'2013-07-06 12:44:32',NULL,NULL),(12495,'12997','S','Wilmington','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.388992,-73.843700,0,'2013-07-06 12:44:30',NULL,NULL),(19771,'20421','U','Veterans Benefits Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906309,-77.031251,0,'2013-07-06 12:44:31',NULL,NULL),(64842,'77041','S','Jersey Vlg','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.857122,-95.572778,0,'2013-07-06 12:44:34',NULL,NULL),(17071,'17758','S','Davidson','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(32061,'35266','P','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(2496,'00956','S','VISTA Bella','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(63972,'76104','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.728820,-97.319414,0,'2013-07-06 12:44:34',NULL,NULL),(56151,'64854','S','Noel','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.541955,-94.486016,0,'2013-07-06 12:44:33',NULL,NULL),(53824,'62298','S','St Joe','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(36359,'40447','S','Foxtown','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(45378,'51019','S','Danbury','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.261533,-95.784346,0,'2013-07-06 12:44:32',NULL,NULL),(73402,'91123','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138331,-118.152775,0,'2013-07-06 12:44:34',NULL,NULL),(69367,'83601','P','Atlanta','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.837386,-115.282367,0,'2013-07-06 12:44:34',NULL,NULL),(56092,'64776','S','Damascus','N','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.040765,-93.704717,0,'2013-07-06 12:44:33',NULL,NULL),(17351,'17870','S','Verdilla','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(24078,'26448','S','Wallace','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.409991,-80.483950,0,'2013-07-06 12:44:31',NULL,NULL),(43784,'49041','P','Comstock','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.284886,-85.511298,0,'2013-07-06 12:44:32',NULL,NULL),(79473,'98858','S','Douglas','N','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.677620,-119.909880,0,'2013-07-06 12:44:34',NULL,NULL),(78433,'98053','S','Redmond','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.666262,-122.015882,0,'2013-07-06 12:44:34',NULL,NULL),(73967,'92070','S','Santa Ysabel','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.143858,-116.712191,0,'2013-07-06 12:44:34',NULL,NULL),(63144,'75372','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.839532,-96.773841,0,'2013-07-06 12:44:33',NULL,NULL),(60717,'71953','S','Menos','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(59387,'70609','U','McNeese State University','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.181629,-93.213153,0,'2013-07-06 12:44:33',NULL,NULL),(57280,'66603','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.058392,-95.676444,0,'2013-07-06 12:44:33',NULL,NULL),(24537,'27292','S','Cid','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(45088,'50535','S','Early','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.454667,-95.092473,0,'2013-07-06 12:44:32',NULL,NULL),(46107,'52632','S','Keokuk','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.472778,-91.448611,0,'2013-07-06 12:44:32',NULL,NULL),(52785,'61270','S','Round Grove','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(51197,'59031','S','Garryowen','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.471093,-107.261777,0,'2013-07-06 12:44:33',NULL,NULL),(11453,'11978','S','West Hampton Dunes','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(18213,'18954','S','Richboro','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.216524,-75.002295,0,'2013-07-06 12:44:31',NULL,NULL),(15672,'16822','S','Beech Creek','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.093511,-77.523777,0,'2013-07-06 12:44:31',NULL,NULL),(40688,'46068','S','Sharpsville','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.380698,-86.088622,0,'2013-07-06 12:44:32',NULL,NULL),(34092,'38163','U','University of Tn','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.141451,-90.035289,0,'2013-07-06 12:44:32',NULL,NULL),(46389,'53149','S','Mukwonago','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.867284,-88.337814,0,'2013-07-06 12:44:32',NULL,NULL),(75305,'93741','U','Fresno City College','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.798392,-119.801743,0,'2013-07-06 12:44:34',NULL,NULL),(31576,'34652','S','New Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.238545,-82.730700,0,'2013-07-06 12:44:32',NULL,NULL),(59512,'70785','S','Walker','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.519892,-90.851667,0,'2013-07-06 12:44:33',NULL,NULL),(50973,'58636','S','Halliday','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.342310,-102.334132,0,'2013-07-06 12:44:33',NULL,NULL),(15484,'16441','S','Waterford','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.951110,-79.987648,0,'2013-07-06 12:44:31',NULL,NULL),(39608,'44878','S','Shenadoah','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.935120,-82.507980,0,'2013-07-06 12:44:32',NULL,NULL),(36812,'41056','S','Sardis','A','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(51508,'59644','S','Townsend','D','Broadwater','30007','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.316771,-111.490400,0,'2013-07-06 12:44:33',NULL,NULL),(36552,'40906','S','Swanpond','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(35528,'39553','S','Gautier','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400064,-88.643006,0,'2013-07-06 12:44:32',NULL,NULL),(36809,'41056','S','Orangeburg','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(77971,'97376','S','Seal Rock','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.499453,-124.055888,0,'2013-07-06 12:44:34',NULL,NULL),(61901,'73142','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.606201,-97.641926,0,'2013-07-06 12:44:33',NULL,NULL),(57383,'66753','S','Mc Cune','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.352484,-95.021069,0,'2013-07-06 12:44:33',NULL,NULL),(45817,'52204','U','Amana Refrigeration Inc','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.798523,-91.870646,0,'2013-07-06 12:44:32',NULL,NULL),(25499,'28370','P','Pinehurst','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.182077,-79.460429,0,'2013-07-06 12:44:31',NULL,NULL),(7188,'06471','S','North Branford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.341138,-72.776339,0,'2013-07-06 12:44:30',NULL,NULL),(9684,'10044','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(49988,'57366','S','Milltown','N','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.394273,-97.988210,0,'2013-07-06 12:44:33',NULL,NULL),(64784,'77008','S','Heights','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.796325,-95.417235,0,'2013-07-06 12:44:34',NULL,NULL),(50299,'57702','S','Hisega','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.063037,-103.280916,0,'2013-07-06 12:44:33',NULL,NULL),(6624,'05904','S','Gilman','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.417023,-71.716414,0,'2013-07-06 12:44:30',NULL,NULL),(36239,'40294','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258043,-85.759137,0,'2013-07-06 12:44:32',NULL,NULL),(32371,'35898','U','Redstone Central','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.628936,-86.651129,0,'2013-07-06 12:44:32',NULL,NULL),(29361,'32570','S','Milton','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.633995,-87.046252,0,'2013-07-06 12:44:32',NULL,NULL),(27057,'29681','S','Simpsonville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.777584,-82.128196,0,'2013-07-06 12:44:31',NULL,NULL),(63677,'75859','S','Winkler','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.921560,-96.280920,0,'2013-07-06 12:44:34',NULL,NULL),(57411,'66770','S','Riverton','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.102246,-94.669909,0,'2013-07-06 12:44:33',NULL,NULL),(2608,'00961','S','Urb Veredas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(57175,'66286','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.993781,-94.871495,0,'2013-07-06 12:44:33',NULL,NULL),(13429,'13757','S','West Meredith','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.415691,-74.888542,0,'2013-07-06 12:44:31',NULL,NULL),(32539,'36106','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.351832,-86.264275,0,'2013-07-06 12:44:32',NULL,NULL),(33279,'37111','P','Mc Minnvl','N','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.687754,-85.775514,0,'2013-07-06 12:44:32',NULL,NULL),(48303,'55441','S','Medicine Lake','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.004561,-93.426516,0,'2013-07-06 12:44:33',NULL,NULL),(23783,'25984','S','Duo','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.961580,-80.692200,0,'2013-07-06 12:44:31',NULL,NULL),(38112,'43105','S','Etna','A','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.858878,-82.620111,0,'2013-07-06 12:44:32',NULL,NULL),(36875,'41095','S','Warsaw','D','Gallatin','21077','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.785010,-84.902852,0,'2013-07-06 12:44:32',NULL,NULL),(36329,'40387','S','Wellington','D','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.981269,-83.472057,0,'2013-07-06 12:44:32',NULL,NULL),(44282,'49716','S','Brutus','D','Emmet','26047','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.504726,-84.772608,0,'2013-07-06 12:44:32',NULL,NULL),(70405,'84716','P','Boulder','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.831807,-111.204558,0,'2013-07-06 12:44:34',NULL,NULL),(68977,'83112','S','Turnerville','N','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.900000,-110.933333,0,'2013-07-06 12:44:34',NULL,NULL),(23536,'25606','P','Accoville','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.766019,-81.835111,0,'2013-07-06 12:44:31',NULL,NULL),(45164,'50595','S','Webster City','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.460860,-93.829680,0,'2013-07-06 12:44:32',NULL,NULL),(10438,'10912','P','Bellvale','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.247332,-74.303862,0,'2013-07-06 12:44:30',NULL,NULL),(16197,'17070','S','New Cmbrlnd','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(12924,'13340','S','Frankfort Center','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.040165,-75.082322,0,'2013-07-06 12:44:30',NULL,NULL),(38109,'43103','S','S Bloomfield','A','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.726780,-82.952940,0,'2013-07-06 12:44:32',NULL,NULL),(15909,'17015','S','W Pennsboro','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.201481,-77.189072,0,'2013-07-06 12:44:31',NULL,NULL),(1815,'00784','S','Comunidad San Martin','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(195,'00623','S','Urb Joyuda Coast','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(14621,'15229','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.517677,-80.040063,0,'2013-07-06 12:44:31',NULL,NULL),(49455,'56647','S','Hagali','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.758791,-94.680589,0,'2013-07-06 12:44:33',NULL,NULL),(77076,'96129','S','Beckwourth','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.818308,-120.376409,0,'2013-07-06 12:44:34',NULL,NULL),(31863,'35120','S','Odenville','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.668856,-86.429644,0,'2013-07-06 12:44:32',NULL,NULL),(19461,'20131','P','Philomont','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.058149,-77.740608,0,'2013-07-06 12:44:31',NULL,NULL),(20245,'20781','S','Tuxedo','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(30931,'33711','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.751284,-82.687336,0,'2013-07-06 12:44:32',NULL,NULL),(3277,'01472','P','West Groton','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.606629,-71.629140,0,'2013-07-06 12:44:30',NULL,NULL),(48600,'55786','P','Arcturus','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.309263,-93.382691,0,'2013-07-06 12:44:33',NULL,NULL),(71242,'86342','P','Lk Montezuma','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.630923,-111.776683,0,'2013-07-06 12:44:34',NULL,NULL),(6631,'05906','S','East Concord','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.429167,-71.679722,0,'2013-07-06 12:44:30',NULL,NULL),(72565,'89311','S','Lehman Caves','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.000092,-114.164202,0,'2013-07-06 12:44:34',NULL,NULL),(51698,'60004','S','Arlington Hts','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.108547,-87.974705,0,'2013-07-06 12:44:33',NULL,NULL),(800,'00693','S','Repto Sobrino','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(47666,'54941','S','Green Lake','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.839465,-88.969575,0,'2013-07-06 12:44:33',NULL,NULL),(16979,'17724','S','Union Center','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(46627,'53581','S','Richland Ctr','A','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.351140,-90.389940,0,'2013-07-06 12:44:32',NULL,NULL),(2789,'00976','S','Urb Altavilla','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(5069,'04286','P','West Bethel','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.418541,-70.844496,0,'2013-07-06 12:44:30',NULL,NULL),(11221,'11747','S','Melville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.803692,-73.402157,0,'2013-07-06 12:44:30',NULL,NULL),(70577,'85069','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.562209,-112.098364,0,'2013-07-06 12:44:34',NULL,NULL),(56129,'64835','S','Carterville','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.148199,-94.439147,0,'2013-07-06 12:44:33',NULL,NULL),(54483,'62862','S','Mill Shoals','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.088088,-88.171431,0,'2013-07-06 12:44:33',NULL,NULL),(17446,'17938','S','Fountain','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.655278,-76.446944,0,'2013-07-06 12:44:31',NULL,NULL),(48528,'55748','S','Haypoint','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.988100,-93.593880,0,'2013-07-06 12:44:33',NULL,NULL),(6314,'05661','S','Elmore','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(28236,'31047','S','Kathleen','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.501331,-83.630956,0,'2013-07-06 12:44:31',NULL,NULL),(48100,'55343','S','Minnetnka Mls','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(56271,'65066','S','Drake','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348543,-91.499030,0,'2013-07-06 12:44:33',NULL,NULL),(53456,'61913','S','Atwood','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.814320,-88.436880,0,'2013-07-06 12:44:33',NULL,NULL),(28099,'30751','P','Tennga','D','Murray','13213','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.986081,-84.736575,0,'2013-07-06 12:44:31',NULL,NULL),(24254,'26807','S','Franklin','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.620551,-79.384110,0,'2013-07-06 12:44:31',NULL,NULL),(78887,'98358','S','Ft Flagler','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(78213,'97756','S','Redmond','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.275433,-121.205705,0,'2013-07-06 12:44:34',NULL,NULL),(66047,'78373','S','Port Aransas','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.825283,-97.064208,0,'2013-07-06 12:44:34',NULL,NULL),(47527,'54806','S','Red Cliff Indian Reservation','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(7931,'07649','S','Oradell','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.951279,-74.037564,0,'2013-07-06 12:44:30',NULL,NULL),(10387,'10598','S','Yorktown','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.294911,-73.797703,0,'2013-07-06 12:44:30',NULL,NULL),(55403,'63645','S','Cobalt City','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.559762,-90.292995,0,'2013-07-06 12:44:33',NULL,NULL),(16670,'17356','S','Snyder Corner','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(33152,'37010','S','Adams','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.565492,-87.095773,0,'2013-07-06 12:44:32',NULL,NULL),(14333,'15003','S','Ambridge','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.582123,-80.214863,0,'2013-07-06 12:44:31',NULL,NULL),(76862,'95969','S','Paradise','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.760113,-121.602349,0,'2013-07-06 12:44:34',NULL,NULL),(51585,'59804','S','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.854972,-114.192637,0,'2013-07-06 12:44:33',NULL,NULL),(50593,'58239','S','Hannah','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.947689,-98.737664,0,'2013-07-06 12:44:33',NULL,NULL),(31726,'34981','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.403812,-80.361046,0,'2013-07-06 12:44:32',NULL,NULL),(41788,'47322','P','Bentonville','D','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.748489,-85.241805,0,'2013-07-06 12:44:32',NULL,NULL),(45724,'52076','S','Strawberry Point','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.704281,-91.512431,0,'2013-07-06 12:44:32',NULL,NULL),(49264,'56481','S','Thomastown','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.399714,-95.014769,0,'2013-07-06 12:44:33',NULL,NULL),(21639,'22923','S','Barboursville','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.166765,-78.365242,0,'2013-07-06 12:44:31',NULL,NULL),(62594,'74501','S','Bache','A','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.935281,-95.767139,0,'2013-07-06 12:44:33',NULL,NULL),(43334,'48367','S','Addison Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.844709,-83.140674,0,'2013-07-06 12:44:32',NULL,NULL),(29443,'32697','P','Worthington Springs','D','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.931333,-82.424654,0,'2013-07-06 12:44:32',NULL,NULL),(58724,'68941','S','Glenvil','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.483464,-98.219562,0,'2013-07-06 12:44:33',NULL,NULL),(50654,'58324','S','Maza','A','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.488286,-99.201112,0,'2013-07-06 12:44:33',NULL,NULL),(1564,'00766','S','Villa Alba','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(13408,'13753','S','West Delhi','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.282872,-74.910178,0,'2013-07-06 12:44:31',NULL,NULL),(79632,'99129','S','Hunters','A','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.045656,-118.195215,0,'2013-07-06 12:44:34',NULL,NULL),(19380,'20063','U','Int Group Plans Inc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903209,-77.044386,0,'2013-07-06 12:44:31',NULL,NULL),(45361,'51003','S','Carnes','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.987828,-96.011384,0,'2013-07-06 12:44:32',NULL,NULL),(32199,'35550','S','Barney','N','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.770460,-87.177780,0,'2013-07-06 12:44:32',NULL,NULL),(16352,'17177','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.290362,-76.812588,0,'2013-07-06 12:44:31',NULL,NULL),(10781,'11367','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728160,-73.818582,0,'2013-07-06 12:44:30',NULL,NULL),(21493,'22655','S','Stephens City','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.086856,-78.206821,0,'2013-07-06 12:44:31',NULL,NULL),(39537,'44833','S','Sugar Grove Lake','N','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.735262,-82.797835,0,'2013-07-06 12:44:32',NULL,NULL),(67821,'80757','S','Woodrow','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.733095,-103.505678,0,'2013-07-06 12:44:34',NULL,NULL),(59552,'70823','U','La Dept Reven','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.445781,-91.189226,0,'2013-07-06 12:44:33',NULL,NULL),(52153,'60445','S','Midlothian','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.635673,-87.738641,0,'2013-07-06 12:44:33',NULL,NULL),(10188,'10286','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705704,-74.007966,0,'2013-07-06 12:44:30',NULL,NULL),(41707,'47232','S','Elizabethtown','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.112200,-85.809480,0,'2013-07-06 12:44:32',NULL,NULL),(23046,'24862','S','Mohawk','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.499123,-81.901942,0,'2013-07-06 12:44:31',NULL,NULL),(41498,'46953','S','Marion','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.532775,-85.658755,0,'2013-07-06 12:44:32',NULL,NULL),(68056,'80932','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848511,-104.780034,0,'2013-07-06 12:44:34',NULL,NULL),(51149,'58845','S','Grenora','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.602400,-103.917180,0,'2013-07-06 12:44:33',NULL,NULL),(50348,'57744','S','Red Shirt','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.838417,-103.190898,0,'2013-07-06 12:44:33',NULL,NULL),(79309,'98595','S','Cohasset Beach','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.881787,-124.107588,0,'2013-07-06 12:44:34',NULL,NULL),(78618,'98199','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.649774,-122.398314,0,'2013-07-06 12:44:34',NULL,NULL),(76992,'96071','S','Old Station','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.661393,-121.458050,0,'2013-07-06 12:44:34',NULL,NULL),(71450,'87043','S','Placitas','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.313941,-106.444467,0,'2013-07-06 12:44:34',NULL,NULL),(55645,'64020','S','Concordia','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',38.955230,-93.584522,0,'2013-07-06 12:44:33',NULL,NULL),(26634,'29331','P','Cross Anchor','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.654981,-81.877783,0,'2013-07-06 12:44:31',NULL,NULL),(22157,'23459','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(41036,'46391','S','Otis','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.551257,-86.899358,0,'2013-07-06 12:44:32',NULL,NULL),(38835,'44085','S','Roaming Shores','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(2258,'00926','S','Urb Montehiedra','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(52155,'60446','S','Romeoville','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.591798,-88.060557,0,'2013-07-06 12:44:33',NULL,NULL),(47694,'54970','S','Redgranite','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.048400,-89.084940,0,'2013-07-06 12:44:33',NULL,NULL),(30425,'33328','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.066580,-80.272800,0,'2013-07-06 12:44:32',NULL,NULL),(28712,'31832','S','Weston','D','Webster','13307','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.958888,-84.567148,0,'2013-07-06 12:44:32',NULL,NULL),(69873,'84095','S','South Jordan','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569297,-111.967229,0,'2013-07-06 12:44:34',NULL,NULL),(69487,'83680','P','Meridian','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.607726,-116.400726,0,'2013-07-06 12:44:34',NULL,NULL),(13694,'14055','S','E Concord','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.553172,-78.608173,0,'2013-07-06 12:44:31',NULL,NULL),(13110,'13483','S','Westdale','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.415556,-75.815422,0,'2013-07-06 12:44:30',NULL,NULL),(7907,'07608','S','Teterboro','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.856525,-74.064571,0,'2013-07-06 12:44:30',NULL,NULL),(56877,'66024','P','Elwood','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.758137,-94.877538,0,'2013-07-06 12:44:33',NULL,NULL),(36899,'41114','U','Ashland Oil Inc','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.461423,-82.647651,0,'2013-07-06 12:44:32',NULL,NULL),(73014,'90067','S','Century City','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.058123,-118.416403,0,'2013-07-06 12:44:34',NULL,NULL),(66013,'78355','S','Falfurrias','D','Brooks','48047','Texas','TX','48','0000','361','Central',-6.0,'Y',27.225360,-98.143700,0,'2013-07-06 12:44:34',NULL,NULL),(73141,'90275','S','Pls Vrds Est','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(67628,'80446','S','Silvercreek','N','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.061700,-105.878940,0,'2013-07-06 12:44:34',NULL,NULL),(64291,'76448','S','Eastland','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.399569,-98.823133,0,'2013-07-06 12:44:34',NULL,NULL),(42504,'47842','S','Syndicate','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(46829,'54014','S','Diamond Bluff','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.602849,-92.538909,0,'2013-07-06 12:44:32',NULL,NULL),(7970,'07702','S','Shrewsbury','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.346944,-74.064722,0,'2013-07-06 12:44:30',NULL,NULL),(7582,'07032','S','South Kearny','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.762320,-74.123220,0,'2013-07-06 12:44:30',NULL,NULL),(41590,'47060','S','W Harrison','N','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.288941,-84.865533,0,'2013-07-06 12:44:32',NULL,NULL),(21238,'22240','U','Us Navy Accounting Office','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853022,-77.054148,0,'2013-07-06 12:44:31',NULL,NULL),(2707,'00969','S','Mans de Alejandrino','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(54272,'62684','S','Sherman','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.894681,-89.600868,0,'2013-07-06 12:44:33',NULL,NULL),(62165,'73737','S','Orienta','A','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.268920,-98.513880,0,'2013-07-06 12:44:33',NULL,NULL),(10317,'10540','P','Lincolndale','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.342061,-73.721539,0,'2013-07-06 12:44:30',NULL,NULL),(71753,'87545','U','Scientific Lab','N','Los Alamos','35028','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.893540,-106.285048,0,'2013-07-06 12:44:34',NULL,NULL),(61042,'72118','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(57458,'66854','S','Hartford','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.307110,-95.957044,0,'2013-07-06 12:44:33',NULL,NULL),(79679,'99171','S','Saint John','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.092191,-117.583530,0,'2013-07-06 12:44:34',NULL,NULL),(73726,'91617','P','Valley Vlg','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164995,-118.403562,0,'2013-07-06 12:44:34',NULL,NULL),(54914,'63088','S','Twin Oaks','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550608,-90.490282,0,'2013-07-06 12:44:33',NULL,NULL),(28412,'31322','S','Pooler','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.117778,-81.252115,0,'2013-07-06 12:44:32',NULL,NULL),(15950,'17024','S','Greenpark','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(44401,'49818','S','Cornell','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.909059,-87.200700,0,'2013-07-06 12:44:32',NULL,NULL),(35280,'39401','S','Batson','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(26424,'29125','S','Rimini','A','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.742260,-80.481720,0,'2013-07-06 12:44:31',NULL,NULL),(22921,'24612','P','Doran','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.090762,-81.791295,0,'2013-07-06 12:44:31',NULL,NULL),(77688,'97038','S','Liberal','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.121182,-122.569308,0,'2013-07-06 12:44:34',NULL,NULL),(74164,'92266','P','Palo Verde','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.427558,-114.728608,0,'2013-07-06 12:44:34',NULL,NULL),(64365,'76524','S','Eddy','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.335720,-97.277820,0,'2013-07-06 12:44:34',NULL,NULL),(22800,'24472','S','Raphine','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.937785,-79.136378,0,'2013-07-06 12:44:31',NULL,NULL),(68386,'81147','S','Pagosa Springs','D','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.256494,-107.086521,0,'2013-07-06 12:44:34',NULL,NULL),(56844,'65890','U','Springfield Brm','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.205863,-93.354799,0,'2013-07-06 12:44:33',NULL,NULL),(77745,'97086','S','Portland','A','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.443245,-122.514694,0,'2013-07-06 12:44:34',NULL,NULL),(71299,'86502','P','Chambers','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.419444,-109.495833,0,'2013-07-06 12:44:34',NULL,NULL),(18562,'19122','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.976781,-75.144244,0,'2013-07-06 12:44:31',NULL,NULL),(16380,'17210','P','Amberson','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.197059,-77.651373,0,'2013-07-06 12:44:31',NULL,NULL),(12295,'12849','S','Mdl Granville','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.451548,-73.301373,0,'2013-07-06 12:44:30',NULL,NULL),(13865,'14231','P','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980390,-78.737853,0,'2013-07-06 12:44:31',NULL,NULL),(52873,'61338','P','Manlius','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.455833,-89.667860,0,'2013-07-06 12:44:33',NULL,NULL),(5718,'04992','P','West Farmington','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.664202,-70.152992,0,'2013-07-06 12:44:30',NULL,NULL),(20325,'20837','S','Poolesville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.131746,-77.404202,0,'2013-07-06 12:44:31',NULL,NULL),(40931,'46283','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.777280,-86.111789,0,'2013-07-06 12:44:32',NULL,NULL),(326,'00650','S','Florida','D','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(75117,'93549','P','Cartago','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.320833,-118.025556,0,'2013-07-06 12:44:34',NULL,NULL),(69945,'84117','S','Holladay','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(36012,'40157','S','Payneville','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',38.025500,-86.400703,0,'2013-07-06 12:44:32',NULL,NULL),(45547,'51460','P','Ricketts','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.130171,-95.573865,0,'2013-07-06 12:44:32',NULL,NULL),(17209,'17822','U','Geisinger Medical Center','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.958350,-76.609495,0,'2013-07-06 12:44:31',NULL,NULL),(25996,'28670','S','Ronda','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.236340,-80.926620,0,'2013-07-06 12:44:31',NULL,NULL),(51176,'59012','S','Birney','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.306004,-106.491116,0,'2013-07-06 12:44:33',NULL,NULL),(19233,'19903','P','Dover','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.209462,-75.570122,0,'2013-07-06 12:44:31',NULL,NULL),(66727,'78956','S','Freyburg','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(55669,'64036','S','Henrietta','D','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.209474,-93.898888,0,'2013-07-06 12:44:33',NULL,NULL),(16551,'17307','S','Guernsey','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(24142,'26566','P','Colfax','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.435212,-80.129545,0,'2013-07-06 12:44:31',NULL,NULL),(12675,'13126','S','North Hannibal','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(45819,'52205','S','Anamosa','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.113520,-91.295220,0,'2013-07-06 12:44:32',NULL,NULL),(19001,'19526','S','Berne','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(33678,'37738','S','Gatlinburg','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.713490,-83.515498,0,'2013-07-06 12:44:32',NULL,NULL),(36895,'41105','P','Ashland','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.430686,-82.667440,0,'2013-07-06 12:44:32',NULL,NULL),(2487,'00956','S','Urb Royal Palm','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(75095,'93536','S','Metler Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(71171,'86040','P','Lake Powell Mart','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.913751,-111.467162,0,'2013-07-06 12:44:34',NULL,NULL),(14338,'15007','S','Bakerstown','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.653132,-79.934695,0,'2013-07-06 12:44:31',NULL,NULL),(14544,'15210','S','Mt Oliver','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.404900,-79.972620,0,'2013-07-06 12:44:31',NULL,NULL),(78925,'98366','S','Horseshoe Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(65929,'78247','S','Wetmore','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588133,-98.402025,0,'2013-07-06 12:44:34',NULL,NULL),(49871,'57259','S','Albee','A','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.017266,-96.548264,0,'2013-07-06 12:44:33',NULL,NULL),(215,'00624','S','Jard de Penuelas','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(41462,'46913','S','Bringhurst','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.513551,-86.527197,0,'2013-07-06 12:44:32',NULL,NULL),(36189,'40257','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(34139,'38230','S','Greenfield','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.151574,-88.799392,0,'2013-07-06 12:44:32',NULL,NULL),(48238,'55421','S','St Anthony','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(3040,'01102','P','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.116054,-72.538580,0,'2013-07-06 12:44:30',NULL,NULL),(5649,'04954','P','New Portland','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.883149,-70.088461,0,'2013-07-06 12:44:30',NULL,NULL),(41668,'47160','S','New Middletwn','A','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.138492,-86.054477,0,'2013-07-06 12:44:32',NULL,NULL),(45651,'52001','S','Julien','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(24170,'26617','S','Dille','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.466488,-80.871552,0,'2013-07-06 12:44:31',NULL,NULL),(1756,'00780','S','Bo Verdum','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(13691,'14054','S','E Bethany','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.915590,-78.135091,0,'2013-07-06 12:44:31',NULL,NULL),(55464,'63740','S','Arbor','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.185720,-89.647920,0,'2013-07-06 12:44:33',NULL,NULL),(40637,'46032','S','Carmel','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.967649,-86.160227,0,'2013-07-06 12:44:32',NULL,NULL),(40431,'45711','S','Amesville','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.415295,-81.940441,0,'2013-07-06 12:44:32',NULL,NULL),(2716,'00969','S','Repto La Esperanza','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(11273,'11771','S','Laurel Hollow','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(68521,'81334','P','Towaoc','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.191688,-108.741033,0,'2013-07-06 12:44:34',NULL,NULL),(68017,'80924','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739417,-104.635170,0,'2013-07-06 12:44:34',NULL,NULL),(63656,'75846','S','Newby','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.375296,-96.221448,0,'2013-07-06 12:44:34',NULL,NULL),(56385,'65233','S','Lamine','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(52626,'61042','S','Harmon','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.694727,-89.557402,0,'2013-07-06 12:44:33',NULL,NULL),(50375,'57758','S','Zeona','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.892550,-102.451810,0,'2013-07-06 12:44:33',NULL,NULL),(15558,'16635','S','Duncansville','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.426696,-78.431599,0,'2013-07-06 12:44:31',NULL,NULL),(29494,'32747','P','Lake Monroe','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.822210,-81.319736,0,'2013-07-06 12:44:32',NULL,NULL),(65982,'78332','S','Guajillo','N','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742680,-98.085900,0,'2013-07-06 12:44:34',NULL,NULL),(51341,'59314','S','Biddle','D','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.286436,-105.315136,0,'2013-07-06 12:44:33',NULL,NULL),(16209,'17071','P','New Germanton','A','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.282231,-77.577883,0,'2013-07-06 12:44:31',NULL,NULL),(14946,'15605','U','Greensburg','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.348276,-79.518797,0,'2013-07-06 12:44:31',NULL,NULL),(19547,'20196','U','Hundon','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.926126,-77.396695,0,'2013-07-06 12:44:31',NULL,NULL),(9516,'10017','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(54145,'62565','S','Westervelt','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(44886,'50317','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(43630,'48823','S','East Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.745357,-84.470605,0,'2013-07-06 12:44:32',NULL,NULL),(16488,'17257','S','Cleversburg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(5018,'04234','P','East Wilton','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.592447,-70.304079,0,'2013-07-06 12:44:30',NULL,NULL),(12503,'13021','S','Owasco','A','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(50780,'58429','S','Dazey','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.202000,-98.138880,0,'2013-07-06 12:44:33',NULL,NULL),(52877,'61342','S','Mendota','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.540805,-89.106262,0,'2013-07-06 12:44:33',NULL,NULL),(52217,'60484','S','Park Forest','A','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466347,-87.698762,0,'2013-07-06 12:44:33',NULL,NULL),(16658,'17352','S','Bridgeton','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.751920,-76.495680,0,'2013-07-06 12:44:31',NULL,NULL),(34172,'38305','S','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.681229,-88.821998,0,'2013-07-06 12:44:32',NULL,NULL),(46371,'53126','S','Franksville','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.779997,-87.960272,0,'2013-07-06 12:44:32',NULL,NULL),(60613,'71858','S','Rosston','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.569569,-93.289236,0,'2013-07-06 12:44:33',NULL,NULL),(60516,'71667','S','Griffith Spring','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(52886,'61349','S','Ohio','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.602605,-89.452512,0,'2013-07-06 12:44:33',NULL,NULL),(13814,'14212','S','Sloan','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.862020,-78.818580,0,'2013-07-06 12:44:31',NULL,NULL),(30600,'33421','P','Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(27600,'30297','S','Gillem Enclave','A','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.615198,-84.367485,0,'2013-07-06 12:44:31',NULL,NULL),(15791,'16923','S','Raymond','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(50566,'58220','S','Akra','N','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.782525,-97.607866,0,'2013-07-06 12:44:33',NULL,NULL),(65516,'77705','S','Taylor Lndg','A','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.969400,-94.155300,0,'2013-07-06 12:44:34',NULL,NULL),(14099,'14622','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.216211,-77.562561,0,'2013-07-06 12:44:31',NULL,NULL),(14356,'15018','S','Buena Vista','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.266596,-79.798318,0,'2013-07-06 12:44:31',NULL,NULL),(52300,'60541','S','Newark','D','Kendall','17093','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.514251,-88.510263,0,'2013-07-06 12:44:33',NULL,NULL),(50416,'57785','S','Hereford','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(14979,'15638','P','Hostetter','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.268335,-79.398814,0,'2013-07-06 12:44:31',NULL,NULL),(36770,'41042','S','Devon','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.986125,-84.648281,0,'2013-07-06 12:44:32',NULL,NULL),(73361,'91012','P','La Canada Flt','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203774,-118.191187,0,'2013-07-06 12:44:34',NULL,NULL),(71107,'86001','S','Northern Arizona University','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.139960,-111.634080,0,'2013-07-06 12:44:34',NULL,NULL),(60496,'71663','S','Portland','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.238405,-91.516386,0,'2013-07-06 12:44:33',NULL,NULL),(53518,'62025','S','Edwardsville','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.808317,-89.950081,0,'2013-07-06 12:44:33',NULL,NULL),(34385,'38618','S','Coldwater','D','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(21262,'22305','S','George Washington','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.838240,-77.066036,0,'2013-07-06 12:44:31',NULL,NULL),(21322,'22407','S','Frederickbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(24612,'27331','P','Sanford','D','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.474935,-79.182583,0,'2013-07-06 12:44:31',NULL,NULL),(53818,'62298','S','Lou del','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(9068,'08989','U','New Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.519417,-74.414583,0,'2013-07-06 12:44:30',NULL,NULL),(80201,'99928','P','Ward Cove','D','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.455705,-131.792537,0,'2013-07-06 12:44:34',NULL,NULL),(2834,'00982','S','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(74117,'92233','S','Calipatria','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.133447,-115.507456,0,'2013-07-06 12:44:34',NULL,NULL),(33895,'38039','S','Grand Junction','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.272747,-89.154588,0,'2013-07-06 12:44:32',NULL,NULL),(47962,'55121','S','Eagan','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.848185,-93.145649,0,'2013-07-06 12:44:33',NULL,NULL),(67430,'80163','P','Hghlnds Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.545881,-104.974412,0,'2013-07-06 12:44:34',NULL,NULL),(34893,'38950','S','Macel','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.745493,-90.213618,0,'2013-07-06 12:44:32',NULL,NULL),(30621,'33436','S','Golf','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524205,-80.107257,0,'2013-07-06 12:44:32',NULL,NULL),(20198,'20753','P','District Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.858256,-76.887275,0,'2013-07-06 12:44:31',NULL,NULL),(3577,'01969','S','Rowley','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.721075,-70.898492,0,'2013-07-06 12:44:30',NULL,NULL),(27359,'30062','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.999118,-84.467523,0,'2013-07-06 12:44:31',NULL,NULL),(1225,'00728','S','Urb San Jose','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(75297,'93728','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.757679,-119.817036,0,'2013-07-06 12:44:34',NULL,NULL),(11432,'11968','S','South Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.907565,-72.411077,0,'2013-07-06 12:44:30',NULL,NULL),(18617,'19148','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.922429,-75.158025,0,'2013-07-06 12:44:31',NULL,NULL),(73839,'91789','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.014965,-117.856127,0,'2013-07-06 12:44:34',NULL,NULL),(1677,'00777','S','Ciudad Jardin Juncos','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(18952,'19510','S','Blandon','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.441303,-75.879383,0,'2013-07-06 12:44:31',NULL,NULL),(23710,'25879','P','Minden','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.977026,-81.119048,0,'2013-07-06 12:44:31',NULL,NULL),(70692,'85258','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.572368,-111.899332,0,'2013-07-06 12:44:34',NULL,NULL),(46618,'53575','S','Oregon','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.931421,-89.389758,0,'2013-07-06 12:44:32',NULL,NULL),(77100,'96140','P','Fulton Acres','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(28667,'31789','S','Sumner','D','Worth','13321','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.542195,-83.718349,0,'2013-07-06 12:44:32',NULL,NULL),(5753,'05039','S','Corinth','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(23268,'25140','S','Stickney','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.897184,-81.525084,0,'2013-07-06 12:44:31',NULL,NULL),(79819,'99506','S','Anchorage','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.232052,-149.789210,0,'2013-07-06 12:44:34',NULL,NULL),(65078,'77351','S','Ala Coushatta Ind Res','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.577170,-94.686210,0,'2013-07-06 12:44:34',NULL,NULL),(62125,'73660','S','Reydon','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.656724,-99.901030,0,'2013-07-06 12:44:33',NULL,NULL),(17388,'17889','S','Winfield','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.918340,-76.860052,0,'2013-07-06 12:44:31',NULL,NULL),(7859,'07481','S','Wyckoff','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.998995,-74.166584,0,'2013-07-06 12:44:30',NULL,NULL),(67049,'79549','S','Dermott','A','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.764680,-100.858920,0,'2013-07-06 12:44:34',NULL,NULL),(61493,'72642','S','Lakeview','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.384430,-92.521129,0,'2013-07-06 12:44:33',NULL,NULL),(52702,'61109','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.194700,-89.062680,0,'2013-07-06 12:44:33',NULL,NULL),(20307,'20815','S','N Chevy Chase','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(17608,'18042','S','Glendon','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(3492,'01843','S','S Lawrence','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.692019,-71.164643,0,'2013-07-06 12:44:30',NULL,NULL),(47374,'54625','S','Dodge','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.247140,-91.491184,0,'2013-07-06 12:44:32',NULL,NULL),(61288,'72403','P','Jonesboro','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.869765,-90.640487,0,'2013-07-06 12:44:33',NULL,NULL),(54150,'62568','S','Langleyville','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(33961,'38105','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.150666,-90.031667,0,'2013-07-06 12:44:32',NULL,NULL),(39766,'45119','P','Feesburg','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.877676,-83.997020,0,'2013-07-06 12:44:32',NULL,NULL),(8304,'08028','S','Aura','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.694694,-75.121217,0,'2013-07-06 12:44:30',NULL,NULL),(62919,'75077','S','Lewisville','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.047969,-96.994857,0,'2013-07-06 12:44:33',NULL,NULL),(45494,'51355','S','Okoboji','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.379236,-95.163787,0,'2013-07-06 12:44:32',NULL,NULL),(48404,'55592','P','Maple Plain','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.991775,-93.711712,0,'2013-07-06 12:44:33',NULL,NULL),(42063,'47448','S','Trevlac','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(76293,'95436','S','Forestville','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.490900,-122.904120,0,'2013-07-06 12:44:34',NULL,NULL),(59735,'71119','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.476576,-93.879452,0,'2013-07-06 12:44:33',NULL,NULL),(5408,'04660','S','Otter Creek','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.315723,-68.366705,0,'2013-07-06 12:44:30',NULL,NULL),(41347,'46788','S','Spencerville','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.252712,-84.942553,0,'2013-07-06 12:44:32',NULL,NULL),(77358,'96738','S','Waikoloa','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.826945,-155.834020,0,'2013-07-06 12:44:34',NULL,NULL),(74105,'92222','P','Bard','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.795556,-114.531521,0,'2013-07-06 12:44:34',NULL,NULL),(68396,'81152','S','San Francisco','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(66294,'78584','S','Roma','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.378999,-98.814980,0,'2013-07-06 12:44:34',NULL,NULL),(32799,'36429','P','Brooklyn','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.494980,-86.912259,0,'2013-07-06 12:44:32',NULL,NULL),(4410,'03224','S','Canterbury','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.339167,-71.562374,0,'2013-07-06 12:44:30',NULL,NULL),(47288,'54542','S','Tipler','A','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.840000,-88.660000,0,'2013-07-06 12:44:32',NULL,NULL),(25025,'27889','S','Washington','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.549639,-77.039376,0,'2013-07-06 12:44:31',NULL,NULL),(71557,'87196','P','Univ of New Mexico','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.082837,-106.619087,0,'2013-07-06 12:44:34',NULL,NULL),(8481,'08092','S','Staffordville','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.653280,-74.280720,0,'2013-07-06 12:44:30',NULL,NULL),(43276,'48331','S','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505080,-83.408580,0,'2013-07-06 12:44:32',NULL,NULL),(79732,'99216','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.664576,-117.214772,0,'2013-07-06 12:44:34',NULL,NULL),(65528,'77801','S','Benchley','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(57640,'67152','S','Wellington','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.269025,-97.394271,0,'2013-07-06 12:44:33',NULL,NULL),(52201,'60477','S','Orland Hills','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.567400,-87.792660,0,'2013-07-06 12:44:33',NULL,NULL),(29014,'32226','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.466832,-81.547848,0,'2013-07-06 12:44:32',NULL,NULL),(13529,'13820','S','North Franklin','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.481020,-75.070440,0,'2013-07-06 12:44:31',NULL,NULL),(76009,'95120','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.218511,-121.857173,0,'2013-07-06 12:44:34',NULL,NULL),(75139,'93560','S','Tropico Village','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.863793,-118.257708,0,'2013-07-06 12:44:34',NULL,NULL),(69727,'84041','S','Layton','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.059983,-112.008085,0,'2013-07-06 12:44:34',NULL,NULL),(69651,'84010','S','W Bountiful','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.871662,-111.890486,0,'2013-07-06 12:44:34',NULL,NULL),(30053,'33146','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(37996,'42754','S','Leitchfield','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.476274,-86.296962,0,'2013-07-06 12:44:32',NULL,NULL),(12636,'13102','P','McLean','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.554414,-76.293544,0,'2013-07-06 12:44:30',NULL,NULL),(40674,'46057','S','Michigantown','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.327309,-86.424171,0,'2013-07-06 12:44:32',NULL,NULL),(28439,'31405','S','Garden Cty','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.043073,-81.132144,0,'2013-07-06 12:44:32',NULL,NULL),(28593,'31641','S','Naylor','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.044144,-83.075482,0,'2013-07-06 12:44:32',NULL,NULL),(60942,'72099','U','Little Rock AFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(60632,'71901','S','Mountain Valley','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(53515,'62024','S','East Alton','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.856649,-90.050801,0,'2013-07-06 12:44:33',NULL,NULL),(68044,'80930','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.830904,-104.513630,0,'2013-07-06 12:44:34',NULL,NULL),(63710,'75904','S','Lufkin','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.282943,-94.807267,0,'2013-07-06 12:44:34',NULL,NULL),(49796,'57117','P','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.548465,-96.724916,0,'2013-07-06 12:44:33',NULL,NULL),(27187,'29851','S','Mixville','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.518108,-81.820849,0,'2013-07-06 12:44:31',NULL,NULL),(20218,'20771','U','Greenbelt','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008275,-76.865678,0,'2013-07-06 12:44:31',NULL,NULL),(4591,'03582','S','Northumberland','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.600195,-71.510658,0,'2013-07-06 12:44:30',NULL,NULL),(47173,'54479','S','Spencer','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.756325,-90.297794,0,'2013-07-06 12:44:32',NULL,NULL),(12820,'13303','S','Ava','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.306203,-75.435640,0,'2013-07-06 12:44:30',NULL,NULL),(6699,'06060','S','North Granby','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',42.010228,-72.840536,0,'2013-07-06 12:44:30',NULL,NULL),(77694,'97041','S','Mount Hood-Parkdale','N','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(54575,'62897','S','Whittington','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.107866,-88.875437,0,'2013-07-06 12:44:33',NULL,NULL),(37963,'42721','S','Steff','N','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.426977,-86.486700,0,'2013-07-06 12:44:32',NULL,NULL),(5128,'04408','S','Great Pond','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.923680,-68.335427,0,'2013-07-06 12:44:30',NULL,NULL),(14479,'15129','S','South Park','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.296259,-79.999358,0,'2013-07-06 12:44:31',NULL,NULL),(7739,'07208','S','Elizabeth','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.674420,-74.225148,0,'2013-07-06 12:44:30',NULL,NULL),(46199,'52753','S','Le Claire','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.606862,-90.370939,0,'2013-07-06 12:44:32',NULL,NULL),(38630,'43920','S','East Liverpool','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.671120,-80.583060,0,'2013-07-06 12:44:32',NULL,NULL),(77529,'96848','U','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.321456,-157.813409,0,'2013-07-06 12:44:34',NULL,NULL),(28906,'32136','S','Beverly Beach','A','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.449219,-81.119771,0,'2013-07-06 12:44:32',NULL,NULL),(80016,'99679','P','Tuluksak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.108431,-160.949411,0,'2013-07-06 12:44:34',NULL,NULL),(31707,'34952','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.298140,-80.296740,0,'2013-07-06 12:44:32',NULL,NULL),(23021,'24830','S','Filbert','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.318056,-81.544167,0,'2013-07-06 12:44:31',NULL,NULL),(63160,'75392','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768860,-96.824914,0,'2013-07-06 12:44:33',NULL,NULL),(75593,'94297','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.552997,-121.497372,0,'2013-07-06 12:44:34',NULL,NULL),(75406,'94018','P','El Granada','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.505155,-122.470995,0,'2013-07-06 12:44:34',NULL,NULL),(62723,'74801','S','Shawnee','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.309893,-96.920802,0,'2013-07-06 12:44:33',NULL,NULL),(57294,'66618','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.135789,-95.731085,0,'2013-07-06 12:44:33',NULL,NULL),(18700,'19193','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955683,-75.184056,0,'2013-07-06 12:44:31',NULL,NULL),(48723,'55955','S','Mantorville','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.066240,-92.759736,0,'2013-07-06 12:44:33',NULL,NULL),(46943,'54165','S','Hofa Park','N','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.500193,-88.301344,0,'2013-07-06 12:44:32',NULL,NULL),(41927,'47383','S','Smithfield','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.185979,-85.275224,0,'2013-07-06 12:44:32',NULL,NULL),(39773,'45121','S','Clermont County','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(61548,'72702','P','Fayetteville','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.063066,-94.162463,0,'2013-07-06 12:44:33',NULL,NULL),(58946,'69358','S','Henry','A','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.962994,-103.926289,0,'2013-07-06 12:44:33',NULL,NULL),(67933,'80909','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.852846,-104.761164,0,'2013-07-06 12:44:34',NULL,NULL),(58393,'68623','S','Belgrade','D','Boone','31011','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.440895,-98.115067,0,'2013-07-06 12:44:33',NULL,NULL),(41551,'47017','S','Cross Plains','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.946441,-85.221148,0,'2013-07-06 12:44:32',NULL,NULL),(8962,'08809','S','Clinton','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.652510,-74.926901,0,'2013-07-06 12:44:30',NULL,NULL),(32079,'35288','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463112,-86.769414,0,'2013-07-06 12:44:32',NULL,NULL),(18166,'18911','P','Blooming Glen','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.374610,-75.254906,0,'2013-07-06 12:44:31',NULL,NULL),(19305,'20005','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905386,-77.030988,0,'2013-07-06 12:44:31',NULL,NULL),(19401,'20074','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914711,-76.995922,0,'2013-07-06 12:44:31',NULL,NULL),(79784,'99345','P','Paterson','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.023614,-119.778013,0,'2013-07-06 12:44:34',NULL,NULL),(79697,'99206','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.651979,-117.275650,0,'2013-07-06 12:44:34',NULL,NULL),(67592,'80419','U','Jefferson County','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.742698,-105.216726,0,'2013-07-06 12:44:34',NULL,NULL),(62739,'74831','S','Rosedale','A','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.873693,-97.047649,0,'2013-07-06 12:44:33',NULL,NULL),(74762,'93101','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.420375,-119.708337,0,'2013-07-06 12:44:34',NULL,NULL),(54980,'63124','S','Clayton','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.642678,-90.378302,0,'2013-07-06 12:44:33',NULL,NULL),(56685,'65646','S','Everton','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.357835,-93.711731,0,'2013-07-06 12:44:33',NULL,NULL),(57940,'67739','S','Herndon','D','Rawlins','20153','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.891480,-100.827986,0,'2013-07-06 12:44:33',NULL,NULL),(55402,'63640','S','Libertyville','N','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.780722,-90.421005,0,'2013-07-06 12:44:33',NULL,NULL),(53530,'62031','S','Rosedale','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.101331,-90.556238,0,'2013-07-06 12:44:33',NULL,NULL),(25490,'28360','S','Lumberton','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.618316,-79.008979,0,'2013-07-06 12:44:31',NULL,NULL),(31815,'35057','S','Cullman','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.213486,-86.865502,0,'2013-07-06 12:44:32',NULL,NULL),(40143,'45344','S','New Carlisle','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.939675,-84.014989,0,'2013-07-06 12:44:32',NULL,NULL),(40829,'46211','U','Time Life Inc','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892914,-86.257085,0,'2013-07-06 12:44:32',NULL,NULL),(3139,'01253','S','Cold Spring','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.192300,-73.068480,0,'2013-07-06 12:44:30',NULL,NULL),(64996,'77289','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.606322,-95.128467,0,'2013-07-06 12:44:34',NULL,NULL),(56894,'66042','S','Lane','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.439184,-95.085753,0,'2013-07-06 12:44:33',NULL,NULL),(76787,'95943','S','Ordbend','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.593700,-122.052780,0,'2013-07-06 12:44:34',NULL,NULL),(70276,'84528','S','Lawrence','N','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.315600,-110.980680,0,'2013-07-06 12:44:34',NULL,NULL),(58128,'68135','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.207735,-96.175838,0,'2013-07-06 12:44:33',NULL,NULL),(31243,'33974','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.554897,-81.626174,0,'2013-07-06 12:44:32',NULL,NULL),(4577,'03575','P','Bretton Woods','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.258425,-71.440405,0,'2013-07-06 12:44:30',NULL,NULL),(10709,'11235','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.582828,-73.951811,0,'2013-07-06 12:44:30',NULL,NULL),(53028,'61473','S','Roseville','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.667778,-90.654722,0,'2013-07-06 12:44:33',NULL,NULL),(56422,'65259','S','Darksville','N','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.435709,-92.545665,0,'2013-07-06 12:44:33',NULL,NULL),(46735,'53901','S','Portage','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.544357,-89.473269,0,'2013-07-06 12:44:32',NULL,NULL),(67497,'80234','S','Federal Heights','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(64597,'76679','S','Silver City','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.949322,-96.573146,0,'2013-07-06 12:44:34',NULL,NULL),(3507,'01864','S','N Reading','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.578246,-71.093981,0,'2013-07-06 12:44:30',NULL,NULL),(39607,'44878','S','Adairo','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.935120,-82.507980,0,'2013-07-06 12:44:32',NULL,NULL),(74227,'92317','P','Blue Jay','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.274933,-117.204147,0,'2013-07-06 12:44:34',NULL,NULL),(4150,'02763','S','North Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.970895,-71.304600,0,'2013-07-06 12:44:30',NULL,NULL),(30231,'33189','S','Perrine','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.568606,-80.342890,0,'2013-07-06 12:44:32',NULL,NULL),(155,'00617','S','Urb Ortega','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(19293,'19973','S','Blades','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.638740,-75.610980,0,'2013-07-06 12:44:31',NULL,NULL),(18963,'19512','S','Morysville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(44613,'50057','S','Columbia','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.182401,-93.157392,0,'2013-07-06 12:44:32',NULL,NULL),(49350,'56572','S','Pel Rapids','A','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.618320,-96.072900,0,'2013-07-06 12:44:33',NULL,NULL),(77055,'96117','S','Litchfield','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.383618,-120.268598,0,'2013-07-06 12:44:34',NULL,NULL),(6772,'06098','S','Winchestr Ctr','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.921164,-73.067666,0,'2013-07-06 12:44:30',NULL,NULL),(59251,'70442','S','Husser','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.594823,-90.337836,0,'2013-07-06 12:44:33',NULL,NULL),(37040,'41263','S','Tutor Key','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.857529,-82.737476,0,'2013-07-06 12:44:32',NULL,NULL),(36132,'40224','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.226983,-85.574524,0,'2013-07-06 12:44:32',NULL,NULL),(42292,'47591','S','Fritchton','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.680278,-87.423056,0,'2013-07-06 12:44:32',NULL,NULL),(6456,'05760','S','Chipmans Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.785111,-73.276135,0,'2013-07-06 12:44:30',NULL,NULL),(78886,'98358','S','Fort Flagler','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(71039,'85742','S','Oro Valley','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.419441,-111.059263,0,'2013-07-06 12:44:34',NULL,NULL),(25829,'28617','S','Crumpler','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.460860,-81.413640,0,'2013-07-06 12:44:31',NULL,NULL),(23222,'25083','S','Burnwell','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(17383,'17887','P','White Deer','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.077886,-76.875075,0,'2013-07-06 12:44:31',NULL,NULL),(70840,'85536','P','Fort Thomas','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.994692,-109.974738,0,'2013-07-06 12:44:34',NULL,NULL),(71792,'87560','S','Sena','A','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(61404,'72550','S','Locust Grove','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.722685,-91.763142,0,'2013-07-06 12:44:33',NULL,NULL),(3734,'02156','P','Medford','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.424333,-71.132274,0,'2013-07-06 12:44:30',NULL,NULL),(12731,'13160','S','Farleys Point','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.842257,-76.688186,0,'2013-07-06 12:44:30',NULL,NULL),(59653,'71047','S','Springridge','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.316074,-93.893584,0,'2013-07-06 12:44:33',NULL,NULL),(57521,'67001','S','Andale','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.787230,-97.633073,0,'2013-07-06 12:44:33',NULL,NULL),(56061,'64744','S','El Dorado Springs','D','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.871840,-94.022563,0,'2013-07-06 12:44:33',NULL,NULL),(924,'00714','S','Parq De Guasimas','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(830,'00693','S','Villa Real','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(54942,'63114','S','Overland','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(52006,'60170','P','Plato Center','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.036740,-88.287579,0,'2013-07-06 12:44:33',NULL,NULL),(23519,'25560','S','Scott Depot','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.453925,-81.902930,0,'2013-07-06 12:44:31',NULL,NULL),(19303,'20003','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880908,-76.994494,0,'2013-07-06 12:44:31',NULL,NULL),(32621,'36141','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386911,-86.148084,0,'2013-07-06 12:44:32',NULL,NULL),(3495,'01845','S','N Andover','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.686182,-71.105718,0,'2013-07-06 12:44:30',NULL,NULL),(46983,'54228','S','Mishicot','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.264424,-87.649973,0,'2013-07-06 12:44:32',NULL,NULL),(63948,'76086','S','Weatherford','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.787926,-97.817546,0,'2013-07-06 12:44:34',NULL,NULL),(6754,'06088','S','East Windsor','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.902833,-72.596403,0,'2013-07-06 12:44:30',NULL,NULL),(8547,'08204','S','Cape May','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(10272,'10510','S','Briarcliff Manor','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.145661,-73.833747,0,'2013-07-06 12:44:30',NULL,NULL),(5913,'05250','S','Arlington Center','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(70561,'85045','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.303621,-112.114190,0,'2013-07-06 12:44:34',NULL,NULL),(59640,'71038','S','Oaks','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(54008,'62448','S','Newton','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.988361,-88.163646,0,'2013-07-06 12:44:33',NULL,NULL),(21258,'22304','S','Cameron Station','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.817208,-77.122599,0,'2013-07-06 12:44:31',NULL,NULL),(1565,'00766','S','Villa Laura','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(69623,'83871','S','Troy','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.740363,-116.768003,0,'2013-07-06 12:44:34',NULL,NULL),(27291,'30005','S','Johns Creek','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.080610,-84.200785,0,'2013-07-06 12:44:31',NULL,NULL),(23396,'25315','S','Marmet','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.235874,-81.555983,0,'2013-07-06 12:44:31',NULL,NULL),(36914,'41143','S','Fultz','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.329825,-82.936538,0,'2013-07-06 12:44:32',NULL,NULL),(37566,'42071','S','University','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(23655,'25813','S','Blue Jay','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.772983,-81.102442,0,'2013-07-06 12:44:31',NULL,NULL),(47575,'54846','S','High Bridge','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.381203,-90.737197,0,'2013-07-06 12:44:33',NULL,NULL),(64518,'76636','S','Covington','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.159516,-97.250808,0,'2013-07-06 12:44:34',NULL,NULL),(32468,'36034','S','Glenwood','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.666194,-86.166870,0,'2013-07-06 12:44:32',NULL,NULL),(73488,'91325','S','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.239807,-118.516396,0,'2013-07-06 12:44:34',NULL,NULL),(57393,'66756','S','Curranville','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.549625,-94.679242,0,'2013-07-06 12:44:33',NULL,NULL),(27240,'29923','P','Gifford','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.861290,-81.239714,0,'2013-07-06 12:44:31',NULL,NULL),(8668,'08322','S','Franklinville','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.629479,-75.046477,0,'2013-07-06 12:44:30',NULL,NULL),(28927,'32163','S','The Villages','D','Sumter','12119','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.933053,-81.948296,0,'2013-07-06 12:44:32',NULL,NULL),(9413,'10001','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(73135,'90274','S','Pls Vrds Pnsl','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(61578,'72740','S','Huntsville','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.085667,-93.734435,0,'2013-07-06 12:44:33',NULL,NULL),(21031,'21866','P','Tylerton','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',37.969447,-76.008360,0,'2013-07-06 12:44:31',NULL,NULL),(22907,'24603','S','Big Rock','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.352222,-82.211944,0,'2013-07-06 12:44:31',NULL,NULL),(15355,'16245','P','Oak Ridge','D','Armstrong','42005','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.009961,-79.298811,0,'2013-07-06 12:44:31',NULL,NULL),(24677,'27410','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(37088,'41339','S','Guage','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(14902,'15520','P','Acosta','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.110851,-79.071739,0,'2013-07-06 12:44:31',NULL,NULL),(20056,'20662','S','Nanjemoy','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.412003,-77.188680,0,'2013-07-06 12:44:31',NULL,NULL),(30259,'33233','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.732156,-80.241534,0,'2013-07-06 12:44:32',NULL,NULL),(4358,'03055','S','Milford','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.829892,-71.659493,0,'2013-07-06 12:44:30',NULL,NULL),(8919,'08742','S','Point Pleasant Boro','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(6494,'05776','S','West Rupert','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.265530,-73.191885,0,'2013-07-06 12:44:30',NULL,NULL),(5048,'04267','P','North Waterford','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.207261,-70.716893,0,'2013-07-06 12:44:30',NULL,NULL),(5574,'04901','S','Waterville','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.554203,-69.630648,0,'2013-07-06 12:44:30',NULL,NULL),(17267,'17843','S','Beaver Sprgs','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.761720,-77.256740,0,'2013-07-06 12:44:31',NULL,NULL),(25514,'28385','S','Salemburg','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.016623,-78.504209,0,'2013-07-06 12:44:31',NULL,NULL),(76329,'95462','S','Monte Rio','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.469285,-123.012010,0,'2013-07-06 12:44:34',NULL,NULL),(71476,'87063','S','Progresso','N','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.449626,-106.011354,0,'2013-07-06 12:44:34',NULL,NULL),(70771,'85340','S','Litchfield','N','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.497954,-112.376641,0,'2013-07-06 12:44:34',NULL,NULL),(5830,'05079','S','Vershire','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.922222,-72.317222,0,'2013-07-06 12:44:30',NULL,NULL),(36758,'41041','S','Blue Bank','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(23502,'25526','S','Hurricane','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.435356,-82.002155,0,'2013-07-06 12:44:31',NULL,NULL),(64519,'76637','S','Cranfills Gap','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.782870,-97.766797,0,'2013-07-06 12:44:34',NULL,NULL),(23258,'25125','S','Lizemores','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.337121,-81.164391,0,'2013-07-06 12:44:31',NULL,NULL),(68020,'80925','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739647,-104.635922,0,'2013-07-06 12:44:34',NULL,NULL),(11773,'12203','S','Stuyvsnt Plz','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(12123,'12601','S','Poughkeepsie','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.701664,-73.916805,0,'2013-07-06 12:44:30',NULL,NULL),(2571,'00959','S','Villa Betania','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(16234,'17076','S','Oakland Mills','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.608663,-77.316236,0,'2013-07-06 12:44:31',NULL,NULL),(43944,'49288','S','Waldron','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.731548,-84.438560,0,'2013-07-06 12:44:32',NULL,NULL),(46010,'52536','S','Munterville','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.960626,-92.635668,0,'2013-07-06 12:44:32',NULL,NULL),(46571,'53523','S','Cambridge','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.978962,-89.047633,0,'2013-07-06 12:44:32',NULL,NULL),(63581,'75780','P','New Summerfield','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.985670,-95.107132,0,'2013-07-06 12:44:34',NULL,NULL),(49727,'57045','S','Menno','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.237787,-97.576619,0,'2013-07-06 12:44:33',NULL,NULL),(19550,'20197','S','Waterford','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.192941,-77.633945,0,'2013-07-06 12:44:31',NULL,NULL),(27085,'29707','S','Indian Land','A','Lancaster','45057','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006139,-80.947219,0,'2013-07-06 12:44:31',NULL,NULL),(24322,'27020','S','Winders Cross Roads','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(20604,'21206','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341591,-76.530778,0,'2013-07-06 12:44:31',NULL,NULL),(23938,'26261','S','Richwood','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.225157,-80.539470,0,'2013-07-06 12:44:31',NULL,NULL),(25943,'28656','U','N Wilkesboro','A','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.203290,-81.076593,0,'2013-07-06 12:44:31',NULL,NULL),(61763,'73054','S','Luther','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.654937,-97.194078,0,'2013-07-06 12:44:33',NULL,NULL),(49559,'56713','S','Argyle','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.332402,-96.821678,0,'2013-07-06 12:44:33',NULL,NULL),(29559,'32810','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.618210,-81.442060,0,'2013-07-06 12:44:32',NULL,NULL),(17137,'17778','S','Westport','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.309029,-77.972308,0,'2013-07-06 12:44:31',NULL,NULL),(75097,'93536','S','Quartz Hill','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(1027,'00718','S','Urb Santo Tomas','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(20225,'20774','S','Kettering','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(33000,'36641','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.682699,-88.068789,0,'2013-07-06 12:44:32',NULL,NULL),(15333,'16221','P','Curllsville','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.220370,-79.505296,0,'2013-07-06 12:44:31',NULL,NULL),(79785,'99346','P','Plymouth','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.016325,-119.584600,0,'2013-07-06 12:44:34',NULL,NULL),(79368,'98651','S','Underwood','D','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.734159,-121.543123,0,'2013-07-06 12:44:34',NULL,NULL),(77860,'97230','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.541400,-122.498239,0,'2013-07-06 12:44:34',NULL,NULL),(53178,'61604','S','Bellview','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(14212,'14783','P','Steamburg','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.106997,-78.904621,0,'2013-07-06 12:44:31',NULL,NULL),(38632,'43925','P','East Springfield','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.451367,-80.858749,0,'2013-07-06 12:44:32',NULL,NULL),(75414,'94024','S','Los Altos','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.353924,-122.085935,0,'2013-07-06 12:44:34',NULL,NULL),(70041,'84134','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.774204,-111.946340,0,'2013-07-06 12:44:34',NULL,NULL),(53283,'61727','S','Birkbeck','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(14784,'15357','S','Rices Landing','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.948975,-79.995111,0,'2013-07-06 12:44:31',NULL,NULL),(65229,'77448','S','Hungerford','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.310181,-96.097046,0,'2013-07-06 12:44:34',NULL,NULL),(63007,'75159','S','Seagoville','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.649678,-96.563503,0,'2013-07-06 12:44:33',NULL,NULL),(21604,'22853','S','Timberville','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.628588,-78.776507,0,'2013-07-06 12:44:31',NULL,NULL),(4560,'03462','S','Spofford','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.905544,-72.403189,0,'2013-07-06 12:44:30',NULL,NULL),(19757,'20414','U','Hud Fed Natl Mortgage','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.881612,-77.024982,0,'2013-07-06 12:44:31',NULL,NULL),(27168,'29839','P','Montmorenci','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.506280,-81.600469,0,'2013-07-06 12:44:31',NULL,NULL),(36866,'41092','S','Verona','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.825633,-84.678381,0,'2013-07-06 12:44:32',NULL,NULL),(44771,'50210','S','Liberty','N','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.205240,-93.670620,0,'2013-07-06 12:44:32',NULL,NULL),(24635,'27371','S','Lovejoy','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(76713,'95842','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.692841,-121.345044,0,'2013-07-06 12:44:34',NULL,NULL),(74133,'92242','S','Earp','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.153020,-114.377820,0,'2013-07-06 12:44:34',NULL,NULL),(72803,'89712','U','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.163703,-119.764433,0,'2013-07-06 12:44:34',NULL,NULL),(20505,'21075','S','Elkridge','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.201493,-76.752641,0,'2013-07-06 12:44:31',NULL,NULL),(32475,'36040','S','Hayneville','D','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.205480,-86.660220,0,'2013-07-06 12:44:32',NULL,NULL),(45850,'52231','S','Harper','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.377556,-92.025480,0,'2013-07-06 12:44:32',NULL,NULL),(25995,'28670','S','Dimmette','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.236340,-80.926620,0,'2013-07-06 12:44:31',NULL,NULL),(9514,'10017','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(13478,'13790','S','Westover','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.120267,-75.972895,0,'2013-07-06 12:44:31',NULL,NULL),(11588,'12077','S','Glenmont','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.596487,-73.794423,0,'2013-07-06 12:44:30',NULL,NULL),(22632,'24245','S','Dungannon','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.828482,-82.534767,0,'2013-07-06 12:44:31',NULL,NULL),(30828,'33623','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.954131,-82.458719,0,'2013-07-06 12:44:32',NULL,NULL),(10420,'10708','S','Bronxville','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.940639,-73.822578,0,'2013-07-06 12:44:30',NULL,NULL),(37856,'42502','P','Somerset','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.095864,-84.603694,0,'2013-07-06 12:44:32',NULL,NULL),(47405,'54648','S','Norwalk','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.822777,-90.660681,0,'2013-07-06 12:44:32',NULL,NULL),(23509,'25540','S','Midkiff','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.140519,-82.139439,0,'2013-07-06 12:44:31',NULL,NULL),(62162,'73735','S','Drummond','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.302135,-98.037900,0,'2013-07-06 12:44:33',NULL,NULL),(53542,'62036','S','Golden Eagle','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.890847,-90.569074,0,'2013-07-06 12:44:33',NULL,NULL),(54768,'62990','S','Thebes','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.189836,-89.393166,0,'2013-07-06 12:44:33',NULL,NULL),(11837,'12245','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.671218,-73.772898,0,'2013-07-06 12:44:30',NULL,NULL),(79296,'98585','S','Harmony','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.535252,-122.576294,0,'2013-07-06 12:44:34',NULL,NULL),(57086,'66217','S','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(27951,'30541','S','Epworth','D','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.904691,-84.495403,0,'2013-07-06 12:44:31',NULL,NULL),(24250,'26802','S','Brandywine','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.640625,-79.198583,0,'2013-07-06 12:44:31',NULL,NULL),(36759,'41041','S','Craintown','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(22441,'24018','S','Roanoke','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.226453,-80.026824,0,'2013-07-06 12:44:31',NULL,NULL),(20709,'21273','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.287419,-76.611265,0,'2013-07-06 12:44:31',NULL,NULL),(58004,'67865','S','Bloom','A','Clark','20025','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.421160,-99.917040,0,'2013-07-06 12:44:33',NULL,NULL),(35441,'39477','P','Sandersville','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.787509,-89.038271,0,'2013-07-06 12:44:32',NULL,NULL),(37577,'42085','S','Water Valley','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.573343,-88.767218,0,'2013-07-06 12:44:32',NULL,NULL),(59391,'70615','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.232902,-93.163514,0,'2013-07-06 12:44:33',NULL,NULL),(52438,'60659','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.986370,-87.701160,0,'2013-07-06 12:44:33',NULL,NULL),(52081,'60402','S','Stickney','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.838828,-87.791023,0,'2013-07-06 12:44:33',NULL,NULL),(36094,'40219','S','Okolona','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(42999,'48160','S','Milan','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(3366,'01581','S','Westborough','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.266610,-71.617194,0,'2013-07-06 12:44:30',NULL,NULL),(6648,'06018','S','No Canaan','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.009780,-73.298160,0,'2013-07-06 12:44:30',NULL,NULL),(26247,'28904','S','Hayesville','D','Clay','37043','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.025287,-83.810433,0,'2013-07-06 12:44:31',NULL,NULL),(11653,'12133','P','Hoosick Junction','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.924518,-73.345704,0,'2013-07-06 12:44:30',NULL,NULL),(17340,'17867','S','Greenbrier','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.712710,-76.735861,0,'2013-07-06 12:44:31',NULL,NULL),(8377,'08055','S','Medford','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862774,-74.815854,0,'2013-07-06 12:44:30',NULL,NULL),(12543,'13040','S','E Freetown','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.562547,-75.928525,0,'2013-07-06 12:44:30',NULL,NULL),(65497,'77661','P','Figridge','N','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.788782,-94.382618,0,'2013-07-06 12:44:34',NULL,NULL),(30980,'33747','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.772495,-82.679889,0,'2013-07-06 12:44:32',NULL,NULL),(563,'00678','S','Parq del Retiro','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(44672,'50116','S','Marysville','N','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.176154,-92.929975,0,'2013-07-06 12:44:32',NULL,NULL),(21807,'23091','S','Little Plymouth','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.667329,-76.806604,0,'2013-07-06 12:44:31',NULL,NULL),(9546,'10022','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(54435,'62840','P','Frankfort Heights','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.900295,-88.840796,0,'2013-07-06 12:44:33',NULL,NULL),(53618,'62088','S','Staunton','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.011425,-89.787070,0,'2013-07-06 12:44:33',NULL,NULL),(29170,'32355','P','Saint Marks','D','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.162617,-84.207166,0,'2013-07-06 12:44:32',NULL,NULL),(23733,'25917','S','Kingston','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.969510,-81.158866,0,'2013-07-06 12:44:31',NULL,NULL),(35317,'39423','S','Carmichael','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.129500,-88.904640,0,'2013-07-06 12:44:32',NULL,NULL),(76914,'96001','S','Keswick','N','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.564869,-122.421215,0,'2013-07-06 12:44:34',NULL,NULL),(12840,'13315','S','Burlngtn Flt','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.753480,-75.169620,0,'2013-07-06 12:44:30',NULL,NULL),(5926,'05252','S','Kansas','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.057869,-73.137659,0,'2013-07-06 12:44:30',NULL,NULL),(1107,'00725','S','Urb San Antonio','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(26125,'28734','S','Burningtown','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(31699,'34948','P','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.447204,-80.344071,0,'2013-07-06 12:44:32',NULL,NULL),(73652,'91499','U','Van Nuys Brm','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201899,-118.454395,0,'2013-07-06 12:44:34',NULL,NULL),(70606,'85118','S','Superstition Mountain','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(52996,'61447','S','Tompkins','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.868978,-90.754051,0,'2013-07-06 12:44:33',NULL,NULL),(19279,'19966','S','Millsboro','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.604960,-75.223260,0,'2013-07-06 12:44:31',NULL,NULL),(60739,'71965','S','Pencil Bluff','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.652412,-93.747235,0,'2013-07-06 12:44:33',NULL,NULL),(43214,'48307','S','Rochester Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657341,-83.123033,0,'2013-07-06 12:44:32',NULL,NULL),(77815,'97147','P','Wheeler','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.689851,-123.883901,0,'2013-07-06 12:44:34',NULL,NULL),(67662,'80482','P','Winter Park','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.938856,-105.795816,0,'2013-07-06 12:44:34',NULL,NULL),(37887,'42602','S','Highway','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(16884,'17573','U','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.028850,-76.167332,0,'2013-07-06 12:44:31',NULL,NULL),(23079,'24892','S','Yukon','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.304104,-81.680662,0,'2013-07-06 12:44:31',NULL,NULL),(27579,'30273','S','Rex','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.577477,-84.276017,0,'2013-07-06 12:44:31',NULL,NULL),(33491,'37349','P','Manchester','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.467600,-86.083325,0,'2013-07-06 12:44:32',NULL,NULL),(15920,'17019','S','Clear Spring','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.098851,-77.022403,0,'2013-07-06 12:44:31',NULL,NULL),(77668,'97028','S','Government Camp','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.306268,-121.746016,0,'2013-07-06 12:44:34',NULL,NULL),(73265,'90720','S','Los Alamitos','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.795614,-118.064756,0,'2013-07-06 12:44:34',NULL,NULL),(70298,'84536','P','Monument Valley','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.154424,-110.741712,0,'2013-07-06 12:44:34',NULL,NULL),(69347,'83540','S','Sweetwater','N','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.404644,-116.807243,0,'2013-07-06 12:44:34',NULL,NULL),(64988,'77277','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.716725,-95.428140,0,'2013-07-06 12:44:34',NULL,NULL),(58547,'68815','S','Vinton','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.524360,-99.039205,0,'2013-07-06 12:44:33',NULL,NULL),(39223,'44412','S','Diamond','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.095854,-81.042337,0,'2013-07-06 12:44:32',NULL,NULL),(11957,'12453','P','Malden','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.094637,-73.933788,0,'2013-07-06 12:44:30',NULL,NULL),(77177,'96284','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76937,'96022','S','Cottonwood','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.324554,-122.350355,0,'2013-07-06 12:44:34',NULL,NULL),(73964,'92068','P','San Luis Rey','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.276757,-117.272701,0,'2013-07-06 12:44:34',NULL,NULL),(64674,'76825','S','Calf Creek','N','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.390710,-99.384310,0,'2013-07-06 12:44:34',NULL,NULL),(57469,'66862','S','Matfield Green','D','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.143372,-96.497559,0,'2013-07-06 12:44:33',NULL,NULL),(46744,'53922','S','Burnett','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.524713,-88.701534,0,'2013-07-06 12:44:32',NULL,NULL),(14082,'14613','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.177983,-77.634610,0,'2013-07-06 12:44:31',NULL,NULL),(79772,'99335','P','Kahlotus','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.680849,-118.541896,0,'2013-07-06 12:44:34',NULL,NULL),(77305,'96672','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60660,'71920','S','Alpine','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.264722,-93.460833,0,'2013-07-06 12:44:33',NULL,NULL),(59289,'70470','P','Mandeville','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.388185,-90.081310,0,'2013-07-06 12:44:33',NULL,NULL),(2228,'00926','S','Urb El Pilar','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(72314,'88905','U','The Lakes','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.143477,-115.279371,0,'2013-07-06 12:44:34',NULL,NULL),(71767,'87553','S','Penasco','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.172500,-105.745200,0,'2013-07-06 12:44:34',NULL,NULL),(69083,'83251','S','Mackay','D','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.933380,-113.779500,0,'2013-07-06 12:44:34',NULL,NULL),(22982,'24738','P','Nemours','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.257627,-81.222882,0,'2013-07-06 12:44:31',NULL,NULL),(8222,'07963','P','Morristown','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.795474,-74.477752,0,'2013-07-06 12:44:30',NULL,NULL),(7042,'06277','S','East Thompson','N','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',41.977800,-71.847180,0,'2013-07-06 12:44:30',NULL,NULL),(36203,'40269','P','Jeffersontown','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.164595,-85.515500,0,'2013-07-06 12:44:32',NULL,NULL),(433,'00662','S','Sect Rotarios','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(69058,'83234','S','Downey','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.451890,-112.157149,0,'2013-07-06 12:44:34',NULL,NULL),(36787,'41049','S','Grange City','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.285556,-83.678852,0,'2013-07-06 12:44:32',NULL,NULL),(45184,'50613','S','Blackhawk Village','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(72205,'88416','P','Tucumcari','A','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.351226,-104.048850,0,'2013-07-06 12:44:34',NULL,NULL),(53473,'61936','P','La Place','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.802335,-88.713608,0,'2013-07-06 12:44:33',NULL,NULL),(28605,'31701','S','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.572819,-84.163287,0,'2013-07-06 12:44:32',NULL,NULL),(3486,'01835','S','Haverhill','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.754563,-71.087282,0,'2013-07-06 12:44:30',NULL,NULL),(24328,'27024','S','Lowgap','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.500159,-80.847233,0,'2013-07-06 12:44:31',NULL,NULL),(37143,'41465','S','Gifford','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(42138,'47514','S','Bandon','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.171100,-86.569380,0,'2013-07-06 12:44:32',NULL,NULL),(24324,'27022','S','Harts Store','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.513484,-80.219058,0,'2013-07-06 12:44:31',NULL,NULL),(12629,'13092','S','East Genoa','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.658980,-76.424040,0,'2013-07-06 12:44:30',NULL,NULL),(48343,'55474','U','Ameriprise Financial','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.981774,-93.263916,0,'2013-07-06 12:44:33',NULL,NULL),(80052,'99709','S','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.859117,-147.880292,0,'2013-07-06 12:44:34',NULL,NULL),(2634,'00965','S','Bo Amelia','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(23381,'25304','S','Kanawha City','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.320517,-81.591144,0,'2013-07-06 12:44:31',NULL,NULL),(46140,'52653','S','Wapello','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.179547,-91.188068,0,'2013-07-06 12:44:32',NULL,NULL),(61307,'72430','S','Greenway','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.339055,-90.222850,0,'2013-07-06 12:44:33',NULL,NULL),(10070,'10179','U','Bear Stearns','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754518,-73.976308,0,'2013-07-06 12:44:30',NULL,NULL),(76839,'95962','S','Renaissance','N','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.355889,-121.262044,0,'2013-07-06 12:44:34',NULL,NULL),(69031,'83217','S','Chesterfield','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.742325,-111.887397,0,'2013-07-06 12:44:34',NULL,NULL),(75842,'94924','S','Bolinas','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.912439,-122.704347,0,'2013-07-06 12:44:34',NULL,NULL),(12635,'13102','P','Mc Lean','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.554414,-76.293544,0,'2013-07-06 12:44:30',NULL,NULL),(5600,'04926','P','China Vlg','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.476142,-69.516388,0,'2013-07-06 12:44:30',NULL,NULL),(45425,'51060','S','Ute','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.050911,-95.707888,0,'2013-07-06 12:44:32',NULL,NULL),(9400,'09873','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(34917,'38961','S','Tillatoba','D','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.990153,-89.878680,0,'2013-07-06 12:44:32',NULL,NULL),(11282,'11772','S','N Patchogue','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(57670,'67216','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.618484,-97.317836,0,'2013-07-06 12:44:33',NULL,NULL),(32167,'35475','S','Nport','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.245390,-87.594372,0,'2013-07-06 12:44:32',NULL,NULL),(3292,'01505','S','Morningdale','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.331643,-71.734141,0,'2013-07-06 12:44:30',NULL,NULL),(11362,'11853','U','Jericho','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786573,-73.542199,0,'2013-07-06 12:44:30',NULL,NULL),(25795,'28604','S','White Rock','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(79706,'99211','P','Cty Spok Val','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.665303,-117.310120,0,'2013-07-06 12:44:34',NULL,NULL),(66965,'79404','S','Buffalo Spgs','A','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.553575,-101.821365,0,'2013-07-06 12:44:34',NULL,NULL),(66389,'78624','S','Gold','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(63363,'75640','S','Ashland','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.699271,-94.668973,0,'2013-07-06 12:44:33',NULL,NULL),(31165,'33917','S','North Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(32503,'36068','P','Prattville','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.461221,-86.444633,0,'2013-07-06 12:44:32',NULL,NULL),(28274,'31085','S','Farrar','N','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.398491,-83.659553,0,'2013-07-06 12:44:31',NULL,NULL),(36178,'40245','S','Worthington Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.264541,-85.495953,0,'2013-07-06 12:44:32',NULL,NULL),(42907,'48104','S','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.261244,-83.716523,0,'2013-07-06 12:44:32',NULL,NULL),(16399,'17220','S','Dry Run','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.179521,-77.749505,0,'2013-07-06 12:44:31',NULL,NULL),(5107,'04352','S','Mt Vernon','N','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.508660,-69.990496,0,'2013-07-06 12:44:30',NULL,NULL),(14686,'15252','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.440966,-79.998271,0,'2013-07-06 12:44:31',NULL,NULL),(7258,'06516','S','West Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.269511,-72.964339,0,'2013-07-06 12:44:30',NULL,NULL),(72607,'89413','S','Lincoln Park','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.081994,-119.937493,0,'2013-07-06 12:44:34',NULL,NULL),(30599,'33421','P','Ryl Palm Bch','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(48145,'55367','S','New Germany','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.885194,-93.968497,0,'2013-07-06 12:44:33',NULL,NULL),(80121,'99764','P','Northway','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.960000,-141.930000,0,'2013-07-06 12:44:34',NULL,NULL),(57457,'66853','S','Hamilton','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.986532,-96.199761,0,'2013-07-06 12:44:33',NULL,NULL),(57333,'66714','S','Benedict','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.635924,-95.634951,0,'2013-07-06 12:44:33',NULL,NULL),(29302,'32520','U','Gulf Power','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.455593,-87.258153,0,'2013-07-06 12:44:32',NULL,NULL),(6080,'05450','S','Berkshire Center','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(46138,'52653','S','Elrick','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.179547,-91.188068,0,'2013-07-06 12:44:32',NULL,NULL),(61779,'73068','S','Noble','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.143049,-97.366525,0,'2013-07-06 12:44:33',NULL,NULL),(27035,'29657','S','Liberty','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.788984,-82.697845,0,'2013-07-06 12:44:31',NULL,NULL),(24859,'27636','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.792686,-78.691052,0,'2013-07-06 12:44:31',NULL,NULL),(65547,'77833','S','Gay Hill','N','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.216840,-96.396420,0,'2013-07-06 12:44:34',NULL,NULL),(65504,'77663','P','Wildwood','N','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.500000,-94.400000,0,'2013-07-06 12:44:34',NULL,NULL),(64327,'76501','S','Moffatt','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(5786,'05055','S','Norwich','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.715882,-72.308168,0,'2013-07-06 12:44:30',NULL,NULL),(56491,'65335','S','Ionia','D','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.485951,-93.316570,0,'2013-07-06 12:44:33',NULL,NULL),(31653,'34742','P','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.296304,-81.352352,0,'2013-07-06 12:44:32',NULL,NULL),(47198,'54487','S','Tomahawk','D','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.474520,-89.727183,0,'2013-07-06 12:44:32',NULL,NULL),(11642,'12124','P','New Baltimore','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.444613,-73.787763,0,'2013-07-06 12:44:30',NULL,NULL),(23951,'26280','S','Mill Creek','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.727962,-80.026616,0,'2013-07-06 12:44:31',NULL,NULL),(37860,'42519','S','Alpine','N','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.970557,-84.572994,0,'2013-07-06 12:44:32',NULL,NULL),(41319,'46774','S','Meadowbrook','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(42038,'47441','S','Victoria','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(71013,'85724','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.245835,-110.944450,0,'2013-07-06 12:44:34',NULL,NULL),(67142,'79766','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.812902,-102.338633,0,'2013-07-06 12:44:34',NULL,NULL),(20148,'20732','S','Chesapeak Bch','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.658353,-76.546878,0,'2013-07-06 12:44:31',NULL,NULL),(31036,'33805','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.085598,-81.975530,0,'2013-07-06 12:44:32',NULL,NULL),(13488,'13801','S','McDonough','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.517672,-75.776919,0,'2013-07-06 12:44:31',NULL,NULL),(38713,'44017','S','Berea','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370214,-81.855911,0,'2013-07-06 12:44:32',NULL,NULL),(7372,'06770','S','Union City','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.492039,-73.048550,0,'2013-07-06 12:44:30',NULL,NULL),(41896,'47371','S','Como','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(41712,'47236','S','Grammer','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.135000,-85.813333,0,'2013-07-06 12:44:32',NULL,NULL),(39873,'45206','S','Walnut Hills','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.126559,-84.483385,0,'2013-07-06 12:44:32',NULL,NULL),(78727,'98279','S','Doebay','N','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.659198,-122.826703,0,'2013-07-06 12:44:34',NULL,NULL),(77868,'97239','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.499027,-122.688364,0,'2013-07-06 12:44:34',NULL,NULL),(68286,'81087','P','Vilas','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.389264,-102.435317,0,'2013-07-06 12:44:34',NULL,NULL),(9667,'10040','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(30104,'33158','S','Village of Palmetto Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(35488,'39522','U','Stennis Ctr','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(21514,'22718','S','Elkwood','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.460796,-77.806980,0,'2013-07-06 12:44:31',NULL,NULL),(77950,'97355','S','Lebanon','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.529419,-122.872642,0,'2013-07-06 12:44:34',NULL,NULL),(70204,'84401','S','Hooper','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(53121,'61546','S','Manito','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.421867,-89.779680,0,'2013-07-06 12:44:33',NULL,NULL),(28972,'32208','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.390755,-81.684166,0,'2013-07-06 12:44:32',NULL,NULL),(43190,'48302','S','Bloomfield Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(4029,'02568','S','Vineyard Hvn','A','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.453520,-70.589400,0,'2013-07-06 12:44:30',NULL,NULL),(8694,'08347','P','Norma','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.493778,-75.087785,0,'2013-07-06 12:44:30',NULL,NULL),(13660,'14025','S','Boston','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.626575,-78.720978,0,'2013-07-06 12:44:31',NULL,NULL),(33831,'37931','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.973270,-84.114430,0,'2013-07-06 12:44:32',NULL,NULL),(26027,'28679','S','Peoria','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273480,-81.876420,0,'2013-07-06 12:44:31',NULL,NULL),(25454,'28327','S','Whisper Pnes','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.341320,-79.362480,0,'2013-07-06 12:44:31',NULL,NULL),(23604,'25701','S','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.401892,-82.435626,0,'2013-07-06 12:44:31',NULL,NULL),(74733,'93041','S','Port Hueneme','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.161105,-119.189825,0,'2013-07-06 12:44:34',NULL,NULL),(65554,'77840','S','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.603583,-96.311081,0,'2013-07-06 12:44:34',NULL,NULL),(61068,'72125','S','Perry','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.037223,-92.794614,0,'2013-07-06 12:44:33',NULL,NULL),(22452,'24026','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.272240,-79.951117,0,'2013-07-06 12:44:31',NULL,NULL),(35912,'40022','S','Finchville','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.155235,-85.300049,0,'2013-07-06 12:44:32',NULL,NULL),(42189,'47545','P','Ireland','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.291263,-86.960857,0,'2013-07-06 12:44:32',NULL,NULL),(10697,'11222','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.727965,-73.949305,0,'2013-07-06 12:44:30',NULL,NULL),(62097,'73573','S','Waurika','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.167818,-97.995767,0,'2013-07-06 12:44:33',NULL,NULL),(59884,'71270','S','Ansley','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(59815,'71232','S','Dunn','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.453833,-91.489746,0,'2013-07-06 12:44:33',NULL,NULL),(42721,'48004','P','Anchorville','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.713705,-82.682196,0,'2013-07-06 12:44:32',NULL,NULL),(8528,'08108','S','Collingswood','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.913768,-75.065877,0,'2013-07-06 12:44:30',NULL,NULL),(17408,'17901','S','Seltzer','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(27671,'30329','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.825160,-84.319700,0,'2013-07-06 12:44:31',NULL,NULL),(2159,'00925','S','Urb Gonzalez','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(74528,'92654','P','Laguna Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.604203,-117.715359,0,'2013-07-06 12:44:34',NULL,NULL),(69416,'83631','S','Idaho City','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(17197,'17821','S','Kaseville','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(24701,'27455','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.155085,-79.814163,0,'2013-07-06 12:44:31',NULL,NULL),(70573,'85065','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.436281,-112.048927,0,'2013-07-06 12:44:34',NULL,NULL),(52781,'61270','S','Clyde','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(2888,'00987','S','Lomas de Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(30887,'33694','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.069310,-82.497203,0,'2013-07-06 12:44:32',NULL,NULL),(22802,'24473','S','Rockbrg Baths','N','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.899159,-79.396696,0,'2013-07-06 12:44:31',NULL,NULL),(69301,'83450','S','Mud Lake','N','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.859400,-112.435380,0,'2013-07-06 12:44:34',NULL,NULL),(56507,'65348','S','Otterville','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.704032,-93.003128,0,'2013-07-06 12:44:33',NULL,NULL),(50619,'58262','S','Mountain','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.673234,-97.797096,0,'2013-07-06 12:44:33',NULL,NULL),(36410,'40522','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.022218,-84.489709,0,'2013-07-06 12:44:32',NULL,NULL),(17902,'18447','S','Scott Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(71435,'87032','P','McIntosh','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.748784,-106.157511,0,'2013-07-06 12:44:34',NULL,NULL),(45454,'51239','S','Perkins','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.192568,-96.130531,0,'2013-07-06 12:44:32',NULL,NULL),(44309,'49737','P','Harbor Spgs','A','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.562761,-85.097009,0,'2013-07-06 12:44:32',NULL,NULL),(58616,'68858','S','Milton','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.958042,-99.365640,0,'2013-07-06 12:44:33',NULL,NULL),(14860,'15458','S','Mc Clellandtown','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.886898,-79.858211,0,'2013-07-06 12:44:31',NULL,NULL),(54578,'62898','S','Roaches','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.387010,-89.091555,0,'2013-07-06 12:44:33',NULL,NULL),(28574,'31622','S','Alapaha','D','Berrien','13019','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.394482,-83.198172,0,'2013-07-06 12:44:32',NULL,NULL),(34366,'38610','S','Blue Mount','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.670141,-89.019896,0,'2013-07-06 12:44:32',NULL,NULL),(62568,'74454','S','Tullahassee','A','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.847041,-95.511485,0,'2013-07-06 12:44:33',NULL,NULL),(2697,'00969','S','Chalets de Santa Clara','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(45477,'51338','S','Everly','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.158726,-95.327253,0,'2013-07-06 12:44:32',NULL,NULL),(50333,'57732','S','Pluma','N','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.275833,-103.665833,0,'2013-07-06 12:44:33',NULL,NULL),(65806,'78133','S','Canyon Lake','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.880900,-98.215200,0,'2013-07-06 12:44:34',NULL,NULL),(36821,'41063','S','Visalia','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.842260,-84.522660,0,'2013-07-06 12:44:32',NULL,NULL),(70259,'84512','P','Bluff','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.280282,-109.568737,0,'2013-07-06 12:44:34',NULL,NULL),(51473,'59535','S','Lloyd','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.043936,-109.213597,0,'2013-07-06 12:44:33',NULL,NULL),(38934,'44122','S','Warrensville Hts','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(71939,'87933','S','Derry','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.849884,-107.038618,0,'2013-07-06 12:44:34',NULL,NULL),(53914,'62375','S','Timewell','D','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.015652,-90.855642,0,'2013-07-06 12:44:33',NULL,NULL),(52816,'61283','S','Tampico','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.637702,-89.784655,0,'2013-07-06 12:44:33',NULL,NULL),(29606,'32837','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.392466,-81.417820,0,'2013-07-06 12:44:32',NULL,NULL),(2935,'01027','S','Easthampton','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.291420,-72.717720,0,'2013-07-06 12:44:30',NULL,NULL),(11955,'12451','S','Leeds','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.305672,-73.944172,0,'2013-07-06 12:44:30',NULL,NULL),(30320,'33306','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163196,-80.110875,0,'2013-07-06 12:44:32',NULL,NULL),(43398,'48444','S','Imlay City','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.055349,-83.070632,0,'2013-07-06 12:44:32',NULL,NULL),(78457,'98068','P','Snoqualmie Ps','A','Kittitas','53037','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.412300,-121.418723,0,'2013-07-06 12:44:34',NULL,NULL),(57959,'67757','S','Selden','D','Sheridan','20179','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.538463,-100.565440,0,'2013-07-06 12:44:33',NULL,NULL),(23930,'26250','S','Belington','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.026524,-79.940877,0,'2013-07-06 12:44:31',NULL,NULL),(15222,'16022','P','Bruin','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.054644,-79.729304,0,'2013-07-06 12:44:31',NULL,NULL),(7625,'07060','S','North Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.631340,-74.437020,0,'2013-07-06 12:44:30',NULL,NULL),(30567,'33414','S','Royal Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(40745,'46135','S','Morton','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(58147,'68157','S','Papillion','N','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.184654,-95.994302,0,'2013-07-06 12:44:33',NULL,NULL),(26003,'28673','S','Sherrills Frd','A','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.589500,-81.002891,0,'2013-07-06 12:44:31',NULL,NULL),(6414,'05739','S','Danby','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(20941,'21765','P','Lisbon','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.334830,-77.068110,0,'2013-07-06 12:44:31',NULL,NULL),(43616,'48808','S','Bath','D','Clinton','26037','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.818180,-84.460610,0,'2013-07-06 12:44:32',NULL,NULL),(28091,'30741','S','Rossville','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.958205,-85.295156,0,'2013-07-06 12:44:31',NULL,NULL),(11213,'11746','S','Huntingtn Sta','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(4441,'03244','S','Windsor','A','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.132803,-71.929453,0,'2013-07-06 12:44:30',NULL,NULL),(477,'00667','S','Ext El Valle 2','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(24221,'26716','S','Horse Shoe Run','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.291239,-79.511965,0,'2013-07-06 12:44:31',NULL,NULL),(42207,'47553','S','Alfordsville','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(71410,'87020','S','Ambrosia Lake','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.159241,-107.836997,0,'2013-07-06 12:44:34',NULL,NULL),(67562,'80291','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.743207,-104.985884,0,'2013-07-06 12:44:34',NULL,NULL),(56755,'65728','S','Ponce de Leon','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.890333,-93.372403,0,'2013-07-06 12:44:33',NULL,NULL),(54983,'63125','S','Bella Villa','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.523552,-90.297410,0,'2013-07-06 12:44:33',NULL,NULL),(51589,'59807','P','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.968666,-113.967458,0,'2013-07-06 12:44:33',NULL,NULL),(21673,'22952','S','Sherando','A','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.011380,-78.924480,0,'2013-07-06 12:44:31',NULL,NULL),(5478,'04743','S','New Canada','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.251669,-68.593437,0,'2013-07-06 12:44:30',NULL,NULL),(44284,'49718','S','Carp Lake','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.699913,-84.792400,0,'2013-07-06 12:44:32',NULL,NULL),(4405,'03222','S','Bridgewater','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.606641,-71.739886,0,'2013-07-06 12:44:30',NULL,NULL),(71545,'87181','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.105228,-106.514073,0,'2013-07-06 12:44:34',NULL,NULL),(47146,'54460','S','Owen','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.947848,-90.563733,0,'2013-07-06 12:44:32',NULL,NULL),(36769,'41041','S','Tilton','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(34699,'38829','S','Burtons','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(30487,'33355','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.112790,-80.303694,0,'2013-07-06 12:44:32',NULL,NULL),(68722,'82073','P','Laramie','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.311168,-105.580954,0,'2013-07-06 12:44:34',NULL,NULL),(64972,'77258','P','Nassau Bay','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.571123,-95.079244,0,'2013-07-06 12:44:34',NULL,NULL),(61724,'73018','S','Norge','A','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.033843,-97.947357,0,'2013-07-06 12:44:33',NULL,NULL),(55878,'64199','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.104105,-94.583828,0,'2013-07-06 12:44:33',NULL,NULL),(48702,'55941','S','Hokah','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.761414,-91.352430,0,'2013-07-06 12:44:33',NULL,NULL),(76233,'95385','S','Vernalis','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.619677,-121.246442,0,'2013-07-06 12:44:34',NULL,NULL),(64064,'76135','S','Lakeside','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.825756,-97.451279,0,'2013-07-06 12:44:34',NULL,NULL),(62571,'74457','S','Proctor','D','Adair','40001','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.968720,-94.744798,0,'2013-07-06 12:44:33',NULL,NULL),(58687,'68924','S','Axtell','D','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.480326,-99.125483,0,'2013-07-06 12:44:33',NULL,NULL),(45053,'50501','S','Crossroads Center','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(12338,'12872','P','Severance','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.884025,-73.724390,0,'2013-07-06 12:44:30',NULL,NULL),(30232,'33189','S','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.568606,-80.342890,0,'2013-07-06 12:44:32',NULL,NULL),(50700,'58361','S','Pekin','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.762536,-98.333124,0,'2013-07-06 12:44:33',NULL,NULL),(57613,'67122','S','Piedmont','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.635562,-96.409749,0,'2013-07-06 12:44:33',NULL,NULL),(23638,'25772','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.416023,-82.474435,0,'2013-07-06 12:44:31',NULL,NULL),(48516,'55746','S','Kelly Lake','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(69652,'84010','S','West Bountiful','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.871662,-111.890486,0,'2013-07-06 12:44:34',NULL,NULL),(17906,'18448','U','Olyphant','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.451993,-75.580207,0,'2013-07-06 12:44:31',NULL,NULL),(21510,'22714','S','Brandy Sta','A','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.523104,-77.898372,0,'2013-07-06 12:44:31',NULL,NULL),(58581,'68835','S','Cotesfield','A','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.285075,-98.591395,0,'2013-07-06 12:44:33',NULL,NULL),(54854,'63043','S','Hazelwood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.724027,-90.439555,0,'2013-07-06 12:44:33',NULL,NULL),(53696,'62231','S','Posey','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(29323,'32542','S','Duke Field AFS','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(69132,'83286','S','Weston','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.033727,-112.014264,0,'2013-07-06 12:44:34',NULL,NULL),(6175,'05474','S','Abnaki','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(49102,'56341','P','Holmes City','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.807434,-95.573123,0,'2013-07-06 12:44:33',NULL,NULL),(69034,'83218','P','Basalt','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.313907,-112.164559,0,'2013-07-06 12:44:34',NULL,NULL),(61359,'72482','S','Williford','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.316801,-91.391813,0,'2013-07-06 12:44:33',NULL,NULL),(27916,'30506','S','Gainesville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.371032,-83.865332,0,'2013-07-06 12:44:31',NULL,NULL),(44552,'50008','S','Harvard','N','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.674358,-93.382116,0,'2013-07-06 12:44:32',NULL,NULL),(45889,'52302','S','Midway','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.043431,-91.593062,0,'2013-07-06 12:44:32',NULL,NULL),(73966,'92069','S','San Marcos','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.149519,-117.173018,0,'2013-07-06 12:44:34',NULL,NULL),(60759,'72004','S','Altheimer','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.318415,-91.842383,0,'2013-07-06 12:44:33',NULL,NULL),(40588,'45876','P','Ottoville','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.931483,-84.336412,0,'2013-07-06 12:44:32',NULL,NULL),(6238,'05491','S','Summer Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(25442,'28312','S','Eastover','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.066291,-78.866574,0,'2013-07-06 12:44:31',NULL,NULL),(64840,'77041','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.857122,-95.572778,0,'2013-07-06 12:44:34',NULL,NULL),(53421,'61850','S','Indianola','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.926910,-87.739525,0,'2013-07-06 12:44:33',NULL,NULL),(52714,'61130','P','Loves Park','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.325927,-89.003941,0,'2013-07-06 12:44:33',NULL,NULL),(35418,'39470','S','Barth','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(45044,'50480','S','German Valley','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.238426,-94.039265,0,'2013-07-06 12:44:32',NULL,NULL),(59394,'70629','S','Calcasieu Marine Tower','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.227087,-93.214488,0,'2013-07-06 12:44:33',NULL,NULL),(17147,'17801','S','Rockefeller','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(49625,'56915','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896263,-77.036490,0,'2013-07-06 12:44:33',NULL,NULL),(25484,'28355','P','Lemon Springs','D','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.394801,-79.188356,0,'2013-07-06 12:44:31',NULL,NULL),(66603,'78759','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.397200,-97.751760,0,'2013-07-06 12:44:34',NULL,NULL),(61848,'73119','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.420064,-97.570604,0,'2013-07-06 12:44:33',NULL,NULL),(59497,'70772','S','Rosedale','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.409574,-91.434613,0,'2013-07-06 12:44:33',NULL,NULL),(57905,'67650','S','Morland','D','Graham','20065','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.337740,-100.071414,0,'2013-07-06 12:44:33',NULL,NULL),(16140,'17059','S','Fermanagh','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(79131,'98498','S','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162978,-122.560507,0,'2013-07-06 12:44:34',NULL,NULL),(66980,'79424','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.522541,-101.927003,0,'2013-07-06 12:44:34',NULL,NULL),(60249,'71438','S','Hineston','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.149021,-92.748532,0,'2013-07-06 12:44:33',NULL,NULL),(59845,'71251','S','Jonesboro','D','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.237820,-92.642040,0,'2013-07-06 12:44:33',NULL,NULL),(59106,'70142','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.947342,-90.030163,0,'2013-07-06 12:44:33',NULL,NULL),(55006,'63131','S','Huntleigh','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(40501,'45806','S','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.686359,-84.133844,0,'2013-07-06 12:44:32',NULL,NULL),(59401,'70633','S','Dequincy','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.447654,-93.429202,0,'2013-07-06 12:44:33',NULL,NULL),(54514,'62871','S','Omaha','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.886303,-88.267731,0,'2013-07-06 12:44:33',NULL,NULL),(38738,'44028','S','No Eaton','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.312086,-81.935671,0,'2013-07-06 12:44:32',NULL,NULL),(73169,'90305','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.960447,-118.331386,0,'2013-07-06 12:44:34',NULL,NULL),(22679,'24314','S','Bastian','D','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.161780,-81.198480,0,'2013-07-06 12:44:31',NULL,NULL),(41916,'47374','S','Whitewater','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(4808,'03890','S','W Ossipee','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.838457,-71.201602,0,'2013-07-06 12:44:30',NULL,NULL),(1159,'00727','S','Urb Altomonte','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(32939,'36567','S','Rosinton','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.569400,-87.630720,0,'2013-07-06 12:44:32',NULL,NULL),(6042,'05408','S','Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446628,-73.175354,0,'2013-07-06 12:44:30',NULL,NULL),(64219,'76270','S','Sunset','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.459316,-97.775400,0,'2013-07-06 12:44:34',NULL,NULL),(748,'00692','S','Est Del Valle','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(54492,'62864','S','Camp Ground','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(65329,'77515','S','Richwood','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(62866,'75033','S','Frisco','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.153543,-96.848348,0,'2013-07-06 12:44:33',NULL,NULL),(45540,'51452','P','Lidderdale','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.125824,-94.783663,0,'2013-07-06 12:44:32',NULL,NULL),(41997,'47424','S','Mineral','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(72324,'89005','S','Willow Beach','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.977834,-114.835850,0,'2013-07-06 12:44:34',NULL,NULL),(20779,'21532','S','Midland','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.655702,-78.929019,0,'2013-07-06 12:44:31',NULL,NULL),(75524,'94161','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.798530,-122.399890,0,'2013-07-06 12:44:34',NULL,NULL),(13327,'13680','S','Rensslaer Fls','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.591957,-75.320308,0,'2013-07-06 12:44:30',NULL,NULL),(16266,'17089','U','High Mark Blue Shield','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.253878,-76.927333,0,'2013-07-06 12:44:31',NULL,NULL),(34578,'38737','S','Dwiggins','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(36140,'40229','S','Okolona','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.102864,-85.665671,0,'2013-07-06 12:44:32',NULL,NULL),(47712,'55003','S','Bayport','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.014760,-92.781480,0,'2013-07-06 12:44:33',NULL,NULL),(44079,'49451','S','Ravenna','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.205403,-85.958895,0,'2013-07-06 12:44:32',NULL,NULL),(46071,'52581','S','Plano','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.783615,-93.036389,0,'2013-07-06 12:44:32',NULL,NULL),(10747,'11359','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.789436,-73.777382,0,'2013-07-06 12:44:30',NULL,NULL),(20458,'21023','P','Butler','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.534656,-76.730495,0,'2013-07-06 12:44:31',NULL,NULL),(39020,'44143','S','Highland Hgts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(73926,'92028','S','Fallbrook','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.368660,-117.219178,0,'2013-07-06 12:44:34',NULL,NULL),(63579,'75778','S','Opelika','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.332800,-95.773080,0,'2013-07-06 12:44:34',NULL,NULL),(51561,'59749','S','Sheridan','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.436690,-112.181736,0,'2013-07-06 12:44:33',NULL,NULL),(50401,'57772','S','Sharps Corner','N','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.497460,-102.501680,0,'2013-07-06 12:44:33',NULL,NULL),(16372,'17201','S','Pond Bank','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(11219,'11747','S','Huntingtn Sta','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.803692,-73.402157,0,'2013-07-06 12:44:30',NULL,NULL),(61887,'73135','S','Del City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.391618,-97.423072,0,'2013-07-06 12:44:33',NULL,NULL),(14281,'14859','S','Lockwood','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.090387,-76.579355,0,'2013-07-06 12:44:31',NULL,NULL),(36290,'40355','S','New Liberty','D','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.620652,-84.890171,0,'2013-07-06 12:44:32',NULL,NULL),(15029,'15688','S','Tarrs','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.158722,-79.572591,0,'2013-07-06 12:44:31',NULL,NULL),(76461,'95615','S','Paintersville','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.316277,-121.553829,0,'2013-07-06 12:44:34',NULL,NULL),(68487,'81252','S','Westcliffe','D','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.114881,-105.429189,0,'2013-07-06 12:44:34',NULL,NULL),(20730,'21287','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304023,-76.562557,0,'2013-07-06 12:44:31',NULL,NULL),(33094,'36849','U','Auburn','A','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.602139,-85.508496,0,'2013-07-06 12:44:32',NULL,NULL),(1112,'00725','S','Urb Santa Cecilia','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(39289,'44488','U','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.240195,-80.819390,0,'2013-07-06 12:44:32',NULL,NULL),(45816,'52204','U','Amana','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.798523,-91.870646,0,'2013-07-06 12:44:32',NULL,NULL),(14635,'15234','S','Baldwin Township','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(15064,'15731','P','Coral','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.502807,-79.176970,0,'2013-07-06 12:44:31',NULL,NULL),(56326,'65106','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578011,-92.174363,0,'2013-07-06 12:44:33',NULL,NULL),(46513,'53263','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084119,-88.035945,0,'2013-07-06 12:44:32',NULL,NULL),(14067,'14602','P','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.168234,-77.601928,0,'2013-07-06 12:44:31',NULL,NULL),(28999,'32219','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.410491,-81.807977,0,'2013-07-06 12:44:32',NULL,NULL),(11878,'12306','S','Rotterdam','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.792392,-73.984961,0,'2013-07-06 12:44:30',NULL,NULL),(49371,'56586','S','Maine','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.326075,-95.839007,0,'2013-07-06 12:44:33',NULL,NULL),(60918,'72081','S','Judsonia','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.429280,-91.690920,0,'2013-07-06 12:44:33',NULL,NULL),(60120,'71369','S','Hyde','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.989911,-91.825861,0,'2013-07-06 12:44:33',NULL,NULL),(67804,'80740','S','Lindon','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.750888,-103.385923,0,'2013-07-06 12:44:34',NULL,NULL),(63236,'75472','S','East Tawakoni','A','Rains','48379','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.892875,-95.866525,0,'2013-07-06 12:44:33',NULL,NULL),(62838,'75009','S','Celina','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.339332,-96.761179,0,'2013-07-06 12:44:33',NULL,NULL),(19664,'20314','U','US Army Corp of Engineers','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895872,-77.009157,0,'2013-07-06 12:44:31',NULL,NULL),(25842,'28622','S','Flat Springs','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(7657,'07083','S','Chestnut','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.691867,-74.269598,0,'2013-07-06 12:44:30',NULL,NULL),(46003,'52533','S','Abingdon','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.997808,-92.159295,0,'2013-07-06 12:44:32',NULL,NULL),(24497,'27261','P','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.975341,-79.999493,0,'2013-07-06 12:44:31',NULL,NULL),(35633,'39633','S','Saukum','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(34157,'38255','S','Sharon','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.235538,-88.824945,0,'2013-07-06 12:44:32',NULL,NULL),(32540,'36107','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.376358,-86.278031,0,'2013-07-06 12:44:32',NULL,NULL),(15622,'16693','S','Williamsburg','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.459604,-78.203477,0,'2013-07-06 12:44:31',NULL,NULL),(79430,'98830','S','Mansfield','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.792917,-119.638497,0,'2013-07-06 12:44:34',NULL,NULL),(59593,'71008','S','Danville','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(18468,'19083','S','Llanerch','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.974773,-75.308851,0,'2013-07-06 12:44:31',NULL,NULL),(7653,'07080','S','S Plainfield','A','Middlesex','34023','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.580308,-74.413829,0,'2013-07-06 12:44:30',NULL,NULL),(4149,'02763','S','N Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.970895,-71.304600,0,'2013-07-06 12:44:30',NULL,NULL),(18966,'19512','S','Woodchoppertown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(14461,'15110','S','Duquesne','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.371863,-79.852119,0,'2013-07-06 12:44:31',NULL,NULL),(41092,'46542','S','Milford','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.409782,-85.848241,0,'2013-07-06 12:44:32',NULL,NULL),(58988,'70052','S','Gramercy','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.102717,-90.695822,0,'2013-07-06 12:44:33',NULL,NULL),(38556,'43760','S','Mount Perry','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.899113,-82.172415,0,'2013-07-06 12:44:32',NULL,NULL),(72986,'90055','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.047536,-118.256556,0,'2013-07-06 12:44:34',NULL,NULL),(71270,'86429','S','Bullhead City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.159216,-114.476797,0,'2013-07-06 12:44:34',NULL,NULL),(63888,'76015','S','Pantego','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.692305,-97.133908,0,'2013-07-06 12:44:34',NULL,NULL),(62185,'73760','S','Meno','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.387867,-98.176168,0,'2013-07-06 12:44:33',NULL,NULL),(58792,'68979','S','Sutton','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.605438,-97.861006,0,'2013-07-06 12:44:33',NULL,NULL),(52001,'60165','S','Melrose Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.900556,-87.856667,0,'2013-07-06 12:44:33',NULL,NULL),(34862,'38929','S','Gore Springs','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.786191,-89.806290,0,'2013-07-06 12:44:32',NULL,NULL),(39011,'44140','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.489820,-81.921480,0,'2013-07-06 12:44:32',NULL,NULL),(47780,'55043','S','Saint Marys Point','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(41150,'46701','S','Burr Oak','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(48813,'56026','S','Ellendale','D','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.874568,-93.302086,0,'2013-07-06 12:44:33',NULL,NULL),(79403,'98811','P','Ardenvoir','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.746154,-120.382400,0,'2013-07-06 12:44:34',NULL,NULL),(19987,'20598','U','Reston','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(26153,'28740','S','Lower Pig Pen','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(31596,'34667','S','Hudson','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.393847,-82.651438,0,'2013-07-06 12:44:32',NULL,NULL),(24453,'27215','S','Glen Raven','A','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.033420,-79.490880,0,'2013-07-06 12:44:31',NULL,NULL),(832,'00693','S','Villas de la Playa','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(5706,'04985','S','Indian Stream','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(6751,'06085','S','Unionville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.752359,-72.892851,0,'2013-07-06 12:44:30',NULL,NULL),(44281,'49715','S','Raco','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.397049,-84.594749,0,'2013-07-06 12:44:32',NULL,NULL),(72414,'89048','S','Pahrump','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.254480,-116.018558,0,'2013-07-06 12:44:34',NULL,NULL),(51297,'59219','S','Dagmar','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.605863,-104.247793,0,'2013-07-06 12:44:33',NULL,NULL),(2684,'00968','S','Metro Office Park','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(3484,'01834','S','Groveland','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.755514,-71.029608,0,'2013-07-06 12:44:30',NULL,NULL),(65946,'78261','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.706348,-98.398494,0,'2013-07-06 12:44:34',NULL,NULL),(2751,'00969','S','Urb Santa Paula','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(6385,'05701','S','Mendon','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(14925,'15549','P','Listie','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.029295,-79.012690,0,'2013-07-06 12:44:31',NULL,NULL),(9530,'10019','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(11386,'11940','S','E Moriches','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.808490,-72.752280,0,'2013-07-06 12:44:30',NULL,NULL),(31583,'34654','S','New Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.300248,-82.634053,0,'2013-07-06 12:44:32',NULL,NULL),(22425,'24009','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270658,-79.938509,0,'2013-07-06 12:44:31',NULL,NULL),(35493,'39525','S','Diamondhead','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.384560,-89.375564,0,'2013-07-06 12:44:32',NULL,NULL),(26329,'29052','S','Kingville','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.849444,-80.763680,0,'2013-07-06 12:44:31',NULL,NULL),(7715,'07193','U','Jp Morgan Chase','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.729343,-74.176946,0,'2013-07-06 12:44:30',NULL,NULL),(46159,'52726','S','Blue Grass','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.498229,-90.757156,0,'2013-07-06 12:44:32',NULL,NULL),(17178,'17815','S','Jerseytown','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(9604,'10031','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(24880,'27699','U','NC Centralized Mailing','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.670641,-78.663729,0,'2013-07-06 12:44:31',NULL,NULL),(58904,'69214','S','Johnstown','D','Brown','31017','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.459054,-100.070999,0,'2013-07-06 12:44:33',NULL,NULL),(39689,'45032','P','Harveysburg','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.504357,-84.009988,0,'2013-07-06 12:44:32',NULL,NULL),(41031,'46385','S','Valpo','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.473056,-87.061111,0,'2013-07-06 12:44:32',NULL,NULL),(33130,'36877','S','Smiths Station','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.537478,-85.099853,0,'2013-07-06 12:44:32',NULL,NULL),(31494,'34442','S','Hernando','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.930770,-82.373430,0,'2013-07-06 12:44:32',NULL,NULL),(59636,'71038','S','Gordon','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(30096,'33158','S','C Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(42148,'47520','S','Cannelton Hts','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(23123,'24963','S','Bozoo','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.398643,-80.800140,0,'2013-07-06 12:44:31',NULL,NULL),(13951,'14454','S','Geneseo','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.788901,-77.771652,0,'2013-07-06 12:44:31',NULL,NULL),(17979,'18617','S','Glen Lyon','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.171949,-76.075487,0,'2013-07-06 12:44:31',NULL,NULL),(36394,'40503','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.000395,-84.530955,0,'2013-07-06 12:44:32',NULL,NULL),(50918,'58562','S','New Leipzig','D','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.405980,-101.895420,0,'2013-07-06 12:44:33',NULL,NULL),(73494,'91327','P','Porter Ranch','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.273021,-118.551433,0,'2013-07-06 12:44:34',NULL,NULL),(62013,'73446','S','Oakland','A','Marshall','40095','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.085514,-96.773997,0,'2013-07-06 12:44:33',NULL,NULL),(56513,'65350','S','Smithton','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.680224,-93.092795,0,'2013-07-06 12:44:33',NULL,NULL),(28951,'32190','S','Seville','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.344542,-81.510069,0,'2013-07-06 12:44:32',NULL,NULL),(18293,'19014','S','Upper Chichester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(49772,'57070','S','Midway','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.189920,-97.116960,0,'2013-07-06 12:44:33',NULL,NULL),(79748,'99251','U','Whitworth University','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.751705,-117.419050,0,'2013-07-06 12:44:34',NULL,NULL),(64156,'76206','P','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.198893,-97.120262,0,'2013-07-06 12:44:34',NULL,NULL),(12577,'13069','S','Bowens Corners','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(29725,'32955','S','Rockledge','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.313343,-80.723283,0,'2013-07-06 12:44:32',NULL,NULL),(3669,'02125','S','Dorchester','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.313703,-71.062976,0,'2013-07-06 12:44:30',NULL,NULL),(35053,'39180','S','Bovina','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.323121,-90.860809,0,'2013-07-06 12:44:32',NULL,NULL),(42242,'47568','S','Epsom','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.777115,-87.180839,0,'2013-07-06 12:44:32',NULL,NULL),(22519,'24088','S','Ferrum','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.928893,-80.016884,0,'2013-07-06 12:44:31',NULL,NULL),(10918,'11429','S','Queens Vlg','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.711559,-73.742091,0,'2013-07-06 12:44:30',NULL,NULL),(65059,'77341','U','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.714355,-95.543506,0,'2013-07-06 12:44:34',NULL,NULL),(67703,'80525','S','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.534158,-105.043374,0,'2013-07-06 12:44:34',NULL,NULL),(66928,'79345','S','Meadow','D','Terry','48445','Texas','TX','48','0000','806','Central',-6.0,'Y',33.326384,-102.332558,0,'2013-07-06 12:44:34',NULL,NULL),(61539,'72682','S','Valley Spgs','A','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.143149,-92.983087,0,'2013-07-06 12:44:33',NULL,NULL),(24215,'26710','S','Burlington','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.365881,-78.911270,0,'2013-07-06 12:44:31',NULL,NULL),(4555,'03457','S','Nelson','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.002905,-72.144980,0,'2013-07-06 12:44:30',NULL,NULL),(40553,'45854','P','Lima','A','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.758842,-83.945650,0,'2013-07-06 12:44:32',NULL,NULL),(19498,'20160','P','Purcellville','A','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.116202,-77.693967,0,'2013-07-06 12:44:31',NULL,NULL),(70521,'85005','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.447818,-112.127906,0,'2013-07-06 12:44:34',NULL,NULL),(18055,'18702','S','Hudson','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(26738,'29420','S','Charleston','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.923689,-80.099458,0,'2013-07-06 12:44:31',NULL,NULL),(10509,'10973','S','Slate Hill','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.374755,-74.486379,0,'2013-07-06 12:44:30',NULL,NULL),(30792,'33603','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.985173,-82.471207,0,'2013-07-06 12:44:32',NULL,NULL),(72523,'89161','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.122600,-115.092200,0,'2013-07-06 12:44:34',NULL,NULL),(11021,'11560','S','Matinecock','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.877100,-73.611420,0,'2013-07-06 12:44:30',NULL,NULL),(29205,'32411','P','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.149160,-85.729755,0,'2013-07-06 12:44:32',NULL,NULL),(29902,'33050','S','Marathon Shores','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(54086,'62523','S','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.842913,-88.949476,0,'2013-07-06 12:44:33',NULL,NULL),(74606,'92707','S','South Main','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.696780,-117.870120,0,'2013-07-06 12:44:34',NULL,NULL),(18696,'19192','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955297,-75.184537,0,'2013-07-06 12:44:31',NULL,NULL),(27599,'30297','S','Fort Gillem','A','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.615198,-84.367485,0,'2013-07-06 12:44:31',NULL,NULL),(73392,'91110','U','Shared Firm Zip Code','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.155939,-118.154292,0,'2013-07-06 12:44:34',NULL,NULL),(68877,'82644','P','Mills','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.866408,-106.410162,0,'2013-07-06 12:44:34',NULL,NULL),(29108,'32307','U','Florida A & M','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.431483,-84.288359,0,'2013-07-06 12:44:32',NULL,NULL),(37711,'42266','S','Pembroke','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.779266,-87.364735,0,'2013-07-06 12:44:32',NULL,NULL),(43452,'48529','S','Southeast','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.974171,-83.664604,0,'2013-07-06 12:44:32',NULL,NULL),(21611,'22903','S','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.037660,-78.519202,0,'2013-07-06 12:44:31',NULL,NULL),(21815,'23103','S','Sabot','N','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.653832,-77.725631,0,'2013-07-06 12:44:31',NULL,NULL),(43589,'48755','S','Pigeon','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.854179,-83.289645,0,'2013-07-06 12:44:32',NULL,NULL),(331,'00652','S','Garrochales','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.466248,-66.569371,0,'2013-07-06 12:44:30',NULL,NULL),(67375,'80121','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(54975,'63122','S','Warson Woods','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.584479,-90.414020,0,'2013-07-06 12:44:33',NULL,NULL),(11591,'12078','S','Meco','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.054502,-74.338330,0,'2013-07-06 12:44:30',NULL,NULL),(11250,'11762','S','Massapequa Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.683043,-73.446969,0,'2013-07-06 12:44:30',NULL,NULL),(17392,'17901','S','Dieners Hill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(61337,'72461','S','Rector','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.265856,-90.293377,0,'2013-07-06 12:44:33',NULL,NULL),(39145,'44282','P','Wadsworth','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027604,-81.727651,0,'2013-07-06 12:44:32',NULL,NULL),(43861,'49117','S','Grand Beach','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.786972,-86.754132,0,'2013-07-06 12:44:32',NULL,NULL),(47842,'55073','S','Otisville','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.271900,-92.831860,0,'2013-07-06 12:44:33',NULL,NULL),(12794,'13220','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.125489,-76.129731,0,'2013-07-06 12:44:30',NULL,NULL),(14423,'15071','S','Noblestown','A','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.391111,-80.198889,0,'2013-07-06 12:44:31',NULL,NULL),(25003,'27871','S','Bear Grass','N','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.822151,-77.251920,0,'2013-07-06 12:44:31',NULL,NULL),(48054,'55319','S','Clear Lake','D','Sherburne','27141','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.449652,-93.997845,0,'2013-07-06 12:44:33',NULL,NULL),(14995,'15656','S','North Leechburg','A','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.629851,-79.604848,0,'2013-07-06 12:44:31',NULL,NULL),(49544,'56685','S','Waskish','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.196353,-94.484298,0,'2013-07-06 12:44:33',NULL,NULL),(54630,'62919','S','Cave in Rock','D','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.539067,-88.238667,0,'2013-07-06 12:44:33',NULL,NULL),(38389,'43519','P','Evansport','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.428226,-84.395702,0,'2013-07-06 12:44:32',NULL,NULL),(3067,'01119','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122853,-72.506417,0,'2013-07-06 12:44:30',NULL,NULL),(23027,'24844','S','Iaeger','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.438200,-81.810900,0,'2013-07-06 12:44:31',NULL,NULL),(39652,'45003','S','College Corner','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.586561,-84.786665,0,'2013-07-06 12:44:32',NULL,NULL),(78365,'98020','S','Woodway','A','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.800941,-122.374292,0,'2013-07-06 12:44:34',NULL,NULL),(74788,'93121','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.419234,-119.709176,0,'2013-07-06 12:44:34',NULL,NULL),(69829,'84079','P','Vernal','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.451292,-109.536992,0,'2013-07-06 12:44:34',NULL,NULL),(44982,'50426','S','Carpenter','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.431365,-92.913573,0,'2013-07-06 12:44:32',NULL,NULL),(48038,'55306','S','Burnsville','D','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.733364,-93.289531,0,'2013-07-06 12:44:33',NULL,NULL),(73012,'90066','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.993713,-118.428320,0,'2013-07-06 12:44:34',NULL,NULL),(33058,'36761','S','Farmersville','N','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.086912,-87.016816,0,'2013-07-06 12:44:32',NULL,NULL),(4032,'02573','P','Vineyard Haven','A','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.441817,-70.600178,0,'2013-07-06 12:44:30',NULL,NULL),(47663,'54937','S','North Fond du Lac','A','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.808088,-88.480729,0,'2013-07-06 12:44:33',NULL,NULL),(2813,'00976','S','Villa Blanca','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(79520,'98936','S','Moxee City','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.549243,-120.329764,0,'2013-07-06 12:44:34',NULL,NULL),(53285,'61727','S','Clintonia Township','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(40702,'46103','P','Amo','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.697239,-86.582314,0,'2013-07-06 12:44:32',NULL,NULL),(17035,'17747','S','Logan Mills','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(2428,'00953','S','Urb Casitas de la Fuente','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(29488,'32738','S','Deltona','D','Volusia','12127','Florida','FL','12','2020','407/321','Eastern',-5.0,'Y',28.910545,-81.192559,0,'2013-07-06 12:44:32',NULL,NULL),(68657,'81647','S','New Castle','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.559479,-107.545886,0,'2013-07-06 12:44:34',NULL,NULL),(37642,'42167','S','Boles','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(40730,'46126','S','Fairland','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.609769,-85.887525,0,'2013-07-06 12:44:32',NULL,NULL),(43735,'48951','U','Jackson National Life Ins Co','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.733180,-84.555446,0,'2013-07-06 12:44:32',NULL,NULL),(37784,'42356','P','Maple Mount','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.689402,-87.323525,0,'2013-07-06 12:44:32',NULL,NULL),(3213,'01364','S','Lake Mattawa','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(25844,'28622','S','Whaley','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(44840,'50263','S','Waukee','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602701,-93.869105,0,'2013-07-06 12:44:32',NULL,NULL),(57435,'66783','S','Yates Center','D','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.881629,-95.728588,0,'2013-07-06 12:44:33',NULL,NULL),(54132,'62560','S','Raymond','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.322024,-89.572809,0,'2013-07-06 12:44:33',NULL,NULL),(14929,'15552','S','Myersdale','N','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.807027,-79.028327,0,'2013-07-06 12:44:31',NULL,NULL),(31286,'34037','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(49133,'56364','S','Harding','A','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.978574,-94.097687,0,'2013-07-06 12:44:33',NULL,NULL),(72776,'89570','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.495119,-119.747101,0,'2013-07-06 12:44:34',NULL,NULL),(10558,'11003','S','Argo Village','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(34497,'38669','P','Baugh','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.189654,-90.626670,0,'2013-07-06 12:44:32',NULL,NULL),(46677,'53726','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.073535,-89.395574,0,'2013-07-06 12:44:32',NULL,NULL),(63545,'75763','S','Frankston Lake','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(50744,'58401','S','Jmst','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(29232,'32428','S','Sunny Hills','A','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.671940,-85.571469,0,'2013-07-06 12:44:32',NULL,NULL),(3804,'02241','U','Bank of America','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.354861,-71.057266,0,'2013-07-06 12:44:30',NULL,NULL),(36883,'41101','S','Bellefonte','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(79161,'98509','P','Lacey','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.036241,-122.810690,0,'2013-07-06 12:44:34',NULL,NULL),(66669,'78881','S','Sabinal','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.314635,-99.472472,0,'2013-07-06 12:44:34',NULL,NULL),(59423,'70658','S','Reeves','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.435432,-93.115704,0,'2013-07-06 12:44:33',NULL,NULL),(56351,'65202','S','Lindbergh','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(53374,'61777','S','Wapella','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.220098,-88.960314,0,'2013-07-06 12:44:33',NULL,NULL),(14436,'15086','S','Warrendale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.661262,-80.083168,0,'2013-07-06 12:44:31',NULL,NULL),(27023,'29647','U','Park Seed Co','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.189754,-82.153840,0,'2013-07-06 12:44:31',NULL,NULL),(41185,'46714','S','Toll Gate Heights','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(1542,'00757','S','Praderas del Sur','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(27569,'30268','S','Chattahoochee Hills','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.533450,-84.690866,0,'2013-07-06 12:44:31',NULL,NULL),(66249,'78572','S','Madero','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(64074,'76140','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.612498,-97.271398,0,'2013-07-06 12:44:34',NULL,NULL),(58299,'68423','S','Pleasant Dale','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.791794,-96.930323,0,'2013-07-06 12:44:33',NULL,NULL),(56846,'65897','U','SMSU','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.199100,-93.276100,0,'2013-07-06 12:44:33',NULL,NULL),(56360,'65203','S','McBaine','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.929931,-92.372948,0,'2013-07-06 12:44:33',NULL,NULL),(19450,'20118','P','Middleburg','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.967524,-77.734278,0,'2013-07-06 12:44:31',NULL,NULL),(2988,'01062','S','Florence','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.331578,-72.692571,0,'2013-07-06 12:44:30',NULL,NULL),(57194,'66422','S','Emmett','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.309020,-96.056094,0,'2013-07-06 12:44:33',NULL,NULL),(52364,'60613','S','Lakeview','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.955735,-87.661210,0,'2013-07-06 12:44:33',NULL,NULL),(15059,'15725','S','Clarksburg','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.500035,-79.369477,0,'2013-07-06 12:44:31',NULL,NULL),(14773,'15346','P','Mather','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.936455,-80.077771,0,'2013-07-06 12:44:31',NULL,NULL),(22271,'23696','S','Seaford','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.188821,-76.431107,0,'2013-07-06 12:44:31',NULL,NULL),(21894,'23183','P','White Marsh','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.341820,-76.520077,0,'2013-07-06 12:44:31',NULL,NULL),(9845,'10117','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752294,-73.995082,0,'2013-07-06 12:44:30',NULL,NULL),(4035,'02574','P','W Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.601360,-70.639607,0,'2013-07-06 12:44:30',NULL,NULL),(4051,'02639','S','Dennis Port','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.662775,-70.133049,0,'2013-07-06 12:44:30',NULL,NULL),(46008,'52535','S','Kilbourn','N','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.854186,-91.948242,0,'2013-07-06 12:44:32',NULL,NULL),(63606,'75798','U','Tyler Junior College','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.334479,-95.285516,0,'2013-07-06 12:44:34',NULL,NULL),(56874,'66020','S','Easton','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.346570,-95.116302,0,'2013-07-06 12:44:33',NULL,NULL),(54091,'62530','S','Cimic','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.565165,-89.656848,0,'2013-07-06 12:44:33',NULL,NULL),(31564,'34611','P','Spring Hill','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.482064,-82.561085,0,'2013-07-06 12:44:32',NULL,NULL),(5483,'04745','S','Upper Frenchville','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.277889,-68.386251,0,'2013-07-06 12:44:30',NULL,NULL),(50113,'57501','S','Eakin','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(73689,'91605','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.209647,-118.402550,0,'2013-07-06 12:44:34',NULL,NULL),(59943,'71301','S','Anandale','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(59146,'70177','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.981380,-90.003173,0,'2013-07-06 12:44:33',NULL,NULL),(77487,'96824','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.280032,-157.758076,0,'2013-07-06 12:44:34',NULL,NULL),(75544,'94235','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584467,-121.495247,0,'2013-07-06 12:44:34',NULL,NULL),(35593,'39574','S','Success','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.600720,-89.112240,0,'2013-07-06 12:44:32',NULL,NULL),(36992,'41214','S','Davella','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.798056,-82.581944,0,'2013-07-06 12:44:32',NULL,NULL),(7898,'07601','S','Hackensack','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.888613,-74.047760,0,'2013-07-06 12:44:30',NULL,NULL),(9876,'10123','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(11891,'12325','P','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.814167,-73.940000,0,'2013-07-06 12:44:30',NULL,NULL),(74755,'93064','U','Simi Valley','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.283831,-118.688394,0,'2013-07-06 12:44:34',NULL,NULL),(69597,'83849','P','Osburn','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.507229,-115.998526,0,'2013-07-06 12:44:34',NULL,NULL),(60518,'71667','S','Palmyra','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(58806,'69023','S','Champion','D','Chase','31029','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.572410,-101.978580,0,'2013-07-06 12:44:33',NULL,NULL),(33454,'37318','S','Cowan','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.163183,-86.015612,0,'2013-07-06 12:44:32',NULL,NULL),(32490,'36053','S','Midway','D','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.107979,-85.526910,0,'2013-07-06 12:44:32',NULL,NULL),(10086,'10203','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711931,-74.011806,0,'2013-07-06 12:44:30',NULL,NULL),(70803,'85366','P','Yuma','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.686728,-114.591916,0,'2013-07-06 12:44:34',NULL,NULL),(53968,'62431','S','Herrick','D','Shelby','17173','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.239384,-88.971246,0,'2013-07-06 12:44:33',NULL,NULL),(1010,'00717','S','Urb Starlight','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(62069,'73550','S','Hollis','D','Harmon','40057','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.688629,-99.915553,0,'2013-07-06 12:44:33',NULL,NULL),(61673,'72927','S','Booneville','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.137425,-93.920695,0,'2013-07-06 12:44:33',NULL,NULL),(54117,'62549','S','Mount Zion','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.785894,-88.870832,0,'2013-07-06 12:44:33',NULL,NULL),(43794,'49053','S','Galesburg','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.289831,-85.420315,0,'2013-07-06 12:44:32',NULL,NULL),(44103,'49502','U','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.961458,-85.661874,0,'2013-07-06 12:44:32',NULL,NULL),(9795,'10109','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(60262,'71446','S','Leesville','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(58900,'69201','S','Valentine','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.876491,-100.569122,0,'2013-07-06 12:44:33',NULL,NULL),(46965,'54207','P','Collins','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.085255,-87.981193,0,'2013-07-06 12:44:32',NULL,NULL),(11179,'11732','S','Muttontown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.846511,-73.536189,0,'2013-07-06 12:44:30',NULL,NULL),(21924,'23225','S','Forest Hill','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.517420,-77.501037,0,'2013-07-06 12:44:31',NULL,NULL),(75940,'95030','S','Monte Sereno','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.171920,-121.974720,0,'2013-07-06 12:44:34',NULL,NULL),(62601,'74522','P','Alderson','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.898910,-95.693249,0,'2013-07-06 12:44:33',NULL,NULL),(77520,'96844','U','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.295954,-157.813874,0,'2013-07-06 12:44:34',NULL,NULL),(59713,'71106','S','Forbing','A','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.426395,-93.738506,0,'2013-07-06 12:44:33',NULL,NULL),(53738,'62253','S','Irishtown','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.739872,-89.312992,0,'2013-07-06 12:44:33',NULL,NULL),(32761,'36352','S','Newton','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.331380,-85.601124,0,'2013-07-06 12:44:32',NULL,NULL),(47755,'55025','S','Forest Lake','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.277195,-92.990033,0,'2013-07-06 12:44:33',NULL,NULL),(31608,'34682','P','Palm Harbor','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.077046,-82.761422,0,'2013-07-06 12:44:32',NULL,NULL),(47147,'54462','S','Pearson','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.388277,-89.085985,0,'2013-07-06 12:44:32',NULL,NULL),(14855,'15456','S','Lemont Fce','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.922596,-79.787657,0,'2013-07-06 12:44:31',NULL,NULL),(16031,'17043','S','Lemoyne','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.254300,-76.898040,0,'2013-07-06 12:44:31',NULL,NULL),(11834,'12243','U','NY Soc Serv Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653793,-73.746424,0,'2013-07-06 12:44:30',NULL,NULL),(27143,'29819','S','Promised Land','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.109752,-82.233224,0,'2013-07-06 12:44:31',NULL,NULL),(29250,'32444','S','Lynn Haven','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.235941,-85.647485,0,'2013-07-06 12:44:32',NULL,NULL),(29707,'32941','P','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.077442,-80.628489,0,'2013-07-06 12:44:32',NULL,NULL),(79982,'99656','P','Red Devil','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.750490,-157.259892,0,'2013-07-06 12:44:34',NULL,NULL),(73997,'92106','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.725654,-117.231417,0,'2013-07-06 12:44:34',NULL,NULL),(70188,'84335','S','Benson','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.835840,-111.870960,0,'2013-07-06 12:44:34',NULL,NULL),(74382,'92507','S','Canyon Crest','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.976325,-117.330414,0,'2013-07-06 12:44:34',NULL,NULL),(67033,'79541','S','Ovalo','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.134044,-99.829405,0,'2013-07-06 12:44:34',NULL,NULL),(23483,'25508','S','Chapmanville','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.967280,-82.016220,0,'2013-07-06 12:44:31',NULL,NULL),(35711,'39667','S','Salem','N','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(55536,'63834','S','Charleston','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.922260,-89.295480,0,'2013-07-06 12:44:33',NULL,NULL),(58448,'68718','S','Bloomfield','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.596572,-97.648618,0,'2013-07-06 12:44:33',NULL,NULL),(6320,'05661','S','Morrisvle','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(42100,'47460','S','Spencer','D','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(36832,'41071','S','Wilder','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(59998,'71330','P','Echo','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.121655,-92.255093,0,'2013-07-06 12:44:33',NULL,NULL),(26765,'29436','S','Cross','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.300589,-80.201392,0,'2013-07-06 12:44:31',NULL,NULL),(75848,'94927','P','Rohnert Park','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.347442,-122.698375,0,'2013-07-06 12:44:34',NULL,NULL),(68624,'81630','S','De Beque','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.331210,-108.216061,0,'2013-07-06 12:44:34',NULL,NULL),(68280,'81082','S','Pinon Canyon','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(64089,'76155','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.823263,-97.054863,0,'2013-07-06 12:44:34',NULL,NULL),(56793,'65761','S','Dugginsville','A','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.577980,-92.706780,0,'2013-07-06 12:44:33',NULL,NULL),(73724,'91617','P','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164995,-118.403562,0,'2013-07-06 12:44:34',NULL,NULL),(10170,'10281','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(7594,'07040','S','Maplewood','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.725322,-74.265292,0,'2013-07-06 12:44:30',NULL,NULL),(21557,'22803','P','Harrisonburg','D','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.449505,-78.869530,0,'2013-07-06 12:44:31',NULL,NULL),(50192,'57568','S','Hilmoe','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.908664,-100.053403,0,'2013-07-06 12:44:33',NULL,NULL),(69529,'83731','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.746358,-116.203781,0,'2013-07-06 12:44:34',NULL,NULL),(39146,'44285','P','Wayland','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.160687,-81.067897,0,'2013-07-06 12:44:32',NULL,NULL),(79639,'99137','S','Cedonia','N','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.152402,-118.128791,0,'2013-07-06 12:44:34',NULL,NULL),(68357,'81133','S','Sangre de Cri','A','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.413562,-105.393706,0,'2013-07-06 12:44:34',NULL,NULL),(11034,'11569','P','Point Lookout','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.593413,-73.580963,0,'2013-07-06 12:44:30',NULL,NULL),(43869,'49128','S','Lakeside','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.822485,-86.616550,0,'2013-07-06 12:44:32',NULL,NULL),(46079,'52588','S','White Elm','N','Van Buren','19177','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.857546,-92.123347,0,'2013-07-06 12:44:32',NULL,NULL),(74054,'92155','U','Naval Amphibious Base','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.674947,-117.160830,0,'2013-07-06 12:44:34',NULL,NULL),(58628,'68863','S','Overton','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.739926,-99.533777,0,'2013-07-06 12:44:33',NULL,NULL),(55068,'63167','U','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.660153,-90.455607,0,'2013-07-06 12:44:33',NULL,NULL),(18392,'19049','U','Union Fidelity Postage Pd','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.175266,-74.919785,0,'2013-07-06 12:44:31',NULL,NULL),(18598,'19139','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.962447,-75.230101,0,'2013-07-06 12:44:31',NULL,NULL),(79626,'99124','P','Elmer City','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.998784,-118.951803,0,'2013-07-06 12:44:34',NULL,NULL),(76184,'95337','S','Manteca','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.782913,-121.231166,0,'2013-07-06 12:44:34',NULL,NULL),(46031,'52555','S','Exline','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.646795,-92.844715,0,'2013-07-06 12:44:32',NULL,NULL),(14740,'15312','S','Avella','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.272892,-80.451010,0,'2013-07-06 12:44:31',NULL,NULL),(6125,'05459','S','Highgate Center','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(36146,'40241','S','Brownsboro Farm','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(17279,'17845','S','Millmont','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864071,-77.239421,0,'2013-07-06 12:44:31',NULL,NULL),(32077,'35287','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513903,-86.807366,0,'2013-07-06 12:44:32',NULL,NULL),(57339,'66720','S','Chanute','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.640820,-95.464980,0,'2013-07-06 12:44:33',NULL,NULL),(59909,'71281','P','Swartz','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.595352,-92.020992,0,'2013-07-06 12:44:33',NULL,NULL),(63503,'75708','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.398669,-95.243419,0,'2013-07-06 12:44:33',NULL,NULL),(66307,'78588','S','San Isidro','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.737743,-98.400419,0,'2013-07-06 12:44:34',NULL,NULL),(72526,'89162','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.172247,-115.136977,0,'2013-07-06 12:44:34',NULL,NULL),(72489,'89135','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.140027,-115.350114,0,'2013-07-06 12:44:34',NULL,NULL),(19947,'20576','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898384,-77.032462,0,'2013-07-06 12:44:31',NULL,NULL),(67072,'79567','S','Wilmeth','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(51825,'60056','S','Mt Prospect','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.068179,-87.932697,0,'2013-07-06 12:44:33',NULL,NULL),(50757,'58415','S','Berlin','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.442400,-98.483700,0,'2013-07-06 12:44:33',NULL,NULL),(31973,'35216','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(52544,'60936','S','Garber','N','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.465996,-88.370237,0,'2013-07-06 12:44:33',NULL,NULL),(19357,'20050','P','Pentagon','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906181,-76.987222,0,'2013-07-06 12:44:31',NULL,NULL),(38854,'44094','S','Willoughby','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(17490,'17960','S','Leibeyville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(68796,'82420','P','Cowley','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.880677,-108.468859,0,'2013-07-06 12:44:34',NULL,NULL),(62354,'74063','S','Lotsee','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.122622,-96.150607,0,'2013-07-06 12:44:33',NULL,NULL),(55486,'63764','S','Marble Hill','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.303440,-89.971980,0,'2013-07-06 12:44:33',NULL,NULL),(41694,'47223','S','Butlerville','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.120056,-85.492249,0,'2013-07-06 12:44:32',NULL,NULL),(78871,'98351','S','Longbranch','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.257222,-122.757222,0,'2013-07-06 12:44:34',NULL,NULL),(76345,'95472','S','Sebastopol','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.401860,-122.851680,0,'2013-07-06 12:44:34',NULL,NULL),(71622,'87364','P','Sheep Springs','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.139160,-108.709856,0,'2013-07-06 12:44:34',NULL,NULL),(47551,'54830','S','Dairyland','A','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.998019,-92.252388,0,'2013-07-06 12:44:32',NULL,NULL),(16819,'17547','S','Marietta','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061561,-76.559472,0,'2013-07-06 12:44:31',NULL,NULL),(68843,'82524','P','St Stephens','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.986090,-108.418042,0,'2013-07-06 12:44:34',NULL,NULL),(57071,'66214','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(51843,'60069','S','Prairieview','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194460,-87.910740,0,'2013-07-06 12:44:33',NULL,NULL),(28695,'31812','S','Junction City','D','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.602308,-84.457842,0,'2013-07-06 12:44:32',NULL,NULL),(41845,'47348','S','Shamrock Lks','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(32311,'35757','S','Madison','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.770466,-86.749611,0,'2013-07-06 12:44:32',NULL,NULL),(36264,'40330','S','Pleasanthill','N','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.789200,-84.861780,0,'2013-07-06 12:44:32',NULL,NULL),(6814,'06110','S','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(37679,'42216','P','Clifty','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.987194,-87.142357,0,'2013-07-06 12:44:32',NULL,NULL),(42864,'48081','S','St Clair Shores','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(64275,'76429','S','Caddo','D','Stephens','48429','Texas','TX','48','0000','254','Central',-6.0,'Y',32.685585,-98.642606,0,'2013-07-06 12:44:34',NULL,NULL),(57258,'66538','S','Kelly','A','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.836640,-96.061080,0,'2013-07-06 12:44:33',NULL,NULL),(57073,'66214','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(8329,'08037','S','Batsto','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(3003,'01074','P','South Barre','D','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.382950,-72.100531,0,'2013-07-06 12:44:30',NULL,NULL),(44388,'49802','S','Kingsford','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.818797,-88.067829,0,'2013-07-06 12:44:32',NULL,NULL),(18203,'18943','P','Penns Park','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.265356,-74.997695,0,'2013-07-06 12:44:31',NULL,NULL),(159,'00617','S','Villa Central','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(60925,'72084','S','Brush Creek','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.219063,-92.603497,0,'2013-07-06 12:44:33',NULL,NULL),(59851,'71254','S','Lake Providence','D','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(16535,'17272','P','Zullinger','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.767422,-77.624697,0,'2013-07-06 12:44:31',NULL,NULL),(18117,'18810','S','Athens','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.961913,-76.521874,0,'2013-07-06 12:44:31',NULL,NULL),(22251,'23666','S','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.049912,-76.412922,0,'2013-07-06 12:44:31',NULL,NULL),(21968,'23241','P','Richmnd','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.585084,-77.420677,0,'2013-07-06 12:44:31',NULL,NULL),(39819,'45146','S','Martinsville','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.316777,-83.795637,0,'2013-07-06 12:44:32',NULL,NULL),(16414,'17225','S','Bino','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(37640,'42166','S','Summer Shade','D','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.891240,-85.715460,0,'2013-07-06 12:44:32',NULL,NULL),(14458,'15108','S','Coropolis','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.510530,-80.182409,0,'2013-07-06 12:44:31',NULL,NULL),(26653,'29365','S','Lyman','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.972496,-82.151829,0,'2013-07-06 12:44:31',NULL,NULL),(42298,'47598','S','Augusta','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(55379,'63620','S','Glover','A','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.429977,-90.655396,0,'2013-07-06 12:44:33',NULL,NULL),(12742,'13201','P','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040920,-76.152640,0,'2013-07-06 12:44:30',NULL,NULL),(13566,'13840','P','Smithboro','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.098839,-76.364903,0,'2013-07-06 12:44:31',NULL,NULL),(18227,'18968','P','Spinnerstown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.443981,-75.438278,0,'2013-07-06 12:44:31',NULL,NULL),(36532,'40858','S','Mozelle','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.987950,-83.390993,0,'2013-07-06 12:44:32',NULL,NULL),(67083,'79607','S','Abilene','A','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.431896,-99.811677,0,'2013-07-06 12:44:34',NULL,NULL),(60053,'71350','S','Hydropolis','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.083712,-92.022496,0,'2013-07-06 12:44:33',NULL,NULL),(4073,'02652','P','North Truro','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.795730,-70.241552,0,'2013-07-06 12:44:30',NULL,NULL),(37166,'41472','S','Lenox','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(27776,'30371','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.762163,-84.424695,0,'2013-07-06 12:44:31',NULL,NULL),(33382,'37214','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.171900,-86.720700,0,'2013-07-06 12:44:32',NULL,NULL),(33157,'37014','S','Arrington','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.864580,-86.664840,0,'2013-07-06 12:44:32',NULL,NULL),(44369,'49786','U','Kincheloe','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.266667,-84.483333,0,'2013-07-06 12:44:32',NULL,NULL),(61528,'72668','S','Peel','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.417830,-92.766644,0,'2013-07-06 12:44:33',NULL,NULL),(28631,'31743','S','De Soto','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.974383,-84.028237,0,'2013-07-06 12:44:32',NULL,NULL),(7829,'07460','S','Hardyston','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(63064,'75232','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.655640,-96.842603,0,'2013-07-06 12:44:33',NULL,NULL),(56107,'64801','S','Belle Center','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(25766,'28589','P','Williston','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.789420,-76.505253,0,'2013-07-06 12:44:31',NULL,NULL),(27107,'29726','S','McConnells','N','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.872034,-81.223083,0,'2013-07-06 12:44:31',NULL,NULL),(12855,'13317','S','Van Deusenville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(8903,'08733','S','Manchester TWP','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(70271,'84526','S','Martin','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(68723,'82081','S','Meriden','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.562155,-104.369259,0,'2013-07-06 12:44:34',NULL,NULL),(64507,'76633','S','China Spring','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.642621,-97.294158,0,'2013-07-06 12:44:34',NULL,NULL),(38169,'43154','S','Stoutsville','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.600098,-82.817282,0,'2013-07-06 12:44:32',NULL,NULL),(46215,'52767','S','Pleasant Valley','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.569175,-90.423855,0,'2013-07-06 12:44:32',NULL,NULL),(41027,'46383','S','Valpo','N','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.489214,-87.074602,0,'2013-07-06 12:44:32',NULL,NULL),(36115,'40222','S','Graymoor-Devondale','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(22084,'23397','P','Isle of Wight','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.853023,-76.721406,0,'2013-07-06 12:44:31',NULL,NULL),(1323,'00735','S','Urb Roosevelt Gdns','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(76769,'95930','S','Clipper Mills','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.524451,-121.230273,0,'2013-07-06 12:44:34',NULL,NULL),(42731,'48009','S','Bham','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.544619,-83.213883,0,'2013-07-06 12:44:32',NULL,NULL),(22889,'24579','S','Naturl Br Sta','A','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.588035,-79.502939,0,'2013-07-06 12:44:31',NULL,NULL),(43502,'48628','S','Hope','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.780241,-84.331596,0,'2013-07-06 12:44:32',NULL,NULL),(45181,'50609','S','Beaman','D','Grundy','19075','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.222729,-92.820110,0,'2013-07-06 12:44:32',NULL,NULL),(35915,'40025','P','Glenview','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.306833,-85.645273,0,'2013-07-06 12:44:32',NULL,NULL),(25437,'28308','S','Pope Army Airfield','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.052500,-78.878611,0,'2013-07-06 12:44:31',NULL,NULL),(26030,'28680','P','Morganton','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.743777,-81.696620,0,'2013-07-06 12:44:31',NULL,NULL),(48674,'55921','S','Caledonia','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.632279,-91.501791,0,'2013-07-06 12:44:33',NULL,NULL),(79568,'99017','S','Lamont','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.193321,-117.800269,0,'2013-07-06 12:44:34',NULL,NULL),(74011,'92118','S','Coronado','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.659560,-117.159480,0,'2013-07-06 12:44:34',NULL,NULL),(37590,'42101','S','Richardsville','A','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.018172,-86.458733,0,'2013-07-06 12:44:32',NULL,NULL),(72429,'89070','U','So Desert Correctional Ctr','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570319,-115.668132,0,'2013-07-06 12:44:34',NULL,NULL),(32171,'35476','S','Nport','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.255087,-87.586136,0,'2013-07-06 12:44:32',NULL,NULL),(29194,'32405','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.203385,-85.660566,0,'2013-07-06 12:44:32',NULL,NULL),(2084,'00921','S','Urb Puerto Nuevo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(24662,'27406','S','South Greensboro','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.021374,-79.767916,0,'2013-07-06 12:44:31',NULL,NULL),(1352,'00736','S','Mans De Los Cedros','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(73427,'91205','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.135443,-118.242580,0,'2013-07-06 12:44:34',NULL,NULL),(68736,'82201','S','Wheatland','D','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031976,-104.976675,0,'2013-07-06 12:44:34',NULL,NULL),(65978,'78299','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425430,-98.486926,0,'2013-07-06 12:44:34',NULL,NULL),(53429,'61857','P','Muncie','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.114015,-87.843950,0,'2013-07-06 12:44:33',NULL,NULL),(20602,'21205','S','Clifton East End','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304502,-76.567527,0,'2013-07-06 12:44:31',NULL,NULL),(74876,'93271','S','Three Rivers','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.446150,-118.889492,0,'2013-07-06 12:44:34',NULL,NULL),(12462,'12976','P','Rainbow Lake','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.489959,-74.121297,0,'2013-07-06 12:44:30',NULL,NULL),(15976,'17032','S','McClellan','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(268,'00641','S','Urb San Martin','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(13824,'14217','S','Tn of Tona','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.972758,-78.876061,0,'2013-07-06 12:44:31',NULL,NULL),(16236,'17078','S','Coffeetown','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299264,-76.586642,0,'2013-07-06 12:44:31',NULL,NULL),(19265,'19952','S','Harrington','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',38.936920,-75.582667,0,'2013-07-06 12:44:31',NULL,NULL),(30535,'33408','S','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(75926,'95014','S','Permanente','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.314123,-122.044411,0,'2013-07-06 12:44:34',NULL,NULL),(75603,'94305','S','Palo Alto','A','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.419371,-122.163685,0,'2013-07-06 12:44:34',NULL,NULL),(58642,'68870','S','Prairie Center','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.784307,-99.160939,0,'2013-07-06 12:44:33',NULL,NULL),(48851,'56069','S','Montgomery','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.436114,-93.587101,0,'2013-07-06 12:44:33',NULL,NULL),(26676,'29403','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.798426,-79.948096,0,'2013-07-06 12:44:31',NULL,NULL),(46110,'52632','S','Summitville','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.472778,-91.448611,0,'2013-07-06 12:44:32',NULL,NULL),(40852,'46226','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.836981,-86.046783,0,'2013-07-06 12:44:32',NULL,NULL),(7811,'07444','S','Pompton Plns','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.965391,-74.307529,0,'2013-07-06 12:44:30',NULL,NULL),(13523,'13815','S','Kings Settlement','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.530787,-75.524876,0,'2013-07-06 12:44:31',NULL,NULL),(14270,'14850','S','Ithaca','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.445573,-76.496428,0,'2013-07-06 12:44:31',NULL,NULL),(48231,'55420','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.835722,-93.275326,0,'2013-07-06 12:44:33',NULL,NULL),(61954,'73167','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460945,-97.520644,0,'2013-07-06 12:44:33',NULL,NULL),(56171,'64874','P','Wheaton','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.765366,-94.056563,0,'2013-07-06 12:44:33',NULL,NULL),(20500,'21065','U','Huntvalley','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.478149,-76.645140,0,'2013-07-06 12:44:31',NULL,NULL),(12631,'13092','S','Summerhill','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.658980,-76.424040,0,'2013-07-06 12:44:30',NULL,NULL),(40305,'45458','S','Sugarcreek Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(40669,'46055','S','McCordsville','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.891661,-85.901929,0,'2013-07-06 12:44:32',NULL,NULL),(74896,'93301','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.384050,-119.008460,0,'2013-07-06 12:44:34',NULL,NULL),(63839,'75974','S','Ramah','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(36646,'41005','S','McVille','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(11568,'12065','S','Clifton Park Center','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.851460,-73.798980,0,'2013-07-06 12:44:30',NULL,NULL),(8129,'07830','S','Califon','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.715880,-74.817513,0,'2013-07-06 12:44:30',NULL,NULL),(46044,'52563','S','Farson','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.182320,-92.284680,0,'2013-07-06 12:44:32',NULL,NULL),(13272,'13652','S','Hermon','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.472545,-75.234487,0,'2013-07-06 12:44:30',NULL,NULL),(77585,'96915','S','Yona','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(73348,'91007','S','Arcadia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.129883,-118.051077,0,'2013-07-06 12:44:34',NULL,NULL),(55696,'64063','S','Unity Village','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(73879,'91943','P','La Mesa','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.777819,-117.010222,0,'2013-07-06 12:44:34',NULL,NULL),(34358,'38602','P','Arkabutla','D','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.697827,-90.008046,0,'2013-07-06 12:44:32',NULL,NULL),(14585,'15220','S','Wabash','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425951,-80.048689,0,'2013-07-06 12:44:31',NULL,NULL),(37435,'41832','S','Carbon Glow','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.160712,-82.994745,0,'2013-07-06 12:44:32',NULL,NULL),(39611,'44881','P','Sulphur Spgs','A','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.869583,-82.881591,0,'2013-07-06 12:44:32',NULL,NULL),(79567,'99016','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.643255,-117.151477,0,'2013-07-06 12:44:34',NULL,NULL),(29715,'32950','S','Valkaria','N','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.985689,-80.589258,0,'2013-07-06 12:44:32',NULL,NULL),(71989,'88029','P','Columbus','D','Luna','35029','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.831886,-107.642376,0,'2013-07-06 12:44:34',NULL,NULL),(67925,'80907','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.881982,-104.814334,0,'2013-07-06 12:44:34',NULL,NULL),(40437,'45717','P','Carbondale','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.379320,-82.270986,0,'2013-07-06 12:44:32',NULL,NULL),(14932,'15555','P','Quecreek','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.091217,-79.079943,0,'2013-07-06 12:44:31',NULL,NULL),(22861,'24550','S','Evington','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.259932,-79.236144,0,'2013-07-06 12:44:31',NULL,NULL),(5426,'04672','P','Salsbury Cove','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.430565,-68.283955,0,'2013-07-06 12:44:30',NULL,NULL),(6226,'05490','P','Underhill Ctr','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.527965,-72.896952,0,'2013-07-06 12:44:30',NULL,NULL),(38371,'43465','S','Walbridge','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.571390,-83.496483,0,'2013-07-06 12:44:32',NULL,NULL),(64708,'76859','S','Menard','D','Menard','48327','Texas','TX','48','0000','325','Central',-6.0,'Y',30.908626,-99.787372,0,'2013-07-06 12:44:34',NULL,NULL),(37806,'42406','S','Corydon','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.727979,-87.694821,0,'2013-07-06 12:44:32',NULL,NULL),(16192,'17070','S','Drexel Hills','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(64141,'76197','U','Bank of America','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.777097,-97.299046,0,'2013-07-06 12:44:34',NULL,NULL),(40393,'45663','S','W Portsmouth','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.749260,-82.987860,0,'2013-07-06 12:44:32',NULL,NULL),(47496,'54758','S','Foster','N','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.576212,-91.220707,0,'2013-07-06 12:44:32',NULL,NULL),(60274,'71447','S','Rock Quarry','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(57668,'67215','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.628626,-97.431951,0,'2013-07-06 12:44:33',NULL,NULL),(49790,'57107','S','Buffalo Ridge','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.565350,-96.796958,0,'2013-07-06 12:44:33',NULL,NULL),(22620,'24225','S','Cleveland','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.982036,-82.136945,0,'2013-07-06 12:44:31',NULL,NULL),(1357,'00736','S','Repto Montellano','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(12778,'13214','S','De Witt','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.036965,-76.073608,0,'2013-07-06 12:44:30',NULL,NULL),(59776,'71202','S','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.481960,-92.080020,0,'2013-07-06 12:44:33',NULL,NULL),(48204,'55403','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.971974,-93.283965,0,'2013-07-06 12:44:33',NULL,NULL),(48759,'55976','S','Pleasant Grove','N','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',43.859369,-92.487834,0,'2013-07-06 12:44:33',NULL,NULL),(17331,'17864','S','McKee Half Fl','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(78484,'98103','S','Greenwood','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.671009,-122.340102,0,'2013-07-06 12:44:34',NULL,NULL),(75551,'94245','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587191,-121.491543,0,'2013-07-06 12:44:34',NULL,NULL),(56573,'65486','S','Iberia','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.094073,-92.298448,0,'2013-07-06 12:44:33',NULL,NULL),(46673,'53718','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.147068,-89.406946,0,'2013-07-06 12:44:32',NULL,NULL),(32567,'36115','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(48173,'55380','S','Maple Lake','A','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.332131,-93.954696,0,'2013-07-06 12:44:33',NULL,NULL),(12785,'13217','P','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.051842,-76.123159,0,'2013-07-06 12:44:30',NULL,NULL),(36301,'40361','S','Paris','D','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.205376,-84.241639,0,'2013-07-06 12:44:32',NULL,NULL),(58256,'68371','S','Henderson','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.785000,-97.783320,0,'2013-07-06 12:44:33',NULL,NULL),(39095,'44231','S','Garrettsville','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.299320,-81.073020,0,'2013-07-06 12:44:32',NULL,NULL),(18338,'19029','S','Tinicum','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868240,-75.294939,0,'2013-07-06 12:44:31',NULL,NULL),(77612,'96944','P','Kosrae','D','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',5.310246,162.962756,0,'2013-07-06 12:44:34',NULL,NULL),(52163,'60454','P','Oak Lawn','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.710601,-87.805343,0,'2013-07-06 12:44:33',NULL,NULL),(6474,'05764','S','Lake St Catherine','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.518045,-73.236985,0,'2013-07-06 12:44:30',NULL,NULL),(24533,'27291','S','Osmond','N','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.416444,-79.191618,0,'2013-07-06 12:44:31',NULL,NULL),(63880,'76011','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.756259,-97.084801,0,'2013-07-06 12:44:34',NULL,NULL),(33132,'36879','S','Waverly','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.785158,-85.532396,0,'2013-07-06 12:44:32',NULL,NULL),(21133,'22102','S','Tysons Corner','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(38064,'43060','S','North Lewisburg','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.219090,-83.569313,0,'2013-07-06 12:44:32',NULL,NULL),(63680,'75860','S','Furney Richardson','N','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.624665,-96.281615,0,'2013-07-06 12:44:34',NULL,NULL),(48124,'55357','S','Medina','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.100321,-93.661093,0,'2013-07-06 12:44:33',NULL,NULL),(80109,'99757','P','Lk Minchumina','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.804795,-152.415256,0,'2013-07-06 12:44:34',NULL,NULL),(77024,'96097','S','Yreka','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.729575,-122.625600,0,'2013-07-06 12:44:34',NULL,NULL),(71269,'86427','P','Fort Mohave','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.017532,-114.584742,0,'2013-07-06 12:44:34',NULL,NULL),(66004,'78349','S','Cruz Calle','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.531404,-98.383724,0,'2013-07-06 12:44:34',NULL,NULL),(51599,'59823','S','Greenough','A','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.877569,-113.629257,0,'2013-07-06 12:44:33',NULL,NULL),(31542,'34602','S','Rolling Acres','N','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.475302,-82.284057,0,'2013-07-06 12:44:32',NULL,NULL),(77525,'96846','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.318332,-157.869521,0,'2013-07-06 12:44:34',NULL,NULL),(6989,'06249','S','Exeter','N','New London','09011','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.627884,-72.237773,0,'2013-07-06 12:44:30',NULL,NULL),(23315,'25208','S','Barrett','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.903787,-81.676067,0,'2013-07-06 12:44:31',NULL,NULL),(47101,'54442','S','Skanawan','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.423722,-89.692568,0,'2013-07-06 12:44:32',NULL,NULL),(69214,'83401','S','Ammon','A','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(64726,'76878','S','Whon','A','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.490380,-99.306940,0,'2013-07-06 12:44:34',NULL,NULL),(11860,'12288','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.728717,-73.847757,0,'2013-07-06 12:44:30',NULL,NULL),(77705,'97049','S','Zigzag','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.369060,-121.922640,0,'2013-07-06 12:44:34',NULL,NULL),(77110,'96145','P','Alpine Meadows','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.174073,-120.155846,0,'2013-07-06 12:44:34',NULL,NULL),(71823,'87575','S','La Puente','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(62853,'75024','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.076641,-96.804029,0,'2013-07-06 12:44:33',NULL,NULL),(19740,'20405','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901076,-77.022171,0,'2013-07-06 12:44:31',NULL,NULL),(15648,'16740','S','Mount Jewett','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.726583,-78.638691,0,'2013-07-06 12:44:31',NULL,NULL),(22544,'24128','S','Newport','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.316078,-80.480491,0,'2013-07-06 12:44:31',NULL,NULL),(61450,'72616','S','Grandview','N','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367020,-93.580140,0,'2013-07-06 12:44:33',NULL,NULL),(56681,'65640','S','Dunnegan','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.704497,-93.522116,0,'2013-07-06 12:44:33',NULL,NULL),(13262,'13648','S','Harrisville','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(18620,'19150','S','Lynnewood Gardens','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.070910,-75.171390,0,'2013-07-06 12:44:31',NULL,NULL),(18636,'19160','P','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.011141,-75.147333,0,'2013-07-06 12:44:31',NULL,NULL),(15591,'16667','S','Osterburg','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.160648,-78.508616,0,'2013-07-06 12:44:31',NULL,NULL),(45987,'52499','U','Aegon USA','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.974943,-91.655103,0,'2013-07-06 12:44:32',NULL,NULL),(40656,'46040','S','Fortville','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.927526,-85.828673,0,'2013-07-06 12:44:32',NULL,NULL),(36122,'40222','S','Thornhill','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(22415,'23974','S','Victoria','D','Lunenburg','51111','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.992629,-78.227515,0,'2013-07-06 12:44:31',NULL,NULL),(27153,'29828','S','Gloverville','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.520944,-81.826713,0,'2013-07-06 12:44:31',NULL,NULL),(80110,'99758','P','Minto','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.041681,-149.644722,0,'2013-07-06 12:44:34',NULL,NULL),(56840,'65810','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.123311,-93.320088,0,'2013-07-06 12:44:33',NULL,NULL),(1968,'00831','P','St John','D','Saint John','78020','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.333472,-64.792955,0,'2013-07-06 12:44:30',NULL,NULL),(41044,'46403','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.590239,-87.276348,0,'2013-07-06 12:44:32',NULL,NULL),(65398,'77560','S','Haukanier','N','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.875851,-94.578420,0,'2013-07-06 12:44:34',NULL,NULL),(58718,'68938','S','Fairfield','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.429297,-98.109807,0,'2013-07-06 12:44:33',NULL,NULL),(37885,'42602','S','Browns Crossroads','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(40269,'45433','S','Wpafb','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(18222,'18964','S','Souderton','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.300323,-75.324550,0,'2013-07-06 12:44:31',NULL,NULL),(11178,'11732','S','East Norwich','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.846511,-73.536189,0,'2013-07-06 12:44:30',NULL,NULL),(34962,'39071','S','Flora','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.543945,-90.295297,0,'2013-07-06 12:44:32',NULL,NULL),(55302,'63532','S','Bevier','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.750077,-92.562520,0,'2013-07-06 12:44:33',NULL,NULL),(33260,'37087','S','Lebanon','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.211615,-86.306808,0,'2013-07-06 12:44:32',NULL,NULL),(24450,'27214','S','Rudd','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(78128,'97527','S','Grants Pass','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.403181,-123.358175,0,'2013-07-06 12:44:34',NULL,NULL),(2793,'00976','S','Urb Entrerios','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(15573,'16651','S','Houtzdale','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.823943,-78.349798,0,'2013-07-06 12:44:31',NULL,NULL),(45639,'51648','S','Percival','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.751649,-95.809619,0,'2013-07-06 12:44:32',NULL,NULL),(36834,'41072','P','Newport','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.079577,-84.480339,0,'2013-07-06 12:44:32',NULL,NULL),(12070,'12545','S','Millbrook','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.769840,-73.664160,0,'2013-07-06 12:44:30',NULL,NULL),(23352,'25262','S','Millwood','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.883965,-81.861594,0,'2013-07-06 12:44:31',NULL,NULL),(70689,'85255','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.678420,-111.806618,0,'2013-07-06 12:44:34',NULL,NULL),(59112,'70146','S','Naval Support Act East Bank','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.033612,-90.041438,0,'2013-07-06 12:44:33',NULL,NULL),(57567,'67052','S','Goddard','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.656893,-97.579974,0,'2013-07-06 12:44:33',NULL,NULL),(27403,'30091','P','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.946415,-84.175009,0,'2013-07-06 12:44:31',NULL,NULL),(9139,'09237','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(75290,'93724','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.725228,-119.794478,0,'2013-07-06 12:44:34',NULL,NULL),(53083,'61525','S','Dunlap','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.843082,-89.645087,0,'2013-07-06 12:44:33',NULL,NULL),(3813,'02293','U','Fidelity Service Company','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358203,-71.061092,0,'2013-07-06 12:44:30',NULL,NULL),(48896,'56118','S','Bingham Lake','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.909110,-95.047383,0,'2013-07-06 12:44:33',NULL,NULL),(41938,'47390','S','Harrisville','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.202822,-84.817856,0,'2013-07-06 12:44:32',NULL,NULL),(60670,'71923','S','Caddo Valley','A','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(41570,'47030','S','Metamora','D','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.425219,-85.136486,0,'2013-07-06 12:44:32',NULL,NULL),(37220,'41535','S','Huddy','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.579269,-82.253429,0,'2013-07-06 12:44:32',NULL,NULL),(4004,'02543','S','Woods Hole','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.526561,-70.667528,0,'2013-07-06 12:44:30',NULL,NULL),(69870,'84095','S','Daybreak','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569297,-111.967229,0,'2013-07-06 12:44:34',NULL,NULL),(70050,'84139','U','Questar Gas Company','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.768936,-111.887445,0,'2013-07-06 12:44:34',NULL,NULL),(38561,'43766','S','New Straitsvl','A','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.614349,-82.280139,0,'2013-07-06 12:44:32',NULL,NULL),(18862,'19443','P','Kulpsville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245647,-75.341502,0,'2013-07-06 12:44:31',NULL,NULL),(50252,'57630','S','Glencross','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.435633,-100.887977,0,'2013-07-06 12:44:33',NULL,NULL),(22414,'23970','S','Union Level','N','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.727549,-78.134748,0,'2013-07-06 12:44:31',NULL,NULL),(4759,'03850','P','Melvin Vlg','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.691873,-71.296061,0,'2013-07-06 12:44:30',NULL,NULL),(47996,'55144','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.925118,-93.048795,0,'2013-07-06 12:44:33',NULL,NULL),(29316,'32536','S','Crestview','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.763215,-86.563528,0,'2013-07-06 12:44:32',NULL,NULL),(22397,'23950','S','La Crosse','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.752222,-78.046389,0,'2013-07-06 12:44:31',NULL,NULL),(76248,'95401','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.452109,-122.761027,0,'2013-07-06 12:44:34',NULL,NULL),(64206,'76259','S','Ponder','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.190172,-97.280414,0,'2013-07-06 12:44:34',NULL,NULL),(31782,'35022','S','Helena','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.342582,-86.962361,0,'2013-07-06 12:44:32',NULL,NULL),(38983,'44131','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(39179,'44314','S','Kenmore','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.042156,-81.557464,0,'2013-07-06 12:44:32',NULL,NULL),(41658,'47144','U','Agricultural Census','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.332730,-85.708400,0,'2013-07-06 12:44:32',NULL,NULL),(70783,'85349','P','San Luis','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.499269,-114.782304,0,'2013-07-06 12:44:34',NULL,NULL),(68679,'82005','S','Cheyenne','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.137080,-104.818020,0,'2013-07-06 12:44:34',NULL,NULL),(50164,'57552','S','Kirley','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(19051,'19542','P','Monocacy Station','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.262469,-75.767703,0,'2013-07-06 12:44:31',NULL,NULL),(7785,'07424','S','Great Notch','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(45403,'51041','S','Middleburg','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.001764,-96.058049,0,'2013-07-06 12:44:32',NULL,NULL),(73602,'91390','S','Santa Clarita','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(3636,'02090','S','Islington','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.216043,-71.204408,0,'2013-07-06 12:44:30',NULL,NULL),(65722,'78026','S','Jourdanton','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.918592,-98.541520,0,'2013-07-06 12:44:34',NULL,NULL),(68511,'81326','S','Hesperus','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.215884,-108.087279,0,'2013-07-06 12:44:34',NULL,NULL),(70190,'84336','S','Snowville','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.839382,-112.595114,0,'2013-07-06 12:44:34',NULL,NULL),(77496,'96828','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.291312,-157.819996,0,'2013-07-06 12:44:34',NULL,NULL),(57439,'66833','S','Bushong','A','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.641500,-96.253620,0,'2013-07-06 12:44:33',NULL,NULL),(54806,'63019','S','Crystal City','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.229875,-90.373397,0,'2013-07-06 12:44:33',NULL,NULL),(1744,'00778','S','Urb Preciosa','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(47015,'54307','P','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.532127,-88.094902,0,'2013-07-06 12:44:32',NULL,NULL),(39404,'44662','S','Justus','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.717968,-81.530814,0,'2013-07-06 12:44:32',NULL,NULL),(36058,'40207','S','Mockingbird Valley','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(32076,'35287','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513903,-86.807366,0,'2013-07-06 12:44:32',NULL,NULL),(5310,'04562','S','Phippsburg','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.771013,-69.811717,0,'2013-07-06 12:44:30',NULL,NULL),(47972,'55126','S','Arden Hills','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(12409,'12935','S','Ellenburg Dep','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.926800,-73.800120,0,'2013-07-06 12:44:30',NULL,NULL),(11676,'12149','S','Richmondville','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.632159,-74.563960,0,'2013-07-06 12:44:30',NULL,NULL),(27557,'30259','S','Moreland','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.275376,-84.749624,0,'2013-07-06 12:44:31',NULL,NULL),(72357,'89021','P','Moapa Valley','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.594627,-114.482251,0,'2013-07-06 12:44:34',NULL,NULL),(70703,'85268','S','Fountain Hills','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.608995,-111.729537,0,'2013-07-06 12:44:34',NULL,NULL),(68192,'81033','P','Crowley','D','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.190478,-103.859733,0,'2013-07-06 12:44:34',NULL,NULL),(57155,'66276','U','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.002659,-94.669998,0,'2013-07-06 12:44:33',NULL,NULL),(68669,'81656','P','Woody Creek','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.269418,-106.863474,0,'2013-07-06 12:44:34',NULL,NULL),(63858,'75979','S','Emilee','N','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.754889,-94.393444,0,'2013-07-06 12:44:34',NULL,NULL),(25754,'28580','S','Snow Hill','D','Greene','37079','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.447755,-77.678735,0,'2013-07-06 12:44:31',NULL,NULL),(36432,'40582','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.139575,-84.473523,0,'2013-07-06 12:44:32',NULL,NULL),(32457,'36026','S','Equality','D','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.803200,-86.079900,0,'2013-07-06 12:44:32',NULL,NULL),(53109,'61539','P','Kingston Mine','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.557947,-89.769951,0,'2013-07-06 12:44:33',NULL,NULL),(35608,'39601','S','Friendship','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(48938,'56161','S','Okabena','D','Jackson','27063','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.713379,-95.345675,0,'2013-07-06 12:44:33',NULL,NULL),(63885,'76013','S','Pantego','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.717191,-97.152038,0,'2013-07-06 12:44:34',NULL,NULL),(60537,'71676','S','Wilmot','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.053808,-91.571053,0,'2013-07-06 12:44:33',NULL,NULL),(44939,'50363','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595159,-93.764976,0,'2013-07-06 12:44:32',NULL,NULL),(42227,'47562','S','Raglesville','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.842918,-86.990039,0,'2013-07-06 12:44:32',NULL,NULL),(41124,'46601','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.672606,-86.251722,0,'2013-07-06 12:44:32',NULL,NULL),(52586,'61008','S','Belvidere','D','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.262789,-88.853441,0,'2013-07-06 12:44:33',NULL,NULL),(33896,'38040','S','Halls','D','Lauderdale','47097','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.875019,-89.394151,0,'2013-07-06 12:44:32',NULL,NULL),(17329,'17864','S','Hoffer','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(68703,'82059','P','Granite Canyon','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.017795,-105.249499,0,'2013-07-06 12:44:34',NULL,NULL),(50275,'57645','S','Morristown','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.882477,-101.699955,0,'2013-07-06 12:44:33',NULL,NULL),(57951,'67749','S','Oberlin','D','Decatur','20039','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.820610,-100.531041,0,'2013-07-06 12:44:33',NULL,NULL),(6143,'05464','S','Smugglers Notch','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663827,-72.783702,0,'2013-07-06 12:44:30',NULL,NULL),(9938,'10154','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(32305,'35750','S','Hazel Green','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.950712,-86.587332,0,'2013-07-06 12:44:32',NULL,NULL),(35870,'39842','S','Dawson','D','Terrell','13273','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.768132,-84.431214,0,'2013-07-06 12:44:32',NULL,NULL),(4584,'03579','S','Wentworths Location','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.775308,-71.175804,0,'2013-07-06 12:44:30',NULL,NULL),(1020,'00718','S','Repto Santiago','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(27365,'30065','P','Mreta','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.047214,-84.442482,0,'2013-07-06 12:44:31',NULL,NULL),(32360,'35893','U','Redstone Fed Credit Union','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.732440,-86.584594,0,'2013-07-06 12:44:32',NULL,NULL),(18470,'19085','S','Ithan','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.036200,-75.349320,0,'2013-07-06 12:44:31',NULL,NULL),(8603,'08234','S','Bargaintown','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(48007,'55166','P','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.965767,-93.081607,0,'2013-07-06 12:44:33',NULL,NULL),(50114,'57501','S','Fairbank','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(5681,'04970','S','Coplin Plt','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(10547,'10998','S','Westtown','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.324124,-74.543313,0,'2013-07-06 12:44:30',NULL,NULL),(75875,'94952','S','Bloomfield','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.244916,-122.659988,0,'2013-07-06 12:44:34',NULL,NULL),(11696,'12158','S','Selkirk','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.551716,-73.817741,0,'2013-07-06 12:44:30',NULL,NULL),(24860,'27640','U','NC Dept Revenue','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.786086,-78.638689,0,'2013-07-06 12:44:31',NULL,NULL),(75562,'94259','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.558715,-121.497522,0,'2013-07-06 12:44:34',NULL,NULL),(67991,'80918','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.915062,-104.773227,0,'2013-07-06 12:44:34',NULL,NULL),(34204,'38343','S','Three Way','A','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.837590,-88.911952,0,'2013-07-06 12:44:32',NULL,NULL),(5293,'04543','S','Damariscotta','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.030927,-69.489468,0,'2013-07-06 12:44:30',NULL,NULL),(42759,'48032','S','Grant Twp','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.173246,-82.593346,0,'2013-07-06 12:44:32',NULL,NULL),(31380,'34215','S','Cortez','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.470889,-82.686173,0,'2013-07-06 12:44:32',NULL,NULL),(34241,'38387','S','Westport','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.889982,-88.297478,0,'2013-07-06 12:44:32',NULL,NULL),(72031,'88054','P','Radium Sprgs','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.641333,-107.073950,0,'2013-07-06 12:44:34',NULL,NULL),(79947,'99627','P','Mc Grath','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.912644,-154.944297,0,'2013-07-06 12:44:34',NULL,NULL),(43531,'48661','S','West Branch','D','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.289024,-84.219010,0,'2013-07-06 12:44:32',NULL,NULL),(24739,'27526','S','Fuquay Varina','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.598540,-78.784320,0,'2013-07-06 12:44:31',NULL,NULL),(32239,'35592','S','Vernon','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.753979,-88.118153,0,'2013-07-06 12:44:32',NULL,NULL),(29549,'32806','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.510504,-81.356954,0,'2013-07-06 12:44:32',NULL,NULL),(67601,'80426','P','Burns','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.882750,-106.965193,0,'2013-07-06 12:44:34',NULL,NULL),(26546,'29206','S','Forest Acres','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(33112,'36861','S','Jacksons Gap','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.882060,-85.825889,0,'2013-07-06 12:44:32',NULL,NULL),(68926,'82901','S','Quealy','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.597550,-109.234183,0,'2013-07-06 12:44:34',NULL,NULL),(64744,'76908','S','Goodfellow AFB','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.387191,-100.562725,0,'2013-07-06 12:44:34',NULL,NULL),(57402,'66761','S','Piqua','D','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.865570,-95.589348,0,'2013-07-06 12:44:33',NULL,NULL),(9237,'09566','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(41272,'46755','S','Allen','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(18716,'19301','S','Paoli','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.039129,-75.489847,0,'2013-07-06 12:44:31',NULL,NULL),(54619,'62916','S','Campbell Hill','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.915585,-89.593551,0,'2013-07-06 12:44:33',NULL,NULL),(36724,'41031','S','Hooktown','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(46520,'53278','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.039450,-87.900295,0,'2013-07-06 12:44:32',NULL,NULL),(875,'00698','S','Villas del Cafetal Ii','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(75478,'94114','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.759122,-122.438712,0,'2013-07-06 12:44:34',NULL,NULL),(46892,'54119','S','Pembine','A','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.620520,-88.145700,0,'2013-07-06 12:44:32',NULL,NULL),(3166,'01267','S','Williamstn','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.699457,-73.210225,0,'2013-07-06 12:44:30',NULL,NULL),(21670,'22948','S','Locust Dale','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.330939,-78.112397,0,'2013-07-06 12:44:31',NULL,NULL),(67501,'80234','S','Westminster','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(63335,'75601','S','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.522353,-94.733035,0,'2013-07-06 12:44:33',NULL,NULL),(62599,'74502','P','McAlester','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.930217,-95.766611,0,'2013-07-06 12:44:33',NULL,NULL),(60656,'71913','S','Lake Hamilton','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.424690,-93.096290,0,'2013-07-06 12:44:33',NULL,NULL),(15185,'15944','S','New Florence','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.330323,-79.081322,0,'2013-07-06 12:44:31',NULL,NULL),(43060,'48189','S','Hamburg Twp','A','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.399875,-83.771630,0,'2013-07-06 12:44:32',NULL,NULL),(42995,'48159','S','Maybee','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.021186,-83.543036,0,'2013-07-06 12:44:32',NULL,NULL),(18420,'19061','S','Linwood','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(74395,'92518','S','Riverside','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.896243,-117.267131,0,'2013-07-06 12:44:34',NULL,NULL),(68105,'80945','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.838745,-104.797322,0,'2013-07-06 12:44:34',NULL,NULL),(67917,'80906','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.791623,-104.825814,0,'2013-07-06 12:44:34',NULL,NULL),(52798,'61275','S','Port Byron','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.598088,-90.317110,0,'2013-07-06 12:44:33',NULL,NULL),(71731,'87532','S','Santa Clara Pueblo','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(31878,'35125','S','Pell City','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573051,-86.276572,0,'2013-07-06 12:44:32',NULL,NULL),(47337,'54566','S','Wabeno','D','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.438000,-88.631280,0,'2013-07-06 12:44:32',NULL,NULL),(8709,'08402','S','Margate City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.330254,-74.506230,0,'2013-07-06 12:44:30',NULL,NULL),(17808,'18407','S','Childs','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(49915,'57314','S','Artesian','D','Sanborn','46111','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.040260,-97.958503,0,'2013-07-06 12:44:33',NULL,NULL),(36999,'41219','S','Redbush','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(10486,'10956','S','Clarkstown','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.144539,-73.996493,0,'2013-07-06 12:44:30',NULL,NULL),(15076,'15746','P','Hillsdale','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.754700,-78.884292,0,'2013-07-06 12:44:31',NULL,NULL),(56954,'66103','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.056699,-94.629221,0,'2013-07-06 12:44:33',NULL,NULL),(76418,'95563','P','Salyer','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.882541,-123.541231,0,'2013-07-06 12:44:34',NULL,NULL),(78476,'98092','S','Auburn','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.283585,-122.128606,0,'2013-07-06 12:44:34',NULL,NULL),(79381,'98672','S','White Salmon','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.771677,-121.478771,0,'2013-07-06 12:44:34',NULL,NULL),(52265,'60525','S','Ind Head Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(63170,'75398','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.765788,-96.856890,0,'2013-07-06 12:44:33',NULL,NULL),(57049,'66210','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(21255,'22303','S','Jefferson Manor','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.794024,-77.074314,0,'2013-07-06 12:44:31',NULL,NULL),(17038,'17747','S','Tylersville','A','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(22665,'24279','S','Pound','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.939099,-82.595500,0,'2013-07-06 12:44:31',NULL,NULL),(6391,'05702','P','Rutland','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.608678,-72.979192,0,'2013-07-06 12:44:30',NULL,NULL),(32616,'36140','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382875,-86.146711,0,'2013-07-06 12:44:32',NULL,NULL),(30031,'33139','S','Venetian Islands','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784853,-80.144731,0,'2013-07-06 12:44:32',NULL,NULL),(68830,'82513','S','Dubois','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.544616,-109.663371,0,'2013-07-06 12:44:34',NULL,NULL),(70754,'85324','S','Rock Springs','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.085943,-112.141600,0,'2013-07-06 12:44:34',NULL,NULL),(15052,'15716','P','Black Lick','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.470582,-79.199693,0,'2013-07-06 12:44:31',NULL,NULL),(20988,'21813','S','Bishopville','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.417940,-75.191460,0,'2013-07-06 12:44:31',NULL,NULL),(11670,'12144','S','Defreestville','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.624600,-73.710120,0,'2013-07-06 12:44:30',NULL,NULL),(7297,'06538','U','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.432208,-72.909280,0,'2013-07-06 12:44:30',NULL,NULL),(39215,'44406','S','Canfield','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.029535,-80.757209,0,'2013-07-06 12:44:32',NULL,NULL),(46210,'52759','S','Montpelier','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.461303,-90.808311,0,'2013-07-06 12:44:32',NULL,NULL),(79686,'99181','S','Valley','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.167585,-117.784374,0,'2013-07-06 12:44:34',NULL,NULL),(73986,'92092','U','Uc Santa Barbara','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.876604,-117.232638,0,'2013-07-06 12:44:34',NULL,NULL),(58357,'68510','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.804463,-96.651746,0,'2013-07-06 12:44:33',NULL,NULL),(58163,'68182','U','Univ Of Ne Omaha','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.254745,-96.009873,0,'2013-07-06 12:44:33',NULL,NULL),(77946,'97348','S','Halsey','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.384368,-123.121631,0,'2013-07-06 12:44:34',NULL,NULL),(72033,'88055','P','Lordsburg','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.867790,-108.723525,0,'2013-07-06 12:44:34',NULL,NULL),(53710,'62237','S','Swanwick','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.198220,-89.593740,0,'2013-07-06 12:44:33',NULL,NULL),(18064,'18704','S','Courtdale','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(5540,'04786','S','Wade','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.786601,-68.147503,0,'2013-07-06 12:44:30',NULL,NULL),(46333,'53085','S','Sheboygan Falls','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.731424,-87.816063,0,'2013-07-06 12:44:32',NULL,NULL),(31101,'33881','S','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.044545,-81.728425,0,'2013-07-06 12:44:32',NULL,NULL),(68341,'81125','S','Center','D','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.779965,-106.095910,0,'2013-07-06 12:44:34',NULL,NULL),(69364,'83554','S','Cooperville','N','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.750001,-116.206388,0,'2013-07-06 12:44:34',NULL,NULL),(65343,'77520','S','McNair','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(64599,'76680','S','Reagan','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.238487,-96.754011,0,'2013-07-06 12:44:34',NULL,NULL),(63045,'75214','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.822865,-96.748359,0,'2013-07-06 12:44:33',NULL,NULL),(14169,'14735','S','Fillmore','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.453300,-78.087607,0,'2013-07-06 12:44:31',NULL,NULL),(4221,'02841','S','Newport','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.528420,-71.310732,0,'2013-07-06 12:44:30',NULL,NULL),(53067,'61520','S','Banner','A','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.516944,-89.908333,0,'2013-07-06 12:44:33',NULL,NULL),(63819,'75972','S','Fords Corner','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(67363,'80112','S','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.575499,-104.861971,0,'2013-07-06 12:44:34',NULL,NULL),(74652,'92836','P','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.875484,-117.903814,0,'2013-07-06 12:44:34',NULL,NULL),(77952,'97358','S','Lyons','D','Linn','41043','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',44.767792,-122.604763,0,'2013-07-06 12:44:34',NULL,NULL),(60377,'71485','S','Timberlake','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.160578,-92.499928,0,'2013-07-06 12:44:33',NULL,NULL),(58558,'68823','S','Burwell','D','Garfield','31071','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.780417,-99.133393,0,'2013-07-06 12:44:33',NULL,NULL),(24017,'26362','S','Mahone','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.211147,-81.050312,0,'2013-07-06 12:44:31',NULL,NULL),(41865,'47357','S','Milton','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.767292,-85.139144,0,'2013-07-06 12:44:32',NULL,NULL),(42133,'47512','S','Indian Crk Stlmt','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772909,-87.307853,0,'2013-07-06 12:44:32',NULL,NULL),(50731,'58384','S','Omemee','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617340,-100.299168,0,'2013-07-06 12:44:33',NULL,NULL),(33415,'37238','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162112,-86.772739,0,'2013-07-06 12:44:32',NULL,NULL),(25474,'28345','S','Hamlet','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.889274,-79.707478,0,'2013-07-06 12:44:31',NULL,NULL),(31714,'34956','S','Indiantown','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.031983,-80.468131,0,'2013-07-06 12:44:32',NULL,NULL),(60362,'71473','S','Hebron','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.067300,-92.422500,0,'2013-07-06 12:44:33',NULL,NULL),(74778,'93111','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.441286,-119.800388,0,'2013-07-06 12:44:34',NULL,NULL),(77084,'96133','S','Topaz','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.635570,-119.547082,0,'2013-07-06 12:44:34',NULL,NULL),(69049,'83228','S','Clifton','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.232150,-112.012326,0,'2013-07-06 12:44:34',NULL,NULL),(61831,'73112','S','Warr Acres','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.519414,-97.575300,0,'2013-07-06 12:44:33',NULL,NULL),(1638,'00771','S','Urb Las Campinas III','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(33505,'37363','S','College Dale','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.087036,-85.060075,0,'2013-07-06 12:44:32',NULL,NULL),(20346,'20857','U','HHS','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.079354,-77.156398,0,'2013-07-06 12:44:31',NULL,NULL),(46332,'53083','S','Sheboygan','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.802340,-87.769800,0,'2013-07-06 12:44:32',NULL,NULL),(43474,'48601','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.405416,-83.900719,0,'2013-07-06 12:44:32',NULL,NULL),(21746,'23038','S','Columbia','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.804145,-78.089610,0,'2013-07-06 12:44:31',NULL,NULL),(1881,'00791','S','Urb Pereyo','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(38437,'43560','S','Sylvania','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.709644,-83.708999,0,'2013-07-06 12:44:32',NULL,NULL),(40767,'46151','S','Martinsville','D','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(50087,'57466','S','Onaka','D','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.201699,-99.451295,0,'2013-07-06 12:44:33',NULL,NULL),(78275,'97862','S','Milton Frwtr','A','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.932608,-118.389207,0,'2013-07-06 12:44:34',NULL,NULL),(71264,'86413','S','Golden Valley','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.220638,-114.219181,0,'2013-07-06 12:44:34',NULL,NULL),(67343,'80106','S','Elbert','D','El Paso','08041','Colorado','CO','08','1720','303/720','Mountain',-7.0,'Y',39.056631,-104.593326,0,'2013-07-06 12:44:34',NULL,NULL),(68683,'82007','S','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.111908,-104.863666,0,'2013-07-06 12:44:34',NULL,NULL),(41041,'46394','S','Whiting','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.679405,-87.496209,0,'2013-07-06 12:44:32',NULL,NULL),(39139,'44275','S','River Corners','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.101074,-82.102809,0,'2013-07-06 12:44:32',NULL,NULL),(46553,'53502','S','Albany','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.730426,-89.443626,0,'2013-07-06 12:44:32',NULL,NULL),(50502,'58064','S','Page','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.142437,-97.615224,0,'2013-07-06 12:44:33',NULL,NULL),(10096,'10242','P','Bar Code Church Street','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715181,-74.009474,0,'2013-07-06 12:44:30',NULL,NULL),(7179,'06460','S','Milford','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.232682,-73.061948,0,'2013-07-06 12:44:30',NULL,NULL),(74421,'92555','S','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.915796,-117.163893,0,'2013-07-06 12:44:34',NULL,NULL),(50414,'57785','S','Clough','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(74269,'92347','S','Hinkley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.938977,-117.196307,0,'2013-07-06 12:44:34',NULL,NULL),(28870,'32118','S','Dayt Bch Sh','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.207209,-80.999801,0,'2013-07-06 12:44:32',NULL,NULL),(30767,'33573','S','Sun City Center','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.718176,-82.364372,0,'2013-07-06 12:44:32',NULL,NULL),(244,'00637','S','Parc Susua','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(21877,'23168','S','Toano','D','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.394198,-76.825905,0,'2013-07-06 12:44:31',NULL,NULL),(24413,'27116','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.097867,-80.244547,0,'2013-07-06 12:44:31',NULL,NULL),(77453,'96812','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304962,-157.861303,0,'2013-07-06 12:44:34',NULL,NULL),(73275,'90734','P','San Pedro','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.756107,-118.306370,0,'2013-07-06 12:44:34',NULL,NULL),(25948,'28657','S','Cranberry Gap','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(14863,'15459','S','Markleysburg','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.767494,-79.454381,0,'2013-07-06 12:44:31',NULL,NULL),(60672,'71923','S','Degray','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(60641,'71902','P','Hot Springs National','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.502350,-93.057544,0,'2013-07-06 12:44:33',NULL,NULL),(57059,'66212','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955997,-94.682048,0,'2013-07-06 12:44:33',NULL,NULL),(2558,'00959','S','Urb Casa Linda CT','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(47140,'54457','S','Nekoosa','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.251920,-89.861040,0,'2013-07-06 12:44:32',NULL,NULL),(24930,'27813','P','Black Creek','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.655977,-77.939568,0,'2013-07-06 12:44:31',NULL,NULL),(77176,'96283','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(57465,'66858','S','Lincolnville','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.485260,-96.957900,0,'2013-07-06 12:44:33',NULL,NULL),(8073,'07753','S','Neptune City','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(30738,'33542','S','Zephyrhills','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.231487,-82.166188,0,'2013-07-06 12:44:32',NULL,NULL),(40142,'45343','P','Miamisburg','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636393,-84.267253,0,'2013-07-06 12:44:32',NULL,NULL),(58876,'69156','S','Potter','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.220036,-103.314887,0,'2013-07-06 12:44:33',NULL,NULL),(30434,'33330','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(36640,'41005','S','Belleview','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(45316,'50846','S','Fontanelle','D','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.293490,-94.562779,0,'2013-07-06 12:44:32',NULL,NULL),(46825,'54011','S','Moeville','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.735213,-92.480939,0,'2013-07-06 12:44:32',NULL,NULL),(2514,'00957','S','Urb Miraflores','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(45333,'50860','S','Redding','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.605151,-94.356644,0,'2013-07-06 12:44:32',NULL,NULL),(24207,'26690','S','Jodie','A','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.277039,-81.070532,0,'2013-07-06 12:44:31',NULL,NULL),(75373,'93930','S','King City','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.202389,-121.137276,0,'2013-07-06 12:44:34',NULL,NULL),(57989,'67850','S','Healy','D','Lane','20101','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.483146,-100.613523,0,'2013-07-06 12:44:33',NULL,NULL),(13285,'13659','S','Worth','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.791138,-75.824986,0,'2013-07-06 12:44:30',NULL,NULL),(71335,'86508','P','Houck','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.350000,-109.050000,0,'2013-07-06 12:44:34',NULL,NULL),(68889,'82716','S','Gillette','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.317614,-105.505943,0,'2013-07-06 12:44:34',NULL,NULL),(55367,'63566','S','North Salem','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.041679,-92.929334,0,'2013-07-06 12:44:33',NULL,NULL),(32879,'36527','S','Timber Creek','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.682370,-87.868223,0,'2013-07-06 12:44:32',NULL,NULL),(36231,'40290','P','Shared Firm Zip','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.201276,-85.698130,0,'2013-07-06 12:44:32',NULL,NULL),(3384,'01604','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.254072,-71.773068,0,'2013-07-06 12:44:30',NULL,NULL),(1298,'00730','S','Urb Nuevo Mameyes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(78659,'98231','P','Blaine','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.989956,-122.761204,0,'2013-07-06 12:44:34',NULL,NULL),(66945,'79366','S','Ransom Canyon','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.533874,-101.681093,0,'2013-07-06 12:44:34',NULL,NULL),(65042,'77331','S','Stephen Creek','N','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.598380,-95.114520,0,'2013-07-06 12:44:34',NULL,NULL),(37098,'41339','S','Wolverine','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(77211,'96378','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(63518,'75754','S','Ben Wheeler','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.414520,-95.649120,0,'2013-07-06 12:44:33',NULL,NULL),(34441,'38649','P','Mt Pleasant','A','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.737265,-89.500427,0,'2013-07-06 12:44:32',NULL,NULL),(19623,'20242','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.960013,-77.043563,0,'2013-07-06 12:44:31',NULL,NULL),(8432,'08080','S','Barnsboro','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.749340,-75.096660,0,'2013-07-06 12:44:30',NULL,NULL),(47802,'55051','S','Quamba','N','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.915556,-93.173056,0,'2013-07-06 12:44:33',NULL,NULL),(29867,'33040','S','Key West','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(33700,'37760','S','Jefferson Cty','A','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.119161,-83.493766,0,'2013-07-06 12:44:32',NULL,NULL),(45459,'51243','S','Little Rock','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.467838,-95.917546,0,'2013-07-06 12:44:32',NULL,NULL),(59286,'70467','P','Angie','A','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.893611,-89.829444,0,'2013-07-06 12:44:33',NULL,NULL),(79213,'98539','P','Doty','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.634783,-123.277844,0,'2013-07-06 12:44:34',NULL,NULL),(73542,'91354','S','Valencia','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.445120,-118.546414,0,'2013-07-06 12:44:34',NULL,NULL),(19549,'20196','U','Sprint','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.926126,-77.396695,0,'2013-07-06 12:44:31',NULL,NULL),(16042,'17044','S','Lewistown Jun','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(47561,'54837','S','Lewis','A','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.703572,-92.475946,0,'2013-07-06 12:44:32',NULL,NULL),(36719,'41031','S','Broadwell','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(31204,'33948','S','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.983322,-82.144991,0,'2013-07-06 12:44:32',NULL,NULL),(16512,'17266','S','Walnut Bottom','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.104396,-77.525358,0,'2013-07-06 12:44:31',NULL,NULL),(27991,'30581','P','Wiley','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.800137,-83.447870,0,'2013-07-06 12:44:31',NULL,NULL),(18587,'19134','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.994605,-75.113258,0,'2013-07-06 12:44:31',NULL,NULL),(6174,'05473','S','The Hollow','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(37524,'42047','S','Hampton','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332744,-88.400437,0,'2013-07-06 12:44:32',NULL,NULL),(38908,'44118','S','Shaker Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(3034,'01096','S','Williamsburg','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.399296,-72.749011,0,'2013-07-06 12:44:30',NULL,NULL),(1913,'00795','S','Ext Las Marias','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(53259,'61704','S','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.479447,-88.950844,0,'2013-07-06 12:44:33',NULL,NULL),(78998,'98382','S','Gardiner','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(55675,'64050','S','Sugar Creek','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.094148,-94.399135,0,'2013-07-06 12:44:33',NULL,NULL),(45903,'52315','S','Newhall','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.993889,-91.967551,0,'2013-07-06 12:44:32',NULL,NULL),(4118,'02724','S','Fall River','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.683999,-71.177015,0,'2013-07-06 12:44:30',NULL,NULL),(39301,'44506','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.098383,-80.625881,0,'2013-07-06 12:44:32',NULL,NULL),(22672,'24293','S','Wise','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.975068,-82.570844,0,'2013-07-06 12:44:31',NULL,NULL),(66274,'78580','S','Porfirio','N','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.481214,-97.783570,0,'2013-07-06 12:44:34',NULL,NULL),(41549,'47012','S','Saint Leon','A','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.416040,-84.981180,0,'2013-07-06 12:44:32',NULL,NULL),(39526,'44824','S','Castalia','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.381570,-82.799917,0,'2013-07-06 12:44:32',NULL,NULL),(46670,'53716','S','Monona','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.065869,-89.312254,0,'2013-07-06 12:44:32',NULL,NULL),(51788,'60045','S','Lincolnshire Woods','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.233956,-87.863856,0,'2013-07-06 12:44:33',NULL,NULL),(17418,'17921','S','Mowry','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(74807,'93207','S','California Hot Springs','D','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.907677,-118.723924,0,'2013-07-06 12:44:34',NULL,NULL),(52749,'61244','S','Babcock','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(79916,'99603','S','Port Graham','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(72668,'89436','S','Sparks','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.645257,-119.698716,0,'2013-07-06 12:44:34',NULL,NULL),(59102,'70131','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.917334,-89.993719,0,'2013-07-06 12:44:33',NULL,NULL),(64669,'76821','S','Blanton','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.734120,-99.961500,0,'2013-07-06 12:44:34',NULL,NULL),(35228,'39309','U','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.537503,-88.567935,0,'2013-07-06 12:44:32',NULL,NULL),(35958,'40065','S','Shelbyville','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.209503,-85.229057,0,'2013-07-06 12:44:32',NULL,NULL),(39382,'44650','P','Maximo','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.876028,-81.174132,0,'2013-07-06 12:44:32',NULL,NULL),(49310,'56540','S','Rindal','N','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.524800,-96.240660,0,'2013-07-06 12:44:33',NULL,NULL),(67954,'80912','S','Schriever Air Force Base','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(12974,'13367','S','West Lowville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(39384,'44652','P','Middlebranch','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.900119,-81.330080,0,'2013-07-06 12:44:32',NULL,NULL),(78318,'97911','S','Beulah','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.745601,-118.076327,0,'2013-07-06 12:44:34',NULL,NULL),(50707,'58366','S','Fonda','N','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.654300,-99.890100,0,'2013-07-06 12:44:33',NULL,NULL),(15923,'17020','S','Cove','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(17657,'18080','S','Slatington','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.734472,-75.615565,0,'2013-07-06 12:44:31',NULL,NULL),(34216,'38358','S','Milan','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.923931,-88.765013,0,'2013-07-06 12:44:32',NULL,NULL),(32952,'36580','S','Summerdale','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.478850,-87.720472,0,'2013-07-06 12:44:32',NULL,NULL),(29533,'32791','P','Longwood','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.703312,-81.419952,0,'2013-07-06 12:44:32',NULL,NULL),(18604,'19142','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.923516,-75.233199,0,'2013-07-06 12:44:31',NULL,NULL),(39674,'45014','S','Hamilton','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.334440,-84.562260,0,'2013-07-06 12:44:32',NULL,NULL),(60899,'72070','S','Stony Point','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.045804,-92.690848,0,'2013-07-06 12:44:33',NULL,NULL),(61113,'72149','U','Harding University','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.247481,-91.726679,0,'2013-07-06 12:44:33',NULL,NULL),(61420,'72567','S','Pleasant Grove','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842601,-91.925046,0,'2013-07-06 12:44:33',NULL,NULL),(75404,'94016','P','Daly City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.707328,-122.454928,0,'2013-07-06 12:44:34',NULL,NULL),(8397,'08062','S','S Harrisn Twp','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722021,-75.221337,0,'2013-07-06 12:44:30',NULL,NULL),(12184,'12769','P','Phillipsport','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.649429,-74.439099,0,'2013-07-06 12:44:30',NULL,NULL),(27664,'30327','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.865889,-84.425245,0,'2013-07-06 12:44:31',NULL,NULL),(37989,'42743','S','Greensburg','D','Green','21087','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.242155,-85.509500,0,'2013-07-06 12:44:32',NULL,NULL),(25354,'28229','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.188824,-80.743635,0,'2013-07-06 12:44:31',NULL,NULL),(59865,'71261','S','Mer Rouge','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.766146,-91.751212,0,'2013-07-06 12:44:33',NULL,NULL),(72460,'89118','S','Arden','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.080056,-115.213988,0,'2013-07-06 12:44:34',NULL,NULL),(63679,'75860','S','Cotton Gin','N','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.624665,-96.281615,0,'2013-07-06 12:44:34',NULL,NULL),(59724,'71108','S','Sunset Acres','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.441723,-93.787148,0,'2013-07-06 12:44:33',NULL,NULL),(22627,'24237','S','Trammel','A','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.040485,-82.275198,0,'2013-07-06 12:44:31',NULL,NULL),(22024,'23291','U','Suntrust Bank','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544706,-77.445183,0,'2013-07-06 12:44:31',NULL,NULL),(50031,'57427','S','Bath','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.457975,-98.329526,0,'2013-07-06 12:44:33',NULL,NULL),(49749,'57061','P','Lake Sinai','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.243038,-97.067738,0,'2013-07-06 12:44:33',NULL,NULL),(233,'00627','S','Urb Las Veredas','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(41056,'46411','P','Merrillville','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.471370,-87.376351,0,'2013-07-06 12:44:32',NULL,NULL),(27472,'30145','S','Euharlee','A','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.236623,-84.966540,0,'2013-07-06 12:44:31',NULL,NULL),(14612,'15227','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426740,-79.969140,0,'2013-07-06 12:44:31',NULL,NULL),(31308,'34105','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.185362,-81.764078,0,'2013-07-06 12:44:32',NULL,NULL),(986,'00716','S','VISTA Point','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(26989,'29623','P','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.519837,-82.717055,0,'2013-07-06 12:44:31',NULL,NULL),(18152,'18845','S','Stevensville','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.770795,-76.170281,0,'2013-07-06 12:44:31',NULL,NULL),(24414,'27117','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.077833,-80.238740,0,'2013-07-06 12:44:31',NULL,NULL),(60184,'71417','S','Colfax','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(57745,'67436','S','Delphos','D','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.275110,-97.762963,0,'2013-07-06 12:44:33',NULL,NULL),(37689,'42234','S','Herman','N','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.695643,-87.176930,0,'2013-07-06 12:44:32',NULL,NULL),(49323,'56550','S','Hendrum','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.260273,-96.809725,0,'2013-07-06 12:44:33',NULL,NULL),(15531,'16553','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.126405,-80.082939,0,'2013-07-06 12:44:31',NULL,NULL),(72692,'89446','P','Winnemucca','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.967126,-117.728697,0,'2013-07-06 12:44:34',NULL,NULL),(69390,'83612','S','Fruitvale','A','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(18902,'19475','S','Spring City','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.173990,-75.572077,0,'2013-07-06 12:44:31',NULL,NULL),(9747,'10101','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(40988,'46355','P','Leroy','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.363967,-87.267208,0,'2013-07-06 12:44:32',NULL,NULL),(24987,'27857','S','Oak City','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.949714,-77.257056,0,'2013-07-06 12:44:31',NULL,NULL),(60291,'71454','S','Crews','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(53453,'61911','S','Cadwell','A','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.703333,-88.391111,0,'2013-07-06 12:44:33',NULL,NULL),(49193,'56443','S','Cushing','D','Morrison','27097','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.196146,-94.570357,0,'2013-07-06 12:44:33',NULL,NULL),(75627,'94509','S','Antioch','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.995169,-121.803953,0,'2013-07-06 12:44:34',NULL,NULL),(52986,'61437','S','Gladstone','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.846849,-90.982709,0,'2013-07-06 12:44:33',NULL,NULL),(51202,'59035','P','Yellowtail','A','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.294259,-107.822552,0,'2013-07-06 12:44:33',NULL,NULL),(50076,'57451','S','Mina','A','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.448625,-99.029411,0,'2013-07-06 12:44:33',NULL,NULL),(2134,'00924','S','Urb Delicias','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(23821,'26075','P','Windsor Heights','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.191404,-80.665424,0,'2013-07-06 12:44:31',NULL,NULL),(36780,'41044','S','Germantown','D','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.624615,-83.978515,0,'2013-07-06 12:44:32',NULL,NULL),(10909,'11428','S','Bellerose Manor','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(58344,'68467','S','York','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.871762,-97.587892,0,'2013-07-06 12:44:33',NULL,NULL),(41811,'47331','S','Lyonsville','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(7823,'07457','S','Riverdale','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.992890,-74.311301,0,'2013-07-06 12:44:30',NULL,NULL),(40961,'46312','S','East Chicago','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.636175,-87.456737,0,'2013-07-06 12:44:32',NULL,NULL),(39482,'44721','S','N Canton','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.882563,-81.346759,0,'2013-07-06 12:44:32',NULL,NULL),(6478,'05765','S','Proctor','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.657570,-73.034159,0,'2013-07-06 12:44:30',NULL,NULL),(59614,'71028','S','Sailes','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.518320,-93.070980,0,'2013-07-06 12:44:33',NULL,NULL),(19818,'20456','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898454,-77.044445,0,'2013-07-06 12:44:31',NULL,NULL),(38612,'43906','S','Bellaire','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.017876,-80.757949,0,'2013-07-06 12:44:32',NULL,NULL),(2524,'00957','S','Urb Santa Elena','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(45294,'50707','S','Raymar','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.482880,-92.277060,0,'2013-07-06 12:44:32',NULL,NULL),(26313,'29040','S','Woodrow','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.002009,-80.482959,0,'2013-07-06 12:44:31',NULL,NULL),(13278,'13656','S','Lafargeville','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.191020,-75.955560,0,'2013-07-06 12:44:30',NULL,NULL),(5609,'04935','P','East Vassalboro','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.449774,-69.608359,0,'2013-07-06 12:44:30',NULL,NULL),(44105,'49503','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963193,-85.659686,0,'2013-07-06 12:44:32',NULL,NULL),(9781,'10106','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(7656,'07082','S','Towaco','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.926548,-74.344404,0,'2013-07-06 12:44:30',NULL,NULL),(26395,'29105','S','Jones Crossroads','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.759336,-81.558390,0,'2013-07-06 12:44:31',NULL,NULL),(26298,'29031','S','Carlisle','D','Union','45087','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.683284,-81.636507,0,'2013-07-06 12:44:31',NULL,NULL),(32961,'36585','S','Wagarville','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.392178,-88.062461,0,'2013-07-06 12:44:32',NULL,NULL),(35933,'40047','S','Mt Washington','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.044170,-85.555572,0,'2013-07-06 12:44:32',NULL,NULL),(51449,'59479','S','Windham','N','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.143920,-110.170380,0,'2013-07-06 12:44:33',NULL,NULL),(52251,'60518','S','Harding','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.592720,-88.892220,0,'2013-07-06 12:44:33',NULL,NULL),(68689,'82010','U','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.103913,-104.783119,0,'2013-07-06 12:44:34',NULL,NULL),(71855,'87701','S','West Las Vegas','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.590200,-105.198120,0,'2013-07-06 12:44:34',NULL,NULL),(74892,'93287','S','Woody','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.702454,-118.816260,0,'2013-07-06 12:44:34',NULL,NULL),(68808,'82435','S','Clark','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(16637,'17339','S','Alpine','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.126080,-76.876560,0,'2013-07-06 12:44:31',NULL,NULL),(18088,'18706','S','Wilkes Barre Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(42557,'47872','S','Rockville','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(3149,'01258','S','S Egremont','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.107580,-73.465080,0,'2013-07-06 12:44:30',NULL,NULL),(47489,'54754','S','Merrillan','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.446740,-90.818160,0,'2013-07-06 12:44:32',NULL,NULL),(68397,'81152','S','San Luis','D','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(60295,'71454','S','Jowers','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(9767,'10104','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(35256,'39348','S','Paulding','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.009581,-89.079164,0,'2013-07-06 12:44:32',NULL,NULL),(43335,'48367','S','Leonard','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.844709,-83.140674,0,'2013-07-06 12:44:32',NULL,NULL),(14817,'15422','P','Chestnut Rdg','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.978300,-79.810140,0,'2013-07-06 12:44:31',NULL,NULL),(915,'00707','S','Maunabo','D','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(19285,'19970','S','Millville','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.555449,-75.108954,0,'2013-07-06 12:44:31',NULL,NULL),(55315,'63539','S','Ethel','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.930787,-92.773951,0,'2013-07-06 12:44:33',NULL,NULL),(79945,'99625','P','Levelock','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.817510,-154.105390,0,'2013-07-06 12:44:34',NULL,NULL),(1851,'00791','S','Bda Praa','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(75146,'93561','S','Golden Hills','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(77303,'96670','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(9522,'10018','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(24064,'26431','S','Peora','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(14665,'15239','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.479721,-79.749820,0,'2013-07-06 12:44:31',NULL,NULL),(33788,'37878','S','Tallassee','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.568988,-83.981124,0,'2013-07-06 12:44:32',NULL,NULL),(43241,'48316','S','Utica','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.680668,-83.052212,0,'2013-07-06 12:44:32',NULL,NULL),(7920,'07640','S','Harrington Pk','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.991196,-73.980288,0,'2013-07-06 12:44:30',NULL,NULL),(14827,'15427','S','Daisytown','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.073433,-79.969493,0,'2013-07-06 12:44:31',NULL,NULL),(57203,'66429','S','Grantville','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.094005,-95.527752,0,'2013-07-06 12:44:33',NULL,NULL),(73703,'91608','S','Universal City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140376,-118.354334,0,'2013-07-06 12:44:34',NULL,NULL),(73914,'92021','S','Bostonia','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.818710,-116.901089,0,'2013-07-06 12:44:34',NULL,NULL),(70739,'85309','S','Gbafaf','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538316,-112.370171,0,'2013-07-06 12:44:34',NULL,NULL),(60742,'71966','P','Pine Ridge','A','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.585833,-93.910000,0,'2013-07-06 12:44:33',NULL,NULL),(17714,'18235','S','Lehighton','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.843037,-75.694426,0,'2013-07-06 12:44:31',NULL,NULL),(32130,'35446','S','Romulus','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.272100,-87.734160,0,'2013-07-06 12:44:32',NULL,NULL),(32302,'35747','S','Grant','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.505027,-86.269107,0,'2013-07-06 12:44:32',NULL,NULL),(34004,'38120','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.122753,-89.861988,0,'2013-07-06 12:44:32',NULL,NULL),(34679,'38824','S','Graham','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(22297,'23822','P','Ammon','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.161452,-77.585170,0,'2013-07-06 12:44:31',NULL,NULL),(4580,'03576','S','Dixville','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.892390,-71.498526,0,'2013-07-06 12:44:30',NULL,NULL),(40908,'46260','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892649,-86.180844,0,'2013-07-06 12:44:32',NULL,NULL),(40798,'46175','S','Russellville','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.823183,-86.955674,0,'2013-07-06 12:44:32',NULL,NULL),(16496,'17257','S','Stoughstown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(45149,'50585','S','Cornell','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.905400,-95.145300,0,'2013-07-06 12:44:32',NULL,NULL),(77514,'96840','U','Hawaiian Electric Company','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306502,-157.860814,0,'2013-07-06 12:44:34',NULL,NULL),(41860,'47355','S','Carlos City','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(38263,'43310','S','Belle Center','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.506954,-83.789570,0,'2013-07-06 12:44:32',NULL,NULL),(35984,'40119','S','Falls of Rough','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.587960,-86.493600,0,'2013-07-06 12:44:32',NULL,NULL),(60153,'71378','S','Holly Grove','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.971417,-91.657424,0,'2013-07-06 12:44:33',NULL,NULL),(52043,'60192','S','Hoffman Estates','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.073812,-88.106821,0,'2013-07-06 12:44:33',NULL,NULL),(141,'00617','S','Ext Est De Imbery','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(8831,'08628','S','Ewing Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.273620,-74.817480,0,'2013-07-06 12:44:30',NULL,NULL),(40529,'45832','S','Convoy','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.918978,-84.703398,0,'2013-07-06 12:44:32',NULL,NULL),(7130,'06387','P','West Wauregan','N','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.743607,-71.911848,0,'2013-07-06 12:44:30',NULL,NULL),(40801,'46181','S','Peoga','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.365002,-86.183378,0,'2013-07-06 12:44:32',NULL,NULL),(69222,'83401','S','New Sweden','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(1372,'00736','S','Urb San Cristobal','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(13487,'13801','S','Mc Donough','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.517672,-75.776919,0,'2013-07-06 12:44:31',NULL,NULL),(59824,'71235','S','Corinth','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.712180,-92.656020,0,'2013-07-06 12:44:33',NULL,NULL),(55193,'63379','S','Troy','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.005640,-90.962460,0,'2013-07-06 12:44:33',NULL,NULL),(29672,'32919','U','Harris Corp','N','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.077407,-80.631614,0,'2013-07-06 12:44:32',NULL,NULL),(24531,'27291','S','Frogsboro','N','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.416444,-79.191618,0,'2013-07-06 12:44:31',NULL,NULL),(1580,'00767','S','Villa El Recreo','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(17268,'17843','S','Beaver Springs','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.761720,-77.256740,0,'2013-07-06 12:44:31',NULL,NULL),(4251,'02878','S','Tiverton','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.615063,-71.168688,0,'2013-07-06 12:44:30',NULL,NULL),(4369,'03073','P','N Salem','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.835016,-71.224246,0,'2013-07-06 12:44:30',NULL,NULL),(49114,'56352','S','Melrose','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.652875,-94.805558,0,'2013-07-06 12:44:33',NULL,NULL),(74913,'93383','P','Pumpkin Center','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.264987,-119.031953,0,'2013-07-06 12:44:34',NULL,NULL),(35293,'39401','S','Lux','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(4731,'03830','S','East Wakefield','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.568056,-71.030556,0,'2013-07-06 12:44:30',NULL,NULL),(8781,'08553','S','Rocky Hill','D','Somerset','34035','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.411503,-74.644626,0,'2013-07-06 12:44:30',NULL,NULL),(77746,'97089','S','Boring','A','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.422127,-122.449928,0,'2013-07-06 12:44:34',NULL,NULL),(73318,'90822','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.831262,-118.238192,0,'2013-07-06 12:44:34',NULL,NULL),(57872,'67583','S','Turon','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.807408,-98.427406,0,'2013-07-06 12:44:33',NULL,NULL),(48697,'55936','S','Frankford','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.704937,-92.570979,0,'2013-07-06 12:44:33',NULL,NULL),(77233,'96517','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(57491,'66938','S','Clyde','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.593388,-97.396828,0,'2013-07-06 12:44:33',NULL,NULL),(6035,'05405','U','Univ of Vermont','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.477327,-73.203176,0,'2013-07-06 12:44:30',NULL,NULL),(19458,'20129','S','Paeonian Spgs','A','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.156021,-77.597753,0,'2013-07-06 12:44:31',NULL,NULL),(59726,'71109','S','Flournoy','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.465400,-93.814020,0,'2013-07-06 12:44:33',NULL,NULL),(53506,'62015','S','Butler','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.221811,-89.534923,0,'2013-07-06 12:44:33',NULL,NULL),(15638,'16729','S','Duke Center','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.952283,-78.505999,0,'2013-07-06 12:44:31',NULL,NULL),(25475,'28347','S','Hoffman','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.043068,-79.558659,0,'2013-07-06 12:44:31',NULL,NULL),(5302,'04551','S','Bremen','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.008174,-69.437857,0,'2013-07-06 12:44:30',NULL,NULL),(12499,'13021','S','Auburn','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(21778,'23065','S','Gum Spring','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.802864,-77.934501,0,'2013-07-06 12:44:31',NULL,NULL),(45352,'50982','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582732,-93.639236,0,'2013-07-06 12:44:32',NULL,NULL),(73885,'91950','S','Lincoln Acres','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.668650,-117.091284,0,'2013-07-06 12:44:34',NULL,NULL),(59997,'71329','P','Rodoc','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.930210,-91.947325,0,'2013-07-06 12:44:33',NULL,NULL),(13328,'13681','S','Richville','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.412057,-75.390018,0,'2013-07-06 12:44:30',NULL,NULL),(27228,'29918','S','Nixville','N','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.744520,-81.240120,0,'2013-07-06 12:44:31',NULL,NULL),(35712,'39667','S','Tylertown','D','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(48425,'55607','S','Isabella','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.629215,-91.392801,0,'2013-07-06 12:44:33',NULL,NULL),(46219,'52771','S','Clinton','A','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.011516,-90.244984,0,'2013-07-06 12:44:32',NULL,NULL),(309,'00646','S','Urb Monte Verde','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(60165,'71406','S','Belmont','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.709761,-93.498938,0,'2013-07-06 12:44:33',NULL,NULL),(28404,'31316','S','Ludowici','D','Long','13183','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.730688,-81.735664,0,'2013-07-06 12:44:32',NULL,NULL),(3548,'01929','S','Essex','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.630853,-70.783172,0,'2013-07-06 12:44:30',NULL,NULL),(10721,'11251','U','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702428,-73.967410,0,'2013-07-06 12:44:30',NULL,NULL),(61993,'73402','P','Ardmore','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.166953,-97.105573,0,'2013-07-06 12:44:33',NULL,NULL),(20387,'20891','P','Kensington','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.026282,-77.075436,0,'2013-07-06 12:44:31',NULL,NULL),(69426,'83635','P','McCall','A','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.911111,-116.097778,0,'2013-07-06 12:44:34',NULL,NULL),(50584,'58233','S','Inkster','A','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.237188,-97.447403,0,'2013-07-06 12:44:33',NULL,NULL),(30635,'33445','S','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.461329,-80.102797,0,'2013-07-06 12:44:32',NULL,NULL),(33898,'38041','S','Henning','D','Lauderdale','47097','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.673919,-89.570485,0,'2013-07-06 12:44:32',NULL,NULL),(27692,'30338','S','Dunwoody','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(77923,'97324','S','Alsea','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.366223,-123.614824,0,'2013-07-06 12:44:34',NULL,NULL),(27934,'30523','S','Clarkesville','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.613734,-83.520947,0,'2013-07-06 12:44:31',NULL,NULL),(12056,'12533','S','Hopewell','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.573590,-73.796075,0,'2013-07-06 12:44:30',NULL,NULL),(19883,'20533','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904566,-77.031907,0,'2013-07-06 12:44:31',NULL,NULL),(47204,'54489','S','Vesper','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.461390,-89.993344,0,'2013-07-06 12:44:32',NULL,NULL),(56265,'65063','S','New Bloomfield','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.748060,-92.080440,0,'2013-07-06 12:44:33',NULL,NULL),(51814,'60050','S','Prairie Grove','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(38188,'43201','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.991350,-83.001104,0,'2013-07-06 12:44:32',NULL,NULL),(40612,'45897','S','Williamstown','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.833565,-83.648163,0,'2013-07-06 12:44:32',NULL,NULL),(55309,'63535','S','Chariton','N','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.570519,-92.620601,0,'2013-07-06 12:44:33',NULL,NULL),(2286,'00926','S','Villa Hucar','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(4663,'03773','S','Croydon','A','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.369645,-72.158576,0,'2013-07-06 12:44:30',NULL,NULL),(5902,'05158','S','Westminster','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.076656,-72.453377,0,'2013-07-06 12:44:30',NULL,NULL),(32873,'36523','S','Heron Bay','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.387102,-88.167787,0,'2013-07-06 12:44:32',NULL,NULL),(28852,'32095','S','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.916697,-81.339048,0,'2013-07-06 12:44:32',NULL,NULL),(10788,'11369','S','East Elmhurst','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.765278,-73.817778,0,'2013-07-06 12:44:30',NULL,NULL),(61734,'73027','S','Coyle','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.905758,-97.219176,0,'2013-07-06 12:44:33',NULL,NULL),(75864,'94945','S','Black Point','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.124448,-122.550509,0,'2013-07-06 12:44:34',NULL,NULL),(72755,'89511','S','Galena','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.382155,-119.751830,0,'2013-07-06 12:44:34',NULL,NULL),(67766,'80638','U','State Farm Ins','N','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.421760,-104.744042,0,'2013-07-06 12:44:34',NULL,NULL),(57919,'67664','S','Prairie View','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.834610,-99.570086,0,'2013-07-06 12:44:33',NULL,NULL),(28583,'31632','S','Hahira','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.980940,-83.370202,0,'2013-07-06 12:44:32',NULL,NULL),(41217,'46732','S','Enchanted Hills','N','Noble','18113','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.401608,-85.666412,0,'2013-07-06 12:44:32',NULL,NULL),(42017,'47433','S','Gosport','D','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.302962,-86.623199,0,'2013-07-06 12:44:32',NULL,NULL),(13368,'13733','S','West Bainbridge','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.304440,-75.480180,0,'2013-07-06 12:44:31',NULL,NULL),(10585,'11023','S','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.798973,-73.733349,0,'2013-07-06 12:44:30',NULL,NULL),(59939,'71295','S','Swampers','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.158360,-91.723430,0,'2013-07-06 12:44:33',NULL,NULL),(56464,'65301','S','Dresden','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.695080,-93.242160,0,'2013-07-06 12:44:33',NULL,NULL),(2650,'00966','S','Mans Garden Hls','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(1615,'00769','S','Villa Madrid','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(1589,'00769','S','Ext Jard de Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(58397,'68628','S','Clarks','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.254383,-97.849012,0,'2013-07-06 12:44:33',NULL,NULL),(55437,'63670','S','Sainte Genevieve','D','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(26599,'29229','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.127676,-80.896127,0,'2013-07-06 12:44:31',NULL,NULL),(7542,'07010','S','Cliff Park','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.819853,-73.988554,0,'2013-07-06 12:44:30',NULL,NULL),(16416,'17225','S','Greencastle','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(42052,'47446','S','Yockey','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(24707,'27498','U','Greensboro Courtesy Reply','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.072005,-79.767906,0,'2013-07-06 12:44:31',NULL,NULL),(28561,'31599','U','Federal Correctional Inst','N','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.478461,-81.802265,0,'2013-07-06 12:44:32',NULL,NULL),(26747,'29423','P','North Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.845603,-79.977751,0,'2013-07-06 12:44:31',NULL,NULL),(47943,'55116','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.913706,-93.174993,0,'2013-07-06 12:44:33',NULL,NULL),(16664,'17354','S','Spring Grove','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.849844,-76.879266,0,'2013-07-06 12:44:31',NULL,NULL),(55562,'63866','P','Marston','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.527620,-89.606608,0,'2013-07-06 12:44:33',NULL,NULL),(410,'00662','S','Repto Apolonio Velez Ramos','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(8221,'07962','P','Morristown','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.806402,-74.500611,0,'2013-07-06 12:44:30',NULL,NULL),(48213,'55411','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.996374,-93.299888,0,'2013-07-06 12:44:33',NULL,NULL),(55138,'63357','S','Lake Sherwood','A','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634000,-91.100160,0,'2013-07-06 12:44:33',NULL,NULL),(8695,'08348','S','Port Elizabeth','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.233423,-75.010390,0,'2013-07-06 12:44:30',NULL,NULL),(48114,'55353','S','Saint Augusta','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.359002,-94.296954,0,'2013-07-06 12:44:33',NULL,NULL),(5314,'04565','P','Sebasco Ests','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.778808,-69.848458,0,'2013-07-06 12:44:30',NULL,NULL),(49438,'56636','S','Deer Riv','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(68488,'81253','S','Greenwood','N','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.178706,-105.106327,0,'2013-07-06 12:44:34',NULL,NULL),(66380,'78621','S','Webberville','A','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(32136,'35453','S','Coaling','A','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.200553,-87.401063,0,'2013-07-06 12:44:32',NULL,NULL),(35583,'39573','S','Inda','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(36408,'40516','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.058255,-84.379824,0,'2013-07-06 12:44:32',NULL,NULL),(38254,'43279','U','Shared Zip Code','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.966103,-83.025448,0,'2013-07-06 12:44:32',NULL,NULL),(38622,'43913','S','Tidd Dale','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.263036,-80.629993,0,'2013-07-06 12:44:32',NULL,NULL),(43961,'49311','P','Bradley','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.638591,-85.646128,0,'2013-07-06 12:44:32',NULL,NULL),(50248,'57626','S','Faith','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(79135,'98499','S','Mc Chord AFB','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(6169,'05473','S','Mount Philo','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(4917,'04073','S','Sanford','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.436687,-70.761335,0,'2013-07-06 12:44:30',NULL,NULL),(57807,'67505','S','South Hutchinson','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.019420,-97.973340,0,'2013-07-06 12:44:33',NULL,NULL),(55780,'64118','S','Nkc','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.215793,-94.572799,0,'2013-07-06 12:44:33',NULL,NULL),(14168,'14733','S','Falconer','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.128136,-79.190161,0,'2013-07-06 12:44:31',NULL,NULL),(32439,'36005','S','Banks','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.842135,-85.789986,0,'2013-07-06 12:44:32',NULL,NULL),(41587,'47042','S','Versailles','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.068723,-85.255691,0,'2013-07-06 12:44:32',NULL,NULL),(42789,'48045','S','Selfridge Air Natl Guard','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(52395,'60632','S','Elsdon','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.808605,-87.711782,0,'2013-07-06 12:44:33',NULL,NULL),(849,'00698','S','Jard De Montblanc','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(30198,'33180','S','North Miami Beach','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.961901,-80.140608,0,'2013-07-06 12:44:32',NULL,NULL),(30785,'33596','S','Valrico','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.871499,-82.251412,0,'2013-07-06 12:44:32',NULL,NULL),(11151,'11717','S','W Brentwood','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.780920,-73.254540,0,'2013-07-06 12:44:30',NULL,NULL),(26572,'29214','U','SC Tax Comm','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.000793,-81.031935,0,'2013-07-06 12:44:31',NULL,NULL),(77676,'97032','S','Hubbard','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.183275,-122.802741,0,'2013-07-06 12:44:34',NULL,NULL),(66616,'78772','U','Veterans Administration','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.224319,-97.750289,0,'2013-07-06 12:44:34',NULL,NULL),(28800,'32061','S','Lulu','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.069316,-82.550528,0,'2013-07-06 12:44:32',NULL,NULL),(33507,'37364','P','Cleveland','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.157291,-84.835529,0,'2013-07-06 12:44:32',NULL,NULL),(56099,'64780','S','Rockville','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.075520,-94.147320,0,'2013-07-06 12:44:33',NULL,NULL),(30202,'33181','S','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(37746,'42320','S','Prentiss','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(22985,'24740','S','Elgood','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.411080,-81.027240,0,'2013-07-06 12:44:31',NULL,NULL),(21684,'22960','S','Thornhill','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.245110,-78.108521,0,'2013-07-06 12:44:31',NULL,NULL),(42604,'47885','S','Tecumseh','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(56925,'66064','S','Osawatomie','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.474864,-94.973904,0,'2013-07-06 12:44:33',NULL,NULL),(55319,'63541','S','Glenwood','D','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.507166,-92.618509,0,'2013-07-06 12:44:33',NULL,NULL),(28757,'32004','P','Ponte Vedra Beach','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.241583,-81.383434,0,'2013-07-06 12:44:32',NULL,NULL),(8340,'08039','P','Harrisonville','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.685686,-75.265322,0,'2013-07-06 12:44:30',NULL,NULL),(69560,'83815','S','Dalton Gardens','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.725192,-116.786915,0,'2013-07-06 12:44:34',NULL,NULL),(30299,'33283','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.699280,-80.381577,0,'2013-07-06 12:44:32',NULL,NULL),(13605,'13856','S','Walton','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(31801,'35044','S','Coosa Pines','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.276643,-86.352253,0,'2013-07-06 12:44:32',NULL,NULL),(44945,'50369','U','Citigroup BRM','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595940,-93.746203,0,'2013-07-06 12:44:32',NULL,NULL),(48194,'55394','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816615,-93.922276,0,'2013-07-06 12:44:33',NULL,NULL),(13456,'13778','S','Triangle','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(72101,'88220','S','Happy Valley','N','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.397966,-104.241065,0,'2013-07-06 12:44:34',NULL,NULL),(9636,'10035','S','Wards Is','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(37835,'42452','S','Robards','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.688158,-87.550435,0,'2013-07-06 12:44:32',NULL,NULL),(39920,'45221','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.130320,-84.516932,0,'2013-07-06 12:44:32',NULL,NULL),(57720,'67360','S','Peru','D','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.054965,-96.154501,0,'2013-07-06 12:44:33',NULL,NULL),(44959,'50395','S','Urbandale','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.600964,-93.630768,0,'2013-07-06 12:44:32',NULL,NULL),(78737,'98286','P','Shaw Island','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.585278,-122.926601,0,'2013-07-06 12:44:34',NULL,NULL),(34654,'38774','S','Lombardy','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.948680,-90.765417,0,'2013-07-06 12:44:32',NULL,NULL),(66316,'78593','S','Santa Rosa','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.250864,-97.825711,0,'2013-07-06 12:44:34',NULL,NULL),(73899,'92004','S','Borrego Springs','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.236443,-116.349384,0,'2013-07-06 12:44:34',NULL,NULL),(79023,'98391','S','Ponderosa Estates','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(15877,'17002','S','Allensville','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.601427,-77.722706,0,'2013-07-06 12:44:31',NULL,NULL),(79062,'98424','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.238360,-122.362020,0,'2013-07-06 12:44:34',NULL,NULL),(76477,'95625','P','Elmira','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.346263,-121.902370,0,'2013-07-06 12:44:34',NULL,NULL),(68526,'81402','P','Montrose','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.484963,-107.838023,0,'2013-07-06 12:44:34',NULL,NULL),(70568,'85060','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.500897,-111.981897,0,'2013-07-06 12:44:34',NULL,NULL),(67503,'80235','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.645945,-105.081888,0,'2013-07-06 12:44:34',NULL,NULL),(61437,'72584','S','La Crosse','N','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.157784,-91.851420,0,'2013-07-06 12:44:33',NULL,NULL),(5803,'05065','S','Sharon','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.774789,-72.419959,0,'2013-07-06 12:44:30',NULL,NULL),(24603,'27330','S','Haw Branch','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(25760,'28584','S','Cedar Point','A','Onslow','37133','North Carolina','NC','37','3605','252','Eastern',-5.0,'Y',34.701094,-77.065759,0,'2013-07-06 12:44:31',NULL,NULL),(26099,'28717','S','Cashiers','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.080295,-83.081376,0,'2013-07-06 12:44:31',NULL,NULL),(58582,'68835','S','Dannevirke','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.285075,-98.591395,0,'2013-07-06 12:44:33',NULL,NULL),(58480,'68748','S','Madison','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.825641,-97.456917,0,'2013-07-06 12:44:33',NULL,NULL),(52870,'61336','S','Magnolia','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.122586,-89.249640,0,'2013-07-06 12:44:33',NULL,NULL),(24208,'26690','S','Swiss','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.277039,-81.070532,0,'2013-07-06 12:44:31',NULL,NULL),(25778,'28602','S','Mountain View','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.661600,-81.370320,0,'2013-07-06 12:44:31',NULL,NULL),(40812,'46197','U','Plainfield','D','Hendricks','18063','Indiana','IN','18','3480','317/765','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(21077,'22026','S','Southbridge','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.583120,-77.333820,0,'2013-07-06 12:44:31',NULL,NULL),(39117,'44256','S','Chatham','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.134844,-81.860472,0,'2013-07-06 12:44:32',NULL,NULL),(46671,'53716','S','Monona Grove','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.065869,-89.312254,0,'2013-07-06 12:44:32',NULL,NULL),(49383,'56601','S','Jones','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(61257,'72358','S','Tomato','N','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.756918,-89.932328,0,'2013-07-06 12:44:33',NULL,NULL),(57492,'66939','S','Courtland','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.784496,-97.895280,0,'2013-07-06 12:44:33',NULL,NULL),(55395,'63632','P','Cascade','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.300000,-90.268317,0,'2013-07-06 12:44:33',NULL,NULL),(32418,'35973','S','Gaylesville','D','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.367610,-85.557609,0,'2013-07-06 12:44:32',NULL,NULL),(5814,'05070','S','South Strafford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.833285,-72.377667,0,'2013-07-06 12:44:30',NULL,NULL),(32190,'35540','S','Arley','A','Winston','01133','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.213763,-87.289271,0,'2013-07-06 12:44:32',NULL,NULL),(25492,'28363','S','Marston','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.991473,-79.618711,0,'2013-07-06 12:44:31',NULL,NULL),(43361,'48397','U','Us Army Tank-Auto Command','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.503868,-83.045668,0,'2013-07-06 12:44:32',NULL,NULL),(26441,'29130','S','Smallwood','N','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.326001,-80.760553,0,'2013-07-06 12:44:31',NULL,NULL),(9256,'09591','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30667,'33466','P','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.617420,-80.060095,0,'2013-07-06 12:44:32',NULL,NULL),(40864,'46229','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.778740,-85.976640,0,'2013-07-06 12:44:32',NULL,NULL),(38355,'43449','S','Oak Harbor','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.533747,-83.138207,0,'2013-07-06 12:44:32',NULL,NULL),(23319,'25209','S','Pettus','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.970938,-81.529874,0,'2013-07-06 12:44:31',NULL,NULL),(35640,'39638','S','Gloster','D','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(70272,'84526','S','Scofield','A','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(76276,'95423','S','Clearlake Oks','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.025340,-122.667855,0,'2013-07-06 12:44:34',NULL,NULL),(78070,'97463','S','Oakridge','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.746949,-122.465772,0,'2013-07-06 12:44:34',NULL,NULL),(78603,'98189','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.610236,-122.341839,0,'2013-07-06 12:44:34',NULL,NULL),(19999,'20606','S','Abell','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.250381,-76.738810,0,'2013-07-06 12:44:31',NULL,NULL),(15273,'16110','S','Adamsville','D','Crawford','42039','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.630097,-80.210844,0,'2013-07-06 12:44:31',NULL,NULL),(45249,'50659','S','Jerico','N','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.062151,-92.314419,0,'2013-07-06 12:44:32',NULL,NULL),(24730,'27520','S','Archers Lodge','N','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.636282,-78.444815,0,'2013-07-06 12:44:31',NULL,NULL),(75947,'95038','P','Morgan Hill','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.085520,-121.609800,0,'2013-07-06 12:44:34',NULL,NULL),(75756,'94614','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.729709,-122.200667,0,'2013-07-06 12:44:34',NULL,NULL),(67706,'80526','S','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.545580,-105.112604,0,'2013-07-06 12:44:34',NULL,NULL),(3222,'01367','S','Zoar','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.689349,-72.935421,0,'2013-07-06 12:44:30',NULL,NULL),(12710,'13148','S','Canoga','N','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.920280,-76.784880,0,'2013-07-06 12:44:30',NULL,NULL),(20827,'21631','S','E New Market','A','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.596813,-75.935069,0,'2013-07-06 12:44:31',NULL,NULL),(11063,'11580','S','Valley Stream','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.674214,-73.709056,0,'2013-07-06 12:44:30',NULL,NULL),(72107,'88240','S','Hobbs','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.725126,-103.140536,0,'2013-07-06 12:44:34',NULL,NULL),(30723,'33523','S','Ridge Manor','A','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.400100,-82.228620,0,'2013-07-06 12:44:32',NULL,NULL),(55768,'64116','S','N Kc','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(56441,'65275','S','Goss','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.481474,-92.009398,0,'2013-07-06 12:44:33',NULL,NULL),(71191,'86047','S','Dilkon','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.275380,-110.315820,0,'2013-07-06 12:44:34',NULL,NULL),(69141,'83302','S','Twin Falls','A','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.208715,-114.593476,0,'2013-07-06 12:44:34',NULL,NULL),(68503,'81323','S','Dolores','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.455410,-108.516324,0,'2013-07-06 12:44:34',NULL,NULL),(11309,'11780','S','Box Hill','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(61055,'72121','S','Davenport','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(16059,'17047','S','Fort Robinson','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(2003,'00911','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451416,-66.061581,0,'2013-07-06 12:44:30',NULL,NULL),(41322,'46774','S','New Haven Heights','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(9631,'10035','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(17770,'18336','S','Matamoras','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.366905,-74.707303,0,'2013-07-06 12:44:31',NULL,NULL),(17466,'17948','S','Mahanoy Cy','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(66374,'78621','S','Beaukiss','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(24090,'26504','P','Star City','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.630371,-79.957848,0,'2013-07-06 12:44:31',NULL,NULL),(34619,'38753','S','Inverness','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.352720,-90.592066,0,'2013-07-06 12:44:32',NULL,NULL),(40424,'45696','S','Willow Wood','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.596101,-82.450776,0,'2013-07-06 12:44:32',NULL,NULL),(46250,'53006','S','Byron','A','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.615200,-88.516980,0,'2013-07-06 12:44:32',NULL,NULL),(52528,'60919','S','Stelle','N','Ford','17053','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.949053,-88.151418,0,'2013-07-06 12:44:33',NULL,NULL),(12644,'13110','S','Amber','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.888966,-76.283957,0,'2013-07-06 12:44:30',NULL,NULL),(400,'00662','S','Est Velazquez','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(7562,'07022','S','Fairview','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.817740,-74.004196,0,'2013-07-06 12:44:30',NULL,NULL),(11164,'11724','S','Cold Spg Hbr','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.866028,-73.450581,0,'2013-07-06 12:44:30',NULL,NULL),(43574,'48738','S','Greenbush','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.565381,-83.332281,0,'2013-07-06 12:44:32',NULL,NULL),(48581,'55771','S','Vermilion Dam','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(48787,'56002','P','Mankato','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.161464,-94.005528,0,'2013-07-06 12:44:33',NULL,NULL),(115,'00612','S','Urb San Lorenzo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(74820,'93222','P','Pine Mountain Club','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.836120,-119.055120,0,'2013-07-06 12:44:34',NULL,NULL),(73690,'91605','S','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.209647,-118.402550,0,'2013-07-06 12:44:34',NULL,NULL),(58003,'67864','S','Meade','D','Meade','20119','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.283989,-100.338920,0,'2013-07-06 12:44:33',NULL,NULL),(51317,'59248','S','Nashua','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.141937,-106.357405,0,'2013-07-06 12:44:33',NULL,NULL),(34777,'38864','S','Randolph','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.171200,-89.188320,0,'2013-07-06 12:44:32',NULL,NULL),(17867,'18436','S','Jefferson Twp','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(38194,'43205','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.959225,-82.966539,0,'2013-07-06 12:44:32',NULL,NULL),(42693,'47988','P','Wallace','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.988972,-87.146779,0,'2013-07-06 12:44:32',NULL,NULL),(77258,'96554','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(62998,'75155','S','Rice','D','Navarro','48349','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.216974,-96.413231,0,'2013-07-06 12:44:33',NULL,NULL),(56821,'65785','S','Stockton','D','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.693951,-93.801056,0,'2013-07-06 12:44:33',NULL,NULL),(25276,'28128','S','Norwood','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.237400,-80.166240,0,'2013-07-06 12:44:31',NULL,NULL),(18363,'19038','S','Wyndmoor','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(40661,'46047','P','Hobbs','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.286838,-85.947714,0,'2013-07-06 12:44:32',NULL,NULL),(6982,'06244','P','E Woodstock','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.986323,-71.974484,0,'2013-07-06 12:44:30',NULL,NULL),(11356,'11803','S','Plainview','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.780517,-73.478813,0,'2013-07-06 12:44:30',NULL,NULL),(33542,'37389','S','Arnold Air Force Base','N','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.320179,-86.067451,0,'2013-07-06 12:44:32',NULL,NULL),(57798,'67492','S','Woodbine','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.830477,-96.969022,0,'2013-07-06 12:44:33',NULL,NULL),(50715,'58368','S','Silva','A','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.303660,-99.994440,0,'2013-07-06 12:44:33',NULL,NULL),(3129,'01245','S','Monterey','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.208800,-73.197240,0,'2013-07-06 12:44:30',NULL,NULL),(31434,'34268','P','Nocatee','D','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.162193,-81.882333,0,'2013-07-06 12:44:32',NULL,NULL),(78984,'98376','S','East Quilcene','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.813700,-122.850480,0,'2013-07-06 12:44:34',NULL,NULL),(21089,'22036','S','Journal Newspaper','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.857984,-77.258665,0,'2013-07-06 12:44:31',NULL,NULL),(25005,'27872','S','Roxobel','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.200834,-77.243084,0,'2013-07-06 12:44:31',NULL,NULL),(41505,'46962','S','North Manchester','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.003793,-85.773443,0,'2013-07-06 12:44:32',NULL,NULL),(564,'00678','S','Quebradillas','D','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(25798,'28605','S','Blowing Rock','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.116573,-81.678226,0,'2013-07-06 12:44:31',NULL,NULL),(62562,'74450','S','Oktaha','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.631644,-95.511202,0,'2013-07-06 12:44:33',NULL,NULL),(32158,'35473','S','North Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.228904,-87.577424,0,'2013-07-06 12:44:32',NULL,NULL),(4640,'03741','S','Canaan','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.663654,-72.004386,0,'2013-07-06 12:44:30',NULL,NULL),(47700,'54979','S','Van Dyne','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.898676,-88.550846,0,'2013-07-06 12:44:33',NULL,NULL),(12439,'12959','S','Mooers Forks','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.965896,-73.694298,0,'2013-07-06 12:44:30',NULL,NULL),(68510,'81326','S','Breen','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.215884,-108.087279,0,'2013-07-06 12:44:34',NULL,NULL),(16912,'17601','S','Roseville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(11871,'12304','S','Brandywine','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.780295,-73.909969,0,'2013-07-06 12:44:30',NULL,NULL),(9718,'10081','U','JP Morgan Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(77483,'96822','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312545,-157.821044,0,'2013-07-06 12:44:34',NULL,NULL),(77362,'96741','S','Kalaheo','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.925585,-159.526952,0,'2013-07-06 12:44:34',NULL,NULL),(73354,'91010','S','Irwindale','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138594,-117.963204,0,'2013-07-06 12:44:34',NULL,NULL),(28923,'32159','S','The Villages','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.929131,-81.925528,0,'2013-07-06 12:44:32',NULL,NULL),(9980,'10163','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755007,-73.967791,0,'2013-07-06 12:44:30',NULL,NULL),(42838,'48070','S','Huntingtn Wds','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.480041,-83.166602,0,'2013-07-06 12:44:32',NULL,NULL),(8274,'08010','S','Edgewater Prk','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.058892,-74.910433,0,'2013-07-06 12:44:30',NULL,NULL),(5341,'04605','S','Otis','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(60576,'71770','S','Waldo','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.352964,-93.291433,0,'2013-07-06 12:44:33',NULL,NULL),(70030,'84131','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700156,-111.944519,0,'2013-07-06 12:44:34',NULL,NULL),(48916,'56141','S','Iona','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.914769,-95.785439,0,'2013-07-06 12:44:33',NULL,NULL),(57074,'66215','S','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(69164,'83321','S','Roseworth','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.522145,-114.871179,0,'2013-07-06 12:44:34',NULL,NULL),(55958,'64493','S','Turney','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.629025,-94.288659,0,'2013-07-06 12:44:33',NULL,NULL),(30794,'33605','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.962333,-82.428868,0,'2013-07-06 12:44:32',NULL,NULL),(6401,'05734','S','Bridport','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.944790,-73.353652,0,'2013-07-06 12:44:30',NULL,NULL),(26317,'29044','S','Eastover','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.918360,-80.732160,0,'2013-07-06 12:44:31',NULL,NULL),(75718,'94583','S','San Ramon','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.751779,-121.953457,0,'2013-07-06 12:44:34',NULL,NULL),(73550,'91359','P','Westlake Vlg','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.194443,-118.820014,0,'2013-07-06 12:44:34',NULL,NULL),(66416,'78634','S','Monadale','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.553860,-97.547946,0,'2013-07-06 12:44:34',NULL,NULL),(58097,'68109','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.237586,-95.927592,0,'2013-07-06 12:44:33',NULL,NULL),(1920,'00795','S','Paseo Sol Y Mar','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(24350,'27041','S','Pilot Mts','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.450094,-80.489865,0,'2013-07-06 12:44:31',NULL,NULL),(62508,'74401','S','Bacone','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(6620,'05901','P','Canaan','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.942849,-71.679618,0,'2013-07-06 12:44:30',NULL,NULL),(48161,'55374','S','Otsego','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.173877,-93.567994,0,'2013-07-06 12:44:33',NULL,NULL),(47799,'55051','S','Brunswick','N','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.915556,-93.173056,0,'2013-07-06 12:44:33',NULL,NULL),(43360,'48393','S','Wixom','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.518077,-83.542455,0,'2013-07-06 12:44:32',NULL,NULL),(43337,'48371','S','Oxford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.837217,-83.289693,0,'2013-07-06 12:44:32',NULL,NULL),(1238,'00729','S','Haciendas De Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(71521,'87119','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.055070,-106.619497,0,'2013-07-06 12:44:34',NULL,NULL),(30164,'33172','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796061,-80.360119,0,'2013-07-06 12:44:32',NULL,NULL),(23501,'25524','S','Leet','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.030940,-82.105380,0,'2013-07-06 12:44:31',NULL,NULL),(34370,'38611','S','Byhalia','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.841937,-89.756017,0,'2013-07-06 12:44:32',NULL,NULL),(10137,'10268','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706940,-74.011574,0,'2013-07-06 12:44:30',NULL,NULL),(25392,'28273','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.137982,-80.938181,0,'2013-07-06 12:44:31',NULL,NULL),(40814,'46201','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.774629,-86.109637,0,'2013-07-06 12:44:32',NULL,NULL),(70830,'85396','S','Buckeye','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.468000,-112.478700,0,'2013-07-06 12:44:34',NULL,NULL),(63988,'76110','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.704715,-97.334989,0,'2013-07-06 12:44:34',NULL,NULL),(63715,'75925','S','Redlawn','N','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.642080,-95.087100,0,'2013-07-06 12:44:34',NULL,NULL),(62956,'75115','S','Desoto','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.596805,-96.866719,0,'2013-07-06 12:44:33',NULL,NULL),(6819,'06111','S','Newington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688552,-72.729085,0,'2013-07-06 12:44:30',NULL,NULL),(3308,'01518','S','Sturbridge','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.120891,-72.110243,0,'2013-07-06 12:44:30',NULL,NULL),(14959,'15620','S','Bradenville','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.306250,-79.262009,0,'2013-07-06 12:44:31',NULL,NULL),(5658,'04961','S','Caryng Pl Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(36916,'41143','S','Jeriel','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.329825,-82.936538,0,'2013-07-06 12:44:32',NULL,NULL),(67190,'79901','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.760394,-106.487292,0,'2013-07-06 12:44:34',NULL,NULL),(72303,'88584','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768405,-106.328241,0,'2013-07-06 12:44:34',NULL,NULL),(71279,'86434','S','Truxton','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.574300,-113.492100,0,'2013-07-06 12:44:34',NULL,NULL),(52344,'60599','S','Fox Valley Facility','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.772102,-88.357402,0,'2013-07-06 12:44:33',NULL,NULL),(44071,'49445','S','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.293180,-86.282880,0,'2013-07-06 12:44:32',NULL,NULL),(65970,'78291','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425516,-98.488267,0,'2013-07-06 12:44:34',NULL,NULL),(57483,'66901','S','Concordia','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.567727,-97.660244,0,'2013-07-06 12:44:33',NULL,NULL),(34738,'38850','S','Houlka','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.916603,-89.002366,0,'2013-07-06 12:44:32',NULL,NULL),(42466,'47834','S','Billtown','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(48779,'55988','P','Stockton','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.027664,-91.760287,0,'2013-07-06 12:44:33',NULL,NULL),(6316,'05661','S','Lake Lamoille','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(27038,'29661','S','Marietta','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.056803,-82.511622,0,'2013-07-06 12:44:31',NULL,NULL),(15849,'16938','S','Plank','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(13517,'13812','S','Nichols','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.042960,-76.358700,0,'2013-07-06 12:44:31',NULL,NULL),(31803,'35046','S','Clanton','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.839427,-86.623504,0,'2013-07-06 12:44:32',NULL,NULL),(72799,'89706','S','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.186004,-119.745390,0,'2013-07-06 12:44:34',NULL,NULL),(40387,'45661','S','Idaho','A','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.037860,-83.101200,0,'2013-07-06 12:44:32',NULL,NULL),(62744,'74836','P','Connerville','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.357545,-96.659671,0,'2013-07-06 12:44:33',NULL,NULL),(23478,'25505','S','Big Creek','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.032514,-82.018313,0,'2013-07-06 12:44:31',NULL,NULL),(69912,'84108','S','Emigratn Cyn','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.738359,-111.812479,0,'2013-07-06 12:44:34',NULL,NULL),(62862,'75029','P','Lewisville','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.045911,-97.009351,0,'2013-07-06 12:44:33',NULL,NULL),(59472,'70748','S','The Bluffs','A','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.777809,-91.210024,0,'2013-07-06 12:44:33',NULL,NULL),(54815,'63021','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(46384,'53143','S','Kenosha','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.544106,-87.837568,0,'2013-07-06 12:44:32',NULL,NULL),(13296,'13667','S','Grantville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.799692,-74.994368,0,'2013-07-06 12:44:30',NULL,NULL),(61199,'72227','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.774106,-92.374415,0,'2013-07-06 12:44:33',NULL,NULL),(29949,'33072','P','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.233068,-80.094210,0,'2013-07-06 12:44:32',NULL,NULL),(63323,'75570','S','Whaley','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.457080,-94.450920,0,'2013-07-06 12:44:33',NULL,NULL),(5037,'04259','S','Monmouth','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.228788,-70.063710,0,'2013-07-06 12:44:30',NULL,NULL),(62976,'75140','S','Grand Saline','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.681237,-95.714325,0,'2013-07-06 12:44:33',NULL,NULL),(48484,'55730','P','Grand Rapids','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.238881,-93.528397,0,'2013-07-06 12:44:33',NULL,NULL),(12702,'13145','S','Sandy Creek','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.656766,-76.114729,0,'2013-07-06 12:44:30',NULL,NULL),(66561,'78736','S','Bee Caves','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250073,-97.926724,0,'2013-07-06 12:44:34',NULL,NULL),(18167,'18912','P','Buckingham','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.293915,-75.059598,0,'2013-07-06 12:44:31',NULL,NULL),(49868,'57257','S','Peever','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.500243,-97.044431,0,'2013-07-06 12:44:33',NULL,NULL),(3261,'01460','S','Pingryville','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.543481,-71.484168,0,'2013-07-06 12:44:30',NULL,NULL),(19672,'20319','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877830,-77.018020,0,'2013-07-06 12:44:31',NULL,NULL),(62713,'74754','S','Ringold','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.195523,-95.071816,0,'2013-07-06 12:44:33',NULL,NULL),(59501,'70775','S','Hardwood','A','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.862864,-91.332969,0,'2013-07-06 12:44:33',NULL,NULL),(29410,'32643','S','High Springs','D','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.827571,-82.600164,0,'2013-07-06 12:44:32',NULL,NULL),(10491,'10960','S','Grand View-On-Hudson','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(65575,'77859','S','Hearne','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',30.876381,-96.596524,0,'2013-07-06 12:44:34',NULL,NULL),(53048,'61483','S','Goshen','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.092649,-89.863127,0,'2013-07-06 12:44:33',NULL,NULL),(8156,'07852','S','Ledgewood','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.883820,-74.655214,0,'2013-07-06 12:44:30',NULL,NULL),(4771,'03860','S','Hales Lctn','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.041258,-71.131424,0,'2013-07-06 12:44:30',NULL,NULL),(18466,'19082','S','Upper Darby','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.956267,-75.274357,0,'2013-07-06 12:44:31',NULL,NULL),(41259,'46747','S','Helmer','A','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.531111,-85.170278,0,'2013-07-06 12:44:32',NULL,NULL),(41410,'46816','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(76035,'95152','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.417403,-121.820034,0,'2013-07-06 12:44:34',NULL,NULL),(52044,'60193','S','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.012042,-88.090697,0,'2013-07-06 12:44:33',NULL,NULL),(25458,'28330','P','Cordova','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.918390,-79.825742,0,'2013-07-06 12:44:31',NULL,NULL),(65072,'77348','U','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722858,-95.553325,0,'2013-07-06 12:44:34',NULL,NULL),(8772,'08550','S','Princeton Junction','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(5639,'04947','S','Carabaset Vly','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.062466,-70.321604,0,'2013-07-06 12:44:30',NULL,NULL),(42830,'48065','S','Bruce Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.840846,-83.032465,0,'2013-07-06 12:44:32',NULL,NULL),(6357,'05675','S','South Washington','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(733,'00688','S','Est de Sabana','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.430209,-66.612619,0,'2013-07-06 12:44:30',NULL,NULL),(79779,'99343','S','Basin City','N','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.568040,-119.167620,0,'2013-07-06 12:44:34',NULL,NULL),(30608,'33426','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.518184,-80.081941,0,'2013-07-06 12:44:32',NULL,NULL),(5812,'05070','S','S Strafford','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.833285,-72.377667,0,'2013-07-06 12:44:30',NULL,NULL),(32935,'36567','S','Bell Fountain','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.569400,-87.630720,0,'2013-07-06 12:44:32',NULL,NULL),(66279,'78582','S','Escobares','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(57211,'66438','S','Home','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.839077,-96.523842,0,'2013-07-06 12:44:33',NULL,NULL),(5332,'04578','S','Wiscasset','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.996053,-69.671510,0,'2013-07-06 12:44:30',NULL,NULL),(42885,'48094','S','Washington Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.734460,-82.998120,0,'2013-07-06 12:44:32',NULL,NULL),(54166,'62612','S','Newmansville','A','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.886126,-90.009613,0,'2013-07-06 12:44:33',NULL,NULL),(79415,'98819','P','Conconully','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.522380,-119.718863,0,'2013-07-06 12:44:34',NULL,NULL),(63691,'75862','S','Pagoda','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(32105,'35297','U','State Farm Insurance','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.493207,-86.781750,0,'2013-07-06 12:44:32',NULL,NULL),(39612,'44881','P','Sulphur Springs','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.869583,-82.881591,0,'2013-07-06 12:44:32',NULL,NULL),(23961,'26289','S','Red Creek','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.023266,-79.564414,0,'2013-07-06 12:44:31',NULL,NULL),(44944,'50368','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.598509,-93.766771,0,'2013-07-06 12:44:32',NULL,NULL),(45323,'50851','S','Stringtown','N','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.882080,-94.560958,0,'2013-07-06 12:44:32',NULL,NULL),(13425,'13756','S','Harvard','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.023889,-75.113056,0,'2013-07-06 12:44:31',NULL,NULL),(48602,'55786','P','Lawrence','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.309263,-93.382691,0,'2013-07-06 12:44:33',NULL,NULL),(48094,'55340','S','Medina','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.072108,-93.576508,0,'2013-07-06 12:44:33',NULL,NULL),(62626,'74549','S','Kiamichi Christian Mission','D','Le Flore','40079','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.539310,-94.938190,0,'2013-07-06 12:44:33',NULL,NULL),(58077,'68064','S','Leshara','A','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.312896,-96.347618,0,'2013-07-06 12:44:33',NULL,NULL),(53358,'61764','S','Rooks Creek','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(56339,'65110','P','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.576911,-92.175487,0,'2013-07-06 12:44:33',NULL,NULL),(5269,'04492','S','Talmadge','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.345472,-67.694919,0,'2013-07-06 12:44:30',NULL,NULL),(19592,'20223','U','US Secret Service','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894341,-77.036991,0,'2013-07-06 12:44:31',NULL,NULL),(21088,'22036','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.857984,-77.258665,0,'2013-07-06 12:44:31',NULL,NULL),(49247,'56474','S','Chickamaw Beach','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(41654,'47140','S','Marengo','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.383335,-86.384510,0,'2013-07-06 12:44:32',NULL,NULL),(77885,'97269','P','Portland','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.438452,-122.611322,0,'2013-07-06 12:44:34',NULL,NULL),(77589,'96921','P','Barrigada','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461338,144.794695,0,'2013-07-06 12:44:34',NULL,NULL),(71189,'86045','P','Tuba City','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.133993,-111.242465,0,'2013-07-06 12:44:34',NULL,NULL),(16544,'17304','S','Aspers','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.978814,-77.237058,0,'2013-07-06 12:44:31',NULL,NULL),(25941,'28655','S','Sunnyside','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(65852,'78203','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.414826,-98.462021,0,'2013-07-06 12:44:34',NULL,NULL),(62243,'74002','S','Wolco','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.558589,-96.162993,0,'2013-07-06 12:44:33',NULL,NULL),(61408,'72555','S','Marcella','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.751456,-91.944708,0,'2013-07-06 12:44:33',NULL,NULL),(58680,'68920','S','Alma','D','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.102175,-99.361810,0,'2013-07-06 12:44:33',NULL,NULL),(56534,'65438','S','Thomasville','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.912332,-91.493803,0,'2013-07-06 12:44:33',NULL,NULL),(54745,'62974','S','Attila','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.787286,-88.865717,0,'2013-07-06 12:44:33',NULL,NULL),(36708,'41017','S','Villa Hills','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(20510,'21078','S','Hvre de Grace','A','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.583804,-76.151327,0,'2013-07-06 12:44:31',NULL,NULL),(1636,'00771','S','Urb las Campinas I','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(53468,'61929','S','Pierson Station','A','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.801837,-88.565868,0,'2013-07-06 12:44:33',NULL,NULL),(26680,'29404','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(30013,'33130','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.770398,-80.203205,0,'2013-07-06 12:44:32',NULL,NULL),(13439,'13761','P','Endicott','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.100447,-76.048838,0,'2013-07-06 12:44:31',NULL,NULL),(50764,'58421','S','Barlow','N','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(77854,'97228','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.529912,-122.682581,0,'2013-07-06 12:44:34',NULL,NULL),(77277,'96611','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(66850,'79124','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.248182,-101.907512,0,'2013-07-06 12:44:34',NULL,NULL),(61702,'72959','S','Winslow','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.811380,-94.106103,0,'2013-07-06 12:44:33',NULL,NULL),(947,'00716','S','Ext Alta Vista','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(10863,'11415','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.708943,-73.826125,0,'2013-07-06 12:44:30',NULL,NULL),(54637,'62922','S','Creal Springs','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.618809,-88.837781,0,'2013-07-06 12:44:33',NULL,NULL),(5679,'04967','S','Pittsfield','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.772452,-69.399569,0,'2013-07-06 12:44:30',NULL,NULL),(21006,'21838','S','Marion','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.025060,-75.729060,0,'2013-07-06 12:44:31',NULL,NULL),(76768,'95929','U','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.753601,-121.807403,0,'2013-07-06 12:44:34',NULL,NULL),(73256,'90712','S','Lakewood','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.848928,-118.147102,0,'2013-07-06 12:44:34',NULL,NULL),(68125,'80951','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837139,-104.795539,0,'2013-07-06 12:44:34',NULL,NULL),(60429,'71644','S','Tamo','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.089960,-91.734240,0,'2013-07-06 12:44:33',NULL,NULL),(12113,'12586','S','Walden','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.562389,-74.173819,0,'2013-07-06 12:44:30',NULL,NULL),(46449,'53210','S','Wauwatosa','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.068996,-87.978957,0,'2013-07-06 12:44:32',NULL,NULL),(65380,'77545','S','Fresno','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.547428,-95.468980,0,'2013-07-06 12:44:34',NULL,NULL),(56493,'65336','S','Montserrat','N','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.764378,-93.556549,0,'2013-07-06 12:44:33',NULL,NULL),(24031,'26385','S','Lost Creek','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.170160,-80.387280,0,'2013-07-06 12:44:31',NULL,NULL),(16743,'17508','P','Brownstown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.127960,-76.211265,0,'2013-07-06 12:44:31',NULL,NULL),(8579,'08215','S','Weekstown','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(7266,'06518','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.415836,-72.912377,0,'2013-07-06 12:44:30',NULL,NULL),(23648,'25802','P','Beckley','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.793326,-81.219605,0,'2013-07-06 12:44:31',NULL,NULL),(44170,'49546','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(68540,'81418','S','Orchard City','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.852404,-107.967183,0,'2013-07-06 12:44:34',NULL,NULL),(64003,'76115','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.682825,-97.332300,0,'2013-07-06 12:44:34',NULL,NULL),(20024,'20626','S','Coltons Point','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.236396,-76.767560,0,'2013-07-06 12:44:31',NULL,NULL),(18478,'19087','S','Saint Davids','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(51887,'60093','S','Winnetka','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.101050,-87.757641,0,'2013-07-06 12:44:33',NULL,NULL),(35722,'39669','S','Lessley','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(40047,'45255','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.051766,-84.347377,0,'2013-07-06 12:44:32',NULL,NULL),(62705,'74741','S','Yarnaby','A','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.792515,-96.312344,0,'2013-07-06 12:44:33',NULL,NULL),(54065,'62480','S','Hunt','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.976776,-88.011300,0,'2013-07-06 12:44:33',NULL,NULL),(4645,'03746','P','Cornish Flat','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.496568,-72.279969,0,'2013-07-06 12:44:30',NULL,NULL),(1035,'00720','S','Villas De Orocovix I','N','Orocovis','72107','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.229109,-66.391520,0,'2013-07-06 12:44:30',NULL,NULL),(7038,'06269','U','Storrs Manfld','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.811419,-72.247553,0,'2013-07-06 12:44:30',NULL,NULL),(47119,'54451','S','Goodrich','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(3187,'01341','S','Conway','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.511022,-72.688092,0,'2013-07-06 12:44:30',NULL,NULL),(70364,'84651','S','Payson','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.026844,-111.705036,0,'2013-07-06 12:44:34',NULL,NULL),(67031,'79539','S','O Brien','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.365964,-99.857010,0,'2013-07-06 12:44:34',NULL,NULL),(51736,'60013','S','Trout Valley','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.219192,-88.239708,0,'2013-07-06 12:44:33',NULL,NULL),(35242,'39332','S','Hickory','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.317605,-89.020950,0,'2013-07-06 12:44:32',NULL,NULL),(41515,'46975','S','Rochester','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.061041,-86.208192,0,'2013-07-06 12:44:32',NULL,NULL),(5726,'05030','P','Ascutney','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.446626,-72.422564,0,'2013-07-06 12:44:30',NULL,NULL),(22820,'24501','S','Miller Park','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.399278,-79.174704,0,'2013-07-06 12:44:31',NULL,NULL),(13479,'13794','P','Killawog','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.399761,-76.021494,0,'2013-07-06 12:44:31',NULL,NULL),(59317,'70522','P','Centerville','D','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.758439,-91.429998,0,'2013-07-06 12:44:33',NULL,NULL),(59807,'71225','S','Indian Village','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.527647,-92.314023,0,'2013-07-06 12:44:33',NULL,NULL),(78678,'98244','S','Glacier','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.824220,-121.958340,0,'2013-07-06 12:44:34',NULL,NULL),(25308,'28151','P','Shelby','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.288342,-81.543859,0,'2013-07-06 12:44:31',NULL,NULL),(28919,'32149','P','Interlachen','A','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.619345,-81.897928,0,'2013-07-06 12:44:32',NULL,NULL),(2448,'00953','S','Urb San Fernando','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(454,'00662','S','Urb Sol y Mar','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(261,'00641','S','Jard de Bubao','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(20643,'21222','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.263020,-76.499604,0,'2013-07-06 12:44:31',NULL,NULL),(28291,'31096','S','Wrightsville','D','Johnson','13167','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.723545,-82.723352,0,'2013-07-06 12:44:31',NULL,NULL),(15166,'15921','P','Beaverdale','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.315204,-78.697283,0,'2013-07-06 12:44:31',NULL,NULL),(79775,'99336','S','Kennewick','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.194720,-119.133240,0,'2013-07-06 12:44:34',NULL,NULL),(70877,'85608','P','Douglas','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.350792,-109.550363,0,'2013-07-06 12:44:34',NULL,NULL),(54130,'62558','S','Pawnee','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.592339,-89.581873,0,'2013-07-06 12:44:33',NULL,NULL),(46174,'52734','U','Clinton','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.848613,-90.208528,0,'2013-07-06 12:44:32',NULL,NULL),(21812,'23102','S','Maidens','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.698420,-77.846880,0,'2013-07-06 12:44:31',NULL,NULL),(13321,'13676','S','West Parishville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(71690,'87518','P','Alire','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.674238,-106.551589,0,'2013-07-06 12:44:34',NULL,NULL),(71850,'87654','U','Spaceport America','N','Sierra','35051','New Mexico','NM','35','0000','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(16933,'17611','S','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.023731,-76.331711,0,'2013-07-06 12:44:31',NULL,NULL),(66423,'78639','S','Lakeside Heights','N','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.662580,-98.454420,0,'2013-07-06 12:44:34',NULL,NULL),(64495,'76627','S','Blum','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.105518,-97.378381,0,'2013-07-06 12:44:34',NULL,NULL),(38919,'44121','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.520000,-81.556389,0,'2013-07-06 12:44:32',NULL,NULL),(46949,'54170','S','Shiocton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.439937,-88.578010,0,'2013-07-06 12:44:32',NULL,NULL),(34262,'38457','S','Five Points','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.027318,-87.284586,0,'2013-07-06 12:44:32',NULL,NULL),(57822,'67525','S','Beaver','A','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.524583,-98.534997,0,'2013-07-06 12:44:33',NULL,NULL),(59275,'70458','S','Slidell','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.272675,-89.772151,0,'2013-07-06 12:44:33',NULL,NULL),(55547,'63848','S','Peach Orchard','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.450950,-89.916845,0,'2013-07-06 12:44:33',NULL,NULL),(674,'00683','S','Urb Los Sauces','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(28582,'31631','S','Fargo','D','Clinch','13065','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.787206,-82.610697,0,'2013-07-06 12:44:32',NULL,NULL),(40554,'45855','P','Latty','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.088271,-84.585511,0,'2013-07-06 12:44:32',NULL,NULL),(27246,'29927','S','Bellinger','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.281300,-81.071015,0,'2013-07-06 12:44:31',NULL,NULL),(58774,'68971','S','Huntley','A','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.100098,-99.231767,0,'2013-07-06 12:44:33',NULL,NULL),(24833,'27612','S','Crabtree Valley','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.856914,-78.689606,0,'2013-07-06 12:44:31',NULL,NULL),(40220,'45410','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.746481,-84.160751,0,'2013-07-06 12:44:32',NULL,NULL),(56394,'65237','S','Pisgah','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.787039,-92.799726,0,'2013-07-06 12:44:33',NULL,NULL),(59032,'70083','S','Ironton','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(59487,'70762','S','Oscar','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.615901,-91.463133,0,'2013-07-06 12:44:33',NULL,NULL),(64233,'76307','P','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.908686,-98.492673,0,'2013-07-06 12:44:34',NULL,NULL),(68572,'81504','S','Fruitvale','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.083097,-108.486204,0,'2013-07-06 12:44:34',NULL,NULL),(74255,'92338','S','Ludlow','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.721111,-116.159167,0,'2013-07-06 12:44:34',NULL,NULL),(50176,'57555','S','Pine Run','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.194176,-100.477794,0,'2013-07-06 12:44:33',NULL,NULL),(24714,'27504','S','Benson','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.394150,-78.547820,0,'2013-07-06 12:44:31',NULL,NULL),(43871,'49129','S','Union Pier','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.825741,-86.688623,0,'2013-07-06 12:44:32',NULL,NULL),(5158,'04424','S','Weston','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.659444,-67.867287,0,'2013-07-06 12:44:30',NULL,NULL),(76936,'96021','S','Corning','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',39.926419,-122.190031,0,'2013-07-06 12:44:34',NULL,NULL),(60327,'71460','P','Negreet','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.471486,-93.572687,0,'2013-07-06 12:44:33',NULL,NULL),(34145,'38235','P','Mc Lemoresvle','A','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.985579,-88.581792,0,'2013-07-06 12:44:32',NULL,NULL),(49624,'56915','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896263,-77.036490,0,'2013-07-06 12:44:33',NULL,NULL),(50564,'58218','S','Buxton','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.603307,-97.100502,0,'2013-07-06 12:44:33',NULL,NULL),(15161,'15907','P','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.328729,-78.918910,0,'2013-07-06 12:44:31',NULL,NULL),(62497,'74362','P','Pryor','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.288695,-95.319273,0,'2013-07-06 12:44:33',NULL,NULL),(8620,'08248','P','Strathmere','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.195556,-74.659715,0,'2013-07-06 12:44:30',NULL,NULL),(884,'00704','S','Aguirre','D','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(28601,'31698','U','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.865739,-83.288419,0,'2013-07-06 12:44:32',NULL,NULL),(9411,'10001','S','Macys Finance','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(32946,'36574','S','Seminole','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.509700,-87.485880,0,'2013-07-06 12:44:32',NULL,NULL),(70439,'84741','S','Big Water','A','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.051804,-112.533746,0,'2013-07-06 12:44:34',NULL,NULL),(54880,'63061','S','Luebbering','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.267851,-90.818825,0,'2013-07-06 12:44:33',NULL,NULL),(26683,'29404','S','Jt Base Chas','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(27877,'30450','S','Aaron','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.569614,-81.903024,0,'2013-07-06 12:44:31',NULL,NULL),(21619,'22906','P','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.030177,-78.475550,0,'2013-07-06 12:44:31',NULL,NULL),(3321,'01527','S','East Millbury','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.197286,-71.770146,0,'2013-07-06 12:44:30',NULL,NULL),(29973,'33084','P','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.025865,-80.243456,0,'2013-07-06 12:44:32',NULL,NULL),(7319,'06701','U','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.558763,-73.052179,0,'2013-07-06 12:44:30',NULL,NULL),(33151,'36925','S','York','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.466360,-88.269480,0,'2013-07-06 12:44:32',NULL,NULL),(33242,'37072','S','Millersville','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.325144,-86.737474,0,'2013-07-06 12:44:32',NULL,NULL),(28351,'31201','S','Huber','A','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.833817,-83.633712,0,'2013-07-06 12:44:32',NULL,NULL),(38903,'44118','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(27660,'30326','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.852137,-84.360463,0,'2013-07-06 12:44:31',NULL,NULL),(47942,'55115','S','White Bear Lk','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(30932,'33711','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.751284,-82.687336,0,'2013-07-06 12:44:32',NULL,NULL),(51005,'58701','S','Ruthville','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230821,-101.294119,0,'2013-07-06 12:44:33',NULL,NULL),(11925,'12422','S','West Durham','N','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.409931,-74.182742,0,'2013-07-06 12:44:30',NULL,NULL),(67163,'79832','U','Alpine','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',30.362350,-103.672744,0,'2013-07-06 12:44:34',NULL,NULL),(50437,'58002','S','Absaraka','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.977810,-97.394630,0,'2013-07-06 12:44:33',NULL,NULL),(17412,'17921','S','Big Mine Run Junction','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(76977,'96058','S','Macdoel','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.752385,-121.974524,0,'2013-07-06 12:44:34',NULL,NULL),(42844,'48073','S','Royal Oak','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.518881,-83.163476,0,'2013-07-06 12:44:32',NULL,NULL),(63958,'76093','S','Rio Vista','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.245704,-97.383650,0,'2013-07-06 12:44:34',NULL,NULL),(57708,'67345','S','Elk Falls','D','Elk','20049','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.384719,-96.271609,0,'2013-07-06 12:44:33',NULL,NULL),(7501,'06921','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.050629,-73.539664,0,'2013-07-06 12:44:30',NULL,NULL),(10911,'11428','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(41996,'47424','S','Koleen','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(60903,'72075','P','Jacksonport','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.637828,-91.190996,0,'2013-07-06 12:44:33',NULL,NULL),(31274,'34021','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(3195,'01346','S','Charlemont','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.672720,-72.834420,0,'2013-07-06 12:44:30',NULL,NULL),(80022,'99683','P','Willow','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.367280,-150.616620,0,'2013-07-06 12:44:34',NULL,NULL),(65989,'78336','S','City by the Sea','A','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.904408,-97.160091,0,'2013-07-06 12:44:34',NULL,NULL),(16341,'17129','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263185,-76.882694,0,'2013-07-06 12:44:31',NULL,NULL),(68747,'82221','S','Lagrange','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.633566,-104.354319,0,'2013-07-06 12:44:34',NULL,NULL),(64995,'77288','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.726969,-95.361707,0,'2013-07-06 12:44:34',NULL,NULL),(26330,'29053','S','Gaston','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.827254,-81.122127,0,'2013-07-06 12:44:31',NULL,NULL),(5027,'04252','S','Lisbon','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.007098,-70.061746,0,'2013-07-06 12:44:30',NULL,NULL),(46790,'53964','S','Westfield','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.920698,-89.619735,0,'2013-07-06 12:44:32',NULL,NULL),(36145,'40241','S','Broeck Pointe','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(3197,'01347','P','Lake Pleasant','D','Franklin','25011','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.557611,-72.518664,0,'2013-07-06 12:44:30',NULL,NULL),(1132,'00725','S','Villa Los Criollos','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(43237,'48315','S','Shelby Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.665560,-82.995885,0,'2013-07-06 12:44:32',NULL,NULL),(79377,'98668','P','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.721072,-122.630742,0,'2013-07-06 12:44:34',NULL,NULL),(10495,'10960','S','Nyack','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(72871,'90008','S','Leimert Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006715,-118.339229,0,'2013-07-06 12:44:34',NULL,NULL),(17646,'18071','S','Palmerton','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.808319,-75.616978,0,'2013-07-06 12:44:31',NULL,NULL),(19985,'20598','U','Mc Lean','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(3474,'01824','S','Chelmsford','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.623280,-71.364720,0,'2013-07-06 12:44:30',NULL,NULL),(49035,'56282','S','Raymond','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.020902,-95.192812,0,'2013-07-06 12:44:33',NULL,NULL),(33295,'37129','S','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.871995,-86.435491,0,'2013-07-06 12:44:32',NULL,NULL),(23271,'25142','S','Nellis','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.157540,-81.729976,0,'2013-07-06 12:44:31',NULL,NULL),(18807,'19403','S','Eagleville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(37025,'41240','S','Thealka','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(23645,'25779','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.340605,-82.518153,0,'2013-07-06 12:44:31',NULL,NULL),(51284,'59116','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.767072,-108.581669,0,'2013-07-06 12:44:33',NULL,NULL),(27774,'30370','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.752250,-84.388990,0,'2013-07-06 12:44:31',NULL,NULL),(64263,'76385','P','Vernon','D','Wilbarger','48487','Texas','TX','48','0000','940','Central',-6.0,'Y',34.154095,-99.264642,0,'2013-07-06 12:44:34',NULL,NULL),(11516,'12033','S','Brookview','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535438,-73.709070,0,'2013-07-06 12:44:30',NULL,NULL),(7063,'06332','P','Central Vlg','A','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.724456,-71.908237,0,'2013-07-06 12:44:30',NULL,NULL),(19058,'19547','S','Basket','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(12833,'13310','S','Pine Woods','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.897902,-75.574398,0,'2013-07-06 12:44:30',NULL,NULL),(26121,'28731','S','Flat Rock','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.272427,-82.419576,0,'2013-07-06 12:44:31',NULL,NULL),(42714,'48002','S','Allenton','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.908333,-82.883056,0,'2013-07-06 12:44:32',NULL,NULL),(42036,'47441','S','Stockton','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(66473,'78659','S','Paige','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.198600,-97.105380,0,'2013-07-06 12:44:34',NULL,NULL),(14730,'15286','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.458733,-80.031221,0,'2013-07-06 12:44:31',NULL,NULL),(7248,'06513','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.321735,-72.859214,0,'2013-07-06 12:44:30',NULL,NULL),(55370,'63601','S','Desloge','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(76623,'95703','S','Heather Glen','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.981227,-120.987593,0,'2013-07-06 12:44:34',NULL,NULL),(63866,'76001','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.621097,-97.154295,0,'2013-07-06 12:44:34',NULL,NULL),(4519,'03303','S','Penacook','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.303680,-71.638500,0,'2013-07-06 12:44:30',NULL,NULL),(32579,'36119','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.398077,-86.328482,0,'2013-07-06 12:44:32',NULL,NULL),(7018,'06260','S','Putnam Heights','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(29275,'32461','P','Rosemary Bch','A','Walton','12131','Florida','FL','12','6015','850','Central',-6.0,'Y',30.251077,-85.950567,0,'2013-07-06 12:44:32',NULL,NULL),(34892,'38949','S','Paris','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.176213,-89.373249,0,'2013-07-06 12:44:32',NULL,NULL),(57482,'66901','S','Ames','A','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.567727,-97.660244,0,'2013-07-06 12:44:33',NULL,NULL),(76292,'95435','P','Finley','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.005524,-122.870799,0,'2013-07-06 12:44:34',NULL,NULL),(20569,'21140','S','Riva','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.951835,-76.586544,0,'2013-07-06 12:44:31',NULL,NULL),(79991,'99660','P','St Paul','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',57.184029,-170.273301,0,'2013-07-06 12:44:34',NULL,NULL),(66853,'79166','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.204349,-101.831265,0,'2013-07-06 12:44:34',NULL,NULL),(54152,'62568','S','Taylorville','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(18791,'19381','P','W Chester','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.960448,-75.601924,0,'2013-07-06 12:44:31',NULL,NULL),(31338,'34139','P','Everglades City','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.860870,-81.381711,0,'2013-07-06 12:44:32',NULL,NULL),(44048,'49429','P','Jenison','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.890110,-85.831096,0,'2013-07-06 12:44:32',NULL,NULL),(43485,'48611','S','Auburn','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.619125,-84.089278,0,'2013-07-06 12:44:32',NULL,NULL),(24256,'26810','S','Lost City','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.907535,-78.801085,0,'2013-07-06 12:44:31',NULL,NULL),(80145,'99784','P','White Mountain','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.868292,-163.260686,0,'2013-07-06 12:44:34',NULL,NULL),(50063,'57441','S','Frederick','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.834238,-98.506058,0,'2013-07-06 12:44:33',NULL,NULL),(58010,'67870','S','Satanta','D','Haskell','20081','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.448615,-101.012179,0,'2013-07-06 12:44:33',NULL,NULL),(71303,'86503','S','Cottonwood Station','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(71784,'87560','S','Coruco','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(9510,'10016','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(45742,'52132','S','Conover','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.184136,-91.872048,0,'2013-07-06 12:44:32',NULL,NULL),(19055,'19545','P','New Berlins','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.344188,-75.633347,0,'2013-07-06 12:44:31',NULL,NULL),(22016,'23288','U','Rich','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.601923,-77.546947,0,'2013-07-06 12:44:31',NULL,NULL),(39641,'44904','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.677720,-82.614840,0,'2013-07-06 12:44:32',NULL,NULL),(17891,'18444','S','Spring Brook Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(77364,'96743','S','Kamuela','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.975127,-155.762770,0,'2013-07-06 12:44:34',NULL,NULL),(50000,'57374','S','Spencer','D','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.775257,-97.591921,0,'2013-07-06 12:44:33',NULL,NULL),(46265,'53021','S','Fredonia','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.498500,-88.005720,0,'2013-07-06 12:44:32',NULL,NULL),(45404,'51041','S','Orange City','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.001764,-96.058049,0,'2013-07-06 12:44:32',NULL,NULL),(39004,'44138','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.378304,-81.918914,0,'2013-07-06 12:44:32',NULL,NULL),(31854,'35115','S','Montevallo','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.135720,-86.848920,0,'2013-07-06 12:44:32',NULL,NULL),(24681,'27410','S','Ridgefield','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(58018,'67882','S','Wright','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.822290,-99.932330,0,'2013-07-06 12:44:33',NULL,NULL),(70374,'84656','P','Scipio','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.252203,-112.101774,0,'2013-07-06 12:44:34',NULL,NULL),(70507,'84783','S','Dammeron','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.313820,-113.668620,0,'2013-07-06 12:44:34',NULL,NULL),(79910,'99603','S','English Bay','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(52243,'60513','S','Brookfield','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.824933,-87.845112,0,'2013-07-06 12:44:33',NULL,NULL),(35741,'39730','S','Binford','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(25594,'28449','S','Fort Fisher Air Force Statio','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.997171,-77.909349,0,'2013-07-06 12:44:31',NULL,NULL),(931,'00714','S','Urb Palmar 2','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(13705,'14062','S','Forestville','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.452584,-79.157422,0,'2013-07-06 12:44:31',NULL,NULL),(46361,'53109','P','Camp Lake','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.540942,-88.140019,0,'2013-07-06 12:44:32',NULL,NULL),(59361,'70580','P','Reddell','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.672058,-92.426456,0,'2013-07-06 12:44:33',NULL,NULL),(40214,'45405','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.787602,-84.210619,0,'2013-07-06 12:44:32',NULL,NULL),(74325,'92399','S','Oak Glen','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.033763,-117.040299,0,'2013-07-06 12:44:34',NULL,NULL),(41312,'46773','S','Dixon','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(34097,'38168','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229844,-89.924595,0,'2013-07-06 12:44:32',NULL,NULL),(41550,'47016','S','Cedar Grove','D','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.368843,-84.909376,0,'2013-07-06 12:44:32',NULL,NULL),(15327,'16212','P','Cadogan','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.753301,-79.583737,0,'2013-07-06 12:44:31',NULL,NULL),(19532,'20188','P','Warrenton','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.705891,-77.839374,0,'2013-07-06 12:44:31',NULL,NULL),(30358,'33313','S','Lauderhill','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(69434,'83641','S','Guffey','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.380775,-116.549761,0,'2013-07-06 12:44:34',NULL,NULL),(67010,'79518','S','Girard','D','Kent','48263','Texas','TX','48','0000','806','Central',-6.0,'Y',33.227158,-100.558396,0,'2013-07-06 12:44:34',NULL,NULL),(56924,'66063','P','Olathe','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.880069,-94.816954,0,'2013-07-06 12:44:33',NULL,NULL),(15979,'17032','S','Waynesville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(15554,'16630','S','Cresson','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.462350,-78.590149,0,'2013-07-06 12:44:31',NULL,NULL),(25487,'28358','S','Biggs Park','N','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.630251,-79.006164,0,'2013-07-06 12:44:31',NULL,NULL),(24928,'27811','P','Bellarthur','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.583071,-77.490491,0,'2013-07-06 12:44:31',NULL,NULL),(19730,'20398','S','Washington Navy Yard','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876127,-76.994243,0,'2013-07-06 12:44:31',NULL,NULL),(29661,'32909','S','Grant Valkaria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.969161,-80.647489,0,'2013-07-06 12:44:32',NULL,NULL),(2822,'00979','S','Urb Atlantic View','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(68308,'81101','S','Estrella','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(75071,'93530','P','Keeler','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.488465,-117.872813,0,'2013-07-06 12:44:34',NULL,NULL),(54011,'62449','S','Kibble','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.001962,-87.906869,0,'2013-07-06 12:44:33',NULL,NULL),(46032,'52556','S','Beckwith','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(55146,'63361','S','Montgomery City','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(11317,'11782','S','Fire Is Pines','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746049,-73.080662,0,'2013-07-06 12:44:30',NULL,NULL),(33478,'37338','S','Graysville','D','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.450237,-85.084610,0,'2013-07-06 12:44:32',NULL,NULL),(52855,'61326','S','Granville','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.262196,-89.232755,0,'2013-07-06 12:44:33',NULL,NULL),(69355,'83546','S','Pierce','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.488420,-115.799880,0,'2013-07-06 12:44:34',NULL,NULL),(61881,'73131','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.578851,-97.470162,0,'2013-07-06 12:44:33',NULL,NULL),(19959,'20585','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886166,-77.025669,0,'2013-07-06 12:44:31',NULL,NULL),(50118,'57501','S','Pierre','D','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(5266,'04490','S','Topsfield','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.452605,-67.717492,0,'2013-07-06 12:44:30',NULL,NULL),(13064,'13450','S','Roseboom','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.694420,-74.819739,0,'2013-07-06 12:44:30',NULL,NULL),(3684,'02131','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.284730,-71.127697,0,'2013-07-06 12:44:30',NULL,NULL),(79517,'98934','P','Kittitas','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.983996,-120.421288,0,'2013-07-06 12:44:34',NULL,NULL),(26837,'29492','S','Wando','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.955719,-79.887276,0,'2013-07-06 12:44:31',NULL,NULL),(56663,'65623','P','Cassville','A','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.745097,-93.914040,0,'2013-07-06 12:44:33',NULL,NULL),(56998,'66204','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(67258,'79958','U','M Bank','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.755406,-106.489477,0,'2013-07-06 12:44:34',NULL,NULL),(63478,'75687','P','Price','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.097208,-94.941505,0,'2013-07-06 12:44:33',NULL,NULL),(58221,'68341','S','De Witt','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.391721,-96.921087,0,'2013-07-06 12:44:33',NULL,NULL),(22520,'24089','S','Fieldale','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.703940,-79.940681,0,'2013-07-06 12:44:31',NULL,NULL),(14906,'15531','S','Boswell','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.160776,-79.027400,0,'2013-07-06 12:44:31',NULL,NULL),(21830,'23115','P','Millers Tavrn','A','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.829088,-76.946007,0,'2013-07-06 12:44:31',NULL,NULL),(18295,'19015','S','Brookhaven','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868688,-75.385721,0,'2013-07-06 12:44:31',NULL,NULL),(49609,'56762','S','Angus','A','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.197279,-96.769251,0,'2013-07-06 12:44:33',NULL,NULL),(43876,'49203','S','Jackson','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.225032,-84.406836,0,'2013-07-06 12:44:32',NULL,NULL),(15547,'16621','S','Broad Top','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.202053,-78.142889,0,'2013-07-06 12:44:31',NULL,NULL),(37134,'41465','S','Duco','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(26864,'29540','S','Darlington','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.300877,-79.875675,0,'2013-07-06 12:44:31',NULL,NULL),(31358,'34203','S','Lakewood Rch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.443170,-82.531219,0,'2013-07-06 12:44:32',NULL,NULL),(20875,'21675','S','Wingate','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.291143,-76.091675,0,'2013-07-06 12:44:31',NULL,NULL),(18303,'19018','S','Clifton Heights','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(49941,'57335','S','Fairfax','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.060860,-98.766233,0,'2013-07-06 12:44:33',NULL,NULL),(80114,'99761','P','Noatak','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',67.296703,-163.011832,0,'2013-07-06 12:44:34',NULL,NULL),(75258,'93665','P','South Dos Palos','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',36.965202,-120.654813,0,'2013-07-06 12:44:34',NULL,NULL),(25297,'28139','S','Westminster','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(18527,'19107','S','William Penn Annex West','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.948927,-75.158663,0,'2013-07-06 12:44:31',NULL,NULL),(23461,'25430','S','Middleway','A','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.341984,-77.943268,0,'2013-07-06 12:44:31',NULL,NULL),(31692,'34789','P','Leesburg','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.809564,-81.882467,0,'2013-07-06 12:44:32',NULL,NULL),(62256,'74005','P','Bville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.748499,-95.980696,0,'2013-07-06 12:44:33',NULL,NULL),(67138,'79762','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.888806,-102.365185,0,'2013-07-06 12:44:34',NULL,NULL),(16746,'17509','S','Christiana','D','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(23460,'25430','S','Kearneysville','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.341984,-77.943268,0,'2013-07-06 12:44:31',NULL,NULL),(36335,'40402','S','Annville','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.303317,-84.007453,0,'2013-07-06 12:44:32',NULL,NULL),(33811,'37918','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.049059,-83.918501,0,'2013-07-06 12:44:32',NULL,NULL),(39470,'44714','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.829869,-81.364581,0,'2013-07-06 12:44:32',NULL,NULL),(24598,'27326','S','Quick','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(13777,'14145','S','Sheldon','N','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.738540,-78.424560,0,'2013-07-06 12:44:31',NULL,NULL),(27288,'30004','S','Alpharetta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.122744,-84.296757,0,'2013-07-06 12:44:31',NULL,NULL),(52382,'60626','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.005107,-87.669133,0,'2013-07-06 12:44:33',NULL,NULL),(71924,'87830','S','Apache Creek','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652664,-108.764998,0,'2013-07-06 12:44:34',NULL,NULL),(10698,'11223','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.596460,-73.972916,0,'2013-07-06 12:44:30',NULL,NULL),(37959,'42720','P','Cane Valley','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.170284,-85.326171,0,'2013-07-06 12:44:32',NULL,NULL),(41612,'47119','S','Navilleton','A','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.356200,-85.904760,0,'2013-07-06 12:44:32',NULL,NULL),(19906,'20546','U','Natl Aero and Space Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.883971,-76.989253,0,'2013-07-06 12:44:31',NULL,NULL),(4430,'03238','P','Glencliff','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.979647,-71.896510,0,'2013-07-06 12:44:30',NULL,NULL),(24085,'26501','S','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.569424,-79.992081,0,'2013-07-06 12:44:31',NULL,NULL),(63824,'75972','S','White Rock','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(32643,'36206','S','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.720033,-85.832356,0,'2013-07-06 12:44:32',NULL,NULL),(7119,'06378','S','Stonington','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.344260,-71.911442,0,'2013-07-06 12:44:30',NULL,NULL),(48017,'55172','P','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.963635,-93.085354,0,'2013-07-06 12:44:33',NULL,NULL),(1529,'00754','S','Urb Savannah Real','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(35598,'39581','S','Pascagoula','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.491609,-88.505551,0,'2013-07-06 12:44:32',NULL,NULL),(13592,'13850','S','Tracy Creek','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(40921,'46275','U','Time Life Inc','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.767780,-86.157755,0,'2013-07-06 12:44:32',NULL,NULL),(19689,'20373','U','Naval Anacost Annex','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(72059,'88115','P','Dora','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.939222,-103.334162,0,'2013-07-06 12:44:34',NULL,NULL),(31563,'34611','P','Brooksville','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.482064,-82.561085,0,'2013-07-06 12:44:32',NULL,NULL),(38413,'43540','S','Metamora','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.702703,-83.933406,0,'2013-07-06 12:44:32',NULL,NULL),(10825,'11379','S','Middle Vlg','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715870,-73.882583,0,'2013-07-06 12:44:30',NULL,NULL),(6561,'05848','P','Lwr Waterford','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.355575,-71.908056,0,'2013-07-06 12:44:30',NULL,NULL),(22852,'24535','P','Cluster Springs','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.585431,-79.033084,0,'2013-07-06 12:44:31',NULL,NULL),(36,'00603','S','Urb Ramey','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(21026,'21862','S','Berlin','N','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.396558,-75.213903,0,'2013-07-06 12:44:31',NULL,NULL),(37087,'41339','S','Frozen Creek','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(54558,'62891','P','Valier','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.019529,-89.043211,0,'2013-07-06 12:44:33',NULL,NULL),(50197,'57569','S','Reliance','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.832195,-99.527936,0,'2013-07-06 12:44:33',NULL,NULL),(12249,'12828','S','Fort Edward','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.271395,-73.587390,0,'2013-07-06 12:44:30',NULL,NULL),(14655,'15237','S','McKnight','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.549733,-80.039957,0,'2013-07-06 12:44:31',NULL,NULL),(55246,'63447','S','La Belle','D','Lewis','29111','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.105774,-91.914071,0,'2013-07-06 12:44:33',NULL,NULL),(44899,'50323','S','Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.626717,-93.801260,0,'2013-07-06 12:44:32',NULL,NULL),(29762,'33008','P','Hallandale Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986952,-80.140539,0,'2013-07-06 12:44:32',NULL,NULL),(33249,'37077','P','Hendersonvlle','A','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.304003,-86.619156,0,'2013-07-06 12:44:32',NULL,NULL),(12894,'13332','S','South Hamilton','N','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(26983,'29620','S','Abbeville','D','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.175299,-82.379012,0,'2013-07-06 12:44:31',NULL,NULL),(22542,'24126','P','Newbern','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.091186,-80.655659,0,'2013-07-06 12:44:31',NULL,NULL),(63837,'75974','S','Flat Fork','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(15339,'16226','S','Ford City','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.765717,-79.528243,0,'2013-07-06 12:44:31',NULL,NULL),(5580,'04912','S','Athens','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.954513,-69.662463,0,'2013-07-06 12:44:30',NULL,NULL),(34016,'38126','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.124020,-90.041534,0,'2013-07-06 12:44:32',NULL,NULL),(24672,'27408','S','Plaza','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.106359,-79.817365,0,'2013-07-06 12:44:31',NULL,NULL),(49713,'57036','S','Hurley','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.287240,-97.160340,0,'2013-07-06 12:44:33',NULL,NULL),(55445,'63701','S','Cape Girardeau','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.318976,-89.540608,0,'2013-07-06 12:44:33',NULL,NULL),(30284,'33261','P','Biscayne Park','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.891214,-80.181179,0,'2013-07-06 12:44:32',NULL,NULL),(37774,'42348','S','Arrington Corner','N','Hancock','21091','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.794496,-86.850476,0,'2013-07-06 12:44:32',NULL,NULL),(6769,'06096','S','Windsor Locks','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.925995,-72.643635,0,'2013-07-06 12:44:30',NULL,NULL),(1682,'00777','S','Haciendas de Tena','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(74749,'93061','P','Santa Paula','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.352648,-119.056905,0,'2013-07-06 12:44:34',NULL,NULL),(14219,'14788','P','Westons Mills','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.060494,-78.380393,0,'2013-07-06 12:44:31',NULL,NULL),(16431,'17233','S','Andover','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(2360,'00949','S','Hacienda del Norte','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(79527,'98938','S','Outlook','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.365661,-120.099166,0,'2013-07-06 12:44:34',NULL,NULL),(72603,'89411','P','Genoa','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.011047,-119.841497,0,'2013-07-06 12:44:34',NULL,NULL),(57406,'66763','S','Frontenac','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.452009,-94.696379,0,'2013-07-06 12:44:33',NULL,NULL),(28023,'30630','S','Crawford','D','Oglethorpe','13221','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.904531,-83.191795,0,'2013-07-06 12:44:31',NULL,NULL),(36601,'40977','S','Callaway','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(2393,'00949','S','Urb San Pedro','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(2642,'00966','S','Bo Buen Samaritano','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(64290,'76446','S','Lingleville','A','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.087767,-98.341739,0,'2013-07-06 12:44:34',NULL,NULL),(5629,'04944','P','Hinckley','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.665618,-69.634653,0,'2013-07-06 12:44:30',NULL,NULL),(77254,'96550','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(24155,'26585','S','Metz','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.612151,-80.438407,0,'2013-07-06 12:44:31',NULL,NULL),(21073,'22015','S','Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.790084,-77.280669,0,'2013-07-06 12:44:31',NULL,NULL),(22331,'23867','S','Jarratt','D','Greensville','51081','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.814192,-77.473012,0,'2013-07-06 12:44:31',NULL,NULL),(48243,'55422','S','Robbinsdale','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.008220,-93.339300,0,'2013-07-06 12:44:33',NULL,NULL),(71996,'88033','P','Old Picacho','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.310850,-107.036454,0,'2013-07-06 12:44:34',NULL,NULL),(69922,'84110','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756105,-111.897245,0,'2013-07-06 12:44:34',NULL,NULL),(11552,'12056','S','Duanesburg','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.766140,-74.139540,0,'2013-07-06 12:44:30',NULL,NULL),(21289,'22350','U','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853006,-77.123393,0,'2013-07-06 12:44:31',NULL,NULL),(10556,'11002','P','Floral Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.720452,-73.707429,0,'2013-07-06 12:44:30',NULL,NULL),(768,'00692','S','Urb Las Palmas Cerro Gordo','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(63175,'75404','P','Greenville','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.192834,-96.105463,0,'2013-07-06 12:44:33',NULL,NULL),(69904,'84107','S','Murray','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(78324,'97914','S','Cairo','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.052879,-116.984744,0,'2013-07-06 12:44:34',NULL,NULL),(62813,'74947','P','Monroe','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.993178,-94.514611,0,'2013-07-06 12:44:33',NULL,NULL),(53257,'61702','P','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.606096,-88.982513,0,'2013-07-06 12:44:33',NULL,NULL),(4785,'03868','S','East Rochester','N','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.336620,-70.947300,0,'2013-07-06 12:44:30',NULL,NULL),(6269,'05604','U','National Life Ins','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.257063,-72.587791,0,'2013-07-06 12:44:30',NULL,NULL),(26500,'29169','S','South Congaree','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(39605,'44875','S','Shelby','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(69055,'83230','S','Soda Springs','A','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.732720,-111.533520,0,'2013-07-06 12:44:34',NULL,NULL),(57442,'66838','S','Burdick','D','Morris','20127','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.567261,-96.820334,0,'2013-07-06 12:44:33',NULL,NULL),(55087,'63301','S','Black Walnut','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(51109,'58783','S','Souris','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.920760,-100.825620,0,'2013-07-06 12:44:33',NULL,NULL),(12925,'13340','S','North Ilion','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.040165,-75.082322,0,'2013-07-06 12:44:30',NULL,NULL),(4371,'03073','P','North Salem','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.835016,-71.224246,0,'2013-07-06 12:44:30',NULL,NULL),(26974,'29614','U','Bob Jones University','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.910320,-82.409036,0,'2013-07-06 12:44:31',NULL,NULL),(4789,'03871','P','Rye Beach','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.991996,-70.760985,0,'2013-07-06 12:44:30',NULL,NULL),(71074,'85912','P','White Mtn Lk','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.322282,-110.075598,0,'2013-07-06 12:44:34',NULL,NULL),(73538,'91352','S','Shadow Hills','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.224912,-118.360350,0,'2013-07-06 12:44:34',NULL,NULL),(69544,'83804','S','Blanchard','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.013661,-116.955335,0,'2013-07-06 12:44:34',NULL,NULL),(53946,'62419','S','Calhoun','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.723920,-88.185778,0,'2013-07-06 12:44:33',NULL,NULL),(53288,'61727','S','Jenkins','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(72253,'88530','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.809820,-106.419658,0,'2013-07-06 12:44:34',NULL,NULL),(61731,'73024','S','Corn','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.377248,-98.782494,0,'2013-07-06 12:44:33',NULL,NULL),(27376,'30074','P','Lithonia','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.744614,-84.135993,0,'2013-07-06 12:44:31',NULL,NULL),(49534,'56679','P','South International Falls','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.587388,-93.399406,0,'2013-07-06 12:44:33',NULL,NULL),(33836,'37934','S','Concord','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(23895,'26184','S','Waverly','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.323032,-81.422838,0,'2013-07-06 12:44:31',NULL,NULL),(29006,'32223','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.158207,-81.624997,0,'2013-07-06 12:44:32',NULL,NULL),(11713,'12170','S','Stillwater','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.933960,-73.690380,0,'2013-07-06 12:44:30',NULL,NULL),(8466,'08088','S','Tabernacle','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(54567,'62895','S','Wayne City','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(23332,'25243','S','Harmony','A','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.706480,-81.426000,0,'2013-07-06 12:44:31',NULL,NULL),(17988,'18622','S','Huntington Ml','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.198934,-76.198272,0,'2013-07-06 12:44:31',NULL,NULL),(36698,'41017','S','Dixie','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(13861,'14228','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.025880,-78.795360,0,'2013-07-06 12:44:31',NULL,NULL),(47379,'54629','S','Fountain City','D','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.128251,-91.715157,0,'2013-07-06 12:44:32',NULL,NULL),(4257,'02879','S','Peace Dale','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(8273,'08010','S','Edgewater Park','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.058892,-74.910433,0,'2013-07-06 12:44:30',NULL,NULL),(36144,'40241','S','Barbourmeade','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(43119,'48227','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.389657,-83.193613,0,'2013-07-06 12:44:32',NULL,NULL),(3436,'01749','S','Hudson','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.388756,-71.557437,0,'2013-07-06 12:44:30',NULL,NULL),(31207,'33949','P','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.975820,-82.090800,0,'2013-07-06 12:44:32',NULL,NULL),(38754,'44036','P','Elyria','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.367756,-82.098511,0,'2013-07-06 12:44:32',NULL,NULL),(55868,'64188','P','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.099722,-94.578333,0,'2013-07-06 12:44:33',NULL,NULL),(21967,'23241','P','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.585084,-77.420677,0,'2013-07-06 12:44:31',NULL,NULL),(13677,'14038','P','Crittenden','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.948673,-78.476057,0,'2013-07-06 12:44:31',NULL,NULL),(69130,'83285','S','Wayan','D','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.951741,-111.173683,0,'2013-07-06 12:44:34',NULL,NULL),(42579,'47879','S','Scott City','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(34396,'38622','P','Crowder','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.172593,-90.135281,0,'2013-07-06 12:44:32',NULL,NULL),(40781,'46163','S','Brookville Heights','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.734334,-85.908374,0,'2013-07-06 12:44:32',NULL,NULL),(69167,'83323','S','Cotterel','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.518218,-113.627087,0,'2013-07-06 12:44:34',NULL,NULL),(66830,'79102','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.200174,-101.841114,0,'2013-07-06 12:44:34',NULL,NULL),(35481,'39520','S','Waveland','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(30242,'33194','S','West Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.758515,-80.391867,0,'2013-07-06 12:44:32',NULL,NULL),(62545,'74437','S','Coalton','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(61052,'72120','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.892804,-92.231859,0,'2013-07-06 12:44:33',NULL,NULL),(54390,'62817','S','Walpole','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.960013,-88.453753,0,'2013-07-06 12:44:33',NULL,NULL),(40348,'45623','S','Crown City','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.616537,-82.261858,0,'2013-07-06 12:44:32',NULL,NULL),(27615,'30306','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.786536,-84.349237,0,'2013-07-06 12:44:31',NULL,NULL),(32460,'36027','S','Eufaula','D','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.884947,-85.153904,0,'2013-07-06 12:44:32',NULL,NULL),(52331,'60566','P','Naperville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.744942,-88.127269,0,'2013-07-06 12:44:33',NULL,NULL),(42424,'47802','S','Spring Valley Estates','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(5970,'05340','S','Bondville','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.155180,-72.907980,0,'2013-07-06 12:44:30',NULL,NULL),(60974,'72106','S','Lollie','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.969289,-92.431561,0,'2013-07-06 12:44:33',NULL,NULL),(36191,'40257','P','St Matthews','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(42464,'47834','S','Bee Ridge','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(20193,'20749','P','Ft Washington','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.733525,-77.003006,0,'2013-07-06 12:44:31',NULL,NULL),(61086,'72131','S','Quitman','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.378007,-92.210229,0,'2013-07-06 12:44:33',NULL,NULL),(53494,'62006','S','Beechville','N','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.087140,-90.668661,0,'2013-07-06 12:44:33',NULL,NULL),(27181,'29847','S','Eureka','N','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.701160,-81.819780,0,'2013-07-06 12:44:31',NULL,NULL),(28192,'31016','S','Culloden','D','Monroe','13207','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.776113,-84.183821,0,'2013-07-06 12:44:31',NULL,NULL),(37182,'41501','S','Pikeville','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(75566,'94267','U','Franchise Tax Board','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582798,-121.490569,0,'2013-07-06 12:44:34',NULL,NULL),(66186,'78538','S','Edcouch','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.309820,-97.959000,0,'2013-07-06 12:44:34',NULL,NULL),(5545,'04846','P','Glen Cove','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.133880,-69.092509,0,'2013-07-06 12:44:30',NULL,NULL),(12921,'13339','S','Starkville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(77751,'97103','S','Astoria','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.181734,-123.826767,0,'2013-07-06 12:44:34',NULL,NULL),(61039,'72118','S','N L R','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(25108,'27973','S','Shawboro','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.376797,-76.085192,0,'2013-07-06 12:44:31',NULL,NULL),(24237,'26753','S','Ridgeley','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.600960,-78.784140,0,'2013-07-06 12:44:31',NULL,NULL),(13440,'13762','P','Endwell','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.107199,-76.023903,0,'2013-07-06 12:44:31',NULL,NULL),(48700,'55939','S','Harmony','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.557088,-92.010857,0,'2013-07-06 12:44:33',NULL,NULL),(6082,'05450','S','East Enosburg','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(10878,'11419','S','South Richmond Hill','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.688921,-73.823304,0,'2013-07-06 12:44:30',NULL,NULL),(246,'00637','S','Urb El Arrendado','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(1630,'00771','S','Repto Arenales','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(43560,'48725','S','Caseville','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.947964,-83.234180,0,'2013-07-06 12:44:32',NULL,NULL),(1392,'00738','S','Terr Demajagua','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(24581,'27316','S','Ramseur','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.703120,-79.624200,0,'2013-07-06 12:44:31',NULL,NULL),(58493,'68761','S','Oakdale','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.047944,-97.951963,0,'2013-07-06 12:44:33',NULL,NULL),(33495,'37352','S','Lynchburg','D','Moore','47127','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.261755,-86.382944,0,'2013-07-06 12:44:32',NULL,NULL),(69345,'83540','S','Lapwai','D','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.404644,-116.807243,0,'2013-07-06 12:44:34',NULL,NULL),(243,'00637','S','Parc Maginas','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(73178,'90402','S','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.035904,-118.502559,0,'2013-07-06 12:44:34',NULL,NULL),(21123,'22096','U','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.949859,-77.344333,0,'2013-07-06 12:44:31',NULL,NULL),(18772,'19358','P','Modena','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.960480,-75.801461,0,'2013-07-06 12:44:31',NULL,NULL),(25503,'28374','S','Pinehurst','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.186997,-79.467297,0,'2013-07-06 12:44:31',NULL,NULL),(79302,'98589','S','Tenino','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.856995,-122.844950,0,'2013-07-06 12:44:34',NULL,NULL),(76505,'95640','S','Carbondale','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.329832,-120.932789,0,'2013-07-06 12:44:34',NULL,NULL),(69072,'83241','S','Niter','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(63529,'75756','S','Edom','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295120,-95.623500,0,'2013-07-06 12:44:33',NULL,NULL),(55139,'63357','S','Marthasville','D','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634000,-91.100160,0,'2013-07-06 12:44:33',NULL,NULL),(40946,'46301','P','Beverly Shrs','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.672687,-86.973604,0,'2013-07-06 12:44:32',NULL,NULL),(10063,'10177','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(50436,'58001','P','Abercrombie','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.416396,-96.715727,0,'2013-07-06 12:44:33',NULL,NULL),(15888,'17004','S','Belleville','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.603109,-77.720588,0,'2013-07-06 12:44:31',NULL,NULL),(17434,'17931','S','Englewood','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779310,-76.233926,0,'2013-07-06 12:44:31',NULL,NULL),(8115,'07821','S','Green Twp','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.967267,-74.766575,0,'2013-07-06 12:44:30',NULL,NULL),(40889,'46247','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.675539,-86.129380,0,'2013-07-06 12:44:32',NULL,NULL),(40454,'45741','S','Langsville','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.062820,-82.249860,0,'2013-07-06 12:44:32',NULL,NULL),(31037,'33806','P','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.028910,-81.955237,0,'2013-07-06 12:44:32',NULL,NULL),(47515,'54774','U','Chippewa Falls','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.933706,-91.391510,0,'2013-07-06 12:44:32',NULL,NULL),(74624,'92804','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.818606,-117.972857,0,'2013-07-06 12:44:34',NULL,NULL),(76368,'95502','P','Eureka','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.786017,-124.192160,0,'2013-07-06 12:44:34',NULL,NULL),(69542,'83802','S','Avery','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.223188,-115.815910,0,'2013-07-06 12:44:34',NULL,NULL),(10466,'10932','P','Howells','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.480603,-74.463537,0,'2013-07-06 12:44:30',NULL,NULL),(34238,'38380','S','Sugar Tree','D','Decatur','47039','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.781661,-87.994033,0,'2013-07-06 12:44:32',NULL,NULL),(1037,'00721','P','Palmer','D','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.371798,-65.774509,0,'2013-07-06 12:44:30',NULL,NULL),(11536,'12043','S','Seward','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(5597,'04924','S','Canaan','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.755486,-69.554143,0,'2013-07-06 12:44:30',NULL,NULL),(9645,'10037','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(65203,'77434','S','Elm Grove','N','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.591280,-96.340440,0,'2013-07-06 12:44:34',NULL,NULL),(79093,'98439','S','McChord AFB','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(33146,'36919','S','Bolinger','A','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.762783,-88.300013,0,'2013-07-06 12:44:32',NULL,NULL),(26767,'29438','S','Edisto','A','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.569486,-80.310046,0,'2013-07-06 12:44:31',NULL,NULL),(12164,'12750','S','Kenoza Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.778207,-74.933450,0,'2013-07-06 12:44:30',NULL,NULL),(7586,'07034','S','Lk Hiawatha','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.879225,-74.384333,0,'2013-07-06 12:44:30',NULL,NULL),(78638,'98221','S','Similk Beach','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.498900,-122.607300,0,'2013-07-06 12:44:34',NULL,NULL),(63010,'75163','S','Trinidad','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.201032,-96.107269,0,'2013-07-06 12:44:33',NULL,NULL),(60084,'71357','S','Newlight','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(61989,'73344','U','Internal Revenue Service','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.176174,-97.729218,0,'2013-07-06 12:44:33',NULL,NULL),(7987,'07712','S','Wayside','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(3780,'02201','U','Boston City Hall','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.359359,-71.059528,0,'2013-07-06 12:44:30',NULL,NULL),(5182,'04441','S','Lily Bay Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(45512,'51401','S','Carroll','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.047220,-94.865160,0,'2013-07-06 12:44:32',NULL,NULL),(39046,'44188','U','Firestone Tire & Rub Co','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.400504,-81.826781,0,'2013-07-06 12:44:32',NULL,NULL),(75096,'93536','S','Neenach','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(65529,'77801','S','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(57597,'67105','S','Milan','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.257763,-97.675280,0,'2013-07-06 12:44:33',NULL,NULL),(55900,'64437','S','Bigelow','A','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.156812,-95.358379,0,'2013-07-06 12:44:33',NULL,NULL),(52115,'60422','S','Homewood','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.540319,-87.682222,0,'2013-07-06 12:44:33',NULL,NULL),(75178,'93606','P','Biola','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.802578,-120.018346,0,'2013-07-06 12:44:34',NULL,NULL),(17541,'17976','S','Shenandoah','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(36389,'40486','S','Tyner','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.378148,-83.874828,0,'2013-07-06 12:44:32',NULL,NULL),(13958,'14467','S','Henrietta','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.053743,-77.609162,0,'2013-07-06 12:44:31',NULL,NULL),(17578,'18014','S','Chapmans','N','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.757035,-75.401241,0,'2013-07-06 12:44:31',NULL,NULL),(4437,'03243','S','Hill','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.511344,-71.760740,0,'2013-07-06 12:44:30',NULL,NULL),(78859,'98343','P','Joyce','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.139728,-123.732852,0,'2013-07-06 12:44:34',NULL,NULL),(27994,'30597','U','North Georgia College','N','Lumpkin','13187','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.528036,-83.987193,0,'2013-07-06 12:44:31',NULL,NULL),(29603,'32835','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.516600,-81.481682,0,'2013-07-06 12:44:32',NULL,NULL),(21300,'22403','P','Fred','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.350856,-77.477360,0,'2013-07-06 12:44:31',NULL,NULL),(9189,'09382','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58614,'68858','S','Armada','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.958042,-99.365640,0,'2013-07-06 12:44:33',NULL,NULL),(65720,'78024','S','Hunt','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',30.075707,-99.324584,0,'2013-07-06 12:44:34',NULL,NULL),(65465,'77625','S','Kountze','D','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.313900,-94.284907,0,'2013-07-06 12:44:34',NULL,NULL),(15345,'16234','P','Limestone','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.136206,-79.295772,0,'2013-07-06 12:44:31',NULL,NULL),(42515,'47849','S','Riverview','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.214283,-87.524549,0,'2013-07-06 12:44:32',NULL,NULL),(40113,'45322','S','Englewood','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.884040,-84.346800,0,'2013-07-06 12:44:32',NULL,NULL),(2396,'00949','S','Urb Valparaiso','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(46525,'53290','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036612,-87.912064,0,'2013-07-06 12:44:32',NULL,NULL),(35644,'39641','S','Bristers','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(5922,'05251','S','South Dorset','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.222500,-73.073889,0,'2013-07-06 12:44:30',NULL,NULL),(11584,'12074','S','Mosherville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.032199,-74.036378,0,'2013-07-06 12:44:30',NULL,NULL),(26202,'28775','S','Scaly Mtn','A','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.014232,-83.333640,0,'2013-07-06 12:44:31',NULL,NULL),(63775,'75951','S','Curtis','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(56437,'65270','S','Moberly','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.418214,-92.439228,0,'2013-07-06 12:44:33',NULL,NULL),(74716,'93016','P','Fillmore','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.401111,-118.911775,0,'2013-07-06 12:44:34',NULL,NULL),(29180,'32362','P','Woodville','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.314652,-84.264359,0,'2013-07-06 12:44:32',NULL,NULL),(8739,'08520','S','E Windsor','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.255080,-74.515680,0,'2013-07-06 12:44:30',NULL,NULL),(22539,'24121','S','Scruggs','N','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.100237,-79.662578,0,'2013-07-06 12:44:31',NULL,NULL),(38534,'43738','P','Fultonham','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.857321,-82.138540,0,'2013-07-06 12:44:32',NULL,NULL),(21354,'22437','S','Center Cross','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.781797,-76.758304,0,'2013-07-06 12:44:31',NULL,NULL),(31880,'35126','S','Pinson','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.726300,-86.643960,0,'2013-07-06 12:44:32',NULL,NULL),(17493,'17960','S','Rauschs','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(60829,'72037','P','Coy','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.537779,-91.873895,0,'2013-07-06 12:44:33',NULL,NULL),(77088,'96134','S','Tionesta','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.949725,-121.472495,0,'2013-07-06 12:44:34',NULL,NULL),(76074,'95207','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.001880,-121.323361,0,'2013-07-06 12:44:34',NULL,NULL),(72935,'90035','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.051619,-118.383580,0,'2013-07-06 12:44:34',NULL,NULL),(59042,'70085','S','Kenilworth','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(5530,'04780','S','Merrill','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.166860,-68.269882,0,'2013-07-06 12:44:30',NULL,NULL),(11131,'11706','S','Point O Woods','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(10199,'10309','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.530762,-74.213351,0,'2013-07-06 12:44:30',NULL,NULL),(22839,'24522','S','Appomattox','D','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.344372,-78.826984,0,'2013-07-06 12:44:31',NULL,NULL),(15918,'17018','S','Water Gap','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.370886,-76.931434,0,'2013-07-06 12:44:31',NULL,NULL),(80183,'99850','P','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.475480,-134.156767,0,'2013-07-06 12:44:34',NULL,NULL),(54883,'63068','S','Campbellton','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(53784,'62278','S','Grigg','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.179200,-89.979600,0,'2013-07-06 12:44:33',NULL,NULL),(78602,'98189','U','Diagnos Techs Inc Mrs','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.610236,-122.341839,0,'2013-07-06 12:44:34',NULL,NULL),(71997,'88034','S','Faywood','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.588497,-107.933514,0,'2013-07-06 12:44:34',NULL,NULL),(69895,'84105','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.734214,-111.856179,0,'2013-07-06 12:44:34',NULL,NULL),(69274,'83440','S','Burton','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(26439,'29130','S','Longtown','N','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.326001,-80.760553,0,'2013-07-06 12:44:31',NULL,NULL),(14303,'14882','S','Lansing','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.563160,-76.554840,0,'2013-07-06 12:44:31',NULL,NULL),(32632,'36191','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.326539,-86.276619,0,'2013-07-06 12:44:32',NULL,NULL),(7643,'07072','S','Carlstadt','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.834310,-74.083962,0,'2013-07-06 12:44:30',NULL,NULL),(52534,'60926','P','Claytonville','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.569513,-87.823184,0,'2013-07-06 12:44:33',NULL,NULL),(60408,'71639','S','Avery','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(62362,'74067','P','Sepulpa','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.986469,-96.117351,0,'2013-07-06 12:44:33',NULL,NULL),(62462,'74331','S','Monkey Island','A','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(76254,'95406','P','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.459917,-122.727704,0,'2013-07-06 12:44:34',NULL,NULL),(72930,'90032','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.080616,-118.174263,0,'2013-07-06 12:44:34',NULL,NULL),(66675,'78932','S','Carmine','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.131389,-96.693393,0,'2013-07-06 12:44:34',NULL,NULL),(56363,'65211','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.948231,-92.327335,0,'2013-07-06 12:44:33',NULL,NULL),(25411,'28296','U','Wachovia Bank','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.213020,-80.827367,0,'2013-07-06 12:44:31',NULL,NULL),(26033,'28681','S','Kilby','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(4950,'04097','S','North Yarmouth','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.845033,-70.235599,0,'2013-07-06 12:44:30',NULL,NULL),(29908,'33052','P','Marathon Shores','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.724766,-81.062436,0,'2013-07-06 12:44:32',NULL,NULL),(50006,'57380','S','Wagner','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.078076,-98.292700,0,'2013-07-06 12:44:33',NULL,NULL),(3528,'01899','U','Bar Coded Irs','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.650375,-71.184561,0,'2013-07-06 12:44:30',NULL,NULL),(20695,'21250','U','Baltimore','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252457,-76.711210,0,'2013-07-06 12:44:31',NULL,NULL),(9379,'09837','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(1001,'00717','S','Urb El Bosque','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(68993,'83127','S','Star Vly Rnch','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.972890,-110.971354,0,'2013-07-06 12:44:34',NULL,NULL),(42865,'48081','S','St Clair Shrs','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(15338,'16225','P','Fisher','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.266056,-79.251978,0,'2013-07-06 12:44:31',NULL,NULL),(47885,'55101','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.972055,-93.082709,0,'2013-07-06 12:44:33',NULL,NULL),(19031,'19536','P','Lyon Station','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.480714,-75.757241,0,'2013-07-06 12:44:31',NULL,NULL),(56015,'64657','S','McFall','N','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.104867,-94.328531,0,'2013-07-06 12:44:33',NULL,NULL),(76637,'95715','P','Blue Canyon','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.270480,-120.616200,0,'2013-07-06 12:44:34',NULL,NULL),(77840,'97220','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.543396,-122.553975,0,'2013-07-06 12:44:34',NULL,NULL),(45140,'50579','S','Lavinia','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(76038,'95155','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.311400,-121.900813,0,'2013-07-06 12:44:34',NULL,NULL),(72905,'90022','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.022686,-118.152363,0,'2013-07-06 12:44:34',NULL,NULL),(23787,'25986','P','Spring Dale','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.870864,-80.812490,0,'2013-07-06 12:44:31',NULL,NULL),(17251,'17841','S','Bannerville','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(62153,'73726','S','Carmen','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.577425,-98.459621,0,'2013-07-06 12:44:33',NULL,NULL),(23775,'25976','S','Meadow Bridge','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.866798,-80.852381,0,'2013-07-06 12:44:31',NULL,NULL),(17660,'18084','P','Sumneytown','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.323169,-75.456240,0,'2013-07-06 12:44:31',NULL,NULL),(12500,'13021','S','Aurelius','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(38784,'44055','S','South Lorain','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.434380,-82.137420,0,'2013-07-06 12:44:32',NULL,NULL),(6560,'05848','P','Lower Waterford','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.355575,-71.908056,0,'2013-07-06 12:44:30',NULL,NULL),(79180,'98520','S','Wishkah','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(76237,'95389','S','Tuolumne Mdws','A','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(74729,'93036','S','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.215746,-119.179322,0,'2013-07-06 12:44:34',NULL,NULL),(33190,'37034','S','Chapel Hill','D','Marshall','47117','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.621639,-86.617769,0,'2013-07-06 12:44:32',NULL,NULL),(50056,'57438','S','Miranda','A','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.035596,-99.120562,0,'2013-07-06 12:44:33',NULL,NULL),(48511,'55744','S','Grand Rapids','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.233828,-93.522105,0,'2013-07-06 12:44:33',NULL,NULL),(47150,'54465','S','Pickerel','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.374025,-88.895950,0,'2013-07-06 12:44:32',NULL,NULL),(25973,'28659','S','N Wilkesboro','A','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(68842,'82524','P','Saint Stephens','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.986090,-108.418042,0,'2013-07-06 12:44:34',NULL,NULL),(51292,'59214','S','Brockway','D','McCone','30055','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.214915,-105.839514,0,'2013-07-06 12:44:33',NULL,NULL),(14232,'14809','S','Wallace','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.417120,-77.456640,0,'2013-07-06 12:44:31',NULL,NULL),(14450,'15104','S','Rankin','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.406423,-79.863859,0,'2013-07-06 12:44:31',NULL,NULL),(10418,'10707','S','Tuckahoe','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955489,-73.813597,0,'2013-07-06 12:44:30',NULL,NULL),(914,'00707','S','Jard los Almendros','N','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(16335,'17127','U','Department of Revenue','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263282,-76.876977,0,'2013-07-06 12:44:31',NULL,NULL),(28414,'31323','S','Retreat','N','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.726286,-81.469983,0,'2013-07-06 12:44:32',NULL,NULL),(41199,'46725','S','Collins','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(28081,'30731','S','Cloudland','A','Chattooga','13055','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.622640,-85.497720,0,'2013-07-06 12:44:31',NULL,NULL),(62804,'74939','S','Hodgen','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.756875,-94.602781,0,'2013-07-06 12:44:33',NULL,NULL),(53825,'62298','S','Tipton','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(75936,'95026','P','Holy City','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.155014,-121.982515,0,'2013-07-06 12:44:34',NULL,NULL),(74962,'93427','S','Buellton','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.628220,-120.254090,0,'2013-07-06 12:44:34',NULL,NULL),(67932,'80909','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.852846,-104.761164,0,'2013-07-06 12:44:34',NULL,NULL),(34116,'38184','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.185496,-89.864856,0,'2013-07-06 12:44:32',NULL,NULL),(53324,'61745','S','Lyttleville','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.318102,-88.971388,0,'2013-07-06 12:44:33',NULL,NULL),(66500,'78680','P','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.446285,-97.668129,0,'2013-07-06 12:44:34',NULL,NULL),(50415,'57785','S','Fairpoint','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(68536,'81415','S','Crawford','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.710743,-107.615416,0,'2013-07-06 12:44:34',NULL,NULL),(61770,'73059','S','Minco','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.310905,-97.948522,0,'2013-07-06 12:44:33',NULL,NULL),(53298,'61733','S','Deer Creek','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.628434,-89.327437,0,'2013-07-06 12:44:33',NULL,NULL),(40202,'45387','S','Yellow Spgs','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.798844,-83.897655,0,'2013-07-06 12:44:32',NULL,NULL),(51444,'59472','S','Sand Coulee','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.394577,-111.164252,0,'2013-07-06 12:44:33',NULL,NULL),(52399,'60634','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.944287,-87.811483,0,'2013-07-06 12:44:33',NULL,NULL),(40455,'45742','S','Little Hocking','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.283437,-81.692064,0,'2013-07-06 12:44:32',NULL,NULL),(6835,'06117','S','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(73934,'92038','P','La Jolla','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.853445,-117.251737,0,'2013-07-06 12:44:34',NULL,NULL),(68798,'82422','P','Emblem','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.504822,-108.389275,0,'2013-07-06 12:44:34',NULL,NULL),(30351,'33312','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.088164,-80.184514,0,'2013-07-06 12:44:32',NULL,NULL),(41953,'47402','P','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.095551,-86.472738,0,'2013-07-06 12:44:32',NULL,NULL),(43386,'48433','S','Flushing','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.068946,-83.837190,0,'2013-07-06 12:44:32',NULL,NULL),(7878,'07511','P','Paterson','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.902429,-74.221090,0,'2013-07-06 12:44:30',NULL,NULL),(47935,'55114','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.964378,-93.195095,0,'2013-07-06 12:44:33',NULL,NULL),(24029,'26378','S','Kincheloe','A','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.117304,-80.435643,0,'2013-07-06 12:44:31',NULL,NULL),(46173,'52733','P','Clinton','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.847697,-90.187345,0,'2013-07-06 12:44:32',NULL,NULL),(51632,'59855','P','Pablo','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.617619,-114.127870,0,'2013-07-06 12:44:33',NULL,NULL),(53047,'61483','S','Elmira','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.092649,-89.863127,0,'2013-07-06 12:44:33',NULL,NULL),(58187,'68310','S','Homestead National Monument','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(58875,'69155','S','Thune','N','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.211049,-101.375901,0,'2013-07-06 12:44:33',NULL,NULL),(71345,'86514','S','Immanuel Mission','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750658,-109.364054,0,'2013-07-06 12:44:34',NULL,NULL),(71834,'87579','S','Rodarte','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(59684,'71069','S','Rodessa','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.975017,-94.004397,0,'2013-07-06 12:44:33',NULL,NULL),(66120,'78418','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.641172,-97.277723,0,'2013-07-06 12:44:34',NULL,NULL),(9907,'10132','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.785292,-73.981536,0,'2013-07-06 12:44:30',NULL,NULL),(37022,'41240','S','Paintsville','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(23944,'26269','S','Hambleton','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.126718,-79.599161,0,'2013-07-06 12:44:31',NULL,NULL),(43211,'48306','S','Rochester Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(36235,'40292','U','Univ of Louisville','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.231826,-85.669849,0,'2013-07-06 12:44:32',NULL,NULL),(33377,'37211','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.075248,-86.720700,0,'2013-07-06 12:44:32',NULL,NULL),(56574,'65501','S','Jadwin','D','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.464090,-91.508089,0,'2013-07-06 12:44:33',NULL,NULL),(61305,'72428','S','Etowah','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.715896,-90.198184,0,'2013-07-06 12:44:33',NULL,NULL),(2473,'00956','S','Lomas Verdes','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(75246,'93656','S','Riverdale','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.439530,-119.909383,0,'2013-07-06 12:44:34',NULL,NULL),(66437,'78645','S','Lago Vista','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.447624,-97.980615,0,'2013-07-06 12:44:34',NULL,NULL),(30102,'33158','S','Palmetto Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(33161,'37018','S','Beechgrove','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.622179,-86.172797,0,'2013-07-06 12:44:32',NULL,NULL),(34812,'38901','S','Dubard','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(8632,'08260','S','Wildwood','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(27721,'30345','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.850513,-84.286420,0,'2013-07-06 12:44:31',NULL,NULL),(50484,'58049','S','Hastings','A','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.701900,-97.985400,0,'2013-07-06 12:44:33',NULL,NULL),(23919,'26222','S','Hacker Valley','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.700556,-80.464167,0,'2013-07-06 12:44:31',NULL,NULL),(19608,'20233','U','Bureau of Census','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(3831,'02333','S','E Bridgewtr','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.029586,-70.942499,0,'2013-07-06 12:44:30',NULL,NULL),(18675,'19183','U','Colonial Penn (BRM)','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951604,-75.168997,0,'2013-07-06 12:44:31',NULL,NULL),(59731,'71113','P','Bossier City','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.496399,-93.687401,0,'2013-07-06 12:44:33',NULL,NULL),(64915,'77202','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.758072,-95.365550,0,'2013-07-06 12:44:34',NULL,NULL),(27860,'30441','S','Colemans Lake','N','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(72380,'89036','P','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.369599,-114.884210,0,'2013-07-06 12:44:34',NULL,NULL),(67912,'80904','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855129,-104.865127,0,'2013-07-06 12:44:34',NULL,NULL),(61776,'73066','P','Nicoma Park','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.495083,-97.324960,0,'2013-07-06 12:44:33',NULL,NULL),(48638,'55811','S','Hermantown','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.837380,-92.201400,0,'2013-07-06 12:44:33',NULL,NULL),(47872,'55083','P','Stillwater','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.058398,-92.825832,0,'2013-07-06 12:44:33',NULL,NULL),(38860,'44095','S','Willoughby','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.654810,-81.440913,0,'2013-07-06 12:44:32',NULL,NULL),(55932,'64471','S','New Hampton','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.215738,-94.158435,0,'2013-07-06 12:44:33',NULL,NULL),(71811,'87569','P','Serafina','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.392778,-105.316944,0,'2013-07-06 12:44:34',NULL,NULL),(35268,'39361','S','Shuqualak','D','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.967999,-88.545385,0,'2013-07-06 12:44:32',NULL,NULL),(1425,'00739','S','Ciudad Primavera','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(73130,'90272','S','Pacific Palisades','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.053275,-118.534568,0,'2013-07-06 12:44:34',NULL,NULL),(57471,'66863','P','Neal','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.838379,-96.078599,0,'2013-07-06 12:44:33',NULL,NULL),(29963,'33076','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.266880,-80.284560,0,'2013-07-06 12:44:32',NULL,NULL),(30389,'33320','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.143950,-80.141327,0,'2013-07-06 12:44:32',NULL,NULL),(13192,'13619','S','West Carthage','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(22417,'24001','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270760,-79.939334,0,'2013-07-06 12:44:31',NULL,NULL),(72784,'89701','S','Carson Meadows','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(57692,'67276','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.660214,-97.415614,0,'2013-07-06 12:44:33',NULL,NULL),(19136,'19610','S','Berkshire Heights','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.338971,-75.981605,0,'2013-07-06 12:44:31',NULL,NULL),(74116,'92232','P','Calexico','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.679271,-115.503159,0,'2013-07-06 12:44:34',NULL,NULL),(70103,'84171','P','Cottonwood Heights','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(6934,'06161','U','Wethersfield','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.701070,-72.667463,0,'2013-07-06 12:44:30',NULL,NULL),(31122,'33901','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628428,-81.867580,0,'2013-07-06 12:44:32',NULL,NULL),(69607,'83856','S','Priest Lake','A','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.186078,-116.913115,0,'2013-07-06 12:44:34',NULL,NULL),(69636,'84003','S','Highland','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.419240,-111.565260,0,'2013-07-06 12:44:34',NULL,NULL),(70160,'84316','P','Howell','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.783340,-112.429895,0,'2013-07-06 12:44:34',NULL,NULL),(64063,'76135','S','Lake Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.825756,-97.451279,0,'2013-07-06 12:44:34',NULL,NULL),(54675,'62940','S','Sand Ridge','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.745311,-89.441223,0,'2013-07-06 12:44:33',NULL,NULL),(13621,'13901','S','Binghamton','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.156660,-75.890520,0,'2013-07-06 12:44:31',NULL,NULL),(69217,'83401','S','Coltman','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(33203,'37044','U','Clarksville','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.529382,-87.337634,0,'2013-07-06 12:44:32',NULL,NULL),(23063,'24871','P','Pageton','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.349119,-81.467423,0,'2013-07-06 12:44:31',NULL,NULL),(14498,'15144','S','Springdale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.540695,-79.782399,0,'2013-07-06 12:44:31',NULL,NULL),(24801,'27592','S','Willow Springs','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.568335,-78.706810,0,'2013-07-06 12:44:31',NULL,NULL),(30894,'33704','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.794804,-82.635433,0,'2013-07-06 12:44:32',NULL,NULL),(27099,'29717','S','Hickory Grove','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.970701,-81.426068,0,'2013-07-06 12:44:31',NULL,NULL),(69914,'84108','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.738359,-111.812479,0,'2013-07-06 12:44:34',NULL,NULL),(66463,'78655','S','Martindale','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.849653,-97.847507,0,'2013-07-06 12:44:34',NULL,NULL),(73376,'91042','S','Tujunga','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252366,-118.283924,0,'2013-07-06 12:44:34',NULL,NULL),(63629,'75835','S','Porter Springs','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(59903,'71277','S','Lockhart','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.897756,-92.609210,0,'2013-07-06 12:44:33',NULL,NULL),(13845,'14223','S','Town of Tonawanda','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(20401,'20901','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.018164,-77.008298,0,'2013-07-06 12:44:31',NULL,NULL),(31031,'33801','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.037963,-81.943908,0,'2013-07-06 12:44:32',NULL,NULL),(56788,'65756','S','Vineyard','N','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.111315,-93.957456,0,'2013-07-06 12:44:33',NULL,NULL),(64874,'77064','S','Jersey Vlg','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.917765,-95.555032,0,'2013-07-06 12:44:34',NULL,NULL),(7373,'06776','S','New Milford','D','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.582173,-73.413047,0,'2013-07-06 12:44:30',NULL,NULL),(48266,'55428','S','New Hope','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(46124,'52642','P','Rome','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.981518,-91.680877,0,'2013-07-06 12:44:32',NULL,NULL),(67918,'80906','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.791623,-104.825814,0,'2013-07-06 12:44:34',NULL,NULL),(22240,'23651','S','Fort Monroe','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.007125,-76.312335,0,'2013-07-06 12:44:31',NULL,NULL),(24823,'27607','S','NC State University','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.804021,-78.697656,0,'2013-07-06 12:44:31',NULL,NULL),(70951,'85643','S','Ft Grant','A','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(70306,'84542','S','Wellington','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.551983,-110.731494,0,'2013-07-06 12:44:34',NULL,NULL),(57224,'66503','S','Manhattan','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.209573,-96.640658,0,'2013-07-06 12:44:33',NULL,NULL),(15740,'16901','S','Stokesdale','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(61185,'72207','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.773082,-92.358471,0,'2013-07-06 12:44:33',NULL,NULL),(70304,'84540','S','Thompson Springs','N','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.035892,-109.696213,0,'2013-07-06 12:44:34',NULL,NULL),(36990,'41203','S','Beauty','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.758275,-82.623531,0,'2013-07-06 12:44:32',NULL,NULL),(38081,'43071','S','St Louisville','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.177388,-82.375739,0,'2013-07-06 12:44:32',NULL,NULL),(59802,'71222','S','Weldon','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.830800,-92.643420,0,'2013-07-06 12:44:33',NULL,NULL),(10028,'10172','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(26913,'29582','S','Cherry Grove Beach','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(8233,'07999','S','Whippany','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.821396,-74.439545,0,'2013-07-06 12:44:30',NULL,NULL),(45776,'52157','S','Giard','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.021470,-91.179382,0,'2013-07-06 12:44:32',NULL,NULL),(70346,'84635','S','Topaz','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.364440,-112.719300,0,'2013-07-06 12:44:34',NULL,NULL),(56517,'65351','S','Sweet Springs','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964117,-93.418774,0,'2013-07-06 12:44:33',NULL,NULL),(7256,'06516','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.269511,-72.964339,0,'2013-07-06 12:44:30',NULL,NULL),(21430,'22555','P','Stafford','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.420262,-77.409552,0,'2013-07-06 12:44:31',NULL,NULL),(5215,'04460','S','Grindstone','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.617950,-68.497973,0,'2013-07-06 12:44:30',NULL,NULL),(4906,'04064','S','Old Orchard Beach','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.526400,-70.392180,0,'2013-07-06 12:44:30',NULL,NULL),(50389,'57767','S','Owanka','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.994400,-102.591900,0,'2013-07-06 12:44:33',NULL,NULL),(56306,'65101','S','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(20947,'21771','S','Mount Airy','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.388389,-77.148195,0,'2013-07-06 12:44:31',NULL,NULL),(1822,'00784','S','Jardines De La Reina','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(48757,'55975','S','Spring Valley','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.687315,-92.391053,0,'2013-07-06 12:44:33',NULL,NULL),(16821,'17549','P','Martindale','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.151513,-76.090144,0,'2013-07-06 12:44:31',NULL,NULL),(24127,'26554','S','Jordan','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(71597,'87320','P','Mexican Springs','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.775385,-108.841337,0,'2013-07-06 12:44:34',NULL,NULL),(56632,'65605','S','Jenkins','A','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.956100,-93.720540,0,'2013-07-06 12:44:33',NULL,NULL),(23208,'25071','S','Elkview','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.455500,-81.469140,0,'2013-07-06 12:44:31',NULL,NULL),(1705,'00777','S','Urb Valencia 2','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(35205,'39296','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.345145,-90.165957,0,'2013-07-06 12:44:32',NULL,NULL),(32958,'36585','S','Bassetts Creek','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.392178,-88.062461,0,'2013-07-06 12:44:32',NULL,NULL),(54280,'62691','S','Virginia','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.948431,-90.202632,0,'2013-07-06 12:44:33',NULL,NULL),(32448,'36017','S','Clio','D','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.711536,-85.661259,0,'2013-07-06 12:44:32',NULL,NULL),(79239,'98555','S','Eldon','N','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.551115,-123.186108,0,'2013-07-06 12:44:34',NULL,NULL),(56890,'66040','S','Lacygne','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.356638,-94.741025,0,'2013-07-06 12:44:33',NULL,NULL),(51675,'59921','P','West Glacier','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.621891,-113.873901,0,'2013-07-06 12:44:33',NULL,NULL),(53706,'62234','S','Lumaghi Heights','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.687371,-89.983306,0,'2013-07-06 12:44:33',NULL,NULL),(74696,'93001','S','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.295546,-119.291976,0,'2013-07-06 12:44:34',NULL,NULL),(21286,'22333','U','Us Army Mat Com','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.815071,-77.113643,0,'2013-07-06 12:44:31',NULL,NULL),(3297,'01509','P','Charlton Depot','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.172996,-71.975620,0,'2013-07-06 12:44:30',NULL,NULL),(48287,'55435','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.874000,-93.343860,0,'2013-07-06 12:44:33',NULL,NULL),(55119,'63338','P','Cottleville','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.746957,-90.653962,0,'2013-07-06 12:44:33',NULL,NULL),(57777,'67466','S','Miltonvale','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.348238,-97.453339,0,'2013-07-06 12:44:33',NULL,NULL),(60873,'72059','P','Gregory','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.155922,-91.346107,0,'2013-07-06 12:44:33',NULL,NULL),(44279,'49713','S','Boyne Falls','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.192764,-84.859816,0,'2013-07-06 12:44:32',NULL,NULL),(29519,'32776','S','Sorrento','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.804779,-81.535369,0,'2013-07-06 12:44:32',NULL,NULL),(31452,'34284','P','Venice','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.047938,-82.407211,0,'2013-07-06 12:44:32',NULL,NULL),(42000,'47424','S','Ridgeport','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(43232,'48313','S','Sterling Hts','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.598804,-82.997434,0,'2013-07-06 12:44:32',NULL,NULL),(6191,'05481','P','St Albans Bay','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.809591,-73.138866,0,'2013-07-06 12:44:30',NULL,NULL),(45264,'50668','S','Klinger','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.703803,-92.225832,0,'2013-07-06 12:44:32',NULL,NULL),(135,'00617','S','Barceloneta','D','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(24843,'27619','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.854221,-78.628804,0,'2013-07-06 12:44:31',NULL,NULL),(61658,'72905','U','Fort Chaffee','A','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.286594,-94.276239,0,'2013-07-06 12:44:33',NULL,NULL),(234,'00627','S','Urb Linda Vista','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(6490,'05773','S','Tinmouth','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.463580,-72.990360,0,'2013-07-06 12:44:30',NULL,NULL),(2857,'00985','S','Bda Buena Vista','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(25662,'28503','P','Kinston','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.280064,-77.582905,0,'2013-07-06 12:44:31',NULL,NULL),(34710,'38834','S','Corinth','D','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(64015,'76118','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(69678,'84023','S','Dutch John','D','Daggett','49009','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.932867,-109.392096,0,'2013-07-06 12:44:34',NULL,NULL),(72067,'88121','S','House','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.739255,-103.985028,0,'2013-07-06 12:44:34',NULL,NULL),(44958,'50395','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.600964,-93.630768,0,'2013-07-06 12:44:32',NULL,NULL),(50123,'57522','S','Blunt','D','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.513605,-99.988191,0,'2013-07-06 12:44:33',NULL,NULL),(52105,'60415','S','Chicago Ridge','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.702093,-87.777421,0,'2013-07-06 12:44:33',NULL,NULL),(43359,'48391','P','Walled Lake','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.534649,-83.479508,0,'2013-07-06 12:44:32',NULL,NULL),(24486,'27252','S','Goldston','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.554892,-79.346266,0,'2013-07-06 12:44:31',NULL,NULL),(15289,'16130','S','Hadley','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.436056,-80.265258,0,'2013-07-06 12:44:31',NULL,NULL),(23093,'24925','S','Caldwell','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.754016,-80.348267,0,'2013-07-06 12:44:31',NULL,NULL),(10500,'10963','S','Otisville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.465261,-74.537215,0,'2013-07-06 12:44:30',NULL,NULL),(11141,'11710','S','North Bellmore','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.679031,-73.534402,0,'2013-07-06 12:44:30',NULL,NULL),(28782,'32040','S','Glen Saint Mary','D','Baker','12003','Florida','FL','12','0000','904','Eastern',-5.0,'Y',30.288545,-82.158561,0,'2013-07-06 12:44:32',NULL,NULL),(28958,'32201','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.275611,-81.764254,0,'2013-07-06 12:44:32',NULL,NULL),(33933,'38063','S','Ripley','D','Lauderdale','47097','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.734610,-89.537080,0,'2013-07-06 12:44:32',NULL,NULL),(71383,'87004','S','Tamaya','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(79440,'98837','S','Raugust','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.126359,-119.296146,0,'2013-07-06 12:44:34',NULL,NULL),(67965,'80914','P','Cheyenne Mtn AFB','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(20929,'21749','U','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.637367,-77.744539,0,'2013-07-06 12:44:31',NULL,NULL),(13504,'13808','S','Maple Grove','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.547176,-75.243080,0,'2013-07-06 12:44:31',NULL,NULL),(32049,'35254','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513945,-86.853654,0,'2013-07-06 12:44:32',NULL,NULL),(61072,'72126','S','Nimrod','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(36139,'40229','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.102864,-85.665671,0,'2013-07-06 12:44:32',NULL,NULL),(1291,'00730','S','Urb Jacaranda','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(51435,'59463','S','Monarch','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.078415,-110.835427,0,'2013-07-06 12:44:33',NULL,NULL),(42592,'47885','S','Fayette','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(76866,'95971','S','East Quincy','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(19035,'19539','S','Hancock','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(14820,'15424','S','Confluence','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.821640,-79.358280,0,'2013-07-06 12:44:31',NULL,NULL),(41556,'47019','P','East Enterprise','D','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.872221,-84.988910,0,'2013-07-06 12:44:32',NULL,NULL),(50554,'58205','S','Grand Forks','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.925264,-97.241434,0,'2013-07-06 12:44:33',NULL,NULL),(15973,'17032','S','Fisherville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(28474,'31510','S','Alma','D','Bacon','13005','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.539831,-82.464187,0,'2013-07-06 12:44:32',NULL,NULL),(27374,'30071','S','Peachtree Corners','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.939475,-84.197677,0,'2013-07-06 12:44:31',NULL,NULL),(73558,'91362','S','Westlake Village','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.192920,-118.822620,0,'2013-07-06 12:44:34',NULL,NULL),(1654,'00772','S','Vistas del Oceano','N','Loiza','72087','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.433938,-65.880795,0,'2013-07-06 12:44:30',NULL,NULL),(22030,'23294','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.630728,-77.544233,0,'2013-07-06 12:44:31',NULL,NULL),(33489,'37347','S','Kimball','A','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.069280,-85.602300,0,'2013-07-06 12:44:32',NULL,NULL),(79601,'99101','S','Addy','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.325010,-117.954310,0,'2013-07-06 12:44:34',NULL,NULL),(72836,'89832','P','Duck Valley','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.750437,-116.013069,0,'2013-07-06 12:44:34',NULL,NULL),(68919,'82840','P','Buffalo','A','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.344040,-106.620111,0,'2013-07-06 12:44:34',NULL,NULL),(64447,'76569','S','Rogers','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.926330,-97.230983,0,'2013-07-06 12:44:34',NULL,NULL),(63664,'75852','S','Elwood','N','Madison','48313','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.018920,-95.758200,0,'2013-07-06 12:44:34',NULL,NULL),(16722,'17406','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(21319,'22406','S','Fredericksburg','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(60966,'72104','S','Magnet Cove','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(50888,'58535','S','Fallon','N','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.466520,-101.178960,0,'2013-07-06 12:44:33',NULL,NULL),(30644,'33449','S','Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.607200,-80.233543,0,'2013-07-06 12:44:32',NULL,NULL),(2947,'01032','S','Goshen','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.466800,-72.830760,0,'2013-07-06 12:44:30',NULL,NULL),(45355,'50983','U','HP Enterprise Services','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582136,-93.638733,0,'2013-07-06 12:44:32',NULL,NULL),(41464,'46915','S','Burlington','D','Carroll','18015','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.481653,-86.394991,0,'2013-07-06 12:44:32',NULL,NULL),(29759,'33004','S','Dania Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.051174,-80.147034,0,'2013-07-06 12:44:32',NULL,NULL),(32111,'35402','P','Tusc','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.148495,-87.609658,0,'2013-07-06 12:44:32',NULL,NULL),(18723,'19317','S','Chadds Ford','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.853281,-75.609998,0,'2013-07-06 12:44:31',NULL,NULL),(47696,'54974','S','Rosendale','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.810083,-88.671512,0,'2013-07-06 12:44:33',NULL,NULL),(19101,'19605','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(3142,'01254','S','Richmond','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.401705,-73.348236,0,'2013-07-06 12:44:30',NULL,NULL),(49483,'56660','S','Gemmell','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.987810,-94.214799,0,'2013-07-06 12:44:33',NULL,NULL),(46557,'53506','S','Avoca','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.190183,-90.317873,0,'2013-07-06 12:44:32',NULL,NULL),(12573,'13064','P','Fair Haven','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.319427,-76.702751,0,'2013-07-06 12:44:30',NULL,NULL),(27478,'30149','P','Mount Berry','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.275000,-85.183320,0,'2013-07-06 12:44:31',NULL,NULL),(78931,'98366','S','Port Orchard','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(65410,'77571','S','La Porte','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.658283,-95.049187,0,'2013-07-06 12:44:34',NULL,NULL),(51860,'60074','S','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.145690,-88.027592,0,'2013-07-06 12:44:33',NULL,NULL),(31869,'35123','P','Palmerdale','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.747733,-86.645060,0,'2013-07-06 12:44:32',NULL,NULL),(31907,'35149','P','Sycamore','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.250962,-86.203027,0,'2013-07-06 12:44:32',NULL,NULL),(70116,'84189','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.764906,-111.886965,0,'2013-07-06 12:44:34',NULL,NULL),(52262,'60523','S','Oak Brook','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.800833,-87.936944,0,'2013-07-06 12:44:33',NULL,NULL),(30396,'33321','S','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(21257,'22304','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.817208,-77.122599,0,'2013-07-06 12:44:31',NULL,NULL),(6595,'05861','P','Passumpsic','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.377353,-72.031425,0,'2013-07-06 12:44:30',NULL,NULL),(4153,'02766','S','Norton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.971692,-71.185840,0,'2013-07-06 12:44:30',NULL,NULL),(35206,'39296','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.345145,-90.165957,0,'2013-07-06 12:44:32',NULL,NULL),(15739,'16901','S','Shippen','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(35209,'39298','P','Flowood','A','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.321984,-90.206032,0,'2013-07-06 12:44:32',NULL,NULL),(11793,'12222','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.693234,-73.838124,0,'2013-07-06 12:44:30',NULL,NULL),(35047,'39175','S','Utica','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.120866,-90.599332,0,'2013-07-06 12:44:32',NULL,NULL),(25428,'28305','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.054049,-78.903538,0,'2013-07-06 12:44:31',NULL,NULL),(43022,'48167','S','Northville Tw','A','Wayne','26163','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.422231,-83.470096,0,'2013-07-06 12:44:32',NULL,NULL),(39320,'44607','P','Augusta','D','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.684240,-81.017079,0,'2013-07-06 12:44:32',NULL,NULL),(58849,'69135','S','Elsmere','D','Cherry','31031','Nebraska','NE','31','0000','308','Central',-6.0,'Y',42.291393,-100.289209,0,'2013-07-06 12:44:33',NULL,NULL),(74622,'92802','S','Holiday','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.808505,-117.922777,0,'2013-07-06 12:44:34',NULL,NULL),(53697,'62231','S','Royal Lake','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(41536,'46996','S','Denham','A','Pulaski','18131','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.054144,-86.603068,0,'2013-07-06 12:44:32',NULL,NULL),(17273,'17844','S','Mifflinburg','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(71786,'87560','S','El Pueblo','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(25228,'28091','S','Lilesville','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',34.967036,-79.989195,0,'2013-07-06 12:44:31',NULL,NULL),(9686,'10044','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(36847,'41076','S','Cold Sprgs Highland Hts','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(47286,'54542','S','Nelma','A','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.840000,-88.660000,0,'2013-07-06 12:44:32',NULL,NULL),(57048,'66210','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(58817,'69033','S','Imperial','D','Chase','31029','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.519882,-101.644043,0,'2013-07-06 12:44:33',NULL,NULL),(61839,'73115','S','Smith Village','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.438660,-97.439577,0,'2013-07-06 12:44:33',NULL,NULL),(16201,'17070','S','New Cumberlnd','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(65498,'77661','P','Stowell','D','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.788782,-94.382618,0,'2013-07-06 12:44:34',NULL,NULL),(70926,'85634','S','Pisinemo','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(65255,'77466','P','Pattison','D','Waller','48473','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.815251,-95.987036,0,'2013-07-06 12:44:34',NULL,NULL),(57420,'66776','S','Morehead','N','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.489369,-95.476701,0,'2013-07-06 12:44:33',NULL,NULL),(12643,'13108','S','Navarino','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.970080,-76.324080,0,'2013-07-06 12:44:30',NULL,NULL),(19597,'20226','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897787,-77.031979,0,'2013-07-06 12:44:31',NULL,NULL),(38033,'43027','P','Homer','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.244808,-82.516572,0,'2013-07-06 12:44:32',NULL,NULL),(37428,'41822','S','Hindman','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.322511,-82.949258,0,'2013-07-06 12:44:32',NULL,NULL),(25772,'28601','S','Longview','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(74103,'92211','S','Palm Desert','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.746188,-116.330491,0,'2013-07-06 12:44:34',NULL,NULL),(65526,'77725','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.087905,-94.101933,0,'2013-07-06 12:44:34',NULL,NULL),(53805,'62292','P','Tilden','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.212150,-89.683049,0,'2013-07-06 12:44:33',NULL,NULL),(9440,'10005','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(12448,'12965','S','Nicholville','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.705556,-74.715278,0,'2013-07-06 12:44:30',NULL,NULL),(45256,'50662','S','Oelwein','D','Fayette','19065','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.678446,-91.911924,0,'2013-07-06 12:44:32',NULL,NULL),(11673,'12147','S','Rensselaervle','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.504660,-74.147340,0,'2013-07-06 12:44:30',NULL,NULL),(22709,'24347','S','Allisonia','A','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.016100,-80.606340,0,'2013-07-06 12:44:31',NULL,NULL),(55787,'64121','P','K C','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.100769,-94.578994,0,'2013-07-06 12:44:33',NULL,NULL),(72063,'88119','S','Ft Sumner','N','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.471919,-104.234002,0,'2013-07-06 12:44:34',NULL,NULL),(6994,'06250','S','Mansfield Hollow','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780580,-72.210300,0,'2013-07-06 12:44:30',NULL,NULL),(36804,'41055','S','Wedonia','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(13683,'14047','S','Derby','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.694620,-78.987802,0,'2013-07-06 12:44:31',NULL,NULL),(4922,'04076','S','Shapleigh','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.517658,-70.853521,0,'2013-07-06 12:44:30',NULL,NULL),(45236,'50649','S','Kesley','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.687274,-92.849624,0,'2013-07-06 12:44:32',NULL,NULL),(22960,'24701','S','Brush Fork','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(17368,'17876','S','Shamokin Dam','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.848931,-76.824586,0,'2013-07-06 12:44:31',NULL,NULL),(58398,'68629','S','Clarkson','D','Colfax','31037','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.721442,-97.118226,0,'2013-07-06 12:44:33',NULL,NULL),(54232,'62661','S','Loami','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.654098,-89.882073,0,'2013-07-06 12:44:33',NULL,NULL),(32538,'36106','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.351832,-86.264275,0,'2013-07-06 12:44:32',NULL,NULL),(34151,'38240','S','Obion','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.261145,-89.190894,0,'2013-07-06 12:44:32',NULL,NULL),(38126,'43115','S','Clarksburg','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.490249,-83.159647,0,'2013-07-06 12:44:32',NULL,NULL),(43064,'48191','S','Willis','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.130909,-83.570539,0,'2013-07-06 12:44:32',NULL,NULL),(9647,'10037','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(24861,'27640','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.786086,-78.638689,0,'2013-07-06 12:44:31',NULL,NULL),(23996,'26342','S','Coxs Mills','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.004809,-80.868049,0,'2013-07-06 12:44:31',NULL,NULL),(5973,'05342','S','Jacksonville','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.770239,-72.799447,0,'2013-07-06 12:44:30',NULL,NULL),(41851,'47353','S','Liberty','D','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(31732,'34983','S','St Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308284,-80.348414,0,'2013-07-06 12:44:32',NULL,NULL),(54307,'62712','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.741810,-89.594360,0,'2013-07-06 12:44:33',NULL,NULL),(77754,'97107','S','Bay City','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.526326,-123.879733,0,'2013-07-06 12:44:34',NULL,NULL),(24123,'26546','S','Pursglove','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.699315,-80.070871,0,'2013-07-06 12:44:31',NULL,NULL),(72484,'89130','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.255509,-115.227097,0,'2013-07-06 12:44:34',NULL,NULL),(67454,'80214','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745789,-105.059616,0,'2013-07-06 12:44:34',NULL,NULL),(66956,'79379','P','Whiteface','D','Cochran','48079','Texas','TX','48','0000','806','Central',-6.0,'Y',33.508578,-102.707047,0,'2013-07-06 12:44:34',NULL,NULL),(60898,'72070','S','Oakgrove','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.045804,-92.690848,0,'2013-07-06 12:44:33',NULL,NULL),(23339,'25248','S','Kentuck','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.655556,-81.590556,0,'2013-07-06 12:44:31',NULL,NULL),(46733,'53826','S','Wauzeka','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.111390,-90.851909,0,'2013-07-06 12:44:32',NULL,NULL),(37591,'42102','P','Bowling Green','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.952692,-86.401915,0,'2013-07-06 12:44:32',NULL,NULL),(9668,'10040','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(9107,'09096','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(51489,'59623','U','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.608066,-112.014893,0,'2013-07-06 12:44:33',NULL,NULL),(13921,'14415','S','Bellona','D','Yates','36123','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.756258,-77.019723,0,'2013-07-06 12:44:31',NULL,NULL),(4495,'03281','S','Weare','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.085078,-71.724757,0,'2013-07-06 12:44:30',NULL,NULL),(73624,'91407','P','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.193851,-118.448447,0,'2013-07-06 12:44:34',NULL,NULL),(66123,'78419','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693737,-97.264702,0,'2013-07-06 12:44:34',NULL,NULL),(63947,'76085','S','Weatherford','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.757858,-97.794211,0,'2013-07-06 12:44:34',NULL,NULL),(19066,'19549','P','Port Clinton','D','Schuylkill','42107','Pennsylvania','PA','42','0000','610/484','Eastern',-5.0,'Y',40.582691,-76.029863,0,'2013-07-06 12:44:31',NULL,NULL),(77068,'96123','S','Ravendale','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.826923,-120.276312,0,'2013-07-06 12:44:34',NULL,NULL),(65542,'77830','S','Anderson','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.556320,-96.019080,0,'2013-07-06 12:44:34',NULL,NULL),(61948,'73164','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.472000,-97.520348,0,'2013-07-06 12:44:33',NULL,NULL),(36052,'40207','S','Brwnsboro Vlg','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(16110,'17055','S','Mech','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(52718,'61204','P','Rock Island','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.490736,-90.569725,0,'2013-07-06 12:44:33',NULL,NULL),(58471,'68740','S','Hoskins','D','Wayne','31179','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.178142,-97.308965,0,'2013-07-06 12:44:33',NULL,NULL),(28777,'32035','P','Amelia Village','N','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.670498,-81.462032,0,'2013-07-06 12:44:32',NULL,NULL),(46634,'53587','S','South Wayne','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.588101,-89.902503,0,'2013-07-06 12:44:32',NULL,NULL),(73058,'90091','P','Cty of Cmmrce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.989658,-118.149153,0,'2013-07-06 12:44:34',NULL,NULL),(66314,'78592','P','Santa Maria','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.073889,-97.822778,0,'2013-07-06 12:44:34',NULL,NULL),(60407,'71638','S','Halley Junction','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(51204,'59037','S','Huntley','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.890286,-108.269545,0,'2013-07-06 12:44:33',NULL,NULL),(22751,'24415','P','Brownsburg','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.931230,-79.316935,0,'2013-07-06 12:44:31',NULL,NULL),(77811,'97143','P','Netarts Bay','A','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.436071,-123.942514,0,'2013-07-06 12:44:34',NULL,NULL),(56956,'66104','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.155349,-94.693675,0,'2013-07-06 12:44:33',NULL,NULL),(34507,'38674','S','Burrow','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.903866,-88.918583,0,'2013-07-06 12:44:32',NULL,NULL),(64442,'76567','S','Rockdale','D','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.657577,-97.009947,0,'2013-07-06 12:44:34',NULL,NULL),(11189,'11735','S','Farmingdale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.725297,-73.444737,0,'2013-07-06 12:44:30',NULL,NULL),(26890,'29569','S','Loris','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.020799,-78.909328,0,'2013-07-06 12:44:31',NULL,NULL),(35995,'40143','S','Hardinsburg','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.779180,-86.458980,0,'2013-07-06 12:44:32',NULL,NULL),(72350,'89019','S','Jean','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.804011,-115.635842,0,'2013-07-06 12:44:34',NULL,NULL),(11082,'11691','S','Far Rockaway','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.602157,-73.760226,0,'2013-07-06 12:44:30',NULL,NULL),(24892,'27708','U','Duke','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.997189,-78.938612,0,'2013-07-06 12:44:31',NULL,NULL),(50669,'58341','S','Hamberg','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(65543,'77830','S','Carlos','N','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.556320,-96.019080,0,'2013-07-06 12:44:34',NULL,NULL),(73696,'91607','S','Sherman Village','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(26168,'28745','S','Lake Junaluska','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.524801,-82.972902,0,'2013-07-06 12:44:31',NULL,NULL),(39778,'45122','S','Edenton','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.222960,-84.120240,0,'2013-07-06 12:44:32',NULL,NULL),(28562,'31599','U','Jesup','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.478461,-81.802265,0,'2013-07-06 12:44:32',NULL,NULL),(45402,'51040','S','Turin','A','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.028935,-96.098207,0,'2013-07-06 12:44:32',NULL,NULL),(23872,'26159','S','Paden City','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.605411,-80.929983,0,'2013-07-06 12:44:31',NULL,NULL),(79004,'98386','P','Southworth','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.509454,-122.501564,0,'2013-07-06 12:44:34',NULL,NULL),(75795,'94710','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.869970,-122.296314,0,'2013-07-06 12:44:34',NULL,NULL),(72676,'89442','P','Olinghouse','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.642321,-119.281177,0,'2013-07-06 12:44:34',NULL,NULL),(73539,'91352','S','Sun Valley','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.224912,-118.360350,0,'2013-07-06 12:44:34',NULL,NULL),(48157,'55373','S','Independence','N','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.089673,-93.734933,0,'2013-07-06 12:44:33',NULL,NULL),(65355,'77523','S','Old Rvr-Wnfre','A','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(59458,'70732','S','Fordoche','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.609062,-91.701767,0,'2013-07-06 12:44:33',NULL,NULL),(38588,'43811','S','Conesville','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.192343,-81.910664,0,'2013-07-06 12:44:32',NULL,NULL),(31633,'34713','P','Clermont','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.547308,-81.770426,0,'2013-07-06 12:44:32',NULL,NULL),(15115,'15781','P','Walston','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.964245,-78.993278,0,'2013-07-06 12:44:31',NULL,NULL),(70586,'85079','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.508957,-112.120287,0,'2013-07-06 12:44:34',NULL,NULL),(63530,'75757','S','Bullard','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.150666,-95.372322,0,'2013-07-06 12:44:33',NULL,NULL),(60990,'72112','S','Algoa','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(65263,'77469','S','Rosenberg','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(34861,'38929','S','Cadaretta','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.786191,-89.806290,0,'2013-07-06 12:44:32',NULL,NULL),(34209,'38347','S','Jacks Creek','D','Chester','47023','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.487538,-88.499439,0,'2013-07-06 12:44:32',NULL,NULL),(33572,'37421','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.025290,-85.144734,0,'2013-07-06 12:44:32',NULL,NULL),(74439,'92572','P','Perris','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.785958,-117.226712,0,'2013-07-06 12:44:34',NULL,NULL),(28376,'31295','U','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.810582,-83.571041,0,'2013-07-06 12:44:32',NULL,NULL),(28060,'30677','S','Watkinsville','D','Oconee','13219','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.848354,-83.414224,0,'2013-07-06 12:44:31',NULL,NULL),(18928,'19504','S','Dale','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(23137,'24981','S','Talcott','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.648685,-80.742207,0,'2013-07-06 12:44:31',NULL,NULL),(80003,'99670','P','S Naknek','N','Bristol Bay','02060','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.712060,-156.908999,0,'2013-07-06 12:44:34',NULL,NULL),(75381,'93942','P','Monterey','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.616965,-121.898809,0,'2013-07-06 12:44:34',NULL,NULL),(61491,'72641','S','Mount Sherman','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.002568,-93.217954,0,'2013-07-06 12:44:33',NULL,NULL),(31850,'35111','S','Mc Calla','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.268815,-87.144228,0,'2013-07-06 12:44:32',NULL,NULL),(45765,'52151','S','Church','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.359099,-91.221890,0,'2013-07-06 12:44:32',NULL,NULL),(46016,'52540','S','Pleasant Plain','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.173994,-91.823207,0,'2013-07-06 12:44:32',NULL,NULL),(1945,'00801','P','Charlotte Amalie','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350000,-64.933333,0,'2013-07-06 12:44:30',NULL,NULL),(1775,'00780','S','Villas del Laurel 1','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(76026,'95138','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.246945,-121.776686,0,'2013-07-06 12:44:34',NULL,NULL),(30834,'33626','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.056858,-82.605871,0,'2013-07-06 12:44:32',NULL,NULL),(47244,'54513','S','Brantwood','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.569485,-90.125463,0,'2013-07-06 12:44:32',NULL,NULL),(52706,'61111','S','Machesney Pk','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.328100,-89.026827,0,'2013-07-06 12:44:33',NULL,NULL),(61475,'72633','S','Everton','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.154251,-92.914436,0,'2013-07-06 12:44:33',NULL,NULL),(68287,'81089','S','Farisita','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(69352,'83544','S','Orofino','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.517820,-116.111280,0,'2013-07-06 12:44:34',NULL,NULL),(52040,'60190','S','Winfield','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.869710,-88.150265,0,'2013-07-06 12:44:33',NULL,NULL),(49278,'56511','S','Audubon','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.860418,-95.980967,0,'2013-07-06 12:44:33',NULL,NULL),(25429,'28305','S','Haymount','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.054049,-78.903538,0,'2013-07-06 12:44:31',NULL,NULL),(80065,'99722','P','Arctic Village','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',68.139958,-145.549133,0,'2013-07-06 12:44:34',NULL,NULL),(68815,'82441','S','Shell','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.613962,-107.811554,0,'2013-07-06 12:44:34',NULL,NULL),(68073,'80937','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798001,-104.836875,0,'2013-07-06 12:44:34',NULL,NULL),(41469,'46920','S','Cutler','D','Carroll','18015','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.472512,-86.476346,0,'2013-07-06 12:44:32',NULL,NULL),(26430,'29127','S','Stoney Hill','N','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.182431,-81.520940,0,'2013-07-06 12:44:31',NULL,NULL),(32372,'35899','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.740543,-86.629283,0,'2013-07-06 12:44:32',NULL,NULL),(2469,'00956','S','Ext Santa Juanita','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(10249,'10470','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.901193,-73.860637,0,'2013-07-06 12:44:30',NULL,NULL),(64323,'76486','S','Perrin','D','Jack','48237','Texas','TX','48','0000','940','Central',-6.0,'Y',33.081552,-98.052484,0,'2013-07-06 12:44:34',NULL,NULL),(26205,'28778','S','Swannanoa','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.603045,-82.409169,0,'2013-07-06 12:44:31',NULL,NULL),(68762,'82243','S','Veteran','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.971969,-104.364572,0,'2013-07-06 12:44:34',NULL,NULL),(66273,'78579','P','Progreso','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.167309,-97.987909,0,'2013-07-06 12:44:34',NULL,NULL),(53253,'61701','S','Kerrik','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(36687,'41016','S','Bromley','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.084954,-84.549188,0,'2013-07-06 12:44:32',NULL,NULL),(36309,'40372','S','Salvisa','D','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.909927,-84.876344,0,'2013-07-06 12:44:32',NULL,NULL),(21614,'22904','S','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000947,-78.471158,0,'2013-07-06 12:44:31',NULL,NULL),(32123,'35442','S','Cochrane','N','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.124200,-88.159260,0,'2013-07-06 12:44:32',NULL,NULL),(58224,'68343','S','Pleasanthill','N','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.648808,-97.117598,0,'2013-07-06 12:44:33',NULL,NULL),(60703,'71943','S','Lodi','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.324416,-93.547401,0,'2013-07-06 12:44:33',NULL,NULL),(68626,'81632','S','Cordillera','A','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.642795,-106.607621,0,'2013-07-06 12:44:34',NULL,NULL),(76944,'96028','S','Fl River Mls','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',41.059235,-121.497300,0,'2013-07-06 12:44:34',NULL,NULL),(50267,'57642','S','Kenel','N','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.810968,-100.813494,0,'2013-07-06 12:44:33',NULL,NULL),(26816,'29479','S','Alvin','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.348889,-79.816389,0,'2013-07-06 12:44:31',NULL,NULL),(51622,'59844','S','Heron','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.045445,-115.955721,0,'2013-07-06 12:44:33',NULL,NULL),(19748,'20409','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.861490,-76.950140,0,'2013-07-06 12:44:31',NULL,NULL),(67886,'80862','P','Aroya','N','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.914328,-103.045161,0,'2013-07-06 12:44:34',NULL,NULL),(70791,'85357','P','Wenden','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.821473,-113.539461,0,'2013-07-06 12:44:34',NULL,NULL),(70584,'85076','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.330640,-111.989021,0,'2013-07-06 12:44:34',NULL,NULL),(46543,'53405','S','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.716356,-87.823291,0,'2013-07-06 12:44:32',NULL,NULL),(292,'00646','S','Sect La Aldea','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(69488,'83686','S','Bowmont','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.533311,-116.574597,0,'2013-07-06 12:44:34',NULL,NULL),(62151,'73724','S','Canton','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.054808,-98.589971,0,'2013-07-06 12:44:33',NULL,NULL),(65823,'78148','S','Randolph Air Force Base','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.551704,-98.302464,0,'2013-07-06 12:44:34',NULL,NULL),(41210,'46725','S','Tri Lakes','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(56193,'65016','S','Luystown','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.562513,-91.919760,0,'2013-07-06 12:44:33',NULL,NULL),(36650,'41006','S','Mount Auburn','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.791002,-84.321560,0,'2013-07-06 12:44:32',NULL,NULL),(74358,'92413','P','Del Rosa','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.150103,-117.256720,0,'2013-07-06 12:44:34',NULL,NULL),(74170,'92273','P','Seeley','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.788008,-115.690304,0,'2013-07-06 12:44:34',NULL,NULL),(52858,'61328','P','Kasbeer','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.507221,-89.465243,0,'2013-07-06 12:44:33',NULL,NULL),(16519,'17268','S','Biesecker Gap','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(55766,'64116','S','Ks City','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(31241,'33974','S','Leehigh Acres','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.554897,-81.626174,0,'2013-07-06 12:44:32',NULL,NULL),(42599,'47885','S','Pine Ridge','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(10415,'10706','S','Hastings on Hudson','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.970520,-73.875300,0,'2013-07-06 12:44:30',NULL,NULL),(1285,'00730','S','Sect La Ponderosa','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(43916,'49259','S','Munith','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.381338,-84.260330,0,'2013-07-06 12:44:32',NULL,NULL),(1729,'00778','S','Urb Altapaz','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(32989,'36618','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.731393,-88.170447,0,'2013-07-06 12:44:32',NULL,NULL),(55462,'63739','S','Burfordville','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.355779,-89.815404,0,'2013-07-06 12:44:33',NULL,NULL),(6950,'06183','U','Travelers Ins','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.764012,-72.685950,0,'2013-07-06 12:44:30',NULL,NULL),(20945,'21769','S','Middletown','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.439010,-77.551480,0,'2013-07-06 12:44:31',NULL,NULL),(44372,'49788','S','Kincheloe','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.495278,-84.345278,0,'2013-07-06 12:44:32',NULL,NULL),(28538,'31554','S','Chatterton','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(27480,'30150','P','Mount Zion','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.625905,-85.185263,0,'2013-07-06 12:44:31',NULL,NULL),(64753,'76933','S','Bronte','D','Coke','48081','Texas','TX','48','0000','325','Central',-6.0,'Y',31.886888,-100.294029,0,'2013-07-06 12:44:34',NULL,NULL),(73987,'92093','U','La Jolla','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.877058,-117.230578,0,'2013-07-06 12:44:34',NULL,NULL),(79321,'98603','S','Yale','N','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',45.996488,-122.449447,0,'2013-07-06 12:44:34',NULL,NULL),(61036,'72118','S','Blue Hill','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(79346,'98628','S','Klickitat','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.825058,-121.122512,0,'2013-07-06 12:44:34',NULL,NULL),(15165,'15920','S','Armagh','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.446149,-79.010580,0,'2013-07-06 12:44:31',NULL,NULL),(44748,'50168','S','Mingo','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.800128,-93.285926,0,'2013-07-06 12:44:32',NULL,NULL),(3223,'01368','S','Royalston','D','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.684928,-72.196002,0,'2013-07-06 12:44:30',NULL,NULL),(10461,'10928','S','Highland Falls','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.368496,-73.970013,0,'2013-07-06 12:44:30',NULL,NULL),(44621,'50061','S','W Des Moines','A','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.489268,-93.753860,0,'2013-07-06 12:44:32',NULL,NULL),(73735,'91706','S','Baldwin Park','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.085581,-117.970122,0,'2013-07-06 12:44:34',NULL,NULL),(60108,'71366','S','Locust Ridge','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(16362,'17201','S','Guilford Sprs','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(32710,'36301','S','Grimes','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(76850,'95965','S','Oroville','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(73794,'91748','S','Rowland Heights','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(58419,'68651','S','Osceola','D','Polk','31143','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.246471,-97.572487,0,'2013-07-06 12:44:33',NULL,NULL),(49409,'56627','S','Nett River','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.157929,-93.863003,0,'2013-07-06 12:44:33',NULL,NULL),(14694,'15257','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441554,-79.997787,0,'2013-07-06 12:44:31',NULL,NULL),(23165,'25019','S','Bickmore','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.357500,-81.103889,0,'2013-07-06 12:44:31',NULL,NULL),(34069,'38148','U','First Tenn National Bank','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.146943,-90.046493,0,'2013-07-06 12:44:32',NULL,NULL),(61787,'73077','S','Perry','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.292043,-97.287861,0,'2013-07-06 12:44:33',NULL,NULL),(28216,'31032','S','Gray','D','Jones','13169','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',33.004161,-83.545026,0,'2013-07-06 12:44:31',NULL,NULL),(77590,'96923','P','Mangilao','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.440321,144.800124,0,'2013-07-06 12:44:34',NULL,NULL),(65462,'77623','S','High Island','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.569042,-94.396675,0,'2013-07-06 12:44:34',NULL,NULL),(49950,'57342','S','Geddes','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.251792,-98.688470,0,'2013-07-06 12:44:33',NULL,NULL),(39400,'44660','P','Mount Hope','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.622100,-81.787658,0,'2013-07-06 12:44:32',NULL,NULL),(1555,'00765','S','Vieques','D','Vieques','72147','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.123576,-65.438423,0,'2013-07-06 12:44:30',NULL,NULL),(8616,'08245','P','South Dennis','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.170998,-74.810448,0,'2013-07-06 12:44:30',NULL,NULL),(53695,'62231','S','Ferrin','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(78321,'97913','S','Arcadia','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.838397,-117.061031,0,'2013-07-06 12:44:34',NULL,NULL),(71640,'87417','S','Kirtland','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.747130,-108.356972,0,'2013-07-06 12:44:34',NULL,NULL),(7108,'06371','S','Old Lyme','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.328807,-72.309397,0,'2013-07-06 12:44:30',NULL,NULL),(20108,'20709','P','Montpelier','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.064161,-76.837097,0,'2013-07-06 12:44:31',NULL,NULL),(58466,'68734','S','Emmet','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.436057,-98.830831,0,'2013-07-06 12:44:33',NULL,NULL),(32245,'35603','S','Decatur','D','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.546718,-86.981852,0,'2013-07-06 12:44:32',NULL,NULL),(57464,'66858','S','Antelope','A','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.485260,-96.957900,0,'2013-07-06 12:44:33',NULL,NULL),(35368,'39451','S','Hillman','N','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.152091,-88.563411,0,'2013-07-06 12:44:32',NULL,NULL),(78175,'97640','S','Summer Lake','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.977860,-120.776260,0,'2013-07-06 12:44:34',NULL,NULL),(12689,'13135','S','Schroeppel','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.261500,-76.325220,0,'2013-07-06 12:44:30',NULL,NULL),(47531,'54812','S','Barron','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.401861,-91.872294,0,'2013-07-06 12:44:32',NULL,NULL),(28318,'31144','U','Kennesaw','D','Cobb','13067','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',34.023650,-84.615540,0,'2013-07-06 12:44:31',NULL,NULL),(12045,'12526','S','Clermont','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.134040,-73.850340,0,'2013-07-06 12:44:30',NULL,NULL),(40509,'45813','S','Antwerp','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.179794,-84.740486,0,'2013-07-06 12:44:32',NULL,NULL),(31016,'33784','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.815529,-82.679700,0,'2013-07-06 12:44:32',NULL,NULL),(79320,'98603','S','Ariel','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',45.996488,-122.449447,0,'2013-07-06 12:44:34',NULL,NULL),(19573,'20213','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.890866,-77.013467,0,'2013-07-06 12:44:31',NULL,NULL),(4075,'02655','S','Osterville','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.631229,-70.382283,0,'2013-07-06 12:44:30',NULL,NULL),(1953,'00804','P','Charlotte Ama','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.349002,-64.932125,0,'2013-07-06 12:44:30',NULL,NULL),(54564,'62895','S','Crouch','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(68634,'81635','S','Rulison','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.460598,-108.009596,0,'2013-07-06 12:44:34',NULL,NULL),(68222,'81050','S','Ft Bent','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(2595,'00961','S','Urb Fronteras','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(8465,'08088','S','Southampton Twp','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(40631,'46018','P','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.093342,-85.685401,0,'2013-07-06 12:44:32',NULL,NULL),(40854,'46227','S','Homecroft','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.674837,-86.127705,0,'2013-07-06 12:44:32',NULL,NULL),(86,'00612','S','Paseos Reales','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(27169,'29840','S','Mount Carmel','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.988998,-82.446249,0,'2013-07-06 12:44:31',NULL,NULL),(67731,'80549','S','Wellington','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.746861,-105.026390,0,'2013-07-06 12:44:34',NULL,NULL),(66833,'79105','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.062024,-101.786283,0,'2013-07-06 12:44:34',NULL,NULL),(62559,'74447','S','Nuyaka','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.623341,-95.970246,0,'2013-07-06 12:44:33',NULL,NULL),(13498,'13804','S','Masonville','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.222370,-75.371063,0,'2013-07-06 12:44:31',NULL,NULL),(58166,'68197','U','1st National Bank of Omaha','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.259112,-95.937493,0,'2013-07-06 12:44:33',NULL,NULL),(62236,'73950','S','Turpin','D','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.876600,-100.851600,0,'2013-07-06 12:44:33',NULL,NULL),(13256,'13646','S','Rossie','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.450100,-75.686400,0,'2013-07-06 12:44:30',NULL,NULL),(16288,'17104','S','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.260352,-76.855909,0,'2013-07-06 12:44:31',NULL,NULL),(54264,'62677','S','Richland','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.875106,-89.916317,0,'2013-07-06 12:44:33',NULL,NULL),(8291,'08020','S','Clarksboro','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.804769,-75.215002,0,'2013-07-06 12:44:30',NULL,NULL),(51030,'58718','S','Foxholm','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328239,-101.921232,0,'2013-07-06 12:44:33',NULL,NULL),(64854,'77051','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.651308,-95.379997,0,'2013-07-06 12:44:34',NULL,NULL),(34992,'39111','S','McGee','N','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.872919,-89.734963,0,'2013-07-06 12:44:32',NULL,NULL),(39434,'44683','S','Rush','N','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.392715,-81.347949,0,'2013-07-06 12:44:32',NULL,NULL),(68729,'82190','S','Mammoth','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.975150,-110.694710,0,'2013-07-06 12:44:34',NULL,NULL),(66951,'79372','P','Sundown','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.455283,-102.488290,0,'2013-07-06 12:44:34',NULL,NULL),(61166,'72183','P','Tafton-Wrightville','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.598156,-92.216135,0,'2013-07-06 12:44:33',NULL,NULL),(35314,'39421','S','Bassfield','D','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.495255,-89.685891,0,'2013-07-06 12:44:32',NULL,NULL),(13727,'14094','S','Lockport','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.164900,-78.702480,0,'2013-07-06 12:44:31',NULL,NULL),(35683,'39661','S','Garden City','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(41068,'46514','S','Elkhart','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.711357,-85.970759,0,'2013-07-06 12:44:32',NULL,NULL),(1235,'00729','S','Ciudad Jardin De Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(51382,'59412','S','Wayne','N','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.371142,-110.903119,0,'2013-07-06 12:44:33',NULL,NULL),(18404,'19053','S','Trevose','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(5242,'04473','S','Orono','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.888696,-68.676848,0,'2013-07-06 12:44:30',NULL,NULL),(6668,'06030','U','University of Ct Health Ctr','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.711768,-72.839345,0,'2013-07-06 12:44:30',NULL,NULL),(55359,'63563','S','Colony','N','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.348929,-92.107301,0,'2013-07-06 12:44:33',NULL,NULL),(33863,'38008','S','Bolivar','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.265716,-89.003717,0,'2013-07-06 12:44:32',NULL,NULL),(442,'00662','S','Urb Hau','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(1420,'00738','S','Villa Marina','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(10849,'11412','S','Saint Albans','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694225,-73.760504,0,'2013-07-06 12:44:30',NULL,NULL),(53557,'62049','S','Schram City','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.155644,-89.482574,0,'2013-07-06 12:44:33',NULL,NULL),(22589,'24174','S','Thaxton','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.331597,-79.688558,0,'2013-07-06 12:44:31',NULL,NULL),(16514,'17267','S','Buck Valley','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.776683,-78.204091,0,'2013-07-06 12:44:31',NULL,NULL),(8332,'08037','S','Elm','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(29082,'32258','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.139567,-81.544736,0,'2013-07-06 12:44:32',NULL,NULL),(25470,'28341','S','Faison','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.107060,-78.103985,0,'2013-07-06 12:44:31',NULL,NULL),(9375,'09833','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(76735,'95903','S','Marysville','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.110580,-121.357920,0,'2013-07-06 12:44:34',NULL,NULL),(8389,'08060','S','Eastampton Township','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(10819,'11378','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.725746,-73.903899,0,'2013-07-06 12:44:30',NULL,NULL),(28891,'32127','S','Pt Orange','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.110341,-80.980002,0,'2013-07-06 12:44:32',NULL,NULL),(26542,'29205','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.992894,-80.994240,0,'2013-07-06 12:44:31',NULL,NULL),(3214,'01364','S','N Orange','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(79363,'98648','S','Skamania','N','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.834480,-121.840560,0,'2013-07-06 12:44:34',NULL,NULL),(55975,'64508','P','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.776769,-94.801029,0,'2013-07-06 12:44:33',NULL,NULL),(16118,'17055','S','Upper Allen','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(33083,'36786','S','Uniontown','D','Perry','01105','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.459293,-87.464556,0,'2013-07-06 12:44:32',NULL,NULL),(14122,'14647','U','Excellus BCBS','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157199,-77.608041,0,'2013-07-06 12:44:31',NULL,NULL),(28011,'30619','S','Arnoldsville','D','Oglethorpe','13221','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.849559,-83.284161,0,'2013-07-06 12:44:31',NULL,NULL),(9227,'09534','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(74001,'92109','S','Pacific Beach','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.791495,-117.236899,0,'2013-07-06 12:44:34',NULL,NULL),(65632,'77964','S','Breslau','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(57961,'67758','S','Sharon Springs','D','Wallace','20199','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',38.901914,-101.747317,0,'2013-07-06 12:44:33',NULL,NULL),(5823,'05075','S','Thetford Center','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.823651,-72.272568,0,'2013-07-06 12:44:30',NULL,NULL),(12723,'13157','P','Sylvan Beach','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.207563,-75.730526,0,'2013-07-06 12:44:30',NULL,NULL),(62101,'73624','P','Burns Flat','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.352897,-99.173437,0,'2013-07-06 12:44:33',NULL,NULL),(55777,'64117','S','Randolph','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.154167,-94.546667,0,'2013-07-06 12:44:33',NULL,NULL),(49090,'56331','S','Saint Rosa','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.681666,-94.680948,0,'2013-07-06 12:44:33',NULL,NULL),(21481,'22644','S','Maurertown','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.984928,-78.511001,0,'2013-07-06 12:44:31',NULL,NULL),(69562,'83815','S','Huetter','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.725192,-116.786915,0,'2013-07-06 12:44:34',NULL,NULL),(17775,'18342','P','Mountain Home','N','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.177592,-75.259145,0,'2013-07-06 12:44:31',NULL,NULL),(53809,'62294','S','Troy','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.706800,-89.873032,0,'2013-07-06 12:44:33',NULL,NULL),(51291,'59213','S','Brockton','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.329383,-104.870593,0,'2013-07-06 12:44:33',NULL,NULL),(59368,'70584','S','Sunset','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.381780,-92.092020,0,'2013-07-06 12:44:33',NULL,NULL),(31030,'33786','S','Indian Rocks Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(52021,'60176','S','Schiller Park','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',41.957359,-87.867520,0,'2013-07-06 12:44:33',NULL,NULL),(34846,'38922','S','Tyson','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(38290,'43337','S','Morral','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.676941,-83.253323,0,'2013-07-06 12:44:32',NULL,NULL),(50151,'57543','S','Kadoka','D','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.833284,-101.486542,0,'2013-07-06 12:44:33',NULL,NULL),(15788,'16923','S','Keech','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(34912,'38958','P','Swan Lake','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.949231,-90.174679,0,'2013-07-06 12:44:32',NULL,NULL),(77252,'96548','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(54234,'62663','P','Manchester','D','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.542922,-90.331459,0,'2013-07-06 12:44:33',NULL,NULL),(52889,'61350','S','Naplate','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(16788,'17535','S','New Milltown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.007451,-76.042530,0,'2013-07-06 12:44:31',NULL,NULL),(17161,'17814','S','Benton','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(6977,'06241','S','Killingly Center','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.851822,-71.860430,0,'2013-07-06 12:44:30',NULL,NULL),(16913,'17602','S','Fertility','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(13583,'13845','P','Tioga Center','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.057895,-76.350624,0,'2013-07-06 12:44:31',NULL,NULL),(36860,'41081','P','Plummers Mill','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.304959,-83.569924,0,'2013-07-06 12:44:32',NULL,NULL),(39064,'44201','S','Atwater','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.023195,-81.197179,0,'2013-07-06 12:44:32',NULL,NULL),(41380,'46797','S','Edgerton','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.130094,-84.866509,0,'2013-07-06 12:44:32',NULL,NULL),(5496,'04757','S','Castle Hill','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.654140,-68.184981,0,'2013-07-06 12:44:30',NULL,NULL),(69809,'84071','S','Bauer','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.449676,-112.359074,0,'2013-07-06 12:44:34',NULL,NULL),(55663,'64029','S','Grain Valley','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.005657,-94.212745,0,'2013-07-06 12:44:33',NULL,NULL),(8487,'08094','S','Cecil','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.642840,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(79011,'98388','S','McNeil Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.170637,-122.588055,0,'2013-07-06 12:44:34',NULL,NULL),(70714,'85281','S','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.422399,-111.927588,0,'2013-07-06 12:44:34',NULL,NULL),(27500,'30173','S','Silver Creek','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.149900,-85.139033,0,'2013-07-06 12:44:31',NULL,NULL),(9875,'10122','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(60477,'71655','S','Tennessee','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(60709,'71950','S','Kirby','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.220101,-93.583010,0,'2013-07-06 12:44:33',NULL,NULL),(15546,'16620','P','Brisbin','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.835418,-78.355642,0,'2013-07-06 12:44:31',NULL,NULL),(70905,'85624','S','Lochiel','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.532257,-110.747116,0,'2013-07-06 12:44:34',NULL,NULL),(61317,'72438','S','Leachville','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.932079,-90.252668,0,'2013-07-06 12:44:33',NULL,NULL),(53922,'62401','S','Boggsville','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(46456,'53212','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.070633,-87.906171,0,'2013-07-06 12:44:32',NULL,NULL),(9515,'10017','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(63534,'75757','S','Teaselville','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.150666,-95.372322,0,'2013-07-06 12:44:33',NULL,NULL),(69422,'83633','S','King Hill','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.859902,-115.243209,0,'2013-07-06 12:44:34',NULL,NULL),(20284,'20792','P','Upper Marlboro','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.815289,-76.749621,0,'2013-07-06 12:44:31',NULL,NULL),(57084,'66216','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.008231,-94.740275,0,'2013-07-06 12:44:33',NULL,NULL),(15258,'16059','S','Valencia','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.703547,-79.917583,0,'2013-07-06 12:44:31',NULL,NULL),(11826,'12239','U','NY Civil Serv Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.650821,-73.758546,0,'2013-07-06 12:44:30',NULL,NULL),(20229,'20774','S','Uppr Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(20770,'21521','S','Barton','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.551923,-79.080111,0,'2013-07-06 12:44:31',NULL,NULL),(50461,'58032','S','Forman','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.107812,-97.638188,0,'2013-07-06 12:44:33',NULL,NULL),(2705,'00969','S','Ext Terrs de Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(54479,'62859','S','South Crouch','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(33937,'38068','S','Somerville','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.241585,-89.359208,0,'2013-07-06 12:44:32',NULL,NULL),(20663,'21226','S','Orchard Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(53493,'62006','S','Batchtown','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.087140,-90.668661,0,'2013-07-06 12:44:33',NULL,NULL),(1924,'00795','S','Sect Serena','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(76814,'95953','S','Pennington','N','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.259446,-121.695206,0,'2013-07-06 12:44:34',NULL,NULL),(21758,'23058','P','Gln Alln','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.662023,-77.484349,0,'2013-07-06 12:44:31',NULL,NULL),(19807,'20442','U','Court of Military Appeals','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892812,-77.014512,0,'2013-07-06 12:44:31',NULL,NULL),(27696,'30339','S','ATL','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(36811,'41056','S','Rectorville','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(35553,'39564','S','Ocean Springs','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(70059,'84143','U','Lds Hospital','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.779354,-111.880031,0,'2013-07-06 12:44:34',NULL,NULL),(728,'00687','S','Valle Barahona','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(27989,'30577','S','Toccoa','D','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.573035,-83.318464,0,'2013-07-06 12:44:31',NULL,NULL),(7936,'07656','S','Park Ridge','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.032204,-74.041158,0,'2013-07-06 12:44:30',NULL,NULL),(60287,'71450','S','Little Egypt','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.793040,-93.399660,0,'2013-07-06 12:44:33',NULL,NULL),(44767,'50208','S','Amboy','N','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.697096,-93.046897,0,'2013-07-06 12:44:32',NULL,NULL),(2815,'00976','S','Villas del Sol','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(54592,'62901','S','Lakewood Park','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(63723,'75931','S','Brookeland','D','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',31.098300,-93.999180,0,'2013-07-06 12:44:34',NULL,NULL),(61287,'72402','P','Jonesboro','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.806103,-90.774552,0,'2013-07-06 12:44:33',NULL,NULL),(18618,'19149','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.038521,-75.067175,0,'2013-07-06 12:44:31',NULL,NULL),(6870,'06137','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(72888,'90015','S','Textile Finance','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038557,-118.268695,0,'2013-07-06 12:44:34',NULL,NULL),(38878,'44106','S','Cleveland Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.505132,-81.607134,0,'2013-07-06 12:44:32',NULL,NULL),(34880,'38943','S','Mc Carley','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.590842,-89.850324,0,'2013-07-06 12:44:32',NULL,NULL),(21351,'22435','S','Walmsley','N','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.941111,-76.535556,0,'2013-07-06 12:44:31',NULL,NULL),(41526,'46988','S','12 Mile','N','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.858248,-86.204585,0,'2013-07-06 12:44:32',NULL,NULL),(24792,'27584','P','Townsville','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.496145,-78.423856,0,'2013-07-06 12:44:31',NULL,NULL),(21729,'23011','S','Barhamsville','D','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.463636,-76.818238,0,'2013-07-06 12:44:31',NULL,NULL),(64607,'76687','S','Bighill','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(37266,'41568','S','Woodman','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.519380,-82.054500,0,'2013-07-06 12:44:32',NULL,NULL),(78011,'97413','S','McKenzie Bridge','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.179665,-122.120204,0,'2013-07-06 12:44:34',NULL,NULL),(67346,'80108','S','Castle Rock','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.391907,-104.859358,0,'2013-07-06 12:44:34',NULL,NULL),(11931,'12429','P','Esopus','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.837603,-73.995484,0,'2013-07-06 12:44:30',NULL,NULL),(14465,'15116','S','Glenshaw','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.523761,-79.946120,0,'2013-07-06 12:44:31',NULL,NULL),(39908,'45216','S','Saint Bernard','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(62200,'73834','S','Buffalo','D','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.826980,-99.592380,0,'2013-07-06 12:44:33',NULL,NULL),(20697,'21250','U','Univ of Md Baltimore County','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252457,-76.711210,0,'2013-07-06 12:44:31',NULL,NULL),(53348,'61760','S','Woodford','N','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.893180,-89.035680,0,'2013-07-06 12:44:33',NULL,NULL),(20351,'20861','S','Ashton','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.155101,-76.994217,0,'2013-07-06 12:44:31',NULL,NULL),(43898,'49242','S','Hillsdale','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.901249,-84.620166,0,'2013-07-06 12:44:32',NULL,NULL),(3285,'01501','S','Auburn','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.205001,-71.840473,0,'2013-07-06 12:44:30',NULL,NULL),(24005,'26349','P','Galloway','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.223973,-80.134333,0,'2013-07-06 12:44:31',NULL,NULL),(45188,'50613','S','Cedarfalls','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(12253,'12831','S','Gurn Spring','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.198440,-73.678260,0,'2013-07-06 12:44:30',NULL,NULL),(80011,'99676','S','Talkeetna','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.175505,-149.900179,0,'2013-07-06 12:44:34',NULL,NULL),(55332,'63548','S','Lancaster','D','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.532296,-92.515275,0,'2013-07-06 12:44:33',NULL,NULL),(29240,'32434','P','Defuniak Springs','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.742338,-86.314609,0,'2013-07-06 12:44:32',NULL,NULL),(14139,'14702','P','Jamestown','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.096597,-79.234978,0,'2013-07-06 12:44:31',NULL,NULL),(44229,'49653','S','Lake Leelanau','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.989830,-85.735701,0,'2013-07-06 12:44:32',NULL,NULL),(17596,'18037','S','Ironton','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.683120,-75.512220,0,'2013-07-06 12:44:31',NULL,NULL),(67674,'80502','P','Longmont','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.027278,-105.296670,0,'2013-07-06 12:44:34',NULL,NULL),(73877,'91941','S','La Mesa','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.759711,-116.997713,0,'2013-07-06 12:44:34',NULL,NULL),(88,'00612','S','Repto San Jose','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(74979,'93442','S','Morro Bay','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.384144,-120.850075,0,'2013-07-06 12:44:34',NULL,NULL),(58820,'69037','S','Max','D','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.111864,-101.380433,0,'2013-07-06 12:44:33',NULL,NULL),(42719,'48003','S','Almont','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.923761,-83.043136,0,'2013-07-06 12:44:32',NULL,NULL),(44044,'49428','S','Georgetown Township','A','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.907457,-85.830308,0,'2013-07-06 12:44:32',NULL,NULL),(77728,'97067','S','Wemme','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.339237,-121.965273,0,'2013-07-06 12:44:34',NULL,NULL),(37528,'42049','S','Hazel','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.539870,-88.342749,0,'2013-07-06 12:44:32',NULL,NULL),(1957,'00820','S','Christiansted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.745943,-64.707272,0,'2013-07-06 12:44:30',NULL,NULL),(2252,'00926','S','Urb Los Cantizales','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(5225,'04463','S','Derby','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.248630,-68.986198,0,'2013-07-06 12:44:30',NULL,NULL),(18316,'19021','S','Bensalem','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.094171,-74.909281,0,'2013-07-06 12:44:31',NULL,NULL),(80190,'99903','P','Meyers Chuck','D','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.740000,-132.250000,0,'2013-07-06 12:44:34',NULL,NULL),(68062,'80934','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.844726,-104.860092,0,'2013-07-06 12:44:34',NULL,NULL),(19348,'20043','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905357,-77.031771,0,'2013-07-06 12:44:31',NULL,NULL),(43872,'49130','S','Edwardsburg','A','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.785266,-85.852560,0,'2013-07-06 12:44:32',NULL,NULL),(40630,'46017','S','Chesterfield','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.084260,-85.604700,0,'2013-07-06 12:44:32',NULL,NULL),(32012,'35234','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.535960,-86.802701,0,'2013-07-06 12:44:32',NULL,NULL),(64139,'76196','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755869,-97.338178,0,'2013-07-06 12:44:34',NULL,NULL),(37919,'42633','S','Steubenville','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(63975,'76106','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.799177,-97.358089,0,'2013-07-06 12:44:34',NULL,NULL),(56025,'64671','S','Polo','D','Caldwell','29025','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.556678,-94.038416,0,'2013-07-06 12:44:33',NULL,NULL),(7612,'07052','S','West Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.784909,-74.257646,0,'2013-07-06 12:44:30',NULL,NULL),(15291,'16132','P','Hillsville','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.007866,-80.500237,0,'2013-07-06 12:44:31',NULL,NULL),(55019,'63134','S','Woodson Terrace','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.738992,-90.342092,0,'2013-07-06 12:44:33',NULL,NULL),(61995,'73425','P','Countyline','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.447952,-97.560974,0,'2013-07-06 12:44:33',NULL,NULL),(68958,'83001','S','Hoback Junction','A','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472028,-110.766160,0,'2013-07-06 12:44:34',NULL,NULL),(77004,'96080','S','Red Bluff','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.177299,-122.263016,0,'2013-07-06 12:44:34',NULL,NULL),(26741,'29420','S','No Chas','N','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.923689,-80.099458,0,'2013-07-06 12:44:31',NULL,NULL),(47033,'54404','U','Figis Inc','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.667961,-90.168447,0,'2013-07-06 12:44:32',NULL,NULL),(58938,'69352','S','Lyman','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.914106,-104.037046,0,'2013-07-06 12:44:33',NULL,NULL),(55715,'64073','P','Mosby','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.313910,-94.291540,0,'2013-07-06 12:44:33',NULL,NULL),(55468,'63742','P','Commerce','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.158771,-89.443457,0,'2013-07-06 12:44:33',NULL,NULL),(32349,'35809','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.730278,-86.586111,0,'2013-07-06 12:44:32',NULL,NULL),(22858,'24541','S','Schoolfield','N','Danville City','51590','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.574659,-79.436458,0,'2013-07-06 12:44:31',NULL,NULL),(40570,'45866','P','Montezuma','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.490703,-84.547420,0,'2013-07-06 12:44:32',NULL,NULL),(61000,'72112','S','Remmel','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(56773,'65742','S','Linden','N','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.121940,-93.138780,0,'2013-07-06 12:44:33',NULL,NULL),(32275,'35648','S','Lexington','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.955610,-87.393336,0,'2013-07-06 12:44:32',NULL,NULL),(29475,'32723','U','Stetson University','N','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.009964,-81.308768,0,'2013-07-06 12:44:32',NULL,NULL),(78962,'98370','S','Sandy Hook Park','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(78782,'98312','S','Kitsap Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(68226,'81050','S','Timber Lake','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(38560,'43766','S','New Straitsville','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.614349,-82.280139,0,'2013-07-06 12:44:32',NULL,NULL),(66626,'78783','U','City Water and Light Dept','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.246407,-97.766387,0,'2013-07-06 12:44:34',NULL,NULL),(62922,'75080','S','Richardson','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.963287,-96.745163,0,'2013-07-06 12:44:33',NULL,NULL),(23096,'24931','S','Clintonville','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.880631,-80.587119,0,'2013-07-06 12:44:31',NULL,NULL),(41008,'46368','S','Portage','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.584620,-87.174720,0,'2013-07-06 12:44:32',NULL,NULL),(6171,'05473','S','N Ferrisburgh','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(30280,'33256','P','Village of Pinecrest','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661865,-80.326386,0,'2013-07-06 12:44:32',NULL,NULL),(782,'00693','S','Bo Carmelita','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(63598,'75790','S','Van','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.529240,-95.637490,0,'2013-07-06 12:44:34',NULL,NULL),(9554,'10023','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(38536,'43740','P','Gratiot','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.949506,-82.210768,0,'2013-07-06 12:44:32',NULL,NULL),(18934,'19505','S','Passmore','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.372171,-75.627950,0,'2013-07-06 12:44:31',NULL,NULL),(23660,'25823','S','Coal City','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.666111,-81.184444,0,'2013-07-06 12:44:31',NULL,NULL),(75897,'94974','S','San Quentin','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.956461,-122.539347,0,'2013-07-06 12:44:34',NULL,NULL),(70184,'84332','S','Providence','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.699994,-111.806147,0,'2013-07-06 12:44:34',NULL,NULL),(1296,'00730','S','Urb Las Monjitas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(6513,'05822','S','Barton','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.752209,-72.184037,0,'2013-07-06 12:44:30',NULL,NULL),(63380,'75644','S','Indian Rock','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(17822,'18413','P','Clifford','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.649391,-75.598833,0,'2013-07-06 12:44:31',NULL,NULL),(36986,'41189','S','Ribolt','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.586965,-83.548106,0,'2013-07-06 12:44:32',NULL,NULL),(40085,'45304','S','Arcanum','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.989474,-84.534278,0,'2013-07-06 12:44:32',NULL,NULL),(7686,'07102','S','Washington Park','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.732638,-74.171775,0,'2013-07-06 12:44:30',NULL,NULL),(49304,'56535','S','Erskine','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.668141,-96.006004,0,'2013-07-06 12:44:33',NULL,NULL),(48341,'55473','P','Norwood Young America','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.961613,-93.266171,0,'2013-07-06 12:44:33',NULL,NULL),(28632,'31744','S','Doerun','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.314801,-83.920494,0,'2013-07-06 12:44:32',NULL,NULL),(23105,'24938','S','Friars Hill','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.909770,-80.357408,0,'2013-07-06 12:44:31',NULL,NULL),(76161,'95313','S','Crows Landing','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.428427,-121.043212,0,'2013-07-06 12:44:34',NULL,NULL),(61204,'72255','U','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(37214,'41527','S','Forest Hills','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.625841,-82.303733,0,'2013-07-06 12:44:32',NULL,NULL),(37437,'41833','S','Linefork','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.038564,-82.945432,0,'2013-07-06 12:44:32',NULL,NULL),(76531,'95654','P','Jackson','A','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.366807,-120.794619,0,'2013-07-06 12:44:34',NULL,NULL),(72346,'89018','P','Creech Air Force Base','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570550,-115.669994,0,'2013-07-06 12:44:34',NULL,NULL),(66614,'78769','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.306857,-97.749066,0,'2013-07-06 12:44:34',NULL,NULL),(47917,'55110','S','White Bear Lake','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(21071,'22009','P','Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.793333,-77.271944,0,'2013-07-06 12:44:31',NULL,NULL),(47277,'54537','S','Kennan','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.530331,-90.591477,0,'2013-07-06 12:44:32',NULL,NULL),(18109,'18766','U','Wilkes University','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.244606,-75.883149,0,'2013-07-06 12:44:31',NULL,NULL),(62327,'74044','S','Mansford','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.121473,-96.344224,0,'2013-07-06 12:44:33',NULL,NULL),(41250,'46742','S','Otsego','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(32486,'36051','S','Marbury','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.668183,-86.517425,0,'2013-07-06 12:44:32',NULL,NULL),(79263,'98568','S','Cedarville','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.843134,-123.246221,0,'2013-07-06 12:44:34',NULL,NULL),(66929,'79346','S','Morton','D','Cochran','48079','Texas','TX','48','0000','806','Central',-6.0,'Y',33.723906,-102.756807,0,'2013-07-06 12:44:34',NULL,NULL),(39206,'44398','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081679,-81.507276,0,'2013-07-06 12:44:32',NULL,NULL),(7281,'06531','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318194,-72.929494,0,'2013-07-06 12:44:30',NULL,NULL),(48560,'55765','S','Meadowlands','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.101666,-92.758853,0,'2013-07-06 12:44:33',NULL,NULL),(24424,'27155','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.105135,-80.201896,0,'2013-07-06 12:44:31',NULL,NULL),(43255,'48323','S','West Bloomfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573180,-83.380200,0,'2013-07-06 12:44:32',NULL,NULL),(31550,'34606','S','Weeki Wachee','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.466311,-82.596769,0,'2013-07-06 12:44:32',NULL,NULL),(48742,'55969','S','Rollingstone','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.096833,-91.819032,0,'2013-07-06 12:44:33',NULL,NULL),(56765,'65737','S','Reeds Spring','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.679200,-93.370680,0,'2013-07-06 12:44:33',NULL,NULL),(35743,'39730','S','Darracott','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(9981,'10163','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755007,-73.967791,0,'2013-07-06 12:44:30',NULL,NULL),(14296,'14877','S','Rexville','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.075702,-77.667295,0,'2013-07-06 12:44:31',NULL,NULL),(18451,'19073','S','Newtown Square','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.983187,-75.412719,0,'2013-07-06 12:44:31',NULL,NULL),(6350,'05673','S','Waitsfield','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.187565,-72.843339,0,'2013-07-06 12:44:30',NULL,NULL),(67814,'80747','S','Peetz','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.950335,-103.070573,0,'2013-07-06 12:44:34',NULL,NULL),(64701,'76853','S','Scallorn','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.209970,-98.398425,0,'2013-07-06 12:44:34',NULL,NULL),(60833,'72039','S','Gravesville','N','Van Buren','05141','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.298334,-92.439056,0,'2013-07-06 12:44:33',NULL,NULL),(20645,'21222','S','Dundalk Sparrows Point','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.263020,-76.499604,0,'2013-07-06 12:44:31',NULL,NULL),(1427,'00739','S','Hacienda Primavera','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(55549,'63850','P','Grayridge','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.821694,-89.783673,0,'2013-07-06 12:44:33',NULL,NULL),(18326,'19026','S','Drexel Hill','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.955020,-75.327420,0,'2013-07-06 12:44:31',NULL,NULL),(8774,'08550','S','W Windsor Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(13006,'13415','S','Stetsonville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.599137,-75.187460,0,'2013-07-06 12:44:30',NULL,NULL),(39519,'44817','S','Bloomdale','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.193937,-83.549843,0,'2013-07-06 12:44:32',NULL,NULL),(38463,'43615','S','Sylvania Twp','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651393,-83.674791,0,'2013-07-06 12:44:32',NULL,NULL),(14415,'15068','S','Barking','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(31296,'34078','M','APO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(17843,'18424','S','Covington Township','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(67126,'79748','S','Knott','D','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.402484,-101.640380,0,'2013-07-06 12:44:34',NULL,NULL),(15803,'16926','S','Granville Summit','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.666415,-76.720268,0,'2013-07-06 12:44:31',NULL,NULL),(7548,'07012','S','Clifton','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.846872,-74.160888,0,'2013-07-06 12:44:30',NULL,NULL),(8957,'08804','S','Bloomsbury','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.645635,-75.076618,0,'2013-07-06 12:44:30',NULL,NULL),(75861,'94941','S','Strawberry Point','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.890300,-122.567640,0,'2013-07-06 12:44:34',NULL,NULL),(66525,'78717','S','Austin','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.503015,-97.742252,0,'2013-07-06 12:44:34',NULL,NULL),(60513,'71667','S','Cornerville','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(1816,'00784','S','Guayama','D','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(22998,'24801','S','Superior','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(27814,'30401','S','Kemp','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(55990,'64635','S','Chula','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.922120,-93.477648,0,'2013-07-06 12:44:33',NULL,NULL),(39212,'44403','S','Yankee Lake','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.236682,-80.577887,0,'2013-07-06 12:44:32',NULL,NULL),(37505,'42032','S','Columbus','D','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.717637,-89.103911,0,'2013-07-06 12:44:32',NULL,NULL),(2582,'00961','S','Bo Hato Tejas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(60708,'71949','S','Jessieville','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.710102,-93.220625,0,'2013-07-06 12:44:33',NULL,NULL),(59871,'71264','S','Oak Ridge','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.645846,-91.746526,0,'2013-07-06 12:44:33',NULL,NULL),(32296,'35740','S','Bridgeport','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.945931,-85.720479,0,'2013-07-06 12:44:32',NULL,NULL),(34414,'38633','S','Hickory Flat','D','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.638021,-89.177255,0,'2013-07-06 12:44:32',NULL,NULL),(51065,'58750','S','Lansford','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617118,-101.405976,0,'2013-07-06 12:44:33',NULL,NULL),(1026,'00718','S','Urb Ramon Rivero','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(11161,'11722','S','Central Islip','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.779120,-73.191420,0,'2013-07-06 12:44:30',NULL,NULL),(35190,'39284','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.275332,-90.218859,0,'2013-07-06 12:44:32',NULL,NULL),(28095,'30746','S','Sugar Valley','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.572613,-85.025048,0,'2013-07-06 12:44:31',NULL,NULL),(54620,'62916','S','Shiloh Hill','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.915585,-89.593551,0,'2013-07-06 12:44:33',NULL,NULL),(57876,'67601','S','Antonino','A','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.820000,-99.408660,0,'2013-07-06 12:44:33',NULL,NULL),(67250,'79949','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761865,-106.481730,0,'2013-07-06 12:44:34',NULL,NULL),(67644,'80465','S','Morrison','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612381,-105.226694,0,'2013-07-06 12:44:34',NULL,NULL),(49599,'56754','S','Saint Hilaire','D','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.999422,-96.277601,0,'2013-07-06 12:44:33',NULL,NULL),(51619,'59841','P','Pinesdale','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.328126,-114.218919,0,'2013-07-06 12:44:33',NULL,NULL),(21859,'23148','S','Indian Neck','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.914841,-77.076387,0,'2013-07-06 12:44:31',NULL,NULL),(26571,'29214','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.000793,-81.031935,0,'2013-07-06 12:44:31',NULL,NULL),(6241,'05491','S','West Addison','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(23207,'25070','P','Eleanor','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.537903,-81.928171,0,'2013-07-06 12:44:31',NULL,NULL),(38520,'43727','S','Chandlersville','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.877305,-81.810514,0,'2013-07-06 12:44:32',NULL,NULL),(18437,'19065','P','Moylan','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.918847,-75.390133,0,'2013-07-06 12:44:31',NULL,NULL),(50667,'58338','S','Hampden','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.503581,-98.643672,0,'2013-07-06 12:44:33',NULL,NULL),(46675,'53719','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.032837,-89.498129,0,'2013-07-06 12:44:32',NULL,NULL),(73804,'91755','S','Monterey Park','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.051246,-118.117947,0,'2013-07-06 12:44:34',NULL,NULL),(77059,'96120','S','Emigrant Trail','N','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(79109,'98465','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.248993,-122.528516,0,'2013-07-06 12:44:34',NULL,NULL),(41685,'47190','S','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.279200,-85.722700,0,'2013-07-06 12:44:32',NULL,NULL),(40120,'45324','S','Fairborn','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.807279,-84.019499,0,'2013-07-06 12:44:32',NULL,NULL),(31005,'33775','P','Seminole','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.845310,-82.794565,0,'2013-07-06 12:44:32',NULL,NULL),(57132,'66225','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.888339,-94.686133,0,'2013-07-06 12:44:33',NULL,NULL),(50055,'57438','S','Faulkton','D','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.035596,-99.120562,0,'2013-07-06 12:44:33',NULL,NULL),(44825,'50250','S','Arbor Hill','N','Guthrie','19077','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.502010,-94.316481,0,'2013-07-06 12:44:32',NULL,NULL),(14911,'15536','S','Crystal Spg','A','Fulton','42057','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.929488,-78.212411,0,'2013-07-06 12:44:31',NULL,NULL),(79907,'99591','P','St Paul Isle','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',56.591517,-169.620701,0,'2013-07-06 12:44:34',NULL,NULL),(76940,'96025','S','Dunsmuir','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.211393,-122.274427,0,'2013-07-06 12:44:34',NULL,NULL),(63937,'76067','S','Salesville','N','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.826780,-98.097180,0,'2013-07-06 12:44:34',NULL,NULL),(32685,'36272','S','Borden Springs','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.916629,-85.632561,0,'2013-07-06 12:44:32',NULL,NULL),(816,'00693','S','Urb Las Terrenas','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(9401,'09874','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42568,'47874','S','West Atherton','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(23637,'25771','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.341767,-82.517475,0,'2013-07-06 12:44:31',NULL,NULL),(30469,'33339','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163838,-80.113870,0,'2013-07-06 12:44:32',NULL,NULL),(55037,'63138','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.795220,-90.209040,0,'2013-07-06 12:44:33',NULL,NULL),(48656,'55910','S','Elba','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(36529,'40854','P','Loyall','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.846185,-83.355819,0,'2013-07-06 12:44:32',NULL,NULL),(51095,'58773','S','Battleview','A','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.618780,-102.624000,0,'2013-07-06 12:44:33',NULL,NULL),(72828,'89825','S','Contact','N','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',41.763600,-115.074720,0,'2013-07-06 12:44:34',NULL,NULL),(57971,'67831','S','Ashland','D','Clark','20025','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.189068,-99.770945,0,'2013-07-06 12:44:33',NULL,NULL),(20937,'21758','S','Brunswick','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.341495,-77.653907,0,'2013-07-06 12:44:31',NULL,NULL),(48410,'55598','P','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.106486,-93.661621,0,'2013-07-06 12:44:33',NULL,NULL),(55149,'63362','S','Moscow Mills','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.931175,-90.881331,0,'2013-07-06 12:44:33',NULL,NULL),(9524,'10018','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(8822,'08619','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.238460,-74.717460,0,'2013-07-06 12:44:30',NULL,NULL),(40316,'45459','S','Washington Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(23512,'25545','S','Ona','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.434490,-82.225918,0,'2013-07-06 12:44:31',NULL,NULL),(52027,'60179','U','Sears Roebuck and Company','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.079712,-88.224255,0,'2013-07-06 12:44:33',NULL,NULL),(29499,'32753','P','Debary','D','Volusia','12127','Florida','FL','12','2020','407/321/689','Eastern',-5.0,'Y',28.880831,-81.306330,0,'2013-07-06 12:44:32',NULL,NULL),(24725,'27515','P','Chapel Hill','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.910217,-79.054608,0,'2013-07-06 12:44:31',NULL,NULL),(3532,'01904','S','East Lynn','A','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.488960,-70.963687,0,'2013-07-06 12:44:30',NULL,NULL),(21110,'22066','S','Great Falls','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.002477,-77.300045,0,'2013-07-06 12:44:31',NULL,NULL),(74120,'92235','P','Cathedral City','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.780606,-116.461273,0,'2013-07-06 12:44:34',NULL,NULL),(64700,'76853','S','Lometa','D','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.209970,-98.398425,0,'2013-07-06 12:44:34',NULL,NULL),(18739,'19335','S','West Bradford','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.016500,-75.713718,0,'2013-07-06 12:44:31',NULL,NULL),(7023,'06263','P','Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.838480,-71.904924,0,'2013-07-06 12:44:30',NULL,NULL),(17841,'18424','S','Clifton Township','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(73932,'92036','S','Julian','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.040532,-116.546326,0,'2013-07-06 12:44:34',NULL,NULL),(65775,'78112','S','Elmendorf','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.226523,-98.366970,0,'2013-07-06 12:44:34',NULL,NULL),(49998,'57373','S','Saint Lawrence','D','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.531049,-98.806533,0,'2013-07-06 12:44:33',NULL,NULL),(5694,'04978','S','Smithfield','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.617911,-69.804118,0,'2013-07-06 12:44:30',NULL,NULL),(45250,'50659','S','N Washington','A','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.062151,-92.314419,0,'2013-07-06 12:44:32',NULL,NULL),(62168,'73741','S','Helena','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.547541,-98.275187,0,'2013-07-06 12:44:33',NULL,NULL),(78945,'98368','S','Fort Worden','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(62,'00612','S','Alt de San Felipe','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(12149,'12736','S','Fremont Ctr','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.848718,-75.024350,0,'2013-07-06 12:44:30',NULL,NULL),(44004,'49348','S','Wayland','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.680118,-85.634853,0,'2013-07-06 12:44:32',NULL,NULL),(56501,'65340','S','Marshall','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.114311,-93.196522,0,'2013-07-06 12:44:33',NULL,NULL),(39137,'44273','S','Seville','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027572,-81.883128,0,'2013-07-06 12:44:32',NULL,NULL),(18389,'19049','U','Fort Washington','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.175266,-74.919785,0,'2013-07-06 12:44:31',NULL,NULL),(42945,'48120','S','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.306408,-83.173266,0,'2013-07-06 12:44:32',NULL,NULL),(25596,'28450','S','Lake Waccamaw','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.315897,-78.505018,0,'2013-07-06 12:44:31',NULL,NULL),(71839,'87581','S','Lower Ranchito','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.698574,-106.136233,0,'2013-07-06 12:44:34',NULL,NULL),(71216,'86320','P','Ash Fork','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.184344,-112.630085,0,'2013-07-06 12:44:34',NULL,NULL),(1201,'00728','S','Parc Magueyes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(69278,'83440','S','Rexburg','D','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(73384,'91104','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.166482,-118.120445,0,'2013-07-06 12:44:34',NULL,NULL),(68995,'83128','S','Alpine','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.121071,-111.022495,0,'2013-07-06 12:44:34',NULL,NULL),(59027,'70082','P','Bohemia','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.575598,-89.793242,0,'2013-07-06 12:44:33',NULL,NULL),(36947,'41166','S','Saint Paul','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.631473,-83.095046,0,'2013-07-06 12:44:32',NULL,NULL),(62858,'75027','P','Lewisville','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.026466,-97.093775,0,'2013-07-06 12:44:33',NULL,NULL),(12444,'12962','S','West Plattsburgh','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.703540,-73.575720,0,'2013-07-06 12:44:30',NULL,NULL),(77776,'97123','S','Orenco','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.506393,-122.946368,0,'2013-07-06 12:44:34',NULL,NULL),(64671,'76823','S','Bangs','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.715094,-99.126441,0,'2013-07-06 12:44:34',NULL,NULL),(41611,'47119','S','Galena','A','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.356200,-85.904760,0,'2013-07-06 12:44:32',NULL,NULL),(48438,'55704','S','Askov','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.272907,-92.812752,0,'2013-07-06 12:44:33',NULL,NULL),(49949,'57342','S','Bovee','N','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.251792,-98.688470,0,'2013-07-06 12:44:33',NULL,NULL),(51769,'60034','S','Hebron','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.458103,-88.417579,0,'2013-07-06 12:44:33',NULL,NULL),(79990,'99660','P','Saint Paul Island','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',57.184029,-170.273301,0,'2013-07-06 12:44:34',NULL,NULL),(15537,'16602','S','Altoona','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.499797,-78.388319,0,'2013-07-06 12:44:31',NULL,NULL),(41663,'47146','P','Mt St Francis','A','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.318232,-85.911798,0,'2013-07-06 12:44:32',NULL,NULL),(33099,'36851','P','Cottonton','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.145972,-85.063402,0,'2013-07-06 12:44:32',NULL,NULL),(36313,'40376','S','Slade','D','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.774455,-83.685771,0,'2013-07-06 12:44:32',NULL,NULL),(79620,'99119','S','Cusick','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.439941,-117.320850,0,'2013-07-06 12:44:34',NULL,NULL),(52981,'61433','P','Fiatt','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.580115,-90.156551,0,'2013-07-06 12:44:33',NULL,NULL),(23571,'25652','P','Whitman','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.790768,-82.050870,0,'2013-07-06 12:44:31',NULL,NULL),(54549,'62888','S','Tamaroa','D','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.148503,-89.210204,0,'2013-07-06 12:44:33',NULL,NULL),(5457,'04732','S','Masardis','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.626925,-68.418941,0,'2013-07-06 12:44:30',NULL,NULL),(42178,'47532','S','Ferdinand','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.226646,-86.862058,0,'2013-07-06 12:44:32',NULL,NULL),(6018,'05363','S','West Marlboro','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.883215,-72.898726,0,'2013-07-06 12:44:30',NULL,NULL),(45125,'50566','S','Moorland','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.445392,-94.290298,0,'2013-07-06 12:44:32',NULL,NULL),(56662,'65623','P','Butterfield','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.745097,-93.914040,0,'2013-07-06 12:44:33',NULL,NULL),(42081,'47454','S','Youngs Creek','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(14127,'14650','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.162172,-77.621673,0,'2013-07-06 12:44:31',NULL,NULL),(26176,'28751','S','Maggie Valley','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.521141,-83.063129,0,'2013-07-06 12:44:31',NULL,NULL),(65022,'77316','S','Montgomery','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.321767,-95.685580,0,'2013-07-06 12:44:34',NULL,NULL),(66253,'78572','S','Perezville','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(70639,'85143','S','Queen Creek','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.161780,-111.550939,0,'2013-07-06 12:44:34',NULL,NULL),(79421,'98826','S','Chumstick','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(26226,'28802','P','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.498675,-82.538396,0,'2013-07-06 12:44:31',NULL,NULL),(18454,'19076','S','Prospect Park','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.885317,-75.306333,0,'2013-07-06 12:44:31',NULL,NULL),(76092,'95219','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.004042,-121.354917,0,'2013-07-06 12:44:34',NULL,NULL),(57507,'66955','S','Mahaska','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.958442,-97.312093,0,'2013-07-06 12:44:33',NULL,NULL),(55030,'63136','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(13125,'13491','S','Plainfield','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(34201,'38341','S','Holladay','D','Benton','47005','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.897318,-88.074904,0,'2013-07-06 12:44:32',NULL,NULL),(4968,'04108','S','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.663288,-70.190829,0,'2013-07-06 12:44:30',NULL,NULL),(55969,'64505','S','Country Club','A','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.791709,-94.841238,0,'2013-07-06 12:44:33',NULL,NULL),(27235,'29921','P','Furman','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.760287,-81.241951,0,'2013-07-06 12:44:31',NULL,NULL),(48402,'55590','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.279732,-93.808215,0,'2013-07-06 12:44:33',NULL,NULL),(43424,'48468','S','Port Hope','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.948198,-82.781696,0,'2013-07-06 12:44:32',NULL,NULL),(42325,'47629','P','Newburgh','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.956025,-87.401574,0,'2013-07-06 12:44:32',NULL,NULL),(13755,'14125','S','Oakfield','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.078642,-78.272493,0,'2013-07-06 12:44:31',NULL,NULL),(4848,'04013','S','Bustins Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.798612,-70.074648,0,'2013-07-06 12:44:30',NULL,NULL),(31611,'34685','S','Palm Harbor','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.104449,-82.680302,0,'2013-07-06 12:44:32',NULL,NULL),(12550,'13043','P','Lincoln','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.039802,-75.744094,0,'2013-07-06 12:44:30',NULL,NULL),(25373,'28253','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.323653,-80.782178,0,'2013-07-06 12:44:31',NULL,NULL),(78634,'98221','S','Anacortes','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.498900,-122.607300,0,'2013-07-06 12:44:34',NULL,NULL),(69691,'84028','S','Swan Creek','N','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.914447,-111.400556,0,'2013-07-06 12:44:34',NULL,NULL),(64944,'77227','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.736978,-95.447271,0,'2013-07-06 12:44:34',NULL,NULL),(12591,'13074','S','Fairdale','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.285920,-76.532580,0,'2013-07-06 12:44:30',NULL,NULL),(65137,'77385','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.185643,-95.428944,0,'2013-07-06 12:44:34',NULL,NULL),(62850,'75022','S','Flowermound','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.014444,-97.096667,0,'2013-07-06 12:44:33',NULL,NULL),(61468,'72631','S','Eureka Springs','D','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.400948,-93.736695,0,'2013-07-06 12:44:33',NULL,NULL),(27846,'30428','S','Glenwood','D','Wheeler','13309','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.111404,-82.665685,0,'2013-07-06 12:44:31',NULL,NULL),(40122,'45325','S','Germantown','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.698340,-84.417900,0,'2013-07-06 12:44:32',NULL,NULL),(57103,'66220','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.968891,-94.817860,0,'2013-07-06 12:44:33',NULL,NULL),(18631,'19153','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.887687,-75.233918,0,'2013-07-06 12:44:31',NULL,NULL),(25615,'28460','S','N Topsail Beach','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.531918,-77.387722,0,'2013-07-06 12:44:31',NULL,NULL),(30623,'33436','S','Vlg of Golf','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524205,-80.107257,0,'2013-07-06 12:44:32',NULL,NULL),(6759,'06091','S','West Hartland','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.952930,-72.935237,0,'2013-07-06 12:44:30',NULL,NULL),(29098,'32277','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.362941,-81.581889,0,'2013-07-06 12:44:32',NULL,NULL),(13373,'13736','S','Ketchumville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.313800,-76.190640,0,'2013-07-06 12:44:31',NULL,NULL),(59439,'70712','P','Angola','D','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.996727,-91.540468,0,'2013-07-06 12:44:33',NULL,NULL),(64102,'76177','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.972817,-97.333370,0,'2013-07-06 12:44:34',NULL,NULL),(76988,'96068','P','Nubieber','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.954132,-121.114759,0,'2013-07-06 12:44:34',NULL,NULL),(76222,'95374','S','Stevinson','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.330524,-120.872176,0,'2013-07-06 12:44:34',NULL,NULL),(72178,'88348','S','San Patricio','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.364897,-105.358603,0,'2013-07-06 12:44:34',NULL,NULL),(50243,'57625','S','Parade','A','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.994139,-101.237386,0,'2013-07-06 12:44:33',NULL,NULL),(76221,'95373','P','Standard','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.966620,-120.310800,0,'2013-07-06 12:44:34',NULL,NULL),(66824,'79094','S','Wayside','D','Armstrong','48011','Texas','TX','48','0000','806','Central',-6.0,'Y',34.812325,-101.541694,0,'2013-07-06 12:44:34',NULL,NULL),(40052,'45264','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.104370,-84.537870,0,'2013-07-06 12:44:32',NULL,NULL),(1616,'00769','S','Villa Santa Catalina','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(4039,'02576','S','W Wareham','N','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.772096,-70.760191,0,'2013-07-06 12:44:30',NULL,NULL),(67210,'79916','S','Fort Bliss','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.944107,-106.179974,0,'2013-07-06 12:44:34',NULL,NULL),(75395,'94002','S','Belmont','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.514450,-122.296118,0,'2013-07-06 12:44:34',NULL,NULL),(66875,'79226','S','Howardwick','A','Donley','48129','Texas','TX','48','0000','806','Central',-6.0,'Y',34.936209,-100.888972,0,'2013-07-06 12:44:34',NULL,NULL),(42525,'47857','P','Knightsville','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.575049,-87.056992,0,'2013-07-06 12:44:32',NULL,NULL),(69097,'83254','S','Montpelier','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(41491,'46945','P','Leiters Ford','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.121701,-86.384808,0,'2013-07-06 12:44:32',NULL,NULL),(30830,'33624','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.076141,-82.523628,0,'2013-07-06 12:44:32',NULL,NULL),(43865,'49120','S','Niles','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.821932,-86.258675,0,'2013-07-06 12:44:32',NULL,NULL),(76622,'95703','S','Applegate','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.981227,-120.987593,0,'2013-07-06 12:44:34',NULL,NULL),(65248,'77460','P','Nada','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.401396,-96.386737,0,'2013-07-06 12:44:34',NULL,NULL),(63712,'75925','S','Alto','D','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.642080,-95.087100,0,'2013-07-06 12:44:34',NULL,NULL),(56150,'64853','P','Newtonia','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.877158,-94.187271,0,'2013-07-06 12:44:33',NULL,NULL),(31120,'33901','S','FMY','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628428,-81.867580,0,'2013-07-06 12:44:32',NULL,NULL),(72674,'89441','S','Spanish Springs','A','Washoe','32031','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.345519,-119.648215,0,'2013-07-06 12:44:34',NULL,NULL),(6591,'05860','S','Evansville','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.807079,-72.201511,0,'2013-07-06 12:44:30',NULL,NULL),(18798,'19395','P','Westtown','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.934998,-75.545125,0,'2013-07-06 12:44:31',NULL,NULL),(7106,'06371','S','Lyme','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.328807,-72.309397,0,'2013-07-06 12:44:30',NULL,NULL),(60581,'71802','P','Hope','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.666096,-93.587333,0,'2013-07-06 12:44:33',NULL,NULL),(61902,'73142','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.606201,-97.641926,0,'2013-07-06 12:44:33',NULL,NULL),(64618,'76691','S','Tours','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.775460,-97.104060,0,'2013-07-06 12:44:34',NULL,NULL),(65411,'77571','S','Lomax','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.658283,-95.049187,0,'2013-07-06 12:44:34',NULL,NULL),(5810,'05069','S','South Ryegate','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.219220,-72.129600,0,'2013-07-06 12:44:30',NULL,NULL),(15799,'16925','S','Wells','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(1394,'00738','S','Urb Alhambra','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(74376,'92504','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.924842,-117.397533,0,'2013-07-06 12:44:34',NULL,NULL),(71069,'85901','S','Shumway','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.241520,-110.077320,0,'2013-07-06 12:44:34',NULL,NULL),(37358,'41722','S','Talcum','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(38110,'43103','S','South Bloomfield','A','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.726780,-82.952940,0,'2013-07-06 12:44:32',NULL,NULL),(35156,'39236','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364207,-90.145180,0,'2013-07-06 12:44:32',NULL,NULL),(1748,'00778','S','Valle de Ensueno','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(72949,'90039','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.107325,-118.260934,0,'2013-07-06 12:44:34',NULL,NULL),(33604,'37640','S','Butler','D','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.342296,-82.220268,0,'2013-07-06 12:44:32',NULL,NULL),(78875,'98353','P','Manchester','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.554483,-122.545778,0,'2013-07-06 12:44:34',NULL,NULL),(78014,'97415','S','Harbor','A','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.054175,-124.260145,0,'2013-07-06 12:44:34',NULL,NULL),(75424,'94028','S','Menlo Pk','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.379860,-122.208569,0,'2013-07-06 12:44:34',NULL,NULL),(54957,'63119','S','Webster Grvs','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.588549,-90.350542,0,'2013-07-06 12:44:33',NULL,NULL),(54543,'62885','S','Wilberton','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842965,-89.082598,0,'2013-07-06 12:44:33',NULL,NULL),(48826,'56037','S','Good Thunder','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.004561,-94.070275,0,'2013-07-06 12:44:33',NULL,NULL),(14216,'14786','P','West Clarksville','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.125215,-78.229883,0,'2013-07-06 12:44:31',NULL,NULL),(47704,'54983','S','Weyauwega','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.322182,-88.930339,0,'2013-07-06 12:44:33',NULL,NULL),(37314,'41647','S','Mc Dowell','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.427384,-82.743993,0,'2013-07-06 12:44:32',NULL,NULL),(11281,'11772','S','East Patchogue','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(6684,'06041','U','Jc Penney Co','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.774955,-72.521556,0,'2013-07-06 12:44:30',NULL,NULL),(51409,'59435','P','Ethridge','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.594725,-112.101698,0,'2013-07-06 12:44:33',NULL,NULL),(12404,'12930','S','East Dickinson','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.779444,-74.498056,0,'2013-07-06 12:44:30',NULL,NULL),(52938,'61377','S','Wenona','D','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.051074,-89.052018,0,'2013-07-06 12:44:33',NULL,NULL),(22350,'23887','S','Valentines','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.560643,-77.826284,0,'2013-07-06 12:44:31',NULL,NULL),(28661,'31781','S','Poulan','D','Worth','13321','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.514345,-83.790800,0,'2013-07-06 12:44:32',NULL,NULL),(25076,'27947','S','Jarvisburg','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.175507,-75.852327,0,'2013-07-06 12:44:31',NULL,NULL),(9903,'10131','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.785617,-73.949816,0,'2013-07-06 12:44:30',NULL,NULL),(48747,'55971','S','Rushford Village','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(27985,'30573','P','Tallulah Fls','A','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.726029,-83.382319,0,'2013-07-06 12:44:31',NULL,NULL),(16342,'17129','S','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263185,-76.882694,0,'2013-07-06 12:44:31',NULL,NULL),(46653,'53703','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.079239,-89.377220,0,'2013-07-06 12:44:32',NULL,NULL),(17812,'18407','S','Greenfild Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(33992,'38116','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.036558,-90.009010,0,'2013-07-06 12:44:32',NULL,NULL),(54247,'62670','S','Berlin','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.734757,-89.908806,0,'2013-07-06 12:44:33',NULL,NULL),(73236,'90660','S','Pico Rivera','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.988063,-118.088143,0,'2013-07-06 12:44:34',NULL,NULL),(79270,'98570','S','Onalaska','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.581895,-122.686352,0,'2013-07-06 12:44:34',NULL,NULL),(47500,'54761','S','Plum City','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.633891,-92.192436,0,'2013-07-06 12:44:32',NULL,NULL),(24660,'27406','S','Forest Oaks','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.021374,-79.767916,0,'2013-07-06 12:44:31',NULL,NULL),(69740,'84045','S','Saratoga Spgs','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.345179,-111.911529,0,'2013-07-06 12:44:34',NULL,NULL),(49823,'57217','S','Crocker','A','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.903080,-97.707295,0,'2013-07-06 12:44:33',NULL,NULL),(7006,'06256','S','North Windham','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.751840,-72.142800,0,'2013-07-06 12:44:30',NULL,NULL),(26197,'28771','S','Tapoco','A','Graham','37075','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.346072,-83.874306,0,'2013-07-06 12:44:31',NULL,NULL),(67559,'80281','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.744220,-104.988910,0,'2013-07-06 12:44:34',NULL,NULL),(79665,'99157','S','Northport','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.925012,-117.788482,0,'2013-07-06 12:44:34',NULL,NULL),(75057,'93523','S','Edwards','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.950022,-117.901246,0,'2013-07-06 12:44:34',NULL,NULL),(70743,'85310','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.702625,-112.161285,0,'2013-07-06 12:44:34',NULL,NULL),(63731,'75933','S','Trout Creek','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.517146,-93.809106,0,'2013-07-06 12:44:34',NULL,NULL),(56134,'64836','S','Kendricktown','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(52854,'61325','S','Grand Ridge','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.229420,-88.790820,0,'2013-07-06 12:44:33',NULL,NULL),(8364,'08052','S','Maple Shade','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.954582,-74.996843,0,'2013-07-06 12:44:30',NULL,NULL),(11302,'11777','S','Prt Jefferson','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(3525,'01889','U','North Reading','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.572012,-71.111231,0,'2013-07-06 12:44:30',NULL,NULL),(34221,'38363','S','Parsons','D','Decatur','47039','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.644216,-88.126023,0,'2013-07-06 12:44:32',NULL,NULL),(27362,'30064','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.939798,-84.614184,0,'2013-07-06 12:44:31',NULL,NULL),(46527,'53293','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.042193,-87.920190,0,'2013-07-06 12:44:32',NULL,NULL),(19997,'20604','P','Saint Charles','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.617973,-76.892084,0,'2013-07-06 12:44:31',NULL,NULL),(61298,'72419','S','Caraway','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.757685,-90.320635,0,'2013-07-06 12:44:33',NULL,NULL),(45548,'51461','S','Schleswig','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.163264,-95.435436,0,'2013-07-06 12:44:32',NULL,NULL),(62196,'73801','S','Woodward','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.432094,-99.399622,0,'2013-07-06 12:44:33',NULL,NULL),(60138,'71373','S','Morville','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(16365,'17201','S','Jackson Hall','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(12801,'13235','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048750,-76.148002,0,'2013-07-06 12:44:30',NULL,NULL),(19037,'19539','S','Longswamp','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(21773,'23062','S','Gloucester Pt','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.256502,-76.493791,0,'2013-07-06 12:44:31',NULL,NULL),(39049,'44191','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.484680,-81.702744,0,'2013-07-06 12:44:32',NULL,NULL),(44156,'49528','P','Kentwood Brch','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881100,-85.623900,0,'2013-07-06 12:44:32',NULL,NULL),(77017,'96092','P','Vina','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',39.937714,-122.011977,0,'2013-07-06 12:44:34',NULL,NULL),(54243,'62667','S','Scottville','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.478096,-89.981342,0,'2013-07-06 12:44:33',NULL,NULL),(10252,'10472','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.830485,-73.870026,0,'2013-07-06 12:44:30',NULL,NULL),(44269,'49701','S','Mackinac City','N','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.777537,-84.754096,0,'2013-07-06 12:44:32',NULL,NULL),(80020,'99682','P','Tyonek','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.060490,-151.200750,0,'2013-07-06 12:44:34',NULL,NULL),(60364,'71473','S','Sikes','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.067300,-92.422500,0,'2013-07-06 12:44:33',NULL,NULL),(27762,'30362','P','Doraville','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.900867,-84.276425,0,'2013-07-06 12:44:31',NULL,NULL),(22272,'23701','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.809491,-76.367984,0,'2013-07-06 12:44:31',NULL,NULL),(35613,'39601','S','Redstar','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(70949,'85643','S','Dos Cabezas','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(59959,'71303','S','Roxana','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(57208,'66434','S','Reserve','A','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.854303,-95.534279,0,'2013-07-06 12:44:33',NULL,NULL),(33045,'36751','S','Chance','N','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.848577,-87.569570,0,'2013-07-06 12:44:32',NULL,NULL),(70244,'84407','U','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.243163,-111.967258,0,'2013-07-06 12:44:34',NULL,NULL),(66023,'78361','S','Escobas','N','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',27.283639,-98.691312,0,'2013-07-06 12:44:34',NULL,NULL),(64604,'76684','P','Ross','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.669367,-97.100626,0,'2013-07-06 12:44:34',NULL,NULL),(4055,'02642','S','Eastham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.823045,-69.988451,0,'2013-07-06 12:44:30',NULL,NULL),(32364,'35895','U','Huntsville Utilities','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.731405,-86.589774,0,'2013-07-06 12:44:32',NULL,NULL),(15507,'16510','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.140278,-80.015278,0,'2013-07-06 12:44:31',NULL,NULL),(47625,'54911','S','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.275220,-88.395755,0,'2013-07-06 12:44:33',NULL,NULL),(44444,'49862','S','Forest Lake','N','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.416420,-86.623980,0,'2013-07-06 12:44:32',NULL,NULL),(22015,'23288','U','Koger Executive Ctr','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.601923,-77.546947,0,'2013-07-06 12:44:31',NULL,NULL),(28024,'30631','S','Crawfordville','D','Taliaferro','13265','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.550580,-82.895523,0,'2013-07-06 12:44:31',NULL,NULL),(31416,'34241','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.283889,-82.409597,0,'2013-07-06 12:44:32',NULL,NULL),(47752,'55021','S','Faribault','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.294178,-93.276667,0,'2013-07-06 12:44:33',NULL,NULL),(49635,'56944','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(7889,'07533','P','South Paterson','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.897871,-74.154273,0,'2013-07-06 12:44:30',NULL,NULL),(41722,'47243','S','Hanover Beach','N','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.714687,-85.472195,0,'2013-07-06 12:44:32',NULL,NULL),(76241,'95389','S','Yosemite National Park','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(72974,'90048','S','Briggs','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.073253,-118.377034,0,'2013-07-06 12:44:34',NULL,NULL),(14816,'15421','P','Chalk Hill','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.843749,-79.616111,0,'2013-07-06 12:44:31',NULL,NULL),(17886,'18444','S','Madison Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(22054,'23322','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.579718,-76.307527,0,'2013-07-06 12:44:31',NULL,NULL),(34083,'38152','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.120123,-89.939705,0,'2013-07-06 12:44:32',NULL,NULL),(4253,'02879','S','Green Hill','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(8434,'08080','S','Hurffville','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.749340,-75.096660,0,'2013-07-06 12:44:30',NULL,NULL),(65700,'78009','S','Castroville','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.348707,-98.887254,0,'2013-07-06 12:44:34',NULL,NULL),(41136,'46634','P','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.692367,-86.238939,0,'2013-07-06 12:44:32',NULL,NULL),(61945,'73163','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.472000,-97.520348,0,'2013-07-06 12:44:33',NULL,NULL),(59143,'70174','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926628,-90.017422,0,'2013-07-06 12:44:33',NULL,NULL),(42220,'47558','S','Montgomery','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.623171,-87.044863,0,'2013-07-06 12:44:32',NULL,NULL),(12719,'13153','P','Skaneateles Falls','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.994912,-76.452863,0,'2013-07-06 12:44:30',NULL,NULL),(48761,'55977','S','Taopi','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.542226,-92.628717,0,'2013-07-06 12:44:33',NULL,NULL),(28970,'32207','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.292512,-81.629247,0,'2013-07-06 12:44:32',NULL,NULL),(31168,'33918','P','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(65449,'77598','S','Fondren','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.540073,-95.142762,0,'2013-07-06 12:44:34',NULL,NULL),(61106,'72142','S','Hamiter','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.776533,-92.063990,0,'2013-07-06 12:44:33',NULL,NULL),(53056,'61489','S','Williamsfield','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.887171,-89.974114,0,'2013-07-06 12:44:33',NULL,NULL),(10645,'11101','S','Long Island City','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.748470,-73.939180,0,'2013-07-06 12:44:30',NULL,NULL),(73909,'92013','P','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.161398,-117.349689,0,'2013-07-06 12:44:34',NULL,NULL),(47274,'54534','S','Kimball','N','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.481944,-90.305833,0,'2013-07-06 12:44:32',NULL,NULL),(62365,'74070','S','Skiatook','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.360002,-95.983740,0,'2013-07-06 12:44:33',NULL,NULL),(57844,'67556','S','Mc Cracken','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.585369,-99.573435,0,'2013-07-06 12:44:33',NULL,NULL),(10960,'11510','S','Baldwin','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655358,-73.607376,0,'2013-07-06 12:44:30',NULL,NULL),(13844,'14223','S','Tonawanda','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(3574,'01965','P','Prides Crssng','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.561561,-70.833711,0,'2013-07-06 12:44:30',NULL,NULL),(41025,'46382','S','Wellsboro','N','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.476020,-86.779080,0,'2013-07-06 12:44:32',NULL,NULL),(5448,'04694','S','Woodland Washington County','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.154958,-67.407874,0,'2013-07-06 12:44:30',NULL,NULL),(37903,'42633','S','Coopersville','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(15381,'16316','S','Conneaut Lake Park','N','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.622180,-80.309520,0,'2013-07-06 12:44:31',NULL,NULL),(15793,'16925','S','Bentley Creek','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(41334,'46780','P','Pleasant Mls','A','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.774016,-84.841633,0,'2013-07-06 12:44:32',NULL,NULL),(13102,'13479','P','Washingtn Mls','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.056604,-75.273986,0,'2013-07-06 12:44:30',NULL,NULL),(30039,'33141','S','North Bay Village','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(55655,'64024','S','Excelsior Spg','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(57820,'67523','S','Burdett','D','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.262009,-99.519236,0,'2013-07-06 12:44:33',NULL,NULL),(60817,'72032','S','Gold Lake Estates','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(13812,'14212','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.862020,-78.818580,0,'2013-07-06 12:44:31',NULL,NULL),(50637,'58282','S','Leroy','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.916140,-97.891560,0,'2013-07-06 12:44:33',NULL,NULL),(50914,'58559','S','Mercer','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.459618,-100.736951,0,'2013-07-06 12:44:33',NULL,NULL),(22348,'23884','P','Sussex','D','Sussex','51183','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.916270,-77.279713,0,'2013-07-06 12:44:31',NULL,NULL),(50768,'58421','S','Melville','A','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(15027,'15686','S','Spring Church','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.622281,-79.446624,0,'2013-07-06 12:44:31',NULL,NULL),(67222,'79926','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.723605,-106.296182,0,'2013-07-06 12:44:34',NULL,NULL),(57151,'66251','U','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(24905,'27712','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.086887,-78.923696,0,'2013-07-06 12:44:31',NULL,NULL),(49960,'57349','S','Roswell','A','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.014323,-97.529484,0,'2013-07-06 12:44:33',NULL,NULL),(26366,'29072','S','Macedon','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.979860,-81.260520,0,'2013-07-06 12:44:31',NULL,NULL),(74914,'93383','P','Pumpkin Ctr','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.264987,-119.031953,0,'2013-07-06 12:44:34',NULL,NULL),(74299,'92373','S','Smiley Heights','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.050061,-117.169355,0,'2013-07-06 12:44:34',NULL,NULL),(18424,'19061','S','Trainer','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(23837,'26120','U','Mineral Wells','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.168661,-81.490206,0,'2013-07-06 12:44:31',NULL,NULL),(73584,'91383','S','Santa Clarita','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.358853,-118.455629,0,'2013-07-06 12:44:34',NULL,NULL),(54523,'62878','S','Keith','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.583362,-88.476223,0,'2013-07-06 12:44:33',NULL,NULL),(53434,'61864','S','Philo','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.004891,-88.156932,0,'2013-07-06 12:44:33',NULL,NULL),(52698,'61107','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.280904,-89.027308,0,'2013-07-06 12:44:33',NULL,NULL),(46757,'53934','S','Friendship','D','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.976790,-89.838601,0,'2013-07-06 12:44:32',NULL,NULL),(65610,'77950','P','Austwell','D','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.395158,-96.973139,0,'2013-07-06 12:44:34',NULL,NULL),(4342,'03040','P','East Candia','D','Rockingham','33015','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.045480,-71.247063,0,'2013-07-06 12:44:30',NULL,NULL),(38272,'43318','S','De Graff','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.329651,-83.914601,0,'2013-07-06 12:44:32',NULL,NULL),(136,'00617','S','Bda Catalana','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(41643,'47134','U','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285868,-85.732024,0,'2013-07-06 12:44:32',NULL,NULL),(57384,'66753','S','McCune','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.352484,-95.021069,0,'2013-07-06 12:44:33',NULL,NULL),(36805,'41056','S','Country Club Heights','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(12548,'13042','S','Cleveland','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.233646,-75.881359,0,'2013-07-06 12:44:30',NULL,NULL),(78344,'98006','S','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.564251,-122.150636,0,'2013-07-06 12:44:34',NULL,NULL),(76261,'95415','S','Boonville','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.004096,-123.358036,0,'2013-07-06 12:44:34',NULL,NULL),(72464,'89121','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.104510,-115.067710,0,'2013-07-06 12:44:34',NULL,NULL),(80202,'99929','P','Wrangell','D','Wrangell','02275','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.467688,-132.384597,0,'2013-07-06 12:44:34',NULL,NULL),(22080,'23359','S','Hallwood','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.846582,-75.549931,0,'2013-07-06 12:44:31',NULL,NULL),(53179,'61604','S','El Vista','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(63827,'75973','S','East Hamilton','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(17276,'17844','S','Whitesprings','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(61519,'72658','S','Old Joe','A','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.208500,-92.266680,0,'2013-07-06 12:44:33',NULL,NULL),(31835,'35079','S','Blount Springs','N','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.884716,-86.806982,0,'2013-07-06 12:44:32',NULL,NULL),(74177,'92274','S','Valerie','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(76286,'95428','S','Covelo','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.795628,-123.247811,0,'2013-07-06 12:44:34',NULL,NULL),(79682,'99174','P','Steptoe','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.007933,-117.352546,0,'2013-07-06 12:44:34',NULL,NULL),(39993,'45242','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.245232,-84.353209,0,'2013-07-06 12:44:32',NULL,NULL),(12815,'13302','S','Howardville','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(13047,'13440','S','Camroden','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(47830,'55070','S','Saint Francis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.394713,-93.363178,0,'2013-07-06 12:44:33',NULL,NULL),(74517,'92649','S','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.717977,-118.050451,0,'2013-07-06 12:44:34',NULL,NULL),(72891,'90017','S','Foy','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.053387,-118.265378,0,'2013-07-06 12:44:34',NULL,NULL),(61904,'73143','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.435074,-97.526700,0,'2013-07-06 12:44:33',NULL,NULL),(8994,'08844','S','Hillsborough','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.479008,-74.628315,0,'2013-07-06 12:44:30',NULL,NULL),(51336,'59276','S','Whitetail','D','Daniels','30019','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.899360,-105.162911,0,'2013-07-06 12:44:33',NULL,NULL),(61168,'72190','P','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.798097,-92.256024,0,'2013-07-06 12:44:33',NULL,NULL),(29256,'32449','S','Wewahitchka','D','Calhoun','12013','Florida','FL','12','0000','850','Central',-6.0,'Y',30.270733,-85.198121,0,'2013-07-06 12:44:32',NULL,NULL),(25924,'28651','S','Millers Creek','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.270637,-81.284124,0,'2013-07-06 12:44:31',NULL,NULL),(24160,'26590','S','Wana','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.705862,-80.314650,0,'2013-07-06 12:44:31',NULL,NULL),(24606,'27330','S','Pine View','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(27783,'30377','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.793048,-84.450115,0,'2013-07-06 12:44:31',NULL,NULL),(38628,'43920','S','Calcutta','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.671120,-80.583060,0,'2013-07-06 12:44:32',NULL,NULL),(50676,'58343','S','Knox','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.327756,-99.654741,0,'2013-07-06 12:44:33',NULL,NULL),(80160,'99811','S','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.475026,-134.157680,0,'2013-07-06 12:44:34',NULL,NULL),(56207,'65026','S','Etterville','A','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(14640,'15234','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(21766,'23061','S','Bellamy','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.435603,-76.547405,0,'2013-07-06 12:44:31',NULL,NULL),(45,'00603','S','Villas de Almeria','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(78272,'97861','S','Arlington','A','Gilliam','41021','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.716832,-120.199034,0,'2013-07-06 12:44:34',NULL,NULL),(71502,'87109','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.156553,-106.565192,0,'2013-07-06 12:44:34',NULL,NULL),(24456,'27217','S','Green Level','A','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.127359,-79.415724,0,'2013-07-06 12:44:31',NULL,NULL),(9503,'10014','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(63131,'75354','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.863850,-96.886097,0,'2013-07-06 12:44:33',NULL,NULL),(23338,'25248','S','Kenna','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.655556,-81.590556,0,'2013-07-06 12:44:31',NULL,NULL),(18522,'19106','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951659,-75.144608,0,'2013-07-06 12:44:31',NULL,NULL),(57559,'67042','S','El Dorado','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.821764,-96.865086,0,'2013-07-06 12:44:33',NULL,NULL),(52906,'61362','S','Spring Valley','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.329992,-89.220913,0,'2013-07-06 12:44:33',NULL,NULL),(4881,'04038','S','Gorham','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.698538,-70.456236,0,'2013-07-06 12:44:30',NULL,NULL),(1051,'00723','S','Valle De La Providencia','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(14913,'15537','S','Everett','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.013698,-78.370151,0,'2013-07-06 12:44:31',NULL,NULL),(73590,'91386','P','Canyon Cntry','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.417490,-118.449656,0,'2013-07-06 12:44:34',NULL,NULL),(16351,'17177','U','Capital Blue Cross','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.290362,-76.812588,0,'2013-07-06 12:44:31',NULL,NULL),(4204,'02830','S','Harrisville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.976597,-71.656277,0,'2013-07-06 12:44:30',NULL,NULL),(46765,'53943','S','Loganville','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.438436,-90.039120,0,'2013-07-06 12:44:32',NULL,NULL),(38289,'43336','P','Middleburg','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.293906,-83.584083,0,'2013-07-06 12:44:32',NULL,NULL),(31584,'34654','S','New Pt Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.300248,-82.634053,0,'2013-07-06 12:44:32',NULL,NULL),(64771,'76957','S','Wall','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.315220,-100.334746,0,'2013-07-06 12:44:34',NULL,NULL),(73416,'91185','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.169701,-117.981386,0,'2013-07-06 12:44:34',NULL,NULL),(73029,'90073','P','Veterans Admin','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.052501,-118.455227,0,'2013-07-06 12:44:34',NULL,NULL),(55236,'63439','S','Emden','D','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.860243,-91.889631,0,'2013-07-06 12:44:33',NULL,NULL),(2505,'00957','S','Parc Van Scoy','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(25018,'27885','S','Swanquarter','D','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.406270,-76.277705,0,'2013-07-06 12:44:31',NULL,NULL),(637,'00682','S','Urb Guanajibo Homes','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(2441,'00953','S','Urb Palacios De Versalles','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(74347,'92407','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(65420,'77575','S','Moss Bluff','N','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.067839,-94.789652,0,'2013-07-06 12:44:34',NULL,NULL),(57913,'67660','P','Pfeifer','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.731742,-99.145308,0,'2013-07-06 12:44:33',NULL,NULL),(4190,'02822','S','Exeter','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.555618,-71.626724,0,'2013-07-06 12:44:30',NULL,NULL),(15062,'15729','S','Commodore','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.697107,-78.898421,0,'2013-07-06 12:44:31',NULL,NULL),(55295,'63530','S','Barnesville','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.928400,-92.451724,0,'2013-07-06 12:44:33',NULL,NULL),(22068,'23337','S','Wallops Island','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.862571,-75.462907,0,'2013-07-06 12:44:31',NULL,NULL),(50925,'58564','S','Saint Gertrude','N','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.337217,-101.260167,0,'2013-07-06 12:44:33',NULL,NULL),(44472,'49892','S','Vulcan','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.783077,-87.869923,0,'2013-07-06 12:44:32',NULL,NULL),(12222,'12809','S','North Argyle','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.236780,-73.456980,0,'2013-07-06 12:44:30',NULL,NULL),(34707,'38833','S','Holts','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.890120,-88.309221,0,'2013-07-06 12:44:32',NULL,NULL),(59519,'70792','P','Uncle Sam','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.023483,-90.777906,0,'2013-07-06 12:44:33',NULL,NULL),(33762,'37861','S','Rutledge','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.277770,-83.517316,0,'2013-07-06 12:44:32',NULL,NULL),(62082,'73561','S','Oscar','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.959973,-97.761343,0,'2013-07-06 12:44:33',NULL,NULL),(29120,'32313','U','Florida State','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430000,-84.280000,0,'2013-07-06 12:44:32',NULL,NULL),(39286,'44486','U','Packard Elec Co Div Gm','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.300597,-80.844183,0,'2013-07-06 12:44:32',NULL,NULL),(37412,'41777','S','Big Rock','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.046606,-83.220511,0,'2013-07-06 12:44:32',NULL,NULL),(33327,'37146','S','Pleasant View','D','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.384642,-87.035393,0,'2013-07-06 12:44:32',NULL,NULL),(33273,'37101','S','Mc Ewen','D','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.138332,-87.657349,0,'2013-07-06 12:44:32',NULL,NULL),(30371,'33317','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.093836,-80.239494,0,'2013-07-06 12:44:32',NULL,NULL),(61781,'73070','P','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.222428,-97.368391,0,'2013-07-06 12:44:33',NULL,NULL),(77075,'96128','S','Standish','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.353727,-120.429652,0,'2013-07-06 12:44:34',NULL,NULL),(29845,'33034','S','Flamingo Lodge','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.450256,-80.489973,0,'2013-07-06 12:44:32',NULL,NULL),(24572,'27312','S','Fearrington Village','A','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.765336,-79.136415,0,'2013-07-06 12:44:31',NULL,NULL),(71259,'86409','S','Kingman','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.244500,-114.016400,0,'2013-07-06 12:44:34',NULL,NULL),(65080,'77351','S','Segno','A','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.577170,-94.686210,0,'2013-07-06 12:44:34',NULL,NULL),(23945,'26270','S','Harman','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.914157,-79.531579,0,'2013-07-06 12:44:31',NULL,NULL),(30796,'33606','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.936563,-82.465286,0,'2013-07-06 12:44:32',NULL,NULL),(4755,'03847','P','Kearsarge','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.072782,-71.133007,0,'2013-07-06 12:44:30',NULL,NULL),(28290,'31095','P','Warner Robins','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.619635,-83.599433,0,'2013-07-06 12:44:31',NULL,NULL),(74307,'92382','P','Running Spgs','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.206744,-117.104968,0,'2013-07-06 12:44:34',NULL,NULL),(70731,'85302','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.568348,-112.178491,0,'2013-07-06 12:44:34',NULL,NULL),(8245,'08004','S','West Atco','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.776340,-74.870640,0,'2013-07-06 12:44:30',NULL,NULL),(12846,'13316','S','Osceola','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.354631,-75.746699,0,'2013-07-06 12:44:30',NULL,NULL),(51839,'60068','S','Park Ridge','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',41.971118,-87.829399,0,'2013-07-06 12:44:33',NULL,NULL),(51925,'60118','S','East Dundee','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.110280,-88.296540,0,'2013-07-06 12:44:33',NULL,NULL),(52275,'60525','S','Mc Cook','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(53910,'62370','S','Atlas','N','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.535316,-91.017575,0,'2013-07-06 12:44:33',NULL,NULL),(62993,'75153','S','Powell','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.207237,-96.359440,0,'2013-07-06 12:44:33',NULL,NULL),(71223,'86327','S','Dewey','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.553959,-112.267851,0,'2013-07-06 12:44:34',NULL,NULL),(36102,'40220','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(43905,'49250','S','Jonesville','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.009584,-84.630051,0,'2013-07-06 12:44:32',NULL,NULL),(11532,'12043','S','Hyndsville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(68332,'81121','P','Arboles','D','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.026700,-107.483555,0,'2013-07-06 12:44:34',NULL,NULL),(13075,'13456','S','Paris','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.000560,-75.269760,0,'2013-07-06 12:44:30',NULL,NULL),(34024,'38130','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.032451,-89.938116,0,'2013-07-06 12:44:32',NULL,NULL),(50504,'58067','S','Rutland','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.054802,-97.502278,0,'2013-07-06 12:44:33',NULL,NULL),(65859,'78209','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.484722,-98.465556,0,'2013-07-06 12:44:34',NULL,NULL),(56600,'65560','S','Maples','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(34269,'38464','S','Lawrenceburg','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.246888,-87.327981,0,'2013-07-06 12:44:32',NULL,NULL),(47959,'55120','S','Mendota Heights','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.873820,-93.140700,0,'2013-07-06 12:44:33',NULL,NULL),(39783,'45130','S','Hamersville','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.910678,-83.984564,0,'2013-07-06 12:44:32',NULL,NULL),(44633,'50067','S','Decatur City','N','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.768448,-93.842967,0,'2013-07-06 12:44:32',NULL,NULL),(39623,'44888','U','R R Donnelly','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.056760,-82.721898,0,'2013-07-06 12:44:32',NULL,NULL),(12804,'13244','U','Syracuse University','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.041575,-76.133784,0,'2013-07-06 12:44:30',NULL,NULL),(13309,'13672','S','Parishville','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.601041,-74.809679,0,'2013-07-06 12:44:30',NULL,NULL),(58262,'68377','S','Harbine','N','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.201560,-97.026840,0,'2013-07-06 12:44:33',NULL,NULL),(45909,'52321','S','Onslow','D','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.127198,-90.958707,0,'2013-07-06 12:44:32',NULL,NULL),(73168,'90304','S','Lennox','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.935693,-118.355284,0,'2013-07-06 12:44:34',NULL,NULL),(18453,'19075','S','Oreland','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.112781,-75.185143,0,'2013-07-06 12:44:31',NULL,NULL),(73040,'90079','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038986,-118.256235,0,'2013-07-06 12:44:34',NULL,NULL),(70440,'84741','S','Canyon Point','A','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.051804,-112.533746,0,'2013-07-06 12:44:34',NULL,NULL),(57093,'66218','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.014399,-94.817167,0,'2013-07-06 12:44:33',NULL,NULL),(1180,'00727','S','Villa Caliz','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(18825,'19409','P','Norristown','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.121389,-75.340278,0,'2013-07-06 12:44:31',NULL,NULL),(35936,'40050','S','New Castle','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.436132,-85.171917,0,'2013-07-06 12:44:32',NULL,NULL),(17807,'18407','S','Carbondale','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(56182,'65013','S','Lanes Prairie','N','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(20497,'21062','U','Md Motor Vehicle Admin','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.163696,-76.603579,0,'2013-07-06 12:44:31',NULL,NULL),(34264,'38460','S','Goodspring','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.126635,-87.143747,0,'2013-07-06 12:44:32',NULL,NULL),(6235,'05491','S','Panton','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(34657,'38778','S','Dwyer','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.550255,-90.529915,0,'2013-07-06 12:44:32',NULL,NULL),(66425,'78640','S','Niederwald','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.006600,-97.807140,0,'2013-07-06 12:44:34',NULL,NULL),(46329,'53083','S','Haven','A','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.802340,-87.769800,0,'2013-07-06 12:44:32',NULL,NULL),(31548,'34606','S','Brooksville','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.466311,-82.596769,0,'2013-07-06 12:44:32',NULL,NULL),(51203,'59036','P','Harlowton','D','Wheatland','30107','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.436792,-109.831908,0,'2013-07-06 12:44:33',NULL,NULL),(13550,'13830','S','Tyner','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(4478,'03266','S','Rumney','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.787467,-71.855141,0,'2013-07-06 12:44:30',NULL,NULL),(59115,'70148','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.029172,-90.068447,0,'2013-07-06 12:44:33',NULL,NULL),(70885,'85614','S','Green Valley','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.859137,-111.000231,0,'2013-07-06 12:44:34',NULL,NULL),(51310,'59240','S','Glentana','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.848625,-106.248421,0,'2013-07-06 12:44:33',NULL,NULL),(6052,'05442','S','Belvidere Center','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.772686,-72.663680,0,'2013-07-06 12:44:30',NULL,NULL),(24777,'27562','S','New Hill','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.697919,-78.934428,0,'2013-07-06 12:44:31',NULL,NULL),(36624,'40997','S','Walker','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.890985,-83.668090,0,'2013-07-06 12:44:32',NULL,NULL),(66484,'78666','S','San Marcos','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.882645,-97.945088,0,'2013-07-06 12:44:34',NULL,NULL),(66556,'78735','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.264300,-97.865340,0,'2013-07-06 12:44:34',NULL,NULL),(25081,'27949','S','Kitty Hawk','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.133440,-75.725400,0,'2013-07-06 12:44:31',NULL,NULL),(75808,'94804','S','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.924560,-122.335196,0,'2013-07-06 12:44:34',NULL,NULL),(68711,'82070','S','Foxpark','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.297825,-105.635487,0,'2013-07-06 12:44:34',NULL,NULL),(64849,'77046','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.737380,-95.393776,0,'2013-07-06 12:44:34',NULL,NULL),(56780,'65747','S','Viola','N','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.617100,-93.627780,0,'2013-07-06 12:44:33',NULL,NULL),(31582,'34654','S','New Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.300248,-82.634053,0,'2013-07-06 12:44:32',NULL,NULL),(19290,'19971','S','Rehoboth','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.726540,-75.081250,0,'2013-07-06 12:44:31',NULL,NULL),(18895,'19472','P','Sassamansvlle','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.339201,-75.573370,0,'2013-07-06 12:44:31',NULL,NULL),(57893,'67640','S','Gorham','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.879983,-99.018706,0,'2013-07-06 12:44:33',NULL,NULL),(45654,'52001','S','Rockdale','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(65633,'77964','S','Ezzell','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(63911,'76040','S','Euless','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.828032,-97.104702,0,'2013-07-06 12:44:34',NULL,NULL),(55877,'64198','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.101834,-94.582276,0,'2013-07-06 12:44:33',NULL,NULL),(16115,'17055','S','Navy Ships','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(7637,'07067','S','Colonia','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.593643,-74.315267,0,'2013-07-06 12:44:30',NULL,NULL),(17182,'17815','S','Rupert','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(3080,'01151','S','Springfield','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.151001,-72.506454,0,'2013-07-06 12:44:30',NULL,NULL),(8008,'07721','S','Cliffwood','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.433787,-74.225814,0,'2013-07-06 12:44:30',NULL,NULL),(26272,'29010','S','Wisacky','A','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(74124,'92239','P','Eagle Mountain','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.712500,-115.401389,0,'2013-07-06 12:44:34',NULL,NULL),(69964,'84119','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(56315,'65102','P','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.579476,-92.170918,0,'2013-07-06 12:44:33',NULL,NULL),(42509,'47847','S','Quaker','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.807913,-87.490923,0,'2013-07-06 12:44:32',NULL,NULL),(48917,'56142','S','Ivanhoe','D','Lincoln','27081','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.462473,-96.244829,0,'2013-07-06 12:44:33',NULL,NULL),(76876,'95974','P','Richvale','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.494588,-121.749311,0,'2013-07-06 12:44:34',NULL,NULL),(68123,'80951','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837139,-104.795539,0,'2013-07-06 12:44:34',NULL,NULL),(18269,'19008','S','Broomall','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.975572,-75.360537,0,'2013-07-06 12:44:31',NULL,NULL),(43342,'48377','S','Novi','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.506757,-83.475536,0,'2013-07-06 12:44:32',NULL,NULL),(6714,'06066','S','Vernon-Rockville','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(3444,'01760','S','No Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(17566,'18001','P','Lehigh Valley','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.580333,-75.474981,0,'2013-07-06 12:44:31',NULL,NULL),(9597,'10030','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(56612,'65570','S','Success','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.484447,-92.009869,0,'2013-07-06 12:44:33',NULL,NULL),(50742,'58401','S','Jamestown','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(19326,'20024','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879013,-77.020737,0,'2013-07-06 12:44:31',NULL,NULL),(45555,'51501','S','Council Blfs','A','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.254887,-95.852753,0,'2013-07-06 12:44:32',NULL,NULL),(61314,'72436','S','Lafe','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.210000,-90.512220,0,'2013-07-06 12:44:33',NULL,NULL),(57874,'67584','S','Utica','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.643687,-100.174726,0,'2013-07-06 12:44:33',NULL,NULL),(33641,'37691','S','Trade','D','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.370684,-81.754167,0,'2013-07-06 12:44:32',NULL,NULL),(68476,'81244','P','Rockvale','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.367179,-105.165393,0,'2013-07-06 12:44:34',NULL,NULL),(65573,'77856','S','Ridge','A','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',31.029518,-96.485340,0,'2013-07-06 12:44:34',NULL,NULL),(46400,'53159','P','Powers Lake','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.553163,-88.293993,0,'2013-07-06 12:44:32',NULL,NULL),(19291,'19971','S','Rehoboth Bch','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.726540,-75.081250,0,'2013-07-06 12:44:31',NULL,NULL),(6058,'05443','S','Lincoln','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(66099,'78408','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.797109,-97.435885,0,'2013-07-06 12:44:34',NULL,NULL),(59876,'71269','S','Alto','A','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(59460,'70733','S','French Settlement','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.311150,-90.799661,0,'2013-07-06 12:44:33',NULL,NULL),(18212,'18953','P','Revere','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.514298,-75.160151,0,'2013-07-06 12:44:31',NULL,NULL),(24737,'27525','S','Franklinton','D','Franklin','37069','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.096252,-78.452456,0,'2013-07-06 12:44:31',NULL,NULL),(22419,'24003','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.273466,-79.942101,0,'2013-07-06 12:44:31',NULL,NULL),(2191,'00926','S','Paseo Alto','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(48565,'55767','S','Moose Lake','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.452701,-92.769759,0,'2013-07-06 12:44:33',NULL,NULL),(34402,'38626','S','Dubbs','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.534380,-90.396000,0,'2013-07-06 12:44:32',NULL,NULL),(39629,'44890','S','Celeryville','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(63285,'75558','S','Argo','N','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.186780,-94.868280,0,'2013-07-06 12:44:33',NULL,NULL),(65853,'78204','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.396742,-98.499996,0,'2013-07-06 12:44:34',NULL,NULL),(66834,'79106','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.212981,-101.901659,0,'2013-07-06 12:44:34',NULL,NULL),(50730,'58384','S','Barton','A','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617340,-100.299168,0,'2013-07-06 12:44:33',NULL,NULL),(25455,'28327','S','Whispering Pines','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.341320,-79.362480,0,'2013-07-06 12:44:31',NULL,NULL),(10108,'10256','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706232,-74.010903,0,'2013-07-06 12:44:30',NULL,NULL),(38587,'43805','P','Blissfield','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.400882,-81.964837,0,'2013-07-06 12:44:32',NULL,NULL),(20696,'21250','U','Catonsville','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252457,-76.711210,0,'2013-07-06 12:44:31',NULL,NULL),(42073,'47453','S','Dresden','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.946534,-86.755017,0,'2013-07-06 12:44:32',NULL,NULL),(23002,'24808','S','Leckie','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.333193,-81.438739,0,'2013-07-06 12:44:31',NULL,NULL),(30345,'33311','S','Lauderhill','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(55123,'63342','P','Dutzow','D','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.594815,-91.001311,0,'2013-07-06 12:44:33',NULL,NULL),(40412,'45684','S','Stout','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.706026,-83.358873,0,'2013-07-06 12:44:32',NULL,NULL),(3202,'01354','S','Gill','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711180,-72.448620,0,'2013-07-06 12:44:30',NULL,NULL),(31264,'33993','S','Matlacha','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.713725,-82.026694,0,'2013-07-06 12:44:32',NULL,NULL),(44943,'50367','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595632,-93.766327,0,'2013-07-06 12:44:32',NULL,NULL),(71700,'87522','S','El Rincon de los Trujillos','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(68870,'82639','S','Kaycee','D','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.748572,-106.551114,0,'2013-07-06 12:44:34',NULL,NULL),(37186,'41503','S','South Williamson','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.670901,-82.287453,0,'2013-07-06 12:44:32',NULL,NULL),(22687,'24316','S','Broadford','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.940706,-81.649256,0,'2013-07-06 12:44:31',NULL,NULL),(22295,'23806','U','Virginia State University','D','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.226377,-77.403086,0,'2013-07-06 12:44:31',NULL,NULL),(19482,'20148','S','Brambleton','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.994011,-77.531312,0,'2013-07-06 12:44:31',NULL,NULL),(47313,'54555','S','Phillips','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(56560,'65466','S','Round Spring','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(3379,'01601','P','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.271095,-71.809743,0,'2013-07-06 12:44:30',NULL,NULL),(20977,'21797','S','Woodbine','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.310263,-77.066828,0,'2013-07-06 12:44:31',NULL,NULL),(11613,'12093','S','North Harpersfield','N','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.493692,-74.604434,0,'2013-07-06 12:44:30',NULL,NULL),(47840,'55073','S','Copas','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.271900,-92.831860,0,'2013-07-06 12:44:33',NULL,NULL),(49645,'56965','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(78643,'98223','S','Bryant','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.181800,-121.979640,0,'2013-07-06 12:44:34',NULL,NULL),(27000,'29632','U','Clemson','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.685014,-82.811204,0,'2013-07-06 12:44:31',NULL,NULL),(37615,'42134','S','Franklin','D','Simpson','21213','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.728547,-86.572927,0,'2013-07-06 12:44:32',NULL,NULL),(71324,'86505','S','Woodsprings','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(4185,'02817','S','W Greenwich','A','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.624715,-71.626315,0,'2013-07-06 12:44:30',NULL,NULL),(5640,'04947','S','Carrabassett Valley','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.062466,-70.321604,0,'2013-07-06 12:44:30',NULL,NULL),(62169,'73742','S','Hennessey','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.107231,-97.899726,0,'2013-07-06 12:44:33',NULL,NULL),(60224,'71428','P','Flora','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.616825,-93.094642,0,'2013-07-06 12:44:33',NULL,NULL),(59132,'70163','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.952763,-90.076684,0,'2013-07-06 12:44:33',NULL,NULL),(57861,'67574','S','Rozel','D','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.929827,-99.410895,0,'2013-07-06 12:44:33',NULL,NULL),(1733,'00778','S','Urb Gran Vista I','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(66613,'78768','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.270459,-97.744069,0,'2013-07-06 12:44:34',NULL,NULL),(74565,'92679','S','Trabuco Cyn','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(17060,'17756','S','East Muncy','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(35124,'39212','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.243548,-90.263734,0,'2013-07-06 12:44:32',NULL,NULL),(33629,'37680','S','Laurel Bloomery','D','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.574547,-81.739325,0,'2013-07-06 12:44:32',NULL,NULL),(26370,'29075','S','Little Mountain','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.204268,-81.289172,0,'2013-07-06 12:44:31',NULL,NULL),(2021,'00916','P','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.376517,-66.162719,0,'2013-07-06 12:44:30',NULL,NULL),(49825,'57219','S','Bristol','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.260940,-97.718340,0,'2013-07-06 12:44:33',NULL,NULL),(74016,'92122','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.854723,-117.209215,0,'2013-07-06 12:44:34',NULL,NULL),(64679,'76831','S','Castell','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.694716,-98.923327,0,'2013-07-06 12:44:34',NULL,NULL),(63298,'75561','S','Redbank','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(78520,'98122','S','East Union','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.613497,-122.297395,0,'2013-07-06 12:44:34',NULL,NULL),(4652,'03753','S','Grantham','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.527803,-72.137172,0,'2013-07-06 12:44:30',NULL,NULL),(4330,'02920','S','Cranston','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.761799,-71.464351,0,'2013-07-06 12:44:30',NULL,NULL),(54779,'62999','S','Six Mile','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.902282,-89.055677,0,'2013-07-06 12:44:33',NULL,NULL),(50306,'57709','P','Rapid City','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.232095,-103.389320,0,'2013-07-06 12:44:33',NULL,NULL),(19673,'20330','U','Dept Air Force Pentagon','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(12661,'13120','S','Rockwell Springs','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(72131,'88301','S','Carrizozo','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(55260,'63458','S','Newark','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.992921,-92.007717,0,'2013-07-06 12:44:33',NULL,NULL),(80180,'99840','P','Skagway','D','Skagway','02230','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.566446,-135.328306,0,'2013-07-06 12:44:34',NULL,NULL),(73825,'91770','S','Rosemead','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065846,-118.082058,0,'2013-07-06 12:44:34',NULL,NULL),(20781,'21536','S','Jennings','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.676680,-79.153920,0,'2013-07-06 12:44:31',NULL,NULL),(18040,'18657','S','Mehoopany Township','N','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(47216,'54494','S','Kellner','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(62997,'75154','S','Red Oak','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.525442,-96.814963,0,'2013-07-06 12:44:33',NULL,NULL),(74514,'92648','S','Beach Center','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.677256,-118.005064,0,'2013-07-06 12:44:34',NULL,NULL),(67921,'80906','S','Stratmoor Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.791623,-104.825814,0,'2013-07-06 12:44:34',NULL,NULL),(54148,'62568','S','Hewittsville','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(35732,'39701','S','McCrary','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(37203,'41522','S','Draffin','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(38021,'43014','S','Danville','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.463831,-82.262310,0,'2013-07-06 12:44:32',NULL,NULL),(49841,'57232','S','Eden','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.613340,-97.356059,0,'2013-07-06 12:44:33',NULL,NULL),(78508,'98115','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.683441,-122.291533,0,'2013-07-06 12:44:34',NULL,NULL),(67433,'80165','U','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595884,-105.008265,0,'2013-07-06 12:44:34',NULL,NULL),(64539,'76645','S','Vaughan','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(43410,'48457','S','Montrose','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.178102,-83.883104,0,'2013-07-06 12:44:32',NULL,NULL),(46905,'54129','S','Hilbert','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.146890,-88.172336,0,'2013-07-06 12:44:32',NULL,NULL),(49792,'57107','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.565350,-96.796958,0,'2013-07-06 12:44:33',NULL,NULL),(17784,'18348','P','Pocono Lk Prs','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106882,-75.479231,0,'2013-07-06 12:44:31',NULL,NULL),(24225,'26722','S','Green Spring','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.494638,-78.628233,0,'2013-07-06 12:44:31',NULL,NULL),(40183,'45373','S','Troy','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.035020,-84.206120,0,'2013-07-06 12:44:32',NULL,NULL),(78827,'98335','S','Key Center','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(57443,'66839','S','Burlington','D','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.195231,-95.743973,0,'2013-07-06 12:44:33',NULL,NULL),(22316,'23840','S','Dewitt','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.035224,-77.651660,0,'2013-07-06 12:44:31',NULL,NULL),(52086,'60406','S','Blue Island','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.654838,-87.678683,0,'2013-07-06 12:44:33',NULL,NULL),(62972,'75134','S','Lancaster','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.618452,-96.780593,0,'2013-07-06 12:44:33',NULL,NULL),(2911,'01002','S','Amherst','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.376860,-72.469140,0,'2013-07-06 12:44:30',NULL,NULL),(24148,'26575','S','Hundred','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.695645,-80.469427,0,'2013-07-06 12:44:31',NULL,NULL),(28500,'31524','U','Glynco','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.144010,-81.469037,0,'2013-07-06 12:44:32',NULL,NULL),(59163,'70310','U','Thibodaux','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.789115,-90.822503,0,'2013-07-06 12:44:33',NULL,NULL),(55380,'63621','S','Arcadia','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.587754,-90.626482,0,'2013-07-06 12:44:33',NULL,NULL),(42808,'48054','S','China','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767172,-82.540934,0,'2013-07-06 12:44:32',NULL,NULL),(22631,'24244','S','Duffield','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.707460,-82.809600,0,'2013-07-06 12:44:31',NULL,NULL),(36465,'40740','S','Lily','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.018122,-84.065681,0,'2013-07-06 12:44:32',NULL,NULL),(57489,'66936','S','Burr Oak','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.916320,-98.385571,0,'2013-07-06 12:44:33',NULL,NULL),(43639,'48832','S','Elwell','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.407798,-84.771317,0,'2013-07-06 12:44:32',NULL,NULL),(36302,'40362','P','Paris','D','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.205378,-84.263431,0,'2013-07-06 12:44:32',NULL,NULL),(13442,'13774','P','Fishs Eddy','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.963583,-75.173944,0,'2013-07-06 12:44:31',NULL,NULL),(50261,'57638','S','Shadehill','A','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.937575,-102.160093,0,'2013-07-06 12:44:33',NULL,NULL),(77962,'97367','S','Rose Lodge','A','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.962200,-123.952740,0,'2013-07-06 12:44:34',NULL,NULL),(35032,'39163','P','Sharon','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.658868,-89.937209,0,'2013-07-06 12:44:32',NULL,NULL),(14377,'15032','P','Curtisville','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.636097,-79.841254,0,'2013-07-06 12:44:31',NULL,NULL),(57641,'67154','S','Whitewater','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.964462,-97.142875,0,'2013-07-06 12:44:33',NULL,NULL),(55342,'63556','S','Owasco','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(65377,'77541','S','Surfside Bch','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(60946,'72101','S','Fair Oaks','A','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(24153,'26581','S','Wileyville','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.665921,-80.575673,0,'2013-07-06 12:44:31',NULL,NULL),(13768,'14138','S','South Dayton','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.399405,-79.100331,0,'2013-07-06 12:44:31',NULL,NULL),(43182,'48301','S','Bloomfield Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(41990,'47424','S','Bloomfield','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(24515,'27282','S','Jamestown','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.999796,-79.931650,0,'2013-07-06 12:44:31',NULL,NULL),(68478,'81247','S','Sapinero','A','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.490794,-107.075470,0,'2013-07-06 12:44:34',NULL,NULL),(64092,'76162','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.663309,-97.377859,0,'2013-07-06 12:44:34',NULL,NULL),(63623,'75834','S','Centralia','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.258369,-95.040616,0,'2013-07-06 12:44:34',NULL,NULL),(17235,'17837','S','Brook Park','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(42884,'48094','S','Washington','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.734460,-82.998120,0,'2013-07-06 12:44:32',NULL,NULL),(19006,'19526','S','Perry','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(7270,'06520','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.308633,-72.925779,0,'2013-07-06 12:44:30',NULL,NULL),(21926,'23225','S','North Chesterfield','A','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.517420,-77.501037,0,'2013-07-06 12:44:31',NULL,NULL),(8855,'08648','S','Lawrence','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.265940,-74.695860,0,'2013-07-06 12:44:30',NULL,NULL),(43251,'48322','S','W Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.545288,-83.382354,0,'2013-07-06 12:44:32',NULL,NULL),(23937,'26260','S','Davis','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.128653,-79.468131,0,'2013-07-06 12:44:31',NULL,NULL),(5044,'04265','S','N Monmouth','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.270876,-70.052031,0,'2013-07-06 12:44:30',NULL,NULL),(19311,'20011','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.949806,-77.015627,0,'2013-07-06 12:44:31',NULL,NULL),(16194,'17070','S','Frogtown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(6728,'06074','S','South Windsor','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.834880,-72.571320,0,'2013-07-06 12:44:30',NULL,NULL),(17065,'17756','S','Muncy Creek','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(49935,'57329','S','Dante','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.040312,-98.184995,0,'2013-07-06 12:44:33',NULL,NULL),(27239,'29922','S','Shirley','N','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.601990,-81.241810,0,'2013-07-06 12:44:31',NULL,NULL),(39254,'44442','S','New Middletwn','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.965625,-80.556678,0,'2013-07-06 12:44:32',NULL,NULL),(536,'00676','S','Hacienda La Monserrate','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(58885,'69163','S','Gandy','N','Logan','31113','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.507700,-100.492800,0,'2013-07-06 12:44:33',NULL,NULL),(59604,'71019','S','Gahagan','N','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(59898,'71276','S','Omega','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.571944,-91.182222,0,'2013-07-06 12:44:33',NULL,NULL),(68538,'81416','S','Delta','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.740747,-108.050120,0,'2013-07-06 12:44:34',NULL,NULL),(76010,'95121','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.305224,-121.807376,0,'2013-07-06 12:44:34',NULL,NULL),(74752,'93063','S','Simi Valley','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.271667,-118.708056,0,'2013-07-06 12:44:34',NULL,NULL),(76001,'95111','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.282801,-121.825473,0,'2013-07-06 12:44:34',NULL,NULL),(69190,'83340','S','Sawtooth City','A','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.733354,-114.512415,0,'2013-07-06 12:44:34',NULL,NULL),(62651,'74601','S','Kildare','N','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.709082,-97.087737,0,'2013-07-06 12:44:33',NULL,NULL),(67134,'79758','S','Gardendale','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',32.025936,-102.385544,0,'2013-07-06 12:44:34',NULL,NULL),(1996,'00909','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(44851,'50269','P','Whitten','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.251604,-93.061585,0,'2013-07-06 12:44:32',NULL,NULL),(44212,'49636','S','Glen Arbor','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.890959,-85.963971,0,'2013-07-06 12:44:32',NULL,NULL),(36319,'40380','S','Rosslyn','A','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.851590,-83.854413,0,'2013-07-06 12:44:32',NULL,NULL),(62274,'74015','S','Catoosa','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.186268,-95.744614,0,'2013-07-06 12:44:33',NULL,NULL),(54235,'62664','S','Luther','A','Mason','17125','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.200803,-89.695417,0,'2013-07-06 12:44:33',NULL,NULL),(29750,'32976','S','Micco','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.880728,-80.516230,0,'2013-07-06 12:44:32',NULL,NULL),(11486,'12020','S','Harmony Corners','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(14998,'15658','S','Ligonier','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.224180,-79.216740,0,'2013-07-06 12:44:31',NULL,NULL),(7678,'07097','U','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.751433,-74.050904,0,'2013-07-06 12:44:30',NULL,NULL),(34481,'38665','S','Longtown','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601919,-90.126392,0,'2013-07-06 12:44:32',NULL,NULL),(21318,'22406','S','Fredericksbur','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(76265,'95416','P','Boyes Springs','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.312407,-122.482861,0,'2013-07-06 12:44:34',NULL,NULL),(72015,'88043','S','Whitewater','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.701595,-108.130863,0,'2013-07-06 12:44:34',NULL,NULL),(60500,'71665','S','Kedron','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(32807,'36442','S','Florala','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.002261,-86.325796,0,'2013-07-06 12:44:32',NULL,NULL),(78050,'97448','S','Junction City','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.195781,-123.252848,0,'2013-07-06 12:44:34',NULL,NULL),(3270,'01468','S','Templeton','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.549860,-72.065785,0,'2013-07-06 12:44:30',NULL,NULL),(13724,'14092','S','Lewiston','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.171111,-79.018833,0,'2013-07-06 12:44:31',NULL,NULL),(31485,'34433','S','Citrus Spgs','A','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.004097,-82.522871,0,'2013-07-06 12:44:32',NULL,NULL),(55137,'63353','S','Louisiana','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.441104,-91.055048,0,'2013-07-06 12:44:33',NULL,NULL),(65561,'77843','U','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.611331,-96.348373,0,'2013-07-06 12:44:34',NULL,NULL),(72628,'89419','S','Rabbit Hole','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(21460,'22622','P','Brucetown','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.256587,-78.067063,0,'2013-07-06 12:44:31',NULL,NULL),(45370,'51010','S','Ticonic','N','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.071125,-95.911358,0,'2013-07-06 12:44:32',NULL,NULL),(56885,'66032','S','Garnett','D','Anderson','20003','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.282629,-95.241151,0,'2013-07-06 12:44:33',NULL,NULL),(18286,'19013','S','Village Green','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(11457,'11980','S','Yaphank','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.838524,-72.933522,0,'2013-07-06 12:44:30',NULL,NULL),(76625,'95709','S','Cedar Grove','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.751360,-120.665040,0,'2013-07-06 12:44:34',NULL,NULL),(66105,'78411','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.743325,-97.390984,0,'2013-07-06 12:44:34',NULL,NULL),(38631,'43925','P','E Springfield','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.451367,-80.858749,0,'2013-07-06 12:44:32',NULL,NULL),(48465,'55717','S','Northland','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.079441,-92.470331,0,'2013-07-06 12:44:33',NULL,NULL),(77544,'96857','S','Helemano Mltry Res','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.494722,-158.066346,0,'2013-07-06 12:44:34',NULL,NULL),(58662,'68879','S','Taylor','D','Loup','31115','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.853120,-99.440580,0,'2013-07-06 12:44:33',NULL,NULL),(58179,'68305','S','Rohrs','N','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.390284,-95.842607,0,'2013-07-06 12:44:33',NULL,NULL),(65773,'78111','S','Ecleto','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',29.046111,-97.751111,0,'2013-07-06 12:44:34',NULL,NULL),(26209,'28782','S','Tryon','D','Polk','37149','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.217184,-82.226181,0,'2013-07-06 12:44:31',NULL,NULL),(12602,'13081','S','Atwater','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.662592,-76.626770,0,'2013-07-06 12:44:30',NULL,NULL),(5523,'04777','S','Sherman Sta','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.896021,-68.492070,0,'2013-07-06 12:44:30',NULL,NULL),(36962,'41174','S','Firebrick','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.706344,-83.011058,0,'2013-07-06 12:44:32',NULL,NULL),(28406,'31319','P','Carnigan','N','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421746,-81.423676,0,'2013-07-06 12:44:32',NULL,NULL),(29005,'32222','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.222818,-81.815888,0,'2013-07-06 12:44:32',NULL,NULL),(24650,'27401','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.068126,-79.770814,0,'2013-07-06 12:44:31',NULL,NULL),(67461,'80218','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.733269,-104.969730,0,'2013-07-06 12:44:34',NULL,NULL),(3530,'01902','S','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.472369,-70.941341,0,'2013-07-06 12:44:30',NULL,NULL),(22814,'24485','S','West Augusta','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.297636,-79.315560,0,'2013-07-06 12:44:31',NULL,NULL),(47126,'54452','S','Merrill','D','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.182325,-89.694701,0,'2013-07-06 12:44:32',NULL,NULL),(73857,'91905','S','Boulevard','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.724561,-116.299903,0,'2013-07-06 12:44:34',NULL,NULL),(52643,'61054','S','Mt Morris','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.052377,-89.432066,0,'2013-07-06 12:44:33',NULL,NULL),(22151,'23459','S','Fort Story','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(47093,'54437','S','Eaton','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.768935,-90.603954,0,'2013-07-06 12:44:32',NULL,NULL),(33145,'36919','S','Bladon Springs','N','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.762783,-88.300013,0,'2013-07-06 12:44:32',NULL,NULL),(31299,'34092','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(2627,'00962','S','Urb Las Vegas','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(12913,'13339','S','Ephratah','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(45261,'50665','S','Sinclair','N','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.579549,-92.788151,0,'2013-07-06 12:44:32',NULL,NULL),(26724,'29418','S','CH Hgts','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(71265,'86413','S','Kingman','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.220638,-114.219181,0,'2013-07-06 12:44:34',NULL,NULL),(68542,'81419','S','Rogers Mesa','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.817069,-107.748719,0,'2013-07-06 12:44:34',NULL,NULL),(66359,'78615','S','Beyersville','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.544620,-97.321980,0,'2013-07-06 12:44:34',NULL,NULL),(32438,'36003','S','Autaugaville','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.458680,-86.714580,0,'2013-07-06 12:44:32',NULL,NULL),(33276,'37110','S','Mc Minnville','A','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.683587,-85.776477,0,'2013-07-06 12:44:32',NULL,NULL),(25413,'28299','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.218471,-80.811634,0,'2013-07-06 12:44:31',NULL,NULL),(2761,'00969','S','Villa Lissette','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(78069,'97462','S','Oakland','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.466880,-123.366240,0,'2013-07-06 12:44:34',NULL,NULL),(32259,'35620','S','Elkmont','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.908359,-87.009957,0,'2013-07-06 12:44:32',NULL,NULL),(68277,'81082','S','El Moro','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(22305,'23832','S','Chesterfield','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.409940,-77.610720,0,'2013-07-06 12:44:31',NULL,NULL),(48770,'55985','S','West Concord','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.147500,-92.836111,0,'2013-07-06 12:44:33',NULL,NULL),(6583,'05858','S','Granby Valley','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.575000,-71.784722,0,'2013-07-06 12:44:30',NULL,NULL),(75426,'94028','S','Portola Vally','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.379860,-122.208569,0,'2013-07-06 12:44:34',NULL,NULL),(58919,'69336','S','Northport','N','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.674740,-103.054260,0,'2013-07-06 12:44:33',NULL,NULL),(54437,'62841','P','Freeman Spur','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.801882,-89.008751,0,'2013-07-06 12:44:33',NULL,NULL),(23345,'25253','S','Letart','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.988570,-81.952381,0,'2013-07-06 12:44:31',NULL,NULL),(2025,'00917','S','Bda Las Monjas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(10815,'11375','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.721216,-73.850210,0,'2013-07-06 12:44:30',NULL,NULL),(23494,'25520','S','Glenwood','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.591594,-82.194435,0,'2013-07-06 12:44:31',NULL,NULL),(56456,'65283','S','Stoutsville','D','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.546823,-91.835464,0,'2013-07-06 12:44:33',NULL,NULL),(33619,'37660','S','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.548955,-82.546424,0,'2013-07-06 12:44:32',NULL,NULL),(40705,'46106','S','Bargersville','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.507357,-86.199658,0,'2013-07-06 12:44:32',NULL,NULL),(45276,'50675','S','Traer','D','Tama','19171','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.191240,-92.477228,0,'2013-07-06 12:44:32',NULL,NULL),(36706,'41017','S','So Fort Mitchell','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(75826,'94904','S','Greenbrae','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.951140,-122.539560,0,'2013-07-06 12:44:34',NULL,NULL),(70072,'84148','U','Veterans Administration Hosp','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.755635,-111.835281,0,'2013-07-06 12:44:34',NULL,NULL),(3491,'01843','S','Lawrence','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.692019,-71.164643,0,'2013-07-06 12:44:30',NULL,NULL),(49553,'56701','S','Thief River Falls','D','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.115399,-96.174170,0,'2013-07-06 12:44:33',NULL,NULL),(23446,'25413','S','Bunker Hill','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.304746,-78.035353,0,'2013-07-06 12:44:31',NULL,NULL),(57543,'67024','S','Hewins','N','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.106753,-96.499615,0,'2013-07-06 12:44:33',NULL,NULL),(49589,'56741','P','Oak Island','D','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',49.310280,-94.849780,0,'2013-07-06 12:44:33',NULL,NULL),(67321,'80030','S','Westminster','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.828893,-105.036679,0,'2013-07-06 12:44:34',NULL,NULL),(51964,'60141','P','Hines','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.854028,-87.833373,0,'2013-07-06 12:44:33',NULL,NULL),(48795,'56006','P','Mankato','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.116841,-93.999585,0,'2013-07-06 12:44:33',NULL,NULL),(78230,'97813','S','Athena','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.814185,-118.488771,0,'2013-07-06 12:44:34',NULL,NULL),(67806,'80741','S','Willard','A','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.531920,-103.413240,0,'2013-07-06 12:44:34',NULL,NULL),(67385,'80123','S','Bow Mar','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(55891,'64428','S','Burlington Junction','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.436052,-95.019402,0,'2013-07-06 12:44:33',NULL,NULL),(54788,'63011','S','Ellisville','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.598725,-90.547046,0,'2013-07-06 12:44:33',NULL,NULL),(53492,'62002','S','Alton','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.901935,-90.165499,0,'2013-07-06 12:44:33',NULL,NULL),(76229,'95380','S','Turlock','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.498202,-120.857364,0,'2013-07-06 12:44:34',NULL,NULL),(49108,'56345','S','Sobieski','A','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.979362,-94.362403,0,'2013-07-06 12:44:33',NULL,NULL),(14869,'15465','P','Mount Braddock','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.940953,-79.645633,0,'2013-07-06 12:44:31',NULL,NULL),(45566,'51521','S','Avoca','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.477491,-95.339627,0,'2013-07-06 12:44:32',NULL,NULL),(19527,'20187','S','Vint Hill Farms','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.722482,-77.719815,0,'2013-07-06 12:44:31',NULL,NULL),(70551,'85035','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.473497,-112.187607,0,'2013-07-06 12:44:34',NULL,NULL),(70359,'84647','S','Mount Pleasant','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.554490,-111.491057,0,'2013-07-06 12:44:34',NULL,NULL),(31533,'34488','S','Silver Spgs','A','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.225427,-81.949001,0,'2013-07-06 12:44:32',NULL,NULL),(1136,'00725','S','Villas de Rio Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(6454,'05759','S','N Clarendon','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.548900,-72.958080,0,'2013-07-06 12:44:30',NULL,NULL),(31684,'34778','P','Winter Garden','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.497294,-81.615976,0,'2013-07-06 12:44:32',NULL,NULL),(71837,'87580','S','Valdez','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.571665,-105.503280,0,'2013-07-06 12:44:34',NULL,NULL),(26046,'28685','S','Abshers','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.346465,-81.027968,0,'2013-07-06 12:44:31',NULL,NULL),(46924,'54152','P','Nichols','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.565309,-88.463726,0,'2013-07-06 12:44:32',NULL,NULL),(48424,'55606','S','Hovland','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.877386,-89.959755,0,'2013-07-06 12:44:33',NULL,NULL),(29960,'33075','P','Pompano Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.244645,-80.262760,0,'2013-07-06 12:44:32',NULL,NULL),(58796,'68982','S','Lake','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.392938,-99.121319,0,'2013-07-06 12:44:33',NULL,NULL),(44461,'49879','S','Republic','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.278878,-88.137022,0,'2013-07-06 12:44:32',NULL,NULL),(41107,'46562','S','Sidney','A','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.200623,-85.708234,0,'2013-07-06 12:44:32',NULL,NULL),(62133,'73668','S','Texola','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.233193,-99.966920,0,'2013-07-06 12:44:33',NULL,NULL),(15715,'16865','S','Pennsylvania Furnace','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.725800,-77.945698,0,'2013-07-06 12:44:31',NULL,NULL),(45357,'51001','S','Ruble','N','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.833520,-96.529560,0,'2013-07-06 12:44:32',NULL,NULL),(48056,'55320','S','Saint Augusta','A','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.413142,-94.119490,0,'2013-07-06 12:44:33',NULL,NULL),(28270,'31082','S','Deepstep','A','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.980476,-82.810981,0,'2013-07-06 12:44:31',NULL,NULL),(15316,'16159','S','W Middlesex','A','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.184971,-80.454618,0,'2013-07-06 12:44:31',NULL,NULL),(8512,'08103','S','Camden','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.935552,-75.114601,0,'2013-07-06 12:44:30',NULL,NULL),(45430,'51063','S','Whiting','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.126223,-96.152390,0,'2013-07-06 12:44:32',NULL,NULL),(79322,'98604','S','Battle Ground','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.794960,-122.520247,0,'2013-07-06 12:44:34',NULL,NULL),(33794,'37885','S','Vonore','D','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.481202,-84.091965,0,'2013-07-06 12:44:32',NULL,NULL),(26190,'28765','P','Penland','D','Mitchell','37121','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.928020,-82.116990,0,'2013-07-06 12:44:31',NULL,NULL),(14452,'15106','S','Collier Township','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405231,-80.093696,0,'2013-07-06 12:44:31',NULL,NULL),(8758,'08535','S','Millstone Township','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.220714,-74.440497,0,'2013-07-06 12:44:30',NULL,NULL),(42421,'47802','S','Prairie Village','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(14252,'14827','P','Coopers Plns','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.178306,-77.140860,0,'2013-07-06 12:44:31',NULL,NULL),(25418,'28301','S','Eastover','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(68432,'81220','S','Cimarron','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.320133,-107.454381,0,'2013-07-06 12:44:34',NULL,NULL),(4076,'02657','S','Provincetown','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',42.055479,-70.187283,0,'2013-07-06 12:44:30',NULL,NULL),(47611,'54889','S','Turtle Lake','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.396821,-92.143546,0,'2013-07-06 12:44:33',NULL,NULL),(50947,'58581','S','Zeeland','D','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.028615,-99.725988,0,'2013-07-06 12:44:33',NULL,NULL),(14287,'14867','S','Newfield','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.359059,-76.599327,0,'2013-07-06 12:44:31',NULL,NULL),(35276,'39367','S','Waynesboro','D','Wayne','28153','Mississippi','MS','28','0000','662','Central',-6.0,'Y',31.677923,-88.642050,0,'2013-07-06 12:44:32',NULL,NULL),(79922,'99607','P','Kalskag','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.544775,-160.334469,0,'2013-07-06 12:44:34',NULL,NULL),(61903,'73143','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.435074,-97.526700,0,'2013-07-06 12:44:33',NULL,NULL),(71869,'87723','S','Holman','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.038580,-105.380259,0,'2013-07-06 12:44:34',NULL,NULL),(21085,'22034','S','Journal Newspaper','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855963,-77.260199,0,'2013-07-06 12:44:31',NULL,NULL),(43974,'49323','S','Dorr','D','Allegan','26005','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.721063,-85.779886,0,'2013-07-06 12:44:32',NULL,NULL),(46245,'53002','S','Allenton','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.458494,-88.359486,0,'2013-07-06 12:44:32',NULL,NULL),(56521,'65355','S','Racket','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(8708,'08402','S','Margate','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.330254,-74.506230,0,'2013-07-06 12:44:30',NULL,NULL),(15107,'15774','S','Shelocta','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.640132,-79.278556,0,'2013-07-06 12:44:31',NULL,NULL),(1962,'00823','P','St Croix','A','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.744235,-64.708266,0,'2013-07-06 12:44:30',NULL,NULL),(48514,'55746','S','Brooklyn','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(76872,'95973','S','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.737451,-121.830460,0,'2013-07-06 12:44:34',NULL,NULL),(70768,'85338','S','Avondale-Goodyear','N','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.434691,-112.383814,0,'2013-07-06 12:44:34',NULL,NULL),(20474,'21042','S','Ellicott','N','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.277416,-76.866712,0,'2013-07-06 12:44:31',NULL,NULL),(15678,'16826','P','Blanchard','D','Centre','42027','Pennsylvania','PA','42','8050','570','Eastern',-5.0,'Y',41.064333,-77.597197,0,'2013-07-06 12:44:31',NULL,NULL),(79112,'98466','S','University Pl','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225803,-122.534108,0,'2013-07-06 12:44:34',NULL,NULL),(35275,'39366','S','Vossburg','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.981816,-88.971858,0,'2013-07-06 12:44:32',NULL,NULL),(46005,'52534','S','Beacon','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.277376,-92.683877,0,'2013-07-06 12:44:32',NULL,NULL),(1416,'00738','S','Urb Veve Calzada','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(33662,'37722','S','Cosby','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.807702,-83.214203,0,'2013-07-06 12:44:32',NULL,NULL),(72528,'89163','U','Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.174641,-115.138381,0,'2013-07-06 12:44:34',NULL,NULL),(64095,'76163','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.664187,-97.374241,0,'2013-07-06 12:44:34',NULL,NULL),(62575,'74461','S','Stidham','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.386730,-95.708509,0,'2013-07-06 12:44:33',NULL,NULL),(10799,'11371','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.775842,-73.874904,0,'2013-07-06 12:44:30',NULL,NULL),(31043,'33813','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.966593,-81.934465,0,'2013-07-06 12:44:32',NULL,NULL),(53455,'61912','S','Ashmore','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.526497,-88.018046,0,'2013-07-06 12:44:33',NULL,NULL),(71351,'86515','P','Tse Bonita','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.660965,-109.102204,0,'2013-07-06 12:44:34',NULL,NULL),(55187,'63377','S','Millwood','N','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.140541,-91.061883,0,'2013-07-06 12:44:33',NULL,NULL),(5670,'04962','S','North Vassalboro','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.475695,-69.624563,0,'2013-07-06 12:44:30',NULL,NULL),(49378,'56592','S','Winger','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.630484,-95.888684,0,'2013-07-06 12:44:33',NULL,NULL),(13034,'13435','P','Prospect','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.303611,-75.148084,0,'2013-07-06 12:44:30',NULL,NULL),(63114,'75287','S','Dallas','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.000097,-96.842497,0,'2013-07-06 12:44:33',NULL,NULL),(73772,'91739','S','Etiwanda','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.124307,-117.519639,0,'2013-07-06 12:44:34',NULL,NULL),(64448,'76570','S','Baileyville','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(26945,'29601','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.850510,-82.403553,0,'2013-07-06 12:44:31',NULL,NULL),(17373,'17882','P','Troxelville','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.804238,-77.208749,0,'2013-07-06 12:44:31',NULL,NULL),(24758,'27541','S','Hurdle Mills','D','Person','37145','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.202600,-79.074166,0,'2013-07-06 12:44:31',NULL,NULL),(49196,'56446','S','Eagle Bend','D','Todd','27153','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.162010,-95.027241,0,'2013-07-06 12:44:33',NULL,NULL),(6428,'05743','S','Fair Haven','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(20007,'20613','S','Brandywine','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.678248,-76.816106,0,'2013-07-06 12:44:31',NULL,NULL),(13175,'13615','P','Paddy Hill','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006764,-75.986222,0,'2013-07-06 12:44:30',NULL,NULL),(63430,'75663','P','Kilgore','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.375233,-94.865339,0,'2013-07-06 12:44:33',NULL,NULL),(78443,'98058','S','Renton','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.444411,-122.142843,0,'2013-07-06 12:44:34',NULL,NULL),(62921,'75080','S','Buckingham','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.963287,-96.745163,0,'2013-07-06 12:44:33',NULL,NULL),(74607,'92708','S','Fountain Valley','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.716650,-117.944594,0,'2013-07-06 12:44:34',NULL,NULL),(52860,'61329','S','Ladd Junction','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.378377,-89.217491,0,'2013-07-06 12:44:33',NULL,NULL),(32938,'36567','S','Robertsdale','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.569400,-87.630720,0,'2013-07-06 12:44:32',NULL,NULL),(61860,'73122','S','Warr Acres','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.522969,-97.614030,0,'2013-07-06 12:44:33',NULL,NULL),(26923,'29585','S','Litchfield','A','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.453325,-79.135137,0,'2013-07-06 12:44:31',NULL,NULL),(50789,'58439','S','Forbes','D','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.032513,-98.844625,0,'2013-07-06 12:44:33',NULL,NULL),(11954,'12450','S','Lanesville','D','Greene','36039','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.134503,-74.264765,0,'2013-07-06 12:44:30',NULL,NULL),(4921,'04076','S','North Shapleigh','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.517658,-70.853521,0,'2013-07-06 12:44:30',NULL,NULL),(11128,'11706','S','Kismet','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(46636,'53589','S','Stoughton','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.930347,-89.214312,0,'2013-07-06 12:44:32',NULL,NULL),(78449,'98062','P','Seahurst','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.469145,-122.360015,0,'2013-07-06 12:44:34',NULL,NULL),(7887,'07524','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.928547,-74.155124,0,'2013-07-06 12:44:30',NULL,NULL),(7309,'06612','S','Easton','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.166944,-73.205278,0,'2013-07-06 12:44:30',NULL,NULL),(46244,'53001','S','Adell','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.622721,-87.956471,0,'2013-07-06 12:44:32',NULL,NULL),(21448,'22581','P','Zacata','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.119696,-76.784998,0,'2013-07-06 12:44:31',NULL,NULL),(53458,'61914','S','Bethany','D','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.646710,-88.736185,0,'2013-07-06 12:44:33',NULL,NULL),(13798,'14204','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.881129,-78.864058,0,'2013-07-06 12:44:31',NULL,NULL),(75051,'93518','S','Loraine','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.318400,-118.462200,0,'2013-07-06 12:44:34',NULL,NULL),(189,'00623','S','Repto Oliveras','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(25676,'28512','S','Pks','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(71746,'87540','S','Lamy','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.397323,-105.846760,0,'2013-07-06 12:44:34',NULL,NULL),(66693,'78945','S','Halsted','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(57229,'66508','S','Marysville','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.846378,-96.645294,0,'2013-07-06 12:44:33',NULL,NULL),(52312,'60551','S','Norway','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.516340,-88.716780,0,'2013-07-06 12:44:33',NULL,NULL),(52038,'60188','S','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.920273,-88.143298,0,'2013-07-06 12:44:33',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (23393,'25314','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.337622,-81.659235,0,'2013-07-06 12:44:31',NULL,NULL),(5592,'04920','S','Plsnt Rdg Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.128441,-69.858003,0,'2013-07-06 12:44:30',NULL,NULL),(58453,'68723','S','Carroll','D','Wayne','31179','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.284958,-97.191946,0,'2013-07-06 12:44:33',NULL,NULL),(23259,'25126','P','London','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.188115,-81.347686,0,'2013-07-06 12:44:31',NULL,NULL),(14709,'15267','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.467425,-80.037466,0,'2013-07-06 12:44:31',NULL,NULL),(18976,'19519','P','Earlville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.314999,-75.738387,0,'2013-07-06 12:44:31',NULL,NULL),(22651,'24266','S','Bolton','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.890460,-82.084560,0,'2013-07-06 12:44:31',NULL,NULL),(60923,'72082','S','Kensett','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.232917,-91.670949,0,'2013-07-06 12:44:33',NULL,NULL),(60367,'71475','P','Slagle','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.198011,-93.136354,0,'2013-07-06 12:44:33',NULL,NULL),(66438,'78645','S','Leander','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.447624,-97.980615,0,'2013-07-06 12:44:34',NULL,NULL),(64391,'76537','S','New Corn Hill','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.788880,-97.606020,0,'2013-07-06 12:44:34',NULL,NULL),(22697,'24326','S','Elk Creek','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.729391,-81.194399,0,'2013-07-06 12:44:31',NULL,NULL),(26596,'29227','U','Wells Fargo','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.033609,-81.108740,0,'2013-07-06 12:44:31',NULL,NULL),(60097,'71360','S','Kingsville','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(53274,'61724','S','Bellflower','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.341562,-88.515542,0,'2013-07-06 12:44:33',NULL,NULL),(38151,'43146','S','Darbyville','A','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.771545,-83.148051,0,'2013-07-06 12:44:32',NULL,NULL),(14231,'14809','S','Avoca','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.417120,-77.456640,0,'2013-07-06 12:44:31',NULL,NULL),(44654,'50103','S','Woodland','N','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.717931,-93.614761,0,'2013-07-06 12:44:32',NULL,NULL),(39152,'44287','S','Lattasburg','N','Wayne','39169','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.925833,-82.053056,0,'2013-07-06 12:44:32',NULL,NULL),(49914,'57313','S','Armour','D','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.318948,-98.345478,0,'2013-07-06 12:44:33',NULL,NULL),(1532,'00754','S','VISTAS de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(8876,'08695','U','Division of Revenue','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220861,-74.764864,0,'2013-07-06 12:44:30',NULL,NULL),(72626,'89419','S','Lower Valley','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(18045,'18660','S','Wapwallopen','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.160721,-76.010549,0,'2013-07-06 12:44:31',NULL,NULL),(15403,'16342','S','Polk','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.340932,-79.932203,0,'2013-07-06 12:44:31',NULL,NULL),(43736,'48951','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.733180,-84.555446,0,'2013-07-06 12:44:32',NULL,NULL),(23131,'24974','S','Secondcreek','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.659279,-80.409383,0,'2013-07-06 12:44:31',NULL,NULL),(7622,'07059','S','Warren','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.631567,-74.508064,0,'2013-07-06 12:44:30',NULL,NULL),(33885,'38027','P','Colliervle','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056954,-89.676442,0,'2013-07-06 12:44:32',NULL,NULL),(40843,'46220','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.867992,-86.108018,0,'2013-07-06 12:44:32',NULL,NULL),(26832,'29488','S','Ritter','A','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.891220,-80.694600,0,'2013-07-06 12:44:31',NULL,NULL),(50949,'58601','S','Lehigh','N','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.882628,-102.783495,0,'2013-07-06 12:44:33',NULL,NULL),(2380,'00949','S','Urb Dos Rios','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(58924,'69339','S','Glen','N','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.658320,-103.409940,0,'2013-07-06 12:44:33',NULL,NULL),(58758,'68959','S','South Minden','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.493757,-98.949409,0,'2013-07-06 12:44:33',NULL,NULL),(53794,'62284','S','Pleasant Mound','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.876400,-89.323800,0,'2013-07-06 12:44:33',NULL,NULL),(42899,'48098','S','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.603558,-83.176258,0,'2013-07-06 12:44:32',NULL,NULL),(49783,'57078','S','Yankton','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.879711,-97.388459,0,'2013-07-06 12:44:33',NULL,NULL),(54748,'62976','S','Pulaski','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.213602,-89.199138,0,'2013-07-06 12:44:33',NULL,NULL),(55065,'63164','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.636218,-90.185817,0,'2013-07-06 12:44:33',NULL,NULL),(71981,'88023','S','Vanadium','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.765190,-108.135124,0,'2013-07-06 12:44:34',NULL,NULL),(50474,'58043','S','Havana','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',45.977636,-97.626381,0,'2013-07-06 12:44:33',NULL,NULL),(37737,'42301','S','Stanley','A','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.747812,-87.178813,0,'2013-07-06 12:44:32',NULL,NULL),(51826,'60060','S','Long Grove','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.268920,-88.060980,0,'2013-07-06 12:44:33',NULL,NULL),(13466,'13783','S','Lordville','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(28780,'32035','P','Five Points Hamilton','N','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.670498,-81.462032,0,'2013-07-06 12:44:32',NULL,NULL),(74483,'92610','S','Lake Forest','N','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.681780,-117.631980,0,'2013-07-06 12:44:34',NULL,NULL),(73060,'90093','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.098083,-118.336400,0,'2013-07-06 12:44:34',NULL,NULL),(70104,'84171','P','Cottonwood Heights City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(66741,'78962','S','Borden','N','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.685660,-96.728400,0,'2013-07-06 12:44:34',NULL,NULL),(56139,'64842','S','Fairview','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.818748,-94.083802,0,'2013-07-06 12:44:33',NULL,NULL),(43203,'48304','S','Bloomfield Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(48269,'55429','S','Brooklyn Park','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(14964,'15625','P','Darragh','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.258382,-79.673932,0,'2013-07-06 12:44:31',NULL,NULL),(72762,'89515','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.498337,-119.746476,0,'2013-07-06 12:44:34',NULL,NULL),(10178,'10282','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(50285,'57651','S','Reva','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.520913,-103.062315,0,'2013-07-06 12:44:33',NULL,NULL),(24145,'26571','S','Farmington','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.515469,-80.248772,0,'2013-07-06 12:44:31',NULL,NULL),(36752,'41040','S','McKinneysburg','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(34432,'38645','S','Clove Hill','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.236273,-90.519701,0,'2013-07-06 12:44:32',NULL,NULL),(56679,'65637','S','Dora','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.758509,-92.222637,0,'2013-07-06 12:44:33',NULL,NULL),(15408,'16346','S','Seneca','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.388298,-79.705000,0,'2013-07-06 12:44:31',NULL,NULL),(32106,'35298','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.499493,-86.800795,0,'2013-07-06 12:44:32',NULL,NULL),(64454,'76570','S','Wilderville','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(43856,'49111','S','Eau Claire','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.016888,-86.301114,0,'2013-07-06 12:44:32',NULL,NULL),(17208,'17822','U','Geisinger Med','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.958350,-76.609495,0,'2013-07-06 12:44:31',NULL,NULL),(20255,'20782','S','West Hyattsville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(13806,'14209','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.917486,-78.864980,0,'2013-07-06 12:44:31',NULL,NULL),(10372,'10590','S','Lake Kitchawan','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.251239,-73.543589,0,'2013-07-06 12:44:30',NULL,NULL),(9358,'09814','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(20630,'21217','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.307911,-76.637572,0,'2013-07-06 12:44:31',NULL,NULL),(32897,'36538','S','Frankville','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.655932,-88.133041,0,'2013-07-06 12:44:32',NULL,NULL),(48654,'55910','S','Altura','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(3793,'02215','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344927,-71.101619,0,'2013-07-06 12:44:30',NULL,NULL),(11799,'12226','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.684962,-73.807547,0,'2013-07-06 12:44:30',NULL,NULL),(60012,'71334','S','Minorca','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(59378,'70601','S','Grand Lake','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.228174,-93.194503,0,'2013-07-06 12:44:33',NULL,NULL),(41586,'47041','S','Weisburg','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(41105,'46561','S','Osceola','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.670601,-86.077419,0,'2013-07-06 12:44:32',NULL,NULL),(23013,'24823','S','Coal Mountain','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.669843,-81.729868,0,'2013-07-06 12:44:31',NULL,NULL),(28257,'31068','S','Ogelthorpe','N','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.293577,-84.068988,0,'2013-07-06 12:44:31',NULL,NULL),(53146,'61554','S','Pekin Mall','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(33725,'37810','S','Mohawk','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.181796,-83.093461,0,'2013-07-06 12:44:32',NULL,NULL),(36728,'41031','S','Morningglory','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(14063,'14589','S','Williamson','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.246564,-77.183230,0,'2013-07-06 12:44:31',NULL,NULL),(4898,'04055','S','Naples','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.943882,-70.591793,0,'2013-07-06 12:44:30',NULL,NULL),(28504,'31525','S','Thalman','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.233616,-81.501727,0,'2013-07-06 12:44:32',NULL,NULL),(11436,'11969','P','Southampton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.965942,-72.357568,0,'2013-07-06 12:44:30',NULL,NULL),(11709,'12168','S','Stephentown','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.560640,-73.451700,0,'2013-07-06 12:44:30',NULL,NULL),(15908,'17015','S','Carlisle','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.201481,-77.189072,0,'2013-07-06 12:44:31',NULL,NULL),(27816,'30401','S','Modoc','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(73343,'90899','U','La International Service Ctr','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.767496,-118.187712,0,'2013-07-06 12:44:34',NULL,NULL),(42258,'47579','S','Santa Claus','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.104943,-86.928717,0,'2013-07-06 12:44:32',NULL,NULL),(72482,'89128','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.196444,-115.296213,0,'2013-07-06 12:44:34',NULL,NULL),(237,'00631','P','Castaner','D','Lares','72081','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.180272,-66.832917,0,'2013-07-06 12:44:30',NULL,NULL),(70666,'85212','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.342880,-111.621592,0,'2013-07-06 12:44:34',NULL,NULL),(68628,'81633','S','Dinosaur','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.314931,-108.350141,0,'2013-07-06 12:44:34',NULL,NULL),(43233,'48314','S','St Heights','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.603554,-83.056445,0,'2013-07-06 12:44:32',NULL,NULL),(29383,'32610','U','University Medical Center','N','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.642276,-82.344949,0,'2013-07-06 12:44:32',NULL,NULL),(37180,'41501','S','Meta','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(34485,'38666','S','Pleasant Grove','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.437126,-89.917698,0,'2013-07-06 12:44:32',NULL,NULL),(27619,'30307','S','Little Five Points Pstl Str','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.769788,-84.328046,0,'2013-07-06 12:44:31',NULL,NULL),(34703,'38829','S','Pine Grove','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(20849,'21654','S','Oxford','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.686228,-76.169503,0,'2013-07-06 12:44:31',NULL,NULL),(45746,'52136','S','Cresco','D','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.376062,-92.114632,0,'2013-07-06 12:44:32',NULL,NULL),(24098,'26507','P','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.614238,-79.915841,0,'2013-07-06 12:44:31',NULL,NULL),(43685,'48877','S','Riverdale','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.401993,-84.838372,0,'2013-07-06 12:44:32',NULL,NULL),(39316,'44555','U','Youngstown State Univ','N','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.101415,-80.643558,0,'2013-07-06 12:44:32',NULL,NULL),(18929,'19504','S','Harlem','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(10419,'10707','S','Yonkers','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955489,-73.813597,0,'2013-07-06 12:44:30',NULL,NULL),(30928,'33710','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.788979,-82.729043,0,'2013-07-06 12:44:32',NULL,NULL),(67102,'79712','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.947125,-102.171522,0,'2013-07-06 12:44:34',NULL,NULL),(78512,'98116','S','West Seattle','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.575300,-122.395975,0,'2013-07-06 12:44:34',NULL,NULL),(74447,'92585','S','Menifee','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.749416,-117.174455,0,'2013-07-06 12:44:34',NULL,NULL),(58677,'68901','S','Spencer Park','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(64656,'76801','S','Indian Creek','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(18052,'18702','S','City of WB','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(64096,'76164','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.782966,-97.347496,0,'2013-07-06 12:44:34',NULL,NULL),(12969,'13367','S','Harrisburg','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(48711,'55946','S','Moland','N','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.271167,-92.988924,0,'2013-07-06 12:44:33',NULL,NULL),(12647,'13111','S','Martville','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.270080,-76.622400,0,'2013-07-06 12:44:30',NULL,NULL),(55772,'64116','S','North Kc','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(50367,'57754','S','Lead','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.350616,-103.768341,0,'2013-07-06 12:44:33',NULL,NULL),(9464,'10008','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(30949,'33731','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.708024,-82.676949,0,'2013-07-06 12:44:32',NULL,NULL),(23234,'25102','P','Handley','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.183415,-81.365717,0,'2013-07-06 12:44:31',NULL,NULL),(31734,'34984','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.275367,-80.347242,0,'2013-07-06 12:44:32',NULL,NULL),(79655,'99149','P','Malden','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.195997,-117.484252,0,'2013-07-06 12:44:34',NULL,NULL),(12726,'13158','S','Truxton','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695444,-76.014250,0,'2013-07-06 12:44:30',NULL,NULL),(44398,'49816','S','Chatham','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.288490,-86.760174,0,'2013-07-06 12:44:32',NULL,NULL),(37521,'42045','S','Grand Rivers','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.075980,-88.259940,0,'2013-07-06 12:44:32',NULL,NULL),(12085,'12563','S','Patterson','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.503033,-73.577046,0,'2013-07-06 12:44:30',NULL,NULL),(57372,'66743','S','Edison','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(73571,'91372','P','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.154498,-118.643170,0,'2013-07-06 12:44:34',NULL,NULL),(59576,'70891','U','Entergy Corp','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.449240,-91.154732,0,'2013-07-06 12:44:33',NULL,NULL),(74527,'92653','S','Laguna Woods','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.601535,-117.711678,0,'2013-07-06 12:44:34',NULL,NULL),(64194,'76245','S','Gordonville','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.857262,-96.807983,0,'2013-07-06 12:44:34',NULL,NULL),(18232,'18970','P','Trumbaversville','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.410255,-75.378287,0,'2013-07-06 12:44:31',NULL,NULL),(50157,'57551','S','Harrington','N','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.218780,-101.666700,0,'2013-07-06 12:44:33',NULL,NULL),(28613,'31706','P','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.579078,-84.156243,0,'2013-07-06 12:44:32',NULL,NULL),(20199,'20753','P','Forestville','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.858256,-76.887275,0,'2013-07-06 12:44:31',NULL,NULL),(14211,'14782','S','Sinclairville','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.275424,-79.244039,0,'2013-07-06 12:44:31',NULL,NULL),(32294,'35699','U','Master Charge','N','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.607691,-87.021300,0,'2013-07-06 12:44:32',NULL,NULL),(63002,'75156','S','Gun Barrel Cy','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295960,-96.118738,0,'2013-07-06 12:44:33',NULL,NULL),(56280,'65069','S','Rhineland','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757968,-91.534285,0,'2013-07-06 12:44:33',NULL,NULL),(54363,'62801','S','Suburban Heights','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(41784,'47306','U','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.200890,-85.407098,0,'2013-07-06 12:44:32',NULL,NULL),(36372,'40456','S','Disputanta','A','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.358415,-84.346235,0,'2013-07-06 12:44:32',NULL,NULL),(68596,'81601','S','Glenwood Springs','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.528426,-107.338503,0,'2013-07-06 12:44:34',NULL,NULL),(60439,'71646','S','Old Milo','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(41284,'46761','S','Fish Lake','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(70200,'84340','S','Willard','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.403126,-112.036100,0,'2013-07-06 12:44:34',NULL,NULL),(62395,'74104','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.149000,-95.953469,0,'2013-07-06 12:44:33',NULL,NULL),(24676,'27410','S','Friendship','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(25843,'28622','S','Heaton','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(10704,'11230','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.619153,-73.965619,0,'2013-07-06 12:44:30',NULL,NULL),(5991,'05353','S','Harmonyville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.064489,-72.668569,0,'2013-07-06 12:44:30',NULL,NULL),(30229,'33189','S','Cutler Ridge','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.568606,-80.342890,0,'2013-07-06 12:44:32',NULL,NULL),(40667,'46052','S','Ulen','A','Boone','18011','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.051603,-86.470531,0,'2013-07-06 12:44:32',NULL,NULL),(69988,'84121','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(68576,'81505','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.107861,-108.607362,0,'2013-07-06 12:44:34',NULL,NULL),(57376,'66743','S','Ringo','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(32842,'36482','S','Gosport','N','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.651737,-87.627073,0,'2013-07-06 12:44:32',NULL,NULL),(25404,'28288','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229166,-80.841138,0,'2013-07-06 12:44:31',NULL,NULL),(30130,'33163','P','Ojus','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.964602,-80.142184,0,'2013-07-06 12:44:32',NULL,NULL),(65937,'78254','S','Leon Valley','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.536152,-98.724160,0,'2013-07-06 12:44:34',NULL,NULL),(14561,'15214','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.481784,-80.018549,0,'2013-07-06 12:44:31',NULL,NULL),(35760,'39739','S','Deerbrook','N','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.234567,-88.580798,0,'2013-07-06 12:44:32',NULL,NULL),(28749,'31998','U','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.468275,-84.949281,0,'2013-07-06 12:44:32',NULL,NULL),(61869,'73126','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.457182,-97.490781,0,'2013-07-06 12:44:33',NULL,NULL),(57334,'66714','S','Roper','N','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.635924,-95.634951,0,'2013-07-06 12:44:33',NULL,NULL),(56884,'66031','S','New Century','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.813738,-94.929095,0,'2013-07-06 12:44:33',NULL,NULL),(25702,'28533','S','Havelock','A','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.878889,-76.901667,0,'2013-07-06 12:44:31',NULL,NULL),(74308,'92382','P','Running Springs','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.206744,-117.104968,0,'2013-07-06 12:44:34',NULL,NULL),(21166,'22151','S','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801146,-77.207526,0,'2013-07-06 12:44:31',NULL,NULL),(8517,'08105','S','Camden','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.948670,-75.087161,0,'2013-07-06 12:44:30',NULL,NULL),(63407,'75652','S','Lake Cherokee','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(66002,'78347','P','Chapman Ranch','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.635423,-97.453410,0,'2013-07-06 12:44:34',NULL,NULL),(112,'00612','S','Urb Regional','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(27363,'30065','P','Mar','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.047214,-84.442482,0,'2013-07-06 12:44:31',NULL,NULL),(4017,'02562','S','Sagamore Bch','A','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.794946,-70.527022,0,'2013-07-06 12:44:30',NULL,NULL),(77849,'97224','S','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.408703,-122.789445,0,'2013-07-06 12:44:34',NULL,NULL),(77664,'97024','S','Wood Village','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.539229,-122.437076,0,'2013-07-06 12:44:34',NULL,NULL),(76636,'95715','P','Alta','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.270480,-120.616200,0,'2013-07-06 12:44:34',NULL,NULL),(68371,'81140','S','Bountiful','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.308960,-106.035240,0,'2013-07-06 12:44:34',NULL,NULL),(33373,'37207','S','Northeast','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.222188,-86.773002,0,'2013-07-06 12:44:32',NULL,NULL),(12089,'12567','S','Gallatin','N','Dutchess','36027','New York','NY','36','2281','518','Eastern',-5.0,'Y',41.993160,-73.666740,0,'2013-07-06 12:44:30',NULL,NULL),(47388,'54635','S','Hixton','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.394000,-91.030320,0,'2013-07-06 12:44:32',NULL,NULL),(28063,'30683','S','Winterville','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.960174,-83.287969,0,'2013-07-06 12:44:31',NULL,NULL),(36357,'40447','S','Clover Bottom','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(61396,'72542','S','Hardy','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.256526,-91.538180,0,'2013-07-06 12:44:33',NULL,NULL),(4000,'02542','S','Otis Air National Guard','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.658720,-70.567260,0,'2013-07-06 12:44:30',NULL,NULL),(78444,'98059','S','Newcastle','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.483100,-122.129820,0,'2013-07-06 12:44:34',NULL,NULL),(79103,'98447','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.147030,-122.445643,0,'2013-07-06 12:44:34',NULL,NULL),(50657,'58327','S','Doyon','A','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.013856,-98.604066,0,'2013-07-06 12:44:33',NULL,NULL),(72955,'90042','S','Highland Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.118577,-118.189925,0,'2013-07-06 12:44:34',NULL,NULL),(31519,'34473','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.026127,-82.185636,0,'2013-07-06 12:44:32',NULL,NULL),(27415,'30098','U','Duluth','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.025560,-84.145413,0,'2013-07-06 12:44:31',NULL,NULL),(12245,'12824','S','Trout Lake','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.485300,-73.691940,0,'2013-07-06 12:44:30',NULL,NULL),(72698,'89448','P','Cave Rock','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(68069,'80936','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.906063,-104.753199,0,'2013-07-06 12:44:34',NULL,NULL),(41689,'47199','U','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285992,-85.732879,0,'2013-07-06 12:44:32',NULL,NULL),(39446,'44697','P','Zoar','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.614579,-81.423245,0,'2013-07-06 12:44:32',NULL,NULL),(34842,'38922','S','Bryant','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(25742,'28564','P','New Bern','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.074831,-77.022188,0,'2013-07-06 12:44:31',NULL,NULL),(24886,'27703','S','East Durham','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.973771,-78.838515,0,'2013-07-06 12:44:31',NULL,NULL),(63276,'75550','S','Annona','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.527852,-94.896667,0,'2013-07-06 12:44:33',NULL,NULL),(79303,'98590','S','North Cove','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.733820,-124.016700,0,'2013-07-06 12:44:34',NULL,NULL),(67916,'80905','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.836829,-104.837659,0,'2013-07-06 12:44:34',NULL,NULL),(33325,'37145','S','Pleasant Shade','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.353662,-85.902405,0,'2013-07-06 12:44:32',NULL,NULL),(68902,'82730','S','Upton','D','Weston','56045','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.076742,-104.695617,0,'2013-07-06 12:44:34',NULL,NULL),(14463,'15112','S','East Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403876,-79.837675,0,'2013-07-06 12:44:31',NULL,NULL),(70353,'84643','P','Mayfield','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.113088,-111.702993,0,'2013-07-06 12:44:34',NULL,NULL),(33389,'37219','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.167252,-86.786435,0,'2013-07-06 12:44:32',NULL,NULL),(41003,'46360','S','Trail Creek','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(71073,'85912','P','White Mountain Lake','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.322282,-110.075598,0,'2013-07-06 12:44:34',NULL,NULL),(6229,'05491','S','Basin Harbor','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(46610,'53566','S','Monroe','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.596735,-89.640073,0,'2013-07-06 12:44:32',NULL,NULL),(24367,'27052','S','Fulp','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.313380,-80.155080,0,'2013-07-06 12:44:31',NULL,NULL),(78266,'97850','S','La Grande','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.331036,-118.078078,0,'2013-07-06 12:44:34',NULL,NULL),(44020,'49405','S','Custer','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.927259,-86.201867,0,'2013-07-06 12:44:32',NULL,NULL),(61118,'72150','S','Sheridan','D','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.305789,-92.400260,0,'2013-07-06 12:44:33',NULL,NULL),(2257,'00926','S','Urb Monte Verde Real','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(73098,'90231','P','Culver City','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.999494,-118.391303,0,'2013-07-06 12:44:34',NULL,NULL),(66899,'79255','S','Quitaque','D','Briscoe','48045','Texas','TX','48','0000','806','Central',-6.0,'Y',34.363373,-101.053649,0,'2013-07-06 12:44:34',NULL,NULL),(58777,'68971','S','Republican City','D','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.100098,-99.231767,0,'2013-07-06 12:44:33',NULL,NULL),(21412,'22534','S','Partlow','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.080719,-77.678074,0,'2013-07-06 12:44:31',NULL,NULL),(43503,'48629','S','Houghton Lake','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.325299,-84.736993,0,'2013-07-06 12:44:32',NULL,NULL),(14470,'15122','S','Pittsburgh','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.377383,-79.892562,0,'2013-07-06 12:44:31',NULL,NULL),(53957,'62426','S','Laclede','A','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.921946,-88.664835,0,'2013-07-06 12:44:33',NULL,NULL),(30961,'33737','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742638,-82.719858,0,'2013-07-06 12:44:32',NULL,NULL),(42143,'47516','S','Bruceville','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.758593,-87.435699,0,'2013-07-06 12:44:32',NULL,NULL),(72239,'88515','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812281,-106.416248,0,'2013-07-06 12:44:34',NULL,NULL),(55024,'63135','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748900,-90.303899,0,'2013-07-06 12:44:33',NULL,NULL),(43416,'48463','S','Otisville','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.154524,-83.519011,0,'2013-07-06 12:44:32',NULL,NULL),(44384,'49801','S','Iron Mountain','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.817870,-88.066576,0,'2013-07-06 12:44:32',NULL,NULL),(46034,'52556','S','Glasgow','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(78163,'97627','S','Keno','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.127531,-121.964050,0,'2013-07-06 12:44:34',NULL,NULL),(56143,'64844','S','Granby','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.920210,-94.267372,0,'2013-07-06 12:44:33',NULL,NULL),(5083,'04330','S','Sidney','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.353599,-69.731361,0,'2013-07-06 12:44:30',NULL,NULL),(58961,'70009','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.008629,-90.163790,0,'2013-07-06 12:44:33',NULL,NULL),(76836,'95961','S','Plumas Lake','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.088781,-121.550818,0,'2013-07-06 12:44:34',NULL,NULL),(617,'00682','S','Alt de Mayaguez','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(5413,'04664','S','Sullivan','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.540556,-68.243611,0,'2013-07-06 12:44:30',NULL,NULL),(2407,'00953','S','Ciudad Jardin I','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(72861,'90004','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.076333,-118.307713,0,'2013-07-06 12:44:34',NULL,NULL),(9498,'10013','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(21799,'23084','S','Kents Store','D','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.862100,-78.043199,0,'2013-07-06 12:44:31',NULL,NULL),(49293,'56523','S','Climax','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.639460,-96.798660,0,'2013-07-06 12:44:33',NULL,NULL),(7002,'06254','S','North Franklin','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.618872,-72.143072,0,'2013-07-06 12:44:30',NULL,NULL),(44022,'49408','S','Fennville','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.567180,-86.126160,0,'2013-07-06 12:44:32',NULL,NULL),(51668,'59916','S','Essex','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.617497,-113.909544,0,'2013-07-06 12:44:33',NULL,NULL),(66435,'78644','S','Seawillow','N','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.879640,-97.666740,0,'2013-07-06 12:44:34',NULL,NULL),(62026,'73463','S','Rubottom','A','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.161452,-97.425765,0,'2013-07-06 12:44:33',NULL,NULL),(33823,'37922','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856420,-84.128340,0,'2013-07-06 12:44:32',NULL,NULL),(26290,'29021','P','Dusty Bend','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(49357,'56577','P','Richwood','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.938320,-95.862320,0,'2013-07-06 12:44:33',NULL,NULL),(50944,'58577','S','Washburn','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.318580,-101.017020,0,'2013-07-06 12:44:33',NULL,NULL),(67324,'80033','S','Wheat Ridge','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.772041,-105.101411,0,'2013-07-06 12:44:34',NULL,NULL),(66311,'78591','S','La Gloria','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.744100,-98.514780,0,'2013-07-06 12:44:34',NULL,NULL),(51457,'59489','S','Winifred','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.631387,-109.214912,0,'2013-07-06 12:44:33',NULL,NULL),(38222,'43221','S','Upper Arlngtn','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.014525,-83.068936,0,'2013-07-06 12:44:32',NULL,NULL),(21185,'22181','S','Vienna','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.898540,-77.291651,0,'2013-07-06 12:44:31',NULL,NULL),(1101,'00725','S','Urb Monticielo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(1155,'00727','S','Parq del Rio','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(2826,'00979','S','Urb Los Angeles','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(4752,'03844','S','Hampton Falls','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.924487,-70.885999,0,'2013-07-06 12:44:30',NULL,NULL),(17637,'18063','P','Martins Creek','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.782042,-75.187733,0,'2013-07-06 12:44:31',NULL,NULL),(75460,'94083','P','South San Francis','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.643644,-122.411982,0,'2013-07-06 12:44:34',NULL,NULL),(69747,'84047','S','Midvale','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.616513,-111.879899,0,'2013-07-06 12:44:34',NULL,NULL),(65113,'77373','S','Rayford','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.054630,-95.382975,0,'2013-07-06 12:44:34',NULL,NULL),(78906,'98362','S','Mount Pleasant','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(32521,'36088','S','Tuskegee University','N','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.413395,-85.721531,0,'2013-07-06 12:44:32',NULL,NULL),(44146,'49519','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.901059,-85.704730,0,'2013-07-06 12:44:32',NULL,NULL),(46967,'54208','S','Langes Corner','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.368075,-87.854079,0,'2013-07-06 12:44:32',NULL,NULL),(1750,'00778','S','Valle del Tesoro','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(59629,'71037','S','Haughton','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(53666,'62208','S','Fairview Heights','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.599660,-90.009909,0,'2013-07-06 12:44:33',NULL,NULL),(52504,'60714','S','Niles','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.027217,-87.813189,0,'2013-07-06 12:44:33',NULL,NULL),(38893,'44112','S','Cleveland Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.534374,-81.574679,0,'2013-07-06 12:44:32',NULL,NULL),(52060,'60204','P','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.057783,-87.695374,0,'2013-07-06 12:44:33',NULL,NULL),(21731,'23015','S','Beaverdam','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',38.008814,-77.648058,0,'2013-07-06 12:44:31',NULL,NULL),(29469,'32719','P','Winter Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.683684,-81.276404,0,'2013-07-06 12:44:32',NULL,NULL),(72244,'88520','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811333,-106.417046,0,'2013-07-06 12:44:34',NULL,NULL),(68361,'81136','S','Hooper','D','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.740979,-105.903868,0,'2013-07-06 12:44:34',NULL,NULL),(60963,'72104','S','Durian','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(36172,'40243','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(29940,'33068','S','Margate','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.216234,-80.216437,0,'2013-07-06 12:44:32',NULL,NULL),(45951,'52351','S','Walford','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.905945,-91.890838,0,'2013-07-06 12:44:32',NULL,NULL),(20409,'20904','S','Colesville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.065040,-76.981500,0,'2013-07-06 12:44:31',NULL,NULL),(39080,'44216','S','Clinton','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.938924,-81.580189,0,'2013-07-06 12:44:32',NULL,NULL),(54172,'62617','S','Bath','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.136329,-90.169770,0,'2013-07-06 12:44:33',NULL,NULL),(59595,'71008','S','Lucky','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(61490,'72641','S','Mossville','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.002568,-93.217954,0,'2013-07-06 12:44:33',NULL,NULL),(80189,'99903','P','Ketchikan','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.740000,-132.250000,0,'2013-07-06 12:44:34',NULL,NULL),(57928,'67674','P','Walker','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.865402,-99.076678,0,'2013-07-06 12:44:33',NULL,NULL),(34454,'38655','S','Lafayette Springs','N','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.350360,-89.518980,0,'2013-07-06 12:44:32',NULL,NULL),(18223,'18964','S','Telford','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.300323,-75.324550,0,'2013-07-06 12:44:31',NULL,NULL),(31191,'33935','S','Ft Denaud','A','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.634300,-81.341400,0,'2013-07-06 12:44:32',NULL,NULL),(45516,'51401','S','Willey','N','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.047220,-94.865160,0,'2013-07-06 12:44:32',NULL,NULL),(47436,'54720','S','Altoona','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.801507,-91.436012,0,'2013-07-06 12:44:32',NULL,NULL),(49360,'56580','S','Baker','A','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.774844,-96.655765,0,'2013-07-06 12:44:33',NULL,NULL),(56922,'66062','S','Olathe','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.840421,-94.781910,0,'2013-07-06 12:44:33',NULL,NULL),(70887,'85615','S','Hereford','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.402920,-110.207340,0,'2013-07-06 12:44:34',NULL,NULL),(56393,'65237','S','Lone Elm','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.787039,-92.799726,0,'2013-07-06 12:44:33',NULL,NULL),(53540,'62034','S','Glen Carbon','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.760540,-89.967660,0,'2013-07-06 12:44:33',NULL,NULL),(31195,'33936','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.615621,-81.616389,0,'2013-07-06 12:44:32',NULL,NULL),(53061,'61501','S','Astoria','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.227008,-90.353086,0,'2013-07-06 12:44:33',NULL,NULL),(18720,'19312','S','Berwyn','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.034377,-75.464176,0,'2013-07-06 12:44:31',NULL,NULL),(19375,'20060','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918639,-77.020382,0,'2013-07-06 12:44:31',NULL,NULL),(38782,'44055','S','Lorain','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.434380,-82.137420,0,'2013-07-06 12:44:32',NULL,NULL),(16756,'17516','S','Safe Harbor','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.925500,-76.366080,0,'2013-07-06 12:44:31',NULL,NULL),(55156,'63366','S','Dardenne Pr','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(66001,'78344','S','Bruni','D','Webb','48479','Texas','TX','48','4080','361','Central',-6.0,'Y',27.418495,-98.853745,0,'2013-07-06 12:44:34',NULL,NULL),(67725,'80543','S','Milliken','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.335711,-104.855069,0,'2013-07-06 12:44:34',NULL,NULL),(28720,'31903','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.425356,-84.945749,0,'2013-07-06 12:44:32',NULL,NULL),(69091,'83252','S','Woodruff','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(63094,'75261','P','DFW','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.873864,-96.965862,0,'2013-07-06 12:44:33',NULL,NULL),(13147,'13601','S','Glen Park','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.984440,-75.900540,0,'2013-07-06 12:44:30',NULL,NULL),(50116,'57501','S','Oahe','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(78526,'98126','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.549039,-122.376348,0,'2013-07-06 12:44:34',NULL,NULL),(58650,'68873','S','Cushing','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.234520,-98.450520,0,'2013-07-06 12:44:33',NULL,NULL),(76632,'95713','S','Iowa Hill','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(42893,'48096','S','Ray Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.761520,-82.927080,0,'2013-07-06 12:44:32',NULL,NULL),(21061,'21916','P','Childs','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.649206,-75.870953,0,'2013-07-06 12:44:31',NULL,NULL),(73854,'91901','S','Alpine','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.826938,-116.755318,0,'2013-07-06 12:44:34',NULL,NULL),(59231,'70427','S','Mitchell City','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(59015,'70072','S','Marrero','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.857680,-90.131160,0,'2013-07-06 12:44:33',NULL,NULL),(14330,'15001','S','MacArthur','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(25430,'28306','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.010174,-78.930528,0,'2013-07-06 12:44:31',NULL,NULL),(55771,'64116','S','North Kansas City','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(55463,'63740','S','Allenville','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.185720,-89.647920,0,'2013-07-06 12:44:33',NULL,NULL),(48214,'55412','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.026523,-93.303691,0,'2013-07-06 12:44:33',NULL,NULL),(51505,'59641','S','Radersburg','D','Broadwater','30007','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.200663,-111.631950,0,'2013-07-06 12:44:33',NULL,NULL),(11148,'11717','S','Brentwood','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.780920,-73.254540,0,'2013-07-06 12:44:30',NULL,NULL),(40609,'45895','S','Wapak','N','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.579383,-84.175552,0,'2013-07-06 12:44:32',NULL,NULL),(53877,'62347','S','Liberty','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.891780,-91.045020,0,'2013-07-06 12:44:33',NULL,NULL),(60204,'71419','S','Converse','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(60436,'71646','S','Hamburg','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(73952,'92060','P','Palomar Mountain','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.336039,-116.799561,0,'2013-07-06 12:44:34',NULL,NULL),(67467,'80221','S','Northglenn','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(56353,'65202','S','Murry','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(36153,'40241','S','Hills And Dales','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(8745,'08526','P','Imlaystown','D','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.164903,-74.496062,0,'2013-07-06 12:44:30',NULL,NULL),(56606,'65565','S','Berryman','A','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.968536,-91.358000,0,'2013-07-06 12:44:33',NULL,NULL),(66179,'78535','P','Combes','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.250563,-97.729406,0,'2013-07-06 12:44:34',NULL,NULL),(31675,'34769','S','Saint Cloud','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.248959,-81.295928,0,'2013-07-06 12:44:32',NULL,NULL),(40800,'46180','S','Stilesville','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.624430,-86.605019,0,'2013-07-06 12:44:32',NULL,NULL),(50064,'57442','S','Forest City','N','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.013247,-99.998682,0,'2013-07-06 12:44:33',NULL,NULL),(77721,'97063','S','Tygh Valley','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.236580,-121.322820,0,'2013-07-06 12:44:34',NULL,NULL),(77019,'96094','S','Edgewood','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.466318,-122.383688,0,'2013-07-06 12:44:34',NULL,NULL),(3147,'01258','S','Mount Washington','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.107580,-73.465080,0,'2013-07-06 12:44:30',NULL,NULL),(56175,'64999','U','Ks City','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.953479,-94.549666,0,'2013-07-06 12:44:33',NULL,NULL),(80164,'99821','P','Auke Bay','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.301944,-134.419722,0,'2013-07-06 12:44:34',NULL,NULL),(69348,'83541','S','Lenore','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.530058,-116.400502,0,'2013-07-06 12:44:34',NULL,NULL),(63603,'75797','U','Big Sandy','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.579684,-95.108732,0,'2013-07-06 12:44:34',NULL,NULL),(47047,'54411','S','Milan','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.034525,-90.084577,0,'2013-07-06 12:44:32',NULL,NULL),(17796,'18360','S','Stroudsburg','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.990640,-75.226300,0,'2013-07-06 12:44:31',NULL,NULL),(12194,'12779','S','S Fallsburg','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.709537,-74.635185,0,'2013-07-06 12:44:30',NULL,NULL),(4200,'02828','S','Smithfield','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.874239,-71.552403,0,'2013-07-06 12:44:30',NULL,NULL),(17074,'17758','S','N Mountain','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(33411,'37235','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.148097,-86.805447,0,'2013-07-06 12:44:32',NULL,NULL),(49366,'56584','S','Faith','N','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.284811,-96.264019,0,'2013-07-06 12:44:33',NULL,NULL),(74726,'93033','S','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.168245,-119.165670,0,'2013-07-06 12:44:34',NULL,NULL),(64479,'76596','U','Lane Murray Prison','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.489084,-97.737219,0,'2013-07-06 12:44:34',NULL,NULL),(30133,'33164','P','North Miami Bch','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.929334,-80.176758,0,'2013-07-06 12:44:32',NULL,NULL),(20377,'20882','S','Laytonsville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.215201,-77.141552,0,'2013-07-06 12:44:31',NULL,NULL),(30573,'33414','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(41944,'47394','S','Rural','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.175183,-84.976721,0,'2013-07-06 12:44:32',NULL,NULL),(51595,'59812','U','Univ Of Mt Missoula','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858954,-113.986470,0,'2013-07-06 12:44:33',NULL,NULL),(30572,'33414','S','Wellington','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(30848,'33637','S','Temple Terr','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.032275,-82.365111,0,'2013-07-06 12:44:32',NULL,NULL),(190,'00623','S','Urb Alta Vista','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(16344,'17130','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.273135,-76.888847,0,'2013-07-06 12:44:31',NULL,NULL),(43346,'48381','S','Milford Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.574828,-83.594968,0,'2013-07-06 12:44:32',NULL,NULL),(55229,'63436','S','Madisonville','N','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.506337,-91.532429,0,'2013-07-06 12:44:33',NULL,NULL),(12351,'12885','S','Riverbank','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.500656,-73.787701,0,'2013-07-06 12:44:30',NULL,NULL),(25683,'28519','P','Bridgeton','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.122069,-77.020064,0,'2013-07-06 12:44:31',NULL,NULL),(79044,'98407','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.283011,-122.504689,0,'2013-07-06 12:44:34',NULL,NULL),(75757,'94615','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.808231,-122.298981,0,'2013-07-06 12:44:34',NULL,NULL),(12502,'13021','S','Fosterville','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(49045,'56292','S','Vesta','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.497090,-95.410520,0,'2013-07-06 12:44:33',NULL,NULL),(41392,'46805','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.099088,-85.115003,0,'2013-07-06 12:44:32',NULL,NULL),(26072,'28697','S','Wilkesboro','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.138201,-81.157500,0,'2013-07-06 12:44:31',NULL,NULL),(69317,'83466','S','North Fork','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.379133,-113.867936,0,'2013-07-06 12:44:34',NULL,NULL),(34607,'38749','P','Holly Ridge','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.450833,-90.655000,0,'2013-07-06 12:44:32',NULL,NULL),(7093,'06355','S','Masons Island','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.358669,-71.979179,0,'2013-07-06 12:44:30',NULL,NULL),(71132,'86022','S','Pipe Spring National Monumen','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(70792,'85358','P','Wickenburg','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.963139,-112.746885,0,'2013-07-06 12:44:34',NULL,NULL),(242,'00637','S','Ext San Jose 2','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(64032,'76123','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.625915,-97.368031,0,'2013-07-06 12:44:34',NULL,NULL),(6578,'05855','S','The Bluffs','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(50736,'58386','S','Baker','A','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.329524,-99.526269,0,'2013-07-06 12:44:33',NULL,NULL),(29685,'32925','S','Patrick Air Force Base','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.229987,-80.623528,0,'2013-07-06 12:44:32',NULL,NULL),(17248,'17839','P','Lightstreet','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.036100,-76.423800,0,'2013-07-06 12:44:31',NULL,NULL),(53284,'61727','S','Clinton','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(57650,'67204','S','Park City','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.752075,-97.357444,0,'2013-07-06 12:44:33',NULL,NULL),(49198,'56448','S','Fifty Lakes','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.801710,-94.017035,0,'2013-07-06 12:44:33',NULL,NULL),(74571,'92688','S','Rcho Sta Marg','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.651232,-117.593834,0,'2013-07-06 12:44:34',NULL,NULL),(1065,'00725','S','Hacienda Borinquen','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(35460,'39501','S','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.385481,-89.086881,0,'2013-07-06 12:44:32',NULL,NULL),(30035,'33141','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(52482,'60693','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879153,-87.612931,0,'2013-07-06 12:44:33',NULL,NULL),(43392,'48439','S','Gr Blanc','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.926659,-83.638011,0,'2013-07-06 12:44:32',NULL,NULL),(12381,'12917','S','Burke','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.926563,-74.176701,0,'2013-07-06 12:44:30',NULL,NULL),(46109,'52632','S','Sandusky','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.472778,-91.448611,0,'2013-07-06 12:44:32',NULL,NULL),(12850,'13317','S','Canajoharie','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(20207,'20758','S','Friendship','D','Anne Arundel','24003','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',38.737232,-76.593800,0,'2013-07-06 12:44:31',NULL,NULL),(63792,'75959','S','Geneva','A','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.481280,-93.838320,0,'2013-07-06 12:44:34',NULL,NULL),(55136,'63352','S','Laddonia','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.242116,-91.642579,0,'2013-07-06 12:44:33',NULL,NULL),(52929,'61373','S','Utica','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.386940,-88.997371,0,'2013-07-06 12:44:33',NULL,NULL),(52561,'60955','S','Onarga','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.720202,-87.994605,0,'2013-07-06 12:44:33',NULL,NULL),(37304,'41636','S','Hi Hat','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.390254,-82.729050,0,'2013-07-06 12:44:32',NULL,NULL),(39185,'44317','U','Firestone Tire & Rub Co','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.045074,-81.526198,0,'2013-07-06 12:44:32',NULL,NULL),(35840,'39776','S','Anchor','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.794434,-89.053443,0,'2013-07-06 12:44:32',NULL,NULL),(26118,'28728','P','Enka Village','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.541407,-82.643640,0,'2013-07-06 12:44:31',NULL,NULL),(23601,'25692','P','Red Jacket','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.647797,-82.133788,0,'2013-07-06 12:44:31',NULL,NULL),(6189,'05479','U','Us Citizenship & Immigration','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.812060,-73.082760,0,'2013-07-06 12:44:30',NULL,NULL),(23846,'26137','S','Big Springs','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.002820,-81.073980,0,'2013-07-06 12:44:31',NULL,NULL),(42443,'47805','S','Progress Acres','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(37710,'42265','S','Olmstead','D','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.723367,-86.991472,0,'2013-07-06 12:44:32',NULL,NULL),(27205,'29906','S','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.432733,-80.673074,0,'2013-07-06 12:44:31',NULL,NULL),(2986,'01062','S','Bay State Village','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.331578,-72.692571,0,'2013-07-06 12:44:30',NULL,NULL),(41362,'46793','S','Waterloo','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.426955,-85.022802,0,'2013-07-06 12:44:32',NULL,NULL),(9785,'10107','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(9079,'09013','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58954,'69367','S','Whitney','D','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.739218,-103.225707,0,'2013-07-06 12:44:33',NULL,NULL),(74330,'92402','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.078958,-117.462404,0,'2013-07-06 12:44:34',NULL,NULL),(43757,'49015','S','Springfield','A','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.301020,-85.229100,0,'2013-07-06 12:44:32',NULL,NULL),(27186,'29851','S','Burnettown','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.518108,-81.820849,0,'2013-07-06 12:44:31',NULL,NULL),(29922,'33062','S','Laud By The Sea','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.234821,-80.093841,0,'2013-07-06 12:44:32',NULL,NULL),(44974,'50420','S','Alexander','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.819827,-93.439648,0,'2013-07-06 12:44:32',NULL,NULL),(27681,'30333','P','Druid Hills','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.795743,-84.323393,0,'2013-07-06 12:44:31',NULL,NULL),(33215,'37052','S','Cunningham','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.381179,-87.408352,0,'2013-07-06 12:44:32',NULL,NULL),(76370,'95511','S','Alderpoint','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.159508,-123.581713,0,'2013-07-06 12:44:34',NULL,NULL),(72011,'88042','S','Hillsboro','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.916944,-107.705556,0,'2013-07-06 12:44:34',NULL,NULL),(61585,'72751','S','Pea Ridge','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.447789,-94.115116,0,'2013-07-06 12:44:33',NULL,NULL),(54447,'62848','P','Irvington','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.438762,-89.164269,0,'2013-07-06 12:44:33',NULL,NULL),(51511,'59647','P','Winston','D','Broadwater','30007','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.363288,-111.641755,0,'2013-07-06 12:44:33',NULL,NULL),(9529,'10019','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(62727,'74820','S','Ada','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.771920,-96.679980,0,'2013-07-06 12:44:33',NULL,NULL),(2995,'01066','P','No Hatfield','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.410613,-72.625559,0,'2013-07-06 12:44:30',NULL,NULL),(48087,'55336','S','Biscay','A','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.771232,-94.149805,0,'2013-07-06 12:44:33',NULL,NULL),(34996,'39114','S','Mendenhall','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.962304,-89.873649,0,'2013-07-06 12:44:32',NULL,NULL),(24639,'27371','S','Queen','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(16556,'17311','P','Codorus','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.822382,-76.843590,0,'2013-07-06 12:44:31',NULL,NULL),(33469,'37330','S','Estill Springs','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.272280,-86.128690,0,'2013-07-06 12:44:32',NULL,NULL),(22469,'24043','U','Norfolk Southern Rwy Brm','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270171,-79.922058,0,'2013-07-06 12:44:31',NULL,NULL),(33605,'37641','S','Chuckey','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.151291,-82.610467,0,'2013-07-06 12:44:32',NULL,NULL),(65408,'77566','S','Richwood','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.041532,-95.444189,0,'2013-07-06 12:44:34',NULL,NULL),(61837,'73115','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.438660,-97.439577,0,'2013-07-06 12:44:33',NULL,NULL),(38685,'43974','P','Harrisville','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.179904,-80.884655,0,'2013-07-06 12:44:32',NULL,NULL),(1513,'00754','S','Ext Tamarindo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(42644,'47929','S','Chalmers','D','White','18181','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.662213,-86.862460,0,'2013-07-06 12:44:32',NULL,NULL),(64779,'77005','S','Southside Place','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.718966,-95.421416,0,'2013-07-06 12:44:34',NULL,NULL),(74028,'92134','U','Naval Hospital','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.727421,-117.147060,0,'2013-07-06 12:44:34',NULL,NULL),(73284,'90747','U','C S U Dom Hls','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.866528,-118.253036,0,'2013-07-06 12:44:34',NULL,NULL),(71348,'86514','S','Teec Nos Pos','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750658,-109.364054,0,'2013-07-06 12:44:34',NULL,NULL),(52921,'61369','S','Pattonsburg','N','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.004179,-89.126813,0,'2013-07-06 12:44:33',NULL,NULL),(38708,'44004','S','Plymouth Twp','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.850540,-80.777400,0,'2013-07-06 12:44:32',NULL,NULL),(47344,'54601','S','Shelby','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.795836,-91.221089,0,'2013-07-06 12:44:32',NULL,NULL),(40543,'45845','S','Ft Loramie','N','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.327233,-84.374535,0,'2013-07-06 12:44:32',NULL,NULL),(59699,'71082','S','Trees','A','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.862552,-93.989497,0,'2013-07-06 12:44:33',NULL,NULL),(43102,'48217','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.276563,-83.152089,0,'2013-07-06 12:44:32',NULL,NULL),(66501,'78681','S','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.513382,-97.712018,0,'2013-07-06 12:44:34',NULL,NULL),(31304,'34101','P','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.138693,-81.797096,0,'2013-07-06 12:44:32',NULL,NULL),(19878,'20531','U','Law Enforce Assist Adm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895714,-77.019633,0,'2013-07-06 12:44:31',NULL,NULL),(23489,'25514','S','Glenhayes','A','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.118046,-82.596913,0,'2013-07-06 12:44:31',NULL,NULL),(39258,'44444','S','Newton Falls','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.185982,-80.967610,0,'2013-07-06 12:44:32',NULL,NULL),(40804,'46181','S','Trafalgar','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.365002,-86.183378,0,'2013-07-06 12:44:32',NULL,NULL),(25839,'28622','S','Cranberry','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(43389,'48436','S','Gaines','D','Genesee','26049','Michigan','MI','26','2640','989','Eastern',-5.0,'Y',42.866091,-83.875450,0,'2013-07-06 12:44:32',NULL,NULL),(19244,'19934','S','Camden Wyoming','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(32479,'36045','P','Kent','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.618799,-85.949542,0,'2013-07-06 12:44:32',NULL,NULL),(27103,'29722','U','Hosiery Corp of America','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.749579,-80.720816,0,'2013-07-06 12:44:31',NULL,NULL),(17614,'18044','P','Easton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.684630,-75.222380,0,'2013-07-06 12:44:31',NULL,NULL),(30324,'33307','P','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181193,-80.277948,0,'2013-07-06 12:44:32',NULL,NULL),(79670,'99161','S','Palouse','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.912803,-117.074810,0,'2013-07-06 12:44:34',NULL,NULL),(67315,'80024','P','Dupont','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.846218,-104.919442,0,'2013-07-06 12:44:34',NULL,NULL),(71461,'87052','S','Kewa','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.533365,-106.392193,0,'2013-07-06 12:44:34',NULL,NULL),(64068,'76137','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.859978,-97.293430,0,'2013-07-06 12:44:34',NULL,NULL),(73110,'90250','S','Holly Park','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.915300,-118.351309,0,'2013-07-06 12:44:34',NULL,NULL),(76562,'95668','S','Pleasant Grove','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.821488,-121.507596,0,'2013-07-06 12:44:34',NULL,NULL),(65435,'77586','S','El Lago','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(7539,'07008','S','West Carteret','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.584894,-74.234297,0,'2013-07-06 12:44:30',NULL,NULL),(60223,'71427','S','Pine Coupee','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.389387,-92.875928,0,'2013-07-06 12:44:33',NULL,NULL),(60194,'71418','S','Columbia Heights','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(28913,'32142','P','Palm Coast','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.480136,-81.216354,0,'2013-07-06 12:44:32',NULL,NULL),(17497,'17961','S','Drehersville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(2898,'00987','S','Urb Los Arboles','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(44972,'50401','S','Winnebago Heights','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(30630,'33442','S','Deerfield Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.308884,-80.140867,0,'2013-07-06 12:44:32',NULL,NULL),(29396,'32621','S','Bronson','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.453446,-82.635481,0,'2013-07-06 12:44:32',NULL,NULL),(60044,'71345','P','Rosa','A','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.733570,-91.976292,0,'2013-07-06 12:44:33',NULL,NULL),(79987,'99659','P','Saint Michael','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.278964,-161.772514,0,'2013-07-06 12:44:34',NULL,NULL),(66526,'78717','S','Brushy Creek','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.503015,-97.742252,0,'2013-07-06 12:44:34',NULL,NULL),(60587,'71827','S','Buckner','D','Lafayette','05073','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.367353,-93.446445,0,'2013-07-06 12:44:33',NULL,NULL),(39712,'45050','S','Liberty Twp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.446195,-84.369751,0,'2013-07-06 12:44:32',NULL,NULL),(39453,'44705','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.822094,-81.338111,0,'2013-07-06 12:44:32',NULL,NULL),(46715,'53804','S','Bloomington','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.874775,-90.912124,0,'2013-07-06 12:44:32',NULL,NULL),(8239,'08002','S','Erlton','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.933589,-75.018781,0,'2013-07-06 12:44:30',NULL,NULL),(49312,'56542','S','Fosston','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.579072,-95.751821,0,'2013-07-06 12:44:33',NULL,NULL),(34259,'38454','S','Duck River','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.696303,-87.340851,0,'2013-07-06 12:44:32',NULL,NULL),(16567,'17315','S','Dover','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.013820,-76.815840,0,'2013-07-06 12:44:31',NULL,NULL),(23641,'25775','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.413131,-82.473204,0,'2013-07-06 12:44:31',NULL,NULL),(70049,'84138','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.752433,-111.880834,0,'2013-07-06 12:44:34',NULL,NULL),(72322,'89004','P','Old Nevada','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.077647,-115.414058,0,'2013-07-06 12:44:34',NULL,NULL),(37030,'41255','S','Sitka','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.886311,-82.846592,0,'2013-07-06 12:44:32',NULL,NULL),(2659,'00966','S','Urb Garden Hls Villas','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(14434,'15084','S','Tarentum','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.607623,-79.775387,0,'2013-07-06 12:44:31',NULL,NULL),(29008,'32224','S','Atlantic Beach','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.275858,-81.461221,0,'2013-07-06 12:44:32',NULL,NULL),(35179,'39272','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.216828,-90.269123,0,'2013-07-06 12:44:32',NULL,NULL),(48305,'55441','S','Plymouth','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.004561,-93.426516,0,'2013-07-06 12:44:33',NULL,NULL),(58050,'68030','S','Homer','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.321130,-96.493233,0,'2013-07-06 12:44:33',NULL,NULL),(44327,'49753','S','Lachine','D','Alpena','26007','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.057363,-83.747507,0,'2013-07-06 12:44:32',NULL,NULL),(68189,'81027','S','Branson','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.132345,-103.773649,0,'2013-07-06 12:44:34',NULL,NULL),(78830,'98335','S','Pt Fosdick','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(72560,'89310','S','Austin','D','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.738476,-117.193253,0,'2013-07-06 12:44:34',NULL,NULL),(65087,'77355','S','Decker Prairie','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.151734,-95.743252,0,'2013-07-06 12:44:34',NULL,NULL),(45174,'50603','S','Alta Vista','D','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.148786,-92.435782,0,'2013-07-06 12:44:32',NULL,NULL),(23593,'25678','S','Lobata','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649769,-82.126194,0,'2013-07-06 12:44:31',NULL,NULL),(29379,'32607','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.643647,-82.414335,0,'2013-07-06 12:44:32',NULL,NULL),(27875,'30448','P','Nunez','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.489470,-82.349001,0,'2013-07-06 12:44:31',NULL,NULL),(17025,'17745','S','Farrandsville','A','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(37539,'42055','S','Kuttawa','D','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.058468,-88.128269,0,'2013-07-06 12:44:32',NULL,NULL),(5196,'04449','S','Hudson','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.944137,-68.941477,0,'2013-07-06 12:44:30',NULL,NULL),(8438,'08083','S','Hi Nella','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.843005,-75.031535,0,'2013-07-06 12:44:30',NULL,NULL),(24224,'26720','S','Gormania','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.246694,-79.352749,0,'2013-07-06 12:44:31',NULL,NULL),(24922,'27806','S','Royal','N','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.301628,-76.789234,0,'2013-07-06 12:44:31',NULL,NULL),(43798,'49057','S','Hartford','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.194050,-86.170158,0,'2013-07-06 12:44:32',NULL,NULL),(19474,'20142','P','Round Hill','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.135038,-77.771792,0,'2013-07-06 12:44:31',NULL,NULL),(36395,'40504','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.039789,-84.537499,0,'2013-07-06 12:44:32',NULL,NULL),(16292,'17106','P','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.233872,-76.819088,0,'2013-07-06 12:44:31',NULL,NULL),(46806,'54004','S','Arland','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.330762,-92.170455,0,'2013-07-06 12:44:32',NULL,NULL),(45214,'50633','S','Geneva','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.676333,-93.131752,0,'2013-07-06 12:44:32',NULL,NULL),(35564,'39567','S','Helena','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(8754,'08533','S','Plumsted Township','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.083333,-74.500000,0,'2013-07-06 12:44:30',NULL,NULL),(25834,'28618','S','Meadow Creek','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.192222,-81.529594,0,'2013-07-06 12:44:31',NULL,NULL),(37833,'42450','S','Providence','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.400598,-87.755019,0,'2013-07-06 12:44:32',NULL,NULL),(30591,'33419','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.781477,-80.092135,0,'2013-07-06 12:44:32',NULL,NULL),(33371,'37206','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.180628,-86.735521,0,'2013-07-06 12:44:32',NULL,NULL),(34732,'38849','S','Alma','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(67871,'80831','S','Peyton','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.989980,-104.505180,0,'2013-07-06 12:44:34',NULL,NULL),(63448,'75680','P','Henderson','A','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.147707,-94.798976,0,'2013-07-06 12:44:33',NULL,NULL),(66229,'78565','P','Curvitas','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.314051,-98.391367,0,'2013-07-06 12:44:34',NULL,NULL),(23031,'24847','P','Itmann','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.574439,-81.419907,0,'2013-07-06 12:44:31',NULL,NULL),(13500,'13806','S','Meridale','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.376987,-74.975118,0,'2013-07-06 12:44:31',NULL,NULL),(22794,'24465','S','Monterey','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.379939,-79.640160,0,'2013-07-06 12:44:31',NULL,NULL),(9448,'10006','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(20683,'21237','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.340320,-76.505100,0,'2013-07-06 12:44:31',NULL,NULL),(59774,'71201','S','Northeast','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(22622,'24228','S','Clintwood','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.152022,-82.458909,0,'2013-07-06 12:44:31',NULL,NULL),(15127,'15827','S','Byrnedale','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.294787,-78.504460,0,'2013-07-06 12:44:31',NULL,NULL),(49199,'56449','S','Fort Ripley','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.204333,-94.228316,0,'2013-07-06 12:44:33',NULL,NULL),(51741,'60015','S','Bannockburn','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.172896,-87.878422,0,'2013-07-06 12:44:33',NULL,NULL),(78467,'98075','S','Issaquah','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.586461,-122.030567,0,'2013-07-06 12:44:34',NULL,NULL),(61747,'73041','S','Gotebo','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.070239,-98.869719,0,'2013-07-06 12:44:33',NULL,NULL),(40926,'46278','S','Traders Point','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.883333,-86.238611,0,'2013-07-06 12:44:32',NULL,NULL),(1608,'00769','S','Urb Provincias Del Rio 1','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(22747,'24411','P','Augusta Sprgs','A','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.104025,-79.318835,0,'2013-07-06 12:44:31',NULL,NULL),(49905,'57279','S','Sodak Park','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.414998,-96.867332,0,'2013-07-06 12:44:33',NULL,NULL),(32504,'36068','P','Pville','N','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.461221,-86.444633,0,'2013-07-06 12:44:32',NULL,NULL),(48387,'55575','P','Howard Lake','D','Hennepin','27053','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.057284,-94.067372,0,'2013-07-06 12:44:33',NULL,NULL),(17100,'17768','S','Fox','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.533107,-76.746568,0,'2013-07-06 12:44:31',NULL,NULL),(1535,'00757','S','Bda San Felipe','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(44222,'49645','S','Kaleva','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.365346,-86.038719,0,'2013-07-06 12:44:32',NULL,NULL),(55219,'63401','S','West Ely','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(1781,'00782','S','Urb La Plata','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(76690,'95820','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.532877,-121.449044,0,'2013-07-06 12:44:34',NULL,NULL),(72569,'89317','P','Lund','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.908148,-115.133606,0,'2013-07-06 12:44:34',NULL,NULL),(52826,'61301','S','Tomahawk Bluff','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.355630,-89.094865,0,'2013-07-06 12:44:33',NULL,NULL),(45879,'52253','S','Sutliff','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.916168,-91.383473,0,'2013-07-06 12:44:32',NULL,NULL),(72023,'88047','S','Mesilla Park','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.239260,-106.735038,0,'2013-07-06 12:44:34',NULL,NULL),(67979,'80915','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.856009,-104.716668,0,'2013-07-06 12:44:34',NULL,NULL),(67292,'80012','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.694487,-104.832515,0,'2013-07-06 12:44:34',NULL,NULL),(55093,'63301','S','South Shore','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(38152,'43146','S','Orient','D','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.771545,-83.148051,0,'2013-07-06 12:44:32',NULL,NULL),(52865,'61334','S','Lostant','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.141825,-89.080670,0,'2013-07-06 12:44:33',NULL,NULL),(73767,'91735','U','El Monte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.074913,-118.028045,0,'2013-07-06 12:44:34',NULL,NULL),(73524,'91346','P','Mission Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.267980,-118.466280,0,'2013-07-06 12:44:34',NULL,NULL),(68264,'81069','S','Rye','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.927576,-104.902916,0,'2013-07-06 12:44:34',NULL,NULL),(14739,'15311','S','Amity','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.031825,-80.191660,0,'2013-07-06 12:44:31',NULL,NULL),(42077,'47454','S','Paoli','D','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(2132,'00924','S','Urb Club Manor','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(11129,'11706','S','N Bay Shore','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(68296,'81091','S','Monument Lake Park','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(14500,'15146','S','Monroeville','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425925,-79.764398,0,'2013-07-06 12:44:31',NULL,NULL),(16790,'17536','S','Kirkwood','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.849151,-76.087262,0,'2013-07-06 12:44:31',NULL,NULL),(7044,'06277','S','Thompson','D','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',41.977800,-71.847180,0,'2013-07-06 12:44:30',NULL,NULL),(20309,'20815','S','Somerset','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(8367,'08053','S','Evesham Twp','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(58526,'68788','S','West Point','D','Cuming','31039','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.841621,-96.709733,0,'2013-07-06 12:44:33',NULL,NULL),(55336,'63552','S','Macon','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738606,-92.473253,0,'2013-07-06 12:44:33',NULL,NULL),(79285,'98579','S','Rochester','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.824952,-123.052537,0,'2013-07-06 12:44:34',NULL,NULL),(71783,'87558','P','Red River','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.731350,-105.591316,0,'2013-07-06 12:44:34',NULL,NULL),(57601,'67109','S','Mullinville','D','Kiowa','20097','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.588569,-99.459868,0,'2013-07-06 12:44:33',NULL,NULL),(8852,'08646','U','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217893,-74.763424,0,'2013-07-06 12:44:30',NULL,NULL),(36053,'40207','S','Druid Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(45586,'51543','S','Kimballton','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.644191,-95.032404,0,'2013-07-06 12:44:32',NULL,NULL),(73683,'91602','S','West Toluca Lake','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(1865,'00791','S','Repto San Felipe','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(68921,'82842','S','Story','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.578395,-106.899253,0,'2013-07-06 12:44:34',NULL,NULL),(68704,'82059','P','Harriman','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.017795,-105.249499,0,'2013-07-06 12:44:34',NULL,NULL),(6817,'06111','S','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688552,-72.729085,0,'2013-07-06 12:44:30',NULL,NULL),(20263,'20784','S','Lanham','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(44683,'50125','S','Cool','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.315040,-93.572040,0,'2013-07-06 12:44:32',NULL,NULL),(41014,'46373','S','St John','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.451569,-87.476665,0,'2013-07-06 12:44:32',NULL,NULL),(26949,'29603','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.850619,-82.396693,0,'2013-07-06 12:44:31',NULL,NULL),(31311,'34107','P','Vanderbilt','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.269597,-81.791672,0,'2013-07-06 12:44:32',NULL,NULL),(34461,'38659','S','Potts Camp','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(53589,'62069','S','White City','N','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.072236,-89.724462,0,'2013-07-06 12:44:33',NULL,NULL),(69446,'83647','S','Mt Home','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(79142,'98501','S','Oly','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(70123,'84199','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725101,-111.939531,0,'2013-07-06 12:44:34',NULL,NULL),(59340,'70548','S','Kaplan','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.005479,-92.282679,0,'2013-07-06 12:44:33',NULL,NULL),(50891,'58535','S','Lark','A','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.466520,-101.178960,0,'2013-07-06 12:44:33',NULL,NULL),(11936,'12432','P','Glasco','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.018530,-73.961443,0,'2013-07-06 12:44:30',NULL,NULL),(9512,'10016','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(27050,'29673','S','Powdersville','A','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.675130,-82.534256,0,'2013-07-06 12:44:31',NULL,NULL),(4641,'03741','S','Orange','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.663654,-72.004386,0,'2013-07-06 12:44:30',NULL,NULL),(71018,'85730','S','Rincon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.177877,-110.803001,0,'2013-07-06 12:44:34',NULL,NULL),(12367,'12911','S','Au Sable Chasm','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.533729,-73.500290,0,'2013-07-06 12:44:30',NULL,NULL),(60725,'71956','S','Mt Pine','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.584960,-93.156960,0,'2013-07-06 12:44:33',NULL,NULL),(58423,'68655','S','Primrose','D','Boone','31011','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.644973,-98.235707,0,'2013-07-06 12:44:33',NULL,NULL),(32317,'35762','P','Alabama A and M','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.792912,-86.569000,0,'2013-07-06 12:44:32',NULL,NULL),(34648,'38771','S','Ruleville','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.721184,-90.544563,0,'2013-07-06 12:44:32',NULL,NULL),(1719,'00778','S','Gurabo','D','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(11919,'12417','P','Connelly','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.911892,-73.994188,0,'2013-07-06 12:44:30',NULL,NULL),(31087,'33867','S','River Ranch','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.884462,-81.479590,0,'2013-07-06 12:44:32',NULL,NULL),(3226,'01370','S','East Charlemont','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.583380,-72.771540,0,'2013-07-06 12:44:30',NULL,NULL),(36982,'41183','S','Worthington','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.550451,-82.732082,0,'2013-07-06 12:44:32',NULL,NULL),(26232,'28805','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.594556,-82.501708,0,'2013-07-06 12:44:31',NULL,NULL),(12992,'13409','S','Munnsville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.950700,-75.568980,0,'2013-07-06 12:44:30',NULL,NULL),(123,'00612','S','Villa Los Santos','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(80112,'99759','P','Point Lay','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',69.538747,-163.247629,0,'2013-07-06 12:44:34',NULL,NULL),(73061,'90094','S','Los Angeles','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.974553,-118.425643,0,'2013-07-06 12:44:34',NULL,NULL),(14649,'15236','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(63708,'75902','P','Lufkin','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.322803,-94.801068,0,'2013-07-06 12:44:34',NULL,NULL),(40839,'46218','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.809206,-86.103073,0,'2013-07-06 12:44:32',NULL,NULL),(5218,'04460','S','Soldiertown','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.617950,-68.497973,0,'2013-07-06 12:44:30',NULL,NULL),(15699,'16850','S','Lecontes Mills','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.081857,-78.280359,0,'2013-07-06 12:44:31',NULL,NULL),(28378,'31296','U','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.808701,-83.569496,0,'2013-07-06 12:44:32',NULL,NULL),(76474,'95623','S','El Dorado','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.672790,-120.847975,0,'2013-07-06 12:44:34',NULL,NULL),(71317,'86505','S','Kin-Li-Chee','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(53552,'62046','P','Hamel','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.889943,-89.846942,0,'2013-07-06 12:44:33',NULL,NULL),(70736,'85307','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538998,-112.347366,0,'2013-07-06 12:44:34',NULL,NULL),(63577,'75778','S','Leagueville','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.332800,-95.773080,0,'2013-07-06 12:44:34',NULL,NULL),(52194,'60474','P','East Brooklyn','N','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.173333,-88.263889,0,'2013-07-06 12:44:33',NULL,NULL),(74946,'93410','S','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.276728,-120.737489,0,'2013-07-06 12:44:34',NULL,NULL),(12984,'13406','S','Middleville','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.139808,-74.969563,0,'2013-07-06 12:44:30',NULL,NULL),(71703,'87523','P','Cordova','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.025520,-105.771929,0,'2013-07-06 12:44:34',NULL,NULL),(30230,'33189','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.568606,-80.342890,0,'2013-07-06 12:44:32',NULL,NULL),(47045,'54411','S','Athens','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.034525,-90.084577,0,'2013-07-06 12:44:32',NULL,NULL),(53237,'61643','U','Peoria Journal Star','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.724136,-89.556863,0,'2013-07-06 12:44:33',NULL,NULL),(51794,'60046','S','Old Mill Creek','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(62263,'74010','S','Edna','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.831459,-96.387712,0,'2013-07-06 12:44:33',NULL,NULL),(58391,'68621','S','Ames','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.460139,-96.639130,0,'2013-07-06 12:44:33',NULL,NULL),(12447,'12965','S','Hopkinton','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.705556,-74.715278,0,'2013-07-06 12:44:30',NULL,NULL),(952,'00716','S','Parc Amalia Marin','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(1848,'00791','S','Alts de San Benito','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(26293,'29021','P','Red Hill','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(25529,'28398','S','Bowdens','A','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.980540,-78.094560,0,'2013-07-06 12:44:31',NULL,NULL),(28385,'31307','P','Eden','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.172291,-81.390170,0,'2013-07-06 12:44:32',NULL,NULL),(49837,'57227','S','Corona','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.362558,-96.668241,0,'2013-07-06 12:44:33',NULL,NULL),(34077,'38151','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.149052,-89.977749,0,'2013-07-06 12:44:32',NULL,NULL),(31708,'34953','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.256604,-80.384626,0,'2013-07-06 12:44:32',NULL,NULL),(4737,'03833','S','Exeter','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.977520,-70.992300,0,'2013-07-06 12:44:30',NULL,NULL),(51340,'59313','S','Baker','D','Fallon','30025','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.360175,-104.270068,0,'2013-07-06 12:44:33',NULL,NULL),(36308,'40372','S','Bondville','A','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.909927,-84.876344,0,'2013-07-06 12:44:32',NULL,NULL),(1190,'00728','S','Brisas del Mar','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(14481,'15131','S','White Oak','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.330620,-79.806180,0,'2013-07-06 12:44:31',NULL,NULL),(21754,'23056','S','Foster','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.451410,-76.385042,0,'2013-07-06 12:44:31',NULL,NULL),(21230,'22225','U','Dept of the Navy','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856611,-77.059377,0,'2013-07-06 12:44:31',NULL,NULL),(66848,'79120','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.192767,-101.760356,0,'2013-07-06 12:44:34',NULL,NULL),(75061,'93524','U','Edwards','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.919545,-117.946773,0,'2013-07-06 12:44:34',NULL,NULL),(67419,'80138','S','Parker','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.515707,-104.662026,0,'2013-07-06 12:44:34',NULL,NULL),(59234,'70429','P','Bogalusa','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.787781,-89.848334,0,'2013-07-06 12:44:33',NULL,NULL),(33602,'37621','P','Bristol','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.580525,-82.204820,0,'2013-07-06 12:44:32',NULL,NULL),(62012,'73446','S','Mc Millan','A','Marshall','40095','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.085514,-96.773997,0,'2013-07-06 12:44:33',NULL,NULL),(9788,'10108','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(48314,'55444','S','Brooklyn Ctr','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.088050,-93.296289,0,'2013-07-06 12:44:33',NULL,NULL),(21379,'22480','S','Irvington','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.665340,-76.414915,0,'2013-07-06 12:44:31',NULL,NULL),(23562,'25639','P','Peach Creek','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.846903,-81.992224,0,'2013-07-06 12:44:31',NULL,NULL),(33372,'37207','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.222188,-86.773002,0,'2013-07-06 12:44:32',NULL,NULL),(29739,'32965','P','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.645533,-80.394153,0,'2013-07-06 12:44:32',NULL,NULL),(66129,'78427','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.795288,-97.403051,0,'2013-07-06 12:44:34',NULL,NULL),(50665,'58335','P','Fort Totten','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.975298,-98.994286,0,'2013-07-06 12:44:33',NULL,NULL),(72224,'88433','S','Qway','N','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.960345,-103.807602,0,'2013-07-06 12:44:34',NULL,NULL),(43127,'48230','S','Grosse Pointe Park','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(46214,'52766','S','Nichols','D','Muscatine','19139','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.479309,-91.305402,0,'2013-07-06 12:44:32',NULL,NULL),(46767,'53944','S','Lyndon Station','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.706413,-89.892011,0,'2013-07-06 12:44:32',NULL,NULL),(17884,'18444','S','Elmhurst Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(9901,'10130','U','Gracie','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754891,-74.003971,0,'2013-07-06 12:44:30',NULL,NULL),(39394,'44657','S','Chambersburg','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(48359,'55487','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.978547,-93.265919,0,'2013-07-06 12:44:33',NULL,NULL),(49460,'56650','S','Saum','A','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.957836,-94.483902,0,'2013-07-06 12:44:33',NULL,NULL),(56476,'65323','S','Calhoun','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.482740,-93.641880,0,'2013-07-06 12:44:33',NULL,NULL),(73871,'91932','S','Imperial Bch','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.574700,-117.116328,0,'2013-07-06 12:44:34',NULL,NULL),(48968,'56208','S','Appleton','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.202224,-96.017184,0,'2013-07-06 12:44:33',NULL,NULL),(39267,'44451','S','North Jackson','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.078419,-80.867992,0,'2013-07-06 12:44:32',NULL,NULL),(37826,'42437','S','Pride','N','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(48504,'55736','S','Van Buren','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(5930,'05253','S','Lake Emerald','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.283889,-73.002778,0,'2013-07-06 12:44:30',NULL,NULL),(46823,'54011','S','Ellsworth','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.735213,-92.480939,0,'2013-07-06 12:44:32',NULL,NULL),(51021,'58710','S','Anamoose','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.848945,-100.262163,0,'2013-07-06 12:44:33',NULL,NULL),(39201,'44334','P','Akron','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.079338,-81.516616,0,'2013-07-06 12:44:32',NULL,NULL),(51299,'59222','S','Flaxville','D','Daniels','30019','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.710057,-105.149161,0,'2013-07-06 12:44:33',NULL,NULL),(26669,'29388','S','Woodruff','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.759551,-82.045514,0,'2013-07-06 12:44:31',NULL,NULL),(1524,'00754','S','Urb Monte Rey','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(37607,'42129','S','Goodluck','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(76425,'95570','S','Trinidad','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',41.072862,-124.128197,0,'2013-07-06 12:44:34',NULL,NULL),(15380,'16316','S','Conneaut Lake','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.622180,-80.309520,0,'2013-07-06 12:44:31',NULL,NULL),(34089,'38161','U','US Postal Inspect Srvc','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.136604,-89.860771,0,'2013-07-06 12:44:32',NULL,NULL),(19949,'20577','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904360,-77.035413,0,'2013-07-06 12:44:31',NULL,NULL),(35991,'40140','S','Constantine','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.814276,-86.321436,0,'2013-07-06 12:44:32',NULL,NULL),(11737,'12183','S','Green Island','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744346,-73.695668,0,'2013-07-06 12:44:30',NULL,NULL),(48862,'56078','S','Pemberton','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.006210,-93.784178,0,'2013-07-06 12:44:33',NULL,NULL),(70028,'84130','P','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700770,-111.947110,0,'2013-07-06 12:44:34',NULL,NULL),(63513,'75751','S','Cardinal Sta','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(54913,'63088','S','Manchester','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550608,-90.490282,0,'2013-07-06 12:44:33',NULL,NULL),(47130,'54455','S','Ashley','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(7796,'07435','S','Green Pond','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.056980,-74.428920,0,'2013-07-06 12:44:30',NULL,NULL),(23162,'25015','S','Quincy','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(30512,'33403','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(34038,'38134','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.191860,-89.925360,0,'2013-07-06 12:44:32',NULL,NULL),(47377,'54627','S','Ettrick','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.174018,-91.271068,0,'2013-07-06 12:44:32',NULL,NULL),(74112,'92227','S','Brawley','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.988510,-115.521752,0,'2013-07-06 12:44:34',NULL,NULL),(64239,'76351','P','Archer City','D','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.587932,-98.622907,0,'2013-07-06 12:44:34',NULL,NULL),(60626,'71901','S','H Spg Nat Pk','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(58296,'68420','S','Pawnee City','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.114423,-96.153820,0,'2013-07-06 12:44:33',NULL,NULL),(70488,'84770','S','St George','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(65782,'78115','P','Geronimo','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.610238,-98.025570,0,'2013-07-06 12:44:34',NULL,NULL),(65043,'77331','S','Willow Springs','N','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.598380,-95.114520,0,'2013-07-06 12:44:34',NULL,NULL),(64767,'76950','S','Sonora','D','Sutton','48435','Texas','TX','48','0000','325','Central',-6.0,'Y',30.568862,-100.642173,0,'2013-07-06 12:44:34',NULL,NULL),(20058,'20667','S','Park Hall','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.217420,-76.450224,0,'2013-07-06 12:44:31',NULL,NULL),(2247,'00926','S','Urb Laderas De San Juan','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(31839,'35082','P','Sylacauga','A','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.115279,-86.108320,0,'2013-07-06 12:44:32',NULL,NULL),(2655,'00966','S','Urb Arboleda','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(16221,'17074','S','Howe','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(6448,'05758','S','Healdville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.450800,-72.791580,0,'2013-07-06 12:44:30',NULL,NULL),(5273,'04493','S','West Enfield','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.243333,-68.650278,0,'2013-07-06 12:44:30',NULL,NULL),(56392,'65237','S','Cotton','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.787039,-92.799726,0,'2013-07-06 12:44:33',NULL,NULL),(65619,'77957','S','Cordele','N','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.974180,-96.649920,0,'2013-07-06 12:44:34',NULL,NULL),(73399,'91121','U','Avon Products','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.149921,-118.088599,0,'2013-07-06 12:44:34',NULL,NULL),(71702,'87522','S','Sanctuario','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(29571,'32816','U','University of Central Fl','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.606119,-81.204801,0,'2013-07-06 12:44:32',NULL,NULL),(45549,'51462','S','Scranton','D','Greene','19073','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.023571,-94.542782,0,'2013-07-06 12:44:32',NULL,NULL),(11521,'12035','S','Central Brg','A','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.716078,-74.361941,0,'2013-07-06 12:44:30',NULL,NULL),(27151,'29827','S','Barton','N','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.923380,-81.285780,0,'2013-07-06 12:44:31',NULL,NULL),(47365,'54619','S','Cashton','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.743540,-90.777120,0,'2013-07-06 12:44:32',NULL,NULL),(11353,'11798','S','Wyandanch','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.756804,-73.364139,0,'2013-07-06 12:44:30',NULL,NULL),(27031,'29653','S','Hodges','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.287837,-82.216353,0,'2013-07-06 12:44:31',NULL,NULL),(69650,'84010','S','Val Verda','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.871662,-111.890486,0,'2013-07-06 12:44:34',NULL,NULL),(63111,'75284','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768664,-96.827092,0,'2013-07-06 12:44:33',NULL,NULL),(55311,'63536','S','Downing','D','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.472383,-92.413598,0,'2013-07-06 12:44:33',NULL,NULL),(41106,'46562','S','Pierceton','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.200623,-85.708234,0,'2013-07-06 12:44:32',NULL,NULL),(47951,'55118','S','Sunfish Lake','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(1938,'00795','S','Urb Tomas Carrion Maduro','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(15896,'17007','S','South Middleton','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.147806,-77.116428,0,'2013-07-06 12:44:31',NULL,NULL),(32191,'35541','S','Arley','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.052335,-87.155167,0,'2013-07-06 12:44:32',NULL,NULL),(30352,'33312','S','Lauderdale Isles','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.088164,-80.184514,0,'2013-07-06 12:44:32',NULL,NULL),(44631,'50066','S','Dawson','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.820013,-94.219980,0,'2013-07-06 12:44:32',NULL,NULL),(23423,'25358','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.333950,-81.745941,0,'2013-07-06 12:44:31',NULL,NULL),(40031,'45249','S','Sycamore Twp','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.290580,-84.334690,0,'2013-07-06 12:44:32',NULL,NULL),(32044,'35249','U','Univ of Alabama Hospital','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519034,-86.803591,0,'2013-07-06 12:44:32',NULL,NULL),(42314,'47613','S','Elberfeld','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.160224,-87.449707,0,'2013-07-06 12:44:32',NULL,NULL),(15773,'16921','S','Gaines','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(5743,'05035','S','Bridgewater Corners','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(25665,'28509','P','Alliance','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.146647,-76.799183,0,'2013-07-06 12:44:31',NULL,NULL),(15340,'16228','S','Ford Cliff','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.760255,-79.536766,0,'2013-07-06 12:44:31',NULL,NULL),(69745,'84047','S','Cottonwood Heights','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.616513,-111.879899,0,'2013-07-06 12:44:34',NULL,NULL),(53861,'62330','S','Pilot Grove','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.632034,-91.172512,0,'2013-07-06 12:44:33',NULL,NULL),(35792,'39751','S','Mantee','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.733333,-89.066667,0,'2013-07-06 12:44:32',NULL,NULL),(21616,'22904','S','Newcomb Hall','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000947,-78.471158,0,'2013-07-06 12:44:31',NULL,NULL),(22122,'23436','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.894714,-76.513517,0,'2013-07-06 12:44:31',NULL,NULL),(44610,'50055','S','Clyde','N','Story','19169','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.903253,-93.306942,0,'2013-07-06 12:44:32',NULL,NULL),(4939,'04088','S','Waterford','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.216087,-70.474619,0,'2013-07-06 12:44:30',NULL,NULL),(78082,'97473','S','Greenacres','N','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.664497,-123.792640,0,'2013-07-06 12:44:34',NULL,NULL),(69165,'83322','S','Corral','D','Camas','16025','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.322434,-114.998760,0,'2013-07-06 12:44:34',NULL,NULL),(55079,'63188','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.629191,-90.197195,0,'2013-07-06 12:44:33',NULL,NULL),(12792,'13219','S','Westvale','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040139,-76.217020,0,'2013-07-06 12:44:30',NULL,NULL),(58603,'68852','S','Litchfield','D','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.199056,-99.120955,0,'2013-07-06 12:44:33',NULL,NULL),(43396,'48442','S','Holly','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.792562,-83.609652,0,'2013-07-06 12:44:32',NULL,NULL),(27482,'30152','S','Kennesaw','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.990560,-84.680880,0,'2013-07-06 12:44:31',NULL,NULL),(47648,'54930','S','Coloma','D','Waushara','55137','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.024459,-89.636788,0,'2013-07-06 12:44:33',NULL,NULL),(21848,'23138','S','Port Haywood','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.371944,-76.279722,0,'2013-07-06 12:44:31',NULL,NULL),(39637,'44903','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.760320,-82.520048,0,'2013-07-06 12:44:32',NULL,NULL),(68339,'81123','S','Blanca','D','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.431657,-105.523346,0,'2013-07-06 12:44:34',NULL,NULL),(62179,'73756','S','Loyal','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.964311,-98.112473,0,'2013-07-06 12:44:33',NULL,NULL),(23451,'25421','S','Glengary','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.383820,-78.155820,0,'2013-07-06 12:44:31',NULL,NULL),(13227,'13636','S','Ellisburg','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.742090,-76.120620,0,'2013-07-06 12:44:30',NULL,NULL),(80156,'99791','P','Barrow','A','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.472212,-157.427665,0,'2013-07-06 12:44:34',NULL,NULL),(75441,'94044','S','Sharp Park','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.602347,-122.485548,0,'2013-07-06 12:44:34',NULL,NULL),(56766,'65738','S','Republic','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.120403,-93.473396,0,'2013-07-06 12:44:33',NULL,NULL),(25648,'28469','S','Ocean Isle','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.923901,-78.459091,0,'2013-07-06 12:44:31',NULL,NULL),(42940,'48118','S','Lima Center','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(27710,'30342','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.877890,-84.370698,0,'2013-07-06 12:44:31',NULL,NULL),(40569,'45865','S','Minster','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.400200,-84.383223,0,'2013-07-06 12:44:32',NULL,NULL),(15458,'16412','S','Edinboro','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.885747,-80.143902,0,'2013-07-06 12:44:31',NULL,NULL),(2420,'00953','S','Mans de Montecasino Ii','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(76017,'95128','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.313617,-121.930590,0,'2013-07-06 12:44:34',NULL,NULL),(66275,'78580','S','Raymondville','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.481214,-97.783570,0,'2013-07-06 12:44:34',NULL,NULL),(63433,'75667','S','Fussel','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.945127,-94.853612,0,'2013-07-06 12:44:33',NULL,NULL),(35002,'39120','S','Church Hill','A','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.536480,-91.326600,0,'2013-07-06 12:44:32',NULL,NULL),(72829,'89825','S','Jackpot','D','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',41.763600,-115.074720,0,'2013-07-06 12:44:34',NULL,NULL),(10196,'10306','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.566903,-74.120829,0,'2013-07-06 12:44:30',NULL,NULL),(60032,'71343','S','Larto','A','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(72832,'89828','S','Lamoille','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.722475,-115.561395,0,'2013-07-06 12:44:34',NULL,NULL),(39284,'44484','S','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.231245,-80.762228,0,'2013-07-06 12:44:32',NULL,NULL),(42183,'47541','S','Holland','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.246997,-87.040762,0,'2013-07-06 12:44:32',NULL,NULL),(11185,'11733','S','Setauket','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(13926,'14423','S','Caledonia','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.941518,-77.843078,0,'2013-07-06 12:44:31',NULL,NULL),(55846,'64163','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.336740,-94.744720,0,'2013-07-06 12:44:33',NULL,NULL),(23595,'25678','S','Meador','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649769,-82.126194,0,'2013-07-06 12:44:31',NULL,NULL),(49740,'57053','S','Parker','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.396890,-97.138100,0,'2013-07-06 12:44:33',NULL,NULL),(46505,'53235','S','Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.969046,-87.871317,0,'2013-07-06 12:44:32',NULL,NULL),(75326,'93776','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.746360,-119.790490,0,'2013-07-06 12:44:34',NULL,NULL),(67494,'80233','S','Thornton','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903291,-104.948178,0,'2013-07-06 12:44:34',NULL,NULL),(31733,'34984','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.275367,-80.347242,0,'2013-07-06 12:44:32',NULL,NULL),(34973,'39086','S','Carpenter','N','Claiborne','28021','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.011080,-90.817800,0,'2013-07-06 12:44:32',NULL,NULL),(15566,'16644','P','Glasgow','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.685011,-78.437460,0,'2013-07-06 12:44:31',NULL,NULL),(1837,'00784','S','Urb Vistamar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(54762,'62987','S','McCormick','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.637140,-88.740772,0,'2013-07-06 12:44:33',NULL,NULL),(21921,'23224','S','N Chesterfld','A','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.495020,-77.477100,0,'2013-07-06 12:44:31',NULL,NULL),(44280,'49715','S','Brimley','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.397049,-84.594749,0,'2013-07-06 12:44:32',NULL,NULL),(22231,'23606','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.070123,-76.500310,0,'2013-07-06 12:44:31',NULL,NULL),(20287,'20797','U','Southern Md Brm','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.095953,-76.838956,0,'2013-07-06 12:44:31',NULL,NULL),(69856,'84090','P','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.572386,-111.852583,0,'2013-07-06 12:44:34',NULL,NULL),(68372,'81140','S','La Jara','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.308960,-106.035240,0,'2013-07-06 12:44:34',NULL,NULL),(56828,'65791','S','Thayer','D','Oregon','29149','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.523905,-91.544323,0,'2013-07-06 12:44:33',NULL,NULL),(4941,'04091','S','West Baldwin','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.831044,-70.745977,0,'2013-07-06 12:44:30',NULL,NULL),(32085,'35291','U','AL Power Co','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513087,-86.806429,0,'2013-07-06 12:44:32',NULL,NULL),(31180,'33927','P','El Jobean','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.976643,-82.202329,0,'2013-07-06 12:44:32',NULL,NULL),(62985,'75147','S','Gun Barrel Cy','A','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.319300,-96.118080,0,'2013-07-06 12:44:33',NULL,NULL),(53756,'62262','S','Royal Lake Resort','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.924180,-89.270352,0,'2013-07-06 12:44:33',NULL,NULL),(8317,'08033','S','Haddonfield','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.895208,-75.039366,0,'2013-07-06 12:44:30',NULL,NULL),(47407,'54650','S','Onalaska','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.885820,-91.217250,0,'2013-07-06 12:44:32',NULL,NULL),(21995,'23274','U','Dept Public Utilities','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542735,-77.446569,0,'2013-07-06 12:44:31',NULL,NULL),(19347,'20042','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916732,-76.994294,0,'2013-07-06 12:44:31',NULL,NULL),(73310,'90809','P','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.762376,-118.121919,0,'2013-07-06 12:44:34',NULL,NULL),(72643,'89426','P','Paradise Valley','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.600543,-117.381616,0,'2013-07-06 12:44:34',NULL,NULL),(67388,'80123','S','Columbine Vly','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(16057,'17047','S','Cisna Run','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(64668,'76821','S','Bethel','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.734120,-99.961500,0,'2013-07-06 12:44:34',NULL,NULL),(46692,'53784','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.040958,-89.394588,0,'2013-07-06 12:44:32',NULL,NULL),(34329,'38562','S','Gainesboro','D','Jackson','47087','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.357388,-85.653151,0,'2013-07-06 12:44:32',NULL,NULL),(75584,'94288','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582186,-121.492888,0,'2013-07-06 12:44:34',NULL,NULL),(66880,'79231','P','Dougherty','D','Floyd','48153','Texas','TX','48','0000','806','Central',-6.0,'Y',33.940185,-101.301349,0,'2013-07-06 12:44:34',NULL,NULL),(3065,'01118','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.093934,-72.527899,0,'2013-07-06 12:44:30',NULL,NULL),(14910,'15535','S','Clearville','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.834884,-78.451629,0,'2013-07-06 12:44:31',NULL,NULL),(14403,'15059','S','Midland','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.661882,-80.471984,0,'2013-07-06 12:44:31',NULL,NULL),(13868,'14233','U','Jingo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.875099,-78.869022,0,'2013-07-06 12:44:31',NULL,NULL),(13382,'13739','S','Kortright Center','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.364324,-74.803449,0,'2013-07-06 12:44:31',NULL,NULL),(40748,'46140','S','Eden','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.794852,-85.791522,0,'2013-07-06 12:44:32',NULL,NULL),(44885,'50317','S','Carbondale','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(2792,'00976','S','Urb El Conquistador','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(5080,'04294','S','Wilton','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.596240,-70.226079,0,'2013-07-06 12:44:30',NULL,NULL),(48,'00604','P','Aguadilla','D','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.505289,-67.135899,0,'2013-07-06 12:44:30',NULL,NULL),(77693,'97041','S','Mount Hood Parkdale','D','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(2965,'01041','P','Halyoke','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.207463,-72.611418,0,'2013-07-06 12:44:30',NULL,NULL),(74541,'92662','S','Balboa','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.606234,-117.893145,0,'2013-07-06 12:44:34',NULL,NULL),(74190,'92278','S','Twentynine Palms MCB','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.273320,-116.102460,0,'2013-07-06 12:44:34',NULL,NULL),(60853,'72045','S','El Paso','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.106575,-92.087418,0,'2013-07-06 12:44:33',NULL,NULL),(46056,'52573','S','Mount Sterling','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.617778,-91.931944,0,'2013-07-06 12:44:32',NULL,NULL),(40911,'46260','S','Nora','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892649,-86.180844,0,'2013-07-06 12:44:32',NULL,NULL),(61799,'73093','S','Goldsby','A','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.128596,-97.486449,0,'2013-07-06 12:44:33',NULL,NULL),(52112,'60420','S','Dwight','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.089777,-88.426759,0,'2013-07-06 12:44:33',NULL,NULL),(6421,'05741','P','East Poultney','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.527104,-73.206396,0,'2013-07-06 12:44:30',NULL,NULL),(47928,'55112','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079380,-93.187200,0,'2013-07-06 12:44:33',NULL,NULL),(53216,'61630','U','East Peoria','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.682843,-89.601814,0,'2013-07-06 12:44:33',NULL,NULL),(68802,'82430','P','Kirby','D','Hot Springs','56017','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.804158,-108.174567,0,'2013-07-06 12:44:34',NULL,NULL),(3451,'01772','S','Southborough','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.295044,-71.532273,0,'2013-07-06 12:44:30',NULL,NULL),(27714,'30342','S','Tuxedo','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.877890,-84.370698,0,'2013-07-06 12:44:31',NULL,NULL),(28473,'31503','S','Waycross','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.218893,-82.373503,0,'2013-07-06 12:44:32',NULL,NULL),(49684,'57018','S','Huntimer','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.785894,-96.927978,0,'2013-07-06 12:44:33',NULL,NULL),(77244,'96540','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60911,'72076','S','LrAFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(25271,'28127','S','Badin Lake','A','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.400410,-80.204216,0,'2013-07-06 12:44:31',NULL,NULL),(48875,'56088','S','Truman','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.828740,-94.436798,0,'2013-07-06 12:44:33',NULL,NULL),(20042,'20646','S','Laplata','N','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.524678,-76.973630,0,'2013-07-06 12:44:31',NULL,NULL),(48664,'55917','S','Bixby','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917900,-93.055500,0,'2013-07-06 12:44:33',NULL,NULL),(41428,'46851','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.067721,-85.165914,0,'2013-07-06 12:44:32',NULL,NULL),(3336,'01538','P','North Uxbridge','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.090256,-71.639891,0,'2013-07-06 12:44:30',NULL,NULL),(56324,'65105','U','Mo Dept of Revenue','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.577411,-92.174184,0,'2013-07-06 12:44:33',NULL,NULL),(3610,'02051','P','Marshfield Hills','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.145186,-70.723880,0,'2013-07-06 12:44:30',NULL,NULL),(61335,'72460','S','Ravenden Spgs','A','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.360741,-91.243680,0,'2013-07-06 12:44:33',NULL,NULL),(68664,'81652','S','Silt','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.506975,-107.653558,0,'2013-07-06 12:44:34',NULL,NULL),(70526,'85010','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.465638,-111.987116,0,'2013-07-06 12:44:34',NULL,NULL),(53608,'62081','S','Rockbridge','D','Greene','17061','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.285885,-90.270095,0,'2013-07-06 12:44:33',NULL,NULL),(34464,'38661','S','Taska','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.955910,-89.516040,0,'2013-07-06 12:44:32',NULL,NULL),(45258,'50664','S','Oran','D','Fayette','19065','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.710590,-91.877058,0,'2013-07-06 12:44:32',NULL,NULL),(52503,'60712','S','Lincolnwood','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.003155,-87.734888,0,'2013-07-06 12:44:33',NULL,NULL),(9388,'09846','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(50485,'58049','S','Kathryn','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.701900,-97.985400,0,'2013-07-06 12:44:33',NULL,NULL),(79282,'98577','S','Raymond','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(74534,'92656','S','Laguna Hills','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.576120,-117.736380,0,'2013-07-06 12:44:34',NULL,NULL),(73985,'92092','U','Uc San Diego','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.876604,-117.232638,0,'2013-07-06 12:44:34',NULL,NULL),(61868,'73126','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.457182,-97.490781,0,'2013-07-06 12:44:33',NULL,NULL),(55612,'63957','S','Piedmont','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.155164,-90.690663,0,'2013-07-06 12:44:33',NULL,NULL),(35075,'39201','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.292867,-90.184187,0,'2013-07-06 12:44:32',NULL,NULL),(31088,'33868','S','Polk City','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.195584,-81.831716,0,'2013-07-06 12:44:32',NULL,NULL),(21904,'23188','S','Williamsburg','D','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.326834,-76.760558,0,'2013-07-06 12:44:31',NULL,NULL),(22607,'24211','S','Abingdon','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.710423,-81.977417,0,'2013-07-06 12:44:31',NULL,NULL),(75529,'94177','U','Pacific Gas and Electric','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.791933,-122.398410,0,'2013-07-06 12:44:34',NULL,NULL),(78084,'97473','S','Scottsburg','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.664497,-123.792640,0,'2013-07-06 12:44:34',NULL,NULL),(14380,'15035','S','E Mc Keesport','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.380214,-79.806760,0,'2013-07-06 12:44:31',NULL,NULL),(32806,'36441','S','Pollard','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.040640,-87.243540,0,'2013-07-06 12:44:32',NULL,NULL),(35604,'39601','S','Cobbs','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(39746,'45101','S','Ellsberry','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.679427,-83.750546,0,'2013-07-06 12:44:32',NULL,NULL),(37281,'41604','S','Ligon','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369321,-82.670590,0,'2013-07-06 12:44:32',NULL,NULL),(67179,'79847','S','Dell City','A','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.808783,-105.277133,0,'2013-07-06 12:44:34',NULL,NULL),(41175,'46710','S','Avilla','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.367073,-85.237128,0,'2013-07-06 12:44:32',NULL,NULL),(66852,'79159','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.237256,-102.038624,0,'2013-07-06 12:44:34',NULL,NULL),(21428,'22553','S','Spotsylvania','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.200620,-77.685420,0,'2013-07-06 12:44:31',NULL,NULL),(42321,'47618','P','Inglefield','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.110743,-87.560239,0,'2013-07-06 12:44:32',NULL,NULL),(43522,'48651','S','Prudenville','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.298054,-84.664910,0,'2013-07-06 12:44:32',NULL,NULL),(40012,'45246','S','Parkdale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.279734,-84.471102,0,'2013-07-06 12:44:32',NULL,NULL),(67934,'80909','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.852846,-104.761164,0,'2013-07-06 12:44:34',NULL,NULL),(11201,'11743','S','Cold Spring Hills','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(30253,'33206','U','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.795180,-80.325380,0,'2013-07-06 12:44:32',NULL,NULL),(50507,'58071','S','Tower City','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.893335,-97.634254,0,'2013-07-06 12:44:33',NULL,NULL),(37562,'42071','S','Faxon','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(73229,'90638','S','Mirada','A','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.906013,-118.005828,0,'2013-07-06 12:44:34',NULL,NULL),(33673,'37731','S','Eidson','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.497864,-83.079182,0,'2013-07-06 12:44:32',NULL,NULL),(28911,'32140','S','Florahome','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.760177,-81.882535,0,'2013-07-06 12:44:32',NULL,NULL),(57450,'66845','S','Cottonwood Falls','D','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.365873,-96.545943,0,'2013-07-06 12:44:33',NULL,NULL),(16433,'17233','S','Knobsville','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(30049,'33145','S','Coral','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753248,-80.236857,0,'2013-07-06 12:44:32',NULL,NULL),(45348,'50980','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.581737,-93.639001,0,'2013-07-06 12:44:32',NULL,NULL),(44028,'49413','U','Gerber Products Inc','N','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.462833,-85.952274,0,'2013-07-06 12:44:32',NULL,NULL),(20415,'20906','S','Leisure World','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(64385,'76531','S','Shive','N','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.664240,-98.413570,0,'2013-07-06 12:44:34',NULL,NULL),(54350,'62781','U','Memorial Med Ctr','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.810838,-89.655757,0,'2013-07-06 12:44:33',NULL,NULL),(31414,'34240','S','Lakewood Rch','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.319476,-82.386179,0,'2013-07-06 12:44:32',NULL,NULL),(201,'00623','S','Urb Montesol','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(44564,'50020','S','Anita','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.444100,-94.765161,0,'2013-07-06 12:44:32',NULL,NULL),(35299,'39401','S','Morriston','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(13124,'13491','S','North Winfield','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(44213,'49637','S','Grawn','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.633541,-85.706844,0,'2013-07-06 12:44:32',NULL,NULL),(73394,'91115','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.135882,-118.151588,0,'2013-07-06 12:44:34',NULL,NULL),(73092,'90223','P','Compton','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.892498,-118.226452,0,'2013-07-06 12:44:34',NULL,NULL),(79212,'98538','S','Wildwood','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.522826,-123.121792,0,'2013-07-06 12:44:34',NULL,NULL),(74398,'92521','U','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.972585,-117.350361,0,'2013-07-06 12:44:34',NULL,NULL),(23099,'24931','S','Sam Black','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.880631,-80.587119,0,'2013-07-06 12:44:31',NULL,NULL),(29751,'32976','S','Sebastian','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.880728,-80.516230,0,'2013-07-06 12:44:32',NULL,NULL),(52954,'61417','S','Berwick','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.762909,-90.501186,0,'2013-07-06 12:44:33',NULL,NULL),(48058,'55322','S','Cologne','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.771368,-93.787282,0,'2013-07-06 12:44:33',NULL,NULL),(39640,'44904','S','Lexington','A','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.677720,-82.614840,0,'2013-07-06 12:44:32',NULL,NULL),(38482,'43657','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.676827,-83.561778,0,'2013-07-06 12:44:32',NULL,NULL),(71499,'87107','S','Los Rnchs Abq','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(67161,'79830','S','Alpine','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',30.347023,-103.658015,0,'2013-07-06 12:44:34',NULL,NULL),(79123,'98493','U','Veterans Hospital','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.053364,-122.551238,0,'2013-07-06 12:44:34',NULL,NULL),(70043,'84136','U','Beneficial Life Insurance','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767474,-111.887633,0,'2013-07-06 12:44:34',NULL,NULL),(68018,'80924','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739417,-104.635170,0,'2013-07-06 12:44:34',NULL,NULL),(49657,'57001','S','Big Springs','N','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.021930,-96.622613,0,'2013-07-06 12:44:33',NULL,NULL),(51536,'59722','S','Deer Lodge','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.380420,-112.722360,0,'2013-07-06 12:44:33',NULL,NULL),(72649,'89429','S','Silver Springs','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.358200,-119.295180,0,'2013-07-06 12:44:34',NULL,NULL),(77189,'96336','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(70628,'85139','S','Maricopa','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.980110,-112.108719,0,'2013-07-06 12:44:34',NULL,NULL),(77937,'97338','S','Dallas','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.922171,-123.326623,0,'2013-07-06 12:44:34',NULL,NULL),(66116,'78416','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.751777,-97.435129,0,'2013-07-06 12:44:34',NULL,NULL),(65136,'77384','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.230149,-95.490453,0,'2013-07-06 12:44:34',NULL,NULL),(10870,'11418','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.698520,-73.835575,0,'2013-07-06 12:44:30',NULL,NULL),(13971,'14478','S','Bluff Point','A','Yates','36123','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.587954,-77.124490,0,'2013-07-06 12:44:31',NULL,NULL),(64538,'76645','S','Peoria','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(61604,'72769','S','Summers','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.021731,-94.497053,0,'2013-07-06 12:44:33',NULL,NULL),(26677,'29403','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.798426,-79.948096,0,'2013-07-06 12:44:31',NULL,NULL),(11595,'12083','S','Greenville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.416705,-74.011373,0,'2013-07-06 12:44:30',NULL,NULL),(11136,'11707','P','W Babylon','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.700400,-73.327799,0,'2013-07-06 12:44:30',NULL,NULL),(15394,'16331','S','Kossuth','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.289342,-79.591132,0,'2013-07-06 12:44:31',NULL,NULL),(53790,'62280','S','Rockwood','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.829257,-89.624565,0,'2013-07-06 12:44:33',NULL,NULL),(10803,'11372','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.749542,-73.883319,0,'2013-07-06 12:44:30',NULL,NULL),(49330,'56557','S','Beaulieu','N','Mahnomen','27087','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.324040,-95.929380,0,'2013-07-06 12:44:33',NULL,NULL),(44756,'50174','S','Murray','D','Clarke','19039','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.040931,-93.949175,0,'2013-07-06 12:44:32',NULL,NULL),(77122,'96151','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.942141,-119.981473,0,'2013-07-06 12:44:34',NULL,NULL),(63424,'75661','S','Baldwin','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.628300,-94.175280,0,'2013-07-06 12:44:33',NULL,NULL),(57497,'66944','S','Haddam','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.855669,-97.302858,0,'2013-07-06 12:44:33',NULL,NULL),(50181,'57560','S','Norris','D','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.473034,-101.079381,0,'2013-07-06 12:44:33',NULL,NULL),(15277,'16114','S','Clarks Mills','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.434108,-80.328430,0,'2013-07-06 12:44:31',NULL,NULL),(19655,'20301','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891090,-77.020936,0,'2013-07-06 12:44:31',NULL,NULL),(64338,'76508','U','Scott and White Hospital','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.092892,-97.364817,0,'2013-07-06 12:44:34',NULL,NULL),(54403,'62825','P','Coello','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.994474,-89.051247,0,'2013-07-06 12:44:33',NULL,NULL),(3429,'01742','S','West Concord','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.456444,-71.370954,0,'2013-07-06 12:44:30',NULL,NULL),(24644,'27375','P','Wentworth','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.336122,-79.653008,0,'2013-07-06 12:44:31',NULL,NULL),(375,'00660','S','Hacienda La Monserrate','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(41961,'47406','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.180192,-86.512479,0,'2013-07-06 12:44:32',NULL,NULL),(49361,'56580','S','Sabin','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.774844,-96.655765,0,'2013-07-06 12:44:33',NULL,NULL),(50989,'58647','S','New England','D','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.538980,-102.864983,0,'2013-07-06 12:44:33',NULL,NULL),(51907,'60104','S','Bellwood','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.882079,-87.878103,0,'2013-07-06 12:44:33',NULL,NULL),(5250,'04478','S','Seboomook Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(70659,'85205','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.437801,-111.714585,0,'2013-07-06 12:44:34',NULL,NULL),(55225,'63433','S','Ashburn','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.523283,-91.160736,0,'2013-07-06 12:44:33',NULL,NULL),(32600,'36132','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380100,-86.181883,0,'2013-07-06 12:44:32',NULL,NULL),(74518,'92649','S','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.717977,-118.050451,0,'2013-07-06 12:44:34',NULL,NULL),(66941,'79363','S','Shallowater','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.688333,-101.993760,0,'2013-07-06 12:44:34',NULL,NULL),(7112,'06375','S','Quaker Hill','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.398982,-72.116095,0,'2013-07-06 12:44:30',NULL,NULL),(23277,'25156','P','Pinch','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.408696,-81.481169,0,'2013-07-06 12:44:31',NULL,NULL),(28204,'31025','S','Elko','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.343533,-83.742165,0,'2013-07-06 12:44:31',NULL,NULL),(11992,'12481','S','Shokan','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.983620,-74.221020,0,'2013-07-06 12:44:30',NULL,NULL),(31919,'35172','S','County Line','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.813893,-86.747615,0,'2013-07-06 12:44:32',NULL,NULL),(27444,'30119','U','Southwire','N','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.589126,-85.132330,0,'2013-07-06 12:44:31',NULL,NULL),(33943,'38076','S','Moscow','A','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.167612,-89.377588,0,'2013-07-06 12:44:32',NULL,NULL),(31297,'34090','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(18000,'18632','S','Mildred','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.469607,-76.379987,0,'2013-07-06 12:44:31',NULL,NULL),(35354,'39440','S','Lightsey','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(12201,'12785','P','Port Jervis','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.495716,-74.561461,0,'2013-07-06 12:44:30',NULL,NULL),(59859,'71259','S','New Light','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.295425,-91.832115,0,'2013-07-06 12:44:33',NULL,NULL),(62606,'74529','S','Blocker','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.065008,-95.569088,0,'2013-07-06 12:44:33',NULL,NULL),(61832,'73113','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.564075,-97.501487,0,'2013-07-06 12:44:33',NULL,NULL),(30077,'33154','S','Surfside','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(28804,'32064','S','Boys Ranch','A','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.295480,-82.987712,0,'2013-07-06 12:44:32',NULL,NULL),(41029,'46384','P','Valpo','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.493624,-87.054754,0,'2013-07-06 12:44:32',NULL,NULL),(23312,'25205','P','Uneeda','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.035397,-81.780288,0,'2013-07-06 12:44:31',NULL,NULL),(12047,'12526','S','Linlithgo','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.134040,-73.850340,0,'2013-07-06 12:44:30',NULL,NULL),(29836,'33031','S','Redland','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526883,-80.482539,0,'2013-07-06 12:44:32',NULL,NULL),(73499,'91330','U','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.245875,-118.501885,0,'2013-07-06 12:44:34',NULL,NULL),(73408,'91126','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.136757,-118.125896,0,'2013-07-06 12:44:34',NULL,NULL),(64727,'76880','P','Star','D','Mills','48333','Texas','TX','48','0000','325','Central',-6.0,'Y',31.479071,-98.414538,0,'2013-07-06 12:44:34',NULL,NULL),(31151,'33912','S','San Carlos Park','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.509195,-81.832204,0,'2013-07-06 12:44:32',NULL,NULL),(44267,'49696','S','Barlow Branch','N','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.757555,-85.601648,0,'2013-07-06 12:44:32',NULL,NULL),(77553,'96860','S','Jbphh','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353536,-157.966185,0,'2013-07-06 12:44:34',NULL,NULL),(45705,'52060','S','Fulton','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.071208,-90.660765,0,'2013-07-06 12:44:32',NULL,NULL),(24948,'27829','S','Fountain','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.675909,-77.637640,0,'2013-07-06 12:44:31',NULL,NULL),(49181,'56434','S','Aldrich','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.411535,-94.969127,0,'2013-07-06 12:44:33',NULL,NULL),(47981,'55127','S','Vadnais Heights','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(2175,'00926','S','Est de San Geraldo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(45051,'50501','S','Clayworks','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(34285,'38485','S','Waynesboro','D','Wayne','47181','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.317202,-87.759589,0,'2013-07-06 12:44:32',NULL,NULL),(28389,'31310','P','Hinesville','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.833907,-81.600102,0,'2013-07-06 12:44:32',NULL,NULL),(28262,'31071','S','Pineview','D','Wilcox','13315','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.076427,-83.500229,0,'2013-07-06 12:44:31',NULL,NULL),(67012,'79520','S','Hamlin','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.881220,-100.126722,0,'2013-07-06 12:44:34',NULL,NULL),(62419,'74136','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.060952,-95.939506,0,'2013-07-06 12:44:33',NULL,NULL),(12947,'13354','S','Holland Patnt','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.253640,-75.284520,0,'2013-07-06 12:44:30',NULL,NULL),(47281,'54540','S','Land O Lakes','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.159664,-89.313769,0,'2013-07-06 12:44:32',NULL,NULL),(24828,'27608','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.810030,-78.645013,0,'2013-07-06 12:44:31',NULL,NULL),(30419,'33326','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(11725,'12180','S','Eagle Mills','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(66518,'78712','S','The University of Texas','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.285130,-97.737776,0,'2013-07-06 12:44:34',NULL,NULL),(76617,'95697','P','Yolo','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.735793,-121.805997,0,'2013-07-06 12:44:34',NULL,NULL),(76487,'95631','S','Baker Ranch','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.009228,-120.852443,0,'2013-07-06 12:44:34',NULL,NULL),(68558,'81433','P','Silverton','D','San Juan','08111','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.811743,-107.664195,0,'2013-07-06 12:44:34',NULL,NULL),(67015,'79526','S','Hermleigh','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.636276,-100.757915,0,'2013-07-06 12:44:34',NULL,NULL),(66272,'78578','S','Pt Isabel','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(55853,'64170','U','Internal Revenue Service','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.951885,-94.546834,0,'2013-07-06 12:44:33',NULL,NULL),(12000,'12489','P','Wawarsing','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.759074,-74.357613,0,'2013-07-06 12:44:30',NULL,NULL),(55922,'64459','S','Helena','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.935056,-94.690651,0,'2013-07-06 12:44:33',NULL,NULL),(36981,'41181','P','Willard','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.213094,-82.899909,0,'2013-07-06 12:44:32',NULL,NULL),(26001,'28672','S','Topia','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.473151,-81.380417,0,'2013-07-06 12:44:31',NULL,NULL),(51624,'59845','S','Niarada','A','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.594102,-114.676664,0,'2013-07-06 12:44:33',NULL,NULL),(48487,'55732','S','Pike','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.667582,-92.224878,0,'2013-07-06 12:44:33',NULL,NULL),(42469,'47834','S','Cardonia','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(41079,'46530','S','Granger','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.742276,-86.161696,0,'2013-07-06 12:44:32',NULL,NULL),(34823,'38915','S','Ellard','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.004880,-89.360460,0,'2013-07-06 12:44:32',NULL,NULL),(32769,'36370','S','Pansey','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.054891,-85.302820,0,'2013-07-06 12:44:32',NULL,NULL),(58723,'68940','S','Funk','D','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.466264,-99.248065,0,'2013-07-06 12:44:33',NULL,NULL),(42931,'48116','S','Brighton','D','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.532103,-83.773187,0,'2013-07-06 12:44:32',NULL,NULL),(78573,'98166','S','Normandy Park','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.447460,-122.356560,0,'2013-07-06 12:44:34',NULL,NULL),(78075,'97467','S','Win Bay','A','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.709940,-123.973740,0,'2013-07-06 12:44:34',NULL,NULL),(63399,'75650','S','Walkers Mill','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.500539,-94.575687,0,'2013-07-06 12:44:33',NULL,NULL),(8927,'08750','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.134492,-74.045049,0,'2013-07-06 12:44:30',NULL,NULL),(40190,'45381','S','W Alexandria','A','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.729736,-84.535455,0,'2013-07-06 12:44:32',NULL,NULL),(12554,'13045','S','Cortlandville','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.602760,-76.171860,0,'2013-07-06 12:44:30',NULL,NULL),(4859,'04021','S','Cumberland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.811530,-70.263280,0,'2013-07-06 12:44:30',NULL,NULL),(62779,'74872','S','Stratford','D','Garvin','40049','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.799153,-96.953781,0,'2013-07-06 12:44:33',NULL,NULL),(38796,'44060','S','Mol','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(21784,'23069','S','Hanover','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.781421,-77.309839,0,'2013-07-06 12:44:31',NULL,NULL),(51921,'60116','U','Household Financial Services','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.913702,-88.133828,0,'2013-07-06 12:44:33',NULL,NULL),(52498,'60706','S','Norridge','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.962443,-87.817391,0,'2013-07-06 12:44:33',NULL,NULL),(61132,'72157','S','Springfield','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.280120,-92.536920,0,'2013-07-06 12:44:33',NULL,NULL),(78621,'98203','S','Lowell','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.945956,-122.229877,0,'2013-07-06 12:44:34',NULL,NULL),(78025,'97424','S','Saginaw','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.784169,-123.057967,0,'2013-07-06 12:44:34',NULL,NULL),(74193,'92280','S','Vidal Junction','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.191918,-114.553587,0,'2013-07-06 12:44:34',NULL,NULL),(55406,'63645','S','Mine La Motte','A','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.559762,-90.292995,0,'2013-07-06 12:44:33',NULL,NULL),(37353,'41722','S','Ajax','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(54293,'62704','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.772500,-89.683680,0,'2013-07-06 12:44:33',NULL,NULL),(28058,'30671','P','Maxeys','D','Oglethorpe','13221','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.772874,-83.107171,0,'2013-07-06 12:44:31',NULL,NULL),(51129,'58795','S','Wildrose','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.609420,-103.202520,0,'2013-07-06 12:44:33',NULL,NULL),(16982,'17726','P','Castanea','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.121972,-77.433801,0,'2013-07-06 12:44:31',NULL,NULL),(40600,'45885','S','St Marys','N','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.546649,-84.395162,0,'2013-07-06 12:44:32',NULL,NULL),(6160,'05472','S','Barnumtown','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(16462,'17241','S','Hays Grove','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(1963,'00824','P','Christiansted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.745183,-64.704271,0,'2013-07-06 12:44:30',NULL,NULL),(24231,'26739','S','Mount Storm','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.211179,-79.252180,0,'2013-07-06 12:44:31',NULL,NULL),(24866,'27661','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.897400,-78.561539,0,'2013-07-06 12:44:31',NULL,NULL),(75725,'94589','S','American Cyn','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.162340,-122.249400,0,'2013-07-06 12:44:34',NULL,NULL),(74903,'93308','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.546760,-119.044020,0,'2013-07-06 12:44:34',NULL,NULL),(61224,'72325','P','Clarkedale','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.219721,-90.324168,0,'2013-07-06 12:44:33',NULL,NULL),(54146,'62567','S','Old Stonington','N','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.637026,-89.188520,0,'2013-07-06 12:44:33',NULL,NULL),(53902,'62363','S','Summer Hill','A','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.609331,-90.807822,0,'2013-07-06 12:44:33',NULL,NULL),(31809,'35053','S','Crane Hill','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.071568,-87.059700,0,'2013-07-06 12:44:32',NULL,NULL),(59619,'71032','S','Dona','N','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.117220,-93.776940,0,'2013-07-06 12:44:33',NULL,NULL),(19045,'19540','S','Hummels Store','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(12783,'13215','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.975120,-76.226340,0,'2013-07-06 12:44:30',NULL,NULL),(1351,'00736','S','Jard del Caribe','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(52777,'61264','S','Oak Grove','A','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.403900,-90.577680,0,'2013-07-06 12:44:33',NULL,NULL),(27796,'30388','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647853,-84.388398,0,'2013-07-06 12:44:31',NULL,NULL),(75403,'94015','S','Daly City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.679341,-122.483788,0,'2013-07-06 12:44:34',NULL,NULL),(62910,'75074','S','Murphy','N','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.029555,-96.675345,0,'2013-07-06 12:44:33',NULL,NULL),(32198,'35549','S','Carbon Hill','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.909911,-87.543633,0,'2013-07-06 12:44:32',NULL,NULL),(60555,'71742','S','Fordyce','D','Dallas','05039','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.813506,-92.420535,0,'2013-07-06 12:44:33',NULL,NULL),(58691,'68925','S','Zero','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.440577,-98.442822,0,'2013-07-06 12:44:33',NULL,NULL),(26709,'29410','S','North Charleston','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.194932,-80.029749,0,'2013-07-06 12:44:31',NULL,NULL),(26437,'29128','S','Spring Hill','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(37592,'42103','S','Bowling Green','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.963037,-86.370495,0,'2013-07-06 12:44:32',NULL,NULL),(21934,'23229','S','Regency','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602592,-77.557517,0,'2013-07-06 12:44:31',NULL,NULL),(74997,'93451','S','San Miguel','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.750880,-120.636780,0,'2013-07-06 12:44:34',NULL,NULL),(76598,'95688','S','Allendale','N','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.396760,-122.004180,0,'2013-07-06 12:44:34',NULL,NULL),(75463,'94086','S','Sunnyvale','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.377200,-122.019178,0,'2013-07-06 12:44:34',NULL,NULL),(70611,'85120','S','Apache Jct','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.412396,-111.589933,0,'2013-07-06 12:44:34',NULL,NULL),(63348,'75608','P','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.556090,-94.801494,0,'2013-07-06 12:44:33',NULL,NULL),(53499,'62011','S','Bingham','D','Fayette','17051','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.151303,-89.197692,0,'2013-07-06 12:44:33',NULL,NULL),(67149,'79777','P','Pyote','D','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.537597,-103.125871,0,'2013-07-06 12:44:34',NULL,NULL),(63156,'75390','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.842526,-96.701666,0,'2013-07-06 12:44:33',NULL,NULL),(49400,'56623','S','Border','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(50163,'57552','S','England Ranch','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(33419,'37241','U','Regions Bank','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108116,-86.674720,0,'2013-07-06 12:44:32',NULL,NULL),(46431,'53201','P','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036178,-87.916956,0,'2013-07-06 12:44:32',NULL,NULL),(273,'00646','S','Brighton Country Club','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(61804,'73098','S','Wynnewood','D','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.641370,-97.165867,0,'2013-07-06 12:44:33',NULL,NULL),(6794,'06108','S','E Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(39849,'45169','S','Clinton Cnty','A','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.491952,-83.654601,0,'2013-07-06 12:44:32',NULL,NULL),(71454,'87047','S','Golden','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.155441,-106.310313,0,'2013-07-06 12:44:34',NULL,NULL),(62657,'74630','S','Billings','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.530507,-97.448759,0,'2013-07-06 12:44:33',NULL,NULL),(61197,'72223','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.746004,-92.290840,0,'2013-07-06 12:44:33',NULL,NULL),(57868,'67579','S','Sterling','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.210635,-98.206878,0,'2013-07-06 12:44:33',NULL,NULL),(863,'00698','S','Urb La Quinta','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(32591,'36130','U','AL Revenue Dept','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.373160,-86.311027,0,'2013-07-06 12:44:32',NULL,NULL),(27368,'30068','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.965429,-84.438820,0,'2013-07-06 12:44:31',NULL,NULL),(2074,'00921','S','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(67763,'80634','S','Evans','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.408834,-104.760402,0,'2013-07-06 12:44:34',NULL,NULL),(70162,'84318','S','Hyde Park','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.798642,-111.816026,0,'2013-07-06 12:44:34',NULL,NULL),(32988,'36617','S','Prichard','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.715635,-88.087882,0,'2013-07-06 12:44:32',NULL,NULL),(43295,'48336','S','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458873,-83.346843,0,'2013-07-06 12:44:32',NULL,NULL),(30703,'33487','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.399700,-80.101680,0,'2013-07-06 12:44:32',NULL,NULL),(35005,'39122','P','Natchez','D','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.562045,-91.401246,0,'2013-07-06 12:44:32',NULL,NULL),(2248,'00926','S','Urb Las Rosas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(54460,'62853','S','Kell','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.541111,-88.912222,0,'2013-07-06 12:44:33',NULL,NULL),(33008,'36671','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.775281,-88.081056,0,'2013-07-06 12:44:32',NULL,NULL),(29142,'32328','S','St George Isl','A','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.746800,-84.923220,0,'2013-07-06 12:44:32',NULL,NULL),(11690,'12155','S','Simpsonville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597180,-74.818920,0,'2013-07-06 12:44:30',NULL,NULL),(13216,'13633','S','Depeyster','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.541079,-75.418940,0,'2013-07-06 12:44:30',NULL,NULL),(19295,'19975','S','Fenwick Island','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.466300,-75.149820,0,'2013-07-06 12:44:31',NULL,NULL),(76900,'95983','S','Genesee','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.058340,-120.710520,0,'2013-07-06 12:44:34',NULL,NULL),(73630,'91412','P','Panorama City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.222076,-118.446033,0,'2013-07-06 12:44:34',NULL,NULL),(60778,'72019','S','Bryant','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.563690,-92.586207,0,'2013-07-06 12:44:33',NULL,NULL),(2395,'00949','S','Urb Toaville','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(18704,'19195','U','Commerce Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952500,-75.164500,0,'2013-07-06 12:44:31',NULL,NULL),(25279,'28129','S','Oakboro','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.240371,-80.331644,0,'2013-07-06 12:44:31',NULL,NULL),(57120,'66223','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(10169,'10280','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711844,-74.019133,0,'2013-07-06 12:44:30',NULL,NULL),(20495,'21061','S','Glen Burnie','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.164525,-76.634664,0,'2013-07-06 12:44:31',NULL,NULL),(24469,'27239','S','Healing Springs','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(37082,'41339','S','Altro','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(76716,'95851','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.608099,-121.441544,0,'2013-07-06 12:44:34',NULL,NULL),(34460,'38659','S','Lebanon','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(13078,'13459','S','Sharon Spgs','A','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.791988,-74.614106,0,'2013-07-06 12:44:30',NULL,NULL),(30318,'33306','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163196,-80.110875,0,'2013-07-06 12:44:32',NULL,NULL),(67910,'80904','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855129,-104.865127,0,'2013-07-06 12:44:34',NULL,NULL),(68492,'81301','S','College Heights Durango','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.326840,-107.831460,0,'2013-07-06 12:44:34',NULL,NULL),(52523,'60914','S','Bourbonnais','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.161134,-87.881497,0,'2013-07-06 12:44:33',NULL,NULL),(50353,'57747','S','Heppner','N','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.433844,-103.476204,0,'2013-07-06 12:44:33',NULL,NULL),(37002,'41222','S','Collista','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.795350,-82.819772,0,'2013-07-06 12:44:32',NULL,NULL),(35909,'40018','P','Eastwood','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.273714,-85.413748,0,'2013-07-06 12:44:32',NULL,NULL),(35835,'39773','S','Abbott','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.629580,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(58500,'68765','S','Foster','A','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.344594,-97.561580,0,'2013-07-06 12:44:33',NULL,NULL),(79742,'99223','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.611523,-117.358133,0,'2013-07-06 12:44:34',NULL,NULL),(35259,'39352','S','Porterville','D','Kemper','28069','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.652809,-88.489078,0,'2013-07-06 12:44:32',NULL,NULL),(37924,'42633','S','Windy','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(40062,'45270','U','Huntington National Bank','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.100915,-84.535879,0,'2013-07-06 12:44:32',NULL,NULL),(3103,'01230','S','Berkshire Heights','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(15795,'16925','S','Fassett','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(6098,'05452','S','Brookside','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(14895,'15489','P','West Leisenring','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.952923,-79.702222,0,'2013-07-06 12:44:31',NULL,NULL),(48691,'55933','S','Elkton','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.633231,-92.691164,0,'2013-07-06 12:44:33',NULL,NULL),(63235,'75471','S','Pickton','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.029259,-95.453730,0,'2013-07-06 12:44:33',NULL,NULL),(72742,'89507','P','University','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.547923,-119.819079,0,'2013-07-06 12:44:34',NULL,NULL),(69423,'83634','S','Kuna','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.477369,-116.392000,0,'2013-07-06 12:44:34',NULL,NULL),(62579,'74463','P','Taft','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.761067,-95.546426,0,'2013-07-06 12:44:33',NULL,NULL),(53720,'62243','S','Freeburg','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.426232,-89.904712,0,'2013-07-06 12:44:33',NULL,NULL),(12795,'13221','P','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048798,-76.149827,0,'2013-07-06 12:44:30',NULL,NULL),(20079,'20686','P','Saint Marys','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.186123,-76.436956,0,'2013-07-06 12:44:31',NULL,NULL),(36240,'40295','P','Bank One','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.249134,-85.757506,0,'2013-07-06 12:44:32',NULL,NULL),(22902,'24597','S','Vernon Hill','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.792310,-79.124740,0,'2013-07-06 12:44:31',NULL,NULL),(22200,'23511','S','Joint Forces Staff College','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(42111,'47467','P','Tunnelton','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.872044,-86.456458,0,'2013-07-06 12:44:32',NULL,NULL),(27661,'30326','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.852137,-84.360463,0,'2013-07-06 12:44:31',NULL,NULL),(21936,'23229','S','Tuckahoe','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602592,-77.557517,0,'2013-07-06 12:44:31',NULL,NULL),(52727,'61231','S','Sunbeam','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(64873,'77064','S','Jersey Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.917765,-95.555032,0,'2013-07-06 12:44:34',NULL,NULL),(3235,'01378','S','Orange','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.677282,-72.343139,0,'2013-07-06 12:44:30',NULL,NULL),(52518,'60901','S','Kankakee','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.113633,-87.860293,0,'2013-07-06 12:44:33',NULL,NULL),(52608,'61025','S','East Dubuque','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.466380,-90.571020,0,'2013-07-06 12:44:33',NULL,NULL),(11066,'11581','S','Valley Stream','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655430,-73.712757,0,'2013-07-06 12:44:30',NULL,NULL),(6917,'06154','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.773119,-72.707051,0,'2013-07-06 12:44:30',NULL,NULL),(53830,'62301','S','Quincy','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.931262,-91.379720,0,'2013-07-06 12:44:33',NULL,NULL),(33546,'37396','S','Whiteside','D','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.093549,-85.395042,0,'2013-07-06 12:44:32',NULL,NULL),(31212,'33952','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.991101,-82.099054,0,'2013-07-06 12:44:32',NULL,NULL),(49487,'56661','S','Bergville','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(25755,'28581','S','Sealevel','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.857921,-76.423320,0,'2013-07-06 12:44:31',NULL,NULL),(20717,'21280','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.297284,-76.608955,0,'2013-07-06 12:44:31',NULL,NULL),(16361,'17201','S','Greenvillage','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(13933,'14428','S','Clifton','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.052222,-77.815000,0,'2013-07-06 12:44:31',NULL,NULL),(75580,'94284','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.553196,-121.501479,0,'2013-07-06 12:44:34',NULL,NULL),(80092,'99744','P','Anderson','D','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.293059,-149.128347,0,'2013-07-06 12:44:34',NULL,NULL),(65880,'78225','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.388465,-98.531438,0,'2013-07-06 12:44:34',NULL,NULL),(53751,'62261','S','Modoc','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.037120,-90.007380,0,'2013-07-06 12:44:33',NULL,NULL),(10208,'10452','S','Stadium','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.841676,-73.921773,0,'2013-07-06 12:44:30',NULL,NULL),(1749,'00778','S','Valle de Santa Barbara','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(10048,'10175','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(50487,'58052','S','Leonard','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.651382,-97.245736,0,'2013-07-06 12:44:33',NULL,NULL),(42561,'47874','S','Diamond','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(49316,'56546','S','Georgetown','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',47.108619,-96.693214,0,'2013-07-06 12:44:33',NULL,NULL),(49755,'57063','S','Tabor','D','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.951432,-97.665236,0,'2013-07-06 12:44:33',NULL,NULL),(63458,'75684','S','Leveretts Chapel','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(54522,'62877','S','Richview','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.402191,-89.201216,0,'2013-07-06 12:44:33',NULL,NULL),(24551,'27292','S','South Lexington','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(71945,'87937','S','Hatch','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.656667,-107.135278,0,'2013-07-06 12:44:34',NULL,NULL),(63447,'75672','S','Marshall','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.534636,-94.353464,0,'2013-07-06 12:44:33',NULL,NULL),(60490,'71660','S','Orlando','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.763918,-92.192406,0,'2013-07-06 12:44:33',NULL,NULL),(38320,'43408','P','Clay Center','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.557648,-83.247498,0,'2013-07-06 12:44:32',NULL,NULL),(3361,'01569','S','Uxbridge','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.078430,-71.634079,0,'2013-07-06 12:44:30',NULL,NULL),(58560,'68824','S','Mayfield','N','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.999381,-98.612998,0,'2013-07-06 12:44:33',NULL,NULL),(53992,'62442','S','Martinsville','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.330353,-87.886995,0,'2013-07-06 12:44:33',NULL,NULL),(8521,'08107','S','Collingswood','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(33476,'37337','S','Grand View','N','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.767208,-84.854798,0,'2013-07-06 12:44:32',NULL,NULL),(14158,'14723','S','Cherry Creek','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.311195,-79.141523,0,'2013-07-06 12:44:31',NULL,NULL),(17061,'17756','S','Halls','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(66309,'78589','S','San Juan','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.196480,-98.153340,0,'2013-07-06 12:44:34',NULL,NULL),(34429,'38642','S','Slayden','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.988460,-89.374740,0,'2013-07-06 12:44:32',NULL,NULL),(31513,'34465','S','Pine Ridge','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.936160,-82.450412,0,'2013-07-06 12:44:32',NULL,NULL),(36068,'40207','S','Windy Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(65005,'77301','S','Beach','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.311394,-95.433846,0,'2013-07-06 12:44:34',NULL,NULL),(73570,'91372','P','Woodland Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.154498,-118.643170,0,'2013-07-06 12:44:34',NULL,NULL),(78701,'98259','P','North Lakewood','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.164986,-122.299200,0,'2013-07-06 12:44:34',NULL,NULL),(50372,'57758','S','Inland','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.892550,-102.451810,0,'2013-07-06 12:44:33',NULL,NULL),(44486,'49912','S','Bruce Xing','A','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.538683,-89.202693,0,'2013-07-06 12:44:32',NULL,NULL),(21708,'22974','S','Troy','D','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.941957,-78.235745,0,'2013-07-06 12:44:31',NULL,NULL),(37059,'41301','S','Zachariah','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(28363,'31209','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.879094,-83.664957,0,'2013-07-06 12:44:32',NULL,NULL),(77020,'96094','S','Hammond Ranch','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.466318,-122.383688,0,'2013-07-06 12:44:34',NULL,NULL),(69854,'84088','S','West Jordan','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.596730,-112.001045,0,'2013-07-06 12:44:34',NULL,NULL),(36091,'40219','S','Heritage Creek','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(44462,'49880','S','Rock','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.038161,-87.175792,0,'2013-07-06 12:44:32',NULL,NULL),(4474,'03264','S','Plymouth','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.753373,-71.693831,0,'2013-07-06 12:44:30',NULL,NULL),(2185,'00926','S','Mans de Park Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(40884,'46241','S','Mars Hill','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(16784,'17533','P','Hopeland','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.234524,-76.267836,0,'2013-07-06 12:44:31',NULL,NULL),(30923,'33708','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(66667,'78879','S','Rio Frio','D','Real','48385','Texas','TX','48','0000','830','Central',-6.0,'Y',29.651527,-99.774446,0,'2013-07-06 12:44:34',NULL,NULL),(55862,'64180','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.101274,-94.582363,0,'2013-07-06 12:44:33',NULL,NULL),(53585,'62067','S','Moro','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.923668,-90.008000,0,'2013-07-06 12:44:33',NULL,NULL),(9371,'09829','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(74356,'92412','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.084156,-117.261759,0,'2013-07-06 12:44:34',NULL,NULL),(67353,'80110','S','Greenwood Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(13117,'13488','S','Maple Valley','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.676969,-74.769177,0,'2013-07-06 12:44:30',NULL,NULL),(98,'00612','S','Urb El Paraiso','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(45453,'51239','S','Hull','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.192568,-96.130531,0,'2013-07-06 12:44:32',NULL,NULL),(18990,'19522','S','Pricetown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(11654,'12133','P','North Hoosick','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.924518,-73.345704,0,'2013-07-06 12:44:30',NULL,NULL),(56952,'66101','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.119223,-94.627014,0,'2013-07-06 12:44:33',NULL,NULL),(62648,'74577','S','Whitesboro','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.690803,-94.857714,0,'2013-07-06 12:44:33',NULL,NULL),(67666,'80487','S','Steamboat Springs','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.488148,-106.868862,0,'2013-07-06 12:44:34',NULL,NULL),(50969,'58631','S','Glen Ullin','D','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.818421,-101.839984,0,'2013-07-06 12:44:33',NULL,NULL),(78572,'98166','S','Burien','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.447460,-122.356560,0,'2013-07-06 12:44:34',NULL,NULL),(38739,'44030','S','Conneaut','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(11183,'11733','S','Old Field','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(6749,'06084','S','Tolland','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.872855,-72.372213,0,'2013-07-06 12:44:30',NULL,NULL),(21717,'23001','P','Achilles','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.281159,-76.440960,0,'2013-07-06 12:44:31',NULL,NULL),(48596,'55784','S','Swan River','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.066819,-93.187769,0,'2013-07-06 12:44:33',NULL,NULL),(11359,'11815','U','L I Power Authority','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.768318,-73.514148,0,'2013-07-06 12:44:30',NULL,NULL),(62149,'73722','S','Burlington','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.909720,-98.435520,0,'2013-07-06 12:44:33',NULL,NULL),(68031,'80927','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.664269,-104.909568,0,'2013-07-06 12:44:34',NULL,NULL),(19129,'19609','S','Lincoln Park','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(63217,'75453','S','Lone Oak','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.995840,-95.940373,0,'2013-07-06 12:44:33',NULL,NULL),(10421,'10708','S','Yonkers','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.940639,-73.822578,0,'2013-07-06 12:44:30',NULL,NULL),(73913,'92020','S','El Cajon','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.793886,-116.965928,0,'2013-07-06 12:44:34',NULL,NULL),(50287,'57652','S','Ridgeview','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.085000,-100.800000,0,'2013-07-06 12:44:33',NULL,NULL),(51006,'58701','S','South Prairie','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230821,-101.294119,0,'2013-07-06 12:44:33',NULL,NULL),(47607,'54876','S','Stone Lake','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.810108,-91.530020,0,'2013-07-06 12:44:33',NULL,NULL),(15624,'16695','S','Woodbury','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.211078,-78.361129,0,'2013-07-06 12:44:31',NULL,NULL),(69324,'83501','S','Lewiston','D','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.388958,-116.986393,0,'2013-07-06 12:44:34',NULL,NULL),(61657,'72904','S','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.403390,-94.389770,0,'2013-07-06 12:44:33',NULL,NULL),(60308,'71454','S','Union Grove','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(29309,'32526','S','Bellview','A','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.478102,-87.324059,0,'2013-07-06 12:44:32',NULL,NULL),(9089,'09049','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19374,'20060','U','Howard University Hospital','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918639,-77.020382,0,'2013-07-06 12:44:31',NULL,NULL),(51749,'60019','U','Despl/Rsmt Bus Rply','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.024981,-87.899607,0,'2013-07-06 12:44:33',NULL,NULL),(73016,'90068','S','Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.120733,-118.335397,0,'2013-07-06 12:44:34',NULL,NULL),(63224,'75457','S','Mt Vernon','A','Franklin','48159','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.180969,-95.227426,0,'2013-07-06 12:44:33',NULL,NULL),(62258,'74006','S','Brtlsville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.738109,-95.933260,0,'2013-07-06 12:44:33',NULL,NULL),(19336,'20032','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(77182,'96319','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76897,'95981','S','Strawberry Valley','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.564167,-121.105833,0,'2013-07-06 12:44:34',NULL,NULL),(37742,'42320','S','Cool Springs','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(34046,'38136','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099619,-90.036265,0,'2013-07-06 12:44:32',NULL,NULL),(25489,'28359','P','Lumberton','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.622961,-79.011063,0,'2013-07-06 12:44:31',NULL,NULL),(60293,'71454','S','Hall','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(67175,'79843','S','Shafter','A','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',30.307094,-104.037151,0,'2013-07-06 12:44:34',NULL,NULL),(73800,'91752','S','Jurupa Valley','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995007,-117.528742,0,'2013-07-06 12:44:34',NULL,NULL),(27634,'30314','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755847,-84.427174,0,'2013-07-06 12:44:31',NULL,NULL),(79821,'99506','S','JBER','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.232052,-149.789210,0,'2013-07-06 12:44:34',NULL,NULL),(68623,'81626','P','Craig','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.562311,-107.571271,0,'2013-07-06 12:44:34',NULL,NULL),(34267,'38462','S','Kimmins','A','Lewis','47101','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.553087,-87.546132,0,'2013-07-06 12:44:32',NULL,NULL),(55135,'63351','S','Jonesburg','D','Montgomery','29139','Missouri','MO','29','0000','636','Central',-6.0,'Y',38.909001,-91.298192,0,'2013-07-06 12:44:33',NULL,NULL),(50276,'57646','S','Campbell','N','Campbell','46021','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.675300,-100.049220,0,'2013-07-06 12:44:33',NULL,NULL),(8677,'08330','S','Belcoville','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440760,-74.728980,0,'2013-07-06 12:44:30',NULL,NULL),(51117,'58788','S','Berwick','A','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.353802,-100.405480,0,'2013-07-06 12:44:33',NULL,NULL),(21175,'22158','U','Springfield Brm','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.812261,-77.256414,0,'2013-07-06 12:44:31',NULL,NULL),(76999,'96079','P','Central Valley','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.691415,-122.344769,0,'2013-07-06 12:44:34',NULL,NULL),(73777,'91743','P','Guasti','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.064884,-117.580297,0,'2013-07-06 12:44:34',NULL,NULL),(37613,'42131','S','Etoile','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.812900,-85.911479,0,'2013-07-06 12:44:32',NULL,NULL),(76646,'95724','P','Norden','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.310380,-120.437220,0,'2013-07-06 12:44:34',NULL,NULL),(67314,'80023','S','Westminster','A','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.953501,-105.036717,0,'2013-07-06 12:44:34',NULL,NULL),(40858,'46228','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(6455,'05759','S','North Clarendon','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.548900,-72.958080,0,'2013-07-06 12:44:30',NULL,NULL),(78390,'98030','S','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.383225,-122.212973,0,'2013-07-06 12:44:34',NULL,NULL),(79513,'98926','S','Thrali','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.999556,-120.542589,0,'2013-07-06 12:44:34',NULL,NULL),(53505,'62014','S','Woodburn','N','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.044260,-89.951789,0,'2013-07-06 12:44:33',NULL,NULL),(37433,'41831','S','Leburn','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.402222,-82.942222,0,'2013-07-06 12:44:32',NULL,NULL),(46221,'52772','S','Buchanan','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.788260,-91.131240,0,'2013-07-06 12:44:32',NULL,NULL),(27059,'29683','P','Slater','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.032403,-82.494379,0,'2013-07-06 12:44:31',NULL,NULL),(5434,'04680','S','Steuben','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.497544,-67.946353,0,'2013-07-06 12:44:30',NULL,NULL),(76987,'96067','S','Mount Shasta','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.356502,-122.348946,0,'2013-07-06 12:44:34',NULL,NULL),(63214,'75450','S','Lake Creek','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.465233,-95.612832,0,'2013-07-06 12:44:33',NULL,NULL),(22063,'23336','S','Chincoteague','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.929948,-75.376428,0,'2013-07-06 12:44:31',NULL,NULL),(20608,'21207','S','Pikesville','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.323820,-76.714260,0,'2013-07-06 12:44:31',NULL,NULL),(14237,'14813','S','Belmont','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.230607,-78.017742,0,'2013-07-06 12:44:31',NULL,NULL),(13502,'13808','S','Elm Grove','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.547176,-75.243080,0,'2013-07-06 12:44:31',NULL,NULL),(24999,'27870','S','Roanoke Rapid','A','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.451430,-77.655125,0,'2013-07-06 12:44:31',NULL,NULL),(30958,'33736','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742754,-82.748427,0,'2013-07-06 12:44:32',NULL,NULL),(46447,'53209','S','River Hills','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.125920,-87.946764,0,'2013-07-06 12:44:32',NULL,NULL),(42751,'48026','S','Fraser','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.534205,-82.950983,0,'2013-07-06 12:44:32',NULL,NULL),(1338,'00736','S','Bo Las Parras','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(57263,'66541','S','Summerfield','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.956625,-96.297143,0,'2013-07-06 12:44:33',NULL,NULL),(78915,'98364','P','Port Gamble','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.836944,-122.594391,0,'2013-07-06 12:44:34',NULL,NULL),(70844,'85541','S','Star Valley','A','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.203600,-111.289860,0,'2013-07-06 12:44:34',NULL,NULL),(40893,'46249','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861999,-86.002044,0,'2013-07-06 12:44:32',NULL,NULL),(47389,'54635','S','Northfield','A','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.394000,-91.030320,0,'2013-07-06 12:44:32',NULL,NULL),(16330,'17125','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266171,-76.880912,0,'2013-07-06 12:44:31',NULL,NULL),(29149,'32335','P','Sumatra','D','Liberty','12077','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023197,-84.979408,0,'2013-07-06 12:44:32',NULL,NULL),(34080,'38151','U','Schering Plough Inc','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.149052,-89.977749,0,'2013-07-06 12:44:32',NULL,NULL),(8912,'08739','P','Normandy Bch','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.999746,-74.064221,0,'2013-07-06 12:44:30',NULL,NULL),(3666,'02124','S','Dorchester Center','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.286139,-71.070555,0,'2013-07-06 12:44:30',NULL,NULL),(43393,'48439','S','Grand Blanc','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.926659,-83.638011,0,'2013-07-06 12:44:32',NULL,NULL),(74949,'93412','P','San Luis Obispo','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.311680,-120.834780,0,'2013-07-06 12:44:34',NULL,NULL),(70101,'84171','P','Cottonwd Hgts','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(35224,'39305','S','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.402996,-88.706033,0,'2013-07-06 12:44:32',NULL,NULL),(36220,'40282','U','Readers Digest','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(40844,'46221','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.699569,-86.233683,0,'2013-07-06 12:44:32',NULL,NULL),(517,'00674','S','Urb Las Gardenias','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(65093,'77357','S','Woodbranch','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.134460,-95.180700,0,'2013-07-06 12:44:34',NULL,NULL),(6662,'06026','S','East Granby','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.934274,-72.746685,0,'2013-07-06 12:44:30',NULL,NULL),(17940,'18507','S','Moosic','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.370930,-75.703801,0,'2013-07-06 12:44:31',NULL,NULL),(41681,'47174','S','Sulphur','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.222890,-86.491470,0,'2013-07-06 12:44:32',NULL,NULL),(72854,'90001','S','Firestone Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.973310,-118.243612,0,'2013-07-06 12:44:34',NULL,NULL),(66095,'78406','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.777491,-97.516057,0,'2013-07-06 12:44:34',NULL,NULL),(6061,'05443','S','West Lincoln','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(41614,'47120','S','Fredericksburg','D','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.433130,-86.189970,0,'2013-07-06 12:44:32',NULL,NULL),(39014,'44142','S','Brook Park','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.398708,-81.832392,0,'2013-07-06 12:44:32',NULL,NULL),(53700,'62232','S','Caseyville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.634957,-90.012889,0,'2013-07-06 12:44:33',NULL,NULL),(55322,'63544','S','Sidney','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.312191,-92.880950,0,'2013-07-06 12:44:33',NULL,NULL),(57436,'66801','S','Emporia','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.409293,-96.189099,0,'2013-07-06 12:44:33',NULL,NULL),(25249,'28110','S','Monroe','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.010982,-80.551224,0,'2013-07-06 12:44:31',NULL,NULL),(73695,'91607','S','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(78219,'97760','S','Crkd Rvr Rnch','A','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358649,-121.184384,0,'2013-07-06 12:44:34',NULL,NULL),(35283,'39401','S','Carterville','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(22036,'23297','U','Richmond','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.399712,-77.457391,0,'2013-07-06 12:44:31',NULL,NULL),(49225,'56468','S','Nisswa','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.504936,-94.283424,0,'2013-07-06 12:44:33',NULL,NULL),(15286,'16125','S','Greenville','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.404860,-80.369580,0,'2013-07-06 12:44:31',NULL,NULL),(12681,'13126','S','Southwest Oswego','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(36963,'41174','S','S Portsmouth','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.706344,-83.011058,0,'2013-07-06 12:44:32',NULL,NULL),(39516,'44814','S','Berlinville','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.327386,-82.477219,0,'2013-07-06 12:44:32',NULL,NULL),(6559,'05847','S','Lowell','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.790453,-72.457109,0,'2013-07-06 12:44:30',NULL,NULL),(41688,'47199','U','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285992,-85.732879,0,'2013-07-06 12:44:32',NULL,NULL),(38611,'43905','P','Barton','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.107657,-80.840421,0,'2013-07-06 12:44:32',NULL,NULL),(75620,'94503','S','Vallejo','A','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.116667,-122.233333,0,'2013-07-06 12:44:34',NULL,NULL),(67477,'80226','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.713584,-105.065468,0,'2013-07-06 12:44:34',NULL,NULL),(37797,'42374','P','South Carrollton','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.335929,-87.142259,0,'2013-07-06 12:44:32',NULL,NULL),(44396,'49814','S','Champion','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.509250,-87.838101,0,'2013-07-06 12:44:32',NULL,NULL),(34487,'38668','S','Barr','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(70798,'85364','S','Yuma','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.701076,-114.646859,0,'2013-07-06 12:44:34',NULL,NULL),(77819,'97202','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.482618,-122.636962,0,'2013-07-06 12:44:34',NULL,NULL),(62716,'74759','S','Soper','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.020552,-95.687894,0,'2013-07-06 12:44:33',NULL,NULL),(9933,'10153','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(52326,'60560','S','Yorkville','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.622305,-88.432040,0,'2013-07-06 12:44:33',NULL,NULL),(67640,'80457','P','Kittredge','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.654710,-105.295448,0,'2013-07-06 12:44:34',NULL,NULL),(32054,'35259','P','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.520556,-86.802500,0,'2013-07-06 12:44:32',NULL,NULL),(11203,'11743','S','Harbor Heights','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(44347,'49775','S','Bois Blanc Island','A','Mackinac','26097','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.764363,-84.467304,0,'2013-07-06 12:44:32',NULL,NULL),(12706,'13147','S','Scipio Center','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(12825,'13305','P','Beaver Fls','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.887639,-75.425266,0,'2013-07-06 12:44:30',NULL,NULL),(10735,'11356','S','College Point','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.786000,-73.844070,0,'2013-07-06 12:44:30',NULL,NULL),(10614,'11042','S','North New Hyde Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757711,-73.697796,0,'2013-07-06 12:44:30',NULL,NULL),(10760,'11362','S','Little Neck','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761850,-73.729718,0,'2013-07-06 12:44:30',NULL,NULL),(20049,'20658','S','Marbury','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.562360,-77.163900,0,'2013-07-06 12:44:31',NULL,NULL),(74639,'92815','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.831943,-117.912104,0,'2013-07-06 12:44:34',NULL,NULL),(60586,'71826','S','Bradley','D','Lafayette','05073','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.112881,-93.649259,0,'2013-07-06 12:44:33',NULL,NULL),(22475,'24055','S','Bassett','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.751969,-79.987513,0,'2013-07-06 12:44:31',NULL,NULL),(24726,'27516','S','Chapel Hill','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.917785,-79.121025,0,'2013-07-06 12:44:31',NULL,NULL),(26807,'29469','S','Pinopolis','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.224163,-80.041291,0,'2013-07-06 12:44:31',NULL,NULL),(27659,'30325','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.791989,-84.447285,0,'2013-07-06 12:44:31',NULL,NULL),(52263,'60525','S','Countryside','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(45198,'50621','S','Conrad','D','Grundy','19075','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.228083,-92.874394,0,'2013-07-06 12:44:32',NULL,NULL),(75986,'95075','S','Tres Pinos','D','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.779945,-121.296876,0,'2013-07-06 12:44:34',NULL,NULL),(67150,'79778','P','Rankin','D','Upton','48461','Texas','TX','48','0000','432','Central',-6.0,'Y',31.225493,-101.943149,0,'2013-07-06 12:44:34',NULL,NULL),(60814,'72032','S','Conway','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(22136,'23451','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.863730,-76.012395,0,'2013-07-06 12:44:31',NULL,NULL),(23753,'25951','S','True','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.667392,-80.883909,0,'2013-07-06 12:44:31',NULL,NULL),(6288,'05647','S','East Cabot','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.400126,-72.297615,0,'2013-07-06 12:44:30',NULL,NULL),(41762,'47302','S','New Burlingtn','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(1942,'00795','S','Villa Norma','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(33800,'37891','S','Whitesburg','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.258729,-83.137811,0,'2013-07-06 12:44:32',NULL,NULL),(41576,'47036','S','Oldenburg','D','Franklin','18047','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.379006,-85.240938,0,'2013-07-06 12:44:32',NULL,NULL),(25,'00603','S','Repto Lopez','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(28472,'31502','P','Waycross','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.210635,-82.359537,0,'2013-07-06 12:44:32',NULL,NULL),(2893,'00987','S','Paseo del Prado','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(19213,'19892','U','Citibank','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.683601,-75.613075,0,'2013-07-06 12:44:31',NULL,NULL),(6363,'05676','S','Colbyville','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.345220,-72.785100,0,'2013-07-06 12:44:30',NULL,NULL),(23430,'25387','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.348986,-81.631166,0,'2013-07-06 12:44:31',NULL,NULL),(10212,'10454','S','Mott Haven','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.808965,-73.916818,0,'2013-07-06 12:44:30',NULL,NULL),(34789,'38869','P','Sherman','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.337307,-88.954321,0,'2013-07-06 12:44:32',NULL,NULL),(76517,'95645','S','Knights Lndg','A','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.859828,-121.732992,0,'2013-07-06 12:44:34',NULL,NULL),(59977,'71325','S','Cheneyville','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.018235,-92.292222,0,'2013-07-06 12:44:33',NULL,NULL),(19886,'20535','U','FBI','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892434,-77.022821,0,'2013-07-06 12:44:31',NULL,NULL),(37139,'41465','S','Foraker','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(37690,'42234','S','Tiny Town','A','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.695643,-87.176930,0,'2013-07-06 12:44:32',NULL,NULL),(49191,'56442','S','Manhattan Bch','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.677300,-94.112100,0,'2013-07-06 12:44:33',NULL,NULL),(3425,'01740','S','Bolton','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.436503,-71.608599,0,'2013-07-06 12:44:30',NULL,NULL),(10235,'10465','S','Throggs Neck','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.823241,-73.826218,0,'2013-07-06 12:44:30',NULL,NULL),(77495,'96826','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.294061,-157.826123,0,'2013-07-06 12:44:34',NULL,NULL),(75413,'94023','P','Los Altos','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.376602,-122.114401,0,'2013-07-06 12:44:34',NULL,NULL),(58035,'68010','P','Boystown','A','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.259761,-96.128888,0,'2013-07-06 12:44:33',NULL,NULL),(55025,'63136','S','Country Club Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(8920,'08742','S','Pt Pleas Bch','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(31828,'35072','S','Goodwater','D','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.063015,-86.041103,0,'2013-07-06 12:44:32',NULL,NULL),(4579,'03576','S','Columbia','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.892390,-71.498526,0,'2013-07-06 12:44:30',NULL,NULL),(22568,'24151','S','Franklin Heights','N','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.000112,-79.895756,0,'2013-07-06 12:44:31',NULL,NULL),(44164,'49544','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.001565,-85.743164,0,'2013-07-06 12:44:32',NULL,NULL),(48195,'55395','S','Winsted','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.964803,-94.048794,0,'2013-07-06 12:44:33',NULL,NULL),(51985,'60155','S','Broadview','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.853946,-87.855949,0,'2013-07-06 12:44:33',NULL,NULL),(23115,'24946','S','Seebert','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.132820,-80.243820,0,'2013-07-06 12:44:31',NULL,NULL),(32940,'36568','P','Saint Elmo','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.496356,-88.284620,0,'2013-07-06 12:44:32',NULL,NULL),(44849,'50268','S','Indianapolis','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.377924,-92.353635,0,'2013-07-06 12:44:32',NULL,NULL),(46108,'52632','S','Mooar','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.472778,-91.448611,0,'2013-07-06 12:44:32',NULL,NULL),(182,'00623','S','Parc Elizabeth','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(74068,'92169','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.799866,-117.251170,0,'2013-07-06 12:44:34',NULL,NULL),(43088,'48208','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.350968,-83.089896,0,'2013-07-06 12:44:32',NULL,NULL),(51086,'58763','S','Newtown','N','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.972700,-102.481620,0,'2013-07-06 12:44:33',NULL,NULL),(24251,'26802','S','Fort Seybert','A','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.640625,-79.198583,0,'2013-07-06 12:44:31',NULL,NULL),(203,'00623','S','Urb Remanso De Cabo Rojo','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(68639,'81637','S','Gypsum','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.633376,-106.954148,0,'2013-07-06 12:44:34',NULL,NULL),(61440,'72585','S','Wideman','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.215052,-92.007034,0,'2013-07-06 12:44:33',NULL,NULL),(60673,'71923','S','Griffithtown','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(12897,'13333','S','East Springfield','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.831907,-74.761141,0,'2013-07-06 12:44:30',NULL,NULL),(5270,'04492','S','Waite','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.345472,-67.694919,0,'2013-07-06 12:44:30',NULL,NULL),(15085,'15756','P','Mc Intyre','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.569874,-79.299788,0,'2013-07-06 12:44:31',NULL,NULL),(33180,'37031','S','Castalian Springs','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.382400,-86.318015,0,'2013-07-06 12:44:32',NULL,NULL),(43621,'48815','S','Clarksville','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',42.844524,-85.247239,0,'2013-07-06 12:44:32',NULL,NULL),(45349,'50980','U','HP-SC/YE','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.581737,-93.639001,0,'2013-07-06 12:44:32',NULL,NULL),(61701,'72958','S','Waldron','D','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.899469,-94.094254,0,'2013-07-06 12:44:33',NULL,NULL),(71920,'87828','S','Polvadera','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.217038,-106.914723,0,'2013-07-06 12:44:34',NULL,NULL),(59611,'71027','S','Frierson','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.235654,-93.677166,0,'2013-07-06 12:44:33',NULL,NULL),(59339,'70546','S','Jennings','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.223918,-92.654187,0,'2013-07-06 12:44:33',NULL,NULL),(5404,'04657','S','Cooper','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.019171,-67.386095,0,'2013-07-06 12:44:30',NULL,NULL),(17089,'17764','S','Renovo','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(24198,'26675','P','Poe','N','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.234705,-80.936228,0,'2013-07-06 12:44:31',NULL,NULL),(10247,'10469','S','Esplanade','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868747,-73.849303,0,'2013-07-06 12:44:30',NULL,NULL),(11519,'12033','S','S Schodack','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535438,-73.709070,0,'2013-07-06 12:44:30',NULL,NULL),(37752,'42323','S','Beechmont','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.177666,-87.050396,0,'2013-07-06 12:44:32',NULL,NULL),(4558,'03458','S','Sharon','A','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.886683,-71.947147,0,'2013-07-06 12:44:30',NULL,NULL),(26675,'29402','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.774463,-79.930662,0,'2013-07-06 12:44:31',NULL,NULL),(69369,'83604','S','Bruneau','D','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.681724,-115.929733,0,'2013-07-06 12:44:34',NULL,NULL),(23825,'26102','P','Parkersburg','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.239752,-81.516397,0,'2013-07-06 12:44:31',NULL,NULL),(7559,'07019','P','East Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.759938,-74.207934,0,'2013-07-06 12:44:30',NULL,NULL),(28714,'31836','S','Woodland','D','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.793372,-84.571930,0,'2013-07-06 12:44:32',NULL,NULL),(42898,'48097','S','Yale','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.116201,-82.794016,0,'2013-07-06 12:44:32',NULL,NULL),(41910,'47374','S','Richmond','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(865,'00698','S','Urb Los Pinos','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(63411,'75652','S','Pleasant Grove','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(57797,'67491','S','Windom','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.386168,-97.906197,0,'2013-07-06 12:44:33',NULL,NULL),(46697,'53788','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075177,-89.378400,0,'2013-07-06 12:44:32',NULL,NULL),(7595,'07041','S','Millburn','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.724998,-74.303620,0,'2013-07-06 12:44:30',NULL,NULL),(51008,'58703','S','Minot','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.266541,-101.312717,0,'2013-07-06 12:44:33',NULL,NULL),(69889,'84103','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.783965,-111.876047,0,'2013-07-06 12:44:34',NULL,NULL),(69406,'83624','S','Grand View','D','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.985300,-116.088493,0,'2013-07-06 12:44:34',NULL,NULL),(39515,'44814','S','Berlin Hts','A','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.327386,-82.477219,0,'2013-07-06 12:44:32',NULL,NULL),(40422,'45695','S','Radcliff','A','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.140833,-82.376944,0,'2013-07-06 12:44:32',NULL,NULL),(16047,'17044','S','Strodes Mills','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(45417,'51053','S','Schaller','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.497581,-95.294879,0,'2013-07-06 12:44:32',NULL,NULL),(26260,'29006','S','New Holland Crossroads','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(17064,'17756','S','Muncy','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(11125,'11706','S','Bay Shore','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(37506,'42033','P','Crayne','D','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.271858,-88.079526,0,'2013-07-06 12:44:32',NULL,NULL),(41939,'47390','S','New Pittsburg','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.202822,-84.817856,0,'2013-07-06 12:44:32',NULL,NULL),(25268,'28125','S','Mount Ulla','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.640595,-80.716219,0,'2013-07-06 12:44:31',NULL,NULL),(73918,'92023','P','Encinitas','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.034774,-117.293255,0,'2013-07-06 12:44:34',NULL,NULL),(66682,'78940','S','Shelby','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.942640,-96.681300,0,'2013-07-06 12:44:34',NULL,NULL),(62760,'74851','S','McLoud','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.425500,-97.104600,0,'2013-07-06 12:44:33',NULL,NULL),(4206,'02831','S','Scituate','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.745013,-71.571255,0,'2013-07-06 12:44:30',NULL,NULL),(19793,'20434','U','Resolution Trust Corporation','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892939,-77.038927,0,'2013-07-06 12:44:31',NULL,NULL),(15855,'16943','S','Cathead','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843054,-77.545629,0,'2013-07-06 12:44:31',NULL,NULL),(20870,'21669','P','Taylors Island','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.472517,-76.276180,0,'2013-07-06 12:44:31',NULL,NULL),(19132,'19609','S','West Lawn','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(3946,'02472','S','East Watertown','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.371297,-71.180361,0,'2013-07-06 12:44:30',NULL,NULL),(620,'00682','S','Bo Mani','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(8998,'08850','S','Milltown','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.449018,-74.435113,0,'2013-07-06 12:44:30',NULL,NULL),(45048,'50483','S','Sexton','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.084090,-93.993811,0,'2013-07-06 12:44:32',NULL,NULL),(42589,'47885','S','Barnhart Town','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(7909,'07621','S','Bergenfield','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.925835,-74.001883,0,'2013-07-06 12:44:30',NULL,NULL),(47352,'54612','S','Arcadia','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.249616,-91.495065,0,'2013-07-06 12:44:32',NULL,NULL),(76029,'95140','S','Mt Hamilton','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.354500,-121.721340,0,'2013-07-06 12:44:34',NULL,NULL),(71647,'87421','S','Waterflow','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.742759,-108.471295,0,'2013-07-06 12:44:34',NULL,NULL),(54140,'62565','S','Clarksburg','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(15012,'15672','S','New Stanton','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.223191,-79.605531,0,'2013-07-06 12:44:31',NULL,NULL),(36206,'40270','P','Valley Statn','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.253553,-85.757909,0,'2013-07-06 12:44:32',NULL,NULL),(27120,'29742','S','Sharon','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.913210,-81.344760,0,'2013-07-06 12:44:31',NULL,NULL),(51959,'60139','S','Glendale Heights','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.918876,-88.076541,0,'2013-07-06 12:44:33',NULL,NULL),(19778,'20424','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895393,-77.031186,0,'2013-07-06 12:44:31',NULL,NULL),(28614,'31707','S','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.580916,-84.221680,0,'2013-07-06 12:44:32',NULL,NULL),(75623,'94506','S','Blackhawk','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.810650,-121.912874,0,'2013-07-06 12:44:34',NULL,NULL),(71537,'87151','U','Metropolitan Detention Ctr','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.025130,-106.856084,0,'2013-07-06 12:44:34',NULL,NULL),(50429,'57791','S','Gumbo','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.094970,-102.335284,0,'2013-07-06 12:44:33',NULL,NULL),(64802,'77022','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.829065,-95.374595,0,'2013-07-06 12:44:34',NULL,NULL),(60883,'72065','S','East End','N','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.529520,-92.222460,0,'2013-07-06 12:44:33',NULL,NULL),(21626,'22908','U','Un Va Med Ctr','N','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.035452,-78.514913,0,'2013-07-06 12:44:31',NULL,NULL),(17816,'18411','S','Clarks Summit','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(23148,'24986','S','Wht Sulphur Spgs','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797867,-80.296195,0,'2013-07-06 12:44:31',NULL,NULL),(47141,'54457','S','Rome','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.251920,-89.861040,0,'2013-07-06 12:44:32',NULL,NULL),(40034,'45250','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118985,-84.547916,0,'2013-07-06 12:44:32',NULL,NULL),(32644,'36207','S','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.680609,-85.710854,0,'2013-07-06 12:44:32',NULL,NULL),(6460,'05761','S','Brimstone Corners','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(63965,'76101','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.759439,-97.329119,0,'2013-07-06 12:44:34',NULL,NULL),(70631,'85140','S','San Tan Valley','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.236620,-111.543690,0,'2013-07-06 12:44:34',NULL,NULL),(8805,'08609','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.222505,-74.741462,0,'2013-07-06 12:44:30',NULL,NULL),(75147,'93561','S','Monolith','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(69079,'83246','S','Lava Hot Springs','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.609094,-112.026692,0,'2013-07-06 12:44:34',NULL,NULL),(40149,'45349','P','N Hampton','N','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.989041,-83.939918,0,'2013-07-06 12:44:32',NULL,NULL),(45405,'51044','S','Oto','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.281336,-95.893624,0,'2013-07-06 12:44:32',NULL,NULL),(2429,'00953','S','Urb Fuentebella','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(22928,'24622','S','Jewell Ridge','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.226926,-81.810969,0,'2013-07-06 12:44:31',NULL,NULL),(36709,'41018','S','Covington','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.009027,-84.598071,0,'2013-07-06 12:44:32',NULL,NULL),(20908,'21719','S','Fort Ritchie','A','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.709736,-77.493313,0,'2013-07-06 12:44:31',NULL,NULL),(9885,'10125','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.753195,-74.000885,0,'2013-07-06 12:44:30',NULL,NULL),(78316,'97910','S','South Mountain','A','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(36791,'41051','S','Independence','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.941955,-84.552352,0,'2013-07-06 12:44:32',NULL,NULL),(78317,'97910','S','South Mtn','A','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(29167,'32352','S','Mt Pleasant','A','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.686033,-84.826115,0,'2013-07-06 12:44:32',NULL,NULL),(48791,'56003','S','Mankato','D','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.185763,-94.056217,0,'2013-07-06 12:44:33',NULL,NULL),(4844,'04011','S','Brunswick','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.905571,-69.964566,0,'2013-07-06 12:44:30',NULL,NULL),(15213,'16016','U','Social Security Admin','N','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.106482,-79.897055,0,'2013-07-06 12:44:31',NULL,NULL),(9319,'09731','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71072,'85911','P','Show Low','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.046700,-110.484957,0,'2013-07-06 12:44:34',NULL,NULL),(33743,'37840','S','Oliver Spgs','A','Roane','47145','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.032719,-84.324441,0,'2013-07-06 12:44:32',NULL,NULL),(36926,'41159','S','Martha','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.011172,-82.957727,0,'2013-07-06 12:44:32',NULL,NULL),(786,'00693','S','Bo Pueblo Nuevo','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(37988,'42742','S','Gradyville','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.046490,-85.437092,0,'2013-07-06 12:44:32',NULL,NULL),(35061,'39183','S','Letourneau','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.390993,-90.829096,0,'2013-07-06 12:44:32',NULL,NULL),(77920,'97317','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503','Pacific',-8.0,'Y',44.966504,-123.003598,0,'2013-07-06 12:44:34',NULL,NULL),(76688,'95819','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.569682,-121.438018,0,'2013-07-06 12:44:34',NULL,NULL),(70078,'84151','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.787872,-111.938789,0,'2013-07-06 12:44:34',NULL,NULL),(16218,'17074','S','Bailey','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(68589,'81525','S','New Liberty','N','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.236370,-108.849029,0,'2013-07-06 12:44:34',NULL,NULL),(72956,'90042','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.118577,-118.189925,0,'2013-07-06 12:44:34',NULL,NULL),(19139,'19611','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324211,-75.944403,0,'2013-07-06 12:44:31',NULL,NULL),(42578,'47879','S','Jackson Hill','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(49709,'57034','S','Norway Center','N','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.130420,-96.455230,0,'2013-07-06 12:44:33',NULL,NULL),(13841,'14223','S','Hiler','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(65856,'78207','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.421586,-98.523179,0,'2013-07-06 12:44:34',NULL,NULL),(2373,'00949','S','Sect La Pra','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(37275,'41601','S','Old Allen','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.657284,-82.701808,0,'2013-07-06 12:44:32',NULL,NULL),(33649,'37708','S','Bean Station','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.338879,-83.325091,0,'2013-07-06 12:44:32',NULL,NULL),(16859,'17563','S','Peach Bottom','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(58793,'68980','S','Leicester','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.627431,-98.095825,0,'2013-07-06 12:44:33',NULL,NULL),(40088,'45304','S','Ithaca','A','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.989474,-84.534278,0,'2013-07-06 12:44:32',NULL,NULL),(18575,'19128','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.042066,-75.225337,0,'2013-07-06 12:44:31',NULL,NULL),(2056,'00920','S','Monterrey Ind Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(78591,'98178','S','Tukwila','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.492862,-122.249902,0,'2013-07-06 12:44:34',NULL,NULL),(76956,'96040','S','Hat Creek','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.814467,-121.506933,0,'2013-07-06 12:44:34',NULL,NULL),(18539,'19111','S','Rhawnhurst','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057937,-75.081966,0,'2013-07-06 12:44:31',NULL,NULL),(65815,'78143','P','Pandora','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.246576,-97.834339,0,'2013-07-06 12:44:34',NULL,NULL),(56031,'64680','P','Norborne','A','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.424328,-93.757542,0,'2013-07-06 12:44:33',NULL,NULL),(52772,'61262','S','Lynn','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.287020,-90.332520,0,'2013-07-06 12:44:33',NULL,NULL),(30304,'33301','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.120250,-80.129547,0,'2013-07-06 12:44:32',NULL,NULL),(36686,'41015','S','Taylor Mill','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(49633,'56935','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(49773,'57070','S','Swan Lake','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.189920,-97.116960,0,'2013-07-06 12:44:33',NULL,NULL),(64220,'76271','S','Tioga','D','Grayson','48181','Texas','TX','48','7640','254','Central',-6.0,'Y',33.471938,-96.888923,0,'2013-07-06 12:44:34',NULL,NULL),(47076,'54429','P','Elderon','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.782305,-89.246015,0,'2013-07-06 12:44:32',NULL,NULL),(7029,'06267','P','S Woodstock','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.930199,-71.958971,0,'2013-07-06 12:44:30',NULL,NULL),(35979,'40115','S','Dyer','N','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.753035,-86.249373,0,'2013-07-06 12:44:32',NULL,NULL),(75787,'94706','S','Kensington','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.888234,-122.293954,0,'2013-07-06 12:44:34',NULL,NULL),(58790,'68979','S','Bixby','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.605438,-97.861006,0,'2013-07-06 12:44:33',NULL,NULL),(11395,'11949','S','Manorville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.852180,-72.788976,0,'2013-07-06 12:44:30',NULL,NULL),(24820,'27605','S','Cameron Village','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.790341,-78.653956,0,'2013-07-06 12:44:31',NULL,NULL),(14133,'14653','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.152130,-77.623329,0,'2013-07-06 12:44:31',NULL,NULL),(31111,'33888','U','State Farm Ins','N','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.044236,-81.722199,0,'2013-07-06 12:44:32',NULL,NULL),(24025,'26377','S','Alvy','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.499919,-80.641416,0,'2013-07-06 12:44:31',NULL,NULL),(36437,'40598','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.050332,-84.497840,0,'2013-07-06 12:44:32',NULL,NULL),(34252,'38425','S','Clifton','D','Wayne','47181','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.388057,-87.990069,0,'2013-07-06 12:44:32',NULL,NULL),(1304,'00731','S','Urb Riberas De Bucana','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014073,-66.617175,0,'2013-07-06 12:44:30',NULL,NULL),(22807,'24476','S','Steeles Tavrn','A','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.926887,-79.200418,0,'2013-07-06 12:44:31',NULL,NULL),(39387,'44654','S','Bunker Hill','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.545778,-81.873263,0,'2013-07-06 12:44:32',NULL,NULL),(37907,'42633','S','Gregory','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(36789,'41049','S','Ringos Mills','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.285556,-83.678852,0,'2013-07-06 12:44:32',NULL,NULL),(24462,'27231','S','Cedar Grove','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.192187,-79.165321,0,'2013-07-06 12:44:31',NULL,NULL),(50446,'58013','S','Cayuga','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.138155,-97.426616,0,'2013-07-06 12:44:33',NULL,NULL),(80075,'99731','S','Delta Jct','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.007436,-145.352807,0,'2013-07-06 12:44:34',NULL,NULL),(72247,'88524','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810427,-106.419393,0,'2013-07-06 12:44:34',NULL,NULL),(65839,'78156','P','Seguin','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.567321,-97.930858,0,'2013-07-06 12:44:34',NULL,NULL),(64512,'76634','S','Norse','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(61210,'72311','P','Aubrey','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.687108,-90.939626,0,'2013-07-06 12:44:33',NULL,NULL),(7552,'07015','P','Clifton','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.891952,-74.131272,0,'2013-07-06 12:44:30',NULL,NULL),(33179,'37031','S','Castalian Spg','N','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.382400,-86.318015,0,'2013-07-06 12:44:32',NULL,NULL),(68888,'82715','S','Newcastle','A','Weston','56045','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.123796,-104.118400,0,'2013-07-06 12:44:34',NULL,NULL),(26802,'29465','P','Mount Pleasant','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.794330,-79.860810,0,'2013-07-06 12:44:31',NULL,NULL),(17142,'17801','S','Klines Grove','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(27955,'30545','S','Helen','D','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.702300,-83.726338,0,'2013-07-06 12:44:31',NULL,NULL),(56646,'65613','S','Slagle','N','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.613564,-93.414989,0,'2013-07-06 12:44:33',NULL,NULL),(36298,'40359','S','Wheatley','A','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.478600,-84.814080,0,'2013-07-06 12:44:32',NULL,NULL),(20048,'20657','S','Lusby','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.375290,-76.337326,0,'2013-07-06 12:44:31',NULL,NULL),(51417,'59446','S','Geraldine','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.601836,-110.269770,0,'2013-07-06 12:44:33',NULL,NULL),(65628,'77963','S','Goliad','D','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(39613,'44882','S','Belle Vernon','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(44178,'49555','U','Radio Bible Class','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.969643,-85.665859,0,'2013-07-06 12:44:32',NULL,NULL),(44070,'49444','S','Norton Shores','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168440,-86.184540,0,'2013-07-06 12:44:32',NULL,NULL),(37723,'42276','S','Cave Spring','N','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(50895,'58540','S','Garrison','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.653205,-101.416654,0,'2013-07-06 12:44:33',NULL,NULL),(31108,'33885','P','Florence Vill','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.053367,-81.712064,0,'2013-07-06 12:44:32',NULL,NULL),(67422,'80151','P','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643942,-104.984296,0,'2013-07-06 12:44:34',NULL,NULL),(78911,'98363','S','Port Angeles','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.118410,-123.480610,0,'2013-07-06 12:44:34',NULL,NULL),(77272,'96606','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(14002,'14520','P','Ontario Center','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.227431,-77.306963,0,'2013-07-06 12:44:31',NULL,NULL),(58640,'68869','S','Sweetwater','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(56719,'65686','S','Kimberling City','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.640893,-93.423901,0,'2013-07-06 12:44:33',NULL,NULL),(32840,'36481','S','Hybart','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.823614,-87.310611,0,'2013-07-06 12:44:32',NULL,NULL),(9674,'10041','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(39972,'45238','S','Covedale','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.110911,-84.613884,0,'2013-07-06 12:44:32',NULL,NULL),(28062,'30680','S','Winder','D','Barrow','13013','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.001056,-83.724148,0,'2013-07-06 12:44:31',NULL,NULL),(56785,'65754','S','Spokane','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.855001,-93.269804,0,'2013-07-06 12:44:33',NULL,NULL),(67243,'79942','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.762715,-106.478179,0,'2013-07-06 12:44:34',NULL,NULL),(44777,'50213','S','Osceola','D','Clarke','19039','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.036668,-93.763856,0,'2013-07-06 12:44:32',NULL,NULL),(78263,'97846','S','Joseph','D','Wallowa','41063','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.353045,-117.228443,0,'2013-07-06 12:44:34',NULL,NULL),(58863,'69150','S','Madrid','D','Perkins','31135','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.852380,-101.534267,0,'2013-07-06 12:44:33',NULL,NULL),(37049,'41301','S','Bethany','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(77748,'97089','S','Happy Valley','N','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.422127,-122.449928,0,'2013-07-06 12:44:34',NULL,NULL),(74222,'92314','S','Big Bear City','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.255983,-116.837555,0,'2013-07-06 12:44:34',NULL,NULL),(6716,'06068','S','Salisbury','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.022364,-73.400985,0,'2013-07-06 12:44:30',NULL,NULL),(8010,'07722','S','Earle Naval Weapons Station','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.309639,-74.182060,0,'2013-07-06 12:44:30',NULL,NULL),(57840,'67552','S','Fellsburg','N','Edwards','20047','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.935830,-99.255148,0,'2013-07-06 12:44:33',NULL,NULL),(7682,'07101','P','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.725761,-74.172221,0,'2013-07-06 12:44:30',NULL,NULL),(6293,'05650','S','South Woodbury','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.351384,-72.439832,0,'2013-07-06 12:44:30',NULL,NULL),(24561,'27299','S','Linwood','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.789855,-80.379540,0,'2013-07-06 12:44:31',NULL,NULL),(24918,'27804','S','Wesleyan Col','A','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.974314,-77.831514,0,'2013-07-06 12:44:31',NULL,NULL),(79635,'99133','S','Grand Coulee','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.929898,-118.999444,0,'2013-07-06 12:44:34',NULL,NULL),(76792,'95945','S','Boston Ravine','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(10541,'10994','S','West Nyack','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.099095,-73.973848,0,'2013-07-06 12:44:30',NULL,NULL),(25590,'28445','S','Surf City','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.479960,-77.502360,0,'2013-07-06 12:44:31',NULL,NULL),(29512,'32771','S','Sanford','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.794190,-81.297139,0,'2013-07-06 12:44:32',NULL,NULL),(33910,'38053','S','Cloverdale','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(78124,'97524','S','Eagle Point','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.484176,-122.771386,0,'2013-07-06 12:44:34',NULL,NULL),(79566,'99016','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.643255,-117.151477,0,'2013-07-06 12:44:34',NULL,NULL),(872,'00698','S','Villa Milagros','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(39314,'44515','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.099874,-80.751233,0,'2013-07-06 12:44:32',NULL,NULL),(42019,'47433','S','Hollybrook Lake','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.302962,-86.623199,0,'2013-07-06 12:44:32',NULL,NULL),(15779,'16922','S','Carter Camp','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.712840,-77.662020,0,'2013-07-06 12:44:31',NULL,NULL),(44872,'50310','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.626925,-93.672635,0,'2013-07-06 12:44:32',NULL,NULL),(30450,'33332','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(43772,'49031','S','Cassopolis','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.903522,-85.989471,0,'2013-07-06 12:44:32',NULL,NULL),(21575,'22833','P','Lacey Spring','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.549055,-78.735050,0,'2013-07-06 12:44:31',NULL,NULL),(71447,'87041','S','Sile','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.638320,-106.348620,0,'2013-07-06 12:44:34',NULL,NULL),(70749,'85322','S','Arlington','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.304639,-112.780664,0,'2013-07-06 12:44:34',NULL,NULL),(59701,'71101','S','La Chute','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.504787,-93.746306,0,'2013-07-06 12:44:33',NULL,NULL),(20532,'21102','S','Lineboro','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.643550,-76.696400,0,'2013-07-06 12:44:31',NULL,NULL),(8188,'07901','S','Summit','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.714694,-74.362930,0,'2013-07-06 12:44:30',NULL,NULL),(55497,'63775','S','Biehle','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(15240,'16040','S','Hilliards','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091111,-79.848962,0,'2013-07-06 12:44:31',NULL,NULL),(79046,'98409','S','Lakewood','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.207636,-122.478327,0,'2013-07-06 12:44:34',NULL,NULL),(73622,'91406','S','Lake Balboa','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201751,-118.492685,0,'2013-07-06 12:44:34',NULL,NULL),(61394,'72539','S','Glencoe','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.294145,-91.775990,0,'2013-07-06 12:44:33',NULL,NULL),(18419,'19061','S','Garnet Valley','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(74329,'92402','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.078958,-117.462404,0,'2013-07-06 12:44:34',NULL,NULL),(8292,'08021','S','Clementon','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(4320,'02914','S','East Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.814172,-71.373425,0,'2013-07-06 12:44:30',NULL,NULL),(73716,'91614','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.393815,0,'2013-07-06 12:44:34',NULL,NULL),(23671,'25833','P','Dothan','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.989553,-81.212484,0,'2013-07-06 12:44:31',NULL,NULL),(2720,'00969','S','Urb Apolo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(37892,'42603','S','Alpha','D','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.783402,-85.083842,0,'2013-07-06 12:44:32',NULL,NULL),(53849,'62321','S','Webster','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(37284,'41606','S','Bevinsville','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.335525,-82.715205,0,'2013-07-06 12:44:32',NULL,NULL),(70591,'85086','S','Anthem','A','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.846680,-112.093223,0,'2013-07-06 12:44:34',NULL,NULL),(64609,'76687','S','Odds','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(33963,'38106','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.107211,-90.042832,0,'2013-07-06 12:44:32',NULL,NULL),(18092,'18707','S','Wilkes Barre','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.144606,-75.925343,0,'2013-07-06 12:44:31',NULL,NULL),(65951,'78266','S','Bracken','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.630375,-98.305497,0,'2013-07-06 12:44:34',NULL,NULL),(56963,'66112','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.114713,-94.761266,0,'2013-07-06 12:44:33',NULL,NULL),(9034,'08876','S','Finderne','N','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.543740,-74.660040,0,'2013-07-06 12:44:30',NULL,NULL),(9601,'10030','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(2115,'00924','S','65th Infantry','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(52505,'60803','S','Alsip','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.667210,-87.740131,0,'2013-07-06 12:44:33',NULL,NULL),(56292,'65079','S','Sunrise Beach','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.167464,-92.692727,0,'2013-07-06 12:44:33',NULL,NULL),(18795,'19383','U','West Chester University','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.957668,-75.604923,0,'2013-07-06 12:44:31',NULL,NULL),(65482,'77641','P','Port Arthur','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.792326,-93.934019,0,'2013-07-06 12:44:34',NULL,NULL),(33945,'38076','S','Rossville','A','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.167612,-89.377588,0,'2013-07-06 12:44:32',NULL,NULL),(28711,'31831','S','Waverly Hall','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.692717,-84.743192,0,'2013-07-06 12:44:32',NULL,NULL),(34067,'38147','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142153,-90.054546,0,'2013-07-06 12:44:32',NULL,NULL),(9283,'09633','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(59648,'71044','S','Mira','A','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.957220,-93.903720,0,'2013-07-06 12:44:33',NULL,NULL),(2533,'00959','S','Alt del Rio','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(3812,'02293','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358203,-71.061092,0,'2013-07-06 12:44:30',NULL,NULL),(22158,'23460','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.814484,-76.025796,0,'2013-07-06 12:44:31',NULL,NULL),(75958,'95044','P','Redwood Estates','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.158418,-121.984871,0,'2013-07-06 12:44:34',NULL,NULL),(67234,'79931','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.809604,-106.443567,0,'2013-07-06 12:44:34',NULL,NULL),(7994,'07717','S','Avon by Sea','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.192871,-74.017170,0,'2013-07-06 12:44:30',NULL,NULL),(34095,'38167','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.255312,-90.030337,0,'2013-07-06 12:44:32',NULL,NULL),(72849,'89835','S','Wells','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(35199,'39288','P','JXN','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.300020,-90.145549,0,'2013-07-06 12:44:32',NULL,NULL),(60806,'72031','S','Koch Ridge','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(8060,'07746','S','Marlboro','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.319065,-74.263182,0,'2013-07-06 12:44:30',NULL,NULL),(9367,'09825','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(49975,'57356','S','Ravinia','A','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.157659,-98.538151,0,'2013-07-06 12:44:33',NULL,NULL),(73830,'91773','S','San Dimas','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.098850,-117.818110,0,'2013-07-06 12:44:34',NULL,NULL),(68801,'82428','S','Hyattville','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.274515,-107.588416,0,'2013-07-06 12:44:34',NULL,NULL),(19640,'20265','U','Philatelic Sales Division','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884326,-77.020200,0,'2013-07-06 12:44:31',NULL,NULL),(20884,'21701','S','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.418320,-77.336160,0,'2013-07-06 12:44:31',NULL,NULL),(47592,'54862','S','Ojibwa','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.803741,-91.114126,0,'2013-07-06 12:44:33',NULL,NULL),(18788,'19380','S','West Bradford','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.982089,-75.603385,0,'2013-07-06 12:44:31',NULL,NULL),(65849,'78201','S','Balcones Hts','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.467240,-98.530042,0,'2013-07-06 12:44:34',NULL,NULL),(75805,'94803','S','El Sobrante','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972375,-122.289337,0,'2013-07-06 12:44:34',NULL,NULL),(41546,'47010','S','Bath','D','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.489557,-84.837882,0,'2013-07-06 12:44:32',NULL,NULL),(47886,'55102','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.930600,-93.122103,0,'2013-07-06 12:44:33',NULL,NULL),(59258,'70446','S','Loranger','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.636570,-90.445237,0,'2013-07-06 12:44:33',NULL,NULL),(57249,'66532','S','Leona','A','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.816900,-95.393820,0,'2013-07-06 12:44:33',NULL,NULL),(53477,'61940','S','Metcalf','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.804258,-87.807725,0,'2013-07-06 12:44:33',NULL,NULL),(50547,'58202','S','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.918885,-97.073180,0,'2013-07-06 12:44:33',NULL,NULL),(19630,'20251','U','Dept Ag Ofc Outside Hq','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886154,-77.021863,0,'2013-07-06 12:44:31',NULL,NULL),(69005,'83203','P','Gibson','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.990305,-112.424758,0,'2013-07-06 12:44:34',NULL,NULL),(11628,'12116','S','Chaseville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.542837,-74.899432,0,'2013-07-06 12:44:30',NULL,NULL),(44147,'49519','S','Grand Rapids','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.901059,-85.704730,0,'2013-07-06 12:44:32',NULL,NULL),(28466,'31418','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.150637,-81.194558,0,'2013-07-06 12:44:32',NULL,NULL),(78702,'98260','S','Langley','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.033663,-122.450203,0,'2013-07-06 12:44:34',NULL,NULL),(32255,'35618','S','Courtland','D','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.652816,-87.299297,0,'2013-07-06 12:44:32',NULL,NULL),(39828,'45154','S','Bardwell','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',39.046508,-83.928470,0,'2013-07-06 12:44:32',NULL,NULL),(40394,'45663','S','West Portsmouth','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.749260,-82.987860,0,'2013-07-06 12:44:32',NULL,NULL),(78392,'98032','S','Kent','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.392732,-122.260066,0,'2013-07-06 12:44:34',NULL,NULL),(64642,'76711','S','Beverly Hills','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.512973,-97.163580,0,'2013-07-06 12:44:34',NULL,NULL),(25383,'28262','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.320146,-80.741193,0,'2013-07-06 12:44:31',NULL,NULL),(41758,'47302','S','Cowan','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(5057,'04275','S','Frye','N','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.688667,-70.639514,0,'2013-07-06 12:44:30',NULL,NULL),(14993,'15656','S','Leechburg','D','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.629851,-79.604848,0,'2013-07-06 12:44:31',NULL,NULL),(56740,'65713','S','Niangua','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.399093,-92.742234,0,'2013-07-06 12:44:33',NULL,NULL),(62900,'75068','S','Lakewood Vlg','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.168674,-96.961589,0,'2013-07-06 12:44:33',NULL,NULL),(59469,'70744','S','Holden','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.510212,-90.658560,0,'2013-07-06 12:44:33',NULL,NULL),(11419,'11963','S','North Haven','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.972440,-72.324540,0,'2013-07-06 12:44:30',NULL,NULL),(47731,'55010','P','Castle Rock','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.572845,-93.124072,0,'2013-07-06 12:44:33',NULL,NULL),(66394,'78626','S','Georgetown','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.637620,-97.659840,0,'2013-07-06 12:44:34',NULL,NULL),(72960,'90043','S','Windsor Hills','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.990206,-118.335759,0,'2013-07-06 12:44:34',NULL,NULL),(30537,'33408','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(7579,'07031','S','North Arlington','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.792821,-74.128838,0,'2013-07-06 12:44:30',NULL,NULL),(60633,'71901','S','Mt Valley','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(58265,'68379','S','Johnson','A','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.522306,-95.868586,0,'2013-07-06 12:44:33',NULL,NULL),(31498,'34446','S','Homosassa Springs','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.747053,-82.526574,0,'2013-07-06 12:44:32',NULL,NULL),(32163,'35474','S','Moundville','D','Hale','01065','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.007906,-87.600750,0,'2013-07-06 12:44:32',NULL,NULL),(39197,'44328','U','Akron Beacon Journal','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.087158,-81.506914,0,'2013-07-06 12:44:32',NULL,NULL),(22051,'23316','P','Cheriton','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.276590,-75.961122,0,'2013-07-06 12:44:31',NULL,NULL),(4111,'02717','S','East Freetown','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.768046,-70.971988,0,'2013-07-06 12:44:30',NULL,NULL),(18422,'19061','S','Marcus Hook','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(23199,'25062','S','Dry Creek','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.872468,-81.428840,0,'2013-07-06 12:44:31',NULL,NULL),(23084,'24902','P','Fairlea','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.777986,-80.453921,0,'2013-07-06 12:44:31',NULL,NULL),(38693,'43988','S','Scio','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.377948,-81.121554,0,'2013-07-06 12:44:32',NULL,NULL),(21341,'22427','S','Bowling Grn','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.049038,-77.350933,0,'2013-07-06 12:44:31',NULL,NULL),(31927,'35179','S','South Vinemont','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.264921,-87.009412,0,'2013-07-06 12:44:32',NULL,NULL),(79274,'98572','S','Peell','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.566487,-123.305284,0,'2013-07-06 12:44:34',NULL,NULL),(78337,'98004','S','Beaux Arts','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(62300,'74023','S','Schlegal','N','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.976349,-96.764819,0,'2013-07-06 12:44:33',NULL,NULL),(65291,'77488','S','Crescent','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(75639,'94520','S','Clyde','N','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.985575,-122.035167,0,'2013-07-06 12:44:34',NULL,NULL),(41190,'46721','S','Butler','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.413936,-84.885428,0,'2013-07-06 12:44:32',NULL,NULL),(53260,'61704','S','Covell','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.479447,-88.950844,0,'2013-07-06 12:44:33',NULL,NULL),(50517,'58078','S','Riverside','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.886111,-96.900000,0,'2013-07-06 12:44:33',NULL,NULL),(41937,'47390','S','Bartonia','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.202822,-84.817856,0,'2013-07-06 12:44:32',NULL,NULL),(24162,'26601','S','Centralia','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.672330,-80.687532,0,'2013-07-06 12:44:31',NULL,NULL),(52676,'61078','S','Shannon','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.147996,-89.735520,0,'2013-07-06 12:44:33',NULL,NULL),(40473,'45768','S','Newport','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.403143,-81.268730,0,'2013-07-06 12:44:32',NULL,NULL),(52241,'60511','S','Big Rock','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.748526,-88.532219,0,'2013-07-06 12:44:33',NULL,NULL),(28478,'31513','S','Baxley','D','Appling','13001','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.772585,-82.351151,0,'2013-07-06 12:44:32',NULL,NULL),(17526,'17970','S','East Mines','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.746000,-76.208460,0,'2013-07-06 12:44:31',NULL,NULL),(11354,'11801','S','Hicksville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.766663,-73.516470,0,'2013-07-06 12:44:30',NULL,NULL),(12385,'12919','S','Perrys Mills','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.965140,-73.434300,0,'2013-07-06 12:44:30',NULL,NULL),(29888,'33042','S','Sugarloaf Shrs','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(58455,'68724','S','Spade','N','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.614295,-97.892406,0,'2013-07-06 12:44:33',NULL,NULL),(71970,'88012','S','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.408123,-106.707551,0,'2013-07-06 12:44:34',NULL,NULL),(78801,'98326','S','Clallam Bay','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.171357,-124.279900,0,'2013-07-06 12:44:34',NULL,NULL),(28820,'32080','S','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(23791,'26003','S','Mozart','A','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(43118,'48226','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.332339,-83.051131,0,'2013-07-06 12:44:32',NULL,NULL),(61059,'72121','S','McJester','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(7744,'07305','S','Ellis Island','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.693860,-74.078820,0,'2013-07-06 12:44:30',NULL,NULL),(21858,'23148','S','Cauthornville','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.914841,-77.076387,0,'2013-07-06 12:44:31',NULL,NULL),(9921,'10151','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(917,'00707','S','Villa Alegre','N','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(36579,'40951','P','Hima','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.118439,-83.774727,0,'2013-07-06 12:44:32',NULL,NULL),(9752,'10102','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(37385,'41749','S','Kaliopi','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164468,-83.437621,0,'2013-07-06 12:44:32',NULL,NULL),(41438,'46861','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069251,-85.163346,0,'2013-07-06 12:44:32',NULL,NULL),(28088,'30738','S','Rising Fawn','D','Dade','13083','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.782056,-85.444826,0,'2013-07-06 12:44:31',NULL,NULL),(48024,'55301','S','Otsego','A','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.239613,-93.654947,0,'2013-07-06 12:44:33',NULL,NULL),(27318,'30026','P','Duluth','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.976579,-84.150049,0,'2013-07-06 12:44:31',NULL,NULL),(22920,'24609','S','Wardell','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083840,-81.768540,0,'2013-07-06 12:44:31',NULL,NULL),(78710,'98270','S','Marysville','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.060880,-122.153881,0,'2013-07-06 12:44:34',NULL,NULL),(32922,'36558','S','Barlow','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(2241,'00926','S','Urb La Alborada','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(55605,'63950','S','Lodi','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.245256,-90.465916,0,'2013-07-06 12:44:33',NULL,NULL),(48529,'55748','S','Hill City','D','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.988100,-93.593880,0,'2013-07-06 12:44:33',NULL,NULL),(20016,'20620','S','Callaway','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.235472,-76.522110,0,'2013-07-06 12:44:31',NULL,NULL),(49077,'56320','S','Cold Spring','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.460008,-94.426927,0,'2013-07-06 12:44:33',NULL,NULL),(14663,'15238','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.530285,-79.876419,0,'2013-07-06 12:44:31',NULL,NULL),(75302,'93740','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.823910,-119.758958,0,'2013-07-06 12:44:34',NULL,NULL),(5194,'04448','S','Howland','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.240115,-68.661207,0,'2013-07-06 12:44:30',NULL,NULL),(41745,'47272','S','St Paul','N','Decatur','18031','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.430872,-85.633781,0,'2013-07-06 12:44:32',NULL,NULL),(46440,'53207','S','Saint Francis','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.980668,-87.892825,0,'2013-07-06 12:44:32',NULL,NULL),(752,'00692','S','Ext Sanchez','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(56053,'64735','S','Clinton','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.370798,-93.768621,0,'2013-07-06 12:44:33',NULL,NULL),(60038,'71343','S','Trinity','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(64123,'76185','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861974,-97.216601,0,'2013-07-06 12:44:34',NULL,NULL),(71042,'85744','U','IBM Corp','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.047559,-110.673722,0,'2013-07-06 12:44:34',NULL,NULL),(71953,'87943','S','Dusty','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.338611,-107.677222,0,'2013-07-06 12:44:34',NULL,NULL),(28138,'30818','S','Wrens','A','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.215285,-82.287101,0,'2013-07-06 12:44:31',NULL,NULL),(61905,'73144','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.411174,-97.556980,0,'2013-07-06 12:44:33',NULL,NULL),(74306,'92382','P','Arrowbear Lk','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.206744,-117.104968,0,'2013-07-06 12:44:34',NULL,NULL),(65050,'77337','P','Hufsmith','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.122113,-95.593231,0,'2013-07-06 12:44:34',NULL,NULL),(43760,'49018','P','Battle Creek','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.397480,-85.219713,0,'2013-07-06 12:44:32',NULL,NULL),(28996,'32218','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.461492,-81.625786,0,'2013-07-06 12:44:32',NULL,NULL),(77441,'96808','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304528,-157.859432,0,'2013-07-06 12:44:34',NULL,NULL),(64540,'76645','S','Winslow','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(9639,'10036','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(21543,'22738','S','Uno','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.265908,-78.251320,0,'2013-07-06 12:44:31',NULL,NULL),(47200,'54489','S','Altdorf','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.461390,-89.993344,0,'2013-07-06 12:44:32',NULL,NULL),(20151,'20735','S','Clinton','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.756541,-76.906990,0,'2013-07-06 12:44:31',NULL,NULL),(14165,'14730','P','East Randolph','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.171250,-78.948137,0,'2013-07-06 12:44:31',NULL,NULL),(202,'00623','S','Urb Ramirez','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(8042,'07733','S','Holmdel Village','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.385487,-74.172575,0,'2013-07-06 12:44:30',NULL,NULL),(45315,'50845','S','Diagonal','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.835955,-94.358078,0,'2013-07-06 12:44:32',NULL,NULL),(68708,'82063','S','Laramie','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',40.912373,-105.868056,0,'2013-07-06 12:44:34',NULL,NULL),(38291,'43338','S','Mount Gilead','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.560186,-82.781700,0,'2013-07-06 12:44:32',NULL,NULL),(31063,'33846','P','Highland City','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.965064,-81.878891,0,'2013-07-06 12:44:32',NULL,NULL),(27220,'29914','P','Dale','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.554485,-80.692502,0,'2013-07-06 12:44:31',NULL,NULL),(972,'00716','S','Urb Los Almendros','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(69776,'84058','S','Clyde','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(36411,'40523','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.984878,-84.513996,0,'2013-07-06 12:44:32',NULL,NULL),(2884,'00987','S','Hacienda Real','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(51258,'59084','S','Teigen','D','Petroleum','30069','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.039156,-108.610344,0,'2013-07-06 12:44:33',NULL,NULL),(56431,'65263','S','Woodlawn','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.473290,-92.214390,0,'2013-07-06 12:44:33',NULL,NULL),(73870,'91931','P','Guatay','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.849587,-116.555021,0,'2013-07-06 12:44:34',NULL,NULL),(44018,'49404','S','Coppersville','N','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.066832,-85.934647,0,'2013-07-06 12:44:32',NULL,NULL),(14696,'15258','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441892,-79.997266,0,'2013-07-06 12:44:31',NULL,NULL),(1279,'00730','S','Ext Valle Alto','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(4107,'02712','P','Chartley','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.967333,-71.241633,0,'2013-07-06 12:44:30',NULL,NULL),(31830,'35073','S','Blossburg','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.621087,-86.958247,0,'2013-07-06 12:44:32',NULL,NULL),(77799,'97136','S','Twin Rocks','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(64041,'76127','S','Naval Air Station/ Jrb','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.776500,-97.423380,0,'2013-07-06 12:44:34',NULL,NULL),(39891,'45213','S','Taft','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.179149,-84.417894,0,'2013-07-06 12:44:32',NULL,NULL),(76073,'95207','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.001880,-121.323361,0,'2013-07-06 12:44:34',NULL,NULL),(56241,'65049','S','Lake Ozark','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.200554,-92.711201,0,'2013-07-06 12:44:33',NULL,NULL),(69861,'84092','S','Granite','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(70268,'84525','S','Green River','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.000232,-110.160774,0,'2013-07-06 12:44:34',NULL,NULL),(73400,'91121','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.149921,-118.088599,0,'2013-07-06 12:44:34',NULL,NULL),(14862,'15458','S','McClellandtwn','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.886898,-79.858211,0,'2013-07-06 12:44:31',NULL,NULL),(63681,'75860','S','Simsboro','N','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.624665,-96.281615,0,'2013-07-06 12:44:34',NULL,NULL),(58627,'68862','S','Springdale','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.599708,-98.930085,0,'2013-07-06 12:44:33',NULL,NULL),(26688,'29405','S','Chas Hgts','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(14744,'15315','P','Bobtown','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.759713,-79.986975,0,'2013-07-06 12:44:31',NULL,NULL),(64490,'76624','S','Axtell','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.673100,-96.981780,0,'2013-07-06 12:44:34',NULL,NULL),(67176,'79845','S','Presidio','D','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',29.568952,-104.374495,0,'2013-07-06 12:44:34',NULL,NULL),(48193,'55393','P','Maple Plain','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',44.994562,-93.711789,0,'2013-07-06 12:44:33',NULL,NULL),(21932,'23228','S','Staples Mill','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.624801,-77.497483,0,'2013-07-06 12:44:31',NULL,NULL),(19696,'20375','U','Naval Research Laboratory','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.941368,-77.089841,0,'2013-07-06 12:44:31',NULL,NULL),(16182,'17067','S','Millardsville','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(4572,'03470','S','Richmond','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.785580,-72.334800,0,'2013-07-06 12:44:30',NULL,NULL),(46167,'52731','S','Petersville','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.963040,-90.471130,0,'2013-07-06 12:44:32',NULL,NULL),(10765,'11363','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.773215,-73.746899,0,'2013-07-06 12:44:30',NULL,NULL),(5361,'04623','S','Columbia','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.707438,-67.773645,0,'2013-07-06 12:44:30',NULL,NULL),(3378,'01590','S','Wilkinsonville','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.138424,-71.752496,0,'2013-07-06 12:44:30',NULL,NULL),(14920,'15544','P','Gray','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.133087,-79.093554,0,'2013-07-06 12:44:31',NULL,NULL),(16508,'17265','S','Upper Strasbg','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.052056,-77.753164,0,'2013-07-06 12:44:31',NULL,NULL),(6951,'06199','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.926830,-72.654423,0,'2013-07-06 12:44:30',NULL,NULL),(73154,'90292','S','Marina dl Rey','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.985510,-118.453180,0,'2013-07-06 12:44:34',NULL,NULL),(64946,'77229','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764959,-95.269432,0,'2013-07-06 12:44:34',NULL,NULL),(57052,'66211','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(34479,'38664','S','Tunica Resorts','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(42761,'48032','S','Worth Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.173246,-82.593346,0,'2013-07-06 12:44:32',NULL,NULL),(39174,'44311','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.060965,-81.521953,0,'2013-07-06 12:44:32',NULL,NULL),(32809,'36444','S','Franklin','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.724640,-87.455369,0,'2013-07-06 12:44:32',NULL,NULL),(71696,'87521','S','Ojo Sarco','A','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.157505,-105.731083,0,'2013-07-06 12:44:34',NULL,NULL),(2972,'01050','S','North Chester','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(37764,'42338','S','Dundee','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.549238,-86.768160,0,'2013-07-06 12:44:32',NULL,NULL),(2186,'00926','S','Mans de Rio Piedras','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(4657,'03765','S','Haverhill','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.042602,-72.061806,0,'2013-07-06 12:44:30',NULL,NULL),(22364,'23915','S','Baskerville','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.634077,-78.298095,0,'2013-07-06 12:44:31',NULL,NULL),(34678,'38824','S','Geeville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(5102,'04349','S','Fayette','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.436832,-70.070204,0,'2013-07-06 12:44:30',NULL,NULL),(66702,'78946','S','Nechanitz','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.231900,-96.775620,0,'2013-07-06 12:44:34',NULL,NULL),(27048,'29672','S','Seneca','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.685658,-82.956989,0,'2013-07-06 12:44:31',NULL,NULL),(72312,'88901','U','The Lakes','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.145297,-115.282899,0,'2013-07-06 12:44:34',NULL,NULL),(2291,'00926','S','Villas del Este','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(32885,'36530','S','Elberta','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.405780,-87.586380,0,'2013-07-06 12:44:32',NULL,NULL),(37766,'42339','S','Penrod','A','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.080671,-86.978957,0,'2013-07-06 12:44:32',NULL,NULL),(509,'00674','S','Parc Marquez','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(77873,'97256','U','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.515988,-122.680938,0,'2013-07-06 12:44:34',NULL,NULL),(50714,'58368','S','Rugby','D','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.303660,-99.994440,0,'2013-07-06 12:44:33',NULL,NULL),(78747,'98291','P','Snohomish','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.928974,-122.099893,0,'2013-07-06 12:44:34',NULL,NULL),(37369,'41731','S','Daisy','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.124133,-83.036516,0,'2013-07-06 12:44:32',NULL,NULL),(69645,'84006','S','Copperton','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.533333,-112.150000,0,'2013-07-06 12:44:34',NULL,NULL),(60028,'71342','S','Routon','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(59551,'70823','U','La Dept of Revenue','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.445781,-91.189226,0,'2013-07-06 12:44:33',NULL,NULL),(21637,'22922','S','Arrington','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.692180,-78.914700,0,'2013-07-06 12:44:31',NULL,NULL),(8730,'08512','S','E Windsor','N','Middlesex','34023','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.311180,-74.525160,0,'2013-07-06 12:44:30',NULL,NULL),(31964,'35213','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504565,-86.747150,0,'2013-07-06 12:44:32',NULL,NULL),(62439,'74171','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.149777,-95.995378,0,'2013-07-06 12:44:33',NULL,NULL),(40809,'46186','S','Warrington','N','Hancock','18059','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.885591,-85.608655,0,'2013-07-06 12:44:32',NULL,NULL),(14832,'15432','P','Dunlevy','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.076962,-79.864922,0,'2013-07-06 12:44:31',NULL,NULL),(29058,'32241','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.168289,-81.629109,0,'2013-07-06 12:44:32',NULL,NULL),(45956,'52355','S','Webster','D','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.436150,-92.189243,0,'2013-07-06 12:44:32',NULL,NULL),(43316,'48357','S','Highland','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.656319,-83.636330,0,'2013-07-06 12:44:32',NULL,NULL),(19422,'20097','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884700,-77.008117,0,'2013-07-06 12:44:31',NULL,NULL),(78540,'98138','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.474167,-122.259722,0,'2013-07-06 12:44:34',NULL,NULL),(55281,'63469','S','Shelbyville','D','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.822053,-92.070853,0,'2013-07-06 12:44:33',NULL,NULL),(11455,'11978','S','Westhampton Dunes','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(37085,'41339','S','Decoy','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(40590,'45879','S','Broughton','A','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.137337,-84.586462,0,'2013-07-06 12:44:32',NULL,NULL),(5205,'04456','S','Levant','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.873590,-68.943452,0,'2013-07-06 12:44:30',NULL,NULL),(80083,'99737','S','Delta Junction','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.022280,-145.516080,0,'2013-07-06 12:44:34',NULL,NULL),(47703,'54982','S','Wautoma','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.069079,-89.290782,0,'2013-07-06 12:44:33',NULL,NULL),(75504,'94139','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794865,-122.406188,0,'2013-07-06 12:44:34',NULL,NULL),(72211,'88422','S','Gladstone','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.321192,-103.864445,0,'2013-07-06 12:44:34',NULL,NULL),(58950,'69361','S','Scottsbluff','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.866912,-103.658986,0,'2013-07-06 12:44:33',NULL,NULL),(54905,'63080','S','Oak Grove Village','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(55239,'63442','S','Granger','D','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.503604,-92.003793,0,'2013-07-06 12:44:33',NULL,NULL),(58063,'68045','S','Oakland','D','Burt','31021','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.835451,-96.465532,0,'2013-07-06 12:44:33',NULL,NULL),(593,'00680','S','Repto Macias','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(22791,'24464','S','Montebello','D','Nelson','51125','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.844280,-79.070071,0,'2013-07-06 12:44:31',NULL,NULL),(20865,'21665','S','Sherwood','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.741644,-76.324831,0,'2013-07-06 12:44:31',NULL,NULL),(3820,'02304','P','Brockton','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.081667,-71.025966,0,'2013-07-06 12:44:30',NULL,NULL),(44799,'50231','P','Randall','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.254007,-93.638925,0,'2013-07-06 12:44:32',NULL,NULL),(36111,'40222','S','Glenview Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(32118,'35407','P','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.166477,-87.522249,0,'2013-07-06 12:44:32',NULL,NULL),(54785,'63006','P','Chesterfield','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.662973,-90.575371,0,'2013-07-06 12:44:33',NULL,NULL),(58233,'68350','S','Endicott','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.079665,-97.093532,0,'2013-07-06 12:44:33',NULL,NULL),(32426,'35983','S','Leesburg','D','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.160544,-85.779405,0,'2013-07-06 12:44:32',NULL,NULL),(75773,'94660','U','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.795912,-122.269768,0,'2013-07-06 12:44:34',NULL,NULL),(64440,'76567','S','Minerva','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.657577,-97.009947,0,'2013-07-06 12:44:34',NULL,NULL),(62385,'74080','S','Talala','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.530859,-95.697833,0,'2013-07-06 12:44:33',NULL,NULL),(55278,'63468','S','Lakenan','N','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.694269,-92.042102,0,'2013-07-06 12:44:33',NULL,NULL),(52788,'61272','S','New Boston','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.200140,-90.991680,0,'2013-07-06 12:44:33',NULL,NULL),(37185,'41503','S','S Williamson','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.670901,-82.287453,0,'2013-07-06 12:44:32',NULL,NULL),(51903,'60102','S','Lk In The Hls','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.170820,-88.318740,0,'2013-07-06 12:44:33',NULL,NULL),(73516,'91342','S','Sylmar','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.303046,-118.421940,0,'2013-07-06 12:44:34',NULL,NULL),(11782,'12207','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652365,-73.754418,0,'2013-07-06 12:44:30',NULL,NULL),(7324,'06704','S','Plaza','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.578898,-73.032746,0,'2013-07-06 12:44:30',NULL,NULL),(3721,'02148','S','Malden','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.432130,-71.056084,0,'2013-07-06 12:44:30',NULL,NULL),(26235,'28810','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.567335,-82.614735,0,'2013-07-06 12:44:31',NULL,NULL),(73006,'90064','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.035989,-118.422620,0,'2013-07-06 12:44:34',NULL,NULL),(30987,'33760','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.905781,-82.718355,0,'2013-07-06 12:44:32',NULL,NULL),(58821,'69038','S','Maywood','D','Frontier','31063','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.526811,-100.666630,0,'2013-07-06 12:44:33',NULL,NULL),(73179,'90403','S','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.029923,-118.490616,0,'2013-07-06 12:44:34',NULL,NULL),(41129,'46617','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.683768,-86.232320,0,'2013-07-06 12:44:32',NULL,NULL),(38339,'43437','P','Jerry City','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.252052,-83.603644,0,'2013-07-06 12:44:32',NULL,NULL),(40602,'45887','S','Spencerville','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.720642,-84.344990,0,'2013-07-06 12:44:32',NULL,NULL),(8092,'07762','S','Spring Lake','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(16698,'17402','S','Locust Grove','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(27548,'30248','S','Locust Grove','D','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.359583,-84.105370,0,'2013-07-06 12:44:31',NULL,NULL),(72130,'88301','S','Ancho','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(46127,'52645','S','Lowell','A','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.923837,-91.401797,0,'2013-07-06 12:44:32',NULL,NULL),(322,'00647','S','Ensenada','D','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.967309,-66.939935,0,'2013-07-06 12:44:30',NULL,NULL),(19732,'20401','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897816,-77.008997,0,'2013-07-06 12:44:31',NULL,NULL),(37530,'42051','S','Dogwood','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(32826,'36461','P','Mville','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.520180,-87.320717,0,'2013-07-06 12:44:32',NULL,NULL),(5693,'04976','S','Skowhegan','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.757178,-69.712735,0,'2013-07-06 12:44:30',NULL,NULL),(18221,'18963','P','Solebury','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.379569,-75.014126,0,'2013-07-06 12:44:31',NULL,NULL),(11038,'11570','S','Rockville Centre','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.665099,-73.637798,0,'2013-07-06 12:44:30',NULL,NULL),(10724,'11252','S','Fort Hamilton','A','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.624546,-74.031281,0,'2013-07-06 12:44:30',NULL,NULL),(7000,'06254','S','Franklin Hill','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.618872,-72.143072,0,'2013-07-06 12:44:30',NULL,NULL),(7759,'07405','S','Butler','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(12255,'12831','S','Wilton','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.198440,-73.678260,0,'2013-07-06 12:44:30',NULL,NULL),(46664,'53713','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.032823,-89.394847,0,'2013-07-06 12:44:32',NULL,NULL),(6114,'05457','S','Franklin','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(26115,'28726','S','East Flat Rock','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.282463,-82.417980,0,'2013-07-06 12:44:31',NULL,NULL),(48493,'55734','S','Genoa','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.431510,-92.516556,0,'2013-07-06 12:44:33',NULL,NULL),(2038,'00918','S','Parq Central','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(33504,'37362','S','Old Fort','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.044633,-84.640632,0,'2013-07-06 12:44:32',NULL,NULL),(10525,'10982','P','Tallman','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.106544,-74.098650,0,'2013-07-06 12:44:30',NULL,NULL),(48566,'55768','S','Mountain Iron','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.530445,-92.581327,0,'2013-07-06 12:44:33',NULL,NULL),(1774,'00780','S','Urb Sombras del Real','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(78905,'98362','S','Maple Grove','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(21034,'21867','P','Upper Fairmt','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.102657,-75.794628,0,'2013-07-06 12:44:31',NULL,NULL),(942,'00716','S','Bo Sabanetas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(35783,'39747','S','Poplar Creek','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444845,-89.567673,0,'2013-07-06 12:44:32',NULL,NULL),(18777,'19366','P','Pocopson','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.899041,-75.625473,0,'2013-07-06 12:44:31',NULL,NULL),(6778,'06103','S','Central','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.767862,-72.674838,0,'2013-07-06 12:44:30',NULL,NULL),(79535,'98944','S','Sunnyside','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.328654,-120.001441,0,'2013-07-06 12:44:34',NULL,NULL),(76180,'95334','S','Livingston','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.376697,-120.726729,0,'2013-07-06 12:44:34',NULL,NULL),(74197,'92283','S','Felicity','A','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.776447,-114.598015,0,'2013-07-06 12:44:34',NULL,NULL),(66511,'78704','S','Travis Heights','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.244144,-97.762860,0,'2013-07-06 12:44:34',NULL,NULL),(62226,'73938','S','Forgan','D','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.906831,-100.534086,0,'2013-07-06 12:44:33',NULL,NULL),(58615,'68858','S','Miller','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.958042,-99.365640,0,'2013-07-06 12:44:33',NULL,NULL),(24476,'27243','S','Efland','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.069418,-79.204420,0,'2013-07-06 12:44:31',NULL,NULL),(16553,'17309','S','Brogue','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.870620,-76.451716,0,'2013-07-06 12:44:31',NULL,NULL),(62909,'75071','S','McKinney','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.167006,-96.597465,0,'2013-07-06 12:44:33',NULL,NULL),(75136,'93558','P','Johannesburg','A','Kern','06029','California','CA','06','6780','760','Pacific',-8.0,'Y',35.351568,-117.627031,0,'2013-07-06 12:44:34',NULL,NULL),(78754,'98295','S','Clearbrook','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.964647,-122.202847,0,'2013-07-06 12:44:34',NULL,NULL),(25998,'28671','P','Rutherfrd Col','A','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.752185,-81.523048,0,'2013-07-06 12:44:31',NULL,NULL),(14984,'15642','S','N Huntingdon','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.328956,-79.721348,0,'2013-07-06 12:44:31',NULL,NULL),(4467,'03260','P','N Sutton','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.365840,-71.939164,0,'2013-07-06 12:44:30',NULL,NULL),(5051,'04270','S','Oxford','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.094340,-70.531443,0,'2013-07-06 12:44:30',NULL,NULL),(13991,'14510','S','Tuscarora','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.688740,-77.895180,0,'2013-07-06 12:44:31',NULL,NULL),(21948,'23233','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.622840,-77.613493,0,'2013-07-06 12:44:31',NULL,NULL),(17320,'17859','S','Orangeville','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(71420,'87025','S','Jemez Springs','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.764625,-106.921242,0,'2013-07-06 12:44:34',NULL,NULL),(72475,'89124','S','Mountain Springs','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(57592,'67101','S','Maize','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.775757,-97.470221,0,'2013-07-06 12:44:33',NULL,NULL),(67220,'79924','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.899322,-106.414327,0,'2013-07-06 12:44:34',NULL,NULL),(6850,'06127','P','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766715,-72.682282,0,'2013-07-06 12:44:30',NULL,NULL),(42422,'47802','S','Southwood','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(40957,'46308','P','Crown Point','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.417149,-87.363926,0,'2013-07-06 12:44:32',NULL,NULL),(25219,'28086','S','Kings Mountain','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.246918,-81.361082,0,'2013-07-06 12:44:31',NULL,NULL),(26319,'29044','S','Wateree','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.918360,-80.732160,0,'2013-07-06 12:44:31',NULL,NULL),(56105,'64788','S','Urich','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.458971,-93.995235,0,'2013-07-06 12:44:33',NULL,NULL),(630,'00682','S','Repto Los Chevres','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(75320,'93765','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.833866,-119.828970,0,'2013-07-06 12:44:34',NULL,NULL),(72522,'89160','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.123119,-115.088896,0,'2013-07-06 12:44:34',NULL,NULL),(9082,'09021','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18436,'19065','P','Media','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.918847,-75.390133,0,'2013-07-06 12:44:31',NULL,NULL),(5410,'04662','P','Northeast Hbr','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.293470,-68.284715,0,'2013-07-06 12:44:30',NULL,NULL),(19446,'20113','P','Manassas Park','A','Manassas Park City','51685','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.786738,-77.455746,0,'2013-07-06 12:44:31',NULL,NULL),(24477,'27244','S','Elon','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.135017,-79.505282,0,'2013-07-06 12:44:31',NULL,NULL),(51521,'59710','P','Alder','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.289372,-112.104091,0,'2013-07-06 12:44:33',NULL,NULL),(2330,'00935','U','Centro Medico Metropolitano','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410481,-66.065613,0,'2013-07-06 12:44:30',NULL,NULL),(18494,'19093','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955914,-75.182383,0,'2013-07-06 12:44:31',NULL,NULL),(70412,'84721','S','Cedar City','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.662085,-113.196253,0,'2013-07-06 12:44:34',NULL,NULL),(54569,'62896','S','Denning','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(38973,'44129','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386440,-81.737700,0,'2013-07-06 12:44:32',NULL,NULL),(39794,'45133','S','North Uniontown','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(46635,'53588','S','Spring Green','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.185995,-90.078999,0,'2013-07-06 12:44:32',NULL,NULL),(11310,'11780','S','Deer Wells','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(49617,'56902','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(24640,'27371','S','Troy','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(22216,'23523','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.831464,-76.269871,0,'2013-07-06 12:44:31',NULL,NULL),(62452,'74301','S','Centralia','A','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.642087,-95.156105,0,'2013-07-06 12:44:33',NULL,NULL),(56858,'66008','S','Bendena','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.702742,-95.179457,0,'2013-07-06 12:44:33',NULL,NULL),(56076,'64756','S','Jerico Springs','D','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.669139,-94.008138,0,'2013-07-06 12:44:33',NULL,NULL),(1318,'00735','S','Paseos de Ceiba','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(2238,'00926','S','Urb Horizons','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(78999,'98382','S','Sequim','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(76358,'95488','S','Rockport','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.641401,-123.785539,0,'2013-07-06 12:44:34',NULL,NULL),(15927,'17020','S','Watts','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(26932,'29589','P','Rains','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.187720,-79.256942,0,'2013-07-06 12:44:31',NULL,NULL),(133,'00616','S','Bajadero','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.426456,-66.673779,0,'2013-07-06 12:44:30',NULL,NULL),(21922,'23224','S','North Chesterfield','A','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.495020,-77.477100,0,'2013-07-06 12:44:31',NULL,NULL),(79850,'99549','P','Port Heiden','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.945595,-158.633989,0,'2013-07-06 12:44:34',NULL,NULL),(77685,'97036','P','Marylhurst','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.397114,-122.648456,0,'2013-07-06 12:44:34',NULL,NULL),(9277,'09624','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(11984,'12472','S','Rosendale','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.846911,-74.073956,0,'2013-07-06 12:44:30',NULL,NULL),(23378,'25303','S','S Charleston','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352660,-81.658500,0,'2013-07-06 12:44:31',NULL,NULL),(27708,'30341','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.897852,-84.306585,0,'2013-07-06 12:44:31',NULL,NULL),(30683,'33470','S','Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(26644,'29346','P','Glendale','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.939880,-81.837005,0,'2013-07-06 12:44:31',NULL,NULL),(52392,'60631','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.989117,-87.805412,0,'2013-07-06 12:44:33',NULL,NULL),(30759,'33570','S','Ruskin','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.709380,-82.447140,0,'2013-07-06 12:44:32',NULL,NULL),(19010,'19529','S','Albany','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(77154,'96202','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(68856,'82620','S','Alcova','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.526185,-106.774157,0,'2013-07-06 12:44:34',NULL,NULL),(5958,'05301','S','Dummerston','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(709,'00687','S','Comunidad Juan Otero','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(59051,'70086','S','St James','N','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',29.970697,-90.862644,0,'2013-07-06 12:44:33',NULL,NULL),(22585,'24167','S','Staffordsville','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.245104,-80.766253,0,'2013-07-06 12:44:31',NULL,NULL),(20185,'20747','S','Forestville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854982,-76.887745,0,'2013-07-06 12:44:31',NULL,NULL),(40201,'45385','S','Xenia','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.691445,-83.953106,0,'2013-07-06 12:44:32',NULL,NULL),(3985,'02536','S','Ea Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(73865,'91914','S','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.654876,-116.952510,0,'2013-07-06 12:44:34',NULL,NULL),(78625,'98204','S','Silver Lake','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.898431,-122.254822,0,'2013-07-06 12:44:34',NULL,NULL),(64945,'77228','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.874659,-95.260396,0,'2013-07-06 12:44:34',NULL,NULL),(46303,'53060','P','Newburg','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.430905,-88.045708,0,'2013-07-06 12:44:32',NULL,NULL),(36500,'40819','S','Coldiron','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.874620,-83.440320,0,'2013-07-06 12:44:32',NULL,NULL),(49267,'56482','S','Wadena','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.439072,-95.137559,0,'2013-07-06 12:44:33',NULL,NULL),(50471,'58042','S','Gardner','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.996140,-96.899460,0,'2013-07-06 12:44:33',NULL,NULL),(32742,'36322','S','Level Plains','A','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.284660,-85.730340,0,'2013-07-06 12:44:32',NULL,NULL),(77543,'96854','S','Wheeler Army Airfield','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.486300,-158.034751,0,'2013-07-06 12:44:34',NULL,NULL),(74842,'93244','S','Lemon Cove','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.381940,-119.025651,0,'2013-07-06 12:44:34',NULL,NULL),(29248,'32442','S','Grand Ridge','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.702810,-85.024770,0,'2013-07-06 12:44:32',NULL,NULL),(19816,'20453','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(79269,'98570','S','Lacamas','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.581895,-122.686352,0,'2013-07-06 12:44:34',NULL,NULL),(78495,'98107','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.669508,-122.383202,0,'2013-07-06 12:44:34',NULL,NULL),(77655,'97019','S','Corbett','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.520077,-122.259345,0,'2013-07-06 12:44:34',NULL,NULL),(54364,'62801','S','Wamac','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(1890,'00791','S','Villas de Candelero','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(1156,'00727','S','Parq Las Haciendas','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(45721,'52073','S','Sherrill','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.613258,-90.811465,0,'2013-07-06 12:44:32',NULL,NULL),(11915,'12413','S','Cairo','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.325140,-74.029920,0,'2013-07-06 12:44:30',NULL,NULL),(25786,'28604','S','Foscoe','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(14662,'15238','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.530285,-79.876419,0,'2013-07-06 12:44:31',NULL,NULL),(7272,'06521','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309985,-72.926398,0,'2013-07-06 12:44:30',NULL,NULL),(42101,'47460','S','Vandalia','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(72420,'89054','S','Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.935345,-115.206008,0,'2013-07-06 12:44:34',NULL,NULL),(67103,'79713','S','Ackerly','D','Martin','48317','Texas','TX','48','0000','432','Central',-6.0,'Y',32.632701,-101.800055,0,'2013-07-06 12:44:34',NULL,NULL),(33434,'37303','S','Athens','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.443853,-84.599989,0,'2013-07-06 12:44:32',NULL,NULL),(3085,'01199','U','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.119147,-72.603412,0,'2013-07-06 12:44:30',NULL,NULL),(55366,'63565','S','Unionville','D','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497300,-93.005760,0,'2013-07-06 12:44:33',NULL,NULL),(30760,'33570','S','Sun City Center','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.709380,-82.447140,0,'2013-07-06 12:44:32',NULL,NULL),(44226,'49650','S','Lake Ann','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.747191,-85.877104,0,'2013-07-06 12:44:32',NULL,NULL),(50543,'58125','U','US Bank','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.879774,-96.814895,0,'2013-07-06 12:44:33',NULL,NULL),(32896,'36536','P','Foley','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.403695,-87.658883,0,'2013-07-06 12:44:32',NULL,NULL),(32508,'36075','S','Shorter','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.406725,-85.954678,0,'2013-07-06 12:44:32',NULL,NULL),(68103,'80945','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.838745,-104.797322,0,'2013-07-06 12:44:34',NULL,NULL),(67660,'80480','S','Walden','D','Jackson','08057','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.647089,-106.301099,0,'2013-07-06 12:44:34',NULL,NULL),(53942,'62418','S','Confidence','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.995023,-88.952593,0,'2013-07-06 12:44:33',NULL,NULL),(29227,'32425','S','Esto','A','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.795111,-85.677801,0,'2013-07-06 12:44:32',NULL,NULL),(25047,'27915','P','Kinnakeet','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.349432,-75.501840,0,'2013-07-06 12:44:31',NULL,NULL),(4870,'04030','S','E Waterboro','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.581317,-70.709279,0,'2013-07-06 12:44:30',NULL,NULL),(78607,'98191','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.613607,-122.335017,0,'2013-07-06 12:44:34',NULL,NULL),(71311,'86504','P','Fort Defiance','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.747110,-109.070940,0,'2013-07-06 12:44:34',NULL,NULL),(69600,'83852','S','Ponderay','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.305269,-116.523954,0,'2013-07-06 12:44:34',NULL,NULL),(69414,'83630','P','Huston','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.594852,-116.781421,0,'2013-07-06 12:44:34',NULL,NULL),(10620,'11050','S','Pr Wash','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(37230,'41540','S','Lick Creek','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369441,-82.297026,0,'2013-07-06 12:44:32',NULL,NULL),(12517,'13029','S','Brewerton','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.226880,-76.141632,0,'2013-07-06 12:44:30',NULL,NULL),(41311,'46773','S','Boston Corner','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(40466,'45764','S','Nelsonville','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.445704,-82.226243,0,'2013-07-06 12:44:32',NULL,NULL),(41608,'47118','S','English','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.333768,-86.461871,0,'2013-07-06 12:44:32',NULL,NULL),(60948,'72101','S','Hillemann','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(60685,'71933','S','Bonnerdale','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.347207,-93.316503,0,'2013-07-06 12:44:33',NULL,NULL),(56440,'65274','S','New Franklin','D','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.014736,-92.740471,0,'2013-07-06 12:44:33',NULL,NULL),(9284,'09636','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4557,'03458','S','Peterborough','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.886683,-71.947147,0,'2013-07-06 12:44:30',NULL,NULL),(18922,'19496','U','The Vanguard Group','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.097292,-75.468489,0,'2013-07-06 12:44:31',NULL,NULL),(3691,'02134','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358096,-71.130571,0,'2013-07-06 12:44:30',NULL,NULL),(35861,'39828','S','Cario','N','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.874451,-84.209360,0,'2013-07-06 12:44:32',NULL,NULL),(15631,'16720','S','Austin','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.637959,-78.005164,0,'2013-07-06 12:44:31',NULL,NULL),(35020,'39153','S','Sylvarena','N','Smith','28129','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.064420,-89.507100,0,'2013-07-06 12:44:32',NULL,NULL),(20051,'20659','S','Mechanicsville','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.438361,-76.723614,0,'2013-07-06 12:44:31',NULL,NULL),(2845,'00983','S','Urb Bahia Vistamar','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(46207,'52756','S','Wildwood Camp','N','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.721476,-90.549616,0,'2013-07-06 12:44:32',NULL,NULL),(27668,'30328','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.933854,-84.386944,0,'2013-07-06 12:44:31',NULL,NULL),(14085,'14615','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.207456,-77.649511,0,'2013-07-06 12:44:31',NULL,NULL),(33722,'37806','S','Mascot','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.080485,-83.735652,0,'2013-07-06 12:44:32',NULL,NULL),(20209,'20762','S','Andrews AFB','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.805042,-76.880984,0,'2013-07-06 12:44:31',NULL,NULL),(67741,'80602','S','Brighton','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.960305,-104.910703,0,'2013-07-06 12:44:34',NULL,NULL),(59284,'70465','P','Tangipahoa','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.874802,-90.516132,0,'2013-07-06 12:44:33',NULL,NULL),(55455,'63735','S','Bell City','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.989276,-89.779173,0,'2013-07-06 12:44:33',NULL,NULL),(47903,'55109','S','N Saint Paul','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(79221,'98542','S','Ethel','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.528205,-122.746310,0,'2013-07-06 12:44:34',NULL,NULL),(74795,'93190','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.425295,-119.701451,0,'2013-07-06 12:44:34',NULL,NULL),(68622,'81625','S','Lay','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.548784,-107.564262,0,'2013-07-06 12:44:34',NULL,NULL),(12287,'12845','S','Assembly Point','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.416960,-73.684800,0,'2013-07-06 12:44:30',NULL,NULL),(554,'00677','S','Urb Palma Real','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(4827,'03909','S','York','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.154395,-70.655138,0,'2013-07-06 12:44:30',NULL,NULL),(27273,'29941','S','Sheldon','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.602379,-80.790344,0,'2013-07-06 12:44:31',NULL,NULL),(7845,'07465','S','Wanaque','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.053747,-74.281246,0,'2013-07-06 12:44:30',NULL,NULL),(41514,'46974','S','Roann','D','Wabash','18169','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.909342,-85.923516,0,'2013-07-06 12:44:32',NULL,NULL),(78992,'98381','S','Hoko','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.265945,-124.306682,0,'2013-07-06 12:44:34',NULL,NULL),(68348,'81132','S','Aqua Ramon','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(6197,'05483','S','Saint Rocks','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(33626,'37669','U','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.529122,-82.556123,0,'2013-07-06 12:44:32',NULL,NULL),(29561,'32811','S','Orlo Vista','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.522969,-81.443050,0,'2013-07-06 12:44:32',NULL,NULL),(72904,'90022','S','Est Ls Angls','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.022686,-118.152363,0,'2013-07-06 12:44:34',NULL,NULL),(77627,'97002','S','Butteville','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.232302,-122.807794,0,'2013-07-06 12:44:34',NULL,NULL),(60039,'71343','S','Utility','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(59586,'71004','S','Belcher','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.756233,-93.856029,0,'2013-07-06 12:44:33',NULL,NULL),(42309,'47601','S','Midway','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(33676,'37733','P','Rugby','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.360310,-84.698278,0,'2013-07-06 12:44:32',NULL,NULL),(57809,'67511','S','Albert','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.451782,-99.010688,0,'2013-07-06 12:44:33',NULL,NULL),(47055,'54416','S','Bowler','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.862605,-88.981079,0,'2013-07-06 12:44:32',NULL,NULL),(19845,'20507','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903711,-77.042144,0,'2013-07-06 12:44:31',NULL,NULL),(20359,'20874','S','Germantown','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.167973,-77.268161,0,'2013-07-06 12:44:31',NULL,NULL),(22058,'23325','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.813481,-76.238375,0,'2013-07-06 12:44:31',NULL,NULL),(4403,'03221','S','Sutton','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.305780,-71.988731,0,'2013-07-06 12:44:30',NULL,NULL),(78100,'97489','S','Leaburg','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.126309,-122.633452,0,'2013-07-06 12:44:34',NULL,NULL),(66527,'78718','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.390334,-97.706191,0,'2013-07-06 12:44:34',NULL,NULL),(12613,'13084','S','Lafayette','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.887460,-76.119300,0,'2013-07-06 12:44:30',NULL,NULL),(48450,'55709','S','Boray','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.248534,-93.364213,0,'2013-07-06 12:44:33',NULL,NULL),(22416,'23976','S','Wylliesburg','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.837427,-78.610991,0,'2013-07-06 12:44:31',NULL,NULL),(53059,'61491','S','Modena','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.066868,-89.788960,0,'2013-07-06 12:44:33',NULL,NULL),(75635,'94516','P','Canyon','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.834668,-122.188041,0,'2013-07-06 12:44:34',NULL,NULL),(73509,'91335','S','Tarzana','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.199469,-118.539891,0,'2013-07-06 12:44:34',NULL,NULL),(7400,'06792','U','Torrington','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.754900,-73.058200,0,'2013-07-06 12:44:30',NULL,NULL),(11224,'11749','S','Islandia','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.809863,-73.179536,0,'2013-07-06 12:44:30',NULL,NULL),(1413,'00738','S','Urb Santa Isidra 2','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(2657,'00966','S','Urb Garden Hls','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(47086,'54435','S','Gleason','D','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.400965,-89.462214,0,'2013-07-06 12:44:32',NULL,NULL),(18489,'19091','U','Franklin Mt Ctr','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919050,-75.387375,0,'2013-07-06 12:44:31',NULL,NULL),(57687,'67235','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.681344,-97.487473,0,'2013-07-06 12:44:33',NULL,NULL),(29251,'32445','S','Malone','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.971243,-85.174676,0,'2013-07-06 12:44:32',NULL,NULL),(60254,'71440','P','East Winnfield','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.940430,-92.599937,0,'2013-07-06 12:44:33',NULL,NULL),(21570,'22830','S','Fulks Run','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.634537,-78.985851,0,'2013-07-06 12:44:31',NULL,NULL),(39207,'44398','U','Akron Business Reply','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081679,-81.507276,0,'2013-07-06 12:44:32',NULL,NULL),(39343,'44622','S','Dover','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.551120,-81.445800,0,'2013-07-06 12:44:32',NULL,NULL),(32420,'35975','S','Groveoak','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.435006,-86.044669,0,'2013-07-06 12:44:32',NULL,NULL),(78080,'97470','S','Rsbg','N','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.223282,-123.366270,0,'2013-07-06 12:44:34',NULL,NULL),(27538,'30229','P','Haralson','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.230541,-84.569939,0,'2013-07-06 12:44:31',NULL,NULL),(26997,'29628','S','Calhoun Falls','D','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.092078,-82.591621,0,'2013-07-06 12:44:31',NULL,NULL),(28946,'32182','P','Orange Springs','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.480155,-81.940776,0,'2013-07-06 12:44:32',NULL,NULL),(3309,'01519','S','Grafton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.201023,-71.687981,0,'2013-07-06 12:44:30',NULL,NULL),(10930,'11433','S','Addisleigh Pk','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.697305,-73.789271,0,'2013-07-06 12:44:30',NULL,NULL),(52005,'60169','S','Hoffman Estates','D','Cook','17031','Illinois','IL','17','1600','847','Central',-6.0,'Y',42.045153,-88.125805,0,'2013-07-06 12:44:33',NULL,NULL),(13764,'14134','S','Sardinia','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.534136,-78.524120,0,'2013-07-06 12:44:31',NULL,NULL),(51594,'59812','U','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858954,-113.986470,0,'2013-07-06 12:44:33',NULL,NULL),(52677,'61079','P','Shirland','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.445358,-89.198015,0,'2013-07-06 12:44:33',NULL,NULL),(46240,'52806','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.571562,-90.603160,0,'2013-07-06 12:44:32',NULL,NULL),(13805,'14208','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.912922,-78.851613,0,'2013-07-06 12:44:31',NULL,NULL),(51493,'59626','S','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.603688,-112.036306,0,'2013-07-06 12:44:33',NULL,NULL),(52208,'60480','S','Willow Spgs','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.725603,-87.874259,0,'2013-07-06 12:44:33',NULL,NULL),(66028,'78363','S','Kingsville','D','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.514425,-97.860850,0,'2013-07-06 12:44:34',NULL,NULL),(57637,'67150','S','Waldron','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.082141,-98.239469,0,'2013-07-06 12:44:33',NULL,NULL),(153,'00617','S','Urb Las Delicias','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(6546,'05841','S','Greensborough','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.582214,-72.297887,0,'2013-07-06 12:44:30',NULL,NULL),(77385,'96763','P','Lanai City','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.830042,-156.920857,0,'2013-07-06 12:44:34',NULL,NULL),(69744,'84047','S','Cottonwd Hgts','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.616513,-111.879899,0,'2013-07-06 12:44:34',NULL,NULL),(57463,'66857','S','Le Roy','D','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.083205,-95.630882,0,'2013-07-06 12:44:33',NULL,NULL),(16962,'17702','S','South Williamsport','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(44964,'50398','U','Urbandale','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.577582,-93.708707,0,'2013-07-06 12:44:32',NULL,NULL),(50026,'57422','S','Andover','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.414053,-97.916761,0,'2013-07-06 12:44:33',NULL,NULL),(45714,'52066','S','North Buena Vista','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.672057,-90.967071,0,'2013-07-06 12:44:32',NULL,NULL),(9941,'10155','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(34010,'38124','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.111049,-89.907808,0,'2013-07-06 12:44:32',NULL,NULL),(45337,'50864','S','Morton Mills','N','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.926401,-94.974732,0,'2013-07-06 12:44:32',NULL,NULL),(51811,'60050','S','Lakemoor','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(67947,'80912','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(66912,'79322','S','Crosbyton','D','Crosby','48107','Texas','TX','48','0000','806','Central',-6.0,'Y',33.656196,-101.240625,0,'2013-07-06 12:44:34',NULL,NULL),(64976,'77263','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.728564,-95.519201,0,'2013-07-06 12:44:34',NULL,NULL),(10431,'10804','S','Wykagyl','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.949073,-73.785808,0,'2013-07-06 12:44:30',NULL,NULL),(24360,'27048','S','Matrimony','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.461117,-79.907962,0,'2013-07-06 12:44:31',NULL,NULL),(72191,'88410','S','Amistad','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.891766,-103.212948,0,'2013-07-06 12:44:34',NULL,NULL),(42727,'48006','S','Greenwood Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(2253,'00926','S','Urb Luna Llena','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(29341,'32549','P','Ft Walton Beach','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.410303,-86.614571,0,'2013-07-06 12:44:32',NULL,NULL),(73101,'90239','P','Downey','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.932418,-118.112837,0,'2013-07-06 12:44:34',NULL,NULL),(20631,'21217','S','Druid','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.307911,-76.637572,0,'2013-07-06 12:44:31',NULL,NULL),(69267,'83434','S','Menan','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.722596,-111.991921,0,'2013-07-06 12:44:34',NULL,NULL),(69206,'83350','S','Rupert','D','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.620280,-113.767320,0,'2013-07-06 12:44:34',NULL,NULL),(68409,'81201','S','Cleora','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(62107,'73632','S','Cordell','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.293592,-98.992219,0,'2013-07-06 12:44:33',NULL,NULL),(1629,'00771','S','Portales de las Piedras','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(26643,'29342','P','Gaffney','D','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.985626,-81.659125,0,'2013-07-06 12:44:31',NULL,NULL),(19885,'20534','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892271,-77.011002,0,'2013-07-06 12:44:31',NULL,NULL),(68254,'81063','S','Ordway','D','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.237711,-103.784046,0,'2013-07-06 12:44:34',NULL,NULL),(74583,'92693','P','San Juan Capo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.497713,-117.665115,0,'2013-07-06 12:44:34',NULL,NULL),(58766,'68967','S','Mascot','N','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(54686,'62943','S','Reevesville','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(58409,'68640','S','Genoa','D','Nance','31125','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.448122,-97.730421,0,'2013-07-06 12:44:33',NULL,NULL),(57494,'66941','S','Esbon','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.825092,-98.429205,0,'2013-07-06 12:44:33',NULL,NULL),(7671,'07093','S','Taurus','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.788201,-74.013854,0,'2013-07-06 12:44:30',NULL,NULL),(41848,'47353','S','Billingsville','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(13534,'13826','S','Harpursville','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.111157,-75.645249,0,'2013-07-06 12:44:31',NULL,NULL),(32514,'36082','U','Troy State University','N','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.797868,-85.959935,0,'2013-07-06 12:44:32',NULL,NULL),(9182,'09369','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(14272,'14850','S','Ithaca College','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.445573,-76.496428,0,'2013-07-06 12:44:31',NULL,NULL),(31910,'35150','S','Taladga Spgs','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.175189,-86.255713,0,'2013-07-06 12:44:32',NULL,NULL),(40078,'45298','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.087401,-84.513464,0,'2013-07-06 12:44:32',NULL,NULL),(39094,'44230','S','Doylestown','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.965720,-81.687944,0,'2013-07-06 12:44:32',NULL,NULL),(37395,'41764','S','Smilax','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.167709,-83.259154,0,'2013-07-06 12:44:32',NULL,NULL),(49179,'56431','S','Aitkin','D','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.529143,-93.707325,0,'2013-07-06 12:44:33',NULL,NULL),(46665,'53713','S','Monona','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.032823,-89.394847,0,'2013-07-06 12:44:32',NULL,NULL),(26076,'28699','P','Scotts','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.844263,-81.007155,0,'2013-07-06 12:44:31',NULL,NULL),(510,'00674','S','Repto Garcia','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(49971,'57354','P','Kaylor','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.206175,-97.825362,0,'2013-07-06 12:44:33',NULL,NULL),(59201,'70380','S','Bayou Vista','N','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.699185,-91.211040,0,'2013-07-06 12:44:33',NULL,NULL),(65899,'78234','S','Jbsa Ft Sam Houston','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.457977,-98.493044,0,'2013-07-06 12:44:34',NULL,NULL),(50766,'58421','S','Carrington','D','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(8501,'08097','S','Woodbury Heights','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.831240,-75.151020,0,'2013-07-06 12:44:30',NULL,NULL),(42146,'47520','S','Cannelton','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(15786,'16923','S','Gold','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(35703,'39666','S','McElveen','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(77900,'97301','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.928656,-122.960707,0,'2013-07-06 12:44:34',NULL,NULL),(32122,'35442','S','Aliceville','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.124200,-88.159260,0,'2013-07-06 12:44:32',NULL,NULL),(27914,'30503','P','Gainesville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.371277,-83.822547,0,'2013-07-06 12:44:31',NULL,NULL),(11703,'12166','S','Charleston Four Corners','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.849600,-74.476380,0,'2013-07-06 12:44:30',NULL,NULL),(79644,'99140','S','Keller','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.001321,-118.561189,0,'2013-07-06 12:44:34',NULL,NULL),(62592,'74472','S','Whitefield','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.250058,-95.226723,0,'2013-07-06 12:44:33',NULL,NULL),(38303,'43349','P','Shauck','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.618676,-82.665978,0,'2013-07-06 12:44:32',NULL,NULL),(43679,'48871','S','Perrinton','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.157508,-84.680945,0,'2013-07-06 12:44:32',NULL,NULL),(45429,'51062','S','Westfield','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.710245,-96.486217,0,'2013-07-06 12:44:32',NULL,NULL),(26446,'29135','S','Saint Matthews','D','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.661870,-80.781778,0,'2013-07-06 12:44:31',NULL,NULL),(10496,'10960','S','South Nyack','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(38411,'43536','S','Mark Center','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.308750,-84.636797,0,'2013-07-06 12:44:32',NULL,NULL),(25376,'28255','U','Bank of America','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.211192,-80.865108,0,'2013-07-06 12:44:31',NULL,NULL),(27674,'30331','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.712646,-84.532291,0,'2013-07-06 12:44:31',NULL,NULL),(5683,'04970','S','Lang Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(14406,'15062','S','Monessen','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.152768,-79.881219,0,'2013-07-06 12:44:31',NULL,NULL),(2799,'00976','S','Urb Lourdes','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(60761,'72005','S','Balch','A','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.554257,-91.080965,0,'2013-07-06 12:44:33',NULL,NULL),(56100,'64780','S','Taberville','N','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.075520,-94.147320,0,'2013-07-06 12:44:33',NULL,NULL),(24336,'27030','S','Mt Airy','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490645,-80.628907,0,'2013-07-06 12:44:31',NULL,NULL),(30545,'33410','S','Palm Beach Gardens','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(41116,'46574','S','Walkerton','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.468357,-86.465282,0,'2013-07-06 12:44:32',NULL,NULL),(35175,'39272','S','Byram','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.216828,-90.269123,0,'2013-07-06 12:44:32',NULL,NULL),(26097,'28715','S','Candler','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.536698,-82.680987,0,'2013-07-06 12:44:31',NULL,NULL),(73118,'90261','S','Lawndale','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.889580,-118.352749,0,'2013-07-06 12:44:34',NULL,NULL),(71380,'87004','S','Sandia Pueblo','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(17791,'18355','S','Scotrun','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.075273,-75.340247,0,'2013-07-06 12:44:31',NULL,NULL),(45891,'52306','S','Mechanicsville','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.902291,-91.254990,0,'2013-07-06 12:44:32',NULL,NULL),(45772,'52155','S','Lime Springs','D','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.453080,-92.282246,0,'2013-07-06 12:44:32',NULL,NULL),(67948,'80912','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(71735,'87535','S','Canyoncito','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.572980,-105.773580,0,'2013-07-06 12:44:34',NULL,NULL),(56927,'66067','S','Centropolis','A','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.607557,-95.267627,0,'2013-07-06 12:44:33',NULL,NULL),(24596,'27326','S','Oregon Hill','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(60866,'72057','S','Grapevine','D','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.118272,-92.308042,0,'2013-07-06 12:44:33',NULL,NULL),(35109,'39209','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.324026,-90.252348,0,'2013-07-06 12:44:32',NULL,NULL),(30058,'33147','S','Dr Martin Luther King Jr','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.853411,-80.237002,0,'2013-07-06 12:44:32',NULL,NULL),(43163,'48267','U','Comerica','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331484,-83.051320,0,'2013-07-06 12:44:32',NULL,NULL),(7636,'07066','S','Clark','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.623271,-74.311429,0,'2013-07-06 12:44:30',NULL,NULL),(7601,'07045','S','Lower Montville','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.909925,-74.364898,0,'2013-07-06 12:44:30',NULL,NULL),(44330,'49757','P','Mackinac Is','A','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.859701,-84.615503,0,'2013-07-06 12:44:32',NULL,NULL),(16324,'17123','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265958,-76.880448,0,'2013-07-06 12:44:31',NULL,NULL),(21560,'22807','U','James Madison University','N','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.434377,-78.874712,0,'2013-07-06 12:44:31',NULL,NULL),(70003,'84124','S','Holladay','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.685813,-111.829118,0,'2013-07-06 12:44:34',NULL,NULL),(79291,'98584','S','Kamilche','N','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(5634,'04945','S','Long Pond Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(37823,'42437','S','Henshaw','A','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(9332,'09745','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(53071,'61520','S','Monterey','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.516944,-89.908333,0,'2013-07-06 12:44:33',NULL,NULL),(47463,'54733','S','Hillsdale','A','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.262056,-91.842404,0,'2013-07-06 12:44:32',NULL,NULL),(72396,'89042','P','Panaca','D','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.791919,-114.389113,0,'2013-07-06 12:44:34',NULL,NULL),(31808,'35052','P','Cook Springs','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.591075,-86.391244,0,'2013-07-06 12:44:32',NULL,NULL),(52665,'61070','S','Rock Grove','N','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.409790,-89.473497,0,'2013-07-06 12:44:33',NULL,NULL),(78319,'97911','S','Jonesboro','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.745601,-118.076327,0,'2013-07-06 12:44:34',NULL,NULL),(21399,'22511','S','Lewisetta','A','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.976560,-76.515670,0,'2013-07-06 12:44:31',NULL,NULL),(27830,'30415','S','Brooklet','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(4052,'02639','S','Dennisport','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.662775,-70.133049,0,'2013-07-06 12:44:30',NULL,NULL),(53243,'61655','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.683663,-89.595192,0,'2013-07-06 12:44:33',NULL,NULL),(51833,'60064','S','North Chicago','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.326825,-87.857674,0,'2013-07-06 12:44:33',NULL,NULL),(12154,'12741','S','Hankins','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.826399,-75.100729,0,'2013-07-06 12:44:30',NULL,NULL),(31389,'34219','S','Parrish','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.562795,-82.433618,0,'2013-07-06 12:44:32',NULL,NULL),(30362,'33314','S','Dania Beach','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.070011,-80.219723,0,'2013-07-06 12:44:32',NULL,NULL),(77644,'97014','S','Dodson','N','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.671880,-121.821480,0,'2013-07-06 12:44:34',NULL,NULL),(14292,'14873','S','Prattsburgh','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.524871,-77.249474,0,'2013-07-06 12:44:31',NULL,NULL),(7951,'07676','S','Township of Washington','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(9500,'10013','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(34532,'38685','S','Waterford','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640700,-89.469780,0,'2013-07-06 12:44:32',NULL,NULL),(8412,'08070','S','Pennsville','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.646661,-75.517532,0,'2013-07-06 12:44:30',NULL,NULL),(1670,'00773','S','Urb Vilomar','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(14599,'15223','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.468740,-79.957200,0,'2013-07-06 12:44:31',NULL,NULL),(66662,'78871','P','Langtry','D','Val Verde','48465','Texas','TX','48','0000','432','Central',-6.0,'Y',29.807539,-101.561034,0,'2013-07-06 12:44:34',NULL,NULL),(36484,'40801','P','Ages Brooksde','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.859167,-83.249444,0,'2013-07-06 12:44:32',NULL,NULL),(28830,'32082','S','Ponte Vedra','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173444,-81.395785,0,'2013-07-06 12:44:32',NULL,NULL),(55901,'64437','S','Corning','A','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.156812,-95.358379,0,'2013-07-06 12:44:33',NULL,NULL),(25328,'28205','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.220088,-80.790126,0,'2013-07-06 12:44:31',NULL,NULL),(34398,'38625','S','Dumas','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640768,-88.802425,0,'2013-07-06 12:44:32',NULL,NULL),(2537,'00959','S','Bo Hato Tejas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(40578,'45872','S','Bairdstown','A','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.189235,-83.669819,0,'2013-07-06 12:44:32',NULL,NULL),(75032,'93512','S','Bishop','A','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.810000,-118.470000,0,'2013-07-06 12:44:34',NULL,NULL),(63683,'75861','S','Massey Lake','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.885591,-95.920349,0,'2013-07-06 12:44:34',NULL,NULL),(53197,'61611','S','East Peoria','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(27744,'30356','P','Dunwoody','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.947356,-84.330786,0,'2013-07-06 12:44:31',NULL,NULL),(50099,'57472','S','Selby','D','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.412860,-100.021500,0,'2013-07-06 12:44:33',NULL,NULL),(32289,'35672','S','Town Creek','D','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.613453,-87.417111,0,'2013-07-06 12:44:32',NULL,NULL),(71357,'86538','P','Chinle','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.453233,-109.581542,0,'2013-07-06 12:44:34',NULL,NULL),(7642,'07071','S','Lyndhurst','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.807324,-74.122919,0,'2013-07-06 12:44:30',NULL,NULL),(12575,'13066','S','Fayetteville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.027198,-76.013016,0,'2013-07-06 12:44:30',NULL,NULL),(27259,'29933','P','Miley','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.948572,-81.031062,0,'2013-07-06 12:44:31',NULL,NULL),(8997,'08848','S','Milford','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.596999,-75.091729,0,'2013-07-06 12:44:30',NULL,NULL),(2336,'00936','P','GPO','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(54180,'62624','S','Bluff City','A','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.160050,-90.349720,0,'2013-07-06 12:44:33',NULL,NULL),(78131,'97530','S','Jacksonville','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.186180,-123.056520,0,'2013-07-06 12:44:34',NULL,NULL),(75300,'93737','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.740681,-119.785728,0,'2013-07-06 12:44:34',NULL,NULL),(8976,'08825','S','Frenchtown','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.521429,-75.047754,0,'2013-07-06 12:44:30',NULL,NULL),(52630,'61046','S','Lanark','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.113145,-89.835553,0,'2013-07-06 12:44:33',NULL,NULL),(63834,'75973','S','Patroon','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(803,'00693','S','Sect El Lido','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(26956,'29607','S','Batesville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.829648,-82.340068,0,'2013-07-06 12:44:31',NULL,NULL),(58851,'69140','S','Brandon','N','Perkins','31135','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.861020,-101.708400,0,'2013-07-06 12:44:33',NULL,NULL),(32705,'36279','S','Wellington','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.866411,-85.887489,0,'2013-07-06 12:44:32',NULL,NULL),(59055,'70091','S','Burrwood','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.209341,-89.231358,0,'2013-07-06 12:44:33',NULL,NULL),(33975,'38111','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.112624,-89.946832,0,'2013-07-06 12:44:32',NULL,NULL),(39580,'44857','S','Bronson','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.238868,-82.602595,0,'2013-07-06 12:44:32',NULL,NULL),(41354,'46792','S','Methodist Mem Home','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(31021,'33785','S','Indian Rks Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(77401,'96780','P','Papaaloa','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.918554,-155.197133,0,'2013-07-06 12:44:34',NULL,NULL),(74462,'92592','S','Temecula','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.505961,-117.003920,0,'2013-07-06 12:44:34',NULL,NULL),(45061,'50511','S','Saint Benedict','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.072355,-94.229492,0,'2013-07-06 12:44:32',NULL,NULL),(36677,'41015','S','Kentonvale','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(21237,'22240','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853022,-77.054148,0,'2013-07-06 12:44:31',NULL,NULL),(21786,'23070','S','Hardyville','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.544869,-76.423694,0,'2013-07-06 12:44:31',NULL,NULL),(58735,'68948','S','Holbrook','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.305242,-100.000159,0,'2013-07-06 12:44:33',NULL,NULL),(62348,'74058','S','Pownee','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.331099,-96.777425,0,'2013-07-06 12:44:33',NULL,NULL),(69338,'83535','S','Juliaetta','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.573013,-116.748611,0,'2013-07-06 12:44:34',NULL,NULL),(76795,'95945','S','Hills Flat','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(43566,'48729','S','Deford','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.491897,-83.183767,0,'2013-07-06 12:44:32',NULL,NULL),(5130,'04411','S','Bradley','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.910032,-68.624203,0,'2013-07-06 12:44:30',NULL,NULL),(18638,'19161','U','Firm Zip Concept (Brm)','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.065457,-75.080697,0,'2013-07-06 12:44:31',NULL,NULL),(17785,'18349','P','Pocono Manor','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.097953,-75.363955,0,'2013-07-06 12:44:31',NULL,NULL),(3767,'02188','S','Weymouth Lndg','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.213792,-70.959371,0,'2013-07-06 12:44:30',NULL,NULL),(77764,'97114','S','Grand Island','N','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.174600,-123.069660,0,'2013-07-06 12:44:34',NULL,NULL),(58912,'69301','S','Berea','N','Box Butte','31013','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.124380,-102.896400,0,'2013-07-06 12:44:33',NULL,NULL),(57760,'67449','S','Latimer','A','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.689020,-96.992160,0,'2013-07-06 12:44:33',NULL,NULL),(6406,'05736','S','Center Rutland','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.595502,-73.025348,0,'2013-07-06 12:44:30',NULL,NULL),(28125,'30815','S','Hephzibah','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.344357,-82.069749,0,'2013-07-06 12:44:31',NULL,NULL),(13914,'14305','S','N Falls','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.117629,-79.029190,0,'2013-07-06 12:44:31',NULL,NULL),(70138,'84304','S','Cache Junction','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.832974,-112.002030,0,'2013-07-06 12:44:34',NULL,NULL),(67351,'80110','S','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(64948,'77230','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.698082,-95.384159,0,'2013-07-06 12:44:34',NULL,NULL),(1708,'00777','S','Villa Graciela','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(72483,'89129','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.235494,-115.290718,0,'2013-07-06 12:44:34',NULL,NULL),(71287,'86439','P','Bullhead City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.148005,-114.567525,0,'2013-07-06 12:44:34',NULL,NULL),(53936,'62414','S','Beecher City','D','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.176936,-88.821983,0,'2013-07-06 12:44:33',NULL,NULL),(45669,'52037','S','Delmar','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.001059,-90.609493,0,'2013-07-06 12:44:32',NULL,NULL),(34502,'38670','S','Tibbs','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.429607,-90.218388,0,'2013-07-06 12:44:32',NULL,NULL),(18932,'19505','S','Bechtelsville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.372171,-75.627950,0,'2013-07-06 12:44:31',NULL,NULL),(42112,'47468','S','Unionville','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.261476,-86.412024,0,'2013-07-06 12:44:32',NULL,NULL),(41308,'46771','P','Mongo','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.685012,-85.278102,0,'2013-07-06 12:44:32',NULL,NULL),(51674,'59921','P','Lake McDonald','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.621891,-113.873901,0,'2013-07-06 12:44:33',NULL,NULL),(61935,'73156','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.566986,-97.550405,0,'2013-07-06 12:44:33',NULL,NULL),(12042,'12524','S','Fishkill','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.541709,-73.902683,0,'2013-07-06 12:44:30',NULL,NULL),(22647,'24260','S','Venia','A','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.029515,-82.003511,0,'2013-07-06 12:44:31',NULL,NULL),(44142,'49516','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.919062,-85.527056,0,'2013-07-06 12:44:32',NULL,NULL),(44242,'49665','S','Marion','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.094231,-85.178134,0,'2013-07-06 12:44:32',NULL,NULL),(61212,'72313','P','Bassett','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.515803,-90.196734,0,'2013-07-06 12:44:33',NULL,NULL),(64964,'77251','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.702599,-95.538992,0,'2013-07-06 12:44:34',NULL,NULL),(19346,'20042','U','Sun Trust Bank Inc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916732,-76.994294,0,'2013-07-06 12:44:31',NULL,NULL),(17255,'17841','S','Mc Clure','D','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(17649,'18073','S','Red Hill','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.392600,-75.482400,0,'2013-07-06 12:44:31',NULL,NULL),(53343,'61758','P','Merna','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.514258,-88.826158,0,'2013-07-06 12:44:33',NULL,NULL),(65974,'78295','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.428181,-98.488309,0,'2013-07-06 12:44:34',NULL,NULL),(59508,'70780','S','Sunshine','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.308649,-91.180634,0,'2013-07-06 12:44:33',NULL,NULL),(33070,'36768','S','Snow Hl','N','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.936892,-87.008880,0,'2013-07-06 12:44:32',NULL,NULL),(36766,'41041','S','Poplar Plains','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(46310,'53064','P','North Lake','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.160497,-88.371653,0,'2013-07-06 12:44:32',NULL,NULL),(28989,'32214','U','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.216694,-81.684003,0,'2013-07-06 12:44:32',NULL,NULL),(61628,'72833','S','Danville','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.067960,-93.373459,0,'2013-07-06 12:44:33',NULL,NULL),(48705,'55944','S','Canisteo','N','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.036896,-92.751584,0,'2013-07-06 12:44:33',NULL,NULL),(52856,'61327','S','Florid','N','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.252075,-89.337202,0,'2013-07-06 12:44:33',NULL,NULL),(78876,'98354','S','Milton','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.249097,-122.316421,0,'2013-07-06 12:44:34',NULL,NULL),(43212,'48306','S','Rochester Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(24902,'27711','U','Research Triangle Park','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916201,-78.867468,0,'2013-07-06 12:44:31',NULL,NULL),(24492,'27260','S','Freemans Mills','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(48149,'55369','S','Hassan','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.121860,-93.457200,0,'2013-07-06 12:44:33',NULL,NULL),(71323,'86505','S','Toyei','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(65459,'77619','S','Groves','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.942831,-93.913486,0,'2013-07-06 12:44:34',NULL,NULL),(60940,'72099','U','Jacksonville','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(21579,'22835','S','Shndoh Nat Pk','N','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.665612,-78.456879,0,'2013-07-06 12:44:31',NULL,NULL),(1242,'00729','S','Parc Monteverde','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(6999,'06254','S','Franklin','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.618872,-72.143072,0,'2013-07-06 12:44:30',NULL,NULL),(9779,'10106','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(1337,'00736','S','Bo Guavate','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(24489,'27258','S','Haw River','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.061861,-79.339937,0,'2013-07-06 12:44:31',NULL,NULL),(59706,'71104','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.484075,-93.733020,0,'2013-07-06 12:44:33',NULL,NULL),(6078,'05448','S','East Fairfield','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.800384,-72.917850,0,'2013-07-06 12:44:30',NULL,NULL),(39821,'45148','S','Midland','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.295707,-83.886912,0,'2013-07-06 12:44:32',NULL,NULL),(17379,'17886','S','Lewisburg','A','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.022009,-76.870147,0,'2013-07-06 12:44:31',NULL,NULL),(43896,'49240','S','Grass Lake','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.283342,-84.200658,0,'2013-07-06 12:44:32',NULL,NULL),(63102,'75270','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.775253,-96.805716,0,'2013-07-06 12:44:33',NULL,NULL),(62443,'74182','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.154100,-95.994899,0,'2013-07-06 12:44:33',NULL,NULL),(541,'00676','S','Urb Las Palmas','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(74074,'92174','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.705682,-117.084537,0,'2013-07-06 12:44:34',NULL,NULL),(46813,'54006','S','Cushing','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.573120,-92.648880,0,'2013-07-06 12:44:32',NULL,NULL),(25604,'28455','S','Nakina','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.112441,-78.653824,0,'2013-07-06 12:44:31',NULL,NULL),(47826,'55066','S','Red Wing','D','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.557341,-92.547612,0,'2013-07-06 12:44:33',NULL,NULL),(26054,'28689','S','Union Grove','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',36.037202,-80.908540,0,'2013-07-06 12:44:31',NULL,NULL),(2695,'00969','S','Bosque De Los Frailes','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(38995,'44135','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.434425,-81.801820,0,'2013-07-06 12:44:32',NULL,NULL),(20382,'20886','S','Montgomery Village','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.170940,-77.209500,0,'2013-07-06 12:44:31',NULL,NULL),(75162,'93590','P','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.579596,-118.088681,0,'2013-07-06 12:44:34',NULL,NULL),(69546,'83805','S','Copeland','N','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.698029,-116.318139,0,'2013-07-06 12:44:34',NULL,NULL),(67182,'79849','S','San Elizario','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.584257,-106.272101,0,'2013-07-06 12:44:34',NULL,NULL),(64882,'77070','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.972794,-95.577432,0,'2013-07-06 12:44:34',NULL,NULL),(12016,'12504','P','Red Hook','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.012397,-73.898328,0,'2013-07-06 12:44:30',NULL,NULL),(50903,'58545','S','Pick City','A','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.335320,-101.623920,0,'2013-07-06 12:44:33',NULL,NULL),(4951,'04098','P','Westbrook','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.675955,-70.365718,0,'2013-07-06 12:44:30',NULL,NULL),(50,'00605','P','Aguadilla','D','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.436149,-67.151346,0,'2013-07-06 12:44:30',NULL,NULL),(45701,'52057','S','Dutchtown','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.485840,-91.458289,0,'2013-07-06 12:44:32',NULL,NULL),(70531,'85015','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.507977,-112.101173,0,'2013-07-06 12:44:34',NULL,NULL),(14755,'15325','P','Crucible','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.946871,-79.964267,0,'2013-07-06 12:44:31',NULL,NULL),(3823,'02324','S','Bridgewater','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.981411,-70.974124,0,'2013-07-06 12:44:30',NULL,NULL),(71031,'85738','P','Catalina','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.221667,-110.925833,0,'2013-07-06 12:44:34',NULL,NULL),(3397,'01615','P','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.270221,-71.809332,0,'2013-07-06 12:44:30',NULL,NULL),(79420,'98826','S','Blewett','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(76942,'96027','S','Sawyers Bar','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.427300,-122.916600,0,'2013-07-06 12:44:34',NULL,NULL),(78575,'98168','S','Burien','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.490093,-122.291541,0,'2013-07-06 12:44:34',NULL,NULL),(10401,'10604','S','White Plains','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.035020,-73.743600,0,'2013-07-06 12:44:30',NULL,NULL),(43580,'48744','S','Mayville','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.354988,-83.361552,0,'2013-07-06 12:44:32',NULL,NULL),(36448,'40620','U','Ky Dept of Revenue','N','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.177757,-84.899142,0,'2013-07-06 12:44:32',NULL,NULL),(65390,'77553','P','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.213993,-94.934063,0,'2013-07-06 12:44:34',NULL,NULL),(32237,'35586','S','Sulligent','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.893001,-88.132364,0,'2013-07-06 12:44:32',NULL,NULL),(16930,'17606','P','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.076740,-76.309140,0,'2013-07-06 12:44:31',NULL,NULL),(54715,'62958','S','Midland Hills','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.637065,-89.186902,0,'2013-07-06 12:44:33',NULL,NULL),(40700,'46085','U','Newgistics Merchandise Retrn','N','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.979634,-86.119609,0,'2013-07-06 12:44:32',NULL,NULL),(12219,'12804','S','Queensbury','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.371360,-73.676100,0,'2013-07-06 12:44:30',NULL,NULL),(25355,'28230','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','910','Eastern',-5.0,'Y',35.212613,-80.828203,0,'2013-07-06 12:44:31',NULL,NULL),(1803,'00784','S','Alts del Olimpo','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(15437,'16388','U','Meadville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.648956,-80.147265,0,'2013-07-06 12:44:31',NULL,NULL),(62828,'74964','S','Watts','D','Adair','40001','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.116613,-94.660947,0,'2013-07-06 12:44:33',NULL,NULL),(76274,'95422','S','Clearlake','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.954845,-122.642133,0,'2013-07-06 12:44:34',NULL,NULL),(30693,'33480','S','S Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.717031,-80.047448,0,'2013-07-06 12:44:32',NULL,NULL),(3234,'01376','S','Turners Falls','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.627240,-72.529080,0,'2013-07-06 12:44:30',NULL,NULL),(19231,'19902','S','Dover AFB','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.120867,-75.478601,0,'2013-07-06 12:44:31',NULL,NULL),(70187,'84335','S','Amalga','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.835840,-111.870960,0,'2013-07-06 12:44:34',NULL,NULL),(18803,'19401','S','East Norriton','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.130580,-75.347520,0,'2013-07-06 12:44:31',NULL,NULL),(15421,'16365','S','North Warren','A','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.854253,-79.159439,0,'2013-07-06 12:44:31',NULL,NULL),(36270,'40336','S','Jinks','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(3326,'01532','S','Northborough','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.316146,-71.648168,0,'2013-07-06 12:44:30',NULL,NULL),(10350,'10573','S','Port Chester','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.011395,-73.678286,0,'2013-07-06 12:44:30',NULL,NULL),(11068,'11590','S','New Cassel','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757311,-73.577498,0,'2013-07-06 12:44:30',NULL,NULL),(30901,'33706','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(29674,'32919','U','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.077407,-80.631614,0,'2013-07-06 12:44:32',NULL,NULL),(28778,'32035','P','Fernandina','A','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.670498,-81.462032,0,'2013-07-06 12:44:32',NULL,NULL),(58673,'68901','S','Hastings','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(68614,'81623','S','Carbondale','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.416703,-107.189562,0,'2013-07-06 12:44:34',NULL,NULL),(23241,'25111','S','Indore','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.360834,-81.168140,0,'2013-07-06 12:44:31',NULL,NULL),(64961,'77245','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.640355,-95.435857,0,'2013-07-06 12:44:34',NULL,NULL),(6028,'05403','S','S Btv','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(33414,'37236','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.150275,-86.802472,0,'2013-07-06 12:44:32',NULL,NULL),(35323,'39426','S','Mill Creek','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.592349,-89.639175,0,'2013-07-06 12:44:32',NULL,NULL),(37622,'42141','S','Glasgow','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.974371,-85.907023,0,'2013-07-06 12:44:32',NULL,NULL),(38714,'44021','S','Burton','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.452676,-81.155013,0,'2013-07-06 12:44:32',NULL,NULL),(73884,'91948','P','Mount Laguna','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.871478,-116.415376,0,'2013-07-06 12:44:34',NULL,NULL),(20294,'20810','U','Geico','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.979522,-77.100398,0,'2013-07-06 12:44:31',NULL,NULL),(10964,'11514','S','Carle Place','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.752349,-73.615237,0,'2013-07-06 12:44:30',NULL,NULL),(70351,'84640','P','Lynndyl','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.521782,-112.369499,0,'2013-07-06 12:44:34',NULL,NULL),(71975,'88021','S','Anthony','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',31.935600,-106.505520,0,'2013-07-06 12:44:34',NULL,NULL),(3614,'02054','S','Millis','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.167699,-71.360144,0,'2013-07-06 12:44:30',NULL,NULL),(71810,'87569','P','Chapelle','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.392778,-105.316944,0,'2013-07-06 12:44:34',NULL,NULL),(71803,'87566','S','Ohkay Owingeh','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(61147,'72168','S','Tucker','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.438521,-91.893833,0,'2013-07-06 12:44:33',NULL,NULL),(58624,'68862','S','Michigan','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.599708,-98.930085,0,'2013-07-06 12:44:33',NULL,NULL),(36247,'40299','S','Jeffersontown','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.163000,-85.521300,0,'2013-07-06 12:44:32',NULL,NULL),(2567,'00959','S','Urb Santa Rosa','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(35949,'40059','S','Prospect','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.338312,-85.613141,0,'2013-07-06 12:44:32',NULL,NULL),(59765,'71165','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.502437,-93.743855,0,'2013-07-06 12:44:33',NULL,NULL),(62047,'73529','S','Comanche','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.366492,-97.970381,0,'2013-07-06 12:44:33',NULL,NULL),(72712,'89449','P','Stateline','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.962500,-119.938800,0,'2013-07-06 12:44:34',NULL,NULL),(3800,'02228','P','East Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.360007,-71.062270,0,'2013-07-06 12:44:30',NULL,NULL),(33972,'38109','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.046864,-90.068205,0,'2013-07-06 12:44:32',NULL,NULL),(10910,'11428','S','Bellrs Manor','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(44772,'50210','S','New Virginia','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.205240,-93.670620,0,'2013-07-06 12:44:32',NULL,NULL),(24245,'26764','S','Corinth','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.444161,-79.544620,0,'2013-07-06 12:44:31',NULL,NULL),(25994,'28670','S','Clingman','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.236340,-80.926620,0,'2013-07-06 12:44:31',NULL,NULL),(78648,'98225','S','Chuckanut','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.746494,-122.493289,0,'2013-07-06 12:44:34',NULL,NULL),(62203,'73838','S','Chester','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.329878,-98.872945,0,'2013-07-06 12:44:33',NULL,NULL),(23018,'24828','S','Twin Branch','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.470561,-81.659490,0,'2013-07-06 12:44:31',NULL,NULL),(27818,'30401','S','Summertown','A','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(6483,'05769','S','Lake Dunmore','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.903320,-73.095300,0,'2013-07-06 12:44:30',NULL,NULL),(3723,'02150','S','Chelsea','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.397479,-71.035464,0,'2013-07-06 12:44:30',NULL,NULL),(50603,'58251','S','Larimore','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.898360,-97.669140,0,'2013-07-06 12:44:33',NULL,NULL),(73992,'92101','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.722628,-117.165331,0,'2013-07-06 12:44:34',NULL,NULL),(19358,'20050','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906181,-76.987222,0,'2013-07-06 12:44:31',NULL,NULL),(15943,'17022','S','West Donegal','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(76970,'96052','S','Lewiston','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.703668,-122.803764,0,'2013-07-06 12:44:34',NULL,NULL),(64792,'77014','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.981923,-95.468159,0,'2013-07-06 12:44:34',NULL,NULL),(64356,'76520','S','Jones Prairie','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(2246,'00926','S','Urb Laderas de Palma Real','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(45680,'52043','S','Communia','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.856180,-91.404581,0,'2013-07-06 12:44:32',NULL,NULL),(18607,'19144','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.031925,-75.173958,0,'2013-07-06 12:44:31',NULL,NULL),(23731,'25915','S','Rhodell','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.623930,-81.286203,0,'2013-07-06 12:44:31',NULL,NULL),(16176,'17066','S','Lucy Furnace','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.386060,-77.874060,0,'2013-07-06 12:44:31',NULL,NULL),(58468,'68736','S','Fordyce','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.735874,-97.367480,0,'2013-07-06 12:44:33',NULL,NULL),(3499,'01852','S','Lowell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.634512,-71.296816,0,'2013-07-06 12:44:30',NULL,NULL),(9002,'08853','S','Neshanic Sta','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.508543,-74.717562,0,'2013-07-06 12:44:30',NULL,NULL),(25813,'28608','U','Appalachian State Univ','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.211626,-81.668282,0,'2013-07-06 12:44:31',NULL,NULL),(26743,'29422','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.681241,-79.953645,0,'2013-07-06 12:44:31',NULL,NULL),(77,'00612','S','Ext Villa los Santos Ii','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(22606,'24210','S','Osceola','N','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.707838,-81.978013,0,'2013-07-06 12:44:31',NULL,NULL),(24579,'27316','S','Coleridge','A','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.703120,-79.624200,0,'2013-07-06 12:44:31',NULL,NULL),(41040,'46394','S','Robertsdale','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.679405,-87.496209,0,'2013-07-06 12:44:32',NULL,NULL),(70289,'84533','S','Halls Xing','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(61964,'73178','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.535490,-97.567572,0,'2013-07-06 12:44:33',NULL,NULL),(59852,'71254','S','Lk Providence','A','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(79110,'98466','S','Fircrest','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225803,-122.534108,0,'2013-07-06 12:44:34',NULL,NULL),(32849,'36502','S','Mc Cullough','A','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.021667,-87.484959,0,'2013-07-06 12:44:32',NULL,NULL),(7664,'07087','S','Union City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.770419,-74.030901,0,'2013-07-06 12:44:30',NULL,NULL),(21213,'22206','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.841046,-77.092448,0,'2013-07-06 12:44:31',NULL,NULL),(14238,'14814','S','Big Flats','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.145843,-76.947025,0,'2013-07-06 12:44:31',NULL,NULL),(29698,'32937','S','Ind Hbr Bch','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(10099,'10249','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(48198,'55397','S','Nya','A','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.803025,-93.930766,0,'2013-07-06 12:44:33',NULL,NULL),(73276,'90740','S','Seal Beach','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.760225,-118.080806,0,'2013-07-06 12:44:34',NULL,NULL),(68950,'82941','S','Pinedale','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.866522,-109.870027,0,'2013-07-06 12:44:34',NULL,NULL),(16803,'17543','S','Kissel Hill','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(74628,'92806','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.835569,-117.868059,0,'2013-07-06 12:44:34',NULL,NULL),(74758,'93067','P','Summerland','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.422355,-119.596145,0,'2013-07-06 12:44:34',NULL,NULL),(17021,'17744','S','Pine Run','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.271905,-77.162229,0,'2013-07-06 12:44:31',NULL,NULL),(56372,'65217','U','State Farm Ins','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.897983,-92.333640,0,'2013-07-06 12:44:33',NULL,NULL),(62794,'74884','S','New Lima','A','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.160960,-96.503340,0,'2013-07-06 12:44:33',NULL,NULL),(64125,'76190','U','Verizon','N','Tarrant','48439','Texas','TX','48','0000','000','Eastern',-5.0,'Y',21.266700,-99.316700,0,'2013-07-06 12:44:34',NULL,NULL),(66504,'78683','P','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.509363,-97.676254,0,'2013-07-06 12:44:34',NULL,NULL),(31001,'33771','S','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.901331,-82.756093,0,'2013-07-06 12:44:32',NULL,NULL),(39697,'45039','S','Hamilton Township','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.320497,-84.253761,0,'2013-07-06 12:44:32',NULL,NULL),(33941,'38075','S','Somerville','A','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.324796,-89.149580,0,'2013-07-06 12:44:32',NULL,NULL),(5315,'04568','S','South Bristol','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.868138,-69.559728,0,'2013-07-06 12:44:30',NULL,NULL),(63572,'75772','P','Maydelle','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.800804,-95.303845,0,'2013-07-06 12:44:34',NULL,NULL),(58258,'68372','S','Hickman','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.588620,-96.617700,0,'2013-07-06 12:44:33',NULL,NULL),(71599,'87321','S','Ramah','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.135560,-108.505655,0,'2013-07-06 12:44:34',NULL,NULL),(51216,'59050','S','Lodge Grass','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.294103,-107.820532,0,'2013-07-06 12:44:33',NULL,NULL),(32102,'35296','U','Compass Bank','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.414914,-86.809475,0,'2013-07-06 12:44:32',NULL,NULL),(29152,'32340','S','Madison','D','Madison','12079','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.467665,-83.415379,0,'2013-07-06 12:44:32',NULL,NULL),(33191,'37035','S','Chapmansboro','D','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.368347,-87.137681,0,'2013-07-06 12:44:32',NULL,NULL),(74664,'92856','P','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.784056,-117.843476,0,'2013-07-06 12:44:34',NULL,NULL),(64989,'77279','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.768115,-95.510337,0,'2013-07-06 12:44:34',NULL,NULL),(38100,'43085','S','Mount Air','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098773,-83.017045,0,'2013-07-06 12:44:32',NULL,NULL),(34879,'38941','S','Quito','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(14028,'14544','S','Rushville','D','Yates','36123','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.742889,-77.245455,0,'2013-07-06 12:44:31',NULL,NULL),(44248,'49670','S','Northport Point','N','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.132456,-85.611687,0,'2013-07-06 12:44:32',NULL,NULL),(29786,'33016','S','Hialeah Gdns','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890138,-80.341466,0,'2013-07-06 12:44:32',NULL,NULL),(16555,'17310','P','Cashtown','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.888603,-77.358894,0,'2013-07-06 12:44:31',NULL,NULL),(55188,'63377','S','Silex','D','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.140541,-91.061883,0,'2013-07-06 12:44:33',NULL,NULL),(2297,'00927','S','Jard Metropolitano','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(53191,'61607','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(43940,'49284','S','Springport','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.379037,-84.666199,0,'2013-07-06 12:44:32',NULL,NULL),(8906,'08735','S','Lavallette','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.980754,-74.100351,0,'2013-07-06 12:44:30',NULL,NULL),(53928,'62401','S','Lake Sara','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(65357,'77531','S','Clute','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.046060,-95.402160,0,'2013-07-06 12:44:34',NULL,NULL),(70172,'84324','S','Mantua','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.494534,-111.938697,0,'2013-07-06 12:44:34',NULL,NULL),(78968,'98371','S','Jovita','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(43446,'48509','S','Northeast','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.024922,-83.604329,0,'2013-07-06 12:44:32',NULL,NULL),(80030,'99690','P','Nightmute','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.470000,-164.720000,0,'2013-07-06 12:44:34',NULL,NULL),(22402,'23958','S','Darlington Heights','A','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.260126,-78.645051,0,'2013-07-06 12:44:31',NULL,NULL),(25826,'28615','S','Parker','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.447180,-81.659280,0,'2013-07-06 12:44:31',NULL,NULL),(72995,'90059','S','August F Haw','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.926115,-118.242201,0,'2013-07-06 12:44:34',NULL,NULL),(5615,'04937','S','Fairfield','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.602380,-69.631697,0,'2013-07-06 12:44:30',NULL,NULL),(32196,'35546','S','Berry','D','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.500490,-87.687768,0,'2013-07-06 12:44:32',NULL,NULL),(29052,'32239','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.330986,-81.577906,0,'2013-07-06 12:44:32',NULL,NULL),(18754,'19345','P','Immaculata','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.900291,-75.671906,0,'2013-07-06 12:44:31',NULL,NULL),(36632,'41004','S','Brooksville','D','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(42058,'47448','S','Coffey Subdiv','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(73880,'91944','P','La Mesa','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.768983,-117.021343,0,'2013-07-06 12:44:34',NULL,NULL),(56991,'66203','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(34233,'38375','S','Selmer','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.153700,-88.611000,0,'2013-07-06 12:44:32',NULL,NULL),(57909,'67656','S','Ogallah','D','Trego','20195','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.913103,-99.688615,0,'2013-07-06 12:44:33',NULL,NULL),(59305,'70512','S','Arnaudville','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.361045,-91.925819,0,'2013-07-06 12:44:33',NULL,NULL),(47412,'54655','S','Soldier Grove','A','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.385327,-90.769115,0,'2013-07-06 12:44:32',NULL,NULL),(13409,'13754','S','Barbourville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(69509,'83715','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.560976,-116.218248,0,'2013-07-06 12:44:34',NULL,NULL),(60820,'72032','S','Skunkhollow','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(56067,'64747','S','Gunn City','N','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.555303,-94.188013,0,'2013-07-06 12:44:33',NULL,NULL),(9201,'09463','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(34107,'38181','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.052297,-89.942237,0,'2013-07-06 12:44:32',NULL,NULL),(33616,'37658','S','Hampton','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.241626,-82.195210,0,'2013-07-06 12:44:32',NULL,NULL),(12717,'13153','P','Skan Fa','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.994912,-76.452863,0,'2013-07-06 12:44:30',NULL,NULL),(75469,'94103','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.773792,-122.409865,0,'2013-07-06 12:44:34',NULL,NULL),(39906,'45216','S','Elmwood Pl','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(48973,'56214','S','Belview','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.814489,-95.543118,0,'2013-07-06 12:44:33',NULL,NULL),(53870,'62343','S','East Hannibal','N','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.720145,-91.262764,0,'2013-07-06 12:44:33',NULL,NULL),(40075,'45280','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.161596,-84.460490,0,'2013-07-06 12:44:32',NULL,NULL),(61829,'73112','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.519414,-97.575300,0,'2013-07-06 12:44:33',NULL,NULL),(24657,'27405','S','Rankin','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(4048,'02635','S','Cotuit','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.626880,-70.434750,0,'2013-07-06 12:44:30',NULL,NULL),(47441,'54724','S','Eagleton','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.100309,-91.483314,0,'2013-07-06 12:44:32',NULL,NULL),(4667,'03774','S','No Haverhill','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.084308,-72.025912,0,'2013-07-06 12:44:30',NULL,NULL),(61650,'72858','S','Pottsville','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.213796,-92.995721,0,'2013-07-06 12:44:33',NULL,NULL),(48207,'55406','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.940817,-93.224478,0,'2013-07-06 12:44:33',NULL,NULL),(63892,'76018','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.652642,-97.094943,0,'2013-07-06 12:44:34',NULL,NULL),(55251,'63452','S','Lewistown','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.082877,-91.813182,0,'2013-07-06 12:44:33',NULL,NULL),(8312,'08031','S','Bellmawr','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.867047,-75.089079,0,'2013-07-06 12:44:30',NULL,NULL),(29199,'32408','S','P C Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.158417,-85.763888,0,'2013-07-06 12:44:32',NULL,NULL),(31048,'33826','P','Avon Park','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.593634,-81.502978,0,'2013-07-06 12:44:32',NULL,NULL),(48768,'55985','S','Berne','N','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.147500,-92.836111,0,'2013-07-06 12:44:33',NULL,NULL),(70870,'85603','S','Tintown','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(53165,'61568','S','Allentown','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.525564,-89.488301,0,'2013-07-06 12:44:33',NULL,NULL),(43293,'48336','S','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458873,-83.346843,0,'2013-07-06 12:44:32',NULL,NULL),(75801,'94801','S','Point Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.942278,-122.355347,0,'2013-07-06 12:44:34',NULL,NULL),(25000,'27870','S','Roanoke Rapids','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.451430,-77.655125,0,'2013-07-06 12:44:31',NULL,NULL),(6721,'06070','S','Simsbury','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.876721,-72.822749,0,'2013-07-06 12:44:30',NULL,NULL),(46176,'52736','U','Clinton','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.842528,-90.231685,0,'2013-07-06 12:44:32',NULL,NULL),(39997,'45243','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.185697,-84.352352,0,'2013-07-06 12:44:32',NULL,NULL),(64337,'76505','P','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.020450,-97.329533,0,'2013-07-06 12:44:34',NULL,NULL),(2621,'00962','S','Sect La Puntilla','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(32207,'35555','S','Fayette','D','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.694040,-87.831107,0,'2013-07-06 12:44:32',NULL,NULL),(14762,'15334','S','Garards Fort','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.862387,-80.002418,0,'2013-07-06 12:44:31',NULL,NULL),(39467,'44710','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.793793,-81.421951,0,'2013-07-06 12:44:32',NULL,NULL),(69009,'83206','P','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.863820,-112.453085,0,'2013-07-06 12:44:34',NULL,NULL),(5326,'04575','P','W Boothby Hbr','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.848039,-69.651327,0,'2013-07-06 12:44:30',NULL,NULL),(16820,'17547','S','Shocks Mills','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061561,-76.559472,0,'2013-07-06 12:44:31',NULL,NULL),(27558,'30260','S','Lake City','A','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.583733,-84.328154,0,'2013-07-06 12:44:31',NULL,NULL),(9198,'09454','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(47345,'54602','P','La Crosse','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.827618,-91.232393,0,'2013-07-06 12:44:32',NULL,NULL),(69331,'83525','S','Elk City','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.823543,-115.443122,0,'2013-07-06 12:44:34',NULL,NULL),(60732,'71960','S','Norman','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.457226,-93.657823,0,'2013-07-06 12:44:33',NULL,NULL),(8470,'08089','S','Waterford','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722580,-74.859000,0,'2013-07-06 12:44:30',NULL,NULL),(11450,'11978','S','W Hampton Bch','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(74970,'93436','S','Lompoc','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.651186,-120.435893,0,'2013-07-06 12:44:34',NULL,NULL),(4415,'03226','S','CTR Harbor','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715187,-71.492553,0,'2013-07-06 12:44:30',NULL,NULL),(41086,'46536','S','Lakeville','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.525454,-86.275744,0,'2013-07-06 12:44:32',NULL,NULL),(38954,'44126','S','Fairview Pk','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.446483,-81.856757,0,'2013-07-06 12:44:32',NULL,NULL),(58557,'68822','S','Broken Bow','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.404251,-99.640958,0,'2013-07-06 12:44:33',NULL,NULL),(1052,'00723','S','Villas de Patillas','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(72621,'89418','S','Nevada Mass','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(80013,'99677','P','Tatitlek','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.105204,-147.109932,0,'2013-07-06 12:44:34',NULL,NULL),(54378,'62812','S','Eastern','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(44413,'49831','S','Felch','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.998379,-87.826892,0,'2013-07-06 12:44:32',NULL,NULL),(41734,'47250','S','Madison','D','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.755353,-85.397514,0,'2013-07-06 12:44:32',NULL,NULL),(14683,'15250','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.448293,-79.951894,0,'2013-07-06 12:44:31',NULL,NULL),(52891,'61350','S','Ottawa','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(22941,'24637','S','Paint Lick','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.057980,-81.738120,0,'2013-07-06 12:44:31',NULL,NULL),(35776,'39744','S','Sapa','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(27411,'30096','S','Berkeley Lake','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.985868,-84.163754,0,'2013-07-06 12:44:31',NULL,NULL),(51720,'60010','S','Lk Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(57202,'66428','S','Goff','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.651949,-95.957550,0,'2013-07-06 12:44:33',NULL,NULL),(37402,'41773','S','Vicco','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.157727,-83.095710,0,'2013-07-06 12:44:32',NULL,NULL),(13678,'14039','S','Dale','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.837927,-78.171008,0,'2013-07-06 12:44:31',NULL,NULL),(51486,'59620','P','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.532823,-112.157489,0,'2013-07-06 12:44:33',NULL,NULL),(39366,'44637','S','Layland','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.502447,-81.988483,0,'2013-07-06 12:44:32',NULL,NULL),(56557,'65466','S','Eminence','D','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(74937,'93407','S','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.298873,-120.658799,0,'2013-07-06 12:44:34',NULL,NULL),(36844,'41075','S','Kenton Vale','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.091389,-84.495833,0,'2013-07-06 12:44:32',NULL,NULL),(24086,'26501','S','Westover','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.569424,-79.992081,0,'2013-07-06 12:44:31',NULL,NULL),(16497,'17257','S','Tusculam','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(7221,'06501','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310083,-72.926314,0,'2013-07-06 12:44:30',NULL,NULL),(43205,'48304','S','Bloomfld Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(32811,'36446','P','Fulton','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.786660,-87.647785,0,'2013-07-06 12:44:32',NULL,NULL),(42622,'47905','S','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.322083,-86.910463,0,'2013-07-06 12:44:32',NULL,NULL),(64186,'76240','S','Callisburg','A','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.621754,-97.121151,0,'2013-07-06 12:44:34',NULL,NULL),(3296,'01508','P','Richardson Corners','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.151392,-71.989604,0,'2013-07-06 12:44:30',NULL,NULL),(48326,'55448','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.187610,-93.298576,0,'2013-07-06 12:44:33',NULL,NULL),(72227,'88435','S','Pastura','A','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.936606,-104.684358,0,'2013-07-06 12:44:34',NULL,NULL),(22347,'23883','S','Surry','D','Surry','51181','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.127433,-76.752688,0,'2013-07-06 12:44:31',NULL,NULL),(23128,'24970','S','Fort Spring','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.752172,-80.467326,0,'2013-07-06 12:44:31',NULL,NULL),(9117,'09128','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(842,'00698','S','Colinas de Yauco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(39557,'44846','S','Milan','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.308029,-82.601408,0,'2013-07-06 12:44:32',NULL,NULL),(42649,'47940','S','Darlington','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.137961,-86.756432,0,'2013-07-06 12:44:32',NULL,NULL),(27135,'29812','S','Barnwell','D','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.243078,-81.359153,0,'2013-07-06 12:44:31',NULL,NULL),(34935,'39042','S','Brandon','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289412,-89.967651,0,'2013-07-06 12:44:32',NULL,NULL),(13604,'13856','S','Readburn','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(13645,'14004','S','Townline','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.901992,-78.524759,0,'2013-07-06 12:44:31',NULL,NULL),(53089,'61528','S','Kickapoo','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.790000,-89.751111,0,'2013-07-06 12:44:33',NULL,NULL),(64109,'76180','S','N Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(29112,'32308','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.503754,-84.212359,0,'2013-07-06 12:44:32',NULL,NULL),(27301,'30013','S','Conyers','D','Rockdale','13247','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.640211,-83.962891,0,'2013-07-06 12:44:31',NULL,NULL),(45101,'50543','S','Slifer','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.278285,-94.288979,0,'2013-07-06 12:44:32',NULL,NULL),(47311,'54555','S','Luger','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(44812,'50239','S','Saint Anthony','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.130933,-93.198735,0,'2013-07-06 12:44:32',NULL,NULL),(53653,'62205','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(34365,'38609','S','Belen','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.232702,-90.292653,0,'2013-07-06 12:44:32',NULL,NULL),(30921,'33708','S','Redington Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(12051,'12530','P','Hollowville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.225766,-73.677514,0,'2013-07-06 12:44:30',NULL,NULL),(5625,'04942','S','Kingsbury Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.011460,-69.569760,0,'2013-07-06 12:44:30',NULL,NULL),(9649,'10037','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(20817,'21619','S','Chester','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.968876,-76.291949,0,'2013-07-06 12:44:31',NULL,NULL),(30654,'33461','S','Village of Palm Springs','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.612961,-80.089250,0,'2013-07-06 12:44:32',NULL,NULL),(13542,'13827','S','South Owego','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(13344,'13691','S','Theresa','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.197024,-75.796300,0,'2013-07-06 12:44:30',NULL,NULL),(66011,'78353','S','Kelsay','N','Brooks','48047','Texas','TX','48','0000','361','Central',-6.0,'Y',26.983969,-98.209608,0,'2013-07-06 12:44:34',NULL,NULL),(63104,'75275','U','Southern Methodist Universit','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.843618,-96.783951,0,'2013-07-06 12:44:33',NULL,NULL),(39310,'44513','P','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.024672,-80.675960,0,'2013-07-06 12:44:32',NULL,NULL),(42701,'47994','S','Wingate','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.173470,-87.070915,0,'2013-07-06 12:44:32',NULL,NULL),(46028,'52552','S','Drakesville','D','Davis','19051','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.777019,-92.455663,0,'2013-07-06 12:44:32',NULL,NULL),(1961,'00823','P','Christiansted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.744235,-64.708266,0,'2013-07-06 12:44:30',NULL,NULL),(29833,'33030','S','Leisure City','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.481403,-80.505418,0,'2013-07-06 12:44:32',NULL,NULL),(66655,'78851','S','Dryden','D','Terrell','48443','Texas','TX','48','0000','432','Central',-6.0,'Y',30.226942,-102.077824,0,'2013-07-06 12:44:34',NULL,NULL),(39983,'45240','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.285863,-84.524542,0,'2013-07-06 12:44:32',NULL,NULL),(14175,'14741','S','Great Valley','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.212580,-78.590700,0,'2013-07-06 12:44:31',NULL,NULL),(59626,'71037','S','Bellevue','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(34770,'38863','S','Pontotoc','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(40381,'45657','S','Otway','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.820494,-83.286860,0,'2013-07-06 12:44:32',NULL,NULL),(27147,'29824','S','Edgefield','D','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.786960,-81.929623,0,'2013-07-06 12:44:31',NULL,NULL),(45856,'52237','S','Sand Spring','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.320147,-91.127320,0,'2013-07-06 12:44:32',NULL,NULL),(71716,'87531','S','Embudo','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.141996,-105.998001,0,'2013-07-06 12:44:34',NULL,NULL),(56976,'66201','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.969026,-94.676138,0,'2013-07-06 12:44:33',NULL,NULL),(32093,'35293','U','Dept of Treas Bur Accts','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463859,-86.823031,0,'2013-07-06 12:44:32',NULL,NULL),(25393,'28274','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.188792,-80.837133,0,'2013-07-06 12:44:31',NULL,NULL),(69500,'83708','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.610841,-116.213183,0,'2013-07-06 12:44:34',NULL,NULL),(9936,'10154','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(33340,'37165','P','Slayden','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.225192,-87.461496,0,'2013-07-06 12:44:32',NULL,NULL),(46731,'53824','P','Sinsinawa','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.523779,-90.537853,0,'2013-07-06 12:44:32',NULL,NULL),(39870,'45205','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.109367,-84.574394,0,'2013-07-06 12:44:32',NULL,NULL),(37096,'41339','S','Talbert','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(4619,'03598','S','Dalton','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.376161,-71.618637,0,'2013-07-06 12:44:30',NULL,NULL),(35659,'39648','S','Bear Town','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(22493,'24068','P','Christiansburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.142462,-80.400792,0,'2013-07-06 12:44:31',NULL,NULL),(78493,'98106','S','White Center','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.536346,-122.352802,0,'2013-07-06 12:44:34',NULL,NULL),(14274,'14852','P','Ithaca','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.507018,-76.471133,0,'2013-07-06 12:44:31',NULL,NULL),(30200,'33181','S','Biscayne Park','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(51320,'59253','S','Peerless','D','Daniels','30019','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.782296,-105.799736,0,'2013-07-06 12:44:33',NULL,NULL),(41318,'46774','S','Gar Creek','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(56782,'65752','S','South Greenfield','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.366087,-93.844568,0,'2013-07-06 12:44:33',NULL,NULL),(62549,'74437','S','Salem','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(13533,'13825','S','Otsdawa','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.394454,-75.172478,0,'2013-07-06 12:44:31',NULL,NULL),(22540,'24122','S','Montvale','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.429529,-79.707858,0,'2013-07-06 12:44:31',NULL,NULL),(24478,'27244','S','Elon College','A','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.135017,-79.505282,0,'2013-07-06 12:44:31',NULL,NULL),(72559,'89301','S','Preston','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(67885,'80861','S','Vona','D','Kit Carson','08063','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.353880,-102.735678,0,'2013-07-06 12:44:34',NULL,NULL),(62487,'74354','S','Miami','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.880147,-94.874310,0,'2013-07-06 12:44:33',NULL,NULL),(60645,'71909','S','Hot Spgs Vl','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.610580,-93.014760,0,'2013-07-06 12:44:33',NULL,NULL),(23726,'25909','P','Prosperity','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.836699,-81.208506,0,'2013-07-06 12:44:31',NULL,NULL),(26095,'28714','S','Burnsville','D','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.885779,-82.259797,0,'2013-07-06 12:44:31',NULL,NULL),(41839,'47348','S','Hartford City','D','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(28196,'31019','S','Dexter','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.438652,-83.060758,0,'2013-07-06 12:44:31',NULL,NULL),(12944,'13353','P','Hoffmeister','D','Hamilton','36041','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.468973,-74.727687,0,'2013-07-06 12:44:30',NULL,NULL),(26164,'28743','S','Spring Creek','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(52675,'61077','P','Seward','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.239655,-89.355356,0,'2013-07-06 12:44:33',NULL,NULL),(55020,'63135','S','Burke City','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748900,-90.303899,0,'2013-07-06 12:44:33',NULL,NULL),(56958,'66106','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.062520,-94.717740,0,'2013-07-06 12:44:33',NULL,NULL),(26805,'29466','S','Mt Pleasant','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.792155,-79.863357,0,'2013-07-06 12:44:31',NULL,NULL),(65235,'77451','P','Powell Point','N','Fort Bend','48157','Texas','TX','48','3360','979','Central',-6.0,'Y',29.447929,-96.001002,0,'2013-07-06 12:44:34',NULL,NULL),(59842,'71247','P','North Hodge','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.278002,-92.712240,0,'2013-07-06 12:44:33',NULL,NULL),(56254,'65059','S','Mokane','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.701839,-91.883986,0,'2013-07-06 12:44:33',NULL,NULL),(53559,'62051','S','Irving','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.204818,-89.405456,0,'2013-07-06 12:44:33',NULL,NULL),(30530,'33407','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.760988,-80.085606,0,'2013-07-06 12:44:32',NULL,NULL),(26444,'29135','S','Fort Motte','A','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.661870,-80.781778,0,'2013-07-06 12:44:31',NULL,NULL),(9476,'10010','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(44595,'50047','S','Avon Lake','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.477985,-93.476846,0,'2013-07-06 12:44:32',NULL,NULL),(13323,'13677','P','Pyrites','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.515099,-75.185572,0,'2013-07-06 12:44:30',NULL,NULL),(13405,'13753','S','Fraser','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.282872,-74.910178,0,'2013-07-06 12:44:31',NULL,NULL),(29903,'33050','S','Marathon Shrs','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(44258,'49682','S','Suttons Bay','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.967179,-85.639857,0,'2013-07-06 12:44:32',NULL,NULL),(18417,'19060','S','Upper Chichester','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.846163,-75.445489,0,'2013-07-06 12:44:31',NULL,NULL),(75342,'93902','P','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.672603,-121.657451,0,'2013-07-06 12:44:34',NULL,NULL),(53430,'61858','S','Oakwood','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.107624,-87.776626,0,'2013-07-06 12:44:33',NULL,NULL),(14972,'15632','S','Murrysville','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.430536,-79.608959,0,'2013-07-06 12:44:31',NULL,NULL),(34085,'38157','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.111106,-89.896047,0,'2013-07-06 12:44:32',NULL,NULL),(23525,'25569','P','Teays','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.442544,-81.952025,0,'2013-07-06 12:44:31',NULL,NULL),(75800,'94801','S','North Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.942278,-122.355347,0,'2013-07-06 12:44:34',NULL,NULL),(6627,'05905','S','Ferdinand','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(2515,'00957','S','Urb Montanez','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(1431,'00739','S','Parc Gandara II','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(12171,'12758','S','Livingston Manor','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.912654,-74.754347,0,'2013-07-06 12:44:30',NULL,NULL),(76904,'95986','P','Washington','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353510,-120.777281,0,'2013-07-06 12:44:34',NULL,NULL),(68299,'81091','S','Tercio','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(65460,'77619','S','Steeltown','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.942831,-93.913486,0,'2013-07-06 12:44:34',NULL,NULL),(63853,'75977','S','Mattox','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(63713,'75925','S','Forest','A','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.642080,-95.087100,0,'2013-07-06 12:44:34',NULL,NULL),(72573,'89402','P','Crystal Bay','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.281362,-119.951752,0,'2013-07-06 12:44:34',NULL,NULL),(58377,'68531','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.885280,-96.713107,0,'2013-07-06 12:44:33',NULL,NULL),(57717,'67356','S','Labette','N','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.189320,-95.138160,0,'2013-07-06 12:44:33',NULL,NULL),(44136,'49512','S','Kentwood','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881460,-85.535400,0,'2013-07-06 12:44:32',NULL,NULL),(23840,'26133','S','Belleville','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.125438,-81.670967,0,'2013-07-06 12:44:31',NULL,NULL),(30388,'33320','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.143950,-80.141327,0,'2013-07-06 12:44:32',NULL,NULL),(45679,'52043','S','Clayton Center','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.856180,-91.404581,0,'2013-07-06 12:44:32',NULL,NULL),(38012,'43004','S','Blacklick','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.011212,-82.809460,0,'2013-07-06 12:44:32',NULL,NULL),(70557,'85041','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.385171,-112.103206,0,'2013-07-06 12:44:34',NULL,NULL),(36011,'40155','S','Muldraugh','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.934965,-85.992791,0,'2013-07-06 12:44:32',NULL,NULL),(20582,'21157','S','Carrollton','N','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.555120,-76.990560,0,'2013-07-06 12:44:31',NULL,NULL),(47620,'54903','P','Oshkosh','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.997702,-88.560337,0,'2013-07-06 12:44:33',NULL,NULL),(63619,'75833','S','Centerville','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.249797,-95.973492,0,'2013-07-06 12:44:34',NULL,NULL),(79288,'98582','S','Salkum','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.526552,-122.627356,0,'2013-07-06 12:44:34',NULL,NULL),(58436,'68701','S','Hadar','A','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.033639,-97.421914,0,'2013-07-06 12:44:33',NULL,NULL),(53961,'62427','S','Heathsville','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.900944,-87.672357,0,'2013-07-06 12:44:33',NULL,NULL),(9183,'09370','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3233,'01375','S','Sunderland','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.461326,-72.563693,0,'2013-07-06 12:44:30',NULL,NULL),(5227,'04463','S','Medford','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.248630,-68.986198,0,'2013-07-06 12:44:30',NULL,NULL),(6801,'06108','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(25822,'28615','S','Ashland','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.447180,-81.659280,0,'2013-07-06 12:44:31',NULL,NULL),(235,'00627','S','VISTAS de Camuy','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(77932,'97331','S','Oregon State Univ','N','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.565718,-123.280906,0,'2013-07-06 12:44:34',NULL,NULL),(44300,'49733','S','Frederic','D','Crawford','26039','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.795919,-84.723377,0,'2013-07-06 12:44:32',NULL,NULL),(46000,'52531','S','Avery','N','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.086920,-92.728800,0,'2013-07-06 12:44:32',NULL,NULL),(39511,'44811','S','Bellevue','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.254327,-82.816931,0,'2013-07-06 12:44:32',NULL,NULL),(60649,'71909','S','Hot Springs Village','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.610580,-93.014760,0,'2013-07-06 12:44:33',NULL,NULL),(56222,'65039','S','Wilton','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.729430,-92.304428,0,'2013-07-06 12:44:33',NULL,NULL),(35093,'39205','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.304324,-90.182529,0,'2013-07-06 12:44:32',NULL,NULL),(11741,'12185','S','Valley Falls','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.887140,-73.544884,0,'2013-07-06 12:44:30',NULL,NULL),(1622,'00771','S','Ext La Inmaculada','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(79835,'99521','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.205326,-149.745570,0,'2013-07-06 12:44:34',NULL,NULL),(78954,'98368','S','Townsend','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(72532,'89164','U','The Lakes','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.127669,-115.277477,0,'2013-07-06 12:44:34',NULL,NULL),(67460,'80217','P','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.751137,-104.996990,0,'2013-07-06 12:44:34',NULL,NULL),(382,'00660','S','Urb Verdun','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(4140,'02760','S','N Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.977034,-71.324788,0,'2013-07-06 12:44:30',NULL,NULL),(31554,'34607','S','Spring Hill','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.505114,-82.636115,0,'2013-07-06 12:44:32',NULL,NULL),(34527,'38683','S','Camphill','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.947755,-88.899821,0,'2013-07-06 12:44:32',NULL,NULL),(34540,'38702','P','Greenville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.408211,-91.061088,0,'2013-07-06 12:44:32',NULL,NULL),(13894,'14270','U','Marine Midland','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870000,-78.832208,0,'2013-07-06 12:44:31',NULL,NULL),(50851,'58492','S','Frazier','N','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.172540,-98.458847,0,'2013-07-06 12:44:33',NULL,NULL),(25600,'28451','S','Northwest','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.213760,-78.038355,0,'2013-07-06 12:44:31',NULL,NULL),(79105,'98448','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.145996,-122.436154,0,'2013-07-06 12:44:34',NULL,NULL),(56737,'65711','S','Mountain Grv','A','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.378970,-92.367020,0,'2013-07-06 12:44:33',NULL,NULL),(34070,'38148','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.146943,-90.046493,0,'2013-07-06 12:44:32',NULL,NULL),(49338,'56563','S','Moorhead State University','N','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.867452,-96.756248,0,'2013-07-06 12:44:33',NULL,NULL),(2673,'00966','S','Villa Caparra','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(41384,'46799','P','Zanesville','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.917963,-85.277888,0,'2013-07-06 12:44:32',NULL,NULL),(36515,'40828','S','Woods','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(62623,'74547','S','Hartshorne','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.846686,-95.558479,0,'2013-07-06 12:44:33',NULL,NULL),(12305,'12853','S','North Creek','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.721592,-73.920875,0,'2013-07-06 12:44:30',NULL,NULL),(24174,'26621','S','Flatwoods','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.728200,-80.630580,0,'2013-07-06 12:44:31',NULL,NULL),(77913,'97310','U','State Government','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.910500,-123.009129,0,'2013-07-06 12:44:34',NULL,NULL),(61630,'72835','S','Delaware','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.239495,-93.444305,0,'2013-07-06 12:44:33',NULL,NULL),(9504,'10014','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(35030,'39161','P','Sandhill','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.469765,-89.876398,0,'2013-07-06 12:44:32',NULL,NULL),(77141,'96160','P','Truckee','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.329587,-120.179308,0,'2013-07-06 12:44:34',NULL,NULL),(68467,'81236','S','Nathrop','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.700006,-106.141598,0,'2013-07-06 12:44:34',NULL,NULL),(42684,'47980','S','Reynolds','D','White','18181','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.750017,-86.872641,0,'2013-07-06 12:44:32',NULL,NULL),(36241,'40295','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.249134,-85.757506,0,'2013-07-06 12:44:32',NULL,NULL),(10286,'10518','S','Cross River','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.268446,-73.602238,0,'2013-07-06 12:44:30',NULL,NULL),(28392,'31312','S','Pineora','N','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.319023,-81.394389,0,'2013-07-06 12:44:32',NULL,NULL),(5468,'04739','S','Eagle Lake','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.040052,-68.589901,0,'2013-07-06 12:44:30',NULL,NULL),(50522,'58081','S','Wyndmere','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.262652,-97.133102,0,'2013-07-06 12:44:33',NULL,NULL),(18572,'19127','S','Manayunk','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.029648,-75.223171,0,'2013-07-06 12:44:31',NULL,NULL),(59616,'71030','S','Gloster','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.199593,-93.847234,0,'2013-07-06 12:44:33',NULL,NULL),(79719,'99213','P','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.656583,-117.291099,0,'2013-07-06 12:44:34',NULL,NULL),(77963,'97368','S','Otis','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.002400,-123.905280,0,'2013-07-06 12:44:34',NULL,NULL),(69739,'84045','S','Lehi','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.345179,-111.911529,0,'2013-07-06 12:44:34',NULL,NULL),(14658,'15237','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.549733,-80.039957,0,'2013-07-06 12:44:31',NULL,NULL),(66430,'78642','S','Liberty Hill','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.684999,-97.910430,0,'2013-07-06 12:44:34',NULL,NULL),(61096,'72135','S','Northpoint','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.869776,-92.522556,0,'2013-07-06 12:44:33',NULL,NULL),(7043,'06277','S','Mechanicsville','N','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',41.977800,-71.847180,0,'2013-07-06 12:44:30',NULL,NULL),(47302,'54552','S','Kaiser','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(29743,'32968','S','Citrus Ridge','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.596949,-80.452283,0,'2013-07-06 12:44:32',NULL,NULL),(51867,'60082','P','Techny','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.108147,-87.807496,0,'2013-07-06 12:44:33',NULL,NULL),(68146,'80995','U','Focus on the Family','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.964661,-104.792493,0,'2013-07-06 12:44:34',NULL,NULL),(26631,'29325','S','Clinton','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.470685,-81.887131,0,'2013-07-06 12:44:31',NULL,NULL),(6258,'05602','S','Gould Hill','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(52806,'61278','P','Rapids City','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.579534,-90.349147,0,'2013-07-06 12:44:33',NULL,NULL),(64555,'76654','P','Leroy','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.655482,-96.979211,0,'2013-07-06 12:44:34',NULL,NULL),(46064,'52577','S','Keomah Village','A','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.286600,-92.600280,0,'2013-07-06 12:44:32',NULL,NULL),(35664,'39649','P','McComb','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.243738,-90.455916,0,'2013-07-06 12:44:32',NULL,NULL),(21406,'22523','P','Morattico','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.788658,-76.630028,0,'2013-07-06 12:44:31',NULL,NULL),(58715,'68937','S','Elwood','D','Gosper','31073','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.557840,-99.856380,0,'2013-07-06 12:44:33',NULL,NULL),(41631,'47130','S','Utica','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(183,'00623','S','Parc Las 35','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(31046,'33823','S','Auburndale','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.072406,-81.804460,0,'2013-07-06 12:44:32',NULL,NULL),(62611,'74534','S','Centrahoma','D','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.596642,-96.323303,0,'2013-07-06 12:44:33',NULL,NULL),(53169,'61570','S','Washburn','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.919991,-89.292237,0,'2013-07-06 12:44:33',NULL,NULL),(58545,'68815','S','Arcadia','D','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.524360,-99.039205,0,'2013-07-06 12:44:33',NULL,NULL),(64922,'77207','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.687816,-95.301088,0,'2013-07-06 12:44:34',NULL,NULL),(24544,'27292','S','Holly Grove','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(5873,'05148','S','Londonderry','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.224333,-72.797903,0,'2013-07-06 12:44:30',NULL,NULL),(24935,'27817','S','Chocowinity','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.516589,-77.104743,0,'2013-07-06 12:44:31',NULL,NULL),(47651,'54931','P','Dale','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.274314,-88.677170,0,'2013-07-06 12:44:33',NULL,NULL),(2176,'00926','S','Ext Alameda','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(73951,'92059','S','Pala','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.385181,-117.069106,0,'2013-07-06 12:44:34',NULL,NULL),(62129,'73664','S','Sentinel','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.156247,-99.175583,0,'2013-07-06 12:44:33',NULL,NULL),(60561,'71749','S','Junction City','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.016895,-92.725033,0,'2013-07-06 12:44:33',NULL,NULL),(12890,'13332','S','Earlville','D','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(56578,'65535','S','Leasburg','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.062860,-91.197995,0,'2013-07-06 12:44:33',NULL,NULL),(72525,'89161','S','Mountain Springs','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.122600,-115.092200,0,'2013-07-06 12:44:34',NULL,NULL),(70491,'84771','P','St George','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.133484,-113.490057,0,'2013-07-06 12:44:34',NULL,NULL),(68204,'81041','S','Granada','D','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.913104,-102.348905,0,'2013-07-06 12:44:34',NULL,NULL),(60600,'71842','S','Horatio','D','Sevier','05133','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.904506,-94.265675,0,'2013-07-06 12:44:33',NULL,NULL),(1176,'00727','S','Urb Terralinda','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(7836,'07461','S','High Point','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(31089,'33870','S','Sebring','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.486041,-81.416909,0,'2013-07-06 12:44:32',NULL,NULL),(17626,'18052','S','Hokendauqua','A','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.658588,-75.491844,0,'2013-07-06 12:44:31',NULL,NULL),(76603,'95690','S','Howard Landing','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(70540,'85024','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.687628,-112.050217,0,'2013-07-06 12:44:34',NULL,NULL),(68239,'81054','S','Ninaview','A','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(36059,'40207','S','Mockngbrd Vly','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(22689,'24318','S','Ceres','D','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.010137,-81.362054,0,'2013-07-06 12:44:31',NULL,NULL),(22638,'24250','S','Ft Blackmore','A','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.754746,-82.625126,0,'2013-07-06 12:44:31',NULL,NULL),(70582,'85074','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.452352,-112.091819,0,'2013-07-06 12:44:34',NULL,NULL),(13399,'13750','S','Sturges Corner','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.469080,-74.807400,0,'2013-07-06 12:44:31',NULL,NULL),(23959,'26288','S','Webster Spgs','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.497260,-80.369280,0,'2013-07-06 12:44:31',NULL,NULL),(24754,'27536','S','Henderson','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.328690,-78.404636,0,'2013-07-06 12:44:31',NULL,NULL),(79939,'99622','P','Kwigillingok','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.867814,-163.000591,0,'2013-07-06 12:44:34',NULL,NULL),(58730,'68944','S','Harvard','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.622196,-98.097457,0,'2013-07-06 12:44:33',NULL,NULL),(8349,'08043','S','Voorhees Township','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(16931,'17607','P','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.030565,-76.347703,0,'2013-07-06 12:44:31',NULL,NULL),(1466,'00745','S','Urb Coco Beach','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(56167,'64867','S','Stella','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.747612,-94.218145,0,'2013-07-06 12:44:33',NULL,NULL),(50425,'57790','S','Creighton','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.255280,-102.207790,0,'2013-07-06 12:44:33',NULL,NULL),(16158,'17062','S','Knousetown','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(77376,'96753','S','Wailea','A','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.733086,-156.449710,0,'2013-07-06 12:44:34',NULL,NULL),(76967,'96050','S','Horse Creek','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.829600,-122.803140,0,'2013-07-06 12:44:34',NULL,NULL),(74215,'92309','S','Kelso','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.273234,-116.067330,0,'2013-07-06 12:44:34',NULL,NULL),(60753,'71998','U','Ouachita Baptist University','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.129042,-93.051992,0,'2013-07-06 12:44:33',NULL,NULL),(53965,'62428','S','Maple Point','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(26742,'29420','S','North Charleston','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.923689,-80.099458,0,'2013-07-06 12:44:31',NULL,NULL),(42484,'47838','S','Bucktown','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.117887,-87.465105,0,'2013-07-06 12:44:32',NULL,NULL),(45141,'50579','S','Piper','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(69936,'84115','S','S Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(63499,'75706','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.464510,-95.278390,0,'2013-07-06 12:44:33',NULL,NULL),(54735,'62966','S','Somerset','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(59319,'70524','P','Chataignier','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.570463,-92.321665,0,'2013-07-06 12:44:33',NULL,NULL),(60320,'71457','S','Northwestern','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(75806,'94803','S','Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972375,-122.289337,0,'2013-07-06 12:44:34',NULL,NULL),(25547,'28407','P','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.156508,-77.894445,0,'2013-07-06 12:44:31',NULL,NULL),(33845,'37939','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.915861,-84.004282,0,'2013-07-06 12:44:32',NULL,NULL),(49939,'57332','S','Emery','D','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.605292,-97.622528,0,'2013-07-06 12:44:33',NULL,NULL),(48821,'56034','S','Garden City','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.047389,-94.164236,0,'2013-07-06 12:44:33',NULL,NULL),(10260,'10502','S','Ardsley','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.015609,-73.844361,0,'2013-07-06 12:44:30',NULL,NULL),(50534,'58108','P','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.851768,-96.800808,0,'2013-07-06 12:44:33',NULL,NULL),(80129,'99771','P','Shaktoolik','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.517738,-160.478717,0,'2013-07-06 12:44:34',NULL,NULL),(62404,'74116','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.172746,-95.841579,0,'2013-07-06 12:44:33',NULL,NULL),(58773,'68970','S','Red Cloud','D','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.107696,-98.518914,0,'2013-07-06 12:44:33',NULL,NULL),(70747,'85320','P','Aguila','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.927739,-113.176579,0,'2013-07-06 12:44:34',NULL,NULL),(79806,'99371','S','Washtucna','D','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.753362,-118.315190,0,'2013-07-06 12:44:34',NULL,NULL),(17977,'18615','S','Falls','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.447237,-75.852850,0,'2013-07-06 12:44:31',NULL,NULL),(52766,'61256','S','Hampton','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.553120,-90.405920,0,'2013-07-06 12:44:33',NULL,NULL),(13157,'13606','S','Adams Center','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.858497,-76.009224,0,'2013-07-06 12:44:30',NULL,NULL),(47355,'54613','S','Monroe Center','N','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.064139,-89.898982,0,'2013-07-06 12:44:32',NULL,NULL),(32474,'36040','S','Gordonville','A','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.205480,-86.660220,0,'2013-07-06 12:44:32',NULL,NULL),(6450,'05758','S','Lake Hinevah','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.450800,-72.791580,0,'2013-07-06 12:44:30',NULL,NULL),(2811,'00976','S','Urb Wonderville','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(70083,'84157','P','Murray','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.660687,-111.884858,0,'2013-07-06 12:44:34',NULL,NULL),(69525,'83728','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.618134,-116.202744,0,'2013-07-06 12:44:34',NULL,NULL),(63209,'75444','P','Golden','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.777209,-95.588657,0,'2013-07-06 12:44:33',NULL,NULL),(5921,'05251','S','So Dorset','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.222500,-73.073889,0,'2013-07-06 12:44:30',NULL,NULL),(3009,'01079','P','Thorndike','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.188900,-72.329835,0,'2013-07-06 12:44:30',NULL,NULL),(2731,'00969','S','Urb El Palmar de Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(18189,'18933','S','Lumberville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.399813,-75.042800,0,'2013-07-06 12:44:31',NULL,NULL),(2066,'00920','S','Urb Summit Hls','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(17936,'18502','P','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.410462,-75.669455,0,'2013-07-06 12:44:31',NULL,NULL),(51001,'58655','S','South Heart','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.722356,-103.059738,0,'2013-07-06 12:44:33',NULL,NULL),(29484,'32732','S','Geneva','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.745894,-81.119322,0,'2013-07-06 12:44:32',NULL,NULL),(36956,'41171','S','Little Sandy','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(43986,'49333','S','Middlevle','N','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.684480,-85.452060,0,'2013-07-06 12:44:32',NULL,NULL),(9911,'10138','U','Midtown','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756075,-73.989193,0,'2013-07-06 12:44:30',NULL,NULL),(21301,'22403','P','Fredericksbrg','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.350856,-77.477360,0,'2013-07-06 12:44:31',NULL,NULL),(4745,'03839','S','Rochester','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.265580,-71.010420,0,'2013-07-06 12:44:30',NULL,NULL),(65652,'77975','S','Old Moulton','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.568900,-97.085580,0,'2013-07-06 12:44:34',NULL,NULL),(47767,'55037','S','Hinckley','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.012922,-92.942087,0,'2013-07-06 12:44:33',NULL,NULL),(28337,'31169','U','Peachtree City Parcel Return','N','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396731,-84.595632,0,'2013-07-06 12:44:32',NULL,NULL),(23479,'25506','S','Branchland','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.232678,-82.211046,0,'2013-07-06 12:44:31',NULL,NULL),(51034,'58721','S','Coteau','A','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.812366,-102.205909,0,'2013-07-06 12:44:33',NULL,NULL),(73706,'91609','P','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.188269,-118.386781,0,'2013-07-06 12:44:34',NULL,NULL),(62570,'74456','P','Preston','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.710379,-95.990731,0,'2013-07-06 12:44:33',NULL,NULL),(16186,'17068','S','Mecks Corner','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.418905,-77.189502,0,'2013-07-06 12:44:31',NULL,NULL),(14213,'14784','S','Stockton','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.325907,-79.365843,0,'2013-07-06 12:44:31',NULL,NULL),(22119,'23434','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.731942,-76.601870,0,'2013-07-06 12:44:31',NULL,NULL),(35004,'39121','P','Natchez','D','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.508317,-91.361730,0,'2013-07-06 12:44:32',NULL,NULL),(50761,'58418','S','Bowdon','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.394246,-99.712026,0,'2013-07-06 12:44:33',NULL,NULL),(256,'00638','S','Urb Los Llanos','N','Ciales','72039','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.338774,-66.466418,0,'2013-07-06 12:44:30',NULL,NULL),(11724,'12180','S','Center Brunswick','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(77491,'96825','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.296254,-157.696767,0,'2013-07-06 12:44:34',NULL,NULL),(74090,'92195','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.744302,-117.050496,0,'2013-07-06 12:44:34',NULL,NULL),(64255,'76373','S','Oklaunion','D','Wilbarger','48487','Texas','TX','48','0000','940','Central',-6.0,'Y',34.083436,-99.159824,0,'2013-07-06 12:44:34',NULL,NULL),(43065,'48192','S','Riverview','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.197463,-83.185203,0,'2013-07-06 12:44:32',NULL,NULL),(18809,'19403','S','Jeffersonville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(36282,'40350','S','Moorefield','D','Nicholas','21181','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.302911,-83.869535,0,'2013-07-06 12:44:32',NULL,NULL),(58412,'68642','S','Humphrey','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.688712,-97.489112,0,'2013-07-06 12:44:33',NULL,NULL),(64997,'77290','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.984528,-95.466634,0,'2013-07-06 12:44:34',NULL,NULL),(68173,'81010','U','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.275773,-104.607888,0,'2013-07-06 12:44:34',NULL,NULL),(18390,'19049','U','Ft Washington','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.175266,-74.919785,0,'2013-07-06 12:44:31',NULL,NULL),(27170,'29841','S','Beech Island','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.512008,-81.932644,0,'2013-07-06 12:44:31',NULL,NULL),(50168,'57552','S','Ottumwa','A','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(56741,'65714','S','Nixa','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.047697,-93.294106,0,'2013-07-06 12:44:33',NULL,NULL),(79193,'98532','S','Ceres','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(72720,'89496','U','Fallon','D','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.477965,-118.780330,0,'2013-07-06 12:44:34',NULL,NULL),(31810,'35054','S','Cropwell','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.506959,-86.294543,0,'2013-07-06 12:44:32',NULL,NULL),(33923,'38054','P','Naval Hospital','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.339231,-89.877562,0,'2013-07-06 12:44:32',NULL,NULL),(9617,'10033','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(42431,'47802','S','Youngstown Meadows','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(52031,'60181','S','Villa Park','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.882953,-87.975404,0,'2013-07-06 12:44:33',NULL,NULL),(47706,'54985','P','Winnebago','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.077792,-88.524229,0,'2013-07-06 12:44:33',NULL,NULL),(41300,'46765','S','Leo-Cedarvle','A','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(26138,'28734','S','Watauga','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(44876,'50313','S','Highland Park','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.641599,-93.617602,0,'2013-07-06 12:44:32',NULL,NULL),(50843,'58482','S','Steele','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.858883,-99.914607,0,'2013-07-06 12:44:33',NULL,NULL),(71679,'87510','S','Barranca','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.154780,-106.234086,0,'2013-07-06 12:44:34',NULL,NULL),(68054,'80932','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848511,-104.780034,0,'2013-07-06 12:44:34',NULL,NULL),(66772,'79029','S','Dumas','D','Moore','48341','Texas','TX','48','0000','806','Central',-6.0,'Y',35.862274,-101.966232,0,'2013-07-06 12:44:34',NULL,NULL),(73887,'91951','P','National City','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.679002,-117.100208,0,'2013-07-06 12:44:34',NULL,NULL),(43835,'49092','S','Tekonsha','D','Calhoun','26025','Michigan','MI','26','3720','517','Eastern',-5.0,'Y',42.102483,-84.980824,0,'2013-07-06 12:44:32',NULL,NULL),(17627,'18052','S','Whitehall','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.658588,-75.491844,0,'2013-07-06 12:44:31',NULL,NULL),(62502,'74365','S','Salina','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.295542,-95.152230,0,'2013-07-06 12:44:33',NULL,NULL),(47692,'54969','P','Readfield','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.273530,-88.767867,0,'2013-07-06 12:44:33',NULL,NULL),(52622,'61038','S','Garden Pr','A','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.249088,-88.739224,0,'2013-07-06 12:44:33',NULL,NULL),(55504,'63775','S','Perryville','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(32116,'35405','S','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.157819,-87.517160,0,'2013-07-06 12:44:32',NULL,NULL),(42558,'47874','S','Atherton','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(36559,'40915','S','Bimble','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.890188,-83.823329,0,'2013-07-06 12:44:32',NULL,NULL),(14079,'14611','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.148324,-77.643809,0,'2013-07-06 12:44:31',NULL,NULL),(24359,'27047','S','Siloam','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.299108,-80.577410,0,'2013-07-06 12:44:31',NULL,NULL),(49344,'56568','S','Nielsville','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.543914,-96.717293,0,'2013-07-06 12:44:33',NULL,NULL),(79133,'98499','S','Lakewood','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(71478,'87064','S','Rito de las Sillas','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188010,-106.557600,0,'2013-07-06 12:44:34',NULL,NULL),(71203,'86302','P','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.584333,-112.427352,0,'2013-07-06 12:44:34',NULL,NULL),(34787,'38868','S','Pine Grove','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.120111,-88.714124,0,'2013-07-06 12:44:32',NULL,NULL),(66807,'79077','P','Sam Norwood','D','Collingsworth','48087','Texas','TX','48','0000','806','Central',-6.0,'Y',34.841460,-100.203785,0,'2013-07-06 12:44:34',NULL,NULL),(67586,'80401','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.712606,-105.229868,0,'2013-07-06 12:44:34',NULL,NULL),(27612,'30305','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.831382,-84.385066,0,'2013-07-06 12:44:31',NULL,NULL),(65503,'77663','P','Village Mills','D','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.500000,-94.400000,0,'2013-07-06 12:44:34',NULL,NULL),(42080,'47454','S','Wildwood Lake','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(3130,'01245','S','West Otis','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.208800,-73.197240,0,'2013-07-06 12:44:30',NULL,NULL),(51339,'59312','S','Angela','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.672840,-106.397622,0,'2013-07-06 12:44:33',NULL,NULL),(72336,'89013','S','Goldfield','D','Esmeralda','32009','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.766010,-117.423544,0,'2013-07-06 12:44:34',NULL,NULL),(63251,'75483','P','Sulphur Springs','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.142219,-95.597859,0,'2013-07-06 12:44:33',NULL,NULL),(59036,'70083','S','West Pointe A la Hache','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(16522,'17268','S','Fiveforks','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(74218,'92311','S','Barstow','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.887322,-117.037597,0,'2013-07-06 12:44:34',NULL,NULL),(9637,'10035','S','Wards Island','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(5728,'05032','S','Bethel','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.810080,-72.656700,0,'2013-07-06 12:44:30',NULL,NULL),(51118,'58788','S','Denbigh','A','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.353802,-100.405480,0,'2013-07-06 12:44:33',NULL,NULL),(4287,'02896','S','N Smithfield','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.965954,-71.552269,0,'2013-07-06 12:44:30',NULL,NULL),(36397,'40506','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.030576,-84.508062,0,'2013-07-06 12:44:32',NULL,NULL),(50725,'58380','S','Hamar','A','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.790000,-98.506800,0,'2013-07-06 12:44:33',NULL,NULL),(72295,'88576','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.764372,-106.329694,0,'2013-07-06 12:44:34',NULL,NULL),(42026,'47438','S','Bogle Corner','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(23450,'25420','S','Gerrardstown','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.378140,-78.135408,0,'2013-07-06 12:44:31',NULL,NULL),(33893,'38037','S','Gates','D','Lauderdale','47097','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.830317,-89.405482,0,'2013-07-06 12:44:32',NULL,NULL),(8234,'08001','P','Alloway','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.562902,-75.349456,0,'2013-07-06 12:44:30',NULL,NULL),(8827,'08620','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.178809,-74.659973,0,'2013-07-06 12:44:30',NULL,NULL),(55256,'63456','S','Hassard','N','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.653180,-91.730329,0,'2013-07-06 12:44:33',NULL,NULL),(71095,'85936','S','Salado','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.506335,-109.378069,0,'2013-07-06 12:44:34',NULL,NULL),(43713,'48911','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.677285,-84.567592,0,'2013-07-06 12:44:32',NULL,NULL),(69564,'83816','P','Coeur D Alene','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.667270,-116.779061,0,'2013-07-06 12:44:34',NULL,NULL),(58668,'68883','S','Martin','N','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.819408,-98.597850,0,'2013-07-06 12:44:33',NULL,NULL),(11001,'11552','S','West Hempstead','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685278,-73.653056,0,'2013-07-06 12:44:30',NULL,NULL),(69480,'83672','S','Crystal','N','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.279700,-116.985420,0,'2013-07-06 12:44:34',NULL,NULL),(18961,'19512','S','Hill Church','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(65983,'78332','S','Palito Blanco','N','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742680,-98.085900,0,'2013-07-06 12:44:34',NULL,NULL),(63936,'76067','S','Mineral Wells','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.826780,-98.097180,0,'2013-07-06 12:44:34',NULL,NULL),(19803,'20440','U','International Joint Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914558,-77.044465,0,'2013-07-06 12:44:31',NULL,NULL),(23202,'25063','S','Harrison','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.567158,-80.975873,0,'2013-07-06 12:44:31',NULL,NULL),(35898,'40011','S','Campbellsburg','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.484347,-85.116998,0,'2013-07-06 12:44:32',NULL,NULL),(18342,'19031','S','Flourtown','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.105338,-75.212140,0,'2013-07-06 12:44:31',NULL,NULL),(51510,'59645','S','Wht Sphr Spgs','A','Meagher','30059','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.539963,-110.910288,0,'2013-07-06 12:44:33',NULL,NULL),(24011,'26354','S','Harmony Grove','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.343632,-80.022519,0,'2013-07-06 12:44:31',NULL,NULL),(30016,'33132','S','Seybold','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784288,-80.193450,0,'2013-07-06 12:44:32',NULL,NULL),(36548,'40906','S','Gausdale','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(77065,'96121','S','Milford','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.192871,-120.409309,0,'2013-07-06 12:44:34',NULL,NULL),(54383,'62815','S','Bone Gap','D','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.449282,-87.999631,0,'2013-07-06 12:44:33',NULL,NULL),(34668,'38803','P','Tupelo','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.271341,-88.703114,0,'2013-07-06 12:44:32',NULL,NULL),(64272,'76426','S','Lake Bridgeport','N','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.151387,-97.821373,0,'2013-07-06 12:44:34',NULL,NULL),(64488,'76622','S','Aquilla','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.868513,-97.206051,0,'2013-07-06 12:44:34',NULL,NULL),(34829,'38917','S','Jefferson','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.632500,-89.895000,0,'2013-07-06 12:44:32',NULL,NULL),(33477,'37337','S','Grandview','D','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.767208,-84.854798,0,'2013-07-06 12:44:32',NULL,NULL),(14525,'15204','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.452082,-80.056352,0,'2013-07-06 12:44:31',NULL,NULL),(59631,'71037','S','Red Chute','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(25836,'28618','S','Triplett','A','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.192222,-81.529594,0,'2013-07-06 12:44:31',NULL,NULL),(34899,'38954','S','Phillipstown','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.461906,-90.211639,0,'2013-07-06 12:44:32',NULL,NULL),(18142,'18833','S','New Albany','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.601394,-76.439697,0,'2013-07-06 12:44:31',NULL,NULL),(42616,'47903','P','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.417333,-86.855216,0,'2013-07-06 12:44:32',NULL,NULL),(28571,'31605','S','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.934844,-83.221011,0,'2013-07-06 12:44:32',NULL,NULL),(64492,'76624','S','Elk','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.673100,-96.981780,0,'2013-07-06 12:44:34',NULL,NULL),(60706,'71949','S','Beaudry','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.710102,-93.220625,0,'2013-07-06 12:44:33',NULL,NULL),(50010,'57382','S','Wessingtn Spg','A','Jerauld','46073','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.084850,-98.568185,0,'2013-07-06 12:44:33',NULL,NULL),(20890,'21703','S','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.366631,-77.464397,0,'2013-07-06 12:44:31',NULL,NULL),(3440,'01756','S','Mendon','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.097875,-71.549061,0,'2013-07-06 12:44:30',NULL,NULL),(10354,'10576','S','Scotts Corners','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.224542,-73.571480,0,'2013-07-06 12:44:30',NULL,NULL),(30550,'33411','S','Royal Plm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(51639,'59865','S','Saint Ignatius','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.357879,-114.052628,0,'2013-07-06 12:44:33',NULL,NULL),(59255,'70444','S','Springcreek','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.936684,-90.517939,0,'2013-07-06 12:44:33',NULL,NULL),(31639,'34715','S','South Clermont','N','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.592359,-81.799392,0,'2013-07-06 12:44:32',NULL,NULL),(76908,'95988','S','Fruto','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.524044,-122.199369,0,'2013-07-06 12:44:34',NULL,NULL),(74126,'92240','S','Desert Hot Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.963925,-116.531153,0,'2013-07-06 12:44:34',NULL,NULL),(51155,'58852','S','Temple','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.387360,-102.971460,0,'2013-07-06 12:44:33',NULL,NULL),(39854,'45171','S','Lake Waynoka','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.969796,-83.793965,0,'2013-07-06 12:44:32',NULL,NULL),(76828,'95959','S','North Bloomfield','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.273440,-121.022061,0,'2013-07-06 12:44:34',NULL,NULL),(22508,'24079','S','Kings Store','N','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.078372,-80.150507,0,'2013-07-06 12:44:31',NULL,NULL),(11978,'12468','S','Red Falls','N','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.259620,-74.360700,0,'2013-07-06 12:44:30',NULL,NULL),(47639,'54921','S','Bancroft','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.304038,-89.543303,0,'2013-07-06 12:44:33',NULL,NULL),(57867,'67578','S','Stafford','D','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.963128,-98.598634,0,'2013-07-06 12:44:33',NULL,NULL),(63103,'75275','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.843618,-96.783951,0,'2013-07-06 12:44:33',NULL,NULL),(73295,'90802','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.770005,-118.190518,0,'2013-07-06 12:44:34',NULL,NULL),(37753,'42324','S','Belton','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.145871,-86.966575,0,'2013-07-06 12:44:32',NULL,NULL),(40130,'45334','S','Jackson Center','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.446262,-84.043697,0,'2013-07-06 12:44:32',NULL,NULL),(42749,'48025','S','Franklin','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.523195,-83.265758,0,'2013-07-06 12:44:32',NULL,NULL),(45104,'50545','S','Hardy','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.807516,-94.053923,0,'2013-07-06 12:44:32',NULL,NULL),(8024,'07727','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.199657,-74.163542,0,'2013-07-06 12:44:30',NULL,NULL),(3745,'02170','S','Quincy','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.268871,-71.020060,0,'2013-07-06 12:44:30',NULL,NULL),(38068,'43064','S','Plain City','D','Madison','39097','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098540,-83.298000,0,'2013-07-06 12:44:32',NULL,NULL),(49904,'57279','S','Madsen Beach','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.414998,-96.867332,0,'2013-07-06 12:44:33',NULL,NULL),(8488,'08094','S','Collings Lakes','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.642840,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(20792,'21545','S','Mount Savage','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.697088,-78.879519,0,'2013-07-06 12:44:31',NULL,NULL),(8815,'08618','S','Ewing Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.221900,-74.733600,0,'2013-07-06 12:44:30',NULL,NULL),(68776,'82325','S','Encampment','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.217500,-106.778333,0,'2013-07-06 12:44:34',NULL,NULL),(55245,'63447','S','Deer Ridge','N','Lewis','29111','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.105774,-91.914071,0,'2013-07-06 12:44:33',NULL,NULL),(61392,'72537','S','Gamaliel','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.368676,-92.459573,0,'2013-07-06 12:44:33',NULL,NULL),(33159,'37015','S','Ashland City','D','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.284785,-87.071634,0,'2013-07-06 12:44:32',NULL,NULL),(24030,'26384','S','Linn','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.960924,-80.717488,0,'2013-07-06 12:44:31',NULL,NULL),(32569,'36116','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.311900,-86.237923,0,'2013-07-06 12:44:32',NULL,NULL),(19587,'20220','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899749,-77.031261,0,'2013-07-06 12:44:31',NULL,NULL),(2840,'00983','S','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(36888,'41101','S','Princess','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(44169,'49546','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(10702,'11228','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.620567,-74.015141,0,'2013-07-06 12:44:30',NULL,NULL),(253,'00638','S','Ciales','D','Ciales','72039','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.338774,-66.466418,0,'2013-07-06 12:44:30',NULL,NULL),(76799,'95945','S','Sunset View','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(72872,'90008','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006715,-118.339229,0,'2013-07-06 12:44:34',NULL,NULL),(22361,'23901','S','Farmville','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.292839,-78.396546,0,'2013-07-06 12:44:31',NULL,NULL),(51755,'60021','S','Fox River Grv','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.192301,-88.222307,0,'2013-07-06 12:44:33',NULL,NULL),(10426,'10801','S','New Rochelle','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.916607,-73.785532,0,'2013-07-06 12:44:30',NULL,NULL),(46533,'53401','P','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.691955,-87.814781,0,'2013-07-06 12:44:32',NULL,NULL),(21704,'22971','S','Shipman','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.758900,-78.819120,0,'2013-07-06 12:44:31',NULL,NULL),(949,'00716','S','Jard Alhambra','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(41118,'46581','P','Warsaw','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.237114,-85.858230,0,'2013-07-06 12:44:32',NULL,NULL),(75251,'93660','S','San Joaquin','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.612847,-120.177122,0,'2013-07-06 12:44:34',NULL,NULL),(61794,'73085','P','Yukon','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.488148,-97.736367,0,'2013-07-06 12:44:33',NULL,NULL),(61534,'72677','P','Summit','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.217652,-92.740882,0,'2013-07-06 12:44:33',NULL,NULL),(54505,'62868','S','Noble','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.700634,-88.223601,0,'2013-07-06 12:44:33',NULL,NULL),(51574,'59761','S','Wisdom','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.700642,-113.604601,0,'2013-07-06 12:44:33',NULL,NULL),(78978,'98374','S','Puyallup','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.142030,-122.266790,0,'2013-07-06 12:44:34',NULL,NULL),(57205,'66432','S','Havensville','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.517992,-96.120433,0,'2013-07-06 12:44:33',NULL,NULL),(70467,'84758','P','Orderville','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.268426,-112.746951,0,'2013-07-06 12:44:34',NULL,NULL),(22279,'23709','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.812989,-76.309856,0,'2013-07-06 12:44:31',NULL,NULL),(6839,'06118','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.748563,-72.609938,0,'2013-07-06 12:44:30',NULL,NULL),(1195,'00728','S','Ext Villa Paraiso','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(20334,'20850','S','Potomac','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.085920,-77.174389,0,'2013-07-06 12:44:31',NULL,NULL),(56692,'65654','P','Freistatt','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.017336,-93.897462,0,'2013-07-06 12:44:33',NULL,NULL),(11692,'12156','S','Schodack Landing','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.479520,-73.725180,0,'2013-07-06 12:44:30',NULL,NULL),(10346,'10566','S','Peekskill','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.299680,-73.906090,0,'2013-07-06 12:44:30',NULL,NULL),(27959,'30549','S','Arcade','A','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.112889,-83.580000,0,'2013-07-06 12:44:31',NULL,NULL),(39198,'44333','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.156040,-81.637740,0,'2013-07-06 12:44:32',NULL,NULL),(32755,'36346','S','Chestnut Grove','N','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.596944,-85.913611,0,'2013-07-06 12:44:32',NULL,NULL),(17034,'17747','S','Greenburr','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(71830,'87579','S','Angostura','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(34561,'38730','S','Boyle','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.705356,-90.727661,0,'2013-07-06 12:44:32',NULL,NULL),(32140,'35458','S','Elrod','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.366419,-87.800829,0,'2013-07-06 12:44:32',NULL,NULL),(22668,'24282','S','Saint Charles','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.835399,-83.053923,0,'2013-07-06 12:44:31',NULL,NULL),(15680,'16828','S','Centre Hall','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.844957,-77.684908,0,'2013-07-06 12:44:31',NULL,NULL),(47497,'54758','S','Osseo','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.576212,-91.220707,0,'2013-07-06 12:44:32',NULL,NULL),(18580,'19130','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.968491,-75.173091,0,'2013-07-06 12:44:31',NULL,NULL),(11774,'12203','S','Westmere','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(38797,'44061','P','Mentor','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.688236,-81.332823,0,'2013-07-06 12:44:32',NULL,NULL),(10499,'10962','S','Orangeburg','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.047289,-73.963065,0,'2013-07-06 12:44:30',NULL,NULL),(58458,'68727','S','Coleridge','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.506829,-97.203319,0,'2013-07-06 12:44:33',NULL,NULL),(74495,'92624','S','Capo Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.459976,-117.663169,0,'2013-07-06 12:44:34',NULL,NULL),(14037,'14550','S','Silver Spgs','A','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.672990,-78.094390,0,'2013-07-06 12:44:31',NULL,NULL),(6918,'06154','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.773119,-72.707051,0,'2013-07-06 12:44:30',NULL,NULL),(36029,'40171','S','Union Star','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.975286,-86.463714,0,'2013-07-06 12:44:32',NULL,NULL),(27366,'30066','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.036122,-84.505267,0,'2013-07-06 12:44:31',NULL,NULL),(20691,'21241','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.303353,-76.733353,0,'2013-07-06 12:44:31',NULL,NULL),(23040,'24857','P','Lillydale','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.676111,-81.663333,0,'2013-07-06 12:44:31',NULL,NULL),(59495,'70769','S','Prairieville','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.311773,-90.937896,0,'2013-07-06 12:44:33',NULL,NULL),(61040,'72118','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(39418,'44671','P','Sandyville','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.639520,-81.370179,0,'2013-07-06 12:44:32',NULL,NULL),(57255,'66536','S','Saint Marys','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.194394,-96.064840,0,'2013-07-06 12:44:33',NULL,NULL),(25242,'28104','S','Wesley Chapel','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.116667,-80.723889,0,'2013-07-06 12:44:31',NULL,NULL),(35731,'39701','S','Golden Triangle Regional Air','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(19642,'20266','U','Philatelic Sales','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882442,-77.020708,0,'2013-07-06 12:44:31',NULL,NULL),(75751,'94611','S','Piedmont','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.835580,-122.223360,0,'2013-07-06 12:44:34',NULL,NULL),(75435,'94040','S','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.380469,-122.081870,0,'2013-07-06 12:44:34',NULL,NULL),(74777,'93111','S','Goleta','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.441286,-119.800388,0,'2013-07-06 12:44:34',NULL,NULL),(1334,'00736','S','Bo Carite','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(18164,'18902','S','Doylestown','D','Bucks','42017','Pennsylvania','PA','42','6160','215','Eastern',-5.0,'Y',40.332651,-75.116540,0,'2013-07-06 12:44:31',NULL,NULL),(66579,'78744','S','Pilot Knob','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.145680,-97.700220,0,'2013-07-06 12:44:34',NULL,NULL),(67514,'80241','S','Northglenn','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.928789,-104.945551,0,'2013-07-06 12:44:34',NULL,NULL),(30967,'33740','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770012,-82.766347,0,'2013-07-06 12:44:32',NULL,NULL),(54869,'63052','S','Antonia','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.390733,-90.422015,0,'2013-07-06 12:44:33',NULL,NULL),(62512,'74401','S','McLain','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(55636,'64013','P','Blue Springs','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.019361,-94.282467,0,'2013-07-06 12:44:33',NULL,NULL),(39360,'44632','S','Congress Lake','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.959926,-81.326086,0,'2013-07-06 12:44:32',NULL,NULL),(41699,'47226','P','Clifford','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.285117,-85.868116,0,'2013-07-06 12:44:32',NULL,NULL),(35174,'39271','U','VISA','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289835,-90.180840,0,'2013-07-06 12:44:32',NULL,NULL),(8552,'08204','S','North Cape May','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(47815,'55057','S','Northfield','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445033,-93.181524,0,'2013-07-06 12:44:33',NULL,NULL),(75938,'95026','P','Redwood Estates','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.155014,-121.982515,0,'2013-07-06 12:44:34',NULL,NULL),(63331,'75574','S','Simms','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.487706,-94.579844,0,'2013-07-06 12:44:33',NULL,NULL),(20628,'21216','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.308329,-76.677180,0,'2013-07-06 12:44:31',NULL,NULL),(21344,'22428','U','Bowling Green','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.047380,-77.348116,0,'2013-07-06 12:44:31',NULL,NULL),(23812,'26056','P','New Manchester','D','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.532923,-80.580463,0,'2013-07-06 12:44:31',NULL,NULL),(28994,'32217','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.237412,-81.617619,0,'2013-07-06 12:44:32',NULL,NULL),(7048,'06279','S','W Willington','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.895780,-72.264300,0,'2013-07-06 12:44:30',NULL,NULL),(16421,'17225','S','Welsh Run','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(27193,'29860','S','North Augusta','D','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.501601,-81.962785,0,'2013-07-06 12:44:31',NULL,NULL),(77579,'96915','S','Inarajan','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(59381,'70605','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.125640,-93.202680,0,'2013-07-06 12:44:33',NULL,NULL),(370,'00659','S','Valle Verde','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(75783,'94704','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.870599,-122.262077,0,'2013-07-06 12:44:34',NULL,NULL),(16517,'17267','S','Warfordsburg','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.776683,-78.204091,0,'2013-07-06 12:44:31',NULL,NULL),(73279,'90744','S','Wilmington','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.791522,-118.252215,0,'2013-07-06 12:44:34',NULL,NULL),(20105,'20708','S','Laurel','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.061389,-76.851111,0,'2013-07-06 12:44:31',NULL,NULL),(53162,'61565','S','Sparland','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.995506,-89.451602,0,'2013-07-06 12:44:33',NULL,NULL),(3556,'01940','S','South Lynnfield','N','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.536090,-71.026506,0,'2013-07-06 12:44:30',NULL,NULL),(46821,'54010','P','East Ellsworth','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.730383,-92.468244,0,'2013-07-06 12:44:32',NULL,NULL),(44699,'50134','S','Kelley','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.940362,-93.660609,0,'2013-07-06 12:44:32',NULL,NULL),(28883,'32123','P','Port Orange','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.149529,-81.031180,0,'2013-07-06 12:44:32',NULL,NULL),(34338,'38571','S','Crossville','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.957067,-84.971996,0,'2013-07-06 12:44:32',NULL,NULL),(68913,'82835','S','Clearmont','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.672925,-106.421526,0,'2013-07-06 12:44:34',NULL,NULL),(44651,'50102','P','Garden City','D','Hardin','19083','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.253563,-93.403906,0,'2013-07-06 12:44:32',NULL,NULL),(47461,'54732','S','Cornell','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.153053,-91.159144,0,'2013-07-06 12:44:32',NULL,NULL),(63168,'75397','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.767255,-96.829088,0,'2013-07-06 12:44:33',NULL,NULL),(71146,'86031','P','Bitahochee','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.404662,-110.085614,0,'2013-07-06 12:44:34',NULL,NULL),(6144,'05464','S','Smuglrs Ntch','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663827,-72.783702,0,'2013-07-06 12:44:30',NULL,NULL),(7873,'07508','S','Paterson','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.951433,-74.185795,0,'2013-07-06 12:44:30',NULL,NULL),(46519,'53274','U','WI Child Support','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.040271,-87.907473,0,'2013-07-06 12:44:32',NULL,NULL),(38210,'43214','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.053773,-83.025973,0,'2013-07-06 12:44:32',NULL,NULL),(8443,'08085','S','Logan Township','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(2302,'00927','S','Urb Belisa','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(22010,'23285','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.538327,-77.435822,0,'2013-07-06 12:44:31',NULL,NULL),(14253,'14830','S','Corning','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.143170,-77.052149,0,'2013-07-06 12:44:31',NULL,NULL),(45749,'52136','S','Schley','N','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.376062,-92.114632,0,'2013-07-06 12:44:32',NULL,NULL),(50740,'58401','S','Fried','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(9355,'09811','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(67790,'80722','S','Atwood','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.529862,-103.266379,0,'2013-07-06 12:44:34',NULL,NULL),(77836,'97219','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.458253,-122.699292,0,'2013-07-06 12:44:34',NULL,NULL),(78210,'97753','S','Powell Butte','D','Crook','41013','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.229143,-121.000900,0,'2013-07-06 12:44:34',NULL,NULL),(53425,'61854','S','Mansfield','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.210375,-88.505603,0,'2013-07-06 12:44:33',NULL,NULL),(29564,'32814','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.555519,-81.347458,0,'2013-07-06 12:44:32',NULL,NULL),(49106,'56345','S','Elmdale','N','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.979362,-94.362403,0,'2013-07-06 12:44:33',NULL,NULL),(56217,'65036','P','Morrison','A','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.672778,-91.636111,0,'2013-07-06 12:44:33',NULL,NULL),(36000,'40144','S','Se Ree','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.750620,-86.371080,0,'2013-07-06 12:44:32',NULL,NULL),(3310,'01519','S','Hassanamisco Indian Reservat','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.201023,-71.687981,0,'2013-07-06 12:44:30',NULL,NULL),(30562,'33412','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(21298,'22402','P','Fredericksburg','D','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.256114,-77.566794,0,'2013-07-06 12:44:31',NULL,NULL),(75143,'93561','S','Bear Valley Springs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(48801,'56011','S','Belle Plaine','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.628797,-93.778892,0,'2013-07-06 12:44:33',NULL,NULL),(47866,'55082','S','Oak Park Heights','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(763,'00692','S','Urb Isomar','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(18157,'18848','S','Towanda','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.770672,-76.447490,0,'2013-07-06 12:44:31',NULL,NULL),(13993,'14512','S','Naples','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.657539,-77.413799,0,'2013-07-06 12:44:31',NULL,NULL),(13191,'13619','S','W Carthage','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(72060,'88116','S','Elida','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.897027,-103.617102,0,'2013-07-06 12:44:34',NULL,NULL),(71213,'86314','S','Prescott Vly','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.605746,-112.320979,0,'2013-07-06 12:44:34',NULL,NULL),(65249,'77461','S','Fairchilds','N','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.394555,-95.817313,0,'2013-07-06 12:44:34',NULL,NULL),(3229,'01370','S','Shelburne Fls','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.583380,-72.771540,0,'2013-07-06 12:44:30',NULL,NULL),(63746,'75937','S','Chireno','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.484579,-94.414781,0,'2013-07-06 12:44:34',NULL,NULL),(59318,'70523','P','Charenton','D','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.890745,-91.524411,0,'2013-07-06 12:44:33',NULL,NULL),(26372,'29078','S','Lugoff','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.220008,-80.713660,0,'2013-07-06 12:44:31',NULL,NULL),(49308,'56538','P','Fergus Falls','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.282796,-96.074809,0,'2013-07-06 12:44:33',NULL,NULL),(23857,'26143','S','Newark','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(79463,'98851','S','Soap Lake','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.395140,-119.452020,0,'2013-07-06 12:44:34',NULL,NULL),(50286,'57652','S','La Plant','A','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.085000,-100.800000,0,'2013-07-06 12:44:33',NULL,NULL),(419,'00662','S','Repto Vega Badillo','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(8787,'08558','S','Montgomery','N','Somerset','34035','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.416194,-74.695442,0,'2013-07-06 12:44:30',NULL,NULL),(72785,'89701','S','Clear Creek','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(2585,'00961','S','Ind Corujo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(6131,'05460','P','Highgate Springs','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.979819,-73.105448,0,'2013-07-06 12:44:30',NULL,NULL),(9822,'10113','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(73003,'90062','S','Westvern','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006750,-118.307195,0,'2013-07-06 12:44:34',NULL,NULL),(34799,'38875','P','Trebloc','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.910763,-88.930078,0,'2013-07-06 12:44:32',NULL,NULL),(69828,'84078','S','Vernal','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.474320,-109.570104,0,'2013-07-06 12:44:34',NULL,NULL),(78568,'98160','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.771124,-122.382371,0,'2013-07-06 12:44:34',NULL,NULL),(63804,'75962','U','S F Austin U','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(47836,'55072','S','Dell Grove','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.126511,-92.866999,0,'2013-07-06 12:44:33',NULL,NULL),(22478,'24055','S','Philpott','N','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.751969,-79.987513,0,'2013-07-06 12:44:31',NULL,NULL),(44942,'50367','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595632,-93.766327,0,'2013-07-06 12:44:32',NULL,NULL),(42176,'47529','S','Elnora','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.875867,-87.084533,0,'2013-07-06 12:44:32',NULL,NULL),(22644,'24260','S','Elk Garden','A','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.029515,-82.003511,0,'2013-07-06 12:44:31',NULL,NULL),(15233,'16034','S','Fenelton','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.861011,-79.715212,0,'2013-07-06 12:44:31',NULL,NULL),(14030,'14545','S','Scottsburg','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.663666,-77.713631,0,'2013-07-06 12:44:31',NULL,NULL),(3814,'02297','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358631,-71.056702,0,'2013-07-06 12:44:30',NULL,NULL),(56334,'65109','S','Brazito','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.555400,-92.280540,0,'2013-07-06 12:44:33',NULL,NULL),(6771,'06098','S','Winchester Center','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.921164,-73.067666,0,'2013-07-06 12:44:30',NULL,NULL),(52769,'61259','S','Illinois City','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.380938,-90.897230,0,'2013-07-06 12:44:33',NULL,NULL),(54501,'62865','S','Mulkeytown','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.989180,-89.109184,0,'2013-07-06 12:44:33',NULL,NULL),(53036,'61477','S','Blyton','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.495882,-90.287939,0,'2013-07-06 12:44:33',NULL,NULL),(50223,'57585','S','Bad Nation','N','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.563165,-100.408076,0,'2013-07-06 12:44:33',NULL,NULL),(8056,'07740','S','Elberon','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.295596,-73.994230,0,'2013-07-06 12:44:30',NULL,NULL),(4682,'03801','S','Portsmouth','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.067228,-70.784076,0,'2013-07-06 12:44:30',NULL,NULL),(38643,'43933','S','Stewartsville','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.945410,-80.902208,0,'2013-07-06 12:44:32',NULL,NULL),(35872,'39845','S','Dville','N','Seminole','13253','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.041858,-84.881232,0,'2013-07-06 12:44:32',NULL,NULL),(79354,'98639','P','N Bonneville','A','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.643202,-121.968412,0,'2013-07-06 12:44:34',NULL,NULL),(53951,'62422','S','Cowden','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.216769,-88.903850,0,'2013-07-06 12:44:33',NULL,NULL),(72341,'89015','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.060266,-114.956815,0,'2013-07-06 12:44:34',NULL,NULL),(71261,'86411','P','Kingman','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.369406,-113.727182,0,'2013-07-06 12:44:34',NULL,NULL),(69734,'84043','S','Saratoga','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(12003,'12491','S','West Hurley','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.006495,-74.105729,0,'2013-07-06 12:44:30',NULL,NULL),(35196,'39288','P','Jackson','A','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.300020,-90.145549,0,'2013-07-06 12:44:32',NULL,NULL),(44081,'49453','S','Saugatuck','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.663097,-86.185702,0,'2013-07-06 12:44:32',NULL,NULL),(41441,'46864','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.067693,-85.166366,0,'2013-07-06 12:44:32',NULL,NULL),(55836,'64155','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.274310,-94.569245,0,'2013-07-06 12:44:33',NULL,NULL),(62201,'73834','S','Selman','A','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.826980,-99.592380,0,'2013-07-06 12:44:33',NULL,NULL),(53808,'62293','S','Trenton','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.607272,-89.683388,0,'2013-07-06 12:44:33',NULL,NULL),(23273,'25148','S','Orgas','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.061808,-81.566835,0,'2013-07-06 12:44:31',NULL,NULL),(71764,'87552','S','Pecos','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(69305,'83454','P','Ucon','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.588504,-111.962864,0,'2013-07-06 12:44:34',NULL,NULL),(13564,'13839','S','Merrickville','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.220441,-75.323336,0,'2013-07-06 12:44:31',NULL,NULL),(1594,'00769','S','Mans De Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(30435,'33330','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(28461,'31415','S','Garden Cty','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.075555,-81.129128,0,'2013-07-06 12:44:32',NULL,NULL),(39625,'44889','S','Clarksfield','N','Huron','39077','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.224184,-82.403611,0,'2013-07-06 12:44:32',NULL,NULL),(40338,'45612','S','Bainbridge','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.240370,-83.270190,0,'2013-07-06 12:44:32',NULL,NULL),(55127,'63344','S','Eolia','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.252646,-91.006354,0,'2013-07-06 12:44:33',NULL,NULL),(7464,'06876','P','Redding Ridge','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.319639,-73.355876,0,'2013-07-06 12:44:30',NULL,NULL),(37117,'41397','S','Zoe','D','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.656853,-83.670861,0,'2013-07-06 12:44:32',NULL,NULL),(18826,'19415','U','Eagleville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.159802,-75.408718,0,'2013-07-06 12:44:31',NULL,NULL),(26831,'29487','S','Wadmalaw Island','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.653461,-80.187416,0,'2013-07-06 12:44:31',NULL,NULL),(49550,'56687','P','Wilton','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522450,-94.996355,0,'2013-07-06 12:44:33',NULL,NULL),(43155,'48260','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331990,-83.057185,0,'2013-07-06 12:44:32',NULL,NULL),(53054,'61486','S','Viola','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.204504,-90.587069,0,'2013-07-06 12:44:33',NULL,NULL),(9478,'10010','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(67548,'80263','U','Affiliated Banks Service Co','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.832482,-105.007481,0,'2013-07-06 12:44:34',NULL,NULL),(66962,'79401','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.584601,-101.846676,0,'2013-07-06 12:44:34',NULL,NULL),(21136,'22103','P','Mc Lean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.947768,-77.227954,0,'2013-07-06 12:44:31',NULL,NULL),(40349,'45624','P','Cynthiana','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.158935,-83.355739,0,'2013-07-06 12:44:32',NULL,NULL),(61261,'72365','S','Marked Tree','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.530804,-90.414142,0,'2013-07-06 12:44:33',NULL,NULL),(40140,'45342','S','Chautauqua','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.629485,-84.263441,0,'2013-07-06 12:44:32',NULL,NULL),(28869,'32117','S','Holly Hill','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.236440,-81.057780,0,'2013-07-06 12:44:32',NULL,NULL),(19644,'20268','U','Postal Regulatory Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901073,-77.028825,0,'2013-07-06 12:44:31',NULL,NULL),(45265,'50668','S','Knittel','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.703803,-92.225832,0,'2013-07-06 12:44:32',NULL,NULL),(43716,'48913','U','State of Michigan','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.677493,-84.665847,0,'2013-07-06 12:44:32',NULL,NULL),(27695,'30338','S','Sandy Springs','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(37246,'41555','S','Pinsonfork','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.556989,-82.192577,0,'2013-07-06 12:44:32',NULL,NULL),(49835,'57226','S','Clear Lake','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.758347,-96.683015,0,'2013-07-06 12:44:33',NULL,NULL),(3456,'01776','S','North Sudbury','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.382955,-71.427696,0,'2013-07-06 12:44:30',NULL,NULL),(37035,'41257','S','Stambaugh','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.841603,-82.762181,0,'2013-07-06 12:44:32',NULL,NULL),(56617,'65583','S','Waynesville','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.821060,-92.186820,0,'2013-07-06 12:44:33',NULL,NULL),(77503,'96836','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289782,-157.836148,0,'2013-07-06 12:44:34',NULL,NULL),(26336,'29058','S','Pleasant Hill','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.544700,-80.751780,0,'2013-07-06 12:44:31',NULL,NULL),(69920,'84110','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756105,-111.897245,0,'2013-07-06 12:44:34',NULL,NULL),(61662,'72913','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.384150,-94.376166,0,'2013-07-06 12:44:33',NULL,NULL),(38241,'43260','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.962870,-82.998416,0,'2013-07-06 12:44:32',NULL,NULL),(17945,'18509','S','Dunmore','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.423216,-75.640635,0,'2013-07-06 12:44:31',NULL,NULL),(54557,'62890','S','West End','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(77280,'96615','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(23334,'25245','S','Given','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.680155,-81.685128,0,'2013-07-06 12:44:31',NULL,NULL),(32657,'36256','S','New Site','A','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.042132,-85.738562,0,'2013-07-06 12:44:32',NULL,NULL),(42996,'48160','S','Augusta Twp','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(45132,'50573','P','Plover','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.866039,-94.620070,0,'2013-07-06 12:44:32',NULL,NULL),(52087,'60406','S','Dixmoor','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.654838,-87.678683,0,'2013-07-06 12:44:33',NULL,NULL),(48080,'55331','S','Orono','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(21750,'23045','S','Diggs','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.436110,-76.281226,0,'2013-07-06 12:44:31',NULL,NULL),(32631,'36191','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.326539,-86.276619,0,'2013-07-06 12:44:32',NULL,NULL),(33855,'37998','U','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.937584,-83.750480,0,'2013-07-06 12:44:32',NULL,NULL),(74821,'93222','P','Pine Mtn Clb','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.836120,-119.055120,0,'2013-07-06 12:44:34',NULL,NULL),(47196,'54487','S','Jersey City','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.474520,-89.727183,0,'2013-07-06 12:44:32',NULL,NULL),(26744,'29423','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.845603,-79.977751,0,'2013-07-06 12:44:31',NULL,NULL),(53033,'61475','S','Blandinsville','A','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.587814,-90.730089,0,'2013-07-06 12:44:33',NULL,NULL),(75488,'94124','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.735457,-122.391588,0,'2013-07-06 12:44:34',NULL,NULL),(198,'00623','S','Urb Las Vistas','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(72546,'89191','P','Isafa','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.244017,-115.040965,0,'2013-07-06 12:44:34',NULL,NULL),(66576,'78744','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.145680,-97.700220,0,'2013-07-06 12:44:34',NULL,NULL),(55982,'64625','S','Breckenridge','D','Caldwell','29025','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.745818,-93.816660,0,'2013-07-06 12:44:33',NULL,NULL),(67977,'80915','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.856009,-104.716668,0,'2013-07-06 12:44:34',NULL,NULL),(55604,'63945','S','Harviell','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.684454,-90.571343,0,'2013-07-06 12:44:33',NULL,NULL),(17556,'17981','S','Frailey','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(25823,'28615','S','Creston','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.447180,-81.659280,0,'2013-07-06 12:44:31',NULL,NULL),(34042,'38135','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229541,-89.853081,0,'2013-07-06 12:44:32',NULL,NULL),(35133,'39216','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.335115,-90.166439,0,'2013-07-06 12:44:32',NULL,NULL),(26849,'29516','S','Blenheim','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.452562,-79.653803,0,'2013-07-06 12:44:31',NULL,NULL),(48949,'56170','S','Ruthton','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.188020,-96.071700,0,'2013-07-06 12:44:33',NULL,NULL),(65483,'77642','S','Port Arthur','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.920768,-93.931982,0,'2013-07-06 12:44:34',NULL,NULL),(26094,'28713','S','Needmore','N','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.401379,-83.467681,0,'2013-07-06 12:44:31',NULL,NULL),(65046,'77333','P','Dobbin','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.367215,-95.772479,0,'2013-07-06 12:44:34',NULL,NULL),(64009,'76117','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(12306,'12854','S','N Granville','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.507018,-73.335407,0,'2013-07-06 12:44:30',NULL,NULL),(45224,'50643','S','Zaneta','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.383057,-92.461301,0,'2013-07-06 12:44:32',NULL,NULL),(20785,'21540','S','Luke','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.479099,-79.055699,0,'2013-07-06 12:44:31',NULL,NULL),(17463,'17948','S','Hills Terrace','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(9873,'10122','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(17370,'17878','S','Stillwater','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.153486,-76.375467,0,'2013-07-06 12:44:31',NULL,NULL),(6691,'06051','S','New Britain','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.662408,-72.770431,0,'2013-07-06 12:44:30',NULL,NULL),(69550,'83810','S','Cataldo','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.531940,-116.457240,0,'2013-07-06 12:44:34',NULL,NULL),(62780,'74873','S','Brooksville','A','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.259960,-96.974340,0,'2013-07-06 12:44:33',NULL,NULL),(26534,'29203','S','Hollywood Hills','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(1036,'00720','S','Villas De Orocovix II','N','Orocovis','72107','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.229109,-66.391520,0,'2013-07-06 12:44:30',NULL,NULL),(4102,'02675','S','Yarmouthport','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.704063,-70.221541,0,'2013-07-06 12:44:30',NULL,NULL),(31666,'34755','P','Minneola','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.577556,-81.749268,0,'2013-07-06 12:44:32',NULL,NULL),(68972,'83101','S','Kemmerer','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.796146,-110.539940,0,'2013-07-06 12:44:34',NULL,NULL),(65123,'77379','S','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.027227,-95.529294,0,'2013-07-06 12:44:34',NULL,NULL),(57216,'66442','S','Ft Riley','A','Geary','20061','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.056640,-96.770220,0,'2013-07-06 12:44:33',NULL,NULL),(56577,'65534','S','Laquey','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.725890,-92.340893,0,'2013-07-06 12:44:33',NULL,NULL),(20023,'20625','P','Cobb Island','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.260467,-76.843591,0,'2013-07-06 12:44:31',NULL,NULL),(423,'00662','S','Sect Cachichuelas','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(45820,'52205','S','Fairview','N','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.113520,-91.295220,0,'2013-07-06 12:44:32',NULL,NULL),(37756,'42327','S','Calhoun','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.564331,-87.260812,0,'2013-07-06 12:44:32',NULL,NULL),(11290,'11776','S','Pjs','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(5539,'04785','S','Van Buren','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.163199,-67.942329,0,'2013-07-06 12:44:30',NULL,NULL),(77720,'97062','S','Tualatin','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.370826,-122.769707,0,'2013-07-06 12:44:34',NULL,NULL),(28398,'31315','S','Fort Stewart','D','Liberty','13179','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.887737,-81.600923,0,'2013-07-06 12:44:32',NULL,NULL),(72610,'89414','S','Red House','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.007834,-117.299047,0,'2013-07-06 12:44:34',NULL,NULL),(64872,'77064','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.917765,-95.555032,0,'2013-07-06 12:44:34',NULL,NULL),(49913,'57312','S','Alpena','D','Jerauld','46073','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.155775,-98.452371,0,'2013-07-06 12:44:33',NULL,NULL),(21388,'22503','S','Lancaster','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.763511,-76.498306,0,'2013-07-06 12:44:31',NULL,NULL),(44235,'49656','S','Luther','D','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.056564,-85.687546,0,'2013-07-06 12:44:32',NULL,NULL),(33988,'38115','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.045523,-89.849029,0,'2013-07-06 12:44:32',NULL,NULL),(64758,'76937','S','Eola','D','Concho','48095','Texas','TX','48','0000','325','Central',-6.0,'Y',31.450555,-100.058489,0,'2013-07-06 12:44:34',NULL,NULL),(70710,'85274','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.386818,-111.873960,0,'2013-07-06 12:44:34',NULL,NULL),(68271,'81073','S','Springfield','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.397087,-102.621835,0,'2013-07-06 12:44:34',NULL,NULL),(40480,'45773','S','Reno','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.396667,-81.375000,0,'2013-07-06 12:44:32',NULL,NULL),(49265,'56481','S','Verndale','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.399714,-95.014769,0,'2013-07-06 12:44:33',NULL,NULL),(8564,'08210','S','Swainton','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(32432,'35986','S','Shiloh','A','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.497002,-85.843760,0,'2013-07-06 12:44:32',NULL,NULL),(51576,'59771','P','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.680005,-111.146230,0,'2013-07-06 12:44:33',NULL,NULL),(13255,'13646','S','Hammond','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.450100,-75.686400,0,'2013-07-06 12:44:30',NULL,NULL),(76135,'95253','P','Victor','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.139786,-121.205269,0,'2013-07-06 12:44:34',NULL,NULL),(69078,'83246','S','Lava Hot Spgs','A','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.609094,-112.026692,0,'2013-07-06 12:44:34',NULL,NULL),(55237,'63440','S','Ewing','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.006771,-91.712936,0,'2013-07-06 12:44:33',NULL,NULL),(47947,'55118','S','Lilydale','N','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(22137,'23452','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.839129,-76.090953,0,'2013-07-06 12:44:31',NULL,NULL),(10417,'10707','S','Eastchester','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955489,-73.813597,0,'2013-07-06 12:44:30',NULL,NULL),(10228,'10461','S','Westchester','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.844984,-73.843255,0,'2013-07-06 12:44:30',NULL,NULL),(5566,'04860','S','Tenants Hbr','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.966485,-69.212306,0,'2013-07-06 12:44:30',NULL,NULL),(12510,'13027','S','Baldwinsville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(50868,'58506','P','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.727975,-100.618831,0,'2013-07-06 12:44:33',NULL,NULL),(36585,'40962','S','Chestnutburg','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(29011,'32225','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.348896,-81.501070,0,'2013-07-06 12:44:32',NULL,NULL),(72739,'89506','S','Silver Knolls','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(67849,'80819','P','Green Mtn Fls','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.932824,-105.016988,0,'2013-07-06 12:44:34',NULL,NULL),(66304,'78586','S','Rangerville','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(5955,'05262','S','South Shaftsbury','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.133333,-73.066667,0,'2013-07-06 12:44:30',NULL,NULL),(27988,'30577','S','Avalon','N','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.573035,-83.318464,0,'2013-07-06 12:44:31',NULL,NULL),(66083,'78393','S','Woodsboro','D','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.167500,-97.299722,0,'2013-07-06 12:44:34',NULL,NULL),(67728,'80545','S','Red Feather Lakes','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.804665,-105.593375,0,'2013-07-06 12:44:34',NULL,NULL),(19580,'20217','U','Us Tax Court','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894934,-77.011177,0,'2013-07-06 12:44:31',NULL,NULL),(50037,'57430','S','Spain','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.806700,-97.722180,0,'2013-07-06 12:44:33',NULL,NULL),(48318,'55445','S','Brooklyn Park','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.106330,-93.384070,0,'2013-07-06 12:44:33',NULL,NULL),(66565,'78738','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(65066,'77345','S','Humble','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.055815,-95.169196,0,'2013-07-06 12:44:34',NULL,NULL),(57815,'67518','S','Beeler','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.475558,-100.150130,0,'2013-07-06 12:44:33',NULL,NULL),(16112,'17055','S','Mechanicsburg','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(6227,'05491','S','Addison','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(53211,'61625','U','Bradley Univ','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.845091,-89.582017,0,'2013-07-06 12:44:33',NULL,NULL),(2942,'01029','P','E Otis','N','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.159812,-73.043385,0,'2013-07-06 12:44:30',NULL,NULL),(61530,'72670','S','Ponca','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.053135,-93.409673,0,'2013-07-06 12:44:33',NULL,NULL),(42032,'47438','S','Lonetree','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(79952,'99630','P','Mekoryuk','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.098493,-166.379379,0,'2013-07-06 12:44:34',NULL,NULL),(76507,'95640','S','Sunnybrook','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.329832,-120.932789,0,'2013-07-06 12:44:34',NULL,NULL),(837,'00698','S','Bda Galarza','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(19563,'20207','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901718,-76.983568,0,'2013-07-06 12:44:31',NULL,NULL),(40174,'45369','S','South Vienna','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.956268,-83.612904,0,'2013-07-06 12:44:32',NULL,NULL),(39271,'44455','S','Clarkson','N','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.779315,-80.606133,0,'2013-07-06 12:44:32',NULL,NULL),(59067,'70094','S','Waggaman','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(75568,'94268','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582457,-121.491815,0,'2013-07-06 12:44:34',NULL,NULL),(50171,'57553','S','Hartley','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.417024,-101.804790,0,'2013-07-06 12:44:33',NULL,NULL),(57082,'66216','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.008231,-94.740275,0,'2013-07-06 12:44:33',NULL,NULL),(40941,'46296','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.770156,-86.161029,0,'2013-07-06 12:44:32',NULL,NULL),(4184,'02816','S','Coventry','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.690858,-71.588592,0,'2013-07-06 12:44:30',NULL,NULL),(317,'00646','S','Urb the Estates','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(23629,'25725','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.398134,-82.446804,0,'2013-07-06 12:44:31',NULL,NULL),(15796,'16925','S','Gillett','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(42912,'48105','S','Dixboro','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.306761,-83.700406,0,'2013-07-06 12:44:32',NULL,NULL),(67424,'80155','P','Greenwood Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.591335,-104.876947,0,'2013-07-06 12:44:34',NULL,NULL),(63661,'75850','S','Leona','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.133565,-95.909582,0,'2013-07-06 12:44:34',NULL,NULL),(39330,'44614','S','New Franklin','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.880580,-81.589680,0,'2013-07-06 12:44:32',NULL,NULL),(10821,'11378','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.725746,-73.903899,0,'2013-07-06 12:44:30',NULL,NULL),(61270,'72376','S','Proctor','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.097258,-90.282934,0,'2013-07-06 12:44:33',NULL,NULL),(48906,'56131','S','Dundee','A','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.871151,-95.602641,0,'2013-07-06 12:44:33',NULL,NULL),(4077,'02659','S','South Chatham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.680494,-70.020630,0,'2013-07-06 12:44:30',NULL,NULL),(9972,'10161','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.747012,-74.005347,0,'2013-07-06 12:44:30',NULL,NULL),(9188,'09380','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(48488,'55732','S','Waasa','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.667582,-92.224878,0,'2013-07-06 12:44:33',NULL,NULL),(31508,'34453','S','Inverness','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.874263,-82.350653,0,'2013-07-06 12:44:32',NULL,NULL),(29799,'33023','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(3929,'02464','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.311972,-71.220047,0,'2013-07-06 12:44:30',NULL,NULL),(61057,'72121','S','Hickory Flat','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(22219,'23541','P','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.857875,-76.211427,0,'2013-07-06 12:44:31',NULL,NULL),(689,'00685','S','Colinas Verdes','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(29459,'32714','S','Altamonte Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.666520,-81.413231,0,'2013-07-06 12:44:32',NULL,NULL),(35747,'39730','S','Muldon','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(21425,'22551','S','Spotsylvania','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.203520,-77.598148,0,'2013-07-06 12:44:31',NULL,NULL),(80094,'99745','P','Hughes','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.974584,-154.194378,0,'2013-07-06 12:44:34',NULL,NULL),(49767,'57069','S','Meckling','A','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.781151,-96.924411,0,'2013-07-06 12:44:33',NULL,NULL),(67528,'80251','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.662790,-104.853146,0,'2013-07-06 12:44:34',NULL,NULL),(54432,'62838','S','Iola','A','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.831400,-88.770151,0,'2013-07-06 12:44:33',NULL,NULL),(6077,'05448','S','E Fairfield','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.800384,-72.917850,0,'2013-07-06 12:44:30',NULL,NULL),(7837,'07461','S','High Point Park','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(16452,'17238','S','Needmore','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.873300,-78.140520,0,'2013-07-06 12:44:31',NULL,NULL),(23917,'26218','S','French Creek','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.846220,-80.269980,0,'2013-07-06 12:44:31',NULL,NULL),(3531,'01903','P','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.466185,-70.949729,0,'2013-07-06 12:44:30',NULL,NULL),(20722,'21284','P','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.399688,-76.599200,0,'2013-07-06 12:44:31',NULL,NULL),(60301,'71454','S','New Salem','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(42004,'47427','S','Daggett','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.249277,-86.989828,0,'2013-07-06 12:44:32',NULL,NULL),(43987,'49333','S','Yankee Springs','N','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.684480,-85.452060,0,'2013-07-06 12:44:32',NULL,NULL),(42059,'47448','S','Coffey Subdivision','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(39030,'44145','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.450401,-81.925054,0,'2013-07-06 12:44:32',NULL,NULL),(75964,'95052','P','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.355841,-121.953674,0,'2013-07-06 12:44:34',NULL,NULL),(79252,'98563','S','Alder Grove','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(72423,'89061','S','Pahrump','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.122780,-115.928662,0,'2013-07-06 12:44:34',NULL,NULL),(35082,'39203','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.309387,-90.196952,0,'2013-07-06 12:44:32',NULL,NULL),(42257,'47579','S','Christmas Lk','A','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.104943,-86.928717,0,'2013-07-06 12:44:32',NULL,NULL),(6170,'05473','S','Mt Philo','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(11751,'12190','S','Gilmantown','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.475882,-74.270426,0,'2013-07-06 12:44:30',NULL,NULL),(24316,'27020','S','Brooks Cross Roads','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(56300,'65084','S','Versailles','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.432613,-92.844180,0,'2013-07-06 12:44:33',NULL,NULL),(859,'00698','S','Urb Costa Sur','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(74279,'92357','U','Loma Linda','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.054612,-117.252812,0,'2013-07-06 12:44:34',NULL,NULL),(68587,'81524','S','Loma','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.227527,-108.800442,0,'2013-07-06 12:44:34',NULL,NULL),(24693,'27425','P','A M F GReensboro','N','Guilford','37081','North Carolina','NC','37','3120','704/980','Eastern',-5.0,'Y',36.127293,-79.942762,0,'2013-07-06 12:44:31',NULL,NULL),(32096,'35294','U','Univ of Alabama Bir','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.510109,-86.807875,0,'2013-07-06 12:44:32',NULL,NULL),(2363,'00949','S','Mans del Lago','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(26351,'29069','S','Cypress Crossroads','N','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.181109,-80.057782,0,'2013-07-06 12:44:31',NULL,NULL),(39624,'44888','U','Willard','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.056760,-82.721898,0,'2013-07-06 12:44:32',NULL,NULL),(39368,'44638','S','Lakeville','D','Holmes','39075','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.623008,-82.136093,0,'2013-07-06 12:44:32',NULL,NULL),(64363,'76524','S','Cego','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.335720,-97.277820,0,'2013-07-06 12:44:34',NULL,NULL),(710,'00687','S','Ext Torrecillas','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(66432,'78643','S','Sunrise Beach','A','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.664320,-98.577660,0,'2013-07-06 12:44:34',NULL,NULL),(35223,'39304','P','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.364295,-88.686990,0,'2013-07-06 12:44:32',NULL,NULL),(11067,'11582','P','Valley Stream','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.664547,-73.704277,0,'2013-07-06 12:44:30',NULL,NULL),(43473,'48557','U','Gm Vehicle Development Ctr','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.987118,-83.679301,0,'2013-07-06 12:44:32',NULL,NULL),(2303,'00927','S','Urb Caribe','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(19660,'20307','U','Walter Reed Army Med Center','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.972480,-77.029182,0,'2013-07-06 12:44:31',NULL,NULL),(80010,'99675','P','Takotna','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.980000,-156.060000,0,'2013-07-06 12:44:34',NULL,NULL),(74972,'93437','S','Lompoc','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.738800,-120.525060,0,'2013-07-06 12:44:34',NULL,NULL),(68728,'82084','P','Tie Siding','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.053617,-105.441046,0,'2013-07-06 12:44:34',NULL,NULL),(74169,'92270','S','Rancho Mirage','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.766858,-116.424596,0,'2013-07-06 12:44:34',NULL,NULL),(54678,'62941','S','New Grand Chain','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.250785,-89.010847,0,'2013-07-06 12:44:33',NULL,NULL),(25749,'28575','P','Salter Path','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.685333,-76.902239,0,'2013-07-06 12:44:31',NULL,NULL),(42456,'47831','P','Blanford','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649794,-87.459919,0,'2013-07-06 12:44:32',NULL,NULL),(28893,'32127','S','Wilbur by the Sea','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.110341,-80.980002,0,'2013-07-06 12:44:32',NULL,NULL),(41435,'46858','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.067996,-85.166367,0,'2013-07-06 12:44:32',NULL,NULL),(13553,'13833','S','Fenton','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.200520,-75.773460,0,'2013-07-06 12:44:31',NULL,NULL),(18721,'19312','S','Tredyffrin','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.034377,-75.464176,0,'2013-07-06 12:44:31',NULL,NULL),(18406,'19054','S','Fallsington','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.168340,-74.822181,0,'2013-07-06 12:44:31',NULL,NULL),(32419,'35974','S','Geraldine','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.357420,-86.003111,0,'2013-07-06 12:44:32',NULL,NULL),(38830,'44084','S','Roaming Shrs','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.666663,-80.872296,0,'2013-07-06 12:44:32',NULL,NULL),(54649,'62930','S','College Heights','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(21275,'22312','S','Lincolnia','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.821508,-77.152254,0,'2013-07-06 12:44:31',NULL,NULL),(44760,'50206','S','Lawn Hill','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.198187,-93.188548,0,'2013-07-06 12:44:32',NULL,NULL),(19258,'19944','S','Selbyville','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.459312,-75.052878,0,'2013-07-06 12:44:31',NULL,NULL),(18061,'18702','S','Wilkes Barre Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(51295,'59218','S','Culbertson','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.143909,-104.518570,0,'2013-07-06 12:44:33',NULL,NULL),(77475,'96820','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.351908,-157.878057,0,'2013-07-06 12:44:34',NULL,NULL),(71314,'86505','S','Ganado','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(62842,'75014','P','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.842082,-96.970227,0,'2013-07-06 12:44:33',NULL,NULL),(35334,'39429','S','Columbia','D','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.256049,-89.826376,0,'2013-07-06 12:44:32',NULL,NULL),(25063,'27930','P','Hertford','A','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.153029,-76.313021,0,'2013-07-06 12:44:31',NULL,NULL),(39765,'45118','S','Saint Martin','N','Brown','39015','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.183132,-83.951736,0,'2013-07-06 12:44:32',NULL,NULL),(35505,'39531','S','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400773,-88.962563,0,'2013-07-06 12:44:32',NULL,NULL),(57772,'67459','S','Lorraine','D','Ellsworth','20053','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.566848,-98.317829,0,'2013-07-06 12:44:33',NULL,NULL),(11607,'12090','S','Walloomsac','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.880260,-73.359060,0,'2013-07-06 12:44:30',NULL,NULL),(21723,'23003','P','Ark','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.438567,-76.578223,0,'2013-07-06 12:44:31',NULL,NULL),(40366,'45643','P','Kerr','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.871119,-82.262830,0,'2013-07-06 12:44:32',NULL,NULL),(35064,'39189','S','Walnut Grove','D','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.596584,-89.456321,0,'2013-07-06 12:44:32',NULL,NULL),(38979,'44130','S','Parma','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(8581,'08218','P','Goshen','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.143741,-74.862001,0,'2013-07-06 12:44:30',NULL,NULL),(79964,'99638','P','Nikolski','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',52.834785,-169.860029,0,'2013-07-06 12:44:34',NULL,NULL),(66084,'78401','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.798095,-97.404668,0,'2013-07-06 12:44:34',NULL,NULL),(53714,'62240','S','E Carondelet','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.525161,-90.223920,0,'2013-07-06 12:44:33',NULL,NULL),(58541,'68814','S','Ansley','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.329198,-99.326790,0,'2013-07-06 12:44:33',NULL,NULL),(75412,'94022','S','Los Altos Hills','A','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.366560,-122.136960,0,'2013-07-06 12:44:34',NULL,NULL),(41446,'46869','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.068482,-85.169351,0,'2013-07-06 12:44:32',NULL,NULL),(65513,'77705','S','Cheek','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.969400,-94.155300,0,'2013-07-06 12:44:34',NULL,NULL),(25189,'28054','S','Spencer Mountain','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229720,-81.142440,0,'2013-07-06 12:44:31',NULL,NULL),(66428,'78641','S','Volente','A','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.527880,-97.880340,0,'2013-07-06 12:44:34',NULL,NULL),(65594,'77876','P','Shiro','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.614572,-95.886899,0,'2013-07-06 12:44:34',NULL,NULL),(58223,'68343','S','Dorchester','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.648808,-97.117598,0,'2013-07-06 12:44:33',NULL,NULL),(32315,'35760','S','New Hope','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.551235,-86.396040,0,'2013-07-06 12:44:32',NULL,NULL),(2350,'00940','P','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410886,-66.065084,0,'2013-07-06 12:44:30',NULL,NULL),(6907,'06151','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766300,-72.673122,0,'2013-07-06 12:44:30',NULL,NULL),(7602,'07045','S','Montville','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.909925,-74.364898,0,'2013-07-06 12:44:30',NULL,NULL),(62970,'75127','S','Fruitvale','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.684251,-95.796947,0,'2013-07-06 12:44:33',NULL,NULL),(32689,'36273','S','Ranburne','D','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.580874,-85.395353,0,'2013-07-06 12:44:32',NULL,NULL),(5606,'04932','S','Dixmont','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.702620,-69.100598,0,'2013-07-06 12:44:30',NULL,NULL),(29337,'32548','S','Okaloosa Island','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(4125,'02742','P','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.637919,-70.929518,0,'2013-07-06 12:44:30',NULL,NULL),(36819,'41063','S','Morning View','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.842260,-84.522660,0,'2013-07-06 12:44:32',NULL,NULL),(56829,'65793','S','Willow Spgs','A','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.994754,-91.969717,0,'2013-07-06 12:44:33',NULL,NULL),(48662,'55912','S','Mapleview','A','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667498,-92.979475,0,'2013-07-06 12:44:33',NULL,NULL),(31711,'34953','S','Saint Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.256604,-80.384626,0,'2013-07-06 12:44:32',NULL,NULL),(37259,'41562','S','Sutton','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.393260,-82.471200,0,'2013-07-06 12:44:32',NULL,NULL),(45869,'52247','S','Joetown','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.487300,-91.707929,0,'2013-07-06 12:44:32',NULL,NULL),(13392,'13746','S','North Fenton','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.269580,-75.839580,0,'2013-07-06 12:44:31',NULL,NULL),(49001,'56244','S','Hancock','D','Stevens','27149','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.495918,-95.791984,0,'2013-07-06 12:44:33',NULL,NULL),(41195,'46723','S','Churubusco','D','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.222797,-85.273777,0,'2013-07-06 12:44:32',NULL,NULL),(3563,'01950','S','Plum Island','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.811261,-70.877264,0,'2013-07-06 12:44:30',NULL,NULL),(21167,'22152','S','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.777214,-77.235211,0,'2013-07-06 12:44:31',NULL,NULL),(27718,'30344','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.668940,-84.458280,0,'2013-07-06 12:44:31',NULL,NULL),(61269,'72374','S','Poplar Grove','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.538156,-90.879149,0,'2013-07-06 12:44:33',NULL,NULL),(58883,'69162','S','Lorenzo','N','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.131320,-103.031580,0,'2013-07-06 12:44:33',NULL,NULL),(35125,'39213','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.346826,-90.214369,0,'2013-07-06 12:44:32',NULL,NULL),(14319,'14902','P','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.104120,-76.812185,0,'2013-07-06 12:44:31',NULL,NULL),(73183,'90407','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.013225,-118.493060,0,'2013-07-06 12:44:34',NULL,NULL),(37073,'41314','S','Pebworth','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(48203,'55402','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.978169,-93.269129,0,'2013-07-06 12:44:33',NULL,NULL),(44544,'50002','S','North Branch','N','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.499324,-94.647499,0,'2013-07-06 12:44:32',NULL,NULL),(18234,'18972','S','Upper Black Eddy','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.538872,-75.126125,0,'2013-07-06 12:44:31',NULL,NULL),(9052,'08889','S','Whitehouse Station','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.599026,-74.758720,0,'2013-07-06 12:44:30',NULL,NULL),(63306,'75564','P','Lodi','D','Marion','48315','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.738598,-94.308278,0,'2013-07-06 12:44:33',NULL,NULL),(60824,'72035','U','UCA','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.073922,-92.457553,0,'2013-07-06 12:44:33',NULL,NULL),(19469,'20137','S','Broad Run','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.823769,-77.715374,0,'2013-07-06 12:44:31',NULL,NULL),(36578,'40949','S','Heidrick','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.896379,-83.868344,0,'2013-07-06 12:44:32',NULL,NULL),(21363,'22443','S','Washgtns Brhp','A','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.248998,-76.962438,0,'2013-07-06 12:44:31',NULL,NULL),(57857,'67570','S','Pretty Praire','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.786862,-97.941549,0,'2013-07-06 12:44:33',NULL,NULL),(64075,'76140','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.612498,-97.271398,0,'2013-07-06 12:44:34',NULL,NULL),(65534,'77801','S','Tabor','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(19698,'20376','S','Naval Sea Sys','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916809,-76.993655,0,'2013-07-06 12:44:31',NULL,NULL),(72886,'90015','S','Dowtown Carrier Annex','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038557,-118.268695,0,'2013-07-06 12:44:34',NULL,NULL),(62432,'74156','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.246098,-95.997005,0,'2013-07-06 12:44:33',NULL,NULL),(34838,'38921','S','Cowart','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.980940,-90.107520,0,'2013-07-06 12:44:32',NULL,NULL),(30274,'33255','P','Ludlam','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.776930,-80.190934,0,'2013-07-06 12:44:32',NULL,NULL),(57,'00610','S','Paseo Del Valle','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(3253,'01440','S','Gardner','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.574542,-71.995414,0,'2013-07-06 12:44:30',NULL,NULL),(2308,'00927','S','Urb Santa Maria','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(68923,'82844','S','Wolf','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.704782,-107.303285,0,'2013-07-06 12:44:34',NULL,NULL),(44021,'49406','P','Douglas','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.639583,-86.213961,0,'2013-07-06 12:44:32',NULL,NULL),(20711,'21275','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.287029,-76.614130,0,'2013-07-06 12:44:31',NULL,NULL),(17017,'17740','S','Tomb','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(24158,'26588','S','Rivesville','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.532536,-80.123247,0,'2013-07-06 12:44:31',NULL,NULL),(46574,'53527','S','Cottage Grove','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.070701,-89.198254,0,'2013-07-06 12:44:32',NULL,NULL),(18864,'19444','S','Lafayette Hl','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.086163,-75.250559,0,'2013-07-06 12:44:31',NULL,NULL),(79234,'98550','S','Nisson','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(40296,'45441','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.644959,-84.167261,0,'2013-07-06 12:44:32',NULL,NULL),(13241,'13642','S','Brasie Corners','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(75315,'93761','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.751664,-119.788568,0,'2013-07-06 12:44:34',NULL,NULL),(74728,'93035','S','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.180219,-119.218055,0,'2013-07-06 12:44:34',NULL,NULL),(41752,'47283','S','Alert','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.175635,-85.575619,0,'2013-07-06 12:44:32',NULL,NULL),(15081,'15750','S','Josephine','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.475450,-79.182367,0,'2013-07-06 12:44:31',NULL,NULL),(66103,'78410','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.837609,-97.590692,0,'2013-07-06 12:44:34',NULL,NULL),(61810,'73103','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.488990,-97.518950,0,'2013-07-06 12:44:33',NULL,NULL),(54881,'63065','P','Mapaville','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.251399,-90.485804,0,'2013-07-06 12:44:33',NULL,NULL),(11036,'11570','S','Lakeview','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.665099,-73.637798,0,'2013-07-06 12:44:30',NULL,NULL),(2414,'00953','S','Jard De Casablanca','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(5685,'04970','S','Sandy River Plt','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(24280,'26865','S','Yellow Spring','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.199167,-78.438333,0,'2013-07-06 12:44:31',NULL,NULL),(47958,'55120','S','Eagan','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.873820,-93.140700,0,'2013-07-06 12:44:33',NULL,NULL),(19976,'20598','U','Alexandria','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(45495,'51357','S','Rossie','A','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.038840,-95.236980,0,'2013-07-06 12:44:32',NULL,NULL),(23197,'25060','S','Dorothy','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.967841,-81.495097,0,'2013-07-06 12:44:31',NULL,NULL),(28145,'30822','S','Perkins','D','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.809497,-81.940678,0,'2013-07-06 12:44:31',NULL,NULL),(16880,'17572','S','Mascot','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014588,-76.149820,0,'2013-07-06 12:44:31',NULL,NULL),(69880,'84098','S','Summit Park','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.657510,-111.495033,0,'2013-07-06 12:44:34',NULL,NULL),(70429,'84733','S','Gunlock','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.284384,-113.758335,0,'2013-07-06 12:44:34',NULL,NULL),(23800,'26035','S','Colliers','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.366239,-80.568744,0,'2013-07-06 12:44:31',NULL,NULL),(21033,'21867','P','Upper Fairmount','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.102657,-75.794628,0,'2013-07-06 12:44:31',NULL,NULL),(20291,'20799','U','Capitol Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.881409,-76.856119,0,'2013-07-06 12:44:31',NULL,NULL),(7003,'06255','S','N Grosvenordl','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.986809,-71.902586,0,'2013-07-06 12:44:30',NULL,NULL),(23709,'25878','P','Pemberton','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.717778,-81.219167,0,'2013-07-06 12:44:31',NULL,NULL),(46531,'53401','P','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.691955,-87.814781,0,'2013-07-06 12:44:32',NULL,NULL),(25972,'28659','S','Mulberry','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(5724,'05009','U','White Riv Jct','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.652072,-72.322990,0,'2013-07-06 12:44:30',NULL,NULL),(52564,'60958','S','Pembroke Township','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.234742,-87.635744,0,'2013-07-06 12:44:33',NULL,NULL),(43518,'48642','S','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.634232,-84.203334,0,'2013-07-06 12:44:32',NULL,NULL),(25764,'28586','S','Vanceboro','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.299473,-77.145872,0,'2013-07-06 12:44:31',NULL,NULL),(28825,'32081','S','Ponte Vedra','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173581,-81.395627,0,'2013-07-06 12:44:32',NULL,NULL),(42957,'48130','S','Dover','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(27091,'29710','S','Lake Wylie','A','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.105301,-81.184746,0,'2013-07-06 12:44:31',NULL,NULL),(79692,'99203','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.629799,-117.389448,0,'2013-07-06 12:44:34',NULL,NULL),(68668,'81655','P','Wolcott','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.683061,-106.673851,0,'2013-07-06 12:44:34',NULL,NULL),(47213,'54493','S','Willard','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.697478,-90.815604,0,'2013-07-06 12:44:32',NULL,NULL),(69125,'83281','P','Swanlake','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.325765,-111.997695,0,'2013-07-06 12:44:34',NULL,NULL),(63793,'75959','S','Milam','D','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.481280,-93.838320,0,'2013-07-06 12:44:34',NULL,NULL),(56089,'64771','S','Moundville','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.744332,-94.494540,0,'2013-07-06 12:44:33',NULL,NULL),(31866,'35121','S','Oneonta','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.948154,-86.470543,0,'2013-07-06 12:44:32',NULL,NULL),(3476,'01824','S','S Chelmsford','A','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.623280,-71.364720,0,'2013-07-06 12:44:30',NULL,NULL),(57493,'66940','S','Cuba','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.786160,-97.423643,0,'2013-07-06 12:44:33',NULL,NULL),(51730,'60012','S','Bull Valley','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.270000,-88.304220,0,'2013-07-06 12:44:33',NULL,NULL),(69625,'83873','S','Prichard','A','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.396520,-115.949460,0,'2013-07-06 12:44:34',NULL,NULL),(63605,'75798','U','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.334479,-95.285516,0,'2013-07-06 12:44:34',NULL,NULL),(64225,'76305','S','Cashion Cmnty','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(12411,'12936','S','Essex','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.261839,-73.374299,0,'2013-07-06 12:44:30',NULL,NULL),(26238,'28814','P','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.623680,-82.554480,0,'2013-07-06 12:44:31',NULL,NULL),(22898,'24593','S','Spout Spring','D','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.368264,-78.908340,0,'2013-07-06 12:44:31',NULL,NULL),(49528,'56676','S','Shevlin','D','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.383450,-95.232970,0,'2013-07-06 12:44:33',NULL,NULL),(42679,'47974','S','Perrysville','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',40.077863,-87.477227,0,'2013-07-06 12:44:32',NULL,NULL),(4793,'03874','S','Seabrook','D','Rockingham','33015','New Hampshire','NH','33','1120','603','Eastern',-5.0,'Y',42.891113,-70.857854,0,'2013-07-06 12:44:30',NULL,NULL),(17014,'17740','S','Ramsey','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(8551,'08204','S','N Cape May','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(36265,'40330','S','Shakertown','N','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.789200,-84.861780,0,'2013-07-06 12:44:32',NULL,NULL),(52689,'61091','P','Woosung','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.907852,-89.543238,0,'2013-07-06 12:44:33',NULL,NULL),(80098,'99749','P','Kiana','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',67.553337,-160.318483,0,'2013-07-06 12:44:34',NULL,NULL),(72192,'88410','S','Hayden','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.891766,-103.212948,0,'2013-07-06 12:44:34',NULL,NULL),(68133,'80962','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.954393,-104.733997,0,'2013-07-06 12:44:34',NULL,NULL),(37977,'42728','S','Milltown','A','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(49626,'56920','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895216,-77.036514,0,'2013-07-06 12:44:33',NULL,NULL),(18093,'18708','S','Jackson Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.300280,-75.965880,0,'2013-07-06 12:44:31',NULL,NULL),(51735,'60013','S','Oakwood Hills','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.219192,-88.239708,0,'2013-07-06 12:44:33',NULL,NULL),(73018,'90069','S','Los Angeles','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091537,-118.382020,0,'2013-07-06 12:44:34',NULL,NULL),(32713,'36301','S','Rehobeth','A','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(20003,'20609','S','Avenue','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.278304,-76.723639,0,'2013-07-06 12:44:31',NULL,NULL),(66018,'78358','P','Fulton Beach','N','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.079830,-97.032030,0,'2013-07-06 12:44:34',NULL,NULL),(15198,'15955','S','Sidman','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.331988,-78.735586,0,'2013-07-06 12:44:31',NULL,NULL),(6807,'06109','S','Wethersfield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(10190,'10292','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708181,-74.003846,0,'2013-07-06 12:44:30',NULL,NULL),(50987,'58646','S','Mott','D','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.395780,-102.428160,0,'2013-07-06 12:44:33',NULL,NULL),(3834,'02337','P','Elmwood','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.011834,-70.964024,0,'2013-07-06 12:44:30',NULL,NULL),(47598,'54870','S','Sarona','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.632426,-91.723092,0,'2013-07-06 12:44:33',NULL,NULL),(43797,'49056','S','Grand Junction','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.375171,-86.059363,0,'2013-07-06 12:44:32',NULL,NULL),(17645,'18070','S','Palm','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.433608,-75.542027,0,'2013-07-06 12:44:31',NULL,NULL),(3408,'01703','P','Framingham','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.323005,-71.441791,0,'2013-07-06 12:44:30',NULL,NULL),(36778,'41043','S','Willow Grove','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(37880,'42566','S','Yosemite','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.325225,-84.928753,0,'2013-07-06 12:44:32',NULL,NULL),(6975,'06241','S','Dayville','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.851822,-71.860430,0,'2013-07-06 12:44:30',NULL,NULL),(57467,'66860','S','Madison','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.136417,-96.134240,0,'2013-07-06 12:44:33',NULL,NULL),(61601,'72766','P','Springdale','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.185364,-94.130656,0,'2013-07-06 12:44:33',NULL,NULL),(22404,'23959','S','Phenix','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.100116,-78.802734,0,'2013-07-06 12:44:31',NULL,NULL),(27277,'29945','S','Blake','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(68350,'81132','S','Del Norte','D','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(64398,'76539','S','Rumley','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.080030,-98.000076,0,'2013-07-06 12:44:34',NULL,NULL),(63753,'75939','S','Pleasant Hill','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(62145,'73717','S','Capron','A','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.796749,-98.668264,0,'2013-07-06 12:44:33',NULL,NULL),(75053,'93519','P','Mojave','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.305573,-117.953568,0,'2013-07-06 12:44:34',NULL,NULL),(76628,'95712','P','Chicago Park','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.162319,-120.956753,0,'2013-07-06 12:44:34',NULL,NULL),(78587,'98177','S','The Highlands','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.743958,-122.369875,0,'2013-07-06 12:44:34',NULL,NULL),(43523,'48652','S','Rhodes','D','Gladwin','26051','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.868179,-84.213418,0,'2013-07-06 12:44:32',NULL,NULL),(8829,'08628','S','Ewing','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.273620,-74.817480,0,'2013-07-06 12:44:30',NULL,NULL),(47208,'54491','S','Markton','N','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.187800,-88.731300,0,'2013-07-06 12:44:32',NULL,NULL),(28420,'31328','S','Fort Screven','N','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.005769,-80.851185,0,'2013-07-06 12:44:32',NULL,NULL),(52141,'60436','S','Shorewood','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.489640,-88.145340,0,'2013-07-06 12:44:33',NULL,NULL),(48234,'55421','S','Fridley','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(73604,'91390','S','Sleepy Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(18479,'19087','S','St Davids','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(51349,'59323','P','Colstrip','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.899305,-106.624828,0,'2013-07-06 12:44:33',NULL,NULL),(22755,'24426','S','Alleghany','A','Covington City','51580','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.751640,-80.045760,0,'2013-07-06 12:44:31',NULL,NULL),(34376,'38614','S','Riverton','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(55051,'63145','P','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748850,-90.361025,0,'2013-07-06 12:44:33',NULL,NULL),(61712,'73008','S','Woodlawn Park','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.502940,-97.644790,0,'2013-07-06 12:44:33',NULL,NULL),(12600,'13080','S','Cross Lake','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.093320,-76.465560,0,'2013-07-06 12:44:30',NULL,NULL),(10366,'10583','S','Scarsdale','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.989799,-73.800070,0,'2013-07-06 12:44:30',NULL,NULL),(11288,'11775','U','Melville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.793182,-73.417940,0,'2013-07-06 12:44:30',NULL,NULL),(18467,'19083','S','Havertown','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.974773,-75.308851,0,'2013-07-06 12:44:31',NULL,NULL),(79310,'98595','S','Westport','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.881787,-124.107588,0,'2013-07-06 12:44:34',NULL,NULL),(33136,'36904','S','Riderwood','N','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.091455,-88.222286,0,'2013-07-06 12:44:32',NULL,NULL),(2781,'00976','S','Parc Saint Just','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(51924,'60118','S','Dundee','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.110280,-88.296540,0,'2013-07-06 12:44:33',NULL,NULL),(2592,'00961','S','Urb El Coqui','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(64110,'76180','S','N Richlnd Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(52532,'60922','S','Sammons Point','A','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.006701,-87.909574,0,'2013-07-06 12:44:33',NULL,NULL),(76136,'95254','P','Wallace','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.172249,-120.935009,0,'2013-07-06 12:44:34',NULL,NULL),(37306,'41640','S','Elmrock','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.508219,-82.832880,0,'2013-07-06 12:44:32',NULL,NULL),(35558,'39565','S','Van Cleave','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.568555,-88.740289,0,'2013-07-06 12:44:32',NULL,NULL),(1382,'00738','S','Bo Proyecto Fema','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(59657,'71049','S','Stanley','A','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.017906,-93.933956,0,'2013-07-06 12:44:33',NULL,NULL),(60735,'71961','S','Pine Ridge','A','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.604027,-93.831820,0,'2013-07-06 12:44:33',NULL,NULL),(79698,'99206','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.651979,-117.275650,0,'2013-07-06 12:44:34',NULL,NULL),(66441,'78648','S','Joliet','N','Caldwell','48055','Texas','TX','48','0640','830','Central',-6.0,'Y',29.678992,-97.646226,0,'2013-07-06 12:44:34',NULL,NULL),(65131,'77382','S','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.229380,-95.510820,0,'2013-07-06 12:44:34',NULL,NULL),(60912,'72076','S','Macon','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(49282,'56515','S','Battle Lake','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.287269,-95.713207,0,'2013-07-06 12:44:33',NULL,NULL),(41222,'46733','S','Decatur','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(39005,'44138','S','Olmsted Falls','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.378304,-81.918914,0,'2013-07-06 12:44:32',NULL,NULL),(73482,'91321','S','Friendly Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.379025,-118.520802,0,'2013-07-06 12:44:34',NULL,NULL),(44458,'49877','P','Felch','A','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.108498,-87.784388,0,'2013-07-06 12:44:32',NULL,NULL),(32006,'35229','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.464351,-86.795405,0,'2013-07-06 12:44:32',NULL,NULL),(59066,'70094','S','South Kenner','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(52420,'60646','S','Lincolnwood','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.007469,-87.741972,0,'2013-07-06 12:44:33',NULL,NULL),(76061,'95201','P','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.906882,-121.223403,0,'2013-07-06 12:44:34',NULL,NULL),(64496,'76628','P','Brandon','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.047616,-97.103411,0,'2013-07-06 12:44:34',NULL,NULL),(12011,'12501','S','Amenia','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.848904,-73.541050,0,'2013-07-06 12:44:30',NULL,NULL),(37725,'42276','S','Daysville','N','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(25720,'28544','S','Jacksonville','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.732620,-77.327640,0,'2013-07-06 12:44:31',NULL,NULL),(45955,'52354','S','Watkins','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.904259,-92.006214,0,'2013-07-06 12:44:32',NULL,NULL),(22897,'24592','S','Turbeville','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.709303,-78.901540,0,'2013-07-06 12:44:31',NULL,NULL),(32287,'35670','S','Somerville','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.536418,-86.780675,0,'2013-07-06 12:44:32',NULL,NULL),(32026,'35242','S','Shoal Creek','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(4612,'03592','S','Pittsburg','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',45.113334,-71.254468,0,'2013-07-06 12:44:30',NULL,NULL),(79107,'98464','P','University Pl','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225450,-122.537309,0,'2013-07-06 12:44:34',NULL,NULL),(36428,'40578','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.078233,-84.503065,0,'2013-07-06 12:44:32',NULL,NULL),(73754,'91729','P','Rancho Cucamonga','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.098356,-117.563036,0,'2013-07-06 12:44:34',NULL,NULL),(43218,'48309','S','Rochester','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657960,-83.186520,0,'2013-07-06 12:44:32',NULL,NULL),(39087,'44223','S','Cuyahoga Falls','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.145747,-81.518239,0,'2013-07-06 12:44:32',NULL,NULL),(29422,'32664','P','Mc Intosh','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.448039,-82.229425,0,'2013-07-06 12:44:32',NULL,NULL),(23039,'24855','P','Kyle','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.407474,-81.427908,0,'2013-07-06 12:44:31',NULL,NULL),(22700,'24330','S','Fries','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.731230,-81.029471,0,'2013-07-06 12:44:31',NULL,NULL),(21217,'22210','P','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.887284,-77.093944,0,'2013-07-06 12:44:31',NULL,NULL),(53987,'62441','S','Clark Center','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.400200,-87.694680,0,'2013-07-06 12:44:33',NULL,NULL),(63042,'75211','S','Cockrell Hill','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.816220,-96.888660,0,'2013-07-06 12:44:33',NULL,NULL),(39887,'45212','S','Norwood','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.175321,-84.440014,0,'2013-07-06 12:44:32',NULL,NULL),(29557,'32809','S','Pine Castle','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.471095,-81.389356,0,'2013-07-06 12:44:32',NULL,NULL),(63301,'75562','P','Kildare','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.010406,-94.364190,0,'2013-07-06 12:44:33',NULL,NULL),(59594,'71008','S','Liberty Hill','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(40901,'46255','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.766744,-86.163967,0,'2013-07-06 12:44:32',NULL,NULL),(52550,'60942','S','Hoopeston','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.463479,-87.670731,0,'2013-07-06 12:44:33',NULL,NULL),(7578,'07031','S','N Arlington','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.792821,-74.128838,0,'2013-07-06 12:44:30',NULL,NULL),(35749,'39730','S','Strongs','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(19637,'20261','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885689,-77.019097,0,'2013-07-06 12:44:31',NULL,NULL),(28682,'31799','P','Thomasville','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.837613,-83.978012,0,'2013-07-06 12:44:32',NULL,NULL),(69700,'84032','S','Daniel','A','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(68846,'82602','P','Casper','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.844076,-106.336675,0,'2013-07-06 12:44:34',NULL,NULL),(65968,'78289','U','City Public Serv Board','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.532254,-98.412276,0,'2013-07-06 12:44:34',NULL,NULL),(22621,'24226','S','Clinchco','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.127536,-82.336672,0,'2013-07-06 12:44:31',NULL,NULL),(21884,'23173','U','University of Richmond','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.577785,-77.534555,0,'2013-07-06 12:44:31',NULL,NULL),(10456,'10924','S','Goshen','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.396494,-74.319687,0,'2013-07-06 12:44:30',NULL,NULL),(52502,'60712','S','CHI','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.003155,-87.734888,0,'2013-07-06 12:44:33',NULL,NULL),(12892,'13332','S','Lebanon Center','N','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(6360,'05675','S','Washingtn','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(27297,'30010','P','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.966056,-84.218437,0,'2013-07-06 12:44:31',NULL,NULL),(53113,'61541','P','La Rose','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.982691,-89.238779,0,'2013-07-06 12:44:33',NULL,NULL),(23471,'25443','S','Shepherdstown','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.427212,-77.814316,0,'2013-07-06 12:44:31',NULL,NULL),(52210,'60481','S','Ballou','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(1024,'00718','S','Urb Juan Mendoza','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(24609,'27330','S','Swan Station','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(11553,'12056','S','Princetown','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.766140,-74.139540,0,'2013-07-06 12:44:30',NULL,NULL),(42505,'47845','P','Coalmont','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.198875,-87.186742,0,'2013-07-06 12:44:32',NULL,NULL),(77648,'97015','S','Happy Valley','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.415610,-122.523750,0,'2013-07-06 12:44:34',NULL,NULL),(13734,'14105','S','Middleport','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.209014,-78.492391,0,'2013-07-06 12:44:31',NULL,NULL),(73424,'91202','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.166714,-118.268347,0,'2013-07-06 12:44:34',NULL,NULL),(31627,'34695','S','Safety Harbor','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.005845,-82.695282,0,'2013-07-06 12:44:32',NULL,NULL),(8097,'07763','P','Tennent','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.275339,-74.337089,0,'2013-07-06 12:44:30',NULL,NULL),(12593,'13074','S','Hannibal Center','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.285920,-76.532580,0,'2013-07-06 12:44:30',NULL,NULL),(49091,'56332','S','Garfield','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.019226,-95.458464,0,'2013-07-06 12:44:33',NULL,NULL),(49610,'56762','S','Radium','A','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.197279,-96.769251,0,'2013-07-06 12:44:33',NULL,NULL),(67738,'80553','U','Teledyne Water Pik','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.565319,-105.045445,0,'2013-07-06 12:44:34',NULL,NULL),(63456,'75684','S','Harmony','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(74369,'92427','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.199862,-117.345353,0,'2013-07-06 12:44:34',NULL,NULL),(28497,'31523','S','Brunswick','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.174003,-81.501377,0,'2013-07-06 12:44:32',NULL,NULL),(57057,'66212','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955997,-94.682048,0,'2013-07-06 12:44:33',NULL,NULL),(56362,'65205','P','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.049268,-92.240473,0,'2013-07-06 12:44:33',NULL,NULL),(54746,'62974','S','Pittsburg','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.787286,-88.865717,0,'2013-07-06 12:44:33',NULL,NULL),(32664,'36261','P','Edwardsville','D','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.707399,-85.509363,0,'2013-07-06 12:44:32',NULL,NULL),(36008,'40152','S','McDaniels','N','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.626288,-86.447899,0,'2013-07-06 12:44:32',NULL,NULL),(10984,'11545','S','Upper Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(413,'00662','S','Repto Jerusalen','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(2555,'00959','S','Repto Valencia','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(77263,'96578','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(73562,'91365','P','Woodland Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.172838,-118.605715,0,'2013-07-06 12:44:34',NULL,NULL),(3373,'01586','P','Millbury','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.126310,-71.646126,0,'2013-07-06 12:44:30',NULL,NULL),(36163,'40242','S','Lyndon','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(43026,'48169','S','Putnam Twp','N','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.459080,-83.934013,0,'2013-07-06 12:44:32',NULL,NULL),(48188,'55391','S','Deephaven','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.966040,-93.541800,0,'2013-07-06 12:44:33',NULL,NULL),(71801,'87566','S','Estaca','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(72857,'90002','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.948432,-118.245196,0,'2013-07-06 12:44:34',NULL,NULL),(44290,'49724','S','Dafter','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.344348,-84.415923,0,'2013-07-06 12:44:32',NULL,NULL),(7446,'06853','S','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.069465,-73.442358,0,'2013-07-06 12:44:30',NULL,NULL),(29479,'32726','S','Eustis','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.861188,-81.618986,0,'2013-07-06 12:44:32',NULL,NULL),(72717,'89452','P','Incline Village','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.244739,-119.964921,0,'2013-07-06 12:44:34',NULL,NULL),(26217,'28789','S','Whittier','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457462,-83.287016,0,'2013-07-06 12:44:31',NULL,NULL),(26682,'29404','S','Joint Base Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(10328,'10547','S','Mohegan Lake','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.317149,-73.846680,0,'2013-07-06 12:44:30',NULL,NULL),(262,'00641','S','Sect Bella Vista','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(72267,'88545','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.765908,-106.329967,0,'2013-07-06 12:44:34',NULL,NULL),(12294,'12848','P','Middle Falls','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.102413,-73.526359,0,'2013-07-06 12:44:30',NULL,NULL),(47131,'54455','S','Dancy','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(68184,'81022','S','N Avondale','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.179817,-104.390761,0,'2013-07-06 12:44:34',NULL,NULL),(35673,'39654','S','Oma','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(41809,'47331','S','Harrisburg','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(4036,'02574','P','West Falmouth','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.601360,-70.639607,0,'2013-07-06 12:44:30',NULL,NULL),(70403,'84714','S','Beryl Junction','N','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.703796,-113.652604,0,'2013-07-06 12:44:34',NULL,NULL),(11566,'12064','S','East Worcester','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.557719,-74.644350,0,'2013-07-06 12:44:30',NULL,NULL),(23732,'25916','P','Sabine','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.678133,-81.503162,0,'2013-07-06 12:44:31',NULL,NULL),(47927,'55112','S','New Brighton','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079380,-93.187200,0,'2013-07-06 12:44:33',NULL,NULL),(17640,'18066','S','New Tripoli','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.676249,-75.744159,0,'2013-07-06 12:44:31',NULL,NULL),(48577,'55771','S','Kinmount','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(64994,'77287','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.674496,-95.247573,0,'2013-07-06 12:44:34',NULL,NULL),(27564,'30264','P','Newnan','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.371858,-84.811498,0,'2013-07-06 12:44:31',NULL,NULL),(3555,'01940','S','Lynnfield','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.536090,-71.026506,0,'2013-07-06 12:44:30',NULL,NULL),(1275,'00730','S','Ext El Madrigal','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(34910,'38958','P','Charlestn','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.949231,-90.174679,0,'2013-07-06 12:44:32',NULL,NULL),(27838,'30420','S','Cobbtown','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.256436,-82.124286,0,'2013-07-06 12:44:31',NULL,NULL),(23630,'25726','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.418723,-82.474617,0,'2013-07-06 12:44:31',NULL,NULL),(18353,'19036','S','Glenolden','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.906381,-75.293696,0,'2013-07-06 12:44:31',NULL,NULL),(56246,'65052','S','Hugo','N','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.040796,-92.706040,0,'2013-07-06 12:44:33',NULL,NULL),(68545,'81423','P','Norwood','D','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.125191,-108.279580,0,'2013-07-06 12:44:34',NULL,NULL),(29858,'33037','S','Ocean Reef Club','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.130791,-80.410224,0,'2013-07-06 12:44:32',NULL,NULL),(70653,'85193','S','Casa Grande','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.893136,-111.734051,0,'2013-07-06 12:44:34',NULL,NULL),(42271,'47581','S','Shoals','D','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(69225,'83401','S','Shelton','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(2917,'01005','S','Barre','D','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.433317,-72.114488,0,'2013-07-06 12:44:30',NULL,NULL),(56718,'65685','S','Louisburg','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.728371,-93.100606,0,'2013-07-06 12:44:33',NULL,NULL),(72132,'88301','S','Duran','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(15285,'16124','S','Fredonia','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.323452,-80.261997,0,'2013-07-06 12:44:31',NULL,NULL),(44231,'49654','S','North Manitou','N','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.025065,-85.752371,0,'2013-07-06 12:44:32',NULL,NULL),(12235,'12817','S','Chestertown','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.635990,-73.803616,0,'2013-07-06 12:44:30',NULL,NULL),(44870,'50309','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.588394,-93.619191,0,'2013-07-06 12:44:32',NULL,NULL),(75728,'94591','S','Vallejo','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.101456,-122.210632,0,'2013-07-06 12:44:34',NULL,NULL),(68850,'82605','P','Casper','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.868032,-106.312773,0,'2013-07-06 12:44:34',NULL,NULL),(57608,'67117','S','North Newton','D','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.134080,-97.321620,0,'2013-07-06 12:44:33',NULL,NULL),(38515,'43722','P','Buffalo','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.914026,-81.520023,0,'2013-07-06 12:44:32',NULL,NULL),(13936,'14432','S','Clifton Spgs','A','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.963132,-77.147698,0,'2013-07-06 12:44:31',NULL,NULL),(26154,'28740','S','Pleasant Gap','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(3957,'02478','S','Belmont','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.394199,-71.180235,0,'2013-07-06 12:44:30',NULL,NULL),(22576,'24153','S','Salem','D','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(37126,'41464','S','Royalton','D','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.662500,-82.963889,0,'2013-07-06 12:44:32',NULL,NULL),(73286,'90747','U','Carson','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.866528,-118.253036,0,'2013-07-06 12:44:34',NULL,NULL),(60473,'71655','S','Ladelle','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(20825,'21628','P','Crumpton','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.237149,-75.920428,0,'2013-07-06 12:44:31',NULL,NULL),(34052,'38138','S','Memphis','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.072700,-89.902500,0,'2013-07-06 12:44:32',NULL,NULL),(60286,'71450','S','Boline','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.793040,-93.399660,0,'2013-07-06 12:44:33',NULL,NULL),(63901,'76023','S','Boyd','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.136623,-97.646998,0,'2013-07-06 12:44:34',NULL,NULL),(8316,'08033','S','East Haddonfield','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.895208,-75.039366,0,'2013-07-06 12:44:30',NULL,NULL),(47631,'54913','S','Freedom','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.263597,-88.413736,0,'2013-07-06 12:44:33',NULL,NULL),(57675,'67220','S','Bel Aire','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.746820,-97.274780,0,'2013-07-06 12:44:33',NULL,NULL),(59441,'70715','S','Batchelor','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.806705,-91.666728,0,'2013-07-06 12:44:33',NULL,NULL),(9115,'09123','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(53937,'62414','S','Wrights Corner','N','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.176936,-88.821983,0,'2013-07-06 12:44:33',NULL,NULL),(46801,'54002','S','Baldwin','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.974620,-92.350320,0,'2013-07-06 12:44:32',NULL,NULL),(7428,'06820','S','Noroton','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.079898,-73.480707,0,'2013-07-06 12:44:30',NULL,NULL),(63502,'75708','S','E Texas Ctr','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.398669,-95.243419,0,'2013-07-06 12:44:33',NULL,NULL),(72426,'89067','S','Moapa','A','Clark','32003','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.675655,-114.620214,0,'2013-07-06 12:44:34',NULL,NULL),(70566,'85053','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.631811,-112.131427,0,'2013-07-06 12:44:34',NULL,NULL),(50821,'58467','S','Crystal Spgs','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.893964,-99.302871,0,'2013-07-06 12:44:33',NULL,NULL),(18908,'19480','P','Uwchland','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.081499,-75.694821,0,'2013-07-06 12:44:31',NULL,NULL),(51323,'59256','P','Raymond','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.782168,-104.556725,0,'2013-07-06 12:44:33',NULL,NULL),(54413,'62830','S','Dix','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441733,-88.935689,0,'2013-07-06 12:44:33',NULL,NULL),(75567,'94267','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582798,-121.490569,0,'2013-07-06 12:44:34',NULL,NULL),(70414,'84721','S','Pintura','N','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.662085,-113.196253,0,'2013-07-06 12:44:34',NULL,NULL),(60272,'71447','S','Marco','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(13675,'14036','S','Pembroke','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.972006,-78.383842,0,'2013-07-06 12:44:31',NULL,NULL),(8866,'08690','S','Hamilton Square','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(79804,'99362','S','Walla Walla','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.059294,-118.330015,0,'2013-07-06 12:44:34',NULL,NULL),(953,'00716','S','Parc Sabanetas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(5394,'04652','S','Trescott Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.864857,-66.991337,0,'2013-07-06 12:44:30',NULL,NULL),(22461,'24035','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.282403,-79.928587,0,'2013-07-06 12:44:31',NULL,NULL),(19990,'20599','U','Pre Inaugural Committee','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893588,-77.001294,0,'2013-07-06 12:44:31',NULL,NULL),(39274,'44460','S','Salem','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.886216,-80.871563,0,'2013-07-06 12:44:32',NULL,NULL),(38867,'44101','P','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.494043,-81.669403,0,'2013-07-06 12:44:32',NULL,NULL),(19843,'20506','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899668,-77.039336,0,'2013-07-06 12:44:31',NULL,NULL),(60964,'72104','S','Gifford','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(58550,'68816','S','Midland','N','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.177012,-98.113761,0,'2013-07-06 12:44:33',NULL,NULL),(18253,'19002','S','Broad Axe','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.190760,-75.206580,0,'2013-07-06 12:44:31',NULL,NULL),(27804,'30396','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647672,-84.393744,0,'2013-07-06 12:44:31',NULL,NULL),(28595,'31643','S','Quitman','D','Brooks','13027','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.785137,-83.557620,0,'2013-07-06 12:44:32',NULL,NULL),(12454,'12969','S','Mountain View','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.705100,-74.111820,0,'2013-07-06 12:44:30',NULL,NULL),(24379,'27055','S','Yadkinville','D','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(56411,'65251','S','Calwood','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.852815,-91.946319,0,'2013-07-06 12:44:33',NULL,NULL),(1812,'00784','S','Chalets De Brisas Del Mar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(42784,'48044','S','Macomb Twp','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.651262,-82.925811,0,'2013-07-06 12:44:32',NULL,NULL),(2892,'00987','S','Paseo de la Alhambra','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(31991,'35222','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.525173,-86.771265,0,'2013-07-06 12:44:32',NULL,NULL),(77194,'96346','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(15229,'16028','S','East Brady','D','Clarion','42031','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.221154,-79.439479,0,'2013-07-06 12:44:31',NULL,NULL),(8764,'08540','S','Princeton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.367460,-74.669520,0,'2013-07-06 12:44:30',NULL,NULL),(37244,'41554','S','Phyllis','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.466033,-82.342894,0,'2013-07-06 12:44:32',NULL,NULL),(65407,'77566','S','Lake Jackson','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.041532,-95.444189,0,'2013-07-06 12:44:34',NULL,NULL),(23806,'26041','S','Moundsville','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.925293,-80.736568,0,'2013-07-06 12:44:31',NULL,NULL),(16058,'17047','S','Couchtown','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(42255,'47578','S','Sandborn','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.897950,-87.185026,0,'2013-07-06 12:44:32',NULL,NULL),(31487,'34433','S','Dunnellon','D','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.004097,-82.522871,0,'2013-07-06 12:44:32',NULL,NULL),(3054,'01108','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.082083,-72.554368,0,'2013-07-06 12:44:30',NULL,NULL),(47283,'54541','S','Laona','D','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.558480,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(49574,'56727','S','Grygla','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.281501,-95.378480,0,'2013-07-06 12:44:33',NULL,NULL),(20313,'20818','S','Cabin John','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.975593,-77.159849,0,'2013-07-06 12:44:31',NULL,NULL),(72937,'90036','S','Farmer Market','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.067699,-118.350907,0,'2013-07-06 12:44:34',NULL,NULL),(72168,'88343','S','Picacho','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.425364,-105.032553,0,'2013-07-06 12:44:34',NULL,NULL),(5283,'04530','S','Bath','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.913876,-69.824845,0,'2013-07-06 12:44:30',NULL,NULL),(46376,'53130','S','Hales Corners','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.939685,-88.050138,0,'2013-07-06 12:44:32',NULL,NULL),(44295,'49727','S','East Jordan','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.175690,-85.132484,0,'2013-07-06 12:44:32',NULL,NULL),(54654,'62930','S','Texas City','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(49876,'57261','S','Roslyn','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.513278,-97.587947,0,'2013-07-06 12:44:33',NULL,NULL),(1199,'00728','S','Jard del Caribe 5','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(66407,'78630','P','Cedar Park','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.504171,-97.820136,0,'2013-07-06 12:44:34',NULL,NULL),(2843,'00983','S','La Ceramica Ind Park','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(49826,'57219','S','Butler','A','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.260940,-97.718340,0,'2013-07-06 12:44:33',NULL,NULL),(57405,'66762','S','Radley','A','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.412275,-94.698359,0,'2013-07-06 12:44:33',NULL,NULL),(8638,'08270','S','Eldora','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(10148,'10275','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.701876,-74.013967,0,'2013-07-06 12:44:30',NULL,NULL),(555,'00677','S','Urb Sea Beach Colony','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(78861,'98345','P','Keyport','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.704222,-122.628278,0,'2013-07-06 12:44:34',NULL,NULL),(74850,'93247','S','Cairns Corner','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.209983,-119.086125,0,'2013-07-06 12:44:34',NULL,NULL),(11995,'12484','S','Stone Ridge','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.876340,-74.175540,0,'2013-07-06 12:44:30',NULL,NULL),(75832,'94914','P','Kentfield','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.947390,-122.537057,0,'2013-07-06 12:44:34',NULL,NULL),(5338,'04605','S','Lamoine','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(55917,'64454','S','Gower','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.591475,-94.589642,0,'2013-07-06 12:44:33',NULL,NULL),(56471,'65305','S','Whiteman Air Force Base','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.728246,-93.565357,0,'2013-07-06 12:44:33',NULL,NULL),(63412,'75652','S','Stewart','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(7896,'07544','P','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.930417,-74.157500,0,'2013-07-06 12:44:30',NULL,NULL),(10599,'11040','S','Hillside Manor','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(34612,'38751','S','Heathman','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(34767,'38863','S','Goodfood','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(54396,'62821','S','Dogtown','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.066220,-88.138320,0,'2013-07-06 12:44:33',NULL,NULL),(44417,'49834','S','Foster City','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.083693,-87.778192,0,'2013-07-06 12:44:32',NULL,NULL),(43604,'48767','S','Unionville','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.644452,-83.470258,0,'2013-07-06 12:44:32',NULL,NULL),(56627,'65591','S','Montreal','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.989338,-92.519461,0,'2013-07-06 12:44:33',NULL,NULL),(73387,'91107','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.152009,-118.088972,0,'2013-07-06 12:44:34',NULL,NULL),(72434,'89084','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.302659,-115.142997,0,'2013-07-06 12:44:34',NULL,NULL),(58045,'68025','S','Fremont','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.441269,-96.494304,0,'2013-07-06 12:44:33',NULL,NULL),(34231,'38374','S','Scotts Hill','D','Decatur','47039','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.504287,-88.236798,0,'2013-07-06 12:44:32',NULL,NULL),(21210,'22204','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.859707,-77.095607,0,'2013-07-06 12:44:31',NULL,NULL),(23062,'24870','S','Toneyfork','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.711020,-81.604020,0,'2013-07-06 12:44:31',NULL,NULL),(1407,'00738','S','Urb Montemar','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(12312,'12858','S','Paradox Lake','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.894090,-73.638656,0,'2013-07-06 12:44:30',NULL,NULL),(4574,'03561','S','Littleton','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.308081,-71.771060,0,'2013-07-06 12:44:30',NULL,NULL),(39747,'45102','S','Amelia','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.022200,-84.225600,0,'2013-07-06 12:44:32',NULL,NULL),(48644,'55816','P','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.768155,-92.133133,0,'2013-07-06 12:44:33',NULL,NULL),(17766,'18333','S','Kresgeville','D','Monroe','42089','Pennsylvania','PA','42','0000','610/484','Eastern',-5.0,'Y',40.958388,-75.501714,0,'2013-07-06 12:44:31',NULL,NULL),(34149,'38238','U','Martin','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.344329,-88.858264,0,'2013-07-06 12:44:32',NULL,NULL),(25777,'28602','S','Longview','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.661600,-81.370320,0,'2013-07-06 12:44:31',NULL,NULL),(79526,'98937','S','White Pass','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(72370,'89030','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.210991,-115.128903,0,'2013-07-06 12:44:34',NULL,NULL),(64905,'77091','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.853167,-95.436756,0,'2013-07-06 12:44:34',NULL,NULL),(33187,'37033','S','Grinders','N','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(18753,'19344','S','West Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.084833,-75.898086,0,'2013-07-06 12:44:31',NULL,NULL),(20211,'20763','S','Savage','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.140828,-76.825900,0,'2013-07-06 12:44:31',NULL,NULL),(49382,'56601','S','Grant Valley','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(17954,'18517','S','Taylor','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350889,-75.727898,0,'2013-07-06 12:44:31',NULL,NULL),(65514,'77705','S','Fannett','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.969400,-94.155300,0,'2013-07-06 12:44:34',NULL,NULL),(44034,'49419','S','Hamilton','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.686263,-85.984542,0,'2013-07-06 12:44:32',NULL,NULL),(60665,'71921','S','Fendley','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(79086,'98438','P','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(66620,'78774','U','State Comptroller','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.279861,-97.739184,0,'2013-07-06 12:44:34',NULL,NULL),(24641,'27371','S','Uwharie','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(22046,'23310','S','Cape Charles','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.269849,-76.019571,0,'2013-07-06 12:44:31',NULL,NULL),(53792,'62282','P','Saint Libory','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.359282,-89.712548,0,'2013-07-06 12:44:33',NULL,NULL),(25339,'28216','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.286212,-80.879816,0,'2013-07-06 12:44:31',NULL,NULL),(25236,'28102','P','Mc Farlan','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',34.815409,-79.977442,0,'2013-07-06 12:44:31',NULL,NULL),(11792,'12220','P','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.664897,-73.883261,0,'2013-07-06 12:44:30',NULL,NULL),(7626,'07060','S','Plainfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.631340,-74.437020,0,'2013-07-06 12:44:30',NULL,NULL),(28848,'32091','S','Starke','D','Bradford','12007','Florida','FL','12','0000','904','Eastern',-5.0,'Y',29.949586,-82.112253,0,'2013-07-06 12:44:32',NULL,NULL),(25521,'28390','S','Olde Farm','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.175116,-78.976743,0,'2013-07-06 12:44:31',NULL,NULL),(68615,'81623','S','Crystal','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.416703,-107.189562,0,'2013-07-06 12:44:34',NULL,NULL),(72730,'89506','S','Black Springs','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(43035,'48174','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.215215,-83.344726,0,'2013-07-06 12:44:32',NULL,NULL),(8897,'08732','P','Island Hgts','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.994447,-74.119283,0,'2013-07-06 12:44:30',NULL,NULL),(19184,'19804','S','Stanton','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.724680,-75.606060,0,'2013-07-06 12:44:31',NULL,NULL),(5607,'04933','P','East Newport','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.820358,-69.224292,0,'2013-07-06 12:44:30',NULL,NULL),(21386,'22501','P','Ladysmith','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.016360,-77.517427,0,'2013-07-06 12:44:31',NULL,NULL),(75443,'94061','S','Redwood City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.462453,-122.234484,0,'2013-07-06 12:44:34',NULL,NULL),(63576,'75773','S','West Mineola','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.646900,-95.516460,0,'2013-07-06 12:44:34',NULL,NULL),(50906,'58552','S','Temvik','A','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.288980,-100.223580,0,'2013-07-06 12:44:33',NULL,NULL),(33614,'37656','S','Fall Branch','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.429658,-82.594132,0,'2013-07-06 12:44:32',NULL,NULL),(55294,'63530','S','Atlanta','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.928400,-92.451724,0,'2013-07-06 12:44:33',NULL,NULL),(34173,'38308','P','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.593630,-88.820531,0,'2013-07-06 12:44:32',NULL,NULL),(28643,'31760','P','Irwinville','D','Irwin','13155','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.656637,-83.410124,0,'2013-07-06 12:44:32',NULL,NULL),(53708,'62236','S','Columbia','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.441727,-90.205289,0,'2013-07-06 12:44:33',NULL,NULL),(45314,'50843','S','Cumberland','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.245510,-94.870675,0,'2013-07-06 12:44:32',NULL,NULL),(59583,'71001','S','Arcadia','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.553515,-92.922337,0,'2013-07-06 12:44:33',NULL,NULL),(74383,'92507','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.976325,-117.330414,0,'2013-07-06 12:44:34',NULL,NULL),(74906,'93312','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.386770,-119.173597,0,'2013-07-06 12:44:34',NULL,NULL),(62213,'73852','S','Mooreland','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.442238,-99.205025,0,'2013-07-06 12:44:33',NULL,NULL),(46191,'52747','S','Durant','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.600384,-90.909392,0,'2013-07-06 12:44:32',NULL,NULL),(4443,'03246','S','Laconia','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.551000,-71.427600,0,'2013-07-06 12:44:30',NULL,NULL),(31121,'33901','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628428,-81.867580,0,'2013-07-06 12:44:32',NULL,NULL),(54252,'62672','P','Nilwood','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.386383,-89.783350,0,'2013-07-06 12:44:33',NULL,NULL),(50057,'57438','S','Norbeck','A','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.035596,-99.120562,0,'2013-07-06 12:44:33',NULL,NULL),(41628,'47130','S','Jeff','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(33085,'36792','S','Randolph','D','Bibb','01007','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.890298,-86.904543,0,'2013-07-06 12:44:32',NULL,NULL),(63120,'75312','U','Mellon','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.769299,-96.827010,0,'2013-07-06 12:44:33',NULL,NULL),(6352,'05674','S','East Warren','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.129916,-72.879337,0,'2013-07-06 12:44:30',NULL,NULL),(49996,'57370','S','Shelby','N','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.777669,-99.173379,0,'2013-07-06 12:44:33',NULL,NULL),(5621,'04940','P','Farmington Falls','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.620574,-70.074052,0,'2013-07-06 12:44:30',NULL,NULL),(65347,'77520','S','Stewart Heights','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(29532,'32790','P','Winter Park','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.589404,-81.330445,0,'2013-07-06 12:44:32',NULL,NULL),(2068,'00921','S','College Park','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(13893,'14270','U','HSBC Bank','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870000,-78.832208,0,'2013-07-06 12:44:31',NULL,NULL),(25386,'28265','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.228515,-80.842113,0,'2013-07-06 12:44:31',NULL,NULL),(67077,'79602','S','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.429788,-99.719438,0,'2013-07-06 12:44:34',NULL,NULL),(64850,'77047','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.604738,-95.386165,0,'2013-07-06 12:44:34',NULL,NULL),(23377,'25303','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352660,-81.658500,0,'2013-07-06 12:44:31',NULL,NULL),(33453,'37317','S','Postelle','A','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',34.987120,-84.372874,0,'2013-07-06 12:44:32',NULL,NULL),(43219,'48309','S','Rochester Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657960,-83.186520,0,'2013-07-06 12:44:32',NULL,NULL),(35452,'39482','S','Sumrall','D','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.362960,-89.589180,0,'2013-07-06 12:44:32',NULL,NULL),(58060,'68042','S','Memphis','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.091772,-96.431850,0,'2013-07-06 12:44:33',NULL,NULL),(71140,'86028','P','Petrified For','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.791446,-109.878946,0,'2013-07-06 12:44:34',NULL,NULL),(34705,'38833','S','Burnsville','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.890120,-88.309221,0,'2013-07-06 12:44:32',NULL,NULL),(17023,'17745','S','Crestmont','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(52233,'60501','S','Summit Argo','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782868,-87.813794,0,'2013-07-06 12:44:33',NULL,NULL),(20383,'20886','S','Montgomry Vlg','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.170940,-77.209500,0,'2013-07-06 12:44:31',NULL,NULL),(2899,'00987','S','Urb Los Caciques','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(26598,'29228','P','Columbia Amf','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.920816,-81.090297,0,'2013-07-06 12:44:31',NULL,NULL),(19325,'20024','S','Ft L J McNair','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879013,-77.020737,0,'2013-07-06 12:44:31',NULL,NULL),(14565,'15215','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.503780,-79.912020,0,'2013-07-06 12:44:31',NULL,NULL),(65550,'77835','S','Burton','D','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.176176,-96.609965,0,'2013-07-06 12:44:34',NULL,NULL),(10605,'11040','S','N H P','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(72499,'89145','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.168465,-115.276824,0,'2013-07-06 12:44:34',NULL,NULL),(9682,'10043','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(53445,'61878','S','Thomasboro','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.242995,-88.181488,0,'2013-07-06 12:44:33',NULL,NULL),(2212,'00926','S','Sect Paracochero','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(43171,'48275','U','Comerica Incorporated','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.332231,-83.050280,0,'2013-07-06 12:44:32',NULL,NULL),(52421,'60647','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.918536,-87.698156,0,'2013-07-06 12:44:33',NULL,NULL),(13197,'13623','P','Chippewa Bay','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.440362,-75.753985,0,'2013-07-06 12:44:30',NULL,NULL),(25715,'28543','S','Jacksonville','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.734194,-77.377379,0,'2013-07-06 12:44:31',NULL,NULL),(59675,'71061','S','Oil City','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.749688,-93.980602,0,'2013-07-06 12:44:33',NULL,NULL),(57915,'67661','S','Stuttgart','A','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.757045,-99.325612,0,'2013-07-06 12:44:33',NULL,NULL),(19819,'20460','U','Envir Protect Agency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878225,-77.020008,0,'2013-07-06 12:44:31',NULL,NULL),(53306,'61737','S','Ellsworth','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.446184,-88.718903,0,'2013-07-06 12:44:33',NULL,NULL),(2780,'00976','S','Mans San Rafael','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(28242,'31055','S','Mc Rae','D','Telfair','13271','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.063143,-82.901568,0,'2013-07-06 12:44:31',NULL,NULL),(7673,'07094','S','Secaucus','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.789459,-74.062775,0,'2013-07-06 12:44:30',NULL,NULL),(69283,'83442','S','Annis','N','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.686480,-111.879600,0,'2013-07-06 12:44:34',NULL,NULL),(24278,'26855','S','Cabins','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.952589,-79.272273,0,'2013-07-06 12:44:31',NULL,NULL),(27848,'30434','S','Grange','N','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.000236,-82.407759,0,'2013-07-06 12:44:31',NULL,NULL),(39295,'44493','P','Winona','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.823075,-80.898260,0,'2013-07-06 12:44:32',NULL,NULL),(8122,'07826','S','Sandyston','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.191414,-74.750519,0,'2013-07-06 12:44:30',NULL,NULL),(9001,'08853','S','Branchburg','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.508543,-74.717562,0,'2013-07-06 12:44:30',NULL,NULL),(17524,'17970','S','Arnots Addition','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.746000,-76.208460,0,'2013-07-06 12:44:31',NULL,NULL),(79076,'98433','S','JB Lewis McChord','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(75676,'94550','S','Livermore','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.681436,-121.753052,0,'2013-07-06 12:44:34',NULL,NULL),(75008,'93455','S','Orcutt','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.838280,-120.403560,0,'2013-07-06 12:44:34',NULL,NULL),(53783,'62277','S','Prairie du Rocher','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.082633,-90.098910,0,'2013-07-06 12:44:33',NULL,NULL),(43884,'49229','S','Britton','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.984165,-83.839522,0,'2013-07-06 12:44:32',NULL,NULL),(70330,'84629','S','Birdseye','N','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(70727,'85297','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.316433,-111.712441,0,'2013-07-06 12:44:34',NULL,NULL),(60976,'72107','P','Menifee','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.146522,-92.553590,0,'2013-07-06 12:44:33',NULL,NULL),(57884,'67628','S','Cedar','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.662455,-98.927189,0,'2013-07-06 12:44:33',NULL,NULL),(42357,'47683','P','Somerville','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.280726,-87.379386,0,'2013-07-06 12:44:32',NULL,NULL),(29621,'32868','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.590178,-81.493630,0,'2013-07-06 12:44:32',NULL,NULL),(54230,'62659','S','Lincolns New Salem','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.010060,-89.849840,0,'2013-07-06 12:44:33',NULL,NULL),(58186,'68310','S','Holmesville','A','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(62506,'74369','S','Welch','D','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.876380,-95.089888,0,'2013-07-06 12:44:33',NULL,NULL),(75121,'93550','S','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.568461,-118.062387,0,'2013-07-06 12:44:34',NULL,NULL),(79182,'98524','S','Allyn','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.367860,-122.861977,0,'2013-07-06 12:44:34',NULL,NULL),(34636,'38762','S','Mnd Bayou','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.884479,-90.728270,0,'2013-07-06 12:44:32',NULL,NULL),(47154,'54466','S','Pray','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.448100,-90.177921,0,'2013-07-06 12:44:32',NULL,NULL),(21139,'22106','P','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.940842,-77.176143,0,'2013-07-06 12:44:31',NULL,NULL),(2682,'00968','S','Ext Alts de San Patricio','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(76729,'95901','S','Hallwood','N','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.215400,-121.463340,0,'2013-07-06 12:44:34',NULL,NULL),(56165,'64865','S','Seneca','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.839888,-94.609979,0,'2013-07-06 12:44:33',NULL,NULL),(39757,'45111','S','Loveland','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197180,-84.291954,0,'2013-07-06 12:44:32',NULL,NULL),(48639,'55812','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.811881,-92.075972,0,'2013-07-06 12:44:33',NULL,NULL),(73161,'90295','P','Venice','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.980879,-118.438136,0,'2013-07-06 12:44:34',NULL,NULL),(32138,'35456','S','Duncanville','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.094162,-87.445692,0,'2013-07-06 12:44:32',NULL,NULL),(51031,'58718','S','Lone Tree','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328239,-101.921232,0,'2013-07-06 12:44:33',NULL,NULL),(73026,'90072','P','Santa Western','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.097188,-118.309018,0,'2013-07-06 12:44:34',NULL,NULL),(74634,'92809','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.842578,-117.938803,0,'2013-07-06 12:44:34',NULL,NULL),(78088,'97477','S','Spfld','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.065622,-123.014262,0,'2013-07-06 12:44:34',NULL,NULL),(22654,'24266','S','Lebanon','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.890460,-82.084560,0,'2013-07-06 12:44:31',NULL,NULL),(7504,'06925','U','Conn Bank & Trust','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.042624,-73.558064,0,'2013-07-06 12:44:30',NULL,NULL),(38098,'43085','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098773,-83.017045,0,'2013-07-06 12:44:32',NULL,NULL),(68232,'81052','S','Prowers','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(23201,'25063','S','Elmira','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.567158,-80.975873,0,'2013-07-06 12:44:31',NULL,NULL),(20111,'20712','S','Mount Rainier','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.943335,-76.965412,0,'2013-07-06 12:44:31',NULL,NULL),(38051,'43046','S','Etna','A','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.898950,-82.526218,0,'2013-07-06 12:44:32',NULL,NULL),(40284,'45439','S','W Carrollton','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(46050,'52569','S','Melrose','D','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.975161,-93.052547,0,'2013-07-06 12:44:32',NULL,NULL),(50499,'58061','S','Mooreton','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.270018,-96.875133,0,'2013-07-06 12:44:33',NULL,NULL),(51961,'60140','S','Campton Hills','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.116520,-88.502220,0,'2013-07-06 12:44:33',NULL,NULL),(2150,'00924','S','Villa Olimpica','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(68152,'81001','S','Devine','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(56448,'65279','S','Woodlinville','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.000717,-92.518405,0,'2013-07-06 12:44:33',NULL,NULL),(22749,'24412','P','Bacova','D','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.054374,-79.846369,0,'2013-07-06 12:44:31',NULL,NULL),(60167,'71407','S','Prospect','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.483526,-92.497502,0,'2013-07-06 12:44:33',NULL,NULL),(42299,'47598','S','Ayrshire','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(48823,'56036','S','Glenville','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.571784,-93.274151,0,'2013-07-06 12:44:33',NULL,NULL),(52200,'60476','S','Thornton','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.571347,-87.610590,0,'2013-07-06 12:44:33',NULL,NULL),(78144,'97543','S','Grants Pass','A','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.439167,-123.327222,0,'2013-07-06 12:44:34',NULL,NULL),(76917,'96003','S','Redding','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.657200,-122.336820,0,'2013-07-06 12:44:34',NULL,NULL),(54487,'62863','S','Mount Carmel','D','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(51304,'59230','S','Glasgow','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.198389,-106.625201,0,'2013-07-06 12:44:33',NULL,NULL),(28041,'30655','S','Monroe','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.790908,-83.711688,0,'2013-07-06 12:44:31',NULL,NULL),(54932,'63109','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.586076,-90.295323,0,'2013-07-06 12:44:33',NULL,NULL),(59327,'70533','S','Erath','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.960100,-92.034375,0,'2013-07-06 12:44:33',NULL,NULL),(72547,'89191','P','Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.244017,-115.040965,0,'2013-07-06 12:44:34',NULL,NULL),(62942,'75098','S','St Paul','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.021961,-96.537200,0,'2013-07-06 12:44:33',NULL,NULL),(18073,'18705','S','Hudson','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(29783,'33015','S','Palm Springs North','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940770,-80.315677,0,'2013-07-06 12:44:32',NULL,NULL),(66475,'78661','P','Prairie Lea','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.732556,-97.753335,0,'2013-07-06 12:44:34',NULL,NULL),(63282,'75555','S','Bivins','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.939700,-94.147800,0,'2013-07-06 12:44:33',NULL,NULL),(55684,'64056','S','Sugar Creek','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.118237,-94.347327,0,'2013-07-06 12:44:33',NULL,NULL),(33433,'37302','S','Apison','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.013216,-85.015951,0,'2013-07-06 12:44:32',NULL,NULL),(35592,'39574','S','Saucier','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.600720,-89.112240,0,'2013-07-06 12:44:32',NULL,NULL),(8530,'08108','S','Haddon Twp','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.913768,-75.065877,0,'2013-07-06 12:44:30',NULL,NULL),(20432,'20916','P','Aspen Hill','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.084115,-77.079333,0,'2013-07-06 12:44:31',NULL,NULL),(11009,'11557','S','Hewlett','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.638779,-73.693176,0,'2013-07-06 12:44:30',NULL,NULL),(79276,'98576','S','Rainier','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.880851,-122.677494,0,'2013-07-06 12:44:34',NULL,NULL),(26737,'29419','P','North Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.936047,-80.100088,0,'2013-07-06 12:44:31',NULL,NULL),(18738,'19335','S','Downingtown','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.016500,-75.713718,0,'2013-07-06 12:44:31',NULL,NULL),(71157,'86035','P','Leupp','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',35.288132,-111.036784,0,'2013-07-06 12:44:34',NULL,NULL),(77618,'96952','P','Tinian','D','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',15.081686,145.652262,0,'2013-07-06 12:44:34',NULL,NULL),(59533,'70811','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.532352,-91.124008,0,'2013-07-06 12:44:33',NULL,NULL),(66234,'78567','P','Los Indios','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.096505,-97.669322,0,'2013-07-06 12:44:34',NULL,NULL),(26428,'29127','S','Slighs','N','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.182431,-81.520940,0,'2013-07-06 12:44:31',NULL,NULL),(66340,'78605','S','Tamega','N','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.745034,-98.053979,0,'2013-07-06 12:44:34',NULL,NULL),(70208,'84401','S','Ms City','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(62021,'73456','S','Ringling','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.179287,-97.610720,0,'2013-07-06 12:44:33',NULL,NULL),(36441,'40603','P','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.202865,-84.829522,0,'2013-07-06 12:44:32',NULL,NULL),(75092,'93536','S','Del Sur','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(64226,'76305','S','Cashion Community','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(12549,'13043','P','Clockville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.039802,-75.744094,0,'2013-07-06 12:44:30',NULL,NULL),(63216,'75452','S','Leonard','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.386190,-96.242571,0,'2013-07-06 12:44:33',NULL,NULL),(15910,'17015','S','West Pennsboro','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.201481,-77.189072,0,'2013-07-06 12:44:31',NULL,NULL),(1944,'00801','P','Charlotte Ama','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350000,-64.933333,0,'2013-07-06 12:44:30',NULL,NULL),(60747,'71970','S','Story','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.677222,-93.560177,0,'2013-07-06 12:44:33',NULL,NULL),(76899,'95982','S','Sutter','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.164282,-121.765471,0,'2013-07-06 12:44:34',NULL,NULL),(50589,'58236','S','Glasston','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.704570,-97.446544,0,'2013-07-06 12:44:33',NULL,NULL),(17852,'18428','S','Hawley','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.473980,-75.205080,0,'2013-07-06 12:44:31',NULL,NULL),(26696,'29406','S','No Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.928960,-80.028420,0,'2013-07-06 12:44:31',NULL,NULL),(22277,'23707','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.834117,-76.341740,0,'2013-07-06 12:44:31',NULL,NULL),(80039,'99697','P','Kodiak','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.412038,-153.537120,0,'2013-07-06 12:44:34',NULL,NULL),(74531,'92655','S','Midway City','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.744616,-117.984000,0,'2013-07-06 12:44:34',NULL,NULL),(71409,'87018','S','Counselor','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',36.141235,-106.934837,0,'2013-07-06 12:44:34',NULL,NULL),(37279,'41604','S','Beaver','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369321,-82.670590,0,'2013-07-06 12:44:32',NULL,NULL),(50673,'58341','S','Saundersville','N','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(60951,'72101','S','McCrory','A','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(20951,'21775','P','New Midway','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.556217,-77.302212,0,'2013-07-06 12:44:31',NULL,NULL),(40682,'46063','P','Orestes','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.269855,-85.730519,0,'2013-07-06 12:44:32',NULL,NULL),(1412,'00738','S','Urb Santa Isidra 1','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(10320,'10541','S','Lake Mahopac','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.378032,-73.749712,0,'2013-07-06 12:44:30',NULL,NULL),(57754,'67446','S','Glen Elder','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.498957,-98.305444,0,'2013-07-06 12:44:33',NULL,NULL),(56184,'65013','S','Summerfield','N','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(16122,'17057','S','H I A','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(24617,'27343','S','Semora','D','Person','37145','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.513121,-79.083162,0,'2013-07-06 12:44:31',NULL,NULL),(31635,'34714','S','Clermont','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.440119,-81.845959,0,'2013-07-06 12:44:32',NULL,NULL),(5795,'05060','S','W Brookfield','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.931946,-72.644794,0,'2013-07-06 12:44:30',NULL,NULL),(17375,'17884','P','Washingtonville','D','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.050669,-76.673774,0,'2013-07-06 12:44:31',NULL,NULL),(47413,'54655','S','Soldiers Grove','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.385327,-90.769115,0,'2013-07-06 12:44:32',NULL,NULL),(42853,'48079','S','Saint Clair Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.853850,-82.547092,0,'2013-07-06 12:44:32',NULL,NULL),(4730,'03830','S','E Wakefield','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.568056,-71.030556,0,'2013-07-06 12:44:30',NULL,NULL),(14770,'15342','S','Houston','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.240723,-80.216694,0,'2013-07-06 12:44:31',NULL,NULL),(61551,'72704','S','Wheeler','A','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.080874,-94.201559,0,'2013-07-06 12:44:33',NULL,NULL),(62320,'74041','S','Keifer','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.945888,-96.059791,0,'2013-07-06 12:44:33',NULL,NULL),(38381,'43506','S','Bryan','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.475430,-84.567219,0,'2013-07-06 12:44:32',NULL,NULL),(45211,'50632','S','Garwin','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.095421,-92.674244,0,'2013-07-06 12:44:32',NULL,NULL),(47014,'54306','P','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.519509,-88.017667,0,'2013-07-06 12:44:32',NULL,NULL),(38103,'43086','P','Westerville','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.117449,-82.916664,0,'2013-07-06 12:44:32',NULL,NULL),(57259,'66538','S','Seneca','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.836640,-96.061080,0,'2013-07-06 12:44:33',NULL,NULL),(59567,'70837','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.550769,-91.203604,0,'2013-07-06 12:44:33',NULL,NULL),(57694,'67278','P','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.693020,-97.337204,0,'2013-07-06 12:44:33',NULL,NULL),(58518,'68779','S','Stanton','D','Stanton','31167','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.952724,-97.226120,0,'2013-07-06 12:44:33',NULL,NULL),(72572,'89319','P','Ruth','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.278199,-114.991266,0,'2013-07-06 12:44:34',NULL,NULL),(62475,'74344','S','Grove','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.589899,-94.772190,0,'2013-07-06 12:44:33',NULL,NULL),(61645,'72853','S','Ola','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.044570,-93.182835,0,'2013-07-06 12:44:33',NULL,NULL),(35405,'39463','P','Nicholson','D','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.557662,-89.644314,0,'2013-07-06 12:44:32',NULL,NULL),(45080,'50528','S','Cylinder','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.090244,-94.550554,0,'2013-07-06 12:44:32',NULL,NULL),(61560,'72718','S','Cave Springs','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.275844,-94.203808,0,'2013-07-06 12:44:33',NULL,NULL),(31256,'33983','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.003613,-82.013836,0,'2013-07-06 12:44:32',NULL,NULL),(44457,'49876','S','Quinnesec','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.803607,-87.991164,0,'2013-07-06 12:44:32',NULL,NULL),(63155,'75389','U','PNC Bank','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770456,-96.687485,0,'2013-07-06 12:44:33',NULL,NULL),(58175,'68305','S','Auburn','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.390284,-95.842607,0,'2013-07-06 12:44:33',NULL,NULL),(60221,'71426','P','Fisher','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498074,-93.469893,0,'2013-07-06 12:44:33',NULL,NULL),(56905,'66047','S','Laurence','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.946781,-95.281917,0,'2013-07-06 12:44:33',NULL,NULL),(35431,'39475','S','Purvis','D','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.065616,-89.289840,0,'2013-07-06 12:44:32',NULL,NULL),(48109,'55349','S','Howard Lake','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.056504,-94.066174,0,'2013-07-06 12:44:33',NULL,NULL),(46927,'54154','S','Oconto Falls','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.874146,-88.164099,0,'2013-07-06 12:44:32',NULL,NULL),(39346,'44624','S','Dundee','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.656300,-81.691080,0,'2013-07-06 12:44:32',NULL,NULL),(78300,'97901','S','Adrian','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.676162,-117.058271,0,'2013-07-06 12:44:34',NULL,NULL),(4766,'03856','S','Newfields','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.037881,-70.937307,0,'2013-07-06 12:44:30',NULL,NULL),(40440,'45721','S','Coal Run','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.567042,-81.582359,0,'2013-07-06 12:44:32',NULL,NULL),(25229,'28092','S','Boger City','A','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485140,-81.223860,0,'2013-07-06 12:44:31',NULL,NULL),(14051,'14563','P','Union Hill','D','Wayne','36117','New York','NY','36','6840','716','Eastern',-5.0,'Y',43.223103,-77.371355,0,'2013-07-06 12:44:31',NULL,NULL),(13862,'14228','S','W Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.025880,-78.795360,0,'2013-07-06 12:44:31',NULL,NULL),(14840,'15439','P','Gans','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.733333,-79.866667,0,'2013-07-06 12:44:31',NULL,NULL),(71343,'86512','P','Burnt Water','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.206267,-109.332901,0,'2013-07-06 12:44:34',NULL,NULL),(71337,'86510','P','Pinon','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.959054,-110.308821,0,'2013-07-06 12:44:34',NULL,NULL),(62596,'74501','S','McAlester','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.935281,-95.767139,0,'2013-07-06 12:44:33',NULL,NULL),(56288,'65076','S','Saint Thomas','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.507852,-92.441678,0,'2013-07-06 12:44:33',NULL,NULL),(24095,'26505','S','Star City','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.636473,-79.951111,0,'2013-07-06 12:44:31',NULL,NULL),(38666,'43948','P','Smithfield','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.274706,-80.782000,0,'2013-07-06 12:44:32',NULL,NULL),(16888,'17578','S','Redrun','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.241389,-76.174444,0,'2013-07-06 12:44:31',NULL,NULL),(47177,'54481','S','Dewey','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(54084,'62521','S','Long Creek','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.827104,-88.924086,0,'2013-07-06 12:44:33',NULL,NULL),(28229,'31040','P','Dublin','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.547937,-82.901637,0,'2013-07-06 12:44:31',NULL,NULL),(53475,'61937','S','Lovington','D','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.711745,-88.639682,0,'2013-07-06 12:44:33',NULL,NULL),(58915,'69333','S','Survey','N','Grant','31075','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.908275,-101.952587,0,'2013-07-06 12:44:33',NULL,NULL),(25840,'28622','S','Darkridge','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.175674,-81.955170,0,'2013-07-06 12:44:31',NULL,NULL),(7821,'07456','S','Skyline Lakes','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.100840,-74.290260,0,'2013-07-06 12:44:30',NULL,NULL),(4290,'02898','S','Wyoming','D','Washington','44009','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.523074,-71.691005,0,'2013-07-06 12:44:30',NULL,NULL),(64759,'76939','P','Knickerbocker','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.267109,-100.624006,0,'2013-07-06 12:44:34',NULL,NULL),(38219,'43220','S','Upper Arlngtn','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.000000,-83.066667,0,'2013-07-06 12:44:32',NULL,NULL),(4220,'02841','S','Netc','N','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.528420,-71.310732,0,'2013-07-06 12:44:30',NULL,NULL),(21202,'22193','S','Woodbridge','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.646162,-77.349693,0,'2013-07-06 12:44:31',NULL,NULL),(16437,'17233','S','Webster Mills','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(69323,'83469','S','Shoup','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.107842,-114.434070,0,'2013-07-06 12:44:34',NULL,NULL),(35400,'39462','S','Belleville','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.291608,-89.067446,0,'2013-07-06 12:44:32',NULL,NULL),(39052,'44192','U','Huntington Bank','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.501720,-81.686437,0,'2013-07-06 12:44:32',NULL,NULL),(24911,'27722','P','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.996965,-78.899565,0,'2013-07-06 12:44:31',NULL,NULL),(469,'00664','S','Urb La Monserrate','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(32433,'35987','S','Steele','D','Saint Clair','01115','Alabama','AL','01','1000','256','Central',-6.0,'Y',33.928976,-86.174926,0,'2013-07-06 12:44:32',NULL,NULL),(46312,'53066','S','Oconomowoc','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.105369,-88.479152,0,'2013-07-06 12:44:32',NULL,NULL),(30427,'33328','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.066580,-80.272800,0,'2013-07-06 12:44:32',NULL,NULL),(67580,'80310','U','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.009234,-105.269921,0,'2013-07-06 12:44:34',NULL,NULL),(45440,'51109','S','Blvd Station','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.515558,-96.478357,0,'2013-07-06 12:44:32',NULL,NULL),(43344,'48380','S','Milford Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.585954,-83.650740,0,'2013-07-06 12:44:32',NULL,NULL),(22906,'24602','S','Bandy','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.175946,-81.666701,0,'2013-07-06 12:44:31',NULL,NULL),(29795,'33020','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.016843,-80.151080,0,'2013-07-06 12:44:32',NULL,NULL),(24674,'27409','S','Guilford','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.093667,-79.927798,0,'2013-07-06 12:44:31',NULL,NULL),(29573,'32817','S','Union Park','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.582385,-81.251475,0,'2013-07-06 12:44:32',NULL,NULL),(69699,'84032','S','Charleston','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(61751,'73045','S','Harrah','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.504304,-97.150314,0,'2013-07-06 12:44:33',NULL,NULL),(59507,'70778','S','Sorrento','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.183229,-90.864373,0,'2013-07-06 12:44:33',NULL,NULL),(58154,'68176','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260689,-95.940590,0,'2013-07-06 12:44:33',NULL,NULL),(21468,'22627','S','Huntly','A','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.730956,-78.064789,0,'2013-07-06 12:44:31',NULL,NULL),(8442,'08085','S','Logan','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(50303,'57702','S','Silver City','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.063037,-103.280916,0,'2013-07-06 12:44:33',NULL,NULL),(14504,'15201','S','Arsenal','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.470679,-79.954348,0,'2013-07-06 12:44:31',NULL,NULL),(23768,'25969','S','Jumping Branch','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.611675,-81.019615,0,'2013-07-06 12:44:31',NULL,NULL),(24953,'27832','S','Gaston','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.488044,-77.622501,0,'2013-07-06 12:44:31',NULL,NULL),(41748,'47274','S','Seymour','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.959237,-85.892632,0,'2013-07-06 12:44:32',NULL,NULL),(30095,'33157','S','Village of Palmetto Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(29134,'32324','S','Chattahoochee','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.692351,-84.842278,0,'2013-07-06 12:44:32',NULL,NULL),(1157,'00727','S','Repto San Jose','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(68447,'81226','S','Florence','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.370060,-105.119760,0,'2013-07-06 12:44:34',NULL,NULL),(34131,'38220','S','Atwood','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.011358,-88.715032,0,'2013-07-06 12:44:32',NULL,NULL),(52773,'61262','S','Lynn Center','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.287020,-90.332520,0,'2013-07-06 12:44:33',NULL,NULL),(29980,'33093','P','CoconutCreek','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.252723,-80.209522,0,'2013-07-06 12:44:32',NULL,NULL),(63744,'75935','S','Waterman','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(3170,'01270','S','Windsor','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.336404,-73.254387,0,'2013-07-06 12:44:30',NULL,NULL),(10367,'10583','S','Scarsdale Park','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.989799,-73.800070,0,'2013-07-06 12:44:30',NULL,NULL),(4167,'02791','P','Westport Point','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.523309,-71.077717,0,'2013-07-06 12:44:30',NULL,NULL),(53857,'62329','P','Niota','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.598632,-91.137878,0,'2013-07-06 12:44:33',NULL,NULL),(20092,'20701','S','Annapolis Jct','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.121614,-76.790430,0,'2013-07-06 12:44:31',NULL,NULL),(44186,'49610','P','Acme','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.793024,-85.494568,0,'2013-07-06 12:44:32',NULL,NULL),(61309,'72432','S','Harrisburg','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.561729,-90.722150,0,'2013-07-06 12:44:33',NULL,NULL),(30088,'33156','S','Village of Pinecrest','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(26921,'29583','S','Pamplico','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.993369,-79.568322,0,'2013-07-06 12:44:31',NULL,NULL),(70755,'85325','P','Bouse','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.931773,-114.003599,0,'2013-07-06 12:44:34',NULL,NULL),(58866,'69152','S','Mullen','D','Hooker','31091','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.040896,-101.045057,0,'2013-07-06 12:44:33',NULL,NULL),(22924,'24614','S','Royal City','N','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.277524,-82.094356,0,'2013-07-06 12:44:31',NULL,NULL),(40498,'45805','S','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.738328,-84.157022,0,'2013-07-06 12:44:32',NULL,NULL),(30707,'33493','S','South Bay','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.672694,-80.716833,0,'2013-07-06 12:44:32',NULL,NULL),(19738,'20404','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897713,-77.008867,0,'2013-07-06 12:44:31',NULL,NULL),(49884,'57265','S','Strandburg','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.017187,-96.820946,0,'2013-07-06 12:44:33',NULL,NULL),(76750,'95919','S','Brownsville','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.446774,-121.268502,0,'2013-07-06 12:44:34',NULL,NULL),(62573,'74459','P','Rentiesville','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.521333,-95.492865,0,'2013-07-06 12:44:33',NULL,NULL),(37242,'41553','S','Paw Paw','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492791,-82.167535,0,'2013-07-06 12:44:32',NULL,NULL),(15921,'17019','S','Dillsburg','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.098851,-77.022403,0,'2013-07-06 12:44:31',NULL,NULL),(23130,'24970','S','Ronceverte','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.752172,-80.467326,0,'2013-07-06 12:44:31',NULL,NULL),(57907,'67653','S','Norcatur','D','Decatur','20039','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.837957,-100.189517,0,'2013-07-06 12:44:33',NULL,NULL),(4258,'02879','S','S Kingstown','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(19582,'20218','U','Natl Comm on Social Sec','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891183,-76.942515,0,'2013-07-06 12:44:31',NULL,NULL),(30955,'33733','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770605,-82.677731,0,'2013-07-06 12:44:32',NULL,NULL),(47577,'54846','S','Marengo','A','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.381203,-90.737197,0,'2013-07-06 12:44:33',NULL,NULL),(2802,'00976','S','Urb Pacifica','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(73100,'90233','P','Culver City','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.983732,-118.391412,0,'2013-07-06 12:44:34',NULL,NULL),(64580,'76667','S','Mexia','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(22670,'24290','S','Weber City','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.619532,-82.559995,0,'2013-07-06 12:44:31',NULL,NULL),(23426,'25362','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.396951,-81.586751,0,'2013-07-06 12:44:31',NULL,NULL),(44773,'50211','S','Churchville','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.464165,-93.687138,0,'2013-07-06 12:44:32',NULL,NULL),(14107,'14626','S','Ridgemont','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.209740,-77.703726,0,'2013-07-06 12:44:31',NULL,NULL),(60351,'71469','S','Fort Jessup','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(11304,'11778','S','Rocky Point','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.949705,-72.936420,0,'2013-07-06 12:44:30',NULL,NULL),(42121,'47470','S','Williams','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.770024,-86.627519,0,'2013-07-06 12:44:32',NULL,NULL),(17068,'17756','S','Seagers','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(19167,'19725','U','Shared Firm Zip','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.685667,-75.737283,0,'2013-07-06 12:44:31',NULL,NULL),(43689,'48881','S','Saranac','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',42.927301,-85.208744,0,'2013-07-06 12:44:32',NULL,NULL),(79886,'99576','P','Koliganek','A','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.070280,-160.266870,0,'2013-07-06 12:44:34',NULL,NULL),(16527,'17268','S','Pennersville','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(54847,'63040','S','Lake Chesterfield','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576576,-90.628174,0,'2013-07-06 12:44:33',NULL,NULL),(59204,'70390','S','Napoleonville','D','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.908160,-91.027806,0,'2013-07-06 12:44:33',NULL,NULL),(75197,'93621','S','Dunlap','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.730872,-119.108608,0,'2013-07-06 12:44:34',NULL,NULL),(61605,'72770','P','Tontitown','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.187972,-94.227786,0,'2013-07-06 12:44:33',NULL,NULL),(18318,'19022','S','Chester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862914,-75.343388,0,'2013-07-06 12:44:31',NULL,NULL),(20831,'21634','S','Hoopersville','N','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.299500,-76.204800,0,'2013-07-06 12:44:31',NULL,NULL),(67870,'80831','S','Falcon','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.989980,-104.505180,0,'2013-07-06 12:44:34',NULL,NULL),(64774,'77002','S','Clutch City','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757918,-95.361884,0,'2013-07-06 12:44:34',NULL,NULL),(44626,'50062','S','Melcher Dallas','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.232661,-93.237493,0,'2013-07-06 12:44:32',NULL,NULL),(75457,'94080','S','South San Francisco','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.652366,-122.430543,0,'2013-07-06 12:44:34',NULL,NULL),(20727,'21286','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.406546,-76.581702,0,'2013-07-06 12:44:31',NULL,NULL),(15007,'15666','S','Mt Pleasant','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.151156,-79.543060,0,'2013-07-06 12:44:31',NULL,NULL),(55660,'64024','S','Wood Heights','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(59868,'71263','S','Goodwill','N','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.840160,-91.467780,0,'2013-07-06 12:44:33',NULL,NULL),(70254,'84501','S','Carbonville','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.359940,-110.944560,0,'2013-07-06 12:44:34',NULL,NULL),(9872,'10122','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(11945,'12440','S','High Falls','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.820309,-74.126454,0,'2013-07-06 12:44:30',NULL,NULL),(24010,'26354','S','Grafton','D','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.343632,-80.022519,0,'2013-07-06 12:44:31',NULL,NULL),(30011,'33128','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.773953,-80.207889,0,'2013-07-06 12:44:32',NULL,NULL),(66509,'78703','S','Tarrytown','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.294325,-97.763573,0,'2013-07-06 12:44:34',NULL,NULL),(32637,'36204','P','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.684768,-85.822124,0,'2013-07-06 12:44:32',NULL,NULL),(1771,'00780','S','Urb Santa Rita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(80081,'99736','P','Deering','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.784125,-163.015543,0,'2013-07-06 12:44:34',NULL,NULL),(78485,'98103','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.671009,-122.340102,0,'2013-07-06 12:44:34',NULL,NULL),(54392,'62819','S','Buckner','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.983174,-89.013020,0,'2013-07-06 12:44:33',NULL,NULL),(69511,'83716','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.531746,-116.140200,0,'2013-07-06 12:44:34',NULL,NULL),(70817,'85379','S','Surprise','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.619029,-112.409147,0,'2013-07-06 12:44:34',NULL,NULL),(7068,'06336','S','Gilman','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.580991,-72.198310,0,'2013-07-06 12:44:30',NULL,NULL),(16795,'17540','S','Bareville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.095709,-76.185401,0,'2013-07-06 12:44:31',NULL,NULL),(50078,'57452','S','Java','D','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.419759,-99.810831,0,'2013-07-06 12:44:33',NULL,NULL),(55474,'63747','S','Perryville','A','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.556658,-89.843268,0,'2013-07-06 12:44:33',NULL,NULL),(21857,'23147','P','Ruthville','D','Charles City','51036','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.367235,-77.041322,0,'2013-07-06 12:44:31',NULL,NULL),(11827,'12240','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651487,-73.756900,0,'2013-07-06 12:44:30',NULL,NULL),(34163,'38261','S','Union City','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.424975,-89.056137,0,'2013-07-06 12:44:32',NULL,NULL),(35678,'39656','S','Oak Vale','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.439273,-90.000185,0,'2013-07-06 12:44:32',NULL,NULL),(37685,'42223','S','Fort Campbell','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.654747,-87.462668,0,'2013-07-06 12:44:32',NULL,NULL),(67459,'80216','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.784552,-104.964547,0,'2013-07-06 12:44:34',NULL,NULL),(72760,'89512','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.549890,-119.797993,0,'2013-07-06 12:44:34',NULL,NULL),(52135,'60435','S','Cresthill','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.552040,-88.111620,0,'2013-07-06 12:44:33',NULL,NULL),(75891,'94965','S','Sausalito','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.865100,-122.530980,0,'2013-07-06 12:44:34',NULL,NULL),(75571,'94273','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587118,-121.494479,0,'2013-07-06 12:44:34',NULL,NULL),(60756,'72001','S','Adona','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.047793,-92.905101,0,'2013-07-06 12:44:33',NULL,NULL),(59192,'70361','P','Houma','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.598605,-90.721756,0,'2013-07-06 12:44:33',NULL,NULL),(24919,'27804','S','Wesleyan College','A','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.974314,-77.831514,0,'2013-07-06 12:44:31',NULL,NULL),(56021,'64667','S','Newtown','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.345569,-93.268683,0,'2013-07-06 12:44:33',NULL,NULL),(55903,'64437','S','Fortescue','A','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.156812,-95.358379,0,'2013-07-06 12:44:33',NULL,NULL),(45804,'52175','S','Auburn Douglas','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.969660,-91.800840,0,'2013-07-06 12:44:32',NULL,NULL),(76322,'95458','S','Lucerne','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.076936,-122.782553,0,'2013-07-06 12:44:34',NULL,NULL),(72319,'89003','P','Beatty','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.876924,-116.730966,0,'2013-07-06 12:44:34',NULL,NULL),(64189,'76240','S','Oak Ridge','A','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.621754,-97.121151,0,'2013-07-06 12:44:34',NULL,NULL),(17724,'18245','P','Quakake','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.841272,-75.984822,0,'2013-07-06 12:44:31',NULL,NULL),(29914,'33055','S','Opa Locka','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.943016,-80.276516,0,'2013-07-06 12:44:32',NULL,NULL),(35029,'39160','S','Sallis','D','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.978934,-89.780790,0,'2013-07-06 12:44:32',NULL,NULL),(42987,'48152','S','Livonia','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.423546,-83.372611,0,'2013-07-06 12:44:32',NULL,NULL),(27835,'30415','S','Stilson','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(72670,'89439','P','Verdi','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.516463,-119.980547,0,'2013-07-06 12:44:34',NULL,NULL),(51723,'60010','S','Port Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(13878,'14261','U','Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.002450,-78.781965,0,'2013-07-06 12:44:31',NULL,NULL),(62876,'75045','P','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.945848,-96.682933,0,'2013-07-06 12:44:33',NULL,NULL),(62438,'74171','U','Oral Roberts Univ','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.149777,-95.995378,0,'2013-07-06 12:44:33',NULL,NULL),(58078,'68064','S','Valley','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.312896,-96.347618,0,'2013-07-06 12:44:33',NULL,NULL),(58025,'67954','S','Rolla','D','Morton','20129','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.117068,-101.630756,0,'2013-07-06 12:44:33',NULL,NULL),(37148,'41465','S','Lickburg','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(20588,'21161','S','White Hall','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.651440,-76.571490,0,'2013-07-06 12:44:31',NULL,NULL),(52768,'61258','S','Hooppole','D','Henry','17073','Illinois','IL','17','1960','815/779','Central',-6.0,'Y',41.524393,-89.911984,0,'2013-07-06 12:44:33',NULL,NULL),(67466,'80221','S','Federal Hgts','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(3483,'01833','S','Haverhill','A','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.724680,-70.975800,0,'2013-07-06 12:44:30',NULL,NULL),(36567,'40935','S','Salt Gum','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834317,-83.759584,0,'2013-07-06 12:44:32',NULL,NULL),(27535,'30223','S','Griffin','D','Spalding','13255','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.292686,-84.261559,0,'2013-07-06 12:44:31',NULL,NULL),(50255,'57633','S','Firesteel','A','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.392234,-101.430938,0,'2013-07-06 12:44:33',NULL,NULL),(68547,'81425','S','Olathe','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.602831,-107.999572,0,'2013-07-06 12:44:34',NULL,NULL),(26846,'29510','S','Andrews','D','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.448476,-79.555913,0,'2013-07-06 12:44:31',NULL,NULL),(30800,'33608','P','Macdill AFB','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.841617,-82.513107,0,'2013-07-06 12:44:32',NULL,NULL),(8875,'08691','S','Uppr Free Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(9565,'10025','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(9899,'10129','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755624,-73.990453,0,'2013-07-06 12:44:30',NULL,NULL),(27977,'30567','S','Pendergrass','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.207969,-83.746626,0,'2013-07-06 12:44:31',NULL,NULL),(1778,'00782','S','Comerio','D','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(11819,'12236','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651877,-73.758413,0,'2013-07-06 12:44:30',NULL,NULL),(29066,'32247','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.297084,-81.635006,0,'2013-07-06 12:44:32',NULL,NULL),(68881,'82649','S','Shoshoni','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.215469,-108.206055,0,'2013-07-06 12:44:34',NULL,NULL),(3098,'01225','S','Cheshire','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.555166,-73.156002,0,'2013-07-06 12:44:30',NULL,NULL),(6673,'06032','S','The Exchange at Talcott Vill','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.725812,-72.835995,0,'2013-07-06 12:44:30',NULL,NULL),(27081,'29704','S','Catawba','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.845853,-80.933937,0,'2013-07-06 12:44:31',NULL,NULL),(33738,'37826','S','Niota','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.509859,-84.545622,0,'2013-07-06 12:44:32',NULL,NULL),(64864,'77058','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.553866,-95.095044,0,'2013-07-06 12:44:34',NULL,NULL),(64475,'76578','S','Thrall','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.588909,-97.293903,0,'2013-07-06 12:44:34',NULL,NULL),(64278,'76432','S','Blanket','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.824212,-98.786390,0,'2013-07-06 12:44:34',NULL,NULL),(25151,'28025','S','Concord','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.400953,-80.583807,0,'2013-07-06 12:44:31',NULL,NULL),(4321,'02915','S','Riverside','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.785200,-71.407260,0,'2013-07-06 12:44:30',NULL,NULL),(45617,'51575','S','Treynor','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.230035,-95.606640,0,'2013-07-06 12:44:32',NULL,NULL),(20842,'21647','S','McDaniel','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.817195,-76.290465,0,'2013-07-06 12:44:31',NULL,NULL),(6528,'05828','S','Danville','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.438199,-72.114702,0,'2013-07-06 12:44:30',NULL,NULL),(78637,'98221','S','Guemes Island','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.498900,-122.607300,0,'2013-07-06 12:44:34',NULL,NULL),(42012,'47432','S','French Lick','D','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.545144,-86.619616,0,'2013-07-06 12:44:32',NULL,NULL),(45571,'51528','S','Buck Grove','N','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.925696,-95.476441,0,'2013-07-06 12:44:32',NULL,NULL),(28353,'31202','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.834051,-83.632207,0,'2013-07-06 12:44:32',NULL,NULL),(70705,'85268','S','Scottsdale','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.608995,-111.729537,0,'2013-07-06 12:44:34',NULL,NULL),(18935,'19506','S','Bernville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.448100,-76.133040,0,'2013-07-06 12:44:31',NULL,NULL),(16224,'17074','S','Montgomery Fy','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(14545,'15210','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.404900,-79.972620,0,'2013-07-06 12:44:31',NULL,NULL),(47932,'55113','S','Little Canada','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(24028,'26378','S','Jane Lew','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.117304,-80.435643,0,'2013-07-06 12:44:31',NULL,NULL),(63850,'75977','S','Farrsville','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(59897,'71275','S','Simsboro','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.530470,-92.786586,0,'2013-07-06 12:44:33',NULL,NULL),(56364,'65211','U','University of Missouri','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.948231,-92.327335,0,'2013-07-06 12:44:33',NULL,NULL),(28977,'32210','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.260733,-81.746664,0,'2013-07-06 12:44:32',NULL,NULL),(34309,'38550','P','Campaign','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.713000,-85.603449,0,'2013-07-06 12:44:32',NULL,NULL),(4182,'02815','S','Clayville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.794176,-71.652718,0,'2013-07-06 12:44:30',NULL,NULL),(17150,'17801','S','Sunbury','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(55623,'63965','S','Garwood','N','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(78802,'98326','S','Lake Ozette','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.171357,-124.279900,0,'2013-07-06 12:44:34',NULL,NULL),(78198,'97735','P','Fort Rock','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.524354,-121.168581,0,'2013-07-06 12:44:34',NULL,NULL),(44496,'49919','S','Covington','D','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.548312,-88.513722,0,'2013-07-06 12:44:32',NULL,NULL),(28375,'31295','U','Geico Underwriting','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.810582,-83.571041,0,'2013-07-06 12:44:32',NULL,NULL),(19219,'19895','U','Delmarva Power','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743840,-75.549474,0,'2013-07-06 12:44:31',NULL,NULL),(28961,'32202','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.328103,-81.654825,0,'2013-07-06 12:44:32',NULL,NULL),(76697,'95826','S','Walsh Station','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.551130,-121.368699,0,'2013-07-06 12:44:34',NULL,NULL),(73467,'91307','S','West Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201920,-118.660980,0,'2013-07-06 12:44:34',NULL,NULL),(70484,'84770','S','Diamond Valley','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(60447,'71647','S','Vick','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(76743,'95915','P','Caribou','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.006111,-121.248056,0,'2013-07-06 12:44:34',NULL,NULL),(48008,'55168','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.945948,-93.091123,0,'2013-07-06 12:44:33',NULL,NULL),(29182,'32395','U','Florida State Lottery','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430504,-84.258788,0,'2013-07-06 12:44:32',NULL,NULL),(79447,'98844','S','Molson','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.946111,-119.050278,0,'2013-07-06 12:44:34',NULL,NULL),(63547,'75764','P','Gallatin','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.894007,-95.155587,0,'2013-07-06 12:44:33',NULL,NULL),(59484,'70759','S','Morganza','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.690421,-91.610359,0,'2013-07-06 12:44:33',NULL,NULL),(62459,'74331','S','Bernice','A','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(38882,'44107','S','Lakewood','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.482343,-81.794563,0,'2013-07-06 12:44:32',NULL,NULL),(54793,'63013','S','Beaufort','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.420673,-91.184590,0,'2013-07-06 12:44:33',NULL,NULL),(53754,'62262','S','Mulberry Grove','D','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.924180,-89.270352,0,'2013-07-06 12:44:33',NULL,NULL),(48573,'55771','S','Buyck','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(73900,'92007','S','Cardiff','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.020814,-117.267083,0,'2013-07-06 12:44:34',NULL,NULL),(14575,'15217','S','Squirrel Hill','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.428877,-79.923209,0,'2013-07-06 12:44:31',NULL,NULL),(39868,'45204','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.099986,-84.570300,0,'2013-07-06 12:44:32',NULL,NULL),(17116,'17772','S','Anthony','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.100974,-76.773819,0,'2013-07-06 12:44:31',NULL,NULL),(51412,'59440','S','Floweree','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.655537,-111.198143,0,'2013-07-06 12:44:33',NULL,NULL),(6776,'06101','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788224,-72.665673,0,'2013-07-06 12:44:30',NULL,NULL),(18066,'18704','S','Forty Fort','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(16616,'17331','S','Hanover','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(56206,'65026','S','Eldon','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(57927,'67673','S','Waldo','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.045196,-98.762026,0,'2013-07-06 12:44:33',NULL,NULL),(7662,'07087','S','Bergenline','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.770419,-74.030901,0,'2013-07-06 12:44:30',NULL,NULL),(30152,'33168','S','North Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.875268,-80.201839,0,'2013-07-06 12:44:32',NULL,NULL),(32104,'35297','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.493207,-86.781750,0,'2013-07-06 12:44:32',NULL,NULL),(19160,'19718','U','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.666500,-75.707524,0,'2013-07-06 12:44:31',NULL,NULL),(9468,'10009','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(37052,'41301','S','Flat','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(35410,'39465','S','Petal','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.340040,-89.189100,0,'2013-07-06 12:44:32',NULL,NULL),(5175,'04434','S','Etna','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.784792,-69.133257,0,'2013-07-06 12:44:30',NULL,NULL),(43455,'48532','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.007712,-83.774965,0,'2013-07-06 12:44:32',NULL,NULL),(34930,'38967','S','Winona','D','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.483835,-89.732137,0,'2013-07-06 12:44:32',NULL,NULL),(78767,'98310','S','Brownsville','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(63733,'75934','P','Lily Island','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.917797,-94.735098,0,'2013-07-06 12:44:34',NULL,NULL),(36904,'41128','P','Carter','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.427399,-83.119767,0,'2013-07-06 12:44:32',NULL,NULL),(54399,'62822','S','Christopher','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.973941,-89.051983,0,'2013-07-06 12:44:33',NULL,NULL),(32642,'36205','S','Ft McClellan','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.659722,-85.831667,0,'2013-07-06 12:44:32',NULL,NULL),(32166,'35475','S','Northport','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.245390,-87.594372,0,'2013-07-06 12:44:32',NULL,NULL),(71771,'87556','S','Columbine','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.718233,-105.599120,0,'2013-07-06 12:44:34',NULL,NULL),(70209,'84401','S','MSC','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(33584,'37601','S','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.331192,-82.359362,0,'2013-07-06 12:44:32',NULL,NULL),(28416,'31323','S','South Newport','N','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.726286,-81.469983,0,'2013-07-06 12:44:32',NULL,NULL),(75600,'94303','S','East Palo Alto','A','Santa Clara','06085','California','CA','06','7360','650','Pacific',-8.0,'Y',37.449360,-122.125260,0,'2013-07-06 12:44:34',NULL,NULL),(68707,'82063','S','Jelm','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',40.912373,-105.868056,0,'2013-07-06 12:44:34',NULL,NULL),(66124,'78419','S','Corpus Christi Army Depot','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693737,-97.264702,0,'2013-07-06 12:44:34',NULL,NULL),(15441,'16401','S','Conneaut Twp','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(17809,'18407','S','Clifford Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(21252,'22301','S','Potomac','A','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.819280,-77.064236,0,'2013-07-06 12:44:31',NULL,NULL),(1454,'00742','P','Roosevelt Roads','D','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.238935,-65.627433,0,'2013-07-06 12:44:30',NULL,NULL),(50535,'58109','P','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.808187,-96.862280,0,'2013-07-06 12:44:33',NULL,NULL),(52269,'60525','S','Indianhead Park','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(13545,'13830','S','Brisben','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(53673,'62217','S','Baldwin','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.185160,-89.845373,0,'2013-07-06 12:44:33',NULL,NULL),(63976,'76106','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.799177,-97.358089,0,'2013-07-06 12:44:34',NULL,NULL),(63752,'75939','S','Corrigan','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(25752,'28579','S','Smyrna','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.800896,-76.512781,0,'2013-07-06 12:44:31',NULL,NULL),(78719,'98276','S','Nooksack','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.929523,-122.320315,0,'2013-07-06 12:44:34',NULL,NULL),(25071,'27942','S','Harrellsville','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.286859,-76.770668,0,'2013-07-06 12:44:31',NULL,NULL),(25405,'28288','U','Wachovia Bank','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229166,-80.841138,0,'2013-07-06 12:44:31',NULL,NULL),(45468,'51249','S','Cloverdale','N','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.403910,-95.746853,0,'2013-07-06 12:44:32',NULL,NULL),(15220,'16020','S','Boyers','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.110539,-79.900944,0,'2013-07-06 12:44:31',NULL,NULL),(55026,'63136','S','Dellwood','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(28688,'31804','S','Cataula','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.640908,-84.902010,0,'2013-07-06 12:44:32',NULL,NULL),(55145,'63361','S','Montgomery','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(77278,'96613','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60922,'72082','S','Kensen','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.232917,-91.670949,0,'2013-07-06 12:44:33',NULL,NULL),(35707,'39667','S','Dexter','N','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(40420,'45693','S','West Union','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.797727,-83.527461,0,'2013-07-06 12:44:32',NULL,NULL),(9710,'10069','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.770156,-73.988079,0,'2013-07-06 12:44:30',NULL,NULL),(164,'00623','S','Alts De Joyuda','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(8725,'08510','S','Millstone','N','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.189800,-74.441400,0,'2013-07-06 12:44:30',NULL,NULL),(32449,'36020','S','Coosada','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.496449,-86.343169,0,'2013-07-06 12:44:32',NULL,NULL),(7556,'07017','S','East Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.772043,-74.209455,0,'2013-07-06 12:44:30',NULL,NULL),(17701,'18220','P','Delano','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.840825,-76.071899,0,'2013-07-06 12:44:31',NULL,NULL),(49614,'56901','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(24570,'27311','S','Pelham','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.477171,-79.471290,0,'2013-07-06 12:44:31',NULL,NULL),(36868,'41093','S','Foxport','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.341084,-83.555814,0,'2013-07-06 12:44:32',NULL,NULL),(7473,'06888','U','Promotional Dev Inc','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.120054,-73.346424,0,'2013-07-06 12:44:30',NULL,NULL),(67213,'79918','S','El Paso','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.847479,-106.378199,0,'2013-07-06 12:44:34',NULL,NULL),(65688,'77995','S','Yoakum','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(50313,'57717','S','Willet','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.665219,-103.847783,0,'2013-07-06 12:44:33',NULL,NULL),(22865,'24555','S','Glasgow','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.634690,-79.452214,0,'2013-07-06 12:44:31',NULL,NULL),(37623,'42141','S','Haywood','N','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.974371,-85.907023,0,'2013-07-06 12:44:32',NULL,NULL),(59172,'70344','S','Chauvin','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.250580,-90.662180,0,'2013-07-06 12:44:33',NULL,NULL),(77079,'96130','S','Eagle Lake Resort','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417140,-120.641220,0,'2013-07-06 12:44:34',NULL,NULL),(7738,'07207','P','Elizabeth','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.669662,-74.217927,0,'2013-07-06 12:44:30',NULL,NULL),(7451,'06855','S','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.099161,-73.400423,0,'2013-07-06 12:44:30',NULL,NULL),(49157,'56386','S','Wahkon','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.067388,-93.494578,0,'2013-07-06 12:44:33',NULL,NULL),(67435,'80166','U','Arapahoe County Offices','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.594031,-105.009802,0,'2013-07-06 12:44:34',NULL,NULL),(30956,'33734','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.805743,-82.647994,0,'2013-07-06 12:44:32',NULL,NULL),(42335,'47635','S','Eureka','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.895520,-87.060780,0,'2013-07-06 12:44:32',NULL,NULL),(66395,'78626','S','Jonah','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.637620,-97.659840,0,'2013-07-06 12:44:34',NULL,NULL),(58899,'69201','S','Eli','N','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.876491,-100.569122,0,'2013-07-06 12:44:33',NULL,NULL),(57696,'67330','S','Altamont','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.197440,-95.303350,0,'2013-07-06 12:44:33',NULL,NULL),(5878,'05149','S','Tyson','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.392420,-72.697140,0,'2013-07-06 12:44:30',NULL,NULL),(26569,'29212','S','Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.081140,-81.194940,0,'2013-07-06 12:44:31',NULL,NULL),(17295,'17851','S','Dooleyville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(40007,'45245','S','Cherry Grove','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.069523,-84.277672,0,'2013-07-06 12:44:32',NULL,NULL),(35952,'40061','P','Saint Catharine','D','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.695114,-85.264452,0,'2013-07-06 12:44:32',NULL,NULL),(67657,'80477','P','Steamboat Springs','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.477411,-106.845470,0,'2013-07-06 12:44:34',NULL,NULL),(45969,'52401','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.974802,-91.660929,0,'2013-07-06 12:44:32',NULL,NULL),(315,'00646','S','Urb Santa Barbara','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(55500,'63775','S','Highland','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(16572,'17318','P','Emigsville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.017660,-76.731660,0,'2013-07-06 12:44:31',NULL,NULL),(13493,'13803','S','Hunts Corners','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(41249,'46742','S','Oakwood Shores','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(78703,'98261','S','Lopez Island','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.447828,-122.842452,0,'2013-07-06 12:44:34',NULL,NULL),(75954,'95043','S','Pinnacles','N','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.548040,-121.016280,0,'2013-07-06 12:44:34',NULL,NULL),(74871,'93265','S','Springville','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.119144,-118.830130,0,'2013-07-06 12:44:34',NULL,NULL),(32796,'36426','S','Keego','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(4305,'02908','S','North Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.847393,-71.449537,0,'2013-07-06 12:44:30',NULL,NULL),(65923,'78243','S','Electronic Security Services','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.381316,-98.579896,0,'2013-07-06 12:44:34',NULL,NULL),(66093,'78405','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.776027,-97.428025,0,'2013-07-06 12:44:34',NULL,NULL),(45612,'51566','S','Red Oak','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.009513,-95.223391,0,'2013-07-06 12:44:32',NULL,NULL),(72520,'89159','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.069731,-115.143235,0,'2013-07-06 12:44:34',NULL,NULL),(39736,'45068','S','Mount Holly','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.520020,-84.073920,0,'2013-07-06 12:44:32',NULL,NULL),(46232,'52777','S','Wheatland','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.832932,-90.840574,0,'2013-07-06 12:44:32',NULL,NULL),(71677,'87509','U','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.673194,-105.954437,0,'2013-07-06 12:44:34',NULL,NULL),(66230,'78565','P','Los Ebanos','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.314051,-98.391367,0,'2013-07-06 12:44:34',NULL,NULL),(7857,'07480','S','West Milford','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.090615,-74.369917,0,'2013-07-06 12:44:30',NULL,NULL),(30258,'33233','P','Coconut Gr','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.732156,-80.241534,0,'2013-07-06 12:44:32',NULL,NULL),(54088,'62525','P','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.832819,-88.944395,0,'2013-07-06 12:44:33',NULL,NULL),(42236,'47567','S','Oatsville','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(55131,'63347','S','Foley','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.067091,-90.743230,0,'2013-07-06 12:44:33',NULL,NULL),(51332,'59270','S','Sidney','D','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.715554,-104.161624,0,'2013-07-06 12:44:33',NULL,NULL),(52687,'61088','S','Winnebago','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.273946,-89.250627,0,'2013-07-06 12:44:33',NULL,NULL),(34437,'38647','S','Michigan City','D','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.932778,-89.211111,0,'2013-07-06 12:44:32',NULL,NULL),(39749,'45102','S','Lindale','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.022200,-84.225600,0,'2013-07-06 12:44:32',NULL,NULL),(65224,'77445','S','Pine Island','A','Waller','48473','Texas','TX','48','3360','979','Central',-6.0,'Y',30.072120,-96.081240,0,'2013-07-06 12:44:34',NULL,NULL),(71414,'87020','S','San Mateo','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.159241,-107.836997,0,'2013-07-06 12:44:34',NULL,NULL),(29287,'32504','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.490718,-87.183731,0,'2013-07-06 12:44:32',NULL,NULL),(67702,'80524','S','Severance','A','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.635510,-105.049839,0,'2013-07-06 12:44:34',NULL,NULL),(64741,'76904','S','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.418391,-100.478565,0,'2013-07-06 12:44:34',NULL,NULL),(16200,'17070','S','New Cumberland Army D','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(5513,'04773','S','Saint David','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.321008,-68.225335,0,'2013-07-06 12:44:30',NULL,NULL),(41575,'47035','P','New Trenton','D','Franklin','18047','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.312024,-84.900887,0,'2013-07-06 12:44:32',NULL,NULL),(19827,'20470','U','Gsa Tele Com Serv','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892775,-77.036853,0,'2013-07-06 12:44:31',NULL,NULL),(64913,'77201','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.763934,-95.363754,0,'2013-07-06 12:44:34',NULL,NULL),(32814,'36451','S','Grove Hill','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.705769,-87.780178,0,'2013-07-06 12:44:32',NULL,NULL),(10368,'10587','P','Shenorock','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.327130,-73.736741,0,'2013-07-06 12:44:30',NULL,NULL),(32970,'36607','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.698011,-88.101960,0,'2013-07-06 12:44:32',NULL,NULL),(66447,'78651','P','McNeil','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.452693,-97.723155,0,'2013-07-06 12:44:34',NULL,NULL),(27020,'29646','S','Gwd','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.184847,-82.152009,0,'2013-07-06 12:44:31',NULL,NULL),(18748,'19343','S','Glenmoore','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.094368,-75.750753,0,'2013-07-06 12:44:31',NULL,NULL),(30585,'33418','S','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855526,-80.144330,0,'2013-07-06 12:44:32',NULL,NULL),(36881,'41099','U','Northern Kentucky University','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.032312,-84.463361,0,'2013-07-06 12:44:32',NULL,NULL),(21831,'23116','S','Mechanicsville','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.628332,-77.353236,0,'2013-07-06 12:44:31',NULL,NULL),(73325,'90840','U','C S U Long Beach','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.781444,-118.118257,0,'2013-07-06 12:44:34',NULL,NULL),(3727,'02152','S','Winthrop','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.373760,-70.980521,0,'2013-07-06 12:44:30',NULL,NULL),(14128,'14651','U','Eastman Kodak','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.160651,-77.619606,0,'2013-07-06 12:44:31',NULL,NULL),(13252,'13643','P','Gt Bend','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.034705,-75.721520,0,'2013-07-06 12:44:30',NULL,NULL),(1244,'00729','S','Parc Villa Delicias','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(6294,'05651','S','E Montpelier','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.250409,-72.473242,0,'2013-07-06 12:44:30',NULL,NULL),(46417,'53184','S','Walworth','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.532266,-88.599572,0,'2013-07-06 12:44:32',NULL,NULL),(23546,'25621','S','Hampden','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.578836,-81.874407,0,'2013-07-06 12:44:31',NULL,NULL),(70297,'84535','S','Monticello','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.869249,-109.348501,0,'2013-07-06 12:44:34',NULL,NULL),(68282,'81082','S','Starkville','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(23515,'25550','S','Pt Pleasant','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.860965,-82.131564,0,'2013-07-06 12:44:31',NULL,NULL),(852,'00698','S','Repto Esperanza','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(34473,'38664','S','Clack','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(12432,'12955','S','Lyon Mountain','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.793668,-73.965388,0,'2013-07-06 12:44:30',NULL,NULL),(45851,'52232','S','Hartwick','D','Poweshiek','19157','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.819886,-92.356934,0,'2013-07-06 12:44:32',NULL,NULL),(51999,'60164','S','Melrose Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.924177,-87.889271,0,'2013-07-06 12:44:33',NULL,NULL),(37665,'42211','S','Cadiz','D','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(28826,'32081','S','Ponte Vedra Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173581,-81.395627,0,'2013-07-06 12:44:32',NULL,NULL),(51894,'60098','S','Bull Valley','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.320586,-88.447623,0,'2013-07-06 12:44:33',NULL,NULL),(53078,'61523','S','Rome Heights','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(58970,'70038','P','Boothville','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.346675,-89.422510,0,'2013-07-06 12:44:33',NULL,NULL),(27982,'30571','S','Sautee Nacoochee','D','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.743332,-83.716475,0,'2013-07-06 12:44:31',NULL,NULL),(11438,'11970','P','South Jamesport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.936611,-72.579128,0,'2013-07-06 12:44:30',NULL,NULL),(26779,'29449','S','Hollywood','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.711040,-80.276820,0,'2013-07-06 12:44:31',NULL,NULL),(9015,'08865','S','Delaware Park','N','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.698180,-75.135480,0,'2013-07-06 12:44:30',NULL,NULL),(17995,'18629','S','Forkston Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.490456,-76.155214,0,'2013-07-06 12:44:31',NULL,NULL),(72275,'88555','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769130,-106.334132,0,'2013-07-06 12:44:34',NULL,NULL),(65624,'77961','P','Francitas','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.817096,-96.445206,0,'2013-07-06 12:44:34',NULL,NULL),(52361,'60611','S','Ontario Street','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.894244,-87.622841,0,'2013-07-06 12:44:33',NULL,NULL),(33857,'38002','S','Arlington','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.292060,-89.741700,0,'2013-07-06 12:44:32',NULL,NULL),(21954,'23235','S','Bon Air','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.502040,-77.569920,0,'2013-07-06 12:44:31',NULL,NULL),(6328,'05664','P','Northfield Fl','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.171996,-72.651009,0,'2013-07-06 12:44:30',NULL,NULL),(50516,'58077','S','Walcott','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.502565,-97.072903,0,'2013-07-06 12:44:33',NULL,NULL),(62276,'74015','S','Fair Oaks','A','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.186268,-95.744614,0,'2013-07-06 12:44:33',NULL,NULL),(65160,'77401','S','Bellaire','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.705063,-95.458755,0,'2013-07-06 12:44:34',NULL,NULL),(37142,'41465','S','Gapville','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(72392,'89040','S','Valley of Fire','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(61880,'73131','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.578851,-97.470162,0,'2013-07-06 12:44:33',NULL,NULL),(34093,'38166','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.130758,-90.004671,0,'2013-07-06 12:44:32',NULL,NULL),(23676,'25840','S','Cunard','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(21395,'22508','S','Lake of Woods','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.333379,-77.762530,0,'2013-07-06 12:44:31',NULL,NULL),(9202,'09464','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42552,'47872','S','Hollandsburg','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(28762,'32008','S','Branford','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.048849,-82.955713,0,'2013-07-06 12:44:32',NULL,NULL),(2236,'00926','S','Urb Hillside','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(47878,'55089','S','Etter','N','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.619771,-92.651690,0,'2013-07-06 12:44:33',NULL,NULL),(15535,'16565','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.069063,-80.102633,0,'2013-07-06 12:44:31',NULL,NULL),(21434,'22565','P','Thornburg','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.133364,-77.519781,0,'2013-07-06 12:44:31',NULL,NULL),(58327,'68450','S','Tecumseh','D','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.369300,-96.193526,0,'2013-07-06 12:44:33',NULL,NULL),(52554,'60948','S','Loda','D','Iroquois','17075','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.525158,-88.094325,0,'2013-07-06 12:44:33',NULL,NULL),(17217,'17824','S','Knoebels Grv','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(7946,'07670','S','Tenafly','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.923667,-73.965326,0,'2013-07-06 12:44:30',NULL,NULL),(43569,'48732','S','Essexville','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.605497,-83.822737,0,'2013-07-06 12:44:32',NULL,NULL),(44204,'49628','P','Elberta','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.617654,-86.225748,0,'2013-07-06 12:44:32',NULL,NULL),(59492,'70767','S','Port Allen','D','West Baton Rouge','22121','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.478469,-91.276421,0,'2013-07-06 12:44:33',NULL,NULL),(60181,'71416','S','Derry','A','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.584840,-92.901000,0,'2013-07-06 12:44:33',NULL,NULL),(62106,'73628','S','Strong City','A','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.625120,-99.687180,0,'2013-07-06 12:44:33',NULL,NULL),(71500,'87107','S','Village Of Los Ranchos','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(66577,'78744','S','Bluff Springs','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.145680,-97.700220,0,'2013-07-06 12:44:34',NULL,NULL),(76946,'96029','S','Flournoy','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',39.913416,-122.467956,0,'2013-07-06 12:44:34',NULL,NULL),(71125,'86021','P','Colorado City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',36.989828,-112.977137,0,'2013-07-06 12:44:34',NULL,NULL),(61463,'72628','S','Wayton','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842526,-93.350809,0,'2013-07-06 12:44:33',NULL,NULL),(29666,'32910','P','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.997533,-80.691463,0,'2013-07-06 12:44:32',NULL,NULL),(40484,'45778','S','Stewart','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.336190,-81.904922,0,'2013-07-06 12:44:32',NULL,NULL),(25359,'28234','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.199142,-80.856456,0,'2013-07-06 12:44:31',NULL,NULL),(50963,'58626','S','Dunn Center','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.349834,-102.564317,0,'2013-07-06 12:44:33',NULL,NULL),(63800,'75962','U','Nacogdoches','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(13642,'14001','S','Akron','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.016719,-78.510497,0,'2013-07-06 12:44:31',NULL,NULL),(9626,'10034','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(3591,'02026','S','Dedham','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.244649,-71.167640,0,'2013-07-06 12:44:30',NULL,NULL),(39417,'44670','P','Robertsville','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.761561,-81.186167,0,'2013-07-06 12:44:32',NULL,NULL),(77911,'97309','P','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.925296,-123.013340,0,'2013-07-06 12:44:34',NULL,NULL),(72953,'90041','S','Eagle Rock','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.137442,-118.206258,0,'2013-07-06 12:44:34',NULL,NULL),(70901,'85621','S','Nogales','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.382641,-110.941760,0,'2013-07-06 12:44:34',NULL,NULL),(23336,'25247','P','Hartford','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.000627,-81.978560,0,'2013-07-06 12:44:31',NULL,NULL),(37939,'42701','S','E Town','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.707586,-85.861867,0,'2013-07-06 12:44:32',NULL,NULL),(25827,'28616','P','Crossnore','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.090448,-81.854065,0,'2013-07-06 12:44:31',NULL,NULL),(10925,'11431','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.717893,-73.793487,0,'2013-07-06 12:44:30',NULL,NULL),(33804,'37902','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.962214,-83.922984,0,'2013-07-06 12:44:32',NULL,NULL),(70778,'85344','S','Parker','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.155315,-114.263030,0,'2013-07-06 12:44:34',NULL,NULL),(69561,'83815','S','Dalton Gdns','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.725192,-116.786915,0,'2013-07-06 12:44:34',NULL,NULL),(46190,'52746','S','Donahue','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.711318,-90.678943,0,'2013-07-06 12:44:32',NULL,NULL),(27651,'30321','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.756316,-84.389551,0,'2013-07-06 12:44:31',NULL,NULL),(72999,'90061','S','August F Haw','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.922433,-118.275162,0,'2013-07-06 12:44:34',NULL,NULL),(40749,'46140','S','Gem','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.794852,-85.791522,0,'2013-07-06 12:44:32',NULL,NULL),(40336,'45506','S','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.911242,-83.839281,0,'2013-07-06 12:44:32',NULL,NULL),(21966,'23241','P','Central Sta','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.585084,-77.420677,0,'2013-07-06 12:44:31',NULL,NULL),(29330,'32547','S','Fort Walton Beach','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.446373,-86.626191,0,'2013-07-06 12:44:32',NULL,NULL),(74302,'92376','S','Rialto','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.117034,-117.376352,0,'2013-07-06 12:44:34',NULL,NULL),(59854,'71254','S','Monticello','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(59490,'70764','S','Plaquemine','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.279526,-91.238445,0,'2013-07-06 12:44:33',NULL,NULL),(30282,'33257','P','Perrine','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.613248,-80.347422,0,'2013-07-06 12:44:32',NULL,NULL),(5732,'05033','S','Bradford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.999980,-72.137700,0,'2013-07-06 12:44:30',NULL,NULL),(43608,'48787','U','Frankenmuth','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.331555,-83.741778,0,'2013-07-06 12:44:32',NULL,NULL),(38657,'43942','S','Powhatan Pt','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.862119,-80.816459,0,'2013-07-06 12:44:32',NULL,NULL),(26585,'29221','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.044558,-81.109663,0,'2013-07-06 12:44:31',NULL,NULL),(9087,'09042','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33001,'36644','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.694297,-88.041917,0,'2013-07-06 12:44:32',NULL,NULL),(36227,'40287','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.226435,-85.686923,0,'2013-07-06 12:44:32',NULL,NULL),(47677,'54950','S','Marion','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.669625,-88.886090,0,'2013-07-06 12:44:33',NULL,NULL),(34003,'38120','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.122753,-89.861988,0,'2013-07-06 12:44:32',NULL,NULL),(28905,'32135','P','Palm Coast','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.545761,-81.225951,0,'2013-07-06 12:44:32',NULL,NULL),(67151,'79780','P','Saragosa','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.024343,-103.661626,0,'2013-07-06 12:44:34',NULL,NULL),(13079,'13459','S','Sharon Springs','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.791988,-74.614106,0,'2013-07-06 12:44:30',NULL,NULL),(62000,'73434','S','Foster','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.638177,-97.558100,0,'2013-07-06 12:44:33',NULL,NULL),(66003,'78349','S','Concepcion','D','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.531404,-98.383724,0,'2013-07-06 12:44:34',NULL,NULL),(68575,'81505','S','Appleton','N','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.107861,-108.607362,0,'2013-07-06 12:44:34',NULL,NULL),(74610,'92711','P','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.766854,-117.804349,0,'2013-07-06 12:44:34',NULL,NULL),(48526,'55746','S','Wilpen','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(1031,'00719','S','Sect Chevres','N','Naranjito','72105','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.301571,-66.244271,0,'2013-07-06 12:44:30',NULL,NULL),(41427,'46850','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.066462,-85.168804,0,'2013-07-06 12:44:32',NULL,NULL),(17063,'17756','S','Moreland','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(52693,'61103','S','Machesney Pk','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.299190,-89.103195,0,'2013-07-06 12:44:33',NULL,NULL),(79498,'98903','S','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.561980,-120.667800,0,'2013-07-06 12:44:34',NULL,NULL),(73507,'91335','S','Encino','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.199469,-118.539891,0,'2013-07-06 12:44:34',NULL,NULL),(63974,'76105','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.722238,-97.267430,0,'2013-07-06 12:44:34',NULL,NULL),(25572,'28430','S','Cerro Gordo','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.287040,-78.927792,0,'2013-07-06 12:44:31',NULL,NULL),(4656,'03756','P','Lebanon','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.637006,-72.252383,0,'2013-07-06 12:44:30',NULL,NULL),(73611,'91396','P','Winnetka','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.210263,-118.570594,0,'2013-07-06 12:44:34',NULL,NULL),(29678,'32920','S','Pt Canaveral','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.391416,-80.605396,0,'2013-07-06 12:44:32',NULL,NULL),(45284,'50681','S','Westgate','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.819240,-92.024227,0,'2013-07-06 12:44:32',NULL,NULL),(27100,'29718','S','Jefferson','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.584331,-80.419337,0,'2013-07-06 12:44:31',NULL,NULL),(7069,'06338','P','Ledyard','A','New London','09011','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.471500,-71.947304,0,'2013-07-06 12:44:30',NULL,NULL),(46101,'52625','S','Primrose','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.653180,-91.550700,0,'2013-07-06 12:44:32',NULL,NULL),(30809,'33615','S','Town N Country','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.009516,-82.585627,0,'2013-07-06 12:44:32',NULL,NULL),(3,'00544','U','Holtsville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.813223,-73.049288,0,'2013-07-06 12:44:30',NULL,NULL),(28787,'32043','S','Green Cv Spgs','A','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.958919,-81.736288,0,'2013-07-06 12:44:32',NULL,NULL),(63152,'75381','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.944758,-96.888462,0,'2013-07-06 12:44:33',NULL,NULL),(35631,'39633','S','Perrytown','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(20136,'20722','S','North Brentwo','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(41911,'47374','S','Richmond Sq','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(4096,'02671','S','West Harwich','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.664741,-70.110160,0,'2013-07-06 12:44:30',NULL,NULL),(9687,'10044','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(77926,'97326','S','Blodgett','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.641659,-123.552667,0,'2013-07-06 12:44:34',NULL,NULL),(76282,'95425','S','The Geysers','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.769480,-122.948340,0,'2013-07-06 12:44:34',NULL,NULL),(20880,'21678','S','Worton','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.299035,-76.108948,0,'2013-07-06 12:44:31',NULL,NULL),(41511,'46971','S','Grissom Air Reserve Base','A','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.673495,-86.158752,0,'2013-07-06 12:44:32',NULL,NULL),(76765,'95928','S','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.724307,-121.813534,0,'2013-07-06 12:44:34',NULL,NULL),(27041,'29665','P','Newry','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.717905,-82.902959,0,'2013-07-06 12:44:31',NULL,NULL),(19905,'20544','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906224,-77.038090,0,'2013-07-06 12:44:31',NULL,NULL),(19126,'19608','S','Sinking Spring','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(28733,'31908','P','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.531133,-84.938045,0,'2013-07-06 12:44:32',NULL,NULL),(21693,'22965','P','Quinque','D','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.279411,-78.430453,0,'2013-07-06 12:44:31',NULL,NULL),(70065,'84145','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.754454,-111.897732,0,'2013-07-06 12:44:34',NULL,NULL),(70889,'85615','S','Nicksville','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.402920,-110.207340,0,'2013-07-06 12:44:34',NULL,NULL),(77145,'96161','S','Hobart Mills','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(71248,'86402','P','Kingman','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.204732,-114.070499,0,'2013-07-06 12:44:34',NULL,NULL),(78431,'98052','S','Earlmount','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.683648,-122.121837,0,'2013-07-06 12:44:34',NULL,NULL),(73645,'91482','U','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201021,-118.475212,0,'2013-07-06 12:44:34',NULL,NULL),(62448,'74192','U','Bok Mail Service','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.153591,-95.995611,0,'2013-07-06 12:44:33',NULL,NULL),(5011,'04226','S','East Andover','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.605912,-70.728406,0,'2013-07-06 12:44:30',NULL,NULL),(72686,'89445','S','Jungo','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(79127,'98497','P','Oakbrook','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.177943,-122.547217,0,'2013-07-06 12:44:34',NULL,NULL),(34043,'38136','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099619,-90.036265,0,'2013-07-06 12:44:32',NULL,NULL),(37473,'42001','S','Fremont','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(42919,'48110','P','Azalia','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.015471,-83.668836,0,'2013-07-06 12:44:32',NULL,NULL),(52365,'60614','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.923621,-87.653367,0,'2013-07-06 12:44:33',NULL,NULL),(52898,'61356','S','Hollowayville','A','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.371332,-89.463511,0,'2013-07-06 12:44:33',NULL,NULL),(79298,'98586','S','Nemah','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.661172,-123.809548,0,'2013-07-06 12:44:34',NULL,NULL),(66339,'78605','S','Oatmeal','N','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.745034,-98.053979,0,'2013-07-06 12:44:34',NULL,NULL),(32678,'36266','S','Pyriton','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(63876,'76008','S','Annetta S','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699617,-97.628794,0,'2013-07-06 12:44:34',NULL,NULL),(37777,'42350','S','Island','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.447021,-87.168751,0,'2013-07-06 12:44:32',NULL,NULL),(44547,'50005','S','Minerva','N','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.121073,-93.013180,0,'2013-07-06 12:44:32',NULL,NULL),(23022,'24831','P','Elkhorn','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.352821,-81.455533,0,'2013-07-06 12:44:31',NULL,NULL),(45079,'50527','S','Curlew','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.959933,-94.824680,0,'2013-07-06 12:44:32',NULL,NULL),(20882,'21690','U','Chestertown','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.218890,-76.071011,0,'2013-07-06 12:44:31',NULL,NULL),(34400,'38625','S','Pleasant Ridge','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640768,-88.802425,0,'2013-07-06 12:44:32',NULL,NULL),(41948,'47396','S','West Muncie','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.172376,-85.487338,0,'2013-07-06 12:44:32',NULL,NULL),(47115,'54449','S','McMillan','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.612100,-90.187920,0,'2013-07-06 12:44:32',NULL,NULL),(60786,'72025','S','Casa','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.030179,-93.036863,0,'2013-07-06 12:44:33',NULL,NULL),(57023,'66207','S','Leawood','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(14365,'15022','S','North Charleroi','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.134660,-79.916040,0,'2013-07-06 12:44:31',NULL,NULL),(33082,'36785','S','Tyler','D','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.269183,-86.852148,0,'2013-07-06 12:44:32',NULL,NULL),(56711,'65676','S','Isabella','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.582288,-92.606559,0,'2013-07-06 12:44:33',NULL,NULL),(68573,'81504','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.083097,-108.486204,0,'2013-07-06 12:44:34',NULL,NULL),(35058,'39182','P','Vburg','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.350854,-90.878540,0,'2013-07-06 12:44:32',NULL,NULL),(27456,'30127','S','Powder Springs','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.883327,-84.688671,0,'2013-07-06 12:44:31',NULL,NULL),(35972,'40104','S','Wolf Creek','N','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',38.067000,-86.323794,0,'2013-07-06 12:44:32',NULL,NULL),(2610,'00961','S','Valle Verde 2','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(314,'00646','S','Urb Sabanera Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(6393,'05731','P','Benson','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594722,-73.266111,0,'2013-07-06 12:44:30',NULL,NULL),(30650,'33459','P','Lake Harbor','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.693456,-80.817722,0,'2013-07-06 12:44:32',NULL,NULL),(75241,'93651','S','Prather','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.000931,-119.524077,0,'2013-07-06 12:44:34',NULL,NULL),(69106,'83261','P','Glencoe','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.229162,-111.407694,0,'2013-07-06 12:44:34',NULL,NULL),(33567,'37414','P','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.026201,-85.230406,0,'2013-07-06 12:44:32',NULL,NULL),(44800,'50232','S','Galesburg','N','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.587056,-93.019302,0,'2013-07-06 12:44:32',NULL,NULL),(3553,'01937','P','Hathorne','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.590815,-70.977070,0,'2013-07-06 12:44:30',NULL,NULL),(18971,'19518','S','Weavertown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(48660,'55912','S','Andyville','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667498,-92.979475,0,'2013-07-06 12:44:33',NULL,NULL),(51604,'59825','S','Turah','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.761060,-113.677380,0,'2013-07-06 12:44:33',NULL,NULL),(18737,'19333','S','Devon','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.044055,-75.424940,0,'2013-07-06 12:44:31',NULL,NULL),(17858,'18433','S','Jermyn','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.533400,-75.542375,0,'2013-07-06 12:44:31',NULL,NULL),(32403,'35959','S','Cedar Bluff','D','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.216906,-85.600321,0,'2013-07-06 12:44:32',NULL,NULL),(28273,'31084','P','Seville','D','Wilcox','13315','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.931082,-83.554622,0,'2013-07-06 12:44:31',NULL,NULL),(6842,'06119','S','W Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760843,-72.729064,0,'2013-07-06 12:44:30',NULL,NULL),(40531,'45835','S','Dola','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.769445,-83.684937,0,'2013-07-06 12:44:32',NULL,NULL),(11788,'12211','S','Siena','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.707382,-73.772002,0,'2013-07-06 12:44:30',NULL,NULL),(57250,'66532','S','Robinson','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.816900,-95.393820,0,'2013-07-06 12:44:33',NULL,NULL),(22211,'23517','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.866827,-76.290455,0,'2013-07-06 12:44:31',NULL,NULL),(3637,'02090','S','Westwood','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.216043,-71.204408,0,'2013-07-06 12:44:30',NULL,NULL),(28515,'31539','S','Roper','N','Jeff Davis','13161','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.866984,-82.600623,0,'2013-07-06 12:44:32',NULL,NULL),(60173,'71409','S','McNutt','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(3100,'01227','P','Dalton','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.472396,-73.162019,0,'2013-07-06 12:44:30',NULL,NULL),(17855,'18430','S','Herrick Ctr','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.761885,-75.507594,0,'2013-07-06 12:44:31',NULL,NULL),(20073,'20682','P','Rock Pt','N','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.346210,-76.920679,0,'2013-07-06 12:44:31',NULL,NULL),(26828,'29485','S','Summ','N','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.975069,-80.180159,0,'2013-07-06 12:44:31',NULL,NULL),(41709,'47234','S','Flat Rock','D','Shelby','18145','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.396093,-85.687549,0,'2013-07-06 12:44:32',NULL,NULL),(22280,'23801','S','Fort Lee','D','Prince George','51149','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.237019,-77.334813,0,'2013-07-06 12:44:31',NULL,NULL),(37008,'41224','S','Job','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.864560,-82.514588,0,'2013-07-06 12:44:32',NULL,NULL),(35559,'39565','S','Vancleave','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.568555,-88.740289,0,'2013-07-06 12:44:32',NULL,NULL),(44746,'50166','S','Milo','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.281038,-93.424925,0,'2013-07-06 12:44:32',NULL,NULL),(72397,'89043','S','Caselton','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(54917,'63090','S','Campbellton','N','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.546118,-91.015131,0,'2013-07-06 12:44:33',NULL,NULL),(73559,'91362','S','Westlake Vlg','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.192920,-118.822620,0,'2013-07-06 12:44:34',NULL,NULL),(4179,'02813','S','Charlestown','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.411805,-71.644218,0,'2013-07-06 12:44:30',NULL,NULL),(965,'00716','S','Urb Bella Vista','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(16907,'17601','S','Eden','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(37859,'42518','S','Bronston','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.967062,-84.627631,0,'2013-07-06 12:44:32',NULL,NULL),(27333,'30035','S','Snapfinger','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.726646,-84.207866,0,'2013-07-06 12:44:31',NULL,NULL),(13031,'13433','S','Leyden','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.588855,-75.279411,0,'2013-07-06 12:44:30',NULL,NULL),(19114,'19606','S','Saint Lawrence','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(15498,'16505','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.096961,-80.169880,0,'2013-07-06 12:44:31',NULL,NULL),(32250,'35613','S','Athens','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.823963,-86.882552,0,'2013-07-06 12:44:32',NULL,NULL),(24340,'27031','P','Mt Airy','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.445556,-80.633611,0,'2013-07-06 12:44:31',NULL,NULL),(78121,'97522','S','Butte Falls','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.537298,-122.551271,0,'2013-07-06 12:44:34',NULL,NULL),(77313,'96682','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75678,'94552','S','Castro Valley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.694127,-122.018877,0,'2013-07-06 12:44:34',NULL,NULL),(57018,'66206','S','Prairie Village','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(24498,'27262','S','Emerywood','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.956020,-80.040720,0,'2013-07-06 12:44:31',NULL,NULL),(18291,'19014','S','Green Ridge','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(40879,'46240','S','Williams Creek','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.905944,-86.128201,0,'2013-07-06 12:44:32',NULL,NULL),(28755,'32003','S','Orange Pk','N','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.106435,-81.711499,0,'2013-07-06 12:44:32',NULL,NULL),(22883,'24577','S','Nathalie','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.942263,-78.970967,0,'2013-07-06 12:44:31',NULL,NULL),(33586,'37602','P','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.305672,-82.383269,0,'2013-07-06 12:44:32',NULL,NULL),(40993,'46356','S','North Hayden','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.284559,-87.416071,0,'2013-07-06 12:44:32',NULL,NULL),(43802,'49061','S','Jones','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.881397,-85.825725,0,'2013-07-06 12:44:32',NULL,NULL),(72874,'90009','P','Los Angeles AFB','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.946348,-118.379884,0,'2013-07-06 12:44:34',NULL,NULL),(77656,'97020','S','Donald','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.224101,-122.841176,0,'2013-07-06 12:44:34',NULL,NULL),(73319,'90822','S','Long Beach Shared Firm','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.831262,-118.238192,0,'2013-07-06 12:44:34',NULL,NULL),(65284,'77484','S','Prairie View','A','Harris','48201','Texas','TX','48','3360','936','Central',-6.0,'Y',30.075392,-95.890763,0,'2013-07-06 12:44:34',NULL,NULL),(62706,'74743','S','Hugo','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.005660,-95.513972,0,'2013-07-06 12:44:33',NULL,NULL),(4787,'03869','S','Rollinsford','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.231809,-70.829693,0,'2013-07-06 12:44:30',NULL,NULL),(13536,'13827','S','Catatonk','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(42336,'47635','S','Patronville','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.895520,-87.060780,0,'2013-07-06 12:44:32',NULL,NULL),(71807,'87567','S','Santa Cruz','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.994133,-106.052197,0,'2013-07-06 12:44:34',NULL,NULL),(23901,'26202','S','Fenwick','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.249209,-80.643415,0,'2013-07-06 12:44:31',NULL,NULL),(31080,'33858','P','Loughman','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.242334,-81.566897,0,'2013-07-06 12:44:32',NULL,NULL),(42003,'47427','S','Coal City','D','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.249277,-86.989828,0,'2013-07-06 12:44:32',NULL,NULL),(7647,'07075','S','Wood Ridge','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.847097,-74.085370,0,'2013-07-06 12:44:30',NULL,NULL),(69093,'83253','S','May','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.577861,-113.809881,0,'2013-07-06 12:44:34',NULL,NULL),(70288,'84533','S','Halls Crossing','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(37765,'42339','S','Dunmor','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.080671,-86.978957,0,'2013-07-06 12:44:32',NULL,NULL),(21114,'22079','S','Mason Neck','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.690100,-77.206500,0,'2013-07-06 12:44:31',NULL,NULL),(46177,'52736','U','Promotional Fulfillment Corp','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.842528,-90.231685,0,'2013-07-06 12:44:32',NULL,NULL),(47514,'54773','S','Whitehall','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.367306,-91.320405,0,'2013-07-06 12:44:32',NULL,NULL),(14754,'15324','P','Cokeburg','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.100061,-80.063337,0,'2013-07-06 12:44:31',NULL,NULL),(20751,'21404','P','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.977778,-76.498291,0,'2013-07-06 12:44:31',NULL,NULL),(1597,'00769','S','Urb Bella Vista Est','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(2458,'00954','P','Toa Alta','D','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.390022,-66.246174,0,'2013-07-06 12:44:30',NULL,NULL),(18423,'19061','S','Ogden','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(72590,'89406','S','Ragtown','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(25546,'28406','P','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.178185,-77.885847,0,'2013-07-06 12:44:31',NULL,NULL),(12118,'12590','S','Wappingers Falls','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.595832,-73.887450,0,'2013-07-06 12:44:30',NULL,NULL),(39501,'44805','S','Widowville','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.853220,-82.315020,0,'2013-07-06 12:44:32',NULL,NULL),(3128,'01244','P','Mill River','D','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.114506,-73.267171,0,'2013-07-06 12:44:30',NULL,NULL),(4242,'02871','S','Portsmouth','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.577598,-71.266115,0,'2013-07-06 12:44:30',NULL,NULL),(31355,'34203','S','Braden River','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.443170,-82.531219,0,'2013-07-06 12:44:32',NULL,NULL),(39280,'44482','P','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.194253,-80.827465,0,'2013-07-06 12:44:32',NULL,NULL),(32004,'35228','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.500280,-86.917620,0,'2013-07-06 12:44:32',NULL,NULL),(48617,'55795','S','Willow River','D','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.311725,-92.860123,0,'2013-07-06 12:44:33',NULL,NULL),(71115,'86015','P','Flagstaff','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.198056,-111.650556,0,'2013-07-06 12:44:34',NULL,NULL),(71101,'85939','P','Taylor','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.458495,-110.079577,0,'2013-07-06 12:44:34',NULL,NULL),(57355,'66736','S','Buxton','N','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.535127,-95.823027,0,'2013-07-06 12:44:33',NULL,NULL),(36188,'40256','P','Shively','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.195411,-85.808291,0,'2013-07-06 12:44:32',NULL,NULL),(39588,'44864','S','Perrysville','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.652120,-82.314078,0,'2013-07-06 12:44:32',NULL,NULL),(55299,'63531','S','Bible Grove','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.263106,-92.262440,0,'2013-07-06 12:44:33',NULL,NULL),(11023,'11561','S','E Atlantic Beach','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.585753,-73.657497,0,'2013-07-06 12:44:30',NULL,NULL),(14666,'15239','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.479721,-79.749820,0,'2013-07-06 12:44:31',NULL,NULL),(7574,'07030','S','Castle Point','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.747748,-74.033860,0,'2013-07-06 12:44:30',NULL,NULL),(44778,'50214','S','Otley','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.459212,-93.038568,0,'2013-07-06 12:44:32',NULL,NULL),(14693,'15257','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441554,-79.997787,0,'2013-07-06 12:44:31',NULL,NULL),(75004,'93454','S','Garey','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.877520,-120.331800,0,'2013-07-06 12:44:34',NULL,NULL),(59240,'70433','S','St Gertrude','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.457687,-90.114529,0,'2013-07-06 12:44:33',NULL,NULL),(6451,'05758','S','Mount Holly','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.450800,-72.791580,0,'2013-07-06 12:44:30',NULL,NULL),(13627,'13903','S','Binghamton','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.097500,-75.894240,0,'2013-07-06 12:44:31',NULL,NULL),(19670,'20318','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.864971,-77.012219,0,'2013-07-06 12:44:31',NULL,NULL),(22067,'23337','S','Wallops Is','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.862571,-75.462907,0,'2013-07-06 12:44:31',NULL,NULL),(67841,'80815','S','Flagler','D','Kit Carson','08063','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.321415,-103.060033,0,'2013-07-06 12:44:34',NULL,NULL),(39971,'45238','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.110911,-84.613884,0,'2013-07-06 12:44:32',NULL,NULL),(31871,'35124','S','Indian Springs','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.301860,-86.791800,0,'2013-07-06 12:44:32',NULL,NULL),(46306,'53062','U','Salvatorian Center','N','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.947498,-88.101978,0,'2013-07-06 12:44:32',NULL,NULL),(66172,'78520','S','Portway Acres','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(59707,'71105','S','Madison Park','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.454589,-93.712715,0,'2013-07-06 12:44:33',NULL,NULL),(56561,'65466','S','West Eminence','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(56283,'65072','S','Rocky Mount','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.292715,-92.713864,0,'2013-07-06 12:44:33',NULL,NULL),(30439,'33330','S','Sw Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(9240,'09569','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(32458,'36026','S','Nixburg','N','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.803200,-86.079900,0,'2013-07-06 12:44:32',NULL,NULL),(32441,'36008','S','Booth','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.497413,-86.571774,0,'2013-07-06 12:44:32',NULL,NULL),(77352,'96730','S','Kaaawa','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.554256,-157.857322,0,'2013-07-06 12:44:34',NULL,NULL),(61574,'72736','S','Gravette','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.422220,-94.447295,0,'2013-07-06 12:44:33',NULL,NULL),(5750,'05037','S','Brownsville','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.483333,-72.483333,0,'2013-07-06 12:44:30',NULL,NULL),(39698,'45039','S','Hamilton Twp','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.320497,-84.253761,0,'2013-07-06 12:44:32',NULL,NULL),(45413,'51051','S','Rodney','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.204480,-95.951601,0,'2013-07-06 12:44:32',NULL,NULL),(48730,'55961','S','Ostrander','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.571582,-92.406254,0,'2013-07-06 12:44:33',NULL,NULL),(78683,'98247','S','Everson','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.906641,-122.329968,0,'2013-07-06 12:44:34',NULL,NULL),(60116,'71367','S','St Landry','N','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.850864,-92.412602,0,'2013-07-06 12:44:33',NULL,NULL),(21914,'23219','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.541877,-77.436280,0,'2013-07-06 12:44:31',NULL,NULL),(40724,'46124','S','Atterbury','A','Johnson','18081','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.353574,-85.964085,0,'2013-07-06 12:44:32',NULL,NULL),(9646,'10037','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(21280,'22315','S','Kingstowne','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.784480,-77.125200,0,'2013-07-06 12:44:31',NULL,NULL),(21367,'22448','S','Naval Surface Weapons Center','N','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.335861,-77.033198,0,'2013-07-06 12:44:31',NULL,NULL),(64000,'76114','S','Sansom Park','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(17435,'17931','S','Frackville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779310,-76.233926,0,'2013-07-06 12:44:31',NULL,NULL),(21333,'22408','S','Fredericksbrg','A','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(7751,'07310','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.733081,-74.041881,0,'2013-07-06 12:44:30',NULL,NULL),(75945,'95036','P','Milpitas','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.243087,-121.971656,0,'2013-07-06 12:44:34',NULL,NULL),(62025,'73461','S','Wapanucka','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.388790,-96.501557,0,'2013-07-06 12:44:33',NULL,NULL),(30462,'33336','U','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.142550,-80.139499,0,'2013-07-06 12:44:32',NULL,NULL),(6110,'05456','S','Ferrisburg','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.214705,-73.268043,0,'2013-07-06 12:44:30',NULL,NULL),(5429,'04675','P','Seal Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.304867,-68.243629,0,'2013-07-06 12:44:30',NULL,NULL),(39905,'45216','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(17054,'17754','S','Farragut','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(49582,'56735','S','Lancaster','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.912614,-96.843421,0,'2013-07-06 12:44:33',NULL,NULL),(43133,'48234','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.430213,-83.042907,0,'2013-07-06 12:44:32',NULL,NULL),(40716,'46118','S','Clayton','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.655558,-86.521037,0,'2013-07-06 12:44:32',NULL,NULL),(60062,'71353','S','Bayou Rouge','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(77711,'97055','S','Sandy','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.388814,-122.228513,0,'2013-07-06 12:44:34',NULL,NULL),(78952,'98368','S','Protection Island','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(71705,'87525','P','Taos Ski Valley','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.403577,-105.576960,0,'2013-07-06 12:44:34',NULL,NULL),(63281,'75554','S','Avery','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.486322,-94.793653,0,'2013-07-06 12:44:33',NULL,NULL),(6425,'05742','S','East Wallingford','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.433994,-72.877559,0,'2013-07-06 12:44:30',NULL,NULL),(16528,'17268','S','Polktown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(9878,'10123','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(20706,'21264','U','M T Bank','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290550,-76.609596,0,'2013-07-06 12:44:31',NULL,NULL),(10831,'11381','U','Metropolitan Museum of Art','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715918,-73.875773,0,'2013-07-06 12:44:30',NULL,NULL),(42767,'48036','S','Clinton Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.593259,-82.911912,0,'2013-07-06 12:44:32',NULL,NULL),(70624,'85132','S','Florence','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.009241,-111.360789,0,'2013-07-06 12:44:34',NULL,NULL),(28463,'31416','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.004398,-81.095040,0,'2013-07-06 12:44:32',NULL,NULL),(23654,'25813','S','Beaver','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.772983,-81.102442,0,'2013-07-06 12:44:31',NULL,NULL),(23569,'25650','S','Verner','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.660000,-81.850000,0,'2013-07-06 12:44:31',NULL,NULL),(38762,'44041','S','Geneva on the Lake','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.786888,-80.957349,0,'2013-07-06 12:44:32',NULL,NULL),(39371,'44640','P','Limaville','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.982869,-81.146572,0,'2013-07-06 12:44:32',NULL,NULL),(75029,'93505','S','California City','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.132536,-117.956387,0,'2013-07-06 12:44:34',NULL,NULL),(23575,'25661','S','Nolan','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.673227,-82.277393,0,'2013-07-06 12:44:31',NULL,NULL),(75547,'94239','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.556510,-121.496477,0,'2013-07-06 12:44:34',NULL,NULL),(71437,'87034','P','Acomita','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084674,-107.598482,0,'2013-07-06 12:44:34',NULL,NULL),(38913,'44118','S','University Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(32963,'36590','P','Theodore','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.533459,-88.184687,0,'2013-07-06 12:44:32',NULL,NULL),(16959,'17702','S','S Williamspor','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(28554,'31565','S','Spring Bluff','N','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.047300,-81.577500,0,'2013-07-06 12:44:32',NULL,NULL),(45521,'51433','S','Grant City','N','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.271200,-94.891740,0,'2013-07-06 12:44:32',NULL,NULL),(44459,'49877','P','Ralph','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.108498,-87.784388,0,'2013-07-06 12:44:32',NULL,NULL),(37170,'41472','S','Relief','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(69591,'83844','U','Moscow','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.730287,-116.996847,0,'2013-07-06 12:44:34',NULL,NULL),(73742,'91711','S','Claremont','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.113043,-117.717351,0,'2013-07-06 12:44:34',NULL,NULL),(79590,'99032','S','Sprague','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.300188,-117.979989,0,'2013-07-06 12:44:34',NULL,NULL),(72425,'89067','S','Coyote Springs','D','Clark','32003','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.675655,-114.620214,0,'2013-07-06 12:44:34',NULL,NULL),(38049,'43045','S','Milford Center','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.174261,-83.443176,0,'2013-07-06 12:44:32',NULL,NULL),(55183,'63376','S','O Fallon','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.780270,-90.624050,0,'2013-07-06 12:44:33',NULL,NULL),(16329,'17125','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266171,-76.880912,0,'2013-07-06 12:44:31',NULL,NULL),(14218,'14788','P','Weston Mills','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.060494,-78.380393,0,'2013-07-06 12:44:31',NULL,NULL),(30879,'33684','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.995506,-82.496710,0,'2013-07-06 12:44:32',NULL,NULL),(47219,'54494','S','Wisconsin Rapids','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(8382,'08057','S','Lenola','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.962222,-74.982778,0,'2013-07-06 12:44:30',NULL,NULL),(33634,'37683','S','Mountain City','D','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.473298,-81.802628,0,'2013-07-06 12:44:32',NULL,NULL),(12279,'12839','S','Sandy Hill','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.320840,-73.576800,0,'2013-07-06 12:44:30',NULL,NULL),(74434,'92567','S','Lakeview','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.834435,-117.107956,0,'2013-07-06 12:44:34',NULL,NULL),(71747,'87540','S','Santa Fe','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.397323,-105.846760,0,'2013-07-06 12:44:34',NULL,NULL),(57266,'66544','S','Vermillion','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.691182,-96.283657,0,'2013-07-06 12:44:33',NULL,NULL),(1274,'00730','S','Est del Golf Club','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(49046,'56293','S','Wabasso','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.402248,-95.248733,0,'2013-07-06 12:44:33',NULL,NULL),(20004,'20610','P','Barstow','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.533156,-76.616803,0,'2013-07-06 12:44:31',NULL,NULL),(30757,'33568','P','Riverview','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.868719,-82.319589,0,'2013-07-06 12:44:32',NULL,NULL),(6480,'05766','S','Ripton','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.015278,-73.167778,0,'2013-07-06 12:44:30',NULL,NULL),(9294,'09704','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(52924,'61370','S','Tonica','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.228820,-89.110860,0,'2013-07-06 12:44:33',NULL,NULL),(16151,'17061','S','Lenkerville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(57272,'66547','S','Wamego','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.211156,-96.316796,0,'2013-07-06 12:44:33',NULL,NULL),(66413,'78632','S','Saturn','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.660518,-97.479686,0,'2013-07-06 12:44:34',NULL,NULL),(67832,'80808','S','Ellicott','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.976792,-104.316048,0,'2013-07-06 12:44:34',NULL,NULL),(68190,'81029','S','Campo','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.092964,-102.569773,0,'2013-07-06 12:44:34',NULL,NULL),(38735,'44026','S','Chesterland','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.536632,-81.339554,0,'2013-07-06 12:44:32',NULL,NULL),(21342,'22427','S','Fort A P Hill','A','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.049038,-77.350933,0,'2013-07-06 12:44:31',NULL,NULL),(6871,'06137','P','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(20083,'20688','S','Solomons','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.338455,-76.463430,0,'2013-07-06 12:44:31',NULL,NULL),(8478,'08092','S','Cedar Run','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.653280,-74.280720,0,'2013-07-06 12:44:30',NULL,NULL),(25043,'27909','S','Elizabeth City Coast Guard A','N','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.295010,-76.233334,0,'2013-07-06 12:44:31',NULL,NULL),(35122,'39212','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.243548,-90.263734,0,'2013-07-06 12:44:32',NULL,NULL),(54719,'62960','S','Metropolis','D','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.154433,-88.723675,0,'2013-07-06 12:44:33',NULL,NULL),(32858,'36509','S','Bayou La Batre','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.403859,-88.246081,0,'2013-07-06 12:44:32',NULL,NULL),(37995,'42753','S','Knifley','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.233254,-85.169953,0,'2013-07-06 12:44:32',NULL,NULL),(40859,'46228','S','N Crows Nest','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(18053,'18702','S','City of Wilkes Barre','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(3505,'01863','S','N Chelmsford','A','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.633290,-71.384253,0,'2013-07-06 12:44:30',NULL,NULL),(19659,'20306','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.974169,-77.033759,0,'2013-07-06 12:44:31',NULL,NULL),(11769,'12203','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(46497,'53227','S','New Berlin','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994705,-88.042267,0,'2013-07-06 12:44:32',NULL,NULL),(56357,'65203','S','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.929931,-92.372948,0,'2013-07-06 12:44:33',NULL,NULL),(71327,'86506','P','Oak Springs','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.389139,-109.283418,0,'2013-07-06 12:44:34',NULL,NULL),(79901,'99589','P','Goodnews Bay','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.081846,-161.216424,0,'2013-07-06 12:44:34',NULL,NULL),(57887,'67632','S','Damar','D','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.320781,-99.588654,0,'2013-07-06 12:44:33',NULL,NULL),(51713,'60010','S','Fox Rv Vly Gn','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(26851,'29518','S','Hebron','N','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.802250,-79.802509,0,'2013-07-06 12:44:31',NULL,NULL),(9501,'10014','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(5938,'05257','S','Barnumsville','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(35253,'39345','S','Newton','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.317802,-89.164446,0,'2013-07-06 12:44:32',NULL,NULL),(63435,'75667','S','Pone','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.945127,-94.853612,0,'2013-07-06 12:44:33',NULL,NULL),(68710,'82070','S','Bosler','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.297825,-105.635487,0,'2013-07-06 12:44:34',NULL,NULL),(70239,'84405','S','South Weber','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(71127,'86022','S','Fredonia','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(75619,'94503','S','American Cyn','A','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.116667,-122.233333,0,'2013-07-06 12:44:34',NULL,NULL),(77593,'96929','S','Dededo','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.539783,144.899632,0,'2013-07-06 12:44:34',NULL,NULL),(64022,'76119','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.680500,-97.264980,0,'2013-07-06 12:44:34',NULL,NULL),(21703,'22971','S','Rockfish','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.758900,-78.819120,0,'2013-07-06 12:44:31',NULL,NULL),(41895,'47371','S','Collett','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(9511,'10016','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(31265,'33994','P','E Fort Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.630413,-81.852216,0,'2013-07-06 12:44:32',NULL,NULL),(78736,'98284','S','Sedro Woolley','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.524748,-122.181496,0,'2013-07-06 12:44:34',NULL,NULL),(77794,'97136','S','Brighton','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(69653,'84010','S','Woods Cross','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.871662,-111.890486,0,'2013-07-06 12:44:34',NULL,NULL),(4138,'02748','S','S Dartmouth','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.598019,-70.954047,0,'2013-07-06 12:44:30',NULL,NULL),(77658,'97021','S','Friend','A','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.421839,-121.162820,0,'2013-07-06 12:44:34',NULL,NULL),(76327,'95461','S','Loch Lomond','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.785860,-122.620200,0,'2013-07-06 12:44:34',NULL,NULL),(75492,'94128','S','San Francisco','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.607851,-122.386722,0,'2013-07-06 12:44:34',NULL,NULL),(69287,'83443','S','Heise','N','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.595448,-111.660076,0,'2013-07-06 12:44:34',NULL,NULL),(63439,'75670','S','Blocker','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(28732,'31908','P','COL','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.531133,-84.938045,0,'2013-07-06 12:44:32',NULL,NULL),(13904,'14280','U','Shared BRM','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.886929,-78.871237,0,'2013-07-06 12:44:31',NULL,NULL),(43417,'48464','S','Otter Lake','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.214142,-83.425096,0,'2013-07-06 12:44:32',NULL,NULL),(61800,'73093','S','Washington','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.128596,-97.486449,0,'2013-07-06 12:44:33',NULL,NULL),(19382,'20064','U','Catholic Univ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.937522,-76.996839,0,'2013-07-06 12:44:31',NULL,NULL),(27543,'30236','S','Lake Spivey','A','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.511823,-84.316803,0,'2013-07-06 12:44:31',NULL,NULL),(36200,'40268','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.146878,-85.870680,0,'2013-07-06 12:44:32',NULL,NULL),(78441,'98058','S','Cascade','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.444411,-122.142843,0,'2013-07-06 12:44:34',NULL,NULL),(6302,'05656','S','Johnson','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.642580,-72.669900,0,'2013-07-06 12:44:30',NULL,NULL),(28908,'32137','S','Palm Coast','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.541470,-81.226479,0,'2013-07-06 12:44:32',NULL,NULL),(33212,'37050','S','Cumberlnd Cty','A','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.375503,-87.563413,0,'2013-07-06 12:44:32',NULL,NULL),(30221,'33186','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661132,-80.407574,0,'2013-07-06 12:44:32',NULL,NULL),(44175,'49548','S','Kentwood','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866570,-85.660484,0,'2013-07-06 12:44:32',NULL,NULL),(15257,'16058','P','Turkey City','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.187943,-79.613578,0,'2013-07-06 12:44:31',NULL,NULL),(30729,'33527','S','Dover','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.982324,-82.223137,0,'2013-07-06 12:44:32',NULL,NULL),(62604,'74525','S','Farris','A','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.385284,-96.132110,0,'2013-07-06 12:44:33',NULL,NULL),(33954,'38101','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.131068,-90.054586,0,'2013-07-06 12:44:32',NULL,NULL),(16383,'17211','S','Mann','N','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.767488,-78.406126,0,'2013-07-06 12:44:31',NULL,NULL),(39300,'44505','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.112602,-80.609229,0,'2013-07-06 12:44:32',NULL,NULL),(68984,'83119','P','Fairview','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.680197,-111.001229,0,'2013-07-06 12:44:34',NULL,NULL),(61024,'72117','S','Baucum','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(37611,'42130','S','88','N','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.924418,-85.789972,0,'2013-07-06 12:44:32',NULL,NULL),(34552,'38725','S','Benoit','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(45633,'51638','S','Essex','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.835360,-95.301959,0,'2013-07-06 12:44:32',NULL,NULL),(25684,'28520','S','Cedar Island','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.941960,-76.335610,0,'2013-07-06 12:44:31',NULL,NULL),(44901,'50324','S','Clive','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543762,-93.586549,0,'2013-07-06 12:44:32',NULL,NULL),(10151,'10276','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733951,-73.989188,0,'2013-07-06 12:44:30',NULL,NULL),(56547,'65457','S','Devils Elbow','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.823341,-92.065045,0,'2013-07-06 12:44:33',NULL,NULL),(35812,'39759','S','Patrick','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(43879,'49221','S','Adrian','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.904241,-84.050711,0,'2013-07-06 12:44:32',NULL,NULL),(5036,'04258','S','Minot','D','Androscoggin','23001','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.061205,-70.415162,0,'2013-07-06 12:44:30',NULL,NULL),(46280,'53036','S','Ixonia','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.135872,-88.583574,0,'2013-07-06 12:44:32',NULL,NULL),(28165,'30909','S','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.478228,-82.067015,0,'2013-07-06 12:44:31',NULL,NULL),(32860,'36511','S','Bon Secour','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.314881,-87.725251,0,'2013-07-06 12:44:32',NULL,NULL),(43268,'48329','S','Waterford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.688849,-83.399301,0,'2013-07-06 12:44:32',NULL,NULL),(28278,'31087','S','Mayfield','A','Hancock','13141','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.277104,-82.971578,0,'2013-07-06 12:44:31',NULL,NULL),(61665,'72916','S','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.326437,-94.423658,0,'2013-07-06 12:44:33',NULL,NULL),(63240,'75474','S','West Tawakoni','A','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.910912,-96.135472,0,'2013-07-06 12:44:33',NULL,NULL),(64227,'76305','S','Dean','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(69667,'84017','S','Hoytsville','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.804680,-111.296340,0,'2013-07-06 12:44:34',NULL,NULL),(25212,'28081','S','Fisher Town','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(44971,'50401','S','Portland','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(54158,'62572','S','Atwater','A','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.378868,-89.648886,0,'2013-07-06 12:44:33',NULL,NULL),(37380,'41745','S','Gays Creek','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.350359,-83.448518,0,'2013-07-06 12:44:32',NULL,NULL),(29851,'33036','S','Matecumbe Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(76022,'95133','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.375782,-121.856892,0,'2013-07-06 12:44:34',NULL,NULL),(6948,'06183','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.764012,-72.685950,0,'2013-07-06 12:44:30',NULL,NULL),(11772,'12203','S','Stuyvesant Plaza','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(6083,'05450','S','East Sheldon','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(16852,'17562','S','Vintage','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(45474,'51333','S','Dickens','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.170368,-94.970954,0,'2013-07-06 12:44:32',NULL,NULL),(31849,'35111','S','Lake View','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.268815,-87.144228,0,'2013-07-06 12:44:32',NULL,NULL),(42008,'47431','S','Arney','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.211607,-86.851623,0,'2013-07-06 12:44:32',NULL,NULL),(5748,'05036','S','Brookfield','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.033106,-72.595924,0,'2013-07-06 12:44:30',NULL,NULL),(79862,'99558','P','Anvik','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.994017,-160.400282,0,'2013-07-06 12:44:34',NULL,NULL),(70230,'84404','S','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(36337,'40402','S','Dabolt','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.303317,-84.007453,0,'2013-07-06 12:44:32',NULL,NULL),(37339,'41669','S','Wheelwright','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.334317,-82.720582,0,'2013-07-06 12:44:32',NULL,NULL),(52817,'61283','S','Thomas','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.637702,-89.784655,0,'2013-07-06 12:44:33',NULL,NULL),(71845,'87583','P','El Cerrito','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.232598,-105.520380,0,'2013-07-06 12:44:34',NULL,NULL),(33405,'37229','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162527,-86.663695,0,'2013-07-06 12:44:32',NULL,NULL),(13982,'14488','P','Livonia Ctr','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.818813,-77.642260,0,'2013-07-06 12:44:31',NULL,NULL),(27504,'30177','S','Tate','D','Pickens','13227','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.462624,-84.317684,0,'2013-07-06 12:44:31',NULL,NULL),(54199,'62634','S','Broadwell','A','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.016327,-89.480200,0,'2013-07-06 12:44:33',NULL,NULL),(53831,'62305','S','Columbus','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.929831,-91.304424,0,'2013-07-06 12:44:33',NULL,NULL),(6939,'06176','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768415,-72.669185,0,'2013-07-06 12:44:30',NULL,NULL),(8167,'07865','S','Port Murray','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.787160,-74.900483,0,'2013-07-06 12:44:30',NULL,NULL),(63748,'75938','S','Rockland','A','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.912780,-94.420200,0,'2013-07-06 12:44:34',NULL,NULL),(44296,'49728','S','Eckerman','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.332529,-85.176969,0,'2013-07-06 12:44:32',NULL,NULL),(29613,'32856','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.513146,-81.371713,0,'2013-07-06 12:44:32',NULL,NULL),(1361,'00736','S','Urb Carrasquillo','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(6091,'05450','S','Samsonville','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(49474,'56655','S','Brevik','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(29848,'33035','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.379693,-80.406632,0,'2013-07-06 12:44:32',NULL,NULL),(76315,'95452','S','Kenwood','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.414881,-122.553830,0,'2013-07-06 12:44:34',NULL,NULL),(67797,'80732','P','Hereford','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.974649,-104.303001,0,'2013-07-06 12:44:34',NULL,NULL),(38277,'43323','S','Harpster','D','Wyandot','39175','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.743966,-83.235166,0,'2013-07-06 12:44:32',NULL,NULL),(18915,'19492','S','Zieglerville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.283333,-75.483333,0,'2013-07-06 12:44:31',NULL,NULL),(75549,'94240','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585287,-121.494786,0,'2013-07-06 12:44:34',NULL,NULL),(66643,'78837','S','Comstock','D','Val Verde','48465','Texas','TX','48','0000','432','Central',-6.0,'Y',29.688730,-101.174400,0,'2013-07-06 12:44:34',NULL,NULL),(23761,'25962','S','Hilton Vlg','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(33524,'37379','S','Lakesite','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.265858,-85.160818,0,'2013-07-06 12:44:32',NULL,NULL),(21340,'22427','S','Bowling Green','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.049038,-77.350933,0,'2013-07-06 12:44:31',NULL,NULL),(31325,'34133','P','Bonita Springs','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.382005,-81.710252,0,'2013-07-06 12:44:32',NULL,NULL),(8048,'07735','S','Cliffwood Bch','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.438200,-74.201940,0,'2013-07-06 12:44:30',NULL,NULL),(1794,'00783','S','Urb El Centro','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(46552,'53501','P','Afton','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.602616,-89.068462,0,'2013-07-06 12:44:32',NULL,NULL),(65279,'77480','S','Sugar Valley','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.059338,-95.705377,0,'2013-07-06 12:44:34',NULL,NULL),(29815,'33026','S','Cooper City','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028424,-80.296813,0,'2013-07-06 12:44:32',NULL,NULL),(8700,'08352','P','Rosenhayn','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.478761,-75.130541,0,'2013-07-06 12:44:30',NULL,NULL),(73515,'91342','S','Lake View Terrace','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.303046,-118.421940,0,'2013-07-06 12:44:34',NULL,NULL),(61674,'72928','S','Branch','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.287852,-93.943319,0,'2013-07-06 12:44:33',NULL,NULL),(32186,'35502','P','Jasper','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.828491,-87.277348,0,'2013-07-06 12:44:32',NULL,NULL),(26026,'28679','S','Beech Creek','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273480,-81.876420,0,'2013-07-06 12:44:31',NULL,NULL),(73714,'91612','U','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186548,-118.396887,0,'2013-07-06 12:44:34',NULL,NULL),(68887,'82715','S','Four Corners','D','Weston','56045','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.123796,-104.118400,0,'2013-07-06 12:44:34',NULL,NULL),(2967,'01050','S','Crescent Mills','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(15098,'15767','S','Frostburg','A','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.944773,-78.978341,0,'2013-07-06 12:44:31',NULL,NULL),(76808,'95948','S','Manzanita','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.358225,-121.696103,0,'2013-07-06 12:44:34',NULL,NULL),(76031,'95141','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.176147,-121.751682,0,'2013-07-06 12:44:34',NULL,NULL),(73143,'90275','S','Rancho Palos Verdes','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(45126,'50566','S','Roelyn','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.445392,-94.290298,0,'2013-07-06 12:44:32',NULL,NULL),(2475,'00956','S','Urb Agustin Stahl','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(21423,'22547','P','Sealston','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.250467,-77.311067,0,'2013-07-06 12:44:31',NULL,NULL),(51791,'60046','S','Fox Lake Hills','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(48469,'55719','S','Chisholm','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.519753,-92.880286,0,'2013-07-06 12:44:33',NULL,NULL),(58827,'69043','S','Stratton','D','Hitchcock','31087','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.149059,-101.228232,0,'2013-07-06 12:44:33',NULL,NULL),(8580,'08217','P','Elwood','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.578807,-74.715895,0,'2013-07-06 12:44:30',NULL,NULL),(15468,'16424','S','Linesville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.643900,-80.452080,0,'2013-07-06 12:44:31',NULL,NULL),(18336,'19029','S','Essington','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868240,-75.294939,0,'2013-07-06 12:44:31',NULL,NULL),(55899,'64436','S','Cosby','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.850155,-94.682207,0,'2013-07-06 12:44:33',NULL,NULL),(36077,'40213','S','Lynnview','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.184398,-85.716074,0,'2013-07-06 12:44:32',NULL,NULL),(39824,'45150','S','Milford','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.178746,-84.246032,0,'2013-07-06 12:44:32',NULL,NULL),(46998,'54241','S','Two Rivers','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.180296,-87.602195,0,'2013-07-06 12:44:32',NULL,NULL),(20606,'21207','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.323820,-76.714260,0,'2013-07-06 12:44:31',NULL,NULL),(4639,'03740','S','Bath','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.180623,-71.951870,0,'2013-07-06 12:44:30',NULL,NULL),(74328,'92401','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.106372,-117.291391,0,'2013-07-06 12:44:34',NULL,NULL),(23290,'25173','S','Beards Fork','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.099577,-81.247750,0,'2013-07-06 12:44:31',NULL,NULL),(38991,'44133','S','N Royalton','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.315718,-81.741271,0,'2013-07-06 12:44:32',NULL,NULL),(46116,'52637','S','Northfield','N','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.007600,-91.097940,0,'2013-07-06 12:44:32',NULL,NULL),(66064,'78380','S','Violet','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(61680,'72936','S','Greenwood','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.217776,-94.260958,0,'2013-07-06 12:44:33',NULL,NULL),(56939,'66085','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.800200,-94.647263,0,'2013-07-06 12:44:33',NULL,NULL),(23653,'25812','S','Ansted','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.136992,-81.094222,0,'2013-07-06 12:44:31',NULL,NULL),(24513,'27281','S','Marcus','N','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(70704,'85268','S','Fountain Hls','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.608995,-111.729537,0,'2013-07-06 12:44:34',NULL,NULL),(18268,'19007','S','West Bristol','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.111586,-74.861944,0,'2013-07-06 12:44:31',NULL,NULL),(68833,'82516','S','Kinnear','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.238224,-108.815850,0,'2013-07-06 12:44:34',NULL,NULL),(60991,'72112','S','Auvergne','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(6149,'05466','P','Jonesville','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.540678,-73.209576,0,'2013-07-06 12:44:30',NULL,NULL),(49654,'56999','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8872','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(36057,'40207','S','Maryhill Ests','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(34134,'38223','P','Como','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.357791,-88.463805,0,'2013-07-06 12:44:32',NULL,NULL),(8104,'07802','P','Dover','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.854243,-74.574694,0,'2013-07-06 12:44:30',NULL,NULL),(43674,'48864','S','Okemos','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.707769,-84.420750,0,'2013-07-06 12:44:32',NULL,NULL),(25728,'28547','S','Naval Hos','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.704321,-77.349467,0,'2013-07-06 12:44:31',NULL,NULL),(44507,'49934','P','Hubbell','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.175317,-88.430414,0,'2013-07-06 12:44:32',NULL,NULL),(73823,'91768','S','Pomona','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.068677,-117.774134,0,'2013-07-06 12:44:34',NULL,NULL),(43104,'48218','S','River Rouge','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331389,-83.045833,0,'2013-07-06 12:44:32',NULL,NULL),(37265,'41568','S','Stopover','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.519380,-82.054500,0,'2013-07-06 12:44:32',NULL,NULL),(2203,'00926','S','Repto Oyola','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(22205,'23511','S','Norfolk Naval Public Works C','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(12032,'12520','S','Cornwall Hdsn','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.442299,-74.015486,0,'2013-07-06 12:44:30',NULL,NULL),(69353,'83545','S','Peck','D','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.471981,-116.419698,0,'2013-07-06 12:44:34',NULL,NULL),(7455,'06858','U','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.130471,-73.440439,0,'2013-07-06 12:44:30',NULL,NULL),(75436,'94040','S','Mt View','N','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.380469,-122.081870,0,'2013-07-06 12:44:34',NULL,NULL),(73656,'91503','P','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.180668,-118.307534,0,'2013-07-06 12:44:34',NULL,NULL),(72378,'89034','S','Mesquite','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',37.938770,-114.449503,0,'2013-07-06 12:44:34',NULL,NULL),(3006,'01075','S','South Hadley','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.253320,-72.579900,0,'2013-07-06 12:44:30',NULL,NULL),(35614,'39601','S','Union Hall','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(57078,'66215','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(66303,'78586','S','Ranchito','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(52056,'60199','S','North Suburban','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.916124,-88.103082,0,'2013-07-06 12:44:33',NULL,NULL),(74070,'92171','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.781734,-117.171530,0,'2013-07-06 12:44:34',NULL,NULL),(73250,'90704','P','Catalina','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.342834,-118.327634,0,'2013-07-06 12:44:34',NULL,NULL),(70201,'84341','S','Logan','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.781188,-111.822443,0,'2013-07-06 12:44:34',NULL,NULL),(3283,'01477','P','Winchdon Spgs','A','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.695867,-72.017823,0,'2013-07-06 12:44:30',NULL,NULL),(31347,'34146','P','Marco Island','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.943277,-81.715711,0,'2013-07-06 12:44:32',NULL,NULL),(11694,'12157','S','Schoharie','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.668153,-74.311743,0,'2013-07-06 12:44:30',NULL,NULL),(38986,'44131','S','Seven Hills','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(22894,'24589','S','Scottsburg','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.771223,-78.761974,0,'2013-07-06 12:44:31',NULL,NULL),(1340,'00736','S','Bo Montellano','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(54055,'62471','S','Shafter','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.967418,-89.105783,0,'2013-07-06 12:44:33',NULL,NULL),(36315,'40379','S','Stamping Grd','A','Scott','21209','Kentucky','KY','21','4280','502','Eastern',-5.0,'Y',38.296886,-84.675833,0,'2013-07-06 12:44:32',NULL,NULL),(52881,'61346','P','New Bedford','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.537255,-89.755983,0,'2013-07-06 12:44:33',NULL,NULL),(13353,'13696','S','West Stockholm','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.734551,-74.887585,0,'2013-07-06 12:44:30',NULL,NULL),(43226,'48311','P','Sterling Hts','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.578334,-83.028442,0,'2013-07-06 12:44:32',NULL,NULL),(14713,'15270','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403948,-80.034848,0,'2013-07-06 12:44:31',NULL,NULL),(34469,'38663','S','Peoples','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(20657,'21226','S','Chstnt Hl Cv','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(13837,'14221','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980183,-78.734894,0,'2013-07-06 12:44:31',NULL,NULL),(30429,'33329','P','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111170,-80.274605,0,'2013-07-06 12:44:32',NULL,NULL),(56330,'65107','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578678,-92.173699,0,'2013-07-06 12:44:33',NULL,NULL),(12394,'12926','S','Trout River','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.947620,-74.337300,0,'2013-07-06 12:44:30',NULL,NULL),(49908,'57301','S','Lake Mitchell','N','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.727400,-98.046180,0,'2013-07-06 12:44:33',NULL,NULL),(69791,'84065','S','Bluffdale','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.535262,-111.962723,0,'2013-07-06 12:44:34',NULL,NULL),(66453,'78653','S','Manda','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(30649,'33458','S','Jupiter','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.935471,-80.116253,0,'2013-07-06 12:44:32',NULL,NULL),(29537,'32792','S','Winter Park','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.595103,-81.304723,0,'2013-07-06 12:44:32',NULL,NULL),(4593,'03582','S','Stark','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.600195,-71.510658,0,'2013-07-06 12:44:30',NULL,NULL),(25423,'28303','S','Eutaw','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.081833,-78.962365,0,'2013-07-06 12:44:31',NULL,NULL),(63809,'75963','P','Nacogdoches','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.632096,-94.637320,0,'2013-07-06 12:44:34',NULL,NULL),(67638,'80456','S','Fairplay','A','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.224722,-106.001389,0,'2013-07-06 12:44:34',NULL,NULL),(41475,'46928','S','Fairmount','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.416231,-85.644682,0,'2013-07-06 12:44:32',NULL,NULL),(44794,'50226','S','Polk City','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.783383,-93.705476,0,'2013-07-06 12:44:32',NULL,NULL),(47209,'54491','S','White Lake','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.187800,-88.731300,0,'2013-07-06 12:44:32',NULL,NULL),(78447,'98061','P','Rollingbay','D','Kitsap','53035','Washington','WA','53','1150','206/564','Pacific',-8.0,'Y',47.652184,-122.548994,0,'2013-07-06 12:44:34',NULL,NULL),(77232,'96516','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(17964,'18602','P','Bear Creek','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.217900,-75.811440,0,'2013-07-06 12:44:31',NULL,NULL),(51781,'60042','S','Island Lake','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.276449,-88.211479,0,'2013-07-06 12:44:33',NULL,NULL),(48776,'55987','S','Winona','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(66764,'79018','S','Channing','D','Hartley','48205','Texas','TX','48','0000','806','Central',-6.0,'Y',35.774520,-102.413280,0,'2013-07-06 12:44:34',NULL,NULL),(23291,'25173','S','Robson','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.099577,-81.247750,0,'2013-07-06 12:44:31',NULL,NULL),(40275,'45434','S','Beavercreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.712421,-84.041488,0,'2013-07-06 12:44:32',NULL,NULL),(41926,'47383','S','Selma','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.185979,-85.275224,0,'2013-07-06 12:44:32',NULL,NULL),(74127,'92240','S','Dsrt Hot Spgs','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.963925,-116.531153,0,'2013-07-06 12:44:34',NULL,NULL),(69077,'83245','S','Inkom','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.795065,-112.236010,0,'2013-07-06 12:44:34',NULL,NULL),(67550,'80264','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741063,-104.984981,0,'2013-07-06 12:44:34',NULL,NULL),(11975,'12465','S','Pine Hill','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.129525,-74.481912,0,'2013-07-06 12:44:30',NULL,NULL),(16304,'17111','S','Swatara','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.270440,-76.805460,0,'2013-07-06 12:44:31',NULL,NULL),(36032,'40175','S','Vine Grove','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.814263,-85.990010,0,'2013-07-06 12:44:32',NULL,NULL),(7251,'06514','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.372400,-72.939720,0,'2013-07-06 12:44:30',NULL,NULL),(29380,'32608','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.602269,-82.399138,0,'2013-07-06 12:44:32',NULL,NULL),(49867,'57256','S','Ortley','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.154950,-97.204176,0,'2013-07-06 12:44:33',NULL,NULL),(57673,'67219','S','Park City','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.756398,-97.317064,0,'2013-07-06 12:44:33',NULL,NULL),(40494,'45789','S','Wingett Run','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.583134,-81.240660,0,'2013-07-06 12:44:32',NULL,NULL),(44485,'49912','S','Bruce Crossing','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.538683,-89.202693,0,'2013-07-06 12:44:32',NULL,NULL),(63349,'75615','P','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.464337,-94.728472,0,'2013-07-06 12:44:33',NULL,NULL),(61516,'72655','S','Mount Judea','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.920000,-93.060000,0,'2013-07-06 12:44:33',NULL,NULL),(60999,'72112','S','Newport','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(10763,'11363','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.773215,-73.746899,0,'2013-07-06 12:44:30',NULL,NULL),(10274,'10510','S','Scarborough','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.145661,-73.833747,0,'2013-07-06 12:44:30',NULL,NULL),(77497,'96828','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.291312,-157.819996,0,'2013-07-06 12:44:34',NULL,NULL),(38500,'43701','S','Sonora','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.954240,-81.984960,0,'2013-07-06 12:44:32',NULL,NULL),(34975,'39087','P','Hillsboro','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.456505,-89.511242,0,'2013-07-06 12:44:32',NULL,NULL),(34498,'38669','P','Clarksdale','A','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.189654,-90.626670,0,'2013-07-06 12:44:32',NULL,NULL),(20885,'21701','S','Hood College','N','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.418320,-77.336160,0,'2013-07-06 12:44:31',NULL,NULL),(9220,'09513','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(23801,'26036','S','Dallas','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.976008,-80.561714,0,'2013-07-06 12:44:31',NULL,NULL),(53874,'62346','S','La Prairie','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.165596,-90.970804,0,'2013-07-06 12:44:33',NULL,NULL),(66708,'78947','S','Tanglewood','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.391667,-97.147222,0,'2013-07-06 12:44:34',NULL,NULL),(29089,'32259','S','St Johns','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(48004,'55155','U','State Offices','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.962818,-93.123683,0,'2013-07-06 12:44:33',NULL,NULL),(7794,'07432','S','Midland Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.995725,-74.139296,0,'2013-07-06 12:44:30',NULL,NULL),(40888,'46244','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.774382,-86.158793,0,'2013-07-06 12:44:32',NULL,NULL),(6327,'05664','P','Northfield Falls','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.171996,-72.651009,0,'2013-07-06 12:44:30',NULL,NULL),(18418,'19061','S','Boothwyn','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(25536,'28402','P','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.238808,-77.948973,0,'2013-07-06 12:44:31',NULL,NULL),(9043,'08880','S','South Bound Brook','D','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.553052,-74.530292,0,'2013-07-06 12:44:30',NULL,NULL),(28264,'31075','S','Rentz','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.334705,-82.885950,0,'2013-07-06 12:44:31',NULL,NULL),(65562,'77843','U','Tx A & M University','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.611331,-96.348373,0,'2013-07-06 12:44:34',NULL,NULL),(32058,'35261','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573309,-86.715321,0,'2013-07-06 12:44:32',NULL,NULL),(53064,'61517','S','Brimfield','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.825159,-89.850815,0,'2013-07-06 12:44:33',NULL,NULL),(16153,'17061','S','Millersburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(5666,'04961','S','North New Portland','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(62291,'74020','S','Cleveland','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.273480,-96.430080,0,'2013-07-06 12:44:33',NULL,NULL),(53439,'61872','S','Sadorus','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.967676,-88.348051,0,'2013-07-06 12:44:33',NULL,NULL),(24817,'27604','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.866620,-78.531900,0,'2013-07-06 12:44:31',NULL,NULL),(14204,'14775','S','Ripley','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.264580,-79.707146,0,'2013-07-06 12:44:31',NULL,NULL),(30853,'33650','U','Home Shopping Club','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.968812,-82.518425,0,'2013-07-06 12:44:32',NULL,NULL),(67144,'79769','P','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.844554,-102.363978,0,'2013-07-06 12:44:34',NULL,NULL),(40788,'46167','S','Pittsboro','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.878885,-86.469256,0,'2013-07-06 12:44:32',NULL,NULL),(44724,'50152','P','Luther','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.994938,-93.862586,0,'2013-07-06 12:44:32',NULL,NULL),(8651,'08313','P','Deerfield','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.530646,-75.231010,0,'2013-07-06 12:44:30',NULL,NULL),(76686,'95817','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.551191,-121.457782,0,'2013-07-06 12:44:34',NULL,NULL),(56642,'65612','S','Bois D Arc','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.221093,-93.560283,0,'2013-07-06 12:44:33',NULL,NULL),(41490,'46943','S','Laketon','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.973045,-85.837383,0,'2013-07-06 12:44:32',NULL,NULL),(3829,'02332','S','Duxbury','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.037692,-70.710603,0,'2013-07-06 12:44:30',NULL,NULL),(6443,'05753','S','Middlebury','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.012313,-73.163211,0,'2013-07-06 12:44:30',NULL,NULL),(41656,'47142','S','Mauckport','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.092395,-86.191402,0,'2013-07-06 12:44:32',NULL,NULL),(51809,'60050','S','Holiday Hills','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(67549,'80263','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.832482,-105.007481,0,'2013-07-06 12:44:34',NULL,NULL),(24524,'27288','S','Draper','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(55635,'64012','S','Vlg Loch Loyd','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.806411,-94.535486,0,'2013-07-06 12:44:33',NULL,NULL),(43101,'48217','S','Delray','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.276563,-83.152089,0,'2013-07-06 12:44:32',NULL,NULL),(64636,'76707','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.554463,-97.158932,0,'2013-07-06 12:44:34',NULL,NULL),(70300,'84537','P','Orangeville','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.232973,-111.055146,0,'2013-07-06 12:44:34',NULL,NULL),(58364,'68522','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.791967,-96.738854,0,'2013-07-06 12:44:33',NULL,NULL),(17830,'18416','P','Elmhurst','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.373414,-75.548628,0,'2013-07-06 12:44:31',NULL,NULL),(42669,'47962','P','Montmorenci','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.474179,-87.030010,0,'2013-07-06 12:44:32',NULL,NULL),(41886,'47370','P','Pershing','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.815011,-85.136637,0,'2013-07-06 12:44:32',NULL,NULL),(38726,'44022','S','South Russell','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(56289,'65077','S','Reform','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757061,-91.782634,0,'2013-07-06 12:44:33',NULL,NULL),(54355,'62794','P','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.761841,-89.631213,0,'2013-07-06 12:44:33',NULL,NULL),(35119,'39211','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.370898,-90.128060,0,'2013-07-06 12:44:32',NULL,NULL),(44801,'50232','S','Reasnor','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.587056,-93.019302,0,'2013-07-06 12:44:32',NULL,NULL),(1624,'00771','S','Jard de Oriente','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(51348,'59322','S','Cohagen','D','Garfield','30033','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.087081,-106.512996,0,'2013-07-06 12:44:33',NULL,NULL),(48501,'55736','S','Floodwood','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(23330,'25241','S','Evans','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.806480,-81.797745,0,'2013-07-06 12:44:31',NULL,NULL),(34622,'38754','S','Caile','N','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.260452,-90.592415,0,'2013-07-06 12:44:32',NULL,NULL),(40368,'45645','S','Kitts Hill','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.576404,-82.529368,0,'2013-07-06 12:44:32',NULL,NULL),(36499,'40818','S','Coalgood','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.807791,-83.237338,0,'2013-07-06 12:44:32',NULL,NULL),(46991,'54235','S','Institute','N','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(70750,'85323','S','Avondale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.429286,-112.345055,0,'2013-07-06 12:44:34',NULL,NULL),(4594,'03583','S','Jefferson','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.394373,-71.432883,0,'2013-07-06 12:44:30',NULL,NULL),(25860,'28629','S','Glendale Springs','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.347119,-81.382714,0,'2013-07-06 12:44:31',NULL,NULL),(27058,'29682','S','Six Mile','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.829053,-82.831145,0,'2013-07-06 12:44:31',NULL,NULL),(66420,'78638','S','Kingsbury','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.687386,-97.803855,0,'2013-07-06 12:44:34',NULL,NULL),(58151,'68172','U','Omaha Brm','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260689,-95.940590,0,'2013-07-06 12:44:33',NULL,NULL),(13718,'14082','S','Java Center','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.657968,-78.385303,0,'2013-07-06 12:44:31',NULL,NULL),(9176,'09363','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(14738,'15310','S','Aleppo','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.823270,-80.462303,0,'2013-07-06 12:44:31',NULL,NULL),(5255,'04485','P','Greenville','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.503846,-69.469162,0,'2013-07-06 12:44:30',NULL,NULL),(19345,'20041','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.834503,-77.210807,0,'2013-07-06 12:44:31',NULL,NULL),(7943,'07663','S','Saddle Brook','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.902033,-74.100102,0,'2013-07-06 12:44:30',NULL,NULL),(71040,'85742','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.419441,-111.059263,0,'2013-07-06 12:44:34',NULL,NULL),(78295,'97882','S','Umatilla','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.915922,-119.296745,0,'2013-07-06 12:44:34',NULL,NULL),(69867,'84093','S','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.590896,-111.828061,0,'2013-07-06 12:44:34',NULL,NULL),(62408,'74121','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.148687,-95.980328,0,'2013-07-06 12:44:33',NULL,NULL),(55410,'63650','S','Ironton','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.601823,-90.629002,0,'2013-07-06 12:44:33',NULL,NULL),(55105,'63330','S','Annada','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.255883,-90.803454,0,'2013-07-06 12:44:33',NULL,NULL),(18534,'19110','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953564,-75.166015,0,'2013-07-06 12:44:31',NULL,NULL),(9790,'10108','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(33153,'37011','P','Antioch','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.172524,-86.880844,0,'2013-07-06 12:44:32',NULL,NULL),(47523,'54806','S','Lac du Flambeau Reservation','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(47236,'54501','S','Sugar Camp','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(43668,'48859','U','Central Michigan University','N','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.597602,-84.778009,0,'2013-07-06 12:44:32',NULL,NULL),(40245,'45428','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.751559,-84.250474,0,'2013-07-06 12:44:32',NULL,NULL),(38209,'43213','S','Whitehall','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.965354,-82.875172,0,'2013-07-06 12:44:32',NULL,NULL),(13264,'13648','S','Pitcairn','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(69251,'83423','S','Reno','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(70290,'84533','S','Hite','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(38372,'43466','S','Wayne','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.291967,-83.509580,0,'2013-07-06 12:44:32',NULL,NULL),(14647,'15235','S','Universal','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445040,-79.913760,0,'2013-07-06 12:44:31',NULL,NULL),(8361,'08051','S','Mantua','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.787980,-75.181295,0,'2013-07-06 12:44:30',NULL,NULL),(19936,'20570','U','Natl Labor Relations Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897985,-77.041530,0,'2013-07-06 12:44:31',NULL,NULL),(67690,'80516','S','Frederick','A','Boulder','08013','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.055613,-105.026348,0,'2013-07-06 12:44:34',NULL,NULL),(20275,'20788','P','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964901,-76.966704,0,'2013-07-06 12:44:31',NULL,NULL),(43301,'48343','P','Pontiac','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.640408,-83.290741,0,'2013-07-06 12:44:32',NULL,NULL),(64734,'76888','S','Leaday','A','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.567778,-99.672778,0,'2013-07-06 12:44:34',NULL,NULL),(65677,'77988','P','Telferner','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.849598,-96.887206,0,'2013-07-06 12:44:34',NULL,NULL),(68147,'80997','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.877688,-104.819099,0,'2013-07-06 12:44:34',NULL,NULL),(68480,'81248','P','Sargents','D','Saguache','08109','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.539419,-106.395042,0,'2013-07-06 12:44:34',NULL,NULL),(70303,'84540','S','Thompson','D','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.035892,-109.696213,0,'2013-07-06 12:44:34',NULL,NULL),(46968,'54208','S','Stangelville','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.368075,-87.854079,0,'2013-07-06 12:44:32',NULL,NULL),(28167,'30912','U','Georgia Regents Univeristy','N','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.473519,-81.988250,0,'2013-07-06 12:44:31',NULL,NULL),(1308,'00734','P','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',17.986721,-66.608975,0,'2013-07-06 12:44:30',NULL,NULL),(18911,'19484','P','Valley Forge','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.111315,-75.402927,0,'2013-07-06 12:44:31',NULL,NULL),(60825,'72035','U','Univ of Central','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.073922,-92.457553,0,'2013-07-06 12:44:33',NULL,NULL),(45952,'52352','S','Walker','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.269223,-91.760343,0,'2013-07-06 12:44:32',NULL,NULL),(28997,'32219','S','Dinsmore','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.410491,-81.807977,0,'2013-07-06 12:44:32',NULL,NULL),(79317,'98601','S','Amboy','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.863781,-122.506327,0,'2013-07-06 12:44:34',NULL,NULL),(70786,'85352','P','Tacna','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.701861,-113.966590,0,'2013-07-06 12:44:34',NULL,NULL),(16654,'17347','S','Starview','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.054598,-76.690743,0,'2013-07-06 12:44:31',NULL,NULL),(21466,'22626','P','Fishers Hill','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.979185,-78.405016,0,'2013-07-06 12:44:31',NULL,NULL),(21050,'21901','S','Northeast','N','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.590075,-75.955936,0,'2013-07-06 12:44:31',NULL,NULL),(31432,'34267','P','Fort Ogden','D','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.087121,-81.954404,0,'2013-07-06 12:44:32',NULL,NULL),(46996,'54235','S','Valmy','N','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(12877,'13326','S','Cooperstown','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.716131,-74.906704,0,'2013-07-06 12:44:30',NULL,NULL),(32864,'36518','S','Chatom','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.465242,-88.237087,0,'2013-07-06 12:44:32',NULL,NULL),(10889,'11423','S','Hollis','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.716723,-73.768410,0,'2013-07-06 12:44:30',NULL,NULL),(79969,'99644','P','Ouzinkie','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.415483,-153.532034,0,'2013-07-06 12:44:34',NULL,NULL),(69939,'84115','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(6745,'06082','S','North Thompsonville','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986942,-72.565275,0,'2013-07-06 12:44:30',NULL,NULL),(38279,'43325','P','Iberia','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.666089,-82.841658,0,'2013-07-06 12:44:32',NULL,NULL),(4506,'03291','S','W Nottingham','A','Rockingham','33015','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.173142,-71.136707,0,'2013-07-06 12:44:30',NULL,NULL),(21571,'22831','S','Hinton','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.485855,-79.006346,0,'2013-07-06 12:44:31',NULL,NULL),(51189,'59026','S','Edgar','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.506601,-109.009043,0,'2013-07-06 12:44:33',NULL,NULL),(79372,'98662','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.671298,-122.559764,0,'2013-07-06 12:44:34',NULL,NULL),(62785,'74878','S','Wanette','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.990948,-97.035680,0,'2013-07-06 12:44:33',NULL,NULL),(1695,'00777','S','Urb El Encanto','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(39103,'44237','U','Allstate Ins Co','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.254965,-81.481388,0,'2013-07-06 12:44:32',NULL,NULL),(42979,'48140','S','Ida','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.875757,-83.580330,0,'2013-07-06 12:44:32',NULL,NULL),(11608,'12092','S','Barnerville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.711693,-74.363530,0,'2013-07-06 12:44:30',NULL,NULL),(25609,'28456','S','Sandyfield','A','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.344900,-78.257820,0,'2013-07-06 12:44:31',NULL,NULL),(52457,'60675','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.880651,-87.630041,0,'2013-07-06 12:44:33',NULL,NULL),(53250,'61701','S','Eastland Shopping Center','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(20396,'20897','U','Suburb Maryland Fac','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.087874,-77.054787,0,'2013-07-06 12:44:31',NULL,NULL),(73492,'91326','S','Porter Ranch','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.276626,-118.543741,0,'2013-07-06 12:44:34',NULL,NULL),(70139,'84305','P','Clarkston','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.919228,-112.037397,0,'2013-07-06 12:44:34',NULL,NULL),(53074,'61523','S','Galena Knolls','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(16121,'17056','P','Mexico','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.536642,-77.354394,0,'2013-07-06 12:44:31',NULL,NULL),(44973,'50402','P','Mason City','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.151666,-93.204478,0,'2013-07-06 12:44:32',NULL,NULL),(58932,'69346','S','Harrison','D','Sioux','31165','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.688129,-103.882560,0,'2013-07-06 12:44:33',NULL,NULL),(9459,'10007','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(11830,'12241','U','NY Workman Comp','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.630394,-73.761975,0,'2013-07-06 12:44:30',NULL,NULL),(40180,'45371','S','Tipp','N','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.955039,-84.178566,0,'2013-07-06 12:44:32',NULL,NULL),(2198,'00926','S','Paseo Real','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(31435,'34269','S','Arcadia','D','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.166492,-81.804395,0,'2013-07-06 12:44:32',NULL,NULL),(52640,'61053','S','Mount Carroll','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.098801,-89.975105,0,'2013-07-06 12:44:33',NULL,NULL),(37268,'41572','S','Etty','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.341120,-82.650600,0,'2013-07-06 12:44:32',NULL,NULL),(63670,'75855','S','Butler','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.580983,-95.892859,0,'2013-07-06 12:44:34',NULL,NULL),(59655,'71048','S','Lisbon','D','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.842916,-92.857990,0,'2013-07-06 12:44:33',NULL,NULL),(56847,'65897','U','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.199100,-93.276100,0,'2013-07-06 12:44:33',NULL,NULL),(28000,'30602','U','University of Georgia','N','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.903503,-83.318464,0,'2013-07-06 12:44:31',NULL,NULL),(9382,'09840','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8901,'08733','S','Manchester','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(73891,'91977','S','Spring Valley','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.722070,-116.993911,0,'2013-07-06 12:44:34',NULL,NULL),(31198,'33945','P','Pineland','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.660469,-82.144604,0,'2013-07-06 12:44:32',NULL,NULL),(58433,'68667','S','Surprise','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.097180,-97.313400,0,'2013-07-06 12:44:33',NULL,NULL),(66352,'78611','S','Burnet','D','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.759861,-98.225244,0,'2013-07-06 12:44:34',NULL,NULL),(68303,'81092','S','Big Bend','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.158784,-102.714060,0,'2013-07-06 12:44:34',NULL,NULL),(32173,'35478','P','Peterson','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.234302,-87.423475,0,'2013-07-06 12:44:32',NULL,NULL),(44274,'49709','S','Atlanta','D','Montmorency','26119','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.991675,-84.144137,0,'2013-07-06 12:44:32',NULL,NULL),(30360,'33313','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(6737,'06078','S','Suffield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986956,-72.648240,0,'2013-07-06 12:44:30',NULL,NULL),(60643,'71903','P','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.525891,-92.996360,0,'2013-07-06 12:44:33',NULL,NULL),(39341,'44621','S','Dennison','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.395563,-81.329056,0,'2013-07-06 12:44:32',NULL,NULL),(24305,'27014','P','Cooleemee','D','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.811382,-80.559115,0,'2013-07-06 12:44:31',NULL,NULL),(69746,'84047','S','Cushing','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.616513,-111.879899,0,'2013-07-06 12:44:34',NULL,NULL),(74702,'93004','S','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.280121,-119.168207,0,'2013-07-06 12:44:34',NULL,NULL),(40706,'46106','S','Providence','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.507357,-86.199658,0,'2013-07-06 12:44:32',NULL,NULL),(43489,'48615','S','Breckenridge','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.391740,-84.482871,0,'2013-07-06 12:44:32',NULL,NULL),(47966,'55123','S','Eagan','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.801532,-93.141757,0,'2013-07-06 12:44:33',NULL,NULL),(68196,'81036','S','Chivington','A','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.463000,-102.652860,0,'2013-07-06 12:44:34',NULL,NULL),(61069,'72126','S','Aplin','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(744,'00692','S','Bda Corea','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(47502,'54763','S','Ridgeland','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.217676,-91.906935,0,'2013-07-06 12:44:32',NULL,NULL),(49480,'56658','S','Margie','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.095867,-93.939313,0,'2013-07-06 12:44:33',NULL,NULL),(56332,'65108','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.573978,-92.171679,0,'2013-07-06 12:44:33',NULL,NULL),(53834,'62311','S','Augusta','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.232617,-90.950322,0,'2013-07-06 12:44:33',NULL,NULL),(6665,'06028','P','East Windsor Hill','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.864145,-72.599902,0,'2013-07-06 12:44:30',NULL,NULL),(56855,'66006','S','Baldwin','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.776889,-95.187756,0,'2013-07-06 12:44:33',NULL,NULL),(20642,'21221','S','Essex','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.294840,-76.436520,0,'2013-07-06 12:44:31',NULL,NULL),(47542,'54820','S','Brule','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.536562,-91.557372,0,'2013-07-06 12:44:32',NULL,NULL),(54533,'62882','S','Fairman','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.612584,-89.121037,0,'2013-07-06 12:44:33',NULL,NULL),(63825,'75973','S','Alexanders Store','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(42495,'47841','S','Martz','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.273442,-87.115129,0,'2013-07-06 12:44:32',NULL,NULL),(7247,'06513','S','Fair Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.321735,-72.859214,0,'2013-07-06 12:44:30',NULL,NULL),(8380,'08055','S','Medford Township','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862774,-74.815854,0,'2013-07-06 12:44:30',NULL,NULL),(52050,'60196','U','Hoffman Estates','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.071476,-88.049239,0,'2013-07-06 12:44:33',NULL,NULL),(22301,'23829','S','Capron','D','Southampton','51175','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.732689,-77.237769,0,'2013-07-06 12:44:31',NULL,NULL),(59385,'70607','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.088912,-93.176486,0,'2013-07-06 12:44:33',NULL,NULL),(73442,'91301','S','Agoura','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(62529,'74426','S','Pierce','N','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.417700,-95.553780,0,'2013-07-06 12:44:33',NULL,NULL),(59442,'70718','P','Brittany','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.208673,-90.891672,0,'2013-07-06 12:44:33',NULL,NULL),(75010,'93456','P','Santa Maria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.942122,-120.461672,0,'2013-07-06 12:44:34',NULL,NULL),(36386,'40486','S','Elias','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.378148,-83.874828,0,'2013-07-06 12:44:32',NULL,NULL),(39882,'45211','S','Cheviot','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.158460,-84.594600,0,'2013-07-06 12:44:32',NULL,NULL),(41395,'46806','S','Diplomat Plaza','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.046401,-85.105518,0,'2013-07-06 12:44:32',NULL,NULL),(47643,'54926','P','Big Falls','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.622482,-89.017580,0,'2013-07-06 12:44:33',NULL,NULL),(25266,'28124','S','Mt Pleasant','A','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.411081,-80.419470,0,'2013-07-06 12:44:31',NULL,NULL),(11705,'12166','S','Root','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.849600,-74.476380,0,'2013-07-06 12:44:30',NULL,NULL),(33049,'36752','S','Burkville','A','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.310120,-86.652300,0,'2013-07-06 12:44:32',NULL,NULL),(43718,'48916','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.671084,-84.573494,0,'2013-07-06 12:44:32',NULL,NULL),(42086,'47458','P','Smithville','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.066787,-86.505402,0,'2013-07-06 12:44:32',NULL,NULL),(41114,'46572','P','Tyner','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.421775,-86.400405,0,'2013-07-06 12:44:32',NULL,NULL),(59328,'70534','P','Estherwood','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.185184,-92.462192,0,'2013-07-06 12:44:33',NULL,NULL),(52549,'60941','S','Herscher','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.049589,-88.094294,0,'2013-07-06 12:44:33',NULL,NULL),(26897,'29575','S','Surfside','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.626586,-78.983446,0,'2013-07-06 12:44:31',NULL,NULL),(51456,'59487','S','Vaughn','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.570060,-111.616366,0,'2013-07-06 12:44:33',NULL,NULL),(10406,'10607','S','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.040477,-73.809229,0,'2013-07-06 12:44:30',NULL,NULL),(53233,'61639','U','Westinghouse Air Brake','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.709663,-89.566400,0,'2013-07-06 12:44:33',NULL,NULL),(30943,'33716','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878343,-82.649244,0,'2013-07-06 12:44:32',NULL,NULL),(59455,'70729','S','Bueche','A','West Baton Rouge','22121','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.534205,-91.395293,0,'2013-07-06 12:44:33',NULL,NULL),(44529,'49960','P','Rockland','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.742283,-89.183486,0,'2013-07-06 12:44:32',NULL,NULL),(58985,'70049','S','Wallace','N','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.033660,-90.556620,0,'2013-07-06 12:44:33',NULL,NULL),(32712,'36301','S','Kelly Springs','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(65012,'77302','S','Woodloch','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.244988,-95.403556,0,'2013-07-06 12:44:34',NULL,NULL),(23639,'25773','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.419532,-82.478315,0,'2013-07-06 12:44:31',NULL,NULL),(54178,'62622','P','Bluff Springs','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.986241,-90.343935,0,'2013-07-06 12:44:33',NULL,NULL),(52663,'61068','S','Rochelle','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.948220,-89.055360,0,'2013-07-06 12:44:33',NULL,NULL),(47218,'54494','S','Wisc Rapids','A','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(37152,'41465','S','Mashfork','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(32119,'35440','P','Abernant','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.292555,-87.197891,0,'2013-07-06 12:44:32',NULL,NULL),(79858,'99556','S','Nikolaevsk','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.777580,-151.765620,0,'2013-07-06 12:44:34',NULL,NULL),(11768,'12202','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.639674,-73.769661,0,'2013-07-06 12:44:30',NULL,NULL),(68930,'82923','S','Boulder','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.730018,-109.684887,0,'2013-07-06 12:44:34',NULL,NULL),(76204,'95360','S','Newman','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.346607,-121.075271,0,'2013-07-06 12:44:34',NULL,NULL),(79960,'99635','P','Nikiski','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.690180,-151.288800,0,'2013-07-06 12:44:34',NULL,NULL),(31477,'34420','S','Belleview','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.044347,-82.036592,0,'2013-07-06 12:44:32',NULL,NULL),(50082,'57457','S','Long Lake','D','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.773410,-99.248283,0,'2013-07-06 12:44:33',NULL,NULL),(22083,'23396','S','Oak Hall','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.925278,-75.558889,0,'2013-07-06 12:44:31',NULL,NULL),(23621,'25717','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.425989,-82.437268,0,'2013-07-06 12:44:31',NULL,NULL),(30278,'33256','P','Pinecrest','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661865,-80.326386,0,'2013-07-06 12:44:32',NULL,NULL),(77047,'96112','S','Fort Bidwell','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.873979,-120.117673,0,'2013-07-06 12:44:34',NULL,NULL),(63219,'75455','S','Mount Pleasant','D','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.156354,-94.968910,0,'2013-07-06 12:44:33',NULL,NULL),(60232,'71430','S','Bucks Landing','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(48777,'55987','S','Wiscoy','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(2275,'00926','S','Urb San Jose Ind','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(4100,'02673','S','West Yarmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.652840,-70.241220,0,'2013-07-06 12:44:30',NULL,NULL),(33541,'37389','S','Arnold AFB','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.320179,-86.067451,0,'2013-07-06 12:44:32',NULL,NULL),(18391,'19049','U','Trevose','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.175266,-74.919785,0,'2013-07-06 12:44:31',NULL,NULL),(61324,'72447','S','Monette','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.883241,-90.351840,0,'2013-07-06 12:44:33',NULL,NULL),(55671,'64037','S','Higginsville','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.033181,-93.707924,0,'2013-07-06 12:44:33',NULL,NULL),(50532,'58106','P','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.852830,-96.823352,0,'2013-07-06 12:44:33',NULL,NULL),(43195,'48303','P','Bloomfield Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(16550,'17307','S','Floradale','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(18416,'19060','S','Marcus Hook','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.846163,-75.445489,0,'2013-07-06 12:44:31',NULL,NULL),(48050,'55315','S','Carver','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.716995,-93.687641,0,'2013-07-06 12:44:33',NULL,NULL),(63201,'75436','S','Detroit','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.662519,-95.230975,0,'2013-07-06 12:44:33',NULL,NULL),(38608,'43901','S','Adena','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.219347,-80.864391,0,'2013-07-06 12:44:32',NULL,NULL),(39564,'44849','S','Edenville','N','Wyandot','39175','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.826400,-83.130900,0,'2013-07-06 12:44:32',NULL,NULL),(54068,'62481','S','Yale','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.132003,-88.004180,0,'2013-07-06 12:44:33',NULL,NULL),(4435,'03241','S','Hebron','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.712551,-71.875491,0,'2013-07-06 12:44:30',NULL,NULL),(32694,'36276','S','Forester Chapel','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(39016,'44142','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.398708,-81.832392,0,'2013-07-06 12:44:32',NULL,NULL),(20164,'20742','U','University of Maryland','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.992333,-76.952986,0,'2013-07-06 12:44:31',NULL,NULL),(17250,'17841','S','Alfarata','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(24528,'27288','S','New Leaksville','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(45067,'50518','S','Barnum','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.509584,-94.365240,0,'2013-07-06 12:44:32',NULL,NULL),(12418,'12943','S','Keene','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.190442,-73.785574,0,'2013-07-06 12:44:30',NULL,NULL),(76145,'95296','U','Lyoth','A','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.025975,-121.297271,0,'2013-07-06 12:44:34',NULL,NULL),(39707,'45044','S','Liberty Township','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.484738,-84.383452,0,'2013-07-06 12:44:32',NULL,NULL),(30237,'33190','S','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556771,-80.336864,0,'2013-07-06 12:44:32',NULL,NULL),(37222,'41537','S','East Jenkins','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(35846,'39817','S','Bainbridge','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.905055,-84.568611,0,'2013-07-06 12:44:32',NULL,NULL),(27694,'30338','S','Sandy Spgs','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(51282,'59115','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.785907,-108.508798,0,'2013-07-06 12:44:33',NULL,NULL),(48694,'55934','S','Viola','A','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.022060,-92.276760,0,'2013-07-06 12:44:33',NULL,NULL),(54250,'62670','S','Old Berlin','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.734757,-89.908806,0,'2013-07-06 12:44:33',NULL,NULL),(24522,'27285','P','Kernersville','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.113720,-80.077061,0,'2013-07-06 12:44:31',NULL,NULL),(25706,'28539','S','Hubert','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.696204,-77.208383,0,'2013-07-06 12:44:31',NULL,NULL),(21797,'23081','P','Williamsburg','A','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.224814,-76.781576,0,'2013-07-06 12:44:31',NULL,NULL),(56346,'65201','S','Elkhurst','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.896440,-92.246280,0,'2013-07-06 12:44:33',NULL,NULL),(61278,'72390','S','West Helena','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.546617,-90.645529,0,'2013-07-06 12:44:33',NULL,NULL),(63899,'76021','S','Bedford','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.855156,-97.139353,0,'2013-07-06 12:44:34',NULL,NULL),(66187,'78538','S','Monte Alto','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.309820,-97.959000,0,'2013-07-06 12:44:34',NULL,NULL),(66992,'79499','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.608049,-101.907364,0,'2013-07-06 12:44:34',NULL,NULL),(69226,'83401','S','Taylor','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(67108,'79720','S','Vealmoor','A','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.514610,-101.575740,0,'2013-07-06 12:44:34',NULL,NULL),(56709,'65674','S','Humansville','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.795619,-93.579699,0,'2013-07-06 12:44:33',NULL,NULL),(30569,'33414','S','Royal Plm Beach','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(38678,'43964','S','Toronto','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.463811,-80.608335,0,'2013-07-06 12:44:32',NULL,NULL),(7566,'07024','S','West Fort Lee','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.851376,-73.975825,0,'2013-07-06 12:44:30',NULL,NULL),(31408,'34235','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.362992,-82.480759,0,'2013-07-06 12:44:32',NULL,NULL),(74685,'92880','S','Eastvale','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.925761,-117.614694,0,'2013-07-06 12:44:34',NULL,NULL),(75531,'94188','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.740660,-122.383372,0,'2013-07-06 12:44:34',NULL,NULL),(61958,'73170','S','okc','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.373300,-97.562460,0,'2013-07-06 12:44:33',NULL,NULL),(61795,'73086','S','Sulphur','D','Murray','40099','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.507938,-96.973516,0,'2013-07-06 12:44:33',NULL,NULL),(34457,'38659','S','Bethlehem','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(33467,'37329','S','Englewood','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.330416,-84.521646,0,'2013-07-06 12:44:32',NULL,NULL),(37272,'41572','S','Wales','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.341120,-82.650600,0,'2013-07-06 12:44:32',NULL,NULL),(52546,'60938','S','Gilman','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.770329,-87.987922,0,'2013-07-06 12:44:33',NULL,NULL),(27938,'30529','S','Commerce','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.187974,-83.514373,0,'2013-07-06 12:44:31',NULL,NULL),(3773,'02190','S','Weymouth NAS','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.171028,-70.948119,0,'2013-07-06 12:44:30',NULL,NULL),(57792,'67484','S','Culver','A','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.987400,-97.788540,0,'2013-07-06 12:44:33',NULL,NULL),(36067,'40207','S','St Matthews','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(33790,'37880','S','Ten Mile','D','Meigs','47121','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.683153,-84.652784,0,'2013-07-06 12:44:32',NULL,NULL),(35416,'39466','S','Picayune','D','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(2117,'00924','S','Bda El Polvorin','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(29849,'33036','S','Islamorada','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(20961,'21782','S','Sharpsburg','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.448815,-77.754900,0,'2013-07-06 12:44:31',NULL,NULL),(5759,'05041','S','East Brookfield','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.973889,-72.556389,0,'2013-07-06 12:44:30',NULL,NULL),(69738,'84044','S','Pleasant Green','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.669490,-112.140714,0,'2013-07-06 12:44:34',NULL,NULL),(67978,'80915','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.856009,-104.716668,0,'2013-07-06 12:44:34',NULL,NULL),(65069,'77346','S','Humble','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.033333,-95.250000,0,'2013-07-06 12:44:34',NULL,NULL),(59705,'71104','S','Centenary','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.484075,-93.733020,0,'2013-07-06 12:44:33',NULL,NULL),(19255,'19944','S','Fenwick Is','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.459312,-75.052878,0,'2013-07-06 12:44:31',NULL,NULL),(31226,'33966','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637141,-81.871604,0,'2013-07-06 12:44:32',NULL,NULL),(27953,'30542','S','Flowery Branch','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.188876,-83.905713,0,'2013-07-06 12:44:31',NULL,NULL),(27098,'29716','P','Fort Mill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006945,-80.942339,0,'2013-07-06 12:44:31',NULL,NULL),(59954,'71302','S','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.266926,-92.417063,0,'2013-07-06 12:44:33',NULL,NULL),(43000,'48160','S','Milan Twp','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(57504,'66952','S','Bellaire','A','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.813397,-98.555445,0,'2013-07-06 12:44:33',NULL,NULL),(56562,'65468','S','Eunice','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.214118,-91.729342,0,'2013-07-06 12:44:33',NULL,NULL),(25478,'28350','P','Lakeview','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.243168,-79.310761,0,'2013-07-06 12:44:31',NULL,NULL),(6649,'06018','S','North Canaan','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.009780,-73.298160,0,'2013-07-06 12:44:30',NULL,NULL),(16937,'17699','U','Qvc Network Inc','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.041872,-76.300120,0,'2013-07-06 12:44:31',NULL,NULL),(41126,'46614','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.625248,-86.247979,0,'2013-07-06 12:44:32',NULL,NULL),(19215,'19893','U','Chase Manhattan Bank N A','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.747693,-75.557912,0,'2013-07-06 12:44:31',NULL,NULL),(27605,'30302','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755454,-84.387605,0,'2013-07-06 12:44:31',NULL,NULL),(6119,'05458','S','Grand Isle','D','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.717862,-73.300101,0,'2013-07-06 12:44:30',NULL,NULL),(17376,'17884','P','Washingtonvle','A','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.050669,-76.673774,0,'2013-07-06 12:44:31',NULL,NULL),(10081,'10199','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(6479,'05765','S','True Blue','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.657570,-73.034159,0,'2013-07-06 12:44:30',NULL,NULL),(19879,'20531','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895714,-77.019633,0,'2013-07-06 12:44:31',NULL,NULL),(35632,'39633','S','Rosetta','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(72902,'90022','S','Commerce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.022686,-118.152363,0,'2013-07-06 12:44:34',NULL,NULL),(71727,'87532','S','Pajarito','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(19717,'20391','S','Washington Na','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877045,-76.994981,0,'2013-07-06 12:44:31',NULL,NULL),(42542,'47868','S','Greybrook Lake','N','Owen','18119','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.450742,-86.974712,0,'2013-07-06 12:44:32',NULL,NULL),(67950,'80912','S','CSOC','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(58165,'68183','U','Omaha Douglas Civic Ctr','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.258306,-95.938217,0,'2013-07-06 12:44:33',NULL,NULL),(58705,'68932','S','Campbell','D','Franklin','31061','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.298761,-98.729244,0,'2013-07-06 12:44:33',NULL,NULL),(30560,'33412','S','Ryl Palm Bch','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(46205,'52756','S','Gambrill','N','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.721476,-90.549616,0,'2013-07-06 12:44:32',NULL,NULL),(42643,'47928','S','Cayuga','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.951874,-87.464218,0,'2013-07-06 12:44:32',NULL,NULL),(47039,'54407','S','Lake Emily','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.518339,-89.294289,0,'2013-07-06 12:44:32',NULL,NULL),(77710,'97054','S','Deer Island','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.929439,-122.925681,0,'2013-07-06 12:44:34',NULL,NULL),(75499,'94133','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.798333,-122.409352,0,'2013-07-06 12:44:34',NULL,NULL),(52722,'61231','S','Hamlet','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(62765,'74857','S','Newalla','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.332436,-97.199877,0,'2013-07-06 12:44:33',NULL,NULL),(15623,'16694','P','Wood','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.166846,-78.135206,0,'2013-07-06 12:44:31',NULL,NULL),(44144,'49518','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.875823,-85.625787,0,'2013-07-06 12:44:32',NULL,NULL),(8907,'08736','S','Manasquan','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.122204,-74.063541,0,'2013-07-06 12:44:30',NULL,NULL),(7858,'07480','S','West Milford Lakes','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.090615,-74.369917,0,'2013-07-06 12:44:30',NULL,NULL),(57044,'66209','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(68295,'81091','S','East Weston','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(74209,'92305','S','Angelus Oaks','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.113181,-117.029126,0,'2013-07-06 12:44:34',NULL,NULL),(67992,'80919','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.928018,-104.848484,0,'2013-07-06 12:44:34',NULL,NULL),(77851,'97225','S','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.501041,-122.761269,0,'2013-07-06 12:44:34',NULL,NULL),(75949,'95041','P','Mount Hermon','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.048230,-122.051231,0,'2013-07-06 12:44:34',NULL,NULL),(64317,'76476','S','Tolar','D','Hood','48221','Texas','TX','48','2800','254','Central',-6.0,'Y',32.407909,-97.838613,0,'2013-07-06 12:44:34',NULL,NULL),(55335,'63551','S','Livonia','D','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.523706,-92.739132,0,'2013-07-06 12:44:33',NULL,NULL),(54521,'62876','P','Radom','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.282401,-89.192991,0,'2013-07-06 12:44:33',NULL,NULL),(12181,'12766','S','North Branch','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.807528,-74.998309,0,'2013-07-06 12:44:30',NULL,NULL),(45092,'50538','S','Rinard','A','Calhoun','19025','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.280038,-94.405502,0,'2013-07-06 12:44:32',NULL,NULL),(67775,'80646','P','Lucerne','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.483405,-104.699549,0,'2013-07-06 12:44:34',NULL,NULL),(18842,'19428','S','Conshohocken','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.077938,-75.303000,0,'2013-07-06 12:44:31',NULL,NULL),(45400,'51039','S','Moville','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.489096,-96.070229,0,'2013-07-06 12:44:32',NULL,NULL),(11858,'12261','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679058,-73.782986,0,'2013-07-06 12:44:30',NULL,NULL),(17475,'17949','P','Mahanoy Plane','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794784,-76.243733,0,'2013-07-06 12:44:31',NULL,NULL),(33829,'37929','S','Plaza Tower','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.962625,-83.921292,0,'2013-07-06 12:44:32',NULL,NULL),(44119,'49506','S','Kentwood','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(46798,'54001','S','Little Falls','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(1428,'00739','S','Jard De Rabanal','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(69757,'84050','S','Richville','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(75070,'93529','S','June Lake Junction','N','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.814915,-119.006993,0,'2013-07-06 12:44:34',NULL,NULL),(77898,'97296','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.531999,-122.773414,0,'2013-07-06 12:44:34',NULL,NULL),(7618,'07055','S','Passaic Park','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.859415,-74.130577,0,'2013-07-06 12:44:30',NULL,NULL),(10345,'10562','S','Ossining','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.174335,-73.845908,0,'2013-07-06 12:44:30',NULL,NULL),(77905,'97305','S','Brooks','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.016500,-122.912220,0,'2013-07-06 12:44:34',NULL,NULL),(5974,'05343','S','East Jamaica','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.104420,-72.807180,0,'2013-07-06 12:44:30',NULL,NULL),(31211,'33952','S','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.991101,-82.099054,0,'2013-07-06 12:44:32',NULL,NULL),(26279,'29016','S','Blythewood','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.192240,-80.975064,0,'2013-07-06 12:44:31',NULL,NULL),(28658,'31778','S','Pavo','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.956101,-83.738121,0,'2013-07-06 12:44:32',NULL,NULL),(8067,'07748','S','North Middletown','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.395074,-74.109292,0,'2013-07-06 12:44:30',NULL,NULL),(77684,'97035','S','Mountain Park','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.411593,-122.725222,0,'2013-07-06 12:44:34',NULL,NULL),(22857,'24541','S','Danville','D','Danville City','51590','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.574659,-79.436458,0,'2013-07-06 12:44:31',NULL,NULL),(31630,'34705','S','Astatula','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.705093,-81.714841,0,'2013-07-06 12:44:32',NULL,NULL),(56069,'64748','S','Golden City','D','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.392379,-94.092888,0,'2013-07-06 12:44:33',NULL,NULL),(23849,'26138','S','Brohard','D','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.028842,-81.193995,0,'2013-07-06 12:44:31',NULL,NULL),(16282,'17102','S','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.258980,-76.862940,0,'2013-07-06 12:44:31',NULL,NULL),(37960,'42721','S','Caneyville','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.426977,-86.486700,0,'2013-07-06 12:44:32',NULL,NULL),(3012,'01082','S','Hardwick','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.262671,-72.265357,0,'2013-07-06 12:44:30',NULL,NULL),(21221,'22212','U','Navy Mutual Aid Assoc','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.858432,-77.089675,0,'2013-07-06 12:44:31',NULL,NULL),(70401,'84713','S','North Creek','N','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.298252,-112.716345,0,'2013-07-06 12:44:34',NULL,NULL),(62935,'75092','S','Sherman','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.645158,-96.633453,0,'2013-07-06 12:44:33',NULL,NULL),(55896,'64433','S','Conception','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.229469,-94.674235,0,'2013-07-06 12:44:33',NULL,NULL),(24552,'27292','S','Tyro','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(25585,'28441','S','Ingold','A','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.822280,-78.329017,0,'2013-07-06 12:44:31',NULL,NULL),(11337,'11792','S','Wading River','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.945440,-72.835020,0,'2013-07-06 12:44:30',NULL,NULL),(12970,'13367','S','Lowville','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(51037,'58723','S','Kief','A','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.764294,-100.649272,0,'2013-07-06 12:44:33',NULL,NULL),(80099,'99750','P','Kivalina','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',67.632189,-163.728466,0,'2013-07-06 12:44:34',NULL,NULL),(10494,'10960','S','Grnd Vw Hudsn','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(58482,'68751','S','Maskell','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.688741,-96.984169,0,'2013-07-06 12:44:33',NULL,NULL),(56661,'65622','S','Buffalo','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.646688,-93.094711,0,'2013-07-06 12:44:33',NULL,NULL),(55887,'64426','S','Blythedale','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.471399,-93.926357,0,'2013-07-06 12:44:33',NULL,NULL),(42629,'47907','S','W Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.368719,-86.877988,0,'2013-07-06 12:44:32',NULL,NULL),(2851,'00983','S','Valle Arriba Hts','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(16866,'17565','S','Marticville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(78882,'98357','P','Makah AFB','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.369349,-124.626924,0,'2013-07-06 12:44:34',NULL,NULL),(40845,'46221','S','West Indianapolis','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.699569,-86.233683,0,'2013-07-06 12:44:32',NULL,NULL),(40802,'46181','S','Samaria','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.365002,-86.183378,0,'2013-07-06 12:44:32',NULL,NULL),(12339,'12873','S','Eagleville','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.127464,-73.307470,0,'2013-07-06 12:44:30',NULL,NULL),(76239,'95389','S','Wawona','A','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(62474,'74343','S','Fairland','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.753338,-94.848103,0,'2013-07-06 12:44:33',NULL,NULL),(10465,'10931','S','Hillburn','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.121428,-74.169527,0,'2013-07-06 12:44:30',NULL,NULL),(34249,'38393','P','Chewalla','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.054641,-88.635842,0,'2013-07-06 12:44:32',NULL,NULL),(36015,'40161','S','Rhodelia','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.964570,-86.315361,0,'2013-07-06 12:44:32',NULL,NULL),(38993,'44134','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.387185,-81.702198,0,'2013-07-06 12:44:32',NULL,NULL),(71152,'86033','P','Chilchinbito','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.630720,-110.277720,0,'2013-07-06 12:44:34',NULL,NULL),(59232,'70427','S','Plainview','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(12621,'13088','S','Salina','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(11390,'11942','S','East Quogue','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.847122,-72.573666,0,'2013-07-06 12:44:30',NULL,NULL),(7698,'07111','S','Irvington','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.722730,-74.232016,0,'2013-07-06 12:44:30',NULL,NULL),(12868,'13324','S','Gray','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(8626,'08260','S','Anglesea','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(33431,'37250','U','Suntrust Bank','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.161267,-86.783675,0,'2013-07-06 12:44:32',NULL,NULL),(69168,'83323','S','Declo','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.518218,-113.627087,0,'2013-07-06 12:44:34',NULL,NULL),(64586,'76671','S','Lakeside Village','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.020833,-97.493611,0,'2013-07-06 12:44:34',NULL,NULL),(21853,'23140','S','Provdence Frg','A','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.443403,-77.056714,0,'2013-07-06 12:44:31',NULL,NULL),(78086,'97476','S','Sixes','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.816790,-124.456383,0,'2013-07-06 12:44:34',NULL,NULL),(65576,'77861','S','Iola','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.676001,-96.130810,0,'2013-07-06 12:44:34',NULL,NULL),(64250,'76369','P','Kamay','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.866687,-98.801923,0,'2013-07-06 12:44:34',NULL,NULL),(46960,'54201','S','Rio Creek','A','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.607804,-87.447524,0,'2013-07-06 12:44:32',NULL,NULL),(64523,'76639','S','Springhill','N','Navarro','48349','Texas','TX','48','0000','254','Central',-6.0,'Y',31.893120,-96.704100,0,'2013-07-06 12:44:34',NULL,NULL),(12722,'13156','S','Sterling','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.317187,-76.700960,0,'2013-07-06 12:44:30',NULL,NULL),(12422,'12945','S','Lake Clear','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.366560,-74.247330,0,'2013-07-06 12:44:30',NULL,NULL),(70360,'84647','S','Mt Pleasant','A','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.554490,-111.491057,0,'2013-07-06 12:44:34',NULL,NULL),(79360,'98644','P','Seaview','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.330283,-124.052924,0,'2013-07-06 12:44:34',NULL,NULL),(76657,'95736','P','Weimar','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.036076,-120.957294,0,'2013-07-06 12:44:34',NULL,NULL),(20301,'20815','S','Bethesda','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(46760,'53937','S','Hillpoint','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.386342,-90.168476,0,'2013-07-06 12:44:32',NULL,NULL),(41004,'46361','P','Michigan City','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.719635,-86.902914,0,'2013-07-06 12:44:32',NULL,NULL),(67786,'80705','S','Log Lane Village','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.260900,-103.818540,0,'2013-07-06 12:44:34',NULL,NULL),(63667,'75853','S','Bradford','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.941780,-95.763120,0,'2013-07-06 12:44:34',NULL,NULL),(14249,'14825','S','Chemung','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.046766,-76.619450,0,'2013-07-06 12:44:31',NULL,NULL),(34574,'38736','S','Linn','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.659722,-90.616389,0,'2013-07-06 12:44:32',NULL,NULL),(12533,'13036','S','Central Square','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.306800,-76.178280,0,'2013-07-06 12:44:30',NULL,NULL),(11449,'11978','S','Quioque','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(44574,'50026','S','Bagley','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.819718,-94.456171,0,'2013-07-06 12:44:32',NULL,NULL),(74274,'92352','P','Lk Arrowhead','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.257718,-117.190169,0,'2013-07-06 12:44:34',NULL,NULL),(31594,'34661','P','Nobleton','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.645537,-82.261836,0,'2013-07-06 12:44:32',NULL,NULL),(69183,'83336','S','Heyburn','D','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.562718,-113.763959,0,'2013-07-06 12:44:34',NULL,NULL),(18125,'18818','S','Friendsville','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.906615,-76.046272,0,'2013-07-06 12:44:31',NULL,NULL),(32757,'36346','S','Victoria','N','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.596944,-85.913611,0,'2013-07-06 12:44:32',NULL,NULL),(10397,'10604','S','East White Plains','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.035020,-73.743600,0,'2013-07-06 12:44:30',NULL,NULL),(6359,'05675','S','Washing','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(39503,'44807','S','Attica Junction','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(38902,'44117','S','Euclid','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.569630,-81.525168,0,'2013-07-06 12:44:32',NULL,NULL),(35266,'39360','S','Matherville','A','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.878000,-88.708080,0,'2013-07-06 12:44:32',NULL,NULL),(57629,'67142','S','Rago','A','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.426412,-98.190505,0,'2013-07-06 12:44:33',NULL,NULL),(18815,'19405','S','Norristown','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.103400,-75.341700,0,'2013-07-06 12:44:31',NULL,NULL),(10862,'11415','S','Kew Gardens','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.708943,-73.826125,0,'2013-07-06 12:44:30',NULL,NULL),(10002,'10167','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(21305,'22404','P','Fredericksburg','D','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.297717,-77.456462,0,'2013-07-06 12:44:31',NULL,NULL),(52095,'60411','S','Ford Heights','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(740,'00690','S','Urb Nuevo San Antonio','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(66605,'78760','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.212563,-97.733320,0,'2013-07-06 12:44:34',NULL,NULL),(66878,'79229','S','Dickens','D','Dickens','48125','Texas','TX','48','0000','806','Central',-6.0,'Y',33.619214,-100.835382,0,'2013-07-06 12:44:34',NULL,NULL),(76542,'95660','S','N Highlands','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.687272,-121.376063,0,'2013-07-06 12:44:34',NULL,NULL),(16693,'17375','S','Peach Glen','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.973828,-77.231585,0,'2013-07-06 12:44:31',NULL,NULL),(4810,'03894','S','Tuftonboro','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.587172,-71.220009,0,'2013-07-06 12:44:30',NULL,NULL),(71646,'87420','S','Tocito','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.574461,-108.590087,0,'2013-07-06 12:44:34',NULL,NULL),(63970,'76103','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.747249,-97.265412,0,'2013-07-06 12:44:34',NULL,NULL),(5287,'04538','S','Boothbay Harbor','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.851438,-69.626454,0,'2013-07-06 12:44:30',NULL,NULL),(37762,'42334','P','Curdsville','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.736732,-87.329656,0,'2013-07-06 12:44:32',NULL,NULL),(3311,'01520','S','Holden','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.345803,-71.846302,0,'2013-07-06 12:44:30',NULL,NULL),(37582,'42086','S','West Paducah','D','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.087107,-88.767014,0,'2013-07-06 12:44:32',NULL,NULL),(13013,'13420','S','Old Forge','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.650231,-74.989248,0,'2013-07-06 12:44:30',NULL,NULL),(48701,'55940','S','Hayfield','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.891882,-92.849789,0,'2013-07-06 12:44:33',NULL,NULL),(46472,'53217','S','River Hills','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(43441,'48506','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.051354,-83.637617,0,'2013-07-06 12:44:32',NULL,NULL),(36477,'40763','S','Siler','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.724748,-83.969105,0,'2013-07-06 12:44:32',NULL,NULL),(72606,'89413','S','Glenbrook','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.081994,-119.937493,0,'2013-07-06 12:44:34',NULL,NULL),(78518,'98119','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.638776,-122.366173,0,'2013-07-06 12:44:34',NULL,NULL),(69937,'84115','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(59718,'71107','S','Risinger Woods','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.608620,-93.862080,0,'2013-07-06 12:44:33',NULL,NULL),(38313,'43360','S','Zanesfield','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.318273,-83.651698,0,'2013-07-06 12:44:32',NULL,NULL),(35823,'39762','P','MSU','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(46656,'53705','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075083,-89.459898,0,'2013-07-06 12:44:32',NULL,NULL),(32731,'36316','S','Chancellor','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.178128,-85.919169,0,'2013-07-06 12:44:32',NULL,NULL),(22004,'23282','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.569356,-77.478092,0,'2013-07-06 12:44:31',NULL,NULL),(18400,'19053','S','Feasterville Trevose','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(70501,'84779','S','Springdale','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.188889,-113.000000,0,'2013-07-06 12:44:34',NULL,NULL),(58227,'68345','S','Dubois','N','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.041000,-96.058080,0,'2013-07-06 12:44:33',NULL,NULL),(53503,'62013','S','Meppen','A','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.966280,-90.600120,0,'2013-07-06 12:44:33',NULL,NULL),(17576,'18013','S','Roseto','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.873341,-75.187858,0,'2013-07-06 12:44:31',NULL,NULL),(50262,'57638','S','Thunder Hawk','A','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.937575,-102.160093,0,'2013-07-06 12:44:33',NULL,NULL),(55699,'64064','S','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.982769,-94.365575,0,'2013-07-06 12:44:33',NULL,NULL),(35227,'39307','S','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.330793,-88.827844,0,'2013-07-06 12:44:32',NULL,NULL),(16604,'17329','S','Brodbecks','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.757860,-76.871220,0,'2013-07-06 12:44:31',NULL,NULL),(36466,'40741','S','London','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.110220,-84.078189,0,'2013-07-06 12:44:32',NULL,NULL),(11210,'11743','S','West Hills','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(38248,'43270','U','Ohio Dept of Taxation','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.964970,-83.000319,0,'2013-07-06 12:44:32',NULL,NULL),(11972,'12461','S','Samsonville','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.898780,-74.257380,0,'2013-07-06 12:44:30',NULL,NULL),(29817,'33026','S','Pembroke Lakes','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028424,-80.296813,0,'2013-07-06 12:44:32',NULL,NULL),(52728,'61231','S','Wanlock','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(11454,'11978','S','Westhampton Beach','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(49004,'56249','S','Holloway','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.282645,-95.934264,0,'2013-07-06 12:44:33',NULL,NULL),(11996,'12484','S','The Vly','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.876340,-74.175540,0,'2013-07-06 12:44:30',NULL,NULL),(30964,'33738','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.801363,-82.801164,0,'2013-07-06 12:44:32',NULL,NULL),(23175,'25033','S','Buffalo','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.605804,-81.913618,0,'2013-07-06 12:44:31',NULL,NULL),(29985,'33101','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.779127,-80.197720,0,'2013-07-06 12:44:32',NULL,NULL),(62861,'75028','S','Lewisville','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.033405,-97.067657,0,'2013-07-06 12:44:33',NULL,NULL),(79224,'98547','S','Grayland','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.743694,-124.084377,0,'2013-07-06 12:44:34',NULL,NULL),(66642,'78836','P','Catarina','D','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.347138,-99.612818,0,'2013-07-06 12:44:34',NULL,NULL),(63912,'76041','S','Forreston','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.235041,-96.854712,0,'2013-07-06 12:44:34',NULL,NULL),(3952,'02475','P','Arlington Heights','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420254,-71.180935,0,'2013-07-06 12:44:30',NULL,NULL),(39245,'44432','S','Lisbon','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.761443,-80.762546,0,'2013-07-06 12:44:32',NULL,NULL),(45272,'50672','S','Steamboat Rock','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.407668,-93.067862,0,'2013-07-06 12:44:32',NULL,NULL),(54313,'62719','U','State Rev Box 3547','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.801546,-89.652704,0,'2013-07-06 12:44:33',NULL,NULL),(70384,'84663','S','Springville','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.162967,-111.603050,0,'2013-07-06 12:44:34',NULL,NULL),(64941,'77224','P','Memorial Park','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.771587,-95.516816,0,'2013-07-06 12:44:34',NULL,NULL),(17428,'17925','P','Hellen Mills','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.748486,-76.067276,0,'2013-07-06 12:44:31',NULL,NULL),(54345,'62769','U','St Johns Hospital','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.805964,-89.643223,0,'2013-07-06 12:44:33',NULL,NULL),(5939,'05257','S','N Bennington','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(22595,'24179','S','Vinton','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.278679,-79.880950,0,'2013-07-06 12:44:31',NULL,NULL),(80174,'99833','P','Kupreanof','A','Petersburg','02280','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.806343,-132.969633,0,'2013-07-06 12:44:34',NULL,NULL),(78842,'98336','S','Carriage Hill','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.526804,-122.119918,0,'2013-07-06 12:44:34',NULL,NULL),(5271,'04493','S','Enfield','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.243333,-68.650278,0,'2013-07-06 12:44:30',NULL,NULL),(19003,'19526','S','Hamburg','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(25336,'28213','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.289780,-80.780774,0,'2013-07-06 12:44:31',NULL,NULL),(72138,'88311','P','Alamogordo','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.823829,-105.978482,0,'2013-07-06 12:44:34',NULL,NULL),(50690,'58352','S','Clyde','A','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.655800,-98.850720,0,'2013-07-06 12:44:33',NULL,NULL),(68924,'82845','P','Wyarno','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.806855,-106.773099,0,'2013-07-06 12:44:34',NULL,NULL),(18196,'18938','S','New Hope','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.357334,-74.995503,0,'2013-07-06 12:44:31',NULL,NULL),(20437,'20997','U','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.994472,-77.025419,0,'2013-07-06 12:44:31',NULL,NULL),(42529,'47859','S','Marshall','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.910754,-87.172148,0,'2013-07-06 12:44:32',NULL,NULL),(64435,'76561','S','Pecangrove','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.453052,-97.567079,0,'2013-07-06 12:44:34',NULL,NULL),(61093,'72134','S','Preston Ferry','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.603333,-91.341667,0,'2013-07-06 12:44:33',NULL,NULL),(25990,'28667','P','Rhodhizz','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.776179,-81.426688,0,'2013-07-06 12:44:31',NULL,NULL),(48053,'55318','S','Chaska','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.811514,-93.610998,0,'2013-07-06 12:44:33',NULL,NULL),(27434,'30114','S','Canton','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.247481,-84.524085,0,'2013-07-06 12:44:31',NULL,NULL),(34130,'38201','S','Mc Kenzie','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.134856,-88.517265,0,'2013-07-06 12:44:32',NULL,NULL),(23745,'25932','S','Surveyor','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.738613,-81.344727,0,'2013-07-06 12:44:31',NULL,NULL),(74717,'93020','P','Moorpark','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.284832,-118.881396,0,'2013-07-06 12:44:34',NULL,NULL),(18962,'19512','S','Landis Store','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(13871,'14241','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927923,-78.747650,0,'2013-07-06 12:44:31',NULL,NULL),(27910,'30501','S','Westside','N','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.286057,-83.820309,0,'2013-07-06 12:44:31',NULL,NULL),(63920,'76050','S','Grandview','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.266227,-97.177163,0,'2013-07-06 12:44:34',NULL,NULL),(66537,'78726','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.422763,-97.849596,0,'2013-07-06 12:44:34',NULL,NULL),(17468,'17948','S','Morea Colliery','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(27990,'30580','P','Turnerville','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.689760,-83.526227,0,'2013-07-06 12:44:31',NULL,NULL),(43572,'48735','S','Gagetown','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.649713,-83.273095,0,'2013-07-06 12:44:32',NULL,NULL),(3714,'02143','S','East Somerville','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.381835,-71.103174,0,'2013-07-06 12:44:30',NULL,NULL),(8183,'07881','S','Wallpack Ctr','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.204221,-74.819332,0,'2013-07-06 12:44:30',NULL,NULL),(72813,'89801','S','North Fork','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.834645,-115.757583,0,'2013-07-06 12:44:34',NULL,NULL),(64527,'76642','S','Box Church','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.546200,-96.529080,0,'2013-07-06 12:44:34',NULL,NULL),(11734,'12182','S','Pleasantdale','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.775992,-73.660085,0,'2013-07-06 12:44:30',NULL,NULL),(34177,'38314','P','Bemis','N','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.572680,-88.821300,0,'2013-07-06 12:44:32',NULL,NULL),(45958,'52356','S','Wellman','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.470532,-91.832359,0,'2013-07-06 12:44:32',NULL,NULL),(29446,'32701','S','Altamonte Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.662995,-81.372939,0,'2013-07-06 12:44:32',NULL,NULL),(10018,'10170','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(54348,'62777','U','IL Office Educ','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.800049,-89.654254,0,'2013-07-06 12:44:33',NULL,NULL),(71396,'87010','S','Madrid','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.413800,-106.124820,0,'2013-07-06 12:44:34',NULL,NULL),(73745,'91715','P','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.015728,-117.969965,0,'2013-07-06 12:44:34',NULL,NULL),(66444,'78650','S','Mc Dade','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.306005,-97.219545,0,'2013-07-06 12:44:34',NULL,NULL),(63890,'76016','S','Dalworthington Gardens','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.689966,-97.191463,0,'2013-07-06 12:44:34',NULL,NULL),(12945,'13354','S','East Floyd','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.253640,-75.284520,0,'2013-07-06 12:44:30',NULL,NULL),(43661,'48853','P','Maple Rapids','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.102216,-84.688937,0,'2013-07-06 12:44:32',NULL,NULL),(6343,'05670','P','South Barre','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.177625,-72.506552,0,'2013-07-06 12:44:30',NULL,NULL),(41257,'46746','S','Lima','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.716860,-85.413840,0,'2013-07-06 12:44:32',NULL,NULL),(15152,'15865','S','Sykesville','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.051580,-78.819613,0,'2013-07-06 12:44:31',NULL,NULL),(7771,'07417','S','Franklin Lakes','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.010518,-74.208897,0,'2013-07-06 12:44:30',NULL,NULL),(47335,'54566','S','Padus','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.438000,-88.631280,0,'2013-07-06 12:44:32',NULL,NULL),(67687,'80515','S','Drake','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.441457,-105.369149,0,'2013-07-06 12:44:34',NULL,NULL),(64321,'76484','S','Palo Pinto','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.749548,-98.288689,0,'2013-07-06 12:44:34',NULL,NULL),(64080,'76148','S','Haltom City','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(68619,'81624','S','Collbran','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.237222,-107.981111,0,'2013-07-06 12:44:34',NULL,NULL),(8471,'08089','S','Waterford Wks','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722580,-74.859000,0,'2013-07-06 12:44:30',NULL,NULL),(2690,'00968','S','Urb San Patricio','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(1303,'00731','S','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014073,-66.617175,0,'2013-07-06 12:44:30',NULL,NULL),(46868,'54028','S','Woodville','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.955122,-92.285779,0,'2013-07-06 12:44:32',NULL,NULL),(34182,'38317','S','Bruceton','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.038756,-88.246285,0,'2013-07-06 12:44:32',NULL,NULL),(17800,'18371','S','Tamiment','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.093333,-75.002222,0,'2013-07-06 12:44:31',NULL,NULL),(11336,'11791','S','Syosset','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.813797,-73.502844,0,'2013-07-06 12:44:30',NULL,NULL),(57302,'66624','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.016351,-95.672071,0,'2013-07-06 12:44:33',NULL,NULL),(74938,'93408','U','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.222175,-120.637046,0,'2013-07-06 12:44:34',NULL,NULL),(15154,'15868','S','Weedville','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.266572,-78.493803,0,'2013-07-06 12:44:31',NULL,NULL),(75796,'94712','P','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.868998,-122.267900,0,'2013-07-06 12:44:34',NULL,NULL),(61681,'72937','S','Hackett','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.189791,-94.413379,0,'2013-07-06 12:44:33',NULL,NULL),(7882,'07512','S','Totowa Boro','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.902106,-74.218941,0,'2013-07-06 12:44:30',NULL,NULL),(3592,'02027','P','Dedham','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.246639,-71.179916,0,'2013-07-06 12:44:30',NULL,NULL),(17165,'17814','S','Elk Grove','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(28976,'32210','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.260733,-81.746664,0,'2013-07-06 12:44:32',NULL,NULL),(40632,'46030','S','Arcadia','D','Hamilton','18057','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.175147,-86.017681,0,'2013-07-06 12:44:32',NULL,NULL),(53210,'61616','S','Peoria Hts','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.751710,-89.600183,0,'2013-07-06 12:44:33',NULL,NULL),(40433,'45713','P','Bartlett','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.421391,-81.815945,0,'2013-07-06 12:44:32',NULL,NULL),(74444,'92583','S','San Jacinto','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.791618,-116.918647,0,'2013-07-06 12:44:34',NULL,NULL),(77550,'96859','S','Tripler Army Med Ctr','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.347002,-157.872476,0,'2013-07-06 12:44:34',NULL,NULL),(14432,'15082','P','Sturgeon','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.413799,-80.193818,0,'2013-07-06 12:44:31',NULL,NULL),(7661,'07086','S','Weehawken','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.766011,-74.029750,0,'2013-07-06 12:44:30',NULL,NULL),(9127,'09172','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(39738,'45069','S','Liberty Township','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.341460,-84.398674,0,'2013-07-06 12:44:32',NULL,NULL),(54922,'63099','U','Maritz Inc','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.536522,-90.448052,0,'2013-07-06 12:44:33',NULL,NULL),(47671,'54945','S','Iola','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.510909,-89.133958,0,'2013-07-06 12:44:33',NULL,NULL),(52787,'61270','S','Ustick','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(1590,'00769','S','Hacienda Miraflores','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(68041,'80929','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.814846,-104.619185,0,'2013-07-06 12:44:34',NULL,NULL),(76037,'95154','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.261661,-121.912816,0,'2013-07-06 12:44:34',NULL,NULL),(72615,'89415','S','Walker Lake','A','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(40530,'45833','S','Delphos','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.825122,-84.323947,0,'2013-07-06 12:44:32',NULL,NULL),(22116,'23432','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.870120,-76.555020,0,'2013-07-06 12:44:31',NULL,NULL),(13307,'13670','S','Oswegatchie','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.179515,-75.082431,0,'2013-07-06 12:44:30',NULL,NULL),(58931,'69345','S','Harrisburg','D','Banner','31007','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.547935,-103.710058,0,'2013-07-06 12:44:33',NULL,NULL),(73455,'91302','S','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.134741,-118.656723,0,'2013-07-06 12:44:34',NULL,NULL),(27654,'30322','U','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.791247,-84.324900,0,'2013-07-06 12:44:31',NULL,NULL),(26861,'29536','S','Dillon','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.414774,-79.364457,0,'2013-07-06 12:44:31',NULL,NULL),(69510,'83716','S','Atlanta','A','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.531746,-116.140200,0,'2013-07-06 12:44:34',NULL,NULL),(55921,'64458','S','Hatfield','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.521238,-94.177381,0,'2013-07-06 12:44:33',NULL,NULL),(29476,'32724','S','Deland','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.041510,-81.285829,0,'2013-07-06 12:44:32',NULL,NULL),(32235,'35584','P','Sipsey','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.822855,-87.080882,0,'2013-07-06 12:44:32',NULL,NULL),(4999,'04217','S','Mason Twp','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.447236,-70.693616,0,'2013-07-06 12:44:30',NULL,NULL),(74211,'92307','S','Apple Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.524715,-117.197826,0,'2013-07-06 12:44:34',NULL,NULL),(20868,'21668','S','Sudlersville','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.197496,-75.855542,0,'2013-07-06 12:44:31',NULL,NULL),(46852,'54022','S','River Falls','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.880780,-92.632260,0,'2013-07-06 12:44:32',NULL,NULL),(27369,'30069','U','Dobbins AFB','A','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.916908,-84.517971,0,'2013-07-06 12:44:31',NULL,NULL),(50359,'57748','S','Plainview','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.541189,-102.211846,0,'2013-07-06 12:44:33',NULL,NULL),(61562,'72721','S','Combs','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.846802,-93.819393,0,'2013-07-06 12:44:33',NULL,NULL),(57580,'67062','S','Hesston','D','Harvey','20079','Kansas','KS','20','9040','620','Central',-6.0,'Y',38.138940,-97.430948,0,'2013-07-06 12:44:33',NULL,NULL),(25888,'28643','S','Apple Grove','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(15246,'16048','P','North Washington','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.046265,-79.815559,0,'2013-07-06 12:44:31',NULL,NULL),(57531,'67012','P','Beaumont','D','Butler','20015','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.658920,-96.533960,0,'2013-07-06 12:44:33',NULL,NULL),(76683,'95815','S','North Sacramento','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.612581,-121.445749,0,'2013-07-06 12:44:34',NULL,NULL),(80117,'99762','P','Little Diomede','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.787400,-165.197220,0,'2013-07-06 12:44:34',NULL,NULL),(73192,'90505','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.809221,-118.349149,0,'2013-07-06 12:44:34',NULL,NULL),(65340,'77520','S','Garth','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(56461,'65286','S','Triplett','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.510264,-93.212915,0,'2013-07-06 12:44:33',NULL,NULL),(18537,'19111','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057937,-75.081966,0,'2013-07-06 12:44:31',NULL,NULL),(23542,'25612','S','Chauncey','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.763663,-81.989120,0,'2013-07-06 12:44:31',NULL,NULL),(2999,'01070','S','Plainfield','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.536840,-72.933103,0,'2013-07-06 12:44:30',NULL,NULL),(53933,'62410','S','Allendale','D','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.527991,-87.708425,0,'2013-07-06 12:44:33',NULL,NULL),(3121,'01237','S','Lanesborough','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.539340,-73.246200,0,'2013-07-06 12:44:30',NULL,NULL),(30115,'33161','S','Biscayne Park','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(28437,'31404','S','Thunderbolt','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.044042,-81.068991,0,'2013-07-06 12:44:32',NULL,NULL),(26641,'29340','S','Gaffney','D','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.062322,-81.645437,0,'2013-07-06 12:44:31',NULL,NULL),(38091,'43078','S','Urbana','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.118640,-83.767620,0,'2013-07-06 12:44:32',NULL,NULL),(45411,'51049','S','Quimby','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.627623,-95.641152,0,'2013-07-06 12:44:32',NULL,NULL),(25288,'28136','P','Shelby','A','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.414631,-81.618702,0,'2013-07-06 12:44:31',NULL,NULL),(66800,'79064','S','Olton','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.183450,-102.136365,0,'2013-07-06 12:44:34',NULL,NULL),(72367,'89029','S','Laughlin','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.138548,-114.623664,0,'2013-07-06 12:44:34',NULL,NULL),(73930,'92030','P','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.135119,-117.056194,0,'2013-07-06 12:44:34',NULL,NULL),(64420,'76550','S','Watson','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.066265,-98.180696,0,'2013-07-06 12:44:34',NULL,NULL),(61886,'73134','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.616422,-97.571744,0,'2013-07-06 12:44:33',NULL,NULL),(8961,'08808','P','Broadway','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.725589,-75.048373,0,'2013-07-06 12:44:30',NULL,NULL),(49652,'56972','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(56309,'65101','S','Osage Bluff','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(72374,'89032','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.224370,-115.171642,0,'2013-07-06 12:44:34',NULL,NULL),(68028,'80927','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.664269,-104.909568,0,'2013-07-06 12:44:34',NULL,NULL),(60905,'72076','S','Gravel Ridge','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(7122,'06382','S','Uncasville','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.460941,-72.113460,0,'2013-07-06 12:44:30',NULL,NULL),(29365,'32577','S','Molino','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.722097,-87.324952,0,'2013-07-06 12:44:32',NULL,NULL),(11283,'11772','S','North Patchogue','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(52108,'60416','S','Diamond','A','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.291648,-88.285221,0,'2013-07-06 12:44:33',NULL,NULL),(2928,'01020','S','Chicopee','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.175600,-72.569990,0,'2013-07-06 12:44:30',NULL,NULL),(2876,'00987','S','Bo Martin Gonzalez','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(44132,'49512','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881460,-85.535400,0,'2013-07-06 12:44:32',NULL,NULL),(39202,'44334','P','Fairlawn','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.079338,-81.516616,0,'2013-07-06 12:44:32',NULL,NULL),(31790,'35033','S','Bremen','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.953478,-87.004753,0,'2013-07-06 12:44:32',NULL,NULL),(50681,'58345','S','Lawton','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.294882,-98.445192,0,'2013-07-06 12:44:33',NULL,NULL),(70969,'85658','S','Marana','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.436756,-111.083038,0,'2013-07-06 12:44:34',NULL,NULL),(66506,'78701','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.271567,-97.741886,0,'2013-07-06 12:44:34',NULL,NULL),(58021,'67950','S','Elkhart','D','Morton','20129','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.000631,-101.903047,0,'2013-07-06 12:44:33',NULL,NULL),(56919,'66060','S','Nortonville','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.420131,-95.330822,0,'2013-07-06 12:44:33',NULL,NULL),(24589,'27320','S','Monroeton','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(13758,'14129','S','Perrysburg','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.469663,-79.006594,0,'2013-07-06 12:44:31',NULL,NULL),(32775,'36376','S','Webb','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.200351,-85.295977,0,'2013-07-06 12:44:32',NULL,NULL),(47626,'54911','S','Grand Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.275220,-88.395755,0,'2013-07-06 12:44:33',NULL,NULL),(55010,'63132','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.671787,-90.377495,0,'2013-07-06 12:44:33',NULL,NULL),(55056,'63151','P','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.468598,-90.305114,0,'2013-07-06 12:44:33',NULL,NULL),(3074,'01139','P','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.116316,-72.546932,0,'2013-07-06 12:44:30',NULL,NULL),(25519,'28388','P','Southern Pines','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.181810,-79.401905,0,'2013-07-06 12:44:31',NULL,NULL),(41125,'46613','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.651754,-86.251010,0,'2013-07-06 12:44:32',NULL,NULL),(65545,'77831','S','Singleton','A','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.747332,-95.921935,0,'2013-07-06 12:44:34',NULL,NULL),(71748,'87543','P','Llano','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.167777,-105.685148,0,'2013-07-06 12:44:34',NULL,NULL),(77298,'96665','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(1482,'00745','S','Vistas del Mar','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(67320,'80027','S','Superior','A','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.966420,-105.154200,0,'2013-07-06 12:44:34',NULL,NULL),(13112,'13485','S','South Brookfield','N','Madison','36053','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.787840,-75.318973,0,'2013-07-06 12:44:30',NULL,NULL),(26903,'29576','S','Murrells Inlt','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.586770,-79.009455,0,'2013-07-06 12:44:31',NULL,NULL),(28374,'31294','U','Macon Brm','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.837487,-83.632352,0,'2013-07-06 12:44:32',NULL,NULL),(79053,'98416','U','University of Puget Sound','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.265185,-122.482216,0,'2013-07-06 12:44:34',NULL,NULL),(77778,'97124','S','Helvetia','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.535156,-122.956260,0,'2013-07-06 12:44:34',NULL,NULL),(61414,'72561','S','Mount Pleasant','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.964212,-91.806374,0,'2013-07-06 12:44:33',NULL,NULL),(9275,'09622','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(37405,'41774','S','Viper','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.138863,-83.165412,0,'2013-07-06 12:44:32',NULL,NULL),(40614,'45899','P','Wren','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.801856,-84.772143,0,'2013-07-06 12:44:32',NULL,NULL),(45108,'50551','S','Jolley','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.512600,-94.745828,0,'2013-07-06 12:44:32',NULL,NULL),(67588,'80403','S','Arvada','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.818028,-105.251370,0,'2013-07-06 12:44:34',NULL,NULL),(53678,'62220','S','Swansea','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.525719,-89.991068,0,'2013-07-06 12:44:33',NULL,NULL),(63749,'75939','S','Asia','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(60977,'72108','P','Monroe','D','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.735002,-91.099721,0,'2013-07-06 12:44:33',NULL,NULL),(53303,'61736','S','Downs','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.364700,-88.868220,0,'2013-07-06 12:44:33',NULL,NULL),(15970,'17032','S','Carsonville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(49571,'56725','S','Erie','N','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.061717,-95.716096,0,'2013-07-06 12:44:33',NULL,NULL),(3524,'01889','U','N Reading','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.572012,-71.111231,0,'2013-07-06 12:44:30',NULL,NULL),(20009,'20615','S','Broomes Island','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.417827,-76.545282,0,'2013-07-06 12:44:31',NULL,NULL),(59376,'70598','P','Energy Center','N','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.175952,-92.009989,0,'2013-07-06 12:44:33',NULL,NULL),(2349,'00940','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410886,-66.065084,0,'2013-07-06 12:44:30',NULL,NULL),(14188,'14753','S','Limestone','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.035199,-78.640416,0,'2013-07-06 12:44:31',NULL,NULL),(39415,'44667','S','Riceland','N','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.833108,-81.768456,0,'2013-07-06 12:44:32',NULL,NULL),(53567,'62054','S','Old Kane','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.217022,-90.382913,0,'2013-07-06 12:44:33',NULL,NULL),(42283,'47586','S','Franklin Hls','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(70875,'85607','S','Douglas','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.351622,-109.543515,0,'2013-07-06 12:44:34',NULL,NULL),(54245,'62668','S','Nortonville','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.586700,-90.247679,0,'2013-07-06 12:44:33',NULL,NULL),(60218,'71423','S','Williana','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.618500,-92.570400,0,'2013-07-06 12:44:33',NULL,NULL),(19216,'19893','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.747693,-75.557912,0,'2013-07-06 12:44:31',NULL,NULL),(24689,'27416','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.002309,-79.764089,0,'2013-07-06 12:44:31',NULL,NULL),(60469,'71655','S','Coleman','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(4795,'03878','S','Somersworth','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.253884,-70.873359,0,'2013-07-06 12:44:30',NULL,NULL),(16286,'17103','S','Penbrook','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259580,-76.860180,0,'2013-07-06 12:44:31',NULL,NULL),(48068,'55328','S','Independence','N','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.036101,-93.816580,0,'2013-07-06 12:44:33',NULL,NULL),(10779,'11366','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.729445,-73.797794,0,'2013-07-06 12:44:30',NULL,NULL),(49585,'56737','S','Middle River','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.459145,-96.060323,0,'2013-07-06 12:44:33',NULL,NULL),(36289,'40353','S','Mt Sterling','A','Montgomery','21173','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.057445,-83.934406,0,'2013-07-06 12:44:32',NULL,NULL),(16717,'17406','S','Accomac','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(32247,'35610','S','Anderson','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.951348,-87.275850,0,'2013-07-06 12:44:32',NULL,NULL),(77659,'97022','S','Dover','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.350882,-122.339245,0,'2013-07-06 12:44:34',NULL,NULL),(64111,'76180','S','North Richland Hills','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(24482,'27248','S','Franklinville','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.749129,-79.701339,0,'2013-07-06 12:44:31',NULL,NULL),(15103,'15771','S','Rochester Mls','A','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.821250,-79.006895,0,'2013-07-06 12:44:31',NULL,NULL),(15284,'16123','S','Fombell','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.813183,-80.198449,0,'2013-07-06 12:44:31',NULL,NULL),(13588,'13849','S','Unadilla','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.323762,-75.319978,0,'2013-07-06 12:44:31',NULL,NULL),(16872,'17567','P','Reamstown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.207163,-76.120458,0,'2013-07-06 12:44:31',NULL,NULL),(778,'00693','S','Alt De Vega Baja','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(25726,'28546','S','Jacksonville','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.774523,-77.381406,0,'2013-07-06 12:44:31',NULL,NULL),(41123,'46601','S','So Bend','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.672606,-86.251722,0,'2013-07-06 12:44:32',NULL,NULL),(35709,'39667','S','Lexie','N','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(17685,'18202','S','Hazle Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(5377,'04634','S','Eastbrook','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.624794,-68.218829,0,'2013-07-06 12:44:30',NULL,NULL),(42011,'47432','S','Cuzco','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.545144,-86.619616,0,'2013-07-06 12:44:32',NULL,NULL),(63059,'75227','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.766974,-96.683948,0,'2013-07-06 12:44:33',NULL,NULL),(57139,'66227','S','Shawnee','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.980518,-94.869055,0,'2013-07-06 12:44:33',NULL,NULL),(22127,'23439','P','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.700891,-76.637248,0,'2013-07-06 12:44:31',NULL,NULL),(8956,'08803','P','Baptistown','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.520741,-75.009187,0,'2013-07-06 12:44:30',NULL,NULL),(9485,'10011','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(37946,'42716','S','Buffalo','D','Larue','21123','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.496324,-85.675114,0,'2013-07-06 12:44:32',NULL,NULL),(69025,'83214','S','Arimo','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.554001,-112.229068,0,'2013-07-06 12:44:34',NULL,NULL),(7120,'06379','S','Pawcatuck','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.373454,-71.849357,0,'2013-07-06 12:44:30',NULL,NULL),(27092,'29710','S','Lk Wylie','N','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.105301,-81.184746,0,'2013-07-06 12:44:31',NULL,NULL),(9569,'10025','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(604,'00680','S','Urb Pura Brisa','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(46055,'52572','S','Moulton','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.689450,-92.684164,0,'2013-07-06 12:44:32',NULL,NULL),(47587,'54856','S','Mason','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.439280,-91.085880,0,'2013-07-06 12:44:33',NULL,NULL),(17366,'17872','S','Weigh Scale','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(19229,'19901','S','Leipsic','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.149969,-75.531543,0,'2013-07-06 12:44:31',NULL,NULL),(71286,'86438','P','Yucca','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.875174,-114.152406,0,'2013-07-06 12:44:34',NULL,NULL),(57245,'66526','S','Paxico','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.070019,-96.168870,0,'2013-07-06 12:44:33',NULL,NULL),(9312,'09724','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(13590,'13850','S','Ross Corners','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(14467,'15120','S','Munhall','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.394809,-79.903215,0,'2013-07-06 12:44:31',NULL,NULL),(38880,'44107','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.482343,-81.794563,0,'2013-07-06 12:44:32',NULL,NULL),(31437,'34270','P','Tallevast','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.402668,-82.541088,0,'2013-07-06 12:44:32',NULL,NULL),(38928,'44122','S','Pepper Pike','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(18487,'19089','U','Wayne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.045461,-75.387632,0,'2013-07-06 12:44:31',NULL,NULL),(57063,'66213','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(68198,'81038','P','Fort Lyon','D','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.910961,-103.098113,0,'2013-07-06 12:44:34',NULL,NULL),(47557,'54835','S','Exeland','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.676386,-91.234509,0,'2013-07-06 12:44:32',NULL,NULL),(80171,'99829','P','Hoonah','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.126218,-135.650802,0,'2013-07-06 12:44:34',NULL,NULL),(63669,'75853','S','Springfield','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.941780,-95.763120,0,'2013-07-06 12:44:34',NULL,NULL),(29000,'32220','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.328507,-81.815147,0,'2013-07-06 12:44:32',NULL,NULL),(28988,'32214','U','Jacksonville Naval Hospital','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.216694,-81.684003,0,'2013-07-06 12:44:32',NULL,NULL),(45036,'50472','S','Otranto','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.377784,-92.915665,0,'2013-07-06 12:44:32',NULL,NULL),(44581,'50034','S','Blairsburg','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.480643,-93.643050,0,'2013-07-06 12:44:32',NULL,NULL),(28815,'32073','S','Orange Park','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.174663,-81.758375,0,'2013-07-06 12:44:32',NULL,NULL),(38056,'43054','S','New Albany','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.086466,-82.808804,0,'2013-07-06 12:44:32',NULL,NULL),(62441,'74172','S','Williams Center','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.150461,-95.972719,0,'2013-07-06 12:44:33',NULL,NULL),(40090,'45305','S','Beavercreek','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(357,'00659','S','Colinas de Hatillo','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(14429,'15077','P','Shippingport','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.617677,-80.425854,0,'2013-07-06 12:44:31',NULL,NULL),(13779,'14150','S','Tonawanda','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.001575,-78.861741,0,'2013-07-06 12:44:31',NULL,NULL),(18727,'19320','S','E Fallowfield','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(13457,'13780','S','Guilford','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.405278,-75.462500,0,'2013-07-06 12:44:31',NULL,NULL),(21064,'21919','S','Earleville','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.430899,-75.945941,0,'2013-07-06 12:44:31',NULL,NULL),(50366,'57754','S','Central City','A','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.350616,-103.768341,0,'2013-07-06 12:44:33',NULL,NULL),(79528,'98939','P','Parker','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.501567,-120.463712,0,'2013-07-06 12:44:34',NULL,NULL),(26259,'29006','S','Kneece','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(43988,'49335','P','Moline','D','Allegan','26005','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.737508,-85.662495,0,'2013-07-06 12:44:32',NULL,NULL),(55104,'63304','S','Weldon Spring Heights','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(2293,'00926','S','Vista Alegre','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(9251,'09586','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8254,'08008','S','Brant Beach','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(20688,'21239','S','Northwood','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.358614,-76.590884,0,'2013-07-06 12:44:31',NULL,NULL),(2668,'00966','S','Urb Susan CT Chalets','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(75349,'93908','S','Corral de Tierra','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.603909,-121.654754,0,'2013-07-06 12:44:34',NULL,NULL),(62845,'75017','P','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.811971,-96.947107,0,'2013-07-06 12:44:33',NULL,NULL),(35480,'39520','S','Stennis Space Center','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(50854,'58494','S','Wing','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',47.152140,-100.332354,0,'2013-07-06 12:44:33',NULL,NULL),(79467,'98855','S','Ellisford','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.704499,-119.439348,0,'2013-07-06 12:44:34',NULL,NULL),(4644,'03745','S','Cornish','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.527810,-72.368380,0,'2013-07-06 12:44:30',NULL,NULL),(37789,'42367','S','Powderly','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.206160,-87.173607,0,'2013-07-06 12:44:32',NULL,NULL),(48102,'55343','S','Minnetonka Mills','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(23011,'24818','S','Brenton','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.582931,-81.667453,0,'2013-07-06 12:44:31',NULL,NULL),(7246,'06513','S','East Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.321735,-72.859214,0,'2013-07-06 12:44:30',NULL,NULL),(44427,'49841','S','Gwinn','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.323840,-87.480360,0,'2013-07-06 12:44:32',NULL,NULL),(34788,'38868','S','Shannon','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.120111,-88.714124,0,'2013-07-06 12:44:32',NULL,NULL),(50983,'58643','S','Marmarth','D','Slope','38087','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.384587,-103.850071,0,'2013-07-06 12:44:33',NULL,NULL),(72149,'88323','P','Ft Stanton','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.498917,-105.523270,0,'2013-07-06 12:44:34',NULL,NULL),(8297,'08021','S','Pine Valley','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(61244,'72346','S','Blackfish','N','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.067120,-90.452280,0,'2013-07-06 12:44:33',NULL,NULL),(70257,'84511','S','Blanding','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.644259,-109.463425,0,'2013-07-06 12:44:34',NULL,NULL),(57519,'66968','S','Washington','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.816009,-97.051399,0,'2013-07-06 12:44:33',NULL,NULL),(56977,'66201','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.969026,-94.676138,0,'2013-07-06 12:44:33',NULL,NULL),(52036,'60186','P','West Chicago','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.884907,-88.206513,0,'2013-07-06 12:44:33',NULL,NULL),(38008,'42788','S','White Mills','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.544181,-86.030281,0,'2013-07-06 12:44:32',NULL,NULL),(40043,'45253','P','Groesbeck','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.269123,-84.599293,0,'2013-07-06 12:44:32',NULL,NULL),(29067,'32247','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.297084,-81.635006,0,'2013-07-06 12:44:32',NULL,NULL),(17324,'17860','S','Paxinos','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.833938,-76.639647,0,'2013-07-06 12:44:31',NULL,NULL),(13665,'14030','S','Chaffee','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.570274,-78.505479,0,'2013-07-06 12:44:31',NULL,NULL),(14534,'15207','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403820,-79.926060,0,'2013-07-06 12:44:31',NULL,NULL),(15079,'15748','S','Homer City','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.525920,-79.162140,0,'2013-07-06 12:44:31',NULL,NULL),(4336,'03034','S','Candia','D','Rockingham','33015','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.050055,-71.305574,0,'2013-07-06 12:44:30',NULL,NULL),(58850,'69138','S','Gothenburg','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.931096,-100.161748,0,'2013-07-06 12:44:33',NULL,NULL),(46547,'53406','S','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.725720,-87.856436,0,'2013-07-06 12:44:32',NULL,NULL),(68644,'81640','S','Browns Park','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.530669,-108.143210,0,'2013-07-06 12:44:34',NULL,NULL),(61038,'72118','S','Jeffery','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(41172,'46706','S','Auburn','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.370451,-85.045718,0,'2013-07-06 12:44:32',NULL,NULL),(23168,'25022','P','Blair','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.877303,-81.827231,0,'2013-07-06 12:44:31',NULL,NULL),(48147,'55368','S','Norwood Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.752993,-93.920341,0,'2013-07-06 12:44:33',NULL,NULL),(79455,'98848','S','Trinidad','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.210850,-119.861652,0,'2013-07-06 12:44:34',NULL,NULL),(74660,'92845','S','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.778738,-118.026665,0,'2013-07-06 12:44:34',NULL,NULL),(71295,'86445','S','White Hills','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.731831,-114.378837,0,'2013-07-06 12:44:34',NULL,NULL),(61198,'72225','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.752796,-92.349189,0,'2013-07-06 12:44:33',NULL,NULL),(46562,'53512','P','Beloit','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.507644,-89.032201,0,'2013-07-06 12:44:32',NULL,NULL),(77787,'97131','S','Mohler','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.720000,-123.859980,0,'2013-07-06 12:44:34',NULL,NULL),(73031,'90073','P','Veterans Admn','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.052501,-118.455227,0,'2013-07-06 12:44:34',NULL,NULL),(71831,'87579','S','El Rancho Loma Linda','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(8869,'08690','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(8951,'08759','S','Manchester Township','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.952064,-74.365653,0,'2013-07-06 12:44:30',NULL,NULL),(42041,'47441','S','Whites Xing','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(21931,'23228','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.624801,-77.497483,0,'2013-07-06 12:44:31',NULL,NULL),(49053,'56301','S','Sartell','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.531141,-94.209162,0,'2013-07-06 12:44:33',NULL,NULL),(47350,'54610','S','Cream','N','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.325050,-91.912041,0,'2013-07-06 12:44:32',NULL,NULL),(73277,'90742','P','Sunset Beach','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.718777,-118.069914,0,'2013-07-06 12:44:34',NULL,NULL),(77738,'97076','P','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.489342,-122.799818,0,'2013-07-06 12:44:34',NULL,NULL),(32851,'36503','P','Atmore','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.022934,-87.493385,0,'2013-07-06 12:44:32',NULL,NULL),(49080,'56324','S','Dalton','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.151717,-95.830472,0,'2013-07-06 12:44:33',NULL,NULL),(4282,'02893','S','W Warwick','N','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.692019,-71.516302,0,'2013-07-06 12:44:30',NULL,NULL),(39901,'45215','S','Reading','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(24445,'27214','S','Brown Summit','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(29501,'32756','P','Mount Dora','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.804712,-81.644149,0,'2013-07-06 12:44:32',NULL,NULL),(9898,'10129','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755624,-73.990453,0,'2013-07-06 12:44:30',NULL,NULL),(78582,'98175','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.603561,-122.329437,0,'2013-07-06 12:44:34',NULL,NULL),(72299,'88580','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.759159,-106.487488,0,'2013-07-06 12:44:34',NULL,NULL),(39232,'44420','S','Girard','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.157789,-80.687930,0,'2013-07-06 12:44:32',NULL,NULL),(6521,'05825','P','Coventry','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.869361,-72.236575,0,'2013-07-06 12:44:30',NULL,NULL),(70002,'84123','S','Taylorsville','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(54927,'63105','S','Clayton','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.643582,-90.328636,0,'2013-07-06 12:44:33',NULL,NULL),(77293,'96660','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(73132,'90274','S','Palos Verdes Estates','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(69612,'83860','S','Sagle','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.199188,-116.569780,0,'2013-07-06 12:44:34',NULL,NULL),(4457,'03255','S','Mount Sunapee','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.320148,-72.027840,0,'2013-07-06 12:44:30',NULL,NULL),(32164,'35475','S','N Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.245390,-87.594372,0,'2013-07-06 12:44:32',NULL,NULL),(30606,'33424','P','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.519180,-80.108145,0,'2013-07-06 12:44:32',NULL,NULL),(50865,'58504','S','Lincoln','A','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.760820,-100.699380,0,'2013-07-06 12:44:33',NULL,NULL),(46981,'54226','P','Maplewood','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.724230,-87.483531,0,'2013-07-06 12:44:32',NULL,NULL),(12993,'13409','S','Pratts Hollow','A','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.950700,-75.568980,0,'2013-07-06 12:44:30',NULL,NULL),(19694,'20374','S','Washington Na','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.828906,-77.015495,0,'2013-07-06 12:44:31',NULL,NULL),(1632,'00771','S','Urb Camino Sereno','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(55197,'63383','S','Elkhorn','N','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.771220,-91.224360,0,'2013-07-06 12:44:33',NULL,NULL),(58868,'69153','S','Roscoe','N','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.154960,-101.677440,0,'2013-07-06 12:44:33',NULL,NULL),(50541,'58124','U','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.873899,-96.786609,0,'2013-07-06 12:44:33',NULL,NULL),(41443,'46866','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.070946,-85.163819,0,'2013-07-06 12:44:32',NULL,NULL),(5433,'04679','S','Southwest Hbr','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.279865,-68.330071,0,'2013-07-06 12:44:30',NULL,NULL),(57723,'67364','P','Tyro','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.039062,-95.820975,0,'2013-07-06 12:44:33',NULL,NULL),(74125,'92239','P','Eagle Mtn','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.712500,-115.401389,0,'2013-07-06 12:44:34',NULL,NULL),(63167,'75395','U','Wachovia Bank and Trust','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.708936,-96.838941,0,'2013-07-06 12:44:33',NULL,NULL),(56238,'65047','S','Kaiser','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.172871,-92.564265,0,'2013-07-06 12:44:33',NULL,NULL),(42463,'47834','S','Asherville','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(43299,'48341','S','Pontiac','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.626279,-83.297758,0,'2013-07-06 12:44:32',NULL,NULL),(51356,'59333','S','Hathaway','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.275921,-106.197425,0,'2013-07-06 12:44:33',NULL,NULL),(31979,'35217','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.608700,-86.752620,0,'2013-07-06 12:44:32',NULL,NULL),(25992,'28669','S','Lomax','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.190998,-80.999456,0,'2013-07-06 12:44:31',NULL,NULL),(22144,'23455','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.888297,-76.144677,0,'2013-07-06 12:44:31',NULL,NULL),(52633,'61048','S','Lena','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.383724,-89.822437,0,'2013-07-06 12:44:33',NULL,NULL),(75131,'93554','P','Randsburg','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.375287,-117.664370,0,'2013-07-06 12:44:34',NULL,NULL),(56850,'65898','U','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.213380,-93.292201,0,'2013-07-06 12:44:33',NULL,NULL),(24185,'26631','S','Napier','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.772829,-80.582664,0,'2013-07-06 12:44:31',NULL,NULL),(26925,'29585','S','Pawleys Is','N','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.453325,-79.135137,0,'2013-07-06 12:44:31',NULL,NULL),(52679,'61080','S','South Beloit','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.477180,-88.971660,0,'2013-07-06 12:44:33',NULL,NULL),(12802,'13235','P','University','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048750,-76.148002,0,'2013-07-06 12:44:30',NULL,NULL),(16284,'17103','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259580,-76.860180,0,'2013-07-06 12:44:31',NULL,NULL),(27749,'30358','P','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.934524,-84.388655,0,'2013-07-06 12:44:31',NULL,NULL),(15241,'16041','S','Karns City','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.009844,-79.704538,0,'2013-07-06 12:44:31',NULL,NULL),(8936,'08753','S','Dover Township','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.988680,-74.179560,0,'2013-07-06 12:44:30',NULL,NULL),(20692,'21241','U','Social Security Admin','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.303353,-76.733353,0,'2013-07-06 12:44:31',NULL,NULL),(18917,'19493','U','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.053935,-75.556943,0,'2013-07-06 12:44:31',NULL,NULL),(16160,'17062','S','Reward','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(77646,'97015','S','Clackamas','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.415610,-122.523750,0,'2013-07-06 12:44:34',NULL,NULL),(76353,'95481','P','Talmage','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.130128,-123.164095,0,'2013-07-06 12:44:34',NULL,NULL),(73302,'90805','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.863555,-118.182163,0,'2013-07-06 12:44:34',NULL,NULL),(71094,'85936','S','Saint Johns','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.506335,-109.378069,0,'2013-07-06 12:44:34',NULL,NULL),(66050,'78376','S','Ramirez','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.518196,-98.637460,0,'2013-07-06 12:44:34',NULL,NULL),(59814,'71232','S','Delhi','D','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.453833,-91.489746,0,'2013-07-06 12:44:33',NULL,NULL),(25765,'28587','S','Vandermere','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.182811,-76.661444,0,'2013-07-06 12:44:31',NULL,NULL),(52389,'60630','S','Jefferson','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.971136,-87.757805,0,'2013-07-06 12:44:33',NULL,NULL),(27766,'30364','P','East Point','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.675999,-84.461995,0,'2013-07-06 12:44:31',NULL,NULL),(567,'00678','S','Urb Dos Ceibas','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(74654,'92838','P','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.893354,-117.931038,0,'2013-07-06 12:44:34',NULL,NULL),(64209,'76262','S','Northlake','A','Denton','48121','Texas','TX','48','1920','817','Central',-6.0,'Y',33.007049,-97.194352,0,'2013-07-06 12:44:34',NULL,NULL),(74900,'93305','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.389089,-118.983059,0,'2013-07-06 12:44:34',NULL,NULL),(63369,'75642','P','Elysian Flds','A','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.366441,-94.185982,0,'2013-07-06 12:44:33',NULL,NULL),(62994,'75154','S','Glenn Heights','A','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.525442,-96.814963,0,'2013-07-06 12:44:33',NULL,NULL),(31509,'34460','P','Lecanto','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.931170,-82.491367,0,'2013-07-06 12:44:32',NULL,NULL),(23281,'25160','S','Pond Gap','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.284577,-81.285850,0,'2013-07-06 12:44:31',NULL,NULL),(43425,'48469','S','Port Sanilac','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.476841,-82.573667,0,'2013-07-06 12:44:32',NULL,NULL),(37935,'42647','S','Stearns','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.681333,-84.619572,0,'2013-07-06 12:44:32',NULL,NULL),(35516,'39533','P','Boloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.396332,-88.884915,0,'2013-07-06 12:44:32',NULL,NULL),(14507,'15201','S','Pitts','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.470679,-79.954348,0,'2013-07-06 12:44:31',NULL,NULL),(34589,'38740','S','Roundlake','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.777156,-90.722884,0,'2013-07-06 12:44:32',NULL,NULL),(5820,'05074','P','Thetford Hill','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.819172,-72.228251,0,'2013-07-06 12:44:30',NULL,NULL),(66410,'78631','S','Noxville','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.317834,-99.222875,0,'2013-07-06 12:44:34',NULL,NULL),(55240,'63443','S','Hunnewell','D','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.668204,-91.858753,0,'2013-07-06 12:44:33',NULL,NULL),(2638,'00965','S','Villa Concepcion 2','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(28380,'31301','S','Allenhurst','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.771082,-81.598279,0,'2013-07-06 12:44:32',NULL,NULL),(10805,'11373','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738937,-73.879160,0,'2013-07-06 12:44:30',NULL,NULL),(13975,'14481','S','Leicester','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.777475,-77.909721,0,'2013-07-06 12:44:31',NULL,NULL),(28381,'31302','S','Bloomingdale','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.121679,-81.299728,0,'2013-07-06 12:44:32',NULL,NULL),(1139,'00727','S','Alt de la Fuente','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(56023,'64670','S','Pattonsburg','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.043173,-94.136185,0,'2013-07-06 12:44:33',NULL,NULL),(22864,'24554','S','Gladys','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.113813,-79.283359,0,'2013-07-06 12:44:31',NULL,NULL),(11033,'11568','S','Westbury','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.782780,-73.590240,0,'2013-07-06 12:44:30',NULL,NULL),(19028,'19534','S','Krumsville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.571700,-75.849180,0,'2013-07-06 12:44:31',NULL,NULL),(67060,'79562','S','Tuscola','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.199975,-99.911111,0,'2013-07-06 12:44:34',NULL,NULL),(38434,'43557','S','Evansport','A','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.502278,-84.412734,0,'2013-07-06 12:44:32',NULL,NULL),(12928,'13341','P','Franklin Springs','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.034678,-75.390751,0,'2013-07-06 12:44:30',NULL,NULL),(15488,'16443','S','W Springfield','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.939334,-80.469219,0,'2013-07-06 12:44:31',NULL,NULL),(23364,'25271','S','Fairplain','N','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.814793,-81.707302,0,'2013-07-06 12:44:31',NULL,NULL),(54376,'62812','S','Barren','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(2680,'00968','S','Amelia Ind Park','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(77144,'96161','S','Glenshire','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(13158,'13607','S','Alex Bay','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(35874,'39851','S','Fort Gaines','D','Clay','13061','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.605392,-85.046905,0,'2013-07-06 12:44:32',NULL,NULL),(28608,'31704','U','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.553595,-84.051925,0,'2013-07-06 12:44:32',NULL,NULL),(30546,'33410','S','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(46026,'52551','S','Douds','D','Van Buren','19177','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.803340,-92.046595,0,'2013-07-06 12:44:32',NULL,NULL),(10686,'11211','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.714112,-73.952354,0,'2013-07-06 12:44:30',NULL,NULL),(44883,'50316','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.607822,-93.597425,0,'2013-07-06 12:44:32',NULL,NULL),(31719,'34972','S','Basinger','A','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.325224,-80.849484,0,'2013-07-06 12:44:32',NULL,NULL),(62415,'74132','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.060047,-96.016045,0,'2013-07-06 12:44:33',NULL,NULL),(42118,'47469','S','W Baden Sprgs','A','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(44341,'49769','S','Pellston','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.568594,-84.874650,0,'2013-07-06 12:44:32',NULL,NULL),(38354,'43447','S','Millbury','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.560938,-83.452654,0,'2013-07-06 12:44:32',NULL,NULL),(44397,'49815','S','Channing','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.157367,-88.073571,0,'2013-07-06 12:44:32',NULL,NULL),(76005,'95116','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.352823,-121.849809,0,'2013-07-06 12:44:34',NULL,NULL),(30656,'33462','S','Hypoluxo','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.581130,-80.079020,0,'2013-07-06 12:44:32',NULL,NULL),(27260,'29934','S','Pineland','D','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.581515,-81.191837,0,'2013-07-06 12:44:31',NULL,NULL),(18477,'19087','S','Radnor','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(63260,'75492','S','Windom','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.561572,-96.000259,0,'2013-07-06 12:44:33',NULL,NULL),(73619,'91404','P','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.177503,-118.431940,0,'2013-07-06 12:44:34',NULL,NULL),(65739,'78054','P','Macdona','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.324013,-98.693558,0,'2013-07-06 12:44:34',NULL,NULL),(62659,'74632','S','Braman','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.923410,-97.333871,0,'2013-07-06 12:44:33',NULL,NULL),(28551,'31564','P','Waresboro','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.245104,-82.475290,0,'2013-07-06 12:44:32',NULL,NULL),(45884,'52257','S','Luzerne','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.903335,-92.178335,0,'2013-07-06 12:44:32',NULL,NULL),(45815,'52203','S','West Amana','A','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.804159,-91.867902,0,'2013-07-06 12:44:32',NULL,NULL),(45624,'51601','S','Shenandoah','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.758944,-95.370427,0,'2013-07-06 12:44:32',NULL,NULL),(33737,'37825','S','New Tazewell','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.439083,-83.601957,0,'2013-07-06 12:44:32',NULL,NULL),(53691,'62230','S','Breese','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.608157,-89.527489,0,'2013-07-06 12:44:33',NULL,NULL),(52595,'61015','S','Paynes Point','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.989953,-89.208021,0,'2013-07-06 12:44:33',NULL,NULL),(9223,'09522','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(15362,'16254','S','Shippenville','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.244548,-79.431978,0,'2013-07-06 12:44:31',NULL,NULL),(79575,'99022','S','Espanola','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.618220,-117.713400,0,'2013-07-06 12:44:34',NULL,NULL),(34898,'38954','S','Holly Grove','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.461906,-90.211639,0,'2013-07-06 12:44:32',NULL,NULL),(78269,'97856','S','Ritter','A','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.715891,-119.102716,0,'2013-07-06 12:44:34',NULL,NULL),(71154,'86033','P','Oljato','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.630720,-110.277720,0,'2013-07-06 12:44:34',NULL,NULL),(26274,'29014','S','Cornwell','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.573234,-80.987145,0,'2013-07-06 12:44:31',NULL,NULL),(68197,'81036','S','Eads','D','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.463000,-102.652860,0,'2013-07-06 12:44:34',NULL,NULL),(51398,'59427','S','Del Bonita','N','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.647289,-112.350965,0,'2013-07-06 12:44:33',NULL,NULL),(36621,'40983','S','Sextons Creek','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.294413,-83.795195,0,'2013-07-06 12:44:32',NULL,NULL),(17747,'18323','P','Buck Hill Falls','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.187496,-75.264475,0,'2013-07-06 12:44:31',NULL,NULL),(53994,'62442','S','Neadmore','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.330353,-87.886995,0,'2013-07-06 12:44:33',NULL,NULL),(62874,'75043','S','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.857549,-96.597118,0,'2013-07-06 12:44:33',NULL,NULL),(32915,'36550','S','Little River','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.216909,-87.793024,0,'2013-07-06 12:44:32',NULL,NULL),(59570,'70874','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.443359,-91.186981,0,'2013-07-06 12:44:33',NULL,NULL),(6686,'06042','S','Manchester','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.800800,-72.515900,0,'2013-07-06 12:44:30',NULL,NULL),(49530,'56678','S','Lammers','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.555400,-95.132820,0,'2013-07-06 12:44:33',NULL,NULL),(5960,'05301','S','Green River','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(31008,'33777','S','Largo','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.853863,-82.762036,0,'2013-07-06 12:44:32',NULL,NULL),(17522,'17968','S','Fearnot','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.643889,-76.636667,0,'2013-07-06 12:44:31',NULL,NULL),(37602,'42129','S','Beechville','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(14724,'15281','U','Macys Dept Store','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.440025,-79.998650,0,'2013-07-06 12:44:31',NULL,NULL),(56732,'65708','S','Monett','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.918466,-93.927500,0,'2013-07-06 12:44:33',NULL,NULL),(72445,'89104','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.150316,-115.113965,0,'2013-07-06 12:44:34',NULL,NULL),(71391,'87007','P','Paraje','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.000475,-107.413240,0,'2013-07-06 12:44:34',NULL,NULL),(62063,'73544','S','Gould','D','Harmon','40057','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.669452,-99.782748,0,'2013-07-06 12:44:33',NULL,NULL),(9650,'10037','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(34545,'38720','S','Hillhouse','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.128534,-90.771281,0,'2013-07-06 12:44:32',NULL,NULL),(30781,'33592','S','Thonotosassa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060970,-82.304210,0,'2013-07-06 12:44:32',NULL,NULL),(47100,'54442','S','Irma','D','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.423722,-89.692568,0,'2013-07-06 12:44:32',NULL,NULL),(8803,'08608','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220494,-74.763438,0,'2013-07-06 12:44:30',NULL,NULL),(8448,'08085','S','Woolwich Twp','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(21735,'23023','S','Bruington','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.776737,-76.937881,0,'2013-07-06 12:44:31',NULL,NULL),(51920,'60116','U','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.913702,-88.133828,0,'2013-07-06 12:44:33',NULL,NULL),(62321,'74041','S','Kiefer','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.945888,-96.059791,0,'2013-07-06 12:44:33',NULL,NULL),(38363,'43457','S','Rising Sun','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.272080,-83.435820,0,'2013-07-06 12:44:32',NULL,NULL),(38922,'44121','S','South Euclid','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.520000,-81.556389,0,'2013-07-06 12:44:32',NULL,NULL),(41461,'46912','P','Athens','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.055062,-86.125399,0,'2013-07-06 12:44:32',NULL,NULL),(26207,'28781','S','Aquone','A','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.256543,-83.696128,0,'2013-07-06 12:44:31',NULL,NULL),(53189,'61607','S','Mardell Manor','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(3232,'01373','S','South Deerfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.486240,-72.610200,0,'2013-07-06 12:44:30',NULL,NULL),(64374,'76528','S','Izoro','A','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(75640,'94520','S','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.985575,-122.035167,0,'2013-07-06 12:44:34',NULL,NULL),(26898,'29575','S','Surfside Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.626586,-78.983446,0,'2013-07-06 12:44:31',NULL,NULL),(32224,'35575','S','Lynn','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.054728,-87.529566,0,'2013-07-06 12:44:32',NULL,NULL),(52812,'61281','S','Richland Grove','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.312272,-90.493734,0,'2013-07-06 12:44:33',NULL,NULL),(7563,'07023','S','Fanwood','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.641449,-74.382226,0,'2013-07-06 12:44:30',NULL,NULL),(50971,'58634','S','Grassy Butte','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.450197,-103.343816,0,'2013-07-06 12:44:33',NULL,NULL),(23000,'24801','S','Wolf Pen','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(44420,'49836','S','Blaney Park','N','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.243692,-85.928722,0,'2013-07-06 12:44:32',NULL,NULL),(28342,'31193','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761200,-84.385347,0,'2013-07-06 12:44:32',NULL,NULL),(35383,'39455','S','Pistol Ridge','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(22329,'23860','S','North Prince George','A','Hopewell City','51670','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.286042,-77.289149,0,'2013-07-06 12:44:31',NULL,NULL),(59627,'71037','S','Bodcau','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(62227,'73939','S','Goodwell','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.586421,-101.643317,0,'2013-07-06 12:44:33',NULL,NULL),(514,'00674','S','Urb Atenas','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(77734,'97070','S','Wilsonville','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.301823,-122.762197,0,'2013-07-06 12:44:34',NULL,NULL),(20442,'21005','S','APG','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.455614,-76.150285,0,'2013-07-06 12:44:31',NULL,NULL),(1710,'00778','S','Alts De Hato Nuevo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(49358,'56578','S','Rochert','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.871600,-95.595803,0,'2013-07-06 12:44:33',NULL,NULL),(31998,'35226','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(11682,'12151','S','Ushers','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923520,-73.782900,0,'2013-07-06 12:44:30',NULL,NULL),(29429,'32669','S','Tioga','A','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.647073,-82.599723,0,'2013-07-06 12:44:32',NULL,NULL),(22684,'24315','S','Bland','D','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.142078,-81.013829,0,'2013-07-06 12:44:31',NULL,NULL),(73086,'90220','S','Rncho Domingz','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.890694,-118.239135,0,'2013-07-06 12:44:34',NULL,NULL),(44377,'49793','P','Trout Lake','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.193435,-85.015947,0,'2013-07-06 12:44:32',NULL,NULL),(69014,'83210','S','Sterling','A','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.012500,-112.829220,0,'2013-07-06 12:44:34',NULL,NULL),(49435,'56634','S','Greenwood','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.831879,-95.319135,0,'2013-07-06 12:44:33',NULL,NULL),(1714,'00778','S','Est de Gran Vista','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(43536,'48667','U','Dow Chemical USA','N','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.610465,-84.237362,0,'2013-07-06 12:44:32',NULL,NULL),(15337,'16224','S','Fairmount Cty','A','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.066180,-79.273214,0,'2013-07-06 12:44:31',NULL,NULL),(71627,'87401','S','Farmington','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.741697,-108.191411,0,'2013-07-06 12:44:34',NULL,NULL),(77700,'97045','S','Oregon City','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.340277,-122.560941,0,'2013-07-06 12:44:34',NULL,NULL),(9896,'10129','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755624,-73.990453,0,'2013-07-06 12:44:30',NULL,NULL),(36488,'40806','S','Baxter','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.877560,-83.316720,0,'2013-07-06 12:44:32',NULL,NULL),(31600,'34669','S','Port Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.359750,-82.610876,0,'2013-07-06 12:44:32',NULL,NULL),(2951,'01034','S','Granville Center','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.081960,-72.950580,0,'2013-07-06 12:44:30',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (9326,'09738','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28890,'32127','S','Port Orange','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.110341,-80.980002,0,'2013-07-06 12:44:32',NULL,NULL),(56098,'64780','S','Prairie City','N','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.075520,-94.147320,0,'2013-07-06 12:44:33',NULL,NULL),(68082,'80939','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798565,-104.836169,0,'2013-07-06 12:44:34',NULL,NULL),(59938,'71295','S','Liddieville','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.158360,-91.723430,0,'2013-07-06 12:44:33',NULL,NULL),(74373,'92503','S','Arlington','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.914455,-117.456060,0,'2013-07-06 12:44:34',NULL,NULL),(6173,'05473','S','North Ferrisburgh','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(17372,'17881','S','Trevorton','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.780986,-76.676793,0,'2013-07-06 12:44:31',NULL,NULL),(40178,'45370','S','Sugarcrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.599468,-84.138005,0,'2013-07-06 12:44:32',NULL,NULL),(49134,'56364','S','Pierz','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.978574,-94.097687,0,'2013-07-06 12:44:33',NULL,NULL),(18257,'19003','S','Ardmore','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.993332,-75.305250,0,'2013-07-06 12:44:31',NULL,NULL),(53768,'62269','S','Belleville','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.562834,-89.896654,0,'2013-07-06 12:44:33',NULL,NULL),(49892,'57271','S','Naples','N','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.676806,-97.547404,0,'2013-07-06 12:44:33',NULL,NULL),(20237,'20779','S','Fairhaven','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.770043,-76.577860,0,'2013-07-06 12:44:31',NULL,NULL),(72213,'88424','S','Mount Dora','A','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.737332,-103.457179,0,'2013-07-06 12:44:34',NULL,NULL),(6041,'05408','S','BURL','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446628,-73.175354,0,'2013-07-06 12:44:30',NULL,NULL),(41814,'47334','S','Daleville','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.122017,-85.548158,0,'2013-07-06 12:44:32',NULL,NULL),(48107,'55347','S','Eden Prairie','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.849847,-93.487285,0,'2013-07-06 12:44:33',NULL,NULL),(56279,'65069','S','Bluffton','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757968,-91.534285,0,'2013-07-06 12:44:33',NULL,NULL),(4605,'03589','P','Mt Washington','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.347851,-71.551849,0,'2013-07-06 12:44:30',NULL,NULL),(34652,'38773','S','Steiner','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.595800,-90.822780,0,'2013-07-06 12:44:32',NULL,NULL),(28305,'31126','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.847924,-84.359054,0,'2013-07-06 12:44:31',NULL,NULL),(65879,'78224','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.312010,-98.539722,0,'2013-07-06 12:44:34',NULL,NULL),(20976,'21795','S','Williamsport','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.607324,-77.800793,0,'2013-07-06 12:44:31',NULL,NULL),(2161,'00926','S','Alts de Borinquen Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(75474,'94109','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794508,-122.418244,0,'2013-07-06 12:44:34',NULL,NULL),(75064,'93526','S','Aberdeen','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.832098,-118.233557,0,'2013-07-06 12:44:34',NULL,NULL),(3843,'02344','U','Aetna Life & Casualty Co','N','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.894218,-70.920815,0,'2013-07-06 12:44:30',NULL,NULL),(22582,'24162','S','Allegany Spring','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.140086,-80.324560,0,'2013-07-06 12:44:31',NULL,NULL),(50270,'57644','S','Anderson','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.291739,-102.295248,0,'2013-07-06 12:44:33',NULL,NULL),(10856,'11413','S','Springfield Gardens','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(31439,'34274','P','Nokomis','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.135066,-82.454548,0,'2013-07-06 12:44:32',NULL,NULL),(21957,'23235','S','Richmond','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.502040,-77.569920,0,'2013-07-06 12:44:31',NULL,NULL),(27108,'29727','S','Mount Croghan','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.750050,-80.250547,0,'2013-07-06 12:44:31',NULL,NULL),(73368,'91025','P','Sierra Madre','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.157498,-118.051198,0,'2013-07-06 12:44:34',NULL,NULL),(76736,'95910','S','Alleghany','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.536220,-120.663120,0,'2013-07-06 12:44:34',NULL,NULL),(78739,'98288','P','Grotto','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.703900,-121.304580,0,'2013-07-06 12:44:34',NULL,NULL),(50697,'58356','S','New Rockford','D','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.684884,-99.133524,0,'2013-07-06 12:44:33',NULL,NULL),(19323,'20024','S','Fort Lesley J McNair','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879013,-77.020737,0,'2013-07-06 12:44:31',NULL,NULL),(35034,'39166','S','Silver City','D','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.094647,-90.490461,0,'2013-07-06 12:44:32',NULL,NULL),(37533,'42051','S','Kaler','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(11238,'11756','S','Plainedge','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.726315,-73.517312,0,'2013-07-06 12:44:30',NULL,NULL),(55162,'63366','S','St Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(41844,'47348','S','Shamrock Lakes','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(2217,'00926','S','Urb Cambridge Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(2778,'00976','S','Jard de Trujillo','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(74482,'92610','S','Foothill Rnch','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.681780,-117.631980,0,'2013-07-06 12:44:34',NULL,NULL),(5964,'05301','S','Harrisville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(78059,'97455','S','P Hill','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.970221,-122.916439,0,'2013-07-06 12:44:34',NULL,NULL),(75181,'93608','S','Cantua Creek','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.519483,-120.349022,0,'2013-07-06 12:44:34',NULL,NULL),(74293,'92368','S','Oro Grande','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.659690,-117.295181,0,'2013-07-06 12:44:34',NULL,NULL),(67231,'79929','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.691648,-106.159445,0,'2013-07-06 12:44:34',NULL,NULL),(10256,'10475','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.876918,-73.830136,0,'2013-07-06 12:44:30',NULL,NULL),(49662,'57004','S','Beresford','D','Union','46127','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.084200,-96.780660,0,'2013-07-06 12:44:33',NULL,NULL),(33200,'37043','S','Hickory Point','N','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.492780,-87.233460,0,'2013-07-06 12:44:32',NULL,NULL),(29303,'32520','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.455593,-87.258153,0,'2013-07-06 12:44:32',NULL,NULL),(18518,'19104','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963766,-75.198203,0,'2013-07-06 12:44:31',NULL,NULL),(16154,'17061','S','Rife','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(62036,'73505','S','Lawton','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.616916,-98.457365,0,'2013-07-06 12:44:33',NULL,NULL),(55097,'63303','S','Saint Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.752200,-90.537720,0,'2013-07-06 12:44:33',NULL,NULL),(49349,'56572','S','Cormorant','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.618320,-96.072900,0,'2013-07-06 12:44:33',NULL,NULL),(12475,'12985','S','Schuyler Fls','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.578980,-73.716120,0,'2013-07-06 12:44:30',NULL,NULL),(69038,'83221','S','Riverside','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(73068,'90099','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062936,-118.236227,0,'2013-07-06 12:44:34',NULL,NULL),(79211,'98538','S','Klaber','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.522826,-123.121792,0,'2013-07-06 12:44:34',NULL,NULL),(34674,'38821','S','Hatley','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.999660,-88.451940,0,'2013-07-06 12:44:32',NULL,NULL),(15694,'16844','S','Julian','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.862270,-77.939689,0,'2013-07-06 12:44:31',NULL,NULL),(13046,'13440','S','Bartlett','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(54551,'62889','S','Texico','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.466107,-88.752074,0,'2013-07-06 12:44:33',NULL,NULL),(3694,'02136','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.252810,-71.129122,0,'2013-07-06 12:44:30',NULL,NULL),(10755,'11361','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.764760,-73.777510,0,'2013-07-06 12:44:30',NULL,NULL),(58667,'68883','S','Cameron','N','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.819408,-98.597850,0,'2013-07-06 12:44:33',NULL,NULL),(25875,'28635','S','Hays','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.356569,-81.127080,0,'2013-07-06 12:44:31',NULL,NULL),(41077,'46527','P','Goshen','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.588710,-85.843436,0,'2013-07-06 12:44:32',NULL,NULL),(24694,'27425','P','Amf G Boro','A','Guilford','37081','North Carolina','NC','37','3120','704/980','Eastern',-5.0,'Y',36.127293,-79.942762,0,'2013-07-06 12:44:31',NULL,NULL),(342,'00656','S','Bo Los Sitios','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(48579,'55771','S','Orr','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(68434,'81222','P','Coaldale','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.387714,-105.769656,0,'2013-07-06 12:44:34',NULL,NULL),(64506,'76632','S','North Prairie','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.300172,-97.109830,0,'2013-07-06 12:44:34',NULL,NULL),(77814,'97146','S','Warrenton','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.146308,-123.920156,0,'2013-07-06 12:44:34',NULL,NULL),(67935,'80910','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.816626,-104.777849,0,'2013-07-06 12:44:34',NULL,NULL),(36714,'41019','U','Internal Revenue','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.069636,-84.529815,0,'2013-07-06 12:44:32',NULL,NULL),(12800,'13225','U','Syracuse Amf','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.129510,-76.131355,0,'2013-07-06 12:44:30',NULL,NULL),(33183,'37033','S','Aetna','N','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(47495,'54757','S','New Auburn','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.245040,-91.470240,0,'2013-07-06 12:44:32',NULL,NULL),(11379,'11934','S','CTR Moriches','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.800258,-72.796529,0,'2013-07-06 12:44:30',NULL,NULL),(10037,'10173','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(31467,'34289','S','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.052555,-82.197321,0,'2013-07-06 12:44:32',NULL,NULL),(40928,'46280','S','Nora','A','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.937574,-86.138329,0,'2013-07-06 12:44:32',NULL,NULL),(1754,'00778','S','Villas del Carmen','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(38198,'43209','S','Bexley','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.959129,-82.928990,0,'2013-07-06 12:44:32',NULL,NULL),(12684,'13132','S','Pennellville','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.252751,-76.232419,0,'2013-07-06 12:44:30',NULL,NULL),(68883,'82710','S','Aladdin','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.823233,-104.206686,0,'2013-07-06 12:44:34',NULL,NULL),(48048,'55313','S','Buffalo','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.175240,-93.873386,0,'2013-07-06 12:44:33',NULL,NULL),(47180,'54481','S','Jordan','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(9217,'09509','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(73591,'91386','P','Canyon Country','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.417490,-118.449656,0,'2013-07-06 12:44:34',NULL,NULL),(38804,'44067','S','Northfield Village','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(11,'00602','S','Bo Guaniquilla','N','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(54195,'62631','S','Concord','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.827443,-90.370445,0,'2013-07-06 12:44:33',NULL,NULL),(8180,'07879','P','Tranquility','D','Sussex','34037','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.957129,-74.807196,0,'2013-07-06 12:44:30',NULL,NULL),(932,'00714','S','Urb San Antonio','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(66133,'78463','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.774768,-97.396997,0,'2013-07-06 12:44:34',NULL,NULL),(47599,'54871','S','Shell Lake','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.760737,-92.105442,0,'2013-07-06 12:44:33',NULL,NULL),(79102,'98447','U','Pacific Lutheran University','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.147030,-122.445643,0,'2013-07-06 12:44:34',NULL,NULL),(12861,'13321','P','Clark Mills','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.091712,-75.378449,0,'2013-07-06 12:44:30',NULL,NULL),(16191,'17069','P','New Buffalo','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.456714,-76.971080,0,'2013-07-06 12:44:31',NULL,NULL),(54125,'62556','S','Clarksdale','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.479520,-89.432400,0,'2013-07-06 12:44:33',NULL,NULL),(6793,'06107','S','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756512,-72.758753,0,'2013-07-06 12:44:30',NULL,NULL),(3898,'02447','P','Brookline Vlg','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.333546,-71.118745,0,'2013-07-06 12:44:30',NULL,NULL),(13451,'13778','S','Genegantslet','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(74323,'92397','S','Wrightwood','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.368657,-117.609670,0,'2013-07-06 12:44:34',NULL,NULL),(80006,'99672','S','Sterling','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.526150,-150.830093,0,'2013-07-06 12:44:34',NULL,NULL),(77993,'97403','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.037363,-123.052143,0,'2013-07-06 12:44:34',NULL,NULL),(56601,'65560','S','Salem','D','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(13230,'13637','S','Pamelia','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.090947,-75.804665,0,'2013-07-06 12:44:30',NULL,NULL),(11803,'12228','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.645681,-73.756663,0,'2013-07-06 12:44:30',NULL,NULL),(19516,'20177','P','Leesburg','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.106936,-77.565274,0,'2013-07-06 12:44:31',NULL,NULL),(1319,'00735','S','Res La Ceiba','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(30686,'33473','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.517012,-80.179715,0,'2013-07-06 12:44:32',NULL,NULL),(22525,'24093','S','Glen Lyn','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.373459,-80.867770,0,'2013-07-06 12:44:31',NULL,NULL),(22038,'23298','S','VCU/MCV East','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.540976,-77.425624,0,'2013-07-06 12:44:31',NULL,NULL),(19792,'20433','U','World Bank','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906462,-77.044928,0,'2013-07-06 12:44:31',NULL,NULL),(51027,'58716','S','Benedict','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.759459,-101.035659,0,'2013-07-06 12:44:33',NULL,NULL),(1831,'00784','S','Urb El Legado Golf Resort','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(13362,'13732','S','Apalachin','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.057017,-76.137903,0,'2013-07-06 12:44:31',NULL,NULL),(37578,'42086','S','Camelia','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.087107,-88.767014,0,'2013-07-06 12:44:32',NULL,NULL),(67864,'80827','S','Tarryall','N','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.063720,-105.486840,0,'2013-07-06 12:44:34',NULL,NULL),(64318,'76481','S','Eliasville','A','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',32.960083,-98.760290,0,'2013-07-06 12:44:34',NULL,NULL),(64262,'76384','S','Vernon','D','Wilbarger','48487','Texas','TX','48','0000','940','Central',-6.0,'Y',34.148130,-99.295162,0,'2013-07-06 12:44:34',NULL,NULL),(17164,'17814','S','Derrs','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(32048,'35254','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513945,-86.853654,0,'2013-07-06 12:44:32',NULL,NULL),(54085,'62522','S','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.845988,-88.993212,0,'2013-07-06 12:44:33',NULL,NULL),(41786,'47308','P','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.130320,-85.379246,0,'2013-07-06 12:44:32',NULL,NULL),(11429,'11967','S','Smith Point','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.795028,-72.869264,0,'2013-07-06 12:44:30',NULL,NULL),(23035,'24851','P','Justice','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.586477,-81.838907,0,'2013-07-06 12:44:31',NULL,NULL),(72261,'88539','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.813086,-106.414291,0,'2013-07-06 12:44:34',NULL,NULL),(74035,'92137','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.886200,-117.101607,0,'2013-07-06 12:44:34',NULL,NULL),(76426,'95571','P','Weott','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.324624,-123.920032,0,'2013-07-06 12:44:34',NULL,NULL),(28331,'31150','P','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.982371,-84.333684,0,'2013-07-06 12:44:32',NULL,NULL),(35587,'39573','S','Sellers','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(2688,'00968','S','Urb Golden Gate','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(49115,'56352','S','Spring Hill','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.652875,-94.805558,0,'2013-07-06 12:44:33',NULL,NULL),(30892,'33703','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.819613,-82.622849,0,'2013-07-06 12:44:32',NULL,NULL),(10464,'10930','S','Highland Mls','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.353753,-74.130068,0,'2013-07-06 12:44:30',NULL,NULL),(1610,'00769','S','Urb San Antonio','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(5134,'04413','S','Forest Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.579310,-67.727269,0,'2013-07-06 12:44:30',NULL,NULL),(30155,'33169','S','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.935490,-80.214010,0,'2013-07-06 12:44:32',NULL,NULL),(79174,'98520','S','Bench Drive','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(44792,'50225','S','Pleasantville','D','Marion','19125','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.388347,-93.271889,0,'2013-07-06 12:44:32',NULL,NULL),(56262,'65062','S','Mt Sterling','A','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.531941,-91.612913,0,'2013-07-06 12:44:33',NULL,NULL),(50955,'58622','S','Belfield','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.884720,-103.180800,0,'2013-07-06 12:44:33',NULL,NULL),(8102,'07801','S','Dover','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.943413,-74.523388,0,'2013-07-06 12:44:30',NULL,NULL),(11977,'12468','S','Prattsville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.259620,-74.360700,0,'2013-07-06 12:44:30',NULL,NULL),(36199,'40266','U','Rr Donnelly','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.226101,-85.742616,0,'2013-07-06 12:44:32',NULL,NULL),(33537,'37385','S','Tellico Plns','A','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.338706,-84.234031,0,'2013-07-06 12:44:32',NULL,NULL),(78227,'97801','S','Pendleton','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.666259,-118.793800,0,'2013-07-06 12:44:34',NULL,NULL),(68969,'83025','P','Teton Village','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.588020,-110.827200,0,'2013-07-06 12:44:34',NULL,NULL),(34563,'38731','S','Chatham','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.087531,-91.084410,0,'2013-07-06 12:44:32',NULL,NULL),(53454,'61911','S','Chesterville','N','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.703333,-88.391111,0,'2013-07-06 12:44:33',NULL,NULL),(18216,'18956','P','Rushland','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.261618,-75.027246,0,'2013-07-06 12:44:31',NULL,NULL),(55501,'63775','S','Lithium','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(53884,'62353','S','Cooperstown','N','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985995,-90.767312,0,'2013-07-06 12:44:33',NULL,NULL),(5153,'04420','U','Castine','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.394667,-68.789459,0,'2013-07-06 12:44:30',NULL,NULL),(57716,'67355','S','Niotaze','D','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.012687,-95.924207,0,'2013-07-06 12:44:33',NULL,NULL),(64434,'76561','S','Oglesby','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.453052,-97.567079,0,'2013-07-06 12:44:34',NULL,NULL),(51600,'59823','S','Potomac','A','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.877569,-113.629257,0,'2013-07-06 12:44:33',NULL,NULL),(25762,'28584','S','Swansboro','D','Onslow','37133','North Carolina','NC','37','3605','252','Eastern',-5.0,'Y',34.701094,-77.065759,0,'2013-07-06 12:44:31',NULL,NULL),(11881,'12307','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.802385,-73.936570,0,'2013-07-06 12:44:30',NULL,NULL),(34839,'38921','S','Effie','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.980940,-90.107520,0,'2013-07-06 12:44:32',NULL,NULL),(20962,'21783','S','Smithsburg','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.610146,-77.526160,0,'2013-07-06 12:44:31',NULL,NULL),(33736,'37824','P','New Tazewell','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.434143,-83.606620,0,'2013-07-06 12:44:32',NULL,NULL),(19483,'20148','S','Broadlands','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.994011,-77.531312,0,'2013-07-06 12:44:31',NULL,NULL),(10072,'10185','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(25324,'28201','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.192962,-80.826311,0,'2013-07-06 12:44:31',NULL,NULL),(56598,'65560','S','Doss','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(41434,'46857','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.072906,-85.166520,0,'2013-07-06 12:44:32',NULL,NULL),(30549,'33411','S','Royal Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(30070,'33154','S','Bay Harbor Is','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(34650,'38773','S','Litton','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.595800,-90.822780,0,'2013-07-06 12:44:32',NULL,NULL),(28008,'30609','U','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.936780,-83.431570,0,'2013-07-06 12:44:31',NULL,NULL),(75719,'94585','S','Birds Lndg','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.246160,-122.022060,0,'2013-07-06 12:44:34',NULL,NULL),(57091,'66217','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(48043,'55311','S','Corcoran','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.118800,-93.486660,0,'2013-07-06 12:44:33',NULL,NULL),(2841,'00983','S','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(56637,'65609','S','Bakersfield','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.537074,-92.157175,0,'2013-07-06 12:44:33',NULL,NULL),(16652,'17347','S','Mount Wolf','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.054598,-76.690743,0,'2013-07-06 12:44:31',NULL,NULL),(6833,'06117','S','W Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(10092,'10212','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713127,-74.010130,0,'2013-07-06 12:44:30',NULL,NULL),(62576,'74462','S','Enterprise','N','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.265840,-95.115060,0,'2013-07-06 12:44:33',NULL,NULL),(67619,'80438','P','Empire','D','Clear Creek','08019','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.766658,-105.711160,0,'2013-07-06 12:44:34',NULL,NULL),(38553,'43757','P','Malaga','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.856227,-81.146767,0,'2013-07-06 12:44:32',NULL,NULL),(37730,'42285','S','Kyrock','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.262476,-86.279063,0,'2013-07-06 12:44:32',NULL,NULL),(21365,'22446','P','Corbin','D','Caroline','51033','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.197773,-77.390523,0,'2013-07-06 12:44:31',NULL,NULL),(39302,'44507','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.073822,-80.656567,0,'2013-07-06 12:44:32',NULL,NULL),(47271,'54532','P','Tomahawk','A','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.547200,-89.715180,0,'2013-07-06 12:44:32',NULL,NULL),(15659,'16749','S','Smethport','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.807779,-78.449022,0,'2013-07-06 12:44:31',NULL,NULL),(32820,'36457','P','Megargel','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.394375,-87.419431,0,'2013-07-06 12:44:32',NULL,NULL),(17984,'18621','S','Hunlock Creek','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.226559,-76.014039,0,'2013-07-06 12:44:31',NULL,NULL),(45907,'52318','S','Norway','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.904347,-91.918391,0,'2013-07-06 12:44:32',NULL,NULL),(49276,'56510','S','Ada','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.298022,-96.510903,0,'2013-07-06 12:44:33',NULL,NULL),(10364,'10583','S','Edgemont','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.989799,-73.800070,0,'2013-07-06 12:44:30',NULL,NULL),(32986,'36616','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.667396,-88.127812,0,'2013-07-06 12:44:32',NULL,NULL),(57454,'66850','S','Elmdale','D','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.380293,-96.713873,0,'2013-07-06 12:44:33',NULL,NULL),(5735,'05034','S','Brgwtr','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.572856,-72.617134,0,'2013-07-06 12:44:30',NULL,NULL),(20634,'21219','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.250556,-76.520833,0,'2013-07-06 12:44:31',NULL,NULL),(30190,'33178','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.856770,-80.415990,0,'2013-07-06 12:44:32',NULL,NULL),(35437,'39476','S','Rhodes','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(5915,'05250','S','Sandgate','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(19095,'19605','S','Bernharts','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(51305,'59230','S','Saint Marie','A','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.198389,-106.625201,0,'2013-07-06 12:44:33',NULL,NULL),(29624,'32877','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.544639,-81.376096,0,'2013-07-06 12:44:32',NULL,NULL),(53621,'62089','P','Taylor Springs','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.130995,-89.494582,0,'2013-07-06 12:44:33',NULL,NULL),(46457,'53213','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.049511,-88.005322,0,'2013-07-06 12:44:32',NULL,NULL),(6909,'06152','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757059,-72.688643,0,'2013-07-06 12:44:30',NULL,NULL),(54265,'62677','S','Salisbury','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.875106,-89.916317,0,'2013-07-06 12:44:33',NULL,NULL),(56913,'66051','P','Olathe','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.880565,-94.817500,0,'2013-07-06 12:44:33',NULL,NULL),(23999,'26346','S','Highland','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.288720,-81.058680,0,'2013-07-06 12:44:31',NULL,NULL),(46200,'52753','S','LeClaire','A','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.606862,-90.370939,0,'2013-07-06 12:44:32',NULL,NULL),(20528,'21094','P','Lutherville','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.421320,-76.623102,0,'2013-07-06 12:44:31',NULL,NULL),(52451,'60670','U','Jp Morgan Chase','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.886480,-87.622247,0,'2013-07-06 12:44:33',NULL,NULL),(32283,'35654','S','Russellville','D','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.507855,-87.727793,0,'2013-07-06 12:44:32',NULL,NULL),(52286,'60531','S','Leland','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.601884,-88.780679,0,'2013-07-06 12:44:33',NULL,NULL),(4837,'04006','P','Biddeford Pl','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.492500,-70.453889,0,'2013-07-06 12:44:30',NULL,NULL),(34544,'38720','S','Alligator','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.128534,-90.771281,0,'2013-07-06 12:44:32',NULL,NULL),(50794,'58443','S','Glenfield','D','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448180,-98.680680,0,'2013-07-06 12:44:33',NULL,NULL),(66754,'79010','P','Prayer Town','N','Oldham','48359','Texas','TX','48','0320','806','Central',-6.0,'Y',35.433035,-102.442266,0,'2013-07-06 12:44:34',NULL,NULL),(62632,'74557','S','Moyers','D','Pushmataha','40127','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.352740,-95.672687,0,'2013-07-06 12:44:33',NULL,NULL),(58602,'68852','S','Elm','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.199056,-99.120955,0,'2013-07-06 12:44:33',NULL,NULL),(12332,'12870','S','Blue Ridge','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.839600,-73.760220,0,'2013-07-06 12:44:30',NULL,NULL),(25876,'28636','S','Hiddenite','D','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.997778,-81.105556,0,'2013-07-06 12:44:31',NULL,NULL),(47378,'54628','S','Ferryville','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.381985,-91.003560,0,'2013-07-06 12:44:32',NULL,NULL),(34037,'38134','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.191860,-89.925360,0,'2013-07-06 12:44:32',NULL,NULL),(37240,'41553','S','Coleman','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492791,-82.167535,0,'2013-07-06 12:44:32',NULL,NULL),(395,'00662','S','Comunidad Mantilla','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(36884,'41101','S','Ironville','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(76041,'95158','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.259318,-121.876807,0,'2013-07-06 12:44:34',NULL,NULL),(35963,'40069','S','Springfield','D','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.713360,-85.201800,0,'2013-07-06 12:44:32',NULL,NULL),(11870,'12303','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.783122,-73.938595,0,'2013-07-06 12:44:30',NULL,NULL),(48507,'55738','S','Zim','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.271048,-92.618597,0,'2013-07-06 12:44:33',NULL,NULL),(5238,'04471','S','Cary Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.890612,-67.847255,0,'2013-07-06 12:44:30',NULL,NULL),(5548,'04848','S','Islesboro','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.304690,-68.922340,0,'2013-07-06 12:44:30',NULL,NULL),(33348,'37178','S','Tennessee Rdg','A','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.313167,-87.764653,0,'2013-07-06 12:44:32',NULL,NULL),(5494,'04751','U','Limestone','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.908611,-67.826389,0,'2013-07-06 12:44:30',NULL,NULL),(24504,'27265','S','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.011602,-80.001458,0,'2013-07-06 12:44:31',NULL,NULL),(15635,'16726','S','Ormsby','A','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.821800,-78.561120,0,'2013-07-06 12:44:31',NULL,NULL),(21727,'23005','S','Ashland','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.747553,-77.471865,0,'2013-07-06 12:44:31',NULL,NULL),(75054,'93522','P','Darwin','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',35.627473,-117.670413,0,'2013-07-06 12:44:34',NULL,NULL),(56525,'65360','S','Windsor','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.529467,-93.525003,0,'2013-07-06 12:44:33',NULL,NULL),(11700,'12161','P','South Bethlehem','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535245,-73.893390,0,'2013-07-06 12:44:30',NULL,NULL),(22468,'24042','U','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.275867,-79.941592,0,'2013-07-06 12:44:31',NULL,NULL),(9098,'09068','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5058,'04275','S','Roxbury','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.688667,-70.639514,0,'2013-07-06 12:44:30',NULL,NULL),(24587,'27320','S','Harrison Cross Roads','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(46573,'53526','S','Cobb','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.963001,-90.333272,0,'2013-07-06 12:44:32',NULL,NULL),(14562,'15214','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.481784,-80.018549,0,'2013-07-06 12:44:31',NULL,NULL),(71721,'87532','S','El Llano','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(2027,'00917','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(2375,'00949','S','Urb Almira','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(55102,'63304','S','St Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(26066,'28694','S','Index','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(53731,'62247','P','Hagarstown','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.943774,-89.171561,0,'2013-07-06 12:44:33',NULL,NULL),(49999,'57373','S','St Lawrence','A','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.531049,-98.806533,0,'2013-07-06 12:44:33',NULL,NULL),(47157,'54467','S','Coddington','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.439810,-89.544706,0,'2013-07-06 12:44:32',NULL,NULL),(3198,'01349','S','Millers Falls','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.578720,-72.492140,0,'2013-07-06 12:44:30',NULL,NULL),(1083,'00725','S','Urb Borinquen Valley','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(13591,'13850','S','South Vestal','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(40289,'45440','S','Beavercreek Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(19404,'20076','U','Geico','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(31547,'34605','P','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.496964,-82.452561,0,'2013-07-06 12:44:32',NULL,NULL),(16132,'17058','S','Doyles Mills','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.565928,-77.406815,0,'2013-07-06 12:44:31',NULL,NULL),(49799,'57186','U','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.549300,-96.726635,0,'2013-07-06 12:44:33',NULL,NULL),(75558,'94254','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585080,-121.491972,0,'2013-07-06 12:44:34',NULL,NULL),(211,'00624','S','Alts de Penuelas','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(69571,'83826','P','Eastport','D','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.991329,-116.179173,0,'2013-07-06 12:44:34',NULL,NULL),(35862,'39828','S','Karo','N','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.874451,-84.209360,0,'2013-07-06 12:44:32',NULL,NULL),(24790,'27582','P','Stovall','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.448628,-78.569712,0,'2013-07-06 12:44:31',NULL,NULL),(19862,'20523','U','Dept Of State Intrntl Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896710,-77.047010,0,'2013-07-06 12:44:31',NULL,NULL),(46120,'52639','S','Montrose','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.528312,-91.412979,0,'2013-07-06 12:44:32',NULL,NULL),(17330,'17864','S','Independence','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(11786,'12211','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.707382,-73.772002,0,'2013-07-06 12:44:30',NULL,NULL),(1268,'00730','S','Bda Tamarindo','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(76284,'95427','S','Comptche','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.261694,-123.582922,0,'2013-07-06 12:44:34',NULL,NULL),(42843,'48072','S','Berkley','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.502236,-83.185811,0,'2013-07-06 12:44:32',NULL,NULL),(7109,'06372','P','Old Mystic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.390591,-71.962876,0,'2013-07-06 12:44:30',NULL,NULL),(37554,'42064','S','Sheridan','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(37419,'41812','S','Deane','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.235392,-82.797841,0,'2013-07-06 12:44:32',NULL,NULL),(8200,'07931','S','Far Hills','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.701710,-74.641610,0,'2013-07-06 12:44:30',NULL,NULL),(762,'00692','S','Urb Grand Palm Ii','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(60025,'71342','S','Jena','D','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(9832,'10115','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(48661,'55912','S','Austin','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667498,-92.979475,0,'2013-07-06 12:44:33',NULL,NULL),(28334,'31156','P','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.959963,-84.364913,0,'2013-07-06 12:44:32',NULL,NULL),(72994,'90058','S','Vernon','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.002300,-118.211520,0,'2013-07-06 12:44:34',NULL,NULL),(72600,'89410','S','Sheridan','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(61801,'73095','S','Wayne','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.918055,-97.314530,0,'2013-07-06 12:44:33',NULL,NULL),(62477,'74345','P','Grove','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.595226,-94.787452,0,'2013-07-06 12:44:33',NULL,NULL),(73203,'90603','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.944907,-117.989049,0,'2013-07-06 12:44:34',NULL,NULL),(71642,'87419','S','Navajo Dam','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.905279,-107.648499,0,'2013-07-06 12:44:34',NULL,NULL),(26486,'29164','S','Bethcar','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(13617,'13864','S','Willseyville','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.276942,-76.378237,0,'2013-07-06 12:44:31',NULL,NULL),(1474,'00745','S','Urb Rio Grande Est','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(855,'00698','S','Sect Las Pelas','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(4670,'03779','S','Piermont','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.976039,-72.093186,0,'2013-07-06 12:44:30',NULL,NULL),(47063,'54423','S','Custer','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.582844,-89.419872,0,'2013-07-06 12:44:32',NULL,NULL),(8197,'07928','S','Chatham','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.733044,-74.403459,0,'2013-07-06 12:44:30',NULL,NULL),(17364,'17872','S','Sunnyside','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(4623,'03602','S','Alstead Center','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.154442,-72.304628,0,'2013-07-06 12:44:30',NULL,NULL),(66631,'78827','S','Asherton','D','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.455861,-99.759092,0,'2013-07-06 12:44:34',NULL,NULL),(56827,'65790','S','Pottersville','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.702688,-92.046284,0,'2013-07-06 12:44:33',NULL,NULL),(44893,'50320','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.541390,-93.582000,0,'2013-07-06 12:44:32',NULL,NULL),(40971,'46324','S','Hammond','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.585919,-87.502396,0,'2013-07-06 12:44:32',NULL,NULL),(39834,'45157','S','Mount Pisgah','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.955180,-84.219600,0,'2013-07-06 12:44:32',NULL,NULL),(60844,'72041','S','Devalls Bluff','A','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.715356,-91.542833,0,'2013-07-06 12:44:33',NULL,NULL),(9893,'10128','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(59431,'70668','S','Vinton','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.190438,-93.581492,0,'2013-07-06 12:44:33',NULL,NULL),(59978,'71325','S','Clearwater','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.018235,-92.292222,0,'2013-07-06 12:44:33',NULL,NULL),(52446,'60668','U','Commonwealth Edison','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881773,-87.626480,0,'2013-07-06 12:44:33',NULL,NULL),(75946,'95037','S','Morgan Hill','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.123009,-121.648882,0,'2013-07-06 12:44:34',NULL,NULL),(68399,'81152','S','San Pedro','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(66459,'78654','S','Highland Haven','A','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(57873,'67584','S','Arnold','N','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.643687,-100.174726,0,'2013-07-06 12:44:33',NULL,NULL),(26361,'29070','S','Summit','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(16645,'17342','P','Loganville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.852555,-76.707028,0,'2013-07-06 12:44:31',NULL,NULL),(40568,'45864','P','Miller Cty','N','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.105717,-84.130775,0,'2013-07-06 12:44:32',NULL,NULL),(53058,'61490','S','Woodhull','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.178623,-90.315302,0,'2013-07-06 12:44:33',NULL,NULL),(12515,'13027','S','Van Buren','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(74589,'92697','U','Uc Irvine','N','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648513,-117.838683,0,'2013-07-06 12:44:34',NULL,NULL),(63766,'75946','S','Garrison','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.799280,-94.485300,0,'2013-07-06 12:44:34',NULL,NULL),(60832,'72039','S','Damascus','D','Van Buren','05141','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.298334,-92.439056,0,'2013-07-06 12:44:33',NULL,NULL),(57780,'67467','S','Wells','A','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.125123,-97.703693,0,'2013-07-06 12:44:33',NULL,NULL),(54909,'63080','S','Sullivan','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(52535,'60927','S','Clifton','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.932602,-87.935467,0,'2013-07-06 12:44:33',NULL,NULL),(23795,'26030','P','Beech Bottom','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.223857,-80.654086,0,'2013-07-06 12:44:31',NULL,NULL),(2576,'00959','S','Villas de Caparra','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(44374,'49788','S','Sault Sainte Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.495278,-84.345278,0,'2013-07-06 12:44:32',NULL,NULL),(43823,'49083','S','Richland','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.376617,-85.447312,0,'2013-07-06 12:44:32',NULL,NULL),(24124,'26547','S','Reedsville','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.514756,-79.813748,0,'2013-07-06 12:44:31',NULL,NULL),(75779,'94666','U','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.809816,-122.265531,0,'2013-07-06 12:44:34',NULL,NULL),(71535,'87144','S','Rio Rancho','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.251144,-106.676305,0,'2013-07-06 12:44:34',NULL,NULL),(69703,'84032','S','Heber City','D','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(59354,'70569','P','Lydia','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.926025,-91.782561,0,'2013-07-06 12:44:33',NULL,NULL),(12999,'13411','S','New Berlin','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(13455,'13778','S','Smithville Center','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(4540,'03445','S','Sullivan','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.995925,-72.191513,0,'2013-07-06 12:44:30',NULL,NULL),(8068,'07750','S','Monmouth Bch','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.332243,-73.999422,0,'2013-07-06 12:44:30',NULL,NULL),(31544,'34604','S','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.555000,-82.388056,0,'2013-07-06 12:44:32',NULL,NULL),(42386,'47724','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.000309,-87.571626,0,'2013-07-06 12:44:32',NULL,NULL),(36341,'40404','U','Berea College','N','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.568461,-84.292823,0,'2013-07-06 12:44:32',NULL,NULL),(34669,'38804','S','Tupelo','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.286982,-88.683036,0,'2013-07-06 12:44:32',NULL,NULL),(34446,'38652','S','Keownville','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(10887,'11422','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.663176,-73.733191,0,'2013-07-06 12:44:30',NULL,NULL),(22746,'24411','P','Augusta Spgs','N','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.104025,-79.318835,0,'2013-07-06 12:44:31',NULL,NULL),(11882,'12307','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.802385,-73.936570,0,'2013-07-06 12:44:30',NULL,NULL),(5643,'04950','S','Madison','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.797501,-69.878154,0,'2013-07-06 12:44:30',NULL,NULL),(1258,'00729','S','Urb River Valley Pk','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(73774,'91739','S','Rch Cucamonga','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.124307,-117.519639,0,'2013-07-06 12:44:34',NULL,NULL),(60799,'72030','S','Cleveland','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.366302,-92.705971,0,'2013-07-06 12:44:33',NULL,NULL),(58441,'68711','S','Amelia','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.215260,-98.842910,0,'2013-07-06 12:44:33',NULL,NULL),(21326,'22407','S','Fredericksbur','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(35806,'39759','S','Clayton Village','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(56194,'65017','S','Brumley','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.088152,-92.530146,0,'2013-07-06 12:44:33',NULL,NULL),(31397,'34224','S','Englewood','D','Charlotte','12015','Florida','FL','12','7510','941','Eastern',-5.0,'Y',26.925390,-82.302641,0,'2013-07-06 12:44:32',NULL,NULL),(55630,'64002','U','Homeland Nbc','N','Jackson','29095','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.104258,-93.546629,0,'2013-07-06 12:44:33',NULL,NULL),(411,'00662','S','Repto Capella','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(65176,'77415','P','Cedar Lane','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.945698,-95.735313,0,'2013-07-06 12:44:34',NULL,NULL),(5170,'04429','S','East Holden','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.761927,-68.642786,0,'2013-07-06 12:44:30',NULL,NULL),(36279,'40346','S','Means','D','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.913900,-83.714363,0,'2013-07-06 12:44:32',NULL,NULL),(43252,'48322','S','West Bloomfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.545288,-83.382354,0,'2013-07-06 12:44:32',NULL,NULL),(47012,'54304','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.503211,-88.067350,0,'2013-07-06 12:44:32',NULL,NULL),(20765,'21504','P','Cumberland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.660766,-78.743170,0,'2013-07-06 12:44:31',NULL,NULL),(24196,'26675','P','Kesler Cr Lns','A','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.234705,-80.936228,0,'2013-07-06 12:44:31',NULL,NULL),(7930,'07648','S','Norwood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.994884,-73.956089,0,'2013-07-06 12:44:30',NULL,NULL),(56523,'65355','S','Whitakerville','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(20212,'20764','S','Shady Side','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.838222,-76.512559,0,'2013-07-06 12:44:31',NULL,NULL),(13551,'13832','S','Beaver Meadow','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.631654,-75.620930,0,'2013-07-06 12:44:31',NULL,NULL),(50749,'58402','P','Jamestown','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.905091,-98.732378,0,'2013-07-06 12:44:33',NULL,NULL),(34815,'38901','S','Grenada','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(41724,'47244','S','Hartsville','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.268162,-85.697809,0,'2013-07-06 12:44:32',NULL,NULL),(68904,'82731','S','Weston','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.756810,-105.296341,0,'2013-07-06 12:44:34',NULL,NULL),(71503,'87110','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.107533,-106.576209,0,'2013-07-06 12:44:34',NULL,NULL),(68859,'82633','S','Bill','N','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.652560,-105.189910,0,'2013-07-06 12:44:34',NULL,NULL),(35434,'39476','S','Good Hope','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(14409,'15065','S','Natrona Heights','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.637760,-79.720740,0,'2013-07-06 12:44:31',NULL,NULL),(47398,'54642','S','Melrose','D','Jackson','55053','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.135999,-90.993372,0,'2013-07-06 12:44:32',NULL,NULL),(9074,'09008','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(59635,'71038','S','Dykesville','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(64083,'76148','S','North Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(48131,'55359','S','Orono','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.997812,-93.687245,0,'2013-07-06 12:44:33',NULL,NULL),(67350,'80110','S','Cherry Hl Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(31177,'33921','P','Boca Grande','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.758763,-82.265044,0,'2013-07-06 12:44:32',NULL,NULL),(29671,'32912','P','West Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.078258,-80.603624,0,'2013-07-06 12:44:32',NULL,NULL),(9103,'09086','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(27542,'30236','S','Jonesboro','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.511823,-84.316803,0,'2013-07-06 12:44:31',NULL,NULL),(20236,'20778','S','West River','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.834032,-76.563786,0,'2013-07-06 12:44:31',NULL,NULL),(31239,'33973','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.610303,-81.691774,0,'2013-07-06 12:44:32',NULL,NULL),(9965,'10159','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(55048,'63144','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616418,-90.349634,0,'2013-07-06 12:44:33',NULL,NULL),(2209,'00926','S','Sect Hoyo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(14182,'14747','S','Kennedy','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.155243,-79.101242,0,'2013-07-06 12:44:31',NULL,NULL),(17788,'18352','S','Reeders','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.989696,-75.275006,0,'2013-07-06 12:44:31',NULL,NULL),(13923,'14418','S','Branchport','D','Yates','36123','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.613768,-77.211323,0,'2013-07-06 12:44:31',NULL,NULL),(28326,'31146','P','Dunwoody','A','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.925442,-84.341206,0,'2013-07-06 12:44:31',NULL,NULL),(1949,'00802','S','St Thomas','D','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.348771,-64.935409,0,'2013-07-06 12:44:30',NULL,NULL),(43669,'48859','U','Mount Pleasant','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.597602,-84.778009,0,'2013-07-06 12:44:32',NULL,NULL),(37861,'42519','S','Burnside','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.970557,-84.572994,0,'2013-07-06 12:44:32',NULL,NULL),(24799,'27592','S','Kennebec','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.568335,-78.706810,0,'2013-07-06 12:44:31',NULL,NULL),(4666,'03774','S','N Haverhill','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.084308,-72.025912,0,'2013-07-06 12:44:30',NULL,NULL),(29347,'32560','P','Gonzalez','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.582196,-87.291619,0,'2013-07-06 12:44:32',NULL,NULL),(17292,'17851','S','Atlas','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(74538,'92659','P','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.622189,-117.923518,0,'2013-07-06 12:44:34',NULL,NULL),(23463,'25432','S','Millville','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.296459,-77.785255,0,'2013-07-06 12:44:31',NULL,NULL),(36886,'41101','S','Millseat','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(52983,'61435','S','Gerlaw','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.000364,-90.613540,0,'2013-07-06 12:44:33',NULL,NULL),(2280,'00926','S','Urb Venus Gdns Norte','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(11643,'12125','S','Lebanon Spg','A','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.483586,-73.377729,0,'2013-07-06 12:44:30',NULL,NULL),(32622,'36142','U','Colonial Mortgage','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.381048,-86.310445,0,'2013-07-06 12:44:32',NULL,NULL),(28858,'32105','P','Barberville','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.188945,-81.418844,0,'2013-07-06 12:44:32',NULL,NULL),(9125,'09143','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8112,'07821','S','Byram Township','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.967267,-74.766575,0,'2013-07-06 12:44:30',NULL,NULL),(60294,'71454','S','Hargis','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(69515,'83720','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.613494,-116.216151,0,'2013-07-06 12:44:34',NULL,NULL),(76838,'95962','S','Oregon House','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.355889,-121.262044,0,'2013-07-06 12:44:34',NULL,NULL),(51789,'60045','S','Mettawa','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.233956,-87.863856,0,'2013-07-06 12:44:33',NULL,NULL),(63093,'75261','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.873864,-96.965862,0,'2013-07-06 12:44:33',NULL,NULL),(36183,'40252','P','Lyndon','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.261193,-85.604564,0,'2013-07-06 12:44:32',NULL,NULL),(8467,'08088','S','Tabernacle Twp','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(46526,'53290','U','WE Energies','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036612,-87.912064,0,'2013-07-06 12:44:32',NULL,NULL),(2863,'00985','S','Est de San Fernando','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(22604,'24209','P','Bristol','D','Bristol City','51520','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.612406,-82.168621,0,'2013-07-06 12:44:31',NULL,NULL),(9344,'09780','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(49966,'57350','S','Lake Byron','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.359540,-98.217645,0,'2013-07-06 12:44:33',NULL,NULL),(31819,'35061','S','Dolomite','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463579,-86.958874,0,'2013-07-06 12:44:32',NULL,NULL),(63926,'76058','S','Joshua','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.465650,-97.396046,0,'2013-07-06 12:44:34',NULL,NULL),(62883,'75051','S','Grand Prairie','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.715451,-96.996819,0,'2013-07-06 12:44:33',NULL,NULL),(46137,'52652','P','Swedesburg','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.119162,-91.540226,0,'2013-07-06 12:44:32',NULL,NULL),(58895,'69170','S','Wellfleet','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.796412,-100.729124,0,'2013-07-06 12:44:33',NULL,NULL),(58305,'68430','S','Saltillo','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.674181,-96.664510,0,'2013-07-06 12:44:33',NULL,NULL),(12793,'13220','P','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.125489,-76.129731,0,'2013-07-06 12:44:30',NULL,NULL),(52825,'61301','S','Rockwell','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.355630,-89.094865,0,'2013-07-06 12:44:33',NULL,NULL),(50278,'57648','S','Pollock','D','Campbell','46021','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.862843,-100.320882,0,'2013-07-06 12:44:33',NULL,NULL),(44839,'50262','S','Van Wert','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.854624,-93.846622,0,'2013-07-06 12:44:32',NULL,NULL),(76804,'95947','S','Almanor','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.154340,-120.924326,0,'2013-07-06 12:44:34',NULL,NULL),(73337,'90848','U','Aarp Pharmacy','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.830348,-118.184925,0,'2013-07-06 12:44:34',NULL,NULL),(64717,'76871','S','Richland Springs','D','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.304072,-98.817416,0,'2013-07-06 12:44:34',NULL,NULL),(59668,'71055','S','Gilark','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.617484,-93.281086,0,'2013-07-06 12:44:33',NULL,NULL),(55763,'64116','S','Kansas Cty','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(52148,'60442','S','Manhattan','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.434474,-87.984338,0,'2013-07-06 12:44:33',NULL,NULL),(34883,'38944','S','Minter City','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.696389,-90.295000,0,'2013-07-06 12:44:32',NULL,NULL),(45941,'52340','S','Tiffin','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.709900,-91.666150,0,'2013-07-06 12:44:32',NULL,NULL),(52111,'60419','S','Dolton','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.626741,-87.595887,0,'2013-07-06 12:44:33',NULL,NULL),(24264,'26823','P','Capon Springs','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.137153,-78.483814,0,'2013-07-06 12:44:31',NULL,NULL),(21864,'23149','S','Saluda','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.578281,-76.606448,0,'2013-07-06 12:44:31',NULL,NULL),(68866,'82637','S','Rolling Hills','A','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.831726,-105.843281,0,'2013-07-06 12:44:34',NULL,NULL),(69435,'83641','S','Melba','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.380775,-116.549761,0,'2013-07-06 12:44:34',NULL,NULL),(76130,'95248','P','Railroad Flat','N','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.315924,-120.516711,0,'2013-07-06 12:44:34',NULL,NULL),(14682,'15244','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445184,-80.143578,0,'2013-07-06 12:44:31',NULL,NULL),(45736,'52101','S','Hesper','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(64335,'76503','P','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.155172,-97.441303,0,'2013-07-06 12:44:34',NULL,NULL),(856,'00698','S','Sect Pueblo Nuevo','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(40192,'45381','S','West Alexandria','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.729736,-84.535455,0,'2013-07-06 12:44:32',NULL,NULL),(76021,'95132','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.406513,-121.855877,0,'2013-07-06 12:44:34',NULL,NULL),(79793,'99352','S','Richland','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.280602,-119.291215,0,'2013-07-06 12:44:34',NULL,NULL),(67408,'80130','S','Highlands Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.544318,-104.920225,0,'2013-07-06 12:44:34',NULL,NULL),(57877,'67601','S','Hays','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.820000,-99.408660,0,'2013-07-06 12:44:33',NULL,NULL),(39063,'44199','P','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.505351,-81.693427,0,'2013-07-06 12:44:32',NULL,NULL),(35182,'39282','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.254854,-90.248918,0,'2013-07-06 12:44:32',NULL,NULL),(16809,'17543','S','Rothsville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(41335,'46781','S','Poneto','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.656523,-85.242718,0,'2013-07-06 12:44:32',NULL,NULL),(47926,'55112','S','Moundsview','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079380,-93.187200,0,'2013-07-06 12:44:33',NULL,NULL),(473,'00667','S','Bda Nicolin Perez','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(64721,'76875','S','Rowena','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.636478,-99.966581,0,'2013-07-06 12:44:34',NULL,NULL),(75042,'93514','S','Swall Meadows','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(79058,'98422','S','Browns Point','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293639,-122.392048,0,'2013-07-06 12:44:34',NULL,NULL),(26665,'29379','S','Union','D','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.714757,-81.621133,0,'2013-07-06 12:44:31',NULL,NULL),(61913,'73146','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.494268,-97.530684,0,'2013-07-06 12:44:33',NULL,NULL),(4505,'03290','S','Nottingham','D','Rockingham','33015','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.092728,-71.118753,0,'2013-07-06 12:44:30',NULL,NULL),(20038,'20645','S','Issue','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.305493,-76.920407,0,'2013-07-06 12:44:31',NULL,NULL),(20441,'21005','S','Aberdeen Proving Ground','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.455614,-76.150285,0,'2013-07-06 12:44:31',NULL,NULL),(55255,'63454','S','Maywood','D','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.940896,-91.602623,0,'2013-07-06 12:44:33',NULL,NULL),(36361,'40447','S','Kerby Knob','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(62268,'74012','S','Brkn Arw','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.045030,-95.808242,0,'2013-07-06 12:44:33',NULL,NULL),(31116,'33896','S','Davenport','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.198079,-81.621088,0,'2013-07-06 12:44:32',NULL,NULL),(72934,'90034','S','Palms','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.028026,-118.399267,0,'2013-07-06 12:44:34',NULL,NULL),(19225,'19898','U','Dupont Inc','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.742451,-75.549413,0,'2013-07-06 12:44:31',NULL,NULL),(53595,'62075','S','Audubon','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.285840,-89.312580,0,'2013-07-06 12:44:33',NULL,NULL),(16840,'17557','S','New Holland','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101003,-76.079601,0,'2013-07-06 12:44:31',NULL,NULL),(39796,'45133','S','Willetsville','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(43481,'48607','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.431818,-83.932056,0,'2013-07-06 12:44:32',NULL,NULL),(28885,'32124','S','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.092732,-81.042176,0,'2013-07-06 12:44:32',NULL,NULL),(7383,'06777','S','Washington Dt','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(75745,'94608','S','Oakland','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.834440,-122.289060,0,'2013-07-06 12:44:34',NULL,NULL),(5705,'04985','S','East Moxie TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(25292,'28139','S','Gilkey','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(77142,'96161','S','Boca','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(72533,'89165','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.330200,-115.325700,0,'2013-07-06 12:44:34',NULL,NULL),(25085,'27950','S','Woodleigh','N','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.537621,-76.038101,0,'2013-07-06 12:44:31',NULL,NULL),(2304,'00927','S','Urb Hyde Pk','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(44918,'50332','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.589141,-93.637284,0,'2013-07-06 12:44:32',NULL,NULL),(56770,'65740','S','Rockaway Bch','A','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.701943,-93.161158,0,'2013-07-06 12:44:33',NULL,NULL),(50409,'57780','S','Imlay','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.794115,-102.431907,0,'2013-07-06 12:44:33',NULL,NULL),(42593,'47885','S','Ferguson Hill','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(4090,'02668','S','W Barnstable','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.706060,-70.366440,0,'2013-07-06 12:44:30',NULL,NULL),(9584,'10028','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(3832,'02333','S','East Bridgewater','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.029586,-70.942499,0,'2013-07-06 12:44:30',NULL,NULL),(74739,'93042','U','Pt Mugu Nawc','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.122182,-119.092865,0,'2013-07-06 12:44:34',NULL,NULL),(60208,'71419','S','Sardis','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(4056,'02643','P','East Orleans','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.788622,-69.962488,0,'2013-07-06 12:44:30',NULL,NULL),(12623,'13090','S','Bayberry','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(20981,'21803','P','Salisbury','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.363050,-75.656824,0,'2013-07-06 12:44:31',NULL,NULL),(11551,'12055','S','Dormansville','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.438420,-74.203080,0,'2013-07-06 12:44:30',NULL,NULL),(50215,'57580','S','Clearfield','A','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(32881,'36528','S','Dauphin Islnd','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.250952,-88.128610,0,'2013-07-06 12:44:32',NULL,NULL),(55608,'63953','S','Naylor','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.557758,-90.628939,0,'2013-07-06 12:44:33',NULL,NULL),(23563,'25644','P','Sarah Ann','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.700463,-81.958636,0,'2013-07-06 12:44:31',NULL,NULL),(4573,'03470','S','Winchester','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.785580,-72.334800,0,'2013-07-06 12:44:30',NULL,NULL),(13184,'13617','S','Pierrepont','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(56789,'65757','S','Strafford','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.271244,-93.115517,0,'2013-07-06 12:44:33',NULL,NULL),(72893,'90018','S','Cimarron','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.030481,-118.318046,0,'2013-07-06 12:44:34',NULL,NULL),(51471,'59531','S','Joplin','D','Liberty','30051','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.697325,-110.825078,0,'2013-07-06 12:44:33',NULL,NULL),(77260,'96557','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(70421,'84728','S','Eskdale','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.935110,-114.034510,0,'2013-07-06 12:44:34',NULL,NULL),(61315,'72436','S','Marmaduke','A','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.210000,-90.512220,0,'2013-07-06 12:44:33',NULL,NULL),(57616,'67124','S','Pratt','D','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.648212,-98.738461,0,'2013-07-06 12:44:33',NULL,NULL),(18177,'18923','S','Fountainville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.350605,-75.163282,0,'2013-07-06 12:44:31',NULL,NULL),(3401,'01654','U','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.269010,-71.809164,0,'2013-07-06 12:44:30',NULL,NULL),(51467,'59527','P','Hays','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.209600,-108.804992,0,'2013-07-06 12:44:33',NULL,NULL),(49015,'56262','S','Milan','D','Chippewa','27023','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.106428,-95.913279,0,'2013-07-06 12:44:33',NULL,NULL),(36867,'41093','S','Beechburg','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.341084,-83.555814,0,'2013-07-06 12:44:32',NULL,NULL),(27604,'30301','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.855904,-84.395303,0,'2013-07-06 12:44:31',NULL,NULL),(27474,'30146','P','Lebanon','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.225248,-84.458297,0,'2013-07-06 12:44:31',NULL,NULL),(19546,'20196','U','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.926126,-77.396695,0,'2013-07-06 12:44:31',NULL,NULL),(54617,'62914','S','Urbandale','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.009840,-89.180112,0,'2013-07-06 12:44:33',NULL,NULL),(34166,'38281','P','Union City','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.425852,-89.049841,0,'2013-07-06 12:44:32',NULL,NULL),(51363,'59343','S','Olive','D','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.543207,-105.650812,0,'2013-07-06 12:44:33',NULL,NULL),(22161,'23461','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.852778,-75.978333,0,'2013-07-06 12:44:31',NULL,NULL),(627,'00682','S','Parc Mani','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(70842,'85540','S','Morenci','D','Greenlee','04011','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.045935,-109.325660,0,'2013-07-06 12:44:34',NULL,NULL),(62039,'73520','P','Addington','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.241461,-97.968550,0,'2013-07-06 12:44:33',NULL,NULL),(26473,'29150','S','Stateburg','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(71694,'87521','S','Chamisal','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.157505,-105.731083,0,'2013-07-06 12:44:34',NULL,NULL),(46151,'52659','S','Winfield','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.126832,-91.436627,0,'2013-07-06 12:44:32',NULL,NULL),(27571,'30269','S','Peachtree City','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.393706,-84.564697,0,'2013-07-06 12:44:31',NULL,NULL),(31673,'34761','S','Ocoee','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.580595,-81.539393,0,'2013-07-06 12:44:32',NULL,NULL),(34594,'38746','S','Dennis Landing','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.977222,-90.912222,0,'2013-07-06 12:44:32',NULL,NULL),(1044,'00723','S','Urb El Paraiso','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(41433,'46856','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.066024,-85.165168,0,'2013-07-06 12:44:32',NULL,NULL),(9216,'09508','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(40758,'46147','S','Jamestown','D','Boone','18011','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.974266,-86.635771,0,'2013-07-06 12:44:32',NULL,NULL),(50180,'57560','S','Blackpipe','N','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.473034,-101.079381,0,'2013-07-06 12:44:33',NULL,NULL),(74046,'92147','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.696705,-117.203572,0,'2013-07-06 12:44:34',NULL,NULL),(69008,'83205','P','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.843492,-112.466169,0,'2013-07-06 12:44:34',NULL,NULL),(66760,'79014','S','Glazier','A','Hemphill','48211','Texas','TX','48','0000','806','Central',-6.0,'Y',35.873100,-100.335420,0,'2013-07-06 12:44:34',NULL,NULL),(35500,'39529','U','Stennis Sp Ct','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(33890,'38030','S','Finley','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.990003,-89.579499,0,'2013-07-06 12:44:32',NULL,NULL),(11823,'12238','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652025,-73.761447,0,'2013-07-06 12:44:30',NULL,NULL),(23278,'25159','S','Lanham','A','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.468640,-81.782100,0,'2013-07-06 12:44:31',NULL,NULL),(22213,'23519','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.923406,-76.187822,0,'2013-07-06 12:44:31',NULL,NULL),(24684,'27412','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.065665,-79.806545,0,'2013-07-06 12:44:31',NULL,NULL),(61451,'72616','S','Metalton','N','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367020,-93.580140,0,'2013-07-06 12:44:33',NULL,NULL),(23975,'26301','S','Nutter Fort','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(38740,'44030','S','Conneaut Harbor','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(31932,'35182','P','Coal City','N','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.660556,-86.263333,0,'2013-07-06 12:44:32',NULL,NULL),(34442,'38649','P','Mt Plsnt','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.737265,-89.500427,0,'2013-07-06 12:44:32',NULL,NULL),(39837,'45159','S','Gist Settlement','N','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.342854,-83.695157,0,'2013-07-06 12:44:32',NULL,NULL),(1129,'00725','S','Villa del Rey 2','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(57632,'67144','S','Towanda','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.795767,-96.999851,0,'2013-07-06 12:44:33',NULL,NULL),(59524,'70803','U','University','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.408018,-91.188669,0,'2013-07-06 12:44:33',NULL,NULL),(21589,'22843','S','Mount Solon','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.371896,-79.168406,0,'2013-07-06 12:44:31',NULL,NULL),(16666,'17356','S','Freysville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(22008,'23285','P','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.538327,-77.435822,0,'2013-07-06 12:44:31',NULL,NULL),(10833,'11385','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702860,-73.879740,0,'2013-07-06 12:44:30',NULL,NULL),(30330,'33308','S','Sea Ranch Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(56406,'65247','S','Woodville','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.651110,-92.451199,0,'2013-07-06 12:44:33',NULL,NULL),(35922,'40032','U','Lagrange','A','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.422760,-85.393054,0,'2013-07-06 12:44:32',NULL,NULL),(61347,'72470','S','Success','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.453426,-90.724904,0,'2013-07-06 12:44:33',NULL,NULL),(78799,'98325','S','Chimacum','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.978657,-122.776970,0,'2013-07-06 12:44:34',NULL,NULL),(77424,'96802','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304492,-157.859879,0,'2013-07-06 12:44:34',NULL,NULL),(65211,'77437','S','New Taiton','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(1069,'00725','S','Parq Las Mercedes','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(77586,'96916','P','Merizo','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.266649,144.670158,0,'2013-07-06 12:44:34',NULL,NULL),(16084,'17050','S','Navy Sup Dpt','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(16004,'17039','P','Kleinfeltersv','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.301020,-76.249244,0,'2013-07-06 12:44:31',NULL,NULL),(27158,'29832','S','Johnston','D','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.833823,-81.807516,0,'2013-07-06 12:44:31',NULL,NULL),(35826,'39767','S','Lodi','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.532113,-89.496533,0,'2013-07-06 12:44:32',NULL,NULL),(51684,'59931','S','Rollins','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.923649,-114.259943,0,'2013-07-06 12:44:33',NULL,NULL),(40853,'46226','S','Lawrence','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.836981,-86.046783,0,'2013-07-06 12:44:32',NULL,NULL),(15420,'16364','S','Venus','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.371566,-79.505515,0,'2013-07-06 12:44:31',NULL,NULL),(46128,'52645','S','New London','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.923837,-91.401797,0,'2013-07-06 12:44:32',NULL,NULL),(7524,'07005','S','Lake Intervale','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(15182,'15940','S','Loretto','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.506522,-78.640492,0,'2013-07-06 12:44:31',NULL,NULL),(31164,'33917','S','No Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(70345,'84635','S','Hinckley','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.364440,-112.719300,0,'2013-07-06 12:44:34',NULL,NULL),(71689,'87517','P','Carson','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.639024,-105.842080,0,'2013-07-06 12:44:34',NULL,NULL),(76878,'95975','S','Rough Ready','A','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.223350,-121.143204,0,'2013-07-06 12:44:34',NULL,NULL),(19872,'20528','U','Dept Homeland Security','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894924,-77.038234,0,'2013-07-06 12:44:31',NULL,NULL),(17581,'18016','S','Bethlehem','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.622362,-75.375164,0,'2013-07-06 12:44:31',NULL,NULL),(36075,'40213','S','Audubon Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.184398,-85.716074,0,'2013-07-06 12:44:32',NULL,NULL),(36391,'40489','S','Waynesburg','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.363655,-84.632448,0,'2013-07-06 12:44:32',NULL,NULL),(41453,'46898','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.197539,-85.305300,0,'2013-07-06 12:44:32',NULL,NULL),(17283,'17846','S','Pine Summit','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.135280,-76.519320,0,'2013-07-06 12:44:31',NULL,NULL),(33439,'37306','S','Belvidere','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.201042,-85.901615,0,'2013-07-06 12:44:32',NULL,NULL),(34068,'38147','U','Regions Bank','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142153,-90.054546,0,'2013-07-06 12:44:32',NULL,NULL),(52218,'60484','S','University Park','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466347,-87.698762,0,'2013-07-06 12:44:33',NULL,NULL),(50505,'58068','S','Sheldon','D','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.531057,-97.411056,0,'2013-07-06 12:44:33',NULL,NULL),(46196,'52750','S','Gooselake','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.993759,-90.411063,0,'2013-07-06 12:44:32',NULL,NULL),(54799,'63016','S','La Barque Crk','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.352981,-90.644798,0,'2013-07-06 12:44:33',NULL,NULL),(62493,'74361','S','Pryor','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.298940,-95.310823,0,'2013-07-06 12:44:33',NULL,NULL),(22392,'23944','S','Kenbridge','D','Lunenburg','51111','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.959977,-78.124350,0,'2013-07-06 12:44:31',NULL,NULL),(77153,'96201','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(52647,'61060','S','Orangeville','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.473749,-89.636004,0,'2013-07-06 12:44:33',NULL,NULL),(29261,'32456','S','Cape San Blas','A','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.819214,-85.299275,0,'2013-07-06 12:44:32',NULL,NULL),(24263,'26818','S','Fisher','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.045865,-78.993193,0,'2013-07-06 12:44:31',NULL,NULL),(23769,'25969','S','Streeter','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.611675,-81.019615,0,'2013-07-06 12:44:31',NULL,NULL),(18159,'18851','S','Warren Center','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.946984,-76.198497,0,'2013-07-06 12:44:31',NULL,NULL),(76811,'95951','P','Hamilton City','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.743650,-122.010960,0,'2013-07-06 12:44:34',NULL,NULL),(77609,'96943','P','Yap','D','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',9.537287,138.126286,0,'2013-07-06 12:44:34',NULL,NULL),(78971,'98371','S','Puy','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(3038,'01101','P','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.099922,-72.589584,0,'2013-07-06 12:44:30',NULL,NULL),(68518,'81330','P','Mesa Verde National Park','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.297111,-108.420076,0,'2013-07-06 12:44:34',NULL,NULL),(38892,'44112','S','Cleveland Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.534374,-81.574679,0,'2013-07-06 12:44:32',NULL,NULL),(19564,'20208','U','Natl Institute of Educ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897725,-77.011119,0,'2013-07-06 12:44:31',NULL,NULL),(32027,'35242','S','Vestavia','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(42699,'47993','S','Pence','A','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.300200,-87.317520,0,'2013-07-06 12:44:32',NULL,NULL),(13786,'14168','P','Versailles','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.518902,-78.991091,0,'2013-07-06 12:44:31',NULL,NULL),(73389,'91108','S','San Marino','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.122334,-118.114252,0,'2013-07-06 12:44:34',NULL,NULL),(75710,'94576','S','Angwin','A','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.529291,-122.468362,0,'2013-07-06 12:44:34',NULL,NULL),(41664,'47147','S','Nabb','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.581248,-85.535514,0,'2013-07-06 12:44:32',NULL,NULL),(42595,'47885','S','Larimer Hill','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(16554,'17309','S','Shenks Ferry','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.870620,-76.451716,0,'2013-07-06 12:44:31',NULL,NULL),(28985,'32212','S','Nas Jacksonvle','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(5879,'05150','S','N Springfield','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.335916,-72.524997,0,'2013-07-06 12:44:30',NULL,NULL),(71908,'87801','S','Florida','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.006320,-106.793820,0,'2013-07-06 12:44:34',NULL,NULL),(65295,'77488','S','Spanish Camp','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(41642,'47134','U','Bureau of the Census','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285868,-85.732024,0,'2013-07-06 12:44:32',NULL,NULL),(38013,'43005','P','Bladensburg','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.290487,-82.291148,0,'2013-07-06 12:44:32',NULL,NULL),(36824,'41064','S','Piqua','N','Robertson','21201','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.532132,-84.039003,0,'2013-07-06 12:44:32',NULL,NULL),(76709,'95838','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.645117,-121.443728,0,'2013-07-06 12:44:34',NULL,NULL),(66936,'79357','S','Cone','A','Crosby','48107','Texas','TX','48','0000','806','Central',-6.0,'Y',33.653760,-101.377380,0,'2013-07-06 12:44:34',NULL,NULL),(61582,'72745','S','Lowell','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.258693,-94.130198,0,'2013-07-06 12:44:33',NULL,NULL),(59549,'70822','U','La Dept Reven','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.450296,-91.129317,0,'2013-07-06 12:44:33',NULL,NULL),(16425,'17228','S','Licking Creek','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.977362,-78.082703,0,'2013-07-06 12:44:31',NULL,NULL),(16586,'17322','S','Lucky','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.860272,-76.566178,0,'2013-07-06 12:44:31',NULL,NULL),(16967,'17705','U','Williamsport','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.240610,-77.039118,0,'2013-07-06 12:44:31',NULL,NULL),(28157,'30903','P','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.472729,-81.967746,0,'2013-07-06 12:44:31',NULL,NULL),(18149,'18843','P','S Montrose','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.796640,-75.891646,0,'2013-07-06 12:44:31',NULL,NULL),(40611,'45896','S','Waynesfield','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.605675,-83.968537,0,'2013-07-06 12:44:32',NULL,NULL),(35971,'40104','S','Battletown','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',38.067000,-86.323794,0,'2013-07-06 12:44:32',NULL,NULL),(73835,'91784','S','Upland','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.136114,-117.665006,0,'2013-07-06 12:44:34',NULL,NULL),(57114,'66222','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.023477,-94.648849,0,'2013-07-06 12:44:33',NULL,NULL),(78149,'97601','S','Klamath Falls','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.221688,-121.796627,0,'2013-07-06 12:44:34',NULL,NULL),(19366,'20055','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901404,-77.023348,0,'2013-07-06 12:44:31',NULL,NULL),(56722,'65689','S','Cabool','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.124655,-92.102085,0,'2013-07-06 12:44:33',NULL,NULL),(10914,'11428','S','Queens Vlg','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(55491,'63769','S','Oak Ridge','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.517100,-89.721600,0,'2013-07-06 12:44:33',NULL,NULL),(55498,'63775','S','Brewer','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(53405,'61832','S','Hegeler','N','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.136438,-87.632393,0,'2013-07-06 12:44:33',NULL,NULL),(7654,'07080','S','South Plainfield','D','Middlesex','34023','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.580308,-74.413829,0,'2013-07-06 12:44:30',NULL,NULL),(36653,'41007','S','California','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.894989,-84.294749,0,'2013-07-06 12:44:32',NULL,NULL),(63780,'75954','S','Hanson','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.938720,-94.055400,0,'2013-07-06 12:44:34',NULL,NULL),(62137,'73701','S','North Enid','A','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.405255,-97.874299,0,'2013-07-06 12:44:33',NULL,NULL),(55866,'64187','U','United Missouri Bank','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.099481,-94.577936,0,'2013-07-06 12:44:33',NULL,NULL),(24990,'27861','P','Parmele','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.820935,-77.312517,0,'2013-07-06 12:44:31',NULL,NULL),(24516,'27283','S','Julian','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.954535,-79.637459,0,'2013-07-06 12:44:31',NULL,NULL),(34692,'38828','S','Fairfield','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(64188,'76240','S','Lake Kiowa','A','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.621754,-97.121151,0,'2013-07-06 12:44:34',NULL,NULL),(59009,'70068','S','Laplace','N','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.054960,-90.480540,0,'2013-07-06 12:44:33',NULL,NULL),(4988,'04123','U','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.659527,-70.306000,0,'2013-07-06 12:44:30',NULL,NULL),(18273,'19009','P','Bryn Athyn','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.135969,-75.061051,0,'2013-07-06 12:44:31',NULL,NULL),(8762,'08540','S','Princeton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.367460,-74.669520,0,'2013-07-06 12:44:30',NULL,NULL),(11276,'11771','S','Oyster Bay Cove','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(33590,'37605','P','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.347307,-82.332037,0,'2013-07-06 12:44:32',NULL,NULL),(35257,'39350','S','Choctaw','A','Neshoba','28099','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.773985,-89.114722,0,'2013-07-06 12:44:32',NULL,NULL),(48852,'56071','S','Heidelberg','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.562435,-93.565297,0,'2013-07-06 12:44:33',NULL,NULL),(65105,'77365','S','Woody Acres','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.105908,-95.260353,0,'2013-07-06 12:44:34',NULL,NULL),(44180,'49560','U','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.876705,-85.627473,0,'2013-07-06 12:44:32',NULL,NULL),(27200,'29902','S','Naval Hospital','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.447460,-80.708640,0,'2013-07-06 12:44:31',NULL,NULL),(15057,'15723','P','Chambersville','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.705759,-79.158229,0,'2013-07-06 12:44:31',NULL,NULL),(15311,'16154','S','S Pymatuning Twp','N','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.330766,-80.441553,0,'2013-07-06 12:44:31',NULL,NULL),(61957,'73170','S','Moore','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.373300,-97.562460,0,'2013-07-06 12:44:33',NULL,NULL),(19141,'19612','P','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.365134,-75.909435,0,'2013-07-06 12:44:31',NULL,NULL),(8621,'08250','P','Tuckahoe','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.290009,-74.759054,0,'2013-07-06 12:44:30',NULL,NULL),(12937,'13346','S','Randallsville','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827220,-75.529560,0,'2013-07-06 12:44:30',NULL,NULL),(53289,'61727','S','Midland City','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(12437,'12957','S','South Bombay','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.868120,-74.563980,0,'2013-07-06 12:44:30',NULL,NULL),(2243,'00926','S','Urb La Cumbre','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(11941,'12436','P','Haines Falls','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.194504,-74.118450,0,'2013-07-06 12:44:30',NULL,NULL),(60808,'72031','S','Rex','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(79279,'98577','S','Frances','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(54871,'63052','S','Otto','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.390733,-90.422015,0,'2013-07-06 12:44:33',NULL,NULL),(65956,'78269','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.567517,-98.615480,0,'2013-07-06 12:44:34',NULL,NULL),(62894,'75063','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.916909,-96.972270,0,'2013-07-06 12:44:33',NULL,NULL),(58033,'68009','P','Blair','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.558272,-96.245006,0,'2013-07-06 12:44:33',NULL,NULL),(51245,'59073','P','Delphia','N','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.504722,-108.218611,0,'2013-07-06 12:44:33',NULL,NULL),(22421,'24005','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271194,-79.940971,0,'2013-07-06 12:44:31',NULL,NULL),(61853,'73120','S','Village','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.584064,-97.574272,0,'2013-07-06 12:44:33',NULL,NULL),(61922,'73151','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.567203,-97.404773,0,'2013-07-06 12:44:33',NULL,NULL),(64439,'76566','S','South Purmela','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.466689,-97.904546,0,'2013-07-06 12:44:34',NULL,NULL),(49100,'56339','S','Hoffman','D','Grant','27051','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.830410,-95.793251,0,'2013-07-06 12:44:33',NULL,NULL),(31668,'34758','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.203472,-81.500447,0,'2013-07-06 12:44:32',NULL,NULL),(30479,'33349','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181282,-80.226180,0,'2013-07-06 12:44:32',NULL,NULL),(1811,'00784','S','Brisas Del Mar Elderly','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(2137,'00924','S','Urb Gonzalez Seijo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(6152,'05468','S','West Milton','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.639211,-73.136914,0,'2013-07-06 12:44:30',NULL,NULL),(22771,'24445','S','Bacova Jnctn','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(18563,'19123','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963063,-75.149978,0,'2013-07-06 12:44:31',NULL,NULL),(79690,'99202','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.657108,-117.377255,0,'2013-07-06 12:44:34',NULL,NULL),(64140,'76196','U','Tarrant County Courthouse','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755869,-97.338178,0,'2013-07-06 12:44:34',NULL,NULL),(32825,'36461','P','Monroeville','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.520180,-87.320717,0,'2013-07-06 12:44:32',NULL,NULL),(44824,'50249','S','Stratford','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.272379,-93.927468,0,'2013-07-06 12:44:32',NULL,NULL),(11779,'12205','S','Colonie Center','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.714746,-73.821155,0,'2013-07-06 12:44:30',NULL,NULL),(54002,'62445','S','Woodbury','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.148880,-88.320381,0,'2013-07-06 12:44:33',NULL,NULL),(27623,'30309','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.788039,-84.385689,0,'2013-07-06 12:44:31',NULL,NULL),(3547,'01923','S','Danvers','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.570577,-70.944262,0,'2013-07-06 12:44:30',NULL,NULL),(78680,'98244','S','Nooksack Indian Reservation','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.824220,-121.958340,0,'2013-07-06 12:44:34',NULL,NULL),(55572,'63873','S','Portageville','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.430781,-89.697849,0,'2013-07-06 12:44:33',NULL,NULL),(51850,'60073','S','Round Lake','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(77241,'96535','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74904,'93309','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.337074,-119.070042,0,'2013-07-06 12:44:34',NULL,NULL),(71984,'88025','S','Buckhorn','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.864735,-108.719779,0,'2013-07-06 12:44:34',NULL,NULL),(53544,'62037','S','Otterville','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.971812,-90.445426,0,'2013-07-06 12:44:33',NULL,NULL),(50953,'58621','S','Beach','D','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.931605,-104.007445,0,'2013-07-06 12:44:33',NULL,NULL),(4608,'03590','S','No Stratford','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.719190,-71.465831,0,'2013-07-06 12:44:30',NULL,NULL),(49012,'56257','S','Nassau','A','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.931601,-96.397949,0,'2013-07-06 12:44:33',NULL,NULL),(37455,'41848','S','Roxana','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.091763,-83.029667,0,'2013-07-06 12:44:32',NULL,NULL),(36913,'41142','P','Grahn','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.283826,-83.075594,0,'2013-07-06 12:44:32',NULL,NULL),(23692,'25857','S','Josephine','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.624937,-81.212444,0,'2013-07-06 12:44:31',NULL,NULL),(5798,'05061','S','Randolph CTR','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.928243,-72.589744,0,'2013-07-06 12:44:30',NULL,NULL),(56169,'64870','S','Webb City','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.144119,-94.470557,0,'2013-07-06 12:44:33',NULL,NULL),(67795,'80729','S','Grover','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.855794,-104.111040,0,'2013-07-06 12:44:34',NULL,NULL),(71833,'87579','S','Placita','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(19969,'20591','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891171,-77.022513,0,'2013-07-06 12:44:31',NULL,NULL),(46761,'53939','P','Kingston','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.694164,-89.126328,0,'2013-07-06 12:44:32',NULL,NULL),(38863,'44097','P','Eastlake','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.651449,-81.448780,0,'2013-07-06 12:44:32',NULL,NULL),(58620,'68859','S','North Loup','D','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.466866,-98.705890,0,'2013-07-06 12:44:33',NULL,NULL),(36664,'41011','S','Cov','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(16945,'17701','S','Newberry','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(3306,'01517','P','East Princeton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.470175,-71.840195,0,'2013-07-06 12:44:30',NULL,NULL),(4915,'04071','S','Raymond','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.914064,-70.444240,0,'2013-07-06 12:44:30',NULL,NULL),(28673,'31792','S','Tville','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.836835,-83.972588,0,'2013-07-06 12:44:32',NULL,NULL),(5335,'04605','S','Ellsworth','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(72554,'89301','S','Cherry Creek','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(55195,'63381','S','Truxton','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.962877,-91.225396,0,'2013-07-06 12:44:33',NULL,NULL),(675,'00683','S','Urb Montebello','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(9633,'10035','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(17697,'18216','S','Beaver Meadows','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.929263,-75.912405,0,'2013-07-06 12:44:31',NULL,NULL),(29859,'33037','S','Upper Key Largo','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.130791,-80.410224,0,'2013-07-06 12:44:32',NULL,NULL),(17445,'17938','S','Barry','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.655278,-76.446944,0,'2013-07-06 12:44:31',NULL,NULL),(7041,'06269','U','University of Ct','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.811419,-72.247553,0,'2013-07-06 12:44:30',NULL,NULL),(54888,'63068','S','Stony Hill','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(63782,'75954','S','Joaquin','D','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.938720,-94.055400,0,'2013-07-06 12:44:34',NULL,NULL),(77208,'96375','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77547,'96857','S','Schofield Barracks','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.494722,-158.066346,0,'2013-07-06 12:44:34',NULL,NULL),(77602,'96940','P','Palau','D','Palau','70030','Palau','PW','70','0000','680','UTC+9',9.0,'N',7.496636,134.574247,0,'2013-07-06 12:44:34',NULL,NULL),(76972,'96055','S','Los Molinos','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.055266,-122.102585,0,'2013-07-06 12:44:34',NULL,NULL),(73033,'90074','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.052583,-118.268010,0,'2013-07-06 12:44:34',NULL,NULL),(1367,'00736','S','Urb La Plata','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(137,'00617','S','Brisas de Llanadas','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(43453,'48531','P','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.055082,-83.750365,0,'2013-07-06 12:44:32',NULL,NULL),(66513,'78708','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.385313,-97.705249,0,'2013-07-06 12:44:34',NULL,NULL),(65604,'77901','S','Victoria','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.706750,-97.181430,0,'2013-07-06 12:44:34',NULL,NULL),(59758,'71154','U','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.492906,-93.766371,0,'2013-07-06 12:44:33',NULL,NULL),(32870,'36522','S','Citronelle','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.072363,-88.264023,0,'2013-07-06 12:44:32',NULL,NULL),(16706,'17402','S','Yorkshire','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(11949,'12444','S','Jewett','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.270415,-74.315880,0,'2013-07-06 12:44:30',NULL,NULL),(75372,'93928','P','Jolon','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.048776,-121.200408,0,'2013-07-06 12:44:34',NULL,NULL),(59329,'70535','S','Eunice','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.493932,-92.414064,0,'2013-07-06 12:44:33',NULL,NULL),(23929,'26241','S','Elkins','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.923260,-79.850503,0,'2013-07-06 12:44:31',NULL,NULL),(28557,'31567','S','West Green','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.608272,-82.739715,0,'2013-07-06 12:44:32',NULL,NULL),(34809,'38878','S','Wardwell','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(35652,'39645','S','Liberty','D','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.158025,-90.804511,0,'2013-07-06 12:44:32',NULL,NULL),(636,'00682','S','Urb Guanajibo Gdns','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(29132,'32323','P','Lanark Village','D','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.880772,-84.599766,0,'2013-07-06 12:44:32',NULL,NULL),(52471,'60686','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.850116,-87.650659,0,'2013-07-06 12:44:33',NULL,NULL),(76167,'95320','S','Escalon','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.799287,-121.005121,0,'2013-07-06 12:44:34',NULL,NULL),(74939,'93408','U','Slo County Govt Ctr','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.222175,-120.637046,0,'2013-07-06 12:44:34',NULL,NULL),(35404,'39462','S','Wingate','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.291608,-89.067446,0,'2013-07-06 12:44:32',NULL,NULL),(21869,'23156','S','Plain View','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.576680,-76.729380,0,'2013-07-06 12:44:31',NULL,NULL),(8790,'08560','S','Ewing','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.296010,-74.856815,0,'2013-07-06 12:44:30',NULL,NULL),(55928,'64468','S','Maryville','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.346452,-94.874254,0,'2013-07-06 12:44:33',NULL,NULL),(75868,'94947','S','Novato','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.103524,-122.616201,0,'2013-07-06 12:44:34',NULL,NULL),(13829,'14218','S','W Seneca','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.810099,-78.781921,0,'2013-07-06 12:44:31',NULL,NULL),(11917,'12414','S','Cementon','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.224593,-73.874142,0,'2013-07-06 12:44:30',NULL,NULL),(24165,'26601','S','Sutton','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.672330,-80.687532,0,'2013-07-06 12:44:31',NULL,NULL),(37415,'41804','S','Blackey','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.175000,-83.000000,0,'2013-07-06 12:44:32',NULL,NULL),(73977,'92084','S','Vista','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.215973,-117.217092,0,'2013-07-06 12:44:34',NULL,NULL),(49822,'57217','S','Bradley','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.903080,-97.707295,0,'2013-07-06 12:44:33',NULL,NULL),(36275,'40337','S','Jeffersonvlle','A','Montgomery','21173','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.951348,-83.863945,0,'2013-07-06 12:44:32',NULL,NULL),(7368,'06759','S','Litchfield','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.750193,-73.189104,0,'2013-07-06 12:44:30',NULL,NULL),(35036,'39168','S','Taylorsville','D','Smith','28129','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.825343,-89.429553,0,'2013-07-06 12:44:32',NULL,NULL),(78787,'98312','S','Wildcat Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(76230,'95381','P','Turlock','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.496400,-120.858683,0,'2013-07-06 12:44:34',NULL,NULL),(60749,'71971','S','Umpire','D','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.290480,-94.094820,0,'2013-07-06 12:44:33',NULL,NULL),(22062,'23328','P','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.731870,-76.230359,0,'2013-07-06 12:44:31',NULL,NULL),(7404,'06793','S','Washington Green','N','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.640788,-73.293104,0,'2013-07-06 12:44:30',NULL,NULL),(35965,'40071','S','Taylorsville','D','Spencer','21215','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.050122,-85.371767,0,'2013-07-06 12:44:32',NULL,NULL),(3542,'01915','S','Beverly','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.566460,-70.853280,0,'2013-07-06 12:44:30',NULL,NULL),(22845,'24529','S','Buffalo Jct','A','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.598421,-78.619575,0,'2013-07-06 12:44:31',NULL,NULL),(6722,'06071','S','Connecticut State Prison','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.994749,-72.451260,0,'2013-07-06 12:44:30',NULL,NULL),(6622,'05903','S','Canaan','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.972195,-71.584884,0,'2013-07-06 12:44:30',NULL,NULL),(66924,'79339','S','Littlefield','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',33.921519,-102.335271,0,'2013-07-06 12:44:34',NULL,NULL),(75407,'94019','S','Half Moon Bay','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.479960,-122.330880,0,'2013-07-06 12:44:34',NULL,NULL),(57535,'67018','S','Bluff City','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.070411,-97.877456,0,'2013-07-06 12:44:33',NULL,NULL),(77680,'97034','S','Oswego','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.410367,-122.689055,0,'2013-07-06 12:44:34',NULL,NULL),(37507,'42035','S','Cunningham','D','Carlisle','21039','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.894031,-88.874629,0,'2013-07-06 12:44:32',NULL,NULL),(8232,'07981','S','Whippany','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.822442,-74.420353,0,'2013-07-06 12:44:30',NULL,NULL),(49260,'56479','S','Moran','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.353921,-94.795227,0,'2013-07-06 12:44:33',NULL,NULL),(56473,'65321','S','Blackburn','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.104512,-93.486773,0,'2013-07-06 12:44:33',NULL,NULL),(47995,'55144','U','Maplewood','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.925118,-93.048795,0,'2013-07-06 12:44:33',NULL,NULL),(49009,'56256','S','Louisburg','A','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.166111,-96.170833,0,'2013-07-06 12:44:33',NULL,NULL),(40266,'45432','S','Kettering','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.741263,-84.068879,0,'2013-07-06 12:44:32',NULL,NULL),(9175,'09360','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(68205,'81041','S','Koen','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.913104,-102.348905,0,'2013-07-06 12:44:34',NULL,NULL),(26879,'29554','S','Stuckey','N','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.739020,-79.447920,0,'2013-07-06 12:44:31',NULL,NULL),(80,'00612','S','Jard de San Rafael','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(3658,'02121','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.306015,-71.084811,0,'2013-07-06 12:44:30',NULL,NULL),(78178,'97701','S','Bend','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.098205,-121.288771,0,'2013-07-06 12:44:34',NULL,NULL),(77105,'96142','P','Rubicon Bay','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.063924,-120.138469,0,'2013-07-06 12:44:34',NULL,NULL),(30290,'33265','P','Olympia Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737256,-80.411116,0,'2013-07-06 12:44:32',NULL,NULL),(80089,'99741','P','Galena','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.094120,-154.253230,0,'2013-07-06 12:44:34',NULL,NULL),(69523,'83726','U','Albertsons','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.435557,-116.004295,0,'2013-07-06 12:44:34',NULL,NULL),(64711,'76864','S','Mullin','D','Mills','48333','Texas','TX','48','0000','325','Central',-6.0,'Y',31.572787,-98.700643,0,'2013-07-06 12:44:34',NULL,NULL),(59729,'71111','S','Bossier City','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.545307,-93.704765,0,'2013-07-06 12:44:33',NULL,NULL),(55974,'64507','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.748921,-94.808435,0,'2013-07-06 12:44:33',NULL,NULL),(49275,'56502','P','Detroit Lakes','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.820385,-95.843944,0,'2013-07-06 12:44:33',NULL,NULL),(41723,'47243','S','Paynesville','N','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.714687,-85.472195,0,'2013-07-06 12:44:32',NULL,NULL),(27819,'30401','S','Swainsboro','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(18565,'19124','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.013115,-75.094734,0,'2013-07-06 12:44:31',NULL,NULL),(50066,'57442','S','Gorman','N','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.013247,-99.998682,0,'2013-07-06 12:44:33',NULL,NULL),(13179,'13617','S','Crary Mills','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(21360,'22443','S','Colonial Bch','A','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.248998,-76.962438,0,'2013-07-06 12:44:31',NULL,NULL),(35789,'39751','S','Bentley','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.733333,-89.066667,0,'2013-07-06 12:44:32',NULL,NULL),(24903,'27711','U','Research Triangle Pk','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916201,-78.867468,0,'2013-07-06 12:44:31',NULL,NULL),(54416,'62832','S','Du Quoin','D','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.009216,-89.237329,0,'2013-07-06 12:44:33',NULL,NULL),(43634,'48827','S','Eaton Rapids','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.508608,-84.668710,0,'2013-07-06 12:44:32',NULL,NULL),(16849,'17562','S','Leaman Place','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(8248,'08005','S','Warren Grove','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.758880,-74.283480,0,'2013-07-06 12:44:30',NULL,NULL),(11368,'11901','S','Riverhead','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.928084,-72.655830,0,'2013-07-06 12:44:30',NULL,NULL),(79596,'99037','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.644452,-117.195238,0,'2013-07-06 12:44:34',NULL,NULL),(64546,'76651','S','Italy','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.181612,-96.885798,0,'2013-07-06 12:44:34',NULL,NULL),(59907,'71280','S','Spencer','A','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.616000,-92.157420,0,'2013-07-06 12:44:33',NULL,NULL),(2509,'00957','S','Urb Cana','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(46529,'53295','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.016381,-87.979711,0,'2013-07-06 12:44:32',NULL,NULL),(47361,'54615','S','Blk River Fls','A','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.290491,-90.846708,0,'2013-07-06 12:44:32',NULL,NULL),(38659,'43943','S','Glen Robbins','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.179877,-80.707940,0,'2013-07-06 12:44:32',NULL,NULL),(62593,'74477','P','Wagoner','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.959752,-95.371077,0,'2013-07-06 12:44:33',NULL,NULL),(6033,'05404','S','Winooski','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.494430,-73.183111,0,'2013-07-06 12:44:30',NULL,NULL),(36467,'40741','S','Marydell','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.110220,-84.078189,0,'2013-07-06 12:44:32',NULL,NULL),(77675,'97031','S','Hood River','D','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.666629,-121.539966,0,'2013-07-06 12:44:34',NULL,NULL),(71078,'85924','S','Concho','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.428600,-109.689120,0,'2013-07-06 12:44:34',NULL,NULL),(6043,'05408','S','Burlngtn','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446628,-73.175354,0,'2013-07-06 12:44:30',NULL,NULL),(30854,'33650','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.968812,-82.518425,0,'2013-07-06 12:44:32',NULL,NULL),(71319,'86505','S','Mennonite Mission','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(67341,'80105','S','Deer Trail','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.613600,-104.044202,0,'2013-07-06 12:44:34',NULL,NULL),(63322,'75570','S','Old Boston','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.457080,-94.450920,0,'2013-07-06 12:44:33',NULL,NULL),(43162,'48266','U','Kelly Services Inc','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.344450,-83.009180,0,'2013-07-06 12:44:32',NULL,NULL),(73252,'90706','S','Bellflower','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.888756,-118.128543,0,'2013-07-06 12:44:34',NULL,NULL),(58783,'68976','S','Smithfield','D','Gosper','31073','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.587296,-99.859973,0,'2013-07-06 12:44:33',NULL,NULL),(48047,'55312','S','Brownton','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.732043,-94.351050,0,'2013-07-06 12:44:33',NULL,NULL),(59215,'70401','S','Hammond','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.516364,-90.476064,0,'2013-07-06 12:44:33',NULL,NULL),(52920,'61368','S','Tiskilwa','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.293034,-89.507464,0,'2013-07-06 12:44:33',NULL,NULL),(48215,'55413','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.001226,-93.245526,0,'2013-07-06 12:44:33',NULL,NULL),(17084,'17764','S','East Renovo','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(36288,'40353','S','Mount Sterling','D','Montgomery','21173','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.057445,-83.934406,0,'2013-07-06 12:44:32',NULL,NULL),(36619,'40981','P','Saul','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.395772,-83.271741,0,'2013-07-06 12:44:32',NULL,NULL),(54849,'63040','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576576,-90.628174,0,'2013-07-06 12:44:33',NULL,NULL),(77425,'96802','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304492,-157.859879,0,'2013-07-06 12:44:34',NULL,NULL),(73725,'91617','P','Valley Village','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164995,-118.403562,0,'2013-07-06 12:44:34',NULL,NULL),(38476,'43652','U','Toledo Edison','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.650967,-83.536485,0,'2013-07-06 12:44:32',NULL,NULL),(80118,'99762','P','Ltl Diomede','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.787400,-165.197220,0,'2013-07-06 12:44:34',NULL,NULL),(72220,'88430','S','Nara Visa','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.638279,-103.217076,0,'2013-07-06 12:44:34',NULL,NULL),(13294,'13665','S','Natural Bridge','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.099422,-75.476914,0,'2013-07-06 12:44:30',NULL,NULL),(24342,'27040','S','Dosier','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.167058,-80.376170,0,'2013-07-06 12:44:31',NULL,NULL),(68781,'82327','S','Leo','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.878504,-106.556303,0,'2013-07-06 12:44:34',NULL,NULL),(58319,'68444','S','Belle Prairie','N','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.396596,-97.540543,0,'2013-07-06 12:44:33',NULL,NULL),(34265,'38461','S','Hampshire','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.586677,-87.357491,0,'2013-07-06 12:44:32',NULL,NULL),(30097,'33158','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(53637,'62201','S','East St Louis','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(44601,'50049','S','Chariton','D','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018686,-93.311392,0,'2013-07-06 12:44:32',NULL,NULL),(2401,'00952','S','Mans del Sol','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.423816,-66.184972,0,'2013-07-06 12:44:30',NULL,NULL),(25165,'28037','S','Denver','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.510143,-81.016888,0,'2013-07-06 12:44:31',NULL,NULL),(17968,'18612','S','College Misericordia','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.332973,-75.961823,0,'2013-07-06 12:44:31',NULL,NULL),(48971,'56211','S','Beardsley','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.558920,-96.712210,0,'2013-07-06 12:44:33',NULL,NULL),(48308,'55443','S','Brooklyn Center','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.076111,-93.332500,0,'2013-07-06 12:44:33',NULL,NULL),(6674,'06032','S','West Farms Mall','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.725812,-72.835995,0,'2013-07-06 12:44:30',NULL,NULL),(17507,'17963','S','Lorberry','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(72951,'90040','S','Cty of Cmmrce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.976980,-118.128840,0,'2013-07-06 12:44:34',NULL,NULL),(71063,'85756','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.136236,-111.085365,0,'2013-07-06 12:44:34',NULL,NULL),(64570,'76661','S','McClanahan','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.310786,-96.891028,0,'2013-07-06 12:44:34',NULL,NULL),(43457,'48550','U','Buick Oldsmobile Cadillac','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.065739,-83.688105,0,'2013-07-06 12:44:32',NULL,NULL),(77296,'96663','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72381,'89037','S','Coyote Spgs','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.370267,-114.883611,0,'2013-07-06 12:44:34',NULL,NULL),(71222,'86326','S','Cottonwood','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.717972,-112.006354,0,'2013-07-06 12:44:34',NULL,NULL),(63031,'75204','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.798752,-96.788683,0,'2013-07-06 12:44:33',NULL,NULL),(47747,'55018','S','Stanton','A','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.407140,-93.018480,0,'2013-07-06 12:44:33',NULL,NULL),(23203,'25063','S','Strange Creek','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.567158,-80.975873,0,'2013-07-06 12:44:31',NULL,NULL),(14229,'14808','S','N Cohocton','A','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.552703,-77.480345,0,'2013-07-06 12:44:31',NULL,NULL),(32743,'36323','S','Elba','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.416920,-86.075109,0,'2013-07-06 12:44:32',NULL,NULL),(55387,'63626','S','Blackwell','D','Saint Francois','29187','Missouri','MO','29','0000','636','Central',-6.0,'Y',38.068875,-90.709883,0,'2013-07-06 12:44:33',NULL,NULL),(49218,'56466','S','Motley','D','Morrison','27097','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.326960,-94.624860,0,'2013-07-06 12:44:33',NULL,NULL),(78909,'98362','S','Pt Angeles','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(64917,'77204','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.765745,-95.389271,0,'2013-07-06 12:44:34',NULL,NULL),(59266,'70452','S','Pearl River','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.402734,-89.773340,0,'2013-07-06 12:44:33',NULL,NULL),(13088,'13468','S','Springfld Ctr','A','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.844523,-74.841105,0,'2013-07-06 12:44:30',NULL,NULL),(2936,'01027','S','Loudville','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.291420,-72.717720,0,'2013-07-06 12:44:30',NULL,NULL),(3240,'01430','S','Ashburnham','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.653600,-71.924255,0,'2013-07-06 12:44:30',NULL,NULL),(9866,'10121','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(28849,'32092','S','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.956369,-81.524977,0,'2013-07-06 12:44:32',NULL,NULL),(46410,'53177','S','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.697861,-87.917460,0,'2013-07-06 12:44:32',NULL,NULL),(25788,'28604','S','Kellersville','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(76383,'95527','S','Burnt Ranch','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.775234,-123.428470,0,'2013-07-06 12:44:34',NULL,NULL),(65389,'77552','P','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.280987,-94.815438,0,'2013-07-06 12:44:34',NULL,NULL),(58644,'68870','S','Thornton','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.784307,-99.160939,0,'2013-07-06 12:44:33',NULL,NULL),(20632,'21218','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.325256,-76.605131,0,'2013-07-06 12:44:31',NULL,NULL),(28183,'31008','S','Powersville','A','Peach','13225','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.646227,-83.754589,0,'2013-07-06 12:44:31',NULL,NULL),(32919,'36555','S','Magnolia Springs','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.399119,-87.787327,0,'2013-07-06 12:44:32',NULL,NULL),(64876,'77065','S','Jersey Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.930003,-95.605601,0,'2013-07-06 12:44:34',NULL,NULL),(59261,'70448','S','Lewisburg','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.366783,-90.034817,0,'2013-07-06 12:44:33',NULL,NULL),(16072,'17049','S','Swales','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(20139,'20723','S','Scaggsville','A','Howard','24027','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.133677,-76.861876,0,'2013-07-06 12:44:31',NULL,NULL),(10011,'10169','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(25485,'28356','S','Linden','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.231971,-78.797717,0,'2013-07-06 12:44:31',NULL,NULL),(54632,'62919','S','Rock Creek','N','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.539067,-88.238667,0,'2013-07-06 12:44:33',NULL,NULL),(43156,'48260','U','DTE','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331990,-83.057185,0,'2013-07-06 12:44:32',NULL,NULL),(43288,'48334','S','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505423,-83.351825,0,'2013-07-06 12:44:32',NULL,NULL),(53879,'62349','S','Bigneck','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153679,-91.205575,0,'2013-07-06 12:44:33',NULL,NULL),(78044,'97441','S','Gardiner','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.730728,-124.106157,0,'2013-07-06 12:44:34',NULL,NULL),(77090,'96135','P','Vinton','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.719317,-120.214213,0,'2013-07-06 12:44:34',NULL,NULL),(76330,'95462','S','Russian River','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.469285,-123.012010,0,'2013-07-06 12:44:34',NULL,NULL),(7988,'07715','U','Belmar','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.181879,-74.022898,0,'2013-07-06 12:44:30',NULL,NULL),(44333,'49759','S','Ocqueoc','A','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.436961,-84.100677,0,'2013-07-06 12:44:32',NULL,NULL),(24643,'27374','P','Welcome','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.907696,-80.254417,0,'2013-07-06 12:44:31',NULL,NULL),(19071,'19555','S','Kindts Corner','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.496804,-75.955057,0,'2013-07-06 12:44:31',NULL,NULL),(28082,'30731','S','Menlo','D','Chattooga','13055','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.622640,-85.497720,0,'2013-07-06 12:44:31',NULL,NULL),(4545,'03446','S','Swanzey Ctr','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.854142,-72.260794,0,'2013-07-06 12:44:30',NULL,NULL),(19847,'20508','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899287,-77.040342,0,'2013-07-06 12:44:31',NULL,NULL),(19731,'20401','U','Gov Printing Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897816,-77.008997,0,'2013-07-06 12:44:31',NULL,NULL),(53949,'62421','S','German','N','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.755773,-87.965113,0,'2013-07-06 12:44:33',NULL,NULL),(65976,'78297','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425414,-98.486372,0,'2013-07-06 12:44:34',NULL,NULL),(58161,'68180','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.233224,-96.053004,0,'2013-07-06 12:44:33',NULL,NULL),(44097,'49464','S','Borculo','N','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866880,-85.968600,0,'2013-07-06 12:44:32',NULL,NULL),(45033,'50470','S','Rowan','D','Wright','19197','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.740083,-93.545238,0,'2013-07-06 12:44:32',NULL,NULL),(45470,'51250','S','Lebanon','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.079162,-96.175074,0,'2013-07-06 12:44:32',NULL,NULL),(12620,'13088','S','Lvrpool','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(72812,'89801','S','Lee','A','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.834645,-115.757583,0,'2013-07-06 12:44:34',NULL,NULL),(12455,'12969','S','Owls Head','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.705100,-74.111820,0,'2013-07-06 12:44:30',NULL,NULL),(50043,'57433','S','Tacoma Park','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.679320,-98.308680,0,'2013-07-06 12:44:33',NULL,NULL),(40181,'45371','S','Tipp City','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.955039,-84.178566,0,'2013-07-06 12:44:32',NULL,NULL),(32697,'36276','S','Motley','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(7820,'07456','S','Ringwood','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.100840,-74.290260,0,'2013-07-06 12:44:30',NULL,NULL),(63515,'75751','S','Tri Cities','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(71332,'86507','P','Lukachukai','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.432600,-109.238820,0,'2013-07-06 12:44:34',NULL,NULL),(24716,'27506','P','Buies Creek','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.406789,-78.738203,0,'2013-07-06 12:44:31',NULL,NULL),(5790,'05058','S','Post Mills','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.891010,-72.266882,0,'2013-07-06 12:44:30',NULL,NULL),(1858,'00791','S','Humacao','D','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(29192,'32404','S','Callaway','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.180448,-85.559816,0,'2013-07-06 12:44:32',NULL,NULL),(13990,'14510','S','Mount Morris','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.688740,-77.895180,0,'2013-07-06 12:44:31',NULL,NULL),(32201,'35551','P','Delmar','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.173518,-87.606111,0,'2013-07-06 12:44:32',NULL,NULL),(75449,'94063','S','Redwood City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.492395,-122.203623,0,'2013-07-06 12:44:34',NULL,NULL),(29989,'33109','S','Fisher Island','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796586,-80.286950,0,'2013-07-06 12:44:32',NULL,NULL),(79966,'99640','P','Nondalton','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.966590,-154.848985,0,'2013-07-06 12:44:34',NULL,NULL),(32422,'35978','S','Henagar','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.626709,-85.752319,0,'2013-07-06 12:44:32',NULL,NULL),(29755,'33001','P','Layton','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.816667,-80.816667,0,'2013-07-06 12:44:32',NULL,NULL),(60096,'71360','S','Green Gables','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(66766,'79019','S','Claude','D','Armstrong','48011','Texas','TX','48','0000','806','Central',-6.0,'Y',35.117381,-101.402531,0,'2013-07-06 12:44:34',NULL,NULL),(67186,'79853','P','Tornillo','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.432754,-106.077830,0,'2013-07-06 12:44:34',NULL,NULL),(478,'00667','S','Jard de Lajas','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(71644,'87420','S','Little Water','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.574461,-108.590087,0,'2013-07-06 12:44:34',NULL,NULL),(40400,'45674','P','Rio Grande','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.882583,-82.380832,0,'2013-07-06 12:44:32',NULL,NULL),(68266,'81071','S','Brandon','A','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.446999,-102.218718,0,'2013-07-06 12:44:34',NULL,NULL),(38135,'43126','P','Harrisburg','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.809767,-83.168194,0,'2013-07-06 12:44:32',NULL,NULL),(54089,'62526','S','Bearsdale','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.875033,-88.956342,0,'2013-07-06 12:44:33',NULL,NULL),(21808,'23091','S','Little Plymth','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.667329,-76.806604,0,'2013-07-06 12:44:31',NULL,NULL),(7839,'07461','S','Wallkill Lake','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(40850,'46224','S','Speedway','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.792960,-86.257080,0,'2013-07-06 12:44:32',NULL,NULL),(36897,'41105','P','Summitt','A','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.430686,-82.667440,0,'2013-07-06 12:44:32',NULL,NULL),(24327,'27023','S','West Bend','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.097444,-80.422826,0,'2013-07-06 12:44:31',NULL,NULL),(24765,'27549','S','Centerville','A','Franklin','37069','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.089778,-78.299777,0,'2013-07-06 12:44:31',NULL,NULL),(43308,'48348','S','Independence Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.767149,-83.400047,0,'2013-07-06 12:44:32',NULL,NULL),(3633,'02071','S','South Walpole','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.104986,-71.270463,0,'2013-07-06 12:44:30',NULL,NULL),(21075,'22025','S','Montclair','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.874600,-77.923200,0,'2013-07-06 12:44:31',NULL,NULL),(47417,'54657','S','Steuben','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.202357,-90.856293,0,'2013-07-06 12:44:32',NULL,NULL),(53681,'62221','S','Shiloh','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.550823,-89.984437,0,'2013-07-06 12:44:33',NULL,NULL),(61846,'73118','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.515114,-97.526477,0,'2013-07-06 12:44:33',NULL,NULL),(48156,'55373','S','Greenfield','N','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.089673,-93.734933,0,'2013-07-06 12:44:33',NULL,NULL),(30555,'33411','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(56266,'65063','S','New Bloomfld','A','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.748060,-92.080440,0,'2013-07-06 12:44:33',NULL,NULL),(39488,'44750','U','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.791005,-81.423621,0,'2013-07-06 12:44:32',NULL,NULL),(42330,'47631','S','New Harmony','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.116261,-87.922878,0,'2013-07-06 12:44:32',NULL,NULL),(22186,'23486','P','Willis Wharf','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.509821,-75.871865,0,'2013-07-06 12:44:31',NULL,NULL),(9316,'09728','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(24149,'26576','P','Idamay','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.497655,-80.257794,0,'2013-07-06 12:44:31',NULL,NULL),(58354,'68508','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.817080,-96.712063,0,'2013-07-06 12:44:33',NULL,NULL),(29878,'33042','S','Little Torch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(58340,'68464','S','Western','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.395360,-97.232299,0,'2013-07-06 12:44:33',NULL,NULL),(35035,'39167','P','Star','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.094353,-90.085165,0,'2013-07-06 12:44:32',NULL,NULL),(37501,'42031','S','Fulgham','N','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(29060,'32244','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.223538,-81.757243,0,'2013-07-06 12:44:32',NULL,NULL),(29259,'32455','S','Ponce de Leon','D','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.771038,-85.953835,0,'2013-07-06 12:44:32',NULL,NULL),(56862,'66012','S','Bonner Sprngs','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.073262,-94.884623,0,'2013-07-06 12:44:33',NULL,NULL),(12651,'13115','P','Minetto','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.398509,-76.493251,0,'2013-07-06 12:44:30',NULL,NULL),(36268,'40336','S','Crystal','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(36876,'41096','P','Washington','D','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.615854,-83.806165,0,'2013-07-06 12:44:32',NULL,NULL),(70945,'85641','S','Santa Rita Foothills','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(35469,'39505','P','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.442559,-89.067759,0,'2013-07-06 12:44:32',NULL,NULL),(33015,'36691','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.691197,-88.042054,0,'2013-07-06 12:44:32',NULL,NULL),(45621,'51579','S','Woodbine','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.746152,-95.697814,0,'2013-07-06 12:44:32',NULL,NULL),(24499,'27262','S','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.956020,-80.040720,0,'2013-07-06 12:44:31',NULL,NULL),(1978,'00902','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446284,-66.098281,0,'2013-07-06 12:44:30',NULL,NULL),(26764,'29435','S','Cottageville','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.938647,-80.479809,0,'2013-07-06 12:44:31',NULL,NULL),(53031,'61474','S','Saint Augustine','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.734471,-90.357068,0,'2013-07-06 12:44:33',NULL,NULL),(7696,'07109','S','Belleville','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.793718,-74.164895,0,'2013-07-06 12:44:30',NULL,NULL),(49318,'56547','S','Glyndon','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.874486,-96.578028,0,'2013-07-06 12:44:33',NULL,NULL),(34904,'38955','P','Calhoun Cty','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(60491,'71661','S','Empire','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.112866,-91.528220,0,'2013-07-06 12:44:33',NULL,NULL),(26632,'29329','P','Converse','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.999533,-81.844017,0,'2013-07-06 12:44:31',NULL,NULL),(57855,'67568','S','Plevna','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.985084,-98.301725,0,'2013-07-06 12:44:33',NULL,NULL),(57561,'67045','S','Reece','N','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.843200,-96.311880,0,'2013-07-06 12:44:33',NULL,NULL),(9169,'09352','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(52668,'61071','S','Yeowardville','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.758470,-89.690648,0,'2013-07-06 12:44:33',NULL,NULL),(22369,'23920','S','Brodnax','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.736438,-77.969862,0,'2013-07-06 12:44:31',NULL,NULL),(22260,'23690','S','Yorktown','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.225941,-76.523574,0,'2013-07-06 12:44:31',NULL,NULL),(24335,'27030','S','Mount Airy','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490645,-80.628907,0,'2013-07-06 12:44:31',NULL,NULL),(66621,'78778','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.276212,-97.739618,0,'2013-07-06 12:44:34',NULL,NULL),(24175,'26623','S','Clem','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.630653,-80.876931,0,'2013-07-06 12:44:31',NULL,NULL),(52307,'60546','S','North Riverside','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.835506,-87.821640,0,'2013-07-06 12:44:33',NULL,NULL),(44970,'50401','S','Mason City','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(15832,'16935','S','Mdby Center','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(4252,'02879','S','East Matunuck','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(63739,'75935','S','Grigsby','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(55577,'63878','P','Tallapoosa','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.506889,-89.821660,0,'2013-07-06 12:44:33',NULL,NULL),(41647,'47137','S','Alton','A','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.209645,-86.365045,0,'2013-07-06 12:44:32',NULL,NULL),(55417,'63655','S','Allbright','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.403467,-90.197360,0,'2013-07-06 12:44:33',NULL,NULL),(63137,'75359','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.812818,-96.756560,0,'2013-07-06 12:44:33',NULL,NULL),(11177,'11732','S','E Norwich','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.846511,-73.536189,0,'2013-07-06 12:44:30',NULL,NULL),(49026,'56273','S','Hawick','A','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.310623,-94.991718,0,'2013-07-06 12:44:33',NULL,NULL),(7339,'06716','S','Waterbury','A','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.591802,-72.972656,0,'2013-07-06 12:44:30',NULL,NULL),(52336,'60568','U','Northern Ill Gas Co','N','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.773392,-88.247376,0,'2013-07-06 12:44:33',NULL,NULL),(6540,'05838','P','E St Johnsbry','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.439437,-71.943690,0,'2013-07-06 12:44:30',NULL,NULL),(52092,'60410','S','Channahon','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.436384,-88.187708,0,'2013-07-06 12:44:33',NULL,NULL),(49444,'56637','S','Talmoon','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.589712,-93.775457,0,'2013-07-06 12:44:33',NULL,NULL),(3382,'01603','S','Webster Square','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.240138,-71.837010,0,'2013-07-06 12:44:30',NULL,NULL),(59433,'70704','P','Baker','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.583683,-91.154281,0,'2013-07-06 12:44:33',NULL,NULL),(61186,'72209','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.672097,-92.362416,0,'2013-07-06 12:44:33',NULL,NULL),(71143,'86029','P','Sun Valley','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.980645,-110.057212,0,'2013-07-06 12:44:34',NULL,NULL),(71067,'85775','U','Tucson Brm','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.215483,-110.970828,0,'2013-07-06 12:44:34',NULL,NULL),(31687,'34786','S','Windermere','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.501774,-81.530876,0,'2013-07-06 12:44:32',NULL,NULL),(17628,'18053','S','Germansville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.692506,-75.655145,0,'2013-07-06 12:44:31',NULL,NULL),(19371,'20058','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',39.023587,-77.138603,0,'2013-07-06 12:44:31',NULL,NULL),(65778,'78113','S','Falls City','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.931521,-98.063035,0,'2013-07-06 12:44:34',NULL,NULL),(60360,'71473','S','Friendship','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.067300,-92.422500,0,'2013-07-06 12:44:33',NULL,NULL),(17920,'18461','S','Starlight','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.918969,-75.320683,0,'2013-07-06 12:44:31',NULL,NULL),(32236,'35585','S','Spruce Pine','D','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.377968,-87.692749,0,'2013-07-06 12:44:32',NULL,NULL),(76673,'95776','S','Woodland','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.677422,-121.680298,0,'2013-07-06 12:44:34',NULL,NULL),(73109,'90250','S','Hawthorne','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.915300,-118.351309,0,'2013-07-06 12:44:34',NULL,NULL),(72218,'88427','S','Mc Alister','N','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.743064,-103.660694,0,'2013-07-06 12:44:34',NULL,NULL),(31565,'34613','S','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.556846,-82.518576,0,'2013-07-06 12:44:32',NULL,NULL),(48648,'55904','S','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.014040,-92.422764,0,'2013-07-06 12:44:33',NULL,NULL),(44881,'50315','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.544895,-93.615845,0,'2013-07-06 12:44:32',NULL,NULL),(24963,'27840','S','Hamilton','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.943055,-77.207183,0,'2013-07-06 12:44:31',NULL,NULL),(54544,'62885','S','Woodyard','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842965,-89.082598,0,'2013-07-06 12:44:33',NULL,NULL),(18288,'19014','S','Bridgewater Farms','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(78504,'98112','S','Madison Park','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.633515,-122.292981,0,'2013-07-06 12:44:34',NULL,NULL),(45781,'52159','S','Volney','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.049280,-91.388773,0,'2013-07-06 12:44:32',NULL,NULL),(65063,'77343','U','Tx State Prison','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722802,-95.548721,0,'2013-07-06 12:44:34',NULL,NULL),(64639,'76708','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.609500,-97.213440,0,'2013-07-06 12:44:34',NULL,NULL),(18143,'18834','S','New Milford','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.873819,-75.726137,0,'2013-07-06 12:44:31',NULL,NULL),(8390,'08060','S','Mount Holly','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(16665,'17355','P','Railroad','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.761150,-76.697707,0,'2013-07-06 12:44:31',NULL,NULL),(36251,'40312','S','Clay City','D','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.839660,-83.936520,0,'2013-07-06 12:44:32',NULL,NULL),(29880,'33042','S','Ltl Torch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(108,'00612','S','Urb Marisol','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(51892,'60097','S','Bull Valley','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.394351,-88.354139,0,'2013-07-06 12:44:33',NULL,NULL),(30880,'33685','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.000085,-82.583494,0,'2013-07-06 12:44:32',NULL,NULL),(29523,'32779','S','Longwood','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.705154,-81.420524,0,'2013-07-06 12:44:32',NULL,NULL),(2616,'00962','S','Catano','D','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(60945,'72099','U','LrAFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(798,'00693','S','Parc Amadeo','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(33299,'37130','S','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.870529,-86.341561,0,'2013-07-06 12:44:32',NULL,NULL),(4683,'03802','P','Portsmouth','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.078761,-70.757698,0,'2013-07-06 12:44:30',NULL,NULL),(22552,'24136','S','Pembroke','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.381014,-80.565458,0,'2013-07-06 12:44:31',NULL,NULL),(56160,'64863','S','South West City','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.510903,-94.612197,0,'2013-07-06 12:44:33',NULL,NULL),(21159,'22134','S','Quantico Naval Hospital','N','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.520589,-77.321006,0,'2013-07-06 12:44:31',NULL,NULL),(37905,'42633','S','Frazer','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(35514,'39533','P','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.396332,-88.884915,0,'2013-07-06 12:44:32',NULL,NULL),(67944,'80911','S','Widefield','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(5154,'04420','U','Maine Maritime Academy','N','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.394667,-68.789459,0,'2013-07-06 12:44:30',NULL,NULL),(80146,'99784','P','White Mtn','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.868292,-163.260686,0,'2013-07-06 12:44:34',NULL,NULL),(71374,'87002','S','Los Trujillos','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.656448,-106.759548,0,'2013-07-06 12:44:34',NULL,NULL),(76394,'95538','P','Crescent City','A','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.838225,-124.166415,0,'2013-07-06 12:44:34',NULL,NULL),(35355,'39440','S','Limbert','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(21476,'22641','S','Lebanon Ch','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.062322,-78.362403,0,'2013-07-06 12:44:31',NULL,NULL),(15867,'16948','S','Ulysses','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846520,-77.709720,0,'2013-07-06 12:44:31',NULL,NULL),(20601,'21205','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304502,-76.567527,0,'2013-07-06 12:44:31',NULL,NULL),(69887,'84103','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.783965,-111.876047,0,'2013-07-06 12:44:34',NULL,NULL),(78270,'97857','S','Lostine','D','Wallowa','41063','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.486867,-117.442480,0,'2013-07-06 12:44:34',NULL,NULL),(68666,'81654','S','Old Snowmass','N','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.286141,-106.979196,0,'2013-07-06 12:44:34',NULL,NULL),(40055,'45267','U','Univ Cinc Med Sciences','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.127931,-84.514462,0,'2013-07-06 12:44:32',NULL,NULL),(51800,'60047','S','Hawthorn Wds','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(29623,'32872','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.539939,-81.372604,0,'2013-07-06 12:44:32',NULL,NULL),(27148,'29824','S','Meeting Street','N','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.786960,-81.929623,0,'2013-07-06 12:44:31',NULL,NULL),(71205,'86303','S','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.534800,-112.469940,0,'2013-07-06 12:44:34',NULL,NULL),(8153,'07850','S','Landing','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.905169,-74.661651,0,'2013-07-06 12:44:30',NULL,NULL),(4147,'02763','S','Attleboro Falls','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.970895,-71.304600,0,'2013-07-06 12:44:30',NULL,NULL),(48347,'55479','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.986463,-93.266403,0,'2013-07-06 12:44:33',NULL,NULL),(23702,'25870','S','Pierpont','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.659608,-81.396162,0,'2013-07-06 12:44:31',NULL,NULL),(57209,'66434','S','Willis','A','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.854303,-95.534279,0,'2013-07-06 12:44:33',NULL,NULL),(55884,'64422','S','Amity','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.889120,-94.521091,0,'2013-07-06 12:44:33',NULL,NULL),(8179,'07878','P','Tabor','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.874494,-74.477334,0,'2013-07-06 12:44:30',NULL,NULL),(75581,'94285','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.552316,-121.500719,0,'2013-07-06 12:44:34',NULL,NULL),(64353,'76520','S','Cameron','D','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(58328,'68452','S','Ong','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.394395,-97.879427,0,'2013-07-06 12:44:33',NULL,NULL),(19713,'20390','U','Us Marine Corps Barracks','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884615,-76.993490,0,'2013-07-06 12:44:31',NULL,NULL),(36813,'41059','S','Campsprings','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.018300,-84.360480,0,'2013-07-06 12:44:32',NULL,NULL),(40686,'46067','P','Sedalia','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.415976,-86.515395,0,'2013-07-06 12:44:32',NULL,NULL),(41843,'47348','S','Roll','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(30343,'33311','S','Laud Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(25539,'28403','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.204361,-77.883608,0,'2013-07-06 12:44:31',NULL,NULL),(46352,'53098','S','Watertown','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.205791,-88.721802,0,'2013-07-06 12:44:32',NULL,NULL),(41891,'47371','S','Boundry','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(8509,'08099','P','Bellmawr','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.868757,-75.092255,0,'2013-07-06 12:44:30',NULL,NULL),(6858,'06129','P','Wethersfld','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.708586,-72.659766,0,'2013-07-06 12:44:30',NULL,NULL),(75660,'94536','S','Fremont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.562573,-121.997844,0,'2013-07-06 12:44:34',NULL,NULL),(77312,'96681','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(63789,'75956','S','Mount Union','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(6305,'05658','S','Lower Cabot','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.328420,-72.374820,0,'2013-07-06 12:44:30',NULL,NULL),(15325,'16210','S','Adrian','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.903141,-79.507012,0,'2013-07-06 12:44:31',NULL,NULL),(11775,'12204','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.676980,-73.737480,0,'2013-07-06 12:44:30',NULL,NULL),(55894,'64431','S','Clearmont','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.506061,-95.034696,0,'2013-07-06 12:44:33',NULL,NULL),(40715,'46118','S','Belleville','N','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.655558,-86.521037,0,'2013-07-06 12:44:32',NULL,NULL),(79407,'98813','S','Bridgeport','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.011747,-119.662504,0,'2013-07-06 12:44:34',NULL,NULL),(74837,'93240','S','Mountain Mesa','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.628560,-118.440370,0,'2013-07-06 12:44:34',NULL,NULL),(47053,'54414','S','Norrie','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.932433,-89.211831,0,'2013-07-06 12:44:32',NULL,NULL),(48895,'56117','S','Bigelow','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.541969,-95.630890,0,'2013-07-06 12:44:33',NULL,NULL),(79170,'98516','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.065090,-122.793039,0,'2013-07-06 12:44:34',NULL,NULL),(75439,'94043','S','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.405548,-122.078481,0,'2013-07-06 12:44:34',NULL,NULL),(69346,'83540','S','Spalding','A','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.404644,-116.807243,0,'2013-07-06 12:44:34',NULL,NULL),(41616,'47123','S','Grantsburg','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.285702,-86.472108,0,'2013-07-06 12:44:32',NULL,NULL),(29838,'33032','S','Naranja','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526149,-80.406867,0,'2013-07-06 12:44:32',NULL,NULL),(54379,'62812','S','Rend City','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(53816,'62298','S','Floraville','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(50170,'57553','S','Billsburg','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.417024,-101.804790,0,'2013-07-06 12:44:33',NULL,NULL),(50407,'57779','S','Saint Onge','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.561575,-103.748203,0,'2013-07-06 12:44:33',NULL,NULL),(5241,'04472','S','Orland','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.535543,-68.744414,0,'2013-07-06 12:44:30',NULL,NULL),(49902,'57276','S','White','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.385480,-96.626520,0,'2013-07-06 12:44:33',NULL,NULL),(55589,'63933','S','Campbell','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.495590,-90.070204,0,'2013-07-06 12:44:33',NULL,NULL),(60461,'71653','S','Panther Forest','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(47656,'54935','S','Fond du Lac','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.775242,-88.431561,0,'2013-07-06 12:44:33',NULL,NULL),(58595,'68846','S','Hordville','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.084527,-97.890303,0,'2013-07-06 12:44:33',NULL,NULL),(58588,'68840','S','Lowell','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.745127,-98.841582,0,'2013-07-06 12:44:33',NULL,NULL),(50335,'57735','S','Ardmore','A','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(29709,'32949','S','Grant','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.925540,-80.531790,0,'2013-07-06 12:44:32',NULL,NULL),(6200,'05483','S','Sheldon Junction','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(838,'00698','S','Bda Las Delicias','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(6015,'05362','S','Williamsville','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.947772,-72.659172,0,'2013-07-06 12:44:30',NULL,NULL),(22265,'23691','S','Yorktown Naval Weapons Stati','N','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.244023,-76.551905,0,'2013-07-06 12:44:31',NULL,NULL),(22233,'23608','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.143493,-76.539049,0,'2013-07-06 12:44:31',NULL,NULL),(44546,'50005','S','Albion','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.121073,-93.013180,0,'2013-07-06 12:44:32',NULL,NULL),(48395,'55583','P','Norwood','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.760954,-93.940513,0,'2013-07-06 12:44:33',NULL,NULL),(59489,'70763','S','Paulina','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.078087,-90.771139,0,'2013-07-06 12:44:33',NULL,NULL),(60226,'71429','S','Gandy Spur','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.562771,-93.478790,0,'2013-07-06 12:44:33',NULL,NULL),(67338,'80102','S','Bennett','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.751155,-104.448047,0,'2013-07-06 12:44:34',NULL,NULL),(32937,'36567','S','Gateswood','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.569400,-87.630720,0,'2013-07-06 12:44:32',NULL,NULL),(75754,'94612','S','Philatelic Center','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.812882,-122.269830,0,'2013-07-06 12:44:34',NULL,NULL),(59980,'71326','S','Clayton','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.746480,-91.495320,0,'2013-07-06 12:44:33',NULL,NULL),(73151,'90291','S','Playa del Rey','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.993348,-118.465075,0,'2013-07-06 12:44:34',NULL,NULL),(79429,'98829','P','Malott','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.283254,-119.800422,0,'2013-07-06 12:44:34',NULL,NULL),(33810,'37917','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.995236,-83.917073,0,'2013-07-06 12:44:32',NULL,NULL),(80142,'99781','P','Venetie','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',67.012334,-146.413119,0,'2013-07-06 12:44:34',NULL,NULL),(74262,'92341','P','Green Vly Lk','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.241861,-117.075564,0,'2013-07-06 12:44:34',NULL,NULL),(56041,'64722','S','Amoret','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.270029,-94.560921,0,'2013-07-06 12:44:33',NULL,NULL),(45810,'52202','S','Alburnett','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.155886,-91.632063,0,'2013-07-06 12:44:32',NULL,NULL),(16702,'17402','S','Spry','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(42814,'48059','S','Burtchville Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(14123,'14647','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157199,-77.608041,0,'2013-07-06 12:44:31',NULL,NULL),(73644,'91482','U','Deluxe Check','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201021,-118.475212,0,'2013-07-06 12:44:34',NULL,NULL),(73831,'91775','S','San Gabriel','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.112605,-118.089861,0,'2013-07-06 12:44:34',NULL,NULL),(39134,'44272','S','Rootstown','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.097130,-81.216588,0,'2013-07-06 12:44:32',NULL,NULL),(7803,'07438','S','Lake Swannanoa','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.033460,-74.499840,0,'2013-07-06 12:44:30',NULL,NULL),(20460,'21028','S','Churchville','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.563049,-76.246709,0,'2013-07-06 12:44:31',NULL,NULL),(10989,'11548','S','East Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(46217,'52768','S','Princeton','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.685749,-90.382646,0,'2013-07-06 12:44:32',NULL,NULL),(14076,'14609','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.174537,-77.559782,0,'2013-07-06 12:44:31',NULL,NULL),(35798,'39754','P','Montpelier','D','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.715811,-88.948250,0,'2013-07-06 12:44:32',NULL,NULL),(59404,'70638','P','Elizabeth','D','Allen','22003','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.894266,-92.789657,0,'2013-07-06 12:44:33',NULL,NULL),(64534,'76644','P','Laguna Park','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.858882,-97.376822,0,'2013-07-06 12:44:34',NULL,NULL),(68459,'81231','U','Gunnison','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.548638,-106.918609,0,'2013-07-06 12:44:34',NULL,NULL),(6019,'05363','S','Wilmington','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.883215,-72.898726,0,'2013-07-06 12:44:30',NULL,NULL),(4597,'03584','S','Northumberland','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.488551,-71.567367,0,'2013-07-06 12:44:30',NULL,NULL),(74823,'93224','S','Fellows','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.205777,-119.553998,0,'2013-07-06 12:44:34',NULL,NULL),(75673,'94547','S','Rodeo','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',38.011358,-122.262961,0,'2013-07-06 12:44:34',NULL,NULL),(79756,'99260','U','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.663463,-117.422938,0,'2013-07-06 12:44:34',NULL,NULL),(58834,'69120','S','Cliff','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.425135,-100.195601,0,'2013-07-06 12:44:33',NULL,NULL),(79768,'99328','S','Dayton','D','Columbia','53013','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.325060,-117.974038,0,'2013-07-06 12:44:34',NULL,NULL),(73882,'91946','P','Lemon Grove','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.742494,-117.032654,0,'2013-07-06 12:44:34',NULL,NULL),(27885,'30457','S','Soperton','D','Treutlen','13283','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.375542,-82.593391,0,'2013-07-06 12:44:31',NULL,NULL),(21506,'22712','S','Bealeton','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.574480,-77.800680,0,'2013-07-06 12:44:31',NULL,NULL),(24099,'26508','S','Cheat Lake','N','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.589081,-79.896108,0,'2013-07-06 12:44:31',NULL,NULL),(440,'00662','S','Urb Domenech','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(26449,'29137','S','Berlin','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.637039,-81.295434,0,'2013-07-06 12:44:31',NULL,NULL),(18027,'18643','S','West Pittston','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.328885,-75.815364,0,'2013-07-06 12:44:31',NULL,NULL),(45686,'52045','S','Epworth','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.440820,-90.928680,0,'2013-07-06 12:44:32',NULL,NULL),(41898,'47371','S','New Mount Pleasant','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(34412,'38631','P','Friars Point','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.359895,-90.635937,0,'2013-07-06 12:44:32',NULL,NULL),(38344,'43440','S','Lakeside Marblehead','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531235,-82.759429,0,'2013-07-06 12:44:32',NULL,NULL),(44215,'49639','S','Hersey','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.852028,-85.409839,0,'2013-07-06 12:44:32',NULL,NULL),(13342,'13690','S','Benson Mines','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.153984,-75.029510,0,'2013-07-06 12:44:30',NULL,NULL),(54798,'63016','S','Cedar Hill','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.352981,-90.644798,0,'2013-07-06 12:44:33',NULL,NULL),(20376,'20882','S','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.215201,-77.141552,0,'2013-07-06 12:44:31',NULL,NULL),(17540,'17976','S','Shaft','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(26674,'29402','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.774463,-79.930662,0,'2013-07-06 12:44:31',NULL,NULL),(70005,'84124','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.685813,-111.829118,0,'2013-07-06 12:44:34',NULL,NULL),(77523,'96844','U','University of Hawaii','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.295954,-157.813874,0,'2013-07-06 12:44:34',NULL,NULL),(24315,'27019','S','Germanton','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.245275,-80.223445,0,'2013-07-06 12:44:31',NULL,NULL),(67071,'79567','S','Pumphrey','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(16901,'17584','S','Baumgardner','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.962325,-76.274759,0,'2013-07-06 12:44:31',NULL,NULL),(25259,'28119','S','Morven','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',34.944771,-80.142387,0,'2013-07-06 12:44:31',NULL,NULL),(19735,'20403','U','GPO Field Serv Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.888390,-77.015989,0,'2013-07-06 12:44:31',NULL,NULL),(7087,'06351','S','Hopeville','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.601907,-71.977075,0,'2013-07-06 12:44:30',NULL,NULL),(53650,'62205','S','Centreville','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(77619,'96952','P','Tinian Mariana Islands','N','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',15.081686,145.652262,0,'2013-07-06 12:44:34',NULL,NULL),(78629,'98207','U','Naval Station Everett','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.959977,-122.196827,0,'2013-07-06 12:44:34',NULL,NULL),(28173,'30999','U','Railroad Retirement Board','N','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.456177,-81.991838,0,'2013-07-06 12:44:31',NULL,NULL),(50828,'58474','S','Guelph','A','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.133520,-98.100180,0,'2013-07-06 12:44:33',NULL,NULL),(75663,'94539','S','Fremont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.517314,-121.929678,0,'2013-07-06 12:44:34',NULL,NULL),(74549,'92675','S','San Juan Capistrano','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.508513,-117.656472,0,'2013-07-06 12:44:34',NULL,NULL),(69266,'83433','P','Macks Inn','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.499167,-111.336944,0,'2013-07-06 12:44:34',NULL,NULL),(61527,'72666','S','Parthenon','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.938050,-93.282571,0,'2013-07-06 12:44:33',NULL,NULL),(41225,'46733','S','Sunny Acres','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(46537,'53403','S','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.704176,-87.806580,0,'2013-07-06 12:44:32',NULL,NULL),(79278,'98577','S','Firdale','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(10080,'10199','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(27937,'30528','S','Cleveland','D','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.626813,-83.804069,0,'2013-07-06 12:44:31',NULL,NULL),(37714,'42274','S','Blue Level','N','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.951025,-86.601859,0,'2013-07-06 12:44:32',NULL,NULL),(46976,'54216','S','Kewaunee','D','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.451161,-87.514802,0,'2013-07-06 12:44:32',NULL,NULL),(23640,'25774','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.419544,-82.475337,0,'2013-07-06 12:44:31',NULL,NULL),(22319,'23843','S','Dolphin','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.835688,-77.794255,0,'2013-07-06 12:44:31',NULL,NULL),(13833,'14220','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.833786,-78.797770,0,'2013-07-06 12:44:31',NULL,NULL),(21642,'22924','P','Batesville','D','Albemarle','51003','Virginia','VA','51','1540','540','Eastern',-5.0,'Y',37.995648,-78.720211,0,'2013-07-06 12:44:31',NULL,NULL),(16065,'17048','S','Lykens','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.595220,-76.713900,0,'2013-07-06 12:44:31',NULL,NULL),(78458,'98070','S','Dockton','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.418180,-122.451780,0,'2013-07-06 12:44:34',NULL,NULL),(68267,'81071','S','Sheridan Lake','D','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.446999,-102.218718,0,'2013-07-06 12:44:34',NULL,NULL),(59881,'71269','S','Holly Ridge','A','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(34281,'38481','S','Saint Joseph','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.039736,-87.505697,0,'2013-07-06 12:44:32',NULL,NULL),(4046,'02633','S','Chatham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.685340,-69.979668,0,'2013-07-06 12:44:30',NULL,NULL),(47472,'54741','S','Fairchild','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.599672,-90.960257,0,'2013-07-06 12:44:32',NULL,NULL),(14729,'15283','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.422089,-80.046367,0,'2013-07-06 12:44:31',NULL,NULL),(27315,'30024','S','Johns Creek','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.062747,-84.083283,0,'2013-07-06 12:44:31',NULL,NULL),(24623,'27351','P','Southmont','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.670001,-80.268009,0,'2013-07-06 12:44:31',NULL,NULL),(55269,'63462','S','Perry','D','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.429064,-91.669127,0,'2013-07-06 12:44:33',NULL,NULL),(75481,'94117','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.770561,-122.441545,0,'2013-07-06 12:44:34',NULL,NULL),(72310,'88595','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769906,-106.428276,0,'2013-07-06 12:44:34',NULL,NULL),(61807,'73101','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.490436,-97.560145,0,'2013-07-06 12:44:33',NULL,NULL),(41638,'47132','U','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287784,-85.731015,0,'2013-07-06 12:44:32',NULL,NULL),(11076,'11598','S','Woodsburgh','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.633418,-73.714284,0,'2013-07-06 12:44:30',NULL,NULL),(10770,'11364','S','Oakland Gardens','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(75150,'93561','S','Stallion Springs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(33359,'37187','S','White Bluff','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.117237,-87.228213,0,'2013-07-06 12:44:32',NULL,NULL),(75927,'95015','P','Cupertino','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.322857,-122.052958,0,'2013-07-06 12:44:34',NULL,NULL),(7299,'06540','U','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310015,-72.921458,0,'2013-07-06 12:44:30',NULL,NULL),(30226,'33188','U','Florida Power & Light Co','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.814728,-80.240372,0,'2013-07-06 12:44:32',NULL,NULL),(16459,'17241','S','Doubling Gap','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(58939,'69353','P','Mc Grew','N','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.785535,-103.681149,0,'2013-07-06 12:44:33',NULL,NULL),(54,'00610','S','Brisas de Anasco','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(62192,'73770','S','Southard','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.075847,-98.456345,0,'2013-07-06 12:44:33',NULL,NULL),(59154,'70186','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.004149,-90.001369,0,'2013-07-06 12:44:33',NULL,NULL),(69192,'83342','S','Elba','A','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.305271,-113.370505,0,'2013-07-06 12:44:34',NULL,NULL),(18880,'19457','P','Parkerford','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.205934,-75.592107,0,'2013-07-06 12:44:31',NULL,NULL),(41867,'47359','S','McNatts','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.553124,-85.277033,0,'2013-07-06 12:44:32',NULL,NULL),(29863,'33040','S','E Rockland Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(6545,'05841','S','Greensboro','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.582214,-72.297887,0,'2013-07-06 12:44:30',NULL,NULL),(43791,'49050','S','Dowling','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.497608,-85.241437,0,'2013-07-06 12:44:32',NULL,NULL),(10143,'10271','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706437,-74.006835,0,'2013-07-06 12:44:30',NULL,NULL),(26536,'29203','S','Lincolnshire','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(77486,'96823','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.307300,-157.844392,0,'2013-07-06 12:44:34',NULL,NULL),(4529,'03431','S','Surry','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.938975,-72.285756,0,'2013-07-06 12:44:30',NULL,NULL),(70067,'84147','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758841,-111.883105,0,'2013-07-06 12:44:34',NULL,NULL),(64193,'76244','S','Keller','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.934024,-97.250604,0,'2013-07-06 12:44:34',NULL,NULL),(45287,'50702','S','Washburn','A','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.470074,-92.327921,0,'2013-07-06 12:44:32',NULL,NULL),(55038,'63138','S','Spanish Lake','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.795220,-90.209040,0,'2013-07-06 12:44:33',NULL,NULL),(54337,'62764','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.757628,-89.635423,0,'2013-07-06 12:44:33',NULL,NULL),(49054,'56302','P','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.560955,-94.164449,0,'2013-07-06 12:44:33',NULL,NULL),(9804,'10110','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(38859,'44095','S','Timberlake','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.654810,-81.440913,0,'2013-07-06 12:44:32',NULL,NULL),(46990,'54234','S','Sister Bay','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.189269,-87.114286,0,'2013-07-06 12:44:32',NULL,NULL),(56242,'65049','S','Village of Four Seasons','A','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.200554,-92.711201,0,'2013-07-06 12:44:33',NULL,NULL),(79390,'98687','P','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.629189,-122.517536,0,'2013-07-06 12:44:34',NULL,NULL),(74791,'93150','P','Montecito','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.434711,-119.632112,0,'2013-07-06 12:44:34',NULL,NULL),(62786,'74880','S','Clearview','A','Okfuskee','40107','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.334178,-96.130338,0,'2013-07-06 12:44:33',NULL,NULL),(47163,'54472','U','Marshfield','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.662245,-90.175187,0,'2013-07-06 12:44:32',NULL,NULL),(32833,'36473','S','Range','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.308807,-87.306658,0,'2013-07-06 12:44:32',NULL,NULL),(28479,'31513','S','Graham','N','Appling','13001','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.772585,-82.351151,0,'2013-07-06 12:44:32',NULL,NULL),(25113,'27980','S','Tyner','D','Chowan','37041','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.254002,-76.634013,0,'2013-07-06 12:44:31',NULL,NULL),(51495,'59632','S','Boulder','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.202844,-112.081611,0,'2013-07-06 12:44:33',NULL,NULL),(61293,'72413','S','Biggers','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.241727,-90.960054,0,'2013-07-06 12:44:33',NULL,NULL),(75448,'94062','S','Woodside','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.448337,-122.268736,0,'2013-07-06 12:44:34',NULL,NULL),(41061,'46507','S','Bristol','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.721113,-85.827423,0,'2013-07-06 12:44:32',NULL,NULL),(19318,'20018','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.927297,-76.975967,0,'2013-07-06 12:44:31',NULL,NULL),(58952,'69365','P','Whiteclay','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.996520,-102.555710,0,'2013-07-06 12:44:33',NULL,NULL),(36242,'40296','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.257669,-85.757548,0,'2013-07-06 12:44:32',NULL,NULL),(14271,'14850','S','Ithaca Coll','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.445573,-76.496428,0,'2013-07-06 12:44:31',NULL,NULL),(54596,'62905','S','Alto Pass','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.557050,-89.339650,0,'2013-07-06 12:44:33',NULL,NULL),(47308,'54554','S','Phelps','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.063958,-89.069360,0,'2013-07-06 12:44:32',NULL,NULL),(56221,'65039','S','Hartsburg','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.729430,-92.304428,0,'2013-07-06 12:44:33',NULL,NULL),(6309,'05660','S','No Fayston','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.252162,-72.748572,0,'2013-07-06 12:44:30',NULL,NULL),(49708,'57034','S','Moe','N','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.130420,-96.455230,0,'2013-07-06 12:44:33',NULL,NULL),(40751,'46140','S','Spring Lake','A','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.794852,-85.791522,0,'2013-07-06 12:44:32',NULL,NULL),(18525,'19107','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.948927,-75.158663,0,'2013-07-06 12:44:31',NULL,NULL),(22745,'24402','P','Staunton','D','Staunton City','51790','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.163217,-79.066886,0,'2013-07-06 12:44:31',NULL,NULL),(32184,'35491','P','West Greene','D','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.923389,-88.088523,0,'2013-07-06 12:44:32',NULL,NULL),(31802,'35045','S','Clanton','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.839154,-86.630913,0,'2013-07-06 12:44:32',NULL,NULL),(23994,'26338','S','Camden','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.097849,-80.609130,0,'2013-07-06 12:44:31',NULL,NULL),(36471,'40743','P','London','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.129167,-84.082336,0,'2013-07-06 12:44:32',NULL,NULL),(65299,'77491','P','Park Row','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.786079,-95.820840,0,'2013-07-06 12:44:34',NULL,NULL),(75647,'94526','S','Danville','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.818542,-121.969476,0,'2013-07-06 12:44:34',NULL,NULL),(13851,'14226','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.969504,-78.798576,0,'2013-07-06 12:44:31',NULL,NULL),(45778,'52158','P','Marquette','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.061141,-91.217446,0,'2013-07-06 12:44:32',NULL,NULL),(50322,'57725','S','Caputa','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.974300,-102.959160,0,'2013-07-06 12:44:33',NULL,NULL),(27389,'30083','S','St Mtn','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.789125,-84.199181,0,'2013-07-06 12:44:31',NULL,NULL),(3849,'02347','S','Lakeville','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.831559,-70.953643,0,'2013-07-06 12:44:30',NULL,NULL),(8479,'08092','S','Eagleswood Township','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.653280,-74.280720,0,'2013-07-06 12:44:30',NULL,NULL),(57499,'66946','S','Hollenberg','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.955656,-96.972145,0,'2013-07-06 12:44:33',NULL,NULL),(61631,'72837','S','Dover','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.371485,-93.116823,0,'2013-07-06 12:44:33',NULL,NULL),(79106,'98464','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225450,-122.537309,0,'2013-07-06 12:44:34',NULL,NULL),(62118,'73650','S','Hammon','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.688205,-99.473097,0,'2013-07-06 12:44:33',NULL,NULL),(51935,'60123','S','Elgin','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.040703,-88.311045,0,'2013-07-06 12:44:33',NULL,NULL),(44110,'49505','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.010412,-85.625219,0,'2013-07-06 12:44:32',NULL,NULL),(40712,'46115','S','Carthage','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.732645,-85.570001,0,'2013-07-06 12:44:32',NULL,NULL),(33598,'37616','S','Afton','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.188867,-82.702767,0,'2013-07-06 12:44:32',NULL,NULL),(78020,'97420','S','Coos Head Naval Facility','N','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.332900,-124.233900,0,'2013-07-06 12:44:34',NULL,NULL),(66722,'78953','S','String Prairie','N','Bastrop','48021','Texas','TX','48','0640','830','Central',-6.0,'Y',29.881875,-97.323178,0,'2013-07-06 12:44:34',NULL,NULL),(24884,'27702','P','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.052515,-78.879485,0,'2013-07-06 12:44:31',NULL,NULL),(75387,'93950','S','Pacific Grove','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.616554,-121.921728,0,'2013-07-06 12:44:34',NULL,NULL),(72083,'88135','S','Texico','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.384860,-103.058640,0,'2013-07-06 12:44:34',NULL,NULL),(4232,'02858','S','Oakland','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.962823,-71.645043,0,'2013-07-06 12:44:30',NULL,NULL),(23090,'24918','S','Ballard','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.512562,-80.758132,0,'2013-07-06 12:44:31',NULL,NULL),(67512,'80241','S','Denver','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.928789,-104.945551,0,'2013-07-06 12:44:34',NULL,NULL),(42983,'48145','S','La Salle','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.847942,-83.455270,0,'2013-07-06 12:44:32',NULL,NULL),(7201,'06481','S','Rockfall','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.533167,-72.700542,0,'2013-07-06 12:44:30',NULL,NULL),(10515,'10977','S','Kaser','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(10159,'10278','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(74216,'92310','S','Barstow','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.343124,-116.617236,0,'2013-07-06 12:44:34',NULL,NULL),(50572,'58223','S','Cummings','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.543956,-96.976085,0,'2013-07-06 12:44:33',NULL,NULL),(56866,'66014','S','Centerville','D','Anderson','20003','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.211339,-94.986151,0,'2013-07-06 12:44:33',NULL,NULL),(27198,'29902','S','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.447460,-80.708640,0,'2013-07-06 12:44:31',NULL,NULL),(38019,'43011','S','Centerburg','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.307025,-82.669574,0,'2013-07-06 12:44:32',NULL,NULL),(20106,'20708','S','Montpelier','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.061389,-76.851111,0,'2013-07-06 12:44:31',NULL,NULL),(69211,'83354','P','Elk Horn','A','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.726589,-114.262377,0,'2013-07-06 12:44:34',NULL,NULL),(77970,'97375','S','Scotts Mills','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.005656,-122.641838,0,'2013-07-06 12:44:34',NULL,NULL),(5477,'04743','S','Fort Kent','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.251669,-68.593437,0,'2013-07-06 12:44:30',NULL,NULL),(28319,'31144','U','N Amercn Mbrshp Grp Brm','N','Cobb','13067','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',34.023650,-84.615540,0,'2013-07-06 12:44:31',NULL,NULL),(39867,'45203','S','Queen City','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.101841,-84.529638,0,'2013-07-06 12:44:32',NULL,NULL),(48393,'55581','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.279386,-93.806546,0,'2013-07-06 12:44:33',NULL,NULL),(2544,'00959','S','Jard de Caparra','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(27644,'30319','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.875460,-84.333398,0,'2013-07-06 12:44:31',NULL,NULL),(74055,'92155','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.674947,-117.160830,0,'2013-07-06 12:44:34',NULL,NULL),(3433,'01746','S','Holliston','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.198796,-71.435066,0,'2013-07-06 12:44:30',NULL,NULL),(20876,'21676','S','Wittman','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.798765,-76.283498,0,'2013-07-06 12:44:31',NULL,NULL),(17563,'17983','S','Valley View','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.646385,-76.546473,0,'2013-07-06 12:44:31',NULL,NULL),(45894,'52307','P','Middle Amana','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.800087,-91.895779,0,'2013-07-06 12:44:32',NULL,NULL),(24665,'27407','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.012660,-79.869960,0,'2013-07-06 12:44:31',NULL,NULL),(21279,'22315','S','Franconia','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.784480,-77.125200,0,'2013-07-06 12:44:31',NULL,NULL),(53221,'61634','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.691385,-89.588711,0,'2013-07-06 12:44:33',NULL,NULL),(50106,'57476','S','Tulare','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.718766,-98.584758,0,'2013-07-06 12:44:33',NULL,NULL),(63561,'75770','S','Larue','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.149920,-95.613600,0,'2013-07-06 12:44:34',NULL,NULL),(14971,'15632','S','Export','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.430536,-79.608959,0,'2013-07-06 12:44:31',NULL,NULL),(14439,'15088','P','West Elizabeth','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.272744,-79.895350,0,'2013-07-06 12:44:31',NULL,NULL),(53764,'62266','P','New Memphis','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.476425,-89.676827,0,'2013-07-06 12:44:33',NULL,NULL),(7718,'07195','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.729819,-74.175366,0,'2013-07-06 12:44:30',NULL,NULL),(50815,'58463','S','Mc Clusky','N','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.483889,-100.443661,0,'2013-07-06 12:44:33',NULL,NULL),(10335,'10551','P','Mount Vernon','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.901727,-73.823937,0,'2013-07-06 12:44:30',NULL,NULL),(18085,'18706','S','Sugar Notch','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(28177,'31004','P','Bolingbroke','D','Monroe','13207','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.085895,-83.921131,0,'2013-07-06 12:44:31',NULL,NULL),(58909,'69220','S','Sparks','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.938895,-100.259960,0,'2013-07-06 12:44:33',NULL,NULL),(71676,'87509','U','New Mexico Tax Rev Dept','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.673194,-105.954437,0,'2013-07-06 12:44:34',NULL,NULL),(71574,'87310','P','Brimhall','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.809225,-108.576279,0,'2013-07-06 12:44:34',NULL,NULL),(59091,'70123','S','River Ridge','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.956536,-90.207527,0,'2013-07-06 12:44:33',NULL,NULL),(19993,'20602','S','Saint Charles','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.603056,-76.938889,0,'2013-07-06 12:44:31',NULL,NULL),(10589,'11024','S','Kenilworth','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.804080,-73.740120,0,'2013-07-06 12:44:30',NULL,NULL),(32410,'35966','S','Flat Rock','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.807624,-85.728970,0,'2013-07-06 12:44:32',NULL,NULL),(2665,'00966','S','Urb Sevilla Biltmore','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(52203,'60478','S','Cntry Clb Hls','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.559523,-87.722149,0,'2013-07-06 12:44:33',NULL,NULL),(8409,'08069','S','Carneys Point','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.707040,-75.446700,0,'2013-07-06 12:44:30',NULL,NULL),(32780,'36420','S','Babbie','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(978,'00716','S','Valle Verde','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(24680,'27410','S','Guilford College','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(53015,'61462','S','Monmouth','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.855000,-90.613056,0,'2013-07-06 12:44:33',NULL,NULL),(74580,'92692','S','San Juan Capistrano','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.614433,-117.643273,0,'2013-07-06 12:44:34',NULL,NULL),(68738,'82210','S','Diamond','A','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.728605,-104.847774,0,'2013-07-06 12:44:34',NULL,NULL),(15086,'15756','P','McIntyre','N','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.569874,-79.299788,0,'2013-07-06 12:44:31',NULL,NULL),(39762,'45115','P','Decatur','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.812180,-83.697339,0,'2013-07-06 12:44:32',NULL,NULL),(43472,'48557','U','GM Tech Center','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.987118,-83.679301,0,'2013-07-06 12:44:32',NULL,NULL),(43552,'48710','U','Univ Ctr','A','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.561826,-83.987515,0,'2013-07-06 12:44:32',NULL,NULL),(51695,'60002','S','Old Mill Creek','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.468500,-88.109296,0,'2013-07-06 12:44:33',NULL,NULL),(18380,'19047','S','Hulmeville','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.179301,-74.905397,0,'2013-07-06 12:44:31',NULL,NULL),(53563,'62052','S','Otter Creek','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.135780,-90.333000,0,'2013-07-06 12:44:33',NULL,NULL),(11766,'12198','S','Wynantskill','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.672720,-73.641840,0,'2013-07-06 12:44:30',NULL,NULL),(44857,'50276','S','Moran','N','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.851937,-93.924289,0,'2013-07-06 12:44:32',NULL,NULL),(78373,'98022','S','Greenwater','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(29546,'32803','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.558279,-81.357567,0,'2013-07-06 12:44:32',NULL,NULL),(47782,'55043','S','St Croix Beach','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(25949,'28657','S','Frank','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(18520,'19105','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952879,-75.157935,0,'2013-07-06 12:44:31',NULL,NULL),(17605,'18041','S','East Greenville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.415749,-75.510509,0,'2013-07-06 12:44:31',NULL,NULL),(21851,'23139','S','Powhatand','N','Powhatan','51145','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544219,-77.877814,0,'2013-07-06 12:44:31',NULL,NULL),(77104,'96142','P','Meeks Bay','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.063924,-120.138469,0,'2013-07-06 12:44:34',NULL,NULL),(13023,'13426','P','Orwell','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.560573,-75.993101,0,'2013-07-06 12:44:30',NULL,NULL),(29480,'32727','P','Eustis','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.831384,-81.656911,0,'2013-07-06 12:44:32',NULL,NULL),(10568,'11020','S','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(45536,'51449','S','Lake City','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.271354,-94.735241,0,'2013-07-06 12:44:32',NULL,NULL),(50235,'57621','P','Bullhead','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.910278,-101.090000,0,'2013-07-06 12:44:33',NULL,NULL),(34439,'38649','P','Holly Springs','A','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.737265,-89.500427,0,'2013-07-06 12:44:32',NULL,NULL),(43400,'48446','S','Lake Nepessing','N','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.056009,-83.327865,0,'2013-07-06 12:44:32',NULL,NULL),(40009,'45245','S','Withamsville','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.069523,-84.277672,0,'2013-07-06 12:44:32',NULL,NULL),(39521,'44818','S','Lykens','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.013780,-82.990920,0,'2013-07-06 12:44:32',NULL,NULL),(32516,'36083','S','Veterans Admin. Fac.','N','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.427623,-85.690804,0,'2013-07-06 12:44:32',NULL,NULL),(42182,'47537','S','Gentryville','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.218070,-86.862317,0,'2013-07-06 12:44:32',NULL,NULL),(63802,'75962','U','S F A','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(64384,'76531','S','Indian Gap','N','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.664240,-98.413570,0,'2013-07-06 12:44:34',NULL,NULL),(22257,'23670','P','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.056273,-76.412388,0,'2013-07-06 12:44:31',NULL,NULL),(51680,'59927','P','Olney','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.542035,-114.572329,0,'2013-07-06 12:44:33',NULL,NULL),(28964,'32204','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.326112,-81.680064,0,'2013-07-06 12:44:32',NULL,NULL),(3416,'01719','S','Boxboro','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.484999,-71.518519,0,'2013-07-06 12:44:30',NULL,NULL),(15069,'15737','P','Elmora','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.600755,-78.747979,0,'2013-07-06 12:44:31',NULL,NULL),(776,'00692','S','Villa Linares','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(8410,'08069','S','Carneys Point Township','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.707040,-75.446700,0,'2013-07-06 12:44:30',NULL,NULL),(61965,'73178','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.535490,-97.567572,0,'2013-07-06 12:44:33',NULL,NULL),(52710,'61115','S','Machesney Park','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.354402,-89.040130,0,'2013-07-06 12:44:33',NULL,NULL),(73173,'90309','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.973424,-118.357069,0,'2013-07-06 12:44:34',NULL,NULL),(68313,'81101','S','Washington','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(58852,'69140','S','Grant','D','Perkins','31135','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.861020,-101.708400,0,'2013-07-06 12:44:33',NULL,NULL),(33192,'37036','S','Charlotte','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.236488,-87.261716,0,'2013-07-06 12:44:32',NULL,NULL),(48245,'55423','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.876412,-93.286850,0,'2013-07-06 12:44:33',NULL,NULL),(42028,'47438','S','Buchanan Corner','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(30750,'33558','S','Lutz','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.157052,-82.520763,0,'2013-07-06 12:44:32',NULL,NULL),(16938,'17701','S','Barbours','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(28774,'32034','S','Amelia Island','A','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.636954,-81.461340,0,'2013-07-06 12:44:32',NULL,NULL),(22770,'24442','S','Head Waters','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.300394,-79.425747,0,'2013-07-06 12:44:31',NULL,NULL),(7536,'07007','P','Caldwell','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.840833,-74.302222,0,'2013-07-06 12:44:30',NULL,NULL),(7690,'07105','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.722140,-74.140998,0,'2013-07-06 12:44:30',NULL,NULL),(39039,'44146','S','Walton Hills','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(72901,'90021','S','Market','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.027564,-118.241023,0,'2013-07-06 12:44:34',NULL,NULL),(4599,'03585','S','Lisbon','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.210565,-71.903972,0,'2013-07-06 12:44:30',NULL,NULL),(54385,'62816','S','Nason','A','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.196392,-88.939503,0,'2013-07-06 12:44:33',NULL,NULL),(23083,'24901','S','Lewisburg','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.800670,-80.437878,0,'2013-07-06 12:44:31',NULL,NULL),(28312,'31136','U','Newgistics','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.720331,-84.525484,0,'2013-07-06 12:44:31',NULL,NULL),(18540,'19112','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.890037,-75.176966,0,'2013-07-06 12:44:31',NULL,NULL),(9496,'10013','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(16713,'17404','S','Shiloh','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.971839,-76.774584,0,'2013-07-06 12:44:31',NULL,NULL),(78668,'98236','S','Clinton','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.959500,-122.402110,0,'2013-07-06 12:44:34',NULL,NULL),(64687,'76837','S','Eden','D','Concho','48095','Texas','TX','48','0000','325','Central',-6.0,'Y',31.213843,-99.833002,0,'2013-07-06 12:44:34',NULL,NULL),(34701,'38829','S','Old Cairo','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(35033,'39165','P','Sibley','D','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.385954,-91.406023,0,'2013-07-06 12:44:32',NULL,NULL),(46197,'52751','S','Grand Mound','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.844423,-90.677731,0,'2013-07-06 12:44:32',NULL,NULL),(16377,'17202','S','Chambersburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.941877,-77.673910,0,'2013-07-06 12:44:31',NULL,NULL),(65517,'77706','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.094918,-94.167107,0,'2013-07-06 12:44:34',NULL,NULL),(68716,'82071','P','University of Wyoming','N','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.422527,-105.607196,0,'2013-07-06 12:44:34',NULL,NULL),(69898,'84106','S','S Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(75454,'94074','S','San Gregorio','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.297693,-122.364423,0,'2013-07-06 12:44:34',NULL,NULL),(52240,'60510','S','Batavia','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.845761,-88.310660,0,'2013-07-06 12:44:33',NULL,NULL),(27118,'29734','S','Rock Hill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.886025,-81.022063,0,'2013-07-06 12:44:31',NULL,NULL),(7777,'07421','S','Awosting','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.157420,-74.352660,0,'2013-07-06 12:44:30',NULL,NULL),(2221,'00926','S','Urb Cupey Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(36001,'40145','S','Hudson','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.606684,-86.318269,0,'2013-07-06 12:44:32',NULL,NULL),(18486,'19089','U','Radnor','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.045461,-75.387632,0,'2013-07-06 12:44:31',NULL,NULL),(73894,'91980','S','Tecate','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.587669,-116.662648,0,'2013-07-06 12:44:34',NULL,NULL),(51866,'60081','S','Spring Grove','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.437393,-88.225911,0,'2013-07-06 12:44:33',NULL,NULL),(79839,'99529','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.151491,-149.944301,0,'2013-07-06 12:44:34',NULL,NULL),(73447,'91301','S','Cornell','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(63475,'75686','S','Pine','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(1997,'00909','S','Urb Hipodromo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(44649,'50099','S','Boone','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.056411,-93.879522,0,'2013-07-06 12:44:32',NULL,NULL),(49311,'56541','P','Flom','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.167634,-96.129210,0,'2013-07-06 12:44:33',NULL,NULL),(2693,'00969','S','Alt de Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(29093,'32260','P','Saint Johns','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.077501,-81.580838,0,'2013-07-06 12:44:32',NULL,NULL),(80168,'99825','P','Elfin Cove','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.184215,-136.313504,0,'2013-07-06 12:44:34',NULL,NULL),(67296,'80014','S','Denver','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.659880,-104.836980,0,'2013-07-06 12:44:34',NULL,NULL),(64885,'77073','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.005562,-95.399856,0,'2013-07-06 12:44:34',NULL,NULL),(57447,'66843','S','Cedar Point','D','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.287465,-96.749099,0,'2013-07-06 12:44:33',NULL,NULL),(40517,'45820','P','Cairo','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.830920,-84.084843,0,'2013-07-06 12:44:32',NULL,NULL),(10057,'10176','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(29253,'32447','P','Marianna','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.852964,-85.227838,0,'2013-07-06 12:44:32',NULL,NULL),(36620,'40982','S','Scalf','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.940616,-83.718678,0,'2013-07-06 12:44:32',NULL,NULL),(67135,'79759','P','Notrees','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.918114,-102.756169,0,'2013-07-06 12:44:34',NULL,NULL),(51676,'59922','S','Lakeside','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.013825,-114.222798,0,'2013-07-06 12:44:33',NULL,NULL),(78220,'97760','S','Crooked River','A','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358649,-121.184384,0,'2013-07-06 12:44:34',NULL,NULL),(19528,'20187','S','Vint Hill Frm','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.722482,-77.719815,0,'2013-07-06 12:44:31',NULL,NULL),(53497,'62010','S','Bethalto','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.907799,-90.044400,0,'2013-07-06 12:44:33',NULL,NULL),(983,'00716','S','Villa Flores','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(3072,'01138','P','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.088597,-72.561028,0,'2013-07-06 12:44:30',NULL,NULL),(8867,'08690','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(28916,'32147','P','Hollister','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.623748,-81.813963,0,'2013-07-06 12:44:32',NULL,NULL),(22232,'23607','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.985518,-76.420528,0,'2013-07-06 12:44:31',NULL,NULL),(7482,'06902','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.054668,-73.543191,0,'2013-07-06 12:44:30',NULL,NULL),(21556,'22802','S','Harrisonburg','D','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.508585,-78.940514,0,'2013-07-06 12:44:31',NULL,NULL),(35893,'40007','S','Bethlehem','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.401801,-85.062016,0,'2013-07-06 12:44:32',NULL,NULL),(3784,'02204','U','Massachusetts Tax','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.395030,-71.050270,0,'2013-07-06 12:44:30',NULL,NULL),(55414,'63653','S','Leadwood','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.863336,-90.592582,0,'2013-07-06 12:44:33',NULL,NULL),(10390,'10598','S','Yorktown Hts','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.294911,-73.797703,0,'2013-07-06 12:44:30',NULL,NULL),(54797,'63015','S','La Barque Crk','N','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.411262,-90.765192,0,'2013-07-06 12:44:33',NULL,NULL),(71927,'87830','S','Reserve','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652664,-108.764998,0,'2013-07-06 12:44:34',NULL,NULL),(69885,'84102','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758805,-111.865417,0,'2013-07-06 12:44:34',NULL,NULL),(67518,'80243','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.686348,-104.961946,0,'2013-07-06 12:44:34',NULL,NULL),(50489,'58053','S','Lidgerwood','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.077722,-97.150760,0,'2013-07-06 12:44:33',NULL,NULL),(755,'00692','S','Ext Santa Rita','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(30467,'33338','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140429,-80.125290,0,'2013-07-06 12:44:32',NULL,NULL),(11414,'11961','S','Panamoka','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.896900,-72.884340,0,'2013-07-06 12:44:30',NULL,NULL),(59768,'71172','P','Bossier City','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.530317,-93.652612,0,'2013-07-06 12:44:33',NULL,NULL),(78973,'98371','S','Summit','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(14359,'15021','S','Burgettstn','N','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.412700,-80.431260,0,'2013-07-06 12:44:31',NULL,NULL),(1243,'00729','S','Parc San Isidro','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(71432,'87029','S','Lindrith','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.429722,-107.087222,0,'2013-07-06 12:44:34',NULL,NULL),(71307,'86503','S','Salina','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(65244,'77458','P','Midfield','D','Matagorda','48321','Texas','TX','48','0000','361','Central',-6.0,'Y',28.941692,-96.241579,0,'2013-07-06 12:44:34',NULL,NULL),(21632,'22910','U','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.021668,-78.598714,0,'2013-07-06 12:44:31',NULL,NULL),(37136,'41465','S','Elsie','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(37755,'42326','S','Browder','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.271937,-87.014955,0,'2013-07-06 12:44:32',NULL,NULL),(45366,'51007','S','Bronson','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.414816,-96.213252,0,'2013-07-06 12:44:32',NULL,NULL),(53955,'62426','S','Edgewood','D','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.921946,-88.664835,0,'2013-07-06 12:44:33',NULL,NULL),(6995,'06250','S','West Ashford','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780580,-72.210300,0,'2013-07-06 12:44:30',NULL,NULL),(11534,'12043','S','Lawyersville','A','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(4919,'04074','S','Scarborough','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.584960,-70.370640,0,'2013-07-06 12:44:30',NULL,NULL),(24238,'26755','S','Kirby','A','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.177526,-78.691989,0,'2013-07-06 12:44:31',NULL,NULL),(73678,'91602','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(47790,'55046','S','Veseli','A','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445600,-93.413280,0,'2013-07-06 12:44:33',NULL,NULL),(63781,'75954','S','Haslam','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.938720,-94.055400,0,'2013-07-06 12:44:34',NULL,NULL),(16111,'17055','S','Mechancsbrg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(77467,'96816','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286442,-157.801992,0,'2013-07-06 12:44:34',NULL,NULL),(3299,'01509','P','Charlton Dpt','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.172996,-71.975620,0,'2013-07-06 12:44:30',NULL,NULL),(39695,'45036','S','Liberty Twp','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.446127,-84.210158,0,'2013-07-06 12:44:32',NULL,NULL),(40698,'46082','P','Carmel','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.979800,-86.119237,0,'2013-07-06 12:44:32',NULL,NULL),(29778,'33014','S','Miami Lakes','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.901437,-80.306472,0,'2013-07-06 12:44:32',NULL,NULL),(17635,'18060','P','Limeport','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.507213,-75.445457,0,'2013-07-06 12:44:31',NULL,NULL),(24222,'26717','S','Elk Garden','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.357260,-79.168660,0,'2013-07-06 12:44:31',NULL,NULL),(32959,'36585','S','Cortelyou','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.392178,-88.062461,0,'2013-07-06 12:44:32',NULL,NULL),(79631,'99129','S','Fruitland','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.045656,-118.195215,0,'2013-07-06 12:44:34',NULL,NULL),(77190,'96337','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(8964,'08810','S','South Brunswick','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.375752,-74.513413,0,'2013-07-06 12:44:30',NULL,NULL),(18501,'19098','U','Holmes','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.904384,-75.308537,0,'2013-07-06 12:44:31',NULL,NULL),(48720,'55953','S','Lyle','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.504882,-92.941860,0,'2013-07-06 12:44:33',NULL,NULL),(1602,'00769','S','Urb La Arboleda','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(55116,'63334','S','Vera','N','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.339811,-91.197015,0,'2013-07-06 12:44:33',NULL,NULL),(8348,'08043','S','Voorhees Kirkwood','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(78696,'98256','P','Index','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.818639,-121.545223,0,'2013-07-06 12:44:34',NULL,NULL),(68819,'82443','S','Thermopolis','D','Hot Springs','56017','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.772510,-108.575150,0,'2013-07-06 12:44:34',NULL,NULL),(68273,'81077','P','Swink','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.015209,-103.627743,0,'2013-07-06 12:44:34',NULL,NULL),(58113,'68123','S','Bellevue','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.112120,-95.957400,0,'2013-07-06 12:44:33',NULL,NULL),(18192,'18935','P','Milford Sq','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.432188,-75.396928,0,'2013-07-06 12:44:31',NULL,NULL),(26464,'29148','S','Goat Island Resort','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.589744,-80.341999,0,'2013-07-06 12:44:31',NULL,NULL),(35149,'39225','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291456,-90.183510,0,'2013-07-06 12:44:32',NULL,NULL),(62789,'74881','S','Fallis','A','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.691700,-97.065941,0,'2013-07-06 12:44:33',NULL,NULL),(68574,'81504','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.083097,-108.486204,0,'2013-07-06 12:44:34',NULL,NULL),(73069,'90099','U','Los Angeles Brm','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062936,-118.236227,0,'2013-07-06 12:44:34',NULL,NULL),(31783,'35023','S','Bessemer','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.411900,-87.046140,0,'2013-07-06 12:44:32',NULL,NULL),(70546,'85030','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.450771,-112.076932,0,'2013-07-06 12:44:34',NULL,NULL),(58853,'69141','S','Gurley','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.283246,-102.992375,0,'2013-07-06 12:44:33',NULL,NULL),(56180,'65013','S','Byron','N','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(53531,'62032','S','Bingham','A','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.103643,-89.305669,0,'2013-07-06 12:44:33',NULL,NULL),(51608,'59828','S','Corvallis','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.318428,-114.086766,0,'2013-07-06 12:44:33',NULL,NULL),(41509,'46970','S','Peru','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.753609,-86.073812,0,'2013-07-06 12:44:32',NULL,NULL),(53392,'61816','S','Broadlands','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.905173,-87.994769,0,'2013-07-06 12:44:33',NULL,NULL),(44314,'49740','S','Harbor Point','A','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.531470,-85.004593,0,'2013-07-06 12:44:32',NULL,NULL),(16806,'17543','S','Lititz','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(64185,'76239','S','Forestburg','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.545695,-97.596154,0,'2013-07-06 12:44:34',NULL,NULL),(75210,'93633','P','Kings Canyon','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(77080,'96130','S','Johnstonville','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417140,-120.641220,0,'2013-07-06 12:44:34',NULL,NULL),(5633,'04945','S','Johnson Mountain Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(68949,'82939','P','Mountain View','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.217362,-110.368583,0,'2013-07-06 12:44:34',NULL,NULL),(38733,'44024','S','Concord Twp','A','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.569436,-81.203372,0,'2013-07-06 12:44:32',NULL,NULL),(52291,'60538','S','Boulder Hill','N','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.709552,-88.336361,0,'2013-07-06 12:44:33',NULL,NULL),(55444,'63675','S','Vulcan','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.308062,-90.711151,0,'2013-07-06 12:44:33',NULL,NULL),(52989,'61440','S','Industry','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.325478,-90.604881,0,'2013-07-06 12:44:33',NULL,NULL),(78563,'98155','S','Shoreline','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(29454,'32708','S','Winter Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.681020,-81.280800,0,'2013-07-06 12:44:32',NULL,NULL),(77098,'96140','P','Cedar Flat','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(50728,'58382','S','Garske','N','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.329263,-98.875167,0,'2013-07-06 12:44:33',NULL,NULL),(34618,'38751','S','Woodburn','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(40138,'45340','S','Maplewood','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.373328,-84.045548,0,'2013-07-06 12:44:32',NULL,NULL),(30607,'33425','P','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.516509,-80.127865,0,'2013-07-06 12:44:32',NULL,NULL),(63194,'75428','S','Commerce','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.258059,-95.931868,0,'2013-07-06 12:44:33',NULL,NULL),(75257,'93665','P','S Dos Palos','A','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',36.965202,-120.654813,0,'2013-07-06 12:44:34',NULL,NULL),(49124,'56359','S','Onamia','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.074699,-93.662677,0,'2013-07-06 12:44:33',NULL,NULL),(76118,'95240','S','Lodi','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.124431,-121.267176,0,'2013-07-06 12:44:34',NULL,NULL),(72162,'88339','S','Flying H','A','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.908298,-105.467489,0,'2013-07-06 12:44:34',NULL,NULL),(18941,'19507','S','Schubert','N','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.492547,-76.295435,0,'2013-07-06 12:44:31',NULL,NULL),(1926,'00795','S','Urb del Carmen','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(42603,'47885','S','Sycamore Park','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(49324,'56551','S','Almora','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.322593,-95.346305,0,'2013-07-06 12:44:33',NULL,NULL),(5427,'04673','S','Sargentville','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.329116,-68.708409,0,'2013-07-06 12:44:30',NULL,NULL),(47481,'54748','S','Jim Falls','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.068050,-91.259361,0,'2013-07-06 12:44:32',NULL,NULL),(47050,'54413','P','Babcock','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.280850,-90.112996,0,'2013-07-06 12:44:32',NULL,NULL),(11181,'11733','S','E Setauket','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(7964,'07699','U','Teterboro','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.859722,-74.059722,0,'2013-07-06 12:44:30',NULL,NULL),(9154,'09310','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(15218,'16018','U','Natl Agency for Check Inqu','N','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091370,-79.908947,0,'2013-07-06 12:44:31',NULL,NULL),(71799,'87566','S','Chamita','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(56259,'65061','S','Pershing','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.502518,-91.534868,0,'2013-07-06 12:44:33',NULL,NULL),(60785,'72024','S','Hamilton','N','Lonoke','05085','Arkansas','AR','05','4400','870','Central',-6.0,'Y',34.788454,-91.746133,0,'2013-07-06 12:44:33',NULL,NULL),(72266,'88544','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769541,-106.427908,0,'2013-07-06 12:44:34',NULL,NULL),(65984,'78332','S','San Jose','N','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742680,-98.085900,0,'2013-07-06 12:44:34',NULL,NULL),(25048,'27916','S','Aydlett','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.302680,-75.909091,0,'2013-07-06 12:44:31',NULL,NULL),(23736,'25918','S','Shady Spring','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.704600,-81.102000,0,'2013-07-06 12:44:31',NULL,NULL),(42611,'47885','S','Windemere Lake','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(17525,'17970','S','Dark Water','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.746000,-76.208460,0,'2013-07-06 12:44:31',NULL,NULL),(8582,'08219','P','Green Creek','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.038214,-74.897029,0,'2013-07-06 12:44:30',NULL,NULL),(62941,'75098','S','Lucas','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.021961,-96.537200,0,'2013-07-06 12:44:33',NULL,NULL),(15189,'15946','S','Puritan','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.395360,-78.690600,0,'2013-07-06 12:44:31',NULL,NULL),(58155,'68176','U','Wells Fargo','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260689,-95.940590,0,'2013-07-06 12:44:33',NULL,NULL),(71109,'86003','P','Flagstaff','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.227378,-111.570364,0,'2013-07-06 12:44:34',NULL,NULL),(79216,'98541','S','Deckerville','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.010231,-123.411051,0,'2013-07-06 12:44:34',NULL,NULL),(80073,'99729','P','Cantwell','D','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.436354,-148.697016,0,'2013-07-06 12:44:34',NULL,NULL),(33172,'37028','S','Bumpus Mills','D','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.660239,-87.828611,0,'2013-07-06 12:44:32',NULL,NULL),(68040,'80929','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.814846,-104.619185,0,'2013-07-06 12:44:34',NULL,NULL),(65175,'77414','S','Sargent','A','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.963849,-95.948080,0,'2013-07-06 12:44:34',NULL,NULL),(57425,'66779','S','Uniontown','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.765781,-94.991098,0,'2013-07-06 12:44:33',NULL,NULL),(9926,'10152','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759241,-73.971816,0,'2013-07-06 12:44:30',NULL,NULL),(1912,'00795','S','Ext Las Flores','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(26626,'29320','P','Arcadia','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.959588,-81.993413,0,'2013-07-06 12:44:31',NULL,NULL),(12674,'13126','S','Furniss Sta','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(9989,'10165','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(20189,'20748','S','Marlow Heights','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(78087,'97477','S','Spfd','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.065622,-123.014262,0,'2013-07-06 12:44:34',NULL,NULL),(68976,'83112','S','Bedford','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.900000,-110.933333,0,'2013-07-06 12:44:34',NULL,NULL),(57721,'67361','S','Sedan','D','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.127555,-96.184822,0,'2013-07-06 12:44:33',NULL,NULL),(4708,'03817','S','Chocorua','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.894157,-71.238916,0,'2013-07-06 12:44:30',NULL,NULL),(53431,'61859','S','Ogden','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.115714,-87.956868,0,'2013-07-06 12:44:33',NULL,NULL),(50283,'57649','S','Strool','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.603149,-102.825211,0,'2013-07-06 12:44:33',NULL,NULL),(36732,'41031','S','Rutland','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(26423,'29125','S','Pinewood','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.742260,-80.481720,0,'2013-07-06 12:44:31',NULL,NULL),(37084,'41339','S','Canoe','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(66953,'79376','S','Tokio','D','Yoakum','48501','Texas','TX','48','0000','806','Central',-6.0,'Y',33.182296,-102.564204,0,'2013-07-06 12:44:34',NULL,NULL),(374,'00660','S','Est del Rio','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(60448,'71651','S','Jersey','D','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.347207,-92.285793,0,'2013-07-06 12:44:33',NULL,NULL),(19034,'19539','S','Fredericksville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(31079,'33857','S','Lorida','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.427648,-81.226924,0,'2013-07-06 12:44:32',NULL,NULL),(1114,'00725','S','Urb Santa Juana','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(53128,'61548','S','Germantown Hills','A','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.788480,-89.427180,0,'2013-07-06 12:44:33',NULL,NULL),(32969,'36606','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.671284,-88.102989,0,'2013-07-06 12:44:32',NULL,NULL),(45888,'52302','S','Marion','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.043431,-91.593062,0,'2013-07-06 12:44:32',NULL,NULL),(15762,'16915','S','Ladona','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(29423,'32664','P','McIntosh','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.448039,-82.229425,0,'2013-07-06 12:44:32',NULL,NULL),(55564,'63868','P','Morehouse','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.845406,-89.689939,0,'2013-07-06 12:44:33',NULL,NULL),(75368,'93926','S','Gonzales','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.517063,-121.430276,0,'2013-07-06 12:44:34',NULL,NULL),(45864,'52244','P','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.685037,-91.517079,0,'2013-07-06 12:44:32',NULL,NULL),(64569,'76661','S','Marlin','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.310786,-96.891028,0,'2013-07-06 12:44:34',NULL,NULL),(15370,'16262','S','Craigsville','A','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.835880,-79.644420,0,'2013-07-06 12:44:31',NULL,NULL),(76324,'95459','S','Manchester Rancheria','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.989307,-123.664351,0,'2013-07-06 12:44:34',NULL,NULL),(60630,'71901','S','HS','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(59601,'71019','S','Coushatta','D','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(38575,'43787','S','Pennsville','A','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.557874,-81.770693,0,'2013-07-06 12:44:32',NULL,NULL),(38876,'44105','S','Newburgh Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(36842,'41075','S','Fort Thomas','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.091389,-84.495833,0,'2013-07-06 12:44:32',NULL,NULL),(32313,'35758','S','Triana','A','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.684680,-86.792040,0,'2013-07-06 12:44:32',NULL,NULL),(46793,'53968','S','Wonewoc','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.654868,-90.220514,0,'2013-07-06 12:44:32',NULL,NULL),(51864,'60078','P','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.141956,-87.922457,0,'2013-07-06 12:44:33',NULL,NULL),(13032,'13433','S','Moose River','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.588855,-75.279411,0,'2013-07-06 12:44:30',NULL,NULL),(17318,'17859','S','Bendertown','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(65860,'78209','S','Terrell Hills','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.484722,-98.465556,0,'2013-07-06 12:44:34',NULL,NULL),(34982,'39096','S','Lorman','D','Jefferson','28063','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.817159,-91.197038,0,'2013-07-06 12:44:32',NULL,NULL),(71133,'86023','P','Grand Canyon','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.054420,-112.138620,0,'2013-07-06 12:44:34',NULL,NULL),(70486,'84770','S','Middleton','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(38820,'44076','S','Orwell','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.532299,-80.830144,0,'2013-07-06 12:44:32',NULL,NULL),(38857,'44095','S','Eastlake','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.654810,-81.440913,0,'2013-07-06 12:44:32',NULL,NULL),(56570,'65483','S','Simmons','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.323082,-91.964295,0,'2013-07-06 12:44:33',NULL,NULL),(43201,'48304','S','Bloomfield Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(35579,'39572','S','Pearlington','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.242297,-89.605365,0,'2013-07-06 12:44:32',NULL,NULL),(1476,'00745','S','Urb Sra del Carmen','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(28680,'31796','S','Warwick','D','Worth','13321','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.829982,-83.919589,0,'2013-07-06 12:44:32',NULL,NULL),(813,'00693','S','Urb La Cruv','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(69027,'83214','S','Hawkins','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.554001,-112.229068,0,'2013-07-06 12:44:34',NULL,NULL),(78498,'98109','S','Queen Anne','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.628934,-122.343181,0,'2013-07-06 12:44:34',NULL,NULL),(76409,'95552','S','Mad River','D','Trinity','06105','California','CA','06','0000','707','Pacific',-8.0,'Y',40.499200,-123.552088,0,'2013-07-06 12:44:34',NULL,NULL),(77530,'96848','U','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.321456,-157.813409,0,'2013-07-06 12:44:34',NULL,NULL),(3622,'02060','P','Scituate','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.186869,-71.204063,0,'2013-07-06 12:44:30',NULL,NULL),(31154,'33913','S','Miromar Lakes','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.497190,-81.730739,0,'2013-07-06 12:44:32',NULL,NULL),(263,'00641','S','Sect Cercadillo','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(42120,'47470','S','Silverville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.770024,-86.627519,0,'2013-07-06 12:44:32',NULL,NULL),(39669,'45013','S','Indian Spgs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.408216,-84.617598,0,'2013-07-06 12:44:32',NULL,NULL),(39351,'44626','S','East Sparta','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.694655,-81.377559,0,'2013-07-06 12:44:32',NULL,NULL),(76247,'95397','U','Modesto Brm Zip','N','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.660766,-120.993431,0,'2013-07-06 12:44:34',NULL,NULL),(69297,'83446','S','Humphrey','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.352939,-112.002532,0,'2013-07-06 12:44:34',NULL,NULL),(45802,'52172','S','Ludlow','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.271393,-91.477245,0,'2013-07-06 12:44:32',NULL,NULL),(9010,'08861','S','Perth Amboy','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.519012,-74.276120,0,'2013-07-06 12:44:30',NULL,NULL),(58118,'68127','S','Ralston','A','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.204126,-96.054148,0,'2013-07-06 12:44:33',NULL,NULL),(44570,'50025','S','Audubon','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.726100,-94.918560,0,'2013-07-06 12:44:32',NULL,NULL),(21467,'22627','S','Flint Hill','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.730956,-78.064789,0,'2013-07-06 12:44:31',NULL,NULL),(22990,'24747','S','Rock','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.389223,-81.233084,0,'2013-07-06 12:44:31',NULL,NULL),(4059,'02645','S','East Harwich','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.703441,-70.062208,0,'2013-07-06 12:44:30',NULL,NULL),(67837,'80810','S','First View','N','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.850458,-102.381819,0,'2013-07-06 12:44:34',NULL,NULL),(3114,'01230','S','Simons Rock','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(27215,'29910','S','Brighton Beach','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.259699,-80.872324,0,'2013-07-06 12:44:31',NULL,NULL),(46590,'53544','S','Hollandale','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.905916,-89.832037,0,'2013-07-06 12:44:32',NULL,NULL),(48622,'55797','S','Wrenshall','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.467500,-92.388333,0,'2013-07-06 12:44:33',NULL,NULL),(56458,'65284','S','Sturgeon','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.204824,-92.308046,0,'2013-07-06 12:44:33',NULL,NULL),(27743,'30356','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.947356,-84.330786,0,'2013-07-06 12:44:31',NULL,NULL),(52992,'61442','S','Keithsburg','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.096626,-90.936722,0,'2013-07-06 12:44:33',NULL,NULL),(50177,'57559','S','Kary','N','Jones','46075','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.958192,-100.699101,0,'2013-07-06 12:44:33',NULL,NULL),(47105,'54446','S','Loyal','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.736705,-90.493341,0,'2013-07-06 12:44:32',NULL,NULL),(44510,'49938','S','Ironwood','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.456602,-90.156472,0,'2013-07-06 12:44:32',NULL,NULL),(28699,'31820','S','Midland','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.560011,-84.843488,0,'2013-07-06 12:44:32',NULL,NULL),(70387,'84665','P','Sterling','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.197144,-111.682371,0,'2013-07-06 12:44:34',NULL,NULL),(37869,'42544','S','Faubush','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(40379,'45654','S','New Plymouth','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.409930,-82.358584,0,'2013-07-06 12:44:32',NULL,NULL),(62048,'73530','S','Davidson','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.241213,-99.079574,0,'2013-07-06 12:44:33',NULL,NULL),(58263,'68377','S','Jansen','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.201560,-97.026840,0,'2013-07-06 12:44:33',NULL,NULL),(17823,'18414','S','Dalton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.532124,-75.732122,0,'2013-07-06 12:44:31',NULL,NULL),(16538,'17302','S','Collinsville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(54552,'62890','S','Akin','A','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(24724,'27514','S','Chapel Hill','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.934949,-79.037474,0,'2013-07-06 12:44:31',NULL,NULL),(20132,'20722','S','Colmar Manor','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(14521,'15203','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.424202,-79.975101,0,'2013-07-06 12:44:31',NULL,NULL),(17912,'18454','P','Poyntelle','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.819727,-75.420566,0,'2013-07-06 12:44:31',NULL,NULL),(11208,'11743','S','Lloyd Neck','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(28007,'30608','P','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.959618,-83.376988,0,'2013-07-06 12:44:31',NULL,NULL),(52697,'61106','P','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.271831,-89.064619,0,'2013-07-06 12:44:33',NULL,NULL),(54462,'62855','P','Lancaster','D','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.534245,-87.886732,0,'2013-07-06 12:44:33',NULL,NULL),(11531,'12043','S','Dorloo','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(22492,'24068','P','Christiansbrg','A','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.142462,-80.400792,0,'2013-07-06 12:44:31',NULL,NULL),(57038,'66208','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(47624,'54909','S','Almond','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.303021,-89.341236,0,'2013-07-06 12:44:33',NULL,NULL),(68851,'82609','S','Allendale','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.846450,-106.274603,0,'2013-07-06 12:44:34',NULL,NULL),(60225,'71429','S','Florien','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.562771,-93.478790,0,'2013-07-06 12:44:33',NULL,NULL),(63014,'75167','S','Waxahachie','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.330887,-96.909444,0,'2013-07-06 12:44:33',NULL,NULL),(53310,'61738','S','Panola','A','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.740699,-89.012596,0,'2013-07-06 12:44:33',NULL,NULL),(38794,'44060','S','Mentor on the','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(34933,'39040','S','Bentonia','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.643323,-90.368586,0,'2013-07-06 12:44:32',NULL,NULL),(38652,'43939','P','Mount Pleasant','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.176383,-80.800676,0,'2013-07-06 12:44:32',NULL,NULL),(26761,'29432','S','Branchville','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.253796,-80.816801,0,'2013-07-06 12:44:31',NULL,NULL),(67664,'80487','S','Steamboat','N','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.488148,-106.868862,0,'2013-07-06 12:44:34',NULL,NULL),(64340,'76511','S','Bartlett','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.797024,-97.428615,0,'2013-07-06 12:44:34',NULL,NULL),(62772,'74865','S','Roff','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.632966,-96.841801,0,'2013-07-06 12:44:33',NULL,NULL),(17335,'17865','P','Pottsgrove','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.996303,-76.789962,0,'2013-07-06 12:44:31',NULL,NULL),(32750,'36343','S','Gordon','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.152278,-85.075175,0,'2013-07-06 12:44:32',NULL,NULL),(44966,'50401','S','Central Heights','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(51647,'59871','S','Sula','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.787998,-113.882464,0,'2013-07-06 12:44:33',NULL,NULL),(35161,'39250','U','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291319,-90.185931,0,'2013-07-06 12:44:32',NULL,NULL),(35830,'39769','S','Sturgis','D','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.357720,-89.050020,0,'2013-07-06 12:44:32',NULL,NULL),(61583,'72747','S','Maysville','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.398981,-94.573958,0,'2013-07-06 12:44:33',NULL,NULL),(61802,'73096','S','Weatherford','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.536765,-98.696109,0,'2013-07-06 12:44:33',NULL,NULL),(62344,'74056','S','Pawhuska','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.823412,-96.367170,0,'2013-07-06 12:44:33',NULL,NULL),(59224,'70422','S','Grangeville','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.725646,-90.507562,0,'2013-07-06 12:44:33',NULL,NULL),(9588,'10028','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(8995,'08844','S','Millstone','N','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.479008,-74.628315,0,'2013-07-06 12:44:30',NULL,NULL),(4504,'03289','P','Winnisquam','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.488007,-71.527208,0,'2013-07-06 12:44:30',NULL,NULL),(10446,'10917','S','Central Valley','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.333541,-74.134438,0,'2013-07-06 12:44:30',NULL,NULL),(52545,'60936','S','Gibson City','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.465996,-88.370237,0,'2013-07-06 12:44:33',NULL,NULL),(32693,'36276','S','Dickert','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(50907,'58554','S','Fort Rice','A','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.828248,-100.892053,0,'2013-07-06 12:44:33',NULL,NULL),(28629,'31738','S','Coolidge','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.033206,-83.856301,0,'2013-07-06 12:44:32',NULL,NULL),(43555,'48720','S','Bay Port','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.827437,-83.354983,0,'2013-07-06 12:44:32',NULL,NULL),(55851,'64168','P','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.168601,-94.631918,0,'2013-07-06 12:44:33',NULL,NULL),(74503,'92629','S','Monarch Bay','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.474313,-117.696438,0,'2013-07-06 12:44:34',NULL,NULL),(29713,'32950','S','Grant Vlkria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.985689,-80.589258,0,'2013-07-06 12:44:32',NULL,NULL),(16382,'17211','S','Inglesmith','N','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.767488,-78.406126,0,'2013-07-06 12:44:31',NULL,NULL),(33726,'37811','S','Mooresburg','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.369657,-83.192901,0,'2013-07-06 12:44:32',NULL,NULL),(42892,'48096','S','Ray Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.761520,-82.927080,0,'2013-07-06 12:44:32',NULL,NULL),(28878,'32121','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.193767,-81.053922,0,'2013-07-06 12:44:32',NULL,NULL),(76283,'95426','P','Cobb','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.840193,-122.723858,0,'2013-07-06 12:44:34',NULL,NULL),(7171,'06447','S','Marlborough','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.641101,-72.458069,0,'2013-07-06 12:44:30',NULL,NULL),(19690,'20373','U','Naval Station Anacostia','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(38418,'43545','S','Florida','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.386399,-84.133117,0,'2013-07-06 12:44:32',NULL,NULL),(37975,'42728','S','Cundiff','A','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(25641,'28467','S','Carolina Shores','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.898397,-78.578267,0,'2013-07-06 12:44:31',NULL,NULL),(56046,'64726','S','Blairstown','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.554804,-93.958139,0,'2013-07-06 12:44:33',NULL,NULL),(7498,'06920','U','Conn National Bank','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.055342,-73.538541,0,'2013-07-06 12:44:30',NULL,NULL),(13087,'13468','S','Springfld Center','N','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.844523,-74.841105,0,'2013-07-06 12:44:30',NULL,NULL),(29224,'32424','S','Blountstown','D','Calhoun','12013','Florida','FL','12','0000','850','Central',-6.0,'Y',30.440452,-85.046484,0,'2013-07-06 12:44:32',NULL,NULL),(2748,'00969','S','Urb San Francisco Javier','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(29720,'32952','S','Merritt Island','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.342491,-80.675378,0,'2013-07-06 12:44:32',NULL,NULL),(64837,'77040','S','Jersey Vlg','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(50601,'58249','S','Mount Carmel','N','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.763045,-98.375077,0,'2013-07-06 12:44:33',NULL,NULL),(69344,'83539','S','Syringa','N','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.156080,-115.886220,0,'2013-07-06 12:44:34',NULL,NULL),(22793,'24465','S','Mill Gap','N','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.379939,-79.640160,0,'2013-07-06 12:44:31',NULL,NULL),(66993,'79501','S','Anson','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.759811,-99.892214,0,'2013-07-06 12:44:34',NULL,NULL),(8436,'08081','S','Erial','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.773333,-75.006667,0,'2013-07-06 12:44:30',NULL,NULL),(10206,'10452','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.841676,-73.921773,0,'2013-07-06 12:44:30',NULL,NULL),(14152,'14717','S','Caneadea','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.372527,-78.210567,0,'2013-07-06 12:44:31',NULL,NULL),(1818,'00784','S','Hacienda Jazmin','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(15210,'16002','S','Butler','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.807304,-79.866026,0,'2013-07-06 12:44:31',NULL,NULL),(36438,'40601','S','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.199801,-84.947505,0,'2013-07-06 12:44:32',NULL,NULL),(45387,'51027','S','McNally','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.975452,-96.317851,0,'2013-07-06 12:44:32',NULL,NULL),(79408,'98814','S','Carlton','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.216121,-120.173751,0,'2013-07-06 12:44:34',NULL,NULL),(72519,'89158','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171909,-115.139969,0,'2013-07-06 12:44:34',NULL,NULL),(33335,'37160','S','Royal','A','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.476039,-86.467210,0,'2013-07-06 12:44:32',NULL,NULL),(47326,'54561','S','Starlake','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.054444,-89.457952,0,'2013-07-06 12:44:32',NULL,NULL),(21016,'21850','S','Pittsville','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.393238,-75.413071,0,'2013-07-06 12:44:31',NULL,NULL),(72909,'90024','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.060189,-118.436400,0,'2013-07-06 12:44:34',NULL,NULL),(32902,'36541','S','Grand Bay','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.490561,-88.330633,0,'2013-07-06 12:44:32',NULL,NULL),(69203,'83350','S','Acequia','A','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.620280,-113.767320,0,'2013-07-06 12:44:34',NULL,NULL),(10168,'10280','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711844,-74.019133,0,'2013-07-06 12:44:30',NULL,NULL),(707,'00687','S','Brisas del Norte','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(11289,'11776','S','P J S','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(41900,'47371','S','Noble','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(21415,'22538','S','Rappahannock Academy','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.158313,-77.300230,0,'2013-07-06 12:44:31',NULL,NULL),(20847,'21652','P','Neavitt','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.736603,-76.292982,0,'2013-07-06 12:44:31',NULL,NULL),(7577,'07030','S','Washington Street','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.747748,-74.033860,0,'2013-07-06 12:44:30',NULL,NULL),(35476,'39520','S','Bayside Park','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(55484,'63763','S','Mc Gee','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.042092,-90.185137,0,'2013-07-06 12:44:33',NULL,NULL),(63263,'75495','S','Van Alstyne','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.436674,-96.518227,0,'2013-07-06 12:44:33',NULL,NULL),(19724,'20394','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.941666,-77.087409,0,'2013-07-06 12:44:31',NULL,NULL),(3703,'02139','S','Inman Square','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.366036,-71.103492,0,'2013-07-06 12:44:30',NULL,NULL),(11740,'12184','S','Valatie','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.440700,-73.679640,0,'2013-07-06 12:44:30',NULL,NULL),(17642,'18068','P','Old Zionsville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.487427,-75.521144,0,'2013-07-06 12:44:31',NULL,NULL),(51655,'59901','S','Creston','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.211236,-114.293904,0,'2013-07-06 12:44:33',NULL,NULL),(80048,'99705','S','North Pole','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.764840,-147.417300,0,'2013-07-06 12:44:34',NULL,NULL),(73144,'90275','S','Rch Palos Vrd','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(66788,'79051','P','Kerrick','D','Dallam','48111','Texas','TX','48','0000','806','Central',-6.0,'Y',36.485140,-102.245450,0,'2013-07-06 12:44:34',NULL,NULL),(69382,'83610','S','Cambridge','D','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.581764,-116.658632,0,'2013-07-06 12:44:34',NULL,NULL),(22444,'24019','S','Roanoke','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.337160,-79.951680,0,'2013-07-06 12:44:31',NULL,NULL),(1870,'00791','S','Urb La Estancia','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(26880,'29555','S','Johnsonville','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.817535,-79.451852,0,'2013-07-06 12:44:31',NULL,NULL),(34236,'38378','P','Spring Creek','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.769058,-88.665436,0,'2013-07-06 12:44:32',NULL,NULL),(49127,'56361','S','Parkers Prairie','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.153362,-95.330911,0,'2013-07-06 12:44:33',NULL,NULL),(40036,'45251','S','Colerain Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.255230,-84.589734,0,'2013-07-06 12:44:32',NULL,NULL),(21283,'22331','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.806630,-77.058064,0,'2013-07-06 12:44:31',NULL,NULL),(30676,'33469','S','Tequesta','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.960459,-80.098465,0,'2013-07-06 12:44:32',NULL,NULL),(30392,'33321','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(44338,'49765','S','Onaway','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.372543,-84.208577,0,'2013-07-06 12:44:32',NULL,NULL),(20655,'21226','S','Carvel Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(3654,'02120','S','Mission Hill','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.334141,-71.097433,0,'2013-07-06 12:44:30',NULL,NULL),(72481,'89127','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.185118,-115.162798,0,'2013-07-06 12:44:34',NULL,NULL),(72736,'89506','S','Red Rock','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(4607,'03590','S','N Stratford','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.719190,-71.465831,0,'2013-07-06 12:44:30',NULL,NULL),(77250,'96544','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(63166,'75395','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.708936,-96.838941,0,'2013-07-06 12:44:33',NULL,NULL),(24748,'27531','S','Seymour Johnson A F B','A','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.380000,-77.990000,0,'2013-07-06 12:44:31',NULL,NULL),(10146,'10273','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711049,-74.003348,0,'2013-07-06 12:44:30',NULL,NULL),(42475,'47834','S','Rocky Fork Lake','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(22152,'23459','S','Little Creek Naval Amphibiou','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(32482,'36047','S','Letohatchee','D','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.078214,-86.555167,0,'2013-07-06 12:44:32',NULL,NULL),(56936,'66079','S','Rantoul','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.547975,-95.097538,0,'2013-07-06 12:44:33',NULL,NULL),(67792,'80726','S','Crook','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.909481,-102.812552,0,'2013-07-06 12:44:34',NULL,NULL),(73520,'91344','S','Granada Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.279812,-118.500354,0,'2013-07-06 12:44:34',NULL,NULL),(48888,'56101','S','Windom','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.873800,-95.153160,0,'2013-07-06 12:44:33',NULL,NULL),(78306,'97906','S','Harper','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.875300,-117.595524,0,'2013-07-06 12:44:34',NULL,NULL),(76153,'95305','P','Big Oak Flat','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.821336,-120.215805,0,'2013-07-06 12:44:34',NULL,NULL),(59637,'71038','S','Haynesville','D','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(16605,'17329','S','Glenville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.757860,-76.871220,0,'2013-07-06 12:44:31',NULL,NULL),(44371,'49786','U','Sault Sainte Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.266667,-84.483333,0,'2013-07-06 12:44:32',NULL,NULL),(18402,'19053','S','Langhorne','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(27637,'30316','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.718321,-84.326190,0,'2013-07-06 12:44:31',NULL,NULL),(70815,'85378','S','Surprise','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.637662,-112.340663,0,'2013-07-06 12:44:34',NULL,NULL),(51484,'59602','S','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.645305,-111.974322,0,'2013-07-06 12:44:33',NULL,NULL),(22311,'23834','S','South Chesterfield','A','Colonial Heights City','51570','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.287361,-77.391074,0,'2013-07-06 12:44:31',NULL,NULL),(8149,'07847','S','Kenvil','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.887908,-74.626161,0,'2013-07-06 12:44:30',NULL,NULL),(7497,'06914','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.099971,-73.551538,0,'2013-07-06 12:44:30',NULL,NULL),(12097,'12571','S','Milan','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.008880,-73.840140,0,'2013-07-06 12:44:30',NULL,NULL),(21054,'21904','S','Port Deposit','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.635940,-76.079400,0,'2013-07-06 12:44:31',NULL,NULL),(6005,'05358','S','Halifax','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.785580,-72.769500,0,'2013-07-06 12:44:30',NULL,NULL),(7182,'06468','S','Monroe','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.340900,-73.234440,0,'2013-07-06 12:44:30',NULL,NULL),(16981,'17724','S','West Leroy','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(51726,'60010','S','South Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(6587,'05859','S','Jay','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.000000,-72.400000,0,'2013-07-06 12:44:30',NULL,NULL),(50696,'58356','S','Munster','N','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.684884,-99.133524,0,'2013-07-06 12:44:33',NULL,NULL),(19333,'20032','S','Wash','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(26672,'29401','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.779122,-79.939806,0,'2013-07-06 12:44:31',NULL,NULL),(64152,'76203','P','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.216321,-97.130801,0,'2013-07-06 12:44:34',NULL,NULL),(50698,'58356','S','New Rockfrd','N','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.684884,-99.133524,0,'2013-07-06 12:44:33',NULL,NULL),(78800,'98325','S','Shine','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.978657,-122.776970,0,'2013-07-06 12:44:34',NULL,NULL),(74290,'92365','S','Newberry Spgs','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.873491,-116.656202,0,'2013-07-06 12:44:34',NULL,NULL),(59272,'70457','P','Saint Benedict','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.524851,-90.094566,0,'2013-07-06 12:44:33',NULL,NULL),(33124,'36872','P','Riverview','N','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.817410,-85.173370,0,'2013-07-06 12:44:32',NULL,NULL),(8683,'08332','S','Laurel Lake','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.330240,-75.027540,0,'2013-07-06 12:44:30',NULL,NULL),(51761,'60030','S','Grayslake','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(15061,'15728','S','Clymer','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.670525,-79.012538,0,'2013-07-06 12:44:31',NULL,NULL),(14639,'15234','S','Castle Shannon','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(69627,'83874','P','Murray','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.623381,-115.857511,0,'2013-07-06 12:44:34',NULL,NULL),(25967,'28658','S','Startown','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(60570,'71762','S','Smackover','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.365650,-92.728056,0,'2013-07-06 12:44:33',NULL,NULL),(58142,'68152','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.341128,-95.998908,0,'2013-07-06 12:44:33',NULL,NULL),(23517,'25557','S','Ranger','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.082567,-82.160452,0,'2013-07-06 12:44:31',NULL,NULL),(11557,'12059','S','East Berne','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.617126,-74.058841,0,'2013-07-06 12:44:30',NULL,NULL),(17314,'17857','S','Northumberlnd','A','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893520,-76.797765,0,'2013-07-06 12:44:31',NULL,NULL),(74081,'92182','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.762178,-117.069156,0,'2013-07-06 12:44:34',NULL,NULL),(40947,'46302','P','Boone Grove','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.353384,-87.125263,0,'2013-07-06 12:44:32',NULL,NULL),(1633,'00771','S','Urb Campo Real','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(49668,'57006','S','Lake Campbell','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.287500,-96.791400,0,'2013-07-06 12:44:33',NULL,NULL),(79371,'98662','S','Orchards','N','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.671298,-122.559764,0,'2013-07-06 12:44:34',NULL,NULL),(22500,'24073','S','Christiansbrg','A','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136439,-80.404000,0,'2013-07-06 12:44:31',NULL,NULL),(13422,'13755','S','Shinhopple','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.067456,-75.036591,0,'2013-07-06 12:44:31',NULL,NULL),(36802,'41055','S','Needmore','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(54870,'63052','S','Imperial','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.390733,-90.422015,0,'2013-07-06 12:44:33',NULL,NULL),(47680,'54957','P','Neenah','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.183332,-88.463405,0,'2013-07-06 12:44:33',NULL,NULL),(59428,'70663','S','Sulphur','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.228528,-93.357785,0,'2013-07-06 12:44:33',NULL,NULL),(765,'00692','S','Urb La Inmaculada','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(16083,'17050','S','Navy Ships','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(48452,'55710','S','Britt','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.648089,-92.655516,0,'2013-07-06 12:44:33',NULL,NULL),(47348,'54603','S','Lacrosse','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.848862,-91.249344,0,'2013-07-06 12:44:32',NULL,NULL),(42563,'47874','S','Jessup','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(35526,'39540','S','Diberville','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.459729,-88.948864,0,'2013-07-06 12:44:32',NULL,NULL),(75400,'94014','S','Colma','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.689480,-122.439360,0,'2013-07-06 12:44:34',NULL,NULL),(75374,'93932','P','Lockwood','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',35.948370,-121.194481,0,'2013-07-06 12:44:34',NULL,NULL),(48585,'55777','P','Virginia','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.520334,-92.532139,0,'2013-07-06 12:44:33',NULL,NULL),(74196,'92282','S','Whitewater','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.933154,-116.693211,0,'2013-07-06 12:44:34',NULL,NULL),(55543,'63845','S','East Prairie','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.779930,-89.384669,0,'2013-07-06 12:44:33',NULL,NULL),(21495,'22657','S','Lebanon Church','N','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.987689,-78.359876,0,'2013-07-06 12:44:31',NULL,NULL),(6103,'05452','S','Pinewood','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(6831,'06117','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(73013,'90066','S','Mar Vista','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.993713,-118.428320,0,'2013-07-06 12:44:34',NULL,NULL),(70333,'84629','S','Milburn','N','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(5857,'05143','S','Baltimore','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(9408,'10001','S','Empire State','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(24807,'27599','U','Chapel Hill','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.928939,-79.040693,0,'2013-07-06 12:44:31',NULL,NULL),(3747,'02171','S','Marina Bay','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(4501,'03287','S','Sutton','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.443972,-71.912264,0,'2013-07-06 12:44:30',NULL,NULL),(69329,'83524','S','Culdesac','D','Nez Perce','16069','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.353838,-116.634758,0,'2013-07-06 12:44:34',NULL,NULL),(62546,'74437','S','Grayson','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(61934,'73156','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.566986,-97.550405,0,'2013-07-06 12:44:33',NULL,NULL),(39066,'44202','S','Reminderville','A','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.314774,-81.345613,0,'2013-07-06 12:44:32',NULL,NULL),(43200,'48304','S','Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(43697,'48888','S','Stanton','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.302535,-85.110003,0,'2013-07-06 12:44:32',NULL,NULL),(19633,'20254','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884967,-77.020848,0,'2013-07-06 12:44:31',NULL,NULL),(47682,'54961','S','New London','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.385363,-88.748158,0,'2013-07-06 12:44:33',NULL,NULL),(18331,'19027','S','Elkins Park','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.017822,-75.135978,0,'2013-07-06 12:44:31',NULL,NULL),(51956,'60137','S','Glendale Heights','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.871806,-88.065073,0,'2013-07-06 12:44:33',NULL,NULL),(47614,'54893','S','Webster','D','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.878830,-92.299184,0,'2013-07-06 12:44:33',NULL,NULL),(8357,'08050','S','Cedar Bonnet Island','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.698720,-74.257382,0,'2013-07-06 12:44:30',NULL,NULL),(24270,'26847','S','Arthur','A','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.996532,-79.123849,0,'2013-07-06 12:44:31',NULL,NULL),(5616,'04938','S','Chesterville','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.670853,-70.146599,0,'2013-07-06 12:44:30',NULL,NULL),(56774,'65742','S','Rogersville','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.121940,-93.138780,0,'2013-07-06 12:44:33',NULL,NULL),(46269,'53023','S','Glenbeulah','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.792158,-88.078669,0,'2013-07-06 12:44:32',NULL,NULL),(53143,'61554','S','North Pekin','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(9033,'08876','S','Branchburg','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.543740,-74.660040,0,'2013-07-06 12:44:30',NULL,NULL),(19574,'20214','U','Bureau Labor Statistics','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917561,-76.993932,0,'2013-07-06 12:44:31',NULL,NULL),(55160,'63366','S','Saint Paul','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(19934,'20566','U','John F Kennedy Center','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903226,-77.049281,0,'2013-07-06 12:44:31',NULL,NULL),(55962,'64498','S','Westboro','D','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.527669,-95.314430,0,'2013-07-06 12:44:33',NULL,NULL),(58592,'68843','S','Hampton','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.881097,-97.885145,0,'2013-07-06 12:44:33',NULL,NULL),(62019,'73455','P','Ravia','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.243035,-96.749987,0,'2013-07-06 12:44:33',NULL,NULL),(71355,'86535','P','Dennehotso','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.741436,-109.852610,0,'2013-07-06 12:44:34',NULL,NULL),(66593,'78752','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.331040,-97.699030,0,'2013-07-06 12:44:34',NULL,NULL),(63604,'75797','U','Stratigic Fulfilment','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.579684,-95.108732,0,'2013-07-06 12:44:34',NULL,NULL),(29847,'33034','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.450256,-80.489973,0,'2013-07-06 12:44:32',NULL,NULL),(50529,'58104','S','Frontier','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.819706,-96.808039,0,'2013-07-06 12:44:33',NULL,NULL),(32724,'36310','S','Lawrenceville','N','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.554960,-85.265460,0,'2013-07-06 12:44:32',NULL,NULL),(56579,'65536','S','Lebanon','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.678149,-92.664800,0,'2013-07-06 12:44:33',NULL,NULL),(70973,'85671','P','Sierra Vista','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.566116,-110.325396,0,'2013-07-06 12:44:34',NULL,NULL),(71496,'87107','S','Los Ranchos','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(58294,'68418','S','Palmyra','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.703411,-96.394378,0,'2013-07-06 12:44:33',NULL,NULL),(26224,'28793','P','Hendersonvlle','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.327979,-82.478182,0,'2013-07-06 12:44:31',NULL,NULL),(56157,'64859','S','Reeds','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.130651,-94.150465,0,'2013-07-06 12:44:33',NULL,NULL),(33661,'37721','S','Corryton','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.124806,-83.814477,0,'2013-07-06 12:44:32',NULL,NULL),(34570,'38733','S','Delta State','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.749492,-90.831182,0,'2013-07-06 12:44:32',NULL,NULL),(11121,'11704','S','W Babylon','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.709193,-73.371464,0,'2013-07-06 12:44:30',NULL,NULL),(4123,'02740','S','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.636223,-70.942002,0,'2013-07-06 12:44:30',NULL,NULL),(49033,'56280','S','Porter','D','Yellow Medicine','27173','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.672238,-96.154789,0,'2013-07-06 12:44:33',NULL,NULL),(21736,'23024','S','Bumpass','D','Louisa','51109','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.036307,-77.714721,0,'2013-07-06 12:44:31',NULL,NULL),(62737,'74830','P','Bowlegs','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.147720,-96.671721,0,'2013-07-06 12:44:33',NULL,NULL),(48989,'56230','S','Danube','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.806228,-95.053722,0,'2013-07-06 12:44:33',NULL,NULL),(7702,'07114','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.713452,-74.174179,0,'2013-07-06 12:44:30',NULL,NULL),(10961,'11510','S','Baldwin Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655358,-73.607376,0,'2013-07-06 12:44:30',NULL,NULL),(6775,'06101','S','HTD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788224,-72.665673,0,'2013-07-06 12:44:30',NULL,NULL),(11437,'11970','P','S Jamesport','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.936611,-72.579128,0,'2013-07-06 12:44:30',NULL,NULL),(17960,'18540','U','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.372284,-75.657800,0,'2013-07-06 12:44:31',NULL,NULL),(1355,'00736','S','Paseo de Las Brumas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(72679,'89444','S','Simpson','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.842200,-119.367900,0,'2013-07-06 12:44:34',NULL,NULL),(12506,'13024','U','Auburn','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920638,-76.552564,0,'2013-07-06 12:44:30',NULL,NULL),(48898,'56120','S','Butterfield','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.957764,-94.792469,0,'2013-07-06 12:44:33',NULL,NULL),(18574,'19127','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.029648,-75.223171,0,'2013-07-06 12:44:31',NULL,NULL),(59598,'71016','S','Roy','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.187420,-93.133374,0,'2013-07-06 12:44:33',NULL,NULL),(236,'00631','P','Adjuntas','A','Lares','72081','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.180272,-66.832917,0,'2013-07-06 12:44:30',NULL,NULL),(52394,'60632','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.808605,-87.711782,0,'2013-07-06 12:44:33',NULL,NULL),(29462,'32715','P','Altamonte Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.666741,-81.359609,0,'2013-07-06 12:44:32',NULL,NULL),(33248,'37077','P','Hendersonville','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.304003,-86.619156,0,'2013-07-06 12:44:32',NULL,NULL),(47922,'55111','S','Fort Snelling Military Resv','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.880467,-93.196044,0,'2013-07-06 12:44:33',NULL,NULL),(31891,'35135','S','Riverside','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.601540,-86.196001,0,'2013-07-06 12:44:32',NULL,NULL),(8136,'07836','S','Flanders','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.853244,-74.708204,0,'2013-07-06 12:44:30',NULL,NULL),(28016,'30622','S','Bogart','D','Oconee','13219','Georgia','GA','13','0500','770/678/470','Eastern',-5.0,'Y',33.921521,-83.527179,0,'2013-07-06 12:44:31',NULL,NULL),(11851,'12255','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.654469,-73.759719,0,'2013-07-06 12:44:30',NULL,NULL),(26037,'28681','S','Taylorsville','D','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(102,'00612','S','Urb La Mucura','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(8600,'08232','S','McKee City','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(147,'00617','S','Parc Punta Palmas','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(38063,'43060','S','N Lewisburg','A','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.219090,-83.569313,0,'2013-07-06 12:44:32',NULL,NULL),(15986,'17033','S','Swatara Sta','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(52707,'61112','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.237664,-88.978952,0,'2013-07-06 12:44:33',NULL,NULL),(41524,'46986','S','Swayzee','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.508776,-85.820070,0,'2013-07-06 12:44:32',NULL,NULL),(32670,'36264','S','Hollis Crossroads','N','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.647368,-85.584872,0,'2013-07-06 12:44:32',NULL,NULL),(63648,'75845','S','Friday','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(42794,'48047','S','New Baltimore','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.674168,-82.780566,0,'2013-07-06 12:44:32',NULL,NULL),(53396,'61821','S','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.106564,-88.283856,0,'2013-07-06 12:44:33',NULL,NULL),(21983,'23255','P','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.588723,-77.567833,0,'2013-07-06 12:44:31',NULL,NULL),(37024,'41240','S','Swamp Branch','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(77601,'96940','P','Koror Republic of Palau','N','Palau','70030','Palau','PW','70','0000','680','UTC+9',9.0,'N',7.496636,134.574247,0,'2013-07-06 12:44:34',NULL,NULL),(73417,'91188','U','Kaiser Foundation Health','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.151026,-118.143944,0,'2013-07-06 12:44:34',NULL,NULL),(68163,'81006','S','Blende','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.244574,-104.524364,0,'2013-07-06 12:44:34',NULL,NULL),(44731,'50157','S','Sheridan','N','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.612217,-92.531212,0,'2013-07-06 12:44:32',NULL,NULL),(49845,'57234','S','Estelline','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.622353,-96.958682,0,'2013-07-06 12:44:33',NULL,NULL),(69831,'84080','S','Vernon','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.036117,-112.388825,0,'2013-07-06 12:44:34',NULL,NULL),(68580,'81507','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.105236,-108.548263,0,'2013-07-06 12:44:34',NULL,NULL),(47037,'54407','S','Amherst Jct','A','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.518339,-89.294289,0,'2013-07-06 12:44:32',NULL,NULL),(10940,'11435','S','Briarwood','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699477,-73.808819,0,'2013-07-06 12:44:30',NULL,NULL),(22192,'23504','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.859599,-76.265830,0,'2013-07-06 12:44:31',NULL,NULL),(13039,'13438','S','Remsen','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.333117,-75.200513,0,'2013-07-06 12:44:30',NULL,NULL),(57661,'67210','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.627375,-97.263435,0,'2013-07-06 12:44:33',NULL,NULL),(66181,'78536','S','Delmita','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.643548,-98.403199,0,'2013-07-06 12:44:34',NULL,NULL),(67707,'80527','P','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.533235,-105.071191,0,'2013-07-06 12:44:34',NULL,NULL),(64011,'76117','S','N Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(58380,'68544','U','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(46907,'54130','S','Kaukauna','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.291186,-88.273071,0,'2013-07-06 12:44:32',NULL,NULL),(54542,'62885','S','Stringtown','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842965,-89.082598,0,'2013-07-06 12:44:33',NULL,NULL),(37233,'41543','S','McAndrews','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537673,-82.262326,0,'2013-07-06 12:44:32',NULL,NULL),(14091,'14618','S','Loehmanns Plz','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.119768,-77.556663,0,'2013-07-06 12:44:31',NULL,NULL),(56762,'65735','S','Quincy','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.007925,-93.468410,0,'2013-07-06 12:44:33',NULL,NULL),(67165,'79834','P','Bg Bnd Ntl Pk','A','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',29.290990,-103.182413,0,'2013-07-06 12:44:34',NULL,NULL),(79226,'98548','S','Cushman Dam','N','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.406850,-123.158638,0,'2013-07-06 12:44:34',NULL,NULL),(73226,'90637','P','La Mirada','D','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.897095,-118.002372,0,'2013-07-06 12:44:34',NULL,NULL),(3975,'02494','S','Needham Hgts','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.305022,-71.231767,0,'2013-07-06 12:44:30',NULL,NULL),(39165,'44306','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.047753,-81.488189,0,'2013-07-06 12:44:32',NULL,NULL),(63275,'75507','U','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.354678,-94.219325,0,'2013-07-06 12:44:33',NULL,NULL),(6219,'05488','S','Popsquash','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(45836,'52216','S','Clarence','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.881233,-91.061085,0,'2013-07-06 12:44:32',NULL,NULL),(66031,'78363','S','Kingsvlle Nas','A','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.514425,-97.860850,0,'2013-07-06 12:44:34',NULL,NULL),(58315,'68441','S','Steinauer','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.207893,-96.231820,0,'2013-07-06 12:44:33',NULL,NULL),(6912,'06153','U','Allstate','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688148,-72.728859,0,'2013-07-06 12:44:30',NULL,NULL),(39602,'44875','S','Ganges','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(27547,'30241','S','Lagrange','D','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.099497,-85.024744,0,'2013-07-06 12:44:31',NULL,NULL),(53398,'61824','P','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.120771,-88.243698,0,'2013-07-06 12:44:33',NULL,NULL),(53416,'61845','S','Foosland','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.358156,-88.428229,0,'2013-07-06 12:44:33',NULL,NULL),(62131,'73666','S','Sweetwater','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.443145,-99.912331,0,'2013-07-06 12:44:33',NULL,NULL),(1138,'00726','P','Caguas','D','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233050,-66.036044,0,'2013-07-06 12:44:30',NULL,NULL),(2835,'00982','S','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(5931,'05254','P','Bromley Mountain','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.162851,-73.070330,0,'2013-07-06 12:44:30',NULL,NULL),(63495,'75705','S','Bascom','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.361239,-95.084145,0,'2013-07-06 12:44:33',NULL,NULL),(8637,'08270','S','Corbin City','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(37624,'42141','S','Lamb','A','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.974371,-85.907023,0,'2013-07-06 12:44:32',NULL,NULL),(47059,'54420','S','Chili','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.574394,-90.300300,0,'2013-07-06 12:44:32',NULL,NULL),(26853,'29520','S','Cheraw','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.691188,-79.902254,0,'2013-07-06 12:44:31',NULL,NULL),(43852,'49104','U','Berrien Springs','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.945755,-86.340672,0,'2013-07-06 12:44:32',NULL,NULL),(59664,'71052','S','Mansfield','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.034409,-93.700560,0,'2013-07-06 12:44:33',NULL,NULL),(77582,'96915','S','Santa Rita','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(77195,'96347','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60929,'72085','P','Letona','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.362925,-91.829710,0,'2013-07-06 12:44:33',NULL,NULL),(31909,'35150','S','Sylacauga','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.175189,-86.255713,0,'2013-07-06 12:44:32',NULL,NULL),(52531,'60922','S','Chebanse','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.006701,-87.909574,0,'2013-07-06 12:44:33',NULL,NULL),(45637,'51646','S','New Market','D','Taylor','19173','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.733318,-94.901302,0,'2013-07-06 12:44:32',NULL,NULL),(9209,'09501','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9028,'08873','S','Somerset','D','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.499340,-74.521380,0,'2013-07-06 12:44:30',NULL,NULL),(19456,'20124','S','Clifton','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.781025,-77.385955,0,'2013-07-06 12:44:31',NULL,NULL),(6936,'06167','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768325,-72.682921,0,'2013-07-06 12:44:30',NULL,NULL),(16971,'17723','S','Jersey Shore','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.391600,-77.471280,0,'2013-07-06 12:44:31',NULL,NULL),(14882,'15476','P','Ronco','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.871721,-79.923226,0,'2013-07-06 12:44:31',NULL,NULL),(41593,'47104','S','Bethlehem','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.539827,-85.422262,0,'2013-07-06 12:44:32',NULL,NULL),(29705,'32940','S','Palm Shores','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.225810,-80.688308,0,'2013-07-06 12:44:32',NULL,NULL),(63232,'75468','S','Pattonville','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.562976,-95.392329,0,'2013-07-06 12:44:33',NULL,NULL),(59085,'70121','S','Shrewsbury','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.964212,-90.156847,0,'2013-07-06 12:44:33',NULL,NULL),(8196,'07927','S','Cedar Knolls','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.821502,-74.454637,0,'2013-07-06 12:44:30',NULL,NULL),(27572,'30269','S','Peachtree Cty','A','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.393706,-84.564697,0,'2013-07-06 12:44:31',NULL,NULL),(29513,'32772','P','Sanford','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.767538,-81.246852,0,'2013-07-06 12:44:32',NULL,NULL),(47448,'54728','S','Chetek','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.317036,-91.673079,0,'2013-07-06 12:44:32',NULL,NULL),(16864,'17565','S','Martic','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(826,'00693','S','Vega Baja','D','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(56871,'66019','P','Clearview City','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.945400,-95.002701,0,'2013-07-06 12:44:33',NULL,NULL),(79860,'99557','P','Chuathbaluk','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.787030,-156.614710,0,'2013-07-06 12:44:34',NULL,NULL),(76767,'95929','U','Ca State Univ Chico','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.753601,-121.807403,0,'2013-07-06 12:44:34',NULL,NULL),(65054,'77339','S','Humble','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.052800,-95.220720,0,'2013-07-06 12:44:34',NULL,NULL),(22183,'23480','P','Wachapreague','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.602689,-75.689312,0,'2013-07-06 12:44:31',NULL,NULL),(48549,'55760','S','Rice River','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(60123,'71369','S','Simmesport','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.989911,-91.825861,0,'2013-07-06 12:44:33',NULL,NULL),(68816,'82442','S','Ten Sleep','D','Washakie','56043','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.034301,-107.445849,0,'2013-07-06 12:44:34',NULL,NULL),(24764,'27546','S','Lillington','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.397219,-78.813484,0,'2013-07-06 12:44:31',NULL,NULL),(3533,'01904','S','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.488960,-70.963687,0,'2013-07-06 12:44:30',NULL,NULL),(9142,'09261','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(22156,'23459','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(7356,'06749','U','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.504981,-73.152430,0,'2013-07-06 12:44:30',NULL,NULL),(989,'00717','S','Bda Mariani','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(58210,'68331','S','Highland','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.503475,-96.706289,0,'2013-07-06 12:44:33',NULL,NULL),(63333,'75599','U','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.447126,-94.077525,0,'2013-07-06 12:44:33',NULL,NULL),(73995,'92104','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.740029,-117.130447,0,'2013-07-06 12:44:34',NULL,NULL),(49302,'56533','S','Elizabeth','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.411743,-96.094139,0,'2013-07-06 12:44:33',NULL,NULL),(71938,'87931','S','Caballo','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.018467,-107.418270,0,'2013-07-06 12:44:34',NULL,NULL),(72169,'88344','S','Dunken','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.657594,-105.424795,0,'2013-07-06 12:44:34',NULL,NULL),(54044,'62467','S','Island Grove','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.131471,-88.475901,0,'2013-07-06 12:44:33',NULL,NULL),(41604,'47115','S','Depauw','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.336211,-86.270190,0,'2013-07-06 12:44:32',NULL,NULL),(6547,'05842','S','Greensboro Bend','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.556900,-72.251340,0,'2013-07-06 12:44:30',NULL,NULL),(37075,'41314','S','Sebastians Branch','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(25740,'28562','S','Trent Woods','A','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.071740,-77.099580,0,'2013-07-06 12:44:31',NULL,NULL),(75168,'93599','U','Lockheed Advanced Dev Co','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.577152,-118.116071,0,'2013-07-06 12:44:34',NULL,NULL),(63034,'75205','S','University Park','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.836236,-96.794663,0,'2013-07-06 12:44:33',NULL,NULL),(38647,'43937','P','Maynard','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.130903,-80.879039,0,'2013-07-06 12:44:32',NULL,NULL),(69296,'83446','S','Dubois','A','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.352939,-112.002532,0,'2013-07-06 12:44:34',NULL,NULL),(6904,'06150','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765671,-72.675155,0,'2013-07-06 12:44:30',NULL,NULL),(17865,'18436','S','Cobbs Lk Pres','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(35305,'39401','S','University Of Southern Ms','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(57248,'66531','S','Riley','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.294454,-96.813036,0,'2013-07-06 12:44:33',NULL,NULL),(48614,'55793','S','Warba','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.129250,-93.267130,0,'2013-07-06 12:44:33',NULL,NULL),(44433,'49852','S','Loretto','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.781469,-87.816698,0,'2013-07-06 12:44:32',NULL,NULL),(18327,'19026','S','Drexelbrook','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.955020,-75.327420,0,'2013-07-06 12:44:31',NULL,NULL),(45373,'51014','S','Cleghorn','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.808720,-95.709164,0,'2013-07-06 12:44:32',NULL,NULL),(63468,'75686','S','County Line','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(30823,'33620','U','Univ of So Florida','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060736,-82.410807,0,'2013-07-06 12:44:32',NULL,NULL),(1575,'00767','S','Urb Los Angeles','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(63141,'75368','U','State Farm Insurance','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.920785,-96.974939,0,'2013-07-06 12:44:33',NULL,NULL),(49167,'56396','U','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.568127,-94.214279,0,'2013-07-06 12:44:33',NULL,NULL),(62239,'74001','P','Avant','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.489618,-96.059840,0,'2013-07-06 12:44:33',NULL,NULL),(61808,'73102','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.471927,-97.518257,0,'2013-07-06 12:44:33',NULL,NULL),(38554,'43758','S','Malta','D','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.640908,-81.894711,0,'2013-07-06 12:44:32',NULL,NULL),(39946,'45231','S','Finneytown','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.244265,-84.540628,0,'2013-07-06 12:44:32',NULL,NULL),(23240,'25110','P','Hugheston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.210093,-81.374878,0,'2013-07-06 12:44:31',NULL,NULL),(28930,'32168','S','New Smyrna Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.002944,-81.017002,0,'2013-07-06 12:44:32',NULL,NULL),(56914,'66052','S','Linwood','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.000948,-95.038348,0,'2013-07-06 12:44:33',NULL,NULL),(44115,'49506','S','East Grand Rapids','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(3692,'02135','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.350820,-71.118420,0,'2013-07-06 12:44:30',NULL,NULL),(57553,'67035','S','Penalosa','A','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.666740,-98.402580,0,'2013-07-06 12:44:33',NULL,NULL),(22863,'24553','S','Gladstone','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.545247,-78.839877,0,'2013-07-06 12:44:31',NULL,NULL),(42173,'47527','S','Kellerville','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(21404,'22517','P','Mollusk','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.732970,-76.537003,0,'2013-07-06 12:44:31',NULL,NULL),(55736,'64086','S','LS','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.919180,-94.320840,0,'2013-07-06 12:44:33',NULL,NULL),(11873,'12304','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.780295,-73.909969,0,'2013-07-06 12:44:30',NULL,NULL),(27232,'29920','S','Harbor Isl','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(65189,'77422','S','Brazoria','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.043342,-95.567119,0,'2013-07-06 12:44:34',NULL,NULL),(73648,'91495','U','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151111,-118.448333,0,'2013-07-06 12:44:34',NULL,NULL),(1086,'00725','S','Urb Caguas Milenio','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(23904,'26205','S','Craigsville','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.332208,-80.639092,0,'2013-07-06 12:44:31',NULL,NULL),(55345,'63557','S','New Boston','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.762044,-93.117461,0,'2013-07-06 12:44:33',NULL,NULL),(53462,'61920','S','Rardin','N','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.604167,-88.101667,0,'2013-07-06 12:44:33',NULL,NULL),(5988,'05351','S','South Newfane','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.938056,-72.705833,0,'2013-07-06 12:44:30',NULL,NULL),(73533,'91351','S','Canyon Cntry','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425819,-118.443437,0,'2013-07-06 12:44:34',NULL,NULL),(26604,'29290','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.918265,-80.873716,0,'2013-07-06 12:44:31',NULL,NULL),(41993,'47424','S','Doans','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(8593,'08230','S','Seaville','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.210240,-74.728080,0,'2013-07-06 12:44:30',NULL,NULL),(65685,'77995','S','Pearl City','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(50473,'58042','S','Prosper','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.996140,-96.899460,0,'2013-07-06 12:44:33',NULL,NULL),(12218,'12804','S','Glens Falls','A','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.371360,-73.676100,0,'2013-07-06 12:44:30',NULL,NULL),(31004,'33774','S','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878143,-82.827197,0,'2013-07-06 12:44:32',NULL,NULL),(34224,'38367','S','Eastview','A','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.052884,-88.638071,0,'2013-07-06 12:44:32',NULL,NULL),(50455,'58027','S','Enderlin','D','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.621570,-97.601885,0,'2013-07-06 12:44:33',NULL,NULL),(22810,'24482','S','Verona','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.199926,-79.005878,0,'2013-07-06 12:44:31',NULL,NULL),(62345,'74056','S','Pearsonia','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.823412,-96.367170,0,'2013-07-06 12:44:33',NULL,NULL),(62812,'74946','P','Moffett','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.389201,-94.447746,0,'2013-07-06 12:44:33',NULL,NULL),(55252,'63452','S','Tolona','N','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.082877,-91.813182,0,'2013-07-06 12:44:33',NULL,NULL),(73404,'91124','U','Ralph M Parsons Co','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.150182,-118.152862,0,'2013-07-06 12:44:34',NULL,NULL),(67714,'80534','S','Johnstown','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.305750,-105.074550,0,'2013-07-06 12:44:34',NULL,NULL),(67500,'80234','S','Thornton','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(67998,'80920','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.958459,-104.757058,0,'2013-07-06 12:44:34',NULL,NULL),(41135,'46628','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.698701,-86.309464,0,'2013-07-06 12:44:32',NULL,NULL),(36130,'40223','S','Sycamore','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(27847,'30429','P','Hagan','D','Evans','13109','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.152588,-81.935744,0,'2013-07-06 12:44:31',NULL,NULL),(5140,'04414','S','Williamsburg Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.307433,-69.030278,0,'2013-07-06 12:44:30',NULL,NULL),(56128,'64834','S','Stringtown','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.170235,-94.542468,0,'2013-07-06 12:44:33',NULL,NULL),(19737,'20404','U','GPO Procurement Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897713,-77.008867,0,'2013-07-06 12:44:31',NULL,NULL),(51265,'59089','S','Wyola','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.081583,-107.669356,0,'2013-07-06 12:44:33',NULL,NULL),(46038,'52556','S','Vedic City','A','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(73030,'90073','P','Veterans Administration','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.052501,-118.455227,0,'2013-07-06 12:44:34',NULL,NULL),(66591,'78750','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.415054,-97.797138,0,'2013-07-06 12:44:34',NULL,NULL),(1373,'00736','S','Urb San Martin','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(42285,'47586','S','Lilly Dale','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(27134,'29810','S','Seigling','N','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.006169,-81.306627,0,'2013-07-06 12:44:31',NULL,NULL),(54141,'62565','S','Duvall','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(4084,'02664','S','Bass River','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.668281,-70.193806,0,'2013-07-06 12:44:30',NULL,NULL),(39616,'44882','S','Lemert','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(76481,'95629','S','Fiddletown','D','Amador','06005','California','CA','06','6920','209','Pacific',-8.0,'Y',38.502916,-120.725438,0,'2013-07-06 12:44:34',NULL,NULL),(35799,'39755','S','Beasley','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.591536,-88.953093,0,'2013-07-06 12:44:32',NULL,NULL),(31028,'33786','S','Indian Rk Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(76858,'95965','S','Yankee Hill','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(43454,'48531','P','Northwest','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.055082,-83.750365,0,'2013-07-06 12:44:32',NULL,NULL),(14053,'14568','S','Walworth','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.142109,-77.287732,0,'2013-07-06 12:44:31',NULL,NULL),(29353,'32564','S','Holt','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.706505,-86.848432,0,'2013-07-06 12:44:32',NULL,NULL),(34117,'38186','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.035348,-90.015959,0,'2013-07-06 12:44:32',NULL,NULL),(6765,'06094','P','Winchestr Ctr','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.901881,-73.142301,0,'2013-07-06 12:44:30',NULL,NULL),(13949,'14452','P','Fancher','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.243195,-78.087864,0,'2013-07-06 12:44:31',NULL,NULL),(8407,'08067','S','Pedricktown','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.740441,-75.406456,0,'2013-07-06 12:44:30',NULL,NULL),(74334,'92404','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.148310,-117.257233,0,'2013-07-06 12:44:34',NULL,NULL),(67260,'79960','U','El Paso Electric Co','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.758857,-106.487767,0,'2013-07-06 12:44:34',NULL,NULL),(64484,'76599','U','Craine Unit','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.474630,-97.739824,0,'2013-07-06 12:44:34',NULL,NULL),(5039,'04260','S','New Gloucestr','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.973580,-70.325340,0,'2013-07-06 12:44:30',NULL,NULL),(14261,'14840','S','Hammondsport','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.450089,-77.184976,0,'2013-07-06 12:44:31',NULL,NULL),(71559,'87196','P','UNM','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.082837,-106.619087,0,'2013-07-06 12:44:34',NULL,NULL),(71321,'86505','S','Steamboat Canyon','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(30463,'33337','U','American Express','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110891,-80.274099,0,'2013-07-06 12:44:32',NULL,NULL),(52274,'60525','S','Lagrange Hlds','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(56969,'66119','P','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.083719,-94.639027,0,'2013-07-06 12:44:33',NULL,NULL),(9720,'10081','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(79307,'98592','S','Union','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.345331,-123.077475,0,'2013-07-06 12:44:34',NULL,NULL),(79976,'99651','P','Platinum','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.789288,-161.481568,0,'2013-07-06 12:44:34',NULL,NULL),(65367,'77535','S','Old River-Winfree','A','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(22528,'24102','S','Henry','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.839964,-80.006088,0,'2013-07-06 12:44:31',NULL,NULL),(7540,'07009','S','Cedar Grove','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.854335,-74.231714,0,'2013-07-06 12:44:30',NULL,NULL),(51660,'59910','S','Big Arm','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.793773,-114.294753,0,'2013-07-06 12:44:33',NULL,NULL),(55989,'64633','S','Carrollton','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.364841,-93.493290,0,'2013-07-06 12:44:33',NULL,NULL),(79294,'98584','S','Skokomish','N','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(69756,'84050','S','Porterville','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(33147,'36919','S','Silas','D','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.762783,-88.300013,0,'2013-07-06 12:44:32',NULL,NULL),(13258,'13647','P','Hannawa Falls','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.612465,-74.970045,0,'2013-07-06 12:44:30',NULL,NULL),(21020,'21853','S','Oriole','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.190240,-75.694800,0,'2013-07-06 12:44:31',NULL,NULL),(43231,'48313','S','Sterling Heights','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.598804,-82.997434,0,'2013-07-06 12:44:32',NULL,NULL),(60689,'71935','S','Hopper','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.358611,-93.688611,0,'2013-07-06 12:44:33',NULL,NULL),(5307,'04556','S','Edgecomb','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.974872,-69.609070,0,'2013-07-06 12:44:30',NULL,NULL),(15328,'16213','P','Callensburg','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.124635,-79.561000,0,'2013-07-06 12:44:31',NULL,NULL),(17484,'17959','S','Silver Creek','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.738984,-76.109152,0,'2013-07-06 12:44:31',NULL,NULL),(14269,'14847','S','Interlaken','D','Seneca','36099','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.614405,-76.729358,0,'2013-07-06 12:44:31',NULL,NULL),(67490,'80232','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.690079,-105.085043,0,'2013-07-06 12:44:34',NULL,NULL),(60329,'71462','S','Ebarb','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.692840,-93.699360,0,'2013-07-06 12:44:33',NULL,NULL),(13518,'13813','S','Doraville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.154740,-75.542760,0,'2013-07-06 12:44:31',NULL,NULL),(51218,'59052','S','McLeod','N','Sweet Grass','30097','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.539768,-110.306341,0,'2013-07-06 12:44:33',NULL,NULL),(42159,'47522','S','Crane Naval Weapons Support','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(52576,'60966','S','Sheldon','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.773437,-87.563900,0,'2013-07-06 12:44:33',NULL,NULL),(7998,'07719','S','Lake Como','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(77089,'96134','S','Tulelake','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.949725,-121.472495,0,'2013-07-06 12:44:34',NULL,NULL),(65068,'77346','S','Atascocita','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.033333,-95.250000,0,'2013-07-06 12:44:34',NULL,NULL),(11964,'12456','S','Mount Merion Park','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.036600,-73.998840,0,'2013-07-06 12:44:30',NULL,NULL),(7493,'06912','P','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.055122,-73.540684,0,'2013-07-06 12:44:30',NULL,NULL),(62004,'73438','S','Healdton','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.228519,-97.484391,0,'2013-07-06 12:44:33',NULL,NULL),(60057,'71351','S','Fifth Ward','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.161480,-92.095020,0,'2013-07-06 12:44:33',NULL,NULL),(28769,'32026','U','Raiford','D','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.062470,-82.236973,0,'2013-07-06 12:44:32',NULL,NULL),(56626,'65590','S','Long Lane','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.573975,-92.932919,0,'2013-07-06 12:44:33',NULL,NULL),(57288,'66611','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.016771,-95.696466,0,'2013-07-06 12:44:33',NULL,NULL),(4971,'04109','S','Diamond Cove','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(2276,'00926','S','Urb San Juan Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(50892,'58538','S','Fort Yates','D','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.075961,-100.641076,0,'2013-07-06 12:44:33',NULL,NULL),(38409,'43534','S','McClure','N','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.373000,-83.939975,0,'2013-07-06 12:44:32',NULL,NULL),(16731,'17415','U','North American Outdoor Group','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.964657,-76.729258,0,'2013-07-06 12:44:31',NULL,NULL),(68818,'82443','S','Hamilton Dome','A','Hot Springs','56017','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.772510,-108.575150,0,'2013-07-06 12:44:34',NULL,NULL),(30340,'33310','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.171944,-80.132222,0,'2013-07-06 12:44:32',NULL,NULL),(1227,'00728','S','Valle de Andalucia','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(56355,'65202','S','Shaw','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(7721,'07199','U','Merrill Lynch Inc','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.727070,-74.172065,0,'2013-07-06 12:44:30',NULL,NULL),(18679,'19184','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953202,-75.183899,0,'2013-07-06 12:44:31',NULL,NULL),(60299,'71454','S','Nantatchie','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(18591,'19136','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.044445,-75.024762,0,'2013-07-06 12:44:31',NULL,NULL),(42049,'47446','S','Mitchell','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(8126,'07828','S','Budd Lake','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.886645,-74.751763,0,'2013-07-06 12:44:30',NULL,NULL),(10718,'11245','U','Chase Manhattan Bank','N','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.693148,-73.985871,0,'2013-07-06 12:44:30',NULL,NULL),(41835,'47346','S','Dalton','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.927181,-85.153805,0,'2013-07-06 12:44:32',NULL,NULL),(26233,'28806','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.583509,-82.607790,0,'2013-07-06 12:44:31',NULL,NULL),(33930,'38060','S','Somerville','A','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.212950,-89.542271,0,'2013-07-06 12:44:32',NULL,NULL),(79134,'98499','S','Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(68706,'82061','P','Horse Creek','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.395577,-105.363112,0,'2013-07-06 12:44:34',NULL,NULL),(18742,'19340','U','Concordville','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.886723,-75.518894,0,'2013-07-06 12:44:31',NULL,NULL),(34295,'38505','U','Tennessee Tech Univ','N','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.182099,-85.461511,0,'2013-07-06 12:44:32',NULL,NULL),(38542,'43749','S','Kimbolton','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.181667,-81.592500,0,'2013-07-06 12:44:32',NULL,NULL),(10038,'10173','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(8103,'07801','S','Victory Gardens','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.943413,-74.523388,0,'2013-07-06 12:44:30',NULL,NULL),(75135,'93556','P','Ridgecrest','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.623072,-117.670357,0,'2013-07-06 12:44:34',NULL,NULL),(21762,'23060','S','Glen Allen','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.659630,-77.529243,0,'2013-07-06 12:44:31',NULL,NULL),(41621,'47126','S','Henryville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.539614,-85.773039,0,'2013-07-06 12:44:32',NULL,NULL),(48754,'55973','S','Sargeant','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.806350,-92.749222,0,'2013-07-06 12:44:33',NULL,NULL),(50826,'58472','S','Montpelier','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.666944,-98.759167,0,'2013-07-06 12:44:33',NULL,NULL),(38123,'43112','S','Carroll','D','Fairfield','39045','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.802370,-82.710428,0,'2013-07-06 12:44:32',NULL,NULL),(69484,'83676','S','Wilder','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.655554,-116.906886,0,'2013-07-06 12:44:34',NULL,NULL),(38695,'44001','S','Brownhelm','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(56138,'64841','P','Duenweg','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.077850,-94.410853,0,'2013-07-06 12:44:33',NULL,NULL),(56455,'65283','S','Florida','A','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.546823,-91.835464,0,'2013-07-06 12:44:33',NULL,NULL),(4355,'03052','S','Litchfield','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.846506,-71.459230,0,'2013-07-06 12:44:30',NULL,NULL),(11227,'11751','S','Islip','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732034,-73.213359,0,'2013-07-06 12:44:30',NULL,NULL),(29391,'32615','S','Santa Fe','A','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.784372,-82.477314,0,'2013-07-06 12:44:32',NULL,NULL),(69442,'83646','S','Meridian','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.609657,-116.398343,0,'2013-07-06 12:44:34',NULL,NULL),(65201,'77433','S','Cypress','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.914176,-95.734253,0,'2013-07-06 12:44:34',NULL,NULL),(75794,'94710','S','Albany','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.869970,-122.296314,0,'2013-07-06 12:44:34',NULL,NULL),(65645,'77970','P','La Ward','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.818428,-96.442505,0,'2013-07-06 12:44:34',NULL,NULL),(65275,'77477','S','Stafford','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.621316,-95.562225,0,'2013-07-06 12:44:34',NULL,NULL),(59024,'70079','S','Norco','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.010500,-90.420660,0,'2013-07-06 12:44:33',NULL,NULL),(35929,'40045','S','Locust','A','Trimble','21223','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.690280,-85.371180,0,'2013-07-06 12:44:32',NULL,NULL),(33362,'37190','S','Woodbury','D','Cannon','47015','Tennessee','TN','47','0000','615','Central',-6.0,'Y',35.812584,-86.069115,0,'2013-07-06 12:44:32',NULL,NULL),(47403,'54646','S','Cutler','N','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.033430,-90.083429,0,'2013-07-06 12:44:32',NULL,NULL),(55654,'64024','S','Excelsior Estates','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(34,'00603','S','Urb Maleza Gdns','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(18568,'19125','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.979114,-75.123882,0,'2013-07-06 12:44:31',NULL,NULL),(3345,'01550','S','Globe Village','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.077174,-72.032139,0,'2013-07-06 12:44:30',NULL,NULL),(60669,'71923','S','Arkadelphia','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(62799,'74931','S','Bunch','D','Adair','40001','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.720151,-94.741191,0,'2013-07-06 12:44:33',NULL,NULL),(47290,'54543','P','McNaughton','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.767082,-89.514971,0,'2013-07-06 12:44:32',NULL,NULL),(78486,'98103','S','Wallingford','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.671009,-122.340102,0,'2013-07-06 12:44:34',NULL,NULL),(35785,'39747','S','Sibleton','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444845,-89.567673,0,'2013-07-06 12:44:32',NULL,NULL),(1658,'00773','S','Hacienda Margarita','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(33511,'37369','S','Reliance','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.181454,-84.505928,0,'2013-07-06 12:44:32',NULL,NULL),(52029,'60181','S','Oakbrook Ter','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.882953,-87.975404,0,'2013-07-06 12:44:33',NULL,NULL),(34521,'38680','S','Glover','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.961644,-90.119278,0,'2013-07-06 12:44:32',NULL,NULL),(47835,'55072','S','Danforth','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.126511,-92.866999,0,'2013-07-06 12:44:33',NULL,NULL),(27141,'29819','S','Bradley','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.109752,-82.233224,0,'2013-07-06 12:44:31',NULL,NULL),(64396,'76538','S','Pancake','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.598240,-97.759127,0,'2013-07-06 12:44:34',NULL,NULL),(48965,'56187','S','Worthington','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.622198,-95.600942,0,'2013-07-06 12:44:33',NULL,NULL),(68785,'82332','S','Savery','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.080988,-107.348315,0,'2013-07-06 12:44:34',NULL,NULL),(58786,'68977','S','Stamford','D','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.089103,-99.575329,0,'2013-07-06 12:44:33',NULL,NULL),(54046,'62467','S','Teutopolis','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.131471,-88.475901,0,'2013-07-06 12:44:33',NULL,NULL),(54116,'62549','S','Hervey City','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.785894,-88.870832,0,'2013-07-06 12:44:33',NULL,NULL),(37536,'42051','S','West Viola','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(9151,'09307','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(2974,'01053','S','Leeds','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.354408,-72.701457,0,'2013-07-06 12:44:30',NULL,NULL),(54203,'62638','S','Franklin','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.621696,-90.042782,0,'2013-07-06 12:44:33',NULL,NULL),(12864,'13323','S','Kirkland','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.056309,-75.375791,0,'2013-07-06 12:44:30',NULL,NULL),(27197,'29901','P','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.417543,-80.657499,0,'2013-07-06 12:44:31',NULL,NULL),(25084,'27950','S','Knotts Island','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.537621,-76.038101,0,'2013-07-06 12:44:31',NULL,NULL),(26434,'29128','S','Hagood','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(61382,'72529','S','Hardy','A','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.295430,-91.540492,0,'2013-07-06 12:44:33',NULL,NULL),(77823,'97206','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.487218,-122.598613,0,'2013-07-06 12:44:34',NULL,NULL),(63361,'75639','S','East Side','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.250480,-94.139400,0,'2013-07-06 12:44:33',NULL,NULL),(62973,'75135','S','Caddo Mills','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.068967,-96.229757,0,'2013-07-06 12:44:33',NULL,NULL),(37845,'42463','P','Wheatcroft','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.489055,-87.858856,0,'2013-07-06 12:44:32',NULL,NULL),(30480,'33349','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181282,-80.226180,0,'2013-07-06 12:44:32',NULL,NULL),(37664,'42211','S','Blue Water Estates','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(76139,'95258','S','Woodbridge','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.154787,-121.305131,0,'2013-07-06 12:44:34',NULL,NULL),(55803,'64134','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.933195,-94.494689,0,'2013-07-06 12:44:33',NULL,NULL),(56738,'65712','S','Hoberg','N','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.098522,-93.815768,0,'2013-07-06 12:44:33',NULL,NULL),(30069,'33154','S','Bal Harbour','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(45533,'51447','S','Red Line','N','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.729851,-95.264767,0,'2013-07-06 12:44:32',NULL,NULL),(1312,'00735','S','Jard Avila','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(34476,'38664','S','Penton','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(29735,'32963','S','Indn Riv Shrs','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.647905,-80.360668,0,'2013-07-06 12:44:32',NULL,NULL),(56842,'65817','P','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.169066,-93.326524,0,'2013-07-06 12:44:33',NULL,NULL),(73603,'91390','S','Saugus','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(35735,'39703','P','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.516152,-88.483499,0,'2013-07-06 12:44:32',NULL,NULL),(52617,'61032','S','Freeport','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.302242,-89.635039,0,'2013-07-06 12:44:33',NULL,NULL),(406,'00662','S','Parc Cotto','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(6013,'05360','S','West Wardsboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.074420,-72.898920,0,'2013-07-06 12:44:30',NULL,NULL),(29463,'32715','P','Altamonte Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.666741,-81.359609,0,'2013-07-06 12:44:32',NULL,NULL),(13976,'14482','S','Le Roy','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.964320,-77.980800,0,'2013-07-06 12:44:31',NULL,NULL),(20607,'21207','S','Gwynn Oak','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.323820,-76.714260,0,'2013-07-06 12:44:31',NULL,NULL),(21118,'22082','U','Engineering Support Center','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.872667,-77.237303,0,'2013-07-06 12:44:31',NULL,NULL),(30063,'33150','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849298,-80.205791,0,'2013-07-06 12:44:32',NULL,NULL),(27493,'30165','S','Rome','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.282882,-85.237598,0,'2013-07-06 12:44:31',NULL,NULL),(50332,'57732','S','Deadwood','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.275833,-103.665833,0,'2013-07-06 12:44:33',NULL,NULL),(47646,'54928','S','Caroline','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.752400,-88.897245,0,'2013-07-06 12:44:33',NULL,NULL),(18731,'19320','S','Valley Twp','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(49808,'57201','S','Grover','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(47026,'54344','U','Employers Health Insure Cos','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.419190,-88.104737,0,'2013-07-06 12:44:32',NULL,NULL),(61286,'72401','S','Jonesboro','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.824808,-90.697175,0,'2013-07-06 12:44:33',NULL,NULL),(54135,'62563','S','Berry','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748414,-89.542262,0,'2013-07-06 12:44:33',NULL,NULL),(78027,'97426','S','Creswell','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.907812,-123.034345,0,'2013-07-06 12:44:34',NULL,NULL),(34766,'38863','S','Furrs','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(2254,'00926','S','Urb Milaville','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(43895,'49239','P','Frontier','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.793886,-84.623116,0,'2013-07-06 12:44:32',NULL,NULL),(40401,'45675','P','Rock Camp','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.521864,-82.563260,0,'2013-07-06 12:44:32',NULL,NULL),(58149,'68172','U','Bar Code','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260689,-95.940590,0,'2013-07-06 12:44:33',NULL,NULL),(67817,'80751','S','Sterling','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.636291,-103.210799,0,'2013-07-06 12:44:34',NULL,NULL),(40014,'45246','S','West Chester','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.279734,-84.471102,0,'2013-07-06 12:44:32',NULL,NULL),(11600,'12085','S','Guilderland Center','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.702864,-73.968446,0,'2013-07-06 12:44:30',NULL,NULL),(5295,'04547','S','Friendship','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.054704,-69.094233,0,'2013-07-06 12:44:30',NULL,NULL),(2031,'00917','S','Urb Floral Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(23369,'25285','S','Valley Fork','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.580248,-81.087658,0,'2013-07-06 12:44:31',NULL,NULL),(39111,'44251','P','Westfield Center','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027952,-81.938348,0,'2013-07-06 12:44:32',NULL,NULL),(78199,'97736','S','Frenchglen','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.824059,-118.917984,0,'2013-07-06 12:44:34',NULL,NULL),(76465,'95617','P','Davis','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.547703,-121.722184,0,'2013-07-06 12:44:34',NULL,NULL),(66485,'78667','P','San Marcos','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.858313,-97.942973,0,'2013-07-06 12:44:34',NULL,NULL),(64320,'76483','S','Throckmorton','D','Throckmorton','48447','Texas','TX','48','0000','940','Central',-6.0,'Y',33.186968,-99.276720,0,'2013-07-06 12:44:34',NULL,NULL),(63602,'75792','S','Winona','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.455404,-95.128624,0,'2013-07-06 12:44:34',NULL,NULL),(22950,'24649','S','Swords Creek','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.081098,-81.917929,0,'2013-07-06 12:44:31',NULL,NULL),(13832,'14219','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.785549,-78.822312,0,'2013-07-06 12:44:31',NULL,NULL),(77555,'96860','S','Pearl Harbor','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353536,-157.966185,0,'2013-07-06 12:44:34',NULL,NULL),(74644,'92822','P','Brea','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.918656,-117.889203,0,'2013-07-06 12:44:34',NULL,NULL),(7784,'07423','S','Ho Ho Kus','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.997732,-74.102172,0,'2013-07-06 12:44:30',NULL,NULL),(3190,'01342','S','West Deerfield','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.553684,-72.589272,0,'2013-07-06 12:44:30',NULL,NULL),(26242,'28816','P','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.581775,-82.601410,0,'2013-07-06 12:44:31',NULL,NULL),(24138,'26561','S','Big Run','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.591392,-80.569806,0,'2013-07-06 12:44:31',NULL,NULL),(20805,'21557','S','Rawlings','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.516721,-78.906140,0,'2013-07-06 12:44:31',NULL,NULL),(9792,'10108','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(15141,'15853','S','Portland Mills','A','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.457360,-78.726660,0,'2013-07-06 12:44:31',NULL,NULL),(71399,'87012','S','Mesa Poleo','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.178174,-106.654000,0,'2013-07-06 12:44:34',NULL,NULL),(71795,'87564','P','San Cristobal','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.629274,-105.603520,0,'2013-07-06 12:44:34',NULL,NULL),(78361,'98014','S','Lake Joy','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.657278,-121.912869,0,'2013-07-06 12:44:34',NULL,NULL),(21106,'22044','S','Seven Corners','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856209,-77.157020,0,'2013-07-06 12:44:31',NULL,NULL),(26078,'28702','S','Almond','D','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.388116,-83.634747,0,'2013-07-06 12:44:31',NULL,NULL),(4653,'03754','P','Guild','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.376375,-72.132970,0,'2013-07-06 12:44:30',NULL,NULL),(32300,'35745','S','Estillfork','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.913039,-86.194623,0,'2013-07-06 12:44:32',NULL,NULL),(25606,'28456','S','East Arcadia','A','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.344900,-78.257820,0,'2013-07-06 12:44:31',NULL,NULL),(55125,'63343','S','Elsberry','D','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.157945,-90.815451,0,'2013-07-06 12:44:33',NULL,NULL),(69702,'84032','S','Heber','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(65331,'77517','S','Arcadia','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.383481,-95.127808,0,'2013-07-06 12:44:34',NULL,NULL),(64865,'77058','S','Lyndon B Johnson Space Cen','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.553866,-95.095044,0,'2013-07-06 12:44:34',NULL,NULL),(23133,'24976','S','Sinks Grove','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.668229,-80.523874,0,'2013-07-06 12:44:31',NULL,NULL),(23564,'25646','P','Mc Connell','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.825556,-81.966944,0,'2013-07-06 12:44:31',NULL,NULL),(37120,'41421','S','Elkfork','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.933831,-83.076852,0,'2013-07-06 12:44:32',NULL,NULL),(11748,'12189','S','Mannville','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.726113,-73.713355,0,'2013-07-06 12:44:30',NULL,NULL),(27064,'29688','P','Tigerville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.062449,-82.352257,0,'2013-07-06 12:44:31',NULL,NULL),(62837,'75007','S','Carrollton','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.006252,-96.886600,0,'2013-07-06 12:44:33',NULL,NULL),(64633,'76705','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(63910,'76039','S','Euless','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.853924,-97.086444,0,'2013-07-06 12:44:34',NULL,NULL),(62464,'74333','S','Bluejacket','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.806420,-95.121074,0,'2013-07-06 12:44:33',NULL,NULL),(12497,'13020','P','Apulia Sta','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.818065,-76.073470,0,'2013-07-06 12:44:30',NULL,NULL),(6748,'06083','P','Enfield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.998183,-72.576392,0,'2013-07-06 12:44:30',NULL,NULL),(7684,'07102','S','Midtown','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.732638,-74.171775,0,'2013-07-06 12:44:30',NULL,NULL),(2095,'00923','S','Repto America','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(55698,'64064','S','Blue Springs','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.982769,-94.365575,0,'2013-07-06 12:44:33',NULL,NULL),(37930,'42638','S','Revelo','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.671672,-84.467842,0,'2013-07-06 12:44:32',NULL,NULL),(36399,'40507','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.048262,-84.492068,0,'2013-07-06 12:44:32',NULL,NULL),(35600,'39595','U','Pascagoula','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.368782,-88.549063,0,'2013-07-06 12:44:32',NULL,NULL),(52244,'60514','S','Clarendon Hills','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.772480,-87.957180,0,'2013-07-06 12:44:33',NULL,NULL),(45609,'51563','S','Persia','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.578558,-95.571262,0,'2013-07-06 12:44:32',NULL,NULL),(13641,'13905','S','Westview','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(5337,'04605','S','Fletchers Ldg','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(44656,'50105','S','Gilbert','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.104178,-93.649016,0,'2013-07-06 12:44:32',NULL,NULL),(75563,'94261','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584987,-121.493673,0,'2013-07-06 12:44:34',NULL,NULL),(63927,'76059','S','Keene','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.393040,-97.327486,0,'2013-07-06 12:44:34',NULL,NULL),(36978,'41179','S','Vanceburg','D','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(44757,'50201','S','Fernald','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.018291,-93.450971,0,'2013-07-06 12:44:32',NULL,NULL),(70679,'85248','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.247500,-111.879180,0,'2013-07-06 12:44:34',NULL,NULL),(52305,'60545','S','Plano','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.668485,-88.531045,0,'2013-07-06 12:44:33',NULL,NULL),(44254,'49679','S','Sears','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.863072,-85.158511,0,'2013-07-06 12:44:32',NULL,NULL),(11399,'11951','S','Mastic Beach','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.764527,-72.843517,0,'2013-07-06 12:44:30',NULL,NULL),(3010,'01080','S','Three Rivers','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.181538,-72.372116,0,'2013-07-06 12:44:30',NULL,NULL),(57332,'66713','S','Sims','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.022713,-94.739150,0,'2013-07-06 12:44:33',NULL,NULL),(70512,'84790','S','Bloomington Hills','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.080345,-113.575391,0,'2013-07-06 12:44:34',NULL,NULL),(9120,'09137','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(54710,'62956','S','Karnak','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.292272,-88.977403,0,'2013-07-06 12:44:33',NULL,NULL),(27702,'30339','S','Vinings','A','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(31588,'34655','S','Seven Springs','N','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210274,-82.682809,0,'2013-07-06 12:44:32',NULL,NULL),(30029,'33139','S','Fisher Island','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784853,-80.144731,0,'2013-07-06 12:44:32',NULL,NULL),(5655,'04958','S','Embden','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.953794,-69.946150,0,'2013-07-06 12:44:30',NULL,NULL),(78728,'98279','S','Olga','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.659198,-122.826703,0,'2013-07-06 12:44:34',NULL,NULL),(78631,'98213','P','Everett','D','Snohomish','53061','Washington','WA','53','7600','425','Pacific',-8.0,'Y',47.940819,-122.234719,0,'2013-07-06 12:44:34',NULL,NULL),(8900,'08733','S','Lakehurst NAEC','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(30217,'33185','S','Olympia Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.716424,-80.437255,0,'2013-07-06 12:44:32',NULL,NULL),(55450,'63703','S','Cpe Girardeau','A','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.296342,-89.537946,0,'2013-07-06 12:44:33',NULL,NULL),(17110,'17771','S','Kelleysburg','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(13109,'13482','S','West Burlington','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.694287,-75.193783,0,'2013-07-06 12:44:30',NULL,NULL),(52219,'60484','S','University Pk','A','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466347,-87.698762,0,'2013-07-06 12:44:33',NULL,NULL),(45658,'52002','S','Dubuque','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.511769,-90.749087,0,'2013-07-06 12:44:32',NULL,NULL),(57569,'67054','S','Greensburg','D','Kiowa','20097','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.604900,-99.294874,0,'2013-07-06 12:44:33',NULL,NULL),(68967,'83013','S','Moran','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.940831,-110.310607,0,'2013-07-06 12:44:34',NULL,NULL),(71092,'85935','S','Pinetop','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.122099,-109.925677,0,'2013-07-06 12:44:34',NULL,NULL),(77112,'96146','S','Alpine Mdws','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.150000,-120.150000,0,'2013-07-06 12:44:34',NULL,NULL),(75865,'94945','S','Novato','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.124448,-122.550509,0,'2013-07-06 12:44:34',NULL,NULL),(50990,'58647','S','Schefield','N','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.538980,-102.864983,0,'2013-07-06 12:44:33',NULL,NULL),(21631,'22910','U','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.021668,-78.598714,0,'2013-07-06 12:44:31',NULL,NULL),(11050,'11575','S','Roosevelt','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.679893,-73.591430,0,'2013-07-06 12:44:30',NULL,NULL),(34279,'38477','S','Prospect','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.051581,-87.009633,0,'2013-07-06 12:44:32',NULL,NULL),(416,'00662','S','Repto Monte Claro','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(69407,'83626','S','Greenleaf','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.669826,-116.818546,0,'2013-07-06 12:44:34',NULL,NULL),(37982,'42732','S','Eastview','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.606912,-86.114062,0,'2013-07-06 12:44:32',NULL,NULL),(39535,'44833','S','Blooming Grove','N','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.735262,-82.797835,0,'2013-07-06 12:44:32',NULL,NULL),(4191,'02823','P','Fiskeville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.734577,-71.545955,0,'2013-07-06 12:44:30',NULL,NULL),(32007,'35229','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.464351,-86.795405,0,'2013-07-06 12:44:32',NULL,NULL),(36112,'40222','S','Glenview Hls','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(68670,'81657','S','East Vail','N','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.650220,-106.360740,0,'2013-07-06 12:44:34',NULL,NULL),(66596,'78754','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.345825,-97.661056,0,'2013-07-06 12:44:34',NULL,NULL),(11614,'12094','S','Johnsonville','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.932662,-73.506739,0,'2013-07-06 12:44:30',NULL,NULL),(30030,'33139','S','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784853,-80.144731,0,'2013-07-06 12:44:32',NULL,NULL),(65422,'77577','S','Liverpool','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.272215,-95.255614,0,'2013-07-06 12:44:34',NULL,NULL),(77800,'97137','S','Saint Paul','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.220766,-122.953219,0,'2013-07-06 12:44:34',NULL,NULL),(4390,'03108','P','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.946210,-71.439047,0,'2013-07-06 12:44:30',NULL,NULL),(4589,'03581','S','Shelburne','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.400621,-71.192698,0,'2013-07-06 12:44:30',NULL,NULL),(24829,'27609','S','North Hills','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.841720,-78.632520,0,'2013-07-06 12:44:31',NULL,NULL),(24592,'27325','S','Glendon','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.429683,-79.581817,0,'2013-07-06 12:44:31',NULL,NULL),(65246,'77459','S','Sienna Plant','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.525902,-95.531735,0,'2013-07-06 12:44:34',NULL,NULL),(61634,'72840','S','Hartman','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.440758,-93.662707,0,'2013-07-06 12:44:33',NULL,NULL),(59647,'71044','S','Ida','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.957220,-93.903720,0,'2013-07-06 12:44:33',NULL,NULL),(18666,'19179','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.032062,-75.177546,0,'2013-07-06 12:44:31',NULL,NULL),(13397,'13750','S','Davenport','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.469080,-74.807400,0,'2013-07-06 12:44:31',NULL,NULL),(45925,'52330','S','Ryan','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.350073,-91.482006,0,'2013-07-06 12:44:32',NULL,NULL),(46296,'53052','P','Menomonee Falls','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.178003,-88.119438,0,'2013-07-06 12:44:32',NULL,NULL),(56758,'65731','S','Powersite','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.637501,-93.080078,0,'2013-07-06 12:44:33',NULL,NULL),(12556,'13045','S','Virgil','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.602760,-76.171860,0,'2013-07-06 12:44:30',NULL,NULL),(56942,'66087','S','Severance','A','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.780540,-95.088600,0,'2013-07-06 12:44:33',NULL,NULL),(34178,'38314','P','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.572680,-88.821300,0,'2013-07-06 12:44:32',NULL,NULL),(13085,'13465','S','Solsville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.910640,-75.521019,0,'2013-07-06 12:44:30',NULL,NULL),(58284,'68410','S','Nebr City','N','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.674994,-95.861844,0,'2013-07-06 12:44:33',NULL,NULL),(68096,'80943','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837361,-104.823078,0,'2013-07-06 12:44:34',NULL,NULL),(72116,'88253','S','Lake Arthur','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.988371,-104.412521,0,'2013-07-06 12:44:34',NULL,NULL),(64072,'76140','S','Everman','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.612498,-97.271398,0,'2013-07-06 12:44:34',NULL,NULL),(197,'00623','S','Urb La Concepcion','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(5471,'04739','S','Wntervlle Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.040052,-68.589901,0,'2013-07-06 12:44:30',NULL,NULL),(51656,'59901','S','Evergreen','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.211236,-114.293904,0,'2013-07-06 12:44:33',NULL,NULL),(23762,'25962','S','Lilly Park','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(78652,'98226','S','Bellingham','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.763345,-122.443649,0,'2013-07-06 12:44:34',NULL,NULL),(68555,'81430','P','Sawpit','N','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.040148,-108.064432,0,'2013-07-06 12:44:34',NULL,NULL),(68059,'80933','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.934825,-105.004782,0,'2013-07-06 12:44:34',NULL,NULL),(8726,'08510','S','Millstone Township','D','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.189800,-74.441400,0,'2013-07-06 12:44:30',NULL,NULL),(66403,'78629','S','Maurin','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(51465,'59525','S','Gildford','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.601564,-110.267779,0,'2013-07-06 12:44:33',NULL,NULL),(13203,'13625','S','Colton','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.538104,-74.928858,0,'2013-07-06 12:44:30',NULL,NULL),(31936,'35185','P','Westover','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.344597,-86.541432,0,'2013-07-06 12:44:32',NULL,NULL),(25724,'28545','S','McCutcheon Field','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.683745,-77.341910,0,'2013-07-06 12:44:31',NULL,NULL),(59195,'70371','P','Kraemer','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.867564,-90.598121,0,'2013-07-06 12:44:33',NULL,NULL),(51488,'59623','U','City County Building','N','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.608066,-112.014893,0,'2013-07-06 12:44:33',NULL,NULL),(64902,'77088','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.880263,-95.453243,0,'2013-07-06 12:44:34',NULL,NULL),(46644,'53596','U','Sun Prairie','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.195587,-89.264013,0,'2013-07-06 12:44:32',NULL,NULL),(6027,'05403','S','Queen City Park','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(1453,'00742','P','Roosevelt Rds','A','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.238935,-65.627433,0,'2013-07-06 12:44:30',NULL,NULL),(51301,'59225','S','Frazer','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.400000,-105.883333,0,'2013-07-06 12:44:33',NULL,NULL),(49947,'57341','S','Bailey','N','Buffalo','46017','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.085809,-99.068600,0,'2013-07-06 12:44:33',NULL,NULL),(13941,'14441','S','Dresden','D','Yates','36123','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.688633,-76.955886,0,'2013-07-06 12:44:31',NULL,NULL),(15951,'17024','S','Little German','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(28261,'31070','S','Pinehurst','D','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.193022,-83.760561,0,'2013-07-06 12:44:31',NULL,NULL),(24455,'27217','S','Burlington','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.127359,-79.415724,0,'2013-07-06 12:44:31',NULL,NULL),(62322,'74042','S','Lenapah','D','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.854195,-95.636555,0,'2013-07-06 12:44:33',NULL,NULL),(67880,'80841','P','Cadet Sta','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.010740,-104.866903,0,'2013-07-06 12:44:34',NULL,NULL),(56764,'65737','S','Lakeview','N','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.679200,-93.370680,0,'2013-07-06 12:44:33',NULL,NULL),(58764,'68967','S','Albany','N','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(71886,'87735','S','Ojo Feliz','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.055745,-105.117418,0,'2013-07-06 12:44:34',NULL,NULL),(1000,'00717','S','Urb Constancia Gdns','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(35351,'39440','S','Glade','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(10185,'10286','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705704,-74.007966,0,'2013-07-06 12:44:30',NULL,NULL),(40541,'45844','S','Ft Jennings','N','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.915999,-84.290490,0,'2013-07-06 12:44:32',NULL,NULL),(36351,'40442','S','Kings Mountain','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.366098,-84.701152,0,'2013-07-06 12:44:32',NULL,NULL),(19555,'20202','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896694,-77.028060,0,'2013-07-06 12:44:31',NULL,NULL),(16320,'17122','U','Bureau of Motor Vehicles','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263288,-76.881597,0,'2013-07-06 12:44:31',NULL,NULL),(61809,'73102','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.471927,-97.518257,0,'2013-07-06 12:44:33',NULL,NULL),(63536,'75759','P','Cuney','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.872734,-95.226061,0,'2013-07-06 12:44:33',NULL,NULL),(76262,'95416','P','B H Springs','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.312407,-122.482861,0,'2013-07-06 12:44:34',NULL,NULL),(71370,'87001','S','Domingo','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.382532,-106.479515,0,'2013-07-06 12:44:34',NULL,NULL),(16298,'17109','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.301280,-76.799940,0,'2013-07-06 12:44:31',NULL,NULL),(35219,'39302','P','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.365411,-88.700251,0,'2013-07-06 12:44:32',NULL,NULL),(43222,'48310','S','Sterling Heights','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.566407,-83.068010,0,'2013-07-06 12:44:32',NULL,NULL),(42977,'48138','S','Hickory Isle','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134339,-83.153677,0,'2013-07-06 12:44:32',NULL,NULL),(3407,'01702','S','Framingham','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.272053,-71.424769,0,'2013-07-06 12:44:30',NULL,NULL),(78382,'98025','P','Hobart','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.418778,-121.966316,0,'2013-07-06 12:44:34',NULL,NULL),(57848,'67561','S','Nickerson','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.144304,-98.080396,0,'2013-07-06 12:44:33',NULL,NULL),(35841,'39776','S','Atlanta','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.794434,-89.053443,0,'2013-07-06 12:44:32',NULL,NULL),(6886,'06142','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.775997,-72.697466,0,'2013-07-06 12:44:30',NULL,NULL),(34456,'38658','S','Pope','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.218345,-89.946584,0,'2013-07-06 12:44:32',NULL,NULL),(24396,'27105','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.150762,-80.234242,0,'2013-07-06 12:44:31',NULL,NULL),(61381,'72529','S','Cherokee Vlg','A','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.295430,-91.540492,0,'2013-07-06 12:44:33',NULL,NULL),(66236,'78569','S','Los Coyotes','N','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.410500,-97.764420,0,'2013-07-06 12:44:34',NULL,NULL),(75456,'94080','S','S San Francisco','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.652366,-122.430543,0,'2013-07-06 12:44:34',NULL,NULL),(43955,'49306','S','Belmont','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.077653,-85.587725,0,'2013-07-06 12:44:32',NULL,NULL),(62933,'75091','P','Sherman','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.634874,-96.609047,0,'2013-07-06 12:44:33',NULL,NULL),(76175,'95327','S','Jamestown','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.919269,-120.439562,0,'2013-07-06 12:44:34',NULL,NULL),(73576,'91380','P','Santa Clarita','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.499933,-118.394976,0,'2013-07-06 12:44:34',NULL,NULL),(20005,'20611','S','Bel Alton','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.477162,-76.981786,0,'2013-07-06 12:44:31',NULL,NULL),(16846,'17562','S','Harristown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(11980,'12469','S','Preston Hollow','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.456600,-74.220660,0,'2013-07-06 12:44:30',NULL,NULL),(5642,'04949','S','Liberty','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.367320,-69.342471,0,'2013-07-06 12:44:30',NULL,NULL),(49294,'56523','S','Eldred','A','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.639460,-96.798660,0,'2013-07-06 12:44:33',NULL,NULL),(27401,'30088','S','Stone Mtn','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.762657,-84.176061,0,'2013-07-06 12:44:31',NULL,NULL),(56181,'65013','S','Koenig','N','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(41134,'46628','S','Lydick','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.698701,-86.309464,0,'2013-07-06 12:44:32',NULL,NULL),(13631,'13903','S','Park Terrace','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.097500,-75.894240,0,'2013-07-06 12:44:31',NULL,NULL),(39706,'45042','S','W Middletown','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.545160,-84.439260,0,'2013-07-06 12:44:32',NULL,NULL),(13565,'13839','S','Sidney Center','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.220441,-75.323336,0,'2013-07-06 12:44:31',NULL,NULL),(30244,'33196','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.651234,-80.481360,0,'2013-07-06 12:44:32',NULL,NULL),(32739,'36321','S','Cowarts','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199896,-85.299320,0,'2013-07-06 12:44:32',NULL,NULL),(50950,'58601','S','New Hradec','A','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.882628,-102.783495,0,'2013-07-06 12:44:33',NULL,NULL),(9744,'10095','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748793,-73.989926,0,'2013-07-06 12:44:30',NULL,NULL),(21306,'22405','S','Falmouth','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.320601,-77.414651,0,'2013-07-06 12:44:31',NULL,NULL),(43741,'49001','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.263880,-85.464000,0,'2013-07-06 12:44:32',NULL,NULL),(43649,'48842','S','Holt','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.640455,-84.528731,0,'2013-07-06 12:44:32',NULL,NULL),(41080,'46531','S','Grovertown','D','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.325500,-86.520662,0,'2013-07-06 12:44:32',NULL,NULL),(41521,'46984','P','Somerset','D','Wabash','18169','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.668252,-85.828011,0,'2013-07-06 12:44:32',NULL,NULL),(71110,'86004','S','Flagstaff','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.225571,-111.571500,0,'2013-07-06 12:44:34',NULL,NULL),(75523,'94161','U','Bank of America','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.798530,-122.399890,0,'2013-07-06 12:44:34',NULL,NULL),(18067,'18704','S','Kingston','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(29631,'32887','U','HBJ','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.384748,-81.467936,0,'2013-07-06 12:44:32',NULL,NULL),(69177,'83332','S','Hagerman','D','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.822866,-114.883889,0,'2013-07-06 12:44:34',NULL,NULL),(45940,'52339','S','Tama','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.966336,-92.573220,0,'2013-07-06 12:44:32',NULL,NULL),(50799,'58448','S','Hannaford','D','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.269722,-98.194167,0,'2013-07-06 12:44:33',NULL,NULL),(12075,'12550','S','Balmville','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.517480,-74.060220,0,'2013-07-06 12:44:30',NULL,NULL),(35457,'39483','S','Pickwick','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(7294,'06537','U','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.431433,-72.910481,0,'2013-07-06 12:44:30',NULL,NULL),(32210,'35560','P','Goodsprings','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.666004,-87.231064,0,'2013-07-06 12:44:32',NULL,NULL),(30748,'33550','P','Mango','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.977903,-82.303118,0,'2013-07-06 12:44:32',NULL,NULL),(58324,'68447','S','Table Rock','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.180260,-96.095765,0,'2013-07-06 12:44:33',NULL,NULL),(58679,'68902','P','Hastings','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.585426,-98.385122,0,'2013-07-06 12:44:33',NULL,NULL),(63652,'75845','S','Lacy','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(39989,'45241','S','Evendale','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267662,-84.405863,0,'2013-07-06 12:44:32',NULL,NULL),(71586,'87315','S','Fence Lake','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.763663,-108.783817,0,'2013-07-06 12:44:34',NULL,NULL),(70126,'84199','U','Us Postal Service','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725101,-111.939531,0,'2013-07-06 12:44:34',NULL,NULL),(24421,'27152','U','Integon Corp','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.104411,-80.206453,0,'2013-07-06 12:44:31',NULL,NULL),(31269,'34004','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(56633,'65606','S','Alton','D','Oregon','29149','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.708600,-91.367400,0,'2013-07-06 12:44:33',NULL,NULL),(33900,'38042','S','Hickory Vly','A','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.322522,-89.152200,0,'2013-07-06 12:44:32',NULL,NULL),(19395,'20070','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878561,-77.230131,0,'2013-07-06 12:44:31',NULL,NULL),(76966,'96049','P','Redding','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.564486,-122.296269,0,'2013-07-06 12:44:34',NULL,NULL),(75652,'94529','U','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.874619,-122.047244,0,'2013-07-06 12:44:34',NULL,NULL),(69114,'83274','S','Goshen','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.379837,-112.124740,0,'2013-07-06 12:44:34',NULL,NULL),(66623,'78779','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.348092,-97.768262,0,'2013-07-06 12:44:34',NULL,NULL),(50943,'58577','S','Falkirk','N','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.318580,-101.017020,0,'2013-07-06 12:44:33',NULL,NULL),(6020,'05401','S','BTV','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487240,-73.227780,0,'2013-07-06 12:44:30',NULL,NULL),(21621,'22907','U','Charlottesvile Brm','N','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.952452,-78.492913,0,'2013-07-06 12:44:31',NULL,NULL),(6767,'06095','S','Windsor','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.863764,-72.668509,0,'2013-07-06 12:44:30',NULL,NULL),(80163,'99820','P','Angoon','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.684678,-134.382269,0,'2013-07-06 12:44:34',NULL,NULL),(64256,'76374','S','Olney','D','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',33.368531,-98.762652,0,'2013-07-06 12:44:34',NULL,NULL),(43568,'48731','S','Elkton','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.833028,-83.158864,0,'2013-07-06 12:44:32',NULL,NULL),(30109,'33160','S','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(68688,'82009','S','Iron Mountain','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.207382,-104.827712,0,'2013-07-06 12:44:34',NULL,NULL),(3835,'02338','S','Halifax','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.001029,-70.851712,0,'2013-07-06 12:44:30',NULL,NULL),(70872,'85605','P','Bowie','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.163358,-109.335116,0,'2013-07-06 12:44:34',NULL,NULL),(69420,'83631','S','Steirman','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(38377,'43501','S','Alvordton','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.644753,-84.448647,0,'2013-07-06 12:44:32',NULL,NULL),(42969,'48134','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.107811,-83.281359,0,'2013-07-06 12:44:32',NULL,NULL),(47946,'55117','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.000144,-93.083067,0,'2013-07-06 12:44:33',NULL,NULL),(50007,'57381','S','Danforth','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.373351,-98.680654,0,'2013-07-06 12:44:33',NULL,NULL),(20246,'20782','S','Avondale','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(33944,'38076','S','Oakland','A','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.167612,-89.377588,0,'2013-07-06 12:44:32',NULL,NULL),(30141,'33166','S','Medley','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(60325,'71459','S','Fort Polk','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.995820,-93.246900,0,'2013-07-06 12:44:33',NULL,NULL),(60595,'71837','S','Fouke','D','Miller','05091','Arkansas','AR','05','8360','870','Central',-6.0,'Y',33.286971,-93.891637,0,'2013-07-06 12:44:33',NULL,NULL),(5461,'04734','P','Blaine','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.503069,-67.869943,0,'2013-07-06 12:44:30',NULL,NULL),(2129,'00924','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(47435,'54703','S','Hallie','N','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.824477,-91.498625,0,'2013-07-06 12:44:32',NULL,NULL),(48110,'55350','S','Cedar Mills','N','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.890688,-94.370230,0,'2013-07-06 12:44:33',NULL,NULL),(49927,'57323','S','Carthage','D','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.174556,-97.719752,0,'2013-07-06 12:44:33',NULL,NULL),(55029,'63136','S','Moline Acres','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(35106,'39208','S','Pearl','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.271720,-90.104940,0,'2013-07-06 12:44:32',NULL,NULL),(41905,'47374','S','Chester','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(23713,'25882','S','Mullens','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.584243,-81.387619,0,'2013-07-06 12:44:31',NULL,NULL),(79830,'99516','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.104106,-149.778328,0,'2013-07-06 12:44:34',NULL,NULL),(20728,'21286','S','Loch Raven','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.406546,-76.581702,0,'2013-07-06 12:44:31',NULL,NULL),(26736,'29419','P','No Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.936047,-80.100088,0,'2013-07-06 12:44:31',NULL,NULL),(76337,'95467','S','Hidden Vl Lk','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.810967,-122.556198,0,'2013-07-06 12:44:34',NULL,NULL),(70838,'85534','S','Virden','N','Greenlee','04011','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.714671,-109.100465,0,'2013-07-06 12:44:34',NULL,NULL),(69812,'84071','S','Stockton','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.449676,-112.359074,0,'2013-07-06 12:44:34',NULL,NULL),(68055,'80932','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848511,-104.780034,0,'2013-07-06 12:44:34',NULL,NULL),(62714,'74755','S','Rufe','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.159058,-95.125044,0,'2013-07-06 12:44:33',NULL,NULL),(14942,'15565','S','West Salisbury','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.752803,-79.096393,0,'2013-07-06 12:44:31',NULL,NULL),(35247,'39338','S','Montrose','N','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.122380,-89.229600,0,'2013-07-06 12:44:32',NULL,NULL),(57788,'67480','S','Solomon','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.918024,-97.371141,0,'2013-07-06 12:44:33',NULL,NULL),(53944,'62419','S','Berryville','N','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.723920,-88.185778,0,'2013-07-06 12:44:33',NULL,NULL),(12494,'12997','S','Whiteface Mtn','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.388992,-73.843700,0,'2013-07-06 12:44:30',NULL,NULL),(32534,'36104','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.409628,-86.330198,0,'2013-07-06 12:44:32',NULL,NULL),(30584,'33417','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.714953,-80.124964,0,'2013-07-06 12:44:32',NULL,NULL),(11508,'12027','S','Burnt Hills','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.916475,-73.901761,0,'2013-07-06 12:44:30',NULL,NULL),(78768,'98310','S','Crosby','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(37573,'42081','S','Carrsville','A','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.397500,-88.374722,0,'2013-07-06 12:44:32',NULL,NULL),(6291,'05650','S','East Calais','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.351384,-72.439832,0,'2013-07-06 12:44:30',NULL,NULL),(26971,'29613','U','Furman University','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.949211,-82.438690,0,'2013-07-06 12:44:31',NULL,NULL),(38394,'43523','P','Grelton','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.342644,-84.000355,0,'2013-07-06 12:44:32',NULL,NULL),(40695,'46075','S','Whitestown','D','Boone','18011','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.982382,-86.350940,0,'2013-07-06 12:44:32',NULL,NULL),(50295,'57701','S','Jolly Acres','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.080920,-103.172940,0,'2013-07-06 12:44:33',NULL,NULL),(55442,'63673','S','Saint Marys','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.827600,-90.039600,0,'2013-07-06 12:44:33',NULL,NULL),(821,'00693','S','Urb San Agustin','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(18898,'19473','S','Fruitville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.237680,-75.481440,0,'2013-07-06 12:44:31',NULL,NULL),(25667,'28510','S','Minnesott Bch','A','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.979257,-76.825851,0,'2013-07-06 12:44:31',NULL,NULL),(66678,'78934','S','Hillcrest','N','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.698260,-96.566400,0,'2013-07-06 12:44:34',NULL,NULL),(32640,'36205','S','Fort Mc Clellan','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.659722,-85.831667,0,'2013-07-06 12:44:32',NULL,NULL),(63420,'75657','S','Smithland','A','Marion','48315','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.787670,-94.073130,0,'2013-07-06 12:44:33',NULL,NULL),(10997,'11550','S','South Hempstead','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.708785,-73.624573,0,'2013-07-06 12:44:30',NULL,NULL),(37191,'41514','S','Belfry','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(37792,'42369','S','Rockport','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.287670,-86.933978,0,'2013-07-06 12:44:32',NULL,NULL),(41531,'46991','S','Van Buren','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.626360,-85.495440,0,'2013-07-06 12:44:32',NULL,NULL),(42991,'48158','S','Manchester','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.162540,-84.020040,0,'2013-07-06 12:44:32',NULL,NULL),(47328,'54562','S','Clearwater Lk','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.805375,-89.123651,0,'2013-07-06 12:44:32',NULL,NULL),(46419,'53185','S','Wind Lake','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.787140,-88.206480,0,'2013-07-06 12:44:32',NULL,NULL),(39390,'44656','S','Mineral City','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.609320,-81.358200,0,'2013-07-06 12:44:32',NULL,NULL),(60452,'71653','S','Ashton','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(30357,'33313','S','Lauderdale Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(65846,'78163','S','Bulverde','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.679028,-98.411488,0,'2013-07-06 12:44:34',NULL,NULL),(63772,'75948','S','Hemphill','D','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.308720,-93.771600,0,'2013-07-06 12:44:34',NULL,NULL),(36911,'41139','S','Flatwoods','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.520483,-82.721857,0,'2013-07-06 12:44:32',NULL,NULL),(32352,'35811','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.780058,-86.523910,0,'2013-07-06 12:44:32',NULL,NULL),(8363,'08051','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.787980,-75.181295,0,'2013-07-06 12:44:30',NULL,NULL),(2341,'00936','P','San Jose','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(1402,'00738','S','Urb Melendez','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(16754,'17516','S','Creswell','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.925500,-76.366080,0,'2013-07-06 12:44:31',NULL,NULL),(22409,'23966','S','Rice','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.287660,-78.280962,0,'2013-07-06 12:44:31',NULL,NULL),(64933,'77217','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.702057,-95.266235,0,'2013-07-06 12:44:34',NULL,NULL),(56754,'65727','S','Polk','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.754824,-93.292646,0,'2013-07-06 12:44:33',NULL,NULL),(71759,'87551','S','Los Ojos','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.673323,-106.552060,0,'2013-07-06 12:44:34',NULL,NULL),(1077,'00725','S','Terr De Borinquen','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(6014,'05361','S','Whitingham','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.782671,-72.872828,0,'2013-07-06 12:44:30',NULL,NULL),(55839,'64158','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.236716,-94.481086,0,'2013-07-06 12:44:33',NULL,NULL),(43443,'48507','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.970942,-83.703232,0,'2013-07-06 12:44:32',NULL,NULL),(30361,'33313','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(23950,'26278','S','Mabie','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.814840,-80.031844,0,'2013-07-06 12:44:31',NULL,NULL),(79411,'98816','S','Holden Village','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.850024,-120.044073,0,'2013-07-06 12:44:34',NULL,NULL),(5430,'04676','S','Sedgwick','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.342650,-68.647623,0,'2013-07-06 12:44:30',NULL,NULL),(22334,'23870','U','Greenville Correctional Ctr','N','Greensville','51081','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.813701,-77.469979,0,'2013-07-06 12:44:31',NULL,NULL),(19172,'19732','P','Rockland','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.792047,-75.572962,0,'2013-07-06 12:44:31',NULL,NULL),(67641,'80459','S','Kremmling','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.074207,-106.407762,0,'2013-07-06 12:44:34',NULL,NULL),(35854,'39824','S','Bluffton','D','Clay','13061','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.552394,-84.899796,0,'2013-07-06 12:44:32',NULL,NULL),(29048,'32237','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.243390,-81.619117,0,'2013-07-06 12:44:32',NULL,NULL),(18914,'19492','S','Zieglersville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.283333,-75.483333,0,'2013-07-06 12:44:31',NULL,NULL),(36629,'41002','S','Sharon','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.770754,-84.002867,0,'2013-07-06 12:44:32',NULL,NULL),(12173,'12759','S','Loch Sheldrke','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.784360,-74.659800,0,'2013-07-06 12:44:30',NULL,NULL),(35132,'39215','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.297171,-90.183699,0,'2013-07-06 12:44:32',NULL,NULL),(48914,'56139','S','Holland','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087975,-96.188304,0,'2013-07-06 12:44:33',NULL,NULL),(22220,'23551','U','Cinclantflt','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.848151,-76.288565,0,'2013-07-06 12:44:31',NULL,NULL),(44407,'49825','P','Eben Jct','N','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.353420,-87.033521,0,'2013-07-06 12:44:32',NULL,NULL),(17043,'17749','P','McEwensville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.073697,-76.821257,0,'2013-07-06 12:44:31',NULL,NULL),(41769,'47303','S','Desoto','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(31166,'33917','S','North Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(64511,'76634','S','Lakewood Harbor','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(74123,'92239','P','Desert Center','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.712500,-115.401389,0,'2013-07-06 12:44:34',NULL,NULL),(67960,'80913','S','Fort Carson','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(47411,'54654','P','Seneca','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.263385,-90.956187,0,'2013-07-06 12:44:32',NULL,NULL),(54481,'62860','S','Macedonia','D','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.009242,-88.683189,0,'2013-07-06 12:44:33',NULL,NULL),(55976,'64601','S','Avalon','A','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.793244,-93.553948,0,'2013-07-06 12:44:33',NULL,NULL),(2907,'00987','S','Villa de San Anton','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(61859,'73122','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.522969,-97.614030,0,'2013-07-06 12:44:33',NULL,NULL),(8679,'08330','S','Mays Landing','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440760,-74.728980,0,'2013-07-06 12:44:30',NULL,NULL),(14586,'15221','S','Braddock Hills','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(43248,'48320','S','Keego Harbor','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.609351,-83.345619,0,'2013-07-06 12:44:32',NULL,NULL),(53337,'61754','S','Funks Grove','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.314947,-89.170467,0,'2013-07-06 12:44:33',NULL,NULL),(361,'00659','S','Ext Villa del Carmen','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(50813,'58460','S','Lehr','D','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.281795,-99.354875,0,'2013-07-06 12:44:33',NULL,NULL),(50521,'58079','S','Wheatland','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.877214,-97.409644,0,'2013-07-06 12:44:33',NULL,NULL),(29718,'32951','S','Melbourne Beach','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.024675,-80.539219,0,'2013-07-06 12:44:32',NULL,NULL),(40189,'45381','S','W Alex','N','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.729736,-84.535455,0,'2013-07-06 12:44:32',NULL,NULL),(79375,'98665','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.690124,-122.664338,0,'2013-07-06 12:44:34',NULL,NULL),(77917,'97312','U','State Accident Ins','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.893155,-123.060071,0,'2013-07-06 12:44:34',NULL,NULL),(58897,'69190','U','Cabela\'s','N','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408180,-102.343473,0,'2013-07-06 12:44:33',NULL,NULL),(13704,'14061','P','Farnham','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.592321,-79.088492,0,'2013-07-06 12:44:31',NULL,NULL),(33257,'37083','S','Lafayette','D','Macon','47111','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.524054,-86.024892,0,'2013-07-06 12:44:32',NULL,NULL),(35684,'39661','S','Hamburg','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(11583,'12074','S','Hagedorns Mills','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.032199,-74.036378,0,'2013-07-06 12:44:30',NULL,NULL),(5156,'04422','S','Charleston','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.068928,-69.085771,0,'2013-07-06 12:44:30',NULL,NULL),(56571,'65483','S','Tyrone','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.323082,-91.964295,0,'2013-07-06 12:44:33',NULL,NULL),(23038,'24854','P','Kopperston','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.745130,-81.570297,0,'2013-07-06 12:44:31',NULL,NULL),(43079,'48198','S','Ypsilanti','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.248536,-83.586753,0,'2013-07-06 12:44:32',NULL,NULL),(66328,'78598','P','Raymondville','A','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.560268,-97.431370,0,'2013-07-06 12:44:34',NULL,NULL),(17348,'17870','S','Monroe Twp','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(19204,'19885','U','Shared Firm Zip','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743278,-75.547128,0,'2013-07-06 12:44:31',NULL,NULL),(56395,'65239','S','Cairo','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.520714,-92.420763,0,'2013-07-06 12:44:33',NULL,NULL),(4309,'02910','S','Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.777181,-71.436666,0,'2013-07-06 12:44:30',NULL,NULL),(37504,'42031','S','Oakton','N','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(31203,'33947','S','Rotonda West','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.890856,-82.289031,0,'2013-07-06 12:44:32',NULL,NULL),(67767,'80639','U','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.401197,-104.701365,0,'2013-07-06 12:44:34',NULL,NULL),(55303,'63532','S','Keota','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.750077,-92.562520,0,'2013-07-06 12:44:33',NULL,NULL),(66492,'78673','P','Walburg','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.736534,-97.577601,0,'2013-07-06 12:44:34',NULL,NULL),(38115,'43107','S','Hide Away Hills','N','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.696084,-82.422138,0,'2013-07-06 12:44:32',NULL,NULL),(14522,'15204','S','Corliss','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.452082,-80.056352,0,'2013-07-06 12:44:31',NULL,NULL),(5788,'05056','S','Plymouth Kingdom','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.512000,-72.720000,0,'2013-07-06 12:44:30',NULL,NULL),(13130,'13491','S','Winfield','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(51274,'59107','P','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.813869,-108.505776,0,'2013-07-06 12:44:33',NULL,NULL),(16595,'17324','S','Uriah','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(15260,'16063','S','Zelienople','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.774935,-80.119536,0,'2013-07-06 12:44:31',NULL,NULL),(5316,'04570','P','Boothbay Harbor','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.807043,-69.634374,0,'2013-07-06 12:44:30',NULL,NULL),(78003,'97410','S','Azalea','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.792077,-123.220657,0,'2013-07-06 12:44:34',NULL,NULL),(78387,'98028','S','Bothell','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.750000,-122.240000,0,'2013-07-06 12:44:34',NULL,NULL),(1257,'00729','S','Urb River Valley','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(73390,'91109','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.167069,-118.164718,0,'2013-07-06 12:44:34',NULL,NULL),(79972,'99647','P','Pedro Bay','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.750000,-154.916667,0,'2013-07-06 12:44:34',NULL,NULL),(2960,'01038','S','West Hatfield','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.381499,-72.607454,0,'2013-07-06 12:44:30',NULL,NULL),(55559,'63862','S','Lilbourn','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.588932,-89.617667,0,'2013-07-06 12:44:33',NULL,NULL),(56212,'65032','S','Spring Garden','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.386782,-92.366414,0,'2013-07-06 12:44:33',NULL,NULL),(10952,'11451','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699605,-73.799982,0,'2013-07-06 12:44:30',NULL,NULL),(41940,'47390','S','South Salem','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.202822,-84.817856,0,'2013-07-06 12:44:32',NULL,NULL),(37102,'41348','S','Ned','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480000,-83.320000,0,'2013-07-06 12:44:32',NULL,NULL),(11933,'12430','S','Halcott Center','A','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.195000,-74.550556,0,'2013-07-06 12:44:30',NULL,NULL),(18584,'19132','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.992702,-75.166366,0,'2013-07-06 12:44:31',NULL,NULL),(15320,'16161','P','Wheatland','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.201592,-80.492161,0,'2013-07-06 12:44:31',NULL,NULL),(34327,'38559','S','Doyle','D','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.866079,-85.496926,0,'2013-07-06 12:44:32',NULL,NULL),(64853,'77050','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.899585,-95.270162,0,'2013-07-06 12:44:34',NULL,NULL),(64048,'76131','S','Blue Mound','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.858146,-97.330601,0,'2013-07-06 12:44:34',NULL,NULL),(38866,'44099','S','Windsor Mills','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.561142,-80.966990,0,'2013-07-06 12:44:32',NULL,NULL),(33775,'37870','S','Speedwell','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.477773,-83.812782,0,'2013-07-06 12:44:32',NULL,NULL),(2331,'00935','U','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410481,-66.065613,0,'2013-07-06 12:44:30',NULL,NULL),(31592,'34656','P','New Pt Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.243613,-82.709068,0,'2013-07-06 12:44:32',NULL,NULL),(47548,'54828','S','Couderay','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.796363,-91.343774,0,'2013-07-06 12:44:32',NULL,NULL),(30225,'33187','S','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.585600,-80.504660,0,'2013-07-06 12:44:32',NULL,NULL),(60159,'71404','S','Iatt Lake','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.832832,-92.788989,0,'2013-07-06 12:44:33',NULL,NULL),(71626,'87401','S','Bisti','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.741697,-108.191411,0,'2013-07-06 12:44:34',NULL,NULL),(417,'00662','S','Repto San Antonio','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(76366,'95497','P','The Sea Ranch','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.740768,-123.483539,0,'2013-07-06 12:44:34',NULL,NULL),(76214,'95366','S','Ripon','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.778832,-121.124563,0,'2013-07-06 12:44:34',NULL,NULL),(27871,'30442','S','Thrift','N','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(20911,'21721','P','Chewsville','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.648217,-77.627585,0,'2013-07-06 12:44:31',NULL,NULL),(30954,'33733','P','St Pete','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770605,-82.677731,0,'2013-07-06 12:44:32',NULL,NULL),(50565,'58219','S','Caledonia','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.450596,-96.917137,0,'2013-07-06 12:44:33',NULL,NULL),(45921,'52327','S','Riverside','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.483163,-91.582362,0,'2013-07-06 12:44:32',NULL,NULL),(44126,'49508','S','Wyoming','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.873625,-85.625143,0,'2013-07-06 12:44:32',NULL,NULL),(63250,'75483','P','Sulphur Spgs','A','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.142219,-95.597859,0,'2013-07-06 12:44:33',NULL,NULL),(78777,'98312','S','Camp Union','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(79202,'98532','S','Newaukum','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(60941,'72099','U','Little Rck AFB','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(60288,'71450','S','Marthaville','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.793040,-93.399660,0,'2013-07-06 12:44:33',NULL,NULL),(11988,'12475','P','Ruby','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.019102,-74.010805,0,'2013-07-06 12:44:30',NULL,NULL),(37114,'41385','S','Vancleve','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.628288,-83.413815,0,'2013-07-06 12:44:32',NULL,NULL),(73017,'90068','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.120733,-118.335397,0,'2013-07-06 12:44:34',NULL,NULL),(78375,'98022','S','Osceola','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(45656,'52001','S','Shawondasse','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(75159,'93584','P','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.699023,-118.138600,0,'2013-07-06 12:44:34',NULL,NULL),(68000,'80920','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.958459,-104.757058,0,'2013-07-06 12:44:34',NULL,NULL),(59968,'71316','S','Acme','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.260852,-91.766700,0,'2013-07-06 12:44:33',NULL,NULL),(59093,'70125','S','Broadmoor','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.952064,-90.105984,0,'2013-07-06 12:44:33',NULL,NULL),(10131,'10261','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(34675,'38821','S','South Amory','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.999660,-88.451940,0,'2013-07-06 12:44:32',NULL,NULL),(8026,'07727','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.199657,-74.163542,0,'2013-07-06 12:44:30',NULL,NULL),(39880,'45209','S','Oakley','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.152971,-84.427731,0,'2013-07-06 12:44:32',NULL,NULL),(66089,'78403','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.786386,-97.395977,0,'2013-07-06 12:44:34',NULL,NULL),(69853,'84088','S','W Jordan','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.596730,-112.001045,0,'2013-07-06 12:44:34',NULL,NULL),(75575,'94278','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.574262,-121.468927,0,'2013-07-06 12:44:34',NULL,NULL),(63192,'75425','P','Chicota','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.771506,-95.713612,0,'2013-07-06 12:44:33',NULL,NULL),(70424,'84729','P','Glendale','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.316984,-112.593213,0,'2013-07-06 12:44:34',NULL,NULL),(69507,'83714','S','Hidden Spgs','A','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.641900,-116.293500,0,'2013-07-06 12:44:34',NULL,NULL),(17518,'17966','P','Ravine','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.559216,-76.330734,0,'2013-07-06 12:44:31',NULL,NULL),(15940,'17022','S','Elizabethtown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(12521,'13031','S','Split Rock','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.044375,-76.289134,0,'2013-07-06 12:44:30',NULL,NULL),(65038,'77327','S','Tarkington Prairie','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(64911,'77098','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.736613,-95.418680,0,'2013-07-06 12:44:34',NULL,NULL),(60568,'71758','S','Mount Holly','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.314945,-92.942896,0,'2013-07-06 12:44:33',NULL,NULL),(3500,'01853','P','Lowell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.658587,-71.305216,0,'2013-07-06 12:44:30',NULL,NULL),(48435,'55702','S','Alborn','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.974185,-92.600750,0,'2013-07-06 12:44:33',NULL,NULL),(55668,'64035','S','Hardin','D','Ray','29177','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.299385,-93.812175,0,'2013-07-06 12:44:33',NULL,NULL),(280,'00646','S','Jard Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(50783,'58431','S','Dickey','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.542335,-98.471216,0,'2013-07-06 12:44:33',NULL,NULL),(72457,'89115','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.229916,-115.075490,0,'2013-07-06 12:44:34',NULL,NULL),(69103,'83255','S','Lost River','A','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869160,-113.078054,0,'2013-07-06 12:44:34',NULL,NULL),(67751,'80615','S','Severance','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.524123,-104.687892,0,'2013-07-06 12:44:34',NULL,NULL),(67100,'79710','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',32.061722,-102.021755,0,'2013-07-06 12:44:34',NULL,NULL),(30598,'33421','P','Royal Plm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(67262,'79961','U','El Paso Water Utilities','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.774025,-106.375278,0,'2013-07-06 12:44:34',NULL,NULL),(38062,'43058','P','Newark','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.059575,-82.403784,0,'2013-07-06 12:44:32',NULL,NULL),(10343,'10562','S','Crotonville','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.174335,-73.845908,0,'2013-07-06 12:44:30',NULL,NULL),(33167,'37024','P','Brentwood','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.997763,-86.785825,0,'2013-07-06 12:44:32',NULL,NULL),(32272,'35645','S','Killen','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.914766,-87.502564,0,'2013-07-06 12:44:32',NULL,NULL),(30768,'33573','S','Sun City Ctr','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.718176,-82.364372,0,'2013-07-06 12:44:32',NULL,NULL),(28175,'31002','S','Adrian','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.528899,-82.592627,0,'2013-07-06 12:44:31',NULL,NULL),(40643,'46036','S','Duck Creek','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(72427,'89070','U','Indian Spgs','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570319,-115.668132,0,'2013-07-06 12:44:34',NULL,NULL),(176,'00623','S','Haciendas de Cabo Rojo','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(38422,'43548','S','New Bavaria','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.203392,-84.166759,0,'2013-07-06 12:44:32',NULL,NULL),(38024,'43017','S','Dublin','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.100412,-83.115807,0,'2013-07-06 12:44:32',NULL,NULL),(37342,'41701','S','Hazard','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.253627,-83.184866,0,'2013-07-06 12:44:32',NULL,NULL),(76826,'95959','S','Graniteville','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.273440,-121.022061,0,'2013-07-06 12:44:34',NULL,NULL),(41615,'47122','S','Georgetown','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.305393,-85.952952,0,'2013-07-06 12:44:32',NULL,NULL),(11275,'11771','S','Oyster Bay','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(32195,'35545','P','Belk','D','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.646243,-87.931317,0,'2013-07-06 12:44:32',NULL,NULL),(45504,'51360','S','Spirit Lake','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(7806,'07440','S','Pequannock','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.946757,-74.294839,0,'2013-07-06 12:44:30',NULL,NULL),(27428,'30109','P','Bowdon Jct','A','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.567436,-85.081472,0,'2013-07-06 12:44:31',NULL,NULL),(27192,'29856','S','Windsor','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.476260,-81.527087,0,'2013-07-06 12:44:31',NULL,NULL),(40044,'45254','P','Anderson','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.105465,-84.501838,0,'2013-07-06 12:44:32',NULL,NULL),(43468,'48555','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.059116,-83.744242,0,'2013-07-06 12:44:32',NULL,NULL),(75537,'94208','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584815,-121.494887,0,'2013-07-06 12:44:34',NULL,NULL),(41635,'47131','P','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.338659,-85.705189,0,'2013-07-06 12:44:32',NULL,NULL),(2151,'00924','S','Villa Prades','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(56814,'65777','S','West Plains','N','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.535679,-91.989585,0,'2013-07-06 12:44:33',NULL,NULL),(1530,'00754','S','Urb Tamarindo 1','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(1787,'00783','S','Colinas de Corozal','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(61806,'73101','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.490436,-97.560145,0,'2013-07-06 12:44:33',NULL,NULL),(74633,'92808','S','Anaheim Hills','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.857901,-117.751326,0,'2013-07-06 12:44:34',NULL,NULL),(74593,'92701','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.752342,-117.854139,0,'2013-07-06 12:44:34',NULL,NULL),(58925,'69340','S','Antioch','N','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.174219,-102.458438,0,'2013-07-06 12:44:33',NULL,NULL),(25410,'28296','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.213020,-80.827367,0,'2013-07-06 12:44:31',NULL,NULL),(33350,'37178','S','Tn Ridge','N','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.313167,-87.764653,0,'2013-07-06 12:44:32',NULL,NULL),(41378,'46796','P','Wolf Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.335013,-85.494767,0,'2013-07-06 12:44:32',NULL,NULL),(16356,'17201','S','Chambersburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(62615,'74538','S','Colgate','N','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.534003,-96.219571,0,'2013-07-06 12:44:33',NULL,NULL),(40206,'45389','P','Christiansbrg','A','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.054168,-84.024219,0,'2013-07-06 12:44:32',NULL,NULL),(3597,'02035','S','Foxborough','A','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.062193,-71.243476,0,'2013-07-06 12:44:30',NULL,NULL),(11277,'11771','S','Upper Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(48854,'56072','S','New Richland','D','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.896674,-93.488835,0,'2013-07-06 12:44:33',NULL,NULL),(13391,'13746','S','Chenango Forks','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.269580,-75.839580,0,'2013-07-06 12:44:31',NULL,NULL),(32573,'36118','U','Gunter AFS','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.406982,-86.247828,0,'2013-07-06 12:44:32',NULL,NULL),(29317,'32537','P','Milligan','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.760921,-86.605919,0,'2013-07-06 12:44:32',NULL,NULL),(51447,'59477','P','Simms','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.496332,-111.928720,0,'2013-07-06 12:44:33',NULL,NULL),(77948,'97351','S','Independence','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.843322,-123.185997,0,'2013-07-06 12:44:34',NULL,NULL),(66405,'78629','S','Oak Forest','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(61092,'72134','S','Lookout Store','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.603333,-91.341667,0,'2013-07-06 12:44:33',NULL,NULL),(44135,'49512','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881460,-85.535400,0,'2013-07-06 12:44:32',NULL,NULL),(21645,'22932','S','Yancey Mills','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.066684,-78.702915,0,'2013-07-06 12:44:31',NULL,NULL),(48729,'55960','S','Oronoco','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.151074,-92.521283,0,'2013-07-06 12:44:33',NULL,NULL),(28300,'31106','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.787616,-84.355516,0,'2013-07-06 12:44:31',NULL,NULL),(57149,'66251','U','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(30319,'33306','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163196,-80.110875,0,'2013-07-06 12:44:32',NULL,NULL),(10064,'10178','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(46945,'54165','S','Seymour','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.500193,-88.301344,0,'2013-07-06 12:44:32',NULL,NULL),(2543,'00959','S','Ind Minillas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(7360,'06753','P','Cornwall','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.825192,-73.333575,0,'2013-07-06 12:44:30',NULL,NULL),(67558,'80274','U','Wells Fargo Bank','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.742322,-104.989512,0,'2013-07-06 12:44:34',NULL,NULL),(47748,'55019','S','Dundas','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.414790,-93.241114,0,'2013-07-06 12:44:33',NULL,NULL),(9656,'10038','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(49693,'57025','S','Spink','N','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.785700,-96.696900,0,'2013-07-06 12:44:33',NULL,NULL),(57799,'67501','S','Hutchinson','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.056168,-97.912213,0,'2013-07-06 12:44:33',NULL,NULL),(40205,'45389','P','Christiansbg','N','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.054168,-84.024219,0,'2013-07-06 12:44:32',NULL,NULL),(67207,'79914','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.902609,-106.414916,0,'2013-07-06 12:44:34',NULL,NULL),(36764,'41041','S','Mount Carmel','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(44259,'49683','S','Thompsonville','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.499017,-85.997212,0,'2013-07-06 12:44:32',NULL,NULL),(12095,'12569','S','Pleasant Vly','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.746335,-73.817266,0,'2013-07-06 12:44:30',NULL,NULL),(8172,'07870','P','Schooleys Mtn','A','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.820164,-74.761778,0,'2013-07-06 12:44:30',NULL,NULL),(55273,'63465','S','Athens','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.495020,-91.677480,0,'2013-07-06 12:44:33',NULL,NULL),(9353,'09809','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(63514,'75751','S','Crescent Heights','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(55748,'64102','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.096511,-94.606378,0,'2013-07-06 12:44:33',NULL,NULL),(42608,'47885','S','Wanda Lake','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(37432,'41828','S','Kite','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.301667,-82.789444,0,'2013-07-06 12:44:32',NULL,NULL),(69094,'83253','S','Patterson','A','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.577861,-113.809881,0,'2013-07-06 12:44:34',NULL,NULL),(62530,'74426','S','Texanna','N','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.417700,-95.553780,0,'2013-07-06 12:44:33',NULL,NULL),(50040,'57432','S','Huffton','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.667260,-98.064619,0,'2013-07-06 12:44:33',NULL,NULL),(47243,'54512','S','Boulder Junction','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.096191,-89.653823,0,'2013-07-06 12:44:32',NULL,NULL),(55327,'63546','S','Sublette','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.344581,-92.537453,0,'2013-07-06 12:44:33',NULL,NULL),(35913,'40023','S','Fisherville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.188191,-85.441224,0,'2013-07-06 12:44:32',NULL,NULL),(32497,'36064','S','Pike Road','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.322691,-86.094111,0,'2013-07-06 12:44:32',NULL,NULL),(41951,'47401','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.095259,-86.457677,0,'2013-07-06 12:44:32',NULL,NULL),(42147,'47520','S','Cannelton Heights','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(45081,'50529','S','Dakota City','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.718671,-94.197179,0,'2013-07-06 12:44:32',NULL,NULL),(45090,'50536','S','Osgood','N','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.108470,-94.678781,0,'2013-07-06 12:44:32',NULL,NULL),(77736,'97071','S','Woodburn','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.147450,-122.855971,0,'2013-07-06 12:44:34',NULL,NULL),(62204,'73840','S','Fargo','D','Ellis','40045','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.373253,-99.624852,0,'2013-07-06 12:44:33',NULL,NULL),(28797,'32059','S','Lee','D','Madison','12079','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.365439,-83.263804,0,'2013-07-06 12:44:32',NULL,NULL),(50136,'57532','S','Mission Ridge','A','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(4439,'03244','S','Hillsboro','A','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.132803,-71.929453,0,'2013-07-06 12:44:30',NULL,NULL),(34995,'39113','P','Mayersville','D','Issaquena','28055','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.851702,-91.035830,0,'2013-07-06 12:44:32',NULL,NULL),(18813,'19404','P','Norristown','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.143810,-75.369566,0,'2013-07-06 12:44:31',NULL,NULL),(31279,'34030','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(54562,'62895','S','Aden','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(33585,'37602','P','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.305672,-82.383269,0,'2013-07-06 12:44:32',NULL,NULL),(52964,'61423','S','Cameron','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.880560,-90.498553,0,'2013-07-06 12:44:33',NULL,NULL),(672,'00683','S','Urb La Quinta Dr Velez','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(15874,'16950','S','Potter Brook','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(16927,'17605','P','E Lancaster','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014997,-76.248254,0,'2013-07-06 12:44:31',NULL,NULL),(65721,'78025','S','Ingram','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',30.085405,-99.243167,0,'2013-07-06 12:44:34',NULL,NULL),(69455,'83648','S','Mountain Home AFB','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.059898,-115.854735,0,'2013-07-06 12:44:34',NULL,NULL),(65537,'77805','P','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.672945,-96.343020,0,'2013-07-06 12:44:34',NULL,NULL),(6371,'05680','S','Branch','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.546700,-72.497820,0,'2013-07-06 12:44:30',NULL,NULL),(11621,'12108','S','Higgins Bay','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.469089,-74.416358,0,'2013-07-06 12:44:30',NULL,NULL),(10932,'11433','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.697305,-73.789271,0,'2013-07-06 12:44:30',NULL,NULL),(32002,'35226','S','Vestavia Hills','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(41768,'47303','S','Country Terrace','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(9011,'08862','P','Perth Amboy','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.520753,-74.269434,0,'2013-07-06 12:44:30',NULL,NULL),(8741,'08520','S','Hightstown','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.255080,-74.515680,0,'2013-07-06 12:44:30',NULL,NULL),(37456,'41849','P','Seco','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.171925,-82.732417,0,'2013-07-06 12:44:32',NULL,NULL),(71660,'87501','S','Seton Village','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(42921,'48111','S','Roulo','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.174217,-83.489647,0,'2013-07-06 12:44:32',NULL,NULL),(40234,'45420','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.704905,-84.126463,0,'2013-07-06 12:44:32',NULL,NULL),(24356,'27045','S','Rural Hall','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.226761,-80.291133,0,'2013-07-06 12:44:31',NULL,NULL),(9060,'08904','S','Highland Park','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.498795,-74.425817,0,'2013-07-06 12:44:30',NULL,NULL),(43588,'48754','S','Owendale','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.733485,-83.244446,0,'2013-07-06 12:44:32',NULL,NULL),(47847,'55075','S','So Saint Paul','N','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.892636,-93.040178,0,'2013-07-06 12:44:33',NULL,NULL),(8886,'08723','S','Bricktown','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.051680,-74.106780,0,'2013-07-06 12:44:30',NULL,NULL),(10004,'10168','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(10236,'10466','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.889675,-73.845608,0,'2013-07-06 12:44:30',NULL,NULL),(13942,'14443','P','E Bloomfield','A','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.890395,-77.446504,0,'2013-07-06 12:44:31',NULL,NULL),(25322,'28173','S','Waxhaw','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.928790,-80.735968,0,'2013-07-06 12:44:31',NULL,NULL),(29477,'32725','S','Deltona','D','Volusia','12127','Florida','FL','12','2020','407/321','Eastern',-5.0,'Y',28.898339,-81.241296,0,'2013-07-06 12:44:32',NULL,NULL),(73159,'90295','P','Marina del Rey','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.980879,-118.438136,0,'2013-07-06 12:44:34',NULL,NULL),(78528,'98127','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.606389,-122.330833,0,'2013-07-06 12:44:34',NULL,NULL),(73859,'91908','P','Bonita','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.659940,-117.032213,0,'2013-07-06 12:44:34',NULL,NULL),(25708,'28540','S','New River Marine Corps Air S','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.764003,-77.434331,0,'2013-07-06 12:44:31',NULL,NULL),(49479,'56657','S','Marcell','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.637327,-93.668318,0,'2013-07-06 12:44:33',NULL,NULL),(50625,'58269','S','Union','A','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.631626,-98.250432,0,'2013-07-06 12:44:33',NULL,NULL),(50636,'58281','S','Wales','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.946518,-98.541361,0,'2013-07-06 12:44:33',NULL,NULL),(54210,'62642','S','Hubly','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.081772,-89.743074,0,'2013-07-06 12:44:33',NULL,NULL),(31480,'34428','S','Crystal River','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.961417,-82.625622,0,'2013-07-06 12:44:32',NULL,NULL),(1984,'00907','S','Bda Figueroa','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.454321,-66.076621,0,'2013-07-06 12:44:30',NULL,NULL),(38011,'43003','S','Ashley','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.418525,-82.974431,0,'2013-07-06 12:44:32',NULL,NULL),(11279,'11772','S','Davis Park','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(14537,'15208','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.456388,-79.897619,0,'2013-07-06 12:44:31',NULL,NULL),(18771,'19357','P','Mendenhall','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.853858,-75.640348,0,'2013-07-06 12:44:31',NULL,NULL),(53270,'61722','S','Arrowsmith','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.449086,-88.632987,0,'2013-07-06 12:44:33',NULL,NULL),(71202,'86301','S','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.585071,-112.459060,0,'2013-07-06 12:44:34',NULL,NULL),(60987,'72111','S','Garland Springs','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.185421,-92.073842,0,'2013-07-06 12:44:33',NULL,NULL),(60237,'71432','S','Georgetown','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.738200,-92.391755,0,'2013-07-06 12:44:33',NULL,NULL),(79565,'99016','S','Spo Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.643255,-117.151477,0,'2013-07-06 12:44:34',NULL,NULL),(77695,'97041','S','Mt Hood','N','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(14313,'14893','P','Wayne','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.466821,-77.111453,0,'2013-07-06 12:44:31',NULL,NULL),(18615,'19148','S','Passyunk','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.922429,-75.158025,0,'2013-07-06 12:44:31',NULL,NULL),(37695,'42252','S','Monford','N','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.236542,-86.517041,0,'2013-07-06 12:44:32',NULL,NULL),(24067,'26431','S','Shinnston','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(32655,'36255','S','Mellow Valley','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.217353,-85.689925,0,'2013-07-06 12:44:32',NULL,NULL),(34878,'38941','S','Mvsu','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(26315,'29042','S','Denmark','D','Bamberg','45009','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.318209,-81.139139,0,'2013-07-06 12:44:31',NULL,NULL),(6231,'05491','S','Chimney Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(62868,'75035','S','Frisco','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.164995,-96.777523,0,'2013-07-06 12:44:33',NULL,NULL),(4071,'02650','S','North Chatham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.702293,-69.968343,0,'2013-07-06 12:44:30',NULL,NULL),(63466,'75686','S','Blodgett','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(15368,'16260','S','Vowinckel','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.372565,-79.256668,0,'2013-07-06 12:44:31',NULL,NULL),(7312,'06650','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.175730,-73.198823,0,'2013-07-06 12:44:30',NULL,NULL),(58112,'68122','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.338700,-96.072049,0,'2013-07-06 12:44:33',NULL,NULL),(34604,'38748','S','Murphy','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(53419,'61848','P','Henning','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.305422,-87.699149,0,'2013-07-06 12:44:33',NULL,NULL),(30724,'33524','P','Crystal Spgs','A','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.182590,-82.158720,0,'2013-07-06 12:44:32',NULL,NULL),(41012,'46373','S','Dyer','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.451569,-87.476665,0,'2013-07-06 12:44:32',NULL,NULL),(14847,'15446','S','Indian Head','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.022294,-79.392471,0,'2013-07-06 12:44:31',NULL,NULL),(5111,'04357','S','Richmond','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.086454,-69.801005,0,'2013-07-06 12:44:30',NULL,NULL),(80103,'99754','P','Koyukuk','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.891532,-157.679599,0,'2013-07-06 12:44:34',NULL,NULL),(74374,'92503','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.914455,-117.456060,0,'2013-07-06 12:44:34',NULL,NULL),(71417,'87023','S','Jarales','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.599154,-106.759615,0,'2013-07-06 12:44:34',NULL,NULL),(60417,'71640','S','Endoka','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(23581,'25669','S','Crum','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',37.938952,-82.443431,0,'2013-07-06 12:44:31',NULL,NULL),(15261,'16066','S','Cranberry Township','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.707441,-80.107217,0,'2013-07-06 12:44:31',NULL,NULL),(7831,'07460','S','Lake Tamarack','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(12875,'13325','S','Fish Creek','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.577189,-75.564678,0,'2013-07-06 12:44:30',NULL,NULL),(51567,'59754','S','Twin Bridges','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.572530,-112.392846,0,'2013-07-06 12:44:33',NULL,NULL),(13129,'13491','S','West Winfield','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(31138,'33907','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.564829,-81.887080,0,'2013-07-06 12:44:32',NULL,NULL),(51277,'59111','U','Public Works','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.634161,-108.361047,0,'2013-07-06 12:44:33',NULL,NULL),(28166,'30912','U','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.473519,-81.988250,0,'2013-07-06 12:44:31',NULL,NULL),(50230,'57620','S','Bison','D','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(36589,'40962','S','Manchester','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(71937,'87930','S','Arrey','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.739686,-107.420655,0,'2013-07-06 12:44:34',NULL,NULL),(37227,'41537','S','Potters Fork','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(78749,'98292','S','Camano Island','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.179280,-122.371440,0,'2013-07-06 12:44:34',NULL,NULL),(75213,'93633','P','Miramonte','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(58936,'69350','S','Hyannis','D','Grant','31075','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.002999,-101.762656,0,'2013-07-06 12:44:33',NULL,NULL),(23437,'25402','P','Martinsburg','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.461446,-77.969824,0,'2013-07-06 12:44:31',NULL,NULL),(25884,'28640','S','Wagoner','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.409140,-81.410460,0,'2013-07-06 12:44:31',NULL,NULL),(14398,'15054','P','Langeloth','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.365148,-80.409787,0,'2013-07-06 12:44:31',NULL,NULL),(51758,'60026','S','Glenview','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.086421,-87.826831,0,'2013-07-06 12:44:33',NULL,NULL),(54421,'62836','S','Ewing','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.074329,-88.801938,0,'2013-07-06 12:44:33',NULL,NULL),(8159,'07856','S','Mount Arlington','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.928208,-74.636027,0,'2013-07-06 12:44:30',NULL,NULL),(13749,'14120','S','N Tonawanda','A','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.071240,-78.814140,0,'2013-07-06 12:44:31',NULL,NULL),(64438,'76566','S','Purmela','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.466689,-97.904546,0,'2013-07-06 12:44:34',NULL,NULL),(63821,'75972','S','Norwood','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(37074,'41314','S','Sebastians Br','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(53954,'62425','S','Dundas','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.829215,-88.106167,0,'2013-07-06 12:44:33',NULL,NULL),(47957,'55119','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.938568,-93.002788,0,'2013-07-06 12:44:33',NULL,NULL),(64673,'76825','S','Brady','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.390710,-99.384310,0,'2013-07-06 12:44:34',NULL,NULL),(51123,'58792','S','Kongsberg','N','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.933754,-100.775619,0,'2013-07-06 12:44:33',NULL,NULL),(30195,'33180','S','Aventura','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.961901,-80.140608,0,'2013-07-06 12:44:32',NULL,NULL),(33866,'38012','S','Brownsville','D','Haywood','47075','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.597482,-89.271036,0,'2013-07-06 12:44:32',NULL,NULL),(523,'00674','S','Urb Portofino','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(37043,'41265','S','Van Lear','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.698773,-82.687184,0,'2013-07-06 12:44:32',NULL,NULL),(22107,'23422','P','Pungoteague','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.579042,-75.795534,0,'2013-07-06 12:44:31',NULL,NULL),(62350,'74059','S','Perkins','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.983101,-97.024469,0,'2013-07-06 12:44:33',NULL,NULL),(77274,'96608','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(57019,'66206','S','Prairie Vlg','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(8307,'08030','S','Brooklawn','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.887704,-75.115680,0,'2013-07-06 12:44:30',NULL,NULL),(76462,'95615','S','Randall Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.316277,-121.553829,0,'2013-07-06 12:44:34',NULL,NULL),(76874,'95973','S','Nord','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.737451,-121.830460,0,'2013-07-06 12:44:34',NULL,NULL),(3154,'01262','P','Stockbridge','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.303969,-73.315856,0,'2013-07-06 12:44:30',NULL,NULL),(67667,'80488','P','Steamboat','N','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.476275,-106.850394,0,'2013-07-06 12:44:34',NULL,NULL),(22317,'23841','S','Dinwiddie','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.080906,-77.549122,0,'2013-07-06 12:44:31',NULL,NULL),(37654,'42204','S','Keysburg','N','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.704760,-87.049860,0,'2013-07-06 12:44:32',NULL,NULL),(23350,'25260','S','Mason','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.017584,-82.027784,0,'2013-07-06 12:44:31',NULL,NULL),(12227,'12812','S','Blue Mtn Lake','A','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.835368,-74.426553,0,'2013-07-06 12:44:30',NULL,NULL),(51000,'58654','S','Sentinl Butte','A','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.801990,-103.732852,0,'2013-07-06 12:44:33',NULL,NULL),(48977,'56218','S','Boyd','D','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.849747,-95.971269,0,'2013-07-06 12:44:33',NULL,NULL),(42360,'47703','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.954521,-87.559550,0,'2013-07-06 12:44:32',NULL,NULL),(16007,'17040','S','Landisbg','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.311569,-77.333589,0,'2013-07-06 12:44:31',NULL,NULL),(20331,'20847','P','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.084480,-77.151860,0,'2013-07-06 12:44:31',NULL,NULL),(60526,'71671','S','Farmville','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.609178,-92.070158,0,'2013-07-06 12:44:33',NULL,NULL),(61481,'72635','S','Whiteville','N','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.302640,-92.484480,0,'2013-07-06 12:44:33',NULL,NULL),(29668,'32911','P','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.018087,-80.682599,0,'2013-07-06 12:44:32',NULL,NULL),(9625,'10034','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(59185,'70357','S','Golden Meadow','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.372100,-90.263340,0,'2013-07-06 12:44:33',NULL,NULL),(71112,'86011','U','Flagstaff','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.188945,-111.620766,0,'2013-07-06 12:44:34',NULL,NULL),(78874,'98352','U','Sumner','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164325,-122.242368,0,'2013-07-06 12:44:34',NULL,NULL),(43011,'48164','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(59250,'70441','S','Greensburg','D','Saint Helena','22091','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.885526,-90.749525,0,'2013-07-06 12:44:33',NULL,NULL),(20492,'21056','P','Gibson Island','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.077370,-76.431211,0,'2013-07-06 12:44:31',NULL,NULL),(21551,'22747','S','Washington','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.719068,-78.166901,0,'2013-07-06 12:44:31',NULL,NULL),(4378,'03086','S','Wilton','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.837925,-71.743677,0,'2013-07-06 12:44:30',NULL,NULL),(57982,'67842','S','Ford','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.634089,-99.755515,0,'2013-07-06 12:44:33',NULL,NULL),(32680,'36266','S','Watts Mill','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(32404,'35960','S','Centre','D','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.150830,-85.674502,0,'2013-07-06 12:44:32',NULL,NULL),(42167,'47525','S','Dexter','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.029575,-86.566656,0,'2013-07-06 12:44:32',NULL,NULL),(4400,'03218','S','Barnstead','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.367179,-71.292304,0,'2013-07-06 12:44:30',NULL,NULL),(78738,'98287','P','Silvana','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.190514,-122.250316,0,'2013-07-06 12:44:34',NULL,NULL),(67957,'80913','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(64584,'76670','S','Iverson','N','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.142009,-96.958075,0,'2013-07-06 12:44:34',NULL,NULL),(15719,'16870','S','Port Matilda','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.801567,-78.030230,0,'2013-07-06 12:44:31',NULL,NULL),(18107,'18765','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.219464,-75.797080,0,'2013-07-06 12:44:31',NULL,NULL),(38093,'43080','S','Utica','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.230307,-82.454626,0,'2013-07-06 12:44:32',NULL,NULL),(80144,'99783','P','Wales','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.663808,-167.435706,0,'2013-07-06 12:44:34',NULL,NULL),(36120,'40222','S','Northfield','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(52118,'60425','S','Glenwood','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.548622,-87.612394,0,'2013-07-06 12:44:33',NULL,NULL),(57991,'67853','S','Ingalls','D','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.958397,-100.526470,0,'2013-07-06 12:44:33',NULL,NULL),(20621,'21213','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.312520,-76.583450,0,'2013-07-06 12:44:31',NULL,NULL),(58185,'68310','S','Hoag','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(1669,'00773','S','Urb Solimar','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(72568,'89316','S','Eureka','D','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.514548,-115.965895,0,'2013-07-06 12:44:34',NULL,NULL),(74908,'93313','S','Pumpkin Center','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.254233,-119.060086,0,'2013-07-06 12:44:34',NULL,NULL),(20086,'20692','S','Valley Lee','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.171738,-76.503440,0,'2013-07-06 12:44:31',NULL,NULL),(6678,'06037','S','Berlin','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.607780,-72.770100,0,'2013-07-06 12:44:30',NULL,NULL),(7081,'06349','P','Naval Submarine Base','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.401943,-72.089280,0,'2013-07-06 12:44:30',NULL,NULL),(3974,'02494','S','Needham Heights','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.305022,-71.231767,0,'2013-07-06 12:44:30',NULL,NULL),(52353,'60608','S','Pilsen','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.849103,-87.667335,0,'2013-07-06 12:44:33',NULL,NULL),(32409,'35966','S','Fabius','N','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.807624,-85.728970,0,'2013-07-06 12:44:32',NULL,NULL),(25087,'27953','S','Manns Harbor','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.865180,-75.919020,0,'2013-07-06 12:44:31',NULL,NULL),(53176,'61603','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.729594,-89.577784,0,'2013-07-06 12:44:33',NULL,NULL),(69647,'84007','S','Upalco','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.336272,-110.332410,0,'2013-07-06 12:44:34',NULL,NULL),(68844,'82601','S','Bar Nunn','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.840004,-106.321610,0,'2013-07-06 12:44:34',NULL,NULL),(38041,'43036','P','Magnetic Spgs','A','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.352146,-83.262257,0,'2013-07-06 12:44:32',NULL,NULL),(32996,'36630','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.690024,-88.040823,0,'2013-07-06 12:44:32',NULL,NULL),(34256,'38451','S','Culleoka','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.462279,-86.991892,0,'2013-07-06 12:44:32',NULL,NULL),(54048,'62468','S','Cottonwood','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.269624,-88.244943,0,'2013-07-06 12:44:33',NULL,NULL),(65631,'77963','S','Weser','N','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(69084,'83252','S','Cherry Creek','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(69587,'83841','P','Laclede','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.186274,-116.904565,0,'2013-07-06 12:44:34',NULL,NULL),(79215,'98540','P','Kellys Korner','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.963393,-122.823764,0,'2013-07-06 12:44:34',NULL,NULL),(78332,'98001','S','Auburn','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.306800,-122.260607,0,'2013-07-06 12:44:34',NULL,NULL),(17120,'17774','S','Biggertown','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.242038,-76.522091,0,'2013-07-06 12:44:31',NULL,NULL),(23852,'26142','S','Davisville','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.204487,-81.491259,0,'2013-07-06 12:44:31',NULL,NULL),(51542,'59728','P','Elliston','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.574757,-112.497615,0,'2013-07-06 12:44:33',NULL,NULL),(10758,'11362','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761850,-73.729718,0,'2013-07-06 12:44:30',NULL,NULL),(30028,'33138','S','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849350,-80.181844,0,'2013-07-06 12:44:32',NULL,NULL),(58913,'69331','S','Angora','D','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.895889,-103.070624,0,'2013-07-06 12:44:33',NULL,NULL),(72664,'89434','S','Tracy-Clark','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(5324,'04575','P','W Boothbay Ha','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.848039,-69.651327,0,'2013-07-06 12:44:30',NULL,NULL),(1500,'00751','S','Urb Las Mercedes','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(17401,'17901','S','New Street','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(13962,'14469','S','East Bloomfield','N','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.877952,-77.456375,0,'2013-07-06 12:44:31',NULL,NULL),(17881,'18443','S','Milanville','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654818,-75.083651,0,'2013-07-06 12:44:31',NULL,NULL),(52303,'60544','S','Plainfield','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.618385,-88.199459,0,'2013-07-06 12:44:33',NULL,NULL),(53823,'62298','S','Saint Joe','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(53945,'62419','S','Bonpas','N','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.723920,-88.185778,0,'2013-07-06 12:44:33',NULL,NULL),(32309,'35755','S','Langston','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.455447,-86.142996,0,'2013-07-06 12:44:32',NULL,NULL),(7850,'07470','S','Pines Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(51153,'58849','S','Ray','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.322800,-103.200900,0,'2013-07-06 12:44:33',NULL,NULL),(48731,'55962','S','Arendahl','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.774230,-91.848858,0,'2013-07-06 12:44:33',NULL,NULL),(18592,'19136','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.044445,-75.024762,0,'2013-07-06 12:44:31',NULL,NULL),(58038,'68016','P','Cedar Creek','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.044111,-96.102145,0,'2013-07-06 12:44:33',NULL,NULL),(41693,'47220','S','Brownstown','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.881161,-86.045869,0,'2013-07-06 12:44:32',NULL,NULL),(42822,'48061','P','Port Huron','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.994263,-82.431910,0,'2013-07-06 12:44:32',NULL,NULL),(55510,'63779','P','Pocahontas','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.499441,-89.642156,0,'2013-07-06 12:44:33',NULL,NULL),(20571,'21146','S','Severna Park','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.081683,-76.565355,0,'2013-07-06 12:44:31',NULL,NULL),(75321,'93771','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.749697,-119.792435,0,'2013-07-06 12:44:34',NULL,NULL),(62590,'74471','S','Welling','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.918573,-94.853344,0,'2013-07-06 12:44:33',NULL,NULL),(42891,'48096','S','Ray','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.761520,-82.927080,0,'2013-07-06 12:44:32',NULL,NULL),(36810,'41056','S','Plumville','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(2549,'00959','S','Parq Valencia','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(51815,'60050','S','Sunnyside','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(49804,'57198','U','Earth Resources Obs','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.733737,-96.628269,0,'2013-07-06 12:44:33',NULL,NULL),(8041,'07733','S','Holmdel','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.385487,-74.172575,0,'2013-07-06 12:44:30',NULL,NULL),(42150,'47520','S','Mount Pleasant','A','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(2819,'00979','S','Ext Villamar','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(59609,'71023','S','Doyline','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.526535,-93.409703,0,'2013-07-06 12:44:33',NULL,NULL),(76442,'95605','S','Broderick','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.594722,-121.540556,0,'2013-07-06 12:44:34',NULL,NULL),(38760,'44040','S','Mayfield Vlg','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.527765,-81.412458,0,'2013-07-06 12:44:32',NULL,NULL),(56816,'65779','S','Galmey','N','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.910520,-93.396600,0,'2013-07-06 12:44:33',NULL,NULL),(29917,'33056','S','Opa Locka','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.946322,-80.247066,0,'2013-07-06 12:44:32',NULL,NULL),(35967,'40075','S','Turners Station','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.556216,-85.126679,0,'2013-07-06 12:44:32',NULL,NULL),(42268,'47581','S','Indian Springs','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(18421,'19061','S','Lower Chichester','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(63826,'75973','S','Dreka','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(62516,'74401','S','Summitt','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(18605,'19143','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.943711,-75.229131,0,'2013-07-06 12:44:31',NULL,NULL),(35871,'39845','S','Donalsonville','D','Seminole','13253','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.041858,-84.881232,0,'2013-07-06 12:44:32',NULL,NULL),(23402,'25322','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.348921,-81.630374,0,'2013-07-06 12:44:31',NULL,NULL),(78094,'97484','S','Tiller','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.906960,-122.943240,0,'2013-07-06 12:44:34',NULL,NULL),(23553,'25632','S','Lyburn','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.773567,-81.951589,0,'2013-07-06 12:44:31',NULL,NULL),(4521,'03304','S','Bow','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.139561,-71.545695,0,'2013-07-06 12:44:30',NULL,NULL),(25289,'28137','S','Pooletown','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.459658,-80.267160,0,'2013-07-06 12:44:31',NULL,NULL),(7476,'06889','U','Westport','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.142373,-73.360124,0,'2013-07-06 12:44:30',NULL,NULL),(26719,'29415','P','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.027502,-80.046168,0,'2013-07-06 12:44:31',NULL,NULL),(66200,'78545','P','Falcon Hts','A','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.581595,-98.985987,0,'2013-07-06 12:44:34',NULL,NULL),(76576,'95676','P','Robbins','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.882324,-121.716170,0,'2013-07-06 12:44:34',NULL,NULL),(40958,'46310','S','Demotte','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.184919,-87.209975,0,'2013-07-06 12:44:32',NULL,NULL),(77370,'96748','S','Kaunakakai','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.116967,-156.882550,0,'2013-07-06 12:44:34',NULL,NULL),(67259,'79960','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.758857,-106.487767,0,'2013-07-06 12:44:34',NULL,NULL),(62793,'74884','S','Lima','A','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.160960,-96.503340,0,'2013-07-06 12:44:33',NULL,NULL),(5176,'04435','S','Exeter','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.965565,-69.108446,0,'2013-07-06 12:44:30',NULL,NULL),(14448,'15102','S','Bethel Park','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.324521,-80.038440,0,'2013-07-06 12:44:31',NULL,NULL),(44067,'49444','S','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168440,-86.184540,0,'2013-07-06 12:44:32',NULL,NULL),(51847,'60071','S','Solon Mills','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.466736,-88.288525,0,'2013-07-06 12:44:33',NULL,NULL),(48026,'55303','S','Andover','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.261223,-93.440539,0,'2013-07-06 12:44:33',NULL,NULL),(71858,'87711','S','Anton Chico','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.084468,-105.060585,0,'2013-07-06 12:44:34',NULL,NULL),(74552,'92676','S','Modjeska Canyon','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.745069,-117.615251,0,'2013-07-06 12:44:34',NULL,NULL),(70419,'84726','P','Escalante','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.764744,-111.592375,0,'2013-07-06 12:44:34',NULL,NULL),(67384,'80122','S','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.580440,-104.955859,0,'2013-07-06 12:44:34',NULL,NULL),(64833,'77039','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.909223,-95.334826,0,'2013-07-06 12:44:34',NULL,NULL),(21332,'22408','S','Fredericksbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(53558,'62050','S','Hillview','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.473831,-90.525724,0,'2013-07-06 12:44:33',NULL,NULL),(47715,'55005','S','Bethel','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.392640,-93.211800,0,'2013-07-06 12:44:33',NULL,NULL),(23298,'25181','S','Williams Mountain','N','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.089680,-81.643862,0,'2013-07-06 12:44:31',NULL,NULL),(56873,'66019','P','De Soto','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.945400,-95.002701,0,'2013-07-06 12:44:33',NULL,NULL),(57150,'66251','U','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(73684,'91603','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.172067,-118.376920,0,'2013-07-06 12:44:34',NULL,NULL),(73575,'91377','S','Oak Park','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.145227,-118.756588,0,'2013-07-06 12:44:34',NULL,NULL),(63057,'75225','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.866007,-96.784662,0,'2013-07-06 12:44:33',NULL,NULL),(6419,'05740','P','E Middlebury','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.972989,-73.102731,0,'2013-07-06 12:44:30',NULL,NULL),(52979,'61432','S','Fairview','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.632317,-90.164403,0,'2013-07-06 12:44:33',NULL,NULL),(35596,'39577','S','Whites Crossing','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.855908,-89.135956,0,'2013-07-06 12:44:32',NULL,NULL),(21276,'22313','P','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.772177,-77.170494,0,'2013-07-06 12:44:31',NULL,NULL),(79503,'98909','P','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.547581,-120.644613,0,'2013-07-06 12:44:34',NULL,NULL),(70894,'85617','S','Double Adobe','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.523874,-109.682735,0,'2013-07-06 12:44:34',NULL,NULL),(51822,'60055','U','Mellon Financial Services','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.125215,-88.075032,0,'2013-07-06 12:44:33',NULL,NULL),(72035,'88056','P','Rodeo','D','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.836121,-109.031867,0,'2013-07-06 12:44:34',NULL,NULL),(70088,'84158','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.739667,-111.817677,0,'2013-07-06 12:44:34',NULL,NULL),(54741,'62972','S','Reynoldsburg','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.533890,-88.763201,0,'2013-07-06 12:44:33',NULL,NULL),(53690,'62226','S','Swansea','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.544506,-90.000820,0,'2013-07-06 12:44:33',NULL,NULL),(27452,'30124','S','Cave Spring','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.125103,-85.349734,0,'2013-07-06 12:44:31',NULL,NULL),(41192,'46721','S','Newville','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.413936,-84.885428,0,'2013-07-06 12:44:32',NULL,NULL),(1757,'00780','S','Brisas del Lago','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(70058,'84141','U','Wells Fargo Bank','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.668129,-111.861408,0,'2013-07-06 12:44:34',NULL,NULL),(33042,'36748','S','Linden','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.306000,-87.793801,0,'2013-07-06 12:44:32',NULL,NULL),(79173,'98520','S','Bay City','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(78285,'97873','S','Seneca','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.129131,-118.989332,0,'2013-07-06 12:44:34',NULL,NULL),(72480,'89126','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.146852,-115.202960,0,'2013-07-06 12:44:34',NULL,NULL),(21601,'22849','S','Shenandoah','D','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.485706,-78.618795,0,'2013-07-06 12:44:31',NULL,NULL),(23429,'25375','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.349281,-81.631727,0,'2013-07-06 12:44:31',NULL,NULL),(79247,'98558','P','McKenna','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.935000,-122.555220,0,'2013-07-06 12:44:34',NULL,NULL),(78085,'97475','P','Springfield','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.065622,-123.014262,0,'2013-07-06 12:44:34',NULL,NULL),(76979,'96061','S','Mill Creek','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.320900,-121.500420,0,'2013-07-06 12:44:34',NULL,NULL),(65563,'77844','P','Aggieland','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.610719,-96.354731,0,'2013-07-06 12:44:34',NULL,NULL),(12980,'13402','S','Madison','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.915824,-75.493148,0,'2013-07-06 12:44:30',NULL,NULL),(4490,'03276','S','Tilton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.456440,-71.570040,0,'2013-07-06 12:44:30',NULL,NULL),(47296,'54546','S','Morse','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.324004,-90.656945,0,'2013-07-06 12:44:32',NULL,NULL),(46324,'53078','S','Rubicon','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.326045,-88.424348,0,'2013-07-06 12:44:32',NULL,NULL),(18656,'19175','U','Mellon Bank East','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.949991,-75.154637,0,'2013-07-06 12:44:31',NULL,NULL),(42777,'48041','S','Riley','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.924364,-82.781340,0,'2013-07-06 12:44:32',NULL,NULL),(15657,'16748','S','Shinglehse','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.947620,-78.166200,0,'2013-07-06 12:44:31',NULL,NULL),(35303,'39401','S','Runnelstown','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(69013,'83210','S','Aberdeen','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.012500,-112.829220,0,'2013-07-06 12:44:34',NULL,NULL),(37998,'42757','S','Magnolia','D','Larue','21123','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.376284,-85.731624,0,'2013-07-06 12:44:32',NULL,NULL),(13895,'14272','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.872268,-78.870254,0,'2013-07-06 12:44:31',NULL,NULL),(18776,'19365','S','Parkesburg','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.960339,-75.923420,0,'2013-07-06 12:44:31',NULL,NULL),(5436,'04683','S','Sunset','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.220643,-68.706654,0,'2013-07-06 12:44:30',NULL,NULL),(18582,'19131','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.978878,-75.220604,0,'2013-07-06 12:44:31',NULL,NULL),(66608,'78763','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.297111,-97.766854,0,'2013-07-06 12:44:34',NULL,NULL),(69385,'83611','S','Mackey Bar','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.393460,-115.981260,0,'2013-07-06 12:44:34',NULL,NULL),(21097,'22041','S','Baileys Crossroads','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.846929,-77.142525,0,'2013-07-06 12:44:31',NULL,NULL),(57950,'67748','S','Oakley','D','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.125270,-100.852996,0,'2013-07-06 12:44:33',NULL,NULL),(56933,'66075','S','Pleasanton','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.174432,-94.709568,0,'2013-07-06 12:44:33',NULL,NULL),(22955,'24657','S','Whitewood','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.266217,-81.886651,0,'2013-07-06 12:44:31',NULL,NULL),(37520,'42044','S','Gilbertsville','D','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.927731,-88.222158,0,'2013-07-06 12:44:32',NULL,NULL),(38410,'43535','S','Malinta','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.320879,-84.040485,0,'2013-07-06 12:44:32',NULL,NULL),(47357,'54614','S','Middle Ridge','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.890535,-90.983181,0,'2013-07-06 12:44:32',NULL,NULL),(64224,'76302','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.866229,-98.491331,0,'2013-07-06 12:44:34',NULL,NULL),(74763,'93102','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.419610,-119.705543,0,'2013-07-06 12:44:34',NULL,NULL),(78229,'97812','S','Arlington','D','Gilliam','41021','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.686001,-120.188140,0,'2013-07-06 12:44:34',NULL,NULL),(36473,'40745','P','London','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.088793,-84.143582,0,'2013-07-06 12:44:32',NULL,NULL),(7019,'06260','S','Putnm','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(8633,'08260','S','Wildwood City','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(45912,'52322','S','Windham','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.722093,-91.785552,0,'2013-07-06 12:44:32',NULL,NULL),(65023,'77318','S','Panorama Village','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.452396,-95.537675,0,'2013-07-06 12:44:34',NULL,NULL),(75132,'93555','S','China Lake','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.622118,-117.690678,0,'2013-07-06 12:44:34',NULL,NULL),(69200,'83347','S','Paul','D','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.617107,-113.751518,0,'2013-07-06 12:44:34',NULL,NULL),(15640,'16730','P','East Smethport','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.809560,-78.417600,0,'2013-07-06 12:44:31',NULL,NULL),(33269,'37096','S','Linden','D','Perry','47135','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.598360,-87.852000,0,'2013-07-06 12:44:32',NULL,NULL),(13473,'13787','S','Harpursville','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.189300,-75.684780,0,'2013-07-06 12:44:31',NULL,NULL),(24205,'26681','S','Nettie','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.197435,-80.682232,0,'2013-07-06 12:44:31',NULL,NULL),(74819,'93222','P','Frazier Park','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.836120,-119.055120,0,'2013-07-06 12:44:34',NULL,NULL),(60691,'71937','S','Cove','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.429351,-94.417896,0,'2013-07-06 12:44:33',NULL,NULL),(58535,'68810','S','Alda','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.873180,-98.456185,0,'2013-07-06 12:44:33',NULL,NULL),(12365,'12910','S','Irona','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.882237,-73.662504,0,'2013-07-06 12:44:30',NULL,NULL),(42967,'48134','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.107811,-83.281359,0,'2013-07-06 12:44:32',NULL,NULL),(47455,'54729','S','Lake Hallie','A','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(52966,'61425','S','Carman','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.764786,-91.060793,0,'2013-07-06 12:44:33',NULL,NULL),(32408,'35964','P','Douglas','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.170870,-86.322900,0,'2013-07-06 12:44:32',NULL,NULL),(53062,'61501','S','Summum','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.227008,-90.353086,0,'2013-07-06 12:44:33',NULL,NULL),(23913,'26215','S','Cleveland','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.836483,-80.340000,0,'2013-07-06 12:44:31',NULL,NULL),(66991,'79493','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.547975,-101.884706,0,'2013-07-06 12:44:34',NULL,NULL),(60397,'71631','S','Banks','D','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.544300,-92.265430,0,'2013-07-06 12:44:33',NULL,NULL),(27826,'30413','S','Bartow','D','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.879456,-82.491070,0,'2013-07-06 12:44:31',NULL,NULL),(12589,'13073','S','W Groton','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.585725,-76.393025,0,'2013-07-06 12:44:30',NULL,NULL),(25315,'28166','S','Bells Cross Roads','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.699084,-80.889947,0,'2013-07-06 12:44:31',NULL,NULL),(1723,'00778','S','Mans de Santa Barbara','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(8825,'08620','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.178809,-74.659973,0,'2013-07-06 12:44:30',NULL,NULL),(52403,'60637','S','Jackson Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781280,-87.603401,0,'2013-07-06 12:44:33',NULL,NULL),(7646,'07074','S','Moonachie','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.839122,-74.057820,0,'2013-07-06 12:44:30',NULL,NULL),(14417,'15068','S','New Kensingtn','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(33528,'37380','S','S Pittsburg','A','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.009705,-85.711704,0,'2013-07-06 12:44:32',NULL,NULL),(5008,'04224','S','Carthage','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.542585,-70.453768,0,'2013-07-06 12:44:30',NULL,NULL),(28506,'31527','S','Jekyll Island','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.071521,-81.407896,0,'2013-07-06 12:44:32',NULL,NULL),(53795,'62284','S','Smithboro','D','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.876400,-89.323800,0,'2013-07-06 12:44:33',NULL,NULL),(17026,'17745','S','Flemington','A','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(63803,'75962','U','S F A U','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(68595,'81601','S','Glenwood Spgs','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.528426,-107.338503,0,'2013-07-06 12:44:34',NULL,NULL),(34222,'38365','P','Pickwick Dam','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.036164,-88.288421,0,'2013-07-06 12:44:32',NULL,NULL),(77509,'96838','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.348058,-157.876862,0,'2013-07-06 12:44:34',NULL,NULL),(22371,'23922','S','Burkeville','D','Nottoway','51135','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.184650,-78.202504,0,'2013-07-06 12:44:31',NULL,NULL),(60330,'71462','S','Noble','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.692840,-93.699360,0,'2013-07-06 12:44:33',NULL,NULL),(3795,'02215','S','Kenmore','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344927,-71.101619,0,'2013-07-06 12:44:30',NULL,NULL),(19398,'20073','U','PNC Financial','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896184,-77.022512,0,'2013-07-06 12:44:31',NULL,NULL),(77138,'96158','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.925696,-119.966045,0,'2013-07-06 12:44:34',NULL,NULL),(18810,'19403','S','Jeffersonvlle','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(47498,'54759','S','Pepin','D','Pepin','55091','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.441752,-92.149129,0,'2013-07-06 12:44:32',NULL,NULL),(47707,'54986','S','Winneconne','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.118546,-88.735465,0,'2013-07-06 12:44:33',NULL,NULL),(62157,'73729','S','Cleo Springs','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.405837,-98.440699,0,'2013-07-06 12:44:33',NULL,NULL),(22061,'23327','P','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.739387,-76.230004,0,'2013-07-06 12:44:31',NULL,NULL),(41928,'47384','S','Grant City','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.888672,-85.580079,0,'2013-07-06 12:44:32',NULL,NULL),(53597,'62075','S','Nokomis','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.285840,-89.312580,0,'2013-07-06 12:44:33',NULL,NULL),(43612,'48804','P','Mt Pleasant','A','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.606089,-84.688548,0,'2013-07-06 12:44:32',NULL,NULL),(3217,'01364','S','Orange','D','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(61271,'72377','P','Rivervale','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.558436,-90.432112,0,'2013-07-06 12:44:33',NULL,NULL),(64664,'76803','P','Early','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.717112,-98.976776,0,'2013-07-06 12:44:34',NULL,NULL),(73541,'91354','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.445120,-118.546414,0,'2013-07-06 12:44:34',NULL,NULL),(54458,'62853','S','Cartter','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.541111,-88.912222,0,'2013-07-06 12:44:33',NULL,NULL),(67784,'80701','S','Fort Morgan','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.256639,-103.806491,0,'2013-07-06 12:44:34',NULL,NULL),(59313,'70518','S','Broussard','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.139449,-91.957153,0,'2013-07-06 12:44:33',NULL,NULL),(784,'00693','S','Bo Las Granjas','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(3876,'02362','P','Plymouth','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.959767,-70.665275,0,'2013-07-06 12:44:30',NULL,NULL),(53839,'62316','S','Bowen','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.238218,-91.085563,0,'2013-07-06 12:44:33',NULL,NULL),(23095,'24927','S','Stony Bottom','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.364167,-79.962500,0,'2013-07-06 12:44:31',NULL,NULL),(9782,'10107','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(36127,'40223','S','Meadowbrk Frm','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(26357,'29070','S','Fairview Crossroads','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(33660,'37719','P','Coalfield','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.052468,-84.343174,0,'2013-07-06 12:44:32',NULL,NULL),(22513,'24086','S','Eggleston','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.284944,-80.619819,0,'2013-07-06 12:44:31',NULL,NULL),(60960,'72103','S','Shannon Hills','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.590766,-92.379460,0,'2013-07-06 12:44:33',NULL,NULL),(67822,'80758','S','Laird','A','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.192680,-102.271860,0,'2013-07-06 12:44:34',NULL,NULL),(52997,'61448','S','Knoxville','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.906224,-90.279802,0,'2013-07-06 12:44:33',NULL,NULL),(70451,'84747','S','Loa','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.441923,-111.593130,0,'2013-07-06 12:44:34',NULL,NULL),(35996,'40143','S','Mooleyville','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.779180,-86.458980,0,'2013-07-06 12:44:32',NULL,NULL),(25739,'28562','S','New Bern','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.071740,-77.099580,0,'2013-07-06 12:44:31',NULL,NULL),(16807,'17543','S','Millway','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(64248,'76366','S','Holliday','D','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.620220,-98.689800,0,'2013-07-06 12:44:34',NULL,NULL),(14006,'14522','S','Palmyra','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.068259,-77.224663,0,'2013-07-06 12:44:31',NULL,NULL),(1492,'00751','S','Ext Monserrate','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(13427,'13757','S','East Meredith','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.415691,-74.888542,0,'2013-07-06 12:44:31',NULL,NULL),(30577,'33415','S','Haverhill','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.663672,-80.126382,0,'2013-07-06 12:44:32',NULL,NULL),(52229,'60501','S','Argo','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782868,-87.813794,0,'2013-07-06 12:44:33',NULL,NULL),(3838,'02339','S','West Hanover','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.130281,-70.846944,0,'2013-07-06 12:44:30',NULL,NULL),(47364,'54618','S','Cutler','A','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.921069,-90.271708,0,'2013-07-06 12:44:32',NULL,NULL),(35811,'39759','S','Osborn','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(5765,'05042','S','Ryegate Corner','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270278,-72.144444,0,'2013-07-06 12:44:30',NULL,NULL),(49406,'56626','S','Bena','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.315217,-94.206922,0,'2013-07-06 12:44:33',NULL,NULL),(60849,'72043','P','Diaz','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.637842,-91.257878,0,'2013-07-06 12:44:33',NULL,NULL),(35670,'39653','S','Mile Branch','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.455600,-90.879660,0,'2013-07-06 12:44:32',NULL,NULL),(35720,'39669','S','Ireland','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(15901,'17011','S','Shiremanstown','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.240066,-76.930386,0,'2013-07-06 12:44:31',NULL,NULL),(18171,'18916','P','Danboro','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.359991,-75.139095,0,'2013-07-06 12:44:31',NULL,NULL),(60616,'71860','S','Stamps','D','Lafayette','05073','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.361637,-93.503365,0,'2013-07-06 12:44:33',NULL,NULL),(18121,'18815','P','Camptown','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.731124,-76.232784,0,'2013-07-06 12:44:31',NULL,NULL),(35507,'39531','S','Boloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400773,-88.962563,0,'2013-07-06 12:44:32',NULL,NULL),(69760,'84052','S','Myton','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.197437,-110.058695,0,'2013-07-06 12:44:34',NULL,NULL),(57656,'67207','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.668530,-97.231169,0,'2013-07-06 12:44:33',NULL,NULL),(5961,'05301','S','Guilford','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(5806,'05068','S','Royalton','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.801620,-72.530880,0,'2013-07-06 12:44:30',NULL,NULL),(44201,'49625','S','Copemish','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.447730,-85.886363,0,'2013-07-06 12:44:32',NULL,NULL),(27968,'30557','S','Martin','D','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.530869,-83.144053,0,'2013-07-06 12:44:31',NULL,NULL),(23250,'25121','S','Lake','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.908488,-81.920919,0,'2013-07-06 12:44:31',NULL,NULL),(28197,'31020','S','Dry Branch','D','Twiggs','13289','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.815139,-83.548394,0,'2013-07-06 12:44:31',NULL,NULL),(63796,'75959','S','Mildland','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.481280,-93.838320,0,'2013-07-06 12:44:34',NULL,NULL),(71951,'87942','S','Williamsburg','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.062500,-107.297778,0,'2013-07-06 12:44:34',NULL,NULL),(22885,'24577','S','Republicn Grv','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.942263,-78.970967,0,'2013-07-06 12:44:31',NULL,NULL),(28832,'32083','S','Raiford','D','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.091771,-82.195882,0,'2013-07-06 12:44:32',NULL,NULL),(45996,'52501','S','Rutledge','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(48683,'55925','S','Nodine','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917120,-91.394520,0,'2013-07-06 12:44:33',NULL,NULL),(79796,'99353','S','West Richland','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.285833,-119.283333,0,'2013-07-06 12:44:34',NULL,NULL),(31093,'33875','S','Sebring','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.429530,-81.468620,0,'2013-07-06 12:44:32',NULL,NULL),(67007,'79512','S','Cuthbert','N','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.394374,-100.859048,0,'2013-07-06 12:44:34',NULL,NULL),(75991,'95076','S','Pajaro','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(4160,'02777','S','Swansea','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.756903,-71.222215,0,'2013-07-06 12:44:30',NULL,NULL),(23424,'25360','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.453240,-81.669481,0,'2013-07-06 12:44:31',NULL,NULL),(3586,'02018','P','Hingham','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.175682,-70.886913,0,'2013-07-06 12:44:30',NULL,NULL),(44260,'49684','S','Traverse City','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.773499,-85.703641,0,'2013-07-06 12:44:32',NULL,NULL),(46012,'52537','S','West Grove','A','Davis','19051','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.732680,-92.414100,0,'2013-07-06 12:44:32',NULL,NULL),(19044,'19540','S','Beckersville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(52743,'61240','S','Coal Valley','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.410440,-90.475920,0,'2013-07-06 12:44:33',NULL,NULL),(50080,'57455','S','Lebanon','D','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.978593,-99.717349,0,'2013-07-06 12:44:33',NULL,NULL),(25897,'28643','S','Little Horse Creek','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(68284,'81084','S','Lycan','A','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.693548,-102.354655,0,'2013-07-06 12:44:34',NULL,NULL),(67727,'80545','S','Red Fe Lks','A','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.804665,-105.593375,0,'2013-07-06 12:44:34',NULL,NULL),(45083,'50531','S','Dolliver','D','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.462245,-94.620349,0,'2013-07-06 12:44:32',NULL,NULL),(39001,'44137','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.409495,-81.558216,0,'2013-07-06 12:44:32',NULL,NULL),(3587,'02019','S','Bellingham','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.068354,-71.476042,0,'2013-07-06 12:44:30',NULL,NULL),(4681,'03801','S','Newington','A','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.067228,-70.784076,0,'2013-07-06 12:44:30',NULL,NULL),(36447,'40620','U','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.177757,-84.899142,0,'2013-07-06 12:44:32',NULL,NULL),(80015,'99679','P','Bethel','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.108431,-160.949411,0,'2013-07-06 12:44:34',NULL,NULL),(68581,'81507','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.105236,-108.548263,0,'2013-07-06 12:44:34',NULL,NULL),(72330,'89008','S','Elgin','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.655453,-114.504832,0,'2013-07-06 12:44:34',NULL,NULL),(62721,'74801','S','Bethel Acres','A','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.309893,-96.920802,0,'2013-07-06 12:44:33',NULL,NULL),(5682,'04970','S','Dallas Plt','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(8988,'08834','P','Little York','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.607637,-75.058036,0,'2013-07-06 12:44:30',NULL,NULL),(36865,'41091','S','Union','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.927700,-84.717540,0,'2013-07-06 12:44:32',NULL,NULL),(10223,'10460','S','Crotona Park','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.837082,-73.880734,0,'2013-07-06 12:44:30',NULL,NULL),(10762,'11363','S','Douglaston','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.773215,-73.746899,0,'2013-07-06 12:44:30',NULL,NULL),(39242,'44429','S','Lake Milton','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.101255,-80.981944,0,'2013-07-06 12:44:32',NULL,NULL),(52034,'60185','S','Northwoods','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.887855,-88.198103,0,'2013-07-06 12:44:33',NULL,NULL),(13071,'13452','S','St Johnsville','A','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(56036,'64686','P','Utica','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.737820,-93.627947,0,'2013-07-06 12:44:33',NULL,NULL),(29414,'32653','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.662490,-82.325135,0,'2013-07-06 12:44:32',NULL,NULL),(52770,'61260','S','Joy','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.196590,-90.881652,0,'2013-07-06 12:44:33',NULL,NULL),(49862,'57249','S','Lake Preston','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.360596,-97.361268,0,'2013-07-06 12:44:33',NULL,NULL),(40769,'46151','S','Waverly','N','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(76895,'95980','P','Storrie','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(4272,'02887','P','Warwick','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.702680,-71.423159,0,'2013-07-06 12:44:30',NULL,NULL),(35396,'39459','S','Oak Grove','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.482740,-89.327507,0,'2013-07-06 12:44:32',NULL,NULL),(20112,'20712','S','Mt Rainier','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.943335,-76.965412,0,'2013-07-06 12:44:31',NULL,NULL),(7658,'07083','S','Townley','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.691867,-74.269598,0,'2013-07-06 12:44:30',NULL,NULL),(72700,'89448','P','Elks Point','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(79005,'98387','S','Bethel','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.077576,-122.396089,0,'2013-07-06 12:44:34',NULL,NULL),(32298,'35742','P','Capshaw','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.804854,-86.781949,0,'2013-07-06 12:44:32',NULL,NULL),(51803,'60047','S','Lake Zurich','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(65551,'77836','S','Caldwell','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.565402,-96.749186,0,'2013-07-06 12:44:34',NULL,NULL),(27954,'30543','S','Gillsville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.292108,-83.674281,0,'2013-07-06 12:44:31',NULL,NULL),(73244,'90701','S','Artesia','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.869028,-118.081967,0,'2013-07-06 12:44:34',NULL,NULL),(69359,'83549','S','Riggins','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.367969,-116.395099,0,'2013-07-06 12:44:34',NULL,NULL),(5086,'04333','U','Augusta','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.309517,-69.783518,0,'2013-07-06 12:44:30',NULL,NULL),(23974,'26301','S','Laurel Valley','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(16591,'17324','S','Mount Tabor','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(24166,'26610','S','Birch River','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.476703,-80.760728,0,'2013-07-06 12:44:31',NULL,NULL),(6216,'05488','S','Hog Island','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(2450,'00953','S','Urb Toalinda','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(25325,'28202','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.228512,-80.844925,0,'2013-07-06 12:44:31',NULL,NULL),(21414,'22538','S','Raphanck Acad','A','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.158313,-77.300230,0,'2013-07-06 12:44:31',NULL,NULL),(4212,'02836','S','Richmond','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.448096,-71.620839,0,'2013-07-06 12:44:30',NULL,NULL),(54529,'62880','S','Saint Peter','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.868041,-88.865839,0,'2013-07-06 12:44:33',NULL,NULL),(24001,'26347','S','Brownton','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.269476,-80.125327,0,'2013-07-06 12:44:31',NULL,NULL),(36642,'41005','S','Burlington','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(41779,'47304','S','Westport Addition','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(12756,'13206','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.070202,-76.106706,0,'2013-07-06 12:44:30',NULL,NULL),(17220,'17829','P','Hartleton','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.863377,-77.236848,0,'2013-07-06 12:44:31',NULL,NULL),(30408,'33324','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110295,-80.270027,0,'2013-07-06 12:44:32',NULL,NULL),(80047,'99705','S','Fairbanks','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.764840,-147.417300,0,'2013-07-06 12:44:34',NULL,NULL),(66940,'79360','S','Seminole','D','Gaines','48165','Texas','TX','48','0000','432','Central',-6.0,'Y',32.717704,-102.674594,0,'2013-07-06 12:44:34',NULL,NULL),(6634,'05907','S','Norton','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.946724,-71.827837,0,'2013-07-06 12:44:30',NULL,NULL),(72300,'88581','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770228,-106.327182,0,'2013-07-06 12:44:34',NULL,NULL),(51986,'60155','S','Maywood','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.853946,-87.855949,0,'2013-07-06 12:44:33',NULL,NULL),(19821,'20463','U','Federal Election Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898581,-77.024538,0,'2013-07-06 12:44:31',NULL,NULL),(20694,'21244','S','Windsor Mill','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.332500,-76.693056,0,'2013-07-06 12:44:31',NULL,NULL),(41520,'46982','S','Silver Lake','D','Kosciusko','18085','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.073022,-85.888777,0,'2013-07-06 12:44:32',NULL,NULL),(27335,'30037','P','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.691557,-84.253279,0,'2013-07-06 12:44:31',NULL,NULL),(6887,'06143','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790844,-72.668920,0,'2013-07-06 12:44:30',NULL,NULL),(12303,'12853','S','Holcombville','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.721592,-73.920875,0,'2013-07-06 12:44:30',NULL,NULL),(73537,'91352','S','Rancho La Tuna Canyon','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.224912,-118.360350,0,'2013-07-06 12:44:34',NULL,NULL),(78360,'98014','S','Carnation','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.657278,-121.912869,0,'2013-07-06 12:44:34',NULL,NULL),(70453,'84750','P','Marysvale','D','Piute','49031','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.431118,-112.218185,0,'2013-07-06 12:44:34',NULL,NULL),(68600,'81602','P','Glenwood Springs','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.494181,-107.328253,0,'2013-07-06 12:44:34',NULL,NULL),(23014,'24826','P','Cucumber','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.284573,-81.621095,0,'2013-07-06 12:44:31',NULL,NULL),(22270,'23694','P','Lackey','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.229370,-76.546609,0,'2013-07-06 12:44:31',NULL,NULL),(38471,'43623','S','Sylvania Township','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.707048,-83.649692,0,'2013-07-06 12:44:32',NULL,NULL),(32704,'36278','S','Wedowee','D','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.325381,-85.506798,0,'2013-07-06 12:44:32',NULL,NULL),(6530,'05829','S','Derby','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.936060,-72.131684,0,'2013-07-06 12:44:30',NULL,NULL),(42575,'47878','P','Tabertown','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.495156,-87.263683,0,'2013-07-06 12:44:32',NULL,NULL),(79893,'99583','P','False Pass','D','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',54.843808,-163.432337,0,'2013-07-06 12:44:34',NULL,NULL),(73342,'90895','U','Long Beach','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.839680,-118.259590,0,'2013-07-06 12:44:34',NULL,NULL),(72562,'89310','S','Kingston','N','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.738476,-117.193253,0,'2013-07-06 12:44:34',NULL,NULL),(70202,'84341','S','N Logan','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.781188,-111.822443,0,'2013-07-06 12:44:34',NULL,NULL),(48523,'55746','S','Ruby Junction','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(37145,'41465','S','Harper','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(33899,'38042','S','Hickory Valley','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.322522,-89.152200,0,'2013-07-06 12:44:32',NULL,NULL),(67683,'80512','S','Bellvue','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.636798,-105.327467,0,'2013-07-06 12:44:34',NULL,NULL),(76059,'95196','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.330413,-121.891128,0,'2013-07-06 12:44:34',NULL,NULL),(67765,'80638','U','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.421760,-104.744042,0,'2013-07-06 12:44:34',NULL,NULL),(48643,'55815','P','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.761056,-92.129829,0,'2013-07-06 12:44:33',NULL,NULL),(59131,'70162','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.958855,-90.074910,0,'2013-07-06 12:44:33',NULL,NULL),(72972,'90047','S','Wagner','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.953467,-118.311177,0,'2013-07-06 12:44:34',NULL,NULL),(77777,'97123','S','Scholls','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.506393,-122.946368,0,'2013-07-06 12:44:34',NULL,NULL),(39325,'44611','S','Big Prairie','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.635128,-82.094110,0,'2013-07-06 12:44:32',NULL,NULL),(25166,'28038','P','Earl','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.199661,-81.543345,0,'2013-07-06 12:44:31',NULL,NULL),(31791,'35034','S','Brent','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.933665,-87.171821,0,'2013-07-06 12:44:32',NULL,NULL),(886,'00704','S','Ext El Coqui','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(15953,'17025','S','E Pennsboro','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(6753,'06087','U','Unionville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756912,-72.885302,0,'2013-07-06 12:44:30',NULL,NULL),(65352,'77523','S','Cove','A','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(50125,'57523','S','Burke','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.244820,-99.239220,0,'2013-07-06 12:44:33',NULL,NULL),(16339,'17128','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263931,-76.883400,0,'2013-07-06 12:44:31',NULL,NULL),(2044,'00918','S','Urb Los Ingenieros','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(9595,'10030','S','College','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(44148,'49519','S','Wyoming','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.901059,-85.704730,0,'2013-07-06 12:44:32',NULL,NULL),(65679,'77990','S','Tivoli','D','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.457266,-96.896070,0,'2013-07-06 12:44:34',NULL,NULL),(75746,'94609','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.834123,-122.263353,0,'2013-07-06 12:44:34',NULL,NULL),(76554,'95667','S','Five Mile Terrace','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(24209,'26691','S','Tioga','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.393433,-80.671490,0,'2013-07-06 12:44:31',NULL,NULL),(2725,'00969','S','Urb Bucare Gdns','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(44892,'50319','S','State of Iowa','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.589947,-93.598609,0,'2013-07-06 12:44:32',NULL,NULL),(78944,'98368','S','Discovery Bay','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(61484,'72638','S','Rule','N','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.331200,-93.423600,0,'2013-07-06 12:44:33',NULL,NULL),(23526,'25570','S','Wayne','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.221065,-82.447234,0,'2013-07-06 12:44:31',NULL,NULL),(49676,'57014','S','Centerville','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.140734,-96.992306,0,'2013-07-06 12:44:33',NULL,NULL),(35822,'39762','P','Ms State Univ','A','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(1534,'00757','S','Bda Felicia 1','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(58787,'68978','S','Bostwick','N','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.020913,-98.064163,0,'2013-07-06 12:44:33',NULL,NULL),(66114,'78415','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.733183,-97.414174,0,'2013-07-06 12:44:34',NULL,NULL),(51962,'60140','S','Hampshire','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.116520,-88.502220,0,'2013-07-06 12:44:33',NULL,NULL),(72170,'88344','S','Pinon','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.657594,-105.424795,0,'2013-07-06 12:44:34',NULL,NULL),(78142,'97540','S','Talent','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.236056,-122.788905,0,'2013-07-06 12:44:34',NULL,NULL),(60528,'71671','S','Warren','D','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.609178,-92.070158,0,'2013-07-06 12:44:33',NULL,NULL),(5405,'04657','S','Meddybemps','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.019171,-67.386095,0,'2013-07-06 12:44:30',NULL,NULL),(24330,'27025','S','Madison','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.385863,-79.967595,0,'2013-07-06 12:44:31',NULL,NULL),(24523,'27288','S','Boulevard','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(36117,'40222','S','Hurstbourne','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(60192,'71418','S','Burroughs','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(19263,'19950','S','Greenwood','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.807972,-75.590786,0,'2013-07-06 12:44:31',NULL,NULL),(76228,'95379','S','Tuolumne','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.967269,-120.241068,0,'2013-07-06 12:44:34',NULL,NULL),(35155,'39232','S','JXN','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289828,-90.181404,0,'2013-07-06 12:44:32',NULL,NULL),(9570,'10026','S','Morningside','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(55298,'63531','S','Baring','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.263106,-92.262440,0,'2013-07-06 12:44:33',NULL,NULL),(26065,'28694','S','Idlewild','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(6593,'05860','S','Westmore','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.807079,-72.201511,0,'2013-07-06 12:44:30',NULL,NULL),(66732,'78956','S','Swiss Alp','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(50939,'58573','S','Strasburg','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.281781,-100.211350,0,'2013-07-06 12:44:33',NULL,NULL),(37878,'42564','P','West Somerset','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.088391,-84.600854,0,'2013-07-06 12:44:32',NULL,NULL),(79056,'98419','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255131,-122.441650,0,'2013-07-06 12:44:34',NULL,NULL),(78150,'97601','S','OreTech','A','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.221688,-121.796627,0,'2013-07-06 12:44:34',NULL,NULL),(19378,'20062','U','US Chamber Of Com','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901909,-77.036280,0,'2013-07-06 12:44:31',NULL,NULL),(46081,'52591','S','Lancaster','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.332082,-92.206101,0,'2013-07-06 12:44:32',NULL,NULL),(36761,'41041','S','Flemingsburg','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(35508,'39531','S','West Biloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400773,-88.962563,0,'2013-07-06 12:44:32',NULL,NULL),(79197,'98532','S','Forest','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(68608,'81615','P','Snowmass Vlg','A','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.209019,-106.936130,0,'2013-07-06 12:44:34',NULL,NULL),(56414,'65251','S','Millersburg','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.852815,-91.946319,0,'2013-07-06 12:44:33',NULL,NULL),(16625,'17331','S','Pleasant Hill','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(68225,'81050','S','Roberta','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(67277,'80001','P','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.801977,-105.087152,0,'2013-07-06 12:44:34',NULL,NULL),(28110,'30805','S','Blythe','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.344593,-82.127389,0,'2013-07-06 12:44:31',NULL,NULL),(2244,'00926','S','Urb la Sierra Alta','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(44819,'50243','P','Sheldahl','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.864748,-93.691118,0,'2013-07-06 12:44:32',NULL,NULL),(20932,'21755','S','Jefferson','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.368939,-77.565107,0,'2013-07-06 12:44:31',NULL,NULL),(32850,'36502','S','McCullough','A','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.021667,-87.484959,0,'2013-07-06 12:44:32',NULL,NULL),(8775,'08550','S','West Win Tow','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(41935,'47388','P','Sulphur Spgs','A','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.016569,-85.443170,0,'2013-07-06 12:44:32',NULL,NULL),(22773,'24445','S','Falling Spring','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(23718,'25901','S','Redstar','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.986637,-81.142428,0,'2013-07-06 12:44:31',NULL,NULL),(74243,'92328','S','Death Valley Jct','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.425648,-117.090213,0,'2013-07-06 12:44:34',NULL,NULL),(606,'00680','S','Urb Santa Maria','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(17385,'17888','S','Midvalley','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.813401,-76.376948,0,'2013-07-06 12:44:31',NULL,NULL),(23746,'25936','S','Thurmond','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.948413,-81.050036,0,'2013-07-06 12:44:31',NULL,NULL),(3078,'01151','S','Indian Orchard','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.151001,-72.506454,0,'2013-07-06 12:44:30',NULL,NULL),(49104,'56343','S','Kensington','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.847542,-95.693324,0,'2013-07-06 12:44:33',NULL,NULL),(43445,'48509','S','Flint','A','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.024922,-83.604329,0,'2013-07-06 12:44:32',NULL,NULL),(43960,'49310','S','Millbrook','A','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.519182,-85.010651,0,'2013-07-06 12:44:32',NULL,NULL),(51885,'60091','S','Wilmette','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.076251,-87.728420,0,'2013-07-06 12:44:33',NULL,NULL),(52797,'61275','S','Mobet Meadows','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.598088,-90.317110,0,'2013-07-06 12:44:33',NULL,NULL),(55624,'63965','S','House Creek','N','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(77848,'97224','S','King City','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.408703,-122.789445,0,'2013-07-06 12:44:34',NULL,NULL),(28581,'31630','S','Du Pont','D','Clinch','13065','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.947953,-82.880111,0,'2013-07-06 12:44:32',NULL,NULL),(55184,'63376','S','Saint Peters','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.780270,-90.624050,0,'2013-07-06 12:44:33',NULL,NULL),(72967,'90045','S','Westchester','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.957494,-118.397884,0,'2013-07-06 12:44:34',NULL,NULL),(26356,'29070','S','Delmar','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(26031,'28681','S','All Healing Springs','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(35815,'39759','S','Starkville','D','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(31147,'33911','P','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628255,-81.993931,0,'2013-07-06 12:44:32',NULL,NULL),(29732,'32961','P','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.630902,-80.379791,0,'2013-07-06 12:44:32',NULL,NULL),(74327,'92401','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.106372,-117.291391,0,'2013-07-06 12:44:34',NULL,NULL),(5993,'05353','S','Simpsonville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.064489,-72.668569,0,'2013-07-06 12:44:30',NULL,NULL),(43878,'49220','S','Addison','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.003218,-84.319565,0,'2013-07-06 12:44:32',NULL,NULL),(31788,'35032','P','Bon Air','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.259993,-86.340295,0,'2013-07-06 12:44:32',NULL,NULL),(77756,'97109','S','Banks','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.688031,-123.190696,0,'2013-07-06 12:44:34',NULL,NULL),(55306,'63533','S','Brashear','D','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.220112,-92.432085,0,'2013-07-06 12:44:33',NULL,NULL),(51141,'58833','S','Ambrose','D','Divide','38023','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.787611,-103.726147,0,'2013-07-06 12:44:33',NULL,NULL),(45542,'51454','S','Botna','N','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.903541,-95.249649,0,'2013-07-06 12:44:32',NULL,NULL),(29496,'32751','S','Eatonville','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.625621,-81.355905,0,'2013-07-06 12:44:32',NULL,NULL),(36103,'40220','S','Meadowview Estates','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(34418,'38635','S','Holly Springs','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.772162,-89.450965,0,'2013-07-06 12:44:32',NULL,NULL),(31426,'34260','P','Sarasota','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.421461,-82.539875,0,'2013-07-06 12:44:32',NULL,NULL),(28271,'31082','S','Sandersville','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.980476,-82.810981,0,'2013-07-06 12:44:31',NULL,NULL),(54955,'63119','S','Shrewsbury','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.588549,-90.350542,0,'2013-07-06 12:44:33',NULL,NULL),(76043,'95160','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.219030,-121.860381,0,'2013-07-06 12:44:34',NULL,NULL),(38505,'43702','P','Zanesville','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.940823,-82.006789,0,'2013-07-06 12:44:32',NULL,NULL),(12398,'12928','S','Crown Point','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.966980,-73.461780,0,'2013-07-06 12:44:30',NULL,NULL),(6863,'06133','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753216,-72.704041,0,'2013-07-06 12:44:30',NULL,NULL),(46166,'52731','S','Charlotte','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.963040,-90.471130,0,'2013-07-06 12:44:32',NULL,NULL),(45911,'52322','S','Oxford','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.722093,-91.785552,0,'2013-07-06 12:44:32',NULL,NULL),(38532,'43736','P','Fairview','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.994015,-81.285558,0,'2013-07-06 12:44:32',NULL,NULL),(34698,'38829','S','Booneville','D','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(75249,'93657','S','Sanger','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.784020,-119.468700,0,'2013-07-06 12:44:34',NULL,NULL),(53252,'61701','S','Gillum','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(18183,'18929','S','Jamison','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.252079,-75.085955,0,'2013-07-06 12:44:31',NULL,NULL),(42549,'47872','S','Catlin','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(33043,'36749','S','Jones','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.476828,-86.848059,0,'2013-07-06 12:44:32',NULL,NULL),(30024,'33136','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784628,-80.206454,0,'2013-07-06 12:44:32',NULL,NULL),(63088,'75252','S','Prestonwood','N','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.995735,-96.784576,0,'2013-07-06 12:44:33',NULL,NULL),(68911,'82833','P','Big Horn','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.666155,-107.005303,0,'2013-07-06 12:44:34',NULL,NULL),(71138,'86025','S','Holbrook','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.906715,-110.159202,0,'2013-07-06 12:44:34',NULL,NULL),(69445,'83647','S','Mountain Home','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(64958,'77242','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.732567,-95.559784,0,'2013-07-06 12:44:34',NULL,NULL),(9049,'08888','P','Whitehouse','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.624996,-74.741639,0,'2013-07-06 12:44:30',NULL,NULL),(55938,'64476','S','Pickering','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.467593,-94.833148,0,'2013-07-06 12:44:33',NULL,NULL),(29975,'33090','P','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.477770,-80.542042,0,'2013-07-06 12:44:32',NULL,NULL),(42181,'47536','P','Fulda','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.137904,-86.851121,0,'2013-07-06 12:44:32',NULL,NULL),(58198,'68320','S','Brock','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.477179,-95.959580,0,'2013-07-06 12:44:33',NULL,NULL),(29399,'32626','S','Chiefland','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.484117,-82.864496,0,'2013-07-06 12:44:32',NULL,NULL),(18185,'18931','P','Lahaska','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.357187,-75.041298,0,'2013-07-06 12:44:31',NULL,NULL),(46616,'53574','S','New Glarus','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.812386,-89.639376,0,'2013-07-06 12:44:32',NULL,NULL),(66292,'78584','S','Fronton','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.378999,-98.814980,0,'2013-07-06 12:44:34',NULL,NULL),(63467,'75686','S','Brumley','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(15746,'16911','P','Arnot','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.661491,-77.120959,0,'2013-07-06 12:44:31',NULL,NULL),(21747,'23039','S','Crozier','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.656430,-77.805950,0,'2013-07-06 12:44:31',NULL,NULL),(38862,'44096','P','Willoughby','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.646617,-81.408728,0,'2013-07-06 12:44:32',NULL,NULL),(41327,'46777','S','Kingsland','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.870920,-85.156740,0,'2013-07-06 12:44:32',NULL,NULL),(23326,'25234','S','Sand Ridge','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.834580,-81.172662,0,'2013-07-06 12:44:31',NULL,NULL),(566,'00678','S','Urb Avila','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(17421,'17922','S','Brommerstown','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.594751,-76.154011,0,'2013-07-06 12:44:31',NULL,NULL),(48817,'56030','P','Essig','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.319831,-94.580016,0,'2013-07-06 12:44:33',NULL,NULL),(57883,'67627','P','Catharine','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.983884,-99.205458,0,'2013-07-06 12:44:33',NULL,NULL),(53316,'61741','S','Forrest','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.751704,-88.412200,0,'2013-07-06 12:44:33',NULL,NULL),(79341,'98622','P','Heisson','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.825047,-122.485823,0,'2013-07-06 12:44:34',NULL,NULL),(74920,'93389','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.355642,-119.062999,0,'2013-07-06 12:44:34',NULL,NULL),(59862,'71260','S','Litroe','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.909183,-92.241002,0,'2013-07-06 12:44:33',NULL,NULL),(47331,'54564','S','Spirit Falls','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.646975,-89.982350,0,'2013-07-06 12:44:32',NULL,NULL),(26463,'29148','S','Davis Crossroads','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.589744,-80.341999,0,'2013-07-06 12:44:31',NULL,NULL),(1306,'00732','P','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.036114,-66.611434,0,'2013-07-06 12:44:30',NULL,NULL),(63628,'75835','S','Mapleton','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(63741,'75935','S','Jericho','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(77983,'97390','S','Tidewater','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.387184,-123.893829,0,'2013-07-06 12:44:34',NULL,NULL),(52136,'60435','S','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.552040,-88.111620,0,'2013-07-06 12:44:33',NULL,NULL),(68665,'81653','S','Slater','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.914059,-107.505659,0,'2013-07-06 12:44:34',NULL,NULL),(57518,'66967','S','Smith Center','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.779397,-98.783094,0,'2013-07-06 12:44:33',NULL,NULL),(60,'00611','P','Angeles','D','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.287716,-66.797578,0,'2013-07-06 12:44:30',NULL,NULL),(20539,'21105','P','Maryland Line','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.711425,-76.652659,0,'2013-07-06 12:44:31',NULL,NULL),(19881,'20532','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903020,-77.016199,0,'2013-07-06 12:44:31',NULL,NULL),(30595,'33420','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855333,-80.083047,0,'2013-07-06 12:44:32',NULL,NULL),(31019,'33785','S','Belleair Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(5485,'04746','S','Grand Isle','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.296352,-68.162290,0,'2013-07-06 12:44:30',NULL,NULL),(26152,'28740','S','Grn Mountain','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(56091,'64772','S','Nevada','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.838803,-94.361260,0,'2013-07-06 12:44:33',NULL,NULL),(23064,'24872','S','Panther','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.481698,-81.898570,0,'2013-07-06 12:44:31',NULL,NULL),(1093,'00725','S','Urb El Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(59177,'70346','S','Donaldsonvlle','A','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.100345,-91.001444,0,'2013-07-06 12:44:33',NULL,NULL),(76843,'95965','S','Cherokee','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(78959,'98370','S','Lofall','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(75216,'93634','P','Shaver Lake','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.252980,-119.173800,0,'2013-07-06 12:44:34',NULL,NULL),(73481,'91320','S','Thousand Oaks','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.185360,-118.926480,0,'2013-07-06 12:44:34',NULL,NULL),(64900,'77086','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.921015,-95.493478,0,'2013-07-06 12:44:34',NULL,NULL),(15671,'16821','S','Allport','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.970492,-78.218066,0,'2013-07-06 12:44:31',NULL,NULL),(50611,'58259','S','Michigan','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.062400,-98.125380,0,'2013-07-06 12:44:33',NULL,NULL),(25206,'28079','S','Hemby Bridge','N','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.098742,-80.631203,0,'2013-07-06 12:44:31',NULL,NULL),(53592,'62071','P','National Stock Yards','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.646662,-90.157901,0,'2013-07-06 12:44:33',NULL,NULL),(38516,'43723','S','Byesville','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.960932,-81.544227,0,'2013-07-06 12:44:32',NULL,NULL),(20142,'20724','S','Md City','A','Anne Arundel','24003','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.090999,-76.818955,0,'2013-07-06 12:44:31',NULL,NULL),(79752,'99256','U','Spokane City Trea','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.662552,-117.423159,0,'2013-07-06 12:44:34',NULL,NULL),(43282,'48333','P','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.462218,-83.377754,0,'2013-07-06 12:44:32',NULL,NULL),(63615,'75831','S','Keechi','A','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.461433,-96.074604,0,'2013-07-06 12:44:34',NULL,NULL),(60209,'71419','S','Union Springs','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(59975,'71323','S','Center Point','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.253134,-92.240147,0,'2013-07-06 12:44:33',NULL,NULL),(18289,'19014','S','Chester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(15600,'16672','P','Riddlesburg','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.162589,-78.253993,0,'2013-07-06 12:44:31',NULL,NULL),(40838,'46217','S','Southport','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.667568,-86.198814,0,'2013-07-06 12:44:32',NULL,NULL),(45786,'52162','S','Gunder','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.045500,-91.566000,0,'2013-07-06 12:44:32',NULL,NULL),(33787,'37878','S','Happy Valley','N','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.568988,-83.981124,0,'2013-07-06 12:44:32',NULL,NULL),(21963,'23237','S','Richmond','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.400976,-77.461897,0,'2013-07-06 12:44:31',NULL,NULL),(34621,'38754','S','Bellewood','N','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.260452,-90.592415,0,'2013-07-06 12:44:32',NULL,NULL),(62808,'74942','P','Leflore','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.895363,-94.979495,0,'2013-07-06 12:44:33',NULL,NULL),(18255,'19002','S','Maple Glen','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.190760,-75.206580,0,'2013-07-06 12:44:31',NULL,NULL),(969,'00716','S','Urb El Monte','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(13069,'13452','S','Saint Johnsville','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(28068,'30708','S','Cisco','D','Murray','13213','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.880162,-84.666973,0,'2013-07-06 12:44:31',NULL,NULL),(6590,'05860','S','Brownington','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.807079,-72.201511,0,'2013-07-06 12:44:30',NULL,NULL),(44382,'49801','S','E Kingsford','N','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.817870,-88.066576,0,'2013-07-06 12:44:32',NULL,NULL),(69548,'83808','S','Calder','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.255334,-116.212663,0,'2013-07-06 12:44:34',NULL,NULL),(22026,'23292','U','Nationsbank Mortgage','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542580,-77.444722,0,'2013-07-06 12:44:31',NULL,NULL),(24416,'27127','S','Waughtown','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.047311,-80.265066,0,'2013-07-06 12:44:31',NULL,NULL),(27522,'30214','S','Fayetteville','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.440281,-84.462654,0,'2013-07-06 12:44:31',NULL,NULL),(42035,'47441','S','Linton','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(45293,'50707','S','Evansdale','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.482880,-92.277060,0,'2013-07-06 12:44:32',NULL,NULL),(47371,'54623','S','Coon Valley','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.702221,-91.011762,0,'2013-07-06 12:44:32',NULL,NULL),(31752,'34988','P','Saint Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.341002,-80.519774,0,'2013-07-06 12:44:32',NULL,NULL),(1730,'00778','S','Urb Bajo Costo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(50929,'58566','S','St Anthony','N','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.577847,-100.891742,0,'2013-07-06 12:44:33',NULL,NULL),(20159,'20740','S','Berwyn Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998722,-76.928721,0,'2013-07-06 12:44:31',NULL,NULL),(50621,'58266','S','Niagara','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.975136,-97.813747,0,'2013-07-06 12:44:33',NULL,NULL),(38195,'43206','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.940669,-82.978592,0,'2013-07-06 12:44:32',NULL,NULL),(47179,'54481','S','Hull','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(35226,'39307','S','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.330793,-88.827844,0,'2013-07-06 12:44:32',NULL,NULL),(71637,'87413','S','El Huerfano','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.713295,-107.969839,0,'2013-07-06 12:44:34',NULL,NULL),(71076,'85922','S','Blue','D','Greenlee','04011','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.580570,-109.096805,0,'2013-07-06 12:44:34',NULL,NULL),(48227,'55418','S','St Anthony','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.022134,-93.244686,0,'2013-07-06 12:44:33',NULL,NULL),(18383,'19047','S','Penndel','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.179301,-74.905397,0,'2013-07-06 12:44:31',NULL,NULL),(53599,'62076','P','Ohlman','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.346133,-89.220212,0,'2013-07-06 12:44:33',NULL,NULL),(26943,'29598','P','North Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.805530,-78.718152,0,'2013-07-06 12:44:31',NULL,NULL),(57085,'66217','S','Lake Quivira','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(38456,'43610','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.675482,-83.557388,0,'2013-07-06 12:44:32',NULL,NULL),(74895,'93292','S','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.334358,-119.257454,0,'2013-07-06 12:44:34',NULL,NULL),(66809,'79079','S','Shamrock','D','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.216100,-100.245380,0,'2013-07-06 12:44:34',NULL,NULL),(65784,'78117','S','Hobson','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.936255,-97.982346,0,'2013-07-06 12:44:34',NULL,NULL),(15992,'17035','S','Reeds Gap','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.434041,-77.587129,0,'2013-07-06 12:44:31',NULL,NULL),(15539,'16611','S','Alexandria','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.556814,-78.096428,0,'2013-07-06 12:44:31',NULL,NULL),(77803,'97138','S','Gearhart','A','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.001224,-123.921677,0,'2013-07-06 12:44:34',NULL,NULL),(24253,'26804','S','Circleville','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.616985,-79.552509,0,'2013-07-06 12:44:31',NULL,NULL),(39151,'44287','S','Congress','A','Wayne','39169','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.925833,-82.053056,0,'2013-07-06 12:44:32',NULL,NULL),(57193,'66420','P','Dover','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.970459,-95.932794,0,'2013-07-06 12:44:33',NULL,NULL),(4444,'03246','S','Lakeport','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.551000,-71.427600,0,'2013-07-06 12:44:30',NULL,NULL),(2796,'00976','S','Urb La Cima','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(3609,'02050','S','Marshfield','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.126517,-70.736310,0,'2013-07-06 12:44:30',NULL,NULL),(25450,'28323','S','Bunnlevel','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.290805,-78.831116,0,'2013-07-06 12:44:31',NULL,NULL),(40832,'46214','S','Eagle Creek','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.788672,-86.295650,0,'2013-07-06 12:44:32',NULL,NULL),(22288,'23805','S','North Dinwiddie','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.136328,-77.391900,0,'2013-07-06 12:44:31',NULL,NULL),(24103,'26519','S','Albright','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.532080,-79.643040,0,'2013-07-06 12:44:31',NULL,NULL),(14125,'14649','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157109,-77.604365,0,'2013-07-06 12:44:31',NULL,NULL),(36652,'41006','S','Pleasant Hill','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.791002,-84.321560,0,'2013-07-06 12:44:32',NULL,NULL),(7168,'06443','S','Madison','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.302547,-72.611171,0,'2013-07-06 12:44:30',NULL,NULL),(6766,'06095','S','Wilson','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.863764,-72.668509,0,'2013-07-06 12:44:30',NULL,NULL),(22933,'24628','S','Maxie','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.303473,-82.173372,0,'2013-07-06 12:44:31',NULL,NULL),(50107,'57477','S','Turton','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.023662,-98.108189,0,'2013-07-06 12:44:33',NULL,NULL),(67642,'80461','S','Leadville','D','Lake','08065','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.249613,-106.297523,0,'2013-07-06 12:44:34',NULL,NULL),(8007,'07720','S','Bradley Beach','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.203627,-74.011629,0,'2013-07-06 12:44:30',NULL,NULL),(59427,'70662','S','Sugartown','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.832576,-93.017024,0,'2013-07-06 12:44:33',NULL,NULL),(55385,'63625','S','Black','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.555320,-91.003080,0,'2013-07-06 12:44:33',NULL,NULL),(779,'00693','S','Bda Collazo','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(24053,'26425','S','Manheim','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.224494,-79.662638,0,'2013-07-06 12:44:31',NULL,NULL),(9386,'09844','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60472,'71655','S','Lacey','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(71883,'87733','S','Mosquero','D','Harding','35021','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.733480,-103.599120,0,'2013-07-06 12:44:34',NULL,NULL),(78646,'98224','P','Baring','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.766661,-121.479114,0,'2013-07-06 12:44:34',NULL,NULL),(52734,'61235','S','Cornwall','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.417664,-90.016623,0,'2013-07-06 12:44:33',NULL,NULL),(34268,'38463','S','Iron City','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.018253,-87.582288,0,'2013-07-06 12:44:32',NULL,NULL),(36793,'41051','S','White Tower','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.941955,-84.552352,0,'2013-07-06 12:44:32',NULL,NULL),(44163,'49544','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.001565,-85.743164,0,'2013-07-06 12:44:32',NULL,NULL),(43860,'49116','S','Lakeside','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.848626,-86.670206,0,'2013-07-06 12:44:32',NULL,NULL),(25659,'28480','S','Writsvlle Bch','A','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.207240,-77.796330,0,'2013-07-06 12:44:31',NULL,NULL),(67449,'80212','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.772488,-105.051110,0,'2013-07-06 12:44:34',NULL,NULL),(10837,'11385','S','Ridgewood','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702860,-73.879740,0,'2013-07-06 12:44:30',NULL,NULL),(38454,'43608','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.676751,-83.535409,0,'2013-07-06 12:44:32',NULL,NULL),(73592,'91386','P','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.417490,-118.449656,0,'2013-07-06 12:44:34',NULL,NULL),(68475,'81243','S','Powderhorn','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.268871,-107.190705,0,'2013-07-06 12:44:34',NULL,NULL),(60952,'72101','S','Morton','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(30925,'33709','S','Kenneth City','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.817643,-82.732339,0,'2013-07-06 12:44:32',NULL,NULL),(13024,'13428','S','Palatine Brg','A','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.909641,-74.574370,0,'2013-07-06 12:44:30',NULL,NULL),(58358,'68512','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.756847,-96.694879,0,'2013-07-06 12:44:33',NULL,NULL),(680,'00683','S','Valle Verde','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(32440,'36006','S','Billingsley','D','Autauga','01001','Alabama','AL','01','5240','205/659','Central',-6.0,'Y',32.616643,-86.708049,0,'2013-07-06 12:44:32',NULL,NULL),(24591,'27323','P','Reidsville','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.315993,-79.658545,0,'2013-07-06 12:44:31',NULL,NULL),(686,'00685','S','Bda Paralelo 38','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(68430,'81212','S','Prospect Heights','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(41651,'47138','S','Blocher','A','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.712755,-85.655231,0,'2013-07-06 12:44:32',NULL,NULL),(55318,'63540','S','Gibbs','D','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.082101,-92.432799,0,'2013-07-06 12:44:33',NULL,NULL),(13715,'14075','S','Hamburg','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.733234,-78.834422,0,'2013-07-06 12:44:31',NULL,NULL),(18340,'19030','S','Fairless Hills','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.173040,-74.848169,0,'2013-07-06 12:44:31',NULL,NULL),(68652,'81642','S','Norrie','N','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.343479,-106.678875,0,'2013-07-06 12:44:34',NULL,NULL),(60446,'71647','S','Sumpter','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(21233,'22227','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.854079,-77.054897,0,'2013-07-06 12:44:31',NULL,NULL),(5797,'05061','S','Randolph Center','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.928243,-72.589744,0,'2013-07-06 12:44:30',NULL,NULL),(10255,'10474','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.809555,-73.885815,0,'2013-07-06 12:44:30',NULL,NULL),(50018,'57399','U','Huron','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.363185,-98.218918,0,'2013-07-06 12:44:33',NULL,NULL),(54287,'62702','S','Grandview','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.829980,-89.653080,0,'2013-07-06 12:44:33',NULL,NULL),(58454,'68724','S','Center','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.614295,-97.892406,0,'2013-07-06 12:44:33',NULL,NULL),(45813,'52203','S','High','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.804159,-91.867902,0,'2013-07-06 12:44:32',NULL,NULL),(20347,'20857','U','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.079354,-77.156398,0,'2013-07-06 12:44:31',NULL,NULL),(59725,'71109','S','Fairgrounds','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.465400,-93.814020,0,'2013-07-06 12:44:33',NULL,NULL),(72641,'89425','S','Orovada','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.738584,-118.090715,0,'2013-07-06 12:44:34',NULL,NULL),(23698,'25865','S','Lester','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.717669,-81.337501,0,'2013-07-06 12:44:31',NULL,NULL),(17737,'18301','S','East Stroudsburg','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024022,-75.185712,0,'2013-07-06 12:44:31',NULL,NULL),(10855,'11413','S','Saint Albans','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(48834,'56047','P','Huntley','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.722763,-94.192025,0,'2013-07-06 12:44:33',NULL,NULL),(49922,'57319','S','Stanley Corner','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.529100,-97.446420,0,'2013-07-06 12:44:33',NULL,NULL),(23625,'25721','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.422993,-82.441633,0,'2013-07-06 12:44:31',NULL,NULL),(18302,'19018','S','Aldan','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(66761,'79015','S','Canyon','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',34.983625,-101.923289,0,'2013-07-06 12:44:34',NULL,NULL),(68869,'82638','S','Moneta','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.161514,-107.722759,0,'2013-07-06 12:44:34',NULL,NULL),(71619,'87347','P','Jamestown','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432459,-108.729828,0,'2013-07-06 12:44:34',NULL,NULL),(41984,'47421','S','Patton Hill','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(73131,'90272','S','Pacific Plsds','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.053275,-118.534568,0,'2013-07-06 12:44:34',NULL,NULL),(11444,'11976','S','Watermill','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.930979,-72.352790,0,'2013-07-06 12:44:30',NULL,NULL),(2163,'00926','S','Bda Vista Alegre','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(25640,'28467','S','Carolina Shor','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.898397,-78.578267,0,'2013-07-06 12:44:31',NULL,NULL),(29491,'32745','P','Mid Florida','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.786730,-81.347130,0,'2013-07-06 12:44:32',NULL,NULL),(30037,'33141','S','Normandy','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(6512,'05821','S','West Barnet','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.314722,-72.166389,0,'2013-07-06 12:44:30',NULL,NULL),(30664,'33464','U','National Enquirer','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.584130,-80.049062,0,'2013-07-06 12:44:32',NULL,NULL),(18465,'19082','S','Millbourne','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.956267,-75.274357,0,'2013-07-06 12:44:31',NULL,NULL),(76881,'95977','S','Big Oak Valley','A','Nevada','06057','California','CA','06','9340','530','Pacific',-8.0,'Y',39.197157,-121.253817,0,'2013-07-06 12:44:34',NULL,NULL),(76530,'95653','P','Madison','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.680956,-121.971051,0,'2013-07-06 12:44:34',NULL,NULL),(18158,'18850','S','Ulster','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.842993,-76.474076,0,'2013-07-06 12:44:31',NULL,NULL),(48325,'55448','S','Coon Rapids','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.187610,-93.298576,0,'2013-07-06 12:44:33',NULL,NULL),(13546,'13830','S','East McDonough','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(58225,'68344','S','Douglas','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.594843,-96.384446,0,'2013-07-06 12:44:33',NULL,NULL),(35839,'39773','S','Whites','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.629580,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(35527,'39552','P','Escatawpa','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.450481,-88.540961,0,'2013-07-06 12:44:32',NULL,NULL),(3708,'02141','S','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.368312,-71.082436,0,'2013-07-06 12:44:30',NULL,NULL),(45577,'51533','S','Emerson','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.018892,-95.403931,0,'2013-07-06 12:44:32',NULL,NULL),(17347,'17870','S','Monroe Township','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(32798,'36427','P','Brewton','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.107929,-87.071149,0,'2013-07-06 12:44:32',NULL,NULL),(73289,'90749','P','Carson','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.819146,-118.263108,0,'2013-07-06 12:44:34',NULL,NULL),(70487,'84770','S','Saint George','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(66934,'79355','S','Plains','D','Yoakum','48501','Texas','TX','48','0000','806','Central',-6.0,'Y',33.196972,-102.829053,0,'2013-07-06 12:44:34',NULL,NULL),(60094,'71360','S','Cp Beauregard','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(30817,'33618','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.077694,-82.499088,0,'2013-07-06 12:44:32',NULL,NULL),(34781,'38865','S','Pisgah','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.711840,-88.659681,0,'2013-07-06 12:44:32',NULL,NULL),(13880,'14261','U','University at Buffalo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.002450,-78.781965,0,'2013-07-06 12:44:31',NULL,NULL),(46647,'53598','S','Lake Windsor','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.211584,-89.345542,0,'2013-07-06 12:44:32',NULL,NULL),(79167,'98513','S','Lacey','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.007788,-122.750150,0,'2013-07-06 12:44:34',NULL,NULL),(78807,'98329','S','Gig Harbor','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.373068,-122.712454,0,'2013-07-06 12:44:34',NULL,NULL),(68043,'80930','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.830904,-104.513630,0,'2013-07-06 12:44:34',NULL,NULL),(54366,'62803','S','Huegely','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.451703,-89.313807,0,'2013-07-06 12:44:33',NULL,NULL),(33698,'37760','S','Jeff City','N','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.119161,-83.493766,0,'2013-07-06 12:44:32',NULL,NULL),(794,'00693','S','Ext Ocean Front','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(48927,'56151','S','Lake Wilson','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.008260,-95.906340,0,'2013-07-06 12:44:33',NULL,NULL),(28521,'31545','S','Jesup','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.612517,-81.885560,0,'2013-07-06 12:44:32',NULL,NULL),(46426,'53190','S','Whitewater','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.820613,-88.729455,0,'2013-07-06 12:44:32',NULL,NULL),(42697,'47992','S','Westpoint','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.317115,-87.066701,0,'2013-07-06 12:44:32',NULL,NULL),(35641,'39638','S','Homochitto','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(38134,'43125','S','Groveport','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.844452,-82.879107,0,'2013-07-06 12:44:32',NULL,NULL),(67399,'80126','S','Highlands Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.548022,-104.963984,0,'2013-07-06 12:44:34',NULL,NULL),(74704,'93006','P','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.279885,-119.291934,0,'2013-07-06 12:44:34',NULL,NULL),(79694,'99205','S','Shadle Garland','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.695450,-117.442334,0,'2013-07-06 12:44:34',NULL,NULL),(66244,'78572','S','Abram','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(42506,'47846','S','Cory','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.381462,-87.201497,0,'2013-07-06 12:44:32',NULL,NULL),(54626,'62918','S','Carterville','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.789020,-89.096520,0,'2013-07-06 12:44:33',NULL,NULL),(57744,'67432','S','Oakhill','A','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.382490,-97.120208,0,'2013-07-06 12:44:33',NULL,NULL),(14251,'14827','P','Coopers Plains','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.178306,-77.140860,0,'2013-07-06 12:44:31',NULL,NULL),(17692,'18210','S','Albrightsvlle','A','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.996515,-75.572713,0,'2013-07-06 12:44:31',NULL,NULL),(18805,'19401','S','Norristown','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.130580,-75.347520,0,'2013-07-06 12:44:31',NULL,NULL),(63116,'75301','U','JC Penney Company','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.661511,-96.885392,0,'2013-07-06 12:44:33',NULL,NULL),(68370,'81138','P','Jaroso','D','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.003263,-105.624634,0,'2013-07-06 12:44:34',NULL,NULL),(74671,'92863','P','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.815348,-117.827275,0,'2013-07-06 12:44:34',NULL,NULL),(68448,'81226','S','Portland','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.370060,-105.119760,0,'2013-07-06 12:44:34',NULL,NULL),(53053,'61485','S','Victoria','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.033668,-90.097689,0,'2013-07-06 12:44:33',NULL,NULL),(57135,'66226','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.004920,-94.858860,0,'2013-07-06 12:44:33',NULL,NULL),(6616,'05875','S','Barton','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.696433,-72.268832,0,'2013-07-06 12:44:30',NULL,NULL),(55055,'63150','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.632631,-90.193043,0,'2013-07-06 12:44:33',NULL,NULL),(28185,'31010','P','Cordele','D','Crisp','13081','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.953919,-83.782947,0,'2013-07-06 12:44:31',NULL,NULL),(18957,'19512','S','Englesville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(16990,'17728','S','Hepburn','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(26349,'29067','S','Taxahaw','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.498309,-80.520734,0,'2013-07-06 12:44:31',NULL,NULL),(10180,'10282','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(31838,'35082','P','Hollins','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.115279,-86.108320,0,'2013-07-06 12:44:32',NULL,NULL),(12618,'13088','S','Lpool','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(70962,'85648','S','Nogales','A','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.486260,-111.003000,0,'2013-07-06 12:44:34',NULL,NULL),(60565,'71753','S','Magnolia','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.264345,-93.233796,0,'2013-07-06 12:44:33',NULL,NULL),(26129,'28734','S','East Franklin','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(4543,'03446','S','Swanzey','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.854142,-72.260794,0,'2013-07-06 12:44:30',NULL,NULL),(28565,'31601','S','Remerton','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.825593,-83.284447,0,'2013-07-06 12:44:32',NULL,NULL),(39096,'44231','S','Nelson','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.299320,-81.073020,0,'2013-07-06 12:44:32',NULL,NULL),(31870,'35124','S','Indian Spgs','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.301860,-86.791800,0,'2013-07-06 12:44:32',NULL,NULL),(13312,'13674','P','Pierrepnt Mnr','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.735379,-76.058567,0,'2013-07-06 12:44:30',NULL,NULL),(48781,'55990','S','Wykoff','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.713480,-92.269860,0,'2013-07-06 12:44:33',NULL,NULL),(43121,'48229','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.252273,-83.144669,0,'2013-07-06 12:44:32',NULL,NULL),(25358,'28233','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.213038,-80.827706,0,'2013-07-06 12:44:31',NULL,NULL),(11149,'11717','S','Edgewood','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.780920,-73.254540,0,'2013-07-06 12:44:30',NULL,NULL),(42485,'47838','S','Carlisle','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.117887,-87.465105,0,'2013-07-06 12:44:32',NULL,NULL),(9384,'09842','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(68375,'81141','P','Manassa','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173854,-105.934271,0,'2013-07-06 12:44:34',NULL,NULL),(75194,'93618','S','London','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.546422,-119.388990,0,'2013-07-06 12:44:34',NULL,NULL),(76605,'95690','S','Long Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(17302,'17853','S','Aline','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(31805,'35049','S','Cleveland','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.969191,-86.598370,0,'2013-07-06 12:44:32',NULL,NULL),(36031,'40175','S','Flaherty','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.814263,-85.990010,0,'2013-07-06 12:44:32',NULL,NULL),(14154,'14719','S','Cattaraugus','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.329564,-78.869510,0,'2013-07-06 12:44:31',NULL,NULL),(27509,'30183','S','Lake Arrowhead','N','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.335140,-84.590564,0,'2013-07-06 12:44:31',NULL,NULL),(18983,'19522','S','Boyers Junction','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(15752,'16914','S','Col X Rds','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(17422,'17922','S','South Manheim','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.594751,-76.154011,0,'2013-07-06 12:44:31',NULL,NULL),(78620,'98203','S','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.945956,-122.229877,0,'2013-07-06 12:44:34',NULL,NULL),(74087,'92191','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.904114,-117.216990,0,'2013-07-06 12:44:34',NULL,NULL),(15750,'16914','S','Austinville','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(40002,'45244','S','Anderson','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118320,-84.337680,0,'2013-07-06 12:44:32',NULL,NULL),(40592,'45880','S','Payne','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.076402,-84.730848,0,'2013-07-06 12:44:32',NULL,NULL),(53084,'61525','S','Lake of the Woods','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.843082,-89.645087,0,'2013-07-06 12:44:33',NULL,NULL),(22187,'23487','S','Windsor','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.815167,-76.744722,0,'2013-07-06 12:44:31',NULL,NULL),(38702,'44003','S','Cherry Valley','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.627584,-80.585183,0,'2013-07-06 12:44:32',NULL,NULL),(70392,'84701','S','Richfield','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.675160,-111.989820,0,'2013-07-06 12:44:34',NULL,NULL),(40733,'46129','P','Carrollton','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.705783,-85.823391,0,'2013-07-06 12:44:32',NULL,NULL),(23555,'25634','P','Mallory','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.737232,-81.818685,0,'2013-07-06 12:44:31',NULL,NULL),(38595,'43828','P','Keene','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.341692,-81.865700,0,'2013-07-06 12:44:32',NULL,NULL),(26811,'29474','S','Round O','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.942016,-80.577727,0,'2013-07-06 12:44:31',NULL,NULL),(38649,'43938','S','Mingo Jct','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.315500,-80.626200,0,'2013-07-06 12:44:32',NULL,NULL),(36831,'41071','S','Southgate','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(63855,'75977','S','Wiergate','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(63269,'75501','S','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.424489,-94.102297,0,'2013-07-06 12:44:33',NULL,NULL),(3468,'01813','U','Mellon Financial Services','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.508236,-71.123401,0,'2013-07-06 12:44:30',NULL,NULL),(11378,'11934','S','Center Moriches','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.800258,-72.796529,0,'2013-07-06 12:44:30',NULL,NULL),(12899,'13334','S','Georgtown Station','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827651,-75.654124,0,'2013-07-06 12:44:30',NULL,NULL),(41903,'47371','S','Westchester','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(12267,'12834','S','Clarks Mills','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.090326,-73.500080,0,'2013-07-06 12:44:30',NULL,NULL),(38127,'43116','S','Commercial Point','D','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.770313,-83.058340,0,'2013-07-06 12:44:32',NULL,NULL),(25751,'28578','S','Seven Springs','D','Wayne','37191','North Carolina','NC','37','2980','252','Eastern',-5.0,'Y',35.208045,-77.918494,0,'2013-07-06 12:44:31',NULL,NULL),(40891,'46249','U','Army Finance Center','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861999,-86.002044,0,'2013-07-06 12:44:32',NULL,NULL),(8454,'08087','S','Ltl Egg Hbr','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(38626,'43917','S','Dillonvale','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.147121,-80.831081,0,'2013-07-06 12:44:32',NULL,NULL),(7709,'07189','U','Bank of America','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.797515,-74.161810,0,'2013-07-06 12:44:30',NULL,NULL),(31459,'34287','S','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.078300,-82.181160,0,'2013-07-06 12:44:32',NULL,NULL),(43397,'48444','S','Imlay','N','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.055349,-83.070632,0,'2013-07-06 12:44:32',NULL,NULL),(33552,'37402','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.045624,-85.310635,0,'2013-07-06 12:44:32',NULL,NULL),(61280,'72392','S','Wheatley','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.953612,-91.099638,0,'2013-07-06 12:44:33',NULL,NULL),(74751,'93063','S','Santa Susana','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.271667,-118.708056,0,'2013-07-06 12:44:34',NULL,NULL),(79759,'99302','P','Tri Cities','A','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.256423,-119.079477,0,'2013-07-06 12:44:34',NULL,NULL),(15130,'15831','P','Dagus Mines','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.352895,-78.606185,0,'2013-07-06 12:44:31',NULL,NULL),(26020,'28677','S','Love Valley','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(42018,'47433','S','Hollybrk Lk','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.302962,-86.623199,0,'2013-07-06 12:44:32',NULL,NULL),(56026,'64672','S','Powersville','D','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.528235,-93.285829,0,'2013-07-06 12:44:33',NULL,NULL),(8134,'07833','P','Delaware','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.891592,-75.066951,0,'2013-07-06 12:44:30',NULL,NULL),(44268,'49696','S','Traverse City','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.757555,-85.601648,0,'2013-07-06 12:44:32',NULL,NULL),(36600,'40977','S','Balkan','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(23184,'25045','S','Clendenin','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.460480,-81.335520,0,'2013-07-06 12:44:31',NULL,NULL),(15617,'16686','S','Tyrone','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.671083,-78.246566,0,'2013-07-06 12:44:31',NULL,NULL),(12664,'13121','P','New Haven','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.479969,-76.313034,0,'2013-07-06 12:44:30',NULL,NULL),(67981,'80916','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.803293,-104.707538,0,'2013-07-06 12:44:34',NULL,NULL),(79672,'99164','U','Pullman','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.728892,-117.155742,0,'2013-07-06 12:44:34',NULL,NULL),(42859,'48080','S','St Clair Shrs','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465933,-82.903852,0,'2013-07-06 12:44:32',NULL,NULL),(52097,'60411','S','Otto Mall','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(24083,'26456','S','West Union','D','Doddridge','54017','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.293955,-80.773989,0,'2013-07-06 12:44:31',NULL,NULL),(48075,'55330','S','Ramsey','N','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(18547,'19114','S','Torresdale South','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.064913,-75.003036,0,'2013-07-06 12:44:31',NULL,NULL),(41459,'46910','S','Akron','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.039604,-86.030494,0,'2013-07-06 12:44:32',NULL,NULL),(41746,'47273','S','Scipio','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.080034,-85.724927,0,'2013-07-06 12:44:32',NULL,NULL),(76935,'96020','S','Chester','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.296069,-121.226895,0,'2013-07-06 12:44:34',NULL,NULL),(66058,'78380','S','Bluntzer','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(54360,'62801','S','Cravat','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(4875,'04034','U','Freeport','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.856581,-70.102589,0,'2013-07-06 12:44:30',NULL,NULL),(14421,'15069','U','New Kensingtn','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.569677,-79.749317,0,'2013-07-06 12:44:31',NULL,NULL),(52150,'60443','S','Matteson','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.507329,-87.735557,0,'2013-07-06 12:44:33',NULL,NULL),(45240,'50652','P','Lincoln','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.265433,-92.689775,0,'2013-07-06 12:44:32',NULL,NULL),(64886,'77074','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.678125,-95.519229,0,'2013-07-06 12:44:34',NULL,NULL),(44716,'50147','S','Lineville','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.579725,-93.523649,0,'2013-07-06 12:44:32',NULL,NULL),(46399,'53158','S','Pleasant Prairie','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.551177,-87.931552,0,'2013-07-06 12:44:32',NULL,NULL),(4254,'02879','S','Jerusalem','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(7926,'07646','S','N Milford','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.933644,-74.022176,0,'2013-07-06 12:44:30',NULL,NULL),(55984,'64628','S','Saint Catharine','A','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.788893,-93.073091,0,'2013-07-06 12:44:33',NULL,NULL),(11435,'11969','P','South Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.965942,-72.357568,0,'2013-07-06 12:44:30',NULL,NULL),(62857,'75027','P','Flowermound','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.026466,-97.093775,0,'2013-07-06 12:44:33',NULL,NULL),(66222,'78560','S','La Joya','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.246580,-98.481120,0,'2013-07-06 12:44:34',NULL,NULL),(70569,'85061','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.519632,-112.127047,0,'2013-07-06 12:44:34',NULL,NULL),(56943,'66087','S','Troy','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.780540,-95.088600,0,'2013-07-06 12:44:33',NULL,NULL),(70955,'85643','S','Sierra Bonita','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(70822,'85385','P','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.583811,-112.234513,0,'2013-07-06 12:44:34',NULL,NULL),(70640,'85143','S','San Tan Valley','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.161780,-111.550939,0,'2013-07-06 12:44:34',NULL,NULL),(24901,'27711','U','Environ  Protect Agency','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916201,-78.867468,0,'2013-07-06 12:44:31',NULL,NULL),(24407,'27110','U','Ws State Univ','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.103342,-80.227719,0,'2013-07-06 12:44:31',NULL,NULL),(10297,'10524','S','Garrison','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.369283,-73.919944,0,'2013-07-06 12:44:30',NULL,NULL),(46504,'53235','S','Bayview','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.969046,-87.871317,0,'2013-07-06 12:44:32',NULL,NULL),(58291,'68415','S','Odell','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.046798,-96.803063,0,'2013-07-06 12:44:33',NULL,NULL),(11416,'11962','P','Sagaponack','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.950826,-72.287798,0,'2013-07-06 12:44:30',NULL,NULL),(37404,'41774','S','Fusonia','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.138863,-83.165412,0,'2013-07-06 12:44:32',NULL,NULL),(31365,'34207','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.437280,-82.576198,0,'2013-07-06 12:44:32',NULL,NULL),(708,'00687','S','Brisas del Rio','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(4362,'03060','S','Nashua','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.759073,-71.467632,0,'2013-07-06 12:44:30',NULL,NULL),(64858,'77054','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.682326,-95.400410,0,'2013-07-06 12:44:34',NULL,NULL),(79129,'98498','S','Fort Steilacoom','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162978,-122.560507,0,'2013-07-06 12:44:34',NULL,NULL),(8061,'07747','S','Aberdeen','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.412700,-74.252520,0,'2013-07-06 12:44:30',NULL,NULL),(73781,'91745','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.998974,-117.965163,0,'2013-07-06 12:44:34',NULL,NULL),(72252,'88529','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810311,-106.416973,0,'2013-07-06 12:44:34',NULL,NULL),(58861,'69149','S','Lodgepole','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.167860,-102.655560,0,'2013-07-06 12:44:33',NULL,NULL),(30826,'33621','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.838697,-82.496433,0,'2013-07-06 12:44:32',NULL,NULL),(51573,'59760','P','Willow Creek','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.823617,-111.635853,0,'2013-07-06 12:44:33',NULL,NULL),(45849,'52229','S','Garrison','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.142701,-92.140224,0,'2013-07-06 12:44:32',NULL,NULL),(62037,'73506','P','Lawton','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.621221,-98.459587,0,'2013-07-06 12:44:33',NULL,NULL),(40219,'45409','S','Moraine','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.724144,-84.183354,0,'2013-07-06 12:44:32',NULL,NULL),(38847,'44092','S','Wickliffe','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.603368,-81.464859,0,'2013-07-06 12:44:32',NULL,NULL),(7004,'06255','S','North Grosvendale','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.986809,-71.902586,0,'2013-07-06 12:44:30',NULL,NULL),(54112,'62547','S','Mount Auburn','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.761091,-89.213265,0,'2013-07-06 12:44:33',NULL,NULL),(56781,'65752','S','S Greenfield','A','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.366087,-93.844568,0,'2013-07-06 12:44:33',NULL,NULL),(57618,'67131','S','Rock','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.430201,-96.931267,0,'2013-07-06 12:44:33',NULL,NULL),(10642,'11096','S','Inwood','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.618459,-73.748859,0,'2013-07-06 12:44:30',NULL,NULL),(59722,'71108','S','Southern Hills','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.441723,-93.787148,0,'2013-07-06 12:44:33',NULL,NULL),(553,'00677','S','Urb Las Lomas','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(23866,'26149','S','Wick','A','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.500700,-80.890860,0,'2013-07-06 12:44:31',NULL,NULL),(801,'00693','S','Sect Arenales','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(4828,'03910','P','York Beach','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.177794,-70.614252,0,'2013-07-06 12:44:30',NULL,NULL),(8498,'08096','S','Woodbury','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(14576,'15218','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426383,-79.888677,0,'2013-07-06 12:44:31',NULL,NULL),(37639,'42164','S','Trammel','N','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.782160,-86.190120,0,'2013-07-06 12:44:32',NULL,NULL),(56153,'64856','S','Jane','A','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.588540,-94.369980,0,'2013-07-06 12:44:33',NULL,NULL),(42119,'47469','S','West Baden Springs','D','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(41738,'47263','P','New Point','D','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.310196,-85.328612,0,'2013-07-06 12:44:32',NULL,NULL),(60401,'71635','S','Meridian','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.129096,-91.960667,0,'2013-07-06 12:44:33',NULL,NULL),(75755,'94613','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.783256,-122.186684,0,'2013-07-06 12:44:34',NULL,NULL),(69897,'84106','S','Millcreek','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(47017,'54311','S','Bellevue','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.493458,-87.928499,0,'2013-07-06 12:44:32',NULL,NULL),(50608,'58256','S','Manvel','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.100804,-97.246341,0,'2013-07-06 12:44:33',NULL,NULL),(7818,'07456','S','Erskine','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.100840,-74.290260,0,'2013-07-06 12:44:30',NULL,NULL),(10936,'11434','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(21491,'22652','S','St Davids Ch','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.842058,-78.419588,0,'2013-07-06 12:44:31',NULL,NULL),(75788,'94707','S','Albany','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.899300,-122.276520,0,'2013-07-06 12:44:34',NULL,NULL),(76583,'95682','S','Cameron Park','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.656055,-120.961681,0,'2013-07-06 12:44:34',NULL,NULL),(73626,'91409','P','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203560,-118.489767,0,'2013-07-06 12:44:34',NULL,NULL),(67544,'80261','U','CO Dept Of Revenue','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.691209,-104.984621,0,'2013-07-06 12:44:34',NULL,NULL),(30708,'33496','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.405070,-80.168274,0,'2013-07-06 12:44:32',NULL,NULL),(49279,'56514','S','Barnesville','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.670040,-96.391560,0,'2013-07-06 12:44:33',NULL,NULL),(76416,'95560','S','Redway','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.120251,-123.869032,0,'2013-07-06 12:44:34',NULL,NULL),(78384,'98027','S','Coal Creek','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.533481,-122.068701,0,'2013-07-06 12:44:34',NULL,NULL),(3839,'02340','U','Hanover','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.110338,-70.812083,0,'2013-07-06 12:44:30',NULL,NULL),(7760,'07405','S','Fayson Lake','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(30413,'33325','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110796,-80.317912,0,'2013-07-06 12:44:32',NULL,NULL),(57870,'67583','S','Langdon','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.807408,-98.427406,0,'2013-07-06 12:44:33',NULL,NULL),(37980,'42731','S','Dubre','D','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.836447,-85.545743,0,'2013-07-06 12:44:32',NULL,NULL),(43989,'49336','S','Morley','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.506477,-85.425900,0,'2013-07-06 12:44:32',NULL,NULL),(54539,'62884','S','Sesser','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.090961,-89.049578,0,'2013-07-06 12:44:33',NULL,NULL),(69030,'83217','S','Bancroft','D','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.742325,-111.887397,0,'2013-07-06 12:44:34',NULL,NULL),(49504,'56667','S','Durand','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(18713,'19244','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951444,-75.151511,0,'2013-07-06 12:44:31',NULL,NULL),(55333,'63549','S','La Plata','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.023008,-92.494977,0,'2013-07-06 12:44:33',NULL,NULL),(22516,'24087','S','Lafayette','A','Montgomery','51121','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.197300,-80.221200,0,'2013-07-06 12:44:31',NULL,NULL),(4173,'02807','P','Block Island','D','Washington','44009','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.180709,-71.573098,0,'2013-07-06 12:44:30',NULL,NULL),(77128,'96155','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.018968,-120.123053,0,'2013-07-06 12:44:34',NULL,NULL),(73937,'92046','P','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.125918,-117.101637,0,'2013-07-06 12:44:34',NULL,NULL),(26642,'29341','S','Gaffney','D','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.094560,-81.677416,0,'2013-07-06 12:44:31',NULL,NULL),(41268,'46750','S','Majenica','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(29768,'33009','S','Halndle Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(31385,'34218','P','Bradenton Bch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.501540,-82.709820,0,'2013-07-06 12:44:32',NULL,NULL),(6572,'05855','S','Eagle Point','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(9990,'10165','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(9393,'09858','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58270,'68382','S','Lorton','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.595600,-96.024200,0,'2013-07-06 12:44:33',NULL,NULL),(79230,'98550','S','Grays Harbor City','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(47096,'54440','S','Bevent','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.822844,-89.379647,0,'2013-07-06 12:44:32',NULL,NULL),(27056,'29680','S','Simpsonville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.720389,-82.270653,0,'2013-07-06 12:44:31',NULL,NULL),(51729,'60011','P','Barrington','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.186028,-88.220256,0,'2013-07-06 12:44:33',NULL,NULL),(45097,'50541','S','Gilmore City','D','Pocahontas','19151','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.717660,-94.425000,0,'2013-07-06 12:44:32',NULL,NULL),(71459,'87049','P','San Fidel','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.083765,-107.608587,0,'2013-07-06 12:44:34',NULL,NULL),(65704,'78012','S','Christine','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.793868,-98.512593,0,'2013-07-06 12:44:34',NULL,NULL),(48132,'55360','S','Mayer','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.882967,-93.888168,0,'2013-07-06 12:44:33',NULL,NULL),(52254,'60520','S','Hinckley','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.768822,-88.648730,0,'2013-07-06 12:44:33',NULL,NULL),(34791,'38870','S','Turon','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.065634,-88.382455,0,'2013-07-06 12:44:32',NULL,NULL),(52363,'60613','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.955735,-87.661210,0,'2013-07-06 12:44:33',NULL,NULL),(2649,'00966','S','Mans de Tintillo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(75518,'94151','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.793488,-122.400180,0,'2013-07-06 12:44:34',NULL,NULL),(35754,'39735','S','Reform','A','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.336060,-89.186940,0,'2013-07-06 12:44:32',NULL,NULL),(67942,'80911','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(61729,'73022','P','Concho','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.617992,-97.995354,0,'2013-07-06 12:44:33',NULL,NULL),(22698,'24327','P','Emory','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.767761,-81.854299,0,'2013-07-06 12:44:31',NULL,NULL),(54301,'62707','S','Clear Lake','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(34147,'38236','S','Mansfield','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.183352,-88.285932,0,'2013-07-06 12:44:32',NULL,NULL),(10243,'10468','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868013,-73.896417,0,'2013-07-06 12:44:30',NULL,NULL),(64142,'76197','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.777097,-97.299046,0,'2013-07-06 12:44:34',NULL,NULL),(72899,'90020','S','Sanford','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.068259,-118.310430,0,'2013-07-06 12:44:34',NULL,NULL),(33421,'37242','U','TN Dept Revenue','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.163122,-86.783343,0,'2013-07-06 12:44:32',NULL,NULL),(33483,'37340','S','Guild','D','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.017989,-85.509634,0,'2013-07-06 12:44:32',NULL,NULL),(57367,'66741','S','Arcadia','A','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.714958,-94.683076,0,'2013-07-06 12:44:33',NULL,NULL),(71879,'87732','S','Ledoux','A','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.059286,-105.288077,0,'2013-07-06 12:44:34',NULL,NULL),(63872,'76007','P','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.721384,-97.081910,0,'2013-07-06 12:44:34',NULL,NULL),(21296,'22402','P','Fred','N','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.256114,-77.566794,0,'2013-07-06 12:44:31',NULL,NULL),(55789,'64121','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.100769,-94.578994,0,'2013-07-06 12:44:33',NULL,NULL),(74910,'93314','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.386302,-119.170023,0,'2013-07-06 12:44:34',NULL,NULL),(70722,'85287','U','Arizona State University','N','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.428352,-111.932123,0,'2013-07-06 12:44:34',NULL,NULL),(63312,'75567','S','Maud','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.364200,-94.472220,0,'2013-07-06 12:44:33',NULL,NULL),(11398,'11950','S','Rivers Edge','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.806599,-72.840193,0,'2013-07-06 12:44:30',NULL,NULL),(11271,'11771','S','Centre Island','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(21956,'23235','S','North Chesterfield','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.502040,-77.569920,0,'2013-07-06 12:44:31',NULL,NULL),(9383,'09841','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(47282,'54541','S','Blackwell','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.558480,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(39740,'45069','S','Liberty Twp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.341460,-84.398674,0,'2013-07-06 12:44:32',NULL,NULL),(38387,'43517','S','Edgerton','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.459680,-84.741556,0,'2013-07-06 12:44:32',NULL,NULL),(35248,'39339','S','Louisville','D','Winston','28159','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.125133,-89.055051,0,'2013-07-06 12:44:32',NULL,NULL),(41394,'46806','S','Diplomat','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.046401,-85.105518,0,'2013-07-06 12:44:32',NULL,NULL),(56500,'65339','S','Malta Bend','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.197280,-93.380280,0,'2013-07-06 12:44:33',NULL,NULL),(17981,'18618','S','Monroe Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.341140,-76.017214,0,'2013-07-06 12:44:31',NULL,NULL),(31216,'33954','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.023295,-82.107696,0,'2013-07-06 12:44:32',NULL,NULL),(15188,'15946','S','Portage','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.395360,-78.690600,0,'2013-07-06 12:44:31',NULL,NULL),(16780,'17529','S','Gordonville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.040039,-76.107124,0,'2013-07-06 12:44:31',NULL,NULL),(65198,'77430','S','Damon','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.288027,-95.684691,0,'2013-07-06 12:44:34',NULL,NULL),(32965,'36602','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.692404,-88.046843,0,'2013-07-06 12:44:32',NULL,NULL),(29702,'32937','S','Satellite Bch','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(34928,'38966','S','Webb','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.948357,-90.348145,0,'2013-07-06 12:44:32',NULL,NULL),(10429,'10803','S','Pelham Manor','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.905342,-73.804941,0,'2013-07-06 12:44:30',NULL,NULL),(48471,'55720','S','Knife Falls','N','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.729380,-92.459220,0,'2013-07-06 12:44:33',NULL,NULL),(35759,'39739','S','Cliftonville','N','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.234567,-88.580798,0,'2013-07-06 12:44:32',NULL,NULL),(35790,'39751','S','Dancy','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.733333,-89.066667,0,'2013-07-06 12:44:32',NULL,NULL),(29409,'32641','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.653504,-82.327190,0,'2013-07-06 12:44:32',NULL,NULL),(27184,'29849','S','Ulmer','D','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.055326,-81.215569,0,'2013-07-06 12:44:31',NULL,NULL),(69325,'83520','S','Ahsahka','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.577730,-116.251715,0,'2013-07-06 12:44:34',NULL,NULL),(62824,'74959','S','Spiro','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.243226,-94.611070,0,'2013-07-06 12:44:33',NULL,NULL),(60260,'71446','S','Hawthorne','N','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(18208,'18949','P','Plumsteadvlle','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.378478,-75.145192,0,'2013-07-06 12:44:31',NULL,NULL),(50466,'58036','S','Harwood','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.108096,-97.007998,0,'2013-07-06 12:44:33',NULL,NULL),(12891,'13332','S','Lebanon','A','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(12729,'13159','S','Vesper','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.808860,-76.143600,0,'2013-07-06 12:44:30',NULL,NULL),(24873,'27690','U','Raleigh Brm','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.834281,-78.666486,0,'2013-07-06 12:44:31',NULL,NULL),(60006,'71334','S','Dunbarton','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(75857,'94939','S','Larkspur','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.937810,-122.537195,0,'2013-07-06 12:44:34',NULL,NULL),(57645,'67159','S','Zenda','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.428640,-98.299926,0,'2013-07-06 12:44:33',NULL,NULL),(66467,'78657','S','Cottonwood Shores','A','Llano','48299','Texas','TX','48','0000','830','Central',-6.0,'Y',30.579706,-98.271069,0,'2013-07-06 12:44:34',NULL,NULL),(59356,'70571','P','Opelousas','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.534539,-92.080148,0,'2013-07-06 12:44:33',NULL,NULL),(19075,'19559','P','Upper Tulpehocken','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.492216,-76.184763,0,'2013-07-06 12:44:31',NULL,NULL),(44784,'50218','S','Patterson','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.374206,-93.874199,0,'2013-07-06 12:44:32',NULL,NULL),(41761,'47302','S','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(62341,'74056','S','Bowring','A','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.823412,-96.367170,0,'2013-07-06 12:44:33',NULL,NULL),(65844,'78161','S','Sutherlnd Spg','A','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.263031,-98.067520,0,'2013-07-06 12:44:34',NULL,NULL),(49121,'56357','S','Oak Park','D','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.664722,-93.909444,0,'2013-07-06 12:44:33',NULL,NULL),(77605,'96941','P','Ponape','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',6.890254,158.209053,0,'2013-07-06 12:44:34',NULL,NULL),(76700,'95829','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.483542,-121.351992,0,'2013-07-06 12:44:34',NULL,NULL),(70992,'85711','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.218469,-110.887678,0,'2013-07-06 12:44:34',NULL,NULL),(48121,'55357','S','Greenfield','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.100321,-93.661093,0,'2013-07-06 12:44:33',NULL,NULL),(2599,'00961','S','Urb Rio Hondo 1','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(54948,'63117','S','Clayton','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.628611,-90.319444,0,'2013-07-06 12:44:33',NULL,NULL),(7275,'06525','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.360503,-73.012777,0,'2013-07-06 12:44:30',NULL,NULL),(28187,'31012','S','Chester','D','Dodge','13091','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.324564,-83.165882,0,'2013-07-06 12:44:31',NULL,NULL),(26043,'28684','S','Todd','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.311400,-81.579000,0,'2013-07-06 12:44:31',NULL,NULL),(63206,'75441','P','Enloe','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.399031,-95.589198,0,'2013-07-06 12:44:33',NULL,NULL),(65327,'77515','S','Holiday Lakes','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(76264,'95416','P','Boyes Hot Springs','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.312407,-122.482861,0,'2013-07-06 12:44:34',NULL,NULL),(79022,'98391','S','Lakeridge','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(51088,'58765','S','Noonan','D','Divide','38023','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.889940,-103.009980,0,'2013-07-06 12:44:33',NULL,NULL),(13730,'14098','S','Lyndonville','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.337372,-78.377353,0,'2013-07-06 12:44:31',NULL,NULL),(68646,'81640','S','Maybell','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.530669,-108.143210,0,'2013-07-06 12:44:34',NULL,NULL),(60726,'71957','S','Mount Ida','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.534979,-93.504073,0,'2013-07-06 12:44:33',NULL,NULL),(45471,'51250','S','Sioux Center','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.079162,-96.175074,0,'2013-07-06 12:44:32',NULL,NULL),(50068,'57445','S','James','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.451773,-98.101092,0,'2013-07-06 12:44:33',NULL,NULL),(50482,'58047','S','Wild Rice','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.717620,-96.856680,0,'2013-07-06 12:44:33',NULL,NULL),(36064,'40207','S','Rolling Field','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(47991,'55130','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944207,-93.005941,0,'2013-07-06 12:44:33',NULL,NULL),(14003,'14520','P','Ontario Ctr','A','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.227431,-77.306963,0,'2013-07-06 12:44:31',NULL,NULL),(44796,'50228','S','Prairie City','D','Jasper','19099','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.598594,-93.236114,0,'2013-07-06 12:44:32',NULL,NULL),(41982,'47421','S','Leesville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(79075,'98433','S','Ft Lewis','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(76309,'95446','S','Guernewood','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.494075,-122.982674,0,'2013-07-06 12:44:34',NULL,NULL),(77899,'97298','P','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.501951,-122.773041,0,'2013-07-06 12:44:34',NULL,NULL),(23626,'25722','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.425562,-82.442578,0,'2013-07-06 12:44:31',NULL,NULL),(33701,'37762','S','Jellico','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.578238,-84.127269,0,'2013-07-06 12:44:32',NULL,NULL),(13516,'13812','S','Lounsberry','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.042960,-76.358700,0,'2013-07-06 12:44:31',NULL,NULL),(7290,'06536','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.317391,-72.926719,0,'2013-07-06 12:44:30',NULL,NULL),(58609,'68854','S','Marquette','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.005970,-98.008746,0,'2013-07-06 12:44:33',NULL,NULL),(22835,'24517','S','Altavista','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.123130,-79.289743,0,'2013-07-06 12:44:31',NULL,NULL),(48531,'55749','S','Wrenshall','A','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.472378,-92.392209,0,'2013-07-06 12:44:33',NULL,NULL),(40690,'46070','S','Summitville','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.340908,-85.662129,0,'2013-07-06 12:44:32',NULL,NULL),(18763,'19352','S','New Londn Twp','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.769645,-75.890630,0,'2013-07-06 12:44:31',NULL,NULL),(42410,'47802','S','Holly Hills','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(47121,'54451','S','Medford','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(58108,'68118','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.263933,-96.177075,0,'2013-07-06 12:44:33',NULL,NULL),(21134,'22102','S','West McLean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(17117,'17772','S','Comly','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.100974,-76.773819,0,'2013-07-06 12:44:31',NULL,NULL),(14106,'14626','S','Greece','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.209740,-77.703726,0,'2013-07-06 12:44:31',NULL,NULL),(71603,'87325','S','Naschitti','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.862100,-108.762199,0,'2013-07-06 12:44:34',NULL,NULL),(74340,'92407','S','Arrowhead Farms','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(74930,'93405','S','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.278280,-120.692170,0,'2013-07-06 12:44:34',NULL,NULL),(73077,'90202','P','Bell Gardens','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.969924,-118.152353,0,'2013-07-06 12:44:34',NULL,NULL),(65895,'78233','S','Live Oak','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.565000,-98.336111,0,'2013-07-06 12:44:34',NULL,NULL),(23028,'24844','S','Steeles','N','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.438200,-81.810900,0,'2013-07-06 12:44:31',NULL,NULL),(14297,'14878','S','Rock Stream','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.469548,-76.930728,0,'2013-07-06 12:44:31',NULL,NULL),(39374,'44643','S','Magnolia','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.667895,-81.306958,0,'2013-07-06 12:44:32',NULL,NULL),(54164,'62611','S','Arenzville','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.876706,-90.369361,0,'2013-07-06 12:44:33',NULL,NULL),(57767,'67455','S','Westfall','A','Lincoln','20105','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.035880,-98.144640,0,'2013-07-06 12:44:33',NULL,NULL),(58031,'68007','S','Bennington','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.354344,-96.169168,0,'2013-07-06 12:44:33',NULL,NULL),(18768,'19354','P','Lyndell','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.059910,-75.751833,0,'2013-07-06 12:44:31',NULL,NULL),(22693,'24323','S','Crockett','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.875940,-81.209706,0,'2013-07-06 12:44:31',NULL,NULL),(10024,'10171','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(75713,'94578','S','San Leandro','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.702893,-122.123888,0,'2013-07-06 12:44:34',NULL,NULL),(67319,'80027','S','Louisville','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.966420,-105.154200,0,'2013-07-06 12:44:34',NULL,NULL),(1609,'00769','S','Urb Provincias Del Rio 2','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(23764,'25966','P','Green Sulphur Springs','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.796066,-80.830326,0,'2013-07-06 12:44:31',NULL,NULL),(4308,'02910','S','Cranston','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.777181,-71.436666,0,'2013-07-06 12:44:30',NULL,NULL),(51552,'59740','P','Mc Allister','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.448495,-111.784925,0,'2013-07-06 12:44:33',NULL,NULL),(23935,'26259','P','Dailey','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.799780,-79.894427,0,'2013-07-06 12:44:31',NULL,NULL),(12645,'13110','S','Marietta','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.888966,-76.283957,0,'2013-07-06 12:44:30',NULL,NULL),(23693,'25860','P','Lanark','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.827028,-81.146530,0,'2013-07-06 12:44:31',NULL,NULL),(60601,'71845','S','Lewisville','D','Lafayette','05073','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.360581,-93.579901,0,'2013-07-06 12:44:33',NULL,NULL),(51621,'59843','S','Helmville','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.879100,-112.992491,0,'2013-07-06 12:44:33',NULL,NULL),(66906,'79311','S','Abernathy','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',33.925509,-101.911126,0,'2013-07-06 12:44:34',NULL,NULL),(60677,'71923','S','Joan','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(46929,'54155','S','Hobart','A','Brown','55009','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.532148,-88.162973,0,'2013-07-06 12:44:32',NULL,NULL),(29945,'33070','S','Plantation Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.000353,-80.537936,0,'2013-07-06 12:44:32',NULL,NULL),(44101,'49501','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.964920,-85.658539,0,'2013-07-06 12:44:32',NULL,NULL),(15820,'16932','S','Sullivan','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.785028,-76.962034,0,'2013-07-06 12:44:31',NULL,NULL),(354,'00659','S','Alt de Hatillo','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(78522,'98124','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.577224,-122.333540,0,'2013-07-06 12:44:34',NULL,NULL),(74522,'92652','P','Laguna Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.543004,-117.781451,0,'2013-07-06 12:44:34',NULL,NULL),(74372,'92502','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.976846,-117.369982,0,'2013-07-06 12:44:34',NULL,NULL),(68217,'81050','S','Bents Fort','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(66822,'79092','S','Vega','D','Oldham','48359','Texas','TX','48','0000','806','Central',-6.0,'Y',35.244444,-102.426615,0,'2013-07-06 12:44:34',NULL,NULL),(43110,'48222','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.273318,-83.132151,0,'2013-07-06 12:44:32',NULL,NULL),(26096,'28715','S','Biltmore Lake','A','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.536698,-82.680987,0,'2013-07-06 12:44:31',NULL,NULL),(59449,'70726','S','Denham Springs','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.495187,-90.921746,0,'2013-07-06 12:44:33',NULL,NULL),(54444,'62844','S','Grayville','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.235615,-88.015319,0,'2013-07-06 12:44:33',NULL,NULL),(10881,'11420','S','S Ozone Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674361,-73.813156,0,'2013-07-06 12:44:30',NULL,NULL),(1111,'00725','S','Urb Santa America','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(47683,'54961','S','Royalton','A','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.385363,-88.748158,0,'2013-07-06 12:44:33',NULL,NULL),(79954,'99632','P','Mountain Village','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.087996,-163.717879,0,'2013-07-06 12:44:34',NULL,NULL),(58903,'69212','S','Crookston','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.899594,-100.794946,0,'2013-07-06 12:44:33',NULL,NULL),(71525,'87122','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.181446,-106.489076,0,'2013-07-06 12:44:34',NULL,NULL),(62167,'73739','S','Goltry','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.538739,-98.160146,0,'2013-07-06 12:44:33',NULL,NULL),(41345,'46787','S','Tunker','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.085770,-85.618016,0,'2013-07-06 12:44:32',NULL,NULL),(34465,'38663','S','Campbell','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(790,'00693','S','Ciudad Real','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(37027,'41250','S','Laura','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.707500,-82.432778,0,'2013-07-06 12:44:32',NULL,NULL),(17604,'18041','S','E Greenville','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.415749,-75.510509,0,'2013-07-06 12:44:31',NULL,NULL),(43338,'48374','S','Novi','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.470836,-83.523535,0,'2013-07-06 12:44:32',NULL,NULL),(14056,'14572','S','Wayland','D','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.541439,-77.588869,0,'2013-07-06 12:44:31',NULL,NULL),(16212,'17072','P','New Kingstown','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.269810,-76.984102,0,'2013-07-06 12:44:31',NULL,NULL),(68654,'81645','P','Gilman','A','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.570257,-106.418899,0,'2013-07-06 12:44:34',NULL,NULL),(53461,'61920','S','Charleston','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.604167,-88.101667,0,'2013-07-06 12:44:33',NULL,NULL),(10796,'11371','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.775842,-73.874904,0,'2013-07-06 12:44:30',NULL,NULL),(27486,'30156','P','Kennesaw','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.024810,-84.612261,0,'2013-07-06 12:44:31',NULL,NULL),(44568,'50022','S','Lorah','N','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.400014,-95.009466,0,'2013-07-06 12:44:32',NULL,NULL),(36152,'40241','S','Hickory Hill','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(9320,'09732','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(34186,'38324','P','Clarksburg','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.862842,-88.379326,0,'2013-07-06 12:44:32',NULL,NULL),(80195,'99921','P','Craig','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.474111,-133.144582,0,'2013-07-06 12:44:34',NULL,NULL),(39512,'44813','S','Bellville','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.610016,-82.517930,0,'2013-07-06 12:44:32',NULL,NULL),(3904,'02453','S','Waltham','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.369917,-71.236818,0,'2013-07-06 12:44:30',NULL,NULL),(47438,'54722','S','Augusta','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.686753,-91.128347,0,'2013-07-06 12:44:32',NULL,NULL),(25192,'28070','P','Huntersville','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.416797,-80.842491,0,'2013-07-06 12:44:31',NULL,NULL),(70307,'84601','S','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.221703,-111.692438,0,'2013-07-06 12:44:34',NULL,NULL),(33360,'37188','S','White House','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.484055,-86.687263,0,'2013-07-06 12:44:32',NULL,NULL),(73843,'91790','S','West Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065225,-117.938282,0,'2013-07-06 12:44:34',NULL,NULL),(20570,'21144','S','Severn','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.131280,-76.689880,0,'2013-07-06 12:44:31',NULL,NULL),(48522,'55746','S','North Hibbing','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(55067,'63167','U','Monsanto','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.660153,-90.455607,0,'2013-07-06 12:44:33',NULL,NULL),(13014,'13421','S','Kenwood','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.064220,-75.648180,0,'2013-07-06 12:44:30',NULL,NULL),(31573,'34639','S','Land O Lakes','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.247163,-82.498330,0,'2013-07-06 12:44:32',NULL,NULL),(57472,'66864','S','Neosho Rapids','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.397821,-96.025281,0,'2013-07-06 12:44:33',NULL,NULL),(14725,'15281','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.440025,-79.998650,0,'2013-07-06 12:44:31',NULL,NULL),(53908,'62367','S','Colmar','A','Hancock','17067','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.290180,-90.893760,0,'2013-07-06 12:44:33',NULL,NULL),(45485,'51347','S','Lake Park','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.448381,-95.331102,0,'2013-07-06 12:44:32',NULL,NULL),(7822,'07457','S','Pompton Junction','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.992890,-74.311301,0,'2013-07-06 12:44:30',NULL,NULL),(27164,'29835','S','Willington','N','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.911159,-82.290467,0,'2013-07-06 12:44:31',NULL,NULL),(24066,'26431','S','Saltwell','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(68579,'81506','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.105108,-108.548046,0,'2013-07-06 12:44:34',NULL,NULL),(27074,'29696','S','West Union','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.772475,-83.047952,0,'2013-07-06 12:44:31',NULL,NULL),(23658,'25818','P','Bradley','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.860258,-81.198448,0,'2013-07-06 12:44:31',NULL,NULL),(19140,'19611','S','West Reading','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324211,-75.944403,0,'2013-07-06 12:44:31',NULL,NULL),(27316,'30024','S','Suwanee','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.062747,-84.083283,0,'2013-07-06 12:44:31',NULL,NULL),(28295,'31098','S','Robins Air Force Base','N','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.611973,-83.596726,0,'2013-07-06 12:44:31',NULL,NULL),(28647,'31765','S','Meigs','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.060680,-84.079500,0,'2013-07-06 12:44:32',NULL,NULL),(55047,'63144','S','Brentwood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616418,-90.349634,0,'2013-07-06 12:44:33',NULL,NULL),(43140,'48236','S','Grosse Pointe Woods','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(60095,'71360','S','Esler','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(68317,'81120','S','Antonito','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(79196,'98532','S','Dryad','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(69938,'84115','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(17016,'17740','S','Salladasburg','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(27935,'30525','S','Clayton','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.863738,-83.398704,0,'2013-07-06 12:44:31',NULL,NULL),(3742,'02169','S','Quincy Center','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.240464,-71.014144,0,'2013-07-06 12:44:30',NULL,NULL),(33699,'37760','S','Jefferson City','D','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.119161,-83.493766,0,'2013-07-06 12:44:32',NULL,NULL),(31102,'33882','P','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.003388,-81.671983,0,'2013-07-06 12:44:32',NULL,NULL),(15073,'15742','S','Glen Campbell','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.858839,-78.856834,0,'2013-07-06 12:44:31',NULL,NULL),(29081,'32258','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.139567,-81.544736,0,'2013-07-06 12:44:32',NULL,NULL),(5463,'04736','S','Caribou','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.847780,-68.010473,0,'2013-07-06 12:44:30',NULL,NULL),(72441,'89087','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.283100,-115.135100,0,'2013-07-06 12:44:34',NULL,NULL),(43833,'49090','S','South Haven','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.386974,-86.258209,0,'2013-07-06 12:44:32',NULL,NULL),(17478,'17953','P','Middleport','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.727354,-76.086539,0,'2013-07-06 12:44:31',NULL,NULL),(54236,'62664','S','Mason City','D','Mason','17125','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.200803,-89.695417,0,'2013-07-06 12:44:33',NULL,NULL),(56173,'64999','U','K C','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.953479,-94.549666,0,'2013-07-06 12:44:33',NULL,NULL),(57993,'67855','S','Big Bow','N','Stanton','20187','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.571880,-101.714760,0,'2013-07-06 12:44:33',NULL,NULL),(35180,'39282','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.254854,-90.248918,0,'2013-07-06 12:44:32',NULL,NULL),(28983,'32212','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(22560,'24146','P','Redwood','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.007922,-79.770253,0,'2013-07-06 12:44:31',NULL,NULL),(49917,'57315','S','Avon','D','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.007771,-98.056898,0,'2013-07-06 12:44:33',NULL,NULL),(68321,'81120','S','La Isla','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(63365,'75640','S','New Diana','A','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.699271,-94.668973,0,'2013-07-06 12:44:33',NULL,NULL),(48338,'55472','U','Abmps','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.980177,-93.268143,0,'2013-07-06 12:44:33',NULL,NULL),(74239,'92325','P','Valley of Enchantment','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.241417,-117.277125,0,'2013-07-06 12:44:34',NULL,NULL),(4262,'02881','S','Kingston','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.481802,-71.525113,0,'2013-07-06 12:44:30',NULL,NULL),(49788,'57106','S','Shindler','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.517030,-96.789603,0,'2013-07-06 12:44:33',NULL,NULL),(29983,'33097','P','Coconut Creek','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.235803,-80.133635,0,'2013-07-06 12:44:32',NULL,NULL),(12347,'12883','S','Eagle Lake','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.843857,-73.431459,0,'2013-07-06 12:44:30',NULL,NULL),(55042,'63140','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.737643,-90.323138,0,'2013-07-06 12:44:33',NULL,NULL),(42538,'47863','P','New Goshen','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.512211,-87.476732,0,'2013-07-06 12:44:32',NULL,NULL),(47803,'55051','S','Warman','N','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.915556,-93.173056,0,'2013-07-06 12:44:33',NULL,NULL),(10248,'10469','S','Hillside','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868747,-73.849303,0,'2013-07-06 12:44:30',NULL,NULL),(61907,'73145','S','Midwest City','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.415801,-97.392307,0,'2013-07-06 12:44:33',NULL,NULL),(13419,'13755','S','Corbett','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.067456,-75.036591,0,'2013-07-06 12:44:31',NULL,NULL),(57107,'66221','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(47262,'54527','S','Glidden','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.135765,-90.576088,0,'2013-07-06 12:44:32',NULL,NULL),(23927,'26237','S','Tallmansville','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.832413,-80.159421,0,'2013-07-06 12:44:31',NULL,NULL),(18767,'19353','P','Lionville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.053600,-75.660180,0,'2013-07-06 12:44:31',NULL,NULL),(55440,'63670','S','Zell','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(67064,'79566','S','Happy Valley','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',32.017027,-100.147498,0,'2013-07-06 12:44:34',NULL,NULL),(71330,'86507','P','Chinle','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.432600,-109.238820,0,'2013-07-06 12:44:34',NULL,NULL),(67616,'80435','S','Montezuma','A','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.618708,-106.041714,0,'2013-07-06 12:44:34',NULL,NULL),(31123,'33902','P','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.604733,-81.863805,0,'2013-07-06 12:44:32',NULL,NULL),(49061,'56308','S','Alexandria','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.892797,-95.365967,0,'2013-07-06 12:44:33',NULL,NULL),(5387,'04645','P','Stonington','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.075278,-68.633889,0,'2013-07-06 12:44:30',NULL,NULL),(5555,'04853','S','North Haven','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.155875,-68.865697,0,'2013-07-06 12:44:30',NULL,NULL),(15443,'16401','S','Lundys Lane','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(14958,'15619','P','Bovard','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.318301,-79.504647,0,'2013-07-06 12:44:31',NULL,NULL),(16825,'17552','S','Donegal Heights','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(77159,'96207','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(67074,'79601','S','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.479020,-99.700020,0,'2013-07-06 12:44:34',NULL,NULL),(38230,'43229','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.083167,-82.975693,0,'2013-07-06 12:44:32',NULL,NULL),(42054,'47448','S','Annandale Estates','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(51195,'59030','S','Gardiner','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.031682,-110.705747,0,'2013-07-06 12:44:33',NULL,NULL),(53119,'61545','S','Cazenovia','A','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.850278,-89.331944,0,'2013-07-06 12:44:33',NULL,NULL),(58559,'68824','S','Cairo','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.999381,-98.612998,0,'2013-07-06 12:44:33',NULL,NULL),(38475,'43652','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.650967,-83.536485,0,'2013-07-06 12:44:32',NULL,NULL),(27017,'29645','S','Gray Court','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.595760,-82.143840,0,'2013-07-06 12:44:31',NULL,NULL),(28348,'31196','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.807894,-84.474929,0,'2013-07-06 12:44:32',NULL,NULL),(79100,'98446','S','Parkland','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.149046,-122.377224,0,'2013-07-06 12:44:34',NULL,NULL),(26009,'28676','S','Kapps Mill','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.396418,-80.892260,0,'2013-07-06 12:44:31',NULL,NULL),(28668,'31790','S','Sycamore','D','Turner','13287','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.655399,-83.592030,0,'2013-07-06 12:44:32',NULL,NULL),(51355,'59332','S','Hammond','D','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.369487,-104.653365,0,'2013-07-06 12:44:33',NULL,NULL),(30106,'33160','S','Aventura','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(49254,'56474','S','Woodrow','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(5593,'04921','S','Brooks','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.519428,-69.099703,0,'2013-07-06 12:44:30',NULL,NULL),(32725,'36311','S','Ariton','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.600782,-85.721325,0,'2013-07-06 12:44:32',NULL,NULL),(10639,'11055','U','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.840893,-73.704913,0,'2013-07-06 12:44:30',NULL,NULL),(42245,'47574','S','Rome','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.947643,-86.588212,0,'2013-07-06 12:44:32',NULL,NULL),(63567,'75771','S','Hideaway','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(54507,'62869','S','Gossett','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.977903,-88.328317,0,'2013-07-06 12:44:33',NULL,NULL),(74026,'92132','U','Naval Supply Ctr','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.719559,-117.166765,0,'2013-07-06 12:44:34',NULL,NULL),(72639,'89424','P','Nixon','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.840656,-119.364727,0,'2013-07-06 12:44:34',NULL,NULL),(66070,'78383','S','Pernitas Point','N','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',28.089420,-97.942200,0,'2013-07-06 12:44:34',NULL,NULL),(64663,'76803','P','Brownwood','A','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.717112,-98.976776,0,'2013-07-06 12:44:34',NULL,NULL),(39541,'44838','P','Hayesville','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.772620,-82.259036,0,'2013-07-06 12:44:32',NULL,NULL),(20197,'20753','P','District Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.858256,-76.887275,0,'2013-07-06 12:44:31',NULL,NULL),(52847,'61322','P','De Pue','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.325484,-89.303078,0,'2013-07-06 12:44:33',NULL,NULL),(43908,'49253','S','Manitou Beach','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.974048,-84.276829,0,'2013-07-06 12:44:32',NULL,NULL),(41923,'47382','P','Saratoga','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.236088,-84.922295,0,'2013-07-06 12:44:32',NULL,NULL),(25169,'28040','S','Ellenboro','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.400480,-81.757380,0,'2013-07-06 12:44:31',NULL,NULL),(40426,'45698','P','Zaleski','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.282937,-82.393240,0,'2013-07-06 12:44:32',NULL,NULL),(43832,'49089','S','Sherwood','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.009295,-85.228710,0,'2013-07-06 12:44:32',NULL,NULL),(37794,'42371','S','Rumsey','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.506347,-87.285270,0,'2013-07-06 12:44:32',NULL,NULL),(56074,'64756','S','Jerico Spgs','N','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.669139,-94.008138,0,'2013-07-06 12:44:33',NULL,NULL),(72713,'89450','P','Incline Village','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.256452,-119.955498,0,'2013-07-06 12:44:34',NULL,NULL),(41026,'46383','S','Valparaiso','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.489214,-87.074602,0,'2013-07-06 12:44:32',NULL,NULL),(17593,'18035','S','Cherryville','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.752413,-75.541641,0,'2013-07-06 12:44:31',NULL,NULL),(32964,'36601','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.697450,-88.049878,0,'2013-07-06 12:44:32',NULL,NULL),(20052,'20659','S','Mechanicsvlle','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.438361,-76.723614,0,'2013-07-06 12:44:31',NULL,NULL),(1835,'00784','S','Urb Rexmanor','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(2440,'00953','S','Urb Palacios de Marbella','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(48241,'55422','S','Golden Valley','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.008220,-93.339300,0,'2013-07-06 12:44:33',NULL,NULL),(27732,'30350','S','Dunwoody','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975825,-84.325274,0,'2013-07-06 12:44:31',NULL,NULL),(1391,'00738','S','Qtas de Fajardo','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(6423,'05742','S','Bowlsville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.433994,-72.877559,0,'2013-07-06 12:44:30',NULL,NULL),(19937,'20570','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897985,-77.041530,0,'2013-07-06 12:44:31',NULL,NULL),(68826,'82501','S','Sand Draw','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(14564,'15215','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.503780,-79.912020,0,'2013-07-06 12:44:31',NULL,NULL),(5985,'05346','S','Westminster West','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.955143,-72.565046,0,'2013-07-06 12:44:30',NULL,NULL),(55189,'63378','P','Treloar','D','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.641449,-91.187134,0,'2013-07-06 12:44:33',NULL,NULL),(12132,'12721','S','Bloomingburg','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.551493,-74.452492,0,'2013-07-06 12:44:30',NULL,NULL),(51097,'58773','S','Powers Lk','N','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.618780,-102.624000,0,'2013-07-06 12:44:33',NULL,NULL),(39681,'45015','S','Princeton','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.367572,-84.550446,0,'2013-07-06 12:44:32',NULL,NULL),(68737,'82210','S','Chugwater','D','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.728605,-104.847774,0,'2013-07-06 12:44:34',NULL,NULL),(70594,'85087','S','New River','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.915238,-112.136717,0,'2013-07-06 12:44:34',NULL,NULL),(70977,'85704','S','Oro Valley','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.328180,-110.986080,0,'2013-07-06 12:44:34',NULL,NULL),(79721,'99214','P','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.711392,-117.206773,0,'2013-07-06 12:44:34',NULL,NULL),(78348,'98007','S','Eastgate','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.612028,-122.141410,0,'2013-07-06 12:44:34',NULL,NULL),(7034,'06268','S','Storrs Manfld','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(9046,'08885','P','Stanton','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.574268,-74.838178,0,'2013-07-06 12:44:30',NULL,NULL),(26878,'29554','S','Hemingway','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.739020,-79.447920,0,'2013-07-06 12:44:31',NULL,NULL),(10996,'11550','S','S Hempstead','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.708785,-73.624573,0,'2013-07-06 12:44:30',NULL,NULL),(66397,'78628','S','Andice','A','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.665203,-97.707564,0,'2013-07-06 12:44:34',NULL,NULL),(76570,'95671','U','Represa','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.676709,-121.147373,0,'2013-07-06 12:44:34',NULL,NULL),(54223,'62650','S','Pisgah','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(29448,'32703','S','Apopka','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.662448,-81.501094,0,'2013-07-06 12:44:32',NULL,NULL),(54428,'62837','S','Grover','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(34500,'38670','S','Falcon','A','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.429607,-90.218388,0,'2013-07-06 12:44:32',NULL,NULL),(33280,'37111','P','Mc Minnvle','N','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.687754,-85.775514,0,'2013-07-06 12:44:32',NULL,NULL),(32570,'36116','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.311900,-86.237923,0,'2013-07-06 12:44:32',NULL,NULL),(1933,'00795','S','Urb Los Reyes','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(42682,'47978','S','Collegeville','A','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.939522,-87.153854,0,'2013-07-06 12:44:32',NULL,NULL),(59270,'70456','S','Arcola','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.765787,-90.512420,0,'2013-07-06 12:44:33',NULL,NULL),(36984,'41189','S','Epworth','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.586965,-83.548106,0,'2013-07-06 12:44:32',NULL,NULL),(25703,'28533','S','MCAS Cherry Point','N','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.878889,-76.901667,0,'2013-07-06 12:44:31',NULL,NULL),(55164,'63367','S','Lake St Louis','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.793015,-90.782477,0,'2013-07-06 12:44:33',NULL,NULL),(669,'00683','S','Urb El Pedregal','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(51159,'58854','S','Watford Cty','N','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.802475,-103.279579,0,'2013-07-06 12:44:33',NULL,NULL),(51045,'58734','S','Aurelia','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.475200,-101.904180,0,'2013-07-06 12:44:33',NULL,NULL),(64770,'76955','S','Vancourt','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.223551,-100.208379,0,'2013-07-06 12:44:34',NULL,NULL),(51522,'59711','S','Anaconda','D','Deer Lodge','30023','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.139820,-113.045940,0,'2013-07-06 12:44:33',NULL,NULL),(42122,'47471','S','Point Commerce','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.118499,-86.979363,0,'2013-07-06 12:44:32',NULL,NULL),(39816,'45144','S','Bradyville','N','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.702000,-83.612593,0,'2013-07-06 12:44:32',NULL,NULL),(19284,'19970','S','Clarksville','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.555449,-75.108954,0,'2013-07-06 12:44:31',NULL,NULL),(60132,'71373','S','Bougere','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(55529,'63827','S','Bragg City','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.267636,-89.913435,0,'2013-07-06 12:44:33',NULL,NULL),(72883,'90013','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.046676,-118.241961,0,'2013-07-06 12:44:34',NULL,NULL),(71028,'85736','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.663202,-111.392856,0,'2013-07-06 12:44:34',NULL,NULL),(67215,'79918','S','Ft Bliss','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.847479,-106.378199,0,'2013-07-06 12:44:34',NULL,NULL),(76552,'95667','S','Bucks Bar','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(73149,'90280','S','South Gate','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.941262,-118.193702,0,'2013-07-06 12:44:34',NULL,NULL),(14092,'14618','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.119768,-77.556663,0,'2013-07-06 12:44:31',NULL,NULL),(15727,'16878','S','West Decatur','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.948226,-78.360410,0,'2013-07-06 12:44:31',NULL,NULL),(38833,'44085','S','New Lyme','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(8046,'07734','S','W Keansburg','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.439051,-74.125510,0,'2013-07-06 12:44:30',NULL,NULL),(53471,'61932','S','Hume','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.795616,-87.867417,0,'2013-07-06 12:44:33',NULL,NULL),(51719,'60010','S','Lake Barrington Shores','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(45204,'50627','S','Eldora','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.366323,-93.095322,0,'2013-07-06 12:44:32',NULL,NULL),(26957,'29607','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.829648,-82.340068,0,'2013-07-06 12:44:31',NULL,NULL),(25019,'27886','S','Leggett','A','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.898660,-77.558220,0,'2013-07-06 12:44:31',NULL,NULL),(13846,'14224','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.841518,-78.761265,0,'2013-07-06 12:44:31',NULL,NULL),(38814,'44073','U','Materials Park','N','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.466851,-81.339894,0,'2013-07-06 12:44:32',NULL,NULL),(65197,'77429','S','Cypress','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.991106,-95.669038,0,'2013-07-06 12:44:34',NULL,NULL),(79068,'98431','U','Joint Base Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(29382,'32610','U','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.642276,-82.344949,0,'2013-07-06 12:44:32',NULL,NULL),(74784,'93117','S','Santa Barbara','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.437147,-119.866076,0,'2013-07-06 12:44:34',NULL,NULL),(66905,'79261','S','Turkey','D','Hall','48191','Texas','TX','48','0000','806','Central',-6.0,'Y',34.396166,-100.893325,0,'2013-07-06 12:44:34',NULL,NULL),(64583,'76667','S','Shiloh','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(43603,'48766','S','Twining','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.119328,-83.853012,0,'2013-07-06 12:44:32',NULL,NULL),(11158,'11720','S','South Setauket','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.871518,-73.084611,0,'2013-07-06 12:44:30',NULL,NULL),(41815,'47335','P','Dublin','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.812592,-85.208670,0,'2013-07-06 12:44:32',NULL,NULL),(38689,'43983','S','Piedmont','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.141278,-81.191640,0,'2013-07-06 12:44:32',NULL,NULL),(51650,'59873','S','Snider','N','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.621869,-115.341150,0,'2013-07-06 12:44:33',NULL,NULL),(76540,'95659','S','Verona','N','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.870336,-121.567175,0,'2013-07-06 12:44:34',NULL,NULL),(70151,'84311','S','Fielding','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.812797,-112.121505,0,'2013-07-06 12:44:34',NULL,NULL),(42581,'47879','S','Wilfred','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(8622,'08251','S','Del Haven','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.023220,-74.931300,0,'2013-07-06 12:44:30',NULL,NULL),(51485,'59604','P','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.615752,-111.963247,0,'2013-07-06 12:44:33',NULL,NULL),(32212,'35563','S','Guin','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.966394,-87.895475,0,'2013-07-06 12:44:32',NULL,NULL),(10285,'10517','P','Crompond','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.295589,-73.861835,0,'2013-07-06 12:44:30',NULL,NULL),(24395,'27105','S','Sedges Garden','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.150762,-80.234242,0,'2013-07-06 12:44:31',NULL,NULL),(18899,'19473','S','Neiffer','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.237680,-75.481440,0,'2013-07-06 12:44:31',NULL,NULL),(15317,'16159','S','West Middlesex','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.184971,-80.454618,0,'2013-07-06 12:44:31',NULL,NULL),(111,'00612','S','Urb Radioville','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(78461,'98071','P','Auburn','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.248768,-122.116851,0,'2013-07-06 12:44:34',NULL,NULL),(23782,'25981','S','Quinwood','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.055556,-80.691389,0,'2013-07-06 12:44:31',NULL,NULL),(21387,'22503','S','Alfonso','A','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.763511,-76.498306,0,'2013-07-06 12:44:31',NULL,NULL),(36345,'40419','S','Crab Orchard','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.440601,-84.519795,0,'2013-07-06 12:44:32',NULL,NULL),(8537,'08201','S','Absecon City','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(44273,'49707','S','Alpena','D','Alpena','26007','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.075555,-83.478059,0,'2013-07-06 12:44:32',NULL,NULL),(43965,'49315','S','Byron Township','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.805357,-85.703821,0,'2013-07-06 12:44:32',NULL,NULL),(37867,'42541','S','Middleburg','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.372342,-84.837752,0,'2013-07-06 12:44:32',NULL,NULL),(44505,'49930','S','Ripley','N','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.144700,-88.526760,0,'2013-07-06 12:44:32',NULL,NULL),(42439,'47805','S','Grouseland','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(68319,'81120','S','Florida','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(75607,'94309','P','Stanford','A','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.416667,-122.166667,0,'2013-07-06 12:44:34',NULL,NULL),(2464,'00956','S','Bosque De Los Pinos','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(65432,'77583','S','Sandy Point','N','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.408146,-95.441666,0,'2013-07-06 12:44:34',NULL,NULL),(60212,'71422','S','Gansville','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.066880,-92.645400,0,'2013-07-06 12:44:33',NULL,NULL),(15732,'16901','S','Asaph','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(47870,'55082','S','W Lakeland','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(11689,'12155','S','Schenevus','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597180,-74.818920,0,'2013-07-06 12:44:30',NULL,NULL),(43636,'48830','P','Elm Hall','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.362598,-84.834064,0,'2013-07-06 12:44:32',NULL,NULL),(27949,'30540','S','East Ellijay','A','Gilmer','13123','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.685591,-84.485193,0,'2013-07-06 12:44:31',NULL,NULL),(38368,'43463','P','Stony Ridge','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.509770,-83.508757,0,'2013-07-06 12:44:32',NULL,NULL),(40479,'45772','S','Reedsville','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.133099,-81.817021,0,'2013-07-06 12:44:32',NULL,NULL),(51334,'59274','S','Vida','D','McCone','30055','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.844345,-105.771091,0,'2013-07-06 12:44:33',NULL,NULL),(9578,'10027','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(30321,'33306','S','Wilton Manors','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163196,-80.110875,0,'2013-07-06 12:44:32',NULL,NULL),(66925,'79342','S','Loop','D','Gaines','48165','Texas','TX','48','0000','806','Central',-6.0,'Y',32.911530,-102.417870,0,'2013-07-06 12:44:34',NULL,NULL),(69978,'84120','S','West Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(23580,'25667','P','Chattaroy','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.705606,-82.267781,0,'2013-07-06 12:44:31',NULL,NULL),(16701,'17402','S','Pleasureville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(38146,'43142','P','Milledgeville','D','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.595174,-83.587871,0,'2013-07-06 12:44:32',NULL,NULL),(38910,'44118','S','South Euclid','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(19948,'20577','U','Inter American Dev Bank','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904360,-77.035413,0,'2013-07-06 12:44:31',NULL,NULL),(74337,'92405','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.141998,-117.299722,0,'2013-07-06 12:44:34',NULL,NULL),(31090,'33871','P','Sebring','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.503328,-81.453853,0,'2013-07-06 12:44:32',NULL,NULL),(31284,'34035','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(69258,'83428','S','Palisades','A','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.410639,-111.291199,0,'2013-07-06 12:44:34',NULL,NULL),(3473,'01822','P','Billerica','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.541274,-71.262879,0,'2013-07-06 12:44:30',NULL,NULL),(46363,'53114','S','Darien','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.601566,-88.704996,0,'2013-07-06 12:44:32',NULL,NULL),(46588,'53542','P','Hanover','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.632620,-89.165667,0,'2013-07-06 12:44:32',NULL,NULL),(3510,'01865','P','Nuttings Lake','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.534713,-71.269156,0,'2013-07-06 12:44:30',NULL,NULL),(9242,'09573','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(24706,'27498','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.072005,-79.767906,0,'2013-07-06 12:44:31',NULL,NULL),(23622,'25718','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.426697,-82.438558,0,'2013-07-06 12:44:31',NULL,NULL),(63375,'75644','S','Enoch','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(67044,'79547','S','Rolls','N','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.177322,-99.891093,0,'2013-07-06 12:44:34',NULL,NULL),(79880,'99572','S','Cooper Lndg','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.448658,-149.916942,0,'2013-07-06 12:44:34',NULL,NULL),(48673,'55920','S','Byron','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.032919,-92.649851,0,'2013-07-06 12:44:33',NULL,NULL),(12457,'12972','S','Harkness','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.570220,-73.547160,0,'2013-07-06 12:44:30',NULL,NULL),(63386,'75644','S','Perryville','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(42354,'47665','S','Owensville','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.274334,-87.691786,0,'2013-07-06 12:44:32',NULL,NULL),(53,'00610','S','Anasco','D','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(7142,'06409','S','Centerbrook','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.345940,-72.416515,0,'2013-07-06 12:44:30',NULL,NULL),(9472,'10009','S','Peter Stuyvesant','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(39898,'45215','S','Evendale','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(55408,'63648','S','Irondale','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.819577,-90.709864,0,'2013-07-06 12:44:33',NULL,NULL),(65365,'77535','S','Kenefick','N','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(13050,'13440','S','Fort Stanwix National Monume','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(19423,'20098','U','Vietnam Vet Mem Fund','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917054,-76.994641,0,'2013-07-06 12:44:31',NULL,NULL),(66866,'79201','S','Carey','N','Childress','48075','Texas','TX','48','0000','940','Central',-6.0,'Y',34.432500,-100.145820,0,'2013-07-06 12:44:34',NULL,NULL),(77391,'96769','P','Makaweli','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.950509,-159.670051,0,'2013-07-06 12:44:34',NULL,NULL),(67301,'80016','S','Foxfield','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.584457,-104.758155,0,'2013-07-06 12:44:34',NULL,NULL),(55933,'64473','S','New Point','A','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.993891,-95.139533,0,'2013-07-06 12:44:33',NULL,NULL),(11970,'12461','S','Olive','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.898780,-74.257380,0,'2013-07-06 12:44:30',NULL,NULL),(22819,'24501','S','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.399278,-79.174704,0,'2013-07-06 12:44:31',NULL,NULL),(11677,'12149','S','West Richmondville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.632159,-74.563960,0,'2013-07-06 12:44:30',NULL,NULL),(48840,'56054','S','Lafayette','D','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445577,-94.394643,0,'2013-07-06 12:44:33',NULL,NULL),(55714,'64072','P','Missouri City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.238267,-94.291412,0,'2013-07-06 12:44:33',NULL,NULL),(57540,'67022','S','Corbin','N','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.040523,-97.615566,0,'2013-07-06 12:44:33',NULL,NULL),(4270,'02885','S','Warren','D','Bristol','44001','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.721913,-71.265238,0,'2013-07-06 12:44:30',NULL,NULL),(27080,'29703','P','Bowling Green','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.145500,-81.223077,0,'2013-07-06 12:44:31',NULL,NULL),(77660,'97022','S','Eagle Creek','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.350882,-122.339245,0,'2013-07-06 12:44:34',NULL,NULL),(15149,'15861','S','Sinnamahoning','D','Cameron','42023','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.384232,-78.051775,0,'2013-07-06 12:44:31',NULL,NULL),(33986,'38115','S','Hickory Hill','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.045523,-89.849029,0,'2013-07-06 12:44:32',NULL,NULL),(23422,'25357','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.421675,-81.689725,0,'2013-07-06 12:44:31',NULL,NULL),(16261,'17087','S','Richland','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.360624,-76.264320,0,'2013-07-06 12:44:31',NULL,NULL),(19939,'20571','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900450,-77.032812,0,'2013-07-06 12:44:31',NULL,NULL),(57359,'66736','S','New Albany','A','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.535127,-95.823027,0,'2013-07-06 12:44:33',NULL,NULL),(63575,'75773','S','Mineola','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.646900,-95.516460,0,'2013-07-06 12:44:34',NULL,NULL),(73299,'90804','S','East Long Beach','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.776725,-118.146150,0,'2013-07-06 12:44:34',NULL,NULL),(5264,'04489','P','Stillwater','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.913220,-68.686039,0,'2013-07-06 12:44:30',NULL,NULL),(33492,'37350','S','Lookout Mountain','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',34.999753,-85.353348,0,'2013-07-06 12:44:32',NULL,NULL),(41847,'47352','S','Lewisville','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.804052,-85.355093,0,'2013-07-06 12:44:32',NULL,NULL),(35339,'39437','S','Johnson','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(43699,'48890','S','Sunfield','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.749009,-84.990678,0,'2013-07-06 12:44:32',NULL,NULL),(16723,'17406','S','Yorkana','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(68218,'81050','S','Bents Old Fort','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(16167,'17064','P','Mount Gretna','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.245217,-76.468668,0,'2013-07-06 12:44:31',NULL,NULL),(588,'00680','S','Lomas Verdes','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(7688,'07104','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.768591,-74.168632,0,'2013-07-06 12:44:30',NULL,NULL),(75590,'94294','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.556446,-121.494212,0,'2013-07-06 12:44:34',NULL,NULL),(72285,'88566','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767675,-106.330083,0,'2013-07-06 12:44:34',NULL,NULL),(12062,'12538','S','Hyde Park','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.782680,-73.891320,0,'2013-07-06 12:44:30',NULL,NULL),(11578,'12070','S','Fort Johnson','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.962988,-74.251122,0,'2013-07-06 12:44:30',NULL,NULL),(6129,'05460','P','Highgate Spgs','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.979819,-73.105448,0,'2013-07-06 12:44:30',NULL,NULL),(9717,'10080','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(56205,'65026','S','Bagnell','N','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(5479,'04743','S','St John Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.251669,-68.593437,0,'2013-07-06 12:44:30',NULL,NULL),(44351,'49777','S','Presque Isle','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.323506,-83.488814,0,'2013-07-06 12:44:32',NULL,NULL),(66027,'78362','S','Ingleside on the Bay','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.869269,-97.204245,0,'2013-07-06 12:44:34',NULL,NULL),(63840,'75974','S','Tenaha','D','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(14609,'15226','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.396692,-80.015390,0,'2013-07-06 12:44:31',NULL,NULL),(12187,'12771','S','Pt Jervis','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.373715,-74.665744,0,'2013-07-06 12:44:30',NULL,NULL),(44202,'49626','P','Eastlake','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.244523,-86.294677,0,'2013-07-06 12:44:32',NULL,NULL),(52047,'60195','S','Hoffman Estates','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.076320,-88.110120,0,'2013-07-06 12:44:33',NULL,NULL),(6647,'06018','S','Canaan','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.009780,-73.298160,0,'2013-07-06 12:44:30',NULL,NULL),(25931,'28655','S','Bridgewater','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(37381,'41746','S','Happy','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.202205,-83.096358,0,'2013-07-06 12:44:32',NULL,NULL),(134,'00616','S','Brisas Del Valle','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.426456,-66.673779,0,'2013-07-06 12:44:30',NULL,NULL),(72588,'89406','S','Middlegate','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(73907,'92011','S','La Costa','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.150800,-117.306000,0,'2013-07-06 12:44:34',NULL,NULL),(36988,'41201','S','Adams','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.001190,-82.716339,0,'2013-07-06 12:44:32',NULL,NULL),(12044,'12526','S','Cheviot','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.134040,-73.850340,0,'2013-07-06 12:44:30',NULL,NULL),(50341,'57737','S','Enning','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.530268,-102.590501,0,'2013-07-06 12:44:33',NULL,NULL),(38526,'43731','S','Crooksville','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.755520,-82.046940,0,'2013-07-06 12:44:32',NULL,NULL),(35207,'39296','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.345145,-90.165957,0,'2013-07-06 12:44:32',NULL,NULL),(33779,'37872','S','Sunbright','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.270660,-84.691200,0,'2013-07-06 12:44:32',NULL,NULL),(52213,'60481','S','Ritchie','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(68554,'81430','P','Placerville','D','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.040148,-108.064432,0,'2013-07-06 12:44:34',NULL,NULL),(40159,'45359','S','P Hill','N','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.054057,-84.353770,0,'2013-07-06 12:44:32',NULL,NULL),(22352,'23889','S','Warfield','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.894657,-77.745989,0,'2013-07-06 12:44:31',NULL,NULL),(6780,'06104','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788898,-72.665246,0,'2013-07-06 12:44:30',NULL,NULL),(40524,'45828','S','Coldwater','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.483515,-84.660080,0,'2013-07-06 12:44:32',NULL,NULL),(2146,'00924','S','Urb Town Pk','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(743,'00692','S','Alts De Cerro Gordo 3&4','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(20170,'20744','S','Fort Washington','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.752955,-76.981503,0,'2013-07-06 12:44:31',NULL,NULL),(11749,'12189','S','Maplewood','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.726113,-73.713355,0,'2013-07-06 12:44:30',NULL,NULL),(44858,'50276','S','The Meadows','N','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.851937,-93.924289,0,'2013-07-06 12:44:32',NULL,NULL),(38645,'43935','S','Martins Ferry','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.100135,-80.730164,0,'2013-07-06 12:44:32',NULL,NULL),(71670,'87506','S','Nambe','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.585314,-106.024436,0,'2013-07-06 12:44:34',NULL,NULL),(66357,'78614','S','Cost','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.420313,-97.554007,0,'2013-07-06 12:44:34',NULL,NULL),(62057,'73538','S','Elgin','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.723178,-98.260077,0,'2013-07-06 12:44:33',NULL,NULL),(2204,'00926','S','Repto Universitario','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(14240,'14816','S','Breesport','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.172988,-76.730149,0,'2013-07-06 12:44:31',NULL,NULL),(44890,'50318','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.586246,-93.622986,0,'2013-07-06 12:44:32',NULL,NULL),(16610,'17331','S','Edgegrove','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(64097,'76164','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.782966,-97.347496,0,'2013-07-06 12:44:34',NULL,NULL),(22748,'24411','P','Augusta Springs','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.104025,-79.318835,0,'2013-07-06 12:44:31',NULL,NULL),(9158,'09314','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(48082,'55331','S','Tonka Bay','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(57977,'67838','S','Deerfield','D','Kearny','20093','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.983227,-101.130217,0,'2013-07-06 12:44:33',NULL,NULL),(78362,'98015','P','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.620020,-122.204989,0,'2013-07-06 12:44:34',NULL,NULL),(15922,'17019','S','Siddonsburg','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.098851,-77.022403,0,'2013-07-06 12:44:31',NULL,NULL),(22462,'24036','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.278909,-79.932979,0,'2013-07-06 12:44:31',NULL,NULL),(38356,'43450','S','Pemberville','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.410784,-83.478730,0,'2013-07-06 12:44:32',NULL,NULL),(47362,'54616','S','Blair','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.291331,-91.231237,0,'2013-07-06 12:44:32',NULL,NULL),(58911,'69301','S','Alliance','D','Box Butte','31013','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.124380,-102.896400,0,'2013-07-06 12:44:33',NULL,NULL),(19953,'20579','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901432,-77.044897,0,'2013-07-06 12:44:31',NULL,NULL),(11137,'11707','P','West Babylon','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.700400,-73.327799,0,'2013-07-06 12:44:30',NULL,NULL),(59110,'70145','S','Navy Reg Data Auto Ctr','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.961146,-90.035413,0,'2013-07-06 12:44:33',NULL,NULL),(70157,'84314','S','Madsen','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.641228,-112.090819,0,'2013-07-06 12:44:34',NULL,NULL),(72048,'88101','S','Cannon AFB','A','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.405380,-103.248420,0,'2013-07-06 12:44:34',NULL,NULL),(26126,'28734','S','Cartoogechaye','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(12773,'13211','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.098535,-76.132190,0,'2013-07-06 12:44:30',NULL,NULL),(69729,'84042','S','Lindon','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.344492,-111.730542,0,'2013-07-06 12:44:34',NULL,NULL),(64852,'77049','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.836704,-95.149474,0,'2013-07-06 12:44:34',NULL,NULL),(1128,'00725','S','Villa del Rey 1','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(62550,'74437','S','Spelter City','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(78922,'98366','S','Fernwood','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(19603,'20229','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892772,-77.032993,0,'2013-07-06 12:44:31',NULL,NULL),(51399,'59427','S','Santa Rita','A','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.647289,-112.350965,0,'2013-07-06 12:44:33',NULL,NULL),(72251,'88528','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811152,-106.420635,0,'2013-07-06 12:44:34',NULL,NULL),(66033,'78364','P','Kingsville','D','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.524434,-97.868903,0,'2013-07-06 12:44:34',NULL,NULL),(25524,'28392','S','Tar Heel','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.733176,-78.793919,0,'2013-07-06 12:44:31',NULL,NULL),(19499,'20163','P','Sterling','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.987990,-77.450131,0,'2013-07-06 12:44:31',NULL,NULL),(34168,'38281','P','Union Cy','N','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.425852,-89.049841,0,'2013-07-06 12:44:32',NULL,NULL),(14619,'15229','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.517677,-80.040063,0,'2013-07-06 12:44:31',NULL,NULL),(34684,'38827','S','Belmont','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.512414,-88.210005,0,'2013-07-06 12:44:32',NULL,NULL),(37254,'41560','S','Robinson Crk','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.328847,-82.570316,0,'2013-07-06 12:44:32',NULL,NULL),(48735,'55963','S','Pine Island','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.203767,-92.648800,0,'2013-07-06 12:44:33',NULL,NULL),(54374,'62810','S','Moores Prairie','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.190078,-88.761816,0,'2013-07-06 12:44:33',NULL,NULL),(1559,'00766','S','Est de Mayoral','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(20087,'20693','S','Welcome','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.478082,-77.090606,0,'2013-07-06 12:44:31',NULL,NULL),(39318,'44601','S','Mt Union','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.918936,-81.135368,0,'2013-07-06 12:44:32',NULL,NULL),(66364,'78616','S','Tilmon','N','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.029845,-97.571615,0,'2013-07-06 12:44:34',NULL,NULL),(33458,'37322','S','Decatur','D','Meigs','47121','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.452828,-84.914566,0,'2013-07-06 12:44:32',NULL,NULL),(36367,'40447','S','Wind Cave','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(45384,'51025','S','Holstein','D','Ida','19093','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.485024,-95.545838,0,'2013-07-06 12:44:32',NULL,NULL),(27261,'29935','S','Port Royal','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.385662,-80.692890,0,'2013-07-06 12:44:31',NULL,NULL),(9571,'10026','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(57432,'66783','S','Durand','N','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.881629,-95.728588,0,'2013-07-06 12:44:33',NULL,NULL),(69635,'84003','S','American Fork','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.419240,-111.565260,0,'2013-07-06 12:44:34',NULL,NULL),(42278,'47585','S','Stendal','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.277754,-87.128319,0,'2013-07-06 12:44:32',NULL,NULL),(66000,'78343','S','Palo Alto','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.585618,-97.797045,0,'2013-07-06 12:44:34',NULL,NULL),(20682,'21236','S','Nottingham','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.389419,-76.488137,0,'2013-07-06 12:44:31',NULL,NULL),(12605,'13081','S','Kings Ferry','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.662592,-76.626770,0,'2013-07-06 12:44:30',NULL,NULL),(8984,'08831','S','Monroe Township','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.350085,-74.441445,0,'2013-07-06 12:44:30',NULL,NULL),(63135,'75358','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.812543,-96.686454,0,'2013-07-06 12:44:33',NULL,NULL),(60704,'71944','S','Grannis','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.230254,-94.362130,0,'2013-07-06 12:44:33',NULL,NULL),(7243,'06512','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.285640,-72.863580,0,'2013-07-06 12:44:30',NULL,NULL),(42806,'48051','S','Chesterfield Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.688473,-82.809772,0,'2013-07-06 12:44:32',NULL,NULL),(42022,'47436','S','Chapelhill','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003996,-86.436004,0,'2013-07-06 12:44:32',NULL,NULL),(39727,'45061','P','Ross','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.311626,-84.645070,0,'2013-07-06 12:44:32',NULL,NULL),(34326,'38558','S','Fairfld Glade','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(14698,'15259','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441403,-79.998160,0,'2013-07-06 12:44:31',NULL,NULL),(77202,'96367','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(52783,'61270','S','Malvern','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(72121,'88260','S','Buckeye','N','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.931120,-103.313460,0,'2013-07-06 12:44:34',NULL,NULL),(66158,'78505','P','McAllen','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.200156,-98.232966,0,'2013-07-06 12:44:34',NULL,NULL),(58111,'68120','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.229884,-96.163790,0,'2013-07-06 12:44:33',NULL,NULL),(16168,'17064','P','Mt Gretna','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.245217,-76.468668,0,'2013-07-06 12:44:31',NULL,NULL),(303,'00646','S','Urb Martorell','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(10679,'11204','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.620189,-73.985706,0,'2013-07-06 12:44:30',NULL,NULL),(30393,'33321','S','Lauder Hill','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(38522,'43728','S','Chesterhill','D','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.653299,-81.810316,0,'2013-07-06 12:44:32',NULL,NULL),(31772,'35013','P','Allgood','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.966342,-86.383570,0,'2013-07-06 12:44:32',NULL,NULL),(71298,'86446','P','Mohave Valley','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.910318,-114.546307,0,'2013-07-06 12:44:34',NULL,NULL),(6797,'06108','S','Forbes Village','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(14453,'15106','S','Collier TWP','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405231,-80.093696,0,'2013-07-06 12:44:31',NULL,NULL),(68051,'80931','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.752720,-104.731586,0,'2013-07-06 12:44:34',NULL,NULL),(6800,'06108','S','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(35307,'39403','P','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.322369,-89.278966,0,'2013-07-06 12:44:32',NULL,NULL),(22823,'24502','S','Timberlake','A','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.359789,-79.218967,0,'2013-07-06 12:44:31',NULL,NULL),(28737,'31914','P','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.556200,-85.005558,0,'2013-07-06 12:44:32',NULL,NULL),(55907,'64441','S','Denver','D','Worth','29227','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.427871,-94.290489,0,'2013-07-06 12:44:33',NULL,NULL),(56848,'65897','U','SW MO State','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.199100,-93.276100,0,'2013-07-06 12:44:33',NULL,NULL),(62501,'74364','S','Rose','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.219382,-94.986746,0,'2013-07-06 12:44:33',NULL,NULL),(68216,'81049','S','Villegreen','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.306177,-103.387984,0,'2013-07-06 12:44:34',NULL,NULL),(51393,'59421','S','Cascade','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.205603,-111.699843,0,'2013-07-06 12:44:33',NULL,NULL),(20162,'20741','P','College Park','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998102,-76.936482,0,'2013-07-06 12:44:31',NULL,NULL),(304,'00646','S','Urb Miraflores','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(47888,'55104','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.955483,-93.160531,0,'2013-07-06 12:44:33',NULL,NULL),(72206,'88417','S','Cuervo','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.989184,-104.378134,0,'2013-07-06 12:44:34',NULL,NULL),(68884,'82711','S','Alva','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.695788,-104.438573,0,'2013-07-06 12:44:34',NULL,NULL),(43997,'49343','S','Sand Lake','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.279939,-85.477323,0,'2013-07-06 12:44:32',NULL,NULL),(50497,'58060','S','Delamere','A','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.256640,-97.434840,0,'2013-07-06 12:44:33',NULL,NULL),(4899,'04056','P','Newfield','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.647796,-70.920037,0,'2013-07-06 12:44:30',NULL,NULL),(27624,'30310','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.725127,-84.422754,0,'2013-07-06 12:44:31',NULL,NULL),(55392,'63630','S','Cadet','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.034480,-90.721680,0,'2013-07-06 12:44:33',NULL,NULL),(17382,'17886','S','West Milton','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.022009,-76.870147,0,'2013-07-06 12:44:31',NULL,NULL),(34640,'38765','P','Panther Burn','D','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.024904,-90.787172,0,'2013-07-06 12:44:32',NULL,NULL),(67361,'80111','S','Greenwood Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(70008,'84125','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701548,-111.945910,0,'2013-07-06 12:44:34',NULL,NULL),(5101,'04348','S','Somerville','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.197758,-69.471419,0,'2013-07-06 12:44:30',NULL,NULL),(59921,'71291','S','Drew','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(34659,'38780','P','Wayside','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.266791,-91.023527,0,'2013-07-06 12:44:32',NULL,NULL),(12576,'13068','S','Freeville','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.502142,-76.354802,0,'2013-07-06 12:44:30',NULL,NULL),(55882,'64420','P','Allendale','D','Worth','29227','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.483158,-94.288233,0,'2013-07-06 12:44:33',NULL,NULL),(7506,'06926','U','Pitney Bowes Inc','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.040259,-73.548051,0,'2013-07-06 12:44:30',NULL,NULL),(56131,'64836','S','Carthage','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(49213,'56464','S','Menahga','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(47978,'55127','S','Little Canada','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(23742,'25922','S','Spanishburg','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.445126,-81.115031,0,'2013-07-06 12:44:31',NULL,NULL),(45089,'50536','S','Emmetsburg','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.108470,-94.678781,0,'2013-07-06 12:44:32',NULL,NULL),(7701,'07112','S','Weequahic','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.709508,-74.211572,0,'2013-07-06 12:44:30',NULL,NULL),(49337,'56563','S','Moorhead','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.867452,-96.756248,0,'2013-07-06 12:44:33',NULL,NULL),(76215,'95367','S','Riverbank','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.733057,-120.941267,0,'2013-07-06 12:44:34',NULL,NULL),(1672,'00773','S','VISTAS de Luquillo','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(31458,'34286','S','Venice','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.070796,-82.145952,0,'2013-07-06 12:44:32',NULL,NULL),(53628,'62093','P','Wilsonville','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.066788,-89.853304,0,'2013-07-06 12:44:33',NULL,NULL),(1620,'00771','S','Colinas de San Agustin','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(46674,'53719','S','Fitchburg','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.032837,-89.498129,0,'2013-07-06 12:44:32',NULL,NULL),(10211,'10454','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.808965,-73.916818,0,'2013-07-06 12:44:30',NULL,NULL),(17899,'18447','S','Blakely','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(47763,'55032','S','Harris','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.590923,-92.982345,0,'2013-07-06 12:44:33',NULL,NULL),(31006,'33776','S','Largo','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.850818,-82.829083,0,'2013-07-06 12:44:32',NULL,NULL),(70667,'85213','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.439179,-111.772612,0,'2013-07-06 12:44:34',NULL,NULL),(75578,'94282','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584515,-121.494490,0,'2013-07-06 12:44:34',NULL,NULL),(73204,'90604','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.934784,-118.022664,0,'2013-07-06 12:44:34',NULL,NULL),(59165,'70340','P','Amelia','D','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.697608,-91.275999,0,'2013-07-06 12:44:33',NULL,NULL),(56918,'66058','S','Muscotah','D','Atchison','20005','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.598180,-95.489987,0,'2013-07-06 12:44:33',NULL,NULL),(9288,'09647','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(31984,'35219','P','Homewd','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473661,-86.825878,0,'2013-07-06 12:44:32',NULL,NULL),(50411,'57782','P','Smithwick','D','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.267905,-103.166889,0,'2013-07-06 12:44:33',NULL,NULL),(12423,'12945','S','Upper Saint Regis','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.366560,-74.247330,0,'2013-07-06 12:44:30',NULL,NULL),(42827,'48064','S','Casco','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767640,-82.672380,0,'2013-07-06 12:44:32',NULL,NULL),(35162,'39250','U','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291319,-90.185931,0,'2013-07-06 12:44:32',NULL,NULL),(72640,'89425','S','King River','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.738584,-118.090715,0,'2013-07-06 12:44:34',NULL,NULL),(69841,'84083','S','Gold Hill','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.738100,-114.021398,0,'2013-07-06 12:44:34',NULL,NULL),(30802,'33609','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.941629,-82.508523,0,'2013-07-06 12:44:32',NULL,NULL),(8727,'08510','S','Millstone Twp','A','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.189800,-74.441400,0,'2013-07-06 12:44:30',NULL,NULL),(56739,'65712','S','Mount Vernon','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.098522,-93.815768,0,'2013-07-06 12:44:33',NULL,NULL),(64430,'76557','S','Willow Grove','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(19605,'20230','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899945,-77.035749,0,'2013-07-06 12:44:31',NULL,NULL),(73122,'90264','P','Malibu','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.043513,-118.771042,0,'2013-07-06 12:44:34',NULL,NULL),(71002,'85717','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.243556,-110.949722,0,'2013-07-06 12:44:34',NULL,NULL),(13476,'13790','S','East Maine','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.120267,-75.972895,0,'2013-07-06 12:44:31',NULL,NULL),(10643,'11101','S','Astoria','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.748470,-73.939180,0,'2013-07-06 12:44:30',NULL,NULL),(15341,'16229','S','Freeport','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.716671,-79.659656,0,'2013-07-06 12:44:31',NULL,NULL),(21315,'22406','S','Frederickbur','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(28106,'30802','S','Leah','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.539800,-82.315022,0,'2013-07-06 12:44:31',NULL,NULL),(43597,'48761','S','South Branch','D','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.475118,-83.916018,0,'2013-07-06 12:44:32',NULL,NULL),(18726,'19320','S','Coatesville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(58288,'68413','S','Nehawka','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.833385,-95.995045,0,'2013-07-06 12:44:33',NULL,NULL),(15939,'17022','S','Deodate','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(47674,'54947','S','Winchester','N','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.195234,-88.695873,0,'2013-07-06 12:44:33',NULL,NULL),(52558,'60952','S','Melvin','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.575987,-88.247029,0,'2013-07-06 12:44:33',NULL,NULL),(27515,'30188','S','Woodstock','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.115005,-84.455112,0,'2013-07-06 12:44:31',NULL,NULL),(43277,'48332','P','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465819,-83.378683,0,'2013-07-06 12:44:32',NULL,NULL),(77521,'96844','U','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.295954,-157.813874,0,'2013-07-06 12:44:34',NULL,NULL),(5348,'04609','S','Bar Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.384770,-68.212594,0,'2013-07-06 12:44:30',NULL,NULL),(55855,'64170','U','Midwest Service Center','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.951885,-94.546834,0,'2013-07-06 12:44:33',NULL,NULL),(32390,'35952','S','Snead','A','Etowah','01055','Alabama','AL','01','2880','205/659','Central',-6.0,'Y',34.026000,-86.299260,0,'2013-07-06 12:44:32',NULL,NULL),(27614,'30306','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.786536,-84.349237,0,'2013-07-06 12:44:31',NULL,NULL),(3201,'01351','S','Montague','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.536668,-72.530141,0,'2013-07-06 12:44:30',NULL,NULL),(68601,'81610','S','Blue Mountain','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.334596,-108.822045,0,'2013-07-06 12:44:34',NULL,NULL),(59891,'71272','U','La Tech','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.529801,-92.650160,0,'2013-07-06 12:44:33',NULL,NULL),(22244,'23662','S','Poquoson','D','Poquoson City','51735','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.133100,-76.365900,0,'2013-07-06 12:44:31',NULL,NULL),(9215,'09507','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21782,'23067','P','Hadensville','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.813710,-78.013015,0,'2013-07-06 12:44:31',NULL,NULL),(3918,'02459','S','Newton Cntr','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.308823,-71.191835,0,'2013-07-06 12:44:30',NULL,NULL),(60021,'71341','S','Hessmer','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.055529,-92.141657,0,'2013-07-06 12:44:33',NULL,NULL),(60205,'71419','S','Hatcher','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(64793,'77015','S','Cloverleaf','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770126,-95.173187,0,'2013-07-06 12:44:34',NULL,NULL),(64959,'77243','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.796788,-95.491971,0,'2013-07-06 12:44:34',NULL,NULL),(65296,'77488','S','Wharton','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(71917,'87825','S','Alamo','A','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.420830,-107.510280,0,'2013-07-06 12:44:34',NULL,NULL),(33909,'38053','S','Barretville','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(66349,'78610','S','Hays','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.082691,-97.843934,0,'2013-07-06 12:44:34',NULL,NULL),(63549,'75765','S','Holly Lake Ranch','A','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.655720,-95.197003,0,'2013-07-06 12:44:33',NULL,NULL),(40967,'46322','S','Hammond','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.551945,-87.457161,0,'2013-07-06 12:44:32',NULL,NULL),(33363,'37191','S','Woodlawn','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.501196,-87.539057,0,'2013-07-06 12:44:32',NULL,NULL),(45841,'52221','S','Guernsey','D','Poweshiek','19157','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.648690,-92.341879,0,'2013-07-06 12:44:32',NULL,NULL),(61625,'72829','P','Centerville','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.168243,-93.223463,0,'2013-07-06 12:44:33',NULL,NULL),(59025,'70080','S','Paradis','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.879077,-90.437083,0,'2013-07-06 12:44:33',NULL,NULL),(25871,'28634','S','Countyline','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.956738,-80.772702,0,'2013-07-06 12:44:31',NULL,NULL),(10392,'10602','P','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.032214,-73.765250,0,'2013-07-06 12:44:30',NULL,NULL),(55537,'63834','S','Diehlstadt','N','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.922260,-89.295480,0,'2013-07-06 12:44:33',NULL,NULL),(40803,'46181','S','Spearsville','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.365002,-86.183378,0,'2013-07-06 12:44:32',NULL,NULL),(31219,'33956','S','St James City','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.527436,-82.090909,0,'2013-07-06 12:44:32',NULL,NULL),(70141,'84306','S','Collinston','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.787743,-112.072730,0,'2013-07-06 12:44:34',NULL,NULL),(65518,'77707','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.068757,-94.173922,0,'2013-07-06 12:44:34',NULL,NULL),(41468,'46919','S','Converse','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.578802,-85.869187,0,'2013-07-06 12:44:32',NULL,NULL),(55850,'64167','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.319126,-94.485130,0,'2013-07-06 12:44:33',NULL,NULL),(39723,'45056','S','Miami Univ','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(40196,'45383','S','West Milton','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.955496,-84.328876,0,'2013-07-06 12:44:32',NULL,NULL),(13081,'13461','S','Sherrill','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.071891,-75.595941,0,'2013-07-06 12:44:30',NULL,NULL),(35311,'39406','U','University Of Southern Ms','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.330181,-89.338932,0,'2013-07-06 12:44:32',NULL,NULL),(60228,'71429','S','Peason','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.562771,-93.478790,0,'2013-07-06 12:44:33',NULL,NULL),(75507,'94141','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.766839,-122.408909,0,'2013-07-06 12:44:34',NULL,NULL),(5794,'05060','S','Randolph','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.931946,-72.644794,0,'2013-07-06 12:44:30',NULL,NULL),(3718,'02144','S','West Somerville','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.399028,-71.123138,0,'2013-07-06 12:44:30',NULL,NULL),(28728,'31906','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.470086,-84.953402,0,'2013-07-06 12:44:32',NULL,NULL),(61637,'72842','S','Havana','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.096421,-93.612292,0,'2013-07-06 12:44:33',NULL,NULL),(60027,'71342','S','Rogers','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(58734,'68947','S','Hildreth','D','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.337326,-99.045308,0,'2013-07-06 12:44:33',NULL,NULL),(35585,'39573','S','Perkinston','D','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(34793,'38871','S','Thaxton','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.310044,-89.158801,0,'2013-07-06 12:44:32',NULL,NULL),(48753,'55972','S','Troy','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.967246,-92.063039,0,'2013-07-06 12:44:33',NULL,NULL),(12372,'12912','S','Hawkeye','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.459424,-73.713927,0,'2013-07-06 12:44:30',NULL,NULL),(55614,'63960','S','Asherville','N','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.952919,-90.157210,0,'2013-07-06 12:44:33',NULL,NULL),(51955,'60137','S','Glen Ellyn','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.871806,-88.065073,0,'2013-07-06 12:44:33',NULL,NULL),(22454,'24028','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.281781,-79.942877,0,'2013-07-06 12:44:31',NULL,NULL),(16014,'17042','S','Buffalo Sprs','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(38305,'43351','S','Upper Sandsky','A','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.815480,-83.310120,0,'2013-07-06 12:44:32',NULL,NULL),(61158,'72178','P','West Point','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.206381,-91.608079,0,'2013-07-06 12:44:33',NULL,NULL),(46211,'52760','S','Moscow','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.580616,-91.050304,0,'2013-07-06 12:44:32',NULL,NULL),(48011,'55170','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944443,-93.092404,0,'2013-07-06 12:44:33',NULL,NULL),(49526,'56676','S','Moose Creek','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.383450,-95.232970,0,'2013-07-06 12:44:33',NULL,NULL),(29019,'32227','S','Mayport','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(53050,'61483','S','Toulon','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.092649,-89.863127,0,'2013-07-06 12:44:33',NULL,NULL),(19068,'19550','P','Tulpehocken','N','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.459219,-76.243509,0,'2013-07-06 12:44:31',NULL,NULL),(7770,'07416','S','Franklin','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.117073,-74.599284,0,'2013-07-06 12:44:30',NULL,NULL),(66193,'78539','S','San Juan Community','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(66215,'78552','S','Harlingen','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.187337,-97.732062,0,'2013-07-06 12:44:34',NULL,NULL),(74676,'92867','S','Villa Park','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.811025,-117.849274,0,'2013-07-06 12:44:34',NULL,NULL),(71825,'87575','S','Tierra Amarilla','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(15854,'16942','S','Osceola','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.985496,-77.345771,0,'2013-07-06 12:44:31',NULL,NULL),(40293,'45440','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(76141,'95267','P','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.003825,-121.319038,0,'2013-07-06 12:44:34',NULL,NULL),(36225,'40285','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.179153,-85.721438,0,'2013-07-06 12:44:32',NULL,NULL),(79543,'98951','S','Sawyer','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.456917,-120.410065,0,'2013-07-06 12:44:34',NULL,NULL),(78307,'97907','S','Huntington','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.347926,-117.262318,0,'2013-07-06 12:44:34',NULL,NULL),(68677,'82002','U','State of Wyoming','N','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.142242,-104.822841,0,'2013-07-06 12:44:34',NULL,NULL),(60688,'71935','S','Fancy Hill','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.358611,-93.688611,0,'2013-07-06 12:44:33',NULL,NULL),(40247,'45429','S','Centerville','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.686892,-84.159357,0,'2013-07-06 12:44:32',NULL,NULL),(22590,'24175','S','Haymakertown','N','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.397461,-79.876477,0,'2013-07-06 12:44:31',NULL,NULL),(28176,'31003','P','Allentown','D','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597329,-83.223086,0,'2013-07-06 12:44:31',NULL,NULL),(56625,'65590','S','Cedar Ridge','N','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.573975,-92.932919,0,'2013-07-06 12:44:33',NULL,NULL),(49869,'57258','S','Clark Colony','N','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.889418,-97.921590,0,'2013-07-06 12:44:33',NULL,NULL),(6534,'05832','S','E Burke','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.604179,-71.918969,0,'2013-07-06 12:44:30',NULL,NULL),(12319,'12862','P','Riparius','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.661660,-73.897245,0,'2013-07-06 12:44:30',NULL,NULL),(24072,'26438','P','Spelter','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.346008,-80.317063,0,'2013-07-06 12:44:31',NULL,NULL),(5318,'04570','P','Squirrel Is','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.807043,-69.634374,0,'2013-07-06 12:44:30',NULL,NULL),(2867,'00985','S','Urb Jose S Quinones','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(60813,'72032','S','Central Baptist College','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(64485,'76599','U','Gatesville','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.474630,-97.739824,0,'2013-07-06 12:44:34',NULL,NULL),(7397,'06791','S','Torrington','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753700,-73.061520,0,'2013-07-06 12:44:30',NULL,NULL),(14446,'15096','U','Warrendale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.651942,-80.093281,0,'2013-07-06 12:44:31',NULL,NULL),(55627,'63966','S','Wappapello','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.996844,-90.274498,0,'2013-07-06 12:44:33',NULL,NULL),(4249,'02876','S','Slatersville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.999790,-71.588540,0,'2013-07-06 12:44:30',NULL,NULL),(3115,'01230','S','Van Deusenville','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(37875,'42544','S','Trimble','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(78048,'97446','S','Harrisburg','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.272830,-123.113964,0,'2013-07-06 12:44:34',NULL,NULL),(44233,'49655','S','Le Roy','N','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.049480,-85.443900,0,'2013-07-06 12:44:32',NULL,NULL),(19851,'20510','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889190,-77.008664,0,'2013-07-06 12:44:31',NULL,NULL),(45582,'51537','S','Tennant','A','Shelby','19165','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.651801,-95.327571,0,'2013-07-06 12:44:32',NULL,NULL),(18410,'19056','S','Middletown Twp','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.150296,-74.888025,0,'2013-07-06 12:44:31',NULL,NULL),(49793,'57108','S','Sioux Falls','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.474208,-96.687689,0,'2013-07-06 12:44:33',NULL,NULL),(57167,'66283','P','Stanley','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861823,-94.670864,0,'2013-07-06 12:44:33',NULL,NULL),(5752,'05039','S','Cookville','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(6680,'06037','S','Kensington','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.607780,-72.770100,0,'2013-07-06 12:44:30',NULL,NULL),(72503,'89149','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.283793,-115.305930,0,'2013-07-06 12:44:34',NULL,NULL),(36246,'40298','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256066,-85.753145,0,'2013-07-06 12:44:32',NULL,NULL),(26595,'29227','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.033609,-81.108740,0,'2013-07-06 12:44:31',NULL,NULL),(58301,'68428','S','Agnew','A','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.970750,-96.786660,0,'2013-07-06 12:44:33',NULL,NULL),(29338,'32548','S','West Destin','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(42223,'47561','S','Oaktown','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.851331,-87.415278,0,'2013-07-06 12:44:32',NULL,NULL),(37014,'41230','S','Richardson','A','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.109540,-82.626840,0,'2013-07-06 12:44:32',NULL,NULL),(33750,'37848','S','Powder Spgs','A','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.252231,-83.668136,0,'2013-07-06 12:44:32',NULL,NULL),(78808,'98330','S','Elbe','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.764306,-122.135706,0,'2013-07-06 12:44:34',NULL,NULL),(58743,'68954','S','Inland','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.571077,-98.228337,0,'2013-07-06 12:44:33',NULL,NULL),(32334,'35774','S','Trenton','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.749319,-86.274711,0,'2013-07-06 12:44:32',NULL,NULL),(2193,'00926','S','Paseo del Parque','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(72135,'88301','S','White Oaks','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(5388,'04646','P','Islesford','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.259058,-68.226602,0,'2013-07-06 12:44:30',NULL,NULL),(4748,'03842','S','Hampton','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.932595,-70.823853,0,'2013-07-06 12:44:30',NULL,NULL),(31258,'33990','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.629659,-81.951755,0,'2013-07-06 12:44:32',NULL,NULL),(18118,'18812','S','Brackney','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.955028,-75.927922,0,'2013-07-06 12:44:31',NULL,NULL),(19614,'20238','U','Us Holocaust Memorial Museum','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904151,-77.045347,0,'2013-07-06 12:44:31',NULL,NULL),(45469,'51249','S','Sibley','D','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.403910,-95.746853,0,'2013-07-06 12:44:32',NULL,NULL),(35203,'39289','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.385455,-90.276532,0,'2013-07-06 12:44:32',NULL,NULL),(43652,'48845','S','Hubbardston','D','Ionia','26067','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.092877,-84.868158,0,'2013-07-06 12:44:32',NULL,NULL),(5584,'04915','S','Waldo','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.418374,-69.007415,0,'2013-07-06 12:44:30',NULL,NULL),(28103,'30756','P','Varnell','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.895021,-84.977128,0,'2013-07-06 12:44:31',NULL,NULL),(70055,'84141','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.668129,-111.861408,0,'2013-07-06 12:44:34',NULL,NULL),(75906,'95001','P','Aptos','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.980421,-121.898405,0,'2013-07-06 12:44:34',NULL,NULL),(79881,'99573','S','Copper Center','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.920251,-145.382949,0,'2013-07-06 12:44:34',NULL,NULL),(79445,'98843','S','Orondo','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.789243,-120.032848,0,'2013-07-06 12:44:34',NULL,NULL),(72186,'88353','P','East Vaughn','N','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.686068,-105.133654,0,'2013-07-06 12:44:34',NULL,NULL),(64977,'77265','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.719840,-95.430807,0,'2013-07-06 12:44:34',NULL,NULL),(59740,'71134','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.478625,-93.735233,0,'2013-07-06 12:44:33',NULL,NULL),(4040,'02576','S','West Wareham','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.772096,-70.760191,0,'2013-07-06 12:44:30',NULL,NULL),(73786,'91746','S','Bassett','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.049002,-117.979948,0,'2013-07-06 12:44:34',NULL,NULL),(71625,'87375','P','Yatahey','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.525520,-108.740820,0,'2013-07-06 12:44:34',NULL,NULL),(15850,'16939','P','Morris Run','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.679295,-77.018305,0,'2013-07-06 12:44:31',NULL,NULL),(30431,'33329','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111170,-80.274605,0,'2013-07-06 12:44:32',NULL,NULL),(21753,'23055','S','Fork Union','D','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.769687,-78.215424,0,'2013-07-06 12:44:31',NULL,NULL),(60177,'71411','S','Campti','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.896095,-93.116422,0,'2013-07-06 12:44:33',NULL,NULL),(23363,'25270','S','Reedy','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.844309,-81.448115,0,'2013-07-06 12:44:31',NULL,NULL),(42221,'47561','S','Busseron','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.851331,-87.415278,0,'2013-07-06 12:44:32',NULL,NULL),(55916,'64453','S','Gentry','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.331820,-94.420990,0,'2013-07-06 12:44:33',NULL,NULL),(16046,'17044','S','Paintersville','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(33174,'37030','S','Carthage','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.262380,-85.994400,0,'2013-07-06 12:44:32',NULL,NULL),(12493,'12997','S','Whiteface Mountain','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.388992,-73.843700,0,'2013-07-06 12:44:30',NULL,NULL),(18403,'19053','S','Oakford','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(16429,'17231','P','Lemasters','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.856695,-77.860814,0,'2013-07-06 12:44:31',NULL,NULL),(60949,'72101','S','Howell','A','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(22255,'23668','U','Hampton University','N','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.023786,-76.339698,0,'2013-07-06 12:44:31',NULL,NULL),(25587,'28443','S','Hampstead','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.394896,-77.651107,0,'2013-07-06 12:44:31',NULL,NULL),(30627,'33440','S','Clewiston','D','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.737871,-80.941459,0,'2013-07-06 12:44:32',NULL,NULL),(59775,'71202','S','Logtown','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.481960,-92.080020,0,'2013-07-06 12:44:33',NULL,NULL),(213,'00624','S','Colinas de Penuelas','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(6849,'06127','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766715,-72.682282,0,'2013-07-06 12:44:30',NULL,NULL),(37873,'42544','S','Naomi','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(29207,'32413','S','Grande Pointe','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(62427,'74149','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.158937,-96.032786,0,'2013-07-06 12:44:33',NULL,NULL),(67946,'80912','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(71037,'85740','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.357607,-111.076619,0,'2013-07-06 12:44:34',NULL,NULL),(65761,'78072','S','Tilden','D','McMullen','48311','Texas','TX','48','0000','361','Central',-6.0,'Y',28.347668,-98.653364,0,'2013-07-06 12:44:34',NULL,NULL),(2535,'00959','S','Bda Pesquera','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(16657,'17350','S','New Oxford','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.888480,-77.077200,0,'2013-07-06 12:44:31',NULL,NULL),(41978,'47421','S','Fort Ritner','A','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(23816,'26059','S','Triadelphia','D','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.090092,-80.620633,0,'2013-07-06 12:44:31',NULL,NULL),(26472,'29150','S','Oswego','A','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(78836,'98335','S','Sunny Bay','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(75405,'94017','P','Daly City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.688779,-122.468923,0,'2013-07-06 12:44:34',NULL,NULL),(68721,'82072','S','Mountain Home','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.061360,-106.014750,0,'2013-07-06 12:44:34',NULL,NULL),(5554,'04852','P','Monhegan','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.768737,-69.313450,0,'2013-07-06 12:44:30',NULL,NULL),(25727,'28547','S','Camp Lejeune','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.704321,-77.349467,0,'2013-07-06 12:44:31',NULL,NULL),(13593,'13850','S','Twin Orchards','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(7756,'07399','U','Pershing','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.727839,-74.078433,0,'2013-07-06 12:44:30',NULL,NULL),(54607,'62910','S','New Liberty','A','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.125868,-88.629383,0,'2013-07-06 12:44:33',NULL,NULL),(54790,'63011','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.598725,-90.547046,0,'2013-07-06 12:44:33',NULL,NULL),(29812,'33025','S','Miramar','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.992876,-80.274221,0,'2013-07-06 12:44:32',NULL,NULL),(33877,'38019','S','Garland','A','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.557255,-89.657223,0,'2013-07-06 12:44:32',NULL,NULL),(1741,'00778','S','Urb Monte Subacio','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(29793,'33018','S','Miami Lakes','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.942320,-80.390400,0,'2013-07-06 12:44:32',NULL,NULL),(29997,'33116','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.671227,-80.372256,0,'2013-07-06 12:44:32',NULL,NULL),(17555,'17981','S','Echo Valley','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(26883,'29560','S','Lake City','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.869500,-79.760872,0,'2013-07-06 12:44:31',NULL,NULL),(58928,'69341','S','Terrytown','N','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.804640,-103.716960,0,'2013-07-06 12:44:33',NULL,NULL),(47429,'54669','S','West Salem','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.899638,-91.087027,0,'2013-07-06 12:44:32',NULL,NULL),(31105,'33884','S','Cypress Gardens','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.999605,-81.679242,0,'2013-07-06 12:44:32',NULL,NULL),(26385,'29102','S','Bloomville','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(11784,'12209','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.641762,-73.788358,0,'2013-07-06 12:44:30',NULL,NULL),(51073,'58758','S','Martin','D','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.719024,-100.120917,0,'2013-07-06 12:44:33',NULL,NULL),(62261,'74008','S','Bixby','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.951012,-95.885108,0,'2013-07-06 12:44:33',NULL,NULL),(65674,'77984','S','Shiner','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.432036,-97.175420,0,'2013-07-06 12:44:34',NULL,NULL),(43019,'48166','S','Newport','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.977424,-83.284218,0,'2013-07-06 12:44:32',NULL,NULL),(44717,'50148','S','Liscomb','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.184344,-93.000026,0,'2013-07-06 12:44:32',NULL,NULL),(15448,'16403','S','Cambridge Springs','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.800913,-80.061183,0,'2013-07-06 12:44:31',NULL,NULL),(50395,'57769','S','Tilford','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.229112,-103.390064,0,'2013-07-06 12:44:33',NULL,NULL),(57935,'67734','S','Gem','D','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.439272,-100.883880,0,'2013-07-06 12:44:33',NULL,NULL),(58972,'70040','S','Belair','N','Plaquemines','22075','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.827869,-89.963279,0,'2013-07-06 12:44:33',NULL,NULL),(34605,'38748','S','Percy','A','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(56081,'64762','S','Liberal','D','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.557891,-94.514277,0,'2013-07-06 12:44:33',NULL,NULL),(65285,'77484','S','Waller','D','Harris','48201','Texas','TX','48','3360','936','Central',-6.0,'Y',30.075392,-95.890763,0,'2013-07-06 12:44:34',NULL,NULL),(59839,'71245','S','Grambling','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.523791,-92.715177,0,'2013-07-06 12:44:33',NULL,NULL),(42455,'47830','P','Bellmore','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.770707,-87.165336,0,'2013-07-06 12:44:32',NULL,NULL),(59840,'71247','P','East Hodge','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.278002,-92.712240,0,'2013-07-06 12:44:33',NULL,NULL),(44185,'49601','S','Hoxeyville','A','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.256670,-85.445220,0,'2013-07-06 12:44:32',NULL,NULL),(43234,'48314','S','Sterling Heights','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.603554,-83.056445,0,'2013-07-06 12:44:32',NULL,NULL),(14760,'15332','S','Finleyville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.255320,-80.006933,0,'2013-07-06 12:44:31',NULL,NULL),(14652,'15236','S','Pleasant Hls','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(58308,'68434','S','Seward','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.911360,-97.152300,0,'2013-07-06 12:44:33',NULL,NULL),(20963,'21784','S','Eldersburg','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.338199,-76.972300,0,'2013-07-06 12:44:31',NULL,NULL),(11080,'11690','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.601071,-73.762108,0,'2013-07-06 12:44:30',NULL,NULL),(15175,'15930','P','Dunlo','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.291746,-78.718451,0,'2013-07-06 12:44:31',NULL,NULL),(35221,'39303','P','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.424433,-88.704863,0,'2013-07-06 12:44:32',NULL,NULL),(52708,'61114','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.307574,-89.013353,0,'2013-07-06 12:44:33',NULL,NULL),(30601,'33421','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(10576,'11021','S','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(63029,'75202','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.781455,-96.801814,0,'2013-07-06 12:44:33',NULL,NULL),(66201,'78545','P','Falcon Village','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.581595,-98.985987,0,'2013-07-06 12:44:34',NULL,NULL),(68506,'81324','S','Dove Creek','D','Dolores','08033','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.765803,-108.904715,0,'2013-07-06 12:44:34',NULL,NULL),(49356,'56576','S','Richville','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.496075,-95.593354,0,'2013-07-06 12:44:33',NULL,NULL),(74734,'93041','S','Pt Mugu Nawc','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.161105,-119.189825,0,'2013-07-06 12:44:34',NULL,NULL),(74423,'92556','P','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.965493,-117.249439,0,'2013-07-06 12:44:34',NULL,NULL),(69918,'84109','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701306,-111.815899,0,'2013-07-06 12:44:34',NULL,NULL),(64543,'76648','S','Pelham','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.846845,-96.799912,0,'2013-07-06 12:44:34',NULL,NULL),(8916,'08742','S','Bay Head','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(44998,'50441','S','Hansell','A','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.745447,-93.208062,0,'2013-07-06 12:44:32',NULL,NULL),(64294,'76452','P','Energy','D','Comanche','48093','Texas','TX','48','0000','254','Central',-6.0,'Y',31.762877,-98.368173,0,'2013-07-06 12:44:34',NULL,NULL),(70660,'85206','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.402178,-111.727568,0,'2013-07-06 12:44:34',NULL,NULL),(72082,'88135','S','Pleasant Hill','N','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.384860,-103.058640,0,'2013-07-06 12:44:34',NULL,NULL),(73729,'91618','P','Universal Cty','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.112736,-118.365832,0,'2013-07-06 12:44:34',NULL,NULL),(79141,'98501','S','Offutt Lake','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(52956,'61419','P','Bishop Hill','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.199134,-90.116322,0,'2013-07-06 12:44:33',NULL,NULL),(34869,'38940','S','Holcomb','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.691186,-89.939080,0,'2013-07-06 12:44:32',NULL,NULL),(38405,'43532','S','Liberty Ctr','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.421995,-83.974523,0,'2013-07-06 12:44:32',NULL,NULL),(4080,'02661','P','South Harwich','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.682731,-70.043762,0,'2013-07-06 12:44:30',NULL,NULL),(15296,'16136','P','Koppel','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.836741,-80.322809,0,'2013-07-06 12:44:31',NULL,NULL),(77531,'96848','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.321456,-157.813409,0,'2013-07-06 12:44:34',NULL,NULL),(55849,'64166','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.320343,-94.520486,0,'2013-07-06 12:44:33',NULL,NULL),(72567,'89315','P','Ely','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.265066,-114.865180,0,'2013-07-06 12:44:34',NULL,NULL),(21438,'22572','S','Foneswood','A','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.957415,-76.762507,0,'2013-07-06 12:44:31',NULL,NULL),(48567,'55768','S','Nichols','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.530445,-92.581327,0,'2013-07-06 12:44:33',NULL,NULL),(1900,'00795','S','Alts del Encanto','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(17207,'17822','U','Danville','D','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.958350,-76.609495,0,'2013-07-06 12:44:31',NULL,NULL),(31645,'34736','S','Groveland','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.570758,-81.862493,0,'2013-07-06 12:44:32',NULL,NULL),(2055,'00920','S','Mario Julia Ind Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(61682,'72938','S','Hartford','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.005190,-94.389892,0,'2013-07-06 12:44:33',NULL,NULL),(64445,'76569','S','Leedale','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.926330,-97.230983,0,'2013-07-06 12:44:34',NULL,NULL),(69218,'83401','S','Grant','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(69405,'83623','S','Glenns Ferry','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.950143,-115.297354,0,'2013-07-06 12:44:34',NULL,NULL),(25164,'28036','S','Davidson','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.479620,-80.823060,0,'2013-07-06 12:44:31',NULL,NULL),(13968,'14475','S','Ionia','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.934998,-77.511407,0,'2013-07-06 12:44:31',NULL,NULL),(14496,'15143','S','Edgeworth','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.553334,-80.152982,0,'2013-07-06 12:44:31',NULL,NULL),(52429,'60655','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.691946,-87.709304,0,'2013-07-06 12:44:33',NULL,NULL),(5905,'05159','P','Westmnstr Sta','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.085978,-72.440728,0,'2013-07-06 12:44:30',NULL,NULL),(55232,'63437','S','Duncans Bridge','N','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738419,-92.263023,0,'2013-07-06 12:44:33',NULL,NULL),(54729,'62965','P','Muddy','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.764433,-88.517106,0,'2013-07-06 12:44:33',NULL,NULL),(44363,'49784','U','Sault Sainte Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.258915,-84.381415,0,'2013-07-06 12:44:32',NULL,NULL),(78653,'98226','S','Silver Beach','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.763345,-122.443649,0,'2013-07-06 12:44:34',NULL,NULL),(62678,'74701','S','Silo','A','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.003629,-96.383237,0,'2013-07-06 12:44:33',NULL,NULL),(61570,'72733','P','Gateway','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.479890,-93.919021,0,'2013-07-06 12:44:33',NULL,NULL),(43230,'48313','S','St Heights','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.598804,-82.997434,0,'2013-07-06 12:44:32',NULL,NULL),(66333,'78602','S','Hill','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.115800,-97.274640,0,'2013-07-06 12:44:34',NULL,NULL),(20243,'20781','S','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(12001,'12490','P','West Camp','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.122589,-73.934344,0,'2013-07-06 12:44:30',NULL,NULL),(55865,'64187','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.099481,-94.577936,0,'2013-07-06 12:44:33',NULL,NULL),(12156,'12743','S','Highland Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.526306,-74.846729,0,'2013-07-06 12:44:30',NULL,NULL),(6599,'05863','P','St Jhnsbry Ct','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.452899,-72.012143,0,'2013-07-06 12:44:30',NULL,NULL),(10403,'10605','S','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.006687,-73.746222,0,'2013-07-06 12:44:30',NULL,NULL),(36606,'40977','S','Clear Crk Spg','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(78908,'98362','S','Port Angeles','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(62726,'74818','P','Seminole','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.225036,-96.670540,0,'2013-07-06 12:44:33',NULL,NULL),(61183,'72207','S','Cammack Village','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.773082,-92.358471,0,'2013-07-06 12:44:33',NULL,NULL),(63973,'76105','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.722238,-97.267430,0,'2013-07-06 12:44:34',NULL,NULL),(9192,'09394','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(10484,'10954','S','Bardonia','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.098338,-74.009393,0,'2013-07-06 12:44:30',NULL,NULL),(39943,'45230','S','Mount Washing','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.078715,-84.377216,0,'2013-07-06 12:44:32',NULL,NULL),(46141,'52654','S','Coppock','N','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.145353,-91.664079,0,'2013-07-06 12:44:32',NULL,NULL),(32572,'36117','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.383690,-86.132460,0,'2013-07-06 12:44:32',NULL,NULL),(57749,'67441','S','Enterprise','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.903547,-97.115537,0,'2013-07-06 12:44:33',NULL,NULL),(59310,'70517','S','Breaux Bridge','D','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.279139,-91.898037,0,'2013-07-06 12:44:33',NULL,NULL),(35617,'39602','P','Bhaven','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.593072,-90.469962,0,'2013-07-06 12:44:32',NULL,NULL),(24024,'26376','S','Wildcat','A','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.753333,-80.438333,0,'2013-07-06 12:44:31',NULL,NULL),(33080,'36784','S','Thomasville','D','Clarke','01025','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.892574,-87.748130,0,'2013-07-06 12:44:32',NULL,NULL),(16402,'17222','S','Fayetteville','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.895994,-77.531945,0,'2013-07-06 12:44:31',NULL,NULL),(22851,'24535','P','Cluster Spgs','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.585431,-79.033084,0,'2013-07-06 12:44:31',NULL,NULL),(10725,'11256','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.663916,-73.860508,0,'2013-07-06 12:44:30',NULL,NULL),(40585,'45874','S','Ohio City','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.774564,-84.633321,0,'2013-07-06 12:44:32',NULL,NULL),(30658,'33462','S','Lantana','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.581130,-80.079020,0,'2013-07-06 12:44:32',NULL,NULL),(52091,'60409','S','Calumet City','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.614779,-87.551336,0,'2013-07-06 12:44:33',NULL,NULL),(29297,'32512','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.502687,-87.173684,0,'2013-07-06 12:44:32',NULL,NULL),(62339,'74055','S','Owasso','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.279959,-95.850118,0,'2013-07-06 12:44:33',NULL,NULL),(54857,'63044','S','Bridgeton','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.760780,-90.412860,0,'2013-07-06 12:44:33',NULL,NULL),(74977,'93440','P','Los Alamos','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.745944,-120.301041,0,'2013-07-06 12:44:34',NULL,NULL),(70410,'84720','S','Enoch','A','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.713174,-113.085548,0,'2013-07-06 12:44:34',NULL,NULL),(26887,'29566','S','Little River','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.885716,-78.637355,0,'2013-07-06 12:44:31',NULL,NULL),(73207,'90606','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.980225,-118.066303,0,'2013-07-06 12:44:34',NULL,NULL),(68013,'80923','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.899457,-104.699208,0,'2013-07-06 12:44:34',NULL,NULL),(67159,'79821','S','Anthony','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.970939,-106.597447,0,'2013-07-06 12:44:34',NULL,NULL),(47094,'54437','S','Greenwood','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.768935,-90.603954,0,'2013-07-06 12:44:32',NULL,NULL),(17005,'17739','P','Jersey Mills','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.408022,-77.457577,0,'2013-07-06 12:44:31',NULL,NULL),(10745,'11358','S','Sta A','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760434,-73.799188,0,'2013-07-06 12:44:30',NULL,NULL),(54440,'62842','S','Jeffersonville','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.440349,-88.426303,0,'2013-07-06 12:44:33',NULL,NULL),(39401,'44660','P','Salt Creek','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.622100,-81.787658,0,'2013-07-06 12:44:32',NULL,NULL),(71583,'87313','P','Dalton Pass','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.798788,-107.923273,0,'2013-07-06 12:44:34',NULL,NULL),(62707,'74745','S','Idabel','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.894371,-94.822174,0,'2013-07-06 12:44:33',NULL,NULL),(60646,'71909','S','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.610580,-93.014760,0,'2013-07-06 12:44:33',NULL,NULL),(46822,'54010','P','Ellsworth','A','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.730383,-92.468244,0,'2013-07-06 12:44:32',NULL,NULL),(27957,'30547','S','Homer','D','Banks','13011','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.358958,-83.486868,0,'2013-07-06 12:44:31',NULL,NULL),(31620,'34690','S','Tarpon Spngs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.191092,-82.728081,0,'2013-07-06 12:44:32',NULL,NULL),(57485,'66930','S','Agenda','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.694671,-97.426245,0,'2013-07-06 12:44:33',NULL,NULL),(63271,'75503','S','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.461416,-94.072824,0,'2013-07-06 12:44:33',NULL,NULL),(65693,'78005','S','Bigfoot','D','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',29.214864,-98.708800,0,'2013-07-06 12:44:34',NULL,NULL),(6060,'05443','S','South Lincoln','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(16219,'17074','S','East Newport','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(16943,'17701','S','Heshbon Park','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(36354,'40445','S','Livingston','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.304447,-84.233162,0,'2013-07-06 12:44:32',NULL,NULL),(2675,'00966','S','Villas de Caparra','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(14136,'14694','U','West Group','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.088842,-77.599683,0,'2013-07-06 12:44:31',NULL,NULL),(47735,'55011','S','East Bethel','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.348975,-93.246677,0,'2013-07-06 12:44:33',NULL,NULL),(47619,'54902','S','Oshkosh','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.999126,-88.669619,0,'2013-07-06 12:44:33',NULL,NULL),(63571,'75771','S','Wood Springs','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(10634,'11053','U','Publishers Clearing House','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.839189,-73.703262,0,'2013-07-06 12:44:30',NULL,NULL),(42872,'48082','S','St Clr Shrs','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.529366,-82.887803,0,'2013-07-06 12:44:32',NULL,NULL),(22498,'24072','S','Simpsons','A','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.036016,-80.241336,0,'2013-07-06 12:44:31',NULL,NULL),(17817,'18411','S','S Abingtn Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(74201,'92285','S','Johnson Vly','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.313640,-116.448000,0,'2013-07-06 12:44:34',NULL,NULL),(63446,'75671','P','Marshall','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.545597,-94.369373,0,'2013-07-06 12:44:33',NULL,NULL),(37411,'41777','S','Big Fork','N','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.046606,-83.220511,0,'2013-07-06 12:44:32',NULL,NULL),(8851,'08646','U','NJ Taxation Dept','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217893,-74.763424,0,'2013-07-06 12:44:30',NULL,NULL),(12763,'13208','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.072766,-76.147309,0,'2013-07-06 12:44:30',NULL,NULL),(9014,'08865','S','Alpha','A','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.698180,-75.135480,0,'2013-07-06 12:44:30',NULL,NULL),(14043,'14557','P','South Byron','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.046795,-78.066225,0,'2013-07-06 12:44:31',NULL,NULL),(42482,'47837','S','Pontiac','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.576608,-87.056532,0,'2013-07-06 12:44:32',NULL,NULL),(20306,'20815','S','Martins Additions','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(34475,'38664','S','Mocarter','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(50860,'58501','S','BIS','N','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.819042,-100.780969,0,'2013-07-06 12:44:33',NULL,NULL),(64349,'76519','S','Ben Arnold','A','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.959980,-96.867177,0,'2013-07-06 12:44:34',NULL,NULL),(26843,'29505','S','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.128606,-79.747284,0,'2013-07-06 12:44:31',NULL,NULL),(45278,'50677','S','Artesian','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.716220,-92.425620,0,'2013-07-06 12:44:32',NULL,NULL),(48926,'56151','S','Hadley','A','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.008260,-95.906340,0,'2013-07-06 12:44:33',NULL,NULL),(50912,'58558','S','Apple Valley','N','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.820879,-100.600093,0,'2013-07-06 12:44:33',NULL,NULL),(40796,'46172','S','Roachdale','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.847885,-86.799339,0,'2013-07-06 12:44:32',NULL,NULL),(41983,'47421','S','Needmore','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(64252,'76371','S','Munday','D','Knox','48275','Texas','TX','48','0000','940','Central',-6.0,'Y',33.447449,-99.623475,0,'2013-07-06 12:44:34',NULL,NULL),(69973,'84120','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(10457,'10925','S','Greenwood Lake','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.218950,-74.294664,0,'2013-07-06 12:44:30',NULL,NULL),(14114,'14642','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.122242,-77.625204,0,'2013-07-06 12:44:31',NULL,NULL),(11905,'12405','S','Acra','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.332936,-74.093813,0,'2013-07-06 12:44:30',NULL,NULL),(43298,'48340','S','Pontiac','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.672494,-83.288704,0,'2013-07-06 12:44:32',NULL,NULL),(69425,'83635','P','Lake Fork','D','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.911111,-116.097778,0,'2013-07-06 12:44:34',NULL,NULL),(49136,'56368','S','Richmond','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.443713,-94.525876,0,'2013-07-06 12:44:33',NULL,NULL),(55997,'64641','S','Galt','D','Grundy','29079','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.156950,-93.412411,0,'2013-07-06 12:44:33',NULL,NULL),(67681,'80510','S','Allenspark','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.217787,-105.524901,0,'2013-07-06 12:44:34',NULL,NULL),(40340,'45614','S','Bidwell','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.928707,-82.254397,0,'2013-07-06 12:44:32',NULL,NULL),(53258,'61704','S','BLM','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.479447,-88.950844,0,'2013-07-06 12:44:33',NULL,NULL),(22900,'24595','P','Sweet Briar','D','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.562727,-79.082436,0,'2013-07-06 12:44:31',NULL,NULL),(56901,'66045','U','Lwrnce','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.959171,-95.264228,0,'2013-07-06 12:44:33',NULL,NULL),(15065,'15732','S','Creekside','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.682141,-79.214813,0,'2013-07-06 12:44:31',NULL,NULL),(19683,'20372','U','Bur Medicine Surgery','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900744,-77.050160,0,'2013-07-06 12:44:31',NULL,NULL),(39410,'44666','S','East Greenville','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.832808,-81.615396,0,'2013-07-06 12:44:32',NULL,NULL),(38549,'43755','S','Lore City','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.052056,-81.438911,0,'2013-07-06 12:44:32',NULL,NULL),(13082,'13464','S','Bonney','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.691125,-75.632663,0,'2013-07-06 12:44:30',NULL,NULL),(56198,'65020','S','Greenview','N','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.025300,-92.778660,0,'2013-07-06 12:44:33',NULL,NULL),(16674,'17361','S','Shrewsbury','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.762201,-76.678536,0,'2013-07-06 12:44:31',NULL,NULL),(38827,'44081','S','Perry','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.765861,-81.146611,0,'2013-07-06 12:44:32',NULL,NULL),(41767,'47303','S','Country Terr','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(46663,'53713','S','Fitchburg','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.032823,-89.394847,0,'2013-07-06 12:44:32',NULL,NULL),(54159,'62572','S','Waggoner','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.378868,-89.648886,0,'2013-07-06 12:44:33',NULL,NULL),(36539,'40873','S','Wallins','N','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.817860,-83.405760,0,'2013-07-06 12:44:32',NULL,NULL),(49164,'56395','U','Fingerhut','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.561027,-94.161673,0,'2013-07-06 12:44:33',NULL,NULL),(29911,'33054','S','Opa Locka','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.905290,-80.257160,0,'2013-07-06 12:44:32',NULL,NULL),(18857,'19440','S','Hatfield','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.274777,-75.289827,0,'2013-07-06 12:44:31',NULL,NULL),(29894,'33043','S','No Name Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.678501,-81.368387,0,'2013-07-06 12:44:32',NULL,NULL),(24839,'27615','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.889314,-78.637839,0,'2013-07-06 12:44:31',NULL,NULL),(59000,'70062','S','Beachview','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.988618,-90.250441,0,'2013-07-06 12:44:33',NULL,NULL),(13937,'14432','S','Clifton Springs','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.963132,-77.147698,0,'2013-07-06 12:44:31',NULL,NULL),(77796,'97136','S','Rockaway','A','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(4903,'04061','S','North Waterboro','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.652363,-70.725533,0,'2013-07-06 12:44:30',NULL,NULL),(36303,'40363','P','Perry Park','D','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.547694,-84.998631,0,'2013-07-06 12:44:32',NULL,NULL),(46209,'52758','P','Mc Causland','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.745733,-90.447474,0,'2013-07-06 12:44:32',NULL,NULL),(36765,'41041','S','Pecksridge','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(2961,'01039','S','Haydenville','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.379586,-72.696757,0,'2013-07-06 12:44:30',NULL,NULL),(39812,'45140','S','Twenty Mile Stand','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(62189,'73764','S','Omega','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.847849,-98.178035,0,'2013-07-06 12:44:33',NULL,NULL),(64433,'76561','S','Cavitt','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.453052,-97.567079,0,'2013-07-06 12:44:34',NULL,NULL),(74361,'92415','U','S B County Offices','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.127706,-117.266443,0,'2013-07-06 12:44:34',NULL,NULL),(5263,'04488','S','Stetson','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.876852,-69.088304,0,'2013-07-06 12:44:30',NULL,NULL),(26691,'29405','S','North Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(75851,'94929','P','Dillon Beach','D','Marin','06041','California','CA','06','7360','707','Pacific',-8.0,'Y',38.253378,-122.965473,0,'2013-07-06 12:44:34',NULL,NULL),(67405,'80129','S','Highlands Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.543276,-105.007567,0,'2013-07-06 12:44:34',NULL,NULL),(19036,'19539','S','Klines Corner','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(21991,'23269','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557901,-77.467640,0,'2013-07-06 12:44:31',NULL,NULL),(8133,'07832','S','Columbia','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.986264,-75.068098,0,'2013-07-06 12:44:30',NULL,NULL),(16245,'17082','S','Old Port','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(47233,'54501','S','Rhinelander','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(31530,'34483','P','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.186238,-82.138652,0,'2013-07-06 12:44:32',NULL,NULL),(53164,'61567','S','Topeka','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.372662,-89.936217,0,'2013-07-06 12:44:33',NULL,NULL),(54168,'62612','S','Yatesville','A','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.886126,-90.009613,0,'2013-07-06 12:44:33',NULL,NULL),(9112,'09107','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(54108,'62545','S','Bolivia','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.809097,-89.397015,0,'2013-07-06 12:44:33',NULL,NULL),(18297,'19015','S','Parkside Manor','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868688,-75.385721,0,'2013-07-06 12:44:31',NULL,NULL),(59210,'70393','S','Plattenville','D','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.986849,-91.021779,0,'2013-07-06 12:44:33',NULL,NULL),(18710,'19197','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954696,-75.178777,0,'2013-07-06 12:44:31',NULL,NULL),(29538,'32793','P','Winter Park','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.662002,-81.483160,0,'2013-07-06 12:44:32',NULL,NULL),(78579,'98170','U','Amazon.com','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.606323,-122.328863,0,'2013-07-06 12:44:34',NULL,NULL),(312,'00646','S','Urb Paisajes De Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(69606,'83855','S','Potlatch','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.011509,-116.928485,0,'2013-07-06 12:44:34',NULL,NULL),(21891,'23181','S','Cologne','A','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.556161,-76.810679,0,'2013-07-06 12:44:31',NULL,NULL),(22736,'24378','S','Trout Dale','N','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.692024,-81.438104,0,'2013-07-06 12:44:31',NULL,NULL),(52264,'60525','S','Hodgkins','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(38598,'43832','S','Wolf','N','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.266000,-81.600180,0,'2013-07-06 12:44:32',NULL,NULL),(37006,'41222','S','Mendola Village','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.795350,-82.819772,0,'2013-07-06 12:44:32',NULL,NULL),(10219,'10459','S','Boulevard','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.827628,-73.896045,0,'2013-07-06 12:44:30',NULL,NULL),(42021,'47435','P','Helmsburg','D','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.310662,-86.313707,0,'2013-07-06 12:44:32',NULL,NULL),(37037,'41262','S','Davisport','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.827120,-82.622820,0,'2013-07-06 12:44:32',NULL,NULL),(4201,'02829','P','Glocester','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.882376,-71.594633,0,'2013-07-06 12:44:30',NULL,NULL),(37688,'42234','S','Hadensville','N','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.695643,-87.176930,0,'2013-07-06 12:44:32',NULL,NULL),(27278,'29945','S','Gardens Corner','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(7941,'07661','S','River Edge','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.929422,-74.039126,0,'2013-07-06 12:44:30',NULL,NULL),(18442,'19067','S','Lower Makefield','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.202400,-74.830980,0,'2013-07-06 12:44:31',NULL,NULL),(49117,'56354','S','Miltona','D','Douglas','27041','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.046559,-95.294043,0,'2013-07-06 12:44:33',NULL,NULL),(49726,'57043','S','Marion','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.424986,-97.260003,0,'2013-07-06 12:44:33',NULL,NULL),(66637,'78833','S','Camp Wood','D','Real','48385','Texas','TX','48','0000','830','Central',-6.0,'Y',29.668540,-100.013494,0,'2013-07-06 12:44:34',NULL,NULL),(64688,'76841','S','Fort Mc Kavett','D','Menard','48327','Texas','TX','48','0000','325','Central',-6.0,'Y',30.930384,-99.828136,0,'2013-07-06 12:44:34',NULL,NULL),(63868,'76003','P','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.654691,-97.175539,0,'2013-07-06 12:44:34',NULL,NULL),(19523,'20186','S','Airlie','N','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.694065,-77.852222,0,'2013-07-06 12:44:31',NULL,NULL),(23957,'26288','S','Curtin','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.497260,-80.369280,0,'2013-07-06 12:44:31',NULL,NULL),(459,'00662','S','Villa Mizei','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(53543,'62037','S','Grafton','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.971812,-90.445426,0,'2013-07-06 12:44:33',NULL,NULL),(33851,'37996','U','University of Tenn','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.956034,-83.937037,0,'2013-07-06 12:44:32',NULL,NULL),(77637,'97009','S','Boring','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.424374,-122.384149,0,'2013-07-06 12:44:34',NULL,NULL),(68470,'81239','S','Parlin','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.505298,-106.636113,0,'2013-07-06 12:44:34',NULL,NULL),(14930,'15553','P','New Baltimore','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.984516,-78.770524,0,'2013-07-06 12:44:31',NULL,NULL),(12564,'13054','S','Stacy Basin','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.141800,-75.670020,0,'2013-07-06 12:44:30',NULL,NULL),(77518,'96843','U','Board of Water Supply','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.302740,-157.850969,0,'2013-07-06 12:44:34',NULL,NULL),(72446,'89105','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171909,-115.139969,0,'2013-07-06 12:44:34',NULL,NULL),(61647,'72855','S','Paris','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.288262,-93.728734,0,'2013-07-06 12:44:33',NULL,NULL),(11096,'11694','S','Rockaway Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.576767,-73.844160,0,'2013-07-06 12:44:30',NULL,NULL),(17239,'17837','S','Fairville','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(12553,'13045','S','Cortland','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.602760,-76.171860,0,'2013-07-06 12:44:30',NULL,NULL),(13349,'13693','S','Three Mle Bay','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.040710,-76.244192,0,'2013-07-06 12:44:30',NULL,NULL),(58378,'68532','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.792402,-96.854537,0,'2013-07-06 12:44:33',NULL,NULL),(75124,'93551','S','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.600777,-118.190371,0,'2013-07-06 12:44:34',NULL,NULL),(71608,'87326','P','Vanderwagen','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.528056,-108.741944,0,'2013-07-06 12:44:34',NULL,NULL),(22485,'24062','P','Blacksburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.228444,-80.415618,0,'2013-07-06 12:44:31',NULL,NULL),(43783,'49040','S','Colon','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.957101,-85.331154,0,'2013-07-06 12:44:32',NULL,NULL),(36138,'40228','S','Spring Mill','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.139470,-85.630403,0,'2013-07-06 12:44:32',NULL,NULL),(27737,'30354','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.658320,-84.384600,0,'2013-07-06 12:44:31',NULL,NULL),(79348,'98631','S','Long Beach','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.348140,-124.052280,0,'2013-07-06 12:44:34',NULL,NULL),(76132,'95251','S','Vallecito','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.085955,-120.470775,0,'2013-07-06 12:44:34',NULL,NULL),(61512,'72653','S','Salesville','A','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.352620,-92.366700,0,'2013-07-06 12:44:33',NULL,NULL),(40521,'45826','P','Celina','A','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.434324,-84.493555,0,'2013-07-06 12:44:32',NULL,NULL),(17632,'18058','S','Kunkletown','D','Monroe','42089','Pennsylvania','PA','42','0000','610/484','Eastern',-5.0,'Y',40.930437,-75.478013,0,'2013-07-06 12:44:31',NULL,NULL),(47756,'55026','S','Frontenac','D','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.498086,-92.359643,0,'2013-07-06 12:44:33',NULL,NULL),(23425,'25361','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.363963,-81.552006,0,'2013-07-06 12:44:31',NULL,NULL),(5745,'05035','S','Bridgewtr Ct','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(13606,'13859','S','Wells Bridge','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.363079,-75.249368,0,'2013-07-06 12:44:31',NULL,NULL),(57342,'66724','S','Cherokee','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.342470,-94.830186,0,'2013-07-06 12:44:33',NULL,NULL),(52235,'60503','S','Aurora','D','Will','17197','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.719900,-88.254800,0,'2013-07-06 12:44:33',NULL,NULL),(36416,'40536','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.030056,-84.507951,0,'2013-07-06 12:44:32',NULL,NULL),(27715,'30343','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.753835,-84.392167,0,'2013-07-06 12:44:31',NULL,NULL),(4825,'03908','S','So Berwick','N','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.230935,-70.783559,0,'2013-07-06 12:44:30',NULL,NULL),(9278,'09625','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(56378,'65231','S','Bachelor','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.015325,-91.894565,0,'2013-07-06 12:44:33',NULL,NULL),(29183,'32395','U','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430504,-84.258788,0,'2013-07-06 12:44:32',NULL,NULL),(5142,'04415','P','Brownvlle JCT','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.349887,-69.058546,0,'2013-07-06 12:44:30',NULL,NULL),(24217,'26711','S','Capon Bridge','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.270713,-78.496923,0,'2013-07-06 12:44:31',NULL,NULL),(80074,'99730','P','Central','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.345564,-145.140260,0,'2013-07-06 12:44:34',NULL,NULL),(74523,'92652','P','Playa','N','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.543004,-117.781451,0,'2013-07-06 12:44:34',NULL,NULL),(67246,'79945','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761453,-106.479316,0,'2013-07-06 12:44:34',NULL,NULL),(57478,'66871','S','Waverly','D','Coffey','20031','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.387387,-95.596753,0,'2013-07-06 12:44:33',NULL,NULL),(70621,'85130','P','Casa Grande','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.879539,-111.750320,0,'2013-07-06 12:44:34',NULL,NULL),(70105,'84171','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(11716,'12173','S','Stuyvesant','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.344820,-73.756440,0,'2013-07-06 12:44:30',NULL,NULL),(44619,'50061','S','Cumming','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.489268,-93.753860,0,'2013-07-06 12:44:32',NULL,NULL),(46243,'52809','P','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.560101,-90.632535,0,'2013-07-06 12:44:32',NULL,NULL),(13973,'14479','S','Knowlesville','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.237153,-78.309111,0,'2013-07-06 12:44:31',NULL,NULL),(9881,'10123','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(10428,'10803','S','Pelham','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.905342,-73.804941,0,'2013-07-06 12:44:30',NULL,NULL),(28111,'30805','S','Ellwood','N','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.344593,-82.127389,0,'2013-07-06 12:44:31',NULL,NULL),(28948,'32185','P','Putnam Hall','D','Putnam','12107','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.730954,-81.957365,0,'2013-07-06 12:44:32',NULL,NULL),(21952,'23234','S','North Chesterfield','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.452407,-77.476225,0,'2013-07-06 12:44:31',NULL,NULL),(73095,'90224','P','Rncho Domingz','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.871965,-118.266771,0,'2013-07-06 12:44:34',NULL,NULL),(7196,'06477','S','Orange','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.282126,-73.025810,0,'2013-07-06 12:44:30',NULL,NULL),(212,'00624','S','Brisas de Guayanes','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(9091,'09054','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3772,'02190','S','Weymouth','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.171028,-70.948119,0,'2013-07-06 12:44:30',NULL,NULL),(79572,'99020','P','Marshall','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.565332,-117.490826,0,'2013-07-06 12:44:34',NULL,NULL),(60509,'71666','P','Mc Gehee','A','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.659552,-91.194003,0,'2013-07-06 12:44:33',NULL,NULL),(66104,'78410','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.837609,-97.590692,0,'2013-07-06 12:44:34',NULL,NULL),(28975,'32209','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355851,-81.694137,0,'2013-07-06 12:44:32',NULL,NULL),(57197,'66425','S','Fairview','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.848405,-95.704379,0,'2013-07-06 12:44:33',NULL,NULL),(7694,'07107','S','Roseville','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.759519,-74.190730,0,'2013-07-06 12:44:30',NULL,NULL),(36863,'41086','S','Sparta','D','Gallatin','21077','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.722967,-84.887273,0,'2013-07-06 12:44:32',NULL,NULL),(71161,'86039','P','Dennebito','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(65458,'77617','P','Gilchrist','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.511982,-94.490314,0,'2013-07-06 12:44:34',NULL,NULL),(50208,'57577','S','Hiles','N','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.551517,-101.805742,0,'2013-07-06 12:44:33',NULL,NULL),(4141,'02760','S','No Attleboro','N','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.977034,-71.324788,0,'2013-07-06 12:44:30',NULL,NULL),(54631,'62919','S','Lamb','N','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.539067,-88.238667,0,'2013-07-06 12:44:33',NULL,NULL),(19924,'20557','U','Lib of Congress Licensing','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880368,-76.990661,0,'2013-07-06 12:44:31',NULL,NULL),(52477,'60689','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.850211,-87.652468,0,'2013-07-06 12:44:33',NULL,NULL),(41479,'46932','S','Galveston','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.576797,-86.195393,0,'2013-07-06 12:44:32',NULL,NULL),(46367,'53120','S','East Troy','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.803402,-88.415506,0,'2013-07-06 12:44:32',NULL,NULL),(74899,'93304','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.349850,-119.024721,0,'2013-07-06 12:44:34',NULL,NULL),(17229,'17833','P','Kreamer','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.803174,-76.964675,0,'2013-07-06 12:44:31',NULL,NULL),(20298,'20813','P','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.984105,-77.080215,0,'2013-07-06 12:44:31',NULL,NULL),(54106,'62543','S','Latham','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.967567,-89.164007,0,'2013-07-06 12:44:33',NULL,NULL),(12853,'13317','S','Marshville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(4909,'04068','S','Porter','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.841790,-70.943960,0,'2013-07-06 12:44:30',NULL,NULL),(21489,'22652','S','Seven Fountains','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.842058,-78.419588,0,'2013-07-06 12:44:31',NULL,NULL),(30976,'33743','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.782429,-82.727623,0,'2013-07-06 12:44:32',NULL,NULL),(67739,'80601','S','Brighton','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.964059,-104.817375,0,'2013-07-06 12:44:34',NULL,NULL),(15553,'16629','S','Coupon','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.537592,-78.513159,0,'2013-07-06 12:44:31',NULL,NULL),(64343,'76513','S','Morgans Point Resort','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.097391,-97.467293,0,'2013-07-06 12:44:34',NULL,NULL),(62695,'74733','S','Colbert','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.858023,-96.505622,0,'2013-07-06 12:44:33',NULL,NULL),(16446,'17236','S','Mercersburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(39739,'45069','S','Liberty Townshp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.341460,-84.398674,0,'2013-07-06 12:44:32',NULL,NULL),(2078,'00921','S','Urb College Park IV','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(12035,'12520','S','Cornwall on Hudson','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.442299,-74.015486,0,'2013-07-06 12:44:30',NULL,NULL),(25801,'28607','S','Adams','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(13326,'13680','S','Rensselaer Falls','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.591957,-75.320308,0,'2013-07-06 12:44:30',NULL,NULL),(43556,'48721','S','Black River','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.796699,-83.324416,0,'2013-07-06 12:44:32',NULL,NULL),(10951,'11451','U','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699605,-73.799982,0,'2013-07-06 12:44:30',NULL,NULL),(13700,'14059','S','Elma','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.831055,-78.639808,0,'2013-07-06 12:44:31',NULL,NULL),(20381,'20886','S','Gaithersburg','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.170940,-77.209500,0,'2013-07-06 12:44:31',NULL,NULL),(49858,'57247','S','Lake City','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.698550,-97.352584,0,'2013-07-06 12:44:33',NULL,NULL),(14323,'14903','S','Elmira Hts','A','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.127740,-76.869660,0,'2013-07-06 12:44:31',NULL,NULL),(36340,'40404','U','Berea','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.568461,-84.292823,0,'2013-07-06 12:44:32',NULL,NULL),(2309,'00927','S','Urb University Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(6963,'06234','S','BKLN','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.785357,-71.954821,0,'2013-07-06 12:44:30',NULL,NULL),(31939,'35188','S','Woodstock','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.168372,-87.170225,0,'2013-07-06 12:44:32',NULL,NULL),(25299,'28144','S','Salisbury','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.664520,-80.474091,0,'2013-07-06 12:44:31',NULL,NULL),(45887,'52302','S','Indian Creek','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.043431,-91.593062,0,'2013-07-06 12:44:32',NULL,NULL),(956,'00716','S','Repto Anaida','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(23403,'25323','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352773,-81.631772,0,'2013-07-06 12:44:31',NULL,NULL),(70320,'84624','S','Delta','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(72848,'89835','S','Thousand Springs','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(72555,'89301','S','Currie','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(70420,'84728','S','Bethel','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.935110,-114.034510,0,'2013-07-06 12:44:34',NULL,NULL),(22952,'24651','S','Maxwell','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.114440,-81.522480,0,'2013-07-06 12:44:31',NULL,NULL),(51709,'60010','S','Barrington','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(54827,'63025','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(37144,'41465','S','Hager','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(31759,'34996','S','Sewalls Point','A','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.194129,-80.206393,0,'2013-07-06 12:44:32',NULL,NULL),(46978,'54217','S','Luxemburg','D','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.594160,-87.715920,0,'2013-07-06 12:44:32',NULL,NULL),(3400,'01654','U','Verizon','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.269010,-71.809164,0,'2013-07-06 12:44:30',NULL,NULL),(77249,'96543','M','FPO','A','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72897,'90019','S','Rimpau','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.048281,-118.342487,0,'2013-07-06 12:44:34',NULL,NULL),(15390,'16326','S','Fryburg','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.367227,-79.415303,0,'2013-07-06 12:44:31',NULL,NULL),(24952,'27831','S','Gumberry','A','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.474201,-77.596465,0,'2013-07-06 12:44:31',NULL,NULL),(53582,'62063','S','Medora','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.205251,-90.162210,0,'2013-07-06 12:44:33',NULL,NULL),(37683,'42220','S','Elkton','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.874485,-87.176140,0,'2013-07-06 12:44:32',NULL,NULL),(15895,'17007','S','Boiling Springs','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.147806,-77.116428,0,'2013-07-06 12:44:31',NULL,NULL),(34113,'38184','P','Bartlett','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.185496,-89.864856,0,'2013-07-06 12:44:32',NULL,NULL),(4458,'03255','S','Mt Sunapee','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.320148,-72.027840,0,'2013-07-06 12:44:30',NULL,NULL),(78081,'97471','S','Roseburg','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.223734,-123.367345,0,'2013-07-06 12:44:34',NULL,NULL),(11794,'12222','U','S U N Y','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.693234,-73.838124,0,'2013-07-06 12:44:30',NULL,NULL),(299,'00646','S','Urb Golden Hls','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(53060,'61491','S','Wyoming','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.066868,-89.788960,0,'2013-07-06 12:44:33',NULL,NULL),(16988,'17728','S','Fairlawn','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(59872,'71266','S','Pioneer','D','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.709261,-91.482032,0,'2013-07-06 12:44:33',NULL,NULL),(63471,'75686','S','Harvard','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(70356,'84645','S','Rocky Ridge','A','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.819573,-111.852966,0,'2013-07-06 12:44:34',NULL,NULL),(69409,'83627','S','Indian Cove','N','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.977016,-115.564362,0,'2013-07-06 12:44:34',NULL,NULL),(68124,'80951','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837139,-104.795539,0,'2013-07-06 12:44:34',NULL,NULL),(4181,'02814','S','Glocester','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.898850,-71.681285,0,'2013-07-06 12:44:30',NULL,NULL),(18493,'19093','U','Firm Zip Concept (Courtesy)','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955914,-75.182383,0,'2013-07-06 12:44:31',NULL,NULL),(13586,'13847','P','Trout Creek','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.206605,-75.279590,0,'2013-07-06 12:44:31',NULL,NULL),(28339,'31192','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.623867,-84.534721,0,'2013-07-06 12:44:32',NULL,NULL),(52739,'61238','S','Munson','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.305313,-90.190486,0,'2013-07-06 12:44:33',NULL,NULL),(28314,'31139','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.748107,-84.384924,0,'2013-07-06 12:44:31',NULL,NULL),(37700,'42259','S','Mammoth Cave','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.284708,-86.189466,0,'2013-07-06 12:44:32',NULL,NULL),(59369,'70585','P','Turkey Creek','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.678169,-92.279405,0,'2013-07-06 12:44:33',NULL,NULL),(66276,'78580','S','Santa Monica','N','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.481214,-97.783570,0,'2013-07-06 12:44:34',NULL,NULL),(54772,'62994','S','Oraville','A','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.910383,-89.321947,0,'2013-07-06 12:44:33',NULL,NULL),(33259,'37086','S','La Vergne','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.013661,-86.565021,0,'2013-07-06 12:44:32',NULL,NULL),(35246,'39338','S','Louin','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.122380,-89.229600,0,'2013-07-06 12:44:32',NULL,NULL),(63362,'75639','S','Horton','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.250480,-94.139400,0,'2013-07-06 12:44:33',NULL,NULL),(49973,'57355','S','Lyonville','N','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.716989,-98.934980,0,'2013-07-06 12:44:33',NULL,NULL),(77151,'96162','P','Truckee','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.307577,-120.314785,0,'2013-07-06 12:44:34',NULL,NULL),(62029,'73487','P','Tatums','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.479887,-97.459668,0,'2013-07-06 12:44:33',NULL,NULL),(5349,'04611','P','Beals','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.488403,-67.587958,0,'2013-07-06 12:44:30',NULL,NULL),(3454,'01775','S','Stow','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.423402,-71.514638,0,'2013-07-06 12:44:30',NULL,NULL),(24719,'27509','S','Butner','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.138357,-78.757582,0,'2013-07-06 12:44:31',NULL,NULL),(505,'00674','S','Jard de Monaco 3','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(56113,'64801','S','Lakeside','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(55783,'64119','S','Claycomo','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.208712,-94.518737,0,'2013-07-06 12:44:33',NULL,NULL),(25603,'28454','S','Maple Hill','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.600327,-77.767276,0,'2013-07-06 12:44:31',NULL,NULL),(10097,'10242','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715181,-74.009474,0,'2013-07-06 12:44:30',NULL,NULL),(11755,'12193','S','Westerlo','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540237,-74.045892,0,'2013-07-06 12:44:30',NULL,NULL),(54865,'63050','S','Hillsboro','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.266141,-90.565313,0,'2013-07-06 12:44:33',NULL,NULL),(71075,'85920','S','Alpine','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.815834,-109.202378,0,'2013-07-06 12:44:34',NULL,NULL),(53052,'61484','S','Vermont','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.294595,-90.430475,0,'2013-07-06 12:44:33',NULL,NULL),(61065,'72124','P','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.811333,-92.234881,0,'2013-07-06 12:44:33',NULL,NULL),(60715,'71953','S','Ink','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(49348,'56571','S','Ottertail','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.410156,-95.533267,0,'2013-07-06 12:44:33',NULL,NULL),(41208,'46725','S','Raber','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(34289,'38501','S','Algood','A','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.199620,-85.522740,0,'2013-07-06 12:44:32',NULL,NULL),(21096,'22040','P','Falls Church','D','Falls Church City','51610','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.885693,-77.171231,0,'2013-07-06 12:44:31',NULL,NULL),(60807,'72031','S','Plant','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(67308,'80021','S','Westminster','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.883964,-105.106613,0,'2013-07-06 12:44:34',NULL,NULL),(67878,'80840','S','US Air Force','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.999759,-104.695596,0,'2013-07-06 12:44:34',NULL,NULL),(8038,'07732','S','Highlands','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.399752,-73.997462,0,'2013-07-06 12:44:30',NULL,NULL),(76500,'95637','S','Guinda','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.810295,-122.220323,0,'2013-07-06 12:44:34',NULL,NULL),(68882,'82701','S','Newcastle','D','Weston','56045','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.834953,-104.292024,0,'2013-07-06 12:44:34',NULL,NULL),(17980,'18618','S','Harveys Lake','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.341140,-76.017214,0,'2013-07-06 12:44:31',NULL,NULL),(20560,'21131','S','Jacksonville','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.501074,-76.573561,0,'2013-07-06 12:44:31',NULL,NULL),(12780,'13214','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.036965,-76.073608,0,'2013-07-06 12:44:30',NULL,NULL),(49763,'57068','S','Valley Spgs','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.582880,-96.464847,0,'2013-07-06 12:44:33',NULL,NULL),(39847,'45167','S','Ripley','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.762237,-83.812847,0,'2013-07-06 12:44:32',NULL,NULL),(63149,'75378','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.892085,-96.873247,0,'2013-07-06 12:44:33',NULL,NULL),(31094,'33876','S','Sebring','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.441087,-81.358870,0,'2013-07-06 12:44:32',NULL,NULL),(25284,'28133','S','White Store','N','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.017385,-80.263528,0,'2013-07-06 12:44:31',NULL,NULL),(59801,'71222','S','Shiloh','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.830800,-92.643420,0,'2013-07-06 12:44:33',NULL,NULL),(79243,'98557','S','Hillgrove','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.053140,-123.286440,0,'2013-07-06 12:44:34',NULL,NULL),(2391,'00949','S','Urb Levittville','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(59257,'70445','S','Lacombe','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.338855,-89.905927,0,'2013-07-06 12:44:33',NULL,NULL),(36212,'40280','U','So Baptist Theo Sem','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.247902,-85.684110,0,'2013-07-06 12:44:32',NULL,NULL),(78748,'98292','S','Camano City','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.179280,-122.371440,0,'2013-07-06 12:44:34',NULL,NULL),(66368,'78618','S','Doss','D','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.469922,-99.146186,0,'2013-07-06 12:44:34',NULL,NULL),(63887,'76015','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.692305,-97.133908,0,'2013-07-06 12:44:34',NULL,NULL),(62743,'74834','S','Chandler','D','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.705912,-96.884924,0,'2013-07-06 12:44:33',NULL,NULL),(42226,'47562','S','Odon','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.842918,-86.990039,0,'2013-07-06 12:44:32',NULL,NULL),(26834,'29492','S','Cainhoy','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.955719,-79.887276,0,'2013-07-06 12:44:31',NULL,NULL),(40133,'45336','P','Kettlersville','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.441376,-84.261648,0,'2013-07-06 12:44:32',NULL,NULL),(24965,'27842','S','Henrico','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.524061,-77.869673,0,'2013-07-06 12:44:31',NULL,NULL),(45702,'52057','S','Manchester','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.485840,-91.458289,0,'2013-07-06 12:44:32',NULL,NULL),(458,'00662','S','Villa Lydia','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(47725,'55008','S','Edgewood','N','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.562400,-93.228686,0,'2013-07-06 12:44:33',NULL,NULL),(59050,'70086','S','Saint James','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',29.970697,-90.862644,0,'2013-07-06 12:44:33',NULL,NULL),(8676,'08329','P','Mauricetown','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.286753,-74.997363,0,'2013-07-06 12:44:30',NULL,NULL),(32671,'36265','S','Jacksonville','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.831372,-85.779123,0,'2013-07-06 12:44:32',NULL,NULL),(57695,'67301','S','Independence','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.225582,-95.713959,0,'2013-07-06 12:44:33',NULL,NULL),(53594,'62074','S','New Douglas','D','Madison','17119','Illinois','IL','17','7040','217','Central',-6.0,'Y',38.966208,-89.691628,0,'2013-07-06 12:44:33',NULL,NULL),(26616,'29306','S','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.928003,-81.908736,0,'2013-07-06 12:44:31',NULL,NULL),(48828,'56041','S','Hanska','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.152100,-94.493356,0,'2013-07-06 12:44:33',NULL,NULL),(57252,'66534','S','Sabetha','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.901237,-95.797438,0,'2013-07-06 12:44:33',NULL,NULL),(74750,'93062','P','Simi Valley','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.287844,-118.741018,0,'2013-07-06 12:44:34',NULL,NULL),(74130,'92241','S','Dsrt Hot Spgs','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.899772,-116.390191,0,'2013-07-06 12:44:34',NULL,NULL),(20494,'21060','S','Glen Burnie','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.164559,-76.583398,0,'2013-07-06 12:44:31',NULL,NULL),(25810,'28607','S','Rutherwood','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(26996,'29627','S','Belton','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.517182,-82.501649,0,'2013-07-06 12:44:31',NULL,NULL),(65664,'77979','S','Port Alto','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(20771,'21522','S','Bittinger','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.588111,-79.202770,0,'2013-07-06 12:44:31',NULL,NULL),(20910,'21720','P','Cavetown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.642371,-77.582852,0,'2013-07-06 12:44:31',NULL,NULL),(22294,'23806','U','Virginia State Univ','N','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.226377,-77.403086,0,'2013-07-06 12:44:31',NULL,NULL),(52911,'61364','S','Missal','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(32552,'36112','S','Maxwell AFB','A','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.366580,-86.299980,0,'2013-07-06 12:44:32',NULL,NULL),(51858,'60074','S','Deer Park','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.145690,-88.027592,0,'2013-07-06 12:44:33',NULL,NULL),(43721,'48918','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.674828,-84.678438,0,'2013-07-06 12:44:32',NULL,NULL),(44874,'50312','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.586911,-93.675689,0,'2013-07-06 12:44:32',NULL,NULL),(80120,'99763','P','Noorvik','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.854813,-159.873232,0,'2013-07-06 12:44:34',NULL,NULL),(77973,'97378','S','Sheridan','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.116608,-123.394851,0,'2013-07-06 12:44:34',NULL,NULL),(48222,'55416','S','St Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.948525,-93.344253,0,'2013-07-06 12:44:33',NULL,NULL),(10626,'11051','U','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.841029,-73.694052,0,'2013-07-06 12:44:30',NULL,NULL),(6368,'05677','S','Waterbury Ctr','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.392439,-72.715938,0,'2013-07-06 12:44:30',NULL,NULL),(20036,'20640','S','Pisgah','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.572080,-77.152920,0,'2013-07-06 12:44:31',NULL,NULL),(63649,'75845','S','Groveton','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(9653,'10038','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(71509,'87114','S','Los Ranchos','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(11220,'11747','S','Huntington Station','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.803692,-73.402157,0,'2013-07-06 12:44:30',NULL,NULL),(20010,'20616','S','Bryans Rd','N','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.648082,-77.084535,0,'2013-07-06 12:44:31',NULL,NULL),(38585,'43804','S','Farmerstown','A','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.463509,-81.734242,0,'2013-07-06 12:44:32',NULL,NULL),(52379,'60624','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.877445,-87.723846,0,'2013-07-06 12:44:33',NULL,NULL),(20723,'21284','P','Loch Raven','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.399688,-76.599200,0,'2013-07-06 12:44:31',NULL,NULL),(5758,'05040','S','East Corinth','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.056109,-72.206479,0,'2013-07-06 12:44:30',NULL,NULL),(69979,'84121','S','Brighton','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(57690,'67275','P','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.674977,-97.445146,0,'2013-07-06 12:44:33',NULL,NULL),(75155,'93562','S','Trona','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.754736,-117.385894,0,'2013-07-06 12:44:34',NULL,NULL),(16379,'17202','S','Guilford Twp','A','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.941877,-77.673910,0,'2013-07-06 12:44:31',NULL,NULL),(42531,'47861','S','Gill','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.014376,-87.525993,0,'2013-07-06 12:44:32',NULL,NULL),(53381,'61799','U','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.428470,-88.986910,0,'2013-07-06 12:44:33',NULL,NULL),(53743,'62255','S','Lenzburg','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.312685,-89.764727,0,'2013-07-06 12:44:33',NULL,NULL),(51664,'59912','S','Columbia Fls','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.365309,-114.192688,0,'2013-07-06 12:44:33',NULL,NULL),(35382,'39455','S','Lumberton','D','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(33462,'37324','S','Decherd','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.207332,-86.082483,0,'2013-07-06 12:44:32',NULL,NULL),(50188,'57567','S','Hilland','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.039632,-101.663435,0,'2013-07-06 12:44:33',NULL,NULL),(22822,'24502','S','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.359789,-79.218967,0,'2013-07-06 12:44:31',NULL,NULL),(43244,'48317','S','Utica','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.647050,-83.049668,0,'2013-07-06 12:44:32',NULL,NULL),(70156,'84314','S','Honeyville','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.641228,-112.090819,0,'2013-07-06 12:44:34',NULL,NULL),(138,'00617','S','Brisas del Monte','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(35903,'40013','S','Lenore','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.917352,-85.501392,0,'2013-07-06 12:44:32',NULL,NULL),(67055,'79556','S','Claytonville','N','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.465940,-100.386240,0,'2013-07-06 12:44:34',NULL,NULL),(61689,'72945','P','Midland','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.106879,-94.363723,0,'2013-07-06 12:44:33',NULL,NULL),(25831,'28617','S','Shatley Springs','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.460860,-81.413640,0,'2013-07-06 12:44:31',NULL,NULL),(48037,'55305','S','Minnetonka','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952480,-93.426660,0,'2013-07-06 12:44:33',NULL,NULL),(17533,'17974','P','Seltzer','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696244,-76.234875,0,'2013-07-06 12:44:31',NULL,NULL),(6176,'05474','S','Birdland','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(51527,'59714','S','Belgrade','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.816111,-111.161003,0,'2013-07-06 12:44:33',NULL,NULL),(15056,'15722','S','Carrolltown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.595688,-78.706957,0,'2013-07-06 12:44:31',NULL,NULL),(24467,'27239','S','Denton','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(17880,'18441','S','Nicholson','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.665200,-75.643680,0,'2013-07-06 12:44:31',NULL,NULL),(61228,'72327','S','Jericho','N','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.207580,-90.343980,0,'2013-07-06 12:44:33',NULL,NULL),(13589,'13849','S','Youngs','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.323762,-75.319978,0,'2013-07-06 12:44:31',NULL,NULL),(4992,'04210','S','Auburn','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.094188,-70.244511,0,'2013-07-06 12:44:30',NULL,NULL),(32152,'35468','P','Searles','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.338804,-87.302401,0,'2013-07-06 12:44:32',NULL,NULL),(56011,'64654','P','Lock Springs','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.903622,-93.817115,0,'2013-07-06 12:44:33',NULL,NULL),(57379,'66749','S','Bassett','N','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.926480,-95.402820,0,'2013-07-06 12:44:33',NULL,NULL),(32954,'36582','S','Saltaire','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.532137,-88.179287,0,'2013-07-06 12:44:32',NULL,NULL),(13731,'14101','S','Machias','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.407012,-78.517340,0,'2013-07-06 12:44:31',NULL,NULL),(23275,'25152','P','Page','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.052053,-81.270363,0,'2013-07-06 12:44:31',NULL,NULL),(65581,'77865','S','Marquez','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.220641,-96.236902,0,'2013-07-06 12:44:34',NULL,NULL),(69371,'83604','S','Grasmere','A','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.681724,-115.929733,0,'2013-07-06 12:44:34',NULL,NULL),(2259,'00926','S','Urb Monterey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(32869,'36521','S','Turnerville','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.974220,-88.126860,0,'2013-07-06 12:44:32',NULL,NULL),(26609,'29302','S','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.957122,-81.863011,0,'2013-07-06 12:44:31',NULL,NULL),(64069,'76137','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.859978,-97.293430,0,'2013-07-06 12:44:34',NULL,NULL),(26722,'29417','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.786797,-80.032618,0,'2013-07-06 12:44:31',NULL,NULL),(6967,'06235','S','Mansfield Ctr','A','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.808838,-72.115007,0,'2013-07-06 12:44:30',NULL,NULL),(50874,'58528','S','Cannon Ball','D','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.378635,-100.614493,0,'2013-07-06 12:44:33',NULL,NULL),(9704,'10060','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748746,-73.997962,0,'2013-07-06 12:44:30',NULL,NULL),(14184,'14748','S','Killbuck','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.149646,-78.639987,0,'2013-07-06 12:44:31',NULL,NULL),(55435,'63670','S','New Offenburg','A','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(31071,'33853','S','Lake Wales','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.903462,-81.534572,0,'2013-07-06 12:44:32',NULL,NULL),(43271,'48330','P','Drayton Plns','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.683616,-83.377192,0,'2013-07-06 12:44:32',NULL,NULL),(8526,'08107','S','West Collingswood','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(12221,'12809','S','Argyle','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.236780,-73.456980,0,'2013-07-06 12:44:30',NULL,NULL),(18577,'19129','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.010366,-75.183597,0,'2013-07-06 12:44:31',NULL,NULL),(15514,'16522','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.125235,-80.080625,0,'2013-07-06 12:44:31',NULL,NULL),(73126,'90267','P','Manhattan Bch','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.874322,-118.395460,0,'2013-07-06 12:44:34',NULL,NULL),(3588,'02020','P','Brant Rock','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.083980,-70.649731,0,'2013-07-06 12:44:30',NULL,NULL),(61703,'73001','P','Albert','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.239299,-98.424106,0,'2013-07-06 12:44:33',NULL,NULL),(23922,'26228','S','Kanawha Head','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.763200,-80.372307,0,'2013-07-06 12:44:31',NULL,NULL),(49525,'56676','S','Bear Creek','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.383450,-95.232970,0,'2013-07-06 12:44:33',NULL,NULL),(52559,'60953','S','Milford','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.644326,-87.696895,0,'2013-07-06 12:44:33',NULL,NULL),(54262,'62677','S','Pleasant Plains','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.875106,-89.916317,0,'2013-07-06 12:44:33',NULL,NULL),(28357,'31204','S','Payne City','A','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.842317,-83.677163,0,'2013-07-06 12:44:32',NULL,NULL),(12064,'12540','S','Lagrangeville','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.668320,-73.743900,0,'2013-07-06 12:44:30',NULL,NULL),(39317,'44601','S','Alliance','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.918936,-81.135368,0,'2013-07-06 12:44:32',NULL,NULL),(40240,'45424','S','Huber Heights','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.845640,-84.111720,0,'2013-07-06 12:44:32',NULL,NULL),(13423,'13756','S','Burnwood','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.023889,-75.113056,0,'2013-07-06 12:44:31',NULL,NULL),(12879,'13326','S','Hrtwk Seminry','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.716131,-74.906704,0,'2013-07-06 12:44:30',NULL,NULL),(51066,'58750','S','Lockwood','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617118,-101.405976,0,'2013-07-06 12:44:33',NULL,NULL),(6811,'06110','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(30457,'33334','S','Wilton Manors','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181067,-80.138938,0,'2013-07-06 12:44:32',NULL,NULL),(31713,'34954','P','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.451083,-80.338885,0,'2013-07-06 12:44:32',NULL,NULL),(37097,'41339','S','Wolf Coal','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(307,'00646','S','Urb Monte Elena','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(23834,'26106','U','Bureau of Public Debt','N','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.324681,-81.500999,0,'2013-07-06 12:44:31',NULL,NULL),(24069,'26435','P','Simpson','D','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.283409,-80.066534,0,'2013-07-06 12:44:31',NULL,NULL),(15665,'16802','S','University Park','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.870717,-77.834150,0,'2013-07-06 12:44:31',NULL,NULL),(15560,'16637','S','E Freedom','N','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.335097,-78.432871,0,'2013-07-06 12:44:31',NULL,NULL),(79452,'98847','S','Peshastin','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.554589,-120.601631,0,'2013-07-06 12:44:34',NULL,NULL),(2859,'00985','S','Bo Villa Caridad','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(75799,'94801','S','N Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.942278,-122.355347,0,'2013-07-06 12:44:34',NULL,NULL),(4702,'03815','P','Center Strafford','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.258263,-71.115091,0,'2013-07-06 12:44:30',NULL,NULL),(33506,'37363','S','Ooltewah','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.087036,-85.060075,0,'2013-07-06 12:44:32',NULL,NULL),(71512,'87114','S','Los Rnchs Abq','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(69782,'84060','S','Park City','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.697533,-111.526589,0,'2013-07-06 12:44:34',NULL,NULL),(67565,'80294','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.753064,-104.990775,0,'2013-07-06 12:44:34',NULL,NULL),(25039,'27907','P','Elizabeth City','D','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.292677,-76.221442,0,'2013-07-06 12:44:31',NULL,NULL),(8253,'08008','S','Beach Haven','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(2324,'00931','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409826,-66.062956,0,'2013-07-06 12:44:30',NULL,NULL),(11364,'11854','U','Hicksville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.753879,-73.503300,0,'2013-07-06 12:44:30',NULL,NULL),(44855,'50274','S','Wiota','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.402820,-94.889868,0,'2013-07-06 12:44:32',NULL,NULL),(17073,'17758','S','Muncy Valley','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(65564,'77844','P','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.610719,-96.354731,0,'2013-07-06 12:44:34',NULL,NULL),(80085,'99738','P','Eagle','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.789177,-141.202941,0,'2013-07-06 12:44:34',NULL,NULL),(8080,'07755','S','Oakhurst','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.264603,-74.023335,0,'2013-07-06 12:44:30',NULL,NULL),(68444,'81225','P','Riverbend','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(61149,'72170','P','Ulm','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.576457,-91.531458,0,'2013-07-06 12:44:33',NULL,NULL),(60551,'71728','P','Curtis','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.997111,-93.108204,0,'2013-07-06 12:44:33',NULL,NULL),(16684,'17366','S','Bittersville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.923540,-76.574778,0,'2013-07-06 12:44:31',NULL,NULL),(30776,'33583','P','Seffner','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.999870,-82.277661,0,'2013-07-06 12:44:32',NULL,NULL),(52120,'60426','S','Harvey','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.604606,-87.669030,0,'2013-07-06 12:44:33',NULL,NULL),(33789,'37879','S','Tazewell','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.445486,-83.583830,0,'2013-07-06 12:44:32',NULL,NULL),(29943,'33068','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.216234,-80.216437,0,'2013-07-06 12:44:32',NULL,NULL),(71403,'87014','S','Cubero','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.112342,-107.506934,0,'2013-07-06 12:44:34',NULL,NULL),(24989,'27860','S','Pantego','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.632234,-76.714103,0,'2013-07-06 12:44:31',NULL,NULL),(20787,'21541','S','Mc Henry','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.556671,-79.350980,0,'2013-07-06 12:44:31',NULL,NULL),(29634,'32891','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.556599,-81.349587,0,'2013-07-06 12:44:32',NULL,NULL),(72014,'88043','S','North Hurley','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.701595,-108.130863,0,'2013-07-06 12:44:34',NULL,NULL),(64967,'77254','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.732223,-95.413869,0,'2013-07-06 12:44:34',NULL,NULL),(25156,'28026','P','Concord','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.376128,-80.533682,0,'2013-07-06 12:44:31',NULL,NULL),(22426,'24010','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271505,-79.942336,0,'2013-07-06 12:44:31',NULL,NULL),(52526,'60918','S','Buckley','D','Iroquois','17075','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.597230,-88.039569,0,'2013-07-06 12:44:33',NULL,NULL),(2378,'00949','S','Urb Campanillas','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(54664,'62935','S','Galatia','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.844203,-88.609011,0,'2013-07-06 12:44:33',NULL,NULL),(47258,'54525','S','Gile','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.430060,-90.222289,0,'2013-07-06 12:44:32',NULL,NULL),(17956,'18518','S','Scranton','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.375757,-75.741012,0,'2013-07-06 12:44:31',NULL,NULL),(73917,'92022','P','El Cajon','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',32.730955,-116.912661,0,'2013-07-06 12:44:34',NULL,NULL),(3634,'02072','S','Stoughton','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.124896,-71.109196,0,'2013-07-06 12:44:30',NULL,NULL),(62486,'74354','S','Maimi','N','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.880147,-94.874310,0,'2013-07-06 12:44:33',NULL,NULL),(19741,'20406','U','GSA Crystal City','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.855860,-77.050730,0,'2013-07-06 12:44:31',NULL,NULL),(23942,'26267','S','Ellamore','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.941989,-80.088341,0,'2013-07-06 12:44:31',NULL,NULL),(33688,'37748','S','Harriman','D','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.942220,-84.500460,0,'2013-07-06 12:44:32',NULL,NULL),(6399,'05733','S','Leicester','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.798620,-73.094520,0,'2013-07-06 12:44:30',NULL,NULL),(3395,'01613','P','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.265737,-71.796527,0,'2013-07-06 12:44:30',NULL,NULL),(30201,'33181','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(9892,'10128','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(24837,'27614','S','North Hills','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.938157,-78.631847,0,'2013-07-06 12:44:31',NULL,NULL),(36771,'41042','S','Florence','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.986125,-84.648281,0,'2013-07-06 12:44:32',NULL,NULL),(75874,'94951','S','Penngrove','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.316000,-122.657980,0,'2013-07-06 12:44:34',NULL,NULL),(69743,'84046','S','Manila','D','Daggett','49009','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.992285,-109.715572,0,'2013-07-06 12:44:34',NULL,NULL),(68611,'81620','P','Beaver Creek','A','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.631320,-106.521600,0,'2013-07-06 12:44:34',NULL,NULL),(5041,'04261','S','Upton','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.570737,-70.882590,0,'2013-07-06 12:44:30',NULL,NULL),(54744,'62973','P','Perks','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.308548,-89.079704,0,'2013-07-06 12:44:33',NULL,NULL),(11363,'11853','U','Uhc Berdon','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786573,-73.542199,0,'2013-07-06 12:44:30',NULL,NULL),(12858,'13319','S','Chadwicks','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.023165,-75.269856,0,'2013-07-06 12:44:30',NULL,NULL),(31868,'35121','S','Straight Mountain','N','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.948154,-86.470543,0,'2013-07-06 12:44:32',NULL,NULL),(25453,'28327','S','Carthage','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.341320,-79.362480,0,'2013-07-06 12:44:31',NULL,NULL),(36932,'41164','S','Enterprise','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(65383,'77549','P','Friendswood','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.530347,-95.201732,0,'2013-07-06 12:44:34',NULL,NULL),(20998,'21826','S','Fruitland','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.322990,-75.623129,0,'2013-07-06 12:44:31',NULL,NULL),(24110,'26525','S','Bruceton MLS','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.646175,-79.624337,0,'2013-07-06 12:44:31',NULL,NULL),(37310,'41645','S','Langley','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.548556,-82.775409,0,'2013-07-06 12:44:32',NULL,NULL),(19571,'20212','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895371,-77.007528,0,'2013-07-06 12:44:31',NULL,NULL),(41655,'47141','S','Marysville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.550638,-85.597956,0,'2013-07-06 12:44:32',NULL,NULL),(68504,'81323','S','Dunton','N','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.455410,-108.516324,0,'2013-07-06 12:44:34',NULL,NULL),(54859,'63044','S','Hazelwood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.760780,-90.412860,0,'2013-07-06 12:44:33',NULL,NULL),(69794,'84065','S','Riverton','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.535262,-111.962723,0,'2013-07-06 12:44:34',NULL,NULL),(16633,'17334','U','Hanover','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.807897,-76.965787,0,'2013-07-06 12:44:31',NULL,NULL),(5329,'04576','S','Southport','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.816792,-69.663987,0,'2013-07-06 12:44:30',NULL,NULL),(45758,'52144','S','Festina','A','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.143605,-91.931990,0,'2013-07-06 12:44:32',NULL,NULL),(8138,'07836','S','Roxbury Twp','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.853244,-74.708204,0,'2013-07-06 12:44:30',NULL,NULL),(51699,'60005','S','Arlington Heights','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.065315,-87.983562,0,'2013-07-06 12:44:33',NULL,NULL),(31779,'35021','P','Bessemer','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.434295,-86.906053,0,'2013-07-06 12:44:32',NULL,NULL),(41037,'46391','S','Westville','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.551257,-86.899358,0,'2013-07-06 12:44:32',NULL,NULL),(25471,'28342','P','Falcon','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.187956,-78.651081,0,'2013-07-06 12:44:31',NULL,NULL),(79313,'98596','S','Winlock','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.496928,-122.919210,0,'2013-07-06 12:44:34',NULL,NULL),(65387,'77550','S','Virginia Point','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.301240,-94.788420,0,'2013-07-06 12:44:34',NULL,NULL),(59764,'71164','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.504198,-93.743651,0,'2013-07-06 12:44:33',NULL,NULL),(24778,'27563','S','Norlina','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.445548,-78.194509,0,'2013-07-06 12:44:31',NULL,NULL),(31059,'33841','S','Fort Meade','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.748263,-81.776231,0,'2013-07-06 12:44:32',NULL,NULL),(50212,'57579','S','Westover','N','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.564463,-100.748538,0,'2013-07-06 12:44:33',NULL,NULL),(49883,'57264','S','Stockholm','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.108718,-96.822810,0,'2013-07-06 12:44:33',NULL,NULL),(34330,'38563','S','Gordonsville','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.172586,-85.931293,0,'2013-07-06 12:44:32',NULL,NULL),(12379,'12916','S','Cooks Corners','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.827852,-74.530013,0,'2013-07-06 12:44:30',NULL,NULL),(33639,'37688','S','Shady Valley','D','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.545239,-81.884418,0,'2013-07-06 12:44:32',NULL,NULL),(18024,'18643','S','Exeter Township','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.328885,-75.815364,0,'2013-07-06 12:44:31',NULL,NULL),(38844,'44089','S','Vermilion on the Lake','N','Erie','39043','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.406313,-82.382678,0,'2013-07-06 12:44:32',NULL,NULL),(59987,'71327','S','Dora Bend','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.988947,-92.052747,0,'2013-07-06 12:44:33',NULL,NULL),(65187,'77420','S','Boling','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.267160,-95.944320,0,'2013-07-06 12:44:34',NULL,NULL),(2846,'00983','S','Urb Castellana Gdn','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(80187,'99901','S','Naukati Bay','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.373751,-131.692560,0,'2013-07-06 12:44:34',NULL,NULL),(79006,'98387','S','Elk Plain','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.077576,-122.396089,0,'2013-07-06 12:44:34',NULL,NULL),(66372,'78620','S','Henly','N','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250260,-98.120160,0,'2013-07-06 12:44:34',NULL,NULL),(79552,'99004','S','Cheney','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.439420,-117.627360,0,'2013-07-06 12:44:34',NULL,NULL),(75239,'93650','S','FRS','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.838859,-119.800966,0,'2013-07-06 12:44:34',NULL,NULL),(38773,'44052','S','Lorain','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.455994,-82.168713,0,'2013-07-06 12:44:32',NULL,NULL),(54643,'62924','S','De Soto','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.824180,-89.224860,0,'2013-07-06 12:44:33',NULL,NULL),(4532,'03440','S','Antrim','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.036836,-71.945973,0,'2013-07-06 12:44:30',NULL,NULL),(16992,'17728','S','Hepburnville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(51784,'60044','S','Knollwood','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.286331,-87.857964,0,'2013-07-06 12:44:33',NULL,NULL),(22109,'23424','P','Rescue','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.954334,-76.545889,0,'2013-07-06 12:44:31',NULL,NULL),(15389,'16323','S','Rocky Grove','N','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.384940,-79.813140,0,'2013-07-06 12:44:31',NULL,NULL),(5861,'05143','S','Middletown','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(38090,'43077','P','Unionvlle Ctr','A','Union','39159','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.138683,-83.338596,0,'2013-07-06 12:44:32',NULL,NULL),(33587,'37604','S','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.309556,-82.381176,0,'2013-07-06 12:44:32',NULL,NULL),(8418,'08075','S','Delanco','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(55798,'64130','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.032795,-94.545329,0,'2013-07-06 12:44:33',NULL,NULL),(29792,'33018','S','Hialeah Gdns','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.942320,-80.390400,0,'2013-07-06 12:44:32',NULL,NULL),(77775,'97123','S','Hillsboro','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.506393,-122.946368,0,'2013-07-06 12:44:34',NULL,NULL),(76431,'95589','S','Whitethorn','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.088692,-124.048710,0,'2013-07-06 12:44:34',NULL,NULL),(67803,'80737','S','Julesburg','D','Sedgwick','08115','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.883840,-102.185425,0,'2013-07-06 12:44:34',NULL,NULL),(62414,'74131','S','Tulsa','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.050360,-96.066439,0,'2013-07-06 12:44:33',NULL,NULL),(16830,'17552','S','Mount Joy','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(42645,'47930','S','Clarks Hill','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.244067,-86.729838,0,'2013-07-06 12:44:32',NULL,NULL),(19261,'19947','S','Georgetown','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.688020,-75.382138,0,'2013-07-06 12:44:31',NULL,NULL),(50129,'57529','S','Dixon','A','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.234545,-99.511640,0,'2013-07-06 12:44:33',NULL,NULL),(7101,'06360','S','Poquetanuck','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.550840,-72.027360,0,'2013-07-06 12:44:30',NULL,NULL),(23845,'26136','S','Five Forks','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.987064,-81.139494,0,'2013-07-06 12:44:31',NULL,NULL),(57468,'66861','S','Marion','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.348861,-97.015964,0,'2013-07-06 12:44:33',NULL,NULL),(5017,'04231','S','Stoneham','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.252980,-70.886744,0,'2013-07-06 12:44:30',NULL,NULL),(8163,'07860','S','Fredon Township','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.036057,-74.764550,0,'2013-07-06 12:44:30',NULL,NULL),(10550,'11001','S','Bellerose Village','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(38276,'43322','P','Green Camp','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.535490,-83.214701,0,'2013-07-06 12:44:32',NULL,NULL),(4402,'03221','S','Bradford','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.305780,-71.988731,0,'2013-07-06 12:44:30',NULL,NULL),(69508,'83714','S','Hidden Springs','A','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.641900,-116.293500,0,'2013-07-06 12:44:34',NULL,NULL),(74433,'92564','P','Murrieta Hot Springs','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.641779,-117.186255,0,'2013-07-06 12:44:34',NULL,NULL),(68221,'81050','S','Fort Bent','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(62548,'74437','S','Hoffman','A','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(59568,'70837','P','Central','A','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.550769,-91.203604,0,'2013-07-06 12:44:33',NULL,NULL),(24628,'27358','S','Summerfield','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.202103,-79.896120,0,'2013-07-06 12:44:31',NULL,NULL),(40194,'45382','S','West Manchester','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.898244,-84.621194,0,'2013-07-06 12:44:32',NULL,NULL),(10399,'10604','S','West Harrison','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.035020,-73.743600,0,'2013-07-06 12:44:30',NULL,NULL),(10329,'10548','S','Montrose','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.247304,-73.934623,0,'2013-07-06 12:44:30',NULL,NULL),(26396,'29105','S','Monetta','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.759336,-81.558390,0,'2013-07-06 12:44:31',NULL,NULL),(35017,'39152','S','Pulaski','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.273915,-89.635116,0,'2013-07-06 12:44:32',NULL,NULL),(76129,'95248','P','Rail Road Flat','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.315924,-120.516711,0,'2013-07-06 12:44:34',NULL,NULL),(49489,'56661','S','Grattan','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(25723,'28545','S','Mc Cutcheon Field','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.683745,-77.341910,0,'2013-07-06 12:44:31',NULL,NULL),(46437,'53207','S','Bay View','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.980668,-87.892825,0,'2013-07-06 12:44:32',NULL,NULL),(30612,'33430','S','Belle Glade','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680463,-80.666853,0,'2013-07-06 12:44:32',NULL,NULL),(8749,'08528','S','Kingston','D','Somerset','34035','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.376992,-74.615316,0,'2013-07-06 12:44:30',NULL,NULL),(77237,'96530','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(42323,'47620','S','Mount Vernon','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.950895,-87.862090,0,'2013-07-06 12:44:32',NULL,NULL),(12695,'13140','S','Port Byron','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.052760,-76.655280,0,'2013-07-06 12:44:30',NULL,NULL),(69394,'83615','S','Donnelly','D','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.710118,-116.095636,0,'2013-07-06 12:44:34',NULL,NULL),(65163,'77404','P','Sargent','A','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.832140,-95.671050,0,'2013-07-06 12:44:34',NULL,NULL),(33973,'38109','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.046864,-90.068205,0,'2013-07-06 12:44:32',NULL,NULL),(24443,'27213','P','Bonlee','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.645657,-79.413871,0,'2013-07-06 12:44:31',NULL,NULL),(43815,'49075','P','Nottawa','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.919222,-85.447537,0,'2013-07-06 12:44:32',NULL,NULL),(7890,'07538','P','Haledon','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.936601,-74.189611,0,'2013-07-06 12:44:30',NULL,NULL),(3584,'01985','S','West Newbury','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.790919,-70.975482,0,'2013-07-06 12:44:30',NULL,NULL),(10506,'10969','S','Pine Island','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.291561,-74.492649,0,'2013-07-06 12:44:30',NULL,NULL),(6201,'05483','S','St Rocks','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(34627,'38756','S','Heads','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(48994,'56236','S','Johnson','A','Traverse','27155','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.716610,-96.423526,0,'2013-07-06 12:44:33',NULL,NULL),(77026,'96101','S','Alturas','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.512612,-120.551753,0,'2013-07-06 12:44:34',NULL,NULL),(62513,'74401','S','Musk','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(19464,'20134','P','Hillsboro','A','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.142329,-77.711386,0,'2013-07-06 12:44:31',NULL,NULL),(21140,'22106','P','McLean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.940842,-77.176143,0,'2013-07-06 12:44:31',NULL,NULL),(15605,'16675','P','Saint Boniface','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.666730,-78.682970,0,'2013-07-06 12:44:31',NULL,NULL),(53152,'61559','S','Princeville','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.894140,-89.775420,0,'2013-07-06 12:44:33',NULL,NULL),(26075,'28698','S','Zionville','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.331209,-81.739210,0,'2013-07-06 12:44:31',NULL,NULL),(56817,'65779','S','Wheatland','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.910520,-93.396600,0,'2013-07-06 12:44:33',NULL,NULL),(9245,'09576','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58810,'69026','S','Danbury','D','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.044247,-100.420473,0,'2013-07-06 12:44:33',NULL,NULL),(32084,'35290','U','Wells Fargo','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.550093,-86.741320,0,'2013-07-06 12:44:32',NULL,NULL),(76020,'95131','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.388051,-121.887208,0,'2013-07-06 12:44:34',NULL,NULL),(32635,'36203','S','Anniston','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.602111,-85.835924,0,'2013-07-06 12:44:32',NULL,NULL),(38809,'44070','S','North Olmsted','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.421789,-81.918009,0,'2013-07-06 12:44:32',NULL,NULL),(22673,'24301','S','Pulaski','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.050533,-80.771948,0,'2013-07-06 12:44:31',NULL,NULL),(23652,'25811','S','Amigo','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.598884,-81.339603,0,'2013-07-06 12:44:31',NULL,NULL),(25905,'28645','S','Cedar Rock','A','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(38201,'43211','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.013425,-82.971974,0,'2013-07-06 12:44:32',NULL,NULL),(35202,'39289','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.385455,-90.276532,0,'2013-07-06 12:44:32',NULL,NULL),(12811,'13261','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.050083,-76.154526,0,'2013-07-06 12:44:30',NULL,NULL),(12482,'12989','S','Onchiota','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.469526,-74.044265,0,'2013-07-06 12:44:30',NULL,NULL),(72194,'88411','S','Bard','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.115660,-103.313220,0,'2013-07-06 12:44:34',NULL,NULL),(44681,'50124','S','Huxley','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.897615,-93.604954,0,'2013-07-06 12:44:32',NULL,NULL),(16159,'17062','S','Millerstown','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(21814,'23103','S','Manakin Sabot','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.653832,-77.725631,0,'2013-07-06 12:44:31',NULL,NULL),(24881,'27699','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.670641,-78.663729,0,'2013-07-06 12:44:31',NULL,NULL),(47099,'54442','S','Birch','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.423722,-89.692568,0,'2013-07-06 12:44:32',NULL,NULL),(4851,'04013','S','South Freeport','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.798612,-70.074648,0,'2013-07-06 12:44:30',NULL,NULL),(684,'00685','S','Bda Chinto Rodon','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(63351,'75630','S','Warlock','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.868195,-94.579545,0,'2013-07-06 12:44:33',NULL,NULL),(73522,'91345','S','Mission Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.281944,-118.438056,0,'2013-07-06 12:44:34',NULL,NULL),(64164,'76225','S','Alvord','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.360060,-97.691800,0,'2013-07-06 12:44:34',NULL,NULL),(38951,'44125','S','Valley View','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(31906,'35148','S','Sumiton','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.753152,-87.050730,0,'2013-07-06 12:44:32',NULL,NULL),(9559,'10024','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(53011,'61459','S','Marietta','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.496541,-90.393466,0,'2013-07-06 12:44:33',NULL,NULL),(50762,'58418','S','Heaton','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.394246,-99.712026,0,'2013-07-06 12:44:33',NULL,NULL),(53837,'62313','S','Basco','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.327265,-91.197950,0,'2013-07-06 12:44:33',NULL,NULL),(10384,'10595','S','Valhalla','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.088128,-73.777872,0,'2013-07-06 12:44:30',NULL,NULL),(78137,'97535','S','Phoenix','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.274463,-122.818314,0,'2013-07-06 12:44:34',NULL,NULL),(37260,'41563','S','Shelby Gap','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.235378,-82.568966,0,'2013-07-06 12:44:32',NULL,NULL),(39483,'44730','S','Canton','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.765560,-81.266520,0,'2013-07-06 12:44:32',NULL,NULL),(9172,'09355','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71184,'86044','S','Tonalea','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',35.966411,-110.876600,0,'2013-07-06 12:44:34',NULL,NULL),(49720,'57040','S','Lesterville','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.076340,-97.546836,0,'2013-07-06 12:44:33',NULL,NULL),(49948,'57341','S','Gann Valley','D','Buffalo','46017','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.085809,-99.068600,0,'2013-07-06 12:44:33',NULL,NULL),(52975,'61430','S','Columbia Heights','N','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.948243,-90.312728,0,'2013-07-06 12:44:33',NULL,NULL),(20724,'21284','P','Towson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.399688,-76.599200,0,'2013-07-06 12:44:31',NULL,NULL),(72971,'90047','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.953467,-118.311177,0,'2013-07-06 12:44:34',NULL,NULL),(13333,'13684','S','Degrasse','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.375880,-75.069180,0,'2013-07-06 12:44:30',NULL,NULL),(3917,'02459','S','Newton Centre','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.308823,-71.191835,0,'2013-07-06 12:44:30',NULL,NULL),(71518,'87116','S','Sandia Base','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.059190,-106.554193,0,'2013-07-06 12:44:34',NULL,NULL),(20160,'20740','S','College Park','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998722,-76.928721,0,'2013-07-06 12:44:31',NULL,NULL),(10258,'10499','U','Priority Mail Ctr','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.827159,-73.824345,0,'2013-07-06 12:44:30',NULL,NULL),(78811,'98331','S','Forks','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(65743,'78057','S','Moore','D','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',29.000816,-98.936703,0,'2013-07-06 12:44:34',NULL,NULL),(20280,'20790','U','Capitol Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854641,-76.931528,0,'2013-07-06 12:44:31',NULL,NULL),(38060,'43056','S','Heath','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.004880,-82.346460,0,'2013-07-06 12:44:32',NULL,NULL),(35313,'39407','U','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.313533,-89.305394,0,'2013-07-06 12:44:32',NULL,NULL),(19916,'20552','U','Cnsmr Fnncl Prtct Brd','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899758,-77.024429,0,'2013-07-06 12:44:31',NULL,NULL),(9241,'09570','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33036,'36740','S','Forkland','D','Greene','01063','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.654245,-87.872492,0,'2013-07-06 12:44:32',NULL,NULL),(68170,'81009','U','Govt Printg Ofc','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.279229,-104.489956,0,'2013-07-06 12:44:34',NULL,NULL),(59217,'70402','U','Slu','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.510346,-90.459565,0,'2013-07-06 12:44:33',NULL,NULL),(51844,'60070','S','Prospect Heights','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.104997,-87.936170,0,'2013-07-06 12:44:33',NULL,NULL),(37012,'41230','S','Fallsburg','A','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.109540,-82.626840,0,'2013-07-06 12:44:32',NULL,NULL),(24624,'27355','S','Soapstone Mountain','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.805737,-79.536595,0,'2013-07-06 12:44:31',NULL,NULL),(65156,'77396','S','Humble','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.952397,-95.268704,0,'2013-07-06 12:44:34',NULL,NULL),(68142,'80977','U','US Olympic','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.772039,-104.665048,0,'2013-07-06 12:44:34',NULL,NULL),(73465,'91307','S','Bell Canyon','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201920,-118.660980,0,'2013-07-06 12:44:34',NULL,NULL),(58478,'68747','S','McClean','N','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.395646,-97.475489,0,'2013-07-06 12:44:33',NULL,NULL),(63174,'75403','P','Greenville','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.195705,-96.105966,0,'2013-07-06 12:44:33',NULL,NULL),(21494,'22656','S','Stephenson','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.207623,-78.094979,0,'2013-07-06 12:44:31',NULL,NULL),(42929,'48114','S','Hartland Township','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.529992,-83.782845,0,'2013-07-06 12:44:32',NULL,NULL),(15120,'15821','S','Benezett','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.315960,-78.333781,0,'2013-07-06 12:44:31',NULL,NULL),(52049,'60196','U','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.071476,-88.049239,0,'2013-07-06 12:44:33',NULL,NULL),(582,'00680','S','Bo Paris','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(32151,'35468','P','Kellerman','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.338804,-87.302401,0,'2013-07-06 12:44:32',NULL,NULL),(10084,'10199','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(66958,'79381','S','New Home','A','Lynn','48305','Texas','TX','48','0000','806','Central',-6.0,'Y',33.321238,-101.724872,0,'2013-07-06 12:44:34',NULL,NULL),(78697,'98257','S','La Conner','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.391688,-122.513106,0,'2013-07-06 12:44:34',NULL,NULL),(40882,'46241','S','Drexel Gdns','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(79919,'99606','P','Iliamna','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.613300,-155.276220,0,'2013-07-06 12:44:34',NULL,NULL),(75696,'94565','S','Pittsburg','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.017076,-121.909650,0,'2013-07-06 12:44:34',NULL,NULL),(64682,'76834','S','Echo','N','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.833600,-99.415500,0,'2013-07-06 12:44:34',NULL,NULL),(64441,'76567','S','Praesel','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.657577,-97.009947,0,'2013-07-06 12:44:34',NULL,NULL),(61575,'72737','P','Greenland','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.994467,-94.174409,0,'2013-07-06 12:44:33',NULL,NULL),(819,'00693','S','Urb Monte Carlo','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(41956,'47404','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.193029,-86.575949,0,'2013-07-06 12:44:32',NULL,NULL),(1932,'00795','S','Urb Las Quintas','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(11845,'12249','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.697178,-73.994306,0,'2013-07-06 12:44:30',NULL,NULL),(18685,'19187','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954771,-75.167691,0,'2013-07-06 12:44:31',NULL,NULL),(59575,'70891','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.449240,-91.154732,0,'2013-07-06 12:44:33',NULL,NULL),(29814,'33025','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.992876,-80.274221,0,'2013-07-06 12:44:32',NULL,NULL),(22175,'23466','P','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.838360,-76.153224,0,'2013-07-06 12:44:31',NULL,NULL),(60724,'71956','S','Mountain Pine','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.584960,-93.156960,0,'2013-07-06 12:44:33',NULL,NULL),(5953,'05262','S','Shaftsbury Center','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.133333,-73.066667,0,'2013-07-06 12:44:30',NULL,NULL),(24310,'27017','S','Dobson','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(275,'00646','S','Comunidad Arenales','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(41038,'46392','S','Wheatfield','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.192267,-87.052631,0,'2013-07-06 12:44:32',NULL,NULL),(41901,'47371','S','Portland','D','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(21401,'22513','P','Merry Point','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.734965,-76.480408,0,'2013-07-06 12:44:31',NULL,NULL),(72918,'90026','S','Silver Lake','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.079313,-118.262692,0,'2013-07-06 12:44:34',NULL,NULL),(78479,'98101','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.611330,-122.333219,0,'2013-07-06 12:44:34',NULL,NULL),(51846,'60071','S','Richmond','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.466736,-88.288525,0,'2013-07-06 12:44:33',NULL,NULL),(80179,'99836','P','Sitka','A','Sitka','02220','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.039187,-132.563950,0,'2013-07-06 12:44:34',NULL,NULL),(49370,'56585','S','Ulen','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',47.076843,-96.257061,0,'2013-07-06 12:44:33',NULL,NULL),(1952,'00803','P','St Thomas','D','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350330,-64.935572,0,'2013-07-06 12:44:30',NULL,NULL),(1570,'00767','S','Ext Villas de Buenaventura','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(10010,'10169','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(48552,'55760','S','Sheshebee','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(38278,'43324','S','Huntsville','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.447389,-83.809071,0,'2013-07-06 12:44:32',NULL,NULL),(64612,'76687','S','Thornton','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(70925,'85634','S','Little Tucson','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(62629,'74554','P','Krebs','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.930835,-95.722322,0,'2013-07-06 12:44:33',NULL,NULL),(61195,'72221','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.793038,-92.535999,0,'2013-07-06 12:44:33',NULL,NULL),(8117,'07823','S','Belvidere','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.829395,-75.063548,0,'2013-07-06 12:44:30',NULL,NULL),(45638,'51647','S','Northboro','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.606685,-95.291836,0,'2013-07-06 12:44:32',NULL,NULL),(39718,'45053','S','Okeana','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.346343,-84.783327,0,'2013-07-06 12:44:32',NULL,NULL),(25970,'28659','S','Fairplains','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(25717,'28543','S','Tarawa Ter','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.734194,-77.377379,0,'2013-07-06 12:44:31',NULL,NULL),(48005,'55164','P','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.966267,-93.084445,0,'2013-07-06 12:44:33',NULL,NULL),(46848,'54021','S','Oak Grove','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.749536,-92.794364,0,'2013-07-06 12:44:32',NULL,NULL),(38361,'43452','S','Pt Clinton','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.536800,-82.908000,0,'2013-07-06 12:44:32',NULL,NULL),(66007,'78350','P','Mount Lucas','N','Live Oak','48297','Texas','TX','48','0000','361','Central',-6.0,'Y',28.226100,-97.961280,0,'2013-07-06 12:44:34',NULL,NULL),(73530,'91350','S','Santa Clarita','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(73202,'90602','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.973637,-118.031821,0,'2013-07-06 12:44:34',NULL,NULL),(70588,'85082','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.465447,-111.985085,0,'2013-07-06 12:44:34',NULL,NULL),(67034,'79543','S','Longworth','N','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.720340,-100.419180,0,'2013-07-06 12:44:34',NULL,NULL),(64052,'76132','S','Benbrook','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.671991,-97.432311,0,'2013-07-06 12:44:34',NULL,NULL),(43132,'48233','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.322115,-83.062643,0,'2013-07-06 12:44:32',NULL,NULL),(21597,'22847','S','Shenandoah Caverns','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.725788,-78.712644,0,'2013-07-06 12:44:31',NULL,NULL),(12342,'12874','S','Silver Bay','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.667500,-73.514444,0,'2013-07-06 12:44:30',NULL,NULL),(10435,'10901','S','Suffern','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.127671,-74.111934,0,'2013-07-06 12:44:30',NULL,NULL),(28544,'31557','S','Patterson','D','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.376101,-82.105370,0,'2013-07-06 12:44:32',NULL,NULL),(69573,'83830','S','Fernwood','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.120761,-116.366132,0,'2013-07-06 12:44:34',NULL,NULL),(75446,'94062','S','Palomar Park','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.448337,-122.268736,0,'2013-07-06 12:44:34',NULL,NULL),(17883,'18444','S','Covington Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(20355,'20871','S','Clarksburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.255811,-77.279923,0,'2013-07-06 12:44:31',NULL,NULL),(1752,'00778','S','Villa Marina','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(56170,'64873','S','Wentworth','D','Lawrence','29109','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.987080,-94.134257,0,'2013-07-06 12:44:33',NULL,NULL),(47540,'54818','P','Brill','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.604237,-91.672272,0,'2013-07-06 12:44:32',NULL,NULL),(21517,'22720','S','Goldvein','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.493237,-77.666206,0,'2013-07-06 12:44:31',NULL,NULL),(31957,'35210','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(61980,'73194','U','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.517415,-97.503803,0,'2013-07-06 12:44:33',NULL,NULL),(1965,'00830','S','Cruz Bay','A','Saint John','78020','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.335154,-64.790707,0,'2013-07-06 12:44:30',NULL,NULL),(42775,'48040','S','Marysville','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.914675,-82.480996,0,'2013-07-06 12:44:32',NULL,NULL),(35934,'40048','P','Nazareth','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.847071,-85.473376,0,'2013-07-06 12:44:32',NULL,NULL),(32312,'35758','S','Madison','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.684680,-86.792040,0,'2013-07-06 12:44:32',NULL,NULL),(817,'00693','S','Urb Los Almendros','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(12105,'12580','S','Staatsburg','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.846035,-73.910551,0,'2013-07-06 12:44:30',NULL,NULL),(12727,'13159','S','Otisco','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.808860,-76.143600,0,'2013-07-06 12:44:30',NULL,NULL),(1893,'00791','S','VISTA Hermosa','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(48931,'56155','S','Lismore','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.716167,-95.994464,0,'2013-07-06 12:44:33',NULL,NULL),(16660,'17352','S','New Park','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.751920,-76.495680,0,'2013-07-06 12:44:31',NULL,NULL),(23659,'25820','S','Camp Creek','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.493487,-81.114447,0,'2013-07-06 12:44:31',NULL,NULL),(31479,'34423','P','Crystal River','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.862789,-82.572331,0,'2013-07-06 12:44:32',NULL,NULL),(3249,'01436','S','Baldwinville','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.594540,-72.086280,0,'2013-07-06 12:44:30',NULL,NULL),(13494,'13803','S','Lapeer','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(45275,'50674','S','Sumner','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.849990,-92.100951,0,'2013-07-06 12:44:32',NULL,NULL),(72644,'89426','P','Paradise Vly','A','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.600543,-117.381616,0,'2013-07-06 12:44:34',NULL,NULL),(70354,'84644','P','Meadow','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.888096,-112.406351,0,'2013-07-06 12:44:34',NULL,NULL),(23404,'25324','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351904,-81.630152,0,'2013-07-06 12:44:31',NULL,NULL),(49352,'56573','S','Perham','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.596594,-95.573756,0,'2013-07-06 12:44:33',NULL,NULL),(6332,'05666','S','N Montpelier','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.256675,-72.485785,0,'2013-07-06 12:44:30',NULL,NULL),(11391,'11944','S','Greenport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.102895,-72.370978,0,'2013-07-06 12:44:30',NULL,NULL),(26215,'28787','S','Weaverville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.718689,-82.547100,0,'2013-07-06 12:44:31',NULL,NULL),(4067,'02649','S','Mashpee','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.632800,-70.488720,0,'2013-07-06 12:44:30',NULL,NULL),(6311,'05660','S','South Duxbury','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.252162,-72.748572,0,'2013-07-06 12:44:30',NULL,NULL),(26127,'28734','S','Cowee','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(57043,'66209','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(26840,'29502','P','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.195168,-79.792218,0,'2013-07-06 12:44:31',NULL,NULL),(33334,'37153','S','Rockvale','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.757032,-86.554116,0,'2013-07-06 12:44:32',NULL,NULL),(46915,'54139','S','Stiles','A','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.935260,-88.054980,0,'2013-07-06 12:44:32',NULL,NULL),(26622,'29316','S','Spartanburg','A','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.056379,-81.964009,0,'2013-07-06 12:44:31',NULL,NULL),(77178,'96303','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76003,'95113','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.333274,-121.890864,0,'2013-07-06 12:44:34',NULL,NULL),(69450,'83647','S','Paradise Hot Springs','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(26480,'29161','S','Cartersville','N','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.119660,-79.973820,0,'2013-07-06 12:44:31',NULL,NULL),(14305,'14883','S','West Danby','A','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.251460,-76.480800,0,'2013-07-06 12:44:31',NULL,NULL),(53986,'62441','S','Albright','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.400200,-87.694680,0,'2013-07-06 12:44:33',NULL,NULL),(54931,'63108','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.642683,-90.253485,0,'2013-07-06 12:44:33',NULL,NULL),(34110,'38182','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145303,-89.970637,0,'2013-07-06 12:44:32',NULL,NULL),(22044,'23307','S','Birdsnest','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.436981,-75.894593,0,'2013-07-06 12:44:31',NULL,NULL),(9005,'08855','P','Piscataway','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.500254,-74.399983,0,'2013-07-06 12:44:30',NULL,NULL),(12311,'12858','S','Paradox','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.894090,-73.638656,0,'2013-07-06 12:44:30',NULL,NULL),(78673,'98239','S','Coupeville','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.184186,-122.613686,0,'2013-07-06 12:44:34',NULL,NULL),(76950,'96033','S','French Gulch','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.736021,-122.619811,0,'2013-07-06 12:44:34',NULL,NULL),(28388,'31309','S','Fleming','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.882670,-81.413585,0,'2013-07-06 12:44:32',NULL,NULL),(76995,'96075','S','Paynes Creek','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.337839,-121.802120,0,'2013-07-06 12:44:34',NULL,NULL),(64187,'76240','S','Gainesville','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.621754,-97.121151,0,'2013-07-06 12:44:34',NULL,NULL),(19163,'19720','S','New Castle','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.673263,-75.595423,0,'2013-07-06 12:44:31',NULL,NULL),(45711,'52064','S','Miles','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.081840,-90.326520,0,'2013-07-06 12:44:32',NULL,NULL),(29729,'32958','S','Sebastian','D','Indian River','12061','Florida','FL','12','4900','772','Eastern',-5.0,'Y',27.783115,-80.483191,0,'2013-07-06 12:44:32',NULL,NULL),(48256,'55426','S','St Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952405,-93.377860,0,'2013-07-06 12:44:33',NULL,NULL),(45170,'50601','S','Faulkner','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.552024,-93.052562,0,'2013-07-06 12:44:32',NULL,NULL),(43999,'49345','S','Sparta','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.161725,-85.694381,0,'2013-07-06 12:44:32',NULL,NULL),(36375,'40460','S','Orlando','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.387780,-84.220202,0,'2013-07-06 12:44:32',NULL,NULL),(64508,'76634','S','Clifton','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(73037,'90077','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.101509,-118.452396,0,'2013-07-06 12:44:34',NULL,NULL),(34350,'38583','S','Ravenscroft','A','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.931616,-85.469699,0,'2013-07-06 12:44:32',NULL,NULL),(46971,'54211','P','Ephraim','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.155329,-87.164732,0,'2013-07-06 12:44:32',NULL,NULL),(23839,'26121','U','Mineral Wells','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.172142,-81.494887,0,'2013-07-06 12:44:31',NULL,NULL),(49565,'56721','S','E G Forks','N','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.929448,-97.017008,0,'2013-07-06 12:44:33',NULL,NULL),(74015,'92121','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.894055,-117.202589,0,'2013-07-06 12:44:34',NULL,NULL),(39586,'44861','P','Old Fort','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.242080,-83.153164,0,'2013-07-06 12:44:32',NULL,NULL),(464,'00664','S','Alts de Jayuya','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(37670,'42211','S','Linton','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(45166,'50598','S','Whittemore','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.062263,-94.424146,0,'2013-07-06 12:44:32',NULL,NULL),(65394,'77554','S','West Galveston','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.207422,-94.965163,0,'2013-07-06 12:44:34',NULL,NULL),(49894,'57272','S','Wallace','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.064905,-97.434058,0,'2013-07-06 12:44:33',NULL,NULL),(32182,'35487','U','University of Alabama','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.215665,-87.539190,0,'2013-07-06 12:44:32',NULL,NULL),(19525,'20186','S','Warrenton','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.694065,-77.852222,0,'2013-07-06 12:44:31',NULL,NULL),(43550,'48708','S','Bay City','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.581561,-83.868517,0,'2013-07-06 12:44:32',NULL,NULL),(24607,'27330','S','Sanford','D','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(16347,'17140','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259652,-76.807717,0,'2013-07-06 12:44:31',NULL,NULL),(39896,'45215','S','Arlington Hts','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(12798,'13224','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.042678,-76.101087,0,'2013-07-06 12:44:30',NULL,NULL),(35618,'39602','P','Brookhaven','D','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.593072,-90.469962,0,'2013-07-06 12:44:32',NULL,NULL),(17420,'17922','S','Auburn','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.594751,-76.154011,0,'2013-07-06 12:44:31',NULL,NULL),(79621,'99121','S','Danville','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.979642,-118.517898,0,'2013-07-06 12:44:34',NULL,NULL),(80024,'99685','P','Unalaska','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',53.864241,-166.717113,0,'2013-07-06 12:44:34',NULL,NULL),(56132,'64836','S','Carytown','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(70616,'85122','S','Eleven Mile Corner','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.893933,-111.745030,0,'2013-07-06 12:44:34',NULL,NULL),(13738,'14108','S','Newfane','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.262960,-78.726232,0,'2013-07-06 12:44:31',NULL,NULL),(41890,'47371','S','Bluff Point','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(42307,'47601','S','De Gonia','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(43498,'48624','S','Gladwin','D','Gladwin','26051','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.036102,-84.457382,0,'2013-07-06 12:44:32',NULL,NULL),(46165,'52730','S','Shaffton','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.785818,-90.261710,0,'2013-07-06 12:44:32',NULL,NULL),(6576,'05855','S','Newport City','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(62984,'75147','S','Gun Barrel City','A','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.319300,-96.118080,0,'2013-07-06 12:44:33',NULL,NULL),(70520,'85004','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.450504,-112.067560,0,'2013-07-06 12:44:34',NULL,NULL),(47801,'55051','S','Mora','D','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.915556,-93.173056,0,'2013-07-06 12:44:33',NULL,NULL),(61987,'73301','U','Internal Revenue Service','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.220228,-97.749942,0,'2013-07-06 12:44:33',NULL,NULL),(61327,'72451','P','Paragould','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.058786,-90.499707,0,'2013-07-06 12:44:33',NULL,NULL),(41805,'47331','S','Alquina','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(22209,'23515','U','Fleet Marine Force Atlantic','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.915605,-76.304000,0,'2013-07-06 12:44:31',NULL,NULL),(11625,'12110','S','Verdoy','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.747077,-73.767886,0,'2013-07-06 12:44:30',NULL,NULL),(72915,'90026','S','Echo Park','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.079313,-118.262692,0,'2013-07-06 12:44:34',NULL,NULL),(12477,'12986','S','Conifer','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.235050,-74.464960,0,'2013-07-06 12:44:30',NULL,NULL),(12426,'12949','S','Lawrenceville','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.758806,-74.662758,0,'2013-07-06 12:44:30',NULL,NULL),(35821,'39762','P','Ms State','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(37112,'41385','S','Sewell','N','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.628288,-83.413815,0,'2013-07-06 12:44:32',NULL,NULL),(43858,'49113','S','Galien','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.799111,-86.515538,0,'2013-07-06 12:44:32',NULL,NULL),(10323,'10542','P','Mahopac Falls','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.372926,-73.759834,0,'2013-07-06 12:44:30',NULL,NULL),(15968,'17029','S','Granville','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.546874,-77.604665,0,'2013-07-06 12:44:31',NULL,NULL),(77489,'96824','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.280032,-157.758076,0,'2013-07-06 12:44:34',NULL,NULL),(73493,'91327','P','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.273021,-118.551433,0,'2013-07-06 12:44:34',NULL,NULL),(64167,'76226','S','Corral City','N','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.104830,-97.164815,0,'2013-07-06 12:44:34',NULL,NULL),(12281,'12841','P','Huletts Lndg','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.640008,-73.506355,0,'2013-07-06 12:44:30',NULL,NULL),(13281,'13657','P','Limerick','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.027898,-76.050991,0,'2013-07-06 12:44:30',NULL,NULL),(14592,'15221','S','Wilkinsburg','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(1544,'00757','S','Urb Alborada','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(60083,'71357','S','Newellton','D','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(51657,'59901','S','Kalispell','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.211236,-114.293904,0,'2013-07-06 12:44:33',NULL,NULL),(67598,'80424','S','Blue River','A','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.472151,-106.040778,0,'2013-07-06 12:44:34',NULL,NULL),(64198,'76248','S','Keller','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.930266,-97.247254,0,'2013-07-06 12:44:34',NULL,NULL),(51445,'59472','S','Tracy','A','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.394577,-111.164252,0,'2013-07-06 12:44:33',NULL,NULL),(5901,'05158','S','West Minster','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.076656,-72.453377,0,'2013-07-06 12:44:30',NULL,NULL),(52377,'60622','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.897111,-87.670880,0,'2013-07-06 12:44:33',NULL,NULL),(53141,'61554','S','Midway','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(53667,'62208','S','Fairview Hts','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.599660,-90.009909,0,'2013-07-06 12:44:33',NULL,NULL),(13220,'13634','S','Muskalounge','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(70108,'84180','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767274,-111.898078,0,'2013-07-06 12:44:34',NULL,NULL),(29524,'32779','S','Wekiva Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.705154,-81.420524,0,'2013-07-06 12:44:32',NULL,NULL),(76951,'96034','S','Gazelle','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.461011,-122.638049,0,'2013-07-06 12:44:34',NULL,NULL),(60263,'71446','S','Pickering','N','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(7699,'07111','S','Township Of Irvington','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.722730,-74.232016,0,'2013-07-06 12:44:30',NULL,NULL),(12881,'13327','S','Croghan','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.899822,-75.381978,0,'2013-07-06 12:44:30',NULL,NULL),(53148,'61555','P','Pekin','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.566754,-89.642930,0,'2013-07-06 12:44:33',NULL,NULL),(34057,'38139','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.089280,-89.773074,0,'2013-07-06 12:44:32',NULL,NULL),(55629,'64001','S','Alma','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.103607,-93.546252,0,'2013-07-06 12:44:33',NULL,NULL),(37347,'41713','P','Avawam','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.222725,-83.280452,0,'2013-07-06 12:44:32',NULL,NULL),(64201,'76251','S','Montague','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.673585,-97.732420,0,'2013-07-06 12:44:34',NULL,NULL),(69926,'84112','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.763779,-111.838359,0,'2013-07-06 12:44:34',NULL,NULL),(75322,'93772','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.748040,-119.791751,0,'2013-07-06 12:44:34',NULL,NULL),(9264,'09605','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28121,'30814','S','Berzelia','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.414274,-82.313268,0,'2013-07-06 12:44:31',NULL,NULL),(8071,'07752','P','Navesink','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.385764,-74.086517,0,'2013-07-06 12:44:30',NULL,NULL),(74142,'92252','S','Joshua Tree','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.159479,-116.297129,0,'2013-07-06 12:44:34',NULL,NULL),(56220,'65038','P','Laurie','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.199727,-92.833349,0,'2013-07-06 12:44:33',NULL,NULL),(65427,'77581','S','Pearland','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.560076,-95.275452,0,'2013-07-06 12:44:34',NULL,NULL),(25977,'28659','S','Windy Gap','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(38327,'43420','S','Fremont','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.345436,-83.117931,0,'2013-07-06 12:44:32',NULL,NULL),(26607,'29301','S','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.933791,-81.965052,0,'2013-07-06 12:44:31',NULL,NULL),(54576,'62898','S','Drivers','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.387010,-89.091555,0,'2013-07-06 12:44:33',NULL,NULL),(28623,'31721','S','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.577688,-84.220227,0,'2013-07-06 12:44:32',NULL,NULL),(34433,'38645','S','Lyon','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.236273,-90.519701,0,'2013-07-06 12:44:32',NULL,NULL),(5577,'04910','S','Albion','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.573904,-69.466422,0,'2013-07-06 12:44:30',NULL,NULL),(30382,'33319','S','Lauderdale Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(25346,'28223','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.327415,-80.759956,0,'2013-07-06 12:44:31',NULL,NULL),(51108,'58783','S','Roth','A','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.920760,-100.825620,0,'2013-07-06 12:44:33',NULL,NULL),(42630,'47907','S','West Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.368719,-86.877988,0,'2013-07-06 12:44:32',NULL,NULL),(34273,'38472','S','Lynnville','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.387148,-86.996972,0,'2013-07-06 12:44:32',NULL,NULL),(62175,'73750','S','Kingfisher','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.848233,-97.936158,0,'2013-07-06 12:44:33',NULL,NULL),(58290,'68415','S','Lanham','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.046798,-96.803063,0,'2013-07-06 12:44:33',NULL,NULL),(26760,'29431','S','Bonneau','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.318469,-79.988526,0,'2013-07-06 12:44:31',NULL,NULL),(41163,'46703','S','Lake James','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(65360,'77533','P','Daisetta','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.115927,-94.643055,0,'2013-07-06 12:44:34',NULL,NULL),(65265,'77471','S','Rosenberg','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.552370,-95.852714,0,'2013-07-06 12:44:34',NULL,NULL),(42500,'47842','S','Jacksonville','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(42625,'47906','S','W Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.495856,-86.967180,0,'2013-07-06 12:44:32',NULL,NULL),(45916,'52324','S','Covington','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.052140,-91.792470,0,'2013-07-06 12:44:32',NULL,NULL),(32368,'35897','U','Munitions Missle Com Sch','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.716742,-86.631183,0,'2013-07-06 12:44:32',NULL,NULL),(58000,'67862','S','Manter','D','Stanton','20187','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.524757,-101.881634,0,'2013-07-06 12:44:33',NULL,NULL),(38664,'43947','S','Dilles Bottom','N','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.968088,-80.754883,0,'2013-07-06 12:44:32',NULL,NULL),(21923,'23224','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.495020,-77.477100,0,'2013-07-06 12:44:31',NULL,NULL),(19679,'20355','U','Pentagon','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896255,-77.034270,0,'2013-07-06 12:44:31',NULL,NULL),(49659,'57002','S','Aurora','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.288735,-96.713704,0,'2013-07-06 12:44:33',NULL,NULL),(77161,'96213','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(26978,'29615','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.868789,-82.312139,0,'2013-07-06 12:44:31',NULL,NULL),(27274,'29943','S','Tarboro','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481456,-81.113941,0,'2013-07-06 12:44:31',NULL,NULL),(33668,'37726','S','Deer Lodge','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.220858,-84.836036,0,'2013-07-06 12:44:32',NULL,NULL),(77219,'96388','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75809,'94805','S','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.943049,-122.320440,0,'2013-07-06 12:44:34',NULL,NULL),(70652,'85192','S','Winkelman','D','Gila','04007','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.915624,-110.721518,0,'2013-07-06 12:44:34',NULL,NULL),(28162,'30906','S','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.400357,-82.031397,0,'2013-07-06 12:44:31',NULL,NULL),(75433,'94039','P','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.395047,-122.076661,0,'2013-07-06 12:44:34',NULL,NULL),(66206,'78550','S','Adams Gardens','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(43085,'48205','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.432798,-82.981462,0,'2013-07-06 12:44:32',NULL,NULL),(3668,'02125','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.313703,-71.062976,0,'2013-07-06 12:44:30',NULL,NULL),(51743,'60015','S','Riverwoods','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.172896,-87.878422,0,'2013-07-06 12:44:33',NULL,NULL),(73477,'91319','P','Newbury Park','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.184847,-118.916417,0,'2013-07-06 12:44:34',NULL,NULL),(68263,'81069','S','Lascar','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.927576,-104.902916,0,'2013-07-06 12:44:34',NULL,NULL),(66595,'78753','S','Dessau','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371378,-97.671747,0,'2013-07-06 12:44:34',NULL,NULL),(43623,'48817','S','Corunna','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.005955,-84.065189,0,'2013-07-06 12:44:32',NULL,NULL),(14573,'15216','S','South Hills','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(18448,'19072','S','Narberth','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.018469,-75.264095,0,'2013-07-06 12:44:31',NULL,NULL),(38942,'44124','S','Mayfield','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(14195,'14760','S','Knapp Creek','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.081747,-78.426015,0,'2013-07-06 12:44:31',NULL,NULL),(14239,'14815','S','Bradford','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.390147,-77.083086,0,'2013-07-06 12:44:31',NULL,NULL),(640,'00682','S','Urb Llavat','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(54956,'63119','S','Webster Groves','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.588549,-90.350542,0,'2013-07-06 12:44:33',NULL,NULL),(70449,'84746','P','Leeds','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.235864,-113.361897,0,'2013-07-06 12:44:34',NULL,NULL),(62376,'74077','U','Ok State Univ Stu Housing','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.118222,-97.062130,0,'2013-07-06 12:44:33',NULL,NULL),(18884,'19462','S','Plymouth Valley','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.108511,-75.277184,0,'2013-07-06 12:44:31',NULL,NULL),(79273,'98572','S','Pe Ell','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.566487,-123.305284,0,'2013-07-06 12:44:34',NULL,NULL),(64375,'76528','S','Leon Junction','A','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(24812,'27602','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.747883,-78.637225,0,'2013-07-06 12:44:31',NULL,NULL),(34160,'38258','S','Trezevant','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.031357,-88.602900,0,'2013-07-06 12:44:32',NULL,NULL),(43264,'48327','S','Waterford Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.647953,-83.407284,0,'2013-07-06 12:44:32',NULL,NULL),(16834,'17555','S','Fetterville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.133056,-75.965000,0,'2013-07-06 12:44:31',NULL,NULL),(60054,'71350','S','Mansura','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.083712,-92.022496,0,'2013-07-06 12:44:33',NULL,NULL),(58180,'68307','S','Avoca','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.798417,-96.119486,0,'2013-07-06 12:44:33',NULL,NULL),(55271,'63463','S','Philadelphia','D','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.837162,-91.765993,0,'2013-07-06 12:44:33',NULL,NULL),(65453,'77613','P','China','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.050864,-94.306407,0,'2013-07-06 12:44:34',NULL,NULL),(71158,'86036','S','Marble Canyon','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.921756,-111.450768,0,'2013-07-06 12:44:34',NULL,NULL),(33471,'37332','S','Evensville','D','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.615048,-84.996588,0,'2013-07-06 12:44:32',NULL,NULL),(72164,'88340','S','Mescalero','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.265571,-105.726911,0,'2013-07-06 12:44:34',NULL,NULL),(46770,'53947','P','Marquette','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.750760,-89.141097,0,'2013-07-06 12:44:32',NULL,NULL),(17508,'17963','S','Marstown','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(52054,'60197','P','North Suburban','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.914461,-88.138313,0,'2013-07-06 12:44:33',NULL,NULL),(52615,'61031','S','Franklin Grove','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.830924,-89.306726,0,'2013-07-06 12:44:33',NULL,NULL),(54503,'62866','P','Nason','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.161713,-88.979469,0,'2013-07-06 12:44:33',NULL,NULL),(10685,'11210','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.628777,-73.945814,0,'2013-07-06 12:44:30',NULL,NULL),(19817,'20456','U','National Credit Union Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898454,-77.044445,0,'2013-07-06 12:44:31',NULL,NULL),(40022,'45247','S','Groesbeck','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(51904,'60103','S','Bartlett','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.966534,-88.165433,0,'2013-07-06 12:44:33',NULL,NULL),(6922,'06155','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757156,-72.743576,0,'2013-07-06 12:44:30',NULL,NULL),(57317,'66701','S','Devon','N','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.822740,-94.701540,0,'2013-07-06 12:44:33',NULL,NULL),(56477,'65324','S','Climax Sprgs','A','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.125197,-92.961855,0,'2013-07-06 12:44:33',NULL,NULL),(23101,'24935','S','Forest Hill','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.554495,-80.831424,0,'2013-07-06 12:44:31',NULL,NULL),(54134,'62561','S','Spaulding','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.854460,-89.507700,0,'2013-07-06 12:44:33',NULL,NULL),(36300,'40361','S','Clintonville','N','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.205376,-84.241639,0,'2013-07-06 12:44:32',NULL,NULL),(58368,'68524','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.857067,-96.786673,0,'2013-07-06 12:44:33',NULL,NULL),(36526,'40845','S','Hulen','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.748142,-83.531184,0,'2013-07-06 12:44:32',NULL,NULL),(60550,'71726','S','Reader','A','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.707156,-93.028850,0,'2013-07-06 12:44:33',NULL,NULL),(74599,'92704','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.724888,-117.908994,0,'2013-07-06 12:44:34',NULL,NULL),(76360,'95490','S','Willits','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.470280,-123.359460,0,'2013-07-06 12:44:34',NULL,NULL),(18335,'19028','P','Edgemont','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.980475,-75.454566,0,'2013-07-06 12:44:31',NULL,NULL),(56575,'65529','S','Jerome','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.915035,-91.991499,0,'2013-07-06 12:44:33',NULL,NULL),(35837,'39773','S','Tibbee','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.629580,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(4746,'03840','S','Greenland','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.037821,-70.846351,0,'2013-07-06 12:44:30',NULL,NULL),(30715,'33509','P','Brandon','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.894857,-82.330950,0,'2013-07-06 12:44:32',NULL,NULL),(14105,'14625','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.134240,-77.499600,0,'2013-07-06 12:44:31',NULL,NULL),(71841,'87582','P','Canova','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.146111,-106.005000,0,'2013-07-06 12:44:34',NULL,NULL),(52953,'61416','P','Bardolph','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.497945,-90.565639,0,'2013-07-06 12:44:33',NULL,NULL),(22300,'23828','S','Branchville','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.585621,-77.291884,0,'2013-07-06 12:44:31',NULL,NULL),(74709,'93011','P','Camarillo','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.214664,-119.035591,0,'2013-07-06 12:44:34',NULL,NULL),(24283,'26886','P','Onego','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.820372,-79.476238,0,'2013-07-06 12:44:31',NULL,NULL),(11366,'11901','S','Flanders','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.928084,-72.655830,0,'2013-07-06 12:44:30',NULL,NULL),(39167,'44307','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.067235,-81.547576,0,'2013-07-06 12:44:32',NULL,NULL),(5360,'04623','S','Centerville','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.707438,-67.773645,0,'2013-07-06 12:44:30',NULL,NULL),(59612,'71028','S','Gibsland','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.518320,-93.070980,0,'2013-07-06 12:44:33',NULL,NULL),(52508,'60803','S','Merrionette Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.667210,-87.740131,0,'2013-07-06 12:44:33',NULL,NULL),(48578,'55771','S','Leiding','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(2808,'00976','S','Urb Round Hls','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(64780,'77005','S','W Univ Pl','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.718966,-95.421416,0,'2013-07-06 12:44:34',NULL,NULL),(71131,'86022','S','Moccasin','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(75655,'94533','S','Fairfield','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.285247,-122.008109,0,'2013-07-06 12:44:34',NULL,NULL),(10005,'10168','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(50183,'57562','S','Okaton','D','Jones','46075','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.988791,-100.927838,0,'2013-07-06 12:44:33',NULL,NULL),(62280,'74016','S','Winganon','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.540960,-95.446920,0,'2013-07-06 12:44:33',NULL,NULL),(1426,'00739','S','Est Del Bosque','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(17168,'17814','S','Laubachs','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(20592,'21201','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.294917,-76.624885,0,'2013-07-06 12:44:31',NULL,NULL),(53848,'62321','S','McCall','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(37734,'42301','S','Owensboro','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.747812,-87.178813,0,'2013-07-06 12:44:32',NULL,NULL),(1766,'00780','S','Urb El Laurel','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(54936,'63112','S','Wellston','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.661545,-90.285509,0,'2013-07-06 12:44:33',NULL,NULL),(47030,'54401','S','Wausau','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.960540,-89.656218,0,'2013-07-06 12:44:32',NULL,NULL),(27631,'30313','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.764232,-84.395287,0,'2013-07-06 12:44:31',NULL,NULL),(3607,'02047','P','Humarock','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.137860,-70.693847,0,'2013-07-06 12:44:30',NULL,NULL),(11835,'12244','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651521,-73.761175,0,'2013-07-06 12:44:30',NULL,NULL),(26280,'29018','S','Bowman','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.349110,-80.687537,0,'2013-07-06 12:44:31',NULL,NULL),(21294,'22401','S','Fredericksbrg','A','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.296176,-77.485335,0,'2013-07-06 12:44:31',NULL,NULL),(18057,'18702','S','Plains','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(19056,'19545','P','New Berlinville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.344188,-75.633347,0,'2013-07-06 12:44:31',NULL,NULL),(14785,'15358','P','Richeyville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.053640,-79.997261,0,'2013-07-06 12:44:31',NULL,NULL),(73849,'91803','S','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.070953,-118.145923,0,'2013-07-06 12:44:34',NULL,NULL),(9016,'08865','S','Harmony Township','N','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.698180,-75.135480,0,'2013-07-06 12:44:30',NULL,NULL),(1030,'00719','S','Naranjito','D','Naranjito','72105','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.301571,-66.244271,0,'2013-07-06 12:44:30',NULL,NULL),(2436,'00953','S','Urb Monte Verde','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(68757,'82229','S','Shawnee','D','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.674994,-105.023349,0,'2013-07-06 12:44:34',NULL,NULL),(11674,'12148','S','Rexford','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.845640,-73.849020,0,'2013-07-06 12:44:30',NULL,NULL),(15689,'16838','S','Grampian','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.999687,-78.603237,0,'2013-07-06 12:44:31',NULL,NULL),(52500,'60707','S','Elmwood Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.923558,-87.816578,0,'2013-07-06 12:44:33',NULL,NULL),(55872,'64195','P','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.302040,-94.718377,0,'2013-07-06 12:44:33',NULL,NULL),(66832,'79104','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.197497,-101.788687,0,'2013-07-06 12:44:34',NULL,NULL),(20239,'20779','S','Tracys Lndg','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.770043,-76.577860,0,'2013-07-06 12:44:31',NULL,NULL),(18702,'19194','U','Phila','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954940,-75.183065,0,'2013-07-06 12:44:31',NULL,NULL),(16202,'17070','S','New Market','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(24399,'27106','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.149640,-80.322600,0,'2013-07-06 12:44:31',NULL,NULL),(41275,'46755','S','Lisbon','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(38633,'43926','P','Empire','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.511930,-80.623747,0,'2013-07-06 12:44:32',NULL,NULL),(5212,'04457','S','Woodville','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(30412,'33325','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110796,-80.317912,0,'2013-07-06 12:44:32',NULL,NULL),(44277,'49711','P','Charlevoix','A','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.358333,-85.097222,0,'2013-07-06 12:44:32',NULL,NULL),(33010,'36675','U','Mobile P&DC','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.695546,-88.046939,0,'2013-07-06 12:44:32',NULL,NULL),(73356,'91011','S','La Canada','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.206651,-118.201628,0,'2013-07-06 12:44:34',NULL,NULL),(72887,'90015','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038557,-118.268695,0,'2013-07-06 12:44:34',NULL,NULL),(14648,'15236','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(3224,'01368','S','S Royalston','A','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.684928,-72.196002,0,'2013-07-06 12:44:30',NULL,NULL),(2879,'00987','S','Ciudad Central II','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(9212,'09504','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(1951,'00803','P','Charlotte Amalie','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350330,-64.935572,0,'2013-07-06 12:44:30',NULL,NULL),(78869,'98350','P','La Push','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.908674,-124.636562,0,'2013-07-06 12:44:34',NULL,NULL),(76556,'95667','S','Kelsey','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(2124,'00924','S','Ext Town Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(20364,'20877','S','Montgomry Vlg','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.141703,-77.193419,0,'2013-07-06 12:44:31',NULL,NULL),(39495,'44799','U','North Canton','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.811856,-81.373368,0,'2013-07-06 12:44:32',NULL,NULL),(44730,'50157','S','Malcom','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.612217,-92.531212,0,'2013-07-06 12:44:32',NULL,NULL),(54368,'62806','S','Black','N','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.377481,-88.056083,0,'2013-07-06 12:44:33',NULL,NULL),(30495,'33388','S','Plantation','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.117073,-80.254184,0,'2013-07-06 12:44:32',NULL,NULL),(71129,'86022','S','Kaibab','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(70761,'85332','P','Congress','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.164079,-112.857349,0,'2013-07-06 12:44:34',NULL,NULL),(11702,'12165','S','Spencertown','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.320381,-73.548607,0,'2013-07-06 12:44:30',NULL,NULL),(6205,'05486','S','Keeler Bay','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.866206,-73.251370,0,'2013-07-06 12:44:30',NULL,NULL),(43367,'48412','S','Lum','A','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075440,-83.171640,0,'2013-07-06 12:44:32',NULL,NULL),(72317,'89001','S','Tempiute','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.481400,-115.488420,0,'2013-07-06 12:44:34',NULL,NULL),(3939,'02467','S','Brookline','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.318527,-71.157052,0,'2013-07-06 12:44:30',NULL,NULL),(34468,'38663','S','Murry','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(78789,'98314','U','Puget Sound Naval Shipyard','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.560627,-122.648934,0,'2013-07-06 12:44:34',NULL,NULL),(16928,'17605','P','East Lancaster','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014997,-76.248254,0,'2013-07-06 12:44:31',NULL,NULL),(20248,'20782','S','Green Meadow','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(76575,'95675','P','River Pines','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.545897,-120.741250,0,'2013-07-06 12:44:34',NULL,NULL),(61854,'73121','S','Forest Park','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.509891,-97.446247,0,'2013-07-06 12:44:33',NULL,NULL),(10846,'11411','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694491,-73.737461,0,'2013-07-06 12:44:30',NULL,NULL),(45964,'52358','S','West Branch','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(57605,'67114','S','Newton','D','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.046304,-97.350600,0,'2013-07-06 12:44:33',NULL,NULL),(25910,'28645','S','Laytown','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(14492,'15139','S','Oakmont','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.518707,-79.834203,0,'2013-07-06 12:44:31',NULL,NULL),(24301,'27013','S','Barber','A','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.745026,-80.676769,0,'2013-07-06 12:44:31',NULL,NULL),(48714,'55949','S','Highland','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.716900,-92.006580,0,'2013-07-06 12:44:33',NULL,NULL),(69429,'83638','S','Burgdorf','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.914318,-116.098389,0,'2013-07-06 12:44:34',NULL,NULL),(40195,'45383','S','W Milton','N','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.955496,-84.328876,0,'2013-07-06 12:44:32',NULL,NULL),(49777,'57073','S','Wakonda','D','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.995805,-97.043929,0,'2013-07-06 12:44:33',NULL,NULL),(11896,'12401','S','Kingston','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.932171,-74.019531,0,'2013-07-06 12:44:30',NULL,NULL),(35900,'40013','S','Coxs Creek','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.917352,-85.501392,0,'2013-07-06 12:44:32',NULL,NULL),(34399,'38625','S','Locum','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640768,-88.802425,0,'2013-07-06 12:44:32',NULL,NULL),(61196,'72222','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.724530,-92.353702,0,'2013-07-06 12:44:33',NULL,NULL),(67567,'80295','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.753583,-104.998039,0,'2013-07-06 12:44:34',NULL,NULL),(70137,'84304','S','Cache Jct','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.832974,-112.002030,0,'2013-07-06 12:44:34',NULL,NULL),(75240,'93650','S','Pinedale','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.838859,-119.800966,0,'2013-07-06 12:44:34',NULL,NULL),(33111,'36860','S','Hurtsboro','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.236282,-85.417164,0,'2013-07-06 12:44:32',NULL,NULL),(27912,'30502','P','Chestnut Mtn','A','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.176858,-83.907840,0,'2013-07-06 12:44:31',NULL,NULL),(8707,'08401','S','Atlantic City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.362143,-74.437879,0,'2013-07-06 12:44:30',NULL,NULL),(19551,'20198','S','The Plains','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.863166,-77.772695,0,'2013-07-06 12:44:31',NULL,NULL),(51738,'60014','S','Lakewood','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.230860,-88.326944,0,'2013-07-06 12:44:33',NULL,NULL),(79841,'99540','S','Anchorage','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.116878,-149.899764,0,'2013-07-06 12:44:34',NULL,NULL),(48430,'55614','S','Silver Bay','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.305260,-91.247460,0,'2013-07-06 12:44:33',NULL,NULL),(53422,'61851','S','Ivesdale','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.944163,-88.454228,0,'2013-07-06 12:44:33',NULL,NULL),(3561,'01949','S','Middleton','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.596262,-71.015245,0,'2013-07-06 12:44:30',NULL,NULL),(8648,'08310','S','Buena Vista Township','N','Atlantic','34001','New Jersey','NJ','34','0560','856','Eastern',-5.0,'Y',39.527337,-74.912575,0,'2013-07-06 12:44:30',NULL,NULL),(62759,'74851','S','Dale','A','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.425500,-97.104600,0,'2013-07-06 12:44:33',NULL,NULL),(9680,'10043','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(32608,'36134','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.377274,-86.308425,0,'2013-07-06 12:44:32',NULL,NULL),(10637,'11054','U','Publishers Clearing House','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.831342,-73.683314,0,'2013-07-06 12:44:30',NULL,NULL),(45317,'50847','P','Grant','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.112132,-94.984793,0,'2013-07-06 12:44:32',NULL,NULL),(48807,'56020','P','Conger','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.618250,-93.532559,0,'2013-07-06 12:44:33',NULL,NULL),(37270,'41572','S','Speight','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.341120,-82.650600,0,'2013-07-06 12:44:32',NULL,NULL),(50678,'58344','S','Bartlett','N','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.042397,-98.341319,0,'2013-07-06 12:44:33',NULL,NULL),(31263,'33993','S','Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.713725,-82.026694,0,'2013-07-06 12:44:32',NULL,NULL),(38938,'44123','S','Euclid','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.593056,-81.526944,0,'2013-07-06 12:44:32',NULL,NULL),(74022,'92128','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',33.010498,-117.070512,0,'2013-07-06 12:44:34',NULL,NULL),(68334,'81121','P','Piedre Park','N','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.026700,-107.483555,0,'2013-07-06 12:44:34',NULL,NULL),(39932,'45225','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.141820,-84.552967,0,'2013-07-06 12:44:32',NULL,NULL),(26818,'29481','S','Smoaks','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.102798,-80.811011,0,'2013-07-06 12:44:31',NULL,NULL),(1687,'00777','S','Mans de Juncos','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(51414,'59442','S','Fort Benton','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.819573,-110.670979,0,'2013-07-06 12:44:33',NULL,NULL),(65206,'77435','S','Tavener','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.527948,-96.061715,0,'2013-07-06 12:44:34',NULL,NULL),(74163,'92264','S','Palm Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.800656,-116.517356,0,'2013-07-06 12:44:34',NULL,NULL),(35153,'39232','S','JAX','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289828,-90.181404,0,'2013-07-06 12:44:32',NULL,NULL),(62304,'74029','S','Dewey','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.794446,-95.936311,0,'2013-07-06 12:44:33',NULL,NULL),(48072,'55330','S','Elk River','D','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(46378,'53137','S','Helenville','D','Jefferson','55055','Wisconsin','WI','55','0000','414','Central',-6.0,'Y',43.057252,-88.694540,0,'2013-07-06 12:44:32',NULL,NULL),(41035,'46390','S','Wanatah','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.435469,-86.892131,0,'2013-07-06 12:44:32',NULL,NULL),(50110,'57481','S','Wetonka','A','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.626880,-98.613000,0,'2013-07-06 12:44:33',NULL,NULL),(58158,'68179','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.262770,-95.934386,0,'2013-07-06 12:44:33',NULL,NULL),(26645,'29348','P','Gramling','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.082221,-82.126458,0,'2013-07-06 12:44:31',NULL,NULL),(49003,'56248','S','Herman','D','Grant','27051','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.808620,-96.138498,0,'2013-07-06 12:44:33',NULL,NULL),(61607,'72774','S','West Fork','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.928209,-94.183808,0,'2013-07-06 12:44:33',NULL,NULL),(75747,'94610','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.815060,-122.239672,0,'2013-07-06 12:44:34',NULL,NULL),(12010,'12498','S','Woodstock','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.032936,-74.116116,0,'2013-07-06 12:44:30',NULL,NULL),(53261,'61705','S','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.479451,-88.950862,0,'2013-07-06 12:44:33',NULL,NULL),(59918,'71286','S','Transylvania','D','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.664934,-91.254060,0,'2013-07-06 12:44:33',NULL,NULL),(37070,'41314','S','Green Hall','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(39661,'45011','S','Indian Spgs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(48363,'55551','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816089,-93.919872,0,'2013-07-06 12:44:33',NULL,NULL),(61786,'73075','S','Pauls Valley','D','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.759938,-97.206699,0,'2013-07-06 12:44:33',NULL,NULL),(24957,'27834','S','Greenville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.626380,-77.438580,0,'2013-07-06 12:44:31',NULL,NULL),(25134,'28012','S','Belmont','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.243718,-81.036410,0,'2013-07-06 12:44:31',NULL,NULL),(37687,'42234','S','Guthrie','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.695643,-87.176930,0,'2013-07-06 12:44:32',NULL,NULL),(21755,'23056','S','Mobjack','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.451410,-76.385042,0,'2013-07-06 12:44:31',NULL,NULL),(73568,'91371','U','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.181136,-118.570613,0,'2013-07-06 12:44:34',NULL,NULL),(74828,'93232','P','Hanford','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.235654,-119.707191,0,'2013-07-06 12:44:34',NULL,NULL),(56322,'65105','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.577411,-92.174184,0,'2013-07-06 12:44:33',NULL,NULL),(79047,'98409','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.207636,-122.478327,0,'2013-07-06 12:44:34',NULL,NULL),(7128,'06385','S','Waterford','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.347357,-72.147670,0,'2013-07-06 12:44:30',NULL,NULL),(38686,'43976','S','Hopedale','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.366816,-80.907190,0,'2013-07-06 12:44:32',NULL,NULL),(35974,'40108','S','Brandenburg','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.982152,-86.130383,0,'2013-07-06 12:44:32',NULL,NULL),(3221,'01367','S','Rowe','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.689349,-72.935421,0,'2013-07-06 12:44:30',NULL,NULL),(20824,'21627','S','Crocheron','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.237770,-76.050194,0,'2013-07-06 12:44:31',NULL,NULL),(20846,'21651','S','Millington','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.257385,-75.837093,0,'2013-07-06 12:44:31',NULL,NULL),(74238,'92325','P','Lake Gregory','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.241417,-117.277125,0,'2013-07-06 12:44:34',NULL,NULL),(61762,'73053','S','Lookeba','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.370593,-98.394538,0,'2013-07-06 12:44:33',NULL,NULL),(25440,'28310','U','Fort Bragg Military','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.138766,-79.000019,0,'2013-07-06 12:44:31',NULL,NULL),(23307,'25202','S','Tornado','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.340295,-81.846193,0,'2013-07-06 12:44:31',NULL,NULL),(45255,'50661','P','North Washington','D','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.057551,-92.312724,0,'2013-07-06 12:44:32',NULL,NULL),(52096,'60411','S','Lynwood','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(60310,'71454','S','Verda','A','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(75423,'94028','S','Menlo Park','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.379860,-122.208569,0,'2013-07-06 12:44:34',NULL,NULL),(18076,'18705','S','Parsons','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(25150,'28024','P','Cliffside','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.237391,-81.743376,0,'2013-07-06 12:44:31',NULL,NULL),(56423,'65259','S','Huntsville','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.435709,-92.545665,0,'2013-07-06 12:44:33',NULL,NULL),(74975,'93437','S','Vandenbrg AFB','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.738800,-120.525060,0,'2013-07-06 12:44:34',NULL,NULL),(17617,'18045','S','Palmer Township','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(23050,'24868','S','Ashland','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(9281,'09630','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(70196,'84338','S','Trenton','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.929311,-111.932730,0,'2013-07-06 12:44:34',NULL,NULL),(79189,'98531','S','Grand Mound','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.723564,-122.958491,0,'2013-07-06 12:44:34',NULL,NULL),(65268,'77474','S','Millheim','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.783576,-96.158093,0,'2013-07-06 12:44:34',NULL,NULL),(26489,'29164','S','Rocky Springs','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(7681,'07099','U','USPS','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.753847,-74.119960,0,'2013-07-06 12:44:30',NULL,NULL),(55384,'63624','S','Bismarck','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.770124,-90.624578,0,'2013-07-06 12:44:33',NULL,NULL),(4426,'03235','S','Franklin','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.437900,-71.664660,0,'2013-07-06 12:44:30',NULL,NULL),(64749,'76930','S','Barnhart','D','Irion','48235','Texas','TX','48','0000','325','Central',-6.0,'Y',31.190776,-101.192246,0,'2013-07-06 12:44:34',NULL,NULL),(47676,'54949','S','Manawa','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.465057,-88.920215,0,'2013-07-06 12:44:33',NULL,NULL),(48746,'55971','S','Rushford','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(31775,'35016','S','Arab','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.321343,-86.497114,0,'2013-07-06 12:44:32',NULL,NULL),(74684,'92880','S','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.925761,-117.614694,0,'2013-07-06 12:44:34',NULL,NULL),(76746,'95916','S','Berry Creek','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.638726,-121.386666,0,'2013-07-06 12:44:34',NULL,NULL),(69984,'84121','S','Holladay','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(21156,'22125','P','Occoquan','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.681319,-77.261520,0,'2013-07-06 12:44:31',NULL,NULL),(13067,'13452','S','Kringsbush','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(14556,'15212','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.469880,-80.015700,0,'2013-07-06 12:44:31',NULL,NULL),(6877,'06138','P','Silver Lane','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.761680,-72.612610,0,'2013-07-06 12:44:30',NULL,NULL),(53247,'61701','S','Bloomington Heights','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(57039,'66209','S','Leawood','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(38318,'43406','S','Bradner','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.330225,-83.442064,0,'2013-07-06 12:44:32',NULL,NULL),(38699,'44001','S','South Amherst','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(51571,'59758','S','West Yellowstone','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',44.711443,-111.150995,0,'2013-07-06 12:44:33',NULL,NULL),(48547,'55760','S','McGregor','D','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(34625,'38756','S','Dunleith','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(25947,'28657','S','Chestnut Dale','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(72624,'89418','S','Unionville','A','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(48019,'55187','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.947433,-92.911685,0,'2013-07-06 12:44:33',NULL,NULL),(62982,'75144','S','Kerens','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.128167,-96.225164,0,'2013-07-06 12:44:33',NULL,NULL),(43354,'48390','S','Commerce Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(48221,'55416','S','Saint Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.948525,-93.344253,0,'2013-07-06 12:44:33',NULL,NULL),(56000,'64643','S','Hale','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.569873,-93.346196,0,'2013-07-06 12:44:33',NULL,NULL),(63479,'75688','P','Scottsville','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.534173,-94.240709,0,'2013-07-06 12:44:33',NULL,NULL),(25210,'28080','S','Iron Station','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.457153,-81.109510,0,'2013-07-06 12:44:31',NULL,NULL),(31566,'34613','S','Spring Hill','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.556846,-82.518576,0,'2013-07-06 12:44:32',NULL,NULL),(16694,'17401','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.961048,-76.728662,0,'2013-07-06 12:44:31',NULL,NULL),(11502,'12025','S','Galway Lake','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(78192,'97731','S','Chemult','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.065300,-121.849920,0,'2013-07-06 12:44:34',NULL,NULL),(63510,'75751','S','Athens','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(42588,'47884','P','Universal','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.650931,-87.462343,0,'2013-07-06 12:44:32',NULL,NULL),(13491,'13803','S','Freetown Corners','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(47071,'54426','S','Poniatowski','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.892081,-89.992307,0,'2013-07-06 12:44:32',NULL,NULL),(56818,'65781','S','Willard','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.304579,-93.436613,0,'2013-07-06 12:44:33',NULL,NULL),(1313,'00735','S','Jard de Ceiba','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(59126,'70159','U','C O Enl Pers Mgmt Cen','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.969507,-90.028428,0,'2013-07-06 12:44:33',NULL,NULL),(37289,'41616','S','David','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.611701,-82.894020,0,'2013-07-06 12:44:32',NULL,NULL),(67444,'80208','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.680475,-104.962996,0,'2013-07-06 12:44:34',NULL,NULL),(24501,'27263','S','Archdale','A','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.908020,-79.980120,0,'2013-07-06 12:44:31',NULL,NULL),(18610,'19145','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.924229,-75.186845,0,'2013-07-06 12:44:31',NULL,NULL),(48762,'55979','S','Fremont','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.945993,-91.935120,0,'2013-07-06 12:44:33',NULL,NULL),(48827,'56039','S','Granada','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.700103,-94.342434,0,'2013-07-06 12:44:33',NULL,NULL),(49156,'56385','S','Westport','A','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.688264,-95.116517,0,'2013-07-06 12:44:33',NULL,NULL),(61009,'72114','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(20752,'21405','S','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.978333,-76.492500,0,'2013-07-06 12:44:31',NULL,NULL),(67457,'80215','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745057,-105.104454,0,'2013-07-06 12:44:34',NULL,NULL),(8413,'08071','S','Pitman','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.728778,-75.128308,0,'2013-07-06 12:44:30',NULL,NULL),(76993,'96073','S','Palo Cedro','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.570792,-122.236172,0,'2013-07-06 12:44:34',NULL,NULL),(66625,'78783','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.246407,-97.766387,0,'2013-07-06 12:44:34',NULL,NULL),(60191,'71418','S','Brownville','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(27390,'30083','S','Stone Mountain','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.789125,-84.199181,0,'2013-07-06 12:44:31',NULL,NULL),(66877,'79227','S','Truscott','A','Foard','48155','Texas','TX','48','0000','254','Central',-6.0,'Y',33.988449,-99.725128,0,'2013-07-06 12:44:34',NULL,NULL),(69783,'84061','S','Peoa','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.714412,-111.334069,0,'2013-07-06 12:44:34',NULL,NULL),(17211,'17823','S','Little Mahany','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.757282,-76.762227,0,'2013-07-06 12:44:31',NULL,NULL),(1168,'00727','S','Urb Diamond Vlg','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(41683,'47177','S','Underwood','D','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.515160,-85.760406,0,'2013-07-06 12:44:32',NULL,NULL),(5075,'04290','S','Peru','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.474094,-70.449296,0,'2013-07-06 12:44:30',NULL,NULL),(16679,'17362','S','Stoverstown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.874292,-76.864491,0,'2013-07-06 12:44:31',NULL,NULL),(35273,'39365','S','Neshoba','N','Neshoba','28099','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.570827,-89.121425,0,'2013-07-06 12:44:32',NULL,NULL),(41263,'46750','S','Bowerstown','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(17767,'18334','S','Long Pond','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.094457,-75.430166,0,'2013-07-06 12:44:31',NULL,NULL),(19041,'19539','S','Shamrock Station','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(16378,'17202','S','Guilford Township','A','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.941877,-77.673910,0,'2013-07-06 12:44:31',NULL,NULL),(76832,'95960','S','Pike','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.339635,-121.132146,0,'2013-07-06 12:44:34',NULL,NULL),(50661,'58330','S','Edmore','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.458045,-98.448032,0,'2013-07-06 12:44:33',NULL,NULL),(8497,'08096','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(7669,'07093','S','Guttenberg','A','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.788201,-74.013854,0,'2013-07-06 12:44:30',NULL,NULL),(32417,'35972','S','Gallant','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.994384,-86.227809,0,'2013-07-06 12:44:32',NULL,NULL),(24797,'27591','S','Eagle Rock','A','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.792984,-78.387755,0,'2013-07-06 12:44:31',NULL,NULL),(53997,'62444','S','Beecher City','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.278154,-88.636713,0,'2013-07-06 12:44:33',NULL,NULL),(29502,'32757','S','Mount Dora','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.774120,-81.628286,0,'2013-07-06 12:44:32',NULL,NULL),(31302,'34098','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(9871,'10122','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(15454,'16410','S','Cranesville','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.919000,-80.316949,0,'2013-07-06 12:44:31',NULL,NULL),(37199,'41520','P','Dorton','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.276554,-82.581764,0,'2013-07-06 12:44:32',NULL,NULL),(8870,'08691','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(19123,'19608','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(22738,'24380','S','Willis','D','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.866498,-80.493020,0,'2013-07-06 12:44:31',NULL,NULL),(34060,'38141','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.026360,-89.847033,0,'2013-07-06 12:44:32',NULL,NULL),(48458,'55711','S','Stoney Brook','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.856672,-92.673076,0,'2013-07-06 12:44:33',NULL,NULL),(8228,'07977','P','Peapack','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.711589,-74.659396,0,'2013-07-06 12:44:30',NULL,NULL),(12473,'12985','S','Peasleeville','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.578980,-73.716120,0,'2013-07-06 12:44:30',NULL,NULL),(13575,'13843','S','S New Berlin','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(50641,'58310','S','Agate','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.623090,-99.439060,0,'2013-07-06 12:44:33',NULL,NULL),(26358,'29070','S','Lake Murray Shores','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(76901,'95983','S','Taylorsville','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.058340,-120.710520,0,'2013-07-06 12:44:34',NULL,NULL),(43052,'48183','S','Woodhaven','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(30674,'33469','S','Jupiter Inlet','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.960459,-80.098465,0,'2013-07-06 12:44:32',NULL,NULL),(4801,'03883','S','So Tamworth','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.839632,-71.313989,0,'2013-07-06 12:44:30',NULL,NULL),(51049,'58736','S','Drake','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.926901,-100.372610,0,'2013-07-06 12:44:33',NULL,NULL),(13746,'14112','P','North Evans','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.697844,-78.984930,0,'2013-07-06 12:44:31',NULL,NULL),(68774,'82323','S','Dixon','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.091246,-107.534368,0,'2013-07-06 12:44:34',NULL,NULL),(80033,'99692','P','Dutch Harbor','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',53.880000,-166.530000,0,'2013-07-06 12:44:34',NULL,NULL),(51534,'59720','S','Cameron','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',44.977680,-111.619208,0,'2013-07-06 12:44:33',NULL,NULL),(59989,'71327','S','Longbridge','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.988947,-92.052747,0,'2013-07-06 12:44:33',NULL,NULL),(17429,'17929','S','Cressona','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.628948,-76.193868,0,'2013-07-06 12:44:31',NULL,NULL),(76509,'95641','S','Bouldin Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.145589,-121.598217,0,'2013-07-06 12:44:34',NULL,NULL),(30051,'33145','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753248,-80.236857,0,'2013-07-06 12:44:32',NULL,NULL),(13074,'13455','P','Sangerfield','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.916248,-75.381705,0,'2013-07-06 12:44:30',NULL,NULL),(20434,'20918','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.020818,-77.016371,0,'2013-07-06 12:44:31',NULL,NULL),(28379,'31297','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.808857,-83.690683,0,'2013-07-06 12:44:32',NULL,NULL),(59081,'70118','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.954635,-90.123422,0,'2013-07-06 12:44:33',NULL,NULL),(39422,'44676','S','Shreve','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.697236,-82.034128,0,'2013-07-06 12:44:32',NULL,NULL),(35838,'39773','S','West Point','D','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.629580,-88.664280,0,'2013-07-06 12:44:32',NULL,NULL),(35565,'39567','S','Navy Homeport','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(732,'00687','S','Vista Verde','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(65641,'77964','S','Worthing','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(76079,'95210','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.026084,-121.295564,0,'2013-07-06 12:44:34',NULL,NULL),(69466,'83654','S','New Meadows','D','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.980560,-116.263800,0,'2013-07-06 12:44:34',NULL,NULL),(67379,'80121','S','Grants Ranch','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(60271,'71447','S','Lena','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(17730,'18251','P','Sybertsville','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.000088,-76.077993,0,'2013-07-06 12:44:31',NULL,NULL),(5962,'05301','S','Guilford Center','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(32767,'36361','P','Ozark','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.454462,-85.647963,0,'2013-07-06 12:44:32',NULL,NULL),(48939,'56162','S','Ormsby','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.849621,-94.700156,0,'2013-07-06 12:44:33',NULL,NULL),(12275,'12837','S','Hampton','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.519469,-73.252209,0,'2013-07-06 12:44:30',NULL,NULL),(20365,'20878','S','Darnestown','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.105531,-77.240190,0,'2013-07-06 12:44:31',NULL,NULL),(61823,'73109','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.433770,-97.518393,0,'2013-07-06 12:44:33',NULL,NULL),(68038,'80929','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.814846,-104.619185,0,'2013-07-06 12:44:34',NULL,NULL),(43748,'49007','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.298764,-85.610796,0,'2013-07-06 12:44:32',NULL,NULL),(30712,'33499','U','Seta Corporation','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.409609,-80.106315,0,'2013-07-06 12:44:32',NULL,NULL),(420,'00662','S','Repto Villa Y Mar','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(60474,'71655','S','Monticello','D','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(66376,'78621','S','Littig','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(74776,'93110','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.438801,-119.766004,0,'2013-07-06 12:44:34',NULL,NULL),(65225,'77445','S','Prairie View','A','Waller','48473','Texas','TX','48','3360','979','Central',-6.0,'Y',30.072120,-96.081240,0,'2013-07-06 12:44:34',NULL,NULL),(28701,'31822','S','Pine Mountain','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.898928,-84.925175,0,'2013-07-06 12:44:32',NULL,NULL),(13043,'13439','S','Richfld Spgs','A','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(16307,'17112','S','Lower Paxton','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.338060,-76.803780,0,'2013-07-06 12:44:31',NULL,NULL),(18173,'18918','P','Earlington','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.323908,-75.377108,0,'2013-07-06 12:44:31',NULL,NULL),(29258,'32455','S','Bruce','A','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.771038,-85.953835,0,'2013-07-06 12:44:32',NULL,NULL),(935,'00715','S','Bo La Cuarta','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(44272,'49706','S','Alanson','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.445809,-84.801513,0,'2013-07-06 12:44:32',NULL,NULL),(29825,'33028','S','Pembroke Pines','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028900,-80.344700,0,'2013-07-06 12:44:32',NULL,NULL),(13899,'14273','U','HSBC Atrium','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870716,-78.869699,0,'2013-07-06 12:44:31',NULL,NULL),(35291,'39401','S','Lamar Park','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(59937,'71295','S','Bushes','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.158360,-91.723430,0,'2013-07-06 12:44:33',NULL,NULL),(62040,'73521','S','Altus','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.642895,-99.327035,0,'2013-07-06 12:44:33',NULL,NULL),(69043,'83221','S','Thomas Junction','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(72010,'88041','S','Sherman','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.746667,-107.885833,0,'2013-07-06 12:44:34',NULL,NULL),(73020,'90069','S','West Hollywood','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091537,-118.382020,0,'2013-07-06 12:44:34',NULL,NULL),(17059,'17756','S','Clarkstown','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(72404,'89044','S','Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.994630,-115.118970,0,'2013-07-06 12:44:34',NULL,NULL),(72051,'88102','P','Clovis','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.392564,-103.215768,0,'2013-07-06 12:44:34',NULL,NULL),(7403,'06793','S','Washington Dt','A','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.640788,-73.293104,0,'2013-07-06 12:44:30',NULL,NULL),(49174,'56401','S','E Gull Lake','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341720,-94.142280,0,'2013-07-06 12:44:33',NULL,NULL),(6565,'05851','S','East Lyndon','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544120,-72.021300,0,'2013-07-06 12:44:30',NULL,NULL),(28488,'31520','S','Altama','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.178679,-81.489022,0,'2013-07-06 12:44:32',NULL,NULL),(34664,'38801','S','Chesterville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.233855,-88.738853,0,'2013-07-06 12:44:32',NULL,NULL),(77767,'97116','S','Glenwood','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.522072,-123.107074,0,'2013-07-06 12:44:34',NULL,NULL),(75019,'93464','P','Solvang','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.554223,-120.141779,0,'2013-07-06 12:44:34',NULL,NULL),(20025,'20627','P','Compton','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.305008,-76.632014,0,'2013-07-06 12:44:31',NULL,NULL),(46458,'53213','S','Wauwatosa','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.049511,-88.005322,0,'2013-07-06 12:44:32',NULL,NULL),(32512,'36081','S','Troy','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.799767,-85.963152,0,'2013-07-06 12:44:32',NULL,NULL),(8863,'08666','U','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.219539,-74.769690,0,'2013-07-06 12:44:30',NULL,NULL),(58435,'68669','S','Ulysses','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.070396,-97.202236,0,'2013-07-06 12:44:33',NULL,NULL),(31662,'34747','S','Reunion','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.297785,-81.613279,0,'2013-07-06 12:44:32',NULL,NULL),(74012,'92118','S','San Diego','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.659560,-117.159480,0,'2013-07-06 12:44:34',NULL,NULL),(68966,'83013','S','Colter Bay','N','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.940831,-110.310607,0,'2013-07-06 12:44:34',NULL,NULL),(39510,'44809','P','Bascom','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.133459,-83.284306,0,'2013-07-06 12:44:32',NULL,NULL),(39978,'45239','S','Colerain TWP','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(40728,'46124','S','Edinburgh','D','Johnson','18081','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.353574,-85.964085,0,'2013-07-06 12:44:32',NULL,NULL),(42381,'47720','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.032487,-87.631363,0,'2013-07-06 12:44:32',NULL,NULL),(46891,'54119','S','Dunbar','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.620520,-88.145700,0,'2013-07-06 12:44:32',NULL,NULL),(46923,'54151','S','Niagara','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.751192,-88.002009,0,'2013-07-06 12:44:32',NULL,NULL),(27550,'30251','S','Luthersville','D','Meriwether','13199','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.209532,-84.744840,0,'2013-07-06 12:44:31',NULL,NULL),(7334,'06708','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.552917,-73.066488,0,'2013-07-06 12:44:30',NULL,NULL),(44594,'50047','S','Avon','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.477985,-93.476846,0,'2013-07-06 12:44:32',NULL,NULL),(40346,'45621','P','Coalton','D','Jackson','39079','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.118612,-82.531374,0,'2013-07-06 12:44:32',NULL,NULL),(61435,'72581','S','Tumbling Shoals','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.549597,-91.952473,0,'2013-07-06 12:44:33',NULL,NULL),(62520,'74403','S','Musk','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.740245,-95.348429,0,'2013-07-06 12:44:33',NULL,NULL),(66793,'79057','S','McLean','D','Gray','48179','Texas','TX','48','0000','806','Central',-6.0,'Y',35.234970,-100.598223,0,'2013-07-06 12:44:34',NULL,NULL),(42072,'47452','S','Syria','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(37653,'42204','S','Allensville','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.704760,-87.049860,0,'2013-07-06 12:44:32',NULL,NULL),(38800,'44065','S','Newbury','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.464982,-81.238490,0,'2013-07-06 12:44:32',NULL,NULL),(69694,'84029','S','Lakeside','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.604525,-112.456180,0,'2013-07-06 12:44:34',NULL,NULL),(24534,'27292','S','Arcadia','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(50694,'58356','S','Brantford','A','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.684884,-99.133524,0,'2013-07-06 12:44:33',NULL,NULL),(46342,'53091','S','Theresa','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.516681,-88.453725,0,'2013-07-06 12:44:32',NULL,NULL),(36119,'40222','S','Lyndon','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(57309,'66636','U','Security Benefit Life','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.056337,-95.675658,0,'2013-07-06 12:44:33',NULL,NULL),(57819,'67522','S','Buhler','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.135527,-97.777796,0,'2013-07-06 12:44:33',NULL,NULL),(42537,'47862','S','West Union','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.789289,-87.373004,0,'2013-07-06 12:44:32',NULL,NULL),(43096,'48214','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.366513,-82.993799,0,'2013-07-06 12:44:32',NULL,NULL),(38137,'43128','S','Jeffersonville','D','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.656660,-83.573926,0,'2013-07-06 12:44:32',NULL,NULL),(10990,'11548','S','Greenvale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(20689,'21240','S','Baltimore','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.175794,-76.666332,0,'2013-07-06 12:44:31',NULL,NULL),(20850,'21655','S','Preston','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.734621,-75.904802,0,'2013-07-06 12:44:31',NULL,NULL),(26281,'29020','S','Antioch','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(5231,'04468','S','Alton','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.930939,-68.654151,0,'2013-07-06 12:44:30',NULL,NULL),(55528,'63826','P','Braggadocio','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.177959,-89.673229,0,'2013-07-06 12:44:33',NULL,NULL),(20887,'21702','S','College Estates','N','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.494400,-77.453520,0,'2013-07-06 12:44:31',NULL,NULL),(15766,'16915','S','Summit','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(9310,'09722','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(16960,'17702','S','S Williamsport','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(14874,'15469','S','Normalville','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.027712,-79.405194,0,'2013-07-06 12:44:31',NULL,NULL),(41716,'47240','S','Greensburg','D','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(26512,'29175','S','Westville','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.447043,-80.601334,0,'2013-07-06 12:44:31',NULL,NULL),(3189,'01342','S','East Deerfield','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.553684,-72.589272,0,'2013-07-06 12:44:30',NULL,NULL),(53779,'62275','S','Millersburg','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770822,-89.501779,0,'2013-07-06 12:44:33',NULL,NULL),(15881,'17003','S','Ft Indiantown','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(5517,'04776','S','Sherman','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.815245,-68.309550,0,'2013-07-06 12:44:30',NULL,NULL),(64264,'76388','S','Weinert','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.325271,-99.612451,0,'2013-07-06 12:44:34',NULL,NULL),(63151,'75380','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.931693,-96.815948,0,'2013-07-06 12:44:33',NULL,NULL),(72576,'89404','P','Dike','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(25812,'28607','S','Shulls Mills','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(43428,'48472','S','Snover','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.521197,-82.956304,0,'2013-07-06 12:44:32',NULL,NULL),(12128,'12604','U','Vassar College','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.685996,-73.896069,0,'2013-07-06 12:44:30',NULL,NULL),(80091,'99743','S','Healy','D','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.896190,-148.529630,0,'2013-07-06 12:44:34',NULL,NULL),(15760,'16915','S','Homer','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(20338,'20852','S','No Bethesda','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.046797,-77.119654,0,'2013-07-06 12:44:31',NULL,NULL),(19870,'20527','U','Oversea Pvt Inves Corp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901910,-77.025942,0,'2013-07-06 12:44:31',NULL,NULL),(71405,'87015','S','Edgewood','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.038748,-106.187474,0,'2013-07-06 12:44:34',NULL,NULL),(38378,'43502','S','Archbold','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.536104,-84.296476,0,'2013-07-06 12:44:32',NULL,NULL),(43915,'49258','P','Mosherville','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.058745,-84.656404,0,'2013-07-06 12:44:32',NULL,NULL),(45827,'52210','S','Brandon','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.314232,-92.005487,0,'2013-07-06 12:44:32',NULL,NULL),(28924,'32160','P','Lake Geneva','D','Clay','12019','Florida','FL','12','3600','352','Eastern',-5.0,'Y',29.773028,-82.010181,0,'2013-07-06 12:44:32',NULL,NULL),(33270,'37097','S','Lobelville','D','Perry','47135','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.778644,-87.786538,0,'2013-07-06 12:44:32',NULL,NULL),(8905,'08734','S','Lanoka Harbor','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.860897,-74.165767,0,'2013-07-06 12:44:30',NULL,NULL),(52178,'60461','S','Olympia Fields','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.515245,-87.687123,0,'2013-07-06 12:44:33',NULL,NULL),(60924,'72083','P','Keo','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.607506,-92.002984,0,'2013-07-06 12:44:33',NULL,NULL),(62110,'73639','S','Custer City','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.693460,-98.923920,0,'2013-07-06 12:44:33',NULL,NULL),(12212,'12801','S','Glens Falls','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.308900,-73.644600,0,'2013-07-06 12:44:30',NULL,NULL),(57087,'66217','S','Quivira','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(34535,'38701','S','Crossroads','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.288780,-90.990720,0,'2013-07-06 12:44:32',NULL,NULL),(29780,'33015','S','Hialeah Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940770,-80.315677,0,'2013-07-06 12:44:32',NULL,NULL),(50092,'57469','S','Zell','A','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.874469,-98.514591,0,'2013-07-06 12:44:33',NULL,NULL),(4812,'03896','P','Wolfeboro Falls','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.587884,-71.207648,0,'2013-07-06 12:44:30',NULL,NULL),(49448,'56644','S','Berner','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.849231,-95.480640,0,'2013-07-06 12:44:33',NULL,NULL),(17091,'17764','S','South Renovo','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(39154,'44287','S','West Salem','D','Wayne','39169','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.925833,-82.053056,0,'2013-07-06 12:44:32',NULL,NULL),(39869,'45204','S','Queen City','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.099986,-84.570300,0,'2013-07-06 12:44:32',NULL,NULL),(44109,'49504','S','Standale','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.986465,-85.721042,0,'2013-07-06 12:44:32',NULL,NULL),(62402,'74114','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.125061,-95.950201,0,'2013-07-06 12:44:33',NULL,NULL),(73948,'92056','S','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.214630,-117.289157,0,'2013-07-06 12:44:34',NULL,NULL),(65496,'77660','S','Spurger','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.726667,-94.171785,0,'2013-07-06 12:44:34',NULL,NULL),(4291,'02901','P','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.826825,-71.407999,0,'2013-07-06 12:44:30',NULL,NULL),(53040,'61478','S','Smithshire','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.722363,-90.727749,0,'2013-07-06 12:44:33',NULL,NULL),(10460,'10927','S','Haverstraw','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.199797,-73.969661,0,'2013-07-06 12:44:30',NULL,NULL),(56313,'65101','S','Wardsville','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (619,'00682','S','Bo El Seco','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(27503,'30176','S','Tallapoosa','D','Haralson','13143','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.753316,-85.291849,0,'2013-07-06 12:44:31',NULL,NULL),(37083,'41339','S','Athol','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(60048,'71346','S','Latanier','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(35804,'39759','S','Blackjack','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(35982,'40118','S','Fairdale','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.110096,-85.755717,0,'2013-07-06 12:44:32',NULL,NULL),(7692,'07106','S','Vailsburg','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.740457,-74.232487,0,'2013-07-06 12:44:30',NULL,NULL),(49143,'56374','S','St Joseph','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.586745,-94.330030,0,'2013-07-06 12:44:33',NULL,NULL),(17787,'18351','P','Portland','D','Northampton','42095','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.927735,-75.103214,0,'2013-07-06 12:44:31',NULL,NULL),(64667,'76821','S','Ballinger','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.734120,-99.961500,0,'2013-07-06 12:44:34',NULL,NULL),(76871,'95972','S','Rackerby','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.433834,-121.327998,0,'2013-07-06 12:44:34',NULL,NULL),(68181,'81021','S','Arlington','D','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.390735,-103.369404,0,'2013-07-06 12:44:34',NULL,NULL),(31961,'35211','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473968,-86.862639,0,'2013-07-06 12:44:32',NULL,NULL),(55052,'63146','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.695246,-90.458647,0,'2013-07-06 12:44:33',NULL,NULL),(7138,'06404','P','Botsford','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.361821,-73.213615,0,'2013-07-06 12:44:30',NULL,NULL),(51468,'59528','S','Hingham','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.595491,-110.425625,0,'2013-07-06 12:44:33',NULL,NULL),(3482,'01833','S','Georgetown','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.724680,-70.975800,0,'2013-07-06 12:44:30',NULL,NULL),(77158,'96206','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72150,'88324','S','Glencoe','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.406087,-105.515545,0,'2013-07-06 12:44:34',NULL,NULL),(32856,'36507','S','Bromley','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.874562,-87.775538,0,'2013-07-06 12:44:32',NULL,NULL),(14687,'15253','P','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.460709,-80.020311,0,'2013-07-06 12:44:31',NULL,NULL),(10655,'11104','S','Astoria','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.744648,-73.917792,0,'2013-07-06 12:44:30',NULL,NULL),(52815,'61283','S','Hahnaman','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.637702,-89.784655,0,'2013-07-06 12:44:33',NULL,NULL),(17514,'17963','S','Suedburg','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(3685,'02131','S','Roslindale','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.284730,-71.127697,0,'2013-07-06 12:44:30',NULL,NULL),(31096,'33880','S','Eloise','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.996505,-81.752285,0,'2013-07-06 12:44:32',NULL,NULL),(68293,'81090','S','Stonington','A','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.351772,-102.260430,0,'2013-07-06 12:44:34',NULL,NULL),(51002,'58656','S','Taylor','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.951621,-102.315515,0,'2013-07-06 12:44:33',NULL,NULL),(5556,'04854','S','Owls Head','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.081327,-69.086543,0,'2013-07-06 12:44:30',NULL,NULL),(34026,'38130','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.032451,-89.938116,0,'2013-07-06 12:44:32',NULL,NULL),(36503,'40823','S','Chad','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.975189,-82.986975,0,'2013-07-06 12:44:32',NULL,NULL),(23570,'25651','S','Wharncliffe','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.550333,-81.977593,0,'2013-07-06 12:44:31',NULL,NULL),(54259,'62675','S','Petersburg','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.003483,-89.851315,0,'2013-07-06 12:44:33',NULL,NULL),(8139,'07837','P','Glasser','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.972319,-74.636884,0,'2013-07-06 12:44:30',NULL,NULL),(54697,'62950','S','Neunert','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.747337,-89.546002,0,'2013-07-06 12:44:33',NULL,NULL),(73838,'91788','P','Walnut','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.013703,-117.863721,0,'2013-07-06 12:44:34',NULL,NULL),(21273,'22311','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.835786,-77.127498,0,'2013-07-06 12:44:31',NULL,NULL),(22792,'24465','S','Hightown','A','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.379939,-79.640160,0,'2013-07-06 12:44:31',NULL,NULL),(38472,'43623','S','Sylvania Twp','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.707048,-83.649692,0,'2013-07-06 12:44:32',NULL,NULL),(41382,'46797','S','Woodburn','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.130094,-84.866509,0,'2013-07-06 12:44:32',NULL,NULL),(24753,'27534','S','Goldsboro','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.370546,-77.930853,0,'2013-07-06 12:44:31',NULL,NULL),(55558,'63860','P','Kewanee','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.673159,-89.572175,0,'2013-07-06 12:44:33',NULL,NULL),(58342,'68466','S','Sicily','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.118874,-96.667542,0,'2013-07-06 12:44:33',NULL,NULL),(4758,'03850','P','Melvin Village','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.691873,-71.296061,0,'2013-07-06 12:44:30',NULL,NULL),(32532,'36103','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.397938,-86.326829,0,'2013-07-06 12:44:32',NULL,NULL),(2431,'00953','S','Urb Las Cascadas','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(8154,'07851','S','Layton','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.202354,-74.835004,0,'2013-07-06 12:44:30',NULL,NULL),(79229,'98550','S','Gray Gables','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(77266,'96599','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(28719,'31903','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.425356,-84.945749,0,'2013-07-06 12:44:32',NULL,NULL),(34319,'38556','S','Jamestown','D','Fentress','47049','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.411279,-84.937606,0,'2013-07-06 12:44:32',NULL,NULL),(34950,'39058','U','Ms College','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.342830,-90.324199,0,'2013-07-06 12:44:32',NULL,NULL),(64472,'76577','S','Nile','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(64311,'76469','P','Putnam','D','Callahan','48059','Texas','TX','48','0000','325','Central',-6.0,'Y',32.374680,-99.200657,0,'2013-07-06 12:44:34',NULL,NULL),(17534,'17976','S','Ellen Gowan','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(14690,'15254','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441088,-79.998276,0,'2013-07-06 12:44:31',NULL,NULL),(58047,'68026','P','Fremont','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.440321,-96.489748,0,'2013-07-06 12:44:33',NULL,NULL),(53639,'62201','S','Sauget','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(16536,'17301','S','Abbottstown','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.885968,-76.997348,0,'2013-07-06 12:44:31',NULL,NULL),(58716,'68937','S','Johnson Lake','A','Gosper','31073','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.557840,-99.856380,0,'2013-07-06 12:44:33',NULL,NULL),(14630,'15233','S','Kilbuck','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.457777,-80.026332,0,'2013-07-06 12:44:31',NULL,NULL),(25691,'28526','S','Fort Barnwell','N','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.267460,-77.374020,0,'2013-07-06 12:44:31',NULL,NULL),(53142,'61554','S','Normandale','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(79130,'98498','S','Lakewood','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162978,-122.560507,0,'2013-07-06 12:44:34',NULL,NULL),(77918,'97314','U','Dept Motor Vehicle','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.966960,-123.004587,0,'2013-07-06 12:44:34',NULL,NULL),(73056,'90090','U','Los Angeles Dodgers','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.013223,-118.138227,0,'2013-07-06 12:44:34',NULL,NULL),(877,'00698','S','VISTAS de Monte Sol','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(49696,'57027','S','Fairview','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.207357,-96.590848,0,'2013-07-06 12:44:33',NULL,NULL),(11041,'11571','P','Rockville Center','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.657461,-73.648593,0,'2013-07-06 12:44:30',NULL,NULL),(46153,'52701','P','Andover','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.987315,-90.239923,0,'2013-07-06 12:44:32',NULL,NULL),(43684,'48876','S','Potterville','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.639064,-84.737396,0,'2013-07-06 12:44:32',NULL,NULL),(77015,'96091','S','Trinity Center','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',41.087390,-122.716384,0,'2013-07-06 12:44:34',NULL,NULL),(24108,'26525','S','Brandonville','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.646175,-79.624337,0,'2013-07-06 12:44:31',NULL,NULL),(40539,'45843','S','Forest','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.777616,-83.537432,0,'2013-07-06 12:44:32',NULL,NULL),(24658,'27405','S','Summit','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(9160,'09320','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(50846,'58486','S','Sykeston','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.410353,-99.392030,0,'2013-07-06 12:44:33',NULL,NULL),(40678,'46060','S','Strawtown','N','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.040132,-86.005910,0,'2013-07-06 12:44:32',NULL,NULL),(39675,'45014','S','Indian Spgs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.334440,-84.562260,0,'2013-07-06 12:44:32',NULL,NULL),(70687,'85253','S','Scottsdale','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.546000,-111.968280,0,'2013-07-06 12:44:34',NULL,NULL),(20985,'21811','S','Ocean Pines','A','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.310240,-75.234480,0,'2013-07-06 12:44:31',NULL,NULL),(38984,'44131','S','Independence','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(27752,'30359','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.822811,-84.323174,0,'2013-07-06 12:44:31',NULL,NULL),(10032,'10172','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(4655,'03756','P','Dartmouth Hitchcock Med Ctr','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.637006,-72.252383,0,'2013-07-06 12:44:30',NULL,NULL),(44426,'49840','S','Gulliver','D','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.113640,-86.008147,0,'2013-07-06 12:44:32',NULL,NULL),(6031,'05403','S','So Burlington','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(43166,'48268','U','DTE Energy','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331348,-83.048397,0,'2013-07-06 12:44:32',NULL,NULL),(63163,'75393','U','SBC ATT','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.801369,-96.790487,0,'2013-07-06 12:44:33',NULL,NULL),(46294,'53051','S','Menomonee Falls','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.145602,-88.115779,0,'2013-07-06 12:44:32',NULL,NULL),(64745,'76908','S','Goodfelow AFB','A','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.387191,-100.562725,0,'2013-07-06 12:44:34',NULL,NULL),(28315,'31141','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761509,-84.419799,0,'2013-07-06 12:44:31',NULL,NULL),(21039,'21871','S','Easton Correctional Inst','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.097540,-75.760560,0,'2013-07-06 12:44:31',NULL,NULL),(2387,'00949','S','Urb Las Colinas','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(47807,'55054','S','Elko New Market','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.571168,-93.354431,0,'2013-07-06 12:44:33',NULL,NULL),(48476,'55723','S','Bear Lake','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.867400,-92.779260,0,'2013-07-06 12:44:33',NULL,NULL),(37768,'42343','S','Trisler','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.628160,-86.708700,0,'2013-07-06 12:44:32',NULL,NULL),(62070,'73551','S','Hollister','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.362803,-98.885749,0,'2013-07-06 12:44:33',NULL,NULL),(26994,'29626','S','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.444494,-82.754302,0,'2013-07-06 12:44:31',NULL,NULL),(59320,'70525','S','Church Point','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.407410,-92.214247,0,'2013-07-06 12:44:33',NULL,NULL),(5736,'05034','S','Bridgewater','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.572856,-72.617134,0,'2013-07-06 12:44:30',NULL,NULL),(49563,'56716','S','Gentilly','N','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.774782,-96.608300,0,'2013-07-06 12:44:33',NULL,NULL),(57036,'66208','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(55039,'63139','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.612066,-90.290206,0,'2013-07-06 12:44:33',NULL,NULL),(63925,'76055','S','Itasca','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.161273,-97.150457,0,'2013-07-06 12:44:34',NULL,NULL),(60843,'72041','S','De Valls Bluff','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.715356,-91.542833,0,'2013-07-06 12:44:33',NULL,NULL),(23003,'24811','P','Avondale','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.400556,-81.784722,0,'2013-07-06 12:44:31',NULL,NULL),(2389,'00949','S','Urb Levittown','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(17336,'17866','S','Coal Run','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.786065,-76.555465,0,'2013-07-06 12:44:31',NULL,NULL),(54982,'63124','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.642678,-90.378302,0,'2013-07-06 12:44:33',NULL,NULL),(6487,'05772','S','Stockbridge','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.770493,-72.783716,0,'2013-07-06 12:44:30',NULL,NULL),(17350,'17870','S','Selinsgrove','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(72862,'90004','S','Oakwood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.076333,-118.307713,0,'2013-07-06 12:44:34',NULL,NULL),(56742,'65715','S','Noble','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.736051,-92.579387,0,'2013-07-06 12:44:33',NULL,NULL),(55196,'63382','S','Vandalia','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.307467,-91.491613,0,'2013-07-06 12:44:33',NULL,NULL),(26170,'28746','S','Lake Lure','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.452129,-82.190425,0,'2013-07-06 12:44:31',NULL,NULL),(20302,'20815','S','Chevy Chase','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(75810,'94805','S','San Pablo','N','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.943049,-122.320440,0,'2013-07-06 12:44:34',NULL,NULL),(70738,'85308','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.651823,-112.167339,0,'2013-07-06 12:44:34',NULL,NULL),(70495,'84774','S','Toquerville','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.246668,-113.286048,0,'2013-07-06 12:44:34',NULL,NULL),(63532,'75757','S','Mount Selman','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.150666,-95.372322,0,'2013-07-06 12:44:33',NULL,NULL),(59452,'70727','P','Denham Spgs','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.449864,-90.967801,0,'2013-07-06 12:44:33',NULL,NULL),(35519,'39534','P','Keesler AFB','A','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413857,-88.910394,0,'2013-07-06 12:44:32',NULL,NULL),(49488,'56661','S','Dora Lake','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(33451,'37316','P','Conasauga','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.004536,-84.733735,0,'2013-07-06 12:44:32',NULL,NULL),(31778,'35020','S','Brighton','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.400980,-86.941560,0,'2013-07-06 12:44:32',NULL,NULL),(57931,'67730','S','Atwood','D','Rawlins','20153','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.810937,-101.039229,0,'2013-07-06 12:44:33',NULL,NULL),(24214,'26707','P','Wilson','A','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.254167,-79.398056,0,'2013-07-06 12:44:31',NULL,NULL),(67256,'79955','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.763644,-106.480213,0,'2013-07-06 12:44:34',NULL,NULL),(35376,'39452','S','Merrill','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(23617,'25713','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.395658,-82.446172,0,'2013-07-06 12:44:31',NULL,NULL),(23756,'25958','S','Hines','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.989769,-80.689842,0,'2013-07-06 12:44:31',NULL,NULL),(50574,'58225','S','Bowesmont','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.567554,-97.176905,0,'2013-07-06 12:44:33',NULL,NULL),(22290,'23805','S','South Prince George','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.136328,-77.391900,0,'2013-07-06 12:44:31',NULL,NULL),(2292,'00926','S','Villas del Pilar','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(9187,'09378','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(22965,'24701','S','Sandlick','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(1239,'00729','S','Jard de Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(25974,'28659','S','North Wilkesboro','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(23459,'25428','S','Inwood','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.358444,-78.042496,0,'2013-07-06 12:44:31',NULL,NULL),(60009,'71334','S','Lake Saint John','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(65874,'78219','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.446920,-98.380980,0,'2013-07-06 12:44:34',NULL,NULL),(62335,'74051','S','Ochelata','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.603241,-95.984384,0,'2013-07-06 12:44:33',NULL,NULL),(17793,'18356','P','Shawnee On De','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.009711,-75.111422,0,'2013-07-06 12:44:31',NULL,NULL),(43705,'48895','S','Williamston','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.689475,-84.286763,0,'2013-07-06 12:44:32',NULL,NULL),(46053,'52571','S','Moravia','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.885620,-92.860620,0,'2013-07-06 12:44:32',NULL,NULL),(33644,'37699','U','Home Shopping Network','N','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.418354,-82.303895,0,'2013-07-06 12:44:32',NULL,NULL),(56688,'65649','S','Fair Play','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.632203,-93.624657,0,'2013-07-06 12:44:33',NULL,NULL),(3642,'02111','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.351267,-71.064699,0,'2013-07-06 12:44:30',NULL,NULL),(51107,'58783','S','Landa','A','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.920760,-100.825620,0,'2013-07-06 12:44:33',NULL,NULL),(17427,'17925','P','Brockton','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.748486,-76.067276,0,'2013-07-06 12:44:31',NULL,NULL),(61559,'72717','S','Canehill','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.909848,-94.377160,0,'2013-07-06 12:44:33',NULL,NULL),(1536,'00757','S','Brisas del Prado','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(73271,'90731','S','San Pedro','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.743520,-118.279440,0,'2013-07-06 12:44:34',NULL,NULL),(69064,'83237','S','Franklin','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.027323,-111.796522,0,'2013-07-06 12:44:34',NULL,NULL),(63291,'75559','S','Hodgson','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(61627,'72832','S','Coal Hill','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.435130,-93.671096,0,'2013-07-06 12:44:33',NULL,NULL),(60862,'72053','P','College Station','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.711660,-92.222290,0,'2013-07-06 12:44:33',NULL,NULL),(20814,'21612','S','Bozman','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.753587,-76.297840,0,'2013-07-06 12:44:31',NULL,NULL),(30177,'33175','S','Olympia Hgts','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729688,-80.410127,0,'2013-07-06 12:44:32',NULL,NULL),(15755,'16914','S','Snedekerville','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(14307,'14885','S','Troupsburg','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.066319,-77.564807,0,'2013-07-06 12:44:31',NULL,NULL),(19973,'20594','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886830,-77.022138,0,'2013-07-06 12:44:31',NULL,NULL),(9610,'10032','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(56380,'65232','S','Benton City','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.105465,-91.774350,0,'2013-07-06 12:44:33',NULL,NULL),(77922,'97322','S','Albany','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.623227,-123.058551,0,'2013-07-06 12:44:34',NULL,NULL),(73165,'90302','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.975295,-118.354145,0,'2013-07-06 12:44:34',NULL,NULL),(58279,'68405','S','Milford','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.775066,-97.054666,0,'2013-07-06 12:44:33',NULL,NULL),(43050,'48183','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(26188,'28762','S','Old Fort','D','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.630002,-82.157958,0,'2013-07-06 12:44:31',NULL,NULL),(8796,'08601','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.219897,-74.763739,0,'2013-07-06 12:44:30',NULL,NULL),(43469,'48556','U','Delphi East','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.064861,-83.626394,0,'2013-07-06 12:44:32',NULL,NULL),(56532,'65438','S','Birch Tree','D','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.912332,-91.493803,0,'2013-07-06 12:44:33',NULL,NULL),(39962,'45236','S','Silverton','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(51705,'60008','S','Rolling Mdws','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.077830,-88.032318,0,'2013-07-06 12:44:33',NULL,NULL),(36349,'40437','S','Hustonville','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.435708,-84.784183,0,'2013-07-06 12:44:32',NULL,NULL),(33050,'36752','S','Lowndesboro','D','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.310120,-86.652300,0,'2013-07-06 12:44:32',NULL,NULL),(38346,'43440','S','Lksid Marblhd','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531235,-82.759429,0,'2013-07-06 12:44:32',NULL,NULL),(6581,'05857','S','Newport Ctr','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.950833,-72.306944,0,'2013-07-06 12:44:30',NULL,NULL),(34853,'38925','S','Cedar Hill','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.633238,-89.715693,0,'2013-07-06 12:44:32',NULL,NULL),(3551,'01931','P','Gloucester','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.630304,-70.681613,0,'2013-07-06 12:44:30',NULL,NULL),(76468,'95619','S','Diamond Spgs','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.665863,-120.822937,0,'2013-07-06 12:44:34',NULL,NULL),(77515,'96840','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306502,-157.860814,0,'2013-07-06 12:44:34',NULL,NULL),(29712,'32950','S','Grant Valkaria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.985689,-80.589258,0,'2013-07-06 12:44:32',NULL,NULL),(26303,'29033','S','Cayce W Cola','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.965536,-81.069156,0,'2013-07-06 12:44:31',NULL,NULL),(12765,'13209','S','Solvay','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.085400,-76.251720,0,'2013-07-06 12:44:30',NULL,NULL),(39225,'44413','S','East Palestine','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.838445,-80.548361,0,'2013-07-06 12:44:32',NULL,NULL),(53069,'61520','S','Brereton','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.516944,-89.908333,0,'2013-07-06 12:44:33',NULL,NULL),(49242,'56472','S','Pequot Lakes','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.615920,-94.281420,0,'2013-07-06 12:44:33',NULL,NULL),(44043,'49427','P','Jamestown','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.827106,-85.846942,0,'2013-07-06 12:44:32',NULL,NULL),(45619,'51577','S','Walnut','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.478376,-95.219305,0,'2013-07-06 12:44:32',NULL,NULL),(37571,'42078','S','Salem','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.242613,-88.281093,0,'2013-07-06 12:44:32',NULL,NULL),(74840,'93243','S','Gorman','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.829880,-118.863480,0,'2013-07-06 12:44:34',NULL,NULL),(72328,'89008','S','Caliente','D','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.655453,-114.504832,0,'2013-07-06 12:44:34',NULL,NULL),(68948,'82938','P','Mc Kinnon','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.027778,-109.935278,0,'2013-07-06 12:44:34',NULL,NULL),(34855,'38925','S','Sweatman','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.633238,-89.715693,0,'2013-07-06 12:44:32',NULL,NULL),(16520,'17268','S','Cress','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(51405,'59434','P','E Glacier Pk','A','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(70158,'84315','S','Hooper','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.175095,-112.082261,0,'2013-07-06 12:44:34',NULL,NULL),(71657,'87501','S','Pojoaque','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(77884,'97269','P','Milwaukie','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.438452,-122.611322,0,'2013-07-06 12:44:34',NULL,NULL),(11708,'12167','S','Stamford','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.407598,-74.619982,0,'2013-07-06 12:44:30',NULL,NULL),(11295,'11776','S','Terryville','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(11058,'11577','S','Roslyn Heights','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.785766,-73.637013,0,'2013-07-06 12:44:30',NULL,NULL),(54096,'62533','S','Farmersville','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.439020,-89.649092,0,'2013-07-06 12:44:33',NULL,NULL),(78394,'98032','S','Woodmont Beach','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.392732,-122.260066,0,'2013-07-06 12:44:34',NULL,NULL),(31298,'34091','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(27244,'29926','S','Hilton Head','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.234951,-80.735624,0,'2013-07-06 12:44:31',NULL,NULL),(38980,'44130','S','Parma Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(15193,'15952','S','Salix','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.297776,-78.772054,0,'2013-07-06 12:44:31',NULL,NULL),(69835,'84081','S','West Jordan','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(17950,'18512','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.420505,-75.625001,0,'2013-07-06 12:44:31',NULL,NULL),(4604,'03589','P','Mount Washington','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.347851,-71.551849,0,'2013-07-06 12:44:30',NULL,NULL),(36420,'40546','U','University of Ky Agri Dept','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.038753,-84.508993,0,'2013-07-06 12:44:32',NULL,NULL),(33651,'37709','S','Blaine','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.124912,-83.715281,0,'2013-07-06 12:44:32',NULL,NULL),(37273,'41601','S','Allen','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.657284,-82.701808,0,'2013-07-06 12:44:32',NULL,NULL),(143,'00617','S','Parc Garrochales','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(44798,'50230','S','Radcliffe','D','Hardin','19083','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.318477,-93.430967,0,'2013-07-06 12:44:32',NULL,NULL),(47529,'54806','S','Stockbridge Indian Reservati','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(48966,'56201','S','Willmar','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.116700,-95.043173,0,'2013-07-06 12:44:33',NULL,NULL),(49911,'57311','S','Alexandria','D','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.645920,-97.761300,0,'2013-07-06 12:44:33',NULL,NULL),(49926,'57322','S','Carpenter','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.674688,-97.914803,0,'2013-07-06 12:44:33',NULL,NULL),(28910,'32139','S','Georgetown','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.417831,-81.584045,0,'2013-07-06 12:44:32',NULL,NULL),(20050,'20658','S','Rison','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.562360,-77.163900,0,'2013-07-06 12:44:31',NULL,NULL),(18818,'19406','S','Norristown','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.115940,-75.373740,0,'2013-07-06 12:44:31',NULL,NULL),(34455,'38655','S','Oxford','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.350360,-89.518980,0,'2013-07-06 12:44:32',NULL,NULL),(66508,'78703','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.294325,-97.763573,0,'2013-07-06 12:44:34',NULL,NULL),(58966,'70032','S','Arabi','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.957958,-89.997724,0,'2013-07-06 12:44:33',NULL,NULL),(25285,'28134','S','Pineville','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.080608,-80.885732,0,'2013-07-06 12:44:31',NULL,NULL),(25984,'28665','S','Maple Springs','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.221121,-81.387906,0,'2013-07-06 12:44:31',NULL,NULL),(29020,'32227','S','Mayport Naval Housing','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(30042,'33143','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.702034,-80.295591,0,'2013-07-06 12:44:32',NULL,NULL),(54872,'63052','S','Sulphur Spg','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.390733,-90.422015,0,'2013-07-06 12:44:33',NULL,NULL),(41797,'47326','S','West Liberty','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.536527,-84.963031,0,'2013-07-06 12:44:32',NULL,NULL),(32297,'35741','S','Brownsboro','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.717749,-86.482115,0,'2013-07-06 12:44:32',NULL,NULL),(59123,'70156','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944269,-90.085697,0,'2013-07-06 12:44:33',NULL,NULL),(3989,'02536','S','Waquoit','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(66567,'78738','S','Bee Caves','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(58726,'68941','S','Little Blue','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.483464,-98.219562,0,'2013-07-06 12:44:33',NULL,NULL),(29974,'33084','P','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.025865,-80.243456,0,'2013-07-06 12:44:32',NULL,NULL),(17102,'17768','S','Wheelerville','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.533107,-76.746568,0,'2013-07-06 12:44:31',NULL,NULL),(9244,'09575','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60855,'72047','S','Barney','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.217403,-92.213012,0,'2013-07-06 12:44:33',NULL,NULL),(71976,'88021','S','Chaparral','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',31.935600,-106.505520,0,'2013-07-06 12:44:34',NULL,NULL),(79271,'98571','P','Aloha','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.201111,-124.166667,0,'2013-07-06 12:44:34',NULL,NULL),(57083,'66216','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.008231,-94.740275,0,'2013-07-06 12:44:33',NULL,NULL),(40081,'45299','U','Pg Contest Mail','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.103830,-84.507547,0,'2013-07-06 12:44:32',NULL,NULL),(42734,'48012','P','Birmingham','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.544872,-83.208462,0,'2013-07-06 12:44:32',NULL,NULL),(45622,'51591','P','Red Oak','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.978361,-95.257753,0,'2013-07-06 12:44:32',NULL,NULL),(53186,'61607','S','Greater Peoria Airport','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(3052,'01107','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122891,-72.607189,0,'2013-07-06 12:44:30',NULL,NULL),(26702,'29409','U','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.794242,-79.960770,0,'2013-07-06 12:44:31',NULL,NULL),(3478,'01827','S','Dunstable','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.669019,-71.496025,0,'2013-07-06 12:44:30',NULL,NULL),(79872,'99566','P','Chitina','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.659272,-143.868456,0,'2013-07-06 12:44:34',NULL,NULL),(68030,'80927','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.664269,-104.909568,0,'2013-07-06 12:44:34',NULL,NULL),(58534,'68803','S','Grand Island','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.926575,-98.377333,0,'2013-07-06 12:44:33',NULL,NULL),(39097,'44232','P','Green','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.945800,-81.483300,0,'2013-07-06 12:44:32',NULL,NULL),(14668,'15240','P','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445977,-79.962428,0,'2013-07-06 12:44:31',NULL,NULL),(51463,'59523','S','Chinook','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.588629,-109.229533,0,'2013-07-06 12:44:33',NULL,NULL),(21953,'23234','S','Richmond','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.452407,-77.476225,0,'2013-07-06 12:44:31',NULL,NULL),(447,'00662','S','Urb Las Flores','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(32206,'35555','S','Bluff','N','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.694040,-87.831107,0,'2013-07-06 12:44:32',NULL,NULL),(15691,'16840','S','Hawk Run','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.941977,-78.219061,0,'2013-07-06 12:44:31',NULL,NULL),(72846,'89835','S','Pequop','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(38600,'43837','S','Port Washington','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.320682,-81.502140,0,'2013-07-06 12:44:32',NULL,NULL),(32252,'35615','P','Belle Mina','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.711141,-86.743460,0,'2013-07-06 12:44:32',NULL,NULL),(4727,'03827','S','S Hampton','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.911422,-70.983388,0,'2013-07-06 12:44:30',NULL,NULL),(34943,'39051','S','Carthage','D','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.758440,-89.584740,0,'2013-07-06 12:44:32',NULL,NULL),(3101,'01229','P','Glendale','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.286122,-73.346812,0,'2013-07-06 12:44:30',NULL,NULL),(41582,'47041','S','Hubbells Corner','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(6763,'06094','P','Winchester','N','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.901881,-73.142301,0,'2013-07-06 12:44:30',NULL,NULL),(28286,'31092','S','Vienna','D','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.093587,-83.793623,0,'2013-07-06 12:44:31',NULL,NULL),(57703,'67337','S','Coffeyville','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.039645,-95.630692,0,'2013-07-06 12:44:33',NULL,NULL),(55949,'64485','S','Savannah','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.940137,-94.827263,0,'2013-07-06 12:44:33',NULL,NULL),(57810,'67512','S','Alden','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.240493,-98.310946,0,'2013-07-06 12:44:33',NULL,NULL),(62504,'74367','S','Strang','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.454942,-95.083903,0,'2013-07-06 12:44:33',NULL,NULL),(68633,'81635','S','Parachute','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.460598,-108.009596,0,'2013-07-06 12:44:34',NULL,NULL),(80134,'99775','U','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.817129,-147.878379,0,'2013-07-06 12:44:34',NULL,NULL),(67052,'79550','P','Snyder','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.718525,-100.919601,0,'2013-07-06 12:44:34',NULL,NULL),(55963,'64499','S','Worth','D','Worth','29227','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.426530,-94.421383,0,'2013-07-06 12:44:33',NULL,NULL),(43847,'49103','S','Berrien Spgs','N','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.940154,-86.349801,0,'2013-07-06 12:44:32',NULL,NULL),(6351,'05673','S','Waitsfield Common','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.187565,-72.843339,0,'2013-07-06 12:44:30',NULL,NULL),(8025,'07727','S','Wall Township','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.199657,-74.163542,0,'2013-07-06 12:44:30',NULL,NULL),(31022,'33785','S','Indian Rocks Beach','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(44788,'50222','S','East Peru','A','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204218,-93.942498,0,'2013-07-06 12:44:32',NULL,NULL),(22222,'23601','S','N N','N','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.057272,-76.460838,0,'2013-07-06 12:44:31',NULL,NULL),(64470,'76577','S','Gano','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(47644,'54927','P','Bte Des Morts','A','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.103693,-88.651664,0,'2013-07-06 12:44:33',NULL,NULL),(35569,'39567','S','Pecan','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(35517,'39534','P','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413857,-88.910394,0,'2013-07-06 12:44:32',NULL,NULL),(17296,'17851','S','Merrian','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(34029,'38132','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.062992,-89.976596,0,'2013-07-06 12:44:32',NULL,NULL),(1504,'00751','S','Villa Cofresi','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(7245,'06513','S','E Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.321735,-72.859214,0,'2013-07-06 12:44:30',NULL,NULL),(7009,'06259','S','Elliot','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.876521,-72.011578,0,'2013-07-06 12:44:30',NULL,NULL),(35147,'39225','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291456,-90.183510,0,'2013-07-06 12:44:32',NULL,NULL),(26487,'29164','S','H L Crossroads','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(74885,'93282','P','Corcoran','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.149403,-119.506075,0,'2013-07-06 12:44:34',NULL,NULL),(68556,'81431','S','Redvale','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.189865,-108.426430,0,'2013-07-06 12:44:34',NULL,NULL),(46987,'54230','S','Reedsville','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.151390,-87.921245,0,'2013-07-06 12:44:32',NULL,NULL),(52015,'60174','S','St Charles','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.922012,-88.304234,0,'2013-07-06 12:44:33',NULL,NULL),(5121,'04401','S','Glenburn','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.814135,-68.778574,0,'2013-07-06 12:44:30',NULL,NULL),(45667,'52035','S','Osterdock','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.634992,-91.200496,0,'2013-07-06 12:44:32',NULL,NULL),(59364,'70582','S','Saint Martinville','D','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.139877,-91.822998,0,'2013-07-06 12:44:33',NULL,NULL),(61088,'72132','S','Orion','N','Jefferson','05069','Arkansas','AR','05','6240','501','Central',-6.0,'Y',34.460182,-92.177190,0,'2013-07-06 12:44:33',NULL,NULL),(56082,'64763','S','Lowry City','D','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.137469,-93.726117,0,'2013-07-06 12:44:33',NULL,NULL),(80106,'99756','P','Manley Hot Springs','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.148185,-150.871479,0,'2013-07-06 12:44:34',NULL,NULL),(78693,'98252','S','Granite Falls','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.053157,-121.683767,0,'2013-07-06 12:44:34',NULL,NULL),(38460,'43614','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.603430,-83.627311,0,'2013-07-06 12:44:32',NULL,NULL),(3973,'02494','S','Needham','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.305022,-71.231767,0,'2013-07-06 12:44:30',NULL,NULL),(12108,'12582','S','Stormville','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.543279,-73.725207,0,'2013-07-06 12:44:30',NULL,NULL),(43658,'48851','S','Lyons','D','Ionia','26067','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.956822,-84.943116,0,'2013-07-06 12:44:32',NULL,NULL),(65590,'77872','S','North Zulch','D','Madison','48313','Texas','TX','48','0000','936','Central',-6.0,'Y',30.953520,-96.090420,0,'2013-07-06 12:44:34',NULL,NULL),(70519,'85003','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.451747,-112.075141,0,'2013-07-06 12:44:34',NULL,NULL),(28549,'31562','S','Saint George','D','Charlton','13049','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.525772,-82.037217,0,'2013-07-06 12:44:32',NULL,NULL),(65500,'77662','S','Pine Forest','N','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.145872,-94.010918,0,'2013-07-06 12:44:34',NULL,NULL),(45319,'50849','S','Greenfield','D','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.308687,-94.461680,0,'2013-07-06 12:44:32',NULL,NULL),(49266,'56481','S','Wing River','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.399714,-95.014769,0,'2013-07-06 12:44:33',NULL,NULL),(167,'00623','S','Bo Monte Grande','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(40799,'46176','S','Shelbyville','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.518570,-85.778917,0,'2013-07-06 12:44:32',NULL,NULL),(21126,'22101','S','Maclean','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.929874,-77.175966,0,'2013-07-06 12:44:31',NULL,NULL),(822,'00693','S','Urb San Demetrio','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(35322,'39426','S','Henleyfield','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.592349,-89.639175,0,'2013-07-06 12:44:32',NULL,NULL),(21829,'23115','P','Millers Tavern','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.829088,-76.946007,0,'2013-07-06 12:44:31',NULL,NULL),(42852,'48079','S','Saint Clair','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.853850,-82.547092,0,'2013-07-06 12:44:32',NULL,NULL),(1861,'00791','S','Mans del Caribe','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(23912,'26210','S','Adrian','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.917176,-80.304769,0,'2013-07-06 12:44:31',NULL,NULL),(6905,'06151','U','Bank of America','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766300,-72.673122,0,'2013-07-06 12:44:30',NULL,NULL),(47718,'55005','S','Oak Grove','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.392640,-93.211800,0,'2013-07-06 12:44:33',NULL,NULL),(31415,'34240','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.319476,-82.386179,0,'2013-07-06 12:44:32',NULL,NULL),(30653,'33461','S','Palm Springs','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.612961,-80.089250,0,'2013-07-06 12:44:32',NULL,NULL),(69456,'83648','S','Mountain Home Air Force Base','N','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.059898,-115.854735,0,'2013-07-06 12:44:34',NULL,NULL),(66046,'78372','S','Orange Grove','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.951121,-98.073418,0,'2013-07-06 12:44:34',NULL,NULL),(49401,'56623','S','Carp','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(7364,'06755','S','Gaylordsville','D','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.648111,-73.483674,0,'2013-07-06 12:44:30',NULL,NULL),(69281,'83441','U','Rexburg','D','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.762902,-111.609618,0,'2013-07-06 12:44:34',NULL,NULL),(58167,'68197','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.259112,-95.937493,0,'2013-07-06 12:44:33',NULL,NULL),(37680,'42217','S','Crofton','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',37.039869,-87.491783,0,'2013-07-06 12:44:32',NULL,NULL),(2924,'01012','S','Chesterfield','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.387225,-72.834041,0,'2013-07-06 12:44:30',NULL,NULL),(5437,'04684','S','Surry','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.492973,-68.529516,0,'2013-07-06 12:44:30',NULL,NULL),(26587,'29223','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.088460,-80.922870,0,'2013-07-06 12:44:31',NULL,NULL),(60199,'71418','S','Hebert','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(13651,'14011','S','Attica','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.835713,-78.280907,0,'2013-07-06 12:44:31',NULL,NULL),(24688,'27415','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.078926,-79.645808,0,'2013-07-06 12:44:31',NULL,NULL),(28542,'31555','S','Odum','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.665775,-82.014991,0,'2013-07-06 12:44:32',NULL,NULL),(30055,'33146','S','South Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(9567,'10025','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(41016,'46375','S','Schererville','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.490429,-87.456888,0,'2013-07-06 12:44:32',NULL,NULL),(27196,'29899','U','McCormick Correctional Inst','N','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.908678,-82.290232,0,'2013-07-06 12:44:31',NULL,NULL),(61108,'72142','S','Scott','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.776533,-92.063990,0,'2013-07-06 12:44:33',NULL,NULL),(19400,'20074','U','PNC Financial','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914711,-76.995922,0,'2013-07-06 12:44:31',NULL,NULL),(38343,'43440','S','Lakeside','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531235,-82.759429,0,'2013-07-06 12:44:32',NULL,NULL),(59236,'70433','S','Claiborne','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.457687,-90.114529,0,'2013-07-06 12:44:33',NULL,NULL),(25026,'27890','S','Weldon','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.420265,-77.609569,0,'2013-07-06 12:44:31',NULL,NULL),(14278,'14856','P','Kanona','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.334564,-77.320273,0,'2013-07-06 12:44:31',NULL,NULL),(3394,'01612','S','Worcester','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.301580,-71.909525,0,'2013-07-06 12:44:30',NULL,NULL),(42294,'47596','P','Westphalia','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.871663,-87.203975,0,'2013-07-06 12:44:32',NULL,NULL),(51230,'59064','S','Pompey Pillar','A','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.949977,-107.981373,0,'2013-07-06 12:44:33',NULL,NULL),(571,'00678','S','Villa Norma','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(65254,'77465','S','Palacios','D','Matagorda','48321','Texas','TX','48','0000','361','Central',-6.0,'Y',28.709508,-96.218574,0,'2013-07-06 12:44:34',NULL,NULL),(55044,'63141','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.659172,-90.456634,0,'2013-07-06 12:44:33',NULL,NULL),(51105,'58782','S','Sherwood','D','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.947485,-101.821254,0,'2013-07-06 12:44:33',NULL,NULL),(6650,'06019','S','Canton','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.835820,-72.896405,0,'2013-07-06 12:44:30',NULL,NULL),(73780,'91744','S','La Puente','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.028223,-117.937998,0,'2013-07-06 12:44:34',NULL,NULL),(38148,'43143','S','Mt Sterling','A','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.741372,-83.306744,0,'2013-07-06 12:44:32',NULL,NULL),(45643,'51652','S','Sidney','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.748440,-95.648459,0,'2013-07-06 12:44:32',NULL,NULL),(77473,'96819','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.345402,-157.880907,0,'2013-07-06 12:44:34',NULL,NULL),(77018,'96093','P','Weaverville','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.732607,-122.935131,0,'2013-07-06 12:44:34',NULL,NULL),(41588,'47043','S','Braytown','N','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750187,-85.066805,0,'2013-07-06 12:44:32',NULL,NULL),(10386,'10597','S','Waccabuc','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.297002,-73.600825,0,'2013-07-06 12:44:30',NULL,NULL),(53895,'62360','S','Bluff Hall','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.818387,-91.239589,0,'2013-07-06 12:44:33',NULL,NULL),(34023,'38128','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.219361,-89.925899,0,'2013-07-06 12:44:32',NULL,NULL),(6947,'06183','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.764012,-72.685950,0,'2013-07-06 12:44:30',NULL,NULL),(69060,'83235','S','Ellis','D','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.851277,-114.092051,0,'2013-07-06 12:44:34',NULL,NULL),(19890,'20537','U','FBI Identification Unit','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897231,-77.025361,0,'2013-07-06 12:44:31',NULL,NULL),(41113,'46571','S','Topeka','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.540647,-85.539540,0,'2013-07-06 12:44:32',NULL,NULL),(29931,'33064','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.277900,-80.147820,0,'2013-07-06 12:44:32',NULL,NULL),(14413,'15067','S','New Eagle','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.205814,-79.953185,0,'2013-07-06 12:44:31',NULL,NULL),(56897,'66044','S','Laurence','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.962471,-95.254516,0,'2013-07-06 12:44:33',NULL,NULL),(73639,'91426','P','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.155006,-118.515946,0,'2013-07-06 12:44:34',NULL,NULL),(31245,'33976','S','Leehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.612085,-81.663866,0,'2013-07-06 12:44:32',NULL,NULL),(79583,'99027','S','City of Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.702089,-117.110984,0,'2013-07-06 12:44:34',NULL,NULL),(72690,'89445','S','Winnemucca','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(79695,'99205','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.695450,-117.442334,0,'2013-07-06 12:44:34',NULL,NULL),(78525,'98125','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.718413,-122.301588,0,'2013-07-06 12:44:34',NULL,NULL),(69401,'83619','S','Fruitland','D','Payette','16075','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.995655,-116.909525,0,'2013-07-06 12:44:34',NULL,NULL),(20258,'20783','S','Langley Park','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.999340,-76.975020,0,'2013-07-06 12:44:31',NULL,NULL),(19138,'19610','S','Wyomissing','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.338971,-75.981605,0,'2013-07-06 12:44:31',NULL,NULL),(7363,'06754','S','Warren','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.770620,-73.367400,0,'2013-07-06 12:44:30',NULL,NULL),(22561,'24147','S','Rich Creek','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.380211,-80.815976,0,'2013-07-06 12:44:31',NULL,NULL),(43594,'48758','P','Richville','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.406608,-83.673253,0,'2013-07-06 12:44:32',NULL,NULL),(2757,'00969','S','Urb Torremolinos','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(38397,'43525','S','Haskins','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.466054,-83.705182,0,'2013-07-06 12:44:32',NULL,NULL),(66694,'78945','S','Holman','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(74320,'92395','S','Spg Valley Lk','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.486200,-117.366100,0,'2013-07-06 12:44:34',NULL,NULL),(23104,'24938','S','Frankford','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.909770,-80.357408,0,'2013-07-06 12:44:31',NULL,NULL),(42836,'48069','S','Pleasant Rdg','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.471590,-83.141547,0,'2013-07-06 12:44:32',NULL,NULL),(44133,'49512','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881460,-85.535400,0,'2013-07-06 12:44:32',NULL,NULL),(17740,'18302','S','E Stroudsbg','N','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024159,-75.185836,0,'2013-07-06 12:44:31',NULL,NULL),(16174,'17065','S','Upper Mill','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.117148,-77.192329,0,'2013-07-06 12:44:31',NULL,NULL),(35461,'39501','S','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.385481,-89.086881,0,'2013-07-06 12:44:32',NULL,NULL),(60572,'71763','S','Sparkman','D','Dallas','05039','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.021111,-92.792778,0,'2013-07-06 12:44:33',NULL,NULL),(3716,'02144','S','Somerville','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.399028,-71.123138,0,'2013-07-06 12:44:30',NULL,NULL),(43655,'48848','S','Laingsburg','D','Shiawassee','26155','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.884521,-84.328333,0,'2013-07-06 12:44:32',NULL,NULL),(14985,'15642','S','No Huntingdon','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.328956,-79.721348,0,'2013-07-06 12:44:31',NULL,NULL),(24825,'27607','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.804021,-78.697656,0,'2013-07-06 12:44:31',NULL,NULL),(9252,'09587','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(31969,'35214','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573360,-86.893260,0,'2013-07-06 12:44:32',NULL,NULL),(1481,'00745','S','VISTAS de Rio Grande II','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(75228,'93642','P','Shaver Lake','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.326667,-119.016667,0,'2013-07-06 12:44:34',NULL,NULL),(23007,'24815','S','Canebrake','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.269547,-81.665130,0,'2013-07-06 12:44:31',NULL,NULL),(17509,'17963','S','Oak Grove','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(47921,'55111','S','Fort Snelling','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.880467,-93.196044,0,'2013-07-06 12:44:33',NULL,NULL),(11026,'11561','S','Long Beach','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.585753,-73.657497,0,'2013-07-06 12:44:30',NULL,NULL),(33508,'37365','S','Palmer','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.378544,-85.569238,0,'2013-07-06 12:44:32',NULL,NULL),(78656,'98229','S','Bellingham','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.765765,-122.442175,0,'2013-07-06 12:44:34',NULL,NULL),(54938,'63113','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.654969,-90.245104,0,'2013-07-06 12:44:33',NULL,NULL),(30214,'33184','S','Olympia Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.756934,-80.404841,0,'2013-07-06 12:44:32',NULL,NULL),(76388,'95532','U','Pelican Bay State Prison','N','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.756509,-124.203866,0,'2013-07-06 12:44:34',NULL,NULL),(19960,'20586','U','Us Synthetic Fuel Corp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905041,-77.047044,0,'2013-07-06 12:44:31',NULL,NULL),(65322,'77514','S','Monroe City','A','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.768783,-94.665834,0,'2013-07-06 12:44:34',NULL,NULL),(46022,'52548','S','Chillicothe','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.069956,-92.541431,0,'2013-07-06 12:44:32',NULL,NULL),(19413,'20081','U','Washington Gas','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899462,-77.026641,0,'2013-07-06 12:44:31',NULL,NULL),(46282,'53038','S','Johnson Creek','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.072467,-88.776005,0,'2013-07-06 12:44:32',NULL,NULL),(47182,'54481','S','Park Ridge','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(13244,'13642','S','Fowler','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(35143,'39218','S','JAX','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.237700,-90.154800,0,'2013-07-06 12:44:32',NULL,NULL),(77780,'97124','S','Orenco','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.535156,-122.956260,0,'2013-07-06 12:44:34',NULL,NULL),(19384,'20065','U','Blue Cross Group Hosp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882711,-77.027194,0,'2013-07-06 12:44:31',NULL,NULL),(71787,'87560','S','Gonzales Ranch','A','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(65840,'78159','S','Smiley','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.241001,-97.593291,0,'2013-07-06 12:44:34',NULL,NULL),(64573,'76664','S','Kirk','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.548099,-96.837534,0,'2013-07-06 12:44:34',NULL,NULL),(9443,'10005','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(62100,'73622','S','Bessie','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.386487,-98.997525,0,'2013-07-06 12:44:33',NULL,NULL),(23368,'25276','S','Spencer','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.798450,-81.353076,0,'2013-07-06 12:44:31',NULL,NULL),(2305,'00927','S','Urb San Francisco','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(54970,'63121','S','Velda Village Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(65167,'77411','P','Alief','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.730802,-95.592618,0,'2013-07-06 12:44:34',NULL,NULL),(61866,'73125','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.456217,-97.528691,0,'2013-07-06 12:44:33',NULL,NULL),(557,'00677','S','VISTA Azul','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(24723,'27513','S','Cary','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.805410,-78.797679,0,'2013-07-06 12:44:31',NULL,NULL),(46356,'53102','P','Trevor','A','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.504370,-88.077260,0,'2013-07-06 12:44:32',NULL,NULL),(10578,'11021','S','Great Neck Plaza','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(37523,'42045','S','Lake City','N','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.075980,-88.259940,0,'2013-07-06 12:44:32',NULL,NULL),(6830,'06117','S','Bishop\'s Corner','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(18476,'19087','S','Chesterbrook','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(12813,'13301','S','Alder Creek','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.414193,-75.210420,0,'2013-07-06 12:44:30',NULL,NULL),(14059,'14585','S','West Bloomfield','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.908597,-77.552853,0,'2013-07-06 12:44:31',NULL,NULL),(47593,'54864','S','Poplar','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.576270,-91.819109,0,'2013-07-06 12:44:33',NULL,NULL),(38749,'44035','S','N Ridgeville','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(39469,'44711','P','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.830222,-81.386453,0,'2013-07-06 12:44:32',NULL,NULL),(27233,'29920','S','Saint Helena Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(17516,'17965','S','Port Carbon','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.699019,-76.165915,0,'2013-07-06 12:44:31',NULL,NULL),(33603,'37625','P','Bristol','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.596104,-82.186322,0,'2013-07-06 12:44:32',NULL,NULL),(8573,'08215','S','Egg Harbor Cy','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(5998,'05355','S','Wardsborough','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.029480,-72.811620,0,'2013-07-06 12:44:30',NULL,NULL),(77113,'96146','S','Alpine Meadows','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.150000,-120.150000,0,'2013-07-06 12:44:34',NULL,NULL),(72076,'88132','S','Garrison','N','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.034530,-103.139803,0,'2013-07-06 12:44:34',NULL,NULL),(56982,'66202','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(4776,'03861','S','Lee','D','Strafford','33017','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.098220,-71.042089,0,'2013-07-06 12:44:30',NULL,NULL),(4973,'04109','S','Diamond Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(79733,'99216','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.664576,-117.214772,0,'2013-07-06 12:44:34',NULL,NULL),(78214,'97758','S','Riley','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.538942,-119.508741,0,'2013-07-06 12:44:34',NULL,NULL),(75401,'94014','S','Daly City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.689480,-122.439360,0,'2013-07-06 12:44:34',NULL,NULL),(69596,'83848','S','Nordman','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.663925,-116.948180,0,'2013-07-06 12:44:34',NULL,NULL),(63997,'76114','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(6007,'05359','S','South Windham','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.163746,-72.719255,0,'2013-07-06 12:44:30',NULL,NULL),(59923,'71291','S','Highland Park','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(39162,'44304','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.082751,-81.509550,0,'2013-07-06 12:44:32',NULL,NULL),(68618,'81623','S','Redstone','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.416703,-107.189562,0,'2013-07-06 12:44:34',NULL,NULL),(24614,'27340','P','Saxapahaw','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.950403,-79.319706,0,'2013-07-06 12:44:31',NULL,NULL),(16787,'17535','S','Kinzers','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.007451,-76.042530,0,'2013-07-06 12:44:31',NULL,NULL),(3332,'01536','S','No Grafton','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.229493,-71.703587,0,'2013-07-06 12:44:30',NULL,NULL),(8814,'08618','S','Ewing','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.221900,-74.733600,0,'2013-07-06 12:44:30',NULL,NULL),(45019,'50460','S','Orchard','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.236860,-92.684180,0,'2013-07-06 12:44:32',NULL,NULL),(28809,'32066','S','Mayo','D','Lafayette','12067','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.055814,-83.175483,0,'2013-07-06 12:44:32',NULL,NULL),(24291,'27007','S','Ash Hill','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.383368,-80.601678,0,'2013-07-06 12:44:31',NULL,NULL),(3672,'02126','S','Hyde Park','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.274690,-71.089937,0,'2013-07-06 12:44:30',NULL,NULL),(49393,'56621','S','Copley','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(39006,'44138','S','Olmsted Twp','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.378304,-81.918914,0,'2013-07-06 12:44:32',NULL,NULL),(53307,'61737','S','Padua','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.446184,-88.718903,0,'2013-07-06 12:44:33',NULL,NULL),(35473,'39507','S','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.394254,-89.037041,0,'2013-07-06 12:44:32',NULL,NULL),(2818,'00979','S','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(15597,'16669','S','Petersburg','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.570589,-78.047614,0,'2013-07-06 12:44:31',NULL,NULL),(36535,'40863','S','Pathfork','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.745787,-83.455764,0,'2013-07-06 12:44:32',NULL,NULL),(77162,'96214','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(40380,'45656','S','Oak Hill','D','Jackson','39079','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.886780,-82.592220,0,'2013-07-06 12:44:32',NULL,NULL),(34386,'38618','S','Cottonville','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(70643,'85147','S','Sacaton','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.082230,-111.752999,0,'2013-07-06 12:44:34',NULL,NULL),(19488,'20152','S','Chantilly','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.907611,-77.518015,0,'2013-07-06 12:44:31',NULL,NULL),(58857,'69145','S','Kimball','D','Kimball','31105','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.234572,-103.657979,0,'2013-07-06 12:44:33',NULL,NULL),(79857,'99556','S','Anchor Point','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.777580,-151.765620,0,'2013-07-06 12:44:34',NULL,NULL),(79050,'98413','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.208479,-122.480466,0,'2013-07-06 12:44:34',NULL,NULL),(75323,'93773','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.719980,-119.858055,0,'2013-07-06 12:44:34',NULL,NULL),(19307,'20007','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.912682,-77.071704,0,'2013-07-06 12:44:31',NULL,NULL),(29823,'33027','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.978093,-80.330196,0,'2013-07-06 12:44:32',NULL,NULL),(46057,'52573','S','Mt Sterling','A','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.617778,-91.931944,0,'2013-07-06 12:44:32',NULL,NULL),(49794,'57109','P','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.520545,-96.738364,0,'2013-07-06 12:44:33',NULL,NULL),(7173,'06451','S','Meriden','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.535911,-72.820885,0,'2013-07-06 12:44:30',NULL,NULL),(52367,'60615','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.800635,-87.604568,0,'2013-07-06 12:44:33',NULL,NULL),(22453,'24027','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.273624,-79.955034,0,'2013-07-06 12:44:31',NULL,NULL),(13253,'13645','P','Hailesboro','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.305254,-75.451418,0,'2013-07-06 12:44:30',NULL,NULL),(3983,'02535','S','Gay Head','A','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.334586,-70.746397,0,'2013-07-06 12:44:30',NULL,NULL),(41415,'46818','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.147538,-85.224765,0,'2013-07-06 12:44:32',NULL,NULL),(3186,'01340','S','Shattuckville','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711706,-72.719125,0,'2013-07-06 12:44:30',NULL,NULL),(77359,'96739','P','Kailua Kona','A','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.648570,-155.999276,0,'2013-07-06 12:44:34',NULL,NULL),(20369,'20878','S','North Potomac','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.105531,-77.240190,0,'2013-07-06 12:44:31',NULL,NULL),(37245,'41555','S','McVeigh','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.556989,-82.192577,0,'2013-07-06 12:44:32',NULL,NULL),(44903,'50324','S','Windsor Heights','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543762,-93.586549,0,'2013-07-06 12:44:32',NULL,NULL),(46013,'52540','S','Brighton','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.173994,-91.823207,0,'2013-07-06 12:44:32',NULL,NULL),(47508,'54767','S','Spring Valley','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.846147,-92.241815,0,'2013-07-06 12:44:32',NULL,NULL),(50443,'58009','S','Blanchard','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.367844,-97.267873,0,'2013-07-06 12:44:33',NULL,NULL),(56056,'64740','S','Deepwater','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.262928,-93.778340,0,'2013-07-06 12:44:33',NULL,NULL),(8660,'08318','S','Daretown','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(50818,'58464','S','Mc Henry','N','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.541956,-98.562354,0,'2013-07-06 12:44:33',NULL,NULL),(67621,'80439','S','Golden','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.608071,-105.332386,0,'2013-07-06 12:44:34',NULL,NULL),(61743,'73036','S','El Reno','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.528207,-97.953685,0,'2013-07-06 12:44:33',NULL,NULL),(61003,'72113','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.852398,-92.404691,0,'2013-07-06 12:44:33',NULL,NULL),(52030,'60181','S','Oakbrook Terrace','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.882953,-87.975404,0,'2013-07-06 12:44:33',NULL,NULL),(60275,'71447','S','Sharp','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(32802,'36436','S','Dickinson','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.730014,-87.651049,0,'2013-07-06 12:44:32',NULL,NULL),(55011,'63133','S','Greendale','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.678252,-90.305602,0,'2013-07-06 12:44:33',NULL,NULL),(9437,'10004','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(30790,'33601','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.981145,-82.342998,0,'2013-07-06 12:44:32',NULL,NULL),(42678,'47971','S','Oxford','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.524522,-87.249544,0,'2013-07-06 12:44:32',NULL,NULL),(13681,'14042','S','Delevan','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.471072,-78.516154,0,'2013-07-06 12:44:31',NULL,NULL),(39979,'45239','S','Groesbeck','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(14646,'15235','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445040,-79.913760,0,'2013-07-06 12:44:31',NULL,NULL),(37028,'41250','S','Pilgrim','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.707500,-82.432778,0,'2013-07-06 12:44:32',NULL,NULL),(72662,'89434','S','Patrick','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(12760,'13207','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.017354,-76.167626,0,'2013-07-06 12:44:30',NULL,NULL),(68916,'82838','S','Parkman','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.969359,-107.316636,0,'2013-07-06 12:44:34',NULL,NULL),(71066,'85775','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.215483,-110.970828,0,'2013-07-06 12:44:34',NULL,NULL),(3337,'01540','S','Oxford','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.112676,-71.870984,0,'2013-07-06 12:44:30',NULL,NULL),(41573,'47033','P','Morris','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.287744,-85.196501,0,'2013-07-06 12:44:32',NULL,NULL),(49466,'56652','S','Leonard','D','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.638080,-95.383500,0,'2013-07-06 12:44:33',NULL,NULL),(49,'00604','P','Ramey','A','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.505289,-67.135899,0,'2013-07-06 12:44:30',NULL,NULL),(31928,'35179','S','Vinemont','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.264921,-87.009412,0,'2013-07-06 12:44:32',NULL,NULL),(41971,'47421','S','Bedford Hts','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(46648,'53598','S','Windsor','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.211584,-89.345542,0,'2013-07-06 12:44:32',NULL,NULL),(74389,'92514','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.945007,-117.414714,0,'2013-07-06 12:44:34',NULL,NULL),(55751,'64108','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.084390,-94.584545,0,'2013-07-06 12:44:33',NULL,NULL),(16473,'17243','S','Meadow Gap','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.239420,-77.907120,0,'2013-07-06 12:44:31',NULL,NULL),(26311,'29040','S','Dalzell','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.002009,-80.482959,0,'2013-07-06 12:44:31',NULL,NULL),(27924,'30516','S','Bowersville','D','Hart','13147','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.398615,-83.048142,0,'2013-07-06 12:44:31',NULL,NULL),(42457,'47832','S','Annapolis','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.844258,-87.267425,0,'2013-07-06 12:44:32',NULL,NULL),(30727,'33525','S','Richland','A','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.364430,-82.209827,0,'2013-07-06 12:44:32',NULL,NULL),(49391,'56619','P','Bemidji','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.473727,-94.879123,0,'2013-07-06 12:44:33',NULL,NULL),(49522,'56673','S','Laona','N','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.779677,-95.251697,0,'2013-07-06 12:44:33',NULL,NULL),(34292,'38503','P','Cookeville','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.156672,-85.506357,0,'2013-07-06 12:44:32',NULL,NULL),(44599,'50048','S','Canby','N','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.488238,-94.430650,0,'2013-07-06 12:44:32',NULL,NULL),(25258,'28117','S','Mooresville','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.586807,-80.810679,0,'2013-07-06 12:44:31',NULL,NULL),(63264,'75496','S','Wolfe City','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.341662,-96.033254,0,'2013-07-06 12:44:33',NULL,NULL),(65816,'78144','P','Panna Maria','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.955850,-97.896534,0,'2013-07-06 12:44:34',NULL,NULL),(73623,'91406','S','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201751,-118.492685,0,'2013-07-06 12:44:34',NULL,NULL),(55784,'64119','S','Gladstone','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.208712,-94.518737,0,'2013-07-06 12:44:33',NULL,NULL),(23963,'26292','S','Thomas','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.142004,-79.498373,0,'2013-07-06 12:44:31',NULL,NULL),(76348,'95476','S','Schellville','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.293075,-122.470371,0,'2013-07-06 12:44:34',NULL,NULL),(63631,'75839','S','Elkhart','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.620240,-95.519820,0,'2013-07-06 12:44:34',NULL,NULL),(39105,'44240','S','Kent','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.152005,-81.325997,0,'2013-07-06 12:44:32',NULL,NULL),(23004,'24811','P','Garland','N','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.400556,-81.784722,0,'2013-07-06 12:44:31',NULL,NULL),(54165,'62612','S','Ashland','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.886126,-90.009613,0,'2013-07-06 12:44:33',NULL,NULL),(43006,'48161','S','Monroe','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.909061,-83.470098,0,'2013-07-06 12:44:32',NULL,NULL),(26678,'29404','S','Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(50410,'57780','S','Scenic','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.794115,-102.431907,0,'2013-07-06 12:44:33',NULL,NULL),(40177,'45370','S','Sugarcreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.599468,-84.138005,0,'2013-07-06 12:44:32',NULL,NULL),(68383,'81147','S','Chimney Rock','A','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.256494,-107.086521,0,'2013-07-06 12:44:34',NULL,NULL),(70881,'85611','S','Canelo','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.615365,-110.515379,0,'2013-07-06 12:44:34',NULL,NULL),(42152,'47520','S','Tobinsport','A','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(44586,'50039','S','Bouton','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.852588,-94.006979,0,'2013-07-06 12:44:32',NULL,NULL),(37811,'42408','S','Dawson Spgs','A','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.189860,-87.687240,0,'2013-07-06 12:44:32',NULL,NULL),(6998,'06251','P','Merrow','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.815888,-72.285998,0,'2013-07-06 12:44:30',NULL,NULL),(62683,'74723','S','Bennington','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.998280,-96.013920,0,'2013-07-06 12:44:33',NULL,NULL),(18870,'19451','P','Mainland','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.265419,-75.357024,0,'2013-07-06 12:44:31',NULL,NULL),(70940,'85640','S','Tumacacori','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.596899,-111.047790,0,'2013-07-06 12:44:34',NULL,NULL),(68758,'82240','S','Prairie Center','A','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.065743,-104.183152,0,'2013-07-06 12:44:34',NULL,NULL),(20637,'21219','S','Sparrows Point','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.250556,-76.520833,0,'2013-07-06 12:44:31',NULL,NULL),(8619,'08247','S','Stone Harbor','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.051880,-74.759867,0,'2013-07-06 12:44:30',NULL,NULL),(54689,'62946','S','Harrisburg','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.735404,-88.544975,0,'2013-07-06 12:44:33',NULL,NULL),(38523,'43730','S','Corning','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.630644,-82.090365,0,'2013-07-06 12:44:32',NULL,NULL),(24281,'26866','S','Upper Tract','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.796684,-79.257888,0,'2013-07-06 12:44:31',NULL,NULL),(48733,'55962','S','Rushford Village','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.774230,-91.848858,0,'2013-07-06 12:44:33',NULL,NULL),(69834,'84081','S','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(66280,'78582','S','Fort Ringgold','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(24942,'27823','S','Enfield','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.175831,-77.666630,0,'2013-07-06 12:44:31',NULL,NULL),(66235,'78568','P','Lozano','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.106850,-97.479596,0,'2013-07-06 12:44:34',NULL,NULL),(61350,'72473','S','Tuckerman','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.734420,-91.198661,0,'2013-07-06 12:44:33',NULL,NULL),(46615,'53573','S','Muscoda','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.164060,-90.468805,0,'2013-07-06 12:44:32',NULL,NULL),(24876,'27697','U','NC Dept Motor Vehicle','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.778849,-78.623747,0,'2013-07-06 12:44:31',NULL,NULL),(58115,'68123','S','La Platte','N','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.112120,-95.957400,0,'2013-07-06 12:44:33',NULL,NULL),(70502,'84779','S','Virgin','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.188889,-113.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77426,'96803','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308655,-157.858561,0,'2013-07-06 12:44:34',NULL,NULL),(60915,'72080','S','Gobblers Point','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.395533,-92.806007,0,'2013-07-06 12:44:33',NULL,NULL),(76975,'96056','S','Pittville','N','Lassen','06035','California','CA','06','6690','530','Pacific',-8.0,'Y',41.167186,-121.356668,0,'2013-07-06 12:44:34',NULL,NULL),(63480,'75689','P','Selman City','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.183333,-94.966667,0,'2013-07-06 12:44:33',NULL,NULL),(11287,'11775','U','Don Jagoda Assc Inc','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.793182,-73.417940,0,'2013-07-06 12:44:30',NULL,NULL),(41733,'47250','S','Jefferson Prv Grnd','N','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.755353,-85.397514,0,'2013-07-06 12:44:32',NULL,NULL),(9024,'08872','S','Sayreville','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.462576,-74.345502,0,'2013-07-06 12:44:30',NULL,NULL),(77328,'96709','P','Kapolei','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.324986,-158.005024,0,'2013-07-06 12:44:34',NULL,NULL),(76013,'95124','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.256921,-121.922873,0,'2013-07-06 12:44:34',NULL,NULL),(73749,'91722','S','Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.097496,-117.902732,0,'2013-07-06 12:44:34',NULL,NULL),(61736,'73028','S','Crescent','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.952496,-97.595964,0,'2013-07-06 12:44:33',NULL,NULL),(39261,'44449','S','North Benton','D','Portage','39133','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.997024,-81.026963,0,'2013-07-06 12:44:32',NULL,NULL),(1335,'00736','S','Bo Cedro','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(40253,'45430','S','Beavercrk Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(25940,'28655','S','Pleasant Grove','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(54300,'62707','S','Bradfordton','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(73163,'90296','P','Venice','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.956096,-118.449853,0,'2013-07-06 12:44:34',NULL,NULL),(72408,'89046','S','Cottonwood Cv','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.466505,-114.918847,0,'2013-07-06 12:44:34',NULL,NULL),(70837,'85534','S','Duncan','D','Greenlee','04011','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.714671,-109.100465,0,'2013-07-06 12:44:34',NULL,NULL),(70133,'84302','S','Brigham','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.536080,-112.048800,0,'2013-07-06 12:44:34',NULL,NULL),(62817,'74953','S','Poteau','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.063987,-94.618703,0,'2013-07-06 12:44:33',NULL,NULL),(8051,'07735','S','Union Beach','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.438200,-74.201940,0,'2013-07-06 12:44:30',NULL,NULL),(25342,'28219','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.206905,-80.941645,0,'2013-07-06 12:44:31',NULL,NULL),(23790,'26003','S','Elm Grove','A','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(10532,'10987','S','Tuxedo Park','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.200012,-74.216239,0,'2013-07-06 12:44:30',NULL,NULL),(50793,'58442','S','Gackle','D','Logan','38047','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.623711,-99.140681,0,'2013-07-06 12:44:33',NULL,NULL),(61602,'72768','S','Sulphur Spgs','A','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.478438,-94.462102,0,'2013-07-06 12:44:33',NULL,NULL),(62406,'74119','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.139674,-95.987503,0,'2013-07-06 12:44:33',NULL,NULL),(77490,'96825','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.296254,-157.696767,0,'2013-07-06 12:44:34',NULL,NULL),(38404,'43532','S','Liberty Center','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.421995,-83.974523,0,'2013-07-06 12:44:32',NULL,NULL),(79015,'98390','S','Sumner','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.179260,-122.192040,0,'2013-07-06 12:44:34',NULL,NULL),(74619,'92799','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.720481,-117.909846,0,'2013-07-06 12:44:34',NULL,NULL),(68246,'81057','S','Mc Clave','D','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.134649,-102.869788,0,'2013-07-06 12:44:34',NULL,NULL),(47238,'54511','S','Argonne','D','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.724974,-88.860373,0,'2013-07-06 12:44:32',NULL,NULL),(59344,'70552','S','Loreauville','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.052012,-91.747984,0,'2013-07-06 12:44:33',NULL,NULL),(73662,'91508','P','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.191193,-118.328476,0,'2013-07-06 12:44:34',NULL,NULL),(18199,'18940','S','Upper Makefield','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245694,-74.942426,0,'2013-07-06 12:44:31',NULL,NULL),(20257,'20783','S','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.999340,-76.975020,0,'2013-07-06 12:44:31',NULL,NULL),(58125,'68133','S','Bellevue','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.134020,-96.001800,0,'2013-07-06 12:44:33',NULL,NULL),(59826,'71235','S','Hilly','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.712180,-92.656020,0,'2013-07-06 12:44:33',NULL,NULL),(35486,'39522','U','Naval Ocean O Graphic','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(18228,'18969','S','Indian Valley','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.322048,-75.363209,0,'2013-07-06 12:44:31',NULL,NULL),(67394,'80124','S','Lone Tree','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.546295,-104.896772,0,'2013-07-06 12:44:34',NULL,NULL),(47023,'54313','S','Suamico','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.558732,-88.102722,0,'2013-07-06 12:44:32',NULL,NULL),(3314,'01521','S','Holland','D','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.042514,-72.149839,0,'2013-07-06 12:44:30',NULL,NULL),(58212,'68333','S','Blue River Lodge','N','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.622672,-96.959633,0,'2013-07-06 12:44:33',NULL,NULL),(48659,'55910','S','Weaver','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(49704,'57032','S','Lake Alvin','N','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.427784,-96.697425,0,'2013-07-06 12:44:33',NULL,NULL),(54004,'62447','S','Big Spring','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.321626,-88.454756,0,'2013-07-06 12:44:33',NULL,NULL),(17230,'17834','S','Kulpmont','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.791597,-76.472043,0,'2013-07-06 12:44:31',NULL,NULL),(79431,'98831','S','Manson','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.892373,-120.146606,0,'2013-07-06 12:44:34',NULL,NULL),(78953,'98368','S','Pt Townsend','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(66319,'78596','S','Progreso Lakes','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160167,-97.986360,0,'2013-07-06 12:44:34',NULL,NULL),(30719,'33514','S','Center Hill','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.699610,-82.004424,0,'2013-07-06 12:44:32',NULL,NULL),(14367,'15025','S','Clairton','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.295525,-79.916350,0,'2013-07-06 12:44:31',NULL,NULL),(58659,'68876','S','Shelton','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.779648,-98.730476,0,'2013-07-06 12:44:33',NULL,NULL),(41151,'46701','S','Green Center','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(3958,'02479','P','Belmont','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.388983,-71.187758,0,'2013-07-06 12:44:30',NULL,NULL),(2820,'00979','S','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(4468,'03260','P','North Sutton','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.365840,-71.939164,0,'2013-07-06 12:44:30',NULL,NULL),(60035,'71343','S','Mayna','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(55651,'64024','S','Ex Sprgs','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(48003,'55155','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.962818,-93.123683,0,'2013-07-06 12:44:33',NULL,NULL),(72979,'90049','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.078365,-118.486589,0,'2013-07-06 12:44:34',NULL,NULL),(5376,'04631','S','Eastport','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.904552,-66.995779,0,'2013-07-06 12:44:30',NULL,NULL),(72230,'88435','S','Puerta de Luna','A','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.936606,-104.684358,0,'2013-07-06 12:44:34',NULL,NULL),(21180,'22160','U','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.811286,-77.221189,0,'2013-07-06 12:44:31',NULL,NULL),(40679,'46061','P','Noblesville','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.057606,-86.031722,0,'2013-07-06 12:44:32',NULL,NULL),(42690,'47986','P','Fowler','A','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.516336,-87.207620,0,'2013-07-06 12:44:32',NULL,NULL),(29875,'33041','P','Stock Island','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.558003,-81.808398,0,'2013-07-06 12:44:32',NULL,NULL),(33312,'37134','S','Denver','A','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.010324,-87.967812,0,'2013-07-06 12:44:32',NULL,NULL),(37803,'42404','S','Blackford','A','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.490563,-87.793465,0,'2013-07-06 12:44:32',NULL,NULL),(69276,'83440','S','Lyman','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(52936,'61377','S','Garfield','N','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.051074,-89.052018,0,'2013-07-06 12:44:33',NULL,NULL),(9630,'10035','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(7100,'06360','S','Occum','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.550840,-72.027360,0,'2013-07-06 12:44:30',NULL,NULL),(17825,'18414','S','North Abington Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.532124,-75.732122,0,'2013-07-06 12:44:31',NULL,NULL),(21046,'21890','U','Eastern Correctional Inst','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.149316,-75.690351,0,'2013-07-06 12:44:31',NULL,NULL),(46576,'53529','S','Dane','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.235421,-89.525588,0,'2013-07-06 12:44:32',NULL,NULL),(55094,'63302','P','Saint Charles','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.783385,-90.487303,0,'2013-07-06 12:44:33',NULL,NULL),(11494,'12022','S','Berlin','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.694299,-73.370325,0,'2013-07-06 12:44:30',NULL,NULL),(53832,'62305','S','Quincy','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.929831,-91.304424,0,'2013-07-06 12:44:33',NULL,NULL),(40408,'45681','S','Lyndon','N','Ross','39141','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.308066,-83.258473,0,'2013-07-06 12:44:32',NULL,NULL),(45493,'51354','S','Ocheyedan','D','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.415978,-95.533305,0,'2013-07-06 12:44:32',NULL,NULL),(21998,'23276','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.559744,-77.446742,0,'2013-07-06 12:44:31',NULL,NULL),(20699,'21251','U','Morgan State University','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341206,-76.585933,0,'2013-07-06 12:44:31',NULL,NULL),(25532,'28401','S','Cape Fear','A','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.229055,-77.935953,0,'2013-07-06 12:44:31',NULL,NULL),(35046,'39175','S','Hinds Junior College','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.120866,-90.599332,0,'2013-07-06 12:44:32',NULL,NULL),(77715,'97058','S','Rowena','N','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.598999,-121.193323,0,'2013-07-06 12:44:34',NULL,NULL),(65155,'77393','P','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.175872,-95.504233,0,'2013-07-06 12:44:34',NULL,NULL),(51575,'59762','S','Wise River','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.695538,-113.082229,0,'2013-07-06 12:44:33',NULL,NULL),(4734,'03832','P','Eaton Center','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.911744,-71.083715,0,'2013-07-06 12:44:30',NULL,NULL),(6034,'05405','U','Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.477327,-73.203176,0,'2013-07-06 12:44:30',NULL,NULL),(67020,'79532','S','Loraine','D','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.406737,-100.718705,0,'2013-07-06 12:44:34',NULL,NULL),(3554,'01938','S','Ipswich','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.682211,-70.846774,0,'2013-07-06 12:44:30',NULL,NULL),(76202,'95357','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.654470,-120.909982,0,'2013-07-06 12:44:34',NULL,NULL),(72790,'89701','S','Stewart','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(41492,'46946','P','Liberty Mills','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.030681,-85.737580,0,'2013-07-06 12:44:32',NULL,NULL),(20320,'20830','P','Olney','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.159267,-77.075718,0,'2013-07-06 12:44:31',NULL,NULL),(25925,'28651','S','Wilbar','A','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.270637,-81.284124,0,'2013-07-06 12:44:31',NULL,NULL),(52752,'61244','S','East Moline','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(15559,'16636','S','Dysart','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.603615,-78.504444,0,'2013-07-06 12:44:31',NULL,NULL),(22281,'23801','S','Petersburg','A','Prince George','51149','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.237019,-77.334813,0,'2013-07-06 12:44:31',NULL,NULL),(18506,'19101','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.003344,-75.136687,0,'2013-07-06 12:44:31',NULL,NULL),(3671,'02126','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.274690,-71.089937,0,'2013-07-06 12:44:30',NULL,NULL),(67647,'80468','S','Parshall','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.940874,-106.154665,0,'2013-07-06 12:44:34',NULL,NULL),(52090,'60408','S','Braidwood','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.265297,-88.216117,0,'2013-07-06 12:44:33',NULL,NULL),(1126,'00725','S','Villa Carmen','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(34103,'38174','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.132269,-90.002258,0,'2013-07-06 12:44:32',NULL,NULL),(21347,'22430','P','Stafford','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.378786,-77.362519,0,'2013-07-06 12:44:31',NULL,NULL),(78519,'98121','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.612625,-122.344460,0,'2013-07-06 12:44:34',NULL,NULL),(69299,'83448','S','Sugar City','D','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.874217,-111.734555,0,'2013-07-06 12:44:34',NULL,NULL),(2489,'00956','S','Urb Santa Juanita','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(39569,'44851','S','Fitchville','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.101292,-82.421414,0,'2013-07-06 12:44:32',NULL,NULL),(24308,'27017','S','Copeland','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(8713,'08405','U','Nat Aviation Fac Exp Ctr','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.366054,-74.422413,0,'2013-07-06 12:44:30',NULL,NULL),(34783,'38866','S','Eggville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.375655,-88.686467,0,'2013-07-06 12:44:32',NULL,NULL),(45807,'52175','S','West Union','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.969660,-91.800840,0,'2013-07-06 12:44:32',NULL,NULL),(27349,'30052','S','Walnut Grove','A','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.810339,-83.891909,0,'2013-07-06 12:44:31',NULL,NULL),(44606,'50054','S','Colfax','D','Jasper','19099','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.681400,-93.267900,0,'2013-07-06 12:44:32',NULL,NULL),(26390,'29102','S','Wilson','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(25543,'28405','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.281720,-77.824740,0,'2013-07-06 12:44:31',NULL,NULL),(11169,'11727','S','Coram','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.885609,-73.006703,0,'2013-07-06 12:44:30',NULL,NULL),(34401,'38626','S','Clayton','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.534380,-90.396000,0,'2013-07-06 12:44:32',NULL,NULL),(79659,'99153','S','Metaline Falls','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.854700,-117.348494,0,'2013-07-06 12:44:34',NULL,NULL),(6282,'05641','S','Boutswells','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(15268,'16105','S','Castle','N','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.031190,-80.343765,0,'2013-07-06 12:44:31',NULL,NULL),(35325,'39427','S','Carson','D','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.561130,-89.781077,0,'2013-07-06 12:44:32',NULL,NULL),(35619,'39603','P','Bhaven','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.577695,-90.477599,0,'2013-07-06 12:44:32',NULL,NULL),(66351,'78610','S','Mustang Ridge','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.082691,-97.843934,0,'2013-07-06 12:44:34',NULL,NULL),(63806,'75962','U','SF Austin Univ','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(53264,'61710','U','3 State Farm Plaza','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.478286,-88.952728,0,'2013-07-06 12:44:33',NULL,NULL),(77290,'96643','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(68202,'81040','S','Gardner','D','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.786005,-105.182854,0,'2013-07-06 12:44:34',NULL,NULL),(12496,'12998','S','Witherbee','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.086571,-73.536128,0,'2013-07-06 12:44:30',NULL,NULL),(51196,'59030','S','Jardine','N','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.031682,-110.705747,0,'2013-07-06 12:44:33',NULL,NULL),(53536,'62033','S','Dorchester','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.107340,-89.842080,0,'2013-07-06 12:44:33',NULL,NULL),(21266,'22307','S','Belleview','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.772576,-77.056869,0,'2013-07-06 12:44:31',NULL,NULL),(21268,'22308','S','Fort Hunt','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.727682,-77.058124,0,'2013-07-06 12:44:31',NULL,NULL),(58765,'68967','S','Hollinger','N','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(73054,'90090','U','Dodgertown','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.013223,-118.138227,0,'2013-07-06 12:44:34',NULL,NULL),(24904,'27711','U','Rtp','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916201,-78.867468,0,'2013-07-06 12:44:31',NULL,NULL),(54760,'62985','S','Simpson','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.443539,-88.639922,0,'2013-07-06 12:44:33',NULL,NULL),(10858,'11414','S','Howard Beach','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.658635,-73.843765,0,'2013-07-06 12:44:30',NULL,NULL),(27137,'29812','S','Snelling','N','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.243078,-81.359153,0,'2013-07-06 12:44:31',NULL,NULL),(47381,'54630','S','Galesville','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.076034,-91.362035,0,'2013-07-06 12:44:32',NULL,NULL),(21800,'23085','S','King and Qn C H','N','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.728500,-76.845215,0,'2013-07-06 12:44:31',NULL,NULL),(23432,'25392','U','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351984,-81.628434,0,'2013-07-06 12:44:31',NULL,NULL),(25073,'27944','S','Durants Neck','A','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.149640,-76.348920,0,'2013-07-06 12:44:31',NULL,NULL),(51614,'59834','S','Frenchtown','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.047842,-114.238465,0,'2013-07-06 12:44:33',NULL,NULL),(13688,'14051','S','East Amherst','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.033131,-78.693260,0,'2013-07-06 12:44:31',NULL,NULL),(35576,'39571','S','Pass Christian','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.367611,-89.262586,0,'2013-07-06 12:44:32',NULL,NULL),(34512,'38676','S','Hollywood','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(31646,'34737','S','Groveland','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.704236,-81.784964,0,'2013-07-06 12:44:32',NULL,NULL),(17610,'18042','S','Williams Township','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(19029,'19534','S','Lenhartsville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.571700,-75.849180,0,'2013-07-06 12:44:31',NULL,NULL),(30002,'33122','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.799007,-80.300688,0,'2013-07-06 12:44:32',NULL,NULL),(41303,'46767','S','Ligonier','D','Noble','18113','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.466943,-85.588349,0,'2013-07-06 12:44:32',NULL,NULL),(3346,'01550','S','Sandersdale','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.077174,-72.032139,0,'2013-07-06 12:44:30',NULL,NULL),(24556,'27294','U','Lexington','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.821157,-80.250582,0,'2013-07-06 12:44:31',NULL,NULL),(48360,'55488','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.981963,-93.265510,0,'2013-07-06 12:44:33',NULL,NULL),(24540,'27292','S','Feezor','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(55827,'64151','S','Riverside','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(45900,'52312','S','Morley','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.003964,-91.244526,0,'2013-07-06 12:44:32',NULL,NULL),(26257,'29006','S','Batsbrg-Levil','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(21562,'22811','S','Bergton','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.796293,-78.969663,0,'2013-07-06 12:44:31',NULL,NULL),(69682,'84024','P','Emory','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.967600,-111.421819,0,'2013-07-06 12:44:34',NULL,NULL),(20769,'21520','S','Accident','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.643308,-79.309802,0,'2013-07-06 12:44:31',NULL,NULL),(11369,'11930','P','Amagansett','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.976299,-72.133670,0,'2013-07-06 12:44:30',NULL,NULL),(2268,'00926','S','Urb Romany Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(21128,'22101','S','McLean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.929874,-77.175966,0,'2013-07-06 12:44:31',NULL,NULL),(25095,'27958','S','Moyock','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.494355,-76.140012,0,'2013-07-06 12:44:31',NULL,NULL),(26114,'28726','S','E Flat Rock','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.282463,-82.417980,0,'2013-07-06 12:44:31',NULL,NULL),(44040,'49425','S','Brunswick','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.425180,-86.105175,0,'2013-07-06 12:44:32',NULL,NULL),(7366,'06757','S','Kent','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.735781,-73.451858,0,'2013-07-06 12:44:30',NULL,NULL),(29506,'32764','S','Osteen','D','Volusia','12127','Florida','FL','12','2020','407/321/689','Eastern',-5.0,'Y',28.848035,-81.140740,0,'2013-07-06 12:44:32',NULL,NULL),(56639,'65610','S','Browns Spring','N','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.063707,-93.556821,0,'2013-07-06 12:44:33',NULL,NULL),(17909,'18452','S','Peckville','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.476387,-75.587851,0,'2013-07-06 12:44:31',NULL,NULL),(65472,'77632','S','Orange','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.162990,-93.783644,0,'2013-07-06 12:44:34',NULL,NULL),(16632,'17334','U','Direct Brands','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.807897,-76.965787,0,'2013-07-06 12:44:31',NULL,NULL),(17613,'18043','P','Palmer','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.688694,-75.219639,0,'2013-07-06 12:44:31',NULL,NULL),(49362,'56581','S','Shelly','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.457649,-96.720417,0,'2013-07-06 12:44:33',NULL,NULL),(32124,'35442','S','McMullen','N','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.124200,-88.159260,0,'2013-07-06 12:44:32',NULL,NULL),(66664,'78873','S','Leakey','D','Real','48385','Texas','TX','48','0000','830','Central',-6.0,'Y',29.861693,-99.800137,0,'2013-07-06 12:44:34',NULL,NULL),(19104,'19606','S','Five Points','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(26867,'29544','S','Aynor','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.127280,-79.108380,0,'2013-07-06 12:44:31',NULL,NULL),(18011,'18640','S','Jenkins Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(17653,'18077','S','Riegelsville','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.559099,-75.236806,0,'2013-07-06 12:44:31',NULL,NULL),(53106,'61536','S','Smithville','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.687089,-89.792578,0,'2013-07-06 12:44:33',NULL,NULL),(54665,'62935','S','Harco','A','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.844203,-88.609011,0,'2013-07-06 12:44:33',NULL,NULL),(10452,'10921','S','Florida','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.329376,-74.347207,0,'2013-07-06 12:44:30',NULL,NULL),(40532,'45836','S','Dunkirk','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.784838,-83.637661,0,'2013-07-06 12:44:32',NULL,NULL),(67718,'80536','S','Virginia Dale','A','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.858860,-105.373320,0,'2013-07-06 12:44:34',NULL,NULL),(29510,'32767','S','Paisley','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.977072,-81.508830,0,'2013-07-06 12:44:32',NULL,NULL),(67710,'80528','S','Windsor','A','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.583017,-105.082450,0,'2013-07-06 12:44:34',NULL,NULL),(67036,'79543','S','Royston','N','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.720340,-100.419180,0,'2013-07-06 12:44:34',NULL,NULL),(57461,'66856','S','Lebo','D','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.389155,-95.844704,0,'2013-07-06 12:44:33',NULL,NULL),(60245,'71433','S','Melder','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(48167,'55375','S','St Bonifacius','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.904785,-93.749054,0,'2013-07-06 12:44:33',NULL,NULL),(39229,'44417','S','Gustavus','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.425790,-80.661237,0,'2013-07-06 12:44:32',NULL,NULL),(75992,'95076','S','Royal Oaks','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(73641,'91436','S','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165910,-118.463570,0,'2013-07-06 12:44:34',NULL,NULL),(61492,'72641','S','Piercetown','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.002568,-93.217954,0,'2013-07-06 12:44:33',NULL,NULL),(6300,'05655','S','Hyde Park','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.631977,-72.569348,0,'2013-07-06 12:44:30',NULL,NULL),(12408,'12934','S','Ellenburg Ctr','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.829883,-73.859154,0,'2013-07-06 12:44:30',NULL,NULL),(23306,'25201','P','Tad','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.332052,-81.495124,0,'2013-07-06 12:44:31',NULL,NULL),(14850,'15449','P','Keisterville','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.961316,-79.783509,0,'2013-07-06 12:44:31',NULL,NULL),(59686,'71070','S','Chestnut','A','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.118780,-92.975340,0,'2013-07-06 12:44:33',NULL,NULL),(53207,'61615','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.786669,-89.632384,0,'2013-07-06 12:44:33',NULL,NULL),(48403,'55591','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.282346,-93.808682,0,'2013-07-06 12:44:33',NULL,NULL),(42067,'47452','S','Northeast','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(17243,'17837','S','Lewisburg','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(65261,'77469','S','Pleak','N','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(34637,'38762','S','Mound Bayou','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.884479,-90.728270,0,'2013-07-06 12:44:32',NULL,NULL),(25127,'28002','P','Albemarle','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.354388,-80.193633,0,'2013-07-06 12:44:31',NULL,NULL),(7469,'06880','S','Saugatuck','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.138856,-73.347965,0,'2013-07-06 12:44:30',NULL,NULL),(51288,'59201','S','Wolf Point','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.108925,-105.569239,0,'2013-07-06 12:44:33',NULL,NULL),(24172,'26619','S','Riffle','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.798217,-80.764455,0,'2013-07-06 12:44:31',NULL,NULL),(11324,'11787','S','Smithtown','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.855292,-73.209738,0,'2013-07-06 12:44:30',NULL,NULL),(39929,'45224','S','Finneytown','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.201250,-84.531566,0,'2013-07-06 12:44:32',NULL,NULL),(77304,'96671','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(4697,'03813','S','Chatham','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.163170,-71.012330,0,'2013-07-06 12:44:30',NULL,NULL),(46516,'53268','U','Chase Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.040756,-87.911157,0,'2013-07-06 12:44:32',NULL,NULL),(30243,'33196','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.651234,-80.481360,0,'2013-07-06 12:44:32',NULL,NULL),(58490,'68759','S','Newport','D','Keya Paha','31103','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.595928,-99.336785,0,'2013-07-06 12:44:33',NULL,NULL),(35646,'39641','S','Enon','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(19569,'20211','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902413,-77.007921,0,'2013-07-06 12:44:31',NULL,NULL),(11937,'12433','S','Glenford','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.008101,-74.151420,0,'2013-07-06 12:44:30',NULL,NULL),(71635,'87413','S','Bloomfield','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.713295,-107.969839,0,'2013-07-06 12:44:34',NULL,NULL),(69696,'84031','S','Defas Park','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.436388,-110.826187,0,'2013-07-06 12:44:34',NULL,NULL),(66331,'78602','S','Calvin','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.115800,-97.274640,0,'2013-07-06 12:44:34',NULL,NULL),(21720,'23002','S','Amelia Court House','D','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.390980,-77.904720,0,'2013-07-06 12:44:31',NULL,NULL),(4720,'03824','S','Durham','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.130400,-70.976700,0,'2013-07-06 12:44:30',NULL,NULL),(30484,'33351','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.177671,-80.275118,0,'2013-07-06 12:44:32',NULL,NULL),(13167,'13608','S','Antwerp','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.198498,-75.607636,0,'2013-07-06 12:44:30',NULL,NULL),(35612,'39601','S','Pearlhaven','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(53716,'62240','S','IMBS','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.525161,-90.223920,0,'2013-07-06 12:44:33',NULL,NULL),(45052,'50501','S','Coalville','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(57635,'67147','S','Valley Center','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.841324,-97.339730,0,'2013-07-06 12:44:33',NULL,NULL),(28116,'30810','S','Edge Hill','A','Glascock','13125','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.235312,-82.597815,0,'2013-07-06 12:44:31',NULL,NULL),(10546,'10997','P','West Point','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.361500,-74.027051,0,'2013-07-06 12:44:30',NULL,NULL),(5772,'05047','P','Hartford','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.658592,-72.337881,0,'2013-07-06 12:44:30',NULL,NULL),(60679,'71923','S','West Gum Springs','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(69789,'84063','S','Randlett','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.211092,-109.729363,0,'2013-07-06 12:44:34',NULL,NULL),(75833,'94915','P','Mission Rafael','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.959899,-122.504023,0,'2013-07-06 12:44:34',NULL,NULL),(79642,'99138','S','Kewa','N','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.288105,-118.525606,0,'2013-07-06 12:44:34',NULL,NULL),(79937,'99620','P','Kotlik','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.096658,-164.037979,0,'2013-07-06 12:44:34',NULL,NULL),(69648,'84008','S','Bonanza','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.019053,-109.175359,0,'2013-07-06 12:44:34',NULL,NULL),(67496,'80234','S','Denver','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(63296,'75561','S','Burns','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(53746,'62257','S','Marrisa','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.253730,-89.758689,0,'2013-07-06 12:44:33',NULL,NULL),(60157,'71404','S','Atlanta','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.832832,-92.788989,0,'2013-07-06 12:44:33',NULL,NULL),(7149,'06415','S','Colchester','D','New London','09011','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.551164,-72.331473,0,'2013-07-06 12:44:30',NULL,NULL),(8175,'07875','P','Stillwater','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.035937,-74.879943,0,'2013-07-06 12:44:30',NULL,NULL),(12526,'13033','S','Cato','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.193419,-76.565257,0,'2013-07-06 12:44:30',NULL,NULL),(34136,'38225','S','Dresden','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.290460,-88.704397,0,'2013-07-06 12:44:32',NULL,NULL),(54727,'62964','S','North Mounds','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.116221,-89.194753,0,'2013-07-06 12:44:33',NULL,NULL),(35301,'39401','S','Palmers Crossing','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(27920,'30512','S','Blairsville','D','Union','13291','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.877672,-84.022139,0,'2013-07-06 12:44:31',NULL,NULL),(17151,'17801','S','Upper Augusta','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(77989,'97401','S','Crow','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.080533,-123.073047,0,'2013-07-06 12:44:34',NULL,NULL),(55142,'63361','S','Buell','A','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(60618,'71862','S','Washington','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.750451,-93.668049,0,'2013-07-06 12:44:33',NULL,NULL),(13243,'13642','S','Emeryville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(75919,'95009','P','Campbell','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.289052,-121.947960,0,'2013-07-06 12:44:34',NULL,NULL),(75512,'94144','U','Wells Fargo Bank','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.783348,-122.459783,0,'2013-07-06 12:44:34',NULL,NULL),(8472,'08089','S','Waterford Works','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722580,-74.859000,0,'2013-07-06 12:44:30',NULL,NULL),(17910,'18453','S','Pleasant Mount','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.732223,-75.389178,0,'2013-07-06 12:44:31',NULL,NULL),(18386,'19048','U','Ft Washington','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.176074,-74.924818,0,'2013-07-06 12:44:31',NULL,NULL),(27698,'30339','S','Cumberland','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(46738,'53913','S','Baraboo','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.525920,-89.774040,0,'2013-07-06 12:44:32',NULL,NULL),(54092,'62530','S','Divernon','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.565165,-89.656848,0,'2013-07-06 12:44:33',NULL,NULL),(32273,'35646','S','Leighton','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.698609,-87.522872,0,'2013-07-06 12:44:32',NULL,NULL),(43892,'49236','S','Clinton','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.066581,-83.957581,0,'2013-07-06 12:44:32',NULL,NULL),(39804,'45140','S','Epworth Heights','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(34580,'38737','S','Goldfield','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(71044,'85745','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.250456,-111.030356,0,'2013-07-06 12:44:34',NULL,NULL),(27213,'29909','S','Sun City','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.262421,-80.867479,0,'2013-07-06 12:44:31',NULL,NULL),(3951,'02475','P','Arlington','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420254,-71.180935,0,'2013-07-06 12:44:30',NULL,NULL),(14801,'15379','P','W Middletown','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.242130,-80.426974,0,'2013-07-06 12:44:31',NULL,NULL),(28052,'30668','S','Danburg','A','Wilkes','13317','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.782130,-82.816561,0,'2013-07-06 12:44:31',NULL,NULL),(9321,'09733','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60047,'71346','S','Lamourie','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(65754,'78064','S','Pleasanton','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.968189,-98.487854,0,'2013-07-06 12:44:34',NULL,NULL),(66996,'79502','S','Peacock','N','Stonewall','48433','Texas','TX','48','0000','940','Central',-6.0,'Y',33.109200,-100.270800,0,'2013-07-06 12:44:34',NULL,NULL),(46799,'54001','S','Range','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(2883,'00987','S','Ext Parq Ecuestre','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(15596,'16668','S','Patton','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.632325,-78.651183,0,'2013-07-06 12:44:31',NULL,NULL),(26203,'28776','P','Skyland','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.482015,-82.523906,0,'2013-07-06 12:44:31',NULL,NULL),(40828,'46211','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892914,-86.257085,0,'2013-07-06 12:44:32',NULL,NULL),(41618,'47125','S','Hardinsburg','D','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.466102,-86.323493,0,'2013-07-06 12:44:32',NULL,NULL),(41914,'47374','S','Spring Grove Heights','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(31897,'35144','P','Alabaster','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.200000,-86.783333,0,'2013-07-06 12:44:32',NULL,NULL),(2619,'00962','S','Parc William Fuertes','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(46154,'52720','S','Atalissa','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.569059,-91.162052,0,'2013-07-06 12:44:32',NULL,NULL),(26704,'29409','U','The Citadel','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.794242,-79.960770,0,'2013-07-06 12:44:31',NULL,NULL),(51217,'59052','S','Mc Leod','D','Sweet Grass','30097','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.539768,-110.306341,0,'2013-07-06 12:44:33',NULL,NULL),(1581,'00767','S','Villa Hilda','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(39416,'44669','S','Paris','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.788186,-81.159780,0,'2013-07-06 12:44:32',NULL,NULL),(77560,'96863','S','Mcbh Kaneohe Bay','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.388480,-157.755014,0,'2013-07-06 12:44:34',NULL,NULL),(16375,'17201','S','Sunbeam','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(75536,'94207','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.581693,-121.488693,0,'2013-07-06 12:44:34',NULL,NULL),(72509,'89152','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.170712,-115.209471,0,'2013-07-06 12:44:34',NULL,NULL),(40615,'45999','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.085561,-84.513589,0,'2013-07-06 12:44:32',NULL,NULL),(52742,'61239','S','Carbon Cliff','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.494663,-90.390578,0,'2013-07-06 12:44:33',NULL,NULL),(58193,'68315','S','Belvidere','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.253359,-97.535575,0,'2013-07-06 12:44:33',NULL,NULL),(62191,'73768','S','Ringwood','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.380403,-98.243833,0,'2013-07-06 12:44:33',NULL,NULL),(48190,'55391','S','Wayzata','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.966040,-93.541800,0,'2013-07-06 12:44:33',NULL,NULL),(62943,'75098','S','Wylie','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.021961,-96.537200,0,'2013-07-06 12:44:33',NULL,NULL),(37929,'42635','S','Pine Knot','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.650404,-84.396639,0,'2013-07-06 12:44:32',NULL,NULL),(24554,'27292','S','Yadkin College','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(29649,'32904','S','Melbourne Village','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074548,-80.694237,0,'2013-07-06 12:44:32',NULL,NULL),(51283,'59115','U','Us Bank','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.785907,-108.508798,0,'2013-07-06 12:44:33',NULL,NULL),(55818,'64149','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.861361,-94.461681,0,'2013-07-06 12:44:33',NULL,NULL),(25912,'28645','S','Mortimer','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(52295,'60539','S','Mooseheart','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.823889,-88.334722,0,'2013-07-06 12:44:33',NULL,NULL),(7568,'07026','S','Outwater','N','Bergen','34003','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.879414,-74.109454,0,'2013-07-06 12:44:30',NULL,NULL),(28879,'32121','P','South Daytona','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.193767,-81.053922,0,'2013-07-06 12:44:32',NULL,NULL),(35779,'39746','S','Hamilton','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.799577,-88.429985,0,'2013-07-06 12:44:32',NULL,NULL),(44938,'50363','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595159,-93.764976,0,'2013-07-06 12:44:32',NULL,NULL),(75850,'94928','S','Rohnert Park','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.343934,-122.699887,0,'2013-07-06 12:44:34',NULL,NULL),(68342,'81126','P','Chama','D','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.171408,-105.390972,0,'2013-07-06 12:44:34',NULL,NULL),(40857,'46228','S','Crows Nest','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(36233,'40291','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.125140,-85.589280,0,'2013-07-06 12:44:32',NULL,NULL),(16092,'17051','S','Mc Veytown','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(56340,'65110','P','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.576911,-92.175487,0,'2013-07-06 12:44:33',NULL,NULL),(36141,'40231','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.179183,-85.719878,0,'2013-07-06 12:44:32',NULL,NULL),(11389,'11942','S','E Quogue','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.847122,-72.573666,0,'2013-07-06 12:44:30',NULL,NULL),(79634,'99131','S','Gifford','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.275675,-118.136018,0,'2013-07-06 12:44:34',NULL,NULL),(65142,'77386','S','Oak Ridge N','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.131735,-95.416441,0,'2013-07-06 12:44:34',NULL,NULL),(75667,'94543','P','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.673234,-122.082200,0,'2013-07-06 12:44:34',NULL,NULL),(73816,'91764','S','Ontario','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.077008,-117.617165,0,'2013-07-06 12:44:34',NULL,NULL),(71655,'87501','S','Jacona','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(51936,'60124','S','Campton Hills','A','Kane','17089','Illinois','IL','17','1600','847','Central',-6.0,'Y',42.040262,-88.310402,0,'2013-07-06 12:44:33',NULL,NULL),(56641,'65611','S','Blue Eye','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.517044,-93.449482,0,'2013-07-06 12:44:33',NULL,NULL),(56868,'66016','S','Cummings','D','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.482336,-95.294104,0,'2013-07-06 12:44:33',NULL,NULL),(635,'00682','S','Urb Fraternidad','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(11385,'11939','S','East Marion','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.128421,-72.341905,0,'2013-07-06 12:44:30',NULL,NULL),(9916,'10150','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(78814,'98331','S','Upper Hoh','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(42098,'47460','S','Pottersville','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(43891,'49235','S','Clayton Twp','A','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.866607,-84.211330,0,'2013-07-06 12:44:32',NULL,NULL),(45487,'51351','S','Milford','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.323480,-95.169660,0,'2013-07-06 12:44:32',NULL,NULL),(13795,'14201','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.897970,-78.884047,0,'2013-07-06 12:44:31',NULL,NULL),(52588,'61011','S','Argyle','N','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.387191,-88.893272,0,'2013-07-06 12:44:33',NULL,NULL),(54939,'63114','S','Breckenridge Hills','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(27703,'30339','S','Vinnings','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(40388,'45661','S','Piketon','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.037860,-83.101200,0,'2013-07-06 12:44:32',NULL,NULL),(23384,'25306','S','Malden','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.305020,-81.530460,0,'2013-07-06 12:44:31',NULL,NULL),(7474,'06888','U','Westport','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.120054,-73.346424,0,'2013-07-06 12:44:30',NULL,NULL),(63933,'76066','S','Cool','A','Parker','48367','Texas','TX','48','2800','940','Central',-6.0,'Y',32.757899,-98.005545,0,'2013-07-06 12:44:34',NULL,NULL),(48948,'56170','S','Florence','A','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.188020,-96.071700,0,'2013-07-06 12:44:33',NULL,NULL),(69104,'83255','S','Moore','D','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869160,-113.078054,0,'2013-07-06 12:44:34',NULL,NULL),(45934,'52336','S','Whittier','A','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.094680,-91.462620,0,'2013-07-06 12:44:32',NULL,NULL),(12542,'13040','S','Cincinnatus','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.562547,-75.928525,0,'2013-07-06 12:44:30',NULL,NULL),(3873,'02360','S','Cedarville','N','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.872920,-70.641420,0,'2013-07-06 12:44:30',NULL,NULL),(10474,'10949','P','Monroe','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.336262,-74.185852,0,'2013-07-06 12:44:30',NULL,NULL),(59037,'70084','S','Belle Point','N','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.069968,-90.557182,0,'2013-07-06 12:44:33',NULL,NULL),(73609,'91395','P','Mission Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.253953,-118.464623,0,'2013-07-06 12:44:34',NULL,NULL),(76771,'95932','S','Colusa','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.211344,-122.010476,0,'2013-07-06 12:44:34',NULL,NULL),(78057,'97454','S','Marcola','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.207589,-122.816542,0,'2013-07-06 12:44:34',NULL,NULL),(43082,'48203','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424001,-83.101934,0,'2013-07-06 12:44:32',NULL,NULL),(8473,'08090','S','Oak Valley','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.799114,-75.150975,0,'2013-07-06 12:44:30',NULL,NULL),(23620,'25716','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.398288,-82.448343,0,'2013-07-06 12:44:31',NULL,NULL),(26048,'28685','S','Joynes','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.346465,-81.027968,0,'2013-07-06 12:44:31',NULL,NULL),(804,'00693','S','Sect Lomba','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(11372,'11931','P','Aquebogue','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.946526,-72.598308,0,'2013-07-06 12:44:30',NULL,NULL),(23699,'25866','P','Lochgelly','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.013867,-81.148885,0,'2013-07-06 12:44:31',NULL,NULL),(7729,'07202','S','Elmora','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.656153,-74.218524,0,'2013-07-06 12:44:30',NULL,NULL),(79266,'98569','S','Ocean City','A','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.970702,-124.150812,0,'2013-07-06 12:44:34',NULL,NULL),(64163,'76210','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.145623,-97.090468,0,'2013-07-06 12:44:34',NULL,NULL),(33956,'38104','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.133557,-89.998776,0,'2013-07-06 12:44:32',NULL,NULL),(69995,'84123','S','Murray','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(33978,'38112','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145279,-89.979378,0,'2013-07-06 12:44:32',NULL,NULL),(8568,'08214','P','Dennisville','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.191334,-74.824104,0,'2013-07-06 12:44:30',NULL,NULL),(58129,'68136','S','Omaha','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.166069,-96.174813,0,'2013-07-06 12:44:33',NULL,NULL),(42841,'48071','S','Madison Heights','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.504258,-83.104966,0,'2013-07-06 12:44:32',NULL,NULL),(39128,'44266','S','Charlestown','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.159227,-81.233714,0,'2013-07-06 12:44:32',NULL,NULL),(36142,'40232','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.175012,-85.720253,0,'2013-07-06 12:44:32',NULL,NULL),(21774,'23062','S','Glouster Point','N','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.256502,-76.493791,0,'2013-07-06 12:44:31',NULL,NULL),(77430,'96804','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306209,-157.860153,0,'2013-07-06 12:44:34',NULL,NULL),(56553,'65464','S','Elk Creek','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.215181,-91.994666,0,'2013-07-06 12:44:33',NULL,NULL),(14849,'15448','P','Jacobs Creek','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.135526,-79.740385,0,'2013-07-06 12:44:31',NULL,NULL),(26371,'29075','S','Little Mtn','A','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.204268,-81.289172,0,'2013-07-06 12:44:31',NULL,NULL),(21962,'23237','S','North Chesterfield','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.400976,-77.461897,0,'2013-07-06 12:44:31',NULL,NULL),(11382,'11937','S','E Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.004735,-72.178804,0,'2013-07-06 12:44:30',NULL,NULL),(32233,'35581','S','Phil Campbell','D','Franklin','01059','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.353650,-87.762918,0,'2013-07-06 12:44:32',NULL,NULL),(8072,'07753','S','Neptune','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(57515,'66964','S','Republic','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.923093,-97.825399,0,'2013-07-06 12:44:33',NULL,NULL),(51093,'58771','S','Wabek','N','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.020768,-101.958837,0,'2013-07-06 12:44:33',NULL,NULL),(71882,'87733','S','Albert','A','Harding','35021','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.733480,-103.599120,0,'2013-07-06 12:44:34',NULL,NULL),(68514,'81327','S','Lewis','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.498381,-108.671871,0,'2013-07-06 12:44:34',NULL,NULL),(59979,'71325','S','Loyds Bridge','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.018235,-92.292222,0,'2013-07-06 12:44:33',NULL,NULL),(43067,'48193','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(12446,'12965','S','Fort Jackson','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.705556,-74.715278,0,'2013-07-06 12:44:30',NULL,NULL),(56999,'66204','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(57633,'67146','S','Udall','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.385176,-97.123103,0,'2013-07-06 12:44:33',NULL,NULL),(52454,'60673','U','Jp Morgan Chase','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.887505,-87.628813,0,'2013-07-06 12:44:33',NULL,NULL),(60822,'72034','S','Conway','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.089669,-92.442567,0,'2013-07-06 12:44:33',NULL,NULL),(33296,'37129','S','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.871995,-86.435491,0,'2013-07-06 12:44:32',NULL,NULL),(66744,'78963','S','West Point','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.960773,-97.036120,0,'2013-07-06 12:44:34',NULL,NULL),(59464,'70738','P','Burnside','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.140739,-90.924234,0,'2013-07-06 12:44:33',NULL,NULL),(27221,'29915','S','Daufuskie Is','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.216111,-80.752778,0,'2013-07-06 12:44:31',NULL,NULL),(30015,'33132','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.784288,-80.193450,0,'2013-07-06 12:44:32',NULL,NULL),(37458,'41858','S','Crown','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(40880,'46240','S','Williams Crk','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.905944,-86.128201,0,'2013-07-06 12:44:32',NULL,NULL),(56405,'65247','S','Excello','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.651110,-92.451199,0,'2013-07-06 12:44:33',NULL,NULL),(17249,'17840','P','Locust Gap','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.773793,-76.437070,0,'2013-07-06 12:44:31',NULL,NULL),(74352,'92410','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.105653,-117.294667,0,'2013-07-06 12:44:34',NULL,NULL),(29267,'32457','P','Port St Joe','A','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.811847,-85.303541,0,'2013-07-06 12:44:32',NULL,NULL),(26266,'29010','S','Bishopville','D','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(72034,'88055','P','Redrock','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.867790,-108.723525,0,'2013-07-06 12:44:34',NULL,NULL),(73723,'91617','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164995,-118.403562,0,'2013-07-06 12:44:34',NULL,NULL),(5064,'04280','S','Wales','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.112074,-70.100318,0,'2013-07-06 12:44:30',NULL,NULL),(40491,'45786','S','Waterford','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.514530,-81.666299,0,'2013-07-06 12:44:32',NULL,NULL),(10254,'10474','S','Boulevard','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.809555,-73.885815,0,'2013-07-06 12:44:30',NULL,NULL),(49791,'57107','S','Ellis','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.565350,-96.796958,0,'2013-07-06 12:44:33',NULL,NULL),(11397,'11950','S','Mastic','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.806599,-72.840193,0,'2013-07-06 12:44:30',NULL,NULL),(26229,'28803','S','Biltmore Frst','A','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.548613,-82.522312,0,'2013-07-06 12:44:31',NULL,NULL),(35904,'40013','S','Samuels','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.917352,-85.501392,0,'2013-07-06 12:44:32',NULL,NULL),(17109,'17771','S','Gamble','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(23612,'25708','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.421876,-82.441837,0,'2013-07-06 12:44:31',NULL,NULL),(4152,'02764','S','North Dighton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.856622,-71.148635,0,'2013-07-06 12:44:30',NULL,NULL),(19134,'19609','S','Wyomissing','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(36549,'40906','S','Himyar','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(51762,'60030','S','Hainesville','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(27487,'30157','S','Dallas','D','Paulding','13223','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.873764,-84.865050,0,'2013-07-06 12:44:31',NULL,NULL),(75987,'95076','S','Corralitos','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(45389,'51029','S','Larrabee','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.862632,-95.544096,0,'2013-07-06 12:44:32',NULL,NULL),(41452,'46897','U','Fort Wayne Brm','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069224,-85.161465,0,'2013-07-06 12:44:32',NULL,NULL),(20102,'20706','S','Lanham Seabrook','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.963377,-76.854396,0,'2013-07-06 12:44:31',NULL,NULL),(27395,'30086','P','Stone Mountain','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.803359,-84.103425,0,'2013-07-06 12:44:31',NULL,NULL),(30276,'33256','P','Kendall','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661865,-80.326386,0,'2013-07-06 12:44:32',NULL,NULL),(12440,'12960','S','Moriah','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.037103,-73.516791,0,'2013-07-06 12:44:30',NULL,NULL),(75831,'94914','P','Greenbrae','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.947390,-122.537057,0,'2013-07-06 12:44:34',NULL,NULL),(78405,'98036','S','Lynnwood','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.802780,-122.284860,0,'2013-07-06 12:44:34',NULL,NULL),(70563,'85048','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.331272,-112.047146,0,'2013-07-06 12:44:34',NULL,NULL),(62381,'74078','U','Stillwater','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.115627,-97.058038,0,'2013-07-06 12:44:33',NULL,NULL),(6251,'05501','U','Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.652272,-71.183498,0,'2013-07-06 12:44:30',NULL,NULL),(26039,'28683','S','Doughton','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.362647,-80.939260,0,'2013-07-06 12:44:31',NULL,NULL),(48988,'56229','S','Cottonwood','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.606261,-95.671125,0,'2013-07-06 12:44:33',NULL,NULL),(28748,'31998','U','Amer Fam Life Ins Brm','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.468275,-84.949281,0,'2013-07-06 12:44:32',NULL,NULL),(58465,'68733','S','Emerson','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.282459,-96.727307,0,'2013-07-06 12:44:33',NULL,NULL),(722,'00687','S','Sect Marrero','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(47088,'54435','S','Jeffris','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.400965,-89.462214,0,'2013-07-06 12:44:32',NULL,NULL),(8788,'08558','S','Skillman','D','Somerset','34035','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.416194,-74.695442,0,'2013-07-06 12:44:30',NULL,NULL),(18311,'19020','S','Andalusia','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.102797,-74.929344,0,'2013-07-06 12:44:31',NULL,NULL),(20240,'20781','S','Avondale','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(69742,'84046','S','Green Lake','N','Daggett','49009','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.992285,-109.715572,0,'2013-07-06 12:44:34',NULL,NULL),(74221,'92313','S','Grand Terrace','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.061014,-117.324151,0,'2013-07-06 12:44:34',NULL,NULL),(74463,'92593','P','Rancho California','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.502066,-117.154829,0,'2013-07-06 12:44:34',NULL,NULL),(79780,'99343','S','Mesa','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.568040,-119.167620,0,'2013-07-06 12:44:34',NULL,NULL),(48975,'56216','S','Blomkest','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.968860,-95.056440,0,'2013-07-06 12:44:33',NULL,NULL),(19067,'19550','P','Rehrersburg','D','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.459219,-76.243509,0,'2013-07-06 12:44:31',NULL,NULL),(66507,'78702','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.266794,-97.714339,0,'2013-07-06 12:44:34',NULL,NULL),(15435,'16374','S','Kennerdell','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.284958,-79.744073,0,'2013-07-06 12:44:31',NULL,NULL),(45782,'52159','S','Watson','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.049280,-91.388773,0,'2013-07-06 12:44:32',NULL,NULL),(11458,'12007','S','Alcove','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.464479,-73.921582,0,'2013-07-06 12:44:30',NULL,NULL),(22039,'23301','S','Accomac','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.705746,-75.664050,0,'2013-07-06 12:44:31',NULL,NULL),(53115,'61542','S','Little America','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.405833,-90.034444,0,'2013-07-06 12:44:33',NULL,NULL),(43499,'48625','S','Harrison','D','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.041448,-84.807070,0,'2013-07-06 12:44:32',NULL,NULL),(23322,'25213','S','Winfield','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.499702,-81.879500,0,'2013-07-06 12:44:31',NULL,NULL),(76754,'95923','S','Canyon Dam','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.208520,-121.155480,0,'2013-07-06 12:44:34',NULL,NULL),(31665,'34753','S','Mascotte','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.579955,-81.892469,0,'2013-07-06 12:44:32',NULL,NULL),(25196,'28073','S','Grover','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.202734,-81.478614,0,'2013-07-06 12:44:31',NULL,NULL),(28283,'31090','S','Toomsboro','D','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.843356,-83.098794,0,'2013-07-06 12:44:31',NULL,NULL),(67502,'80235','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.645945,-105.081888,0,'2013-07-06 12:44:34',NULL,NULL),(25820,'28612','S','Connelly Springs','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.819784,-81.615772,0,'2013-07-06 12:44:31',NULL,NULL),(16621,'17331','S','Park Heights','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(11228,'11751','S','Islip Manor','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732034,-73.213359,0,'2013-07-06 12:44:30',NULL,NULL),(31377,'34212','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.471865,-82.412165,0,'2013-07-06 12:44:32',NULL,NULL),(45049,'50483','S','Wesley','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.084090,-93.993811,0,'2013-07-06 12:44:32',NULL,NULL),(40359,'45634','S','Hamden','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.160870,-82.524305,0,'2013-07-06 12:44:32',NULL,NULL),(21823,'23111','S','Mechanicsville','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.631363,-77.356146,0,'2013-07-06 12:44:31',NULL,NULL),(18441,'19066','S','Merion Station','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002386,-75.253465,0,'2013-07-06 12:44:31',NULL,NULL),(69913,'84108','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.738359,-111.812479,0,'2013-07-06 12:44:34',NULL,NULL),(14837,'15436','S','Fairchance','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.814848,-79.724357,0,'2013-07-06 12:44:31',NULL,NULL),(36187,'40256','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.195411,-85.808291,0,'2013-07-06 12:44:32',NULL,NULL),(39294,'44492','P','West Point','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.707961,-80.702205,0,'2013-07-06 12:44:32',NULL,NULL),(31954,'35210','S','Irondale','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(34595,'38746','S','Gunnison','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.977222,-90.912222,0,'2013-07-06 12:44:32',NULL,NULL),(6974,'06239','S','South Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.790480,-71.855880,0,'2013-07-06 12:44:30',NULL,NULL),(47016,'54308','P','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.509218,-87.934095,0,'2013-07-06 12:44:32',NULL,NULL),(4522,'03305','U','Concord','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.206116,-71.539058,0,'2013-07-06 12:44:30',NULL,NULL),(17983,'18619','S','Hillsgrove','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.433378,-76.709144,0,'2013-07-06 12:44:31',NULL,NULL),(69179,'83333','S','Triumph','A','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.520227,-114.306418,0,'2013-07-06 12:44:34',NULL,NULL),(71236,'86337','P','Seligman','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.330209,-112.875150,0,'2013-07-06 12:44:34',NULL,NULL),(68980,'83114','S','Raymond','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.294901,-111.093695,0,'2013-07-06 12:44:34',NULL,NULL),(64059,'76134','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.642955,-97.327416,0,'2013-07-06 12:44:34',NULL,NULL),(63292,'75559','S','Siloam','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(62123,'73658','S','Oakwood','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.933395,-98.705777,0,'2013-07-06 12:44:33',NULL,NULL),(62115,'73646','S','Fay','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.834829,-98.678039,0,'2013-07-06 12:44:33',NULL,NULL),(42153,'47521','S','Celestine','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.392127,-86.734494,0,'2013-07-06 12:44:32',NULL,NULL),(21191,'22185','U','AT&T','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.899292,-77.260327,0,'2013-07-06 12:44:31',NULL,NULL),(2171,'00926','S','Camino Del Bosque','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(80200,'99927','P','Point Baker','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.246711,-133.356548,0,'2013-07-06 12:44:34',NULL,NULL),(3255,'01441','U','Westminster','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.573616,-71.994641,0,'2013-07-06 12:44:30',NULL,NULL),(43134,'48235','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.425493,-83.193350,0,'2013-07-06 12:44:32',NULL,NULL),(52501,'60712','S','Chgo','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.003155,-87.734888,0,'2013-07-06 12:44:33',NULL,NULL),(13964,'14470','S','Holley','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.253056,-78.066111,0,'2013-07-06 12:44:31',NULL,NULL),(71228,'86332','S','Peeples Vly','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.433099,-112.599720,0,'2013-07-06 12:44:34',NULL,NULL),(31768,'35010','S','Alex City','A','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.913360,-85.938360,0,'2013-07-06 12:44:32',NULL,NULL),(70167,'84321','S','Nibley','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.736480,-111.673800,0,'2013-07-06 12:44:34',NULL,NULL),(62534,'74429','S','Coweta','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.956129,-95.658301,0,'2013-07-06 12:44:33',NULL,NULL),(62049,'73531','S','Devol','D','Cotton','40033','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.216520,-98.565803,0,'2013-07-06 12:44:33',NULL,NULL),(49807,'57201','S','Foley','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(12938,'13348','S','Hartwick','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695880,-75.066180,0,'2013-07-06 12:44:30',NULL,NULL),(8500,'08097','S','Woodbury','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.831240,-75.151020,0,'2013-07-06 12:44:30',NULL,NULL),(38028,'43021','S','Galena','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.195977,-82.899957,0,'2013-07-06 12:44:32',NULL,NULL),(19568,'20211','U','Office of Workers Comp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902413,-77.007921,0,'2013-07-06 12:44:31',NULL,NULL),(2756,'00969','S','Urb Tierra Alta III','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(69575,'83833','S','Harrison','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.452307,-116.775887,0,'2013-07-06 12:44:34',NULL,NULL),(77678,'97034','S','Lake Grove','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.410367,-122.689055,0,'2013-07-06 12:44:34',NULL,NULL),(73976,'92083','S','Vista','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.190177,-117.234888,0,'2013-07-06 12:44:34',NULL,NULL),(2745,'00969','S','Urb Parkville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(41887,'47371','S','Antiville','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(44956,'50393','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582211,-93.622208,0,'2013-07-06 12:44:32',NULL,NULL),(33029,'36727','S','Campbell','D','Clarke','01025','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.966651,-88.007603,0,'2013-07-06 12:44:32',NULL,NULL),(45134,'50575','S','Knoke','A','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.517470,-94.763370,0,'2013-07-06 12:44:32',NULL,NULL),(5160,'04426','S','Bowerbank','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(2905,'00987','S','Urb Rolling Hls','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(44579,'50032','P','Berwick','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.666398,-93.544619,0,'2013-07-06 12:44:32',NULL,NULL),(41652,'47138','S','Lexington','D','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.712755,-85.655231,0,'2013-07-06 12:44:32',NULL,NULL),(41174,'46706','S','Norland Park','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.370451,-85.045718,0,'2013-07-06 12:44:32',NULL,NULL),(72432,'89081','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.257700,-115.142400,0,'2013-07-06 12:44:34',NULL,NULL),(43554,'48710','U','University Ctr','N','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.561826,-83.987515,0,'2013-07-06 12:44:32',NULL,NULL),(3463,'01805','U','Burlington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.506346,-71.198244,0,'2013-07-06 12:44:30',NULL,NULL),(46749,'53926','S','Dalton','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.655050,-89.206388,0,'2013-07-06 12:44:32',NULL,NULL),(54739,'62971','P','Oraville','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.863401,-89.384050,0,'2013-07-06 12:44:33',NULL,NULL),(22147,'23457','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.618897,-76.058292,0,'2013-07-06 12:44:31',NULL,NULL),(65214,'77437','S','West End','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(74422,'92555','S','Rancho Belago','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.915796,-117.163893,0,'2013-07-06 12:44:34',NULL,NULL),(78995,'98382','S','Diamond Point','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(47402,'54645','P','Mt Sterling','A','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.314232,-90.930144,0,'2013-07-06 12:44:32',NULL,NULL),(78206,'97741','S','Metolius','A','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.650922,-121.136968,0,'2013-07-06 12:44:34',NULL,NULL),(74205,'92301','S','Adelanto','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.589414,-117.479821,0,'2013-07-06 12:44:34',NULL,NULL),(70882,'85611','S','Elgin','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.615365,-110.515379,0,'2013-07-06 12:44:34',NULL,NULL),(65715,'78019','P','Encinal','D','La Salle','48283','Texas','TX','48','0000','956','Central',-6.0,'Y',28.038753,-99.353485,0,'2013-07-06 12:44:34',NULL,NULL),(65450,'77598','S','Webster','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.540073,-95.142762,0,'2013-07-06 12:44:34',NULL,NULL),(23986,'26327','S','Berea','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.129419,-80.926406,0,'2013-07-06 12:44:31',NULL,NULL),(41950,'47401','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.095259,-86.457677,0,'2013-07-06 12:44:32',NULL,NULL),(30857,'33660','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.931147,-82.375898,0,'2013-07-06 12:44:32',NULL,NULL),(6879,'06140','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.789823,-72.663704,0,'2013-07-06 12:44:30',NULL,NULL),(56366,'65212','U','Umc Hospital Clinics','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.909422,-92.247037,0,'2013-07-06 12:44:33',NULL,NULL),(46048,'52567','S','Libertyville','D','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.956315,-92.049045,0,'2013-07-06 12:44:32',NULL,NULL),(75721,'94586','S','Sunol','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.603456,-121.893025,0,'2013-07-06 12:44:34',NULL,NULL),(29670,'32912','P','W Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.078258,-80.603624,0,'2013-07-06 12:44:32',NULL,NULL),(70459,'84754','S','Austin','A','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.642486,-112.135978,0,'2013-07-06 12:44:34',NULL,NULL),(14113,'14639','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.158018,-77.605115,0,'2013-07-06 12:44:31',NULL,NULL),(28846,'32091','S','Kingsley Lake','A','Bradford','12007','Florida','FL','12','0000','904','Eastern',-5.0,'Y',29.949586,-82.112253,0,'2013-07-06 12:44:32',NULL,NULL),(28214,'31031','S','Ivey','A','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.901291,-83.317179,0,'2013-07-06 12:44:31',NULL,NULL),(23953,'26283','S','Montrose','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.113355,-79.784186,0,'2013-07-06 12:44:31',NULL,NULL),(46667,'53714','S','Monona','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.099135,-89.312700,0,'2013-07-06 12:44:32',NULL,NULL),(5236,'04469','U','University of Maine','N','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.901113,-68.672733,0,'2013-07-06 12:44:30',NULL,NULL),(45755,'52142','S','Donnan','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.857326,-91.809593,0,'2013-07-06 12:44:32',NULL,NULL),(42764,'48035','S','Clinton Township','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.552959,-82.911875,0,'2013-07-06 12:44:32',NULL,NULL),(23458,'25427','S','Jones Springs','A','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.549480,-78.070560,0,'2013-07-06 12:44:31',NULL,NULL),(36801,'41055','S','Mill Creek','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(70265,'84521','S','Elmo','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.392279,-110.818565,0,'2013-07-06 12:44:34',NULL,NULL),(79510,'98923','S','Cowiche','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.663934,-120.731123,0,'2013-07-06 12:44:34',NULL,NULL),(75727,'94590','S','Vallejo','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.104516,-122.243320,0,'2013-07-06 12:44:34',NULL,NULL),(3284,'01477','P','Winchendon Springs','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.695867,-72.017823,0,'2013-07-06 12:44:30',NULL,NULL),(1992,'00909','S','Fdez Juncos','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.447257,-66.067925,0,'2013-07-06 12:44:30',NULL,NULL),(36666,'41011','S','Decoursey','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(565,'00678','S','Repto Kennedy','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(13003,'13413','S','New Hartfd','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.066052,-75.290055,0,'2013-07-06 12:44:30',NULL,NULL),(41184,'46714','S','Rockford','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(24375,'27055','S','Courtney','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(43436,'48503','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.012315,-83.692060,0,'2013-07-06 12:44:32',NULL,NULL),(11528,'12041','S','Clarksville','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.560143,-73.980356,0,'2013-07-06 12:44:30',NULL,NULL),(34288,'38488','S','Taft','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.051918,-86.681270,0,'2013-07-06 12:44:32',NULL,NULL),(30838,'33630','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.968369,-82.519828,0,'2013-07-06 12:44:32',NULL,NULL),(2769,'00971','S','Urb La Fontana De Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388508,-66.115017,0,'2013-07-06 12:44:30',NULL,NULL),(25282,'28133','S','Fountain Hill','N','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.017385,-80.263528,0,'2013-07-06 12:44:31',NULL,NULL),(62127,'73662','S','Sayre','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.299435,-99.638752,0,'2013-07-06 12:44:33',NULL,NULL),(30089,'33157','S','Cutler Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(25957,'28657','S','Stamey Branch','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(62102,'73625','S','Butler','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.647194,-99.259907,0,'2013-07-06 12:44:33',NULL,NULL),(32219,'35572','S','Grayson','N','Winston','01133','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.280278,-87.319444,0,'2013-07-06 12:44:32',NULL,NULL),(38496,'43682','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.642592,-83.544001,0,'2013-07-06 12:44:32',NULL,NULL),(29349,'32561','S','Pensacola Bch','A','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.383106,-87.090524,0,'2013-07-06 12:44:32',NULL,NULL),(42562,'47874','S','Florida','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(15616,'16686','S','Birmingham','A','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.671083,-78.246566,0,'2013-07-06 12:44:31',NULL,NULL),(41183,'46714','S','Reiffsburg','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(6702,'06063','S','Barkhamsted','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917156,-72.977392,0,'2013-07-06 12:44:30',NULL,NULL),(9106,'09095','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21617,'22905','P','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.023188,-78.489866,0,'2013-07-06 12:44:31',NULL,NULL),(11061,'11580','S','N Valley Stream','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.674214,-73.709056,0,'2013-07-06 12:44:30',NULL,NULL),(56130,'64836','S','Brooklyn Heights','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(54258,'62675','S','Atterbury','N','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.003483,-89.851315,0,'2013-07-06 12:44:33',NULL,NULL),(38202,'43212','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(79864,'99559','P','Bethel','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.940000,-164.620000,0,'2013-07-06 12:44:34',NULL,NULL),(67038,'79545','S','Inadale','N','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.440465,-100.529095,0,'2013-07-06 12:44:34',NULL,NULL),(12950,'13355','S','Hubbardsville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.815696,-75.457847,0,'2013-07-06 12:44:30',NULL,NULL),(38701,'44003','S','Andover','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.627584,-80.585183,0,'2013-07-06 12:44:32',NULL,NULL),(47458,'54730','S','Albertville','N','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.999975,-91.723838,0,'2013-07-06 12:44:32',NULL,NULL),(49951,'57344','S','Harrison','D','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.455028,-98.525175,0,'2013-07-06 12:44:33',NULL,NULL),(74357,'92412','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.084156,-117.261759,0,'2013-07-06 12:44:34',NULL,NULL),(23410,'25330','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.347736,-81.630516,0,'2013-07-06 12:44:31',NULL,NULL),(13169,'13608','S','Wegatchie','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.198498,-75.607636,0,'2013-07-06 12:44:30',NULL,NULL),(57134,'66226','S','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.004920,-94.858860,0,'2013-07-06 12:44:33',NULL,NULL),(23427,'25364','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.322642,-81.602646,0,'2013-07-06 12:44:31',NULL,NULL),(34165,'38271','P','Woodland Mls','A','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.430309,-89.123003,0,'2013-07-06 12:44:32',NULL,NULL),(18828,'19420','P','Arcola','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.153344,-75.456923,0,'2013-07-06 12:44:31',NULL,NULL),(59634,'71038','S','Colquitt','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(66060,'78380','S','Rabb','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(12176,'12762','S','Mongaup Vly','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.688622,-74.802774,0,'2013-07-06 12:44:30',NULL,NULL),(5620,'04940','P','Farmingtn Fls','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.620574,-70.074052,0,'2013-07-06 12:44:30',NULL,NULL),(14759,'15331','P','Ellsworth','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.110058,-80.020917,0,'2013-07-06 12:44:31',NULL,NULL),(36207,'40272','S','Kosmosdale','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.087506,-85.844480,0,'2013-07-06 12:44:32',NULL,NULL),(26047,'28685','S','Dockery','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.346465,-81.027968,0,'2013-07-06 12:44:31',NULL,NULL),(5850,'05101','S','Gageville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185420,-72.488580,0,'2013-07-06 12:44:30',NULL,NULL),(26733,'29419','P','Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.936047,-80.100088,0,'2013-07-06 12:44:31',NULL,NULL),(5096,'04345','S','Pittston','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.231489,-69.779004,0,'2013-07-06 12:44:30',NULL,NULL),(1433,'00739','S','Sect Lozada','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(29222,'32422','P','Argyle','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.749556,-86.072870,0,'2013-07-06 12:44:32',NULL,NULL),(71091,'85934','P','Pinedale','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.306291,-110.248080,0,'2013-07-06 12:44:34',NULL,NULL),(60124,'71371','S','Fellowship','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(59773,'71201','S','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(75477,'94112','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.721519,-122.439949,0,'2013-07-06 12:44:34',NULL,NULL),(70203,'84341','S','North Logan','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.781188,-111.822443,0,'2013-07-06 12:44:34',NULL,NULL),(62684,'74723','S','Wade','A','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.998280,-96.013920,0,'2013-07-06 12:44:33',NULL,NULL),(40129,'45333','S','Houston','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.258320,-84.346537,0,'2013-07-06 12:44:32',NULL,NULL),(25937,'28655','S','Morganton','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(32001,'35226','S','Vestavia','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(22954,'24656','S','Vansant','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.160378,-82.127811,0,'2013-07-06 12:44:31',NULL,NULL),(76367,'95501','S','Eureka','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.780564,-124.148905,0,'2013-07-06 12:44:34',NULL,NULL),(55913,'64448','S','Faucett','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.585293,-94.799734,0,'2013-07-06 12:44:33',NULL,NULL),(61235,'72333','S','Elaine','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.304716,-90.852738,0,'2013-07-06 12:44:33',NULL,NULL),(23323,'25214','S','Winifrede','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.165043,-81.560846,0,'2013-07-06 12:44:31',NULL,NULL),(14276,'14854','P','Jacksonville','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.502545,-76.610456,0,'2013-07-06 12:44:31',NULL,NULL),(13898,'14273','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870716,-78.869699,0,'2013-07-06 12:44:31',NULL,NULL),(42939,'48118','S','Freedom Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(484,'00669','S','Lares','D','Lares','72081','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.294354,-66.884391,0,'2013-07-06 12:44:30',NULL,NULL),(31140,'33908','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.506918,-81.928540,0,'2013-07-06 12:44:32',NULL,NULL),(72277,'88557','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766860,-106.331835,0,'2013-07-06 12:44:34',NULL,NULL),(74759,'93094','P','Simi Valley','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.272171,-118.795286,0,'2013-07-06 12:44:34',NULL,NULL),(3988,'02536','S','Teaticket','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(20576,'21152','S','Sparks Glencoe','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.543240,-76.682820,0,'2013-07-06 12:44:31',NULL,NULL),(19512,'20175','S','Leesburg','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.083838,-77.605714,0,'2013-07-06 12:44:31',NULL,NULL),(20026,'20628','S','Dameron','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.140812,-76.328067,0,'2013-07-06 12:44:31',NULL,NULL),(30485,'33351','S','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.177671,-80.275118,0,'2013-07-06 12:44:32',NULL,NULL),(10844,'11411','S','Cambria Heights','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694491,-73.737461,0,'2013-07-06 12:44:30',NULL,NULL),(31785,'35023','S','Hopewell','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.411900,-87.046140,0,'2013-07-06 12:44:32',NULL,NULL),(59434,'70706','S','Denham Spgs','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.606884,-90.920617,0,'2013-07-06 12:44:33',NULL,NULL),(76012,'95123','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.242541,-121.834674,0,'2013-07-06 12:44:34',NULL,NULL),(78903,'98362','S','Gales Addition','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(6779,'06103','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.767862,-72.674838,0,'2013-07-06 12:44:30',NULL,NULL),(55509,'63776','P','Perryville','A','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.714454,-89.890647,0,'2013-07-06 12:44:33',NULL,NULL),(26053,'28689','S','Osbornville','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',36.037202,-80.908540,0,'2013-07-06 12:44:31',NULL,NULL),(33448,'37313','S','Coalmont','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.403427,-85.646182,0,'2013-07-06 12:44:32',NULL,NULL),(31598,'34668','S','Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.303686,-82.700630,0,'2013-07-06 12:44:32',NULL,NULL),(23211,'25075','S','Decota','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(30098,'33158','S','Coral Gbls','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(78325,'97914','S','Claude','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.052879,-116.984744,0,'2013-07-06 12:44:34',NULL,NULL),(61323,'72445','P','Minturn','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.969792,-91.028835,0,'2013-07-06 12:44:33',NULL,NULL),(13930,'14425','S','Farmington','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.958380,-77.310240,0,'2013-07-06 12:44:31',NULL,NULL),(23614,'25710','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.421544,-82.442258,0,'2013-07-06 12:44:31',NULL,NULL),(17039,'17748','P','Mc Elhattan','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.149722,-77.365556,0,'2013-07-06 12:44:31',NULL,NULL),(41294,'46764','S','Larwill','D','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.191399,-85.616852,0,'2013-07-06 12:44:32',NULL,NULL),(54894,'63071','S','Richwoods','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.153582,-90.832931,0,'2013-07-06 12:44:33',NULL,NULL),(34122,'38188','U','Natl Customer Support Ctr','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.096999,-89.857680,0,'2013-07-06 12:44:32',NULL,NULL),(56707,'65672','S','Hollister','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.628402,-93.207631,0,'2013-07-06 12:44:33',NULL,NULL),(45077,'50526','U','Clarion','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.732885,-93.732537,0,'2013-07-06 12:44:32',NULL,NULL),(23065,'24873','S','Paynesville','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.361138,-81.664254,0,'2013-07-06 12:44:31',NULL,NULL),(328,'00650','S','Urb Altos De Florida','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(27601,'30298','P','Forest','N','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.620191,-84.355795,0,'2013-07-06 12:44:31',NULL,NULL),(76681,'95813','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.507995,-121.416783,0,'2013-07-06 12:44:34',NULL,NULL),(37237,'41548','S','Mouthcard','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.374131,-82.287581,0,'2013-07-06 12:44:32',NULL,NULL),(13664,'14029','P','Centerville','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.481516,-78.251815,0,'2013-07-06 12:44:31',NULL,NULL),(40229,'45416','S','Trotwood','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.800645,-84.257639,0,'2013-07-06 12:44:32',NULL,NULL),(16273,'17097','P','Wiconisco','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.572367,-76.688285,0,'2013-07-06 12:44:31',NULL,NULL),(2912,'01002','S','Cushman','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.376860,-72.469140,0,'2013-07-06 12:44:30',NULL,NULL),(76428,'95585','S','Leggett','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.845655,-123.633673,0,'2013-07-06 12:44:34',NULL,NULL),(37529,'42050','S','Hickman','D','Fulton','21075','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.566908,-89.186943,0,'2013-07-06 12:44:32',NULL,NULL),(5026,'04250','S','Lisbon','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.022494,-70.108463,0,'2013-07-06 12:44:30',NULL,NULL),(47827,'55067','P','Rock Creek','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.762300,-92.926200,0,'2013-07-06 12:44:33',NULL,NULL),(49899,'57274','S','Webster','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.325620,-97.519560,0,'2013-07-06 12:44:33',NULL,NULL),(54693,'62949','P','Hurst','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.831859,-89.141272,0,'2013-07-06 12:44:33',NULL,NULL),(11475,'12018','S','East Poestenkill','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(518,'00674','S','Urb Los Rosales','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(1045,'00723','S','Urb Mariani','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(12559,'13052','S','Deruyter','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.760200,-75.892320,0,'2013-07-06 12:44:30',NULL,NULL),(53213,'61629','U','Caterpillar Inc','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.692997,-89.593053,0,'2013-07-06 12:44:33',NULL,NULL),(66449,'78653','S','Cele','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(34164,'38271','P','Woodland Mills','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.430309,-89.123003,0,'2013-07-06 12:44:32',NULL,NULL),(44057,'49440','S','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.232503,-86.251323,0,'2013-07-06 12:44:32',NULL,NULL),(75683,'94555','S','Fremont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.574646,-122.046431,0,'2013-07-06 12:44:34',NULL,NULL),(71710,'87528','S','Jicarilla Apache Indian Rese','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.947461,-106.988234,0,'2013-07-06 12:44:34',NULL,NULL),(70524,'85008','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.469624,-111.998569,0,'2013-07-06 12:44:34',NULL,NULL),(24092,'26505','S','Everettville','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.636473,-79.951111,0,'2013-07-06 12:44:31',NULL,NULL),(19966,'20590','U','Dept Transportation','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878849,-77.023618,0,'2013-07-06 12:44:31',NULL,NULL),(10912,'11428','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(54730,'62966','S','Etherton','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(33027,'36726','S','Camden','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.996605,-87.296969,0,'2013-07-06 12:44:32',NULL,NULL),(76801,'95945','S','Willaura Estates','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(8142,'07840','S','Allamuchy Twp','N','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.855816,-74.844411,0,'2013-07-06 12:44:30',NULL,NULL),(53248,'61701','S','Bloomington Normal Airport','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(12819,'13302','S','South Albion','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(74305,'92382','P','Arrowbear Lake','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.206744,-117.104968,0,'2013-07-06 12:44:34',NULL,NULL),(15028,'15687','S','Stahlstown','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.135220,-79.297697,0,'2013-07-06 12:44:31',NULL,NULL),(38935,'44122','S','Warrensvl Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(28594,'31642','S','Pearson','D','Atkinson','13003','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.300424,-82.854854,0,'2013-07-06 12:44:32',NULL,NULL),(52221,'60487','S','Tinley Park','D','Cook','17031','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.567359,-87.791980,0,'2013-07-06 12:44:33',NULL,NULL),(4778,'03862','S','No Hampton','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.976443,-70.820892,0,'2013-07-06 12:44:30',NULL,NULL),(60321,'71457','S','Nsu','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(71449,'87042','S','Peralta','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.832700,-106.662840,0,'2013-07-06 12:44:34',NULL,NULL),(27400,'30088','S','Stone Mountain','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.762657,-84.176061,0,'2013-07-06 12:44:31',NULL,NULL),(41196,'46723','S','Eel River','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.222797,-85.273777,0,'2013-07-06 12:44:32',NULL,NULL),(46133,'52649','S','Salem','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.855483,-91.622611,0,'2013-07-06 12:44:32',NULL,NULL),(6195,'05483','S','Fairground','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(14222,'14803','S','Alfred Sta','A','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.256785,-77.788411,0,'2013-07-06 12:44:31',NULL,NULL),(77753,'97106','S','Banks','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.620175,-123.112354,0,'2013-07-06 12:44:34',NULL,NULL),(63308,'75565','P','McLeod','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.951167,-94.079416,0,'2013-07-06 12:44:33',NULL,NULL),(62154,'73727','S','Carrier','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.526404,-98.013999,0,'2013-07-06 12:44:33',NULL,NULL),(42346,'47639','S','Haubstadt','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.184600,-87.625920,0,'2013-07-06 12:44:32',NULL,NULL),(15491,'16444','U','Edinboro University','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.875950,-80.130328,0,'2013-07-06 12:44:31',NULL,NULL),(47580,'54849','S','Lake Nebagamon','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.491177,-91.743284,0,'2013-07-06 12:44:33',NULL,NULL),(64354,'76520','S','Cross Roads','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(9669,'10040','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(18513,'19103','S','Middle City West','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.964218,-75.200972,0,'2013-07-06 12:44:31',NULL,NULL),(48557,'55763','S','Markham','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.336731,-92.257473,0,'2013-07-06 12:44:33',NULL,NULL),(74507,'92637','S','Laguna Hills','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.615016,-117.711378,0,'2013-07-06 12:44:34',NULL,NULL),(72193,'88410','S','Rosebud','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.891766,-103.212948,0,'2013-07-06 12:44:34',NULL,NULL),(65334,'77519','S','Batson','D','Hardin','48199','Texas','TX','48','0840','936','Central',-6.0,'Y',30.232867,-94.603365,0,'2013-07-06 12:44:34',NULL,NULL),(41626,'47129','S','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.316146,-85.769135,0,'2013-07-06 12:44:32',NULL,NULL),(32782,'36420','S','Dixie','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(42005,'47427','S','Denmark','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.249277,-86.989828,0,'2013-07-06 12:44:32',NULL,NULL),(40552,'45854','P','Lafayette','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.758842,-83.945650,0,'2013-07-06 12:44:32',NULL,NULL),(7054,'06320','S','Ft Trumbull','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.351139,-72.108165,0,'2013-07-06 12:44:30',NULL,NULL),(22942,'24637','S','Pounding Mill','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.057980,-81.738120,0,'2013-07-06 12:44:31',NULL,NULL),(51378,'59410','P','Augusta','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.392784,-112.635264,0,'2013-07-06 12:44:33',NULL,NULL),(54153,'62568','S','Willeys','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(66286,'78582','S','Rio Grande Cy','A','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(65404,'77565','S','Clear Lake Shores','A','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.540679,-95.030712,0,'2013-07-06 12:44:34',NULL,NULL),(24173,'26621','S','Corley','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.728200,-80.630580,0,'2013-07-06 12:44:31',NULL,NULL),(27469,'30143','S','Jasper','D','Pickens','13227','Georgia','GA','13','0520','706/762','Eastern',-5.0,'Y',34.458900,-84.504060,0,'2013-07-06 12:44:31',NULL,NULL),(11911,'12410','S','Big Indian','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.092940,-74.461860,0,'2013-07-06 12:44:30',NULL,NULL),(41023,'46381','S','Thayer','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.171767,-87.335809,0,'2013-07-06 12:44:32',NULL,NULL),(12837,'13314','S','Brookfield','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.807903,-75.342084,0,'2013-07-06 12:44:30',NULL,NULL),(42935,'48116','S','Green Oak Twp','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.532103,-83.773187,0,'2013-07-06 12:44:32',NULL,NULL),(10530,'10986','S','Tomkins Cove','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.259488,-73.990449,0,'2013-07-06 12:44:30',NULL,NULL),(44368,'49786','U','Hiawatha Temp Correction Fac','N','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.266667,-84.483333,0,'2013-07-06 12:44:32',NULL,NULL),(53330,'61750','P','Lane','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.080356,-88.846052,0,'2013-07-06 12:44:33',NULL,NULL),(15234,'16035','P','Forestville','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.105975,-80.006860,0,'2013-07-06 12:44:31',NULL,NULL),(64165,'76226','S','Argyle','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.104830,-97.164815,0,'2013-07-06 12:44:34',NULL,NULL),(24370,'27053','S','W Field','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.434671,-80.321082,0,'2013-07-06 12:44:31',NULL,NULL),(25867,'28631','S','Helton','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.547139,-81.434483,0,'2013-07-06 12:44:31',NULL,NULL),(30209,'33182','S','West Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.778250,-80.414948,0,'2013-07-06 12:44:32',NULL,NULL),(36493,'40810','S','Pine Mountain','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.872980,-83.432960,0,'2013-07-06 12:44:32',NULL,NULL),(72996,'90059','S','Greenmead','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.926115,-118.242201,0,'2013-07-06 12:44:34',NULL,NULL),(9775,'10105','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(18229,'18969','S','Telford','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.322048,-75.363209,0,'2013-07-06 12:44:31',NULL,NULL),(2245,'00926','S','Urb La Utt','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(13096,'13473','S','Turin','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.655600,-75.428792,0,'2013-07-06 12:44:30',NULL,NULL),(32824,'36461','P','Fountain','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.520180,-87.320717,0,'2013-07-06 12:44:32',NULL,NULL),(76250,'95403','S','Larkfield','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.479575,-122.750548,0,'2013-07-06 12:44:34',NULL,NULL),(71017,'85728','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.309471,-110.916610,0,'2013-07-06 12:44:34',NULL,NULL),(63036,'75206','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.830488,-96.772733,0,'2013-07-06 12:44:33',NULL,NULL),(19415,'20082','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896423,-77.008777,0,'2013-07-06 12:44:31',NULL,NULL),(13931,'14427','S','Castile','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.642063,-78.046828,0,'2013-07-06 12:44:31',NULL,NULL),(27443,'30119','U','Carrollton','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.589126,-85.132330,0,'2013-07-06 12:44:31',NULL,NULL),(4050,'02638','S','Dennis','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.733006,-70.199015,0,'2013-07-06 12:44:30',NULL,NULL),(71340,'86511','P','Saint Michaels','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.853888,-109.299177,0,'2013-07-06 12:44:34',NULL,NULL),(67254,'79953','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761675,-106.478965,0,'2013-07-06 12:44:34',NULL,NULL),(29124,'32315','P','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.461690,-84.287643,0,'2013-07-06 12:44:32',NULL,NULL),(35495,'39529','U','Bay St Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(15144,'15856','S','Rockton','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.090624,-78.634352,0,'2013-07-06 12:44:31',NULL,NULL),(4497,'03284','S','Springfield','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.486437,-72.056353,0,'2013-07-06 12:44:30',NULL,NULL),(76870,'95971','S','Spring Garden','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(62122,'73658','S','Eagle City','A','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.933395,-98.705777,0,'2013-07-06 12:44:33',NULL,NULL),(7875,'07508','S','Prospect Pk','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.951433,-74.185795,0,'2013-07-06 12:44:30',NULL,NULL),(53312,'61739','S','Champlin','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.747916,-88.513741,0,'2013-07-06 12:44:33',NULL,NULL),(73923,'92026','S','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.174100,-117.101925,0,'2013-07-06 12:44:34',NULL,NULL),(64348,'76518','S','Yarrelton','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.894745,-97.123059,0,'2013-07-06 12:44:34',NULL,NULL),(63633,'75839','S','Slocum','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.620240,-95.519820,0,'2013-07-06 12:44:34',NULL,NULL),(64424,'76556','S','Milano','D','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.735780,-96.807000,0,'2013-07-06 12:44:34',NULL,NULL),(13885,'14264','U','Nat Fuel Gas Co','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.887206,-78.823444,0,'2013-07-06 12:44:31',NULL,NULL),(8255,'08008','S','Harvey Cedars','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(2153,'00924','S','Vista del Atlantico','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(11895,'12401','S','Eddyville','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.932171,-74.019531,0,'2013-07-06 12:44:30',NULL,NULL),(52575,'60964','S','Sun River Terrace','A','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.023177,-87.716807,0,'2013-07-06 12:44:33',NULL,NULL),(35099,'39207','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.306196,-90.198595,0,'2013-07-06 12:44:32',NULL,NULL),(2877,'00987','S','Brisas De Metropolis','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(35818,'39762','P','Mississippi State','D','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(4456,'03254','S','Moultonborough','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.671415,-71.378539,0,'2013-07-06 12:44:30',NULL,NULL),(32326,'35766','S','Princeton','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.839156,-86.228857,0,'2013-07-06 12:44:32',NULL,NULL),(31749,'34988','P','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.341002,-80.519774,0,'2013-07-06 12:44:32',NULL,NULL),(30433,'33330','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(26116,'28727','P','Edneyville','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.396345,-82.343722,0,'2013-07-06 12:44:31',NULL,NULL),(24082,'26456','S','Blandville','A','Doddridge','54017','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.293955,-80.773989,0,'2013-07-06 12:44:31',NULL,NULL),(4066,'02648','S','Marstons Mls','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.671089,-70.408963,0,'2013-07-06 12:44:30',NULL,NULL),(8948,'08758','S','Waretown','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.793952,-74.192189,0,'2013-07-06 12:44:30',NULL,NULL),(14805,'15401','S','Uniontown','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.864960,-79.759380,0,'2013-07-06 12:44:31',NULL,NULL),(6499,'05777','S','West Rutland','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.547778,-73.022778,0,'2013-07-06 12:44:30',NULL,NULL),(43149,'48240','S','Redford Twp','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.423668,-83.299778,0,'2013-07-06 12:44:32',NULL,NULL),(44808,'50237','S','Runnells','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.545966,-93.400201,0,'2013-07-06 12:44:32',NULL,NULL),(45568,'51525','S','Carson','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.238041,-95.417441,0,'2013-07-06 12:44:32',NULL,NULL),(55461,'63738','P','Brownwood','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.080255,-89.955275,0,'2013-07-06 12:44:33',NULL,NULL),(68854,'82615','S','Casper','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031000,-106.545746,0,'2013-07-06 12:44:34',NULL,NULL),(68957,'83001','S','Hoback Jct','A','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472028,-110.766160,0,'2013-07-06 12:44:34',NULL,NULL),(69223,'83401','S','Osgood','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(70231,'84404','S','Plain City','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(78139,'97537','S','Rogue River','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.501647,-123.150155,0,'2013-07-06 12:44:34',NULL,NULL),(21876,'23163','S','Susan','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.349167,-76.296944,0,'2013-07-06 12:44:31',NULL,NULL),(43305,'48347','P','Clarkston','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.735616,-83.419991,0,'2013-07-06 12:44:32',NULL,NULL),(26443,'29133','S','Rowesville','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.368863,-80.834172,0,'2013-07-06 12:44:31',NULL,NULL),(44501,'49925','S','Ewen','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.539412,-89.381658,0,'2013-07-06 12:44:32',NULL,NULL),(46766,'53944','S','Lyndon Sta','A','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.706413,-89.892011,0,'2013-07-06 12:44:32',NULL,NULL),(14283,'14861','S','Lowman','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.136889,-76.727834,0,'2013-07-06 12:44:31',NULL,NULL),(3696,'02136','S','Readville','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.252810,-71.129122,0,'2013-07-06 12:44:30',NULL,NULL),(54999,'63130','S','Univ City','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.664368,-90.323797,0,'2013-07-06 12:44:33',NULL,NULL),(8022,'07727','S','Farmingdale','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.199657,-74.163542,0,'2013-07-06 12:44:30',NULL,NULL),(21243,'22243','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.861034,-77.052567,0,'2013-07-06 12:44:31',NULL,NULL),(35081,'39202','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.310057,-90.176007,0,'2013-07-06 12:44:32',NULL,NULL),(37720,'42275','S','Region','N','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.199181,-86.454521,0,'2013-07-06 12:44:32',NULL,NULL),(33188,'37033','S','Pleasantville','A','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(16133,'17058','S','McCoysville','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.565928,-77.406815,0,'2013-07-06 12:44:31',NULL,NULL),(72222,'88431','S','Newkirk','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.120222,-104.233344,0,'2013-07-06 12:44:34',NULL,NULL),(6503,'05819','S','Saint Johnsbury','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.434670,-72.038170,0,'2013-07-06 12:44:30',NULL,NULL),(46181,'52738','S','Columbus Junction','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(21471,'22630','S','Lk Frederick','A','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.946389,-78.199722,0,'2013-07-06 12:44:31',NULL,NULL),(66457,'78654','S','Granite Shls','A','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(71551,'87191','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.134415,-106.520743,0,'2013-07-06 12:44:34',NULL,NULL),(55847,'64164','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.324928,-94.621880,0,'2013-07-06 12:44:33',NULL,NULL),(272,'00646','S','Bosque Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(75720,'94585','S','Suisun City','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.246160,-122.022060,0,'2013-07-06 12:44:34',NULL,NULL),(39957,'45236','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(47658,'54935','S','North Fond du Lac','A','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.775242,-88.431561,0,'2013-07-06 12:44:33',NULL,NULL),(1137,'00725','S','Villas del Rio Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(58427,'68661','S','Schuyler','D','Colfax','31037','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.447978,-97.057723,0,'2013-07-06 12:44:33',NULL,NULL),(14950,'15611','S','Adamsburg','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.314024,-79.649385,0,'2013-07-06 12:44:31',NULL,NULL),(48139,'55364','S','Minnetrista','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.935114,-93.662910,0,'2013-07-06 12:44:33',NULL,NULL),(69989,'84121','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(16641,'17339','S','Silver Lake','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.126080,-76.876560,0,'2013-07-06 12:44:31',NULL,NULL),(15402,'16341','S','Pleasantville','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.589223,-79.572581,0,'2013-07-06 12:44:31',NULL,NULL),(60345,'71467','S','Pollock','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498140,-92.421420,0,'2013-07-06 12:44:33',NULL,NULL),(79992,'99660','P','St Paul Island','N','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',57.184029,-170.273301,0,'2013-07-06 12:44:34',NULL,NULL),(24560,'27298','S','Liberty','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.896446,-79.506774,0,'2013-07-06 12:44:31',NULL,NULL),(5369,'04628','S','Dennysville','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.854149,-67.275517,0,'2013-07-06 12:44:30',NULL,NULL),(15656,'16748','S','Shinglehouse','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.947620,-78.166200,0,'2013-07-06 12:44:31',NULL,NULL),(71296,'86445','S','Willow Beach','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.731831,-114.378837,0,'2013-07-06 12:44:34',NULL,NULL),(41603,'47114','S','Crandall','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.289320,-86.073487,0,'2013-07-06 12:44:32',NULL,NULL),(29703,'32937','S','Satellite Beach','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(65801,'78132','S','Canyon Lake','A','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.777220,-98.152980,0,'2013-07-06 12:44:34',NULL,NULL),(50981,'58641','S','Lefor','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.715881,-102.768022,0,'2013-07-06 12:44:33',NULL,NULL),(36744,'41039','S','Ewing','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.433060,-83.851740,0,'2013-07-06 12:44:32',NULL,NULL),(62526,'74425','S','Canadian','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.156646,-95.618903,0,'2013-07-06 12:44:33',NULL,NULL),(5835,'05085','P','West Newbury','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.069472,-72.121627,0,'2013-07-06 12:44:30',NULL,NULL),(45943,'52342','S','Toledo','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.990728,-92.575735,0,'2013-07-06 12:44:32',NULL,NULL),(7838,'07461','S','Sussex','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(54128,'62557','S','Millersville','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.386310,-89.080983,0,'2013-07-06 12:44:33',NULL,NULL),(56651,'65616','S','Gretna','N','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(19385,'20065','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882711,-77.027194,0,'2013-07-06 12:44:31',NULL,NULL),(5291,'04539','S','Bristol','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.954915,-69.499200,0,'2013-07-06 12:44:30',NULL,NULL),(15931,'17021','S','Ewaterfrd','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(48790,'56002','P','North Mankato','N','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.161464,-94.005528,0,'2013-07-06 12:44:33',NULL,NULL),(34813,'38901','S','Futheyville','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(29516,'32775','P','Scottsmoor','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.769130,-80.873824,0,'2013-07-06 12:44:32',NULL,NULL),(27907,'30499','U','Georgia State Penitentiary','N','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.083302,-82.119056,0,'2013-07-06 12:44:31',NULL,NULL),(17494,'17960','S','Snyders','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(73563,'91365','P','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.172838,-118.605715,0,'2013-07-06 12:44:34',NULL,NULL),(66736,'78959','S','Thompsonville','N','Gonzales','48177','Texas','TX','48','0000','512/737','Central',-6.0,'Y',29.695667,-97.293035,0,'2013-07-06 12:44:34',NULL,NULL),(64533,'76644','P','Clifton','A','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.858882,-97.376822,0,'2013-07-06 12:44:34',NULL,NULL),(7769,'07416','S','Beaver Lake','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.117073,-74.599284,0,'2013-07-06 12:44:30',NULL,NULL),(50882,'58530','S','Price','N','Oliver','38065','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.086010,-100.941390,0,'2013-07-06 12:44:33',NULL,NULL),(52690,'61101','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.299194,-89.130429,0,'2013-07-06 12:44:33',NULL,NULL),(38898,'44115','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.496936,-81.674200,0,'2013-07-06 12:44:32',NULL,NULL),(119,'00612','S','Urb Victor Rojas 2','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(38265,'43311','S','Bellefontne','N','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.359628,-83.757376,0,'2013-07-06 12:44:32',NULL,NULL),(30694,'33480','S','South Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.717031,-80.047448,0,'2013-07-06 12:44:32',NULL,NULL),(74198,'92283','S','Winterhaven','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.776447,-114.598015,0,'2013-07-06 12:44:34',NULL,NULL),(27462,'30137','S','Emerson','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.115139,-84.758982,0,'2013-07-06 12:44:31',NULL,NULL),(30769,'33574','P','Saint Leo','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.331832,-82.274046,0,'2013-07-06 12:44:32',NULL,NULL),(49490,'56661','S','Kinghurst','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(56580,'65541','S','Lenox','D','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.645800,-91.735893,0,'2013-07-06 12:44:33',NULL,NULL),(4965,'04107','S','Pond Cove','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.610918,-70.232964,0,'2013-07-06 12:44:30',NULL,NULL),(78216,'97759','S','Blk Btte Rnch','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.323931,-121.575944,0,'2013-07-06 12:44:34',NULL,NULL),(74403,'92530','S','Lk Elsinore','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.603897,-117.377208,0,'2013-07-06 12:44:34',NULL,NULL),(19130,'19609','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(33509,'37366','S','Pelham','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.320199,-85.789482,0,'2013-07-06 12:44:32',NULL,NULL),(11393,'11947','P','Jamesport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.946167,-72.583098,0,'2013-07-06 12:44:30',NULL,NULL),(48367,'55556','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.812926,-93.918352,0,'2013-07-06 12:44:33',NULL,NULL),(66259,'78574','S','Palmhurst','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.219063,-98.325099,0,'2013-07-06 12:44:34',NULL,NULL),(61788,'73078','S','Piedmont','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.660181,-97.757489,0,'2013-07-06 12:44:33',NULL,NULL),(36825,'41065','P','Muses Mills','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.352545,-83.524381,0,'2013-07-06 12:44:32',NULL,NULL),(75557,'94252','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586196,-121.495323,0,'2013-07-06 12:44:34',NULL,NULL),(21375,'22471','P','Hartwood','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.402421,-77.580674,0,'2013-07-06 12:44:31',NULL,NULL),(44980,'50424','S','Buffalo Center','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.388034,-93.950119,0,'2013-07-06 12:44:32',NULL,NULL),(26651,'29360','S','Laurens','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.499471,-82.025271,0,'2013-07-06 12:44:31',NULL,NULL),(57501,'66949','S','Ionia','A','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.672180,-98.108820,0,'2013-07-06 12:44:33',NULL,NULL),(78511,'98116','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.575300,-122.395975,0,'2013-07-06 12:44:34',NULL,NULL),(70017,'84128','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(9308,'09719','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38563,'43768','P','Old Washingtn','A','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.032494,-81.411187,0,'2013-07-06 12:44:32',NULL,NULL),(32871,'36523','S','Alabama Port','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.387102,-88.167787,0,'2013-07-06 12:44:32',NULL,NULL),(42076,'47454','S','Chambersburg','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(44389,'49805','S','Allouez','D','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.284989,-88.408322,0,'2013-07-06 12:44:32',NULL,NULL),(35509,'39532','S','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.461218,-88.949246,0,'2013-07-06 12:44:32',NULL,NULL),(33571,'37419','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.034095,-85.367139,0,'2013-07-06 12:44:32',NULL,NULL),(21508,'22713','S','Boston','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.537783,-78.142325,0,'2013-07-06 12:44:31',NULL,NULL),(31440,'34275','S','Nokomis','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.136587,-82.450143,0,'2013-07-06 12:44:32',NULL,NULL),(11729,'12180','S','Speigletown','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(13925,'14422','S','Byron','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.076150,-78.071607,0,'2013-07-06 12:44:31',NULL,NULL),(54941,'63114','S','Charlack','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(25417,'28301','S','East Fayetteville','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(207,'00623','S','Villa del Carmen','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(42555,'47872','S','Milligan','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(73842,'91789','S','Walnut','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.014965,-117.856127,0,'2013-07-06 12:44:34',NULL,NULL),(22600,'24202','S','Bristol','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.649682,-82.201966,0,'2013-07-06 12:44:31',NULL,NULL),(42084,'47456','S','Quincy','D','Owen','18119','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.435138,-86.786652,0,'2013-07-06 12:44:32',NULL,NULL),(4672,'03780','S','Pike','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.999870,-72.000233,0,'2013-07-06 12:44:30',NULL,NULL),(17104,'17771','S','Buttonwood','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(28842,'32086','S','St Aug Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.759403,-81.303970,0,'2013-07-06 12:44:32',NULL,NULL),(41975,'47421','S','East Oolitic','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(55964,'64501','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.765162,-94.844255,0,'2013-07-06 12:44:33',NULL,NULL),(160,'00617','S','Villa Georgetti','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(2260,'00926','S','Urb Monteverde','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(70031,'84131','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700156,-111.944519,0,'2013-07-06 12:44:34',NULL,NULL),(51876,'60085','S','Waukegan','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.360907,-87.862378,0,'2013-07-06 12:44:33',NULL,NULL),(4611,'03592','S','Clarksville','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',45.113334,-71.254468,0,'2013-07-06 12:44:30',NULL,NULL),(1652,'00772','S','Sect Villa Canona','N','Loiza','72087','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.433938,-65.880795,0,'2013-07-06 12:44:30',NULL,NULL),(43633,'48826','P','East Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.744186,-84.484100,0,'2013-07-06 12:44:32',NULL,NULL),(57560,'67045','S','Eureka','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.843200,-96.311880,0,'2013-07-06 12:44:33',NULL,NULL),(61616,'72821','S','Wiederkehr Village','A','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.439891,-93.763349,0,'2013-07-06 12:44:33',NULL,NULL),(34746,'38852','S','Gravel Siding','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(58720,'68939','S','Franklin','D','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.097909,-98.951170,0,'2013-07-06 12:44:33',NULL,NULL),(55301,'63531','S','Greensburg','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.263106,-92.262440,0,'2013-07-06 12:44:33',NULL,NULL),(70833,'85530','P','Bylas','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.105420,-110.225621,0,'2013-07-06 12:44:34',NULL,NULL),(69398,'83616','S','Pearl','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.711993,-116.374414,0,'2013-07-06 12:44:34',NULL,NULL),(6001,'05356','S','W Dover','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.933333,-72.833333,0,'2013-07-06 12:44:30',NULL,NULL),(43535,'48663','U','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.419367,-83.947813,0,'2013-07-06 12:44:32',NULL,NULL),(44315,'49740','S','Harbor Spgs','A','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.531470,-85.004593,0,'2013-07-06 12:44:32',NULL,NULL),(58593,'68844','S','Hazard','D','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.025534,-98.916251,0,'2013-07-06 12:44:33',NULL,NULL),(4646,'03748','S','Enfield','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.632905,-72.135383,0,'2013-07-06 12:44:30',NULL,NULL),(61775,'73065','S','Newcastle','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.249529,-97.626363,0,'2013-07-06 12:44:33',NULL,NULL),(35884,'39885','P','Sasser','D','Terrell','13273','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.713415,-84.349784,0,'2013-07-06 12:44:32',NULL,NULL),(65675,'77986','P','Sublime','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.397544,-96.823783,0,'2013-07-06 12:44:34',NULL,NULL),(63520,'75754','S','Flatwood','N','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.414520,-95.649120,0,'2013-07-06 12:44:33',NULL,NULL),(45543,'51454','S','Manilla','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.903541,-95.249649,0,'2013-07-06 12:44:32',NULL,NULL),(45367,'51008','P','Brunsville','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.809493,-96.268603,0,'2013-07-06 12:44:32',NULL,NULL),(61503,'72648','S','Marble Falls','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.084759,-93.146930,0,'2013-07-06 12:44:33',NULL,NULL),(55906,'64440','S','De Kalb','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.575413,-94.939986,0,'2013-07-06 12:44:33',NULL,NULL),(52813,'61281','S','Sherrard','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.312272,-90.493734,0,'2013-07-06 12:44:33',NULL,NULL),(77652,'97016','S','Westport','A','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.996389,-123.255278,0,'2013-07-06 12:44:34',NULL,NULL),(54076,'62515','S','Buffalo','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.847849,-89.406204,0,'2013-07-06 12:44:33',NULL,NULL),(8630,'08260','S','Shaw Crest','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(63121,'75313','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.785602,-96.799853,0,'2013-07-06 12:44:33',NULL,NULL),(37937,'42653','S','Beulah Heights','N','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.720391,-84.465547,0,'2013-07-06 12:44:32',NULL,NULL),(9285,'09642','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(25244,'28106','P','Matthews','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.123453,-80.713602,0,'2013-07-06 12:44:31',NULL,NULL),(1100,'00725','S','Urb Mariolga','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(6396,'05732','S','Neshobe Beach','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.643611,-73.199167,0,'2013-07-06 12:44:30',NULL,NULL),(49467,'56652','S','Sinclair','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.638080,-95.383500,0,'2013-07-06 12:44:33',NULL,NULL),(58,'00610','S','Repto Daguey','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(71474,'87062','S','Veguita','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.488921,-106.725214,0,'2013-07-06 12:44:34',NULL,NULL),(51966,'60143','S','Itasca','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.973492,-88.015802,0,'2013-07-06 12:44:33',NULL,NULL),(8697,'08349','S','Bivalve','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.258120,-75.059520,0,'2013-07-06 12:44:30',NULL,NULL),(1039,'00723','S','Jard de Mamey','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(9716,'10080','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(14187,'14752','P','Lily Dale','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.350044,-79.326995,0,'2013-07-06 12:44:31',NULL,NULL),(25449,'28320','S','Butters','A','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.529407,-78.793874,0,'2013-07-06 12:44:31',NULL,NULL),(27677,'30332','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.777293,-84.396568,0,'2013-07-06 12:44:31',NULL,NULL),(31129,'33903','S','No Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(34188,'38327','S','Crump','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.221868,-88.323878,0,'2013-07-06 12:44:32',NULL,NULL),(49853,'57241','S','Thomas','N','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.677517,-97.250132,0,'2013-07-06 12:44:33',NULL,NULL),(3435,'01748','S','Hopkinton','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.217945,-71.533938,0,'2013-07-06 12:44:30',NULL,NULL),(9887,'10126','U','Franklin D Roosevelt','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760726,-73.970532,0,'2013-07-06 12:44:30',NULL,NULL),(73121,'90263','U','Pepperdine University','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.006202,-118.810015,0,'2013-07-06 12:44:34',NULL,NULL),(78063,'97457','S','Myrtle Creek','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.026142,-123.281038,0,'2013-07-06 12:44:34',NULL,NULL),(78544,'98144','S','Beacon Hill','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.586883,-122.298008,0,'2013-07-06 12:44:34',NULL,NULL),(72753,'89510','S','Sand Pass','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(45588,'51545','S','Little Sioux','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.807064,-96.024597,0,'2013-07-06 12:44:32',NULL,NULL),(51728,'60010','S','Tower Lakes','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(53524,'62028','S','Chautauqua','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.964120,-90.331920,0,'2013-07-06 12:44:33',NULL,NULL),(69765,'84055','S','Oakley','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.711397,-111.292326,0,'2013-07-06 12:44:34',NULL,NULL),(55290,'63501','S','Nind','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(18680,'19184','U','Sunmark Industries','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953202,-75.183899,0,'2013-07-06 12:44:31',NULL,NULL),(15984,'17033','S','S Londonderry','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(33407,'37232','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.142857,-86.807356,0,'2013-07-06 12:44:32',NULL,NULL),(35083,'39203','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.309387,-90.196952,0,'2013-07-06 12:44:32',NULL,NULL),(37776,'42349','S','Horse Branch','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.421761,-86.606244,0,'2013-07-06 12:44:32',NULL,NULL),(30260,'33234','P','C Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.750799,-80.274412,0,'2013-07-06 12:44:32',NULL,NULL),(56020,'64664','S','Mooresville','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.742218,-93.716811,0,'2013-07-06 12:44:33',NULL,NULL),(54577,'62898','S','Grand Prairie','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.387010,-89.091555,0,'2013-07-06 12:44:33',NULL,NULL),(33615,'37657','S','Flag Pond','D','Unicoi','47171','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.024636,-82.552636,0,'2013-07-06 12:44:32',NULL,NULL),(10573,'11020','S','University Gardens','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(44195,'49618','S','Boon','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.301037,-85.592047,0,'2013-07-06 12:44:32',NULL,NULL),(72281,'88561','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.765754,-106.331188,0,'2013-07-06 12:44:34',NULL,NULL),(71256,'86406','S','Lake Havasu City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.474110,-114.284707,0,'2013-07-06 12:44:34',NULL,NULL),(69843,'84083','S','Partoun','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.738100,-114.021398,0,'2013-07-06 12:44:34',NULL,NULL),(57825,'67526','S','Ellinwood','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.357981,-98.581126,0,'2013-07-06 12:44:33',NULL,NULL),(24627,'27357','S','Stokesdale','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.239862,-79.981948,0,'2013-07-06 12:44:31',NULL,NULL),(22862,'24551','S','Forest','D','Bedford','51019','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.354725,-79.283113,0,'2013-07-06 12:44:31',NULL,NULL),(29419,'32658','P','La Crosse','D','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.844295,-82.405529,0,'2013-07-06 12:44:32',NULL,NULL),(31853,'35115','S','Marvel','N','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.135720,-86.848920,0,'2013-07-06 12:44:32',NULL,NULL),(32385,'35907','S','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.014167,-86.006667,0,'2013-07-06 12:44:32',NULL,NULL),(20393,'20895','S','North Bethesda','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.027491,-77.077263,0,'2013-07-06 12:44:31',NULL,NULL),(34296,'38506','S','Cookeville','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.146202,-85.527440,0,'2013-07-06 12:44:32',NULL,NULL),(58888,'69165','S','Sutherland','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.162515,-101.123437,0,'2013-07-06 12:44:33',NULL,NULL),(58697,'68928','S','Bladen','D','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.261950,-98.615407,0,'2013-07-06 12:44:33',NULL,NULL),(5052,'04271','P','Paris','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.220906,-70.478319,0,'2013-07-06 12:44:30',NULL,NULL),(42624,'47906','S','Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.495856,-86.967180,0,'2013-07-06 12:44:32',NULL,NULL),(36928,'41164','S','Ault','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(19170,'19730','P','Odessa','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.457130,-75.657005,0,'2013-07-06 12:44:31',NULL,NULL),(23737,'25919','P','Skelton','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.796073,-81.182158,0,'2013-07-06 12:44:31',NULL,NULL),(51547,'59732','P','Glen','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.480685,-112.692146,0,'2013-07-06 12:44:33',NULL,NULL),(31103,'33883','P','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.023165,-81.726968,0,'2013-07-06 12:44:32',NULL,NULL),(69659,'84015','S','Anchorage','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(67820,'80757','S','Last Chance','A','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.733095,-103.505678,0,'2013-07-06 12:44:34',NULL,NULL),(62712,'74753','P','Platter','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.906949,-96.532507,0,'2013-07-06 12:44:33',NULL,NULL),(61871,'73127','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.484360,-97.631411,0,'2013-07-06 12:44:33',NULL,NULL),(57896,'67644','S','Kirwin','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.653797,-99.125884,0,'2013-07-06 12:44:33',NULL,NULL),(55263,'63461','S','Ely','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.797789,-91.526300,0,'2013-07-06 12:44:33',NULL,NULL),(41197,'46725','S','Big Lake','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(22428,'24012','S','Bonsack','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.306500,-79.940340,0,'2013-07-06 12:44:31',NULL,NULL),(5997,'05355','S','Wardsboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.029480,-72.811620,0,'2013-07-06 12:44:30',NULL,NULL),(16597,'17325','S','Fairplay','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.851653,-77.260693,0,'2013-07-06 12:44:31',NULL,NULL),(60085,'71357','S','Notnac','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(59888,'71270','S','Vernon','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(53980,'62439','S','Lawrenceville','D','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(7317,'06699','U','Controlled Distribution','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.191157,-73.138012,0,'2013-07-06 12:44:30',NULL,NULL),(34348,'38581','S','Rock Island','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.730840,-85.650180,0,'2013-07-06 12:44:32',NULL,NULL),(22948,'24649','S','Dye','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.081098,-81.917929,0,'2013-07-06 12:44:31',NULL,NULL),(1751,'00778','S','Villa Alegre','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(13303,'13669','S','Ogd','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.666280,-75.499440,0,'2013-07-06 12:44:30',NULL,NULL),(25319,'28169','P','Waco','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.361895,-81.432001,0,'2013-07-06 12:44:31',NULL,NULL),(47230,'54501','S','Lake George','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(49924,'57321','S','Epiphany','N','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.893120,-97.542420,0,'2013-07-06 12:44:33',NULL,NULL),(2940,'01028','S','East Longmeadow','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.068418,-72.504285,0,'2013-07-06 12:44:30',NULL,NULL),(68994,'83127','S','Thayne','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.972890,-110.971354,0,'2013-07-06 12:44:34',NULL,NULL),(50159,'57551','S','Patricia','N','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.218780,-101.666700,0,'2013-07-06 12:44:33',NULL,NULL),(20340,'20852','S','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.046797,-77.119654,0,'2013-07-06 12:44:31',NULL,NULL),(13761,'14132','S','Pendleton','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.147891,-78.872724,0,'2013-07-06 12:44:31',NULL,NULL),(31756,'34992','P','Port Salerno','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.142814,-80.209168,0,'2013-07-06 12:44:32',NULL,NULL),(76702,'95831','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.498299,-121.534017,0,'2013-07-06 12:44:34',NULL,NULL),(19424,'20098','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917054,-76.994641,0,'2013-07-06 12:44:31',NULL,NULL),(19602,'20229','U','Us Bureau of Customs','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892772,-77.032993,0,'2013-07-06 12:44:31',NULL,NULL),(50196,'57569','S','Lyman','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.832195,-99.527936,0,'2013-07-06 12:44:33',NULL,NULL),(21196,'22192','S','Lake Ridge','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.680010,-77.309022,0,'2013-07-06 12:44:31',NULL,NULL),(27596,'30295','S','Zebulon','D','Pike','13231','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.098626,-84.300730,0,'2013-07-06 12:44:31',NULL,NULL),(4466,'03259','S','North Sandwich','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.862648,-71.379837,0,'2013-07-06 12:44:30',NULL,NULL),(32818,'36456','S','Mc Kenzie','D','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.545720,-86.743920,0,'2013-07-06 12:44:32',NULL,NULL),(73105,'90245','S','El Segundo','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.923798,-118.405527,0,'2013-07-06 12:44:34',NULL,NULL),(70913,'85629','S','Continental','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.952136,-110.997432,0,'2013-07-06 12:44:34',NULL,NULL),(62829,'74965','S','Westville','D','Adair','40001','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.989517,-94.572260,0,'2013-07-06 12:44:33',NULL,NULL),(12918,'13339','S','Minden','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(33715,'37777','S','McGhee Tyson ANG Base','N','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.831102,-84.048154,0,'2013-07-06 12:44:32',NULL,NULL),(11355,'11802','P','Hicksville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.764323,-73.531618,0,'2013-07-06 12:44:30',NULL,NULL),(48669,'55918','S','Brownsdale','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.731405,-92.872054,0,'2013-07-06 12:44:33',NULL,NULL),(20800,'21550','S','Mt Lake Park','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(68549,'81427','P','Ouray','D','Ouray','08091','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.058846,-107.701590,0,'2013-07-06 12:44:34',NULL,NULL),(18712,'19244','U','Internal Revenue Service','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951444,-75.151511,0,'2013-07-06 12:44:31',NULL,NULL),(4610,'03590','S','Stratford','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.719190,-71.465831,0,'2013-07-06 12:44:30',NULL,NULL),(3847,'02346','S','Middleboro','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.887265,-70.887189,0,'2013-07-06 12:44:30',NULL,NULL),(42949,'48124','S','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.294678,-83.250573,0,'2013-07-06 12:44:32',NULL,NULL),(12096,'12570','S','Poughquag','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.644619,-73.674092,0,'2013-07-06 12:44:30',NULL,NULL),(10554,'11001','S','So Floral Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(18270,'19008','S','Lawrence Park','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.975572,-75.360537,0,'2013-07-06 12:44:31',NULL,NULL),(7285,'06533','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.317731,-72.929215,0,'2013-07-06 12:44:30',NULL,NULL),(15414,'16353','S','Starr','N','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.493407,-79.458434,0,'2013-07-06 12:44:31',NULL,NULL),(55103,'63304','S','Weldon Spring','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(58009,'67869','S','Plains','D','Meade','20119','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.260083,-100.592316,0,'2013-07-06 12:44:33',NULL,NULL),(59252,'70443','S','Independence','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.628982,-90.498195,0,'2013-07-06 12:44:33',NULL,NULL),(61738,'73030','S','Davis','D','Murray','40099','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.506038,-97.113104,0,'2013-07-06 12:44:33',NULL,NULL),(2442,'00953','S','Urb Palacios Del Monte','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(7379,'06777','S','New Preston-Marble Dale','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(59904,'71277','S','Mount Union','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.897756,-92.609210,0,'2013-07-06 12:44:33',NULL,NULL),(44172,'49548','S','Cutlerville','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866570,-85.660484,0,'2013-07-06 12:44:32',NULL,NULL),(65765,'78076','S','Zapata','D','Zapata','48505','Texas','TX','48','0000','956','Central',-6.0,'Y',26.896429,-99.262993,0,'2013-07-06 12:44:34',NULL,NULL),(30730,'33530','P','Durant','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.896971,-82.163527,0,'2013-07-06 12:44:32',NULL,NULL),(28611,'31705','S','Bridgeboro','A','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.558731,-84.090313,0,'2013-07-06 12:44:32',NULL,NULL),(45200,'50623','P','Dewar','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.527591,-92.212957,0,'2013-07-06 12:44:32',NULL,NULL),(48941,'56164','S','Pipestone','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.994823,-96.317095,0,'2013-07-06 12:44:33',NULL,NULL),(38102,'43085','S','Worthington','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098773,-83.017045,0,'2013-07-06 12:44:32',NULL,NULL),(72566,'89314','S','Duckwater','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.946009,-115.707247,0,'2013-07-06 12:44:34',NULL,NULL),(78707,'98264','S','Lynden','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.940810,-122.459641,0,'2013-07-06 12:44:34',NULL,NULL),(48592,'55780','S','Sawyer','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.685243,-92.685120,0,'2013-07-06 12:44:33',NULL,NULL),(38501,'43701','S','South Zanesville','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.954240,-81.984960,0,'2013-07-06 12:44:32',NULL,NULL),(51477,'59540','S','Rudyard','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.653209,-110.555719,0,'2013-07-06 12:44:33',NULL,NULL),(1617,'00769','S','Villa Tropical','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(1153,'00727','S','Parq del Monte','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(55940,'64479','S','Ravenwood','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.351795,-94.672436,0,'2013-07-06 12:44:33',NULL,NULL),(22603,'24205','U','Bristol Merchandise Return','N','Bristol City','51520','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.613682,-82.170691,0,'2013-07-06 12:44:31',NULL,NULL),(25476,'28348','S','Hope Mills','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',34.967775,-78.945409,0,'2013-07-06 12:44:31',NULL,NULL),(52669,'61072','S','Rockton','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.438120,-89.144820,0,'2013-07-06 12:44:33',NULL,NULL),(37241,'41553','S','Jamboree','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492791,-82.167535,0,'2013-07-06 12:44:32',NULL,NULL),(6677,'06035','S','Granby','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.953412,-72.796813,0,'2013-07-06 12:44:30',NULL,NULL),(58779,'68973','S','Roseland','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.437498,-98.550739,0,'2013-07-06 12:44:33',NULL,NULL),(74408,'92536','S','Aguanga','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.424735,-116.802848,0,'2013-07-06 12:44:34',NULL,NULL),(50073,'57450','S','Hoven','D','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.239765,-99.778414,0,'2013-07-06 12:44:33',NULL,NULL),(69677,'84022','S','Terra','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.288140,-112.817460,0,'2013-07-06 12:44:34',NULL,NULL),(66137,'78466','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.744040,-97.381702,0,'2013-07-06 12:44:34',NULL,NULL),(24150,'26578','P','Kingmont','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.448876,-80.178997,0,'2013-07-06 12:44:31',NULL,NULL),(20537,'21104','S','Marriottsvl','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.343680,-76.907220,0,'2013-07-06 12:44:31',NULL,NULL),(17794,'18356','P','Shawnee on Delaware','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.009711,-75.111422,0,'2013-07-06 12:44:31',NULL,NULL),(45993,'52501','S','Dudley','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(47250,'54520','S','Mole Lake','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.568279,-88.904809,0,'2013-07-06 12:44:32',NULL,NULL),(54499,'62864','S','Summersville','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(26759,'29430','P','Moncks Corner','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.201366,-79.789924,0,'2013-07-06 12:44:31',NULL,NULL),(19081,'19564','P','Virginville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.522052,-75.870747,0,'2013-07-06 12:44:31',NULL,NULL),(57381,'66749','S','Iola','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.926480,-95.402820,0,'2013-07-06 12:44:33',NULL,NULL),(77961,'97367','S','Lincoln City','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.962200,-123.952740,0,'2013-07-06 12:44:34',NULL,NULL),(21985,'23260','P','Main Office','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.549463,-77.459359,0,'2013-07-06 12:44:31',NULL,NULL),(77552,'96860','S','Jb Pearl Harbor Hickam','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353536,-157.966185,0,'2013-07-06 12:44:34',NULL,NULL),(74880,'93276','P','Tupman','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.290082,-119.335739,0,'2013-07-06 12:44:34',NULL,NULL),(32730,'36316','S','Battens Crossroads','N','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.178128,-85.919169,0,'2013-07-06 12:44:32',NULL,NULL),(52180,'60462','S','Orland Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.623590,-87.845563,0,'2013-07-06 12:44:33',NULL,NULL),(30193,'33179','S','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.954530,-80.183568,0,'2013-07-06 12:44:32',NULL,NULL),(48923,'56147','S','Kenneth','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.760221,-96.115402,0,'2013-07-06 12:44:33',NULL,NULL),(42110,'47465','S','Switz City','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.038049,-87.047701,0,'2013-07-06 12:44:32',NULL,NULL),(67162,'79831','P','Alpine','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',30.363181,-103.666231,0,'2013-07-06 12:44:34',NULL,NULL),(72180,'88350','P','Cloudcroft','A','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.835667,-105.691772,0,'2013-07-06 12:44:34',NULL,NULL),(24652,'27403','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.065760,-79.822871,0,'2013-07-06 12:44:31',NULL,NULL),(45506,'51360','S','Triboji Beach','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(45693,'52049','S','Garnavillo','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.872700,-91.229160,0,'2013-07-06 12:44:32',NULL,NULL),(19276,'19963','S','Slaughter Beach','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.903495,-75.432364,0,'2013-07-06 12:44:31',NULL,NULL),(10931,'11433','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.697305,-73.789271,0,'2013-07-06 12:44:30',NULL,NULL),(44990,'50435','S','Floyd','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.127067,-92.736859,0,'2013-07-06 12:44:32',NULL,NULL),(33122,'36870','S','Phenix City','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.467449,-85.011553,0,'2013-07-06 12:44:32',NULL,NULL),(72337,'89013','S','Lida','N','Esmeralda','32009','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.766010,-117.423544,0,'2013-07-06 12:44:34',NULL,NULL),(68860,'82633','S','Douglas','D','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.652560,-105.189910,0,'2013-07-06 12:44:34',NULL,NULL),(1635,'00771','S','Urb La Inmaculada','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(40784,'46164','S','Nineveh','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.341154,-86.103529,0,'2013-07-06 12:44:32',NULL,NULL),(35736,'39704','P','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.517443,-88.479933,0,'2013-07-06 12:44:32',NULL,NULL),(48772,'55987','S','Lamoille','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(59077,'70116','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.967019,-90.068695,0,'2013-07-06 12:44:33',NULL,NULL),(1266,'00730','S','Bda Clausells','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(69714,'84036','S','Kamas','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(457,'00662','S','Villa Karen','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(24319,'27020','S','Eagle','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(44859,'50276','S','Woodward','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.851937,-93.924289,0,'2013-07-06 12:44:32',NULL,NULL),(16451,'17238','S','Belfast','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.873300,-78.140520,0,'2013-07-06 12:44:31',NULL,NULL),(31076,'33855','P','Lake Wales','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.873608,-81.477219,0,'2013-07-06 12:44:32',NULL,NULL),(62523,'74421','S','Winchester','A','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.743595,-96.068230,0,'2013-07-06 12:44:33',NULL,NULL),(48477,'55723','S','Bearville North','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.867400,-92.779260,0,'2013-07-06 12:44:33',NULL,NULL),(10187,'10286','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705704,-74.007966,0,'2013-07-06 12:44:30',NULL,NULL),(8084,'07757','S','Port-au-Peck','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315089,-74.017467,0,'2013-07-06 12:44:30',NULL,NULL),(44092,'49461','S','Sylvan Beach','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.384995,-86.340748,0,'2013-07-06 12:44:32',NULL,NULL),(42849,'48076','S','Lathrup Village','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.497322,-83.233132,0,'2013-07-06 12:44:32',NULL,NULL),(66347,'78610','S','Buda','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.082691,-97.843934,0,'2013-07-06 12:44:34',NULL,NULL),(70816,'85379','S','Sun City','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.619029,-112.409147,0,'2013-07-06 12:44:34',NULL,NULL),(21244,'22243','U','Naval Air System Command','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.861034,-77.052567,0,'2013-07-06 12:44:31',NULL,NULL),(58314,'68440','S','Steele City','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.047836,-96.973471,0,'2013-07-06 12:44:33',NULL,NULL),(8128,'07829','P','Buttzville','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.830698,-75.008925,0,'2013-07-06 12:44:30',NULL,NULL),(37417,'41810','P','Cromona','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.181445,-82.686695,0,'2013-07-06 12:44:32',NULL,NULL),(51057,'58744','S','Karlsruhe','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.138431,-100.487239,0,'2013-07-06 12:44:33',NULL,NULL),(32355,'35814','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.708405,-86.617310,0,'2013-07-06 12:44:32',NULL,NULL),(71514,'87115','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.982758,-106.517977,0,'2013-07-06 12:44:34',NULL,NULL),(59751,'71152','U','CNB','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.440924,-93.788435,0,'2013-07-06 12:44:33',NULL,NULL),(28576,'31624','S','Axson','D','Atkinson','13003','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.289599,-82.720752,0,'2013-07-06 12:44:32',NULL,NULL),(20585,'21160','S','Cardiff','A','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.706514,-76.316709,0,'2013-07-06 12:44:31',NULL,NULL),(36234,'40292','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.231826,-85.669849,0,'2013-07-06 12:44:32',NULL,NULL),(39631,'44890','S','Delphi','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(24783,'27571','S','Rolesville','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.923393,-78.456423,0,'2013-07-06 12:44:31',NULL,NULL),(35366,'39442','P','Laurel','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.693155,-89.143217,0,'2013-07-06 12:44:32',NULL,NULL),(34523,'38680','S','Memphis','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.961644,-90.119278,0,'2013-07-06 12:44:32',NULL,NULL),(26732,'29418','S','North Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(58472,'68741','S','Hubbard','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.407532,-96.622940,0,'2013-07-06 12:44:33',NULL,NULL),(76676,'95798','P','West Sacto','N','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.574918,-121.561857,0,'2013-07-06 12:44:34',NULL,NULL),(67573,'80304','S','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.038088,-105.282837,0,'2013-07-06 12:44:34',NULL,NULL),(22931,'24627','P','Mavisdale','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.182988,-82.215192,0,'2013-07-06 12:44:31',NULL,NULL),(8151,'07849','S','Lake Hopatcong','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.954339,-74.614031,0,'2013-07-06 12:44:30',NULL,NULL),(37042,'41265','S','Johns Creek','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.698773,-82.687184,0,'2013-07-06 12:44:32',NULL,NULL),(67218,'79922','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.822081,-106.568367,0,'2013-07-06 12:44:34',NULL,NULL),(25523,'28391','S','Stedman','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.021874,-78.704641,0,'2013-07-06 12:44:31',NULL,NULL),(28907,'32136','S','Flagler Beach','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.449219,-81.119771,0,'2013-07-06 12:44:32',NULL,NULL),(1103,'00725','S','Urb Nazario','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(39933,'45226','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118178,-84.426641,0,'2013-07-06 12:44:32',NULL,NULL),(12941,'13350','S','East Herkimer','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.030105,-74.984973,0,'2013-07-06 12:44:30',NULL,NULL),(51718,'60010','S','Lake Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(51302,'59225','S','Lustre','A','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.400000,-105.883333,0,'2013-07-06 12:44:33',NULL,NULL),(31018,'33785','S','Belleair Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(71085,'85930','P','Hawley Lake','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.983889,-109.746389,0,'2013-07-06 12:44:34',NULL,NULL),(25312,'28163','S','Stanfield','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.251684,-80.403160,0,'2013-07-06 12:44:31',NULL,NULL),(76109,'95229','P','Vallecito','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.116433,-120.457748,0,'2013-07-06 12:44:34',NULL,NULL),(48239,'55421','S','St Anthony Village','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(49730,'57048','S','Montrose','D','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.700076,-97.186816,0,'2013-07-06 12:44:33',NULL,NULL),(50936,'58571','S','Stanton','D','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.384708,-101.394519,0,'2013-07-06 12:44:33',NULL,NULL),(26916,'29582','S','N Myrtle Beach','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(57639,'67152','S','Riverdale','N','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.269025,-97.394271,0,'2013-07-06 12:44:33',NULL,NULL),(59080,'70118','S','Carrollton','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.954635,-90.123422,0,'2013-07-06 12:44:33',NULL,NULL),(76251,'95403','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.479575,-122.750548,0,'2013-07-06 12:44:34',NULL,NULL),(58654,'68874','S','Sargent','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.639988,-99.371879,0,'2013-07-06 12:44:33',NULL,NULL),(49073,'56316','S','Brooten','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.527831,-95.089575,0,'2013-07-06 12:44:33',NULL,NULL),(37261,'41564','S','Sidney','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.615627,-82.377097,0,'2013-07-06 12:44:32',NULL,NULL),(54610,'62912','S','Buncombe','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.464327,-88.986086,0,'2013-07-06 12:44:33',NULL,NULL),(65903,'78235','S','Brooks City Base','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.341979,-98.442498,0,'2013-07-06 12:44:34',NULL,NULL),(23955,'26287','S','Parsons','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.093406,-79.681282,0,'2013-07-06 12:44:31',NULL,NULL),(67068,'79567','S','Crews','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(2590,'00961','S','Sect Punta Brava','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(14546,'15210','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.404900,-79.972620,0,'2013-07-06 12:44:31',NULL,NULL),(26836,'29492','S','Daniel Island','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.955719,-79.887276,0,'2013-07-06 12:44:31',NULL,NULL),(34447,'38652','S','New Albany','D','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(10916,'11429','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.711559,-73.742091,0,'2013-07-06 12:44:30',NULL,NULL),(70234,'84404','S','Warren','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(11154,'11719','S','Brookhaven','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.779227,-72.915009,0,'2013-07-06 12:44:30',NULL,NULL),(17693,'18211','S','Andreas','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.740448,-75.826332,0,'2013-07-06 12:44:31',NULL,NULL),(7986,'07712','S','Wanamassa','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(8778,'08551','S','East Amwell Township','N','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.441298,-74.836215,0,'2013-07-06 12:44:30',NULL,NULL),(40185,'45374','U','Troy','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.044093,-84.217683,0,'2013-07-06 12:44:32',NULL,NULL),(2317,'00929','P','65th Infantry','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.401987,-66.023228,0,'2013-07-06 12:44:30',NULL,NULL),(9084,'09033','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5441,'04686','S','Wesley','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.952222,-67.661389,0,'2013-07-06 12:44:30',NULL,NULL),(52424,'60652','S','Ashburn Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.743986,-87.712805,0,'2013-07-06 12:44:33',NULL,NULL),(50145,'57536','S','Joe Creek','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.524105,-99.741834,0,'2013-07-06 12:44:33',NULL,NULL),(36998,'41219','S','Gillem Branch','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(59503,'70775','S','St Francisvle','A','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.862864,-91.332969,0,'2013-07-06 12:44:33',NULL,NULL),(65663,'77979','S','Olivia','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(77444,'96809','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305003,-157.859366,0,'2013-07-06 12:44:34',NULL,NULL),(74232,'92322','P','Cedarpines Park','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.252934,-117.324200,0,'2013-07-06 12:44:34',NULL,NULL),(69848,'84085','S','Whiterocks','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.486689,-109.917677,0,'2013-07-06 12:44:34',NULL,NULL),(59265,'70451','P','Natalbany','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.544927,-90.486193,0,'2013-07-06 12:44:33',NULL,NULL),(39131,'44270','S','Easton','N','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.952500,-81.735556,0,'2013-07-06 12:44:32',NULL,NULL),(17567,'18002','P','Lehigh Valley','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.584058,-75.470320,0,'2013-07-06 12:44:31',NULL,NULL),(10478,'10952','S','Airmont','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.114522,-74.077510,0,'2013-07-06 12:44:30',NULL,NULL),(13826,'14217','S','Town of Tonawanda','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.972758,-78.876061,0,'2013-07-06 12:44:31',NULL,NULL),(65546,'77833','S','Brenham','D','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.216840,-96.396420,0,'2013-07-06 12:44:34',NULL,NULL),(65857,'78208','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.438357,-98.457025,0,'2013-07-06 12:44:34',NULL,NULL),(71404,'87014','S','Seboyeta','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.112342,-107.506934,0,'2013-07-06 12:44:34',NULL,NULL),(61249,'72348','S','Hughes','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.920523,-90.311029,0,'2013-07-06 12:44:33',NULL,NULL),(34550,'38722','P','McCutcheon','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.267536,-90.881204,0,'2013-07-06 12:44:32',NULL,NULL),(39973,'45238','S','Del Fair','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.110911,-84.613884,0,'2013-07-06 12:44:32',NULL,NULL),(34832,'38920','S','Greenwood-Leflore Airport','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(11664,'12138','S','Taconic Lake','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.737100,-73.362660,0,'2013-07-06 12:44:30',NULL,NULL),(16630,'17333','U','Hanover','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.824208,-76.990704,0,'2013-07-06 12:44:31',NULL,NULL),(65954,'78268','P','Leon Valley','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.470275,-98.617172,0,'2013-07-06 12:44:34',NULL,NULL),(70477,'84764','P','Bryce Canyon City','A','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.677100,-112.155661,0,'2013-07-06 12:44:34',NULL,NULL),(16910,'17601','S','Neffsville','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(55869,'64188','P','Ks City','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.099722,-94.578333,0,'2013-07-06 12:44:33',NULL,NULL),(57736,'67422','S','Bennington','D','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.032683,-97.594152,0,'2013-07-06 12:44:33',NULL,NULL),(23178,'25036','P','Cannelton','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.196778,-81.296157,0,'2013-07-06 12:44:31',NULL,NULL),(64689,'76841','S','Fort McKavett','A','Menard','48327','Texas','TX','48','0000','325','Central',-6.0,'Y',30.930384,-99.828136,0,'2013-07-06 12:44:34',NULL,NULL),(71510,'87114','S','Los Ranchos De Abq','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(71866,'87715','S','Cleveland','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.973436,-105.543712,0,'2013-07-06 12:44:34',NULL,NULL),(59003,'70063','P','Kenner','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.992959,-90.253629,0,'2013-07-06 12:44:33',NULL,NULL),(38280,'43326','S','Hepburn','N','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.643700,-83.607011,0,'2013-07-06 12:44:32',NULL,NULL),(36250,'40311','S','Carlisle','D','Nicholas','21181','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.338601,-84.025878,0,'2013-07-06 12:44:32',NULL,NULL),(33846,'37940','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.899618,-83.855185,0,'2013-07-06 12:44:32',NULL,NULL),(11554,'12057','S','Eagle Bridge','D','Rensselaer','36083','New York','NY','36','2975','518','Eastern',-5.0,'Y',42.956640,-73.361520,0,'2013-07-06 12:44:30',NULL,NULL),(42936,'48117','S','Ash Twp','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.052359,-83.410724,0,'2013-07-06 12:44:32',NULL,NULL),(16969,'17721','P','Avis','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.184921,-77.321914,0,'2013-07-06 12:44:31',NULL,NULL),(6732,'06076','S','Stafford Spgs','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.985120,-72.255660,0,'2013-07-06 12:44:30',NULL,NULL),(59786,'71212','U','Northeast Univ','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.510013,-92.120718,0,'2013-07-06 12:44:33',NULL,NULL),(36334,'40392','P','Winchester','D','Clark','21049','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.988447,-84.178486,0,'2013-07-06 12:44:32',NULL,NULL),(926,'00714','S','Repto Bello Mar','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(23434,'25396','U','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351027,-81.629411,0,'2013-07-06 12:44:31',NULL,NULL),(55588,'63932','S','Broseley','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.707461,-90.239409,0,'2013-07-06 12:44:33',NULL,NULL),(56822,'65786','S','Branch','N','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.976586,-92.968476,0,'2013-07-06 12:44:33',NULL,NULL),(32953,'36581','S','Sunflower','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.393774,-88.062270,0,'2013-07-06 12:44:32',NULL,NULL),(53218,'61633','U','Great Central Ins Co','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.708280,-89.662648,0,'2013-07-06 12:44:33',NULL,NULL),(35177,'39272','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.216828,-90.269123,0,'2013-07-06 12:44:32',NULL,NULL),(49107,'56345','S','Little Falls','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.979362,-94.362403,0,'2013-07-06 12:44:33',NULL,NULL),(72685,'89445','S','Grass Valley','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(7095,'06357','S','Niantic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.320835,-72.211925,0,'2013-07-06 12:44:30',NULL,NULL),(79773,'99336','S','Finley','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.194720,-119.133240,0,'2013-07-06 12:44:34',NULL,NULL),(60767,'72013','S','Bee Branch','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423104,-92.413884,0,'2013-07-06 12:44:33',NULL,NULL),(49863,'57251','S','Marvin','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.282954,-96.941539,0,'2013-07-06 12:44:33',NULL,NULL),(1834,'00784','S','Urb La Hacienda','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(29151,'32337','P','Lloyd','D','Jefferson','12065','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.476702,-84.021720,0,'2013-07-06 12:44:32',NULL,NULL),(61638,'72842','S','Waveland','A','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.096421,-93.612292,0,'2013-07-06 12:44:33',NULL,NULL),(79558,'99011','S','Fairchild AFB','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.636732,-117.652435,0,'2013-07-06 12:44:34',NULL,NULL),(63954,'76088','S','Weatherford','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.766147,-97.803836,0,'2013-07-06 12:44:34',NULL,NULL),(39048,'44190','U','Key Bank','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.503501,-81.621160,0,'2013-07-06 12:44:32',NULL,NULL),(2717,'00969','S','Terrs de Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(47342,'54601','S','French Island','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.795836,-91.221089,0,'2013-07-06 12:44:32',NULL,NULL),(5680,'04969','S','Plymouth','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.765423,-69.229519,0,'2013-07-06 12:44:30',NULL,NULL),(47268,'54531','S','Hazelhurst','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.766734,-89.756601,0,'2013-07-06 12:44:32',NULL,NULL),(9709,'10065','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.765326,-73.963802,0,'2013-07-06 12:44:30',NULL,NULL),(22235,'23612','P','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.068802,-76.494931,0,'2013-07-06 12:44:31',NULL,NULL),(45435,'51104','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.522094,-96.384395,0,'2013-07-06 12:44:32',NULL,NULL),(38603,'43842','P','Trinway','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.139867,-82.009530,0,'2013-07-06 12:44:32',NULL,NULL),(63133,'75356','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.815147,-96.877005,0,'2013-07-06 12:44:33',NULL,NULL),(61841,'73116','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.540626,-97.556678,0,'2013-07-06 12:44:33',NULL,NULL),(24815,'27604','S','Brentwood','A','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.866620,-78.531900,0,'2013-07-06 12:44:31',NULL,NULL),(54156,'62571','S','Hinton','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.390541,-88.964526,0,'2013-07-06 12:44:33',NULL,NULL),(1264,'00730','S','Alt del Madrigal','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(25012,'27879','P','Simpson','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.573583,-77.279610,0,'2013-07-06 12:44:31',NULL,NULL),(45963,'52358','S','Springdale','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(62563,'74451','S','Park Hill','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.649292,-95.023172,0,'2013-07-06 12:44:33',NULL,NULL),(65598,'77881','P','Wellborn','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.536561,-96.301446,0,'2013-07-06 12:44:34',NULL,NULL),(75175,'93603','S','Miramonte','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.588008,-119.015000,0,'2013-07-06 12:44:34',NULL,NULL),(59584,'71002','S','Ashland','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.116351,-93.114423,0,'2013-07-06 12:44:33',NULL,NULL),(47184,'54481','S','Stockton','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(45740,'52101','S','Sattre','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(33319,'37138','S','Old Hickory','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.245160,-86.632377,0,'2013-07-06 12:44:32',NULL,NULL),(47001,'54246','S','Washington Island','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.370595,-86.902605,0,'2013-07-06 12:44:32',NULL,NULL),(27822,'30410','S','Higgston','N','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210400,-82.483320,0,'2013-07-06 12:44:31',NULL,NULL),(18655,'19173','U','Verizon','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954726,-75.169864,0,'2013-07-06 12:44:31',NULL,NULL),(59882,'71269','S','Jonesburg','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(74559,'92679','S','Dove Canyon','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(79205,'98536','S','Carlisle','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.141395,-124.099068,0,'2013-07-06 12:44:34',NULL,NULL),(73822,'91767','S','Pomona','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.081648,-117.740882,0,'2013-07-06 12:44:34',NULL,NULL),(40851,'46225','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.747805,-86.160941,0,'2013-07-06 12:44:32',NULL,NULL),(42976,'48138','S','Grosse Ile','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134339,-83.153677,0,'2013-07-06 12:44:32',NULL,NULL),(52032,'60183','P','Wasco','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.939492,-88.401527,0,'2013-07-06 12:44:33',NULL,NULL),(28498,'31524','U','Brunswick','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.144010,-81.469037,0,'2013-07-06 12:44:32',NULL,NULL),(36545,'40906','S','Barbourville','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(15450,'16405','S','Columbus','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.940610,-79.580520,0,'2013-07-06 12:44:31',NULL,NULL),(40303,'45458','S','Centerville','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(68019,'80925','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739647,-104.635922,0,'2013-07-06 12:44:34',NULL,NULL),(67187,'79854','S','Valentine','D','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',30.729283,-104.450344,0,'2013-07-06 12:44:34',NULL,NULL),(27497,'30170','S','Roopville','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.418873,-85.174117,0,'2013-07-06 12:44:31',NULL,NULL),(39538,'44836','S','Green Springs','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.232713,-83.073155,0,'2013-07-06 12:44:32',NULL,NULL),(9910,'10138','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756075,-73.989193,0,'2013-07-06 12:44:30',NULL,NULL),(43020,'48167','S','Northville','D','Wayne','26163','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.422231,-83.470096,0,'2013-07-06 12:44:32',NULL,NULL),(46123,'52641','S','Mt Pleasant','A','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.968419,-91.548901,0,'2013-07-06 12:44:32',NULL,NULL),(53633,'62098','P','Wrights','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.379455,-90.293520,0,'2013-07-06 12:44:33',NULL,NULL),(36377,'40464','S','Parksville','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.588144,-84.921499,0,'2013-07-06 12:44:32',NULL,NULL),(39025,'44143','S','Mayfield Vlg','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(46630,'53584','P','Sextonville','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.281665,-90.292672,0,'2013-07-06 12:44:32',NULL,NULL),(11165,'11724','S','Cold Spring Harbor','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.866028,-73.450581,0,'2013-07-06 12:44:30',NULL,NULL),(8189,'07902','P','Summit','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.714140,-74.365895,0,'2013-07-06 12:44:30',NULL,NULL),(62290,'74020','S','Baugh','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.273480,-96.430080,0,'2013-07-06 12:44:33',NULL,NULL),(60246,'71433','S','Pawnee','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(76140,'95267','P','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.003825,-121.319038,0,'2013-07-06 12:44:34',NULL,NULL),(59114,'70146','S','New Orleans Naval Air','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.033612,-90.041438,0,'2013-07-06 12:44:33',NULL,NULL),(29653,'32905','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.028121,-80.601039,0,'2013-07-06 12:44:32',NULL,NULL),(46327,'53081','S','Sheboygan','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.741822,-87.728355,0,'2013-07-06 12:44:32',NULL,NULL),(49439,'56636','S','Deer River','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(4493,'03279','S','Warren','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.964838,-71.882662,0,'2013-07-06 12:44:30',NULL,NULL),(43167,'48269','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.328906,-83.045858,0,'2013-07-06 12:44:32',NULL,NULL),(34333,'38565','S','Grimsley','D','Fentress','47049','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.255506,-85.030665,0,'2013-07-06 12:44:32',NULL,NULL),(29193,'32404','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.180448,-85.559816,0,'2013-07-06 12:44:32',NULL,NULL),(4831,'04002','S','Alfred','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.492177,-70.705903,0,'2013-07-06 12:44:30',NULL,NULL),(63408,'75652','S','McKnight','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(62089,'73567','P','Sterling','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.752387,-98.160528,0,'2013-07-06 12:44:33',NULL,NULL),(61259,'72360','S','Marianna','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.772374,-90.762665,0,'2013-07-06 12:44:33',NULL,NULL),(17792,'18356','P','Shawnee','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.009711,-75.111422,0,'2013-07-06 12:44:31',NULL,NULL),(51147,'58844','S','Fortuna','D','Divide','38023','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.948333,-103.627778,0,'2013-07-06 12:44:33',NULL,NULL),(29782,'33015','S','Miami Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940770,-80.315677,0,'2013-07-06 12:44:32',NULL,NULL),(27194,'29861','P','North Augusta','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.517536,-81.958594,0,'2013-07-06 12:44:31',NULL,NULL),(9423,'10002','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(78224,'97761','P','Kahneeta','N','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.762816,-121.302390,0,'2013-07-06 12:44:34',NULL,NULL),(57315,'66699','U','Kansas Income Tax','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.053504,-95.673075,0,'2013-07-06 12:44:33',NULL,NULL),(61687,'72944','S','Abbott','N','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.017534,-94.201396,0,'2013-07-06 12:44:33',NULL,NULL),(61580,'72742','S','Kingston','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.037868,-93.500749,0,'2013-07-06 12:44:33',NULL,NULL),(60145,'71375','S','Cooters Point','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(47581,'54849','S','Lk Nebagamon','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.491177,-91.743284,0,'2013-07-06 12:44:33',NULL,NULL),(36751,'41040','S','Locust Grove','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(58383,'68583','P','Univ Of Ne E Campus','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.828399,-96.663016,0,'2013-07-06 12:44:33',NULL,NULL),(4665,'03773','S','Unity','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.369645,-72.158576,0,'2013-07-06 12:44:30',NULL,NULL),(32266,'35632','U','Florence','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.841710,-87.606651,0,'2013-07-06 12:44:32',NULL,NULL),(62278,'74016','S','Bushyhead','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.540960,-95.446920,0,'2013-07-06 12:44:33',NULL,NULL),(71739,'87537','S','El Duende','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.070638,-106.160258,0,'2013-07-06 12:44:34',NULL,NULL),(33921,'38053','S','Woodstock','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(16843,'17560','S','Providence','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.252500,0,'2013-07-06 12:44:31',NULL,NULL),(15118,'15801','S','Du Bois','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.124856,-78.763496,0,'2013-07-06 12:44:31',NULL,NULL),(8259,'08008','S','Long Beach','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(52843,'61319','S','Cornell','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.989667,-88.729988,0,'2013-07-06 12:44:33',NULL,NULL),(76742,'95915','P','Belden','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.006111,-121.248056,0,'2013-07-06 12:44:34',NULL,NULL),(69615,'83864','S','Sandpoint','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.299419,-116.535216,0,'2013-07-06 12:44:34',NULL,NULL),(20969,'21790','S','Tuscarora','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.266735,-77.501058,0,'2013-07-06 12:44:31',NULL,NULL),(24380,'27094','U','Princess House','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.236783,-80.297030,0,'2013-07-06 12:44:31',NULL,NULL),(608,'00680','S','Villa Angelica','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(55233,'63437','S','Hagars Grove','N','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738419,-92.263023,0,'2013-07-06 12:44:33',NULL,NULL),(56281,'65069','S','Starkenburg','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757968,-91.534285,0,'2013-07-06 12:44:33',NULL,NULL),(58704,'68932','S','Buffalo','N','Franklin','31061','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.298761,-98.729244,0,'2013-07-06 12:44:33',NULL,NULL),(58403,'68633','S','Dodge','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.724830,-96.880938,0,'2013-07-06 12:44:33',NULL,NULL),(29910,'33054','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.905290,-80.257160,0,'2013-07-06 12:44:32',NULL,NULL),(46242,'52808','P','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.503182,-90.633992,0,'2013-07-06 12:44:32',NULL,NULL),(39231,'44418','S','Fowler','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.302457,-80.606765,0,'2013-07-06 12:44:32',NULL,NULL),(6607,'05871','S','Newark Hollow','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.616667,-71.933333,0,'2013-07-06 12:44:30',NULL,NULL),(61375,'72525','P','Cherokee Village','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.315833,-91.482500,0,'2013-07-06 12:44:33',NULL,NULL),(72002,'88039','S','Alma','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.327720,-108.813300,0,'2013-07-06 12:44:34',NULL,NULL),(38347,'43440','S','Marblehead','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531235,-82.759429,0,'2013-07-06 12:44:32',NULL,NULL),(41579,'47039','P','Pierceville','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.112806,-85.221521,0,'2013-07-06 12:44:32',NULL,NULL),(17094,'17765','S','Leolyn','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(47110,'54448','S','Marathon','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.930712,-89.834421,0,'2013-07-06 12:44:32',NULL,NULL),(16184,'17067','S','Myerstwn','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(30971,'33741','P','Pass A Grille Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.688063,-82.733847,0,'2013-07-06 12:44:32',NULL,NULL),(58727,'68941','S','Pauline','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.483464,-98.219562,0,'2013-07-06 12:44:33',NULL,NULL),(54181,'62624','S','Browning','D','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.160050,-90.349720,0,'2013-07-06 12:44:33',NULL,NULL),(64778,'77005','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.718966,-95.421416,0,'2013-07-06 12:44:34',NULL,NULL),(70635,'85142','S','Chandler Hts','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.228018,-111.637649,0,'2013-07-06 12:44:34',NULL,NULL),(30534,'33408','S','North Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(73338,'90848','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.830348,-118.184925,0,'2013-07-06 12:44:34',NULL,NULL),(1283,'00730','S','Qtas de Monserrate','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(25619,'28461','S','Bald Head Island','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(21144,'22108','U','USA Today','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.936723,-77.177728,0,'2013-07-06 12:44:31',NULL,NULL),(67499,'80234','S','Northglenn','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(79178,'98520','S','Ocosta','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(74860,'93256','S','Pixley','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',35.970182,-119.290216,0,'2013-07-06 12:44:34',NULL,NULL),(24104,'26520','P','Arthurdale','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.492323,-79.813201,0,'2013-07-06 12:44:31',NULL,NULL),(20440,'21005','S','Aber Prov Grd','A','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.455614,-76.150285,0,'2013-07-06 12:44:31',NULL,NULL),(28051,'30667','S','Stephens','D','Oglethorpe','13221','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.772658,-83.106905,0,'2013-07-06 12:44:31',NULL,NULL),(21862,'23148','S','St Stephns Ch','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.914841,-77.076387,0,'2013-07-06 12:44:31',NULL,NULL),(24433,'27202','P','Altamahaw','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.184262,-79.506728,0,'2013-07-06 12:44:31',NULL,NULL),(64085,'76150','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.751455,-97.338993,0,'2013-07-06 12:44:34',NULL,NULL),(51266,'59101','S','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.774634,-108.479727,0,'2013-07-06 12:44:33',NULL,NULL),(13900,'14273','U','HSBC Bank','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870716,-78.869699,0,'2013-07-06 12:44:31',NULL,NULL),(65202,'77434','S','Eagle Lake','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.591280,-96.340440,0,'2013-07-06 12:44:34',NULL,NULL),(60258,'71443','S','Kurthwood','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.334766,-93.164776,0,'2013-07-06 12:44:33',NULL,NULL),(38384,'43512','S','Defiance','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.297567,-84.357805,0,'2013-07-06 12:44:32',NULL,NULL),(49838,'57227','S','Linden Beach','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.362558,-96.668241,0,'2013-07-06 12:44:33',NULL,NULL),(5927,'05252','S','Sunderland','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.057869,-73.137659,0,'2013-07-06 12:44:30',NULL,NULL),(52455,'60674','U','Bank of America','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.876571,-87.649480,0,'2013-07-06 12:44:33',NULL,NULL),(41099,'46552','S','New Carlisle','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.708477,-86.481430,0,'2013-07-06 12:44:32',NULL,NULL),(70248,'84412','P','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.300877,-111.946406,0,'2013-07-06 12:44:34',NULL,NULL),(62988,'75148','S','Malakoff','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.186698,-96.026721,0,'2013-07-06 12:44:33',NULL,NULL),(62752,'74845','S','Vernon','A','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.215556,-95.925556,0,'2013-07-06 12:44:33',NULL,NULL),(65003,'77299','U','Bank of America','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770633,-95.414819,0,'2013-07-06 12:44:34',NULL,NULL),(38832,'44085','S','Hartsgrove','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(70923,'85634','S','Fresnal Canyon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(64215,'76265','S','Saint Jo','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.700478,-97.526008,0,'2013-07-06 12:44:34',NULL,NULL),(18284,'19013','S','Upper Chichester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(39846,'45167','S','Redoak','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.762237,-83.812847,0,'2013-07-06 12:44:32',NULL,NULL),(30978,'33744','P','Bay Pines','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.817002,-82.774691,0,'2013-07-06 12:44:32',NULL,NULL),(5742,'05035','S','Bridgewater Corn','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(57627,'67140','S','Hunnewell','A','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.093316,-97.350358,0,'2013-07-06 12:44:33',NULL,NULL),(36523,'40840','S','Helton','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.952639,-83.391566,0,'2013-07-06 12:44:32',NULL,NULL),(40372,'45650','S','Lynx','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.744486,-83.422398,0,'2013-07-06 12:44:32',NULL,NULL),(7157,'06422','S','Durham','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.459510,-72.690481,0,'2013-07-06 12:44:30',NULL,NULL),(76356,'95486','P','Villa Grande','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.474220,-123.035100,0,'2013-07-06 12:44:34',NULL,NULL),(75498,'94132','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.723729,-122.480389,0,'2013-07-06 12:44:34',NULL,NULL),(45764,'52149','P','Highlandville','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.305362,-91.789881,0,'2013-07-06 12:44:32',NULL,NULL),(26984,'29621','S','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.523656,-82.644593,0,'2013-07-06 12:44:31',NULL,NULL),(40462,'45746','S','Macksburg','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.608280,-81.441502,0,'2013-07-06 12:44:32',NULL,NULL),(50844,'58483','S','Streeter','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.659173,-99.360588,0,'2013-07-06 12:44:33',NULL,NULL),(31647,'34737','S','Howey In Hls','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.704236,-81.784964,0,'2013-07-06 12:44:32',NULL,NULL),(9362,'09820','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9538,'10021','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(48891,'56113','S','Arco','D','Lincoln','27081','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.412524,-96.199843,0,'2013-07-06 12:44:33',NULL,NULL),(11742,'12185','S','West Valley Falls','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.887140,-73.544884,0,'2013-07-06 12:44:30',NULL,NULL),(52605,'61021','S','Prairieville','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.838841,-89.492572,0,'2013-07-06 12:44:33',NULL,NULL),(10995,'11550','S','Hempstead','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.708785,-73.624573,0,'2013-07-06 12:44:30',NULL,NULL),(1386,'00738','S','Ext Veve Calzada','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(38755,'44039','S','Elyria','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.391979,-82.019396,0,'2013-07-06 12:44:32',NULL,NULL),(13932,'14428','S','Churchville','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.052222,-77.815000,0,'2013-07-06 12:44:31',NULL,NULL),(16388,'17213','S','Nossville','N','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(68325,'81120','S','Mogote','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(7191,'06473','S','North Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.381539,-72.861606,0,'2013-07-06 12:44:30',NULL,NULL),(5123,'04401','S','Veazie','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.814135,-68.778574,0,'2013-07-06 12:44:30',NULL,NULL),(76341,'95470','S','Redwood Valley','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.280802,-123.212931,0,'2013-07-06 12:44:34',NULL,NULL),(45016,'50458','S','Nora Springs','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.129100,-92.996025,0,'2013-07-06 12:44:32',NULL,NULL),(47425,'54665','S','Viroqua','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.555035,-90.889322,0,'2013-07-06 12:44:32',NULL,NULL),(48544,'55760','S','East Lake','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(31918,'35171','S','Thorsby','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.923746,-86.770973,0,'2013-07-06 12:44:32',NULL,NULL),(12824,'13305','P','Beaver Falls','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.887639,-75.425266,0,'2013-07-06 12:44:30',NULL,NULL),(12157,'12745','S','Hortonville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.787313,-75.028169,0,'2013-07-06 12:44:30',NULL,NULL),(66665,'78877','S','Quemado','D','Maverick','48323','Texas','TX','48','0000','830','Central',-6.0,'Y',28.927200,-100.426200,0,'2013-07-06 12:44:34',NULL,NULL),(59468,'70743','P','Hester','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.020132,-90.770944,0,'2013-07-06 12:44:33',NULL,NULL),(40910,'46260','S','Meridian Hls','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.892649,-86.180844,0,'2013-07-06 12:44:32',NULL,NULL),(54775,'62996','S','America','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.157145,-89.175913,0,'2013-07-06 12:44:33',NULL,NULL),(1277,'00730','S','Ext Qtas de Monserrate','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(52107,'60416','S','Coal City','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.291648,-88.285221,0,'2013-07-06 12:44:33',NULL,NULL),(12596,'13077','S','Homer','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.676667,-76.189530,0,'2013-07-06 12:44:30',NULL,NULL),(72106,'88232','S','Hagerman','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.115176,-104.352664,0,'2013-07-06 12:44:34',NULL,NULL),(43907,'49252','S','Litchfield','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.031597,-84.766909,0,'2013-07-06 12:44:32',NULL,NULL),(51452,'59483','S','Sun River','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.502761,-111.746669,0,'2013-07-06 12:44:33',NULL,NULL),(5375,'04630','S','East Machias','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.709473,-67.461926,0,'2013-07-06 12:44:30',NULL,NULL),(49851,'57239','S','Grenville','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.502047,-97.411324,0,'2013-07-06 12:44:33',NULL,NULL),(29521,'32778','S','Deer Island','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.801667,-81.736253,0,'2013-07-06 12:44:32',NULL,NULL),(60680,'71923','S','Witherspoon','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(73328,'90842','U','Department of Gas & Water','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.819348,-118.168139,0,'2013-07-06 12:44:34',NULL,NULL),(69668,'84017','S','Pine Cliff','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.804680,-111.296340,0,'2013-07-06 12:44:34',NULL,NULL),(69642,'84006','S','Bingham','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.533333,-112.150000,0,'2013-07-06 12:44:34',NULL,NULL),(62135,'73673','S','Willow','D','Greer','40055','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.046358,-99.643262,0,'2013-07-06 12:44:33',NULL,NULL),(31126,'33903','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(12845,'13316','S','Hillsboro','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.354631,-75.746699,0,'2013-07-06 12:44:30',NULL,NULL),(79751,'99256','U','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.662552,-117.423159,0,'2013-07-06 12:44:34',NULL,NULL),(77774,'97123','S','Cornelius','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.506393,-122.946368,0,'2013-07-06 12:44:34',NULL,NULL),(68602,'81610','S','Dinosaur','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.334596,-108.822045,0,'2013-07-06 12:44:34',NULL,NULL),(59342,'70550','P','Lawtell','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.514286,-92.177092,0,'2013-07-06 12:44:33',NULL,NULL),(15712,'16863','S','Olanta','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.905935,-78.501934,0,'2013-07-06 12:44:31',NULL,NULL),(41084,'46534','S','Ober','A','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.299044,-86.616720,0,'2013-07-06 12:44:32',NULL,NULL),(43867,'49126','S','Sodus','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.036820,-86.369682,0,'2013-07-06 12:44:32',NULL,NULL),(27834,'30415','S','McGregor','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(12208,'12789','S','Woodridge','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.693208,-74.584330,0,'2013-07-06 12:44:30',NULL,NULL),(44207,'49631','S','Evart','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.893701,-85.267454,0,'2013-07-06 12:44:32',NULL,NULL),(9808,'10111','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(67493,'80233','S','Northglenn','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903291,-104.948178,0,'2013-07-06 12:44:34',NULL,NULL),(65145,'77386','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.131735,-95.416441,0,'2013-07-06 12:44:34',NULL,NULL),(59388,'70611','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.336660,-93.203040,0,'2013-07-06 12:44:33',NULL,NULL),(37181,'41501','S','Nelse','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(11801,'12227','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.689555,-73.845984,0,'2013-07-06 12:44:30',NULL,NULL),(58401,'68632','S','Garrison','A','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.243121,-97.131923,0,'2013-07-06 12:44:33',NULL,NULL),(55666,'64034','S','Lake Winnebago','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.849040,-94.287060,0,'2013-07-06 12:44:33',NULL,NULL),(35866,'39836','S','Coleman','D','Randolph','13243','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.654867,-84.876604,0,'2013-07-06 12:44:32',NULL,NULL),(51638,'59864','S','Ronan','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.541838,-114.139907,0,'2013-07-06 12:44:33',NULL,NULL),(2812,'00976','S','Valle San Juan','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(62429,'74152','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.126786,-95.944930,0,'2013-07-06 12:44:33',NULL,NULL),(77557,'96861','S','Camp H M Smith','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.395150,-157.899220,0,'2013-07-06 12:44:34',NULL,NULL),(53820,'62298','S','Monroe City','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(78826,'98335','S','Glencove','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(66217,'78553','P','Harlingen','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.209958,-97.695299,0,'2013-07-06 12:44:34',NULL,NULL),(38262,'43306','P','Marion','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.611969,-83.158583,0,'2013-07-06 12:44:32',NULL,NULL),(38684,'43973','S','Freeport','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.156554,-81.323349,0,'2013-07-06 12:44:32',NULL,NULL),(31461,'34288','S','N Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.048529,-82.194897,0,'2013-07-06 12:44:32',NULL,NULL),(31529,'34482','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.229052,-82.306676,0,'2013-07-06 12:44:32',NULL,NULL),(20008,'20615','S','Broomes Is','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.417827,-76.545282,0,'2013-07-06 12:44:31',NULL,NULL),(23499,'25524','S','Ferrellsburg','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.030940,-82.105380,0,'2013-07-06 12:44:31',NULL,NULL),(72752,'89510','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(50739,'58401','S','Eldridge','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(8945,'08757','S','S Toms River','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(31322,'34119','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.256936,-81.713878,0,'2013-07-06 12:44:32',NULL,NULL),(41749,'47280','P','Taylorsville','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.298329,-85.947906,0,'2013-07-06 12:44:32',NULL,NULL),(2412,'00953','S','Hacienda El Pilar','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(35848,'39817','S','West Bainbridge','N','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.905055,-84.568611,0,'2013-07-06 12:44:32',NULL,NULL),(64029,'76122','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.725278,-97.320556,0,'2013-07-06 12:44:34',NULL,NULL),(15594,'16667','S','St Clairsville','A','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.160648,-78.508616,0,'2013-07-06 12:44:31',NULL,NULL),(33636,'37684','P','Mtn Home','A','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.306702,-82.377444,0,'2013-07-06 12:44:32',NULL,NULL),(30648,'33455','S','Hobe Sound','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.075482,-80.143309,0,'2013-07-06 12:44:32',NULL,NULL),(42340,'47637','S','Folsomvl','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.128740,-87.148763,0,'2013-07-06 12:44:32',NULL,NULL),(44219,'49643','S','Karlin','A','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.651160,-85.838640,0,'2013-07-06 12:44:32',NULL,NULL),(54519,'62875','S','Patoka','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.753045,-89.096352,0,'2013-07-06 12:44:33',NULL,NULL),(13816,'14214','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.941449,-78.836451,0,'2013-07-06 12:44:31',NULL,NULL),(54495,'62864','S','Marcoe','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(45398,'51037','S','Meriden','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.794769,-95.632212,0,'2013-07-06 12:44:32',NULL,NULL),(61864,'73124','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.431919,-97.525309,0,'2013-07-06 12:44:33',NULL,NULL),(64306,'76464','S','Moran','D','Shackelford','48417','Texas','TX','48','0000','325','Central',-6.0,'Y',32.544410,-99.168805,0,'2013-07-06 12:44:34',NULL,NULL),(67446,'80209','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.704419,-104.959341,0,'2013-07-06 12:44:34',NULL,NULL),(76514,'95644','P','Kit Carson','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.457312,-120.530419,0,'2013-07-06 12:44:34',NULL,NULL),(74387,'92509','S','Rubidoux','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.996714,-117.445775,0,'2013-07-06 12:44:34',NULL,NULL),(68827,'82510','S','Arapahoe','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.989002,-108.542725,0,'2013-07-06 12:44:34',NULL,NULL),(63165,'75394','U','SBC ATT','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.830895,-96.706192,0,'2013-07-06 12:44:33',NULL,NULL),(36670,'41011','S','Kenton Hills','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(40487,'45782','P','Trimble','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.482076,-82.083290,0,'2013-07-06 12:44:32',NULL,NULL),(29416,'32655','P','High Springs','D','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.822532,-82.590809,0,'2013-07-06 12:44:32',NULL,NULL),(24494,'27260','S','H P','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(40040,'45252','S','Colerain Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.272712,-84.627394,0,'2013-07-06 12:44:32',NULL,NULL),(76055,'95193','U','I B M','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.244015,-121.830989,0,'2013-07-06 12:44:34',NULL,NULL),(59136,'70165','U','Sewage Water Board','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944694,-90.071602,0,'2013-07-06 12:44:33',NULL,NULL),(25737,'28560','S','New Bern','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.097221,-77.029014,0,'2013-07-06 12:44:31',NULL,NULL),(71382,'87004','S','Santa Ana Pueblo','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(31075,'33855','P','Indian Lk Est','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.873608,-81.477219,0,'2013-07-06 12:44:32',NULL,NULL),(40017,'45247','S','Colerain Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(264,'00641','S','Sect Vendrell','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(25510,'28382','S','Roseboro','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.950848,-78.516195,0,'2013-07-06 12:44:31',NULL,NULL),(27531,'30219','P','Glenn','D','Heard','13149','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.152807,-85.202848,0,'2013-07-06 12:44:31',NULL,NULL),(67371,'80116','S','Franktown','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.353282,-104.711853,0,'2013-07-06 12:44:34',NULL,NULL),(59535,'70811','S','Zion City','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.532352,-91.124008,0,'2013-07-06 12:44:33',NULL,NULL),(27382,'30078','S','Snellville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.854024,-84.010874,0,'2013-07-06 12:44:31',NULL,NULL),(36100,'40220','S','Hurstbrne Acr','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(31044,'33815','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.038562,-81.997042,0,'2013-07-06 12:44:32',NULL,NULL),(46098,'52625','S','Donnellson','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.653180,-91.550700,0,'2013-07-06 12:44:32',NULL,NULL),(32949,'36577','P','Spanish Fort','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.674440,-87.884145,0,'2013-07-06 12:44:32',NULL,NULL),(36508,'40826','S','Eolia','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.065784,-82.760052,0,'2013-07-06 12:44:32',NULL,NULL),(73791,'91748','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(32765,'36353','S','Newville','D','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.431420,-85.331160,0,'2013-07-06 12:44:32',NULL,NULL),(70801,'85365','S','Yuma','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.672337,-114.502398,0,'2013-07-06 12:44:34',NULL,NULL),(66066,'78382','S','Copano Village','N','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.022280,-97.099080,0,'2013-07-06 12:44:34',NULL,NULL),(3765,'02187','P','Milton Vlg','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.260688,-71.078672,0,'2013-07-06 12:44:30',NULL,NULL),(10823,'11379','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715870,-73.882583,0,'2013-07-06 12:44:30',NULL,NULL),(49833,'57225','S','Clark','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.881594,-97.733744,0,'2013-07-06 12:44:33',NULL,NULL),(51487,'59620','P','State of Montana','N','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.532823,-112.157489,0,'2013-07-06 12:44:33',NULL,NULL),(1980,'00902','P','Viejo Sn Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446284,-66.098281,0,'2013-07-06 12:44:30',NULL,NULL),(32566,'36115','S','Gunter AFS','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(30179,'33176','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(65057,'77340','S','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.688500,-95.572380,0,'2013-07-06 12:44:34',NULL,NULL),(66720,'78953','S','Jeddo','N','Bastrop','48021','Texas','TX','48','0640','830','Central',-6.0,'Y',29.881875,-97.323178,0,'2013-07-06 12:44:34',NULL,NULL),(72517,'89157','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171909,-115.139969,0,'2013-07-06 12:44:34',NULL,NULL),(77741,'97080','S','Damascus','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.483779,-122.416754,0,'2013-07-06 12:44:34',NULL,NULL),(25280,'28129','S','Red Cross','A','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.240371,-80.331644,0,'2013-07-06 12:44:31',NULL,NULL),(8368,'08053','S','Kresson','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(42840,'48070','S','Huntington Woods','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.480041,-83.166602,0,'2013-07-06 12:44:32',NULL,NULL),(44934,'50361','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.597268,-93.764352,0,'2013-07-06 12:44:32',NULL,NULL),(45657,'52002','S','Asbury','A','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.511769,-90.749087,0,'2013-07-06 12:44:32',NULL,NULL),(10782,'11367','S','Kew Garden Hl','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728160,-73.818582,0,'2013-07-06 12:44:30',NULL,NULL),(12535,'13037','S','Chittenango','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(46846,'54020','S','Nye','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.320122,-92.699523,0,'2013-07-06 12:44:32',NULL,NULL),(6660,'06025','P','E Glstnbry','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.690889,-72.534917,0,'2013-07-06 12:44:30',NULL,NULL),(36121,'40222','S','Norwood','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(5573,'04901','S','Benton','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.554203,-69.630648,0,'2013-07-06 12:44:30',NULL,NULL),(58235,'68352','S','Fairbury','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.156080,-97.171800,0,'2013-07-06 12:44:33',NULL,NULL),(72492,'89138','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.185165,-115.387370,0,'2013-07-06 12:44:34',NULL,NULL),(58696,'68927','S','Williamsburg','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.526584,-99.632651,0,'2013-07-06 12:44:33',NULL,NULL),(18210,'18950','P','Pt Pleasant','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.414930,-75.067576,0,'2013-07-06 12:44:31',NULL,NULL),(8208,'07939','S','Basking Ridge','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.679559,-74.567323,0,'2013-07-06 12:44:30',NULL,NULL),(31158,'33916','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.630792,-81.834110,0,'2013-07-06 12:44:32',NULL,NULL),(50139,'57533','S','Carlock','N','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.233905,-99.427134,0,'2013-07-06 12:44:33',NULL,NULL),(54296,'62706','U','State of Illinois','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.799900,-89.654773,0,'2013-07-06 12:44:33',NULL,NULL),(57364,'66739','S','Lowell','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.069390,-94.633351,0,'2013-07-06 12:44:33',NULL,NULL),(68,'00612','S','Bo Jarealitos','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(34124,'38193','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.055189,-89.862910,0,'2013-07-06 12:44:32',NULL,NULL),(21756,'23058','P','Glen Allen','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.662023,-77.484349,0,'2013-07-06 12:44:31',NULL,NULL),(69148,'83313','S','East Magic','A','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.414624,-114.198990,0,'2013-07-06 12:44:34',NULL,NULL),(69524,'83726','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.435557,-116.004295,0,'2013-07-06 12:44:34',NULL,NULL),(17758,'18328','S','Dingmans Ferry','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.227695,-74.945839,0,'2013-07-06 12:44:31',NULL,NULL),(35771,'39743','S','Trinity','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.341575,-88.514050,0,'2013-07-06 12:44:32',NULL,NULL),(15576,'16654','U','Huntingdon','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.487207,-78.009794,0,'2013-07-06 12:44:31',NULL,NULL),(57925,'67672','S','Wa Keeney','A','Trego','20195','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.987400,-99.880140,0,'2013-07-06 12:44:33',NULL,NULL),(57409,'66767','S','Prescott','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.180379,-94.704409,0,'2013-07-06 12:44:33',NULL,NULL),(57168,'66285','P','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.016846,-94.663276,0,'2013-07-06 12:44:33',NULL,NULL),(18447,'19070','S','Rutledge','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.908428,-75.323818,0,'2013-07-06 12:44:31',NULL,NULL),(19832,'20501','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900876,-77.029709,0,'2013-07-06 12:44:31',NULL,NULL),(40692,'46072','S','Tipton','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.287496,-86.046318,0,'2013-07-06 12:44:32',NULL,NULL),(51068,'58755','S','Mc Gregor','N','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.591101,-102.949822,0,'2013-07-06 12:44:33',NULL,NULL),(49270,'56484','S','Shingobee','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(58807,'69023','S','Lamar','A','Chase','31029','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.572410,-101.978580,0,'2013-07-06 12:44:33',NULL,NULL),(67505,'80236','S','Fort Logan','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.655391,-105.022433,0,'2013-07-06 12:44:34',NULL,NULL),(69927,'84112','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.763779,-111.838359,0,'2013-07-06 12:44:34',NULL,NULL),(42686,'47982','P','State Line','D','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.196368,-87.529325,0,'2013-07-06 12:44:32',NULL,NULL),(38260,'43302','S','Marion','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.588875,-83.125520,0,'2013-07-06 12:44:32',NULL,NULL),(37039,'41262','S','Tomahawk','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.827120,-82.622820,0,'2013-07-06 12:44:32',NULL,NULL),(55207,'63387','P','Whiteside','D','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.184376,-91.018211,0,'2013-07-06 12:44:33',NULL,NULL),(22025,'23292','U','Bank of America','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542580,-77.444722,0,'2013-07-06 12:44:31',NULL,NULL),(7573,'07029','S','Harrison','D','Hudson','34017','New Jersey','NJ','34','3640','973/862','Eastern',-5.0,'Y',40.744953,-74.152306,0,'2013-07-06 12:44:30',NULL,NULL),(32187,'35503','S','Jasper','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.930626,-87.314072,0,'2013-07-06 12:44:32',NULL,NULL),(12538,'13037','S','North Chittenango','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(20873,'21672','S','Toddville','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.270820,-76.065987,0,'2013-07-06 12:44:31',NULL,NULL),(22344,'23879','S','Skippers','D','Greensville','51081','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.588846,-77.542319,0,'2013-07-06 12:44:31',NULL,NULL),(28340,'31192','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.623867,-84.534721,0,'2013-07-06 12:44:32',NULL,NULL),(25761,'28584','S','Peletier','A','Onslow','37133','North Carolina','NC','37','3605','252','Eastern',-5.0,'Y',34.701094,-77.065759,0,'2013-07-06 12:44:31',NULL,NULL),(41569,'47025','S','Lawrenceburg','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.152460,-84.887280,0,'2013-07-06 12:44:32',NULL,NULL),(53027,'61472','S','Rio','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.109478,-90.395822,0,'2013-07-06 12:44:33',NULL,NULL),(62349,'74058','S','Skedee','A','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.331099,-96.777425,0,'2013-07-06 12:44:33',NULL,NULL),(62412,'74129','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.126438,-95.862391,0,'2013-07-06 12:44:33',NULL,NULL),(63617,'75832','P','Cayuga','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.958674,-95.973425,0,'2013-07-06 12:44:34',NULL,NULL),(63798,'75960','S','Moscow','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.921945,-94.936938,0,'2013-07-06 12:44:34',NULL,NULL),(69307,'83455','S','Vernon','N','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.606526,-111.128907,0,'2013-07-06 12:44:34',NULL,NULL),(71776,'87557','S','Ranches of Taos','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(75033,'93513','S','Big Pine','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.175394,-118.303999,0,'2013-07-06 12:44:34',NULL,NULL),(16524,'17268','S','Glen Forney','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(3901,'02452','S','North Waltham','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.398020,-71.220337,0,'2013-07-06 12:44:30',NULL,NULL),(34064,'38145','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142373,-90.050604,0,'2013-07-06 12:44:32',NULL,NULL),(51541,'59727','S','Divide','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.780438,-112.710053,0,'2013-07-06 12:44:33',NULL,NULL),(29083,'32259','S','Fruit Cove','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(69349,'83542','S','Lucile','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.535466,-116.317589,0,'2013-07-06 12:44:34',NULL,NULL),(48236,'55421','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(402,'00662','S','Haciendas de Isabela','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(6586,'05858','S','Victory','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.575000,-71.784722,0,'2013-07-06 12:44:30',NULL,NULL),(17986,'18621','S','Hunlock Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.226559,-76.014039,0,'2013-07-06 12:44:31',NULL,NULL),(21348,'22432','S','Burgess','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.868770,-76.341637,0,'2013-07-06 12:44:31',NULL,NULL),(66068,'78382','S','Lamar','N','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.022280,-97.099080,0,'2013-07-06 12:44:34',NULL,NULL),(66247,'78572','S','Granjeno','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(72611,'89415','S','Babbitt','N','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(63157,'75390','U','UT Sw Medical Center','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.842526,-96.701666,0,'2013-07-06 12:44:33',NULL,NULL),(69882,'84101','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756416,-111.899070,0,'2013-07-06 12:44:34',NULL,NULL),(71444,'87038','P','New Laguna','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.002693,-107.413459,0,'2013-07-06 12:44:34',NULL,NULL),(6738,'06079','P','Taconic','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.035556,-73.408333,0,'2013-07-06 12:44:30',NULL,NULL),(14560,'15214','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.481784,-80.018549,0,'2013-07-06 12:44:31',NULL,NULL),(52473,'60687','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.878579,-87.625823,0,'2013-07-06 12:44:33',NULL,NULL),(12806,'13250','U','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.122569,-76.132866,0,'2013-07-06 12:44:30',NULL,NULL),(41048,'46406','S','Brunswick','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.587301,-87.411577,0,'2013-07-06 12:44:32',NULL,NULL),(43796,'49056','S','Grand Jct','A','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.375171,-86.059363,0,'2013-07-06 12:44:32',NULL,NULL),(62511,'74401','S','Martin','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(66810,'79079','S','Twitty','A','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.216100,-100.245380,0,'2013-07-06 12:44:34',NULL,NULL),(68312,'81101','S','Stanley','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(1443,'00739','S','Urb Treasure Vly','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(11396,'11950','S','Manor Park','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.806599,-72.840193,0,'2013-07-06 12:44:30',NULL,NULL),(26273,'29014','S','Blackstock','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.573234,-80.987145,0,'2013-07-06 12:44:31',NULL,NULL),(25850,'28624','S','Denny','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.156660,-81.393840,0,'2013-07-06 12:44:31',NULL,NULL),(45801,'52171','S','Waucoma','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.058499,-91.990554,0,'2013-07-06 12:44:32',NULL,NULL),(45886,'52301','S','Marengo','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.797617,-92.081501,0,'2013-07-06 12:44:32',NULL,NULL),(51697,'60004','S','Arlington Heights','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.108547,-87.974705,0,'2013-07-06 12:44:33',NULL,NULL),(54031,'62460','S','Sand Barrens','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.591789,-87.646603,0,'2013-07-06 12:44:33',NULL,NULL),(75496,'94130','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.821576,-122.371703,0,'2013-07-06 12:44:34',NULL,NULL),(61253,'72353','P','Lambrook','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.398323,-90.866902,0,'2013-07-06 12:44:33',NULL,NULL),(16309,'17112','S','West Hanover','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.338060,-76.803780,0,'2013-07-06 12:44:31',NULL,NULL),(54090,'62526','S','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.875033,-88.956342,0,'2013-07-06 12:44:33',NULL,NULL),(52542,'60934','S','Emington','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.971773,-88.359505,0,'2013-07-06 12:44:33',NULL,NULL),(13996,'14514','S','North Chili','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.114248,-77.792506,0,'2013-07-06 12:44:31',NULL,NULL),(32564,'36115','S','Gunter A F S','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(50274,'57644','S','Meadow','D','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.291739,-102.295248,0,'2013-07-06 12:44:33',NULL,NULL),(47284,'54542','S','Alvin','A','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.840000,-88.660000,0,'2013-07-06 12:44:32',NULL,NULL),(72226,'88434','S','San Jon','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.263046,-103.265336,0,'2013-07-06 12:44:34',NULL,NULL),(76149,'95301','S','Atwater','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.349553,-120.616931,0,'2013-07-06 12:44:34',NULL,NULL),(76299,'95437','S','Redwood Lodge','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(76775,'95936','P','Downieville','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.561914,-120.825020,0,'2013-07-06 12:44:34',NULL,NULL),(23855,'26143','S','Limestone Hill','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(63697,'75880','U','Tenn Colony Prison Beto 1','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.835895,-95.839416,0,'2013-07-06 12:44:34',NULL,NULL),(65912,'78236','S','Security svc','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(76932,'96019','S','Central Valley','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.681560,-122.377440,0,'2013-07-06 12:44:34',NULL,NULL),(3872,'02359','S','Pembroke','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.063591,-70.805297,0,'2013-07-06 12:44:30',NULL,NULL),(38158,'43149','S','Rockbridge','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.520860,-82.585680,0,'2013-07-06 12:44:32',NULL,NULL),(5131,'04412','S','Brewer','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.785715,-68.754256,0,'2013-07-06 12:44:30',NULL,NULL),(35016,'39151','P','Puckett','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.101045,-89.787095,0,'2013-07-06 12:44:32',NULL,NULL),(31644,'34734','S','Gotha','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.536246,-81.525220,0,'2013-07-06 12:44:32',NULL,NULL),(30917,'33708','S','N Redngtn Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(24249,'26801','S','Baker','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.066706,-78.787850,0,'2013-07-06 12:44:31',NULL,NULL),(44866,'50305','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602146,-93.631088,0,'2013-07-06 12:44:32',NULL,NULL),(49328,'56554','S','Lake Park','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.826541,-96.081630,0,'2013-07-06 12:44:33',NULL,NULL),(49499,'56662','S','Trelipe','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.846424,-93.901398,0,'2013-07-06 12:44:33',NULL,NULL),(60896,'72069','S','Raymond','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(61037,'72118','S','Crystal Hill','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(71544,'87176','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.999579,-106.338211,0,'2013-07-06 12:44:34',NULL,NULL),(35896,'40009','S','Bradfordsvlle','A','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.421874,-85.166763,0,'2013-07-06 12:44:32',NULL,NULL),(43877,'49204','P','Jackson','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.330066,-84.515206,0,'2013-07-06 12:44:32',NULL,NULL),(14142,'14708','S','Alma','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.013652,-78.025114,0,'2013-07-06 12:44:31',NULL,NULL),(13377,'13738','P','Blodgett Mills','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.565864,-76.125222,0,'2013-07-06 12:44:31',NULL,NULL),(18689,'19188','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963336,-75.159526,0,'2013-07-06 12:44:31',NULL,NULL),(19554,'20202','U','Dept Education','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896694,-77.028060,0,'2013-07-06 12:44:31',NULL,NULL),(63660,'75849','P','Latexo','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.396803,-95.477311,0,'2013-07-06 12:44:34',NULL,NULL),(69339,'83536','S','Kamiah','D','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.225754,-116.027528,0,'2013-07-06 12:44:34',NULL,NULL),(73637,'91423','S','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151353,-118.435422,0,'2013-07-06 12:44:34',NULL,NULL),(78340,'98004','S','Clyde Hill','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(34590,'38744','S','Glen Allan','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.035500,-91.016167,0,'2013-07-06 12:44:32',NULL,NULL),(52072,'60399','U','Bensenville','A','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.958880,-87.941435,0,'2013-07-06 12:44:33',NULL,NULL),(1495,'00751','S','Sect Campito','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(51029,'58718','S','Blaisdell','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328239,-101.921232,0,'2013-07-06 12:44:33',NULL,NULL),(13183,'13617','S','North Russell','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(34034,'38133','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.206829,-89.791238,0,'2013-07-06 12:44:32',NULL,NULL),(41141,'46680','P','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.632227,-86.250041,0,'2013-07-06 12:44:32',NULL,NULL),(67120,'79741','S','Goldsmith','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.983410,-102.612281,0,'2013-07-06 12:44:34',NULL,NULL),(415,'00662','S','Repto Miraflores','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(39913,'45218','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.269057,-84.521832,0,'2013-07-06 12:44:32',NULL,NULL),(38879,'44106','S','Cleveland Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.505132,-81.607134,0,'2013-07-06 12:44:32',NULL,NULL),(3922,'02461','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.314739,-71.208012,0,'2013-07-06 12:44:30',NULL,NULL),(22878,'24572','S','Madison Hts','A','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.447984,-79.112687,0,'2013-07-06 12:44:31',NULL,NULL),(19454,'20121','S','Centreville','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.818190,-77.468677,0,'2013-07-06 12:44:31',NULL,NULL),(8300,'08023','P','Deepwater','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.685875,-75.490960,0,'2013-07-06 12:44:30',NULL,NULL),(47916,'55110','S','Vadnais Hts','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(50509,'58074','P','Wahpeton','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.281699,-96.609083,0,'2013-07-06 12:44:33',NULL,NULL),(57617,'67127','S','Protection','D','Comanche','20033','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.198884,-99.485702,0,'2013-07-06 12:44:33',NULL,NULL),(60876,'72063','S','Hattieville','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.289780,-92.784000,0,'2013-07-06 12:44:33',NULL,NULL),(67755,'80621','S','Wattenburg','A','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.099919,-104.805331,0,'2013-07-06 12:44:34',NULL,NULL),(34283,'38482','S','Santa Fe','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.756828,-87.167110,0,'2013-07-06 12:44:32',NULL,NULL),(62749,'74843','S','Fitzhugh','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.660154,-96.766516,0,'2013-07-06 12:44:33',NULL,NULL),(77226,'96502','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(49786,'57104','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.556226,-96.734063,0,'2013-07-06 12:44:33',NULL,NULL),(1178,'00727','S','Valle Tolima','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(11820,'12236','U','Audit and Control Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651877,-73.758413,0,'2013-07-06 12:44:30',NULL,NULL),(31425,'34260','P','Manasota','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.421461,-82.539875,0,'2013-07-06 12:44:32',NULL,NULL),(35538,'39561','S','McHenry','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.688163,-89.180838,0,'2013-07-06 12:44:32',NULL,NULL),(7877,'07510','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.910846,-74.172169,0,'2013-07-06 12:44:30',NULL,NULL),(46204,'52755','S','River Junction','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.483617,-91.428653,0,'2013-07-06 12:44:32',NULL,NULL),(14671,'15240','P','Veterans Hospital','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445977,-79.962428,0,'2013-07-06 12:44:31',NULL,NULL),(46047,'52566','S','Kirkville','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.119729,-92.464299,0,'2013-07-06 12:44:32',NULL,NULL),(62991,'75151','P','Corsicana','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053898,-96.523430,0,'2013-07-06 12:44:33',NULL,NULL),(26483,'29161','S','Timmonsville','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.119660,-79.973820,0,'2013-07-06 12:44:31',NULL,NULL),(41785,'47307','P','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.177694,-85.395063,0,'2013-07-06 12:44:32',NULL,NULL),(19420,'20091','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904862,-77.026188,0,'2013-07-06 12:44:31',NULL,NULL),(1174,'00727','S','Urb Mirador de Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(49187,'56441','S','Crosby','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.482415,-93.958313,0,'2013-07-06 12:44:33',NULL,NULL),(55519,'63787','S','Zalma','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.131892,-90.084809,0,'2013-07-06 12:44:33',NULL,NULL),(37442,'41837','S','Mayking','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.106826,-82.767907,0,'2013-07-06 12:44:32',NULL,NULL),(76959,'96044','S','Hilt','N','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.939820,-122.530020,0,'2013-07-06 12:44:34',NULL,NULL),(64748,'76909','U','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.446944,-100.450967,0,'2013-07-06 12:44:34',NULL,NULL),(27555,'30257','S','Milner','D','Lamar','13171','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.128913,-84.198621,0,'2013-07-06 12:44:31',NULL,NULL),(46678,'53744','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.015628,-89.414521,0,'2013-07-06 12:44:32',NULL,NULL),(55568,'63873','S','Boekerton','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.430781,-89.697849,0,'2013-07-06 12:44:33',NULL,NULL),(75160,'93586','P','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.648854,-118.219319,0,'2013-07-06 12:44:34',NULL,NULL),(25674,'28512','S','Indian Beach','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(18305,'19018','S','Primos','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(54606,'62910','S','Hamletsburg','A','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.125868,-88.629383,0,'2013-07-06 12:44:33',NULL,NULL),(17799,'18371','S','Lehman','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.093333,-75.002222,0,'2013-07-06 12:44:31',NULL,NULL),(55676,'64051','P','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.093706,-94.417679,0,'2013-07-06 12:44:33',NULL,NULL),(11005,'11554','S','East Meadow','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.715698,-73.556154,0,'2013-07-06 12:44:30',NULL,NULL),(39180,'44315','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.037729,-81.483085,0,'2013-07-06 12:44:32',NULL,NULL),(74655,'92840','S','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.786931,-117.927259,0,'2013-07-06 12:44:34',NULL,NULL),(71378,'87004','S','El Llanito','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(67793,'80727','S','Eckley','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.026993,-102.521039,0,'2013-07-06 12:44:34',NULL,NULL),(4009,'02554','S','Nantucket','D','Nantucket','25019','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.275552,-70.091002,0,'2013-07-06 12:44:30',NULL,NULL),(54889,'63069','S','La Barque Crk','A','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.491435,-90.765094,0,'2013-07-06 12:44:33',NULL,NULL),(39810,'45140','S','Steelville','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(35347,'39440','S','Antioch','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(41669,'47161','S','New Salisbury','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.302477,-86.097081,0,'2013-07-06 12:44:32',NULL,NULL),(50273,'57644','S','Glad Valley','A','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.291739,-102.295248,0,'2013-07-06 12:44:33',NULL,NULL),(35430,'39475','S','Pine Ridge','N','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.065616,-89.289840,0,'2013-07-06 12:44:32',NULL,NULL),(13291,'13662','S','Massena Springs','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.918160,-74.935980,0,'2013-07-06 12:44:30',NULL,NULL),(54819,'63024','P','Ballwin','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.596264,-90.543221,0,'2013-07-06 12:44:33',NULL,NULL),(63004,'75157','P','Rosser','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.583808,-96.450152,0,'2013-07-06 12:44:33',NULL,NULL),(31324,'34133','P','Bonita Spgs','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.382005,-81.710252,0,'2013-07-06 12:44:32',NULL,NULL),(49929,'57325','S','Bijou Hills','N','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.806473,-99.327811,0,'2013-07-06 12:44:33',NULL,NULL),(6383,'05701','S','Glen','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(46131,'52647','P','Olds','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.119622,-91.542675,0,'2013-07-06 12:44:32',NULL,NULL),(48954,'56175','S','Amiret','A','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.234148,-95.619944,0,'2013-07-06 12:44:33',NULL,NULL),(15567,'16645','P','Glen Hope','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.794730,-78.501098,0,'2013-07-06 12:44:31',NULL,NULL),(55045,'63143','S','Maplewood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.741558,-90.362467,0,'2013-07-06 12:44:33',NULL,NULL),(55811,'64144','U','Philatelic Distribution Ctr','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.143477,-94.571588,0,'2013-07-06 12:44:33',NULL,NULL),(34343,'38577','S','Pall Mall','D','Fentress','47049','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.570466,-84.950492,0,'2013-07-06 12:44:32',NULL,NULL),(25634,'28465','S','Oak Island','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(37883,'42602','S','Aaron','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(65140,'77385','S','Shenandoah','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.185643,-95.428944,0,'2013-07-06 12:44:34',NULL,NULL),(64677,'76827','S','Brookesmith','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.519708,-99.137923,0,'2013-07-06 12:44:34',NULL,NULL),(24984,'27855','S','Murfreesboro','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.437143,-77.097324,0,'2013-07-06 12:44:31',NULL,NULL),(29445,'32701','S','Altamonte Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.662995,-81.372939,0,'2013-07-06 12:44:32',NULL,NULL),(48869,'56083','S','Sanborn','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.211909,-95.127962,0,'2013-07-06 12:44:33',NULL,NULL),(10492,'10960','S','Grandview','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(54537,'62883','S','Scheller','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.167601,-89.094075,0,'2013-07-06 12:44:33',NULL,NULL),(58848,'69134','S','Elsie','D','Perkins','31135','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.851137,-101.366563,0,'2013-07-06 12:44:33',NULL,NULL),(56551,'65462','S','Edgar Springs','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.750210,-91.912584,0,'2013-07-06 12:44:33',NULL,NULL),(74839,'93242','S','Laton','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.438987,-119.716083,0,'2013-07-06 12:44:34',NULL,NULL),(74377,'92504','S','Woodcrest','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.924842,-117.397533,0,'2013-07-06 12:44:34',NULL,NULL),(18322,'19023','S','Colwyn','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.917217,-75.266969,0,'2013-07-06 12:44:31',NULL,NULL),(46640,'53594','S','Waterloo','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.177186,-88.982394,0,'2013-07-06 12:44:32',NULL,NULL),(23814,'26056','P','New Manchstr','N','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.532923,-80.580463,0,'2013-07-06 12:44:31',NULL,NULL),(73832,'91776','S','San Gabriel','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.089832,-118.092812,0,'2013-07-06 12:44:34',NULL,NULL),(68326,'81120','S','Ortiz','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(40696,'46076','S','Windfall','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.363274,-85.957340,0,'2013-07-06 12:44:32',NULL,NULL),(41039,'46393','P','Wheeler','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.512642,-87.177875,0,'2013-07-06 12:44:32',NULL,NULL),(45852,'52233','S','Hiawatha','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.040137,-91.676199,0,'2013-07-06 12:44:32',NULL,NULL),(8583,'08220','P','Leeds Point','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.499150,-74.432534,0,'2013-07-06 12:44:30',NULL,NULL),(21212,'22205','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.884663,-77.140211,0,'2013-07-06 12:44:31',NULL,NULL),(56960,'66110','P','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.113228,-94.694979,0,'2013-07-06 12:44:33',NULL,NULL),(60007,'71334','S','Ferriday','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(38700,'44001','S','Vermilion','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(31951,'35209','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.460200,-86.809200,0,'2013-07-06 12:44:32',NULL,NULL),(17126,'17776','S','English Ctr','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.331890,-77.344196,0,'2013-07-06 12:44:31',NULL,NULL),(34021,'38128','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.219361,-89.925899,0,'2013-07-06 12:44:32',NULL,NULL),(77224,'96447','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(36839,'41074','S','Bellevue','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.110380,-84.468431,0,'2013-07-06 12:44:32',NULL,NULL),(52828,'61310','S','Binghampton','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.704186,-89.342017,0,'2013-07-06 12:44:33',NULL,NULL),(39687,'45030','S','Harrison','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.251160,-84.739620,0,'2013-07-06 12:44:32',NULL,NULL),(664,'00683','S','Repto Suris','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(20647,'21223','S','Franklin','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.280260,-76.650540,0,'2013-07-06 12:44:31',NULL,NULL),(18751,'19344','S','Honey Brook','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.084833,-75.898086,0,'2013-07-06 12:44:31',NULL,NULL),(25174,'28043','S','Alexander Mls','A','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.333268,-81.867460,0,'2013-07-06 12:44:31',NULL,NULL),(55449,'63703','S','Cape Girardeau','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.296342,-89.537946,0,'2013-07-06 12:44:33',NULL,NULL),(45298,'50831','P','Arispe','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.985255,-94.071276,0,'2013-07-06 12:44:32',NULL,NULL),(37007,'41224','S','Inez','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.864560,-82.514588,0,'2013-07-06 12:44:32',NULL,NULL),(12812,'13290','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.050110,-76.150573,0,'2013-07-06 12:44:30',NULL,NULL),(32471,'36037','S','Greenville','D','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.819462,-86.607363,0,'2013-07-06 12:44:32',NULL,NULL),(58515,'68776','S','South Sioux City','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.471705,-96.414132,0,'2013-07-06 12:44:33',NULL,NULL),(39529,'44826','S','East Townsend','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.236226,-82.484275,0,'2013-07-06 12:44:32',NULL,NULL),(345,'00656','S','Guayanilla','D','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(67390,'80123','S','Grants Ranch','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(65527,'77726','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.091114,-94.145957,0,'2013-07-06 12:44:34',NULL,NULL),(63993,'76112','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.749775,-97.211509,0,'2013-07-06 12:44:34',NULL,NULL),(20115,'20714','S','North Beach','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.711654,-76.537211,0,'2013-07-06 12:44:31',NULL,NULL),(19632,'20254','U','Social Securtiy Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884967,-77.020848,0,'2013-07-06 12:44:31',NULL,NULL),(47474,'54742','S','Fall Creek','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.754625,-91.331294,0,'2013-07-06 12:44:32',NULL,NULL),(75357,'93921','P','Carmel','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.562001,-121.896409,0,'2013-07-06 12:44:34',NULL,NULL),(24040,'26410','S','Newburg','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.400981,-79.824788,0,'2013-07-06 12:44:31',NULL,NULL),(59547,'70822','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.450296,-91.129317,0,'2013-07-06 12:44:33',NULL,NULL),(59689,'71071','S','Porterville','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.938210,-93.434653,0,'2013-07-06 12:44:33',NULL,NULL),(60368,'71477','P','Tioga','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.394424,-92.434818,0,'2013-07-06 12:44:33',NULL,NULL),(42902,'48103','S','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.270780,-83.808660,0,'2013-07-06 12:44:32',NULL,NULL),(39543,'44839','S','Huron','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388818,-82.561774,0,'2013-07-06 12:44:32',NULL,NULL),(68943,'82935','S','Mc Kinnon','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.512073,-109.465736,0,'2013-07-06 12:44:34',NULL,NULL),(54326,'62756','U','IL Sec State','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797359,-89.654776,0,'2013-07-06 12:44:33',NULL,NULL),(65081,'77353','P','Magnolia','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.211660,-95.757010,0,'2013-07-06 12:44:34',NULL,NULL),(56649,'65616','S','Branson','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(76430,'95589','S','Shelter Cove','N','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.088692,-124.048710,0,'2013-07-06 12:44:34',NULL,NULL),(76179,'95333','S','Le Grand','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.239816,-120.263215,0,'2013-07-06 12:44:34',NULL,NULL),(48260,'55427','S','New Hope','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996340,-93.379980,0,'2013-07-06 12:44:33',NULL,NULL),(65673,'77984','S','Mount Olive','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.432036,-97.175420,0,'2013-07-06 12:44:34',NULL,NULL),(70946,'85641','S','Vail','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(6926,'06156','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.758950,-72.732086,0,'2013-07-06 12:44:30',NULL,NULL),(26801,'29464','S','Mt Pleasant','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.820260,-79.846061,0,'2013-07-06 12:44:31',NULL,NULL),(31688,'34787','S','Oakland','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.532903,-81.590667,0,'2013-07-06 12:44:32',NULL,NULL),(33627,'37669','U','Kingsport Book','N','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.529122,-82.556123,0,'2013-07-06 12:44:32',NULL,NULL),(14019,'14537','P','Port Gibson','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.035448,-77.158404,0,'2013-07-06 12:44:31',NULL,NULL),(38078,'43070','P','Rosewood','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.217305,-83.959489,0,'2013-07-06 12:44:32',NULL,NULL),(14828,'15428','S','Dawson','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.071850,-79.669366,0,'2013-07-06 12:44:31',NULL,NULL),(16506,'17264','S','Selea','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.174380,-77.988180,0,'2013-07-06 12:44:31',NULL,NULL),(27594,'30293','S','Woodbury','D','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.974674,-84.588014,0,'2013-07-06 12:44:31',NULL,NULL),(64556,'76655','S','Golinda','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.422120,-97.237920,0,'2013-07-06 12:44:34',NULL,NULL),(39065,'44202','S','Aurora','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.314774,-81.345613,0,'2013-07-06 12:44:32',NULL,NULL),(18602,'19141','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.034650,-75.144766,0,'2013-07-06 12:44:31',NULL,NULL),(48417,'55602','S','Toimi','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.309551,-91.835899,0,'2013-07-06 12:44:33',NULL,NULL),(52425,'60652','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.743986,-87.712805,0,'2013-07-06 12:44:33',NULL,NULL),(29966,'33081','P','Hillcrest','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.017272,-80.199990,0,'2013-07-06 12:44:32',NULL,NULL),(33464,'37326','P','Ducktown','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.037585,-84.380831,0,'2013-07-06 12:44:32',NULL,NULL),(13548,'13830','S','Preston','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(58496,'68763','S','Oneill','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.456401,-98.648879,0,'2013-07-06 12:44:33',NULL,NULL),(67591,'80419','U','Golden','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.742698,-105.216726,0,'2013-07-06 12:44:34',NULL,NULL),(76689,'95820','S','Fruitridge','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.532877,-121.449044,0,'2013-07-06 12:44:34',NULL,NULL),(54143,'62565','S','Middlesworth','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(37906,'42633','S','Frisby','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(36124,'40223','S','Blue Rdg Mnr','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(31695,'34797','S','Yalaha','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.742227,-81.820758,0,'2013-07-06 12:44:32',NULL,NULL),(53845,'62321','S','Denver','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(4871,'04030','S','East Waterboro','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.581317,-70.709279,0,'2013-07-06 12:44:30',NULL,NULL),(32214,'35565','S','Haleyville','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.233891,-87.618593,0,'2013-07-06 12:44:32',NULL,NULL),(17304,'17853','S','Mount Pleasant Mills','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(34282,'38481','S','St Joseph','N','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.039736,-87.505697,0,'2013-07-06 12:44:32',NULL,NULL),(36274,'40337','S','Jeffersonville','D','Montgomery','21173','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.951348,-83.863945,0,'2013-07-06 12:44:32',NULL,NULL),(2094,'00923','S','Bo Capetillo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(22837,'24521','S','Amherst','D','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.573238,-79.057954,0,'2013-07-06 12:44:31',NULL,NULL),(40522,'45826','P','Chickasaw','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.434324,-84.493555,0,'2013-07-06 12:44:32',NULL,NULL),(41455,'46901','S','Kokomo','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.490485,-86.147278,0,'2013-07-06 12:44:32',NULL,NULL),(48703,'55942','P','Homer','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.982101,-91.637823,0,'2013-07-06 12:44:33',NULL,NULL),(58389,'68620','S','Albion','D','Boone','31011','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.709480,-98.002200,0,'2013-07-06 12:44:33',NULL,NULL),(14826,'15425','S','S Connelsvl','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.027320,-79.588740,0,'2013-07-06 12:44:31',NULL,NULL),(45792,'52166','P','St Lucas','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.065027,-91.932103,0,'2013-07-06 12:44:32',NULL,NULL),(24043,'26415','S','Greenwood','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.285557,-80.967156,0,'2013-07-06 12:44:31',NULL,NULL),(12986,'13407','S','Fort Herkimer','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.991140,-74.980560,0,'2013-07-06 12:44:30',NULL,NULL),(2916,'01004','P','Amherst','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.383945,-72.511834,0,'2013-07-06 12:44:30',NULL,NULL),(25185,'28053','P','Gastonia','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.192766,-81.235852,0,'2013-07-06 12:44:31',NULL,NULL),(12562,'13054','S','Durhamville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.141800,-75.670020,0,'2013-07-06 12:44:30',NULL,NULL),(8610,'08241','S','Port Republic','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.522108,-74.511826,0,'2013-07-06 12:44:30',NULL,NULL),(1133,'00725','S','Villa Maria','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(14530,'15205','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437059,-80.074137,0,'2013-07-06 12:44:31',NULL,NULL),(12078,'12551','P','Newburgh','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.540771,-74.046731,0,'2013-07-06 12:44:30',NULL,NULL),(9575,'10026','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(7737,'07206','S','Elizabethport','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.654517,-74.189804,0,'2013-07-06 12:44:30',NULL,NULL),(46387,'53147','S','Lake Geneva','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.590378,-88.439640,0,'2013-07-06 12:44:32',NULL,NULL),(73661,'91507','P','Magnolia Park','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.168685,-118.347797,0,'2013-07-06 12:44:34',NULL,NULL),(38297,'43344','S','Richwood','D','Union','39159','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.453611,-83.455556,0,'2013-07-06 12:44:32',NULL,NULL),(47287,'54542','S','Popple River','N','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.840000,-88.660000,0,'2013-07-06 12:44:32',NULL,NULL),(20855,'21659','S','Brookview','A','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.575555,-75.815263,0,'2013-07-06 12:44:31',NULL,NULL),(2224,'00926','S','Urb El Escorial','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(1470,'00745','S','Urb Los Arboles','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(36710,'41018','S','Edgewood','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.009027,-84.598071,0,'2013-07-06 12:44:32',NULL,NULL),(62686,'74726','S','Armstrong','A','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.016496,-96.139454,0,'2013-07-06 12:44:33',NULL,NULL),(76355,'95485','S','Upper Lake','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.157111,-122.905787,0,'2013-07-06 12:44:34',NULL,NULL),(55609,'63954','S','Neelyville','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.571386,-90.476614,0,'2013-07-06 12:44:33',NULL,NULL),(63289,'75559','S','Dalby Springs','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(21863,'23149','S','Glenns','N','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.578281,-76.606448,0,'2013-07-06 12:44:31',NULL,NULL),(2325,'00933','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.470198,-66.107908,0,'2013-07-06 12:44:30',NULL,NULL),(1310,'00735','S','Ceiba','D','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(3878,'02364','S','Rocky Nook','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',41.979540,-70.745100,0,'2013-07-06 12:44:30',NULL,NULL),(21850,'23139','S','Powhatan','D','Powhatan','51145','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544219,-77.877814,0,'2013-07-06 12:44:31',NULL,NULL),(26133,'28734','S','Higdonville','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(40737,'46131','S','Bengal','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.488252,-86.054873,0,'2013-07-06 12:44:32',NULL,NULL),(60210,'71422','S','Dodson','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.066880,-92.645400,0,'2013-07-06 12:44:33',NULL,NULL),(61127,'72156','S','Arthur','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.275653,-92.675788,0,'2013-07-06 12:44:33',NULL,NULL),(64415,'76549','S','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.119841,-97.729720,0,'2013-07-06 12:44:34',NULL,NULL),(66652,'78847','U','Carolina Redemption Services','N','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.375719,-100.895923,0,'2013-07-06 12:44:34',NULL,NULL),(78347,'98007','S','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.612028,-122.141410,0,'2013-07-06 12:44:34',NULL,NULL),(33697,'37757','S','Jacksboro','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.331839,-84.179659,0,'2013-07-06 12:44:32',NULL,NULL),(47109,'54448','S','Ltl Chicago','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.930712,-89.834421,0,'2013-07-06 12:44:32',NULL,NULL),(44387,'49802','S','Iron Mountain','A','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.818797,-88.067829,0,'2013-07-06 12:44:32',NULL,NULL),(9167,'09347','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(17916,'18458','S','Shohola','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.417725,-74.913678,0,'2013-07-06 12:44:31',NULL,NULL),(29289,'32506','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.433325,-87.318561,0,'2013-07-06 12:44:32',NULL,NULL),(22812,'24484','S','Bolar','A','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.217222,-79.676667,0,'2013-07-06 12:44:31',NULL,NULL),(77789,'97131','S','Nehalem','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.720000,-123.859980,0,'2013-07-06 12:44:34',NULL,NULL),(74950,'93412','P','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.311680,-120.834780,0,'2013-07-06 12:44:34',NULL,NULL),(73561,'91364','S','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.153026,-118.602986,0,'2013-07-06 12:44:34',NULL,NULL),(67865,'80828','S','Limon','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.261367,-103.688061,0,'2013-07-06 12:44:34',NULL,NULL),(63763,'75944','S','Etoile','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.373726,-94.430148,0,'2013-07-06 12:44:34',NULL,NULL),(43647,'48841','S','Henderson','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.100242,-84.227445,0,'2013-07-06 12:44:32',NULL,NULL),(46036,'52556','S','Perlee','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(4807,'03887','S','Union','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.462117,-71.075110,0,'2013-07-06 12:44:30',NULL,NULL),(38926,'44122','S','Highland Hls','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(43840,'49097','S','Vicksburg','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.120191,-85.506280,0,'2013-07-06 12:44:32',NULL,NULL),(45354,'50983','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582136,-93.638733,0,'2013-07-06 12:44:32',NULL,NULL),(46792,'53965','S','Wisconsin Dells','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.727182,-89.759168,0,'2013-07-06 12:44:32',NULL,NULL),(58910,'69221','S','Wood Lake','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.630562,-100.298622,0,'2013-07-06 12:44:33',NULL,NULL),(66393,'78624','S','Tivydale','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(67520,'80244','U','Us West Communications','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.749741,-104.991002,0,'2013-07-06 12:44:34',NULL,NULL),(69802,'84069','S','Clover','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.346188,-112.454949,0,'2013-07-06 12:44:34',NULL,NULL),(33404,'37228','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.194411,-86.800170,0,'2013-07-06 12:44:32',NULL,NULL),(60765,'72011','S','Bauxite','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.532579,-92.477290,0,'2013-07-06 12:44:33',NULL,NULL),(58634,'68866','S','Sartoria','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.971884,-99.085142,0,'2013-07-06 12:44:33',NULL,NULL),(51569,'59756','P','Warm Springs','D','Deer Lodge','30023','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.221341,-112.793192,0,'2013-07-06 12:44:33',NULL,NULL),(47252,'54521','S','Clearwater Lake','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.910500,-89.224500,0,'2013-07-06 12:44:32',NULL,NULL),(14735,'15295','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.442411,-79.996664,0,'2013-07-06 12:44:31',NULL,NULL),(32254,'35617','P','Cloverdale','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.936875,-87.771703,0,'2013-07-06 12:44:32',NULL,NULL),(79724,'99214','P','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.711392,-117.206773,0,'2013-07-06 12:44:34',NULL,NULL),(72419,'89053','P','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.980158,-115.059027,0,'2013-07-06 12:44:34',NULL,NULL),(18924,'19501','P','Adamstown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.244709,-76.056831,0,'2013-07-06 12:44:31',NULL,NULL),(30803,'33610','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.992647,-82.383708,0,'2013-07-06 12:44:32',NULL,NULL),(30399,'33322','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.150168,-80.273686,0,'2013-07-06 12:44:32',NULL,NULL),(40464,'45760','S','Middleport','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.006705,-82.080090,0,'2013-07-06 12:44:32',NULL,NULL),(67025,'79536','S','Merkel','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.449860,-99.988740,0,'2013-07-06 12:44:34',NULL,NULL),(2046,'00918','S','Urb Roosevelt','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(35961,'40068','S','Smithfield','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.357433,-85.320685,0,'2013-07-06 12:44:32',NULL,NULL),(6659,'06025','P','E Glastonbury','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.690889,-72.534917,0,'2013-07-06 12:44:30',NULL,NULL),(15396,'16333','P','Ludlow','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.734068,-78.919513,0,'2013-07-06 12:44:31',NULL,NULL),(10528,'10985','S','Thompson Rdg','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.626920,-74.634300,0,'2013-07-06 12:44:30',NULL,NULL),(35277,'39367','S','Wboro','N','Wayne','28153','Mississippi','MS','28','0000','662','Central',-6.0,'Y',31.677923,-88.642050,0,'2013-07-06 12:44:32',NULL,NULL),(29981,'33093','P','Margate','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.252723,-80.209522,0,'2013-07-06 12:44:32',NULL,NULL),(71070,'85902','P','Show Low','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.252928,-110.029914,0,'2013-07-06 12:44:34',NULL,NULL),(78302,'97903','S','Brogan','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.246514,-117.515103,0,'2013-07-06 12:44:34',NULL,NULL),(4165,'02790','S','Horseneck Beach','N','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.607558,-71.083877,0,'2013-07-06 12:44:30',NULL,NULL),(38444,'43571','S','Whitehouse','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.521573,-83.813173,0,'2013-07-06 12:44:32',NULL,NULL),(39181,'44315','U','Lockhead Martin','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.037729,-81.483085,0,'2013-07-06 12:44:32',NULL,NULL),(78034,'97434','S','Culp Creek','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.739244,-122.888624,0,'2013-07-06 12:44:34',NULL,NULL),(64169,'76226','S','Northlake','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.104830,-97.164815,0,'2013-07-06 12:44:34',NULL,NULL),(27855,'30436','S','Santa Claus','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.201196,-82.323239,0,'2013-07-06 12:44:31',NULL,NULL),(13528,'13820','S','Milford Center','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.481020,-75.070440,0,'2013-07-06 12:44:31',NULL,NULL),(49748,'57059','S','Scotland','D','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.138096,-97.725804,0,'2013-07-06 12:44:33',NULL,NULL),(58091,'68104','S','Benson','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.291657,-95.996811,0,'2013-07-06 12:44:33',NULL,NULL),(60955,'72101','S','Wiville','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(10778,'11366','S','Fresh Meadows','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.729445,-73.797794,0,'2013-07-06 12:44:30',NULL,NULL),(57098,'66219','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.965992,-94.764646,0,'2013-07-06 12:44:33',NULL,NULL),(69522,'83725','U','Boise State University','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.605516,-116.199180,0,'2013-07-06 12:44:34',NULL,NULL),(16494,'17257','S','Pinola','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(47584,'54854','S','Maple','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.641739,-91.676601,0,'2013-07-06 12:44:33',NULL,NULL),(43845,'49102','S','Berrien Center','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.954134,-86.276203,0,'2013-07-06 12:44:32',NULL,NULL),(69172,'83325','S','Eden','D','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.602980,-114.221090,0,'2013-07-06 12:44:34',NULL,NULL),(7802,'07438','S','Jefferson Twp','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.033460,-74.499840,0,'2013-07-06 12:44:30',NULL,NULL),(59976,'71324','P','Chase','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.094945,-91.700927,0,'2013-07-06 12:44:33',NULL,NULL),(60086,'71357','S','Somerset','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(59311,'70517','S','Butte Larose','A','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.279139,-91.898037,0,'2013-07-06 12:44:33',NULL,NULL),(70112,'84184','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.679483,-111.954813,0,'2013-07-06 12:44:34',NULL,NULL),(62736,'74829','S','Boley','D','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.499313,-96.485265,0,'2013-07-06 12:44:33',NULL,NULL),(27404,'30092','S','Berkeley Lake','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.973773,-84.238127,0,'2013-07-06 12:44:31',NULL,NULL),(40789,'46168','S','Cartersburg','A','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.709427,-86.395053,0,'2013-07-06 12:44:32',NULL,NULL),(36496,'40815','S','Crummies','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751998,-83.268360,0,'2013-07-06 12:44:32',NULL,NULL),(71278,'86434','S','Shipley','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.574300,-113.492100,0,'2013-07-06 12:44:34',NULL,NULL),(68187,'81024','S','Boncarbo','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.217437,-104.698315,0,'2013-07-06 12:44:34',NULL,NULL),(63239,'75474','S','Quinlan','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.910912,-96.135472,0,'2013-07-06 12:44:33',NULL,NULL),(18182,'18928','P','Holicong','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.337249,-75.047898,0,'2013-07-06 12:44:31',NULL,NULL),(24188,'26636','S','Rosedale','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.782250,-80.899765,0,'2013-07-06 12:44:31',NULL,NULL),(37966,'42724','S','Stephensburg','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.671855,-86.025831,0,'2013-07-06 12:44:32',NULL,NULL),(9812,'10111','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(37080,'41332','S','Helechawa','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.796026,-83.456314,0,'2013-07-06 12:44:32',NULL,NULL),(63300,'75561','S','Victory City','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(46364,'53115','S','Delavan','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.613597,-88.628941,0,'2013-07-06 12:44:32',NULL,NULL),(44475,'49895','S','Wetmore','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.374729,-86.618286,0,'2013-07-06 12:44:32',NULL,NULL),(64654,'76801','S','Brownwood','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(48208,'55407','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.940372,-93.252678,0,'2013-07-06 12:44:33',NULL,NULL),(9828,'10114','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(19965,'20588','U','DHS','D','Howard','24027','Maryland','MD','24','8840','202','Eastern',-5.0,'Y',38.916044,-77.056499,0,'2013-07-06 12:44:31',NULL,NULL),(48300,'55439','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.875459,-93.374350,0,'2013-07-06 12:44:33',NULL,NULL),(68725,'82083','S','Arlington','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.782089,-105.885219,0,'2013-07-06 12:44:34',NULL,NULL),(72458,'89116','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.152678,-115.113609,0,'2013-07-06 12:44:34',NULL,NULL),(27391,'30083','S','Stone Mtn','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.789125,-84.199181,0,'2013-07-06 12:44:31',NULL,NULL),(20547,'21117','S','Owings Mills','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.428406,-76.769758,0,'2013-07-06 12:44:31',NULL,NULL),(41610,'47119','S','Floyds Knobs','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.356200,-85.904760,0,'2013-07-06 12:44:32',NULL,NULL),(51625,'59846','S','Huson','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.056338,-114.368199,0,'2013-07-06 12:44:33',NULL,NULL),(27867,'30442','S','Emmalane','N','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(72179,'88349','P','Sunspot','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.789592,-105.817602,0,'2013-07-06 12:44:34',NULL,NULL),(61164,'72182','P','Wright','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.445490,-92.038390,0,'2013-07-06 12:44:33',NULL,NULL),(74146,'92255','P','Palm Desert','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.746759,-116.366511,0,'2013-07-06 12:44:34',NULL,NULL),(59402,'70634','S','Deridder','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.849546,-93.293114,0,'2013-07-06 12:44:33',NULL,NULL),(14721,'15278','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.511937,-80.079685,0,'2013-07-06 12:44:31',NULL,NULL),(56400,'65244','S','Clifton Hill','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.425930,-92.665220,0,'2013-07-06 12:44:33',NULL,NULL),(75105,'93543','S','Sun Village','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.520996,-117.951674,0,'2013-07-06 12:44:34',NULL,NULL),(70517,'85001','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.449215,-112.069209,0,'2013-07-06 12:44:34',NULL,NULL),(69041,'83221','S','Taber','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(63612,'75803','S','Palestine','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.755991,-95.638246,0,'2013-07-06 12:44:34',NULL,NULL),(17643,'18068','P','Old Zionsvlle','A','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.487427,-75.521144,0,'2013-07-06 12:44:31',NULL,NULL),(11641,'12123','S','Nassau','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.521046,-73.625267,0,'2013-07-06 12:44:30',NULL,NULL),(6403,'05735','S','Castleton State College','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627980,-73.170780,0,'2013-07-06 12:44:30',NULL,NULL),(58501,'68765','S','Osmond','D','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.344594,-97.561580,0,'2013-07-06 12:44:33',NULL,NULL),(30782,'33593','P','Trilby','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.458610,-82.195910,0,'2013-07-06 12:44:32',NULL,NULL),(32042,'35246','U','Regions Bank','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519522,-86.801880,0,'2013-07-06 12:44:32',NULL,NULL),(49414,'56629','P','Manitou','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.564892,-94.239618,0,'2013-07-06 12:44:33',NULL,NULL),(64702,'76854','S','London','D','Kimble','48267','Texas','TX','48','0000','325','Central',-6.0,'Y',30.624246,-99.658540,0,'2013-07-06 12:44:34',NULL,NULL),(73405,'91125','U','Cal Tech','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138929,-118.123728,0,'2013-07-06 12:44:34',NULL,NULL),(20014,'20618','S','Bushwood','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.278595,-76.795324,0,'2013-07-06 12:44:31',NULL,NULL),(71412,'87020','S','Broadview Acres','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.159241,-107.836997,0,'2013-07-06 12:44:34',NULL,NULL),(66461,'78654','S','Marble Falls','D','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(62747,'74840','S','Earlsboro','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.250122,-96.803354,0,'2013-07-06 12:44:33',NULL,NULL),(56667,'65625','S','Cassville','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.679611,-93.872639,0,'2013-07-06 12:44:33',NULL,NULL),(3674,'02127','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.338960,-71.025290,0,'2013-07-06 12:44:30',NULL,NULL),(28158,'30904','S','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.470117,-82.013170,0,'2013-07-06 12:44:31',NULL,NULL),(2604,'00961','S','Urb River Vw','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(52645,'61059','P','Nora','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.457286,-89.943451,0,'2013-07-06 12:44:33',NULL,NULL),(12400,'12928','S','Ironville','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.966980,-73.461780,0,'2013-07-06 12:44:30',NULL,NULL),(58685,'68923','P','Industry-Rock Falls','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.453315,-99.343230,0,'2013-07-06 12:44:33',NULL,NULL),(65792,'78123','S','McQueeney','A','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.605956,-98.034172,0,'2013-07-06 12:44:34',NULL,NULL),(64811,'77024','S','Spring Valley','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(49209,'56461','S','La Porte','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.227020,-94.766880,0,'2013-07-06 12:44:33',NULL,NULL),(31371,'34211','S','B\'TON','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(5865,'05143','S','Simonsville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(24850,'27625','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.821341,-78.570840,0,'2013-07-06 12:44:31',NULL,NULL),(34036,'38134','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.191860,-89.925360,0,'2013-07-06 12:44:32',NULL,NULL),(20758,'21412','U','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.122086,-76.529331,0,'2013-07-06 12:44:31',NULL,NULL),(30863,'33663','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.961787,-82.527993,0,'2013-07-06 12:44:32',NULL,NULL),(23136,'24981','S','Ballengee','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.648685,-80.742207,0,'2013-07-06 12:44:31',NULL,NULL),(45189,'50613','S','College Square','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(25103,'27967','P','Powellsville','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.224611,-76.930696,0,'2013-07-06 12:44:31',NULL,NULL),(2062,'00920','S','Urb Altamira','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(55132,'63348','S','Foristell','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.790081,-90.936659,0,'2013-07-06 12:44:33',NULL,NULL),(3663,'02123','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.343940,-71.085266,0,'2013-07-06 12:44:30',NULL,NULL),(50121,'57520','S','Agar','D','Sully','46119','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.845395,-100.057684,0,'2013-07-06 12:44:33',NULL,NULL),(26143,'28738','P','Hazelwood','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.476787,-83.002928,0,'2013-07-06 12:44:31',NULL,NULL),(61840,'73116','S','Nichols Hills','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.540626,-97.556678,0,'2013-07-06 12:44:33',NULL,NULL),(10538,'10992','S','Washingtonvle','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.424960,-74.171460,0,'2013-07-06 12:44:30',NULL,NULL),(17353,'17872','S','Boydtown','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(21987,'23261','P','Main Office','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.548641,-77.458413,0,'2013-07-06 12:44:31',NULL,NULL),(24042,'26412','S','Orlando','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.888712,-80.568821,0,'2013-07-06 12:44:31',NULL,NULL),(8922,'08742','S','Pt Pleasant B','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(53526,'62030','P','Fidelity','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.128225,-90.195318,0,'2013-07-06 12:44:33',NULL,NULL),(62517,'74401','S','Wybark','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(39168,'44307','S','West Akron','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.067235,-81.547576,0,'2013-07-06 12:44:32',NULL,NULL),(30332,'33309','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(55843,'64162','U','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.161625,-94.466674,0,'2013-07-06 12:44:33',NULL,NULL),(56142,'64844','S','Boulder City','N','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.920210,-94.267372,0,'2013-07-06 12:44:33',NULL,NULL),(2358,'00949','S','Ext La Inmaculada','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(4811,'03894','S','Wolfeboro','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.587172,-71.220009,0,'2013-07-06 12:44:30',NULL,NULL),(69308,'83455','S','Victor','D','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.606526,-111.128907,0,'2013-07-06 12:44:34',NULL,NULL),(72332,'89010','S','Dyer','D','Esmeralda','32009','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.677830,-118.084202,0,'2013-07-06 12:44:34',NULL,NULL),(48382,'55571','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.994464,-93.710566,0,'2013-07-06 12:44:33',NULL,NULL),(65780,'78113','S','Pawelekville','N','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.931521,-98.063035,0,'2013-07-06 12:44:34',NULL,NULL),(63313,'75568','S','Bryans Mill','N','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192600,-94.693620,0,'2013-07-06 12:44:33',NULL,NULL),(1124,'00725','S','Villa Blanca','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(49023,'56270','S','Morton','D','Renville','27129','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.587990,-95.043274,0,'2013-07-06 12:44:33',NULL,NULL),(32875,'36524','S','Coffeeville','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.791771,-88.066849,0,'2013-07-06 12:44:32',NULL,NULL),(23081,'24895','P','Wilcoe','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.440921,-81.595056,0,'2013-07-06 12:44:31',NULL,NULL),(28456,'31410','S','Wilmington Island','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.013342,-80.953521,0,'2013-07-06 12:44:32',NULL,NULL),(22850,'24534','S','Clover','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.879431,-78.787323,0,'2013-07-06 12:44:31',NULL,NULL),(17417,'17921','S','Mable','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(75923,'95013','P','Coyote','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.199573,-121.726813,0,'2013-07-06 12:44:34',NULL,NULL),(19968,'20591','U','Dept Transportation','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891171,-77.022513,0,'2013-07-06 12:44:31',NULL,NULL),(17721,'18241','S','Nuremberg','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.938327,-76.189558,0,'2013-07-06 12:44:31',NULL,NULL),(63273,'75505','P','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.396381,-94.250523,0,'2013-07-06 12:44:33',NULL,NULL),(25629,'28464','S','Teachey','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.771922,-78.014009,0,'2013-07-06 12:44:31',NULL,NULL),(23530,'25573','S','Yawkey','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.238417,-81.957848,0,'2013-07-06 12:44:31',NULL,NULL),(40152,'45350','P','North Star','D','Darke','39037','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.326656,-84.567991,0,'2013-07-06 12:44:32',NULL,NULL),(59296,'70505','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.226159,-92.044067,0,'2013-07-06 12:44:33',NULL,NULL),(54651,'62930','S','East Eldorado','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(55373,'63601','S','Frankclay','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(1288,'00730','S','Urb El Madrigal','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(6054,'05442','S','Belvidere Ctr','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.772686,-72.663680,0,'2013-07-06 12:44:30',NULL,NULL),(20072,'20682','P','Rock Point','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.346210,-76.920679,0,'2013-07-06 12:44:31',NULL,NULL),(25881,'28640','S','Orion','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.409140,-81.410460,0,'2013-07-06 12:44:31',NULL,NULL),(78546,'98145','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.658611,-122.312482,0,'2013-07-06 12:44:34',NULL,NULL),(3371,'01585','S','West Brookfield','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.235246,-72.146449,0,'2013-07-06 12:44:30',NULL,NULL),(79410,'98816','S','Chelan','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.850024,-120.044073,0,'2013-07-06 12:44:34',NULL,NULL),(20613,'21209','S','Mount Washington','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.370500,-76.694460,0,'2013-07-06 12:44:31',NULL,NULL),(38156,'43147','S','Pickerington','D','Fairfield','39045','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.903244,-82.750689,0,'2013-07-06 12:44:32',NULL,NULL),(58250,'68364','P','Goehner','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.833094,-97.203137,0,'2013-07-06 12:44:33',NULL,NULL),(31974,'35216','S','Hoover','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(8931,'08751','S','Seaside Hgts','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.937620,-74.080080,0,'2013-07-06 12:44:30',NULL,NULL),(59848,'71253','P','Kilbourne','D','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.870714,-91.427530,0,'2013-07-06 12:44:33',NULL,NULL),(65927,'78246','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.535290,-98.486200,0,'2013-07-06 12:44:34',NULL,NULL),(52539,'60931','S','Donovan','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.887160,-87.614177,0,'2013-07-06 12:44:33',NULL,NULL),(69681,'84024','P','Echo','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.967600,-111.421819,0,'2013-07-06 12:44:34',NULL,NULL),(63678,'75860','S','Clay Hill','N','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.624665,-96.281615,0,'2013-07-06 12:44:34',NULL,NULL),(22035,'23297','U','Rich','N','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.399712,-77.457391,0,'2013-07-06 12:44:31',NULL,NULL),(10007,'10168','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(27844,'30427','S','Glennville','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.933927,-81.925339,0,'2013-07-06 12:44:31',NULL,NULL),(43517,'48641','P','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.578180,-84.358213,0,'2013-07-06 12:44:32',NULL,NULL),(2188,'00926','S','Mans de Villanova','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(33486,'37343','S','Hixson','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.163602,-85.211915,0,'2013-07-06 12:44:32',NULL,NULL),(57116,'66223','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(24406,'27110','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.103342,-80.227719,0,'2013-07-06 12:44:31',NULL,NULL),(40048,'45258','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.140679,-84.627510,0,'2013-07-06 12:44:32',NULL,NULL),(43404,'48451','S','Linden','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.813625,-83.801965,0,'2013-07-06 12:44:32',NULL,NULL),(24721,'27511','S','Cary','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.758852,-78.780766,0,'2013-07-06 12:44:31',NULL,NULL),(47373,'54624','S','Victory','A','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.485556,-91.212500,0,'2013-07-06 12:44:32',NULL,NULL),(41802,'47330','S','Abington','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.797725,-85.011958,0,'2013-07-06 12:44:32',NULL,NULL),(1221,'00728','S','Urb Morell Campos','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(54560,'62893','S','Walnut Hill','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.517277,-88.978021,0,'2013-07-06 12:44:33',NULL,NULL),(78521,'98122','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.613497,-122.297395,0,'2013-07-06 12:44:34',NULL,NULL),(67196,'79906','S','Fort Bliss','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.823040,-106.423800,0,'2013-07-06 12:44:34',NULL,NULL),(64061,'76135','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.825756,-97.451279,0,'2013-07-06 12:44:34',NULL,NULL),(60196,'71418','S','Duty Ferry','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(43281,'48333','P','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.462218,-83.377754,0,'2013-07-06 12:44:32',NULL,NULL),(43325,'48361','P','Lake Orion','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.784438,-83.238082,0,'2013-07-06 12:44:32',NULL,NULL),(25222,'28089','P','Lattimore','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.314701,-81.654427,0,'2013-07-06 12:44:31',NULL,NULL),(48584,'55775','S','Pengilly','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.330220,-93.162673,0,'2013-07-06 12:44:33',NULL,NULL),(472,'00667','S','Alts De San Blas','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(1627,'00771','S','Mans De Los Artesanos','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(57283,'66606','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.060395,-95.716596,0,'2013-07-06 12:44:33',NULL,NULL),(37226,'41537','S','Payne Gap','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(74038,'92140','U','MCRD San Diego','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.741172,-117.196705,0,'2013-07-06 12:44:34',NULL,NULL),(79904,'99591','P','Saint Paul Island','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',56.591517,-169.620701,0,'2013-07-06 12:44:34',NULL,NULL),(15146,'15857','S','St Marys','N','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.433156,-78.550932,0,'2013-07-06 12:44:31',NULL,NULL),(37717,'42274','S','Petros','N','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.951025,-86.601859,0,'2013-07-06 12:44:32',NULL,NULL),(57827,'67530','S','Dundee','A','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.368828,-98.776747,0,'2013-07-06 12:44:33',NULL,NULL),(3822,'02322','S','Avon','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.122045,-71.048657,0,'2013-07-06 12:44:30',NULL,NULL),(59542,'70817','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.384984,-90.995591,0,'2013-07-06 12:44:33',NULL,NULL),(76561,'95667','S','Swansboro Country','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(600,'00680','S','Urb La Estancia','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(46305,'53062','U','New Holstein','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.947498,-88.101978,0,'2013-07-06 12:44:32',NULL,NULL),(27004,'29634','U','Clemson University','N','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.673146,-82.823962,0,'2013-07-06 12:44:31',NULL,NULL),(59467,'70740','S','Grosse Tete','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.412537,-91.430224,0,'2013-07-06 12:44:33',NULL,NULL),(73042,'90080','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',33.954771,-118.396089,0,'2013-07-06 12:44:34',NULL,NULL),(61926,'73153','P','Moore','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.335006,-97.492751,0,'2013-07-06 12:44:33',NULL,NULL),(46546,'53406','S','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.725720,-87.856436,0,'2013-07-06 12:44:32',NULL,NULL),(46478,'53219','S','West Allis','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994394,-87.991356,0,'2013-07-06 12:44:32',NULL,NULL),(57026,'66207','S','Prairie Village','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(41482,'46935','P','Kewanna','A','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.018611,-86.413333,0,'2013-07-06 12:44:32',NULL,NULL),(20259,'20784','S','Cheverly','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(36228,'40289','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258911,-85.756935,0,'2013-07-06 12:44:32',NULL,NULL),(1585,'00769','S','Bda San Antonio','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(9092,'09055','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(12193,'12778','P','Smallwood','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.663676,-74.820124,0,'2013-07-06 12:44:30',NULL,NULL),(26018,'28677','S','Eufola','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(4703,'03815','P','CTR Strafford','A','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.258263,-71.115091,0,'2013-07-06 12:44:30',NULL,NULL),(26269,'29010','S','McCutchen Crossroads','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(18371,'19046','S','Fox Chase Manor','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(51861,'60075','P','Russell','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.491134,-87.925180,0,'2013-07-06 12:44:33',NULL,NULL),(27455,'30127','S','Powder Spgs','A','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.883327,-84.688671,0,'2013-07-06 12:44:31',NULL,NULL),(54979,'63123','S','Wilbur Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.543880,-90.318420,0,'2013-07-06 12:44:33',NULL,NULL),(19734,'20402','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898247,-77.010957,0,'2013-07-06 12:44:31',NULL,NULL),(35343,'39437','S','Sand Hill','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(55218,'63401','S','Spalding','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(46720,'53809','S','Fennimore','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.990107,-90.647260,0,'2013-07-06 12:44:32',NULL,NULL),(54010,'62448','S','Wendelin','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.988361,-88.163646,0,'2013-07-06 12:44:33',NULL,NULL),(49212,'56464','S','Huntersville','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(51568,'59755','S','Virginia City','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.294302,-111.941730,0,'2013-07-06 12:44:33',NULL,NULL),(50788,'58438','S','Fessenden','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.652404,-99.623115,0,'2013-07-06 12:44:33',NULL,NULL),(38066,'43062','S','Etna','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.005979,-82.676213,0,'2013-07-06 12:44:32',NULL,NULL),(22130,'23442','S','Temperanceville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.895258,-75.559531,0,'2013-07-06 12:44:31',NULL,NULL),(17860,'18433','S','Scott Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.533400,-75.542375,0,'2013-07-06 12:44:31',NULL,NULL),(57737,'67423','S','Beverly','D','Lincoln','20105','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.958805,-97.980819,0,'2013-07-06 12:44:33',NULL,NULL),(20316,'20825','P','Chevy Chase','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.995496,-77.074994,0,'2013-07-06 12:44:31',NULL,NULL),(78566,'98158','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445664,-122.311881,0,'2013-07-06 12:44:34',NULL,NULL),(26628,'29322','S','Campobello','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.118004,-82.126556,0,'2013-07-06 12:44:31',NULL,NULL),(11174,'11731','S','E Northport','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.864288,-73.317866,0,'2013-07-06 12:44:30',NULL,NULL),(53295,'61730','S','Cooksville','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.527376,-88.746598,0,'2013-07-06 12:44:33',NULL,NULL),(30619,'33435','S','Ocean Ridge','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524047,-80.068212,0,'2013-07-06 12:44:32',NULL,NULL),(57699,'67334','P','Chautauqua','D','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.021829,-96.177323,0,'2013-07-06 12:44:33',NULL,NULL),(49738,'57052','S','Olivet','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.282169,-97.732289,0,'2013-07-06 12:44:33',NULL,NULL),(48603,'55786','P','Savannah','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.309263,-93.382691,0,'2013-07-06 12:44:33',NULL,NULL),(45926,'52332','S','Shellsburg','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.095680,-91.870031,0,'2013-07-06 12:44:32',NULL,NULL),(16208,'17070','S','Westfield Ter','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(6601,'05866','S','Sheffield Square','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.639720,-72.125008,0,'2013-07-06 12:44:30',NULL,NULL),(20060,'20670','S','Patuxent River','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.281107,-76.420424,0,'2013-07-06 12:44:31',NULL,NULL),(77702,'97048','S','Prescott','A','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',46.058179,-122.963608,0,'2013-07-06 12:44:34',NULL,NULL),(71719,'87531','S','La Junta','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.141996,-105.998001,0,'2013-07-06 12:44:34',NULL,NULL),(60357,'71471','P','Saint Maurice','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.757113,-92.962011,0,'2013-07-06 12:44:33',NULL,NULL),(3976,'02495','P','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.332052,-71.207484,0,'2013-07-06 12:44:30',NULL,NULL),(18955,'19512','S','Colebrookdale','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(3673,'02126','S','Mattapan','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.274690,-71.089937,0,'2013-07-06 12:44:30',NULL,NULL),(27350,'30054','S','Oxford','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.677484,-83.872134,0,'2013-07-06 12:44:31',NULL,NULL),(45737,'52101','S','Locust','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(5942,'05257','S','Paper Mill Village','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(4049,'02637','P','Cummaquid','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.704363,-70.279241,0,'2013-07-06 12:44:30',NULL,NULL),(29938,'33067','S','Parkland','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.309681,-80.220464,0,'2013-07-06 12:44:32',NULL,NULL),(34953,'39060','P','Clinton','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.362834,-90.265435,0,'2013-07-06 12:44:32',NULL,NULL),(9823,'10113','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(26614,'29305','P','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.989259,-81.954612,0,'2013-07-06 12:44:31',NULL,NULL),(30142,'33166','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(65913,'78236','S','Wilford Hall','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(74621,'92802','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.808505,-117.922777,0,'2013-07-06 12:44:34',NULL,NULL),(69968,'84119','S','Ssl','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(60836,'72040','S','Childress','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(30873,'33675','P','Ybor City','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.119021,-82.471502,0,'2013-07-06 12:44:32',NULL,NULL),(25427,'28304','S','Lafayette','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.029744,-78.970982,0,'2013-07-06 12:44:31',NULL,NULL),(12566,'13057','S','E Syracuse','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.075530,-76.051820,0,'2013-07-06 12:44:30',NULL,NULL),(53554,'62048','S','Hartford','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.834452,-90.093735,0,'2013-07-06 12:44:33',NULL,NULL),(46802,'54002','S','Erin Prairie','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.974620,-92.350320,0,'2013-07-06 12:44:32',NULL,NULL),(16396,'17217','S','Concord','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.255335,-77.699826,0,'2013-07-06 12:44:31',NULL,NULL),(31388,'34219','S','Duette','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.562795,-82.433618,0,'2013-07-06 12:44:32',NULL,NULL),(42053,'47448','S','Annandale Est','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(60182,'71417','S','Aloha','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(67963,'80914','P','Cheyenne Mountain AFB','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(70574,'85066','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.394343,-112.032370,0,'2013-07-06 12:44:34',NULL,NULL),(37248,'41557','S','Jonican','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.498447,-82.428405,0,'2013-07-06 12:44:32',NULL,NULL),(4711,'03819','S','Danville','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.919072,-71.116979,0,'2013-07-06 12:44:30',NULL,NULL),(4946,'04094','P','West Kennebunk','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.426443,-70.630455,0,'2013-07-06 12:44:30',NULL,NULL),(8523,'08107','S','Haddon Twp','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(16518,'17268','S','Altenwald','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(54102,'62538','S','Harvel','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.385957,-89.543556,0,'2013-07-06 12:44:33',NULL,NULL),(64040,'76127','S','Nas/Jrb','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.776500,-97.423380,0,'2013-07-06 12:44:34',NULL,NULL),(45874,'52248','S','Talleyrand','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.363498,-91.954172,0,'2013-07-06 12:44:32',NULL,NULL),(14919,'15542','S','Garrett','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.867239,-79.062657,0,'2013-07-06 12:44:31',NULL,NULL),(39711,'45050','S','Liberty Twnship','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.446195,-84.369751,0,'2013-07-06 12:44:32',NULL,NULL),(27435,'30114','S','Holly Springs','A','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.247481,-84.524085,0,'2013-07-06 12:44:31',NULL,NULL),(41630,'47130','S','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(49255,'56475','S','Clough','N','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.064416,-94.520309,0,'2013-07-06 12:44:33',NULL,NULL),(52316,'60553','S','Steward','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.812414,-89.021117,0,'2013-07-06 12:44:33',NULL,NULL),(4301,'02906','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.837825,-71.397886,0,'2013-07-06 12:44:30',NULL,NULL),(34895,'38951','S','Pittsboro','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.944219,-89.313681,0,'2013-07-06 12:44:32',NULL,NULL),(15153,'15866','S','Troutville','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.024504,-78.785531,0,'2013-07-06 12:44:31',NULL,NULL),(24334,'27028','S','Mocksville','D','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.908260,-80.556300,0,'2013-07-06 12:44:31',NULL,NULL),(79668,'99160','S','Kettle Falls','A','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.865447,-118.201993,0,'2013-07-06 12:44:34',NULL,NULL),(51175,'59011','S','Big Timber','D','Sweet Grass','30097','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.835144,-109.951625,0,'2013-07-06 12:44:33',NULL,NULL),(23765,'25966','P','Grn Sphr Spgs','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.796066,-80.830326,0,'2013-07-06 12:44:31',NULL,NULL),(2460,'00956','S','Alts de Bayamon','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(2589,'00961','S','Repto Teresita','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(387,'00662','S','Bda La Mayor','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(8849,'08645','U','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217190,-74.769632,0,'2013-07-06 12:44:30',NULL,NULL),(44658,'50107','S','Grand Jct','A','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.032301,-94.232040,0,'2013-07-06 12:44:32',NULL,NULL),(596,'00680','S','Urb Belmonte','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(76905,'95987','S','Leesville','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.148021,-122.145602,0,'2013-07-06 12:44:34',NULL,NULL),(31746,'34987','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308771,-80.453062,0,'2013-07-06 12:44:32',NULL,NULL),(21702,'22969','S','Schuyler','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.772564,-78.697807,0,'2013-07-06 12:44:31',NULL,NULL),(38326,'43416','S','Elmore','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.480107,-83.282707,0,'2013-07-06 12:44:32',NULL,NULL),(67824,'80759','S','Yuma','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.133756,-102.693014,0,'2013-07-06 12:44:34',NULL,NULL),(75107,'93544','S','Llano','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.493353,-117.787760,0,'2013-07-06 12:44:34',NULL,NULL),(73423,'91201','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.171910,-118.292436,0,'2013-07-06 12:44:34',NULL,NULL),(65348,'77521','S','Baytown','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.795863,-94.973054,0,'2013-07-06 12:44:34',NULL,NULL),(64912,'77099','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.670332,-95.586361,0,'2013-07-06 12:44:34',NULL,NULL),(59605,'71019','S','Hanna','A','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(6321,'05661','S','Mud City','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(58416,'68647','S','Monroe','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.470368,-97.612457,0,'2013-07-06 12:44:33',NULL,NULL),(52988,'61439','P','Henderson','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.024270,-90.356495,0,'2013-07-06 12:44:33',NULL,NULL),(56837,'65807','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.166766,-93.312621,0,'2013-07-06 12:44:33',NULL,NULL),(58688,'68924','S','Keene','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.480326,-99.125483,0,'2013-07-06 12:44:33',NULL,NULL),(79766,'99324','S','College Place','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.045542,-118.385670,0,'2013-07-06 12:44:34',NULL,NULL),(54012,'62449','S','Oblong','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.001962,-87.906869,0,'2013-07-06 12:44:33',NULL,NULL),(54049,'62468','S','Cumberland','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.269624,-88.244943,0,'2013-07-06 12:44:33',NULL,NULL),(54613,'62914','S','Cache','A','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.009840,-89.180112,0,'2013-07-06 12:44:33',NULL,NULL),(79579,'99025','S','East Farms','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.733704,-117.077767,0,'2013-07-06 12:44:34',NULL,NULL),(78762,'98304','S','Ashford','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.741603,-121.974327,0,'2013-07-06 12:44:34',NULL,NULL),(76782,'95941','S','Forbestown','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.486274,-121.283600,0,'2013-07-06 12:44:34',NULL,NULL),(62242,'74002','S','Tallant','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.558589,-96.162993,0,'2013-07-06 12:44:33',NULL,NULL),(59652,'71047','S','Keithville','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.316074,-93.893584,0,'2013-07-06 12:44:33',NULL,NULL),(24535,'27292','S','Arnold','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(49387,'56601','S','Sugar Bush','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(20035,'20640','S','Indian Head','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.572080,-77.152920,0,'2013-07-06 12:44:31',NULL,NULL),(31741,'34986','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.321528,-80.418405,0,'2013-07-06 12:44:32',NULL,NULL),(80027,'99688','S','Willow','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.644526,-150.671047,0,'2013-07-06 12:44:34',NULL,NULL),(79689,'99202','S','Liberty Park','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.657108,-117.377255,0,'2013-07-06 12:44:34',NULL,NULL),(76965,'96048','S','Junction City','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.780780,-123.050679,0,'2013-07-06 12:44:34',NULL,NULL),(30363,'33314','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.070011,-80.219723,0,'2013-07-06 12:44:32',NULL,NULL),(2594,'00961','S','Urb Estancias','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(19161,'19720','S','Manor','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.673263,-75.595423,0,'2013-07-06 12:44:31',NULL,NULL),(39951,'45232','S','Saint Bernard','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.176213,-84.513602,0,'2013-07-06 12:44:32',NULL,NULL),(7174,'06455','S','Middlefield','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.517769,-72.717522,0,'2013-07-06 12:44:30',NULL,NULL),(48780,'55990','S','Fillmore','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.713480,-92.269860,0,'2013-07-06 12:44:33',NULL,NULL),(13402,'13752','S','Cabinhill','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.164722,-74.910240,0,'2013-07-06 12:44:31',NULL,NULL),(7973,'07704','S','Fair Haven','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.371420,-74.035620,0,'2013-07-06 12:44:30',NULL,NULL),(55980,'64623','S','Bosworth','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.468808,-93.339284,0,'2013-07-06 12:44:33',NULL,NULL),(4990,'04124','U','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.652070,-70.330016,0,'2013-07-06 12:44:30',NULL,NULL),(16021,'17042','S','Fontana','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(37593,'42104','S','Bowling Green','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.932012,-86.450060,0,'2013-07-06 12:44:32',NULL,NULL),(68331,'81120','S','Track City','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(72561,'89310','S','Ione','N','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.738476,-117.193253,0,'2013-07-06 12:44:34',NULL,NULL),(37257,'41562','S','Millard','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.393260,-82.471200,0,'2013-07-06 12:44:32',NULL,NULL),(43025,'48169','S','Pinckney','D','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.459080,-83.934013,0,'2013-07-06 12:44:32',NULL,NULL),(24805,'27596','S','Youngsville','D','Franklin','37069','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.025816,-78.467462,0,'2013-07-06 12:44:31',NULL,NULL),(46009,'52536','S','Blakesburg','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.960626,-92.635668,0,'2013-07-06 12:44:32',NULL,NULL),(39935,'45227','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.156000,-84.371400,0,'2013-07-06 12:44:32',NULL,NULL),(64725,'76878','S','Santa Anna','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.490380,-99.306940,0,'2013-07-06 12:44:34',NULL,NULL),(72637,'89422','P','Mina','D','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.386579,-118.108409,0,'2013-07-06 12:44:34',NULL,NULL),(41280,'46760','S','Kimmell','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.348810,-85.609076,0,'2013-07-06 12:44:32',NULL,NULL),(57013,'66205','S','Westwood Hills','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(77701,'97045','S','Redland','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.340277,-122.560941,0,'2013-07-06 12:44:34',NULL,NULL),(79847,'99548','P','Chignik','A','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.233333,-158.783333,0,'2013-07-06 12:44:34',NULL,NULL),(73734,'91702','S','Irwindale','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.124881,-117.903021,0,'2013-07-06 12:44:34',NULL,NULL),(38901,'44117','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.569630,-81.525168,0,'2013-07-06 12:44:32',NULL,NULL),(54805,'63017','S','Twn and Cntry','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.647818,-90.545814,0,'2013-07-06 12:44:33',NULL,NULL),(24143,'26568','S','Enterprise','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.427050,-80.347848,0,'2013-07-06 12:44:31',NULL,NULL),(71422,'87026','S','Cononcito','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(70884,'85613','S','Sierra Vista','A','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.551784,-110.347231,0,'2013-07-06 12:44:34',NULL,NULL),(70342,'84633','P','Goshen','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',39.954290,-111.903284,0,'2013-07-06 12:44:34',NULL,NULL),(17786,'18350','S','Pocono Pines','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.117264,-75.442241,0,'2013-07-06 12:44:31',NULL,NULL),(37827,'42437','S','Spring Grove','N','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(6669,'06031','S','Falls Village','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.963160,-73.316160,0,'2013-07-06 12:44:30',NULL,NULL),(45102,'50544','S','Harcourt','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.263592,-94.178232,0,'2013-07-06 12:44:32',NULL,NULL),(52146,'60441','S','Homer Glen','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.608015,-88.013188,0,'2013-07-06 12:44:33',NULL,NULL),(78627,'98206','P','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.925630,-122.226390,0,'2013-07-06 12:44:34',NULL,NULL),(77939,'97341','S','Depoe Bay','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.827080,-124.043640,0,'2013-07-06 12:44:34',NULL,NULL),(41653,'47140','S','Hogtown','A','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.383335,-86.384510,0,'2013-07-06 12:44:32',NULL,NULL),(16397,'17219','S','Doylesburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.217940,-77.713500,0,'2013-07-06 12:44:31',NULL,NULL),(71293,'86444','S','Meadview','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.868609,-114.312856,0,'2013-07-06 12:44:34',NULL,NULL),(70537,'85021','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.558995,-112.088925,0,'2013-07-06 12:44:34',NULL,NULL),(42660,'47952','S','Kingman','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.017300,-87.285120,0,'2013-07-06 12:44:32',NULL,NULL),(18432,'19063','S','Rose Valley','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(32789,'36421','S','Andalusia','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.307991,-86.476872,0,'2013-07-06 12:44:32',NULL,NULL),(51124,'58792','S','Verendrye','N','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.933754,-100.775619,0,'2013-07-06 12:44:33',NULL,NULL),(4453,'03252','P','Lochmere','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.471344,-71.538544,0,'2013-07-06 12:44:30',NULL,NULL),(30632,'33443','P','Deerfield Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.324699,-80.120509,0,'2013-07-06 12:44:32',NULL,NULL),(17371,'17880','P','Swengel','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.940790,-77.074448,0,'2013-07-06 12:44:31',NULL,NULL),(5005,'04221','S','Canton','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.416910,-70.322598,0,'2013-07-06 12:44:30',NULL,NULL),(71743,'87539','S','La Madera','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.290427,-106.105471,0,'2013-07-06 12:44:34',NULL,NULL),(72456,'89114','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.151263,-115.153968,0,'2013-07-06 12:44:34',NULL,NULL),(40881,'46241','S','Drexel Gardens','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(36336,'40402','S','Bond','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.303317,-84.007453,0,'2013-07-06 12:44:32',NULL,NULL),(426,'00662','S','Sect La Media Cuerda','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(35212,'39298','P','Jksn','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.321984,-90.206032,0,'2013-07-06 12:44:32',NULL,NULL),(48956,'56176','S','Trimont','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.762998,-94.711798,0,'2013-07-06 12:44:33',NULL,NULL),(33692,'37754','S','Heiskell','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.087523,-84.042629,0,'2013-07-06 12:44:32',NULL,NULL),(15636,'16727','S','Derrick City','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.980673,-78.552131,0,'2013-07-06 12:44:31',NULL,NULL),(37172,'41472','S','Stacy Fork','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(39518,'44816','P','Birmingham','D','Erie','39043','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.329962,-82.361126,0,'2013-07-06 12:44:32',NULL,NULL),(13011,'13418','S','N Brookfield','A','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.851796,-75.374964,0,'2013-07-06 12:44:30',NULL,NULL),(51032,'58718','S','Tagus','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328239,-101.921232,0,'2013-07-06 12:44:33',NULL,NULL),(24986,'27856','S','Nashville','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.965691,-77.958946,0,'2013-07-06 12:44:31',NULL,NULL),(79905,'99591','P','St George','N','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',56.591517,-169.620701,0,'2013-07-06 12:44:34',NULL,NULL),(75570,'94271','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583207,-121.491295,0,'2013-07-06 12:44:34',NULL,NULL),(21657,'22942','S','Gordonsville','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.134847,-78.186346,0,'2013-07-06 12:44:31',NULL,NULL),(48480,'55724','S','Cotton','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.154803,-92.576170,0,'2013-07-06 12:44:33',NULL,NULL),(17723,'18244','P','Parryville','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.822254,-75.674108,0,'2013-07-06 12:44:31',NULL,NULL),(1906,'00795','S','Comunidad Monte Cristo','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(29579,'32820','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.588392,-81.123204,0,'2013-07-06 12:44:32',NULL,NULL),(17972,'18614','S','Dushore','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.522494,-76.401012,0,'2013-07-06 12:44:31',NULL,NULL),(29168,'32352','S','Quincy','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.686033,-84.826115,0,'2013-07-06 12:44:32',NULL,NULL),(62090,'73568','S','Temple','D','Cotton','40033','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.274774,-98.231968,0,'2013-07-06 12:44:33',NULL,NULL),(33997,'38118','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.048583,-89.925961,0,'2013-07-06 12:44:32',NULL,NULL),(53415,'61844','S','Fithian','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.071139,-87.775363,0,'2013-07-06 12:44:33',NULL,NULL),(61464,'72629','S','Dennard','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.721345,-92.586703,0,'2013-07-06 12:44:33',NULL,NULL),(46756,'53933','S','Fox Lake','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.565132,-88.913530,0,'2013-07-06 12:44:32',NULL,NULL),(34493,'38668','S','Senatobia','D','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(12072,'12547','S','Milton','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.655535,-73.977058,0,'2013-07-06 12:44:30',NULL,NULL),(9748,'10101','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(72144,'88317','S','Cloudcroft','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.945250,-105.747305,0,'2013-07-06 12:44:34',NULL,NULL),(58295,'68419','P','Panama','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.603592,-96.507775,0,'2013-07-06 12:44:33',NULL,NULL),(16006,'17040','S','Alinda','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.311569,-77.333589,0,'2013-07-06 12:44:31',NULL,NULL),(26935,'29591','S','Scranton','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.916161,-79.742464,0,'2013-07-06 12:44:31',NULL,NULL),(3906,'02455','P','North Waltham','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.357184,-71.059255,0,'2013-07-06 12:44:30',NULL,NULL),(13647,'14006','S','Angola','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.634072,-79.051514,0,'2013-07-06 12:44:31',NULL,NULL),(6646,'06016','S','Windsorville','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.908366,-72.542144,0,'2013-07-06 12:44:30',NULL,NULL),(52434,'60656','S','Harwood Hts','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.975199,-87.825937,0,'2013-07-06 12:44:33',NULL,NULL),(71268,'86427','P','Bullhead City','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.017532,-114.584742,0,'2013-07-06 12:44:34',NULL,NULL),(74477,'92607','P','Laguna Niguel','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.526852,-117.711714,0,'2013-07-06 12:44:34',NULL,NULL),(66287,'78582','S','Santa Catarina','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(42633,'47916','P','Alamo','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.972803,-87.029735,0,'2013-07-06 12:44:32',NULL,NULL),(38535,'43739','S','Glenford','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.939027,-82.274937,0,'2013-07-06 12:44:32',NULL,NULL),(56297,'65083','S','Ulman','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.130959,-92.463161,0,'2013-07-06 12:44:33',NULL,NULL),(38284,'43331','S','Orchard Island','N','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.498480,-83.907723,0,'2013-07-06 12:44:32',NULL,NULL),(21976,'23250','S','Air Mail Facility','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(68863,'82636','S','Evansville','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.858536,-106.200733,0,'2013-07-06 12:44:34',NULL,NULL),(36017,'40165','S','Fox Chase','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(12297,'12850','S','Barkersville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.118700,-73.987500,0,'2013-07-06 12:44:30',NULL,NULL),(28108,'30802','S','Pollards Corner','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.539800,-82.315022,0,'2013-07-06 12:44:31',NULL,NULL),(33841,'37934','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(3402,'01655','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.276871,-71.761225,0,'2013-07-06 12:44:30',NULL,NULL),(75621,'94505','S','Byron','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.903278,-121.602226,0,'2013-07-06 12:44:34',NULL,NULL),(259,'00641','S','Bda Nueva','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(29664,'32909','S','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.969161,-80.647489,0,'2013-07-06 12:44:32',NULL,NULL),(14065,'14591','S','Wyoming','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.827666,-78.086670,0,'2013-07-06 12:44:31',NULL,NULL),(24796,'27589','S','Warrenton','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.397160,-78.151699,0,'2013-07-06 12:44:31',NULL,NULL),(75736,'94601','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.780584,-122.216306,0,'2013-07-06 12:44:34',NULL,NULL),(34572,'38733','S','DSU','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.749492,-90.831182,0,'2013-07-06 12:44:32',NULL,NULL),(78805,'98328','S','Alder','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',46.867140,-122.289000,0,'2013-07-06 12:44:34',NULL,NULL),(24576,'27313','S','Pleasant Gdns','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.952898,-79.757191,0,'2013-07-06 12:44:31',NULL,NULL),(78851,'98339','S','Irondale','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.027885,-122.759844,0,'2013-07-06 12:44:34',NULL,NULL),(16752,'17512','S','Kinderhook','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.036944,-76.480322,0,'2013-07-06 12:44:31',NULL,NULL),(46467,'53216','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.089739,-87.975948,0,'2013-07-06 12:44:32',NULL,NULL),(12370,'12912','S','Au Sable Forks','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.459424,-73.713927,0,'2013-07-06 12:44:30',NULL,NULL),(10907,'11427','S','Queens Village','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(8881,'08721','S','Bayville','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.906120,-74.174220,0,'2013-07-06 12:44:30',NULL,NULL),(52896,'61354','S','Peru','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333179,-89.128880,0,'2013-07-06 12:44:33',NULL,NULL),(10075,'10185','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(48818,'56031','S','Fairmont','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.645556,-94.459260,0,'2013-07-06 12:44:33',NULL,NULL),(7639,'07069','S','Plainfield','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.636817,-74.452093,0,'2013-07-06 12:44:30',NULL,NULL),(39363,'44634','S','Homeworth','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.830436,-81.045474,0,'2013-07-06 12:44:32',NULL,NULL),(30629,'33441','S','Deerfield Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.312859,-80.104367,0,'2013-07-06 12:44:32',NULL,NULL),(77464,'96815','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.278625,-157.820909,0,'2013-07-06 12:44:34',NULL,NULL),(77309,'96677','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75261,'93668','S','Tranquillity','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.644518,-120.258784,0,'2013-07-06 12:44:34',NULL,NULL),(65990,'78336','S','Cty by the Se','A','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.904408,-97.160091,0,'2013-07-06 12:44:34',NULL,NULL),(23936,'26260','S','Canaan Valley','A','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.128653,-79.468131,0,'2013-07-06 12:44:31',NULL,NULL),(30871,'33674','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.018749,-82.457886,0,'2013-07-06 12:44:32',NULL,NULL),(3269,'01467','P','Still River','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.483655,-71.621609,0,'2013-07-06 12:44:30',NULL,NULL),(8682,'08332','S','Carmel','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.330240,-75.027540,0,'2013-07-06 12:44:30',NULL,NULL),(51886,'60093','S','Northfield','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.101050,-87.757641,0,'2013-07-06 12:44:33',NULL,NULL),(43670,'48859','U','Mt Pleasant','A','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.597602,-84.778009,0,'2013-07-06 12:44:32',NULL,NULL),(16489,'17257','S','Lees Cross Rd','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(50732,'58384','S','Ostby','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617340,-100.299168,0,'2013-07-06 12:44:33',NULL,NULL),(76054,'95192','U','San Jose State University','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.341891,-121.890214,0,'2013-07-06 12:44:34',NULL,NULL),(31053,'33835','P','Bradley','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.780904,-81.917625,0,'2013-07-06 12:44:32',NULL,NULL),(52456,'60674','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.876571,-87.649480,0,'2013-07-06 12:44:33',NULL,NULL),(50384,'57762','S','Arpan','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.673863,-103.556841,0,'2013-07-06 12:44:33',NULL,NULL),(3514,'01879','S','Tyngsboro','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.673414,-71.416749,0,'2013-07-06 12:44:30',NULL,NULL),(14548,'15211','S','Mount Washington','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.432740,-79.945680,0,'2013-07-06 12:44:31',NULL,NULL),(22215,'23521','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.917343,-76.155443,0,'2013-07-06 12:44:31',NULL,NULL),(28644,'31763','S','Leesburg','D','Lee','13177','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.676690,-84.145973,0,'2013-07-06 12:44:32',NULL,NULL),(69306,'83455','S','Fox Creek','N','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.606526,-111.128907,0,'2013-07-06 12:44:34',NULL,NULL),(66907,'79312','S','Amherst','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.016464,-102.416863,0,'2013-07-06 12:44:34',NULL,NULL),(37945,'42715','S','Breeding','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.959621,-85.388851,0,'2013-07-06 12:44:32',NULL,NULL),(23631,'25727','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.414002,-82.475200,0,'2013-07-06 12:44:31',NULL,NULL),(26497,'29169','S','Pineridge','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(1925,'00795','S','Urb Camino Real','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(20503,'21074','S','Greenmount','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.610628,-76.848152,0,'2013-07-06 12:44:31',NULL,NULL),(40508,'45812','S','Alger','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.697300,-83.822534,0,'2013-07-06 12:44:32',NULL,NULL),(63665,'75852','S','Midway','D','Madison','48313','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.018920,-95.758200,0,'2013-07-06 12:44:34',NULL,NULL),(4531,'03435','U','Keene State College','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.925672,-72.276350,0,'2013-07-06 12:44:30',NULL,NULL),(42889,'48095','S','Washington Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.783484,-83.041714,0,'2013-07-06 12:44:32',NULL,NULL),(41255,'46746','S','Brighton','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.716860,-85.413840,0,'2013-07-06 12:44:32',NULL,NULL),(49050,'56297','S','Wood Lake','D','Yellow Medicine','27173','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.651680,-95.541100,0,'2013-07-06 12:44:33',NULL,NULL),(49239,'56470','S','Todd','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(44976,'50423','S','Britt','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.095207,-93.799817,0,'2013-07-06 12:44:32',NULL,NULL),(11222,'11749','S','Central Islip','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.809863,-73.179536,0,'2013-07-06 12:44:30',NULL,NULL),(27191,'29853','S','Williston','D','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.397983,-81.424281,0,'2013-07-06 12:44:31',NULL,NULL),(26375,'29080','S','Lynchburg','D','Lee','45061','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.038853,-80.110297,0,'2013-07-06 12:44:31',NULL,NULL),(60522,'71670','S','Selma','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.672180,-91.540620,0,'2013-07-06 12:44:33',NULL,NULL),(73209,'90608','P','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.979318,-118.030530,0,'2013-07-06 12:44:34',NULL,NULL),(77275,'96609','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(31996,'35223','S','Vestavia','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489469,-86.741202,0,'2013-07-06 12:44:32',NULL,NULL),(70990,'85710','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.214160,-110.829230,0,'2013-07-06 12:44:34',NULL,NULL),(59291,'70501','S','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.236054,-92.006492,0,'2013-07-06 12:44:33',NULL,NULL),(40871,'46236','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.863210,-85.967360,0,'2013-07-06 12:44:32',NULL,NULL),(6106,'05454','S','Fairfax','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.686800,-73.015620,0,'2013-07-06 12:44:30',NULL,NULL),(22682,'24314','S','Grapefield','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.161780,-81.198480,0,'2013-07-06 12:44:31',NULL,NULL),(18434,'19063','S','Wawa','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(78533,'98133','S','Bitter Lake','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.739660,-122.333340,0,'2013-07-06 12:44:34',NULL,NULL),(44674,'50118','S','Hartford','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.461679,-93.389691,0,'2013-07-06 12:44:32',NULL,NULL),(32453,'36023','P','Tallassee','A','Tallapoosa','01123','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.609580,-85.810369,0,'2013-07-06 12:44:32',NULL,NULL),(28402,'31316','S','Donald','N','Long','13183','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.730688,-81.735664,0,'2013-07-06 12:44:32',NULL,NULL),(23303,'25186','P','Smithers','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.181843,-81.308979,0,'2013-07-06 12:44:31',NULL,NULL),(4091,'02668','S','W Barnstble','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.706060,-70.366440,0,'2013-07-06 12:44:30',NULL,NULL),(5294,'04544','S','East Boothbay','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.821989,-69.593962,0,'2013-07-06 12:44:30',NULL,NULL),(48784,'55992','S','Zumbrota','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.288714,-92.672873,0,'2013-07-06 12:44:33',NULL,NULL),(61888,'73135','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.391618,-97.423072,0,'2013-07-06 12:44:33',NULL,NULL),(60548,'71725','S','Carthage','D','Dallas','05039','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.045382,-92.647954,0,'2013-07-06 12:44:33',NULL,NULL),(52232,'60501','S','Summit','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782868,-87.813794,0,'2013-07-06 12:44:33',NULL,NULL),(30158,'33170','S','Country Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(30057,'33146','S','University of Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(18611,'19146','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.936445,-75.183641,0,'2013-07-06 12:44:31',NULL,NULL),(38193,'43204','S','Valleyview','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.955851,-83.082221,0,'2013-07-06 12:44:32',NULL,NULL),(15947,'17024','S','Elliottsburg','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(24378,'27055','S','Shacktown','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(9528,'10019','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(24213,'26707','P','Bayard','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.254167,-79.398056,0,'2013-07-06 12:44:31',NULL,NULL),(18435,'19064','S','Springfield','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.954540,-75.297960,0,'2013-07-06 12:44:31',NULL,NULL),(8999,'08852','S','Monmouth Jct','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.394077,-74.544739,0,'2013-07-06 12:44:30',NULL,NULL),(32606,'36134','U','First Alabama Bank','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.377274,-86.308425,0,'2013-07-06 12:44:32',NULL,NULL),(39277,'44473','S','Vienna','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.237908,-80.662007,0,'2013-07-06 12:44:32',NULL,NULL),(3994,'02539','S','Chappaquiddick Island','N','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.391367,-70.529036,0,'2013-07-06 12:44:30',NULL,NULL),(3840,'02340','U','Wearguard','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.110338,-70.812083,0,'2013-07-06 12:44:30',NULL,NULL),(68680,'82005','S','Fe Warren Afb','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.137080,-104.818020,0,'2013-07-06 12:44:34',NULL,NULL),(6851,'06127','P','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766715,-72.682282,0,'2013-07-06 12:44:30',NULL,NULL),(37169,'41472','S','Moon','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(2306,'00927','S','Urb San Ignacio','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(41532,'46992','S','Wabash','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.803388,-85.826820,0,'2013-07-06 12:44:32',NULL,NULL),(35761,'39739','S','Lynn Creek','N','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.234567,-88.580798,0,'2013-07-06 12:44:32',NULL,NULL),(57118,'66223','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(7405,'06794','S','Washington','N','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.649297,-73.322807,0,'2013-07-06 12:44:30',NULL,NULL),(1405,'00738','S','Urb Monte Brisas 5','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(43091,'48211','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.380130,-83.051750,0,'2013-07-06 12:44:32',NULL,NULL),(45071,'50521','P','Burnside','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.336366,-94.111285,0,'2013-07-06 12:44:32',NULL,NULL),(23266,'25140','S','Montcoal','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.897184,-81.525084,0,'2013-07-06 12:44:31',NULL,NULL),(76385,'95531','S','Crescent City','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.784192,-124.168263,0,'2013-07-06 12:44:34',NULL,NULL),(66792,'79056','S','Lipscomb','D','Lipscomb','48295','Texas','TX','48','0000','806','Central',-6.0,'Y',36.222453,-100.287339,0,'2013-07-06 12:44:34',NULL,NULL),(36853,'41076','S','Highland Heights','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(16955,'17702','S','Collomsville','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(9577,'10027','S','Manhattanville','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(76581,'95680','P','Ryde','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.238604,-121.560075,0,'2013-07-06 12:44:34',NULL,NULL),(22401,'23958','S','Darlingtn Hts','A','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.260126,-78.645051,0,'2013-07-06 12:44:31',NULL,NULL),(7295,'06538','U','Advertising Distr Co','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.432208,-72.909280,0,'2013-07-06 12:44:30',NULL,NULL),(50552,'58204','S','Grand Forks Air Force Base','N','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.960971,-97.370375,0,'2013-07-06 12:44:33',NULL,NULL),(69169,'83323','S','Idahome','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.518218,-113.627087,0,'2013-07-06 12:44:34',NULL,NULL),(67900,'80902','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(61955,'73169','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.394847,-97.644712,0,'2013-07-06 12:44:33',NULL,NULL),(24091,'26505','S','Booth','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.636473,-79.951111,0,'2013-07-06 12:44:31',NULL,NULL),(14778,'15349','S','Mt Morris','A','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.745620,-80.092800,0,'2013-07-06 12:44:31',NULL,NULL),(74039,'92140','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.741172,-117.196705,0,'2013-07-06 12:44:34',NULL,NULL),(67305,'80020','S','Broomfield','D','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.934680,-105.076620,0,'2013-07-06 12:44:34',NULL,NULL),(11783,'12208','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652812,-73.807109,0,'2013-07-06 12:44:30',NULL,NULL),(21811,'23102','S','Dabneys','A','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.698420,-77.846880,0,'2013-07-06 12:44:31',NULL,NULL),(41179,'46714','S','Bluffton','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(18836,'19425','S','Chester Sprgs','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.089503,-75.637922,0,'2013-07-06 12:44:31',NULL,NULL),(10355,'10577','S','Purchase','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.041406,-73.715358,0,'2013-07-06 12:44:30',NULL,NULL),(61611,'72811','P','Russellville','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.278223,-93.134189,0,'2013-07-06 12:44:33',NULL,NULL),(4673,'03781','S','Plainfield','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.381168,-72.177240,0,'2013-07-06 12:44:30',NULL,NULL),(32772,'36374','S','Bertha','N','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.558713,-85.543523,0,'2013-07-06 12:44:32',NULL,NULL),(14477,'15127','P','Ingomar','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.585000,-80.054465,0,'2013-07-06 12:44:31',NULL,NULL),(18894,'19472','P','Sassamansville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.339201,-75.573370,0,'2013-07-06 12:44:31',NULL,NULL),(28387,'31308','S','Ellabell','D','Bryan','13029','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.175889,-81.482070,0,'2013-07-06 12:44:32',NULL,NULL),(26577,'29217','U','City of Columbia','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.010724,-81.036122,0,'2013-07-06 12:44:31',NULL,NULL),(23810,'26050','S','Newell','D','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.612215,-80.600971,0,'2013-07-06 12:44:31',NULL,NULL),(47036,'54406','S','Amherst','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.424411,-89.318885,0,'2013-07-06 12:44:32',NULL,NULL),(49284,'56517','S','Beltrami','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.800102,-96.433917,0,'2013-07-06 12:44:33',NULL,NULL),(60460,'71653','S','McMilan Corner','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(69418,'83631','S','Pioneerville','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(15954,'17025','S','East Pennsboro','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(57097,'66219','S','Shawnee','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.965992,-94.764646,0,'2013-07-06 12:44:33',NULL,NULL),(51368,'59351','S','Volborg','D','Custer','30017','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.035585,-105.624324,0,'2013-07-06 12:44:33',NULL,NULL),(31176,'33920','S','Alva','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.711165,-81.630975,0,'2013-07-06 12:44:32',NULL,NULL),(30223,'33187','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.585600,-80.504660,0,'2013-07-06 12:44:32',NULL,NULL),(42882,'48093','S','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.516647,-83.007709,0,'2013-07-06 12:44:32',NULL,NULL),(25194,'28072','P','Granite Qry','A','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.607440,-80.444746,0,'2013-07-06 12:44:31',NULL,NULL),(27583,'30277','S','Sharpsburg','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.383410,-84.635224,0,'2013-07-06 12:44:31',NULL,NULL),(75391,'93955','S','Seaside','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.608641,-121.837368,0,'2013-07-06 12:44:34',NULL,NULL),(39402,'44661','P','Nashville','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.592914,-82.099696,0,'2013-07-06 12:44:32',NULL,NULL),(29015,'32227','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(45441,'51109','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.515558,-96.478357,0,'2013-07-06 12:44:32',NULL,NULL),(69319,'83467','S','Elk Bend','N','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.172897,-113.898929,0,'2013-07-06 12:44:34',NULL,NULL),(69451,'83647','S','Pine','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(72486,'89132','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.085836,-115.148467,0,'2013-07-06 12:44:34',NULL,NULL),(4582,'03576','S','Stewartstown','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.892390,-71.498526,0,'2013-07-06 12:44:30',NULL,NULL),(38911,'44118','S','University Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(31879,'35126','S','Dixiana','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.726300,-86.643960,0,'2013-07-06 12:44:32',NULL,NULL),(8302,'08026','S','Gibbsboro','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.833660,-74.966747,0,'2013-07-06 12:44:30',NULL,NULL),(15822,'16933','S','Canoe Camp','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(15183,'15942','S','Mineral Point','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.393290,-78.854040,0,'2013-07-06 12:44:31',NULL,NULL),(42826,'48063','S','Columbus Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.847910,-82.676031,0,'2013-07-06 12:44:32',NULL,NULL),(49008,'56255','S','Lucan','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.408035,-95.410790,0,'2013-07-06 12:44:33',NULL,NULL),(67848,'80819','P','Green Mountain Falls','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.932824,-105.016988,0,'2013-07-06 12:44:34',NULL,NULL),(5221,'04462','S','Cedar Lake Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.654650,-68.702349,0,'2013-07-06 12:44:30',NULL,NULL),(57311,'66647','P','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.038830,-95.725226,0,'2013-07-06 12:44:33',NULL,NULL),(55351,'63559','S','Novinger','D','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(9960,'10159','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(51810,'60050','S','Johnsburg','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(51387,'59417','S','Saint Mary','A','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.571299,-113.206612,0,'2013-07-06 12:44:33',NULL,NULL),(57336,'66716','S','Xenia','N','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.945353,-94.999462,0,'2013-07-06 12:44:33',NULL,NULL),(37818,'42420','S','Henderson','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.822440,-87.555260,0,'2013-07-06 12:44:32',NULL,NULL),(24161,'26591','S','Worthington','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.455841,-80.298455,0,'2013-07-06 12:44:31',NULL,NULL),(40467,'45766','S','New Marshfield','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.333878,-82.244068,0,'2013-07-06 12:44:32',NULL,NULL),(42204,'47552','S','Lincoln Boyhood National Mem','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.129410,-86.988319,0,'2013-07-06 12:44:32',NULL,NULL),(47485,'54751','S','Menomonie','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.877251,-91.923866,0,'2013-07-06 12:44:32',NULL,NULL),(73508,'91335','S','Reseda','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.199469,-118.539891,0,'2013-07-06 12:44:34',NULL,NULL),(51870,'60083','S','Old Mill Crk','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.429918,-87.932049,0,'2013-07-06 12:44:33',NULL,NULL),(25401,'28284','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229893,-80.840823,0,'2013-07-06 12:44:31',NULL,NULL),(25456,'28328','S','Clinton','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.000598,-78.339145,0,'2013-07-06 12:44:31',NULL,NULL),(45396,'51035','S','Marcus','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.819666,-95.803987,0,'2013-07-06 12:44:32',NULL,NULL),(47940,'55115','S','Saint Paul','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(43016,'48164','S','Waltz','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(40783,'46163','S','New Palestine','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.734334,-85.908374,0,'2013-07-06 12:44:32',NULL,NULL),(37659,'42210','S','Brownsville','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.198402,-86.277888,0,'2013-07-06 12:44:32',NULL,NULL),(74943,'93409','U','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.220710,-120.636882,0,'2013-07-06 12:44:34',NULL,NULL),(19641,'20265','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884326,-77.020200,0,'2013-07-06 12:44:31',NULL,NULL),(39921,'45221','U','University of Cincinnati','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.130320,-84.516932,0,'2013-07-06 12:44:32',NULL,NULL),(20485,'21048','S','Finksburg','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.504233,-76.904395,0,'2013-07-06 12:44:31',NULL,NULL),(31205,'33948','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.983322,-82.144991,0,'2013-07-06 12:44:32',NULL,NULL),(45410,'51048','S','Pierson','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.543373,-95.867850,0,'2013-07-06 12:44:32',NULL,NULL),(58816,'69032','S','Hayes Center','D','Hayes','31085','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.542924,-101.033581,0,'2013-07-06 12:44:33',NULL,NULL),(64813,'77025','S','Astroworld','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.690087,-95.433831,0,'2013-07-06 12:44:34',NULL,NULL),(66679,'78935','S','Alleyton','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.745337,-96.458108,0,'2013-07-06 12:44:34',NULL,NULL),(69039,'83221','S','Rockford','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(69779,'84058','S','Vineyard','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(70637,'85142','S','San Tan Valley','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.228018,-111.637649,0,'2013-07-06 12:44:34',NULL,NULL),(71023,'85733','P','Sun','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.085766,-111.071379,0,'2013-07-06 12:44:34',NULL,NULL),(72421,'89054','S','Sloan','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.935345,-115.206008,0,'2013-07-06 12:44:34',NULL,NULL),(6057,'05443','S','Jerusalem','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(51609,'59829','S','Darby','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.992560,-114.180694,0,'2013-07-06 12:44:33',NULL,NULL),(47513,'54772','S','Wheeler','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.042301,-91.908178,0,'2013-07-06 12:44:32',NULL,NULL),(9913,'10150','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(9486,'10012','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(75559,'94256','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583585,-121.494299,0,'2013-07-06 12:44:34',NULL,NULL),(44768,'50208','S','Lambs Grove','N','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.697096,-93.046897,0,'2013-07-06 12:44:32',NULL,NULL),(34825,'38915','S','Shepherd','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.004880,-89.360460,0,'2013-07-06 12:44:32',NULL,NULL),(32052,'35259','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.520556,-86.802500,0,'2013-07-06 12:44:32',NULL,NULL),(29595,'32830','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.370015,-81.556799,0,'2013-07-06 12:44:32',NULL,NULL),(24333,'27028','S','Farmington','N','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.908260,-80.556300,0,'2013-07-06 12:44:31',NULL,NULL),(69238,'83420','S','Ashton','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.042760,-111.375420,0,'2013-07-06 12:44:34',NULL,NULL),(48709,'55946','S','Bombay','N','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.271167,-92.988924,0,'2013-07-06 12:44:33',NULL,NULL),(39763,'45118','S','Fayetteville','D','Brown','39015','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.183132,-83.951736,0,'2013-07-06 12:44:32',NULL,NULL),(14886,'15479','S','Van Meter','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.139958,-79.727931,0,'2013-07-06 12:44:31',NULL,NULL),(36739,'41033','S','Gardnersville','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.749457,-84.473187,0,'2013-07-06 12:44:32',NULL,NULL),(12483,'12989','S','Vermontville','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.469526,-74.044265,0,'2013-07-06 12:44:30',NULL,NULL),(19720,'20392','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.933497,-77.060031,0,'2013-07-06 12:44:31',NULL,NULL),(22501,'24073','S','Christiansburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136439,-80.404000,0,'2013-07-06 12:44:31',NULL,NULL),(22512,'24085','S','Eagle Rock','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.663244,-79.835843,0,'2013-07-06 12:44:31',NULL,NULL),(43909,'49254','S','Michigan Center','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.227720,-84.324707,0,'2013-07-06 12:44:32',NULL,NULL),(44124,'49508','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.873625,-85.625143,0,'2013-07-06 12:44:32',NULL,NULL),(44830,'50252','S','Swan','D','Marion','19125','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.443405,-93.351241,0,'2013-07-06 12:44:32',NULL,NULL),(46597,'53551','S','Lake Mills','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.079375,-88.910122,0,'2013-07-06 12:44:32',NULL,NULL),(55591,'63934','S','Silva','A','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.235017,-90.363369,0,'2013-07-06 12:44:33',NULL,NULL),(65732,'78044','P','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.460208,-99.488931,0,'2013-07-06 12:44:34',NULL,NULL),(68483,'81252','S','Horn Creek','N','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.114881,-105.429189,0,'2013-07-06 12:44:34',NULL,NULL),(69620,'83869','S','Spirit Lake','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.968207,-116.854846,0,'2013-07-06 12:44:34',NULL,NULL),(71498,'87107','S','Los Ranchos de Albuquerque','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(79097,'98444','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.150660,-122.447434,0,'2013-07-06 12:44:34',NULL,NULL),(39471,'44718','S','Belden Village Mall','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.851462,-81.443104,0,'2013-07-06 12:44:32',NULL,NULL),(58833,'69120','S','Arnold','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.425135,-100.195601,0,'2013-07-06 12:44:33',NULL,NULL),(11627,'12115','S','Malden Bridge','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.456040,-73.591434,0,'2013-07-06 12:44:30',NULL,NULL),(47726,'55008','S','Spectacle Lake','N','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.562400,-93.228686,0,'2013-07-06 12:44:33',NULL,NULL),(17752,'18326','S','Cresco','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.160326,-75.252633,0,'2013-07-06 12:44:31',NULL,NULL),(35738,'39710','U','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.636366,-88.455067,0,'2013-07-06 12:44:32',NULL,NULL),(17536,'17976','S','Kohinoor Junction','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(2943,'01029','P','East Otis','D','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.159812,-73.043385,0,'2013-07-06 12:44:30',NULL,NULL),(5815,'05071','S','S Woodstock','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.555829,-72.534771,0,'2013-07-06 12:44:30',NULL,NULL),(4062,'02646','S','Harwich Port','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.673644,-70.071486,0,'2013-07-06 12:44:30',NULL,NULL),(21997,'23276','U','Capital One','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.559744,-77.446742,0,'2013-07-06 12:44:31',NULL,NULL),(50108,'57479','S','Warner','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.350260,-98.443385,0,'2013-07-06 12:44:33',NULL,NULL),(4798,'03882','S','So Effingham','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715503,-71.004712,0,'2013-07-06 12:44:30',NULL,NULL),(78576,'98168','S','Seatac','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.490093,-122.291541,0,'2013-07-06 12:44:34',NULL,NULL),(64952,'77235','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.654102,-95.481116,0,'2013-07-06 12:44:34',NULL,NULL),(63254,'75487','S','Talco','D','Franklin','48159','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.362033,-95.103676,0,'2013-07-06 12:44:33',NULL,NULL),(21396,'22508','S','Locust Grove','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.333379,-77.762530,0,'2013-07-06 12:44:31',NULL,NULL),(46257,'53013','S','Cedar Grove','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.571376,-87.844404,0,'2013-07-06 12:44:32',NULL,NULL),(22466,'24040','U','Wachovia','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.277095,-79.934639,0,'2013-07-06 12:44:31',NULL,NULL),(15730,'16882','S','Woodward','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.925398,-77.309132,0,'2013-07-06 12:44:31',NULL,NULL),(16515,'17267','S','Dott','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.776683,-78.204091,0,'2013-07-06 12:44:31',NULL,NULL),(25861,'28630','S','Baton','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.816100,-81.457140,0,'2013-07-06 12:44:31',NULL,NULL),(38923,'44122','S','Beachwood','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(78091,'97479','S','Sutherlin','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.390789,-123.296484,0,'2013-07-06 12:44:34',NULL,NULL),(62689,'74728','S','BB','N','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.027544,-94.734750,0,'2013-07-06 12:44:33',NULL,NULL),(1218,'00728','S','Urb La Providencia','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(58844,'69131','S','Dalton','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408249,-102.969507,0,'2013-07-06 12:44:33',NULL,NULL),(76004,'95115','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.304232,-121.887889,0,'2013-07-06 12:44:34',NULL,NULL),(64388,'76534','S','Sparks','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.877288,-97.404648,0,'2013-07-06 12:44:34',NULL,NULL),(64066,'76136','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.899378,-97.458124,0,'2013-07-06 12:44:34',NULL,NULL),(9307,'09718','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(27980,'30571','S','Saute-Nacoche','A','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.743332,-83.716475,0,'2013-07-06 12:44:31',NULL,NULL),(36147,'40241','S','Brwnsboro Frm','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(75087,'93535','S','Lake La','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(30636,'33446','S','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.451567,-80.173388,0,'2013-07-06 12:44:32',NULL,NULL),(53023,'61469','S','Oquawka','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.944763,-90.883365,0,'2013-07-06 12:44:33',NULL,NULL),(35201,'39289','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.385455,-90.276532,0,'2013-07-06 12:44:32',NULL,NULL),(59805,'71225','S','Carlton','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.527647,-92.314023,0,'2013-07-06 12:44:33',NULL,NULL),(61895,'73139','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.393759,-97.524997,0,'2013-07-06 12:44:33',NULL,NULL),(30308,'33303','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.198883,-80.095109,0,'2013-07-06 12:44:32',NULL,NULL),(22534,'24114','P','Martinsville','D','Martinsville City','51690','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.683887,-79.864118,0,'2013-07-06 12:44:31',NULL,NULL),(2872,'00986','P','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.408856,-65.981189,0,'2013-07-06 12:44:30',NULL,NULL),(12474,'12985','S','Schuyler Falls','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.578980,-73.716120,0,'2013-07-06 12:44:30',NULL,NULL),(48257,'55427','S','Crystal','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996340,-93.379980,0,'2013-07-06 12:44:33',NULL,NULL),(32035,'35243','S','Vestavia','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(54731,'62966','S','Levan','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(59075,'70115','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.924584,-90.101956,0,'2013-07-06 12:44:33',NULL,NULL),(77766,'97116','S','Forest Grove','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.522072,-123.107074,0,'2013-07-06 12:44:34',NULL,NULL),(48286,'55435','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.874000,-93.343860,0,'2013-07-06 12:44:33',NULL,NULL),(48409,'55597','P','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.102352,-93.658396,0,'2013-07-06 12:44:33',NULL,NULL),(40434,'45714','S','Belpre','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.288600,-81.595680,0,'2013-07-06 12:44:32',NULL,NULL),(26264,'29010','S','Alcot','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(12106,'12580','S','Staatsburgh','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.846035,-73.910551,0,'2013-07-06 12:44:30',NULL,NULL),(32801,'36435','S','Coy','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.891108,-87.331404,0,'2013-07-06 12:44:32',NULL,NULL),(73280,'90745','S','Carson','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.820353,-118.266179,0,'2013-07-06 12:44:34',NULL,NULL),(73150,'90290','S','Topanga','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.104396,-118.604094,0,'2013-07-06 12:44:34',NULL,NULL),(68291,'81089','S','Toltec','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(56591,'65556','S','Richland','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.857338,-92.400215,0,'2013-07-06 12:44:33',NULL,NULL),(45407,'51046','S','Germantown','N','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.974580,-95.706300,0,'2013-07-06 12:44:32',NULL,NULL),(34230,'38372','S','Savannah','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.226194,-88.233434,0,'2013-07-06 12:44:32',NULL,NULL),(60619,'71864','P','Willisville','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.489851,-93.301468,0,'2013-07-06 12:44:33',NULL,NULL),(50721,'58374','S','Sheyenne','D','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.828806,-99.117344,0,'2013-07-06 12:44:33',NULL,NULL),(51605,'59826','S','Condon','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.490393,-113.715644,0,'2013-07-06 12:44:33',NULL,NULL),(51859,'60074','S','Kildeer','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.145690,-88.027592,0,'2013-07-06 12:44:33',NULL,NULL),(60361,'71473','S','Hart','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.067300,-92.422500,0,'2013-07-06 12:44:33',NULL,NULL),(66558,'78735','S','Sunset Valley','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.264300,-97.865340,0,'2013-07-06 12:44:34',NULL,NULL),(42432,'47803','S','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.465549,-87.354311,0,'2013-07-06 12:44:32',NULL,NULL),(20836,'21639','S','Greensboro','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.975235,-75.808602,0,'2013-07-06 12:44:31',NULL,NULL),(55926,'64466','S','Maitland','D','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.203260,-95.076602,0,'2013-07-06 12:44:33',NULL,NULL),(34061,'38145','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142373,-90.050604,0,'2013-07-06 12:44:32',NULL,NULL),(35717,'39669','S','Fort Adams','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(46499,'53228','S','Greenfield','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.966203,-88.043196,0,'2013-07-06 12:44:32',NULL,NULL),(73896,'91987','U','Tk Manufacturing','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.592436,-116.638994,0,'2013-07-06 12:44:34',NULL,NULL),(22259,'23681','U','Nasa','N','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.088709,-76.366965,0,'2013-07-06 12:44:31',NULL,NULL),(26339,'29059','S','Holly Hill','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.322019,-80.412299,0,'2013-07-06 12:44:31',NULL,NULL),(44831,'50254','S','Talmage','N','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.985232,-94.072081,0,'2013-07-06 12:44:32',NULL,NULL),(79998,'99665','P','Shageluk','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.649355,-159.792051,0,'2013-07-06 12:44:34',NULL,NULL),(70553,'85037','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.494055,-112.254448,0,'2013-07-06 12:44:34',NULL,NULL),(66065,'78381','P','Rockport','D','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.007465,-97.060724,0,'2013-07-06 12:44:34',NULL,NULL),(30118,'33161','S','Nmb','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(45472,'51301','S','Spencer','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.144591,-95.144154,0,'2013-07-06 12:44:32',NULL,NULL),(5575,'04901','S','Winslow','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.554203,-69.630648,0,'2013-07-06 12:44:30',NULL,NULL),(13357,'13730','S','Afton','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.209640,-75.490260,0,'2013-07-06 12:44:31',NULL,NULL),(33195,'37041','P','Clarksville','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.561204,-87.348735,0,'2013-07-06 12:44:32',NULL,NULL),(49063,'56310','S','Avon','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.624787,-94.445931,0,'2013-07-06 12:44:33',NULL,NULL),(18741,'19339','U','State Farm Insurance','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.899120,-75.504198,0,'2013-07-06 12:44:31',NULL,NULL),(11405,'11954','S','Montauk','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.041068,-71.950598,0,'2013-07-06 12:44:30',NULL,NULL),(10625,'11050','S','The Terrace','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(76411,'95554','S','Myers Flat','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.296472,-123.803222,0,'2013-07-06 12:44:34',NULL,NULL),(37556,'42064','S','Winslow Park','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(74285,'92363','S','Chemehuevi Valley','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.833512,-114.602406,0,'2013-07-06 12:44:34',NULL,NULL),(32399,'35956','S','Sardis City','A','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.203788,-86.154159,0,'2013-07-06 12:44:32',NULL,NULL),(14193,'14757','S','Mayville','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.250678,-79.500191,0,'2013-07-06 12:44:31',NULL,NULL),(58395,'68626','S','Brainard','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.175159,-96.967982,0,'2013-07-06 12:44:33',NULL,NULL),(60893,'72069','S','Lawrenceville','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(51090,'58769','S','Palermo','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.329944,-102.245364,0,'2013-07-06 12:44:33',NULL,NULL),(47829,'55069','S','Rush City','D','Chisago','27025','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.684410,-92.967539,0,'2013-07-06 12:44:33',NULL,NULL),(29091,'32260','P','Jacksonville','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.077501,-81.580838,0,'2013-07-06 12:44:32',NULL,NULL),(49494,'56661','S','Wildwood','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(1717,'00778','S','Ext Llanos de Gurabo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(28978,'32211','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.329252,-81.579613,0,'2013-07-06 12:44:32',NULL,NULL),(23964,'26293','S','Valley Bend','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.795403,-79.924628,0,'2013-07-06 12:44:31',NULL,NULL),(43364,'48410','P','Argyle','D','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.564218,-82.928368,0,'2013-07-06 12:44:32',NULL,NULL),(52601,'61020','S','Davis Junction','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.103439,-89.090160,0,'2013-07-06 12:44:33',NULL,NULL),(76958,'96041','S','Peanut','N','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.511880,-123.235800,0,'2013-07-06 12:44:34',NULL,NULL),(45118,'50560','S','Irvington','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.912847,-94.084571,0,'2013-07-06 12:44:32',NULL,NULL),(12774,'13212','S','N Syracuse','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.110960,-76.139280,0,'2013-07-06 12:44:30',NULL,NULL),(8456,'08087','S','Mystic Islnds','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(7841,'07461','S','Wantage Twp','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(27338,'30040','S','Cumming','D','Forsyth','13117','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.249703,-84.175246,0,'2013-07-06 12:44:31',NULL,NULL),(21596,'22847','S','Quicksburg','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.725788,-78.712644,0,'2013-07-06 12:44:31',NULL,NULL),(46818,'54009','S','Sandlake','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.362975,-92.621521,0,'2013-07-06 12:44:32',NULL,NULL),(75467,'94089','S','Sunnyvale','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.401284,-122.008179,0,'2013-07-06 12:44:34',NULL,NULL),(72697,'89447','S','Yerington','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.921460,-119.117640,0,'2013-07-06 12:44:34',NULL,NULL),(41522,'46985','S','Star City','D','Pulaski','18131','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.957243,-86.526445,0,'2013-07-06 12:44:32',NULL,NULL),(19418,'20090','P','General Delivery','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878902,-77.015978,0,'2013-07-06 12:44:31',NULL,NULL),(61353,'72476','S','Light','N','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.090720,-90.959580,0,'2013-07-06 12:44:33',NULL,NULL),(6869,'06137','P','Bishops Corner','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(51737,'60014','S','Crystal Lake','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.230860,-88.326944,0,'2013-07-06 12:44:33',NULL,NULL),(30494,'33388','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.117073,-80.254184,0,'2013-07-06 12:44:32',NULL,NULL),(31826,'35070','P','Garden City','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.015138,-86.748672,0,'2013-07-06 12:44:32',NULL,NULL),(13766,'14136','S','Silver Creek','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.536350,-79.168058,0,'2013-07-06 12:44:31',NULL,NULL),(38036,'43030','P','Jacksontown','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.960557,-82.413494,0,'2013-07-06 12:44:32',NULL,NULL),(36768,'41041','S','Sutton','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(47716,'55005','S','East Bethel','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.392640,-93.211800,0,'2013-07-06 12:44:33',NULL,NULL),(50144,'57536','S','Harrold','D','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.524105,-99.741834,0,'2013-07-06 12:44:33',NULL,NULL),(53245,'61701','S','Barnes','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(54115,'62548','S','Mt Pulaski','N','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.009094,-89.284725,0,'2013-07-06 12:44:33',NULL,NULL),(55203,'63385','S','Gilmore','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.798044,-90.860524,0,'2013-07-06 12:44:33',NULL,NULL),(59471,'70748','S','Jackson','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.777809,-91.210024,0,'2013-07-06 12:44:33',NULL,NULL),(38656,'43942','S','Powhatan Point','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.862119,-80.816459,0,'2013-07-06 12:44:32',NULL,NULL),(52022,'60177','S','South Elgin','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',41.993436,-88.295863,0,'2013-07-06 12:44:33',NULL,NULL),(45391,'51031','S','Le Mars','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.786590,-96.172617,0,'2013-07-06 12:44:32',NULL,NULL),(19239,'19930','S','South Bethany','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.530364,-75.062715,0,'2013-07-06 12:44:31',NULL,NULL),(6237,'05491','S','Potash Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(32351,'35810','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.781112,-86.605454,0,'2013-07-06 12:44:32',NULL,NULL),(11789,'12212','P','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679670,-73.840113,0,'2013-07-06 12:44:30',NULL,NULL),(5313,'04565','P','Sebasco Estates','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.778808,-69.848458,0,'2013-07-06 12:44:30',NULL,NULL),(14831,'15431','S','Dunbar','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.957225,-79.609197,0,'2013-07-06 12:44:31',NULL,NULL),(4341,'03040','P','E Candia','N','Rockingham','33015','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.045480,-71.247063,0,'2013-07-06 12:44:30',NULL,NULL),(38637,'43931','P','Hannibal','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.664786,-80.877461,0,'2013-07-06 12:44:32',NULL,NULL),(7399,'06792','U','Mbi Inc','N','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.754900,-73.058200,0,'2013-07-06 12:44:30',NULL,NULL),(31040,'33810','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.112240,-82.015226,0,'2013-07-06 12:44:32',NULL,NULL),(26866,'29543','S','Fork','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.288639,-79.241710,0,'2013-07-06 12:44:31',NULL,NULL),(25623,'28461','S','Oak Island','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(43319,'48359','S','Orion','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722304,-83.277927,0,'2013-07-06 12:44:32',NULL,NULL),(49347,'56570','S','Snellman','N','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.932684,-95.224283,0,'2013-07-06 12:44:33',NULL,NULL),(49987,'57366','S','Marcy Colony','N','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.394273,-97.988210,0,'2013-07-06 12:44:33',NULL,NULL),(50371,'57756','P','Manderson','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.300674,-102.383533,0,'2013-07-06 12:44:33',NULL,NULL),(64159,'76208','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.194850,-97.056584,0,'2013-07-06 12:44:34',NULL,NULL),(77450,'96811','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.326884,-157.828158,0,'2013-07-06 12:44:34',NULL,NULL),(53147,'61554','S','Schaeferville','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(50095,'57471','S','Gretna','N','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.429120,-99.336780,0,'2013-07-06 12:44:33',NULL,NULL),(62718,'74761','P','Swink','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.017732,-95.198626,0,'2013-07-06 12:44:33',NULL,NULL),(77526,'96847','U','First Hawaiian Bank','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.301543,-157.845453,0,'2013-07-06 12:44:34',NULL,NULL),(9088,'09046','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9399,'09870','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30557,'33412','S','Palm Beach Gardens','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(25031,'27893','S','Wilson','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.732520,-77.920181,0,'2013-07-06 12:44:31',NULL,NULL),(73519,'91343','S','Sepulveda','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.237131,-118.481042,0,'2013-07-06 12:44:34',NULL,NULL),(74811,'93212','S','Corcoran','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.096009,-119.571693,0,'2013-07-06 12:44:34',NULL,NULL),(40347,'45622','S','Creola','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.383811,-82.529439,0,'2013-07-06 12:44:32',NULL,NULL),(37459,'41858','S','Day Rural','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(14221,'14802','S','Alfred','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.255151,-77.785384,0,'2013-07-06 12:44:31',NULL,NULL),(1666,'00773','S','Urb Luquillo Mar','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(8712,'08405','U','Atlantic City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.366054,-74.422413,0,'2013-07-06 12:44:30',NULL,NULL),(41457,'46903','P','Kokomo','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.475045,-86.131830,0,'2013-07-06 12:44:32',NULL,NULL),(41921,'47381','S','Salamonia','D','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.350997,-84.851952,0,'2013-07-06 12:44:32',NULL,NULL),(48095,'55341','S','Hanover','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.161338,-93.655523,0,'2013-07-06 12:44:33',NULL,NULL),(48189,'55391','S','Orono','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.966040,-93.541800,0,'2013-07-06 12:44:33',NULL,NULL),(71709,'87528','S','Dulce','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.947461,-106.988234,0,'2013-07-06 12:44:34',NULL,NULL),(73175,'90311','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.957310,-118.358381,0,'2013-07-06 12:44:34',NULL,NULL),(3462,'01803','S','Burlington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.508545,-71.201304,0,'2013-07-06 12:44:30',NULL,NULL),(56146,'64848','S','Larussell','N','Lawrence','29109','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.193142,-94.016140,0,'2013-07-06 12:44:33',NULL,NULL),(37282,'41605','S','Betsy Layne','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.542142,-82.692771,0,'2013-07-06 12:44:32',NULL,NULL),(51689,'59935','S','Yaak','N','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.462428,-115.874402,0,'2013-07-06 12:44:33',NULL,NULL),(36870,'41093','S','Wallingford','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.341084,-83.555814,0,'2013-07-06 12:44:32',NULL,NULL),(204,'00623','S','Urb San Miguel','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(50996,'58653','S','Haley','N','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.112711,-103.120110,0,'2013-07-06 12:44:33',NULL,NULL),(24012,'26354','S','Haymond','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.343632,-80.022519,0,'2013-07-06 12:44:31',NULL,NULL),(21074,'22025','S','Dumfries','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.874600,-77.923200,0,'2013-07-06 12:44:31',NULL,NULL),(12466,'12980','S','Saint Regis Falls','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.656564,-74.564467,0,'2013-07-06 12:44:30',NULL,NULL),(18749,'19343','S','W Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.094368,-75.750753,0,'2013-07-06 12:44:31',NULL,NULL),(64505,'76632','S','Mooresville','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.300172,-97.109830,0,'2013-07-06 12:44:34',NULL,NULL),(5610,'04936','S','Chain of Pnds','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182634,-70.491461,0,'2013-07-06 12:44:30',NULL,NULL),(3288,'01504','S','E Blackstone','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.026266,-71.528483,0,'2013-07-06 12:44:30',NULL,NULL),(815,'00693','S','Urb Las Flores','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(22615,'24219','S','Big Stone Gap','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.869831,-82.774127,0,'2013-07-06 12:44:31',NULL,NULL),(42441,'47805','S','N Terre Haute','A','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(47430,'54670','S','Wilton','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.814109,-90.531731,0,'2013-07-06 12:44:32',NULL,NULL),(49019,'56265','S','Montevideo','D','Chippewa','27023','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.947794,-95.714191,0,'2013-07-06 12:44:33',NULL,NULL),(51333,'59273','S','Vandalia','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.356238,-106.909833,0,'2013-07-06 12:44:33',NULL,NULL),(59818,'71233','P','Delta','D','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.320750,-90.925348,0,'2013-07-06 12:44:33',NULL,NULL),(48797,'56007','S','Manchester','A','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.650835,-93.371347,0,'2013-07-06 12:44:33',NULL,NULL),(46550,'53407','U','WI Natural Gas Co','N','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.726079,-87.783375,0,'2013-07-06 12:44:32',NULL,NULL),(17166,'17814','S','Fairmount Spr','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(5614,'04936','S','Jim Pond Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182634,-70.491461,0,'2013-07-06 12:44:30',NULL,NULL),(22446,'24020','P','Hollins College','A','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.245254,-80.030639,0,'2013-07-06 12:44:31',NULL,NULL),(30979,'33747','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.772495,-82.679889,0,'2013-07-06 12:44:32',NULL,NULL),(25828,'28617','S','Chestnut Hill','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.460860,-81.413640,0,'2013-07-06 12:44:31',NULL,NULL),(2895,'00987','S','Terrs de Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(66184,'78537','S','Donna','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.171006,-98.055232,0,'2013-07-06 12:44:34',NULL,NULL),(17917,'18459','P','South Canaan','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.503648,-75.413679,0,'2013-07-06 12:44:31',NULL,NULL),(17386,'17888','S','Wilburton','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.813401,-76.376948,0,'2013-07-06 12:44:31',NULL,NULL),(19566,'20210','U','Dept of Labor','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889938,-77.012346,0,'2013-07-06 12:44:31',NULL,NULL),(7077,'06340','S','Jupiter Point','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(63110,'75284','U','Bank of America','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768664,-96.827092,0,'2013-07-06 12:44:33',NULL,NULL),(67310,'80022','S','Denver','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.831897,-104.894182,0,'2013-07-06 12:44:34',NULL,NULL),(76976,'96057','S','McCloud','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.371800,-121.885080,0,'2013-07-06 12:44:34',NULL,NULL),(77791,'97133','S','North Plains','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.597975,-122.995930,0,'2013-07-06 12:44:34',NULL,NULL),(439,'00662','S','Urb Costa Brava','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(37072,'41314','S','Morris Fork','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(8345,'08043','S','Kirkwd Vrhes','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(58449,'68719','S','Bristow','D','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.892730,-98.602953,0,'2013-07-06 12:44:33',NULL,NULL),(78125,'97525','S','Gold Hill','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.462540,-123.088200,0,'2013-07-06 12:44:34',NULL,NULL),(60838,'72040','S','Four Mile Corner','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(3516,'01880','S','Wakefield','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.502111,-71.069674,0,'2013-07-06 12:44:30',NULL,NULL),(18657,'19175','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.949991,-75.154637,0,'2013-07-06 12:44:31',NULL,NULL),(35832,'39771','S','Walthall','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.613941,-89.366226,0,'2013-07-06 12:44:32',NULL,NULL),(36975,'41179','S','Petersville','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(34508,'38674','S','Tiplersville','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.903866,-88.918583,0,'2013-07-06 12:44:32',NULL,NULL),(11842,'12247','U','New York State Gov','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.682270,-73.727879,0,'2013-07-06 12:44:30',NULL,NULL),(53912,'62373','S','Sutter','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.292944,-91.386089,0,'2013-07-06 12:44:33',NULL,NULL),(76297,'95437','S','Noyo','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(58174,'68304','S','Alvo','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.869803,-96.385970,0,'2013-07-06 12:44:33',NULL,NULL),(601,'00680','S','Urb Monterey','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(39047,'44190','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.503501,-81.621160,0,'2013-07-06 12:44:32',NULL,NULL),(14636,'15234','S','BRA# 52','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(26679,'29404','S','Charleston AFB','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(53603,'62079','S','Piasa','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.130671,-90.120036,0,'2013-07-06 12:44:33',NULL,NULL),(70390,'84701','S','Burrville','N','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.675160,-111.989820,0,'2013-07-06 12:44:34',NULL,NULL),(71388,'87006','S','Sabinal','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.561472,-106.781071,0,'2013-07-06 12:44:34',NULL,NULL),(73412,'91182','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.148771,-118.140407,0,'2013-07-06 12:44:34',NULL,NULL),(44217,'49642','S','Idlewild','D','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.889548,-85.782464,0,'2013-07-06 12:44:32',NULL,NULL),(28591,'31638','S','Morven','D','Brooks','13027','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.903326,-83.496047,0,'2013-07-06 12:44:32',NULL,NULL),(34232,'38375','S','Lawton','N','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.153700,-88.611000,0,'2013-07-06 12:44:32',NULL,NULL),(55522,'63820','P','Anniston','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.834055,-89.364267,0,'2013-07-06 12:44:33',NULL,NULL),(3175,'01330','S','South Ashfield','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.521400,-72.813120,0,'2013-07-06 12:44:30',NULL,NULL),(6929,'06160','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.771494,-72.707813,0,'2013-07-06 12:44:30',NULL,NULL),(49724,'57042','S','Madison','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.008120,-97.113629,0,'2013-07-06 12:44:33',NULL,NULL),(61300,'72422','S','Corning','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.411931,-90.587967,0,'2013-07-06 12:44:33',NULL,NULL),(8240,'08003','S','Cherry Hill','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.881958,-74.970489,0,'2013-07-06 12:44:30',NULL,NULL),(64590,'76673','S','Mount Calm','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.762263,-96.911319,0,'2013-07-06 12:44:34',NULL,NULL),(22892,'24586','S','Ringgold','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.591963,-79.308479,0,'2013-07-06 12:44:31',NULL,NULL),(37147,'41465','S','Ivyton','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(41623,'47129','S','Clarksville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.316146,-85.769135,0,'2013-07-06 12:44:32',NULL,NULL),(42123,'47471','S','Pt Commerce','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.118499,-86.979363,0,'2013-07-06 12:44:32',NULL,NULL),(73294,'90801','P','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.773782,-118.186314,0,'2013-07-06 12:44:34',NULL,NULL),(42260,'47579','S','Xmas Lk Vlg','A','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.104943,-86.928717,0,'2013-07-06 12:44:32',NULL,NULL),(8838,'08638','S','Ewing','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.266540,-74.712840,0,'2013-07-06 12:44:30',NULL,NULL),(64449,'76570','S','Briary','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(2180,'00926','S','Ind Victor Fernandez','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(66683,'78941','S','Cistern','N','Fayette','48149','Texas','TX','48','0000','361','Central',-6.0,'Y',29.687084,-97.108065,0,'2013-07-06 12:44:34',NULL,NULL),(31357,'34203','S','Lakewood Ranch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.443170,-82.531219,0,'2013-07-06 12:44:32',NULL,NULL),(15978,'17032','S','Reed','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(46957,'54182','P','Bonduel','A','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.733306,-88.358285,0,'2013-07-06 12:44:32',NULL,NULL),(50475,'58045','S','Hillsboro','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.400171,-97.060426,0,'2013-07-06 12:44:33',NULL,NULL),(16707,'17403','S','Botts','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(67671,'80498','S','Heeney','A','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.060000,-106.400000,0,'2013-07-06 12:44:34',NULL,NULL),(61774,'73064','S','Mustang','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.390347,-97.728864,0,'2013-07-06 12:44:33',NULL,NULL),(15702,'16852','S','Madisonburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.941285,-77.498441,0,'2013-07-06 12:44:31',NULL,NULL),(33654,'37711','S','Bulls Gap','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.269293,-83.102067,0,'2013-07-06 12:44:32',NULL,NULL),(4788,'03870','S','Rye','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.007023,-70.767292,0,'2013-07-06 12:44:30',NULL,NULL),(43642,'48835','S','Fowler','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.010137,-84.749958,0,'2013-07-06 12:44:32',NULL,NULL),(44323,'49748','P','Hulbert','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.355616,-85.156135,0,'2013-07-06 12:44:32',NULL,NULL),(64034,'76124','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.758223,-97.205267,0,'2013-07-06 12:44:34',NULL,NULL),(48763,'55979','S','Utica','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.945993,-91.935120,0,'2013-07-06 12:44:33',NULL,NULL),(56433,'65265','S','Mexico','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.167340,-91.870440,0,'2013-07-06 12:44:33',NULL,NULL),(79223,'98546','S','Grapeview','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.331222,-122.904914,0,'2013-07-06 12:44:34',NULL,NULL),(9958,'10158','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(46102,'52626','S','Farmington','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.649487,-91.745867,0,'2013-07-06 12:44:32',NULL,NULL),(63173,'75402','S','Greenville','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.071077,-96.085608,0,'2013-07-06 12:44:33',NULL,NULL),(23681,'25841','S','Flat Top','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.545399,-81.119412,0,'2013-07-06 12:44:31',NULL,NULL),(21748,'23040','S','Cumberland','D','Cumberland','51049','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.509967,-78.242868,0,'2013-07-06 12:44:31',NULL,NULL),(25363,'28241','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227662,-80.843582,0,'2013-07-06 12:44:31',NULL,NULL),(9629,'10035','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(72751,'89510','S','Pyramid','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(66424,'78640','S','Kyle','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.006600,-97.807140,0,'2013-07-06 12:44:34',NULL,NULL),(33177,'37030','S','So Carthage','A','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.262380,-85.994400,0,'2013-07-06 12:44:32',NULL,NULL),(31593,'34660','P','Ozona','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.066568,-82.777726,0,'2013-07-06 12:44:32',NULL,NULL),(62023,'73459','S','Thackerville','D','Love','40085','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.789735,-97.135258,0,'2013-07-06 12:44:33',NULL,NULL),(22436,'24016','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271578,-79.950125,0,'2013-07-06 12:44:31',NULL,NULL),(54702,'62951','S','Shakerag','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.819324,-88.924585,0,'2013-07-06 12:44:33',NULL,NULL),(13313,'13674','P','Pierrepont Manor','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.735379,-76.058567,0,'2013-07-06 12:44:30',NULL,NULL),(57591,'67074','S','Leon','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.692456,-96.784325,0,'2013-07-06 12:44:33',NULL,NULL),(60424,'71643','S','Cole Spur','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.984603,-91.556472,0,'2013-07-06 12:44:33',NULL,NULL),(36110,'40222','S','Crossgate','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(64217,'76267','P','Slidell','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.356794,-97.391325,0,'2013-07-06 12:44:34',NULL,NULL),(52166,'60455','S','Oak Lawn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.737459,-87.803915,0,'2013-07-06 12:44:33',NULL,NULL),(2852,'00983','S','Villa Asturias','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(14073,'14607','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.151853,-77.593546,0,'2013-07-06 12:44:31',NULL,NULL),(15735,'16901','S','Draper','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(4554,'03457','S','Munsonville','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.002905,-72.144980,0,'2013-07-06 12:44:30',NULL,NULL),(79843,'99540','S','Indian','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.116878,-149.899764,0,'2013-07-06 12:44:34',NULL,NULL),(74509,'92646','S','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.665392,-117.968576,0,'2013-07-06 12:44:34',NULL,NULL),(48391,'55579','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996510,-93.710861,0,'2013-07-06 12:44:33',NULL,NULL),(12,'00602','S','Comunidad Las Flores','N','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(5504,'04763','S','Oakfield','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.106875,-68.096989,0,'2013-07-06 12:44:30',NULL,NULL),(52721,'61231','S','Aledo','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(18242,'18977','S','Washington Xing','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.291900,-74.884277,0,'2013-07-06 12:44:31',NULL,NULL),(46481,'53220','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.961389,-88.012500,0,'2013-07-06 12:44:32',NULL,NULL),(68128,'80960','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.810217,-104.816961,0,'2013-07-06 12:44:34',NULL,NULL),(10504,'10968','S','Grand View-On-Hudson','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.039429,-73.921498,0,'2013-07-06 12:44:30',NULL,NULL),(24756,'27539','S','Apex','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.712518,-78.823489,0,'2013-07-06 12:44:31',NULL,NULL),(8659,'08318','S','Centerton','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(53722,'62244','S','Fults','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.163740,-90.201178,0,'2013-07-06 12:44:33',NULL,NULL),(5514,'04774','S','Allagash','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.101533,-69.051562,0,'2013-07-06 12:44:30',NULL,NULL),(22958,'24701','S','Bluefield','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(24536,'27292','S','Churchland','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(16411,'17224','S','Metal','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(67209,'79916','S','El Paso','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.944107,-106.179974,0,'2013-07-06 12:44:34',NULL,NULL),(3720,'02145','S','Winter Hill','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.391409,-71.094721,0,'2013-07-06 12:44:30',NULL,NULL),(61567,'72730','S','Farmington','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.043692,-94.238565,0,'2013-07-06 12:44:33',NULL,NULL),(67943,'80911','S','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(18750,'19343','S','West Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.094368,-75.750753,0,'2013-07-06 12:44:31',NULL,NULL),(12223,'12809','S','South Argyle','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.236780,-73.456980,0,'2013-07-06 12:44:30',NULL,NULL),(10793,'11370','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760333,-73.890833,0,'2013-07-06 12:44:30',NULL,NULL),(50426,'57790','S','Dowling','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.255280,-102.207790,0,'2013-07-06 12:44:33',NULL,NULL),(23102,'24935','S','Indian Mills','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.554495,-80.831424,0,'2013-07-06 12:44:31',NULL,NULL),(53039,'61478','S','Ellison','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.722363,-90.727749,0,'2013-07-06 12:44:33',NULL,NULL),(48265,'55428','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(46655,'53704','S','Maple Bluff','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.117217,-89.335082,0,'2013-07-06 12:44:32',NULL,NULL),(13274,'13654','S','Pope Mills','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.582100,-75.440160,0,'2013-07-06 12:44:30',NULL,NULL),(7675,'07096','P','Meadows','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.781235,-74.064580,0,'2013-07-06 12:44:30',NULL,NULL),(15425,'16367','U','New Process Co','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846440,-79.146417,0,'2013-07-06 12:44:31',NULL,NULL),(55360,'63563','S','Rutledge','D','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.348929,-92.107301,0,'2013-07-06 12:44:33',NULL,NULL),(15645,'16735','S','East Kane','N','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.663640,-78.790860,0,'2013-07-06 12:44:31',NULL,NULL),(68782,'82329','S','Medicine Bow','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.899425,-106.203240,0,'2013-07-06 12:44:34',NULL,NULL),(62155,'73728','S','Cherokee','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.755620,-98.350679,0,'2013-07-06 12:44:33',NULL,NULL),(22840,'24523','S','Bedford','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.334622,-79.522483,0,'2013-07-06 12:44:31',NULL,NULL),(29097,'32266','S','Neptune Beach','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.315188,-81.404431,0,'2013-07-06 12:44:32',NULL,NULL),(18357,'19037','P','Lima','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.901166,-75.442291,0,'2013-07-06 12:44:31',NULL,NULL),(48830,'56043','S','Hayward','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.646014,-93.245401,0,'2013-07-06 12:44:33',NULL,NULL),(9526,'10019','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(71250,'86403','S','Lake Havasu City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.487063,-114.330287,0,'2013-07-06 12:44:34',NULL,NULL),(68213,'81047','S','Cheney Center','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.982565,-102.140804,0,'2013-07-06 12:44:34',NULL,NULL),(29245,'32438','S','Fountain','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.482956,-85.422367,0,'2013-07-06 12:44:32',NULL,NULL),(45124,'50565','S','Marathon','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.859938,-94.983964,0,'2013-07-06 12:44:32',NULL,NULL),(38483,'43659','U','Owens Corning','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.649245,-83.536795,0,'2013-07-06 12:44:32',NULL,NULL),(5322,'04573','S','Walpole','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.942985,-69.553344,0,'2013-07-06 12:44:30',NULL,NULL),(64276,'76430','S','Albany','D','Shackelford','48417','Texas','TX','48','0000','325','Central',-6.0,'Y',32.730230,-99.293869,0,'2013-07-06 12:44:34',NULL,NULL),(41485,'46938','S','Jonesboro','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.475900,-85.623772,0,'2013-07-06 12:44:32',NULL,NULL),(833,'00693','S','Vista Verde','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(58647,'68872','S','Saint Libory','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.082458,-98.362472,0,'2013-07-06 12:44:33',NULL,NULL),(7861,'07501','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.913332,-74.175473,0,'2013-07-06 12:44:30',NULL,NULL),(44205,'49629','S','Elk Rapids','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.904646,-85.399511,0,'2013-07-06 12:44:32',NULL,NULL),(79556,'99008','S','Edwall','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.493709,-117.816492,0,'2013-07-06 12:44:34',NULL,NULL),(47070,'54426','S','Fenwood','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.892081,-89.992307,0,'2013-07-06 12:44:32',NULL,NULL),(50480,'58047','S','Horace','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.717620,-96.856680,0,'2013-07-06 12:44:33',NULL,NULL),(38569,'43778','S','Salesville','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.005360,-81.385560,0,'2013-07-06 12:44:32',NULL,NULL),(34528,'38683','S','Chalybeate','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.947755,-88.899821,0,'2013-07-06 12:44:32',NULL,NULL),(57671,'67217','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.624467,-97.361850,0,'2013-07-06 12:44:33',NULL,NULL),(40376,'45652','S','Mc Dermott','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.842800,-83.081400,0,'2013-07-06 12:44:32',NULL,NULL),(75206,'93630','S','Kerman','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.735924,-120.074457,0,'2013-07-06 12:44:34',NULL,NULL),(55258,'63456','S','Monroe City','D','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.653180,-91.730329,0,'2013-07-06 12:44:33',NULL,NULL),(63464,'75685','P','Latex','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.441546,-93.973308,0,'2013-07-06 12:44:33',NULL,NULL),(8735,'08515','S','Chesterfield','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.153936,-74.650330,0,'2013-07-06 12:44:30',NULL,NULL),(16732,'17415','U','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.964657,-76.729258,0,'2013-07-06 12:44:31',NULL,NULL),(14583,'15220','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425951,-80.048689,0,'2013-07-06 12:44:31',NULL,NULL),(15697,'16848','P','Lamar','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.016265,-77.531108,0,'2013-07-06 12:44:31',NULL,NULL),(12242,'12823','S','Cossayuna','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.173480,-73.411500,0,'2013-07-06 12:44:30',NULL,NULL),(10943,'11436','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678055,-73.797848,0,'2013-07-06 12:44:30',NULL,NULL),(44411,'49827','S','Engadine','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.208679,-85.595465,0,'2013-07-06 12:44:32',NULL,NULL),(10980,'11545','S','Glen Head','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(66078,'78389','S','Olmos','N','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.254041,-97.650357,0,'2013-07-06 12:44:34',NULL,NULL),(50820,'58466','S','Marion','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.562135,-98.244893,0,'2013-07-06 12:44:33',NULL,NULL),(61247,'72348','S','Horseshoe Lake','A','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.920523,-90.311029,0,'2013-07-06 12:44:33',NULL,NULL),(7232,'06507','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.305516,-72.922831,0,'2013-07-06 12:44:30',NULL,NULL),(38527,'43732','S','Cumberland','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.883082,-81.641698,0,'2013-07-06 12:44:32',NULL,NULL),(12872,'13324','S','Ohio','A','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(70592,'85086','S','Desert Hills','A','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.846680,-112.093223,0,'2013-07-06 12:44:34',NULL,NULL),(79299,'98586','S','South Bend','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.661172,-123.809548,0,'2013-07-06 12:44:34',NULL,NULL),(55637,'64014','S','Blue Springs','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.017346,-94.260374,0,'2013-07-06 12:44:33',NULL,NULL),(60449,'71651','S','Morobay','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.347207,-92.285793,0,'2013-07-06 12:44:33',NULL,NULL),(29615,'32858','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.554201,-81.449787,0,'2013-07-06 12:44:32',NULL,NULL),(7135,'06390','P','Fishers Isle','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.250000,-72.020000,0,'2013-07-06 12:44:30',NULL,NULL),(22658,'24271','S','Nickelsville','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.752077,-82.419781,0,'2013-07-06 12:44:31',NULL,NULL),(72093,'88203','S','Roswell','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.397297,-104.521731,0,'2013-07-06 12:44:34',NULL,NULL),(25781,'28604','S','Balm','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(20666,'21227','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252540,-76.696380,0,'2013-07-06 12:44:31',NULL,NULL),(21490,'22652','S','Seven Fountns','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.842058,-78.419588,0,'2013-07-06 12:44:31',NULL,NULL),(3758,'02184','S','Braintree Hld','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.208818,-71.000729,0,'2013-07-06 12:44:30',NULL,NULL),(36098,'40220','S','Houston Acres','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(51048,'58735','S','Douglas','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.892601,-101.552246,0,'2013-07-06 12:44:33',NULL,NULL),(10559,'11003','S','Elmont','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(26200,'28774','S','Sapphire','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.104149,-82.978026,0,'2013-07-06 12:44:31',NULL,NULL),(75882,'94955','P','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.222372,-122.556183,0,'2013-07-06 12:44:34',NULL,NULL),(6429,'05743','S','Fairhaven','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(48169,'55377','P','Santiago','D','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.541150,-93.812186,0,'2013-07-06 12:44:33',NULL,NULL),(32763,'36353','S','Bertha','N','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.431420,-85.331160,0,'2013-07-06 12:44:32',NULL,NULL),(41907,'47374','S','Gateway Shopping Center','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(17735,'18256','P','Weston','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.941459,-76.142805,0,'2013-07-06 12:44:31',NULL,NULL),(71204,'86303','S','Groom Creek','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.534800,-112.469940,0,'2013-07-06 12:44:34',NULL,NULL),(69185,'83338','S','Appleton','N','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.709237,-114.464322,0,'2013-07-06 12:44:34',NULL,NULL),(67602,'80427','P','Central City','D','Gilpin','08047','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.797305,-105.514119,0,'2013-07-06 12:44:34',NULL,NULL),(66281,'78582','S','Garceno','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(59800,'71222','S','Bernice','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.830800,-92.643420,0,'2013-07-06 12:44:33',NULL,NULL),(44711,'50143','S','Olivet','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.376124,-92.816298,0,'2013-07-06 12:44:32',NULL,NULL),(11916,'12414','S','Catskill','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.224593,-73.874142,0,'2013-07-06 12:44:30',NULL,NULL),(45235,'50648','S','Shady Grove','N','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.458700,-92.063160,0,'2013-07-06 12:44:32',NULL,NULL),(1943,'00795','S','Villas del Sol','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(42103,'47462','S','Hobbieville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003349,-86.589842,0,'2013-07-06 12:44:32',NULL,NULL),(33612,'37645','S','Mt Carmel','A','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.522222,-82.713611,0,'2013-07-06 12:44:32',NULL,NULL),(72269,'88547','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767112,-106.331411,0,'2013-07-06 12:44:34',NULL,NULL),(69341,'83537','S','Southwick','N','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.643793,-116.541608,0,'2013-07-06 12:44:34',NULL,NULL),(17052,'17752','S','Montgomery','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.173173,-76.873541,0,'2013-07-06 12:44:31',NULL,NULL),(3250,'01436','S','Otter River','N','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.594540,-72.086280,0,'2013-07-06 12:44:30',NULL,NULL),(36249,'40310','P','Burgin','D','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.755091,-84.770528,0,'2013-07-06 12:44:32',NULL,NULL),(75542,'94232','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.554971,-121.496277,0,'2013-07-06 12:44:34',NULL,NULL),(71294,'86445','S','Kingman','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.731831,-114.378837,0,'2013-07-06 12:44:34',NULL,NULL),(33646,'37701','S','Alcoa','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.784224,-83.980839,0,'2013-07-06 12:44:32',NULL,NULL),(36773,'41043','S','Berlin','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(19100,'19605','S','Ontelaunee','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(31718,'34958','P','Jensen Beach','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.194070,-80.193203,0,'2013-07-06 12:44:32',NULL,NULL),(390,'00662','S','Comunidad El Canon','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(37001,'41219','S','Winifred','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(44868,'50307','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.594051,-93.602387,0,'2013-07-06 12:44:32',NULL,NULL),(1921,'00795','S','Portal Del Valle','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(29460,'32714','S','Altamonte Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.666520,-81.413231,0,'2013-07-06 12:44:32',NULL,NULL),(16767,'17522','S','Clay','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(67768,'80639','U','Univ of Northern Colorado','N','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.401197,-104.701365,0,'2013-07-06 12:44:34',NULL,NULL),(76266,'95416','P','Fetters Hot Springs','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.312407,-122.482861,0,'2013-07-06 12:44:34',NULL,NULL),(63565,'75771','S','Hide a Way','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(18919,'19494','U','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.054579,-75.556882,0,'2013-07-06 12:44:31',NULL,NULL),(24649,'27379','S','Yanceyville','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.404814,-79.335765,0,'2013-07-06 12:44:31',NULL,NULL),(58886,'69163','S','Stapleton','D','Logan','31113','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.507700,-100.492800,0,'2013-07-06 12:44:33',NULL,NULL),(57437,'66830','S','Admire','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.638623,-96.099050,0,'2013-07-06 12:44:33',NULL,NULL),(11024,'11561','S','East Atlantic Beach','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.585753,-73.657497,0,'2013-07-06 12:44:30',NULL,NULL),(66843,'79118','S','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.065430,-101.852052,0,'2013-07-06 12:44:34',NULL,NULL),(61692,'72948','S','Natural Dam','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.696396,-94.421810,0,'2013-07-06 12:44:33',NULL,NULL),(63851,'75977','S','Indian Hill','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(63253,'75486','S','Sumner','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.775975,-95.712769,0,'2013-07-06 12:44:33',NULL,NULL),(40922,'46277','U','Chase Bank','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.772026,-86.155024,0,'2013-07-06 12:44:32',NULL,NULL),(52587,'61010','S','Byron','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.126357,-89.262545,0,'2013-07-06 12:44:33',NULL,NULL),(31463,'34288','S','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.048529,-82.194897,0,'2013-07-06 12:44:32',NULL,NULL),(47215,'54494','S','Grand Rapids','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(76798,'95945','S','Spring Hill','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(3930,'02464','S','Newton U F','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.311972,-71.220047,0,'2013-07-06 12:44:30',NULL,NULL),(78483,'98102','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.632744,-122.321885,0,'2013-07-06 12:44:34',NULL,NULL),(19678,'20350','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(44536,'49967','S','Trout Creek','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.476821,-89.007955,0,'2013-07-06 12:44:32',NULL,NULL),(51469,'59529','S','Hogeland','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.877402,-108.722102,0,'2013-07-06 12:44:33',NULL,NULL),(56767,'65739','S','Ridgedale','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.539284,-93.280373,0,'2013-07-06 12:44:33',NULL,NULL),(57523,'67003','S','Anthony','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.155954,-98.029197,0,'2013-07-06 12:44:33',NULL,NULL),(14324,'14904','S','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.072220,-76.805797,0,'2013-07-06 12:44:31',NULL,NULL),(12555,'13045','S','Munsons Corners','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.602760,-76.171860,0,'2013-07-06 12:44:30',NULL,NULL),(38331,'43432','S','Graytown','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.557515,-83.242620,0,'2013-07-06 12:44:32',NULL,NULL),(2645,'00966','S','Est de Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(9783,'10107','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(61891,'73136','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.589704,-97.456239,0,'2013-07-06 12:44:33',NULL,NULL),(9249,'09581','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(43388,'48435','S','Fostoria','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.260793,-83.382924,0,'2013-07-06 12:44:32',NULL,NULL),(53373,'61776','S','Towanda','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.563669,-88.896787,0,'2013-07-06 12:44:33',NULL,NULL),(21544,'22739','P','Somerville','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.523991,-77.610489,0,'2013-07-06 12:44:31',NULL,NULL),(55061,'63160','U','Bank of America','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.637559,-90.186991,0,'2013-07-06 12:44:33',NULL,NULL),(59280,'70462','S','Killian','N','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.383769,-90.574931,0,'2013-07-06 12:44:33',NULL,NULL),(35877,'39859','S','Iron City','D','Seminole','13253','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.984497,-84.786533,0,'2013-07-06 12:44:32',NULL,NULL),(47240,'54511','S','Hiles','A','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.724974,-88.860373,0,'2013-07-06 12:44:32',NULL,NULL),(64924,'77209','U','Ellington Field','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.620069,-95.190018,0,'2013-07-06 12:44:34',NULL,NULL),(33030,'36728','S','Catherine','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.201926,-87.481239,0,'2013-07-06 12:44:32',NULL,NULL),(403,'00662','S','Isabela','D','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(14112,'14639','U','HSBC','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.158018,-77.605115,0,'2013-07-06 12:44:31',NULL,NULL),(25238,'28103','S','Olive Branch','N','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.992963,-80.366496,0,'2013-07-06 12:44:31',NULL,NULL),(63783,'75954','S','Paxton','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.938720,-94.055400,0,'2013-07-06 12:44:34',NULL,NULL),(3833,'02334','P','Easton','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.023847,-71.129217,0,'2013-07-06 12:44:30',NULL,NULL),(71685,'87513','P','Arroyo Hondo','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.537421,-105.668659,0,'2013-07-06 12:44:34',NULL,NULL),(60810,'72031','S','Walnut Grove','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(39118,'44256','S','Medina','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.134844,-81.860472,0,'2013-07-06 12:44:32',NULL,NULL),(40004,'45244','S','Mount Carmel','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118320,-84.337680,0,'2013-07-06 12:44:32',NULL,NULL),(44999,'50444','S','Hanlontown','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.279755,-93.377590,0,'2013-07-06 12:44:32',NULL,NULL),(13847,'14224','S','West Seneca','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.841518,-78.761265,0,'2013-07-06 12:44:31',NULL,NULL),(9942,'10155','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(49751,'57062','S','Running Water','A','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.853777,-97.892321,0,'2013-07-06 12:44:33',NULL,NULL),(45634,'51639','S','Farragut','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.721288,-95.480358,0,'2013-07-06 12:44:32',NULL,NULL),(63491,'75702','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.362178,-95.309998,0,'2013-07-06 12:44:33',NULL,NULL),(77960,'97366','S','South Beach','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.553071,-124.041750,0,'2013-07-06 12:44:34',NULL,NULL),(33718,'37801','S','Maryville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.749086,-83.969540,0,'2013-07-06 12:44:32',NULL,NULL),(65194,'77423','S','Sunny Side','N','Waller','48473','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.798940,-95.962284,0,'2013-07-06 12:44:34',NULL,NULL),(54824,'63025','S','Hoene Spring','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(57398,'66758','S','Carmean','N','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.972738,-95.553451,0,'2013-07-06 12:44:33',NULL,NULL),(34571,'38733','S','Delta State Univ','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.749492,-90.831182,0,'2013-07-06 12:44:32',NULL,NULL),(1937,'00795','S','Urb San Martin Ii','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(74256,'92338','S','Newberry Spgs','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.721111,-116.159167,0,'2013-07-06 12:44:34',NULL,NULL),(60881,'72064','S','Hazen','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.797715,-91.570184,0,'2013-07-06 12:44:33',NULL,NULL),(14956,'15618','S','Avonmore','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.528479,-79.465500,0,'2013-07-06 12:44:31',NULL,NULL),(45855,'52237','S','Hopkinton','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.320147,-91.127320,0,'2013-07-06 12:44:32',NULL,NULL),(57654,'67206','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.703526,-97.234538,0,'2013-07-06 12:44:33',NULL,NULL),(13632,'13904','S','Binghamton','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.129060,-75.821820,0,'2013-07-06 12:44:31',NULL,NULL),(32018,'35235','S','Roebuck Plaza','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(34349,'38582','S','Silver Point','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.102070,-85.749169,0,'2013-07-06 12:44:32',NULL,NULL),(54704,'62952','S','Reynoldsville','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.452013,-89.269945,0,'2013-07-06 12:44:33',NULL,NULL),(44114,'49506','S','East Grand Ra','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(60092,'71359','U','Pineville','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.323914,-92.427031,0,'2013-07-06 12:44:33',NULL,NULL),(74714,'93014','P','Carpinteria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.392417,-119.512519,0,'2013-07-06 12:44:34',NULL,NULL),(36167,'40242','S','Old Brownsbro','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(65361,'77534','S','Danbury','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.224819,-95.335793,0,'2013-07-06 12:44:34',NULL,NULL),(62503,'74366','S','Spavinaw','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.430107,-95.011716,0,'2013-07-06 12:44:33',NULL,NULL),(11074,'11598','S','Hewlett Neck','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.633418,-73.714284,0,'2013-07-06 12:44:30',NULL,NULL),(14472,'15122','S','West Mifflin','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.377383,-79.892562,0,'2013-07-06 12:44:31',NULL,NULL),(48551,'55760','S','Shamrock','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(24009,'26354','S','Belgium','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.343632,-80.022519,0,'2013-07-06 12:44:31',NULL,NULL),(14101,'14624','S','Gates','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.120619,-77.729488,0,'2013-07-06 12:44:31',NULL,NULL),(69381,'83610','S','Alpine','N','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.581764,-116.658632,0,'2013-07-06 12:44:34',NULL,NULL),(70366,'84652','P','Redmond','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.005668,-111.869050,0,'2013-07-06 12:44:34',NULL,NULL),(20019,'20622','S','Charlott Hall','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.497286,-76.765851,0,'2013-07-06 12:44:31',NULL,NULL),(52493,'60699','S','USPS District Chicago','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875983,-87.646718,0,'2013-07-06 12:44:33',NULL,NULL),(13267,'13650','S','Jefferson Park','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.849649,-76.228306,0,'2013-07-06 12:44:30',NULL,NULL),(63062,'75230','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.902378,-96.789669,0,'2013-07-06 12:44:33',NULL,NULL),(66192,'78539','S','San Carlos','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(64554,'76653','S','Kosse','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.314780,-96.621000,0,'2013-07-06 12:44:34',NULL,NULL),(59873,'71268','S','Mount Olive','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.363260,-92.650820,0,'2013-07-06 12:44:33',NULL,NULL),(51122,'58792','S','Bergen','A','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.933754,-100.775619,0,'2013-07-06 12:44:33',NULL,NULL),(11999,'12487','S','Ulster Park','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.866568,-73.990210,0,'2013-07-06 12:44:30',NULL,NULL),(31704,'34951','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.532914,-80.396835,0,'2013-07-06 12:44:32',NULL,NULL),(28575,'31623','P','Argyle','D','Clinch','13065','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.065563,-82.759949,0,'2013-07-06 12:44:32',NULL,NULL),(45681,'52043','S','Elkader','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.856180,-91.404581,0,'2013-07-06 12:44:32',NULL,NULL),(66566,'78738','S','Bee Cave','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(69236,'83415','U','Idaho National Lab','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.491978,-112.033059,0,'2013-07-06 12:44:34',NULL,NULL),(60900,'72072','S','Humnoke','D','Lonoke','05085','Arkansas','AR','05','4400','870','Central',-6.0,'Y',34.542157,-91.732209,0,'2013-07-06 12:44:33',NULL,NULL),(56040,'64720','S','Adrian','D','Bates','29013','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',38.397993,-94.348187,0,'2013-07-06 12:44:33',NULL,NULL),(19478,'20146','P','Dulles','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.019050,-77.460991,0,'2013-07-06 12:44:31',NULL,NULL),(52053,'60197','P','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.914461,-88.138313,0,'2013-07-06 12:44:33',NULL,NULL),(7571,'07028','S','Glen Ridge','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.808362,-74.207544,0,'2013-07-06 12:44:30',NULL,NULL),(76210,'95363','S','Patterson','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.486062,-121.129906,0,'2013-07-06 12:44:34',NULL,NULL),(74923,'93401','S','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.259509,-120.652522,0,'2013-07-06 12:44:34',NULL,NULL),(69634,'84003','S','Am Fork','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.419240,-111.565260,0,'2013-07-06 12:44:34',NULL,NULL),(25926,'28652','P','Carpenter Bottom','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.099899,-81.987145,0,'2013-07-06 12:44:31',NULL,NULL),(57558,'67041','P','Elbing','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.055539,-97.124644,0,'2013-07-06 12:44:33',NULL,NULL),(52288,'60534','S','Lyons','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.811846,-87.820628,0,'2013-07-06 12:44:33',NULL,NULL),(16904,'17584','S','Willow','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.962325,-76.274759,0,'2013-07-06 12:44:31',NULL,NULL),(59973,'71322','S','Whitehall','A','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.943380,-92.185260,0,'2013-07-06 12:44:33',NULL,NULL),(36495,'40815','S','Cawood','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751998,-83.268360,0,'2013-07-06 12:44:32',NULL,NULL),(72062,'88119','S','Fort Sumner','D','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.471919,-104.234002,0,'2013-07-06 12:44:34',NULL,NULL),(76728,'95899','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.580708,-121.526563,0,'2013-07-06 12:44:34',NULL,NULL),(43638,'48831','S','Elsie','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.089874,-84.427686,0,'2013-07-06 12:44:32',NULL,NULL),(45419,'51054','S','Sergeant Bluff','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.407067,-96.357402,0,'2013-07-06 12:44:32',NULL,NULL),(9906,'10132','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.785292,-73.981536,0,'2013-07-06 12:44:30',NULL,NULL),(58597,'68848','P','Kearney','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.699406,-99.081670,0,'2013-07-06 12:44:33',NULL,NULL),(40833,'46214','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.788672,-86.295650,0,'2013-07-06 12:44:32',NULL,NULL),(64610,'76687','S','Old Union','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(74067,'92168','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.766840,-117.153066,0,'2013-07-06 12:44:34',NULL,NULL),(62458,'74331','S','Aston','N','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(50829,'58474','S','Ludden','A','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.133520,-98.100180,0,'2013-07-06 12:44:33',NULL,NULL),(40740,'46131','S','Urmeyville','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.488252,-86.054873,0,'2013-07-06 12:44:32',NULL,NULL),(51224,'59058','S','Mosby','D','Garfield','30033','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.925179,-107.780982,0,'2013-07-06 12:44:33',NULL,NULL),(5943,'05257','S','Sodom','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(27109,'29728','S','Pageland','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.769328,-80.392158,0,'2013-07-06 12:44:31',NULL,NULL),(71686,'87514','P','Arroyo Seco','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.500749,-105.615520,0,'2013-07-06 12:44:34',NULL,NULL),(3816,'02298','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358631,-71.056702,0,'2013-07-06 12:44:30',NULL,NULL),(74838,'93241','S','Lamont','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.259651,-118.914469,0,'2013-07-06 12:44:34',NULL,NULL),(13240,'13642','S','Balmat','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(28449,'31408','S','Garden Cty','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.172908,-81.206224,0,'2013-07-06 12:44:32',NULL,NULL),(18271,'19008','S','Marple Township','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.975572,-75.360537,0,'2013-07-06 12:44:31',NULL,NULL),(65089,'77355','S','Stagecoach','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.151734,-95.743252,0,'2013-07-06 12:44:34',NULL,NULL),(511,'00674','S','Repto Geovani','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(70698,'85263','S','Scottsdale','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.722520,-111.675000,0,'2013-07-06 12:44:34',NULL,NULL),(36671,'41011','S','Lookout Heights','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(42301,'47598','S','Coe','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(12915,'13339','S','Ft Plain','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(12638,'13104','S','Manlius','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.994893,-75.970433,0,'2013-07-06 12:44:30',NULL,NULL),(31153,'33913','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.497190,-81.730739,0,'2013-07-06 12:44:32',NULL,NULL),(79971,'99647','P','Iliamna','A','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.750000,-154.916667,0,'2013-07-06 12:44:34',NULL,NULL),(22477,'24055','S','Oaklevel','N','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.751969,-79.987513,0,'2013-07-06 12:44:31',NULL,NULL),(21130,'22102','S','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(43266,'48328','S','Waterford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.644305,-83.356394,0,'2013-07-06 12:44:32',NULL,NULL),(13659,'14024','S','Bliss','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.574673,-78.261100,0,'2013-07-06 12:44:31',NULL,NULL),(55927,'64467','S','Martinsville','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.380894,-94.158772,0,'2013-07-06 12:44:33',NULL,NULL),(25214,'28081','S','Kannapolis','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(10218,'10458','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.859035,-73.890784,0,'2013-07-06 12:44:30',NULL,NULL),(65092,'77357','S','Roman Forest','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.134460,-95.180700,0,'2013-07-06 12:44:34',NULL,NULL),(47950,'55118','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(11139,'11710','S','Bellmore','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.679031,-73.534402,0,'2013-07-06 12:44:30',NULL,NULL),(2644,'00966','S','Chalet de la Reina','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(73410,'91129','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.141146,-118.156851,0,'2013-07-06 12:44:34',NULL,NULL),(75133,'93555','S','China Lake Nwc','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.622118,-117.690678,0,'2013-07-06 12:44:34',NULL,NULL),(4780,'03864','S','Ossipee','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.692691,-71.113673,0,'2013-07-06 12:44:30',NULL,NULL),(25154,'28025','S','Sidestown','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.400953,-80.583807,0,'2013-07-06 12:44:31',NULL,NULL),(15139,'15849','S','Penfield','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.163297,-78.561053,0,'2013-07-06 12:44:31',NULL,NULL),(55576,'63877','S','Steele','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.084889,-89.832085,0,'2013-07-06 12:44:33',NULL,NULL),(41812,'47331','S','Nulltown','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(66639,'78834','S','Carrizo Spgs','A','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.520700,-99.888480,0,'2013-07-06 12:44:34',NULL,NULL),(73458,'91303','S','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.196941,-118.603090,0,'2013-07-06 12:44:34',NULL,NULL),(32204,'35553','S','Double Springs','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.132870,-87.387518,0,'2013-07-06 12:44:32',NULL,NULL),(56062,'64744','S','Eldorado Springs','N','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.871840,-94.022563,0,'2013-07-06 12:44:33',NULL,NULL),(1248,'00729','S','Urb del Pilar','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(4680,'03785','S','Woodsville','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.149423,-72.034577,0,'2013-07-06 12:44:30',NULL,NULL),(48953,'56174','S','Storden','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.036411,-95.318955,0,'2013-07-06 12:44:33',NULL,NULL),(10490,'10960','S','Central Nyack','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(77198,'96350','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72165,'88340','S','Mescalero Apache Indian Rese','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.265571,-105.726911,0,'2013-07-06 12:44:34',NULL,NULL),(66932,'79351','S','Odonnell','D','Lynn','48305','Texas','TX','48','0000','806','Central',-6.0,'Y',32.966548,-101.828190,0,'2013-07-06 12:44:34',NULL,NULL),(46349,'53095','S','Westbend','N','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.390226,-88.167388,0,'2013-07-06 12:44:32',NULL,NULL),(79505,'98921','P','Buena','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.421724,-120.296841,0,'2013-07-06 12:44:34',NULL,NULL),(17990,'18624','P','Lake Harmony','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',41.060501,-75.605658,0,'2013-07-06 12:44:31',NULL,NULL),(54825,'63025','S','La Barque Crk','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(19137,'19610','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.338971,-75.981605,0,'2013-07-06 12:44:31',NULL,NULL),(60534,'71675','S','Green Hill','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.621420,-91.927800,0,'2013-07-06 12:44:33',NULL,NULL),(70847,'85543','S','Pima','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.883664,-109.832708,0,'2013-07-06 12:44:34',NULL,NULL),(71283,'86436','S','Topock','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.778287,-114.483910,0,'2013-07-06 12:44:34',NULL,NULL),(61328,'72453','S','Peach Orchard','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.278302,-90.662335,0,'2013-07-06 12:44:33',NULL,NULL),(27903,'30474','S','Vidalia','D','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(37449,'41843','S','Pine Top','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.305673,-82.826660,0,'2013-07-06 12:44:32',NULL,NULL),(14350,'15012','S','N Belle Vernon','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(53516,'62024','S','Rosewood','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.856649,-90.050801,0,'2013-07-06 12:44:33',NULL,NULL),(3145,'01256','S','Savoy','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.576296,-73.030921,0,'2013-07-06 12:44:30',NULL,NULL),(17192,'17821','S','Danville','D','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(24129,'26554','S','Pleasant Valley','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(69572,'83827','P','Elk River','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.779323,-116.178085,0,'2013-07-06 12:44:34',NULL,NULL),(45343,'50940','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585359,-93.629011,0,'2013-07-06 12:44:32',NULL,NULL),(1131,'00725','S','Villa Las Mercedes','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(69257,'83428','S','Irwin','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.410639,-111.291199,0,'2013-07-06 12:44:34',NULL,NULL),(74681,'92877','P','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.875817,-117.567292,0,'2013-07-06 12:44:34',NULL,NULL),(79358,'98642','S','Ridgefield','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.793986,-122.689276,0,'2013-07-06 12:44:34',NULL,NULL),(74683,'92879','S','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.880653,-117.537555,0,'2013-07-06 12:44:34',NULL,NULL),(10562,'11003','S','Meacham','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(29413,'32648','S','Horseshoe Beach','D','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.554006,-83.254234,0,'2013-07-06 12:44:32',NULL,NULL),(3603,'02044','U','Hingham','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.242484,-70.892883,0,'2013-07-06 12:44:30',NULL,NULL),(34208,'38346','P','Idlewild','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.028634,-88.801305,0,'2013-07-06 12:44:32',NULL,NULL),(58374,'68528','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.819560,-96.813060,0,'2013-07-06 12:44:33',NULL,NULL),(49422,'56630','S','Langor','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(12151,'12738','S','Glen Wild','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.634250,-74.594325,0,'2013-07-06 12:44:30',NULL,NULL),(47166,'54474','S','Rothschild','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.933333,-89.600000,0,'2013-07-06 12:44:32',NULL,NULL),(18849,'19435','S','Frederick','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.304515,-75.538564,0,'2013-07-06 12:44:31',NULL,NULL),(31428,'34265','P','Arcadia','D','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.187943,-81.808861,0,'2013-07-06 12:44:32',NULL,NULL),(9224,'09522','M','FPO','N','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(63929,'76061','P','Lillian','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.503898,-97.190717,0,'2013-07-06 12:44:34',NULL,NULL),(63459,'75684','S','Overton','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(29694,'32935','S','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.138545,-80.657969,0,'2013-07-06 12:44:32',NULL,NULL),(24956,'27834','S','East Carolina University','N','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.626380,-77.438580,0,'2013-07-06 12:44:31',NULL,NULL),(7050,'06280','S','Windham','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.689241,-72.134796,0,'2013-07-06 12:44:30',NULL,NULL),(47475,'54743','P','Gilmanton','D','Buffalo','55011','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.468305,-91.675117,0,'2013-07-06 12:44:32',NULL,NULL),(82,'00612','S','Parc Navas','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(26374,'29080','S','Atkins','N','Lee','45061','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.038853,-80.110297,0,'2013-07-06 12:44:31',NULL,NULL),(46322,'53075','S','Random Lake','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.553924,-87.951651,0,'2013-07-06 12:44:32',NULL,NULL),(11693,'12156','S','Schodack Lndg','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.479520,-73.725180,0,'2013-07-06 12:44:30',NULL,NULL),(39442,'44693','P','Deersville','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.308377,-81.185804,0,'2013-07-06 12:44:32',NULL,NULL),(74672,'92864','P','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.814252,-117.830751,0,'2013-07-06 12:44:34',NULL,NULL),(79340,'98621','S','Grays River','D','Wahkiakum','53069','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.353507,-123.584488,0,'2013-07-06 12:44:34',NULL,NULL),(35049,'39176','S','Vaiden','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.334334,-89.741800,0,'2013-07-06 12:44:32',NULL,NULL),(9541,'10021','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(46629,'53583','S','Sauk City','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.273674,-89.737229,0,'2013-07-06 12:44:32',NULL,NULL),(79073,'98431','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(74916,'93385','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.379110,-118.989648,0,'2013-07-06 12:44:34',NULL,NULL),(71192,'86047','S','Leupp Corner','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.275380,-110.315820,0,'2013-07-06 12:44:34',NULL,NULL),(60139,'71373','S','Shaw','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(28943,'32180','S','Pierson','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.222630,-81.466671,0,'2013-07-06 12:44:32',NULL,NULL),(47894,'55107','S','W St Paul','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.932638,-93.077152,0,'2013-07-06 12:44:33',NULL,NULL),(79942,'99623','S','Meadow Lake','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593459,-149.414728,0,'2013-07-06 12:44:34',NULL,NULL),(77308,'96675','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72728,'89505','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.529321,-119.804953,0,'2013-07-06 12:44:34',NULL,NULL),(19860,'20522','U','Government Agency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893759,-77.050641,0,'2013-07-06 12:44:31',NULL,NULL),(73115,'90255','S','Huntington Pk','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.980311,-118.209874,0,'2013-07-06 12:44:34',NULL,NULL),(65200,'77432','S','Danevang','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.078906,-96.175303,0,'2013-07-06 12:44:34',NULL,NULL),(60729,'71958','S','Mount Moriah','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.060950,-93.689939,0,'2013-07-06 12:44:33',NULL,NULL),(23903,'26205','S','Cottle','A','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.332208,-80.639092,0,'2013-07-06 12:44:31',NULL,NULL),(46359,'53105','S','Burlington','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.677953,-88.265880,0,'2013-07-06 12:44:32',NULL,NULL),(10479,'10952','S','Chestnut Ridge','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.114522,-74.077510,0,'2013-07-06 12:44:30',NULL,NULL),(53907,'62367','S','Birmingham','N','Hancock','17067','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.290180,-90.893760,0,'2013-07-06 12:44:33',NULL,NULL),(53803,'62288','S','Wine Hill','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.005855,-89.658943,0,'2013-07-06 12:44:33',NULL,NULL),(73301,'90805','S','Lakewood','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.863555,-118.182163,0,'2013-07-06 12:44:34',NULL,NULL),(37614,'42133','S','Fountain Run','D','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.703779,-85.937084,0,'2013-07-06 12:44:32',NULL,NULL),(65807,'78133','S','New Braunfels','A','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.880900,-98.215200,0,'2013-07-06 12:44:34',NULL,NULL),(29704,'32940','S','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.225810,-80.688308,0,'2013-07-06 12:44:32',NULL,NULL),(20123,'20717','P','Mitchellville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008960,-76.781954,0,'2013-07-06 12:44:31',NULL,NULL),(69594,'83846','S','Mullan','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.469843,-115.796934,0,'2013-07-06 12:44:34',NULL,NULL),(63688,'75862','S','Chita','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(8193,'07922','S','Berkeley Hts','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.678984,-74.432692,0,'2013-07-06 12:44:30',NULL,NULL),(6039,'05407','P','So Burlington','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446346,-73.175684,0,'2013-07-06 12:44:30',NULL,NULL),(31545,'34604','S','Masaryktown','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.555000,-82.388056,0,'2013-07-06 12:44:32',NULL,NULL),(721,'00687','S','Sect La Alianza','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(44517,'49946','S','Lanse','D','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.759740,-88.409340,0,'2013-07-06 12:44:32',NULL,NULL),(50805,'58454','S','Alfred','A','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.488265,-98.813122,0,'2013-07-06 12:44:33',NULL,NULL),(25433,'28307','S','Fayetteville','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.140740,-78.998040,0,'2013-07-06 12:44:31',NULL,NULL),(62653,'74602','P','Kildare','N','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.720461,-97.080194,0,'2013-07-06 12:44:33',NULL,NULL),(16689,'17370','S','York Haven','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.117401,-76.775929,0,'2013-07-06 12:44:31',NULL,NULL),(56882,'66027','S','Ft Leavnwrth','A','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.361430,-94.923664,0,'2013-07-06 12:44:33',NULL,NULL),(10565,'11005','S','Floral Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.755594,-73.715036,0,'2013-07-06 12:44:30',NULL,NULL),(71986,'88026','P','Santa Clara','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.776365,-108.150858,0,'2013-07-06 12:44:34',NULL,NULL),(7218,'06495','U','Wallingford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.458768,-72.826674,0,'2013-07-06 12:44:30',NULL,NULL),(72125,'88263','P','Malaga','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.210989,-104.067615,0,'2013-07-06 12:44:34',NULL,NULL),(69205,'83350','S','Minidoka','A','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.620280,-113.767320,0,'2013-07-06 12:44:34',NULL,NULL),(15654,'16746','S','Roulette','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.769999,-78.142998,0,'2013-07-06 12:44:31',NULL,NULL),(33859,'38004','S','Atoka','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.433070,-89.796386,0,'2013-07-06 12:44:32',NULL,NULL),(36611,'40977','S','Field','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(60603,'71847','S','Mc Caskill','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.932758,-93.639952,0,'2013-07-06 12:44:33',NULL,NULL),(70953,'85643','S','Klondyke','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(35168,'39269','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.299021,-90.185387,0,'2013-07-06 12:44:32',NULL,NULL),(43348,'48382','S','Commerce Township','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.583560,-83.500320,0,'2013-07-06 12:44:32',NULL,NULL),(79386,'98683','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.602976,-122.528874,0,'2013-07-06 12:44:34',NULL,NULL),(74242,'92328','S','Death Valley','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.425648,-117.090213,0,'2013-07-06 12:44:34',NULL,NULL),(39949,'45231','S','Wyoming','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.244265,-84.540628,0,'2013-07-06 12:44:32',NULL,NULL),(38634,'43927','P','Fairpoint','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.123339,-80.933498,0,'2013-07-06 12:44:32',NULL,NULL),(28518,'31544','S','Jacksonville','D','Telfair','13271','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.836189,-82.953021,0,'2013-07-06 12:44:32',NULL,NULL),(17087,'17764','S','Leidy','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(46779,'53955','S','Poynette','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.393535,-89.413257,0,'2013-07-06 12:44:32',NULL,NULL),(43805,'49064','S','Lawrence','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.216384,-86.051631,0,'2013-07-06 12:44:32',NULL,NULL),(4396,'03215','P','Waterville Vly','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.951855,-71.500298,0,'2013-07-06 12:44:30',NULL,NULL),(62955,'75114','S','Crandall','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.619327,-96.444364,0,'2013-07-06 12:44:33',NULL,NULL),(73868,'91917','S','Dulzura','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.607702,-116.786150,0,'2013-07-06 12:44:34',NULL,NULL),(69128,'83285','S','Gray','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.951741,-111.173683,0,'2013-07-06 12:44:34',NULL,NULL),(15237,'16038','S','Barkeyville','N','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.136102,-80.004545,0,'2013-07-06 12:44:31',NULL,NULL),(20078,'20685','S','St Leonard','N','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.438901,-76.519070,0,'2013-07-06 12:44:31',NULL,NULL),(19353,'20047','U','Criterion Ins Co','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(6468,'05763','S','Fredetteville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.767228,-72.969037,0,'2013-07-06 12:44:30',NULL,NULL),(22838,'24521','S','Falconerville','N','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.573238,-79.057954,0,'2013-07-06 12:44:31',NULL,NULL),(34012,'38125','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.029029,-89.810269,0,'2013-07-06 12:44:32',NULL,NULL),(22506,'24078','S','Collinsville','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.722836,-79.914738,0,'2013-07-06 12:44:31',NULL,NULL),(19,'00603','S','Bo Ceiba Baja','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(69388,'83612','S','Council','D','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(20818,'21620','S','Chestertown','D','Kent','24029','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.204983,-76.131512,0,'2013-07-06 12:44:31',NULL,NULL),(47385,'54634','S','Bloom City','A','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.653481,-90.344014,0,'2013-07-06 12:44:32',NULL,NULL),(35586,'39573','S','Riceville','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(59393,'70629','S','Cal Marne Twr','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.227087,-93.214488,0,'2013-07-06 12:44:33',NULL,NULL),(19260,'19946','S','Frederica','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.014861,-75.479837,0,'2013-07-06 12:44:31',NULL,NULL),(25396,'28277','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.064565,-80.806138,0,'2013-07-06 12:44:31',NULL,NULL),(36519,'40831','S','Chevrolet','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.846189,-83.314477,0,'2013-07-06 12:44:32',NULL,NULL),(37163,'41472','S','Dingus','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(44429,'49845','P','Harris','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.702908,-87.347276,0,'2013-07-06 12:44:32',NULL,NULL),(53275,'61724','S','Glen Avon','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.341562,-88.515542,0,'2013-07-06 12:44:33',NULL,NULL),(19212,'19891','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.682268,-75.693124,0,'2013-07-06 12:44:31',NULL,NULL),(1824,'00784','S','Res Valles de Guayama','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(69613,'83861','S','Saint Maries','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.316709,-116.572684,0,'2013-07-06 12:44:34',NULL,NULL),(71846,'87583','P','Guagolotes','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.232598,-105.520380,0,'2013-07-06 12:44:34',NULL,NULL),(76301,'95439','S','Fulton','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.492569,-122.776272,0,'2013-07-06 12:44:34',NULL,NULL),(19541,'20192','U','Us Geological Survey','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.946349,-77.363143,0,'2013-07-06 12:44:31',NULL,NULL),(3260,'01460','S','Littleton','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.543481,-71.484168,0,'2013-07-06 12:44:30',NULL,NULL),(11230,'11753','S','Jericho','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.784785,-73.535500,0,'2013-07-06 12:44:30',NULL,NULL),(17311,'17857','S','Kapp Heights','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893520,-76.797765,0,'2013-07-06 12:44:31',NULL,NULL),(39559,'44847','S','Monroeville','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.214505,-82.714432,0,'2013-07-06 12:44:32',NULL,NULL),(40272,'45433','S','Wright Patterson AFB','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(44249,'49673','P','Old Mission','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.954609,-85.488628,0,'2013-07-06 12:44:32',NULL,NULL),(53778,'62275','S','Jamestown','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770822,-89.501779,0,'2013-07-06 12:44:33',NULL,NULL),(26479,'29160','S','Swansea','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.734049,-81.101430,0,'2013-07-06 12:44:31',NULL,NULL),(2850,'00983','S','Urb Vistamar Marina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(12478,'12986','S','Massawepie','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.235050,-74.464960,0,'2013-07-06 12:44:30',NULL,NULL),(36945,'41164','S','Wolf','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(43438,'48504','S','Mott Park','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.035862,-83.742760,0,'2013-07-06 12:44:32',NULL,NULL),(59822,'71234','S','Point','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.581980,-92.345100,0,'2013-07-06 12:44:33',NULL,NULL),(60638,'71901','S','Price','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(62333,'74048','S','Watova','N','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.697172,-95.639359,0,'2013-07-06 12:44:33',NULL,NULL),(64613,'76689','S','Mosheim','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.674120,-97.509300,0,'2013-07-06 12:44:34',NULL,NULL),(74202,'92285','S','Landers','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.313640,-116.448000,0,'2013-07-06 12:44:34',NULL,NULL),(32797,'36426','S','Wallace','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(45944,'52344','P','Troy Mills','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.292040,-91.685564,0,'2013-07-06 12:44:32',NULL,NULL),(43962,'49312','P','Brohman','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.689648,-85.794821,0,'2013-07-06 12:44:32',NULL,NULL),(63339,'75602','S','Pinewood','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.473920,-94.684860,0,'2013-07-06 12:44:33',NULL,NULL),(20930,'21750','S','Hancock','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.703852,-78.188237,0,'2013-07-06 12:44:31',NULL,NULL),(43864,'49119','P','New Troy','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.878062,-86.550298,0,'2013-07-06 12:44:32',NULL,NULL),(170,'00623','S','Est Reales','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(30145,'33166','S','Virginia Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(10601,'11040','S','Lake Success','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(20012,'20616','S','Marshall Hall','N','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.648082,-77.084535,0,'2013-07-06 12:44:31',NULL,NULL),(34740,'38851','S','Buena Vista','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897840,-88.990980,0,'2013-07-06 12:44:32',NULL,NULL),(21563,'22812','S','Bridgewater','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.382640,-78.971771,0,'2013-07-06 12:44:31',NULL,NULL),(16793,'17538','S','Landisville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.100343,-76.427234,0,'2013-07-06 12:44:31',NULL,NULL),(22974,'24729','P','Hiawatha','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.439979,-81.244511,0,'2013-07-06 12:44:31',NULL,NULL),(79295,'98584','S','Skokomish Nation','A','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(72105,'88231','P','Eunice','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.441225,-103.165099,0,'2013-07-06 12:44:34',NULL,NULL),(39672,'45013','S','Village Of Indian Springs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.408216,-84.617598,0,'2013-07-06 12:44:32',NULL,NULL),(56318,'65103','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578727,-92.174092,0,'2013-07-06 12:44:33',NULL,NULL),(26029,'28679','S','Sweetwater','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273480,-81.876420,0,'2013-07-06 12:44:31',NULL,NULL),(1365,'00736','S','Urb Fullana','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(9986,'10165','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(57715,'67354','S','Mound Valley','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.208363,-95.449695,0,'2013-07-06 12:44:33',NULL,NULL),(8131,'07830','S','Tewksbury Twp','A','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.715880,-74.817513,0,'2013-07-06 12:44:30',NULL,NULL),(34730,'38848','S','Greenwood Springs','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.850186,-88.364251,0,'2013-07-06 12:44:32',NULL,NULL),(57220,'66501','P','Alma','A','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.052131,-96.237299,0,'2013-07-06 12:44:33',NULL,NULL),(52472,'60686','U','National City Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.850116,-87.650659,0,'2013-07-06 12:44:33',NULL,NULL),(77340,'96718','P','Hi Natl Park','A','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.410522,-155.274653,0,'2013-07-06 12:44:34',NULL,NULL),(47975,'55126','S','Roseville','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(49305,'56536','S','Felton','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',47.050669,-96.495429,0,'2013-07-06 12:44:33',NULL,NULL),(58030,'68005','S','Bellevue','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.150489,-95.908507,0,'2013-07-06 12:44:33',NULL,NULL),(55742,'64092','P','Waldron','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.222803,-94.793089,0,'2013-07-06 12:44:33',NULL,NULL),(6212,'05487','S','Starksboro','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.229720,-73.013400,0,'2013-07-06 12:44:30',NULL,NULL),(17457,'17946','P','Lost Creek','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809304,-76.248260,0,'2013-07-06 12:44:31',NULL,NULL),(25106,'27970','S','Roper','D','Washington','37187','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.875739,-76.616924,0,'2013-07-06 12:44:31',NULL,NULL),(71591,'87317','S','Gallup','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.570550,-108.763745,0,'2013-07-06 12:44:34',NULL,NULL),(63051,'75219','S','Highland Park','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.814032,-96.815005,0,'2013-07-06 12:44:33',NULL,NULL),(37138,'41465','S','Flat Fork','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(47056,'54417','P','Brokaw','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.027750,-89.651093,0,'2013-07-06 12:44:32',NULL,NULL),(17204,'17821','S','Strawberry Rg','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(32976,'36611','S','Chickasaw','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.727800,-88.138980,0,'2013-07-06 12:44:32',NULL,NULL),(58485,'68755','S','Naper','D','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.927102,-99.089391,0,'2013-07-06 12:44:33',NULL,NULL),(9370,'09828','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18927,'19504','S','Congo','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(79438,'98837','S','Mae','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.126359,-119.296146,0,'2013-07-06 12:44:34',NULL,NULL),(29787,'33016','S','Miami Lakes','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890138,-80.341466,0,'2013-07-06 12:44:32',NULL,NULL),(32156,'35471','P','Mc Shan','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.381037,-88.142720,0,'2013-07-06 12:44:32',NULL,NULL),(52756,'61244','S','Watertown','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(17096,'17765','S','Ogdensburg','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(65890,'78232','S','Hill Country Village','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584537,-98.475424,0,'2013-07-06 12:44:34',NULL,NULL),(72524,'89161','S','Mountain Sprg','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.122600,-115.092200,0,'2013-07-06 12:44:34',NULL,NULL),(63352,'75631','S','Beckville','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.252312,-94.452675,0,'2013-07-06 12:44:33',NULL,NULL),(59956,'71303','S','Alex','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(8604,'08234','S','Egg Harbor Township','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(14789,'15362','S','Spraggs','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.765273,-80.279959,0,'2013-07-06 12:44:31',NULL,NULL),(25382,'28260','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.231298,-80.844846,0,'2013-07-06 12:44:31',NULL,NULL),(21970,'23242','P','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.619818,-77.613981,0,'2013-07-06 12:44:31',NULL,NULL),(1864,'00791','S','Qtas de Humacao','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(19776,'20423','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893212,-77.027764,0,'2013-07-06 12:44:31',NULL,NULL),(53166,'61568','S','Dillon','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.525564,-89.488301,0,'2013-07-06 12:44:33',NULL,NULL),(61295,'72415','S','Black Rock','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.122987,-91.133935,0,'2013-07-06 12:44:33',NULL,NULL),(64789,'77011','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.742104,-95.305993,0,'2013-07-06 12:44:34',NULL,NULL),(69676,'84022','S','Dugway','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.288140,-112.817460,0,'2013-07-06 12:44:34',NULL,NULL),(77944,'97346','S','Gates','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.753250,-122.382624,0,'2013-07-06 12:44:34',NULL,NULL),(39594,'44867','S','Republic','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.141469,-82.996490,0,'2013-07-06 12:44:32',NULL,NULL),(57979,'67839','S','Shields','A','Lane','20101','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.462460,-100.435140,0,'2013-07-06 12:44:33',NULL,NULL),(52901,'61359','P','Seatonville','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.362889,-89.276334,0,'2013-07-06 12:44:33',NULL,NULL),(31929,'35179','S','West Point','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.264921,-87.009412,0,'2013-07-06 12:44:32',NULL,NULL),(22575,'24153','S','Mason Cove','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(46459,'53213','S','Wawatosa','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.049511,-88.005322,0,'2013-07-06 12:44:32',NULL,NULL),(58969,'70037','S','Belle Chasse','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.814680,-90.009629,0,'2013-07-06 12:44:33',NULL,NULL),(49667,'57006','S','Brookings','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.287500,-96.791400,0,'2013-07-06 12:44:33',NULL,NULL),(41601,'47111','S','Charlestown','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.457512,-85.653758,0,'2013-07-06 12:44:32',NULL,NULL),(13282,'13658','S','Lisbon','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.725973,-75.323276,0,'2013-07-06 12:44:30',NULL,NULL),(15100,'15767','S','Punxsutawney','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.944773,-78.978341,0,'2013-07-06 12:44:31',NULL,NULL),(13040,'13439','S','Cullen','N','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(38915,'44119','S','Euclid','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.586699,-81.547659,0,'2013-07-06 12:44:32',NULL,NULL),(37643,'42167','S','Flippin','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(10405,'10607','S','Greenburgh','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.040477,-73.809229,0,'2013-07-06 12:44:30',NULL,NULL),(29862,'33039','U','Homestead Air Force Base','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.507761,-80.409021,0,'2013-07-06 12:44:32',NULL,NULL),(21373,'22463','P','Garrisonville','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.479142,-77.496343,0,'2013-07-06 12:44:31',NULL,NULL),(4294,'02903','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821633,-71.412670,0,'2013-07-06 12:44:30',NULL,NULL),(7719,'07198','U','Bank of New York','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.735880,-74.143855,0,'2013-07-06 12:44:30',NULL,NULL),(52890,'61350','S','North Ottawa','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(57312,'66667','P','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.041848,-95.727354,0,'2013-07-06 12:44:33',NULL,NULL),(59721,'71108','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.441723,-93.787148,0,'2013-07-06 12:44:33',NULL,NULL),(67414,'80134','S','Parker','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.471996,-104.768182,0,'2013-07-06 12:44:34',NULL,NULL),(72536,'89170','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.085850,-115.146603,0,'2013-07-06 12:44:34',NULL,NULL),(51394,'59422','S','Choteau','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.830951,-112.163398,0,'2013-07-06 12:44:33',NULL,NULL),(40985,'46350','S','La Porte','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.614878,-86.734117,0,'2013-07-06 12:44:32',NULL,NULL),(23706,'25876','S','Mc Graws','A','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.633053,-81.446009,0,'2013-07-06 12:44:31',NULL,NULL),(17173,'17815','S','Almedia','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(15801,'16926','S','Granville Ctr','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.666415,-76.720268,0,'2013-07-06 12:44:31',NULL,NULL),(5173,'04430','S','East Millinocket','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.626046,-68.571668,0,'2013-07-06 12:44:30',NULL,NULL),(16454,'17239','S','Neelyton','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.130165,-77.856685,0,'2013-07-06 12:44:31',NULL,NULL),(15104,'15772','S','Rossiter','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.893457,-78.932651,0,'2013-07-06 12:44:31',NULL,NULL),(5761,'05041','S','North Randolph','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.973889,-72.556389,0,'2013-07-06 12:44:30',NULL,NULL),(31034,'33804','P','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.079105,-81.954512,0,'2013-07-06 12:44:32',NULL,NULL),(9951,'10156','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(27358,'30061','P','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.920083,-84.544072,0,'2013-07-06 12:44:31',NULL,NULL),(19500,'20164','S','Sterling','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.011683,-77.393194,0,'2013-07-06 12:44:31',NULL,NULL),(43275,'48331','S','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505080,-83.408580,0,'2013-07-06 12:44:32',NULL,NULL),(47744,'55016','S','Cottage Grove','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.840257,-92.894321,0,'2013-07-06 12:44:33',NULL,NULL),(48672,'55919','S','Reno','N','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.688294,-91.294422,0,'2013-07-06 12:44:33',NULL,NULL),(52794,'61274','S','Osco','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.368894,-90.260590,0,'2013-07-06 12:44:33',NULL,NULL),(53426,'61855','S','Milmine','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.889725,-88.641072,0,'2013-07-06 12:44:33',NULL,NULL),(56226,'65041','S','Hermann','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.697938,-91.437726,0,'2013-07-06 12:44:33',NULL,NULL),(61423,'72568','S','Pleasant Plns','A','Independence','05063','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.564579,-91.626652,0,'2013-07-06 12:44:33',NULL,NULL),(62688,'74727','S','Boswell','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.032558,-95.831904,0,'2013-07-06 12:44:33',NULL,NULL),(75417,'94025','S','W Menlo Park','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.436934,-122.193602,0,'2013-07-06 12:44:34',NULL,NULL),(2885,'00987','S','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(57508,'66956','S','Mankato','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.789686,-98.211883,0,'2013-07-06 12:44:33',NULL,NULL),(18126,'18820','P','Gibson','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.802322,-75.644157,0,'2013-07-06 12:44:31',NULL,NULL),(14378,'15033','S','Donora','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.177612,-79.862742,0,'2013-07-06 12:44:31',NULL,NULL),(8935,'08753','S','Berkeley','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.988680,-74.179560,0,'2013-07-06 12:44:30',NULL,NULL),(68292,'81089','S','Walsenburg','D','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(68985,'83120','S','Freedom','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.044737,-111.029966,0,'2013-07-06 12:44:34',NULL,NULL),(78657,'98230','S','Birch Bay','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.961751,-122.743093,0,'2013-07-06 12:44:34',NULL,NULL),(34643,'38769','S','Malvina','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.846420,-91.001880,0,'2013-07-06 12:44:32',NULL,NULL),(21072,'22015','S','Burke','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.790084,-77.280669,0,'2013-07-06 12:44:31',NULL,NULL),(26776,'29446','S','Greenpond','A','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.655449,-80.515240,0,'2013-07-06 12:44:31',NULL,NULL),(26533,'29203','S','Haskell Heights','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(69145,'83312','P','Almo','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.123110,-113.622820,0,'2013-07-06 12:44:34',NULL,NULL),(70998,'85715','S','Fort Lowell','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.274389,-110.828940,0,'2013-07-06 12:44:34',NULL,NULL),(36588,'40962','S','Grace','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(3387,'01606','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.310950,-71.801404,0,'2013-07-06 12:44:30',NULL,NULL),(4431,'03240','S','Grafton','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.573264,-71.971029,0,'2013-07-06 12:44:30',NULL,NULL),(34676,'38824','S','Baldwyn','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(29977,'33092','P','Naranja','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.546985,-80.424765,0,'2013-07-06 12:44:32',NULL,NULL),(7160,'06424','S','Haddam Neck','A','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.560080,-72.501360,0,'2013-07-06 12:44:30',NULL,NULL),(52110,'60417','S','Crete','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.444101,-87.592909,0,'2013-07-06 12:44:33',NULL,NULL),(55575,'63876','S','Senath','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.137887,-90.163119,0,'2013-07-06 12:44:33',NULL,NULL),(55776,'64117','S','Nkc','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.154167,-94.546667,0,'2013-07-06 12:44:33',NULL,NULL),(79085,'98438','P','McChord AFB','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(8990,'08836','S','Martinsville','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.599919,-74.559189,0,'2013-07-06 12:44:30',NULL,NULL),(13515,'13812','S','Hoopers Valley','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.042960,-76.358700,0,'2013-07-06 12:44:31',NULL,NULL),(45745,'52135','S','Clermont','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.004514,-91.660610,0,'2013-07-06 12:44:32',NULL,NULL),(36593,'40962','S','Tanksley','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(1356,'00736','S','Repto Ana Luisa','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(977,'00716','S','Valle Real','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(4461,'03257','S','New London','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.419016,-71.993387,0,'2013-07-06 12:44:30',NULL,NULL),(13380,'13739','S','Doonan Corners','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.364324,-74.803449,0,'2013-07-06 12:44:31',NULL,NULL),(3558,'01944','S','Manchester by the Sea','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.580512,-70.767075,0,'2013-07-06 12:44:30',NULL,NULL),(42229,'47564','S','Otwell','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.478071,-87.099267,0,'2013-07-06 12:44:32',NULL,NULL),(44822,'50247','S','State Center','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.015094,-93.161812,0,'2013-07-06 12:44:32',NULL,NULL),(53329,'61749','S','Tunbridge','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.093731,-89.081482,0,'2013-07-06 12:44:33',NULL,NULL),(56819,'65783','S','Windyville','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.713918,-92.933038,0,'2013-07-06 12:44:33',NULL,NULL),(75591,'94295','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584072,-121.493284,0,'2013-07-06 12:44:34',NULL,NULL),(79681,'99174','P','Colfax','N','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.007933,-117.352546,0,'2013-07-06 12:44:34',NULL,NULL),(232,'00627','S','Urb del Carmen','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(58761,'68961','S','Nora','A','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.198823,-98.070094,0,'2013-07-06 12:44:33',NULL,NULL),(31549,'34606','S','Spring Hill','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.466311,-82.596769,0,'2013-07-06 12:44:32',NULL,NULL),(40039,'45252','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.272712,-84.627394,0,'2013-07-06 12:44:32',NULL,NULL),(38834,'44085','S','Roaming Rock Shores','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(36457,'40724','P','Bush','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.077557,-84.082857,0,'2013-07-06 12:44:32',NULL,NULL),(16450,'17237','S','Mont Alto','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.841479,-77.558453,0,'2013-07-06 12:44:31',NULL,NULL),(21690,'22963','S','Wildwood','A','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(10497,'10960','S','Upper Grandview','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(42293,'47591','S','Vincennes','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.680278,-87.423056,0,'2013-07-06 12:44:32',NULL,NULL),(55852,'64168','P','Riverside','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.168601,-94.631918,0,'2013-07-06 12:44:33',NULL,NULL),(4354,'03051','S','Hudson','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.769764,-71.420398,0,'2013-07-06 12:44:30',NULL,NULL),(64175,'76227','S','Savannah','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(37468,'41861','S','Raven','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.394717,-82.840377,0,'2013-07-06 12:44:32',NULL,NULL),(55428,'63663','P','Pilot Knob','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.620975,-90.637685,0,'2013-07-06 12:44:33',NULL,NULL),(7995,'07717','S','Avon by the Sea','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.192871,-74.017170,0,'2013-07-06 12:44:30',NULL,NULL),(72359,'89023','P','Jackass Flats','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.661428,-115.999727,0,'2013-07-06 12:44:34',NULL,NULL),(30,'00603','S','Urb Esteves','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(66863,'79185','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.083202,-101.918470,0,'2013-07-06 12:44:34',NULL,NULL),(74706,'93009','U','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.266232,-119.209181,0,'2013-07-06 12:44:34',NULL,NULL),(75156,'93563','S','Pearblossom','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.429622,-117.797685,0,'2013-07-06 12:44:34',NULL,NULL),(6326,'05663','S','West Berlin','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.149825,-72.660946,0,'2013-07-06 12:44:30',NULL,NULL),(2101,'00923','S','Urb Dos Pinos Townhouse','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(1369,'00736','S','Urb Minima','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(66553,'78734','S','Bee Caves','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371100,-97.869900,0,'2013-07-06 12:44:34',NULL,NULL),(28502,'31525','S','Everett','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.233616,-81.501727,0,'2013-07-06 12:44:32',NULL,NULL),(12130,'12719','S','Barryville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.483085,-74.910653,0,'2013-07-06 12:44:30',NULL,NULL),(58513,'68774','S','St Helena','N','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.821267,-97.340702,0,'2013-07-06 12:44:33',NULL,NULL),(26547,'29206','S','Forest Lake','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(26475,'29151','P','Sumter','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.908640,-80.362593,0,'2013-07-06 12:44:31',NULL,NULL),(47537,'54816','P','Benoit','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.503624,-91.077200,0,'2013-07-06 12:44:32',NULL,NULL),(2622,'00962','S','Urb Bahia','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(76096,'95222','S','Angels Camp','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.074616,-120.625043,0,'2013-07-06 12:44:34',NULL,NULL),(48482,'55725','S','Crane Lake','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.268374,-92.489389,0,'2013-07-06 12:44:33',NULL,NULL),(43066,'48192','S','Wyandotte','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.197463,-83.185203,0,'2013-07-06 12:44:32',NULL,NULL),(46052,'52571','S','Iconium','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.885620,-92.860620,0,'2013-07-06 12:44:32',NULL,NULL),(21794,'23076','S','Redart','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.468121,-76.323510,0,'2013-07-06 12:44:31',NULL,NULL),(49685,'57020','S','Crooks','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.661406,-96.808287,0,'2013-07-06 12:44:33',NULL,NULL),(54986,'63126','S','Crestwood','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550063,-90.377582,0,'2013-07-06 12:44:33',NULL,NULL),(61283,'72395','S','Reverie TN','N','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.572882,-90.043975,0,'2013-07-06 12:44:33',NULL,NULL),(47278,'54538','S','Lac du Flambeau','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.966884,-89.889537,0,'2013-07-06 12:44:32',NULL,NULL),(79999,'99666','P','Nunam Iqua','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.509200,-164.453220,0,'2013-07-06 12:44:34',NULL,NULL),(2952,'01034','S','Tolland','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.081960,-72.950580,0,'2013-07-06 12:44:30',NULL,NULL),(71032,'85738','P','Tucson','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.221667,-110.925833,0,'2013-07-06 12:44:34',NULL,NULL),(32647,'36251','S','Bluff Spring','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(39085,'44222','P','Cuyahoga Falls','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.135336,-81.483106,0,'2013-07-06 12:44:32',NULL,NULL),(15818,'16930','S','Sebring','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.550000,-77.100000,0,'2013-07-06 12:44:31',NULL,NULL),(52126,'60429','S','Hazel Crest','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.568060,-87.673440,0,'2013-07-06 12:44:33',NULL,NULL),(16573,'17319','S','Etters','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.152317,-76.794239,0,'2013-07-06 12:44:31',NULL,NULL),(17553,'17980','S','Tower City','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.591905,-76.538022,0,'2013-07-06 12:44:31',NULL,NULL),(55157,'63366','S','Dardenne Prairie','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(20232,'20775','P','Upper Marlboro','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.782687,-76.767816,0,'2013-07-06 12:44:31',NULL,NULL),(33897,'38041','S','Fort Pillow','A','Lauderdale','47097','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.673919,-89.570485,0,'2013-07-06 12:44:32',NULL,NULL),(12633,'13101','S','Mc Graw','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597772,-76.078518,0,'2013-07-06 12:44:30',NULL,NULL),(29530,'32784','S','Umatilla','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.927940,-81.664305,0,'2013-07-06 12:44:32',NULL,NULL),(75503,'94139','U','First Interstate Bank','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794865,-122.406188,0,'2013-07-06 12:44:34',NULL,NULL),(59539,'70814','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.486773,-91.067329,0,'2013-07-06 12:44:33',NULL,NULL),(76845,'95965','S','Hurleton','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(24074,'26443','S','Troy','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.085069,-80.757695,0,'2013-07-06 12:44:31',NULL,NULL),(4933,'04084','S','Standish','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.744118,-70.411562,0,'2013-07-06 12:44:30',NULL,NULL),(36994,'41216','S','East Point','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.709857,-82.834990,0,'2013-07-06 12:44:32',NULL,NULL),(37511,'42038','S','Eddyville','D','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.045200,-88.050120,0,'2013-07-06 12:44:32',NULL,NULL),(34364,'38606','S','Terza','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.316846,-89.949955,0,'2013-07-06 12:44:32',NULL,NULL),(24480,'27244','S','Stonycreek','N','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.135017,-79.505282,0,'2013-07-06 12:44:31',NULL,NULL),(63953,'76087','S','Willow Park','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699394,-97.772650,0,'2013-07-06 12:44:34',NULL,NULL),(78838,'98335','S','Victor','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(19038,'19539','S','Lower Longswamp','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(17963,'18601','P','Beach Haven','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.067660,-76.176436,0,'2013-07-06 12:44:31',NULL,NULL),(45148,'50583','S','Sac City','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.419313,-94.993699,0,'2013-07-06 12:44:32',NULL,NULL),(51246,'59073','P','Roundup','D','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.504722,-108.218611,0,'2013-07-06 12:44:33',NULL,NULL),(6087,'05450','S','Enosburg Fls','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(45569,'51526','S','Crescent','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.364771,-95.850441,0,'2013-07-06 12:44:32',NULL,NULL),(64843,'77042','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.746724,-95.559671,0,'2013-07-06 12:44:34',NULL,NULL),(79865,'99559','P','Napaskiak','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.940000,-164.620000,0,'2013-07-06 12:44:34',NULL,NULL),(68766,'82301','S','Muddy Gap','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.788870,-107.199009,0,'2013-07-06 12:44:34',NULL,NULL),(66209,'78550','S','Harlingen','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(44751,'50170','S','Monroe','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.523814,-93.103546,0,'2013-07-06 12:44:32',NULL,NULL),(15308,'16151','P','Sheakleyville','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.444815,-80.208292,0,'2013-07-06 12:44:31',NULL,NULL),(33283,'37116','P','Madison','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.193514,-86.743409,0,'2013-07-06 12:44:32',NULL,NULL),(52405,'60638','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781649,-87.774356,0,'2013-07-06 12:44:33',NULL,NULL),(55223,'63431','S','Anabel','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.737067,-92.346965,0,'2013-07-06 12:44:33',NULL,NULL),(58942,'69355','P','Melbeta','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.781301,-103.682107,0,'2013-07-06 12:44:33',NULL,NULL),(11720,'12176','S','Surprise','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.359083,-73.950092,0,'2013-07-06 12:44:30',NULL,NULL),(57456,'66852','S','Gridley','D','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.095862,-95.882201,0,'2013-07-06 12:44:33',NULL,NULL),(51207,'59039','S','Ingomar','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.666043,-107.528931,0,'2013-07-06 12:44:33',NULL,NULL),(74710,'93012','S','Camarillo','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.224457,-118.978052,0,'2013-07-06 12:44:34',NULL,NULL),(37881,'42567','S','Eubank','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.258848,-84.598938,0,'2013-07-06 12:44:32',NULL,NULL),(63610,'75801','S','Palestine','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.789440,-95.632020,0,'2013-07-06 12:44:34',NULL,NULL),(43601,'48764','P','Tawas City','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.272502,-83.531206,0,'2013-07-06 12:44:32',NULL,NULL),(58234,'68351','S','Exeter','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.642520,-97.446271,0,'2013-07-06 12:44:33',NULL,NULL),(3769,'02189','S','Weymouth','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.213831,-70.932791,0,'2013-07-06 12:44:30',NULL,NULL),(51654,'59875','S','Victor','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.402361,-114.167020,0,'2013-07-06 12:44:33',NULL,NULL),(12539,'13037','S','Sullivan','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(50009,'57381','S','Wessington','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.373351,-98.680654,0,'2013-07-06 12:44:33',NULL,NULL),(66135,'78465','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.776147,-97.419137,0,'2013-07-06 12:44:34',NULL,NULL),(49728,'57046','S','Mission Hill','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.997714,-97.338079,0,'2013-07-06 12:44:33',NULL,NULL),(26771,'29440','S','Georgetown','D','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.526980,-79.298460,0,'2013-07-06 12:44:31',NULL,NULL),(3162,'01266','S','Interlaken','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.333061,-73.380396,0,'2013-07-06 12:44:30',NULL,NULL),(3411,'01718','S','Acton','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.517046,-71.412305,0,'2013-07-06 12:44:30',NULL,NULL),(24972,'27847','S','Kelford','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.181279,-77.218678,0,'2013-07-06 12:44:31',NULL,NULL),(32736,'36319','S','Haleburg','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.315380,-85.123620,0,'2013-07-06 12:44:32',NULL,NULL),(78141,'97539','S','Shady Cove','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.615032,-122.812277,0,'2013-07-06 12:44:34',NULL,NULL),(72263,'88541','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.772056,-106.430870,0,'2013-07-06 12:44:34',NULL,NULL),(63427,'75661','S','Uncertain','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.628300,-94.175280,0,'2013-07-06 12:44:33',NULL,NULL),(32836,'36476','P','River Falls','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.301610,-86.622849,0,'2013-07-06 12:44:32',NULL,NULL),(11903,'12404','S','Mettacahonts','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810460,-74.249820,0,'2013-07-06 12:44:30',NULL,NULL),(40132,'45335','S','Jamestown','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.639044,-83.749398,0,'2013-07-06 12:44:32',NULL,NULL),(3704,'02140','S','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.392350,-71.131259,0,'2013-07-06 12:44:30',NULL,NULL),(5675,'04965','S','Palmyra','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.859932,-69.373177,0,'2013-07-06 12:44:30',NULL,NULL),(12153,'12740','S','Sundown','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.888409,-74.521026,0,'2013-07-06 12:44:30',NULL,NULL),(44093,'49461','S','Whitehall','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.384995,-86.340748,0,'2013-07-06 12:44:32',NULL,NULL),(40991,'46356','S','Lake Dalecarlia','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.284559,-87.416071,0,'2013-07-06 12:44:32',NULL,NULL),(19853,'20511','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.840700,-77.016700,0,'2013-07-06 12:44:31',NULL,NULL),(77625,'97001','S','Clarno','N','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.876700,-120.709320,0,'2013-07-06 12:44:34',NULL,NULL),(2390,'00949','S','Urb Levittown Lakes','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(20149,'20732','S','Chesapeake Beach','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.658353,-76.546878,0,'2013-07-06 12:44:31',NULL,NULL),(45075,'50525','S','Clarion','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.729586,-93.733773,0,'2013-07-06 12:44:32',NULL,NULL),(61272,'72379','P','Snow Lake','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.043221,-91.043702,0,'2013-07-06 12:44:33',NULL,NULL),(5061,'04276','S','Rumford Ctr','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.546376,-70.554444,0,'2013-07-06 12:44:30',NULL,NULL),(38571,'43780','S','Senecaville','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.937952,-81.463412,0,'2013-07-06 12:44:32',NULL,NULL),(21865,'23150','S','Sandston','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.507416,-77.252885,0,'2013-07-06 12:44:31',NULL,NULL),(78378,'98023','S','Federal Way','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.304480,-122.372580,0,'2013-07-06 12:44:34',NULL,NULL),(79591,'99033','S','Tekoa','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.225203,-117.070645,0,'2013-07-06 12:44:34',NULL,NULL),(30197,'33180','S','Nmb','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.961901,-80.140608,0,'2013-07-06 12:44:32',NULL,NULL),(68659,'81649','P','Red Cliff','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.486718,-106.376152,0,'2013-07-06 12:44:34',NULL,NULL),(15197,'15954','S','Seward','D','Westmoreland','42129','Pennsylvania','PA','42','6280','814','Eastern',-5.0,'Y',40.403760,-79.025220,0,'2013-07-06 12:44:31',NULL,NULL),(57486,'66932','S','Athol','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.810288,-98.557279,0,'2013-07-06 12:44:33',NULL,NULL),(60289,'71452','S','Melrose','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.650694,-93.016790,0,'2013-07-06 12:44:33',NULL,NULL),(34634,'38760','P','Metcalfe','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444780,-91.001974,0,'2013-07-06 12:44:32',NULL,NULL),(48767,'55983','S','Wanamingo','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.302169,-92.788163,0,'2013-07-06 12:44:33',NULL,NULL),(34818,'38902','P','Grenada','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.778833,-89.812279,0,'2013-07-06 12:44:32',NULL,NULL),(38190,'43203','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.971464,-82.969937,0,'2013-07-06 12:44:32',NULL,NULL),(57126,'66224','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(10314,'10537','S','Lake Peekskill','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.337997,-73.885707,0,'2013-07-06 12:44:30',NULL,NULL),(52724,'61231','S','Ohio Grove','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(24429,'27198','U','Winston Salem Courtesy Reply','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.105109,-80.225702,0,'2013-07-06 12:44:31',NULL,NULL),(10284,'10516','S','Philipstown','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422380,-73.950720,0,'2013-07-06 12:44:30',NULL,NULL),(59128,'70160','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.940419,-90.084959,0,'2013-07-06 12:44:33',NULL,NULL),(40497,'45804','S','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.721201,-84.076062,0,'2013-07-06 12:44:32',NULL,NULL),(31352,'34202','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.475504,-82.392128,0,'2013-07-06 12:44:32',NULL,NULL),(8578,'08215','S','South Egg Harbor','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(41166,'46703','S','Scott','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(70252,'84414','S','Pleasant View','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.315661,-111.978351,0,'2013-07-06 12:44:34',NULL,NULL),(72071,'88124','S','Melrose','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.431609,-103.627753,0,'2013-07-06 12:44:34',NULL,NULL),(72256,'88533','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811084,-106.416966,0,'2013-07-06 12:44:34',NULL,NULL),(73988,'92093','U','Uc San Diego','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.877058,-117.230578,0,'2013-07-06 12:44:34',NULL,NULL),(4996,'04217','S','Albany Twp','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.447236,-70.693616,0,'2013-07-06 12:44:30',NULL,NULL),(16128,'17057','S','Middletwn','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(39984,'45240','S','Forest Park','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.285863,-84.524542,0,'2013-07-06 12:44:32',NULL,NULL),(37956,'42718','S','Finley','A','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.461291,-85.462912,0,'2013-07-06 12:44:32',NULL,NULL),(35436,'39476','S','Piave','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(16003,'17038','S','McGillstown','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.410665,-76.486339,0,'2013-07-06 12:44:31',NULL,NULL),(47546,'54826','S','Comstock','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.486641,-92.088794,0,'2013-07-06 12:44:32',NULL,NULL),(52859,'61329','S','Ladd','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.378377,-89.217491,0,'2013-07-06 12:44:33',NULL,NULL),(58940,'69353','P','McGrew','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.785535,-103.681149,0,'2013-07-06 12:44:33',NULL,NULL),(66369,'78619','S','Driftwood','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.076279,-98.024355,0,'2013-07-06 12:44:34',NULL,NULL),(70107,'84171','P','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(75611,'94404','S','Foster City','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.547930,-122.269310,0,'2013-07-06 12:44:34',NULL,NULL),(2771,'00975','U','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410442,-66.065594,0,'2013-07-06 12:44:30',NULL,NULL),(24057,'26426','S','Salem','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281554,-80.559325,0,'2013-07-06 12:44:31',NULL,NULL),(12019,'12507','S','Red Hook','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.995000,-73.875833,0,'2013-07-06 12:44:30',NULL,NULL),(63636,'75840','S','Turlington','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.722324,-96.157345,0,'2013-07-06 12:44:34',NULL,NULL),(79242,'98557','S','Garden City','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.053140,-123.286440,0,'2013-07-06 12:44:34',NULL,NULL),(80126,'99768','P','Ruby','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.351768,-155.985094,0,'2013-07-06 12:44:34',NULL,NULL),(32213,'35564','S','Hackleburg','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.259300,-87.866969,0,'2013-07-06 12:44:32',NULL,NULL),(26826,'29485','S','Ladson','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.975069,-80.180159,0,'2013-07-06 12:44:31',NULL,NULL),(79851,'99550','P','Port Lions','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.822751,-153.076643,0,'2013-07-06 12:44:34',NULL,NULL),(4434,'03241','S','Groton','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.712551,-71.875491,0,'2013-07-06 12:44:30',NULL,NULL),(38982,'44131','S','Brooklyn Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(25349,'28226','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.107873,-80.807637,0,'2013-07-06 12:44:31',NULL,NULL),(42518,'47851','P','Nevins','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.543778,-87.319509,0,'2013-07-06 12:44:32',NULL,NULL),(48930,'56153','P','Leota','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.820813,-95.995240,0,'2013-07-06 12:44:33',NULL,NULL),(68421,'81210','S','Tincup','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(68631,'81635','S','Btlmt Mesa','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.460598,-108.009596,0,'2013-07-06 12:44:34',NULL,NULL),(75259,'93666','P','Sultana','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.546876,-119.335670,0,'2013-07-06 12:44:34',NULL,NULL),(38296,'43343','S','Quincy','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.318945,-83.974251,0,'2013-07-06 12:44:32',NULL,NULL),(56236,'65046','S','Lupus','N','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.790635,-92.483677,0,'2013-07-06 12:44:33',NULL,NULL),(47719,'55006','S','Braham','D','Isanti','27059','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.724622,-93.172881,0,'2013-07-06 12:44:33',NULL,NULL),(17391,'17901','S','Bunker Hill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(72040,'88061','S','Mangas Springs','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.775733,-108.264777,0,'2013-07-06 12:44:34',NULL,NULL),(21235,'22230','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.870056,-77.116680,0,'2013-07-06 12:44:31',NULL,NULL),(32117,'35406','S','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.251917,-87.530735,0,'2013-07-06 12:44:32',NULL,NULL),(45358,'51002','S','Alta','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.672649,-95.304541,0,'2013-07-06 12:44:32',NULL,NULL),(47693,'54970','S','Lohrville','N','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.048400,-89.084940,0,'2013-07-06 12:44:33',NULL,NULL),(53668,'62214','S','Addieville','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.381708,-89.611975,0,'2013-07-06 12:44:33',NULL,NULL),(55761,'64116','S','Kans Cy','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(69947,'84117','S','Holladay Ctwd','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(71568,'87301','S','Tohlakai','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(74723,'93030','S','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.214999,-119.179607,0,'2013-07-06 12:44:34',NULL,NULL),(77130,'96155','P','Tahoe Paradise','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.018968,-120.123053,0,'2013-07-06 12:44:34',NULL,NULL),(62279,'74016','S','Chelsea','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.540960,-95.446920,0,'2013-07-06 12:44:33',NULL,NULL),(13273,'13654','S','Heuvelton','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.582100,-75.440160,0,'2013-07-06 12:44:30',NULL,NULL),(26835,'29492','S','Charleston','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.955719,-79.887276,0,'2013-07-06 12:44:31',NULL,NULL),(22676,'24312','S','Austinville','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.819859,-80.870189,0,'2013-07-06 12:44:31',NULL,NULL),(18701,'19194','U','First Chicago','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954940,-75.183065,0,'2013-07-06 12:44:31',NULL,NULL),(12653,'13117','P','Montezuma','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.009921,-76.700005,0,'2013-07-06 12:44:30',NULL,NULL),(78177,'97641','P','Christmas Vly','A','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.240268,-120.677507,0,'2013-07-06 12:44:34',NULL,NULL),(52694,'61103','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.299190,-89.103195,0,'2013-07-06 12:44:33',NULL,NULL),(41846,'47351','P','Kennard','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.901651,-85.518515,0,'2013-07-06 12:44:32',NULL,NULL),(75099,'93541','P','Lee Vining','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.002080,-119.069580,0,'2013-07-06 12:44:34',NULL,NULL),(1217,'00728','S','Urb Casa Mia','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(16837,'17557','S','Greenbank','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101003,-76.079601,0,'2013-07-06 12:44:31',NULL,NULL),(5070,'04287','S','Bowdoin','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.985129,-70.094212,0,'2013-07-06 12:44:30',NULL,NULL),(36388,'40486','S','Maulden','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.378148,-83.874828,0,'2013-07-06 12:44:32',NULL,NULL),(32132,'35447','S','Pickensville','A','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.224370,-88.073930,0,'2013-07-06 12:44:32',NULL,NULL),(15349,'16238','P','Manorville','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.787779,-79.521007,0,'2013-07-06 12:44:31',NULL,NULL),(42379,'47719','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.986573,-87.595529,0,'2013-07-06 12:44:32',NULL,NULL),(48563,'55766','P','Melrude','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.236200,-92.412180,0,'2013-07-06 12:44:33',NULL,NULL),(51013,'58704','S','Minot Air Force Base','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.232500,-101.295833,0,'2013-07-06 12:44:33',NULL,NULL),(72474,'89124','S','Mountain Sprg','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(13655,'14013','S','Basom','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.071553,-78.387693,0,'2013-07-06 12:44:31',NULL,NULL),(45734,'52101','S','Decorah','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(75814,'94806','S','Tara Hills','N','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972918,-122.333929,0,'2013-07-06 12:44:34',NULL,NULL),(56090,'64772','S','Camp Clark','N','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.838803,-94.361260,0,'2013-07-06 12:44:33',NULL,NULL),(32555,'36113','S','Maxwell AFB','A','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382900,-86.304300,0,'2013-07-06 12:44:32',NULL,NULL),(49797,'57118','P','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.604782,-96.706975,0,'2013-07-06 12:44:33',NULL,NULL),(42483,'47837','S','Smockville','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.576608,-87.056532,0,'2013-07-06 12:44:32',NULL,NULL),(41633,'47131','P','Clarksville','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.338659,-85.705189,0,'2013-07-06 12:44:32',NULL,NULL),(22349,'23885','S','Sutherland','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.196090,-77.553076,0,'2013-07-06 12:44:31',NULL,NULL),(4485,'03274','P','Stinson Lake','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.859098,-71.802344,0,'2013-07-06 12:44:30',NULL,NULL),(67345,'80108','S','Castle Pines','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.391907,-104.859358,0,'2013-07-06 12:44:34',NULL,NULL),(73104,'90242','S','Downey','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.924064,-118.145732,0,'2013-07-06 12:44:34',NULL,NULL),(16246,'17082','S','Pleasantview','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(36276,'40339','P','Keene','D','Jessamine','21113','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.938356,-84.656390,0,'2013-07-06 12:44:32',NULL,NULL),(4218,'02839','S','Mapleville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.942142,-71.637583,0,'2013-07-06 12:44:30',NULL,NULL),(14273,'14851','P','Ithaca','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.447569,-76.503192,0,'2013-07-06 12:44:31',NULL,NULL),(27620,'30308','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.769731,-84.377217,0,'2013-07-06 12:44:31',NULL,NULL),(8777,'08551','S','East Amwell','N','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.441298,-74.836215,0,'2013-07-06 12:44:30',NULL,NULL),(51450,'59480','S','Stockett','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.237996,-111.146478,0,'2013-07-06 12:44:33',NULL,NULL),(51459,'59520','S','Big Sandy','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.059026,-110.023117,0,'2013-07-06 12:44:33',NULL,NULL),(60815,'72032','S','Gleason','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(57070,'66214','S','Shawnee','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(15865,'16948','S','Brookland','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846520,-77.709720,0,'2013-07-06 12:44:31',NULL,NULL),(48070,'55330','S','Burns Township','A','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(4804,'03885','S','Stratham','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.017264,-70.897061,0,'2013-07-06 12:44:30',NULL,NULL),(67404,'80129','S','Hghlnds Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.543276,-105.007567,0,'2013-07-06 12:44:34',NULL,NULL),(71717,'87531','S','Junta','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.141996,-105.998001,0,'2013-07-06 12:44:34',NULL,NULL),(33272,'37098','S','Wrigley','A','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.888030,-87.337285,0,'2013-07-06 12:44:32',NULL,NULL),(77157,'96205','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(59670,'71055','S','Minden','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.617484,-93.281086,0,'2013-07-06 12:44:33',NULL,NULL),(2322,'00930','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405329,-66.062376,0,'2013-07-06 12:44:30',NULL,NULL),(34187,'38326','S','Counce','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.168761,-88.213907,0,'2013-07-06 12:44:32',NULL,NULL),(30564,'33413','S','Greenacres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.678715,-80.141603,0,'2013-07-06 12:44:32',NULL,NULL),(51437,'59465','S','Neihart','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.046281,-110.770490,0,'2013-07-06 12:44:33',NULL,NULL),(19432,'20104','U','Inspection Service Forensic','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.326264,-77.534628,0,'2013-07-06 12:44:31',NULL,NULL),(52071,'60305','S','River Forest','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.894703,-87.818109,0,'2013-07-06 12:44:33',NULL,NULL),(26944,'29601','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.850510,-82.403553,0,'2013-07-06 12:44:31',NULL,NULL),(61152,'72173','S','Otto','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.066940,-92.174760,0,'2013-07-06 12:44:33',NULL,NULL),(22790,'24463','P','Mint Spring','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.063584,-79.113794,0,'2013-07-06 12:44:31',NULL,NULL),(10124,'10260','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(14309,'14887','P','Tyrone','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.402468,-77.069893,0,'2013-07-06 12:44:31',NULL,NULL),(3899,'02451','S','North Waltham','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.399203,-71.262490,0,'2013-07-06 12:44:30',NULL,NULL),(30461,'33336','U','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.142550,-80.139499,0,'2013-07-06 12:44:32',NULL,NULL),(2139,'00924','S','Urb La Vista','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(57214,'66441','S','Junction City','D','Geary','20061','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.026800,-96.836313,0,'2013-07-06 12:44:33',NULL,NULL),(23152,'25002','P','Alloy','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.181600,-81.328790,0,'2013-07-06 12:44:31',NULL,NULL),(8296,'08021','S','Pine Hill','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(25853,'28625','S','Statesville','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.780234,-80.886089,0,'2013-07-06 12:44:31',NULL,NULL),(16771,'17522','S','Hahnstown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(57326,'66711','S','Gross','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.625557,-94.701799,0,'2013-07-06 12:44:33',NULL,NULL),(79557,'99009','S','Elk','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',48.013171,-117.270307,0,'2013-07-06 12:44:34',NULL,NULL),(75093,'93536','S','Fairmont','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(68420,'81210','S','Taylor Park','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(50268,'57642','S','Maple Leaf','N','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.810968,-100.813494,0,'2013-07-06 12:44:33',NULL,NULL),(49881,'57262','S','Tekakwitha','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.664922,-97.048055,0,'2013-07-06 12:44:33',NULL,NULL),(16162,'17063','S','Locke Mills','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.716078,-77.590384,0,'2013-07-06 12:44:31',NULL,NULL),(34121,'38188','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.096999,-89.857680,0,'2013-07-06 12:44:32',NULL,NULL),(31315,'34110','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.305562,-81.790880,0,'2013-07-06 12:44:32',NULL,NULL),(24298,'27011','S','Richmond Hill','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.240300,-80.637420,0,'2013-07-06 12:44:31',NULL,NULL),(39249,'44438','S','Masury','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.225733,-80.533137,0,'2013-07-06 12:44:32',NULL,NULL),(7,'00601','S','Jard de Adjuntas','N','Adjuntas','72001','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.165950,-66.723627,0,'2013-07-06 12:44:30',NULL,NULL),(76989,'96069','S','Oak Run','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.698804,-122.014457,0,'2013-07-06 12:44:34',NULL,NULL),(75476,'94111','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.798010,-122.396965,0,'2013-07-06 12:44:34',NULL,NULL),(1755,'00778','S','Vista Lago','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(72939,'90036','S','Miracle Mile','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.067699,-118.350907,0,'2013-07-06 12:44:34',NULL,NULL),(9493,'10013','S','Canal Street','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(4178,'02812','S','Richmond','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.477353,-71.646761,0,'2013-07-06 12:44:30',NULL,NULL),(76294,'95437','S','Cleone','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(68092,'80942','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834659,-104.822936,0,'2013-07-06 12:44:34',NULL,NULL),(46455,'53212','S','Glendale','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.070633,-87.906171,0,'2013-07-06 12:44:32',NULL,NULL),(56367,'65215','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.953037,-92.325011,0,'2013-07-06 12:44:33',NULL,NULL),(57431,'66782','P','West Mineral','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.286058,-94.924505,0,'2013-07-06 12:44:33',NULL,NULL),(58772,'68969','P','Scandinavia','N','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.310839,-99.254620,0,'2013-07-06 12:44:33',NULL,NULL),(34687,'38828','S','Blue Springs','D','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(2628,'00962','S','Urb Marina Bahia','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(12028,'12515','S','Clintondale','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.673000,-74.059920,0,'2013-07-06 12:44:30',NULL,NULL),(23060,'24870','S','Oceana','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.711020,-81.604020,0,'2013-07-06 12:44:31',NULL,NULL),(75203,'93627','P','Helm','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.575023,-120.081468,0,'2013-07-06 12:44:34',NULL,NULL),(74104,'92220','S','Banning','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.931597,-116.885541,0,'2013-07-06 12:44:34',NULL,NULL),(72885,'90015','S','Del Valle Finance','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038557,-118.268695,0,'2013-07-06 12:44:34',NULL,NULL),(36253,'40313','S','Clearfield','D','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.139029,-83.539583,0,'2013-07-06 12:44:32',NULL,NULL),(8143,'07840','S','Hackettstown','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.855816,-74.844411,0,'2013-07-06 12:44:30',NULL,NULL),(18744,'19341','S','Exton','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.040047,-75.636825,0,'2013-07-06 12:44:31',NULL,NULL),(13057,'13440','S','Spencer Settlement','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(24309,'27017','S','Devotion','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(41223,'46733','S','Hondorus','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(41568,'47025','S','Greendale','A','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.152460,-84.887280,0,'2013-07-06 12:44:32',NULL,NULL),(13120,'13490','S','Hecla','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.113737,-75.416336,0,'2013-07-06 12:44:30',NULL,NULL),(46559,'53508','S','Belleville','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.881803,-89.560741,0,'2013-07-06 12:44:32',NULL,NULL),(46886,'54114','S','Crivitz','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.293210,-87.992690,0,'2013-07-06 12:44:32',NULL,NULL),(48079,'55331','S','Minnetrista','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(25046,'27915','P','Avon','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.349432,-75.501840,0,'2013-07-06 12:44:31',NULL,NULL),(9078,'09012','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(29437,'32692','P','Suwannee','D','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.327937,-83.145284,0,'2013-07-06 12:44:32',NULL,NULL),(31277,'34024','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(50319,'57724','S','Camp Crook','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.615420,-103.933080,0,'2013-07-06 12:44:33',NULL,NULL),(32727,'36312','S','Avon','A','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.188743,-85.240935,0,'2013-07-06 12:44:32',NULL,NULL),(38442,'43570','S','Archbold','A','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.584133,-84.438762,0,'2013-07-06 12:44:32',NULL,NULL),(75026,'93504','P','Calif City','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.147963,-118.010042,0,'2013-07-06 12:44:34',NULL,NULL),(71656,'87501','S','Nambe','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(63311,'75567','S','Corley','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.364200,-94.472220,0,'2013-07-06 12:44:33',NULL,NULL),(17994,'18628','S','Lopez','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.456957,-76.295701,0,'2013-07-06 12:44:31',NULL,NULL),(37089,'41339','S','Guerrant','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(61613,'72820','P','Alix','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.505512,-93.844411,0,'2013-07-06 12:44:33',NULL,NULL),(73911,'92018','P','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.162901,-117.345744,0,'2013-07-06 12:44:34',NULL,NULL),(69752,'84050','S','Morgan','D','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(20995,'21822','S','Eden','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.282396,-75.658085,0,'2013-07-06 12:44:31',NULL,NULL),(38386,'43516','S','Deshler','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.206706,-83.901298,0,'2013-07-06 12:44:32',NULL,NULL),(40243,'45426','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.804271,-84.300328,0,'2013-07-06 12:44:32',NULL,NULL),(31470,'34290','P','Venice','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.043504,-82.236065,0,'2013-07-06 12:44:32',NULL,NULL),(29221,'32421','S','Altha','D','Calhoun','12013','Florida','FL','12','0000','850','Central',-6.0,'Y',30.520144,-85.213643,0,'2013-07-06 12:44:32',NULL,NULL),(41739,'47264','S','Norman','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.953683,-86.223030,0,'2013-07-06 12:44:32',NULL,NULL),(77827,'97210','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.533955,-122.714744,0,'2013-07-06 12:44:34',NULL,NULL),(77479,'96821','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289359,-157.755003,0,'2013-07-06 12:44:34',NULL,NULL),(67421,'80150','P','Greenwood Village','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643214,-104.985443,0,'2013-07-06 12:44:34',NULL,NULL),(4010,'02556','S','N Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.649960,-70.624919,0,'2013-07-06 12:44:30',NULL,NULL),(44718,'50149','S','Barney','N','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.111128,-94.073065,0,'2013-07-06 12:44:32',NULL,NULL),(70968,'85655','P','Douglas','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.339191,-109.529628,0,'2013-07-06 12:44:34',NULL,NULL),(31926,'35179','S','S Vinemont','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.264921,-87.009412,0,'2013-07-06 12:44:32',NULL,NULL),(23727,'25911','P','Raleigh','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.755290,-81.170641,0,'2013-07-06 12:44:31',NULL,NULL),(50233,'57620','S','Chance','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(11585,'12075','S','Ghent','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.292747,-73.702189,0,'2013-07-06 12:44:30',NULL,NULL),(27343,'30045','S','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.937159,-83.961100,0,'2013-07-06 12:44:31',NULL,NULL),(19438,'20109','S','Manassas','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.799297,-77.546852,0,'2013-07-06 12:44:31',NULL,NULL),(38341,'43438','P','Kelleys Island','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.603835,-82.686144,0,'2013-07-06 12:44:32',NULL,NULL),(52416,'60643','S','Morgan Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.699379,-87.659992,0,'2013-07-06 12:44:33',NULL,NULL),(74230,'92321','P','Cedar Glen','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.254999,-117.170783,0,'2013-07-06 12:44:34',NULL,NULL),(1255,'00729','S','Urb River Gdns','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(20906,'21718','S','Burkittsville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.391756,-77.631033,0,'2013-07-06 12:44:31',NULL,NULL),(27002,'29633','P','Clemson','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.698880,-82.893146,0,'2013-07-06 12:44:31',NULL,NULL),(67240,'79938','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.822773,-106.187046,0,'2013-07-06 12:44:34',NULL,NULL),(62965,'75125','S','Ferris','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.519486,-96.617282,0,'2013-07-06 12:44:33',NULL,NULL),(11880,'12306','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.792392,-73.984961,0,'2013-07-06 12:44:30',NULL,NULL),(29835,'33031','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526883,-80.482539,0,'2013-07-06 12:44:32',NULL,NULL),(47572,'54843','S','North Woods Beach','A','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.018712,-91.462960,0,'2013-07-06 12:44:33',NULL,NULL),(39304,'44510','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.121745,-80.667955,0,'2013-07-06 12:44:32',NULL,NULL),(77596,'96932','P','Agana','N','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.475530,144.748524,0,'2013-07-06 12:44:34',NULL,NULL),(68252,'81062','S','Olney Springs','D','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.212062,-103.937865,0,'2013-07-06 12:44:34',NULL,NULL),(29056,'32240','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.278240,-81.411680,0,'2013-07-06 12:44:32',NULL,NULL),(3915,'02459','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.308823,-71.191835,0,'2013-07-06 12:44:30',NULL,NULL),(22556,'24141','S','Fairlawn','A','Radford City','51750','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136700,-80.608200,0,'2013-07-06 12:44:31',NULL,NULL),(46483,'53221','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.947637,-87.944575,0,'2013-07-06 12:44:32',NULL,NULL),(78829,'98335','S','Point Fosdick','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(8617,'08246','P','S Seaville','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.176868,-74.761084,0,'2013-07-06 12:44:30',NULL,NULL),(34949,'39058','U','Clinton','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.342830,-90.324199,0,'2013-07-06 12:44:32',NULL,NULL),(13509,'13810','S','Welcome','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.612677,-75.133564,0,'2013-07-06 12:44:31',NULL,NULL),(74280,'92357','U','Veterans\' Hospital','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.054612,-117.252812,0,'2013-07-06 12:44:34',NULL,NULL),(77584,'96915','S','Umatac','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(77991,'97402','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.057393,-123.188424,0,'2013-07-06 12:44:34',NULL,NULL),(2483,'00956','S','Urb Irlanda Hts','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(50965,'58627','S','Fairfield','D','Billings','38007','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.120520,-103.314000,0,'2013-07-06 12:44:33',NULL,NULL),(29324,'32542','S','Eglin','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(22060,'23326','U','Coast Guard Finance Center','N','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.763676,-76.252135,0,'2013-07-06 12:44:31',NULL,NULL),(56055,'64739','S','Creighton','D','Henry','29083','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.504829,-94.095951,0,'2013-07-06 12:44:33',NULL,NULL),(70854,'85550','P','San Carlos','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.365010,-110.457515,0,'2013-07-06 12:44:34',NULL,NULL),(47920,'55110','S','White Bear Tp','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(45994,'52501','S','Ottumwa','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(35636,'39638','S','Ariel','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(40516,'45819','S','Lima','A','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.624010,-84.262255,0,'2013-07-06 12:44:32',NULL,NULL),(20220,'20772','S','Upper Marlboro','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.799000,-76.785960,0,'2013-07-06 12:44:31',NULL,NULL),(15239,'16039','P','Herman','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.840488,-79.811967,0,'2013-07-06 12:44:31',NULL,NULL),(25807,'28607','S','Laxon','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(61349,'72472','S','Trumann','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.666940,-90.539160,0,'2013-07-06 12:44:33',NULL,NULL),(56549,'65459','S','Hayden','N','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.999415,-92.102681,0,'2013-07-06 12:44:33',NULL,NULL),(20715,'21279','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.296632,-76.608209,0,'2013-07-06 12:44:31',NULL,NULL),(38552,'43756','S','Reinersville','N','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.690000,-81.835980,0,'2013-07-06 12:44:32',NULL,NULL),(71292,'86443','S','Temple Bar Marina','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',36.024395,-114.298481,0,'2013-07-06 12:44:34',NULL,NULL),(73596,'91387','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425030,-118.444260,0,'2013-07-06 12:44:34',NULL,NULL),(16956,'17702','S','Duboistown','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(44604,'50051','S','Clemons','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.131461,-93.145031,0,'2013-07-06 12:44:32',NULL,NULL),(59144,'70175','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.924771,-90.104056,0,'2013-07-06 12:44:33',NULL,NULL),(54221,'62650','S','Lynnville','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(40456,'45742','S','Little Hockng','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.283437,-81.692064,0,'2013-07-06 12:44:32',NULL,NULL),(9122,'09139','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3027,'01092','P','W Warren','N','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.212500,-72.191667,0,'2013-07-06 12:44:30',NULL,NULL),(72870,'90008','S','Crenshaw','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006715,-118.339229,0,'2013-07-06 12:44:34',NULL,NULL),(25388,'28269','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.314436,-80.805053,0,'2013-07-06 12:44:31',NULL,NULL),(18625,'19151','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.977579,-75.254673,0,'2013-07-06 12:44:31',NULL,NULL),(20356,'20871','S','Hyattstown','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.255811,-77.279923,0,'2013-07-06 12:44:31',NULL,NULL),(20992,'21821','S','Dames Quarter','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.167252,-75.905948,0,'2013-07-06 12:44:31',NULL,NULL),(23869,'26152','S','Munday','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.007664,-81.229239,0,'2013-07-06 12:44:31',NULL,NULL),(34357,'38601','S','Abbeville','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.472120,-89.600253,0,'2013-07-06 12:44:32',NULL,NULL),(725,'00687','S','Urb Las Cumbres','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(51028,'58718','S','Berthold','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328239,-101.921232,0,'2013-07-06 12:44:33',NULL,NULL),(50510,'58075','S','Dwight','A','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.273495,-96.609475,0,'2013-07-06 12:44:33',NULL,NULL),(40396,'45669','S','Proctorville','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.435220,-82.381444,0,'2013-07-06 12:44:32',NULL,NULL),(27586,'30285','S','The Rock','D','Upson','13293','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.969762,-84.247908,0,'2013-07-06 12:44:31',NULL,NULL),(5551,'04850','P','Lincolnville Center','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.294881,-69.109732,0,'2013-07-06 12:44:30',NULL,NULL),(20529,'21094','P','Lutherville Timonium','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.421320,-76.623102,0,'2013-07-06 12:44:31',NULL,NULL),(68086,'80939','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798565,-104.836169,0,'2013-07-06 12:44:34',NULL,NULL),(71671,'87506','S','San Ildefonso','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.585314,-106.024436,0,'2013-07-06 12:44:34',NULL,NULL),(69543,'83803','S','Bayview','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.984780,-116.564588,0,'2013-07-06 12:44:34',NULL,NULL),(29076,'32255','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.280202,-81.546387,0,'2013-07-06 12:44:32',NULL,NULL),(29607,'32839','S','Edgewood','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.487458,-81.403507,0,'2013-07-06 12:44:32',NULL,NULL),(56996,'66203','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(33093,'36832','S','Auburn','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.593250,-85.479363,0,'2013-07-06 12:44:32',NULL,NULL),(8176,'07876','S','Succasunna','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.858420,-74.651368,0,'2013-07-06 12:44:30',NULL,NULL),(799,'00693','S','Qtas De Tortuguero','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(9770,'10105','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(46684,'53778','U','Swiss Colony','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.096424,-89.322479,0,'2013-07-06 12:44:32',NULL,NULL),(62818,'74954','S','Roland','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.417716,-94.509455,0,'2013-07-06 12:44:33',NULL,NULL),(13056,'13440','S','Seifert Corners','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(58410,'68641','S','Howells','D','Colfax','31037','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.725645,-97.002347,0,'2013-07-06 12:44:33',NULL,NULL),(25049,'27917','S','Barco','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.359337,-75.990261,0,'2013-07-06 12:44:31',NULL,NULL),(50314,'57718','S','Black Hawk','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.156289,-103.325645,0,'2013-07-06 12:44:33',NULL,NULL),(33666,'37724','S','Cumberland Gp','A','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.542300,-83.689657,0,'2013-07-06 12:44:32',NULL,NULL),(57319,'66701','S','Hiattville','A','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.822740,-94.701540,0,'2013-07-06 12:44:33',NULL,NULL),(27879,'30451','P','Pulaski','D','Candler','13043','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.391427,-81.959069,0,'2013-07-06 12:44:31',NULL,NULL),(11687,'12155','S','Elk Creek','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597180,-74.818920,0,'2013-07-06 12:44:30',NULL,NULL),(6116,'05457','S','Morses Line','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(60487,'71659','P','Moscow','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.146589,-91.795504,0,'2013-07-06 12:44:33',NULL,NULL),(64647,'76715','P','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.603053,-97.081317,0,'2013-07-06 12:44:34',NULL,NULL),(62770,'74864','S','Prague','D','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.485130,-96.685572,0,'2013-07-06 12:44:33',NULL,NULL),(5898,'05156','S','Pedden Acres','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.289460,-72.474780,0,'2013-07-06 12:44:30',NULL,NULL),(11160,'11721','S','Centerport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.890176,-73.372822,0,'2013-07-06 12:44:30',NULL,NULL),(37900,'42633','S','Barrier','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(8371,'08053','S','North Marlton','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(64760,'76940','S','Mereta','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.487707,-100.181602,0,'2013-07-06 12:44:34',NULL,NULL),(79376,'98666','P','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.712413,-122.597049,0,'2013-07-06 12:44:34',NULL,NULL),(48385,'55573','P','Young America','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814145,-93.918567,0,'2013-07-06 12:44:33',NULL,NULL),(62981,'75143','S','Tool','A','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.366040,-96.286680,0,'2013-07-06 12:44:33',NULL,NULL),(10136,'10268','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706940,-74.011574,0,'2013-07-06 12:44:30',NULL,NULL),(11157,'11720','S','S Setauket','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.871518,-73.084611,0,'2013-07-06 12:44:30',NULL,NULL),(1753,'00778','S','Villas de Gurabo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(65269,'77474','S','Peters','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.783576,-96.158093,0,'2013-07-06 12:44:34',NULL,NULL),(16144,'17059','S','Van Wert','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(39050,'44191','U','Key Corp','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.484680,-81.702744,0,'2013-07-06 12:44:32',NULL,NULL),(42621,'47905','S','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.322083,-86.910463,0,'2013-07-06 12:44:32',NULL,NULL),(35210,'39298','P','Jackson','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.321984,-90.206032,0,'2013-07-06 12:44:32',NULL,NULL),(50909,'58554','S','Mandan','D','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.828248,-100.892053,0,'2013-07-06 12:44:33',NULL,NULL),(73418,'91188','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.151026,-118.143944,0,'2013-07-06 12:44:34',NULL,NULL),(32029,'35242','S','Vestavia Hls','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(61145,'72167','S','Fenter','N','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.450558,-92.654895,0,'2013-07-06 12:44:33',NULL,NULL),(46418,'53185','S','Waterford','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.787140,-88.206480,0,'2013-07-06 12:44:32',NULL,NULL),(78529,'98129','U','Reg Lib Handicapped','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.615110,-122.338189,0,'2013-07-06 12:44:34',NULL,NULL),(68749,'82223','S','Lingle','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.002320,-104.576230,0,'2013-07-06 12:44:34',NULL,NULL),(63153,'75382','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.878734,-96.749853,0,'2013-07-06 12:44:33',NULL,NULL),(61411,'72556','S','Zion','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.062170,-91.899240,0,'2013-07-06 12:44:33',NULL,NULL),(28986,'32212','S','Nas Jax','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(13364,'13733','S','Bainbridge','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.304440,-75.480180,0,'2013-07-06 12:44:31',NULL,NULL),(3599,'02040','P','Greenbush','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.179589,-70.749679,0,'2013-07-06 12:44:30',NULL,NULL),(44949,'50381','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585640,-93.640154,0,'2013-07-06 12:44:32',NULL,NULL),(9290,'09649','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(65980,'78332','S','Alfred','N','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742680,-98.085900,0,'2013-07-06 12:44:34',NULL,NULL),(76102,'95225','P','Burson','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.184216,-120.886309,0,'2013-07-06 12:44:34',NULL,NULL),(76196,'95351','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.629231,-121.008022,0,'2013-07-06 12:44:34',NULL,NULL),(79016,'98391','S','Bonney Lake','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(79660,'99153','S','Metaline Fls','A','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.854700,-117.348494,0,'2013-07-06 12:44:34',NULL,NULL),(79203,'98533','S','Cinebar','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.583022,-122.540618,0,'2013-07-06 12:44:34',NULL,NULL),(1960,'00822','P','Christiansted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.744810,-64.709745,0,'2013-07-06 12:44:30',NULL,NULL),(15861,'16947','S','Troy','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.783653,-76.791605,0,'2013-07-06 12:44:31',NULL,NULL),(25148,'28021','S','Flay','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.381411,-81.375643,0,'2013-07-06 12:44:31',NULL,NULL),(42033,'47439','P','Koleen','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.032313,-86.852313,0,'2013-07-06 12:44:32',NULL,NULL),(520,'00674','S','Urb Manati Chalets','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(1193,'00728','S','Ext Las Delicias 2','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(71665,'87503','U','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.683677,-105.938892,0,'2013-07-06 12:44:34',NULL,NULL),(14894,'15489','P','W Leisenring','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.952923,-79.702222,0,'2013-07-06 12:44:31',NULL,NULL),(31606,'34680','P','Elfers','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210297,-82.711649,0,'2013-07-06 12:44:32',NULL,NULL),(29695,'32935','S','Suntree','N','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.138545,-80.657969,0,'2013-07-06 12:44:32',NULL,NULL),(23247,'25115','S','Kanawha Falls','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.115592,-81.158077,0,'2013-07-06 12:44:31',NULL,NULL),(25718,'28543','S','Tarawa Terrace','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.734194,-77.377379,0,'2013-07-06 12:44:31',NULL,NULL),(44125,'49508','S','Kentwood','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.873625,-85.625143,0,'2013-07-06 12:44:32',NULL,NULL),(11452,'11978','S','West Hampton Beach','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(60788,'72025','S','Homewood','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.030179,-93.036863,0,'2013-07-06 12:44:33',NULL,NULL),(62645,'74572','S','Tupelo','D','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.604978,-96.414543,0,'2013-07-06 12:44:33',NULL,NULL),(66150,'78502','P','Mc Allen','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.198279,-98.246967,0,'2013-07-06 12:44:34',NULL,NULL),(68471,'81240','S','Penrose','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.431671,-105.009121,0,'2013-07-06 12:44:34',NULL,NULL),(22074,'23354','S','Franktown','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.469820,-75.913860,0,'2013-07-06 12:44:31',NULL,NULL),(26292,'29021','P','Kirkwood','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(39449,'44702','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.798315,-81.377198,0,'2013-07-06 12:44:32',NULL,NULL),(57649,'67204','S','North Wichita','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.752075,-97.357444,0,'2013-07-06 12:44:33',NULL,NULL),(3300,'01510','S','Clinton','D','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.419337,-71.685094,0,'2013-07-06 12:44:30',NULL,NULL),(21973,'23242','P','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.619818,-77.613981,0,'2013-07-06 12:44:31',NULL,NULL),(38466,'43617','S','Sylvania Township','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.664110,-83.717316,0,'2013-07-06 12:44:32',NULL,NULL),(44635,'50068','S','Last Chance','N','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.943215,-93.498112,0,'2013-07-06 12:44:32',NULL,NULL),(76586,'95682','S','Shingle Springs','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.656055,-120.961681,0,'2013-07-06 12:44:34',NULL,NULL),(80133,'99774','P','Stevens Vlg','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.024206,-149.187155,0,'2013-07-06 12:44:34',NULL,NULL),(73753,'91729','P','Cucamonga','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.098356,-117.563036,0,'2013-07-06 12:44:34',NULL,NULL),(62294,'74021','S','Collinsville','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.360682,-95.850702,0,'2013-07-06 12:44:33',NULL,NULL),(15190,'15948','P','Revloc','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.488532,-78.763286,0,'2013-07-06 12:44:31',NULL,NULL),(56717,'65682','S','Lockwood','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.384939,-93.950106,0,'2013-07-06 12:44:33',NULL,NULL),(10353,'10576','S','Pound Ridge','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.224542,-73.571480,0,'2013-07-06 12:44:30',NULL,NULL),(34477,'38664','S','Robinsonville','D','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(15655,'16748','S','Millport','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.947620,-78.166200,0,'2013-07-06 12:44:31',NULL,NULL),(52711,'61115','S','Machesney Pk','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.354402,-89.040130,0,'2013-07-06 12:44:33',NULL,NULL),(67244,'79943','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761236,-106.481343,0,'2013-07-06 12:44:34',NULL,NULL),(64287,'76444','S','De Leon','D','Comanche','48093','Texas','TX','48','0000','254','Central',-6.0,'Y',32.106459,-98.537498,0,'2013-07-06 12:44:34',NULL,NULL),(35786,'39750','S','Cumberland','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.509640,-89.066880,0,'2013-07-06 12:44:32',NULL,NULL),(37094,'41339','S','Quicksand','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(2192,'00926','S','Paseo de la Fuente','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(5892,'05155','S','South Londonderry','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(25145,'28019','P','Caroleen','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.353630,-81.871480,0,'2013-07-06 12:44:31',NULL,NULL),(61125,'72153','S','Rushing','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.579400,-92.291580,0,'2013-07-06 12:44:33',NULL,NULL),(70179,'84329','S','Park Valley','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.827210,-113.269450,0,'2013-07-06 12:44:34',NULL,NULL),(76553,'95667','S','Cedar Ravine','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(75450,'94064','P','Redwood City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.462934,-122.255439,0,'2013-07-06 12:44:34',NULL,NULL),(65405,'77565','S','Clear Lk Shrs','A','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.540679,-95.030712,0,'2013-07-06 12:44:34',NULL,NULL),(1253,'00729','S','Urb Los Eucaliptos','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(13066,'13452','S','Johnsville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(57346,'66725','S','Neutral','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(22992,'24801','S','Capels','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(23924,'26230','S','Pickens','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.659025,-80.203847,0,'2013-07-06 12:44:31',NULL,NULL),(33033,'36736','S','Dixons Mills','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.054938,-87.730751,0,'2013-07-06 12:44:32',NULL,NULL),(7735,'07205','S','Industrial Hillside','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.693929,-74.228806,0,'2013-07-06 12:44:30',NULL,NULL),(4027,'02568','S','Tisbury','N','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.453520,-70.589400,0,'2013-07-06 12:44:30',NULL,NULL),(2982,'01060','S','North Hampton','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.330720,-72.675060,0,'2013-07-06 12:44:30',NULL,NULL),(12316,'12860','S','Pottersville','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.697539,-73.757282,0,'2013-07-06 12:44:30',NULL,NULL),(24559,'27298','S','Kimesville','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.896446,-79.506774,0,'2013-07-06 12:44:31',NULL,NULL),(75977,'95064','S','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.988279,-122.063261,0,'2013-07-06 12:44:34',NULL,NULL),(71387,'87006','S','Bosque','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.561472,-106.781071,0,'2013-07-06 12:44:34',NULL,NULL),(64105,'76179','S','Saginaw','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.906400,-97.433220,0,'2013-07-06 12:44:34',NULL,NULL),(68835,'82520','S','Ethete','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(67133,'79756','S','Thorntonville','A','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.581630,-102.896507,0,'2013-07-06 12:44:34',NULL,NULL),(42792,'48047','S','Chesterfield','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.674168,-82.780566,0,'2013-07-06 12:44:32',NULL,NULL),(19208,'19886','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.748270,-75.545647,0,'2013-07-06 12:44:31',NULL,NULL),(56494,'65336','S','Valley City','N','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.764378,-93.556549,0,'2013-07-06 12:44:33',NULL,NULL),(49188,'56441','S','Trommald','N','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.482415,-93.958313,0,'2013-07-06 12:44:33',NULL,NULL),(16987,'17728','S','Cogan Station','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(22178,'23471','P','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.893954,-76.147453,0,'2013-07-06 12:44:31',NULL,NULL),(35450,'39482','S','Melba','N','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.362960,-89.589180,0,'2013-07-06 12:44:32',NULL,NULL),(20406,'20903','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.012780,-76.981200,0,'2013-07-06 12:44:31',NULL,NULL),(70575,'85067','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.512131,-112.081821,0,'2013-07-06 12:44:34',NULL,NULL),(67386,'80123','S','Centennial','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(15817,'16930','S','Liberty','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.550000,-77.100000,0,'2013-07-06 12:44:31',NULL,NULL),(25675,'28512','S','Pine Knoll Shores','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(31522,'34476','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.085582,-82.193215,0,'2013-07-06 12:44:32',NULL,NULL),(22473,'24053','S','Ararat','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.590790,-80.526996,0,'2013-07-06 12:44:31',NULL,NULL),(50323,'57725','S','Farmingdale','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.974300,-102.959160,0,'2013-07-06 12:44:33',NULL,NULL),(58841,'69129','S','Chappell','D','Deuel','31049','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.092730,-102.470400,0,'2013-07-06 12:44:33',NULL,NULL),(5945,'05260','S','N Pownal','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.821495,-73.250086,0,'2013-07-06 12:44:30',NULL,NULL),(2080,'00921','S','Urb La Riviera','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(66161,'78516','S','Campo Alto','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.184742,-98.117053,0,'2013-07-06 12:44:34',NULL,NULL),(75526,'94163','U','Wells Fargo Bank','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.791422,-122.399414,0,'2013-07-06 12:44:34',NULL,NULL),(30797,'33606','S','Univ of Tampa','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.936563,-82.465286,0,'2013-07-06 12:44:32',NULL,NULL),(3559,'01945','S','Marblehead','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.497030,-70.866105,0,'2013-07-06 12:44:30',NULL,NULL),(4255,'02879','S','Matunuck','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(30561,'33412','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(13924,'14420','S','Brockport','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.214548,-77.929502,0,'2013-07-06 12:44:31',NULL,NULL),(29045,'32235','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.294054,-81.634778,0,'2013-07-06 12:44:32',NULL,NULL),(40527,'45830','S','Columbus Grv','A','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.872082,-84.028336,0,'2013-07-06 12:44:32',NULL,NULL),(13381,'13739','S','Kortright','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.364324,-74.803449,0,'2013-07-06 12:44:31',NULL,NULL),(44437,'49854','S','Manistique','D','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.009740,-86.278800,0,'2013-07-06 12:44:32',NULL,NULL),(10186,'10286','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705704,-74.007966,0,'2013-07-06 12:44:30',NULL,NULL),(59470,'70747','P','Innis','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.877689,-91.680562,0,'2013-07-06 12:44:33',NULL,NULL),(67734,'80551','U','Eastman Kodak Co','N','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.477500,-104.900833,0,'2013-07-06 12:44:34',NULL,NULL),(62176,'73753','S','Kremlin','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.529606,-97.835904,0,'2013-07-06 12:44:33',NULL,NULL),(61429,'72576','S','Moko','A','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367489,-91.825824,0,'2013-07-06 12:44:33',NULL,NULL),(11537,'12045','P','Coeymans','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.472313,-73.793901,0,'2013-07-06 12:44:30',NULL,NULL),(18138,'18830','S','Little Mdws','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.959552,-76.107242,0,'2013-07-06 12:44:31',NULL,NULL),(47939,'55115','S','Pine Springs','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(54408,'62828','S','Belle Prairie City','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.189495,-88.540853,0,'2013-07-06 12:44:33',NULL,NULL),(27393,'30085','P','Tucker','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.857014,-84.222994,0,'2013-07-06 12:44:31',NULL,NULL),(35563,'39567','S','Eastlawn','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(12328,'12865','S','Salem','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(41577,'47037','S','Osgood','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.126913,-85.293630,0,'2013-07-06 12:44:32',NULL,NULL),(61726,'73019','U','University of Ok','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.207241,-97.446305,0,'2013-07-06 12:44:33',NULL,NULL),(20390,'20894','U','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.002607,-77.093732,0,'2013-07-06 12:44:31',NULL,NULL),(17124,'17776','S','Carsontown','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.331890,-77.344196,0,'2013-07-06 12:44:31',NULL,NULL),(41119,'46582','S','Warsaw','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.237728,-85.854267,0,'2013-07-06 12:44:32',NULL,NULL),(41836,'47346','S','Graceland Heights','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.927181,-85.153805,0,'2013-07-06 12:44:32',NULL,NULL),(43409,'48456','S','Minden City','D','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.666281,-82.738842,0,'2013-07-06 12:44:32',NULL,NULL),(43808,'49067','S','Marcellus','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.015960,-85.835576,0,'2013-07-06 12:44:32',NULL,NULL),(44278,'49712','S','Boyne City','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.221294,-85.026342,0,'2013-07-06 12:44:32',NULL,NULL),(59711,'71105','S','Youree','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.454589,-93.712715,0,'2013-07-06 12:44:33',NULL,NULL),(72991,'90057','S','Flint','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.060269,-118.276734,0,'2013-07-06 12:44:34',NULL,NULL),(3914,'02458','S','Riverside','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.352515,-71.190702,0,'2013-07-06 12:44:30',NULL,NULL),(14903,'15521','S','Alum Bank','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.194420,-78.630714,0,'2013-07-06 12:44:31',NULL,NULL),(72139,'88312','S','Alto','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.394388,-105.666923,0,'2013-07-06 12:44:34',NULL,NULL),(64986,'77274','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.687989,-95.516437,0,'2013-07-06 12:44:34',NULL,NULL),(5787,'05056','S','Plymouth','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.512000,-72.720000,0,'2013-07-06 12:44:30',NULL,NULL),(16509,'17265','S','Upperstrasbrg','A','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.052056,-77.753164,0,'2013-07-06 12:44:31',NULL,NULL),(15346,'16235','S','Lucinda','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.310870,-79.384903,0,'2013-07-06 12:44:31',NULL,NULL),(33671,'37729','S','La Follette','A','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.426894,-83.993190,0,'2013-07-06 12:44:32',NULL,NULL),(14955,'15617','P','Arona','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.270674,-79.657323,0,'2013-07-06 12:44:31',NULL,NULL),(8264,'08008','S','Ship Bottom Boro','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(21405,'22520','S','Montross','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.148213,-76.728369,0,'2013-07-06 12:44:31',NULL,NULL),(24978,'27851','S','Lunana','N','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.634649,-78.012797,0,'2013-07-06 12:44:31',NULL,NULL),(49430,'56633','S','Pike Bay','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(53001,'61451','S','Elmore','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.944652,-89.961612,0,'2013-07-06 12:44:33',NULL,NULL),(57980,'67840','P','Englewood','D','Clark','20025','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.038590,-99.982070,0,'2013-07-06 12:44:33',NULL,NULL),(31174,'33919','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.561274,-81.905205,0,'2013-07-06 12:44:32',NULL,NULL),(28615,'31708','P','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.593388,-84.141048,0,'2013-07-06 12:44:32',NULL,NULL),(21888,'23177','S','Walkerton','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.764484,-77.011691,0,'2013-07-06 12:44:31',NULL,NULL),(52248,'60517','S','Downers Grove','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.754240,-88.061040,0,'2013-07-06 12:44:33',NULL,NULL),(24981,'27853','S','Margaretsville','N','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.525209,-77.292806,0,'2013-07-06 12:44:31',NULL,NULL),(8612,'08243','S','Sea Isle City','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.152160,-74.693700,0,'2013-07-06 12:44:30',NULL,NULL),(74990,'93448','P','Pismo Beach','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.155278,-120.671389,0,'2013-07-06 12:44:34',NULL,NULL),(56967,'66117','P','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.116401,-94.624298,0,'2013-07-06 12:44:33',NULL,NULL),(15494,'16501','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.123266,-80.084213,0,'2013-07-06 12:44:31',NULL,NULL),(38457,'43611','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.706803,-83.489427,0,'2013-07-06 12:44:32',NULL,NULL),(9452,'10006','S','Trinity','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(20507,'21076','S','Harmans','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.164940,-76.715640,0,'2013-07-06 12:44:31',NULL,NULL),(28276,'31085','S','Shady Dale','D','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.398491,-83.659553,0,'2013-07-06 12:44:31',NULL,NULL),(53960,'62427','S','Flat Rock','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.900944,-87.672357,0,'2013-07-06 12:44:33',NULL,NULL),(61111,'72143','S','Searcy','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.252280,-91.849260,0,'2013-07-06 12:44:33',NULL,NULL),(63597,'75789','S','Walnut Grove','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(66160,'78516','S','Alamo','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.184742,-98.117053,0,'2013-07-06 12:44:34',NULL,NULL),(67374,'80120','S','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.600857,-105.006450,0,'2013-07-06 12:44:34',NULL,NULL),(72634,'89421','P','Cordero','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.990819,-117.712764,0,'2013-07-06 12:44:34',NULL,NULL),(77452,'96811','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.326884,-157.828158,0,'2013-07-06 12:44:34',NULL,NULL),(55004,'63131','S','Des Peres','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(33847,'37950','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.944694,-84.022662,0,'2013-07-06 12:44:32',NULL,NULL),(14336,'15005','S','Baden','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.643059,-80.201665,0,'2013-07-06 12:44:31',NULL,NULL),(29211,'32413','S','Panama City Beach','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(37744,'42320','S','Horton','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(51933,'60122','U','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.036725,-88.288337,0,'2013-07-06 12:44:33',NULL,NULL),(35550,'39564','S','Gulf Park Estates','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(42046,'47446','S','Bryantsville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(2677,'00966','S','Villas De Tintillos','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(74967,'93433','S','Grover Beach','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.123216,-120.617031,0,'2013-07-06 12:44:34',NULL,NULL),(61686,'72943','S','Magazine','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.169105,-93.784677,0,'2013-07-06 12:44:33',NULL,NULL),(6685,'06041','U','Manchester','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.774955,-72.521556,0,'2013-07-06 12:44:30',NULL,NULL),(16917,'17602','S','Willow View Heights','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(36089,'40218','S','Watterson Pk','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192865,-85.653204,0,'2013-07-06 12:44:32',NULL,NULL),(1866,'00791','S','Urb Arboleda','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(33072,'36769','S','Pine Hill','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.949033,-87.557784,0,'2013-07-06 12:44:32',NULL,NULL),(7340,'06716','S','Wolcott','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.591802,-72.972656,0,'2013-07-06 12:44:30',NULL,NULL),(19651,'20289','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.883057,-77.018850,0,'2013-07-06 12:44:31',NULL,NULL),(41486,'46939','S','Kewanna','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.990318,-86.398743,0,'2013-07-06 12:44:32',NULL,NULL),(43471,'48557','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.987118,-83.679301,0,'2013-07-06 12:44:32',NULL,NULL),(47623,'54906','U','Oshkosh','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.018997,-88.553426,0,'2013-07-06 12:44:33',NULL,NULL),(66156,'78505','P','Bonner','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.200156,-98.232966,0,'2013-07-06 12:44:34',NULL,NULL),(70866,'85603','S','Copper Queen','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(56079,'64759','S','Lamar','D','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.493876,-94.271176,0,'2013-07-06 12:44:33',NULL,NULL),(27330,'30033','S','Vista Grove','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.817078,-84.281903,0,'2013-07-06 12:44:31',NULL,NULL),(7046,'06278','S','Warrenville','A','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.896620,-72.141240,0,'2013-07-06 12:44:30',NULL,NULL),(47382,'54631','S','Bell Center','N','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.291823,-90.867048,0,'2013-07-06 12:44:32',NULL,NULL),(67076,'79601','S','Potosi','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.479020,-99.700020,0,'2013-07-06 12:44:34',NULL,NULL),(5497,'04757','S','Chapman','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.654140,-68.184981,0,'2013-07-06 12:44:30',NULL,NULL),(16161,'17062','S','Seven Stars','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(15545,'16619','P','Blandburg','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.690699,-78.441786,0,'2013-07-06 12:44:31',NULL,NULL),(8423,'08075','S','Riverside','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(2230,'00926','S','Urb El Senorial','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(50979,'58639','S','Hettinger','D','Adams','38001','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.035840,-102.570120,0,'2013-07-06 12:44:33',NULL,NULL),(56415,'65254','S','Glasgow','D','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.228178,-92.839068,0,'2013-07-06 12:44:33',NULL,NULL),(62700,'74737','P','Golden','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.035793,-94.893397,0,'2013-07-06 12:44:33',NULL,NULL),(66787,'79046','S','Higgins','D','Lipscomb','48295','Texas','TX','48','0000','806','Central',-6.0,'Y',36.120498,-100.024049,0,'2013-07-06 12:44:34',NULL,NULL),(67976,'80915','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.856009,-104.716668,0,'2013-07-06 12:44:34',NULL,NULL),(74999,'93452','S','San Simeon','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.549785,-120.950261,0,'2013-07-06 12:44:34',NULL,NULL),(5219,'04460','S','Soldiertown Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.617950,-68.497973,0,'2013-07-06 12:44:30',NULL,NULL),(78334,'98002','S','Auburn','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.302461,-122.186065,0,'2013-07-06 12:44:34',NULL,NULL),(22275,'23704','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.830829,-76.312922,0,'2013-07-06 12:44:31',NULL,NULL),(28694,'31811','S','Hamilton','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.726249,-84.994153,0,'2013-07-06 12:44:32',NULL,NULL),(20071,'20680','S','Ridge','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.119822,-76.371486,0,'2013-07-06 12:44:31',NULL,NULL),(64844,'77043','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.804733,-95.560006,0,'2013-07-06 12:44:34',NULL,NULL),(12960,'13362','P','Knoxboro','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.984335,-75.519009,0,'2013-07-06 12:44:30',NULL,NULL),(34591,'38744','S','Hampton','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.035500,-91.016167,0,'2013-07-06 12:44:32',NULL,NULL),(18328,'19026','S','Oakview','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.955020,-75.327420,0,'2013-07-06 12:44:31',NULL,NULL),(30747,'33549','S','Lutz','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.123545,-82.449632,0,'2013-07-06 12:44:32',NULL,NULL),(20114,'20714','S','N Beach','N','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.711654,-76.537211,0,'2013-07-06 12:44:31',NULL,NULL),(27999,'30602','U','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.903503,-83.318464,0,'2013-07-06 12:44:31',NULL,NULL),(55000,'63130','S','University City','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.664368,-90.323797,0,'2013-07-06 12:44:33',NULL,NULL),(55267,'63461','S','Woodland','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.797789,-91.526300,0,'2013-07-06 12:44:33',NULL,NULL),(16934,'17622','U','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.023731,-76.331711,0,'2013-07-06 12:44:31',NULL,NULL),(62193,'73771','S','Wakita','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.883918,-97.926796,0,'2013-07-06 12:44:33',NULL,NULL),(31484,'34432','S','Dunnellon','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.057502,-82.386536,0,'2013-07-06 12:44:32',NULL,NULL),(47844,'55074','S','Franconia','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.387412,-92.746332,0,'2013-07-06 12:44:33',NULL,NULL),(43543,'48686','U','Dow Corning Corporation','N','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.601347,-84.206759,0,'2013-07-06 12:44:32',NULL,NULL),(69684,'84026','S','Bottle Hollow','N','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.294221,-109.839602,0,'2013-07-06 12:44:34',NULL,NULL),(14625,'15231','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.502772,-80.189169,0,'2013-07-06 12:44:31',NULL,NULL),(38257,'43291','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.976602,-82.856827,0,'2013-07-06 12:44:32',NULL,NULL),(36862,'41085','P','Silver Grove','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.032105,-84.387375,0,'2013-07-06 12:44:32',NULL,NULL),(9519,'10017','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(65991,'78338','P','Armstrong','D','Kenedy','48261','Texas','TX','48','0000','361','Central',-6.0,'Y',26.826414,-97.750931,0,'2013-07-06 12:44:34',NULL,NULL),(40117,'45324','S','Beavercreek','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.807279,-84.019499,0,'2013-07-06 12:44:32',NULL,NULL),(40105,'45315','S','Clayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.852017,-84.332780,0,'2013-07-06 12:44:32',NULL,NULL),(40053,'45264','U','First National Bank','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.104370,-84.537870,0,'2013-07-06 12:44:32',NULL,NULL),(13582,'13845','P','Tioga','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.057895,-76.350624,0,'2013-07-06 12:44:31',NULL,NULL),(11106,'11701','S','Amityville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.686293,-73.412179,0,'2013-07-06 12:44:30',NULL,NULL),(30939,'33715','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.687120,-82.712580,0,'2013-07-06 12:44:32',NULL,NULL),(8534,'08110','S','Delair','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.954445,-75.074257,0,'2013-07-06 12:44:30',NULL,NULL),(41732,'47250','S','Jefferson Proving Ground','N','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.755353,-85.397514,0,'2013-07-06 12:44:32',NULL,NULL),(44068,'49444','S','Muskegon Heights','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168440,-86.184540,0,'2013-07-06 12:44:32',NULL,NULL),(45579,'51535','S','Griswold','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.236282,-95.139293,0,'2013-07-06 12:44:32',NULL,NULL),(46826,'54011','S','Trimbelle','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.735213,-92.480939,0,'2013-07-06 12:44:32',NULL,NULL),(55339,'63556','S','Boynton','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(64975,'77262','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.723146,-95.278930,0,'2013-07-06 12:44:34',NULL,NULL),(66258,'78574','S','Mission','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.219063,-98.325099,0,'2013-07-06 12:44:34',NULL,NULL),(70965,'85652','P','Cortaro','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.384868,-111.114433,0,'2013-07-06 12:44:34',NULL,NULL),(71552,'87192','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.102775,-106.512743,0,'2013-07-06 12:44:34',NULL,NULL),(72468,'89124','S','Callville Bay','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(5431,'04677','S','Sorrento','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.490431,-68.178524,0,'2013-07-06 12:44:30',NULL,NULL),(64257,'76377','S','Petrolia','D','Clay','48077','Texas','TX','48','0000','940','Central',-6.0,'Y',34.018615,-98.234478,0,'2013-07-06 12:44:34',NULL,NULL),(44657,'50106','S','Gilman','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.900273,-92.824750,0,'2013-07-06 12:44:32',NULL,NULL),(44927,'50339','U','Equitable Life Assurance','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.597161,-93.746439,0,'2013-07-06 12:44:32',NULL,NULL),(54838,'63036','S','French Village','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.764518,-90.427334,0,'2013-07-06 12:44:33',NULL,NULL),(22085,'23398','P','Jamesville','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.510425,-75.870874,0,'2013-07-06 12:44:31',NULL,NULL),(13943,'14443','P','East Bloomfield','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.890395,-77.446504,0,'2013-07-06 12:44:31',NULL,NULL),(13016,'13421','S','Oneida','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.064220,-75.648180,0,'2013-07-06 12:44:30',NULL,NULL),(79378,'98670','S','Klickitat','A','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.827577,-121.274857,0,'2013-07-06 12:44:34',NULL,NULL),(58191,'68313','S','Beaver Xing','A','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.780014,-97.268905,0,'2013-07-06 12:44:33',NULL,NULL),(79002,'98384','P','South Colby','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.519470,-122.538947,0,'2013-07-06 12:44:34',NULL,NULL),(77462,'96815','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.278625,-157.820909,0,'2013-07-06 12:44:34',NULL,NULL),(73775,'91740','S','Glendora','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.115217,-117.859340,0,'2013-07-06 12:44:34',NULL,NULL),(69483,'83672','S','Weiser','D','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.279700,-116.985420,0,'2013-07-06 12:44:34',NULL,NULL),(67679,'80504','S','Longmont','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.160065,-104.966226,0,'2013-07-06 12:44:34',NULL,NULL),(26163,'28743','S','Paint Rock','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(8215,'07950','S','Greystone Pk','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.844846,-74.476815,0,'2013-07-06 12:44:30',NULL,NULL),(9815,'10112','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(25435,'28308','S','Fayetteville','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.052500,-78.878611,0,'2013-07-06 12:44:31',NULL,NULL),(25205,'28079','S','Hemby','N','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.098742,-80.631203,0,'2013-07-06 12:44:31',NULL,NULL),(5498,'04757','S','Mapleton','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.654140,-68.184981,0,'2013-07-06 12:44:30',NULL,NULL),(58181,'68309','S','Barneston','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.049316,-96.575317,0,'2013-07-06 12:44:33',NULL,NULL),(57001,'66204','S','Prairie Vlg','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(52319,'60556','S','McGirr','N','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.749083,-88.773261,0,'2013-07-06 12:44:33',NULL,NULL),(28065,'30703','P','Calhoun','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.501348,-84.953816,0,'2013-07-06 12:44:31',NULL,NULL),(21249,'22246','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.857622,-77.053083,0,'2013-07-06 12:44:31',NULL,NULL),(59398,'70631','S','Johnson Bayou','N','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.826351,-93.397555,0,'2013-07-06 12:44:33',NULL,NULL),(54457,'62852','P','Keensburg','D','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.350337,-87.864112,0,'2013-07-06 12:44:33',NULL,NULL),(75744,'94608','S','Emeryville','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.834440,-122.289060,0,'2013-07-06 12:44:34',NULL,NULL),(194,'00623','S','Urb Elizabeth','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(77999,'97407','P','Allegany','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.425190,-124.033608,0,'2013-07-06 12:44:34',NULL,NULL),(72405,'89045','S','Carvers','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.808300,-117.156300,0,'2013-07-06 12:44:34',NULL,NULL),(9181,'09368','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28413,'31323','S','Jones','N','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.726286,-81.469983,0,'2013-07-06 12:44:32',NULL,NULL),(3043,'01104','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.128134,-72.571488,0,'2013-07-06 12:44:30',NULL,NULL),(11321,'11784','S','Old Westfield','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.871531,-73.043571,0,'2013-07-06 12:44:30',NULL,NULL),(19002,'19526','S','Edenburg','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(22545,'24129','P','New River','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.152671,-80.619218,0,'2013-07-06 12:44:31',NULL,NULL),(24508,'27281','S','Foxfire','N','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(49750,'57061','P','Sinai','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.243038,-97.067738,0,'2013-07-06 12:44:33',NULL,NULL),(58124,'68132','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.267177,-96.001881,0,'2013-07-06 12:44:33',NULL,NULL),(62158,'73730','S','Covington','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.298352,-97.541055,0,'2013-07-06 12:44:33',NULL,NULL),(77107,'96143','P','Brockway','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.258133,-120.036587,0,'2013-07-06 12:44:34',NULL,NULL),(35539,'39562','S','Moss Point','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.425733,-88.529215,0,'2013-07-06 12:44:32',NULL,NULL),(31631,'34711','S','Clermont','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.535867,-81.763831,0,'2013-07-06 12:44:32',NULL,NULL),(76712,'95841','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.661566,-121.343467,0,'2013-07-06 12:44:34',NULL,NULL),(60350,'71469','S','Allen','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(73585,'91384','S','Castaic','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.464820,-118.640594,0,'2013-07-06 12:44:34',NULL,NULL),(80032,'99691','P','Nikolai','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.998454,-154.389565,0,'2013-07-06 12:44:34',NULL,NULL),(61008,'72114','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(2870,'00985','S','Villa Cooperativa','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(40334,'45504','S','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.940286,-83.843773,0,'2013-07-06 12:44:32',NULL,NULL),(11320,'11783','S','Seaford','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.679021,-73.487144,0,'2013-07-06 12:44:30',NULL,NULL),(36705,'41017','S','S Ft Mitchell','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(5855,'05143','S','Andover','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(34375,'38614','S','Mattson','A','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(26198,'28772','S','Rosman','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.142895,-82.836230,0,'2013-07-06 12:44:31',NULL,NULL),(20226,'20774','S','Largo','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(2342,'00936','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(41955,'47403','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.113644,-86.586952,0,'2013-07-06 12:44:32',NULL,NULL),(60631,'71901','S','Lakeside','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(69048,'83227','S','Torrey','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.298351,-114.409180,0,'2013-07-06 12:44:34',NULL,NULL),(15905,'17013','S','Carlisle Barracks','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.203056,-77.313611,0,'2013-07-06 12:44:31',NULL,NULL),(6750,'06085','S','Lake Garda','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.752359,-72.892851,0,'2013-07-06 12:44:30',NULL,NULL),(70014,'84127','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700486,-111.945715,0,'2013-07-06 12:44:34',NULL,NULL),(78832,'98335','S','Raft Is','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(46286,'53044','S','Kohler','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.740624,-87.785575,0,'2013-07-06 12:44:32',NULL,NULL),(42217,'47558','S','Corning','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.623171,-87.044863,0,'2013-07-06 12:44:32',NULL,NULL),(40273,'45434','S','Beaver Creek','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.712421,-84.041488,0,'2013-07-06 12:44:32',NULL,NULL),(19439,'20109','S','Sudley Spgs','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.799297,-77.546852,0,'2013-07-06 12:44:31',NULL,NULL),(65392,'77554','S','Jamaica Beach','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.207422,-94.965163,0,'2013-07-06 12:44:34',NULL,NULL),(39791,'45133','S','Fairfax','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(39240,'44428','S','Vernon','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.437474,-80.580228,0,'2013-07-06 12:44:32',NULL,NULL),(18473,'19086','S','Nether Providence','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889823,-75.370994,0,'2013-07-06 12:44:31',NULL,NULL),(33645,'37699','U','Piney Flats','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.418354,-82.303895,0,'2013-07-06 12:44:32',NULL,NULL),(12069,'12544','P','Mellenville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.250628,-73.666472,0,'2013-07-06 12:44:30',NULL,NULL),(31686,'34785','S','Wildwood','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.860356,-82.040896,0,'2013-07-06 12:44:32',NULL,NULL),(28069,'30710','S','Cohutta','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.942281,-84.939608,0,'2013-07-06 12:44:31',NULL,NULL),(23539,'25607','S','Robinette','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.786800,-81.789540,0,'2013-07-06 12:44:31',NULL,NULL),(45596,'51553','S','Minden','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.467372,-95.544170,0,'2013-07-06 12:44:32',NULL,NULL),(51244,'59072','S','Roundup','D','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.410128,-108.546630,0,'2013-07-06 12:44:33',NULL,NULL),(66510,'78704','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.244144,-97.762860,0,'2013-07-06 12:44:34',NULL,NULL),(33235,'37070','P','Goodlettsville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.323710,-86.715822,0,'2013-07-06 12:44:32',NULL,NULL),(27566,'30265','S','Shenandoah','N','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.405124,-84.710418,0,'2013-07-06 12:44:31',NULL,NULL),(24058,'26426','S','Wolf Summit','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281554,-80.559325,0,'2013-07-06 12:44:31',NULL,NULL),(22179,'23471','P','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.893954,-76.147453,0,'2013-07-06 12:44:31',NULL,NULL),(4547,'03448','S','Gilsum','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.041392,-72.265499,0,'2013-07-06 12:44:30',NULL,NULL),(2631,'00962','S','VISTA del Morro','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(39125,'44265','P','Randolph','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.019515,-81.302392,0,'2013-07-06 12:44:32',NULL,NULL),(23876,'26160','S','Sanoma','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(27682,'30334','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.727528,-84.412803,0,'2013-07-06 12:44:31',NULL,NULL),(43094,'48212','S','Hamtramck','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.408353,-83.058329,0,'2013-07-06 12:44:32',NULL,NULL),(49744,'57057','S','Rutland','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.075835,-96.954530,0,'2013-07-06 12:44:33',NULL,NULL),(51126,'58793','S','Westhope','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.895227,-101.090296,0,'2013-07-06 12:44:33',NULL,NULL),(71168,'86039','P','Oraibi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(78412,'98041','P','Bothell','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.754018,-122.216128,0,'2013-07-06 12:44:34',NULL,NULL),(62784,'74878','S','Tribbey','A','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.990948,-97.035680,0,'2013-07-06 12:44:33',NULL,NULL),(50894,'58540','S','Emmet','A','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.653205,-101.416654,0,'2013-07-06 12:44:33',NULL,NULL),(33818,'37921','S','Lonsdale','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.972950,-83.986531,0,'2013-07-06 12:44:32',NULL,NULL),(69852,'84087','S','Woods Cross','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.888560,-111.912240,0,'2013-07-06 12:44:34',NULL,NULL),(39136,'44273','S','Guilford','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027572,-81.883128,0,'2013-07-06 12:44:32',NULL,NULL),(17440,'17934','S','Maizeville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.800835,-76.217462,0,'2013-07-06 12:44:31',NULL,NULL),(34431,'38644','P','Lula','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.455872,-90.475665,0,'2013-07-06 12:44:32',NULL,NULL),(33474,'37335','S','Flintville','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.018124,-86.440120,0,'2013-07-06 12:44:32',NULL,NULL),(15632,'16724','P','Crosby','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.698976,-78.371156,0,'2013-07-06 12:44:31',NULL,NULL),(11348,'11796','S','W Sayville','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732739,-73.100528,0,'2013-07-06 12:44:30',NULL,NULL),(15033,'15691','P','Wendel','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.292363,-79.687605,0,'2013-07-06 12:44:31',NULL,NULL),(63371,'75643','S','Gary City','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.031808,-94.395253,0,'2013-07-06 12:44:33',NULL,NULL),(62150,'73722','S','Byron','A','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.909720,-98.435520,0,'2013-07-06 12:44:33',NULL,NULL),(56533,'65438','S','Teresita','A','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.912332,-91.493803,0,'2013-07-06 12:44:33',NULL,NULL),(43958,'49309','S','Woodland Park','N','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.740936,-85.870792,0,'2013-07-06 12:44:32',NULL,NULL),(5737,'05034','S','W Bridgewater','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.572856,-72.617134,0,'2013-07-06 12:44:30',NULL,NULL),(16164,'17063','S','Naginey','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.716078,-77.590384,0,'2013-07-06 12:44:31',NULL,NULL),(62086,'73564','S','Roosevelt','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.850654,-99.024694,0,'2013-07-06 12:44:33',NULL,NULL),(71302,'86503','S','Chinle','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(72383,'89037','S','Moapa','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.370267,-114.883611,0,'2013-07-06 12:44:34',NULL,NULL),(15314,'16156','S','Volant','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.087993,-80.223055,0,'2013-07-06 12:44:31',NULL,NULL),(45771,'52155','S','Bonair','N','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.453080,-92.282246,0,'2013-07-06 12:44:32',NULL,NULL),(26510,'29175','S','De Kalb','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.447043,-80.601334,0,'2013-07-06 12:44:31',NULL,NULL),(66265,'78577','S','Pharr','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.187450,-98.183954,0,'2013-07-06 12:44:34',NULL,NULL),(76460,'95615','S','Courtland','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.316277,-121.553829,0,'2013-07-06 12:44:34',NULL,NULL),(39182,'44316','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.079334,-81.472767,0,'2013-07-06 12:44:32',NULL,NULL),(48624,'55801','P','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.099061,-91.852643,0,'2013-07-06 12:44:33',NULL,NULL),(74099,'92203','S','Bermuda Dunes','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.755580,-116.226718,0,'2013-07-06 12:44:34',NULL,NULL),(74587,'92694','S','Rancho Mission Viejo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.555120,-117.666532,0,'2013-07-06 12:44:34',NULL,NULL),(6056,'05443','S','Downingville','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(16829,'17552','S','Milton Grove','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(26740,'29420','S','N Charleston','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.923689,-80.099458,0,'2013-07-06 12:44:31',NULL,NULL),(22491,'24067','S','Callaway','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.040050,-80.065629,0,'2013-07-06 12:44:31',NULL,NULL),(47839,'55072','S','Sandstone','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.126511,-92.866999,0,'2013-07-06 12:44:33',NULL,NULL),(51987,'60156','S','Algonquin','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.180245,-88.331470,0,'2013-07-06 12:44:33',NULL,NULL),(58362,'68520','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.796037,-96.584520,0,'2013-07-06 12:44:33',NULL,NULL),(62077,'73557','P','Medicine Park','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.727409,-98.462061,0,'2013-07-06 12:44:33',NULL,NULL),(71601,'87322','P','Rehoboth','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.431749,-108.723591,0,'2013-07-06 12:44:34',NULL,NULL),(80131,'99773','P','Shungnak','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.715224,-156.995761,0,'2013-07-06 12:44:34',NULL,NULL),(2181,'00926','S','Jard Botanico Sur','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(38302,'43348','S','Russells Pt','A','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.468795,-83.879904,0,'2013-07-06 12:44:32',NULL,NULL),(65413,'77571','S','Shoreacres','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.658283,-95.049187,0,'2013-07-06 12:44:34',NULL,NULL),(9874,'10122','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750153,-73.997056,0,'2013-07-06 12:44:30',NULL,NULL),(42075,'47454','S','Braxton','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(50842,'58481','S','Urbana','N','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.935970,-98.333360,0,'2013-07-06 12:44:33',NULL,NULL),(54410,'62829','P','Dale','D','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.995516,-88.532996,0,'2013-07-06 12:44:33',NULL,NULL),(67770,'80642','S','Hudson','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.077349,-104.641907,0,'2013-07-06 12:44:34',NULL,NULL),(74579,'92692','S','Mission Viejo','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.614433,-117.643273,0,'2013-07-06 12:44:34',NULL,NULL),(74701,'93004','S','Saticoy','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.280121,-119.168207,0,'2013-07-06 12:44:34',NULL,NULL),(76996,'96076','S','Platina','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.370400,-122.952720,0,'2013-07-06 12:44:34',NULL,NULL),(7060,'06331','S','Canterbury','D','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.693971,-72.004297,0,'2013-07-06 12:44:30',NULL,NULL),(62708,'74747','P','Kemp','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.769653,-96.355469,0,'2013-07-06 12:44:33',NULL,NULL),(12002,'12491','S','W Hurley','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.006495,-74.105729,0,'2013-07-06 12:44:30',NULL,NULL),(36700,'41017','S','Erlanger','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(8457,'08087','S','Parkertown','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(13477,'13790','S','Johnson City','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.120267,-75.972895,0,'2013-07-06 12:44:31',NULL,NULL),(25655,'28478','S','Watha','A','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.665443,-78.066376,0,'2013-07-06 12:44:31',NULL,NULL),(24539,'27292','S','Enterprise','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(68858,'82630','S','Casper','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.121700,-107.371907,0,'2013-07-06 12:44:34',NULL,NULL),(75935,'95024','P','Hollister','D','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.842897,-121.393538,0,'2013-07-06 12:44:34',NULL,NULL),(3159,'01264','P','Lee','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.243506,-73.205466,0,'2013-07-06 12:44:30',NULL,NULL),(17020,'17744','S','Linden','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.271905,-77.162229,0,'2013-07-06 12:44:31',NULL,NULL),(1686,'00777','S','Juncos','D','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(8965,'08812','S','Dunellen','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.601341,-74.478647,0,'2013-07-06 12:44:30',NULL,NULL),(33221,'37059','S','Dowelltown','D','DeKalb','47041','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.013610,-85.946404,0,'2013-07-06 12:44:32',NULL,NULL),(12873,'13325','S','Constableville','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.577189,-75.564678,0,'2013-07-06 12:44:30',NULL,NULL),(19090,'19602','S','Reading Station','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.329373,-75.921719,0,'2013-07-06 12:44:31',NULL,NULL),(25567,'28425','S','Burgaw','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.550127,-77.935342,0,'2013-07-06 12:44:31',NULL,NULL),(48250,'55424','S','St Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.902538,-93.339411,0,'2013-07-06 12:44:33',NULL,NULL),(72890,'90016','S','West Adams','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.027729,-118.351874,0,'2013-07-06 12:44:34',NULL,NULL),(75703,'94569','P','Port Costa','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',38.044526,-122.187291,0,'2013-07-06 12:44:34',NULL,NULL),(76319,'95456','S','Little River','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.266551,-123.763145,0,'2013-07-06 12:44:34',NULL,NULL),(76953,'96037','P','Greenview','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.549707,-122.910580,0,'2013-07-06 12:44:34',NULL,NULL),(79181,'98522','P','Adna','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.574140,-123.296827,0,'2013-07-06 12:44:34',NULL,NULL),(38367,'43462','S','Rudolph','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.284376,-83.698854,0,'2013-07-06 12:44:32',NULL,NULL),(49817,'57213','S','Astoria','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.557233,-96.546861,0,'2013-07-06 12:44:33',NULL,NULL),(20374,'20880','P','Washingtn Grv','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.140721,-77.176247,0,'2013-07-06 12:44:31',NULL,NULL),(26417,'29118','S','Orangeburg','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.532316,-80.873936,0,'2013-07-06 12:44:31',NULL,NULL),(28791,'32052','S','Jasper','D','Hamilton','12047','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.517247,-82.950317,0,'2013-07-06 12:44:32',NULL,NULL),(72221,'88431','S','Bell Ranch','A','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.120222,-104.233344,0,'2013-07-06 12:44:34',NULL,NULL),(1675,'00777','S','Bda Flores','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(12322,'12864','P','Indian Lake','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.728403,-74.305522,0,'2013-07-06 12:44:30',NULL,NULL),(27580,'30274','S','Riverdale','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.554773,-84.399793,0,'2013-07-06 12:44:31',NULL,NULL),(19537,'20191','S','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.941053,-77.346029,0,'2013-07-06 12:44:31',NULL,NULL),(42328,'47630','S','Paradise','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.964340,-87.354120,0,'2013-07-06 12:44:32',NULL,NULL),(46258,'53014','S','Chilton','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.030916,-88.193260,0,'2013-07-06 12:44:32',NULL,NULL),(49702,'57031','S','Gayville','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.889770,-97.174801,0,'2013-07-06 12:44:33',NULL,NULL),(60311,'71454','S','Wheeling','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(60655,'71913','S','Hot Springs National Park','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.424690,-93.096290,0,'2013-07-06 12:44:33',NULL,NULL),(67845,'80817','S','Fountain','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.698619,-104.696917,0,'2013-07-06 12:44:34',NULL,NULL),(47507,'54767','S','Martell','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.846147,-92.241815,0,'2013-07-06 12:44:32',NULL,NULL),(17951,'18512','S','Throop','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.420505,-75.625001,0,'2013-07-06 12:44:31',NULL,NULL),(65122,'77379','S','Klein','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.027227,-95.529294,0,'2013-07-06 12:44:34',NULL,NULL),(2944,'01030','S','Feeding Hills','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.072375,-72.675163,0,'2013-07-06 12:44:30',NULL,NULL),(12764,'13209','S','Geddes','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.085400,-76.251720,0,'2013-07-06 12:44:30',NULL,NULL),(68775,'82324','P','Elk Mountain','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.690182,-106.414493,0,'2013-07-06 12:44:34',NULL,NULL),(18538,'19111','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057937,-75.081966,0,'2013-07-06 12:44:31',NULL,NULL),(40170,'45368','S','So Charleston','N','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.847694,-83.658868,0,'2013-07-06 12:44:32',NULL,NULL),(39102,'44236','S','Hudson','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.246532,-81.439256,0,'2013-07-06 12:44:32',NULL,NULL),(26393,'29104','S','Scottsville','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.983524,-80.208008,0,'2013-07-06 12:44:31',NULL,NULL),(22683,'24314','S','Hicksville','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.161780,-81.198480,0,'2013-07-06 12:44:31',NULL,NULL),(54546,'62886','S','Sims','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.411879,-88.528805,0,'2013-07-06 12:44:33',NULL,NULL),(2205,'00926','S','Repto Veterano','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(60161,'71404','S','New Verda Community','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.832832,-92.788989,0,'2013-07-06 12:44:33',NULL,NULL),(50231,'57620','S','Bixby','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(66844,'79118','S','Palisades','A','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.065430,-101.852052,0,'2013-07-06 12:44:34',NULL,NULL),(76489,'95631','S','Michigan Bluff','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.009228,-120.852443,0,'2013-07-06 12:44:34',NULL,NULL),(38518,'43725','S','Cambridge','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.027358,-81.593383,0,'2013-07-06 12:44:32',NULL,NULL),(68068,'80935','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.833696,-104.818441,0,'2013-07-06 12:44:34',NULL,NULL),(70168,'84321','S','River Heights','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.736480,-111.673800,0,'2013-07-06 12:44:34',NULL,NULL),(71390,'87007','P','Casa Blanca','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.000475,-107.413240,0,'2013-07-06 12:44:34',NULL,NULL),(381,'00660','S','Urb Paseo La Ceiba','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(17083,'17764','S','Drury Run','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(988,'00717','S','Bda Belgica','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(17037,'17747','S','Rosecrans','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(30522,'33406','S','Glen Ridge','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(12683,'13131','S','Parish','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.423380,-76.078500,0,'2013-07-06 12:44:30',NULL,NULL),(13042,'13439','S','Richfield Springs','D','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(15223,'16023','S','Cabot','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.778889,-79.773333,0,'2013-07-06 12:44:31',NULL,NULL),(46360,'53108','S','Caledonia','D','Racine','55101','Wisconsin','WI','55','6600','414','Central',-6.0,'Y',42.827165,-87.936080,0,'2013-07-06 12:44:32',NULL,NULL),(48721,'55953','S','Nevada','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.504882,-92.941860,0,'2013-07-06 12:44:33',NULL,NULL),(48969,'56209','S','Atwater','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.129185,-94.804925,0,'2013-07-06 12:44:33',NULL,NULL),(54845,'63039','S','Gray Summit','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.496101,-90.838410,0,'2013-07-06 12:44:33',NULL,NULL),(16063,'17048','S','Erdman','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.595220,-76.713900,0,'2013-07-06 12:44:31',NULL,NULL),(78666,'98233','S','Upper Skagit Indian Reservat','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.503280,-122.360460,0,'2013-07-06 12:44:34',NULL,NULL),(17476,'17951','P','Mar Lin','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.677881,-76.239672,0,'2013-07-06 12:44:31',NULL,NULL),(9616,'10033','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(29918,'33060','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.227867,-80.120189,0,'2013-07-06 12:44:32',NULL,NULL),(32506,'36071','S','Rutledge','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.768034,-86.364675,0,'2013-07-06 12:44:32',NULL,NULL),(28368,'31216','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.730819,-83.683586,0,'2013-07-06 12:44:32',NULL,NULL),(24018,'26362','S','Newberne','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.211147,-81.050312,0,'2013-07-06 12:44:31',NULL,NULL),(55300,'63531','S','Colony','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.263106,-92.262440,0,'2013-07-06 12:44:33',NULL,NULL),(59756,'71153','U','Water Department','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.515347,-93.749932,0,'2013-07-06 12:44:33',NULL,NULL),(65850,'78201','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.467240,-98.530042,0,'2013-07-06 12:44:34',NULL,NULL),(33703,'37764','S','Kodak','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.979026,-83.672577,0,'2013-07-06 12:44:32',NULL,NULL),(14551,'15211','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.432740,-79.945680,0,'2013-07-06 12:44:31',NULL,NULL),(4942,'04092','S','Westbrook','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.684846,-70.357119,0,'2013-07-06 12:44:30',NULL,NULL),(37135,'41465','S','Edna','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(36969,'41179','S','Clarksburg','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(40307,'45458','S','Washingtn Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(43767,'49026','S','Bloomingdale','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.373480,-85.971257,0,'2013-07-06 12:44:32',NULL,NULL),(55838,'64157','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.277775,-94.470561,0,'2013-07-06 12:44:33',NULL,NULL),(14320,'14903','S','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.127740,-76.869660,0,'2013-07-06 12:44:31',NULL,NULL),(72945,'90038','S','W Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091104,-118.343030,0,'2013-07-06 12:44:34',NULL,NULL),(10106,'10256','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706232,-74.010903,0,'2013-07-06 12:44:30',NULL,NULL),(34205,'38344','S','Huntingdon','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.997060,-88.422900,0,'2013-07-06 12:44:32',NULL,NULL),(67443,'80207','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.757333,-104.912703,0,'2013-07-06 12:44:34',NULL,NULL),(16919,'17603','S','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(38136,'43127','P','Haydenville','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.474543,-82.317784,0,'2013-07-06 12:44:32',NULL,NULL),(7597,'07043','S','Montclair','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.841403,-74.201411,0,'2013-07-06 12:44:30',NULL,NULL),(79956,'99633','P','Naknek','D','Bristol Bay','02060','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.859847,-156.710370,0,'2013-07-06 12:44:34',NULL,NULL),(27283,'29945','S','Yemassee','D','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(44448,'49865','P','Ishpeming','A','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.457683,-87.681834,0,'2013-07-06 12:44:32',NULL,NULL),(33968,'38108','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.180649,-89.954309,0,'2013-07-06 12:44:32',NULL,NULL),(21974,'23249','U','McGuire Veterans Hospital','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.494632,-77.467640,0,'2013-07-06 12:44:31',NULL,NULL),(68861,'82633','S','Orin','A','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.652560,-105.189910,0,'2013-07-06 12:44:34',NULL,NULL),(9894,'10128','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(48364,'55552','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.811369,-93.921421,0,'2013-07-06 12:44:33',NULL,NULL),(26453,'29138','S','Emory','N','Saluda','45081','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.007368,-81.769758,0,'2013-07-06 12:44:31',NULL,NULL),(7815,'07451','P','Ridgewood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.980549,-74.119354,0,'2013-07-06 12:44:30',NULL,NULL),(35788,'39750','S','Oktibbeha','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.509640,-89.066880,0,'2013-07-06 12:44:32',NULL,NULL),(4186,'02817','S','West Greenwich','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.624715,-71.626315,0,'2013-07-06 12:44:30',NULL,NULL),(58605,'68853','S','Oak Creek','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.279151,-98.969658,0,'2013-07-06 12:44:33',NULL,NULL),(30220,'33186','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661132,-80.407574,0,'2013-07-06 12:44:32',NULL,NULL),(56112,'64801','S','Joplin','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(53953,'62424','S','Dieterich','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.062733,-88.380295,0,'2013-07-06 12:44:33',NULL,NULL),(19428,'20102','U','Dulles Air Transfer Office','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.956561,-77.450321,0,'2013-07-06 12:44:31',NULL,NULL),(15123,'15823','S','Brockport','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.300154,-78.729739,0,'2013-07-06 12:44:31',NULL,NULL),(14353,'15014','S','Brackenridge','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.609876,-79.740604,0,'2013-07-06 12:44:31',NULL,NULL),(79245,'98557','S','McCleary','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.053140,-123.286440,0,'2013-07-06 12:44:34',NULL,NULL),(65186,'77419','P','Blessing','D','Matagorda','48321','Texas','TX','48','0000','361','Central',-6.0,'Y',28.851796,-96.229757,0,'2013-07-06 12:44:34',NULL,NULL),(18832,'19422','S','Penllyn','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.152960,-75.274659,0,'2013-07-06 12:44:31',NULL,NULL),(9930,'10153','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(40423,'45695','S','Wilkesville','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.140833,-82.376944,0,'2013-07-06 12:44:32',NULL,NULL),(12203,'12785','P','Westbrookvlle','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.495716,-74.561461,0,'2013-07-06 12:44:30',NULL,NULL),(8967,'08816','S','E Brunswick','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.429733,-74.407288,0,'2013-07-06 12:44:30',NULL,NULL),(485,'00669','S','Urb Buena Vista','N','Lares','72081','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.294354,-66.884391,0,'2013-07-06 12:44:30',NULL,NULL),(25563,'28422','S','Bolivia','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.034100,-78.167160,0,'2013-07-06 12:44:31',NULL,NULL),(33251,'37078','S','Hurricne Mlls','A','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.949864,-87.761509,0,'2013-07-06 12:44:32',NULL,NULL),(37297,'41635','S','Amba','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(23147,'24986','S','Wht Sulphur S','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797867,-80.296195,0,'2013-07-06 12:44:31',NULL,NULL),(9194,'09399','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8251,'08006','P','Barnegat Light Boro','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.757500,-74.106667,0,'2013-07-06 12:44:30',NULL,NULL),(74957,'93424','P','Avila Beach','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.183729,-120.725586,0,'2013-07-06 12:44:34',NULL,NULL),(23116,'24951','S','Lindside','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.676334,-80.887504,0,'2013-07-06 12:44:31',NULL,NULL),(28545,'31558','S','Saint Marys','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.754348,-81.561603,0,'2013-07-06 12:44:32',NULL,NULL),(10880,'11420','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674361,-73.813156,0,'2013-07-06 12:44:30',NULL,NULL),(34586,'38740','S','Duncan','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.777156,-90.722884,0,'2013-07-06 12:44:32',NULL,NULL),(37324,'41653','S','Emma','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(21860,'23148','S','Saint Stephens Church','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.914841,-77.076387,0,'2013-07-06 12:44:31',NULL,NULL),(46429,'53194','P','Woodworth','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.562811,-88.072225,0,'2013-07-06 12:44:32',NULL,NULL),(60076,'71355','S','Voorhies','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(68066,'80935','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.833696,-104.818441,0,'2013-07-06 12:44:34',NULL,NULL),(77690,'97039','S','Moro','D','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.486939,-120.733300,0,'2013-07-06 12:44:34',NULL,NULL),(65368,'77535','S','Old Rvr-Wnfre','A','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(68245,'81057','S','Lubers','N','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.134649,-102.869788,0,'2013-07-06 12:44:34',NULL,NULL),(5104,'04350','S','Litchfield','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.158538,-69.950907,0,'2013-07-06 12:44:30',NULL,NULL),(43546,'48703','S','Au Gres','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.060348,-83.644117,0,'2013-07-06 12:44:32',NULL,NULL),(51358,'59337','S','Jordan','D','Garfield','30033','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.543154,-106.792270,0,'2013-07-06 12:44:33',NULL,NULL),(54377,'62812','S','Benton','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(57843,'67554','S','Lyons','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.345749,-98.206137,0,'2013-07-06 12:44:33',NULL,NULL),(4375,'03082','S','Lyndeboro','N','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.903214,-71.778697,0,'2013-07-06 12:44:30',NULL,NULL),(58781,'68974','S','Ruskin','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.129971,-97.877465,0,'2013-07-06 12:44:33',NULL,NULL),(25961,'28658','S','Drums Crossroads','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(9572,'10026','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(21980,'23250','S','Richmnd','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(14908,'15533','S','Breezewood','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.987619,-78.243556,0,'2013-07-06 12:44:31',NULL,NULL),(77301,'96668','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(67522,'80246','S','Glendale','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.703000,-104.929994,0,'2013-07-06 12:44:34',NULL,NULL),(66450,'78653','S','Daffan','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(62310,'74034','P','Hallett','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.233896,-96.567733,0,'2013-07-06 12:44:33',NULL,NULL),(18438,'19066','S','Merion','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002386,-75.253465,0,'2013-07-06 12:44:31',NULL,NULL),(54582,'62899','S','Songer','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.697541,-88.638859,0,'2013-07-06 12:44:33',NULL,NULL),(2210,'00926','S','Sect la Corte','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(24712,'27502','S','Apex','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.711653,-78.819650,0,'2013-07-06 12:44:31',NULL,NULL),(52912,'61364','S','Munster','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(66433,'78644','S','Lockhart','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.879640,-97.666740,0,'2013-07-06 12:44:34',NULL,NULL),(10839,'11386','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.700392,-73.894731,0,'2013-07-06 12:44:30',NULL,NULL),(52308,'60546','S','Riverside','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.835506,-87.821640,0,'2013-07-06 12:44:33',NULL,NULL),(59400,'70632','S','Creole','D','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.785822,-93.024222,0,'2013-07-06 12:44:33',NULL,NULL),(750,'00692','S','Ext La Esperanza','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(74609,'92708','S','Santa Ana','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.716650,-117.944594,0,'2013-07-06 12:44:34',NULL,NULL),(72584,'89406','S','Dixie Valley','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(67184,'79852','S','Lajitas','A','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',29.330664,-103.591563,0,'2013-07-06 12:44:34',NULL,NULL),(66067,'78382','S','Estes','N','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.022280,-97.099080,0,'2013-07-06 12:44:34',NULL,NULL),(59287,'70467','P','Varnado','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.893611,-89.829444,0,'2013-07-06 12:44:33',NULL,NULL),(79039,'98403','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.267293,-122.458412,0,'2013-07-06 12:44:34',NULL,NULL),(26505,'29170','S','West Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.950402,-81.141165,0,'2013-07-06 12:44:31',NULL,NULL),(24966,'27843','S','Hobgood','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.983532,-77.442885,0,'2013-07-06 12:44:31',NULL,NULL),(29074,'32254','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.338709,-81.727618,0,'2013-07-06 12:44:32',NULL,NULL),(32040,'35246','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519522,-86.801880,0,'2013-07-06 12:44:32',NULL,NULL),(32558,'36114','S','Gunter AFB','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405544,-86.248050,0,'2013-07-06 12:44:32',NULL,NULL),(52552,'60945','P','Iroquois','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.827046,-87.583107,0,'2013-07-06 12:44:33',NULL,NULL),(10156,'10278','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(36774,'41043','S','Bradford','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(50246,'57626','S','Cooper','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(46311,'53065','S','Oakfield','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.684255,-88.546863,0,'2013-07-06 12:44:32',NULL,NULL),(3631,'02070','P','Sheldonville','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.034805,-71.386000,0,'2013-07-06 12:44:30',NULL,NULL),(44663,'50110','P','Gray','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.837497,-94.976472,0,'2013-07-06 12:44:32',NULL,NULL),(79667,'99159','S','Odessa','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.331306,-118.683124,0,'2013-07-06 12:44:34',NULL,NULL),(33530,'37381','S','Spring City','D','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.669020,-84.851318,0,'2013-07-06 12:44:32',NULL,NULL),(61683,'72940','S','Huntington','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.080324,-94.261638,0,'2013-07-06 12:44:33',NULL,NULL),(16663,'17354','S','Ports Sidling','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.849844,-76.879266,0,'2013-07-06 12:44:31',NULL,NULL),(19496,'20159','P','Hamilton','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.134248,-77.664947,0,'2013-07-06 12:44:31',NULL,NULL),(22049,'23315','S','Carrsville','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.743516,-76.837238,0,'2013-07-06 12:44:31',NULL,NULL),(27036,'29658','S','Long Creek','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.762398,-83.233773,0,'2013-07-06 12:44:31',NULL,NULL),(26342,'29062','P','Horatio','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.113377,-80.549366,0,'2013-07-06 12:44:31',NULL,NULL),(66931,'79350','P','New Deal','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.718840,-101.837287,0,'2013-07-06 12:44:34',NULL,NULL),(70149,'84310','S','Eden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.338807,-111.865237,0,'2013-07-06 12:44:34',NULL,NULL),(9784,'10107','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(14742,'15313','P','Beallsville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.062950,-80.027147,0,'2013-07-06 12:44:31',NULL,NULL),(52916,'61364','S','Streator West','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(53185,'61607','S','Bartonville','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(23992,'26335','S','Gem','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.848620,-80.650380,0,'2013-07-06 12:44:31',NULL,NULL),(18728,'19320','S','East Fallowfield Township','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(59902,'71276','S','Talla Bena','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.571944,-91.182222,0,'2013-07-06 12:44:33',NULL,NULL),(79920,'99606','P','Kokhanok','A','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.613300,-155.276220,0,'2013-07-06 12:44:34',NULL,NULL),(71188,'86045','P','Rare Metals','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.133993,-111.242465,0,'2013-07-06 12:44:34',NULL,NULL),(64047,'76130','U','Texas Christian Univ','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.706926,-97.362225,0,'2013-07-06 12:44:34',NULL,NULL),(63817,'75972','S','Blandlake','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(26891,'29570','S','Mc Coll','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.662498,-79.544259,0,'2013-07-06 12:44:31',NULL,NULL),(15956,'17025','S','South Enola','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(3999,'02542','S','Otis A F B','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.658720,-70.567260,0,'2013-07-06 12:44:30',NULL,NULL),(37743,'42320','S','Echols','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(38138,'43128','S','Jeffersonvlle','A','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.656660,-83.573926,0,'2013-07-06 12:44:32',NULL,NULL),(12558,'13052','S','De Ruyter','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.760200,-75.892320,0,'2013-07-06 12:44:30',NULL,NULL),(6628,'05905','S','Guildhall','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(11159,'11721','S','Center Port','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.890176,-73.372822,0,'2013-07-06 12:44:30',NULL,NULL),(59071,'70112','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.956043,-90.079214,0,'2013-07-06 12:44:33',NULL,NULL),(77641,'97013','S','Barlow','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.241313,-122.677583,0,'2013-07-06 12:44:34',NULL,NULL),(52190,'60470','S','Ransom','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.157396,-88.657910,0,'2013-07-06 12:44:33',NULL,NULL),(22442,'24019','S','Hollins','A','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.337160,-79.951680,0,'2013-07-06 12:44:31',NULL,NULL),(25260,'28120','S','Mount Holly','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.307051,-81.030096,0,'2013-07-06 12:44:31',NULL,NULL),(60861,'72053','P','College Sta','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.711660,-92.222290,0,'2013-07-06 12:44:33',NULL,NULL),(72608,'89414','S','Golconda','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.007834,-117.299047,0,'2013-07-06 12:44:34',NULL,NULL),(68318,'81120','S','Espinoza','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(1898,'00794','S','Urb San Cristobal','N','Barranquitas','72019','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.187596,-66.307408,0,'2013-07-06 12:44:30',NULL,NULL),(27736,'30353','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.753297,-84.391406,0,'2013-07-06 12:44:31',NULL,NULL),(54082,'62520','S','Dawson','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.855253,-89.459959,0,'2013-07-06 12:44:33',NULL,NULL),(36712,'41018','S','Erlanger','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.009027,-84.598071,0,'2013-07-06 12:44:32',NULL,NULL),(296,'00646','S','Urb Dorado Reef','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(21738,'23025','S','Miles','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.420768,-76.382292,0,'2013-07-06 12:44:31',NULL,NULL),(50622,'58267','S','Kempton','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.743920,-97.583880,0,'2013-07-06 12:44:33',NULL,NULL),(78864,'98348','P','La Grande','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.819889,-122.277126,0,'2013-07-06 12:44:34',NULL,NULL),(75002,'93453','S','Santa Margarita','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.365892,-120.392105,0,'2013-07-06 12:44:34',NULL,NULL),(68874,'82642','S','Lost Cabin','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.300855,-107.638296,0,'2013-07-06 12:44:34',NULL,NULL),(5599,'04926','P','China Village','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.476142,-69.516388,0,'2013-07-06 12:44:30',NULL,NULL),(39872,'45206','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.126559,-84.483385,0,'2013-07-06 12:44:32',NULL,NULL),(20533,'21102','S','Manchester','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.643550,-76.696400,0,'2013-07-06 12:44:31',NULL,NULL),(31884,'35128','S','Pell City','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.586316,-86.285828,0,'2013-07-06 12:44:32',NULL,NULL),(52789,'61273','S','Orion','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.366880,-90.433140,0,'2013-07-06 12:44:33',NULL,NULL),(57260,'66538','S','St Benedict','A','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.836640,-96.061080,0,'2013-07-06 12:44:33',NULL,NULL),(188,'00623','S','Repto Miradero','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(13661,'14026','S','Bowmansville','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.941598,-78.690474,0,'2013-07-06 12:44:31',NULL,NULL),(26781,'29449','S','Rantowels','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.711040,-80.276820,0,'2013-07-06 12:44:31',NULL,NULL),(18165,'18910','P','Bedminster','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.422200,-75.179820,0,'2013-07-06 12:44:31',NULL,NULL),(15809,'16927','S','Westfield','A','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.951385,-77.702976,0,'2013-07-06 12:44:31',NULL,NULL),(64466,'76574','S','Sandoval','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(37669,'42211','S','Ironton','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(64467,'76574','S','Taylor','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(34220,'38362','S','Oakfield','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.721568,-88.774780,0,'2013-07-06 12:44:32',NULL,NULL),(21190,'22185','U','A T & T','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.899292,-77.260327,0,'2013-07-06 12:44:31',NULL,NULL),(759,'00692','S','Urb Cerro Gordo Hls','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(13634,'13904','S','West Colesville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.129060,-75.821820,0,'2013-07-06 12:44:31',NULL,NULL),(5844,'05089','S','Windsor','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.475040,-72.427380,0,'2013-07-06 12:44:30',NULL,NULL),(4625,'03602','S','Langdon','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.154442,-72.304628,0,'2013-07-06 12:44:30',NULL,NULL),(46093,'52621','S','Crawfordsville','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.212644,-91.536955,0,'2013-07-06 12:44:32',NULL,NULL),(11944,'12439','S','Hensonville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.258600,-74.224980,0,'2013-07-06 12:44:30',NULL,NULL),(22032,'23295','U','Capital One','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.555283,-77.461217,0,'2013-07-06 12:44:31',NULL,NULL),(21502,'22701','S','Raccoon Ford','A','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.471640,-78.013989,0,'2013-07-06 12:44:31',NULL,NULL),(54504,'62867','S','New Haven','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.854820,-88.099558,0,'2013-07-06 12:44:33',NULL,NULL),(77262,'96577','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(65706,'78014','S','Cotulla','D','La Salle','48283','Texas','TX','48','0000','830','Central',-6.0,'Y',28.424112,-99.237016,0,'2013-07-06 12:44:34',NULL,NULL),(60961,'72104','S','Brown Springs','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(21201,'22193','S','Dalecity','N','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.646162,-77.349693,0,'2013-07-06 12:44:31',NULL,NULL),(16744,'17509','S','Andrews Bridge','N','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(38640,'43933','S','Armstrong Mills','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.945410,-80.902208,0,'2013-07-06 12:44:32',NULL,NULL),(1923,'00795','S','Sect Las Flores','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(30491,'33359','P','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.179370,-80.226998,0,'2013-07-06 12:44:32',NULL,NULL),(34087,'38159','U','Regions Bank','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.148592,-90.054728,0,'2013-07-06 12:44:32',NULL,NULL),(31728,'34983','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308284,-80.348414,0,'2013-07-06 12:44:32',NULL,NULL),(23668,'25831','S','Maplewood','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.883531,-80.971211,0,'2013-07-06 12:44:31',NULL,NULL),(49979,'57361','P','Marty','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.959043,-98.392182,0,'2013-07-06 12:44:33',NULL,NULL),(75791,'94708','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.906115,-122.273476,0,'2013-07-06 12:44:34',NULL,NULL),(76199,'95354','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.643098,-120.968790,0,'2013-07-06 12:44:34',NULL,NULL),(7780,'07421','S','Upper Greenwood Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.157420,-74.352660,0,'2013-07-06 12:44:30',NULL,NULL),(72767,'89521','S','VC Highlands','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.379920,-119.753303,0,'2013-07-06 12:44:34',NULL,NULL),(65372,'77539','S','San Leon','A','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.469000,-95.014380,0,'2013-07-06 12:44:34',NULL,NULL),(67413,'80133','S','Palmer Lake','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.117250,-104.913143,0,'2013-07-06 12:44:34',NULL,NULL),(64196,'76247','S','Justin','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.070947,-97.302229,0,'2013-07-06 12:44:34',NULL,NULL),(62937,'75094','S','Murphy','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.017760,-96.624420,0,'2013-07-06 12:44:33',NULL,NULL),(49820,'57216','S','Big Stone City','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.292796,-96.462397,0,'2013-07-06 12:44:33',NULL,NULL),(52905,'61362','S','Ottoville','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.329992,-89.220913,0,'2013-07-06 12:44:33',NULL,NULL),(56498,'65338','S','Palopinto','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.436452,-93.404512,0,'2013-07-06 12:44:33',NULL,NULL),(22846,'24529','S','Buffalo Junction','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.598421,-78.619575,0,'2013-07-06 12:44:31',NULL,NULL),(33674,'37732','P','Elgin','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.460220,-84.581296,0,'2013-07-06 12:44:32',NULL,NULL),(42370,'47711','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(57742,'67431','S','Chapman','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.971941,-97.021979,0,'2013-07-06 12:44:33',NULL,NULL),(18329,'19026','S','Pilgrim Gardens','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.955020,-75.327420,0,'2013-07-06 12:44:31',NULL,NULL),(8826,'08620','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.178809,-74.659973,0,'2013-07-06 12:44:30',NULL,NULL),(28232,'31044','S','Jeffersonville','D','Twiggs','13289','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.682004,-83.331608,0,'2013-07-06 12:44:31',NULL,NULL),(54365,'62803','S','Hoyleton','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.451703,-89.313807,0,'2013-07-06 12:44:33',NULL,NULL),(31966,'35213','S','Crestline Heights','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504565,-86.747150,0,'2013-07-06 12:44:32',NULL,NULL),(39579,'44856','P','North Robinson','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.792386,-82.860196,0,'2013-07-06 12:44:32',NULL,NULL),(74024,'92130','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.951538,-117.222721,0,'2013-07-06 12:44:34',NULL,NULL),(54976,'63123','S','Affton','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.543880,-90.318420,0,'2013-07-06 12:44:33',NULL,NULL),(67846,'80818','S','Bovina','N','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.275097,-103.500657,0,'2013-07-06 12:44:34',NULL,NULL),(2201,'00926','S','Repto Contemporaneo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(7466,'06878','S','Riverside','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.035745,-73.581706,0,'2013-07-06 12:44:30',NULL,NULL),(41343,'46787','S','Luther','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.085770,-85.618016,0,'2013-07-06 12:44:32',NULL,NULL),(57050,'66210','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(35213,'39298','P','JXN','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.321984,-90.206032,0,'2013-07-06 12:44:32',NULL,NULL),(56247,'65052','S','Linn Creek','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.040796,-92.706040,0,'2013-07-06 12:44:33',NULL,NULL),(17325,'17860','S','Reed Station','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.833938,-76.639647,0,'2013-07-06 12:44:31',NULL,NULL),(17437,'17932','U','State Correctional Inst','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.782690,-76.232139,0,'2013-07-06 12:44:31',NULL,NULL),(44243,'49666','P','Mayfield','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.597988,-85.534358,0,'2013-07-06 12:44:32',NULL,NULL),(65171,'77414','S','Bay City','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.963849,-95.948080,0,'2013-07-06 12:44:34',NULL,NULL),(1073,'00725','S','Qtas de Villa Blanca','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(21623,'22907','U','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.952452,-78.492913,0,'2013-07-06 12:44:31',NULL,NULL),(3389,'01608','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.261746,-71.802267,0,'2013-07-06 12:44:30',NULL,NULL),(9746,'10101','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(26343,'29063','S','Irmo','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.122153,-81.195991,0,'2013-07-06 12:44:31',NULL,NULL),(36702,'41017','S','Ft Mitchell','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(19801,'20439','U','Us Court Appeal Fed Circuit','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904771,-77.030231,0,'2013-07-06 12:44:31',NULL,NULL),(40297,'45448','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.647561,-84.169843,0,'2013-07-06 12:44:32',NULL,NULL),(22274,'23703','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.866685,-76.387575,0,'2013-07-06 12:44:31',NULL,NULL),(369,'00659','S','Urb Mar Azul','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(4877,'04037','S','Fryeburg','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.014772,-70.967645,0,'2013-07-06 12:44:30',NULL,NULL),(71936,'87901','S','Truth or Consequences','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.129932,-107.251636,0,'2013-07-06 12:44:34',NULL,NULL),(69768,'84056','S','Hillfield','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.120889,-111.982055,0,'2013-07-06 12:44:34',NULL,NULL),(9347,'09802','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(54541,'62885','S','Shobonier','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842965,-89.082598,0,'2013-07-06 12:44:33',NULL,NULL),(36283,'40351','S','Haldeman','A','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.194098,-83.439956,0,'2013-07-06 12:44:32',NULL,NULL),(21040,'21871','S','Kingston','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.097540,-75.760560,0,'2013-07-06 12:44:31',NULL,NULL),(33763,'37862','S','Pigeon Forge','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.871495,-83.533150,0,'2013-07-06 12:44:32',NULL,NULL),(11575,'12068','S','Fonda','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.942360,-74.430300,0,'2013-07-06 12:44:30',NULL,NULL),(56111,'64801','S','Iron Gates','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(9230,'09549','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60030,'71343','S','Book','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(60282,'71449','S','Sabine','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(156,'00617','S','Urb Plazuela Estates','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(77365,'96743','S','Kawaihae','N','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.975127,-155.762770,0,'2013-07-06 12:44:34',NULL,NULL),(73254,'90710','S','Harbor City','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.800611,-118.299094,0,'2013-07-06 12:44:34',NULL,NULL),(17901,'18447','S','Olyphant','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(17187,'17820','S','Mayberry','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(45594,'51551','S','Malvern','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.003006,-95.585413,0,'2013-07-06 12:44:32',NULL,NULL),(10789,'11369','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.765278,-73.817778,0,'2013-07-06 12:44:30',NULL,NULL),(12595,'13076','S','Hastings','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.351755,-76.149799,0,'2013-07-06 12:44:30',NULL,NULL),(19074,'19559','P','Strausstown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.492216,-76.184763,0,'2013-07-06 12:44:31',NULL,NULL),(23691,'25855','P','Hilltop','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.944541,-81.149775,0,'2013-07-06 12:44:31',NULL,NULL),(64601,'76682','S','Otto','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.473889,-96.920114,0,'2013-07-06 12:44:34',NULL,NULL),(54911,'63084','S','Union','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.429607,-90.998487,0,'2013-07-06 12:44:33',NULL,NULL),(60897,'72070','S','Houston','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.045804,-92.690848,0,'2013-07-06 12:44:33',NULL,NULL),(62581,'74464','S','Talequah','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.913588,-94.967828,0,'2013-07-06 12:44:33',NULL,NULL),(46175,'52734','U','Seventh Avenue','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.848613,-90.208528,0,'2013-07-06 12:44:32',NULL,NULL),(77267,'96601','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(66477,'78663','S','Cypress Mill','A','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.441858,-98.468024,0,'2013-07-06 12:44:34',NULL,NULL),(78179,'97702','S','Bend','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.022054,-121.297092,0,'2013-07-06 12:44:34',NULL,NULL),(35988,'40121','S','Fort Knox','D','Hardin','21093','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.926575,-85.912788,0,'2013-07-06 12:44:32',NULL,NULL),(44750,'50169','S','Santiago','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.665549,-93.367550,0,'2013-07-06 12:44:32',NULL,NULL),(34017,'38126','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.124020,-90.041534,0,'2013-07-06 12:44:32',NULL,NULL),(76708,'95837','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.697994,-121.588047,0,'2013-07-06 12:44:34',NULL,NULL),(76563,'95668','S','Pleasant Grv','A','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.821488,-121.507596,0,'2013-07-06 12:44:34',NULL,NULL),(57752,'67444','S','Geneseo','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.516502,-98.151849,0,'2013-07-06 12:44:33',NULL,NULL),(49180,'56433','S','Akeley','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.022069,-94.724608,0,'2013-07-06 12:44:33',NULL,NULL),(72889,'90016','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.027729,-118.351874,0,'2013-07-06 12:44:34',NULL,NULL),(79608,'99107','S','Kettle Falls','A','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.713044,-118.132398,0,'2013-07-06 12:44:34',NULL,NULL),(78611,'98198','S','Des Moines','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.405098,-122.310024,0,'2013-07-06 12:44:34',NULL,NULL),(29143,'32329','P','Apalachicola','D','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.726522,-84.997012,0,'2013-07-06 12:44:32',NULL,NULL),(42233,'47567','S','Glezen','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(14986,'15642','S','North Huntingdon','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.328956,-79.721348,0,'2013-07-06 12:44:31',NULL,NULL),(33694,'37755','S','New River','N','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.434790,-84.565182,0,'2013-07-06 12:44:32',NULL,NULL),(36625,'41001','S','Alexandria','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.915760,-84.395700,0,'2013-07-06 12:44:32',NULL,NULL),(57538,'67021','S','Byers','D','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.779250,-98.907252,0,'2013-07-06 12:44:33',NULL,NULL),(26958,'29607','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.829648,-82.340068,0,'2013-07-06 12:44:31',NULL,NULL),(44045,'49428','S','Georgetown Tp','A','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.907457,-85.830308,0,'2013-07-06 12:44:32',NULL,NULL),(25986,'28665','S','Purlear','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.221121,-81.387906,0,'2013-07-06 12:44:31',NULL,NULL),(63196,'75431','S','Como','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.079440,-95.368016,0,'2013-07-06 12:44:33',NULL,NULL),(68278,'81082','S','Jansen','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(71160,'86038','S','Mormon Lake','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.944121,-111.427745,0,'2013-07-06 12:44:34',NULL,NULL),(73532,'91350','S','Sleepy Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(74810,'93210','S','Coalinga','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.170199,-120.361013,0,'2013-07-06 12:44:34',NULL,NULL),(73032,'90074','U','Bank of America','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.052583,-118.268010,0,'2013-07-06 12:44:34',NULL,NULL),(7261,'06517','S','Whitneyville','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.349805,-72.913991,0,'2013-07-06 12:44:30',NULL,NULL),(27427,'30108','S','Bowdon','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.537435,-85.256617,0,'2013-07-06 12:44:31',NULL,NULL),(58420,'68652','S','Petersburg','D','Boone','31011','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.854671,-98.148496,0,'2013-07-06 12:44:33',NULL,NULL),(16734,'17502','S','Bainbridge','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.121860,-76.654353,0,'2013-07-06 12:44:31',NULL,NULL),(32248,'35611','S','Athens','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.798525,-86.966415,0,'2013-07-06 12:44:32',NULL,NULL),(25792,'28604','S','Seven Devils','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(25170,'28040','S','Hollis','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.400480,-81.757380,0,'2013-07-06 12:44:31',NULL,NULL),(75750,'94611','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.835580,-122.223360,0,'2013-07-06 12:44:34',NULL,NULL),(39619,'44883','S','Fort Seneca','A','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.121369,-83.175860,0,'2013-07-06 12:44:32',NULL,NULL),(76491,'95632','S','Galt','D','Sacramento','06067','California','CA','06','6920','209','Pacific',-8.0,'Y',38.277565,-121.294004,0,'2013-07-06 12:44:34',NULL,NULL),(71528,'87124','S','Panorama Heights','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.256600,-106.696560,0,'2013-07-06 12:44:34',NULL,NULL),(10729,'11352','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.753276,-73.820637,0,'2013-07-06 12:44:30',NULL,NULL),(26829,'29485','S','Summerville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.975069,-80.180159,0,'2013-07-06 12:44:31',NULL,NULL),(31965,'35213','S','Crestline','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504565,-86.747150,0,'2013-07-06 12:44:32',NULL,NULL),(36461,'40729','S','Victory','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.204331,-84.118241,0,'2013-07-06 12:44:32',NULL,NULL),(5793,'05060','S','East Roxbury','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.931946,-72.644794,0,'2013-07-06 12:44:30',NULL,NULL),(67407,'80130','S','Hghlnds Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.544318,-104.920225,0,'2013-07-06 12:44:34',NULL,NULL),(35076,'39201','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.292867,-90.184187,0,'2013-07-06 12:44:32',NULL,NULL),(36026,'40166','U','Shepherdsville','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(56010,'64653','S','Linneus','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.775581,-93.062095,0,'2013-07-06 12:44:33',NULL,NULL),(61488,'72641','S','Jasper','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.002568,-93.217954,0,'2013-07-06 12:44:33',NULL,NULL),(36218,'40282','U','Pleasure Rdge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(26398,'29107','S','Livingston','A','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.489723,-81.034501,0,'2013-07-06 12:44:31',NULL,NULL),(54860,'63045','S','Earth City','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.768694,-90.463908,0,'2013-07-06 12:44:33',NULL,NULL),(75480,'94116','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.741108,-122.485687,0,'2013-07-06 12:44:34',NULL,NULL),(18430,'19063','S','Media','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(2379,'00949','S','Urb Covadonga','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(25933,'28655','S','Burkemont','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(21349,'22433','S','Burr Hill','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.369137,-77.885088,0,'2013-07-06 12:44:31',NULL,NULL),(19084,'19567','S','Ryeland','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386594,-76.216795,0,'2013-07-06 12:44:31',NULL,NULL),(52381,'60625','S','Ravenswood','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.968521,-87.703667,0,'2013-07-06 12:44:33',NULL,NULL),(54791,'63011','S','Winchester','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.598725,-90.547046,0,'2013-07-06 12:44:33',NULL,NULL),(76384,'95528','S','Carlotta','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.486485,-123.887890,0,'2013-07-06 12:44:34',NULL,NULL),(7123,'06383','P','Versailles','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.600591,-72.043044,0,'2013-07-06 12:44:30',NULL,NULL),(60135,'71373','S','Green Acres','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(63651,'75845','S','Josserand','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(78996,'98382','S','Diamond Pt','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(33395,'37221','S','Bellevue','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.055020,-86.961600,0,'2013-07-06 12:44:32',NULL,NULL),(19982,'20598','U','Falls Church','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(35502,'39529','U','Stennis Spc Ctr','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(44543,'50002','S','Adair','D','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.499324,-94.647499,0,'2013-07-06 12:44:32',NULL,NULL),(50122,'57521','S','Belvidere','D','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.901848,-101.246893,0,'2013-07-06 12:44:33',NULL,NULL),(38824,'44077','S','Painesville','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.750000,-81.283333,0,'2013-07-06 12:44:32',NULL,NULL),(45589,'51546','S','Logan','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.648696,-95.789131,0,'2013-07-06 12:44:32',NULL,NULL),(50346,'57744','S','Hayward','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.838417,-103.190898,0,'2013-07-06 12:44:33',NULL,NULL),(65139,'77385','S','Oak Ridge North','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.185643,-95.428944,0,'2013-07-06 12:44:34',NULL,NULL),(44710,'50143','S','Leighton','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.376124,-92.816298,0,'2013-07-06 12:44:32',NULL,NULL),(41341,'46786','P','South Milford','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.528859,-85.274974,0,'2013-07-06 12:44:32',NULL,NULL),(2480,'00956','S','Urb Forest View','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(8043,'07734','S','East Keansburg','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.439051,-74.125510,0,'2013-07-06 12:44:30',NULL,NULL),(25512,'28383','S','Rowland','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.536371,-79.290511,0,'2013-07-06 12:44:31',NULL,NULL),(28969,'32206','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.351865,-81.643107,0,'2013-07-06 12:44:32',NULL,NULL),(1458,'00745','S','Hacienda Las Garzas','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(10050,'10175','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(50932,'58569','S','Shields','D','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.200991,-101.235194,0,'2013-07-06 12:44:33',NULL,NULL),(9432,'10004','S','Bowling Green','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(27685,'30336','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.749608,-84.551548,0,'2013-07-06 12:44:31',NULL,NULL),(66350,'78610','S','Mountain City','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.082691,-97.843934,0,'2013-07-06 12:44:34',NULL,NULL),(63083,'75248','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.966396,-96.798494,0,'2013-07-06 12:44:33',NULL,NULL),(8791,'08560','S','Titusville','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.296010,-74.856815,0,'2013-07-06 12:44:30',NULL,NULL),(5567,'04861','S','Thomaston','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.082000,-69.178594,0,'2013-07-06 12:44:30',NULL,NULL),(21370,'22454','S','Howertons','A','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.843800,-76.831080,0,'2013-07-06 12:44:31',NULL,NULL),(36254,'40316','S','Denniston','D','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.921607,-83.511154,0,'2013-07-06 12:44:32',NULL,NULL),(10632,'11053','U','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.839189,-73.703262,0,'2013-07-06 12:44:30',NULL,NULL),(56189,'65014','S','Old Woolam','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(18812,'19403','S','Trooper','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(43225,'48311','P','Sterling Heights','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.578334,-83.028442,0,'2013-07-06 12:44:32',NULL,NULL),(44305,'49735','S','Treetops Village','A','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.987952,-84.675724,0,'2013-07-06 12:44:32',NULL,NULL),(65478,'77640','S','Port Arthur','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(66498,'78677','S','Gonzales','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.351201,-97.503023,0,'2013-07-06 12:44:34',NULL,NULL),(66882,'79234','S','Flomot','D','Motley','48345','Texas','TX','48','0000','806','Central',-6.0,'Y',34.200068,-100.997843,0,'2013-07-06 12:44:34',NULL,NULL),(77334,'96715','P','Hanamaulu','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.998592,-159.356441,0,'2013-07-06 12:44:34',NULL,NULL),(37655,'42206','S','Auburn','D','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.885141,-86.723180,0,'2013-07-06 12:44:32',NULL,NULL),(21545,'22740','S','Sperryville','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.629508,-78.252819,0,'2013-07-06 12:44:31',NULL,NULL),(53280,'61726','S','Weston','N','McLean','17113','Illinois','IL','17','1040','815/779','Central',-6.0,'Y',40.743720,-88.717320,0,'2013-07-06 12:44:33',NULL,NULL),(4525,'03431','S','Keene','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.938975,-72.285756,0,'2013-07-06 12:44:30',NULL,NULL),(78173,'97639','S','Chiloquin','A','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.455534,-121.503033,0,'2013-07-06 12:44:34',NULL,NULL),(18964,'19512','S','Shanesville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(25444,'28314','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.057720,-79.003491,0,'2013-07-06 12:44:31',NULL,NULL),(3594,'02032','S','E Walpole','N','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.154795,-71.216436,0,'2013-07-06 12:44:30',NULL,NULL),(14298,'14879','S','Savona','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.307167,-77.182785,0,'2013-07-06 12:44:31',NULL,NULL),(56899,'66045','U','Laurence','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.959171,-95.264228,0,'2013-07-06 12:44:33',NULL,NULL),(73875,'91934','S','Jacumba','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.615886,-116.187817,0,'2013-07-06 12:44:34',NULL,NULL),(78236,'97817','S','Bates','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.511076,-118.503159,0,'2013-07-06 12:44:34',NULL,NULL),(79576,'99022','S','Medical Lake','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.618220,-117.713400,0,'2013-07-06 12:44:34',NULL,NULL),(68465,'81236','S','Iron City','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.700006,-106.141598,0,'2013-07-06 12:44:34',NULL,NULL),(43382,'48429','S','Durand','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.909481,-83.991837,0,'2013-07-06 12:44:32',NULL,NULL),(77862,'97231','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.633419,-122.856362,0,'2013-07-06 12:44:34',NULL,NULL),(16921,'17603','S','Manor Ridge','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(28768,'32026','U','Florida Dept of Corrections','N','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.062470,-82.236973,0,'2013-07-06 12:44:32',NULL,NULL),(46964,'54205','S','Casco','D','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.554361,-87.624666,0,'2013-07-06 12:44:32',NULL,NULL),(34847,'38922','S','Youngs','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(15001,'15661','S','Loyalhanna','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.318587,-79.354068,0,'2013-07-06 12:44:31',NULL,NULL),(19662,'20310','U','Dept Army Pentagon','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(10121,'10260','U','JP Morgan Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(2614,'00962','S','Bo Juana Matos','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(21885,'23175','S','Urbanna','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.652942,-76.612774,0,'2013-07-06 12:44:31',NULL,NULL),(19332,'20032','S','Bolling Air Force Bas','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(30356,'33313','S','Laud Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(15693,'16843','P','Hyde','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.002709,-78.466463,0,'2013-07-06 12:44:31',NULL,NULL),(19700,'20376','S','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916809,-76.993655,0,'2013-07-06 12:44:31',NULL,NULL),(70034,'84132','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.765465,-111.840905,0,'2013-07-06 12:44:34',NULL,NULL),(66108,'78412','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.705823,-97.348066,0,'2013-07-06 12:44:34',NULL,NULL),(51303,'59226','S','Froid','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.337849,-104.491623,0,'2013-07-06 12:44:33',NULL,NULL),(55728,'64082','S','LS','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.860336,-94.400056,0,'2013-07-06 12:44:33',NULL,NULL),(30642,'33449','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.607200,-80.233543,0,'2013-07-06 12:44:32',NULL,NULL),(25447,'28319','P','Barnesville','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.384291,-79.066130,0,'2013-07-06 12:44:31',NULL,NULL),(48583,'55772','P','Orr','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.053611,-92.830833,0,'2013-07-06 12:44:33',NULL,NULL),(53395,'61820','S','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.109868,-88.247163,0,'2013-07-06 12:44:33',NULL,NULL),(68065,'80935','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.833696,-104.818441,0,'2013-07-06 12:44:34',NULL,NULL),(30249,'33199','U','Florida International Univ','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.759145,-80.372492,0,'2013-07-06 12:44:32',NULL,NULL),(36463,'40734','S','Gray','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.952243,-83.963632,0,'2013-07-06 12:44:32',NULL,NULL),(67223,'79927','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.655220,-106.228260,0,'2013-07-06 12:44:34',NULL,NULL),(38789,'44057','S','North Madison','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.770970,-81.058712,0,'2013-07-06 12:44:32',NULL,NULL),(22579,'24157','U','Home Shopping Network','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.292411,-80.063958,0,'2013-07-06 12:44:31',NULL,NULL),(60400,'71635','S','Crossett','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.129096,-91.960667,0,'2013-07-06 12:44:33',NULL,NULL),(57102,'66220','S','Shawnee','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.968891,-94.817860,0,'2013-07-06 12:44:33',NULL,NULL),(47068,'54425','S','Dorchester','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.006873,-90.331133,0,'2013-07-06 12:44:32',NULL,NULL),(45915,'52323','S','Oxford Mills','N','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.989991,-90.978487,0,'2013-07-06 12:44:32',NULL,NULL),(39658,'45011','S','City View Heights','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(71890,'87740','S','Raton','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.870600,-104.648580,0,'2013-07-06 12:44:34',NULL,NULL),(70843,'85541','S','Payson','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.203600,-111.289860,0,'2013-07-06 12:44:34',NULL,NULL),(67669,'80488','P','Steamboat Springs','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.476275,-106.850394,0,'2013-07-06 12:44:34',NULL,NULL),(25911,'28645','S','Lenoir','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(13596,'13850','S','Vestal Gardens','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(8710,'08403','S','Longport','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.315216,-74.537153,0,'2013-07-06 12:44:30',NULL,NULL),(57972,'67834','S','Bucklin','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.550242,-99.635022,0,'2013-07-06 12:44:33',NULL,NULL),(10318,'10541','S','Lake Lincolnd','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.378032,-73.749712,0,'2013-07-06 12:44:30',NULL,NULL),(55074,'63179','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.630674,-90.216355,0,'2013-07-06 12:44:33',NULL,NULL),(2591,'00961','S','Urb Campo Verde','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(47459,'54730','S','Colfax','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.999975,-91.723838,0,'2013-07-06 12:44:32',NULL,NULL),(71878,'87731','S','Montezuma','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.696667,-105.382222,0,'2013-07-06 12:44:34',NULL,NULL),(68400,'81152','S','Wildhorse Mesa','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(41821,'47338','S','Granville','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.342989,-85.353750,0,'2013-07-06 12:44:32',NULL,NULL),(39621,'44883','S','Tiffin','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.121369,-83.175860,0,'2013-07-06 12:44:32',NULL,NULL),(19765,'20418','U','National Academy of Science','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889776,-77.044451,0,'2013-07-06 12:44:31',NULL,NULL),(24047,'26416','S','Philippi','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.150767,-80.040442,0,'2013-07-06 12:44:31',NULL,NULL),(17500,'17961','S','Orwigsburg','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(65603,'77901','S','Mission Valley','N','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.706750,-97.181430,0,'2013-07-06 12:44:34',NULL,NULL),(66098,'78407','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.805931,-97.436894,0,'2013-07-06 12:44:34',NULL,NULL),(21722,'23003','P','Akk','N','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.438567,-76.578223,0,'2013-07-06 12:44:31',NULL,NULL),(10811,'11375','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.721216,-73.850210,0,'2013-07-06 12:44:30',NULL,NULL),(29181,'32395','U','Fl State Lot','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430504,-84.258788,0,'2013-07-06 12:44:32',NULL,NULL),(36468,'40741','S','Sasser','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.110220,-84.078189,0,'2013-07-06 12:44:32',NULL,NULL),(37888,'42602','S','Seminary','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(7507,'06926','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.040259,-73.548051,0,'2013-07-06 12:44:30',NULL,NULL),(9688,'10044','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(19241,'19933','S','Bridgeville','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.738901,-75.593665,0,'2013-07-06 12:44:31',NULL,NULL),(61982,'73195','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.564526,-97.518216,0,'2013-07-06 12:44:33',NULL,NULL),(75111,'93545','S','Panamint Springs','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.588000,-118.056263,0,'2013-07-06 12:44:34',NULL,NULL),(68604,'81611','S','Aspen','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.194434,-106.826452,0,'2013-07-06 12:44:34',NULL,NULL),(65657,'77979','S','Clarks','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(50899,'58542','S','Hague','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.063690,-99.942884,0,'2013-07-06 12:44:33',NULL,NULL),(23399,'25320','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.526900,-81.639120,0,'2013-07-06 12:44:31',NULL,NULL),(13041,'13439','S','Richfield','N','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(9912,'10138','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756075,-73.989193,0,'2013-07-06 12:44:30',NULL,NULL),(54274,'62685','S','Royal Lakes','A','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.116628,-90.005444,0,'2013-07-06 12:44:33',NULL,NULL),(53692,'62230','S','Saint Rose','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.608157,-89.527489,0,'2013-07-06 12:44:33',NULL,NULL),(25217,'28082','P','Kannapolis','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.479541,-80.626617,0,'2013-07-06 12:44:31',NULL,NULL),(27529,'30217','S','Franklin','D','Heard','13149','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.308377,-85.109975,0,'2013-07-06 12:44:31',NULL,NULL),(9918,'10150','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(36679,'41015','S','Latonia Lakes','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(21463,'22625','S','Cross Jnct','A','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.370440,-78.303060,0,'2013-07-06 12:44:31',NULL,NULL),(11412,'11960','P','Remsenburg','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.812687,-72.695052,0,'2013-07-06 12:44:30',NULL,NULL),(31320,'34116','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.182736,-81.710784,0,'2013-07-06 12:44:32',NULL,NULL),(1461,'00745','S','Repto Costa del Sol','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(60366,'71474','P','Temple','A','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.242969,-93.015952,0,'2013-07-06 12:44:33',NULL,NULL),(40262,'45431','S','Wpafb','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(47864,'55080','S','Stanford','N','Isanti','27059','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.663805,-93.233436,0,'2013-07-06 12:44:33',NULL,NULL),(56460,'65286','S','Snyder','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.510264,-93.212915,0,'2013-07-06 12:44:33',NULL,NULL),(31534,'34488','S','Silver Springs','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.225427,-81.949001,0,'2013-07-06 12:44:32',NULL,NULL),(27595,'30294','S','Ellenwood','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.640692,-84.256263,0,'2013-07-06 12:44:31',NULL,NULL),(6101,'05452','S','Essex Jct','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(5547,'04847','S','Hope','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.256919,-69.143873,0,'2013-07-06 12:44:30',NULL,NULL),(42648,'47933','S','Crawfordsvlle','A','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.034074,-86.907942,0,'2013-07-06 12:44:32',NULL,NULL),(42564,'47874','S','Lyford','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(19509,'20171','S','Herndon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.925711,-77.403864,0,'2013-07-06 12:44:31',NULL,NULL),(79524,'98937','S','Nile','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(1509,'00754','S','Ciudad Masso','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(11877,'12306','S','Lower Rotterdam','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.792392,-73.984961,0,'2013-07-06 12:44:30',NULL,NULL),(62566,'74452','S','Peggs','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.081793,-94.980751,0,'2013-07-06 12:44:33',NULL,NULL),(16295,'17107','U','USPS Official','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.296479,-76.874607,0,'2013-07-06 12:44:31',NULL,NULL),(58457,'68726','S','Clearwater','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.089728,-98.180321,0,'2013-07-06 12:44:33',NULL,NULL),(5208,'04457','S','Lincoln Center','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(55652,'64024','S','Ex Springs','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(2700,'00969','S','Colinas Metropolitana','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(37671,'42211','S','Maggie','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(22729,'24366','S','Rocky Gap','D','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.229852,-81.195570,0,'2013-07-06 12:44:31',NULL,NULL),(4480,'03269','S','Sanbornton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.544440,-71.623113,0,'2013-07-06 12:44:30',NULL,NULL),(17327,'17862','P','Penns Creek','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.859673,-77.067203,0,'2013-07-06 12:44:31',NULL,NULL),(63844,'75975','S','Caledonia','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(77071,'96125','S','Bassetts','N','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.570300,-120.647805,0,'2013-07-06 12:44:34',NULL,NULL),(7037,'06269','U','Storrs','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.811419,-72.247553,0,'2013-07-06 12:44:30',NULL,NULL),(41596,'47107','P','Bradford','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.367030,-86.063767,0,'2013-07-06 12:44:32',NULL,NULL),(42944,'48118','S','Sylvan Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(44064,'49443','P','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.211349,-86.228675,0,'2013-07-06 12:44:32',NULL,NULL),(31156,'33915','P','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.669179,-82.003870,0,'2013-07-06 12:44:32',NULL,NULL),(67929,'80908','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.046410,-104.669910,0,'2013-07-06 12:44:34',NULL,NULL),(34543,'38704','P','Greenville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.404969,-91.038585,0,'2013-07-06 12:44:32',NULL,NULL),(38839,'44087','S','Twinsburg','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.322813,-81.453825,0,'2013-07-06 12:44:32',NULL,NULL),(45103,'50544','S','Lanyon','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.263592,-94.178232,0,'2013-07-06 12:44:32',NULL,NULL),(51055,'58741','S','Granville','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.255272,-100.782829,0,'2013-07-06 12:44:33',NULL,NULL),(37071,'41314','S','Island City','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(53880,'62349','S','Loraine','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153679,-91.205575,0,'2013-07-06 12:44:33',NULL,NULL),(55377,'63601','S','Rivermines','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(12838,'13315','S','Burlington','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.753480,-75.169620,0,'2013-07-06 12:44:30',NULL,NULL),(29856,'33037','S','Cross Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.130791,-80.410224,0,'2013-07-06 12:44:32',NULL,NULL),(69481,'83672','S','Eaton','N','Washington','16087','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.279700,-116.985420,0,'2013-07-06 12:44:34',NULL,NULL),(74497,'92625','S','Corona del Mar','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.603589,-117.861931,0,'2013-07-06 12:44:34',NULL,NULL),(74766,'93106','U','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.431306,-119.834277,0,'2013-07-06 12:44:34',NULL,NULL),(75069,'93529','S','June Lake','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.814915,-119.006993,0,'2013-07-06 12:44:34',NULL,NULL),(49380,'56594','S','Wolverton','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.544595,-96.575540,0,'2013-07-06 12:44:33',NULL,NULL),(72758,'89511','S','Steamboat','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.382155,-119.751830,0,'2013-07-06 12:44:34',NULL,NULL),(25055,'27923','S','Coinjock','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.341401,-75.937150,0,'2013-07-06 12:44:31',NULL,NULL),(23878,'26160','S','Sommerville Fork','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(39051,'44192','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.501720,-81.686437,0,'2013-07-06 12:44:32',NULL,NULL),(36701,'41017','S','Fort Mitchell','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(48197,'55397','S','Norwood Young America','A','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.803025,-93.930766,0,'2013-07-06 12:44:33',NULL,NULL),(44438,'49854','S','Thompson','A','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.009740,-86.278800,0,'2013-07-06 12:44:32',NULL,NULL),(38511,'43718','S','Belmont','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.015424,-81.015620,0,'2013-07-06 12:44:32',NULL,NULL),(29758,'33004','S','Dania','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.051174,-80.147034,0,'2013-07-06 12:44:32',NULL,NULL),(51783,'60044','S','Green Oaks','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.286331,-87.857964,0,'2013-07-06 12:44:33',NULL,NULL),(67899,'80902','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(26071,'28697','S','Goshen','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.138201,-81.157500,0,'2013-07-06 12:44:31',NULL,NULL),(36967,'41179','S','Carrs','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(20651,'21225','S','Brooklyn','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.230400,-76.617360,0,'2013-07-06 12:44:31',NULL,NULL),(57237,'66518','S','Oketo','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.961003,-96.635095,0,'2013-07-06 12:44:33',NULL,NULL),(33606,'37641','S','Chucky','N','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.151291,-82.610467,0,'2013-07-06 12:44:32',NULL,NULL),(26234,'28806','S','West Ashville','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.583509,-82.607790,0,'2013-07-06 12:44:31',NULL,NULL),(656,'00683','S','Ext Santa Maria','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(47294,'54546','S','Cosy Valley','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.324004,-90.656945,0,'2013-07-06 12:44:32',NULL,NULL),(16815,'17545','S','Mastersonville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(11563,'12062','S','Hoag Corners','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.531602,-73.502202,0,'2013-07-06 12:44:30',NULL,NULL),(74089,'92193','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.800654,-117.141627,0,'2013-07-06 12:44:34',NULL,NULL),(69568,'83823','S','Helmer','N','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.778100,-116.515320,0,'2013-07-06 12:44:34',NULL,NULL),(30307,'33302','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.036168,-80.196791,0,'2013-07-06 12:44:32',NULL,NULL),(41122,'46601','S','S Bend','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.672606,-86.251722,0,'2013-07-06 12:44:32',NULL,NULL),(30472,'33345','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.178308,-80.278398,0,'2013-07-06 12:44:32',NULL,NULL),(37046,'41268','P','West Van Lear','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.812240,-82.805599,0,'2013-07-06 12:44:32',NULL,NULL),(4977,'04109','S','Ltle Dia Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(57967,'67764','S','Russell Springs','A','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046384,-101.228293,0,'2013-07-06 12:44:33',NULL,NULL),(50901,'58544','S','Hazelton','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.481145,-100.277086,0,'2013-07-06 12:44:33',NULL,NULL),(48665,'55917','S','Blmng Prairie','A','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917900,-93.055500,0,'2013-07-06 12:44:33',NULL,NULL),(48980,'56221','S','Chokio','D','Stevens','27149','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.572737,-96.176855,0,'2013-07-06 12:44:33',NULL,NULL),(67456,'80215','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745057,-105.104454,0,'2013-07-06 12:44:34',NULL,NULL),(69073,'83241','S','Turner','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(77102,'96141','P','Homewood','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.097839,-120.169341,0,'2013-07-06 12:44:34',NULL,NULL),(78207,'97750','S','Mitchell','D','Wheeler','41069','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.546826,-120.009094,0,'2013-07-06 12:44:34',NULL,NULL),(76669,'95762','S','El Dorado Hls','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.715279,-121.078888,0,'2013-07-06 12:44:34',NULL,NULL),(66250,'78572','S','Mission','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(54224,'62650','S','Sinclair','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(7479,'06896','S','West Redding','A','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.299751,-73.405213,0,'2013-07-06 12:44:30',NULL,NULL),(68885,'82712','S','Beulah','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.559360,-104.135611,0,'2013-07-06 12:44:34',NULL,NULL),(2749,'00969','S','Urb San Ramon','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(52322,'60558','S','Western Sprgs','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.804602,-87.896988,0,'2013-07-06 12:44:33',NULL,NULL),(52351,'60607','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879410,-87.650582,0,'2013-07-06 12:44:33',NULL,NULL),(79970,'99645','S','Palmer','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.616657,-149.116091,0,'2013-07-06 12:44:34',NULL,NULL),(68004,'80921','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047737,-104.816446,0,'2013-07-06 12:44:34',NULL,NULL),(1435,'00739','S','Urb Campo Lago','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(8594,'08231','P','Oceanville','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.464796,-74.460379,0,'2013-07-06 12:44:30',NULL,NULL),(57634,'67147','S','Park City','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.841324,-97.339730,0,'2013-07-06 12:44:33',NULL,NULL),(75140,'93560','S','Willow Spgs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.863793,-118.257708,0,'2013-07-06 12:44:34',NULL,NULL),(37920,'42633','S','Stop','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(5886,'05152','S','Peru','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.111543,-73.014331,0,'2013-07-06 12:44:30',NULL,NULL),(19011,'19529','S','Eckville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(61758,'73051','S','Slaughterville','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.016330,-97.333336,0,'2013-07-06 12:44:33',NULL,NULL),(61333,'72458','S','Powhatan','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.052816,-91.149604,0,'2013-07-06 12:44:33',NULL,NULL),(17961,'18577','U','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.421090,-75.602820,0,'2013-07-06 12:44:31',NULL,NULL),(51047,'58734','S','Donnybrook','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.475200,-101.904180,0,'2013-07-06 12:44:33',NULL,NULL),(22765,'24437','S','Fort Defiance','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.217711,-78.944668,0,'2013-07-06 12:44:31',NULL,NULL),(8123,'07827','S','Branchville','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.306160,-74.748900,0,'2013-07-06 12:44:30',NULL,NULL),(21700,'22968','S','Advance Mills','A','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.218427,-78.382009,0,'2013-07-06 12:44:31',NULL,NULL),(36082,'40216','S','Shively','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.189129,-85.835133,0,'2013-07-06 12:44:32',NULL,NULL),(10444,'10916','S','Camp Bell Hall','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.437341,-74.250632,0,'2013-07-06 12:44:30',NULL,NULL),(32363,'35895','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.731405,-86.589774,0,'2013-07-06 12:44:32',NULL,NULL),(64494,'76626','S','Blooming Grv','A','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.093811,-96.720007,0,'2013-07-06 12:44:34',NULL,NULL),(6824,'06114','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.741050,-72.669085,0,'2013-07-06 12:44:30',NULL,NULL),(56002,'64645','S','Harris','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.312175,-93.345961,0,'2013-07-06 12:44:33',NULL,NULL),(50718,'58370','S','Saint Michael','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.941869,-98.905060,0,'2013-07-06 12:44:33',NULL,NULL),(6859,'06131','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688690,-72.729814,0,'2013-07-06 12:44:30',NULL,NULL),(28452,'31409','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.022510,-81.128570,0,'2013-07-06 12:44:32',NULL,NULL),(24426,'27157','U','Nc Baptist Hospital','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.059402,-80.321981,0,'2013-07-06 12:44:31',NULL,NULL),(23391,'25313','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.410380,-81.753720,0,'2013-07-06 12:44:31',NULL,NULL),(4586,'03580','S','Easton','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.228548,-71.749886,0,'2013-07-06 12:44:30',NULL,NULL),(43894,'49238','S','Deerfield','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.896662,-83.797467,0,'2013-07-06 12:44:32',NULL,NULL),(48362,'55550','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.811977,-93.921680,0,'2013-07-06 12:44:33',NULL,NULL),(49256,'56475','S','Parker','N','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.064416,-94.520309,0,'2013-07-06 12:44:33',NULL,NULL),(50472,'58042','S','Harwood','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.996140,-96.899460,0,'2013-07-06 12:44:33',NULL,NULL),(70645,'85173','S','Superior','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.280529,-111.115992,0,'2013-07-06 12:44:34',NULL,NULL),(18503,'19099','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953075,-75.161034,0,'2013-07-06 12:44:31',NULL,NULL),(62355,'74063','S','Sand Springs','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.122622,-96.150607,0,'2013-07-06 12:44:33',NULL,NULL),(41377,'46795','S','Woodruff','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(70851,'85546','S','Safford','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.809537,-109.716115,0,'2013-07-06 12:44:34',NULL,NULL),(26551,'29207','P','Fort Jackson','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.061667,-80.966102,0,'2013-07-06 12:44:31',NULL,NULL),(57206,'66434','S','Hamlin','N','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.854303,-95.534279,0,'2013-07-06 12:44:33',NULL,NULL),(66887,'79240','S','Lelia Lake','D','Donley','48129','Texas','TX','48','0000','806','Central',-6.0,'Y',34.862395,-100.678668,0,'2013-07-06 12:44:34',NULL,NULL),(2468,'00956','S','Ext Oller','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(15023,'15682','P','Schenley','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.685401,-79.662340,0,'2013-07-06 12:44:31',NULL,NULL),(14311,'14891','S','Watkins Glen','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.372716,-76.913044,0,'2013-07-06 12:44:31',NULL,NULL),(29038,'32233','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355620,-81.518460,0,'2013-07-06 12:44:32',NULL,NULL),(28894,'32128','S','Port Orange','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.130510,-81.118481,0,'2013-07-06 12:44:32',NULL,NULL),(51623,'59845','S','Hot Springs','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.594102,-114.676664,0,'2013-07-06 12:44:33',NULL,NULL),(68685,'82008','U','Unicover Corp','N','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.110745,-104.832693,0,'2013-07-06 12:44:34',NULL,NULL),(72542,'89180','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.152556,-115.107244,0,'2013-07-06 12:44:34',NULL,NULL),(37722,'42275','S','Threlkel','N','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.199181,-86.454521,0,'2013-07-06 12:44:32',NULL,NULL),(36931,'41164','S','Counts Cross Roads','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(28150,'30828','S','Reese','N','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.408859,-82.665215,0,'2013-07-06 12:44:31',NULL,NULL),(48996,'56239','S','Ghent','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.514365,-95.891974,0,'2013-07-06 12:44:33',NULL,NULL),(42352,'47654','P','Mackey','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.251669,-87.390716,0,'2013-07-06 12:44:32',NULL,NULL),(31017,'33784','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.815529,-82.679700,0,'2013-07-06 12:44:32',NULL,NULL),(31319,'34116','S','Golden Gate','N','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.182736,-81.710784,0,'2013-07-06 12:44:32',NULL,NULL),(65686,'77995','S','Petersville','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(50380,'57760','S','Hoover','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.718125,-103.420575,0,'2013-07-06 12:44:33',NULL,NULL),(44803,'50233','S','Wiscotta','N','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.551425,-94.182514,0,'2013-07-06 12:44:32',NULL,NULL),(41735,'47250','S','North Madison','N','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.755353,-85.397514,0,'2013-07-06 12:44:32',NULL,NULL),(36219,'40282','U','Pleasure Ridge Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(30587,'33418','S','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855526,-80.144330,0,'2013-07-06 12:44:32',NULL,NULL),(77034,'96103','S','Graeagle','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(35096,'39206','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364777,-90.171740,0,'2013-07-06 12:44:32',NULL,NULL),(4710,'03818','S','Conway','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.925298,-71.134643,0,'2013-07-06 12:44:30',NULL,NULL),(53362,'61764','S','Vermillion Estates','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(65021,'77315','S','North Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.929363,-95.317465,0,'2013-07-06 12:44:34',NULL,NULL),(3630,'02067','S','Sharon','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.111505,-71.179831,0,'2013-07-06 12:44:30',NULL,NULL),(62056,'73537','S','Eldorado','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.472637,-99.647878,0,'2013-07-06 12:44:33',NULL,NULL),(7070,'06338','P','Mashantucket','D','New London','09011','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.471500,-71.947304,0,'2013-07-06 12:44:30',NULL,NULL),(48411,'55599','P','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.058193,-93.658925,0,'2013-07-06 12:44:33',NULL,NULL),(45739,'52101','S','Quandahl','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(38765,'44045','P','Grand River','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.738297,-81.279247,0,'2013-07-06 12:44:32',NULL,NULL),(69567,'83823','S','Deary','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.778100,-116.515320,0,'2013-07-06 12:44:34',NULL,NULL),(71263,'86412','P','Kingman','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.503062,-113.881715,0,'2013-07-06 12:44:34',NULL,NULL),(79946,'99626','P','Lower Kalskag','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.518855,-160.354907,0,'2013-07-06 12:44:34',NULL,NULL),(2741,'00969','S','Urb Monte Olimpo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(78435,'98056','S','Hazelwood','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.512620,-122.193420,0,'2013-07-06 12:44:34',NULL,NULL),(78930,'98366','S','Parkwood','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(79335,'98616','S','Cougar','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.049921,-122.298820,0,'2013-07-06 12:44:34',NULL,NULL),(53685,'62223','S','Signal Hill','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.535955,-90.002379,0,'2013-07-06 12:44:33',NULL,NULL),(7104,'06370','S','Chesterfield','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.468520,-72.176760,0,'2013-07-06 12:44:30',NULL,NULL),(34391,'38619','S','Como','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.510320,-89.901900,0,'2013-07-06 12:44:32',NULL,NULL),(2406,'00953','S','Brisas de Montecasino','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(28735,'31909','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.534042,-84.924710,0,'2013-07-06 12:44:32',NULL,NULL),(22642,'24258','S','Hiltons','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.647452,-82.409346,0,'2013-07-06 12:44:31',NULL,NULL),(24773,'27557','S','Emit','N','Nash','37127','North Carolina','NC','37','6640','252','Eastern',-5.0,'Y',35.791243,-78.189798,0,'2013-07-06 12:44:31',NULL,NULL),(76124,'95246','S','Mtn Ranch','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.242296,-120.533316,0,'2013-07-06 12:44:34',NULL,NULL),(38048,'43044','S','Mechanicsburg','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.064517,-83.580112,0,'2013-07-06 12:44:32',NULL,NULL),(33449,'37314','P','Coker Creek','D','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.459502,-84.343618,0,'2013-07-06 12:44:32',NULL,NULL),(47566,'54840','S','Grantsburg','D','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.751715,-92.652724,0,'2013-07-06 12:44:33',NULL,NULL),(44312,'49739','U','Camp Grayling','N','Crawford','26039','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.621842,-84.784785,0,'2013-07-06 12:44:32',NULL,NULL),(42915,'48107','P','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.256407,-83.680540,0,'2013-07-06 12:44:32',NULL,NULL),(17878,'18441','S','Clifford Twp','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.665200,-75.643680,0,'2013-07-06 12:44:31',NULL,NULL),(17717,'18237','S','McAdoo','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893467,-75.999474,0,'2013-07-06 12:44:31',NULL,NULL),(33815,'37920','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.923862,-83.877198,0,'2013-07-06 12:44:32',NULL,NULL),(43851,'49104','U','Berrien Sprgs','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.945755,-86.340672,0,'2013-07-06 12:44:32',NULL,NULL),(18006,'18636','S','Monroe Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.418188,-76.075214,0,'2013-07-06 12:44:31',NULL,NULL),(34671,'38821','S','Amory','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.999660,-88.451940,0,'2013-07-06 12:44:32',NULL,NULL),(40598,'45884','P','St Johns','N','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.553727,-84.081758,0,'2013-07-06 12:44:32',NULL,NULL),(2077,'00921','S','Urb Caparra Terr','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(26986,'29622','P','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.499718,-82.660714,0,'2013-07-06 12:44:31',NULL,NULL),(42201,'47551','S','Leopold','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.100381,-86.605274,0,'2013-07-06 12:44:32',NULL,NULL),(44578,'50031','P','Beaver','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.036895,-94.105895,0,'2013-07-06 12:44:32',NULL,NULL),(61167,'72183','P','Wrightsville','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.598156,-92.216135,0,'2013-07-06 12:44:33',NULL,NULL),(66088,'78403','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.786386,-97.395977,0,'2013-07-06 12:44:34',NULL,NULL),(72450,'89109','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.124358,-115.145079,0,'2013-07-06 12:44:34',NULL,NULL),(76643,'95721','P','Echo Lake','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.914913,-120.009699,0,'2013-07-06 12:44:34',NULL,NULL),(336,'00653','S','Guanica','D','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(60312,'71455','S','Mora','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.330922,-92.883150,0,'2013-07-06 12:44:33',NULL,NULL),(53107,'61537','S','Henry','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.113512,-89.361700,0,'2013-07-06 12:44:33',NULL,NULL),(48397,'55585','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.278144,-93.808085,0,'2013-07-06 12:44:33',NULL,NULL),(39423,'44677','S','Smithville','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.870847,-81.857857,0,'2013-07-06 12:44:32',NULL,NULL),(15718,'16868','P','Pine Grv Mls','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.730879,-77.886053,0,'2013-07-06 12:44:31',NULL,NULL),(24065,'26431','S','Pine Bluff','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(22785,'24458','S','McDowell','N','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.301798,-79.524270,0,'2013-07-06 12:44:31',NULL,NULL),(15090,'15758','S','Marchand','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.874307,-79.045535,0,'2013-07-06 12:44:31',NULL,NULL),(74857,'93254','S','Cuyama','A','Santa Barbara','06083','California','CA','06','7480','661','Pacific',-8.0,'Y',34.942355,-119.664181,0,'2013-07-06 12:44:34',NULL,NULL),(58943,'69356','S','Minatare','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.853491,-103.615644,0,'2013-07-06 12:44:33',NULL,NULL),(43238,'48315','S','Utica','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.665560,-82.995885,0,'2013-07-06 12:44:32',NULL,NULL),(4783,'03867','S','Rochester','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.306503,-70.991609,0,'2013-07-06 12:44:30',NULL,NULL),(16695,'17402','S','East York','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(76361,'95492','S','Windsor','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.539164,-122.805174,0,'2013-07-06 12:44:34',NULL,NULL),(59831,'71238','S','Okaloosa','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.364300,-92.361480,0,'2013-07-06 12:44:33',NULL,NULL),(18236,'18974','S','Hartsville','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.208672,-75.079555,0,'2013-07-06 12:44:31',NULL,NULL),(77945,'97347','S','Grand Ronde','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.056652,-123.632496,0,'2013-07-06 12:44:34',NULL,NULL),(1896,'00794','S','Bda Alemania','N','Barranquitas','72019','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.187596,-66.307408,0,'2013-07-06 12:44:30',NULL,NULL),(41679,'47172','S','Sellersburg','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.392719,-85.760504,0,'2013-07-06 12:44:32',NULL,NULL),(42275,'47581','S','Windom','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(63043,'75211','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.816220,-96.888660,0,'2013-07-06 12:44:33',NULL,NULL),(70904,'85624','S','Harshaw','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.532257,-110.747116,0,'2013-07-06 12:44:34',NULL,NULL),(78559,'98155','S','Lk Forest Park','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(62326,'74044','S','Mannford','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.121473,-96.344224,0,'2013-07-06 12:44:33',NULL,NULL),(58306,'68431','S','Rulo','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.046310,-95.442036,0,'2013-07-06 12:44:33',NULL,NULL),(10501,'10964','S','Palisades','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.012718,-73.924838,0,'2013-07-06 12:44:30',NULL,NULL),(31792,'35035','S','Brierfield','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.069588,-86.928859,0,'2013-07-06 12:44:32',NULL,NULL),(33901,'38044','S','Hornsby','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.223706,-88.825077,0,'2013-07-06 12:44:32',NULL,NULL),(76797,'95945','S','Peardale','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(18132,'18826','S','Kingsley','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.769860,-75.783059,0,'2013-07-06 12:44:31',NULL,NULL),(36661,'41010','S','Blanchet','A','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.539046,-84.590182,0,'2013-07-06 12:44:32',NULL,NULL),(8284,'08016','S','Burlington','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.070260,-74.841534,0,'2013-07-06 12:44:30',NULL,NULL),(14823,'15425','S','Connellsville','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.027320,-79.588740,0,'2013-07-06 12:44:31',NULL,NULL),(29411,'32644','P','Chiefland','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.478382,-82.858338,0,'2013-07-06 12:44:32',NULL,NULL),(49459,'56650','S','Kelliher','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.957836,-94.483902,0,'2013-07-06 12:44:33',NULL,NULL),(50431,'57792','S','White Owl','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.614087,-102.426405,0,'2013-07-06 12:44:33',NULL,NULL),(55371,'63601','S','Elvins','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(59086,'70122','S','Gentilly','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.005955,-90.065104,0,'2013-07-06 12:44:33',NULL,NULL),(71491,'87105','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.043217,-106.694148,0,'2013-07-06 12:44:34',NULL,NULL),(76410,'95553','P','Miranda','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.212752,-123.842699,0,'2013-07-06 12:44:34',NULL,NULL),(77461,'96814','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.301058,-157.848253,0,'2013-07-06 12:44:34',NULL,NULL),(78313,'97910','S','Danner','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(80069,'99725','P','Ester','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.945192,-148.247520,0,'2013-07-06 12:44:34',NULL,NULL),(35721,'39669','S','Laneheart','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(58213,'68333','S','Crete','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.622672,-96.959633,0,'2013-07-06 12:44:33',NULL,NULL),(63787,'75956','S','Magnolia Spgs','A','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(33204,'37046','S','Allisona','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.772714,-86.714662,0,'2013-07-06 12:44:32',NULL,NULL),(40106,'45316','P','Clifton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.799124,-83.826339,0,'2013-07-06 12:44:32',NULL,NULL),(25183,'28052','S','South Gastonia','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(20944,'21767','S','Maugansville','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.696351,-77.746502,0,'2013-07-06 12:44:31',NULL,NULL),(29857,'33037','S','Key Largo','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.130791,-80.410224,0,'2013-07-06 12:44:32',NULL,NULL),(52328,'60563','S','Naperville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.792577,-88.165647,0,'2013-07-06 12:44:33',NULL,NULL),(56558,'65466','S','Ink','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(60926,'72084','S','Leola','D','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.219063,-92.603497,0,'2013-07-06 12:44:33',NULL,NULL),(64288,'76445','S','Desdemona','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.303279,-98.565945,0,'2013-07-06 12:44:34',NULL,NULL),(64563,'76656','S','Lott','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(77929,'97330','S','Adair Village','A','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.603787,-123.273273,0,'2013-07-06 12:44:34',NULL,NULL),(30169,'33173','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.701363,-80.360874,0,'2013-07-06 12:44:32',NULL,NULL),(30041,'33142','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.811543,-80.237681,0,'2013-07-06 12:44:32',NULL,NULL),(33004,'36660','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.674301,-88.087731,0,'2013-07-06 12:44:32',NULL,NULL),(35134,'39216','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.335115,-90.166439,0,'2013-07-06 12:44:32',NULL,NULL),(73819,'91766','S','Phillips Ranch','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.041268,-117.761339,0,'2013-07-06 12:44:34',NULL,NULL),(73908,'92011','S','Rancho La Costa','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.150800,-117.306000,0,'2013-07-06 12:44:34',NULL,NULL),(77395,'96773','P','Ninole','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.931260,-155.161510,0,'2013-07-06 12:44:34',NULL,NULL),(78278,'97865','S','Mount Vernon','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.420455,-119.113641,0,'2013-07-06 12:44:34',NULL,NULL),(38655,'43941','P','Piney Fork','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.252583,-80.813445,0,'2013-07-06 12:44:32',NULL,NULL),(20413,'20906','S','Aspen Hill','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(7197,'06478','S','Oxford','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.426687,-73.133697,0,'2013-07-06 12:44:30',NULL,NULL),(30139,'33165','S','Westchester','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729513,-80.360218,0,'2013-07-06 12:44:32',NULL,NULL),(31119,'33901','S','F M','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628428,-81.867580,0,'2013-07-06 12:44:32',NULL,NULL),(35009,'39145','S','Pelahatchie','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.327227,-89.790741,0,'2013-07-06 12:44:32',NULL,NULL),(48554,'55760','S','Turner','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(51422,'59450','S','Shonkin','A','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.628889,-110.571944,0,'2013-07-06 12:44:33',NULL,NULL),(53170,'61570','S','Wilbern','N','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.919991,-89.292237,0,'2013-07-06 12:44:33',NULL,NULL),(53273,'61723','S','Atlanta','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.261033,-89.235255,0,'2013-07-06 12:44:33',NULL,NULL),(54211,'62642','S','Sweetwater','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.081772,-89.743074,0,'2013-07-06 12:44:33',NULL,NULL),(61322,'72444','S','Maynard','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.424145,-90.898712,0,'2013-07-06 12:44:33',NULL,NULL),(64026,'76121','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.722031,-97.449860,0,'2013-07-06 12:44:34',NULL,NULL),(70446,'84744','S','Fish Lake','N','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.513397,-111.882136,0,'2013-07-06 12:44:34',NULL,NULL),(72696,'89447','S','Weed Heights','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.921460,-119.117640,0,'2013-07-06 12:44:34',NULL,NULL),(31466,'34289','S','No Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.052555,-82.197321,0,'2013-07-06 12:44:32',NULL,NULL),(18361,'19038','S','Laverock','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(55924,'64463','S','King City','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.050966,-94.519029,0,'2013-07-06 12:44:33',NULL,NULL),(34722,'38843','S','Dorsey','N','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.269865,-88.403996,0,'2013-07-06 12:44:32',NULL,NULL),(36731,'41031','S','Ruddels Mills','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(15904,'17013','S','Carlisle','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.203056,-77.313611,0,'2013-07-06 12:44:31',NULL,NULL),(17763,'18330','S','Effort','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.982020,-75.453034,0,'2013-07-06 12:44:31',NULL,NULL),(29386,'32612','U','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.652878,-82.351153,0,'2013-07-06 12:44:32',NULL,NULL),(46404,'53170','S','Silver Lake','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.550510,-88.168709,0,'2013-07-06 12:44:32',NULL,NULL),(51267,'59101','S','Lockwood','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.774634,-108.479727,0,'2013-07-06 12:44:33',NULL,NULL),(53577,'62060','S','Madison','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.686572,-90.153079,0,'2013-07-06 12:44:33',NULL,NULL),(53601,'62077','P','Panama','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.050000,-89.533333,0,'2013-07-06 12:44:33',NULL,NULL),(55523,'63821','S','Arbyrd','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.079265,-90.204869,0,'2013-07-06 12:44:33',NULL,NULL),(55810,'64144','U','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.143477,-94.571588,0,'2013-07-06 12:44:33',NULL,NULL),(56172,'64999','U','Internal Revenue Service','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.953479,-94.549666,0,'2013-07-06 12:44:33',NULL,NULL),(56809,'65773','S','Wasola','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.745108,-92.521187,0,'2013-07-06 12:44:33',NULL,NULL),(59293,'70503','S','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.189233,-92.044087,0,'2013-07-06 12:44:33',NULL,NULL),(60306,'71454','S','Shell Point','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(64223,'76301','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.911774,-98.498600,0,'2013-07-06 12:44:34',NULL,NULL),(65972,'78293','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425368,-98.486732,0,'2013-07-06 12:44:34',NULL,NULL),(67780,'80652','S','Roggen','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.115915,-104.314832,0,'2013-07-06 12:44:34',NULL,NULL),(69815,'84074','S','Erda','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(79662,'99154','S','Mohler','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.402809,-118.329726,0,'2013-07-06 12:44:34',NULL,NULL),(38009,'43001','S','Alexandria','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.092467,-82.608341,0,'2013-07-06 12:44:32',NULL,NULL),(62479,'74346','S','Jay','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.418698,-94.795826,0,'2013-07-06 12:44:33',NULL,NULL),(17262,'17842','S','Kissimmee','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(43493,'48619','S','Comins','D','Oscoda','26135','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.803567,-84.037996,0,'2013-07-06 12:44:32',NULL,NULL),(67110,'79730','P','Coyanosa','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',31.199049,-103.064347,0,'2013-07-06 12:44:34',NULL,NULL),(75884,'94956','S','Pt Reyes Sta','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.063493,-122.809164,0,'2013-07-06 12:44:34',NULL,NULL),(29527,'32781','P','Titusville','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.535305,-80.812429,0,'2013-07-06 12:44:32',NULL,NULL),(55750,'64106','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.103459,-94.569988,0,'2013-07-06 12:44:33',NULL,NULL),(9712,'10080','U','Merrill Lynch','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(61713,'73009','S','Binger','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.311026,-98.347123,0,'2013-07-06 12:44:33',NULL,NULL),(36665,'41011','S','Covington','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(3864,'02356','S','North Easton','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.057491,-71.115498,0,'2013-07-06 12:44:30',NULL,NULL),(5727,'05031','P','Barnard','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.726037,-72.618887,0,'2013-07-06 12:44:30',NULL,NULL),(7621,'07058','S','Pinebrook','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.871765,-74.347469,0,'2013-07-06 12:44:30',NULL,NULL),(43080,'48201','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.346393,-83.061020,0,'2013-07-06 12:44:32',NULL,NULL),(78037,'97436','S','Elkton','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.638237,-123.592008,0,'2013-07-06 12:44:34',NULL,NULL),(62488,'74355','P','Maimi','N','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.890711,-94.876486,0,'2013-07-06 12:44:33',NULL,NULL),(2945,'01031','S','Gilbertville','D','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.334260,-72.176040,0,'2013-07-06 12:44:30',NULL,NULL),(5390,'04649','S','Jonesport','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.574423,-67.601698,0,'2013-07-06 12:44:30',NULL,NULL),(5932,'05254','P','Manchester','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.162851,-73.070330,0,'2013-07-06 12:44:30',NULL,NULL),(5415,'04666','S','Pembroke','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.953808,-67.162264,0,'2013-07-06 12:44:30',NULL,NULL),(45042,'50478','S','Thompson','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.368530,-93.771293,0,'2013-07-06 12:44:32',NULL,NULL),(40584,'45874','S','Oh City','N','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.774564,-84.633321,0,'2013-07-06 12:44:32',NULL,NULL),(7516,'07003','S','Bloomfield','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.805311,-74.187412,0,'2013-07-06 12:44:30',NULL,NULL),(17644,'18069','S','Orefield','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.618409,-75.594982,0,'2013-07-06 12:44:31',NULL,NULL),(37692,'42240','S','Hopkinsville','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.868139,-87.479532,0,'2013-07-06 12:44:32',NULL,NULL),(7615,'07054','S','Troy Hills','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.859388,-74.413425,0,'2013-07-06 12:44:30',NULL,NULL),(33696,'37756','S','Norma','N','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.395880,-84.459240,0,'2013-07-06 12:44:32',NULL,NULL),(21605,'22901','S','Charlottesville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.057163,-78.493130,0,'2013-07-06 12:44:31',NULL,NULL),(51165,'59002','S','Acton','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.924789,-108.695498,0,'2013-07-06 12:44:33',NULL,NULL),(17848,'18426','S','Greentown','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.366597,-75.248592,0,'2013-07-06 12:44:31',NULL,NULL),(19772,'20421','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906309,-77.031251,0,'2013-07-06 12:44:31',NULL,NULL),(20312,'20817','S','Westlake','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.997996,-77.146318,0,'2013-07-06 12:44:31',NULL,NULL),(34275,'38474','S','Mount Pleasant','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.536870,-87.207199,0,'2013-07-06 12:44:32',NULL,NULL),(29650,'32904','S','Melbourne Vlg','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074548,-80.694237,0,'2013-07-06 12:44:32',NULL,NULL),(59767,'71171','P','Bossier City','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.513854,-93.731075,0,'2013-07-06 12:44:33',NULL,NULL),(67063,'79565','S','Westbrook','D','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.359444,-101.013905,0,'2013-07-06 12:44:34',NULL,NULL),(49170,'56399','U','Fulfillment Distribution Ctr','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.549763,-94.227348,0,'2013-07-06 12:44:33',NULL,NULL),(46184,'52738','S','Gladwin','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(42906,'48103','S','Scio Township','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.270780,-83.808660,0,'2013-07-06 12:44:32',NULL,NULL),(14358,'15020','P','Bunola','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.239015,-79.953531,0,'2013-07-06 12:44:31',NULL,NULL),(18765,'19352','S','NewLondon TWP','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.769645,-75.890630,0,'2013-07-06 12:44:31',NULL,NULL),(36431,'40581','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.139148,-84.475535,0,'2013-07-06 12:44:32',NULL,NULL),(18823,'19409','P','Fairview Village','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.121389,-75.340278,0,'2013-07-06 12:44:31',NULL,NULL),(21880,'23170','P','Trevilians','D','Louisa','51109','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.053742,-78.072476,0,'2013-07-06 12:44:31',NULL,NULL),(64423,'76554','S','Ltl Rvr Acad','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.988620,-97.365780,0,'2013-07-06 12:44:34',NULL,NULL),(69282,'83441','U','Rexcraft','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.762902,-111.609618,0,'2013-07-06 12:44:34',NULL,NULL),(70299,'84536','P','Monument Vly','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.154424,-110.741712,0,'2013-07-06 12:44:34',NULL,NULL),(73420,'91189','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.124070,-118.164542,0,'2013-07-06 12:44:34',NULL,NULL),(60857,'72048','S','Ethel','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.193665,-91.132556,0,'2013-07-06 12:44:33',NULL,NULL),(33144,'36916','S','Pennington','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.246209,-88.080810,0,'2013-07-06 12:44:32',NULL,NULL),(30858,'33660','U','Time Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.931147,-82.375898,0,'2013-07-06 12:44:32',NULL,NULL),(26109,'28723','S','Erastus','N','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.284272,-83.179192,0,'2013-07-06 12:44:31',NULL,NULL),(14601,'15224','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465933,-79.946627,0,'2013-07-06 12:44:31',NULL,NULL),(25262,'28123','P','Mooresville','A','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.543985,-80.846555,0,'2013-07-06 12:44:31',NULL,NULL),(23566,'25647','P','Switzer','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.785601,-81.977736,0,'2013-07-06 12:44:31',NULL,NULL),(12834,'13312','P','Brantingham','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.685598,-75.289871,0,'2013-07-06 12:44:30',NULL,NULL),(41827,'47340','S','Maxville','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.181057,-85.113281,0,'2013-07-06 12:44:32',NULL,NULL),(47165,'54473','S','Rosholt','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.630777,-89.318589,0,'2013-07-06 12:44:32',NULL,NULL),(55083,'63197','U','Courtesy Reply Mail Firms','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.626874,-90.201876,0,'2013-07-06 12:44:33',NULL,NULL),(64157,'76207','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.237391,-97.180102,0,'2013-07-06 12:44:34',NULL,NULL),(70229,'84404','S','North Ogden','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(71678,'87510','S','Abiquiu','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.154780,-106.234086,0,'2013-07-06 12:44:34',NULL,NULL),(74310,'92385','P','Skyforest','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.232939,-117.184281,0,'2013-07-06 12:44:34',NULL,NULL),(76182,'95335','S','Long Barn','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.212980,-120.039480,0,'2013-07-06 12:44:34',NULL,NULL),(76733,'95901','S','Marysville','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.215400,-121.463340,0,'2013-07-06 12:44:34',NULL,NULL),(1485,'00751','S','Bo Playita','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(61912,'73146','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.494268,-97.530684,0,'2013-07-06 12:44:33',NULL,NULL),(16338,'17128','U','Department of Revenue','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263931,-76.883400,0,'2013-07-06 12:44:31',NULL,NULL),(15279,'16116','S','Edinburg','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.038058,-80.485481,0,'2013-07-06 12:44:31',NULL,NULL),(8203,'07934','S','Gladstone','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.720951,-74.669067,0,'2013-07-06 12:44:30',NULL,NULL),(36826,'41071','S','Fort Thomas','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(72070,'88123','S','Portales','A','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652386,-103.141603,0,'2013-07-06 12:44:34',NULL,NULL),(73274,'90733','P','San Pedro','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.706639,-118.290674,0,'2013-07-06 12:44:34',NULL,NULL),(13554,'13833','S','Port Crane','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.200520,-75.773460,0,'2013-07-06 12:44:31',NULL,NULL),(18822,'19408','P','Norristown','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.154128,-75.414151,0,'2013-07-06 12:44:31',NULL,NULL),(31862,'35120','S','Branchville','A','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.668856,-86.429644,0,'2013-07-06 12:44:32',NULL,NULL),(21324,'22407','S','Fredericksbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(23495,'25521','S','Griffithsville','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.246530,-81.989476,0,'2013-07-06 12:44:31',NULL,NULL),(41316,'46773','S','Townley','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(42610,'47885','S','Whitcomb Heights','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(42820,'48060','S','Port Huron','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.986100,-82.467480,0,'2013-07-06 12:44:32',NULL,NULL),(45574,'51530','S','Earling','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.772993,-95.417996,0,'2013-07-06 12:44:32',NULL,NULL),(58776,'68971','S','Repub City','A','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.100098,-99.231767,0,'2013-07-06 12:44:33',NULL,NULL),(58976,'70041','S','Buras','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.352900,-89.502060,0,'2013-07-06 12:44:33',NULL,NULL),(70086,'84157','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.660687,-111.884858,0,'2013-07-06 12:44:34',NULL,NULL),(72348,'89018','P','Indian Springs','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570550,-115.669994,0,'2013-07-06 12:44:34',NULL,NULL),(56867,'66015','S','Colony','D','Anderson','20003','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.072175,-95.363939,0,'2013-07-06 12:44:33',NULL,NULL),(39406,'44663','S','New Phila','A','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.486040,-81.442532,0,'2013-07-06 12:44:32',NULL,NULL),(15326,'16211','P','Beyer','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.784514,-79.203666,0,'2013-07-06 12:44:31',NULL,NULL),(71276,'86434','S','Grand Canyon Caverns','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.574300,-113.492100,0,'2013-07-06 12:44:34',NULL,NULL),(66630,'78802','P','Uvalde','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.210020,-99.788699,0,'2013-07-06 12:44:34',NULL,NULL),(4180,'02814','S','Chepachet','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.898850,-71.681285,0,'2013-07-06 12:44:30',NULL,NULL),(16156,'17062','S','Donnally Mill','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(23293,'25177','S','Jefferson','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.381638,-81.823224,0,'2013-07-06 12:44:31',NULL,NULL),(46495,'53227','S','Greenfield','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994705,-88.042267,0,'2013-07-06 12:44:32',NULL,NULL),(48555,'55763','S','Colvin','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.336731,-92.257473,0,'2013-07-06 12:44:33',NULL,NULL),(48568,'55768','S','Parkville','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.530445,-92.581327,0,'2013-07-06 12:44:33',NULL,NULL),(66666,'78877','S','Spofford','A','Maverick','48323','Texas','TX','48','0000','830','Central',-6.0,'Y',28.927200,-100.426200,0,'2013-07-06 12:44:34',NULL,NULL),(68166,'81007','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.346600,-104.788860,0,'2013-07-06 12:44:34',NULL,NULL),(70765,'85336','P','Gadsden','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.551578,-114.772541,0,'2013-07-06 12:44:34',NULL,NULL),(61438,'72584','S','Violet Hill','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.157784,-91.851420,0,'2013-07-06 12:44:33',NULL,NULL),(56038,'64689','S','Winston','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.871939,-94.138417,0,'2013-07-06 12:44:33',NULL,NULL),(34253,'38449','S','Ardmore','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.080509,-86.889332,0,'2013-07-06 12:44:32',NULL,NULL),(17409,'17901','S','Wadesville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(30137,'33165','S','Olympia Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729513,-80.360218,0,'2013-07-06 12:44:32',NULL,NULL),(33824,'37923','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.924565,-84.100399,0,'2013-07-06 12:44:32',NULL,NULL),(72290,'88571','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767204,-106.333301,0,'2013-07-06 12:44:34',NULL,NULL),(73139,'90275','S','Palos Verdes Estates','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(11762,'12197','S','Decatur','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.517778,-74.750278,0,'2013-07-06 12:44:30',NULL,NULL),(61434,'72581','S','Tumbling Shls','A','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.549597,-91.952473,0,'2013-07-06 12:44:33',NULL,NULL),(34713,'38834','S','Kossuth','A','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(14723,'15279','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465513,-80.038303,0,'2013-07-06 12:44:31',NULL,NULL),(26647,'29351','S','Joanna','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.409867,-81.817504,0,'2013-07-06 12:44:31',NULL,NULL),(363,'00659','S','Parc Santa Rosa','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(10104,'10249','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(63071,'75237','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.669182,-96.875904,0,'2013-07-06 12:44:33',NULL,NULL),(959,'00716','S','Sect Playita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(60392,'71612','P','Pine Bluff','A','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.228866,-92.000890,0,'2013-07-06 12:44:33',NULL,NULL),(61728,'73021','S','Colony','D','Washita','40149','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.336110,-98.673629,0,'2013-07-06 12:44:33',NULL,NULL),(50486,'58051','S','Kindred','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.650631,-97.014151,0,'2013-07-06 12:44:33',NULL,NULL),(1973,'00901','S','Old San Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.463862,-66.109811,0,'2013-07-06 12:44:30',NULL,NULL),(42868,'48082','S','Saint Clair Shores','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.529366,-82.887803,0,'2013-07-06 12:44:32',NULL,NULL),(72289,'88570','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769943,-106.332058,0,'2013-07-06 12:44:34',NULL,NULL),(749,'00692','S','Est San Nicolas','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(37111,'41368','P','Saint Helens','D','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.579332,-83.644057,0,'2013-07-06 12:44:32',NULL,NULL),(34884,'38944','S','Somerville','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.696389,-90.295000,0,'2013-07-06 12:44:32',NULL,NULL),(18564,'19123','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963063,-75.149978,0,'2013-07-06 12:44:31',NULL,NULL),(29891,'33042','S','Upper Sugarloaf Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(17141,'17801','S','Island Park','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(15524,'16541','U','Gannon University','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.124753,-80.089452,0,'2013-07-06 12:44:31',NULL,NULL),(7053,'06282','S','Woodstock Vly','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.930860,-72.104123,0,'2013-07-06 12:44:30',NULL,NULL),(9152,'09308','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(41578,'47038','S','Patriot','D','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.835094,-84.844731,0,'2013-07-06 12:44:32',NULL,NULL),(47048,'54411','S','Weurtsburg','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.034525,-90.084577,0,'2013-07-06 12:44:32',NULL,NULL),(51017,'58705','S','Minot AFB','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230700,-101.307900,0,'2013-07-06 12:44:33',NULL,NULL),(56778,'65746','S','Seymour','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.147408,-92.767863,0,'2013-07-06 12:44:33',NULL,NULL),(65614,'77954','S','Concrete','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(63895,'76019','U','Univ TX At Arlington','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.728201,-97.112604,0,'2013-07-06 12:44:34',NULL,NULL),(76126,'95246','S','Sheepranch','N','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.242296,-120.533316,0,'2013-07-06 12:44:34',NULL,NULL),(80137,'99776','P','Tok','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.354709,-143.360570,0,'2013-07-06 12:44:34',NULL,NULL),(39209,'44401','S','Berlin Center','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.035720,-80.951296,0,'2013-07-06 12:44:32',NULL,NULL),(32483,'36048','S','Louisville','D','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.780682,-85.554586,0,'2013-07-06 12:44:32',NULL,NULL),(32174,'35480','S','Ralph','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.054468,-87.770735,0,'2013-07-06 12:44:32',NULL,NULL),(46832,'54015','S','Pleasant Valley','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.964112,-92.465156,0,'2013-07-06 12:44:32',NULL,NULL),(16391,'17213','S','Tell','N','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(65157,'77399','U','Escapees','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.713086,-94.935409,0,'2013-07-06 12:44:34',NULL,NULL),(51993,'60160','S','Melrose Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.901365,-87.860604,0,'2013-07-06 12:44:33',NULL,NULL),(36070,'40208','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.218692,-85.766333,0,'2013-07-06 12:44:32',NULL,NULL),(51533,'59719','P','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.678181,-111.036579,0,'2013-07-06 12:44:33',NULL,NULL),(30503,'33402','P','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.717231,-80.051556,0,'2013-07-06 12:44:32',NULL,NULL),(28149,'30828','S','Norris','N','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.408859,-82.665215,0,'2013-07-06 12:44:31',NULL,NULL),(46037,'52556','S','Salina','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(62126,'73661','S','Rocky','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.158120,-99.059953,0,'2013-07-06 12:44:33',NULL,NULL),(5356,'04619','S','Calais','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182779,-67.280905,0,'2013-07-06 12:44:30',NULL,NULL),(7980,'07711','S','W Allenhurst','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235381,-74.005003,0,'2013-07-06 12:44:30',NULL,NULL),(33669,'37727','S','Del Rio','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.885054,-83.001681,0,'2013-07-06 12:44:32',NULL,NULL),(28959,'32201','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.275611,-81.764254,0,'2013-07-06 12:44:32',NULL,NULL),(11636,'12122','S','Breakabeen','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540360,-74.270820,0,'2013-07-06 12:44:30',NULL,NULL),(23419,'25339','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351127,-81.629133,0,'2013-07-06 12:44:31',NULL,NULL),(42481,'47837','S','Perth','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.576608,-87.056532,0,'2013-07-06 12:44:32',NULL,NULL),(45732,'52101','S','Bluffton','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(78472,'98083','P','Kirkland','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.682571,-122.191069,0,'2013-07-06 12:44:34',NULL,NULL),(39725,'45056','S','Oxford','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(35074,'39201','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.292867,-90.184187,0,'2013-07-06 12:44:32',NULL,NULL),(10094,'10213','U','Canal Street','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.718440,-74.006344,0,'2013-07-06 12:44:30',NULL,NULL),(65701,'78010','S','Camp Verde','A','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',29.935620,-99.010020,0,'2013-07-06 12:44:34',NULL,NULL),(71253,'86404','S','Lk Havasu Cty','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.518339,-114.324094,0,'2013-07-06 12:44:34',NULL,NULL),(15119,'15801','S','Dubois','A','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.124856,-78.763496,0,'2013-07-06 12:44:31',NULL,NULL),(1796,'00783','S','Urb Maria del Carmen','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(34602,'38748','S','Hollandale','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(68537,'81415','S','Maher','A','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.710743,-107.615416,0,'2013-07-06 12:44:34',NULL,NULL),(24228,'26726','S','Scherr','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.437003,-78.981107,0,'2013-07-06 12:44:31',NULL,NULL),(4268,'02883','P','S Kingstown','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.451648,-71.501278,0,'2013-07-06 12:44:30',NULL,NULL),(9036,'08876','S','Somerville','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.543740,-74.660040,0,'2013-07-06 12:44:30',NULL,NULL),(10915,'11429','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.711559,-73.742091,0,'2013-07-06 12:44:30',NULL,NULL),(19169,'19726','U','Shared Firm Zip','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.684577,-75.735242,0,'2013-07-06 12:44:31',NULL,NULL),(24937,'27819','P','Conetoe','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.818553,-77.457634,0,'2013-07-06 12:44:31',NULL,NULL),(45648,'52001','S','Center Grove','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(46337,'53089','S','Lisbon','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.153034,-88.234855,0,'2013-07-06 12:44:32',NULL,NULL),(48264,'55428','S','Crystal','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(51116,'58787','S','Tolley','D','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.819983,-101.869920,0,'2013-07-06 12:44:33',NULL,NULL),(59072,'70113','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.943595,-90.083150,0,'2013-07-06 12:44:33',NULL,NULL),(62363,'74067','P','Supulpa','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.986469,-96.117351,0,'2013-07-06 12:44:33',NULL,NULL),(65051,'77337','P','Tomball','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.122113,-95.593231,0,'2013-07-06 12:44:34',NULL,NULL),(66926,'79343','S','Lorenzo','D','Crosby','48107','Texas','TX','48','0000','806','Central',-6.0,'Y',33.673352,-101.537127,0,'2013-07-06 12:44:34',NULL,NULL),(70380,'84660','S','Leland','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(37813,'42409','S','Dixon','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.525276,-87.680465,0,'2013-07-06 12:44:32',NULL,NULL),(35919,'40031','S','Lagrange','A','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.406748,-85.388667,0,'2013-07-06 12:44:32',NULL,NULL),(67437,'80201','P','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.695496,-105.084115,0,'2013-07-06 12:44:34',NULL,NULL),(35523,'39535','P','BLX','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.415255,-88.930352,0,'2013-07-06 12:44:32',NULL,NULL),(9009,'08861','S','Hopelawn','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.519012,-74.276120,0,'2013-07-06 12:44:30',NULL,NULL),(54220,'62650','S','Literberry','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(45372,'51012','S','Cherokee','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.749686,-95.554902,0,'2013-07-06 12:44:32',NULL,NULL),(72388,'89040','S','Moapa Valley','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(56084,'64766','P','Lamar','A','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.586167,-94.155511,0,'2013-07-06 12:44:33',NULL,NULL),(15957,'17025','S','W Fairview','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(32848,'36502','S','Canoe','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.021667,-87.484959,0,'2013-07-06 12:44:32',NULL,NULL),(29013,'32226','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.466832,-81.547848,0,'2013-07-06 12:44:32',NULL,NULL),(22675,'24311','S','Atkins','D','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.855788,-81.388130,0,'2013-07-06 12:44:31',NULL,NULL),(20726,'21285','P','Towson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.407938,-76.597911,0,'2013-07-06 12:44:31',NULL,NULL),(48285,'55434','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.167369,-93.248268,0,'2013-07-06 12:44:33',NULL,NULL),(67673,'80501','S','Longmont','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.166839,-105.134916,0,'2013-07-06 12:44:34',NULL,NULL),(74062,'92163','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.747287,-117.171093,0,'2013-07-06 12:44:34',NULL,NULL),(75030,'93510','S','Acton','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.489202,-118.197221,0,'2013-07-06 12:44:34',NULL,NULL),(11948,'12443','S','Hurley','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.924537,-74.067379,0,'2013-07-06 12:44:30',NULL,NULL),(14149,'14715','S','Bolivar','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.075166,-78.157392,0,'2013-07-06 12:44:31',NULL,NULL),(53798,'62286','S','Houston','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.151540,-89.723160,0,'2013-07-06 12:44:33',NULL,NULL),(46894,'54121','S','Florence','D','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.921716,-88.250804,0,'2013-07-06 12:44:32',NULL,NULL),(77040,'96107','S','Walker','N','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.478060,-119.477040,0,'2013-07-06 12:44:34',NULL,NULL),(28993,'32217','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.237412,-81.617619,0,'2013-07-06 12:44:32',NULL,NULL),(7521,'07005','S','Boonton','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(74627,'92805','S','Federal','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.835916,-117.908583,0,'2013-07-06 12:44:34',NULL,NULL),(32485,'36049','S','Patsburg','N','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.713452,-86.263994,0,'2013-07-06 12:44:32',NULL,NULL),(31745,'34987','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308771,-80.453062,0,'2013-07-06 12:44:32',NULL,NULL),(15330,'16217','S','Cooksburg','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.337377,-79.188795,0,'2013-07-06 12:44:31',NULL,NULL),(47181,'54481','S','Linwood','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(78308,'97907','S','Lime','N','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.347926,-117.262318,0,'2013-07-06 12:44:34',NULL,NULL),(37066,'41311','S','Vada','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(42437,'47805','S','Cemar Estates','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(15178,'15935','S','Hollsopple','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.203772,-78.924453,0,'2013-07-06 12:44:31',NULL,NULL),(30149,'33167','S','North Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885455,-80.228537,0,'2013-07-06 12:44:32',NULL,NULL),(64313,'76471','S','Rising Star','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.096400,-98.965407,0,'2013-07-06 12:44:34',NULL,NULL),(47879,'55089','S','Vasa','N','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.619771,-92.651690,0,'2013-07-06 12:44:33',NULL,NULL),(5819,'05074','P','Thetford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.819172,-72.228251,0,'2013-07-06 12:44:30',NULL,NULL),(11790,'12214','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.686317,-73.846929,0,'2013-07-06 12:44:30',NULL,NULL),(6855,'06129','P','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.708586,-72.659766,0,'2013-07-06 12:44:30',NULL,NULL),(40905,'46256','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.901691,-86.015662,0,'2013-07-06 12:44:32',NULL,NULL),(23262,'25133','S','Maysel','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.483821,-81.127172,0,'2013-07-06 12:44:31',NULL,NULL),(26405,'29111','S','Workman','N','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.780339,-80.018183,0,'2013-07-06 12:44:31',NULL,NULL),(41624,'47129','S','Jeff','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.316146,-85.769135,0,'2013-07-06 12:44:32',NULL,NULL),(59429,'70664','P','Sulphur','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.260305,-93.372461,0,'2013-07-06 12:44:33',NULL,NULL),(76025,'95136','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.268106,-121.844685,0,'2013-07-06 12:44:34',NULL,NULL),(40687,'46068','S','Nevada','N','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.380698,-86.088622,0,'2013-07-06 12:44:32',NULL,NULL),(60302,'71454','S','New Verda','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(39599,'44874','P','Clear Creek','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.966349,-82.366717,0,'2013-07-06 12:44:32',NULL,NULL),(11031,'11566','S','North Merrick','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685085,-73.560710,0,'2013-07-06 12:44:30',NULL,NULL),(31898,'35144','P','Elliotsville','N','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.200000,-86.783333,0,'2013-07-06 12:44:32',NULL,NULL),(24337,'27030','S','Round Peak','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490645,-80.628907,0,'2013-07-06 12:44:31',NULL,NULL),(38715,'44022','S','Bentleyville','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(4892,'04047','S','Parsonsfield','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.802761,-70.891033,0,'2013-07-06 12:44:30',NULL,NULL),(25838,'28621','S','Elkin','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.315720,-80.816160,0,'2013-07-06 12:44:31',NULL,NULL),(9299,'09709','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(65025,'77320','S','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.819130,-95.578507,0,'2013-07-06 12:44:34',NULL,NULL),(70978,'85704','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.328180,-110.986080,0,'2013-07-06 12:44:34',NULL,NULL),(2733,'00969','S','Urb Highland Gdns','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(39947,'45231','S','Mount Healthy','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.244265,-84.540628,0,'2013-07-06 12:44:32',NULL,NULL),(31531,'34484','S','Oxford','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.923120,-82.043905,0,'2013-07-06 12:44:32',NULL,NULL),(25612,'28458','S','Rose Hill','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.825637,-78.025004,0,'2013-07-06 12:44:31',NULL,NULL),(24932,'27815','U','QVC','N','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.935230,-77.775237,0,'2013-07-06 12:44:31',NULL,NULL),(12147,'12736','S','Fremont','N','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.848718,-75.024350,0,'2013-07-06 12:44:30',NULL,NULL),(1146,'00727','S','Est Degetau','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(11467,'12015','S','Athens','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.262647,-73.810372,0,'2013-07-06 12:44:30',NULL,NULL),(51219,'59053','S','Lennep','N','Meagher','30059','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.416111,-110.542500,0,'2013-07-06 12:44:33',NULL,NULL),(10640,'11055','U','Publishers Clearing House','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.840893,-73.704913,0,'2013-07-06 12:44:30',NULL,NULL),(7558,'07018','S','VA Hospital','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.754785,-74.218897,0,'2013-07-06 12:44:30',NULL,NULL),(41858,'47355','S','Arba','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(39107,'44242','U','Kent','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.146742,-81.362684,0,'2013-07-06 12:44:32',NULL,NULL),(78756,'98296','S','Snohomish','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.822897,-122.118251,0,'2013-07-06 12:44:34',NULL,NULL),(74042,'92143','P','San Ysidro','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.567534,-116.974021,0,'2013-07-06 12:44:34',NULL,NULL),(29853,'33036','S','Upper Matecumbe Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(49175,'56401','S','East Gull Lake','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341720,-94.142280,0,'2013-07-06 12:44:33',NULL,NULL),(33301,'37131','U','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.853243,-86.396024,0,'2013-07-06 12:44:32',NULL,NULL),(1875,'00791','S','Urb Los Sauces','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(35194,'39286','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.350653,-90.176499,0,'2013-07-06 12:44:32',NULL,NULL),(46162,'52729','S','Calamus','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.828564,-90.756519,0,'2013-07-06 12:44:32',NULL,NULL),(79648,'99144','S','Lamona','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.356543,-118.481045,0,'2013-07-06 12:44:34',NULL,NULL),(51233,'59065','S','Wan I Gan','N','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.437484,-110.684001,0,'2013-07-06 12:44:33',NULL,NULL),(31391,'34221','S','Palmetto','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.538108,-82.552860,0,'2013-07-06 12:44:32',NULL,NULL),(32094,'35294','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.510109,-86.807875,0,'2013-07-06 12:44:32',NULL,NULL),(25847,'28623','S','Saddle','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.529320,-80.969220,0,'2013-07-06 12:44:31',NULL,NULL),(68673,'81658','P','Vail','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.621866,-106.500236,0,'2013-07-06 12:44:34',NULL,NULL),(25052,'27920','P','Cape Hatteras Naval Facility','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.265883,-75.528710,0,'2013-07-06 12:44:31',NULL,NULL),(62472,'74340','P','Disney','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.480968,-95.017109,0,'2013-07-06 12:44:33',NULL,NULL),(42241,'47568','S','Cornettsville','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.777115,-87.180839,0,'2013-07-06 12:44:32',NULL,NULL),(24063,'26431','S','Owings','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(5012,'04227','P','East Dixfield','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.595169,-70.303575,0,'2013-07-06 12:44:30',NULL,NULL),(34646,'38769','S','Symonds','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.846420,-91.001880,0,'2013-07-06 12:44:32',NULL,NULL),(68947,'82938','P','Green River','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.027778,-109.935278,0,'2013-07-06 12:44:34',NULL,NULL),(65571,'77855','P','Flynn','D','Leon','48289','Texas','TX','48','0000','936','Central',-6.0,'Y',31.149791,-96.124432,0,'2013-07-06 12:44:34',NULL,NULL),(2265,'00926','S','Urb Riberas Del Senorial','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(63674,'75858','P','Ratcliff','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.392189,-95.142575,0,'2013-07-06 12:44:34',NULL,NULL),(40339,'45613','S','Beaver','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.028231,-82.860447,0,'2013-07-06 12:44:32',NULL,NULL),(6435,'05746','P','Gaysville','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.734541,-72.743050,0,'2013-07-06 12:44:30',NULL,NULL),(18343,'19032','S','Folcroft','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.894926,-75.279274,0,'2013-07-06 12:44:31',NULL,NULL),(8148,'07846','P','Johnsonburg','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.966061,-74.874409,0,'2013-07-06 12:44:30',NULL,NULL),(27646,'30319','S','Sandy Spgs','A','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.875460,-84.333398,0,'2013-07-06 12:44:31',NULL,NULL),(48670,'55918','S','Red Rock','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.731405,-92.872054,0,'2013-07-06 12:44:33',NULL,NULL),(20034,'20639','S','Huntingtown','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.606230,-76.599274,0,'2013-07-06 12:44:31',NULL,NULL),(77005,'96084','P','Round Mountain','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.774706,-121.988586,0,'2013-07-06 12:44:34',NULL,NULL),(59588,'71006','S','Ivan','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.679257,-93.707187,0,'2013-07-06 12:44:33',NULL,NULL),(44301,'49734','P','Gaylord','D','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.026069,-84.673010,0,'2013-07-06 12:44:32',NULL,NULL),(78507,'98114','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.580063,-122.312552,0,'2013-07-06 12:44:34',NULL,NULL),(43170,'48272','U','Remittance Contest','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.336958,-83.054444,0,'2013-07-06 12:44:32',NULL,NULL),(12098,'12571','S','Red Hook','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.008880,-73.840140,0,'2013-07-06 12:44:30',NULL,NULL),(79492,'98902','S','West Side','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(61422,'72568','S','Pleasant Plains','D','Independence','05063','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.564579,-91.626652,0,'2013-07-06 12:44:33',NULL,NULL),(35001,'39119','S','Mount Olive','D','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.720647,-89.680754,0,'2013-07-06 12:44:32',NULL,NULL),(10244,'10468','S','Jerome','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868013,-73.896417,0,'2013-07-06 12:44:30',NULL,NULL),(64021,'76119','S','Forest Hill','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.680500,-97.264980,0,'2013-07-06 12:44:34',NULL,NULL),(13113,'13485','S','West Edmeston','D','Madison','36053','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.787840,-75.318973,0,'2013-07-06 12:44:30',NULL,NULL),(2516,'00957','S','Urb Panorama','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(8731,'08512','S','East Windsor','A','Middlesex','34023','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.311180,-74.525160,0,'2013-07-06 12:44:30',NULL,NULL),(59841,'71247','P','Hodge','D','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.278002,-92.712240,0,'2013-07-06 12:44:33',NULL,NULL),(16207,'17070','S','Rudytown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(14875,'15470','S','Ohiopyle','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.830011,-79.447971,0,'2013-07-06 12:44:31',NULL,NULL),(32625,'36142','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.381048,-86.310445,0,'2013-07-06 12:44:32',NULL,NULL),(2225,'00926','S','Urb El Mirador','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(56929,'66070','S','Ozawkie','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.205018,-95.449424,0,'2013-07-06 12:44:33',NULL,NULL),(24975,'27849','S','Woodville','N','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.088260,-77.229660,0,'2013-07-06 12:44:31',NULL,NULL),(15771,'16920','S','Elkland','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.989723,-77.313730,0,'2013-07-06 12:44:31',NULL,NULL),(6873,'06137','P','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(51612,'59832','S','Drummond','D','Granite','30039','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.660732,-113.170929,0,'2013-07-06 12:44:33',NULL,NULL),(20046,'20653','S','Lexington Pk','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.273193,-76.464098,0,'2013-07-06 12:44:31',NULL,NULL),(62945,'75099','U','USPS Official Mail','N','Dallas','48113','Texas','TX','48','1920','940','Central',-6.0,'Y',32.954431,-97.015214,0,'2013-07-06 12:44:33',NULL,NULL),(79564,'99016','S','Liberty Lake','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.643255,-117.151477,0,'2013-07-06 12:44:34',NULL,NULL),(7736,'07206','S','Elizabeth','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.654517,-74.189804,0,'2013-07-06 12:44:30',NULL,NULL),(33628,'37680','S','Laurel Blmry','A','Johnson','47091','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.574547,-81.739325,0,'2013-07-06 12:44:32',NULL,NULL),(58804,'69021','S','Doane','N','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.051824,-101.532367,0,'2013-07-06 12:44:33',NULL,NULL),(71730,'87532','S','San Pedro','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(18725,'19319','S','Cheyney','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.929221,-75.516239,0,'2013-07-06 12:44:31',NULL,NULL),(38070,'43065','S','Shawnee Hills','A','Delaware','39041','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.172501,-83.093346,0,'2013-07-06 12:44:32',NULL,NULL),(27836,'30417','S','Claxton','D','Evans','13109','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.161491,-81.909323,0,'2013-07-06 12:44:31',NULL,NULL),(20300,'20814','S','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.999228,-77.104177,0,'2013-07-06 12:44:31',NULL,NULL),(63820,'75972','S','Macune','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(77085,'96134','S','Lava Beds National Monument','N','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.949725,-121.472495,0,'2013-07-06 12:44:34',NULL,NULL),(19773,'20422','U','Veterans Hospital','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.931850,-77.031546,0,'2013-07-06 12:44:31',NULL,NULL),(20646,'21223','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.280260,-76.650540,0,'2013-07-06 12:44:31',NULL,NULL),(13771,'14140','P','Spring Brook','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.801249,-78.665071,0,'2013-07-06 12:44:31',NULL,NULL),(344,'00656','S','Ext Santa Elena 3','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(58891,'69167','S','Ringgold','N','McPherson','31117','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.568840,-101.061231,0,'2013-07-06 12:44:33',NULL,NULL),(31002,'33772','S','Seminole','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.837047,-82.799175,0,'2013-07-06 12:44:32',NULL,NULL),(12614,'13087','P','Little York','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.705528,-76.157984,0,'2013-07-06 12:44:30',NULL,NULL),(20305,'20815','S','Martins Add','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(12180,'12765','S','Neversink','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.853274,-74.621890,0,'2013-07-06 12:44:30',NULL,NULL),(52017,'60175','S','Campton Hills','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.952674,-88.346033,0,'2013-07-06 12:44:33',NULL,NULL),(65471,'77631','P','Orange','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.092765,-93.732040,0,'2013-07-06 12:44:34',NULL,NULL),(79797,'99354','S','Richland','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.280405,-119.290503,0,'2013-07-06 12:44:34',NULL,NULL),(71400,'87013','S','Cuba','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.863380,-107.072820,0,'2013-07-06 12:44:34',NULL,NULL),(73874,'91933','P','Imperial Beach','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.582379,-117.111447,0,'2013-07-06 12:44:34',NULL,NULL),(64906,'77092','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.833550,-95.473861,0,'2013-07-06 12:44:34',NULL,NULL),(35332,'39428','S','Smith','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(9947,'10156','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(10352,'10573','S','Rye Brook','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.011395,-73.678286,0,'2013-07-06 12:44:30',NULL,NULL),(59155,'70187','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.026248,-89.973423,0,'2013-07-06 12:44:33',NULL,NULL),(16360,'17201','S','Franklin Furn','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(19502,'20165','S','Sterling','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.053592,-77.392876,0,'2013-07-06 12:44:31',NULL,NULL),(16946,'17701','S','Old Lycoming','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(78524,'98125','S','Northgate','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.718413,-122.301588,0,'2013-07-06 12:44:34',NULL,NULL),(22806,'24476','S','Steeles Tavern','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.926887,-79.200418,0,'2013-07-06 12:44:31',NULL,NULL),(3942,'02468','S','Newton','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.326111,-71.231512,0,'2013-07-06 12:44:30',NULL,NULL),(14103,'14624','S','Westgate','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.120619,-77.729488,0,'2013-07-06 12:44:31',NULL,NULL),(42739,'48021','S','East Detroit','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.463894,-82.946167,0,'2013-07-06 12:44:32',NULL,NULL),(56348,'65201','S','Pierpont','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.896440,-92.246280,0,'2013-07-06 12:44:33',NULL,NULL),(51354,'59330','S','Glendive','D','Dawson','30021','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.111083,-104.721775,0,'2013-07-06 12:44:33',NULL,NULL),(48878,'56091','S','Waldorf','D','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.934133,-93.697286,0,'2013-07-06 12:44:33',NULL,NULL),(738,'00690','S','Paseos Reales','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(79638,'99136','S','Hay','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.728658,-117.837934,0,'2013-07-06 12:44:34',NULL,NULL),(61988,'73344','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.176174,-97.729218,0,'2013-07-06 12:44:33',NULL,NULL),(47884,'55092','S','Wyoming','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.329640,-93.074700,0,'2013-07-06 12:44:33',NULL,NULL),(51403,'59434','P','E Glacier Par','A','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(8453,'08087','S','Little Egg Harbor Twp','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(54666,'62938','S','Brownfield','A','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.357533,-88.488804,0,'2013-07-06 12:44:33',NULL,NULL),(61421,'72567','S','Pleasant Grv','A','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842601,-91.925046,0,'2013-07-06 12:44:33',NULL,NULL),(46783,'53958','U','Lands End','N','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.532160,-90.001703,0,'2013-07-06 12:44:32',NULL,NULL),(57939,'67738','S','Grinnell','D','Gove','20063','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.123089,-100.630849,0,'2013-07-06 12:44:33',NULL,NULL),(12405,'12932','S','Elizabethtown','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.226627,-73.624732,0,'2013-07-06 12:44:30',NULL,NULL),(59703,'71102','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.493336,-93.771521,0,'2013-07-06 12:44:33',NULL,NULL),(22694,'24324','S','Draper','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.967091,-80.820914,0,'2013-07-06 12:44:31',NULL,NULL),(6242,'05491','S','West Ferrisburgh','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(17305,'17853','S','Mt Pleasant M','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(21537,'22733','S','Rapidan','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.333795,-78.039595,0,'2013-07-06 12:44:31',NULL,NULL),(59200,'70377','S','Montegut','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.476743,-90.543778,0,'2013-07-06 12:44:33',NULL,NULL),(74539,'92660','S','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.629473,-117.868392,0,'2013-07-06 12:44:34',NULL,NULL),(20249,'20782','S','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(49508,'56667','S','O Brien','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(53886,'62353','S','Mount Sterling','D','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985995,-90.767312,0,'2013-07-06 12:44:33',NULL,NULL),(23690,'25854','S','Hico','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.112753,-80.947352,0,'2013-07-06 12:44:31',NULL,NULL),(60112,'71366','S','St Joseph','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(36513,'40828','S','Louellen','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(37408,'41776','S','Cutshin','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.201089,-83.298307,0,'2013-07-06 12:44:32',NULL,NULL),(10597,'11040','S','Gdn City Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(62730,'74820','S','Pontotoc','A','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.771920,-96.679980,0,'2013-07-06 12:44:33',NULL,NULL),(42571,'47876','P','Saint Mary of the Woods','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.511739,-87.474237,0,'2013-07-06 12:44:32',NULL,NULL),(11237,'11756','S','Levittown','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.726315,-73.517312,0,'2013-07-06 12:44:30',NULL,NULL),(60993,'72112','S','Blackville','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(65056,'77340','S','Crabbs Prairie','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.688500,-95.572380,0,'2013-07-06 12:44:34',NULL,NULL),(19721,'20393','U','Navy Security Group','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.943574,-77.082429,0,'2013-07-06 12:44:31',NULL,NULL),(23538,'25607','S','Amherstdale','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.786800,-81.789540,0,'2013-07-06 12:44:31',NULL,NULL),(23561,'25638','S','Omar','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.738800,-82.008780,0,'2013-07-06 12:44:31',NULL,NULL),(30725,'33524','P','Crystal Springs','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.182590,-82.158720,0,'2013-07-06 12:44:32',NULL,NULL),(27383,'30079','S','Scottdale','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.792377,-84.260882,0,'2013-07-06 12:44:31',NULL,NULL),(27613,'30305','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.831382,-84.385066,0,'2013-07-06 12:44:31',NULL,NULL),(34156,'38254','P','Samburg','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.357242,-89.298053,0,'2013-07-06 12:44:32',NULL,NULL),(42810,'48054','S','East China','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767172,-82.540934,0,'2013-07-06 12:44:32',NULL,NULL),(39703,'45042','S','Bethany','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.545160,-84.439260,0,'2013-07-06 12:44:32',NULL,NULL),(2605,'00961','S','Urb Riverside Park','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(22503,'24073','S','Prices Fork','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136439,-80.404000,0,'2013-07-06 12:44:31',NULL,NULL),(59931,'71292','S','Lapine','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(71364,'86547','P','Chinle','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.513828,-109.469489,0,'2013-07-06 12:44:34',NULL,NULL),(50160,'57551','S','Swett','N','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.218780,-101.666700,0,'2013-07-06 12:44:33',NULL,NULL),(28440,'31405','S','Hunter Army Air Field','N','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.043073,-81.132144,0,'2013-07-06 12:44:32',NULL,NULL),(29514,'32773','S','Sanford','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.765778,-81.276553,0,'2013-07-06 12:44:32',NULL,NULL),(51917,'60112','S','Cortland','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.921249,-88.691137,0,'2013-07-06 12:44:33',NULL,NULL),(21154,'22124','S','Oakton','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.889170,-77.322192,0,'2013-07-06 12:44:31',NULL,NULL),(4647,'03749','P','Enfield Center','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.589213,-72.110433,0,'2013-07-06 12:44:30',NULL,NULL),(56264,'65063','S','Guthrie','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.748060,-92.080440,0,'2013-07-06 12:44:33',NULL,NULL),(25009,'27876','S','Seaboard','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.487659,-77.441965,0,'2013-07-06 12:44:31',NULL,NULL),(25802,'28607','S','Boone','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(23360,'25267','S','Stumptown','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.891624,-80.957193,0,'2013-07-06 12:44:31',NULL,NULL),(76071,'95206','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.918977,-121.312883,0,'2013-07-06 12:44:34',NULL,NULL),(38610,'43903','S','Amsterdam','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.477439,-80.963005,0,'2013-07-06 12:44:32',NULL,NULL),(40902,'46255','U','Merchants Bank','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.766744,-86.163967,0,'2013-07-06 12:44:32',NULL,NULL),(46096,'52623','S','Danville','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.865581,-91.312756,0,'2013-07-06 12:44:32',NULL,NULL),(20788,'21541','S','McHenry','N','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.556671,-79.350980,0,'2013-07-06 12:44:31',NULL,NULL),(1033,'00720','S','Orocovis','D','Orocovis','72107','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.229109,-66.391520,0,'2013-07-06 12:44:30',NULL,NULL),(36944,'41164','S','Upper Tygart','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(14424,'15071','S','Oakdale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.391111,-80.198889,0,'2013-07-06 12:44:31',NULL,NULL),(38390,'43519','P','Stryker','A','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.428226,-84.395702,0,'2013-07-06 12:44:32',NULL,NULL),(28717,'31902','P','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.500152,-84.973827,0,'2013-07-06 12:44:32',NULL,NULL),(8219,'07961','P','Convent Station','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.796667,-74.481944,0,'2013-07-06 12:44:30',NULL,NULL),(48590,'55779','S','Industrial','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(44533,'49964','P','Stambaugh','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.081481,-88.629835,0,'2013-07-06 12:44:32',NULL,NULL),(15997,'17036','S','Waltonville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.277580,-76.708800,0,'2013-07-06 12:44:31',NULL,NULL),(55936,'64474','S','Osborn','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.791289,-94.290578,0,'2013-07-06 12:44:33',NULL,NULL),(35816,'39760','P','Starkville','D','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.449945,-88.820003,0,'2013-07-06 12:44:32',NULL,NULL),(43973,'49322','S','Coral','D','Montcalm','26117','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.357892,-85.362896,0,'2013-07-06 12:44:32',NULL,NULL),(34729,'38848','S','Greenwood Spr','A','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.850186,-88.364251,0,'2013-07-06 12:44:32',NULL,NULL),(3487,'01835','S','Ward Hill','A','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.754563,-71.087282,0,'2013-07-06 12:44:30',NULL,NULL),(72770,'89523','S','Somersett','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.525676,-119.890959,0,'2013-07-06 12:44:34',NULL,NULL),(52524,'60915','S','Bradley','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.146337,-87.863690,0,'2013-07-06 12:44:33',NULL,NULL),(59493,'70769','S','Galvez','A','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.311773,-90.937896,0,'2013-07-06 12:44:33',NULL,NULL),(69731,'84043','S','Eagle Mountain','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(26793,'29456','S','College Park','N','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.016638,-80.105646,0,'2013-07-06 12:44:31',NULL,NULL),(53154,'61560','S','Putnam','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.203217,-89.441455,0,'2013-07-06 12:44:33',NULL,NULL),(57794,'67485','S','Tipton','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.340353,-98.472284,0,'2013-07-06 12:44:33',NULL,NULL),(33797,'37888','S','Washburn','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.312757,-83.599222,0,'2013-07-06 12:44:32',NULL,NULL),(79037,'98401','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255867,-122.441654,0,'2013-07-06 12:44:34',NULL,NULL),(68934,'82930','S','Bear River','A','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.249255,-110.959297,0,'2013-07-06 12:44:34',NULL,NULL),(18619,'19149','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.038521,-75.067175,0,'2013-07-06 12:44:31',NULL,NULL),(47123,'54451','S','Whittlesey','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(14792,'15365','P','Taylorstown','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.161997,-80.379282,0,'2013-07-06 12:44:31',NULL,NULL),(56096,'64778','S','Richards','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.941915,-94.557009,0,'2013-07-06 12:44:33',NULL,NULL),(15332,'16220','P','Crown','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.392264,-79.268025,0,'2013-07-06 12:44:31',NULL,NULL),(32844,'36482','S','Whatley','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.651737,-87.627073,0,'2013-07-06 12:44:32',NULL,NULL),(9831,'10114','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(62666,'74643','S','Lamont','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.690943,-97.556922,0,'2013-07-06 12:44:33',NULL,NULL),(61515,'72655','S','Bass','A','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.920000,-93.060000,0,'2013-07-06 12:44:33',NULL,NULL),(55383,'63623','S','Goodland','N','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.669675,-90.853916,0,'2013-07-06 12:44:33',NULL,NULL),(10448,'10918','S','Chester','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.352758,-74.266372,0,'2013-07-06 12:44:30',NULL,NULL),(30904,'33706','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(76647,'95724','P','Soda Springs','A','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.310380,-120.437220,0,'2013-07-06 12:44:34',NULL,NULL),(74321,'92395','S','Spring Valley Lake','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.486200,-117.366100,0,'2013-07-06 12:44:34',NULL,NULL),(41237,'46738','S','Keyser','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(75202,'93626','S','Friant','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.988336,-119.693009,0,'2013-07-06 12:44:34',NULL,NULL),(66005,'78349','S','Rios','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.531404,-98.383724,0,'2013-07-06 12:44:34',NULL,NULL),(54747,'62975','S','Pomona','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.643077,-89.349507,0,'2013-07-06 12:44:33',NULL,NULL),(43111,'48222','U','Detroit River Station','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.273318,-83.132151,0,'2013-07-06 12:44:32',NULL,NULL),(24394,'27105','S','North','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.150762,-80.234242,0,'2013-07-06 12:44:31',NULL,NULL),(41960,'47406','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.180192,-86.512479,0,'2013-07-06 12:44:32',NULL,NULL),(41880,'47368','S','Parker City','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.192356,-85.191566,0,'2013-07-06 12:44:32',NULL,NULL),(3783,'02204','U','Mass Tax','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.395030,-71.050270,0,'2013-07-06 12:44:30',NULL,NULL),(79012,'98388','S','Steilacoom','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.170637,-122.588055,0,'2013-07-06 12:44:34',NULL,NULL),(33198,'37043','S','Clarksville','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.492780,-87.233460,0,'2013-07-06 12:44:32',NULL,NULL),(17265,'17842','S','Middleswarth','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(16911,'17601','S','Oyster Point','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(20057,'20664','S','Newburg','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.359304,-76.945242,0,'2013-07-06 12:44:31',NULL,NULL),(21124,'22096','U','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.949859,-77.344333,0,'2013-07-06 12:44:31',NULL,NULL),(25323,'28174','S','Wingate','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.986550,-80.448698,0,'2013-07-06 12:44:31',NULL,NULL),(34978,'39092','S','Lake','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.340473,-89.356039,0,'2013-07-06 12:44:32',NULL,NULL),(6187,'05479','U','Eastern Reg Serv Ctr','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.812060,-73.082760,0,'2013-07-06 12:44:30',NULL,NULL),(35701,'39666','S','Johnston','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(11094,'11694','S','Neponsit','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.576767,-73.844160,0,'2013-07-06 12:44:30',NULL,NULL),(37216,'41528','S','Freeburn','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.543483,-82.135640,0,'2013-07-06 12:44:32',NULL,NULL),(47974,'55126','S','No Oaks','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(18856,'19438','S','Lower Salford','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.267589,-75.382781,0,'2013-07-06 12:44:31',NULL,NULL),(29133,'32323','P','Lanark Vlg','A','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.880772,-84.599766,0,'2013-07-06 12:44:32',NULL,NULL),(4784,'03868','S','E Rochester','N','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.336620,-70.947300,0,'2013-07-06 12:44:30',NULL,NULL),(46935,'54159','S','Porterfield','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.205080,-87.795180,0,'2013-07-06 12:44:32',NULL,NULL),(54636,'62921','P','Old Camp','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.804393,-89.081265,0,'2013-07-06 12:44:33',NULL,NULL),(57164,'66283','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861823,-94.670864,0,'2013-07-06 12:44:33',NULL,NULL),(65490,'77656','S','Silsbee','D','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.319984,-94.189246,0,'2013-07-06 12:44:34',NULL,NULL),(66581,'78745','S','Sunset Valley','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.208076,-97.800448,0,'2013-07-06 12:44:34',NULL,NULL),(73005,'90063','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.042454,-118.184723,0,'2013-07-06 12:44:34',NULL,NULL),(79465,'98853','P','Stratford','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.366763,-119.278631,0,'2013-07-06 12:44:34',NULL,NULL),(6533,'05832','S','Burke Mountain','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.604179,-71.918969,0,'2013-07-06 12:44:30',NULL,NULL),(62075,'73555','P','Manitou','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.507307,-98.978423,0,'2013-07-06 12:44:33',NULL,NULL),(35377,'39452','S','Movella','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(18054,'18702','S','Hilldale','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(63711,'75915','P','Lufkin','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.335282,-94.728710,0,'2013-07-06 12:44:34',NULL,NULL),(73709,'91610','P','Toluca Lake','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.155836,-118.379194,0,'2013-07-06 12:44:34',NULL,NULL),(43792,'49051','S','East Leroy','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.191219,-85.236464,0,'2013-07-06 12:44:32',NULL,NULL),(20370,'20879','S','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.177540,-77.194392,0,'2013-07-06 12:44:31',NULL,NULL),(39211,'44403','S','Brookfield','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.236682,-80.577887,0,'2013-07-06 12:44:32',NULL,NULL),(39092,'44224','S','Silver Lake','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.173500,-81.449700,0,'2013-07-06 12:44:32',NULL,NULL),(69430,'83638','S','Lardo','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.914318,-116.098389,0,'2013-07-06 12:44:34',NULL,NULL),(69686,'84026','S','Gusher','A','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.294221,-109.839602,0,'2013-07-06 12:44:34',NULL,NULL),(75348,'93908','S','Corral de Tie','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.603909,-121.654754,0,'2013-07-06 12:44:34',NULL,NULL),(77382,'96760','S','Kurtistown','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.580365,-155.036812,0,'2013-07-06 12:44:34',NULL,NULL),(12272,'12835','S','Hadley','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.336182,-73.985758,0,'2013-07-06 12:44:30',NULL,NULL),(10877,'11419','S','S Richmond Hl','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.688921,-73.823304,0,'2013-07-06 12:44:30',NULL,NULL),(25832,'28617','S','Weaversford','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.460860,-81.413640,0,'2013-07-06 12:44:31',NULL,NULL),(39009,'44139','S','Solon','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.392321,-81.444888,0,'2013-07-06 12:44:32',NULL,NULL),(47226,'54498','S','Withee','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953103,-90.595538,0,'2013-07-06 12:44:32',NULL,NULL),(51793,'60046','S','Lindenhurst','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(54875,'63053','P','Kimmswick','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.367900,-90.365393,0,'2013-07-06 12:44:33',NULL,NULL),(71732,'87532','S','Sombrillo','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(9723,'10081','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(33199,'37043','S','Fredonia','N','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.492780,-87.233460,0,'2013-07-06 12:44:32',NULL,NULL),(30714,'33508','P','Brandon','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.927446,-82.293411,0,'2013-07-06 12:44:32',NULL,NULL),(26640,'29338','P','Fingerville','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.934397,-81.981856,0,'2013-07-06 12:44:31',NULL,NULL),(65016,'77304','S','Panorama Village','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.342840,-95.477880,0,'2013-07-06 12:44:34',NULL,NULL),(18639,'19161','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.065457,-75.080697,0,'2013-07-06 12:44:31',NULL,NULL),(34689,'38828','S','Center','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(43918,'49262','S','North Adams','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.962474,-84.490077,0,'2013-07-06 12:44:32',NULL,NULL),(26111,'28723','S','Speedwell','N','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.284272,-83.179192,0,'2013-07-06 12:44:31',NULL,NULL),(74675,'92867','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.811025,-117.849274,0,'2013-07-06 12:44:34',NULL,NULL),(58838,'69125','S','Broadwater','D','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.598355,-102.850741,0,'2013-07-06 12:44:33',NULL,NULL),(8279,'08012','S','Hilltop','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(38873,'44105','S','Garfield Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(38529,'43734','S','Duncan Falls','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.880812,-81.911534,0,'2013-07-06 12:44:32',NULL,NULL),(25582,'28438','S','Evergreen','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.420210,-78.817830,0,'2013-07-06 12:44:31',NULL,NULL),(65812,'78140','S','Nixon','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.272127,-97.765242,0,'2013-07-06 12:44:34',NULL,NULL),(13086,'13468','S','Springfield Center','D','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.844523,-74.841105,0,'2013-07-06 12:44:30',NULL,NULL),(13182,'13617','S','Morley','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(18977,'19520','S','Bulltown','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(9664,'10039','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(12707,'13147','S','Scipioville','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(54174,'62617','S','Snicarte','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.136329,-90.169770,0,'2013-07-06 12:44:33',NULL,NULL),(68106,'80945','U','Comcast','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.838745,-104.797322,0,'2013-07-06 12:44:34',NULL,NULL),(59010,'70068','S','Montz','A','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.054960,-90.480540,0,'2013-07-06 12:44:33',NULL,NULL),(7518,'07003','S','Grove','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.805311,-74.187412,0,'2013-07-06 12:44:30',NULL,NULL),(12985,'13407','S','Dennison Corners','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.991140,-74.980560,0,'2013-07-06 12:44:30',NULL,NULL),(39086,'44222','P','Cuyahoga Fls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.135336,-81.483106,0,'2013-07-06 12:44:32',NULL,NULL),(26388,'29102','S','Manning','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(42997,'48160','S','Cone','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(50823,'58467','S','Medina','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.893964,-99.302871,0,'2013-07-06 12:44:33',NULL,NULL),(55805,'64137','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.933186,-94.540154,0,'2013-07-06 12:44:33',NULL,NULL),(64929,'77213','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.794698,-95.240665,0,'2013-07-06 12:44:34',NULL,NULL),(40825,'46209','U','Business Reply','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.744999,-86.158607,0,'2013-07-06 12:44:32',NULL,NULL),(7767,'07410','S','Fairlawn','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.934411,-74.117638,0,'2013-07-06 12:44:30',NULL,NULL),(57335,'66716','S','Bronson','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.945353,-94.999462,0,'2013-07-06 12:44:33',NULL,NULL),(28019,'30625','S','Buckhead','D','Morgan','13211','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.528483,-83.340128,0,'2013-07-06 12:44:31',NULL,NULL),(13510,'13811','S','Newark Valley','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.232380,-76.176420,0,'2013-07-06 12:44:31',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (67491,'80233','S','Denver','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903291,-104.948178,0,'2013-07-06 12:44:34',NULL,NULL),(72306,'88587','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.813359,-106.417488,0,'2013-07-06 12:44:34',NULL,NULL),(77603,'96941','P','Pohnpei','D','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',6.890254,158.209053,0,'2013-07-06 12:44:34',NULL,NULL),(58049,'68029','S','Herman','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.642508,-96.321076,0,'2013-07-06 12:44:33',NULL,NULL),(14877,'15473','S','Layton','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.087523,-79.750761,0,'2013-07-06 12:44:31',NULL,NULL),(65643,'77968','S','Inez','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.877985,-96.832224,0,'2013-07-06 12:44:34',NULL,NULL),(73760,'91732','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.074497,-118.011309,0,'2013-07-06 12:44:34',NULL,NULL),(63315,'75568','S','Dalton','N','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192600,-94.693620,0,'2013-07-06 12:44:33',NULL,NULL),(37307,'41640','S','Hueysville','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.508219,-82.832880,0,'2013-07-06 12:44:32',NULL,NULL),(44669,'50115','S','Guthrie Center','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.677381,-94.500012,0,'2013-07-06 12:44:32',NULL,NULL),(71887,'87735','S','Wagon Mound','A','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.055745,-105.117418,0,'2013-07-06 12:44:34',NULL,NULL),(72980,'90050','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.121378,-118.206906,0,'2013-07-06 12:44:34',NULL,NULL),(4168,'02791','P','Westport Pt','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.523309,-71.077717,0,'2013-07-06 12:44:30',NULL,NULL),(15461,'16416','P','Garland','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.816258,-79.444502,0,'2013-07-06 12:44:31',NULL,NULL),(47197,'54487','S','Tannery','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.474520,-89.727183,0,'2013-07-06 12:44:32',NULL,NULL),(36557,'40914','S','Big Creek','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.151896,-83.620829,0,'2013-07-06 12:44:32',NULL,NULL),(73180,'90404','S','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.028496,-118.470151,0,'2013-07-06 12:44:34',NULL,NULL),(22202,'23511','S','Naval Communications Area Ma','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(73403,'91124','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.150182,-118.152862,0,'2013-07-06 12:44:34',NULL,NULL),(54318,'62723','U','Drivers Lic Div','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.759431,-89.634086,0,'2013-07-06 12:44:33',NULL,NULL),(33482,'37339','S','Laager','N','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.372500,-85.598889,0,'2013-07-06 12:44:32',NULL,NULL),(15572,'16651','S','Ginter','A','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.823943,-78.349798,0,'2013-07-06 12:44:31',NULL,NULL),(6729,'06074','S','Wapping','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.834880,-72.571320,0,'2013-07-06 12:44:30',NULL,NULL),(69290,'83445','S','Anthony','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(50062,'57441','S','Elm Lake','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.834238,-98.506058,0,'2013-07-06 12:44:33',NULL,NULL),(55764,'64116','S','Kansas Cy','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(78870,'98351','S','Lakebay','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.257222,-122.757222,0,'2013-07-06 12:44:34',NULL,NULL),(71794,'87562','P','Rowe','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.507793,-105.666812,0,'2013-07-06 12:44:34',NULL,NULL),(55420,'63655','S','Gravelton','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.403467,-90.197360,0,'2013-07-06 12:44:33',NULL,NULL),(55200,'63383','S','Truesdale','A','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.771220,-91.224360,0,'2013-07-06 12:44:33',NULL,NULL),(46979,'54220','S','Manitowoc','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.095713,-87.711060,0,'2013-07-06 12:44:32',NULL,NULL),(45039,'50475','S','Sheffield','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.891379,-93.218136,0,'2013-07-06 12:44:32',NULL,NULL),(12288,'12845','S','Lake George','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.416960,-73.684800,0,'2013-07-06 12:44:30',NULL,NULL),(13388,'13745','P','Chenango Brg','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.285719,-75.910766,0,'2013-07-06 12:44:31',NULL,NULL),(15034,'15692','S','Westmoreland City','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.330504,-79.679891,0,'2013-07-06 12:44:31',NULL,NULL),(37394,'41763','S','Slemp','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.069934,-83.118057,0,'2013-07-06 12:44:32',NULL,NULL),(15196,'15954','S','Cramer','N','Westmoreland','42129','Pennsylvania','PA','42','6280','814','Eastern',-5.0,'Y',40.403760,-79.025220,0,'2013-07-06 12:44:31',NULL,NULL),(33993,'38117','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.115970,-89.901902,0,'2013-07-06 12:44:32',NULL,NULL),(47134,'54455','S','Kronenwetter','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(45383,'51024','S','Neptune','N','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.621194,-96.295955,0,'2013-07-06 12:44:32',NULL,NULL),(2729,'00969','S','Urb El Alamo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(5587,'04918','S','Belgrade Lks','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.512980,-69.860580,0,'2013-07-06 12:44:30',NULL,NULL),(72919,'90027','S','Hollywood','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.123560,-118.287840,0,'2013-07-06 12:44:34',NULL,NULL),(4588,'03581','S','Gorham','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.400621,-71.192698,0,'2013-07-06 12:44:30',NULL,NULL),(13594,'13850','S','Vestal','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(29184,'32399','U','State of Florida','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.429675,-84.258538,0,'2013-07-06 12:44:32',NULL,NULL),(26323,'29047','S','Elloree','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.531329,-80.571823,0,'2013-07-06 12:44:31',NULL,NULL),(23254,'25123','S','Leon','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.746520,-81.955930,0,'2013-07-06 12:44:31',NULL,NULL),(11757,'12194','S','West Fulton','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.538560,-74.454716,0,'2013-07-06 12:44:30',NULL,NULL),(34516,'38676','S','Tunica','D','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(7728,'07202','S','Elizabeth','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.656153,-74.218524,0,'2013-07-06 12:44:30',NULL,NULL),(68233,'81052','S','Shady Camp','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(72478,'89124','S','Sloan','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(13595,'13850','S','Vestal Center','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(76952,'96035','S','Gerber','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.038799,-122.172069,0,'2013-07-06 12:44:34',NULL,NULL),(49978,'57359','S','Storla','N','Sanborn','46111','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.896104,-98.208027,0,'2013-07-06 12:44:33',NULL,NULL),(1701,'00777','S','Urb Los Almendros','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(34642,'38768','P','Rome','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.987693,-90.345294,0,'2013-07-06 12:44:32',NULL,NULL),(12568,'13060','S','Elbridge','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.024371,-76.418761,0,'2013-07-06 12:44:30',NULL,NULL),(14813,'15417','S','West Brownsville','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.031040,-79.929900,0,'2013-07-06 12:44:31',NULL,NULL),(14670,'15240','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445977,-79.962428,0,'2013-07-06 12:44:31',NULL,NULL),(20704,'21263','U','Bank of America','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290550,-76.609596,0,'2013-07-06 12:44:31',NULL,NULL),(12808,'13251','U','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.123742,-76.135103,0,'2013-07-06 12:44:30',NULL,NULL),(18628,'19152','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057073,-75.047092,0,'2013-07-06 12:44:31',NULL,NULL),(17001,'17737','S','Bryan Mills','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257740,-76.713780,0,'2013-07-06 12:44:31',NULL,NULL),(44542,'50001','S','Sandyville','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.381400,-93.398760,0,'2013-07-06 12:44:32',NULL,NULL),(60176,'71410','P','Calvin','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.965432,-92.775052,0,'2013-07-06 12:44:33',NULL,NULL),(75577,'94280','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582315,-121.494471,0,'2013-07-06 12:44:34',NULL,NULL),(60143,'71375','S','Azucena','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(6415,'05739','S','Danby Corners','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(29023,'32228','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(16935,'17622','U','Qvc Network Inc','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.023731,-76.331711,0,'2013-07-06 12:44:31',NULL,NULL),(3053,'01108','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.082083,-72.554368,0,'2013-07-06 12:44:30',NULL,NULL),(10822,'11379','S','Elmhurst','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715870,-73.882583,0,'2013-07-06 12:44:30',NULL,NULL),(71054,'85750','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.291010,-110.842443,0,'2013-07-06 12:44:34',NULL,NULL),(77117,'96148','P','Tahoe Vista','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.240575,-120.071544,0,'2013-07-06 12:44:34',NULL,NULL),(63037,'75207','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.787059,-96.820335,0,'2013-07-06 12:44:33',NULL,NULL),(4662,'03771','S','Monroe','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.271248,-72.025509,0,'2013-07-06 12:44:30',NULL,NULL),(37809,'42408','S','Carbondale','N','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.189860,-87.687240,0,'2013-07-06 12:44:32',NULL,NULL),(15303,'16145','S','Sandy Lake','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.349979,-80.084405,0,'2013-07-06 12:44:31',NULL,NULL),(13603,'13856','S','Pineville','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(24895,'27709','P','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.913800,-78.848911,0,'2013-07-06 12:44:31',NULL,NULL),(20746,'21402','S','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.987681,-76.487016,0,'2013-07-06 12:44:31',NULL,NULL),(2040,'00918','S','Urb Baldrich','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(47986,'55128','S','Oakdale','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.007260,-92.964120,0,'2013-07-06 12:44:33',NULL,NULL),(49295,'56524','S','Clitherall','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.327298,-95.592298,0,'2013-07-06 12:44:33',NULL,NULL),(53679,'62221','S','Belleville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.550823,-89.984437,0,'2013-07-06 12:44:33',NULL,NULL),(57200,'66427','S','Frankfort','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.705297,-96.415675,0,'2013-07-06 12:44:33',NULL,NULL),(72491,'89137','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.190857,-115.311325,0,'2013-07-06 12:44:34',NULL,NULL),(74080,'92179','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.567887,-116.970748,0,'2013-07-06 12:44:34',NULL,NULL),(79645,'99141','S','Kettle Falls','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.634583,-118.061902,0,'2013-07-06 12:44:34',NULL,NULL),(62352,'74061','S','Ramona','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.562678,-95.905588,0,'2013-07-06 12:44:33',NULL,NULL),(31061,'33844','S','Haines City','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.099287,-81.615558,0,'2013-07-06 12:44:32',NULL,NULL),(25080,'27949','S','Duck','A','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.133440,-75.725400,0,'2013-07-06 12:44:31',NULL,NULL),(56921,'66062','S','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.840421,-94.781910,0,'2013-07-06 12:44:33',NULL,NULL),(66479,'78663','S','Round Mtn','A','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.441858,-98.468024,0,'2013-07-06 12:44:34',NULL,NULL),(37850,'42501','S','Poplarville','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(3836,'02339','S','Assinippi','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.130281,-70.846944,0,'2013-07-06 12:44:30',NULL,NULL),(7098,'06360','S','Norwich','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.550840,-72.027360,0,'2013-07-06 12:44:30',NULL,NULL),(35577,'39571','S','Pass Christin','A','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.367611,-89.262586,0,'2013-07-06 12:44:32',NULL,NULL),(29543,'32799','P','Mid Florida','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.630233,-81.354944,0,'2013-07-06 12:44:32',NULL,NULL),(43714,'48912','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.735638,-84.523037,0,'2013-07-06 12:44:32',NULL,NULL),(45695,'52052','S','Guttenberg','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.711000,-91.078680,0,'2013-07-06 12:44:32',NULL,NULL),(75245,'93654','S','Reedley','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.611335,-119.434150,0,'2013-07-06 12:44:34',NULL,NULL),(58987,'70051','S','Garyville','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.124963,-90.609115,0,'2013-07-06 12:44:33',NULL,NULL),(1473,'00745','S','Urb Ponderosa','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(19281,'19967','S','Ocean View','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.565806,-75.113837,0,'2013-07-06 12:44:31',NULL,NULL),(79627,'99125','S','Endicott','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.921399,-117.701784,0,'2013-07-06 12:44:34',NULL,NULL),(63457,'75684','S','Jacobs','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(6812,'06110','S','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(76756,'95923','S','Prattville','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.208520,-121.155480,0,'2013-07-06 12:44:34',NULL,NULL),(77770,'97118','P','Garibaldi','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.561012,-123.912301,0,'2013-07-06 12:44:34',NULL,NULL),(80070,'99726','P','Bettles','N','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.906944,-151.683056,0,'2013-07-06 12:44:34',NULL,NULL),(41220,'46733','S','Barrington Woods','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(705,'00685','S','Villa Rita','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(3432,'01745','S','Southborough','A','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.292310,-71.504095,0,'2013-07-06 12:44:30',NULL,NULL),(6085,'05450','S','Enosburg Center','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(27077,'29702','S','Cherokee Falls','A','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.115670,-81.513969,0,'2013-07-06 12:44:31',NULL,NULL),(41853,'47353','S','Roseburg','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(47264,'54529','S','Goodnow','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.673020,-89.671560,0,'2013-07-06 12:44:32',NULL,NULL),(47506,'54766','S','Sheldon','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.309937,-90.902709,0,'2013-07-06 12:44:32',NULL,NULL),(55262,'63460','S','Novelty','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.037920,-92.257514,0,'2013-07-06 12:44:33',NULL,NULL),(70785,'85351','S','Sun City','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.604778,-112.279344,0,'2013-07-06 12:44:34',NULL,NULL),(75774,'94660','U','Safeway Stores','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.795912,-122.269768,0,'2013-07-06 12:44:34',NULL,NULL),(18734,'19320','S','West Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(14155,'14720','P','Celoron','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.108480,-79.283040,0,'2013-07-06 12:44:31',NULL,NULL),(48252,'55425','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.842620,-93.239760,0,'2013-07-06 12:44:33',NULL,NULL),(8354,'08048','S','Lumberton Twp','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.956414,-74.804349,0,'2013-07-06 12:44:30',NULL,NULL),(76245,'95391','S','Tracy','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.760523,-121.546105,0,'2013-07-06 12:44:34',NULL,NULL),(40504,'45808','S','Beaverdam','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.830818,-83.969324,0,'2013-07-06 12:44:32',NULL,NULL),(7799,'07436','S','Oakland','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.029740,-74.233815,0,'2013-07-06 12:44:30',NULL,NULL),(648,'00682','S','Urb Ramirez de Arellano','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(36401,'40509','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.003602,-84.419005,0,'2013-07-06 12:44:32',NULL,NULL),(24968,'27844','S','Hollister','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.246667,-77.956944,0,'2013-07-06 12:44:31',NULL,NULL),(56807,'65772','S','Washburn','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.675572,-93.880587,0,'2013-07-06 12:44:33',NULL,NULL),(58979,'70041','S','Triumph','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.352900,-89.502060,0,'2013-07-06 12:44:33',NULL,NULL),(63429,'75662','S','Liberty City','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.400240,-94.890180,0,'2013-07-06 12:44:33',NULL,NULL),(71482,'87070','P','Clines Corners','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.960483,-105.561423,0,'2013-07-06 12:44:34',NULL,NULL),(73916,'92021','S','El Cajon','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.818710,-116.901089,0,'2013-07-06 12:44:34',NULL,NULL),(62635,'74560','S','Pittsburg','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.658705,-95.813697,0,'2013-07-06 12:44:33',NULL,NULL),(57583,'67066','S','Iuka','D','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.755818,-98.740454,0,'2013-07-06 12:44:33',NULL,NULL),(51391,'59419','S','Bynum','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.981196,-112.307571,0,'2013-07-06 12:44:33',NULL,NULL),(26355,'29070','S','Batsbrg-Levil','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(29430,'32680','S','Old Town','D','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.626506,-83.105630,0,'2013-07-06 12:44:32',NULL,NULL),(65045,'77333','P','Bobville','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.367215,-95.772479,0,'2013-07-06 12:44:34',NULL,NULL),(74614,'92728','P','Santa Ana','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.713991,-117.928354,0,'2013-07-06 12:44:34',NULL,NULL),(21369,'22454','S','Dunnsville','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.843800,-76.831080,0,'2013-07-06 12:44:31',NULL,NULL),(4866,'04028','P','East Parsonsfield','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.765270,-70.917943,0,'2013-07-06 12:44:30',NULL,NULL),(31250,'33980','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.978628,-82.059701,0,'2013-07-06 12:44:32',NULL,NULL),(26278,'29015','S','Blair','D','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.321055,-81.130372,0,'2013-07-06 12:44:31',NULL,NULL),(844,'00698','S','Est de Yodimar','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(37727,'42276','S','Oakville','A','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(5692,'04976','S','Cornville','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.757178,-69.712735,0,'2013-07-06 12:44:30',NULL,NULL),(34831,'38920','S','Cascilla','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(16124,'17057','S','Londonderry','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(26670,'29395','U','Disney Direct Marketing','N','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.855365,-81.738114,0,'2013-07-06 12:44:31',NULL,NULL),(43893,'49237','S','Concord','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.171609,-84.646329,0,'2013-07-06 12:44:32',NULL,NULL),(54663,'62935','S','Cornerville','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.844203,-88.609011,0,'2013-07-06 12:44:33',NULL,NULL),(33114,'36862','S','Lafayette','D','Chambers','01017','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.897003,-85.435404,0,'2013-07-06 12:44:32',NULL,NULL),(1072,'00725','S','Qtas de San Luis 2','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(24163,'26601','S','Herold','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.672330,-80.687532,0,'2013-07-06 12:44:31',NULL,NULL),(47753,'55024','S','Farmington','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.638608,-93.149008,0,'2013-07-06 12:44:33',NULL,NULL),(35914,'40023','S','Wilsonville','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.188191,-85.441224,0,'2013-07-06 12:44:32',NULL,NULL),(12862,'13322','S','Clayville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.973910,-75.243398,0,'2013-07-06 12:44:30',NULL,NULL),(60370,'71479','S','Tullos','D','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.858786,-92.289315,0,'2013-07-06 12:44:33',NULL,NULL),(18077,'18705','S','Plains','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(16401,'17221','S','Fannettsburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.064497,-77.824260,0,'2013-07-06 12:44:31',NULL,NULL),(60939,'72089','P','Bryant','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.596252,-92.486894,0,'2013-07-06 12:44:33',NULL,NULL),(74588,'92697','U','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648513,-117.838683,0,'2013-07-06 12:44:34',NULL,NULL),(71621,'87357','P','Ramah','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.134800,-108.495600,0,'2013-07-06 12:44:34',NULL,NULL),(69492,'83702','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.628437,-116.207449,0,'2013-07-06 12:44:34',NULL,NULL),(10542,'10996','S','United States Military Acade','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.388670,-73.982179,0,'2013-07-06 12:44:30',NULL,NULL),(25725,'28545','S','McCutchn Fld','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.683745,-77.341910,0,'2013-07-06 12:44:31',NULL,NULL),(22854,'24538','S','Concord','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.344367,-78.992295,0,'2013-07-06 12:44:31',NULL,NULL),(7544,'07010','S','Cliffside Pk','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.819853,-73.988554,0,'2013-07-06 12:44:30',NULL,NULL),(41248,'46742','S','Oakwood','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(59913,'71282','S','Quimby','N','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(29998,'33119','P','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.786672,-80.133513,0,'2013-07-06 12:44:32',NULL,NULL),(74450,'92586','S','Menifee','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.702108,-117.201493,0,'2013-07-06 12:44:34',NULL,NULL),(62640,'74567','S','Snow','D','Pushmataha','40127','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.442369,-95.423848,0,'2013-07-06 12:44:33',NULL,NULL),(50067,'57445','S','Groton','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.451773,-98.101092,0,'2013-07-06 12:44:33',NULL,NULL),(13912,'14304','S','Niagara Falls','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.100160,-78.955200,0,'2013-07-06 12:44:31',NULL,NULL),(78619,'98201','S','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.988594,-122.201789,0,'2013-07-06 12:44:34',NULL,NULL),(78571,'98165','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.603561,-122.329437,0,'2013-07-06 12:44:34',NULL,NULL),(43970,'49319','S','Cedar Springs','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.224214,-85.536818,0,'2013-07-06 12:44:32',NULL,NULL),(37673,'42211','S','Montgomery','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(30038,'33141','S','Normandy Isle','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(20693,'21244','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.332500,-76.693056,0,'2013-07-06 12:44:31',NULL,NULL),(16836,'17555','S','South Hermitage','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.133056,-75.965000,0,'2013-07-06 12:44:31',NULL,NULL),(59837,'71243','S','Fort Necessity','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.044920,-91.820280,0,'2013-07-06 12:44:33',NULL,NULL),(74693,'93001','S','Casitas Springs','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.295546,-119.291976,0,'2013-07-06 12:44:34',NULL,NULL),(36450,'40621','U','Ky Dept Human Resources','N','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.200847,-84.872727,0,'2013-07-06 12:44:32',NULL,NULL),(50187,'57566','S','Parmelee','D','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.331201,-101.013019,0,'2013-07-06 12:44:33',NULL,NULL),(27948,'30539','S','East Ellijay','D','Gilmer','13123','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.686350,-84.474574,0,'2013-07-06 12:44:31',NULL,NULL),(15858,'16943','S','Sunderlinvle','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843054,-77.545629,0,'2013-07-06 12:44:31',NULL,NULL),(3374,'01586','P','West Millbury','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.126310,-71.646126,0,'2013-07-06 12:44:30',NULL,NULL),(450,'00662','S','Urb Medina','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(72284,'88565','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766368,-106.330038,0,'2013-07-06 12:44:34',NULL,NULL),(61334,'72459','S','Ravenden','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.186880,-91.285302,0,'2013-07-06 12:44:33',NULL,NULL),(5379,'04635','P','Frenchboro','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.110168,-68.355204,0,'2013-07-06 12:44:30',NULL,NULL),(31837,'35080','S','Helena','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.305287,-86.818296,0,'2013-07-06 12:44:32',NULL,NULL),(57911,'67658','S','Paradise','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.045372,-98.928358,0,'2013-07-06 12:44:33',NULL,NULL),(17573,'18012','P','Aquashicola','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.808358,-75.772424,0,'2013-07-06 12:44:31',NULL,NULL),(17727,'18248','P','Sheppton','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.894965,-76.115005,0,'2013-07-06 12:44:31',NULL,NULL),(29154,'32343','S','Midway','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.487891,-84.462951,0,'2013-07-06 12:44:32',NULL,NULL),(18874,'19454','S','Montgomery Twp','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.215532,-75.258606,0,'2013-07-06 12:44:31',NULL,NULL),(46475,'53219','S','Greenfield','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994394,-87.991356,0,'2013-07-06 12:44:32',NULL,NULL),(3763,'02186','S','Milton','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.249317,-71.074516,0,'2013-07-06 12:44:30',NULL,NULL),(34919,'38963','S','Brazil','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014758,-90.431889,0,'2013-07-06 12:44:32',NULL,NULL),(7307,'06610','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.201974,-73.166951,0,'2013-07-06 12:44:30',NULL,NULL),(7773,'07418','S','Glenwood','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.246598,-74.484700,0,'2013-07-06 12:44:30',NULL,NULL),(77236,'96522','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(33113,'36862','S','Laf Ayette','N','Chambers','01017','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.897003,-85.435404,0,'2013-07-06 12:44:32',NULL,NULL),(78359,'98013','P','Vashon','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.389080,-122.459400,0,'2013-07-06 12:44:34',NULL,NULL),(42707,'48001','S','Algonac','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(45717,'52069','S','Preston','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.050769,-90.394243,0,'2013-07-06 12:44:32',NULL,NULL),(12465,'12979','S','Rouses Point','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.990534,-73.367171,0,'2013-07-06 12:44:30',NULL,NULL),(20856,'21659','S','Eldorado','A','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.575555,-75.815263,0,'2013-07-06 12:44:31',NULL,NULL),(49159,'56388','S','Waite Park','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.557519,-94.224792,0,'2013-07-06 12:44:33',NULL,NULL),(1770,'00780','S','Urb Santa America','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(23802,'26037','S','Follansbee','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.327418,-80.583587,0,'2013-07-06 12:44:31',NULL,NULL),(53881,'62351','S','Mendon','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.086590,-91.284958,0,'2013-07-06 12:44:33',NULL,NULL),(77363,'96742','P','Kalaupapa','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.182329,-156.974434,0,'2013-07-06 12:44:34',NULL,NULL),(37587,'42101','S','Bowling Grn','N','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.018172,-86.458733,0,'2013-07-06 12:44:32',NULL,NULL),(75548,'94240','U','Franchise Tax Brd Refunds','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585287,-121.494786,0,'2013-07-06 12:44:34',NULL,NULL),(61506,'72650','S','Dongola','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.940312,-92.656563,0,'2013-07-06 12:44:33',NULL,NULL),(6549,'05842','S','Grnsboro Bend','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.556900,-72.251340,0,'2013-07-06 12:44:30',NULL,NULL),(39069,'44203','S','New Franklin','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.014711,-81.614500,0,'2013-07-06 12:44:32',NULL,NULL),(44340,'49768','S','Paradise','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.592184,-85.129207,0,'2013-07-06 12:44:32',NULL,NULL),(62416,'74133','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.050515,-95.881034,0,'2013-07-06 12:44:33',NULL,NULL),(56682,'65641','S','Eagle Rock','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.563526,-93.755814,0,'2013-07-06 12:44:33',NULL,NULL),(16460,'17241','S','Entlerville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(2881,'00987','S','Ciudad Jardin','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(52121,'60426','S','Markham','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.604606,-87.669030,0,'2013-07-06 12:44:33',NULL,NULL),(3315,'01522','S','Jefferson','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.374580,-71.866788,0,'2013-07-06 12:44:30',NULL,NULL),(25865,'28630','S','Sawmills','A','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.816100,-81.457140,0,'2013-07-06 12:44:31',NULL,NULL),(52563,'60957','S','Paxton','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.457648,-88.094231,0,'2013-07-06 12:44:33',NULL,NULL),(62308,'74033','S','Glenpool','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.956351,-95.996719,0,'2013-07-06 12:44:33',NULL,NULL),(10759,'11362','S','Horace Harding','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761850,-73.729718,0,'2013-07-06 12:44:30',NULL,NULL),(10240,'10467','S','Mosholu','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.873256,-73.870576,0,'2013-07-06 12:44:30',NULL,NULL),(55539,'63837','S','Freeborn','N','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.450728,-89.964168,0,'2013-07-06 12:44:33',NULL,NULL),(24832,'27611','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.720263,-78.733806,0,'2013-07-06 12:44:31',NULL,NULL),(17710,'18232','S','Lansford','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.834983,-75.884076,0,'2013-07-06 12:44:31',NULL,NULL),(10424,'10710','S','Centuck','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.965847,-73.845926,0,'2013-07-06 12:44:30',NULL,NULL),(5411,'04664','S','N Sullivan','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.540556,-68.243611,0,'2013-07-06 12:44:30',NULL,NULL),(24079,'26451','S','West Milford','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.200286,-80.401724,0,'2013-07-06 12:44:31',NULL,NULL),(55590,'63934','S','Clubb','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.235017,-90.363369,0,'2013-07-06 12:44:33',NULL,NULL),(28724,'31905','S','Camp Rogers','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.430120,-84.918180,0,'2013-07-06 12:44:32',NULL,NULL),(55182,'63376','S','Cottleville','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.780270,-90.624050,0,'2013-07-06 12:44:33',NULL,NULL),(16428,'17229','S','Hustontwn','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.120009,-77.992025,0,'2013-07-06 12:44:31',NULL,NULL),(70460,'84754','S','Central Valley','A','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.642486,-112.135978,0,'2013-07-06 12:44:34',NULL,NULL),(72339,'89014','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.063431,-115.054663,0,'2013-07-06 12:44:34',NULL,NULL),(27842,'30425','S','Garfield','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.599435,-82.070896,0,'2013-07-06 12:44:31',NULL,NULL),(23020,'24830','S','Elbert','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.318056,-81.544167,0,'2013-07-06 12:44:31',NULL,NULL),(22625,'24236','S','Damascus','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.636452,-81.802169,0,'2013-07-06 12:44:31',NULL,NULL),(13153,'13603','S','Fort Drum','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.042160,-75.791520,0,'2013-07-06 12:44:30',NULL,NULL),(35956,'40063','P','Saint Mary','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.579147,-85.342897,0,'2013-07-06 12:44:32',NULL,NULL),(52791,'61273','S','Sunny Hill Estates','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.366880,-90.433140,0,'2013-07-06 12:44:33',NULL,NULL),(65040,'77331','S','Camilla','N','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.598380,-95.114520,0,'2013-07-06 12:44:34',NULL,NULL),(32348,'35808','S','Redstone Arsenal','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.698410,-86.646477,0,'2013-07-06 12:44:32',NULL,NULL),(45554,'51501','S','Co Bluffs','N','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.254887,-95.852753,0,'2013-07-06 12:44:32',NULL,NULL),(68100,'80944','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832646,-104.822595,0,'2013-07-06 12:44:34',NULL,NULL),(15963,'17027','P','Messiah Coll','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.152071,-77.002719,0,'2013-07-06 12:44:31',NULL,NULL),(13331,'13683','P','Rooseveltown','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.973162,-74.730968,0,'2013-07-06 12:44:30',NULL,NULL),(5023,'04240','S','Lewiston','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.097005,-70.186774,0,'2013-07-06 12:44:30',NULL,NULL),(35784,'39747','S','Poplar Springs','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444845,-89.567673,0,'2013-07-06 12:44:32',NULL,NULL),(79805,'99363','P','Wallula','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.083748,-118.907555,0,'2013-07-06 12:44:34',NULL,NULL),(77949,'97352','S','Jefferson','D','Marion','41047','Oregon','OR','41','7080','541','Pacific',-8.0,'Y',44.740581,-123.021516,0,'2013-07-06 12:44:34',NULL,NULL),(52579,'60969','P','Union Hill','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.109158,-88.144731,0,'2013-07-06 12:44:33',NULL,NULL),(40948,'46303','S','Cedar Lake','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.377765,-87.444811,0,'2013-07-06 12:44:32',NULL,NULL),(76969,'96051','S','Lakehead','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.877574,-122.371334,0,'2013-07-06 12:44:34',NULL,NULL),(43508,'48632','S','Lake','D','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.895163,-85.005528,0,'2013-07-06 12:44:32',NULL,NULL),(54874,'63053','P','Imperial','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.367900,-90.365393,0,'2013-07-06 12:44:33',NULL,NULL),(22669,'24283','S','Saint Paul','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.936209,-82.355456,0,'2013-07-06 12:44:31',NULL,NULL),(27795,'30385','U','ATT Bellsouth','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.674395,-84.441613,0,'2013-07-06 12:44:31',NULL,NULL),(65512,'77705','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.969400,-94.155300,0,'2013-07-06 12:44:34',NULL,NULL),(44059,'49441','S','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168889,-86.263889,0,'2013-07-06 12:44:32',NULL,NULL),(6736,'06077','P','Staffordville','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.994937,-72.260286,0,'2013-07-06 12:44:30',NULL,NULL),(48340,'55473','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.961613,-93.266171,0,'2013-07-06 12:44:33',NULL,NULL),(36980,'41180','S','Webbville','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.152071,-82.793657,0,'2013-07-06 12:44:32',NULL,NULL),(56203,'65025','S','Clarksburg','D','Moniteau','29135','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.630773,-92.682499,0,'2013-07-06 12:44:33',NULL,NULL),(3513,'01876','S','Tewksbury','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.599815,-71.222861,0,'2013-07-06 12:44:30',NULL,NULL),(28032,'30642','S','Greensboro','D','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.556831,-83.171996,0,'2013-07-06 12:44:31',NULL,NULL),(52479,'60690','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.882153,-87.630933,0,'2013-07-06 12:44:33',NULL,NULL),(11176,'11731','S','Elwood','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.864288,-73.317866,0,'2013-07-06 12:44:30',NULL,NULL),(10653,'11103','S','Long Island City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.762281,-73.910107,0,'2013-07-06 12:44:30',NULL,NULL),(42875,'48085','S','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595219,-83.120115,0,'2013-07-06 12:44:32',NULL,NULL),(44011,'49356','U','Amway Corp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.956876,-85.481400,0,'2013-07-06 12:44:32',NULL,NULL),(48676,'55922','S','Canton','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.587946,-91.908721,0,'2013-07-06 12:44:33',NULL,NULL),(49718,'57039','S','Lennox','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.353196,-96.892740,0,'2013-07-06 12:44:33',NULL,NULL),(11360,'11819','U','Chase Bank','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.763511,-73.532506,0,'2013-07-06 12:44:30',NULL,NULL),(6973,'06239','S','Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.790480,-71.855880,0,'2013-07-06 12:44:30',NULL,NULL),(46498,'53227','S','West Allis','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994705,-88.042267,0,'2013-07-06 12:44:32',NULL,NULL),(8137,'07836','S','Roxbury Township','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.853244,-74.708204,0,'2013-07-06 12:44:30',NULL,NULL),(3560,'01945','S','Mhead','N','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.497030,-70.866105,0,'2013-07-06 12:44:30',NULL,NULL),(61883,'73132','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.545017,-97.635324,0,'2013-07-06 12:44:33',NULL,NULL),(49272,'56484','S','Walker','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(13781,'14166','P','Dunkirk','A','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.450113,-79.417318,0,'2013-07-06 12:44:31',NULL,NULL),(46073,'52584','S','Pulaski','D','Davis','19051','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.695621,-92.235799,0,'2013-07-06 12:44:32',NULL,NULL),(17352,'17872','S','Bear Valley','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(8482,'08092','S','West Creek','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.653280,-74.280720,0,'2013-07-06 12:44:30',NULL,NULL),(55807,'64138','S','Raytown','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.971599,-94.474727,0,'2013-07-06 12:44:33',NULL,NULL),(24220,'26716','S','Horse Shoe Rn','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.291239,-79.511965,0,'2013-07-06 12:44:31',NULL,NULL),(6325,'05663','S','Riverton','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.149825,-72.660946,0,'2013-07-06 12:44:30',NULL,NULL),(8107,'07806','S','Dover','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.939389,-74.558453,0,'2013-07-06 12:44:30',NULL,NULL),(3617,'02056','S','Norfolk','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.118496,-71.328676,0,'2013-07-06 12:44:30',NULL,NULL),(78847,'98338','S','Graham','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.033524,-122.293101,0,'2013-07-06 12:44:34',NULL,NULL),(31489,'34434','S','Citrus Springs','A','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.998415,-82.431555,0,'2013-07-06 12:44:32',NULL,NULL),(15125,'15825','S','Brookville','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.174100,-79.067400,0,'2013-07-06 12:44:31',NULL,NULL),(43625,'48819','S','Dansville','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.547264,-84.279402,0,'2013-07-06 12:44:32',NULL,NULL),(36081,'40216','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.189129,-85.835133,0,'2013-07-06 12:44:32',NULL,NULL),(57148,'66251','U','Op','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.020332,-94.663201,0,'2013-07-06 12:44:33',NULL,NULL),(36617,'40977','S','Wallsend','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(13254,'13646','S','Edwardsville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.450100,-75.686400,0,'2013-07-06 12:44:30',NULL,NULL),(28508,'31532','S','Snipesville','N','Jeff Davis','13161','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.783139,-82.658447,0,'2013-07-06 12:44:32',NULL,NULL),(7162,'06437','S','Guilford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.316416,-72.695683,0,'2013-07-06 12:44:30',NULL,NULL),(1656,'00773','S','Brisas del Mar','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(4211,'02836','S','Kenyon','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.448096,-71.620839,0,'2013-07-06 12:44:30',NULL,NULL),(75775,'94661','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.829778,-122.209894,0,'2013-07-06 12:44:34',NULL,NULL),(65326,'77515','S','Bonney','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(40610,'45895','S','Wapakoneta','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.579383,-84.175552,0,'2013-07-06 12:44:32',NULL,NULL),(10913,'11428','S','Queens Village','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.719990,-73.740969,0,'2013-07-06 12:44:30',NULL,NULL),(70447,'84744','S','Koosharem','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.513397,-111.882136,0,'2013-07-06 12:44:34',NULL,NULL),(76618,'95698','P','Zamora','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.789567,-121.922857,0,'2013-07-06 12:44:34',NULL,NULL),(62199,'73832','S','Harmon','A','Ellis','40045','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.083700,-99.745800,0,'2013-07-06 12:44:33',NULL,NULL),(6878,'06140','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.789823,-72.663704,0,'2013-07-06 12:44:30',NULL,NULL),(11144,'11713','S','North Bellport','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.769052,-72.942600,0,'2013-07-06 12:44:30',NULL,NULL),(2438,'00953','S','Urb Montecasino Hts','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(11333,'11791','S','Laurel Hollow','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.813797,-73.502844,0,'2013-07-06 12:44:30',NULL,NULL),(21581,'22840','S','Mc Gaheysville','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.404045,-78.719342,0,'2013-07-06 12:44:31',NULL,NULL),(58869,'69154','S','Kowanda','N','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408280,-102.349472,0,'2013-07-06 12:44:33',NULL,NULL),(6377,'05681','S','Woodbury','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.445762,-72.409821,0,'2013-07-06 12:44:30',NULL,NULL),(41001,'46360','S','Pottawattamie Park','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(80196,'99922','P','Hydaburg','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.158425,-132.440454,0,'2013-07-06 12:44:34',NULL,NULL),(56861,'66012','S','Bonner Springs','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.073262,-94.884623,0,'2013-07-06 12:44:33',NULL,NULL),(75461,'94083','P','South San Francisco','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.643644,-122.411982,0,'2013-07-06 12:44:34',NULL,NULL),(72809,'89721','P','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.979214,-119.729519,0,'2013-07-06 12:44:34',NULL,NULL),(20399,'20899','U','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.144286,-77.215257,0,'2013-07-06 12:44:31',NULL,NULL),(5956,'05301','S','Brattleboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(73915,'92021','S','Crest','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.818710,-116.901089,0,'2013-07-06 12:44:34',NULL,NULL),(18863,'19444','S','Lafayette Hill','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.086163,-75.250559,0,'2013-07-06 12:44:31',NULL,NULL),(23025,'24839','S','Hanover','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.555070,-81.821381,0,'2013-07-06 12:44:31',NULL,NULL),(51610,'59830','P','De Borgia','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.393745,-115.346115,0,'2013-07-06 12:44:33',NULL,NULL),(34739,'38850','S','Old Houlka','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.916603,-89.002366,0,'2013-07-06 12:44:32',NULL,NULL),(58798,'68982','S','Sherman','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.392938,-99.121319,0,'2013-07-06 12:44:33',NULL,NULL),(1660,'00773','S','Hacienda Paloma Ii','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(16961,'17702','S','S Williamsprt','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(13407,'13753','S','Meredith','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.282872,-74.910178,0,'2013-07-06 12:44:31',NULL,NULL),(63200,'75435','S','Deport','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.499435,-95.380000,0,'2013-07-06 12:44:33',NULL,NULL),(9859,'10120','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(29094,'32260','P','St Johns','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.077501,-81.580838,0,'2013-07-06 12:44:32',NULL,NULL),(21129,'22102','S','Maclean','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(9039,'08879','S','Laurence Hbr','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.463991,-74.275843,0,'2013-07-06 12:44:30',NULL,NULL),(31329,'34134','S','Bonita Spgs','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.362812,-81.822980,0,'2013-07-06 12:44:32',NULL,NULL),(54907,'63080','S','Spring Bluff','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(56555,'65464','S','Tyrone','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.215181,-91.994666,0,'2013-07-06 12:44:33',NULL,NULL),(35422,'39470','S','Hillsdale','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(50240,'57623','S','Red Elm','N','Ziebach','46137','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.990004,-101.647447,0,'2013-07-06 12:44:33',NULL,NULL),(37581,'42086','S','High Point','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.087107,-88.767014,0,'2013-07-06 12:44:32',NULL,NULL),(2776,'00976','S','Ciudad Universitaria','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(28853,'32095','S','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.916697,-81.339048,0,'2013-07-06 12:44:32',NULL,NULL),(17461,'17948','S','Coles','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(39356,'44628','S','Glenmont','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.536455,-82.219421,0,'2013-07-06 12:44:32',NULL,NULL),(65318,'77510','S','Santa Fe','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.372127,-95.087892,0,'2013-07-06 12:44:34',NULL,NULL),(67625,'80443','P','Frisco','D','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.574380,-106.096920,0,'2013-07-06 12:44:34',NULL,NULL),(72273,'88553','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769808,-106.331320,0,'2013-07-06 12:44:34',NULL,NULL),(8952,'08759','S','Manchester TW','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.952064,-74.365653,0,'2013-07-06 12:44:30',NULL,NULL),(74748,'93060','S','Santa Paula','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.358433,-119.070823,0,'2013-07-06 12:44:34',NULL,NULL),(70984,'85707','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.182027,-110.868630,0,'2013-07-06 12:44:34',NULL,NULL),(43209,'48306','S','Oakland Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(22110,'23426','S','Sanford','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.922079,-75.683828,0,'2013-07-06 12:44:31',NULL,NULL),(47772,'55040','S','Isanti','D','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.492258,-93.250696,0,'2013-07-06 12:44:33',NULL,NULL),(12597,'13077','S','Scott','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.676667,-76.189530,0,'2013-07-06 12:44:30',NULL,NULL),(78291,'97877','S','Sumpter','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.729195,-118.264168,0,'2013-07-06 12:44:34',NULL,NULL),(76772,'95934','S','Crescent Mills','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.088345,-120.891835,0,'2013-07-06 12:44:34',NULL,NULL),(66126,'78426','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.840566,-97.597016,0,'2013-07-06 12:44:34',NULL,NULL),(65307,'77498','S','Sugar Land','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.615834,-95.552346,0,'2013-07-06 12:44:34',NULL,NULL),(61027,'72117','S','Marche','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(15898,'17010','P','Campbelltown','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.274565,-76.580954,0,'2013-07-06 12:44:31',NULL,NULL),(31604,'34677','S','Oldsmar','D','Pinellas','12103','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.045649,-82.687104,0,'2013-07-06 12:44:32',NULL,NULL),(48426,'55609','P','Knife River','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.949401,-91.779693,0,'2013-07-06 12:44:33',NULL,NULL),(63016,'75169','S','Wills Point','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.733837,-96.013236,0,'2013-07-06 12:44:33',NULL,NULL),(9537,'10020','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(50752,'58405','U','Jamestown College','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910278,-98.696046,0,'2013-07-06 12:44:33',NULL,NULL),(33230,'37065','P','Franklin','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.923142,-86.869800,0,'2013-07-06 12:44:32',NULL,NULL),(7894,'07543','P','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.905000,-74.148698,0,'2013-07-06 12:44:30',NULL,NULL),(17686,'18202','S','Hazle Townshp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(16682,'17364','S','Thomasville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.926966,-76.885934,0,'2013-07-06 12:44:31',NULL,NULL),(25989,'28667','P','Rhodhiss','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.776179,-81.426688,0,'2013-07-06 12:44:31',NULL,NULL),(9794,'10109','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(56926,'66066','S','Oskaloosa','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.213571,-95.314577,0,'2013-07-06 12:44:33',NULL,NULL),(58742,'68952','S','Inavale','D','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.085139,-98.667264,0,'2013-07-06 12:44:33',NULL,NULL),(59395,'70629','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.227087,-93.214488,0,'2013-07-06 12:44:33',NULL,NULL),(74510,'92646','S','Huntington','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.665392,-117.968576,0,'2013-07-06 12:44:34',NULL,NULL),(79967,'99641','P','Nunapitchuk','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.011329,-162.059436,0,'2013-07-06 12:44:34',NULL,NULL),(57898,'67645','S','Edmond','A','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610537,-100.001449,0,'2013-07-06 12:44:33',NULL,NULL),(57370,'66743','S','Beulah','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(54692,'62948','S','Paineville','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.801582,-89.028075,0,'2013-07-06 12:44:33',NULL,NULL),(24685,'27412','U','Unc Greensboro','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.065665,-79.806545,0,'2013-07-06 12:44:31',NULL,NULL),(28973,'32208','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.390755,-81.684166,0,'2013-07-06 12:44:32',NULL,NULL),(13623,'13901','S','Kattelville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.156660,-75.890520,0,'2013-07-06 12:44:31',NULL,NULL),(31420,'34243','S','Sarasota','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.408675,-82.523335,0,'2013-07-06 12:44:32',NULL,NULL),(7090,'06351','S','Preston','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.601907,-71.977075,0,'2013-07-06 12:44:30',NULL,NULL),(2764,'00969','S','Vistas De Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(8403,'08065','S','Palmyra','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.004611,-75.012134,0,'2013-07-06 12:44:30',NULL,NULL),(26859,'29530','S','Coward','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.003183,-79.743920,0,'2013-07-06 12:44:31',NULL,NULL),(27212,'29909','S','Spring Island','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.262421,-80.867479,0,'2013-07-06 12:44:31',NULL,NULL),(44576,'50028','S','Baxter','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.820316,-93.148265,0,'2013-07-06 12:44:32',NULL,NULL),(50324,'57730','S','Bakerville','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(51641,'59866','S','Saint Regis','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.298848,-115.094482,0,'2013-07-06 12:44:33',NULL,NULL),(53513,'62022','S','Dow','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.964281,-90.299373,0,'2013-07-06 12:44:33',NULL,NULL),(55129,'63345','S','Farber','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.277771,-91.577512,0,'2013-07-06 12:44:33',NULL,NULL),(62232,'73946','S','Kenton','D','Cimarron','40025','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.851936,-102.905823,0,'2013-07-06 12:44:33',NULL,NULL),(67303,'80018','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.713568,-104.709729,0,'2013-07-06 12:44:34',NULL,NULL),(72466,'89123','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.023482,-115.150519,0,'2013-07-06 12:44:34',NULL,NULL),(15397,'16334','S','Marble','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.331223,-79.444935,0,'2013-07-06 12:44:31',NULL,NULL),(48634,'55810','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.764120,-92.254200,0,'2013-07-06 12:44:33',NULL,NULL),(41803,'47330','S','Centerville','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.797725,-85.011958,0,'2013-07-06 12:44:32',NULL,NULL),(75989,'95076','S','La Selva Beach','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(56195,'65018','S','California','D','Moniteau','29135','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.631897,-92.567720,0,'2013-07-06 12:44:33',NULL,NULL),(38596,'43830','S','Nashport','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.055220,-82.109940,0,'2013-07-06 12:44:32',NULL,NULL),(14178,'14743','S','Hinsdale','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.201120,-78.409800,0,'2013-07-06 12:44:31',NULL,NULL),(33920,'38053','S','Wilkinsville','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(33268,'37096','S','Flatwoods','A','Perry','47135','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.598360,-87.852000,0,'2013-07-06 12:44:32',NULL,NULL),(9295,'09705','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(70150,'84310','S','Liberty','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.338807,-111.865237,0,'2013-07-06 12:44:34',NULL,NULL),(70215,'84401','S','Wilson','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(79121,'98490','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255131,-122.441650,0,'2013-07-06 12:44:34',NULL,NULL),(79144,'98501','S','Schneiders Prairie','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(34482,'38665','S','Sarah','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601919,-90.126392,0,'2013-07-06 12:44:32',NULL,NULL),(14577,'15218','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426383,-79.888677,0,'2013-07-06 12:44:31',NULL,NULL),(33186,'37033','S','Fairfield','N','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(28664,'31784','S','Sale City','D','Mitchell','13205','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.254991,-84.042695,0,'2013-07-06 12:44:32',NULL,NULL),(68193,'81034','U','Ark Valley Corr Facl','N','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.192350,-103.856264,0,'2013-07-06 12:44:34',NULL,NULL),(13301,'13668','S','Norwood','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.762820,-74.991240,0,'2013-07-06 12:44:30',NULL,NULL),(47419,'54659','S','Taylor','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.328279,-91.108533,0,'2013-07-06 12:44:32',NULL,NULL),(1918,'00795','S','Mans En Paseo De Reyes','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(40775,'46160','S','Bean Blossom','N','Morgan','18109','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.380093,-86.264593,0,'2013-07-06 12:44:32',NULL,NULL),(13233,'13638','S','Rutland','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.019385,-75.745627,0,'2013-07-06 12:44:30',NULL,NULL),(19581,'20217','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894934,-77.011177,0,'2013-07-06 12:44:31',NULL,NULL),(30847,'33637','S','Temple Ter','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.032275,-82.365111,0,'2013-07-06 12:44:32',NULL,NULL),(29765,'33009','S','Hallandale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(43280,'48332','P','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465819,-83.378683,0,'2013-07-06 12:44:32',NULL,NULL),(44585,'50038','S','Booneville','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.539788,-93.885271,0,'2013-07-06 12:44:32',NULL,NULL),(46804,'54003','S','Beldenville','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.787574,-92.441735,0,'2013-07-06 12:44:32',NULL,NULL),(50835,'58478','S','Lake Williams','A','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.157419,-99.686502,0,'2013-07-06 12:44:33',NULL,NULL),(54765,'62988','S','Tamms','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.234196,-89.266755,0,'2013-07-06 12:44:33',NULL,NULL),(69516,'83720','U','Idaho State House','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.613494,-116.216151,0,'2013-07-06 12:44:34',NULL,NULL),(71683,'87512','P','Amalia','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.802991,-105.583675,0,'2013-07-06 12:44:34',NULL,NULL),(55154,'63366','S','Cottleville','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(63560,'75766','S','Turney','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:34',NULL,NULL),(47363,'54618','S','Camp Douglas','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.921069,-90.271708,0,'2013-07-06 12:44:32',NULL,NULL),(35459,'39483','S','Whitebluff','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(27217,'29911','S','Brunson','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.925432,-81.187770,0,'2013-07-06 12:44:31',NULL,NULL),(774,'00692','S','Urb Velomas','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(26850,'29518','S','Cades','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.802250,-79.802509,0,'2013-07-06 12:44:31',NULL,NULL),(41448,'46895','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.104804,-85.116922,0,'2013-07-06 12:44:32',NULL,NULL),(31305,'34102','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.143103,-81.799067,0,'2013-07-06 12:44:32',NULL,NULL),(41807,'47331','S','East Connersville','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(54506,'62868','S','Wynoose','N','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.700634,-88.223601,0,'2013-07-06 12:44:33',NULL,NULL),(58404,'68634','P','Duncan','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.390994,-97.538674,0,'2013-07-06 12:44:33',NULL,NULL),(67924,'80907','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.881982,-104.814334,0,'2013-07-06 12:44:34',NULL,NULL),(62481,'74349','P','Grand Lake Towne','A','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.522655,-95.024834,0,'2013-07-06 12:44:33',NULL,NULL),(15835,'16935','S','Middlebury Center','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(33166,'37023','S','Big Rock','D','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.598437,-87.699494,0,'2013-07-06 12:44:32',NULL,NULL),(32339,'35776','S','Woodville','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.575641,-86.243534,0,'2013-07-06 12:44:32',NULL,NULL),(32324,'35764','S','Paint Rock','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.673521,-86.317046,0,'2013-07-06 12:44:32',NULL,NULL),(20476,'21043','S','Daniels','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.266016,-76.845513,0,'2013-07-06 12:44:31',NULL,NULL),(32059,'35266','P','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(23149,'24991','S','Trout','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.951530,-80.512983,0,'2013-07-06 12:44:31',NULL,NULL),(44989,'50434','S','Fertile','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.263400,-93.421488,0,'2013-07-06 12:44:32',NULL,NULL),(47272,'54534','S','Carey','N','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.481944,-90.305833,0,'2013-07-06 12:44:32',NULL,NULL),(48432,'55616','S','Two Harbors','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.029764,-91.671200,0,'2013-07-06 12:44:33',NULL,NULL),(67267,'79978','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.760770,-106.488302,0,'2013-07-06 12:44:34',NULL,NULL),(71155,'86034','P','Jeddito','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.777580,-110.171820,0,'2013-07-06 12:44:34',NULL,NULL),(75682,'94553','S','Pacheco','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.991280,-122.164320,0,'2013-07-06 12:44:34',NULL,NULL),(32260,'35621','S','Eva','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.315232,-86.738421,0,'2013-07-06 12:44:32',NULL,NULL),(58658,'68876','S','Sharon','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.779648,-98.730476,0,'2013-07-06 12:44:33',NULL,NULL),(53030,'61473','S','Youngstown','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.667778,-90.654722,0,'2013-07-06 12:44:33',NULL,NULL),(45967,'52362','S','Hale','A','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.062000,-91.004313,0,'2013-07-06 12:44:32',NULL,NULL),(11365,'11854','U','Hicksville Firms','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.753879,-73.503300,0,'2013-07-06 12:44:30',NULL,NULL),(54463,'62855','P','Mesa Lake','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.534245,-87.886732,0,'2013-07-06 12:44:33',NULL,NULL),(16851,'17562','S','Paradise','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(19856,'20520','U','Dept Of State','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895588,-77.047964,0,'2013-07-06 12:44:31',NULL,NULL),(38711,'44011','S','Avon','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.448666,-82.021439,0,'2013-07-06 12:44:32',NULL,NULL),(17450,'17941','S','Klingerstown','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.726516,-76.605887,0,'2013-07-06 12:44:31',NULL,NULL),(38462,'43615','S','Sylvania Township','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651393,-83.674791,0,'2013-07-06 12:44:32',NULL,NULL),(37547,'42064','S','Frances','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(32762,'36352','S','Waterford','N','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.331380,-85.601124,0,'2013-07-06 12:44:32',NULL,NULL),(11401,'11951','S','Village Of Mastic Beach','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.764527,-72.843517,0,'2013-07-06 12:44:30',NULL,NULL),(20109,'20710','S','Bladensburg','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.942074,-76.931715,0,'2013-07-06 12:44:31',NULL,NULL),(28148,'30824','S','Winfield','N','McDuffie','13189','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.468374,-82.498017,0,'2013-07-06 12:44:31',NULL,NULL),(23707,'25876','S','Saulsville','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.633053,-81.446009,0,'2013-07-06 12:44:31',NULL,NULL),(21634,'22911','S','Charlottesville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.071652,-78.432215,0,'2013-07-06 12:44:31',NULL,NULL),(44292,'49725','S','De Tour Vlle','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.984999,-83.903840,0,'2013-07-06 12:44:32',NULL,NULL),(58856,'69144','S','Keystone','D','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.304038,-101.607568,0,'2013-07-06 12:44:33',NULL,NULL),(59453,'70727','P','Denham Springs','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.449864,-90.967801,0,'2013-07-06 12:44:33',NULL,NULL),(66406,'78629','S','Summerville','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(68696,'82053','S','Burns','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.218272,-104.362776,0,'2013-07-06 12:44:34',NULL,NULL),(69249,'83423','S','Kilgore','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(70256,'84510','P','Aneth','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.210842,-109.289967,0,'2013-07-06 12:44:34',NULL,NULL),(70262,'84516','P','Clawson','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.134526,-111.097580,0,'2013-07-06 12:44:34',NULL,NULL),(79030,'98393','P','Tracyton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.620108,-122.651269,0,'2013-07-06 12:44:34',NULL,NULL),(8210,'07940','S','Madison','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.755677,-74.418689,0,'2013-07-06 12:44:30',NULL,NULL),(71507,'87114','S','Alameda','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(69322,'83469','S','North Fork','A','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.107842,-114.434070,0,'2013-07-06 12:44:34',NULL,NULL),(69787,'84062','S','Pleasant Grove','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.384620,-111.736380,0,'2013-07-06 12:44:34',NULL,NULL),(70518,'85002','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.451112,-112.067779,0,'2013-07-06 12:44:34',NULL,NULL),(74332,'92403','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.102131,-117.269257,0,'2013-07-06 12:44:34',NULL,NULL),(78123,'97523','S','Kerby','N','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.140230,-123.623029,0,'2013-07-06 12:44:34',NULL,NULL),(24631,'27360','S','Thomasville','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.880803,-80.083016,0,'2013-07-06 12:44:31',NULL,NULL),(39367,'44637','S','Stillwell','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.502447,-81.988483,0,'2013-07-06 12:44:32',NULL,NULL),(38334,'43435','S','Helena','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.311944,-83.281389,0,'2013-07-06 12:44:32',NULL,NULL),(37197,'41517','S','Burdine','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.188924,-82.606072,0,'2013-07-06 12:44:32',NULL,NULL),(19411,'20080','U','Washington Gas','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900032,-77.026546,0,'2013-07-06 12:44:31',NULL,NULL),(34764,'38862','S','Richmond','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.197376,-88.663986,0,'2013-07-06 12:44:32',NULL,NULL),(23729,'25915','S','East Gulf','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.623930,-81.286203,0,'2013-07-06 12:44:31',NULL,NULL),(59263,'70449','S','Maurepas','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.272741,-90.698250,0,'2013-07-06 12:44:33',NULL,NULL),(59781,'71209','U','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.528150,-92.072246,0,'2013-07-06 12:44:33',NULL,NULL),(4472,'03263','S','Pittsfield','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.297121,-71.331823,0,'2013-07-06 12:44:30',NULL,NULL),(66801,'79065','S','Pampa','D','Gray','48179','Texas','TX','48','0000','806','Central',-6.0,'Y',35.541949,-100.962049,0,'2013-07-06 12:44:34',NULL,NULL),(69590,'83843','S','University','N','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.728363,-116.968109,0,'2013-07-06 12:44:34',NULL,NULL),(80192,'99918','P','Ketchikan','A','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.358140,-131.698840,0,'2013-07-06 12:44:34',NULL,NULL),(42735,'48014','S','Capac','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.023996,-82.924320,0,'2013-07-06 12:44:32',NULL,NULL),(8311,'08030','S','Gloucstr City','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.887704,-75.115680,0,'2013-07-06 12:44:30',NULL,NULL),(43399,'48445','S','Kinde','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.949160,-83.004445,0,'2013-07-06 12:44:32',NULL,NULL),(18550,'19116','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.121574,-75.018481,0,'2013-07-06 12:44:31',NULL,NULL),(34993,'39111','S','Sanatorium','A','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.872919,-89.734963,0,'2013-07-06 12:44:32',NULL,NULL),(17715,'18235','S','Lehighton Borough','A','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.843037,-75.694426,0,'2013-07-06 12:44:31',NULL,NULL),(16271,'17094','S','Maze','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.564068,-77.237090,0,'2013-07-06 12:44:31',NULL,NULL),(33545,'37394','P','Viola','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.539624,-85.857890,0,'2013-07-06 12:44:32',NULL,NULL),(1316,'00735','S','Parc Calderonas Nuevas','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(4171,'02804','S','Ashaway','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.425785,-71.774739,0,'2013-07-06 12:44:30',NULL,NULL),(14598,'15223','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.468740,-79.957200,0,'2013-07-06 12:44:31',NULL,NULL),(2734,'00969','S','Urb Juan Ponce de Leon','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(2207,'00926','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(12296,'12849','S','Middle Granville','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.451548,-73.301373,0,'2013-07-06 12:44:30',NULL,NULL),(44465,'49884','S','Shingleton','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.355034,-86.452403,0,'2013-07-06 12:44:32',NULL,NULL),(53291,'61727','S','South Clinton','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(64234,'76308','S','Lakeside City','N','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.869770,-98.538219,0,'2013-07-06 12:44:34',NULL,NULL),(66325,'78597','S','South Padre Island','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.109550,-97.168003,0,'2013-07-06 12:44:34',NULL,NULL),(71901,'87750','S','Valmora','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.810499,-104.924862,0,'2013-07-06 12:44:34',NULL,NULL),(73594,'91387','S','Canyon Country','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425030,-118.444260,0,'2013-07-06 12:44:34',NULL,NULL),(79997,'99664','S','Seward','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.137917,-149.439230,0,'2013-07-06 12:44:34',NULL,NULL),(36927,'41160','S','Mazie','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.033886,-82.858510,0,'2013-07-06 12:44:32',NULL,NULL),(50402,'57773','P','Pringle','D','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.609429,-103.594212,0,'2013-07-06 12:44:33',NULL,NULL),(48353,'55484','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.970317,-93.280682,0,'2013-07-06 12:44:33',NULL,NULL),(34939,'39046','S','Canton','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.639280,-90.007500,0,'2013-07-06 12:44:32',NULL,NULL),(8065,'07748','S','N Middletown','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.395074,-74.109292,0,'2013-07-06 12:44:30',NULL,NULL),(28227,'31038','S','Round Oak','A','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.174782,-83.709904,0,'2013-07-06 12:44:31',NULL,NULL),(29962,'33076','S','Parkland','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.266880,-80.284560,0,'2013-07-06 12:44:32',NULL,NULL),(26566,'29210','S','Dutch Fork','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.040812,-81.095436,0,'2013-07-06 12:44:31',NULL,NULL),(7205,'06484','S','Shelton','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.313540,-73.137300,0,'2013-07-06 12:44:30',NULL,NULL),(18495,'19094','S','Woodlyn','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.873824,-75.345641,0,'2013-07-06 12:44:31',NULL,NULL),(214,'00624','S','Ext Alts de Penuelas II','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(35809,'39759','S','Muldrow','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(30315,'33305','S','Lazy Lake','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.156150,-80.122239,0,'2013-07-06 12:44:32',NULL,NULL),(12324,'12865','S','Belcher','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(70912,'85628','P','Nogales','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.414484,-110.893584,0,'2013-07-06 12:44:34',NULL,NULL),(78155,'97620','P','Adel','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.192887,-119.719932,0,'2013-07-06 12:44:34',NULL,NULL),(62844,'75016','P','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.901900,-96.978136,0,'2013-07-06 12:44:33',NULL,NULL),(73364,'91020','S','Montrose','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.209369,-118.229787,0,'2013-07-06 12:44:34',NULL,NULL),(18782,'19372','S','Thorndale','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.992760,-75.758760,0,'2013-07-06 12:44:31',NULL,NULL),(24460,'27229','S','Candor','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.226802,-79.791427,0,'2013-07-06 12:44:31',NULL,NULL),(17495,'17960','S','West Penn','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(21288,'22334','U','Sun Trust Bank','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.803177,-77.058685,0,'2013-07-06 12:44:31',NULL,NULL),(9291,'09701','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(55017,'63134','S','Edmundson','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.738992,-90.342092,0,'2013-07-06 12:44:33',NULL,NULL),(5462,'04735','S','Bridgewater','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.419626,-67.849255,0,'2013-07-06 12:44:30',NULL,NULL),(3144,'01255','S','South Sandisfield','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.117840,-73.134120,0,'2013-07-06 12:44:30',NULL,NULL),(43500,'48626','S','Hemlock','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.410234,-84.223586,0,'2013-07-06 12:44:32',NULL,NULL),(34686,'38828','S','Alpine','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(39163,'44305','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.073760,-81.465332,0,'2013-07-06 12:44:32',NULL,NULL),(35778,'39745','S','French Camp','D','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.290348,-89.401960,0,'2013-07-06 12:44:32',NULL,NULL),(12093,'12568','P','Plattekill','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.612267,-74.062280,0,'2013-07-06 12:44:30',NULL,NULL),(52720,'61230','S','Ceffco','N','Whiteside','17195','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.766402,-90.214367,0,'2013-07-06 12:44:33',NULL,NULL),(52933,'61376','S','Walnut','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.534821,-89.602442,0,'2013-07-06 12:44:33',NULL,NULL),(53807,'62293','S','Sugar Creek','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.607272,-89.683388,0,'2013-07-06 12:44:33',NULL,NULL),(55734,'64086','S','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.919180,-94.320840,0,'2013-07-06 12:44:33',NULL,NULL),(58192,'68314','S','Bee','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.007694,-97.054158,0,'2013-07-06 12:44:33',NULL,NULL),(61378,'72527','S','Desha','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.732739,-91.681637,0,'2013-07-06 12:44:33',NULL,NULL),(71693,'87520','S','Chama','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.857830,-106.600498,0,'2013-07-06 12:44:34',NULL,NULL),(74861,'93257','S','Poplar','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.069871,-119.021504,0,'2013-07-06 12:44:34',NULL,NULL),(24361,'27048','S','Price','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.461117,-79.907962,0,'2013-07-06 12:44:31',NULL,NULL),(13162,'13607','S','Collins Landing','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(42210,'47553','S','Loogootee','D','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(42420,'47802','S','Paint Mill Lake','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(49707,'57034','S','Hudson','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.130420,-96.455230,0,'2013-07-06 12:44:33',NULL,NULL),(49680,'57016','S','Franklin','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.894594,-97.007429,0,'2013-07-06 12:44:33',NULL,NULL),(25735,'28556','S','Merritt','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.110791,-76.694764,0,'2013-07-06 12:44:31',NULL,NULL),(12905,'13337','S','Otsego','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.734651,-74.991943,0,'2013-07-06 12:44:30',NULL,NULL),(60958,'72103','S','Mabelvale','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.590766,-92.379460,0,'2013-07-06 12:44:33',NULL,NULL),(17452,'17941','S','Rough and Ready','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.726516,-76.605887,0,'2013-07-06 12:44:31',NULL,NULL),(46103,'52627','S','Fort Madison','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.632072,-91.335554,0,'2013-07-06 12:44:32',NULL,NULL),(46750,'53927','P','Dellwood','D','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.984167,-89.938611,0,'2013-07-06 12:44:32',NULL,NULL),(52834,'61313','S','Blackstone','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.063846,-88.642597,0,'2013-07-06 12:44:33',NULL,NULL),(39090,'44224','S','Cuyahoga Fls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.173500,-81.449700,0,'2013-07-06 12:44:32',NULL,NULL),(18533,'19110','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953564,-75.166015,0,'2013-07-06 12:44:31',NULL,NULL),(60520,'71667','S','Star City','D','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(35623,'39629','S','Bouge Chitto','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.485120,-90.452940,0,'2013-07-06 12:44:32',NULL,NULL),(45288,'50702','S','Waterloo','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.470074,-92.327921,0,'2013-07-06 12:44:32',NULL,NULL),(12425,'12946','S','Lake Placid','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.281966,-73.988816,0,'2013-07-06 12:44:30',NULL,NULL),(65280,'77480','S','Sweeny','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.059338,-95.705377,0,'2013-07-06 12:44:34',NULL,NULL),(71868,'87722','S','Guadalupita','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.145903,-105.136117,0,'2013-07-06 12:44:34',NULL,NULL),(52066,'60290','U','Jt Weeker Isc','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881027,-87.624730,0,'2013-07-06 12:44:33',NULL,NULL),(49472,'56654','S','Loman','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.517326,-93.899334,0,'2013-07-06 12:44:33',NULL,NULL),(70068,'84147','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758841,-111.883105,0,'2013-07-06 12:44:34',NULL,NULL),(32551,'36111','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.337152,-86.267594,0,'2013-07-06 12:44:32',NULL,NULL),(76464,'95616','S','Davis','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.556431,-121.746377,0,'2013-07-06 12:44:34',NULL,NULL),(65726,'78039','S','La Coste','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.316965,-98.832569,0,'2013-07-06 12:44:34',NULL,NULL),(22170,'23465','U','Chrstn Brdcst Network','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.797995,-76.176483,0,'2013-07-06 12:44:31',NULL,NULL),(38238,'43240','S','Columbus','D','Delaware','39041','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.140503,-82.986473,0,'2013-07-06 12:44:32',NULL,NULL),(58384,'68588','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.821099,-96.711844,0,'2013-07-06 12:44:33',NULL,NULL),(78853,'98339','S','Port Hadlock','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.027885,-122.759844,0,'2013-07-06 12:44:34',NULL,NULL),(45122,'50563','S','Manson','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.530080,-94.537593,0,'2013-07-06 12:44:32',NULL,NULL),(15781,'16922','S','West Branch','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.712840,-77.662020,0,'2013-07-06 12:44:31',NULL,NULL),(20254,'20782','S','W Hyattsville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(1489,'00751','S','Brisas De Evelymar','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(68656,'81646','P','Molina','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.189509,-108.061834,0,'2013-07-06 12:44:34',NULL,NULL),(69259,'83429','S','Box Canyon','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.459589,-111.345873,0,'2013-07-06 12:44:34',NULL,NULL),(76930,'96017','S','Castella','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',41.141859,-122.318402,0,'2013-07-06 12:44:34',NULL,NULL),(10100,'10249','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(30908,'33707','S','Gulfport','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(32590,'36125','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.313036,-86.318132,0,'2013-07-06 12:44:32',NULL,NULL),(2501,'00957','S','BO Los Angeles','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(73187,'90411','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.012451,-118.471282,0,'2013-07-06 12:44:34',NULL,NULL),(71056,'85751','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.248543,-110.834322,0,'2013-07-06 12:44:34',NULL,NULL),(65230,'77449','S','Katy','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.819538,-95.752260,0,'2013-07-06 12:44:34',NULL,NULL),(23143,'24985','S','Wayside','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.634903,-80.702448,0,'2013-07-06 12:44:31',NULL,NULL),(2222,'00926','S','Urb El Cerezal','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(3164,'01266','S','West Stockbridge','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.333061,-73.380396,0,'2013-07-06 12:44:30',NULL,NULL),(52256,'60521','S','Oak Brk Mall','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.790281,-87.948130,0,'2013-07-06 12:44:33',NULL,NULL),(60465,'71654','S','Mc Gehee','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.656460,-91.408020,0,'2013-07-06 12:44:33',NULL,NULL),(5002,'04219','S','Woodstock','N','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.383477,-70.617546,0,'2013-07-06 12:44:30',NULL,NULL),(2797,'00976','S','Urb Lago Alto','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(18613,'19147','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.936737,-75.154764,0,'2013-07-06 12:44:31',NULL,NULL),(18794,'19383','U','West Chester','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.957668,-75.604923,0,'2013-07-06 12:44:31',NULL,NULL),(14989,'15646','S','Jones Mills','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.066173,-79.317064,0,'2013-07-06 12:44:31',NULL,NULL),(34248,'38392','S','Mercer','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.494613,-89.039633,0,'2013-07-06 12:44:32',NULL,NULL),(67113,'79734','S','Fort Davis','D','Jeff Davis','48243','Texas','TX','48','0000','432','Central',-6.0,'Y',30.709108,-103.914129,0,'2013-07-06 12:44:34',NULL,NULL),(5189,'04443','S','Parkman','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.214034,-69.409404,0,'2013-07-06 12:44:30',NULL,NULL),(1315,'00735','S','Parc Calderonas','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(61159,'72179','S','Hiram','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.447510,-91.900253,0,'2013-07-06 12:44:33',NULL,NULL),(69869,'84094','S','White City','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.563547,-111.859471,0,'2013-07-06 12:44:34',NULL,NULL),(74525,'92653','S','Laguna Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.601535,-117.711678,0,'2013-07-06 12:44:34',NULL,NULL),(77813,'97145','P','Tolovana Park','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.871142,-123.958868,0,'2013-07-06 12:44:34',NULL,NULL),(27407,'30092','S','Peachtree Corners','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.973773,-84.238127,0,'2013-07-06 12:44:31',NULL,NULL),(27076,'29702','S','Blacksburg','D','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.115670,-81.513969,0,'2013-07-06 12:44:31',NULL,NULL),(75043,'93515','P','Bishop','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.360144,-118.401003,0,'2013-07-06 12:44:34',NULL,NULL),(71490,'87104','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.102306,-106.670441,0,'2013-07-06 12:44:34',NULL,NULL),(31010,'33778','S','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.885994,-82.798166,0,'2013-07-06 12:44:32',NULL,NULL),(36452,'40622','U','Ky Dept of Transportation','N','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.197856,-84.871610,0,'2013-07-06 12:44:32',NULL,NULL),(15231,'16030','P','Eau Claire','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.133800,-79.795252,0,'2013-07-06 12:44:31',NULL,NULL),(51375,'59404','S','Great Falls','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.510920,-111.352773,0,'2013-07-06 12:44:33',NULL,NULL),(6102,'05452','S','Essex Junction','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(55496,'63774','P','Perkins','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.095312,-89.775153,0,'2013-07-06 12:44:33',NULL,NULL),(78072,'97465','S','Port Orford','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.760002,-124.486419,0,'2013-07-06 12:44:34',NULL,NULL),(62569,'74455','S','Porum','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.364609,-95.248583,0,'2013-07-06 12:44:33',NULL,NULL),(73682,'91602','S','W Toluca Lake','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(72659,'89434','S','Lockwood','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(72375,'89032','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.224370,-115.171642,0,'2013-07-06 12:44:34',NULL,NULL),(50024,'57420','P','Akaska','D','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.244797,-99.803819,0,'2013-07-06 12:44:33',NULL,NULL),(52597,'61016','S','Irene','N','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.217093,-88.965911,0,'2013-07-06 12:44:33',NULL,NULL),(36114,'40222','S','Glenview Mnr','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(10068,'10178','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(29723,'32954','P','Merritt Is','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.307863,-80.663103,0,'2013-07-06 12:44:32',NULL,NULL),(38763,'44044','S','Grafton','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.270820,-82.045800,0,'2013-07-06 12:44:32',NULL,NULL),(7583,'07032','S','West Arlington','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.762320,-74.123220,0,'2013-07-06 12:44:30',NULL,NULL),(19994,'20602','S','Waldorf','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.603056,-76.938889,0,'2013-07-06 12:44:31',NULL,NULL),(11961,'12454','S','Maplecrest','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.289106,-74.147239,0,'2013-07-06 12:44:30',NULL,NULL),(8904,'08734','S','Lacey Township','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.860897,-74.165767,0,'2013-07-06 12:44:30',NULL,NULL),(75993,'95076','S','Watsonville','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(76730,'95901','S','Hammonton','N','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.215400,-121.463340,0,'2013-07-06 12:44:34',NULL,NULL),(35625,'39630','S','Bude','D','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.463101,-90.850212,0,'2013-07-06 12:44:32',NULL,NULL),(74844,'93245','S','Lemoore Nas','N','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.320100,-119.816820,0,'2013-07-06 12:44:34',NULL,NULL),(13195,'13621','S','Chase Mills','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.859073,-75.069656,0,'2013-07-06 12:44:30',NULL,NULL),(59755,'71153','U','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.515347,-93.749932,0,'2013-07-06 12:44:33',NULL,NULL),(45106,'50546','S','Ware','N','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.842849,-94.734536,0,'2013-07-06 12:44:32',NULL,NULL),(66130,'78460','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.831211,-97.596211,0,'2013-07-06 12:44:34',NULL,NULL),(5067,'04284','S','Wayne','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.354609,-70.078791,0,'2013-07-06 12:44:30',NULL,NULL),(49040,'56285','S','Sacred Heart','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.782863,-95.363020,0,'2013-07-06 12:44:33',NULL,NULL),(1080,'00725','S','Urb Billy Suarez','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(34344,'38578','P','Pleasant Hill','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.981599,-85.202413,0,'2013-07-06 12:44:32',NULL,NULL),(339,'00653','S','Urb Santa Clara','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(64070,'76137','S','Haltom City','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.859978,-97.293430,0,'2013-07-06 12:44:34',NULL,NULL),(27287,'30003','P','Rockbridge','N','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.680810,-84.007320,0,'2013-07-06 12:44:31',NULL,NULL),(18733,'19320','S','West Bradford','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(783,'00693','S','BO La Trocha','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(58729,'68943','S','Hardy','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.009261,-97.923180,0,'2013-07-06 12:44:33',NULL,NULL),(5319,'04570','P','Squirrel Island','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.807043,-69.634374,0,'2013-07-06 12:44:30',NULL,NULL),(30452,'33332','S','Sw Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(78182,'97708','P','Bend','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.074771,-121.301451,0,'2013-07-06 12:44:34',NULL,NULL),(33637,'37686','S','Piney Flats','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.446800,-82.334349,0,'2013-07-06 12:44:32',NULL,NULL),(19108,'19606','S','Mt Penn','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(45902,'52314','S','Mount Vernon','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.936750,-91.438291,0,'2013-07-06 12:44:32',NULL,NULL),(53155,'61561','S','Roanoke','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.797589,-89.200350,0,'2013-07-06 12:44:33',NULL,NULL),(67607,'80430','S','Walden','A','Jackson','08057','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.562500,-106.443889,0,'2013-07-06 12:44:34',NULL,NULL),(67778,'80650','S','Pierce','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.640189,-104.758624,0,'2013-07-06 12:44:34',NULL,NULL),(376,'00660','S','Haciendas Constancia','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(16796,'17540','S','Leacock','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.095709,-76.185401,0,'2013-07-06 12:44:31',NULL,NULL),(9729,'10087','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(21307,'22405','S','Fred','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.320601,-77.414651,0,'2013-07-06 12:44:31',NULL,NULL),(69838,'84081','S','WJ','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(9270,'09613','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28435,'31404','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.044042,-81.068991,0,'2013-07-06 12:44:32',NULL,NULL),(14317,'14898','S','Woodhull','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.077279,-77.409549,0,'2013-07-06 12:44:31',NULL,NULL),(29967,'33081','P','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.017272,-80.199990,0,'2013-07-06 12:44:32',NULL,NULL),(55204,'63385','S','Josephville','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.798044,-90.860524,0,'2013-07-06 12:44:33',NULL,NULL),(33691,'37753','S','Hartford','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.820547,-83.101045,0,'2013-07-06 12:44:32',NULL,NULL),(59069,'70096','P','Westwego','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.905251,-90.142705,0,'2013-07-06 12:44:33',NULL,NULL),(28424,'31331','S','Ashintilly','N','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(3582,'01983','S','Topsfield','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.640415,-70.947058,0,'2013-07-06 12:44:30',NULL,NULL),(28017,'30623','P','Bostwick','D','Morgan','13211','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.735548,-83.522298,0,'2013-07-06 12:44:31',NULL,NULL),(47391,'54637','P','Camp Douglas','A','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.876945,-90.275207,0,'2013-07-06 12:44:32',NULL,NULL),(13490,'13803','S','Freetown','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(45539,'51451','P','Lanesboro','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.184141,-94.694018,0,'2013-07-06 12:44:32',NULL,NULL),(63128,'75336','P','Kleberg','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.674559,-96.619806,0,'2013-07-06 12:44:33',NULL,NULL),(11258,'11767','S','Nesconset','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.843134,-73.147736,0,'2013-07-06 12:44:30',NULL,NULL),(69832,'84081','S','W Jordan','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(30639,'33448','P','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.461111,-80.073056,0,'2013-07-06 12:44:32',NULL,NULL),(16741,'17506','P','Blue Ball','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.116423,-76.050361,0,'2013-07-06 12:44:31',NULL,NULL),(39793,'45133','S','New Market','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(50101,'57473','S','Seneca','D','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.038006,-99.131468,0,'2013-07-06 12:44:33',NULL,NULL),(54602,'62908','S','Belknap','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.328034,-88.950830,0,'2013-07-06 12:44:33',NULL,NULL),(15099,'15767','S','Juneau','A','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.944773,-78.978341,0,'2013-07-06 12:44:31',NULL,NULL),(54724,'62963','S','Mound City','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.091182,-89.167350,0,'2013-07-06 12:44:33',NULL,NULL),(68425,'81212','S','Buckskin Joe','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(6656,'06022','S','Collinsville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.882336,-72.927691,0,'2013-07-06 12:44:30',NULL,NULL),(71889,'87740','S','Colfax','N','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.870600,-104.648580,0,'2013-07-06 12:44:34',NULL,NULL),(15009,'15670','S','New Alexandri','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.414581,-79.384148,0,'2013-07-06 12:44:31',NULL,NULL),(5721,'05001','S','White Riv Jct','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.662310,-72.359191,0,'2013-07-06 12:44:30',NULL,NULL),(15267,'16103','P','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.992916,-80.294581,0,'2013-07-06 12:44:31',NULL,NULL),(60764,'72010','S','Bald Knob','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.305421,-91.585816,0,'2013-07-06 12:44:33',NULL,NULL),(5581,'04912','S','Brighton Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.954513,-69.662463,0,'2013-07-06 12:44:30',NULL,NULL),(26615,'29305','P','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.989259,-81.954612,0,'2013-07-06 12:44:31',NULL,NULL),(46863,'54027','S','Cady','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.956333,-92.173468,0,'2013-07-06 12:44:32',NULL,NULL),(39262,'44450','S','Greene','N','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.460780,-80.830440,0,'2013-07-06 12:44:32',NULL,NULL),(39832,'45156','P','Neville','D','Clermont','39025','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.809335,-84.207927,0,'2013-07-06 12:44:32',NULL,NULL),(58498,'68763','S','Willowdale','N','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.456401,-98.648879,0,'2013-07-06 12:44:33',NULL,NULL),(62006,'73440','S','Lebanon','D','Marshall','40095','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.964525,-96.875097,0,'2013-07-06 12:44:33',NULL,NULL),(4363,'03061','P','Nashua','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.746543,-71.493005,0,'2013-07-06 12:44:30',NULL,NULL),(78434,'98055','S','Renton','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.458993,-122.208401,0,'2013-07-06 12:44:34',NULL,NULL),(18100,'18710','P','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.249324,-75.879888,0,'2013-07-06 12:44:31',NULL,NULL),(28115,'30809','S','Evans','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.541277,-82.136764,0,'2013-07-06 12:44:31',NULL,NULL),(12205,'12787','S','White Sulphur Springs','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.789800,-74.828390,0,'2013-07-06 12:44:30',NULL,NULL),(40097,'45307','P','Bowersville','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.580195,-83.724466,0,'2013-07-06 12:44:32',NULL,NULL),(10510,'10974','S','Sloatsburg','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.160697,-74.189154,0,'2013-07-06 12:44:30',NULL,NULL),(80042,'99702','S','Fairbanks','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.653581,-147.085013,0,'2013-07-06 12:44:34',NULL,NULL),(16863,'17565','S','Colemanville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(49642,'56950','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(49780,'57075','S','Wentworth','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.998194,-96.968790,0,'2013-07-06 12:44:33',NULL,NULL),(32145,'35461','S','Ethelsville','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.380586,-88.218499,0,'2013-07-06 12:44:32',NULL,NULL),(43509,'48632','S','Lake Station','A','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.895163,-85.005528,0,'2013-07-06 12:44:32',NULL,NULL),(69497,'83705','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.580123,-116.219041,0,'2013-07-06 12:44:34',NULL,NULL),(60892,'72069','S','Holly Grove','D','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(19282,'19968','S','Milton','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.781391,-75.282612,0,'2013-07-06 12:44:31',NULL,NULL),(42598,'47885','S','Marion Heights','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(6501,'05778','S','Whiting','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.885116,-73.211804,0,'2013-07-06 12:44:30',NULL,NULL),(6799,'06108','S','Hartfrd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(72142,'88316','S','Angus','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.545370,-105.578780,0,'2013-07-06 12:44:34',NULL,NULL),(71745,'87540','S','Galisteo','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.397323,-105.846760,0,'2013-07-06 12:44:34',NULL,NULL),(65233,'77450','S','Park Row','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.768276,-95.743065,0,'2013-07-06 12:44:34',NULL,NULL),(23807,'26047','S','New Cumberland','D','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.493050,-80.597570,0,'2013-07-06 12:44:31',NULL,NULL),(46171,'52732','S','Hauntown','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.849037,-90.208697,0,'2013-07-06 12:44:32',NULL,NULL),(57240,'66521','S','Onaga','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.491343,-96.171545,0,'2013-07-06 12:44:33',NULL,NULL),(46877,'54106','S','Center Valley','N','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.480124,-88.446752,0,'2013-07-06 12:44:32',NULL,NULL),(45433,'51102','P','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.417726,-96.339615,0,'2013-07-06 12:44:32',NULL,NULL),(24763,'27545','S','Knightdale','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.787687,-78.483413,0,'2013-07-06 12:44:31',NULL,NULL),(45289,'50703','S','Waterloo','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.515044,-92.320054,0,'2013-07-06 12:44:32',NULL,NULL),(42222,'47561','S','Emison','A','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.851331,-87.415278,0,'2013-07-06 12:44:32',NULL,NULL),(76740,'95913','P','Artois','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.729068,-122.144526,0,'2013-07-06 12:44:34',NULL,NULL),(61262,'72366','S','Marvell','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.542820,-90.986332,0,'2013-07-06 12:44:33',NULL,NULL),(27361,'30063','U','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928513,-84.522094,0,'2013-07-06 12:44:31',NULL,NULL),(1331,'00736','S','Bda Polvorin','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(68591,'81526','S','Palisade','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.097318,-108.363606,0,'2013-07-06 12:44:34',NULL,NULL),(44936,'50362','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.596486,-93.765012,0,'2013-07-06 12:44:32',NULL,NULL),(40146,'45347','S','New Paris','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.870254,-84.772952,0,'2013-07-06 12:44:32',NULL,NULL),(46372,'53126','S','Mount Pleasant','N','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.779997,-87.960272,0,'2013-07-06 12:44:32',NULL,NULL),(27800,'30392','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755406,-84.392641,0,'2013-07-06 12:44:31',NULL,NULL),(6709,'06066','S','Talcottville','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(45309,'50840','S','Clearfield','D','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.800557,-94.478617,0,'2013-07-06 12:44:32',NULL,NULL),(66502,'78682','U','Dell Computers','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.515111,-97.672706,0,'2013-07-06 12:44:34',NULL,NULL),(64222,'76273','S','Whitesboro','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.658844,-96.908512,0,'2013-07-06 12:44:34',NULL,NULL),(62324,'74044','S','Lawrence Creek','A','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.121473,-96.344224,0,'2013-07-06 12:44:33',NULL,NULL),(5925,'05252','S','East Arlington','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.057869,-73.137659,0,'2013-07-06 12:44:30',NULL,NULL),(24044,'26415','S','Mountain','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.285557,-80.967156,0,'2013-07-06 12:44:31',NULL,NULL),(37993,'42749','S','Horse Cave','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.185069,-85.878778,0,'2013-07-06 12:44:32',NULL,NULL),(29582,'32821','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.379055,-81.467846,0,'2013-07-06 12:44:32',NULL,NULL),(62224,'73933','S','Boise City','D','Cimarron','40025','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.730203,-102.507607,0,'2013-07-06 12:44:33',NULL,NULL),(78640,'98222','S','Blakely Is','A','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.609071,-122.921563,0,'2013-07-06 12:44:34',NULL,NULL),(67271,'79990','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.848079,-106.440251,0,'2013-07-06 12:44:34',NULL,NULL),(57207,'66434','S','Hiawatha','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.854303,-95.534279,0,'2013-07-06 12:44:33',NULL,NULL),(22630,'24244','S','Clinchport','A','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.707460,-82.809600,0,'2013-07-06 12:44:31',NULL,NULL),(65298,'77491','P','Katy','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.786079,-95.820840,0,'2013-07-06 12:44:34',NULL,NULL),(76007,'95118','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.257586,-121.889924,0,'2013-07-06 12:44:34',NULL,NULL),(77940,'97342','S','Detroit','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.731480,-122.146785,0,'2013-07-06 12:44:34',NULL,NULL),(77830,'97213','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.538000,-122.599744,0,'2013-07-06 12:44:34',NULL,NULL),(20386,'20889','U','Walter Reed Natl Mil Med Ctr','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.009294,-77.097732,0,'2013-07-06 12:44:31',NULL,NULL),(1452,'00742','P','Ceiba','A','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.238935,-65.627433,0,'2013-07-06 12:44:30',NULL,NULL),(59733,'71115','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.383613,-93.665812,0,'2013-07-06 12:44:33',NULL,NULL),(11922,'12420','P','Cragsmoor','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.670081,-74.385271,0,'2013-07-06 12:44:30',NULL,NULL),(26457,'29142','S','Parlers','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.488318,-80.456440,0,'2013-07-06 12:44:31',NULL,NULL),(62085,'73564','S','Cooperton','A','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.850654,-99.024694,0,'2013-07-06 12:44:33',NULL,NULL),(7141,'06408','U','Macys By Mail','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.498889,-72.901111,0,'2013-07-06 12:44:30',NULL,NULL),(4738,'03833','S','Kensington','A','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.977520,-70.992300,0,'2013-07-06 12:44:30',NULL,NULL),(53044,'61480','S','Olena','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.746561,-90.908216,0,'2013-07-06 12:44:33',NULL,NULL),(54213,'62644','S','Eckard','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.297332,-90.063176,0,'2013-07-06 12:44:33',NULL,NULL),(60710,'71952','S','Langley','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.310476,-93.846112,0,'2013-07-06 12:44:33',NULL,NULL),(45138,'50578','S','Ringsted','D','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.236142,-94.319113,0,'2013-07-06 12:44:32',NULL,NULL),(63058,'75226','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.783088,-96.775161,0,'2013-07-06 12:44:33',NULL,NULL),(12137,'12725','S','Claryville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.974754,-74.541152,0,'2013-07-06 12:44:30',NULL,NULL),(31453,'34285','S','Venice','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.072561,-82.435523,0,'2013-07-06 12:44:32',NULL,NULL),(40000,'45243','S','Indian Hill','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.185697,-84.352352,0,'2013-07-06 12:44:32',NULL,NULL),(75028,'93505','S','Calif City','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.132536,-117.956387,0,'2013-07-06 12:44:34',NULL,NULL),(65272,'77476','P','Simonton','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.683333,-95.966667,0,'2013-07-06 12:44:34',NULL,NULL),(41917,'47375','P','Richmond','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.830703,-84.894185,0,'2013-07-06 12:44:32',NULL,NULL),(32019,'35236','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.356611,-86.817395,0,'2013-07-06 12:44:32',NULL,NULL),(32126,'35443','S','Boligee','D','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.763781,-88.025971,0,'2013-07-06 12:44:32',NULL,NULL),(66391,'78624','S','Morris Ranch','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(60768,'72014','P','Beedeville','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.427637,-91.107215,0,'2013-07-06 12:44:33',NULL,NULL),(37897,'42629','S','Sewellton','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.976422,-85.093378,0,'2013-07-06 12:44:32',NULL,NULL),(52923,'61370','S','Lowell','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.228820,-89.110860,0,'2013-07-06 12:44:33',NULL,NULL),(62030,'73488','S','Tussy','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.482407,-97.534246,0,'2013-07-06 12:44:33',NULL,NULL),(68845,'82601','S','Casper','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.840004,-106.321610,0,'2013-07-06 12:44:34',NULL,NULL),(11468,'12016','P','Auriesville','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.928783,-74.319642,0,'2013-07-06 12:44:30',NULL,NULL),(6400,'05733','S','Sudbury','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.798620,-73.094520,0,'2013-07-06 12:44:30',NULL,NULL),(14893,'15488','S','Waltersburg','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.983940,-79.750425,0,'2013-07-06 12:44:31',NULL,NULL),(22968,'24715','S','Bramwell','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.337624,-81.331466,0,'2013-07-06 12:44:31',NULL,NULL),(51275,'59108','P','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.775122,-108.582655,0,'2013-07-06 12:44:33',NULL,NULL),(70911,'85627','P','Pomerene','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.175856,-110.256989,0,'2013-07-06 12:44:34',NULL,NULL),(49866,'57255','S','New Effington','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.877140,-96.918980,0,'2013-07-06 12:44:33',NULL,NULL),(2271,'00926','S','Urb Roseville','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(63511,'75751','S','Baxter','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(73861,'91910','S','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.625054,-117.013699,0,'2013-07-06 12:44:34',NULL,NULL),(68990,'83124','P','Opal','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.769911,-110.321322,0,'2013-07-06 12:44:34',NULL,NULL),(57451,'66846','S','Council Grove','D','Morris','20127','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.660778,-96.489119,0,'2013-07-06 12:44:33',NULL,NULL),(51476,'59538','S','Wagner','N','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.343680,-107.839380,0,'2013-07-06 12:44:33',NULL,NULL),(46898,'54124','S','Pulcifer','A','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.903377,-88.341021,0,'2013-07-06 12:44:32',NULL,NULL),(7790,'07424','S','Woodland Park','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(36574,'40941','P','Garrard','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122850,-83.748834,0,'2013-07-06 12:44:32',NULL,NULL),(45165,'50597','S','West Bend','D','Palo Alto','19147','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.962944,-94.445907,0,'2013-07-06 12:44:32',NULL,NULL),(14026,'14543','S','Rush','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.994532,-77.664004,0,'2013-07-06 12:44:31',NULL,NULL),(21311,'22406','S','Falmouth','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(2054,'00920','S','Caparra Terrace','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(48920,'56144','S','Trosky','A','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.854508,-96.397055,0,'2013-07-06 12:44:33',NULL,NULL),(72198,'88415','S','Bueyeros','A','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(73762,'91732','S','El Monte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.074497,-118.011309,0,'2013-07-06 12:44:34',NULL,NULL),(80205,'99950','P','Ketchikan','D','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.340000,-131.640000,0,'2013-07-06 12:44:34',NULL,NULL),(43197,'48303','P','Bloomfield Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(50394,'57769','S','Summerset','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.229112,-103.390064,0,'2013-07-06 12:44:33',NULL,NULL),(25111,'27978','S','Stumpy Point','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.750419,-75.808743,0,'2013-07-06 12:44:31',NULL,NULL),(9824,'10113','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(32378,'35903','S','Hokes Bluff','A','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.993300,-85.905900,0,'2013-07-06 12:44:32',NULL,NULL),(16808,'17543','S','Poplar Grove','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(17512,'17963','S','Roedersville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(29147,'32333','S','Havana','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.620089,-84.419787,0,'2013-07-06 12:44:32',NULL,NULL),(19711,'20390','U','Dept Navy Other Offices','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884615,-76.993490,0,'2013-07-06 12:44:31',NULL,NULL),(33175,'37030','S','Defeated','A','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.262380,-85.994400,0,'2013-07-06 12:44:32',NULL,NULL),(55625,'63965','S','South Van Buren','N','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(45030,'50469','S','Burchinal','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.012320,-93.314520,0,'2013-07-06 12:44:32',NULL,NULL),(15872,'16950','S','Little Marsh','A','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(28866,'32116','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.212508,-81.008741,0,'2013-07-06 12:44:32',NULL,NULL),(28817,'32079','P','Penney Farms','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.984314,-81.808272,0,'2013-07-06 12:44:32',NULL,NULL),(73153,'90292','S','Marina del Rey','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.985510,-118.453180,0,'2013-07-06 12:44:34',NULL,NULL),(60385,'71601','S','Hardin','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.201680,-91.929399,0,'2013-07-06 12:44:33',NULL,NULL),(76543,'95660','S','North Highlands','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.687272,-121.376063,0,'2013-07-06 12:44:34',NULL,NULL),(74855,'93251','S','Mc Kittrick','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.468972,-119.676436,0,'2013-07-06 12:44:34',NULL,NULL),(71649,'87461','P','Sanostee','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.433337,-108.871740,0,'2013-07-06 12:44:34',NULL,NULL),(68746,'82219','S','Jay Em','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.384406,-104.332696,0,'2013-07-06 12:44:34',NULL,NULL),(66016,'78357','S','Seven Sisters','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.861524,-98.563007,0,'2013-07-06 12:44:34',NULL,NULL),(56950,'66095','S','Williamsburg','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.480623,-95.464930,0,'2013-07-06 12:44:33',NULL,NULL),(20759,'21412','U','Bancroft Hall','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.122086,-76.529331,0,'2013-07-06 12:44:31',NULL,NULL),(3146,'01257','S','Sheffield','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.077092,-73.395288,0,'2013-07-06 12:44:30',NULL,NULL),(3275,'01471','U','New England Business Svc Inc','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.607854,-71.572329,0,'2013-07-06 12:44:30',NULL,NULL),(27913,'30502','P','Oakwood','A','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.176858,-83.907840,0,'2013-07-06 12:44:31',NULL,NULL),(28006,'30607','S','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.992365,-83.416707,0,'2013-07-06 12:44:31',NULL,NULL),(16363,'17201','S','Guilford Township','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(39500,'44805','S','Olivesburg','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.853220,-82.315020,0,'2013-07-06 12:44:32',NULL,NULL),(50961,'58623','S','Ladd','N','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.179366,-103.400993,0,'2013-07-06 12:44:33',NULL,NULL),(30646,'33454','P','Greenacres','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.594768,-80.200705,0,'2013-07-06 12:44:32',NULL,NULL),(42959,'48130','S','Hudson Mills','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(19789,'20431','U','International Monetary Fund','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895708,-77.044874,0,'2013-07-06 12:44:31',NULL,NULL),(67995,'80919','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.928018,-104.848484,0,'2013-07-06 12:44:34',NULL,NULL),(72331,'89009','P','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.057322,-114.961265,0,'2013-07-06 12:44:34',NULL,NULL),(717,'00687','S','Praderas De Morovis Sur','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(16848,'17562','S','Lapark','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(25267,'28125','S','Bear Poplar','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.640595,-80.716219,0,'2013-07-06 12:44:31',NULL,NULL),(49491,'56661','S','Nore','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(61803,'73097','P','Wheatland','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.397374,-97.652196,0,'2013-07-06 12:44:33',NULL,NULL),(77987,'97394','S','Waldport','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.421450,-124.047173,0,'2013-07-06 12:44:34',NULL,NULL),(76793,'95945','S','Glenbrook Heights','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(76645,'95722','S','Meadow Vista','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.004269,-121.028689,0,'2013-07-06 12:44:34',NULL,NULL),(64126,'76191','U','Chase Bank','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.808015,-97.354309,0,'2013-07-06 12:44:34',NULL,NULL),(52553,'60946','S','Kempton','D','Ford','17053','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.933757,-88.236069,0,'2013-07-06 12:44:33',NULL,NULL),(26476,'29152','S','Shaw AFB','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.983141,-80.485057,0,'2013-07-06 12:44:31',NULL,NULL),(24776,'27560','S','Morrisville','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.825795,-78.836037,0,'2013-07-06 12:44:31',NULL,NULL),(33056,'36759','S','Marion Jct','A','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.440860,-87.349080,0,'2013-07-06 12:44:32',NULL,NULL),(16243,'17082','S','Academia','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(6760,'06092','S','West Simsbury','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.870101,-72.861810,0,'2013-07-06 12:44:30',NULL,NULL),(32406,'35962','S','Crossville','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.283369,-85.998076,0,'2013-07-06 12:44:32',NULL,NULL),(55815,'64147','S','Martin City','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.852262,-94.547801,0,'2013-07-06 12:44:33',NULL,NULL),(42105,'47462','S','Springville','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003349,-86.589842,0,'2013-07-06 12:44:32',NULL,NULL),(12450,'12966','S','North Bangor','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.818980,-74.415000,0,'2013-07-06 12:44:30',NULL,NULL),(25368,'28244','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.228942,-80.845170,0,'2013-07-06 12:44:31',NULL,NULL),(71077,'85923','P','Clay Springs','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.360411,-110.296265,0,'2013-07-06 12:44:34',NULL,NULL),(18972,'19518','S','West Monocacy','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(34115,'38184','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.185496,-89.864856,0,'2013-07-06 12:44:32',NULL,NULL),(15134,'15841','P','Force','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.260072,-78.499772,0,'2013-07-06 12:44:31',NULL,NULL),(44275,'49710','S','Barbeau','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.486615,-84.376114,0,'2013-07-06 12:44:32',NULL,NULL),(55100,'63304','S','Saint Charles','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(75109,'93545','S','Dolomite','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.588000,-118.056263,0,'2013-07-06 12:44:34',NULL,NULL),(73845,'91792','S','West Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.021820,-117.897867,0,'2013-07-06 12:44:34',NULL,NULL),(73504,'91333','P','Pacoima','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.266069,-118.426873,0,'2013-07-06 12:44:34',NULL,NULL),(67953,'80912','S','Schriever AFB','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(64592,'76678','S','Prairie Hill','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.651957,-96.786893,0,'2013-07-06 12:44:34',NULL,NULL),(51770,'60035','S','Highland Park','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.182657,-87.805479,0,'2013-07-06 12:44:33',NULL,NULL),(49827,'57220','S','Bruce','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.485116,-96.934663,0,'2013-07-06 12:44:33',NULL,NULL),(20260,'20784','S','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(33781,'37874','S','Sweetwater','D','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.600803,-84.460574,0,'2013-07-06 12:44:32',NULL,NULL),(36720,'41031','S','Buena Vista','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(41198,'46725','S','Coesse','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(24296,'27011','S','Boonville','D','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.240300,-80.637420,0,'2013-07-06 12:44:31',NULL,NULL),(29103,'32304','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.424511,-84.324199,0,'2013-07-06 12:44:32',NULL,NULL),(32734,'36318','S','Coffee Springs','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.169648,-85.910785,0,'2013-07-06 12:44:32',NULL,NULL),(2437,'00953','S','Urb Montecasino','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(67928,'80908','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.046410,-104.669910,0,'2013-07-06 12:44:34',NULL,NULL),(1418,'00738','S','Valle Verde','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(57444,'66839','S','New Strawn','A','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.195231,-95.743973,0,'2013-07-06 12:44:33',NULL,NULL),(57188,'66415','S','Centralia','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.726064,-96.129109,0,'2013-07-06 12:44:33',NULL,NULL),(34555,'38725','S','Eutaw','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(47077,'54430','S','Elton','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.150241,-88.895219,0,'2013-07-06 12:44:32',NULL,NULL),(79428,'98828','S','Malaga','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.353050,-120.205699,0,'2013-07-06 12:44:34',NULL,NULL),(71451,'87044','S','Ponderosa','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.661919,-106.666841,0,'2013-07-06 12:44:34',NULL,NULL),(68562,'81435','S','Mountain Vlg','A','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.979875,-107.941486,0,'2013-07-06 12:44:34',NULL,NULL),(66737,'78959','S','Waelder','D','Gonzales','48177','Texas','TX','48','0000','512/737','Central',-6.0,'Y',29.695667,-97.293035,0,'2013-07-06 12:44:34',NULL,NULL),(64269,'76402','U','Tarleton State Univ','N','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.218530,-98.217122,0,'2013-07-06 12:44:34',NULL,NULL),(54476,'62859','S','Mc Leansboro','D','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(51941,'60128','U','Household Finance Corp','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.916845,-88.105772,0,'2013-07-06 12:44:33',NULL,NULL),(41979,'47421','S','Guthrie','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(29544,'32801','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.538375,-81.374693,0,'2013-07-06 12:44:32',NULL,NULL),(37953,'42717','S','Waterview','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(55378,'63620','S','Annapolis','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.429977,-90.655396,0,'2013-07-06 12:44:33',NULL,NULL),(58918,'69336','S','Bridgeport','D','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.674740,-103.054260,0,'2013-07-06 12:44:33',NULL,NULL),(59620,'71032','S','Grand Cane','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.117220,-93.776940,0,'2013-07-06 12:44:33',NULL,NULL),(59798,'71220','S','Wardville','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(66680,'78938','S','Ellinger','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.836939,-96.697511,0,'2013-07-06 12:44:34',NULL,NULL),(73239,'90670','S','Santa Fe Spgs','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.935015,-118.068892,0,'2013-07-06 12:44:34',NULL,NULL),(79718,'99213','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.656583,-117.291099,0,'2013-07-06 12:44:34',NULL,NULL),(62860,'75028','S','Flowermound','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.033405,-97.067657,0,'2013-07-06 12:44:33',NULL,NULL),(59762,'71162','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.503045,-93.741033,0,'2013-07-06 12:44:33',NULL,NULL),(45948,'52347','S','Victor','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.729129,-92.294632,0,'2013-07-06 12:44:32',NULL,NULL),(12982,'13404','P','Martinsburg','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.738157,-75.468625,0,'2013-07-06 12:44:30',NULL,NULL),(64360,'76522','S','Topsey','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.138380,-97.934220,0,'2013-07-06 12:44:34',NULL,NULL),(67811,'80745','S','Padroni','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.842172,-103.291729,0,'2013-07-06 12:44:34',NULL,NULL),(34257,'38452','S','Cypress Inn','D','Wayne','47181','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.057191,-87.795538,0,'2013-07-06 12:44:32',NULL,NULL),(32229,'35578','S','Nauvoo','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.933720,-87.426540,0,'2013-07-06 12:44:32',NULL,NULL),(68243,'81055','S','Ojo','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.461120,-105.039180,0,'2013-07-06 12:44:34',NULL,NULL),(77155,'96203','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(61076,'72127','S','Hill Creek','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.160737,-92.634377,0,'2013-07-06 12:44:33',NULL,NULL),(193,'00623','S','Urb El Retiro','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(6090,'05450','S','S Franklin','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(5981,'05346','S','E Dummerston','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.955143,-72.565046,0,'2013-07-06 12:44:30',NULL,NULL),(14580,'15219','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.447423,-79.979867,0,'2013-07-06 12:44:31',NULL,NULL),(8599,'08232','S','Farmington','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(14080,'14612','S','Greece','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.256923,-77.669136,0,'2013-07-06 12:44:31',NULL,NULL),(24132,'26555','P','Fairmont','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.470255,-80.150258,0,'2013-07-06 12:44:31',NULL,NULL),(20660,'21226','S','Curtis Bay','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(53424,'61853','S','Mahomet','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.198333,-88.389388,0,'2013-07-06 12:44:33',NULL,NULL),(55171,'63368','S','O Fallon','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.757000,-90.724700,0,'2013-07-06 12:44:33',NULL,NULL),(58998,'70060','U','La Gas Serv Inc','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.867768,-90.068648,0,'2013-07-06 12:44:33',NULL,NULL),(59129,'70161','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.941124,-90.080453,0,'2013-07-06 12:44:33',NULL,NULL),(59952,'71301','S','Timber Trails','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(68206,'81043','P','Hartman','D','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.088807,-102.169281,0,'2013-07-06 12:44:34',NULL,NULL),(14536,'15208','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.456388,-79.897619,0,'2013-07-06 12:44:31',NULL,NULL),(49075,'56318','S','Burtrum','D','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.866944,-94.686134,0,'2013-07-06 12:44:33',NULL,NULL),(25632,'28465','S','Ft Caswell','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(20913,'21722','S','Clear Spring','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.664980,-77.909160,0,'2013-07-06 12:44:31',NULL,NULL),(62551,'74438','P','Hitchita','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.519756,-95.752635,0,'2013-07-06 12:44:33',NULL,NULL),(64783,'77007','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772971,-95.402249,0,'2013-07-06 12:44:34',NULL,NULL),(45694,'52050','S','Greeley','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.602932,-91.308377,0,'2013-07-06 12:44:32',NULL,NULL),(20599,'21204','S','Ruxton','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404090,-76.608279,0,'2013-07-06 12:44:31',NULL,NULL),(24890,'27707','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.964557,-78.940527,0,'2013-07-06 12:44:31',NULL,NULL),(25380,'28258','U','Branch Bank and Trust (BB&T)','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.223001,-80.930365,0,'2013-07-06 12:44:31',NULL,NULL),(18178,'18924','P','Franconia','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.307778,-75.358056,0,'2013-07-06 12:44:31',NULL,NULL),(10184,'10286','U','Bank of New York','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705704,-74.007966,0,'2013-07-06 12:44:30',NULL,NULL),(37113,'41385','S','Taulbee','N','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.628288,-83.413815,0,'2013-07-06 12:44:32',NULL,NULL),(54903,'63079','P','Stanton','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.275896,-91.104717,0,'2013-07-06 12:44:33',NULL,NULL),(53847,'62321','S','Harmony','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(23198,'25061','P','Drybranch','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.177371,-81.469407,0,'2013-07-06 12:44:31',NULL,NULL),(40821,'46207','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.742239,-86.164298,0,'2013-07-06 12:44:32',NULL,NULL),(62962,'75121','P','Copeville','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.171629,-96.372040,0,'2013-07-06 12:44:33',NULL,NULL),(62188,'73763','S','Okeene','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.117634,-98.330975,0,'2013-07-06 12:44:33',NULL,NULL),(61002,'72113','S','Maumelle','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.852398,-92.404691,0,'2013-07-06 12:44:33',NULL,NULL),(60877,'72063','S','Macedonia','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.289780,-92.784000,0,'2013-07-06 12:44:33',NULL,NULL),(47309,'54555','S','Elk','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(2364,'00949','S','Mans del Mar','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(33109,'36858','S','Hatchechubbee','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.223068,-85.239841,0,'2013-07-06 12:44:32',NULL,NULL),(9579,'10027','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(38451,'43606','S','Ottawa Hills','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.672103,-83.602649,0,'2013-07-06 12:44:32',NULL,NULL),(39523,'44820','S','New Winchester','N','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.816708,-82.969402,0,'2013-07-06 12:44:32',NULL,NULL),(11856,'12257','U','Ny State Dept Financial Svc','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653571,-73.757472,0,'2013-07-06 12:44:30',NULL,NULL),(2714,'00969','S','Parq Torremolinos','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(32450,'36022','S','Deatsville','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.583847,-86.444717,0,'2013-07-06 12:44:32',NULL,NULL),(65731,'78043','S','Rio Bravo','A','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.491910,-99.471710,0,'2013-07-06 12:44:34',NULL,NULL),(73873,'91933','P','Imperial Bch','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.582379,-117.111447,0,'2013-07-06 12:44:34',NULL,NULL),(58429,'68663','S','Silver Creek','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.315738,-97.665030,0,'2013-07-06 12:44:33',NULL,NULL),(16583,'17322','S','Brogueville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.860272,-76.566178,0,'2013-07-06 12:44:31',NULL,NULL),(56233,'65043','S','Wainwright','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.639139,-92.116345,0,'2013-07-06 12:44:33',NULL,NULL),(71406,'87016','S','Estancia','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.775760,-106.171560,0,'2013-07-06 12:44:34',NULL,NULL),(3050,'01107','S','Brightwood','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122891,-72.607189,0,'2013-07-06 12:44:30',NULL,NULL),(77936,'97336','P','Crawfordsvlle','A','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358322,-122.851361,0,'2013-07-06 12:44:34',NULL,NULL),(77571,'96910','S','Toto','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(44636,'50069','S','De Soto','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.529836,-94.062822,0,'2013-07-06 12:44:32',NULL,NULL),(42712,'48001','S','Russell Is','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(25906,'28645','S','Edgemont','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(27576,'30270','U','Peachtree Cty','A','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396971,-84.592052,0,'2013-07-06 12:44:31',NULL,NULL),(11342,'11793','S','Wantagh','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685767,-73.514020,0,'2013-07-06 12:44:30',NULL,NULL),(11849,'12252','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.648263,-73.761928,0,'2013-07-06 12:44:30',NULL,NULL),(19331,'20032','S','Bolling AFB','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(4094,'02670','S','W Dennis','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.660127,-70.167457,0,'2013-07-06 12:44:30',NULL,NULL),(21359,'22442','P','Ragged Point Beach','N','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.146230,-76.633816,0,'2013-07-06 12:44:31',NULL,NULL),(72629,'89419','S','Rye Patch','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(753,'00692','S','Ext Santa Ana','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(60235,'71430','S','Midway','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(1078,'00725','S','Urb Balcones Las Catalinas','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(9956,'10158','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(8168,'07866','S','Rockaway','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.943479,-74.478766,0,'2013-07-06 12:44:30',NULL,NULL),(72757,'89511','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.382155,-119.751830,0,'2013-07-06 12:44:34',NULL,NULL),(58241,'68355','S','Barada','N','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.063372,-95.601580,0,'2013-07-06 12:44:33',NULL,NULL),(75978,'95065','S','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.016503,-121.979468,0,'2013-07-06 12:44:34',NULL,NULL),(67357,'80111','S','Cherry Hills Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(66838,'79110','S','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.149965,-101.872798,0,'2013-07-06 12:44:34',NULL,NULL),(59564,'70835','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.428404,-91.024943,0,'2013-07-06 12:44:33',NULL,NULL),(54850,'63041','S','Grubville','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.231698,-90.793851,0,'2013-07-06 12:44:33',NULL,NULL),(50147,'57537','S','Sansarc','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.433640,-100.547120,0,'2013-07-06 12:44:33',NULL,NULL),(23320,'25209','S','Whitesville','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.970938,-81.529874,0,'2013-07-06 12:44:31',NULL,NULL),(32898,'36538','S','Silver Cross','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.655932,-88.133041,0,'2013-07-06 12:44:32',NULL,NULL),(35680,'39657','S','Gillsburg','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.020240,-90.463920,0,'2013-07-06 12:44:32',NULL,NULL),(37194,'41514','S','Hatfield','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(38082,'43072','S','Saint Paris','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.125518,-83.957665,0,'2013-07-06 12:44:32',NULL,NULL),(7835,'07461','S','Colesville','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(9021,'08869','S','Raritan','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.573369,-74.637747,0,'2013-07-06 12:44:30',NULL,NULL),(64815,'77026','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.791713,-95.332479,0,'2013-07-06 12:44:34',NULL,NULL),(69067,'83239','P','Georgetown','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.471629,-111.396953,0,'2013-07-06 12:44:34',NULL,NULL),(79861,'99557','P','Stony River','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.787030,-156.614710,0,'2013-07-06 12:44:34',NULL,NULL),(19178,'19801','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.736602,-75.548998,0,'2013-07-06 12:44:31',NULL,NULL),(34100,'38173','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.143248,-90.054456,0,'2013-07-06 12:44:32',NULL,NULL),(33040,'36744','S','Greensboro','D','Hale','01065','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.702746,-87.601343,0,'2013-07-06 12:44:32',NULL,NULL),(66293,'78584','S','Los Saenz','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.378999,-98.814980,0,'2013-07-06 12:44:34',NULL,NULL),(16975,'17724','S','Cedar Ledge','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(74590,'92697','U','Univ of California Irvine','N','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648513,-117.838683,0,'2013-07-06 12:44:34',NULL,NULL),(73164,'90301','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.958998,-118.350254,0,'2013-07-06 12:44:34',NULL,NULL),(65699,'78008','S','Fashing','N','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.792111,-98.245657,0,'2013-07-06 12:44:34',NULL,NULL),(25092,'27954','S','Wright Brothers National Mem','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.915917,-75.677254,0,'2013-07-06 12:44:31',NULL,NULL),(44293,'49726','S','Drummond Is','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.998200,-83.715920,0,'2013-07-06 12:44:32',NULL,NULL),(54967,'63121','S','Pasadena Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(67276,'79999','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768099,-106.428742,0,'2013-07-06 12:44:34',NULL,NULL),(34266,'38462','S','Hohenwald','D','Lewis','47101','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.553087,-87.546132,0,'2013-07-06 12:44:32',NULL,NULL),(32455,'36024','S','Eclectic','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.681580,-85.997880,0,'2013-07-06 12:44:32',NULL,NULL),(24717,'27507','S','Bullock','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.361513,-78.529433,0,'2013-07-06 12:44:31',NULL,NULL),(11994,'12483','P','Spring Glen','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.664498,-74.428203,0,'2013-07-06 12:44:30',NULL,NULL),(27771,'30368','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.649172,-84.392574,0,'2013-07-06 12:44:31',NULL,NULL),(66091,'78404','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.766532,-97.401972,0,'2013-07-06 12:44:34',NULL,NULL),(32095,'35294','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.510109,-86.807875,0,'2013-07-06 12:44:32',NULL,NULL),(57598,'67106','S','Milton','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.427920,-97.749981,0,'2013-07-06 12:44:33',NULL,NULL),(6806,'06109','S','Weth','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(38199,'43209','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.959129,-82.928990,0,'2013-07-06 12:44:32',NULL,NULL),(38211,'43215','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.965846,-83.003648,0,'2013-07-06 12:44:32',NULL,NULL),(36987,'41189','S','Tollesboro','D','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.586965,-83.548106,0,'2013-07-06 12:44:32',NULL,NULL),(7035,'06268','S','Storrs Mansfield','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(31861,'35119','P','New Castle','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.648426,-86.773022,0,'2013-07-06 12:44:32',NULL,NULL),(26258,'29006','S','Holtson Crossroads','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(574,'00680','S','Bo Broadway','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(1165,'00727','S','Urb Bonneville Hts','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(41870,'47361','P','Mount Summit','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.005668,-85.386730,0,'2013-07-06 12:44:32',NULL,NULL),(47509,'54768','S','Stanley','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.964604,-90.935717,0,'2013-07-06 12:44:32',NULL,NULL),(78605,'98190','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.503893,-122.294967,0,'2013-07-06 12:44:34',NULL,NULL),(11862,'12301','P','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.813236,-73.939399,0,'2013-07-06 12:44:30',NULL,NULL),(21059,'21915','S','Chesapeake City','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.508657,-75.850582,0,'2013-07-06 12:44:31',NULL,NULL),(40239,'45424','S','Huber','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.845640,-84.111720,0,'2013-07-06 12:44:32',NULL,NULL),(51915,'60110','S','Carpentersvle','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.125226,-88.263423,0,'2013-07-06 12:44:33',NULL,NULL),(33720,'37803','S','Maryville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.764529,-83.964122,0,'2013-07-06 12:44:32',NULL,NULL),(10871,'11418','S','Kew Gardens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.698520,-73.835575,0,'2013-07-06 12:44:30',NULL,NULL),(51653,'59874','S','Trout Creek','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.788105,-115.556441,0,'2013-07-06 12:44:33',NULL,NULL),(48074,'55330','S','Otsego','A','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(24711,'27501','S','Angier','D','Harnett','37085','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.510553,-78.742398,0,'2013-07-06 12:44:31',NULL,NULL),(27551,'30252','S','McDonough','D','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.469647,-84.049084,0,'2013-07-06 12:44:31',NULL,NULL),(45156,'50588','S','Storm Lake','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(54273,'62685','S','Plainview','A','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.116628,-90.005444,0,'2013-07-06 12:44:33',NULL,NULL),(3575,'01966','S','Pigeon Cove','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.658742,-70.618711,0,'2013-07-06 12:44:30',NULL,NULL),(37355,'41722','S','Duane','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(20252,'20782','S','University Pa','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(54725,'62964','S','Meridian Heights','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.116221,-89.194753,0,'2013-07-06 12:44:33',NULL,NULL),(59645,'71040','S','Homer','D','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.787891,-93.059930,0,'2013-07-06 12:44:33',NULL,NULL),(66963,'79402','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.588324,-101.846875,0,'2013-07-06 12:44:34',NULL,NULL),(41548,'47012','S','Brookville','D','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.416040,-84.981180,0,'2013-07-06 12:44:32',NULL,NULL),(36591,'40962','S','Ogle','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(31657,'34744','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.277758,-81.350625,0,'2013-07-06 12:44:32',NULL,NULL),(44344,'49770','S','Petoskey','D','Emmet','26047','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.356561,-84.930304,0,'2013-07-06 12:44:32',NULL,NULL),(47861,'55079','S','Martin Lake','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.397384,-92.987057,0,'2013-07-06 12:44:33',NULL,NULL),(69397,'83616','S','Eagle','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.711993,-116.374414,0,'2013-07-06 12:44:34',NULL,NULL),(12086,'12564','S','Pawling','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.587140,-73.589460,0,'2013-07-06 12:44:30',NULL,NULL),(25186,'28054','S','Gastonia','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229720,-81.142440,0,'2013-07-06 12:44:31',NULL,NULL),(31402,'34229','S','Osprey','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.183926,-82.488306,0,'2013-07-06 12:44:32',NULL,NULL),(67075,'79601','S','Hamby','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.479020,-99.700020,0,'2013-07-06 12:44:34',NULL,NULL),(70148,'84309','S','Deweyville','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.707724,-112.092685,0,'2013-07-06 12:44:34',NULL,NULL),(73296,'90803','S','Belmont Shore','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.759309,-118.125598,0,'2013-07-06 12:44:34',NULL,NULL),(393,'00662','S','Comunidad Los Pinos','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(41264,'46750','S','Bracken','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(38815,'44073','U','Novelty','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.466851,-81.339894,0,'2013-07-06 12:44:32',NULL,NULL),(36788,'41049','S','Hillsboro','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.285556,-83.678852,0,'2013-07-06 12:44:32',NULL,NULL),(16505,'17264','S','Pogue','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.174380,-77.988180,0,'2013-07-06 12:44:31',NULL,NULL),(15235,'16036','P','Foxburg','D','Clarion','42031','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.155559,-79.653411,0,'2013-07-06 12:44:31',NULL,NULL),(27810,'30401','S','Blundale','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(49429,'56633','S','Farris','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(54438,'62842','S','Elm River','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.440349,-88.426303,0,'2013-07-06 12:44:33',NULL,NULL),(56126,'64834','S','Carl Junction','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.170235,-94.542468,0,'2013-07-06 12:44:33',NULL,NULL),(56993,'66203','S','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(60464,'71654','S','Masonville','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.656460,-91.408020,0,'2013-07-06 12:44:33',NULL,NULL),(63356,'75636','P','Cason','D','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.943509,-94.705178,0,'2013-07-06 12:44:33',NULL,NULL),(74708,'93010','S','Camarillo','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.228608,-119.022550,0,'2013-07-06 12:44:34',NULL,NULL),(80154,'99790','S','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.842970,-147.724179,0,'2013-07-06 12:44:34',NULL,NULL),(33911,'38053','S','Cuba','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(24306,'27016','S','Danbury','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.466460,-80.251279,0,'2013-07-06 12:44:31',NULL,NULL),(17603,'18040','S','Stockrtwn Twp','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.719000,-75.220260,0,'2013-07-06 12:44:31',NULL,NULL),(70909,'85625','S','Sunsites','A','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.935591,-109.803528,0,'2013-07-06 12:44:34',NULL,NULL),(70416,'84723','P','Circleville','D','Piute','49031','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.171505,-112.272478,0,'2013-07-06 12:44:34',NULL,NULL),(66408,'78631','S','Harper','D','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.317834,-99.222875,0,'2013-07-06 12:44:34',NULL,NULL),(63540,'75762','S','Noonday','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.221740,-95.396400,0,'2013-07-06 12:44:33',NULL,NULL),(58549,'68816','S','Archer','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.177012,-98.113761,0,'2013-07-06 12:44:33',NULL,NULL),(57776,'67464','S','Marquette','D','McPherson','20113','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.557377,-97.834152,0,'2013-07-06 12:44:33',NULL,NULL),(55465,'63740','S','Chaffee','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.185720,-89.647920,0,'2013-07-06 12:44:33',NULL,NULL),(51881,'60088','S','Great Lakes','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.308646,-87.854501,0,'2013-07-06 12:44:33',NULL,NULL),(45277,'50676','S','Tripoli','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.806451,-92.259397,0,'2013-07-06 12:44:32',NULL,NULL),(27275,'29943','S','Tillman','D','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481456,-81.113941,0,'2013-07-06 12:44:31',NULL,NULL),(11998,'12486','S','Tillson','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.841672,-74.054520,0,'2013-07-06 12:44:30',NULL,NULL),(33734,'37821','S','Newport','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.965629,-83.188913,0,'2013-07-06 12:44:32',NULL,NULL),(3188,'01342','S','Deerfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.553684,-72.589272,0,'2013-07-06 12:44:30',NULL,NULL),(33353,'37180','S','Unionville','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.624856,-86.570973,0,'2013-07-06 12:44:32',NULL,NULL),(29955,'33074','P','Lghthse Point','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.238998,-80.124146,0,'2013-07-06 12:44:32',NULL,NULL),(37335,'41663','S','Tram','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.575173,-82.646677,0,'2013-07-06 12:44:32',NULL,NULL),(39874,'45207','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.146978,-84.470797,0,'2013-07-06 12:44:32',NULL,NULL),(29641,'32899','U','Kennedy Space Center','A','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.611682,-80.677691,0,'2013-07-06 12:44:32',NULL,NULL),(20942,'21766','S','Little Orleans','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.660121,-78.402968,0,'2013-07-06 12:44:31',NULL,NULL),(48151,'55369','S','Osseo','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.121860,-93.457200,0,'2013-07-06 12:44:33',NULL,NULL),(78990,'98380','S','Miami Beach','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.634664,-122.844456,0,'2013-07-06 12:44:34',NULL,NULL),(5646,'04952','S','Morrill','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.413305,-69.150780,0,'2013-07-06 12:44:30',NULL,NULL),(33522,'37377','S','Walden','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.147329,-85.330097,0,'2013-07-06 12:44:32',NULL,NULL),(19736,'20403','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.888390,-77.015989,0,'2013-07-06 12:44:31',NULL,NULL),(29375,'32603','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.655262,-82.346991,0,'2013-07-06 12:44:32',NULL,NULL),(26130,'28734','S','Ellijay','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(66168,'78520','S','Keller Corner','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(5992,'05353','S','Mary Meyer','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.064489,-72.668569,0,'2013-07-06 12:44:30',NULL,NULL),(71135,'86023','P','Tusayan','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.054420,-112.138620,0,'2013-07-06 12:44:34',NULL,NULL),(56434,'65265','S','Riversville','N','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.167340,-91.870440,0,'2013-07-06 12:44:33',NULL,NULL),(29206,'32412','P','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.156293,-85.648646,0,'2013-07-06 12:44:32',NULL,NULL),(9660,'10039','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(12335,'12871','S','Grangerville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.088460,-73.622760,0,'2013-07-06 12:44:30',NULL,NULL),(36935,'41164','S','Gimlet','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(37911,'42633','S','Number One','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(41292,'46763','S','Laotto','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.291971,-85.202440,0,'2013-07-06 12:44:32',NULL,NULL),(41367,'46794','S','Waldron Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(51649,'59873','S','Copper King','N','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.621869,-115.341150,0,'2013-07-06 12:44:33',NULL,NULL),(27754,'30360','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928090,-84.278530,0,'2013-07-06 12:44:31',NULL,NULL),(7099,'06360','S','Norwichtown','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.550840,-72.027360,0,'2013-07-06 12:44:30',NULL,NULL),(33403,'37227','P','Nashvle','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.132543,-86.669444,0,'2013-07-06 12:44:32',NULL,NULL),(38097,'43084','S','Woodstock','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.161980,-83.543234,0,'2013-07-06 12:44:32',NULL,NULL),(30456,'33334','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181067,-80.138938,0,'2013-07-06 12:44:32',NULL,NULL),(13038,'13438','S','North Wilmurt','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.333117,-75.200513,0,'2013-07-06 12:44:30',NULL,NULL),(3993,'02538','S','East Wareham','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.781003,-70.649757,0,'2013-07-06 12:44:30',NULL,NULL),(52268,'60525','S','Indian Head Pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(53333,'61752','S','Leroy','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.346851,-88.766920,0,'2013-07-06 12:44:33',NULL,NULL),(55148,'63362','S','Fountain N Lakes','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.931175,-90.881331,0,'2013-07-06 12:44:33',NULL,NULL),(57557,'67039','S','Douglass','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.514862,-97.010503,0,'2013-07-06 12:44:33',NULL,NULL),(6614,'05873','S','West Danville','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.445900,-72.224520,0,'2013-07-06 12:44:30',NULL,NULL),(24500,'27263','S','Allen Jay','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.908020,-79.980120,0,'2013-07-06 12:44:31',NULL,NULL),(23228,'25085','S','Brownsville','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.167246,-81.190813,0,'2013-07-06 12:44:31',NULL,NULL),(22939,'24634','S','Pilgrims Knob','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.297807,-81.906793,0,'2013-07-06 12:44:31',NULL,NULL),(70544,'85028','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.579575,-112.006348,0,'2013-07-06 12:44:34',NULL,NULL),(53598,'62075','S','Wenonah','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.285840,-89.312580,0,'2013-07-06 12:44:33',NULL,NULL),(42408,'47802','S','Allendale','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(75932,'95020','S','Gilroy','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.019255,-121.574817,0,'2013-07-06 12:44:34',NULL,NULL),(78588,'98178','S','Bryn Mawr','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.492862,-122.249902,0,'2013-07-06 12:44:34',NULL,NULL),(4106,'02703','S','South Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.939160,-71.302800,0,'2013-07-06 12:44:30',NULL,NULL),(15614,'16684','P','Tipton','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.634837,-78.302127,0,'2013-07-06 12:44:31',NULL,NULL),(34020,'38127','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.240147,-90.020802,0,'2013-07-06 12:44:32',NULL,NULL),(5059,'04276','S','Rumford','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.546376,-70.554444,0,'2013-07-06 12:44:30',NULL,NULL),(21683,'22960','S','Orange','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.245110,-78.108521,0,'2013-07-06 12:44:31',NULL,NULL),(11618,'12095','S','Rockwood','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.021140,-74.395500,0,'2013-07-06 12:44:30',NULL,NULL),(20603,'21205','S','East End','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304502,-76.567527,0,'2013-07-06 12:44:31',NULL,NULL),(45434,'51103','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.507089,-96.433472,0,'2013-07-06 12:44:32',NULL,NULL),(53269,'61721','S','Hittle','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.341244,-89.310815,0,'2013-07-06 12:44:33',NULL,NULL),(57963,'67762','S','Weskan','D','Wallace','20199','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',38.885719,-101.946745,0,'2013-07-06 12:44:33',NULL,NULL),(69264,'83433','P','Big Springs','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.499167,-111.336944,0,'2013-07-06 12:44:34',NULL,NULL),(48706,'55944','S','Kasson','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.036896,-92.751584,0,'2013-07-06 12:44:33',NULL,NULL),(20896,'21710','S','Adamstown','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.291540,-77.458140,0,'2013-07-06 12:44:31',NULL,NULL),(66291,'78584','S','Falcon','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.378999,-98.814980,0,'2013-07-06 12:44:34',NULL,NULL),(69527,'83729','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.605939,-116.193296,0,'2013-07-06 12:44:34',NULL,NULL),(73232,'90640','S','Montebello','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.015369,-118.111726,0,'2013-07-06 12:44:34',NULL,NULL),(77101,'96140','P','Ridgewood','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(10451,'10920','S','Congers','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.147711,-73.941171,0,'2013-07-06 12:44:30',NULL,NULL),(37122,'41426','P','Falcon','D','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.788716,-83.000043,0,'2013-07-06 12:44:32',NULL,NULL),(31334,'34136','P','Bonita Springs','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.387994,-81.709518,0,'2013-07-06 12:44:32',NULL,NULL),(42140,'47515','S','Bristow','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.167640,-86.715843,0,'2013-07-06 12:44:32',NULL,NULL),(44376,'49792','P','Tower','D','Cheboygan','26031','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.366980,-84.306157,0,'2013-07-06 12:44:32',NULL,NULL),(79802,'99360','S','Touchet','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.069500,-118.716300,0,'2013-07-06 12:44:34',NULL,NULL),(12604,'13081','S','King Ferry','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.662592,-76.626770,0,'2013-07-06 12:44:30',NULL,NULL),(38267,'43314','S','Caledonia','D','Marion','39101','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.646640,-82.961160,0,'2013-07-06 12:44:32',NULL,NULL),(36869,'41093','S','Goddard','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.341084,-83.555814,0,'2013-07-06 12:44:32',NULL,NULL),(36540,'40873','S','Wallins Creek','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.817860,-83.405760,0,'2013-07-06 12:44:32',NULL,NULL),(31472,'34291','S','Venice','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.091905,-82.232783,0,'2013-07-06 12:44:32',NULL,NULL),(30138,'33165','S','Olympia Hgts','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729513,-80.360218,0,'2013-07-06 12:44:32',NULL,NULL),(26544,'29206','S','Arcadia Lakes','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(25796,'28605','S','Aho','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.116573,-81.678226,0,'2013-07-06 12:44:31',NULL,NULL),(22003,'23279','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.583347,-77.491807,0,'2013-07-06 12:44:31',NULL,NULL),(49376,'56590','S','Wendell','D','Grant','27051','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.061875,-96.139321,0,'2013-07-06 12:44:33',NULL,NULL),(72782,'89701','S','Carson City Mall','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(73119,'90262','S','Lynwood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.925084,-118.198182,0,'2013-07-06 12:44:34',NULL,NULL),(77498,'96828','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.291312,-157.819996,0,'2013-07-06 12:44:34',NULL,NULL),(66454,'78653','S','Manor','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(72749,'89510','S','Cottonwood Creek','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(11307,'11779','S','Lk Ronkonkoma','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.818120,-73.120800,0,'2013-07-06 12:44:30',NULL,NULL),(18769,'19355','S','Frazer','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041360,-75.537060,0,'2013-07-06 12:44:31',NULL,NULL),(41513,'46971','S','Peru','A','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.673495,-86.158752,0,'2013-07-06 12:44:32',NULL,NULL),(20848,'21653','P','Newcomb','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.787178,-76.224932,0,'2013-07-06 12:44:31',NULL,NULL),(29781,'33015','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940770,-80.315677,0,'2013-07-06 12:44:32',NULL,NULL),(25944,'28656','U','North Wilkesboro','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.203290,-81.076593,0,'2013-07-06 12:44:31',NULL,NULL),(40671,'46056','S','Emporia','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.982476,-85.614191,0,'2013-07-06 12:44:32',NULL,NULL),(19699,'20376','S','Naval Sea Systems Command','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916809,-76.993655,0,'2013-07-06 12:44:31',NULL,NULL),(39081,'44216','S','New Franklin','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.938924,-81.580189,0,'2013-07-06 12:44:32',NULL,NULL),(34212,'38352','S','Luray','D','Chester','47023','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.685659,-88.877568,0,'2013-07-06 12:44:32',NULL,NULL),(35271,'39363','S','Stonewall','D','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.133765,-88.798622,0,'2013-07-06 12:44:32',NULL,NULL),(49249,'56474','S','Pine River','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(15962,'17027','P','Grantham','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.152071,-77.002719,0,'2013-07-06 12:44:31',NULL,NULL),(61690,'72946','S','Mountainburg','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.629888,-94.086149,0,'2013-07-06 12:44:33',NULL,NULL),(21056,'21912','S','Warwick','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.430272,-75.803960,0,'2013-07-06 12:44:31',NULL,NULL),(44468,'49887','S','Cedar River','A','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.414673,-87.615414,0,'2013-07-06 12:44:32',NULL,NULL),(34704,'38829','S','Thrashers','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(33098,'36850','S','Camp Hill','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.896297,-85.575854,0,'2013-07-06 12:44:32',NULL,NULL),(24268,'26838','S','Milam','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.803923,-79.064534,0,'2013-07-06 12:44:31',NULL,NULL),(77569,'96910','S','Ordot','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(79474,'98858','S','Farmer','N','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.677620,-119.909880,0,'2013-07-06 12:44:34',NULL,NULL),(59248,'70438','S','Thomas','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.848512,-90.146024,0,'2013-07-06 12:44:33',NULL,NULL),(4395,'03215','P','Waterville Valley','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.951855,-71.500298,0,'2013-07-06 12:44:30',NULL,NULL),(49161,'56389','P','West Union','D','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.798359,-95.079178,0,'2013-07-06 12:44:33',NULL,NULL),(45227,'50644','S','Otterville','N','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.468967,-91.895783,0,'2013-07-06 12:44:32',NULL,NULL),(20714,'21278','U','Baltimore Sunpapers','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.316363,-76.614724,0,'2013-07-06 12:44:31',NULL,NULL),(21501,'22701','S','Culpeper','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.471640,-78.013989,0,'2013-07-06 12:44:31',NULL,NULL),(70756,'85326','S','Buckeye','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.382557,-112.568263,0,'2013-07-06 12:44:34',NULL,NULL),(6847,'06123','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765654,-72.686093,0,'2013-07-06 12:44:30',NULL,NULL),(650,'00682','S','Urb Santa Rosa De Lima','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(21186,'22182','S','Tysons','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.928478,-77.261486,0,'2013-07-06 12:44:31',NULL,NULL),(54714,'62958','S','Makanda','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.637065,-89.186902,0,'2013-07-06 12:44:33',NULL,NULL),(71282,'86436','S','Golden Shores','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.778287,-114.483910,0,'2013-07-06 12:44:34',NULL,NULL),(75785,'94706','S','Albany','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.888234,-122.293954,0,'2013-07-06 12:44:34',NULL,NULL),(37407,'41776','S','Cinda','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.201089,-83.298307,0,'2013-07-06 12:44:32',NULL,NULL),(62766,'74859','S','Bearden','A','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.431460,-96.305173,0,'2013-07-06 12:44:33',NULL,NULL),(35218,'39302','P','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.365411,-88.700251,0,'2013-07-06 12:44:32',NULL,NULL),(54595,'62903','S','Carbondale','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.727269,-89.209493,0,'2013-07-06 12:44:33',NULL,NULL),(4285,'02894','S','Wood River Junction','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.450100,-71.691600,0,'2013-07-06 12:44:30',NULL,NULL),(43125,'48230','S','Grosse Pointe','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(20328,'20841','S','Boyds','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.196623,-77.335092,0,'2013-07-06 12:44:31',NULL,NULL),(75187,'93611','S','Clovis','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.845587,-119.652237,0,'2013-07-06 12:44:34',NULL,NULL),(46317,'53072','S','Brookfld','N','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.078937,-88.256368,0,'2013-07-06 12:44:32',NULL,NULL),(43242,'48317','S','Shelby Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.647050,-83.049668,0,'2013-07-06 12:44:32',NULL,NULL),(22685,'24315','S','Bland Correct','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.142078,-81.013829,0,'2013-07-06 12:44:31',NULL,NULL),(29575,'32818','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.577550,-81.496134,0,'2013-07-06 12:44:32',NULL,NULL),(28476,'31510','S','Rockingham','N','Bacon','13005','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.539831,-82.464187,0,'2013-07-06 12:44:32',NULL,NULL),(10806,'11373','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738937,-73.879160,0,'2013-07-06 12:44:30',NULL,NULL),(330,'00650','S','Urb Vegas de Florida','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(38000,'42759','P','Marrowbone','D','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.832079,-85.514937,0,'2013-07-06 12:44:32',NULL,NULL),(36922,'41144','S','Wurtland','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.572275,-82.812737,0,'2013-07-06 12:44:32',NULL,NULL),(901,'00705','S','Est del Llano','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(9666,'10040','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(27656,'30324','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.820340,-84.362232,0,'2013-07-06 12:44:31',NULL,NULL),(43413,'48461','S','North Branch','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.211436,-83.212904,0,'2013-07-06 12:44:32',NULL,NULL),(60678,'71923','S','Richwood','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(65651,'77975','S','Novohrad','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.568900,-97.085580,0,'2013-07-06 12:44:34',NULL,NULL),(52464,'60681','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.876672,-87.646485,0,'2013-07-06 12:44:33',NULL,NULL),(57022,'66206','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(4124,'02741','P','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.639892,-70.939996,0,'2013-07-06 12:44:30',NULL,NULL),(23887,'26170','S','Saint Marys','D','Pleasants','54073','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.394325,-81.200298,0,'2013-07-06 12:44:31',NULL,NULL),(70523,'85007','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.447641,-112.089757,0,'2013-07-06 12:44:34',NULL,NULL),(73605,'91392','P','Sylmar','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.310015,-118.431906,0,'2013-07-06 12:44:34',NULL,NULL),(79210,'98538','S','Kalber','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.522826,-123.121792,0,'2013-07-06 12:44:34',NULL,NULL),(60186,'71417','S','McNeely','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(62351,'74060','S','Prue','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.281438,-96.242323,0,'2013-07-06 12:44:33',NULL,NULL),(5311,'04563','S','Cushing','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.991530,-69.264311,0,'2013-07-06 12:44:30',NULL,NULL),(28660,'31780','S','Plains','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.029302,-84.393140,0,'2013-07-06 12:44:32',NULL,NULL),(54455,'62851','S','Shields','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.364300,-88.656120,0,'2013-07-06 12:44:33',NULL,NULL),(7921,'07641','S','Haworth','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.958091,-73.990667,0,'2013-07-06 12:44:30',NULL,NULL),(37728,'42276','S','Russellville','D','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(9361,'09818','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(77954,'97361','S','Monmouth','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.813075,-123.295883,0,'2013-07-06 12:44:34',NULL,NULL),(74797,'93199','U','Santa Barbara','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.489743,-120.039532,0,'2013-07-06 12:44:34',NULL,NULL),(72039,'88061','S','Little Walnut Village','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.775733,-108.264777,0,'2013-07-06 12:44:34',NULL,NULL),(14767,'15339','P','Hendersonvlle','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.298920,-80.154703,0,'2013-07-06 12:44:31',NULL,NULL),(50403,'57775','S','Cactus Flats','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.097300,-102.109920,0,'2013-07-06 12:44:33',NULL,NULL),(41007,'46368','S','Ogden Dunes','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.584620,-87.174720,0,'2013-07-06 12:44:32',NULL,NULL),(66735,'78957','S','Upton','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.013892,-97.156138,0,'2013-07-06 12:44:34',NULL,NULL),(30766,'33573','S','Ruskin','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.718176,-82.364372,0,'2013-07-06 12:44:32',NULL,NULL),(36158,'40241','S','Spring Valley','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(53177,'61604','S','Bellevue','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(24006,'26351','S','Baldwin','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.938379,-80.837080,0,'2013-07-06 12:44:31',NULL,NULL),(21173,'22158','U','Army Times','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.812261,-77.256414,0,'2013-07-06 12:44:31',NULL,NULL),(64747,'76909','U','Angelo State University','N','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.446944,-100.450967,0,'2013-07-06 12:44:34',NULL,NULL),(70629,'85139','S','Mobile','A','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.980110,-112.108719,0,'2013-07-06 12:44:34',NULL,NULL),(35513,'39532','S','St Martin','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.461218,-88.949246,0,'2013-07-06 12:44:32',NULL,NULL),(19156,'19715','P','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.714043,-75.737757,0,'2013-07-06 12:44:31',NULL,NULL),(9101,'09079','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(44482,'49908','S','Keweenaw Bay','A','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.784280,-88.493640,0,'2013-07-06 12:44:32',NULL,NULL),(36456,'40702','P','Corbin','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.950715,-84.086781,0,'2013-07-06 12:44:32',NULL,NULL),(44423,'49837','S','Gladstone','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.880140,-87.047580,0,'2013-07-06 12:44:32',NULL,NULL),(45356,'51001','S','Akron','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.833520,-96.529560,0,'2013-07-06 12:44:32',NULL,NULL),(17254,'17841','S','Decatur','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(12816,'13302','S','Kasoag','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(53532,'62032','S','Chapman','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.103643,-89.305669,0,'2013-07-06 12:44:33',NULL,NULL),(3327,'01534','S','Northbridge','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.143607,-71.654859,0,'2013-07-06 12:44:30',NULL,NULL),(1742,'00778','S','Urb Oreilly','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(9513,'10017','S','Grand Central','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(50049,'57437','S','Artas','A','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.802620,-99.618600,0,'2013-07-06 12:44:33',NULL,NULL),(48986,'56227','S','Correll','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.303856,-96.177070,0,'2013-07-06 12:44:33',NULL,NULL),(80066,'99722','P','Arctic Vlg','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',68.139958,-145.549133,0,'2013-07-06 12:44:34',NULL,NULL),(24511,'27281','S','Jackson Spgs','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(33326,'37145','S','Pleasant Shde','A','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.353662,-85.902405,0,'2013-07-06 12:44:32',NULL,NULL),(42845,'48074','S','Kimball','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.944217,-82.559913,0,'2013-07-06 12:44:32',NULL,NULL),(3978,'02532','S','Bourne','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.741040,-70.588920,0,'2013-07-06 12:44:30',NULL,NULL),(71169,'86039','P','Sand Springs','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(62995,'75154','S','Oak Leaf','A','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.525442,-96.814963,0,'2013-07-06 12:44:33',NULL,NULL),(6554,'05845','S','Albany Center','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.820600,-72.278400,0,'2013-07-06 12:44:30',NULL,NULL),(1147,'00727','S','Est del Turabo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(6908,'06151','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766300,-72.673122,0,'2013-07-06 12:44:30',NULL,NULL),(11989,'12477','S','Saugerties','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.077520,-74.013600,0,'2013-07-06 12:44:30',NULL,NULL),(46477,'53219','S','W Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994394,-87.991356,0,'2013-07-06 12:44:32',NULL,NULL),(48436,'55703','S','Alango','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.758363,-92.771783,0,'2013-07-06 12:44:33',NULL,NULL),(55996,'64640','S','Lake Viking','N','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.902820,-93.968700,0,'2013-07-06 12:44:33',NULL,NULL),(54801,'63016','S','Lake Adelle','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.352981,-90.644798,0,'2013-07-06 12:44:33',NULL,NULL),(46292,'53049','S','Malone','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.844750,-88.345131,0,'2013-07-06 12:44:32',NULL,NULL),(40067,'45274','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138138,-84.536318,0,'2013-07-06 12:44:32',NULL,NULL),(20907,'21719','S','Cascade','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.709736,-77.493313,0,'2013-07-06 12:44:31',NULL,NULL),(9031,'08875','P','East Millstone','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.486000,-74.465000,0,'2013-07-06 12:44:30',NULL,NULL),(12031,'12518','S','Cornwall','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.432794,-74.045095,0,'2013-07-06 12:44:30',NULL,NULL),(25614,'28460','S','N Topsail Bch','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.531918,-77.387722,0,'2013-07-06 12:44:31',NULL,NULL),(58960,'70006','S','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.013680,-90.194627,0,'2013-07-06 12:44:33',NULL,NULL),(60543,'71711','P','Camden','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.581943,-92.834036,0,'2013-07-06 12:44:33',NULL,NULL),(33989,'38115','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.045523,-89.849029,0,'2013-07-06 12:44:32',NULL,NULL),(3083,'01199','U','Baystate Medical','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.119147,-72.603412,0,'2013-07-06 12:44:30',NULL,NULL),(21993,'23273','U','Henrico','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.587216,-77.495005,0,'2013-07-06 12:44:31',NULL,NULL),(2573,'00959','S','Villa del Rio Bayamon','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(66653,'78847','U','Del Rio','D','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.375719,-100.895923,0,'2013-07-06 12:44:34',NULL,NULL),(37418,'41810','P','Tolliver Town','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.181445,-82.686695,0,'2013-07-06 12:44:32',NULL,NULL),(60013,'71334','S','Panola','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(28532,'31553','S','Hickox','N','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.216716,-81.956732,0,'2013-07-06 12:44:32',NULL,NULL),(50590,'58237','S','Grafton','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.415200,-97.411740,0,'2013-07-06 12:44:33',NULL,NULL),(6323,'05663','S','Northfield','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.149825,-72.660946,0,'2013-07-06 12:44:30',NULL,NULL),(39830,'45154','S','Mount Orab','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',39.046508,-83.928470,0,'2013-07-06 12:44:32',NULL,NULL),(45583,'51540','S','Hastings','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.019331,-95.500910,0,'2013-07-06 12:44:32',NULL,NULL),(3406,'01701','S','Saxonville','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.315117,-71.434120,0,'2013-07-06 12:44:30',NULL,NULL),(30733,'33538','S','Lake Panasoffkee','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.885081,-82.192820,0,'2013-07-06 12:44:32',NULL,NULL),(13062,'13449','U','BRM Customer','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.225494,-75.492278,0,'2013-07-06 12:44:30',NULL,NULL),(6679,'06037','S','Kenington','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.607780,-72.770100,0,'2013-07-06 12:44:30',NULL,NULL),(5230,'04464','S','Monson','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.302859,-69.480734,0,'2013-07-06 12:44:30',NULL,NULL),(43369,'48414','S','Bancroft','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.866302,-84.074561,0,'2013-07-06 12:44:32',NULL,NULL),(66592,'78751','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.307949,-97.724524,0,'2013-07-06 12:44:34',NULL,NULL),(75200,'93624','P','Five Points','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.395983,-120.129336,0,'2013-07-06 12:44:34',NULL,NULL),(17167,'17814','S','Jamison City','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(41544,'47006','S','Huntersville','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.328406,-85.199126,0,'2013-07-06 12:44:32',NULL,NULL),(43109,'48221','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.429028,-83.150684,0,'2013-07-06 12:44:32',NULL,NULL),(63501,'75707','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.297280,-95.202900,0,'2013-07-06 12:44:33',NULL,NULL),(41450,'46897','U','Business Reply','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069224,-85.161465,0,'2013-07-06 12:44:32',NULL,NULL),(6417,'05739','S','Scottsville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(13874,'14260','U','Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.003074,-78.785924,0,'2013-07-06 12:44:31',NULL,NULL),(51821,'60053','S','Morton Grove','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.044087,-87.791267,0,'2013-07-06 12:44:33',NULL,NULL),(71106,'86001','S','Flagstaff','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.139960,-111.634080,0,'2013-07-06 12:44:34',NULL,NULL),(69391,'83612','S','Goodrich','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(11527,'12040','P','Cherryplain','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.634921,-73.355054,0,'2013-07-06 12:44:30',NULL,NULL),(18151,'18844','S','Springville','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.710753,-75.894888,0,'2013-07-06 12:44:31',NULL,NULL),(22306,'23832','S','Chesterfld','N','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.409940,-77.610720,0,'2013-07-06 12:44:31',NULL,NULL),(6805,'06109','S','Weathersfield','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(39070,'44203','S','Norton','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.014711,-81.614500,0,'2013-07-06 12:44:32',NULL,NULL),(20017,'20621','S','Chaptico','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.334840,-76.820400,0,'2013-07-06 12:44:31',NULL,NULL),(4648,'03749','P','Enfield Ctr','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.589213,-72.110433,0,'2013-07-06 12:44:30',NULL,NULL),(28160,'30905','S','Fort Gordon','A','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.403925,-82.120051,0,'2013-07-06 12:44:31',NULL,NULL),(9713,'10080','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(68941,'82934','P','Granger','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.595416,-109.965628,0,'2013-07-06 12:44:34',NULL,NULL),(79683,'99176','S','Thornton','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.119259,-117.372762,0,'2013-07-06 12:44:34',NULL,NULL),(69833,'84081','S','W Valley','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(33002,'36644','U','Mobile Gov Plz','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.694297,-88.041917,0,'2013-07-06 12:44:32',NULL,NULL),(26296,'29030','S','Creston','N','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.550000,-80.710000,0,'2013-07-06 12:44:31',NULL,NULL),(50421,'57787','S','Red Owl','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.733611,-102.654167,0,'2013-07-06 12:44:33',NULL,NULL),(73858,'91906','S','Campo','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.693965,-116.510269,0,'2013-07-06 12:44:34',NULL,NULL),(72344,'89017','S','Crystal Springs','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.591348,-115.225947,0,'2013-07-06 12:44:34',NULL,NULL),(44198,'49621','S','Cedar','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.862433,-85.783402,0,'2013-07-06 12:44:32',NULL,NULL),(6263,'05602','S','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(53037,'61477','S','Seville','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.495882,-90.287939,0,'2013-07-06 12:44:33',NULL,NULL),(59476,'70753','S','Lettsworth','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.938450,-91.731716,0,'2013-07-06 12:44:33',NULL,NULL),(22248,'23665','S','Langley','N','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.080265,-76.373645,0,'2013-07-06 12:44:31',NULL,NULL),(22853,'24536','S','Coleman Falls','D','Bedford','51019','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.473399,-79.324182,0,'2013-07-06 12:44:31',NULL,NULL),(23263,'25134','P','Miami','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.150420,-81.448615,0,'2013-07-06 12:44:31',NULL,NULL),(32979,'36612','S','Whistler','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.751290,-88.110308,0,'2013-07-06 12:44:32',NULL,NULL),(12458,'12972','S','Peru','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.570220,-73.547160,0,'2013-07-06 12:44:30',NULL,NULL),(62240,'74002','S','Barnsdall','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.558589,-96.162993,0,'2013-07-06 12:44:33',NULL,NULL),(66373,'78620','S','Mount Sharp','N','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250260,-98.120160,0,'2013-07-06 12:44:34',NULL,NULL),(74390,'92515','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.918462,-117.490092,0,'2013-07-06 12:44:34',NULL,NULL),(26600,'29230','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.138187,-81.065959,0,'2013-07-06 12:44:31',NULL,NULL),(14825,'15425','S','S Connellsvl','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.027320,-79.588740,0,'2013-07-06 12:44:31',NULL,NULL),(21449,'22601','S','Winchester','D','Winchester City','51840','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.175637,-78.164962,0,'2013-07-06 12:44:31',NULL,NULL),(37819,'42431','S','Madisonville','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.336987,-87.497302,0,'2013-07-06 12:44:32',NULL,NULL),(31938,'35187','P','Wilton','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.073633,-86.875231,0,'2013-07-06 12:44:32',NULL,NULL),(36735,'41031','S','Sunrise','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(69764,'84054','S','Nsl','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.837299,-111.919323,0,'2013-07-06 12:44:34',NULL,NULL),(43643,'48836','S','Fowlerville','D','Livingston','26093','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.663825,-84.068992,0,'2013-07-06 12:44:32',NULL,NULL),(50797,'58445','S','Grace City','D','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.541934,-98.816327,0,'2013-07-06 12:44:33',NULL,NULL),(78110,'97497','S','Sunnyvalley','N','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.660780,-123.385560,0,'2013-07-06 12:44:34',NULL,NULL),(20909,'21719','S','Highfield','A','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.709736,-77.493313,0,'2013-07-06 12:44:31',NULL,NULL),(24874,'27695','U','Nc State Univ','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.803047,-78.713095,0,'2013-07-06 12:44:31',NULL,NULL),(27645,'30319','S','North Atlanta','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.875460,-84.333398,0,'2013-07-06 12:44:31',NULL,NULL),(28740,'31917','P','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.484084,-84.828966,0,'2013-07-06 12:44:32',NULL,NULL),(52884,'61348','S','Piety Hill','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.291493,-89.048588,0,'2013-07-06 12:44:33',NULL,NULL),(62905,'75069','S','McKinney','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.179280,-96.601020,0,'2013-07-06 12:44:33',NULL,NULL),(16426,'17228','S','Saluvia','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.977362,-78.082703,0,'2013-07-06 12:44:31',NULL,NULL),(29010,'32224','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.275858,-81.461221,0,'2013-07-06 12:44:32',NULL,NULL),(30983,'33756','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.945940,-82.788362,0,'2013-07-06 12:44:32',NULL,NULL),(39848,'45168','S','Russellville','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.860557,-83.770773,0,'2013-07-06 12:44:32',NULL,NULL),(11087,'11693','S','Broad Channel','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.589797,-73.813567,0,'2013-07-06 12:44:30',NULL,NULL),(3638,'02093','S','Wrentham','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.057241,-71.344361,0,'2013-07-06 12:44:30',NULL,NULL),(43021,'48167','S','Northville Township','A','Wayne','26163','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.422231,-83.470096,0,'2013-07-06 12:44:32',NULL,NULL),(14884,'15478','S','Smithfield','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.784827,-79.787692,0,'2013-07-06 12:44:31',NULL,NULL),(57399,'66758','S','Neosho Falls','D','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.972738,-95.553451,0,'2013-07-06 12:44:33',NULL,NULL),(49520,'56672','S','Thunder Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(10404,'10606','S','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.031329,-73.779151,0,'2013-07-06 12:44:30',NULL,NULL),(10804,'11373','S','Elmhurst','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738937,-73.879160,0,'2013-07-06 12:44:30',NULL,NULL),(61966,'73179','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.425455,-97.641765,0,'2013-07-06 12:44:33',NULL,NULL),(4494,'03280','S','Washington','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.168019,-72.073347,0,'2013-07-06 12:44:30',NULL,NULL),(5442,'04691','S','Whiting','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.788736,-67.175252,0,'2013-07-06 12:44:30',NULL,NULL),(13433,'13760','S','Crestview Heights','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(13648,'14008','S','Appleton','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.306841,-78.637519,0,'2013-07-06 12:44:31',NULL,NULL),(857,'00698','S','Urb Barinas','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(7726,'07201','S','Union Square','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.664256,-74.179890,0,'2013-07-06 12:44:30',NULL,NULL),(3861,'02355','P','North Carver','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.917753,-70.797313,0,'2013-07-06 12:44:30',NULL,NULL),(46251,'53006','S','South Byron','A','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.615200,-88.516980,0,'2013-07-06 12:44:32',NULL,NULL),(70255,'84501','S','Price','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.359940,-110.944560,0,'2013-07-06 12:44:34',NULL,NULL),(72201,'88415','S','Seneca','A','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(68398,'81152','S','San Pablo','A','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(47929,'55113','S','Falcon Heights','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(30386,'33319','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(19329,'20029','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892932,-76.939967,0,'2013-07-06 12:44:31',NULL,NULL),(26905,'29578','P','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.726237,-78.844532,0,'2013-07-06 12:44:31',NULL,NULL),(22780,'24450','S','Lexington','D','Lexington City','51678','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.779731,-79.444573,0,'2013-07-06 12:44:31',NULL,NULL),(1371,'00736','S','Urb Mirador Universitario','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(1954,'00804','P','Charlotte Amalie','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.349002,-64.932125,0,'2013-07-06 12:44:30',NULL,NULL),(4740,'03836','S','Freedom','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.821384,-71.088403,0,'2013-07-06 12:44:30',NULL,NULL),(21930,'23228','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.624801,-77.497483,0,'2013-07-06 12:44:31',NULL,NULL),(16952,'17701','S','Williamsport','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(16944,'17701','S','Loyalsock','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(56723,'65690','S','Couch','D','Oregon','29149','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.567378,-91.299734,0,'2013-07-06 12:44:33',NULL,NULL),(77782,'97125','S','Banks','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.618889,-123.113056,0,'2013-07-06 12:44:34',NULL,NULL),(72447,'89106','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.183406,-115.162406,0,'2013-07-06 12:44:34',NULL,NULL),(66759,'79014','S','Canadian','D','Hemphill','48211','Texas','TX','48','0000','806','Central',-6.0,'Y',35.873100,-100.335420,0,'2013-07-06 12:44:34',NULL,NULL),(9207,'09496','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(43229,'48312','S','Sterling Hts','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.556244,-83.006843,0,'2013-07-06 12:44:32',NULL,NULL),(52432,'60656','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.975199,-87.825937,0,'2013-07-06 12:44:33',NULL,NULL),(33525,'37379','S','Soddy Daisy','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.265858,-85.160818,0,'2013-07-06 12:44:32',NULL,NULL),(33523,'37378','P','Smartt','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.647368,-85.833968,0,'2013-07-06 12:44:32',NULL,NULL),(49954,'57345','S','Tennis','N','Hyde','46069','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.520425,-99.443461,0,'2013-07-06 12:44:33',NULL,NULL),(25589,'28445','S','Holly Ridge','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.479960,-77.502360,0,'2013-07-06 12:44:31',NULL,NULL),(21554,'22801','S','Harrisburg','N','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.442152,-78.874027,0,'2013-07-06 12:44:31',NULL,NULL),(45286,'50701','S','Waterloo','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.478356,-92.367856,0,'2013-07-06 12:44:32',NULL,NULL),(13428,'13757','S','Shackport','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.415691,-74.888542,0,'2013-07-06 12:44:31',NULL,NULL),(76907,'95987','S','Williams','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.148021,-122.145602,0,'2013-07-06 12:44:34',NULL,NULL),(40389,'45662','S','New Boston','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.783520,-82.941300,0,'2013-07-06 12:44:32',NULL,NULL),(56986,'66202','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(13265,'13649','P','Helena','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.921541,-74.724428,0,'2013-07-06 12:44:30',NULL,NULL),(2197,'00926','S','Paseo Mayor','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(45195,'50619','S','Clarksville','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.778981,-92.665398,0,'2013-07-06 12:44:32',NULL,NULL),(27767,'30366','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.887527,-84.287641,0,'2013-07-06 12:44:31',NULL,NULL),(36514,'40828','S','Redbud','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(31410,'34237','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.339503,-82.514099,0,'2013-07-06 12:44:32',NULL,NULL),(62454,'74301','S','Vinita','D','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.642087,-95.156105,0,'2013-07-06 12:44:33',NULL,NULL),(69846,'84084','S','W Jordan','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618542,-111.967531,0,'2013-07-06 12:44:34',NULL,NULL),(73826,'91771','U','Rosemead','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065056,-118.083026,0,'2013-07-06 12:44:34',NULL,NULL),(10276,'10512','S','Carmel','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.449121,-73.679279,0,'2013-07-06 12:44:30',NULL,NULL),(75692,'94562','P','Oakville','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.428074,-122.403836,0,'2013-07-06 12:44:34',NULL,NULL),(27923,'30515','P','Buford','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.130974,-84.026588,0,'2013-07-06 12:44:31',NULL,NULL),(8020,'07726','S','Englishtown','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.277760,-74.361120,0,'2013-07-06 12:44:30',NULL,NULL),(45523,'51436','S','Breda','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.185428,-94.974505,0,'2013-07-06 12:44:32',NULL,NULL),(51023,'58711','S','Antler','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.948044,-101.362952,0,'2013-07-06 12:44:33',NULL,NULL),(37868,'42544','S','Cains Store','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(8229,'07978','P','Pluckemin','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.644091,-74.635527,0,'2013-07-06 12:44:30',NULL,NULL),(38242,'43260','U','Huntington National Bank','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.962870,-82.998416,0,'2013-07-06 12:44:32',NULL,NULL),(47000,'54246','S','Washington Is','A','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.370595,-86.902605,0,'2013-07-06 12:44:32',NULL,NULL),(9856,'10119','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(57574,'67058','S','Harper','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.285895,-98.026088,0,'2013-07-06 12:44:33',NULL,NULL),(6,'00601','S','Colinas Del Gigante','N','Adjuntas','72001','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.165950,-66.723627,0,'2013-07-06 12:44:30',NULL,NULL),(80036,'99693','P','Whittier','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.770000,-148.680000,0,'2013-07-06 12:44:34',NULL,NULL),(78514,'98117','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.686273,-122.380393,0,'2013-07-06 12:44:34',NULL,NULL),(41565,'47024','S','Andersonville','N','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.477157,-85.195131,0,'2013-07-06 12:44:32',NULL,NULL),(3295,'01508','P','Charlton City','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.151392,-71.989604,0,'2013-07-06 12:44:30',NULL,NULL),(30762,'33571','P','Sun City Center','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.720556,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(74986,'93446','S','Lake Nacimiento','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(73812,'91761','S','Ontario','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.036901,-117.606236,0,'2013-07-06 12:44:34',NULL,NULL),(13884,'14264','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.887206,-78.823444,0,'2013-07-06 12:44:31',NULL,NULL),(7268,'06519','S','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.294976,-72.938709,0,'2013-07-06 12:44:30',NULL,NULL),(5891,'05155','S','S Londonderry','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(216,'00624','S','Penuelas','D','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(55033,'63137','S','North County','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748404,-90.218419,0,'2013-07-06 12:44:33',NULL,NULL),(49779,'57075','S','Smiths Park','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.998194,-96.968790,0,'2013-07-06 12:44:33',NULL,NULL),(6234,'05491','S','Owls Head Harbor','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(23120,'24954','S','Minnehaha Springs','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.211660,-80.055660,0,'2013-07-06 12:44:31',NULL,NULL),(624,'00682','S','Mans de Espana','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(12215,'12803','S','Glens Falls','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.280520,-73.630020,0,'2013-07-06 12:44:30',NULL,NULL),(77245,'96541','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(1140,'00727','S','Alt Villa del Rey','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(74273,'92352','P','Lake Arrowhead','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.257718,-117.190169,0,'2013-07-06 12:44:34',NULL,NULL),(72255,'88532','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812036,-106.416055,0,'2013-07-06 12:44:34',NULL,NULL),(71663,'87502','P','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.662831,-105.980173,0,'2013-07-06 12:44:34',NULL,NULL),(2140,'00924','S','Urb Las Virtudes','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(59506,'70777','S','Slaughter','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.685136,-91.114161,0,'2013-07-06 12:44:33',NULL,NULL),(37509,'42037','P','Dycusburg','D','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.158069,-88.186909,0,'2013-07-06 12:44:32',NULL,NULL),(32676,'36266','S','Lineville','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(14750,'15320','S','Fairdale','N','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.874080,-79.982880,0,'2013-07-06 12:44:31',NULL,NULL),(7999,'07719','S','S Belmar','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(48829,'56042','S','Hartland','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.805754,-93.490778,0,'2013-07-06 12:44:33',NULL,NULL),(48316,'55444','S','Brooklyn Pk','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.088050,-93.296289,0,'2013-07-06 12:44:33',NULL,NULL),(23590,'25676','S','Lenore','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.804610,-82.272646,0,'2013-07-06 12:44:31',NULL,NULL),(24081,'26452','S','Weston','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.041383,-80.464446,0,'2013-07-06 12:44:31',NULL,NULL),(36430,'40580','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.136215,-84.470716,0,'2013-07-06 12:44:32',NULL,NULL),(32379,'35904','S','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.023713,-86.054211,0,'2013-07-06 12:44:32',NULL,NULL),(57106,'66221','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(51193,'59029','S','Fromberg','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.393397,-108.908205,0,'2013-07-06 12:44:33',NULL,NULL),(48866,'56081','S','St James','N','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.984257,-94.625393,0,'2013-07-06 12:44:33',NULL,NULL),(48727,'55959','S','Minnesota City','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087785,-91.743808,0,'2013-07-06 12:44:33',NULL,NULL),(45914,'52323','S','Oxford Junction','D','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.989991,-90.978487,0,'2013-07-06 12:44:32',NULL,NULL),(22569,'24151','S','Rocky Mount','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.000112,-79.895756,0,'2013-07-06 12:44:31',NULL,NULL),(30162,'33170','S','Perrine','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(78551,'98148','S','Burien','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.425051,-122.332127,0,'2013-07-06 12:44:34',NULL,NULL),(70509,'84783','S','Dammeron Vly','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.313820,-113.668620,0,'2013-07-06 12:44:34',NULL,NULL),(49968,'57353','S','Esmond','N','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365169,-97.849047,0,'2013-07-06 12:44:33',NULL,NULL),(19472,'20140','P','Rectortown','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.920368,-77.862916,0,'2013-07-06 12:44:31',NULL,NULL),(9436,'10004','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(13735,'14105','S','Royalton','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.209014,-78.492391,0,'2013-07-06 12:44:31',NULL,NULL),(19705,'20388','S','Naval Investigative Service','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878851,-76.991728,0,'2013-07-06 12:44:31',NULL,NULL),(8783,'08555','P','Roosevelt','D','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.216490,-74.473122,0,'2013-07-06 12:44:30',NULL,NULL),(28653,'31772','S','Oakfield','D','Worth','13321','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.787275,-83.962687,0,'2013-07-06 12:44:32',NULL,NULL),(27868,'30442','S','Millen','D','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(37612,'42130','S','Eighty Eight','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.924418,-85.789972,0,'2013-07-06 12:44:32',NULL,NULL),(60997,'72112','S','Murphys Corner','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(53838,'62314','S','Baylis','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.781675,-90.857580,0,'2013-07-06 12:44:33',NULL,NULL),(68534,'81414','P','Cory','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.788359,-107.986539,0,'2013-07-06 12:44:34',NULL,NULL),(70136,'84302','S','Perry','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.536080,-112.048800,0,'2013-07-06 12:44:34',NULL,NULL),(70836,'85533','S','Clifton','D','Greenlee','04011','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.045381,-109.294642,0,'2013-07-06 12:44:34',NULL,NULL),(74077,'92177','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.823966,-117.198462,0,'2013-07-06 12:44:34',NULL,NULL),(79610,'99110','S','Clayton','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.011653,-117.526022,0,'2013-07-06 12:44:34',NULL,NULL),(72214,'88424','S','Mt Dora','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.737332,-103.457179,0,'2013-07-06 12:44:34',NULL,NULL),(77563,'96910','S','Agana Heights','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(67595,'80422','S','Black Hawk','D','Gilpin','08047','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.821401,-105.500162,0,'2013-07-06 12:44:34',NULL,NULL),(46465,'53215','S','W Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.997687,-87.942662,0,'2013-07-06 12:44:32',NULL,NULL),(19815,'20453','U','Comm Equal Oppor Armed Forc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(17077,'17758','S','Strawbridge','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(40855,'46227','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.674837,-86.127705,0,'2013-07-06 12:44:32',NULL,NULL),(7550,'07014','S','Clifton','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.835346,-74.135292,0,'2013-07-06 12:44:30',NULL,NULL),(19185,'19804','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.724680,-75.606060,0,'2013-07-06 12:44:31',NULL,NULL),(4994,'04212','P','Auburn','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.084323,-70.251260,0,'2013-07-06 12:44:30',NULL,NULL),(57503,'66951','S','Kensington','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.766393,-99.033290,0,'2013-07-06 12:44:33',NULL,NULL),(56520,'65355','S','Old Fredonia','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(79540,'98950','P','Ellensburg','A','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.946109,-119.985319,0,'2013-07-06 12:44:34',NULL,NULL),(52411,'60640','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.972600,-87.666715,0,'2013-07-06 12:44:33',NULL,NULL),(75939,'95030','S','Los Gatos','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.171920,-121.974720,0,'2013-07-06 12:44:34',NULL,NULL),(48847,'56063','S','Madison Lake','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.202965,-93.811225,0,'2013-07-06 12:44:33',NULL,NULL),(32464,'36031','P','Fort Davis','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.286461,-85.728157,0,'2013-07-06 12:44:32',NULL,NULL),(17731,'18252','S','Hometown','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.798861,-75.971960,0,'2013-07-06 12:44:31',NULL,NULL),(3032,'01096','S','S Chesterfield','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.399296,-72.749011,0,'2013-07-06 12:44:30',NULL,NULL),(1329,'00736','S','Bda Cantera','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(15575,'16652','S','Huntingdon','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.496445,-78.012809,0,'2013-07-06 12:44:31',NULL,NULL),(40989,'46356','S','Belshaw','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.284559,-87.416071,0,'2013-07-06 12:44:32',NULL,NULL),(58202,'68324','S','Burr','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.537964,-96.303129,0,'2013-07-06 12:44:33',NULL,NULL),(2929,'01021','P','Chicopee','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.177959,-72.572836,0,'2013-07-06 12:44:30',NULL,NULL),(46285,'53042','S','Kiel','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.925523,-87.986674,0,'2013-07-06 12:44:32',NULL,NULL),(39826,'45152','S','Morrow','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.350658,-84.092161,0,'2013-07-06 12:44:32',NULL,NULL),(35419,'39470','S','Crossroads','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(76190,'95345','S','Midpines','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.564531,-119.946697,0,'2013-07-06 12:44:34',NULL,NULL),(45950,'52349','S','Vinton','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.166008,-92.019386,0,'2013-07-06 12:44:32',NULL,NULL),(76479,'95627','S','Esparto','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.691535,-122.017443,0,'2013-07-06 12:44:34',NULL,NULL),(74223,'92315','S','Big Bear','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.244670,-116.890676,0,'2013-07-06 12:44:34',NULL,NULL),(55194,'63381','S','New Truxton','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.962877,-91.225396,0,'2013-07-06 12:44:33',NULL,NULL),(50391,'57769','S','Bethlehem','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.229112,-103.390064,0,'2013-07-06 12:44:33',NULL,NULL),(19376,'20061','U','Wachovia','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918880,-76.993855,0,'2013-07-06 12:44:31',NULL,NULL),(33752,'37849','S','Powell','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.054476,-84.029301,0,'2013-07-06 12:44:32',NULL,NULL),(34094,'38166','U','Southeast Area','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.130758,-90.004671,0,'2013-07-06 12:44:32',NULL,NULL),(34274,'38473','S','Minor Hill','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.048358,-87.154937,0,'2013-07-06 12:44:32',NULL,NULL),(13666,'14031','S','Clarence','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.982268,-78.617411,0,'2013-07-06 12:44:31',NULL,NULL),(37517,'42041','S','Cayce','N','Fulton','21075','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.531900,-88.947480,0,'2013-07-06 12:44:32',NULL,NULL),(5204,'04455','S','Lee','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.368332,-68.291487,0,'2013-07-06 12:44:30',NULL,NULL),(35278,'39401','S','Arnold Line','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(45794,'52169','S','Wadena','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.839330,-91.652851,0,'2013-07-06 12:44:32',NULL,NULL),(30835,'33626','S','Westchase','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.056858,-82.605871,0,'2013-07-06 12:44:32',NULL,NULL),(57886,'67631','S','Collyer','D','Trego','20195','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.916551,-100.058186,0,'2013-07-06 12:44:33',NULL,NULL),(68423,'81211','S','Johnson Village','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.849213,-106.155646,0,'2013-07-06 12:44:34',NULL,NULL),(50777,'58425','S','Shepard','N','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.445786,-98.118678,0,'2013-07-06 12:44:33',NULL,NULL),(48556,'55763','S','Makinen','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.336731,-92.257473,0,'2013-07-06 12:44:33',NULL,NULL),(47814,'55056','S','Weber','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.504480,-92.877900,0,'2013-07-06 12:44:33',NULL,NULL),(33583,'37601','S','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.331192,-82.359362,0,'2013-07-06 12:44:32',NULL,NULL),(42144,'47519','S','Barr','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.697215,-86.969122,0,'2013-07-06 12:44:32',NULL,NULL),(24842,'27617','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.877636,-78.743481,0,'2013-07-06 12:44:31',NULL,NULL),(25797,'28605','S','Bamboo','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.116573,-81.678226,0,'2013-07-06 12:44:31',NULL,NULL),(76352,'95480','S','Stewarts Pt','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.619693,-123.377331,0,'2013-07-06 12:44:34',NULL,NULL),(60712,'71953','S','Big Fork','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(79192,'98532','S','Bunker','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(67382,'80121','S','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(62332,'74048','S','Nowata','D','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.697172,-95.639359,0,'2013-07-06 12:44:33',NULL,NULL),(61170,'72190','P','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.798097,-92.256024,0,'2013-07-06 12:44:33',NULL,NULL),(53025,'61470','S','Walnut Grove','N','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.606546,-90.501629,0,'2013-07-06 12:44:33',NULL,NULL),(45812,'52203','S','East Amana','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.804159,-91.867902,0,'2013-07-06 12:44:32',NULL,NULL),(25902,'28645','S','Brown Mountain Beach','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(64804,'77024','S','Bunker Hill Village','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(58775,'68971','S','Mullally','N','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.100098,-99.231767,0,'2013-07-06 12:44:33',NULL,NULL),(21492,'22654','S','Star Tannery','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.081239,-78.461184,0,'2013-07-06 12:44:31',NULL,NULL),(14174,'14740','S','Gerry','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.198621,-79.226713,0,'2013-07-06 12:44:31',NULL,NULL),(14322,'14903','S','Elmira Hgts','A','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.127740,-76.869660,0,'2013-07-06 12:44:31',NULL,NULL),(26304,'29033','S','West Columbia','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.965536,-81.069156,0,'2013-07-06 12:44:31',NULL,NULL),(38427,'43552','P','Perrysburg','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.553911,-83.626056,0,'2013-07-06 12:44:32',NULL,NULL),(50635,'58278','S','Thompson','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.775505,-97.103322,0,'2013-07-06 12:44:33',NULL,NULL),(46206,'52756','S','Long Grove','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.721476,-90.549616,0,'2013-07-06 12:44:32',NULL,NULL),(40861,'46228','S','Spring Hills','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(25054,'27922','S','Cofield','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.316047,-76.856572,0,'2013-07-06 12:44:31',NULL,NULL),(29594,'32830','P','Lk Buena Vis','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.370015,-81.556799,0,'2013-07-06 12:44:32',NULL,NULL),(41963,'47407','P','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.170043,-86.495005,0,'2013-07-06 12:44:32',NULL,NULL),(78056,'97453','S','Mapleton','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.035320,-123.862351,0,'2013-07-06 12:44:34',NULL,NULL),(70250,'84414','S','North Ogden','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.315661,-111.978351,0,'2013-07-06 12:44:34',NULL,NULL),(64400,'76541','S','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.114961,-97.723782,0,'2013-07-06 12:44:34',NULL,NULL),(56749,'65723','S','Pierce City','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.946566,-94.004128,0,'2013-07-06 12:44:33',NULL,NULL),(55399,'63637','S','Doe Run','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.743759,-90.499528,0,'2013-07-06 12:44:33',NULL,NULL),(42984,'48146','S','Lincoln Park','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.245551,-83.180156,0,'2013-07-06 12:44:32',NULL,NULL),(25919,'28649','S','Halls Mills','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.321231,-81.188583,0,'2013-07-06 12:44:31',NULL,NULL),(23696,'25864','S','Layland','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.871329,-80.996894,0,'2013-07-06 12:44:31',NULL,NULL),(20552,'21122','S','Pasadena','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.127599,-76.512544,0,'2013-07-06 12:44:31',NULL,NULL),(40898,'46253','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.826866,-86.270775,0,'2013-07-06 12:44:32',NULL,NULL),(52412,'60641','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.944704,-87.745925,0,'2013-07-06 12:44:33',NULL,NULL),(49456,'56647','S','Hines','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.758791,-94.680589,0,'2013-07-06 12:44:33',NULL,NULL),(23725,'25908','S','Winding Gulf','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.656976,-81.239502,0,'2013-07-06 12:44:31',NULL,NULL),(30765,'33572','S','Ruskin','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.771363,-82.391466,0,'2013-07-06 12:44:32',NULL,NULL),(14022,'14541','S','Mac Dougall','A','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.750765,-76.870680,0,'2013-07-06 12:44:31',NULL,NULL),(59485,'70760','S','New Roads','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.698418,-91.437962,0,'2013-07-06 12:44:33',NULL,NULL),(57764,'67452','S','Hunter','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.264312,-98.432653,0,'2013-07-06 12:44:33',NULL,NULL),(56101,'64781','P','Roscoe','D','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.976815,-93.812387,0,'2013-07-06 12:44:33',NULL,NULL),(3082,'01152','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.152789,-72.511258,0,'2013-07-06 12:44:30',NULL,NULL),(37051,'41301','S','Campton','D','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(43086,'48206','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.372290,-83.099898,0,'2013-07-06 12:44:32',NULL,NULL),(24212,'26705','S','Aurora','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.302220,-79.577580,0,'2013-07-06 12:44:31',NULL,NULL),(69498,'83706','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.590476,-116.189842,0,'2013-07-06 12:44:34',NULL,NULL),(77726,'97065','S','Wasco','D','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.593945,-120.695798,0,'2013-07-06 12:44:34',NULL,NULL),(51181,'59016','S','Busby','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.516379,-106.872747,0,'2013-07-06 12:44:33',NULL,NULL),(77181,'96310','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60563,'71751','S','Louann','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.409352,-92.779759,0,'2013-07-06 12:44:33',NULL,NULL),(51235,'59067','S','Rapelje','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.978980,-109.320062,0,'2013-07-06 12:44:33',NULL,NULL),(10992,'11548','S','Roslyn Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(14190,'14754','S','Little Genesee','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.024649,-78.183950,0,'2013-07-06 12:44:31',NULL,NULL),(3206,'01354','S','Northfield Mt Hermon','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711180,-72.448620,0,'2013-07-06 12:44:30',NULL,NULL),(40315,'45459','S','Washingtn Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(18722,'19316','P','Brandamore','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.048316,-75.831566,0,'2013-07-06 12:44:31',NULL,NULL),(9833,'10115','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(8845,'08641','S','Mc Guire Air Force Base','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.027821,-74.570679,0,'2013-07-06 12:44:30',NULL,NULL),(65414,'77571','S','Sylvan Beach','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.658283,-95.049187,0,'2013-07-06 12:44:34',NULL,NULL),(35787,'39750','S','Maben','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.509640,-89.066880,0,'2013-07-06 12:44:32',NULL,NULL),(34560,'38726','S','Mound City','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.786816,-90.981417,0,'2013-07-06 12:44:32',NULL,NULL),(42196,'47549','U','Kimball International','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.392247,-86.955378,0,'2013-07-06 12:44:32',NULL,NULL),(75724,'94589','S','American Canyon','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.162340,-122.249400,0,'2013-07-06 12:44:34',NULL,NULL),(19330,'20030','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.862889,-76.974730,0,'2013-07-06 12:44:31',NULL,NULL),(75304,'93741','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.798392,-119.801743,0,'2013-07-06 12:44:34',NULL,NULL),(70879,'85610','S','Elfrida','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.719147,-109.464014,0,'2013-07-06 12:44:34',NULL,NULL),(69062,'83236','S','Kimball','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.286660,-112.129557,0,'2013-07-06 12:44:34',NULL,NULL),(43700,'48891','S','Vestaburg','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.395790,-84.918019,0,'2013-07-06 12:44:32',NULL,NULL),(25058,'27926','S','Corapeake','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.506041,-76.585151,0,'2013-07-06 12:44:31',NULL,NULL),(31273,'34020','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(200,'00623','S','Urb Monte Rio','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(36657,'41007','S','Mentor','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.894989,-84.294749,0,'2013-07-06 12:44:32',NULL,NULL),(37416,'41804','S','Carcassonne','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.175000,-83.000000,0,'2013-07-06 12:44:32',NULL,NULL),(32373,'35899','U','Univ of Alabama Hsv','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.740543,-86.629283,0,'2013-07-06 12:44:32',NULL,NULL),(56912,'66050','S','Lecompton','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',39.039869,-95.402286,0,'2013-07-06 12:44:33',NULL,NULL),(47622,'54906','U','Miles Kimball Co','N','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.018997,-88.553426,0,'2013-07-06 12:44:33',NULL,NULL),(4042,'02601','S','Hyannis','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.651481,-70.295573,0,'2013-07-06 12:44:30',NULL,NULL),(43395,'48441','S','Harbor Beach','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.809224,-82.686669,0,'2013-07-06 12:44:32',NULL,NULL),(5601,'04927','S','Clinton','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.594335,-69.507931,0,'2013-07-06 12:44:30',NULL,NULL),(17000,'17735','P','Grover','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.614555,-76.864981,0,'2013-07-06 12:44:31',NULL,NULL),(26435,'29128','S','Pisgah','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(618,'00682','S','Bo Dulces Labios','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(70037,'84133','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.770852,-111.892118,0,'2013-07-06 12:44:34',NULL,NULL),(59445,'70722','S','Clinton','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.709871,-90.896667,0,'2013-07-06 12:44:33',NULL,NULL),(73315,'90813','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.778685,-118.191698,0,'2013-07-06 12:44:34',NULL,NULL),(71527,'87124','S','Albuquerque','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.256600,-106.696560,0,'2013-07-06 12:44:34',NULL,NULL),(63278,'75551','S','Galloway','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.115529,-94.170131,0,'2013-07-06 12:44:33',NULL,NULL),(60335,'71463','S','Ward','N','Allen','22003','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.817482,-92.658202,0,'2013-07-06 12:44:33',NULL,NULL),(49192,'56442','S','Manhattan Beach','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.677300,-94.112100,0,'2013-07-06 12:44:33',NULL,NULL),(48335,'55467','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.980000,-93.263611,0,'2013-07-06 12:44:33',NULL,NULL),(47114,'54449','S','Marshfield','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.612100,-90.187920,0,'2013-07-06 12:44:32',NULL,NULL),(10977,'11531','P','Roosevelt Field','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.721588,-73.632436,0,'2013-07-06 12:44:30',NULL,NULL),(35549,'39564','S','Gulf Islands National Seasho','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(58095,'68107','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.207250,-95.955270,0,'2013-07-06 12:44:33',NULL,NULL),(6210,'05487','S','Buels Gore','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.229720,-73.013400,0,'2013-07-06 12:44:30',NULL,NULL),(78000,'97408','S','Coburg','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.054100,-123.091980,0,'2013-07-06 12:44:34',NULL,NULL),(59510,'70783','S','Ventress','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.686090,-91.386692,0,'2013-07-06 12:44:33',NULL,NULL),(24835,'27612','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.856914,-78.689606,0,'2013-07-06 12:44:31',NULL,NULL),(16603,'17327','S','Larue','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.798447,-76.722134,0,'2013-07-06 12:44:31',NULL,NULL),(52582,'60974','P','Woodland','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.714106,-87.733104,0,'2013-07-06 12:44:33',NULL,NULL),(3865,'02357','U','North Easton','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.059436,-71.080861,0,'2013-07-06 12:44:30',NULL,NULL),(9603,'10031','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(70648,'85190','P','Apache Jct','N','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.414513,-111.581113,0,'2013-07-06 12:44:34',NULL,NULL),(77371,'96749','S','Keaau','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.575395,-154.961816,0,'2013-07-06 12:44:34',NULL,NULL),(15110,'15776','S','Sprankle Mls','A','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.021239,-79.085612,0,'2013-07-06 12:44:31',NULL,NULL),(80139,'99778','P','Teller','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.179234,-166.288621,0,'2013-07-06 12:44:34',NULL,NULL),(57666,'67215','S','Oatville','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.628626,-97.431951,0,'2013-07-06 12:44:33',NULL,NULL),(48217,'55415','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.979183,-93.261094,0,'2013-07-06 12:44:33',NULL,NULL),(13452,'13778','S','Greene','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(392,'00662','S','Comunidad Guanabano','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(45652,'52001','S','Key West','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(67808,'80742','S','Raymer','N','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.643775,-103.873642,0,'2013-07-06 12:44:34',NULL,NULL),(72839,'89833','S','Shantytown','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.306038,-115.284616,0,'2013-07-06 12:44:34',NULL,NULL),(55424,'63660','S','Mineral Point','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.916100,-90.710280,0,'2013-07-06 12:44:33',NULL,NULL),(54373,'62810','S','Belle Rive','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.190078,-88.761816,0,'2013-07-06 12:44:33',NULL,NULL),(26211,'28784','P','Tuxedo','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.232294,-82.431185,0,'2013-07-06 12:44:31',NULL,NULL),(66296,'78586','S','Carricitos','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(22497,'24072','S','Check','D','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.036016,-80.241336,0,'2013-07-06 12:44:31',NULL,NULL),(68876,'82643','S','Midwest','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.409443,-106.276916,0,'2013-07-06 12:44:34',NULL,NULL),(54608,'62910','S','Shady Grove','N','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.125868,-88.629383,0,'2013-07-06 12:44:33',NULL,NULL),(51036,'58723','S','Butte','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.764294,-100.649272,0,'2013-07-06 12:44:33',NULL,NULL),(45223,'50643','S','Voorhies','A','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.383057,-92.461301,0,'2013-07-06 12:44:32',NULL,NULL),(29566,'32815','P','Kennedy Space Center','A','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.592290,-80.656063,0,'2013-07-06 12:44:32',NULL,NULL),(70434,'84737','S','Hurricane','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.242480,-113.200860,0,'2013-07-06 12:44:34',NULL,NULL),(78437,'98056','S','Kennydale','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.512620,-122.193420,0,'2013-07-06 12:44:34',NULL,NULL),(47554,'54830','S','Yellow Lake','A','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.998019,-92.252388,0,'2013-07-06 12:44:32',NULL,NULL),(80096,'99747','P','Kaktovik','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',69.877219,-143.681104,0,'2013-07-06 12:44:34',NULL,NULL),(71118,'86017','P','Flagstaff','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.946175,-111.638116,0,'2013-07-06 12:44:34',NULL,NULL),(69452,'83647','S','Prairie','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(65048,'77335','S','Goodrich','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.551965,-94.877464,0,'2013-07-06 12:44:34',NULL,NULL),(55525,'63823','S','Bertrand','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.911363,-89.446282,0,'2013-07-06 12:44:33',NULL,NULL),(47192,'54486','S','Split Rock','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.743866,-89.041687,0,'2013-07-06 12:44:32',NULL,NULL),(33261,'37088','P','Lebanon','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.208115,-86.289256,0,'2013-07-06 12:44:32',NULL,NULL),(26580,'29218','U','SC Electric And Gas','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.007301,-81.036586,0,'2013-07-06 12:44:31',NULL,NULL),(32822,'36460','S','Monroeville','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.514812,-87.327625,0,'2013-07-06 12:44:32',NULL,NULL),(13507,'13809','S','Rockdale','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.406126,-75.409032,0,'2013-07-06 12:44:31',NULL,NULL),(28901,'32132','S','Edgewater','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.975063,-80.912136,0,'2013-07-06 12:44:32',NULL,NULL),(23078,'24892','S','War','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.304104,-81.680662,0,'2013-07-06 12:44:31',NULL,NULL),(4488,'03275','S','Suncook','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.173240,-71.403720,0,'2013-07-06 12:44:30',NULL,NULL),(63317,'75568','S','Rocky Branch','N','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192600,-94.693620,0,'2013-07-06 12:44:33',NULL,NULL),(59054,'70090','S','Vacherie','D','Saint James','22093','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.961304,-90.706982,0,'2013-07-06 12:44:33',NULL,NULL),(11037,'11570','S','Rockville Center','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.665099,-73.637798,0,'2013-07-06 12:44:30',NULL,NULL),(77763,'97114','S','Dayton','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.174600,-123.069660,0,'2013-07-06 12:44:34',NULL,NULL),(39680,'45015','S','Lindenwald','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.367572,-84.550446,0,'2013-07-06 12:44:32',NULL,NULL),(71529,'87124','S','Rancho West','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.256600,-106.696560,0,'2013-07-06 12:44:34',NULL,NULL),(62401,'74112','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.145326,-95.906130,0,'2013-07-06 12:44:33',NULL,NULL),(48433,'55701','S','Adolph','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.841320,-92.220552,0,'2013-07-06 12:44:33',NULL,NULL),(29639,'32897','U','Suntrust National Bank','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.538957,-81.379064,0,'2013-07-06 12:44:32',NULL,NULL),(20975,'21794','S','West Friendship','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295986,-76.972906,0,'2013-07-06 12:44:31',NULL,NULL),(14965,'15626','S','Delmont','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.406329,-79.574177,0,'2013-07-06 12:44:31',NULL,NULL),(24203,'26680','S','Nallen','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.100120,-80.886900,0,'2013-07-06 12:44:31',NULL,NULL),(74043,'92145','U','Nas Miramar','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.874445,-117.152969,0,'2013-07-06 12:44:34',NULL,NULL),(75767,'94623','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.810666,-122.297470,0,'2013-07-06 12:44:34',NULL,NULL),(7280,'06531','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318194,-72.929494,0,'2013-07-06 12:44:30',NULL,NULL),(4750,'03843','P','Hampton','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.940988,-70.825066,0,'2013-07-06 12:44:30',NULL,NULL),(11550,'12054','S','Elsmere','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.605220,-73.870080,0,'2013-07-06 12:44:30',NULL,NULL),(61953,'73167','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460945,-97.520644,0,'2013-07-06 12:44:33',NULL,NULL),(29225,'32425','S','Bonifay','D','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.795111,-85.677801,0,'2013-07-06 12:44:32',NULL,NULL),(79253,'98563','S','Brady','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(75686,'94557','P','Mount Eden','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.629876,-122.103025,0,'2013-07-06 12:44:34',NULL,NULL),(51805,'60048','S','Green Oaks','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.293735,-87.944893,0,'2013-07-06 12:44:33',NULL,NULL),(45498,'51358','S','Ruthven','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.131401,-94.899857,0,'2013-07-06 12:44:32',NULL,NULL),(44902,'50324','S','Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543762,-93.586549,0,'2013-07-06 12:44:32',NULL,NULL),(42725,'48006','S','Fargo','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(14373,'15027','S','Conway','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.661278,-80.235402,0,'2013-07-06 12:44:31',NULL,NULL),(7127,'06385','S','Millstone','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.347357,-72.147670,0,'2013-07-06 12:44:30',NULL,NULL),(12384,'12919','S','Coopersville','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.965140,-73.434300,0,'2013-07-06 12:44:30',NULL,NULL),(67639,'80456','S','Jefferson','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.224722,-106.001389,0,'2013-07-06 12:44:34',NULL,NULL),(39539,'44837','S','Greenwich','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.032283,-82.508909,0,'2013-07-06 12:44:32',NULL,NULL),(63129,'75339','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.716432,-96.783070,0,'2013-07-06 12:44:33',NULL,NULL),(12964,'13364','P','Leonardsville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.808457,-75.253988,0,'2013-07-06 12:44:30',NULL,NULL),(57295,'66619','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.952172,-95.713215,0,'2013-07-06 12:44:33',NULL,NULL),(54811,'63021','S','Ellisville','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(67857,'80824','S','Kirk','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.667666,-102.417352,0,'2013-07-06 12:44:34',NULL,NULL),(59283,'70464','P','Talisheek','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.531567,-89.876619,0,'2013-07-06 12:44:33',NULL,NULL),(69710,'84036','S','Black Rock','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(50226,'57601','S','Gopher','N','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.538190,-100.429946,0,'2013-07-06 12:44:33',NULL,NULL),(22451,'24025','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.272916,-79.952822,0,'2013-07-06 12:44:31',NULL,NULL),(22908,'24603','S','Conaway','A','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.352222,-82.211944,0,'2013-07-06 12:44:31',NULL,NULL),(25622,'28461','S','Boiling Spring Lakes','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(25782,'28604','S','Banner Elk','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(21358,'22442','P','Coles Point','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.146230,-76.633816,0,'2013-07-06 12:44:31',NULL,NULL),(27132,'29809','S','New Ellenton','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.414659,-81.688024,0,'2013-07-06 12:44:31',NULL,NULL),(5811,'05069','S','Swamp Rd','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.219220,-72.129600,0,'2013-07-06 12:44:30',NULL,NULL),(16403,'17223','S','Fort Littletn','A','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.060812,-77.970494,0,'2013-07-06 12:44:31',NULL,NULL),(32865,'36521','S','Chunchula','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.974220,-88.126860,0,'2013-07-06 12:44:32',NULL,NULL),(33298,'37130','S','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.870529,-86.341561,0,'2013-07-06 12:44:32',NULL,NULL),(39485,'44730','S','Mapleton','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.765560,-81.266520,0,'2013-07-06 12:44:32',NULL,NULL),(16636,'17337','P','Idaville','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.013198,-77.202890,0,'2013-07-06 12:44:31',NULL,NULL),(7547,'07012','S','Allwood','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.846872,-74.160888,0,'2013-07-06 12:44:30',NULL,NULL),(59955,'71302','S','Willow Glen','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.266926,-92.417063,0,'2013-07-06 12:44:33',NULL,NULL),(10820,'11378','S','Maspeth','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.725746,-73.903899,0,'2013-07-06 12:44:30',NULL,NULL),(50312,'57717','S','Mason','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.665219,-103.847783,0,'2013-07-06 12:44:33',NULL,NULL),(33291,'37127','S','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.775581,-86.328633,0,'2013-07-06 12:44:32',NULL,NULL),(79754,'99258','U','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.666477,-117.405160,0,'2013-07-06 12:44:34',NULL,NULL),(58110,'68119','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.306600,-95.905130,0,'2013-07-06 12:44:33',NULL,NULL),(56033,'64681','S','Sumner','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.655667,-93.244717,0,'2013-07-06 12:44:33',NULL,NULL),(53728,'62246','S','Stubblefield','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(46083,'52593','S','Udell','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.820480,-92.697529,0,'2013-07-06 12:44:32',NULL,NULL),(12214,'12801','S','West Glens Falls','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.308900,-73.644600,0,'2013-07-06 12:44:30',NULL,NULL),(13126,'13491','S','Plainfield Center','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(13210,'13628','P','Deferiet','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.033049,-75.677888,0,'2013-07-06 12:44:30',NULL,NULL),(35525,'39540','S','Biloxi','A','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.459729,-88.948864,0,'2013-07-06 12:44:32',NULL,NULL),(35955,'40062','S','St Francis','N','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.626449,-85.465732,0,'2013-07-06 12:44:32',NULL,NULL),(18161,'18854','S','Wysox','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.781631,-76.360050,0,'2013-07-06 12:44:31',NULL,NULL),(18264,'19006','S','Huntingdon Vy','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.129527,-75.060892,0,'2013-07-06 12:44:31',NULL,NULL),(1930,'00795','S','Urb Las Flores','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(53423,'61852','S','Longview','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.885257,-88.059748,0,'2013-07-06 12:44:33',NULL,NULL),(40805,'46182','S','Waldron','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.452440,-85.665930,0,'2013-07-06 12:44:32',NULL,NULL),(55801,'64133','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.022020,-94.464540,0,'2013-07-06 12:44:33',NULL,NULL),(32258,'35619','S','Danville','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.419222,-87.159667,0,'2013-07-06 12:44:32',NULL,NULL),(50796,'58444','S','Goodrich','D','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.479344,-100.123247,0,'2013-07-06 12:44:33',NULL,NULL),(47433,'54702','P','Eau Claire','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.814260,-91.501979,0,'2013-07-06 12:44:32',NULL,NULL),(29104,'32305','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.199158,-84.267525,0,'2013-07-06 12:44:32',NULL,NULL),(21302,'22403','P','Fredericksburg','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.350856,-77.477360,0,'2013-07-06 12:44:31',NULL,NULL),(26681,'29404','S','Chas AFB','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(9992,'10166','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(78894,'98359','S','Olalla','D','Kitsap','53035','Washington','WA','53','1150','253/564','Pacific',-8.0,'Y',47.427546,-122.575624,0,'2013-07-06 12:44:34',NULL,NULL),(9203,'09468','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(72497,'89143','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.322533,-115.283692,0,'2013-07-06 12:44:34',NULL,NULL),(30846,'33637','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.032275,-82.365111,0,'2013-07-06 12:44:32',NULL,NULL),(38342,'43439','P','Lacarne','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.517228,-83.040882,0,'2013-07-06 12:44:32',NULL,NULL),(10772,'11364','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(51516,'59701','S','Walkerville','A','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.946740,-112.517340,0,'2013-07-06 12:44:33',NULL,NULL),(39741,'45069','S','Pisgah','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.341460,-84.398674,0,'2013-07-06 12:44:32',NULL,NULL),(42654,'47946','S','Francesville','D','Pulaski','18131','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.984945,-86.882427,0,'2013-07-06 12:44:32',NULL,NULL),(12741,'13167','S','West Monroe','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.284609,-76.076927,0,'2013-07-06 12:44:30',NULL,NULL),(20119,'20716','S','Mitchellville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.925300,-76.715460,0,'2013-07-06 12:44:31',NULL,NULL),(30501,'33401','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.705811,-80.064783,0,'2013-07-06 12:44:32',NULL,NULL),(62008,'73442','S','Loco','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.323988,-97.688378,0,'2013-07-06 12:44:33',NULL,NULL),(51392,'59420','S','Carter','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.785720,-110.999607,0,'2013-07-06 12:44:33',NULL,NULL),(65582,'77865','S','Vanetia','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.220641,-96.236902,0,'2013-07-06 12:44:34',NULL,NULL),(67699,'80523','U','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.572240,-105.086088,0,'2013-07-06 12:44:34',NULL,NULL),(3113,'01230','S','Risingdale','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(78379,'98024','S','Fall City','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.561848,-121.901429,0,'2013-07-06 12:44:34',NULL,NULL),(64298,'76457','S','Duffau','N','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.990782,-98.024841,0,'2013-07-06 12:44:34',NULL,NULL),(69153,'83316','S','Buhl','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.604315,-114.762452,0,'2013-07-06 12:44:34',NULL,NULL),(33870,'38015','S','Randolph','N','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.560536,-89.838101,0,'2013-07-06 12:44:32',NULL,NULL),(63026,'75187','P','Mesquite','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770412,-96.614054,0,'2013-07-06 12:44:33',NULL,NULL),(47982,'55127','S','Vadnais Hts','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(61006,'72113','S','North Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.852398,-92.404691,0,'2013-07-06 12:44:33',NULL,NULL),(50343,'57738','S','Fleming','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.651331,-103.221411,0,'2013-07-06 12:44:33',NULL,NULL),(70317,'84621','S','Axtell','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.118389,-111.773799,0,'2013-07-06 12:44:34',NULL,NULL),(21712,'22980','S','Waynesboro','D','Waynesboro City','51820','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.073472,-78.902930,0,'2013-07-06 12:44:31',NULL,NULL),(27423,'30104','S','Aragon','D','Polk','13233','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.061779,-85.078993,0,'2013-07-06 12:44:31',NULL,NULL),(58430,'68664','P','Snyder','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.703092,-96.789139,0,'2013-07-06 12:44:33',NULL,NULL),(15753,'16914','S','Columbia Cross Roads','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(25097,'27960','P','Ocracoke','D','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.112320,-75.976220,0,'2013-07-06 12:44:31',NULL,NULL),(18543,'19113','S','Phila','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868191,-75.284889,0,'2013-07-06 12:44:31',NULL,NULL),(9482,'10011','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(70699,'85264','S','Fort McDowell','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.625402,-111.662260,0,'2013-07-06 12:44:34',NULL,NULL),(38122,'43111','P','Carbon Hill','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.501058,-82.236496,0,'2013-07-06 12:44:32',NULL,NULL),(73472,'91310','P','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.494638,-118.614455,0,'2013-07-06 12:44:34',NULL,NULL),(21372,'22460','S','Farnham','D','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.864783,-76.598767,0,'2013-07-06 12:44:31',NULL,NULL),(51804,'60047','S','Long Grove','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(55479,'63751','S','Grassy','A','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.327212,-90.061063,0,'2013-07-06 12:44:33',NULL,NULL),(20548,'21120','S','Bentley Spgs','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.639703,-76.682750,0,'2013-07-06 12:44:31',NULL,NULL),(70966,'85653','S','Marana','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.414714,-111.294865,0,'2013-07-06 12:44:34',NULL,NULL),(71733,'87533','P','Espanola','D','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.991120,-106.080000,0,'2013-07-06 12:44:34',NULL,NULL),(77259,'96555','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(66266,'78578','S','Bahia Mar','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(24003,'26347','S','Wendel','A','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.269476,-80.125327,0,'2013-07-06 12:44:31',NULL,NULL),(59100,'70130','S','Lafayette Square','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.935313,-90.068825,0,'2013-07-06 12:44:33',NULL,NULL),(34760,'38860','S','Egypt','A','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.005968,-88.748637,0,'2013-07-06 12:44:32',NULL,NULL),(74521,'92651','S','Laguna Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.542914,-117.781265,0,'2013-07-06 12:44:34',NULL,NULL),(67732,'80550','S','Severance','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.480502,-104.904076,0,'2013-07-06 12:44:34',NULL,NULL),(23990,'26330','S','Maple Lake','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.289276,-80.254283,0,'2013-07-06 12:44:31',NULL,NULL),(11239,'11757','S','Heer Park','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.688951,-73.376317,0,'2013-07-06 12:44:30',NULL,NULL),(9715,'10080','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.698283,-73.981208,0,'2013-07-06 12:44:30',NULL,NULL),(43077,'48198','S','Superior Twp','A','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.248536,-83.586753,0,'2013-07-06 12:44:32',NULL,NULL),(30188,'33178','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.856770,-80.415990,0,'2013-07-06 12:44:32',NULL,NULL),(28987,'32214','U','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.216694,-81.684003,0,'2013-07-06 12:44:32',NULL,NULL),(10711,'11237','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.704643,-73.921609,0,'2013-07-06 12:44:30',NULL,NULL),(30448,'33332','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(40441,'45721','S','Dungannon','N','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.567042,-81.582359,0,'2013-07-06 12:44:32',NULL,NULL),(41474,'46926','S','Denver','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.891935,-86.050254,0,'2013-07-06 12:44:32',NULL,NULL),(32766,'36360','S','Ozark','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.443324,-85.646911,0,'2013-07-06 12:44:32',NULL,NULL),(56792,'65760','S','Tecumseh','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.584742,-92.258059,0,'2013-07-06 12:44:33',NULL,NULL),(70191,'84337','S','Bothwell','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.676420,-112.267800,0,'2013-07-06 12:44:34',NULL,NULL),(66612,'78767','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.272823,-97.742829,0,'2013-07-06 12:44:34',NULL,NULL),(7535,'07006','S','West Caldwell','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.855020,-74.277840,0,'2013-07-06 12:44:30',NULL,NULL),(30547,'33410','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(76399,'95545','P','Honeydew','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.245055,-124.116430,0,'2013-07-06 12:44:34',NULL,NULL),(64968,'77255','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.804405,-95.496230,0,'2013-07-06 12:44:34',NULL,NULL),(1396,'00738','S','Urb Baralt','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(22723,'24360','S','Max Meadows','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.924480,-80.911800,0,'2013-07-06 12:44:31',NULL,NULL),(36434,'40588','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.046141,-84.498648,0,'2013-07-06 12:44:32',NULL,NULL),(23971,'26301','S','Country Club','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(39109,'44243','S','Kent','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.136498,-81.341458,0,'2013-07-06 12:44:32',NULL,NULL),(35294,'39401','S','Macedonia','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(38298,'43345','S','Ridgeway','D','Hardin','39065','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.528770,-83.584574,0,'2013-07-06 12:44:32',NULL,NULL),(52680,'61081','S','Coleta','A','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.818523,-89.718838,0,'2013-07-06 12:44:33',NULL,NULL),(74932,'93406','P','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.246254,-120.639327,0,'2013-07-06 12:44:34',NULL,NULL),(66022,'78361','S','Bustamante','N','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',27.283639,-98.691312,0,'2013-07-06 12:44:34',NULL,NULL),(6287,'05647','S','Cabot','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.400126,-72.297615,0,'2013-07-06 12:44:30',NULL,NULL),(22086,'23399','S','Jenkins Brg','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.917093,-75.635031,0,'2013-07-06 12:44:31',NULL,NULL),(20392,'20895','S','Kensington','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.027491,-77.077263,0,'2013-07-06 12:44:31',NULL,NULL),(17606,'18042','S','College Hill','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(55078,'63182','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.630539,-90.203178,0,'2013-07-06 12:44:33',NULL,NULL),(20983,'21810','P','Allen','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.285863,-75.689873,0,'2013-07-06 12:44:31',NULL,NULL),(28154,'30830','S','Waynesboro','D','Burke','13033','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.092086,-82.019367,0,'2013-07-06 12:44:31',NULL,NULL),(12282,'12842','S','Indian Lake','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.746756,-74.262085,0,'2013-07-06 12:44:30',NULL,NULL),(33577,'37424','P','Chickamauga','N','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.030239,-85.148472,0,'2013-07-06 12:44:32',NULL,NULL),(77007,'96085','S','Scott Bar','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.759130,-123.015446,0,'2013-07-06 12:44:34',NULL,NULL),(65585,'77868','S','Navasota','D','Grimes','48185','Texas','TX','48','1260','936','Central',-6.0,'Y',30.388874,-96.084543,0,'2013-07-06 12:44:34',NULL,NULL),(3422,'01730','S','Bedford','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.493394,-71.278531,0,'2013-07-06 12:44:30',NULL,NULL),(2957,'01036','S','Hampton','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.062919,-72.430251,0,'2013-07-06 12:44:30',NULL,NULL),(29682,'32925','S','Canaveral Air Station','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.229987,-80.623528,0,'2013-07-06 12:44:32',NULL,NULL),(15030,'15689','P','United','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.217074,-79.489300,0,'2013-07-06 12:44:31',NULL,NULL),(56356,'65202','S','Stephens','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(79427,'98827','S','Loomis','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.861023,-119.675028,0,'2013-07-06 12:44:34',NULL,NULL),(74637,'92812','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.816996,-117.928604,0,'2013-07-06 12:44:34',NULL,NULL),(67365,'80112','S','Greenwood Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.575499,-104.861971,0,'2013-07-06 12:44:34',NULL,NULL),(41149,'46701','S','Bear Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(56648,'65615','P','Branson','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.642143,-93.216875,0,'2013-07-06 12:44:33',NULL,NULL),(54347,'62776','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.802184,-89.654242,0,'2013-07-06 12:44:33',NULL,NULL),(79120,'98481','U','World Vision','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.222822,-122.472110,0,'2013-07-06 12:44:34',NULL,NULL),(73374,'91040','S','Sunland','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.260030,-118.332661,0,'2013-07-06 12:44:34',NULL,NULL),(10826,'11379','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715870,-73.882583,0,'2013-07-06 12:44:30',NULL,NULL),(41339,'46785','S','Saint Joe','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.320866,-84.892900,0,'2013-07-06 12:44:32',NULL,NULL),(21588,'22842','S','South Jackson','N','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.753381,-78.639309,0,'2013-07-06 12:44:31',NULL,NULL),(8106,'07803','S','Mine Hill','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.880184,-74.596365,0,'2013-07-06 12:44:30',NULL,NULL),(73795,'91748','S','Rowland Hghts','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(39464,'44708','S','Hills and Dales','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.812034,-81.424133,0,'2013-07-06 12:44:32',NULL,NULL),(4025,'02565','P','Silver Beach','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.639770,-70.635490,0,'2013-07-06 12:44:30',NULL,NULL),(35115,'39210','U','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.276055,-90.218261,0,'2013-07-06 12:44:32',NULL,NULL),(57770,'67457','S','Little River','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.394820,-98.012446,0,'2013-07-06 12:44:33',NULL,NULL),(53655,'62205','S','Washington Pk','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(75930,'95018','S','Lompico','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.063973,-122.063202,0,'2013-07-06 12:44:34',NULL,NULL),(13597,'13850','S','Willow Point','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.055560,-76.024560,0,'2013-07-06 12:44:31',NULL,NULL),(37644,'42167','S','Forkton','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(51059,'58746','S','Kenmare','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678244,-102.068686,0,'2013-07-06 12:44:33',NULL,NULL),(71848,'87592','P','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.794833,-105.993546,0,'2013-07-06 12:44:34',NULL,NULL),(65359,'77532','S','Crosby','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.925886,-95.070322,0,'2013-07-06 12:44:34',NULL,NULL),(12609,'13083','S','Smartville','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.647853,-76.060983,0,'2013-07-06 12:44:30',NULL,NULL),(1070,'00725','S','Paseo Del Rio','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(28496,'31522','S','St Simons Island','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.165091,-81.384700,0,'2013-07-06 12:44:32',NULL,NULL),(62295,'74021','S','Cville','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.360682,-95.850702,0,'2013-07-06 12:44:33',NULL,NULL),(76596,'95686','P','Thornton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.225441,-121.438262,0,'2013-07-06 12:44:34',NULL,NULL),(70069,'84148','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.755635,-111.835281,0,'2013-07-06 12:44:34',NULL,NULL),(61265,'72369','P','Oneida','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.399355,-90.865962,0,'2013-07-06 12:44:33',NULL,NULL),(8140,'07838','S','Great Meadows','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.882833,-74.929368,0,'2013-07-06 12:44:30',NULL,NULL),(26327,'29051','S','Gable','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.841591,-80.087052,0,'2013-07-06 12:44:31',NULL,NULL),(57570,'67055','S','Greenwich','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.781435,-97.202874,0,'2013-07-06 12:44:33',NULL,NULL),(57823,'67525','S','Claflin','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.524583,-98.534997,0,'2013-07-06 12:44:33',NULL,NULL),(72415,'89049','S','Coaldale','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.064715,-117.227674,0,'2013-07-06 12:44:34',NULL,NULL),(72043,'88063','S','Sunland Park','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',31.799466,-106.579887,0,'2013-07-06 12:44:34',NULL,NULL),(51353,'59327','S','Forsyth','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.266629,-106.680593,0,'2013-07-06 12:44:33',NULL,NULL),(44609,'50054','S','Valeria','N','Jasper','19099','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.681400,-93.267900,0,'2013-07-06 12:44:32',NULL,NULL),(40644,'46036','S','Elwood','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(20333,'20849','P','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.082419,-77.152820,0,'2013-07-06 12:44:31',NULL,NULL),(30524,'33406','S','Lake Clarke Shores','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(14864,'15460','P','Martin','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.806688,-79.912558,0,'2013-07-06 12:44:31',NULL,NULL),(53733,'62249','S','Grantfork','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.792100,-89.687580,0,'2013-07-06 12:44:33',NULL,NULL),(73369,'91030','S','S Pasadena','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.111870,-118.155784,0,'2013-07-06 12:44:34',NULL,NULL),(16750,'17512','S','Columbia','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.036944,-76.480322,0,'2013-07-06 12:44:31',NULL,NULL),(3097,'01224','S','Lanesboro','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.489291,-73.195563,0,'2013-07-06 12:44:30',NULL,NULL),(8177,'07877','P','Swartswood','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.087231,-74.829003,0,'2013-07-06 12:44:30',NULL,NULL),(4197,'02827','S','Coventry','A','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.697997,-71.733673,0,'2013-07-06 12:44:30',NULL,NULL),(52590,'61012','S','Capron','D','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.406793,-88.752439,0,'2013-07-06 12:44:33',NULL,NULL),(27123,'29745','S','York','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.004572,-81.209303,0,'2013-07-06 12:44:31',NULL,NULL),(28759,'32006','P','Fleming Isle','A','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.157247,-81.704123,0,'2013-07-06 12:44:32',NULL,NULL),(78116,'97502','S','Medford','A','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.402193,-122.914829,0,'2013-07-06 12:44:34',NULL,NULL),(72376,'89033','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.300750,-115.139908,0,'2013-07-06 12:44:34',NULL,NULL),(23196,'25060','S','Ameagle','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.967841,-81.495097,0,'2013-07-06 12:44:31',NULL,NULL),(23012,'24822','S','Clear Fork','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.651797,-81.691747,0,'2013-07-06 12:44:31',NULL,NULL),(5346,'04607','S','S Gouldsboro','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.472300,-68.086980,0,'2013-07-06 12:44:30',NULL,NULL),(29965,'33077','P','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.246438,-80.263929,0,'2013-07-06 12:44:32',NULL,NULL),(52035,'60185','S','West Chicago','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.887855,-88.198103,0,'2013-07-06 12:44:33',NULL,NULL),(49160,'56389','P','Sauk Centre','A','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.798359,-95.079178,0,'2013-07-06 12:44:33',NULL,NULL),(67922,'80907','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.881982,-104.814334,0,'2013-07-06 12:44:34',NULL,NULL),(69273,'83440','S','Archer','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(21875,'23163','S','Shadow','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.349167,-76.296944,0,'2013-07-06 12:44:31',NULL,NULL),(43880,'49221','S','Cadmus','A','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.904241,-84.050711,0,'2013-07-06 12:44:32',NULL,NULL),(13236,'13640','S','Wellesley Is','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.317415,-76.008175,0,'2013-07-06 12:44:30',NULL,NULL),(24463,'27233','S','Climax','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.932240,-79.699061,0,'2013-07-06 12:44:31',NULL,NULL),(30017,'33133','S','Coconut Grove','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.733767,-80.241942,0,'2013-07-06 12:44:32',NULL,NULL),(59426,'70661','S','Starks','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.319269,-93.624742,0,'2013-07-06 12:44:33',NULL,NULL),(19355,'20049','U','Amer Assc Retired Persons','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894428,-77.020323,0,'2013-07-06 12:44:31',NULL,NULL),(66036,'78368','S','Lake City','A','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(61521,'72660','S','Oak Grove','D','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.459428,-93.431893,0,'2013-07-06 12:44:33',NULL,NULL),(28267,'31078','S','Roberta','D','Crawford','13079','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.723299,-84.016707,0,'2013-07-06 12:44:31',NULL,NULL),(18986,'19522','S','Fleetwood','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(2801,'00976','S','Urb Montebello Est','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(42480,'47837','S','Carbon','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.576608,-87.056532,0,'2013-07-06 12:44:32',NULL,NULL),(12740,'13166','S','Weedsport','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.055291,-76.559355,0,'2013-07-06 12:44:30',NULL,NULL),(45193,'50616','S','Charles City','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.063262,-92.671092,0,'2013-07-06 12:44:32',NULL,NULL),(52596,'61016','S','Cherry Valley','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.217093,-88.965911,0,'2013-07-06 12:44:33',NULL,NULL),(29869,'33040','S','Key West Naval Air Station','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(2651,'00966','S','Parq De Villa Caparra','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(58608,'68854','S','Kronborg','N','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.005970,-98.008746,0,'2013-07-06 12:44:33',NULL,NULL),(48599,'55785','S','Swatara','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.877521,-93.682649,0,'2013-07-06 12:44:33',NULL,NULL),(45853,'52235','P','Hills','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.552974,-91.532344,0,'2013-07-06 12:44:32',NULL,NULL),(74059,'92160','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.783954,-117.093500,0,'2013-07-06 12:44:34',NULL,NULL),(64399,'76540','P','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.121623,-97.720447,0,'2013-07-06 12:44:34',NULL,NULL),(44379,'49796','P','Walloon Lake','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.264304,-84.933235,0,'2013-07-06 12:44:32',NULL,NULL),(20927,'21747','P','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.634471,-77.745963,0,'2013-07-06 12:44:31',NULL,NULL),(54740,'62972','S','Ozark','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.533890,-88.763201,0,'2013-07-06 12:44:33',NULL,NULL),(10332,'10549','S','Mount Kisco','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.207160,-73.717320,0,'2013-07-06 12:44:30',NULL,NULL),(858,'00698','S','Urb Buena Vista','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(36161,'40242','S','Langdon Place','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(40625,'46013','S','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.053006,-85.676882,0,'2013-07-06 12:44:32',NULL,NULL),(75784,'94705','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.856122,-122.246704,0,'2013-07-06 12:44:34',NULL,NULL),(61716,'73011','S','Bradley','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.858774,-97.723616,0,'2013-07-06 12:44:33',NULL,NULL),(78330,'97920','P','Westfall','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.948095,-117.749854,0,'2013-07-06 12:44:34',NULL,NULL),(75636,'94517','S','Clayton','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.931137,-121.920029,0,'2013-07-06 12:44:34',NULL,NULL),(60019,'71339','P','Hamburg','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.061489,-91.921786,0,'2013-07-06 12:44:33',NULL,NULL),(57055,'66211','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(5959,'05301','S','Gilford','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(33466,'37328','S','Elora','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.032842,-86.422944,0,'2013-07-06 12:44:32',NULL,NULL),(27231,'29920','S','Frogmore','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(6568,'05851','S','South Wheelock','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544120,-72.021300,0,'2013-07-06 12:44:30',NULL,NULL),(74191,'92280','S','Blythe','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.191918,-114.553587,0,'2013-07-06 12:44:34',NULL,NULL),(16915,'17602','S','Lyndon','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(67620,'80439','S','Evergreen','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.608071,-105.332386,0,'2013-07-06 12:44:34',NULL,NULL),(6492,'05774','S','Wells','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.432771,-73.196315,0,'2013-07-06 12:44:30',NULL,NULL),(39486,'44730','S','Osnaburg','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.765560,-81.266520,0,'2013-07-06 12:44:32',NULL,NULL),(54581,'62899','S','Oskaloosa','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.697541,-88.638859,0,'2013-07-06 12:44:33',NULL,NULL),(50852,'58492','S','Wimbledon','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.172540,-98.458847,0,'2013-07-06 12:44:33',NULL,NULL),(76158,'95310','S','Columbia','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.043041,-120.391074,0,'2013-07-06 12:44:34',NULL,NULL),(68867,'82638','S','Casper','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.161514,-107.722759,0,'2013-07-06 12:44:34',NULL,NULL),(64826,'77034','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.612502,-95.200900,0,'2013-07-06 12:44:34',NULL,NULL),(47831,'55070','S','St Francis','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.394713,-93.363178,0,'2013-07-06 12:44:33',NULL,NULL),(24191,'26656','S','Belva','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.269941,-81.130988,0,'2013-07-06 12:44:31',NULL,NULL),(51223,'59057','S','Molt','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.861923,-108.802347,0,'2013-07-06 12:44:33',NULL,NULL),(33380,'37213','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.165353,-86.765654,0,'2013-07-06 12:44:32',NULL,NULL),(32386,'35907','S','Southside','A','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.014167,-86.006667,0,'2013-07-06 12:44:32',NULL,NULL),(14199,'14769','S','Portland','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.377963,-79.471958,0,'2013-07-06 12:44:31',NULL,NULL),(53249,'61701','S','Eastland Commons','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(35184,'39283','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.367889,-90.231119,0,'2013-07-06 12:44:32',NULL,NULL),(46118,'52639','S','Bluff Park','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.528312,-91.412979,0,'2013-07-06 12:44:32',NULL,NULL),(38806,'44067','S','Sagamore Hls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(75484,'94120','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.793768,-122.402158,0,'2013-07-06 12:44:34',NULL,NULL),(17668,'18098','U','Rodale Press','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.527440,-75.500014,0,'2013-07-06 12:44:31',NULL,NULL),(43220,'48309','S','Rochester Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657960,-83.186520,0,'2013-07-06 12:44:32',NULL,NULL),(65947,'78263','S','China Grove','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.354295,-98.331761,0,'2013-07-06 12:44:34',NULL,NULL),(72863,'90005','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.055509,-118.309220,0,'2013-07-06 12:44:34',NULL,NULL),(73974,'92081','S','Vista','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.192078,-117.236148,0,'2013-07-06 12:44:34',NULL,NULL),(70456,'84752','P','Minersville','D','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.216645,-112.921086,0,'2013-07-06 12:44:34',NULL,NULL),(45282,'50677','S','Waverly','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.716220,-92.425620,0,'2013-07-06 12:44:32',NULL,NULL),(33081,'36785','S','Benton','A','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.269183,-86.852148,0,'2013-07-06 12:44:32',NULL,NULL),(60355,'71469','S','Spanish Lake','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(36024,'40165','S','Shepherdsville','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(44453,'49871','P','Palmer','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.440099,-87.590135,0,'2013-07-06 12:44:32',NULL,NULL),(26936,'29592','S','Sellers','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.252631,-79.457951,0,'2013-07-06 12:44:31',NULL,NULL),(29457,'32712','S','Apopka','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.736116,-81.538717,0,'2013-07-06 12:44:32',NULL,NULL),(64008,'76117','S','Fort Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(72975,'90048','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.073253,-118.377034,0,'2013-07-06 12:44:34',NULL,NULL),(16865,'17565','S','Martic Forge','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(8520,'08106','S','Audubon Park','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.892401,-75.074652,0,'2013-07-06 12:44:30',NULL,NULL),(10462,'10928','S','Highland Fls','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.368496,-73.970013,0,'2013-07-06 12:44:30',NULL,NULL),(24193,'26662','S','Canvas','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.261219,-80.733726,0,'2013-07-06 12:44:31',NULL,NULL),(34598,'38748','S','Bear Garden','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(37332,'41655','S','Printer','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.505207,-82.707164,0,'2013-07-06 12:44:32',NULL,NULL),(56492,'65336','S','Knob Noster','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.764378,-93.556549,0,'2013-07-06 12:44:33',NULL,NULL),(16222,'17074','S','Mannsville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(868,'00698','S','Urb Monteverde','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(68121,'80950','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837558,-104.795156,0,'2013-07-06 12:44:34',NULL,NULL),(33805,'37909','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.949730,-84.018625,0,'2013-07-06 12:44:32',NULL,NULL),(66753,'79010','P','Boys Ranch','D','Oldham','48359','Texas','TX','48','0320','806','Central',-6.0,'Y',35.433035,-102.442266,0,'2013-07-06 12:44:34',NULL,NULL),(66970,'79408','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.580757,-101.977652,0,'2013-07-06 12:44:34',NULL,NULL),(69821,'84074','S','Tooele','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(79713,'99212','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(49129,'56362','S','Paynesville','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.407807,-94.699248,0,'2013-07-06 12:44:33',NULL,NULL),(15924,'17020','S','Dellville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(5900,'05156','S','Weathersfield','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.289460,-72.474780,0,'2013-07-06 12:44:30',NULL,NULL),(41157,'46703','S','Angola','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(38183,'43194','U','Shared Zip Code','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.808925,-82.977053,0,'2013-07-06 12:44:32',NULL,NULL),(44008,'49355','U','Ada','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.953901,-85.478655,0,'2013-07-06 12:44:32',NULL,NULL),(22337,'23872','S','McKenney','N','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.010182,-77.725604,0,'2013-07-06 12:44:31',NULL,NULL),(67225,'79927','S','Socorro','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.655220,-106.228260,0,'2013-07-06 12:44:34',NULL,NULL),(3242,'01431','S','Ashby','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.677809,-71.811241,0,'2013-07-06 12:44:30',NULL,NULL),(39285,'44485','S','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.235976,-80.843944,0,'2013-07-06 12:44:32',NULL,NULL),(17675,'18104','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.603189,-75.532165,0,'2013-07-06 12:44:31',NULL,NULL),(17564,'17985','S','North Union','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.941300,-76.218000,0,'2013-07-06 12:44:31',NULL,NULL),(35254,'39346','S','Noxapater','D','Winston','28159','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.975786,-89.155652,0,'2013-07-06 12:44:32',NULL,NULL),(29736,'32963','S','Orchid','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.647905,-80.360668,0,'2013-07-06 12:44:32',NULL,NULL),(28426,'31331','S','Eulonia','N','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(26506,'29171','P','Cayce','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.970062,-81.078582,0,'2013-07-06 12:44:31',NULL,NULL),(25304,'28147','S','Salisbury','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.667513,-80.533434,0,'2013-07-06 12:44:31',NULL,NULL),(5717,'04992','P','W Farmington','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.664202,-70.152992,0,'2013-07-06 12:44:30',NULL,NULL),(20372,'20879','S','Montgomery Village','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.177540,-77.194392,0,'2013-07-06 12:44:31',NULL,NULL),(43866,'49125','S','Sawyer','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.888650,-86.594119,0,'2013-07-06 12:44:32',NULL,NULL),(52991,'61441','S','Ipava','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.365743,-90.275106,0,'2013-07-06 12:44:33',NULL,NULL),(55915,'64451','S','Forest City','D','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.983626,-95.222753,0,'2013-07-06 12:44:33',NULL,NULL),(62492,'74360','S','Picher','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.985528,-94.833169,0,'2013-07-06 12:44:33',NULL,NULL),(68392,'81152','S','El Rito','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(69915,'84108','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.738359,-111.812479,0,'2013-07-06 12:44:34',NULL,NULL),(75818,'94820','P','Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.978266,-122.295281,0,'2013-07-06 12:44:34',NULL,NULL),(76397,'95542','S','Garberville','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.173931,-123.912209,0,'2013-07-06 12:44:34',NULL,NULL),(23185,'25045','S','Clio','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.460480,-81.335520,0,'2013-07-06 12:44:31',NULL,NULL),(5841,'05089','S','Jenneville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.475040,-72.427380,0,'2013-07-06 12:44:30',NULL,NULL),(76830,'95960','S','N San Juan','A','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.339635,-121.132146,0,'2013-07-06 12:44:34',NULL,NULL),(22775,'24445','S','Healing Sprgs','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(24770,'27553','S','Soul City','N','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.468780,-78.292380,0,'2013-07-06 12:44:31',NULL,NULL),(47955,'55118','S','West St Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(1977,'00902','P','Old San Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446284,-66.098281,0,'2013-07-06 12:44:30',NULL,NULL),(41718,'47240','S','Lake McCoy','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(5446,'04694','S','Baring Plt','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.154958,-67.407874,0,'2013-07-06 12:44:30',NULL,NULL),(38963,'44128','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(37319,'41650','S','Melvin','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.348109,-82.692963,0,'2013-07-06 12:44:32',NULL,NULL),(8806,'08610','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.215600,-74.739600,0,'2013-07-06 12:44:30',NULL,NULL),(49415,'56630','S','Alvwood','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(50629,'58272','S','Petersburg','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.974888,-97.960513,0,'2013-07-06 12:44:33',NULL,NULL),(58632,'68866','S','Pleasanton','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.971884,-99.085142,0,'2013-07-06 12:44:33',NULL,NULL),(60420,'71640','S','Indian','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(11808,'12230','U','NY Educ Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.654700,-73.757766,0,'2013-07-06 12:44:30',NULL,NULL),(66466,'78657','S','Cottonwd Shrs','A','Llano','48299','Texas','TX','48','0000','830','Central',-6.0,'Y',30.579706,-98.271069,0,'2013-07-06 12:44:34',NULL,NULL),(56484,'65327','P','Emma','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',38.973396,-93.491435,0,'2013-07-06 12:44:33',NULL,NULL),(55656,'64024','S','Excelsior Springs','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(31577,'34652','S','New Pt Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.238545,-82.730700,0,'2013-07-06 12:44:32',NULL,NULL),(69931,'84113','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775548,-111.831028,0,'2013-07-06 12:44:34',NULL,NULL),(72459,'89117','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.140602,-115.274020,0,'2013-07-06 12:44:34',NULL,NULL),(75230,'93644','S','Oakhurst','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.336859,-119.642905,0,'2013-07-06 12:44:34',NULL,NULL),(56700,'65663','S','Goodson','A','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.601355,-93.248196,0,'2013-07-06 12:44:33',NULL,NULL),(39860,'45176','S','Eastwood','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.072060,-84.043331,0,'2013-07-06 12:44:32',NULL,NULL),(39159,'44301','S','Firestone Park','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.043261,-81.521198,0,'2013-07-06 12:44:32',NULL,NULL),(7928,'07647','S','Northvale','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.010086,-73.950666,0,'2013-07-06 12:44:30',NULL,NULL),(14624,'15231','P','Pgh Int Arprt','A','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.502772,-80.189169,0,'2013-07-06 12:44:31',NULL,NULL),(578,'00680','S','Bo Colombia','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(6834,'06117','S','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(21522,'22726','S','Lignum','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.398281,-77.816915,0,'2013-07-06 12:44:31',NULL,NULL),(23596,'25685','P','Naugatuck','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.806746,-82.271267,0,'2013-07-06 12:44:31',NULL,NULL),(43859,'49115','P','Harbert','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.875075,-86.630900,0,'2013-07-06 12:44:32',NULL,NULL),(47535,'54814','S','Bayfield','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.824360,-90.830460,0,'2013-07-06 12:44:32',NULL,NULL),(36305,'40370','S','Sadieville','D','Scott','21209','Kentucky','KY','21','4280','502','Eastern',-5.0,'Y',38.387033,-84.533895,0,'2013-07-06 12:44:32',NULL,NULL),(34897,'38953','S','Scobey','D','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.885851,-89.918100,0,'2013-07-06 12:44:32',NULL,NULL),(16545,'17304','S','Center Mills','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.978814,-77.237058,0,'2013-07-06 12:44:31',NULL,NULL),(33729,'37815','P','Morristown','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.213648,-83.293749,0,'2013-07-06 12:44:32',NULL,NULL),(75358,'93921','P','Carmel by the','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.562001,-121.896409,0,'2013-07-06 12:44:34',NULL,NULL),(38495,'43682','U','Business Reply Firm ZIP','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.642592,-83.544001,0,'2013-07-06 12:44:32',NULL,NULL),(61100,'72136','S','Romance','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.216583,-92.069911,0,'2013-07-06 12:44:33',NULL,NULL),(16749,'17509','S','Smyrna','N','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(16541,'17302','S','Sunnyburn','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(2783,'00976','S','Parq del Rio','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(57984,'67843','S','Dodge City','A','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.665605,-99.944540,0,'2013-07-06 12:44:33',NULL,NULL),(39694,'45036','S','Lebanon','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.446127,-84.210158,0,'2013-07-06 12:44:32',NULL,NULL),(77060,'96120','S','Fredricksburg','N','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(76732,'95901','S','Loma Rica','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.215400,-121.463340,0,'2013-07-06 12:44:34',NULL,NULL),(45719,'52071','P','Saint Donatus','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.336876,-90.494815,0,'2013-07-06 12:44:32',NULL,NULL),(50379,'57760','S','Gill','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.718125,-103.420575,0,'2013-07-06 12:44:33',NULL,NULL),(56029,'64676','S','Rothville','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.653317,-93.063400,0,'2013-07-06 12:44:33',NULL,NULL),(56301,'65085','S','Babbtown','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.428260,-92.023140,0,'2013-07-06 12:44:33',NULL,NULL),(4714,'03819','S','South Danville','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.919072,-71.116979,0,'2013-07-06 12:44:30',NULL,NULL),(7091,'06353','S','Montville','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.451114,-72.131081,0,'2013-07-06 12:44:30',NULL,NULL),(16142,'17059','S','Macedonia','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(2142,'00924','S','Urb Monte Carlo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(10231,'10463','S','Riverdale','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.881512,-73.907521,0,'2013-07-06 12:44:30',NULL,NULL),(10757,'11362','S','Douglaston','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761850,-73.729718,0,'2013-07-06 12:44:30',NULL,NULL),(23484,'25508','S','Shively','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.967280,-82.016220,0,'2013-07-06 12:44:31',NULL,NULL),(29061,'32244','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.223538,-81.757243,0,'2013-07-06 12:44:32',NULL,NULL),(49453,'56646','S','Gully','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.803463,-95.643510,0,'2013-07-06 12:44:33',NULL,NULL),(57142,'66227','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.980518,-94.869055,0,'2013-07-06 12:44:33',NULL,NULL),(62249,'74003','S','Okesa','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(70404,'84715','P','Bicknell','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.350142,-111.554345,0,'2013-07-06 12:44:34',NULL,NULL),(77434,'96805','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305636,-157.856474,0,'2013-07-06 12:44:34',NULL,NULL),(28872,'32118','S','Daytona Beach Shores','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.207209,-80.999801,0,'2013-07-06 12:44:32',NULL,NULL),(46920,'54143','S','Menekaunee','N','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.091002,-87.625627,0,'2013-07-06 12:44:32',NULL,NULL),(74917,'93386','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.375572,-118.954656,0,'2013-07-06 12:44:34',NULL,NULL),(76612,'95692','S','Wheatland','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.025057,-121.422710,0,'2013-07-06 12:44:34',NULL,NULL),(36402,'40510','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.060788,-84.603634,0,'2013-07-06 12:44:32',NULL,NULL),(14716,'15275','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.439193,-80.096656,0,'2013-07-06 12:44:31',NULL,NULL),(45905,'52316','S','White Pigeon','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.518029,-92.080384,0,'2013-07-06 12:44:32',NULL,NULL),(70311,'84604','S','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.264063,-111.623041,0,'2013-07-06 12:44:34',NULL,NULL),(57680,'67226','S','Bel Aire','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.742159,-97.242969,0,'2013-07-06 12:44:33',NULL,NULL),(1975,'00901','S','Viejo San Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.463862,-66.109811,0,'2013-07-06 12:44:30',NULL,NULL),(8525,'08107','S','W Colls','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(31681,'34773','S','Harmony','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.060933,-81.052530,0,'2013-07-06 12:44:32',NULL,NULL),(30262,'33234','P','Coral Gbls','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.750799,-80.274412,0,'2013-07-06 12:44:32',NULL,NULL),(22449,'24023','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.269966,-79.951696,0,'2013-07-06 12:44:31',NULL,NULL),(29140,'32328','S','Eastpoint','D','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.746800,-84.923220,0,'2013-07-06 12:44:32',NULL,NULL),(27068,'29691','S','Walhalla','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.766678,-83.062038,0,'2013-07-06 12:44:31',NULL,NULL),(53242,'61654','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.677695,-89.603707,0,'2013-07-06 12:44:33',NULL,NULL),(19846,'20508','U','US Trade Representative','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899287,-77.040342,0,'2013-07-06 12:44:31',NULL,NULL),(20395,'20897','U','Subn MD Fac','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.087874,-77.054787,0,'2013-07-06 12:44:31',NULL,NULL),(16432,'17233','S','Cito','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(49567,'56721','S','East Grand Forks','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.929448,-97.017008,0,'2013-07-06 12:44:33',NULL,NULL),(25979,'28661','P','Happy Valley','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.998515,-81.563991,0,'2013-07-06 12:44:31',NULL,NULL),(12514,'13027','S','Radisson','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(59477,'70754','S','Livingston','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.446103,-90.758829,0,'2013-07-06 12:44:33',NULL,NULL),(60067,'71354','S','Eva','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.345723,-91.668555,0,'2013-07-06 12:44:33',NULL,NULL),(58316,'68442','S','Stella','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.229088,-95.773985,0,'2013-07-06 12:44:33',NULL,NULL),(18220,'18962','P','Silverdale','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.346383,-75.268821,0,'2013-07-06 12:44:31',NULL,NULL),(65024,'77318','S','Willis','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.452396,-95.537675,0,'2013-07-06 12:44:34',NULL,NULL),(44111,'49505','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.010412,-85.625219,0,'2013-07-06 12:44:32',NULL,NULL),(4344,'03041','P','East Derry','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.889640,-71.297132,0,'2013-07-06 12:44:30',NULL,NULL),(30025,'33137','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.814453,-80.188296,0,'2013-07-06 12:44:32',NULL,NULL),(76023,'95134','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.413678,-121.946751,0,'2013-07-06 12:44:34',NULL,NULL),(30553,'33411','S','Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(34478,'38664','S','Tunica Resort','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(27306,'30016','S','Covington','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.530099,-83.944327,0,'2013-07-06 12:44:31',NULL,NULL),(28446,'31407','S','Prt Wentworth','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.166660,-81.172740,0,'2013-07-06 12:44:32',NULL,NULL),(45947,'52347','S','Carnforth','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.729129,-92.294632,0,'2013-07-06 12:44:32',NULL,NULL),(48502,'55736','S','Halden','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(59656,'71049','S','Logansport','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.017906,-93.933956,0,'2013-07-06 12:44:33',NULL,NULL),(10810,'11374','S','Rego Pk','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.727079,-73.861454,0,'2013-07-06 12:44:30',NULL,NULL),(36348,'40434','P','Gray Hawk','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.403958,-83.898404,0,'2013-07-06 12:44:32',NULL,NULL),(56995,'66203','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(20435,'20993','U','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.990556,-77.026389,0,'2013-07-06 12:44:31',NULL,NULL),(74747,'93044','P','Port Hueneme CBC Base','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.154211,-119.187956,0,'2013-07-06 12:44:34',NULL,NULL),(18241,'18977','S','Washington Crossing','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.291900,-74.884277,0,'2013-07-06 12:44:31',NULL,NULL),(43084,'48204','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.367514,-83.138488,0,'2013-07-06 12:44:32',NULL,NULL),(23941,'26266','S','Upperglade','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.432206,-80.500417,0,'2013-07-06 12:44:31',NULL,NULL),(34753,'38856','S','Marietta','D','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.496021,-88.422433,0,'2013-07-06 12:44:32',NULL,NULL),(52602,'61021','S','Dixon','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.838841,-89.492572,0,'2013-07-06 12:44:33',NULL,NULL),(72157,'88330','S','Holloman Air Force Base','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.820176,-105.935630,0,'2013-07-06 12:44:34',NULL,NULL),(20586,'21160','S','Whiteford','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.706514,-76.316709,0,'2013-07-06 12:44:31',NULL,NULL),(36209,'40272','S','Valley Station','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.087506,-85.844480,0,'2013-07-06 12:44:32',NULL,NULL),(31113,'33890','S','Zolfo Springs','D','Hardee','12049','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.492646,-81.789165,0,'2013-07-06 12:44:32',NULL,NULL),(78186,'97712','S','Brothers','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.717130,-120.469505,0,'2013-07-06 12:44:34',NULL,NULL),(77947,'97350','S','Idanha','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.700587,-122.071486,0,'2013-07-06 12:44:34',NULL,NULL),(75459,'94083','P','S San Fran','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.643644,-122.411982,0,'2013-07-06 12:44:34',NULL,NULL),(70145,'84308','S','Cornish','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.967723,-112.004942,0,'2013-07-06 12:44:34',NULL,NULL),(65266,'77473','P','San Felipe','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.792743,-96.091014,0,'2013-07-06 12:44:34',NULL,NULL),(56756,'65729','S','Pontiac','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.523201,-92.547871,0,'2013-07-06 12:44:33',NULL,NULL),(3682,'02130','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.294720,-71.130540,0,'2013-07-06 12:44:30',NULL,NULL),(10520,'10979','P','Sterling Forest','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.182254,-74.315748,0,'2013-07-06 12:44:30',NULL,NULL),(25234,'28098','S','Lowell','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.270919,-81.108026,0,'2013-07-06 12:44:31',NULL,NULL),(25199,'28076','P','Henrietta','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.258864,-81.794733,0,'2013-07-06 12:44:31',NULL,NULL),(18081,'18706','S','Ashley','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(63528,'75756','S','Brownsboro','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295120,-95.623500,0,'2013-07-06 12:44:33',NULL,NULL),(65094,'77358','S','New Waverly','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.548896,-95.493570,0,'2013-07-06 12:44:34',NULL,NULL),(45035,'50472','S','Meltonville','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.377784,-92.915665,0,'2013-07-06 12:44:32',NULL,NULL),(76998,'96078','P','Proberta','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.077572,-122.170185,0,'2013-07-06 12:44:34',NULL,NULL),(26392,'29104','S','Saint Charles','A','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.983524,-80.208008,0,'2013-07-06 12:44:31',NULL,NULL),(5000,'04219','S','Bryant Pond','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.383477,-70.617546,0,'2013-07-06 12:44:30',NULL,NULL),(15360,'16250','P','Sagamore','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.780780,-79.225637,0,'2013-07-06 12:44:31',NULL,NULL),(42165,'47524','S','Decker','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.486075,-87.622339,0,'2013-07-06 12:44:32',NULL,NULL),(65592,'77875','P','Anderson','A','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.583507,-95.941256,0,'2013-07-06 12:44:34',NULL,NULL),(11483,'12020','S','Ballston Spa','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(4325,'02918','U','Friar Station','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821945,-71.419150,0,'2013-07-06 12:44:30',NULL,NULL),(5484,'04745','S','Upper Frnchvl','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.277889,-68.386251,0,'2013-07-06 12:44:30',NULL,NULL),(35590,'39574','S','Airey','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.600720,-89.112240,0,'2013-07-06 12:44:32',NULL,NULL),(10944,'11436','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678055,-73.797848,0,'2013-07-06 12:44:30',NULL,NULL),(50194,'57568','S','Sweeney','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.908664,-100.053403,0,'2013-07-06 12:44:33',NULL,NULL),(52844,'61319','S','Manville','A','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.989667,-88.729988,0,'2013-07-06 12:44:33',NULL,NULL),(40313,'45459','S','Moraine','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(3851,'02348','U','Middleboro','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.877314,-70.946435,0,'2013-07-06 12:44:30',NULL,NULL),(39027,'44143','S','Richmond Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(9179,'09366','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(26931,'29588','S','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.676817,-79.014238,0,'2013-07-06 12:44:31',NULL,NULL),(11255,'11765','S','Mill Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.885753,-73.553815,0,'2013-07-06 12:44:30',NULL,NULL),(61409,'72556','S','Boswell','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.062170,-91.899240,0,'2013-07-06 12:44:33',NULL,NULL),(72910,'90024','S','Village','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.060189,-118.436400,0,'2013-07-06 12:44:34',NULL,NULL),(45362,'51004','S','Anthon','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.387190,-95.883290,0,'2013-07-06 12:44:32',NULL,NULL),(23976,'26301','S','Stonewood','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(57238,'66520','S','Olsburg','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.415248,-96.599074,0,'2013-07-06 12:44:33',NULL,NULL),(8770,'08544','U','Princeton University','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.345441,-74.655866,0,'2013-07-06 12:44:30',NULL,NULL),(41156,'46702','S','Andrews','D','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.851385,-85.602954,0,'2013-07-06 12:44:32',NULL,NULL),(63084,'75249','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.648113,-96.958024,0,'2013-07-06 12:44:33',NULL,NULL),(64119,'76182','S','N Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.798211,-97.191792,0,'2013-07-06 12:44:34',NULL,NULL),(67251,'79950','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.762458,-106.480372,0,'2013-07-06 12:44:34',NULL,NULL),(50048,'57436','S','Doland','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.785446,-98.116565,0,'2013-07-06 12:44:33',NULL,NULL),(54951,'63117','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.628611,-90.319444,0,'2013-07-06 12:44:33',NULL,NULL),(78184,'97710','S','Fields','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.272108,-118.862519,0,'2013-07-06 12:44:34',NULL,NULL),(67583,'80314','U','Ibm Corp','N','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.087784,-105.199407,0,'2013-07-06 12:44:34',NULL,NULL),(51039,'58725','S','Hartland','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.414749,-101.712035,0,'2013-07-06 12:44:33',NULL,NULL),(11193,'11738','S','Farmingville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.837113,-73.044352,0,'2013-07-06 12:44:30',NULL,NULL),(5783,'05053','S','North Pomfret','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.722778,-72.480278,0,'2013-07-06 12:44:30',NULL,NULL),(39724,'45056','S','Miami University','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(33926,'38057','S','Moscow','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.059236,-89.379123,0,'2013-07-06 12:44:32',NULL,NULL),(36942,'41164','S','Smoky Valley','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(34754,'38857','S','Mooreville','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.280237,-88.592439,0,'2013-07-06 12:44:32',NULL,NULL),(47167,'54474','S','Weston','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.933333,-89.600000,0,'2013-07-06 12:44:32',NULL,NULL),(44245,'49668','S','Mesick','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.408397,-85.709353,0,'2013-07-06 12:44:32',NULL,NULL),(57045,'66210','S','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(60794,'72027','S','Lick Mountain','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.401579,-92.560518,0,'2013-07-06 12:44:33',NULL,NULL),(10730,'11354','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770167,-73.825967,0,'2013-07-06 12:44:30',NULL,NULL),(71221,'86325','S','Cornville','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.724178,-111.911588,0,'2013-07-06 12:44:34',NULL,NULL),(31401,'34228','S','Longboat Key','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.426057,-82.672355,0,'2013-07-06 12:44:32',NULL,NULL),(6459,'05760','S','Orwell','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.785111,-73.276135,0,'2013-07-06 12:44:30',NULL,NULL),(39273,'44460','S','Patmos','N','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.886216,-80.871563,0,'2013-07-06 12:44:32',NULL,NULL),(3977,'02495','P','Nonantum','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.332052,-71.207484,0,'2013-07-06 12:44:30',NULL,NULL),(15682,'16830','S','Clearfield','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.023121,-78.441626,0,'2013-07-06 12:44:31',NULL,NULL),(37909,'42633','S','Monticello','D','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(10338,'10552','S','Mount Vernon','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.922381,-73.829403,0,'2013-07-06 12:44:30',NULL,NULL),(33052,'36754','S','Magnolia','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.140290,-87.716683,0,'2013-07-06 12:44:32',NULL,NULL),(14243,'14819','S','Cameron','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.201213,-77.462912,0,'2013-07-06 12:44:31',NULL,NULL),(12038,'12521','S','Taghkanic','A','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.181320,-73.655640,0,'2013-07-06 12:44:30',NULL,NULL),(41850,'47353','S','Dunlapsville','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(46427,'53191','S','Williams Bay','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.579130,-88.536213,0,'2013-07-06 12:44:32',NULL,NULL),(50337,'57735','S','Dewey','A','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(68006,'80922','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.898824,-104.700007,0,'2013-07-06 12:44:34',NULL,NULL),(33785,'37876','S','Sevierville','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.839522,-83.480286,0,'2013-07-06 12:44:32',NULL,NULL),(22188,'23488','S','Withams','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.962106,-75.511229,0,'2013-07-06 12:44:31',NULL,NULL),(10521,'10979','P','Sterling Frst','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.182254,-74.315748,0,'2013-07-06 12:44:30',NULL,NULL),(18215,'18955','S','Richlandtown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.474440,-75.321164,0,'2013-07-06 12:44:31',NULL,NULL),(6903,'06150','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765671,-72.675155,0,'2013-07-06 12:44:30',NULL,NULL),(48454,'55711','S','Arrowhead','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.856672,-92.673076,0,'2013-07-06 12:44:33',NULL,NULL),(41994,'47424','S','Elliston','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(19691,'20373','U','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(35554,'39564','S','Polfry','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(80143,'99782','P','Wainwright','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.565980,-159.429874,0,'2013-07-06 12:44:34',NULL,NULL),(22584,'24165','S','Spencer','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.579029,-80.045917,0,'2013-07-06 12:44:31',NULL,NULL),(13335,'13684','S','Russell','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.375880,-75.069180,0,'2013-07-06 12:44:30',NULL,NULL),(49476,'56655','S','Kego','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(22566,'24150','S','Kimballton','N','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.378380,-80.656200,0,'2013-07-06 12:44:31',NULL,NULL),(68088,'80941','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.866594,-104.755324,0,'2013-07-06 12:44:34',NULL,NULL),(79254,'98563','S','Grisdale','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(18002,'18634','S','West Nanticoke','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.196217,-76.003548,0,'2013-07-06 12:44:31',NULL,NULL),(80035,'99693','P','Girdwood','A','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.770000,-148.680000,0,'2013-07-06 12:44:34',NULL,NULL),(71320,'86505','S','Navajo Station','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(58951,'69363','P','Scottsbluff','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.868379,-103.658193,0,'2013-07-06 12:44:33',NULL,NULL),(51942,'60128','U','North Suburban','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.916845,-88.105772,0,'2013-07-06 12:44:33',NULL,NULL),(51128,'58795','S','Hamlet','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.609420,-103.202520,0,'2013-07-06 12:44:33',NULL,NULL),(50117,'57501','S','Okobojo','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(43789,'49047','S','Dowagiac','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.997525,-86.111356,0,'2013-07-06 12:44:32',NULL,NULL),(4883,'04040','S','Harrison','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',44.104958,-70.668459,0,'2013-07-06 12:44:30',NULL,NULL),(38142,'43137','S','Lockbourne','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.832831,-82.978833,0,'2013-07-06 12:44:32',NULL,NULL),(40499,'45806','S','Cridersville','A','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.686359,-84.133844,0,'2013-07-06 12:44:32',NULL,NULL),(41386,'46802','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.072951,-85.153427,0,'2013-07-06 12:44:32',NULL,NULL),(14975,'15634','S','Grapeville','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.322571,-79.608097,0,'2013-07-06 12:44:31',NULL,NULL),(3023,'01089','S','West Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.117059,-72.639407,0,'2013-07-06 12:44:30',NULL,NULL),(41774,'47304','S','Brewington Wds','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(76817,'95954','S','Paradise Pines','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.835983,-121.595496,0,'2013-07-06 12:44:34',NULL,NULL),(44017,'49404','S','Coopersville','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.066832,-85.934647,0,'2013-07-06 12:44:32',NULL,NULL),(1946,'00801','P','St Thomas','D','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350000,-64.933333,0,'2013-07-06 12:44:30',NULL,NULL),(36939,'41164','S','Limestone','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(61064,'72124','P','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.811333,-92.234881,0,'2013-07-06 12:44:33',NULL,NULL),(77218,'96387','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(55436,'63670','S','Rocky Ridge','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(23608,'25705','S','Beverly Hills','N','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.408574,-82.369744,0,'2013-07-06 12:44:31',NULL,NULL),(39484,'44730','S','East Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.765560,-81.266520,0,'2013-07-06 12:44:32',NULL,NULL),(40640,'46034','S','Westfield','A','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.129985,-86.018106,0,'2013-07-06 12:44:32',NULL,NULL),(9605,'10031','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(13995,'14513','S','Newark','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.052762,-77.096188,0,'2013-07-06 12:44:31',NULL,NULL),(4117,'02723','S','Fall River','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.694619,-71.129750,0,'2013-07-06 12:44:30',NULL,NULL),(9266,'09607','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(530,'00674','S','Villa Evangelina','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(11446,'11977','S','W Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.819853,-72.666788,0,'2013-07-06 12:44:30',NULL,NULL),(58363,'68521','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.848806,-96.715959,0,'2013-07-06 12:44:33',NULL,NULL),(30960,'33736','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742754,-82.748427,0,'2013-07-06 12:44:32',NULL,NULL),(21290,'22350','U','Dept Of Defense','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853006,-77.123393,0,'2013-07-06 12:44:31',NULL,NULL),(45875,'52249','S','Keystone','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.002389,-92.202003,0,'2013-07-06 12:44:32',NULL,NULL),(79259,'98564','S','Ajlune','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.510282,-122.501783,0,'2013-07-06 12:44:34',NULL,NULL),(74847,'93246','U','Lemoore Naval Air Station','A','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.290241,-119.847834,0,'2013-07-06 12:44:34',NULL,NULL),(74413,'92545','S','Hemet','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.734737,-117.051196,0,'2013-07-06 12:44:34',NULL,NULL),(71199,'86053','P','Tonalea','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.590000,-111.070000,0,'2013-07-06 12:44:34',NULL,NULL),(68553,'81429','P','Paradox','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.365643,-108.963680,0,'2013-07-06 12:44:34',NULL,NULL),(57575,'67059','S','Haviland','D','Kiowa','20097','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.616471,-99.104840,0,'2013-07-06 12:44:33',NULL,NULL),(27784,'30377','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.793048,-84.450115,0,'2013-07-06 12:44:31',NULL,NULL),(28441,'31405','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.043073,-81.132144,0,'2013-07-06 12:44:32',NULL,NULL),(15017,'15676','P','Pleasant Unty','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.237179,-79.451409,0,'2013-07-06 12:44:31',NULL,NULL),(33202,'37044','U','austin peay st univ','N','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.529382,-87.337634,0,'2013-07-06 12:44:32',NULL,NULL),(14490,'15137','S','N Versailles','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.392941,-79.833489,0,'2013-07-06 12:44:31',NULL,NULL),(23879,'26160','S','Two Run','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(69704,'84032','S','Independence','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(60579,'71801','S','Hope','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.661513,-93.589430,0,'2013-07-06 12:44:33',NULL,NULL),(1189,'00728','S','Bosque Senorial','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(29627,'32885','U','Amsouth','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.539323,-81.379368,0,'2013-07-06 12:44:32',NULL,NULL),(23383,'25306','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.305020,-81.530460,0,'2013-07-06 12:44:31',NULL,NULL),(3675,'02127','S','S Boston','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.338960,-71.025290,0,'2013-07-06 12:44:30',NULL,NULL),(5246,'04478','S','Pittstn Acdmy','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(75367,'93925','S','Chualar','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.591206,-121.465765,0,'2013-07-06 12:44:34',NULL,NULL),(27779,'30374','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.576833,-84.394740,0,'2013-07-06 12:44:31',NULL,NULL),(74648,'92832','S','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.867963,-117.926477,0,'2013-07-06 12:44:34',NULL,NULL),(74151,'92258','P','N Palm Spgs','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.922919,-116.549446,0,'2013-07-06 12:44:34',NULL,NULL),(71381,'87004','S','Santa Ana Pue','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(69583,'83837','S','Wardner','A','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.585040,-116.134800,0,'2013-07-06 12:44:34',NULL,NULL),(67245,'79944','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.763223,-106.480051,0,'2013-07-06 12:44:34',NULL,NULL),(66647,'78840','S','Laughlin AFB','A','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.367308,-100.890893,0,'2013-07-06 12:44:34',NULL,NULL),(45202,'50625','S','Dumont','D','Butler','19023','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.761396,-92.980568,0,'2013-07-06 12:44:32',NULL,NULL),(20815,'21613','S','Cambridge','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.553713,-76.094747,0,'2013-07-06 12:44:31',NULL,NULL),(12847,'13317','S','Ames','A','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(30342,'33311','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(7505,'06925','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.042624,-73.558064,0,'2013-07-06 12:44:30',NULL,NULL),(148,'00617','S','Parc Tiburon','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(50511,'58075','S','Galchutt','A','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.273495,-96.609475,0,'2013-07-06 12:44:33',NULL,NULL),(44877,'50313','S','Marquisville','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.641599,-93.617602,0,'2013-07-06 12:44:32',NULL,NULL),(2551,'00959','S','Qtas del Norte','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(72788,'89701','S','New Empire','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(62323,'74043','P','Leonard','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.946668,-95.785019,0,'2013-07-06 12:44:33',NULL,NULL),(34987,'39108','S','McCool','N','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.168445,-89.328314,0,'2013-07-06 12:44:32',NULL,NULL),(14254,'14830','S','South Corning','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.143170,-77.052149,0,'2013-07-06 12:44:31',NULL,NULL),(52578,'60968','S','Thawville','D','Iroquois','17075','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.674254,-88.115142,0,'2013-07-06 12:44:33',NULL,NULL),(78604,'98190','U','Capital One','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.503893,-122.294967,0,'2013-07-06 12:44:34',NULL,NULL),(60823,'72035','U','Conway','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.073922,-92.457553,0,'2013-07-06 12:44:33',NULL,NULL),(42752,'48027','S','Goodells','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.981737,-82.660493,0,'2013-07-06 12:44:32',NULL,NULL),(5256,'04485','P','Shirley','N','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.503846,-69.469162,0,'2013-07-06 12:44:30',NULL,NULL),(26973,'29613','U','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.949211,-82.438690,0,'2013-07-06 12:44:31',NULL,NULL),(2063,'00920','S','Urb Caparra Hts','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(19159,'19718','U','Christiana Medical Center','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.666500,-75.707524,0,'2013-07-06 12:44:31',NULL,NULL),(1363,'00736','S','Urb El Rocio','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(43951,'49302','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.829750,-85.422188,0,'2013-07-06 12:44:32',NULL,NULL),(5065,'04281','S','South Paris','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.226244,-70.517516,0,'2013-07-06 12:44:30',NULL,NULL),(12276,'12838','S','Hartford','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.335141,-73.402119,0,'2013-07-06 12:44:30',NULL,NULL),(72321,'89004','P','Blue Diamond','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.077647,-115.414058,0,'2013-07-06 12:44:34',NULL,NULL),(33858,'38002','S','Lakeland','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.292060,-89.741700,0,'2013-07-06 12:44:32',NULL,NULL),(29029,'32229','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.408371,-81.579521,0,'2013-07-06 12:44:32',NULL,NULL),(63702,'75884','U','Tenn Colony Prison Coffield','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.834403,-95.840540,0,'2013-07-06 12:44:34',NULL,NULL),(23557,'25635','S','Landville','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.744662,-81.878847,0,'2013-07-06 12:44:31',NULL,NULL),(52444,'60666','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.972411,-87.895058,0,'2013-07-06 12:44:33',NULL,NULL),(70742,'85309','S','Luke Air Force Base','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538316,-112.370171,0,'2013-07-06 12:44:34',NULL,NULL),(546,'00676','S','Villa Soto','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(63582,'75780','P','New Summerfld','A','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.985670,-95.107132,0,'2013-07-06 12:44:34',NULL,NULL),(42247,'47575','S','Kyana','A','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.333863,-86.821988,0,'2013-07-06 12:44:32',NULL,NULL),(12584,'13072','S','Georgetown','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.763862,-75.753162,0,'2013-07-06 12:44:30',NULL,NULL),(34719,'38839','P','Derma','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.863628,-89.321103,0,'2013-07-06 12:44:32',NULL,NULL),(32039,'35244','S','Riverchase','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.361710,-86.788783,0,'2013-07-06 12:44:32',NULL,NULL),(21345,'22428','U','Boy Scouts of America','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.047380,-77.348116,0,'2013-07-06 12:44:31',NULL,NULL),(919,'00714','S','Arroyo','D','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(63541,'75763','S','Berryville','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(51537,'59722','S','Galen','N','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.380420,-112.722360,0,'2013-07-06 12:44:33',NULL,NULL),(1639,'00771','S','Urb Olimpic Cts','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(80167,'99824','S','Juneau','A','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.276465,-134.391690,0,'2013-07-06 12:44:34',NULL,NULL),(78010,'97413','S','Mc Kenzie Brg','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.179665,-122.120204,0,'2013-07-06 12:44:34',NULL,NULL),(69621,'83870','S','Sanders','N','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.183819,-116.871974,0,'2013-07-06 12:44:34',NULL,NULL),(56968,'66118','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.103935,-94.612021,0,'2013-07-06 12:44:33',NULL,NULL),(54583,'62899','S','Xenia','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.697541,-88.638859,0,'2013-07-06 12:44:33',NULL,NULL),(52423,'60651','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.899870,-87.741859,0,'2013-07-06 12:44:33',NULL,NULL),(44811,'50238','S','Russell','D','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.983991,-93.199488,0,'2013-07-06 12:44:32',NULL,NULL),(22333,'23868','S','Triplet','A','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.610278,-77.766111,0,'2013-07-06 12:44:31',NULL,NULL),(23618,'25714','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.398121,-82.450042,0,'2013-07-06 12:44:31',NULL,NULL),(27642,'30318','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.787680,-84.443612,0,'2013-07-06 12:44:31',NULL,NULL),(28600,'31650','S','Willacoochee','D','Atkinson','13003','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.337658,-83.051055,0,'2013-07-06 12:44:32',NULL,NULL),(10561,'11003','S','Locustwood','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(32500,'36066','S','Pville','N','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.469884,-86.436853,0,'2013-07-06 12:44:32',NULL,NULL),(8494,'08096','S','Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(36569,'40939','S','Fourmile','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.742655,-83.693032,0,'2013-07-06 12:44:32',NULL,NULL),(40778,'46161','S','Freeport','N','Shelby','18145','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.674407,-85.699943,0,'2013-07-06 12:44:32',NULL,NULL),(5177,'04438','S','Frankfort','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.596637,-68.926678,0,'2013-07-06 12:44:30',NULL,NULL),(18804,'19401','S','Jeffersonville','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.130580,-75.347520,0,'2013-07-06 12:44:31',NULL,NULL),(51338,'59311','S','Alzada','D','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.184649,-104.249236,0,'2013-07-06 12:44:33',NULL,NULL),(46452,'53211','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.082534,-87.884406,0,'2013-07-06 12:44:32',NULL,NULL),(44288,'49722','P','Conway','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.419771,-84.865068,0,'2013-07-06 12:44:32',NULL,NULL),(34587,'38740','S','Francis','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.777156,-90.722884,0,'2013-07-06 12:44:32',NULL,NULL),(53584,'62065','S','Michael','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.228894,-90.630458,0,'2013-07-06 12:44:33',NULL,NULL),(54671,'62939','S','Goreville','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.554162,-88.969995,0,'2013-07-06 12:44:33',NULL,NULL),(69840,'84082','S','Wallsburg','D','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.374397,-111.402007,0,'2013-07-06 12:44:34',NULL,NULL),(68586,'81523','S','Glade Park','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',38.997277,-108.740054,0,'2013-07-06 12:44:34',NULL,NULL),(67476,'80226','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.713584,-105.065468,0,'2013-07-06 12:44:34',NULL,NULL),(59277,'70460','S','Slidell','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.293114,-89.820906,0,'2013-07-06 12:44:33',NULL,NULL),(58117,'68127','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.204126,-96.054148,0,'2013-07-06 12:44:33',NULL,NULL),(56152,'64855','S','Oronogo','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.189393,-94.466033,0,'2013-07-06 12:44:33',NULL,NULL),(51018,'58705','S','Minot Air Force Base','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230700,-101.307900,0,'2013-07-06 12:44:33',NULL,NULL),(50222,'57584','S','Witten','D','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.463176,-100.065744,0,'2013-07-06 12:44:33',NULL,NULL),(48224,'55418','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.022134,-93.244686,0,'2013-07-06 12:44:33',NULL,NULL),(42851,'48076','S','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.497322,-83.233132,0,'2013-07-06 12:44:32',NULL,NULL),(11194,'11739','P','Great River','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.726303,-73.157742,0,'2013-07-06 12:44:30',NULL,NULL),(21878,'23169','S','Syringa','A','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.599000,-76.451820,0,'2013-07-06 12:44:31',NULL,NULL),(997,'00717','S','Repto Universitario','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(35597,'39577','S','Wiggins','D','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.855908,-89.135956,0,'2013-07-06 12:44:32',NULL,NULL),(38224,'43223','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.935259,-83.043278,0,'2013-07-06 12:44:32',NULL,NULL),(24449,'27214','S','Osceola','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(54078,'62515','S','Lanesville','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.847849,-89.406204,0,'2013-07-06 12:44:33',NULL,NULL),(44512,'49942','P','Kearsarge','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.269521,-88.416753,0,'2013-07-06 12:44:32',NULL,NULL),(47207,'54491','S','Lily','A','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.187800,-88.731300,0,'2013-07-06 12:44:32',NULL,NULL),(49878,'57262','S','Agency Vlg','A','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.664922,-97.048055,0,'2013-07-06 12:44:33',NULL,NULL),(38688,'43981','P','New Athens','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.181824,-80.993551,0,'2013-07-06 12:44:32',NULL,NULL),(34905,'38955','P','Calhoun Cy','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(63601,'75792','S','Waters Bluff','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.455404,-95.128624,0,'2013-07-06 12:44:34',NULL,NULL),(59712,'71106','S','Cedar Grove','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.426395,-93.738506,0,'2013-07-06 12:44:33',NULL,NULL),(55110,'63333','S','Gamma','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.001005,-91.334577,0,'2013-07-06 12:44:33',NULL,NULL),(9825,'10114','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(52644,'61057','P','Nachusa','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.829658,-89.391748,0,'2013-07-06 12:44:33',NULL,NULL),(59145,'70176','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.933672,-90.072503,0,'2013-07-06 12:44:33',NULL,NULL),(55622,'63965','S','Eastwood','N','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(51607,'59827','S','Conner','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.856111,-114.335036,0,'2013-07-06 12:44:33',NULL,NULL),(50599,'58249','S','Dresden','N','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.763045,-98.375077,0,'2013-07-06 12:44:33',NULL,NULL),(50356,'57747','S','Minnekata','N','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.433844,-103.476204,0,'2013-07-06 12:44:33',NULL,NULL),(1891,'00791','S','Villas del Rio','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(9454,'10007','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(5552,'04850','P','Lincolnvl Ctr','A','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.294881,-69.109732,0,'2013-07-06 12:44:30',NULL,NULL),(5782,'05052','S','North Hartland','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.592240,-72.354055,0,'2013-07-06 12:44:30',NULL,NULL),(24300,'27013','S','Amity','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.745026,-80.676769,0,'2013-07-06 12:44:31',NULL,NULL),(35286,'39401','S','Eatonville','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(5864,'05143','S','Reedville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(2706,'00969','S','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(42623,'47906','S','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.495856,-86.967180,0,'2013-07-06 12:44:32',NULL,NULL),(39598,'44871','P','Sandusky','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.449774,-82.705869,0,'2013-07-06 12:44:32',NULL,NULL),(26530,'29203','S','Fairfield Terrace','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(11315,'11780','S','St James','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(48282,'55433','S','Coon Rapids','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.167194,-93.324436,0,'2013-07-06 12:44:33',NULL,NULL),(49306,'56537','S','Carlisle','A','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.291020,-96.074820,0,'2013-07-06 12:44:33',NULL,NULL),(78138,'97536','S','Prospect','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.811440,-122.453640,0,'2013-07-06 12:44:34',NULL,NULL),(52774,'61262','S','Swedona','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.287020,-90.332520,0,'2013-07-06 12:44:33',NULL,NULL),(73834,'91780','S','Temple City','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.101878,-118.057437,0,'2013-07-06 12:44:34',NULL,NULL),(64325,'76490','S','Whitt','D','Parker','48367','Texas','TX','48','2800','940','Central',-6.0,'Y',32.968194,-98.022376,0,'2013-07-06 12:44:34',NULL,NULL),(63268,'75501','S','South Texarkana','A','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.424489,-94.102297,0,'2013-07-06 12:44:33',NULL,NULL),(58890,'69166','S','Thedford','D','Thomas','31171','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.978979,-100.570282,0,'2013-07-06 12:44:33',NULL,NULL),(57338,'66720','S','Austin','N','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.640820,-95.464980,0,'2013-07-06 12:44:33',NULL,NULL),(55023,'63135','S','Ferguson','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748900,-90.303899,0,'2013-07-06 12:44:33',NULL,NULL),(53732,'62248','P','Hecker','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.306219,-89.991457,0,'2013-07-06 12:44:33',NULL,NULL),(21602,'22850','S','Singers Glen','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.557018,-78.895545,0,'2013-07-06 12:44:31',NULL,NULL),(25317,'28167','S','Union Mills','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.490737,-81.962942,0,'2013-07-06 12:44:31',NULL,NULL),(26102,'28719','S','Cherokee','D','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.474495,-83.341234,0,'2013-07-06 12:44:31',NULL,NULL),(21161,'22135','U','Quantico','D','Stafford','51179','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.521184,-77.288054,0,'2013-07-06 12:44:31',NULL,NULL),(30687,'33474','P','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.526563,-80.082117,0,'2013-07-06 12:44:32',NULL,NULL),(34467,'38663','S','Mitchell','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(10713,'11239','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.647564,-73.877052,0,'2013-07-06 12:44:30',NULL,NULL),(42188,'47542','S','Maltersville','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.297169,-86.956690,0,'2013-07-06 12:44:32',NULL,NULL),(17498,'17961','S','Frisbie','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(44948,'50380','U','HP Other','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582496,-93.639304,0,'2013-07-06 12:44:32',NULL,NULL),(40877,'46240','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.905944,-86.128201,0,'2013-07-06 12:44:32',NULL,NULL),(8970,'08818','P','Edison','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.513663,-74.397993,0,'2013-07-06 12:44:30',NULL,NULL),(69972,'84120','S','Hunter','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(56997,'66204','S','Merriam','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(217,'00624','S','Repto Kennedy','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(60720,'71953','S','Potter','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(60580,'71801','S','Perrytown','N','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.661513,-93.589430,0,'2013-07-06 12:44:33',NULL,NULL),(18811,'19403','S','Norristown','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(49729,'57047','S','Monroe','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.479273,-97.218530,0,'2013-07-06 12:44:33',NULL,NULL),(35634,'39635','P','Farwood','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.183043,-90.447396,0,'2013-07-06 12:44:32',NULL,NULL),(16613,'17331','S','Gnatstown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(65763,'78074','P','Waring','D','Kendall','48259','Texas','TX','48','0000','830','Central',-6.0,'Y',29.821529,-98.752234,0,'2013-07-06 12:44:34',NULL,NULL),(69535,'83756','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.611127,-116.215521,0,'2013-07-06 12:44:34',NULL,NULL),(70730,'85301','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.536288,-112.176745,0,'2013-07-06 12:44:34',NULL,NULL),(74355,'92411','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.124542,-117.321697,0,'2013-07-06 12:44:34',NULL,NULL),(77600,'96940','P','Koror Caroline Islands','N','Palau','70030','Palau','PW','70','0000','680','UTC+9',9.0,'N',7.496636,134.574247,0,'2013-07-06 12:44:34',NULL,NULL),(75431,'94037','P','Montara','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.543182,-122.507644,0,'2013-07-06 12:44:34',NULL,NULL),(75285,'93718','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.734971,-119.782302,0,'2013-07-06 12:44:34',NULL,NULL),(11473,'12018','S','Burden Lake','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(24555,'27293','P','Lexington','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.859259,-80.257858,0,'2013-07-06 12:44:31',NULL,NULL),(26695,'29406','S','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.928960,-80.028420,0,'2013-07-06 12:44:31',NULL,NULL),(15499,'16506','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.072704,-80.153452,0,'2013-07-06 12:44:31',NULL,NULL),(31945,'35205','S','South Highlands','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.496708,-86.804796,0,'2013-07-06 12:44:32',NULL,NULL),(32916,'36551','S','Loxley','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.615589,-87.751521,0,'2013-07-06 12:44:32',NULL,NULL),(18909,'19481','P','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.091240,-75.474279,0,'2013-07-06 12:44:31',NULL,NULL),(39806,'45140','S','Montgomery','A','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(7975,'07709','U','Jersey Central Power Light','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.234142,-74.002173,0,'2013-07-06 12:44:30',NULL,NULL),(14052,'14564','S','Victor','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.979988,-77.424394,0,'2013-07-06 12:44:31',NULL,NULL),(75086,'93535','S','Hi Vista','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(75360,'93922','P','Carmel','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.489187,-121.744754,0,'2013-07-06 12:44:34',NULL,NULL),(62565,'74451','S','Qualls','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.649292,-95.023172,0,'2013-07-06 12:44:33',NULL,NULL),(38872,'44105','S','Cuyahoga Heights','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(10543,'10996','S','West Point','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.388670,-73.982179,0,'2013-07-06 12:44:30',NULL,NULL),(51132,'58801','S','Round Prairie','N','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.416870,-103.823860,0,'2013-07-06 12:44:33',NULL,NULL),(11558,'12060','S','East Chatham','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.412620,-73.496040,0,'2013-07-06 12:44:30',NULL,NULL),(69012,'83209','U','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.875640,-112.470880,0,'2013-07-06 12:44:34',NULL,NULL),(79518,'98935','S','Mabton','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.232289,-120.008491,0,'2013-07-06 12:44:34',NULL,NULL),(58051,'68031','S','Hooper','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.610766,-96.546766,0,'2013-07-06 12:44:33',NULL,NULL),(78496,'98108','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.537090,-122.310216,0,'2013-07-06 12:44:34',NULL,NULL),(76108,'95229','P','Douglas Flat','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.116433,-120.457748,0,'2013-07-06 12:44:34',NULL,NULL),(75797,'94720','U','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.868252,-122.258486,0,'2013-07-06 12:44:34',NULL,NULL),(75122,'93551','S','City Ranch','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.600777,-118.190371,0,'2013-07-06 12:44:34',NULL,NULL),(68648,'81641','S','Buford','N','Rio Blanco','08103','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.045459,-107.946922,0,'2013-07-06 12:44:34',NULL,NULL),(56397,'65240','S','Rowena','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.199769,-92.146039,0,'2013-07-06 12:44:33',NULL,NULL),(49056,'56303','S','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.583801,-94.203700,0,'2013-07-06 12:44:33',NULL,NULL),(27084,'29707','S','Ft Mill','N','Lancaster','45057','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006139,-80.947219,0,'2013-07-06 12:44:31',NULL,NULL),(27588,'30287','P','Morrow','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.549788,-84.403101,0,'2013-07-06 12:44:31',NULL,NULL),(24760,'27542','S','Kenly','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.590858,-78.122283,0,'2013-07-06 12:44:31',NULL,NULL),(38166,'43152','S','So Bloomingville','N','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.407940,-82.611540,0,'2013-07-06 12:44:32',NULL,NULL),(16976,'17724','S','East Canton','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(47079,'54432','P','Wittenberg','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.767380,-89.216040,0,'2013-07-06 12:44:32',NULL,NULL),(5518,'04776','S','Sherman Mills','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.815245,-68.309550,0,'2013-07-06 12:44:30',NULL,NULL),(6341,'05669','S','W Braintree','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(40997,'46360','S','Michiana Shrs','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(572,'00680','S','Bo Balboa','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(10141,'10270','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703355,-74.007485,0,'2013-07-06 12:44:30',NULL,NULL),(67486,'80230','S','Lowry','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.730904,-104.903794,0,'2013-07-06 12:44:34',NULL,NULL),(71173,'86042','P','First Mesa','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.967439,-110.430862,0,'2013-07-06 12:44:34',NULL,NULL),(77417,'96796','P','Waimea','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.962949,-159.669111,0,'2013-07-06 12:44:34',NULL,NULL),(41830,'47341','S','Fountain City','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.967634,-84.910903,0,'2013-07-06 12:44:32',NULL,NULL),(64352,'76519','S','Meeks','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.959980,-96.867177,0,'2013-07-06 12:44:34',NULL,NULL),(32770,'36371','P','Pinckard','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.398565,-85.503290,0,'2013-07-06 12:44:32',NULL,NULL),(78243,'97825','S','Dayville','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.469607,-119.529778,0,'2013-07-06 12:44:34',NULL,NULL),(16280,'17101','S','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.262172,-76.880556,0,'2013-07-06 12:44:31',NULL,NULL),(76347,'95476','S','Agua Caliente','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.293075,-122.470371,0,'2013-07-06 12:44:34',NULL,NULL),(70228,'84404','S','MSC','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(68115,'80949','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.929049,-104.855865,0,'2013-07-06 12:44:34',NULL,NULL),(62218,'73859','S','Vici','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.149345,-99.301235,0,'2013-07-06 12:44:33',NULL,NULL),(60887,'72067','S','Greers Ferry','A','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.570040,-92.174640,0,'2013-07-06 12:44:33',NULL,NULL),(58159,'68179','U','Union Pacific RR','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.262770,-95.934386,0,'2013-07-06 12:44:33',NULL,NULL),(53145,'61554','S','Pekin Heights','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(51466,'59526','S','Harlem','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.600839,-108.852510,0,'2013-07-06 12:44:33',NULL,NULL),(47578,'54847','S','Iron River','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.562142,-91.413369,0,'2013-07-06 12:44:33',NULL,NULL),(44035,'49420','S','Hart','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.703466,-86.359567,0,'2013-07-06 12:44:32',NULL,NULL),(5929,'05253','S','East Dorset','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.283889,-73.002778,0,'2013-07-06 12:44:30',NULL,NULL),(6446,'05757','S','Middletown Springs','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.501080,-73.123260,0,'2013-07-06 12:44:30',NULL,NULL),(23864,'26148','S','Macfarlan','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.080471,-81.185556,0,'2013-07-06 12:44:31',NULL,NULL),(24667,'27407','S','Hilltop','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.012660,-79.869960,0,'2013-07-06 12:44:31',NULL,NULL),(13780,'14151','P','Tonawanda','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.016876,-78.878188,0,'2013-07-06 12:44:31',NULL,NULL),(34986,'39108','S','Mc Cool','D','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.168445,-89.328314,0,'2013-07-06 12:44:32',NULL,NULL),(41229,'46737','S','Long Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.721900,-84.920220,0,'2013-07-06 12:44:32',NULL,NULL),(63321,'75570','S','New Boston','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.457080,-94.450920,0,'2013-07-06 12:44:33',NULL,NULL),(7753,'07395','U','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.727933,-74.077952,0,'2013-07-06 12:44:30',NULL,NULL),(1939,'00795','S','Valle Hucares','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(59846,'71251','S','Weston','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.237820,-92.642040,0,'2013-07-06 12:44:33',NULL,NULL),(31636,'34714','S','South Clermont','N','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.440119,-81.845959,0,'2013-07-06 12:44:32',NULL,NULL),(71431,'87029','S','Gavilan','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.429722,-107.087222,0,'2013-07-06 12:44:34',NULL,NULL),(58134,'68142','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.339409,-96.095430,0,'2013-07-06 12:44:33',NULL,NULL),(55331,'63547','S','Locust Hill','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.145709,-92.302124,0,'2013-07-06 12:44:33',NULL,NULL),(14931,'15554','S','New Paris','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.120057,-78.598280,0,'2013-07-06 12:44:31',NULL,NULL),(77559,'96863','S','Mcbh K Bay','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.388480,-157.755014,0,'2013-07-06 12:44:34',NULL,NULL),(72970,'90046','S','West Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105576,-118.366794,0,'2013-07-06 12:44:34',NULL,NULL),(72382,'89037','S','Coyote Springs','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.370267,-114.883611,0,'2013-07-06 12:44:34',NULL,NULL),(12561,'13053','S','Dryden','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.488910,-76.296223,0,'2013-07-06 12:44:30',NULL,NULL),(12931,'13343','S','Glenfield','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.737780,-75.327900,0,'2013-07-06 12:44:30',NULL,NULL),(34794,'38873','S','Mingo','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.644991,-88.238561,0,'2013-07-06 12:44:32',NULL,NULL),(28085,'30734','S','Ranger','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.532321,-84.734690,0,'2013-07-06 12:44:31',NULL,NULL),(27284,'30002','S','Avondale Est','A','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.772774,-84.264732,0,'2013-07-06 12:44:31',NULL,NULL),(42492,'47840','S','Sugar Ridge','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.376944,-87.100716,0,'2013-07-06 12:44:32',NULL,NULL),(46896,'54123','S','Forest Junction','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.207672,-88.144352,0,'2013-07-06 12:44:32',NULL,NULL),(8932,'08752','S','S Seaside Pk','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.922118,-74.080135,0,'2013-07-06 12:44:30',NULL,NULL),(41293,'46764','S','Etna-Troy','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.191399,-85.616852,0,'2013-07-06 12:44:32',NULL,NULL),(41243,'46742','S','Clarks Landing','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(2053,'00920','S','Caparra Ter','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(38925,'44122','S','Highland Hills','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(55144,'63361','S','Mineola','A','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(72858,'90002','S','Watts','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.948432,-118.245196,0,'2013-07-06 12:44:34',NULL,NULL),(17569,'18003','U','Lehigh Valley','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.644716,-75.434684,0,'2013-07-06 12:44:31',NULL,NULL),(76419,'95564','S','Samoa','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.802899,-124.191388,0,'2013-07-06 12:44:34',NULL,NULL),(75390,'93955','S','Sand City','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.608641,-121.837368,0,'2013-07-06 12:44:34',NULL,NULL),(73535,'91351','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425819,-118.443437,0,'2013-07-06 12:44:34',NULL,NULL),(67901,'80902','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(64444,'76569','S','Edgeworth','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.926330,-97.230983,0,'2013-07-06 12:44:34',NULL,NULL),(64270,'76424','S','Breckenridge','D','Stephens','48429','Texas','TX','48','0000','254','Central',-6.0,'Y',32.752306,-98.909708,0,'2013-07-06 12:44:34',NULL,NULL),(47019,'54313','S','Ashwaubenon','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.558732,-88.102722,0,'2013-07-06 12:44:32',NULL,NULL),(11831,'12242','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652754,-73.757551,0,'2013-07-06 12:44:30',NULL,NULL),(33621,'37663','S','Colonial Heights','A','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.460654,-82.484579,0,'2013-07-06 12:44:32',NULL,NULL),(4517,'03303','S','Boscawen','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.303680,-71.638500,0,'2013-07-06 12:44:30',NULL,NULL),(58812,'69028','S','Eustis','D','Frontier','31063','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.659907,-100.032461,0,'2013-07-06 12:44:33',NULL,NULL),(25028,'27892','S','Bear Grass','A','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.731680,-77.114100,0,'2013-07-06 12:44:31',NULL,NULL),(56876,'66023','S','Effingham','D','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.486207,-95.451980,0,'2013-07-06 12:44:33',NULL,NULL),(26040,'28683','S','Thurmond','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.362647,-80.939260,0,'2013-07-06 12:44:31',NULL,NULL),(23954,'26285','P','Norton','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.934311,-79.967217,0,'2013-07-06 12:44:31',NULL,NULL),(42858,'48080','S','St Clair Shores','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465933,-82.903852,0,'2013-07-06 12:44:32',NULL,NULL),(25078,'27948','S','Kill Devil Hl','A','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.022095,-75.680394,0,'2013-07-06 12:44:31',NULL,NULL),(65076,'77350','P','Leggett','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.817983,-94.870287,0,'2013-07-06 12:44:34',NULL,NULL),(46834,'54016','S','Burkhardt','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.981880,-92.690820,0,'2013-07-06 12:44:32',NULL,NULL),(62641,'74569','S','Stringtown','D','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.465763,-96.049636,0,'2013-07-06 12:44:33',NULL,NULL),(9396,'09866','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71654,'87501','S','Hyde Park Estates','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(11409,'11957','S','Orient Point','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.154240,-72.249750,0,'2013-07-06 12:44:30',NULL,NULL),(72983,'90052','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',33.974069,-118.248510,0,'2013-07-06 12:44:34',NULL,NULL),(4649,'03750','S','Etna','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715017,-72.211489,0,'2013-07-06 12:44:30',NULL,NULL),(3324,'01531','S','New Braintree','D','Worcester','25027','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',42.321017,-72.142586,0,'2013-07-06 12:44:30',NULL,NULL),(25920,'28649','S','Mc Grady','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.321231,-81.188583,0,'2013-07-06 12:44:31',NULL,NULL),(28043,'30656','S','Monroe','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.847484,-83.717624,0,'2013-07-06 12:44:31',NULL,NULL),(59860,'71260','S','Haile','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.909183,-92.241002,0,'2013-07-06 12:44:33',NULL,NULL),(22715,'24354','S','Marion','D','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(35308,'39404','P','Hattiesbg','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.296391,-89.429287,0,'2013-07-06 12:44:32',NULL,NULL),(22523,'24091','S','Floyd','D','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.914072,-80.316498,0,'2013-07-06 12:44:31',NULL,NULL),(4726,'03827','S','East Kingston','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.911422,-70.983388,0,'2013-07-06 12:44:30',NULL,NULL),(47713,'55003','S','Baytown','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.014760,-92.781480,0,'2013-07-06 12:44:33',NULL,NULL),(49258,'56477','S','Sebeka','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.627873,-95.089864,0,'2013-07-06 12:44:33',NULL,NULL),(54835,'63033','S','Black Jack','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.794669,-90.277021,0,'2013-07-06 12:44:33',NULL,NULL),(14008,'14526','S','Penfield','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.141702,-77.455684,0,'2013-07-06 12:44:31',NULL,NULL),(74449,'92585','S','Sun City','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.749416,-117.174455,0,'2013-07-06 12:44:34',NULL,NULL),(75644,'94523','S','Pleasant Hill','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.952057,-122.074333,0,'2013-07-06 12:44:34',NULL,NULL),(66310,'78590','P','San Perlita','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.467593,-97.579720,0,'2013-07-06 12:44:34',NULL,NULL),(3122,'01237','S','New Ashford','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.539340,-73.246200,0,'2013-07-06 12:44:30',NULL,NULL),(10195,'10305','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.594867,-74.077800,0,'2013-07-06 12:44:30',NULL,NULL),(43577,'48741','S','Kingston','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.405212,-83.175423,0,'2013-07-06 12:44:32',NULL,NULL),(38484,'43659','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.649245,-83.536795,0,'2013-07-06 12:44:32',NULL,NULL),(54553,'62890','S','Cave','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(57314,'66683','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.055847,-95.673223,0,'2013-07-06 12:44:33',NULL,NULL),(36688,'41016','S','Covington','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.084954,-84.549188,0,'2013-07-06 12:44:32',NULL,NULL),(69910,'84107','S','Ssl','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(18879,'19457','P','Parker Ford','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.205934,-75.592107,0,'2013-07-06 12:44:31',NULL,NULL),(39603,'44875','S','Little London','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(41989,'47421','S','Walnut Hts','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(53817,'62298','S','Foster Pond','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(65416,'77573','S','League City','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.503872,-95.092521,0,'2013-07-06 12:44:34',NULL,NULL),(63659,'75848','P','Kirvin','D','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.766052,-96.332854,0,'2013-07-06 12:44:34',NULL,NULL),(18385,'19048','U','Fort Washington','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.176074,-74.924818,0,'2013-07-06 12:44:31',NULL,NULL),(46787,'53961','S','Rock Springs','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.479574,-89.912377,0,'2013-07-06 12:44:32',NULL,NULL),(61174,'72199','U','Nlr','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.785804,-92.255214,0,'2013-07-06 12:44:33',NULL,NULL),(15568,'16646','S','Hastings','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.663534,-78.710124,0,'2013-07-06 12:44:31',NULL,NULL),(36125,'40223','S','Blue Ridge Manor','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(48448,'55707','S','Skelton','N','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.576488,-92.717904,0,'2013-07-06 12:44:33',NULL,NULL),(11577,'12069','P','Fort Hunter','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.941659,-74.279913,0,'2013-07-06 12:44:30',NULL,NULL),(26146,'28739','S','Laurel Park','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.318666,-82.488402,0,'2013-07-06 12:44:31',NULL,NULL),(9558,'10024','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(27532,'30220','S','Grantville','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.226075,-84.819456,0,'2013-07-06 12:44:31',NULL,NULL),(29746,'32969','P','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.638947,-80.397672,0,'2013-07-06 12:44:32',NULL,NULL),(12348,'12883','S','Streetroad','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.843857,-73.431459,0,'2013-07-06 12:44:30',NULL,NULL),(5858,'05143','S','Bartonsville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(52629,'61046','S','Lake Carroll','N','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.113145,-89.835553,0,'2013-07-06 12:44:33',NULL,NULL),(48045,'55311','S','Maple Grove','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.118800,-93.486660,0,'2013-07-06 12:44:33',NULL,NULL),(21855,'23141','S','Quinton','D','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.531619,-77.162791,0,'2013-07-06 12:44:31',NULL,NULL),(6146,'05465','S','Jericho Center','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.476140,-72.949800,0,'2013-07-06 12:44:30',NULL,NULL),(45970,'52402','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.020752,-91.669918,0,'2013-07-06 12:44:32',NULL,NULL),(61875,'73129','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.429134,-97.486641,0,'2013-07-06 12:44:33',NULL,NULL),(76848,'95965','S','Oak Grove','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(78764,'98305','S','Beaver','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.063480,-124.296000,0,'2013-07-06 12:44:34',NULL,NULL),(77205,'96372','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(62917,'75077','S','Highland Vill','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.047969,-96.994857,0,'2013-07-06 12:44:33',NULL,NULL),(49099,'56338','S','Hillman','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.030871,-93.858263,0,'2013-07-06 12:44:33',NULL,NULL),(52750,'61244','S','Campbells Island','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(54728,'62964','S','Spencer Heights','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.116221,-89.194753,0,'2013-07-06 12:44:33',NULL,NULL),(31924,'35176','S','Vandiver','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.483959,-86.499823,0,'2013-07-06 12:44:32',NULL,NULL),(34494,'38668','S','Thyatira','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(20067,'20678','S','Dares Beach','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.531530,-76.586745,0,'2013-07-06 12:44:31',NULL,NULL),(74592,'92698','U','Fluor Corp','N','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.668598,-117.838637,0,'2013-07-06 12:44:34',NULL,NULL),(78331,'98001','S','Algona','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.306800,-122.260607,0,'2013-07-06 12:44:34',NULL,NULL),(70091,'84165','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(17469,'17948','S','New Boston','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(52657,'61065','S','Poplar Grove','D','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.380237,-88.844362,0,'2013-07-06 12:44:33',NULL,NULL),(21548,'22743','S','Syria','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.516368,-78.353621,0,'2013-07-06 12:44:31',NULL,NULL),(22042,'23304','P','Battery Park','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.996165,-76.577882,0,'2013-07-06 12:44:31',NULL,NULL),(39113,'44253','S','Litchfield','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.167635,-82.032477,0,'2013-07-06 12:44:32',NULL,NULL),(8736,'08515','S','Chesterfield Township','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.153936,-74.650330,0,'2013-07-06 12:44:30',NULL,NULL),(75052,'93519','P','Cantil','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.305573,-117.953568,0,'2013-07-06 12:44:34',NULL,NULL),(20210,'20762','S','Andrews Air Force Base','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.805042,-76.880984,0,'2013-07-06 12:44:31',NULL,NULL),(21835,'23120','S','Moseley','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.419091,-77.768808,0,'2013-07-06 12:44:31',NULL,NULL),(35055,'39180','S','Vicksburg','D','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.323121,-90.860809,0,'2013-07-06 12:44:32',NULL,NULL),(79003,'98385','P','South Prairie','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.133592,-122.098445,0,'2013-07-06 12:44:34',NULL,NULL),(29241,'32434','P','Mossy Head','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.742338,-86.314609,0,'2013-07-06 12:44:32',NULL,NULL),(69427,'83636','P','Letha','D','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.898310,-116.648901,0,'2013-07-06 12:44:34',NULL,NULL),(2411,'00953','S','Est de la Fuente','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(11266,'11770','P','Corneil Estates','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.647098,-73.151777,0,'2013-07-06 12:44:30',NULL,NULL),(17750,'18324','S','Lehman','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.166175,-74.955517,0,'2013-07-06 12:44:31',NULL,NULL),(19716,'20391','S','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877045,-76.994981,0,'2013-07-06 12:44:31',NULL,NULL),(14558,'15213','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.444993,-79.952662,0,'2013-07-06 12:44:31',NULL,NULL),(46095,'52621','S','Wyman','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.212644,-91.536955,0,'2013-07-06 12:44:32',NULL,NULL),(15272,'16108','S','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.988263,-80.295406,0,'2013-07-06 12:44:31',NULL,NULL),(54358,'62801','S','Central City','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(53564,'62052','S','Otterville','A','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.135780,-90.333000,0,'2013-07-06 12:44:33',NULL,NULL),(40930,'46283','U','Brylane','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.777280,-86.111789,0,'2013-07-06 12:44:32',NULL,NULL),(68390,'81151','S','San Acacio','A','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.265658,-105.848320,0,'2013-07-06 12:44:34',NULL,NULL),(10769,'11364','S','Hollis Hills','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(30745,'33547','S','Lithia','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.810925,-82.148900,0,'2013-07-06 12:44:32',NULL,NULL),(12962,'13363','S','Stokes','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.314420,-75.512100,0,'2013-07-06 12:44:30',NULL,NULL),(41398,'46807','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.048761,-85.145583,0,'2013-07-06 12:44:32',NULL,NULL),(5723,'05009','U','Veterans Administration','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.652072,-72.322990,0,'2013-07-06 12:44:30',NULL,NULL),(38747,'44033','P','East Claridon','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.546980,-81.101726,0,'2013-07-06 12:44:32',NULL,NULL),(13626,'13902','P','Binghamton','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.107412,-75.868335,0,'2013-07-06 12:44:31',NULL,NULL),(62028,'73481','S','Ratliff City','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.409849,-97.511917,0,'2013-07-06 12:44:33',NULL,NULL),(32977,'36611','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.727800,-88.138980,0,'2013-07-06 12:44:32',NULL,NULL),(18561,'19122','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.976781,-75.144244,0,'2013-07-06 12:44:31',NULL,NULL),(32817,'36455','P','Lockhart','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.050639,-86.347063,0,'2013-07-06 12:44:32',NULL,NULL),(43848,'49103','S','Berrien Sprgs','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.940154,-86.349801,0,'2013-07-06 12:44:32',NULL,NULL),(71699,'87522','S','El Portero','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.024720,-105.870480,0,'2013-07-06 12:44:34',NULL,NULL),(33834,'37933','P','Farragut','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.866070,-84.124099,0,'2013-07-06 12:44:32',NULL,NULL),(19481,'20148','S','Ashburn','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.994011,-77.531312,0,'2013-07-06 12:44:31',NULL,NULL),(41725,'47244','S','Waynesburg','N','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.268162,-85.697809,0,'2013-07-06 12:44:32',NULL,NULL),(4428,'03235','S','West Franklin','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.437900,-71.664660,0,'2013-07-06 12:44:30',NULL,NULL),(49621,'56904','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(61433,'72579','S','Sulphur Rock','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.799327,-91.472922,0,'2013-07-06 12:44:33',NULL,NULL),(50869,'58507','P','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.796368,-100.756084,0,'2013-07-06 12:44:33',NULL,NULL),(53507,'62016','S','Carrollton','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.299962,-90.410116,0,'2013-07-06 12:44:33',NULL,NULL),(59708,'71105','S','Shreve Island','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.454589,-93.712715,0,'2013-07-06 12:44:33',NULL,NULL),(62658,'74631','S','Blackwell','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.799089,-97.288017,0,'2013-07-06 12:44:33',NULL,NULL),(75271,'93704','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.799379,-119.799461,0,'2013-07-06 12:44:34',NULL,NULL),(63966,'76101','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.759439,-97.329119,0,'2013-07-06 12:44:34',NULL,NULL),(60445,'71647','S','Smearney','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(54207,'62640','S','McVey','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.446714,-89.796627,0,'2013-07-06 12:44:33',NULL,NULL),(31737,'34985','P','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.295090,-80.349568,0,'2013-07-06 12:44:32',NULL,NULL),(44256,'49680','S','South Boardman','D','Kalkaska','26079','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.633052,-85.243490,0,'2013-07-06 12:44:32',NULL,NULL),(42871,'48082','S','St Clr Shores','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.529366,-82.887803,0,'2013-07-06 12:44:32',NULL,NULL),(72609,'89414','S','Midas','A','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.007834,-117.299047,0,'2013-07-06 12:44:34',NULL,NULL),(3375,'01588','S','Whitinsville','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.122324,-71.671383,0,'2013-07-06 12:44:30',NULL,NULL),(78047,'97444','S','Gold Beach','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.434400,-124.366860,0,'2013-07-06 12:44:34',NULL,NULL),(4819,'03905','S','Kittery Point','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.090653,-70.699746,0,'2013-07-06 12:44:30',NULL,NULL),(48713,'55947','S','La Crescent','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.819624,-91.327279,0,'2013-07-06 12:44:33',NULL,NULL),(65146,'77387','P','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.077102,-95.417741,0,'2013-07-06 12:44:34',NULL,NULL),(67440,'80204','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.736603,-105.021230,0,'2013-07-06 12:44:34',NULL,NULL),(68778,'82327','S','Elmo','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.878504,-106.556303,0,'2013-07-06 12:44:34',NULL,NULL),(6924,'06156','U','Aetna Life','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.758950,-72.732086,0,'2013-07-06 12:44:30',NULL,NULL),(5455,'04732','S','Ashland','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.626925,-68.418941,0,'2013-07-06 12:44:30',NULL,NULL),(36685,'41015','S','Ryland Hgts','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(24113,'26527','P','Cassville','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.667123,-80.056369,0,'2013-07-06 12:44:31',NULL,NULL),(9184,'09372','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(65455,'77615','P','Evadale','D','Jasper','48241','Texas','TX','48','0840','409','Central',-6.0,'Y',30.353312,-94.074008,0,'2013-07-06 12:44:34',NULL,NULL),(74206,'92301','S','El Mirage','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.589414,-117.479821,0,'2013-07-06 12:44:34',NULL,NULL),(63159,'75391','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.949228,-96.825524,0,'2013-07-06 12:44:33',NULL,NULL),(40876,'46239','S','Wanamaker','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.717557,-86.000421,0,'2013-07-06 12:44:32',NULL,NULL),(14757,'15329','S','Prosperity','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.024107,-80.251263,0,'2013-07-06 12:44:31',NULL,NULL),(11055,'11576','S','Roslyn Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.774722,-73.656111,0,'2013-07-06 12:44:30',NULL,NULL),(13882,'14263','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.873378,-78.869243,0,'2013-07-06 12:44:31',NULL,NULL),(34159,'38257','S','South Fulton','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.496436,-88.876214,0,'2013-07-06 12:44:32',NULL,NULL),(40581,'45872','S','North Baltimore','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.189235,-83.669819,0,'2013-07-06 12:44:32',NULL,NULL),(28553,'31565','S','Piney Bluff','N','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.047300,-81.577500,0,'2013-07-06 12:44:32',NULL,NULL),(37344,'41701','S','Walkertown','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.253627,-83.184866,0,'2013-07-06 12:44:32',NULL,NULL),(75916,'95006','S','Boulder Creek','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.148282,-122.131711,0,'2013-07-06 12:44:34',NULL,NULL),(21986,'23260','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.549463,-77.459359,0,'2013-07-06 12:44:31',NULL,NULL),(40158,'45358','P','Pitsburg','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.986707,-84.487723,0,'2013-07-06 12:44:32',NULL,NULL),(25231,'28093','P','Lincolnton','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.473610,-81.254310,0,'2013-07-06 12:44:31',NULL,NULL),(31148,'33912','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.509195,-81.832204,0,'2013-07-06 12:44:32',NULL,NULL),(50921,'58563','S','Judson','A','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.853700,-101.435580,0,'2013-07-06 12:44:33',NULL,NULL),(59650,'71046','S','Four Forks','N','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.214950,-93.998948,0,'2013-07-06 12:44:33',NULL,NULL),(62246,'74003','S','Bville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(70465,'84756','P','Pinto','N','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.823414,-113.721440,0,'2013-07-06 12:44:34',NULL,NULL),(61648,'72856','S','Pelsor','D','Pope','05115','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.690402,-93.054572,0,'2013-07-06 12:44:33',NULL,NULL),(22509,'24082','S','Critz','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.614641,-80.121704,0,'2013-07-06 12:44:31',NULL,NULL),(74368,'92423','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.107116,-117.292358,0,'2013-07-06 12:44:34',NULL,NULL),(4927,'04079','S','S Harpswell','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.825960,-69.953763,0,'2013-07-06 12:44:30',NULL,NULL),(27650,'30320','P','Logistics & Distribution Ctr','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.635644,-84.433286,0,'2013-07-06 12:44:31',NULL,NULL),(61746,'73040','S','Geary','D','Blaine','40011','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.628001,-98.318180,0,'2013-07-06 12:44:33',NULL,NULL),(20250,'20782','S','Lewisdale','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(62524,'74422','S','Boynton','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.664613,-95.672648,0,'2013-07-06 12:44:33',NULL,NULL),(8206,'07938','P','Liberty Cor','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.664700,-74.577720,0,'2013-07-06 12:44:30',NULL,NULL),(18319,'19022','S','Crum Lynne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862914,-75.343388,0,'2013-07-06 12:44:31',NULL,NULL),(11345,'11794','U','Suny Stony Brook','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.914561,-73.125169,0,'2013-07-06 12:44:30',NULL,NULL),(60845,'72041','S','Tollville','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.715356,-91.542833,0,'2013-07-06 12:44:33',NULL,NULL),(51500,'59636','P','Fort Harrison','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.604791,-112.091661,0,'2013-07-06 12:44:33',NULL,NULL),(53973,'62435','P','Janesville','D','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.374587,-88.243602,0,'2013-07-06 12:44:33',NULL,NULL),(74313,'92389','P','Tecopa','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',35.948545,-115.897853,0,'2013-07-06 12:44:34',NULL,NULL),(30883,'33687','P','Temple Ter','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.035966,-82.390978,0,'2013-07-06 12:44:32',NULL,NULL),(29490,'32744','S','Lake Helen','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.984058,-81.234902,0,'2013-07-06 12:44:32',NULL,NULL),(3580,'01982','S','S Hamilton','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.619543,-70.861660,0,'2013-07-06 12:44:30',NULL,NULL),(54810,'63021','S','Ballwin','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(21419,'22544','P','Rollins Fork','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.185617,-77.065844,0,'2013-07-06 12:44:31',NULL,NULL),(20551,'21122','S','Lake Shore','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.127599,-76.512544,0,'2013-07-06 12:44:31',NULL,NULL),(60074,'71355','S','Moreauville','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(34776,'38864','S','Buckhorn','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.171200,-89.188320,0,'2013-07-06 12:44:32',NULL,NULL),(30735,'33539','P','Zephyrhills','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.249851,-82.300231,0,'2013-07-06 12:44:32',NULL,NULL),(44691,'50128','S','Jamaica','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.833335,-94.338909,0,'2013-07-06 12:44:32',NULL,NULL),(50001,'57375','S','Aurora Center','N','Aurora','46003','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.586250,-98.561284,0,'2013-07-06 12:44:33',NULL,NULL),(59221,'70420','S','Abita Springs','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.486971,-89.957312,0,'2013-07-06 12:44:33',NULL,NULL),(62370,'74074','S','Stillwater','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.107960,-97.076194,0,'2013-07-06 12:44:33',NULL,NULL),(67241,'79940','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.771329,-106.426299,0,'2013-07-06 12:44:34',NULL,NULL),(67368,'80113','S','Cherry Hills Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643479,-104.956040,0,'2013-07-06 12:44:34',NULL,NULL),(76923,'96010','S','Big Bar','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.912200,-123.256187,0,'2013-07-06 12:44:34',NULL,NULL),(4024,'02565','P','North Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.639770,-70.635490,0,'2013-07-06 12:44:30',NULL,NULL),(62916,'75077','S','Double Oak','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.047969,-96.994857,0,'2013-07-06 12:44:33',NULL,NULL),(26369,'29074','P','Liberty Hill','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.453638,-80.790518,0,'2013-07-06 12:44:31',NULL,NULL),(45559,'51502','P','Council Blfs','A','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.261393,-95.849876,0,'2013-07-06 12:44:32',NULL,NULL),(72238,'88514','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812685,-106.415171,0,'2013-07-06 12:44:34',NULL,NULL),(79994,'99661','P','Sand Point','D','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.268136,-160.681303,0,'2013-07-06 12:44:34',NULL,NULL),(39017,'44143','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(16281,'17102','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.258980,-76.862940,0,'2013-07-06 12:44:31',NULL,NULL),(47145,'54460','S','Green Grove','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.947848,-90.563733,0,'2013-07-06 12:44:32',NULL,NULL),(31144,'33910','P','Cape Coral S','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.551448,-82.020111,0,'2013-07-06 12:44:32',NULL,NULL),(73844,'91791','S','West Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.062629,-117.893363,0,'2013-07-06 12:44:34',NULL,NULL),(68238,'81054','S','Las Animas','D','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(68155,'81001','S','Pueblo Dep Ac','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(4674,'03782','S','Sunapee','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.389600,-72.091380,0,'2013-07-06 12:44:30',NULL,NULL),(12165,'12751','S','Kiamesha Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.680968,-74.674693,0,'2013-07-06 12:44:30',NULL,NULL),(37491,'42025','S','Benton','D','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.877980,-88.333200,0,'2013-07-06 12:44:32',NULL,NULL),(7301,'06602','P','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.173645,-73.200467,0,'2013-07-06 12:44:30',NULL,NULL),(26911,'29582','S','Atlantic Beach','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(10396,'10603','S','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.050315,-73.777527,0,'2013-07-06 12:44:30',NULL,NULL),(46273,'53029','S','Chenequa','N','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.106382,-88.351136,0,'2013-07-06 12:44:32',NULL,NULL),(56644,'65613','S','Cherkee Hmstd','A','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.613564,-93.414989,0,'2013-07-06 12:44:33',NULL,NULL),(56869,'66017','S','Denton','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.732820,-95.269710,0,'2013-07-06 12:44:33',NULL,NULL),(63843,'75975','S','Antioch','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(78981,'98375','S','South Hill','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118810,-122.306430,0,'2013-07-06 12:44:34',NULL,NULL),(26795,'29457','P','Johns Island','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.745060,-80.032709,0,'2013-07-06 12:44:31',NULL,NULL),(35151,'39232','S','Flowood','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289828,-90.181404,0,'2013-07-06 12:44:32',NULL,NULL),(6880,'06140','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.789823,-72.663704,0,'2013-07-06 12:44:30',NULL,NULL),(18415,'19060','S','Garnet Valley','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.846163,-75.445489,0,'2013-07-06 12:44:31',NULL,NULL),(12262,'12833','S','Greenfield','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.141920,-73.855860,0,'2013-07-06 12:44:30',NULL,NULL),(38968,'44128','S','North Randall','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(22267,'23692','S','Yorktown','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.177139,-76.459291,0,'2013-07-06 12:44:31',NULL,NULL),(47728,'55009','S','Miesville','N','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.507743,-92.905112,0,'2013-07-06 12:44:33',NULL,NULL),(68219,'81050','S','Fair View','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(69987,'84121','S','Murray','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(71086,'85930','P','McNary','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.983889,-109.746389,0,'2013-07-06 12:44:34',NULL,NULL),(40981,'46346','P','Kingsford Hts','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.479434,-86.694760,0,'2013-07-06 12:44:32',NULL,NULL),(57144,'66250','U','Shawnee Mission','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955067,-94.786621,0,'2013-07-06 12:44:33',NULL,NULL),(11719,'12175','S','Summit','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.533016,-74.538830,0,'2013-07-06 12:44:30',NULL,NULL),(22111,'23427','P','Saxis','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.921375,-75.683849,0,'2013-07-06 12:44:31',NULL,NULL),(24076,'26447','S','Roanoke','A','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.848407,-80.503889,0,'2013-07-06 12:44:31',NULL,NULL),(12026,'12514','S','Clinton Cors','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.875980,-73.772400,0,'2013-07-06 12:44:30',NULL,NULL),(34006,'38122','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.158002,-89.923644,0,'2013-07-06 12:44:32',NULL,NULL),(21112,'22067','S','Mc Lean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.940622,-77.165123,0,'2013-07-06 12:44:31',NULL,NULL),(49710,'57035','S','Humboldt','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.711272,-96.886802,0,'2013-07-06 12:44:33',NULL,NULL),(55644,'64019','S','Centerview','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.792943,-93.873742,0,'2013-07-06 12:44:33',NULL,NULL),(56907,'66047','S','Lwrnce','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.946781,-95.281917,0,'2013-07-06 12:44:33',NULL,NULL),(1586,'00769','S','Coamo','D','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(76363,'95493','S','Witter Spgs','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.186429,-122.962942,0,'2013-07-06 12:44:34',NULL,NULL),(76084,'95212','S','Morada','A','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.039880,-121.237899,0,'2013-07-06 12:44:34',NULL,NULL),(66426,'78640','S','Uhland','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.006600,-97.807140,0,'2013-07-06 12:44:34',NULL,NULL),(22934,'24630','S','N Tazewell','A','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.154700,-81.511320,0,'2013-07-06 12:44:31',NULL,NULL),(37619,'42140','S','Freetown','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.660772,-85.813348,0,'2013-07-06 12:44:32',NULL,NULL),(13311,'13673','S','Philadelphia','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.157023,-75.711455,0,'2013-07-06 12:44:30',NULL,NULL),(40104,'45314','S','Cedarville','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.747769,-83.788032,0,'2013-07-06 12:44:32',NULL,NULL),(25818,'28611','S','Collettsville','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.992485,-81.713513,0,'2013-07-06 12:44:31',NULL,NULL),(29214,'32413','S','W Panama City Beach','N','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(17259,'17841','S','Wagner','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(75040,'93514','S','Round Valley','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(25930,'28654','S','Moravian Fls','A','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.099261,-81.174660,0,'2013-07-06 12:44:31',NULL,NULL),(45965,'52359','S','West Chester','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.377483,-91.881338,0,'2013-07-06 12:44:32',NULL,NULL),(37866,'42539','S','Liberty','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.316700,-84.981180,0,'2013-07-06 12:44:32',NULL,NULL),(37460,'41858','S','Democrat','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(77118,'96150','S','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.886415,-120.035272,0,'2013-07-06 12:44:34',NULL,NULL),(29342,'32550','S','Destin','A','Walton','12131','Florida','FL','12','2750','850','Central',-6.0,'Y',30.393333,-86.495833,0,'2013-07-06 12:44:32',NULL,NULL),(47275,'54534','S','Oma','N','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.481944,-90.305833,0,'2013-07-06 12:44:32',NULL,NULL),(66607,'78762','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.260427,-97.722951,0,'2013-07-06 12:44:34',NULL,NULL),(9527,'10019','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(9598,'10030','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(693,'00685','S','Repto Pin Mendez','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(2656,'00966','S','Urb Garden CT','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(75295,'93726','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.790420,-119.762793,0,'2013-07-06 12:44:34',NULL,NULL),(10109,'10256','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706232,-74.010903,0,'2013-07-06 12:44:30',NULL,NULL),(48297,'55438','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.827962,-93.378236,0,'2013-07-06 12:44:33',NULL,NULL),(73242,'90671','P','Santa Fe Springs','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.932507,-118.058491,0,'2013-07-06 12:44:34',NULL,NULL),(68322,'81120','S','Las Mesitas','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(31330,'34134','S','Bonita Springs','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.362812,-81.822980,0,'2013-07-06 12:44:32',NULL,NULL),(50561,'58212','S','Aneta','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.759500,-97.948747,0,'2013-07-06 12:44:33',NULL,NULL),(36820,'41063','S','Piner','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.842260,-84.522660,0,'2013-07-06 12:44:32',NULL,NULL),(13723,'14091','S','Lawtons','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.539825,-78.865691,0,'2013-07-06 12:44:31',NULL,NULL),(45759,'52144','S','Fort Atkinson','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.143605,-91.931990,0,'2013-07-06 12:44:32',NULL,NULL),(5399,'04654','S','Roque Bluffs','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.720530,-67.467043,0,'2013-07-06 12:44:30',NULL,NULL),(21561,'22810','S','Basye','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.795741,-78.799328,0,'2013-07-06 12:44:31',NULL,NULL),(37427,'41822','S','Brinkley','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.322511,-82.949258,0,'2013-07-06 12:44:32',NULL,NULL),(78134,'97532','S','Merlin','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.530607,-123.432611,0,'2013-07-06 12:44:34',NULL,NULL),(72320,'89003','P','Rhyolite','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.876924,-116.730966,0,'2013-07-06 12:44:34',NULL,NULL),(66346,'78609','S','Inks Lake Village','N','Llano','48299','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.798498,-98.465383,0,'2013-07-06 12:44:34',NULL,NULL),(47312,'54555','S','Lugerville','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(53104,'61535','S','Whispering Oaks','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.593891,-89.535053,0,'2013-07-06 12:44:33',NULL,NULL),(327,'00650','S','Repto Seoane','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(67236,'79934','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.939849,-106.402095,0,'2013-07-06 12:44:34',NULL,NULL),(25215,'28081','S','Royal Oaks','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(4634,'03607','S','South Acworth','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.176228,-72.332333,0,'2013-07-06 12:44:30',NULL,NULL),(10987,'11548','S','Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(48006,'55165','P','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.965239,-93.085789,0,'2013-07-06 12:44:33',NULL,NULL),(32021,'35237','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519891,-86.807747,0,'2013-07-06 12:44:32',NULL,NULL),(56584,'65548','S','Mountain View','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.995415,-91.718827,0,'2013-07-06 12:44:33',NULL,NULL),(34693,'38828','S','Jug Fork','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(28888,'32126','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.225945,-81.006483,0,'2013-07-06 12:44:32',NULL,NULL),(44723,'50151','S','Norwood','N','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.177296,-93.538427,0,'2013-07-06 12:44:32',NULL,NULL),(597,'00680','S','Urb Ensanche Ramirez','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(49688,'57022','S','Dell Rapids','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.826202,-96.717843,0,'2013-07-06 12:44:33',NULL,NULL),(5207,'04457','S','Lincoln','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(48350,'55483','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.935113,-93.283739,0,'2013-07-06 12:44:33',NULL,NULL),(45054,'50501','S','Fort Dodge','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(5982,'05346','S','East Putney','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.955143,-72.565046,0,'2013-07-06 12:44:30',NULL,NULL),(77029,'96101','S','Xl Ranch Indian Reservation','N','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.512612,-120.551753,0,'2013-07-06 12:44:34',NULL,NULL),(68625,'81631','P','Eagle','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.646581,-106.837237,0,'2013-07-06 12:44:34',NULL,NULL),(67712,'80532','P','Glen Haven','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.457347,-105.443964,0,'2013-07-06 12:44:34',NULL,NULL),(66710,'78948','S','Fedor','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.316524,-96.976370,0,'2013-07-06 12:44:34',NULL,NULL),(63815,'75969','S','Pollok','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.415556,-94.938889,0,'2013-07-06 12:44:34',NULL,NULL),(55941,'64480','S','Rea','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',40.058207,-94.688636,0,'2013-07-06 12:44:33',NULL,NULL),(55469,'63743','S','Daisy','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.512497,-89.826349,0,'2013-07-06 12:44:33',NULL,NULL),(53591,'62071','P','Nat Stock Yds','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.646662,-90.157901,0,'2013-07-06 12:44:33',NULL,NULL),(49468,'56653','S','Happyland','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.362760,-93.507720,0,'2013-07-06 12:44:33',NULL,NULL),(47306,'54552','S','Sherman','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(40175,'45370','S','Spg Valley','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.599468,-84.138005,0,'2013-07-06 12:44:32',NULL,NULL),(28706,'31826','S','Shiloh','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.798553,-84.744824,0,'2013-07-06 12:44:32',NULL,NULL),(20227,'20774','S','Springdale','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(4743,'03838','S','Glen','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.099679,-71.206218,0,'2013-07-06 12:44:30',NULL,NULL),(76446,'95605','S','West Sacramento','D','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.594722,-121.540556,0,'2013-07-06 12:44:34',NULL,NULL),(80115,'99762','P','Diomede','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.787400,-165.197220,0,'2013-07-06 12:44:34',NULL,NULL),(77256,'96552','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(70375,'84657','P','Sigurd','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.840732,-111.970860,0,'2013-07-06 12:44:34',NULL,NULL),(44577,'50029','S','Bayard','D','Guthrie','19077','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.853153,-94.558798,0,'2013-07-06 12:44:32',NULL,NULL),(53556,'62049','S','Kortcamp','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.155644,-89.482574,0,'2013-07-06 12:44:33',NULL,NULL),(44019,'49404','S','Eastmanville','N','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.066832,-85.934647,0,'2013-07-06 12:44:32',NULL,NULL),(74106,'92223','S','Beaumont','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.952498,-116.973803,0,'2013-07-06 12:44:34',NULL,NULL),(72361,'89024','P','Mesquite','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.804545,-114.071143,0,'2013-07-06 12:44:34',NULL,NULL),(64761,'76941','S','Mertzon','D','Irion','48235','Texas','TX','48','0000','325','Central',-6.0,'Y',31.291680,-100.860180,0,'2013-07-06 12:44:34',NULL,NULL),(11715,'12173','S','Newton Hook','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.344820,-73.756440,0,'2013-07-06 12:44:30',NULL,NULL),(6944,'06180','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757571,-72.764720,0,'2013-07-06 12:44:30',NULL,NULL),(6275,'05633','U','State of Vermont','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.259083,-72.580549,0,'2013-07-06 12:44:30',NULL,NULL),(24297,'27011','S','Longtown','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.240300,-80.637420,0,'2013-07-06 12:44:31',NULL,NULL),(27111,'29729','S','Richburg','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.775868,-81.026327,0,'2013-07-06 12:44:31',NULL,NULL),(27918,'30510','S','Alto','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.430265,-83.636673,0,'2013-07-06 12:44:31',NULL,NULL),(31671,'34759','S','Poinciana','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.142963,-81.453023,0,'2013-07-06 12:44:32',NULL,NULL),(14927,'15551','S','Markleton','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.872698,-79.292074,0,'2013-07-06 12:44:31',NULL,NULL),(37822,'42437','S','Grove Center','N','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(36590,'40962','S','Marcum','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(75886,'94960','S','San Anselmo','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.980263,-122.567823,0,'2013-07-06 12:44:34',NULL,NULL),(8391,'08060','S','Mount Holly Township','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(30746,'33548','S','Lutz','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.143554,-82.480350,0,'2013-07-06 12:44:32',NULL,NULL),(39494,'44799','U','Canton Business Reply','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.811856,-81.373368,0,'2013-07-06 12:44:32',NULL,NULL),(10885,'11421','S','Woodhaven','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.692189,-73.856141,0,'2013-07-06 12:44:30',NULL,NULL),(76893,'95980','P','Rock Crest','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(62920,'75078','S','Prosper','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.247578,-96.811198,0,'2013-07-06 12:44:33',NULL,NULL),(62711,'74752','P','Pickens','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.394987,-95.012194,0,'2013-07-06 12:44:33',NULL,NULL),(60711,'71953','S','Acorn','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(54430,'62837','S','Merriam','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(53144,'61554','S','Pekin','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(52404,'60638','S','Bedford Park','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781649,-87.774356,0,'2013-07-06 12:44:33',NULL,NULL),(51423,'59451','S','Hilger','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.067997,-109.432142,0,'2013-07-06 12:44:33',NULL,NULL),(63522,'75754','S','Primrose','N','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.414520,-95.649120,0,'2013-07-06 12:44:33',NULL,NULL),(32270,'35640','S','Hartselle','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.446769,-86.939131,0,'2013-07-06 12:44:32',NULL,NULL),(23256,'25124','S','Liberty','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.629289,-81.767821,0,'2013-07-06 12:44:31',NULL,NULL),(12065,'12541','P','Livingston','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.141513,-73.778200,0,'2013-07-06 12:44:30',NULL,NULL),(15720,'16871','S','Pottersdale','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.210847,-78.022444,0,'2013-07-06 12:44:31',NULL,NULL),(38957,'44127','S','Cuyahoga Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472030,-81.650481,0,'2013-07-06 12:44:32',NULL,NULL),(54042,'62466','S','Helena','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.730600,-87.772380,0,'2013-07-06 12:44:33',NULL,NULL),(70570,'85062','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.464180,-111.987880,0,'2013-07-06 12:44:34',NULL,NULL),(43912,'49256','S','Morenci','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.743671,-84.217238,0,'2013-07-06 12:44:32',NULL,NULL),(16721,'17406','S','Kreutz Creek','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(41954,'47403','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.113644,-86.586952,0,'2013-07-06 12:44:32',NULL,NULL),(15733,'16901','S','Charleston','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(24438,'27207','S','Harpers Crossroads','N','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.698455,-79.508612,0,'2013-07-06 12:44:31',NULL,NULL),(61461,'72628','S','Limestone','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842526,-93.350809,0,'2013-07-06 12:44:33',NULL,NULL),(28131,'30817','S','Lincolnton','D','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(22087,'23399','S','Jenkins Bridge','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.917093,-75.635031,0,'2013-07-06 12:44:31',NULL,NULL),(37278,'41603','S','Honaker','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.579884,-82.700311,0,'2013-07-06 12:44:32',NULL,NULL),(24355,'27043','S','Shoal','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.255873,-80.442780,0,'2013-07-06 12:44:31',NULL,NULL),(15446,'16402','S','Bear Lake','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.968751,-79.476934,0,'2013-07-06 12:44:31',NULL,NULL),(15777,'16921','S','Watrous','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(63919,'76049','S','Granbury','D','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.449949,-97.737417,0,'2013-07-06 12:44:34',NULL,NULL),(9737,'10090','S','S Pole','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(36507,'40824','P','Dayhoit','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.867282,-83.387384,0,'2013-07-06 12:44:32',NULL,NULL),(13171,'13612','S','Black River','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006210,-75.796688,0,'2013-07-06 12:44:30',NULL,NULL),(5265,'04490','S','Codyville Plt','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.452605,-67.717492,0,'2013-07-06 12:44:30',NULL,NULL),(17562,'17983','S','Hubley','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.646385,-76.546473,0,'2013-07-06 12:44:31',NULL,NULL),(20270,'20785','S','N Englewood','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(21519,'22723','S','Hood','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.357258,-78.383955,0,'2013-07-06 12:44:31',NULL,NULL),(49206,'56458','S','Lake George','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.282516,-95.048993,0,'2013-07-06 12:44:33',NULL,NULL),(50927,'58565','S','Riverdale','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.502299,-101.368973,0,'2013-07-06 12:44:33',NULL,NULL),(51873,'60084','S','Lk Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.262122,-88.139439,0,'2013-07-06 12:44:33',NULL,NULL),(30359,'33313','S','Ldhl','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(21521,'22725','S','Leon','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.453845,-78.158848,0,'2013-07-06 12:44:31',NULL,NULL),(20903,'21716','S','Brunswick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.314478,-77.622428,0,'2013-07-06 12:44:31',NULL,NULL),(14473,'15123','S','W Mifflin/Pleasant Hills','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.342320,-79.954680,0,'2013-07-06 12:44:31',NULL,NULL),(29254,'32448','S','Marianna','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.661698,-85.184840,0,'2013-07-06 12:44:32',NULL,NULL),(60930,'72086','S','Bayou Metro','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.788120,-91.948860,0,'2013-07-06 12:44:33',NULL,NULL),(62311,'74034','P','Hallis','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.233896,-96.567733,0,'2013-07-06 12:44:33',NULL,NULL),(519,'00674','S','Urb Luchetti','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(71959,'88002','S','White Sands Missile Range','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.263759,-106.471871,0,'2013-07-06 12:44:34',NULL,NULL),(69109,'83263','S','Preston','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.209880,-111.753600,0,'2013-07-06 12:44:34',NULL,NULL),(36964,'41174','S','South Portsmouth','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.706344,-83.011058,0,'2013-07-06 12:44:32',NULL,NULL),(29691,'32932','P','Cocoa Beach','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.318120,-80.612743,0,'2013-07-06 12:44:32',NULL,NULL),(72594,'89408','S','Fernley','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.597279,-119.231521,0,'2013-07-06 12:44:34',NULL,NULL),(21480,'22643','S','Markham','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.916784,-78.004657,0,'2013-07-06 12:44:31',NULL,NULL),(38985,'44131','S','Parma','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(56377,'65231','S','Auxvasse','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.015325,-91.894565,0,'2013-07-06 12:44:33',NULL,NULL),(16390,'17213','S','Shade Valley','N','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(17195,'17821','S','Exchange','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(3116,'01235','S','Hinsdale','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.430860,-73.069380,0,'2013-07-06 12:44:30',NULL,NULL),(38895,'44112','S','East Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.534374,-81.574679,0,'2013-07-06 12:44:32',NULL,NULL),(59885,'71270','S','Barnet Springs','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(45865,'52245','S','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.666350,-91.511043,0,'2013-07-06 12:44:32',NULL,NULL),(18859,'19441','U','Harleysville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.278302,-75.390438,0,'2013-07-06 12:44:31',NULL,NULL),(29887,'33042','S','Sugarloaf Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(76928,'96015','S','Canby','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.561292,-121.024824,0,'2013-07-06 12:44:34',NULL,NULL),(6026,'05403','S','Queen City','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(75717,'94582','S','San Ramon','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.672450,-121.889069,0,'2013-07-06 12:44:34',NULL,NULL),(68971,'83101','S','Hamsfork','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.796146,-110.539940,0,'2013-07-06 12:44:34',NULL,NULL),(63759,'75941','S','Pine Valley','N','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.187357,-94.786365,0,'2013-07-06 12:44:34',NULL,NULL),(30592,'33419','P','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.781477,-80.092135,0,'2013-07-06 12:44:32',NULL,NULL),(34568,'38732','S','Zumbro','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740820,-90.724995,0,'2013-07-06 12:44:32',NULL,NULL),(19436,'20106','S','Viewtown','A','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.671345,-77.996631,0,'2013-07-06 12:44:31',NULL,NULL),(42574,'47878','P','Seelyville','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.495156,-87.263683,0,'2013-07-06 12:44:32',NULL,NULL),(7468,'06879','U','Ridgefield','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.272541,-73.497016,0,'2013-07-06 12:44:30',NULL,NULL),(2762,'00969','S','Villas Del Parque','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(32834,'36474','S','Red Level','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.456303,-86.602931,0,'2013-07-06 12:44:32',NULL,NULL),(3286,'01503','S','Berlin','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.374084,-71.632431,0,'2013-07-06 12:44:30',NULL,NULL),(57791,'67483','S','Tampa','D','Marion','20115','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.564314,-97.203721,0,'2013-07-06 12:44:33',NULL,NULL),(25565,'28423','S','Bolton','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.178325,-78.398021,0,'2013-07-06 12:44:31',NULL,NULL),(27552,'30253','S','Mc Donough','N','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.443757,-84.181882,0,'2013-07-06 12:44:31',NULL,NULL),(67226,'79927','S','Ysleta Del Sur Pueblo','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.655220,-106.228260,0,'2013-07-06 12:44:34',NULL,NULL),(371,'00659','S','Villa del Carmen','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(1814,'00784','S','Comunidad Puente Jobos','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(20879,'21678','S','Lynch','A','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.299035,-76.108948,0,'2013-07-06 12:44:31',NULL,NULL),(29680,'32923','P','Cocoa','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.260750,-80.705796,0,'2013-07-06 12:44:32',NULL,NULL),(31169,'33918','P','N Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(55317,'63539','S','Goldsberry','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.930787,-92.773951,0,'2013-07-06 12:44:33',NULL,NULL),(23456,'25427','S','Cherry Run','A','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.549480,-78.070560,0,'2013-07-06 12:44:31',NULL,NULL),(71162,'86039','P','Hard Rock','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(69219,'83401','S','Hillview','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(29101,'32302','P','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.443756,-84.283569,0,'2013-07-06 12:44:32',NULL,NULL),(7797,'07435','S','Greenpond','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.056980,-74.428920,0,'2013-07-06 12:44:30',NULL,NULL),(6573,'05855','S','Indian Point','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(30490,'33359','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.179370,-80.226998,0,'2013-07-06 12:44:32',NULL,NULL),(40444,'45727','S','Dexter City','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.634712,-81.506267,0,'2013-07-06 12:44:32',NULL,NULL),(6220,'05488','S','Swanton','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(35937,'40051','S','Howardstown','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.671684,-85.546062,0,'2013-07-06 12:44:32',NULL,NULL),(44666,'50112','S','Grinnell','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.767320,-92.765040,0,'2013-07-06 12:44:32',NULL,NULL),(10502,'10965','S','Chestnut Ridge','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.062979,-74.018824,0,'2013-07-06 12:44:30',NULL,NULL),(78234,'97814','S','Medical Spgs','A','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.779688,-117.834287,0,'2013-07-06 12:44:34',NULL,NULL),(79094,'98439','S','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(50833,'58476','S','Pingree','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.134183,-99.032822,0,'2013-07-06 12:44:33',NULL,NULL),(14531,'15206','S','East Liberty','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.466864,-79.915908,0,'2013-07-06 12:44:31',NULL,NULL),(60792,'72027','S','Catholic Point','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.401579,-92.560518,0,'2013-07-06 12:44:33',NULL,NULL),(50579,'58229','S','Fairdale','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.472054,-98.208653,0,'2013-07-06 12:44:33',NULL,NULL),(20562,'21132','S','Pylesville','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.696302,-76.432946,0,'2013-07-06 12:44:31',NULL,NULL),(21846,'23138','S','Bavon','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.371944,-76.279722,0,'2013-07-06 12:44:31',NULL,NULL),(63210,'75446','S','Honey Grove','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.583513,-95.910691,0,'2013-07-06 12:44:33',NULL,NULL),(68505,'81323','S','Stoner','N','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.455410,-108.516324,0,'2013-07-06 12:44:34',NULL,NULL),(75382,'93943','S','Monterey','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.580963,-121.831768,0,'2013-07-06 12:44:34',NULL,NULL),(32175,'35481','S','Coal Fire','N','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.385953,-88.014060,0,'2013-07-06 12:44:32',NULL,NULL),(79324,'98605','S','Bingen','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.738971,-121.475690,0,'2013-07-06 12:44:34',NULL,NULL),(64841,'77041','S','Jersey Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.857122,-95.572778,0,'2013-07-06 12:44:34',NULL,NULL),(64168,'76226','S','Lantana','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.104830,-97.164815,0,'2013-07-06 12:44:34',NULL,NULL),(44793,'50226','S','Crocker','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.783383,-93.705476,0,'2013-07-06 12:44:32',NULL,NULL),(13127,'13491','S','Unadilla Forks','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.881365,-75.189026,0,'2013-07-06 12:44:30',NULL,NULL),(12445,'12964','S','New Russia','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.147061,-73.607718,0,'2013-07-06 12:44:30',NULL,NULL),(36267,'40336','S','Cobhill','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(9218,'09510','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(55979,'64622','S','Bogard','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.315895,-93.498092,0,'2013-07-06 12:44:33',NULL,NULL),(25208,'28079','S','Indian Trl','N','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.098742,-80.631203,0,'2013-07-06 12:44:31',NULL,NULL),(59784,'71211','P','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.699598,-92.073593,0,'2013-07-06 12:44:33',NULL,NULL),(55533,'63830','S','Caruthersvlle','A','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.185729,-89.658756,0,'2013-07-06 12:44:33',NULL,NULL),(71684,'87512','P','Ventero','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.802991,-105.583675,0,'2013-07-06 12:44:34',NULL,NULL),(77578,'96913','S','Tumon','N','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(33055,'36758','S','Plantersville','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.597755,-86.944319,0,'2013-07-06 12:44:32',NULL,NULL),(11086,'11692','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.590874,-73.796576,0,'2013-07-06 12:44:30',NULL,NULL),(17456,'17945','P','Locustdale','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.692963,-76.260764,0,'2013-07-06 12:44:31',NULL,NULL),(28241,'31054','S','Mc Intyre','D','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.848657,-83.203467,0,'2013-07-06 12:44:31',NULL,NULL),(41736,'47260','S','Medora','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.820298,-86.211748,0,'2013-07-06 12:44:32',NULL,NULL),(56832,'65802','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.212257,-93.306677,0,'2013-07-06 12:44:33',NULL,NULL),(70715,'85282','S','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.390870,-111.925598,0,'2013-07-06 12:44:34',NULL,NULL),(71600,'87321','S','Tinaja','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.135560,-108.505655,0,'2013-07-06 12:44:34',NULL,NULL),(73665,'91521','U','Disney Productions','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.154869,-118.326276,0,'2013-07-06 12:44:34',NULL,NULL),(58073,'68059','S','Springfield','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.068450,-96.150271,0,'2013-07-06 12:44:33',NULL,NULL),(55113,'63334','S','Cyrene','N','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.339811,-91.197015,0,'2013-07-06 12:44:33',NULL,NULL),(4436,'03242','S','Henniker','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.172677,-71.819805,0,'2013-07-06 12:44:30',NULL,NULL),(51396,'59425','S','Conrad','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.169762,-111.949697,0,'2013-07-06 12:44:33',NULL,NULL),(3125,'01240','S','Lenox','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.363117,-73.273909,0,'2013-07-06 12:44:30',NULL,NULL),(34530,'38685','S','Blackwater','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640700,-89.469780,0,'2013-07-06 12:44:32',NULL,NULL),(70472,'84762','P','Duck Creek Village','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.529935,-112.666908,0,'2013-07-06 12:44:34',NULL,NULL),(60919,'72081','S','Providence','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.429280,-91.690920,0,'2013-07-06 12:44:33',NULL,NULL),(77478,'96821','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289359,-157.755003,0,'2013-07-06 12:44:34',NULL,NULL),(75016,'93461','S','Shandon','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.535600,-120.203280,0,'2013-07-06 12:44:34',NULL,NULL),(39788,'45133','S','Allensburg','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(59351,'70560','S','New Iberia','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.003568,-91.819418,0,'2013-07-06 12:44:33',NULL,NULL),(24218,'26714','S','Delray','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.176445,-78.639695,0,'2013-07-06 12:44:31',NULL,NULL),(73548,'91359','P','Thousand Oaks','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.194443,-118.820014,0,'2013-07-06 12:44:34',NULL,NULL),(1737,'00778','S','Urb Llanos de Gurabo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(37675,'42211','S','Rockcastle','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(37446,'41840','S','Fleming Neon','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.212627,-82.707115,0,'2013-07-06 12:44:32',NULL,NULL),(6190,'05481','P','Saint Albans Bay','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.809591,-73.138866,0,'2013-07-06 12:44:30',NULL,NULL),(8574,'08215','S','Egg Hbr City','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(12610,'13084','S','Berwyn','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.887460,-76.119300,0,'2013-07-06 12:44:30',NULL,NULL),(43074,'48197','S','Rawsonville','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.233132,-83.623767,0,'2013-07-06 12:44:32',NULL,NULL),(43433,'48480','P','Grand Blanc','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.925523,-83.632082,0,'2013-07-06 12:44:32',NULL,NULL),(5183,'04441','S','Shirley','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(31641,'34729','P','Montverde','A','Lake','12069','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.620539,-81.711500,0,'2013-07-06 12:44:32',NULL,NULL),(26521,'29201','S','Olympia','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998223,-81.032546,0,'2013-07-06 12:44:31',NULL,NULL),(50061,'57440','S','Spink Colony','N','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.760514,-98.279710,0,'2013-07-06 12:44:33',NULL,NULL),(23372,'25287','S','Lakin','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.930914,-82.072593,0,'2013-07-06 12:44:31',NULL,NULL),(46213,'52765','S','New Liberty','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.727867,-90.862476,0,'2013-07-06 12:44:32',NULL,NULL),(17546,'17978','S','Spring Glen','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.635438,-76.645327,0,'2013-07-06 12:44:31',NULL,NULL),(41437,'46860','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.071141,-85.162544,0,'2013-07-06 12:44:32',NULL,NULL),(64522,'76639','S','Dawson','D','Navarro','48349','Texas','TX','48','0000','254','Central',-6.0,'Y',31.893120,-96.704100,0,'2013-07-06 12:44:34',NULL,NULL),(52741,'61238','S','Weller','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.305313,-90.190486,0,'2013-07-06 12:44:33',NULL,NULL),(40954,'46307','S','Lakes of Four Seasons','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.419705,-87.354291,0,'2013-07-06 12:44:32',NULL,NULL),(56282,'65072','S','Eldon','A','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.292715,-92.713864,0,'2013-07-06 12:44:33',NULL,NULL),(59377,'70598','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.175952,-92.009989,0,'2013-07-06 12:44:33',NULL,NULL),(32634,'36202','P','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.718679,-85.875597,0,'2013-07-06 12:44:32',NULL,NULL),(3325,'01532','S','Northboro','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.316146,-71.648168,0,'2013-07-06 12:44:30',NULL,NULL),(13059,'13440','S','Stanwix Heights','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(40066,'45273','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.101063,-84.514066,0,'2013-07-06 12:44:32',NULL,NULL),(41967,'47420','P','Avoca','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.951522,-86.626391,0,'2013-07-06 12:44:32',NULL,NULL),(44698,'50133','S','Tuskeego','N','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648980,-94.070796,0,'2013-07-06 12:44:32',NULL,NULL),(52000,'60164','S','Northlake','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.924177,-87.889271,0,'2013-07-06 12:44:33',NULL,NULL),(63613,'75831','S','Buffalo','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.461433,-96.074604,0,'2013-07-06 12:44:34',NULL,NULL),(67483,'80229','S','Thornton','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.850200,-104.969880,0,'2013-07-06 12:44:34',NULL,NULL),(75514,'94145','U','Union Bank of California','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794247,-122.400377,0,'2013-07-06 12:44:34',NULL,NULL),(22101,'23417','S','Onancock','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.713408,-75.753403,0,'2013-07-06 12:44:31',NULL,NULL),(50660,'58329','S','San Haven','A','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.815206,-100.062160,0,'2013-07-06 12:44:33',NULL,NULL),(63945,'76082','S','Springtown','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.960236,-97.682574,0,'2013-07-06 12:44:34',NULL,NULL),(67082,'79606','S','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.386800,-99.771092,0,'2013-07-06 12:44:34',NULL,NULL),(68745,'82218','P','Huntley','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.931563,-104.145205,0,'2013-07-06 12:44:34',NULL,NULL),(70113,'84184','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.679483,-111.954813,0,'2013-07-06 12:44:34',NULL,NULL),(5370,'04628','S','Edmunds Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.854149,-67.275517,0,'2013-07-06 12:44:30',NULL,NULL),(76198,'95353','P','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.665412,-120.944142,0,'2013-07-06 12:44:34',NULL,NULL),(66799,'79063','S','Nazareth','D','Castro','48069','Texas','TX','48','0000','806','Central',-6.0,'Y',34.551554,-102.114728,0,'2013-07-06 12:44:34',NULL,NULL),(22735,'24377','S','Tannersville','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.974613,-81.640976,0,'2013-07-06 12:44:31',NULL,NULL),(23848,'26137','S','Tanner','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.002820,-81.073980,0,'2013-07-06 12:44:31',NULL,NULL),(38480,'43656','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.704746,-83.650800,0,'2013-07-06 12:44:32',NULL,NULL),(56610,'65566','S','Viburnum','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.717920,-91.129200,0,'2013-07-06 12:44:33',NULL,NULL),(33576,'37424','P','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.030239,-85.148472,0,'2013-07-06 12:44:32',NULL,NULL),(30180,'33176','S','Palmetto Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(25599,'28451','S','Navassa','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.213760,-78.038355,0,'2013-07-06 12:44:31',NULL,NULL),(16016,'17042','S','Colebrook','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(43581,'48745','S','Mikado','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.577581,-83.456148,0,'2013-07-06 12:44:32',NULL,NULL),(48041,'55309','S','Big Lake','D','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.332043,-93.745422,0,'2013-07-06 12:44:33',NULL,NULL),(50756,'58413','S','Venturia','A','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.036030,-99.371223,0,'2013-07-06 12:44:33',NULL,NULL),(53568,'62056','S','Barnett','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.190380,-89.637780,0,'2013-07-06 12:44:33',NULL,NULL),(61412,'72560','S','Hanover','A','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.867456,-92.123865,0,'2013-07-06 12:44:33',NULL,NULL),(7391,'06784','S','Sherman','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.578039,-73.499079,0,'2013-07-06 12:44:30',NULL,NULL),(58544,'68814','S','Weissert','A','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.329198,-99.326790,0,'2013-07-06 12:44:33',NULL,NULL),(57217,'66442','S','Junction City','A','Geary','20061','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.056640,-96.770220,0,'2013-07-06 12:44:33',NULL,NULL),(46321,'53074','S','Prt Washingtn','A','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.421132,-87.876731,0,'2013-07-06 12:44:32',NULL,NULL),(64723,'76877','S','Harkeyville','N','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.195610,-98.725363,0,'2013-07-06 12:44:34',NULL,NULL),(72926,'90030','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062074,-118.238504,0,'2013-07-06 12:44:34',NULL,NULL),(50016,'57386','S','Yale','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.531154,-97.981398,0,'2013-07-06 12:44:33',NULL,NULL),(15077,'15747','S','Home','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.752433,-79.146315,0,'2013-07-06 12:44:31',NULL,NULL),(27131,'29808','U','Ei Dupont Corp','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.248093,-81.649368,0,'2013-07-06 12:44:31',NULL,NULL),(8029,'07728','S','Georgia','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.243519,-74.277392,0,'2013-07-06 12:44:30',NULL,NULL),(57957,'67756','S','St Francis','N','Cheyenne','20023','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.774780,-101.810400,0,'2013-07-06 12:44:33',NULL,NULL),(19619,'20240','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894680,-77.041752,0,'2013-07-06 12:44:31',NULL,NULL),(41333,'46780','P','Pleasant Mills','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.774016,-84.841633,0,'2013-07-06 12:44:32',NULL,NULL),(57733,'67418','S','Barnard','D','Lincoln','20105','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.178066,-98.098256,0,'2013-07-06 12:44:33',NULL,NULL),(61742,'73034','S','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.697131,-97.433009,0,'2013-07-06 12:44:33',NULL,NULL),(63234,'75470','S','Petty','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.618704,-95.794676,0,'2013-07-06 12:44:33',NULL,NULL),(66798,'79062','S','Morse','D','Hansford','48195','Texas','TX','48','0000','806','Central',-6.0,'Y',36.075797,-101.518203,0,'2013-07-06 12:44:34',NULL,NULL),(69741,'84045','S','Saratoga Springs','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.345179,-111.911529,0,'2013-07-06 12:44:34',NULL,NULL),(79087,'98439','S','JB Lewis McChord','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(14344,'15010','S','Patterson Heights','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.763952,-80.341536,0,'2013-07-06 12:44:31',NULL,NULL),(25669,'28511','S','Atlantic','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.893362,-76.336977,0,'2013-07-06 12:44:31',NULL,NULL),(40912,'46262','U','Huntington Bank','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.893169,-86.181003,0,'2013-07-06 12:44:32',NULL,NULL),(79597,'99037','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.644452,-117.195238,0,'2013-07-06 12:44:34',NULL,NULL),(80155,'99791','P','Atqasuk','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.472212,-157.427665,0,'2013-07-06 12:44:34',NULL,NULL),(44307,'49736','S','Stalwart','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.095000,-84.067020,0,'2013-07-06 12:44:32',NULL,NULL),(36781,'41045','S','Ghent','D','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.738171,-85.060813,0,'2013-07-06 12:44:32',NULL,NULL),(60776,'72018','P','Benton','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.562736,-92.586155,0,'2013-07-06 12:44:33',NULL,NULL),(6055,'05443','S','Bristol','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(15071,'15739','P','Ernest','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.678859,-79.164580,0,'2013-07-06 12:44:31',NULL,NULL),(11869,'12303','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.783122,-73.938595,0,'2013-07-06 12:44:30',NULL,NULL),(37804,'42404','S','Blackfrd','N','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.490563,-87.793465,0,'2013-07-06 12:44:32',NULL,NULL),(26442,'29132','P','Rion','D','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.303731,-81.124142,0,'2013-07-06 12:44:31',NULL,NULL),(26720,'29415','P','North Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.027502,-80.046168,0,'2013-07-06 12:44:31',NULL,NULL),(48312,'55443','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.076111,-93.332500,0,'2013-07-06 12:44:33',NULL,NULL),(45484,'51346','S','Moneta','N','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.183529,-95.478433,0,'2013-07-06 12:44:32',NULL,NULL),(33904,'38047','S','Lenox','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.064558,-89.421360,0,'2013-07-06 12:44:32',NULL,NULL),(27355,'30060','S','Dobbins AFB','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.936824,-84.529346,0,'2013-07-06 12:44:31',NULL,NULL),(25922,'28649','S','Radical','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.321231,-81.188583,0,'2013-07-06 12:44:31',NULL,NULL),(72875,'90009','P','Los Angeles International','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.946348,-118.379884,0,'2013-07-06 12:44:34',NULL,NULL),(75972,'95060','S','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.989018,-122.057824,0,'2013-07-06 12:44:34',NULL,NULL),(40505,'45809','S','Gomer','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.845893,-84.183369,0,'2013-07-06 12:44:32',NULL,NULL),(32011,'35233','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.509765,-86.802918,0,'2013-07-06 12:44:32',NULL,NULL),(26399,'29107','S','Neeses','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.489723,-81.034501,0,'2013-07-06 12:44:31',NULL,NULL),(26418,'29122','P','Peak','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.171834,-81.414509,0,'2013-07-06 12:44:31',NULL,NULL),(69379,'83606','P','Caldwell','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.717644,-116.742415,0,'2013-07-06 12:44:34',NULL,NULL),(57327,'66712','S','Arma','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.566997,-94.729298,0,'2013-07-06 12:44:33',NULL,NULL),(23218,'25081','S','Foster','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.092895,-81.772967,0,'2013-07-06 12:44:31',NULL,NULL),(9698,'10055','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(30643,'33449','S','Village of Wellington','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.607200,-80.233543,0,'2013-07-06 12:44:32',NULL,NULL),(15530,'16550','U','Upmc Hamot','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.133326,-80.087856,0,'2013-07-06 12:44:31',NULL,NULL),(6983,'06244','P','East Woodstock','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.986323,-71.974484,0,'2013-07-06 12:44:30',NULL,NULL),(3655,'02120','S','Roxbury','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.334141,-71.097433,0,'2013-07-06 12:44:30',NULL,NULL),(12989,'13407','S','Paines Hollow','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.991140,-74.980560,0,'2013-07-06 12:44:30',NULL,NULL),(24683,'27411','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.074246,-79.776390,0,'2013-07-06 12:44:31',NULL,NULL),(78315,'97910','S','Rome','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(37779,'42352','S','Livermore','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.496597,-87.125805,0,'2013-07-06 12:44:32',NULL,NULL),(56004,'64647','S','Jameson','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.011109,-93.960000,0,'2013-07-06 12:44:33',NULL,NULL),(53336,'61753','S','Money Creek','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.620011,-88.806012,0,'2013-07-06 12:44:33',NULL,NULL),(48832,'56045','S','Hollandale','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.758613,-93.202523,0,'2013-07-06 12:44:33',NULL,NULL),(46646,'53597','S','Westport','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.181072,-89.450204,0,'2013-07-06 12:44:32',NULL,NULL),(23421,'25356','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.446811,-81.754015,0,'2013-07-06 12:44:31',NULL,NULL),(26415,'29117','U','Orangeburg','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.495205,-80.844399,0,'2013-07-06 12:44:31',NULL,NULL),(74101,'92210','S','Indian Wells','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.715709,-116.334198,0,'2013-07-06 12:44:34',NULL,NULL),(55662,'64029','S','Blue Springs','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.005657,-94.212745,0,'2013-07-06 12:44:33',NULL,NULL),(78786,'98312','S','West Park','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(70438,'84740','P','Junction','D','Piute','49031','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.242270,-112.220822,0,'2013-07-06 12:44:34',NULL,NULL),(63608,'75799','U','University of Texas at Tyler','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.328487,-95.303780,0,'2013-07-06 12:44:34',NULL,NULL),(63050,'75219','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.814032,-96.815005,0,'2013-07-06 12:44:33',NULL,NULL),(46075,'52585','S','Rubio','A','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.182995,-91.991490,0,'2013-07-06 12:44:32',NULL,NULL),(19767,'20419','U','Merit Systems Protection Bd','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902312,-77.031757,0,'2013-07-06 12:44:31',NULL,NULL),(11039,'11570','S','Rockville Ctr','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.665099,-73.637798,0,'2013-07-06 12:44:30',NULL,NULL),(24400,'27107','S','Eller','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.062543,-80.183453,0,'2013-07-06 12:44:31',NULL,NULL),(28821,'32080','S','Saint Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(30092,'33157','S','Palmetto Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(32638,'36204','P','Blue Mountain','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.684768,-85.822124,0,'2013-07-06 12:44:32',NULL,NULL),(43068,'48193','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(12711,'13148','S','Seneca Falls','D','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.920280,-76.784880,0,'2013-07-06 12:44:30',NULL,NULL),(10656,'11104','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.744648,-73.917792,0,'2013-07-06 12:44:30',NULL,NULL),(76466,'95618','S','Davis','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.545000,-121.739444,0,'2013-07-06 12:44:34',NULL,NULL),(61877,'73130','S','Midwest City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.467400,-97.336500,0,'2013-07-06 12:44:33',NULL,NULL),(7430,'06820','S','Tokeneke','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.079898,-73.480707,0,'2013-07-06 12:44:30',NULL,NULL),(64056,'76133','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.652107,-97.377051,0,'2013-07-06 12:44:34',NULL,NULL),(1763,'00780','S','Mans del Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(54527,'62880','S','Frogtown','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.868041,-88.865839,0,'2013-07-06 12:44:33',NULL,NULL),(29283,'32466','S','Youngstown','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.336245,-85.525494,0,'2013-07-06 12:44:32',NULL,NULL),(20129,'20721','S','Mitchellville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.930700,-76.785600,0,'2013-07-06 12:44:31',NULL,NULL),(13077,'13457','P','Schuyler Lake','D','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.779466,-75.026726,0,'2013-07-06 12:44:30',NULL,NULL),(68515,'81328','S','Mancos','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.369314,-108.348608,0,'2013-07-06 12:44:34',NULL,NULL),(7394,'06787','S','Thomaston','D','Litchfield','09005','Connecticut','CT','09','8880','860/959','Eastern',-5.0,'Y',41.655480,-73.099140,0,'2013-07-06 12:44:30',NULL,NULL),(61418,'72565','S','Oxford','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.214720,-91.918823,0,'2013-07-06 12:44:33',NULL,NULL),(20040,'20646','S','Dentsville','A','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.524678,-76.973630,0,'2013-07-06 12:44:31',NULL,NULL),(14835,'15434','P','Elco','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.078597,-79.875182,0,'2013-07-06 12:44:31',NULL,NULL),(24762,'27544','S','Kittrell','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.223160,-78.440172,0,'2013-07-06 12:44:31',NULL,NULL),(8440,'08084','S','Stratford','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.832123,-75.015935,0,'2013-07-06 12:44:30',NULL,NULL),(19669,'20318','U','Joint Staff','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.864971,-77.012219,0,'2013-07-06 12:44:31',NULL,NULL),(2983,'01060','S','Northampton','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.330720,-72.675060,0,'2013-07-06 12:44:30',NULL,NULL),(34865,'38930','S','Greenwood','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.504180,-90.161880,0,'2013-07-06 12:44:32',NULL,NULL),(68552,'81428','S','Paonia','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.895300,-107.587980,0,'2013-07-06 12:44:34',NULL,NULL),(64192,'76244','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.934024,-97.250604,0,'2013-07-06 12:44:34',NULL,NULL),(54571,'62896','S','Plumfield','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(69327,'83522','S','Keuterville','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.023442,-116.268584,0,'2013-07-06 12:44:34',NULL,NULL),(7438,'06831','S','Glenville','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.058575,-73.658439,0,'2013-07-06 12:44:30',NULL,NULL),(76892,'95980','P','Rock Creek','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(72718,'89452','P','Incline Vlg','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.244739,-119.964921,0,'2013-07-06 12:44:34',NULL,NULL),(65213,'77437','S','Taiton','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(62054,'73536','U','Duncan','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.449703,-97.832209,0,'2013-07-06 12:44:33',NULL,NULL),(47732,'55011','S','Cedar','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.348975,-93.246677,0,'2013-07-06 12:44:33',NULL,NULL),(47563,'54838','S','Gordon','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.198672,-91.897453,0,'2013-07-06 12:44:32',NULL,NULL),(46572,'53525','S','Clinton','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.560436,-88.867865,0,'2013-07-06 12:44:32',NULL,NULL),(45492,'51354','S','May City','A','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.415978,-95.533305,0,'2013-07-06 12:44:32',NULL,NULL),(8540,'08201','S','Galloway','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(13901,'14276','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.885680,-78.871160,0,'2013-07-06 12:44:31',NULL,NULL),(28798,'32060','S','Dowling Park','A','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.244980,-83.212850,0,'2013-07-06 12:44:32',NULL,NULL),(16525,'17268','S','Good','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(40663,'46049','S','Kempton','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.290062,-86.230566,0,'2013-07-06 12:44:32',NULL,NULL),(1171,'00727','S','Urb Islabella','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(59958,'71303','S','Magda','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(37150,'41465','S','Maggard','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(57664,'67213','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.669090,-97.361883,0,'2013-07-06 12:44:33',NULL,NULL),(14596,'15223','S','Etna','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.468740,-79.957200,0,'2013-07-06 12:44:31',NULL,NULL),(14402,'15057','S','McDonald','N','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.363602,-80.232468,0,'2013-07-06 12:44:31',NULL,NULL),(20858,'21659','S','Rhodesdale','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.575555,-75.815263,0,'2013-07-06 12:44:31',NULL,NULL),(5703,'04984','S','Temple','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.697633,-70.281549,0,'2013-07-06 12:44:30',NULL,NULL),(51058,'58746','S','Kenaston','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678244,-102.068686,0,'2013-07-06 12:44:33',NULL,NULL),(9289,'09648','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38088,'43076','S','Thornville','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.876048,-82.363065,0,'2013-07-06 12:44:32',NULL,NULL),(6787,'06106','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.746680,-72.696298,0,'2013-07-06 12:44:30',NULL,NULL),(58657,'68875','S','Scotia','D','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.469255,-98.702666,0,'2013-07-06 12:44:33',NULL,NULL),(69698,'84032','S','Center Creek','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(77193,'96343','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75614,'94497','U','San Mateo','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.562555,-122.324828,0,'2013-07-06 12:44:34',NULL,NULL),(78046,'97443','S','Glide','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.275871,-123.073860,0,'2013-07-06 12:44:34',NULL,NULL),(70644,'85172','S','Stanfield','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.884730,-111.960609,0,'2013-07-06 12:44:34',NULL,NULL),(70218,'84403','S','South Ogden','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.178180,-111.963540,0,'2013-07-06 12:44:34',NULL,NULL),(65873,'78219','S','Kirby','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.446920,-98.380980,0,'2013-07-06 12:44:34',NULL,NULL),(52252,'60518','S','Rollo','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.592720,-88.892220,0,'2013-07-06 12:44:33',NULL,NULL),(44349,'49775','S','Pointe Aux Pins','D','Mackinac','26097','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.764363,-84.467304,0,'2013-07-06 12:44:32',NULL,NULL),(25224,'28090','S','Delight','N','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.465460,-81.532440,0,'2013-07-06 12:44:31',NULL,NULL),(5391,'04650','S','Little Deer Isle','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.290418,-68.711631,0,'2013-07-06 12:44:30',NULL,NULL),(76534,'95655','S','Rancho Cordova','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.550396,-121.280814,0,'2013-07-06 12:44:34',NULL,NULL),(60978,'72110','S','Dabney','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(6121,'05458','S','Point Farm','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.717862,-73.300101,0,'2013-07-06 12:44:30',NULL,NULL),(50069,'57445','S','Putney','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.451773,-98.101092,0,'2013-07-06 12:44:33',NULL,NULL),(29885,'33042','S','Sugarlf Shrs','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(65676,'77987','P','Sweet Home','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.240475,-97.068106,0,'2013-07-06 12:44:34',NULL,NULL),(23967,'26296','P','Job','A','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.864167,-79.557222,0,'2013-07-06 12:44:31',NULL,NULL),(68102,'80944','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832646,-104.822595,0,'2013-07-06 12:44:34',NULL,NULL),(56077,'64759','S','Iantha','A','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.493876,-94.271176,0,'2013-07-06 12:44:33',NULL,NULL),(27893,'30467','S','Sylvania','D','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.748470,-81.638522,0,'2013-07-06 12:44:31',NULL,NULL),(28928,'32164','S','Palm Coast','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.532413,-81.230479,0,'2013-07-06 12:44:32',NULL,NULL),(32651,'36251','S','Idaho','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(6105,'05453','P','Essex Junction','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.492901,-73.081591,0,'2013-07-06 12:44:30',NULL,NULL),(16127,'17057','S','Middletown','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(14510,'15202','S','Bellevue','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(2111,'00923','S','Valle Universitario','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(28146,'30823','S','Stapleton','D','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.211040,-82.458438,0,'2013-07-06 12:44:31',NULL,NULL),(11615,'12095','S','Garoga','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.021140,-74.395500,0,'2013-07-06 12:44:30',NULL,NULL),(1650,'00772','S','Jard de Loiza','N','Loiza','72087','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.433938,-65.880795,0,'2013-07-06 12:44:30',NULL,NULL),(55649,'64024','S','Crystal Lakes','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(47822,'55063','S','Chengwatana','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.910278,-92.955000,0,'2013-07-06 12:44:33',NULL,NULL),(31160,'33917','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(1887,'00791','S','Villa Humacao','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(70737,'85307','S','Luke AFB','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538998,-112.347366,0,'2013-07-06 12:44:34',NULL,NULL),(51381,'59412','S','Belt','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.371142,-110.903119,0,'2013-07-06 12:44:33',NULL,NULL),(69463,'83652','P','Nampa','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.707330,-116.621299,0,'2013-07-06 12:44:34',NULL,NULL),(67458,'80215','S','Wheat Ridge','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745057,-105.104454,0,'2013-07-06 12:44:34',NULL,NULL),(53214,'61629','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.692997,-89.593053,0,'2013-07-06 12:44:33',NULL,NULL),(44909,'50328','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582091,-93.637951,0,'2013-07-06 12:44:32',NULL,NULL),(35643,'39638','S','White Cap','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(20152,'20736','S','Owings','D','Calvert','24009','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.698789,-76.617409,0,'2013-07-06 12:44:31',NULL,NULL),(39124,'44264','S','Peninsula','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.232420,-81.553757,0,'2013-07-06 12:44:32',NULL,NULL),(41082,'46534','S','Bass Lake','N','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.299044,-86.616720,0,'2013-07-06 12:44:32',NULL,NULL),(1177,'00727','S','Urb Turabo Gdns','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(41379,'46796','P','Wolflake','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.335013,-85.494767,0,'2013-07-06 12:44:32',NULL,NULL),(12234,'12816','S','Coila','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.040880,-73.380600,0,'2013-07-06 12:44:30',NULL,NULL),(55338,'63556','S','Bairdtown','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(54137,'62563','S','Buckhart','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748414,-89.542262,0,'2013-07-06 12:44:33',NULL,NULL),(22910,'24605','S','Bluefield','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.263360,-81.288780,0,'2013-07-06 12:44:31',NULL,NULL),(55566,'63869','S','New Madrid','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.594000,-89.558640,0,'2013-07-06 12:44:33',NULL,NULL),(55948,'64484','S','Winthrop','N','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.587737,-95.016396,0,'2013-07-06 12:44:33',NULL,NULL),(48313,'55444','S','Brooklyn Center','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.088050,-93.296289,0,'2013-07-06 12:44:33',NULL,NULL),(13902,'14276','U','Scoreball','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.885680,-78.871160,0,'2013-07-06 12:44:31',NULL,NULL),(25507,'28378','P','Rex','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.853450,-79.050019,0,'2013-07-06 12:44:31',NULL,NULL),(15728,'16879','S','Winburne','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.969762,-78.160371,0,'2013-07-06 12:44:31',NULL,NULL),(5741,'05035','S','Bridgewater Center','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(33995,'38117','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.115970,-89.901902,0,'2013-07-06 12:44:32',NULL,NULL),(17922,'18463','S','Sterling','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.355750,-75.353736,0,'2013-07-06 12:44:31',NULL,NULL),(18830,'19422','S','Blue Bell','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.152960,-75.274659,0,'2013-07-06 12:44:31',NULL,NULL),(9949,'10156','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(11669,'12143','S','Ravena','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.471720,-73.820415,0,'2013-07-06 12:44:30',NULL,NULL),(65287,'77486','S','East Columbia','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.142060,-95.665560,0,'2013-07-06 12:44:34',NULL,NULL),(60553,'71731','P','El Dorado','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.209369,-92.666930,0,'2013-07-06 12:44:33',NULL,NULL),(19781,'20426','U','Federal Energy Reg Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901696,-77.005988,0,'2013-07-06 12:44:31',NULL,NULL),(4984,'04116','P','S Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.659977,-70.267197,0,'2013-07-06 12:44:30',NULL,NULL),(26785,'29451','S','Isle of Palms','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.795877,-79.769665,0,'2013-07-06 12:44:31',NULL,NULL),(54683,'62943','S','Ganntown','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(16926,'17604','P','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.099859,-76.278485,0,'2013-07-06 12:44:31',NULL,NULL),(49984,'57364','S','New Holland','D','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.438098,-98.647921,0,'2013-07-06 12:44:33',NULL,NULL),(26265,'29010','S','Ashland','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(13464,'13783','S','Hancock','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(60552,'71730','S','El Dorado','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.214492,-92.664791,0,'2013-07-06 12:44:33',NULL,NULL),(47452,'54729','S','Eagle Point','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(13728,'14094','S','Pendleton','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.164900,-78.702480,0,'2013-07-06 12:44:31',NULL,NULL),(6084,'05450','S','Enosburg','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(5648,'04954','P','N New Portlnd','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.883149,-70.088461,0,'2013-07-06 12:44:30',NULL,NULL),(34450,'38652','S','Wallerville','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(34681,'38824','S','Kirkville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(37821,'42437','S','Boxville','N','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(39184,'44317','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.045074,-81.526198,0,'2013-07-06 12:44:32',NULL,NULL),(7743,'07304','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.718014,-74.075125,0,'2013-07-06 12:44:30',NULL,NULL),(71012,'85724','U','Arizona Medical Center','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.245835,-110.944450,0,'2013-07-06 12:44:34',NULL,NULL),(72119,'88255','P','Loco Hills','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.818534,-103.978209,0,'2013-07-06 12:44:34',NULL,NULL),(29273,'32461','P','Alys Beach','A','Walton','12131','Florida','FL','12','6015','850','Central',-6.0,'Y',30.251077,-85.950567,0,'2013-07-06 12:44:32',NULL,NULL),(58244,'68357','S','Filley','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.304907,-96.519067,0,'2013-07-06 12:44:33',NULL,NULL),(4214,'02837','S','Little Compton','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.511254,-71.170707,0,'2013-07-06 12:44:30',NULL,NULL),(21915,'23220','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.553206,-77.456383,0,'2013-07-06 12:44:31',NULL,NULL),(1203,'00728','S','Parc Nuevas Magueyes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(67695,'80521','S','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.584979,-105.114124,0,'2013-07-06 12:44:34',NULL,NULL),(63265,'75497','S','Yantis','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.891648,-95.532085,0,'2013-07-06 12:44:33',NULL,NULL),(45735,'52101','S','Freeport','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(34210,'38348','S','Lavinia','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.864377,-88.649514,0,'2013-07-06 12:44:32',NULL,NULL),(35534,'39558','P','Clermont Hbr','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.241870,-89.434728,0,'2013-07-06 12:44:32',NULL,NULL),(24973,'27849','S','Lewiston','A','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.088260,-77.229660,0,'2013-07-06 12:44:31',NULL,NULL),(21833,'23117','S','Mineral','D','Louisa','51109','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.837624,-77.976633,0,'2013-07-06 12:44:31',NULL,NULL),(40664,'46050','S','Kirklin','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.194024,-86.358834,0,'2013-07-06 12:44:32',NULL,NULL),(2565,'00959','S','Urb San Rafael Est','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(5500,'04760','S','Monticello','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.308896,-67.841826,0,'2013-07-06 12:44:30',NULL,NULL),(51455,'59486','S','Valier','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.306088,-112.253949,0,'2013-07-06 12:44:33',NULL,NULL),(77551,'96859','S','Tripler Army Medical Center','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.347002,-157.872476,0,'2013-07-06 12:44:34',NULL,NULL),(42508,'47847','S','Helt','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.807913,-87.490923,0,'2013-07-06 12:44:32',NULL,NULL),(50573,'58224','S','Dahlen','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.168809,-97.966760,0,'2013-07-06 12:44:33',NULL,NULL),(50557,'58207','U','Gfafb Postal Service Center','N','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.916740,-97.367273,0,'2013-07-06 12:44:33',NULL,NULL),(24288,'27006','S','Hillsdale','N','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(13960,'14469','S','Bloomfield','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.877952,-77.456375,0,'2013-07-06 12:44:31',NULL,NULL),(12337,'12871','S','Schuylerville','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.088460,-73.622760,0,'2013-07-06 12:44:30',NULL,NULL),(71623,'87365','P','Smith Lake','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.775009,-107.989424,0,'2013-07-06 12:44:34',NULL,NULL),(34863,'38930','S','Avalon','A','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.504180,-90.161880,0,'2013-07-06 12:44:32',NULL,NULL),(6612,'05873','S','Joes Pond','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.445900,-72.224520,0,'2013-07-06 12:44:30',NULL,NULL),(11631,'12117','S','Mayfield','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.102843,-74.263232,0,'2013-07-06 12:44:30',NULL,NULL),(32412,'35968','S','Fort Payne','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.441634,-85.719381,0,'2013-07-06 12:44:32',NULL,NULL),(41602,'47112','S','Corydon','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.207724,-86.127597,0,'2013-07-06 12:44:32',NULL,NULL),(28047,'30663','S','Rutledge','D','Morgan','13211','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.615881,-83.607221,0,'2013-07-06 12:44:31',NULL,NULL),(4733,'03832','P','Eaton','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.911744,-71.083715,0,'2013-07-06 12:44:30',NULL,NULL),(55268,'63462','S','Green Lawn','N','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.429064,-91.669127,0,'2013-07-06 12:44:33',NULL,NULL),(45966,'52361','S','Williamsburg','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.661523,-92.015230,0,'2013-07-06 12:44:32',NULL,NULL),(44151,'49525','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.012830,-85.601883,0,'2013-07-06 12:44:32',NULL,NULL),(20639,'21220','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.342626,-76.412643,0,'2013-07-06 12:44:31',NULL,NULL),(49458,'56649','S','Intl Falls','A','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.582200,-93.411492,0,'2013-07-06 12:44:33',NULL,NULL),(66295,'78585','P','Salineno','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.581894,-98.989067,0,'2013-07-06 12:44:34',NULL,NULL),(73790,'91747','P','La Puente','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.023217,-117.947994,0,'2013-07-06 12:44:34',NULL,NULL),(27490,'30162','P','Rome','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.246306,-85.127709,0,'2013-07-06 12:44:31',NULL,NULL),(61745,'73039','P','Davis','D','Murray','40099','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.614900,-97.491100,0,'2013-07-06 12:44:33',NULL,NULL),(7600,'07044','S','Verona','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.833949,-74.245427,0,'2013-07-06 12:44:30',NULL,NULL),(26964,'29610','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.931778,-82.471944,0,'2013-07-06 12:44:31',NULL,NULL),(37565,'42071','S','Shiloh','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(37294,'41631','S','Grethel','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.455430,-82.735217,0,'2013-07-06 12:44:32',NULL,NULL),(53736,'62252','P','Clement','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.604272,-89.290238,0,'2013-07-06 12:44:33',NULL,NULL),(19754,'20412','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892284,-77.020518,0,'2013-07-06 12:44:31',NULL,NULL),(55368,'63566','S','Winigan','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.041679,-92.929334,0,'2013-07-06 12:44:33',NULL,NULL),(43063,'48190','P','Whittaker','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.126163,-83.593877,0,'2013-07-06 12:44:32',NULL,NULL),(22009,'23285','P','Richmnd','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.538327,-77.435822,0,'2013-07-06 12:44:31',NULL,NULL),(28490,'31520','S','Sears','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.178679,-81.489022,0,'2013-07-06 12:44:32',NULL,NULL),(4736,'03833','S','Brentwood','A','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.977520,-70.992300,0,'2013-07-06 12:44:30',NULL,NULL),(35415,'39466','S','Industrial','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(18214,'18954','S','Southampton','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.216524,-75.002295,0,'2013-07-06 12:44:31',NULL,NULL),(33573,'37422','P','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.141047,-85.348656,0,'2013-07-06 12:44:32',NULL,NULL),(2671,'00966','S','Urb Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(42194,'47547','P','Jasper','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.420527,-86.963204,0,'2013-07-06 12:44:32',NULL,NULL),(56836,'65806','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.203058,-93.297901,0,'2013-07-06 12:44:33',NULL,NULL),(54738,'62970','S','Olmsted','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.210434,-89.098545,0,'2013-07-06 12:44:33',NULL,NULL),(44566,'50021','S','Ankeny','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.724091,-93.609680,0,'2013-07-06 12:44:32',NULL,NULL),(59579,'70894','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.415846,-91.177469,0,'2013-07-06 12:44:33',NULL,NULL),(79194,'98532','S','Chehalis','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(77802,'97138','S','Elsie','N','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.001224,-123.921677,0,'2013-07-06 12:44:34',NULL,NULL),(71274,'86432','P','Littlefield','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',36.883333,-113.933333,0,'2013-07-06 12:44:34',NULL,NULL),(59262,'70448','S','Mandeville','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.366783,-90.034817,0,'2013-07-06 12:44:33',NULL,NULL),(49759,'57066','S','Tyndall','D','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.989816,-97.860137,0,'2013-07-06 12:44:33',NULL,NULL),(24571,'27312','S','Fearrington','A','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.765336,-79.136415,0,'2013-07-06 12:44:31',NULL,NULL),(27740,'30355','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.835447,-84.366399,0,'2013-07-06 12:44:31',NULL,NULL),(28281,'31088','S','Warner Robins','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.595758,-83.638378,0,'2013-07-06 12:44:31',NULL,NULL),(31722,'34972','S','Yeehaw Junction','A','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.325224,-80.849484,0,'2013-07-06 12:44:32',NULL,NULL),(11499,'12024','S','Brainard','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.482968,-73.534390,0,'2013-07-06 12:44:30',NULL,NULL),(15205,'15961','S','Vintondale','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.477503,-78.908359,0,'2013-07-06 12:44:31',NULL,NULL),(38570,'43779','S','Sarahsville','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.814019,-81.441843,0,'2013-07-06 12:44:32',NULL,NULL),(17734,'18255','S','Weatherly','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.944377,-75.829049,0,'2013-07-06 12:44:31',NULL,NULL),(49955,'57346','S','Stephan','D','Hyde','46069','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.249295,-99.452534,0,'2013-07-06 12:44:33',NULL,NULL),(31812,'35055','S','Dodge City','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.174036,-86.843648,0,'2013-07-06 12:44:32',NULL,NULL),(46493,'53226','S','Wauwatosa','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.047262,-88.044347,0,'2013-07-06 12:44:32',NULL,NULL),(43106,'48220','S','Detroit','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458803,-83.138618,0,'2013-07-06 12:44:32',NULL,NULL),(49088,'56330','S','Foreston','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.759384,-93.777218,0,'2013-07-06 12:44:33',NULL,NULL),(78661,'98232','S','Bow','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.562380,-122.444940,0,'2013-07-06 12:44:34',NULL,NULL),(54538,'62884','S','Goode','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.090961,-89.049578,0,'2013-07-06 12:44:33',NULL,NULL),(79736,'99218','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.752457,-117.412302,0,'2013-07-06 12:44:34',NULL,NULL),(77743,'97086','S','Clackamas','A','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.443245,-122.514694,0,'2013-07-06 12:44:34',NULL,NULL),(62930,'75089','S','Rowlett','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.933137,-96.556218,0,'2013-07-06 12:44:33',NULL,NULL),(54754,'62984','S','Bowlesville','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.715092,-88.188836,0,'2013-07-06 12:44:33',NULL,NULL),(53353,'61764','S','Eppards Point','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(45558,'51502','P','Co Bluffs','N','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.261393,-95.849876,0,'2013-07-06 12:44:32',NULL,NULL),(44765,'50207','S','Taintor','A','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.467705,-92.649644,0,'2013-07-06 12:44:32',NULL,NULL),(44620,'50061','S','Orillia','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.489268,-93.753860,0,'2013-07-06 12:44:32',NULL,NULL),(20266,'20785','S','Ardmore','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(36051,'40207','S','Brownsboro Village','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(37667,'42211','S','Donaldson','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(41834,'47345','S','Greens Fork','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.896372,-85.052265,0,'2013-07-06 12:44:32',NULL,NULL),(19412,'20081','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899462,-77.026641,0,'2013-07-06 12:44:31',NULL,NULL),(20905,'21717','P','Buckeystown','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.314542,-77.441873,0,'2013-07-06 12:44:31',NULL,NULL),(28205,'31026','U','Eatonton','D','Putnam','13237','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.303533,-83.377912,0,'2013-07-06 12:44:31',NULL,NULL),(5644,'04951','S','Monroe','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.591373,-69.042303,0,'2013-07-06 12:44:30',NULL,NULL),(22988,'24747','S','Duhring','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.389223,-81.233084,0,'2013-07-06 12:44:31',NULL,NULL),(67622,'80440','S','Fairplay','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.207943,-106.001520,0,'2013-07-06 12:44:34',NULL,NULL),(16002,'17038','S','Jonestwn','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.410665,-76.486339,0,'2013-07-06 12:44:31',NULL,NULL),(78815,'98332','S','Gig Harbor','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.358119,-122.594158,0,'2013-07-06 12:44:34',NULL,NULL),(78201,'97738','S','Hines','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.564589,-119.080532,0,'2013-07-06 12:44:34',NULL,NULL),(76343,'95471','P','Rio Nido','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.522828,-122.980653,0,'2013-07-06 12:44:34',NULL,NULL),(71356,'86535','P','Teec Nos Pos','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.741436,-109.852610,0,'2013-07-06 12:44:34',NULL,NULL),(67693,'80520','P','Firestone','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.109830,-104.934680,0,'2013-07-06 12:44:34',NULL,NULL),(67211,'79917','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.706371,-106.325020,0,'2013-07-06 12:44:34',NULL,NULL),(61813,'73104','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.474590,-97.505034,0,'2013-07-06 12:44:33',NULL,NULL),(58914,'69333','S','Ashby','D','Grant','31075','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.908275,-101.952587,0,'2013-07-06 12:44:33',NULL,NULL),(30936,'33713','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.788397,-82.674456,0,'2013-07-06 12:44:32',NULL,NULL),(31829,'35073','S','Alden','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.621087,-86.958247,0,'2013-07-06 12:44:32',NULL,NULL),(35265,'39359','P','Sebastopol','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.570670,-89.332385,0,'2013-07-06 12:44:32',NULL,NULL),(35309,'39404','P','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.296391,-89.429287,0,'2013-07-06 12:44:32',NULL,NULL),(29800,'33023','S','Miramar','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(25945,'28657','S','Altamont','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(67532,'80256','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.750699,-104.989735,0,'2013-07-06 12:44:34',NULL,NULL),(67747,'80611','S','Briggsdale','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.636008,-104.347130,0,'2013-07-06 12:44:34',NULL,NULL),(57763,'67451','S','Navarre','A','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.679420,-97.107720,0,'2013-07-06 12:44:33',NULL,NULL),(52811,'61281','S','Cable','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.312272,-90.493734,0,'2013-07-06 12:44:33',NULL,NULL),(46565,'53516','S','Blanchardvlle','A','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.784010,-89.902654,0,'2013-07-06 12:44:32',NULL,NULL),(4470,'03262','S','N Woodstock','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.033209,-71.687240,0,'2013-07-06 12:44:30',NULL,NULL),(20329,'20842','S','Comus','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.204180,-77.421720,0,'2013-07-06 12:44:31',NULL,NULL),(72399,'89043','S','Eagle Valley','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(73021,'90070','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062440,-118.310436,0,'2013-07-06 12:44:34',NULL,NULL),(78388,'98028','S','Kenmore','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.750000,-122.240000,0,'2013-07-06 12:44:34',NULL,NULL),(51171,'59007','S','Bearcreek','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.161087,-109.156095,0,'2013-07-06 12:44:33',NULL,NULL),(50910,'58554','S','Saint Anthony','A','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.828248,-100.892053,0,'2013-07-06 12:44:33',NULL,NULL),(46795,'54001','S','Amery','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(42655,'47948','S','Goodland','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.766143,-87.293377,0,'2013-07-06 12:44:32',NULL,NULL),(9857,'10119','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(5423,'04669','S','Prospect Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.422425,-68.036636,0,'2013-07-06 12:44:30',NULL,NULL),(17393,'17901','S','Duncott','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(6945,'06180','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757571,-72.764720,0,'2013-07-06 12:44:30',NULL,NULL),(35945,'40057','S','Defoe','A','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.369196,-85.063919,0,'2013-07-06 12:44:32',NULL,NULL),(65658,'77979','S','Green Lake','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(71828,'87577','P','Tres Piedras','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.637988,-105.845102,0,'2013-07-06 12:44:34',NULL,NULL),(59790,'71219','S','Baskin','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.316337,-91.687881,0,'2013-07-06 12:44:33',NULL,NULL),(79684,'99179','S','Uniontown','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.538566,-117.088019,0,'2013-07-06 12:44:34',NULL,NULL),(19728,'20398','S','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876127,-76.994243,0,'2013-07-06 12:44:31',NULL,NULL),(46156,'52722','S','Bettendorf','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.567220,-90.462000,0,'2013-07-06 12:44:32',NULL,NULL),(69191,'83341','S','Kimberly','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.542008,-114.362786,0,'2013-07-06 12:44:34',NULL,NULL),(78320,'97911','S','Juntura','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.745601,-118.076327,0,'2013-07-06 12:44:34',NULL,NULL),(16233,'17075','P','Newton Hamltn','A','Mifflin','42087','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.393403,-77.835133,0,'2013-07-06 12:44:31',NULL,NULL),(56779,'65747','S','Shell Knob','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.617100,-93.627780,0,'2013-07-06 12:44:33',NULL,NULL),(53871,'62343','S','Hull','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.720145,-91.262764,0,'2013-07-06 12:44:33',NULL,NULL),(45659,'52003','S','Dubuque','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.466529,-90.686748,0,'2013-07-06 12:44:32',NULL,NULL),(44139,'49515','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.962887,-85.654539,0,'2013-07-06 12:44:32',NULL,NULL),(43158,'48264','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.329958,-83.045066,0,'2013-07-06 12:44:32',NULL,NULL),(33450,'37315','P','Collegedale','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.047840,-85.047590,0,'2013-07-06 12:44:32',NULL,NULL),(24834,'27612','S','Duraleigh','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.856914,-78.689606,0,'2013-07-06 12:44:31',NULL,NULL),(24573,'27312','S','Pittsboro','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.765336,-79.136415,0,'2013-07-06 12:44:31',NULL,NULL),(17134,'17778','S','Cooks Run','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.309029,-77.972308,0,'2013-07-06 12:44:31',NULL,NULL),(41005,'46365','S','Mill Creek','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.597919,-86.549243,0,'2013-07-06 12:44:32',NULL,NULL),(8983,'08831','S','Monroe','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.350085,-74.441445,0,'2013-07-06 12:44:30',NULL,NULL),(6574,'05855','S','Lake Park','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(73627,'91410','P','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203639,-118.492923,0,'2013-07-06 12:44:34',NULL,NULL),(77784,'97127','S','Lafayette','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.245825,-123.113634,0,'2013-07-06 12:44:34',NULL,NULL),(26856,'29527','S','Bucksport','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.745620,-79.074900,0,'2013-07-06 12:44:31',NULL,NULL),(31208,'33950','S','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.912326,-82.046888,0,'2013-07-06 12:44:32',NULL,NULL),(39745,'45101','S','Aberdeen','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.679427,-83.750546,0,'2013-07-06 12:44:32',NULL,NULL),(62750,'74844','P','Francis','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.873807,-96.591929,0,'2013-07-06 12:44:33',NULL,NULL),(55130,'63346','P','Flinthill','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.855883,-90.865770,0,'2013-07-06 12:44:33',NULL,NULL),(8034,'07731','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.147323,-74.206531,0,'2013-07-06 12:44:30',NULL,NULL),(24785,'27573','S','Roxboro','D','Person','37145','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.393107,-78.985483,0,'2013-07-06 12:44:31',NULL,NULL),(78553,'98148','S','Normandy Park','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.425051,-122.332127,0,'2013-07-06 12:44:34',NULL,NULL),(66210,'78550','S','HGN','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(64463,'76574','S','Noack','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(62693,'74730','S','Calera','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.936330,-96.430353,0,'2013-07-06 12:44:33',NULL,NULL),(27125,'29801','S','Vaucluse','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.564827,-81.709984,0,'2013-07-06 12:44:31',NULL,NULL),(11168,'11726','S','Marconiville','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.680826,-73.393642,0,'2013-07-06 12:44:30',NULL,NULL),(30673,'33469','S','Jupiter','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.960459,-80.098465,0,'2013-07-06 12:44:32',NULL,NULL),(31660,'34747','S','Celebration','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.297785,-81.613279,0,'2013-07-06 12:44:32',NULL,NULL),(64412,'76548','S','Harker Heights','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.116944,-97.727500,0,'2013-07-06 12:44:34',NULL,NULL),(73214,'90621','S','Buena Park','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.877168,-117.989269,0,'2013-07-06 12:44:34',NULL,NULL),(351,'00656','S','Urb Santa Maria','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(60404,'71638','S','Collins','A','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(29741,'32966','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.637794,-80.475396,0,'2013-07-06 12:44:32',NULL,NULL),(17631,'18056','S','Hereford','D','Berks','42011','Pennsylvania','PA','42','6680','215/267','Eastern',-5.0,'Y',40.410555,-75.761626,0,'2013-07-06 12:44:31',NULL,NULL),(62253,'74004','U','Phillips 66','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.739762,-95.948625,0,'2013-07-06 12:44:33',NULL,NULL),(21666,'22947','S','Cismont','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(26845,'29506','S','Quinby','A','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.209900,-79.734120,0,'2013-07-06 12:44:31',NULL,NULL),(26501,'29169','S','Springdale','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(52014,'60174','S','Saint Charles','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.922012,-88.304234,0,'2013-07-06 12:44:33',NULL,NULL),(14595,'15222','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.448765,-79.991418,0,'2013-07-06 12:44:31',NULL,NULL),(68472,'81241','P','Pitkin','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.609178,-106.515547,0,'2013-07-06 12:44:34',NULL,NULL),(50236,'57622','S','Cherry Creek','D','Ziebach','46137','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.611279,-101.796280,0,'2013-07-06 12:44:33',NULL,NULL),(53734,'62249','S','Highland','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.792100,-89.687580,0,'2013-07-06 12:44:33',NULL,NULL),(50272,'57644','S','Coal Springs','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.291739,-102.295248,0,'2013-07-06 12:44:33',NULL,NULL),(30793,'33604','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.015177,-82.457644,0,'2013-07-06 12:44:32',NULL,NULL),(15967,'17029','S','Anderson','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.546874,-77.604665,0,'2013-07-06 12:44:31',NULL,NULL),(39942,'45230','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.078715,-84.377216,0,'2013-07-06 12:44:32',NULL,NULL),(41304,'46769','P','Berne','A','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.644448,-85.031233,0,'2013-07-06 12:44:32',NULL,NULL),(26052,'28688','P','Turnersburg','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.830740,-80.898404,0,'2013-07-06 12:44:31',NULL,NULL),(46658,'53706','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.072821,-89.410573,0,'2013-07-06 12:44:32',NULL,NULL),(39337,'44617','P','Charm','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.506035,-81.784473,0,'2013-07-06 12:44:32',NULL,NULL),(30018,'33133','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.733767,-80.241942,0,'2013-07-06 12:44:32',NULL,NULL),(49836,'57226','S','Tunnerville','N','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.758347,-96.683015,0,'2013-07-06 12:44:33',NULL,NULL),(3179,'01337','S','Bernardston','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.689880,-72.583740,0,'2013-07-06 12:44:30',NULL,NULL),(68315,'81102','U','Adams State College','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.471930,-105.861118,0,'2013-07-06 12:44:34',NULL,NULL),(24004,'26348','S','Folsom','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.468173,-80.526646,0,'2013-07-06 12:44:31',NULL,NULL),(43168,'48269','U','DTE Energy Brm','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.328906,-83.045858,0,'2013-07-06 12:44:32',NULL,NULL),(12509,'13026','S','Ledyard','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.743286,-76.652204,0,'2013-07-06 12:44:30',NULL,NULL),(16187,'17068','S','New Bloomfield','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.418905,-77.189502,0,'2013-07-06 12:44:31',NULL,NULL),(49771,'57070','S','Hooker','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.189920,-97.116960,0,'2013-07-06 12:44:33',NULL,NULL),(60809,'72031','S','Rupert','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(44375,'49791','P','Topinabee','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.485724,-84.596255,0,'2013-07-06 12:44:32',NULL,NULL),(45464,'51246','S','Rock Rapids','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.422060,-96.248040,0,'2013-07-06 12:44:32',NULL,NULL),(15987,'17033','S','Union Deposit','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(78934,'98366','S','S Park Vlg','A','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(13214,'13632','P','Depauville','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.140916,-76.063848,0,'2013-07-06 12:44:30',NULL,NULL),(14620,'15229','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.517677,-80.040063,0,'2013-07-06 12:44:31',NULL,NULL),(544,'00676','S','Villa Deloamit','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(22430,'24013','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.265503,-79.928798,0,'2013-07-06 12:44:31',NULL,NULL),(53629,'62094','S','Witt','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.258265,-89.347637,0,'2013-07-06 12:44:33',NULL,NULL),(33149,'36922','S','Ward','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.361718,-88.277930,0,'2013-07-06 12:44:32',NULL,NULL),(162,'00622','S','Boqueron','D','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.017976,-67.170627,0,'2013-07-06 12:44:30',NULL,NULL),(8879,'08701','S','Lakewood','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.084328,-74.203837,0,'2013-07-06 12:44:30',NULL,NULL),(78963,'98370','S','Scandia','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(48796,'56007','S','Albert Lea','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.650835,-93.371347,0,'2013-07-06 12:44:33',NULL,NULL),(31883,'35127','S','Pleasant Grv','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489447,-86.973348,0,'2013-07-06 12:44:32',NULL,NULL),(39068,'44203','S','Barberton','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.014711,-81.614500,0,'2013-07-06 12:44:32',NULL,NULL),(72844,'89835','S','Metropolis','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(19875,'20529','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895138,-77.036621,0,'2013-07-06 12:44:31',NULL,NULL),(28622,'31720','P','Barwick','D','Brooks','13027','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.899369,-83.740513,0,'2013-07-06 12:44:32',NULL,NULL),(17749,'18324','S','Bushkill','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.166175,-74.955517,0,'2013-07-06 12:44:31',NULL,NULL),(7833,'07460','S','Stockholm','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(77665,'97026','S','Gervais','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.112684,-122.921660,0,'2013-07-06 12:44:34',NULL,NULL),(77276,'96610','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(29412,'32648','S','Horseshoe Bch','A','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.554006,-83.254234,0,'2013-07-06 12:44:32',NULL,NULL),(25868,'28631','S','Sussex','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.547139,-81.434483,0,'2013-07-06 12:44:31',NULL,NULL),(35150,'39225','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291456,-90.183510,0,'2013-07-06 12:44:32',NULL,NULL),(61303,'72426','P','Dell','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.855661,-90.045048,0,'2013-07-06 12:44:33',NULL,NULL),(51929,'60119','S','Elburn','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.881407,-88.488714,0,'2013-07-06 12:44:33',NULL,NULL),(49757,'57065','S','Trent','D','Moody','46101','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.888752,-96.608927,0,'2013-07-06 12:44:33',NULL,NULL),(24527,'27288','S','Meadow Summit','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(36572,'40940','S','Frakes','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.629745,-83.888424,0,'2013-07-06 12:44:32',NULL,NULL),(16953,'17702','S','Armstrong','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(27946,'30537','S','Sky Valley','A','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.981080,-83.381580,0,'2013-07-06 12:44:31',NULL,NULL),(72365,'89027','S','Mesquite','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.810333,-114.077791,0,'2013-07-06 12:44:34',NULL,NULL),(25414,'28301','S','E Fayettevill','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(11187,'11735','S','E Farmingdale','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.725297,-73.444737,0,'2013-07-06 12:44:30',NULL,NULL),(22979,'24736','S','Giatto','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.419663,-81.244363,0,'2013-07-06 12:44:31',NULL,NULL),(22893,'24588','S','Rustburg','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.295271,-79.148504,0,'2013-07-06 12:44:31',NULL,NULL),(33719,'37802','P','Maryville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.756806,-83.970335,0,'2013-07-06 12:44:32',NULL,NULL),(47889,'55105','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.936784,-93.164881,0,'2013-07-06 12:44:33',NULL,NULL),(71467,'87059','S','Chilili','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.015760,-106.279680,0,'2013-07-06 12:44:34',NULL,NULL),(45312,'50841','S','Corning','D','Adams','19003','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.004900,-94.742880,0,'2013-07-06 12:44:32',NULL,NULL),(8918,'08742','S','Point Pleasant Beach','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(54609,'62910','S','Unionville','N','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.125868,-88.629383,0,'2013-07-06 12:44:33',NULL,NULL),(59763,'71163','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.507808,-93.744894,0,'2013-07-06 12:44:33',NULL,NULL),(26191,'28766','S','Penrose','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.282903,-82.658439,0,'2013-07-06 12:44:31',NULL,NULL),(2419,'00953','S','Mans de Montecasino I','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(44304,'49735','S','Treetops Vil','A','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.987952,-84.675724,0,'2013-07-06 12:44:32',NULL,NULL),(30509,'33403','S','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(73595,'91387','S','Fair Oaks Ranch','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425030,-118.444260,0,'2013-07-06 12:44:34',NULL,NULL),(70994,'85712','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.253883,-110.884936,0,'2013-07-06 12:44:34',NULL,NULL),(65789,'78121','S','Lavernia','A','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.336135,-98.095702,0,'2013-07-06 12:44:34',NULL,NULL),(33408,'37232','U','Vanderbilt Hospital','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.142857,-86.807356,0,'2013-07-06 12:44:32',NULL,NULL),(33721,'37804','S','Maryville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.775122,-83.939035,0,'2013-07-06 12:44:32',NULL,NULL),(49733,'57049','S','McCook Lake','A','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.528060,-96.503280,0,'2013-07-06 12:44:33',NULL,NULL),(34239,'38381','S','Toone','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.363456,-88.937564,0,'2013-07-06 12:44:32',NULL,NULL),(26034,'28681','S','Liledown','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(43246,'48318','P','Shelby Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.624463,-83.033255,0,'2013-07-06 12:44:32',NULL,NULL),(8798,'08603','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220508,-74.765264,0,'2013-07-06 12:44:30',NULL,NULL),(42205,'47552','S','Lincoln Boyhood Natl Mem','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.129410,-86.988319,0,'2013-07-06 12:44:32',NULL,NULL),(40964,'46320','S','Hammond','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.613152,-87.504662,0,'2013-07-06 12:44:32',NULL,NULL),(62338,'74054','S','Osage','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.294059,-96.383486,0,'2013-07-06 12:44:33',NULL,NULL),(67563,'80291','U','Wells Fargo Bank','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.743207,-104.985884,0,'2013-07-06 12:44:34',NULL,NULL),(63202,'75437','S','Dike','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192096,-95.466019,0,'2013-07-06 12:44:33',NULL,NULL),(2402,'00952','S','Sabana Seca','D','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.423816,-66.184972,0,'2013-07-06 12:44:30',NULL,NULL),(19487,'20151','S','Fairfax','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.888306,-77.453725,0,'2013-07-06 12:44:31',NULL,NULL),(36554,'40906','S','Woollum','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(12531,'13035','S','Nelson','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968760,-75.820020,0,'2013-07-06 12:44:30',NULL,NULL),(35642,'39638','S','Tatum','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(30529,'33407','S','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.760988,-80.085606,0,'2013-07-06 12:44:32',NULL,NULL),(64724,'76877','S','San Saba','D','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.195610,-98.725363,0,'2013-07-06 12:44:34',NULL,NULL),(69052,'83229','S','Cobalt','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.111576,-114.436081,0,'2013-07-06 12:44:34',NULL,NULL),(72172,'88345','S','Hollywood','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.341149,-105.667861,0,'2013-07-06 12:44:34',NULL,NULL),(75082,'93534','S','Hi Vista','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(19052,'19543','S','Morgantown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.167689,-75.887010,0,'2013-07-06 12:44:31',NULL,NULL),(30839,'33631','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.962692,-82.533494,0,'2013-07-06 12:44:32',NULL,NULL),(21329,'22408','S','Fredbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(1696,'00777','S','Urb La Ceiba','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(45215,'50634','P','Gilbertville','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.415900,-92.215683,0,'2013-07-06 12:44:32',NULL,NULL),(79150,'98502','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.034250,-122.969325,0,'2013-07-06 12:44:34',NULL,NULL),(46570,'53522','S','Browntown','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.576493,-89.795722,0,'2013-07-06 12:44:32',NULL,NULL),(79257,'98563','S','Preachers Slough','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(40974,'46327','S','Hammond','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.632444,-87.508675,0,'2013-07-06 12:44:32',NULL,NULL),(53495,'62006','S','Gilead','N','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.087140,-90.668661,0,'2013-07-06 12:44:33',NULL,NULL),(2311,'00927','S','Villa Nevarez','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(43888,'49233','S','Cement City','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.051484,-84.379811,0,'2013-07-06 12:44:32',NULL,NULL),(67016,'79527','S','Ira','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.621370,-101.066330,0,'2013-07-06 12:44:34',NULL,NULL),(19183,'19804','S','Newport','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.724680,-75.606060,0,'2013-07-06 12:44:31',NULL,NULL),(12174,'12760','S','Long Eddy','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.869262,-75.080306,0,'2013-07-06 12:44:30',NULL,NULL),(37968,'42726','S','Clarkson','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.413206,-86.157634,0,'2013-07-06 12:44:32',NULL,NULL),(37110,'41367','S','Rowdy','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.413974,-83.205249,0,'2013-07-06 12:44:32',NULL,NULL),(35888,'39901','U','Chamblee','A','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.890737,-84.287630,0,'2013-07-06 12:44:32',NULL,NULL),(28523,'31545','S','McKinnon','N','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.612517,-81.885560,0,'2013-07-06 12:44:32',NULL,NULL),(28419,'31327','P','Sapelo Island','D','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.441253,-81.264230,0,'2013-07-06 12:44:32',NULL,NULL),(42303,'47598','S','Whiteoak','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(46838,'54017','S','Cylon','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(73147,'90277','S','Redondo Beach','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.832658,-118.380150,0,'2013-07-06 12:44:34',NULL,NULL),(79117,'98471','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.252509,-122.476476,0,'2013-07-06 12:44:34',NULL,NULL),(40977,'46342','S','Hobart','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.519340,-87.249960,0,'2013-07-06 12:44:32',NULL,NULL),(61715,'73010','S','Cole','A','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.136801,-97.648526,0,'2013-07-06 12:44:33',NULL,NULL),(56713,'65679','S','Mildred','N','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.567600,-93.114480,0,'2013-07-06 12:44:33',NULL,NULL),(11973,'12463','S','Palenville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.174316,-74.021686,0,'2013-07-06 12:44:30',NULL,NULL),(49692,'57025','S','Richland','N','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.785700,-96.696900,0,'2013-07-06 12:44:33',NULL,NULL),(46461,'53214','S','W Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.020816,-88.017337,0,'2013-07-06 12:44:32',NULL,NULL),(46914,'54139','S','Lena','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.935260,-88.054980,0,'2013-07-06 12:44:32',NULL,NULL),(69940,'84115','S','South Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.713441,-111.889049,0,'2013-07-06 12:44:34',NULL,NULL),(78286,'97874','S','Spray','D','Wheeler','41069','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.811765,-119.865455,0,'2013-07-06 12:44:34',NULL,NULL),(9416,'10001','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(47408,'54651','S','Ontario','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.723689,-90.589316,0,'2013-07-06 12:44:32',NULL,NULL),(48332,'55458','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.984312,-93.273338,0,'2013-07-06 12:44:33',NULL,NULL),(57550,'67031','S','Conway Spgs','A','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.388963,-97.644705,0,'2013-07-06 12:44:33',NULL,NULL),(933,'00714','S','Villas de Lafayette','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(35252,'39342','S','Marion','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.418900,-88.647270,0,'2013-07-06 12:44:32',NULL,NULL),(30614,'33432','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.349491,-80.092164,0,'2013-07-06 12:44:32',NULL,NULL),(42918,'48109','S','U of M','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.289849,-83.715145,0,'2013-07-06 12:44:32',NULL,NULL),(47522,'54806','S','Lac Courte Oreilles Indian R','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(51759,'60029','P','Golf','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.058706,-87.790933,0,'2013-07-06 12:44:33',NULL,NULL),(57779,'67467','S','Minneapolis','D','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.125123,-97.703693,0,'2013-07-06 12:44:33',NULL,NULL),(63086,'75251','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.915992,-96.770079,0,'2013-07-06 12:44:33',NULL,NULL),(69228,'83402','S','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.496857,-112.113288,0,'2013-07-06 12:44:34',NULL,NULL),(1903,'00795','S','Colinas de San Martin','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(54241,'62666','S','Middletown','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.100321,-89.588736,0,'2013-07-06 12:44:33',NULL,NULL),(64553,'76653','S','Headsville','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.314780,-96.621000,0,'2013-07-06 12:44:34',NULL,NULL),(64626,'76704','S','Bellmead','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.582080,-97.125000,0,'2013-07-06 12:44:34',NULL,NULL),(70767,'85337','S','Gila Bend','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.984592,-112.679461,0,'2013-07-06 12:44:34',NULL,NULL),(62208,'73844','S','Gate','D','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.914570,-100.128511,0,'2013-07-06 12:44:33',NULL,NULL),(61858,'73122','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.522969,-97.614030,0,'2013-07-06 12:44:33',NULL,NULL),(2183,'00926','S','Mans Colinas de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(34228,'38370','S','Saltillo','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.382497,-88.209373,0,'2013-07-06 12:44:32',NULL,NULL),(33425,'37243','U','TN State Government','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162894,-86.785734,0,'2013-07-06 12:44:32',NULL,NULL),(52284,'60530','S','Lee','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.792838,-88.972591,0,'2013-07-06 12:44:33',NULL,NULL),(49457,'56649','S','International Falls','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.582200,-93.411492,0,'2013-07-06 12:44:33',NULL,NULL),(7375,'06777','S','Marble Dale','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(17219,'17827','S','Freeburg','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.763907,-76.942194,0,'2013-07-06 12:44:31',NULL,NULL),(39435,'44683','S','Uhrichsville','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.392715,-81.347949,0,'2013-07-06 12:44:32',NULL,NULL),(4083,'02663','P','South Wellfleet','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.742515,-70.060551,0,'2013-07-06 12:44:30',NULL,NULL),(34506,'38674','S','Anvil','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.903866,-88.918583,0,'2013-07-06 12:44:32',NULL,NULL),(12876,'13325','S','West Turin','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.577189,-75.564678,0,'2013-07-06 12:44:30',NULL,NULL),(11829,'12241','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.630394,-73.761975,0,'2013-07-06 12:44:30',NULL,NULL),(45787,'52162','S','Postville','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.045500,-91.566000,0,'2013-07-06 12:44:32',NULL,NULL),(64355,'76520','S','Hoyte','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(67927,'80908','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.046410,-104.669910,0,'2013-07-06 12:44:34',NULL,NULL),(11351,'11798','S','Wheatley Heights','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.756804,-73.364139,0,'2013-07-06 12:44:30',NULL,NULL),(48330,'55454','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.964379,-93.244559,0,'2013-07-06 12:44:33',NULL,NULL),(48569,'55769','S','Cooley','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379684,-93.166650,0,'2013-07-06 12:44:33',NULL,NULL),(8331,'08037','S','Braddock','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(55140,'63359','S','Middletown','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.093735,-91.367918,0,'2013-07-06 12:44:33',NULL,NULL),(29175,'32358','S','St Teresa','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.122839,-84.522762,0,'2013-07-06 12:44:32',NULL,NULL),(21158,'22134','S','Quantico','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.520589,-77.321006,0,'2013-07-06 12:44:31',NULL,NULL),(48025,'55302','S','Annandale','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.263750,-94.124170,0,'2013-07-06 12:44:33',NULL,NULL),(787,'00693','S','BO Yeguada','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(13385,'13743','S','Hubbardtown','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.217072,-76.337592,0,'2013-07-06 12:44:31',NULL,NULL),(35285,'39401','S','Dixie Pine','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(23442,'25411','S','Berkeley Spgs','A','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.549780,-78.188160,0,'2013-07-06 12:44:31',NULL,NULL),(27115,'29733','U','Rock Hill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.890601,-81.024567,0,'2013-07-06 12:44:31',NULL,NULL),(48251,'55425','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.842620,-93.239760,0,'2013-07-06 12:44:33',NULL,NULL),(54122,'62553','S','Oconee','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.280213,-89.084082,0,'2013-07-06 12:44:33',NULL,NULL),(59120,'70153','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.941366,-90.085663,0,'2013-07-06 12:44:33',NULL,NULL),(60797,'72029','S','Clarendon','D','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.695459,-91.307560,0,'2013-07-06 12:44:33',NULL,NULL),(61202,'72231','P','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.746261,-92.276659,0,'2013-07-06 12:44:33',NULL,NULL),(41154,'46701','S','Skinner Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(31474,'34293','S','Venice','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.051449,-82.393701,0,'2013-07-06 12:44:32',NULL,NULL),(46144,'52655','S','W Burlington','A','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.826742,-91.165656,0,'2013-07-06 12:44:32',NULL,NULL),(76328,'95461','S','Middletown','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.785860,-122.620200,0,'2013-07-06 12:44:34',NULL,NULL),(8655,'08315','P','Dividing Creek','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.269693,-75.104860,0,'2013-07-06 12:44:30',NULL,NULL),(75952,'95043','S','Paicines','D','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.548040,-121.016280,0,'2013-07-06 12:44:34',NULL,NULL),(74008,'92115','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.761679,-117.070858,0,'2013-07-06 12:44:34',NULL,NULL),(58963,'70011','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.009593,-90.155327,0,'2013-07-06 12:44:33',NULL,NULL),(53631,'62097','S','Prairietown','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.957880,-89.870040,0,'2013-07-06 12:44:33',NULL,NULL),(49395,'56621','S','Falk','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(966,'00716','S','Urb Camino del Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(26092,'28713','S','Bryson City','D','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.401379,-83.467681,0,'2013-07-06 12:44:31',NULL,NULL),(26707,'29410','S','Hanahan','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.194932,-80.029749,0,'2013-07-06 12:44:31',NULL,NULL),(14361,'15021','S','Eldersville','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.412700,-80.431260,0,'2013-07-06 12:44:31',NULL,NULL),(33742,'37831','P','Oak Ridge','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.963275,-84.298102,0,'2013-07-06 12:44:32',NULL,NULL),(37931,'42642','S','Russell Spgs','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.055440,-85.091503,0,'2013-07-06 12:44:32',NULL,NULL),(41148,'46701','S','Bakertown','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(7153,'06419','S','Deep River','A','Middlesex','09007','Connecticut','CT','09','5480','860/959','Eastern',-5.0,'Y',41.375700,-72.581460,0,'2013-07-06 12:44:30',NULL,NULL),(41671,'47162','S','New Washington','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.545267,-85.478896,0,'2013-07-06 12:44:32',NULL,NULL),(18897,'19473','S','Delphi','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.237680,-75.481440,0,'2013-07-06 12:44:31',NULL,NULL),(40,'00603','S','Urb Victoria','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(45790,'52165','S','Ridgeway','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.293751,-91.988675,0,'2013-07-06 12:44:32',NULL,NULL),(23665,'25827','S','Crab Orchard','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.735882,-81.231306,0,'2013-07-06 12:44:31',NULL,NULL),(24766,'27549','S','Louisburg','D','Franklin','37069','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.089778,-78.299777,0,'2013-07-06 12:44:31',NULL,NULL),(23656,'25813','S','Glen Morgan','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.772983,-81.102442,0,'2013-07-06 12:44:31',NULL,NULL),(23376,'25302','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.386200,-81.617460,0,'2013-07-06 12:44:31',NULL,NULL),(38837,'44085','S','Rome','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(61354,'72476','S','Walnut Ridge','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.090720,-90.959580,0,'2013-07-06 12:44:33',NULL,NULL),(13859,'14227','S','South Cheektowaga','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.876735,-78.744457,0,'2013-07-06 12:44:31',NULL,NULL),(13797,'14203','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.882150,-78.867026,0,'2013-07-06 12:44:31',NULL,NULL),(22482,'24060','S','Blacksburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.229033,-80.414886,0,'2013-07-06 12:44:31',NULL,NULL),(77638,'97009','S','Damascus','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.424374,-122.384149,0,'2013-07-06 12:44:34',NULL,NULL),(44,'00603','S','Villa Universitaria','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(69816,'84074','S','Lake Point','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(65653,'77975','S','Witting','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.568900,-97.085580,0,'2013-07-06 12:44:34',NULL,NULL),(58424,'68658','S','Rising City','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.198815,-97.295333,0,'2013-07-06 12:44:33',NULL,NULL),(54100,'62536','S','Glenarm','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.637226,-89.634543,0,'2013-07-06 12:44:33',NULL,NULL),(46659,'53707','P','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.098563,-89.311125,0,'2013-07-06 12:44:32',NULL,NULL),(44262,'49686','S','Barlow Branch','N','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.754969,-85.596072,0,'2013-07-06 12:44:32',NULL,NULL),(43838,'49095','S','Vandalia','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.903319,-85.885876,0,'2013-07-06 12:44:32',NULL,NULL),(43494,'48620','P','Edenville','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.799885,-84.388017,0,'2013-07-06 12:44:32',NULL,NULL),(40465,'45761','S','Millfield','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.427040,-82.080598,0,'2013-07-06 12:44:32',NULL,NULL),(11426,'11967','S','E Yaphank','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.795028,-72.869264,0,'2013-07-06 12:44:30',NULL,NULL),(11859,'12261','U','Nys Tax Processing Ctr','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679058,-73.782986,0,'2013-07-06 12:44:30',NULL,NULL),(17145,'17801','S','Mile Run','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(10635,'11054','U','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.831342,-73.683314,0,'2013-07-06 12:44:30',NULL,NULL),(1440,'00739','S','Urb Freire','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(75291,'93724','U','Fresno Superior Court','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.725228,-119.794478,0,'2013-07-06 12:44:34',NULL,NULL),(4021,'02564','P','Sconset','N','Nantucket','25019','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.283333,-70.100000,0,'2013-07-06 12:44:30',NULL,NULL),(36626,'41001','S','Claryville','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.915760,-84.395700,0,'2013-07-06 12:44:32',NULL,NULL),(2106,'00923','S','Urb San Agustin','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(40675,'46058','S','Frankfort','A','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.371179,-86.626904,0,'2013-07-06 12:44:32',NULL,NULL),(39865,'45202','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.105479,-84.502052,0,'2013-07-06 12:44:32',NULL,NULL),(17363,'17872','S','Shamokin','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(27030,'29652','P','Greer','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.937860,-82.202937,0,'2013-07-06 12:44:31',NULL,NULL),(35295,'39401','S','Maybank','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(6447,'05757','S','Middletwn Spg','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.501080,-73.123260,0,'2013-07-06 12:44:30',NULL,NULL),(37157,'41465','S','Swampton','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(1311,'00735','S','Ext Villa del Pilar','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(39000,'44136','S','Strongsville','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.312880,-81.834720,0,'2013-07-06 12:44:32',NULL,NULL),(39115,'44255','S','Mantua','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.300880,-81.229860,0,'2013-07-06 12:44:32',NULL,NULL),(49235,'56470','S','Hubbard','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(64969,'77256','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.738334,-95.436312,0,'2013-07-06 12:44:34',NULL,NULL),(78399,'98034','S','Juanita','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.718053,-122.198946,0,'2013-07-06 12:44:34',NULL,NULL),(37485,'42020','S','Almo','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.668399,-88.368865,0,'2013-07-06 12:44:32',NULL,NULL),(61768,'73057','S','Maysville','D','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.818329,-97.412594,0,'2013-07-06 12:44:33',NULL,NULL),(9206,'09494','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9542,'10021','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(4215,'02838','S','Lincoln','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.968318,-71.474105,0,'2013-07-06 12:44:30',NULL,NULL),(28783,'32040','S','Glen St Mary','A','Baker','12003','Florida','FL','12','0000','904','Eastern',-5.0,'Y',30.288545,-82.158561,0,'2013-07-06 12:44:32',NULL,NULL),(24033,'26386','S','Dola','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.379361,-80.353385,0,'2013-07-06 12:44:31',NULL,NULL),(67675,'80503','S','Longmont','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.153029,-105.171300,0,'2013-07-06 12:44:34',NULL,NULL),(79973,'99648','P','Perryville','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.927650,-159.332132,0,'2013-07-06 12:44:34',NULL,NULL),(56786,'65755','S','Squires','D','Douglas','29067','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.848501,-92.582552,0,'2013-07-06 12:44:33',NULL,NULL),(36762,'41041','S','Flemingsburg Junction','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(6246,'05494','S','Brookside','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.630369,-73.005676,0,'2013-07-06 12:44:30',NULL,NULL),(17777,'18342','P','Mt Home','N','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.177592,-75.259145,0,'2013-07-06 12:44:31',NULL,NULL),(61216,'72319','P','Blytheville','A','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.961585,-89.974738,0,'2013-07-06 12:44:33',NULL,NULL),(64602,'76682','S','Perry','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.473889,-96.920114,0,'2013-07-06 12:44:34',NULL,NULL),(66861,'79178','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.187943,-101.848673,0,'2013-07-06 12:44:34',NULL,NULL),(75047,'93516','S','Kramer Junction','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.008562,-117.655982,0,'2013-07-06 12:44:34',NULL,NULL),(79580,'99025','S','Newman Lake','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.733704,-117.077767,0,'2013-07-06 12:44:34',NULL,NULL),(34723,'38843','S','Fulton','D','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.269865,-88.403996,0,'2013-07-06 12:44:32',NULL,NULL),(56966,'66115','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.145350,-94.610031,0,'2013-07-06 12:44:33',NULL,NULL),(27280,'29945','S','Salkehatchie','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(49303,'56534','S','Erhard','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.499200,-96.031562,0,'2013-07-06 12:44:33',NULL,NULL),(6029,'05403','S','S Burl','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(42448,'47805','S','Springwood','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(11542,'12047','S','Dunsbach Ferry','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.774939,-73.715732,0,'2013-07-06 12:44:30',NULL,NULL),(64369,'76527','S','Florence','D','Williamson','48491','Texas','TX','48','0640','254','Central',-6.0,'Y',30.838651,-97.790208,0,'2013-07-06 12:44:34',NULL,NULL),(14764,'15337','S','Graysville','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.896059,-80.400627,0,'2013-07-06 12:44:31',NULL,NULL),(39522,'44820','S','Bucyrus','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.816708,-82.969402,0,'2013-07-06 12:44:32',NULL,NULL),(11328,'11789','S','Scotts Beach','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.955253,-72.973851,0,'2013-07-06 12:44:30',NULL,NULL),(12832,'13310','S','Bouckville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.897902,-75.574398,0,'2013-07-06 12:44:30',NULL,NULL),(37374,'41736','P','Dice','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.377071,-83.208391,0,'2013-07-06 12:44:32',NULL,NULL),(19675,'20340','U','Defense Intelligence','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.849617,-77.016636,0,'2013-07-06 12:44:31',NULL,NULL),(30147,'33167','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885455,-80.228537,0,'2013-07-06 12:44:32',NULL,NULL),(47162,'54472','U','FIGIS','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.662245,-90.175187,0,'2013-07-06 12:44:32',NULL,NULL),(47724,'55008','S','Cambridge','D','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.562400,-93.228686,0,'2013-07-06 12:44:33',NULL,NULL),(74725,'93032','P','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.199525,-119.176669,0,'2013-07-06 12:44:34',NULL,NULL),(52396,'60633','S','Burnham','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.653807,-87.559353,0,'2013-07-06 12:44:33',NULL,NULL),(1211,'00728','S','Sect Las Cucharas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(41942,'47392','S','Webster','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.905961,-84.929026,0,'2013-07-06 12:44:32',NULL,NULL),(28956,'32198','U','Fl Reg Lib Bl','N','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.195511,-81.052236,0,'2013-07-06 12:44:32',NULL,NULL),(38005,'42776','S','Sonora','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.527380,-85.932922,0,'2013-07-06 12:44:32',NULL,NULL),(13670,'14034','S','Collins','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.502473,-78.860926,0,'2013-07-06 12:44:31',NULL,NULL),(13369,'13734','S','Barton','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.076679,-76.408720,0,'2013-07-06 12:44:31',NULL,NULL),(73801,'91752','S','Mira Loma','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995007,-117.528742,0,'2013-07-06 12:44:34',NULL,NULL),(79114,'98467','S','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.235833,-122.549167,0,'2013-07-06 12:44:34',NULL,NULL),(8212,'07945','S','Mendham Twsp','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.782239,-74.596638,0,'2013-07-06 12:44:30',NULL,NULL),(63521,'75754','S','Martins Mills','N','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.414520,-95.649120,0,'2013-07-06 12:44:33',NULL,NULL),(17589,'18030','P','Bowmanstown','D','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.803030,-75.658473,0,'2013-07-06 12:44:31',NULL,NULL),(30856,'33655','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.948815,-82.455581,0,'2013-07-06 12:44:32',NULL,NULL),(18049,'18701','S','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.242470,-75.884842,0,'2013-07-06 12:44:31',NULL,NULL),(43253,'48323','S','Orchard Lake','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573180,-83.380200,0,'2013-07-06 12:44:32',NULL,NULL),(48178,'55383','P','Norwood','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.771196,-93.927336,0,'2013-07-06 12:44:33',NULL,NULL),(66572,'78739','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.170527,-97.876902,0,'2013-07-06 12:44:34',NULL,NULL),(1511,'00754','S','Ext Bda Roosevelt','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(73485,'91322','P','Newhall','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.384669,-118.530023,0,'2013-07-06 12:44:34',NULL,NULL),(76582,'95681','S','Sheridan','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.010786,-121.357453,0,'2013-07-06 12:44:34',NULL,NULL),(54691,'62948','S','Herrin','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.801582,-89.028075,0,'2013-07-06 12:44:33',NULL,NULL),(64720,'76874','S','Roosevelt','D','Kimble','48267','Texas','TX','48','0000','325','Central',-6.0,'Y',30.547687,-99.958726,0,'2013-07-06 12:44:34',NULL,NULL),(79067,'98431','U','JBLM','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(16724,'17407','S','Jacobus','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.938040,-76.666080,0,'2013-07-06 12:44:31',NULL,NULL),(35131,'39215','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.297171,-90.183699,0,'2013-07-06 12:44:32',NULL,NULL),(2949,'01033','S','Granby','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.256411,-72.519474,0,'2013-07-06 12:44:30',NULL,NULL),(9258,'09594','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(6928,'06160','U','Aetna Insurance','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.771494,-72.707813,0,'2013-07-06 12:44:30',NULL,NULL),(19935,'20566','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903226,-77.049281,0,'2013-07-06 12:44:31',NULL,NULL),(20681,'21236','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.389419,-76.488137,0,'2013-07-06 12:44:31',NULL,NULL),(40228,'45416','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.800645,-84.257639,0,'2013-07-06 12:44:32',NULL,NULL),(56176,'65001','S','Argyle','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.299331,-92.007748,0,'2013-07-06 12:44:33',NULL,NULL),(78720,'98277','S','Ault Field','N','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.302951,-122.640714,0,'2013-07-06 12:44:34',NULL,NULL),(3133,'01247','S','N Adams','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.687120,-73.074360,0,'2013-07-06 12:44:30',NULL,NULL),(74816,'93219','S','Earlimart','D','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.887086,-119.278166,0,'2013-07-06 12:44:34',NULL,NULL),(49970,'57353','S','Manchester','N','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365169,-97.849047,0,'2013-07-06 12:44:33',NULL,NULL),(41238,'46740','S','Ceylon','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.595413,-84.959127,0,'2013-07-06 12:44:32',NULL,NULL),(10268,'10509','S','Brewster','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422678,-73.599511,0,'2013-07-06 12:44:30',NULL,NULL),(4135,'02748','S','Dartmouth','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.598019,-70.954047,0,'2013-07-06 12:44:30',NULL,NULL),(59099,'70129','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.046012,-89.902076,0,'2013-07-06 12:44:33',NULL,NULL),(73238,'90662','P','Pico Rivera','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.969412,-118.098484,0,'2013-07-06 12:44:34',NULL,NULL),(37480,'42001','S','Paducah Mall','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(66522,'78714','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.268840,-97.741223,0,'2013-07-06 12:44:34',NULL,NULL),(48740,'55967','S','Racine','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.795675,-92.569537,0,'2013-07-06 12:44:33',NULL,NULL),(50819,'58464','S','McHenry','D','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.541956,-98.562354,0,'2013-07-06 12:44:33',NULL,NULL),(48329,'55450','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.878006,-93.218677,0,'2013-07-06 12:44:33',NULL,NULL),(62903,'75069','S','Fairview','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.179280,-96.601020,0,'2013-07-06 12:44:33',NULL,NULL),(2299,'00927','S','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(28373,'31294','U','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.837487,-83.632352,0,'2013-07-06 12:44:32',NULL,NULL),(42274,'47581','S','Willow Valley','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(38748,'44035','S','Elyria','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(67873,'80833','S','Rush','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.923499,-104.031203,0,'2013-07-06 12:44:34',NULL,NULL),(76503,'95639','P','Hood','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.368835,-121.517767,0,'2013-07-06 12:44:34',NULL,NULL),(15117,'15784','S','Worthville','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.026469,-79.140778,0,'2013-07-06 12:44:31',NULL,NULL),(30355,'33313','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(48598,'55785','S','Shovel Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.877521,-93.682649,0,'2013-07-06 12:44:33',NULL,NULL),(70132,'84301','P','Bear River Cy','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.594870,-112.127635,0,'2013-07-06 12:44:34',NULL,NULL),(38997,'44135','S','Puritas Pk','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.434425,-81.801820,0,'2013-07-06 12:44:32',NULL,NULL),(32109,'35401','S','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.191809,-87.564581,0,'2013-07-06 12:44:32',NULL,NULL),(8199,'07930','S','Chester','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.791787,-74.674518,0,'2013-07-06 12:44:30',NULL,NULL),(27006,'29636','P','Conestee','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.769607,-82.352293,0,'2013-07-06 12:44:31',NULL,NULL),(45645,'51654','S','Bartlett','A','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.821039,-95.750570,0,'2013-07-06 12:44:32',NULL,NULL),(18433,'19063','S','Upper Providence','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(76006,'95117','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.312261,-121.963925,0,'2013-07-06 12:44:34',NULL,NULL),(76968,'96050','S','Klamath River','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.829600,-122.803140,0,'2013-07-06 12:44:34',NULL,NULL),(16303,'17111','S','Paxtang','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.270440,-76.805460,0,'2013-07-06 12:44:31',NULL,NULL),(57446,'66842','S','Cassoday','D','Butler','20015','Kansas','KS','20','9040','620','Central',-6.0,'Y',38.030185,-96.651453,0,'2013-07-06 12:44:33',NULL,NULL),(13719,'14083','S','Java Village','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.671187,-78.432902,0,'2013-07-06 12:44:31',NULL,NULL),(49664,'57005','S','Brandon','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.587111,-96.580716,0,'2013-07-06 12:44:33',NULL,NULL),(43139,'48236','S','Grosse Pointe Shores','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(79466,'98855','S','Aeneas','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.704499,-119.439348,0,'2013-07-06 12:44:34',NULL,NULL),(5802,'05062','S','Reading Center','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.494300,-72.584520,0,'2013-07-06 12:44:30',NULL,NULL),(35501,'39529','U','Stennis Space Center','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(12856,'13318','S','Cassville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.940901,-75.285826,0,'2013-07-06 12:44:30',NULL,NULL),(33102,'36854','S','Fairfax','N','Chambers','01017','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.810093,-85.181624,0,'2013-07-06 12:44:32',NULL,NULL),(25173,'28043','S','Alexander Mills','A','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.333268,-81.867460,0,'2013-07-06 12:44:31',NULL,NULL),(55695,'64063','S','LS','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(56655,'65617','S','Brighton','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.480535,-93.362368,0,'2013-07-06 12:44:33',NULL,NULL),(68770,'82310','S','Rawlins','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.512682,-107.892119,0,'2013-07-06 12:44:34',NULL,NULL),(7491,'06910','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.044441,-73.549631,0,'2013-07-06 12:44:30',NULL,NULL),(12749,'13204','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.052042,-76.177065,0,'2013-07-06 12:44:30',NULL,NULL),(49010,'56256','S','Madison','D','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.166111,-96.170833,0,'2013-07-06 12:44:33',NULL,NULL),(12429,'12952','S','Standish','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.689167,-73.949444,0,'2013-07-06 12:44:30',NULL,NULL),(21955,'23235','S','N Chesterfld','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.502040,-77.569920,0,'2013-07-06 12:44:31',NULL,NULL),(31289,'34041','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(66699,'78945','S','Rutersville','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(22643,'24260','S','Council','A','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.029515,-82.003511,0,'2013-07-06 12:44:31',NULL,NULL),(73601,'91390','S','Mint Canyon','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(871,'00698','S','Urb Turnkey','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(3527,'01899','U','Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.650375,-71.184561,0,'2013-07-06 12:44:30',NULL,NULL),(11593,'12078','S','West Bush','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.054502,-74.338330,0,'2013-07-06 12:44:30',NULL,NULL),(9929,'10153','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(47152,'54466','S','Dexterville','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.448100,-90.177921,0,'2013-07-06 12:44:32',NULL,NULL),(55883,'64421','S','Amazonia','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.913600,-94.923408,0,'2013-07-06 12:44:33',NULL,NULL),(58253,'68367','S','Gresham','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.006280,-97.421986,0,'2013-07-06 12:44:33',NULL,NULL),(58509,'68771','S','Sholes','A','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.376438,-97.356521,0,'2013-07-06 12:44:33',NULL,NULL),(58745,'68955','S','Hayland','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.587480,-98.516760,0,'2013-07-06 12:44:33',NULL,NULL),(64329,'76501','S','Oscar','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(26101,'28718','S','Cedar Mtn','A','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.137445,-82.682532,0,'2013-07-06 12:44:31',NULL,NULL),(62762,'74854','S','Maud','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.130126,-96.778888,0,'2013-07-06 12:44:33',NULL,NULL),(11231,'11753','S','Muttontown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.784785,-73.535500,0,'2013-07-06 12:44:30',NULL,NULL),(66228,'78564','S','Lopeno','D','Zapata','48505','Texas','TX','48','0000','956','Central',-6.0,'Y',26.900251,-99.137082,0,'2013-07-06 12:44:34',NULL,NULL),(6733,'06076','S','Stafford Springs','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.985120,-72.255660,0,'2013-07-06 12:44:30',NULL,NULL),(60702,'71943','S','Glenwood','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.324416,-93.547401,0,'2013-07-06 12:44:33',NULL,NULL),(59559,'70827','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.434309,-91.082897,0,'2013-07-06 12:44:33',NULL,NULL),(30763,'33571','P','Sun City Ctr','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.720556,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(44687,'50125','S','Summerset','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.315040,-93.572040,0,'2013-07-06 12:44:32',NULL,NULL),(1076,'00725','S','Res Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(15342,'16230','P','Hawthorn','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.015961,-79.279887,0,'2013-07-06 12:44:31',NULL,NULL),(10273,'10510','S','Briarcliff Mnr','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.145661,-73.833747,0,'2013-07-06 12:44:30',NULL,NULL),(19744,'20407','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884305,-77.023130,0,'2013-07-06 12:44:31',NULL,NULL),(30445,'33331','S','Southwest Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(53579,'62061','S','Marine','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.786990,-89.778910,0,'2013-07-06 12:44:33',NULL,NULL),(53616,'62086','S','Sorento','D','Bond','17005','Illinois','IL','17','0000','217','Central',-6.0,'Y',38.977320,-89.600100,0,'2013-07-06 12:44:33',NULL,NULL),(64985,'77273','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.000875,-95.398266,0,'2013-07-06 12:44:34',NULL,NULL),(35987,'40119','S','Vanzant','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.587960,-86.493600,0,'2013-07-06 12:44:32',NULL,NULL),(13886,'14265','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.978557,-78.750032,0,'2013-07-06 12:44:31',NULL,NULL),(20687,'21239','S','Loch Hill','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.358614,-76.590884,0,'2013-07-06 12:44:31',NULL,NULL),(24219,'26716','S','Eglon','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.291239,-79.511965,0,'2013-07-06 12:44:31',NULL,NULL),(44764,'50207','S','New Sharon','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.467705,-92.649644,0,'2013-07-06 12:44:32',NULL,NULL),(39399,'44659','P','Mount Eaton','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.693635,-81.703189,0,'2013-07-06 12:44:32',NULL,NULL),(34733,'38849','S','Blair','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(2069,'00921','S','Parq de San Ignacio','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(13852,'14226','S','Eggertsville','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.969504,-78.798576,0,'2013-07-06 12:44:31',NULL,NULL),(32716,'36303','S','Dothan','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.254240,-85.398900,0,'2013-07-06 12:44:32',NULL,NULL),(11402,'11952','S','Mattituck','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.993754,-72.539624,0,'2013-07-06 12:44:30',NULL,NULL),(186,'00623','S','Paseos De Plan Bonito','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(4279,'02892','S','Richmond','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.502011,-71.593784,0,'2013-07-06 12:44:30',NULL,NULL),(50328,'57730','S','Game Lodge','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(73933,'92037','S','La Jolla','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.838775,-117.253243,0,'2013-07-06 12:44:34',NULL,NULL),(63932,'76065','S','Midlothian','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.478311,-96.981773,0,'2013-07-06 12:44:34',NULL,NULL),(42085,'47457','S','Scotland','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.032752,-86.854951,0,'2013-07-06 12:44:32',NULL,NULL),(44775,'50211','S','Norwalk','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.464165,-93.687138,0,'2013-07-06 12:44:32',NULL,NULL),(6464,'05761','S','North Rupert','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(37263,'41567','S','Stone','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.563307,-82.289864,0,'2013-07-06 12:44:32',NULL,NULL),(9259,'09595','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(26124,'28733','S','Fontana Dam','D','Graham','37075','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.430442,-83.828133,0,'2013-07-06 12:44:31',NULL,NULL),(45032,'50469','S','Rockwell','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.012320,-93.314520,0,'2013-07-06 12:44:32',NULL,NULL),(62210,'73848','S','Laverne','D','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.716580,-99.880538,0,'2013-07-06 12:44:33',NULL,NULL),(62720,'74766','S','Wright City','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.153986,-94.980004,0,'2013-07-06 12:44:33',NULL,NULL),(64301,'76459','S','Jermyn','D','Jack','48237','Texas','TX','48','0000','940','Central',-6.0,'Y',33.260472,-98.401293,0,'2013-07-06 12:44:34',NULL,NULL),(79809,'99403','S','Clarkston','D','Asotin','53003','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.398309,-117.067291,0,'2013-07-06 12:44:34',NULL,NULL),(15225,'16024','P','Callery','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.740036,-80.035826,0,'2013-07-06 12:44:31',NULL,NULL),(62331,'74048','S','Coodys Bluff','N','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.697172,-95.639359,0,'2013-07-06 12:44:33',NULL,NULL),(58945,'69357','S','Mitchell','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.940372,-103.808440,0,'2013-07-06 12:44:33',NULL,NULL),(40157,'45356','S','Piqua','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.148347,-84.241182,0,'2013-07-06 12:44:32',NULL,NULL),(45263,'50667','S','Raymond','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.469819,-92.222425,0,'2013-07-06 12:44:32',NULL,NULL),(46070,'52580','S','Pekin','N','Jefferson','19101','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.118406,-92.061888,0,'2013-07-06 12:44:32',NULL,NULL),(48306,'55442','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.050500,-93.428851,0,'2013-07-06 12:44:33',NULL,NULL),(38117,'43109','P','Brice','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.915024,-82.832813,0,'2013-07-06 12:44:32',NULL,NULL),(21625,'22908','U','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.035452,-78.514913,0,'2013-07-06 12:44:31',NULL,NULL),(29233,'32430','S','Clarksville','D','Calhoun','12013','Florida','FL','12','0000','850','Central',-6.0,'Y',30.363435,-85.182016,0,'2013-07-06 12:44:32',NULL,NULL),(2704,'00969','S','Ext Santa Paula','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(75669,'94545','S','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.633620,-122.101731,0,'2013-07-06 12:44:34',NULL,NULL),(9168,'09348','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(48467,'55718','S','Carlton','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.634040,-92.553300,0,'2013-07-06 12:44:33',NULL,NULL),(17146,'17801','S','Oaklyn','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(32741,'36322','S','Daleville','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.284660,-85.730340,0,'2013-07-06 12:44:32',NULL,NULL),(31748,'34987','S','St Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308771,-80.453062,0,'2013-07-06 12:44:32',NULL,NULL),(27788,'30380','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.646308,-84.389514,0,'2013-07-06 12:44:31',NULL,NULL),(21214,'22207','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.903531,-77.129764,0,'2013-07-06 12:44:31',NULL,NULL),(18469,'19083','S','Lower Merion','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.974773,-75.308851,0,'2013-07-06 12:44:31',NULL,NULL),(50103,'57474','S','Stratford','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.286060,-98.280146,0,'2013-07-06 12:44:33',NULL,NULL),(55767,'64116','S','N Kansas City','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(65164,'77406','S','Richmond','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.622710,-95.647993,0,'2013-07-06 12:44:34',NULL,NULL),(72534,'89166','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.308840,-115.315133,0,'2013-07-06 12:44:34',NULL,NULL),(54342,'62767','U','IL Dept Ins','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.804644,-89.655319,0,'2013-07-06 12:44:33',NULL,NULL),(49848,'57237','S','Gary','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.853000,-96.530608,0,'2013-07-06 12:44:33',NULL,NULL),(923,'00714','S','Jard de Lafayette','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(1668,'00773','S','Urb River Edge Hl','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(2579,'00960','P','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180281,-66.116276,0,'2013-07-06 12:44:30',NULL,NULL),(66343,'78608','S','Briggs','D','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.935647,-97.969927,0,'2013-07-06 12:44:34',NULL,NULL),(64795,'77015','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770126,-95.173187,0,'2013-07-06 12:44:34',NULL,NULL),(22573,'24153','S','Hanging Rock','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(19049,'19541','S','Mohrsville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.477756,-76.012001,0,'2013-07-06 12:44:31',NULL,NULL),(50141,'57533','S','Gregory','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.233905,-99.427134,0,'2013-07-06 12:44:33',NULL,NULL),(33822,'37922','S','Farragut','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856420,-84.128340,0,'2013-07-06 12:44:32',NULL,NULL),(11548,'12054','S','Bethlehem','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.605220,-73.870080,0,'2013-07-06 12:44:30',NULL,NULL),(10775,'11365','S','Pomonok','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738549,-73.790001,0,'2013-07-06 12:44:30',NULL,NULL),(27577,'30271','P','Newnan','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.377625,-84.787631,0,'2013-07-06 12:44:31',NULL,NULL),(27439,'30117','S','Carrollton','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.589927,-85.120833,0,'2013-07-06 12:44:31',NULL,NULL),(9838,'10116','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(17680,'18109','S','Allentown Airport','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.581201,-75.472059,0,'2013-07-06 12:44:31',NULL,NULL),(42317,'47615','S','Newtonville','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.974900,-86.947020,0,'2013-07-06 12:44:32',NULL,NULL),(45376,'51016','S','Correctionvle','A','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.478073,-95.782566,0,'2013-07-06 12:44:32',NULL,NULL),(48104,'55345','S','Hopkins','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.921543,-93.482675,0,'2013-07-06 12:44:33',NULL,NULL),(54060,'62475','S','West Liberty','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.906032,-88.096973,0,'2013-07-06 12:44:33',NULL,NULL),(57351,'66732','S','Elsmore','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.816229,-95.157167,0,'2013-07-06 12:44:33',NULL,NULL),(68561,'81435','S','Mountain Village','A','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.979875,-107.941486,0,'2013-07-06 12:44:34',NULL,NULL),(69499,'83707','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.659380,-116.166616,0,'2013-07-06 12:44:34',NULL,NULL),(74013,'92119','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.802216,-117.025108,0,'2013-07-06 12:44:34',NULL,NULL),(66781,'79040','S','Gruver','D','Hansford','48195','Texas','TX','48','0000','806','Central',-6.0,'Y',36.262897,-101.400686,0,'2013-07-06 12:44:34',NULL,NULL),(19373,'20059','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.923858,-77.016121,0,'2013-07-06 12:44:31',NULL,NULL),(57404,'66762','S','Pittsburg','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.412275,-94.698359,0,'2013-07-06 12:44:33',NULL,NULL),(1097,'00725','S','Urb La Granja','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(38089,'43077','P','Unionville Center','D','Union','39159','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.138683,-83.338596,0,'2013-07-06 12:44:32',NULL,NULL),(6768,'06096','S','Bradley International Airpor','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.925995,-72.643635,0,'2013-07-06 12:44:30',NULL,NULL),(30213,'33184','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.756934,-80.404841,0,'2013-07-06 12:44:32',NULL,NULL),(25956,'28657','S','Spear','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(11206,'11743','S','Knollwood Beach','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(19974,'20597','U','Armed Forces Inaugural Com','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896622,-77.034001,0,'2013-07-06 12:44:31',NULL,NULL),(51133,'58801','S','Williston','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.416870,-103.823860,0,'2013-07-06 12:44:33',NULL,NULL),(53002,'61451','S','Laura','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.944652,-89.961612,0,'2013-07-06 12:44:33',NULL,NULL),(62091,'73569','S','Grady','A','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.021990,-97.664480,0,'2013-07-06 12:44:33',NULL,NULL),(64210,'76262','S','Roanoke','D','Denton','48121','Texas','TX','48','1920','817','Central',-6.0,'Y',33.007049,-97.194352,0,'2013-07-06 12:44:34',NULL,NULL),(68411,'81201','S','Salida','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(29113,'32309','S','Centerville','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.597156,-84.041559,0,'2013-07-06 12:44:32',NULL,NULL),(59399,'70631','S','Johnsons Bayou','N','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.826351,-93.397555,0,'2013-07-06 12:44:33',NULL,NULL),(52384,'60628','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.691540,-87.621710,0,'2013-07-06 12:44:33',NULL,NULL),(50198,'57570','P','Rosebud','D','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.268101,-100.736849,0,'2013-07-06 12:44:33',NULL,NULL),(154,'00617','S','Urb las Praderas','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(28028,'30638','P','Farmington','D','Oconee','13219','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.770038,-83.422408,0,'2013-07-06 12:44:31',NULL,NULL),(17789,'18353','S','Saylorsburg','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.925028,-75.381343,0,'2013-07-06 12:44:31',NULL,NULL),(11088,'11693','S','Far Rockaway','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.589797,-73.813567,0,'2013-07-06 12:44:30',NULL,NULL),(55647,'64021','S','Corder','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.111496,-93.637089,0,'2013-07-06 12:44:33',NULL,NULL),(56019,'64661','S','Mercer','D','Mercer','29129','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.527222,-93.497307,0,'2013-07-06 12:44:33',NULL,NULL),(76912,'95992','P','Yuba City','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.023600,-121.607036,0,'2013-07-06 12:44:34',NULL,NULL),(22118,'23433','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.906300,-76.492560,0,'2013-07-06 12:44:31',NULL,NULL),(73993,'92102','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.716263,-117.114260,0,'2013-07-06 12:44:34',NULL,NULL),(14880,'15474','S','Point Marion','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.737710,-79.900557,0,'2013-07-06 12:44:31',NULL,NULL),(13840,'14223','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(58434,'68667','S','Ulysses','A','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.097180,-97.313400,0,'2013-07-06 12:44:33',NULL,NULL),(52151,'60444','S','Mazon','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.250355,-88.413014,0,'2013-07-06 12:44:33',NULL,NULL),(49139,'56372','U','Fingerhut Bus Reply','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.562988,-94.218716,0,'2013-07-06 12:44:33',NULL,NULL),(306,'00646','S','Urb Monte Bello','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(8550,'08204','S','Fishing Creek','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(1368,'00736','S','Urb Las Muesas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(5308,'04558','S','New Harbor','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.875833,-69.490556,0,'2013-07-06 12:44:30',NULL,NULL),(34354,'38587','S','Walling','D','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.930222,-85.474463,0,'2013-07-06 12:44:32',NULL,NULL),(33232,'37067','S','Franklin','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.928406,-86.805538,0,'2013-07-06 12:44:32',NULL,NULL),(9110,'09103','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8625,'08252','P','Whitesboro','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.036990,-74.863423,0,'2013-07-06 12:44:30',NULL,NULL),(20496,'21062','U','Glen Burnie','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.163696,-76.603579,0,'2013-07-06 12:44:31',NULL,NULL),(6875,'06138','P','East Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.761680,-72.612610,0,'2013-07-06 12:44:30',NULL,NULL),(66921,'79336','S','Levelland','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.554160,-102.384000,0,'2013-07-06 12:44:34',NULL,NULL),(68049,'80931','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.752720,-104.731586,0,'2013-07-06 12:44:34',NULL,NULL),(26359,'29070','S','Leesville','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(10591,'11026','P','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.791618,-73.729669,0,'2013-07-06 12:44:30',NULL,NULL),(9734,'10090','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(1480,'00745','S','VISTAS de Rio Grande I','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(70596,'85097','S','Census Bureau','N','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.448261,-112.075768,0,'2013-07-06 12:44:34',NULL,NULL),(73085,'90220','S','Rancho Dominguez','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.890694,-118.239135,0,'2013-07-06 12:44:34',NULL,NULL),(75712,'94577','S','San Leandro','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.718789,-122.158712,0,'2013-07-06 12:44:34',NULL,NULL),(78820,'98335','S','Arletta','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(48408,'55596','P','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.103689,-93.660200,0,'2013-07-06 12:44:33',NULL,NULL),(70328,'84628','P','Eureka','D','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.953450,-112.113013,0,'2013-07-06 12:44:34',NULL,NULL),(76078,'95209','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.025675,-121.348721,0,'2013-07-06 12:44:34',NULL,NULL),(78542,'98139','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.651421,-122.405153,0,'2013-07-06 12:44:34',NULL,NULL),(4192,'02824','P','Forestdale','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.945312,-71.699264,0,'2013-07-06 12:44:30',NULL,NULL),(40280,'45437','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.767084,-84.125122,0,'2013-07-06 12:44:32',NULL,NULL),(35470,'39506','P','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.389458,-89.057201,0,'2013-07-06 12:44:32',NULL,NULL),(14749,'15320','S','Carmichaels','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.874080,-79.982880,0,'2013-07-06 12:44:31',NULL,NULL),(22470,'24043','U','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270171,-79.922058,0,'2013-07-06 12:44:31',NULL,NULL),(22298,'23824','S','Blackstone','D','Nottoway','51135','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.081591,-77.999211,0,'2013-07-06 12:44:31',NULL,NULL),(18032,'18651','S','Plymouth','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.245620,-75.961740,0,'2013-07-06 12:44:31',NULL,NULL),(53041,'61479','S','Speer','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.017323,-89.699335,0,'2013-07-06 12:44:33',NULL,NULL),(2662,'00966','S','Urb Martin CT','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(71090,'85933','P','Overgaard','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.389598,-110.552466,0,'2013-07-06 12:44:34',NULL,NULL),(70895,'85617','S','Mc Neal','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.523874,-109.682735,0,'2013-07-06 12:44:34',NULL,NULL),(68220,'81050','S','Fairmont','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(64115,'76181','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.813066,-97.228230,0,'2013-07-06 12:44:34',NULL,NULL),(21385,'22488','S','Kinsale','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.046655,-76.588726,0,'2013-07-06 12:44:31',NULL,NULL),(3807,'02266','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.349321,-71.059883,0,'2013-07-06 12:44:30',NULL,NULL),(5428,'04674','S','Seal Cove','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.315468,-68.364237,0,'2013-07-06 12:44:30',NULL,NULL),(29690,'32931','S','Cocoa Beach','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.329058,-80.611545,0,'2013-07-06 12:44:32',NULL,NULL),(12355,'12886','S','Wevertown','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.642397,-73.900698,0,'2013-07-06 12:44:30',NULL,NULL),(33213,'37051','S','Cmbrlnd Frnce','A','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.298358,-87.412642,0,'2013-07-06 12:44:32',NULL,NULL),(34651,'38773','S','Shaw','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.595800,-90.822780,0,'2013-07-06 12:44:32',NULL,NULL),(36073,'40211','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.238179,-85.809781,0,'2013-07-06 12:44:32',NULL,NULL),(36845,'41075','S','Newport','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.091389,-84.495833,0,'2013-07-06 12:44:32',NULL,NULL),(68442,'81225','P','Mount Crested Butte','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(50370,'57755','S','Wilson Corner','N','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.848971,-103.364264,0,'2013-07-06 12:44:33',NULL,NULL),(15515,'16530','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.132056,-80.083610,0,'2013-07-06 12:44:31',NULL,NULL),(24037,'26405','S','Moatsville','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.224954,-79.904469,0,'2013-07-06 12:44:31',NULL,NULL),(69074,'83243','S','Holbrook','D','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.267950,-112.616196,0,'2013-07-06 12:44:34',NULL,NULL),(74705,'93007','P','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.289720,-119.157813,0,'2013-07-06 12:44:34',NULL,NULL),(77707,'97051','S','Saint Helens','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.871834,-122.872699,0,'2013-07-06 12:44:34',NULL,NULL),(78672,'98238','P','Conway','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.338751,-122.343828,0,'2013-07-06 12:44:34',NULL,NULL),(35688,'39661','S','Oldenburg','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(72954,'90041','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.137442,-118.206258,0,'2013-07-06 12:44:34',NULL,NULL),(67298,'80015','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.624696,-104.788800,0,'2013-07-06 12:44:34',NULL,NULL),(44682,'50124','S','Midvale','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.897615,-93.604954,0,'2013-07-06 12:44:32',NULL,NULL),(43558,'48723','S','Caro','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.486120,-83.389537,0,'2013-07-06 12:44:32',NULL,NULL),(43175,'48278','U','Chase Bank','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.326390,-83.060061,0,'2013-07-06 12:44:32',NULL,NULL),(30045,'33144','S','Coral Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.763251,-80.313357,0,'2013-07-06 12:44:32',NULL,NULL),(29865,'33040','S','East Rockland Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(34806,'38878','S','Reid','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(18354,'19037','P','Glen Rdl Lima','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.901166,-75.442291,0,'2013-07-06 12:44:31',NULL,NULL),(3421,'01721','S','Ashland','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.253129,-71.460756,0,'2013-07-06 12:44:30',NULL,NULL),(1459,'00745','S','Jard Rio Grande','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(21565,'22820','S','Criders','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.722457,-79.017457,0,'2013-07-06 12:44:31',NULL,NULL),(69619,'83868','S','Smelterville','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.544033,-116.181812,0,'2013-07-06 12:44:34',NULL,NULL),(2810,'00976','S','Urb Sunville','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(3881,'02367','S','Plympton','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',41.955248,-70.806097,0,'2013-07-06 12:44:30',NULL,NULL),(14282,'14860','S','Lodi','D','Seneca','36099','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.603278,-76.842228,0,'2013-07-06 12:44:31',NULL,NULL),(30310,'33304','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140780,-80.124434,0,'2013-07-06 12:44:32',NULL,NULL),(77653,'97017','S','Colton','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.156854,-122.356927,0,'2013-07-06 12:44:34',NULL,NULL),(78734,'98283','S','Newhalem','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.482400,-121.527120,0,'2013-07-06 12:44:34',NULL,NULL),(57127,'66224','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(60384,'71601','S','Arsenal','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.201680,-91.929399,0,'2013-07-06 12:44:33',NULL,NULL),(52125,'60429','S','East Hazel Crest','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.568060,-87.673440,0,'2013-07-06 12:44:33',NULL,NULL),(49627,'56920','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895216,-77.036514,0,'2013-07-06 12:44:33',NULL,NULL),(43626,'48820','S','De Witt','A','Clinton','26037','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.846571,-84.590334,0,'2013-07-06 12:44:32',NULL,NULL),(22895,'24590','S','Scottsville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.810811,-78.512844,0,'2013-07-06 12:44:31',NULL,NULL),(25357,'28232','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.216280,-80.826821,0,'2013-07-06 12:44:31',NULL,NULL),(30574,'33414','S','West Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(40536,'45839','P','Findlay','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.044361,-83.648036,0,'2013-07-06 12:44:32',NULL,NULL),(41697,'47224','S','Canaan','D','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.876350,-85.265875,0,'2013-07-06 12:44:32',NULL,NULL),(8399,'08062','S','South Harrison Township','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722021,-75.221337,0,'2013-07-06 12:44:30',NULL,NULL),(56904,'66046','S','Lawrence','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.943832,-95.255319,0,'2013-07-06 12:44:33',NULL,NULL),(17925,'18466','S','Coolbaugh Township','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.183409,-75.377541,0,'2013-07-06 12:44:31',NULL,NULL),(52618,'61032','S','Scioto Mills','A','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.302242,-89.635039,0,'2013-07-06 12:44:33',NULL,NULL),(5779,'05051','S','Newbury','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.046111,-72.085278,0,'2013-07-06 12:44:30',NULL,NULL),(37026,'41240','S','Whitehouse','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(36040,'40204','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.235927,-85.724905,0,'2013-07-06 12:44:32',NULL,NULL),(65738,'78052','S','Lytle','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',29.223945,-98.788386,0,'2013-07-06 12:44:34',NULL,NULL),(78452,'98064','P','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.395900,-122.239201,0,'2013-07-06 12:44:34',NULL,NULL),(79462,'98851','S','Lakeview Park','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.395140,-119.452020,0,'2013-07-06 12:44:34',NULL,NULL),(30837,'33629','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.921224,-82.508478,0,'2013-07-06 12:44:32',NULL,NULL),(78274,'97862','S','Milton Freewater','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.932608,-118.389207,0,'2013-07-06 12:44:34',NULL,NULL),(67081,'79605','S','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.430449,-99.776943,0,'2013-07-06 12:44:34',NULL,NULL),(65841,'78160','S','Denhawken','N','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.232249,-97.963196,0,'2013-07-06 12:44:34',NULL,NULL),(56811,'65775','S','Lanton','N','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.513880,-91.801540,0,'2013-07-06 12:44:33',NULL,NULL),(56550,'65461','S','Duke','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.655315,-91.986358,0,'2013-07-06 12:44:33',NULL,NULL),(56524,'65355','S','Wisdom','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(47483,'54750','S','Maiden Rock','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.562824,-92.308633,0,'2013-07-06 12:44:32',NULL,NULL),(15883,'17003','S','Steelstown','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(19088,'19601','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.347781,-75.938400,0,'2013-07-06 12:44:31',NULL,NULL),(19954,'20580','U','Federal Trade Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894121,-77.024126,0,'2013-07-06 12:44:31',NULL,NULL),(18995,'19523','P','Geigertown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.203402,-75.838200,0,'2013-07-06 12:44:31',NULL,NULL),(62399,'74108','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.144971,-95.800496,0,'2013-07-06 12:44:33',NULL,NULL),(40719,'46120','S','Cunot','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.512820,-86.819220,0,'2013-07-06 12:44:32',NULL,NULL),(21791,'23075','S','Highland Spgs','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.546429,-77.325289,0,'2013-07-06 12:44:31',NULL,NULL),(64296,'76454','S','Gorman','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.213362,-98.669901,0,'2013-07-06 12:44:34',NULL,NULL),(66237,'78569','S','Lyford','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.410500,-97.764420,0,'2013-07-06 12:44:34',NULL,NULL),(50748,'58401','S','Woodbury','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(49335,'56562','S','Concordia College','N','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.862982,-96.763781,0,'2013-07-06 12:44:33',NULL,NULL),(46035,'52556','S','Maharishi Vedic City','A','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(43942,'49286','S','Tecumseh','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.010493,-83.943686,0,'2013-07-06 12:44:32',NULL,NULL),(43459,'48551','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.987259,-83.711956,0,'2013-07-06 12:44:32',NULL,NULL),(39275,'44470','S','Southington','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.299650,-80.950333,0,'2013-07-06 12:44:32',NULL,NULL),(21661,'22943','S','Greenwood','D','Albemarle','51003','Virginia','VA','51','1540','540','Eastern',-5.0,'Y',38.044494,-78.788119,0,'2013-07-06 12:44:31',NULL,NULL),(10552,'11001','S','Floral Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(16172,'17065','S','Mt Holly Spgs','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.117148,-77.192329,0,'2013-07-06 12:44:31',NULL,NULL),(4292,'02902','U','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.824676,-71.410790,0,'2013-07-06 12:44:30',NULL,NULL),(15675,'16823','S','Pleasant Gap','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.938060,-77.721720,0,'2013-07-06 12:44:31',NULL,NULL),(33515,'37373','S','Sale Creek','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.386080,-85.095951,0,'2013-07-06 12:44:32',NULL,NULL),(40118,'45324','S','Beavercreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.807279,-84.019499,0,'2013-07-06 12:44:32',NULL,NULL),(13431,'13758','P','East Pharsalia','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.555016,-75.716571,0,'2013-07-06 12:44:31',NULL,NULL),(78369,'98021','S','Thrashers Corner','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791648,-122.217445,0,'2013-07-06 12:44:34',NULL,NULL),(3689,'02133','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.354273,-71.065367,0,'2013-07-06 12:44:30',NULL,NULL),(40978,'46342','S','New Chicago','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.519340,-87.249960,0,'2013-07-06 12:44:32',NULL,NULL),(56911,'66049','S','Lwrnce','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.970249,-95.279946,0,'2013-07-06 12:44:33',NULL,NULL),(9813,'10112','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(51418,'59446','S','Square Butte','A','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.601836,-110.269770,0,'2013-07-06 12:44:33',NULL,NULL),(31068,'33850','S','Lake Alfred','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.088186,-81.727355,0,'2013-07-06 12:44:32',NULL,NULL),(26518,'29180','S','Winnsboro Mills','N','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.372149,-81.086971,0,'2013-07-06 12:44:31',NULL,NULL),(14600,'15224','S','Bloomfield','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465933,-79.946627,0,'2013-07-06 12:44:31',NULL,NULL),(36489,'40806','S','Keith','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.877560,-83.316720,0,'2013-07-06 12:44:32',NULL,NULL),(39566,'44849','S','Nevada','D','Wyandot','39175','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.826400,-83.130900,0,'2013-07-06 12:44:32',NULL,NULL),(12025,'12514','S','Clinton Corners','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.875980,-73.772400,0,'2013-07-06 12:44:30',NULL,NULL),(72174,'88345','S','Sierra Blanca','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.341149,-105.667861,0,'2013-07-06 12:44:34',NULL,NULL),(19494,'20156','P','Gainesville','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.791954,-77.625370,0,'2013-07-06 12:44:31',NULL,NULL),(219,'00624','S','Urb El Madrigal','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(32610,'36135','U','AL Income Tax','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.387934,-86.151025,0,'2013-07-06 12:44:32',NULL,NULL),(13863,'14228','S','West Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.025880,-78.795360,0,'2013-07-06 12:44:31',NULL,NULL),(16470,'17241','S','Upper Mifflin','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(41471,'46922','P','Delong','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.138558,-86.416382,0,'2013-07-06 12:44:32',NULL,NULL),(2016,'00915','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(33553,'37403','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.045024,-85.296037,0,'2013-07-06 12:44:32',NULL,NULL),(12210,'12791','S','Youngsville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.805090,-74.885943,0,'2013-07-06 12:44:30',NULL,NULL),(9061,'08904','S','New Brunswick','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.498795,-74.425817,0,'2013-07-06 12:44:30',NULL,NULL),(28579,'31627','P','Cecil','D','Cook','13075','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.109433,-83.419618,0,'2013-07-06 12:44:32',NULL,NULL),(1959,'00821','P','Christiansted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.746073,-64.706553,0,'2013-07-06 12:44:30',NULL,NULL),(22611,'24216','S','Exeter','A','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.906361,-82.782620,0,'2013-07-06 12:44:31',NULL,NULL),(20471,'21040','S','Edgewood','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.429165,-76.304399,0,'2013-07-06 12:44:31',NULL,NULL),(49870,'57258','S','Raymond','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.889418,-97.921590,0,'2013-07-06 12:44:33',NULL,NULL),(51556,'59743','P','Melrose','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.631690,-112.680504,0,'2013-07-06 12:44:33',NULL,NULL),(70283,'84532','S','Castleton','N','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(78757,'98297','P','Waldron','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.688854,-123.037160,0,'2013-07-06 12:44:34',NULL,NULL),(31574,'34639','S','Land O\' Lakes','N','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.247163,-82.498330,0,'2013-07-06 12:44:32',NULL,NULL),(71121,'86018','P','Parks','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.260485,-111.947488,0,'2013-07-06 12:44:34',NULL,NULL),(68359,'81135','P','Homelake','D','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.578239,-106.147242,0,'2013-07-06 12:44:34',NULL,NULL),(75397,'94010','S','Burlingame','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.570237,-122.360344,0,'2013-07-06 12:44:34',NULL,NULL),(446,'00662','S','Urb Las Ceibas','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(3601,'02041','P','Green Harbor','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.071576,-70.654380,0,'2013-07-06 12:44:30',NULL,NULL),(25685,'28521','S','Chinquapin','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.827840,-77.744935,0,'2013-07-06 12:44:31',NULL,NULL),(45154,'50588','S','Juniata','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(57418,'66773','S','Skidmore','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.267281,-94.853706,0,'2013-07-06 12:44:33',NULL,NULL),(59246,'70438','S','Franklinton','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.848512,-90.146024,0,'2013-07-06 12:44:33',NULL,NULL),(65708,'78015','S','Boerne','D','Kendall','48259','Texas','TX','48','7240','210','Central',-6.0,'Y',29.801349,-98.741246,0,'2013-07-06 12:44:34',NULL,NULL),(68150,'80997','U','Compassion International','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.877688,-104.819099,0,'2013-07-06 12:44:34',NULL,NULL),(70724,'85287','U','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.428352,-111.932123,0,'2013-07-06 12:44:34',NULL,NULL),(71874,'87729','S','Springer','A','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.361111,-104.594722,0,'2013-07-06 12:44:34',NULL,NULL),(73984,'92092','U','La Jolla','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.876604,-117.232638,0,'2013-07-06 12:44:34',NULL,NULL),(40777,'46160','S','Morgantown','D','Morgan','18109','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.380093,-86.264593,0,'2013-07-06 12:44:32',NULL,NULL),(6913,'06153','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688148,-72.728859,0,'2013-07-06 12:44:30',NULL,NULL),(32759,'36350','S','Midland City','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.278807,-85.501242,0,'2013-07-06 12:44:32',NULL,NULL),(50004,'57379','S','Virgil','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.322364,-98.408134,0,'2013-07-06 12:44:33',NULL,NULL),(56225,'65041','S','Case','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.697938,-91.437726,0,'2013-07-06 12:44:33',NULL,NULL),(67378,'80121','S','Cherry Hl Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(79908,'99599','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.215459,-149.870722,0,'2013-07-06 12:44:34',NULL,NULL),(35458,'39483','S','Pittman','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(60099,'71360','S','Lakeside','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(7789,'07424','S','West Paterson','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(35851,'39819','S','Bainbridge','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.901653,-84.567519,0,'2013-07-06 12:44:32',NULL,NULL),(7384,'06778','S','Northfield','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.703300,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(27206,'29907','S','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.427269,-80.702200,0,'2013-07-06 12:44:31',NULL,NULL),(21764,'23060','S','Glenallen','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.659630,-77.529243,0,'2013-07-06 12:44:31',NULL,NULL),(4448,'03247','P','Lakeport','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.547500,-71.407222,0,'2013-07-06 12:44:30',NULL,NULL),(54770,'62993','P','Tamms','A','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.236409,-89.269604,0,'2013-07-06 12:44:33',NULL,NULL),(74399,'92521','U','Univ of CA Riverside','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.972585,-117.350361,0,'2013-07-06 12:44:34',NULL,NULL),(74801,'93203','S','Arvin','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.213446,-118.854447,0,'2013-07-06 12:44:34',NULL,NULL),(3225,'01370','S','Baptist Corner','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.583380,-72.771540,0,'2013-07-06 12:44:30',NULL,NULL),(63105,'75277','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.738399,-96.746366,0,'2013-07-06 12:44:33',NULL,NULL),(54858,'63044','S','Bridgeton Terrace','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.760780,-90.412860,0,'2013-07-06 12:44:33',NULL,NULL),(1375,'00736','S','Villa Verde','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(79384,'98675','S','Yacolt','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.863047,-122.435554,0,'2013-07-06 12:44:34',NULL,NULL),(47760,'55030','S','Grasston','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.858693,-93.055173,0,'2013-07-06 12:44:33',NULL,NULL),(20523,'21092','P','Long Green','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.475296,-76.528579,0,'2013-07-06 12:44:31',NULL,NULL),(75196,'93620','S','Dos Palos','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.020964,-120.644224,0,'2013-07-06 12:44:34',NULL,NULL),(3522,'01888','P','Woburn','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.486156,-71.158082,0,'2013-07-06 12:44:30',NULL,NULL),(685,'00685','S','Bda Estalingrado','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(39342,'44622','S','Columbia','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.551120,-81.445800,0,'2013-07-06 12:44:32',NULL,NULL),(14822,'15424','S','Ursina','A','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.821640,-79.358280,0,'2013-07-06 12:44:31',NULL,NULL),(2747,'00969','S','Urb Ponce de Leon','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(33830,'37930','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.930170,-84.077513,0,'2013-07-06 12:44:32',NULL,NULL),(7052,'06282','S','Woodstock Valley','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.930860,-72.104123,0,'2013-07-06 12:44:30',NULL,NULL),(6976,'06241','S','Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.851822,-71.860430,0,'2013-07-06 12:44:30',NULL,NULL),(21719,'23002','S','Amelia Ch','N','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.390980,-77.904720,0,'2013-07-06 12:44:31',NULL,NULL),(20326,'20838','S','Barnesville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.234875,-77.348886,0,'2013-07-06 12:44:31',NULL,NULL),(44116,'49506','S','Forest Hills','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(45168,'50601','S','Ackley','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.552024,-93.052562,0,'2013-07-06 12:44:32',NULL,NULL),(62702,'74740','S','Haworth','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.845727,-94.648373,0,'2013-07-06 12:44:33',NULL,NULL),(63538,'75762','S','Dogwood City','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.221740,-95.396400,0,'2013-07-06 12:44:33',NULL,NULL),(78218,'97759','S','Tollgate','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.323931,-121.575944,0,'2013-07-06 12:44:34',NULL,NULL),(35008,'39144','S','Pattison','D','Claiborne','28021','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.851924,-90.804549,0,'2013-07-06 12:44:32',NULL,NULL),(4879,'04037','S','North Fryeburg','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.014772,-70.967645,0,'2013-07-06 12:44:30',NULL,NULL),(9665,'10040','S','Fort George','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(68139,'80977','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.772039,-104.665048,0,'2013-07-06 12:44:34',NULL,NULL),(17226,'17831','P','Hummels Wharf','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.773405,-76.964768,0,'2013-07-06 12:44:31',NULL,NULL),(11812,'12232','U','NY Dept Trans','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652603,-73.754055,0,'2013-07-06 12:44:30',NULL,NULL),(78548,'98146','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.500943,-122.357500,0,'2013-07-06 12:44:34',NULL,NULL),(60305,'71454','S','Pecan Acres','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(8686,'08341','S','Minotola','D','Atlantic','34001','New Jersey','NJ','34','0560','856','Eastern',-5.0,'Y',39.519078,-74.950352,0,'2013-07-06 12:44:30',NULL,NULL),(19806,'20441','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.923260,-77.034800,0,'2013-07-06 12:44:31',NULL,NULL),(31418,'34242','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.270991,-82.547525,0,'2013-07-06 12:44:32',NULL,NULL),(28119,'30812','P','Gracewood','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.373889,-82.026497,0,'2013-07-06 12:44:31',NULL,NULL),(5464,'04736','S','Connor Twp','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.847780,-68.010473,0,'2013-07-06 12:44:30',NULL,NULL),(43083,'48203','S','Highland Park','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424001,-83.101934,0,'2013-07-06 12:44:32',NULL,NULL),(61282,'72394','S','Widener','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.022701,-90.686118,0,'2013-07-06 12:44:33',NULL,NULL),(66482,'78664','S','Three Point','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.512352,-97.670283,0,'2013-07-06 12:44:34',NULL,NULL),(70900,'85621','S','Fairbank','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.382641,-110.941760,0,'2013-07-06 12:44:34',NULL,NULL),(73255,'90711','P','Lakewood','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.848941,-118.146773,0,'2013-07-06 12:44:34',NULL,NULL),(37515,'42040','S','Bell City','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.678450,-88.535796,0,'2013-07-06 12:44:32',NULL,NULL),(70701,'85266','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.487674,-111.926487,0,'2013-07-06 12:44:34',NULL,NULL),(73208,'90607','P','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.959614,-118.026554,0,'2013-07-06 12:44:34',NULL,NULL),(64957,'77241','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.858836,-95.537055,0,'2013-07-06 12:44:34',NULL,NULL),(69549,'83809','S','Careywood','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.068520,-116.599500,0,'2013-07-06 12:44:34',NULL,NULL),(70054,'84141','U','First Security Bank','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.668129,-111.861408,0,'2013-07-06 12:44:34',NULL,NULL),(62428,'74150','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.160850,-95.956181,0,'2013-07-06 12:44:33',NULL,NULL),(9027,'08873','S','Middlebush','N','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.499340,-74.521380,0,'2013-07-06 12:44:30',NULL,NULL),(39147,'44286','S','Richfield','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.231451,-81.641199,0,'2013-07-06 12:44:32',NULL,NULL),(32480,'36045','P','Tallassee','A','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.618799,-85.949542,0,'2013-07-06 12:44:32',NULL,NULL),(17911,'18453','S','Pleasant Mt','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.732223,-75.389178,0,'2013-07-06 12:44:31',NULL,NULL),(21615,'22904','S','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000947,-78.471158,0,'2013-07-06 12:44:31',NULL,NULL),(29117,'32311','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.425681,-84.177159,0,'2013-07-06 12:44:32',NULL,NULL),(23507,'25535','S','Lavalette','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.304182,-82.447328,0,'2013-07-06 12:44:31',NULL,NULL),(44418,'49834','S','Hardwood','A','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.083693,-87.778192,0,'2013-07-06 12:44:32',NULL,NULL),(47138,'54456','S','Christie','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.563991,-90.593555,0,'2013-07-06 12:44:32',NULL,NULL),(51061,'58746','S','Norma','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678244,-102.068686,0,'2013-07-06 12:44:33',NULL,NULL),(58245,'68358','S','Firth','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.536757,-96.608791,0,'2013-07-06 12:44:33',NULL,NULL),(61968,'73184','U','Globe Life and Accident Co','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.620834,-97.571442,0,'2013-07-06 12:44:33',NULL,NULL),(64937,'77221','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.701556,-95.352515,0,'2013-07-06 12:44:34',NULL,NULL),(68956,'82945','P','Superior','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.765269,-108.966414,0,'2013-07-06 12:44:34',NULL,NULL),(78682,'98245','S','Eastsound','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.707485,-122.916139,0,'2013-07-06 12:44:34',NULL,NULL),(42766,'48036','S','Clinton Township','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.593259,-82.911912,0,'2013-07-06 12:44:32',NULL,NULL),(30821,'33620','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060736,-82.410807,0,'2013-07-06 12:44:32',NULL,NULL),(58645,'68871','S','Bristol','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.119338,-98.859015,0,'2013-07-06 12:44:33',NULL,NULL),(54515,'62872','S','Marlow','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.276278,-88.754542,0,'2013-07-06 12:44:33',NULL,NULL),(13628,'13903','S','Conklin Forks','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.097500,-75.894240,0,'2013-07-06 12:44:31',NULL,NULL),(26400,'29108','S','Newberry','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.277092,-81.618636,0,'2013-07-06 12:44:31',NULL,NULL),(63106,'75277','U','Dallas City Water Dept','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.738399,-96.746366,0,'2013-07-06 12:44:33',NULL,NULL),(54657,'62932','S','Chamnesstown','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.911722,-89.233161,0,'2013-07-06 12:44:33',NULL,NULL),(30690,'33477','S','Jupiter','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.921272,-80.075932,0,'2013-07-06 12:44:32',NULL,NULL),(51543,'59729','S','Ennis','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.342760,-111.727330,0,'2013-07-06 12:44:33',NULL,NULL),(34966,'39077','P','Gallman','D','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.933678,-90.386888,0,'2013-07-06 12:44:32',NULL,NULL),(15661,'16801','S','State College','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.796516,-77.844795,0,'2013-07-06 12:44:31',NULL,NULL),(60985,'72110','S','Sandtown','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(29172,'32357','P','Shady Grove','D','Taylor','12123','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.285383,-83.629313,0,'2013-07-06 12:44:32',NULL,NULL),(20163,'20742','U','College Park','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.992333,-76.952986,0,'2013-07-06 12:44:31',NULL,NULL),(2218,'00926','S','Urb Caribe','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(80055,'99711','P','Badger','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.818214,-147.567698,0,'2013-07-06 12:44:34',NULL,NULL),(76991,'96070','P','Obrien','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.812222,-122.323056,0,'2013-07-06 12:44:34',NULL,NULL),(1223,'00728','S','Urb Rio Canas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(50454,'58021','S','Warren','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.715969,-97.069115,0,'2013-07-06 12:44:33',NULL,NULL),(48349,'55480','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.984744,-93.269393,0,'2013-07-06 12:44:33',NULL,NULL),(73650,'91496','U','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.163186,-118.456615,0,'2013-07-06 12:44:34',NULL,NULL),(69144,'83311','S','Albion','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.391988,-113.548093,0,'2013-07-06 12:44:34',NULL,NULL),(22832,'24514','U','Thomas Rd Bapt Church','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.365835,-79.215293,0,'2013-07-06 12:44:31',NULL,NULL),(49747,'57058','S','Unityville','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.737240,-97.384440,0,'2013-07-06 12:44:33',NULL,NULL),(2786,'00976','S','Saint Just','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(39347,'44624','S','Trail','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.656300,-81.691080,0,'2013-07-06 12:44:32',NULL,NULL),(70766,'85336','P','San Luis','N','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.551578,-114.772541,0,'2013-07-06 12:44:34',NULL,NULL),(35536,'39560','S','Long Beach','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.362985,-89.166163,0,'2013-07-06 12:44:32',NULL,NULL),(30890,'33702','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.844334,-82.643675,0,'2013-07-06 12:44:32',NULL,NULL),(4775,'03860','S','North Conway','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.041258,-71.131424,0,'2013-07-06 12:44:30',NULL,NULL),(70180,'84329','S','Rosette','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.827210,-113.269450,0,'2013-07-06 12:44:34',NULL,NULL),(64879,'77067','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.954058,-95.455417,0,'2013-07-06 12:44:34',NULL,NULL),(42402,'47740','U','Waterworks Dept','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.976389,-87.585504,0,'2013-07-06 12:44:32',NULL,NULL),(41389,'46803','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.070631,-85.101842,0,'2013-07-06 12:44:32',NULL,NULL),(59041,'70085','S','Hopedale','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(72398,'89043','S','Dry Valley','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(54700,'62951','S','Fergestown','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.819324,-88.924585,0,'2013-07-06 12:44:33',NULL,NULL),(47330,'54563','S','Tony','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.573335,-90.953398,0,'2013-07-06 12:44:32',NULL,NULL),(43834,'49091','S','Sturgis','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.814747,-85.431390,0,'2013-07-06 12:44:32',NULL,NULL),(48174,'55380','S','Silver Creek','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.332131,-93.954696,0,'2013-07-06 12:44:33',NULL,NULL),(64328,'76501','S','Oenaville','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(64351,'76519','S','Cyclone','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.959980,-96.867177,0,'2013-07-06 12:44:34',NULL,NULL),(37081,'41332','S','Insko','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.796026,-83.456314,0,'2013-07-06 12:44:32',NULL,NULL),(76882,'95977','S','Big Oak Vly','A','Nevada','06057','California','CA','06','9340','530','Pacific',-8.0,'Y',39.197157,-121.253817,0,'2013-07-06 12:44:34',NULL,NULL),(65071,'77347','P','Humble','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.991455,-95.251652,0,'2013-07-06 12:44:34',NULL,NULL),(64410,'76544','S','Montague Village','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(17689,'18202','S','W Hazleton','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(62733,'74825','S','Allen','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.877567,-96.412377,0,'2013-07-06 12:44:33',NULL,NULL),(29776,'33014','S','Hialeah Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.901437,-80.306472,0,'2013-07-06 12:44:32',NULL,NULL),(8388,'08060','S','Eastampton','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(37598,'42123','S','Cooktown','N','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.822874,-85.994572,0,'2013-07-06 12:44:32',NULL,NULL),(39952,'45233','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.119196,-84.669399,0,'2013-07-06 12:44:32',NULL,NULL),(78612,'98198','S','Normandy Park','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.405098,-122.310024,0,'2013-07-06 12:44:34',NULL,NULL),(70590,'85085','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.763610,-112.110839,0,'2013-07-06 12:44:34',NULL,NULL),(17699,'18218','S','Coaldale','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820684,-75.912612,0,'2013-07-06 12:44:31',NULL,NULL),(24558,'27295','S','Lexington','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.809988,-80.258118,0,'2013-07-06 12:44:31',NULL,NULL),(14389,'15045','S','Glassport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.327068,-79.890734,0,'2013-07-06 12:44:31',NULL,NULL),(4732,'03830','S','Wakefield','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.568056,-71.030556,0,'2013-07-06 12:44:30',NULL,NULL),(79592,'99034','S','Tum Tum','N','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.890134,-117.774983,0,'2013-07-06 12:44:34',NULL,NULL),(6514,'05822','S','West Glover','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.752209,-72.184037,0,'2013-07-06 12:44:30',NULL,NULL),(16321,'17122','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263288,-76.881597,0,'2013-07-06 12:44:31',NULL,NULL),(68616,'81623','S','El Jebel','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.416703,-107.189562,0,'2013-07-06 12:44:34',NULL,NULL),(65385,'77550','S','Island','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.301240,-94.788420,0,'2013-07-06 12:44:34',NULL,NULL),(63956,'76092','S','South Lake','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.953968,-97.150453,0,'2013-07-06 12:44:34',NULL,NULL),(247,'00637','S','Urb La Milagrosa','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(63092,'75260','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.772403,-96.825763,0,'2013-07-06 12:44:33',NULL,NULL),(60279,'71449','S','Many','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(68961,'83002','P','Jackson','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472865,-110.763529,0,'2013-07-06 12:44:34',NULL,NULL),(51550,'59736','S','Jackson','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.398432,-113.455323,0,'2013-07-06 12:44:33',NULL,NULL),(5078,'04292','S','Sumner','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.374681,-70.484850,0,'2013-07-06 12:44:30',NULL,NULL),(23541,'25611','P','Bruno','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.692032,-81.869387,0,'2013-07-06 12:44:31',NULL,NULL),(38092,'43080','S','Etna','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.230307,-82.454626,0,'2013-07-06 12:44:32',NULL,NULL),(165,'00623','S','Alts del Mar','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(16048,'17044','S','Vira','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(54958,'63120','S','Goodfellow Terrace','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.690003,-90.261886,0,'2013-07-06 12:44:33',NULL,NULL),(59363,'70582','S','Parks','A','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.139877,-91.822998,0,'2013-07-06 12:44:33',NULL,NULL),(16540,'17302','S','Muddy Creek Forks','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(79332,'98612','S','Puget Island','N','Wahkiakum','53069','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.210920,-123.335040,0,'2013-07-06 12:44:34',NULL,NULL),(19607,'20232','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.919252,-77.036045,0,'2013-07-06 12:44:31',NULL,NULL),(42306,'47601','S','Bullocktown','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(46695,'53786','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077126,-89.380448,0,'2013-07-06 12:44:32',NULL,NULL),(60372,'71483','S','Colgrade','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.922636,-92.645336,0,'2013-07-06 12:44:33',NULL,NULL),(40773,'46157','S','Monrovia','D','Morgan','18109','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.570970,-86.521600,0,'2013-07-06 12:44:32',NULL,NULL),(76112,'95232','S','Glencoe','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.328099,-120.543595,0,'2013-07-06 12:44:34',NULL,NULL),(26276,'29014','S','Stover','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.573234,-80.987145,0,'2013-07-06 12:44:31',NULL,NULL),(68871,'82639','S','Mayoworth','A','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.748572,-106.551114,0,'2013-07-06 12:44:34',NULL,NULL),(76714,'95843','S','Antelope','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.686118,-121.380837,0,'2013-07-06 12:44:34',NULL,NULL),(61561,'72719','S','Centerton','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.374201,-94.317969,0,'2013-07-06 12:44:33',NULL,NULL),(33005,'36663','P','Eight Mile','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.762053,-88.128625,0,'2013-07-06 12:44:32',NULL,NULL),(69963,'84119','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(43173,'48277','U','Chase Bank','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.325731,-83.056878,0,'2013-07-06 12:44:32',NULL,NULL),(11108,'11701','S','North Amityville','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.686293,-73.412179,0,'2013-07-06 12:44:30',NULL,NULL),(7900,'07603','S','Bogota','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.874605,-74.024967,0,'2013-07-06 12:44:30',NULL,NULL),(56001,'64644','S','Hamilton','D','Caldwell','29025','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.743022,-93.997309,0,'2013-07-06 12:44:33',NULL,NULL),(7795,'07432','S','Midland Pk','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.995725,-74.139296,0,'2013-07-06 12:44:30',NULL,NULL),(63904,'76028','S','Cross Timber','A','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.529531,-97.311978,0,'2013-07-06 12:44:34',NULL,NULL),(19452,'20120','S','Centreville','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.850947,-77.461130,0,'2013-07-06 12:44:31',NULL,NULL),(43462,'48552','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.990914,-83.711409,0,'2013-07-06 12:44:32',NULL,NULL),(18687,'19188','U','Hosiery Corp Of America','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963336,-75.159526,0,'2013-07-06 12:44:31',NULL,NULL),(14684,'15251','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.444752,-79.951563,0,'2013-07-06 12:44:31',NULL,NULL),(57643,'67156','S','New Salem','N','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.232820,-96.954840,0,'2013-07-06 12:44:33',NULL,NULL),(59389,'70611','S','Moss Bluff','A','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.336660,-93.203040,0,'2013-07-06 12:44:33',NULL,NULL),(72147,'88321','S','Milagro','N','Torrance','35057','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.593805,-105.496912,0,'2013-07-06 12:44:34',NULL,NULL),(71835,'87579','S','Tres Ritos','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(68986,'83121','P','Frontier','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.812622,-110.536977,0,'2013-07-06 12:44:34',NULL,NULL),(20371,'20879','S','Laytonsville','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.177540,-77.194392,0,'2013-07-06 12:44:31',NULL,NULL),(42467,'47834','S','Billville','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(11950,'12446','S','Cherrytown','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.812920,-74.294880,0,'2013-07-06 12:44:30',NULL,NULL),(46941,'54162','S','South Chase','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.651006,-88.212562,0,'2013-07-06 12:44:32',NULL,NULL),(14038,'14550','S','Silver Springs','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.672990,-78.094390,0,'2013-07-06 12:44:31',NULL,NULL),(67890,'80863','S','Woodland Park','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.992976,-105.071027,0,'2013-07-06 12:44:34',NULL,NULL),(64594,'76679','S','Navarro Mills','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.949322,-96.573146,0,'2013-07-06 12:44:34',NULL,NULL),(25362,'28237','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.216255,-80.828169,0,'2013-07-06 12:44:31',NULL,NULL),(13231,'13637','S','Pamelia Four Corners','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.090947,-75.804665,0,'2013-07-06 12:44:30',NULL,NULL),(48327,'55449','S','Blaine','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.166800,-93.189660,0,'2013-07-06 12:44:33',NULL,NULL),(60456,'71653','S','Jennie','A','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(20158,'20740','S','Berwyn Heights','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998722,-76.928721,0,'2013-07-06 12:44:31',NULL,NULL),(69003,'83203','P','Fort Hall Indian Reservation','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.990305,-112.424758,0,'2013-07-06 12:44:34',NULL,NULL),(73866,'91915','S','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.629740,-116.939565,0,'2013-07-06 12:44:34',NULL,NULL),(33517,'37375','S','Saint Andrews','A','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.204551,-85.919546,0,'2013-07-06 12:44:32',NULL,NULL),(834,'00694','P','Vega Baja','D','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444623,-66.402557,0,'2013-07-06 12:44:30',NULL,NULL),(53008,'61455','S','Macomb','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.457219,-90.674006,0,'2013-07-06 12:44:33',NULL,NULL),(72114,'88252','S','Bennett','N','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.112508,-103.194980,0,'2013-07-06 12:44:34',NULL,NULL),(74682,'92878','P','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.874330,-117.565154,0,'2013-07-06 12:44:34',NULL,NULL),(3396,'01614','P','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.260921,-71.799490,0,'2013-07-06 12:44:30',NULL,NULL),(19078,'19560','S','Spring Valley','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.396140,-75.889620,0,'2013-07-06 12:44:31',NULL,NULL),(47984,'55128','S','Landfall Village','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.007260,-92.964120,0,'2013-07-06 12:44:33',NULL,NULL),(53133,'61550','S','Field Shopping Center','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613787,-89.463814,0,'2013-07-06 12:44:33',NULL,NULL),(59944,'71301','S','Camp Stafford','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(10074,'10185','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(25750,'28577','S','Sealevel','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.893197,-76.392189,0,'2013-07-06 12:44:31',NULL,NULL),(66839,'79111','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.217768,-101.689855,0,'2013-07-06 12:44:34',NULL,NULL),(67434,'80165','U','Littleton City Offices','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595884,-105.008265,0,'2013-07-06 12:44:34',NULL,NULL),(76048,'95173','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.334594,-121.893325,0,'2013-07-06 12:44:34',NULL,NULL),(17722,'18242','P','Oneida','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.909404,-76.133243,0,'2013-07-06 12:44:31',NULL,NULL),(54822,'63025','S','Crescent','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(40008,'45245','S','Cincinnati','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.069523,-84.277672,0,'2013-07-06 12:44:32',NULL,NULL),(24362,'27048','S','Stoneville','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.461117,-79.907962,0,'2013-07-06 12:44:31',NULL,NULL),(42219,'47558','S','Hudsonville','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.623171,-87.044863,0,'2013-07-06 12:44:32',NULL,NULL),(46043,'52562','S','Hayesville','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.332615,-92.181871,0,'2013-07-06 12:44:32',NULL,NULL),(47172,'54479','S','Riplinger','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.756325,-90.297794,0,'2013-07-06 12:44:32',NULL,NULL),(60542,'71701','S','East Camden','A','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.581400,-92.819340,0,'2013-07-06 12:44:33',NULL,NULL),(61505,'72650','S','Canaan','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.940312,-92.656563,0,'2013-07-06 12:44:33',NULL,NULL),(49636,'56944','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(52157,'60448','S','Mokena','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.533318,-87.888034,0,'2013-07-06 12:44:33',NULL,NULL),(4675,'03784','S','W Lebanon','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.652405,-72.304175,0,'2013-07-06 12:44:30',NULL,NULL),(46628,'53582','S','Ridgeway','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.998132,-89.996343,0,'2013-07-06 12:44:32',NULL,NULL),(25968,'28659','S','Call','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(19070,'19554','P','Shartlesville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.513720,-76.105043,0,'2013-07-06 12:44:31',NULL,NULL),(4277,'02891','S','Watch Hill','N','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.362200,-71.796000,0,'2013-07-06 12:44:30',NULL,NULL),(14520,'15203','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.424202,-79.975101,0,'2013-07-06 12:44:31',NULL,NULL),(28467,'31419','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.979874,-81.180758,0,'2013-07-06 12:44:32',NULL,NULL),(58474,'68743','S','Jackson','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.467929,-96.580412,0,'2013-07-06 12:44:33',NULL,NULL),(69384,'83611','S','Cascade','D','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.393460,-115.981260,0,'2013-07-06 12:44:34',NULL,NULL),(76365,'95494','S','Yorkville','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.896250,-123.229549,0,'2013-07-06 12:44:34',NULL,NULL),(4764,'03854','P','Newcastle','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.068790,-70.719895,0,'2013-07-06 12:44:30',NULL,NULL),(31383,'34217','S','Bradenton Beach','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.508565,-82.716234,0,'2013-07-06 12:44:32',NULL,NULL),(24244,'26763','S','Springfield','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.468141,-78.699250,0,'2013-07-06 12:44:31',NULL,NULL),(12240,'12822','S','Corinth','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.242443,-73.838394,0,'2013-07-06 12:44:30',NULL,NULL),(10966,'11518','S','E Rockaway','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.641066,-73.666046,0,'2013-07-06 12:44:30',NULL,NULL),(68731,'82190','S','Yellowstone National Park','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.975150,-110.694710,0,'2013-07-06 12:44:34',NULL,NULL),(72354,'89020','S','Amargosa Vly','A','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.490016,-116.390342,0,'2013-07-06 12:44:34',NULL,NULL),(76610,'95691','S','W Sacramento','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.562100,-121.541198,0,'2013-07-06 12:44:34',NULL,NULL),(7353,'06726','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.555029,-73.037976,0,'2013-07-06 12:44:30',NULL,NULL),(35647,'39641','S','Jayess','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(49983,'57364','S','Joubert','N','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.438098,-98.647921,0,'2013-07-06 12:44:33',NULL,NULL),(47594,'54865','S','Port Wing','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.730386,-91.391591,0,'2013-07-06 12:44:33',NULL,NULL),(22153,'23459','S','Nav Amph Base','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(23972,'26301','S','Dawmont','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(42343,'47638','S','Blairsville','N','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.075839,-87.761568,0,'2013-07-06 12:44:32',NULL,NULL),(25495,'28366','S','Newton Grove','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.017786,-78.501727,0,'2013-07-06 12:44:31',NULL,NULL),(66714,'78949','S','Muldoon','D','Fayette','48149','Texas','TX','48','0000','512/737','Central',-6.0,'Y',29.798228,-97.092113,0,'2013-07-06 12:44:34',NULL,NULL),(5659,'04961','S','Dead River TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(25361,'28236','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.290104,-81.013101,0,'2013-07-06 12:44:31',NULL,NULL),(26107,'28723','S','Cullowhee','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.284272,-83.179192,0,'2013-07-06 12:44:31',NULL,NULL),(29458,'32713','S','Debary','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.882535,-81.306446,0,'2013-07-06 12:44:32',NULL,NULL),(47634,'54914','S','Grand Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.271885,-88.437781,0,'2013-07-06 12:44:33',NULL,NULL),(57610,'67119','S','Oxford','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.276202,-97.170267,0,'2013-07-06 12:44:33',NULL,NULL),(58984,'70049','S','Edgard','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.033660,-90.556620,0,'2013-07-06 12:44:33',NULL,NULL),(60521,'71667','S','Tarry','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(62538,'74432','S','Eufaula','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.288414,-95.585124,0,'2013-07-06 12:44:33',NULL,NULL),(76401,'95546','S','Hoopa Valley Indian Reservat','N','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',41.168795,-123.727286,0,'2013-07-06 12:44:34',NULL,NULL),(14268,'14846','S','Hunt','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.558498,-78.003025,0,'2013-07-06 12:44:31',NULL,NULL),(20578,'21154','S','Street','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.652920,-76.376820,0,'2013-07-06 12:44:31',NULL,NULL),(39801,'45135','S','Highland County','A','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(39665,'45011','S','Village Of Indian Springs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(20425,'20912','S','Takoma Park','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.985658,-77.005547,0,'2013-07-06 12:44:31',NULL,NULL),(7883,'07513','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.907163,-74.148803,0,'2013-07-06 12:44:30',NULL,NULL),(12923,'13340','S','Frankfort','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.040165,-75.082322,0,'2013-07-06 12:44:30',NULL,NULL),(65830,'78150','S','Universal City','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(75662,'94538','S','Fremont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.526834,-121.965639,0,'2013-07-06 12:44:34',NULL,NULL),(76434,'95602','S','Auburn','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.985263,-121.123044,0,'2013-07-06 12:44:34',NULL,NULL),(6075,'05447','S','E Berkshire','A','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.930619,-72.710708,0,'2013-07-06 12:44:30',NULL,NULL),(17138,'17779','P','Woolrich','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.188628,-77.374922,0,'2013-07-06 12:44:31',NULL,NULL),(2454,'00953','S','Valle Del Paraiso','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(16786,'17535','S','Buyerstown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.007451,-76.042530,0,'2013-07-06 12:44:31',NULL,NULL),(2121,'00924','S','Colinas de Monte Carlo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(26104,'28720','P','Chimney Rock','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.437008,-82.244140,0,'2013-07-06 12:44:31',NULL,NULL),(52823,'61301','S','Dimmick','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.355630,-89.094865,0,'2013-07-06 12:44:33',NULL,NULL),(54902,'63077','S','Saint Clair','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.335319,-90.973118,0,'2013-07-06 12:44:33',NULL,NULL),(63338,'75602','S','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.473920,-94.684860,0,'2013-07-06 12:44:33',NULL,NULL),(49761,'57067','S','Utica','D','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.962076,-97.507277,0,'2013-07-06 12:44:33',NULL,NULL),(41641,'47133','U','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287708,-85.736180,0,'2013-07-06 12:44:32',NULL,NULL),(31976,'35216','S','Vestavia','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(29589,'32827','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.427444,-81.316938,0,'2013-07-06 12:44:32',NULL,NULL),(1827,'00784','S','Urb Camino de La Princesa','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(26159,'28743','S','Bluff','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(59890,'71270','S','Woodville','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(8882,'08721','S','Berkeley Township','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.906120,-74.174220,0,'2013-07-06 12:44:30',NULL,NULL),(6556,'05845','S','Irasburg','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.820600,-72.278400,0,'2013-07-06 12:44:30',NULL,NULL),(26324,'29047','S','Felderville','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.531329,-80.571823,0,'2013-07-06 12:44:31',NULL,NULL),(2791,'00976','S','Urb Corrientes','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(17170,'17814','S','Red Rock','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(1117,'00725','S','Urb Santa Juana 4','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(2785,'00976','S','Repto San Rafael','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(21646,'22935','S','Boonesville','A','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.264055,-78.574641,0,'2013-07-06 12:44:31',NULL,NULL),(48799,'56009','S','Alden','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.668147,-93.574066,0,'2013-07-06 12:44:33',NULL,NULL),(50640,'58301','S','Devils Lk','N','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.112685,-98.856665,0,'2013-07-06 12:44:33',NULL,NULL),(52484,'60694','U','Harris Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.877882,-87.629688,0,'2013-07-06 12:44:33',NULL,NULL),(61063,'72124','P','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.811333,-92.234881,0,'2013-07-06 12:44:33',NULL,NULL),(66790,'79053','P','Lazbuddie','D','Parmer','48369','Texas','TX','48','0000','806','Central',-6.0,'Y',34.394728,-102.889672,0,'2013-07-06 12:44:34',NULL,NULL),(26074,'28698','S','Silverstone','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.331209,-81.739210,0,'2013-07-06 12:44:31',NULL,NULL),(3782,'02204','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.395030,-71.050270,0,'2013-07-06 12:44:30',NULL,NULL),(58122,'68130','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.237517,-96.169978,0,'2013-07-06 12:44:33',NULL,NULL),(55158,'63366','S','O Fallon','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(65930,'78248','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584143,-98.523204,0,'2013-07-06 12:44:34',NULL,NULL),(32660,'36258','S','Christiana','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.454247,-85.684409,0,'2013-07-06 12:44:32',NULL,NULL),(25893,'28643','S','Dolinger','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(66254,'78572','S','Sharyland','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(43537,'48667','U','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.610465,-84.237362,0,'2013-07-06 12:44:32',NULL,NULL),(42998,'48160','S','London Twp','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(67783,'80654','S','Wiggins','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.157963,-104.074736,0,'2013-07-06 12:44:34',NULL,NULL),(75859,'94941','S','Mill Valley','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.890300,-122.567640,0,'2013-07-06 12:44:34',NULL,NULL),(50046,'57434','S','Verdon','A','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.165262,-98.015514,0,'2013-07-06 12:44:33',NULL,NULL),(29753,'33001','P','Conch Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.816667,-80.816667,0,'2013-07-06 12:44:32',NULL,NULL),(4513,'03299','U','J Jill','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.639447,-71.526265,0,'2013-07-06 12:44:30',NULL,NULL),(4813,'03896','P','Wolfeboro Fls','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.587884,-71.207648,0,'2013-07-06 12:44:30',NULL,NULL),(11272,'11771','S','Cove Neck','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(23486,'25511','S','Dunlow','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.036055,-82.342780,0,'2013-07-06 12:44:31',NULL,NULL),(10522,'10980','S','Grassy Point','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.236440,-74.011260,0,'2013-07-06 12:44:30',NULL,NULL),(4533,'03441','S','Ashuelot','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.785208,-72.433601,0,'2013-07-06 12:44:30',NULL,NULL),(50935,'58570','S','Timmer','N','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.276735,-100.808228,0,'2013-07-06 12:44:33',NULL,NULL),(61085,'72131','S','Pearson','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.378007,-92.210229,0,'2013-07-06 12:44:33',NULL,NULL),(429,'00662','S','Sect Las Marias','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(59273,'70457','P','St Benedict','A','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.524851,-90.094566,0,'2013-07-06 12:44:33',NULL,NULL),(36520,'40831','S','Harlan','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.846189,-83.314477,0,'2013-07-06 12:44:32',NULL,NULL),(28355,'31204','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.842317,-83.677163,0,'2013-07-06 12:44:32',NULL,NULL),(26008,'28675','S','Whitehead','A','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.506191,-81.117283,0,'2013-07-06 12:44:31',NULL,NULL),(68240,'81054','S','Toonerville','N','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(32038,'35244','S','Hoover','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.361710,-86.788783,0,'2013-07-06 12:44:32',NULL,NULL),(60943,'72099','U','Little Rock Air Force Base','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(629,'00682','S','Parq De La Ceiba','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(35940,'40052','S','New Hope','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.611523,-85.515059,0,'2013-07-06 12:44:32',NULL,NULL),(4694,'03812','S','Harts Lctn','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.088653,-71.280179,0,'2013-07-06 12:44:30',NULL,NULL),(48628,'55805','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.796549,-92.094486,0,'2013-07-06 12:44:33',NULL,NULL),(48630,'55807','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.739838,-92.167853,0,'2013-07-06 12:44:33',NULL,NULL),(49261,'56479','S','Poplar','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.353921,-94.795227,0,'2013-07-06 12:44:33',NULL,NULL),(59205,'70391','P','Paincourtville','D','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.990731,-91.055924,0,'2013-07-06 12:44:33',NULL,NULL),(60529,'71674','S','Kelso','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.798097,-91.302406,0,'2013-07-06 12:44:33',NULL,NULL),(65894,'78232','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584537,-98.475424,0,'2013-07-06 12:44:34',NULL,NULL),(78822,'98335','S','Crescent Valley','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(35463,'39502','P','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.389224,-89.099424,0,'2013-07-06 12:44:32',NULL,NULL),(16458,'17241','S','Dickinson','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(44908,'50327','S','Pleasant Hill','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.578216,-93.491427,0,'2013-07-06 12:44:32',NULL,NULL),(23970,'26301','S','Clarksburg','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(11813,'12233','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.649243,-73.755554,0,'2013-07-06 12:44:30',NULL,NULL),(1049,'00723','S','Urb Solimar','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(5731,'05032','S','Olympus','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.810080,-72.656700,0,'2013-07-06 12:44:30',NULL,NULL),(37610,'42129','S','Sulphur Well','A','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(56815,'65778','S','Myrtle','D','Oregon','29149','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.518344,-91.257862,0,'2013-07-06 12:44:33',NULL,NULL),(27902,'30474','S','Petross','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(68687,'82009','S','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.207382,-104.827712,0,'2013-07-06 12:44:34',NULL,NULL),(41215,'46731','S','Craigville','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.778549,-85.098739,0,'2013-07-06 12:44:32',NULL,NULL),(63978,'76107','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.743320,-97.380480,0,'2013-07-06 12:44:34',NULL,NULL),(59096,'70126','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.017111,-90.019351,0,'2013-07-06 12:44:33',NULL,NULL),(10790,'11369','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.765278,-73.817778,0,'2013-07-06 12:44:30',NULL,NULL),(32329,'35768','S','Scottsboro','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.916550,-86.087910,0,'2013-07-06 12:44:32',NULL,NULL),(43615,'48807','S','Bannister','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.140978,-84.424584,0,'2013-07-06 12:44:32',NULL,NULL),(47317,'54557','S','Winchester','A','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.223820,-89.758920,0,'2013-07-06 12:44:32',NULL,NULL),(60422,'71642','S','Fort Hill','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.344234,-91.818649,0,'2013-07-06 12:44:33',NULL,NULL),(9099,'09069','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33201,'37043','S','Hilldale','N','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.492780,-87.233460,0,'2013-07-06 12:44:32',NULL,NULL),(79622,'99122','S','Davenport','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.655779,-118.147962,0,'2013-07-06 12:44:34',NULL,NULL),(61047,'72119','P','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.763985,-92.258586,0,'2013-07-06 12:44:33',NULL,NULL),(22149,'23458','P','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.853343,-75.975659,0,'2013-07-06 12:44:31',NULL,NULL),(37,'00603','S','Urb Rubianes','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(39987,'45241','S','Blue Ash','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267662,-84.405863,0,'2013-07-06 12:44:32',NULL,NULL),(6719,'06069','S','West Woods','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.865139,-73.455872,0,'2013-07-06 12:44:30',NULL,NULL),(30415,'33326','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(14334,'15003','S','Fair Oaks','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.582123,-80.214863,0,'2013-07-06 12:44:31',NULL,NULL),(10385,'10596','P','Verplanck','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.256445,-73.959330,0,'2013-07-06 12:44:30',NULL,NULL),(9421,'10002','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(10107,'10256','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706232,-74.010903,0,'2013-07-06 12:44:30',NULL,NULL),(43227,'48312','S','St Heights','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.556244,-83.006843,0,'2013-07-06 12:44:32',NULL,NULL),(46402,'53168','S','Paddock Lake','N','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.578640,-88.136640,0,'2013-07-06 12:44:32',NULL,NULL),(51140,'58831','S','Rawson','A','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.855481,-103.642519,0,'2013-07-06 12:44:33',NULL,NULL),(77235,'96521','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(38651,'43938','S','New Alexandria','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.315500,-80.626200,0,'2013-07-06 12:44:32',NULL,NULL),(26093,'28713','S','Ela','N','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.401379,-83.467681,0,'2013-07-06 12:44:31',NULL,NULL),(7057,'06320','S','Us Coast Guard Acad','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.351139,-72.108165,0,'2013-07-06 12:44:30',NULL,NULL),(75078,'93532','S','Sandberg','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(5526,'04779','S','Cross Lake Twp','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.170980,-68.304902,0,'2013-07-06 12:44:30',NULL,NULL),(18089,'18706','S','Wlks Barr Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(29073,'32254','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.338709,-81.727618,0,'2013-07-06 12:44:32',NULL,NULL),(53328,'61749','S','Kenney','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.093731,-89.081482,0,'2013-07-06 12:44:33',NULL,NULL),(8209,'07939','S','Lyons','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.679559,-74.567323,0,'2013-07-06 12:44:30',NULL,NULL),(35580,'39573','S','Big Level','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(11456,'11980','S','Carver Park','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.838524,-72.933522,0,'2013-07-06 12:44:30',NULL,NULL),(30502,'33402','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.717231,-80.051556,0,'2013-07-06 12:44:32',NULL,NULL),(23215,'25075','S','Ohley','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(42016,'47433','S','Baker','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.302962,-86.623199,0,'2013-07-06 12:44:32',NULL,NULL),(46391,'53151','S','New Berlin','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.976655,-88.098995,0,'2013-07-06 12:44:32',NULL,NULL),(47586,'54856','S','Delta','A','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.439280,-91.085880,0,'2013-07-06 12:44:33',NULL,NULL),(59333,'70538','S','Franklin','D','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.796186,-91.507053,0,'2013-07-06 12:44:33',NULL,NULL),(61755,'73049','S','Jones','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.570334,-97.323953,0,'2013-07-06 12:44:33',NULL,NULL),(22757,'24426','S','Cmp Appalchia','N','Covington City','51580','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.751640,-80.045760,0,'2013-07-06 12:44:31',NULL,NULL),(32381,'35905','S','Glencoe','A','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.954808,-85.903321,0,'2013-07-06 12:44:32',NULL,NULL),(26657,'29372','S','Pacolet','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.898710,-81.758466,0,'2013-07-06 12:44:31',NULL,NULL),(30178,'33176','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(2647,'00966','S','Ext Villa Caparra','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(64819,'77029','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.767222,-95.233611,0,'2013-07-06 12:44:34',NULL,NULL),(69603,'83854','S','Post Falls','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.740920,-116.944800,0,'2013-07-06 12:44:34',NULL,NULL),(49936,'57330','S','Delmont','D','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.299981,-98.212417,0,'2013-07-06 12:44:33',NULL,NULL),(15344,'16233','S','Leeper','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.360556,-79.293356,0,'2013-07-06 12:44:31',NULL,NULL),(36269,'40336','S','Irvine','D','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(28841,'32086','S','Saint Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.759403,-81.303970,0,'2013-07-06 12:44:32',NULL,NULL),(42926,'48114','S','Brighton','D','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.529992,-83.782845,0,'2013-07-06 12:44:32',NULL,NULL),(47010,'54303','S','Howard','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.529758,-88.061259,0,'2013-07-06 12:44:32',NULL,NULL),(48299,'55439','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.875459,-93.374350,0,'2013-07-06 12:44:33',NULL,NULL),(48880,'56093','S','Otisco','A','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.080423,-93.503192,0,'2013-07-06 12:44:33',NULL,NULL),(51169,'59004','U','Saint Labre Mission','N','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.621966,-106.314153,0,'2013-07-06 12:44:33',NULL,NULL),(57191,'66418','S','Delia','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.285279,-95.955597,0,'2013-07-06 12:44:33',NULL,NULL),(6623,'05903','S','Lemington','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.972195,-71.584884,0,'2013-07-06 12:44:30',NULL,NULL),(658,'00683','S','Hacienda La Monserrate','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(45374,'51015','S','Climbing Hill','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.347865,-96.093439,0,'2013-07-06 12:44:32',NULL,NULL),(25064,'27932','S','Edenton','D','Chowan','37041','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.115773,-76.642747,0,'2013-07-06 12:44:31',NULL,NULL),(29749,'32976','S','Barefoot Bay','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.880728,-80.516230,0,'2013-07-06 12:44:32',NULL,NULL),(36794,'41052','S','Jonesville','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.661690,-84.772325,0,'2013-07-06 12:44:32',NULL,NULL),(24023,'26376','S','Ireland','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.753333,-80.438333,0,'2013-07-06 12:44:31',NULL,NULL),(15162,'15909','S','Conemaugh','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.357965,-78.876651,0,'2013-07-06 12:44:31',NULL,NULL),(55288,'63501','S','Kirksville','D','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(61667,'72918','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.301729,-94.408019,0,'2013-07-06 12:44:33',NULL,NULL),(41606,'47117','S','Elizabeth','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.115905,-86.055376,0,'2013-07-06 12:44:32',NULL,NULL),(51472,'59532','S','Kremlin','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.567704,-110.047892,0,'2013-07-06 12:44:33',NULL,NULL),(28587,'31636','S','Lake Park','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.687100,-83.202030,0,'2013-07-06 12:44:32',NULL,NULL),(42860,'48080','S','St Clr Shores','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465933,-82.903852,0,'2013-07-06 12:44:32',NULL,NULL),(1254,'00729','S','Urb Pueblo Indio','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(68460,'81231','U','Western State College','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.548638,-106.918609,0,'2013-07-06 12:44:34',NULL,NULL),(77758,'97110','P','Cannon Beach','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.890942,-123.958453,0,'2013-07-06 12:44:34',NULL,NULL),(40932,'46285','U','Eli Lilly Co','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.743009,-86.162811,0,'2013-07-06 12:44:32',NULL,NULL),(72156,'88330','S','Holloman AFB','A','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.820176,-105.935630,0,'2013-07-06 12:44:34',NULL,NULL),(51538,'59724','P','Dell','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',44.723990,-112.700150,0,'2013-07-06 12:44:33',NULL,NULL),(47655,'54935','S','Fdl','N','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.775242,-88.431561,0,'2013-07-06 12:44:33',NULL,NULL),(44313,'49739','U','Grayling','D','Crawford','26039','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.621842,-84.784785,0,'2013-07-06 12:44:32',NULL,NULL),(6259,'05602','S','Jones Brook','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(32178,'35482','P','Samantha','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.456558,-87.670475,0,'2013-07-06 12:44:32',NULL,NULL),(36387,'40486','S','Herd','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.378148,-83.874828,0,'2013-07-06 12:44:32',NULL,NULL),(2538,'00959','S','Colinas Vista Alegre','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(41493,'46947','S','Logansport','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.789744,-86.408796,0,'2013-07-06 12:44:32',NULL,NULL),(19671,'20319','U','Fort McNair','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877830,-77.018020,0,'2013-07-06 12:44:31',NULL,NULL),(1772,'00780','S','Urb Santa Rita 2','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(3414,'01718','S','Vlg of Nagog Woods','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.517046,-71.412305,0,'2013-07-06 12:44:30',NULL,NULL),(35715,'39669','S','Doloroso','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(15255,'16056','S','Saxonburg','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.725323,-79.839817,0,'2013-07-06 12:44:31',NULL,NULL),(32396,'35954','S','Ridgeville','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.083060,-86.060280,0,'2013-07-06 12:44:32',NULL,NULL),(78469,'98077','S','Woodinville','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.749870,-122.098319,0,'2013-07-06 12:44:34',NULL,NULL),(75980,'95066','S','Scotts Valley','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.071000,-122.010600,0,'2013-07-06 12:44:34',NULL,NULL),(66239,'78570','S','Heidelberg','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160480,-97.919820,0,'2013-07-06 12:44:34',NULL,NULL),(62111,'73641','S','Dill City','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.278526,-99.129216,0,'2013-07-06 12:44:33',NULL,NULL),(48176,'55382','S','Saint Augusta','A','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.347660,-94.185903,0,'2013-07-06 12:44:33',NULL,NULL),(44549,'50006','S','Buckeye','A','Hardin','19083','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.518788,-93.372170,0,'2013-07-06 12:44:32',NULL,NULL),(26529,'29203','S','Eau Claire','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(7486,'06905','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.085715,-73.541654,0,'2013-07-06 12:44:30',NULL,NULL),(34520,'38679','P','Victoria','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.885729,-89.510380,0,'2013-07-06 12:44:32',NULL,NULL),(36501,'40819','S','Molus','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.874620,-83.440320,0,'2013-07-06 12:44:32',NULL,NULL),(37341,'41701','S','Darfork','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.253627,-83.184866,0,'2013-07-06 12:44:32',NULL,NULL),(38576,'43787','S','Stockport','D','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.557874,-81.770693,0,'2013-07-06 12:44:32',NULL,NULL),(56294,'65081','S','Tipton','D','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.654674,-92.779444,0,'2013-07-06 12:44:33',NULL,NULL),(9424,'10002','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(11800,'12226','S','NY State Campus','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.684962,-73.807547,0,'2013-07-06 12:44:30',NULL,NULL),(4346,'03043','S','Francestown','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.002197,-71.866335,0,'2013-07-06 12:44:30',NULL,NULL),(56948,'66093','S','Westphalia','D','Anderson','20003','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.152826,-95.456557,0,'2013-07-06 12:44:33',NULL,NULL),(4562,'03465','S','Troy','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.826713,-72.181022,0,'2013-07-06 12:44:30',NULL,NULL),(44829,'50251','S','Sully','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.575962,-92.842502,0,'2013-07-06 12:44:32',NULL,NULL),(77323,'96706','S','Ewa Beach','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.332660,-158.021874,0,'2013-07-06 12:44:34',NULL,NULL),(72171,'88345','S','Alto Crest','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.341149,-105.667861,0,'2013-07-06 12:44:34',NULL,NULL),(43720,'48917','S','Lansing','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.731731,-84.637521,0,'2013-07-06 12:44:32',NULL,NULL),(32234,'35582','S','Red Bay','D','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.441006,-88.144045,0,'2013-07-06 12:44:32',NULL,NULL),(32793,'36426','S','Damascus','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(21612,'22903','S','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.037660,-78.519202,0,'2013-07-06 12:44:31',NULL,NULL),(25997,'28671','P','Rutherford College','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.752185,-81.523048,0,'2013-07-06 12:44:31',NULL,NULL),(360,'00659','S','Ext San Ramon','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(18531,'19109','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.950326,-75.156065,0,'2013-07-06 12:44:31',NULL,NULL),(9600,'10030','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(5598,'04925','S','Caratunk','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.242341,-69.920146,0,'2013-07-06 12:44:30',NULL,NULL),(39910,'45217','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.165637,-84.495829,0,'2013-07-06 12:44:32',NULL,NULL),(68029,'80927','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.664269,-104.909568,0,'2013-07-06 12:44:34',NULL,NULL),(72601,'89410','S','Topaz Lake','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(16482,'17252','S','Saint Thomas','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.915118,-77.808351,0,'2013-07-06 12:44:31',NULL,NULL),(72882,'90013','S','Federal','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.046676,-118.241961,0,'2013-07-06 12:44:34',NULL,NULL),(70777,'85343','S','Palo Verde','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.331240,-112.703013,0,'2013-07-06 12:44:34',NULL,NULL),(65702,'78010','S','Center Point','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',29.935620,-99.010020,0,'2013-07-06 12:44:34',NULL,NULL),(58847,'69133','S','Jacinto','N','Kimball','31105','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.200815,-103.468834,0,'2013-07-06 12:44:33',NULL,NULL),(53812,'62295','S','Merrimac','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.280452,-90.340506,0,'2013-07-06 12:44:33',NULL,NULL),(44837,'50259','S','Gifford','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.253336,-93.059924,0,'2013-07-06 12:44:32',NULL,NULL),(12582,'13069','S','Volney','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(13775,'14144','P','Stela Niagara','A','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.197880,-79.046406,0,'2013-07-06 12:44:31',NULL,NULL),(14162,'14727','S','Cuba','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.211225,-78.268103,0,'2013-07-06 12:44:31',NULL,NULL),(9113,'09112','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(68413,'81201','S','Swissvale','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(76454,'95611','P','Citrus Heights','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.707001,-121.277971,0,'2013-07-06 12:44:34',NULL,NULL),(7918,'07632','S','Englewood Cliffs','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.883283,-73.954892,0,'2013-07-06 12:44:30',NULL,NULL),(40648,'46036','S','New Lancaster','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(49341,'56567','S','Butler','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.688056,-95.352778,0,'2013-07-06 12:44:33',NULL,NULL),(23289,'25169','S','Ridgeview','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.157778,-81.787522,0,'2013-07-06 12:44:31',NULL,NULL),(73958,'92066','S','Ranchita','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.219240,-116.528880,0,'2013-07-06 12:44:34',NULL,NULL),(20292,'20799','U','Washington NDC','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.881409,-76.856119,0,'2013-07-06 12:44:31',NULL,NULL),(72795,'89704','S','Branch #1','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.283073,-119.794595,0,'2013-07-06 12:44:34',NULL,NULL),(72358,'89022','P','Manhattan','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.538447,-117.076448,0,'2013-07-06 12:44:34',NULL,NULL),(62907,'75070','S','McKinney','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.169120,-96.691924,0,'2013-07-06 12:44:33',NULL,NULL),(54175,'62618','S','Beardstown','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.011462,-90.424051,0,'2013-07-06 12:44:33',NULL,NULL),(29972,'33084','P','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.025865,-80.243456,0,'2013-07-06 12:44:32',NULL,NULL),(61990,'73401','S','Ardmore','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.332490,-97.335320,0,'2013-07-06 12:44:33',NULL,NULL),(14775,'15348','P','Millsboro','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.991943,-79.993148,0,'2013-07-06 12:44:31',NULL,NULL),(39540,'44837','S','Shenandoah','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.032283,-82.508909,0,'2013-07-06 12:44:32',NULL,NULL),(47654,'54934','P','Eureka','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.005446,-88.841950,0,'2013-07-06 12:44:33',NULL,NULL),(79434,'98832','S','Ruff','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.461144,-118.922067,0,'2013-07-06 12:44:34',NULL,NULL),(37617,'42140','S','Bugtussle','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.660772,-85.813348,0,'2013-07-06 12:44:32',NULL,NULL),(37231,'41542','P','Lookout','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.315919,-82.470787,0,'2013-07-06 12:44:32',NULL,NULL),(34752,'38855','S','Mantachie','D','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.372551,-88.474011,0,'2013-07-06 12:44:32',NULL,NULL),(42407,'47801','P','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.467121,-87.410139,0,'2013-07-06 12:44:32',NULL,NULL),(36323,'40384','U','Versailles','D','Woodford','21239','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.051980,-84.725980,0,'2013-07-06 12:44:32',NULL,NULL),(11495,'12022','S','Center Berlin','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.694299,-73.370325,0,'2013-07-06 12:44:30',NULL,NULL),(69892,'84104','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.749850,-111.934638,0,'2013-07-06 12:44:34',NULL,NULL),(59483,'70759','S','Labarre','A','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.690421,-91.610359,0,'2013-07-06 12:44:33',NULL,NULL),(56215,'65035','S','Rich Fountain','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.336520,-91.928220,0,'2013-07-06 12:44:33',NULL,NULL),(52599,'61019','S','Davis','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.440537,-89.419639,0,'2013-07-06 12:44:33',NULL,NULL),(44130,'49510','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.022059,-85.612581,0,'2013-07-06 12:44:32',NULL,NULL),(28503,'31525','S','Sterling','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.233616,-81.501727,0,'2013-07-06 12:44:32',NULL,NULL),(21826,'23113','S','Midlothian','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.535176,-77.670301,0,'2013-07-06 12:44:31',NULL,NULL),(10604,'11040','S','Manhasset Hills','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(36887,'41101','S','Naples','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(38325,'43414','P','Dunbridge','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.457303,-83.611686,0,'2013-07-06 12:44:32',NULL,NULL),(7956,'07676','S','Washington Twnshp','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(38022,'43015','S','Delaware','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.285380,-83.059500,0,'2013-07-06 12:44:32',NULL,NULL),(32181,'35487','U','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.215665,-87.539190,0,'2013-07-06 12:44:32',NULL,NULL),(50500,'58062','S','Nome','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.672685,-97.785523,0,'2013-07-06 12:44:33',NULL,NULL),(64383,'76531','S','Hamilton','D','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.664240,-98.413570,0,'2013-07-06 12:44:34',NULL,NULL),(63342,'75604','S','Greggton','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.522216,-94.799589,0,'2013-07-06 12:44:33',NULL,NULL),(39545,'44839','S','Ruggles Beach','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388818,-82.561774,0,'2013-07-06 12:44:32',NULL,NULL),(70806,'85371','P','Poston','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.957856,-114.413584,0,'2013-07-06 12:44:34',NULL,NULL),(75735,'94599','S','Yountville','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.407604,-122.357035,0,'2013-07-06 12:44:34',NULL,NULL),(78609,'98195','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.651377,-122.298431,0,'2013-07-06 12:44:34',NULL,NULL),(28001,'30603','P','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.959292,-83.376888,0,'2013-07-06 12:44:31',NULL,NULL),(70797,'85363','S','Youngtown','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.592828,-112.302050,0,'2013-07-06 12:44:34',NULL,NULL),(56763,'65737','S','Branson West','A','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.679200,-93.370680,0,'2013-07-06 12:44:33',NULL,NULL),(45511,'51366','S','Webb','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.063795,-95.283539,0,'2013-07-06 12:44:32',NULL,NULL),(24427,'27157','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.059402,-80.321981,0,'2013-07-06 12:44:31',NULL,NULL),(15147,'15860','S','Hallton','A','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.359757,-78.990878,0,'2013-07-06 12:44:31',NULL,NULL),(7036,'06268','S','Storrs/Mansfield','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(18916,'19493','U','Providian Agon','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.053935,-75.556943,0,'2013-07-06 12:44:31',NULL,NULL),(3799,'02228','P','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.360007,-71.062270,0,'2013-07-06 12:44:30',NULL,NULL),(10349,'10570','S','Pleasantville','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.134752,-73.784806,0,'2013-07-06 12:44:30',NULL,NULL),(40123,'45326','S','Fletcher','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.139900,-84.102649,0,'2013-07-06 12:44:32',NULL,NULL),(61759,'73051','S','Slaughtervl','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.016330,-97.333336,0,'2013-07-06 12:44:33',NULL,NULL),(46649,'53599','P','Woodford','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.649996,-89.862141,0,'2013-07-06 12:44:32',NULL,NULL),(24727,'27517','S','Chapel Hill','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.938902,-79.040688,0,'2013-07-06 12:44:31',NULL,NULL),(30328,'33308','S','Lauderdale by the Sea','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(67200,'79908','S','Biggs Field','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.838148,-106.375434,0,'2013-07-06 12:44:34',NULL,NULL),(50154,'57544','S','Kennebec','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.891020,-99.847320,0,'2013-07-06 12:44:33',NULL,NULL),(80159,'99803','P','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.373979,-134.593339,0,'2013-07-06 12:44:34',NULL,NULL),(79787,'99348','S','Prescott','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.302913,-118.311757,0,'2013-07-06 12:44:34',NULL,NULL),(75445,'94062','S','Emerald Hills','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.448337,-122.268736,0,'2013-07-06 12:44:34',NULL,NULL),(71972,'88020','S','Animas','D','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.948375,-108.813066,0,'2013-07-06 12:44:34',NULL,NULL),(70258,'84511','S','White Mesa','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.644259,-109.463425,0,'2013-07-06 12:44:34',NULL,NULL),(69199,'83346','S','Oakley','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.303000,-113.996280,0,'2013-07-06 12:44:34',NULL,NULL),(57210,'66436','S','Holton','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.465523,-95.740235,0,'2013-07-06 12:44:33',NULL,NULL),(56073,'64755','S','Jasper','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.326541,-94.302019,0,'2013-07-06 12:44:33',NULL,NULL),(53158,'61563','P','St David','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.494712,-90.046750,0,'2013-07-06 12:44:33',NULL,NULL),(50876,'58529','S','Brisbane','N','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.502100,-101.502900,0,'2013-07-06 12:44:33',NULL,NULL),(50127,'57528','S','Colome','D','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.262769,-99.716287,0,'2013-07-06 12:44:33',NULL,NULL),(48819,'56032','P','Freeborn','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.767534,-93.562106,0,'2013-07-06 12:44:33',NULL,NULL),(44402,'49819','P','Arnold','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.049895,-87.492966,0,'2013-07-06 12:44:32',NULL,NULL),(43414,'48462','S','Brandon','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.838413,-83.428185,0,'2013-07-06 12:44:32',NULL,NULL),(12167,'12752','S','Lk Huntington','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.687177,-74.991409,0,'2013-07-06 12:44:30',NULL,NULL),(27096,'29714','S','Ft Lawn','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.701218,-80.913514,0,'2013-07-06 12:44:31',NULL,NULL),(19894,'20539','U','Immig and Natural Records','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898392,-77.028592,0,'2013-07-06 12:44:31',NULL,NULL),(7755,'07399','U','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.727839,-74.078433,0,'2013-07-06 12:44:30',NULL,NULL),(4384,'03104','S','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.003662,-71.446862,0,'2013-07-06 12:44:30',NULL,NULL),(25709,'28541','P','Jacksonville','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.764959,-77.403904,0,'2013-07-06 12:44:31',NULL,NULL),(43732,'48933','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.732863,-84.552700,0,'2013-07-06 12:44:32',NULL,NULL),(71026,'85734','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.114902,-110.894300,0,'2013-07-06 12:44:34',NULL,NULL),(34181,'38316','S','Bradford','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.065895,-88.807989,0,'2013-07-06 12:44:32',NULL,NULL),(55347,'63559','S','Connelsville','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(52386,'60629','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.777493,-87.709271,0,'2013-07-06 12:44:33',NULL,NULL),(18155,'18848','S','Burlingtn Twp','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.770672,-76.447490,0,'2013-07-06 12:44:31',NULL,NULL),(17560,'17981','S','Zerbe','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(66976,'79414','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.548719,-101.922888,0,'2013-07-06 12:44:34',NULL,NULL),(20117,'20715','S','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.988865,-76.738966,0,'2013-07-06 12:44:31',NULL,NULL),(21012,'21842','S','Ocean City','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.387820,-75.107280,0,'2013-07-06 12:44:31',NULL,NULL),(11485,'12020','S','Factory Village','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(19386,'20066','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918215,-76.995482,0,'2013-07-06 12:44:31',NULL,NULL),(19118,'19607','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.311120,-75.923820,0,'2013-07-06 12:44:31',NULL,NULL),(71666,'87504','P','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.810156,-105.984088,0,'2013-07-06 12:44:34',NULL,NULL),(77230,'96511','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77322,'96705','P','Eleele','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.916405,-159.594600,0,'2013-07-06 12:44:34',NULL,NULL),(58207,'68329','S','Cook','D','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.508304,-96.163432,0,'2013-07-06 12:44:33',NULL,NULL),(65785,'78118','S','Coy City','N','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.891304,-97.900158,0,'2013-07-06 12:44:34',NULL,NULL),(66516,'78711','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.279684,-97.738098,0,'2013-07-06 12:44:34',NULL,NULL),(74402,'92530','S','Lake Elsinore','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.603897,-117.377208,0,'2013-07-06 12:44:34',NULL,NULL),(79188,'98531','S','Fords Prairie','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.723564,-122.958491,0,'2013-07-06 12:44:34',NULL,NULL),(21654,'22940','S','Free Union','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.155282,-78.577674,0,'2013-07-06 12:44:31',NULL,NULL),(28061,'30678','S','White Plains','D','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.455729,-83.082172,0,'2013-07-06 12:44:31',NULL,NULL),(78019,'97420','S','Coos Bay','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.332900,-124.233900,0,'2013-07-06 12:44:34',NULL,NULL),(19782,'20426','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901696,-77.005988,0,'2013-07-06 12:44:31',NULL,NULL),(63020,'75180','S','Mesquite','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.717417,-96.619426,0,'2013-07-06 12:44:33',NULL,NULL),(28107,'30802','S','Phinizy','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.539800,-82.315022,0,'2013-07-06 12:44:31',NULL,NULL),(50562,'58214','S','Arvilla','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.889871,-97.497276,0,'2013-07-06 12:44:33',NULL,NULL),(52820,'61285','S','Thomson','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.962948,-90.103044,0,'2013-07-06 12:44:33',NULL,NULL),(25870,'28633','U','Lenoir','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.902482,-81.535317,0,'2013-07-06 12:44:31',NULL,NULL),(72219,'88427','S','McAlister','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.743064,-103.660694,0,'2013-07-06 12:44:34',NULL,NULL),(16050,'17045','S','Mount Patrick','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.574018,-76.985771,0,'2013-07-06 12:44:31',NULL,NULL),(22162,'23462','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.839595,-76.151374,0,'2013-07-06 12:44:31',NULL,NULL),(28328,'31150','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.982371,-84.333684,0,'2013-07-06 12:44:32',NULL,NULL),(29109,'32307','U','Florida A and M University','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.431483,-84.288359,0,'2013-07-06 12:44:32',NULL,NULL),(70788,'85354','S','Tonopah','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.475267,-112.879075,0,'2013-07-06 12:44:34',NULL,NULL),(62284,'74017','S','Valley Park','A','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.343020,-95.596680,0,'2013-07-06 12:44:33',NULL,NULL),(56465,'65301','S','Georgetown','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.695080,-93.242160,0,'2013-07-06 12:44:33',NULL,NULL),(27046,'29670','S','Pendleton','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.645861,-82.767260,0,'2013-07-06 12:44:31',NULL,NULL),(17532,'17972','S','Schuylkill Haven','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.632720,-76.155120,0,'2013-07-06 12:44:31',NULL,NULL),(31825,'35068','S','Fultondale','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.612000,-86.826540,0,'2013-07-06 12:44:32',NULL,NULL),(64861,'77056','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.748168,-95.467449,0,'2013-07-06 12:44:34',NULL,NULL),(7530,'07005','S','Taylortown','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(37479,'42001','S','Paducah','D','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(845,'00698','S','Ext Alts de Yauco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(25017,'27884','S','Stokes','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.716698,-77.269611,0,'2013-07-06 12:44:31',NULL,NULL),(55075,'63180','U','IBSSC Acs Asc','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.632421,-90.202951,0,'2013-07-06 12:44:33',NULL,NULL),(59463,'70737','S','Gonzales','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.245951,-90.916050,0,'2013-07-06 12:44:33',NULL,NULL),(59541,'70816','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.423198,-91.036850,0,'2013-07-06 12:44:33',NULL,NULL),(67393,'80124','S','Littleton','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.546295,-104.896772,0,'2013-07-06 12:44:34',NULL,NULL),(67526,'80249','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.776761,-104.756428,0,'2013-07-06 12:44:34',NULL,NULL),(8190,'07920','S','Basking Ridge','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.685358,-74.571598,0,'2013-07-06 12:44:30',NULL,NULL),(22836,'24520','S','Alton','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.712113,-78.848345,0,'2013-07-06 12:44:31',NULL,NULL),(60701,'71942','P','Friendship','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.244521,-92.982342,0,'2013-07-06 12:44:33',NULL,NULL),(56141,'64844','S','Aroma','N','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.920210,-94.267372,0,'2013-07-06 12:44:33',NULL,NULL),(49495,'56662','S','Beulah','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.846424,-93.901398,0,'2013-07-06 12:44:33',NULL,NULL),(2061,'00920','S','San Miguel Ind Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(47327,'54562','S','Clearwater Lake','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.805375,-89.123651,0,'2013-07-06 12:44:32',NULL,NULL),(46939,'54162','S','Kunesh','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.651006,-88.212562,0,'2013-07-06 12:44:32',NULL,NULL),(73813,'91762','S','Montclair','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.058501,-117.667472,0,'2013-07-06 12:44:34',NULL,NULL),(231,'00627','S','Sect Pena','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(19981,'20598','U','Fairfax','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(7374,'06776','S','Northville','N','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.582173,-73.413047,0,'2013-07-06 12:44:30',NULL,NULL),(4982,'04112','P','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.666707,-70.205810,0,'2013-07-06 12:44:30',NULL,NULL),(34219,'38361','S','Morris Chapel','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.309868,-88.287025,0,'2013-07-06 12:44:32',NULL,NULL),(33582,'37544','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.070320,-89.956560,0,'2013-07-06 12:44:32',NULL,NULL),(45960,'52358','S','Downey','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(46955,'54177','S','Wausaukee','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.360633,-87.911018,0,'2013-07-06 12:44:32',NULL,NULL),(71950,'87942','S','Las Palomas','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.062500,-107.297778,0,'2013-07-06 12:44:34',NULL,NULL),(73929,'92029','S','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.090581,-117.108862,0,'2013-07-06 12:44:34',NULL,NULL),(37549,'42064','S','Marion','D','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(59617,'71030','S','Kickapoo','N','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.199593,-93.847234,0,'2013-07-06 12:44:33',NULL,NULL),(79717,'99213','P','Cty Spok Val','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.656583,-117.291099,0,'2013-07-06 12:44:34',NULL,NULL),(29281,'32465','S','Wewahitchka','D','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',30.056707,-85.159531,0,'2013-07-06 12:44:32',NULL,NULL),(19370,'20058','U','Marriott Corp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',39.023587,-77.138603,0,'2013-07-06 12:44:31',NULL,NULL),(8298,'08022','S','Columbus','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.077182,-74.691452,0,'2013-07-06 12:44:30',NULL,NULL),(75085,'93534','S','Wilsona Gardens','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(75276,'93708','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.736262,-119.782514,0,'2013-07-06 12:44:34',NULL,NULL),(38900,'44116','S','Rocky River','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.467062,-81.860125,0,'2013-07-06 12:44:32',NULL,NULL),(38550,'43756','S','McConnelsville','D','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.690000,-81.835980,0,'2013-07-06 12:44:32',NULL,NULL),(32347,'35808','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.698410,-86.646477,0,'2013-07-06 12:44:32',NULL,NULL),(10553,'11001','S','S Floral Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(26221,'28792','S','Hendersonville','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.337349,-82.449108,0,'2013-07-06 12:44:31',NULL,NULL),(23599,'25690','P','Ragland','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.701906,-82.125852,0,'2013-07-06 12:44:31',NULL,NULL),(17877,'18441','S','Clifford Township','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.665200,-75.643680,0,'2013-07-06 12:44:31',NULL,NULL),(56745,'65721','S','Finley','N','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.014220,-93.204822,0,'2013-07-06 12:44:33',NULL,NULL),(68104,'80945','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.838745,-104.797322,0,'2013-07-06 12:44:34',NULL,NULL),(70214,'84401','S','West Weber','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(72543,'89183','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.153552,-115.106506,0,'2013-07-06 12:44:34',NULL,NULL),(16175,'17066','S','Aughwick','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.386060,-77.874060,0,'2013-07-06 12:44:31',NULL,NULL),(19397,'20071','U','Washington Post','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903241,-77.036061,0,'2013-07-06 12:44:31',NULL,NULL),(34784,'38866','S','Saltillo','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.375655,-88.686467,0,'2013-07-06 12:44:32',NULL,NULL),(22357,'23894','S','Wilsons','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.130551,-77.854198,0,'2013-07-06 12:44:31',NULL,NULL),(79769,'99329','S','Dixie','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.140674,-118.153495,0,'2013-07-06 12:44:34',NULL,NULL),(17214,'17824','S','Elysburg','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(24184,'26631','S','Falls Mill','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.772829,-80.582664,0,'2013-07-06 12:44:31',NULL,NULL),(26064,'28694','S','Beaver Creek','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(12041,'12523','S','Taghkanic','A','Columbia','36021','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.072600,-73.792544,0,'2013-07-06 12:44:30',NULL,NULL),(25133,'28010','P','Barium Springs','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.720008,-80.898107,0,'2013-07-06 12:44:31',NULL,NULL),(67114,'79734','S','Mcdonald Obs','A','Jeff Davis','48243','Texas','TX','48','0000','432','Central',-6.0,'Y',30.709108,-103.914129,0,'2013-07-06 12:44:34',NULL,NULL),(3661,'02122','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.297038,-71.054735,0,'2013-07-06 12:44:30',NULL,NULL),(17260,'17841','S','West Beaver','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(29660,'32908','S','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.980227,-80.688532,0,'2013-07-06 12:44:32',NULL,NULL),(11695,'12158','S','Beckers Corners','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.551716,-73.817741,0,'2013-07-06 12:44:30',NULL,NULL),(5564,'04860','S','Saint George','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.966485,-69.212306,0,'2013-07-06 12:44:30',NULL,NULL),(8032,'07730','S','Hazlet','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.421652,-74.178151,0,'2013-07-06 12:44:30',NULL,NULL),(5766,'05043','S','E Thetford','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.788611,-72.255833,0,'2013-07-06 12:44:30',NULL,NULL),(47976,'55126','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(49351,'56572','S','Pelican Rapids','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.618320,-96.072900,0,'2013-07-06 12:44:33',NULL,NULL),(49775,'57071','S','Volga','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.320521,-96.925166,0,'2013-07-06 12:44:33',NULL,NULL),(52903,'61360','S','Stavanger','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.329446,-88.610406,0,'2013-07-06 12:44:33',NULL,NULL),(60349,'71468','S','Provencal','D','Natchitoches','22069','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.538100,-93.115260,0,'2013-07-06 12:44:33',NULL,NULL),(64954,'77237','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.734098,-95.498638,0,'2013-07-06 12:44:34',NULL,NULL),(72772,'89555','U','Parcel Return Reno','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.529646,-119.812392,0,'2013-07-06 12:44:34',NULL,NULL),(76060,'95196','U','San Jose Water Company','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.330413,-121.891128,0,'2013-07-06 12:44:34',NULL,NULL),(78779,'98312','S','Enetai','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(39405,'44662','S','Navarre','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.717968,-81.530814,0,'2013-07-06 12:44:32',NULL,NULL),(58629,'68864','S','Palmer','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.169772,-98.216393,0,'2013-07-06 12:44:33',NULL,NULL),(33681,'37743','S','Greeneville','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.162752,-82.818898,0,'2013-07-06 12:44:32',NULL,NULL),(41566,'47024','S','Buena Vista','N','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.477157,-85.195131,0,'2013-07-06 12:44:32',NULL,NULL),(40367,'45644','S','Kingston','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.448325,-82.875803,0,'2013-07-06 12:44:32',NULL,NULL),(7947,'07675','S','Old Tappan','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.000621,-74.031463,0,'2013-07-06 12:44:30',NULL,NULL),(18043,'18657','S','Monroe Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(8857,'08648','S','Lawrence Twp','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.265940,-74.695860,0,'2013-07-06 12:44:30',NULL,NULL),(75994,'95077','P','Watsonville','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.911048,-121.758494,0,'2013-07-06 12:44:34',NULL,NULL),(54231,'62660','P','Literberry','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.856774,-90.197612,0,'2013-07-06 12:44:33',NULL,NULL),(27673,'30329','S','Briarcliff','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.825160,-84.319700,0,'2013-07-06 12:44:31',NULL,NULL),(14953,'15615','S','Ardara','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.358953,-79.738286,0,'2013-07-06 12:44:31',NULL,NULL),(78706,'98263','P','Lyman','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.529335,-122.064232,0,'2013-07-06 12:44:34',NULL,NULL),(1346,'00736','S','Comunidad San Tomas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(23192,'25053','S','Danville','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.000074,-81.865118,0,'2013-07-06 12:44:31',NULL,NULL),(23888,'26175','S','Sistersville','D','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.556931,-80.998026,0,'2013-07-06 12:44:31',NULL,NULL),(43591,'48756','S','Prescott','D','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.183333,-84.035278,0,'2013-07-06 12:44:32',NULL,NULL),(44642,'50073','S','Enterprise','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.789463,-93.515162,0,'2013-07-06 12:44:32',NULL,NULL),(66922,'79336','S','Pettit','N','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.554160,-102.384000,0,'2013-07-06 12:44:34',NULL,NULL),(68407,'81157','P','Pagosa Spgs','A','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.268072,-107.088673,0,'2013-07-06 12:44:34',NULL,NULL),(75695,'94565','S','Bay Point','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.017076,-121.909650,0,'2013-07-06 12:44:34',NULL,NULL),(72733,'89506','S','Lemmon Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(75561,'94258','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585278,-121.494965,0,'2013-07-06 12:44:34',NULL,NULL),(54160,'62573','S','Heman','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.929287,-89.062013,0,'2013-07-06 12:44:33',NULL,NULL),(79962,'99637','P','Bethel','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.605545,-164.759764,0,'2013-07-06 12:44:34',NULL,NULL),(5651,'04955','S','New Sharon','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.676689,-69.983240,0,'2013-07-06 12:44:30',NULL,NULL),(11597,'12083','S','S Westerlo','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.416705,-74.011373,0,'2013-07-06 12:44:30',NULL,NULL),(36261,'40328','S','Gravel Switch','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.568998,-85.085670,0,'2013-07-06 12:44:32',NULL,NULL),(33148,'36921','S','Toxey','D','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.965833,-88.360431,0,'2013-07-06 12:44:32',NULL,NULL),(13580,'13844','S','So Plymouth','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.608333,-75.701944,0,'2013-07-06 12:44:31',NULL,NULL),(23487,'25512','S','East Lynn','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.194258,-82.327188,0,'2013-07-06 12:44:31',NULL,NULL),(22291,'23805','S','Walnut Hill','N','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.136328,-77.391900,0,'2013-07-06 12:44:31',NULL,NULL),(18413,'19058','P','Levittown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.152223,-74.851228,0,'2013-07-06 12:44:31',NULL,NULL),(42374,'47712','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.991451,-87.637797,0,'2013-07-06 12:44:32',NULL,NULL),(52497,'60706','S','Harwood Hts','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.962443,-87.817391,0,'2013-07-06 12:44:33',NULL,NULL),(57729,'67410','S','Manchester','A','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.921079,-97.220096,0,'2013-07-06 12:44:33',NULL,NULL),(59685,'71069','S','Zylks','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.975017,-94.004397,0,'2013-07-06 12:44:33',NULL,NULL),(62757,'74849','S','Konawa','D','Seminole','40133','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.958396,-96.751473,0,'2013-07-06 12:44:33',NULL,NULL),(70344,'84635','S','Abraham','A','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.364440,-112.719300,0,'2013-07-06 12:44:34',NULL,NULL),(73309,'90809','P','LB','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.762376,-118.121919,0,'2013-07-06 12:44:34',NULL,NULL),(74965,'93430','S','Cayucos','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.446852,-120.882430,0,'2013-07-06 12:44:34',NULL,NULL),(76314,'95451','S','Kelseyville','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.966686,-122.776460,0,'2013-07-06 12:44:34',NULL,NULL),(62423,'74145','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.096758,-95.885146,0,'2013-07-06 12:44:33',NULL,NULL),(59543,'70818','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.544903,-91.049706,0,'2013-07-06 12:44:33',NULL,NULL),(12665,'13122','S','New Wdstock','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.855055,-75.914421,0,'2013-07-06 12:44:30',NULL,NULL),(53985,'62440','S','Lerna','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.417463,-88.287007,0,'2013-07-06 12:44:33',NULL,NULL),(34311,'38552','S','Chestnut Mnd','A','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.187343,-85.842629,0,'2013-07-06 12:44:32',NULL,NULL),(30250,'33199','U','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.759145,-80.372492,0,'2013-07-06 12:44:32',NULL,NULL),(10181,'10282','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(7863,'07502','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.918903,-74.194887,0,'2013-07-06 12:44:30',NULL,NULL),(17638,'18064','S','Nazareth','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.745850,-75.320102,0,'2013-07-06 12:44:31',NULL,NULL),(64171,'76227','S','Crossroads','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(51321,'59254','S','Plentywood','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.815609,-104.661196,0,'2013-07-06 12:44:33',NULL,NULL),(19833,'20501','U','White House Ofc of Vice Pres','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900876,-77.029709,0,'2013-07-06 12:44:31',NULL,NULL),(5895,'05155','S','Stratton Mtn','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(35238,'39326','S','Daleville','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.547875,-88.672319,0,'2013-07-06 12:44:32',NULL,NULL),(7531,'07006','S','Caldwell','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.855020,-74.277840,0,'2013-07-06 12:44:30',NULL,NULL),(33924,'38055','U','Millington','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.340560,-89.894343,0,'2013-07-06 12:44:32',NULL,NULL),(20555,'21123','P','Pasadena','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.111974,-76.553563,0,'2013-07-06 12:44:31',NULL,NULL),(30120,'33161','S','North Miami Beach','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(24687,'27413','U','Unc Greensboro','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.068728,-79.810276,0,'2013-07-06 12:44:31',NULL,NULL),(46815,'54006','S','Sterling','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.573120,-92.648880,0,'2013-07-06 12:44:32',NULL,NULL),(54834,'63032','P','Florissant','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.803152,-90.311355,0,'2013-07-06 12:44:33',NULL,NULL),(66908,'79313','S','Anton','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.812829,-102.160095,0,'2013-07-06 12:44:34',NULL,NULL),(74318,'92394','S','George AFB','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.585299,-117.369903,0,'2013-07-06 12:44:34',NULL,NULL),(24669,'27408','S','Country Park Acres','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.106359,-79.817365,0,'2013-07-06 12:44:31',NULL,NULL),(22649,'24265','S','Keokee','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834134,-82.964016,0,'2013-07-06 12:44:31',NULL,NULL),(68917,'82839','S','Acme','A','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.903574,-107.143746,0,'2013-07-06 12:44:34',NULL,NULL),(39,'00603','S','Urb Santa Marta','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(17189,'17820','S','Parrs Mill','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(64035,'76126','S','Benbrook','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.586584,-97.538996,0,'2013-07-06 12:44:34',NULL,NULL),(28700,'31821','S','Omaha','D','Stewart','13259','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.145985,-84.904327,0,'2013-07-06 12:44:32',NULL,NULL),(10971,'11530','S','Garden City South','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(64476,'76579','S','Belfalls','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.204456,-97.308221,0,'2013-07-06 12:44:34',NULL,NULL),(44335,'49761','P','Mullett Lake','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.560825,-84.523849,0,'2013-07-06 12:44:32',NULL,NULL),(40966,'46321','S','Munster','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.555530,-87.497888,0,'2013-07-06 12:44:32',NULL,NULL),(22541,'24124','S','Narrows','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.332730,-80.807301,0,'2013-07-06 12:44:31',NULL,NULL),(23649,'25802','P','Sprague','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.793326,-81.219605,0,'2013-07-06 12:44:31',NULL,NULL),(43752,'49011','S','Athens','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.098631,-85.219805,0,'2013-07-06 12:44:32',NULL,NULL),(61961,'73172','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.419424,-97.569451,0,'2013-07-06 12:44:33',NULL,NULL),(62064,'73546','S','Grandfield','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.229710,-98.690114,0,'2013-07-06 12:44:33',NULL,NULL),(15660,'16750','S','Turtlepoint','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.882910,-78.326584,0,'2013-07-06 12:44:31',NULL,NULL),(52339,'60572','U','Fox Valley','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.766060,-88.320017,0,'2013-07-06 12:44:33',NULL,NULL),(26705,'29410','S','Charleston','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.194932,-80.029749,0,'2013-07-06 12:44:31',NULL,NULL),(73730,'91701','S','Alta Loma','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.155540,-117.589740,0,'2013-07-06 12:44:34',NULL,NULL),(73947,'92055','S','Oceanside','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.291239,-117.301241,0,'2013-07-06 12:44:34',NULL,NULL),(3243,'01432','S','Ayer','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.559756,-71.575320,0,'2013-07-06 12:44:30',NULL,NULL),(14131,'14652','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.150617,-77.728304,0,'2013-07-06 12:44:31',NULL,NULL),(62103,'73626','S','Canute','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.416760,-99.280266,0,'2013-07-06 12:44:33',NULL,NULL),(61284,'72395','S','Wilson','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.572882,-90.043975,0,'2013-07-06 12:44:33',NULL,NULL),(54925,'63103','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.633829,-90.213138,0,'2013-07-06 12:44:33',NULL,NULL),(21487,'22652','S','Fort Valley','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.842058,-78.419588,0,'2013-07-06 12:44:31',NULL,NULL),(44597,'50047','S','Palmyra','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.477985,-93.476846,0,'2013-07-06 12:44:32',NULL,NULL),(67652,'80474','S','Rollinsville','D','Gilpin','08047','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.879622,-105.485351,0,'2013-07-06 12:44:34',NULL,NULL),(715,'00687','S','Parc Barahona','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(17595,'18037','S','Coplay','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.683120,-75.512220,0,'2013-07-06 12:44:31',NULL,NULL),(34918,'38962','P','Tippo','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.892564,-90.035943,0,'2013-07-06 12:44:32',NULL,NULL),(25577,'28434','S','Council','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.448316,-78.437794,0,'2013-07-06 12:44:31',NULL,NULL),(54405,'62827','S','Crossville','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.169678,-88.066046,0,'2013-07-06 12:44:33',NULL,NULL),(56401,'65244','S','Thomas Hill','N','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.425930,-92.665220,0,'2013-07-06 12:44:33',NULL,NULL),(56488,'65333','S','Houstonia','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.901082,-93.360319,0,'2013-07-06 12:44:33',NULL,NULL),(65447,'77592','P','Texas City','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.508754,-95.145277,0,'2013-07-06 12:44:34',NULL,NULL),(68076,'80937','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798001,-104.836875,0,'2013-07-06 12:44:34',NULL,NULL),(31321,'34117','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.143413,-81.523339,0,'2013-07-06 12:44:32',NULL,NULL),(26084,'28707','P','Balsam','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.447490,-83.082210,0,'2013-07-06 12:44:31',NULL,NULL),(58618,'68859','S','Eureka','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.466866,-98.705890,0,'2013-07-06 12:44:33',NULL,NULL),(56135,'64836','S','Morgan Heights','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(58840,'69128','S','Bushnell','D','Kimball','31105','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.194059,-103.922750,0,'2013-07-06 12:44:33',NULL,NULL),(58043,'68022','S','Elkhorn','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.272116,-96.241943,0,'2013-07-06 12:44:33',NULL,NULL),(22115,'23432','S','Chuckatuck','N','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.870120,-76.555020,0,'2013-07-06 12:44:31',NULL,NULL),(48774,'55987','S','Stockton','A','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(71829,'87578','P','Truchas','D','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.038566,-105.809232,0,'2013-07-06 12:44:34',NULL,NULL),(72652,'89430','S','Smith','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.764947,-119.324642,0,'2013-07-06 12:44:34',NULL,NULL),(61386,'72532','S','Evening Shade','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.092593,-91.579676,0,'2013-07-06 12:44:33',NULL,NULL),(13198,'13624','S','Clayton','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.239325,-76.080450,0,'2013-07-06 12:44:30',NULL,NULL),(11132,'11706','S','Saltaire','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(60734,'71961','S','Oden','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.604027,-93.831820,0,'2013-07-06 12:44:33',NULL,NULL),(74300,'92374','S','Redlands','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.065425,-117.168070,0,'2013-07-06 12:44:34',NULL,NULL),(66042,'78369','S','Mirando City','D','Webb','48479','Texas','TX','48','4080','361','Central',-6.0,'Y',27.441138,-99.024210,0,'2013-07-06 12:44:34',NULL,NULL),(53364,'61769','S','Saunemin','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.893501,-88.404022,0,'2013-07-06 12:44:33',NULL,NULL),(45863,'52243','U','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.656599,-91.535548,0,'2013-07-06 12:44:32',NULL,NULL),(1582,'00767','S','Villas de Buenaventura','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(3959,'02479','P','Waverley','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.388983,-71.187758,0,'2013-07-06 12:44:30',NULL,NULL),(10705,'11231','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.680052,-74.004522,0,'2013-07-06 12:44:30',NULL,NULL),(45014,'50456','S','Manly','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.288858,-93.201173,0,'2013-07-06 12:44:32',NULL,NULL),(34202,'38342','S','Hollow Rock','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.027870,-88.277775,0,'2013-07-06 12:44:32',NULL,NULL),(6510,'05821','S','Inwood','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.314722,-72.166389,0,'2013-07-06 12:44:30',NULL,NULL),(5181,'04441','S','Greenville','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(14345,'15010','S','Patterson Hts','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.763952,-80.341536,0,'2013-07-06 12:44:31',NULL,NULL),(48133,'55361','P','Minetonka Bch','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.940420,-93.597000,0,'2013-07-06 12:44:33',NULL,NULL),(57183,'66409','S','Berryton','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.923456,-95.591604,0,'2013-07-06 12:44:33',NULL,NULL),(57496,'66943','S','Greenleaf','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.726397,-96.977347,0,'2013-07-06 12:44:33',NULL,NULL),(62092,'73569','S','Terral','D','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.021990,-97.664480,0,'2013-07-06 12:44:33',NULL,NULL),(70961,'85646','P','Tubac','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.609126,-111.051323,0,'2013-07-06 12:44:34',NULL,NULL),(62390,'74084','S','Wynona','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.550067,-96.321628,0,'2013-07-06 12:44:33',NULL,NULL),(8343,'08043','S','Echelon','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(43738,'48956','U','Mi Department of Revenue','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734814,-84.556691,0,'2013-07-06 12:44:32',NULL,NULL),(70263,'84518','P','Cleveland','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.347860,-110.850481,0,'2013-07-06 12:44:34',NULL,NULL),(74414,'92546','P','Hemet','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.749990,-116.968130,0,'2013-07-06 12:44:34',NULL,NULL),(42262,'47581','S','Cale','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(64228,'76305','S','Jolly','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(55879,'64401','S','Agency','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.663257,-94.685736,0,'2013-07-06 12:44:33',NULL,NULL),(32081,'35288','U','Regions Bank','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463112,-86.769414,0,'2013-07-06 12:44:32',NULL,NULL),(73133,'90274','S','Palos Verdes Peninsula','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(42724,'48006','S','Avoca','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(18135,'18828','S','Rushville','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.764619,-76.094363,0,'2013-07-06 12:44:31',NULL,NULL),(16650,'17345','S','Manchester','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.073680,-76.730034,0,'2013-07-06 12:44:31',NULL,NULL),(36374,'40460','S','Johnetta','A','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.387780,-84.220202,0,'2013-07-06 12:44:32',NULL,NULL),(31894,'35139','P','Sayre','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.714591,-86.975210,0,'2013-07-06 12:44:32',NULL,NULL),(26253,'29003','S','Bamberg','D','Bamberg','45009','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.287100,-81.022920,0,'2013-07-06 12:44:31',NULL,NULL),(6319,'05661','S','Morrisvl','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(23075,'24888','P','Thorpe','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.441338,-81.596776,0,'2013-07-06 12:44:31',NULL,NULL),(43131,'48232','P','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.328867,-83.051104,0,'2013-07-06 12:44:32',NULL,NULL),(47422,'54661','S','Trempealeau','D','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.006596,-91.437566,0,'2013-07-06 12:44:32',NULL,NULL),(78064,'97458','S','Myrtle Point','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.114800,-124.156800,0,'2013-07-06 12:44:34',NULL,NULL),(40897,'46253','P','Eagle Creek','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.826866,-86.270775,0,'2013-07-06 12:44:32',NULL,NULL),(35970,'40078','S','Willisburg','D','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.895371,-85.106075,0,'2013-07-06 12:44:32',NULL,NULL),(2090,'00922','P','Caparra Ter','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409982,-66.092553,0,'2013-07-06 12:44:30',NULL,NULL),(27598,'30297','S','Forest Park','D','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.615198,-84.367485,0,'2013-07-06 12:44:31',NULL,NULL),(25209,'28079','S','Lake Park','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.098742,-80.631203,0,'2013-07-06 12:44:31',NULL,NULL),(76611,'95691','S','West Sacramento','D','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.562100,-121.541198,0,'2013-07-06 12:44:34',NULL,NULL),(20221,'20772','S','Uppr Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.799000,-76.785960,0,'2013-07-06 12:44:31',NULL,NULL),(27904,'30475','P','Vidalia','D','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.211075,-82.403886,0,'2013-07-06 12:44:31',NULL,NULL),(59397,'70631','S','Cameron','D','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.826351,-93.397555,0,'2013-07-06 12:44:33',NULL,NULL),(6756,'06088','S','Warehouse Point','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.902833,-72.596403,0,'2013-07-06 12:44:30',NULL,NULL),(21151,'22119','U','Navy Federal Credit Union','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.876851,-77.235738,0,'2013-07-06 12:44:31',NULL,NULL),(6558,'05846','S','Island Pond','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.796300,-71.855580,0,'2013-07-06 12:44:30',NULL,NULL),(48631,'55807','S','West Duluth','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.739838,-92.167853,0,'2013-07-06 12:44:33',NULL,NULL),(48418,'55603','S','Finland','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.469373,-91.279679,0,'2013-07-06 12:44:33',NULL,NULL),(44276,'49711','P','Bay Shore','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.358333,-85.097222,0,'2013-07-06 12:44:32',NULL,NULL),(65557,'77841','P','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.572808,-96.326388,0,'2013-07-06 12:44:34',NULL,NULL),(40717,'46120','S','Belle Union','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.512820,-86.819220,0,'2013-07-06 12:44:32',NULL,NULL),(37140,'41465','S','Fredville','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(31995,'35223','S','Mountain Brook','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489469,-86.741202,0,'2013-07-06 12:44:32',NULL,NULL),(16870,'17566','S','Mechanics Grove','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.879899,-76.148321,0,'2013-07-06 12:44:31',NULL,NULL),(14861,'15458','S','McClellandtown','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.886898,-79.858211,0,'2013-07-06 12:44:31',NULL,NULL),(55821,'64150','S','Riverside','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.170613,-94.628810,0,'2013-07-06 12:44:33',NULL,NULL),(56564,'65470','S','Nebo','N','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.611420,-92.350500,0,'2013-07-06 12:44:33',NULL,NULL),(65580,'77864','S','Madisonville','D','Madison','48313','Texas','TX','48','0000','936','Central',-6.0,'Y',30.975540,-95.900700,0,'2013-07-06 12:44:34',NULL,NULL),(69969,'84119','S','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(29531,'32789','S','Winter Park','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.599717,-81.357134,0,'2013-07-06 12:44:32',NULL,NULL),(28302,'31107','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.763577,-84.351567,0,'2013-07-06 12:44:31',NULL,NULL),(20705,'21264','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290550,-76.609596,0,'2013-07-06 12:44:31',NULL,NULL),(17547,'17979','P','Summit Sta','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.576003,-76.192712,0,'2013-07-06 12:44:31',NULL,NULL),(6900,'06150','U','Bank of America','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765671,-72.675155,0,'2013-07-06 12:44:30',NULL,NULL),(68672,'81657','S','West Vail','N','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.650220,-106.360740,0,'2013-07-06 12:44:34',NULL,NULL),(33160,'37016','S','Auburntown','D','Cannon','47015','Tennessee','TN','47','0000','615','Central',-6.0,'Y',35.988733,-86.114362,0,'2013-07-06 12:44:32',NULL,NULL),(29197,'32407','S','Panama City','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.202980,-85.797960,0,'2013-07-06 12:44:32',NULL,NULL),(21821,'23109','S','Mathews','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.442814,-76.356370,0,'2013-07-06 12:44:31',NULL,NULL),(21503,'22701','S','Winston','A','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.471640,-78.013989,0,'2013-07-06 12:44:31',NULL,NULL),(20701,'21252','U','Towson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.394959,-76.612936,0,'2013-07-06 12:44:31',NULL,NULL),(4455,'03254','S','Moultonboro','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.671415,-71.378539,0,'2013-07-06 12:44:30',NULL,NULL),(47992,'55133','U','Minn Mining Boxes','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944520,-93.005804,0,'2013-07-06 12:44:33',NULL,NULL),(48541,'55756','S','Kerrick','D','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.298113,-92.721724,0,'2013-07-06 12:44:33',NULL,NULL),(54270,'62683','P','Scottville','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.473489,-90.097437,0,'2013-07-06 12:44:33',NULL,NULL),(55287,'63474','S','Wyaconda','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.336883,-91.890611,0,'2013-07-06 12:44:33',NULL,NULL),(57689,'67260','U','Wichita State University','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.707488,-97.281218,0,'2013-07-06 12:44:33',NULL,NULL),(73230,'90639','U','Biola University','N','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.907592,-118.020573,0,'2013-07-06 12:44:34',NULL,NULL),(52016,'60174','S','Valley View','N','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.922012,-88.304234,0,'2013-07-06 12:44:33',NULL,NULL),(34299,'38541','S','Allons','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.491250,-85.317823,0,'2013-07-06 12:44:32',NULL,NULL),(3437,'01752','S','Marlboro','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.349703,-71.546947,0,'2013-07-06 12:44:30',NULL,NULL),(68417,'81210','S','Jacks Cabin','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(28917,'32148','S','Interlachen','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.641935,-81.900984,0,'2013-07-06 12:44:32',NULL,NULL),(60387,'71601','S','Pine Bluff','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.201680,-91.929399,0,'2013-07-06 12:44:33',NULL,NULL),(55745,'64097','S','Wellington','D','Lafayette','29107','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.132020,-93.986179,0,'2013-07-06 12:44:33',NULL,NULL),(41791,'47325','S','Philomath','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.717506,-84.963353,0,'2013-07-06 12:44:32',NULL,NULL),(21208,'22202','S','Crystal City','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.861338,-77.056739,0,'2013-07-06 12:44:31',NULL,NULL),(10575,'11021','S','Great Nck Plz','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(46076,'52585','S','Veo','N','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.182995,-91.991490,0,'2013-07-06 12:44:32',NULL,NULL),(51350,'59324','S','Ekalaka','D','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.853140,-104.217350,0,'2013-07-06 12:44:33',NULL,NULL),(52272,'60525','S','La Grange','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(57305,'66626','U','Ks Dept of Revenue Vehicles','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.047246,-95.682820,0,'2013-07-06 12:44:33',NULL,NULL),(58076,'68063','P','Uehling','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.734407,-96.505658,0,'2013-07-06 12:44:33',NULL,NULL),(75199,'93623','S','Fish Camp','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.479525,-119.636199,0,'2013-07-06 12:44:34',NULL,NULL),(51360,'59339','S','Lindsay','D','Dawson','30021','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.195082,-105.200493,0,'2013-07-06 12:44:33',NULL,NULL),(56368,'65215','U','Stephens College','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.953037,-92.325011,0,'2013-07-06 12:44:33',NULL,NULL),(8590,'08226','S','Ocean City','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.268442,-74.593530,0,'2013-07-06 12:44:30',NULL,NULL),(51222,'59055','S','Melville','D','Sweet Grass','30097','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.072838,-109.879094,0,'2013-07-06 12:44:33',NULL,NULL),(34811,'38880','P','Wheeler','D','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.535135,-88.636857,0,'2013-07-06 12:44:32',NULL,NULL),(7500,'06921','U','Champion International','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.050629,-73.539664,0,'2013-07-06 12:44:30',NULL,NULL),(32699,'36276','S','Wadley','D','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(1019,'00718','S','Naguabo','D','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(28982,'32212','S','Jacksonville Naval Air Stati','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(10748,'11359','S','Fort Totten','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.789436,-73.777382,0,'2013-07-06 12:44:30',NULL,NULL),(9274,'09621','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(73758,'91730','S','Rch Cucamonga','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.099140,-117.581280,0,'2013-07-06 12:44:34',NULL,NULL),(79878,'99571','P','Nelson Lagoon','A','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.180000,-162.720000,0,'2013-07-06 12:44:34',NULL,NULL),(8646,'08302','S','Upper Deerfield Twp','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.438881,-75.228175,0,'2013-07-06 12:44:30',NULL,NULL),(5330,'04578','S','Westport Is','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.996053,-69.671510,0,'2013-07-06 12:44:30',NULL,NULL),(22196,'23508','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.887613,-76.299540,0,'2013-07-06 12:44:31',NULL,NULL),(64965,'77252','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.759003,-95.366897,0,'2013-07-06 12:44:34',NULL,NULL),(72864,'90005','S','Sanford','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.055509,-118.309220,0,'2013-07-06 12:44:34',NULL,NULL),(79619,'99118','S','Curlew','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.916644,-118.626738,0,'2013-07-06 12:44:34',NULL,NULL),(16686,'17368','S','Longlevel','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015953,-76.528879,0,'2013-07-06 12:44:31',NULL,NULL),(61529,'72669','P','Pindall','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.072776,-92.886999,0,'2013-07-06 12:44:33',NULL,NULL),(72490,'89136','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.174109,-115.134431,0,'2013-07-06 12:44:34',NULL,NULL),(72958,'90043','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.990206,-118.335759,0,'2013-07-06 12:44:34',NULL,NULL),(355,'00659','S','Bda Clan','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(17521,'17967','S','Ringtown','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.849233,-76.231076,0,'2013-07-06 12:44:31',NULL,NULL),(16354,'17201','S','Aqua','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(36160,'40242','S','Briarwood','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(33609,'37644','P','Elizabethton','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.347396,-82.213748,0,'2013-07-06 12:44:32',NULL,NULL),(14316,'14897','S','Whitesville','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.035503,-77.777158,0,'2013-07-06 12:44:31',NULL,NULL),(28656,'31775','S','Omega','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.380728,-83.582679,0,'2013-07-06 12:44:32',NULL,NULL),(12849,'13317','S','Buel','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(28132,'30817','S','Loco','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(51406,'59434','P','East Glacier','N','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(53370,'61774','S','Allin','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.435071,-89.223520,0,'2013-07-06 12:44:33',NULL,NULL),(53576,'62060','S','Eagle Park','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.686572,-90.153079,0,'2013-07-06 12:44:33',NULL,NULL),(79876,'99571','P','Adak','A','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.180000,-162.720000,0,'2013-07-06 12:44:34',NULL,NULL),(4079,'02660','S','South Dennis','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.705465,-70.157465,0,'2013-07-06 12:44:30',NULL,NULL),(31888,'35130','S','West Jefferson','A','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.570865,-87.165507,0,'2013-07-06 12:44:32',NULL,NULL),(43228,'48312','S','Sterling Heights','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.556244,-83.006843,0,'2013-07-06 12:44:32',NULL,NULL),(28294,'31098','S','Robins AFB','A','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.611973,-83.596726,0,'2013-07-06 12:44:31',NULL,NULL),(4483,'03273','P','S Sutton','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.321255,-71.936438,0,'2013-07-06 12:44:30',NULL,NULL),(11691,'12155','S','Westville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597180,-74.818920,0,'2013-07-06 12:44:30',NULL,NULL),(27688,'30337','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.644256,-84.467351,0,'2013-07-06 12:44:31',NULL,NULL),(26624,'29319','U','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.947178,-81.926781,0,'2013-07-06 12:44:31',NULL,NULL),(11540,'12047','S','Boght Corners','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.774939,-73.715732,0,'2013-07-06 12:44:30',NULL,NULL),(13453,'13778','S','Lower Genegantslet Corner','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(66195,'78541','S','Edinburg','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.295361,-98.163430,0,'2013-07-06 12:44:34',NULL,NULL),(75769,'94649','U','Ebmud','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.806936,-122.263828,0,'2013-07-06 12:44:34',NULL,NULL),(77114,'96146','S','Olympic Valley','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.150000,-120.150000,0,'2013-07-06 12:44:34',NULL,NULL),(35681,'39657','S','Osyka','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.020240,-90.463920,0,'2013-07-06 12:44:32',NULL,NULL),(31634,'34713','P','South Clermont','N','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.547308,-81.770426,0,'2013-07-06 12:44:32',NULL,NULL),(21839,'23126','S','Newtown','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.877373,-77.115657,0,'2013-07-06 12:44:31',NULL,NULL),(22408,'23964','S','Red Oak','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.763884,-78.636781,0,'2013-07-06 12:44:31',NULL,NULL),(23134,'24977','S','Meadow Bluff','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.866405,-80.665267,0,'2013-07-06 12:44:31',NULL,NULL),(47813,'55056','S','Sunrise','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.504480,-92.877900,0,'2013-07-06 12:44:33',NULL,NULL),(69309,'83460','U','BYU-IDAHO','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.818343,-111.782192,0,'2013-07-06 12:44:34',NULL,NULL),(33592,'37614','P','Etsu','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.330892,-82.365584,0,'2013-07-06 12:44:32',NULL,NULL),(21705,'22972','S','Old Somerset','N','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.207130,-78.237240,0,'2013-07-06 12:44:31',NULL,NULL),(14078,'14610','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.140249,-77.545983,0,'2013-07-06 12:44:31',NULL,NULL),(76354,'95482','S','Ukiah','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.152661,-123.202275,0,'2013-07-06 12:44:34',NULL,NULL),(77121,'96151','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.942141,-119.981473,0,'2013-07-06 12:44:34',NULL,NULL),(51294,'59217','P','Crane','D','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.711877,-104.182796,0,'2013-07-06 12:44:33',NULL,NULL),(4781,'03865','S','Plaistow','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.838950,-71.091887,0,'2013-07-06 12:44:30',NULL,NULL),(4267,'02883','P','Peace Dale','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.451648,-71.501278,0,'2013-07-06 12:44:30',NULL,NULL),(71352,'86515','P','Window Rock','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.660965,-109.102204,0,'2013-07-06 12:44:34',NULL,NULL),(72453,'89111','P','McCarran Airport','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.089397,-115.148121,0,'2013-07-06 12:44:34',NULL,NULL),(77010,'96088','S','Shingletown','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.531920,-121.845240,0,'2013-07-06 12:44:34',NULL,NULL),(9314,'09726','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42514,'47849','S','Fairbanks','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.214283,-87.524549,0,'2013-07-06 12:44:32',NULL,NULL),(38719,'44022','S','Moreland Hills','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(7448,'06854','S','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.091966,-73.433011,0,'2013-07-06 12:44:30',NULL,NULL),(35163,'39250','U','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291319,-90.185931,0,'2013-07-06 12:44:32',NULL,NULL),(28153,'30830','S','Shell Bluff','N','Burke','13033','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.092086,-82.019367,0,'2013-07-06 12:44:31',NULL,NULL),(21818,'23107','P','Maryus','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.278151,-76.403531,0,'2013-07-06 12:44:31',NULL,NULL),(13133,'13492','S','Whitestown','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.118640,-75.329340,0,'2013-07-06 12:44:30',NULL,NULL),(12406,'12933','P','Ellenburg','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.894704,-73.837993,0,'2013-07-06 12:44:30',NULL,NULL),(7288,'06535','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.314321,-72.929008,0,'2013-07-06 12:44:30',NULL,NULL),(49031,'56278','S','Ortonville','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.315111,-96.442360,0,'2013-07-06 12:44:33',NULL,NULL),(6897,'06147','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791110,-72.668684,0,'2013-07-06 12:44:30',NULL,NULL),(50741,'58401','S','Homer','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(44914,'50330','U','VISA Mastercard','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587059,-93.637291,0,'2013-07-06 12:44:32',NULL,NULL),(916,'00707','S','Urb San Pedro','N','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(36959,'41171','S','Sandy Hook','D','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(10127,'10261','U','JP Morgan Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(33731,'37818','S','Mosheim','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.169896,-82.973555,0,'2013-07-06 12:44:32',NULL,NULL),(49540,'56682','S','Roosevelt','A','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.840032,-95.286441,0,'2013-07-06 12:44:33',NULL,NULL),(76902,'95984','P','Twain','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.043280,-121.112580,0,'2013-07-06 12:44:34',NULL,NULL),(66176,'78522','P','Brownsville','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.002417,-97.571137,0,'2013-07-06 12:44:34',NULL,NULL),(66085,'78401','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.798095,-97.404668,0,'2013-07-06 12:44:34',NULL,NULL),(6582,'05858','S','Gallup Mills','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.575000,-71.784722,0,'2013-07-06 12:44:30',NULL,NULL),(40028,'45248','S','Westwood','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159624,-84.661853,0,'2013-07-06 12:44:32',NULL,NULL),(47583,'54853','S','Luck','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.569924,-92.473493,0,'2013-07-06 12:44:33',NULL,NULL),(50030,'57426','P','Brainard','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.717662,-98.606716,0,'2013-07-06 12:44:33',NULL,NULL),(60659,'71914','P','Hot Springs National Park','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.529159,-93.051519,0,'2013-07-06 12:44:33',NULL,NULL),(77213,'96380','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77968,'97373','P','St Benedict','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.056509,-122.784435,0,'2013-07-06 12:44:34',NULL,NULL),(79687,'99185','S','Wilbur','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.759063,-118.709043,0,'2013-07-06 12:44:34',NULL,NULL),(41314,'46773','S','Monroevl','A','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(7876,'07509','P','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.911995,-74.172226,0,'2013-07-06 12:44:30',NULL,NULL),(48180,'55385','S','Stewart','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.722483,-94.485164,0,'2013-07-06 12:44:33',NULL,NULL),(34040,'38135','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229541,-89.853081,0,'2013-07-06 12:44:32',NULL,NULL),(31276,'34023','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(13193,'13619','S','Wilna','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(68145,'80995','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.964661,-104.792493,0,'2013-07-06 12:44:34',NULL,NULL),(36693,'41017','S','Crescent Spg','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(36680,'41015','S','Latonia Lks','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(28709,'31829','S','Upatoi','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.563740,-84.739320,0,'2013-07-06 12:44:32',NULL,NULL),(13633,'13904','S','Hospital','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.129060,-75.821820,0,'2013-07-06 12:44:31',NULL,NULL),(28320,'31144','U','Namg','N','Cobb','13067','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',34.023650,-84.615540,0,'2013-07-06 12:44:31',NULL,NULL),(23467,'25440','P','Ridgeway','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.298009,-78.071014,0,'2013-07-06 12:44:31',NULL,NULL),(53101,'61535','S','Groveland','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.593891,-89.535053,0,'2013-07-06 12:44:33',NULL,NULL),(63097,'75263','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.752718,-96.842401,0,'2013-07-06 12:44:33',NULL,NULL),(67882,'80860','P','Elkton','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.739224,-105.125564,0,'2013-07-06 12:44:34',NULL,NULL),(75976,'95063','P','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.982267,-122.009181,0,'2013-07-06 12:44:34',NULL,NULL),(77942,'97344','S','Falls City','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.866851,-123.444396,0,'2013-07-06 12:44:34',NULL,NULL),(62691,'74728','S','Broken Bow','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.027544,-94.734750,0,'2013-07-06 12:44:33',NULL,NULL),(46006,'52534','S','Evans Junction','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.277376,-92.683877,0,'2013-07-06 12:44:32',NULL,NULL),(43826,'49085','S','Saint Joseph','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.068065,-86.475496,0,'2013-07-06 12:44:32',NULL,NULL),(23741,'25921','P','Tams','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.706351,-81.256171,0,'2013-07-06 12:44:31',NULL,NULL),(75960,'95045','S','Sn Jun Batsta','A','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.853236,-121.536794,0,'2013-07-06 12:44:34',NULL,NULL),(57707,'67344','S','Elk City','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.288200,-95.911482,0,'2013-07-06 12:44:33',NULL,NULL),(5414,'04666','S','Charlotte','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.953808,-67.162264,0,'2013-07-06 12:44:30',NULL,NULL),(6099,'05452','S','Essex','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(27418,'30099','U','Primerica Financial Services','N','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.980117,-84.149338,0,'2013-07-06 12:44:31',NULL,NULL),(36684,'41015','S','Ryland Hght','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(31194,'33936','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.615621,-81.616389,0,'2013-07-06 12:44:32',NULL,NULL),(45893,'52307','P','Middle','A','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.800087,-91.895779,0,'2013-07-06 12:44:32',NULL,NULL),(51174,'59010','S','Bighorn','D','Treasure','30103','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.079700,-107.171186,0,'2013-07-06 12:44:33',NULL,NULL),(52763,'61252','S','Garden Plain','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.855867,-90.142898,0,'2013-07-06 12:44:33',NULL,NULL),(71045,'85746','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.082299,-111.092793,0,'2013-07-06 12:44:34',NULL,NULL),(42193,'47546','S','Portersville','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.395440,-86.932333,0,'2013-07-06 12:44:32',NULL,NULL),(65276,'77478','S','Sugar Land','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.627645,-95.635597,0,'2013-07-06 12:44:34',NULL,NULL),(56853,'66002','S','Atchison','D','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.562045,-95.129084,0,'2013-07-06 12:44:33',NULL,NULL),(45981,'52411','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.040798,-91.723138,0,'2013-07-06 12:44:32',NULL,NULL),(34658,'38778','S','Sunflower','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.550255,-90.529915,0,'2013-07-06 12:44:32',NULL,NULL),(73136,'90274','S','Rllng Hls Est','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(42396,'47733','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974042,-87.573396,0,'2013-07-06 12:44:32',NULL,NULL),(19014,'19529','S','Lynn','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(31800,'35044','S','Childersburg','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.276643,-86.352253,0,'2013-07-06 12:44:32',NULL,NULL),(60077,'71355','S','Zimmer','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(49353,'56574','S','Perley','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.194663,-96.759572,0,'2013-07-06 12:44:33',NULL,NULL),(14041,'14555','S','Sodus Point','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.266985,-76.988411,0,'2013-07-06 12:44:31',NULL,NULL),(73733,'91702','S','Azusa','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.124881,-117.903021,0,'2013-07-06 12:44:34',NULL,NULL),(75517,'94151','U','IRS Service Center','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.793488,-122.400180,0,'2013-07-06 12:44:34',NULL,NULL),(18280,'19013','S','Eddystone','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(42186,'47542','S','Huntingburg','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.297169,-86.956690,0,'2013-07-06 12:44:32',NULL,NULL),(17760,'18328','S','Lakeview Township','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.227695,-74.945839,0,'2013-07-06 12:44:31',NULL,NULL),(17757,'18327','P','Delaware Water Gap','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.988659,-75.147989,0,'2013-07-06 12:44:31',NULL,NULL),(9025,'08873','S','East Millstone','N','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.499340,-74.521380,0,'2013-07-06 12:44:30',NULL,NULL),(2507,'00957','S','Urb Bayamon Gdns','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(3632,'02071','S','S Walpole','N','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.104986,-71.270463,0,'2013-07-06 12:44:30',NULL,NULL),(13012,'13418','S','North Brookfield','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.851796,-75.374964,0,'2013-07-06 12:44:30',NULL,NULL),(44931,'50359','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595835,-93.764981,0,'2013-07-06 12:44:32',NULL,NULL),(61005,'72113','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.852398,-92.404691,0,'2013-07-06 12:44:33',NULL,NULL),(63056,'75224','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.713449,-96.837214,0,'2013-07-06 12:44:33',NULL,NULL),(67791,'80723','S','Brush','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.250157,-103.619204,0,'2013-07-06 12:44:34',NULL,NULL),(71734,'87533','P','Fairview','A','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.991120,-106.080000,0,'2013-07-06 12:44:34',NULL,NULL),(74773,'93108','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.433903,-119.629863,0,'2013-07-06 12:44:34',NULL,NULL),(1240,'00729','S','Jard de Palmarejo','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(63717,'75926','S','Nigton','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.259600,-94.971845,0,'2013-07-06 12:44:34',NULL,NULL),(25416,'28301','S','E Fayettevlle','A','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(24261,'26815','S','Sugar Grove','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.498767,-79.274451,0,'2013-07-06 12:44:31',NULL,NULL),(11889,'12325','P','Glenville','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.814167,-73.940000,0,'2013-07-06 12:44:30',NULL,NULL),(46937,'54161','S','Pound','D','Marinette','55075','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.098136,-88.211847,0,'2013-07-06 12:44:32',NULL,NULL),(71949,'87941','S','Salem','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.714876,-107.233735,0,'2013-07-06 12:44:34',NULL,NULL),(32688,'36273','S','Macedonia','N','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.580874,-85.395353,0,'2013-07-06 12:44:32',NULL,NULL),(27321,'30029','P','Duluth','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.977944,-84.147687,0,'2013-07-06 12:44:31',NULL,NULL),(8839,'08638','S','Ewing Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.266540,-74.712840,0,'2013-07-06 12:44:30',NULL,NULL),(10388,'10598','S','Yorktown Heights','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.294911,-73.797703,0,'2013-07-06 12:44:30',NULL,NULL),(44063,'49442','S','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.233938,-86.169837,0,'2013-07-06 12:44:32',NULL,NULL),(75198,'93622','S','Firebaugh','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.830459,-120.540226,0,'2013-07-06 12:44:34',NULL,NULL),(56845,'65897','U','Missouri State University','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.199100,-93.276100,0,'2013-07-06 12:44:33',NULL,NULL),(3056,'01109','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.118736,-72.548305,0,'2013-07-06 12:44:30',NULL,NULL),(40079,'45298','U','Internal Revenue Service','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.087401,-84.513464,0,'2013-07-06 12:44:32',NULL,NULL),(15846,'16938','S','Morris','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(3828,'02331','P','Duxbury','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.031844,-70.694226,0,'2013-07-06 12:44:30',NULL,NULL),(2654,'00966','S','Terrs de Tintillo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(51611,'59831','S','Dixon','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.306648,-114.369745,0,'2013-07-06 12:44:33',NULL,NULL),(62980,'75143','S','Seven Points','A','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.366040,-96.286680,0,'2013-07-06 12:44:33',NULL,NULL),(68154,'81001','S','Pueblo Army Depot','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(65241,'77455','S','Provident City','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.164080,-96.406800,0,'2013-07-06 12:44:34',NULL,NULL),(59787,'71213','P','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.509651,-92.119049,0,'2013-07-06 12:44:33',NULL,NULL),(18876,'19455','U','Harriet Carter Gifts','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.211065,-75.277900,0,'2013-07-06 12:44:31',NULL,NULL),(10344,'10562','S','Kitchawan','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.174335,-73.845908,0,'2013-07-06 12:44:30',NULL,NULL),(23314,'25208','S','Bald Knob','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.903787,-81.676067,0,'2013-07-06 12:44:31',NULL,NULL),(6837,'06118','S','E Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.748563,-72.609938,0,'2013-07-06 12:44:30',NULL,NULL),(80147,'99785','P','Brevig Mission','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.459441,-166.825450,0,'2013-07-06 12:44:34',NULL,NULL),(59646,'71043','S','Hosston','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.897358,-93.887395,0,'2013-07-06 12:44:33',NULL,NULL),(23481,'25506','S','Sias','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.232678,-82.211046,0,'2013-07-06 12:44:31',NULL,NULL),(28418,'31326','S','Rincon','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.283779,-81.221548,0,'2013-07-06 12:44:32',NULL,NULL),(17861,'18433','S','Scott Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.533400,-75.542375,0,'2013-07-06 12:44:31',NULL,NULL),(35980,'40115','S','Garfield','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.753035,-86.249373,0,'2013-07-06 12:44:32',NULL,NULL),(10337,'10552','S','Fleetwood','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.922381,-73.829403,0,'2013-07-06 12:44:30',NULL,NULL),(65747,'78061','S','Frio Town','N','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',28.891692,-99.095347,0,'2013-07-06 12:44:34',NULL,NULL),(66977,'79415','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.605722,-101.873513,0,'2013-07-06 12:44:34',NULL,NULL),(78608,'98194','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.599793,-122.329770,0,'2013-07-06 12:44:34',NULL,NULL),(19193,'19809','S','Bellefonte','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.771847,-75.496485,0,'2013-07-06 12:44:31',NULL,NULL),(79650,'99146','P','Laurier','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',49.001431,-118.225126,0,'2013-07-06 12:44:34',NULL,NULL),(69280,'83440','S','Thornton','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(61201,'72231','P','N Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.746261,-92.276659,0,'2013-07-06 12:44:33',NULL,NULL),(60640,'71902','P','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.502350,-93.057544,0,'2013-07-06 12:44:33',NULL,NULL),(57667,'67215','S','Schulte','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.628626,-97.431951,0,'2013-07-06 12:44:33',NULL,NULL),(43771,'49030','S','Burr Oak','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.858964,-85.335230,0,'2013-07-06 12:44:32',NULL,NULL),(26559,'29209','S','Eastmont','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(28981,'32212','S','Jacksonville Nas','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(31895,'35142','P','Shannon','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403514,-86.874303,0,'2013-07-06 12:44:32',NULL,NULL),(5185,'04442','S','Greenvlle Jct','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.460833,-69.616667,0,'2013-07-06 12:44:30',NULL,NULL),(6426,'05743','S','Benson','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(12540,'13039','S','Cicero','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.172160,-76.071720,0,'2013-07-06 12:44:30',NULL,NULL),(15253,'16054','P','St Petersburg','A','Clarion','42031','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.158592,-79.655355,0,'2013-07-06 12:44:31',NULL,NULL),(70578,'85070','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.304598,-112.047711,0,'2013-07-06 12:44:34',NULL,NULL),(32778,'36401','S','Evergreen','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.430309,-86.956166,0,'2013-07-06 12:44:32',NULL,NULL),(62964,'75124','S','Eustace','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.305380,-95.988221,0,'2013-07-06 12:44:33',NULL,NULL),(59700,'71082','S','Vivian','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.862552,-93.989497,0,'2013-07-06 12:44:33',NULL,NULL),(15787,'16923','S','Hickox','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(77030,'96103','S','Blairsden','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(40500,'45806','S','Fort Shawnee','A','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.686359,-84.133844,0,'2013-07-06 12:44:32',NULL,NULL),(21147,'22116','P','Merrifield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.861347,-77.257450,0,'2013-07-06 12:44:31',NULL,NULL),(21667,'22947','S','Cobham','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(24967,'27844','S','Essex','N','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.246667,-77.956944,0,'2013-07-06 12:44:31',NULL,NULL),(25670,'28512','S','Atlantic Bch','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(6453,'05759','S','Clarendon','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.548900,-72.958080,0,'2013-07-06 12:44:30',NULL,NULL),(29071,'32250','S','JAX Bch','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.281220,-81.416820,0,'2013-07-06 12:44:32',NULL,NULL),(36363,'40447','S','Morrill','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(14990,'15647','S','Larimer','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.342614,-79.725305,0,'2013-07-06 12:44:31',NULL,NULL),(6032,'05403','S','South Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(16766,'17521','P','Elm','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.202510,-76.350523,0,'2013-07-06 12:44:31',NULL,NULL),(71903,'87752','S','Levy','N','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.010540,-104.701530,0,'2013-07-06 12:44:34',NULL,NULL),(74888,'93285','S','Wofford Heights','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.713219,-118.475236,0,'2013-07-06 12:44:34',NULL,NULL),(44753,'50171','S','Montezuma','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.584863,-92.525294,0,'2013-07-06 12:44:32',NULL,NULL),(48594,'55782','P','Soudan','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.816426,-92.236907,0,'2013-07-06 12:44:33',NULL,NULL),(55527,'63825','S','Bloomfield','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.886309,-89.930714,0,'2013-07-06 12:44:33',NULL,NULL),(55738,'64088','S','Sibley','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.160798,-94.188480,0,'2013-07-06 12:44:33',NULL,NULL),(66125,'78419','S','Corpus Christi Naval Air Sta','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693737,-97.264702,0,'2013-07-06 12:44:34',NULL,NULL),(68566,'81501','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.080461,-108.541256,0,'2013-07-06 12:44:34',NULL,NULL),(6891,'06144','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790732,-72.669992,0,'2013-07-06 12:44:30',NULL,NULL),(63854,'75977','S','Mayflower','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(58978,'70041','S','Pilottown','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.352900,-89.502060,0,'2013-07-06 12:44:33',NULL,NULL),(55415,'63653','S','Park Hills','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.863336,-90.592582,0,'2013-07-06 12:44:33',NULL,NULL),(55090,'63301','S','Kampville Court','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(49084,'56328','P','Flensburg','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.952423,-94.533435,0,'2013-07-06 12:44:33',NULL,NULL),(17442,'17935','S','Girardville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.790036,-76.280325,0,'2013-07-06 12:44:31',NULL,NULL),(44359,'49783','S','Sault Sainte Marie','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.478524,-84.355204,0,'2013-07-06 12:44:32',NULL,NULL),(65323,'77515','S','Anchor','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(43350,'48383','S','White Lake','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.658765,-83.542659,0,'2013-07-06 12:44:32',NULL,NULL),(40867,'46234','S','Clermont','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.807710,-86.337590,0,'2013-07-06 12:44:32',NULL,NULL),(23397,'25317','U','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.360057,-81.570732,0,'2013-07-06 12:44:31',NULL,NULL),(68075,'80937','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798001,-104.836875,0,'2013-07-06 12:44:34',NULL,NULL),(3211,'01364','S','Blissville','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(12481,'12989','S','Loon Lake','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.469526,-74.044265,0,'2013-07-06 12:44:30',NULL,NULL),(33648,'37707','P','Arthur','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.425379,-83.558044,0,'2013-07-06 12:44:32',NULL,NULL),(33479,'37339','S','Gruetli','N','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.372500,-85.598889,0,'2013-07-06 12:44:32',NULL,NULL),(48376,'55566','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.815816,-93.918673,0,'2013-07-06 12:44:33',NULL,NULL),(66569,'78738','S','The Hills','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(71220,'86324','S','Clarkdale','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.759427,-112.117522,0,'2013-07-06 12:44:34',NULL,NULL),(79688,'99201','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.668386,-117.433067,0,'2013-07-06 12:44:34',NULL,NULL),(12178,'12763','S','Mountaindale','N','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.691362,-74.525101,0,'2013-07-06 12:44:30',NULL,NULL),(41350,'46791','S','Uniondale','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.833492,-85.234445,0,'2013-07-06 12:44:32',NULL,NULL),(30813,'33617','S','Temple Ter','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.036676,-82.396230,0,'2013-07-06 12:44:32',NULL,NULL),(36429,'40579','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.136298,-84.472269,0,'2013-07-06 12:44:32',NULL,NULL),(75438,'94042','P','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.410772,-122.087316,0,'2013-07-06 12:44:34',NULL,NULL),(1278,'00730','S','Ext Santa Teresita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(18951,'19508','S','White Bear','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(50148,'57538','S','Herrick','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.113395,-99.197920,0,'2013-07-06 12:44:33',NULL,NULL),(59101,'70130','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.935313,-90.068825,0,'2013-07-06 12:44:33',NULL,NULL),(61143,'72166','S','Nady','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057122,-91.234851,0,'2013-07-06 12:44:33',NULL,NULL),(37969,'42726','S','Millerstown','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.413206,-86.157634,0,'2013-07-06 12:44:32',NULL,NULL),(55678,'64053','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.106160,-94.463378,0,'2013-07-06 12:44:33',NULL,NULL),(2968,'01050','S','Hntgtn','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(10120,'10259','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(35107,'39209','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.324026,-90.252348,0,'2013-07-06 12:44:32',NULL,NULL),(68809,'82435','S','Garland','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(69015,'83211','S','Am Falls','A','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(5187,'04443','S','Elliottsville Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.214034,-69.409404,0,'2013-07-06 12:44:30',NULL,NULL),(21364,'22443','S','Washingtons Birthplace','A','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.248998,-76.962438,0,'2013-07-06 12:44:31',NULL,NULL),(26450,'29137','S','Kitchings Mill','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.637039,-81.295434,0,'2013-07-06 12:44:31',NULL,NULL),(42550,'47872','S','Coloma','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(22705,'24340','S','Glade Spring','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.787559,-81.771869,0,'2013-07-06 12:44:31',NULL,NULL),(45597,'51554','P','Mineola','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.142317,-95.692775,0,'2013-07-06 12:44:32',NULL,NULL),(47758,'55027','S','Goodhue','D','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.407008,-92.585148,0,'2013-07-06 12:44:33',NULL,NULL),(51186,'59022','S','Crow Agency','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.643077,-107.468227,0,'2013-07-06 12:44:33',NULL,NULL),(40943,'46298','U','Greater Indiana District','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.893930,-86.229942,0,'2013-07-06 12:44:32',NULL,NULL),(64150,'76201','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.220863,-97.144294,0,'2013-07-06 12:44:34',NULL,NULL),(32211,'35563','S','Gu-Win','A','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.966394,-87.895475,0,'2013-07-06 12:44:32',NULL,NULL),(24970,'27845','S','Lasker','A','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.393280,-77.420095,0,'2013-07-06 12:44:31',NULL,NULL),(13983,'14489','S','Lyons','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.087298,-76.996974,0,'2013-07-06 12:44:31',NULL,NULL),(2289,'00926','S','Villas de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(69387,'83612','S','Bear','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(69424,'83634','S','Mora','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.477369,-116.392000,0,'2013-07-06 12:44:34',NULL,NULL),(8786,'08557','P','Sergeantsvlle','A','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.445407,-74.943046,0,'2013-07-06 12:44:30',NULL,NULL),(1823,'00784','S','Parc Nueva Olimpo','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(973,'00716','S','Urb Los Caobos','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(32327,'35767','P','Ryland','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.770398,-86.481716,0,'2013-07-06 12:44:32',NULL,NULL),(31421,'34250','P','Terra Ceia','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.575069,-82.576017,0,'2013-07-06 12:44:32',NULL,NULL),(22784,'24458','S','Mc Dowell','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.301798,-79.524270,0,'2013-07-06 12:44:31',NULL,NULL),(43617,'48809','S','Belding','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',43.077173,-85.228388,0,'2013-07-06 12:44:32',NULL,NULL),(50390,'57767','S','Wicksville','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.994400,-102.591900,0,'2013-07-06 12:44:33',NULL,NULL),(51420,'59448','P','Heart Butte','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.315582,-112.929607,0,'2013-07-06 12:44:33',NULL,NULL),(66865,'79189','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.199732,-101.816887,0,'2013-07-06 12:44:34',NULL,NULL),(72931,'90033','S','Boyle Heights','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.049807,-118.209245,0,'2013-07-06 12:44:34',NULL,NULL),(76721,'95865','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.588685,-121.407253,0,'2013-07-06 12:44:34',NULL,NULL),(76800,'95945','S','Union Hill','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(5127,'04408','S','Aurora','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.923680,-68.335427,0,'2013-07-06 12:44:30',NULL,NULL),(76809,'95949','S','Grass Valley','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.121108,-121.081015,0,'2013-07-06 12:44:34',NULL,NULL),(19107,'19606','S','Mount Penn','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(6297,'05653','S','Eden','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.707222,-72.546111,0,'2013-07-06 12:44:30',NULL,NULL),(15091,'15759','S','Marion Center','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.786688,-79.031890,0,'2013-07-06 12:44:31',NULL,NULL),(2318,'00929','P','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.401987,-66.023228,0,'2013-07-06 12:44:30',NULL,NULL),(8776,'08550','S','West Windsor','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(45783,'52160','S','New Albin','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.495201,-91.284754,0,'2013-07-06 12:44:32',NULL,NULL),(2732,'00969','S','Urb Frailes Sur','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(18658,'19175','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.949991,-75.154637,0,'2013-07-06 12:44:31',NULL,NULL),(40091,'45305','S','Beavercreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(34066,'38147','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142153,-90.054546,0,'2013-07-06 12:44:32',NULL,NULL),(30959,'33736','P','St Pete Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742754,-82.748427,0,'2013-07-06 12:44:32',NULL,NULL),(65933,'78250','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.508030,-98.664842,0,'2013-07-06 12:44:34',NULL,NULL),(50086,'57465','S','Northville','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.166500,-98.688780,0,'2013-07-06 12:44:33',NULL,NULL),(2556,'00959','S','Urb Altos de Torrimar','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(73241,'90671','P','Santa Fe Spgs','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.932507,-118.058491,0,'2013-07-06 12:44:34',NULL,NULL),(65555,'77840','S','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.603583,-96.311081,0,'2013-07-06 12:44:34',NULL,NULL),(69351,'83544','S','Greer','N','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.517820,-116.111280,0,'2013-07-06 12:44:34',NULL,NULL),(50376,'57759','S','Nemo','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.199962,-103.516384,0,'2013-07-06 12:44:33',NULL,NULL),(1692,'00777','S','Sect Canales','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(38403,'43531','P','Kunkle','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.635529,-84.493224,0,'2013-07-06 12:44:32',NULL,NULL),(13531,'13820','S','West End','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.481020,-75.070440,0,'2013-07-06 12:44:31',NULL,NULL),(2971,'01050','S','Montgomery','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(33796,'37887','S','Wartburg','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.047026,-84.613764,0,'2013-07-06 12:44:32',NULL,NULL),(31491,'34436','S','Floral City','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.721477,-82.298318,0,'2013-07-06 12:44:32',NULL,NULL),(21078,'22027','S','Dunn Loring','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.894516,-77.223341,0,'2013-07-06 12:44:31',NULL,NULL),(20589,'21162','S','White Marsh','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.395111,-76.411347,0,'2013-07-06 12:44:31',NULL,NULL),(61177,'72201','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.748078,-92.276457,0,'2013-07-06 12:44:33',NULL,NULL),(65584,'77867','P','Mumford','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',30.731767,-96.565295,0,'2013-07-06 12:44:34',NULL,NULL),(70227,'84404','S','Ms City','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(70559,'85043','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.439449,-112.191012,0,'2013-07-06 12:44:34',NULL,NULL),(79750,'99252','U','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.657262,-117.377674,0,'2013-07-06 12:44:34',NULL,NULL),(8052,'07737','S','Leonardo','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.411795,-74.059003,0,'2013-07-06 12:44:30',NULL,NULL),(2446,'00953','S','Urb Plaza de la Fuente','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(11847,'12250','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.673005,-73.735244,0,'2013-07-06 12:44:30',NULL,NULL),(34009,'38124','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.111049,-89.907808,0,'2013-07-06 12:44:32',NULL,NULL),(65793,'78124','S','Marion','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.574239,-98.150612,0,'2013-07-06 12:44:34',NULL,NULL),(72593,'89407','P','Fallon','D','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.471205,-118.780385,0,'2013-07-06 12:44:34',NULL,NULL),(79744,'99223','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.611523,-117.358133,0,'2013-07-06 12:44:34',NULL,NULL),(21899,'23186','U','College of William & Mary','N','Williamsburg City','51830','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.272593,-76.682518,0,'2013-07-06 12:44:31',NULL,NULL),(9618,'10033','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(69528,'83729','U','Washington Group','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.605939,-116.193296,0,'2013-07-06 12:44:34',NULL,NULL),(62553,'74440','P','Hoyt','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.271675,-95.303078,0,'2013-07-06 12:44:33',NULL,NULL),(17661,'18085','P','Tatamy','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.737579,-75.255429,0,'2013-07-06 12:44:31',NULL,NULL),(35204,'39289','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.385455,-90.276532,0,'2013-07-06 12:44:32',NULL,NULL),(5818,'05073','S','Taftsville','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.629922,-72.463386,0,'2013-07-06 12:44:30',NULL,NULL),(10025,'10171','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(47333,'54565','S','Upson','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.342704,-90.470449,0,'2013-07-06 12:44:32',NULL,NULL),(49024,'56271','S','De Graff','A','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.224810,-95.391809,0,'2013-07-06 12:44:33',NULL,NULL),(49965,'57350','S','James Valley','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.359540,-98.217645,0,'2013-07-06 12:44:33',NULL,NULL),(50083,'57460','S','Mansfield','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.216824,-98.632295,0,'2013-07-06 12:44:33',NULL,NULL),(50329,'57730','S','Harney Peak','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(55717,'64075','S','Oak Grove','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.998544,-94.144642,0,'2013-07-06 12:44:33',NULL,NULL),(65905,'78236','S','Jbsa Lackland','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(67810,'80744','S','Ovid','D','Sedgwick','08115','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.934084,-102.381984,0,'2013-07-06 12:44:34',NULL,NULL),(75545,'94236','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583196,-121.490865,0,'2013-07-06 12:44:34',NULL,NULL),(77594,'96929','S','Yigo','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.539783,144.899632,0,'2013-07-06 12:44:34',NULL,NULL),(79041,'98405','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.249001,-122.465330,0,'2013-07-06 12:44:34',NULL,NULL),(1290,'00730','S','Urb Glenview Gdns','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(14763,'15336','P','Gastonville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.263798,-80.007512,0,'2013-07-06 12:44:31',NULL,NULL),(54597,'62906','S','Anna','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.463400,-89.229960,0,'2013-07-06 12:44:33',NULL,NULL),(71301,'86503','S','Canyon de Chelly National Mo','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(77631,'97006','S','Aloha','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.516558,-122.858874,0,'2013-07-06 12:44:34',NULL,NULL),(62875,'75044','S','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.966795,-96.665145,0,'2013-07-06 12:44:33',NULL,NULL),(20508,'21077','S','Harmans','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.156823,-76.701819,0,'2013-07-06 12:44:31',NULL,NULL),(27556,'30258','S','Molena','D','Pike','13231','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',32.972429,-84.454609,0,'2013-07-06 12:44:31',NULL,NULL),(9800,'10109','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(851,'00698','S','Qtas de Valle Verde','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(3461,'01801','S','Woburn','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.484238,-71.157430,0,'2013-07-06 12:44:30',NULL,NULL),(27797,'30388','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647853,-84.388398,0,'2013-07-06 12:44:31',NULL,NULL),(43440,'48505','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.062702,-83.692479,0,'2013-07-06 12:44:32',NULL,NULL),(43824,'49084','P','Riverside','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.182986,-86.380844,0,'2013-07-06 12:44:32',NULL,NULL),(62832,'75001','S','Addison','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.961429,-96.829542,0,'2013-07-06 12:44:33',NULL,NULL),(66982,'79430','U','Texas Tech School of Medicin','N','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.592746,-101.898787,0,'2013-07-06 12:44:34',NULL,NULL),(67869,'80830','S','Matheson','D','Elbert','08039','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.092970,-103.918338,0,'2013-07-06 12:44:34',NULL,NULL),(32080,'35288','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463112,-86.769414,0,'2013-07-06 12:44:32',NULL,NULL),(30677,'33470','S','Lox','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(24728,'27518','S','Cary','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.756619,-78.781530,0,'2013-07-06 12:44:31',NULL,NULL),(1699,'00777','S','Urb Lirios Cala II','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(68880,'82648','P','Powder River','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.113054,-107.014093,0,'2013-07-06 12:44:34',NULL,NULL),(73411,'91182','U','Fuller Theological Seminary','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.148771,-118.140407,0,'2013-07-06 12:44:34',NULL,NULL),(1902,'00795','S','Brisas Del Valle','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(39441,'44691','S','Wooster','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.806978,-81.956817,0,'2013-07-06 12:44:32',NULL,NULL),(51041,'58727','S','Larson','A','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.862800,-102.815100,0,'2013-07-06 12:44:33',NULL,NULL),(5576,'04903','P','Waterville','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.540326,-69.635013,0,'2013-07-06 12:44:30',NULL,NULL),(23400,'25320','S','Sissonville','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.526900,-81.639120,0,'2013-07-06 12:44:31',NULL,NULL),(72502,'89148','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.057633,-115.319731,0,'2013-07-06 12:44:34',NULL,NULL),(34030,'38132','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.062992,-89.976596,0,'2013-07-06 12:44:32',NULL,NULL),(14343,'15010','S','Beaver Falls','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.763952,-80.341536,0,'2013-07-06 12:44:31',NULL,NULL),(29646,'32903','S','Indialantic','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.116342,-80.582287,0,'2013-07-06 12:44:32',NULL,NULL),(12054,'12531','S','Whaley Lake','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.504700,-73.661640,0,'2013-07-06 12:44:30',NULL,NULL),(6972,'06239','S','East Brooklyn','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.790480,-71.855880,0,'2013-07-06 12:44:30',NULL,NULL),(78904,'98362','S','Lake Crescent','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(79312,'98596','S','Saint Urbans','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.496928,-122.919210,0,'2013-07-06 12:44:34',NULL,NULL),(32155,'35470','S','Livingston','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.602560,-88.164180,0,'2013-07-06 12:44:32',NULL,NULL),(45147,'50582','S','Rutland','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.757650,-94.291712,0,'2013-07-06 12:44:32',NULL,NULL),(5657,'04961','S','Carrying Place Town TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(17729,'18250','S','Summit Hill','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.828849,-75.873626,0,'2013-07-06 12:44:31',NULL,NULL),(2394,'00949','S','Urb Santa Maria','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(69365,'83554','S','White Bird','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.750001,-116.206388,0,'2013-07-06 12:44:34',NULL,NULL),(64345,'76518','S','Sharp','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.894745,-97.123059,0,'2013-07-06 12:44:34',NULL,NULL),(6522,'05826','S','Craftsbury','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.642564,-72.352204,0,'2013-07-06 12:44:30',NULL,NULL),(17193,'17821','S','Danville East','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(36180,'40250','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.218955,-85.620945,0,'2013-07-06 12:44:32',NULL,NULL),(6158,'05471','S','Montgomery Center','D','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.860467,-72.593608,0,'2013-07-06 12:44:30',NULL,NULL),(23505,'25534','S','Cove Gap','A','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.095556,-82.254444,0,'2013-07-06 12:44:31',NULL,NULL),(57213,'66440','S','Hoyt','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.247703,-95.704724,0,'2013-07-06 12:44:33',NULL,NULL),(59058,'70091','S','Venice','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.209341,-89.231358,0,'2013-07-06 12:44:33',NULL,NULL),(64856,'77053','S','Houston','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.595640,-95.454151,0,'2013-07-06 12:44:34',NULL,NULL),(69213,'83355','S','Wendell','D','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.760933,-114.702018,0,'2013-07-06 12:44:34',NULL,NULL),(75854,'94933','P','Forest Knolls','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.015968,-122.691503,0,'2013-07-06 12:44:34',NULL,NULL),(77127,'96155','P','Meyers','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.018968,-120.123053,0,'2013-07-06 12:44:34',NULL,NULL),(51786,'60045','S','Green Oaks','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.233956,-87.863856,0,'2013-07-06 12:44:33',NULL,NULL),(58708,'68933','S','Lynn','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.528949,-98.058999,0,'2013-07-06 12:44:33',NULL,NULL),(75646,'94525','S','Crockett','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',38.052469,-122.219057,0,'2013-07-06 12:44:34',NULL,NULL),(37201,'41522','S','Big Branch','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(11006,'11555','U','Citibank','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705942,-73.595749,0,'2013-07-06 12:44:30',NULL,NULL),(49754,'57063','S','Lakeport','N','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.951432,-97.665236,0,'2013-07-06 12:44:33',NULL,NULL),(67705,'80526','S','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.545580,-105.112604,0,'2013-07-06 12:44:34',NULL,NULL),(68761,'82242','S','Van Tassell','D','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.694487,-104.114695,0,'2013-07-06 12:44:34',NULL,NULL),(33069,'36768','S','Snow Hill','A','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.936892,-87.008880,0,'2013-07-06 12:44:32',NULL,NULL),(2057,'00920','S','Pto Nuevo','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(41473,'46926','S','Chili','A','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.891935,-86.050254,0,'2013-07-06 12:44:32',NULL,NULL),(39626,'44889','S','Wakeman','D','Huron','39077','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.224184,-82.403611,0,'2013-07-06 12:44:32',NULL,NULL),(7525,'07005','S','Lk Intervale','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(12935,'13346','S','Colgate','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827220,-75.529560,0,'2013-07-06 12:44:30',NULL,NULL),(12063,'12540','S','La Grange','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.668320,-73.743900,0,'2013-07-06 12:44:30',NULL,NULL),(48812,'56025','S','Easton','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.760588,-93.949610,0,'2013-07-06 12:44:33',NULL,NULL),(56849,'65898','U','Bass Pro Shops','N','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.213380,-93.292201,0,'2013-07-06 12:44:33',NULL,NULL),(62309,'74034','P','Hailey','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.233896,-96.567733,0,'2013-07-06 12:44:33',NULL,NULL),(77282,'96617','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(26715,'29414','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.821883,-80.055197,0,'2013-07-06 12:44:31',NULL,NULL),(19015,'19529','S','Slateville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(6180,'05474','S','North Hero','D','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(43291,'48335','S','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.466205,-83.401727,0,'2013-07-06 12:44:32',NULL,NULL),(21281,'22320','P','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.805356,-77.056422,0,'2013-07-06 12:44:31',NULL,NULL),(75730,'94592','S','Vallejo','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.102623,-122.275686,0,'2013-07-06 12:44:34',NULL,NULL),(16582,'17321','S','Fawn Grove','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.752280,-76.447440,0,'2013-07-06 12:44:31',NULL,NULL),(57734,'67420','S','Beloit','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.451140,-98.110080,0,'2013-07-06 12:44:33',NULL,NULL),(639,'00682','S','Urb La Riviera','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(19823,'20468','U','GSA Surplus Sales','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894581,-77.036348,0,'2013-07-06 12:44:31',NULL,NULL),(32291,'35674','S','Tuscumbia','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.725279,-87.697761,0,'2013-07-06 12:44:32',NULL,NULL),(7089,'06351','S','Lisbon','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.601907,-71.977075,0,'2013-07-06 12:44:30',NULL,NULL),(21236,'22230','U','National Science Foundation','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.870056,-77.116680,0,'2013-07-06 12:44:31',NULL,NULL),(10780,'11366','S','Utopia','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.729445,-73.797794,0,'2013-07-06 12:44:30',NULL,NULL),(10683,'11208','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.673964,-73.872964,0,'2013-07-06 12:44:30',NULL,NULL),(43836,'49093','S','Three Rivers','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.960439,-85.636997,0,'2013-07-06 12:44:32',NULL,NULL),(50708,'58366','S','Nanson','A','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.654300,-99.890100,0,'2013-07-06 12:44:33',NULL,NULL),(53782,'62277','S','Pr du Rocher','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.082633,-90.098910,0,'2013-07-06 12:44:33',NULL,NULL),(56185,'65014','S','Bland','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(32547,'36110','S','Chisolm','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.418887,-86.273229,0,'2013-07-06 12:44:32',NULL,NULL),(64991,'77280','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.860314,-95.585484,0,'2013-07-06 12:44:34',NULL,NULL),(19876,'20530','U','Dept Justice','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891194,-77.022162,0,'2013-07-06 12:44:31',NULL,NULL),(50282,'57649','S','Prairie City','D','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.603149,-102.825211,0,'2013-07-06 12:44:33',NULL,NULL),(51379,'59411','P','Babb','D','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.851670,-113.435990,0,'2013-07-06 12:44:33',NULL,NULL),(4144,'02761','P','North Attleboro','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.979305,-71.331434,0,'2013-07-06 12:44:30',NULL,NULL),(17853,'18428','S','Lords Valley','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.473980,-75.205080,0,'2013-07-06 12:44:31',NULL,NULL),(17634,'18059','S','Laurys Station','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.727455,-75.535044,0,'2013-07-06 12:44:31',NULL,NULL),(33087,'36801','S','Opelika','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.640621,-85.382583,0,'2013-07-06 12:44:32',NULL,NULL),(29637,'32896','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.537421,-81.381153,0,'2013-07-06 12:44:32',NULL,NULL),(25130,'28009','P','Badin','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.405852,-80.114436,0,'2013-07-06 12:44:31',NULL,NULL),(9157,'09313','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42324,'47620','S','Solitude','N','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.950895,-87.862090,0,'2013-07-06 12:44:32',NULL,NULL),(16726,'17408','S','New Salem Borough','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015315,-76.597579,0,'2013-07-06 12:44:31',NULL,NULL),(32456,'36025','S','Elmore','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.516019,-86.351147,0,'2013-07-06 12:44:32',NULL,NULL),(13945,'14445','S','East Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.112550,-77.489182,0,'2013-07-06 12:44:31',NULL,NULL),(3039,'01102','P','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.116054,-72.538580,0,'2013-07-06 12:44:30',NULL,NULL),(44919,'50332','U','Wells Fargo Mortgage','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.589141,-93.637284,0,'2013-07-06 12:44:32',NULL,NULL),(45761,'52146','S','Harpers Ferry','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.201376,-91.147423,0,'2013-07-06 12:44:32',NULL,NULL),(49768,'57069','S','Vermillion','D','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.781151,-96.924411,0,'2013-07-06 12:44:33',NULL,NULL),(60582,'71820','P','Alleene','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.766950,-94.262426,0,'2013-07-06 12:44:33',NULL,NULL),(63419,'75657','S','Jefferson','D','Marion','48315','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.787670,-94.073130,0,'2013-07-06 12:44:33',NULL,NULL),(68178,'81019','P','Colo City','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.943546,-104.846617,0,'2013-07-06 12:44:34',NULL,NULL),(68733,'82201','S','Bordeaux','A','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031976,-104.976675,0,'2013-07-06 12:44:34',NULL,NULL),(57688,'67260','U','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.707488,-97.281218,0,'2013-07-06 12:44:33',NULL,NULL),(50713,'58368','S','Pleasant Lake','A','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.303660,-99.994440,0,'2013-07-06 12:44:33',NULL,NULL),(65111,'77372','S','Patton Vlg','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.220286,-95.158358,0,'2013-07-06 12:44:34',NULL,NULL),(52944,'61410','S','Abingdon','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.802476,-90.401919,0,'2013-07-06 12:44:33',NULL,NULL),(28687,'31803','S','Tazewell','A','Marion','13197','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.312777,-84.511370,0,'2013-07-06 12:44:32',NULL,NULL),(592,'00680','S','Repto Flamboyan','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(8365,'08053','S','Evesboro','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(37863,'42528','S','Dunnville','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.171173,-85.079962,0,'2013-07-06 12:44:32',NULL,NULL),(20168,'20743','S','Fairmount Hgt','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.885663,-76.901034,0,'2013-07-06 12:44:31',NULL,NULL),(2837,'00982','S','Urb Country Club','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(2703,'00969','S','Ext Parkville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(26285,'29020','S','Kirkwood','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(23380,'25304','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.320517,-81.591144,0,'2013-07-06 12:44:31',NULL,NULL),(46420,'53186','S','Vernon','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.013231,-88.214586,0,'2013-07-06 12:44:32',NULL,NULL),(54861,'63047','P','Hematite','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.201959,-90.478230,0,'2013-07-06 12:44:33',NULL,NULL),(60578,'71772','P','Whelen Springs','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.831489,-93.126424,0,'2013-07-06 12:44:33',NULL,NULL),(62009,'73443','S','Lone Grove','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.175811,-97.261787,0,'2013-07-06 12:44:33',NULL,NULL),(19324,'20024','S','Fort McNair','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879013,-77.020737,0,'2013-07-06 12:44:31',NULL,NULL),(7603,'07045','S','Montville Township','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.909925,-74.364898,0,'2013-07-06 12:44:30',NULL,NULL),(70618,'85127','P','Chandler Heights','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.210185,-111.687173,0,'2013-07-06 12:44:34',NULL,NULL),(40962,'46319','S','Griffith','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.532140,-87.421913,0,'2013-07-06 12:44:32',NULL,NULL),(47521,'54806','S','Bad River Indian Reservation','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(43648,'48841','S','Owosso','A','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.100242,-84.227445,0,'2013-07-06 12:44:32',NULL,NULL),(56017,'64659','S','Meadville','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.780240,-93.299940,0,'2013-07-06 12:44:33',NULL,NULL),(63882,'76013','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.717191,-97.152038,0,'2013-07-06 12:44:34',NULL,NULL),(8763,'08540','S','Princeton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.367460,-74.669520,0,'2013-07-06 12:44:30',NULL,NULL),(61368,'72519','S','Calico Rock','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.152503,-92.016533,0,'2013-07-06 12:44:33',NULL,NULL),(2520,'00957','S','Urb Royal Gdns','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(18869,'19451','P','Harleysville','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.265419,-75.357024,0,'2013-07-06 12:44:31',NULL,NULL),(34044,'38136','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099619,-90.036265,0,'2013-07-06 12:44:32',NULL,NULL),(30951,'33732','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.756372,-82.643512,0,'2013-07-06 12:44:32',NULL,NULL),(11770,'12203','S','McKownville','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(46613,'53571','P','Morrisonville','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.277632,-89.357662,0,'2013-07-06 12:44:32',NULL,NULL),(47103,'54443','S','Eau Pleine','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.604785,-89.748588,0,'2013-07-06 12:44:32',NULL,NULL),(48401,'55589','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.277793,-93.810904,0,'2013-07-06 12:44:33',NULL,NULL),(48629,'55806','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.774041,-92.124646,0,'2013-07-06 12:44:33',NULL,NULL),(48649,'55905','U','Mayo Clinic','N','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.037368,-92.490118,0,'2013-07-06 12:44:33',NULL,NULL),(51679,'59926','S','Martin City','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.391343,-114.039284,0,'2013-07-06 12:44:33',NULL,NULL),(53465,'61928','S','Gays','D','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.486579,-88.541705,0,'2013-07-06 12:44:33',NULL,NULL),(55495,'63771','S','Painton','A','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.085317,-89.648175,0,'2013-07-06 12:44:33',NULL,NULL),(79669,'99160','S','Orient','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.865447,-118.201993,0,'2013-07-06 12:44:34',NULL,NULL),(17935,'18501','P','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.373105,-75.683695,0,'2013-07-06 12:44:31',NULL,NULL),(16311,'17113','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.247280,-76.842480,0,'2013-07-06 12:44:31',NULL,NULL),(56260,'65062','S','Bland','A','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.531941,-91.612913,0,'2013-07-06 12:44:33',NULL,NULL),(71226,'86332','S','Kirkland','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.433099,-112.599720,0,'2013-07-06 12:44:34',NULL,NULL),(25153,'28025','S','North Concord','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.400953,-80.583807,0,'2013-07-06 12:44:31',NULL,NULL),(5770,'05045','S','Lake Morey','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.916667,-72.150000,0,'2013-07-06 12:44:30',NULL,NULL),(54356,'62796','U','IL Ro Tax Div','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797299,-89.621525,0,'2013-07-06 12:44:33',NULL,NULL),(28071,'30719','P','Dalton','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.770019,-84.970725,0,'2013-07-06 12:44:31',NULL,NULL),(79585,'99027','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.702089,-117.110984,0,'2013-07-06 12:44:34',NULL,NULL),(1092,'00725','S','Urb El Rincon De La Serrania','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(22033,'23295','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.555283,-77.461217,0,'2013-07-06 12:44:31',NULL,NULL),(65602,'77901','S','Guadalupe','N','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.706750,-97.181430,0,'2013-07-06 12:44:34',NULL,NULL),(6523,'05826','S','East Craftsbury','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.642564,-72.352204,0,'2013-07-06 12:44:30',NULL,NULL),(14844,'15443','P','Hibbs','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.930820,-79.885064,0,'2013-07-06 12:44:31',NULL,NULL),(37759,'42330','S','Central Cty','A','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294778,-87.126648,0,'2013-07-06 12:44:32',NULL,NULL),(17344,'17870','S','Blue Hill','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(13574,'13843','S','Rockwells Mills','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(30935,'33713','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.788397,-82.674456,0,'2013-07-06 12:44:32',NULL,NULL),(27727,'30349','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.614175,-84.497109,0,'2013-07-06 12:44:31',NULL,NULL),(9506,'10014','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(44464,'49883','S','Seney','D','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.420521,-86.051082,0,'2013-07-06 12:44:32',NULL,NULL),(60230,'71430','S','Bennetts Bay','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(60419,'71640','S','Grand Lake','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(54202,'62638','S','Clements','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.621696,-90.042782,0,'2013-07-06 12:44:33',NULL,NULL),(8277,'08012','S','Blenheim','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(14954,'15616','P','Armbrust','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.242673,-79.551029,0,'2013-07-06 12:44:31',NULL,NULL),(50242,'57625','S','Eagle Butte','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.994139,-101.237386,0,'2013-07-06 12:44:33',NULL,NULL),(1863,'00791','S','Plaza Del Mar','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(16711,'17403','S','Wyndham Hills','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(13547,'13830','S','Oxford','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(20157,'20740','S','Berwyn','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998722,-76.928721,0,'2013-07-06 12:44:31',NULL,NULL),(47022,'54313','S','Howard','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.558732,-88.102722,0,'2013-07-06 12:44:32',NULL,NULL),(47493,'54756','S','Nelson','D','Buffalo','55011','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.440524,-92.014778,0,'2013-07-06 12:44:32',NULL,NULL),(69326,'83522','S','Cottonwood','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.023442,-116.268584,0,'2013-07-06 12:44:34',NULL,NULL),(74091,'92196','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.914241,-117.126252,0,'2013-07-06 12:44:34',NULL,NULL),(76260,'95412','S','Annapolis','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.694238,-123.326413,0,'2013-07-06 12:44:34',NULL,NULL),(78750,'98292','S','Elger Bay','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.179280,-122.371440,0,'2013-07-06 12:44:34',NULL,NULL),(54764,'62988','S','Elco','A','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.234196,-89.266755,0,'2013-07-06 12:44:33',NULL,NULL),(28279,'31087','S','Sparta','D','Hancock','13141','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.277104,-82.971578,0,'2013-07-06 12:44:31',NULL,NULL),(21806,'23090','P','Lightfoot','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.323189,-76.738989,0,'2013-07-06 12:44:31',NULL,NULL),(20077,'20685','S','Saint Leonard','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.438901,-76.519070,0,'2013-07-06 12:44:31',NULL,NULL),(27505,'30178','S','Taylorsville','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.118231,-84.974477,0,'2013-07-06 12:44:31',NULL,NULL),(17277,'17845','S','Gleniron','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864071,-77.239421,0,'2013-07-06 12:44:31',NULL,NULL),(54711,'62957','S','East Cape Girardeau','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.295028,-89.495807,0,'2013-07-06 12:44:33',NULL,NULL),(45699,'52054','S','La Motte','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.379281,-90.670192,0,'2013-07-06 12:44:32',NULL,NULL),(64916,'77203','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.758943,-95.367728,0,'2013-07-06 12:44:34',NULL,NULL),(72231,'88435','S','Santa Rosa','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.936606,-104.684358,0,'2013-07-06 12:44:34',NULL,NULL),(39329,'44614','S','Lawrence','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.880580,-81.589680,0,'2013-07-06 12:44:32',NULL,NULL),(35467,'39503','S','Orange Grove','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.473100,-89.153820,0,'2013-07-06 12:44:32',NULL,NULL),(11349,'11796','S','West Sayville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732739,-73.100528,0,'2013-07-06 12:44:30',NULL,NULL),(15844,'16938','S','Hoytville','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(41719,'47240','S','Sandusky','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(43998,'49344','S','Shelbyville','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.601379,-85.613081,0,'2013-07-06 12:44:32',NULL,NULL),(55372,'63601','S','Flat River','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(62586,'74467','S','Wagoner','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.957074,-95.369537,0,'2013-07-06 12:44:33',NULL,NULL),(66375,'78621','S','Elgin','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(71616,'87328','P','Navajo','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.899177,-109.030882,0,'2013-07-06 12:44:34',NULL,NULL),(19103,'19605','S','Tuckerton','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(74168,'92268','P','Rimrock','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.184357,-116.516406,0,'2013-07-06 12:44:34',NULL,NULL),(47552,'54830','S','Danbury','D','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.998019,-92.252388,0,'2013-07-06 12:44:32',NULL,NULL),(36232,'40291','S','Fern Creek','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.125140,-85.589280,0,'2013-07-06 12:44:32',NULL,NULL),(7488,'06906','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.070278,-73.523724,0,'2013-07-06 12:44:30',NULL,NULL),(46690,'53783','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.159291,-89.283709,0,'2013-07-06 12:44:32',NULL,NULL),(73025,'90072','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.097188,-118.309018,0,'2013-07-06 12:44:34',NULL,NULL),(11479,'12019','S','Burnt Hills','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.921720,-73.890600,0,'2013-07-06 12:44:30',NULL,NULL),(9829,'10114','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(5232,'04468','S','Argyle Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.930939,-68.654151,0,'2013-07-06 12:44:30',NULL,NULL),(24546,'27292','S','Lexington','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(30140,'33166','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(32423,'35979','S','Higdon','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.882242,-85.639687,0,'2013-07-06 12:44:32',NULL,NULL),(43610,'48801','S','Alma','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.375805,-84.664584,0,'2013-07-06 12:44:32',NULL,NULL),(44009,'49355','U','Amway Corp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.953901,-85.478655,0,'2013-07-06 12:44:32',NULL,NULL),(50338,'57735','S','Edgemont','D','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(36171,'40243','S','Douglass Hls','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(46262,'53018','S','Delafield','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.063198,-88.402580,0,'2013-07-06 12:44:32',NULL,NULL),(24633,'27370','S','Trinity','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.868794,-79.948733,0,'2013-07-06 12:44:31',NULL,NULL),(32698,'36276','S','Sikesville','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(33059,'36761','S','Minter','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.086912,-87.016816,0,'2013-07-06 12:44:32',NULL,NULL),(28920,'32157','P','Lake Como','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.480074,-81.574063,0,'2013-07-06 12:44:32',NULL,NULL),(45146,'50581','S','Rolfe','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.812984,-94.529614,0,'2013-07-06 12:44:32',NULL,NULL),(8629,'08260','S','North Wildwood','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(78686,'98248','S','Ferndale','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.858300,-122.606024,0,'2013-07-06 12:44:34',NULL,NULL),(6658,'06024','S','East Canaan','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.014044,-73.287474,0,'2013-07-06 12:44:30',NULL,NULL),(16479,'17249','P','Rockhill Furnace','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.242980,-77.900687,0,'2013-07-06 12:44:31',NULL,NULL),(2100,'00923','S','Urb Dos Pinos','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(12356,'12887','S','Dresden Station','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.554480,-73.401960,0,'2013-07-06 12:44:30',NULL,NULL),(9389,'09848','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71421,'87026','S','Canoncito','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(79325,'98605','S','Cook','A','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.738971,-121.475690,0,'2013-07-06 12:44:34',NULL,NULL),(40237,'45423','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.757346,-84.187384,0,'2013-07-06 12:44:32',NULL,NULL),(17307,'17853','S','Mt Plsnt Mills','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(20623,'21213','S','Clifton East End','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.312520,-76.583450,0,'2013-07-06 12:44:31',NULL,NULL),(67171,'79839','S','Fort Hancock','D','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.297510,-105.837570,0,'2013-07-06 12:44:34',NULL,NULL),(35160,'39250','U','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.291319,-90.185931,0,'2013-07-06 12:44:32',NULL,NULL),(33569,'37415','S','Red Bank','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.127000,-85.274040,0,'2013-07-06 12:44:32',NULL,NULL),(29906,'33051','P','Marathon','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.721329,-81.021245,0,'2013-07-06 12:44:32',NULL,NULL),(10200,'10310','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.630863,-74.117886,0,'2013-07-06 12:44:30',NULL,NULL),(10470,'10940','S','Scotchtown Branch','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.474400,-74.410980,0,'2013-07-06 12:44:30',NULL,NULL),(24738,'27526','S','Duncan','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.598540,-78.784320,0,'2013-07-06 12:44:31',NULL,NULL),(54513,'62871','S','Elba','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.886303,-88.267731,0,'2013-07-06 12:44:33',NULL,NULL),(57871,'67583','S','Preston','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.807408,-98.427406,0,'2013-07-06 12:44:33',NULL,NULL),(60231,'71430','S','Blue Lake','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(61994,'73403','P','Ardmore','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.172863,-97.144409,0,'2013-07-06 12:44:33',NULL,NULL),(71339,'86511','P','Hunters Point','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.853888,-109.299177,0,'2013-07-06 12:44:34',NULL,NULL),(75941,'95031','P','Los Gatos','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.130087,-121.938513,0,'2013-07-06 12:44:34',NULL,NULL),(26461,'29146','S','Springfield','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.497823,-81.280338,0,'2013-07-06 12:44:31',NULL,NULL),(4911,'04070','P','Scarborough','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.570278,-70.388333,0,'2013-07-06 12:44:30',NULL,NULL),(24847,'27623','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.859066,-78.790232,0,'2013-07-06 12:44:31',NULL,NULL),(35462,'39501','S','Us Nav Const Batt','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.385481,-89.086881,0,'2013-07-06 12:44:32',NULL,NULL),(11655,'12134','S','Edinburg','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.234942,-74.156837,0,'2013-07-06 12:44:30',NULL,NULL),(48773,'55987','S','Pickwick','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(3564,'01951','S','Newbury','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.789959,-70.844019,0,'2013-07-06 12:44:30',NULL,NULL),(14851,'15450','S','La Belle','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.966730,-79.943086,0,'2013-07-06 12:44:31',NULL,NULL),(33374,'37208','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.177224,-86.806822,0,'2013-07-06 12:44:32',NULL,NULL),(23209,'25071','S','Frame','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.455500,-81.469140,0,'2013-07-06 12:44:31',NULL,NULL),(51227,'59061','S','Nye','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.439173,-109.832978,0,'2013-07-06 12:44:33',NULL,NULL),(58070,'68057','S','Scribner','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.661517,-96.655134,0,'2013-07-06 12:44:33',NULL,NULL),(68928,'82902','P','Rock Springs','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.589546,-109.202827,0,'2013-07-06 12:44:34',NULL,NULL),(62161,'73734','S','Dover','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.979509,-97.912821,0,'2013-07-06 12:44:33',NULL,NULL),(54757,'62984','S','Shawnee','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.715092,-88.188836,0,'2013-07-06 12:44:33',NULL,NULL),(11901,'12404','S','Leibhardt','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810460,-74.249820,0,'2013-07-06 12:44:30',NULL,NULL),(16318,'17121','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.314697,-76.874265,0,'2013-07-06 12:44:31',NULL,NULL),(30845,'33635','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.029590,-82.606177,0,'2013-07-06 12:44:32',NULL,NULL),(5077,'04291','P','West Poland','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.040660,-70.444596,0,'2013-07-06 12:44:30',NULL,NULL),(28465,'31418','P','Garden Cty','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.150637,-81.194558,0,'2013-07-06 12:44:32',NULL,NULL),(31504,'34449','S','Inglis','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.200281,-82.708237,0,'2013-07-06 12:44:32',NULL,NULL),(33245,'37075','S','Hendersonville','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.316241,-86.607771,0,'2013-07-06 12:44:32',NULL,NULL),(42454,'47809','U','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.470391,-87.409294,0,'2013-07-06 12:44:32',NULL,NULL),(30161,'33170','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(67279,'80003','S','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.824737,-105.061827,0,'2013-07-06 12:44:34',NULL,NULL),(23521,'25564','S','Sod','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.265993,-81.885135,0,'2013-07-06 12:44:31',NULL,NULL),(58901,'69210','S','Ainsworth','D','Brown','31017','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.548318,-99.859190,0,'2013-07-06 12:44:33',NULL,NULL),(35716,'39669','S','Donegal','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(9614,'10032','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(10654,'11103','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.762281,-73.910107,0,'2013-07-06 12:44:30',NULL,NULL),(69622,'83870','S','Tensed','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.183819,-116.871974,0,'2013-07-06 12:44:34',NULL,NULL),(11492,'12020','S','Riley Cove','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(36933,'41164','S','Fitch','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(22102,'23418','S','Onley','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.662299,-75.687848,0,'2013-07-06 12:44:31',NULL,NULL),(43366,'48412','S','Attica','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075440,-83.171640,0,'2013-07-06 12:44:32',NULL,NULL),(46353,'53099','S','Woodland','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.366744,-88.517082,0,'2013-07-06 12:44:32',NULL,NULL),(48496,'55735','S','Finlayson','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.217584,-92.953356,0,'2013-07-06 12:44:33',NULL,NULL),(49475,'56655','S','Inguadona','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(60544,'71720','S','Bearden','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.730610,-92.636797,0,'2013-07-06 12:44:33',NULL,NULL),(62974,'75137','S','Duncanville','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.632128,-96.909950,0,'2013-07-06 12:44:33',NULL,NULL),(71365,'86547','P','Round Rock','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.513828,-109.469489,0,'2013-07-06 12:44:34',NULL,NULL),(39751,'45103','S','Stonelick','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.097260,-84.147060,0,'2013-07-06 12:44:32',NULL,NULL),(52661,'61068','S','Hillcrest','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.948220,-89.055360,0,'2013-07-06 12:44:33',NULL,NULL),(49036,'56283','S','Delhi','A','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.540219,-95.111345,0,'2013-07-06 12:44:33',NULL,NULL),(4015,'02559','S','Pocasset','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.687784,-70.615331,0,'2013-07-06 12:44:30',NULL,NULL),(16408,'17224','S','Cowans Vlg','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(44991,'50436','S','Forest City','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.264540,-93.644865,0,'2013-07-06 12:44:32',NULL,NULL),(29279,'32463','P','Wausau','D','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.629641,-85.587623,0,'2013-07-06 12:44:32',NULL,NULL),(69107,'83261','P','Paris','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.229162,-111.407694,0,'2013-07-06 12:44:34',NULL,NULL),(55405,'63645','S','Millcreek','A','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.559762,-90.292995,0,'2013-07-06 12:44:33',NULL,NULL),(229,'00627','S','Alts el Maestro','N','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(14300,'14881','S','Slaterville Springs','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.401520,-76.322280,0,'2013-07-06 12:44:31',NULL,NULL),(33378,'37211','S','Woodbine','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.075248,-86.720700,0,'2013-07-06 12:44:32',NULL,NULL),(13470,'13787','S','Belden','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.189300,-75.684780,0,'2013-07-06 12:44:31',NULL,NULL),(45628,'51631','S','Braddyville','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.610998,-94.969146,0,'2013-07-06 12:44:32',NULL,NULL),(46786,'53960','S','Rio','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.444828,-89.251186,0,'2013-07-06 12:44:32',NULL,NULL),(59951,'71301','S','Tanglewood','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(60389,'71602','S','White Hall','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.261382,-92.132192,0,'2013-07-06 12:44:33',NULL,NULL),(62839,'75010','S','Carrollton','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.027899,-96.875883,0,'2013-07-06 12:44:33',NULL,NULL),(65251,'77461','S','Needville','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.394555,-95.817313,0,'2013-07-06 12:44:34',NULL,NULL),(35762,'39740','S','Bartahatchie','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.688435,-88.329881,0,'2013-07-06 12:44:32',NULL,NULL),(56453,'65281','S','Salisbury','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.420951,-92.803243,0,'2013-07-06 12:44:33',NULL,NULL),(16502,'17262','S','Spring Run','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.150278,-77.744679,0,'2013-07-06 12:44:31',NULL,NULL),(7608,'07047','S','Woodcliff','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.793459,-74.022545,0,'2013-07-06 12:44:30',NULL,NULL),(30369,'33316','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.103966,-80.124513,0,'2013-07-06 12:44:32',NULL,NULL),(12680,'13126','S','Seneca Hill','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(29090,'32259','S','Switzerland','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(63662,'75850','S','Midway','A','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.133565,-95.909582,0,'2013-07-06 12:44:34',NULL,NULL),(75365,'93924','S','Robles del Rio','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.393660,-121.675020,0,'2013-07-06 12:44:34',NULL,NULL),(14688,'15253','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.460709,-80.020311,0,'2013-07-06 12:44:31',NULL,NULL),(4240,'02864','S','Cumberland','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.903280,-71.392380,0,'2013-07-06 12:44:30',NULL,NULL),(20743,'21401','S','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.002488,-76.510357,0,'2013-07-06 12:44:31',NULL,NULL),(41966,'47408','S','Woodbridge','A','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.217645,-86.458495,0,'2013-07-06 12:44:32',NULL,NULL),(42065,'47451','S','Oolitic','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896406,-86.528488,0,'2013-07-06 12:44:32',NULL,NULL),(51682,'59929','S','Proctor','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.926738,-114.371692,0,'2013-07-06 12:44:33',NULL,NULL),(35375,'39452','S','Lucedale','D','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(29700,'32937','S','Indn Hbr Bch','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(42539,'47865','P','Paxton','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.961776,-87.355067,0,'2013-07-06 12:44:32',NULL,NULL),(45808,'52201','S','Ainsworth','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.291753,-91.552100,0,'2013-07-06 12:44:32',NULL,NULL),(47090,'54436','S','Granton','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.569207,-90.452286,0,'2013-07-06 12:44:32',NULL,NULL),(55991,'64636','S','Coffey','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.091422,-94.050445,0,'2013-07-06 12:44:33',NULL,NULL),(66134,'78465','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.776147,-97.419137,0,'2013-07-06 12:44:34',NULL,NULL),(67272,'79995','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768254,-106.423095,0,'2013-07-06 12:44:34',NULL,NULL),(78181,'97707','S','Sunriver','A','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.843213,-121.509344,0,'2013-07-06 12:44:34',NULL,NULL),(79985,'99658','P','Saint Marys','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.268431,-163.344319,0,'2013-07-06 12:44:34',NULL,NULL),(21590,'22844','S','Alpine','N','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.648808,-78.674885,0,'2013-07-06 12:44:31',NULL,NULL),(6687,'06043','S','Bolton','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.774734,-72.438821,0,'2013-07-06 12:44:30',NULL,NULL),(69419,'83631','S','Star Ranch','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(78277,'97864','S','Monument','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.870791,-119.448452,0,'2013-07-06 12:44:34',NULL,NULL),(37629,'42154','S','Knob Lick','D','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.054794,-85.720252,0,'2013-07-06 12:44:32',NULL,NULL),(12161,'12748','S','Jeffersonvlle','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.745480,-74.746860,0,'2013-07-06 12:44:30',NULL,NULL),(35515,'39533','P','BLX','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.396332,-88.884915,0,'2013-07-06 12:44:32',NULL,NULL),(32934,'36564','P','Point Clear','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.477081,-87.920025,0,'2013-07-06 12:44:32',NULL,NULL),(31546,'34604','S','Spring Hill','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.555000,-82.388056,0,'2013-07-06 12:44:32',NULL,NULL),(7942,'07662','S','Rochelle Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.906515,-74.089155,0,'2013-07-06 12:44:30',NULL,NULL),(27312,'30022','S','Alpharetta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.029562,-84.240658,0,'2013-07-06 12:44:31',NULL,NULL),(11280,'11772','S','E Patchogue','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(43236,'48315','S','Shelby Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.665560,-82.995885,0,'2013-07-06 12:44:32',NULL,NULL),(75483,'94119','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.785934,-122.455188,0,'2013-07-06 12:44:34',NULL,NULL),(48400,'55588','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.281139,-93.806961,0,'2013-07-06 12:44:33',NULL,NULL),(38124,'43113','S','Circleville','D','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.594775,-82.936458,0,'2013-07-06 12:44:32',NULL,NULL),(43184,'48301','S','Bloomfield Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(21432,'22558','P','Stratford','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.146473,-76.842295,0,'2013-07-06 12:44:31',NULL,NULL),(64582,'76667','S','Prairie Grove','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(1572,'00767','S','Repto Horizonte','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(13247,'13642','S','Macomb','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(25959,'28657','S','Valley','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(19437,'20108','P','Manassas','D','Manassas City','51683','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.745944,-77.485770,0,'2013-07-06 12:44:31',NULL,NULL),(50994,'58652','S','Richardton','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.884107,-102.320815,0,'2013-07-06 12:44:33',NULL,NULL),(60190,'71418','S','Big Ridge','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(69689,'84028','S','Garden City','D','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.914447,-111.400556,0,'2013-07-06 12:44:34',NULL,NULL),(37976,'42728','S','Fairplay','A','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(62068,'73549','S','Headrick','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.627655,-99.139731,0,'2013-07-06 12:44:33',NULL,NULL),(20068,'20678','S','Pr Frederick','N','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.531530,-76.586745,0,'2013-07-06 12:44:31',NULL,NULL),(5136,'04414','S','Barnard Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.307433,-69.030278,0,'2013-07-06 12:44:30',NULL,NULL),(70337,'84631','S','Fillmore','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.901194,-112.632166,0,'2013-07-06 12:44:34',NULL,NULL),(41423,'46835','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.138225,-85.061298,0,'2013-07-06 12:44:32',NULL,NULL),(40582,'45873','S','Melrose','A','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.096528,-84.403657,0,'2013-07-06 12:44:32',NULL,NULL),(77405,'96784','P','Puunene','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.771617,-156.330622,0,'2013-07-06 12:44:34',NULL,NULL),(62148,'73720','S','Bison','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.191013,-97.887494,0,'2013-07-06 12:44:33',NULL,NULL),(7055,'06320','S','New London','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.351139,-72.108165,0,'2013-07-06 12:44:30',NULL,NULL),(14476,'15126','S','Imperial','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.445351,-80.240735,0,'2013-07-06 12:44:31',NULL,NULL),(11236,'11756','S','Island Trees','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.726315,-73.517312,0,'2013-07-06 12:44:30',NULL,NULL),(7648,'07075','S','Wood-Ridge','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.847097,-74.085370,0,'2013-07-06 12:44:30',NULL,NULL),(46099,'52625','S','Franklin','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.653180,-91.550700,0,'2013-07-06 12:44:32',NULL,NULL),(53943,'62418','S','Otego','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.995023,-88.952593,0,'2013-07-06 12:44:33',NULL,NULL),(68642,'81638','S','Pagoda','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.331158,-107.548854,0,'2013-07-06 12:44:34',NULL,NULL),(38944,'44124','S','Mayfield Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(7520,'07004','S','Fairfield','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.882870,-74.309056,0,'2013-07-06 12:44:30',NULL,NULL),(32805,'36441','S','Flomaton','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.040640,-87.243540,0,'2013-07-06 12:44:32',NULL,NULL),(65644,'77969','P','La Salle','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',29.014273,-96.683801,0,'2013-07-06 12:44:34',NULL,NULL),(65711,'78016','S','Devine','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.146284,-98.910239,0,'2013-07-06 12:44:34',NULL,NULL),(61929,'73154','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.521987,-97.527560,0,'2013-07-06 12:44:33',NULL,NULL),(5476,'04742','S','Ft Fairfield','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.769823,-67.829838,0,'2013-07-06 12:44:30',NULL,NULL),(18262,'19006','S','Bethayres','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.129527,-75.060892,0,'2013-07-06 12:44:31',NULL,NULL),(4364,'03062','S','Nashua','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.726609,-71.499556,0,'2013-07-06 12:44:30',NULL,NULL),(59372,'70591','S','Welsh','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.235930,-92.817753,0,'2013-07-06 12:44:33',NULL,NULL),(71163,'86039','P','Hopi Indian Reservation','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(37397,'41766','S','Thsandsticks','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.184094,-83.430195,0,'2013-07-06 12:44:32',NULL,NULL),(74176,'92274','S','Torres Martinez Indian Reser','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(3369,'01583','S','Westboylston','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.360502,-71.787608,0,'2013-07-06 12:44:30',NULL,NULL),(35258,'39350','S','Philadelphia','D','Neshoba','28099','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.773985,-89.114722,0,'2013-07-06 12:44:32',NULL,NULL),(32222,'35574','S','Kennedy','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.633424,-87.932980,0,'2013-07-06 12:44:32',NULL,NULL),(20763,'21502','S','Lavale','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.596959,-78.834511,0,'2013-07-06 12:44:31',NULL,NULL),(15294,'16134','S','Jamestown','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.497920,-80.449020,0,'2013-07-06 12:44:31',NULL,NULL),(7741,'07302','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.726243,-74.048743,0,'2013-07-06 12:44:30',NULL,NULL),(9735,'10090','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(11388,'11941','S','Eastport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.830437,-72.731567,0,'2013-07-06 12:44:30',NULL,NULL),(47387,'54634','S','Yuba','A','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.653481,-90.344014,0,'2013-07-06 12:44:32',NULL,NULL),(75234,'93647','S','East Orosi','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.548019,-119.262283,0,'2013-07-06 12:44:34',NULL,NULL),(12486,'12992','S','West Chazy','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.780960,-73.505322,0,'2013-07-06 12:44:30',NULL,NULL),(59090,'70123','S','New Orleans','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.956536,-90.207527,0,'2013-07-06 12:44:33',NULL,NULL),(3264,'01463','S','East Pepperell','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.667500,-71.599440,0,'2013-07-06 12:44:30',NULL,NULL),(39871,'45205','S','Price Hill','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.109367,-84.574394,0,'2013-07-06 12:44:32',NULL,NULL),(67834,'80809','S','Chipita Park','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.911495,-104.985682,0,'2013-07-06 12:44:34',NULL,NULL),(79349,'98631','S','Oceanside','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.348140,-124.052280,0,'2013-07-06 12:44:34',NULL,NULL),(2643,'00966','S','Bo Juan Domingo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(8732,'08514','S','Cream Ridge','D','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.164531,-74.453412,0,'2013-07-06 12:44:30',NULL,NULL),(33767,'37864','P','Pigeon Forge','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856862,-83.577319,0,'2013-07-06 12:44:32',NULL,NULL),(50084,'57461','S','Mellette','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.160243,-98.478011,0,'2013-07-06 12:44:33',NULL,NULL),(61430,'72576','S','Salem','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367489,-91.825824,0,'2013-07-06 12:44:33',NULL,NULL),(65799,'78130','S','Solms','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.719620,-98.080800,0,'2013-07-06 12:44:34',NULL,NULL),(70000,'84123','S','So Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(75217,'93635','S','Los Banos','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.052173,-120.851591,0,'2013-07-06 12:44:34',NULL,NULL),(5686,'04970','S','Sandy Rvr Plt','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(60197,'71418','S','Eastside','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(47653,'54933','P','Embarrass','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.667842,-88.705156,0,'2013-07-06 12:44:33',NULL,NULL),(28010,'30612','P','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.955626,-83.393098,0,'2013-07-06 12:44:31',NULL,NULL),(2345,'00937','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410859,-66.063834,0,'2013-07-06 12:44:30',NULL,NULL),(11093,'11694','S','Far Rockaway','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.576767,-73.844160,0,'2013-07-06 12:44:30',NULL,NULL),(72128,'88267','S','Tatum','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.249397,-103.316675,0,'2013-07-06 12:44:34',NULL,NULL),(78039,'97438','S','Fall Creek','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.957500,-122.703420,0,'2013-07-06 12:44:34',NULL,NULL),(58343,'68466','S','Wymore','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.118874,-96.667542,0,'2013-07-06 12:44:33',NULL,NULL),(22824,'24503','S','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.434734,-79.200804,0,'2013-07-06 12:44:31',NULL,NULL),(14940,'15564','S','Wellersburg','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.734737,-78.850995,0,'2013-07-06 12:44:31',NULL,NULL),(77955,'97362','S','Mount Angel','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.068098,-122.780735,0,'2013-07-06 12:44:34',NULL,NULL),(3874,'02360','S','Plymouth','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.872920,-70.641420,0,'2013-07-06 12:44:30',NULL,NULL),(5425,'04671','S','Robbinston','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.064703,-67.169070,0,'2013-07-06 12:44:30',NULL,NULL),(39264,'44450','S','N Bloomfield','A','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.460780,-80.830440,0,'2013-07-06 12:44:32',NULL,NULL),(36362,'40447','S','Mc Kee','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(32276,'35649','P','Mooresville','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.710313,-86.739400,0,'2013-07-06 12:44:32',NULL,NULL),(30087,'33156','S','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(14794,'15367','S','Venetia','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.269984,-80.060582,0,'2013-07-06 12:44:31',NULL,NULL),(41430,'46853','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.067397,-85.165583,0,'2013-07-06 12:44:32',NULL,NULL),(41817,'47336','S','Crumley Xing','N','Jay','18075','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.374187,-85.208851,0,'2013-07-06 12:44:32',NULL,NULL),(43562,'48725','S','Pt Elizabeth','A','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.947964,-83.234180,0,'2013-07-06 12:44:32',NULL,NULL),(54054,'62471','S','Hagarstown','A','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.967418,-89.105783,0,'2013-07-06 12:44:33',NULL,NULL),(69763,'84054','S','North Salt Lake','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.837299,-111.919323,0,'2013-07-06 12:44:34',NULL,NULL),(58040,'68018','S','Colon','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.301021,-96.606339,0,'2013-07-06 12:44:33',NULL,NULL),(9654,'10038','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(20979,'21801','S','Salisbury','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.362467,-75.594499,0,'2013-07-06 12:44:31',NULL,NULL),(78430,'98052','S','Avondale','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.683648,-122.121837,0,'2013-07-06 12:44:34',NULL,NULL),(45842,'52222','S','Deep River','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.597340,-92.319254,0,'2013-07-06 12:44:32',NULL,NULL),(498,'00674','S','Est Marylin','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(39549,'44840','S','Mohicanville','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.810987,-82.189201,0,'2013-07-06 12:44:32',NULL,NULL),(676,'00683','S','Urb Porta Coeli','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(34997,'39115','P','Midnight','D','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.050106,-90.572655,0,'2013-07-06 12:44:32',NULL,NULL),(12885,'13329','S','Dolgeville','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.103700,-74.740980,0,'2013-07-06 12:44:30',NULL,NULL),(4629,'03605','S','E Lempster','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.212734,-72.161103,0,'2013-07-06 12:44:30',NULL,NULL),(43375,'48420','S','Clio','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.174189,-83.719772,0,'2013-07-06 12:44:32',NULL,NULL),(45567,'51523','S','Blencoe','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.932467,-96.082692,0,'2013-07-06 12:44:32',NULL,NULL),(55998,'64642','S','Brimson','A','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.147080,-93.846120,0,'2013-07-06 12:44:33',NULL,NULL),(57622,'67134','S','Sawyer','D','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.515252,-98.626573,0,'2013-07-06 12:44:33',NULL,NULL),(58470,'68739','S','Hartington','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.620002,-97.262062,0,'2013-07-06 12:44:33',NULL,NULL),(59777,'71202','S','Richwood','A','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.481960,-92.080020,0,'2013-07-06 12:44:33',NULL,NULL),(53614,'62085','P','Sawyerville','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.075347,-89.802966,0,'2013-07-06 12:44:33',NULL,NULL),(22168,'23464','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.798333,-76.177537,0,'2013-07-06 12:44:31',NULL,NULL),(66856,'79168','U','American Quarter Horse Assoc','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.157736,-101.801454,0,'2013-07-06 12:44:34',NULL,NULL),(16183,'17067','S','Myerstown','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(54357,'62796','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797299,-89.621525,0,'2013-07-06 12:44:33',NULL,NULL),(29818,'33026','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028424,-80.296813,0,'2013-07-06 12:44:32',NULL,NULL),(24584,'27317','S','Randleman','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.841660,-79.816020,0,'2013-07-06 12:44:31',NULL,NULL),(20737,'21290','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.292820,-76.623790,0,'2013-07-06 12:44:31',NULL,NULL),(72084,'88136','S','Lon','A','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.351148,-104.598484,0,'2013-07-06 12:44:34',NULL,NULL),(39568,'44850','P','New Haven','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.034144,-82.680678,0,'2013-07-06 12:44:32',NULL,NULL),(158,'00617','S','Villa Barcelona','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(8006,'07719','S','West Belmar','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(12241,'12822','S','Palmer','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.242443,-73.838394,0,'2013-07-06 12:44:30',NULL,NULL),(25747,'28573','S','Pollocksville','D','Jones','37103','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.003901,-77.230433,0,'2013-07-06 12:44:31',NULL,NULL),(65314,'77506','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.705414,-95.201839,0,'2013-07-06 12:44:34',NULL,NULL),(74738,'93042','U','Port Hueneme','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.122182,-119.092865,0,'2013-07-06 12:44:34',NULL,NULL),(75113,'93546','S','Crowley Lake','A','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.564380,-118.744510,0,'2013-07-06 12:44:34',NULL,NULL),(30064,'33150','S','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849298,-80.205791,0,'2013-07-06 12:44:32',NULL,NULL),(26082,'28704','S','West Haven','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.473046,-82.519301,0,'2013-07-06 12:44:31',NULL,NULL),(21125,'22096','U','Sprint','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.949859,-77.344333,0,'2013-07-06 12:44:31',NULL,NULL),(79437,'98836','P','Monitor','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.493945,-120.434651,0,'2013-07-06 12:44:34',NULL,NULL),(32115,'35405','S','Skyland','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.157819,-87.517160,0,'2013-07-06 12:44:32',NULL,NULL),(31676,'34770','P','Saint Cloud','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.164897,-81.285225,0,'2013-07-06 12:44:32',NULL,NULL),(24849,'27624','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.845056,-78.634253,0,'2013-07-06 12:44:31',NULL,NULL),(51316,'59247','S','Medicine Lake','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.504952,-104.501297,0,'2013-07-06 12:44:33',NULL,NULL),(49722,'57042','S','Junius','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.008120,-97.113629,0,'2013-07-06 12:44:33',NULL,NULL),(79930,'99613','P','King Salmon','D','Bristol Bay','02060','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.709924,-156.656310,0,'2013-07-06 12:44:34',NULL,NULL),(356,'00659','S','Brisas de Hatillo','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(7444,'06851','S','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.132716,-73.402689,0,'2013-07-06 12:44:30',NULL,NULL),(37373,'41735','S','Delphia','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.022953,-83.093658,0,'2013-07-06 12:44:32',NULL,NULL),(34819,'38913','S','Banner','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.104818,-89.422186,0,'2013-07-06 12:44:32',NULL,NULL),(17196,'17821','S','Grovania','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(11722,'12180','S','Albia','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(30080,'33155','S','West Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737315,-80.309137,0,'2013-07-06 12:44:32',NULL,NULL),(22549,'24133','S','Patrick Spgs','A','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.689216,-80.149261,0,'2013-07-06 12:44:31',NULL,NULL),(27245,'29926','S','Hilton Head Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.234951,-80.735624,0,'2013-07-06 12:44:31',NULL,NULL),(43093,'48212','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.408353,-83.058329,0,'2013-07-06 12:44:32',NULL,NULL),(69797,'84066','S','Leeton','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.298824,-109.998125,0,'2013-07-06 12:44:34',NULL,NULL),(79605,'99104','S','Farmington','A','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.085311,-117.161106,0,'2013-07-06 12:44:34',NULL,NULL),(55,'00610','S','Est de Valle Verde','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(24830,'27609','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.841720,-78.632520,0,'2013-07-06 12:44:31',NULL,NULL),(41561,'47022','S','New Alsace','N','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.206304,-84.952322,0,'2013-07-06 12:44:32',NULL,NULL),(45501,'51360','S','Methodist Camp','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(51782,'60043','S','Kenilworth','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.088730,-87.714867,0,'2013-07-06 12:44:33',NULL,NULL),(48486,'55732','S','Embarrass','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.667582,-92.224878,0,'2013-07-06 12:44:33',NULL,NULL),(47571,'54843','S','N Woods Beach','A','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.018712,-91.462960,0,'2013-07-06 12:44:33',NULL,NULL),(11710,'12168','S','Stephentown Center','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.560640,-73.451700,0,'2013-07-06 12:44:30',NULL,NULL),(27119,'29741','S','Ruby','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.703963,-80.206821,0,'2013-07-06 12:44:31',NULL,NULL),(59045,'70085','S','Saint Bernard','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(50109,'57481','S','Westport','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.626880,-98.613000,0,'2013-07-06 12:44:33',NULL,NULL),(49815,'57212','S','Hetland','A','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365792,-97.151109,0,'2013-07-06 12:44:33',NULL,NULL),(46707,'53793','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.098357,-89.325603,0,'2013-07-06 12:44:32',NULL,NULL),(45603,'51558','S','Moorhead','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.928152,-95.852604,0,'2013-07-06 12:44:32',NULL,NULL),(26240,'28815','P','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.575619,-82.545629,0,'2013-07-06 12:44:31',NULL,NULL),(39771,'45121','S','Browntown','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(7220,'06501','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310083,-72.926314,0,'2013-07-06 12:44:30',NULL,NULL),(45450,'51237','S','George','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.346352,-96.004770,0,'2013-07-06 12:44:32',NULL,NULL),(9950,'10156','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(18891,'19468','S','Royersford','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.196820,-75.539280,0,'2013-07-06 12:44:31',NULL,NULL),(21534,'22730','S','Oakpark','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.376926,-78.124661,0,'2013-07-06 12:44:31',NULL,NULL),(41930,'47385','S','Spiceland','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.837003,-85.438958,0,'2013-07-06 12:44:32',NULL,NULL),(41572,'47032','S','Moores Hill','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.077097,-85.051934,0,'2013-07-06 12:44:32',NULL,NULL),(34033,'38133','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.206829,-89.791238,0,'2013-07-06 12:44:32',NULL,NULL),(31761,'34997','S','Stuart','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.138891,-80.214592,0,'2013-07-06 12:44:32',NULL,NULL),(70929,'85634','S','Vamori','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(77893,'97291','P','Cedar Mill','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.547380,-122.726171,0,'2013-07-06 12:44:34',NULL,NULL),(78376,'98022','S','Wabash','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(46683,'53778','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.096424,-89.322479,0,'2013-07-06 12:44:32',NULL,NULL),(80007,'99674','P','Chickaloon','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.796667,-148.462778,0,'2013-07-06 12:44:34',NULL,NULL),(76235,'95387','P','Westley','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.567797,-121.211323,0,'2013-07-06 12:44:34',NULL,NULL),(69255,'83425','S','Hamer','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.906168,-112.144117,0,'2013-07-06 12:44:34',NULL,NULL),(60718,'71953','S','Mountain Fork','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(53677,'62220','S','Belleville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.525719,-89.991068,0,'2013-07-06 12:44:33',NULL,NULL),(10194,'10304','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.603229,-74.090210,0,'2013-07-06 12:44:30',NULL,NULL),(4469,'03261','S','Northwood','D','Rockingham','33015','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.194231,-71.188653,0,'2013-07-06 12:44:30',NULL,NULL),(1090,'00725','S','Urb Condado Viejo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(36806,'41056','S','Maysville','D','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(79755,'99260','U','Public Safety Bldg','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.663463,-117.422938,0,'2013-07-06 12:44:34',NULL,NULL),(6204,'05485','P','Sheldon Springs','D','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.910556,-72.907500,0,'2013-07-06 12:44:30',NULL,NULL),(16232,'17075','P','Newton Hamilton','D','Mifflin','42087','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.393403,-77.835133,0,'2013-07-06 12:44:31',NULL,NULL),(45185,'50613','S','Brookside','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(10843,'11405','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699453,-73.788562,0,'2013-07-06 12:44:30',NULL,NULL),(4425,'03234','S','Epsom','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.214669,-71.353386,0,'2013-07-06 12:44:30',NULL,NULL),(21058,'21914','P','Charlestown','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.574153,-75.980992,0,'2013-07-06 12:44:31',NULL,NULL),(12043,'12525','S','Gardiner','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.662675,-74.149433,0,'2013-07-06 12:44:30',NULL,NULL),(37726,'42276','S','Gordonsville','N','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.830940,-86.917020,0,'2013-07-06 12:44:32',NULL,NULL),(79433,'98832','S','Marlin','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.461144,-118.922067,0,'2013-07-06 12:44:34',NULL,NULL),(73260,'90716','S','Hawaiian Gardens','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.853611,-118.133056,0,'2013-07-06 12:44:34',NULL,NULL),(56438,'65270','S','Urbandale','N','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.418214,-92.439228,0,'2013-07-06 12:44:33',NULL,NULL),(50905,'58552','S','Linton','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.288980,-100.223580,0,'2013-07-06 12:44:33',NULL,NULL),(41715,'47240','S','Enochsburg','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(30302,'33296','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656259,-80.357036,0,'2013-07-06 12:44:32',NULL,NULL),(10875,'11419','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.688921,-73.823304,0,'2013-07-06 12:44:30',NULL,NULL),(30662,'33463','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.593980,-80.127720,0,'2013-07-06 12:44:32',NULL,NULL),(55925,'64465','S','Lathrop','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.543217,-94.300166,0,'2013-07-06 12:44:33',NULL,NULL),(68496,'81301','S','Tamarron','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.326840,-107.831460,0,'2013-07-06 12:44:34',NULL,NULL),(69780,'84059','P','Orem','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.319582,-111.722564,0,'2013-07-06 12:44:34',NULL,NULL),(51307,'59231','P','Glasgow','A','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.402929,-106.543693,0,'2013-07-06 12:44:33',NULL,NULL),(50546,'58201','S','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.912435,-97.052752,0,'2013-07-06 12:44:33',NULL,NULL),(41078,'46528','S','Goshen','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.599107,-85.787614,0,'2013-07-06 12:44:32',NULL,NULL),(73201,'90601','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',34.005998,-118.032175,0,'2013-07-06 12:44:34',NULL,NULL),(55354,'63559','S','Stahl','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(78664,'98233','S','Alger','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.503280,-122.360460,0,'2013-07-06 12:44:34',NULL,NULL),(68998,'83201','S','Tyhee','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.882088,-112.423285,0,'2013-07-06 12:44:34',NULL,NULL),(62619,'74540','S','Daisy','D','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.548938,-95.733571,0,'2013-07-06 12:44:33',NULL,NULL),(55524,'63822','S','Bernie','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.668746,-89.969821,0,'2013-07-06 12:44:33',NULL,NULL),(55416,'63654','S','Lesterville','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.481049,-90.833927,0,'2013-07-06 12:44:33',NULL,NULL),(50802,'58448','S','Walum','A','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.269722,-98.194167,0,'2013-07-06 12:44:33',NULL,NULL),(46084,'52594','S','Unionville','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.853185,-92.696609,0,'2013-07-06 12:44:32',NULL,NULL),(45234,'50648','S','Littleton','N','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.458700,-92.063160,0,'2013-07-06 12:44:32',NULL,NULL),(11721,'12177','P','Tribes Hill','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.953630,-74.291341,0,'2013-07-06 12:44:30',NULL,NULL),(5816,'05071','S','South Woodstock','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.555829,-72.534771,0,'2013-07-06 12:44:30',NULL,NULL),(37164,'41472','S','Elamton','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(545,'00676','S','Villa Mercedes','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(1625,'00771','S','Las Piedras','D','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(54147,'62567','S','Stonington','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.637026,-89.188520,0,'2013-07-06 12:44:33',NULL,NULL),(11010,'11557','S','Hewlett Bay','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.638779,-73.693176,0,'2013-07-06 12:44:30',NULL,NULL),(10551,'11001','S','Bellrose Village','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(20579,'21155','S','Fowbelsburg','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.565851,-76.800573,0,'2013-07-06 12:44:31',NULL,NULL),(42195,'47549','U','Jasper','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.392247,-86.955378,0,'2013-07-06 12:44:32',NULL,NULL),(69155,'83316','S','Deep Creek','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.604315,-114.762452,0,'2013-07-06 12:44:34',NULL,NULL),(78040,'97438','S','Jasper','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.957500,-122.703420,0,'2013-07-06 12:44:34',NULL,NULL),(20921,'21740','S','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.643547,-77.718382,0,'2013-07-06 12:44:31',NULL,NULL),(21939,'23231','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(71995,'88033','P','Fairacres','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.310850,-107.036454,0,'2013-07-06 12:44:34',NULL,NULL),(46255,'53011','S','Cascade','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.659276,-88.033207,0,'2013-07-06 12:44:32',NULL,NULL),(74883,'93279','P','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.329207,-119.291014,0,'2013-07-06 12:44:34',NULL,NULL),(74774,'93109','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.402587,-119.718355,0,'2013-07-06 12:44:34',NULL,NULL),(65553,'77838','P','Chriesman','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.600084,-96.772451,0,'2013-07-06 12:44:34',NULL,NULL),(61496,'72645','S','Chimes','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.826780,-92.575020,0,'2013-07-06 12:44:33',NULL,NULL),(56072,'64752','S','Stotesbury','A','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.090159,-94.586446,0,'2013-07-06 12:44:33',NULL,NULL),(14083,'14614','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.155018,-77.609665,0,'2013-07-06 12:44:31',NULL,NULL),(30525,'33406','S','Palm Springs','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(34394,'38621','S','Askew','A','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.504355,-90.192058,0,'2013-07-06 12:44:32',NULL,NULL),(3854,'02349','U','Middleboro','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.870977,-70.908380,0,'2013-07-06 12:44:30',NULL,NULL),(39246,'44436','S','Coitsville','N','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.051961,-80.544699,0,'2013-07-06 12:44:32',NULL,NULL),(17761,'18328','S','Lakeview Twp','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.227695,-74.945839,0,'2013-07-06 12:44:31',NULL,NULL),(30076,'33154','S','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(61671,'72923','S','Barling','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.329328,-94.306177,0,'2013-07-06 12:44:33',NULL,NULL),(12304,'12853','S','Igerna','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.721592,-73.920875,0,'2013-07-06 12:44:30',NULL,NULL),(18063,'18703','P','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.243136,-75.885306,0,'2013-07-06 12:44:31',NULL,NULL),(24749,'27531','S','Seymour Johnson AFB','A','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.380000,-77.990000,0,'2013-07-06 12:44:31',NULL,NULL),(67235,'79932','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.865419,-106.595931,0,'2013-07-06 12:44:34',NULL,NULL),(63626,'75835','S','Cut','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(53394,'61818','S','Cerro Gordo','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.890715,-88.732130,0,'2013-07-06 12:44:33',NULL,NULL),(49320,'56549','S','Dale','N','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.740000,-96.237778,0,'2013-07-06 12:44:33',NULL,NULL),(48081,'55331','S','Shorewood','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(20222,'20773','P','Upper Marlboro','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.814554,-76.754248,0,'2013-07-06 12:44:31',NULL,NULL),(9311,'09723','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(984,'00716','S','Villa Pampanos','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(3869,'02358','P','N Pembroke','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.094410,-70.787885,0,'2013-07-06 12:44:30',NULL,NULL),(70199,'84339','S','Young Ward','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.645040,-111.918060,0,'2013-07-06 12:44:34',NULL,NULL),(19083,'19567','S','Host','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386594,-76.216795,0,'2013-07-06 12:44:31',NULL,NULL),(2326,'00934','S','Fort Buchanan','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413161,-66.131635,0,'2013-07-06 12:44:30',NULL,NULL),(61942,'73160','S','Oklahoma City','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.381160,-97.475880,0,'2013-07-06 12:44:33',NULL,NULL),(54461,'62854','S','Kinmundy','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770470,-88.849169,0,'2013-07-06 12:44:33',NULL,NULL),(75959,'95045','S','San Juan Bautista','D','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.853236,-121.536794,0,'2013-07-06 12:44:34',NULL,NULL),(28,'00603','S','Urb Borinquen','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(41310,'46772','S','Monroe','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.740508,-84.944366,0,'2013-07-06 12:44:32',NULL,NULL),(19864,'20524','U','Passport Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902472,-77.031794,0,'2013-07-06 12:44:31',NULL,NULL),(16578,'17320','S','Charnita','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.755100,-77.376290,0,'2013-07-06 12:44:31',NULL,NULL),(609,'00680','S','Villa Gerena','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(27082,'29706','S','Chester','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.711411,-81.207675,0,'2013-07-06 12:44:31',NULL,NULL),(26384,'29101','S','Robinson','N','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.489200,-80.248200,0,'2013-07-06 12:44:31',NULL,NULL),(26045,'28684','S','Woodford','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.311400,-81.579000,0,'2013-07-06 12:44:31',NULL,NULL),(25528,'28396','S','Wagram','D','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.909224,-79.383666,0,'2013-07-06 12:44:31',NULL,NULL),(24179,'26624','S','Chapel','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.686020,-80.772214,0,'2013-07-06 12:44:31',NULL,NULL),(44238,'49660','S','Manistee','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.176440,-86.209560,0,'2013-07-06 12:44:32',NULL,NULL),(46969,'54209','S','Egg Harbor','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.017597,-87.282895,0,'2013-07-06 12:44:32',NULL,NULL),(47080,'54433','S','Donald','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.214708,-90.818461,0,'2013-07-06 12:44:32',NULL,NULL),(57061,'66213','S','Lenexa','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(65821,'78148','S','Live Oak','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.551704,-98.302464,0,'2013-07-06 12:44:34',NULL,NULL),(71336,'86508','P','Lupton','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.350000,-109.050000,0,'2013-07-06 12:44:34',NULL,NULL),(72024,'88048','S','Mesquite','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.103494,-106.651884,0,'2013-07-06 12:44:34',NULL,NULL),(74009,'92116','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.760043,-117.120973,0,'2013-07-06 12:44:34',NULL,NULL),(74292,'92366','S','Mountain Pass','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.472787,-115.527445,0,'2013-07-06 12:44:34',NULL,NULL),(6462,'05761','S','N Pawlet','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(62882,'75050','S','Grand Prairie','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768436,-97.002967,0,'2013-07-06 12:44:33',NULL,NULL),(28566,'31601','S','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.825593,-83.284447,0,'2013-07-06 12:44:32',NULL,NULL),(61579,'72741','P','Johnson','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.129144,-94.164122,0,'2013-07-06 12:44:33',NULL,NULL),(46549,'53407','U','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.726079,-87.783375,0,'2013-07-06 12:44:32',NULL,NULL),(47941,'55115','S','White Bear Lake','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(67911,'80904','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855129,-104.865127,0,'2013-07-06 12:44:34',NULL,NULL),(40672,'46056','S','Markleville','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.982476,-85.614191,0,'2013-07-06 12:44:32',NULL,NULL),(30816,'33618','S','Carrollwood','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.077694,-82.499088,0,'2013-07-06 12:44:32',NULL,NULL),(70009,'84125','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701548,-111.945910,0,'2013-07-06 12:44:34',NULL,NULL),(72694,'89447','S','Pizen Switch','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.921460,-119.117640,0,'2013-07-06 12:44:34',NULL,NULL),(8989,'08835','S','Manville','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.536675,-74.592514,0,'2013-07-06 12:44:30',NULL,NULL),(43975,'49325','S','Freeport','D','Barry','26015','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',42.748202,-85.308202,0,'2013-07-06 12:44:32',NULL,NULL),(61243,'72342','S','Helena','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.533018,-90.601243,0,'2013-07-06 12:44:33',NULL,NULL),(40267,'45433','S','Dayton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(57528,'67008','S','Atlanta','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.430972,-96.768361,0,'2013-07-06 12:44:33',NULL,NULL),(55235,'63438','S','Durham','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.956865,-91.675935,0,'2013-07-06 12:44:33',NULL,NULL),(49428,'56633','S','Farden','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(6112,'05457','S','E Franklin','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(9442,'10005','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(43653,'48846','S','Ionia','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',42.985392,-85.064142,0,'2013-07-06 12:44:32',NULL,NULL),(21391,'22504','S','Butylo','N','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.770833,-76.688333,0,'2013-07-06 12:44:31',NULL,NULL),(21871,'23156','S','Shacklefords','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.576680,-76.729380,0,'2013-07-06 12:44:31',NULL,NULL),(74613,'92728','P','Fountain Vly','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.713991,-117.928354,0,'2013-07-06 12:44:34',NULL,NULL),(60126,'71371','S','Searcy','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(26972,'29613','U','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.949211,-82.438690,0,'2013-07-06 12:44:31',NULL,NULL),(24373,'27055','S','Branon','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(10851,'11413','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(12869,'13324','S','Morehouse','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(79837,'99523','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.170998,-149.838325,0,'2013-07-06 12:44:34',NULL,NULL),(65216,'77440','P','Elmaton','D','Matagorda','48321','Texas','TX','48','0000','361','Central',-6.0,'Y',28.831003,-96.120733,0,'2013-07-06 12:44:34',NULL,NULL),(20223,'20773','P','Uppr Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.814554,-76.754248,0,'2013-07-06 12:44:31',NULL,NULL),(27341,'30043','S','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.009393,-84.001553,0,'2013-07-06 12:44:31',NULL,NULL),(22535,'24115','P','Martinsville','D','Martinsville City','51690','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.687968,-79.858657,0,'2013-07-06 12:44:31',NULL,NULL),(21992,'23273','U','County of Henrico','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.587216,-77.495005,0,'2013-07-06 12:44:31',NULL,NULL),(11704,'12166','S','Lykers','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.849600,-74.476380,0,'2013-07-06 12:44:30',NULL,NULL),(51101,'58778','S','Ruso','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.759221,-100.844798,0,'2013-07-06 12:44:33',NULL,NULL),(40378,'45653','S','Minford','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.888850,-82.831125,0,'2013-07-06 12:44:32',NULL,NULL),(70897,'85618','S','Mammoth','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.706378,-110.655407,0,'2013-07-06 12:44:34',NULL,NULL),(74246,'92329','P','Phelan','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.355142,-117.607156,0,'2013-07-06 12:44:34',NULL,NULL),(51293,'59215','S','Circle','D','McCone','30055','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.428645,-105.619788,0,'2013-07-06 12:44:33',NULL,NULL),(48909,'56132','S','Garvin','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.216569,-95.757821,0,'2013-07-06 12:44:33',NULL,NULL),(8053,'07738','S','Lincroft','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.337902,-74.126907,0,'2013-07-06 12:44:30',NULL,NULL),(19693,'20374','S','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.828906,-77.015495,0,'2013-07-06 12:44:31',NULL,NULL),(35925,'40036','S','Lockport','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.417408,-84.961804,0,'2013-07-06 12:44:32',NULL,NULL),(28691,'31807','S','Ellerslie','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.633465,-84.791841,0,'2013-07-06 12:44:32',NULL,NULL),(53096,'61532','S','Bishop','N','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.225226,-90.006004,0,'2013-07-06 12:44:33',NULL,NULL),(60639,'71901','S','Red Oak','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(63987,'76109','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.701611,-97.382250,0,'2013-07-06 12:44:34',NULL,NULL),(70963,'85648','S','Rio Rico','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.486260,-111.003000,0,'2013-07-06 12:44:34',NULL,NULL),(78363,'98019','S','Duvall','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.737750,-121.848365,0,'2013-07-06 12:44:34',NULL,NULL),(39106,'44241','S','Streetsboro','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.248684,-81.345809,0,'2013-07-06 12:44:32',NULL,NULL),(62890,'75058','S','Gunter','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.448112,-96.747724,0,'2013-07-06 12:44:33',NULL,NULL),(17286,'17847','S','E Lewisburg','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.014839,-76.846934,0,'2013-07-06 12:44:31',NULL,NULL),(41690,'47201','S','Columbus','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.199917,-85.934788,0,'2013-07-06 12:44:32',NULL,NULL),(59166,'70341','S','Belle Rose','D','Assumption','22007','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.041700,-91.067400,0,'2013-07-06 12:44:33',NULL,NULL),(34419,'38635','S','Mount Pleasant','A','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.772162,-89.450965,0,'2013-07-06 12:44:32',NULL,NULL),(66009,'78352','P','Edroy','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.956153,-97.579874,0,'2013-07-06 12:44:34',NULL,NULL),(8767,'08542','S','Princeton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.350373,-74.660999,0,'2013-07-06 12:44:30',NULL,NULL),(7765,'07407','S','Elmwood Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.905895,-74.121413,0,'2013-07-06 12:44:30',NULL,NULL),(39217,'44410','S','Bazetta','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.331036,-80.729796,0,'2013-07-06 12:44:32',NULL,NULL),(30375,'33318','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118323,-80.251273,0,'2013-07-06 12:44:32',NULL,NULL),(44168,'49546','S','East Grand Rapids','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(5013,'04228','S','E Livermore','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.400255,-70.128240,0,'2013-07-06 12:44:30',NULL,NULL),(41470,'46921','P','Deedsville','D','Miami','18103','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.910115,-86.101803,0,'2013-07-06 12:44:32',NULL,NULL),(30406,'33324','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110295,-80.270027,0,'2013-07-06 12:44:32',NULL,NULL),(39815,'45144','S','Adams County','A','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.702000,-83.612593,0,'2013-07-06 12:44:32',NULL,NULL),(68211,'81046','P','Hoehne','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.169175,-104.502607,0,'2013-07-06 12:44:34',NULL,NULL),(76909,'95988','S','Willows','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.524044,-122.199369,0,'2013-07-06 12:44:34',NULL,NULL),(1450,'00741','S','Urb Verdemar','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.168687,-65.747221,0,'2013-07-06 12:44:30',NULL,NULL),(20757,'21411','U','Comptroller of the Treasury','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.971614,-76.499864,0,'2013-07-06 12:44:31',NULL,NULL),(18035,'18655','S','Mocanaqua','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.171280,-76.140000,0,'2013-07-06 12:44:31',NULL,NULL),(6239,'05491','S','Vergennes','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(10101,'10249','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(30309,'33303','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.198883,-80.095109,0,'2013-07-06 12:44:32',NULL,NULL),(30114,'33161','S','Barry University','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(29747,'32970','P','Wabasso','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.751915,-80.447757,0,'2013-07-06 12:44:32',NULL,NULL),(25132,'28010','P','Barium Spngs','A','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.720008,-80.898107,0,'2013-07-06 12:44:31',NULL,NULL),(10732,'11354','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770167,-73.825967,0,'2013-07-06 12:44:30',NULL,NULL),(46691,'53784','U','Electronic Data Systems','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.040958,-89.394588,0,'2013-07-06 12:44:32',NULL,NULL),(50578,'58228','S','Emerado','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.919406,-97.369328,0,'2013-07-06 12:44:33',NULL,NULL),(62174,'73749','S','Jet','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.670491,-98.179568,0,'2013-07-06 12:44:33',NULL,NULL),(74604,'92706','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.769052,-117.885536,0,'2013-07-06 12:44:34',NULL,NULL),(18653,'19173','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954726,-75.169864,0,'2013-07-06 12:44:31',NULL,NULL),(72924,'90029','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.090213,-118.293835,0,'2013-07-06 12:44:34',NULL,NULL),(33976,'38111','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.112624,-89.946832,0,'2013-07-06 12:44:32',NULL,NULL),(58749,'68956','S','Wanda','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.625091,-98.657971,0,'2013-07-06 12:44:33',NULL,NULL),(43646,'48840','S','Haslett','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.751765,-84.395613,0,'2013-07-06 12:44:32',NULL,NULL),(31172,'33918','P','North Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(4454,'03253','S','Meredith','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.600423,-71.485652,0,'2013-07-06 12:44:30',NULL,NULL),(21928,'23226','S','Richmond','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.579818,-77.521626,0,'2013-07-06 12:44:31',NULL,NULL),(27683,'30334','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.727528,-84.412803,0,'2013-07-06 12:44:31',NULL,NULL),(44862,'50301','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.603794,-93.631657,0,'2013-07-06 12:44:32',NULL,NULL),(47877,'55088','S','Webster','D','Rice','27131','Minnesota','MN','27','0000','952','Central',-6.0,'Y',44.518717,-93.365425,0,'2013-07-06 12:44:33',NULL,NULL),(49041,'56287','S','Seaforth','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.485083,-95.311940,0,'2013-07-06 12:44:33',NULL,NULL),(58184,'68310','S','Glenover','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(76050,'95190','U','San Jose Mercury NewS','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.376143,-121.902320,0,'2013-07-06 12:44:34',NULL,NULL),(41698,'47225','P','Clarksburg','D','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.432445,-85.355350,0,'2013-07-06 12:44:32',NULL,NULL),(53656,'62206','S','Cahokia','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.561749,-90.161656,0,'2013-07-06 12:44:33',NULL,NULL),(66747,'79003','P','Allison','D','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.544911,-100.145217,0,'2013-07-06 12:44:34',NULL,NULL),(49721,'57041','P','Lyons','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.786932,-96.929752,0,'2013-07-06 12:44:33',NULL,NULL),(38709,'44005','P','Ashtabula','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.876001,-80.800053,0,'2013-07-06 12:44:32',NULL,NULL),(13486,'13797','S','Lisle','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.334546,-76.047179,0,'2013-07-06 12:44:31',NULL,NULL),(31369,'34209','S','Palma Sola','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.508354,-82.646654,0,'2013-07-06 12:44:32',NULL,NULL),(41504,'46962','S','N Manchester','A','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.003793,-85.773443,0,'2013-07-06 12:44:32',NULL,NULL),(40920,'46275','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.767780,-86.157755,0,'2013-07-06 12:44:32',NULL,NULL),(9651,'10038','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(13058,'13440','S','Stanwix','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(50433,'57794','S','Wounded Knee','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.160272,-102.359904,0,'2013-07-06 12:44:33',NULL,NULL),(51056,'58741','S','Simcoe','N','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.255272,-100.782829,0,'2013-07-06 12:44:33',NULL,NULL),(54618,'62915','P','Cambria','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.781551,-89.119596,0,'2013-07-06 12:44:33',NULL,NULL),(65959,'78278','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.562987,-98.562275,0,'2013-07-06 12:44:34',NULL,NULL),(63145,'75373','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.783840,-96.829120,0,'2013-07-06 12:44:33',NULL,NULL),(60233,'71430','S','Camp Claiborne','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(34920,'38963','S','Tutwiler','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014758,-90.431889,0,'2013-07-06 12:44:32',NULL,NULL),(75148,'93561','S','Sand Canyon','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(39903,'45215','S','Wyoming','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(72433,'89081','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.257700,-115.142400,0,'2013-07-06 12:44:34',NULL,NULL),(14346,'15010','S','Racine','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.763952,-80.341536,0,'2013-07-06 12:44:31',NULL,NULL),(30187,'33177','S','Quail Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.592736,-80.405844,0,'2013-07-06 12:44:32',NULL,NULL),(28168,'30914','P','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.467027,-82.017430,0,'2013-07-06 12:44:31',NULL,NULL),(25167,'28039','P','East Spencer','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.678327,-80.433160,0,'2013-07-06 12:44:31',NULL,NULL),(46784,'53958','U','Reedsburg','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.532160,-90.001703,0,'2013-07-06 12:44:32',NULL,NULL),(48278,'55432','S','Fridley','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.098640,-93.254963,0,'2013-07-06 12:44:33',NULL,NULL),(55897,'64434','S','Cncpton Jctn','A','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.276364,-94.718527,0,'2013-07-06 12:44:33',NULL,NULL),(68033,'80928','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.588656,-104.442148,0,'2013-07-06 12:44:34',NULL,NULL),(73991,'92096','U','San Marcos','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.133957,-117.175047,0,'2013-07-06 12:44:34',NULL,NULL),(75979,'95066','S','Santa Cruz','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.071000,-122.010600,0,'2013-07-06 12:44:34',NULL,NULL),(224,'00624','S','Urb Rio Sol','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(18250,'19001','S','Ogontz Campus','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.123936,-75.131093,0,'2013-07-06 12:44:31',NULL,NULL),(25344,'28221','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.368572,-80.760130,0,'2013-07-06 12:44:31',NULL,NULL),(68585,'81522','S','Gateway','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',38.788558,-108.746500,0,'2013-07-06 12:44:34',NULL,NULL),(69769,'84057','S','Bonnie','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.315140,-111.695870,0,'2013-07-06 12:44:34',NULL,NULL),(74189,'92278','S','Twentynine Palms','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.273320,-116.102460,0,'2013-07-06 12:44:34',NULL,NULL),(75209,'93633','P','KCNP','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(78929,'98366','S','Overlook','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(28742,'31993','U','Columbus Brm','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.481702,-84.976028,0,'2013-07-06 12:44:32',NULL,NULL),(43090,'48210','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.336104,-83.126056,0,'2013-07-06 12:44:32',NULL,NULL),(3508,'01864','S','North Reading','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.578246,-71.093981,0,'2013-07-06 12:44:30',NULL,NULL),(41878,'47367','P','Oakville','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.079318,-85.389412,0,'2013-07-06 12:44:32',NULL,NULL),(41545,'47006','S','West Brook Acres','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.328406,-85.199126,0,'2013-07-06 12:44:32',NULL,NULL),(39907,'45216','S','Elmwood Place','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(45473,'51331','S','Arnolds Park','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.364605,-95.133522,0,'2013-07-06 12:44:32',NULL,NULL),(53321,'61744','S','Gridley','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.742252,-88.880157,0,'2013-07-06 12:44:33',NULL,NULL),(53470,'61931','S','Humboldt','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.603165,-88.319354,0,'2013-07-06 12:44:33',NULL,NULL),(61760,'73052','S','Erin Springs','A','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.840396,-97.607974,0,'2013-07-06 12:44:33',NULL,NULL),(12280,'12841','P','Huletts Landing','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.640008,-73.506355,0,'2013-07-06 12:44:30',NULL,NULL),(26210,'28783','S','Tuckasegee','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.249037,-83.118647,0,'2013-07-06 12:44:31',NULL,NULL),(68191,'81030','P','Cheraw','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.108149,-103.506915,0,'2013-07-06 12:44:34',NULL,NULL),(38960,'44127','S','Newburgh Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472030,-81.650481,0,'2013-07-06 12:44:32',NULL,NULL),(1429,'00739','S','Jard Treasure Island','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(46872,'54103','S','Armstrong Creek','D','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.667445,-88.447142,0,'2013-07-06 12:44:32',NULL,NULL),(46586,'53540','P','Gotham','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.222224,-90.292434,0,'2013-07-06 12:44:32',NULL,NULL),(22619,'24224','S','Dickensonville','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.880080,-82.279800,0,'2013-07-06 12:44:31',NULL,NULL),(745,'00692','S','Bo Brenas','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(39684,'45018','P','Hamilton','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.430238,-84.492982,0,'2013-07-06 12:44:32',NULL,NULL),(15937,'17022','S','Aberdeen','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(37305,'41636','S','Price','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.390254,-82.729050,0,'2013-07-06 12:44:32',NULL,NULL),(22872,'24565','S','Java','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.864910,-79.186583,0,'2013-07-06 12:44:31',NULL,NULL),(28307,'31126','P','Lenox Sq Finance','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.847924,-84.359054,0,'2013-07-06 12:44:31',NULL,NULL),(28527,'31549','S','Lumber City','D','Telfair','13271','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.911153,-82.774223,0,'2013-07-06 12:44:32',NULL,NULL),(28721,'31904','S','Beallwood','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.520024,-84.981542,0,'2013-07-06 12:44:32',NULL,NULL),(44162,'49534','S','Walker','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.976900,-85.768900,0,'2013-07-06 12:44:32',NULL,NULL),(53012,'61459','S','New Philadelphia','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.496541,-90.393466,0,'2013-07-06 12:44:33',NULL,NULL),(54816,'63021','S','Winchester','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(55128,'63344','S','Prairieville','N','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.252646,-91.006354,0,'2013-07-06 12:44:33',NULL,NULL),(60750,'71972','S','Vandervoort','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.375951,-94.357777,0,'2013-07-06 12:44:33',NULL,NULL),(65395,'77555','U','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.311767,-94.782331,0,'2013-07-06 12:44:34',NULL,NULL),(76922,'96009','P','Bieber','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',41.121327,-121.137406,0,'2013-07-06 12:44:34',NULL,NULL),(78083,'97473','S','Murphys Camp','N','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.664497,-123.792640,0,'2013-07-06 12:44:34',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (16259,'17086','S','Richfield','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.698624,-77.126607,0,'2013-07-06 12:44:31',NULL,NULL),(37704,'42261','S','Huntsville','A','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(32831,'36470','P','Perdue Hill','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.525703,-87.324291,0,'2013-07-06 12:44:32',NULL,NULL),(76318,'95454','S','Laytonville Rancheria','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.731538,-123.505679,0,'2013-07-06 12:44:34',NULL,NULL),(37206,'41522','S','Praise','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(17876,'18440','P','La Plume','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.558059,-75.753488,0,'2013-07-06 12:44:31',NULL,NULL),(71766,'87552','S','Pine','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(3470,'01815','U','Bank of America','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.505881,-71.127147,0,'2013-07-06 12:44:30',NULL,NULL),(7748,'07307','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.747679,-74.049894,0,'2013-07-06 12:44:30',NULL,NULL),(2028,'00917','S','Sect El Relincho','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(14616,'15228','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.375682,-80.040038,0,'2013-07-06 12:44:31',NULL,NULL),(29779,'33015','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940770,-80.315677,0,'2013-07-06 12:44:32',NULL,NULL),(33820,'37922','S','Concord Farr','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856420,-84.128340,0,'2013-07-06 12:44:32',NULL,NULL),(45302,'50835','S','Benton','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.728444,-94.396830,0,'2013-07-06 12:44:32',NULL,NULL),(46536,'53403','S','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.704176,-87.806580,0,'2013-07-06 12:44:32',NULL,NULL),(47637,'54919','U','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.268304,-88.396324,0,'2013-07-06 12:44:33',NULL,NULL),(75289,'93723','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.797657,-119.881938,0,'2013-07-06 12:44:34',NULL,NULL),(39349,'44625','S','East Rochester','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.771834,-80.996741,0,'2013-07-06 12:44:32',NULL,NULL),(56136,'64836','S','Scotland','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(15629,'16701','S','Bradford','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.953308,-78.645295,0,'2013-07-06 12:44:31',NULL,NULL),(27540,'30233','S','Jackson','D','Butts','13035','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.294108,-83.965048,0,'2013-07-06 12:44:31',NULL,NULL),(21393,'22507','P','Lively','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.775853,-76.514865,0,'2013-07-06 12:44:31',NULL,NULL),(66870,'79220','S','Afton','D','Dickens','48125','Texas','TX','48','0000','806','Central',-6.0,'Y',33.786080,-100.734282,0,'2013-07-06 12:44:34',NULL,NULL),(71844,'87583','P','Cerritos','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.232598,-105.520380,0,'2013-07-06 12:44:34',NULL,NULL),(8217,'07960','S','Morristown','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.793680,-74.491343,0,'2013-07-06 12:44:30',NULL,NULL),(43665,'48857','S','Morrice','D','Shiawassee','26155','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.844130,-84.160156,0,'2013-07-06 12:44:32',NULL,NULL),(6243,'05492','S','Belvidere Center','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.717268,-72.755250,0,'2013-07-06 12:44:30',NULL,NULL),(42199,'47550','S','Kennedy','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.052420,-86.966520,0,'2013-07-06 12:44:32',NULL,NULL),(22914,'24608','P','Burkes Garden','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.116004,-81.525343,0,'2013-07-06 12:44:31',NULL,NULL),(24329,'27025','S','Ellisboro','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.385863,-79.967595,0,'2013-07-06 12:44:31',NULL,NULL),(31145,'33910','P','Cape Coral South','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.551448,-82.020111,0,'2013-07-06 12:44:32',NULL,NULL),(76656,'95735','S','Twin Bridges','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.810318,-120.126317,0,'2013-07-06 12:44:34',NULL,NULL),(12487,'12993','S','Wadhams','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.229722,-73.460833,0,'2013-07-06 12:44:30',NULL,NULL),(7912,'07627','S','Demarest','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.951934,-73.959887,0,'2013-07-06 12:44:30',NULL,NULL),(32876,'36525','S','Creola','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.889269,-88.026134,0,'2013-07-06 12:44:32',NULL,NULL),(29428,'32669','S','Newberry','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.647073,-82.599723,0,'2013-07-06 12:44:32',NULL,NULL),(20912,'21722','S','Big Spring','A','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.664980,-77.909160,0,'2013-07-06 12:44:31',NULL,NULL),(2526,'00957','S','Urb Santa Monica','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(62879,'75048','S','Garland','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.968200,-96.583260,0,'2013-07-06 12:44:33',NULL,NULL),(64179,'76230','S','Newport','N','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.561402,-97.838818,0,'2013-07-06 12:44:34',NULL,NULL),(75813,'94806','S','San Pablo','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972918,-122.333929,0,'2013-07-06 12:44:34',NULL,NULL),(79268,'98570','S','Alpha','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.581895,-122.686352,0,'2013-07-06 12:44:34',NULL,NULL),(59207,'70392','S','Calumet','N','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.698890,-91.305847,0,'2013-07-06 12:44:33',NULL,NULL),(2314,'00927','S','Villas de San Ignacio','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(9799,'10109','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(58780,'68973','S','Silver Lake','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.437498,-98.550739,0,'2013-07-06 12:44:33',NULL,NULL),(22199,'23511','S','Fleet','A','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(44405,'49821','S','Daggett','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.452521,-87.594739,0,'2013-07-06 12:44:32',NULL,NULL),(22165,'23463','U','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.801576,-76.176454,0,'2013-07-06 12:44:31',NULL,NULL),(4850,'04013','S','S Freeport','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.798612,-70.074648,0,'2013-07-06 12:44:30',NULL,NULL),(43151,'48243','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.329927,-83.033898,0,'2013-07-06 12:44:32',NULL,NULL),(42681,'47977','S','Remington','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.763980,-87.150709,0,'2013-07-06 12:44:32',NULL,NULL),(19975,'20597','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896622,-77.034001,0,'2013-07-06 12:44:31',NULL,NULL),(22375,'23924','S','Chase City','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.796017,-78.461840,0,'2013-07-06 12:44:31',NULL,NULL),(44041,'49425','S','Holton','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.425180,-86.105175,0,'2013-07-06 12:44:32',NULL,NULL),(44738,'50162','S','Van Cleve','N','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.929203,-93.067787,0,'2013-07-06 12:44:32',NULL,NULL),(63695,'75865','P','Woodlake','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.030787,-95.034157,0,'2013-07-06 12:44:34',NULL,NULL),(66056,'78379','S','Riviera Beach','N','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.319380,-97.862520,0,'2013-07-06 12:44:34',NULL,NULL),(58371,'68527','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.842546,-96.535412,0,'2013-07-06 12:44:33',NULL,NULL),(53553,'62047','S','Hardin','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.153320,-90.623852,0,'2013-07-06 12:44:33',NULL,NULL),(7209,'06491','P','Stevenson','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.381403,-73.187735,0,'2013-07-06 12:44:30',NULL,NULL),(47944,'55117','S','Little Canada','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.000144,-93.083067,0,'2013-07-06 12:44:33',NULL,NULL),(4399,'03217','S','Ashland','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.693199,-71.631526,0,'2013-07-06 12:44:30',NULL,NULL),(21951,'23234','S','N Chesterfld','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.452407,-77.476225,0,'2013-07-06 12:44:31',NULL,NULL),(67836,'80810','S','Cheyenne Wls','A','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.850458,-102.381819,0,'2013-07-06 12:44:34',NULL,NULL),(55544,'63846','S','Essex','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.801227,-89.806089,0,'2013-07-06 12:44:33',NULL,NULL),(27884,'30456','S','Sardis','D','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.976002,-81.759411,0,'2013-07-06 12:44:31',NULL,NULL),(26700,'29407','S','Saint Andrews','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.800052,-80.010928,0,'2013-07-06 12:44:31',NULL,NULL),(51974,'60148','S','Flowerfield','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.869897,-88.011733,0,'2013-07-06 12:44:33',NULL,NULL),(70662,'85208','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.390705,-111.648725,0,'2013-07-06 12:44:34',NULL,NULL),(72416,'89049','S','Tonopah','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.064715,-117.227674,0,'2013-07-06 12:44:34',NULL,NULL),(74378,'92505','S','La Sierra','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.919916,-117.486689,0,'2013-07-06 12:44:34',NULL,NULL),(30867,'33664','U','Time Customer Service Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.967760,-82.518250,0,'2013-07-06 12:44:32',NULL,NULL),(879,'00698','S','Yauco','D','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(45938,'52338','S','Swisher','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.848730,-91.697035,0,'2013-07-06 12:44:32',NULL,NULL),(50035,'57430','S','Kidder','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.806700,-97.722180,0,'2013-07-06 12:44:33',NULL,NULL),(61557,'72716','U','Bentonville','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.322580,-94.180850,0,'2013-07-06 12:44:33',NULL,NULL),(62710,'74750','P','Millerton','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.991302,-95.020656,0,'2013-07-06 12:44:33',NULL,NULL),(75998,'95108','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.336070,-122.090216,0,'2013-07-06 12:44:34',NULL,NULL),(50331,'57730','S','Sylvan Lake','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(67322,'80031','S','Westminster','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.861937,-105.041266,0,'2013-07-06 12:44:34',NULL,NULL),(17797,'18370','S','Swiftwater','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.089290,-75.361974,0,'2013-07-06 12:44:31',NULL,NULL),(8027,'07728','S','East Freehold','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.243519,-74.277392,0,'2013-07-06 12:44:30',NULL,NULL),(25488,'28358','S','Lumberton','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.630251,-79.006164,0,'2013-07-06 12:44:31',NULL,NULL),(79977,'99652','P','Big Lake','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.581389,-149.439444,0,'2013-07-06 12:44:34',NULL,NULL),(17236,'17837','S','Buffalo X Rds','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(42102,'47460','S','Vilas','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(33131,'36879','S','Auburn','A','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.785158,-85.532396,0,'2013-07-06 12:44:32',NULL,NULL),(13401,'13751','S','Davenport Ctr','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.456620,-74.900750,0,'2013-07-06 12:44:31',NULL,NULL),(4311,'02911','S','Centredale','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(5150,'04418','S','Greenfld Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(47545,'54824','S','Centuria','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.448916,-92.546255,0,'2013-07-06 12:44:32',NULL,NULL),(50100,'57472','S','Sitka','N','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.412860,-100.021500,0,'2013-07-06 12:44:33',NULL,NULL),(50781,'58429','S','Sibley','A','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.202000,-98.138880,0,'2013-07-06 12:44:33',NULL,NULL),(61151,'72173','S','Naylor','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.066940,-92.174760,0,'2013-07-06 12:44:33',NULL,NULL),(68274,'81081','S','Trinchera','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.012494,-103.883558,0,'2013-07-06 12:44:34',NULL,NULL),(655,'00683','S','Ext Parc Sabana Eneas','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(1507,'00754','S','Bda Roosevelt','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(26873,'29547','S','Hamer','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.508632,-79.405977,0,'2013-07-06 12:44:31',NULL,NULL),(21674,'22957','P','Mntpelier Sta','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.199667,-78.116529,0,'2013-07-06 12:44:31',NULL,NULL),(54398,'62821','S','Rising Sun','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.066220,-88.138320,0,'2013-07-06 12:44:33',NULL,NULL),(7996,'07718','S','Belford','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.417983,-74.088112,0,'2013-07-06 12:44:30',NULL,NULL),(13480,'13795','S','Fivemile Point','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.067223,-75.796242,0,'2013-07-06 12:44:31',NULL,NULL),(29969,'33082','P','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.013469,-80.203516,0,'2013-07-06 12:44:32',NULL,NULL),(28489,'31520','S','Brunswick','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.178679,-81.489022,0,'2013-07-06 12:44:32',NULL,NULL),(27507,'30180','S','Villa Rica','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.708023,-84.932487,0,'2013-07-06 12:44:31',NULL,NULL),(27178,'29845','S','Parksville','A','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.816772,-82.235638,0,'2013-07-06 12:44:31',NULL,NULL),(11344,'11794','U','Stonybrook','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.914561,-73.125169,0,'2013-07-06 12:44:30',NULL,NULL),(23712,'25880','S','Mount Hope','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.893074,-81.167686,0,'2013-07-06 12:44:31',NULL,NULL),(14315,'14895','S','Wellsville','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.111970,-77.945146,0,'2013-07-06 12:44:31',NULL,NULL),(51845,'60070','S','Prospect Hts','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.104997,-87.936170,0,'2013-07-06 12:44:33',NULL,NULL),(60499,'71665','S','Herbine','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(73765,'91733','S','South El Monte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.051383,-118.044588,0,'2013-07-06 12:44:34',NULL,NULL),(36344,'40410','P','Bryantsville','D','Garrard','21079','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.713868,-84.646972,0,'2013-07-06 12:44:32',NULL,NULL),(34979,'39094','S','Lena','D','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.638026,-89.568150,0,'2013-07-06 12:44:32',NULL,NULL),(59170,'70342','S','Glenwild','N','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.694615,-91.225759,0,'2013-07-06 12:44:33',NULL,NULL),(26942,'29598','P','N Myrtle Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.805530,-78.718152,0,'2013-07-06 12:44:31',NULL,NULL),(79813,'99504','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.204464,-149.748496,0,'2013-07-06 12:44:34',NULL,NULL),(35948,'40058','P','Port Royal','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.557783,-85.078665,0,'2013-07-06 12:44:32',NULL,NULL),(24678,'27410','S','Greensboro-High Point-Winsto','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(6961,'06233','P','Ballouville','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.873110,-71.863498,0,'2013-07-06 12:44:30',NULL,NULL),(15723,'16874','S','Snow Shoe','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',41.028036,-77.945971,0,'2013-07-06 12:44:31',NULL,NULL),(75153,'93562','S','Ballarat','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.754736,-117.385894,0,'2013-07-06 12:44:34',NULL,NULL),(41947,'47394','S','Winchester','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.175183,-84.976721,0,'2013-07-06 12:44:32',NULL,NULL),(3779,'02201','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.359359,-71.059528,0,'2013-07-06 12:44:30',NULL,NULL),(29406,'32639','P','Gulf Hammock','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.250081,-82.722370,0,'2013-07-06 12:44:32',NULL,NULL),(27485,'30154','P','Douglasville','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.744279,-84.746956,0,'2013-07-06 12:44:31',NULL,NULL),(16822,'17550','P','Maytown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.069679,-76.581371,0,'2013-07-06 12:44:31',NULL,NULL),(21942,'23231','S','Montrose Heights','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(11951,'12446','S','Kerhonkson','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.812920,-74.294880,0,'2013-07-06 12:44:30',NULL,NULL),(7172,'06450','S','Meriden','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.533886,-72.799816,0,'2013-07-06 12:44:30',NULL,NULL),(7553,'07016','S','Cranford','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.654829,-74.305974,0,'2013-07-06 12:44:30',NULL,NULL),(77759,'97111','S','Carlton','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.292939,-123.183750,0,'2013-07-06 12:44:34',NULL,NULL),(77924,'97325','S','Aumsville','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.838831,-122.858581,0,'2013-07-06 12:44:34',NULL,NULL),(79753,'99258','U','Gonzaga Univ','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.666477,-117.405160,0,'2013-07-06 12:44:34',NULL,NULL),(7584,'07033','S','Kenilworth','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.678129,-74.294073,0,'2013-07-06 12:44:30',NULL,NULL),(50880,'58530','S','Fort Clark','A','Oliver','38065','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.086010,-100.941390,0,'2013-07-06 12:44:33',NULL,NULL),(55439,'63670','S','Weingarten','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(56748,'65723','S','Berwick','N','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.946566,-94.004128,0,'2013-07-06 12:44:33',NULL,NULL),(15650,'16743','S','Port Allegany','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.818170,-78.285029,0,'2013-07-06 12:44:31',NULL,NULL),(45421,'51055','S','Sloan','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.236796,-96.226638,0,'2013-07-06 12:44:32',NULL,NULL),(6290,'05649','S','East Barre','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.159916,-72.445332,0,'2013-07-06 12:44:30',NULL,NULL),(40572,'45867','S','Mt Blanchard','A','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.905474,-83.535045,0,'2013-07-06 12:44:32',NULL,NULL),(38764,'44044','S','North Eaton','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.270820,-82.045800,0,'2013-07-06 12:44:32',NULL,NULL),(44500,'49922','P','Dollar Bay','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.121190,-88.503527,0,'2013-07-06 12:44:32',NULL,NULL),(65876,'78221','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.319342,-98.496250,0,'2013-07-06 12:44:34',NULL,NULL),(79978,'99652','P','Wasilla','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.581389,-149.439444,0,'2013-07-06 12:44:34',NULL,NULL),(5668,'04961','S','Pierce Pond TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(15602,'16673','S','Roaring Spg','A','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.334211,-78.396280,0,'2013-07-06 12:44:31',NULL,NULL),(45961,'52358','S','Herbert Hoover National Hist','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(76518,'95646','P','Amador Station','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(52704,'61111','S','Loves Park','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.328100,-89.026827,0,'2013-07-06 12:44:33',NULL,NULL),(17397,'17901','S','Greenbury','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(39925,'45223','S','Cumminsville','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.162801,-84.548827,0,'2013-07-06 12:44:32',NULL,NULL),(35444,'39479','S','Gandsi','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.532820,-89.486580,0,'2013-07-06 12:44:32',NULL,NULL),(66785,'79044','S','Hartley','D','Hartley','48205','Texas','TX','48','0000','806','Central',-6.0,'Y',35.882162,-102.397209,0,'2013-07-06 12:44:34',NULL,NULL),(73468,'91308','P','Canoga Park','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201111,-118.597222,0,'2013-07-06 12:44:34',NULL,NULL),(69449,'83647','S','Paradise HOT','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(1465,'00745','S','Urb Cambalache Ii','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(22000,'23278','U','Wachovia Bank','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.558671,-77.443034,0,'2013-07-06 12:44:31',NULL,NULL),(34808,'38878','S','Varden','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(26222,'28792','S','Hendersonvlle','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.337349,-82.449108,0,'2013-07-06 12:44:31',NULL,NULL),(48275,'55430','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.056240,-93.301390,0,'2013-07-06 12:44:33',NULL,NULL),(48708,'55945','S','Theilman','A','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.308082,-91.996965,0,'2013-07-06 12:44:33',NULL,NULL),(56808,'65773','S','Souder','A','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.745108,-92.521187,0,'2013-07-06 12:44:33',NULL,NULL),(40168,'45367','U','Sidney','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.289153,-84.163256,0,'2013-07-06 12:44:32',NULL,NULL),(5202,'04453','S','Maxfield','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.211211,-68.824655,0,'2013-07-06 12:44:30',NULL,NULL),(79519,'98936','S','Moxee','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.549243,-120.329764,0,'2013-07-06 12:44:34',NULL,NULL),(66082,'78393','S','Bonnie View','N','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.167500,-97.299722,0,'2013-07-06 12:44:34',NULL,NULL),(15521,'16538','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.129086,-80.085881,0,'2013-07-06 12:44:31',NULL,NULL),(33037,'36741','P','Furman','D','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',32.002943,-86.962196,0,'2013-07-06 12:44:32',NULL,NULL),(48355,'55485','U','Wells Fargo Bank','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.936905,-93.221555,0,'2013-07-06 12:44:33',NULL,NULL),(54796,'63015','S','Catawissa','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.411262,-90.765192,0,'2013-07-06 12:44:33',NULL,NULL),(41894,'47371','S','College Corner','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(40244,'45426','S','Trotwood','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.804271,-84.300328,0,'2013-07-06 12:44:32',NULL,NULL),(11596,'12083','S','Norton Hill','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.416705,-74.011373,0,'2013-07-06 12:44:30',NULL,NULL),(48218,'55416','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.948525,-93.344253,0,'2013-07-06 12:44:33',NULL,NULL),(51366,'59347','S','Rosebud','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.274581,-106.441343,0,'2013-07-06 12:44:33',NULL,NULL),(51502,'59638','P','Jefferson Cty','A','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.383852,-112.059319,0,'2013-07-06 12:44:33',NULL,NULL),(40996,'46360','S','Michiana Shores','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(35672,'39654','S','Monticello','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(18589,'19135','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.024203,-75.049991,0,'2013-07-06 12:44:31',NULL,NULL),(16838,'17557','S','Groffdale','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101003,-76.079601,0,'2013-07-06 12:44:31',NULL,NULL),(30556,'33412','S','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(34968,'39079','S','Goodman','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.968830,-89.910822,0,'2013-07-06 12:44:32',NULL,NULL),(40807,'46184','S','New Whiteland','A','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.555508,-86.091336,0,'2013-07-06 12:44:32',NULL,NULL),(51598,'59823','S','Bonner','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.877569,-113.629257,0,'2013-07-06 12:44:33',NULL,NULL),(7097,'06359','S','North Stonington','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.462417,-71.870272,0,'2013-07-06 12:44:30',NULL,NULL),(9126,'09154','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7962,'07677','S','Woodcliff Lk','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.024537,-74.060304,0,'2013-07-06 12:44:30',NULL,NULL),(40402,'45677','P','Scioto Furnace','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.797453,-82.762942,0,'2013-07-06 12:44:32',NULL,NULL),(36850,'41076','S','Cold Spring Highland Heights','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(53791,'62281','S','Saint Jacob','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.701425,-89.784039,0,'2013-07-06 12:44:33',NULL,NULL),(57010,'66205','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(78556,'98154','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.606686,-122.333804,0,'2013-07-06 12:44:34',NULL,NULL),(50378,'57760','S','Cedar Canyon','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.718125,-103.420575,0,'2013-07-06 12:44:33',NULL,NULL),(71729,'87532','S','Riverside','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(4216,'02838','S','Manville','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.968318,-71.474105,0,'2013-07-06 12:44:30',NULL,NULL),(70169,'84322','U','Logan','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.746323,-111.810684,0,'2013-07-06 12:44:34',NULL,NULL),(54431,'62838','S','Farina','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.831400,-88.770151,0,'2013-07-06 12:44:33',NULL,NULL),(51370,'59354','P','Willard','D','Fallon','30025','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.130042,-104.458001,0,'2013-07-06 12:44:33',NULL,NULL),(50913,'58558','S','Menoken','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.820879,-100.600093,0,'2013-07-06 12:44:33',NULL,NULL),(57741,'67430','S','Cawker City','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.502984,-98.383572,0,'2013-07-06 12:44:33',NULL,NULL),(36885,'41101','S','Meads','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(26833,'29488','S','Walterboro','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.891220,-80.694600,0,'2013-07-06 12:44:31',NULL,NULL),(1888,'00791','S','Villa Oriente','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(38322,'43412','S','Curtice','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.651607,-83.283540,0,'2013-07-06 12:44:32',NULL,NULL),(19402,'20075','U','PNC Financial','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916959,-76.995806,0,'2013-07-06 12:44:31',NULL,NULL),(2295,'00927','S','Ext Santa Maria','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(25785,'28604','S','Elk Valley','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(22073,'23354','S','Bayford','N','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.469820,-75.913860,0,'2013-07-06 12:44:31',NULL,NULL),(21656,'22942','S','Boswells Tavern','N','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.134847,-78.186346,0,'2013-07-06 12:44:31',NULL,NULL),(14777,'15349','S','Mount Morris','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.745620,-80.092800,0,'2013-07-06 12:44:31',NULL,NULL),(12932,'13343','S','Otter Creek','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.737780,-75.327900,0,'2013-07-06 12:44:30',NULL,NULL),(45524,'51439','S','Charter Oak','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.067724,-95.591441,0,'2013-07-06 12:44:32',NULL,NULL),(45676,'52042','S','Edgewood','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.649161,-91.399965,0,'2013-07-06 12:44:32',NULL,NULL),(66935,'79356','S','Post','D','Garza','48169','Texas','TX','48','0000','806','Central',-6.0,'Y',33.194872,-101.378281,0,'2013-07-06 12:44:34',NULL,NULL),(68162,'81006','S','Baxter','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.244574,-104.524364,0,'2013-07-06 12:44:34',NULL,NULL),(78583,'98177','S','Bitter Lake','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.743958,-122.369875,0,'2013-07-06 12:44:34',NULL,NULL),(48200,'55398','S','Zimmerman','D','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.445056,-93.592028,0,'2013-07-06 12:44:33',NULL,NULL),(79703,'99209','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.699040,-117.445081,0,'2013-07-06 12:44:34',NULL,NULL),(41342,'46787','S','Collamer','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.085770,-85.618016,0,'2013-07-06 12:44:32',NULL,NULL),(694,'00685','S','San Sebastian','D','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(34002,'38120','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.122753,-89.861988,0,'2013-07-06 12:44:32',NULL,NULL),(4979,'04110','S','Cumb Foreside','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.759193,-70.202112,0,'2013-07-06 12:44:30',NULL,NULL),(43365,'48411','P','Atlas','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.930338,-83.544652,0,'2013-07-06 12:44:32',NULL,NULL),(42720,'48003','S','Almont Township','N','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.923761,-83.043136,0,'2013-07-06 12:44:32',NULL,NULL),(1411,'00738','S','Urb San Pedro','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(10239,'10467','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.873256,-73.870576,0,'2013-07-06 12:44:30',NULL,NULL),(16213,'17073','S','Millbach','N','Lebanon','42075','Pennsylvania','PA','42','3240','610/484','Eastern',-5.0,'Y',40.308720,-76.252800,0,'2013-07-06 12:44:31',NULL,NULL),(32489,'36053','S','Comer','N','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.107979,-85.526910,0,'2013-07-06 12:44:32',NULL,NULL),(31857,'35118','S','Maytown','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.538080,-87.039240,0,'2013-07-06 12:44:32',NULL,NULL),(31624,'34691','S','Tarpon Spngs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.192041,-82.754164,0,'2013-07-06 12:44:32',NULL,NULL),(31310,'34107','P','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.269597,-81.791672,0,'2013-07-06 12:44:32',NULL,NULL),(44912,'50329','U','Wells Fargo Mortgage','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585933,-93.635208,0,'2013-07-06 12:44:32',NULL,NULL),(57554,'67036','S','Danville','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.255729,-97.867543,0,'2013-07-06 12:44:33',NULL,NULL),(71913,'87821','S','Datil','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.918300,-108.055080,0,'2013-07-06 12:44:34',NULL,NULL),(56961,'66111','S','Edwardsville','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.089580,-94.739700,0,'2013-07-06 12:44:33',NULL,NULL),(55022,'63135','S','Dellwood','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748900,-90.303899,0,'2013-07-06 12:44:33',NULL,NULL),(34277,'38475','S','Olivehill','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.271532,-88.040542,0,'2013-07-06 12:44:32',NULL,NULL),(71290,'86442','S','Bullhead City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.097257,-114.601553,0,'2013-07-06 12:44:34',NULL,NULL),(33237,'37070','P','Goodlettsvle','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.323710,-86.715822,0,'2013-07-06 12:44:32',NULL,NULL),(23274,'25149','P','Ottawa','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.959696,-81.817975,0,'2013-07-06 12:44:31',NULL,NULL),(38777,'44054','S','Sheffield Lake','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(54896,'63073','P','Saint Albans','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.579100,-90.775020,0,'2013-07-06 12:44:33',NULL,NULL),(4391,'03109','S','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.973773,-71.413591,0,'2013-07-06 12:44:30',NULL,NULL),(2768,'00971','S','Urb Camino Del Monte','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388508,-66.115017,0,'2013-07-06 12:44:30',NULL,NULL),(6432,'05744','S','Florence','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.595204,-73.048443,0,'2013-07-06 12:44:30',NULL,NULL),(33217,'37056','P','Dickson','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.076801,-87.377175,0,'2013-07-06 12:44:32',NULL,NULL),(45175,'50604','S','Aplington','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.581630,-92.880135,0,'2013-07-06 12:44:32',NULL,NULL),(45931,'52335','S','South English','D','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.469607,-92.116288,0,'2013-07-06 12:44:32',NULL,NULL),(48457,'55711','S','Fine Lakes','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.856672,-92.673076,0,'2013-07-06 12:44:33',NULL,NULL),(11200,'11743','S','Beech Croft','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(70485,'84770','S','Harrisburg Junction','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(35141,'39217','U','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.288941,-90.186095,0,'2013-07-06 12:44:32',NULL,NULL),(62444,'74186','U','Oklahoma Natural Gas','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.152163,-95.995000,0,'2013-07-06 12:44:33',NULL,NULL),(19008,'19526','S','West Hamburg','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(18786,'19376','P','Wagontown','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.023441,-75.826703,0,'2013-07-06 12:44:31',NULL,NULL),(59622,'71032','S','Kingston','N','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.117220,-93.776940,0,'2013-07-06 12:44:33',NULL,NULL),(1038,'00721','P','Rio Grande','A','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.371798,-65.774509,0,'2013-07-06 12:44:30',NULL,NULL),(31552,'34607','S','Hernando Bch','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.505114,-82.636115,0,'2013-07-06 12:44:32',NULL,NULL),(52383,'60626','S','Rogers Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.005107,-87.669133,0,'2013-07-06 12:44:33',NULL,NULL),(65039,'77328','S','Cleveland','D','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.341748,-95.086861,0,'2013-07-06 12:44:34',NULL,NULL),(70691,'85257','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.466740,-111.917674,0,'2013-07-06 12:44:34',NULL,NULL),(1040,'00723','S','Jard de Patillas','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(19958,'20585','U','Dept Energy','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886166,-77.025669,0,'2013-07-06 12:44:31',NULL,NULL),(19144,'19702','S','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.604610,-75.746270,0,'2013-07-06 12:44:31',NULL,NULL),(36423,'40555','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.984827,-84.427055,0,'2013-07-06 12:44:32',NULL,NULL),(36078,'40213','S','Poplar Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.184398,-85.716074,0,'2013-07-06 12:44:32',NULL,NULL),(33760,'37857','S','Rogersville','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.405041,-83.009455,0,'2013-07-06 12:44:32',NULL,NULL),(32394,'35954','S','Ivalee','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.083060,-86.060280,0,'2013-07-06 12:44:32',NULL,NULL),(6635,'06001','S','Avon','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.794016,-72.860016,0,'2013-07-06 12:44:30',NULL,NULL),(29398,'32625','S','Cedar Key','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.170127,-83.014197,0,'2013-07-06 12:44:32',NULL,NULL),(5261,'04487','S','Springfield','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.393599,-68.101456,0,'2013-07-06 12:44:30',NULL,NULL),(53713,'62239','S','Dupo','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.523233,-90.198401,0,'2013-07-06 12:44:33',NULL,NULL),(63358,'75638','S','Daingerfield','D','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.976111,-94.718333,0,'2013-07-06 12:44:33',NULL,NULL),(74212,'92308','S','Apple Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.460602,-117.192247,0,'2013-07-06 12:44:34',NULL,NULL),(19087,'19601','S','Greenfield Manor','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.347781,-75.938400,0,'2013-07-06 12:44:31',NULL,NULL),(60040,'71343','S','Wallace Ridge','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(29295,'32511','U','NTT Corry Field','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.396956,-87.352515,0,'2013-07-06 12:44:32',NULL,NULL),(4638,'03609','S','North Walpole','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.141354,-72.445147,0,'2013-07-06 12:44:30',NULL,NULL),(78956,'98370','S','Central Valley','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(65579,'77864','S','Connor','N','Madison','48313','Texas','TX','48','0000','936','Central',-6.0,'Y',30.975540,-95.900700,0,'2013-07-06 12:44:34',NULL,NULL),(5042,'04262','P','North Jay','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.523739,-70.210122,0,'2013-07-06 12:44:30',NULL,NULL),(41102,'46555','S','North Webster','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.325309,-85.689820,0,'2013-07-06 12:44:32',NULL,NULL),(64130,'76192','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.932938,-97.435253,0,'2013-07-06 12:44:34',NULL,NULL),(11517,'12033','S','Castleton','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535438,-73.709070,0,'2013-07-06 12:44:30',NULL,NULL),(59212,'70394','S','St Charles','N','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.709855,-90.605109,0,'2013-07-06 12:44:33',NULL,NULL),(45991,'52501','S','Cliffland','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(22031,'23294','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.630728,-77.544233,0,'2013-07-06 12:44:31',NULL,NULL),(27603,'30301','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.855904,-84.395303,0,'2013-07-06 12:44:31',NULL,NULL),(9696,'10045','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(15683,'16832','S','Coburn','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.869439,-77.735780,0,'2013-07-06 12:44:31',NULL,NULL),(37189,'41513','S','Ferrells Creek','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300665,-82.348713,0,'2013-07-06 12:44:32',NULL,NULL),(25321,'28173','S','Marvin','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.928790,-80.735968,0,'2013-07-06 12:44:31',NULL,NULL),(31784,'35023','S','Concord','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.411900,-87.046140,0,'2013-07-06 12:44:32',NULL,NULL),(26899,'29575','S','Surfside Beach','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.626586,-78.983446,0,'2013-07-06 12:44:31',NULL,NULL),(53935,'62413','S','Annapolis','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.123916,-87.798072,0,'2013-07-06 12:44:33',NULL,NULL),(60072,'71355','S','Borodino','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(60348,'71468','S','Kisatchie','N','Natchitoches','22069','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.538100,-93.115260,0,'2013-07-06 12:44:33',NULL,NULL),(65434,'77585','S','Saratoga','D','Hardin','48199','Texas','TX','48','0840','936','Central',-6.0,'Y',30.358816,-94.559529,0,'2013-07-06 12:44:34',NULL,NULL),(68329,'81120','S','San Miguel','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(4960,'04106','S','S Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.620751,-70.291117,0,'2013-07-06 12:44:30',NULL,NULL),(33916,'38053','S','Lucy','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(11958,'12453','P','Malden Hudson','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.094637,-73.933788,0,'2013-07-06 12:44:30',NULL,NULL),(52161,'60452','S','Oak Forest','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.608681,-87.757635,0,'2013-07-06 12:44:33',NULL,NULL),(42095,'47460','S','Heights Corner','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(49897,'57274','S','Holmquist','N','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.325620,-97.519560,0,'2013-07-06 12:44:33',NULL,NULL),(26162,'28743','S','Luck','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(37258,'41562','S','Shelbiana','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.393260,-82.471200,0,'2013-07-06 12:44:32',NULL,NULL),(9351,'09806','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18933,'19505','S','Eshbach','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.372171,-75.627950,0,'2013-07-06 12:44:31',NULL,NULL),(15863,'16947','S','West Burlington Township','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.783653,-76.791605,0,'2013-07-06 12:44:31',NULL,NULL),(23784,'25984','S','Kessler','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.961580,-80.692200,0,'2013-07-06 12:44:31',NULL,NULL),(70361,'84648','S','Nephi','D','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.710909,-111.844866,0,'2013-07-06 12:44:34',NULL,NULL),(77871,'97256','U','Pacific Power','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.515988,-122.680938,0,'2013-07-06 12:44:34',NULL,NULL),(17776,'18342','P','Mountainhome','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.177592,-75.259145,0,'2013-07-06 12:44:31',NULL,NULL),(65358,'77531','S','Richwood','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.046060,-95.402160,0,'2013-07-06 12:44:34',NULL,NULL),(47970,'55125','S','Saint Paul','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.905320,-92.923260,0,'2013-07-06 12:44:33',NULL,NULL),(15172,'15927','S','Colver','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.540795,-78.790981,0,'2013-07-06 12:44:31',NULL,NULL),(46637,'53590','S','Sun Prairie','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.189901,-89.219791,0,'2013-07-06 12:44:32',NULL,NULL),(44551,'50008','S','Allerton','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.674358,-93.382116,0,'2013-07-06 12:44:32',NULL,NULL),(31559,'34609','S','Spring Hill','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.479491,-82.499987,0,'2013-07-06 12:44:32',NULL,NULL),(36575,'40943','S','Girdler','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.972409,-83.855205,0,'2013-07-06 12:44:32',NULL,NULL),(68012,'80923','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.899457,-104.699208,0,'2013-07-06 12:44:34',NULL,NULL),(47595,'54867','S','Radisson','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.804361,-91.228172,0,'2013-07-06 12:44:33',NULL,NULL),(36546,'40906','S','Baughman','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(68437,'81224','S','Cement Creek','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.860596,-106.956766,0,'2013-07-06 12:44:34',NULL,NULL),(25004,'27871','S','Robersonville','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.822151,-77.251920,0,'2013-07-06 12:44:31',NULL,NULL),(35414,'39466','S','Greenbrier Park','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(50142,'57533','S','Iona','A','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.233905,-99.427134,0,'2013-07-06 12:44:33',NULL,NULL),(55633,'64012','S','Belton','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.806411,-94.535486,0,'2013-07-06 12:44:33',NULL,NULL),(58707,'68933','S','Clay Center','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.528949,-98.058999,0,'2013-07-06 12:44:33',NULL,NULL),(66096,'78406','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.777491,-97.516057,0,'2013-07-06 12:44:34',NULL,NULL),(68804,'82431','S','Lovell','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.799584,-108.346495,0,'2013-07-06 12:44:34',NULL,NULL),(71257,'86406','S','Lk Havasu Cty','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.474110,-114.284707,0,'2013-07-06 12:44:34',NULL,NULL),(77012,'96089','P','Shasta Lake','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.683097,-122.400465,0,'2013-07-06 12:44:34',NULL,NULL),(77419,'96799','P','Pago Pago','D','American Samoa','60001','American Samoa','AS','60','0000','684','None',0.0,'N',14.241200,-170.719577,0,'2013-07-06 12:44:34',NULL,NULL),(64733,'76887','S','Voca','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',30.984719,-99.147972,0,'2013-07-06 12:44:34',NULL,NULL),(51631,'59854','S','Ovando','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.033331,-113.032408,0,'2013-07-06 12:44:33',NULL,NULL),(30695,'33481','P','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.379928,-80.101289,0,'2013-07-06 12:44:32',NULL,NULL),(30268,'33239','P','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.790887,-80.141386,0,'2013-07-06 12:44:32',NULL,NULL),(34015,'38126','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.124020,-90.041534,0,'2013-07-06 12:44:32',NULL,NULL),(34132,'38221','S','Big Sandy','D','Benton','47005','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.239190,-88.060257,0,'2013-07-06 12:44:32',NULL,NULL),(77492,'96825','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.296254,-157.696767,0,'2013-07-06 12:44:34',NULL,NULL),(19611,'20235','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.911897,-77.045863,0,'2013-07-06 12:44:31',NULL,NULL),(52488,'60696','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.848295,-87.649618,0,'2013-07-06 12:44:33',NULL,NULL),(25220,'28086','S','Kings Mtn','A','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.246918,-81.361082,0,'2013-07-06 12:44:31',NULL,NULL),(35365,'39441','P','Laurel','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.704944,-89.123240,0,'2013-07-06 12:44:32',NULL,NULL),(72855,'90001','S','Firestone Pk','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.973310,-118.243612,0,'2013-07-06 12:44:34',NULL,NULL),(56616,'65583','S','Buckhorn','N','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.821060,-92.186820,0,'2013-07-06 12:44:33',NULL,NULL),(16340,'17128','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263931,-76.883400,0,'2013-07-06 12:44:31',NULL,NULL),(41501,'46959','S','Miami','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.613903,-86.108163,0,'2013-07-06 12:44:32',NULL,NULL),(53474,'61937','S','Lake City','A','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.711745,-88.639682,0,'2013-07-06 12:44:33',NULL,NULL),(59794,'71220','S','Log Cabin','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(66663,'78872','P','La Pryor','D','Zavala','48507','Texas','TX','48','0000','830','Central',-6.0,'Y',28.951466,-99.848475,0,'2013-07-06 12:44:34',NULL,NULL),(68700,'82058','S','Garrett','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.196069,-105.678821,0,'2013-07-06 12:44:34',NULL,NULL),(72952,'90040','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.976980,-118.128840,0,'2013-07-06 12:44:34',NULL,NULL),(8346,'08043','S','Kirkwood','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.846520,-74.960981,0,'2013-07-06 12:44:30',NULL,NULL),(50542,'58125','U','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.879774,-96.814895,0,'2013-07-06 12:44:33',NULL,NULL),(41359,'46792','S','Salamonie','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(14433,'15083','S','Sutersville','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.238648,-79.791917,0,'2013-07-06 12:44:31',NULL,NULL),(37633,'42160','S','Park City','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.064959,-86.054190,0,'2013-07-06 12:44:32',NULL,NULL),(14021,'14539','P','Retsof','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.835036,-77.880566,0,'2013-07-06 12:44:31',NULL,NULL),(43150,'48242','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.212327,-83.347739,0,'2013-07-06 12:44:32',NULL,NULL),(24940,'27821','S','Edward','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.329294,-76.892630,0,'2013-07-06 12:44:31',NULL,NULL),(45157,'50588','S','Sulphur Springs','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(51584,'59803','S','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.821982,-114.017179,0,'2013-07-06 12:44:33',NULL,NULL),(3278,'01473','S','Westminster','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.540906,-71.906138,0,'2013-07-06 12:44:30',NULL,NULL),(57243,'66523','S','Osage City','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.631972,-95.827197,0,'2013-07-06 12:44:33',NULL,NULL),(56687,'65648','S','Fair Grove','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.374876,-93.133028,0,'2013-07-06 12:44:33',NULL,NULL),(5040,'04261','S','Newry','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.570737,-70.882590,0,'2013-07-06 12:44:30',NULL,NULL),(6828,'06115','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760560,-72.674050,0,'2013-07-06 12:44:30',NULL,NULL),(24269,'26845','S','Old Fields','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.146898,-78.951621,0,'2013-07-06 12:44:31',NULL,NULL),(30698,'33483','S','Gulf Stream','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.463927,-80.062263,0,'2013-07-06 12:44:32',NULL,NULL),(12883,'13327','S','Kirschnerville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.899822,-75.381978,0,'2013-07-06 12:44:30',NULL,NULL),(17365,'17872','S','Tharptown','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(16886,'17575','P','Silver Spring','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.074020,-76.430012,0,'2013-07-06 12:44:31',NULL,NULL),(61733,'73026','S','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.234976,-97.361332,0,'2013-07-06 12:44:33',NULL,NULL),(41874,'47362','S','Millville','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(33693,'37755','S','Helenwood','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.434790,-84.565182,0,'2013-07-06 12:44:32',NULL,NULL),(48728,'55960','S','Douglas','N','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.151074,-92.521283,0,'2013-07-06 12:44:33',NULL,NULL),(67909,'80904','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855129,-104.865127,0,'2013-07-06 12:44:34',NULL,NULL),(73544,'91355','S','Valencia','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.403591,-118.532784,0,'2013-07-06 12:44:34',NULL,NULL),(76906,'95987','S','Wilbur Springs','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.148021,-122.145602,0,'2013-07-06 12:44:34',NULL,NULL),(79791,'99350','S','Prosser','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.203527,-119.766249,0,'2013-07-06 12:44:34',NULL,NULL),(3340,'01543','S','Rutland','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.374268,-71.950450,0,'2013-07-06 12:44:30',NULL,NULL),(55214,'63401','S','Huntington','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(19093,'19604','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.354850,-75.907765,0,'2013-07-06 12:44:31',NULL,NULL),(6356,'05675','S','Sky Acres','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(64616,'76690','S','Walnut Springs','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.064900,-97.763580,0,'2013-07-06 12:44:34',NULL,NULL),(62741,'74833','S','Castle','D','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.481185,-96.369933,0,'2013-07-06 12:44:33',NULL,NULL),(15216,'16018','U','Annandale','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091370,-79.908947,0,'2013-07-06 12:44:31',NULL,NULL),(3192,'01344','S','Erving','D','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.605957,-72.410738,0,'2013-07-06 12:44:30',NULL,NULL),(52051,'60196','U','Multi High Volume Firms','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.071476,-88.049239,0,'2013-07-06 12:44:33',NULL,NULL),(35425,'39470','S','West Poplarville','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(727,'00687','S','Urb Russe','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(44975,'50421','S','Belmond','D','Wright','19197','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.846375,-93.614291,0,'2013-07-06 12:44:32',NULL,NULL),(63472,'75686','S','Lafayette','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(65898,'78234','S','Ft Sm Houston','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.457977,-98.493044,0,'2013-07-06 12:44:34',NULL,NULL),(77988,'97396','S','Willamina','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.119860,-123.538659,0,'2013-07-06 12:44:34',NULL,NULL),(79283,'98577','S','Willapa','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(8662,'08318','S','Pittsgrov Twp','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(63417,'75657','S','Berea','N','Marion','48315','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.787670,-94.073130,0,'2013-07-06 12:44:33',NULL,NULL),(49577,'56729','S','Halma','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.672798,-96.583668,0,'2013-07-06 12:44:33',NULL,NULL),(20081,'20686','P','St Marys City','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.186123,-76.436956,0,'2013-07-06 12:44:31',NULL,NULL),(55765,'64116','S','KC','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(79366,'98650','S','Trout Lake','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.986684,-121.511092,0,'2013-07-06 12:44:34',NULL,NULL),(39777,'45122','S','Cozaddale','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.222960,-84.120240,0,'2013-07-06 12:44:32',NULL,NULL),(37649,'42170','S','Woodburn','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.840465,-86.611447,0,'2013-07-06 12:44:32',NULL,NULL),(37125,'41464','S','Gypsy','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.662500,-82.963889,0,'2013-07-06 12:44:32',NULL,NULL),(16434,'17233','S','Mc Connellsbg','A','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(46672,'53717','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.070985,-89.512160,0,'2013-07-06 12:44:32',NULL,NULL),(55312,'63537','S','Edina','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.169229,-92.170868,0,'2013-07-06 12:44:33',NULL,NULL),(76813,'95953','S','Live Oak','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.259446,-121.695206,0,'2013-07-06 12:44:34',NULL,NULL),(78339,'98004','S','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(79319,'98602','S','Appleton','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.839361,-121.285084,0,'2013-07-06 12:44:34',NULL,NULL),(29318,'32538','P','Paxton','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.977370,-86.312405,0,'2013-07-06 12:44:32',NULL,NULL),(63584,'75783','S','Oak Grove','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.795818,-95.445299,0,'2013-07-06 12:44:34',NULL,NULL),(54769,'62992','S','Ullin','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.269766,-89.176840,0,'2013-07-06 12:44:33',NULL,NULL),(26893,'29571','S','Marion','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.183414,-79.396314,0,'2013-07-06 12:44:31',NULL,NULL),(25845,'28623','S','Barrett','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.529320,-80.969220,0,'2013-07-06 12:44:31',NULL,NULL),(1250,'00729','S','Urb Las Haciendas Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(9315,'09727','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19859,'20521','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899591,-77.051114,0,'2013-07-06 12:44:31',NULL,NULL),(38266,'43311','S','Bellfntn','N','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.359628,-83.757376,0,'2013-07-06 12:44:32',NULL,NULL),(18529,'19108','P','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.062989,-75.200974,0,'2013-07-06 12:44:31',NULL,NULL),(17238,'17837','S','East Buffalo','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(32975,'36610','S','Prichard','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.739731,-88.080296,0,'2013-07-06 12:44:32',NULL,NULL),(32925,'36558','S','Healing Springs','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(51425,'59453','S','Garneill','A','Wheatland','30107','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.605514,-109.599361,0,'2013-07-06 12:44:33',NULL,NULL),(53114,'61542','S','Lewistown','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.405833,-90.034444,0,'2013-07-06 12:44:33',NULL,NULL),(64934,'77218','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.828144,-95.653044,0,'2013-07-06 12:44:34',NULL,NULL),(71372,'87002','S','Belen','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.656448,-106.759548,0,'2013-07-06 12:44:34',NULL,NULL),(78910,'98362','S','Sol Duc Hot Springs','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(42415,'47802','S','Lakeview Estates','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(70931,'85635','S','Sierra Vista','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.528599,-110.259800,0,'2013-07-06 12:44:34',NULL,NULL),(20366,'20878','S','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.105531,-77.240190,0,'2013-07-06 12:44:31',NULL,NULL),(17062,'17756','S','Huntersville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(67355,'80111','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(74425,'92561','S','Mountain Center','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.518312,-116.424551,0,'2013-07-06 12:44:34',NULL,NULL),(1784,'00782','S','Urb Sabana del Palmar','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(23190,'25049','S','Comfort','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.124386,-81.572157,0,'2013-07-06 12:44:31',NULL,NULL),(28341,'31192','U','Mellon Bank','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.623867,-84.534721,0,'2013-07-06 12:44:32',NULL,NULL),(45379,'51020','S','Galva','D','Ida','19093','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.505637,-95.414574,0,'2013-07-06 12:44:32',NULL,NULL),(46728,'53820','S','Potosi','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.699392,-90.705017,0,'2013-07-06 12:44:32',NULL,NULL),(49007,'56253','S','Lake Lillian','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.971457,-94.888107,0,'2013-07-06 12:44:33',NULL,NULL),(51922,'60117','U','Bloomingdale','D','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.945790,-88.084824,0,'2013-07-06 12:44:33',NULL,NULL),(66142,'78469','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.796865,-97.445946,0,'2013-07-06 12:44:34',NULL,NULL),(69105,'83256','P','Moreland','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.224524,-112.442830,0,'2013-07-06 12:44:34',NULL,NULL),(41074,'46524','S','Etna Green','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.296073,-86.089031,0,'2013-07-06 12:44:32',NULL,NULL),(4033,'02573','P','Vineyard Hvn','A','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.441817,-70.600178,0,'2013-07-06 12:44:30',NULL,NULL),(75167,'93596','P','Boron','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.006002,-117.651389,0,'2013-07-06 12:44:34',NULL,NULL),(74121,'92235','P','Cathedral Cty','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.780606,-116.461273,0,'2013-07-06 12:44:34',NULL,NULL),(20219,'20772','S','Marlboro','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.799000,-76.785960,0,'2013-07-06 12:44:31',NULL,NULL),(69961,'84119','S','Granger Hunter','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(68445,'81225','P','Skyland','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(65297,'77489','S','Missouri City','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.596601,-95.516014,0,'2013-07-06 12:44:34',NULL,NULL),(5146,'04418','S','Cardville','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(44190,'49614','S','Bear Lake','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.423101,-86.126289,0,'2013-07-06 12:44:32',NULL,NULL),(45700,'52056','P','Luxemburg','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.611503,-91.083512,0,'2013-07-06 12:44:32',NULL,NULL),(48407,'55595','P','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.102155,-93.660246,0,'2013-07-06 12:44:33',NULL,NULL),(50294,'57661','P','Whitehorse','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.268514,-100.888467,0,'2013-07-06 12:44:33',NULL,NULL),(53206,'61615','S','Alta','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.786669,-89.632384,0,'2013-07-06 12:44:33',NULL,NULL),(55254,'63453','S','Luray','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.510718,-91.888478,0,'2013-07-06 12:44:33',NULL,NULL),(76219,'95372','S','Soulsbyville','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.991804,-120.263586,0,'2013-07-06 12:44:34',NULL,NULL),(58170,'68198','U','Univ of Ne Med Center','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.265996,-96.010026,0,'2013-07-06 12:44:33',NULL,NULL),(17322,'17859','S','Rohrsburg','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(46940,'54162','S','Pulaski','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.651006,-88.212562,0,'2013-07-06 12:44:32',NULL,NULL),(37807,'42406','S','Geneva','N','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.727979,-87.694821,0,'2013-07-06 12:44:32',NULL,NULL),(74234,'92323','S','Cima','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.236266,-115.498775,0,'2013-07-06 12:44:34',NULL,NULL),(56510,'65349','S','Slater','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.214173,-93.069492,0,'2013-07-06 12:44:33',NULL,NULL),(48943,'56165','S','Reading','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.712991,-95.758482,0,'2013-07-06 12:44:33',NULL,NULL),(22712,'24350','S','Ivanhoe','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.818045,-81.007296,0,'2013-07-06 12:44:31',NULL,NULL),(34470,'38663','S','Ripley','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(20339,'20852','S','North Bethesda','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.046797,-77.119654,0,'2013-07-06 12:44:31',NULL,NULL),(15309,'16153','S','Stoneboro','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.329861,-80.115692,0,'2013-07-06 12:44:31',NULL,NULL),(17090,'17764','S','Shintown','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(13579,'13844','S','North Pharsalia','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.608333,-75.701944,0,'2013-07-06 12:44:31',NULL,NULL),(26041,'28684','S','Brownwood','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.311400,-81.579000,0,'2013-07-06 12:44:31',NULL,NULL),(51077,'58760','S','Eckman','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.799553,-101.327522,0,'2013-07-06 12:44:33',NULL,NULL),(72648,'89429','S','Silver Spgs','A','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.358200,-119.295180,0,'2013-07-06 12:44:34',NULL,NULL),(75910,'95003','S','Rio del Mar','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.992640,-121.876740,0,'2013-07-06 12:44:34',NULL,NULL),(79418,'98823','S','Ephrata','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.317313,-119.548000,0,'2013-07-06 12:44:34',NULL,NULL),(32383,'35906','S','Rainbow City','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.942000,-86.103720,0,'2013-07-06 12:44:32',NULL,NULL),(55806,'64138','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.971599,-94.474727,0,'2013-07-06 12:44:33',NULL,NULL),(43501,'48627','P','Higgins Lake','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.442024,-84.743635,0,'2013-07-06 12:44:32',NULL,NULL),(67273,'79996','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.850216,-106.438303,0,'2013-07-06 12:44:34',NULL,NULL),(78209,'97752','S','Post','D','Crook','41013','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.995731,-120.231420,0,'2013-07-06 12:44:34',NULL,NULL),(50317,'57720','S','Buffalo','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.507180,-103.656180,0,'2013-07-06 12:44:33',NULL,NULL),(6626,'05905','S','Brunswick','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(64925,'77209','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.620069,-95.190018,0,'2013-07-06 12:44:34',NULL,NULL),(2596,'00961','S','Urb Los Almendros','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(42329,'47630','S','Yankeetown','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.964340,-87.354120,0,'2013-07-06 12:44:32',NULL,NULL),(40684,'46064','S','Pendleton','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.992520,-85.772940,0,'2013-07-06 12:44:32',NULL,NULL),(12552,'13044','S','Gayville','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.266484,-76.009432,0,'2013-07-06 12:44:30',NULL,NULL),(38712,'44012','S','Avon Lake','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.494448,-82.020479,0,'2013-07-06 12:44:32',NULL,NULL),(22394,'23950','S','Black Ridge','N','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.752222,-78.046389,0,'2013-07-06 12:44:31',NULL,NULL),(64101,'76177','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.972817,-97.333370,0,'2013-07-06 12:44:34',NULL,NULL),(67875,'80835','S','Simla','D','Elbert','08039','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.182899,-104.082890,0,'2013-07-06 12:44:34',NULL,NULL),(729,'00687','S','Valles de San Luis','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(53586,'62069','S','Lake Keho','N','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.072236,-89.724462,0,'2013-07-06 12:44:33',NULL,NULL),(39742,'45069','S','West Chester','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.341460,-84.398674,0,'2013-07-06 12:44:32',NULL,NULL),(65457,'77617','P','Caplen','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.511982,-94.490314,0,'2013-07-06 12:44:34',NULL,NULL),(76298,'95437','S','Pudding Creek','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(4986,'04122','U','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.653310,-70.331898,0,'2013-07-06 12:44:30',NULL,NULL),(45918,'52325','S','Holbrook','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.554231,-92.004947,0,'2013-07-06 12:44:32',NULL,NULL),(45340,'50936','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582040,-93.638893,0,'2013-07-06 12:44:32',NULL,NULL),(31384,'34217','S','Holmes Beach','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.508565,-82.716234,0,'2013-07-06 12:44:32',NULL,NULL),(13141,'13502','S','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.127460,-75.214260,0,'2013-07-06 12:44:30',NULL,NULL),(26181,'28756','S','Mill Spring','D','Polk','37149','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.339715,-82.169664,0,'2013-07-06 12:44:31',NULL,NULL),(20459,'21027','P','Chase','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.353926,-76.372508,0,'2013-07-06 12:44:31',NULL,NULL),(43185,'48301','S','Bloomfield Village','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(19989,'20598','U','Sterling','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(38150,'43145','S','New Holland','D','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.558554,-83.232584,0,'2013-07-06 12:44:32',NULL,NULL),(37141,'41465','S','Fritz','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(26333,'29055','S','Great Falls','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.570485,-80.902059,0,'2013-07-06 12:44:31',NULL,NULL),(33922,'38054','P','Millington','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.339231,-89.877562,0,'2013-07-06 12:44:32',NULL,NULL),(33316,'37136','P','Norene','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.195537,-86.278064,0,'2013-07-06 12:44:32',NULL,NULL),(51517,'59702','P','Butte','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.908075,-112.496591,0,'2013-07-06 12:44:33',NULL,NULL),(52755,'61244','S','South Moline','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(57321,'66710','S','Guilford','N','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.520445,-95.658609,0,'2013-07-06 12:44:33',NULL,NULL),(78596,'98188','S','Duwamish','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(61890,'73136','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.589704,-97.456239,0,'2013-07-06 12:44:33',NULL,NULL),(9419,'10002','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(9811,'10111','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(44460,'49878','S','Rapid River','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.897736,-86.899651,0,'2013-07-06 12:44:32',NULL,NULL),(21228,'22219','P','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.891234,-77.073069,0,'2013-07-06 12:44:31',NULL,NULL),(25160,'28033','S','Crouse','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.401571,-81.346799,0,'2013-07-06 12:44:31',NULL,NULL),(68369,'81137','S','Tiffany','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(56454,'65282','S','Santa Fe','D','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.403821,-91.824295,0,'2013-07-06 12:44:33',NULL,NULL),(3512,'01867','S','Reading','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.529523,-71.108868,0,'2013-07-06 12:44:30',NULL,NULL),(19205,'19885','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743278,-75.547128,0,'2013-07-06 12:44:31',NULL,NULL),(18664,'19178','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953092,-75.184961,0,'2013-07-06 12:44:31',NULL,NULL),(54157,'62571','S','Tower Hill','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.390541,-88.964526,0,'2013-07-06 12:44:33',NULL,NULL),(57615,'67124','S','Cullison','A','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.648212,-98.738461,0,'2013-07-06 12:44:33',NULL,NULL),(67560,'80281','U','Wells Fargo Bank','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.744220,-104.988910,0,'2013-07-06 12:44:34',NULL,NULL),(79387,'98684','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.621240,-122.551080,0,'2013-07-06 12:44:34',NULL,NULL),(17709,'18231','P','Kelayres','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.902566,-76.005270,0,'2013-07-06 12:44:31',NULL,NULL),(67829,'80805','S','Bethune','D','Kit Carson','08063','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.313695,-102.437199,0,'2013-07-06 12:44:34',NULL,NULL),(45179,'50607','S','Aurora','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.623665,-91.733386,0,'2013-07-06 12:44:32',NULL,NULL),(16776,'17522','S','Weidmanville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(60913,'72078','P','Jacksonville','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.864160,-92.122487,0,'2013-07-06 12:44:33',NULL,NULL),(35316,'39423','S','Beaumont','D','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.129500,-88.904640,0,'2013-07-06 12:44:32',NULL,NULL),(25320,'28170','S','Wadesboro','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',34.964789,-80.071006,0,'2013-07-06 12:44:31',NULL,NULL),(11278,'11772','S','Canaan Lake','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(45239,'50651','S','Laporte City','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.333783,-92.194367,0,'2013-07-06 12:44:32',NULL,NULL),(55856,'64171','P','K C','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.050940,-94.588104,0,'2013-07-06 12:44:33',NULL,NULL),(60741,'71966','P','Oden','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.585833,-93.910000,0,'2013-07-06 12:44:33',NULL,NULL),(64692,'76844','S','Goldthwaite','D','Mills','48333','Texas','TX','48','0000','325','Central',-6.0,'Y',31.438800,-98.575140,0,'2013-07-06 12:44:34',NULL,NULL),(72789,'89701','S','New Washoe City','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(13139,'13502','S','Deerfield','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.127460,-75.214260,0,'2013-07-06 12:44:30',NULL,NULL),(72911,'90025','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.044073,-118.451381,0,'2013-07-06 12:44:34',NULL,NULL),(78865,'98349','S','Herron Is','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.280780,-122.773440,0,'2013-07-06 12:44:34',NULL,NULL),(15031,'15690','S','Park','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.598718,-79.570417,0,'2013-07-06 12:44:31',NULL,NULL),(53065,'61517','S','Southport','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.825159,-89.850815,0,'2013-07-06 12:44:33',NULL,NULL),(37824,'42437','S','Morganfield','D','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(346,'00656','S','Urb La Concepcion','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(42401,'47740','U','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.976389,-87.585504,0,'2013-07-06 12:44:32',NULL,NULL),(11098,'11695','P','Fort Tilden','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.558349,-73.911454,0,'2013-07-06 12:44:30',NULL,NULL),(36797,'41054','P','Williamstown','N','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.578368,-84.584337,0,'2013-07-06 12:44:32',NULL,NULL),(36085,'40217','S','Parkway Vlg','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.217903,-85.741113,0,'2013-07-06 12:44:32',NULL,NULL),(12289,'12846','S','Lake Luzerne','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.326780,-73.820220,0,'2013-07-06 12:44:30',NULL,NULL),(13115,'13486','S','Frenchville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.347210,-75.324999,0,'2013-07-06 12:44:30',NULL,NULL),(29360,'32569','S','Mary Esther','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.412242,-86.717211,0,'2013-07-06 12:44:32',NULL,NULL),(57028,'66207','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(75546,'94237','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585474,-121.493315,0,'2013-07-06 12:44:34',NULL,NULL),(38227,'43227','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.937858,-82.887113,0,'2013-07-06 12:44:32',NULL,NULL),(43763,'49021','S','Bellevue','D','Eaton','26045','Michigan','MI','26','4040','269','Eastern',-5.0,'Y',42.465598,-85.009860,0,'2013-07-06 12:44:32',NULL,NULL),(32574,'36118','U','Gunter AFS-ECI','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.406982,-86.247828,0,'2013-07-06 12:44:32',NULL,NULL),(76960,'96044','S','Hornbrook','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.939820,-122.530020,0,'2013-07-06 12:44:34',NULL,NULL),(9533,'10020','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(61646,'72854','S','Ozone','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.670828,-93.430450,0,'2013-07-06 12:44:33',NULL,NULL),(19026,'19533','S','Fairview Heights','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.440626,-75.974641,0,'2013-07-06 12:44:31',NULL,NULL),(18686,'19187','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954771,-75.167691,0,'2013-07-06 12:44:31',NULL,NULL),(39620,'44883','S','Ink','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.121369,-83.175860,0,'2013-07-06 12:44:32',NULL,NULL),(7315,'06673','U','Promotion Marketing Ser Inc','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.184273,-73.148138,0,'2013-07-06 12:44:30',NULL,NULL),(37934,'42642','S','Webbs Crs Rds','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.055440,-85.091503,0,'2013-07-06 12:44:32',NULL,NULL),(28140,'30820','S','Mitchell','D','Glascock','13125','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.187247,-82.669971,0,'2013-07-06 12:44:31',NULL,NULL),(32494,'36061','P','Banks','A','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.991905,-85.751161,0,'2013-07-06 12:44:32',NULL,NULL),(47969,'55124','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.746620,-93.201840,0,'2013-07-06 12:44:33',NULL,NULL),(61032,'72117','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(62461,'74331','S','Cleora','A','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(63055,'75223','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.789977,-96.752931,0,'2013-07-06 12:44:33',NULL,NULL),(64866,'77058','S','Nassau Bay','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.553866,-95.095044,0,'2013-07-06 12:44:34',NULL,NULL),(55909,'64443','S','Easton','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.764417,-94.661851,0,'2013-07-06 12:44:33',NULL,NULL),(31011,'33778','S','Seminole','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.885994,-82.798166,0,'2013-07-06 12:44:32',NULL,NULL),(46605,'53560','S','Mazomanie','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.188047,-89.758253,0,'2013-07-06 12:44:32',NULL,NULL),(48085,'55334','S','Gaylord','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.554134,-94.216762,0,'2013-07-06 12:44:33',NULL,NULL),(74098,'92202','P','Indio','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.661343,-116.297796,0,'2013-07-06 12:44:34',NULL,NULL),(76117,'95237','S','Lockeford','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.156983,-121.146692,0,'2013-07-06 12:44:34',NULL,NULL),(80116,'99762','P','Golovin','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.787400,-165.197220,0,'2013-07-06 12:44:34',NULL,NULL),(42109,'47465','S','Grant','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.038049,-87.047701,0,'2013-07-06 12:44:32',NULL,NULL),(64888,'77076','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.859606,-95.384462,0,'2013-07-06 12:44:34',NULL,NULL),(41147,'46701','S','Albion','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(29400,'32627','P','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.646353,-82.328199,0,'2013-07-06 12:44:32',NULL,NULL),(51712,'60010','S','Fox River Valley Gardens','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(58929,'69343','S','Clinton','N','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.808801,-102.202166,0,'2013-07-06 12:44:33',NULL,NULL),(39654,'45005','S','Blue Ball','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.528960,-84.297420,0,'2013-07-06 12:44:32',NULL,NULL),(36186,'40255','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.227823,-85.686306,0,'2013-07-06 12:44:32',NULL,NULL),(78092,'97480','S','Swisshome','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.055425,-123.740628,0,'2013-07-06 12:44:34',NULL,NULL),(30331,'33308','S','Sea Ranch Lks','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(16143,'17059','S','Mifflintown','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(49355,'56576','S','Basswood','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.496075,-95.593354,0,'2013-07-06 12:44:33',NULL,NULL),(9821,'10113','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(38208,'43213','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.965354,-82.875172,0,'2013-07-06 12:44:32',NULL,NULL),(26553,'29208','U','University of Sc','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.975039,-81.007842,0,'2013-07-06 12:44:31',NULL,NULL),(49372,'56586','S','Underwood','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.326075,-95.839007,0,'2013-07-06 12:44:33',NULL,NULL),(49485,'56660','S','Mozeppa','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.987810,-94.214799,0,'2013-07-06 12:44:33',NULL,NULL),(68042,'80929','S','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.814846,-104.619185,0,'2013-07-06 12:44:34',NULL,NULL),(68862,'82635','P','Edgerton','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.410816,-106.254934,0,'2013-07-06 12:44:34',NULL,NULL),(77615,'96950','P','Saipan Mariana Islands','N','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',15.181897,145.756677,0,'2013-07-06 12:44:34',NULL,NULL),(56342,'65111','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.551103,-92.118815,0,'2013-07-06 12:44:33',NULL,NULL),(12954,'13357','S','Ilion','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(22927,'24620','S','Hurley','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.417851,-82.017149,0,'2013-07-06 12:44:31',NULL,NULL),(44878,'50313','S','Saydel','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.641599,-93.617602,0,'2013-07-06 12:44:32',NULL,NULL),(67852,'80821','S','Boyero','A','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.942890,-103.269910,0,'2013-07-06 12:44:34',NULL,NULL),(25256,'28115','S','Mazeppa','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.575801,-80.819083,0,'2013-07-06 12:44:31',NULL,NULL),(19097,'19605','S','Muhlenberg','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(4210,'02835','S','Jamestown','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.535161,-71.377788,0,'2013-07-06 12:44:30',NULL,NULL),(41177,'46711','S','Linn Grove','A','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.645000,-85.033056,0,'2013-07-06 12:44:32',NULL,NULL),(17774,'18341','P','Minisink Hls','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.999999,-75.136178,0,'2013-07-06 12:44:31',NULL,NULL),(30942,'33716','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878343,-82.649244,0,'2013-07-06 12:44:32',NULL,NULL),(602,'00680','S','Urb Paraiso De Mayaguez','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(23572,'25653','P','Wilkinson','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.836127,-82.024798,0,'2013-07-06 12:44:31',NULL,NULL),(47746,'55018','S','Dennison','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.407140,-93.018480,0,'2013-07-06 12:44:33',NULL,NULL),(57449,'66845','S','Cottonwd Fls','A','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.365873,-96.545943,0,'2013-07-06 12:44:33',NULL,NULL),(66657,'78853','P','Eagle Pass','D','Maverick','48323','Texas','TX','48','0000','830','Central',-6.0,'Y',28.682171,-100.484060,0,'2013-07-06 12:44:34',NULL,NULL),(67850,'80819','P','Ute Pass','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.932824,-105.016988,0,'2013-07-06 12:44:34',NULL,NULL),(73797,'91749','P','La Puente','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.030733,-117.949992,0,'2013-07-06 12:44:34',NULL,NULL),(78758,'98303','S','Anderson Is','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164386,-122.695768,0,'2013-07-06 12:44:34',NULL,NULL),(49431,'56633','S','Schley','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(21316,'22406','S','Fredericksbg','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(71867,'87718','S','Eagle Nest','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.589838,-105.275134,0,'2013-07-06 12:44:34',NULL,NULL),(57301,'66624','U','Material Distribution Ctr','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.016351,-95.672071,0,'2013-07-06 12:44:33',NULL,NULL),(39961,'45236','S','Rossmoyne','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(11493,'12020','S','West Milton','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(56556,'65466','S','Alley Springs','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(4429,'03237','S','Gilmanton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.415945,-71.406213,0,'2013-07-06 12:44:30',NULL,NULL),(66891,'79245','S','Memphis','D','Hall','48191','Texas','TX','48','0000','806','Central',-6.0,'Y',34.727267,-100.539322,0,'2013-07-06 12:44:34',NULL,NULL),(28681,'31798','S','Wray','D','Irwin','13155','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.595382,-83.109035,0,'2013-07-06 12:44:32',NULL,NULL),(48369,'55558','U','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816260,-93.919928,0,'2013-07-06 12:44:33',NULL,NULL),(38474,'43635','P','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.652535,-83.671321,0,'2013-07-06 12:44:32',NULL,NULL),(8062,'07747','S','Matawan','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.412700,-74.252520,0,'2013-07-06 12:44:30',NULL,NULL),(2147,'00924','S','Urb Vosburg','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(36415,'40533','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.038800,-84.542503,0,'2013-07-06 12:44:32',NULL,NULL),(48263,'55428','S','Brooklyn Park','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(63255,'75488','S','Telephone','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.809494,-96.004066,0,'2013-07-06 12:44:33',NULL,NULL),(64386,'76533','P','Heidenheimer','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.080372,-97.323755,0,'2013-07-06 12:44:34',NULL,NULL),(77197,'96349','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(64232,'76306','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.980770,-98.523004,0,'2013-07-06 12:44:34',NULL,NULL),(61301,'72424','P','Datto','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.381098,-90.723940,0,'2013-07-06 12:44:33',NULL,NULL),(59139,'70167','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.964802,-90.084829,0,'2013-07-06 12:44:33',NULL,NULL),(1598,'00769','S','Urb Coamo Gdns','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(34191,'38330','S','Dyer','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.068208,-89.016996,0,'2013-07-06 12:44:32',NULL,NULL),(66740,'78961','P','Warrenton','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.017222,-96.731667,0,'2013-07-06 12:44:34',NULL,NULL),(71185,'86045','P','Coal Mine Mesa','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.133993,-111.242465,0,'2013-07-06 12:44:34',NULL,NULL),(9935,'10154','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(19491,'20153','P','Chantilly','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.887590,-77.441421,0,'2013-07-06 12:44:31',NULL,NULL),(37063,'41311','S','Old Landing','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(36333,'40391','S','Winchester','D','Clark','21049','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.980177,-84.168803,0,'2013-07-06 12:44:32',NULL,NULL),(55939,'64477','S','Plattsburg','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.562750,-94.455169,0,'2013-07-06 12:44:33',NULL,NULL),(50418,'57785','S','Sturgis','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(28834,'32084','S','Saint Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.885160,-81.313980,0,'2013-07-06 12:44:32',NULL,NULL),(9765,'10104','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(4449,'03247','P','Weirs Beach','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.547500,-71.407222,0,'2013-07-06 12:44:30',NULL,NULL),(10173,'10281','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(26112,'28724','P','Dana','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.329055,-82.374461,0,'2013-07-06 12:44:31',NULL,NULL),(58120,'68128','S','Lavista','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.183889,-96.030833,0,'2013-07-06 12:44:33',NULL,NULL),(76176,'95328','S','Keyes','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.560712,-120.913563,0,'2013-07-06 12:44:34',NULL,NULL),(76918,'96006','S','Adin','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.202807,-120.938418,0,'2013-07-06 12:44:34',NULL,NULL),(80191,'99918','P','Coffman Cove','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.358140,-131.698840,0,'2013-07-06 12:44:34',NULL,NULL),(9461,'10008','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(60150,'71375','S','Waterproof','D','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(58285,'68410','S','Nebraska City','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.674994,-95.861844,0,'2013-07-06 12:44:33',NULL,NULL),(51616,'59837','S','Hall','D','Granite','30039','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.396225,-113.279865,0,'2013-07-06 12:44:33',NULL,NULL),(51234,'59066','P','Pryor','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.420790,-108.529611,0,'2013-07-06 12:44:33',NULL,NULL),(27070,'29693','S','Madison','A','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.642443,-83.088445,0,'2013-07-06 12:44:31',NULL,NULL),(45252,'50659','S','North Washington','A','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.062151,-92.314419,0,'2013-07-06 12:44:32',NULL,NULL),(19012,'19529','S','Jacksonville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(24819,'27604','S','Wilders Grove','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.866620,-78.531900,0,'2013-07-06 12:44:31',NULL,NULL),(77663,'97024','S','Interlachen','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.539229,-122.437076,0,'2013-07-06 12:44:34',NULL,NULL),(64036,'76126','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.586584,-97.538996,0,'2013-07-06 12:44:34',NULL,NULL),(257,'00638','S','Urb Monte Rey','N','Ciales','72039','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.338774,-66.466418,0,'2013-07-06 12:44:30',NULL,NULL),(43506,'48630','P','Htn Lk Hghts','A','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.325418,-84.774328,0,'2013-07-06 12:44:32',NULL,NULL),(9851,'10118','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(9441,'10005','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(37526,'42048','S','Aurora','N','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.781080,-88.252740,0,'2013-07-06 12:44:32',NULL,NULL),(35097,'39206','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364777,-90.171740,0,'2013-07-06 12:44:32',NULL,NULL),(16393,'17214','S','Blue Ridge Summit','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.730375,-77.470658,0,'2013-07-06 12:44:31',NULL,NULL),(26540,'29204','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.028919,-80.998590,0,'2013-07-06 12:44:31',NULL,NULL),(26134,'28734','S','Iotla','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(12298,'12850','S','Lake Desolation','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.118700,-73.987500,0,'2013-07-06 12:44:30',NULL,NULL),(24321,'27020','S','Marler','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(21854,'23140','S','Providence Forge','D','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.443403,-77.056714,0,'2013-07-06 12:44:31',NULL,NULL),(2874,'00987','S','Bo Buenaventura','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(49074,'56317','P','Buckman','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.897683,-94.092696,0,'2013-07-06 12:44:33',NULL,NULL),(49898,'57274','S','Lily','A','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.325620,-97.519560,0,'2013-07-06 12:44:33',NULL,NULL),(54066,'62480','S','Hunt City','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.976776,-88.011300,0,'2013-07-06 12:44:33',NULL,NULL),(49273,'56484','S','Whipholt','A','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(15419,'16362','S','Utica','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.486308,-79.931100,0,'2013-07-06 12:44:31',NULL,NULL),(27177,'29844','P','Parksville','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.786637,-82.217188,0,'2013-07-06 12:44:31',NULL,NULL),(79512,'98926','S','Ellensburg','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.999556,-120.542589,0,'2013-07-06 12:44:34',NULL,NULL),(14095,'14620','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.132792,-77.600284,0,'2013-07-06 12:44:31',NULL,NULL),(25900,'28644','S','Laurel Spgs','A','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.448151,-81.252551,0,'2013-07-06 12:44:31',NULL,NULL),(23282,'25161','S','Powellton','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.097121,-81.323113,0,'2013-07-06 12:44:31',NULL,NULL),(66743,'78962','S','Weimar','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.685660,-96.728400,0,'2013-07-06 12:44:34',NULL,NULL),(67428,'80161','P','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.596945,-104.961633,0,'2013-07-06 12:44:34',NULL,NULL),(2586,'00961','S','Ind Luchetti','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(3196,'01346','S','Heath','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.672720,-72.834420,0,'2013-07-06 12:44:30',NULL,NULL),(37127,'41465','S','Bethanna','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(34976,'39088','S','Holly Bluff','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.832419,-90.698675,0,'2013-07-06 12:44:32',NULL,NULL),(40563,'45861','P','Melrose','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.091358,-84.420370,0,'2013-07-06 12:44:32',NULL,NULL),(9995,'10166','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(59806,'71225','S','Forksville','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.527647,-92.314023,0,'2013-07-06 12:44:33',NULL,NULL),(64073,'76140','S','Forest Hill','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.612498,-97.271398,0,'2013-07-06 12:44:34',NULL,NULL),(73120,'90263','U','Malibu','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.006202,-118.810015,0,'2013-07-06 12:44:34',NULL,NULL),(74611,'92712','P','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.749620,-117.874983,0,'2013-07-06 12:44:34',NULL,NULL),(63449,'75680','P','Minden','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.147707,-94.798976,0,'2013-07-06 12:44:33',NULL,NULL),(61264,'72368','S','Moro','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.763741,-90.766708,0,'2013-07-06 12:44:33',NULL,NULL),(51596,'59820','S','Alberton','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.006105,-114.508962,0,'2013-07-06 12:44:33',NULL,NULL),(44160,'49534','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.976900,-85.768900,0,'2013-07-06 12:44:32',NULL,NULL),(4967,'04108','S','Peaks Island','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.663288,-70.190829,0,'2013-07-06 12:44:30',NULL,NULL),(26787,'29453','S','Jamestown','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.197783,-79.691205,0,'2013-07-06 12:44:31',NULL,NULL),(5852,'05101','S','Rockingham','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185420,-72.488580,0,'2013-07-06 12:44:30',NULL,NULL),(13674,'14036','S','Corfu','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.972006,-78.383842,0,'2013-07-06 12:44:31',NULL,NULL),(14700,'15260','S','Univ of Pittsburgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441234,-79.945700,0,'2013-07-06 12:44:31',NULL,NULL),(20564,'21133','S','McDonogh Run','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.369846,-76.802416,0,'2013-07-06 12:44:31',NULL,NULL),(75014,'93460','S','Santa Ynez','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.637026,-120.073744,0,'2013-07-06 12:44:34',NULL,NULL),(76296,'95437','S','Inglenook','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(76640,'95717','P','Magra','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.164539,-120.859208,0,'2013-07-06 12:44:34',NULL,NULL),(59142,'70172','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.955546,-90.072693,0,'2013-07-06 12:44:33',NULL,NULL),(19557,'20203','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904541,-77.045041,0,'2013-07-06 12:44:31',NULL,NULL),(54516,'62872','S','Opdyke','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.276278,-88.754542,0,'2013-07-06 12:44:33',NULL,NULL),(72835,'89831','S','Patsville','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.853920,-115.956750,0,'2013-07-06 12:44:34',NULL,NULL),(48398,'55586','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.279628,-93.806902,0,'2013-07-06 12:44:33',NULL,NULL),(9869,'10121','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(14819,'15423','S','Coal Center','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.087540,-79.914422,0,'2013-07-06 12:44:31',NULL,NULL),(13430,'13758','P','E Pharsalia','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.555016,-75.716571,0,'2013-07-06 12:44:31',NULL,NULL),(10232,'10463','S','Spuyten Duyvil','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.881512,-73.907521,0,'2013-07-06 12:44:30',NULL,NULL),(42030,'47438','S','Howesville','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(57879,'67622','S','Almena','D','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.893457,-99.707325,0,'2013-07-06 12:44:33',NULL,NULL),(56502,'65340','S','Marshall Junction','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.114311,-93.196522,0,'2013-07-06 12:44:33',NULL,NULL),(55118,'63336','S','Paynesville','A','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.367306,-90.901583,0,'2013-07-06 12:44:33',NULL,NULL),(31213,'33953','S','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.000048,-82.209983,0,'2013-07-06 12:44:32',NULL,NULL),(76938,'96023','S','Dorris','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.970671,-121.937185,0,'2013-07-06 12:44:34',NULL,NULL),(1950,'00803','P','Charlotte Ama','A','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350330,-64.935572,0,'2013-07-06 12:44:30',NULL,NULL),(7955,'07676','S','Washington Township','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(22252,'23667','U','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.009530,-76.385641,0,'2013-07-06 12:44:31',NULL,NULL),(47067,'54424','S','Neva Corners','N','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.242450,-89.156160,0,'2013-07-06 12:44:32',NULL,NULL),(51042,'58730','S','Crosby','D','Divide','38023','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.913050,-103.296401,0,'2013-07-06 12:44:33',NULL,NULL),(73945,'92055','S','Cmp Pendleton','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.291239,-117.301241,0,'2013-07-06 12:44:34',NULL,NULL),(77354,'96732','S','Kahului','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.883882,-156.475338,0,'2013-07-06 12:44:34',NULL,NULL),(1882,'00791','S','Urb Rivera Donato','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(63140,'75368','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.920785,-96.974939,0,'2013-07-06 12:44:33',NULL,NULL),(13519,'13813','S','Nineveh','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.154740,-75.542760,0,'2013-07-06 12:44:31',NULL,NULL),(35056,'39181','P','Vburg','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.343713,-90.857460,0,'2013-07-06 12:44:32',NULL,NULL),(45437,'51106','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.468321,-96.358319,0,'2013-07-06 12:44:32',NULL,NULL),(29893,'33043','S','Big Pine Key','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.678501,-81.368387,0,'2013-07-06 12:44:32',NULL,NULL),(66227,'78564','S','Falcon','A','Zapata','48505','Texas','TX','48','0000','956','Central',-6.0,'Y',26.900251,-99.137082,0,'2013-07-06 12:44:34',NULL,NULL),(76584,'95682','S','Latrobe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.656055,-120.961681,0,'2013-07-06 12:44:34',NULL,NULL),(79720,'99213','P','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.656583,-117.291099,0,'2013-07-06 12:44:34',NULL,NULL),(32794,'36426','S','Dixonville','N','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(40949,'46304','S','Burns Harbor','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.617037,-87.028793,0,'2013-07-06 12:44:32',NULL,NULL),(37210,'41522','S','Wolfpit','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(27069,'29692','S','Ware Shoals','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.391023,-82.244579,0,'2013-07-06 12:44:31',NULL,NULL),(65147,'77387','P','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.077102,-95.417741,0,'2013-07-06 12:44:34',NULL,NULL),(69080,'83246','S','Topaz','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.609094,-112.026692,0,'2013-07-06 12:44:34',NULL,NULL),(73155,'90292','S','Venice','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.985510,-118.453180,0,'2013-07-06 12:44:34',NULL,NULL),(73243,'90680','S','Stanton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.799083,-117.995649,0,'2013-07-06 12:44:34',NULL,NULL),(79362,'98647','S','Skamokawa','D','Wahkiakum','53069','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.296971,-123.449654,0,'2013-07-06 12:44:34',NULL,NULL),(53771,'62271','S','Covington','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.418120,-89.524620,0,'2013-07-06 12:44:33',NULL,NULL),(26865,'29541','S','Effingham','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.117509,-79.771376,0,'2013-07-06 12:44:31',NULL,NULL),(43071,'48193','S','Riverview','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(38888,'44110','S','E Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.565195,-81.567100,0,'2013-07-06 12:44:32',NULL,NULL),(56938,'66083','S','Spring Hill','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.732116,-94.808736,0,'2013-07-06 12:44:33',NULL,NULL),(46904,'54128','S','Gresham','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.841941,-88.817707,0,'2013-07-06 12:44:32',NULL,NULL),(18861,'19442','P','Kimberton','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.134638,-75.582908,0,'2013-07-06 12:44:31',NULL,NULL),(72636,'89421','P','McDermitt','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.990819,-117.712764,0,'2013-07-06 12:44:34',NULL,NULL),(3968,'02493','S','Hastings','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(4323,'02917','S','Esmond','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.855160,-71.492220,0,'2013-07-06 12:44:30',NULL,NULL),(9643,'10036','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(29452,'32708','S','Casselberry','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.681020,-81.280800,0,'2013-07-06 12:44:32',NULL,NULL),(28995,'32218','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.461492,-81.625786,0,'2013-07-06 12:44:32',NULL,NULL),(51525,'59711','S','Opportunity','N','Deer Lodge','30023','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.139820,-113.045940,0,'2013-07-06 12:44:33',NULL,NULL),(54051,'62468','S','Toledo','D','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.269624,-88.244943,0,'2013-07-06 12:44:33',NULL,NULL),(54701,'62951','S','Johnston City','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.819324,-88.924585,0,'2013-07-06 12:44:33',NULL,NULL),(54995,'63129','S','Oakville','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.464400,-90.332031,0,'2013-07-06 12:44:33',NULL,NULL),(56327,'65106','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578011,-92.174363,0,'2013-07-06 12:44:33',NULL,NULL),(59747,'71150','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.514610,-93.747269,0,'2013-07-06 12:44:33',NULL,NULL),(32545,'36109','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380663,-86.246181,0,'2013-07-06 12:44:32',NULL,NULL),(57421,'66776','S','Thayer','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.489369,-95.476701,0,'2013-07-06 12:44:33',NULL,NULL),(28555,'31565','S','Waverly','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.047300,-81.577500,0,'2013-07-06 12:44:32',NULL,NULL),(52899,'61356','S','Princeton','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.371332,-89.463511,0,'2013-07-06 12:44:33',NULL,NULL),(52045,'60194','S','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.044152,-88.110153,0,'2013-07-06 12:44:33',NULL,NULL),(21950,'23234','S','Ampthill','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.452407,-77.476225,0,'2013-07-06 12:44:31',NULL,NULL),(73649,'91496','U','Us Purchasing Exchange','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.163186,-118.456615,0,'2013-07-06 12:44:34',NULL,NULL),(1469,'00745','S','Urb Jose Ph Hernandez','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(40918,'46274','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.895207,-86.257246,0,'2013-07-06 12:44:32',NULL,NULL),(62171,'73744','S','Hitchcock','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.969989,-98.351985,0,'2013-07-06 12:44:33',NULL,NULL),(56094,'64776','S','Vista','A','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.040765,-93.704717,0,'2013-07-06 12:44:33',NULL,NULL),(10761,'11362','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761850,-73.729718,0,'2013-07-06 12:44:30',NULL,NULL),(46021,'52544','S','Rathbun','A','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.727537,-92.865109,0,'2013-07-06 12:44:32',NULL,NULL),(63935,'76067','S','Fort Wolters','N','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.826780,-98.097180,0,'2013-07-06 12:44:34',NULL,NULL),(70489,'84770','S','Winchester Hills','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.084694,-113.585569,0,'2013-07-06 12:44:34',NULL,NULL),(3037,'01101','P','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.099922,-72.589584,0,'2013-07-06 12:44:30',NULL,NULL),(9131,'09186','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38682,'43971','S','Yorkville','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.164160,-80.703781,0,'2013-07-06 12:44:32',NULL,NULL),(19350,'20045','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895329,-77.025372,0,'2013-07-06 12:44:31',NULL,NULL),(43812,'49072','S','Mendon','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.006628,-85.460228,0,'2013-07-06 12:44:32',NULL,NULL),(55473,'63747','S','Friedheim','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.556658,-89.843268,0,'2013-07-06 12:44:33',NULL,NULL),(23349,'25260','S','Clifton','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.017584,-82.027784,0,'2013-07-06 12:44:31',NULL,NULL),(45203,'50626','S','Dunkerton','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.577243,-92.168002,0,'2013-07-06 12:44:32',NULL,NULL),(48756,'55975','S','Cherry Grove','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.687315,-92.391053,0,'2013-07-06 12:44:33',NULL,NULL),(57015,'66206','S','Leawood','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(59158,'70195','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.953286,-90.071666,0,'2013-07-06 12:44:33',NULL,NULL),(62217,'73858','S','Shattuck','D','Ellis','40045','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.269773,-99.876079,0,'2013-07-06 12:44:33',NULL,NULL),(73761,'91732','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.074497,-118.011309,0,'2013-07-06 12:44:34',NULL,NULL),(79179,'98520','S','South Aberdeen','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(37450,'41844','S','Hollybush','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369951,-82.827928,0,'2013-07-06 12:44:32',NULL,NULL),(60800,'72031','S','Alread','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(41873,'47362','S','Messick','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(43873,'49130','S','Union','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.785266,-85.852560,0,'2013-07-06 12:44:32',NULL,NULL),(73747,'91716','P','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.003756,-117.974564,0,'2013-07-06 12:44:34',NULL,NULL),(18230,'18970','P','Trumbauersville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.410255,-75.378287,0,'2013-07-06 12:44:31',NULL,NULL),(1746,'00778','S','Urb Sabanera del Rio','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(68661,'81650','S','Rifle','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.540153,-107.790633,0,'2013-07-06 12:44:34',NULL,NULL),(60826,'72035','U','University of Central Ar','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.073922,-92.457553,0,'2013-07-06 12:44:33',NULL,NULL),(38382,'43510','P','Colton','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.447834,-83.972902,0,'2013-07-06 12:44:32',NULL,NULL),(32515,'36083','S','Tuskegee','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.427623,-85.690804,0,'2013-07-06 12:44:32',NULL,NULL),(32445,'36015','P','Chapman','D','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.663525,-86.700217,0,'2013-07-06 12:44:32',NULL,NULL),(43846,'49102','S','Berrien Ctr','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.954134,-86.276203,0,'2013-07-06 12:44:32',NULL,NULL),(44096,'49463','P','Whitehall','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.370564,-86.423252,0,'2013-07-06 12:44:32',NULL,NULL),(56934,'66076','S','Pomona','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.608081,-95.451714,0,'2013-07-06 12:44:33',NULL,NULL),(67478,'80227','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.666540,-105.096180,0,'2013-07-06 12:44:34',NULL,NULL),(39789,'45133','S','Belfast','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(33876,'38019','S','Covington','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.557255,-89.657223,0,'2013-07-06 12:44:32',NULL,NULL),(47862,'55079','S','Stacy','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.397384,-92.987057,0,'2013-07-06 12:44:33',NULL,NULL),(15427,'16368','U','Crossing Pointe','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.848758,-79.146681,0,'2013-07-06 12:44:31',NULL,NULL),(15145,'15857','S','Saint Marys','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.433156,-78.550932,0,'2013-07-06 12:44:31',NULL,NULL),(66725,'78956','S','Dubina','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(70122,'84190','U','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725005,-111.886915,0,'2013-07-06 12:44:34',NULL,NULL),(73757,'91730','S','Rancho Cucamonga','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.099140,-117.581280,0,'2013-07-06 12:44:34',NULL,NULL),(39439,'44689','S','Wilmot','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.657592,-81.635586,0,'2013-07-06 12:44:32',NULL,NULL),(79235,'98550','S','Oyhat','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(70056,'84141','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.668129,-111.861408,0,'2013-07-06 12:44:34',NULL,NULL),(66335,'78604','P','Luling','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.523929,-97.681918,0,'2013-07-06 12:44:34',NULL,NULL),(60240,'71432','S','Zion','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.738200,-92.391755,0,'2013-07-06 12:44:33',NULL,NULL),(55859,'64179','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.123220,-94.555049,0,'2013-07-06 12:44:33',NULL,NULL),(61393,'72538','S','Gepp','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.441864,-92.095472,0,'2013-07-06 12:44:33',NULL,NULL),(32197,'35548','S','Brilliant','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.053064,-87.730084,0,'2013-07-06 12:44:32',NULL,NULL),(27523,'30214','S','Woolsey','A','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.440281,-84.462654,0,'2013-07-06 12:44:31',NULL,NULL),(26752,'29425','U','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.785741,-79.947783,0,'2013-07-06 12:44:31',NULL,NULL),(45136,'50576','S','Rembrandt','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.826983,-95.165096,0,'2013-07-06 12:44:32',NULL,NULL),(11717,'12174','P','Stuyvesant Falls','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.351815,-73.733223,0,'2013-07-06 12:44:30',NULL,NULL),(1983,'00906','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405503,-66.062657,0,'2013-07-06 12:44:30',NULL,NULL),(3910,'02457','P','Babson Park','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.297040,-71.259784,0,'2013-07-06 12:44:30',NULL,NULL),(9868,'10121','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(61163,'72182','P','Plum Bayou','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.445490,-92.038390,0,'2013-07-06 12:44:33',NULL,NULL),(47738,'55012','S','Chisago Lake','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.396474,-92.816791,0,'2013-07-06 12:44:33',NULL,NULL),(560,'00678','S','Camino Los Paganes','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(68653,'81643','S','Mesa','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.147763,-108.131264,0,'2013-07-06 12:44:34',NULL,NULL),(62587,'74468','P','Wainwright','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.616788,-95.565724,0,'2013-07-06 12:44:33',NULL,NULL),(20520,'21090','S','Linthicum','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.205670,-76.657567,0,'2013-07-06 12:44:31',NULL,NULL),(66668,'78880','S','Rocksprings','D','Edwards','48137','Texas','TX','48','0000','830','Central',-6.0,'Y',30.004685,-100.313091,0,'2013-07-06 12:44:34',NULL,NULL),(75268,'93701','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.751098,-119.789664,0,'2013-07-06 12:44:34',NULL,NULL),(6388,'05701','S','Rutland Town','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(68207,'81044','S','Caddoa','A','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.061389,-102.926667,0,'2013-07-06 12:44:34',NULL,NULL),(67048,'79549','S','Clairemont','N','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.764680,-100.858920,0,'2013-07-06 12:44:34',NULL,NULL),(64947,'77230','P','Astrodome','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.698082,-95.384159,0,'2013-07-06 12:44:34',NULL,NULL),(59578,'70893','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.412199,-91.172514,0,'2013-07-06 12:44:33',NULL,NULL),(58036,'68014','S','Bruno','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.264706,-96.967950,0,'2013-07-06 12:44:33',NULL,NULL),(55279,'63468','S','Shelbina','D','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.694269,-92.042102,0,'2013-07-06 12:44:33',NULL,NULL),(52202,'60477','S','Tinley Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.567400,-87.792660,0,'2013-07-06 12:44:33',NULL,NULL),(45462,'51245','S','Primghar','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.083360,-95.641200,0,'2013-07-06 12:44:32',NULL,NULL),(23086,'24910','S','Dawson','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.732200,-80.660640,0,'2013-07-06 12:44:31',NULL,NULL),(33854,'37998','U','Johnson Bible College','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.937584,-83.750480,0,'2013-07-06 12:44:32',NULL,NULL),(37436,'41832','S','Letcher','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.160712,-82.994745,0,'2013-07-06 12:44:32',NULL,NULL),(41704,'47229','S','Tampico','N','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.792996,-85.841879,0,'2013-07-06 12:44:32',NULL,NULL),(52832,'61311','S','Reading','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.050980,-88.930999,0,'2013-07-06 12:44:33',NULL,NULL),(32708,'36280','S','Woodland','D','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.357551,-85.348233,0,'2013-07-06 12:44:32',NULL,NULL),(60283,'71449','S','Toledo Bend','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(58486,'68756','S','Neligh','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.129599,-98.028352,0,'2013-07-06 12:44:33',NULL,NULL),(53682,'62221','S','Swansea','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.550823,-89.984437,0,'2013-07-06 12:44:33',NULL,NULL),(50896,'58540','S','White Shield','A','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.653205,-101.416654,0,'2013-07-06 12:44:33',NULL,NULL),(51515,'59701','S','Rocker','N','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.946740,-112.517340,0,'2013-07-06 12:44:33',NULL,NULL),(70634,'85142','S','Chandler Heights','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.228018,-111.637649,0,'2013-07-06 12:44:34',NULL,NULL),(75003,'93453','S','Sn Margarita','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.365892,-120.392105,0,'2013-07-06 12:44:34',NULL,NULL),(53476,'61938','S','Mattoon','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.481399,-88.374478,0,'2013-07-06 12:44:33',NULL,NULL),(63643,'75844','S','Percilla','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(43449,'48519','S','Southeast','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.989167,-83.615887,0,'2013-07-06 12:44:32',NULL,NULL),(28217,'31033','S','Haddock','D','Jones','13169','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',33.008756,-83.368096,0,'2013-07-06 12:44:31',NULL,NULL),(6276,'05640','S','Adamant','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.329167,-72.503333,0,'2013-07-06 12:44:30',NULL,NULL),(6531,'05830','S','Derby Line','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.001164,-72.103249,0,'2013-07-06 12:44:30',NULL,NULL),(6295,'05651','S','East Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.250409,-72.473242,0,'2013-07-06 12:44:30',NULL,NULL),(9882,'10124','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757053,-73.970342,0,'2013-07-06 12:44:30',NULL,NULL),(9655,'10038','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(41949,'47396','S','Yorktown','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.172376,-85.487338,0,'2013-07-06 12:44:32',NULL,NULL),(6761,'06093','S','W Suffield','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',42.011488,-72.735632,0,'2013-07-06 12:44:30',NULL,NULL),(35944,'40057','S','Cropper','A','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.369196,-85.063919,0,'2013-07-06 12:44:32',NULL,NULL),(54024,'62454','S','Trimble','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(32362,'35894','U','Intergraph Corporation','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.646701,-86.754498,0,'2013-07-06 12:44:32',NULL,NULL),(64970,'77257','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.744580,-95.486171,0,'2013-07-06 12:44:34',NULL,NULL),(57112,'66222','P','Mission','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.023477,-94.648849,0,'2013-07-06 12:44:33',NULL,NULL),(55049,'63145','P','Lambert Airport','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748850,-90.361025,0,'2013-07-06 12:44:33',NULL,NULL),(51877,'60086','U','North Chicago','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.320270,-87.859647,0,'2013-07-06 12:44:33',NULL,NULL),(5456,'04732','S','Garfield Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.626925,-68.418941,0,'2013-07-06 12:44:30',NULL,NULL),(2234,'00926','S','Urb Garcia','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(23140,'24983','S','Union','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.562090,-80.514593,0,'2013-07-06 12:44:31',NULL,NULL),(30764,'33572','S','Apollo Beach','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.771363,-82.391466,0,'2013-07-06 12:44:32',NULL,NULL),(16922,'17603','S','New Danville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(36104,'40220','S','Meadowvw Ests','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(18370,'19046','S','Baederwood','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(38329,'43431','S','Gibsonburg','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.379115,-83.329977,0,'2013-07-06 12:44:32',NULL,NULL),(4340,'03038','S','Londonderry','A','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.888158,-71.298963,0,'2013-07-06 12:44:30',NULL,NULL),(68148,'80997','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.877688,-104.819099,0,'2013-07-06 12:44:34',NULL,NULL),(61188,'72211','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.760749,-92.445427,0,'2013-07-06 12:44:33',NULL,NULL),(52048,'60195','S','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.076320,-88.110120,0,'2013-07-06 12:44:33',NULL,NULL),(48858,'56073','S','Searles','A','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.312771,-94.465735,0,'2013-07-06 12:44:33',NULL,NULL),(74072,'92173','S','San Diego','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.560130,-116.974360,0,'2013-07-06 12:44:34',NULL,NULL),(24841,'27616','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.863033,-78.535615,0,'2013-07-06 12:44:31',NULL,NULL),(79185,'98528','S','Belfair','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.444164,-122.867043,0,'2013-07-06 12:44:34',NULL,NULL),(78353,'98011','S','Bothell','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.755500,-122.191349,0,'2013-07-06 12:44:34',NULL,NULL),(30316,'33305','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.156150,-80.122239,0,'2013-07-06 12:44:32',NULL,NULL),(20104,'20707','S','Laurel','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.101616,-76.884527,0,'2013-07-06 12:44:31',NULL,NULL),(17842,'18424','S','Clifton Twp','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(7178,'06459','U','Wesleyan','N','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.551147,-72.651828,0,'2013-07-06 12:44:30',NULL,NULL),(28123,'30814','S','Harlem','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.414274,-82.313268,0,'2013-07-06 12:44:31',NULL,NULL),(26171,'28747','S','Lake Toxaway','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.146040,-82.933874,0,'2013-07-06 12:44:31',NULL,NULL),(42010,'47431','S','Freedom','D','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.211607,-86.851623,0,'2013-07-06 12:44:32',NULL,NULL),(66728,'78956','S','Glecker','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(67637,'80455','S','Jamestown','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.097980,-105.404295,0,'2013-07-06 12:44:34',NULL,NULL),(441,'00662','S','Urb Figueroa','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(970,'00716','S','Urb Flamboyanes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(9150,'09306','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(22874,'24569','S','Long Island','D','Pittsylvania','51143','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.068332,-79.117191,0,'2013-07-06 12:44:31',NULL,NULL),(24786,'27574','S','Roxboro','D','Person','37145','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.391284,-78.989423,0,'2013-07-06 12:44:31',NULL,NULL),(40883,'46241','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(46283,'53039','S','Juneau','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.395816,-88.684251,0,'2013-07-06 12:44:32',NULL,NULL),(59819,'71234','S','Downsville','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.581980,-92.345100,0,'2013-07-06 12:44:33',NULL,NULL),(60307,'71454','S','Three Bridges','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(72675,'89441','S','Sparks','D','Washoe','32031','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.345519,-119.648215,0,'2013-07-06 12:44:34',NULL,NULL),(73579,'91381','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.381783,-118.573262,0,'2013-07-06 12:44:34',NULL,NULL),(57700,'67335','S','Cherryvale','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.264500,-95.551419,0,'2013-07-06 12:44:33',NULL,NULL),(55711,'64069','P','Liberty','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.241780,-94.417223,0,'2013-07-06 12:44:33',NULL,NULL),(57782,'67470','S','New Cambria','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.905756,-97.498694,0,'2013-07-06 12:44:33',NULL,NULL),(25446,'28318','S','Autryville','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.989808,-78.579363,0,'2013-07-06 12:44:31',NULL,NULL),(38540,'43748','S','Junction City','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.714915,-82.310414,0,'2013-07-06 12:44:32',NULL,NULL),(52019,'60175','S','Saint Charles','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.952674,-88.346033,0,'2013-07-06 12:44:33',NULL,NULL),(79232,'98550','S','New London','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(61285,'72396','S','Wynne','D','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.225405,-90.788153,0,'2013-07-06 12:44:33',NULL,NULL),(27253,'29928','S','Hilton Head Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.161512,-80.752518,0,'2013-07-06 12:44:31',NULL,NULL),(32280,'35652','S','Whitehead','N','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.828765,-87.292792,0,'2013-07-06 12:44:32',NULL,NULL),(33591,'37614','P','East TN State Univ','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.330892,-82.365584,0,'2013-07-06 12:44:32',NULL,NULL),(35428,'39474','S','Prentiss','D','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.595381,-89.875941,0,'2013-07-06 12:44:32',NULL,NULL),(62639,'74565','P','Savanna','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.828744,-95.834824,0,'2013-07-06 12:44:33',NULL,NULL),(69753,'84050','S','Mountain Green','A','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(16035,'17044','S','Bratton','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(62272,'74014','S','Brkn Arw','N','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.054889,-95.716187,0,'2013-07-06 12:44:33',NULL,NULL),(22605,'24210','S','Abingdon','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.707838,-81.978013,0,'2013-07-06 12:44:31',NULL,NULL),(40292,'45440','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(38548,'43754','S','Sycamore Vly','A','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.762764,-81.237672,0,'2013-07-06 12:44:32',NULL,NULL),(32889,'36532','S','Fair Hope','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.500250,-87.868968,0,'2013-07-06 12:44:32',NULL,NULL),(79033,'98396','P','Wilkeson','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.107954,-122.040929,0,'2013-07-06 12:44:34',NULL,NULL),(16651,'17345','S','Strinestown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.073680,-76.730034,0,'2013-07-06 12:44:31',NULL,NULL),(15790,'16923','S','North Bingham','A','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(43373,'48418','S','Byron','D','Shiawassee','26155','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',42.811174,-83.979390,0,'2013-07-06 12:44:32',NULL,NULL),(20958,'21780','S','Sabillasville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.677831,-77.464773,0,'2013-07-06 12:44:31',NULL,NULL),(19621,'20241','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894725,-77.052712,0,'2013-07-06 12:44:31',NULL,NULL),(40392,'45663','S','Portsmouth','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.749260,-82.987860,0,'2013-07-06 12:44:32',NULL,NULL),(6011,'05360','S','Stratton','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.074420,-72.898920,0,'2013-07-06 12:44:30',NULL,NULL),(9073,'09006','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(20100,'20706','S','Glenarden','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.963377,-76.854396,0,'2013-07-06 12:44:31',NULL,NULL),(61896,'73140','P','Midwest City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.464047,-97.383601,0,'2013-07-06 12:44:33',NULL,NULL),(61941,'73160','S','okc','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.381160,-97.475880,0,'2013-07-06 12:44:33',NULL,NULL),(62609,'74531','S','Gerty','A','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.835012,-96.293203,0,'2013-07-06 12:44:33',NULL,NULL),(62649,'74578','S','Higgins','N','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.914894,-95.309389,0,'2013-07-06 12:44:33',NULL,NULL),(66155,'78504','S','McAllen','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.255155,-98.226059,0,'2013-07-06 12:44:34',NULL,NULL),(67066,'79566','S','Wingate','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',32.017027,-100.147498,0,'2013-07-06 12:44:34',NULL,NULL),(69330,'83525','S','Dixie','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.823543,-115.443122,0,'2013-07-06 12:44:34',NULL,NULL),(72377,'89033','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.300750,-115.139908,0,'2013-07-06 12:44:34',NULL,NULL),(80107,'99756','P','Manley Spgs','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.148185,-150.871479,0,'2013-07-06 12:44:34',NULL,NULL),(59302,'70510','S','Cow Island','A','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.904840,-92.133480,0,'2013-07-06 12:44:33',NULL,NULL),(19795,'20435','U','National Selective Service','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916398,-77.077870,0,'2013-07-06 12:44:31',NULL,NULL),(70350,'84639','P','Levan','D','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.554285,-111.859135,0,'2013-07-06 12:44:34',NULL,NULL),(62889,'75057','S','Lewisville','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.050693,-96.996496,0,'2013-07-06 12:44:33',NULL,NULL),(62636,'74561','S','Quinton','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.108516,-95.511932,0,'2013-07-06 12:44:33',NULL,NULL),(52458,'60675','U','Northern Trust Co','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.880651,-87.630041,0,'2013-07-06 12:44:33',NULL,NULL),(20489,'21052','P','Fort Howard','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.203436,-76.446048,0,'2013-07-06 12:44:31',NULL,NULL),(43887,'49232','S','Camden','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.739730,-84.652695,0,'2013-07-06 12:44:32',NULL,NULL),(71469,'87059','S','Sedillo','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.015760,-106.279680,0,'2013-07-06 12:44:34',NULL,NULL),(7513,'07002','S','Bayonne','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.664207,-74.122276,0,'2013-07-06 12:44:30',NULL,NULL),(11338,'11792','S','Wildwood','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.945440,-72.835020,0,'2013-07-06 12:44:30',NULL,NULL),(38662,'43945','S','Salineville','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.640246,-80.828749,0,'2013-07-06 12:44:32',NULL,NULL),(32575,'36118','U','Gunter ECI','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.406982,-86.247828,0,'2013-07-06 12:44:32',NULL,NULL),(32462,'36029','S','Fitzpatrick','D','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.179055,-85.901826,0,'2013-07-06 12:44:32',NULL,NULL),(26322,'29046','P','Elliott','D','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.115037,-80.183743,0,'2013-07-06 12:44:31',NULL,NULL),(48646,'55902','S','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.000389,-92.492318,0,'2013-07-06 12:44:33',NULL,NULL),(52567,'60960','S','Clarence','A','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.464320,-87.896604,0,'2013-07-06 12:44:33',NULL,NULL),(67039,'79545','S','Pyron','N','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.440465,-100.529095,0,'2013-07-06 12:44:34',NULL,NULL),(68807,'82434','S','Otto','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.409748,-108.289207,0,'2013-07-06 12:44:34',NULL,NULL),(13848,'14225','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927300,-78.747480,0,'2013-07-06 12:44:31',NULL,NULL),(38813,'44073','U','Asm International','N','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.466851,-81.339894,0,'2013-07-06 12:44:32',NULL,NULL),(12393,'12926','S','Constable','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.947620,-74.337300,0,'2013-07-06 12:44:30',NULL,NULL),(11732,'12181','P','Troy','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.731923,-73.686799,0,'2013-07-06 12:44:30',NULL,NULL),(24126,'26554','S','Fairmont','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(35645,'39641','S','Bristers Store','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(41781,'47305','S','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.193779,-85.384433,0,'2013-07-06 12:44:32',NULL,NULL),(32388,'35951','S','Albertville','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.267171,-86.210937,0,'2013-07-06 12:44:32',NULL,NULL),(65267,'77474','S','Frydek','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.783576,-96.158093,0,'2013-07-06 12:44:34',NULL,NULL),(39412,'44666','S','North Lawrence','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.832808,-81.615396,0,'2013-07-06 12:44:32',NULL,NULL),(23354,'25265','P','New Haven','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.985473,-81.959404,0,'2013-07-06 12:44:31',NULL,NULL),(9200,'09461','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(741,'00690','S','Urb San Antonio','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(16438,'17235','P','Marion','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.860111,-77.698187,0,'2013-07-06 12:44:31',NULL,NULL),(34889,'38947','P','North Carrollton','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.519480,-89.919278,0,'2013-07-06 12:44:32',NULL,NULL),(32127,'35443','S','Mount Hebron','N','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.763781,-88.025971,0,'2013-07-06 12:44:32',NULL,NULL),(47299,'54550','S','Montreal','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.415615,-90.262829,0,'2013-07-06 12:44:32',NULL,NULL),(51553,'59740','P','McAllister','N','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.448495,-111.784925,0,'2013-07-06 12:44:33',NULL,NULL),(67891,'80864','S','Edison','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.751983,-104.200640,0,'2013-07-06 12:44:34',NULL,NULL),(72797,'89704','S','Washoe Valley','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.283073,-119.794595,0,'2013-07-06 12:44:34',NULL,NULL),(35435,'39476','S','McSwain','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(60796,'72028','P','Choctaw','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.521105,-92.417740,0,'2013-07-06 12:44:33',NULL,NULL),(46432,'53202','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.048572,-87.896280,0,'2013-07-06 12:44:32',NULL,NULL),(29260,'32455','S','Red Bay','A','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.771038,-85.953835,0,'2013-07-06 12:44:32',NULL,NULL),(19135,'19609','S','Wyomissing Hills','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(17436,'17932','U','Frackville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.782690,-76.232139,0,'2013-07-06 12:44:31',NULL,NULL),(21469,'22630','S','Front Royal','D','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.946389,-78.199722,0,'2013-07-06 12:44:31',NULL,NULL),(13201,'13624','S','Grindstone','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.239325,-76.080450,0,'2013-07-06 12:44:30',NULL,NULL),(45342,'50940','U','Communications Data Service','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585359,-93.629011,0,'2013-07-06 12:44:32',NULL,NULL),(11101,'11697','S','Far Rockaway','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.556389,-73.926667,0,'2013-07-06 12:44:30',NULL,NULL),(71484,'87072','P','Cochiti Publo','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.609104,-106.344513,0,'2013-07-06 12:44:34',NULL,NULL),(72096,'88211','P','Artesia','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.838496,-104.425434,0,'2013-07-06 12:44:34',NULL,NULL),(36924,'41146','S','Hitchins','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.236656,-82.919076,0,'2013-07-06 12:44:32',NULL,NULL),(34276,'38474','S','Mt Pleasant','A','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.536870,-87.207199,0,'2013-07-06 12:44:32',NULL,NULL),(32790,'36425','S','Beatrice','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.746433,-87.105274,0,'2013-07-06 12:44:32',NULL,NULL),(6236,'05491','S','Potash Bay','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(37496,'42027','S','Boaz','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.954599,-88.641856,0,'2013-07-06 12:44:32',NULL,NULL),(74411,'92543','S','Hemet','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.703050,-116.976717,0,'2013-07-06 12:44:34',NULL,NULL),(59141,'70170','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.951633,-90.071628,0,'2013-07-06 12:44:33',NULL,NULL),(19567,'20210','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889938,-77.012346,0,'2013-07-06 12:44:31',NULL,NULL),(13763,'14133','P','Sandusky','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.499653,-78.378886,0,'2013-07-06 12:44:31',NULL,NULL),(7619,'07057','S','Wallington','D','Bergen','34003','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.854569,-74.107540,0,'2013-07-06 12:44:30',NULL,NULL),(17506,'17963','S','Lincoln Colliery','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(26227,'28803','S','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.548613,-82.522312,0,'2013-07-06 12:44:31',NULL,NULL),(36628,'41002','S','Augusta','D','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.770754,-84.002867,0,'2013-07-06 12:44:32',NULL,NULL),(77146,'96161','S','Northstar','A','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(76841,'95963','S','Orland','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.745762,-122.190763,0,'2013-07-06 12:44:34',NULL,NULL),(75396,'94005','S','Brisbane','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.687731,-122.404012,0,'2013-07-06 12:44:34',NULL,NULL),(72817,'89815','S','Spring Creek','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.551508,-115.576891,0,'2013-07-06 12:44:34',NULL,NULL),(55057,'63155','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.630199,-90.204551,0,'2013-07-06 12:44:33',NULL,NULL),(19039,'19539','S','Mertztown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(13213,'13631','P','Denmark','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.900363,-75.585290,0,'2013-07-06 12:44:30',NULL,NULL),(13387,'13744','S','Castle Creek','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.225902,-75.928088,0,'2013-07-06 12:44:31',NULL,NULL),(52164,'60455','S','Bedford Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.737459,-87.803915,0,'2013-07-06 12:44:33',NULL,NULL),(24089,'26504','P','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.630371,-79.957848,0,'2013-07-06 12:44:31',NULL,NULL),(69473,'83660','S','Parma','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.774723,-116.935468,0,'2013-07-06 12:44:34',NULL,NULL),(18814,'19405','S','Bridgeport','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.103400,-75.341700,0,'2013-07-06 12:44:31',NULL,NULL),(63905,'76031','S','Cleburne','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.348683,-97.392831,0,'2013-07-06 12:44:34',NULL,NULL),(66345,'78609','S','Buchanan Dam','D','Llano','48299','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.798498,-98.465383,0,'2013-07-06 12:44:34',NULL,NULL),(36005,'40150','S','Lebanon Jctn','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.853195,-85.729211,0,'2013-07-06 12:44:32',NULL,NULL),(78078,'97469','S','Riddle','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.953638,-123.371150,0,'2013-07-06 12:44:34',NULL,NULL),(46922,'54150','S','Neopit','D','Menominee','55078','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.988343,-88.859236,0,'2013-07-06 12:44:32',NULL,NULL),(44087,'49457','S','Twin Lake','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.359781,-86.176186,0,'2013-07-06 12:44:32',NULL,NULL),(42928,'48114','S','Genoa Twp','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.529992,-83.782845,0,'2013-07-06 12:44:32',NULL,NULL),(27622,'30309','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.788039,-84.385689,0,'2013-07-06 12:44:31',NULL,NULL),(32256,'35618','S','N Courtland','A','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.652816,-87.299297,0,'2013-07-06 12:44:32',NULL,NULL),(2900,'00987','S','Urb Los Colobos','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(15643,'16733','P','Hazel Hurst','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.705754,-78.585227,0,'2013-07-06 12:44:31',NULL,NULL),(35977,'40111','S','Cloverport','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.832364,-86.631000,0,'2013-07-06 12:44:32',NULL,NULL),(27578,'30272','P','Red Oak','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.610004,-84.512219,0,'2013-07-06 12:44:31',NULL,NULL),(14445,'15096','U','Soc Auto Engineers','N','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.651942,-80.093281,0,'2013-07-06 12:44:31',NULL,NULL),(61156,'72176','S','Sylvania','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.018174,-91.946490,0,'2013-07-06 12:44:33',NULL,NULL),(24976,'27850','S','Littleton','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.517439,-77.947612,0,'2013-07-06 12:44:31',NULL,NULL),(79154,'98504','U','Washington State Department','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.021117,-122.868044,0,'2013-07-06 12:44:34',NULL,NULL),(61693,'72949','S','Ozark','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.490486,-93.838570,0,'2013-07-06 12:44:33',NULL,NULL),(61389,'72534','S','Floral','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.605698,-91.730413,0,'2013-07-06 12:44:33',NULL,NULL),(47322,'54559','S','Saxon','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.522463,-90.556240,0,'2013-07-06 12:44:32',NULL,NULL),(59548,'70822','U','La Dept of Revenue','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.450296,-91.129317,0,'2013-07-06 12:44:33',NULL,NULL),(76308,'95446','S','Guerneville','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.494075,-122.982674,0,'2013-07-06 12:44:34',NULL,NULL),(79914,'99603','S','Kachemak','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(12008,'12495','S','Willow','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.091198,-74.202183,0,'2013-07-06 12:44:30',NULL,NULL),(56354,'65202','S','Prathersville','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(24226,'26726','S','Keyser','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.437003,-78.981107,0,'2013-07-06 12:44:31',NULL,NULL),(28945,'32182','P','Orange Spgs','A','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.480155,-81.940776,0,'2013-07-06 12:44:32',NULL,NULL),(34025,'38130','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.032451,-89.938116,0,'2013-07-06 12:44:32',NULL,NULL),(10985,'11547','P','Glenwood Landing','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.829786,-73.644155,0,'2013-07-06 12:44:30',NULL,NULL),(35879,'39862','S','Leary','D','Calhoun','13037','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.524345,-84.506321,0,'2013-07-06 12:44:32',NULL,NULL),(38807,'44068','P','N Kingsville','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.905833,-80.690556,0,'2013-07-06 12:44:32',NULL,NULL),(4382,'03102','S','Pinardville','N','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.975161,-71.506713,0,'2013-07-06 12:44:30',NULL,NULL),(35121,'39212','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.243548,-90.263734,0,'2013-07-06 12:44:32',NULL,NULL),(52614,'61030','S','Haldane','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.116467,-89.581432,0,'2013-07-06 12:44:33',NULL,NULL),(13366,'13733','S','Coventryville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.304440,-75.480180,0,'2013-07-06 12:44:31',NULL,NULL),(716,'00687','S','Parc Torrecillas','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(77052,'96114','S','Janesville','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.283659,-120.476457,0,'2013-07-06 12:44:34',NULL,NULL),(68302,'81091','S','Weston','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(60917,'72080','S','Lost Corner','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.395533,-92.806007,0,'2013-07-06 12:44:33',NULL,NULL),(54187,'62626','S','Womac','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.282298,-89.878029,0,'2013-07-06 12:44:33',NULL,NULL),(43304,'48346','S','Independence Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722381,-83.418152,0,'2013-07-06 12:44:32',NULL,NULL),(21353,'22436','S','Supply','A','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.978173,-76.944159,0,'2013-07-06 12:44:31',NULL,NULL),(7764,'07405','S','Lindy Lake','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(38167,'43152','S','South Bloomingville','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.407940,-82.611540,0,'2013-07-06 12:44:32',NULL,NULL),(38306,'43351','S','Upper Sandusky','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.815480,-83.310120,0,'2013-07-06 12:44:32',NULL,NULL),(16199,'17070','S','New Cumberland','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(39805,'45140','S','Loveland','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(16902,'17584','S','Herrville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.962325,-76.274759,0,'2013-07-06 12:44:31',NULL,NULL),(61660,'72906','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.330629,-94.396602,0,'2013-07-06 12:44:33',NULL,NULL),(56972,'66160','U','Kansas University Med Center','N','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.058215,-94.609992,0,'2013-07-06 12:44:33',NULL,NULL),(39651,'45003','S','College Cor','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.586561,-84.786665,0,'2013-07-06 12:44:32',NULL,NULL),(6104,'05453','P','Essex Jct','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.492901,-73.081591,0,'2013-07-06 12:44:30',NULL,NULL),(10480,'10952','S','Kaser','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.114522,-74.077510,0,'2013-07-06 12:44:30',NULL,NULL),(77180,'96309','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(72241,'88517','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810543,-106.415682,0,'2013-07-06 12:44:34',NULL,NULL),(64392,'76537','S','Theon','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.788880,-97.606020,0,'2013-07-06 12:44:34',NULL,NULL),(55583,'63901','S','Poplar Bluff','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.760411,-90.402714,0,'2013-07-06 12:44:33',NULL,NULL),(50249,'57626','S','Maurine','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(50015,'57385','S','Woonsocket','D','Sanborn','46111','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.067170,-98.211946,0,'2013-07-06 12:44:33',NULL,NULL),(13098,'13475','S','Van Hornesvle','A','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.895000,-74.828056,0,'2013-07-06 12:44:30',NULL,NULL),(27051,'29675','P','Richland','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.704787,-83.020014,0,'2013-07-06 12:44:31',NULL,NULL),(30589,'33418','S','West Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855526,-80.144330,0,'2013-07-06 12:44:32',NULL,NULL),(15563,'16639','S','Fallentimber','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.663089,-78.489248,0,'2013-07-06 12:44:31',NULL,NULL),(16995,'17728','S','Powys','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(2666,'00966','S','Urb Suchville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(7576,'07030','S','Uptown','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.747748,-74.033860,0,'2013-07-06 12:44:30',NULL,NULL),(79327,'98607','S','Camas','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.614294,-122.413462,0,'2013-07-06 12:44:34',NULL,NULL),(37370,'41731','S','Leatherwood','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.124133,-83.036516,0,'2013-07-06 12:44:32',NULL,NULL),(61311,'72434','S','Imboden','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.180475,-91.194025,0,'2013-07-06 12:44:33',NULL,NULL),(11986,'12474','S','Hubbell Cors','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.287672,-74.561318,0,'2013-07-06 12:44:30',NULL,NULL),(48870,'56084','P','Searles','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.227290,-94.433366,0,'2013-07-06 12:44:33',NULL,NULL),(43981,'49331','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.948478,-85.359091,0,'2013-07-06 12:44:32',NULL,NULL),(42392,'47728','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.946514,-87.527325,0,'2013-07-06 12:44:32',NULL,NULL),(64983,'77271','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.659656,-95.526379,0,'2013-07-06 12:44:34',NULL,NULL),(67306,'80020','S','Westminster','A','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.934680,-105.076620,0,'2013-07-06 12:44:34',NULL,NULL),(16277,'17099','S','Yeagertown','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.640569,-77.579797,0,'2013-07-06 12:44:31',NULL,NULL),(67680,'80504','S','Niwot','A','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.160065,-104.966226,0,'2013-07-06 12:44:34',NULL,NULL),(63706,'75886','U','Tennessee Colony','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.836617,-95.838882,0,'2013-07-06 12:44:34',NULL,NULL),(60635,'71901','S','Ozark Lithia','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(60488,'71660','S','Hebron','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.763918,-92.192406,0,'2013-07-06 12:44:33',NULL,NULL),(51559,'59747','P','Pony','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.605632,-111.932296,0,'2013-07-06 12:44:33',NULL,NULL),(48160,'55374','S','Hassan','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.173877,-93.567994,0,'2013-07-06 12:44:33',NULL,NULL),(45332,'50860','S','Delphos','A','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.605151,-94.356644,0,'2013-07-06 12:44:32',NULL,NULL),(22150,'23458','P','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.853343,-75.975659,0,'2013-07-06 12:44:31',NULL,NULL),(1667,'00773','S','Urb Paisaje del Lago','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(3096,'01224','S','Berkshire','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.489291,-73.195563,0,'2013-07-06 12:44:30',NULL,NULL),(5047,'04267','P','N Waterford','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.207261,-70.716893,0,'2013-07-06 12:44:30',NULL,NULL),(38776,'44054','S','Lorain','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(34387,'38618','S','Evansville','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(36272,'40336','S','West Irvine','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(6336,'05667','S','Plainfield','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.243569,-72.409078,0,'2013-07-06 12:44:30',NULL,NULL),(13107,'13480','S','Waterville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.930337,-75.378181,0,'2013-07-06 12:44:30',NULL,NULL),(21580,'22840','S','Massanutten','A','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.404045,-78.719342,0,'2013-07-06 12:44:31',NULL,NULL),(23279,'25159','S','Poca','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.468640,-81.782100,0,'2013-07-06 12:44:31',NULL,NULL),(45416,'51052','S','Salix','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.304178,-96.275313,0,'2013-07-06 12:44:32',NULL,NULL),(66081,'78391','S','Tynan','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.171961,-97.748240,0,'2013-07-06 12:44:34',NULL,NULL),(68759,'82240','S','Prairie Ctr','A','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.065743,-104.183152,0,'2013-07-06 12:44:34',NULL,NULL),(68760,'82240','S','Torrington','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.065743,-104.183152,0,'2013-07-06 12:44:34',NULL,NULL),(73073,'90201','S','Bell','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.969157,-118.172903,0,'2013-07-06 12:44:34',NULL,NULL),(77724,'97065','S','Biggs','N','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.593945,-120.695798,0,'2013-07-06 12:44:34',NULL,NULL),(427,'00662','S','Sect La Pra','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(57548,'67029','S','Coldwater','D','Comanche','20033','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.268276,-99.320591,0,'2013-07-06 12:44:33',NULL,NULL),(57235,'66516','S','Netawaka','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.607386,-95.734371,0,'2013-07-06 12:44:33',NULL,NULL),(47247,'54517','S','Clam Lake','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.269533,-90.901740,0,'2013-07-06 12:44:32',NULL,NULL),(24735,'27523','S','Apex','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.713062,-78.823781,0,'2013-07-06 12:44:31',NULL,NULL),(21845,'23131','P','Ordinary','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.314816,-76.514907,0,'2013-07-06 12:44:31',NULL,NULL),(32929,'36559','P','Montrose','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.565959,-87.901959,0,'2013-07-06 12:44:32',NULL,NULL),(67863,'80827','S','Lake George','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.063720,-105.486840,0,'2013-07-06 12:44:34',NULL,NULL),(3493,'01843','S','South Lawrence','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.692019,-71.164643,0,'2013-07-06 12:44:30',NULL,NULL),(60894,'72069','S','Palmer','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(53325,'61745','S','Randolph','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.318102,-88.971388,0,'2013-07-06 12:44:33',NULL,NULL),(45085,'50532','S','Duncombe','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.470067,-93.993314,0,'2013-07-06 12:44:32',NULL,NULL),(34948,'39057','S','Conehatta','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.475021,-89.318100,0,'2013-07-06 12:44:32',NULL,NULL),(24461,'27230','P','Cedar Falls','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.752858,-79.731626,0,'2013-07-06 12:44:31',NULL,NULL),(74296,'92372','S','Pinon Hills','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.442809,-117.636179,0,'2013-07-06 12:44:34',NULL,NULL),(161,'00617','S','Villas de la Sabana','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(10701,'11226','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.647083,-73.954915,0,'2013-07-06 12:44:30',NULL,NULL),(4367,'03070','S','New Boston','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.978338,-71.696741,0,'2013-07-06 12:44:30',NULL,NULL),(42418,'47802','S','Marywood','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(38253,'43279','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.966103,-83.025448,0,'2013-07-06 12:44:32',NULL,NULL),(36295,'40359','S','Gratz','A','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.478600,-84.814080,0,'2013-07-06 12:44:32',NULL,NULL),(49784,'57101','P','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.601314,-96.704854,0,'2013-07-06 12:44:33',NULL,NULL),(55348,'63559','S','Low Ground','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(58762,'68964','S','Oak','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.261972,-97.878336,0,'2013-07-06 12:44:33',NULL,NULL),(78367,'98021','S','Kennard Corner','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791648,-122.217445,0,'2013-07-06 12:44:34',NULL,NULL),(19627,'20245','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892480,-77.045778,0,'2013-07-06 12:44:31',NULL,NULL),(8135,'07834','S','Denville','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.888195,-74.484822,0,'2013-07-06 12:44:30',NULL,NULL),(12456,'12970','S','Paul Smiths','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.434675,-74.276736,0,'2013-07-06 12:44:30',NULL,NULL),(11252,'11763','S','Gordon Heights','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.825920,-72.986100,0,'2013-07-06 12:44:30',NULL,NULL),(42982,'48144','S','Lambertville','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.753467,-83.627319,0,'2013-07-06 12:44:32',NULL,NULL),(47539,'54817','S','Birchwood','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.619630,-91.595128,0,'2013-07-06 12:44:32',NULL,NULL),(22241,'23651','S','Hampton','A','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.007125,-76.312335,0,'2013-07-06 12:44:31',NULL,NULL),(34807,'38878','S','Vardaman','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(34162,'38260','S','Troy','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.335456,-89.165183,0,'2013-07-06 12:44:32',NULL,NULL),(29099,'32277','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.362941,-81.581889,0,'2013-07-06 12:44:32',NULL,NULL),(69844,'84083','S','Trout Creek','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.738100,-114.021398,0,'2013-07-06 12:44:34',NULL,NULL),(70426,'84731','S','Adamsville','A','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.265985,-112.729199,0,'2013-07-06 12:44:34',NULL,NULL),(70444,'84743','P','Kingston','D','Piute','49031','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.208632,-112.187039,0,'2013-07-06 12:44:34',NULL,NULL),(58555,'68820','S','Boelus','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.120885,-98.684760,0,'2013-07-06 12:44:33',NULL,NULL),(25568,'28425','S','Saint Helena','A','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.550127,-77.935342,0,'2013-07-06 12:44:31',NULL,NULL),(9065,'08933','U','Johnson & Johnson','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.486376,-74.445210,0,'2013-07-06 12:44:30',NULL,NULL),(6257,'05602','S','East Montpelier Center','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(38485,'43660','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.638952,-83.544684,0,'2013-07-06 12:44:32',NULL,NULL),(36864,'41091','S','Hamilton','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.927700,-84.717540,0,'2013-07-06 12:44:32',NULL,NULL),(32584,'36123','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.364931,-86.298471,0,'2013-07-06 12:44:32',NULL,NULL),(14382,'15035','S','East Mc Keesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.380214,-79.806760,0,'2013-07-06 12:44:31',NULL,NULL),(15018,'15677','S','Rector','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.175826,-79.226021,0,'2013-07-06 12:44:31',NULL,NULL),(16668,'17356','S','Pleasant View','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(24626,'27356','S','Star','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.397694,-79.785044,0,'2013-07-06 12:44:31',NULL,NULL),(23043,'24859','P','Pineville','A','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.617318,-81.578242,0,'2013-07-06 12:44:31',NULL,NULL),(49753,'57063','S','Janousek','N','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.951432,-97.665236,0,'2013-07-06 12:44:33',NULL,NULL),(13935,'14430','P','Clarkson','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.235446,-77.925235,0,'2013-07-06 12:44:31',NULL,NULL),(57625,'67137','S','Severy','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.647180,-96.226920,0,'2013-07-06 12:44:33',NULL,NULL),(26844,'29506','S','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.209900,-79.734120,0,'2013-07-06 12:44:31',NULL,NULL),(25555,'28410','U','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.125636,-77.953828,0,'2013-07-06 12:44:31',NULL,NULL),(43038,'48174','S','Romulus','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.215215,-83.344726,0,'2013-07-06 12:44:32',NULL,NULL),(23579,'25666','S','Breeden','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.922409,-82.269737,0,'2013-07-06 12:44:31',NULL,NULL),(38054,'43048','P','Mount Liberty','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.350178,-82.630042,0,'2013-07-06 12:44:32',NULL,NULL),(22591,'24175','S','Troutville','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.397461,-79.876477,0,'2013-07-06 12:44:31',NULL,NULL),(37842,'42460','P','Sullivan','D','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.498725,-87.945255,0,'2013-07-06 12:44:32',NULL,NULL),(69965,'84119','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(20573,'21152','S','Glencoe','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.543240,-76.682820,0,'2013-07-06 12:44:31',NULL,NULL),(37213,'41526','P','Fords Branch','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.535969,-82.510334,0,'2013-07-06 12:44:32',NULL,NULL),(33394,'37220','S','Oak Hill','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.067492,-86.781198,0,'2013-07-06 12:44:32',NULL,NULL),(33223,'37061','S','Erin','D','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.289871,-87.748300,0,'2013-07-06 12:44:32',NULL,NULL),(32920,'36556','P','Malcolm','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.232074,-88.063390,0,'2013-07-06 12:44:32',NULL,NULL),(28453,'31410','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.013342,-80.953521,0,'2013-07-06 12:44:32',NULL,NULL),(27709,'30341','S','Chamblee','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.897852,-84.306585,0,'2013-07-06 12:44:31',NULL,NULL),(21547,'22742','S','Sumerduck','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.453208,-77.707748,0,'2013-07-06 12:44:31',NULL,NULL),(46163,'52730','S','Camanche','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.785818,-90.261710,0,'2013-07-06 12:44:32',NULL,NULL),(58585,'68837','S','Elyria','D','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.695233,-99.068791,0,'2013-07-06 12:44:33',NULL,NULL),(68011,'80923','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.899457,-104.699208,0,'2013-07-06 12:44:34',NULL,NULL),(68531,'81413','S','Cedaredge','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.957100,-107.913960,0,'2013-07-06 12:44:34',NULL,NULL),(59444,'70721','S','Carville','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.217565,-91.116119,0,'2013-07-06 12:44:33',NULL,NULL),(54502,'62865','S','Urbain','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.989180,-89.109184,0,'2013-07-06 12:44:33',NULL,NULL),(45499,'51360','S','Crandalls Lodge','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(13866,'14231','P','Williamsville','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980390,-78.737853,0,'2013-07-06 12:44:31',NULL,NULL),(22374,'23923','S','Charlotte Court House','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.091464,-78.658894,0,'2013-07-06 12:44:31',NULL,NULL),(74027,'92132','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.719559,-117.166765,0,'2013-07-06 12:44:34',NULL,NULL),(76480,'95628','S','Fair Oaks','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.652240,-121.255592,0,'2013-07-06 12:44:34',NULL,NULL),(76815,'95954','S','Magalia','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.835983,-121.595496,0,'2013-07-06 12:44:34',NULL,NULL),(78866,'98349','S','Herron Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.280780,-122.773440,0,'2013-07-06 12:44:34',NULL,NULL),(38821,'44077','S','Concord Twp','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.750000,-81.283333,0,'2013-07-06 12:44:32',NULL,NULL),(55876,'64198','U','Federal Reserve','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.101834,-94.582276,0,'2013-07-06 12:44:33',NULL,NULL),(74632,'92808','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.857901,-117.751326,0,'2013-07-06 12:44:34',NULL,NULL),(58100,'68112','S','Florence','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.338789,-95.974358,0,'2013-07-06 12:44:33',NULL,NULL),(8515,'08104','S','Haddon Twp','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.919931,-75.108157,0,'2013-07-06 12:44:30',NULL,NULL),(41400,'46808','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.101060,-85.170092,0,'2013-07-06 12:44:32',NULL,NULL),(35968,'40076','S','Waddy','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.149878,-85.061480,0,'2013-07-06 12:44:32',NULL,NULL),(57242,'66522','S','Oneida','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.871331,-95.957222,0,'2013-07-06 12:44:33',NULL,NULL),(60052,'71350','S','Cocoville','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.083712,-92.022496,0,'2013-07-06 12:44:33',NULL,NULL),(63977,'76107','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.743320,-97.380480,0,'2013-07-06 12:44:34',NULL,NULL),(65007,'77301','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.311394,-95.433846,0,'2013-07-06 12:44:34',NULL,NULL),(69036,'83221','S','Blackfoot','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(71909,'87801','S','Luis Lopez','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.006320,-106.793820,0,'2013-07-06 12:44:34',NULL,NULL),(63736,'75935','S','Choice','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(19115,'19606','S','St Lawrence','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(56628,'65601','S','Aldrich','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.506631,-93.562372,0,'2013-07-06 12:44:33',NULL,NULL),(47698,'54977','S','Scandinavia','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.463678,-89.148098,0,'2013-07-06 12:44:33',NULL,NULL),(70999,'85715','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.274389,-110.828940,0,'2013-07-06 12:44:34',NULL,NULL),(75272,'93705','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.792350,-119.828938,0,'2013-07-06 12:44:34',NULL,NULL),(10485,'10954','S','Nanuet','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.098338,-74.009393,0,'2013-07-06 12:44:30',NULL,NULL),(10572,'11020','S','Lake Success','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(13613,'13862','S','Whitney Point','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.357840,-75.938160,0,'2013-07-06 12:44:31',NULL,NULL),(41924,'47383','S','Hills and Dales','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.185979,-85.275224,0,'2013-07-06 12:44:32',NULL,NULL),(3927,'02462','S','Newton Lower Falls','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.331200,-71.258208,0,'2013-07-06 12:44:30',NULL,NULL),(3620,'02060','P','N Scituate','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.186869,-71.204063,0,'2013-07-06 12:44:30',NULL,NULL),(2946,'01031','S','Old Furnace','N','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.334260,-72.176040,0,'2013-07-06 12:44:30',NULL,NULL),(45020,'50461','S','Meroa','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.286734,-92.810092,0,'2013-07-06 12:44:32',NULL,NULL),(57046,'66210','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(64235,'76308','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.869770,-98.538219,0,'2013-07-06 12:44:34',NULL,NULL),(70805,'85369','P','Yuma','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.698844,-114.677928,0,'2013-07-06 12:44:34',NULL,NULL),(72122,'88260','S','Lovington','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.931120,-103.313460,0,'2013-07-06 12:44:34',NULL,NULL),(57391,'66756','S','Cockerill','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.549625,-94.679242,0,'2013-07-06 12:44:33',NULL,NULL),(20493,'21057','S','Glen Arm','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.448699,-76.500508,0,'2013-07-06 12:44:31',NULL,NULL),(19457,'20128','P','Orlean','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.749579,-77.962459,0,'2013-07-06 12:44:31',NULL,NULL),(46782,'53957','U','Randolph','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.541272,-89.005699,0,'2013-07-06 12:44:32',NULL,NULL),(3506,'01863','S','North Chelmsford','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.633290,-71.384253,0,'2013-07-06 12:44:30',NULL,NULL),(29539,'32794','P','Maitland','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.627618,-81.365615,0,'2013-07-06 12:44:32',NULL,NULL),(15429,'16369','U','Crossing Pointe','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.847491,-79.145887,0,'2013-07-06 12:44:31',NULL,NULL),(3026,'01090','P','West Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.121280,-72.654857,0,'2013-07-06 12:44:30',NULL,NULL),(48946,'56168','S','Rushmore','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.632693,-95.753484,0,'2013-07-06 12:44:33',NULL,NULL),(48009,'55168','U','Veterans Admin','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.945948,-93.091123,0,'2013-07-06 12:44:33',NULL,NULL),(8531,'08108','S','Westmont','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.913768,-75.065877,0,'2013-07-06 12:44:30',NULL,NULL),(4843,'04011','S','Birch Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.905571,-69.964566,0,'2013-07-06 12:44:30',NULL,NULL),(13416,'13754','S','Sanford','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(65508,'77701','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.071367,-94.103219,0,'2013-07-06 12:44:34',NULL,NULL),(9446,'10006','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(42037,'47441','S','Vicksburg','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(21321,'22407','S','Fredbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(36818,'41063','S','Atwood','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.842260,-84.522660,0,'2013-07-06 12:44:32',NULL,NULL),(35611,'39601','S','New Sight','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(34843,'38922','S','Coffeeville','D','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(20795,'21550','S','Hutton','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(32962,'36587','S','Wilmer','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.815411,-88.330567,0,'2013-07-06 12:44:32',NULL,NULL),(15982,'17033','S','Hershey','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(29987,'33106','U','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796832,-80.301438,0,'2013-07-06 12:44:32',NULL,NULL),(15391,'16327','S','Guys Mills','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.634230,-79.955731,0,'2013-07-06 12:44:31',NULL,NULL),(7344,'06721','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.559848,-73.059033,0,'2013-07-06 12:44:30',NULL,NULL),(10902,'11427','S','Bellerose Manor','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(47199,'54488','S','Unity','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.849654,-90.320639,0,'2013-07-06 12:44:32',NULL,NULL),(55512,'63781','S','Sedgewickville','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.545458,-89.928209,0,'2013-07-06 12:44:33',NULL,NULL),(70266,'84522','P','Emery','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.920269,-111.251922,0,'2013-07-06 12:44:34',NULL,NULL),(78949,'98368','S','Mats Mats','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(40709,'46111','P','Brooklyn','D','Morgan','18109','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.540408,-86.366352,0,'2013-07-06 12:44:32',NULL,NULL),(60902,'72074','P','Hunter','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.050948,-91.126664,0,'2013-07-06 12:44:33',NULL,NULL),(19365,'20055','U','Bank of America','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901404,-77.023348,0,'2013-07-06 12:44:31',NULL,NULL),(70848,'85544','S','Pine','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.396467,-111.453745,0,'2013-07-06 12:44:34',NULL,NULL),(63226,'75459','S','Dorchester','A','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.517500,-96.640380,0,'2013-07-06 12:44:33',NULL,NULL),(69343,'83539','S','Lowell','N','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.156080,-115.886220,0,'2013-07-06 12:44:34',NULL,NULL),(68468,'81236','S','Saint Elmo','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.700006,-106.141598,0,'2013-07-06 12:44:34',NULL,NULL),(23552,'25632','S','Earling','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.773567,-81.951589,0,'2013-07-06 12:44:31',NULL,NULL),(9525,'10018','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(2930,'01022','S','Chicopee','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.194752,-72.561933,0,'2013-07-06 12:44:30',NULL,NULL),(10001,'10167','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(51063,'58748','S','Kramer','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678784,-100.658855,0,'2013-07-06 12:44:33',NULL,NULL),(55782,'64118','S','Village of Oakview','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.215793,-94.572799,0,'2013-07-06 12:44:33',NULL,NULL),(65417,'77574','P','League City','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.513134,-95.058105,0,'2013-07-06 12:44:34',NULL,NULL),(51928,'60119','S','Campton Hills','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.881407,-88.488714,0,'2013-07-06 12:44:33',NULL,NULL),(6109,'05455','S','Sheldon','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.784985,-73.017552,0,'2013-07-06 12:44:30',NULL,NULL),(67339,'80103','S','Byers','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.663695,-104.136365,0,'2013-07-06 12:44:34',NULL,NULL),(70480,'84766','S','Sevier','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.593540,-112.243870,0,'2013-07-06 12:44:34',NULL,NULL),(76627,'95709','S','Snowline Camp','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.751360,-120.665040,0,'2013-07-06 12:44:34',NULL,NULL),(48513,'55745','U','Grand Rapids','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.230302,-93.524079,0,'2013-07-06 12:44:33',NULL,NULL),(27530,'30218','S','Gay','D','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.104107,-84.631461,0,'2013-07-06 12:44:31',NULL,NULL),(16323,'17123','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265958,-76.880448,0,'2013-07-06 12:44:31',NULL,NULL),(41073,'46517','S','Elkhart','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.622360,-85.983780,0,'2013-07-06 12:44:32',NULL,NULL),(73027,'90073','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.052501,-118.455227,0,'2013-07-06 12:44:34',NULL,NULL),(11985,'12473','S','Round Top','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.270121,-74.070612,0,'2013-07-06 12:44:30',NULL,NULL),(13561,'13839','S','East Masonville','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.220441,-75.323336,0,'2013-07-06 12:44:31',NULL,NULL),(33842,'37934','S','Knx','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(45291,'50707','S','Elk Run Heights','A','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.482880,-92.277060,0,'2013-07-06 12:44:32',NULL,NULL),(52830,'61310','S','Shaws','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.704186,-89.342017,0,'2013-07-06 12:44:33',NULL,NULL),(57875,'67585','P','Yoder','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.943107,-97.868576,0,'2013-07-06 12:44:33',NULL,NULL),(71861,'87712','P','Buena Vista','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.891111,-105.185278,0,'2013-07-06 12:44:34',NULL,NULL),(72940,'90036','S','Wilshire La Brea','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.067699,-118.350907,0,'2013-07-06 12:44:34',NULL,NULL),(77332,'96713','S','Hana Maui','N','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.746665,-156.122196,0,'2013-07-06 12:44:34',NULL,NULL),(9731,'10087','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(42320,'47618','P','Darmstadt','A','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.110743,-87.560239,0,'2013-07-06 12:44:32',NULL,NULL),(21505,'22711','S','Banco','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.448654,-78.279768,0,'2013-07-06 12:44:31',NULL,NULL),(4014,'02559','S','Bourne','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.687784,-70.615331,0,'2013-07-06 12:44:30',NULL,NULL),(25816,'28609','S','Longisland','A','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.667368,-80.999551,0,'2013-07-06 12:44:31',NULL,NULL),(65759,'78070','S','Spring Branch','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.839116,-98.409301,0,'2013-07-06 12:44:34',NULL,NULL),(17639,'18065','P','Neffs','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.696820,-75.609024,0,'2013-07-06 12:44:31',NULL,NULL),(57058,'66212','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955997,-94.682048,0,'2013-07-06 12:44:33',NULL,NULL),(8944,'08757','S','Berkeley Twp','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(39890,'45213','S','Pleasant Ridge','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.179149,-84.417894,0,'2013-07-06 12:44:32',NULL,NULL),(38450,'43605','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651460,-83.508660,0,'2013-07-06 12:44:32',NULL,NULL),(21170,'22153','S','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.745146,-77.237140,0,'2013-07-06 12:44:31',NULL,NULL),(15843,'16938','S','Blackwell','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(33075,'36773','S','Safford','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.283499,-87.417631,0,'2013-07-06 12:44:32',NULL,NULL),(13237,'13640','S','Wellesley Island','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.317415,-76.008175,0,'2013-07-06 12:44:30',NULL,NULL),(26010,'28676','S','Mountain Park','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.396418,-80.892260,0,'2013-07-06 12:44:31',NULL,NULL),(7948,'07675','S','River Vale','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.000621,-74.031463,0,'2013-07-06 12:44:30',NULL,NULL),(21901,'23186','U','Wlmg','N','Williamsburg City','51830','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.272593,-76.682518,0,'2013-07-06 12:44:31',NULL,NULL),(51194,'59030','S','Corwin Springs','N','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.031682,-110.705747,0,'2013-07-06 12:44:33',NULL,NULL),(61082,'72130','S','Woodrow','N','Cleburne','05023','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.689015,-92.144913,0,'2013-07-06 12:44:33',NULL,NULL),(79057,'98421','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250147,-122.413100,0,'2013-07-06 12:44:34',NULL,NULL),(33076,'36775','S','Sardis','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.267832,-86.986240,0,'2013-07-06 12:44:32',NULL,NULL),(2985,'01061','P','Northampton','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.323341,-72.690352,0,'2013-07-06 12:44:30',NULL,NULL),(32154,'35470','S','Coatopa','A','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.602560,-88.164180,0,'2013-07-06 12:44:32',NULL,NULL),(35369,'39451','S','Jonathan','N','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.152091,-88.563411,0,'2013-07-06 12:44:32',NULL,NULL),(42190,'47546','S','Boone','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.395440,-86.932333,0,'2013-07-06 12:44:32',NULL,NULL),(39700,'45039','S','Maineville','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.320497,-84.253761,0,'2013-07-06 12:44:32',NULL,NULL),(35521,'39534','P','Keesler Field','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413857,-88.910394,0,'2013-07-06 12:44:32',NULL,NULL),(30084,'33156','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(12951,'13357','S','Cedarville','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(50879,'58530','S','Center','D','Oliver','38065','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.086010,-100.941390,0,'2013-07-06 12:44:33',NULL,NULL),(56307,'65101','S','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(64019,'76118','S','Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(66782,'79041','S','Hale Center','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',34.062137,-101.847807,0,'2013-07-06 12:44:34',NULL,NULL),(35801,'39756','S','Prairie','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.807566,-88.636356,0,'2013-07-06 12:44:32',NULL,NULL),(54808,'63020','S','Desoto','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.090460,-90.566700,0,'2013-07-06 12:44:33',NULL,NULL),(54591,'62901','S','Lake Tacoma','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(22999,'24801','S','Welch','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(37471,'42001','S','Avondale','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(47823,'55063','S','Pine City','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.910278,-92.955000,0,'2013-07-06 12:44:33',NULL,NULL),(31628,'34697','P','Dunedin','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.026546,-82.764257,0,'2013-07-06 12:44:32',NULL,NULL),(36940,'41164','S','Olive Hill','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(40321,'45470','U','Metropolitan Medical Claims','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.629744,-84.272496,0,'2013-07-06 12:44:32',NULL,NULL),(24389,'27103','S','Hanes','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.069214,-80.316170,0,'2013-07-06 12:44:31',NULL,NULL),(45328,'50858','S','Hebron','N','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204707,-94.422418,0,'2013-07-06 12:44:32',NULL,NULL),(53387,'61811','S','Alvin','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.309944,-87.607061,0,'2013-07-06 12:44:33',NULL,NULL),(20922,'21741','P','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.641390,-77.718786,0,'2013-07-06 12:44:31',NULL,NULL),(11753,'12192','S','W Coxsackie','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.383280,-73.824300,0,'2013-07-06 12:44:30',NULL,NULL),(31318,'34114','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.989979,-81.533404,0,'2013-07-06 12:44:32',NULL,NULL),(54419,'62834','P','Emma','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.973611,-88.121084,0,'2013-07-06 12:44:33',NULL,NULL),(59194,'70364','S','Houma','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.623107,-90.729507,0,'2013-07-06 12:44:33',NULL,NULL),(64525,'76641','S','Emmett','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.029561,-96.778412,0,'2013-07-06 12:44:34',NULL,NULL),(66584,'78746','S','West Lake Hills','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.301080,-97.814880,0,'2013-07-06 12:44:34',NULL,NULL),(66684,'78941','S','Flatonia','D','Fayette','48149','Texas','TX','48','0000','361','Central',-6.0,'Y',29.687084,-97.108065,0,'2013-07-06 12:44:34',NULL,NULL),(69980,'84121','S','Cottonwd Hgts','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(70880,'85610','S','Gleeson','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.719147,-109.464014,0,'2013-07-06 12:44:34',NULL,NULL),(74111,'92226','P','Blythe','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.606806,-114.587890,0,'2013-07-06 12:44:34',NULL,NULL),(78102,'97490','S','Walton','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.033871,-123.594278,0,'2013-07-06 12:44:34',NULL,NULL),(7825,'07458','S','U Saddle Riv','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.045460,-74.099880,0,'2013-07-06 12:44:30',NULL,NULL),(63336,'75601','S','Longview Heights','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.522353,-94.733035,0,'2013-07-06 12:44:33',NULL,NULL),(61229,'72328','P','Crumrod','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.193874,-90.947200,0,'2013-07-06 12:44:33',NULL,NULL),(6959,'06231','S','Amston','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.627816,-72.364549,0,'2013-07-06 12:44:30',NULL,NULL),(55173,'63369','S','Chain of Rocks','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.942597,-90.763542,0,'2013-07-06 12:44:33',NULL,NULL),(70941,'85641','S','Corona','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(71740,'87537','S','Hernandez','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.070638,-106.160258,0,'2013-07-06 12:44:34',NULL,NULL),(73957,'92065','S','Ramona','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.026308,-116.857009,0,'2013-07-06 12:44:34',NULL,NULL),(9415,'10001','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(13513,'13811','S','West Newark','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.232380,-76.176420,0,'2013-07-06 12:44:31',NULL,NULL),(44592,'50044','S','Bussey','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204439,-92.884174,0,'2013-07-06 12:44:32',NULL,NULL),(38851,'44094','S','Kirtland','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(33062,'36763','P','Myrtlewood','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.248322,-87.949345,0,'2013-07-06 12:44:32',NULL,NULL),(28788,'32044','S','Hampton','D','Bradford','12007','Florida','FL','12','0000','904','Eastern',-5.0,'Y',29.845168,-82.144682,0,'2013-07-06 12:44:32',NULL,NULL),(16165,'17063','S','Roseann','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.716078,-77.590384,0,'2013-07-06 12:44:31',NULL,NULL),(4916,'04072','S','Saco','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.538160,-70.469340,0,'2013-07-06 12:44:30',NULL,NULL),(1584,'00769','S','Alts De Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(49648,'56967','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(59405,'70639','S','Evans','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.996277,-93.448813,0,'2013-07-06 12:44:33',NULL,NULL),(59957,'71303','S','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(40944,'46298','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.893930,-86.229942,0,'2013-07-06 12:44:32',NULL,NULL),(5033,'04256','S','Mechanic Falls','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.104531,-70.370014,0,'2013-07-06 12:44:30',NULL,NULL),(79206,'98536','S','Copalis Crossing','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.141395,-124.099068,0,'2013-07-06 12:44:34',NULL,NULL),(71402,'87013','S','Pueblo Pintado','N','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.863380,-107.072820,0,'2013-07-06 12:44:34',NULL,NULL),(21996,'23274','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542735,-77.446569,0,'2013-07-06 12:44:31',NULL,NULL),(57182,'66408','S','Bern','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.955795,-95.954970,0,'2013-07-06 12:44:33',NULL,NULL),(51636,'59860','S','Polson','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.698356,-114.140847,0,'2013-07-06 12:44:33',NULL,NULL),(6724,'06072','P','Somersville','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.981639,-72.492023,0,'2013-07-06 12:44:30',NULL,NULL),(1229,'00728','S','Villa Delicias','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(15615,'16685','S','Todd','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.265213,-78.107904,0,'2013-07-06 12:44:31',NULL,NULL),(40413,'45685','S','Thurman','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.956699,-82.474011,0,'2013-07-06 12:44:32',NULL,NULL),(28235,'31046','S','Juliette','D','Monroe','13207','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.995420,-83.775669,0,'2013-07-06 12:44:31',NULL,NULL),(28336,'31169','U','Peachtree City','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396731,-84.595632,0,'2013-07-06 12:44:32',NULL,NULL),(33913,'38053','S','East Acres','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(33336,'37160','S','Shelbyville','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.476039,-86.467210,0,'2013-07-06 12:44:32',NULL,NULL),(30288,'33261','P','North Miami Beach','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.891214,-80.181179,0,'2013-07-06 12:44:32',NULL,NULL),(47820,'55060','S','Pratt','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087587,-93.221024,0,'2013-07-06 12:44:33',NULL,NULL),(49602,'56757','S','Stephen','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.467526,-96.872246,0,'2013-07-06 12:44:33',NULL,NULL),(49615,'56901','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(53173,'61572','S','Yates City','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.785951,-90.046044,0,'2013-07-06 12:44:33',NULL,NULL),(69690,'84028','S','Pickleville','N','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.914447,-111.400556,0,'2013-07-06 12:44:34',NULL,NULL),(74526,'92653','S','Laguna Hills','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.601535,-117.711678,0,'2013-07-06 12:44:34',NULL,NULL),(75369,'93927','S','Greenfield','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.309634,-121.319264,0,'2013-07-06 12:44:34',NULL,NULL),(76981,'96062','S','Millville','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.549344,-122.140240,0,'2013-07-06 12:44:34',NULL,NULL),(40896,'46251','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.724125,-86.269787,0,'2013-07-06 12:44:32',NULL,NULL),(63498,'75706','S','Lindale','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.464510,-95.278390,0,'2013-07-06 12:44:33',NULL,NULL),(5716,'04989','S','Vassalboro','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.429961,-69.652697,0,'2013-07-06 12:44:30',NULL,NULL),(5595,'04922','S','Burnham','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.666298,-69.331480,0,'2013-07-06 12:44:30',NULL,NULL),(35128,'39213','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.346826,-90.214369,0,'2013-07-06 12:44:32',NULL,NULL),(66674,'78931','S','Bleiblerville','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.940764,-96.404250,0,'2013-07-06 12:44:34',NULL,NULL),(36170,'40243','S','Douglass Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(24339,'27031','P','Mount Airy','A','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.445556,-80.633611,0,'2013-07-06 12:44:31',NULL,NULL),(12835,'13312','P','Glenfield','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.685598,-75.289871,0,'2013-07-06 12:44:30',NULL,NULL),(62533,'74429','S','Choska','N','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.956129,-95.658301,0,'2013-07-06 12:44:33',NULL,NULL),(63568,'75771','S','Lindale','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(40507,'45810','S','Ada','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.748152,-83.793709,0,'2013-07-06 12:44:32',NULL,NULL),(40356,'45631','S','Rodney','N','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.821555,-82.196836,0,'2013-07-06 12:44:32',NULL,NULL),(19688,'20373','U','Joint Base Anacostia Bolling','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(7903,'07605','S','Leonia','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.862411,-73.985614,0,'2013-07-06 12:44:30',NULL,NULL),(36292,'40357','P','N Middletown','A','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.144609,-84.108627,0,'2013-07-06 12:44:32',NULL,NULL),(52776,'61264','S','Milan','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.403900,-90.577680,0,'2013-07-06 12:44:33',NULL,NULL),(63923,'76053','S','Hurst','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.824147,-97.176902,0,'2013-07-06 12:44:34',NULL,NULL),(67484,'80229','S','Welby','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.850200,-104.969880,0,'2013-07-06 12:44:34',NULL,NULL),(40726,'46124','S','Camp Atterbury','A','Johnson','18081','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.353574,-85.964085,0,'2013-07-06 12:44:32',NULL,NULL),(22663,'24277','S','Pennington','N','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.755012,-83.033078,0,'2013-07-06 12:44:31',NULL,NULL),(56211,'65032','S','Marys Home','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.386782,-92.366414,0,'2013-07-06 12:44:33',NULL,NULL),(24856,'27634','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.779441,-78.638863,0,'2013-07-06 12:44:31',NULL,NULL),(31950,'35209','S','Homewood','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.460200,-86.809200,0,'2013-07-06 12:44:32',NULL,NULL),(27356,'30060','S','Dobbins Air Force Base','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.936824,-84.529346,0,'2013-07-06 12:44:31',NULL,NULL),(45928,'52333','S','Twin View Heights','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.803913,-91.515810,0,'2013-07-06 12:44:32',NULL,NULL),(18217,'18957','P','Salford','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.296070,-75.453386,0,'2013-07-06 12:44:31',NULL,NULL),(44286,'49720','S','Charlevoix','D','Charlevoix','26029','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.279360,-85.270470,0,'2013-07-06 12:44:32',NULL,NULL),(8744,'08525','S','Hopewell Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.386966,-74.765926,0,'2013-07-06 12:44:30',NULL,NULL),(32333,'35773','S','Toney','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.901692,-86.691794,0,'2013-07-06 12:44:32',NULL,NULL),(56418,'65256','S','Woodlandville','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.126631,-92.438081,0,'2013-07-06 12:44:33',NULL,NULL),(71230,'86333','S','Cordes Lakes','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.316282,-112.121385,0,'2013-07-06 12:44:34',NULL,NULL),(73862,'91911','S','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.608080,-117.053163,0,'2013-07-06 12:44:34',NULL,NULL),(75820,'94901','S','San Anselmo','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.974155,-122.509463,0,'2013-07-06 12:44:34',NULL,NULL),(56813,'65777','S','Moody','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.535679,-91.989585,0,'2013-07-06 12:44:33',NULL,NULL),(19904,'20544','U','Adm Office Us Court','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906224,-77.038090,0,'2013-07-06 12:44:31',NULL,NULL),(41934,'47387','S','Straughn','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.829411,-85.270894,0,'2013-07-06 12:44:32',NULL,NULL),(6969,'06237','S','Columbia','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702445,-72.302125,0,'2013-07-06 12:44:30',NULL,NULL),(3385,'01605','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.286159,-71.795924,0,'2013-07-06 12:44:30',NULL,NULL),(46888,'54115','S','Ashwaubenon','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.434457,-88.070098,0,'2013-07-06 12:44:32',NULL,NULL),(5139,'04414','S','Wiliamsbg Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.307433,-69.030278,0,'2013-07-06 12:44:30',NULL,NULL),(2522,'00957','S','Urb Sans Souci','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(76243,'95391','S','Mountain House','A','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.760523,-121.546105,0,'2013-07-06 12:44:34',NULL,NULL),(50239,'57623','S','Ohem','N','Ziebach','46137','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.990004,-101.647447,0,'2013-07-06 12:44:33',NULL,NULL),(15,'00603','S','Aguadilla','D','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(42117,'47469','S','W Baden Spgs','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(38370,'43465','S','Moline','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.571390,-83.496483,0,'2013-07-06 12:44:32',NULL,NULL),(7952,'07676','S','Twp Washingtn','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(35601,'39595','U','Pascagoula Naval Air Station','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.368782,-88.549063,0,'2013-07-06 12:44:32',NULL,NULL),(54677,'62941','S','Hillerman','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.250785,-89.010847,0,'2013-07-06 12:44:33',NULL,NULL),(56699,'65662','S','Grovespring','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.472989,-92.575018,0,'2013-07-06 12:44:33',NULL,NULL),(58591,'68842','S','Greeley','D','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.549174,-98.536561,0,'2013-07-06 12:44:33',NULL,NULL),(73664,'91521','U','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.154869,-118.326276,0,'2013-07-06 12:44:34',NULL,NULL),(42224,'47561','S','Widner','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.851331,-87.415278,0,'2013-07-06 12:44:32',NULL,NULL),(20013,'20617','S','Bryantown','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.542375,-76.854109,0,'2013-07-06 12:44:31',NULL,NULL),(17890,'18444','S','Roaring Brook Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(2891,'00987','S','Parq Ind Jn Matos','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(71946,'87937','S','Rodey','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.656667,-107.135278,0,'2013-07-06 12:44:34',NULL,NULL),(75677,'94551','S','Livermore','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.730738,-121.691989,0,'2013-07-06 12:44:34',NULL,NULL),(8820,'08619','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.238460,-74.717460,0,'2013-07-06 12:44:30',NULL,NULL),(18139,'18830','S','Little Meadows','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.959552,-76.107242,0,'2013-07-06 12:44:31',NULL,NULL),(12490,'12996','S','Reber','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.374140,-73.417200,0,'2013-07-06 12:44:30',NULL,NULL),(20749,'21403','S','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.949357,-76.488902,0,'2013-07-06 12:44:31',NULL,NULL),(33502,'37360','S','Normandy','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.414121,-86.237865,0,'2013-07-06 12:44:32',NULL,NULL),(7164,'06439','P','Hadlyme','D','New London','09011','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.418853,-72.397690,0,'2013-07-06 12:44:30',NULL,NULL),(16308,'17112','S','Paxtonia','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.338060,-76.803780,0,'2013-07-06 12:44:31',NULL,NULL),(30113,'33160','S','Sunny Isles Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(15177,'15934','P','Elton','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.279621,-78.800745,0,'2013-07-06 12:44:31',NULL,NULL),(26528,'29203','S','Denny Terrace','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(29,'00603','S','Urb El Prado','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(471,'00664','S','Valle Verde','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(41355,'46792','S','Methodist Memorial Home','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(55681,'64054','S','Sugar Creek','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.111863,-94.441141,0,'2013-07-06 12:44:33',NULL,NULL),(31648,'34737','S','Howey in the Hills','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.704236,-81.784964,0,'2013-07-06 12:44:32',NULL,NULL),(16999,'17731','P','Eagles Mere','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.409817,-76.585625,0,'2013-07-06 12:44:31',NULL,NULL),(31430,'34266','S','Lake Suzy','A','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.199150,-81.847982,0,'2013-07-06 12:44:32',NULL,NULL),(29745,'32969','P','Citrus Ridge','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.638947,-80.397672,0,'2013-07-06 12:44:32',NULL,NULL),(5808,'05068','S','South Royalton','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.801620,-72.530880,0,'2013-07-06 12:44:30',NULL,NULL),(76404,'95547','S','Hydesville','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.545772,-124.092537,0,'2013-07-06 12:44:34',NULL,NULL),(41876,'47362','S','Westwood','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(17127,'17776','S','Pine Village','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.331890,-77.344196,0,'2013-07-06 12:44:31',NULL,NULL),(69289,'83444','S','Roberts','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.733673,-112.127030,0,'2013-07-06 12:44:34',NULL,NULL),(73298,'90803','S','Naples','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.759309,-118.125598,0,'2013-07-06 12:44:34',NULL,NULL),(10906,'11427','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(39008,'44139','S','Glenwillow','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.392321,-81.444888,0,'2013-07-06 12:44:32',NULL,NULL),(11078,'11690','P','Edgemere','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.601071,-73.762108,0,'2013-07-06 12:44:30',NULL,NULL),(30219,'33186','S','Crossings','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661132,-80.407574,0,'2013-07-06 12:44:32',NULL,NULL),(28935,'32173','P','Ormond Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.290568,-81.094572,0,'2013-07-06 12:44:32',NULL,NULL),(54937,'63113','S','Louis','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.654969,-90.245104,0,'2013-07-06 12:44:33',NULL,NULL),(55640,'64015','S','Lake Tapwingo','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.017700,-94.310640,0,'2013-07-06 12:44:33',NULL,NULL),(69715,'84036','S','Marion','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(77234,'96520','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79856,'99555','P','Aleknagik','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.320900,-158.641070,0,'2013-07-06 12:44:34',NULL,NULL),(20698,'21251','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341206,-76.585933,0,'2013-07-06 12:44:31',NULL,NULL),(16475,'17244','S','Orrstown','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.078520,-77.650599,0,'2013-07-06 12:44:31',NULL,NULL),(66330,'78602','S','Bastrop','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.115800,-97.274640,0,'2013-07-06 12:44:34',NULL,NULL),(51747,'60018','S','Rosemont','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.002700,-87.900840,0,'2013-07-06 12:44:33',NULL,NULL),(66767,'79021','P','Cotton Center','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',34.069917,-101.934182,0,'2013-07-06 12:44:34',NULL,NULL),(58437,'68701','S','Norfolk','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.033639,-97.421914,0,'2013-07-06 12:44:33',NULL,NULL),(4633,'03607','S','So Acworth','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.176228,-72.332333,0,'2013-07-06 12:44:30',NULL,NULL),(35890,'40003','S','Bagdad','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.283992,-84.974789,0,'2013-07-06 12:44:32',NULL,NULL),(6701,'06062','S','Plainville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.669972,-72.864805,0,'2013-07-06 12:44:30',NULL,NULL),(23488,'25514','S','Fort Gay','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.118046,-82.596913,0,'2013-07-06 12:44:31',NULL,NULL),(50524,'58102','S','North River','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.893312,-96.798609,0,'2013-07-06 12:44:33',NULL,NULL),(51185,'59020','P','Cooke City','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.018847,-109.934351,0,'2013-07-06 12:44:33',NULL,NULL),(52517,'60901','S','Irwin','A','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.113633,-87.860293,0,'2013-07-06 12:44:33',NULL,NULL),(55448,'63702','P','Cpe Girardeau','A','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.310950,-89.625937,0,'2013-07-06 12:44:33',NULL,NULL),(64381,'76530','S','Friendship','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.730080,-97.435980,0,'2013-07-06 12:44:34',NULL,NULL),(53735,'62250','S','Hoffman','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.540845,-89.264477,0,'2013-07-06 12:44:33',NULL,NULL),(30385,'33319','S','North Lauderdale','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(68327,'81120','S','Paisaje','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(73888,'91962','S','Pine Valley','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.820653,-116.453373,0,'2013-07-06 12:44:34',NULL,NULL),(18320,'19022','S','Eddystone','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862914,-75.343388,0,'2013-07-06 12:44:31',NULL,NULL),(40006,'45244','S','Shademore','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118320,-84.337680,0,'2013-07-06 12:44:32',NULL,NULL),(5837,'05086','S','Waits River','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.094722,-72.341944,0,'2013-07-06 12:44:30',NULL,NULL),(13412,'13754','S','Hambletville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(71966,'88008','S','Santa Teresa','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',31.861190,-106.642311,0,'2013-07-06 12:44:34',NULL,NULL),(34963,'39072','P','Pocahontas','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.462960,-90.265940,0,'2013-07-06 12:44:32',NULL,NULL),(43046,'48182','S','Temperance','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.788937,-83.571374,0,'2013-07-06 12:44:32',NULL,NULL),(30665,'33465','P','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.576320,-80.087218,0,'2013-07-06 12:44:32',NULL,NULL),(46777,'53953','P','Packwaukee','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.767992,-89.469212,0,'2013-07-06 12:44:32',NULL,NULL),(72176,'88347','S','Artesia Camp','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.784443,-105.642462,0,'2013-07-06 12:44:34',NULL,NULL),(72703,'89448','P','Lake Village','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(76652,'95728','P','Kingvale','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.320782,-120.408004,0,'2013-07-06 12:44:34',NULL,NULL),(37908,'42633','S','Mill Springs','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(61105,'72141','S','Scotland','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.522817,-92.668783,0,'2013-07-06 12:44:33',NULL,NULL),(14615,'15228','S','Mt Lebanon','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.375682,-80.040038,0,'2013-07-06 12:44:31',NULL,NULL),(69136,'83301','S','Lynwood','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.447360,-114.538200,0,'2013-07-06 12:44:34',NULL,NULL),(78303,'97904','S','Drewsey','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.875912,-118.535320,0,'2013-07-06 12:44:34',NULL,NULL),(537,'00676','S','Moca','D','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(50684,'58348','S','Flora','A','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.932284,-99.553226,0,'2013-07-06 12:44:33',NULL,NULL),(61128,'72156','S','Cypress Valley','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.275653,-92.675788,0,'2013-07-06 12:44:33',NULL,NULL),(40270,'45433','S','Wright Pat','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(7628,'07062','S','N Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.632249,-74.399691,0,'2013-07-06 12:44:30',NULL,NULL),(16764,'17520','S','E Petersburg','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101393,-76.349047,0,'2013-07-06 12:44:31',NULL,NULL),(39879,'45209','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.152971,-84.427731,0,'2013-07-06 12:44:32',NULL,NULL),(6553,'05843','S','South Walden','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.504809,-72.357211,0,'2013-07-06 12:44:30',NULL,NULL),(60625,'71901','S','Fountain Lake','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(56337,'65109','S','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.555400,-92.280540,0,'2013-07-06 12:44:33',NULL,NULL),(9865,'10121','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(17993,'18627','P','Lehman','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.316513,-76.023413,0,'2013-07-06 12:44:31',NULL,NULL),(39358,'44629','S','Gnadenhutten','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.357109,-81.429140,0,'2013-07-06 12:44:32',NULL,NULL),(13998,'14516','S','North Rose','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.193625,-76.907679,0,'2013-07-06 12:44:31',NULL,NULL),(29191,'32403','S','Tyndall AFB','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.090395,-85.629069,0,'2013-07-06 12:44:32',NULL,NULL),(28672,'31792','S','Thomasville','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.836835,-83.972588,0,'2013-07-06 12:44:32',NULL,NULL),(25142,'28018','S','Golden','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(2194,'00926','S','Paseo del Prado','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(1344,'00736','S','Colinas de Cayey','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(46511,'53263','U','J C Penney','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084119,-88.035945,0,'2013-07-06 12:44:32',NULL,NULL),(64129,'76192','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.932938,-97.435253,0,'2013-07-06 12:44:34',NULL,NULL),(69342,'83539','S','Kooskia','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.156080,-115.886220,0,'2013-07-06 12:44:34',NULL,NULL),(40731,'46127','S','Falmouth','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.743856,-85.354057,0,'2013-07-06 12:44:32',NULL,NULL),(30970,'33741','P','Pass A Grille','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.688063,-82.733847,0,'2013-07-06 12:44:32',NULL,NULL),(11254,'11764','S','Miller Place','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.946583,-72.995207,0,'2013-07-06 12:44:30',NULL,NULL),(5780,'05051','S','South Newbury','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.046111,-72.085278,0,'2013-07-06 12:44:30',NULL,NULL),(45606,'51561','S','Pacific Jct','A','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.020858,-95.797670,0,'2013-07-06 12:44:32',NULL,NULL),(73848,'91802','P','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.090903,-118.124015,0,'2013-07-06 12:44:34',NULL,NULL),(75370,'93928','P','Fort Hunter Liggett','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.048776,-121.200408,0,'2013-07-06 12:44:34',NULL,NULL),(39112,'44251','P','Westfield Ctr','A','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027952,-81.938348,0,'2013-07-06 12:44:32',NULL,NULL),(56622,'65586','P','Wesco','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.859098,-91.356689,0,'2013-07-06 12:44:33',NULL,NULL),(15204,'15960','P','Twin Rocks','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.498305,-78.865075,0,'2013-07-06 12:44:31',NULL,NULL),(19760,'20415','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896458,-77.040977,0,'2013-07-06 12:44:31',NULL,NULL),(29228,'32425','S','Noma','A','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.795111,-85.677801,0,'2013-07-06 12:44:32',NULL,NULL),(30207,'33182','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.778250,-80.414948,0,'2013-07-06 12:44:32',NULL,NULL),(12733,'13160','S','Union Springs','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.842257,-76.688186,0,'2013-07-06 12:44:30',NULL,NULL),(51365,'59345','S','Powderville','D','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.741289,-105.248925,0,'2013-07-06 12:44:33',NULL,NULL),(54910,'63084','S','Moselle','N','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.429607,-90.998487,0,'2013-07-06 12:44:33',NULL,NULL),(21227,'22217','U','Office of Naval Research','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855660,-77.093001,0,'2013-07-06 12:44:31',NULL,NULL),(57407,'66763','S','Pittsburg','A','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.452009,-94.696379,0,'2013-07-06 12:44:33',NULL,NULL),(21048,'21890','U','Westover','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.149316,-75.690351,0,'2013-07-06 12:44:31',NULL,NULL),(691,'00685','S','Ext Villa Rita','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(1167,'00727','S','Urb Bonneville Vly','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(32726,'36312','S','Ashford','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.188743,-85.240935,0,'2013-07-06 12:44:32',NULL,NULL),(1579,'00767','S','Valles De Yabucoa','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(2481,'00956','S','Urb Francisco Oller','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(46433,'53203','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.035350,-87.915098,0,'2013-07-06 12:44:32',NULL,NULL),(70982,'85707','P','Davis Monthan AFB','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.182027,-110.868630,0,'2013-07-06 12:44:34',NULL,NULL),(74437,'92570','S','Perris','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.783592,-117.339362,0,'2013-07-06 12:44:34',NULL,NULL),(7161,'06426','S','Essex','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.365983,-72.412721,0,'2013-07-06 12:44:30',NULL,NULL),(62160,'73733','S','Douglas','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.233929,-97.689016,0,'2013-07-06 12:44:33',NULL,NULL),(21000,'21830','S','Hebron','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.412322,-75.687536,0,'2013-07-06 12:44:31',NULL,NULL),(20736,'21289','U','T Rowe Price Associates Inc','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.312384,-76.727934,0,'2013-07-06 12:44:31',NULL,NULL),(31724,'34974','S','Okeechobee','D','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.228620,-80.807426,0,'2013-07-06 12:44:32',NULL,NULL),(53761,'62263','S','Todds Mill','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441389,-89.370278,0,'2013-07-06 12:44:33',NULL,NULL),(12401,'12929','P','Dannemora','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.723692,-73.721780,0,'2013-07-06 12:44:30',NULL,NULL),(79459,'98850','S','Rock Island','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.369739,-120.138925,0,'2013-07-06 12:44:34',NULL,NULL),(20028,'20630','S','Drayden','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.175055,-76.471555,0,'2013-07-06 12:44:31',NULL,NULL),(74919,'93388','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.418862,-119.022933,0,'2013-07-06 12:44:34',NULL,NULL),(41067,'46513','P','Donaldson','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.361678,-86.445676,0,'2013-07-06 12:44:32',NULL,NULL),(10036,'10173','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(41619,'47125','S','Rego','A','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.466102,-86.323493,0,'2013-07-06 12:44:32',NULL,NULL),(38650,'43938','S','Mingo Junction','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.315500,-80.626200,0,'2013-07-06 12:44:32',NULL,NULL),(13751,'14120','S','North Tonawanda','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.071240,-78.814140,0,'2013-07-06 12:44:31',NULL,NULL),(32658,'36257','P','De Armanville','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.628517,-85.743250,0,'2013-07-06 12:44:32',NULL,NULL),(30678,'33470','S','Loxahatchee','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(24869,'27675','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.904343,-78.742412,0,'2013-07-06 12:44:31',NULL,NULL),(6735,'06076','S','West Stafford','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.985120,-72.255660,0,'2013-07-06 12:44:30',NULL,NULL),(48434,'55701','S','Duluth','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.841320,-92.220552,0,'2013-07-06 12:44:33',NULL,NULL),(55107,'63332','S','Femme Osage','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.595378,-90.883880,0,'2013-07-06 12:44:33',NULL,NULL),(55545,'63847','P','Gibson','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.456793,-90.010085,0,'2013-07-06 12:44:33',NULL,NULL),(77284,'96620','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(48310,'55443','S','Brooklyn Park','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.076111,-93.332500,0,'2013-07-06 12:44:33',NULL,NULL),(4723,'03826','S','E Hampstead','A','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.890279,-71.137885,0,'2013-07-06 12:44:30',NULL,NULL),(13970,'14477','S','Kent','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.340537,-78.142360,0,'2013-07-06 12:44:31',NULL,NULL),(43385,'48432','S','Filion','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.904518,-82.998654,0,'2013-07-06 12:44:32',NULL,NULL),(56920,'66061','S','Olathe','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.884071,-94.870529,0,'2013-07-06 12:44:33',NULL,NULL),(23776,'25977','S','Meadow Creek','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.806389,-80.910024,0,'2013-07-06 12:44:31',NULL,NULL),(33324,'37144','S','Petersburg','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.377427,-86.586934,0,'2013-07-06 12:44:32',NULL,NULL),(72028,'88053','P','Pinos Altos','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.783686,-108.271831,0,'2013-07-06 12:44:34',NULL,NULL),(18913,'19490','P','Worcester','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.197251,-75.344516,0,'2013-07-06 12:44:31',NULL,NULL),(45858,'52241','S','Coralville','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.680235,-91.577652,0,'2013-07-06 12:44:32',NULL,NULL),(46716,'53805','S','Boscobel','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.117895,-90.678798,0,'2013-07-06 12:44:32',NULL,NULL),(58208,'68330','P','Cordova','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.715330,-97.350442,0,'2013-07-06 12:44:33',NULL,NULL),(72695,'89447','S','Wabuska','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.921460,-119.117640,0,'2013-07-06 12:44:34',NULL,NULL),(77331,'96713','S','Hana','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.746665,-156.122196,0,'2013-07-06 12:44:34',NULL,NULL),(79128,'98497','P','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.177943,-122.547217,0,'2013-07-06 12:44:34',NULL,NULL),(79491,'98902','S','Weikel','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(43680,'48872','S','Perry','D','Shiawassee','26155','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.816189,-84.226366,0,'2013-07-06 12:44:32',NULL,NULL),(57805,'67505','S','S Hutchinson','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.019420,-97.973340,0,'2013-07-06 12:44:33',NULL,NULL),(57110,'66221','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(31575,'34652','S','New Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.238545,-82.730700,0,'2013-07-06 12:44:32',NULL,NULL),(7541,'07009','S','Overbrook','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.854335,-74.231714,0,'2013-07-06 12:44:30',NULL,NULL),(34234,'38376','S','Shiloh','D','Hardin','47071','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.129598,-88.342137,0,'2013-07-06 12:44:32',NULL,NULL),(16611,'17331','S','Fairview Drive','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(69790,'84064','S','Randolph','D','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.696212,-111.151274,0,'2013-07-06 12:44:34',NULL,NULL),(56733,'65710','S','Eudora','A','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.467448,-93.429803,0,'2013-07-06 12:44:33',NULL,NULL),(45660,'52004','P','Dubuque','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.500101,-90.667751,0,'2013-07-06 12:44:32',NULL,NULL),(5198,'04451','S','Kingman','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.604763,-68.227102,0,'2013-07-06 12:44:30',NULL,NULL),(42344,'47638','S','Parkers Settlement','N','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.075839,-87.761568,0,'2013-07-06 12:44:32',NULL,NULL),(40742,'46135','S','Greencastle','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(8833,'08628','S','West Trenton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.273620,-74.817480,0,'2013-07-06 12:44:30',NULL,NULL),(28795,'32056','P','Lake City','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.190680,-82.639799,0,'2013-07-06 12:44:32',NULL,NULL),(16817,'17545','S','Old Line','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(26886,'29565','S','Latta','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.335502,-79.432246,0,'2013-07-06 12:44:31',NULL,NULL),(22418,'24002','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.277907,-79.956942,0,'2013-07-06 12:44:31',NULL,NULL),(44412,'49829','S','Escanaba','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.749678,-87.096833,0,'2013-07-06 12:44:32',NULL,NULL),(49769,'57069','S','Westerville','N','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.781151,-96.924411,0,'2013-07-06 12:44:33',NULL,NULL),(58469,'68738','P','Hadar','D','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.106986,-97.449535,0,'2013-07-06 12:44:33',NULL,NULL),(62358,'74066','S','Sapulpa','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.000197,-96.113994,0,'2013-07-06 12:44:33',NULL,NULL),(66978,'79416','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.589644,-101.934284,0,'2013-07-06 12:44:34',NULL,NULL),(68379,'81144','S','Maxeyville','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.566562,-106.148089,0,'2013-07-06 12:44:34',NULL,NULL),(73921,'92024','S','Olivenhain','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.055326,-117.263733,0,'2013-07-06 12:44:34',NULL,NULL),(79649,'99144','S','Odessa','A','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.356543,-118.481045,0,'2013-07-06 12:44:34',NULL,NULL),(57378,'66748','S','Humboldt','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.812264,-95.433752,0,'2013-07-06 12:44:33',NULL,NULL),(54370,'62808','S','Ashley','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.328964,-89.188569,0,'2013-07-06 12:44:33',NULL,NULL),(45649,'52001','S','Dubuque','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(66128,'78427','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.795288,-97.403051,0,'2013-07-06 12:44:34',NULL,NULL),(53535,'62032','S','Van Burensburg','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.103643,-89.305669,0,'2013-07-06 12:44:33',NULL,NULL),(14745,'15316','S','Brave','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.721840,-80.260459,0,'2013-07-06 12:44:31',NULL,NULL),(41369,'46795','S','Adams Lake','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(38736,'44028','S','Columbia Sta','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.312086,-81.935671,0,'2013-07-06 12:44:32',NULL,NULL),(35976,'40110','P','Clermont','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.930194,-85.655556,0,'2013-07-06 12:44:32',NULL,NULL),(6181,'05476','S','Richford','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.990100,-72.662700,0,'2013-07-06 12:44:30',NULL,NULL),(48952,'56173','S','Steen','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.545343,-96.234404,0,'2013-07-06 12:44:33',NULL,NULL),(78628,'98207','U','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.959977,-122.196827,0,'2013-07-06 12:44:34',NULL,NULL),(8293,'08021','S','Laurel Spgs','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(42209,'47553','S','Burns City','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(11077,'11599','S','Garden City','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.724849,-73.632559,0,'2013-07-06 12:44:30',NULL,NULL),(27126,'29802','P','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.562561,-81.720328,0,'2013-07-06 12:44:31',NULL,NULL),(40701,'46102','P','Advance','D','Boone','18011','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.996834,-86.620497,0,'2013-07-06 12:44:32',NULL,NULL),(77821,'97204','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.517959,-122.672222,0,'2013-07-06 12:44:34',NULL,NULL),(21539,'22735','S','Reva','D','Madison','51113','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.475407,-78.161530,0,'2013-07-06 12:44:31',NULL,NULL),(62022,'73458','S','Springer','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.314982,-97.129095,0,'2013-07-06 12:44:33',NULL,NULL),(72325,'89006','P','Boulder City','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.965217,-114.836545,0,'2013-07-06 12:44:34',NULL,NULL),(73358,'91011','S','La Canada Flt','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.206651,-118.201628,0,'2013-07-06 12:44:34',NULL,NULL),(9434,'10004','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(18359,'19038','S','Erdenheim','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(43431,'48475','S','Ubly','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.714517,-82.944482,0,'2013-07-06 12:44:32',NULL,NULL),(37519,'42041','S','Fulton','D','Fulton','21075','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.531900,-88.947480,0,'2013-07-06 12:44:32',NULL,NULL),(32301,'35746','S','Fackler','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.828261,-85.987826,0,'2013-07-06 12:44:32',NULL,NULL),(8468,'08088','S','Vincentown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(79334,'98614','P','Chinook','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.271951,-123.940497,0,'2013-07-06 12:44:34',NULL,NULL),(9177,'09364','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33958,'38104','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.133557,-89.998776,0,'2013-07-06 12:44:32',NULL,NULL),(12321,'12863','S','Rock City Fls','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.062610,-73.924524,0,'2013-07-06 12:44:30',NULL,NULL),(18246,'18981','P','Zionhill','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.486011,-75.394037,0,'2013-07-06 12:44:31',NULL,NULL),(57773,'67460','S','Conway','A','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.387160,-97.656540,0,'2013-07-06 12:44:33',NULL,NULL),(45598,'51555','S','Missouri Valley','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.562303,-95.890364,0,'2013-07-06 12:44:32',NULL,NULL),(67270,'79980','U','Wells Fargo Bank','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.746134,-106.375219,0,'2013-07-06 12:44:34',NULL,NULL),(70543,'85027','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.828950,-112.121700,0,'2013-07-06 12:44:34',NULL,NULL),(13802,'14206','S','West Seneca','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.869763,-78.796792,0,'2013-07-06 12:44:31',NULL,NULL),(37958,'42719','P','Campbellsvlle','A','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.341936,-85.340234,0,'2013-07-06 12:44:32',NULL,NULL),(23513,'25547','S','Pecks Mill','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.931460,-81.999056,0,'2013-07-06 12:44:31',NULL,NULL),(32172,'35477','P','Panola','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.952883,-88.270684,0,'2013-07-06 12:44:32',NULL,NULL),(46809,'54004','S','Richardson','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.330762,-92.170455,0,'2013-07-06 12:44:32',NULL,NULL),(69762,'84054','S','N Salt Lake','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.837299,-111.919323,0,'2013-07-06 12:44:34',NULL,NULL),(73660,'91507','P','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.168685,-118.347797,0,'2013-07-06 12:44:34',NULL,NULL),(42139,'47514','S','Branchville','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.171100,-86.569380,0,'2013-07-06 12:44:32',NULL,NULL),(13156,'13605','S','Smithville','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.823100,-76.036860,0,'2013-07-06 12:44:30',NULL,NULL),(59847,'71251','S','Wyatt','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.237820,-92.642040,0,'2013-07-06 12:44:33',NULL,NULL),(33953,'38088','P','Cordova','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.151852,-89.790781,0,'2013-07-06 12:44:32',NULL,NULL),(69917,'84109','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701306,-111.815899,0,'2013-07-06 12:44:34',NULL,NULL),(79441,'98837','S','Wheeler','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.126359,-119.296146,0,'2013-07-06 12:44:34',NULL,NULL),(52985,'61436','S','Gilson','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.875827,-90.156586,0,'2013-07-06 12:44:33',NULL,NULL),(72599,'89410','S','Gardnerville','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(20843,'21648','S','Madison','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.501857,-76.229213,0,'2013-07-06 12:44:31',NULL,NULL),(33364,'37201','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.165634,-86.779786,0,'2013-07-06 12:44:32',NULL,NULL),(29656,'32906','P','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.012469,-80.627582,0,'2013-07-06 12:44:32',NULL,NULL),(26147,'28740','S','Double Island','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(49982,'57363','S','Mount Vernon','D','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.720808,-98.265908,0,'2013-07-06 12:44:33',NULL,NULL),(51308,'59231','P','Saint Marie','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.402929,-106.543693,0,'2013-07-06 12:44:33',NULL,NULL),(75067,'93527','S','Pearsonville','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.685858,-117.832494,0,'2013-07-06 12:44:34',NULL,NULL),(35127,'39213','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.346826,-90.214369,0,'2013-07-06 12:44:32',NULL,NULL),(61161,'72180','P','Woodson','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.530195,-92.211883,0,'2013-07-06 12:44:33',NULL,NULL),(19638,'20262','U','Mafic','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918995,-76.994920,0,'2013-07-06 12:44:31',NULL,NULL),(49070,'56314','S','Elmdale','A','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.770146,-94.355231,0,'2013-07-06 12:44:33',NULL,NULL),(3238,'01380','S','Wendell Depot','D','Franklin','25011','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.569537,-72.406436,0,'2013-07-06 12:44:30',NULL,NULL),(73377,'91043','P','Tujunga','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252009,-118.292791,0,'2013-07-06 12:44:34',NULL,NULL),(52170,'60457','S','Oak Lawn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.727067,-87.828588,0,'2013-07-06 12:44:33',NULL,NULL),(3744,'02169','S','West Quincy','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.240464,-71.014144,0,'2013-07-06 12:44:30',NULL,NULL),(32854,'36505','S','Lemoyne','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.903562,-88.047940,0,'2013-07-06 12:44:32',NULL,NULL),(27387,'30083','S','Memorial Square','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.789125,-84.199181,0,'2013-07-06 12:44:31',NULL,NULL),(70391,'84701','S','Fish Lake','N','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.675160,-111.989820,0,'2013-07-06 12:44:34',NULL,NULL),(76842,'95965','S','Butte Valley','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(41051,'46408','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.539202,-87.365937,0,'2013-07-06 12:44:32',NULL,NULL),(38052,'43046','S','Millersport','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.898950,-82.526218,0,'2013-07-06 12:44:32',NULL,NULL),(33832,'37932','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.920159,-84.174433,0,'2013-07-06 12:44:32',NULL,NULL),(16599,'17325','S','Heidlersburg','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.851653,-77.260693,0,'2013-07-06 12:44:31',NULL,NULL),(23968,'26296','P','Whitmer','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.864167,-79.557222,0,'2013-07-06 12:44:31',NULL,NULL),(52759,'61251','S','Fenton','D','Whiteside','17195','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.729808,-90.072365,0,'2013-07-06 12:44:33',NULL,NULL),(63404,'75652','S','Crimcrest','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(67611,'80433','S','Conifer','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.515866,-105.311973,0,'2013-07-06 12:44:34',NULL,NULL),(70646,'85178','P','Apache Jct','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.423180,-111.546089,0,'2013-07-06 12:44:34',NULL,NULL),(74326,'92399','S','Yucaipa','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.033763,-117.040299,0,'2013-07-06 12:44:34',NULL,NULL),(3796,'02217','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348526,-71.072994,0,'2013-07-06 12:44:30',NULL,NULL),(60835,'72039','S','Twin Groves','A','Van Buren','05141','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.298334,-92.439056,0,'2013-07-06 12:44:33',NULL,NULL),(34235,'38377','P','Silerton','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.362195,-88.829203,0,'2013-07-06 12:44:32',NULL,NULL),(51796,'60046','S','Venetian Village','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(50393,'57769','S','Piedmont','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.229112,-103.390064,0,'2013-07-06 12:44:33',NULL,NULL),(33342,'37167','S','Smyrna','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.967035,-86.513959,0,'2013-07-06 12:44:32',NULL,NULL),(16549,'17307','S','Brysonia','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(27647,'30319','S','Sandy Springs','A','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.875460,-84.333398,0,'2013-07-06 12:44:31',NULL,NULL),(52375,'60621','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.778204,-87.641571,0,'2013-07-06 12:44:33',NULL,NULL),(25556,'28410','U','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.125636,-77.953828,0,'2013-07-06 12:44:31',NULL,NULL),(51834,'60065','P','Northbrook','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.216196,-87.883916,0,'2013-07-06 12:44:33',NULL,NULL),(5323,'04574','S','Washington','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.272720,-69.390395,0,'2013-07-06 12:44:30',NULL,NULL),(70084,'84157','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.660687,-111.884858,0,'2013-07-06 12:44:34',NULL,NULL),(71915,'87823','S','Lemitar','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.156724,-106.907083,0,'2013-07-06 12:44:34',NULL,NULL),(76962,'96047','S','Igo','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.458121,-122.588612,0,'2013-07-06 12:44:34',NULL,NULL),(79028,'98391','S','Tapps Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(32437,'35990','P','Walnut Grove','D','Etowah','01055','Alabama','AL','01','2880','205/659','Central',-6.0,'Y',34.063349,-86.288307,0,'2013-07-06 12:44:32',NULL,NULL),(9093,'09058','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19746,'20408','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893730,-77.021451,0,'2013-07-06 12:44:31',NULL,NULL),(19200,'19880','P','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.730183,-75.538618,0,'2013-07-06 12:44:31',NULL,NULL),(8306,'08029','S','Glendora','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.839674,-75.068120,0,'2013-07-06 12:44:30',NULL,NULL),(21713,'22987','P','White Hall','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.119410,-78.660697,0,'2013-07-06 12:44:31',NULL,NULL),(13299,'13668','S','Knapps Station','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.762820,-74.991240,0,'2013-07-06 12:44:30',NULL,NULL),(46085,'52595','P','Univ Park','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.285630,-92.620526,0,'2013-07-06 12:44:32',NULL,NULL),(46476,'53219','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994394,-87.991356,0,'2013-07-06 12:44:32',NULL,NULL),(48293,'55436','S','St Louis Pk','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.901982,-93.372906,0,'2013-07-06 12:44:33',NULL,NULL),(52805,'61277','S','Wethersfield','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(61252,'72352','P','La Grange','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.780461,-90.746676,0,'2013-07-06 12:44:33',NULL,NULL),(67779,'80651','S','Platteville','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.223774,-104.822498,0,'2013-07-06 12:44:34',NULL,NULL),(76784,'95942','S','Forest Ranch','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',40.089969,-121.531089,0,'2013-07-06 12:44:34',NULL,NULL),(78250,'97833','S','Haines','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.914380,-117.938903,0,'2013-07-06 12:44:34',NULL,NULL),(29721,'32953','S','Merritt Is','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.400081,-80.705159,0,'2013-07-06 12:44:32',NULL,NULL),(66041,'78369','S','Aguilares','N','Webb','48479','Texas','TX','48','4080','361','Central',-6.0,'Y',27.441138,-99.024210,0,'2013-07-06 12:44:34',NULL,NULL),(20349,'20859','P','Rockville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.022959,-77.199250,0,'2013-07-06 12:44:31',NULL,NULL),(22336,'23872','S','Mc Kenney','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.010182,-77.725604,0,'2013-07-06 12:44:31',NULL,NULL),(47906,'55109','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(20099,'20705','S','Calverton','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.044597,-76.906156,0,'2013-07-06 12:44:31',NULL,NULL),(69618,'83867','P','Silverton','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.495375,-115.955531,0,'2013-07-06 12:44:34',NULL,NULL),(52541,'60933','P','Elliott','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.463544,-88.274723,0,'2013-07-06 12:44:33',NULL,NULL),(7685,'07102','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.732638,-74.171775,0,'2013-07-06 12:44:30',NULL,NULL),(16747,'17509','S','Cooperville','N','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(30571,'33414','S','Vlg Wellingtn','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(47691,'54968','S','Princeton','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.850369,-89.128752,0,'2013-07-06 12:44:33',NULL,NULL),(69521,'83725','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.605516,-116.199180,0,'2013-07-06 12:44:34',NULL,NULL),(73070,'90101','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',33.995072,-118.164164,0,'2013-07-06 12:44:34',NULL,NULL),(77028,'96101','S','California Pines','N','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.512612,-120.551753,0,'2013-07-06 12:44:34',NULL,NULL),(65305,'77496','P','Sugar Land','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.620202,-95.637753,0,'2013-07-06 12:44:34',NULL,NULL),(61080,'72129','S','Prattsville','D','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.294448,-92.504614,0,'2013-07-06 12:44:33',NULL,NULL),(57347,'66725','S','Quaker','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(43476,'48603','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.433525,-84.027056,0,'2013-07-06 12:44:32',NULL,NULL),(51579,'59801','S','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858650,-114.039769,0,'2013-07-06 12:44:33',NULL,NULL),(46158,'52722','S','Riverdale','A','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.567220,-90.462000,0,'2013-07-06 12:44:32',NULL,NULL),(37801,'42378','S','Whitesville','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.683228,-86.873020,0,'2013-07-06 12:44:32',NULL,NULL),(22029,'23293','U','Richmond Newspapers','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.441334,-77.322755,0,'2013-07-06 12:44:31',NULL,NULL),(59412,'70648','S','Kinder','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.485538,-92.846763,0,'2013-07-06 12:44:33',NULL,NULL),(37327,'41653','S','Lancer','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(57858,'67570','S','Pretty Prairie','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.786862,-97.941549,0,'2013-07-06 12:44:33',NULL,NULL),(30798,'33606','S','University of Tampa','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.936563,-82.465286,0,'2013-07-06 12:44:32',NULL,NULL),(2568,'00959','S','Urb Tortuguero','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(10719,'11247','P','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.675485,-73.966404,0,'2013-07-06 12:44:30',NULL,NULL),(20153,'20737','S','Riverdale','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.959262,-76.920047,0,'2013-07-06 12:44:31',NULL,NULL),(9186,'09374','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(57267,'66544','S','Vliets','A','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.691182,-96.283657,0,'2013-07-06 12:44:33',NULL,NULL),(58169,'68198','U','Un Med Center','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.265996,-96.010026,0,'2013-07-06 12:44:33',NULL,NULL),(34937,'39044','S','Braxton','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.025924,-89.969873,0,'2013-07-06 12:44:32',NULL,NULL),(61048,'72119','P','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.763985,-92.258586,0,'2013-07-06 12:44:33',NULL,NULL),(9343,'09777','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71011,'85723','U','Veterans Hospital','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.194430,-111.005542,0,'2013-07-06 12:44:34',NULL,NULL),(38568,'43777','S','Roseville','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.826232,-82.065033,0,'2013-07-06 12:44:32',NULL,NULL),(54033,'62460','S','St Francisvle','A','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.591789,-87.646603,0,'2013-07-06 12:44:33',NULL,NULL),(15814,'16929','S','Lawrenceville','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.993999,-77.123186,0,'2013-07-06 12:44:31',NULL,NULL),(29311,'32530','P','Bagdad','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.618153,-87.025228,0,'2013-07-06 12:44:32',NULL,NULL),(50173,'57555','S','Hidden Timber','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.194176,-100.477794,0,'2013-07-06 12:44:33',NULL,NULL),(76443,'95605','S','Bryte','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.594722,-121.540556,0,'2013-07-06 12:44:34',NULL,NULL),(4297,'02904','S','North Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.832900,-71.437560,0,'2013-07-06 12:44:30',NULL,NULL),(17257,'17841','S','Shindle','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(36371,'40456','S','Conway','A','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.358415,-84.346235,0,'2013-07-06 12:44:32',NULL,NULL),(1251,'00729','S','Urb Las Vegas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(32943,'36571','S','Saraland','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.822782,-88.095227,0,'2013-07-06 12:44:32',NULL,NULL),(32675,'36266','S','Highland','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(32586,'36123','P','Shakespeare','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.364931,-86.298471,0,'2013-07-06 12:44:32',NULL,NULL),(29766,'33009','S','Hallandale Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(9759,'10103','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(49217,'56465','S','Merrifield','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.462831,-94.175144,0,'2013-07-06 12:44:33',NULL,NULL),(54773,'62994','S','Vergennes','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.910383,-89.321947,0,'2013-07-06 12:44:33',NULL,NULL),(59360,'70578','S','Rayne','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.234611,-92.266913,0,'2013-07-06 12:44:33',NULL,NULL),(59667,'71055','S','Dixie Inn','A','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.617484,-93.281086,0,'2013-07-06 12:44:33',NULL,NULL),(59757,'71154','U','Premier Bank','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.492906,-93.766371,0,'2013-07-06 12:44:33',NULL,NULL),(61110,'72143','S','Georgetown','A','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.252280,-91.849260,0,'2013-07-06 12:44:33',NULL,NULL),(71800,'87566','S','El Guique','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(75894,'94971','P','Tomales','D','Marin','06041','California','CA','06','7360','707','Pacific',-8.0,'Y',38.248863,-122.899922,0,'2013-07-06 12:44:34',NULL,NULL),(60584,'71823','P','Ben Lomond','D','Sevier','05133','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.835180,-94.119060,0,'2013-07-06 12:44:33',NULL,NULL),(33406,'37230','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.148709,-86.785305,0,'2013-07-06 12:44:32',NULL,NULL),(53120,'61545','S','Lowpoint','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.850278,-89.331944,0,'2013-07-06 12:44:33',NULL,NULL),(41742,'47270','S','Paris Crossing','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.855889,-85.743535,0,'2013-07-06 12:44:32',NULL,NULL),(23355,'25266','S','Newton','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.617778,-81.143333,0,'2013-07-06 12:44:31',NULL,NULL),(67975,'80915','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.856009,-104.716668,0,'2013-07-06 12:44:34',NULL,NULL),(18345,'19033','S','Milmont Park','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889987,-75.326801,0,'2013-07-06 12:44:31',NULL,NULL),(37848,'42501','S','Alcalde','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(17269,'17843','S','Middle Creek','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.761720,-77.256740,0,'2013-07-06 12:44:31',NULL,NULL),(14922,'15546','S','Jenners','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.141601,-79.048110,0,'2013-07-06 12:44:31',NULL,NULL),(6354,'05674','S','Sugarbush Vly','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.129916,-72.879337,0,'2013-07-06 12:44:30',NULL,NULL),(40951,'46304','S','Dune Acres','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.617037,-87.028793,0,'2013-07-06 12:44:32',NULL,NULL),(21380,'22481','P','Jersey','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.210480,-77.137268,0,'2013-07-06 12:44:31',NULL,NULL),(71470,'87059','S','Tijeras','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.015760,-106.279680,0,'2013-07-06 12:44:34',NULL,NULL),(38510,'43717','P','Belle Valley','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.802138,-81.551969,0,'2013-07-06 12:44:32',NULL,NULL),(6475,'05764','S','Poultney','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.518045,-73.236985,0,'2013-07-06 12:44:30',NULL,NULL),(22134,'23450','P','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.844030,-76.093079,0,'2013-07-06 12:44:31',NULL,NULL),(25459,'28331','P','Cumberland','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',34.998959,-78.973679,0,'2013-07-06 12:44:31',NULL,NULL),(47971,'55125','S','Woodbury','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.905320,-92.923260,0,'2013-07-06 12:44:33',NULL,NULL),(51461,'59521','S','Rocky Boy','N','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.320436,-109.832831,0,'2013-07-06 12:44:33',NULL,NULL),(78402,'98034','S','Totem Lake','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.718053,-122.198946,0,'2013-07-06 12:44:34',NULL,NULL),(33985,'38114','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.102122,-89.980902,0,'2013-07-06 12:44:32',NULL,NULL),(31199,'33946','S','Cape Haze','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.851772,-82.287635,0,'2013-07-06 12:44:32',NULL,NULL),(43913,'49256','S','Seneca','A','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.743671,-84.217238,0,'2013-07-06 12:44:32',NULL,NULL),(41301,'46766','S','Liberty Center','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.707359,-85.290083,0,'2013-07-06 12:44:32',NULL,NULL),(27007,'29638','S','Donalds','D','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.374350,-82.272156,0,'2013-07-06 12:44:31',NULL,NULL),(28144,'30821','S','Norwood','D','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.462193,-82.706161,0,'2013-07-06 12:44:31',NULL,NULL),(29662,'32909','S','Grant Vlkria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.969161,-80.647489,0,'2013-07-06 12:44:32',NULL,NULL),(68143,'80995','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.964661,-104.792493,0,'2013-07-06 12:44:34',NULL,NULL),(70285,'84532','S','Natural Bridges','N','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(47104,'54443','S','Junction City','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.604785,-89.748588,0,'2013-07-06 12:44:32',NULL,NULL),(69189,'83340','S','Ketchum','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.733354,-114.512415,0,'2013-07-06 12:44:34',NULL,NULL),(40255,'45430','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(13897,'14273','U','Bflo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870716,-78.869699,0,'2013-07-06 12:44:31',NULL,NULL),(13076,'13456','S','Sauquoit','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.000560,-75.269760,0,'2013-07-06 12:44:30',NULL,NULL),(32768,'36362','S','Fort Rucker','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.348835,-85.719366,0,'2013-07-06 12:44:32',NULL,NULL),(29129,'32320','S','Apalachicola','D','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.724173,-84.999118,0,'2013-07-06 12:44:32',NULL,NULL),(20402,'20901','S','Takoma Park','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.018164,-77.008298,0,'2013-07-06 12:44:31',NULL,NULL),(25616,'28460','S','Sneads Ferry','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.531918,-77.387722,0,'2013-07-06 12:44:31',NULL,NULL),(72080,'88134','S','Taiban','D','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.352414,-104.034639,0,'2013-07-06 12:44:34',NULL,NULL),(74312,'92386','P','Sugarloaf','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.261111,-116.844167,0,'2013-07-06 12:44:34',NULL,NULL),(62819,'74955','S','Sallisaw','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.458935,-94.786707,0,'2013-07-06 12:44:33',NULL,NULL),(44553,'50009','S','Adventureland Estates','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.649151,-93.469244,0,'2013-07-06 12:44:32',NULL,NULL),(26122,'28732','S','Carolina Hills','N','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.421548,-82.499968,0,'2013-07-06 12:44:31',NULL,NULL),(6347,'05673','S','Fayston','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.187565,-72.843339,0,'2013-07-06 12:44:30',NULL,NULL),(34382,'38617','S','Rudyard','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.393358,-90.490310,0,'2013-07-06 12:44:32',NULL,NULL),(3191,'01343','S','Drury','D','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.643800,-72.987878,0,'2013-07-06 12:44:30',NULL,NULL),(3908,'02456','P','New Town','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.333573,-71.204106,0,'2013-07-06 12:44:30',NULL,NULL),(8211,'07945','S','Mendham','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.782239,-74.596638,0,'2013-07-06 12:44:30',NULL,NULL),(13068,'13452','S','Lassellsville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(53858,'62330','S','Adrian','A','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.632034,-91.172512,0,'2013-07-06 12:44:33',NULL,NULL),(36721,'41031','S','Colville','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(66872,'79223','S','Cee Vee','D','Cottle','48101','Texas','TX','48','0000','940','Central',-6.0,'Y',34.069136,-100.277443,0,'2013-07-06 12:44:34',NULL,NULL),(4440,'03244','S','Hillsborough','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.132803,-71.929453,0,'2013-07-06 12:44:30',NULL,NULL),(6720,'06070','S','Simbury','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.876721,-72.822749,0,'2013-07-06 12:44:30',NULL,NULL),(36006,'40150','S','Lebanon Junction','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.853195,-85.729211,0,'2013-07-06 12:44:32',NULL,NULL),(34027,'38131','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.063425,-89.993345,0,'2013-07-06 12:44:32',NULL,NULL),(47224,'54498','S','Maplehurst','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953103,-90.595538,0,'2013-07-06 12:44:32',NULL,NULL),(48153,'55371','S','Princeton','D','Mille Lacs','27095','Minnesota','MN','27','0000','763','Central',-6.0,'Y',45.571897,-93.588076,0,'2013-07-06 12:44:33',NULL,NULL),(48315,'55444','S','Brooklyn Park','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.088050,-93.296289,0,'2013-07-06 12:44:33',NULL,NULL),(48520,'55746','S','Little Swan','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(49992,'57369','S','Academy','A','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.405260,-98.888040,0,'2013-07-06 12:44:33',NULL,NULL),(60994,'72112','S','Fitzgerald','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(67831,'80808','S','Calhan','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.976792,-104.316048,0,'2013-07-06 12:44:34',NULL,NULL),(75687,'94558','S','Napa','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.343537,-122.305067,0,'2013-07-06 12:44:34',NULL,NULL),(75825,'94903','S','Terra Linda','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.013354,-122.548797,0,'2013-07-06 12:44:34',NULL,NULL),(62761,'74852','S','Macomb','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.118011,-97.038526,0,'2013-07-06 12:44:33',NULL,NULL),(61138,'72160','S','One Horse Store','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(9556,'10023','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(48334,'55460','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.984357,-93.269822,0,'2013-07-06 12:44:33',NULL,NULL),(44002,'49346','S','Stanwood','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.590116,-85.361863,0,'2013-07-06 12:44:32',NULL,NULL),(1016,'00718','S','Jard De La Via','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(37167,'41472','S','Matthew','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(60653,'71913','S','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.424690,-93.096290,0,'2013-07-06 12:44:33',NULL,NULL),(40538,'45841','S','Jenera','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.886220,-83.722860,0,'2013-07-06 12:44:32',NULL,NULL),(15533,'16563','U','Behrend College','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.122676,-79.983259,0,'2013-07-06 12:44:31',NULL,NULL),(34942,'39047','S','Brandon','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.273533,-89.985922,0,'2013-07-06 12:44:32',NULL,NULL),(34850,'38924','S','Cruger','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.293145,-90.230924,0,'2013-07-06 12:44:32',NULL,NULL),(50585,'58233','S','Ops','N','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.237188,-97.447403,0,'2013-07-06 12:44:33',NULL,NULL),(55959,'64494','S','Union Star','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.978656,-94.597443,0,'2013-07-06 12:44:33',NULL,NULL),(60779,'72020','S','Bradford','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.549950,-91.438267,0,'2013-07-06 12:44:33',NULL,NULL),(65769,'78107','P','Berclair','D','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.532318,-97.588001,0,'2013-07-06 12:44:34',NULL,NULL),(17403,'17901','S','Palo Alto','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(58907,'69218','S','Merriman','D','Cherry','31031','Nebraska','NE','31','0000','308','Central',-6.0,'Y',42.921590,-101.706650,0,'2013-07-06 12:44:33',NULL,NULL),(69866,'84093','S','Cottonwood Heights','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.590896,-111.828061,0,'2013-07-06 12:44:34',NULL,NULL),(69728,'84041','S','West Layton','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.059983,-112.008085,0,'2013-07-06 12:44:34',NULL,NULL),(62386,'74081','S','Terlton','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.192149,-96.486493,0,'2013-07-06 12:44:33',NULL,NULL),(60078,'71356','S','Le Moyen','A','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.824220,-92.041680,0,'2013-07-06 12:44:33',NULL,NULL),(52993,'61443','S','Kewanee','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.240215,-89.930304,0,'2013-07-06 12:44:33',NULL,NULL),(51213,'59046','S','Cushman','N','Golden Valley','30037','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.227533,-108.713743,0,'2013-07-06 12:44:33',NULL,NULL),(48422,'55604','S','Maple Hill','N','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.800000,-90.300000,0,'2013-07-06 12:44:33',NULL,NULL),(17955,'18518','S','Old Forge','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.375757,-75.741012,0,'2013-07-06 12:44:31',NULL,NULL),(12828,'13309','S','Boonville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.453080,-75.336000,0,'2013-07-06 12:44:30',NULL,NULL),(11448,'11977','S','Westhampton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.819853,-72.666788,0,'2013-07-06 12:44:30',NULL,NULL),(11410,'11958','S','Peconic','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.041580,-72.458859,0,'2013-07-06 12:44:30',NULL,NULL),(2829,'00979','S','Urb Villamar','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(10471,'10941','S','Middletown','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.463349,-74.421398,0,'2013-07-06 12:44:30',NULL,NULL),(57020,'66206','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(9219,'09511','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71533,'87131','U','Univ of New Mexico','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.089423,-106.619821,0,'2013-07-06 12:44:34',NULL,NULL),(62328,'74045','S','Maramec','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.216245,-96.677382,0,'2013-07-06 12:44:33',NULL,NULL),(49315,'56545','S','Gary','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.369160,-96.193999,0,'2013-07-06 12:44:33',NULL,NULL),(17696,'18216','S','Beaver Mdws','A','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.929263,-75.912405,0,'2013-07-06 12:44:31',NULL,NULL),(71201,'86054','P','Tonalea','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.592945,-110.656759,0,'2013-07-06 12:44:34',NULL,NULL),(50512,'58075','S','Great Bend','A','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.273495,-96.609475,0,'2013-07-06 12:44:33',NULL,NULL),(45805,'52175','S','Douglas','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.969660,-91.800840,0,'2013-07-06 12:44:32',NULL,NULL),(40906,'46259','S','Acton','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.656811,-85.996975,0,'2013-07-06 12:44:32',NULL,NULL),(32331,'35771','S','Section','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.580858,-85.989749,0,'2013-07-06 12:44:32',NULL,NULL),(55275,'63465','S','Revere','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.495020,-91.677480,0,'2013-07-06 12:44:33',NULL,NULL),(26988,'29623','P','AND','N','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.519837,-82.717055,0,'2013-07-06 12:44:31',NULL,NULL),(26881,'29555','S','Poston','A','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.817535,-79.451852,0,'2013-07-06 12:44:31',NULL,NULL),(24971,'27846','S','Jamesville','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.810294,-76.905822,0,'2013-07-06 12:44:31',NULL,NULL),(44612,'50056','S','Colo','D','Story','19169','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.017715,-93.315659,0,'2013-07-06 12:44:32',NULL,NULL),(66816,'79085','S','Summerfield','D','Castro','48069','Texas','TX','48','0000','806','Central',-6.0,'Y',34.711045,-102.480510,0,'2013-07-06 12:44:34',NULL,NULL),(1292,'00730','S','Urb Jaime L Drew','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(30156,'33169','S','North Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.935490,-80.214010,0,'2013-07-06 12:44:32',NULL,NULL),(55337,'63555','S','Memphis','D','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.457615,-92.169013,0,'2013-07-06 12:44:33',NULL,NULL),(43330,'48363','S','Oakland','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.764292,-83.166518,0,'2013-07-06 12:44:32',NULL,NULL),(55265,'63461','S','South River','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.797789,-91.526300,0,'2013-07-06 12:44:33',NULL,NULL),(66823,'79093','P','Waka','D','Ochiltree','48357','Texas','TX','48','0000','806','Central',-6.0,'Y',36.279937,-100.816771,0,'2013-07-06 12:44:34',NULL,NULL),(74859,'93255','S','Onyx','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.700418,-118.192403,0,'2013-07-06 12:44:34',NULL,NULL),(27165,'29836','S','Martin','D','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.096723,-81.525746,0,'2013-07-06 12:44:31',NULL,NULL),(79680,'99173','S','Springdale','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.056680,-117.743339,0,'2013-07-06 12:44:34',NULL,NULL),(63023,'75182','S','Mesquite','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.782434,-96.554366,0,'2013-07-06 12:44:33',NULL,NULL),(60129,'71371','S','White Sulphur Springs','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(26862,'29536','S','Floyd Dale','A','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.414774,-79.364457,0,'2013-07-06 12:44:31',NULL,NULL),(23411,'25331','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.350011,-81.629325,0,'2013-07-06 12:44:31',NULL,NULL),(21790,'23075','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.546429,-77.325289,0,'2013-07-06 12:44:31',NULL,NULL),(1516,'00754','S','Jard de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(16067,'17049','S','Bunkertown','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(31417,'34242','S','Crescent Beach','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.270991,-82.547525,0,'2013-07-06 12:44:32',NULL,NULL),(67189,'79855','P','Van Horn','D','Culberson','48109','Texas','TX','48','0000','915','Central',-6.0,'Y',31.060000,-104.210000,0,'2013-07-06 12:44:34',NULL,NULL),(51590,'59807','P','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.968666,-113.967458,0,'2013-07-06 12:44:33',NULL,NULL),(611,'00680','S','Villa Sultanita','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(57180,'66406','S','Beattie','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.861607,-96.420383,0,'2013-07-06 12:44:33',NULL,NULL),(16730,'17408','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015315,-76.597579,0,'2013-07-06 12:44:31',NULL,NULL),(12023,'12512','P','Chelsea','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.554815,-73.965035,0,'2013-07-06 12:44:30',NULL,NULL),(14594,'15222','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.448765,-79.991418,0,'2013-07-06 12:44:31',NULL,NULL),(37103,'41351','S','Mistletoe','D','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.318317,-83.581646,0,'2013-07-06 12:44:32',NULL,NULL),(74063,'92164','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.751071,-117.127245,0,'2013-07-06 12:44:34',NULL,NULL),(71923,'87829','S','Red Hill','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.311420,-108.809880,0,'2013-07-06 12:44:34',NULL,NULL),(61844,'73117','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.480060,-97.473067,0,'2013-07-06 12:44:33',NULL,NULL),(59789,'71218','P','Archibald','D','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.349414,-91.775739,0,'2013-07-06 12:44:33',NULL,NULL),(44208,'49632','S','Falmouth','D','Missaukee','26113','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.256075,-85.024453,0,'2013-07-06 12:44:32',NULL,NULL),(19813,'20451','U','Arms Control and Disarm Agy','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894433,-77.046676,0,'2013-07-06 12:44:31',NULL,NULL),(19396,'20071','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903241,-77.036061,0,'2013-07-06 12:44:31',NULL,NULL),(12366,'12910','S','Purdys Mills','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.882237,-73.662504,0,'2013-07-06 12:44:30',NULL,NULL),(28674,'31793','S','Tifton','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.465874,-83.505876,0,'2013-07-06 12:44:32',NULL,NULL),(12507,'13024','U','Auburn State Prison','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920638,-76.552564,0,'2013-07-06 12:44:30',NULL,NULL),(7809,'07442','S','Pompton Lakes','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.000492,-74.286910,0,'2013-07-06 12:44:30',NULL,NULL),(2037,'00918','S','Ext Roosevelt','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(2122,'00924','S','Colinas Verde','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(31179,'33924','P','Captiva','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.519264,-82.188154,0,'2013-07-06 12:44:32',NULL,NULL),(15938,'17022','S','Bellaire','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(5035,'04257','S','Mexico','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.555597,-70.539231,0,'2013-07-06 12:44:30',NULL,NULL),(30398,'33322','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.150168,-80.273686,0,'2013-07-06 12:44:32',NULL,NULL),(30167,'33172','S','West Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796061,-80.360119,0,'2013-07-06 12:44:32',NULL,NULL),(55632,'64011','S','Bates City','D','Lafayette','29107','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.979798,-94.070890,0,'2013-07-06 12:44:33',NULL,NULL),(72793,'89702','P','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.069397,-119.792347,0,'2013-07-06 12:44:34',NULL,NULL),(77411,'96790','S','Kula','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.770144,-156.325085,0,'2013-07-06 12:44:34',NULL,NULL),(78111,'97497','S','Wolf Creek','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.660780,-123.385560,0,'2013-07-06 12:44:34',NULL,NULL),(55532,'63830','S','Caruthersville','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.185729,-89.658756,0,'2013-07-06 12:44:33',NULL,NULL),(70062,'84143','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.779354,-111.880031,0,'2013-07-06 12:44:34',NULL,NULL),(72819,'89820','S','Battle Mtn','A','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.619494,-116.936088,0,'2013-07-06 12:44:34',NULL,NULL),(2432,'00953','S','Urb Los Arboles','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(73323,'90834','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.770162,-118.203615,0,'2013-07-06 12:44:34',NULL,NULL),(66742,'78962','S','Osage','N','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.685660,-96.728400,0,'2013-07-06 12:44:34',NULL,NULL),(55467,'63740','S','Rockview','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.185720,-89.647920,0,'2013-07-06 12:44:33',NULL,NULL),(53525,'62028','S','Elsah','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.964120,-90.331920,0,'2013-07-06 12:44:33',NULL,NULL),(26545,'29206','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(12654,'13118','S','Montville','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.730440,-76.380600,0,'2013-07-06 12:44:30',NULL,NULL),(14807,'15411','S','Addison','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.777122,-79.306950,0,'2013-07-06 12:44:31',NULL,NULL),(30542,'33410','S','N Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(37363,'41727','S','Chavies','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.361634,-83.321070,0,'2013-07-06 12:44:32',NULL,NULL),(38293,'43341','S','New Bloomington','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.591276,-83.317071,0,'2013-07-06 12:44:32',NULL,NULL),(38333,'43434','P','Harbor View','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.677710,-83.519921,0,'2013-07-06 12:44:32',NULL,NULL),(3538,'01908','S','Nahant','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.426338,-70.924198,0,'2013-07-06 12:44:30',NULL,NULL),(23862,'26146','S','Friendly','D','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.492550,-81.013419,0,'2013-07-06 12:44:31',NULL,NULL),(26508,'29172','S','Cayce','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.898509,-81.092152,0,'2013-07-06 12:44:31',NULL,NULL),(7781,'07422','S','Barry Lakes','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.187240,-74.453760,0,'2013-07-06 12:44:30',NULL,NULL),(76602,'95690','S','Grand Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(64261,'76380','S','Vera','A','Baylor','48023','Texas','TX','48','0000','940','Central',-6.0,'Y',33.591147,-99.263331,0,'2013-07-06 12:44:34',NULL,NULL),(55404,'63645','S','Fredericktown','D','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.559762,-90.292995,0,'2013-07-06 12:44:33',NULL,NULL),(38970,'44128','S','Warrensville Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(26117,'28728','P','Enka','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.541407,-82.643640,0,'2013-07-06 12:44:31',NULL,NULL),(8451,'08087','S','Leh','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(8100,'07765','P','Wickatunk','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.350285,-74.248034,0,'2013-07-06 12:44:30',NULL,NULL),(22532,'24112','S','Martinsville','D','Martinsville City','51690','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.685246,-79.865321,0,'2013-07-06 12:44:31',NULL,NULL),(79356,'98640','S','Ocean Park','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.531235,-124.048847,0,'2013-07-06 12:44:34',NULL,NULL),(77580,'96915','S','Merizo','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(75830,'94913','P','San Rafael','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.025782,-122.544870,0,'2013-07-06 12:44:34',NULL,NULL),(74438,'92571','S','Perris','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.820593,-117.202999,0,'2013-07-06 12:44:34',NULL,NULL),(73950,'92058','S','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.182717,-117.295644,0,'2013-07-06 12:44:34',NULL,NULL),(72942,'90037','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.000915,-118.288342,0,'2013-07-06 12:44:34',NULL,NULL),(70251,'84414','S','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.315661,-111.978351,0,'2013-07-06 12:44:34',NULL,NULL),(62398,'74107','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.100711,-96.030063,0,'2013-07-06 12:44:33',NULL,NULL),(29629,'32886','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.541241,-81.380821,0,'2013-07-06 12:44:32',NULL,NULL),(25533,'28401','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.229055,-77.935953,0,'2013-07-06 12:44:31',NULL,NULL),(14518,'15203','S','Carson','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.424202,-79.975101,0,'2013-07-06 12:44:31',NULL,NULL),(20360,'20875','P','Germantown','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.176434,-77.262513,0,'2013-07-06 12:44:31',NULL,NULL),(7508,'06927','U','Gecc','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.043828,-73.548111,0,'2013-07-06 12:44:30',NULL,NULL),(4907,'04064','S','Old Orchd Bch','A','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.526400,-70.392180,0,'2013-07-06 12:44:30',NULL,NULL),(7086,'06351','S','Griswold','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.601907,-71.977075,0,'2013-07-06 12:44:30',NULL,NULL),(9066,'08933','U','New Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.486376,-74.445210,0,'2013-07-06 12:44:30',NULL,NULL),(4246,'02874','S','Saunderstown','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.515080,-71.467380,0,'2013-07-06 12:44:30',NULL,NULL),(46878,'54107','S','Bonduel','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.695751,-88.437835,0,'2013-07-06 12:44:32',NULL,NULL),(74342,'92407','S','Cajon Junction','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(52613,'61030','S','Forreston','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.116467,-89.581432,0,'2013-07-06 12:44:33',NULL,NULL),(49354,'56575','S','Ponsford','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.039423,-95.308645,0,'2013-07-06 12:44:33',NULL,NULL),(66957,'79380','P','Whitharral','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.736476,-102.325231,0,'2013-07-06 12:44:34',NULL,NULL),(5594,'04921','S','Jackson','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.519428,-69.099703,0,'2013-07-06 12:44:30',NULL,NULL),(70389,'84701','S','Bowery Haven','N','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.675160,-111.989820,0,'2013-07-06 12:44:34',NULL,NULL),(71427,'87027','S','La Jara','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',36.110729,-106.993790,0,'2013-07-06 12:44:34',NULL,NULL),(74225,'92316','S','Bloomington','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.069928,-117.397247,0,'2013-07-06 12:44:34',NULL,NULL),(5867,'05144','P','Chester Depot','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.286631,-72.634544,0,'2013-07-06 12:44:30',NULL,NULL),(37853,'42501','S','Somerset','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(12333,'12870','S','Schroon Lake','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.839600,-73.760220,0,'2013-07-06 12:44:30',NULL,NULL),(19667,'20317','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.942652,-77.012337,0,'2013-07-06 12:44:31',NULL,NULL),(47898,'55108','S','Falcon Hgts','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.982543,-93.179571,0,'2013-07-06 12:44:33',NULL,NULL),(58268,'68381','S','Liberty','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.082959,-96.516995,0,'2013-07-06 12:44:33',NULL,NULL),(61590,'72757','P','Rogers','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.333653,-94.127310,0,'2013-07-06 12:44:33',NULL,NULL),(65062,'77343','U','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722802,-95.548721,0,'2013-07-06 12:44:34',NULL,NULL),(67356,'80111','S','Cherry Hills','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(77808,'97141','S','Lees Camp','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.466380,-123.716940,0,'2013-07-06 12:44:34',NULL,NULL),(78098,'97488','S','Finn Rock','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.133120,-122.463360,0,'2013-07-06 12:44:34',NULL,NULL),(39676,'45014','S','Village Of Indian Springs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.334440,-84.562260,0,'2013-07-06 12:44:32',NULL,NULL),(58168,'68198','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.265996,-96.010026,0,'2013-07-06 12:44:33',NULL,NULL),(58106,'68116','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.289542,-96.170593,0,'2013-07-06 12:44:33',NULL,NULL),(1192,'00728','S','Ext Jard del Caribe','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(4792,'03873','S','Sandown','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.929720,-71.186162,0,'2013-07-06 12:44:30',NULL,NULL),(33650,'37708','S','Tate Springs','N','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.338879,-83.325091,0,'2013-07-06 12:44:32',NULL,NULL),(33171,'37027','S','Forest Hills','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.002450,-86.791159,0,'2013-07-06 12:44:32',NULL,NULL),(22194,'23506','P','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.856945,-76.211968,0,'2013-07-06 12:44:31',NULL,NULL),(74139,'92250','S','Bonds Corner','N','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.808254,-115.375136,0,'2013-07-06 12:44:34',NULL,NULL),(78204,'97739','S','La Pine','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.704905,-121.531851,0,'2013-07-06 12:44:34',NULL,NULL),(61862,'73123','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.537598,-97.621042,0,'2013-07-06 12:44:33',NULL,NULL),(14258,'14837','S','Dundee','D','Yates','36123','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.525317,-76.973125,0,'2013-07-06 12:44:31',NULL,NULL),(41142,'46699','U','Business Reply','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.671706,-86.252194,0,'2013-07-06 12:44:32',NULL,NULL),(18937,'19506','S','New Schaefferstown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.448100,-76.133040,0,'2013-07-06 12:44:31',NULL,NULL),(73577,'91380','P','Valencia','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.499933,-118.394976,0,'2013-07-06 12:44:34',NULL,NULL),(5695,'04979','S','Solon','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.951130,-69.853389,0,'2013-07-06 12:44:30',NULL,NULL),(9902,'10130','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754891,-74.003971,0,'2013-07-06 12:44:30',NULL,NULL),(41854,'47353','S','Treaty Line Museum','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(51374,'59403','P','Great Falls','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.553383,-111.540413,0,'2013-07-06 12:44:33',NULL,NULL),(55409,'63650','S','Iron Mountain','N','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.601823,-90.629002,0,'2013-07-06 12:44:33',NULL,NULL),(61531,'72672','P','Pyatt','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.217134,-92.737719,0,'2013-07-06 12:44:33',NULL,NULL),(78798,'98324','P','Carlsborg','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.106925,-123.175464,0,'2013-07-06 12:44:34',NULL,NULL),(39900,'45215','S','Lockland','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(13552,'13832','S','Plymouth','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.631654,-75.620930,0,'2013-07-06 12:44:31',NULL,NULL),(61466,'72631','S','Busch','A','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.400948,-93.736695,0,'2013-07-06 12:44:33',NULL,NULL),(43261,'48326','S','Auburn Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.664620,-83.273880,0,'2013-07-06 12:44:32',NULL,NULL),(9953,'10157','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743962,-73.977191,0,'2013-07-06 12:44:30',NULL,NULL),(23415,'25335','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.349999,-81.629054,0,'2013-07-06 12:44:31',NULL,NULL),(9356,'09812','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(906,'00705','S','Urb Bella Vista','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(5647,'04953','S','Newport','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.831227,-69.266093,0,'2013-07-06 12:44:30',NULL,NULL),(24875,'27695','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.803047,-78.713095,0,'2013-07-06 12:44:31',NULL,NULL),(50934,'58570','S','Solen','D','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.276735,-100.808228,0,'2013-07-06 12:44:33',NULL,NULL),(50201,'57571','S','Saint Charles','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.108303,-99.115247,0,'2013-07-06 12:44:33',NULL,NULL),(46298,'53056','P','Merton','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.147758,-88.307088,0,'2013-07-06 12:44:32',NULL,NULL),(29868,'33040','S','Key West Nas','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(5505,'04764','S','Oxbow','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.403080,-68.550291,0,'2013-07-06 12:44:30',NULL,NULL),(32932,'36561','S','Orange Beach','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.296786,-87.548627,0,'2013-07-06 12:44:32',NULL,NULL),(16185,'17067','S','Reistville','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(24052,'26424','P','Rosemont','D','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.265886,-80.160007,0,'2013-07-06 12:44:31',NULL,NULL),(46496,'53227','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994705,-88.042267,0,'2013-07-06 12:44:32',NULL,NULL),(50940,'58575','S','Turtle Lake','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.518146,-100.890776,0,'2013-07-06 12:44:33',NULL,NULL),(58415,'68644','S','Lindsay','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.705080,-97.697472,0,'2013-07-06 12:44:33',NULL,NULL),(62673,'74652','S','Foraker','A','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.872222,-96.565278,0,'2013-07-06 12:44:33',NULL,NULL),(76194,'95348','S','Merced','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.331406,-120.499796,0,'2013-07-06 12:44:34',NULL,NULL),(16614,'17331','S','Grangeville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(51050,'58736','S','Guthrie','N','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.926901,-100.372610,0,'2013-07-06 12:44:33',NULL,NULL),(42947,'48122','S','Melvindale','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.277639,-83.181617,0,'2013-07-06 12:44:32',NULL,NULL),(61445,'72611','S','Alpena','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.300437,-93.274506,0,'2013-07-06 12:44:33',NULL,NULL),(20022,'20624','S','Clements','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.341980,-76.733728,0,'2013-07-06 12:44:31',NULL,NULL),(19497,'20160','P','Lincoln','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.116202,-77.693967,0,'2013-07-06 12:44:31',NULL,NULL),(76174,'95326','S','Hughson','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.596929,-120.858572,0,'2013-07-06 12:44:34',NULL,NULL),(3184,'01339','S','West Hawley','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.645420,-72.880260,0,'2013-07-06 12:44:30',NULL,NULL),(40490,'45784','S','Vincent','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.333552,-81.675363,0,'2013-07-06 12:44:32',NULL,NULL),(3138,'01252','P','North Egremont','D','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.196701,-73.436284,0,'2013-07-06 12:44:30',NULL,NULL),(50301,'57702','S','Rapid City','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.063037,-103.280916,0,'2013-07-06 12:44:33',NULL,NULL),(64600,'76681','S','Richland','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.879527,-96.446943,0,'2013-07-06 12:44:34',NULL,NULL),(74976,'93438','P','Lompoc','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.636380,-120.469031,0,'2013-07-06 12:44:34',NULL,NULL),(40651,'46036','S','West Elwood','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(37518,'42041','S','Crutchfield','A','Fulton','21075','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.531900,-88.947480,0,'2013-07-06 12:44:32',NULL,NULL),(5151,'04418','S','Olamon','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(22082,'23395','S','Horntown','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.970467,-75.475713,0,'2013-07-06 12:44:31',NULL,NULL),(51306,'59230','S','Tampico','N','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.198389,-106.625201,0,'2013-07-06 12:44:33',NULL,NULL),(17159,'17812','S','Middle Creek','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.770100,-77.247271,0,'2013-07-06 12:44:31',NULL,NULL),(302,'00646','S','Urb Los Prados Sur','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(18806,'19403','S','Audubon','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(27573,'30270','U','Fayetteville','A','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396971,-84.592052,0,'2013-07-06 12:44:31',NULL,NULL),(69685,'84026','S','Fort Duchesne','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.294221,-109.839602,0,'2013-07-06 12:44:34',NULL,NULL),(74519,'92650','P','East Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.679458,-117.760857,0,'2013-07-06 12:44:34',NULL,NULL),(59892,'71272','U','Louisiana Tech','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.529801,-92.650160,0,'2013-07-06 12:44:33',NULL,NULL),(12489,'12995','P','Whippleville','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.808327,-74.261237,0,'2013-07-06 12:44:30',NULL,NULL),(7916,'07632','S','Englewd Clfs','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.883283,-73.954892,0,'2013-07-06 12:44:30',NULL,NULL),(41622,'47129','S','Cementville','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.316146,-85.769135,0,'2013-07-06 12:44:32',NULL,NULL),(43141,'48237','S','Detroit','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465540,-83.197380,0,'2013-07-06 12:44:32',NULL,NULL),(48159,'55374','S','Corcoran','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.173877,-93.567994,0,'2013-07-06 12:44:33',NULL,NULL),(50318,'57722','S','Buffalo Gap','D','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.516065,-103.261524,0,'2013-07-06 12:44:33',NULL,NULL),(55914,'64449','S','Fillmore','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',40.003091,-94.948412,0,'2013-07-06 12:44:33',NULL,NULL),(71958,'88002','S','White Sands','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.263759,-106.471871,0,'2013-07-06 12:44:34',NULL,NULL),(55971,'64505','S','St Joseph','N','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.791709,-94.841238,0,'2013-07-06 12:44:33',NULL,NULL),(12994,'13409','S','Stockbridge','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.950700,-75.568980,0,'2013-07-06 12:44:30',NULL,NULL),(28669,'31791','S','Sylvester','D','Worth','13321','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.531174,-83.842342,0,'2013-07-06 12:44:32',NULL,NULL),(22608,'24212','P','Abingdon','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.706928,-81.974386,0,'2013-07-06 12:44:31',NULL,NULL),(19069,'19551','S','Robesonia','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.352879,-76.135855,0,'2013-07-06 12:44:31',NULL,NULL),(2339,'00936','P','Old San Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(50205,'57574','S','Tuthill','D','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.095698,-101.439977,0,'2013-07-06 12:44:33',NULL,NULL),(43900,'49246','S','Horton','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.118300,-84.501820,0,'2013-07-06 12:44:32',NULL,NULL),(28275,'31085','S','Kelly','N','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.398491,-83.659553,0,'2013-07-06 12:44:31',NULL,NULL),(38319,'43407','S','Burgoon','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.277987,-83.245497,0,'2013-07-06 12:44:32',NULL,NULL),(8572,'08215','S','Egg Harbor City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(40213,'45404','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.785814,-84.160985,0,'2013-07-06 12:44:32',NULL,NULL),(9592,'10029','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(70407,'84718','P','Cannonville','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.564981,-112.057416,0,'2013-07-06 12:44:34',NULL,NULL),(62045,'73527','S','Cache','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.631259,-98.625510,0,'2013-07-06 12:44:33',NULL,NULL),(50140,'57533','S','Dixon','A','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.233905,-99.427134,0,'2013-07-06 12:44:33',NULL,NULL),(46551,'53408','P','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.725298,-87.808915,0,'2013-07-06 12:44:32',NULL,NULL),(41714,'47240','S','Burney','A','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(10677,'11202','P','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.692402,-73.991159,0,'2013-07-06 12:44:30',NULL,NULL),(20940,'21762','P','Libertytown','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.483338,-77.248590,0,'2013-07-06 12:44:31',NULL,NULL),(39597,'44870','S','Sandusky','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.404980,-82.731420,0,'2013-07-06 12:44:32',NULL,NULL),(12067,'12542','S','Marlborough','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.608715,-73.992141,0,'2013-07-06 12:44:30',NULL,NULL),(14223,'14803','S','Alfred Station','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.256785,-77.788411,0,'2013-07-06 12:44:31',NULL,NULL),(40986,'46350','S','Laporte','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.614878,-86.734117,0,'2013-07-06 12:44:32',NULL,NULL),(46522,'53288','U','Bmo Harris Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.043453,-87.912413,0,'2013-07-06 12:44:32',NULL,NULL),(39974,'45238','S','Delhi','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.110911,-84.613884,0,'2013-07-06 12:44:32',NULL,NULL),(6370,'05679','S','Williamstown','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.105138,-72.542504,0,'2013-07-06 12:44:30',NULL,NULL),(18848,'19432','P','Devault','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.080666,-75.534691,0,'2013-07-06 12:44:31',NULL,NULL),(75254,'93662','S','Conejo','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.541105,-119.637973,0,'2013-07-06 12:44:34',NULL,NULL),(70997,'85714','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.175070,-110.966248,0,'2013-07-06 12:44:34',NULL,NULL),(51352,'59326','S','Fallon','D','Prairie','30079','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.675800,-105.139405,0,'2013-07-06 12:44:33',NULL,NULL),(45025,'50464','S','Plymouth','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.247429,-93.124562,0,'2013-07-06 12:44:32',NULL,NULL),(10016,'10170','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(24562,'27301','S','Mc Leansville','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.113388,-79.673916,0,'2013-07-06 12:44:31',NULL,NULL),(28567,'31602','S','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.869486,-83.287532,0,'2013-07-06 12:44:32',NULL,NULL),(28698,'31816','S','Manchester','D','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.856189,-84.621217,0,'2013-07-06 12:44:32',NULL,NULL),(14634,'15234','S','Baldwin','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(37387,'41754','S','Krypton','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.313333,-83.312222,0,'2013-07-06 12:44:32',NULL,NULL),(38086,'43073','P','Summit Station','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.001966,-82.751027,0,'2013-07-06 12:44:32',NULL,NULL),(16758,'17517','S','Fivepointville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.241302,-76.137348,0,'2013-07-06 12:44:31',NULL,NULL),(2405,'00953','S','Alts del Toa','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(23627,'25723','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.423117,-82.440485,0,'2013-07-06 12:44:31',NULL,NULL),(1172,'00727','S','Urb La Reserva','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(36995,'41219','S','Elna','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(56419,'65257','S','Higbee','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.307992,-92.520101,0,'2013-07-06 12:44:33',NULL,NULL),(18148,'18842','S','South Gibson','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.753016,-75.603639,0,'2013-07-06 12:44:31',NULL,NULL),(45663,'52032','S','Bernard','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.334273,-90.835393,0,'2013-07-06 12:44:32',NULL,NULL),(30869,'33672','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.955873,-82.454991,0,'2013-07-06 12:44:32',NULL,NULL),(18558,'19120','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.036043,-75.119434,0,'2013-07-06 12:44:31',NULL,NULL),(24745,'27530','S','Walnut Creek','N','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.379960,-78.097860,0,'2013-07-06 12:44:31',NULL,NULL),(77120,'96151','P','Fallen Leaf','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.942141,-119.981473,0,'2013-07-06 12:44:34',NULL,NULL),(77681,'97034','S','Rivergrove','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.410367,-122.689055,0,'2013-07-06 12:44:34',NULL,NULL),(5740,'05035','S','Brgwtr Cors','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(75226,'93642','P','Mono Hot Spgs','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.326667,-119.016667,0,'2013-07-06 12:44:34',NULL,NULL),(66973,'79411','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.570446,-101.861236,0,'2013-07-06 12:44:34',NULL,NULL),(66399,'78628','S','Sun City','A','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.665203,-97.707564,0,'2013-07-06 12:44:34',NULL,NULL),(57714,'67353','S','Moline','D','Elk','20049','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.367151,-96.301387,0,'2013-07-06 12:44:33',NULL,NULL),(55180,'63373','S','Prtg de Sioux','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.924848,-90.364053,0,'2013-07-06 12:44:33',NULL,NULL),(52352,'60608','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.849103,-87.667335,0,'2013-07-06 12:44:33',NULL,NULL),(48437,'55703','S','Angora','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.758363,-92.771783,0,'2013-07-06 12:44:33',NULL,NULL),(26539,'29204','S','Bayview','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.028919,-80.998590,0,'2013-07-06 12:44:31',NULL,NULL),(20089,'20697','U','Southern Md Brm','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.032920,-76.904253,0,'2013-07-06 12:44:31',NULL,NULL),(14992,'15655','S','Laughlintown','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.190921,-79.165971,0,'2013-07-06 12:44:31',NULL,NULL),(2178,'00926','S','Ext Milaville','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(61785,'73074','S','Paoli','D','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.828366,-97.259896,0,'2013-07-06 12:44:33',NULL,NULL),(18458,'19080','U','Radnor','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041159,-75.388173,0,'2013-07-06 12:44:31',NULL,NULL),(22733,'24374','S','Speedwell','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.786136,-81.193948,0,'2013-07-06 12:44:31',NULL,NULL),(64714,'76869','S','Pontotoc','D','Mason','48319','Texas','TX','48','0000','325','Central',-6.0,'Y',30.875755,-99.020982,0,'2013-07-06 12:44:34',NULL,NULL),(64943,'77226','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.801613,-95.328864,0,'2013-07-06 12:44:34',NULL,NULL),(32760,'36351','S','New Brockton','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.382154,-85.931082,0,'2013-07-06 12:44:32',NULL,NULL),(63762,'75943','S','Douglass','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.659041,-94.873128,0,'2013-07-06 12:44:34',NULL,NULL),(53117,'61544','S','London Mills','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.710980,-90.265154,0,'2013-07-06 12:44:33',NULL,NULL),(23153,'25003','S','Alum Creek','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.257455,-81.792680,0,'2013-07-06 12:44:31',NULL,NULL),(76181,'95335','S','Cold Springs','A','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.212980,-120.039480,0,'2013-07-06 12:44:34',NULL,NULL),(54394,'62820','S','Prairie','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.190633,-88.210081,0,'2013-07-06 12:44:33',NULL,NULL),(75839,'94922','S','Bodega','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.375585,-122.983422,0,'2013-07-06 12:44:34',NULL,NULL),(73750,'91723','S','Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.087728,-117.886449,0,'2013-07-06 12:44:34',NULL,NULL),(72834,'89831','S','Mountain City','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.853920,-115.956750,0,'2013-07-06 12:44:34',NULL,NULL),(67536,'80259','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.740324,-104.987582,0,'2013-07-06 12:44:34',NULL,NULL),(60343,'71467','S','Breezy Hill','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498140,-92.421420,0,'2013-07-06 12:44:33',NULL,NULL),(10935,'11434','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(1118,'00725','S','Urb Santa Rosa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(33129,'36877','S','Smiths Sta','A','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.537478,-85.099853,0,'2013-07-06 12:44:32',NULL,NULL),(67092,'79701','S','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.989057,-102.081900,0,'2013-07-06 12:44:34',NULL,NULL),(41897,'47371','S','Liber','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(47260,'54526','S','Glen Flora','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.504780,-90.859620,0,'2013-07-06 12:44:32',NULL,NULL),(72852,'89883','P','Wendover','A','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',40.691330,-114.143019,0,'2013-07-06 12:44:34',NULL,NULL),(51830,'60062','S','Northbrook','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.126945,-87.842535,0,'2013-07-06 12:44:33',NULL,NULL),(73536,'91352','S','La Tuna Canyon','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.224912,-118.360350,0,'2013-07-06 12:44:34',NULL,NULL),(64473,'76577','S','San Gabriel','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(21240,'22241','U','Naval Supply System Command','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.858702,-77.056354,0,'2013-07-06 12:44:31',NULL,NULL),(17672,'18101','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.599392,-75.472595,0,'2013-07-06 12:44:31',NULL,NULL),(385,'00660','S','Villa Zoraida','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(11776,'12204','S','Menands','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.676980,-73.737480,0,'2013-07-06 12:44:30',NULL,NULL),(6789,'06107','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756512,-72.758753,0,'2013-07-06 12:44:30',NULL,NULL),(45696,'52052','S','Millville','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.711000,-91.078680,0,'2013-07-06 12:44:32',NULL,NULL),(3134,'01247','S','No Adams','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.687120,-73.074360,0,'2013-07-06 12:44:30',NULL,NULL),(5452,'04730','S','Linneus','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(22680,'24314','S','Clearfork','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.161780,-81.198480,0,'2013-07-06 12:44:31',NULL,NULL),(79702,'99209','P','Shadle Garland','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.699040,-117.445081,0,'2013-07-06 12:44:34',NULL,NULL),(72229,'88435','S','Puerta D Luna','A','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.936606,-104.684358,0,'2013-07-06 12:44:34',NULL,NULL),(58281,'68407','S','Murdock','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.923635,-96.282292,0,'2013-07-06 12:44:33',NULL,NULL),(45093,'50539','S','Fenton','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.216976,-94.411098,0,'2013-07-06 12:44:32',NULL,NULL),(20669,'21228','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.327900,-76.743960,0,'2013-07-06 12:44:31',NULL,NULL),(20080,'20686','P','Saint Marys City','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.186123,-76.436956,0,'2013-07-06 12:44:31',NULL,NULL),(21828,'23114','S','Midlothian','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.456175,-77.643750,0,'2013-07-06 12:44:31',NULL,NULL),(21960,'23236','S','Richmond','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.478368,-77.582532,0,'2013-07-06 12:44:31',NULL,NULL),(7659,'07083','S','Union','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.691867,-74.269598,0,'2013-07-06 12:44:30',NULL,NULL),(30424,'33328','S','Cooper City','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.066580,-80.272800,0,'2013-07-06 12:44:32',NULL,NULL),(18009,'18640','S','Hughestown','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(34988,'39109','P','Madden','D','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.707565,-89.376192,0,'2013-07-06 12:44:32',NULL,NULL),(15305,'16148','S','Hermitage','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.229960,-80.440500,0,'2013-07-06 12:44:31',NULL,NULL),(16139,'17059','S','East Salem','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(20740,'21297','P','Firms-Courtesy Reply','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295383,-76.609172,0,'2013-07-06 12:44:31',NULL,NULL),(41957,'47404','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.193029,-86.575949,0,'2013-07-06 12:44:32',NULL,NULL),(38073,'43068','S','Etna','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.962571,-82.783851,0,'2013-07-06 12:44:32',NULL,NULL),(52616,'61031','S','Franklin Grv','A','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.830924,-89.306726,0,'2013-07-06 12:44:33',NULL,NULL),(33246,'37075','S','Hendersonvlle','A','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.316241,-86.607771,0,'2013-07-06 12:44:32',NULL,NULL),(44652,'50103','S','Garden Grove','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.717931,-93.614761,0,'2013-07-06 12:44:32',NULL,NULL),(52491,'60697','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879482,-87.615588,0,'2013-07-06 12:44:33',NULL,NULL),(67340,'80104','S','Castle Rock','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.390403,-104.858710,0,'2013-07-06 12:44:34',NULL,NULL),(73453,'91302','S','Monte Nido','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.134741,-118.656723,0,'2013-07-06 12:44:34',NULL,NULL),(77540,'96853','S','Jbphh','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.339051,-157.943329,0,'2013-07-06 12:44:34',NULL,NULL),(58926,'69340','S','Ellsworth','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.174219,-102.458438,0,'2013-07-06 12:44:33',NULL,NULL),(37585,'42088','S','Wingo','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618387,-88.735634,0,'2013-07-06 12:44:32',NULL,NULL),(12755,'13206','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.070202,-76.106706,0,'2013-07-06 12:44:30',NULL,NULL),(19763,'20417','U','Gen Services Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885642,-77.021833,0,'2013-07-06 12:44:31',NULL,NULL),(5178,'04441','S','Beaver Cove','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(4438,'03244','S','Deering','A','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.132803,-71.929453,0,'2013-07-06 12:44:30',NULL,NULL),(962,'00716','S','Urb Alhambra CT','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(40739,'46131','S','Hopewell','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.488252,-86.054873,0,'2013-07-06 12:44:32',NULL,NULL),(38694,'44001','S','Amherst','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(37252,'41560','S','Douglas','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.328847,-82.570316,0,'2013-07-06 12:44:32',NULL,NULL),(33133,'36901','P','Bellamy','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.449118,-88.131892,0,'2013-07-06 12:44:32',NULL,NULL),(20101,'20706','S','Lanham','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.963377,-76.854396,0,'2013-07-06 12:44:31',NULL,NULL),(18747,'19342','S','Glen Mills','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.896140,-75.501769,0,'2013-07-06 12:44:31',NULL,NULL),(51411,'59436','S','Golden Ridge','N','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.614592,-112.099185,0,'2013-07-06 12:44:33',NULL,NULL),(60266,'71447','S','Castor Lane','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(66224,'78562','P','La Villa','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.298317,-97.929404,0,'2013-07-06 12:44:34',NULL,NULL),(77930,'97330','S','Corvallis','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.603787,-123.273273,0,'2013-07-06 12:44:34',NULL,NULL),(39150,'44287','S','Albion','N','Wayne','39169','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.925833,-82.053056,0,'2013-07-06 12:44:32',NULL,NULL),(65752,'78063','S','Medina Lake','N','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.656800,-98.907540,0,'2013-07-06 12:44:34',NULL,NULL),(53339,'61754','S','McLean','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.314947,-89.170467,0,'2013-07-06 12:44:33',NULL,NULL),(31266,'33994','P','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.630413,-81.852216,0,'2013-07-06 12:44:32',NULL,NULL),(44926,'50339','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.597161,-93.746439,0,'2013-07-06 12:44:32',NULL,NULL),(10548,'11001','S','Bellerose Terrace','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(14691,'15255','U','Bell Telephone Co','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.455892,-80.021962,0,'2013-07-06 12:44:31',NULL,NULL),(10098,'10249','P','Church Street Boxes','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(8374,'08054','S','Mount Laurel','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.946438,-74.915955,0,'2013-07-06 12:44:30',NULL,NULL),(35185,'39283','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.367889,-90.231119,0,'2013-07-06 12:44:32',NULL,NULL),(60411,'71639','S','Garrett Bridge','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(65798,'78130','S','New Braunfels','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.719620,-98.080800,0,'2013-07-06 12:44:34',NULL,NULL),(72477,'89124','S','Old Nevada','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(75307,'93745','P','Calwa','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.707049,-119.753500,0,'2013-07-06 12:44:34',NULL,NULL),(79747,'99251','U','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.751705,-117.419050,0,'2013-07-06 12:44:34',NULL,NULL),(40221,'45412','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.760813,-84.193399,0,'2013-07-06 12:44:32',NULL,NULL),(61815,'73105','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.512654,-97.504104,0,'2013-07-06 12:44:33',NULL,NULL),(60000,'71331','S','Vick','A','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.219560,-92.118600,0,'2013-07-06 12:44:33',NULL,NULL),(35960,'40067','S','Simpsonville','D','Shelby','21211','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.235127,-85.352938,0,'2013-07-06 12:44:32',NULL,NULL),(1439,'00739','S','Urb Ferrer','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(24417,'27127','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.047311,-80.265066,0,'2013-07-06 12:44:31',NULL,NULL),(31132,'33904','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.599610,-81.950324,0,'2013-07-06 12:44:32',NULL,NULL),(56941,'66086','S','Tonganoxie','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.107235,-95.088280,0,'2013-07-06 12:44:33',NULL,NULL),(28152,'30830','S','Munnerlyn','N','Burke','13033','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.092086,-82.019367,0,'2013-07-06 12:44:31',NULL,NULL),(10287,'10519','P','Croton Falls','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.345613,-73.660066,0,'2013-07-06 12:44:30',NULL,NULL),(13,'00602','S','Ext Los Robles','N','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(17185,'17820','S','Kulp','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(17080,'17762','P','Picture Rocks','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.278642,-76.711572,0,'2013-07-06 12:44:31',NULL,NULL),(37991,'42748','S','Hodgenville','D','Larue','21123','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.576860,-85.708920,0,'2013-07-06 12:44:32',NULL,NULL),(9094,'09059','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(6093,'05450','S','West Berkshire','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(34119,'38187','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.076070,-89.843603,0,'2013-07-06 12:44:32',NULL,NULL),(55704,'64065','U','Unity Village','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.949632,-94.405068,0,'2013-07-06 12:44:33',NULL,NULL),(58272,'68401','S','Mc Cool Junction','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.744573,-97.595253,0,'2013-07-06 12:44:33',NULL,NULL),(58845,'69132','S','Dickens','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.816152,-100.991147,0,'2013-07-06 12:44:33',NULL,NULL),(60125,'71371','S','Little Creek','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(62656,'74604','S','Ponca City','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.725760,-97.042075,0,'2013-07-06 12:44:33',NULL,NULL),(66411,'78632','S','Harwood','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.660518,-97.479686,0,'2013-07-06 12:44:34',NULL,NULL),(65817,'78145','P','Pawnee','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.654255,-98.001202,0,'2013-07-06 12:44:34',NULL,NULL),(63047,'75216','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.707957,-96.787266,0,'2013-07-06 12:44:33',NULL,NULL),(61720,'73015','S','Carnegie','D','Caddo','40015','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.103495,-98.599878,0,'2013-07-06 12:44:33',NULL,NULL),(55817,'64148','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.088651,-94.581287,0,'2013-07-06 12:44:33',NULL,NULL),(8358,'08050','S','Manahawkin','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.698720,-74.257382,0,'2013-07-06 12:44:30',NULL,NULL),(71553,'87193','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.190497,-106.688950,0,'2013-07-06 12:44:34',NULL,NULL),(54952,'63118','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.595639,-90.224066,0,'2013-07-06 12:44:33',NULL,NULL),(21314,'22406','S','Frederickbg','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(15496,'16503','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.124801,-80.063248,0,'2013-07-06 12:44:31',NULL,NULL),(36226,'40287','U','KY Lottery Corp','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.226435,-85.686923,0,'2013-07-06 12:44:32',NULL,NULL),(32628,'36177','U','Montgomery Business Reply Ma','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.378975,-86.303722,0,'2013-07-06 12:44:32',NULL,NULL),(29552,'32808','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.572630,-81.442973,0,'2013-07-06 12:44:32',NULL,NULL),(26448,'29135','S','St Matthews','A','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.661870,-80.781778,0,'2013-07-06 12:44:31',NULL,NULL),(23024,'24836','P','Gary','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.359828,-81.553478,0,'2013-07-06 12:44:31',NULL,NULL),(22969,'24716','P','Bud','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.534900,-81.378125,0,'2013-07-06 12:44:31',NULL,NULL),(50406,'57776','P','Redig','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.268253,-103.547357,0,'2013-07-06 12:44:33',NULL,NULL),(51618,'59840','S','Pinesdale','A','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.229862,-114.164719,0,'2013-07-06 12:44:33',NULL,NULL),(54923,'63101','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.631974,-90.191176,0,'2013-07-06 12:44:33',NULL,NULL),(62831,'74966','S','Wister','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.941720,-94.815000,0,'2013-07-06 12:44:33',NULL,NULL),(64623,'76701','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.551963,-97.136548,0,'2013-07-06 12:44:34',NULL,NULL),(76608,'95690','S','Walker Landing','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(14399,'15055','S','Lawrence','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.304760,-80.127553,0,'2013-07-06 12:44:31',NULL,NULL),(55729,'64083','S','Lees Summit','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.803006,-94.446895,0,'2013-07-06 12:44:33',NULL,NULL),(53334,'61753','S','Hilltop','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.620011,-88.806012,0,'2013-07-06 12:44:33',NULL,NULL),(10265,'10505','S','Baldwin Place','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.342445,-73.747115,0,'2013-07-06 12:44:30',NULL,NULL),(58879,'69160','U','Sidney','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.141884,-102.978079,0,'2013-07-06 12:44:33',NULL,NULL),(27672,'30329','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.825160,-84.319700,0,'2013-07-06 12:44:31',NULL,NULL),(84,'00612','S','Parc Rodriguez Olmo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(42582,'47880','P','Shepardsville','D','Vigo','18167','Indiana','IN','18','8320','317','Eastern',-5.0,'Y',39.510391,-87.477562,0,'2013-07-06 12:44:32',NULL,NULL),(5966,'05301','S','West Brattleboro','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(38769,'44047','S','New Lyme','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.650287,-80.769918,0,'2013-07-06 12:44:32',NULL,NULL),(33118,'36866','S','Notasulga','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.557951,-85.662068,0,'2013-07-06 12:44:32',NULL,NULL),(30789,'33598','S','Wimauma','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.699334,-82.321612,0,'2013-07-06 12:44:32',NULL,NULL),(25300,'28145','P','Salisbury','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.661257,-80.447211,0,'2013-07-06 12:44:31',NULL,NULL),(47279,'54538','S','Lac Du Flambu','A','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.966884,-89.889537,0,'2013-07-06 12:44:32',NULL,NULL),(47447,'54727','S','Crescent','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.939274,-91.171476,0,'2013-07-06 12:44:32',NULL,NULL),(53271,'61722','S','Sabina','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.449086,-88.632987,0,'2013-07-06 12:44:33',NULL,NULL),(55471,'63745','P','Dutchtown','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.252156,-89.659063,0,'2013-07-06 12:44:33',NULL,NULL),(58297,'68421','S','Peru','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.479889,-95.731319,0,'2013-07-06 12:44:33',NULL,NULL),(21030,'21865','S','Tyaskin','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.267142,-75.793733,0,'2013-07-06 12:44:31',NULL,NULL),(36287,'40353','S','Camargo','A','Montgomery','21173','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.057445,-83.934406,0,'2013-07-06 12:44:32',NULL,NULL),(54482,'62861','P','Maunie','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.034049,-88.045662,0,'2013-07-06 12:44:33',NULL,NULL),(72816,'89815','S','Jiggs','A','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.551508,-115.576891,0,'2013-07-06 12:44:34',NULL,NULL),(32225,'35576','S','Fernbank','N','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.557280,-88.190520,0,'2013-07-06 12:44:32',NULL,NULL),(47432,'54701','S','Eau Claire','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.794997,-91.483260,0,'2013-07-06 12:44:32',NULL,NULL),(42289,'47588','S','Huffman','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.996498,-86.801594,0,'2013-07-06 12:44:32',NULL,NULL),(8721,'08504','P','Blawenburg','D','Somerset','34035','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.401040,-74.704738,0,'2013-07-06 12:44:30',NULL,NULL),(48255,'55426','S','Saint Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952405,-93.377860,0,'2013-07-06 12:44:33',NULL,NULL),(53762,'62264','S','New Athens','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.323227,-89.876837,0,'2013-07-06 12:44:33',NULL,NULL),(68335,'81122','S','Bayfield','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.314420,-107.612280,0,'2013-07-06 12:44:34',NULL,NULL),(19915,'20551','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893288,-77.043093,0,'2013-07-06 12:44:31',NULL,NULL),(70287,'84533','S','Fry Canyon','N','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(69237,'83415','U','Scoville','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.491978,-112.033059,0,'2013-07-06 12:44:34',NULL,NULL),(58421,'68653','S','Platte Center','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.526326,-97.482444,0,'2013-07-06 12:44:33',NULL,NULL),(37954,'42718','S','Campbellsville','D','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.461291,-85.462912,0,'2013-07-06 12:44:32',NULL,NULL),(19521,'20184','S','Upperville','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.973017,-77.856287,0,'2013-07-06 12:44:31',NULL,NULL),(31218,'33956','S','Saint James City','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.527436,-82.090909,0,'2013-07-06 12:44:32',NULL,NULL),(28423,'31329','S','Stillwell','A','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.369473,-81.309239,0,'2013-07-06 12:44:32',NULL,NULL),(15046,'15712','P','Arcadia','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.785500,-78.855219,0,'2013-07-06 12:44:31',NULL,NULL),(27378,'30075','S','Roswell','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.046659,-84.376691,0,'2013-07-06 12:44:31',NULL,NULL),(27267,'29938','P','Hilton Head','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.161530,-80.752119,0,'2013-07-06 12:44:31',NULL,NULL),(25263,'28123','P','Mount Mourne','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.543985,-80.846555,0,'2013-07-06 12:44:31',NULL,NULL),(49144,'56375','S','Saint Stephen','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.700959,-94.266485,0,'2013-07-06 12:44:33',NULL,NULL),(53660,'62207','S','Alorton','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.610300,-90.156180,0,'2013-07-06 12:44:33',NULL,NULL),(56658,'65619','S','Brookline','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.129140,-93.386700,0,'2013-07-06 12:44:33',NULL,NULL),(61554,'72714','S','Bella Vista','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.457140,-94.237320,0,'2013-07-06 12:44:33',NULL,NULL),(64244,'76363','S','Goree','D','Knox','48275','Texas','TX','48','0000','940','Central',-6.0,'Y',33.495442,-99.527854,0,'2013-07-06 12:44:34',NULL,NULL),(78148,'97601','S','Kingsley Field','N','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.221688,-121.796627,0,'2013-07-06 12:44:34',NULL,NULL),(78299,'97886','S','Weston','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.814204,-118.423866,0,'2013-07-06 12:44:34',NULL,NULL),(79944,'99624','P','Larsen Bay','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.416283,-153.532302,0,'2013-07-06 12:44:34',NULL,NULL),(74181,'92276','S','1000 Palms','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.810639,-116.376227,0,'2013-07-06 12:44:34',NULL,NULL),(65825,'78148','S','Universal Cty','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.551704,-98.302464,0,'2013-07-06 12:44:34',NULL,NULL),(2108,'00923','S','Urb Santa Barbara','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(53788,'62279','P','Renault','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.168555,-90.090299,0,'2013-07-06 12:44:33',NULL,NULL),(14678,'15242','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.417412,-80.045004,0,'2013-07-06 12:44:31',NULL,NULL),(532,'00674','S','Villa Maria','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(18601,'19141','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.034650,-75.144766,0,'2013-07-06 12:44:31',NULL,NULL),(42494,'47841','S','Clay City','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.273442,-87.115129,0,'2013-07-06 12:44:32',NULL,NULL),(15887,'17004','S','Alexander Springs','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.603109,-77.720588,0,'2013-07-06 12:44:31',NULL,NULL),(23464,'25434','S','Paw Paw','D','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.468601,-78.445876,0,'2013-07-06 12:44:31',NULL,NULL),(32945,'36574','S','Robertsdale','A','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.509700,-87.485880,0,'2013-07-06 12:44:32',NULL,NULL),(25061,'27929','S','Currituck','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.416317,-76.013973,0,'2013-07-06 12:44:31',NULL,NULL),(53964,'62428','S','Hazel Dell','A','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(54038,'62464','P','Stoy','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.993997,-87.833521,0,'2013-07-06 12:44:33',NULL,NULL),(72677,'89442','P','Wadsworth','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.642321,-119.281177,0,'2013-07-06 12:44:34',NULL,NULL),(30884,'33688','P','Carrollwood','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.061605,-82.505549,0,'2013-07-06 12:44:32',NULL,NULL),(13918,'14411','S','Eagle Harbor','A','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.239907,-78.202239,0,'2013-07-06 12:44:31',NULL,NULL),(72270,'88548','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770652,-106.329428,0,'2013-07-06 12:44:34',NULL,NULL),(23506,'25534','S','Kiahsville','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.095556,-82.254444,0,'2013-07-06 12:44:31',NULL,NULL),(37820,'42436','S','Manitou','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.417951,-87.567065,0,'2013-07-06 12:44:32',NULL,NULL),(11971,'12461','S','Olivebridge','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.898780,-74.257380,0,'2013-07-06 12:44:30',NULL,NULL),(42799,'48049','S','Clyde Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.036320,-82.574580,0,'2013-07-06 12:44:32',NULL,NULL),(18732,'19320','S','W Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(6232,'05491','S','Crown Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(11897,'12401','S','Saint Remy','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.932171,-74.019531,0,'2013-07-06 12:44:30',NULL,NULL),(35880,'39866','S','Morgan','D','Calhoun','13037','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.531835,-84.623875,0,'2013-07-06 12:44:32',NULL,NULL),(34672,'38821','S','Bigbee','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.999660,-88.451940,0,'2013-07-06 12:44:32',NULL,NULL),(22702,'24333','S','Dalhart','N','Galax City','51640','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.660590,-80.923683,0,'2013-07-06 12:44:31',NULL,NULL),(59832,'71240','P','Fairbanks','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.643216,-92.035880,0,'2013-07-06 12:44:33',NULL,NULL),(60863,'72053','P','Genevia','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.711660,-92.222290,0,'2013-07-06 12:44:33',NULL,NULL),(70853,'85548','P','Safford','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.769268,-109.711887,0,'2013-07-06 12:44:34',NULL,NULL),(7380,'06777','S','Warren','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(58331,'68455','S','Union','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.828465,-95.897147,0,'2013-07-06 12:44:33',NULL,NULL),(41064,'46511','S','Burr Oak','A','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.226198,-86.415220,0,'2013-07-06 12:44:32',NULL,NULL),(70567,'85054','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.675343,-111.936202,0,'2013-07-06 12:44:34',NULL,NULL),(52974,'61428','S','Oak Run','N','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.963678,-90.139944,0,'2013-07-06 12:44:33',NULL,NULL),(61148,'72169','P','Tupelo','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.391187,-91.227190,0,'2013-07-06 12:44:33',NULL,NULL),(10898,'11425','U','Vet Admin Ext Care Ctr','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674365,-73.771894,0,'2013-07-06 12:44:30',NULL,NULL),(65586,'77868','S','White Hall','N','Grimes','48185','Texas','TX','48','1260','936','Central',-6.0,'Y',30.388874,-96.084543,0,'2013-07-06 12:44:34',NULL,NULL),(44189,'49613','S','Arcadia','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.480669,-86.217650,0,'2013-07-06 12:44:32',NULL,NULL),(5282,'04530','S','Arrowsic','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.913876,-69.824845,0,'2013-07-06 12:44:30',NULL,NULL),(27285,'30002','S','Avondale Estates','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.772774,-84.264732,0,'2013-07-06 12:44:31',NULL,NULL),(27628,'30311','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.722171,-84.473898,0,'2013-07-06 12:44:31',NULL,NULL),(15892,'17006','S','Blain','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.306622,-77.513142,0,'2013-07-06 12:44:31',NULL,NULL),(10198,'10308','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.553407,-74.150326,0,'2013-07-06 12:44:30',NULL,NULL),(36618,'40979','S','Roark','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.028733,-83.510828,0,'2013-07-06 12:44:32',NULL,NULL),(30044,'33143','S','South Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.702034,-80.295591,0,'2013-07-06 12:44:32',NULL,NULL),(29085,'32259','S','JAX','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(8402,'08064','P','New Lisbon','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.956127,-74.628458,0,'2013-07-06 12:44:30',NULL,NULL),(46502,'53233','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036985,-87.932408,0,'2013-07-06 12:44:32',NULL,NULL),(60119,'71368','S','Sicily Island','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.854570,-91.693483,0,'2013-07-06 12:44:33',NULL,NULL),(77691,'97040','S','Mosier','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.664735,-121.375464,0,'2013-07-06 12:44:34',NULL,NULL),(78840,'98335','S','Wauna Shores','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(66923,'79338','P','Levelland','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.592383,-102.357242,0,'2013-07-06 12:44:34',NULL,NULL),(75023,'93501','S','Fremont Valley','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.024023,-118.177512,0,'2013-07-06 12:44:34',NULL,NULL),(47511,'54770','S','Strum','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.546891,-91.389040,0,'2013-07-06 12:44:32',NULL,NULL),(8305,'08028','S','Glassboro','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.694694,-75.121217,0,'2013-07-06 12:44:30',NULL,NULL),(24782,'27570','P','Ridgeway','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.433158,-78.236769,0,'2013-07-06 12:44:31',NULL,NULL),(67881,'80841','P','USAF Academy','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.010740,-104.866903,0,'2013-07-06 12:44:34',NULL,NULL),(70161,'84317','S','Huntsville','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.287874,-111.684215,0,'2013-07-06 12:44:34',NULL,NULL),(10165,'10279','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(15890,'17004','S','Union Mills','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.603109,-77.720588,0,'2013-07-06 12:44:31',NULL,NULL),(35129,'39215','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.297171,-90.183699,0,'2013-07-06 12:44:32',NULL,NULL),(25337,'28214','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.269641,-80.960674,0,'2013-07-06 12:44:31',NULL,NULL),(24621,'27349','S','Snow Camp','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.915033,-79.427355,0,'2013-07-06 12:44:31',NULL,NULL),(56005,'64648','S','Jamesport','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.011038,-93.792366,0,'2013-07-06 12:44:33',NULL,NULL),(39940,'45230','S','Anderson Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.078715,-84.377216,0,'2013-07-06 12:44:32',NULL,NULL),(59227,'70426','S','Angie','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.965129,-89.812871,0,'2013-07-06 12:44:33',NULL,NULL),(57490,'66937','S','Clifton','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.563357,-97.278970,0,'2013-07-06 12:44:33',NULL,NULL),(49120,'56357','S','Foley','A','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.664722,-93.909444,0,'2013-07-06 12:44:33',NULL,NULL),(39122,'44262','S','Munroe Falls','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.142981,-81.439172,0,'2013-07-06 12:44:32',NULL,NULL),(47501,'54762','S','Prairie Farm','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.255879,-91.978677,0,'2013-07-06 12:44:32',NULL,NULL),(47457,'54729','S','Tilden','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(11805,'12229','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.650418,-73.814413,0,'2013-07-06 12:44:30',NULL,NULL),(12124,'12602','P','Poughkeepsie','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.706233,-73.928540,0,'2013-07-06 12:44:30',NULL,NULL),(43475,'48602','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.420918,-83.974434,0,'2013-07-06 12:44:32',NULL,NULL),(27526,'30216','S','Indian Springs','N','Butts','13035','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.244230,-83.896090,0,'2013-07-06 12:44:31',NULL,NULL),(76377,'95521','S','McKinleyville','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.928760,-124.060080,0,'2013-07-06 12:44:34',NULL,NULL),(56856,'66006','S','Baldwin City','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.776889,-95.187756,0,'2013-07-06 12:44:33',NULL,NULL),(55968,'64504','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.714268,-94.865023,0,'2013-07-06 12:44:33',NULL,NULL),(49643,'56950','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(76382,'95526','S','Ruth','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.467480,-123.693420,0,'2013-07-06 12:44:34',NULL,NULL),(62252,'74004','U','Bville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.739762,-95.948625,0,'2013-07-06 12:44:33',NULL,NULL),(21679,'22959','S','South Garden','N','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.954067,-78.691947,0,'2013-07-06 12:44:31',NULL,NULL),(2319,'00929','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.401987,-66.023228,0,'2013-07-06 12:44:30',NULL,NULL),(6747,'06082','S','Thompsonville','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986942,-72.565275,0,'2013-07-06 12:44:30',NULL,NULL),(61589,'72756','S','Rogers','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.322705,-94.027850,0,'2013-07-06 12:44:33',NULL,NULL),(15826,'16933','S','Lambs Creek','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(18174,'18920','S','Erwinna','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.491353,-75.079035,0,'2013-07-06 12:44:31',NULL,NULL),(18694,'19191','U','Wachovia Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952279,-75.165967,0,'2013-07-06 12:44:31',NULL,NULL),(76133,'95252','S','Valley Spgs','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.147636,-120.857242,0,'2013-07-06 12:44:34',NULL,NULL),(25035,'27897','S','George','A','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.324900,-77.199060,0,'2013-07-06 12:44:31',NULL,NULL),(65363,'77535','S','Dayton Lakes','A','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(17673,'18102','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.604201,-75.481145,0,'2013-07-06 12:44:31',NULL,NULL),(26708,'29410','S','N Charleston','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.194932,-80.029749,0,'2013-07-06 12:44:31',NULL,NULL),(21555,'22801','S','Harrisonburg','D','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.442152,-78.874027,0,'2013-07-06 12:44:31',NULL,NULL),(10103,'10249','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(45607,'51561','S','Pacific Junction','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.020858,-95.797670,0,'2013-07-06 12:44:32',NULL,NULL),(49832,'57224','S','Claire City','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.877033,-97.104277,0,'2013-07-06 12:44:33',NULL,NULL),(60441,'71647','S','Johnsville','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(42088,'47459','S','Hendricksvle','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.123646,-86.753712,0,'2013-07-06 12:44:32',NULL,NULL),(37346,'41712','S','Ary','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.352774,-83.137318,0,'2013-07-06 12:44:32',NULL,NULL),(13920,'14414','S','Avon','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.897668,-77.736093,0,'2013-07-06 12:44:31',NULL,NULL),(78501,'98110','S','Bainbridge Island','D','Kitsap','53035','Washington','WA','53','1150','206/564','Pacific',-8.0,'Y',47.648322,-122.533526,0,'2013-07-06 12:44:34',NULL,NULL),(35487,'39522','U','Navocean O','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(3218,'01364','S','Warwick','A','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(18858,'19440','S','North Penn','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.274777,-75.289827,0,'2013-07-06 12:44:31',NULL,NULL),(75344,'93905','S','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.680613,-121.618316,0,'2013-07-06 12:44:34',NULL,NULL),(75888,'94964','P','San Quentin','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.940537,-122.482541,0,'2013-07-06 12:44:34',NULL,NULL),(47919,'55110','S','White Bear Township','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(4286,'02895','S','Woonsocket','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',42.003900,-71.502576,0,'2013-07-06 12:44:30',NULL,NULL),(9149,'09304','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(20421,'20910','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998735,-77.036543,0,'2013-07-06 12:44:31',NULL,NULL),(20176,'20746','S','Camp Springs','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(19903,'20543','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889169,-77.008796,0,'2013-07-06 12:44:31',NULL,NULL),(24094,'26505','S','Sabraton','N','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.636473,-79.951111,0,'2013-07-06 12:44:31',NULL,NULL),(5288,'04538','S','Boothbay Hbr','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.851438,-69.626454,0,'2013-07-06 12:44:30',NULL,NULL),(10277,'10512','S','Kent Cliffs','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.449121,-73.679279,0,'2013-07-06 12:44:30',NULL,NULL),(46910,'54135','S','Keshena','D','Menominee','55078','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.897092,-88.546594,0,'2013-07-06 12:44:32',NULL,NULL),(48155,'55372','S','Shakopee','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.683929,-93.399760,0,'2013-07-06 12:44:33',NULL,NULL),(53293,'61728','S','Colfax','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.567120,-88.612858,0,'2013-07-06 12:44:33',NULL,NULL),(56166,'64866','S','Stark City','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.885513,-94.142051,0,'2013-07-06 12:44:33',NULL,NULL),(71397,'87011','P','Claunch','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.142312,-105.992013,0,'2013-07-06 12:44:34',NULL,NULL),(65733,'78045','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.594073,-99.512850,0,'2013-07-06 12:44:34',NULL,NULL),(69942,'84116','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.785043,-111.930074,0,'2013-07-06 12:44:34',NULL,NULL),(73806,'91756','U','Mont Pk','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.047565,-118.132799,0,'2013-07-06 12:44:34',NULL,NULL),(60056,'71351','S','Brouillette','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.161480,-92.095020,0,'2013-07-06 12:44:33',NULL,NULL),(3806,'02241','U','Fleet Bank Boston','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.354861,-71.057266,0,'2013-07-06 12:44:30',NULL,NULL),(6506,'05819','S','West Waterford','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.434670,-72.038170,0,'2013-07-06 12:44:30',NULL,NULL),(12772,'13211','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.098535,-76.132190,0,'2013-07-06 12:44:30',NULL,NULL),(30732,'33537','P','Lacoochee','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.466643,-82.176760,0,'2013-07-06 12:44:32',NULL,NULL),(23045,'24861','P','Maybeury','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.376327,-81.357481,0,'2013-07-06 12:44:31',NULL,NULL),(35059,'39182','P','Vicksburg','D','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.350854,-90.878540,0,'2013-07-06 12:44:32',NULL,NULL),(41585,'47041','S','Sunman','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(3399,'01653','U','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.292703,-71.779043,0,'2013-07-06 12:44:30',NULL,NULL),(1273,'00730','S','Comunidad Playita Ferry','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(26314,'29041','P','Davis Station','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.601734,-80.264746,0,'2013-07-06 12:44:31',NULL,NULL),(58396,'68627','S','Cedar Rapids','D','Boone','31011','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.558896,-98.143523,0,'2013-07-06 12:44:33',NULL,NULL),(69102,'83255','S','Darlington','A','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869160,-113.078054,0,'2013-07-06 12:44:34',NULL,NULL),(73890,'91976','P','Spring Valley','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.749273,-116.987310,0,'2013-07-06 12:44:34',NULL,NULL),(61071,'72126','S','Deberrie','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(49138,'56371','S','Roscoe','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.433706,-94.637291,0,'2013-07-06 12:44:33',NULL,NULL),(23374,'25301','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.348843,-81.631272,0,'2013-07-06 12:44:31',NULL,NULL),(66864,'79185','U','Clowe and Cowan','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.083202,-101.918470,0,'2013-07-06 12:44:34',NULL,NULL),(70061,'84143','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.779354,-111.880031,0,'2013-07-06 12:44:34',NULL,NULL),(74282,'92359','S','Mentone','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.073506,-117.106254,0,'2013-07-06 12:44:34',NULL,NULL),(3948,'02474','S','Arlington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420728,-71.158189,0,'2013-07-06 12:44:30',NULL,NULL),(673,'00683','S','Urb Las Quintas','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(30205,'33181','S','North Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(12678,'13126','S','Scriba','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(2807,'00976','S','Urb Riverwalk','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(22045,'23308','S','Bloxom','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.824339,-75.612737,0,'2013-07-06 12:44:31',NULL,NULL),(49986,'57366','S','Beardsley','N','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.394273,-97.988210,0,'2013-07-06 12:44:33',NULL,NULL),(53021,'61468','S','Opheim','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.252242,-90.382634,0,'2013-07-06 12:44:33',NULL,NULL),(64524,'76640','S','Elm Mott','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.672519,-97.097840,0,'2013-07-06 12:44:34',NULL,NULL),(66689,'78943','S','Glidden','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.707561,-96.539912,0,'2013-07-06 12:44:34',NULL,NULL),(542,'00676','S','Urb Los Robles','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(24907,'27712','S','North Durham','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.086887,-78.923696,0,'2013-07-06 12:44:31',NULL,NULL),(29135,'32326','P','Crawfordville','D','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.172668,-84.375634,0,'2013-07-06 12:44:32',NULL,NULL),(38256,'43287','U','Huntington National Bank','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.961425,-82.999386,0,'2013-07-06 12:44:32',NULL,NULL),(1591,'00769','S','Haciendas Monterrey','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(32663,'36260','S','Eastaboga','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.603741,-85.976733,0,'2013-07-06 12:44:32',NULL,NULL),(18474,'19086','S','Rose Valley','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889823,-75.370994,0,'2013-07-06 12:44:31',NULL,NULL),(4,'00544','U','Internal Revenue Service','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.813223,-73.049288,0,'2013-07-06 12:44:30',NULL,NULL),(75804,'94802','P','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.937113,-122.356577,0,'2013-07-06 12:44:34',NULL,NULL),(72764,'89520','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.494960,-119.742902,0,'2013-07-06 12:44:34',NULL,NULL),(17835,'18421','S','Clifford Township','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(19292,'19971','S','Rehoboth Beach','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.726540,-75.081250,0,'2013-07-06 12:44:31',NULL,NULL),(41877,'47366','P','New Lisbon','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.861283,-85.263377,0,'2013-07-06 12:44:32',NULL,NULL),(40128,'45332','S','Hollansburg','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.998065,-84.788708,0,'2013-07-06 12:44:32',NULL,NULL),(18569,'19126','S','Oak Lane','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.055969,-75.135303,0,'2013-07-06 12:44:31',NULL,NULL),(12612,'13084','S','La Fayette','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.887460,-76.119300,0,'2013-07-06 12:44:30',NULL,NULL),(16461,'17241','S','Greenspring','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(27901,'30474','S','Normantown','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(50155,'57547','S','Long Valley','D','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.557373,-101.366701,0,'2013-07-06 12:44:33',NULL,NULL),(52238,'60506','S','Aurora','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.762574,-88.353484,0,'2013-07-06 12:44:33',NULL,NULL),(56230,'65042','P','High Point','D','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.478593,-92.606101,0,'2013-07-06 12:44:33',NULL,NULL),(56787,'65756','S','Stotts City','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.111315,-93.957456,0,'2013-07-06 12:44:33',NULL,NULL),(65018,'77305','P','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.322008,-95.462195,0,'2013-07-06 12:44:34',NULL,NULL),(69868,'84094','S','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.563547,-111.859471,0,'2013-07-06 12:44:34',NULL,NULL),(36738,'41033','S','Fiskburg','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.749457,-84.473187,0,'2013-07-06 12:44:32',NULL,NULL),(74314,'92389','P','Tecopa Hot Springs','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',35.948545,-115.897853,0,'2013-07-06 12:44:34',NULL,NULL),(76205,'95361','S','Knights Ferry','A','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.781218,-120.835377,0,'2013-07-06 12:44:34',NULL,NULL),(823,'00693','S','Urb San Vicente','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(70433,'84737','S','Apple Valley','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.242480,-113.200860,0,'2013-07-06 12:44:34',NULL,NULL),(22722,'24360','S','Foster Falls','A','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.924480,-80.911800,0,'2013-07-06 12:44:31',NULL,NULL),(63860,'75979','S','Town Bluff','N','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.754889,-94.393444,0,'2013-07-06 12:44:34',NULL,NULL),(29826,'33028','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028900,-80.344700,0,'2013-07-06 12:44:32',NULL,NULL),(50479,'58047','S','Hickson','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.717620,-96.856680,0,'2013-07-06 12:44:33',NULL,NULL),(24189,'26638','S','Shock','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.767670,-80.992411,0,'2013-07-06 12:44:31',NULL,NULL),(43829,'49085','S','St Joseph','N','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.068065,-86.475496,0,'2013-07-06 12:44:32',NULL,NULL),(17811,'18407','S','Greenfield Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(40670,'46055','S','Woodbury','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.891661,-85.901929,0,'2013-07-06 12:44:32',NULL,NULL),(37188,'41513','S','Belcher','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300665,-82.348713,0,'2013-07-06 12:44:32',NULL,NULL),(31133,'33905','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.670910,-81.802140,0,'2013-07-06 12:44:32',NULL,NULL),(8353,'08048','S','Lumberton Township','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.956414,-74.804349,0,'2013-07-06 12:44:30',NULL,NULL),(24048,'26419','S','Hastings','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.566100,-80.676780,0,'2013-07-06 12:44:31',NULL,NULL),(51454,'59485','P','Ulm','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.421211,-111.544461,0,'2013-07-06 12:44:33',NULL,NULL),(60661,'71921','S','Alpine','A','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(62380,'74078','U','OK State Univ Admin','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.115627,-97.058038,0,'2013-07-06 12:44:33',NULL,NULL),(41328,'46777','S','Ossian','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.870920,-85.156740,0,'2013-07-06 12:44:32',NULL,NULL),(19588,'20221','U','District Director Irs','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894103,-77.028884,0,'2013-07-06 12:44:31',NULL,NULL),(28539,'31554','S','Nicholls','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(8592,'08230','S','Palermo','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.210240,-74.728080,0,'2013-07-06 12:44:30',NULL,NULL),(60285,'71450','S','Bethel','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.793040,-93.399660,0,'2013-07-06 12:44:33',NULL,NULL),(59298,'70507','S','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.281565,-92.021505,0,'2013-07-06 12:44:33',NULL,NULL),(44600,'50048','S','Casey','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.488238,-94.430650,0,'2013-07-06 12:44:32',NULL,NULL),(11863,'12302','S','East Glenville','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(4869,'04029','S','Sebago','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.888056,-70.632500,0,'2013-07-06 12:44:30',NULL,NULL),(8401,'08063','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862622,-75.176008,0,'2013-07-06 12:44:30',NULL,NULL),(23854,'26143','S','Hughes River','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(76088,'95213','P','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.955793,-121.438557,0,'2013-07-06 12:44:34',NULL,NULL),(58136,'68144','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.233210,-96.113706,0,'2013-07-06 12:44:33',NULL,NULL),(43179,'48288','U','Chrysler Corporation','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.418809,-83.104982,0,'2013-07-06 12:44:32',NULL,NULL),(16301,'17110','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.308930,-76.874147,0,'2013-07-06 12:44:31',NULL,NULL),(42083,'47456','S','Lake Maxine','N','Owen','18119','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.435138,-86.786652,0,'2013-07-06 12:44:32',NULL,NULL),(11394,'11948','S','Laurel','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.963392,-72.548573,0,'2013-07-06 12:44:30',NULL,NULL),(3210,'01360','S','Northfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.700499,-72.450887,0,'2013-07-06 12:44:30',NULL,NULL),(26382,'29101','S','Mc Bee','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.489200,-80.248200,0,'2013-07-06 12:44:31',NULL,NULL),(45862,'52243','U','American College Testing','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.656599,-91.535548,0,'2013-07-06 12:44:32',NULL,NULL),(45881,'52254','S','Lost Nation','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.966532,-90.817621,0,'2013-07-06 12:44:32',NULL,NULL),(47526,'54806','S','Potawatomi Indian Reservatio','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(49154,'56384','S','Upsala','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.810940,-94.580977,0,'2013-07-06 12:44:33',NULL,NULL),(59367,'70584','S','Cankton','A','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.381780,-92.092020,0,'2013-07-06 12:44:33',NULL,NULL),(80076,'99731','S','Delta Junction','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.007436,-145.352807,0,'2013-07-06 12:44:34',NULL,NULL),(42214,'47553','S','Whitfield','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(25056,'27924','S','Colerain','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.180756,-76.848835,0,'2013-07-06 12:44:31',NULL,NULL),(23646,'25801','S','Beckley','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.786941,-81.191873,0,'2013-07-06 12:44:31',NULL,NULL),(23472,'25444','S','Slanesville','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.397483,-78.510178,0,'2013-07-06 12:44:31',NULL,NULL),(40281,'45439','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(15478,'16434','S','Spartansburg','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.826335,-79.688422,0,'2013-07-06 12:44:31',NULL,NULL),(64593,'76679','S','Jester','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.949322,-96.573146,0,'2013-07-06 12:44:34',NULL,NULL),(1985,'00907','S','Condado','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.454321,-66.076621,0,'2013-07-06 12:44:30',NULL,NULL),(63341,'75603','S','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.435729,-94.725812,0,'2013-07-06 12:44:33',NULL,NULL),(6609,'05872','S','Charleston','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.898889,-72.060000,0,'2013-07-06 12:44:30',NULL,NULL),(18005,'18636','S','Forkston Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.418188,-76.075214,0,'2013-07-06 12:44:31',NULL,NULL),(41837,'47346','S','Graceland Hts','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.927181,-85.153805,0,'2013-07-06 12:44:32',NULL,NULL),(34280,'38478','S','Pulaski','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.190505,-87.026770,0,'2013-07-06 12:44:32',NULL,NULL),(34133,'38222','S','Buchanan','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.346048,-88.380509,0,'2013-07-06 12:44:32',NULL,NULL),(31599,'34669','S','Hudson','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.359750,-82.610876,0,'2013-07-06 12:44:32',NULL,NULL),(29620,'32867','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.567313,-81.255496,0,'2013-07-06 12:44:32',NULL,NULL),(1859,'00791','S','Jard Central','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(53408,'61833','S','Tilton','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.124444,-87.630000,0,'2013-07-06 12:44:33',NULL,NULL),(53665,'62208','S','East Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.599660,-90.009909,0,'2013-07-06 12:44:33',NULL,NULL),(62447,'74187','U','Tulsa City Utilities','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147918,-95.994333,0,'2013-07-06 12:44:33',NULL,NULL),(72356,'89021','P','Logandale','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.594627,-114.482251,0,'2013-07-06 12:44:34',NULL,NULL),(73090,'90222','S','Compton','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.911837,-118.235008,0,'2013-07-06 12:44:34',NULL,NULL),(76259,'95410','S','Albion','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.214084,-123.705350,0,'2013-07-06 12:44:34',NULL,NULL),(79104,'98448','P','Parkland','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.145996,-122.436154,0,'2013-07-06 12:44:34',NULL,NULL),(19463,'20132','S','Purcellville','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.163955,-77.727182,0,'2013-07-06 12:44:31',NULL,NULL),(60562,'71750','P','Lawson','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.195209,-92.481515,0,'2013-07-06 12:44:33',NULL,NULL),(21695,'22967','S','Massies Mill','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(24446,'27214','S','Browns Summit','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(12247,'12827','S','South Bay Village','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.431600,-73.509180,0,'2013-07-06 12:44:30',NULL,NULL),(74174,'92274','S','Sandy Korner','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(75022,'93483','P','Grover Beach','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.119166,-120.620876,0,'2013-07-06 12:44:34',NULL,NULL),(68001,'80921','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047737,-104.816446,0,'2013-07-06 12:44:34',NULL,NULL),(1236,'00729','S','Est del Rio','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(29541,'32796','S','Titusville','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.621623,-80.840117,0,'2013-07-06 12:44:32',NULL,NULL),(21520,'22724','S','Jeffersonton','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.629391,-77.906070,0,'2013-07-06 12:44:31',NULL,NULL),(14758,'15330','S','Eighty Four','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.182230,-80.088968,0,'2013-07-06 12:44:31',NULL,NULL),(45861,'52242','S','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.664405,-91.542152,0,'2013-07-06 12:44:32',NULL,NULL),(53005,'61453','S','Eleanor','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.009373,-90.745049,0,'2013-07-06 12:44:33',NULL,NULL),(59016,'70073','P','Marrero','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.862287,-90.119262,0,'2013-07-06 12:44:33',NULL,NULL),(59256,'70444','S','Sunnyhill','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.936684,-90.517939,0,'2013-07-06 12:44:33',NULL,NULL),(60247,'71434','P','Gorum','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.432994,-92.943122,0,'2013-07-06 12:44:33',NULL,NULL),(67827,'80802','S','Arapahoe','D','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.920045,-102.226031,0,'2013-07-06 12:44:34',NULL,NULL),(73531,'91350','S','Saugus','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(34816,'38901','S','Hardy','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(21060,'21915','S','Chesapeake Cy','A','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.508657,-75.850582,0,'2013-07-06 12:44:31',NULL,NULL),(26938,'29594','P','Tatum','D','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.645210,-79.585766,0,'2013-07-06 12:44:31',NULL,NULL),(49147,'56376','P','St Martin','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.498646,-94.663967,0,'2013-07-06 12:44:33',NULL,NULL),(56321,'65104','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.575066,-92.173635,0,'2013-07-06 12:44:33',NULL,NULL),(67097,'79706','S','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.989044,-102.073733,0,'2013-07-06 12:44:34',NULL,NULL),(23138,'24983','S','Glace','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.562090,-80.514593,0,'2013-07-06 12:44:31',NULL,NULL),(23719,'25901','S','Summerlee','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.986637,-81.142428,0,'2013-07-06 12:44:31',NULL,NULL),(24651,'27402','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.071757,-79.791027,0,'2013-07-06 12:44:31',NULL,NULL),(5989,'05352','S','Readsboro','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.775380,-73.068420,0,'2013-07-06 12:44:30',NULL,NULL),(11053,'11576','S','Roslyn','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.774722,-73.656111,0,'2013-07-06 12:44:30',NULL,NULL),(55353,'63559','S','Shibleys Point','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(19278,'19966','S','Long Neck','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.604960,-75.223260,0,'2013-07-06 12:44:31',NULL,NULL),(8021,'07726','S','Manalapan','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.277760,-74.361120,0,'2013-07-06 12:44:30',NULL,NULL),(42009,'47431','S','Farmers','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.211607,-86.851623,0,'2013-07-06 12:44:32',NULL,NULL),(40208,'45390','S','Dayton','A','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.018500,-84.564240,0,'2013-07-06 12:44:32',NULL,NULL),(38670,'43951','P','Lafferty','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.111831,-81.018183,0,'2013-07-06 12:44:32',NULL,NULL),(18987,'19522','S','Molltown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(29137,'32327','S','Wakulla Spgs','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.194005,-84.263529,0,'2013-07-06 12:44:32',NULL,NULL),(18350,'19035','S','Gladwyne','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.043915,-75.283448,0,'2013-07-06 12:44:31',NULL,NULL),(16263,'17088','P','Schaefferstwn','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.298697,-76.299045,0,'2013-07-06 12:44:31',NULL,NULL),(23844,'26136','S','Big Bend','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.987064,-81.139494,0,'2013-07-06 12:44:31',NULL,NULL),(44790,'50223','S','Pilot Mound','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.167465,-94.010592,0,'2013-07-06 12:44:32',NULL,NULL),(75807,'94803','S','San Pablo','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972375,-122.289337,0,'2013-07-06 12:44:34',NULL,NULL),(78465,'98074','S','Redmond','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.624151,-122.048612,0,'2013-07-06 12:44:34',NULL,NULL),(32957,'36584','S','Vinegar Bend','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.255248,-88.393313,0,'2013-07-06 12:44:32',NULL,NULL),(32950,'36578','S','Stapleton','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.743444,-87.788150,0,'2013-07-06 12:44:32',NULL,NULL),(54400,'62823','S','Cisne','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.515855,-88.366410,0,'2013-07-06 12:44:33',NULL,NULL),(47324,'54560','S','Sayner','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.993836,-89.520140,0,'2013-07-06 12:44:32',NULL,NULL),(1401,'00738','S','Urb Marines','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(54771,'62993','P','Unity','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.236409,-89.269604,0,'2013-07-06 12:44:33',NULL,NULL),(42040,'47441','S','Whites Crossing','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(10315,'10537','S','Lk Peekskill','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.337997,-73.885707,0,'2013-07-06 12:44:30',NULL,NULL),(17828,'18415','S','Damascus','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.735665,-75.135097,0,'2013-07-06 12:44:31',NULL,NULL),(37255,'41561','P','Rockhouse','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.326911,-82.453377,0,'2013-07-06 12:44:32',NULL,NULL),(32546,'36109','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380663,-86.246181,0,'2013-07-06 12:44:32',NULL,NULL),(44367,'49785','U','Sault Sainte Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.264580,-84.449270,0,'2013-07-06 12:44:32',NULL,NULL),(65391,'77554','S','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.207422,-94.965163,0,'2013-07-06 12:44:34',NULL,NULL),(71578,'87311','P','Springstead','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.532257,-108.606034,0,'2013-07-06 12:44:34',NULL,NULL),(71817,'87571','S','Valle Escondido','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(42250,'47576','S','Oil','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.227647,-86.609796,0,'2013-07-06 12:44:32',NULL,NULL),(64118,'76182','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.798211,-97.191792,0,'2013-07-06 12:44:34',NULL,NULL),(15517,'16531','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.156495,-80.011362,0,'2013-07-06 12:44:31',NULL,NULL),(33914,'38053','S','Kerrville','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(46938,'54162','S','Angelica','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.651006,-88.212562,0,'2013-07-06 12:44:32',NULL,NULL),(57119,'66223','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(47710,'55001','S','Afton','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.904954,-92.816718,0,'2013-07-06 12:44:33',NULL,NULL),(11639,'12122','S','Middleburg','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540360,-74.270820,0,'2013-07-06 12:44:30',NULL,NULL),(14717,'15276','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.438026,-80.093764,0,'2013-07-06 12:44:31',NULL,NULL),(13576,'13843','S','South New Berlin','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(76595,'95685','S','Sutter Hill','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.424660,-120.753360,0,'2013-07-06 12:44:34',NULL,NULL),(51900,'60102','S','Algonquin','D','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.170820,-88.318740,0,'2013-07-06 12:44:33',NULL,NULL),(1499,'00751','S','Urb las Antillas','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(20823,'21626','S','Crapo','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.324307,-76.111506,0,'2013-07-06 12:44:31',NULL,NULL),(43687,'48879','S','Saint Johns','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',42.999309,-84.575430,0,'2013-07-06 12:44:32',NULL,NULL),(57349,'66725','S','Stippville','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(63734,'75935','S','Campti','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(76395,'95538','P','Fort Dick','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.838225,-124.166415,0,'2013-07-06 12:44:34',NULL,NULL),(61060,'72121','S','Pangburn','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(45532,'51447','S','Kirkman','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.729851,-95.264767,0,'2013-07-06 12:44:32',NULL,NULL),(72291,'88572','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768538,-106.329071,0,'2013-07-06 12:44:34',NULL,NULL),(79292,'98584','S','Shelton','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(2472,'00956','S','Jard de Bayamonte','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(8335,'08037','S','Nesco','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(42106,'47463','P','Stanford','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.095244,-86.664081,0,'2013-07-06 12:44:32',NULL,NULL),(18306,'19018','S','Primos Secane','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(67406,'80129','S','Littleton','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.543276,-105.007567,0,'2013-07-06 12:44:34',NULL,NULL),(76305,'95444','S','Graton','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.433837,-122.865481,0,'2013-07-06 12:44:34',NULL,NULL),(4023,'02565','P','N Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.639770,-70.635490,0,'2013-07-06 12:44:30',NULL,NULL),(37964,'42722','S','Canmer','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.271473,-85.717382,0,'2013-07-06 12:44:32',NULL,NULL),(37285,'41606','S','Halo','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.335525,-82.715205,0,'2013-07-06 12:44:32',NULL,NULL),(33066,'36766','P','Oakhill','N','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.921413,-87.086669,0,'2013-07-06 12:44:32',NULL,NULL),(45946,'52346','S','Van Horne','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.023359,-92.079688,0,'2013-07-06 12:44:32',NULL,NULL),(46318,'53072','S','Pewaukee','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.078937,-88.256368,0,'2013-07-06 12:44:32',NULL,NULL),(48142,'55364','S','Shorewood','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.935114,-93.662910,0,'2013-07-06 12:44:33',NULL,NULL),(51498,'59634','S','Montana City','A','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.495380,-111.967500,0,'2013-07-06 12:44:33',NULL,NULL),(65366,'77535','S','Mont Belvieu','A','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(79609,'99109','S','Chewelah','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.277353,-117.729854,0,'2013-07-06 12:44:34',NULL,NULL),(37599,'42124','S','Beaumont','D','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.862105,-85.644818,0,'2013-07-06 12:44:32',NULL,NULL),(63148,'75376','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.711568,-96.839218,0,'2013-07-06 12:44:33',NULL,NULL),(54332,'62762','U','IL Dept Human Services','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.787857,-89.652226,0,'2013-07-06 12:44:33',NULL,NULL),(72701,'89448','P','Kelmont East','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(37348,'41714','S','Bear Branch','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.209943,-83.490621,0,'2013-07-06 12:44:32',NULL,NULL),(28020,'30627','S','Carlton','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.965792,-82.939135,0,'2013-07-06 12:44:31',NULL,NULL),(301,'00646','S','Urb Los Prados Norte','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(16405,'17223','S','Ft Littleton','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.060812,-77.970494,0,'2013-07-06 12:44:31',NULL,NULL),(735,'00690','S','Brisas De Campo Alegre','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(25216,'28081','S','Shady Brook','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(23789,'26003','S','Bethlehem','A','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(14207,'14778','P','St Bonas','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.080151,-78.474616,0,'2013-07-06 12:44:31',NULL,NULL),(1467,'00745','S','Urb Galateo','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(10807,'11374','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.727079,-73.861454,0,'2013-07-06 12:44:30',NULL,NULL),(46416,'53183','S','Wales','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.004463,-88.378948,0,'2013-07-06 12:44:32',NULL,NULL),(60910,'72076','S','Lr Airforce Base','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(68912,'82834','S','Buffalo','D','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.343046,-106.711767,0,'2013-07-06 12:44:34',NULL,NULL),(75429,'94035','P','Moffett Field NAS','N','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.412894,-122.049891,0,'2013-07-06 12:44:34',NULL,NULL),(27511,'30184','S','White','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.268651,-84.714438,0,'2013-07-06 12:44:31',NULL,NULL),(47590,'54859','S','Minong','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.102673,-91.850913,0,'2013-07-06 12:44:33',NULL,NULL),(10454,'10922','P','Ft Montgomery','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.338977,-73.987248,0,'2013-07-06 12:44:30',NULL,NULL),(18463,'19082','S','Highland Park','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.956267,-75.274357,0,'2013-07-06 12:44:31',NULL,NULL),(68936,'82931','P','Evanston','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.288857,-110.966642,0,'2013-07-06 12:44:34',NULL,NULL),(74948,'93412','P','Los Osos','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.311680,-120.834780,0,'2013-07-06 12:44:34',NULL,NULL),(77606,'96942','P','Chuuk','D','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',7.323877,151.653461,0,'2013-07-06 12:44:34',NULL,NULL),(30121,'33162','S','Mia Shores','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(29157,'32346','S','Alligator Point','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023822,-84.391553,0,'2013-07-06 12:44:32',NULL,NULL),(42772,'48039','S','Cottrellville Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.719047,-82.521691,0,'2013-07-06 12:44:32',NULL,NULL),(50419,'57785','S','Volunteer','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(34936,'39043','P','Brandon','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.282534,-90.005169,0,'2013-07-06 12:44:32',NULL,NULL),(20654,'21226','S','Brooklyn','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(22445,'24020','P','Hollins Clg','A','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.245254,-80.030639,0,'2013-07-06 12:44:31',NULL,NULL),(47505,'54765','P','Sand Creek','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170922,-91.702804,0,'2013-07-06 12:44:32',NULL,NULL),(47516,'54774','U','Chippewa Fls','A','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.933706,-91.391510,0,'2013-07-06 12:44:32',NULL,NULL),(49202,'56453','S','Hewitt','D','Todd','27153','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.324158,-95.029177,0,'2013-07-06 12:44:33',NULL,NULL),(55758,'64116','S','K C','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(77856,'97229','S','Forest Heights','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.540884,-122.829980,0,'2013-07-06 12:44:34',NULL,NULL),(27088,'29708','S','Tega Cay','A','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006322,-80.942526,0,'2013-07-06 12:44:31',NULL,NULL),(43664,'48856','S','Middleton','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.198172,-84.737927,0,'2013-07-06 12:44:32',NULL,NULL),(79290,'98584','S','Harstine','N','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(74918,'93387','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.351514,-118.962431,0,'2013-07-06 12:44:34',NULL,NULL),(25364,'28242','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.211849,-80.861761,0,'2013-07-06 12:44:31',NULL,NULL),(16314,'17120','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.267283,-76.881635,0,'2013-07-06 12:44:31',NULL,NULL),(8645,'08302','S','Stow Creek Twp','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.438881,-75.228175,0,'2013-07-06 12:44:30',NULL,NULL),(19507,'20169','S','Haymarket','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.872792,-77.660457,0,'2013-07-06 12:44:31',NULL,NULL),(21574,'22832','S','Keezletown','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.452004,-78.762661,0,'2013-07-06 12:44:31',NULL,NULL),(61996,'73430','S','Burneyville','D','Love','40085','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.924514,-97.312760,0,'2013-07-06 12:44:33',NULL,NULL),(63316,'75568','S','Naples','D','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192600,-94.693620,0,'2013-07-06 12:44:33',NULL,NULL),(60996,'72112','S','Johnstown','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(50354,'57747','S','Hot Springs','D','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.433844,-103.476204,0,'2013-07-06 12:44:33',NULL,NULL),(48712,'55947','S','Dresbach','N','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.819624,-91.327279,0,'2013-07-06 12:44:33',NULL,NULL),(23255,'25123','S','Robertsburg','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.746520,-81.955930,0,'2013-07-06 12:44:31',NULL,NULL),(36177,'40245','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.264541,-85.495953,0,'2013-07-06 12:44:32',NULL,NULL),(31091,'33872','S','Sebring','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.463340,-81.482785,0,'2013-07-06 12:44:32',NULL,NULL),(36049,'40206','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256596,-85.701248,0,'2013-07-06 12:44:32',NULL,NULL),(1694,'00777','S','Urb Diamaris','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(8280,'08012','S','Lakeland','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(14191,'14755','S','Little Valley','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.248809,-78.800866,0,'2013-07-06 12:44:31',NULL,NULL),(78651,'98226','S','Bakerview','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.763345,-122.443649,0,'2013-07-06 12:44:34',NULL,NULL),(522,'00674','S','Urb Oneill','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(10250,'10471','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.903491,-73.903466,0,'2013-07-06 12:44:30',NULL,NULL),(11549,'12054','S','Delmar','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.605220,-73.870080,0,'2013-07-06 12:44:30',NULL,NULL),(29676,'32920','S','Cpe Canaveral','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.391416,-80.605396,0,'2013-07-06 12:44:32',NULL,NULL),(41365,'46794','S','Cosperville','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(46985,'54229','S','New Franken','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.559527,-87.833095,0,'2013-07-06 12:44:32',NULL,NULL),(58567,'68825','S','Triumph','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(60790,'72025','S','Round Mountain','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.030179,-93.036863,0,'2013-07-06 12:44:33',NULL,NULL),(70527,'85011','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.508799,-112.057469,0,'2013-07-06 12:44:34',NULL,NULL),(72159,'88337','S','La Luz','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.968274,-105.947227,0,'2013-07-06 12:44:34',NULL,NULL),(79289,'98583','P','Satsop','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.002138,-123.479491,0,'2013-07-06 12:44:34',NULL,NULL),(17358,'17872','S','Hunter','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(52620,'61037','P','Galt','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.788009,-89.758920,0,'2013-07-06 12:44:33',NULL,NULL),(20762,'21502','S','Cumberland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.596959,-78.834511,0,'2013-07-06 12:44:31',NULL,NULL),(1104,'00725','S','Urb Notre Dame','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(35669,'39653','S','Meedville','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.455600,-90.879660,0,'2013-07-06 12:44:32',NULL,NULL),(5767,'05043','S','East Thetford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.788611,-72.255833,0,'2013-07-06 12:44:30',NULL,NULL),(15906,'17013','S','Carlisle Brks','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.203056,-77.313611,0,'2013-07-06 12:44:31',NULL,NULL),(35079,'39202','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.310057,-90.176007,0,'2013-07-06 12:44:32',NULL,NULL),(3644,'02113','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.365976,-71.053080,0,'2013-07-06 12:44:30',NULL,NULL),(26915,'29582','S','N Myrtle Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(42955,'48128','S','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.320079,-83.262487,0,'2013-07-06 12:44:32',NULL,NULL),(39029,'44144','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.437456,-81.744047,0,'2013-07-06 12:44:32',NULL,NULL),(44032,'49418','S','Grandville','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.896187,-85.756061,0,'2013-07-06 12:44:32',NULL,NULL),(29619,'32862','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.538739,-81.377138,0,'2013-07-06 12:44:32',NULL,NULL),(32429,'35984','S','Mentone','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.591751,-85.576610,0,'2013-07-06 12:44:32',NULL,NULL),(73647,'91495','U','Us Purchasing Exchange','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151111,-118.448333,0,'2013-07-06 12:44:34',NULL,NULL),(49437,'56634','S','Minnewaska','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.831879,-95.319135,0,'2013-07-06 12:44:33',NULL,NULL),(44066,'49444','S','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168440,-86.184540,0,'2013-07-06 12:44:32',NULL,NULL),(58488,'68757','S','Obert','A','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.659384,-96.887990,0,'2013-07-06 12:44:33',NULL,NULL),(42355,'47666','S','Patoka','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.407821,-87.585980,0,'2013-07-06 12:44:32',NULL,NULL),(45522,'51433','S','Yetter','A','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.271200,-94.891740,0,'2013-07-06 12:44:32',NULL,NULL),(52073,'60399','U','Id Commerce And Logisitcs','N','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.958880,-87.941435,0,'2013-07-06 12:44:33',NULL,NULL),(56177,'65010','S','Ashland','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.789046,-92.259669,0,'2013-07-06 12:44:33',NULL,NULL),(59966,'71315','P','Alex','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.255060,-92.471756,0,'2013-07-06 12:44:33',NULL,NULL),(80149,'99786','P','Ambler','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',67.084605,-157.867930,0,'2013-07-06 12:44:34',NULL,NULL),(6791,'06107','S','W Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756512,-72.758753,0,'2013-07-06 12:44:30',NULL,NULL),(59748,'71151','U','Arkansas Louisiana Gas','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.514610,-93.747269,0,'2013-07-06 12:44:33',NULL,NULL),(26218,'28790','S','Zirconia','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.233139,-82.415861,0,'2013-07-06 12:44:31',NULL,NULL),(10058,'10177','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(61513,'72654','P','Mountain Home','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.336533,-92.384535,0,'2013-07-06 12:44:33',NULL,NULL),(13389,'13745','P','Chenango Bridge','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.285719,-75.910766,0,'2013-07-06 12:44:31',NULL,NULL),(22043,'23306','S','Belle Haven','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.582273,-75.875233,0,'2013-07-06 12:44:31',NULL,NULL),(41273,'46755','S','Cree Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(39772,'45121','S','Clermont Cnty','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(17768,'18335','P','Marshalls Creek','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.080932,-75.167868,0,'2013-07-06 12:44:31',NULL,NULL),(34673,'38821','S','Colsub','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.999660,-88.451940,0,'2013-07-06 12:44:32',NULL,NULL),(7348,'06723','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.557069,-73.036745,0,'2013-07-06 12:44:30',NULL,NULL),(1047,'00723','S','Urb San Jose','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(12901,'13335','S','Edmeston','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.697595,-75.238939,0,'2013-07-06 12:44:30',NULL,NULL),(23418,'25338','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.349917,-81.630449,0,'2013-07-06 12:44:31',NULL,NULL),(22577,'24155','U','Home Shopping Network','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.292570,-80.063621,0,'2013-07-06 12:44:31',NULL,NULL),(19951,'20578','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897253,-77.010546,0,'2013-07-06 12:44:31',NULL,NULL),(76889,'95979','S','Stonyford','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.308210,-122.511314,0,'2013-07-06 12:44:34',NULL,NULL),(14058,'14585','S','W Bloomfield','A','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.908597,-77.552853,0,'2013-07-06 12:44:31',NULL,NULL),(64908,'77094','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757352,-95.680631,0,'2013-07-06 12:44:34',NULL,NULL),(76056,'95193','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.244015,-121.830989,0,'2013-07-06 12:44:34',NULL,NULL),(13361,'13731','S','Andes','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.130940,-74.783500,0,'2013-07-06 12:44:31',NULL,NULL),(71516,'87115','S','Sandia Base','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.982758,-106.517977,0,'2013-07-06 12:44:34',NULL,NULL),(76193,'95347','P','Moccasin','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.789070,-120.306245,0,'2013-07-06 12:44:34',NULL,NULL),(34489,'38668','S','Looxahoma','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(28962,'32203','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.337271,-81.672748,0,'2013-07-06 12:44:32',NULL,NULL),(28776,'32034','S','Fernandina Beach','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.636954,-81.461340,0,'2013-07-06 12:44:32',NULL,NULL),(27581,'30275','P','Sargent','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.429119,-84.855226,0,'2013-07-06 12:44:31',NULL,NULL),(25719,'28543','S','Tarawa Tr','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.734194,-77.377379,0,'2013-07-06 12:44:31',NULL,NULL),(11990,'12477','S','West Saugerties','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.077520,-74.013600,0,'2013-07-06 12:44:30',NULL,NULL),(21220,'22212','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.858432,-77.089675,0,'2013-07-06 12:44:31',NULL,NULL),(47414,'54656','S','Camp McCoy','N','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.948001,-90.811171,0,'2013-07-06 12:44:32',NULL,NULL),(48527,'55747','P','Hibbing','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.401006,-92.948455,0,'2013-07-06 12:44:33',NULL,NULL),(1014,'00718','S','Hacienda Grande','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(30624,'33437','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524817,-80.176790,0,'2013-07-06 12:44:32',NULL,NULL),(6202,'05483','S','Sweek Hollow','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(15579,'16656','S','Irvona','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.830282,-78.566973,0,'2013-07-06 12:44:31',NULL,NULL),(2370,'00949','S','Qta Real','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(67101,'79711','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.997626,-102.077428,0,'2013-07-06 12:44:34',NULL,NULL),(70332,'84629','S','Indianola','N','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(71027,'85735','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.953898,-111.342837,0,'2013-07-06 12:44:34',NULL,NULL),(71577,'87311','P','Navajo Wingate Village','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.532257,-108.606034,0,'2013-07-06 12:44:34',NULL,NULL),(6874,'06138','P','E Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.761680,-72.612610,0,'2013-07-06 12:44:30',NULL,NULL),(2214,'00926','S','Urb Beverly Hills Ct','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(23309,'25203','S','Turtle Creek','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.044085,-81.862302,0,'2013-07-06 12:44:31',NULL,NULL),(23545,'25621','S','Gilbert','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.578836,-81.874407,0,'2013-07-06 12:44:31',NULL,NULL),(56666,'65625','S','Butterfield','A','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.679611,-93.872639,0,'2013-07-06 12:44:33',NULL,NULL),(57350,'66728','P','Crestline','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.158411,-94.669975,0,'2013-07-06 12:44:33',NULL,NULL),(67084,'79607','S','Dyess AFB','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.431896,-99.811677,0,'2013-07-06 12:44:34',NULL,NULL),(6188,'05479','U','Saint Albans','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.812060,-73.082760,0,'2013-07-06 12:44:30',NULL,NULL),(18535,'19111','S','Lawncrest','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.057937,-75.081966,0,'2013-07-06 12:44:31',NULL,NULL),(43629,'48822','S','Eagle','D','Clinton','26037','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.976002,-84.535243,0,'2013-07-06 12:44:32',NULL,NULL),(64696,'76849','S','Segovia','N','Kimble','48267','Texas','TX','48','0000','325','Central',-6.0,'Y',30.462840,-99.710040,0,'2013-07-06 12:44:34',NULL,NULL),(79079,'98433','S','Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(58061,'68044','S','Fontanelle','A','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.521374,-96.498540,0,'2013-07-06 12:44:33',NULL,NULL),(31449,'34281','P','Trailer Est','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.489556,-82.579608,0,'2013-07-06 12:44:32',NULL,NULL),(28813,'32071','S','O Brien','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.048120,-82.976580,0,'2013-07-06 12:44:32',NULL,NULL),(22160,'23461','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.852778,-75.978333,0,'2013-07-06 12:44:31',NULL,NULL),(47794,'55047','S','Marine St Crx','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(65441,'77587','S','South Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.664258,-95.234301,0,'2013-07-06 12:44:34',NULL,NULL),(66051,'78376','S','Realitos','D','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.518196,-98.637460,0,'2013-07-06 12:44:34',NULL,NULL),(66986,'79457','U','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.584608,-101.851658,0,'2013-07-06 12:44:34',NULL,NULL),(73225,'90633','P','La Habra','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.934534,-117.945247,0,'2013-07-06 12:44:34',NULL,NULL),(9585,'10028','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(36442,'40604','P','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.221884,-84.916161,0,'2013-07-06 12:44:32',NULL,NULL),(77934,'97335','P','Crabtree','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.635357,-122.898705,0,'2013-07-06 12:44:34',NULL,NULL),(77672,'97029','S','Grass Valley','D','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.273881,-120.760619,0,'2013-07-06 12:44:34',NULL,NULL),(70548,'85032','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.619208,-112.004108,0,'2013-07-06 12:44:34',NULL,NULL),(70445,'84744','S','Burrville','A','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.513397,-111.882136,0,'2013-07-06 12:44:34',NULL,NULL),(68199,'81038','P','Ft Lyon','N','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.910961,-103.098113,0,'2013-07-06 12:44:34',NULL,NULL),(6405,'05735','S','Hubbardton','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627980,-73.170780,0,'2013-07-06 12:44:30',NULL,NULL),(4782,'03866','P','Rochester','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.301013,-70.977337,0,'2013-07-06 12:44:30',NULL,NULL),(53841,'62320','S','Camp Point','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.038481,-91.064920,0,'2013-07-06 12:44:33',NULL,NULL),(5756,'05039','S','Goose Green','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(69050,'83228','S','Oxford','A','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.232150,-112.012326,0,'2013-07-06 12:44:34',NULL,NULL),(57400,'66759','P','New Albany','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.567673,-95.940241,0,'2013-07-06 12:44:33',NULL,NULL),(3741,'02169','S','Quincy','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.240464,-71.014144,0,'2013-07-06 12:44:30',NULL,NULL),(33733,'37820','S','New Market','D','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.081197,-83.567459,0,'2013-07-06 12:44:32',NULL,NULL),(9020,'08868','P','Quakertown','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.566073,-74.943554,0,'2013-07-06 12:44:30',NULL,NULL),(48793,'56003','S','No Mankato','N','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.185763,-94.056217,0,'2013-07-06 12:44:33',NULL,NULL),(21718,'23002','S','Amelia','N','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.390980,-77.904720,0,'2013-07-06 12:44:31',NULL,NULL),(18992,'19522','S','RuscMBMnr Twp','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(32984,'36615','S','Brookley Fld','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.628884,-88.072632,0,'2013-07-06 12:44:32',NULL,NULL),(69551,'83810','S','Rose Lake','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.531940,-116.457240,0,'2013-07-06 12:44:34',NULL,NULL),(62394,'74103','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.159273,-95.994723,0,'2013-07-06 12:44:33',NULL,NULL),(65635,'77964','S','Kinkler','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(47800,'55051','S','Knife Lake','N','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.915556,-93.173056,0,'2013-07-06 12:44:33',NULL,NULL),(24808,'27599','U','Unc Chapel Hill Admin','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.928939,-79.040693,0,'2013-07-06 12:44:31',NULL,NULL),(23551,'25630','P','Lundale','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.798699,-81.716346,0,'2013-07-06 12:44:31',NULL,NULL),(38737,'44028','S','Columbia Station','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.312086,-81.935671,0,'2013-07-06 12:44:32',NULL,NULL),(5342,'04605','S','Trenton','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(56006,'64649','S','Kidder','D','Caldwell','29025','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.741250,-94.151132,0,'2013-07-06 12:44:33',NULL,NULL),(32556,'36113','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382900,-86.304300,0,'2013-07-06 12:44:32',NULL,NULL),(47186,'54482','S','Stevens Point','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.573483,-89.546894,0,'2013-07-06 12:44:32',NULL,NULL),(73457,'91303','S','Woodland Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.196941,-118.603090,0,'2013-07-06 12:44:34',NULL,NULL),(37798,'42376','S','Utica','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.624761,-87.078380,0,'2013-07-06 12:44:32',NULL,NULL),(11545,'12052','S','Cropseyville','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.753953,-73.477300,0,'2013-07-06 12:44:30',NULL,NULL),(29269,'32459','S','Pt Washington','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.359723,-86.237832,0,'2013-07-06 12:44:32',NULL,NULL),(43595,'48759','S','Sebewaing','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.732180,-83.412960,0,'2013-07-06 12:44:32',NULL,NULL),(35306,'39402','S','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.313286,-89.341967,0,'2013-07-06 12:44:32',NULL,NULL),(29087,'32259','S','Julington Crk','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(28269,'31081','S','Rupert','D','Taylor','13269','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.424044,-84.289842,0,'2013-07-06 12:44:31',NULL,NULL),(18844,'19428','S','W Cnshohocken','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.077938,-75.303000,0,'2013-07-06 12:44:31',NULL,NULL),(69089,'83252','S','Pleasantview','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(70763,'85334','P','Ehrenberg','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.620992,-114.496847,0,'2013-07-06 12:44:34',NULL,NULL),(35531,'39556','S','Kiln','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413756,-89.447969,0,'2013-07-06 12:44:32',NULL,NULL),(49683,'57018','S','Colton','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.785894,-96.927978,0,'2013-07-06 12:44:33',NULL,NULL),(27149,'29824','S','Pleasant Lane','N','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.786960,-81.929623,0,'2013-07-06 12:44:31',NULL,NULL),(2467,'00956','S','Ext Campo Alegre','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(3842,'02343','S','Holbrook','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.148030,-71.010637,0,'2013-07-06 12:44:30',NULL,NULL),(78049,'97447','S','Idleyld Park','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.326044,-123.026706,0,'2013-07-06 12:44:34',NULL,NULL),(76449,'95607','S','Esparto','A','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.688170,-122.139102,0,'2013-07-06 12:44:34',NULL,NULL),(67139,'79763','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.841408,-102.429466,0,'2013-07-06 12:44:34',NULL,NULL),(63445,'75670','S','Nesbitt','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(62690,'74728','S','Brkn Bow','N','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.027544,-94.734750,0,'2013-07-06 12:44:33',NULL,NULL),(54087,'62524','P','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.904113,-88.966664,0,'2013-07-06 12:44:33',NULL,NULL),(52449,'60670','U','Chase Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.886480,-87.622247,0,'2013-07-06 12:44:33',NULL,NULL),(12412,'12936','S','Whallonsburg','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.261839,-73.374299,0,'2013-07-06 12:44:30',NULL,NULL),(33938,'38069','S','Stanton','D','Haywood','47075','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.441511,-89.336860,0,'2013-07-06 12:44:32',NULL,NULL),(35040,'39169','S','Thornton','A','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.179923,-90.223094,0,'2013-07-06 12:44:32',NULL,NULL),(14176,'14741','S','Humphrey','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.212580,-78.590700,0,'2013-07-06 12:44:31',NULL,NULL),(26591,'29225','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998957,-81.030860,0,'2013-07-06 12:44:31',NULL,NULL),(10794,'11370','S','Trainsmeadow','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760333,-73.890833,0,'2013-07-06 12:44:30',NULL,NULL),(20618,'21211','S','Hampden','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.330421,-76.637183,0,'2013-07-06 12:44:31',NULL,NULL),(44736,'50161','S','Maxwell','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.881140,-93.411720,0,'2013-07-06 12:44:32',NULL,NULL),(12190,'12777','S','Forestburg','N','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.565300,-74.605980,0,'2013-07-06 12:44:30',NULL,NULL),(13020,'13425','S','Augusta','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.939058,-75.459424,0,'2013-07-06 12:44:30',NULL,NULL),(61296,'72416','S','Bono','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.902843,-90.785560,0,'2013-07-06 12:44:33',NULL,NULL),(74295,'92371','S','Phelan','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.477063,-117.534399,0,'2013-07-06 12:44:34',NULL,NULL),(68275,'81082','S','Beshoar Jct','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(61606,'72773','S','Wesley','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.925152,-93.907474,0,'2013-07-06 12:44:33',NULL,NULL),(33747,'37845','P','Petros','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.055638,-84.435067,0,'2013-07-06 12:44:32',NULL,NULL),(2085,'00921','S','Urb Santiago Iglesias','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(14018,'14536','S','Rossburg','A','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.550639,-78.081712,0,'2013-07-06 12:44:31',NULL,NULL),(61234,'72332','P','Edmondson','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.099676,-90.305839,0,'2013-07-06 12:44:33',NULL,NULL),(57880,'67623','S','Alton','D','Osborne','20141','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.453032,-98.957600,0,'2013-07-06 12:44:33',NULL,NULL),(52994,'61447','S','Kirkwood','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.868978,-90.754051,0,'2013-07-06 12:44:33',NULL,NULL),(49765,'57069','S','Greenfield','N','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.781151,-96.924411,0,'2013-07-06 12:44:33',NULL,NULL),(29271,'32459','S','Santa Rsa Bch','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.359723,-86.237832,0,'2013-07-06 12:44:32',NULL,NULL),(73687,'91604','S','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144568,-118.390161,0,'2013-07-06 12:44:34',NULL,NULL),(78463,'98072','S','Woodinville','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.748655,-122.095293,0,'2013-07-06 12:44:34',NULL,NULL),(16205,'17070','S','Nw Cumberland','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(40503,'45807','S','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.795920,-84.119340,0,'2013-07-06 12:44:32',NULL,NULL),(40403,'45677','P','Scioto Furnce','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.797453,-82.762942,0,'2013-07-06 12:44:32',NULL,NULL),(37299,'41635','S','Galveston','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(12386,'12920','S','Chateaugay','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.923150,-74.082893,0,'2013-07-06 12:44:30',NULL,NULL),(2352,'00949','S','Alts de Covadonga','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(23666,'25831','S','Clifftop','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.883531,-80.971211,0,'2013-07-06 12:44:31',NULL,NULL),(71456,'87047','S','Sandia Park','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.155441,-106.310313,0,'2013-07-06 12:44:34',NULL,NULL),(18290,'19014','S','Chichester','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(78273,'97861','S','Mikkalo','D','Gilliam','41021','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.716832,-120.199034,0,'2013-07-06 12:44:34',NULL,NULL),(68241,'81055','S','Indian Creek','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.461120,-105.039180,0,'2013-07-06 12:44:34',NULL,NULL),(62027,'73463','S','Wilson','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.161452,-97.425765,0,'2013-07-06 12:44:33',NULL,NULL),(58092,'68104','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.291657,-95.996811,0,'2013-07-06 12:44:33',NULL,NULL),(49185,'56438','S','Browerville','D','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.083198,-94.869079,0,'2013-07-06 12:44:33',NULL,NULL),(44755,'50174','S','Hopeville','N','Clarke','19039','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.040931,-93.949175,0,'2013-07-06 12:44:32',NULL,NULL),(39042,'44147','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.320684,-81.676508,0,'2013-07-06 12:44:32',NULL,NULL),(24412,'27115','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.099410,-80.249956,0,'2013-07-06 12:44:31',NULL,NULL),(16043,'17044','S','Lewistwn','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(14230,'14808','S','North Cohocton','A','Steuben','36101','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.552703,-77.480345,0,'2013-07-06 12:44:31',NULL,NULL),(29244,'32437','S','Ebro','D','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.433336,-85.911773,0,'2013-07-06 12:44:32',NULL,NULL),(46266,'53021','S','Waubeka','A','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.498500,-88.005720,0,'2013-07-06 12:44:32',NULL,NULL),(465,'00664','S','Jard de Jayuya','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(39074,'44214','S','Burbank','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.946706,-81.998141,0,'2013-07-06 12:44:32',NULL,NULL),(39645,'44905','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.775298,-82.476807,0,'2013-07-06 12:44:32',NULL,NULL),(67685,'80514','S','Dacono','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.084772,-104.929982,0,'2013-07-06 12:44:34',NULL,NULL),(74812,'93215','S','Delano','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.770672,-119.247345,0,'2013-07-06 12:44:34',NULL,NULL),(76115,'95234','P','Holt','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.934038,-121.427141,0,'2013-07-06 12:44:34',NULL,NULL),(42519,'47852','P','Graysville','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.106009,-87.433786,0,'2013-07-06 12:44:32',NULL,NULL),(50937,'58572','S','McKenzie','A','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.850141,-100.264685,0,'2013-07-06 12:44:33',NULL,NULL),(42968,'48134','S','Brownstown TWP','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.107811,-83.281359,0,'2013-07-06 12:44:32',NULL,NULL),(25120,'28001','S','Albemarle','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(23073,'24884','S','Squire','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.263607,-81.571953,0,'2013-07-06 12:44:31',NULL,NULL),(28401,'31316','S','Bayview','N','Long','13183','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.730688,-81.735664,0,'2013-07-06 12:44:32',NULL,NULL),(19530,'20188','P','Vint Hill Farms','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.705891,-77.839374,0,'2013-07-06 12:44:31',NULL,NULL),(10455,'10923','S','Garnerville','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.203736,-74.000708,0,'2013-07-06 12:44:30',NULL,NULL),(33459,'37323','S','Cleveland','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.125348,-84.866606,0,'2013-07-06 12:44:32',NULL,NULL),(14468,'15120','S','W Homestead','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.394809,-79.903215,0,'2013-07-06 12:44:31',NULL,NULL),(18308,'19018','S','Secane','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(23243,'25113','S','Big Otter','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.529600,-81.032880,0,'2013-07-06 12:44:31',NULL,NULL),(27216,'29910','S','Pritchardville','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.259699,-80.872324,0,'2013-07-06 12:44:31',NULL,NULL),(31570,'34636','P','Istachatta','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.658911,-82.273018,0,'2013-07-06 12:44:32',NULL,NULL),(70686,'85253','S','Paradise Vly','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.546000,-111.968280,0,'2013-07-06 12:44:34',NULL,NULL),(76089,'95215','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.971031,-121.203236,0,'2013-07-06 12:44:34',NULL,NULL),(33009,'36675','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.695546,-88.046939,0,'2013-07-06 12:44:32',NULL,NULL),(3049,'01106','S','Springfield','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.052405,-72.567774,0,'2013-07-06 12:44:30',NULL,NULL),(71805,'87566','S','San Juan Pblo','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(75988,'95076','S','La Selva Bch','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(25230,'28092','S','Lincolnton','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485140,-81.223860,0,'2013-07-06 12:44:31',NULL,NULL),(56331,'65108','U','Div of Witholding Tax','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.573978,-92.171679,0,'2013-07-06 12:44:33',NULL,NULL),(51669,'59917','S','Eureka','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.876240,-115.050699,0,'2013-07-06 12:44:33',NULL,NULL),(777,'00692','S','Vistas De La Vega','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(7228,'06505','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.307813,-72.923064,0,'2013-07-06 12:44:30',NULL,NULL),(35112,'39210','U','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.276055,-90.218261,0,'2013-07-06 12:44:32',NULL,NULL),(33254,'37082','S','Kingston Spgs','A','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.085361,-87.121788,0,'2013-07-06 12:44:32',NULL,NULL),(24746,'27530','S','Webtown','N','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.379960,-78.097860,0,'2013-07-06 12:44:31',NULL,NULL),(12049,'12528','S','Highland','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.717520,-74.005620,0,'2013-07-06 12:44:30',NULL,NULL),(58521,'68783','S','Verdigre','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.598647,-98.038208,0,'2013-07-06 12:44:33',NULL,NULL),(60834,'72039','S','Martinville','N','Van Buren','05141','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.298334,-92.439056,0,'2013-07-06 12:44:33',NULL,NULL),(63481,'75689','P','Turnertown','A','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.183333,-94.966667,0,'2013-07-06 12:44:33',NULL,NULL),(71366,'86556','P','Chinle','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.326278,-109.268065,0,'2013-07-06 12:44:34',NULL,NULL),(74155,'92259','P','Ocotillo','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.728348,-115.953395,0,'2013-07-06 12:44:34',NULL,NULL),(62806,'74941','S','Cowlington','A','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.289455,-94.900018,0,'2013-07-06 12:44:33',NULL,NULL),(24840,'27616','S','Brentwood','A','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.863033,-78.535615,0,'2013-07-06 12:44:31',NULL,NULL),(27367,'30067','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.930563,-84.462218,0,'2013-07-06 12:44:31',NULL,NULL),(68734,'82201','S','Slater','A','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031976,-104.976675,0,'2013-07-06 12:44:34',NULL,NULL),(77628,'97004','S','Beavercreek','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.253113,-122.477961,0,'2013-07-06 12:44:34',NULL,NULL),(29022,'32228','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(35755,'39736','P','Artesia','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.409816,-88.642641,0,'2013-07-06 12:44:32',NULL,NULL),(15242,'16045','S','Lyndora','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.853036,-79.917677,0,'2013-07-06 12:44:31',NULL,NULL),(19828,'20470','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892775,-77.036853,0,'2013-07-06 12:44:31',NULL,NULL),(61217,'72319','P','Gosnell','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.961585,-89.974738,0,'2013-07-06 12:44:33',NULL,NULL),(58660,'68878','S','Sumner','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.947194,-99.527507,0,'2013-07-06 12:44:33',NULL,NULL),(39627,'44889','S','West Clarksfield','N','Huron','39077','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.224184,-82.403611,0,'2013-07-06 12:44:32',NULL,NULL),(30191,'33179','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.954530,-80.183568,0,'2013-07-06 12:44:32',NULL,NULL),(29819,'33026','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028424,-80.296813,0,'2013-07-06 12:44:32',NULL,NULL),(28603,'31699','U','Moody AFB','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.971019,-83.202986,0,'2013-07-06 12:44:32',NULL,NULL),(56110,'64801','S','Grand Falls','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(51170,'59006','S','Ballantine','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.956810,-108.097366,0,'2013-07-06 12:44:33',NULL,NULL),(6788,'06106','S','West Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.746680,-72.696298,0,'2013-07-06 12:44:30',NULL,NULL),(68337,'81122','S','Gem Village','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.314420,-107.612280,0,'2013-07-06 12:44:34',NULL,NULL),(63525,'75755','S','Holly Lk Rnch','A','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.583260,-95.112002,0,'2013-07-06 12:44:33',NULL,NULL),(80082,'99737','S','Delta Jct','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.022280,-145.516080,0,'2013-07-06 12:44:34',NULL,NULL),(78577,'98168','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.490093,-122.291541,0,'2013-07-06 12:44:34',NULL,NULL),(69135,'83301','S','Hollister','A','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.447360,-114.538200,0,'2013-07-06 12:44:34',NULL,NULL),(9376,'09834','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19403,'20075','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916959,-76.995806,0,'2013-07-06 12:44:31',NULL,NULL),(41680,'47172','S','Speed','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.392719,-85.760504,0,'2013-07-06 12:44:32',NULL,NULL),(18626,'19151','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.977579,-75.254673,0,'2013-07-06 12:44:31',NULL,NULL),(35561,'39566','P','Ocean Springs','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.414895,-88.823565,0,'2013-07-06 12:44:32',NULL,NULL),(13869,'14240','P','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.878840,-78.809620,0,'2013-07-06 12:44:31',NULL,NULL),(57369,'66742','P','Gas','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.924172,-95.347532,0,'2013-07-06 12:44:33',NULL,NULL),(61778,'73068','S','Etowah','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.143049,-97.366525,0,'2013-07-06 12:44:33',NULL,NULL),(65510,'77703','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.111926,-94.118168,0,'2013-07-06 12:44:34',NULL,NULL),(72018,'88045','S','Lordsburg','D','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.347258,-108.708739,0,'2013-07-06 12:44:34',NULL,NULL),(43135,'48236','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(38842,'44089','S','Linwood Park','N','Erie','39043','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.406313,-82.382678,0,'2013-07-06 12:44:32',NULL,NULL),(69392,'83612','S','Hornet','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(75244,'93654','S','Navelencia','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.611335,-119.434150,0,'2013-07-06 12:44:34',NULL,NULL),(34961,'39069','S','Fayette','D','Jefferson','28063','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.708395,-91.061363,0,'2013-07-06 12:44:32',NULL,NULL),(33386,'37216','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.214733,-86.724860,0,'2013-07-06 12:44:32',NULL,NULL),(22303,'23831','S','Chester','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.338977,-77.447582,0,'2013-07-06 12:44:31',NULL,NULL),(51462,'59522','S','Chester','D','Liberty','30051','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.510703,-110.964702,0,'2013-07-06 12:44:33',NULL,NULL),(60935,'72087','S','Lonsdale','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.566522,-92.816237,0,'2013-07-06 12:44:33',NULL,NULL),(77640,'97011','S','Brightwood','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.363522,-122.000338,0,'2013-07-06 12:44:34',NULL,NULL),(40438,'45719','P','Chauncey','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.401522,-82.129448,0,'2013-07-06 12:44:32',NULL,NULL),(42541,'47868','S','Atkinsonville','N','Owen','18119','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.450742,-86.974712,0,'2013-07-06 12:44:32',NULL,NULL),(20456,'21022','P','Brooklandville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.407526,-76.667451,0,'2013-07-06 12:44:31',NULL,NULL),(35541,'39563','S','East Moss Point','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(18181,'18927','S','Hilltown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.322584,-75.245962,0,'2013-07-06 12:44:31',NULL,NULL),(1886,'00791','S','Villa Franca 2','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(32956,'36583','S','Tibbie','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.381734,-88.265038,0,'2013-07-06 12:44:32',NULL,NULL),(7971,'07703','S','Fort Monmouth','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315026,-74.037045,0,'2013-07-06 12:44:30',NULL,NULL),(43570,'48733','S','Fairgrove','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.533081,-83.593351,0,'2013-07-06 12:44:32',NULL,NULL),(43512,'48635','S','Lupton','D','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.402931,-83.988841,0,'2013-07-06 12:44:32',NULL,NULL),(15348,'16236','P','McGrann','N','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.781649,-79.522667,0,'2013-07-06 12:44:31',NULL,NULL),(6603,'05867','S','Sutton','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663871,-72.037012,0,'2013-07-06 12:44:30',NULL,NULL),(13800,'14206','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.869763,-78.796792,0,'2013-07-06 12:44:31',NULL,NULL),(65130,'77381','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.168480,-95.489640,0,'2013-07-06 12:44:34',NULL,NULL),(65371,'77539','S','Dickinson','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.469000,-95.014380,0,'2013-07-06 12:44:34',NULL,NULL),(78534,'98133','S','Richmond Highlands','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.739660,-122.333340,0,'2013-07-06 12:44:34',NULL,NULL),(23516,'25555','S','Prichard','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.247056,-82.578821,0,'2013-07-06 12:44:31',NULL,NULL),(47841,'55073','S','New Scandia','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.271900,-92.831860,0,'2013-07-06 12:44:33',NULL,NULL),(52995,'61447','S','Rozetta','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.868978,-90.754051,0,'2013-07-06 12:44:33',NULL,NULL),(53236,'61643','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.724136,-89.556863,0,'2013-07-06 12:44:33',NULL,NULL),(59644,'71040','S','Aycock','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.787891,-93.059930,0,'2013-07-06 12:44:33',NULL,NULL),(67581,'80310','U','Residence Halls Univ of Co','N','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.009234,-105.269921,0,'2013-07-06 12:44:34',NULL,NULL),(46925,'54153','S','Oconto','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.893296,-87.900009,0,'2013-07-06 12:44:32',NULL,NULL),(1447,'00740','S','Valle Puerto Real','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332837,-65.634129,0,'2013-07-06 12:44:30',NULL,NULL),(19441,'20110','S','Manassas','D','Manassas City','51683','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.748646,-77.477633,0,'2013-07-06 12:44:31',NULL,NULL),(17106,'17771','S','Cascade','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(44523,'49950','S','Mohawk','D','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.316535,-88.344835,0,'2013-07-06 12:44:32',NULL,NULL),(56530,'65409','U','Rolla','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.956712,-91.771492,0,'2013-07-06 12:44:33',NULL,NULL),(41765,'47303','S','Anthony','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(21527,'22727','S','Etlan','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(39696,'45039','S','Foster','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.320497,-84.253761,0,'2013-07-06 12:44:32',NULL,NULL),(15642,'16732','S','Gifford','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.857157,-78.576690,0,'2013-07-06 12:44:31',NULL,NULL),(28922,'32159','S','Lady Lake','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.929131,-81.925528,0,'2013-07-06 12:44:32',NULL,NULL),(14991,'15650','S','Latrobe','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.307482,-79.383971,0,'2013-07-06 12:44:31',NULL,NULL),(27073,'29695','U','Wayside Nurseries','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.287453,-82.245208,0,'2013-07-06 12:44:31',NULL,NULL),(49537,'56680','S','Spring Lake','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.633333,-93.966667,0,'2013-07-06 12:44:33',NULL,NULL),(59572,'70879','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.375009,-90.980828,0,'2013-07-06 12:44:33',NULL,NULL),(62251,'74004','U','Brtlsville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.739762,-95.948625,0,'2013-07-06 12:44:33',NULL,NULL),(66062,'78380','S','San Pedro','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(21751,'23047','S','Doswell','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.850145,-77.506082,0,'2013-07-06 12:44:31',NULL,NULL),(52696,'61105','P','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.267533,-89.098361,0,'2013-07-06 12:44:33',NULL,NULL),(48288,'55435','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.874000,-93.343860,0,'2013-07-06 12:44:33',NULL,NULL),(29290,'32507','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.367319,-87.330899,0,'2013-07-06 12:44:32',NULL,NULL),(70004,'84124','S','Millcreek','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.685813,-111.829118,0,'2013-07-06 12:44:34',NULL,NULL),(72097,'88213','S','Caprock','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.404833,-103.659049,0,'2013-07-06 12:44:34',NULL,NULL),(72579,'89404','P','Pueblo Valley','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(68787,'82335','P','Walcott','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.763315,-106.845197,0,'2013-07-06 12:44:34',NULL,NULL),(6306,'05658','S','Marshfield','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.328420,-72.374820,0,'2013-07-06 12:44:30',NULL,NULL),(4534,'03442','S','Bennington','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.001522,-71.924428,0,'2013-07-06 12:44:30',NULL,NULL),(40780,'46162','S','Needham','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.555482,-85.957258,0,'2013-07-06 12:44:32',NULL,NULL),(39926,'45223','S','Northside','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.162801,-84.548827,0,'2013-07-06 12:44:32',NULL,NULL),(34714,'38834','S','Wenasoga','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(23716,'25901','S','Harvey','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.986637,-81.142428,0,'2013-07-06 12:44:31',NULL,NULL),(18480,'19087','S','Strafford','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(13359,'13730','S','Nineveh Junction','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.209640,-75.490260,0,'2013-07-06 12:44:31',NULL,NULL),(45592,'51549','S','Macedonia','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.189072,-95.425145,0,'2013-07-06 12:44:32',NULL,NULL),(66911,'79316','S','Brownfield','D','Terry','48445','Texas','TX','48','0000','806','Central',-6.0,'Y',33.178367,-102.272062,0,'2013-07-06 12:44:34',NULL,NULL),(78600,'98188','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(38722,'44022','S','Newbury Twp','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(26110,'28723','S','Norton','N','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.284272,-83.179192,0,'2013-07-06 12:44:31',NULL,NULL),(61090,'72133','P','Reydell','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.175799,-91.627993,0,'2013-07-06 12:44:33',NULL,NULL),(21516,'22719','S','Madison','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.556608,-78.307639,0,'2013-07-06 12:44:31',NULL,NULL),(25044,'27909','S','Elizabeth Cty','A','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.295010,-76.233334,0,'2013-07-06 12:44:31',NULL,NULL),(54877,'63056','S','Leslie','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.445236,-91.223446,0,'2013-07-06 12:44:33',NULL,NULL),(713,'00687','S','Jard de Russe','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(72759,'89511','S','Virginia Foothills','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.382155,-119.751830,0,'2013-07-06 12:44:34',NULL,NULL),(11959,'12453','P','Malden on Hudson','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.094637,-73.933788,0,'2013-07-06 12:44:30',NULL,NULL),(58083,'68069','S','Waterloo','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.285288,-96.280956,0,'2013-07-06 12:44:33',NULL,NULL),(58880,'69161','S','Seneca','D','Thomas','31171','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.913830,-100.764572,0,'2013-07-06 12:44:33',NULL,NULL),(4660,'03769','P','Lyme Center','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.794676,-72.065610,0,'2013-07-06 12:44:30',NULL,NULL),(1662,'00773','S','Urb Alamar','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(43751,'49010','S','Allegan','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.531851,-85.867200,0,'2013-07-06 12:44:32',NULL,NULL),(17870,'18436','S','Roaring Bk Tp','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(4224,'02852','S','N Kingstown','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.584340,-71.463799,0,'2013-07-06 12:44:30',NULL,NULL),(31601,'34673','P','Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.275161,-82.720167,0,'2013-07-06 12:44:32',NULL,NULL),(60340,'71465','S','Summerville','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.907286,-92.223113,0,'2013-07-06 12:44:33',NULL,NULL),(63971,'76104','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.728820,-97.319414,0,'2013-07-06 12:44:34',NULL,NULL),(31925,'35178','S','Vincent','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.398446,-86.393123,0,'2013-07-06 12:44:32',NULL,NULL),(5280,'04497','S','Reed Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(50450,'58017','S','Cogswell','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.100640,-97.809420,0,'2013-07-06 12:44:33',NULL,NULL),(31697,'34946','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.482596,-80.353492,0,'2013-07-06 12:44:32',NULL,NULL),(64624,'76702','P','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.544973,-97.142627,0,'2013-07-06 12:44:34',NULL,NULL),(64973,'77259','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.574345,-95.141093,0,'2013-07-06 12:44:34',NULL,NULL),(43504,'48630','P','Hghtn Lk Hts','A','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.325418,-84.774328,0,'2013-07-06 12:44:32',NULL,NULL),(36511,'40828','S','Dizney','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(36398,'40506','U','University of Ky','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.030576,-84.508062,0,'2013-07-06 12:44:32',NULL,NULL),(31677,'34771','S','Magnolia Sq','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.287024,-81.213434,0,'2013-07-06 12:44:32',NULL,NULL),(48062,'55325','S','Dassel','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.092940,-94.315860,0,'2013-07-06 12:44:33',NULL,NULL),(77643,'97014','S','Cascade Locks','D','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.671880,-121.821480,0,'2013-07-06 12:44:34',NULL,NULL),(38258,'43291','U','Eddie Bauer Co','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.976602,-82.856827,0,'2013-07-06 12:44:32',NULL,NULL),(38029,'43022','S','Gambier','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.346971,-82.347352,0,'2013-07-06 12:44:32',NULL,NULL),(54161,'62573','S','Warrensburg','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.929287,-89.062013,0,'2013-07-06 12:44:33',NULL,NULL),(66381,'78622','P','Fentress','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.756855,-97.779629,0,'2013-07-06 12:44:34',NULL,NULL),(56145,'64848','S','La Russell','D','Lawrence','29109','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.193142,-94.016140,0,'2013-07-06 12:44:33',NULL,NULL),(74093,'92198','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.997052,-117.070698,0,'2013-07-06 12:44:34',NULL,NULL),(17619,'18045','S','Tatamy Boro','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(43507,'48631','S','Kawkawlin','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.676581,-83.989626,0,'2013-07-06 12:44:32',NULL,NULL),(33016,'36693','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.631691,-88.156439,0,'2013-07-06 12:44:32',NULL,NULL),(1342,'00736','S','Cayey','D','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(1764,'00780','S','Mans Real','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(37538,'42054','S','Kirksey','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.682144,-88.428036,0,'2013-07-06 12:44:32',NULL,NULL),(37000,'41219','S','Volga','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(3713,'02143','S','E Somerville','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.381835,-71.103174,0,'2013-07-06 12:44:30',NULL,NULL),(11599,'12084','S','Guilderland','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.699325,-73.899710,0,'2013-07-06 12:44:30',NULL,NULL),(6820,'06112','S','Blue Hills','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.794394,-72.696348,0,'2013-07-06 12:44:30',NULL,NULL),(6208,'05486','S','So Hero','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.866206,-73.251370,0,'2013-07-06 12:44:30',NULL,NULL),(56826,'65789','S','Pomona','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.847064,-91.915901,0,'2013-07-06 12:44:33',NULL,NULL),(62002,'73436','P','Gene Autry','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.291154,-97.036168,0,'2013-07-06 12:44:33',NULL,NULL),(62112,'73642','S','Durham','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.847476,-99.919531,0,'2013-07-06 12:44:33',NULL,NULL),(76188,'95343','S','Merced','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.293701,-120.487843,0,'2013-07-06 12:44:34',NULL,NULL),(79534,'98943','P','South Cle Elum','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.190225,-120.953413,0,'2013-07-06 12:44:34',NULL,NULL),(43,'00603','S','Villa Lydia','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(63586,'75783','S','Rock Hill','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.795818,-95.445299,0,'2013-07-06 12:44:34',NULL,NULL),(56576,'65532','P','Lake Spring','D','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.781951,-91.679376,0,'2013-07-06 12:44:33',NULL,NULL),(54978,'63123','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.543880,-90.318420,0,'2013-07-06 12:44:33',NULL,NULL),(46742,'53919','S','Brandon','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.733428,-88.783020,0,'2013-07-06 12:44:32',NULL,NULL),(28105,'30802','S','Appling','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.539800,-82.315022,0,'2013-07-06 12:44:31',NULL,NULL),(5475,'04742','S','Fort Fairfield','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.769823,-67.829838,0,'2013-07-06 12:44:30',NULL,NULL),(32722,'36305','S','Taylor','A','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.222470,-85.390698,0,'2013-07-06 12:44:32',NULL,NULL),(35490,'39522','U','Stennis Space Center','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(14427,'15075','P','Rural Ridge','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.585809,-79.823173,0,'2013-07-06 12:44:31',NULL,NULL),(16015,'17042','S','Cleona','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(70397,'84712','S','Antimony','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.939733,-112.138116,0,'2013-07-06 12:44:34',NULL,NULL),(56179,'65013','S','Belle','D','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.276622,-91.726297,0,'2013-07-06 12:44:33',NULL,NULL),(69719,'84037','S','Kaysville','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.031000,-111.942000,0,'2013-07-06 12:44:34',NULL,NULL),(30903,'33706','S','St Pete Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(7132,'06388','P','West Mystic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.350556,-71.982500,0,'2013-07-06 12:44:30',NULL,NULL),(20059,'20670','S','Patuxent Riv','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.281107,-76.420424,0,'2013-07-06 12:44:31',NULL,NULL),(19562,'20207','U','Consumer Product Safety Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901718,-76.983568,0,'2013-07-06 12:44:31',NULL,NULL),(37658,'42207','S','Bee Spring','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.301324,-86.275612,0,'2013-07-06 12:44:32',NULL,NULL),(12658,'13120','S','Indian Village','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(33440,'37307','S','Benton','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.171455,-84.649915,0,'2013-07-06 12:44:32',NULL,NULL),(71401,'87013','S','Ojo Encino','A','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.863380,-107.072820,0,'2013-07-06 12:44:34',NULL,NULL),(10309,'10533','S','Irvington on Hudson','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.041760,-73.855752,0,'2013-07-06 12:44:30',NULL,NULL),(21706,'22972','S','Somerset','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.207130,-78.237240,0,'2013-07-06 12:44:31',NULL,NULL),(42715,'48002','S','Berlin','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.908333,-82.883056,0,'2013-07-06 12:44:32',NULL,NULL),(46622,'53578','S','Prairie du Sac','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.289654,-89.736826,0,'2013-07-06 12:44:32',NULL,NULL),(67853,'80821','S','Hugo','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.942890,-103.269910,0,'2013-07-06 12:44:34',NULL,NULL),(29916,'33056','S','Miami Gardens','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.946322,-80.247066,0,'2013-07-06 12:44:32',NULL,NULL),(22420,'24004','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270193,-79.944668,0,'2013-07-06 12:44:31',NULL,NULL),(19306,'20006','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896170,-77.042671,0,'2013-07-06 12:44:31',NULL,NULL),(47615,'54895','S','Weyerhaeuser','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.425272,-91.413452,0,'2013-07-06 12:44:33',NULL,NULL),(40064,'45271','U','Key Bank','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.136175,-84.536864,0,'2013-07-06 12:44:32',NULL,NULL),(702,'00685','S','Urb Pepino','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(44712,'50144','S','Leon','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.740854,-93.745139,0,'2013-07-06 12:44:32',NULL,NULL),(50227,'57601','S','Mobridge','D','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.538190,-100.429946,0,'2013-07-06 12:44:33',NULL,NULL),(56269,'65066','S','Bem','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348543,-91.499030,0,'2013-07-06 12:44:33',NULL,NULL),(57549,'67030','S','Colwich','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.757205,-97.532781,0,'2013-07-06 12:44:33',NULL,NULL),(60684,'71932','P','Opal','N','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.552927,-94.204398,0,'2013-07-06 12:44:33',NULL,NULL),(62768,'74859','S','Okemah','D','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.431460,-96.305173,0,'2013-07-06 12:44:33',NULL,NULL),(63428,'75662','S','Kilgore','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.400240,-94.890180,0,'2013-07-06 12:44:33',NULL,NULL),(63861,'75979','S','Woodville','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.754889,-94.393444,0,'2013-07-06 12:44:34',NULL,NULL),(68627,'81632','S','Edwards','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.642795,-106.607621,0,'2013-07-06 12:44:34',NULL,NULL),(73999,'92107','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.740687,-117.238741,0,'2013-07-06 12:44:34',NULL,NULL),(29096,'32266','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.315188,-81.404431,0,'2013-07-06 12:44:32',NULL,NULL),(26397,'29105','S','Watsonia','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.759336,-81.558390,0,'2013-07-06 12:44:31',NULL,NULL),(48882,'56096','S','Waterville','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.217758,-93.568226,0,'2013-07-06 12:44:33',NULL,NULL),(73278,'90743','P','Surfside','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.726441,-118.083289,0,'2013-07-06 12:44:34',NULL,NULL),(64271,'76426','S','Bridgeport','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.151387,-97.821373,0,'2013-07-06 12:44:34',NULL,NULL),(69946,'84117','S','Holladay Cottonwood','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(52907,'61362','S','Webster Park','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.329992,-89.220913,0,'2013-07-06 12:44:33',NULL,NULL),(41265,'46750','S','Goblesville','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(9475,'10010','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(7460,'06860','U','Shared Zip For Brm','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.086401,-73.475590,0,'2013-07-06 12:44:30',NULL,NULL),(24604,'27330','S','Jonesboro Heights','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(31585,'34655','S','New Port Richey','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210274,-82.682809,0,'2013-07-06 12:44:32',NULL,NULL),(68495,'81301','S','Purgatory','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.326840,-107.831460,0,'2013-07-06 12:44:34',NULL,NULL),(43650,'48843','S','Howell','D','Livingston','26093','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.620869,-83.919104,0,'2013-07-06 12:44:32',NULL,NULL),(42573,'47876','P','St Mary of Wd','A','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.511739,-87.474237,0,'2013-07-06 12:44:32',NULL,NULL),(26498,'29169','S','Saluda Gardens','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(26635,'29332','S','Cross Hill','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.283143,-81.982876,0,'2013-07-06 12:44:31',NULL,NULL),(54058,'62474','S','Parker','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.454400,-87.997271,0,'2013-07-06 12:44:33',NULL,NULL),(33158,'37014','S','Triune','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.864580,-86.664840,0,'2013-07-06 12:44:32',NULL,NULL),(1295,'00730','S','Urb La Rambla','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(49558,'56711','P','Penasse','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',49.309708,-95.090831,0,'2013-07-06 12:44:33',NULL,NULL),(65593,'77875','P','Roans Prairie','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.583507,-95.941256,0,'2013-07-06 12:44:34',NULL,NULL),(10835,'11385','S','Glendale','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702860,-73.879740,0,'2013-07-06 12:44:30',NULL,NULL),(9330,'09743','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(6364,'05676','S','Duxbury','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.345220,-72.785100,0,'2013-07-06 12:44:30',NULL,NULL),(16562,'17314','S','Delta','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.730000,-76.313333,0,'2013-07-06 12:44:31',NULL,NULL),(3347,'01550','S','Southbridge','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.077174,-72.032139,0,'2013-07-06 12:44:30',NULL,NULL),(46567,'53518','S','Blue River','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.185758,-90.552858,0,'2013-07-06 12:44:32',NULL,NULL),(59638,'71038','S','Millerton','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(67299,'80016','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.584457,-104.758155,0,'2013-07-06 12:44:34',NULL,NULL),(67847,'80818','S','Genoa','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.275097,-103.500657,0,'2013-07-06 12:44:34',NULL,NULL),(41366,'46794','S','Diamond Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(13164,'13607','S','Point Vivian','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(61816,'73106','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483548,-97.534998,0,'2013-07-06 12:44:33',NULL,NULL),(13692,'14054','S','East Bethany','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.915590,-78.135091,0,'2013-07-06 12:44:31',NULL,NULL),(68301,'81091','S','Vigil','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(30737,'33541','S','Zephyrhills','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.237746,-82.210716,0,'2013-07-06 12:44:32',NULL,NULL),(76097,'95223','S','Arnold','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.263800,-120.332640,0,'2013-07-06 12:44:34',NULL,NULL),(75878,'94952','S','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.244916,-122.659988,0,'2013-07-06 12:44:34',NULL,NULL),(69428,'83637','S','Lowman','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.140322,-115.552484,0,'2013-07-06 12:44:34',NULL,NULL),(69157,'83318','S','Pella','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.528311,-113.790822,0,'2013-07-06 12:44:34',NULL,NULL),(54139,'62563','S','Rochester','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748414,-89.542262,0,'2013-07-06 12:44:33',NULL,NULL),(53077,'61523','S','Renchville','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(51069,'58755','S','McGregor','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.591101,-102.949822,0,'2013-07-06 12:44:33',NULL,NULL),(4003,'02543','S','Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.526561,-70.667528,0,'2013-07-06 12:44:30',NULL,NULL),(21905,'23188','S','Wlmg','N','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.326834,-76.760558,0,'2013-07-06 12:44:31',NULL,NULL),(23817,'26060','S','Valley Grove','D','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.092999,-80.573503,0,'2013-07-06 12:44:31',NULL,NULL),(24388,'27103','S','Ardmore','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.069214,-80.316170,0,'2013-07-06 12:44:31',NULL,NULL),(8647,'08310','S','Buena','D','Atlantic','34001','New Jersey','NJ','34','0560','856','Eastern',-5.0,'Y',39.527337,-74.912575,0,'2013-07-06 12:44:30',NULL,NULL),(12479,'12986','S','Tupper Lake','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.235050,-74.464960,0,'2013-07-06 12:44:30',NULL,NULL),(29026,'32228','P','Mayport Naval Sta','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(29654,'32905','S','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.028121,-80.601039,0,'2013-07-06 12:44:32',NULL,NULL),(2409,'00953','S','Ciudad Jardin III','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(16745,'17509','S','Bartville','N','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(4541,'03446','S','E Swanzey','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.854142,-72.260794,0,'2013-07-06 12:44:30',NULL,NULL),(16703,'17402','S','Stonybrook','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(27012,'29641','P','Easley','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.843681,-82.595072,0,'2013-07-06 12:44:31',NULL,NULL),(60889,'72068','S','Higginson','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.181008,-91.715439,0,'2013-07-06 12:44:33',NULL,NULL),(60791,'72026','S','Casscoe','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.455148,-91.327569,0,'2013-07-06 12:44:33',NULL,NULL),(48825,'56036','S','Myrtle','A','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.571784,-93.274151,0,'2013-07-06 12:44:33',NULL,NULL),(49675,'57013','S','Canton','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.303968,-96.595930,0,'2013-07-06 12:44:33',NULL,NULL),(25835,'28618','S','Stony Fork','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.192222,-81.529594,0,'2013-07-06 12:44:31',NULL,NULL),(6349,'05673','S','Mad River Glen','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.187565,-72.843339,0,'2013-07-06 12:44:30',NULL,NULL),(45564,'51510','S','Carter Lake','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.291727,-95.910128,0,'2013-07-06 12:44:32',NULL,NULL),(60002,'71333','S','Goudeau','A','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.946851,-92.094994,0,'2013-07-06 12:44:33',NULL,NULL),(15538,'16603','P','Altoona','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.516049,-78.374390,0,'2013-07-06 12:44:31',NULL,NULL),(80086,'99739','P','Elim','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.759345,-162.070639,0,'2013-07-06 12:44:34',NULL,NULL),(76734,'95903','S','Beale AFB','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.110580,-121.357920,0,'2013-07-06 12:44:34',NULL,NULL),(71639,'87416','S','Fruitland','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.745061,-108.394950,0,'2013-07-06 12:44:34',NULL,NULL),(55707,'64067','S','Lexington','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.149380,-93.846657,0,'2013-07-06 12:44:33',NULL,NULL),(26492,'29166','S','Ward','D','Saluda','45081','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.884865,-81.740141,0,'2013-07-06 12:44:31',NULL,NULL),(20175,'20745','S','Oxon Hill','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.807841,-76.989145,0,'2013-07-06 12:44:31',NULL,NULL),(8785,'08557','P','Sergeantsville','D','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.445407,-74.943046,0,'2013-07-06 12:44:30',NULL,NULL),(39226,'44415','P','Elkton','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.770882,-80.691391,0,'2013-07-06 12:44:32',NULL,NULL),(15048,'15714','S','Barnesboro','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.663026,-78.778938,0,'2013-07-06 12:44:31',NULL,NULL),(13969,'14476','S','Kendall','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.333198,-78.046930,0,'2013-07-06 12:44:31',NULL,NULL),(45927,'52333','S','Solon','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.803913,-91.515810,0,'2013-07-06 12:44:32',NULL,NULL),(5213,'04459','S','Mattawamkeag','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.544499,-68.310790,0,'2013-07-06 12:44:30',NULL,NULL),(41337,'46783','S','Roanoke','D','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.962488,-85.294525,0,'2013-07-06 12:44:32',NULL,NULL),(27719,'30344','S','East Point','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.668940,-84.458280,0,'2013-07-06 12:44:31',NULL,NULL),(63181,'75413','P','Bailey','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.433133,-96.164564,0,'2013-07-06 12:44:33',NULL,NULL),(31326,'34134','S','Barefoot Bch','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.362812,-81.822980,0,'2013-07-06 12:44:32',NULL,NULL),(29756,'33001','P','Long Key','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.816667,-80.816667,0,'2013-07-06 12:44:32',NULL,NULL),(36030,'40175','S','Big Spring','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.814263,-85.990010,0,'2013-07-06 12:44:32',NULL,NULL),(62340,'74055','S','Owosso','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.279959,-95.850118,0,'2013-07-06 12:44:33',NULL,NULL),(60577,'71772','P','Whelen Spgs','A','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.831489,-93.126424,0,'2013-07-06 12:44:33',NULL,NULL),(51895,'60098','S','Greenwood','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.320586,-88.447623,0,'2013-07-06 12:44:33',NULL,NULL),(50519,'58079','S','Chaffee','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.877214,-97.409644,0,'2013-07-06 12:44:33',NULL,NULL),(48272,'55429','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(47129,'54454','S','Sherry','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.602472,-89.883051,0,'2013-07-06 12:44:32',NULL,NULL),(44047,'49428','S','Jenison','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.907457,-85.830308,0,'2013-07-06 12:44:32',NULL,NULL),(9463,'10008','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(10588,'11024','S','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.804080,-73.740120,0,'2013-07-06 12:44:30',NULL,NULL),(33994,'38117','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.115970,-89.901902,0,'2013-07-06 12:44:32',NULL,NULL),(74492,'92620','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.700942,-117.756405,0,'2013-07-06 12:44:34',NULL,NULL),(47751,'55020','S','Elko New Mrkt','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.567439,-93.328186,0,'2013-07-06 12:44:33',NULL,NULL),(1358,'00736','S','Sect Sanchez','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(33960,'38105','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.150666,-90.031667,0,'2013-07-06 12:44:32',NULL,NULL),(27337,'30039','S','Snellville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.816200,-84.018020,0,'2013-07-06 12:44:31',NULL,NULL),(37425,'41821','S','Hallie','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.075833,-82.981667,0,'2013-07-06 12:44:32',NULL,NULL),(58228,'68346','S','Dunbar','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.655568,-96.007618,0,'2013-07-06 12:44:33',NULL,NULL),(22901,'24597','S','Ingram','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.792310,-79.124740,0,'2013-07-06 12:44:31',NULL,NULL),(22017,'23288','U','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.601923,-77.546947,0,'2013-07-06 12:44:31',NULL,NULL),(64661,'76802','S','Brownwood','A','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.753994,-98.924325,0,'2013-07-06 12:44:34',NULL,NULL),(66690,'78944','S','Industry','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989859,-96.530885,0,'2013-07-06 12:44:34',NULL,NULL),(30941,'33715','S','Tierra Verde','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.687120,-82.712580,0,'2013-07-06 12:44:32',NULL,NULL),(78193,'97731','S','Diamond Lake','A','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.065300,-121.849920,0,'2013-07-06 12:44:34',NULL,NULL),(65717,'78022','S','George West','D','Live Oak','48297','Texas','TX','48','0000','361','Central',-6.0,'Y',28.328968,-98.118165,0,'2013-07-06 12:44:34',NULL,NULL),(59303,'70510','S','Meaux','A','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.904840,-92.133480,0,'2013-07-06 12:44:33',NULL,NULL),(56640,'65610','S','Union City','N','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.063707,-93.556821,0,'2013-07-06 12:44:33',NULL,NULL),(54590,'62901','S','Crab Orchard Estates','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(52543,'60935','S','Essex','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.177901,-88.192704,0,'2013-07-06 12:44:33',NULL,NULL),(51715,'60010','S','Hoffman Estates','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(51215,'59047','S','Livingston','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.652211,-110.568153,0,'2013-07-06 12:44:33',NULL,NULL),(50890,'58535','S','Freda','N','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.466520,-101.178960,0,'2013-07-06 12:44:33',NULL,NULL),(14410,'15065','S','Natrona Hts','A','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.637760,-79.720740,0,'2013-07-06 12:44:31',NULL,NULL),(23822,'26075','P','Windsor Hts','A','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.191404,-80.665424,0,'2013-07-06 12:44:31',NULL,NULL),(5674,'04964','P','Oquossoc','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.943193,-70.653585,0,'2013-07-06 12:44:30',NULL,NULL),(38517,'43724','S','Caldwell','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.769680,-81.480060,0,'2013-07-06 12:44:32',NULL,NULL),(39842,'45162','S','Pleasant Plain','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.296640,-84.086520,0,'2013-07-06 12:44:32',NULL,NULL),(839,'00698','S','Bda Lluberas','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(8083,'07757','S','Oceanport','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315089,-74.017467,0,'2013-07-06 12:44:30',NULL,NULL),(15839,'16936','S','Jackson Smt','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.931667,-76.936111,0,'2013-07-06 12:44:31',NULL,NULL),(60871,'72058','S','Republican','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(46776,'53952','S','Oxford','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.802455,-89.641674,0,'2013-07-06 12:44:32',NULL,NULL),(65132,'77382','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.229380,-95.510820,0,'2013-07-06 12:44:34',NULL,NULL),(69092,'83253','S','Ellis','N','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.577861,-113.809881,0,'2013-07-06 12:44:34',NULL,NULL),(77317,'96698','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(78225,'97761','P','Warm Springs','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.762816,-121.302390,0,'2013-07-06 12:44:34',NULL,NULL),(15106,'15773','S','St Benedict','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.608504,-78.736951,0,'2013-07-06 12:44:31',NULL,NULL),(76927,'96014','S','Callahan','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.334799,-122.813345,0,'2013-07-06 12:44:34',NULL,NULL),(67825,'80801','S','Anton','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.709723,-103.281853,0,'2013-07-06 12:44:34',NULL,NULL),(53356,'61764','S','Owego','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(52162,'60453','S','Oak Lawn','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.713314,-87.756652,0,'2013-07-06 12:44:33',NULL,NULL),(50683,'58346','S','Leeds','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.276420,-99.437460,0,'2013-07-06 12:44:33',NULL,NULL),(48794,'56003','S','North Mankato','A','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.185763,-94.056217,0,'2013-07-06 12:44:33',NULL,NULL),(47589,'54858','S','Milltown','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.527734,-92.506351,0,'2013-07-06 12:44:33',NULL,NULL),(45904,'52316','S','North English','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.518029,-92.080384,0,'2013-07-06 12:44:32',NULL,NULL),(30347,'33311','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(25679,'28515','S','Mesic','A','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.132651,-76.760131,0,'2013-07-06 12:44:31',NULL,NULL),(32603,'36133','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.374861,-86.309891,0,'2013-07-06 12:44:32',NULL,NULL),(1583,'00767','S','Yabucoa','D','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(51944,'60130','S','Forest Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.871581,-87.815134,0,'2013-07-06 12:44:33',NULL,NULL),(60214,'71422','S','Tannehill','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.066880,-92.645400,0,'2013-07-06 12:44:33',NULL,NULL),(77292,'96657','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(49153,'56382','S','Swanville','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.946803,-94.625252,0,'2013-07-06 12:44:33',NULL,NULL),(75337,'93844','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.753633,-119.673434,0,'2013-07-06 12:44:34',NULL,NULL),(75311,'93750','U','Fresno Cnty Social Svc Dept','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.838720,-119.788009,0,'2013-07-06 12:44:34',NULL,NULL),(15969,'17030','S','Gratz','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.608917,-76.718596,0,'2013-07-06 12:44:31',NULL,NULL),(7985,'07712','S','Tinton Falls','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(23141,'24983','S','Willow Bend','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.562090,-80.514593,0,'2013-07-06 12:44:31',NULL,NULL),(7184,'06468','S','Upper Stepney','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.340900,-73.234440,0,'2013-07-06 12:44:30',NULL,NULL),(65814,'78142','P','Normanna','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.530161,-97.783158,0,'2013-07-06 12:44:34',NULL,NULL),(52468,'60684','U','Sears Tower','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.870185,-87.671984,0,'2013-07-06 12:44:33',NULL,NULL),(25425,'28303','S','Ponderosa','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.081833,-78.962365,0,'2013-07-06 12:44:31',NULL,NULL),(39844,'45164','P','Port William','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.551661,-83.786658,0,'2013-07-06 12:44:32',NULL,NULL),(2145,'00924','S','Urb Sevilla','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(20575,'21152','S','Sparks Glenco','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.543240,-76.682820,0,'2013-07-06 12:44:31',NULL,NULL),(43692,'48884','S','Sheridan','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.211632,-85.052531,0,'2013-07-06 12:44:32',NULL,NULL),(17092,'17764','S','West Renovo','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(34670,'38820','P','Algoma','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.178945,-88.965751,0,'2013-07-06 12:44:32',NULL,NULL),(38629,'43920','S','E Liverpool','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.671120,-80.583060,0,'2013-07-06 12:44:32',NULL,NULL),(60241,'71433','S','Blanche','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(62142,'73716','S','Aline','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.512405,-98.451450,0,'2013-07-06 12:44:33',NULL,NULL),(76278,'95424','P','Clearlake Park','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.968797,-122.661577,0,'2013-07-06 12:44:34',NULL,NULL),(79723,'99214','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.711392,-117.206773,0,'2013-07-06 12:44:34',NULL,NULL),(42249,'47575','S','St Anthony','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.333863,-86.821988,0,'2013-07-06 12:44:32',NULL,NULL),(58032,'68008','S','Blair','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.543330,-96.141019,0,'2013-07-06 12:44:33',NULL,NULL),(54183,'62625','S','Cantrall','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.926649,-89.669971,0,'2013-07-06 12:44:33',NULL,NULL),(17152,'17810','S','Allenwood','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.117860,-77.022795,0,'2013-07-06 12:44:31',NULL,NULL),(47512,'54771','S','Thorp','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.957639,-90.800960,0,'2013-07-06 12:44:32',NULL,NULL),(39968,'45237','S','Golf Manor','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(18051,'18702','S','Bear Creek Tw','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(32714,'36301','S','Taylor','A','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(7911,'07626','S','Cresskill','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.941788,-73.964411,0,'2013-07-06 12:44:30',NULL,NULL),(64611,'76687','S','Oletha','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(64974,'77261','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.675671,-95.244406,0,'2013-07-06 12:44:34',NULL,NULL),(69019,'83211','S','Neeley','N','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(57908,'67654','S','Norton','D','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.834865,-99.889403,0,'2013-07-06 12:44:33',NULL,NULL),(54470,'62858','S','Louisville','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(46727,'53818','S','Platteville','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.747092,-90.496206,0,'2013-07-06 12:44:32',NULL,NULL),(5386,'04645','P','Isle au Haut','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.075278,-68.633889,0,'2013-07-06 12:44:30',NULL,NULL),(73111,'90250','S','Hollyglen','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.915300,-118.351309,0,'2013-07-06 12:44:34',NULL,NULL),(3893,'02421','S','Lexington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.448372,-71.233754,0,'2013-07-06 12:44:30',NULL,NULL),(22821,'24502','S','Fort Hill','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.359789,-79.218967,0,'2013-07-06 12:44:31',NULL,NULL),(3731,'02155','S','Medford','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.421320,-71.113443,0,'2013-07-06 12:44:30',NULL,NULL),(7807,'07440','S','Pequannock Township','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.946757,-74.294839,0,'2013-07-06 12:44:30',NULL,NULL),(1282,'00730','S','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(17136,'17778','S','Keating','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.309029,-77.972308,0,'2013-07-06 12:44:31',NULL,NULL),(44117,'49506','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(24036,'26405','S','Kasson','A','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.224954,-79.904469,0,'2013-07-06 12:44:31',NULL,NULL),(61277,'72389','P','Wabash','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.396758,-90.863995,0,'2013-07-06 12:44:33',NULL,NULL),(63218,'75454','S','Melissa','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.278837,-96.587184,0,'2013-07-06 12:44:33',NULL,NULL),(65774,'78111','S','Gillett','A','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',29.046111,-97.751111,0,'2013-07-06 12:44:34',NULL,NULL),(69884,'84102','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758805,-111.865417,0,'2013-07-06 12:44:34',NULL,NULL),(72390,'89040','S','Overton Beach','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(75115,'93546','S','Mammoth Lakes','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.564380,-118.744510,0,'2013-07-06 12:44:34',NULL,NULL),(2510,'00957','S','Urb Flamingo Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(56751,'65725','S','Pleasant Hope','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.475864,-93.255307,0,'2013-07-06 12:44:33',NULL,NULL),(23777,'25978','S','Nimitz','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.626395,-80.937460,0,'2013-07-06 12:44:31',NULL,NULL),(5635,'04945','S','Moose River','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(26663,'29377','P','Startex','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.931343,-82.098636,0,'2013-07-06 12:44:31',NULL,NULL),(40242,'45424','S','Huber Hts','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.845640,-84.111720,0,'2013-07-06 12:44:32',NULL,NULL),(6758,'06090','S','West Granby','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.953225,-72.860826,0,'2013-07-06 12:44:30',NULL,NULL),(70774,'85341','P','Lukeville','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.881005,-112.815265,0,'2013-07-06 12:44:34',NULL,NULL),(74506,'92630','S','Lake Forest','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.645780,-117.669120,0,'2013-07-06 12:44:34',NULL,NULL),(39820,'45147','P','Miamiville','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.212370,-84.299993,0,'2013-07-06 12:44:32',NULL,NULL),(1219,'00728','S','Urb Las Delicias','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(22174,'23466','P','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.838360,-76.153224,0,'2013-07-06 12:44:31',NULL,NULL),(74224,'92315','S','Big Bear Lake','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.244670,-116.890676,0,'2013-07-06 12:44:34',NULL,NULL),(72304,'88585','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770440,-106.329042,0,'2013-07-06 12:44:34',NULL,NULL),(68310,'81101','S','Henry','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(14236,'14812','S','Beaver Dams','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.307691,-76.988302,0,'2013-07-06 12:44:31',NULL,NULL),(28552,'31565','S','Hickory Bluff','N','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.047300,-81.577500,0,'2013-07-06 12:44:32',NULL,NULL),(1191,'00728','S','Comunidad Punta Diamante','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(39699,'45039','S','Landon','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.320497,-84.253761,0,'2013-07-06 12:44:32',NULL,NULL),(32525,'36091','S','Verbena','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.692852,-86.553384,0,'2013-07-06 12:44:32',NULL,NULL),(14829,'15429','P','Denbo','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.004049,-79.935234,0,'2013-07-06 12:44:31',NULL,NULL),(7259,'06517','S','Hamden','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.349805,-72.913991,0,'2013-07-06 12:44:30',NULL,NULL),(5687,'04971','S','Saint Albans','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.920418,-69.621989,0,'2013-07-06 12:44:30',NULL,NULL),(45456,'51241','S','Granite','N','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.453490,-96.435021,0,'2013-07-06 12:44:32',NULL,NULL),(69823,'84075','S','Syracuse','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.082208,-112.075504,0,'2013-07-06 12:44:34',NULL,NULL),(71181,'86043','P','Shongopovi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.805000,-110.491944,0,'2013-07-06 12:44:34',NULL,NULL),(4515,'03301','S','Concord','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.238760,-71.511000,0,'2013-07-06 12:44:30',NULL,NULL),(19289,'19971','S','Dewey Beach','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.726540,-75.081250,0,'2013-07-06 12:44:31',NULL,NULL),(50445,'58012','S','Casselton','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.902199,-97.211966,0,'2013-07-06 12:44:33',NULL,NULL),(47881,'55090','P','Willernie','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052511,-92.957501,0,'2013-07-06 12:44:33',NULL,NULL),(16607,'17331','S','Baresville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(2966,'01041','P','Holyoke','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.207463,-72.611418,0,'2013-07-06 12:44:30',NULL,NULL),(32162,'35474','S','Havana','A','Hale','01065','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.007906,-87.600750,0,'2013-07-06 12:44:32',NULL,NULL),(69629,'83876','S','Worley','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.446445,-116.913723,0,'2013-07-06 12:44:34',NULL,NULL),(71291,'86443','S','Templ Bar Mar','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',36.024395,-114.298481,0,'2013-07-06 12:44:34',NULL,NULL),(76857,'95965','S','Wyandotte','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(65630,'77963','S','Schroeder','N','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(80004,'99670','P','South Naknek','D','Bristol Bay','02060','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.712060,-156.908999,0,'2013-07-06 12:44:34',NULL,NULL),(62296,'74022','S','Copan','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.896936,-95.924587,0,'2013-07-06 12:44:33',NULL,NULL),(58740,'68950','S','Denver','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.434655,-98.666771,0,'2013-07-06 12:44:33',NULL,NULL),(6569,'05851','S','Wheelock','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544120,-72.021300,0,'2013-07-06 12:44:30',NULL,NULL),(11993,'12482','S','South Cairo','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.274889,-73.952337,0,'2013-07-06 12:44:30',NULL,NULL),(10112,'10258','U','European American Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713720,-74.007559,0,'2013-07-06 12:44:30',NULL,NULL),(31750,'34988','P','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.341002,-80.519774,0,'2013-07-06 12:44:32',NULL,NULL),(6100,'05452','S','Essex Ctr','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.499816,-73.089496,0,'2013-07-06 12:44:30',NULL,NULL),(14042,'14556','P','Sonyea','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.679657,-77.826587,0,'2013-07-06 12:44:31',NULL,NULL),(4993,'04211','P','Auburn','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.083325,-70.247116,0,'2013-07-06 12:44:30',NULL,NULL),(12854,'13317','S','Sprout Brook','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(58663,'68881','S','Spring Creek','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.414776,-99.392022,0,'2013-07-06 12:44:33',NULL,NULL),(69644,'84006','S','Bingham Cyn','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.533333,-112.150000,0,'2013-07-06 12:44:34',NULL,NULL),(70381,'84660','S','Palmyra','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(72508,'89152','U','Embarq Telphone','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.170712,-115.209471,0,'2013-07-06 12:44:34',NULL,NULL),(79251,'98562','P','Moclips','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.237863,-124.097499,0,'2013-07-06 12:44:34',NULL,NULL),(69916,'84109','S','Millcreek','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701306,-111.815899,0,'2013-07-06 12:44:34',NULL,NULL),(63689,'75862','S','Glendale','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(5006,'04222','S','Durham','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',43.931777,-70.147030,0,'2013-07-06 12:44:30',NULL,NULL),(15472,'16427','P','Mill Village','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.875887,-79.967552,0,'2013-07-06 12:44:31',NULL,NULL),(24464,'27235','S','Colfax','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.099110,-80.009479,0,'2013-07-06 12:44:31',NULL,NULL),(49963,'57350','S','Huron','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.359540,-98.217645,0,'2013-07-06 12:44:33',NULL,NULL),(9622,'10034','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(39633,'44890','S','Willard','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(34417,'38634','P','Holly Springs','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.772071,-89.440463,0,'2013-07-06 12:44:32',NULL,NULL),(15387,'16322','P','Endeavor','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.560795,-79.374860,0,'2013-07-06 12:44:31',NULL,NULL),(31314,'34109','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.236364,-81.764780,0,'2013-07-06 12:44:32',NULL,NULL),(27854,'30436','S','Ohoopee','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.201196,-82.323239,0,'2013-07-06 12:44:31',NULL,NULL),(71877,'87731','S','Gallinas','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.696667,-105.382222,0,'2013-07-06 12:44:34',NULL,NULL),(72750,'89510','S','Palomino Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(4143,'02761','P','N Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.979305,-71.331434,0,'2013-07-06 12:44:30',NULL,NULL),(21451,'22603','S','Hayfield','A','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.204657,-78.162238,0,'2013-07-06 12:44:31',NULL,NULL),(20866,'21666','S','Stevensville','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.932349,-76.336467,0,'2013-07-06 12:44:31',NULL,NULL),(18016,'18640','S','Port Griffith','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(17129,'17777','S','Delaware Run','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.092752,-76.861603,0,'2013-07-06 12:44:31',NULL,NULL),(32343,'35804','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.729985,-86.585901,0,'2013-07-06 12:44:32',NULL,NULL),(22308,'23834','S','Colonial Heights','D','Colonial Heights City','51570','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.287361,-77.391074,0,'2013-07-06 12:44:31',NULL,NULL),(65485,'77650','P','Bolivar','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.449643,-94.635997,0,'2013-07-06 12:44:34',NULL,NULL),(68931,'82925','S','Cora','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.112794,-109.988839,0,'2013-07-06 12:44:34',NULL,NULL),(69683,'84025','S','Farmington','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.983682,-111.870619,0,'2013-07-06 12:44:34',NULL,NULL),(70918,'85632','S','Paradise','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.177580,-109.379880,0,'2013-07-06 12:44:34',NULL,NULL),(74586,'92694','S','Ran Msn Viejo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.555120,-117.666532,0,'2013-07-06 12:44:34',NULL,NULL),(38168,'43153','S','South Solon','D','Madison','39097','Ohio','OH','39','1840','937','Eastern',-5.0,'Y',39.741198,-83.564833,0,'2013-07-06 12:44:32',NULL,NULL),(38165,'43152','S','S Bloomingville','A','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.407940,-82.611540,0,'2013-07-06 12:44:32',NULL,NULL),(66360,'78615','S','Coupland','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.544620,-97.321980,0,'2013-07-06 12:44:34',NULL,NULL),(47569,'54843','S','Hayward','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.018712,-91.462960,0,'2013-07-06 12:44:33',NULL,NULL),(14431,'15081','P','South Heights','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576453,-80.237470,0,'2013-07-06 12:44:31',NULL,NULL),(13063,'13449','U','Rome','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.225494,-75.492278,0,'2013-07-06 12:44:30',NULL,NULL),(70370,'84654','S','Gooseberry','N','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.951768,-111.860719,0,'2013-07-06 12:44:34',NULL,NULL),(77169,'96266','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(6074,'05447','S','Berkshire','N','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.930619,-72.710708,0,'2013-07-06 12:44:30',NULL,NULL),(35981,'40117','S','Ekron','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.906255,-86.150031,0,'2013-07-06 12:44:32',NULL,NULL),(21168,'22152','S','W Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.777214,-77.235211,0,'2013-07-06 12:44:31',NULL,NULL),(34407,'38627','S','Pinedale','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.434041,-89.185271,0,'2013-07-06 12:44:32',NULL,NULL),(23797,'26032','S','Bethany','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.204912,-80.557309,0,'2013-07-06 12:44:31',NULL,NULL),(9621,'10033','S','Washington Bridge','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(43029,'48173','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(14396,'15052','S','Industry','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.671192,-80.430030,0,'2013-07-06 12:44:31',NULL,NULL),(8378,'08055','S','Medford Lakes','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862774,-74.815854,0,'2013-07-06 12:44:30',NULL,NULL),(53369,'61773','S','Sibley','D','Ford','17053','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.588171,-88.380978,0,'2013-07-06 12:44:33',NULL,NULL),(54780,'62999','S','Zeigler','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.902282,-89.055677,0,'2013-07-06 12:44:33',NULL,NULL),(62121,'73655','S','Lone Wolf','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.991436,-99.245561,0,'2013-07-06 12:44:33',NULL,NULL),(69761,'84053','S','Neola','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.512629,-110.096294,0,'2013-07-06 12:44:34',NULL,NULL),(74764,'93103','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.427799,-119.684102,0,'2013-07-06 12:44:34',NULL,NULL),(79308,'98593','S','Vader','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.404935,-122.970879,0,'2013-07-06 12:44:34',NULL,NULL),(22154,'23459','S','Naval Amphib Base','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(46890,'54115','S','Hobart','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.434457,-88.070098,0,'2013-07-06 12:44:32',NULL,NULL),(1783,'00782','S','Urb Rio Plata','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(11135,'11707','P','Babylon','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.700400,-73.327799,0,'2013-07-06 12:44:30',NULL,NULL),(6730,'06075','P','Stafford','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.987932,-72.287083,0,'2013-07-06 12:44:30',NULL,NULL),(71681,'87511','P','La Villita','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.103333,-106.047500,0,'2013-07-06 12:44:34',NULL,NULL),(74210,'92305','S','Seven Oaks','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.113181,-117.029126,0,'2013-07-06 12:44:34',NULL,NULL),(51386,'59417','S','Browning','D','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.571299,-113.206612,0,'2013-07-06 12:44:33',NULL,NULL),(18169,'18914','S','Chalfont','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.283914,-75.196735,0,'2013-07-06 12:44:31',NULL,NULL),(10671,'11120','U','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747242,-73.949347,0,'2013-07-06 12:44:30',NULL,NULL),(16173,'17065','S','Mt Holly Springs','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.117148,-77.192329,0,'2013-07-06 12:44:31',NULL,NULL),(46837,'54017','S','Alden','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(49746,'57058','S','Salem','D','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.737240,-97.384440,0,'2013-07-06 12:44:33',NULL,NULL),(54097,'62534','S','Findlay','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.520163,-88.754757,0,'2013-07-06 12:44:33',NULL,NULL),(58133,'68139','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.221510,-96.120245,0,'2013-07-06 12:44:33',NULL,NULL),(67930,'80908','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.046410,-104.669910,0,'2013-07-06 12:44:34',NULL,NULL),(71775,'87557','S','Ranch Taos','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(73475,'91316','S','Encino','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.162355,-118.514077,0,'2013-07-06 12:44:34',NULL,NULL),(51998,'60163','S','Melrose Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.884020,-87.908634,0,'2013-07-06 12:44:33',NULL,NULL),(5367,'04626','S','Cutler','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.691830,-67.216792,0,'2013-07-06 12:44:30',NULL,NULL),(51849,'60073','S','Hainesville','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(55443,'63674','P','Tiff','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.018253,-90.651893,0,'2013-07-06 12:44:33',NULL,NULL),(44715,'50146','S','Linden','D','Dallas','19049','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.641849,-94.271445,0,'2013-07-06 12:44:32',NULL,NULL),(27618,'30307','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.769788,-84.328046,0,'2013-07-06 12:44:31',NULL,NULL),(9915,'10150','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(11469,'12016','P','Fultonville','A','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.928783,-74.319642,0,'2013-07-06 12:44:30',NULL,NULL),(34496,'38668','S','Wyatte','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(12991,'13408','S','Morrisville Station','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.905156,-75.677630,0,'2013-07-06 12:44:30',NULL,NULL),(45432,'51101','S','Wickham Spur','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.494368,-96.395068,0,'2013-07-06 12:44:32',NULL,NULL),(52700,'61109','S','Morristown','N','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.194700,-89.062680,0,'2013-07-06 12:44:33',NULL,NULL),(54755,'62984','S','Gold Hill','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.715092,-88.188836,0,'2013-07-06 12:44:33',NULL,NULL),(64891,'77079','S','Addicks','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.781784,-95.602535,0,'2013-07-06 12:44:34',NULL,NULL),(70580,'85072','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.453483,-112.009671,0,'2013-07-06 12:44:34',NULL,NULL),(73713,'91612','U','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186548,-118.396887,0,'2013-07-06 12:44:34',NULL,NULL),(66955,'79378','P','Wellman','D','Terry','48445','Texas','TX','48','0000','806','Central',-6.0,'Y',33.044827,-102.427981,0,'2013-07-06 12:44:34',NULL,NULL),(61403,'72546','S','Ida','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.596815,-91.946535,0,'2013-07-06 12:44:33',NULL,NULL),(52169,'60457','S','Hickory Hills','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.727067,-87.828588,0,'2013-07-06 12:44:33',NULL,NULL),(497,'00674','S','Est de Valle Verde','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(41418,'46819','S','Poe','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.996887,-85.132630,0,'2013-07-06 12:44:32',NULL,NULL),(12511,'13027','S','Belgium','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(11477,'12019','S','Ballston','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.921720,-73.890600,0,'2013-07-06 12:44:30',NULL,NULL),(25621,'28461','S','Blng Spg Lks','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(23750,'25943','P','Wyco','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.598955,-81.343661,0,'2013-07-06 12:44:31',NULL,NULL),(10690,'11215','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.666364,-73.985457,0,'2013-07-06 12:44:30',NULL,NULL),(2536,'00959','S','Bo Cerro Gordo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(35845,'39815','S','Attapulgus','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.818988,-84.519116,0,'2013-07-06 12:44:32',NULL,NULL),(30739,'33543','S','Wesley Chapel','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.205100,-82.300020,0,'2013-07-06 12:44:32',NULL,NULL),(42973,'48137','S','Gregory','D','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.468420,-84.065880,0,'2013-07-06 12:44:32',NULL,NULL),(32493,'36057','P','Mount Meigs','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.360503,-86.065967,0,'2013-07-06 12:44:32',NULL,NULL),(31038,'33807','P','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.953142,-81.991994,0,'2013-07-06 12:44:32',NULL,NULL),(45978,'52408','P','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.987896,-91.713106,0,'2013-07-06 12:44:32',NULL,NULL),(61588,'72756','S','Little Flock','A','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.322705,-94.027850,0,'2013-07-06 12:44:33',NULL,NULL),(65475,'77640','S','Griffing Park','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(69465,'83654','S','Meadows','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.980560,-116.263800,0,'2013-07-06 12:44:34',NULL,NULL),(70600,'85117','P','Apache Jct','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.421692,-111.548959,0,'2013-07-06 12:44:34',NULL,NULL),(78090,'97478','S','Springfield','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.059336,-122.896044,0,'2013-07-06 12:44:34',NULL,NULL),(6493,'05775','S','West Pawlet','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.360535,-73.225173,0,'2013-07-06 12:44:30',NULL,NULL),(2369,'00949','S','Pradera Norte','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(23118,'24954','S','Minehaha Spgs','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.211660,-80.055660,0,'2013-07-06 12:44:31',NULL,NULL),(78244,'97826','S','Echo','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.739831,-119.191208,0,'2013-07-06 12:44:34',NULL,NULL),(15903,'17012','U','Camp Hill','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.181354,-76.990646,0,'2013-07-06 12:44:31',NULL,NULL),(61536,'72680','S','Alco','A','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842844,-92.354172,0,'2013-07-06 12:44:33',NULL,NULL),(38578,'43791','P','White Cottage','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.876236,-82.103404,0,'2013-07-06 12:44:32',NULL,NULL),(32072,'35283','P','Caller Boxes','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.517488,-86.809476,0,'2013-07-06 12:44:32',NULL,NULL),(56592,'65556','S','Swedeborg','A','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.857338,-92.400215,0,'2013-07-06 12:44:33',NULL,NULL),(64474,'76577','S','Thorndale','D','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(65659,'77979','S','Indianola','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(65788,'78121','S','La Vernia','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.336135,-98.095702,0,'2013-07-06 12:44:34',NULL,NULL),(435,'00662','S','Sect Tocones','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(3565,'01951','S','Newburyport','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.789959,-70.844019,0,'2013-07-06 12:44:30',NULL,NULL),(60812,'72032','S','Brumley','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(20053,'20660','P','Morganza','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.376183,-76.695132,0,'2013-07-06 12:44:31',NULL,NULL),(32177,'35481','S','Stansel','N','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.385953,-88.014060,0,'2013-07-06 12:44:32',NULL,NULL),(6467,'05762','S','Pittsfield','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.759163,-72.855098,0,'2013-07-06 12:44:30',NULL,NULL),(66203,'78548','P','Grulla','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.273939,-98.638445,0,'2013-07-06 12:44:34',NULL,NULL),(76867,'95971','S','Massack','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(63767,'75946','S','Henning','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.799280,-94.485300,0,'2013-07-06 12:44:34',NULL,NULL),(17621,'18046','P','East Texas','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.547616,-75.560939,0,'2013-07-06 12:44:31',NULL,NULL),(22023,'23291','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544706,-77.445183,0,'2013-07-06 12:44:31',NULL,NULL),(53878,'62348','P','Lima','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.166554,-91.406349,0,'2013-07-06 12:44:33',NULL,NULL),(50456,'58027','S','Lucca','N','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.621570,-97.601885,0,'2013-07-06 12:44:33',NULL,NULL),(49974,'57356','S','Lake Andes','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.157659,-98.538151,0,'2013-07-06 12:44:33',NULL,NULL),(27421,'30102','S','Acworth','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.097324,-84.614194,0,'2013-07-06 12:44:31',NULL,NULL),(28213,'31031','S','Gordon','D','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.901291,-83.317179,0,'2013-07-06 12:44:31',NULL,NULL),(79522,'98937','S','Goose Prairie','A','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(80135,'99775','U','Univ Of Ak','N','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.817129,-147.878379,0,'2013-07-06 12:44:34',NULL,NULL),(12263,'12833','S','Greenfield Center','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.141920,-73.855860,0,'2013-07-06 12:44:30',NULL,NULL),(35187,'39283','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.367889,-90.231119,0,'2013-07-06 12:44:32',NULL,NULL),(11421,'11963','S','Sag Harbor','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.972440,-72.324540,0,'2013-07-06 12:44:30',NULL,NULL),(30523,'33406','S','Lake Clarke','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(47346,'54602','P','Lacrosse','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.827618,-91.232393,0,'2013-07-06 12:44:32',NULL,NULL),(52866,'61334','S','Mount Palatine','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.141825,-89.080670,0,'2013-07-06 12:44:33',NULL,NULL),(66415,'78634','S','Hutto','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.553860,-97.547946,0,'2013-07-06 12:44:34',NULL,NULL),(76288,'95430','P','Duncans Mills','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.495218,-123.143138,0,'2013-07-06 12:44:34',NULL,NULL),(77170,'96267','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(21568,'22824','S','Edinburg','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.814496,-78.572016,0,'2013-07-06 12:44:31',NULL,NULL),(3104,'01230','S','Egremont','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(36494,'40813','S','Calvin','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.693772,-83.765321,0,'2013-07-06 12:44:32',NULL,NULL),(16171,'17065','S','Mount Holly Springs','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.117148,-77.192329,0,'2013-07-06 12:44:31',NULL,NULL),(71695,'87521','S','El Valle','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.157505,-105.731083,0,'2013-07-06 12:44:34',NULL,NULL),(75303,'93740','U','Fresno State University','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.823910,-119.758958,0,'2013-07-06 12:44:34',NULL,NULL),(78335,'98003','S','Auburn','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.309940,-122.313900,0,'2013-07-06 12:44:34',NULL,NULL),(71843,'87582','P','Velarde','D','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.146111,-106.005000,0,'2013-07-06 12:44:34',NULL,NULL),(1641,'00771','S','Urb Olivia Pk','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(35192,'39286','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.350653,-90.176499,0,'2013-07-06 12:44:32',NULL,NULL),(29855,'33036','S','Windley Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(48505,'55736','S','Wawina','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(20919,'21737','S','Glenelg','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.259403,-77.002827,0,'2013-07-06 12:44:31',NULL,NULL),(40397,'45671','S','Rarden','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.980022,-83.276192,0,'2013-07-06 12:44:32',NULL,NULL),(57924,'67671','S','Victoria','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.851560,-99.147399,0,'2013-07-06 12:44:33',NULL,NULL),(58947,'69358','S','Morrill','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.962994,-103.926289,0,'2013-07-06 12:44:33',NULL,NULL),(59678,'71065','S','Pleasant Hill','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822235,-93.513309,0,'2013-07-06 12:44:33',NULL,NULL),(63687,'75862','S','Carlisle','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(6107,'05454','S','Georgia','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.686800,-73.015620,0,'2013-07-06 12:44:30',NULL,NULL),(6923,'06155','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757156,-72.743576,0,'2013-07-06 12:44:30',NULL,NULL),(13160,'13607','S','Alexandria','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(75208,'93633','P','Grant Grove','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(66298,'78586','S','La Paloma','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(75233,'93646','S','Squaw Valley','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.625475,-119.320410,0,'2013-07-06 12:44:34',NULL,NULL),(68391,'81151','S','Sanford','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.265658,-105.848320,0,'2013-07-06 12:44:34',NULL,NULL),(65376,'77541','S','Quintana','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(62231,'73945','S','Optima','A','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.827280,-101.182200,0,'2013-07-06 12:44:33',NULL,NULL),(52127,'60430','S','Homewood','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.554935,-87.672332,0,'2013-07-06 12:44:33',NULL,NULL),(49227,'56469','S','Logan','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(24703,'27495','S','Greensboro NDC','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.108616,-79.737907,0,'2013-07-06 12:44:31',NULL,NULL),(11326,'11788','S','Hauppauge','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.816902,-73.210989,0,'2013-07-06 12:44:30',NULL,NULL),(2157,'00925','S','University Station','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(21338,'22412','U','Fredericksburg','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299924,-77.488208,0,'2013-07-06 12:44:31',NULL,NULL),(42922,'48111','S','Sumpter Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.174217,-83.489647,0,'2013-07-06 12:44:32',NULL,NULL),(3313,'01521','S','Halland','N','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.042514,-72.149839,0,'2013-07-06 12:44:30',NULL,NULL),(59022,'70078','P','New Sarpy','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.986850,-90.386567,0,'2013-07-06 12:44:33',NULL,NULL),(55369,'63567','S','Worthington','D','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.424019,-92.765730,0,'2013-07-06 12:44:33',NULL,NULL),(28209,'31027','S','East Dublin','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.548593,-82.870112,0,'2013-07-06 12:44:31',NULL,NULL),(10612,'11042','S','N New Hyde Pk','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757711,-73.697796,0,'2013-07-06 12:44:30',NULL,NULL),(48042,'55310','S','Bird Island','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.764029,-94.896190,0,'2013-07-06 12:44:33',NULL,NULL),(74831,'93237','P','Kaweah','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.471130,-118.920319,0,'2013-07-06 12:44:34',NULL,NULL),(78245,'97827','S','Elgin','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.591741,-117.893621,0,'2013-07-06 12:44:34',NULL,NULL),(57644,'67156','S','Winfield','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.232820,-96.954840,0,'2013-07-06 12:44:33',NULL,NULL),(73869,'91921','P','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.656547,-116.959070,0,'2013-07-06 12:44:34',NULL,NULL),(56536,'65440','S','Boss','D','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.642860,-91.189840,0,'2013-07-06 12:44:33',NULL,NULL),(49891,'57270','S','Veblen','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.864739,-97.284259,0,'2013-07-06 12:44:33',NULL,NULL),(29163,'32348','S','Perry','D','Taylor','12123','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.110251,-83.579791,0,'2013-07-06 12:44:32',NULL,NULL),(17380,'17886','S','New Columbia','A','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.022009,-76.870147,0,'2013-07-06 12:44:31',NULL,NULL),(18646,'19170','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952013,-75.183323,0,'2013-07-06 12:44:31',NULL,NULL),(11760,'12196','S','W Sand Lake','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.627847,-73.632094,0,'2013-07-06 12:44:30',NULL,NULL),(43729,'48929','U','Mi Department of Revenue','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734857,-84.556883,0,'2013-07-06 12:44:32',NULL,NULL),(249,'00637','S','Urb Santa Ana','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(66112,'78414','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.671260,-97.368060,0,'2013-07-06 12:44:34',NULL,NULL),(36783,'41048','S','Francisville','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.073020,-84.713160,0,'2013-07-06 12:44:32',NULL,NULL),(35752,'39735','S','Chester','N','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.336060,-89.186940,0,'2013-07-06 12:44:32',NULL,NULL),(66079,'78389','S','Skidmore','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.254041,-97.650357,0,'2013-07-06 12:44:34',NULL,NULL),(34105,'38177','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.114710,-89.904468,0,'2013-07-06 12:44:32',NULL,NULL),(76624,'95709','S','Camino','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.751360,-120.665040,0,'2013-07-06 12:44:34',NULL,NULL),(70867,'85603','S','Lowell','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(33735,'37822','P','Newport','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.957118,-83.190977,0,'2013-07-06 12:44:32',NULL,NULL),(57556,'67038','S','Dexter','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.181350,-96.714685,0,'2013-07-06 12:44:33',NULL,NULL),(41988,'47421','S','Walnut Heights','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(15428,'16368','U','Warren','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.848758,-79.146681,0,'2013-07-06 12:44:31',NULL,NULL),(52271,'60525','S','La Gran Hghls','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(48090,'55338','S','Green Isle','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.647904,-93.903079,0,'2013-07-06 12:44:33',NULL,NULL),(70664,'85210','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.390402,-111.844450,0,'2013-07-06 12:44:34',NULL,NULL),(75519,'94158','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.768342,-122.394191,0,'2013-07-06 12:44:34',NULL,NULL),(40032,'45249','S','Symmes','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.290580,-84.334690,0,'2013-07-06 12:44:32',NULL,NULL),(76340,'95469','S','Potter Valley','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.346143,-123.112031,0,'2013-07-06 12:44:34',NULL,NULL),(65293,'77488','S','Mackay','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(51688,'59935','S','Troy','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.462428,-115.874402,0,'2013-07-06 12:44:33',NULL,NULL),(6322,'05662','P','Moscow','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.441941,-72.717235,0,'2013-07-06 12:44:30',NULL,NULL),(12968,'13367','S','Dadville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(9758,'10103','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(11335,'11791','S','Oyster Bay Cove','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.813797,-73.502844,0,'2013-07-06 12:44:30',NULL,NULL),(9042,'08880','S','S Bound Brook','A','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.553052,-74.530292,0,'2013-07-06 12:44:30',NULL,NULL),(24137,'26560','S','Baxter','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.537151,-80.145841,0,'2013-07-06 12:44:31',NULL,NULL),(35326,'39428','S','Collins','D','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(16984,'17727','S','Jersey Shore','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.497301,-77.490054,0,'2013-07-06 12:44:31',NULL,NULL),(40268,'45433','S','WP Air Base','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(40923,'46277','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.772026,-86.155024,0,'2013-07-06 12:44:32',NULL,NULL),(8070,'07751','S','Morganville','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.350715,-74.272724,0,'2013-07-06 12:44:30',NULL,NULL),(10673,'11120','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747242,-73.949347,0,'2013-07-06 12:44:30',NULL,NULL),(12617,'13088','S','Liverpool','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(61066,'72124','P','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.811333,-92.234881,0,'2013-07-06 12:44:33',NULL,NULL),(2372,'00949','S','Res Campanilla','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(14843,'15442','S','Grindstone','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.013530,-79.829571,0,'2013-07-06 12:44:31',NULL,NULL),(65185,'77418','S','Raccoon Bend','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(62270,'74013','P','Brkn Arw','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.045952,-95.789603,0,'2013-07-06 12:44:33',NULL,NULL),(68563,'81435','S','Pandora','N','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.979875,-107.941486,0,'2013-07-06 12:44:34',NULL,NULL),(79607,'99107','S','Boyds','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.713044,-118.132398,0,'2013-07-06 12:44:34',NULL,NULL),(71080,'85925','S','Eagar','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.119507,-109.290239,0,'2013-07-06 12:44:34',NULL,NULL),(65589,'77871','S','Normangee','D','Leon','48289','Texas','TX','48','0000','936','Central',-6.0,'Y',31.088820,-96.153300,0,'2013-07-06 12:44:34',NULL,NULL),(12346,'12883','S','Chilson','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.843857,-73.431459,0,'2013-07-06 12:44:30',NULL,NULL),(8546,'08203','S','Brigantine City','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.400502,-74.382819,0,'2013-07-06 12:44:30',NULL,NULL),(19417,'20088','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.965266,-77.055986,0,'2013-07-06 12:44:31',NULL,NULL),(61044,'72118','S','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(49394,'56621','S','Ebro','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(60175,'71409','S','Wilda','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(42029,'47438','S','Gilmour','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(34451,'38654','S','Mineral Wells','A','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.950007,-89.862634,0,'2013-07-06 12:44:32',NULL,NULL),(26213,'28786','S','Hazelwood','A','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.500644,-82.995090,0,'2013-07-06 12:44:31',NULL,NULL),(14441,'15090','S','Wexford','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.616768,-80.064826,0,'2013-07-06 12:44:31',NULL,NULL),(11908,'12407','S','Ashland','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.295009,-74.355618,0,'2013-07-06 12:44:30',NULL,NULL),(23796,'26031','S','Benwood','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.008780,-80.724416,0,'2013-07-06 12:44:31',NULL,NULL),(64532,'76643','S','Hewitt','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.460339,-97.196015,0,'2013-07-06 12:44:34',NULL,NULL),(64718,'76872','S','Rochelle','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.328255,-99.142167,0,'2013-07-06 12:44:34',NULL,NULL),(69649,'84010','S','Bountiful','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.871662,-111.890486,0,'2013-07-06 12:44:34',NULL,NULL),(36116,'40222','S','Grymr-Devndle','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(13008,'13417','S','New York Mills','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.100821,-75.290988,0,'2013-07-06 12:44:30',NULL,NULL),(70713,'85280','P','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.406776,-111.926582,0,'2013-07-06 12:44:34',NULL,NULL),(73612,'91401','S','Sherman Oaks','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.176265,-118.427626,0,'2013-07-06 12:44:34',NULL,NULL),(5521,'04777','S','Herseytown Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.896021,-68.492070,0,'2013-07-06 12:44:30',NULL,NULL),(37173,'41472','S','West Liberty','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(4030,'02571','S','Wareham','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.748569,-70.710818,0,'2013-07-06 12:44:30',NULL,NULL),(60148,'71375','S','Highland','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(17157,'17812','S','Beaver Springs','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.770100,-77.247271,0,'2013-07-06 12:44:31',NULL,NULL),(29871,'33040','S','Raccoon Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(19779,'20425','U','Comm on Civil Rights','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897093,-77.024167,0,'2013-07-06 12:44:31',NULL,NULL),(53918,'62379','S','Warsaw','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.353789,-91.425514,0,'2013-07-06 12:44:33',NULL,NULL),(15460,'16415','S','Fairview','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.040104,-80.238339,0,'2013-07-06 12:44:31',NULL,NULL),(35176,'39272','S','Jackson','A','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.216828,-90.269123,0,'2013-07-06 12:44:32',NULL,NULL),(36396,'40505','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.063208,-84.449524,0,'2013-07-06 12:44:32',NULL,NULL),(37330,'41653','S','Watergap','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(63343,'75604','S','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.522216,-94.799589,0,'2013-07-06 12:44:33',NULL,NULL),(55889,'64428','S','Brlngton Jctn','A','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.436052,-95.019402,0,'2013-07-06 12:44:33',NULL,NULL),(7139,'06405','S','Branford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.278295,-72.796351,0,'2013-07-06 12:44:30',NULL,NULL),(66145,'78472','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693700,-97.398467,0,'2013-07-06 12:44:34',NULL,NULL),(55819,'64150','S','Kansas City','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.170613,-94.628810,0,'2013-07-06 12:44:33',NULL,NULL),(54302,'62707','S','Devereux Heights','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(12084,'12561','S','New Paltz','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.740002,-74.095014,0,'2013-07-06 12:44:30',NULL,NULL),(51856,'60073','S','Round Lk Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(55854,'64170','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.951885,-94.546834,0,'2013-07-06 12:44:33',NULL,NULL),(42234,'47567','S','Little','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(46424,'53188','S','Waukesha','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.016203,-88.267858,0,'2013-07-06 12:44:32',NULL,NULL),(46451,'53211','S','Glendale','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.082534,-87.884406,0,'2013-07-06 12:44:32',NULL,NULL),(17989,'18623','S','Laceyville','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.672186,-76.135681,0,'2013-07-06 12:44:31',NULL,NULL),(13919,'14413','P','Alton','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.208705,-76.983214,0,'2013-07-06 12:44:31',NULL,NULL),(59886,'71270','S','Kellys','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(25203,'28078','S','Huntersville','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.414040,-80.852580,0,'2013-07-06 12:44:31',NULL,NULL),(28198,'31021','S','Dublin','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.542986,-82.909684,0,'2013-07-06 12:44:31',NULL,NULL),(38214,'43217','S','Rickenbacker Air Force Base','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.825664,-82.947527,0,'2013-07-06 12:44:32',NULL,NULL),(73811,'91759','P','Mt Baldy','D','San Bernardino','06071','California','CA','06','4480','909','Pacific',-8.0,'Y',34.255822,-117.635688,0,'2013-07-06 12:44:34',NULL,NULL),(65568,'77850','P','Concord','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.257320,-96.117089,0,'2013-07-06 12:44:34',NULL,NULL),(10648,'11102','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770391,-73.923967,0,'2013-07-06 12:44:30',NULL,NULL),(78343,'98005','S','Bellevue','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.615593,-122.169920,0,'2013-07-06 12:44:34',NULL,NULL),(75516,'94147','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.800828,-122.434822,0,'2013-07-06 12:44:34',NULL,NULL),(74102,'92210','S','Palm Desert','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.715709,-116.334198,0,'2013-07-06 12:44:34',NULL,NULL),(51259,'59084','S','Winnett','A','Petroleum','30069','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.039156,-108.610344,0,'2013-07-06 12:44:33',NULL,NULL),(55326,'63546','S','Greentop','D','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.344581,-92.537453,0,'2013-07-06 12:44:33',NULL,NULL),(56690,'65652','S','Fordland','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.116309,-93.062582,0,'2013-07-06 12:44:33',NULL,NULL),(26208,'28781','S','Topton','D','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.256543,-83.696128,0,'2013-07-06 12:44:31',NULL,NULL),(13222,'13634','S','Pillar Point','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(7143,'06410','S','Cheshire','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.504235,-72.906403,0,'2013-07-06 12:44:30',NULL,NULL),(63415,'75656','S','Hughes Spgs','A','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.941001,-94.707975,0,'2013-07-06 12:44:33',NULL,NULL),(26335,'29058','S','Heath Springs','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.544700,-80.751780,0,'2013-07-06 12:44:31',NULL,NULL),(37187,'41512','S','Ashcamp','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.256847,-82.473464,0,'2013-07-06 12:44:32',NULL,NULL),(76990,'96070','P','Lakehead','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.812222,-122.323056,0,'2013-07-06 12:44:34',NULL,NULL),(7396,'06791','S','Harwinton','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753700,-73.061520,0,'2013-07-06 12:44:30',NULL,NULL),(71726,'87532','S','La Puebla','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(75264,'93670','P','Yettem','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.484454,-119.224712,0,'2013-07-06 12:44:34',NULL,NULL),(77069,'96124','S','Calpine','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.653100,-120.514620,0,'2013-07-06 12:44:34',NULL,NULL),(42952,'48126','S','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.335197,-83.193476,0,'2013-07-06 12:44:32',NULL,NULL),(8794,'08562','S','North Hanover','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.063017,-74.606180,0,'2013-07-06 12:44:30',NULL,NULL),(52945,'61411','S','Adair','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.294685,-90.423851,0,'2013-07-06 12:44:33',NULL,NULL),(16543,'17303','P','Arendtsville','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.921479,-77.297065,0,'2013-07-06 12:44:31',NULL,NULL),(38235,'43234','P','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.102980,-83.055995,0,'2013-07-06 12:44:32',NULL,NULL),(17018,'17742','S','Lairdsville','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.233339,-76.588125,0,'2013-07-06 12:44:31',NULL,NULL),(30364,'33314','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.070011,-80.219723,0,'2013-07-06 12:44:32',NULL,NULL),(75001,'93453','S','Santa Margar','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.365892,-120.392105,0,'2013-07-06 12:44:34',NULL,NULL),(75044,'93516','S','Boron','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.008562,-117.655982,0,'2013-07-06 12:44:34',NULL,NULL),(79786,'99347','S','Pomeroy','D','Garfield','53023','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.473394,-117.600009,0,'2013-07-06 12:44:34',NULL,NULL),(8733,'08514','S','Creamridge','N','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.164531,-74.453412,0,'2013-07-06 12:44:30',NULL,NULL),(7534,'07006','S','W Caldwell','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.855020,-74.277840,0,'2013-07-06 12:44:30',NULL,NULL),(35533,'39558','P','Clermont Harbor','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.241870,-89.434728,0,'2013-07-06 12:44:32',NULL,NULL),(12887,'13329','S','Oppenheim','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.103700,-74.740980,0,'2013-07-06 12:44:30',NULL,NULL),(66644,'78838','S','Concan','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.505014,-99.683308,0,'2013-07-06 12:44:34',NULL,NULL),(19963,'20588','U','Columbia','A','Howard','24027','Maryland','MD','24','8840','202','Eastern',-5.0,'Y',38.916044,-77.056499,0,'2013-07-06 12:44:31',NULL,NULL),(24423,'27155','U','Veterans Affairs','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.105135,-80.201896,0,'2013-07-06 12:44:31',NULL,NULL),(33538,'37387','S','Tracy City','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.277419,-85.733605,0,'2013-07-06 12:44:32',NULL,NULL),(74849,'93246','U','Naval Air Station Lemoore','N','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.290241,-119.847834,0,'2013-07-06 12:44:34',NULL,NULL),(1922,'00795','S','Qtas De Altamira','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(77366,'96744','S','Kaneohe','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.417372,-157.811961,0,'2013-07-06 12:44:34',NULL,NULL),(43243,'48317','S','Shelby Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.647050,-83.049668,0,'2013-07-06 12:44:32',NULL,NULL),(60700,'71941','S','Saginaw','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.199333,-92.931422,0,'2013-07-06 12:44:33',NULL,NULL),(35654,'39647','S','Mc Call Creek','D','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.510920,-90.772920,0,'2013-07-06 12:44:32',NULL,NULL),(66270,'78578','S','Laguna Vista','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(24391,'27103','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.069214,-80.316170,0,'2013-07-06 12:44:31',NULL,NULL),(2989,'01062','S','North Hampton','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.331578,-72.692571,0,'2013-07-06 12:44:30',NULL,NULL),(30189,'33178','S','Medley','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.856770,-80.415990,0,'2013-07-06 12:44:32',NULL,NULL),(44979,'50423','S','Stilson','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.095207,-93.799817,0,'2013-07-06 12:44:32',NULL,NULL),(3212,'01364','S','Eagleville','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(51990,'60156','S','Lk In The Hls','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.180245,-88.331470,0,'2013-07-06 12:44:33',NULL,NULL),(49742,'57055','S','Crooks','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.669327,-96.702890,0,'2013-07-06 12:44:33',NULL,NULL),(15357,'16248','S','Huey','A','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.041825,-79.501697,0,'2013-07-06 12:44:31',NULL,NULL),(42013,'47432','S','Hillham','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.545144,-86.619616,0,'2013-07-06 12:44:32',NULL,NULL),(29028,'32228','P','Mayport Navy','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(72099,'88220','S','Carlsbad','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.397966,-104.241065,0,'2013-07-06 12:44:34',NULL,NULL),(59895,'71273','P','Ruston','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.558247,-92.590363,0,'2013-07-06 12:44:33',NULL,NULL),(49171,'56399','U','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.549763,-94.227348,0,'2013-07-06 12:44:33',NULL,NULL),(43983,'49331','S','Lowell','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.948478,-85.359091,0,'2013-07-06 12:44:32',NULL,NULL),(39581,'44857','S','Hartland','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.238868,-82.602595,0,'2013-07-06 12:44:32',NULL,NULL),(58386,'68601','S','Columbus','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.449200,-97.371960,0,'2013-07-06 12:44:33',NULL,NULL),(31586,'34655','S','New Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210274,-82.682809,0,'2013-07-06 12:44:32',NULL,NULL),(46189,'52745','S','Dixon','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.770278,-90.826111,0,'2013-07-06 12:44:32',NULL,NULL),(50449,'58017','S','Brampton','A','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.100640,-97.809420,0,'2013-07-06 12:44:33',NULL,NULL),(58896,'69171','S','Willow Island','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.852075,-100.026775,0,'2013-07-06 12:44:33',NULL,NULL),(60220,'71425','S','Enterprise','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.891021,-91.881818,0,'2013-07-06 12:44:33',NULL,NULL),(60421,'71640','S','Readland','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(74581,'92692','S','San Juan Capo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.614433,-117.643273,0,'2013-07-06 12:44:34',NULL,NULL),(80169,'99826','P','Gustavus','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.824371,-136.971035,0,'2013-07-06 12:44:34',NULL,NULL),(63537,'75760','S','Cushing','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.765157,-94.857374,0,'2013-07-06 12:44:33',NULL,NULL),(44743,'50164','S','Glendon','N','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.558007,-94.416659,0,'2013-07-06 12:44:32',NULL,NULL),(53664,'62208','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.599660,-90.009909,0,'2013-07-06 12:44:33',NULL,NULL),(45345,'50947','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582042,-93.629331,0,'2013-07-06 12:44:32',NULL,NULL),(72990,'90056','S','Windsor Hills','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.984248,-118.364182,0,'2013-07-06 12:44:34',NULL,NULL),(60970,'72104','S','Rolla','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(46087,'52595','P','University Pk','A','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.285630,-92.620526,0,'2013-07-06 12:44:32',NULL,NULL),(1059,'00725','S','Caguas','D','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(19684,'20372','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900744,-77.050160,0,'2013-07-06 12:44:31',NULL,NULL),(7134,'06390','P','Fishers Island','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.250000,-72.020000,0,'2013-07-06 12:44:30',NULL,NULL),(16516,'17267','S','Stoneybreak','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.776683,-78.204091,0,'2013-07-06 12:44:31',NULL,NULL),(28590,'31637','S','Lenox','D','Cook','13075','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.268413,-83.464912,0,'2013-07-06 12:44:32',NULL,NULL),(46169,'52732','S','Clinton','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.849037,-90.208697,0,'2013-07-06 12:44:32',NULL,NULL),(1272,'00730','S','Bo Tamarindo','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(13314,'13675','S','Plessis','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.277977,-75.850834,0,'2013-07-06 12:44:30',NULL,NULL),(41285,'46761','S','Lagrange','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(3488,'01840','S','Lawrence','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.710311,-71.164020,0,'2013-07-06 12:44:30',NULL,NULL),(44491,'49915','P','Caspian','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.066795,-88.627714,0,'2013-07-06 12:44:32',NULL,NULL),(50785,'58433','S','Merricourt','A','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.321320,-98.721720,0,'2013-07-06 12:44:33',NULL,NULL),(56973,'66201','P','Mission','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.969026,-94.676138,0,'2013-07-06 12:44:33',NULL,NULL),(73051,'90088','U','Wells Fargo','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.055128,-118.261962,0,'2013-07-06 12:44:34',NULL,NULL),(39823,'45150','S','Day Heights','A','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.178746,-84.246032,0,'2013-07-06 12:44:32',NULL,NULL),(52253,'60519','P','Eola','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.774530,-88.242378,0,'2013-07-06 12:44:33',NULL,NULL),(49731,'57048','S','Ramsey','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.700076,-97.186816,0,'2013-07-06 12:44:33',NULL,NULL),(49280,'56514','S','Downer','A','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.670040,-96.391560,0,'2013-07-06 12:44:33',NULL,NULL),(29626,'32878','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.526291,-81.170878,0,'2013-07-06 12:44:32',NULL,NULL),(71005,'85719','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.241787,-110.946837,0,'2013-07-06 12:44:34',NULL,NULL),(72389,'89040','S','Overton','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.542460,-114.453410,0,'2013-07-06 12:44:34',NULL,NULL),(64548,'76652','S','Eulogy','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.121465,-97.581963,0,'2013-07-06 12:44:34',NULL,NULL),(27574,'30270','U','Peachtree City','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396971,-84.592052,0,'2013-07-06 12:44:31',NULL,NULL),(12057,'12533','S','Hopewell Jct','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.573590,-73.796075,0,'2013-07-06 12:44:30',NULL,NULL),(23547,'25624','P','Henlawson','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.846452,-81.992864,0,'2013-07-06 12:44:31',NULL,NULL),(26402,'29111','S','Oak Dale','N','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.780339,-80.018183,0,'2013-07-06 12:44:31',NULL,NULL),(36166,'40242','S','Old Brownsboro Place','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(21507,'22712','S','Morrisville','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.574480,-77.800680,0,'2013-07-06 12:44:31',NULL,NULL),(6317,'05661','S','Morristown','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(24608,'27330','S','Shallowell','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(44680,'50123','S','Le Roy','N','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.846920,-93.503520,0,'2013-07-06 12:44:32',NULL,NULL),(64216,'76266','S','Sanger','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.359586,-97.179563,0,'2013-07-06 12:44:34',NULL,NULL),(65995,'78340','S','Bayside','D','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.099979,-97.203803,0,'2013-07-06 12:44:34',NULL,NULL),(68269,'81073','S','Edler','N','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.397087,-102.621835,0,'2013-07-06 12:44:34',NULL,NULL),(69896,'84105','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.734214,-111.856179,0,'2013-07-06 12:44:34',NULL,NULL),(75738,'94602','S','Piedmont','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.802583,-122.208576,0,'2013-07-06 12:44:34',NULL,NULL),(5617,'04938','S','Farmington','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.670853,-70.146599,0,'2013-07-06 12:44:30',NULL,NULL),(51376,'59405','S','Great Falls','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.473605,-111.259493,0,'2013-07-06 12:44:33',NULL,NULL),(51138,'58831','S','Alexander','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.855481,-103.642519,0,'2013-07-06 12:44:33',NULL,NULL),(50424,'57788','S','Vale','D','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.629977,-103.368084,0,'2013-07-06 12:44:33',NULL,NULL),(34967,'39078','S','Georgetown','D','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.838165,-90.219233,0,'2013-07-06 12:44:32',NULL,NULL),(33959,'38105','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.150666,-90.031667,0,'2013-07-06 12:44:32',NULL,NULL),(58754,'68958','S','Loomis','D','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.475637,-99.508161,0,'2013-07-06 12:44:33',NULL,NULL),(76447,'95606','S','Brooks','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.737977,-122.148254,0,'2013-07-06 12:44:34',NULL,NULL),(72545,'89191','P','Indian Springs Air Force Aux','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.244017,-115.040965,0,'2013-07-06 12:44:34',NULL,NULL),(50999,'58654','S','Sentinel Butte','D','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.801990,-103.732852,0,'2013-07-06 12:44:33',NULL,NULL),(57678,'67221','S','Wichita','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.632480,-97.250340,0,'2013-07-06 12:44:33',NULL,NULL),(44917,'50331','U','Wells Fargo Mortgage','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587161,-93.634602,0,'2013-07-06 12:44:32',NULL,NULL),(287,'00646','S','Paseo Las Palmas','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(10507,'10970','S','Mount Ivy','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.184834,-74.046948,0,'2013-07-06 12:44:30',NULL,NULL),(35417,'39466','S','Richardson','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(4507,'03291','S','West Nottingham','D','Rockingham','33015','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.173142,-71.136707,0,'2013-07-06 12:44:30',NULL,NULL),(26220,'28791','S','Hendersonvlle','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.350441,-82.494453,0,'2013-07-06 12:44:31',NULL,NULL),(24002,'26347','S','Flemington','D','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.269476,-80.125327,0,'2013-07-06 12:44:31',NULL,NULL),(9268,'09609','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(46903,'54127','S','Green Valley','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.795152,-88.270695,0,'2013-07-06 12:44:32',NULL,NULL),(61812,'73104','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.474590,-97.505034,0,'2013-07-06 12:44:33',NULL,NULL),(64122,'76185','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861974,-97.216601,0,'2013-07-06 12:44:34',NULL,NULL),(73166,'90303','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.934314,-118.325571,0,'2013-07-06 12:44:34',NULL,NULL),(79240,'98555','S','Lilliwaup','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.551115,-123.186108,0,'2013-07-06 12:44:34',NULL,NULL),(44179,'49560','U','Christian Reformed Church','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.876705,-85.627473,0,'2013-07-06 12:44:32',NULL,NULL),(63353,'75631','S','Fair Play','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.252312,-94.452675,0,'2013-07-06 12:44:33',NULL,NULL),(62740,'74832','S','Carney','D','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.806618,-97.018059,0,'2013-07-06 12:44:33',NULL,NULL),(17820,'18411','S','Scott Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(56895,'66043','S','Lansing','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.253586,-94.901087,0,'2013-07-06 12:44:33',NULL,NULL),(56572,'65484','S','Huggins','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.271540,-92.151285,0,'2013-07-06 12:44:33',NULL,NULL),(53898,'62361','S','Pearl','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.428363,-90.649756,0,'2013-07-06 12:44:33',NULL,NULL),(15040,'15698','S','Yukon','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.213260,-79.684888,0,'2013-07-06 12:44:31',NULL,NULL),(67344,'80107','S','Elizabeth','D','Elbert','08039','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.384034,-104.593094,0,'2013-07-06 12:44:34',NULL,NULL),(78537,'98134','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.578213,-122.333073,0,'2013-07-06 12:44:34',NULL,NULL),(65006,'77301','S','Camp Strake','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.311394,-95.433846,0,'2013-07-06 12:44:34',NULL,NULL),(77215,'96384','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(31232,'33971','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.597681,-81.699773,0,'2013-07-06 12:44:32',NULL,NULL),(31025,'33786','S','Belleair Beach','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(23611,'25707','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.395939,-82.448947,0,'2013-07-06 12:44:31',NULL,NULL),(10489,'10959','P','New Milford','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.234545,-74.413065,0,'2013-07-06 12:44:30',NULL,NULL),(2377,'00949','S','Urb Camino del Mar','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(48463,'55717','S','Canyon','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.079441,-92.470331,0,'2013-07-06 12:44:33',NULL,NULL),(54998,'63130','S','U City','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.664368,-90.323797,0,'2013-07-06 12:44:33',NULL,NULL),(57270,'66547','S','Louisvl','N','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.211156,-96.316796,0,'2013-07-06 12:44:33',NULL,NULL),(57904,'67649','S','Luray','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.049864,-98.649181,0,'2013-07-06 12:44:33',NULL,NULL),(69437,'83641','S','Wilson','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.380775,-116.549761,0,'2013-07-06 12:44:34',NULL,NULL),(71658,'87501','S','San Ildefonso Pueblo','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(75134,'93555','S','Ridgecrest','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.622118,-117.690678,0,'2013-07-06 12:44:34',NULL,NULL),(2173,'00926','S','Colinas de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(30540,'33409','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.708576,-80.096654,0,'2013-07-06 12:44:32',NULL,NULL),(61365,'72513','S','Ash Flat','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.222517,-91.611780,0,'2013-07-06 12:44:33',NULL,NULL),(54327,'62756','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797359,-89.654776,0,'2013-07-06 12:44:33',NULL,NULL),(14859,'15458','S','Lamberton','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.886898,-79.858211,0,'2013-07-06 12:44:31',NULL,NULL),(41144,'46699','U','So Bend','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.671706,-86.252194,0,'2013-07-06 12:44:32',NULL,NULL),(65834,'78154','S','Live Oak','N','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.587509,-98.288298,0,'2013-07-06 12:44:34',NULL,NULL),(39861,'45176','S','New Harmony','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.072060,-84.043331,0,'2013-07-06 12:44:32',NULL,NULL),(29177,'32359','S','Steinhatchee','D','Taylor','12123','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.676861,-83.378046,0,'2013-07-06 12:44:32',NULL,NULL),(14753,'15323','S','Claysville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.134267,-80.390629,0,'2013-07-06 12:44:31',NULL,NULL),(40555,'45856','S','Leipsic','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.097024,-83.996732,0,'2013-07-06 12:44:32',NULL,NULL),(33306,'37132','U','Middle Tenn State Univ','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.850303,-86.361672,0,'2013-07-06 12:44:32',NULL,NULL),(27276,'29944','S','Varnville','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.857618,-81.077280,0,'2013-07-06 12:44:31',NULL,NULL),(48625,'55802','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.767393,-92.115470,0,'2013-07-06 12:44:33',NULL,NULL),(65669,'77983','S','Seadrift','D','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.401205,-96.657487,0,'2013-07-06 12:44:34',NULL,NULL),(27234,'29920','S','St Helena Is','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(68119,'80950','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837558,-104.795156,0,'2013-07-06 12:44:34',NULL,NULL),(60636,'71901','S','Piney','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(1879,'00791','S','Urb Palmas Plantation','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(21685,'22963','S','Bybee','A','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(1916,'00795','S','Jard de Santo Domingo','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(33580,'37501','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.068065,-89.957585,0,'2013-07-06 12:44:32',NULL,NULL),(6310,'05660','S','North Fayston','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.252162,-72.748572,0,'2013-07-06 12:44:30',NULL,NULL),(17790,'18354','S','Sciota','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.919277,-75.284452,0,'2013-07-06 12:44:31',NULL,NULL),(25779,'28602','S','Mt View','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.661600,-81.370320,0,'2013-07-06 12:44:31',NULL,NULL),(11191,'11735','S','South Farmingdale','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.725297,-73.444737,0,'2013-07-06 12:44:30',NULL,NULL),(6097,'05451','P','Essex Center','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.507500,-73.069481,0,'2013-07-06 12:44:30',NULL,NULL),(50162,'57552','S','Capa','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(55072,'63177','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.629158,-90.217012,0,'2013-07-06 12:44:33',NULL,NULL),(61026,'72117','S','Galloway','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(65242,'77456','P','Markham','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.964731,-96.090617,0,'2013-07-06 12:44:34',NULL,NULL),(70883,'85613','S','Fort Huachuca','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.551784,-110.347231,0,'2013-07-06 12:44:34',NULL,NULL),(31650,'34740','P','Killarney','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.545029,-81.648835,0,'2013-07-06 12:44:32',NULL,NULL),(44891,'50319','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.589947,-93.598609,0,'2013-07-06 12:44:32',NULL,NULL),(68164,'81006','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.244574,-104.524364,0,'2013-07-06 12:44:34',NULL,NULL),(79814,'99505','S','Anch','N','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.255993,-149.689138,0,'2013-07-06 12:44:34',NULL,NULL),(76457,'95613','P','Coloma','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.827378,-120.881447,0,'2013-07-06 12:44:34',NULL,NULL),(37767,'42343','S','Fordsville','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.628160,-86.708700,0,'2013-07-06 12:44:32',NULL,NULL),(3761,'02185','P','Braintree','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.201183,-71.005109,0,'2013-07-06 12:44:30',NULL,NULL),(10616,'11050','S','Harbor Acres','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(17044,'17750','P','Mackeyville','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.055114,-77.446721,0,'2013-07-06 12:44:31',NULL,NULL),(13905,'14301','S','N Falls','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.093678,-79.041792,0,'2013-07-06 12:44:31',NULL,NULL),(53299,'61734','S','Boynton','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.372475,-89.541913,0,'2013-07-06 12:44:33',NULL,NULL),(53852,'62324','S','Kellerville','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.030973,-90.957190,0,'2013-07-06 12:44:33',NULL,NULL),(55313,'63538','S','Elmer','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.931558,-92.652345,0,'2013-07-06 12:44:33',NULL,NULL),(70398,'84713','S','Beaver','D','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.298252,-112.716345,0,'2013-07-06 12:44:34',NULL,NULL),(73490,'91325','S','Sherwood Frst','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.239807,-118.516396,0,'2013-07-06 12:44:34',NULL,NULL),(44527,'49958','S','Pelkie','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.729644,-88.643973,0,'2013-07-06 12:44:32',NULL,NULL),(27026,'29649','S','Greenwood','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.219994,-82.160345,0,'2013-07-06 12:44:31',NULL,NULL),(74092,'92197','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.831074,-117.199135,0,'2013-07-06 12:44:34',NULL,NULL),(5439,'04685','S','Swans Island','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.145000,-68.452222,0,'2013-07-06 12:44:30',NULL,NULL),(3619,'02059','P','North Marshfield','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.142821,-70.772118,0,'2013-07-06 12:44:30',NULL,NULL),(7714,'07192','U','Wachovia Bank','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.730050,-74.176568,0,'2013-07-06 12:44:30',NULL,NULL),(19514,'20176','S','Leesburg','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.201977,-77.535473,0,'2013-07-06 12:44:31',NULL,NULL),(33758,'37854','S','Rockwood','D','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.862451,-84.679796,0,'2013-07-06 12:44:32',NULL,NULL),(58023,'67952','S','Moscow','D','Stevens','20189','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.312499,-101.293672,0,'2013-07-06 12:44:33',NULL,NULL),(29901,'33050','S','Marathon','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(54019,'62454','S','Eaton','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(55425,'63660','S','Springtown','N','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.916100,-90.710280,0,'2013-07-06 12:44:33',NULL,NULL),(37328,'41653','S','Prestonsburg','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(12814,'13302','S','Altmar','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(30082,'33156','S','Gables by the Sea','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(27079,'29702','S','Kings Creek','A','Cherokee','45021','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.115670,-81.513969,0,'2013-07-06 12:44:31',NULL,NULL),(27962,'30553','S','Lavonia','D','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.436422,-83.105732,0,'2013-07-06 12:44:31',NULL,NULL),(48209,'55408','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.946848,-93.290970,0,'2013-07-06 12:44:33',NULL,NULL),(52400,'60636','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.774317,-87.670123,0,'2013-07-06 12:44:33',NULL,NULL),(58607,'68853','S','Webster','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.279151,-98.969658,0,'2013-07-06 12:44:33',NULL,NULL),(69530,'83731','U','Dept of Transportation','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.746358,-116.203781,0,'2013-07-06 12:44:34',NULL,NULL),(9708,'10060','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748746,-73.997962,0,'2013-07-06 12:44:30',NULL,NULL),(50624,'58269','S','Osnabrock','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.631626,-98.250432,0,'2013-07-06 12:44:33',NULL,NULL),(50594,'58240','S','Hatton','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.639762,-97.456978,0,'2013-07-06 12:44:33',NULL,NULL),(25008,'27875','S','Scranton','D','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.581105,-76.448894,0,'2013-07-06 12:44:31',NULL,NULL),(76306,'95445','S','Anchor Bay','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.805573,-123.562187,0,'2013-07-06 12:44:34',NULL,NULL),(62433,'74157','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.077399,-96.054854,0,'2013-07-06 12:44:33',NULL,NULL),(73053,'90089','U','University of Southern Ca','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.017658,-118.284157,0,'2013-07-06 12:44:34',NULL,NULL),(69724,'84039','S','Lapoint','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.384027,-109.797883,0,'2013-07-06 12:44:34',NULL,NULL),(60280,'71449','S','Pendleton','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(53483,'61951','S','Allenville','A','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.597396,-88.609239,0,'2013-07-06 12:44:33',NULL,NULL),(48947,'56169','S','Russell','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.322829,-95.950801,0,'2013-07-06 12:44:33',NULL,NULL),(59971,'71322','S','Bunkie','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.943380,-92.185260,0,'2013-07-06 12:44:33',NULL,NULL),(25558,'28411','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.227651,-77.945987,0,'2013-07-06 12:44:31',NULL,NULL),(57459,'66855','S','Lamont','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.116882,-96.022522,0,'2013-07-06 12:44:33',NULL,NULL),(56039,'64701','S','Harrisonville','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.629786,-94.326071,0,'2013-07-06 12:44:33',NULL,NULL),(38494,'43681','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.642211,-83.542156,0,'2013-07-06 12:44:32',NULL,NULL),(43926,'49270','S','Petersburg','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.872970,-83.680358,0,'2013-07-06 12:44:32',NULL,NULL),(2310,'00927','S','Villa Los Olmos','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(44027,'49413','U','Fremont','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.462833,-85.952274,0,'2013-07-06 12:44:32',NULL,NULL),(7666,'07090','S','Westfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.646334,-74.345624,0,'2013-07-06 12:44:30',NULL,NULL),(37003,'41222','S','Denver','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.795350,-82.819772,0,'2013-07-06 12:44:32',NULL,NULL),(27792,'30384','U','Bank America','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.897456,-84.451548,0,'2013-07-06 12:44:31',NULL,NULL),(36727,'41031','S','Leesburg','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(76304,'95443','S','Glenhaven','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.031330,-122.740821,0,'2013-07-06 12:44:34',NULL,NULL),(71260,'86411','P','Hackberry','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.369406,-113.727182,0,'2013-07-06 12:44:34',NULL,NULL),(59825,'71235','S','Dubach','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.712180,-92.656020,0,'2013-07-06 12:44:33',NULL,NULL),(56803,'65768','S','Vanzant','D','Douglas','29067','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.968695,-92.197398,0,'2013-07-06 12:44:33',NULL,NULL),(55257,'63456','S','Indian Creek','N','Monroe','29137','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.653180,-91.730329,0,'2013-07-06 12:44:33',NULL,NULL),(54489,'62863','S','Odgen','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(52317,'60554','S','Sugar Grove','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.771338,-88.459795,0,'2013-07-06 12:44:33',NULL,NULL),(50791,'58441','S','Fullerton','D','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.195764,-98.379125,0,'2013-07-06 12:44:33',NULL,NULL),(48853,'56071','S','New Prague','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.562435,-93.565297,0,'2013-07-06 12:44:33',NULL,NULL),(22699,'24328','S','Fancy Gap','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.661564,-80.692260,0,'2013-07-06 12:44:31',NULL,NULL),(30893,'33703','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.819613,-82.622849,0,'2013-07-06 12:44:32',NULL,NULL),(33073,'36769','S','Sunny South','N','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.949033,-87.557784,0,'2013-07-06 12:44:32',NULL,NULL),(35263,'39358','S','Electric Mills','N','Kemper','28069','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.840314,-88.517252,0,'2013-07-06 12:44:32',NULL,NULL),(38083,'43072','S','St Paris','N','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.125518,-83.957665,0,'2013-07-06 12:44:32',NULL,NULL),(40952,'46304','S','Porter','A','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.617037,-87.028793,0,'2013-07-06 12:44:32',NULL,NULL),(20861,'21662','S','Royal Oak','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.712959,-76.197379,0,'2013-07-06 12:44:31',NULL,NULL),(3776,'02191','S','Weymouth','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.241032,-70.943260,0,'2013-07-06 12:44:30',NULL,NULL),(44026,'49412','S','Fremont','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.466550,-85.948006,0,'2013-07-06 12:44:32',NULL,NULL),(44941,'50364','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.596699,-93.764908,0,'2013-07-06 12:44:32',NULL,NULL),(29161,'32346','S','Panacea','D','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023822,-84.391553,0,'2013-07-06 12:44:32',NULL,NULL),(46721,'53810','S','Glen Haven','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.821307,-90.991171,0,'2013-07-06 12:44:32',NULL,NULL),(40913,'46262','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.893169,-86.181003,0,'2013-07-06 12:44:32',NULL,NULL),(64571,'76661','S','Rocky Hill','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.310786,-96.891028,0,'2013-07-06 12:44:34',NULL,NULL),(42879,'48090','P','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.455368,-82.885257,0,'2013-07-06 12:44:32',NULL,NULL),(3304,'01516','S','East Douglas','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.057720,-71.755020,0,'2013-07-06 12:44:30',NULL,NULL),(12557,'13051','P','Delphi Falls','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.878158,-75.912999,0,'2013-07-06 12:44:30',NULL,NULL),(25248,'28109','P','Misenheimer','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.483541,-80.322701,0,'2013-07-06 12:44:31',NULL,NULL),(70128,'84201','U','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.244252,-112.000722,0,'2013-07-06 12:44:34',NULL,NULL),(20002,'20608','S','Eagle Harbor','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.582892,-76.715193,0,'2013-07-06 12:44:31',NULL,NULL),(74679,'92870','S','Placentia','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.874415,-117.854269,0,'2013-07-06 12:44:34',NULL,NULL),(50075,'57451','S','Ipswich','D','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.448625,-99.029411,0,'2013-07-06 12:44:33',NULL,NULL),(48745,'55971','S','Hart','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(28233,'31044','S','Jeffersonvlle','A','Twiggs','13289','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.682004,-83.331608,0,'2013-07-06 12:44:31',NULL,NULL),(30822,'33620','U','Univ Of S FL','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060736,-82.410807,0,'2013-07-06 12:44:32',NULL,NULL),(24294,'27010','P','Bethania','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.165806,-80.369502,0,'2013-07-06 12:44:31',NULL,NULL),(34018,'38127','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.240147,-90.020802,0,'2013-07-06 12:44:32',NULL,NULL),(37474,'42001','S','Hendron','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(47662,'54937','S','N Fond du Lac','A','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.808088,-88.480729,0,'2013-07-06 12:44:33',NULL,NULL),(74199,'92284','S','Yucca Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.177234,-116.431890,0,'2013-07-06 12:44:34',NULL,NULL),(79318,'98601','S','Chelatchie','N','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.863781,-122.506327,0,'2013-07-06 12:44:34',NULL,NULL),(18943,'19508','S','Birdsboro','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(75953,'95043','S','Panoche','N','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.548040,-121.016280,0,'2013-07-06 12:44:34',NULL,NULL),(74867,'93261','P','Richgrove','D','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.798221,-119.108668,0,'2013-07-06 12:44:34',NULL,NULL),(67026,'79536','S','Noodle','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.449860,-99.988740,0,'2013-07-06 12:44:34',NULL,NULL),(56402,'65246','S','Dalton','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.390580,-92.993274,0,'2013-07-06 12:44:33',NULL,NULL),(10361,'10579','S','Putnam Valley','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.390553,-73.846426,0,'2013-07-06 12:44:30',NULL,NULL),(38375,'43468','P','Williston','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.603678,-83.331413,0,'2013-07-06 12:44:32',NULL,NULL),(36368,'40448','P','Mc Kinney','D','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.454010,-84.760289,0,'2013-07-06 12:44:32',NULL,NULL),(18047,'18690','U','Dallas','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.335765,-75.970464,0,'2013-07-06 12:44:31',NULL,NULL),(45005,'50449','S','Klemme','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.045820,-93.475891,0,'2013-07-06 12:44:32',NULL,NULL),(9349,'09804','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(16114,'17055','S','Mount Allen','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(67665,'80487','S','Steamboat Spr','A','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.488148,-106.868862,0,'2013-07-06 12:44:34',NULL,NULL),(72088,'88201','S','Elkins','N','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.393099,-104.522917,0,'2013-07-06 12:44:34',NULL,NULL),(51745,'60017','P','Des Plaines','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.024452,-87.902856,0,'2013-07-06 12:44:33',NULL,NULL),(38014,'43006','S','Brinkhaven','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.471026,-82.188196,0,'2013-07-06 12:44:32',NULL,NULL),(35935,'40049','P','Nerinx','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.661331,-85.397992,0,'2013-07-06 12:44:32',NULL,NULL),(15509,'16511','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.157917,-80.011344,0,'2013-07-06 12:44:31',NULL,NULL),(10508,'10970','S','Pomona','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.184834,-74.046948,0,'2013-07-06 12:44:30',NULL,NULL),(10699,'11224','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.577387,-73.994493,0,'2013-07-06 12:44:30',NULL,NULL),(12688,'13135','S','Phoenix','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.261500,-76.325220,0,'2013-07-06 12:44:30',NULL,NULL),(12965,'13365','S','Little Falls','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.086420,-74.904000,0,'2013-07-06 12:44:30',NULL,NULL),(14416,'15068','S','Lower Burrell','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(78237,'97818','S','Boardman','D','Morrow','41049','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.810948,-119.695417,0,'2013-07-06 12:44:34',NULL,NULL),(79549,'99003','S','Chattaroy','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.914506,-117.304131,0,'2013-07-06 12:44:34',NULL,NULL),(27770,'30368','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.649172,-84.392574,0,'2013-07-06 12:44:31',NULL,NULL),(76569,'95671','U','Folsom Prison','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.676709,-121.147373,0,'2013-07-06 12:44:34',NULL,NULL),(75701,'94568','S','Dublin','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.714234,-121.930817,0,'2013-07-06 12:44:34',NULL,NULL),(75493,'94128','S','San Francisco Intnl Airport','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.607851,-122.386722,0,'2013-07-06 12:44:34',NULL,NULL),(73381,'91101','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.147489,-118.139596,0,'2013-07-06 12:44:34',NULL,NULL),(71426,'87026','S','Tohajiilee','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(70834,'85531','P','Central','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.866645,-109.788905,0,'2013-07-06 12:44:34',NULL,NULL),(67145,'79770','P','Orla','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.827890,-103.913030,0,'2013-07-06 12:44:34',NULL,NULL),(64956,'77240','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.876306,-95.525353,0,'2013-07-06 12:44:34',NULL,NULL),(59924,'71291','S','Kiroli Woods','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(45885,'52301','S','Genoa Bluff','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.797617,-92.081501,0,'2013-07-06 12:44:32',NULL,NULL),(9296,'09706','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(9392,'09855','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(13624,'13901','S','Nimmonsburg','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.156660,-75.890520,0,'2013-07-06 12:44:31',NULL,NULL),(3127,'01243','P','Middlefield','D','Hampshire','25015','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.346522,-73.008342,0,'2013-07-06 12:44:30',NULL,NULL),(14260,'14839','S','Greenwood','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.144281,-77.644114,0,'2013-07-06 12:44:31',NULL,NULL),(34372,'38614','S','Bobo','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(39427,'44681','S','Ragersville','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.512840,-81.678300,0,'2013-07-06 12:44:32',NULL,NULL),(5671,'04963','S','Oakland','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.544935,-69.721959,0,'2013-07-06 12:44:30',NULL,NULL),(44962,'50396','U','First Interstate Bank','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587997,-93.609801,0,'2013-07-06 12:44:32',NULL,NULL),(64128,'76191','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.808015,-97.354309,0,'2013-07-06 12:44:34',NULL,NULL),(48342,'55473','P','Nya','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.961613,-93.266171,0,'2013-07-06 12:44:33',NULL,NULL),(8878,'08695','U','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220861,-74.764864,0,'2013-07-06 12:44:30',NULL,NULL),(41852,'47353','S','Lotus','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(70893,'85616','S','Whetstone','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.680383,-110.316970,0,'2013-07-06 12:44:34',NULL,NULL),(69318,'83467','S','Baker','N','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.172897,-113.898929,0,'2013-07-06 12:44:34',NULL,NULL),(64517,'76635','S','Mustang','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.742700,-96.672420,0,'2013-07-06 12:44:34',NULL,NULL),(58042,'68020','S','Decatur','D','Burt','31021','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.008059,-96.248686,0,'2013-07-06 12:44:33',NULL,NULL),(55426,'63660','S','Stoney Point','N','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.916100,-90.710280,0,'2013-07-06 12:44:33',NULL,NULL),(52122,'60426','S','Phoenix','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.604606,-87.669030,0,'2013-07-06 12:44:33',NULL,NULL),(42127,'47501','S','S Washington','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(8874,'08691','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(6030,'05403','S','S Burlington','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.461260,-73.197180,0,'2013-07-06 12:44:30',NULL,NULL),(22034,'23297','U','Defense General Supply Ct','N','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.399712,-77.457391,0,'2013-07-06 12:44:31',NULL,NULL),(6962,'06233','P','Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.873110,-71.863498,0,'2013-07-06 12:44:30',NULL,NULL),(3657,'02120','S','Roxbury Xing','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.334141,-71.097433,0,'2013-07-06 12:44:30',NULL,NULL),(30295,'33280','P','Aventura','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.932022,-80.136421,0,'2013-07-06 12:44:32',NULL,NULL),(16903,'17584','S','Lime Valley','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.962325,-76.274759,0,'2013-07-06 12:44:31',NULL,NULL),(17278,'17845','S','Laurel Park','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864071,-77.239421,0,'2013-07-06 12:44:31',NULL,NULL),(7492,'06911','P','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.041357,-73.562481,0,'2013-07-06 12:44:30',NULL,NULL),(40150,'45349','P','North Hampton','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.989041,-83.939918,0,'2013-07-06 12:44:32',NULL,NULL),(41271,'46750','S','Toledo','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(10954,'11499','U','Amf/Jfk Incoming Express Mai','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.649401,-73.783733,0,'2013-07-06 12:44:30',NULL,NULL),(19341,'20038','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905008,-77.031432,0,'2013-07-06 12:44:31',NULL,NULL),(9293,'09703','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(65375,'77541','S','Oyster Creek','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(79486,'98902','S','Ahtanum','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(36891,'41101','S','West Fairview','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(34313,'38553','S','Clarkrange','D','Fentress','47049','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.217167,-84.966493,0,'2013-07-06 12:44:32',NULL,NULL),(50915,'58560','S','Moffit','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.676728,-100.268751,0,'2013-07-06 12:44:33',NULL,NULL),(48758,'55976','S','High Forest','N','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',43.859369,-92.487834,0,'2013-07-06 12:44:33',NULL,NULL),(42367,'47710','S','North Park','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.011789,-87.579506,0,'2013-07-06 12:44:32',NULL,NULL),(8485,'08093','S','Westville','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.859740,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(75786,'94706','S','Berkeley','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.888234,-122.293954,0,'2013-07-06 12:44:34',NULL,NULL),(58784,'68977','S','Precept','N','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.089103,-99.575329,0,'2013-07-06 12:44:33',NULL,NULL),(79891,'99580','P','Ekwok','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.374924,-157.596749,0,'2013-07-06 12:44:34',NULL,NULL),(78991,'98380','S','Seabeck','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.634664,-122.844456,0,'2013-07-06 12:44:34',NULL,NULL),(73049,'90087','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.064384,-118.240662,0,'2013-07-06 12:44:34',NULL,NULL),(72068,'88122','P','Kenna','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.840570,-103.775941,0,'2013-07-06 12:44:34',NULL,NULL),(72004,'88039','S','Mogollon','A','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.327720,-108.813300,0,'2013-07-06 12:44:34',NULL,NULL),(50577,'58227','S','Gardar','A','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.488220,-97.915800,0,'2013-07-06 12:44:33',NULL,NULL),(44695,'50131','S','Johnston','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.682602,-93.709577,0,'2013-07-06 12:44:32',NULL,NULL),(35245,'39337','S','Little Rock','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.538238,-89.184620,0,'2013-07-06 12:44:32',NULL,NULL),(13250,'13642','S','Somerville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(17492,'17960','S','New Ringgold','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(1836,'00784','S','Urb Villamar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(54154,'62570','P','Tovey','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.587380,-89.448612,0,'2013-07-06 12:44:33',NULL,NULL),(30773,'33576','S','San Antonio','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.324246,-82.319355,0,'2013-07-06 12:44:32',NULL,NULL),(74577,'92691','S','San Juan Capistrano','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.612814,-117.662215,0,'2013-07-06 12:44:34',NULL,NULL),(39733,'45067','S','Trenton','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.468243,-84.457116,0,'2013-07-06 12:44:32',NULL,NULL),(18285,'19013','S','Uppr Chichstr','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(15687,'16836','S','Frenchville','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.145604,-78.242900,0,'2013-07-06 12:44:31',NULL,NULL),(36681,'41015','S','Rosedale','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(42812,'48054','S','East China Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767172,-82.540934,0,'2013-07-06 12:44:32',NULL,NULL),(74048,'92150','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.986294,-117.081364,0,'2013-07-06 12:44:34',NULL,NULL),(77326,'96707','S','Makakilo','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333426,-158.094993,0,'2013-07-06 12:44:34',NULL,NULL),(3635,'02081','S','Walpole','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.142932,-71.257130,0,'2013-07-06 12:44:30',NULL,NULL),(78831,'98335','S','Purdy','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(64788,'77010','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.754759,-95.361326,0,'2013-07-06 12:44:34',NULL,NULL),(2772,'00976','S','Alt de Fairview','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(22524,'24092','S','Glade Hill','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.003275,-79.769882,0,'2013-07-06 12:44:31',NULL,NULL),(30046,'33144','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.763251,-80.313357,0,'2013-07-06 12:44:32',NULL,NULL),(33019,'36701','S','Valley Grande','A','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.413447,-87.027314,0,'2013-07-06 12:44:32',NULL,NULL),(3140,'01253','S','North Otis','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.192300,-73.068480,0,'2013-07-06 12:44:30',NULL,NULL),(25334,'28211','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.165273,-80.788876,0,'2013-07-06 12:44:31',NULL,NULL),(51160,'58854','S','Watford Cy','N','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.802475,-103.279579,0,'2013-07-06 12:44:33',NULL,NULL),(57408,'66767','S','Mantey','N','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.180379,-94.704409,0,'2013-07-06 12:44:33',NULL,NULL),(63985,'76109','S','Benbrook','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.701611,-97.382250,0,'2013-07-06 12:44:34',NULL,NULL),(63991,'76111','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779783,-97.302729,0,'2013-07-06 12:44:34',NULL,NULL),(75528,'94172','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.760435,-122.483159,0,'2013-07-06 12:44:34',NULL,NULL),(19033,'19539','S','Dryville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(65520,'77708','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.146229,-94.170262,0,'2013-07-06 12:44:34',NULL,NULL),(74044,'92145','U','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.874445,-117.152969,0,'2013-07-06 12:44:34',NULL,NULL),(76173,'95325','S','Hornitos','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.509349,-120.214130,0,'2013-07-06 12:44:34',NULL,NULL),(45980,'52410','P','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.021256,-91.658506,0,'2013-07-06 12:44:32',NULL,NULL),(64644,'76712','S','Waco','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.491114,-97.225849,0,'2013-07-06 12:44:34',NULL,NULL),(835,'00698','S','Alts de Yauco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(40451,'45739','P','Hockingport','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.187565,-81.750644,0,'2013-07-06 12:44:32',NULL,NULL),(3953,'02475','P','Arlington Hts','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420254,-71.180935,0,'2013-07-06 12:44:30',NULL,NULL),(2803,'00976','S','Urb Primavera','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(11204,'11743','S','Huntington','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(42383,'47721','U','Mead Johnson Co','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.915026,-87.648785,0,'2013-07-06 12:44:32',NULL,NULL),(59982,'71326','S','Foules','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.746480,-91.495320,0,'2013-07-06 12:44:33',NULL,NULL),(76516,'95645','S','Knights Landing','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.859828,-121.732992,0,'2013-07-06 12:44:34',NULL,NULL),(80037,'99694','P','Houston','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.491709,-149.790453,0,'2013-07-06 12:44:34',NULL,NULL),(18839,'19426','S','Graterford','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.188960,-75.426360,0,'2013-07-06 12:44:31',NULL,NULL),(30851,'33647','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.114509,-82.363889,0,'2013-07-06 12:44:32',NULL,NULL),(53188,'61607','S','Hollis','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(23532,'25601','S','Mitchell Hts','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.868777,-81.988500,0,'2013-07-06 12:44:31',NULL,NULL),(58905,'69216','S','Kilgore','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.873857,-101.013927,0,'2013-07-06 12:44:33',NULL,NULL),(9517,'10017','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751186,-73.972138,0,'2013-07-06 12:44:30',NULL,NULL),(10134,'10265','U','Barclay Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703113,-74.013325,0,'2013-07-06 12:44:30',NULL,NULL),(11016,'11558','S','Island Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.600901,-73.654227,0,'2013-07-06 12:44:30',NULL,NULL),(37434,'41831','S','Soft Shell','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.402222,-82.942222,0,'2013-07-06 12:44:32',NULL,NULL),(41567,'47024','S','Laurel','D','Franklin','18047','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.477157,-85.195131,0,'2013-07-06 12:44:32',NULL,NULL),(38586,'43804','S','Mechanic','A','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.463509,-81.734242,0,'2013-07-06 12:44:32',NULL,NULL),(38237,'43236','P','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.000056,-82.887958,0,'2013-07-06 12:44:32',NULL,NULL),(524,'00674','S','Urb San Salvador','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(9427,'10003','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(16530,'17268','S','Tomstown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(35350,'39440','S','Errata','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(31710,'34953','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.256604,-80.384626,0,'2013-07-06 12:44:32',NULL,NULL),(24187,'26636','S','Perkins','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.782250,-80.899765,0,'2013-07-06 12:44:31',NULL,NULL),(21671,'22949','S','Lovingston','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.802521,-78.876351,0,'2013-07-06 12:44:31',NULL,NULL),(21187,'22182','S','Tysons Corner','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.928478,-77.261486,0,'2013-07-06 12:44:31',NULL,NULL),(44637,'50070','S','Dexter','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.518177,-94.226804,0,'2013-07-06 12:44:32',NULL,NULL),(37160,'41472','S','Blaze','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(60705,'71945','S','Hatfield','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.487192,-94.352930,0,'2013-07-06 12:44:33',NULL,NULL),(20778,'21532','S','Frostburg','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.655702,-78.929019,0,'2013-07-06 12:44:31',NULL,NULL),(52845,'61320','S','Dalzell','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.358910,-89.177080,0,'2013-07-06 12:44:33',NULL,NULL),(51099,'58776','S','Manitou','N','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328261,-102.500895,0,'2013-07-06 12:44:33',NULL,NULL),(19343,'20040','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.966723,-77.031587,0,'2013-07-06 12:44:31',NULL,NULL),(12091,'12567','S','Pine Plains','D','Dutchess','36027','New York','NY','36','2281','518','Eastern',-5.0,'Y',41.993160,-73.666740,0,'2013-07-06 12:44:30',NULL,NULL),(78740,'98288','P','Scenic','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.703900,-121.304580,0,'2013-07-06 12:44:34',NULL,NULL),(29773,'33012','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.865517,-80.297427,0,'2013-07-06 12:44:32',NULL,NULL),(16896,'17582','S','Central Manor','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.996531,-76.452756,0,'2013-07-06 12:44:31',NULL,NULL),(25213,'28081','S','Glass','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(72711,'89449','P','Lakeridge','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.962500,-119.938800,0,'2013-07-06 12:44:34',NULL,NULL),(18831,'19422','S','Center Square','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.152960,-75.274659,0,'2013-07-06 12:44:31',NULL,NULL),(34566,'38732','S','Cleveland','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740820,-90.724995,0,'2013-07-06 12:44:32',NULL,NULL),(31413,'34240','S','Lakewood Ranch','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.319476,-82.386179,0,'2013-07-06 12:44:32',NULL,NULL),(8743,'08525','S','Hopewell Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.386966,-74.765926,0,'2013-07-06 12:44:30',NULL,NULL),(8934,'08752','S','South Seaside Park','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.922118,-74.080135,0,'2013-07-06 12:44:30',NULL,NULL),(48346,'55478','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.983515,-93.264921,0,'2013-07-06 12:44:33',NULL,NULL),(54962,'63121','S','Bel Ridge','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(71047,'85747','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.043928,-110.735754,0,'2013-07-06 12:44:34',NULL,NULL),(21137,'22103','P','McLean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.947768,-77.227954,0,'2013-07-06 12:44:31',NULL,NULL),(65053,'77338','S','Humble','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.003446,-95.277832,0,'2013-07-06 12:44:34',NULL,NULL),(79013,'98390','S','Dieringer','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.179260,-122.192040,0,'2013-07-06 12:44:34',NULL,NULL),(79489,'98902','S','Pomona','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(57914,'67661','S','Phillipsburg','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.757045,-99.325612,0,'2013-07-06 12:44:33',NULL,NULL),(41659,'47144','U','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.332730,-85.708400,0,'2013-07-06 12:44:32',NULL,NULL),(13760,'14131','S','Ransomville','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.228804,-78.911638,0,'2013-07-06 12:44:31',NULL,NULL),(30551,'33411','S','Royal Plm Beach','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(1852,'00791','S','Ciudad Cristiana','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(10310,'10535','S','Jefferson Valley','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.339561,-73.798456,0,'2013-07-06 12:44:30',NULL,NULL),(10014,'10169','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(13810,'14211','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.909859,-78.822940,0,'2013-07-06 12:44:31',NULL,NULL),(33012,'36688','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.688966,-88.189832,0,'2013-07-06 12:44:32',NULL,NULL),(21609,'22902','S','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000280,-78.463620,0,'2013-07-06 12:44:31',NULL,NULL),(46328,'53082','P','Sheboygan','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.765755,-87.768710,0,'2013-07-06 12:44:32',NULL,NULL),(46763,'53941','S','La Valle','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.573421,-90.140745,0,'2013-07-06 12:44:32',NULL,NULL),(59858,'71259','S','Mangham','D','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.295425,-91.832115,0,'2013-07-06 12:44:33',NULL,NULL),(61049,'72119','P','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.763985,-92.258586,0,'2013-07-06 12:44:33',NULL,NULL),(66300,'78586','S','Las Rusias','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(72917,'90026','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.079313,-118.262692,0,'2013-07-06 12:44:34',NULL,NULL),(73949,'92057','S','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.240638,-117.298443,0,'2013-07-06 12:44:34',NULL,NULL),(6888,'06143','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790844,-72.668920,0,'2013-07-06 12:44:30',NULL,NULL),(54954,'63119','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.588549,-90.350542,0,'2013-07-06 12:44:33',NULL,NULL),(31923,'35175','S','Union Grove','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.420133,-86.465895,0,'2013-07-06 12:44:32',NULL,NULL),(31350,'34201','S','University Park','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.390254,-82.481246,0,'2013-07-06 12:44:32',NULL,NULL),(65577,'77862','P','Kurten','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.784754,-96.265159,0,'2013-07-06 12:44:34',NULL,NULL),(78167,'97634','P','Midland','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.133092,-121.816443,0,'2013-07-06 12:44:34',NULL,NULL),(1678,'00777','S','Colinas del Este','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(5589,'04920','S','Concord Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.128441,-69.858003,0,'2013-07-06 12:44:30',NULL,NULL),(30269,'33242','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.811761,-80.234329,0,'2013-07-06 12:44:32',NULL,NULL),(22695,'24325','S','Dugspur','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.821816,-80.614233,0,'2013-07-06 12:44:31',NULL,NULL),(23070,'24880','S','Rock View','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.554073,-81.524227,0,'2013-07-06 12:44:31',NULL,NULL),(46454,'53211','S','Whitefish Bay','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.082534,-87.884406,0,'2013-07-06 12:44:32',NULL,NULL),(46474,'53218','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.113642,-87.991022,0,'2013-07-06 12:44:32',NULL,NULL),(48820,'56033','S','Frost','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.587427,-93.921214,0,'2013-07-06 12:44:33',NULL,NULL),(52139,'60436','S','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.489640,-88.145340,0,'2013-07-06 12:44:33',NULL,NULL),(54841,'63038','S','Ellisville','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.582772,-90.652220,0,'2013-07-06 12:44:33',NULL,NULL),(57902,'67647','S','Long Island','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.959355,-99.556644,0,'2013-07-06 12:44:33',NULL,NULL),(59008,'70068','S','La Place','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.054960,-90.480540,0,'2013-07-06 12:44:33',NULL,NULL),(67482,'80229','S','Denver','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.850200,-104.969880,0,'2013-07-06 12:44:34',NULL,NULL),(75437,'94041','S','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.387390,-122.071863,0,'2013-07-06 12:44:34',NULL,NULL),(76033,'95150','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.289036,-121.914383,0,'2013-07-06 12:44:34',NULL,NULL),(55513,'63781','S','Sedgewickvlle','A','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.545458,-89.928209,0,'2013-07-06 12:44:33',NULL,NULL),(16166,'17063','S','Siglerville','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.716078,-77.590384,0,'2013-07-06 12:44:31',NULL,NULL),(46899,'54124','S','Underhill','A','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.903377,-88.341021,0,'2013-07-06 12:44:32',NULL,NULL),(41120,'46590','S','Winona Lake','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.219507,-85.818519,0,'2013-07-06 12:44:32',NULL,NULL),(26,'00603','S','Repto Tres Palmas','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(2560,'00959','S','Urb Forest Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(8654,'08314','S','Delmont','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.207047,-74.971309,0,'2013-07-06 12:44:30',NULL,NULL),(1091,'00725','S','Urb El Retiro','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(54261,'62677','S','Farmingdale','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.875106,-89.916317,0,'2013-07-06 12:44:33',NULL,NULL),(55835,'64154','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.276392,-94.627724,0,'2013-07-06 12:44:33',NULL,NULL),(58098,'68110','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.291646,-95.926442,0,'2013-07-06 12:44:33',NULL,NULL),(60168,'71409','S','Alfalfa','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(61997,'73432','S','Coleman','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.283307,-96.485701,0,'2013-07-06 12:44:33',NULL,NULL),(60818,'72032','S','Preston','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(64681,'76834','S','Coleman','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.833600,-99.415500,0,'2013-07-06 12:44:34',NULL,NULL),(14787,'15360','S','Scenery Hill','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.076136,-80.074788,0,'2013-07-06 12:44:31',NULL,NULL),(56116,'64801','S','Stones Corner','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(22207,'23513','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.887779,-76.238460,0,'2013-07-06 12:44:31',NULL,NULL),(22978,'24736','S','Dott','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.419663,-81.244363,0,'2013-07-06 12:44:31',NULL,NULL),(3882,'02368','S','Randolph','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.173512,-71.050595,0,'2013-07-06 12:44:30',NULL,NULL),(38220,'43221','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.014525,-83.068936,0,'2013-07-06 12:44:32',NULL,NULL),(60538,'71677','P','Winchester','D','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.750509,-91.549042,0,'2013-07-06 12:44:33',NULL,NULL),(64549,'76652','S','Kimball','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.121465,-97.581963,0,'2013-07-06 12:44:34',NULL,NULL),(77372,'96750','S','Kealakekua','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.525821,-155.926480,0,'2013-07-06 12:44:34',NULL,NULL),(78293,'97880','P','Ukiah','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.134770,-118.928389,0,'2013-07-06 12:44:34',NULL,NULL),(7551,'07014','S','Delawanna','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.835346,-74.135292,0,'2013-07-06 12:44:30',NULL,NULL),(31455,'34286','S','No Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.070796,-82.145952,0,'2013-07-06 12:44:32',NULL,NULL),(48196,'55396','S','Winthrop','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.542475,-94.367319,0,'2013-07-06 12:44:33',NULL,NULL),(22817,'24487','S','Burnsville','A','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.177778,-79.647778,0,'2013-07-06 12:44:31',NULL,NULL),(69957,'84118','S','Taylorsville','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(1820,'00784','S','Jard de Guamani','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(23948,'26275','P','Junior','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.034866,-79.954565,0,'2013-07-06 12:44:31',NULL,NULL),(59432,'70669','S','Westlake','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.259227,-93.263167,0,'2013-07-06 12:44:33',NULL,NULL),(29001,'32220','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.328507,-81.815147,0,'2013-07-06 12:44:32',NULL,NULL),(44806,'50235','S','Rippey','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.932292,-94.202558,0,'2013-07-06 12:44:32',NULL,NULL),(47711,'55002','P','Almelund','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.393889,-92.816389,0,'2013-07-06 12:44:33',NULL,NULL),(50827,'58474','S','Glover','N','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.133520,-98.100180,0,'2013-07-06 12:44:33',NULL,NULL),(60341,'71466','S','Otis','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.218380,-92.742689,0,'2013-07-06 12:44:33',NULL,NULL),(60503,'71665','S','Rison','D','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(65,'00612','S','Bo El Pasaje','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(25399,'28281','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.226708,-80.841821,0,'2013-07-06 12:44:31',NULL,NULL),(19492,'20153','P','Fairfax','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.887590,-77.441421,0,'2013-07-06 12:44:31',NULL,NULL),(69354,'83546','S','Headquarters','A','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.488420,-115.799880,0,'2013-07-06 12:44:34',NULL,NULL),(16797,'17540','S','Leola','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.095709,-76.185401,0,'2013-07-06 12:44:31',NULL,NULL),(13776,'14144','P','Stella Niagara','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.197880,-79.046406,0,'2013-07-06 12:44:31',NULL,NULL),(56263,'65063','S','Dixie','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.748060,-92.080440,0,'2013-07-06 12:44:33',NULL,NULL),(881,'00703','S','Est del Rio','N','Aguas Buenas','72007','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.261636,-66.103857,0,'2013-07-06 12:44:30',NULL,NULL),(18012,'18640','S','Jenkins Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(38486,'43660','U','Toledo Blade','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.638952,-83.544684,0,'2013-07-06 12:44:32',NULL,NULL),(1162,'00727','S','Urb Bairoa Golden Gate Ii','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(26502,'29169','S','West Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(43311,'48350','S','Springfield Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.742927,-83.530899,0,'2013-07-06 12:44:32',NULL,NULL),(52327,'60561','S','Darien','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.749940,-87.977041,0,'2013-07-06 12:44:33',NULL,NULL),(76856,'95965','S','Villa Verona','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(57172,'66286','P','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.993781,-94.871495,0,'2013-07-06 12:44:33',NULL,NULL),(19956,'20581','U','Commodity Futures Trade','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891213,-77.044910,0,'2013-07-06 12:44:31',NULL,NULL),(79329,'98610','S','Carson','D','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.748636,-121.845884,0,'2013-07-06 12:44:34',NULL,NULL),(26294,'29021','P','Shamokin','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(28186,'31011','S','Chauncey','D','Dodge','13091','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.207960,-83.128783,0,'2013-07-06 12:44:31',NULL,NULL),(18882,'19462','S','Plymouth Meeting','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.108511,-75.277184,0,'2013-07-06 12:44:31',NULL,NULL),(28934,'32170','P','New Smyrna Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.034832,-80.918544,0,'2013-07-06 12:44:32',NULL,NULL),(9185,'09373','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(41325,'46776','S','Orland','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.736790,-85.171469,0,'2013-07-06 12:44:32',NULL,NULL),(4142,'02760','S','North Attleboro','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.977034,-71.324788,0,'2013-07-06 12:44:30',NULL,NULL),(6331,'05665','P','North Hyde Park','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.671791,-72.598969,0,'2013-07-06 12:44:30',NULL,NULL),(34055,'38139','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.089280,-89.773074,0,'2013-07-06 12:44:32',NULL,NULL),(33307,'37132','U','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.850303,-86.361672,0,'2013-07-06 12:44:32',NULL,NULL),(7895,'07543','P','Peoples Park','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.905000,-74.148698,0,'2013-07-06 12:44:30',NULL,NULL),(2463,'00956','S','Bosque de Las Palmas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(21500,'22701','S','Catalpa','N','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.471640,-78.013989,0,'2013-07-06 12:44:31',NULL,NULL),(47087,'54435','S','Harrison','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.400965,-89.462214,0,'2013-07-06 12:44:32',NULL,NULL),(48270,'55429','S','Brooklyn Pk','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(51369,'59353','S','Wibaux','D','Wibaux','30109','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.983568,-104.188289,0,'2013-07-06 12:44:33',NULL,NULL),(61670,'72921','S','Alma','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.486757,-94.227174,0,'2013-07-06 12:44:33',NULL,NULL),(76789,'95945','S','Alta Hill','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(1821,'00784','S','Jard de Monte Olivo','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(56162,'64864','P','Saginaw','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.025742,-94.470028,0,'2013-07-06 12:44:33',NULL,NULL),(49618,'56902','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(49570,'56724','S','Gatzke','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.413315,-95.794605,0,'2013-07-06 12:44:33',NULL,NULL),(48130,'55359','S','Minnetrista','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.997812,-93.687245,0,'2013-07-06 12:44:33',NULL,NULL),(14892,'15486','S','Vanderbilt','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.023658,-79.702799,0,'2013-07-06 12:44:31',NULL,NULL),(34700,'38829','S','Jumpertown','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(32036,'35244','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.361710,-86.788783,0,'2013-07-06 12:44:32',NULL,NULL),(7267,'06519','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.294976,-72.938709,0,'2013-07-06 12:44:30',NULL,NULL),(29777,'33014','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.901437,-80.306472,0,'2013-07-06 12:44:32',NULL,NULL),(2042,'00918','S','Urb Hyde Pk','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(73172,'90308','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.960454,-118.351465,0,'2013-07-06 12:44:34',NULL,NULL),(38916,'44120','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472129,-81.578028,0,'2013-07-06 12:44:32',NULL,NULL),(6165,'05472','S','New Haven Mills','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(35857,'39827','S','Cairo','D','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.876043,-84.206528,0,'2013-07-06 12:44:32',NULL,NULL),(10622,'11050','S','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(41484,'46937','P','Hemlock','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.419095,-86.040352,0,'2013-07-06 12:44:32',NULL,NULL),(43435,'48502','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.014202,-83.688920,0,'2013-07-06 12:44:32',NULL,NULL),(46975,'54215','P','Kellnersville','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.218693,-87.814613,0,'2013-07-06 12:44:32',NULL,NULL),(47108,'54448','S','Little Chicago','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.930712,-89.834421,0,'2013-07-06 12:44:32',NULL,NULL),(48116,'55354','S','Lester Prairie','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.883546,-94.040436,0,'2013-07-06 12:44:33',NULL,NULL),(54709,'62956','S','Boaz','N','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.292272,-88.977403,0,'2013-07-06 12:44:33',NULL,NULL),(55483,'63760','S','Leopold','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.263829,-89.909492,0,'2013-07-06 12:44:33',NULL,NULL),(60121,'71369','S','Odenburg','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.989911,-91.825861,0,'2013-07-06 12:44:33',NULL,NULL),(67993,'80919','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.928018,-104.848484,0,'2013-07-06 12:44:34',NULL,NULL),(17992,'18626','P','Laporte','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.426484,-76.495974,0,'2013-07-06 12:44:31',NULL,NULL),(55031,'63137','S','Bellefontaine Neighbors','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748404,-90.218419,0,'2013-07-06 12:44:33',NULL,NULL),(3550,'01930','S','Magnolia','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.628500,-70.686240,0,'2013-07-06 12:44:30',NULL,NULL),(761,'00692','S','Urb Golden Vlg','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(1417,'00738','S','Urb Viera','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(2071,'00921','S','Puerto Nuevo','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(25975,'28659','S','Quarry','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(30050,'33145','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753248,-80.236857,0,'2013-07-06 12:44:32',NULL,NULL),(40371,'45648','S','Lucasville','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.914740,-83.032800,0,'2013-07-06 12:44:32',NULL,NULL),(17128,'17776','S','Waterville','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.331890,-77.344196,0,'2013-07-06 12:44:31',NULL,NULL),(3737,'02163','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.369472,-71.124373,0,'2013-07-06 12:44:30',NULL,NULL),(16532,'17268','S','Waynesboro','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(3995,'02539','S','Edgartown','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.391367,-70.529036,0,'2013-07-06 12:44:30',NULL,NULL),(7591,'07036','S','Winfield Park','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.635633,-74.256169,0,'2013-07-06 12:44:30',NULL,NULL),(8093,'07762','S','Spring Lake Heights','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(50137,'57532','S','Norman Ranch','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(63742,'75935','S','Neuville','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(70462,'84754','S','Monroe','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.642486,-112.135978,0,'2013-07-06 12:44:34',NULL,NULL),(72333,'89011','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.097423,-114.923904,0,'2013-07-06 12:44:34',NULL,NULL),(67367,'80113','S','Cherry Hills','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643479,-104.956040,0,'2013-07-06 12:44:34',NULL,NULL),(63566,'75771','S','Hide A Way Lake','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(57771,'67458','S','Longford','D','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.169610,-97.330790,0,'2013-07-06 12:44:33',NULL,NULL),(50138,'57532','S','Orton','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(20615,'21210','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.354360,-76.635912,0,'2013-07-06 12:44:31',NULL,NULL),(20707,'21270','P','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.359071,-76.704770,0,'2013-07-06 12:44:31',NULL,NULL),(26654,'29368','P','Mayo','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.072629,-81.873086,0,'2013-07-06 12:44:31',NULL,NULL),(28822,'32080','S','St Aug Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(33117,'36865','P','Loachapoka','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.616958,-85.600678,0,'2013-07-06 12:44:32',NULL,NULL),(16157,'17062','S','Eshcol','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.570620,-77.131680,0,'2013-07-06 12:44:31',NULL,NULL),(37393,'41762','S','Sizerock','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164104,-83.438462,0,'2013-07-06 12:44:32',NULL,NULL),(17449,'17941','S','Hepler','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.726516,-76.605887,0,'2013-07-06 12:44:31',NULL,NULL),(24910,'27717','P','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.956235,-78.951630,0,'2013-07-06 12:44:31',NULL,NULL),(42911,'48105','S','Barton Hills','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.306761,-83.700406,0,'2013-07-06 12:44:32',NULL,NULL),(948,'00716','S','Ext Villa del Carmen','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(25152,'28025','S','Flowes Store','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.400953,-80.583807,0,'2013-07-06 12:44:31',NULL,NULL),(53428,'61856','S','Monticello','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.021922,-88.574094,0,'2013-07-06 12:44:33',NULL,NULL),(59838,'71243','S','Ft Necessity','A','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.044920,-91.820280,0,'2013-07-06 12:44:33',NULL,NULL),(66458,'78654','S','Granite Shoals','A','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(24260,'26815','S','Moyers','A','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.498767,-79.274451,0,'2013-07-06 12:44:31',NULL,NULL),(4031,'02573','P','Tisbury','N','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.441817,-70.600178,0,'2013-07-06 12:44:30',NULL,NULL),(1712,'00778','S','Bda Nueva','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(67566,'80294','S','Federal Bldg/Us Courthouse','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.753064,-104.990775,0,'2013-07-06 12:44:34',NULL,NULL),(12622,'13089','P','Liverpool','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.139774,-76.227220,0,'2013-07-06 12:44:30',NULL,NULL),(43283,'48333','P','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.462218,-83.377754,0,'2013-07-06 12:44:32',NULL,NULL),(73850,'91804','S','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.092015,-118.128852,0,'2013-07-06 12:44:34',NULL,NULL),(73782,'91745','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.998974,-117.965163,0,'2013-07-06 12:44:34',NULL,NULL),(42327,'47630','S','Newburgh','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.964340,-87.354120,0,'2013-07-06 12:44:32',NULL,NULL),(14865,'15461','S','Masontown','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.832222,-79.918889,0,'2013-07-06 12:44:31',NULL,NULL),(67730,'80547','P','Timnath','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.530372,-104.983760,0,'2013-07-06 12:44:34',NULL,NULL),(68570,'81503','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.039000,-108.496612,0,'2013-07-06 12:44:34',NULL,NULL),(48545,'55760','S','Jevne','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(30594,'33420','P','Palm Beach Gardens','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855333,-80.083047,0,'2013-07-06 12:44:32',NULL,NULL),(70807,'85372','P','Sun City','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.616054,-112.283824,0,'2013-07-06 12:44:34',NULL,NULL),(72311,'88901','U','Citibank','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.145297,-115.282899,0,'2013-07-06 12:44:34',NULL,NULL),(77783,'97125','S','Manning','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.618889,-123.113056,0,'2013-07-06 12:44:34',NULL,NULL),(66517,'78712','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.285130,-97.737776,0,'2013-07-06 12:44:34',NULL,NULL),(64274,'76427','S','Bryson','D','Jack','48237','Texas','TX','48','0000','940','Central',-6.0,'Y',33.129840,-98.344304,0,'2013-07-06 12:44:34',NULL,NULL),(1029,'00719','S','Jard de Naranjito','N','Naranjito','72105','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.301571,-66.244271,0,'2013-07-06 12:44:30',NULL,NULL),(17477,'17952','P','Mary D','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.760300,-76.055326,0,'2013-07-06 12:44:31',NULL,NULL),(37886,'42602','S','Browns XRoads','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(52228,'60499','P','South Suburbn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782323,-87.767936,0,'2013-07-06 12:44:33',NULL,NULL),(41050,'46407','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.583077,-87.335347,0,'2013-07-06 12:44:32',NULL,NULL),(75892,'94966','P','Sausalito','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.865865,-122.496891,0,'2013-07-06 12:44:34',NULL,NULL),(12551,'13044','S','Constantia','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.266484,-76.009432,0,'2013-07-06 12:44:30',NULL,NULL),(36004,'40150','S','Lebanon Jct','N','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.853195,-85.729211,0,'2013-07-06 12:44:32',NULL,NULL),(67035,'79543','S','Roby','D','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.720340,-100.419180,0,'2013-07-06 12:44:34',NULL,NULL),(69438,'83642','S','Meridian','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.609109,-116.398114,0,'2013-07-06 12:44:34',NULL,NULL),(73783,'91745','S','Hacienda Heights','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.998974,-117.965163,0,'2013-07-06 12:44:34',NULL,NULL),(79789,'99349','S','Mattawa','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.736559,-119.899537,0,'2013-07-06 12:44:34',NULL,NULL),(63998,'76114','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(59396,'70630','S','Bell City','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.097651,-93.013132,0,'2013-07-06 12:44:33',NULL,NULL),(57628,'67140','S','South Haven','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.093316,-97.350358,0,'2013-07-06 12:44:33',NULL,NULL),(6848,'06126','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766509,-72.679994,0,'2013-07-06 12:44:30',NULL,NULL),(10381,'10591','S','Tarrytown','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(34608,'38749','P','Indianola','A','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.450833,-90.655000,0,'2013-07-06 12:44:32',NULL,NULL),(41033,'46390','S','South Wanatah','N','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.435469,-86.892131,0,'2013-07-06 12:44:32',NULL,NULL),(70813,'85376','P','Sun City West','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.667527,-112.351724,0,'2013-07-06 12:44:34',NULL,NULL),(14360,'15021','S','Burgettstown','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.412700,-80.431260,0,'2013-07-06 12:44:31',NULL,NULL),(7216,'06494','U','Wallingford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.469621,-72.818052,0,'2013-07-06 12:44:30',NULL,NULL),(37462,'41858','S','Kings Creek','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(72746,'89508','S','Silver Knolls','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.630232,-119.870037,0,'2013-07-06 12:44:34',NULL,NULL),(38597,'43832','S','Newcomerstown','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.266000,-81.600180,0,'2013-07-06 12:44:32',NULL,NULL),(23051,'24868','S','Crumpler','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(36983,'41189','S','Burtonville','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.586965,-83.548106,0,'2013-07-06 12:44:32',NULL,NULL),(36384,'40481','S','Sandgap','D','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.485179,-84.044483,0,'2013-07-06 12:44:32',NULL,NULL),(43640,'48833','P','Eureka','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.103318,-84.507212,0,'2013-07-06 12:44:32',NULL,NULL),(75812,'94806','S','Richmond','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972918,-122.333929,0,'2013-07-06 12:44:34',NULL,NULL),(67326,'80035','P','Westminster','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.862046,-105.039789,0,'2013-07-06 12:44:34',NULL,NULL),(18087,'18706','S','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(23529,'25572','S','Woodville','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.160737,-81.893383,0,'2013-07-06 12:44:31',NULL,NULL),(69396,'83615','S','Tamarack','A','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.710118,-116.095636,0,'2013-07-06 12:44:34',NULL,NULL),(70769,'85338','S','Goodyear','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.434691,-112.383814,0,'2013-07-06 12:44:34',NULL,NULL),(76287,'95429','S','Dos Rios','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.706380,-123.324240,0,'2013-07-06 12:44:34',NULL,NULL),(40915,'46266','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.767943,-86.160502,0,'2013-07-06 12:44:32',NULL,NULL),(297,'00646','S','Urb Doraville','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(44381,'49799','S','Wolverine','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.267783,-84.588712,0,'2013-07-06 12:44:32',NULL,NULL),(10557,'11003','S','Alden Manor','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(12330,'12866','S','Saratoga Spgs','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.075993,-73.774821,0,'2013-07-06 12:44:30',NULL,NULL),(68769,'82310','S','Jeffrey City','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.512682,-107.892119,0,'2013-07-06 12:44:34',NULL,NULL),(22195,'23507','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.863555,-76.299662,0,'2013-07-06 12:44:31',NULL,NULL),(66570,'78738','S','Village of the Hills','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(15891,'17005','P','Berrysburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.604532,-76.809901,0,'2013-07-06 12:44:31',NULL,NULL),(8627,'08260','S','Grassy Sound','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(33683,'37744','P','Greeneville','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.163345,-82.812426,0,'2013-07-06 12:44:32',NULL,NULL),(51967,'60144','P','Kaneville','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.832200,-88.517235,0,'2013-07-06 12:44:33',NULL,NULL),(56531,'65436','S','Beulah','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.647062,-91.877380,0,'2013-07-06 12:44:33',NULL,NULL),(74365,'92418','U','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.104145,-117.290746,0,'2013-07-06 12:44:34',NULL,NULL),(33292,'37128','S','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.815518,-86.451250,0,'2013-07-06 12:44:32',NULL,NULL),(36694,'41017','S','Crescent Spgs','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(58339,'68463','S','Weeping Water','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.866222,-96.140444,0,'2013-07-06 12:44:33',NULL,NULL),(74252,'92335','S','Fontana','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.093648,-117.460417,0,'2013-07-06 12:44:34',NULL,NULL),(39769,'45121','S','Ash Ridge','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(21531,'22727','S','Twymans Mill','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(69906,'84107','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(74244,'92328','S','Death Valley Junction','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.425648,-117.090213,0,'2013-07-06 12:44:34',NULL,NULL),(60854,'72046','S','England','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.574340,-91.977060,0,'2013-07-06 12:44:33',NULL,NULL),(19222,'19896','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.758421,-75.527711,0,'2013-07-06 12:44:31',NULL,NULL),(34755,'38858','S','Cardsville','N','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.076707,-88.619807,0,'2013-07-06 12:44:32',NULL,NULL),(17066,'17756','S','Opp','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(6541,'05838','P','East Saint Johnsbury','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.439437,-71.943690,0,'2013-07-06 12:44:30',NULL,NULL),(59023,'70079','S','Good Hope','N','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.010500,-90.420660,0,'2013-07-06 12:44:33',NULL,NULL),(37481,'42001','S','Reidland','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(65232,'77450','S','Katy','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.768276,-95.743065,0,'2013-07-06 12:44:34',NULL,NULL),(71983,'88024','P','Berino','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.068056,-106.623056,0,'2013-07-06 12:44:34',NULL,NULL),(70130,'84244','U','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.260364,-111.970792,0,'2013-07-06 12:44:34',NULL,NULL),(2075,'00921','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(17744,'18321','S','Bartonsville','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.009326,-75.290126,0,'2013-07-06 12:44:31',NULL,NULL),(16081,'17050','S','Mechanicsburg','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(13944,'14445','S','E Rochester','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.112550,-77.489182,0,'2013-07-06 12:44:31',NULL,NULL),(4177,'02812','S','Carolina','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.477353,-71.646761,0,'2013-07-06 12:44:30',NULL,NULL),(23200,'25063','S','Duck','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.567158,-80.975873,0,'2013-07-06 12:44:31',NULL,NULL),(22380,'23936','S','Dillwyn','D','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.520399,-78.476570,0,'2013-07-06 12:44:31',NULL,NULL),(73613,'91401','S','Valley Glen','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.176265,-118.427626,0,'2013-07-06 12:44:34',NULL,NULL),(75729,'94592','S','Mare Island','N','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.102623,-122.275686,0,'2013-07-06 12:44:34',NULL,NULL),(59878,'71269','S','Crew Lake','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(4685,'03803','U','Portsmouth','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.067757,-70.800532,0,'2013-07-06 12:44:30',NULL,NULL),(10636,'11054','U','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.831342,-73.683314,0,'2013-07-06 12:44:30',NULL,NULL),(4668,'03774','S','North Haverhill','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.084308,-72.025912,0,'2013-07-06 12:44:30',NULL,NULL),(24761,'27543','P','Kipling','D','Harnett','37085','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.481055,-78.821646,0,'2013-07-06 12:44:31',NULL,NULL),(30811,'33616','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.871387,-82.519405,0,'2013-07-06 12:44:32',NULL,NULL),(56589,'65552','S','Plato','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.494347,-92.183812,0,'2013-07-06 12:44:33',NULL,NULL),(15716,'16866','S','Philipsburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.894163,-78.213044,0,'2013-07-06 12:44:31',NULL,NULL),(47273,'54534','S','Hurley','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.481944,-90.305833,0,'2013-07-06 12:44:32',NULL,NULL),(26140,'28736','S','Glenville','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.193680,-83.085357,0,'2013-07-06 12:44:31',NULL,NULL),(69253,'83424','S','Felt','D','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.888177,-111.176883,0,'2013-07-06 12:44:34',NULL,NULL),(178,'00623','S','Jard del Puerto','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(48394,'55582','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.279713,-93.808776,0,'2013-07-06 12:44:33',NULL,NULL),(18120,'18814','P','Burlington','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.776235,-76.608405,0,'2013-07-06 12:44:31',NULL,NULL),(51070,'58756','S','Makoti','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.020926,-101.834279,0,'2013-07-06 12:44:33',NULL,NULL),(10305,'10530','S','Scarsdale','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.021378,-73.805692,0,'2013-07-06 12:44:30',NULL,NULL),(66035,'78368','S','Hubert','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(59011,'70069','P','La Place','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.064380,-90.482520,0,'2013-07-06 12:44:33',NULL,NULL),(56037,'64688','S','Wheeling','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.805261,-93.393424,0,'2013-07-06 12:44:33',NULL,NULL),(14117,'14643','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.155367,-77.607291,0,'2013-07-06 12:44:31',NULL,NULL),(34161,'38259','S','Trimble','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.201934,-89.190422,0,'2013-07-06 12:44:32',NULL,NULL),(32509,'36078','S','Tallassee','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.540535,-85.904526,0,'2013-07-06 12:44:32',NULL,NULL),(28599,'31649','S','Stockton','D','Lanier','13173','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.029294,-83.008366,0,'2013-07-06 12:44:32',NULL,NULL),(22412,'23970','S','South Hill','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.727549,-78.134748,0,'2013-07-06 12:44:31',NULL,NULL),(63496,'75705','S','Omen','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.361239,-95.084145,0,'2013-07-06 12:44:33',NULL,NULL),(77311,'96679','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(42043,'47443','S','Lyons','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.989429,-87.083684,0,'2013-07-06 12:44:32',NULL,NULL),(6142,'05464','S','Madonna','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663827,-72.783702,0,'2013-07-06 12:44:30',NULL,NULL),(57718,'67356','S','Oswego','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.189320,-95.138160,0,'2013-07-06 12:44:33',NULL,NULL),(13155,'13605','S','Adams','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.823100,-76.036860,0,'2013-07-06 12:44:30',NULL,NULL),(44653,'50103','S','High Point','N','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.717931,-93.614761,0,'2013-07-06 12:44:32',NULL,NULL),(53522,'62027','S','Eldred','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.286541,-90.553196,0,'2013-07-06 12:44:33',NULL,NULL),(4659,'03768','S','Lyme','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.773137,-72.164254,0,'2013-07-06 12:44:30',NULL,NULL),(22599,'24201','S','Bristol','D','Bristol City','51520','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.613610,-82.170950,0,'2013-07-06 12:44:31',NULL,NULL),(11616,'12095','S','Johnstown','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.021140,-74.395500,0,'2013-07-06 12:44:30',NULL,NULL),(30151,'33168','S','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.875268,-80.201839,0,'2013-07-06 12:44:32',NULL,NULL),(31375,'34211','S','Lakewood Ranch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(36568,'40939','S','Elys','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.742655,-83.693032,0,'2013-07-06 12:44:32',NULL,NULL),(39072,'44211','P','Brady Lake','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.170383,-81.316819,0,'2013-07-06 12:44:32',NULL,NULL),(44580,'50033','S','Bevington','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.359363,-93.792209,0,'2013-07-06 12:44:32',NULL,NULL),(42619,'47904','S','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.428786,-86.875104,0,'2013-07-06 12:44:32',NULL,NULL),(7432,'06825','S','Fairfield','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.194876,-73.240637,0,'2013-07-06 12:44:30',NULL,NULL),(42326,'47630','S','Dayville','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.964340,-87.354120,0,'2013-07-06 12:44:32',NULL,NULL),(73718,'91614','P','Studio City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.393815,0,'2013-07-06 12:44:34',NULL,NULL),(8649,'08311','S','Cedarville','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.331341,-75.202275,0,'2013-07-06 12:44:30',NULL,NULL),(52762,'61252','S','Fulton','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.855867,-90.142898,0,'2013-07-06 12:44:33',NULL,NULL),(2029,'00917','S','Urb Davila & Llenza','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(57988,'67849','S','Hanston','D','Hodgeman','20083','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.123791,-99.713284,0,'2013-07-06 12:44:33',NULL,NULL),(28607,'31703','P','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.577073,-84.153068,0,'2013-07-06 12:44:32',NULL,NULL),(33026,'36723','P','Boykin','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.079748,-87.281135,0,'2013-07-06 12:44:32',NULL,NULL),(33695,'37756','S','Huntsville','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.395880,-84.459240,0,'2013-07-06 12:44:32',NULL,NULL),(66208,'78550','S','Avondale','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(23689,'25853','P','Helen','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.635682,-81.312751,0,'2013-07-06 12:44:31',NULL,NULL),(45127,'50567','S','Nemaha','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.516543,-95.092223,0,'2013-07-06 12:44:32',NULL,NULL),(45115,'50559','S','Lotts Creek','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.223405,-94.320812,0,'2013-07-06 12:44:32',NULL,NULL),(76662,'95746','S','Granite Bay','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.744190,-121.191175,0,'2013-07-06 12:44:34',NULL,NULL),(6122,'05459','S','Beaulieus Corner','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(17413,'17921','S','Centralia','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(29136,'32327','S','Crawfordville','D','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.194005,-84.263529,0,'2013-07-06 12:44:32',NULL,NULL),(56698,'65661','S','Greenfield','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.415238,-93.844974,0,'2013-07-06 12:44:33',NULL,NULL),(56325,'65106','U','Income Tax Refund','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578011,-92.174363,0,'2013-07-06 12:44:33',NULL,NULL),(64709,'76861','S','Miles','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.595322,-100.184718,0,'2013-07-06 12:44:34',NULL,NULL),(75262,'93669','S','Bass Lake','A','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.320000,-119.556667,0,'2013-07-06 12:44:34',NULL,NULL),(71429,'87028','S','Contreras','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.390372,-106.803839,0,'2013-07-06 12:44:34',NULL,NULL),(8813,'08611','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.209791,-74.754696,0,'2013-07-06 12:44:30',NULL,NULL),(17006,'17739','P','Okome','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.408022,-77.457577,0,'2013-07-06 12:44:31',NULL,NULL),(62046,'73528','S','Chattanooga','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.423232,-98.646524,0,'2013-07-06 12:44:33',NULL,NULL),(40566,'45863','S','Middle Pt','N','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.854860,-84.447417,0,'2013-07-06 12:44:32',NULL,NULL),(51154,'58849','S','Wheelock','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.322800,-103.200900,0,'2013-07-06 12:44:33',NULL,NULL),(47635,'54915','S','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.282485,-88.412760,0,'2013-07-06 12:44:33',NULL,NULL),(41721,'47243','S','Hanover','D','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.714687,-85.472195,0,'2013-07-06 12:44:32',NULL,NULL),(50523,'58102','S','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.893312,-96.798609,0,'2013-07-06 12:44:33',NULL,NULL),(25877,'28636','S','Vashti','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.997778,-81.105556,0,'2013-07-06 12:44:31',NULL,NULL),(26284,'29020','S','Kirkland','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(65292,'77488','S','Dinsmore','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(69231,'83405','P','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.489274,-112.110220,0,'2013-07-06 12:44:34',NULL,NULL),(68394,'81152','S','Los Fuertes','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(38391,'43520','P','Farmer','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.384405,-84.628572,0,'2013-07-06 12:44:32',NULL,NULL),(66738,'78960','P','Warda','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.053576,-96.915576,0,'2013-07-06 12:44:34',NULL,NULL),(24293,'27009','S','Belews Creek','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.237061,-80.082222,0,'2013-07-06 12:44:31',NULL,NULL),(26713,'29413','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.793627,-79.929515,0,'2013-07-06 12:44:31',NULL,NULL),(37851,'42501','S','Public','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(78725,'98278','U','Whidbey Island Naval Air','A','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.281520,-122.625637,0,'2013-07-06 12:44:34',NULL,NULL),(74432,'92564','P','Murrieta','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.641779,-117.186255,0,'2013-07-06 12:44:34',NULL,NULL),(58542,'68814','S','Berwyn','A','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.329198,-99.326790,0,'2013-07-06 12:44:33',NULL,NULL),(48475,'55722','P','Coleraine','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.290086,-93.425775,0,'2013-07-06 12:44:33',NULL,NULL),(17609,'18042','S','West Easton','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(70500,'84776','P','Tropic','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.621375,-112.086482,0,'2013-07-06 12:44:34',NULL,NULL),(78979,'98374','S','South Hill','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.142030,-122.266790,0,'2013-07-06 12:44:34',NULL,NULL),(54814,'63021','S','Twin Oaks','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(2086,'00921','S','Villa El Salvador','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(20839,'21643','S','Hurlock','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.640404,-75.867217,0,'2013-07-06 12:44:31',NULL,NULL),(67130,'79754','P','Mentone','D','Loving','48301','Texas','TX','48','0000','432','Central',-6.0,'Y',31.786479,-103.629093,0,'2013-07-06 12:44:34',NULL,NULL),(20264,'20784','S','New Carrolltn','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(18994,'19522','S','Walnuttown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(12571,'13062','P','Etna','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.482285,-76.390876,0,'2013-07-06 12:44:30',NULL,NULL),(37177,'41501','S','Broad Bottom','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(8420,'08075','S','Delran','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(12830,'13309','S','Mohawk Hill','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.453080,-75.336000,0,'2013-07-06 12:44:30',NULL,NULL),(67104,'79714','S','Andrews','D','Andrews','48003','Texas','TX','48','0000','432','Central',-6.0,'Y',32.327110,-102.548597,0,'2013-07-06 12:44:34',NULL,NULL),(34782,'38865','S','Rienzi','D','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.711840,-88.659681,0,'2013-07-06 12:44:32',NULL,NULL),(41069,'46515','P','Elkhart','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.684211,-85.969529,0,'2013-07-06 12:44:32',NULL,NULL),(13080,'13460','S','Sherburne','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.680970,-75.499170,0,'2013-07-06 12:44:30',NULL,NULL),(30784,'33595','P','Valrico','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.947074,-82.258942,0,'2013-07-06 12:44:32',NULL,NULL),(56273,'65066','S','Owensville','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348543,-91.499030,0,'2013-07-06 12:44:33',NULL,NULL),(71464,'87053','S','San Ysidro','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.543280,-106.757400,0,'2013-07-06 12:44:34',NULL,NULL),(20343,'20854','S','Rockville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.028740,-77.240940,0,'2013-07-06 12:44:31',NULL,NULL),(67290,'80011','S','Buckley Air Natl Guard Base','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741650,-104.791421,0,'2013-07-06 12:44:34',NULL,NULL),(25645,'28468','S','Sunset Bch','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.884891,-78.508720,0,'2013-07-06 12:44:31',NULL,NULL),(58898,'69190','U','Oshkosh','D','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408180,-102.343473,0,'2013-07-06 12:44:33',NULL,NULL),(64693,'76845','S','Gouldbusk','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.513687,-99.531879,0,'2013-07-06 12:44:34',NULL,NULL),(44624,'50062','S','Dallas','A','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.232661,-93.237493,0,'2013-07-06 12:44:32',NULL,NULL),(44360,'49784','U','Chippewa Reg Correction Fac','N','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.258915,-84.381415,0,'2013-07-06 12:44:32',NULL,NULL),(28344,'31193','U','Wells Fargo','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761200,-84.385347,0,'2013-07-06 12:44:32',NULL,NULL),(23722,'25906','P','Piney View','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.831764,-81.121938,0,'2013-07-06 12:44:31',NULL,NULL),(15564,'16640','S','Flinton','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.706160,-78.470165,0,'2013-07-06 12:44:31',NULL,NULL),(28705,'31825','S','Richland','D','Stewart','13259','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.090514,-84.663910,0,'2013-07-06 12:44:32',NULL,NULL),(31956,'35210','S','Liberty Highlands','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(35216,'39301','S','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.372903,-88.696221,0,'2013-07-06 12:44:32',NULL,NULL),(69824,'84076','S','Tridell','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.466810,-109.813447,0,'2013-07-06 12:44:34',NULL,NULL),(39786,'45131','P','Higginsport','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.790408,-83.968405,0,'2013-07-06 12:44:32',NULL,NULL),(25851,'28624','S','Ferguson','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.156660,-81.393840,0,'2013-07-06 12:44:31',NULL,NULL),(36312,'40376','S','Natural Bridge','N','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.774455,-83.685771,0,'2013-07-06 12:44:32',NULL,NULL),(18758,'19348','S','Kennett Square','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.860730,-75.704389,0,'2013-07-06 12:44:31',NULL,NULL),(71341,'86511','P','St Michaels','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.853888,-109.299177,0,'2013-07-06 12:44:34',NULL,NULL),(36814,'41059','S','Melbourne','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.018300,-84.360480,0,'2013-07-06 12:44:32',NULL,NULL),(78314,'97910','S','Jordan Valley','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(73955,'92061','S','Pauma Valley','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.306639,-116.974166,0,'2013-07-06 12:44:34',NULL,NULL),(65141,'77385','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.185643,-95.428944,0,'2013-07-06 12:44:34',NULL,NULL),(59651,'71046','S','Keatchie','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.214950,-93.998948,0,'2013-07-06 12:44:33',NULL,NULL),(8663,'08318','S','Pittsgrove','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(28039,'30650','S','Madison','D','Morgan','13211','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.590212,-83.477409,0,'2013-07-06 12:44:31',NULL,NULL),(40596,'45883','S','St Henry','N','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.409173,-84.633077,0,'2013-07-06 12:44:32',NULL,NULL),(12696,'13141','S','Preble','D','Cortland','36023','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.738644,-76.158017,0,'2013-07-06 12:44:30',NULL,NULL),(31285,'34036','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(17101,'17768','S','Shunk','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.533107,-76.746568,0,'2013-07-06 12:44:31',NULL,NULL),(17819,'18411','S','Scott Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(16420,'17225','S','Waynecastle','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(5105,'04351','S','Manchester','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.329710,-69.870346,0,'2013-07-06 12:44:30',NULL,NULL),(26660,'29374','S','Pauline','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.773660,-81.857040,0,'2013-07-06 12:44:31',NULL,NULL),(42145,'47519','S','Cannelburg','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.697215,-86.969122,0,'2013-07-06 12:44:32',NULL,NULL),(73529,'91350','S','Mint Canyon','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(39250,'44439','P','Mesopotamia','D','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.464411,-80.950412,0,'2013-07-06 12:44:32',NULL,NULL),(25237,'28103','S','Marshville','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.992963,-80.366496,0,'2013-07-06 12:44:31',NULL,NULL),(23984,'26323','P','Anmoore','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.258261,-80.289050,0,'2013-07-06 12:44:31',NULL,NULL),(65615,'77954','S','Cuero','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(74978,'93441','P','Los Olivos','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.666706,-120.109409,0,'2013-07-06 12:44:34',NULL,NULL),(34255,'38450','S','Collinwood','D','Wayne','47181','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.150728,-87.703441,0,'2013-07-06 12:44:32',NULL,NULL),(73527,'91350','S','Bouquet Canyon','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(68242,'81055','S','La Veta','D','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.461120,-105.039180,0,'2013-07-06 12:44:34',NULL,NULL),(57562,'67047','S','Fall River','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.609772,-96.028373,0,'2013-07-06 12:44:33',NULL,NULL),(41519,'46980','P','Servia','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.955080,-85.739339,0,'2013-07-06 12:44:32',NULL,NULL),(24619,'27344','S','Silk Hope','N','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.723460,-79.425420,0,'2013-07-06 12:44:31',NULL,NULL),(20718,'21280','U','Bank of America','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.297284,-76.608955,0,'2013-07-06 12:44:31',NULL,NULL),(26889,'29568','S','Longs','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.887253,-78.749124,0,'2013-07-06 12:44:31',NULL,NULL),(7989,'07715','U','NJ Natural Gas Co','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.181879,-74.022898,0,'2013-07-06 12:44:30',NULL,NULL),(31501,'34448','S','Homosassa','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.772147,-82.591385,0,'2013-07-06 12:44:32',NULL,NULL),(32709,'36301','S','Dothan','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(15556,'16633','P','Defiance','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.161667,-78.229935,0,'2013-07-06 12:44:31',NULL,NULL),(16229,'17074','S','Walnut Grove','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(38440,'43567','S','Wauseon','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.557717,-84.152338,0,'2013-07-06 12:44:32',NULL,NULL),(17433,'17931','S','Cresmont','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779310,-76.233926,0,'2013-07-06 12:44:31',NULL,NULL),(15649,'16740','S','Westline','A','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.726583,-78.638691,0,'2013-07-06 12:44:31',NULL,NULL),(67511,'80239','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.785062,-104.824573,0,'2013-07-06 12:44:34',NULL,NULL),(71506,'87113','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.178200,-106.596684,0,'2013-07-06 12:44:34',NULL,NULL),(51229,'59063','S','Park City','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.633195,-108.912996,0,'2013-07-06 12:44:33',NULL,NULL),(4132,'02747','S','Dartmouth','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.645940,-70.997460,0,'2013-07-06 12:44:30',NULL,NULL),(60654,'71913','S','Hot Springs National','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.424690,-93.096290,0,'2013-07-06 12:44:33',NULL,NULL),(48837,'56051','S','Kiester','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.538911,-93.713440,0,'2013-07-06 12:44:33',NULL,NULL),(24405,'27109','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.122579,-80.285996,0,'2013-07-06 12:44:31',NULL,NULL),(37747,'42320','S','Render','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(31287,'34038','M','APO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(14227,'14807','S','Arkport','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.427575,-77.668725,0,'2013-07-06 12:44:31',NULL,NULL),(26564,'29209','S','Twin Lake Hill','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(26637,'29334','S','Duncan','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.914282,-82.134672,0,'2013-07-06 12:44:31',NULL,NULL),(66687,'78941','S','Praha','N','Fayette','48149','Texas','TX','48','0000','361','Central',-6.0,'Y',29.687084,-97.108065,0,'2013-07-06 12:44:34',NULL,NULL),(72778,'89595','U','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.527847,-119.782389,0,'2013-07-06 12:44:34',NULL,NULL),(26926,'29585','S','Pawleys Isl','A','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.453325,-79.135137,0,'2013-07-06 12:44:31',NULL,NULL),(74756,'93065','S','Simi Valley','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.268961,-118.769487,0,'2013-07-06 12:44:34',NULL,NULL),(73553,'91361','S','Lake Sherwood','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.152136,-118.846704,0,'2013-07-06 12:44:34',NULL,NULL),(69151,'83314','S','Mellon Valley','N','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.946860,-114.934200,0,'2013-07-06 12:44:34',NULL,NULL),(58759,'68960','S','Naponee','D','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.075142,-99.139486,0,'2013-07-06 12:44:33',NULL,NULL),(55534,'63830','S','Cottonwood Point','N','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.185729,-89.658756,0,'2013-07-06 12:44:33',NULL,NULL),(54237,'62664','S','Teheran','A','Mason','17125','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.200803,-89.695417,0,'2013-07-06 12:44:33',NULL,NULL),(34169,'38301','S','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.610381,-88.819872,0,'2013-07-06 12:44:32',NULL,NULL),(4195,'02826','P','Burrillville','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.983366,-71.627803,0,'2013-07-06 12:44:30',NULL,NULL),(6380,'05682','S','Worcester','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.408965,-72.573124,0,'2013-07-06 12:44:30',NULL,NULL),(31115,'33896','S','Champions GT','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.198079,-81.621088,0,'2013-07-06 12:44:32',NULL,NULL),(64426,'76557','S','Moody','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(6638,'06006','U','Windsor','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.854244,-72.644045,0,'2013-07-06 12:44:30',NULL,NULL),(35393,'39457','P','Mc Neill','D','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.668484,-89.638961,0,'2013-07-06 12:44:32',NULL,NULL),(55550,'63851','S','Hayti','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.235589,-89.749057,0,'2013-07-06 12:44:33',NULL,NULL),(54314,'62721','U','Ameritech','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.794416,-89.648447,0,'2013-07-06 12:44:33',NULL,NULL),(43273,'48331','S','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505080,-83.408580,0,'2013-07-06 12:44:32',NULL,NULL),(70663,'85209','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.377300,-111.659500,0,'2013-07-06 12:44:34',NULL,NULL),(71297,'86446','P','Bullhead City','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.910318,-114.546307,0,'2013-07-06 12:44:34',NULL,NULL),(72181,'88350','P','Timberon','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.835667,-105.691772,0,'2013-07-06 12:44:34',NULL,NULL),(75338,'93844','U','IRS Service Center','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.753633,-119.673434,0,'2013-07-06 12:44:34',NULL,NULL),(61289,'72404','S','Jonesboro','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.800265,-90.714862,0,'2013-07-06 12:44:33',NULL,NULL),(56427,'65262','S','Kingdom City','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.957522,-91.962837,0,'2013-07-06 12:44:33',NULL,NULL),(50926,'58564','S','St Gertrude','N','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.337217,-101.260167,0,'2013-07-06 12:44:33',NULL,NULL),(3004,'01075','S','S Hadley','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.253320,-72.579900,0,'2013-07-06 12:44:30',NULL,NULL),(20980,'21802','P','Salisbury','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.340961,-75.536031,0,'2013-07-06 12:44:31',NULL,NULL),(810,'00693','S','Urb El Rosario','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(2371,'00949','S','Repto Anamar','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(35070,'39193','P','Whitfield','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.236068,-90.070628,0,'2013-07-06 12:44:32',NULL,NULL),(36757,'41041','S','Bald Hill','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(37053,'41301','S','Gillmore','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(5690,'04974','S','Searsport','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.467583,-68.922689,0,'2013-07-06 12:44:30',NULL,NULL),(71965,'88007','S','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.323889,-106.803570,0,'2013-07-06 12:44:34',NULL,NULL),(4475,'03266','S','Dorchester','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.787467,-71.855141,0,'2013-07-06 12:44:30',NULL,NULL),(37366,'41729','S','Dolan','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.295690,-83.200168,0,'2013-07-06 12:44:32',NULL,NULL),(22753,'24421','S','Churchville','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.219303,-79.203526,0,'2013-07-06 12:44:31',NULL,NULL),(56605,'65564','S','Solo','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.164907,-91.946563,0,'2013-07-06 12:44:33',NULL,NULL),(12260,'12832','S','South Granville','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(72395,'89041','P','Pahrump','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.259020,-116.018640,0,'2013-07-06 12:44:34',NULL,NULL),(72462,'89119','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.086953,-115.137796,0,'2013-07-06 12:44:34',NULL,NULL),(75102,'93542','P','Little Lake','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',35.936934,-117.907963,0,'2013-07-06 12:44:34',NULL,NULL),(46592,'53546','S','Janesville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.670071,-88.994997,0,'2013-07-06 12:44:32',NULL,NULL),(72617,'89418','S','Apache','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(65085,'77354','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.221346,-95.676720,0,'2013-07-06 12:44:34',NULL,NULL),(62892,'75061','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.824483,-96.953242,0,'2013-07-06 12:44:33',NULL,NULL),(67807,'80742','S','New Raymer','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.643775,-103.873642,0,'2013-07-06 12:44:34',NULL,NULL),(68557,'81432','S','Ridgway','D','Ouray','08091','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.158922,-107.749219,0,'2013-07-06 12:44:34',NULL,NULL),(73283,'90746','S','Long Beach','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.860506,-118.255622,0,'2013-07-06 12:44:34',NULL,NULL),(7609,'07050','S','Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.770499,-74.237810,0,'2013-07-06 12:44:30',NULL,NULL),(66446,'78651','P','Mc Neil','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.452693,-97.723155,0,'2013-07-06 12:44:34',NULL,NULL),(48641,'55814','P','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.841316,-92.216319,0,'2013-07-06 12:44:33',NULL,NULL),(68343,'81128','P','Chromo','D','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.038716,-106.843999,0,'2013-07-06 12:44:34',NULL,NULL),(71485,'87072','P','Cochiti Pueblo','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.609104,-106.344513,0,'2013-07-06 12:44:34',NULL,NULL),(647,'00682','S','Urb Quinto Centenario','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(17447,'17938','S','Hegins','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.655278,-76.446944,0,'2013-07-06 12:44:31',NULL,NULL),(8187,'07890','U','Selected Risks Insurance Co','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.144891,-74.752093,0,'2013-07-06 12:44:30',NULL,NULL),(6670,'06031','S','South Canaan','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.963160,-73.316160,0,'2013-07-06 12:44:30',NULL,NULL),(64364,'76524','S','Dot','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.335720,-97.277820,0,'2013-07-06 12:44:34',NULL,NULL),(49125,'56360','S','Osakis','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.869297,-95.165575,0,'2013-07-06 12:44:33',NULL,NULL),(33547,'37397','S','Powells Crossroads','A','Sequatchie','47153','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.198597,-85.514246,0,'2013-07-06 12:44:32',NULL,NULL),(39643,'44905','S','Cool Ridge Heights','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.775298,-82.476807,0,'2013-07-06 12:44:32',NULL,NULL),(37508,'42036','S','Dexter','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.698534,-88.166659,0,'2013-07-06 12:44:32',NULL,NULL),(43053,'48184','S','Wayne','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.275455,-83.382717,0,'2013-07-06 12:44:32',NULL,NULL),(45920,'52326','S','Quasqueton','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.395085,-91.756488,0,'2013-07-06 12:44:32',NULL,NULL),(51995,'60162','S','Hillside','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.874464,-87.898242,0,'2013-07-06 12:44:33',NULL,NULL),(54919,'63090','S','Washington','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.546118,-91.015131,0,'2013-07-06 12:44:33',NULL,NULL),(65666,'77979','S','Weedhaven','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(2932,'01026','S','Cummington','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.427860,-72.900300,0,'2013-07-06 12:44:30',NULL,NULL),(27271,'29940','S','Coosaw','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.522450,-80.745942,0,'2013-07-06 12:44:31',NULL,NULL),(70593,'85086','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.846680,-112.093223,0,'2013-07-06 12:44:34',NULL,NULL),(73731,'91701','S','Rancho Cucamonga','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.155540,-117.589740,0,'2013-07-06 12:44:34',NULL,NULL),(77172,'96271','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(61962,'73173','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.339186,-97.618675,0,'2013-07-06 12:44:33',NULL,NULL),(48039,'55307','S','Arlington','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.604877,-94.078182,0,'2013-07-06 12:44:33',NULL,NULL),(57481,'66873','S','Wilsey','D','Morris','20127','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.654363,-96.693462,0,'2013-07-06 12:44:33',NULL,NULL),(42704,'47996','P','W Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.443842,-86.911409,0,'2013-07-06 12:44:32',NULL,NULL),(1841,'00784','S','Villa Rosa','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(20426,'20913','P','Silver Spring','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.981883,-77.003878,0,'2013-07-06 12:44:31',NULL,NULL),(19308,'20008','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.935762,-77.059427,0,'2013-07-06 12:44:31',NULL,NULL),(19280,'19967','S','Millville','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.565806,-75.113837,0,'2013-07-06 12:44:31',NULL,NULL),(43324,'48360','S','Orion Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.766320,-83.278020,0,'2013-07-06 12:44:32',NULL,NULL),(29438,'32693','S','Fanning Spgs','A','Gilchrist','12041','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.613522,-82.814668,0,'2013-07-06 12:44:32',NULL,NULL),(29402,'32631','S','Earleton','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.759280,-82.122210,0,'2013-07-06 12:44:32',NULL,NULL),(23158,'25011','P','Bancroft','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.330954,-81.604553,0,'2013-07-06 12:44:31',NULL,NULL),(11105,'11701','S','Amity Harbor','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.686293,-73.412179,0,'2013-07-06 12:44:30',NULL,NULL),(5276,'04497','S','Bancroft','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(8929,'08751','S','Pelican Island','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.937620,-74.080080,0,'2013-07-06 12:44:30',NULL,NULL),(46224,'52772','S','Tipton','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.788260,-91.131240,0,'2013-07-06 12:44:32',NULL,NULL),(48028,'55303','S','Nowthen','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.261223,-93.440539,0,'2013-07-06 12:44:33',NULL,NULL),(48499,'55735','S','Wagner','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.217584,-92.953356,0,'2013-07-06 12:44:33',NULL,NULL),(51158,'58854','S','Watford City','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.802475,-103.279579,0,'2013-07-06 12:44:33',NULL,NULL),(51785,'60044','S','Lake Bluff','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.286331,-87.857964,0,'2013-07-06 12:44:33',NULL,NULL),(55621,'63965','S','Chicopee','N','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(58107,'68117','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.206624,-95.999613,0,'2013-07-06 12:44:33',NULL,NULL),(65570,'77853','S','Dime Box','D','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.170413,-96.979700,0,'2013-07-06 12:44:34',NULL,NULL),(71495,'87107','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(72442,'89101','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.174960,-115.123394,0,'2013-07-06 12:44:34',NULL,NULL),(75266,'93675','S','Orange Cove','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.624444,-119.312778,0,'2013-07-06 12:44:34',NULL,NULL),(65047,'77334','P','Dodge','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.744321,-95.396593,0,'2013-07-06 12:44:34',NULL,NULL),(3960,'02481','S','Wellesley','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.316214,-71.265402,0,'2013-07-06 12:44:30',NULL,NULL),(39454,'44705','S','N E Waterworks','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.822094,-81.338111,0,'2013-07-06 12:44:32',NULL,NULL),(77556,'96860','S','Pearl Harbor Naval Base','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.353536,-157.966185,0,'2013-07-06 12:44:34',NULL,NULL),(45274,'50674','S','Buckcreek','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.849990,-92.100951,0,'2013-07-06 12:44:32',NULL,NULL),(39835,'45157','S','New Richmond','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.955180,-84.219600,0,'2013-07-06 12:44:32',NULL,NULL),(44380,'49797','P','Waters','D','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.868270,-84.670040,0,'2013-07-06 12:44:32',NULL,NULL),(40718,'46120','S','Cloverdale','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.512820,-86.819220,0,'2013-07-06 12:44:32',NULL,NULL),(39679,'45015','S','Indian Spgs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.367572,-84.550446,0,'2013-07-06 12:44:32',NULL,NULL),(37532,'42051','S','Hickory','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(35361,'39440','S','Powers','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(20238,'20779','S','Tracys Landing','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.770043,-76.577860,0,'2013-07-06 12:44:31',NULL,NULL),(49257,'56475','S','Randall','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.064416,-94.520309,0,'2013-07-06 12:44:33',NULL,NULL),(53602,'62078','P','Patterson','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.482705,-90.481614,0,'2013-07-06 12:44:33',NULL,NULL),(55181,'63373','S','Prtg de Souix','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.924848,-90.364053,0,'2013-07-06 12:44:33',NULL,NULL),(65952,'78266','S','Garden Ridge','A','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.630375,-98.305497,0,'2013-07-06 12:44:34',NULL,NULL),(68107,'80946','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.847888,-104.824771,0,'2013-07-06 12:44:34',NULL,NULL),(71955,'88001','S','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.317522,-106.743509,0,'2013-07-06 12:44:34',NULL,NULL),(40760,'46148','S','Ogden','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.794447,-85.525839,0,'2013-07-06 12:44:32',NULL,NULL),(50778,'58426','S','Courtenay','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.221503,-98.566893,0,'2013-07-06 12:44:33',NULL,NULL),(50711,'58367','S','Rolla','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.867168,-99.613739,0,'2013-07-06 12:44:33',NULL,NULL),(5532,'04780','S','Smyrna Mills','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.166860,-68.269882,0,'2013-07-06 12:44:30',NULL,NULL),(77003,'96080','S','Dairyville','N','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.177299,-122.263016,0,'2013-07-06 12:44:34',NULL,NULL),(77722,'97063','S','Wamic','A','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.236580,-121.322820,0,'2013-07-06 12:44:34',NULL,NULL),(12743,'13201','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040920,-76.152640,0,'2013-07-06 12:44:30',NULL,NULL),(76081,'95211','U','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.982119,-121.309791,0,'2013-07-06 12:44:34',NULL,NULL),(32188,'35504','S','Jasper','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.890976,-87.194044,0,'2013-07-06 12:44:32',NULL,NULL),(36360,'40447','S','Hisle','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(20281,'20791','P','Capitol Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.817650,-76.943769,0,'2013-07-06 12:44:31',NULL,NULL),(42447,'47805','S','Spelterville','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(40873,'46237','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.656220,-86.100300,0,'2013-07-06 12:44:32',NULL,NULL),(4855,'04017','S','Chebeague Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.733941,-70.127652,0,'2013-07-06 12:44:30',NULL,NULL),(36837,'41073','S','Fort Thomas','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.101923,-84.482010,0,'2013-07-06 12:44:32',NULL,NULL),(15151,'15864','S','Summerville','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.089924,-79.171113,0,'2013-07-06 12:44:31',NULL,NULL),(14732,'15289','U','Carnegie Mellon Univ','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.438309,-79.997452,0,'2013-07-06 12:44:31',NULL,NULL),(25381,'28258','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.223001,-80.930365,0,'2013-07-06 12:44:31',NULL,NULL),(24912,'27801','S','Dortches','N','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.954100,-77.751840,0,'2013-07-06 12:44:31',NULL,NULL),(51742,'60015','S','Deerfield','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.172896,-87.878422,0,'2013-07-06 12:44:33',NULL,NULL),(66827,'79097','S','White Deer','D','Carson','48065','Texas','TX','48','0000','806','Central',-6.0,'Y',35.431497,-101.175997,0,'2013-07-06 12:44:34',NULL,NULL),(67037,'79544','S','Rochester','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.301989,-99.846699,0,'2013-07-06 12:44:34',NULL,NULL),(68111,'80947','U','Co Spgs Utilities','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832634,-104.819249,0,'2013-07-06 12:44:34',NULL,NULL),(73581,'91381','S','Stevenson Rnh','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.381783,-118.573262,0,'2013-07-06 12:44:34',NULL,NULL),(48211,'55410','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.913077,-93.319293,0,'2013-07-06 12:44:33',NULL,NULL),(6358,'05675','S','Washgtin','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(67376,'80121','S','Cherry Hills','N','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(74584,'92694','S','Ladera Ranch','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.555120,-117.666532,0,'2013-07-06 12:44:34',NULL,NULL),(19822,'20463','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898581,-77.024538,0,'2013-07-06 12:44:31',NULL,NULL),(72454,'89112','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.115583,-115.015105,0,'2013-07-06 12:44:34',NULL,NULL),(35705,'39666','S','Summit','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(5233,'04468','S','Indian Island','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.930939,-68.654151,0,'2013-07-06 12:44:30',NULL,NULL),(44149,'49523','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.965240,-85.672993,0,'2013-07-06 12:44:32',NULL,NULL),(39959,'45236','S','Kenwood','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(19908,'20547','U','Us Information Agency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885247,-77.014601,0,'2013-07-06 12:44:31',NULL,NULL),(46911,'54136','S','Kimberly','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.269942,-88.340690,0,'2013-07-06 12:44:32',NULL,NULL),(61013,'72114','S','Veterans Admin. Fac.','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(63642,'75844','S','Mound City','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(72833,'89830','P','Montello','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.261351,-114.190320,0,'2013-07-06 12:44:34',NULL,NULL),(633,'00682','S','Urb Buenaventura','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(56133,'64836','S','Fidelity','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.168290,-94.314586,0,'2013-07-06 12:44:33',NULL,NULL),(51250,'59076','S','Sanders','D','Treasure','30103','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.292117,-107.095156,0,'2013-07-06 12:44:33',NULL,NULL),(33965,'38107','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.168302,-90.028300,0,'2013-07-06 12:44:32',NULL,NULL),(23226,'25083','S','Standard','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(43715,'48913','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.677493,-84.665847,0,'2013-07-06 12:44:32',NULL,NULL),(7314,'06673','U','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.184273,-73.148138,0,'2013-07-06 12:44:30',NULL,NULL),(18953,'19511','P','Bowers','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.518810,-75.774350,0,'2013-07-06 12:44:31',NULL,NULL),(60435,'71646','S','Gulledge','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(57169,'66285','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.016846,-94.663276,0,'2013-07-06 12:44:33',NULL,NULL),(58823,'69040','S','Hamlet','A','Hitchcock','31087','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.293079,-101.075084,0,'2013-07-06 12:44:33',NULL,NULL),(70334,'84629','S','Oak Creek','N','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(69616,'83865','P','Colburn','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.399606,-116.537553,0,'2013-07-06 12:44:34',NULL,NULL),(63267,'75501','S','S Texarkana','A','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.424489,-94.102297,0,'2013-07-06 12:44:33',NULL,NULL),(37750,'42321','S','Beech Creek','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.182281,-87.120566,0,'2013-07-06 12:44:32',NULL,NULL),(16574,'17319','S','Goldsboro','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.152317,-76.794239,0,'2013-07-06 12:44:31',NULL,NULL),(14891,'15485','P','Ursina','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.815167,-79.333622,0,'2013-07-06 12:44:31',NULL,NULL),(75845,'94926','U','Rohnert Park','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.326476,-122.712308,0,'2013-07-06 12:44:34',NULL,NULL),(28184,'31009','S','Cadwell','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.337992,-83.042533,0,'2013-07-06 12:44:31',NULL,NULL),(41071,'46517','S','Concord','N','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.622360,-85.983780,0,'2013-07-06 12:44:32',NULL,NULL),(14242,'14818','S','Burdett','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.437057,-76.828291,0,'2013-07-06 12:44:31',NULL,NULL),(34076,'38150','U','Suntrust Bank','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.147314,-90.048201,0,'2013-07-06 12:44:32',NULL,NULL),(65740,'78055','S','Medina','D','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.938918,-99.226717,0,'2013-07-06 12:44:34',NULL,NULL),(21852,'23139','S','Powhatano','N','Powhatan','51145','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544219,-77.877814,0,'2013-07-06 12:44:31',NULL,NULL),(58130,'68137','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.206074,-96.122007,0,'2013-07-06 12:44:33',NULL,NULL),(33139,'36910','S','Jachin','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.240990,-88.223446,0,'2013-07-06 12:44:32',NULL,NULL),(30498,'33394','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.121148,-80.139899,0,'2013-07-06 12:44:32',NULL,NULL),(38696,'44001','S','Henrietta','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(59676,'71063','S','Pelican','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.888361,-93.556746,0,'2013-07-06 12:44:33',NULL,NULL),(78796,'98322','P','Burley','D','Kitsap','53035','Washington','WA','53','1150','253/564','Pacific',-8.0,'Y',47.412292,-122.629833,0,'2013-07-06 12:44:34',NULL,NULL),(65502,'77662','S','Vidor','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.145872,-94.010918,0,'2013-07-06 12:44:34',NULL,NULL),(60870,'72058','S','Pleasant Valley','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(58505,'68769','S','Plainview','D','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.353090,-97.783657,0,'2013-07-06 12:44:33',NULL,NULL),(56875,'66021','S','Edgerton','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.769465,-95.000783,0,'2013-07-06 12:44:33',NULL,NULL),(27307,'30016','S','Porterdale','A','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.530099,-83.944327,0,'2013-07-06 12:44:31',NULL,NULL),(36497,'40815','S','Three Point','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751998,-83.268360,0,'2013-07-06 12:44:32',NULL,NULL),(12476,'12985','S','Swastika','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.578980,-73.716120,0,'2013-07-06 12:44:30',NULL,NULL),(20914,'21723','S','Cooksville','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.320349,-77.008735,0,'2013-07-06 12:44:31',NULL,NULL),(44252,'49676','S','Rapid City','D','Kalkaska','26079','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.821793,-85.263782,0,'2013-07-06 12:44:32',NULL,NULL),(6784,'06105','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.769774,-72.699048,0,'2013-07-06 12:44:30',NULL,NULL),(50396,'57770','S','Calico','N','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.232220,-102.696720,0,'2013-07-06 12:44:33',NULL,NULL),(36817,'41062','P','Minerva','D','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.703777,-83.917172,0,'2013-07-06 12:44:32',NULL,NULL),(12975,'13368','S','Goulds Mill','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.630920,-75.348480,0,'2013-07-06 12:44:30',NULL,NULL),(5935,'05255','S','Manchester Center','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.194892,-73.065620,0,'2013-07-06 12:44:30',NULL,NULL),(74436,'92570','S','Lake Mathews','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.783592,-117.339362,0,'2013-07-06 12:44:34',NULL,NULL),(67782,'80654','S','Hoyt','A','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.157963,-104.074736,0,'2013-07-06 12:44:34',NULL,NULL),(3349,'01560','S','South Grafton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.177849,-71.693325,0,'2013-07-06 12:44:30',NULL,NULL),(10111,'10257','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712067,-74.003313,0,'2013-07-06 12:44:30',NULL,NULL),(61351,'72474','P','Walcott','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.044624,-90.672594,0,'2013-07-06 12:44:33',NULL,NULL),(27003,'29634','U','Clemson','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.673146,-82.823962,0,'2013-07-06 12:44:31',NULL,NULL),(71560,'87197','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.118513,-106.642871,0,'2013-07-06 12:44:34',NULL,NULL),(14731,'15286','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.458733,-80.031221,0,'2013-07-06 12:44:31',NULL,NULL),(69555,'83813','S','Cocolalla','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.114657,-116.651538,0,'2013-07-06 12:44:34',NULL,NULL),(68533,'81413','S','Grand Mesa','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.957100,-107.913960,0,'2013-07-06 12:44:34',NULL,NULL),(57192,'66419','S','Denison','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.461982,-95.742722,0,'2013-07-06 12:44:33',NULL,NULL),(12590,'13073','S','West Groton','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.585725,-76.393025,0,'2013-07-06 12:44:30',NULL,NULL),(32816,'36454','S','Lenox','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.324078,-87.197115,0,'2013-07-06 12:44:32',NULL,NULL),(34246,'38390','S','Yuma','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.865184,-88.379591,0,'2013-07-06 12:44:32',NULL,NULL),(37763,'42337','S','Drakesboro','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.215647,-87.049887,0,'2013-07-06 12:44:32',NULL,NULL),(19769,'20420','U','Veterans Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902553,-77.028688,0,'2013-07-06 12:44:31',NULL,NULL),(6136,'05462','S','Huntington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.310720,-73.003500,0,'2013-07-06 12:44:30',NULL,NULL),(44587,'50039','S','Gardiner','N','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.852588,-94.006979,0,'2013-07-06 12:44:32',NULL,NULL),(9465,'10008','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(13172,'13613','S','Brasher Falls','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.860326,-74.725235,0,'2013-07-06 12:44:30',NULL,NULL),(25886,'28642','S','Arlington','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.236940,-80.782320,0,'2013-07-06 12:44:31',NULL,NULL),(21203,'22194','P','Woodbridge','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.634959,-77.259815,0,'2013-07-06 12:44:31',NULL,NULL),(14533,'15207','S','Hazelwood','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403820,-79.926060,0,'2013-07-06 12:44:31',NULL,NULL),(78440,'98057','S','Renton','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.485383,-122.197551,0,'2013-07-06 12:44:34',NULL,NULL),(76903,'95984','P','Virgilia','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.043280,-121.112580,0,'2013-07-06 12:44:34',NULL,NULL),(74993,'93449','S','Shell Beach','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.158200,-120.655200,0,'2013-07-06 12:44:34',NULL,NULL),(53172,'61571','S','Washington','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.694863,-89.479364,0,'2013-07-06 12:44:33',NULL,NULL),(45182,'50611','S','Bristow','D','Butler','19023','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.774055,-92.905640,0,'2013-07-06 12:44:32',NULL,NULL),(10623,'11050','S','Pt Wash','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(14177,'14742','P','Greenhurst','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.120268,-79.305125,0,'2013-07-06 12:44:31',NULL,NULL),(35402,'39462','S','Mahned','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.291608,-89.067446,0,'2013-07-06 12:44:32',NULL,NULL),(53355,'61764','S','Ocoya','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(77449,'96810','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304604,-157.858316,0,'2013-07-06 12:44:34',NULL,NULL),(74470,'92602','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.741875,-117.746704,0,'2013-07-06 12:44:34',NULL,NULL),(64106,'76180','S','Fort Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(57894,'67642','S','Hill City','D','Graham','20065','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.364762,-99.843675,0,'2013-07-06 12:44:33',NULL,NULL),(54876,'63055','S','Labadie','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.521470,-90.835673,0,'2013-07-06 12:44:33',NULL,NULL),(52612,'61028','S','Woodbine','N','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.309202,-90.187779,0,'2013-07-06 12:44:33',NULL,NULL),(45112,'50557','S','Lehigh','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.470182,-93.987054,0,'2013-07-06 12:44:32',NULL,NULL),(35186,'39283','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.367889,-90.231119,0,'2013-07-06 12:44:32',NULL,NULL),(32595,'36131','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.379353,-86.298504,0,'2013-07-06 12:44:32',NULL,NULL),(40865,'46230','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.866751,-86.109147,0,'2013-07-06 12:44:32',NULL,NULL),(41824,'47339','S','Economy','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.965896,-85.092842,0,'2013-07-06 12:44:32',NULL,NULL),(4970,'04109','S','Cushing Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(78873,'98352','U','REI','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164325,-122.242368,0,'2013-07-06 12:44:34',NULL,NULL),(50493,'58057','S','McLeod','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.506063,-97.187561,0,'2013-07-06 12:44:33',NULL,NULL),(33006,'36663','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.762053,-88.128625,0,'2013-07-06 12:44:32',NULL,NULL),(38144,'43140','S','London','D','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.891060,-83.405340,0,'2013-07-06 12:44:32',NULL,NULL),(51343,'59316','S','Boyes','D','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.507523,-104.910869,0,'2013-07-06 12:44:33',NULL,NULL),(25128,'28006','S','Alexis','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.395071,-81.113297,0,'2013-07-06 12:44:31',NULL,NULL),(39927,'45224','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.201250,-84.531566,0,'2013-07-06 12:44:32',NULL,NULL),(63940,'76071','S','Newark','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.009770,-97.536559,0,'2013-07-06 12:44:34',NULL,NULL),(61725,'73019','U','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.207241,-97.446305,0,'2013-07-06 12:44:33',NULL,NULL),(52810,'61281','S','Boden','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.312272,-90.493734,0,'2013-07-06 12:44:33',NULL,NULL),(11893,'12345','U','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.815656,-73.942324,0,'2013-07-06 12:44:30',NULL,NULL),(79392,'98801','S','Grant Road Addition','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(77838,'97220','S','Maywood Pk','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.543396,-122.553975,0,'2013-07-06 12:44:34',NULL,NULL),(64371,'76528','S','Ater','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(58445,'68715','S','Battle Creek','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.999323,-97.599609,0,'2013-07-06 12:44:33',NULL,NULL),(55494,'63771','S','Oran','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.085317,-89.648175,0,'2013-07-06 12:44:33',NULL,NULL),(52635,'61049','S','Lindenwood','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.049974,-89.024262,0,'2013-07-06 12:44:33',NULL,NULL),(46997,'54240','P','Tisch Mills','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.327519,-87.623779,0,'2013-07-06 12:44:32',NULL,NULL),(45986,'52498','U','Rockwell Collins','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.021791,-91.661092,0,'2013-07-06 12:44:32',NULL,NULL),(27958,'30548','S','Hoschton','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.068356,-83.870870,0,'2013-07-06 12:44:31',NULL,NULL),(25107,'27972','P','Salvo','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.548722,-75.468151,0,'2013-07-06 12:44:31',NULL,NULL),(24663,'27406','S','Spring Valley','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.021374,-79.767916,0,'2013-07-06 12:44:31',NULL,NULL),(38317,'43403','U','Bowling Green State Univ','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.376437,-83.650803,0,'2013-07-06 12:44:32',NULL,NULL),(21429,'22554','S','Stafford','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.460218,-77.437061,0,'2013-07-06 12:44:31',NULL,NULL),(42212,'47553','S','Rutherford','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(4853,'04015','S','Casco','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.987101,-70.539816,0,'2013-07-06 12:44:30',NULL,NULL),(37810,'42408','S','Charleston','N','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.189860,-87.687240,0,'2013-07-06 12:44:32',NULL,NULL),(14994,'15656','S','N Leechburg','A','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.629851,-79.604848,0,'2013-07-06 12:44:31',NULL,NULL),(18931,'19504','S','Schultzville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(59160,'70301','S','Thibodaux','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.803218,-90.813933,0,'2013-07-06 12:44:33',NULL,NULL),(4699,'03813','S','South Chatham','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.163170,-71.012330,0,'2013-07-06 12:44:30',NULL,NULL),(52129,'60431','S','Shorewood','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.523431,-88.158761,0,'2013-07-06 12:44:33',NULL,NULL),(10275,'10511','S','Buchanan','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.258401,-73.939031,0,'2013-07-06 12:44:30',NULL,NULL),(20671,'21229','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.284902,-76.689882,0,'2013-07-06 12:44:31',NULL,NULL),(44095,'49463','P','Wabaningo','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.370564,-86.423252,0,'2013-07-06 12:44:32',NULL,NULL),(71064,'85756','S','Tuscon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.136236,-111.085365,0,'2013-07-06 12:44:34',NULL,NULL),(23094,'24927','S','Cass','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.364167,-79.962500,0,'2013-07-06 12:44:31',NULL,NULL),(16066,'17048','S','Specktown','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.595220,-76.713900,0,'2013-07-06 12:44:31',NULL,NULL),(9369,'09827','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30329,'33308','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(42661,'47952','S','Tangier','A','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.017300,-87.285120,0,'2013-07-06 12:44:32',NULL,NULL),(27987,'30576','S','Tiger','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.801334,-83.450139,0,'2013-07-06 12:44:31',NULL,NULL),(59147,'70178','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944263,-90.122770,0,'2013-07-06 12:44:33',NULL,NULL),(71214,'86315','S','Prescott Valley','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',34.537845,-112.469326,0,'2013-07-06 12:44:34',NULL,NULL),(67155,'79785','P','Toyah','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.313466,-103.792586,0,'2013-07-06 12:44:34',NULL,NULL),(40933,'46285','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.743009,-86.162811,0,'2013-07-06 12:44:32',NULL,NULL),(40165,'45363','S','Russia','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.240468,-84.403292,0,'2013-07-06 12:44:32',NULL,NULL),(58226,'68345','S','Du Bois','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.041000,-96.058080,0,'2013-07-06 12:44:33',NULL,NULL),(20208,'20759','S','Fulton','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.152829,-76.931318,0,'2013-07-06 12:44:31',NULL,NULL),(79666,'99158','S','Oakesdale','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.131686,-117.244287,0,'2013-07-06 12:44:34',NULL,NULL),(72763,'89519','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.498928,-119.745485,0,'2013-07-06 12:44:34',NULL,NULL),(68008,'80922','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.898824,-104.700007,0,'2013-07-06 12:44:34',NULL,NULL),(52767,'61257','S','Hillsdale','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.596080,-90.230700,0,'2013-07-06 12:44:33',NULL,NULL),(50444,'58011','S','Buffalo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.933102,-97.490429,0,'2013-07-06 12:44:33',NULL,NULL),(48064,'55327','S','Dayton','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.202456,-93.468790,0,'2013-07-06 12:44:33',NULL,NULL),(12874,'13325','S','Constablevle','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.577189,-75.564678,0,'2013-07-06 12:44:30',NULL,NULL),(22479,'24055','S','Sanville','N','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.751969,-79.987513,0,'2013-07-06 12:44:31',NULL,NULL),(30613,'33431','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.384367,-80.099535,0,'2013-07-06 12:44:32',NULL,NULL),(7012,'06259','S','Pomfret Landing','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.876521,-72.011578,0,'2013-07-06 12:44:30',NULL,NULL),(31637,'34715','S','Clermont','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.592359,-81.799392,0,'2013-07-06 12:44:32',NULL,NULL),(37323,'41653','S','Dock','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(4729,'03827','S','South Hampton','A','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.911422,-70.983388,0,'2013-07-06 12:44:30',NULL,NULL),(47125,'54452','S','Harding','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.182325,-89.694701,0,'2013-07-06 12:44:32',NULL,NULL),(46301,'53058','S','Nashotah','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.112049,-88.405116,0,'2013-07-06 12:44:32',NULL,NULL),(55834,'64153','S','Wthrby Lake','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.273370,-94.691489,0,'2013-07-06 12:44:33',NULL,NULL),(74605,'92707','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.696780,-117.870120,0,'2013-07-06 12:44:34',NULL,NULL),(75704,'94570','P','Moraga','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.115617,-122.140088,0,'2013-07-06 12:44:34',NULL,NULL),(5209,'04457','S','Lincoln Cntr','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(78060,'97455','S','Pleasant Hill','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.970221,-122.916439,0,'2013-07-06 12:44:34',NULL,NULL),(67990,'80918','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.915062,-104.773227,0,'2013-07-06 12:44:34',NULL,NULL),(61456,'72619','S','Bull Shoals','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.382828,-92.579818,0,'2013-07-06 12:44:33',NULL,NULL),(50321,'57724','S','Sky Ranch','A','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.615420,-103.933080,0,'2013-07-06 12:44:33',NULL,NULL),(45723,'52075','P','Springbrook','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.166719,-90.491550,0,'2013-07-06 12:44:32',NULL,NULL),(20986,'21811','S','Ocean Pnes','A','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.310240,-75.234480,0,'2013-07-06 12:44:31',NULL,NULL),(8941,'08756','P','Toms River','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.946246,-74.252466,0,'2013-07-06 12:44:30',NULL,NULL),(26966,'29611','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.854896,-82.448532,0,'2013-07-06 12:44:31',NULL,NULL),(873,'00698','S','Villa Olimpia','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(33623,'37663','S','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.460654,-82.484579,0,'2013-07-06 12:44:32',NULL,NULL),(18235,'18972','S','Uppr Blck Edy','A','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.538872,-75.126125,0,'2013-07-06 12:44:31',NULL,NULL),(18008,'18636','S','Noxen','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.418188,-76.075214,0,'2013-07-06 12:44:31',NULL,NULL),(26022,'28677','S','Statesville','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(12789,'13219','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040139,-76.217020,0,'2013-07-06 12:44:30',NULL,NULL),(68772,'82322','P','Bairoil','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.238410,-107.560162,0,'2013-07-06 12:44:34',NULL,NULL),(69400,'83617','S','Montour','A','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.896900,-116.502780,0,'2013-07-06 12:44:34',NULL,NULL),(49981,'57362','S','Miller','D','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.522526,-98.983752,0,'2013-07-06 12:44:33',NULL,NULL),(486,'00670','S','Jard de las Marias','N','Las Marias','72083','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.296381,-67.146608,0,'2013-07-06 12:44:30',NULL,NULL),(57324,'66711','S','Coalvale','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.625557,-94.701799,0,'2013-07-06 12:44:33',NULL,NULL),(52678,'61080','S','Beloit','N','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.477180,-88.971660,0,'2013-07-06 12:44:33',NULL,NULL),(24216,'26710','S','Medley','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.365881,-78.911270,0,'2013-07-06 12:44:31',NULL,NULL),(67332,'80042','P','Aurora','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.739084,-104.809365,0,'2013-07-06 12:44:34',NULL,NULL),(36907,'41132','S','Denton','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.287351,-82.822444,0,'2013-07-06 12:44:32',NULL,NULL),(70733,'85304','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.593730,-112.176099,0,'2013-07-06 12:44:34',NULL,NULL),(67192,'79903','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.784330,-106.445689,0,'2013-07-06 12:44:34',NULL,NULL),(52314,'60552','S','Somonauk','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.651699,-88.677362,0,'2013-07-06 12:44:33',NULL,NULL),(51798,'60047','S','Echo Lake','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(46261,'53017','S','Colgate','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.204933,-88.243200,0,'2013-07-06 12:44:32',NULL,NULL),(10884,'11421','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.692189,-73.856141,0,'2013-07-06 12:44:30',NULL,NULL),(24116,'26537','S','Kingwood','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.471602,-79.684322,0,'2013-07-06 12:44:31',NULL,NULL),(4005,'02543','S','Woodshole','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.526561,-70.667528,0,'2013-07-06 12:44:30',NULL,NULL),(5762,'05042','S','East Ryegate','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270278,-72.144444,0,'2013-07-06 12:44:30',NULL,NULL),(4742,'03837','S','Gilmanton Iw','A','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.431240,-71.299440,0,'2013-07-06 12:44:30',NULL,NULL),(13753,'14120','S','Wheatfield','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.071240,-78.814140,0,'2013-07-06 12:44:31',NULL,NULL),(70047,'84138','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.752433,-111.880834,0,'2013-07-06 12:44:34',NULL,NULL),(41302,'46766','S','Liberty Ctr','A','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.707359,-85.290083,0,'2013-07-06 12:44:32',NULL,NULL),(48192,'55392','P','Navarre','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.954900,-93.541055,0,'2013-07-06 12:44:33',NULL,NULL),(58303,'68429','S','Reynolds','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.046208,-97.312464,0,'2013-07-06 12:44:33',NULL,NULL),(57433,'66783','S','Rose','N','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.881629,-95.728588,0,'2013-07-06 12:44:33',NULL,NULL),(44037,'49422','P','Holland','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.786809,-86.109131,0,'2013-07-06 12:44:32',NULL,NULL),(69501,'83709','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.574795,-116.289166,0,'2013-07-06 12:44:34',NULL,NULL),(64698,'76852','S','Pear Valley','A','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.340312,-99.380947,0,'2013-07-06 12:44:34',NULL,NULL),(63535,'75758','S','Chandler','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.241628,-95.532762,0,'2013-07-06 12:44:33',NULL,NULL),(43059,'48188','S','Canton Twp','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.288869,-83.477501,0,'2013-07-06 12:44:32',NULL,NULL),(12996,'13410','P','Nelliston','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.932952,-74.608756,0,'2013-07-06 12:44:30',NULL,NULL),(27675,'30331','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.712646,-84.532291,0,'2013-07-06 12:44:31',NULL,NULL),(7347,'06723','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.557069,-73.036745,0,'2013-07-06 12:44:30',NULL,NULL),(32861,'36512','P','Bucks','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.089663,-88.045174,0,'2013-07-06 12:44:32',NULL,NULL),(1005,'00717','S','Urb Patio Laboy','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(20832,'21635','S','Galena','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.335931,-75.867837,0,'2013-07-06 12:44:31',NULL,NULL),(72531,'89164','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.127669,-115.277477,0,'2013-07-06 12:44:34',NULL,NULL),(63893,'76019','U','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.728201,-97.112604,0,'2013-07-06 12:44:34',NULL,NULL),(31150,'33912','S','S Fort Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.509195,-81.832204,0,'2013-07-06 12:44:32',NULL,NULL),(64801,'77021','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.698994,-95.355219,0,'2013-07-06 12:44:34',NULL,NULL),(24541,'27292','S','Gordontown','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(4409,'03223','S','Thornton','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.876228,-71.679742,0,'2013-07-06 12:44:30',NULL,NULL),(12673,'13126','S','Furniss','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(14728,'15283','U','AT & T','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.422089,-80.046367,0,'2013-07-06 12:44:31',NULL,NULL),(66876,'79227','S','Crowell','D','Foard','48155','Texas','TX','48','0000','254','Central',-6.0,'Y',33.988449,-99.725128,0,'2013-07-06 12:44:34',NULL,NULL),(78455,'98068','P','Hyak','N','Kittitas','53037','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.412300,-121.418723,0,'2013-07-06 12:44:34',NULL,NULL),(56485,'65329','S','Florence','D','Morgan','29141','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.610140,-92.998452,0,'2013-07-06 12:44:33',NULL,NULL),(75343,'93905','S','Alisal','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.680613,-121.618316,0,'2013-07-06 12:44:34',NULL,NULL),(61157,'72176','S','Ward','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.018174,-91.946490,0,'2013-07-06 12:44:33',NULL,NULL),(49543,'56684','S','Trail','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.766120,-95.763420,0,'2013-07-06 12:44:33',NULL,NULL),(49034,'56281','S','Prinsburg','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.949845,-95.177085,0,'2013-07-06 12:44:33',NULL,NULL),(42311,'47610','S','Chandler','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.036425,-87.376602,0,'2013-07-06 12:44:32',NULL,NULL),(25885,'28641','P','Jonas Ridge','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.884283,-81.739742,0,'2013-07-06 12:44:31',NULL,NULL),(30334,'33309','S','Laud Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(13966,'14471','S','Honeoye','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.761985,-77.496841,0,'2013-07-06 12:44:31',NULL,NULL),(32594,'36130','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.373160,-86.311027,0,'2013-07-06 12:44:32',NULL,NULL),(76745,'95915','P','Oroville','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.006111,-121.248056,0,'2013-07-06 12:44:34',NULL,NULL),(62484,'74350','P','Langley','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.463504,-95.047589,0,'2013-07-06 12:44:33',NULL,NULL),(20766,'21504','P','Lavale','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.660766,-78.743170,0,'2013-07-06 12:44:31',NULL,NULL),(54016,'62451','S','Palestine','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.002766,-87.615625,0,'2013-07-06 12:44:33',NULL,NULL),(63655,'75846','S','Jewett','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.375296,-96.221448,0,'2013-07-06 12:44:34',NULL,NULL),(65209,'77437','S','Hillje','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(71241,'86342','P','Lake Montezuma','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.630923,-111.776683,0,'2013-07-06 12:44:34',NULL,NULL),(75189,'93613','P','Clovis','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.797845,-119.640595,0,'2013-07-06 12:44:34',NULL,NULL),(34925,'38965','S','Velma','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.153955,-89.632766,0,'2013-07-06 12:44:32',NULL,NULL),(62409,'74126','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.238869,-95.985200,0,'2013-07-06 12:44:33',NULL,NULL),(21887,'23176','S','Wake','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.564504,-76.427978,0,'2013-07-06 12:44:31',NULL,NULL),(11906,'12405','S','South Durham','N','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.332936,-74.093813,0,'2013-07-06 12:44:30',NULL,NULL),(71842,'87582','P','Lyden','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.146111,-106.005000,0,'2013-07-06 12:44:34',NULL,NULL),(76316,'95453','S','Lakeport','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.052335,-122.913246,0,'2013-07-06 12:44:34',NULL,NULL),(79816,'99505','S','Fort Richardson','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.255993,-149.689138,0,'2013-07-06 12:44:34',NULL,NULL),(18443,'19067','S','Morrisville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.202400,-74.830980,0,'2013-07-06 12:44:31',NULL,NULL),(59323,'70528','S','Delcambre','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.949875,-91.992886,0,'2013-07-06 12:44:33',NULL,NULL),(57257,'66537','S','Scranton','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.780681,-95.736223,0,'2013-07-06 12:44:33',NULL,NULL),(11015,'11558','S','Harbor Isle','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.600901,-73.654227,0,'2013-07-06 12:44:30',NULL,NULL),(21898,'23185','S','Wmsbg','N','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.266334,-76.709764,0,'2013-07-06 12:44:31',NULL,NULL),(26135,'28734','S','Prentiss','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(67003,'79510','S','Eula','N','Callahan','48059','Texas','TX','48','0000','325','Central',-6.0,'Y',32.407474,-99.501877,0,'2013-07-06 12:44:34',NULL,NULL),(7440,'06836','P','Greenwich','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.022765,-73.628447,0,'2013-07-06 12:44:30',NULL,NULL),(2477,'00956','S','Urb Campo Alegre','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(38559,'43764','S','New Lexington','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.718020,-82.185900,0,'2013-07-06 12:44:32',NULL,NULL),(34922,'38965','S','Pine Flat','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.153955,-89.632766,0,'2013-07-06 12:44:32',NULL,NULL),(14069,'14604','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157946,-77.604476,0,'2013-07-06 12:44:31',NULL,NULL),(28505,'31527','S','Brunswick','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.071521,-81.407896,0,'2013-07-06 12:44:32',NULL,NULL),(22886,'24578','S','Natural Brg','A','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.665785,-79.551093,0,'2013-07-06 12:44:31',NULL,NULL),(48570,'55769','S','Lone Pine','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379684,-93.166650,0,'2013-07-06 12:44:33',NULL,NULL),(48667,'55917','S','Newry','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917900,-93.055500,0,'2013-07-06 12:44:33',NULL,NULL),(49481,'56659','S','Max','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.629486,-93.984984,0,'2013-07-06 12:44:33',NULL,NULL),(67050,'79549','S','Snyder','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.764680,-100.858920,0,'2013-07-06 12:44:34',NULL,NULL),(78292,'97880','P','Dale','A','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.134770,-118.928389,0,'2013-07-06 12:44:34',NULL,NULL),(580,'00680','S','Bo Liceo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(63637,'75840','S','Ward Prairie','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.722324,-96.157345,0,'2013-07-06 12:44:34',NULL,NULL),(59410,'70646','P','Hayes','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.134607,-92.927376,0,'2013-07-06 12:44:33',NULL,NULL),(747,'00692','S','Est Cerro Gordo','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(46134,'52650','S','Dodgeville','N','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.943056,-91.180556,0,'2013-07-06 12:44:32',NULL,NULL),(79138,'98501','S','Boston Harbor','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(38004,'42765','S','Rowletts','A','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.293705,-85.916947,0,'2013-07-06 12:44:32',NULL,NULL),(48001,'55150','P','Mendota','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.886247,-93.161578,0,'2013-07-06 12:44:33',NULL,NULL),(43712,'48910','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.704153,-84.546782,0,'2013-07-06 12:44:32',NULL,NULL),(31610,'34684','S','Palm Harbor','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.077842,-82.725926,0,'2013-07-06 12:44:32',NULL,NULL),(30409,'33325','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110796,-80.317912,0,'2013-07-06 12:44:32',NULL,NULL),(24934,'27816','S','Castalia','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',36.100785,-78.065444,0,'2013-07-06 12:44:31',NULL,NULL),(74851,'93247','S','Lindsay','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.209983,-119.086125,0,'2013-07-06 12:44:34',NULL,NULL),(1526,'00754','S','Urb Portal Del Sol','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(14349,'15012','S','N Bell Vernon','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(24845,'27621','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.774204,-78.634732,0,'2013-07-06 12:44:31',NULL,NULL),(47040,'54408','S','Aniwa','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.045303,-89.291462,0,'2013-07-06 12:44:32',NULL,NULL),(50553,'58205','S','Gfafb','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.925264,-97.241434,0,'2013-07-06 12:44:33',NULL,NULL),(53319,'61742','S','Goodfield','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.632122,-89.278523,0,'2013-07-06 12:44:33',NULL,NULL),(67907,'80903','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.831839,-104.818927,0,'2013-07-06 12:44:34',NULL,NULL),(73693,'91606','S','Valley Glen','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186265,-118.391357,0,'2013-07-06 12:44:34',NULL,NULL),(10340,'10553','S','Mount Vernon','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.904734,-73.824600,0,'2013-07-06 12:44:30',NULL,NULL),(61626,'72830','S','Clarksville','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.465085,-93.471562,0,'2013-07-06 12:44:33',NULL,NULL),(51191,'59027','S','Miner','N','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.182840,-110.937072,0,'2013-07-06 12:44:33',NULL,NULL),(63938,'76068','P','Mineral Wells','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.807949,-98.112596,0,'2013-07-06 12:44:34',NULL,NULL),(35662,'39648','S','Progress','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(26416,'29117','U','SC State University','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.495205,-80.844399,0,'2013-07-06 12:44:31',NULL,NULL),(68340,'81124','P','Capulin','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.281746,-106.101224,0,'2013-07-06 12:44:34',NULL,NULL),(75666,'94542','S','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.657207,-122.041013,0,'2013-07-06 12:44:34',NULL,NULL),(76764,'95928','S','Chapmantown','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.724307,-121.813534,0,'2013-07-06 12:44:34',NULL,NULL),(19019,'19529','S','Wanamakers','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(68525,'81401','S','Montrose','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.412000,-107.862900,0,'2013-07-06 12:44:34',NULL,NULL),(74659,'92844','S','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.766072,-117.973804,0,'2013-07-06 12:44:34',NULL,NULL),(79231,'98550','S','Hoquiam','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(18431,'19063','S','Rose Tree','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(39969,'45237','S','Losantiville','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(12766,'13209','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.085400,-76.251720,0,'2013-07-06 12:44:30',NULL,NULL),(24977,'27851','S','Lucama','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.634649,-78.012797,0,'2013-07-06 12:44:31',NULL,NULL),(22318,'23842','S','Disputanta','D','Prince George','51149','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.152950,-77.237944,0,'2013-07-06 12:44:31',NULL,NULL),(21765,'23060','S','Gln Alln','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.659630,-77.529243,0,'2013-07-06 12:44:31',NULL,NULL),(12949,'13354','S','Steuben Valley','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.253640,-75.284520,0,'2013-07-06 12:44:30',NULL,NULL),(55786,'64120','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.123910,-94.537200,0,'2013-07-06 12:44:33',NULL,NULL),(56462,'65287','S','Wooldridge','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.919004,-92.582291,0,'2013-07-06 12:44:33',NULL,NULL),(69158,'83318','S','Springdale','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.528311,-113.790822,0,'2013-07-06 12:44:34',NULL,NULL),(70238,'84405','S','South Ogden','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(4038,'02575','P','West Tisbury','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.402414,-70.630193,0,'2013-07-06 12:44:30',NULL,NULL),(61194,'72219','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.680928,-92.347200,0,'2013-07-06 12:44:33',NULL,NULL),(3537,'01907','S','Swampscott','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.472258,-70.908157,0,'2013-07-06 12:44:30',NULL,NULL),(64366,'76525','S','Bee House','A','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.409762,-98.104299,0,'2013-07-06 12:44:34',NULL,NULL),(57024,'66207','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(33601,'37620','S','Bristol','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.569357,-82.183865,0,'2013-07-06 12:44:32',NULL,NULL),(64367,'76525','S','Evant','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.409762,-98.104299,0,'2013-07-06 12:44:34',NULL,NULL),(34790,'38870','S','Smithville','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.065634,-88.382455,0,'2013-07-06 12:44:32',NULL,NULL),(42913,'48105','S','Superior Township','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.306761,-83.700406,0,'2013-07-06 12:44:32',NULL,NULL),(63482,'75691','S','Dirgin','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.329081,-94.530614,0,'2013-07-06 12:44:33',NULL,NULL),(72923,'90028','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.099218,-118.327098,0,'2013-07-06 12:44:34',NULL,NULL),(15334,'16222','S','Dayton','D','Armstrong','42005','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.878895,-79.240426,0,'2013-07-06 12:44:31',NULL,NULL),(18654,'19173','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954726,-75.169864,0,'2013-07-06 12:44:31',NULL,NULL),(21692,'22964','S','Piney River','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.714274,-79.020575,0,'2013-07-06 12:44:31',NULL,NULL),(11623,'12110','S','Latham','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.747077,-73.767886,0,'2013-07-06 12:44:30',NULL,NULL),(18238,'18974','S','Warminster','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.208672,-75.079555,0,'2013-07-06 12:44:31',NULL,NULL),(10204,'10314','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.606393,-74.152402,0,'2013-07-06 12:44:30',NULL,NULL),(3489,'01841','S','Lawrence','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.711749,-71.163840,0,'2013-07-06 12:44:30',NULL,NULL),(9508,'10016','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(10467,'10933','P','Johnson','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.365309,-74.507791,0,'2013-07-06 12:44:30',NULL,NULL),(25663,'28504','S','Kinston','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.275222,-77.589004,0,'2013-07-06 12:44:31',NULL,NULL),(27768,'30366','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.887527,-84.287641,0,'2013-07-06 12:44:31',NULL,NULL),(54446,'62846','S','Spring Garden','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.152390,-88.904498,0,'2013-07-06 12:44:33',NULL,NULL),(60602,'71846','S','Lockesburg','D','Sevier','05133','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.917861,-94.115216,0,'2013-07-06 12:44:33',NULL,NULL),(61441,'72587','S','Wiseman','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.226251,-91.854109,0,'2013-07-06 12:44:33',NULL,NULL),(71433,'87029','S','Ojito','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.429722,-107.087222,0,'2013-07-06 12:44:34',NULL,NULL),(79036,'98398','P','Paradise Inn','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.782679,-121.742713,0,'2013-07-06 12:44:34',NULL,NULL),(59610,'71024','S','Dubberly','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.489041,-93.201393,0,'2013-07-06 12:44:33',NULL,NULL),(57033,'66208','S','Overland Park','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(56879,'66026','S','Fontana','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.396275,-94.874247,0,'2013-07-06 12:44:33',NULL,NULL),(41560,'47022','S','Guilford','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.206304,-84.952322,0,'2013-07-06 12:44:32',NULL,NULL),(36107,'40221','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.186043,-85.751873,0,'2013-07-06 12:44:32',NULL,NULL),(22057,'23324','S','South Norfolk','A','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.799974,-76.267142,0,'2013-07-06 12:44:31',NULL,NULL),(69316,'83465','P','Lemhi','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.849930,-113.617058,0,'2013-07-06 12:44:34',NULL,NULL),(36655,'41007','S','Flagg Spring','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.894989,-84.294749,0,'2013-07-06 12:44:32',NULL,NULL),(27723,'30346','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.927811,-84.344192,0,'2013-07-06 12:44:31',NULL,NULL),(27941,'30533','S','Dahlonega','D','Lumpkin','13187','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.529731,-83.984892,0,'2013-07-06 12:44:31',NULL,NULL),(17719,'18240','S','Nesquehoning','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.864814,-75.815635,0,'2013-07-06 12:44:31',NULL,NULL),(50652,'58323','S','Calvin','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.802865,-98.936626,0,'2013-07-06 12:44:33',NULL,NULL),(39272,'44455','S','Rogers','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.779315,-80.606133,0,'2013-07-06 12:44:32',NULL,NULL),(37537,'42053','S','Kevil','D','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.100611,-88.846047,0,'2013-07-06 12:44:32',NULL,NULL),(68466,'81236','S','Mount Princeton','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.700006,-106.141598,0,'2013-07-06 12:44:34',NULL,NULL),(37249,'41557','S','Raccoon','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.498447,-82.428405,0,'2013-07-06 12:44:32',NULL,NULL),(29150,'32336','S','Lamont','D','Jefferson','12065','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.301068,-83.940182,0,'2013-07-06 12:44:32',NULL,NULL),(10861,'11415','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.708943,-73.826125,0,'2013-07-06 12:44:30',NULL,NULL),(39822,'45148','S','Westboro','N','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.295707,-83.886912,0,'2013-07-06 12:44:32',NULL,NULL),(72673,'89441','S','Spanish Spgs','A','Washoe','32031','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.345519,-119.648215,0,'2013-07-06 12:44:34',NULL,NULL),(77897,'97294','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.542313,-122.496847,0,'2013-07-06 12:44:34',NULL,NULL),(7711,'07191','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.702983,-74.168748,0,'2013-07-06 12:44:30',NULL,NULL),(79502,'98908','S','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606563,-120.620141,0,'2013-07-06 12:44:34',NULL,NULL),(65118,'77375','S','Tomball','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.081648,-95.615932,0,'2013-07-06 12:44:34',NULL,NULL),(63223,'75457','S','Mount Vernon','D','Franklin','48159','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.180969,-95.227426,0,'2013-07-06 12:44:33',NULL,NULL),(62661,'74636','S','Deer Creek','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.804851,-97.507404,0,'2013-07-06 12:44:33',NULL,NULL),(5751,'05038','S','Chelsea','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.986493,-72.444333,0,'2013-07-06 12:44:30',NULL,NULL),(10027,'10171','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(24118,'26541','S','Maidsville','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.705779,-79.993492,0,'2013-07-06 12:44:31',NULL,NULL),(42162,'47523','S','Heilman','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.173260,-86.999460,0,'2013-07-06 12:44:32',NULL,NULL),(71389,'87006','S','San Francisco','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.561472,-106.781071,0,'2013-07-06 12:44:34',NULL,NULL),(76653,'95728','P','Serene Lakes','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.320782,-120.408004,0,'2013-07-06 12:44:34',NULL,NULL),(80064,'99721','P','Anaktuvuk Pass','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',68.240851,-151.892653,0,'2013-07-06 12:44:34',NULL,NULL),(65424,'77580','P','Mont Belvieu','D','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.873761,-94.855727,0,'2013-07-06 12:44:34',NULL,NULL),(5015,'04230','P','East Poland','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.025349,-70.386493,0,'2013-07-06 12:44:30',NULL,NULL),(27495,'30169','P','Canton','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.247238,-84.521591,0,'2013-07-06 12:44:31',NULL,NULL),(54698,'62950','S','Raddle','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.747337,-89.546002,0,'2013-07-06 12:44:33',NULL,NULL),(3033,'01096','S','South Chesterfield','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.399296,-72.749011,0,'2013-07-06 12:44:30',NULL,NULL),(8408,'08068','S','Pemberton','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.962570,-74.681969,0,'2013-07-06 12:44:30',NULL,NULL),(41408,'46816','S','Diplomat','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(28074,'30722','P','Dalton','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.761009,-84.949881,0,'2013-07-06 12:44:31',NULL,NULL),(45143,'50579','S','Richards','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(4053,'02641','P','E Dennis','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.740504,-70.158592,0,'2013-07-06 12:44:30',NULL,NULL),(13608,'13860','P','West Davenport','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.446027,-74.965139,0,'2013-07-06 12:44:31',NULL,NULL),(59238,'70433','S','Riverwood','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.457687,-90.114529,0,'2013-07-06 12:44:33',NULL,NULL),(42908,'48104','S','Pittsfield Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.261244,-83.716523,0,'2013-07-06 12:44:32',NULL,NULL),(24267,'26836','S','Rig','A','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.087480,-78.995940,0,'2013-07-06 12:44:31',NULL,NULL),(6482,'05768','P','Rupert','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.263597,-73.222220,0,'2013-07-06 12:44:30',NULL,NULL),(42748,'48025','S','Bingham Farms','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.523195,-83.265758,0,'2013-07-06 12:44:32',NULL,NULL),(22692,'24322','S','Cripple Creek','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.797818,-81.105797,0,'2013-07-06 12:44:31',NULL,NULL),(22925,'24614','S','Stacy','N','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.277524,-82.094356,0,'2013-07-06 12:44:31',NULL,NULL),(58612,'68856','S','Kilfoil','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.395529,-99.846927,0,'2013-07-06 12:44:33',NULL,NULL),(54821,'63025','S','Byrnes Mill','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(42295,'47597','S','Steen','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.669385,-87.298788,0,'2013-07-06 12:44:32',NULL,NULL),(19351,'20046','U','Geico','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.957666,-77.086672,0,'2013-07-06 12:44:31',NULL,NULL),(61569,'72732','S','Garfield','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.391692,-93.912175,0,'2013-07-06 12:44:33',NULL,NULL),(33457,'37321','S','Dayton','D','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.491810,-85.015179,0,'2013-07-06 12:44:32',NULL,NULL),(35606,'39601','S','Fair Oaks Springs','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(49064,'56311','S','Barrett','D','Grant','27051','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.891548,-95.883332,0,'2013-07-06 12:44:33',NULL,NULL),(20488,'21051','S','Fork','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.473118,-76.456353,0,'2013-07-06 12:44:31',NULL,NULL),(45233,'50648','S','Jesup','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.458700,-92.063160,0,'2013-07-06 12:44:32',NULL,NULL),(41170,'46705','S','Steuben','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.514265,-85.072002,0,'2013-07-06 12:44:32',NULL,NULL),(31774,'35015','P','Alton','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.579758,-86.639044,0,'2013-07-06 12:44:32',NULL,NULL),(12959,'13361','S','Jordanville','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.894770,-74.817340,0,'2013-07-06 12:44:30',NULL,NULL),(22808,'24477','S','Stuarts Draft','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.021357,-79.030230,0,'2013-07-06 12:44:31',NULL,NULL),(63372,'75644','S','Cox','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(21658,'22942','S','Zion','N','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.134847,-78.186346,0,'2013-07-06 12:44:31',NULL,NULL),(30872,'33675','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.119021,-82.471502,0,'2013-07-06 12:44:32',NULL,NULL),(39710,'45050','S','Liberty Tnsp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.446195,-84.369751,0,'2013-07-06 12:44:32',NULL,NULL),(31202,'33947','S','Placida','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.890856,-82.289031,0,'2013-07-06 12:44:32',NULL,NULL),(73669,'91523','U','Nbc Tv Network','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169107,-118.336597,0,'2013-07-06 12:44:34',NULL,NULL),(6115,'05457','S','Lake Carmi','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(43357,'48390','S','Wolverine Lake','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(70099,'84170','P','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701243,-112.010773,0,'2013-07-06 12:44:34',NULL,NULL),(9222,'09520','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(62173,'73747','S','Isabella','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.234371,-98.338643,0,'2013-07-06 12:44:33',NULL,NULL),(653,'00682','S','Vista Verde','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(46602,'53557','S','Lowell','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.339451,-88.816525,0,'2013-07-06 12:44:32',NULL,NULL),(668,'00683','S','Urb El Convento','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(20403,'20902','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.037324,-77.049792,0,'2013-07-06 12:44:31',NULL,NULL),(51562,'59750','S','Butte','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.974422,-112.808021,0,'2013-07-06 12:44:33',NULL,NULL),(41828,'47340','S','Unionport','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.181057,-85.113281,0,'2013-07-06 12:44:32',NULL,NULL),(72714,'89450','P','Incline Vlg','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.256452,-119.955498,0,'2013-07-06 12:44:34',NULL,NULL),(6092,'05450','S','So Franklin','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(19319,'20019','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.890726,-76.938125,0,'2013-07-06 12:44:31',NULL,NULL),(63434,'75667','S','Laneville','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.945127,-94.853612,0,'2013-07-06 12:44:33',NULL,NULL),(23156,'25008','S','Artie','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.915001,-81.368050,0,'2013-07-06 12:44:31',NULL,NULL),(24514,'27281','S','Wind Blow','N','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(62826,'74962','S','Vian','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.527280,-94.963056,0,'2013-07-06 12:44:33',NULL,NULL),(11728,'12180','S','Snyders Lake','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(50727,'58381','S','Warwick','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.907807,-98.671215,0,'2013-07-06 12:44:33',NULL,NULL),(56316,'65103','U','Div of Family Services','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578727,-92.174092,0,'2013-07-06 12:44:33',NULL,NULL),(44392,'49807','S','Hardwood','A','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.698400,-87.235980,0,'2013-07-06 12:44:32',NULL,NULL),(16623,'17331','S','Parkville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(28823,'32080','S','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(16742,'17507','P','Bowmansville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.195667,-76.013395,0,'2013-07-06 12:44:31',NULL,NULL),(78647,'98225','S','Bellingham','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.746494,-122.493289,0,'2013-07-06 12:44:34',NULL,NULL),(7617,'07055','S','Passaic','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.859415,-74.130577,0,'2013-07-06 12:44:30',NULL,NULL),(641,'00682','S','Urb Los Versalles','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(18160,'18853','S','Wyalusing','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.669695,-76.262492,0,'2013-07-06 12:44:31',NULL,NULL),(56312,'65101','S','Taos','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(51531,'59717','P','Montana State Univ Bozeman','N','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.661963,-111.059937,0,'2013-07-06 12:44:33',NULL,NULL),(48962,'56183','S','Westbrook','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.043900,-95.436643,0,'2013-07-06 12:44:33',NULL,NULL),(31381,'34216','P','Anna Maria','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.531908,-82.733863,0,'2013-07-06 12:44:32',NULL,NULL),(26610,'29303','S','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.018040,-81.976140,0,'2013-07-06 12:44:31',NULL,NULL),(63044,'75212','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.782293,-96.875996,0,'2013-07-06 12:44:33',NULL,NULL),(43458,'48550','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.065739,-83.688105,0,'2013-07-06 12:44:32',NULL,NULL),(41538,'46998','S','Young America','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.568911,-86.352814,0,'2013-07-06 12:44:32',NULL,NULL),(68847,'82604','S','Casper','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.826825,-106.381639,0,'2013-07-06 12:44:34',NULL,NULL),(3312,'01521','S','Fiskdale','A','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.042514,-72.149839,0,'2013-07-06 12:44:30',NULL,NULL),(12606,'13082','S','Kirkville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083758,-75.970572,0,'2013-07-06 12:44:30',NULL,NULL),(54036,'62463','S','Kingman','N','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.266470,-88.628735,0,'2013-07-06 12:44:33',NULL,NULL),(36027,'40166','U','Zappos Inc','N','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(45038,'50473','S','Scarville','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.466570,-93.652350,0,'2013-07-06 12:44:32',NULL,NULL),(38419,'43545','S','Napoleon','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.386399,-84.133117,0,'2013-07-06 12:44:32',NULL,NULL),(69127,'83283','S','Thatcher','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.387191,-111.717415,0,'2013-07-06 12:44:34',NULL,NULL),(22537,'24120','S','Meadows of Dan','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.724210,-80.401341,0,'2013-07-06 12:44:31',NULL,NULL),(71610,'87327','P','Lower Nutria','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(74339,'92406','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.133983,-117.286246,0,'2013-07-06 12:44:34',NULL,NULL),(63719,'75928','S','Bon Wier','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.680792,-93.761316,0,'2013-07-06 12:44:34',NULL,NULL),(11007,'11555','U','Uniondale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705942,-73.595749,0,'2013-07-06 12:44:30',NULL,NULL),(52740,'61238','S','Ulah','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.305313,-90.190486,0,'2013-07-06 12:44:33',NULL,NULL),(73184,'90408','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.026164,-118.491968,0,'2013-07-06 12:44:34',NULL,NULL),(62929,'75088','S','Rowlett','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.893933,-96.553094,0,'2013-07-06 12:44:33',NULL,NULL),(10627,'11051','U','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.841029,-73.694052,0,'2013-07-06 12:44:30',NULL,NULL),(31968,'35213','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504565,-86.747150,0,'2013-07-06 12:44:32',NULL,NULL),(49410,'56628','S','Bigfork','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.766250,-93.707164,0,'2013-07-06 12:44:33',NULL,NULL),(67032,'79540','S','Old Glory','D','Stonewall','48433','Texas','TX','48','0000','940','Central',-6.0,'Y',33.264549,-100.140769,0,'2013-07-06 12:44:34',NULL,NULL),(29397,'32622','S','Brooker','D','Bradford','12007','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.926221,-82.284544,0,'2013-07-06 12:44:32',NULL,NULL),(55517,'63785','S','Whitewater','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.274009,-89.758470,0,'2013-07-06 12:44:33',NULL,NULL),(45113,'50558','S','Livermore','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.866229,-94.183669,0,'2013-07-06 12:44:32',NULL,NULL),(53222,'61635','U','East Peoria','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.708299,-89.522384,0,'2013-07-06 12:44:33',NULL,NULL),(7229,'06505','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.307813,-72.923064,0,'2013-07-06 12:44:30',NULL,NULL),(41360,'46792','S','Warren','D','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(19030,'19535','P','Limekiln','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.379094,-75.763387,0,'2013-07-06 12:44:31',NULL,NULL),(51331,'59263','S','Scobey','D','Daniels','30019','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.790791,-105.423135,0,'2013-07-06 12:44:33',NULL,NULL),(17501,'17961','S','Pinedale','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(24816,'27604','S','Neuse','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.866620,-78.531900,0,'2013-07-06 12:44:31',NULL,NULL),(69862,'84092','S','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(70627,'85138','S','Maricopa','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.053790,-112.004917,0,'2013-07-06 12:44:34',NULL,NULL),(22813,'24484','S','Warm Springs','D','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.217222,-79.676667,0,'2013-07-06 12:44:31',NULL,NULL),(16149,'17060','S','Mlcreek','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.445595,-77.904057,0,'2013-07-06 12:44:31',NULL,NULL),(14512,'15202','S','Ben Avon','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(23703,'25871','P','Mabscott','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.769428,-81.208346,0,'2013-07-06 12:44:31',NULL,NULL),(60315,'71457','S','Cypress','A','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(43945,'49289','P','Weston','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.772761,-84.098116,0,'2013-07-06 12:44:32',NULL,NULL),(45957,'52356','S','Daytonville','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.470532,-91.832359,0,'2013-07-06 12:44:32',NULL,NULL),(11004,'11554','S','E Meadow','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.715698,-73.556154,0,'2013-07-06 12:44:30',NULL,NULL),(63347,'75607','P','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.578408,-94.779284,0,'2013-07-06 12:44:33',NULL,NULL),(32745,'36330','S','Eprise','N','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.325580,-85.844682,0,'2013-07-06 12:44:32',NULL,NULL),(73045,'90083','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',33.954859,-118.400826,0,'2013-07-06 12:44:34',NULL,NULL),(9334,'09748','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7199,'06479','S','Plantsville','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.581652,-72.897889,0,'2013-07-06 12:44:30',NULL,NULL),(31751,'34988','P','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.341002,-80.519774,0,'2013-07-06 12:44:32',NULL,NULL),(65697,'78007','S','Calliham','D','McMullen','48311','Texas','TX','48','0000','361','Central',-6.0,'Y',28.345836,-98.421438,0,'2013-07-06 12:44:34',NULL,NULL),(49814,'57212','S','Arlington','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365792,-97.151109,0,'2013-07-06 12:44:33',NULL,NULL),(16328,'17124','U','State Liquor Control','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266009,-76.881673,0,'2013-07-06 12:44:31',NULL,NULL),(71664,'87503','U','New Mexico State Capitol','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.683677,-105.938892,0,'2013-07-06 12:44:34',NULL,NULL),(29971,'33083','P','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148688,-80.224835,0,'2013-07-06 12:44:32',NULL,NULL),(38506,'43711','P','Ava','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.832707,-81.574545,0,'2013-07-06 12:44:32',NULL,NULL),(80198,'99925','P','Klawock','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.554962,-133.096707,0,'2013-07-06 12:44:34',NULL,NULL),(53403,'61832','S','Central Park','N','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.136438,-87.632393,0,'2013-07-06 12:44:33',NULL,NULL),(8533,'08109','S','Pennsauken','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.950935,-75.052361,0,'2013-07-06 12:44:30',NULL,NULL),(13027,'13431','S','Poland','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.205100,-75.072600,0,'2013-07-06 12:44:30',NULL,NULL),(6790,'06107','S','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756512,-72.758753,0,'2013-07-06 12:44:30',NULL,NULL),(8077,'07753','S','Wall Township','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(34155,'38253','S','Rives','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.323149,-89.039676,0,'2013-07-06 12:44:32',NULL,NULL),(41160,'46703','S','Flint','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(2005,'00912','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446583,-66.061072,0,'2013-07-06 12:44:30',NULL,NULL),(16620,'17331','S','Moulstown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(48679,'55923','S','Pilot Mound','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.842309,-92.183188,0,'2013-07-06 12:44:33',NULL,NULL),(48588,'55779','S','Grand Lake','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(41872,'47362','S','Henry','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(70393,'84701','S','Venice','A','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.675160,-111.989820,0,'2013-07-06 12:44:34',NULL,NULL),(12715,'13152','S','Skan','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.884340,-76.351260,0,'2013-07-06 12:44:30',NULL,NULL),(62496,'74361','S','Sprtsmn Acres','A','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.298940,-95.310823,0,'2013-07-06 12:44:33',NULL,NULL),(59137,'70166','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948632,-90.073740,0,'2013-07-06 12:44:33',NULL,NULL),(48177,'55382','S','South Haven','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.347660,-94.185903,0,'2013-07-06 12:44:33',NULL,NULL),(53952,'62423','S','Dennison','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.450635,-87.609931,0,'2013-07-06 12:44:33',NULL,NULL),(77210,'96377','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(54532,'62881','S','Salem','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.628360,-88.946423,0,'2013-07-06 12:44:33',NULL,NULL),(38691,'43985','P','Holloway','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.161005,-81.127401,0,'2013-07-06 12:44:32',NULL,NULL),(66987,'79464','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.535470,-101.916226,0,'2013-07-06 12:44:34',NULL,NULL),(57502,'66949','S','Jewell','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.672180,-98.108820,0,'2013-07-06 12:44:33',NULL,NULL),(40515,'45819','S','Buckland','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.624010,-84.262255,0,'2013-07-06 12:44:32',NULL,NULL),(34196,'38336','P','Fruitvale','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.718807,-89.064976,0,'2013-07-06 12:44:32',NULL,NULL),(24659,'27405','S','Tennessee Acres','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(30926,'33709','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.817643,-82.732339,0,'2013-07-06 12:44:32',NULL,NULL),(54579,'62898','S','Woodlawn','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.387010,-89.091555,0,'2013-07-06 12:44:33',NULL,NULL),(21512,'22715','S','Brightwood','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.409191,-78.168015,0,'2013-07-06 12:44:31',NULL,NULL),(41085,'46534','S','Toto','N','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.299044,-86.616720,0,'2013-07-06 12:44:32',NULL,NULL),(28602,'31698','U','Valdosta State College','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.865739,-83.288419,0,'2013-07-06 12:44:32',NULL,NULL),(9777,'10106','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(62670,'74647','S','Peckham','A','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.884362,-97.055620,0,'2013-07-06 12:44:33',NULL,NULL),(57681,'67226','S','Comotara','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.742159,-97.242969,0,'2013-07-06 12:44:33',NULL,NULL),(5653,'04957','S','Mercer','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.672400,-69.856231,0,'2013-07-06 12:44:30',NULL,NULL),(53770,'62269','S','Shiloh','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.562834,-89.896654,0,'2013-07-06 12:44:33',NULL,NULL),(5562,'04859','S','Tenants Harbor','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.013030,-69.171205,0,'2013-07-06 12:44:30',NULL,NULL),(14383,'15035','S','East McKeesport','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.380214,-79.806760,0,'2013-07-06 12:44:31',NULL,NULL),(6893,'06145','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791818,-72.668284,0,'2013-07-06 12:44:30',NULL,NULL),(41098,'46552','S','Hudson Lake','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.708477,-86.481430,0,'2013-07-06 12:44:32',NULL,NULL),(2584,'00961','S','Bo Volcan Arenas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(35589,'39573','S','Ten Mile','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(79246,'98558','P','Mc Kenna','N','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.935000,-122.555220,0,'2013-07-06 12:44:34',NULL,NULL),(2766,'00971','S','Finca Elena','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388508,-66.115017,0,'2013-07-06 12:44:30',NULL,NULL),(5244,'04475','S','Passadumkeag','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.186271,-68.592122,0,'2013-07-06 12:44:30',NULL,NULL),(54767,'62990','S','Gale','A','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.189836,-89.393166,0,'2013-07-06 12:44:33',NULL,NULL),(58649,'68872','S','Worms','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.082458,-98.362472,0,'2013-07-06 12:44:33',NULL,NULL),(29188,'32401','S','Panama City Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.160005,-85.649607,0,'2013-07-06 12:44:32',NULL,NULL),(25783,'28604','S','Beech Mnt','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(50722,'58377','S','Starkweather','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.449454,-98.802536,0,'2013-07-06 12:44:33',NULL,NULL),(66212,'78550','S','Primera','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(4905,'04063','P','Ocean Park','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.517222,-70.378056,0,'2013-07-06 12:44:30',NULL,NULL),(25736,'28557','S','Morehead City','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.725535,-76.758443,0,'2013-07-06 12:44:31',NULL,NULL),(33727,'37813','S','Morristown','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.190558,-83.271169,0,'2013-07-06 12:44:32',NULL,NULL),(72438,'89086','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.281466,-115.134712,0,'2013-07-06 12:44:34',NULL,NULL),(56514,'65351','S','Cretcher','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964117,-93.418774,0,'2013-07-06 12:44:33',NULL,NULL),(49113,'56352','S','Meire Grove','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.652875,-94.805558,0,'2013-07-06 12:44:33',NULL,NULL),(38261,'43306','P','Fulfillment Corp of Amer Brm','N','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.611969,-83.158583,0,'2013-07-06 12:44:32',NULL,NULL),(68676,'82002','U','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.142242,-104.822841,0,'2013-07-06 12:44:34',NULL,NULL),(59796,'71220','S','Shelton','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(14552,'15211','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.432740,-79.945680,0,'2013-07-06 12:44:31',NULL,NULL),(50679,'58344','S','Lakota','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.042397,-98.341319,0,'2013-07-06 12:44:33',NULL,NULL),(31192,'33935','S','La Belle','N','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.634300,-81.341400,0,'2013-07-06 12:44:32',NULL,NULL),(31626,'34692','P','Holiday','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.191135,-82.728072,0,'2013-07-06 12:44:32',NULL,NULL),(43148,'48240','S','Redford','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.423668,-83.299778,0,'2013-07-06 12:44:32',NULL,NULL),(12265,'12834','S','Bald Mountain','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.090326,-73.500080,0,'2013-07-06 12:44:30',NULL,NULL),(41741,'47265','S','Queensville','N','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.018614,-85.652437,0,'2013-07-06 12:44:32',NULL,NULL),(10845,'11411','S','Cambria Hts','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694491,-73.737461,0,'2013-07-06 12:44:30',NULL,NULL),(16206,'17070','S','Nw Cumberlnd','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(43538,'48670','U','Mid Michigan Reg Med Ctr','N','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.636969,-84.256060,0,'2013-07-06 12:44:32',NULL,NULL),(6372,'05680','S','East Elmore','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.546700,-72.497820,0,'2013-07-06 12:44:30',NULL,NULL),(67696,'80522','P','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.594542,-105.127399,0,'2013-07-06 12:44:34',NULL,NULL),(59870,'71263','S','Terry','A','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.840160,-91.467780,0,'2013-07-06 12:44:33',NULL,NULL),(76739,'95912','S','College City','A','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.032646,-122.014634,0,'2013-07-06 12:44:34',NULL,NULL),(5924,'05252','S','E Arlington','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.057869,-73.137659,0,'2013-07-06 12:44:30',NULL,NULL),(34321,'38558','S','Crossville','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(21714,'22989','P','Wdberry Forst','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.213226,-78.052185,0,'2013-07-06 12:44:31',NULL,NULL),(65162,'77404','P','Bay City','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.832140,-95.671050,0,'2013-07-06 12:44:34',NULL,NULL),(66888,'79241','S','Lockney','D','Floyd','48153','Texas','TX','48','0000','806','Central',-6.0,'Y',34.119383,-101.443723,0,'2013-07-06 12:44:34',NULL,NULL),(70612,'85120','S','Apache Junction','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.412396,-111.589933,0,'2013-07-06 12:44:34',NULL,NULL),(74094,'92199','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.980136,-117.082337,0,'2013-07-06 12:44:34',NULL,NULL),(75624,'94506','S','Danville','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.810650,-121.912874,0,'2013-07-06 12:44:34',NULL,NULL),(8461,'08088','S','Indian Mills','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(16818,'17545','S','Sporting Hill','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(26363,'29072','S','Barr','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.979860,-81.260520,0,'2013-07-06 12:44:31',NULL,NULL),(42462,'47834','S','Art','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(52857,'61327','S','Hennepin','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.252075,-89.337202,0,'2013-07-06 12:44:33',NULL,NULL),(53344,'61759','S','Little Mackinaw','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.432110,-89.310172,0,'2013-07-06 12:44:33',NULL,NULL),(54026,'62458','S','St Elmo','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.029314,-88.854347,0,'2013-07-06 12:44:33',NULL,NULL),(59964,'71307','P','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284883,-92.452270,0,'2013-07-06 12:44:33',NULL,NULL),(75555,'94249','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.573020,-121.467357,0,'2013-07-06 12:44:34',NULL,NULL),(18683,'19185','U','Selective Service System','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.891542,-75.169424,0,'2013-07-06 12:44:31',NULL,NULL),(30157,'33169','S','North Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.935490,-80.214010,0,'2013-07-06 12:44:32',NULL,NULL),(20184,'20747','S','District Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854982,-76.887745,0,'2013-07-06 12:44:31',NULL,NULL),(16708,'17403','S','Leaders Heights','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(64028,'76122','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.725278,-97.320556,0,'2013-07-06 12:44:34',NULL,NULL),(27896,'30471','S','Twin City','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.652254,-82.155942,0,'2013-07-06 12:44:31',NULL,NULL),(27777,'30371','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.762163,-84.424695,0,'2013-07-06 12:44:31',NULL,NULL),(53606,'62080','S','Vera','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.144853,-89.109512,0,'2013-07-06 12:44:33',NULL,NULL),(44425,'49839','P','Grand Marais','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.588717,-86.046862,0,'2013-07-06 12:44:32',NULL,NULL),(48059,'55323','P','Crystal Bay','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.954569,-93.576380,0,'2013-07-06 12:44:33',NULL,NULL),(72029,'88053','P','Silver City','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.783686,-108.271831,0,'2013-07-06 12:44:34',NULL,NULL),(39012,'44141','S','Brecksville','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.308320,-81.620760,0,'2013-07-06 12:44:32',NULL,NULL),(4158,'02770','S','Rochester','D','Plymouth','25023','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.761866,-70.845819,0,'2013-07-06 12:44:30',NULL,NULL),(36215,'40281','U','Pleasure Ridge Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.145981,-85.867083,0,'2013-07-06 12:44:32',NULL,NULL),(23632,'25728','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.398675,-82.451881,0,'2013-07-06 12:44:31',NULL,NULL),(8069,'07750','S','Monmouth Beach','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.332243,-73.999422,0,'2013-07-06 12:44:30',NULL,NULL),(51150,'58845','S','Westby','N','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.602400,-103.917180,0,'2013-07-06 12:44:33',NULL,NULL),(58606,'68853','S','Sherman Lake','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.279151,-98.969658,0,'2013-07-06 12:44:33',NULL,NULL),(69173,'83327','S','Fairfield','D','Camas','16025','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.487841,-114.769284,0,'2013-07-06 12:44:34',NULL,NULL),(72021,'88045','S','Virden','A','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.347258,-108.708739,0,'2013-07-06 12:44:34',NULL,NULL),(74905,'93311','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.290415,-119.115826,0,'2013-07-06 12:44:34',NULL,NULL),(28126,'30816','S','Keysville','D','Burke','13033','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.170681,-82.179086,0,'2013-07-06 12:44:31',NULL,NULL),(22309,'23834','S','Colonial Hgts','A','Colonial Heights City','51570','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.287361,-77.391074,0,'2013-07-06 12:44:31',NULL,NULL),(58551,'68817','S','Ashton','D','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.302577,-98.817867,0,'2013-07-06 12:44:33',NULL,NULL),(67887,'80862','P','Wild Horse','D','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.914328,-103.045161,0,'2013-07-06 12:44:34',NULL,NULL),(76674,'95798','P','W Sacramento','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.574918,-121.561857,0,'2013-07-06 12:44:34',NULL,NULL),(21411,'22530','P','Ophelia','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.912472,-76.283591,0,'2013-07-06 12:44:31',NULL,NULL),(36320,'40380','S','Stanton','D','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.851590,-83.854413,0,'2013-07-06 12:44:32',NULL,NULL),(12039,'12522','S','Dover Plains','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.717700,-73.582080,0,'2013-07-06 12:44:30',NULL,NULL),(48324,'55447','S','Plymouth','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.000722,-93.488055,0,'2013-07-06 12:44:33',NULL,NULL),(10468,'10940','S','Middletown','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.474400,-74.410980,0,'2013-07-06 12:44:30',NULL,NULL),(11560,'12061','S','E Greenbush','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.595189,-73.693628,0,'2013-07-06 12:44:30',NULL,NULL),(33208,'37048','S','Cottontown','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.491451,-86.594531,0,'2013-07-06 12:44:32',NULL,NULL),(11730,'12180','S','Sycaway','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(30218,'33185','S','Olympia Hgts','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.716424,-80.437255,0,'2013-07-06 12:44:32',NULL,NULL),(25175,'28043','S','Forest City','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.333268,-81.867460,0,'2013-07-06 12:44:31',NULL,NULL),(20190,'20748','S','Marlow Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(41974,'47421','S','Coveyville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(51494,'59631','P','Basin','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.303194,-112.367722,0,'2013-07-06 12:44:33',NULL,NULL),(66481,'78664','S','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.512352,-97.670283,0,'2013-07-06 12:44:34',NULL,NULL),(68127,'80951','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837139,-104.795539,0,'2013-07-06 12:44:34',NULL,NULL),(49591,'56744','S','Oslo','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.226185,-97.084870,0,'2013-07-06 12:44:33',NULL,NULL),(4932,'04084','S','Sebago Lake','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.744118,-70.411562,0,'2013-07-06 12:44:30',NULL,NULL),(24472,'27239','S','New Hope Academy','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(79008,'98387','S','Spanaway','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.077576,-122.396089,0,'2013-07-06 12:44:34',NULL,NULL),(41253,'46743','S','Harlan','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.219283,-84.848097,0,'2013-07-06 12:44:32',NULL,NULL),(49132,'56364','S','Genola','N','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.978574,-94.097687,0,'2013-07-06 12:44:33',NULL,NULL),(27815,'30401','S','Lexsy','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(20597,'21204','S','Eudowood','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404090,-76.608279,0,'2013-07-06 12:44:31',NULL,NULL),(19677,'20350','U','Chief Naval Operation','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(87,'00612','S','Repto Marquez','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(31393,'34222','S','Ellenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.533400,-82.500332,0,'2013-07-06 12:44:32',NULL,NULL),(47486,'54751','S','North Menomonie','N','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.877251,-91.923866,0,'2013-07-06 12:44:32',NULL,NULL),(51372,'59402','S','Great Falls','A','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.509367,-111.194562,0,'2013-07-06 12:44:33',NULL,NULL),(51857,'60073','S','Volo','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(4856,'04017','S','Chebeague Island','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.733941,-70.127652,0,'2013-07-06 12:44:30',NULL,NULL),(25651,'28470','S','S Brunswick','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.959446,-78.395981,0,'2013-07-06 12:44:31',NULL,NULL),(34741,'38851','S','Houston','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897840,-88.990980,0,'2013-07-06 12:44:32',NULL,NULL),(67095,'79704','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.911944,-102.118442,0,'2013-07-06 12:44:34',NULL,NULL),(74446,'92584','S','Sun City','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.679800,-117.189480,0,'2013-07-06 12:44:34',NULL,NULL),(67623,'80442','P','Fraser','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.951119,-105.814806,0,'2013-07-06 12:44:34',NULL,NULL),(61380,'72529','S','Cherokee Village','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.295430,-91.540492,0,'2013-07-06 12:44:33',NULL,NULL),(44569,'50023','S','Ankeny','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.719600,-93.622700,0,'2013-07-06 12:44:32',NULL,NULL),(44554,'50009','S','Altoona','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.649151,-93.469244,0,'2013-07-06 12:44:32',NULL,NULL),(44354,'49780','S','Rudyard','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.185180,-84.483720,0,'2013-07-06 12:44:32',NULL,NULL),(11765,'12198','S','North Greenbush','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.672720,-73.641840,0,'2013-07-06 12:44:30',NULL,NULL),(34490,'38668','S','New Town','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(4857,'04019','P','Cliff Island','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.699789,-70.100719,0,'2013-07-06 12:44:30',NULL,NULL),(37553,'42064','S','Repton','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(40323,'45475','P','Washington Township','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.643805,-84.166326,0,'2013-07-06 12:44:32',NULL,NULL),(27309,'30018','P','Jersey','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.715558,-83.801524,0,'2013-07-06 12:44:31',NULL,NULL),(5254,'04481','P','Sebec','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.271763,-69.117916,0,'2013-07-06 12:44:30',NULL,NULL),(46705,'53792','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.076741,-89.433069,0,'2013-07-06 12:44:32',NULL,NULL),(77306,'96673','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(78054,'97451','S','Rogue Elk','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.818474,-123.243039,0,'2013-07-06 12:44:34',NULL,NULL),(79125,'98496','P','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.161770,-122.514397,0,'2013-07-06 12:44:34',NULL,NULL),(15068,'15736','P','Elderton','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.693042,-79.339389,0,'2013-07-06 12:44:31',NULL,NULL),(78771,'98310','S','Meadowdale','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(71964,'88006','P','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.322006,-106.767074,0,'2013-07-06 12:44:34',NULL,NULL),(71453,'87046','S','Regina','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',36.203051,-107.057457,0,'2013-07-06 12:44:34',NULL,NULL),(54276,'62688','S','Tallula','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.942864,-89.901619,0,'2013-07-06 12:44:33',NULL,NULL),(52636,'61050','S','Mc Connell','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.439584,-89.731064,0,'2013-07-06 12:44:33',NULL,NULL),(26306,'29036','S','Lake Murray','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.141080,-81.344100,0,'2013-07-06 12:44:31',NULL,NULL),(23504,'25530','S','Kenova','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.383516,-82.570203,0,'2013-07-06 12:44:31',NULL,NULL),(34254,'38449','S','Dellrose','N','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.080509,-86.889332,0,'2013-07-06 12:44:32',NULL,NULL),(9826,'10114','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(40659,'46044','S','Frankton','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.223059,-85.771497,0,'2013-07-06 12:44:32',NULL,NULL),(14462,'15112','S','E Pittsburgh','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403876,-79.837675,0,'2013-07-06 12:44:31',NULL,NULL),(53174,'61601','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.694012,-89.590850,0,'2013-07-06 12:44:33',NULL,NULL),(48653,'55909','S','Johnsburg','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.567108,-92.718696,0,'2013-07-06 12:44:33',NULL,NULL),(71744,'87539','S','Servilleta Plaza','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.290427,-106.105471,0,'2013-07-06 12:44:34',NULL,NULL),(61470,'72631','S','Holiday Isle','A','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.400948,-93.736695,0,'2013-07-06 12:44:33',NULL,NULL),(12166,'12752','S','Lake Huntington','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.687177,-74.991409,0,'2013-07-06 12:44:30',NULL,NULL),(8665,'08319','S','Estell Manor','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.365517,-74.797079,0,'2013-07-06 12:44:30',NULL,NULL),(25748,'28574','S','Richlands','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.831710,-77.576529,0,'2013-07-06 12:44:31',NULL,NULL),(18881,'19460','S','Phoenixville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.111368,-75.546198,0,'2013-07-06 12:44:31',NULL,NULL),(4412,'03225','S','CTR Barnstead','A','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.379371,-71.231100,0,'2013-07-06 12:44:30',NULL,NULL),(15132,'15834','S','Emporium','D','Cameron','42023','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.513262,-78.233322,0,'2013-07-06 12:44:31',NULL,NULL),(23843,'26134','S','Willow Island','A','Pleasants','54073','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.379129,-81.264578,0,'2013-07-06 12:44:31',NULL,NULL),(1053,'00725','S','Alt De Caguas','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(6516,'05823','P','Beebe Plain','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.005425,-72.143158,0,'2013-07-06 12:44:30',NULL,NULL),(11209,'11743','S','W Hills','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(33935,'38067','S','Saulsbury','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.051743,-88.948776,0,'2013-07-06 12:44:32',NULL,NULL),(70019,'84128','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(39939,'45229','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.149736,-84.487866,0,'2013-07-06 12:44:32',NULL,NULL),(66121,'78418','S','Padre Island National Seasho','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.641172,-97.277723,0,'2013-07-06 12:44:34',NULL,NULL),(60564,'71752','S','Mc Neil','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.384319,-93.194790,0,'2013-07-06 12:44:33',NULL,NULL),(46819,'54009','S','Ubet','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.362975,-92.621521,0,'2013-07-06 12:44:32',NULL,NULL),(45541,'51453','S','Lohrville','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.272104,-94.540172,0,'2013-07-06 12:44:32',NULL,NULL),(44842,'50265','S','W Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.583232,-93.756888,0,'2013-07-06 12:44:32',NULL,NULL),(65919,'78239','S','Windcrest','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.511329,-98.367675,0,'2013-07-06 12:44:34',NULL,NULL),(67201,'79908','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.838148,-106.375434,0,'2013-07-06 12:44:34',NULL,NULL),(69837,'84081','S','West Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(52639,'61052','S','Monroe Center','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.107139,-89.003254,0,'2013-07-06 12:44:33',NULL,NULL),(17337,'17866','S','Coal Township','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.786065,-76.555465,0,'2013-07-06 12:44:31',NULL,NULL),(31943,'35204','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.520297,-86.838364,0,'2013-07-06 12:44:32',NULL,NULL),(60023,'71342','S','Blade','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(23635,'25755','U','Marshall University','N','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.416466,-82.447210,0,'2013-07-06 12:44:31',NULL,NULL),(25424,'28303','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.081833,-78.962365,0,'2013-07-06 12:44:31',NULL,NULL),(8514,'08104','S','Haddon Township','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.919931,-75.108157,0,'2013-07-06 12:44:30',NULL,NULL),(13584,'13846','S','Franklin','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340556,-75.165556,0,'2013-07-06 12:44:31',NULL,NULL),(33589,'37605','P','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.347307,-82.332037,0,'2013-07-06 12:44:32',NULL,NULL),(1079,'00725','S','Urb Batista','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(54218,'62650','S','Arnold','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(39324,'44610','P','Berlin','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.558598,-81.809134,0,'2013-07-06 12:44:32',NULL,NULL),(61833,'73113','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.564075,-97.501487,0,'2013-07-06 12:44:33',NULL,NULL),(57676,'67220','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.746820,-97.274780,0,'2013-07-06 12:44:33',NULL,NULL),(35512,'39532','S','Saint Martin','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.461218,-88.949246,0,'2013-07-06 12:44:32',NULL,NULL),(22844,'24528','S','Brookneal','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.054719,-78.946910,0,'2013-07-06 12:44:31',NULL,NULL),(20972,'21792','P','Unionville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.474806,-77.187221,0,'2013-07-06 12:44:31',NULL,NULL),(31959,'35210','S','Rose Hill','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(65961,'78280','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.561734,-98.355891,0,'2013-07-06 12:44:34',NULL,NULL),(37696,'42254','S','Hopkinsville','N','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.658712,-87.647685,0,'2013-07-06 12:44:32',NULL,NULL),(9071,'09004','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(40335,'45505','S','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.908372,-83.780134,0,'2013-07-06 12:44:32',NULL,NULL),(2500,'00957','S','Bda Calderon','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(15916,'17018','S','Middle Paxton','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.370886,-76.931434,0,'2013-07-06 12:44:31',NULL,NULL),(13794,'14174','S','Youngstown','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.249215,-79.026030,0,'2013-07-06 12:44:31',NULL,NULL),(43215,'48307','S','Rochester Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657341,-83.123033,0,'2013-07-06 12:44:32',NULL,NULL),(44930,'50359','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595835,-93.764981,0,'2013-07-06 12:44:32',NULL,NULL),(59835,'71242','P','Forest','D','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.859905,-91.390790,0,'2013-07-06 12:44:33',NULL,NULL),(80008,'99674','P','Sutton','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.796667,-148.462778,0,'2013-07-06 12:44:34',NULL,NULL),(12175,'12762','S','Mongaup Valley','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.688622,-74.802774,0,'2013-07-06 12:44:30',NULL,NULL),(12436,'12957','S','Moira','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.868120,-74.563980,0,'2013-07-06 12:44:30',NULL,NULL),(52196,'60474','P','South Wilmington','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.173333,-88.263889,0,'2013-07-06 12:44:33',NULL,NULL),(16768,'17522','S','Durlach','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(28751,'31999','U','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.457882,-84.988344,0,'2013-07-06 12:44:32',NULL,NULL),(352,'00656','S','Urb Stella','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(70988,'85709','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.231493,-111.013919,0,'2013-07-06 12:44:34',NULL,NULL),(72527,'89163','U','Citibank','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.174641,-115.138381,0,'2013-07-06 12:44:34',NULL,NULL),(114,'00612','S','Urb San Felipe','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(40959,'46310','S','Kersey','N','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.184919,-87.209975,0,'2013-07-06 12:44:32',NULL,NULL),(32561,'36114','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405544,-86.248050,0,'2013-07-06 12:44:32',NULL,NULL),(1860,'00791','S','Jard de Humacao','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(25181,'28052','S','Ridge','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(41646,'47136','S','Lanesville','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.242776,-85.930962,0,'2013-07-06 12:44:32',NULL,NULL),(53836,'62312','S','El Dara','N','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.691709,-91.023573,0,'2013-07-06 12:44:33',NULL,NULL),(63079,'75244','S','Farmers Brnch','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.939490,-96.838730,0,'2013-07-06 12:44:33',NULL,NULL),(17194,'17821','S','Deiblers','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(1761,'00780','S','Ext Lago Horizonte','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(52055,'60199','S','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.916124,-88.103082,0,'2013-07-06 12:44:33',NULL,NULL),(46909,'54131','P','Kaukauna','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.386389,-88.288611,0,'2013-07-06 12:44:32',NULL,NULL),(26525,'29203','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(35116,'39210','U','Millsaps College','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.276055,-90.218261,0,'2013-07-06 12:44:32',NULL,NULL),(58709,'68933','S','Marshall','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.528949,-98.058999,0,'2013-07-06 12:44:33',NULL,NULL),(50199,'57570','P','Rosebud Indian Reservation','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.268101,-100.736849,0,'2013-07-06 12:44:33',NULL,NULL),(28525,'31547','S','Kings Bay','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.834844,-81.773454,0,'2013-07-06 12:44:32',NULL,NULL),(47469,'54738','S','Eleva','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.572874,-91.472242,0,'2013-07-06 12:44:32',NULL,NULL),(5362,'04623','S','Columbia Falls','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.707438,-67.773645,0,'2013-07-06 12:44:30',NULL,NULL),(26906,'29579','S','Carolina Forest','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.655004,-78.945276,0,'2013-07-06 12:44:31',NULL,NULL),(21940,'23231','S','Millers','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(43691,'48883','S','Shepherd','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.523860,-84.731401,0,'2013-07-06 12:44:32',NULL,NULL),(51228,'59062','S','Otter','D','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.397871,-105.983338,0,'2013-07-06 12:44:33',NULL,NULL),(58337,'68461','S','Walton','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.755755,-96.512662,0,'2013-07-06 12:44:33',NULL,NULL),(68182,'81022','S','Avondale','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.179817,-104.390761,0,'2013-07-06 12:44:34',NULL,NULL),(76589,'95683','S','Sloughhouse','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.496180,-121.127280,0,'2013-07-06 12:44:34',NULL,NULL),(37295,'41632','S','Gunlock','D','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.550571,-82.947420,0,'2013-07-06 12:44:32',NULL,NULL),(9620,'10033','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(13495,'13803','S','Marathon','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(70787,'85353','S','Tolleson','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.413557,-112.273803,0,'2013-07-06 12:44:34',NULL,NULL),(73910,'92014','S','Del Mar','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.961870,-117.232665,0,'2013-07-06 12:44:34',NULL,NULL),(54652,'62930','S','Eldorado','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(23884,'26164','S','Sherman','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.952720,-81.756120,0,'2013-07-06 12:44:31',NULL,NULL),(260,'00641','S','Ext San Martin','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(37183,'41501','S','Piso','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(13985,'14504','S','Manchester','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.969996,-77.229900,0,'2013-07-06 12:44:31',NULL,NULL),(20398,'20898','P','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.142887,-77.202815,0,'2013-07-06 12:44:31',NULL,NULL),(42087,'47459','S','Hendricksville','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.123646,-86.753712,0,'2013-07-06 12:44:32',NULL,NULL),(46381,'53140','S','Kenosha','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.577888,-87.830792,0,'2013-07-06 12:44:32',NULL,NULL),(47183,'54481','S','Stevens Point','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(52879,'61344','S','Mineral','D','Bureau','17011','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.383083,-89.840185,0,'2013-07-06 12:44:33',NULL,NULL),(54184,'62626','S','Carlinville','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.282298,-89.878029,0,'2013-07-06 12:44:33',NULL,NULL),(62880,'75048','S','Sachse','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.968200,-96.583260,0,'2013-07-06 12:44:33',NULL,NULL),(78130,'97530','S','Applegate','A','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.186180,-123.056520,0,'2013-07-06 12:44:34',NULL,NULL),(36667,'41011','S','Fort Wright','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(66221,'78559','S','Lafkin','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.156158,-97.824324,0,'2013-07-06 12:44:34',NULL,NULL),(13820,'14215','S','Snyder','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.933454,-78.811840,0,'2013-07-06 12:44:31',NULL,NULL),(21328,'22408','S','Fred','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(54188,'62627','S','Chandlerville','D','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.051276,-90.147153,0,'2013-07-06 12:44:33',NULL,NULL),(1161,'00727','S','Urb Arbolada','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(29540,'32795','P','Lake Mary','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.758848,-81.331901,0,'2013-07-06 12:44:32',NULL,NULL),(8484,'08093','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.859740,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(22148,'23457','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.618897,-76.058292,0,'2013-07-06 12:44:31',NULL,NULL),(42491,'47840','S','Saline City','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.376944,-87.100716,0,'2013-07-06 12:44:32',NULL,NULL),(49923,'57321','S','Canova','D','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.893120,-97.542420,0,'2013-07-06 12:44:33',NULL,NULL),(57365,'66739','S','Spring Grove','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.069390,-94.633351,0,'2013-07-06 12:44:33',NULL,NULL),(21021,'21853','S','Princess Anne','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.190240,-75.694800,0,'2013-07-06 12:44:31',NULL,NULL),(19896,'20540','U','Library of Congress','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889270,-77.004711,0,'2013-07-06 12:44:31',NULL,NULL),(36192,'40258','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.142310,-85.861886,0,'2013-07-06 12:44:32',NULL,NULL),(24616,'27342','P','Sedalia','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.077179,-79.624155,0,'2013-07-06 12:44:31',NULL,NULL),(6477,'05764','S','South Poultney','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.518045,-73.236985,0,'2013-07-06 12:44:30',NULL,NULL),(58273,'68402','S','Malcolm','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.910990,-96.868127,0,'2013-07-06 12:44:33',NULL,NULL),(6118,'05458','S','Adams Landing','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.717862,-73.300101,0,'2013-07-06 12:44:30',NULL,NULL),(3439,'01754','S','Maynard','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.430993,-71.451177,0,'2013-07-06 12:44:30',NULL,NULL),(78993,'98381','S','Sekiu','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.265945,-124.306682,0,'2013-07-06 12:44:34',NULL,NULL),(43511,'48634','S','Linwood','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.749601,-84.040156,0,'2013-07-06 12:44:32',NULL,NULL),(37548,'42064','S','Levias','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(48013,'55170','U','US Bank Visa','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944443,-93.092404,0,'2013-07-06 12:44:33',NULL,NULL),(12737,'13165','S','Junius','N','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.907458,-76.877046,0,'2013-07-06 12:44:30',NULL,NULL),(9798,'10109','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(44326,'49752','S','Kinross','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.364888,-84.844438,0,'2013-07-06 12:44:32',NULL,NULL),(12052,'12531','S','Holmes','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.504700,-73.661640,0,'2013-07-06 12:44:30',NULL,NULL),(5983,'05346','S','Putney','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.955143,-72.565046,0,'2013-07-06 12:44:30',NULL,NULL),(57542,'67024','S','Cedar Vale','D','Chautauqua','20019','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.106753,-96.499615,0,'2013-07-06 12:44:33',NULL,NULL),(51765,'60030','S','Wildwood','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(41049,'46406','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.587301,-87.411577,0,'2013-07-06 12:44:32',NULL,NULL),(7406,'06794','S','Washington Depot','D','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.649297,-73.322807,0,'2013-07-06 12:44:30',NULL,NULL),(71452,'87045','S','Prewitt','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.342097,-108.112957,0,'2013-07-06 12:44:34',NULL,NULL),(67168,'79836','S','Clint','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.593077,-106.239404,0,'2013-07-06 12:44:34',NULL,NULL),(49809,'57201','S','Kampeska','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(7538,'07008','S','Carteret','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.584894,-74.234297,0,'2013-07-06 12:44:30',NULL,NULL),(37760,'42332','P','Cleaton','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.252816,-87.092264,0,'2013-07-06 12:44:32',NULL,NULL),(32487,'36051','S','Mountain Creek','N','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.668183,-86.517425,0,'2013-07-06 12:44:32',NULL,NULL),(14395,'15051','S','Indianola','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.566841,-79.871404,0,'2013-07-06 12:44:31',NULL,NULL),(33141,'36912','S','Yantley','N','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.222880,-88.326180,0,'2013-07-06 12:44:32',NULL,NULL),(44960,'50395','S','USPS Bmc','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.600964,-93.630768,0,'2013-07-06 12:44:32',NULL,NULL),(43002,'48160','S','Oakville','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(23405,'25325','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.354475,-81.627292,0,'2013-07-06 12:44:31',NULL,NULL),(41424,'46845','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.201330,-85.112447,0,'2013-07-06 12:44:32',NULL,NULL),(68825,'82501','S','Riverton','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(53670,'62215','S','Albers','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.510000,-89.619444,0,'2013-07-06 12:44:33',NULL,NULL),(3569,'01952','S','Salisbury Beach','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.843480,-70.820580,0,'2013-07-06 12:44:30',NULL,NULL),(20949,'21774','S','Lake Linganore','N','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.406320,-77.296380,0,'2013-07-06 12:44:31',NULL,NULL),(51853,'60073','S','Round Lake Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(27332,'30035','S','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.726646,-84.207866,0,'2013-07-06 12:44:31',NULL,NULL),(27528,'30217','S','Ctrlhatchee','A','Heard','13149','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.308377,-85.109975,0,'2013-07-06 12:44:31',NULL,NULL),(33253,'37080','S','Joelton','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.329107,-86.905779,0,'2013-07-06 12:44:32',NULL,NULL),(74854,'93250','S','Mc Farland','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.679779,-119.224936,0,'2013-07-06 12:44:34',NULL,NULL),(53332,'61752','S','Le Roy','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.346851,-88.766920,0,'2013-07-06 12:44:33',NULL,NULL),(3589,'02021','S','Canton','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.164447,-71.131647,0,'2013-07-06 12:44:30',NULL,NULL),(21792,'23075','S','Highland Springs','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.546429,-77.325289,0,'2013-07-06 12:44:31',NULL,NULL),(50976,'58638','S','Hebron','D','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.900954,-102.033164,0,'2013-07-06 12:44:33',NULL,NULL),(70655,'85201','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.430515,-111.840854,0,'2013-07-06 12:44:34',NULL,NULL),(11434,'11969','P','S Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.965942,-72.357568,0,'2013-07-06 12:44:30',NULL,NULL),(17430,'17929','S','West Cressona','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.628948,-76.193868,0,'2013-07-06 12:44:31',NULL,NULL),(58178,'68305','S','North Auburn','N','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.390284,-95.842607,0,'2013-07-06 12:44:33',NULL,NULL),(56989,'66203','S','Merriam','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(10133,'10261','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(8877,'08695','U','NJ Taxation Dept','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.220861,-74.764864,0,'2013-07-06 12:44:30',NULL,NULL),(25617,'28461','S','Bald Head','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(33778,'37872','S','Burrville','N','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.270660,-84.691200,0,'2013-07-06 12:44:32',NULL,NULL),(77888,'97281','P','Tigard','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.441124,-122.779329,0,'2013-07-06 12:44:34',NULL,NULL),(53545,'62037','S','Quarry','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.971812,-90.445426,0,'2013-07-06 12:44:33',NULL,NULL),(9331,'09744','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(50539,'58122','U','Sanford','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.881557,-96.784709,0,'2013-07-06 12:44:33',NULL,NULL),(50002,'57375','S','Stickney','D','Aurora','46003','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.586250,-98.561284,0,'2013-07-06 12:44:33',NULL,NULL),(49251,'56474','S','Swanburg','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(4104,'02703','S','Attleboro','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.939160,-71.302800,0,'2013-07-06 12:44:30',NULL,NULL),(149,'00617','S','Repto Las Llanadas','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(70845,'85542','S','Peridot','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.315190,-110.451540,0,'2013-07-06 12:44:34',NULL,NULL),(35344,'39437','S','Walters','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(48572,'55771','S','Ash Lake','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(66580,'78745','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.208076,-97.800448,0,'2013-07-06 12:44:34',NULL,NULL),(65941,'78257','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.656582,-98.617388,0,'2013-07-06 12:44:34',NULL,NULL),(65351,'77523','S','Beach City','A','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(7047,'06279','S','East Willington','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.895780,-72.264300,0,'2013-07-06 12:44:30',NULL,NULL),(17826,'18414','S','Scott Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.532124,-75.732122,0,'2013-07-06 12:44:31',NULL,NULL),(48029,'55303','S','Oak Grove','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.261223,-93.440539,0,'2013-07-06 12:44:33',NULL,NULL),(36577,'40946','S','Green Road','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.010050,-83.896526,0,'2013-07-06 12:44:32',NULL,NULL),(71713,'87529','S','El Prado','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.448620,-105.574980,0,'2013-07-06 12:44:34',NULL,NULL),(15652,'16744','S','Rew','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.895778,-78.519135,0,'2013-07-06 12:44:31',NULL,NULL),(51401,'59432','P','Dupuyer','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.215159,-112.671463,0,'2013-07-06 12:44:33',NULL,NULL),(46518,'53274','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.040271,-87.907473,0,'2013-07-06 12:44:32',NULL,NULL),(72678,'89444','S','Aurora','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.842200,-119.367900,0,'2013-07-06 12:44:34',NULL,NULL),(11261,'11768','S','Eatons Neck','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(8373,'08054','S','Masonville','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.946438,-74.915955,0,'2013-07-06 12:44:30',NULL,NULL),(25646,'28468','S','Sunset Beach','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.884891,-78.508720,0,'2013-07-06 12:44:31',NULL,NULL),(22811,'24483','S','Vesuvius','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.807797,-79.222553,0,'2013-07-06 12:44:31',NULL,NULL),(49229,'56469','S','Palisade','D','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(15945,'17023','S','Elizabethvle','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.555025,-76.826794,0,'2013-07-06 12:44:31',NULL,NULL),(27720,'30345','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.850513,-84.286420,0,'2013-07-06 12:44:31',NULL,NULL),(2554,'00959','S','Repto Rivera','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(47855,'55077','S','Inver Grove Heights','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.839723,-93.076930,0,'2013-07-06 12:44:33',NULL,NULL),(13341,'13687','S','South Colton','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.501899,-74.856620,0,'2013-07-06 12:44:30',NULL,NULL),(59607,'71019','S','Martin','A','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(50871,'58521','S','Baldwin','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.980509,-100.749644,0,'2013-07-06 12:44:33',NULL,NULL),(16812,'17545','S','Elwyn Terrace','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(41818,'47336','S','Dunkirk','D','Jay','18075','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.374187,-85.208851,0,'2013-07-06 12:44:32',NULL,NULL),(4882,'04039','S','Gray','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.883914,-70.346256,0,'2013-07-06 12:44:30',NULL,NULL),(13612,'13862','S','Upper Lisle','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.357840,-75.938160,0,'2013-07-06 12:44:31',NULL,NULL),(31652,'34741','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.304764,-81.423148,0,'2013-07-06 12:44:32',NULL,NULL),(24106,'26524','S','Bretz','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.541498,-79.802342,0,'2013-07-06 12:44:31',NULL,NULL),(30929,'33710','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.788979,-82.729043,0,'2013-07-06 12:44:32',NULL,NULL),(63227,'75459','S','Howe','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.517500,-96.640380,0,'2013-07-06 12:44:33',NULL,NULL),(62675,'74652','S','Webb City','A','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.872222,-96.565278,0,'2013-07-06 12:44:33',NULL,NULL),(50397,'57770','S','Pine Ridge','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.232220,-102.696720,0,'2013-07-06 12:44:33',NULL,NULL),(38671,'43952','S','Steubenville','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.369140,-80.712600,0,'2013-07-06 12:44:32',NULL,NULL),(71346,'86514','S','Mexican Water','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750658,-109.364054,0,'2013-07-06 12:44:34',NULL,NULL),(78849,'98338','S','Thrift','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.033524,-122.293101,0,'2013-07-06 12:44:34',NULL,NULL),(27734,'30350','S','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975825,-84.325274,0,'2013-07-06 12:44:31',NULL,NULL),(45901,'52313','S','Mount Auburn','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.256626,-92.171137,0,'2013-07-06 12:44:32',NULL,NULL),(29813,'33025','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.992876,-80.274221,0,'2013-07-06 12:44:32',NULL,NULL),(37321,'41653','S','Bonanza','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(71963,'88005','S','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.323217,-106.805117,0,'2013-07-06 12:44:34',NULL,NULL),(1179,'00727','S','Valle Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(52841,'61318','S','Compton','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.699592,-89.081857,0,'2013-07-06 12:44:33',NULL,NULL),(50264,'57639','P','Little Eagle','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.679175,-100.799069,0,'2013-07-06 12:44:33',NULL,NULL),(11318,'11782','S','Fire Island Pines','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746049,-73.080662,0,'2013-07-06 12:44:30',NULL,NULL),(20556,'21123','P','Riviera Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.111974,-76.553563,0,'2013-07-06 12:44:31',NULL,NULL),(8394,'08061','S','Mount Royal','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.803964,-75.203019,0,'2013-07-06 12:44:30',NULL,NULL),(50253,'57631','S','Glenham','D','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.531715,-100.271893,0,'2013-07-06 12:44:33',NULL,NULL),(31658,'34745','P','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.302729,-81.409886,0,'2013-07-06 12:44:32',NULL,NULL),(27286,'30003','P','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.680810,-84.007320,0,'2013-07-06 12:44:31',NULL,NULL),(66686,'78941','S','Kovar','N','Fayette','48149','Texas','TX','48','0000','361','Central',-6.0,'Y',29.687084,-97.108065,0,'2013-07-06 12:44:34',NULL,NULL),(13469,'13786','S','West Harpersfield','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.434722,-74.723889,0,'2013-07-06 12:44:31',NULL,NULL),(72286,'88567','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769857,-106.328792,0,'2013-07-06 12:44:34',NULL,NULL),(26485,'29163','S','Vance','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.407034,-80.468950,0,'2013-07-06 12:44:31',NULL,NULL),(17810,'18407','S','Clifford Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(20790,'21542','P','Midland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.588970,-78.950252,0,'2013-07-06 12:44:31',NULL,NULL),(38811,'44072','S','Russell','A','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.472300,-81.335220,0,'2013-07-06 12:44:32',NULL,NULL),(37448,'41840','S','Neon','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.212627,-82.707115,0,'2013-07-06 12:44:32',NULL,NULL),(36613,'40977','S','Log Mountain','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(45000,'50446','S','Joice','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.361512,-93.454058,0,'2013-07-06 12:44:32',NULL,NULL),(55910,'64444','S','Edgerton','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.505807,-94.633325,0,'2013-07-06 12:44:33',NULL,NULL),(61219,'72321','P','Burdette','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.816597,-89.939769,0,'2013-07-06 12:44:33',NULL,NULL),(70693,'85259','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.601991,-111.813977,0,'2013-07-06 12:44:34',NULL,NULL),(72163,'88339','S','Mayhill','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.908298,-105.467489,0,'2013-07-06 12:44:34',NULL,NULL),(41336,'46782','P','Preble','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.833715,-85.014182,0,'2013-07-06 12:44:32',NULL,NULL),(27226,'29916','S','Grays','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.635320,-81.034920,0,'2013-07-06 12:44:31',NULL,NULL),(56154,'64856','S','Pineville','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.588540,-94.369980,0,'2013-07-06 12:44:33',NULL,NULL),(49568,'56722','S','Euclid','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',48.047293,-96.890781,0,'2013-07-06 12:44:33',NULL,NULL),(45306,'50836','S','Platteville','N','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648229,-94.530783,0,'2013-07-06 12:44:32',NULL,NULL),(42687,'47983','P','Stockwell','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.283659,-86.770630,0,'2013-07-06 12:44:32',NULL,NULL),(19171,'19731','P','Port Penn','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.515664,-75.574443,0,'2013-07-06 12:44:31',NULL,NULL),(53488,'61956','S','Villa Grove','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.863078,-88.156017,0,'2013-07-06 12:44:33',NULL,NULL),(30536,'33408','S','Palm Beach Gardens','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(27402,'30090','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.968982,-84.548663,0,'2013-07-06 12:44:31',NULL,NULL),(25225,'28090','S','Double Shoals','N','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.465460,-81.532440,0,'2013-07-06 12:44:31',NULL,NULL),(69556,'83814','S','Coeur D Alene','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.687824,-116.779638,0,'2013-07-06 12:44:34',NULL,NULL),(2232,'00926','S','Urb Experimental','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(9733,'10090','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(42848,'48075','S','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.464070,-83.225289,0,'2013-07-06 12:44:32',NULL,NULL),(15936,'17021','S','Waterloo','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(5874,'05149','S','Grahamville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.392420,-72.697140,0,'2013-07-06 12:44:30',NULL,NULL),(35239,'39327','S','Decatur','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.440159,-89.109307,0,'2013-07-06 12:44:32',NULL,NULL),(12821,'13303','S','West Branch','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.306203,-75.435640,0,'2013-07-06 12:44:30',NULL,NULL),(26592,'29225','U','Univ Of SC Students Mail','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998957,-81.030860,0,'2013-07-06 12:44:31',NULL,NULL),(46117,'52638','S','Middletown','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.824699,-91.262591,0,'2013-07-06 12:44:32',NULL,NULL),(55999,'64642','S','Gilman City','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.147080,-93.846120,0,'2013-07-06 12:44:33',NULL,NULL),(74014,'92120','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.795177,-117.068719,0,'2013-07-06 12:44:34',NULL,NULL),(79883,'99574','P','Cordova','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.074390,-147.992410,0,'2013-07-06 12:44:34',NULL,NULL),(55427,'63662','S','Patton','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.416507,-90.064187,0,'2013-07-06 12:44:33',NULL,NULL),(51241,'59071','S','Alpine','N','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.377011,-109.424177,0,'2013-07-06 12:44:33',NULL,NULL),(22677,'24313','S','Barren Spgs','A','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.913901,-80.807836,0,'2013-07-06 12:44:31',NULL,NULL),(75180,'93607','P','Riverdale','A','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.488333,-119.984167,0,'2013-07-06 12:44:34',NULL,NULL),(75375,'93933','S','East Garrison','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.683535,-121.792949,0,'2013-07-06 12:44:34',NULL,NULL),(77549,'96859','S','Tripler Amc','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.347002,-157.872476,0,'2013-07-06 12:44:34',NULL,NULL),(54930,'63107','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.663781,-90.213079,0,'2013-07-06 12:44:33',NULL,NULL),(18692,'19191','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952279,-75.165967,0,'2013-07-06 12:44:31',NULL,NULL),(37489,'42023','S','Bardwell','D','Carlisle','21039','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.874889,-89.008820,0,'2013-07-06 12:44:32',NULL,NULL),(28332,'31156','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.959963,-84.364913,0,'2013-07-06 12:44:32',NULL,NULL),(9453,'10007','S','Church Street','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(39776,'45121','S','Utopia','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(14868,'15464','S','Mill Run','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.966000,-79.457136,0,'2013-07-06 12:44:31',NULL,NULL),(36010,'40153','P','McQuady','N','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.707933,-86.521171,0,'2013-07-06 12:44:32',NULL,NULL),(11738,'12183','S','Troy','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744346,-73.695668,0,'2013-07-06 12:44:30',NULL,NULL),(29114,'32309','S','Miccosukee','A','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.597156,-84.041559,0,'2013-07-06 12:44:32',NULL,NULL),(46271,'53026','P','Greenbush','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.778693,-88.080218,0,'2013-07-06 12:44:32',NULL,NULL),(49860,'57248','S','Alsville','N','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.581820,-97.211073,0,'2013-07-06 12:44:33',NULL,NULL),(62099,'73620','S','Arapaho','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.580064,-98.962591,0,'2013-07-06 12:44:33',NULL,NULL),(68351,'81132','S','Freeman','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(74740,'93043','U','Naval Base Ventura County','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.162390,-119.201182,0,'2013-07-06 12:44:34',NULL,NULL),(79435,'98833','S','Mazama','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.643442,-120.211281,0,'2013-07-06 12:44:34',NULL,NULL),(62542,'74435','S','Gore','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.530194,-95.117900,0,'2013-07-06 12:44:33',NULL,NULL),(55492,'63770','S','Old Appleton','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.569514,-89.703774,0,'2013-07-06 12:44:33',NULL,NULL),(6515,'05822','S','Westmore','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.752209,-72.184037,0,'2013-07-06 12:44:30',NULL,NULL),(34546,'38721','S','Anguilla','D','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.974616,-90.831462,0,'2013-07-06 12:44:32',NULL,NULL),(68458,'81230','S','Taylor Park','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.453420,-106.609860,0,'2013-07-06 12:44:34',NULL,NULL),(72288,'88569','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769133,-106.331114,0,'2013-07-06 12:44:34',NULL,NULL),(75985,'95073','S','Soquel','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.008856,-121.950993,0,'2013-07-06 12:44:34',NULL,NULL),(4823,'03907','S','Ogunquit','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.257416,-70.602930,0,'2013-07-06 12:44:30',NULL,NULL),(57660,'67210','S','Planeview','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.627375,-97.263435,0,'2013-07-06 12:44:33',NULL,NULL),(42231,'47567','S','Algiers','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(14426,'15074','S','Rochester','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.708963,-80.270064,0,'2013-07-06 12:44:31',NULL,NULL),(32894,'36535','S','Oyster Bay','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.398083,-87.704195,0,'2013-07-06 12:44:32',NULL,NULL),(2381,'00949','S','Urb El Naranjal','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(44531,'49962','S','Skanee','D','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.871363,-88.163796,0,'2013-07-06 12:44:32',NULL,NULL),(43189,'48302','S','Bloomfield Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(24345,'27040','S','Vienna','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.167058,-80.376170,0,'2013-07-06 12:44:31',NULL,NULL),(56140,'64843','S','Goodman','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.737322,-94.406831,0,'2013-07-06 12:44:33',NULL,NULL),(72657,'89432','P','Sparks','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.540878,-119.747797,0,'2013-07-06 12:44:34',NULL,NULL),(896,'00705','S','Aibonito','D','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(64265,'76389','S','Antelope','N','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.580829,-98.431065,0,'2013-07-06 12:44:34',NULL,NULL),(62237,'73951','S','Tyrone','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.949359,-101.024269,0,'2013-07-06 12:44:33',NULL,NULL),(20857,'21659','S','Galestown','A','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.575555,-75.815263,0,'2013-07-06 12:44:31',NULL,NULL),(15767,'16915','S','Sweden','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(40070,'45275','P','Amf','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138322,-84.504469,0,'2013-07-06 12:44:32',NULL,NULL),(22877,'24572','S','Madison Heights','D','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.447984,-79.112687,0,'2013-07-06 12:44:31',NULL,NULL),(922,'00714','S','Jard de Arroyo','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(73625,'91408','P','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.175689,-118.430158,0,'2013-07-06 12:44:34',NULL,NULL),(43927,'49271','S','Pittsford','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.835985,-84.461354,0,'2013-07-06 12:44:32',NULL,NULL),(15013,'15673','P','North Apollo','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.591389,-79.556930,0,'2013-07-06 12:44:31',NULL,NULL),(43169,'48272','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.336958,-83.054444,0,'2013-07-06 12:44:32',NULL,NULL),(37650,'42171','S','Smiths Grove','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.022755,-86.184158,0,'2013-07-06 12:44:32',NULL,NULL),(30204,'33181','S','North Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(29647,'32903','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.116342,-80.582287,0,'2013-07-06 12:44:32',NULL,NULL),(51329,'59262','S','Savage','D','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.453876,-104.345096,0,'2013-07-06 12:44:33',NULL,NULL),(7843,'07463','S','Waldwick','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.012050,-74.127754,0,'2013-07-06 12:44:30',NULL,NULL),(16712,'17403','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(41831,'47342','S','Gaston','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.310795,-85.502413,0,'2013-07-06 12:44:32',NULL,NULL),(41629,'47130','S','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(37840,'42458','S','Spottsville','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.853559,-87.428941,0,'2013-07-06 12:44:32',NULL,NULL),(4953,'04102','S','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.663962,-70.291819,0,'2013-07-06 12:44:30',NULL,NULL),(24338,'27030','S','White Sulphur Springs','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490645,-80.628907,0,'2013-07-06 12:44:31',NULL,NULL),(24772,'27556','S','Middleburg','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.355080,-78.399025,0,'2013-07-06 12:44:31',NULL,NULL),(29821,'33027','S','Miramar','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.978093,-80.330196,0,'2013-07-06 12:44:32',NULL,NULL),(28260,'31069','S','Perry','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.458921,-83.730638,0,'2013-07-06 12:44:31',NULL,NULL),(45683,'52043','S','Osborne','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.856180,-91.404581,0,'2013-07-06 12:44:32',NULL,NULL),(56370,'65216','U','Columbia College','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.961050,-92.325791,0,'2013-07-06 12:44:33',NULL,NULL),(63795,'75959','S','Milane','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.481280,-93.838320,0,'2013-07-06 12:44:34',NULL,NULL),(938,'00715','S','Mercedita','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(54409,'62828','S','Dahlgren','D','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.189495,-88.540853,0,'2013-07-06 12:44:33',NULL,NULL),(43787,'49045','S','Decatur','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.119771,-85.998583,0,'2013-07-06 12:44:32',NULL,NULL),(22570,'24153','S','Bennett Springs','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(13838,'14221','S','Williamsville','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980183,-78.734894,0,'2013-07-06 12:44:31',NULL,NULL),(25803,'28607','S','Deerfield','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(26014,'28677','S','Celeste Hinkle','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(70878,'85609','P','Dragoon','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.029931,-110.047592,0,'2013-07-06 12:44:34',NULL,NULL),(14622,'15229','S','West View','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.517677,-80.040063,0,'2013-07-06 12:44:31',NULL,NULL),(65220,'77443','P','Glen Flora','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.344945,-96.191280,0,'2013-07-06 12:44:34',NULL,NULL),(58460,'68729','S','Bazile Mills','A','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.462700,-97.906128,0,'2013-07-06 12:44:33',NULL,NULL),(71943,'87935','P','Rock Canyon','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.195236,-107.218449,0,'2013-07-06 12:44:34',NULL,NULL),(5968,'05303','P','Brattleboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.854637,-72.558621,0,'2013-07-06 12:44:30',NULL,NULL),(58785,'68977','S','Sappa','N','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.089103,-99.575329,0,'2013-07-06 12:44:33',NULL,NULL),(47956,'55119','S','Maplewood','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.938568,-93.002788,0,'2013-07-06 12:44:33',NULL,NULL),(12140,'12727','P','Cochecton Ctr','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.640608,-74.968130,0,'2013-07-06 12:44:30',NULL,NULL),(6036,'05405','U','UVM','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.477327,-73.203176,0,'2013-07-06 12:44:30',NULL,NULL),(72775,'89557','U','Univ Nv Reno','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.539719,-119.818005,0,'2013-07-06 12:44:34',NULL,NULL),(24803,'27593','P','Wilsons Mills','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.604395,-78.341248,0,'2013-07-06 12:44:31',NULL,NULL),(1208,'00728','S','Res Perla Del Bucana','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(65026,'77325','P','Humble','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.068280,-95.216280,0,'2013-07-06 12:44:34',NULL,NULL),(11325,'11787','S','Village Of The Branch','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.855292,-73.209738,0,'2013-07-06 12:44:30',NULL,NULL),(37735,'42301','S','Saint Joseph','A','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.747812,-87.178813,0,'2013-07-06 12:44:32',NULL,NULL),(79511,'98925','P','Easton','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.238991,-121.179797,0,'2013-07-06 12:44:34',NULL,NULL),(42870,'48082','S','St Clair Shrs','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.529366,-82.887803,0,'2013-07-06 12:44:32',NULL,NULL),(5248,'04478','S','Plymouth Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(41775,'47304','S','Brewington Woods','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(71900,'87749','P','Ute Park','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.562308,-105.101040,0,'2013-07-06 12:44:34',NULL,NULL),(68756,'82227','S','Manville','D','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.778823,-104.616179,0,'2013-07-06 12:44:34',NULL,NULL),(2184,'00926','S','Mans de Caldas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(12922,'13339','S','Stone Arabia','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(3568,'01952','S','Salisbury Bch','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.843480,-70.820580,0,'2013-07-06 12:44:30',NULL,NULL),(63204,'75439','S','Ector','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.574815,-96.268692,0,'2013-07-06 12:44:33',NULL,NULL),(5220,'04461','S','Milford','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.945800,-68.635601,0,'2013-07-06 12:44:30',NULL,NULL),(36262,'40330','S','Cornishville','A','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.789200,-84.861780,0,'2013-07-06 12:44:32',NULL,NULL),(59208,'70392','S','Idlewild','N','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.698890,-91.305847,0,'2013-07-06 12:44:33',NULL,NULL),(19435,'20106','S','Amissville','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.671345,-77.996631,0,'2013-07-06 12:44:31',NULL,NULL),(24583,'27317','S','New Salem','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.841660,-79.816020,0,'2013-07-06 12:44:31',NULL,NULL),(70267,'84523','P','Ferron','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.089869,-111.126484,0,'2013-07-06 12:44:34',NULL,NULL),(65794,'78124','S','Santa Clara','A','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.574239,-98.150612,0,'2013-07-06 12:44:34',NULL,NULL),(22487,'24064','S','Blue Ridge','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.377288,-79.824583,0,'2013-07-06 12:44:31',NULL,NULL),(20191,'20748','S','Temple Hills','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(47191,'54486','S','Morris','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.743866,-89.041687,0,'2013-07-06 12:44:32',NULL,NULL),(15834,'16935','S','Middlebury','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(15199,'15956','S','Ehrenfeld','N','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.365677,-78.792021,0,'2013-07-06 12:44:31',NULL,NULL),(7588,'07036','S','Linden','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.635633,-74.256169,0,'2013-07-06 12:44:30',NULL,NULL),(78252,'97835','S','Helix','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.911186,-118.848872,0,'2013-07-06 12:44:34',NULL,NULL),(78502,'98110','S','Seattle','A','Kitsap','53035','Washington','WA','53','1150','206/564','Pacific',-8.0,'Y',47.648322,-122.533526,0,'2013-07-06 12:44:34',NULL,NULL),(64503,'76631','S','Bynum','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.985653,-96.968659,0,'2013-07-06 12:44:34',NULL,NULL),(31360,'34205','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.484977,-82.585541,0,'2013-07-06 12:44:32',NULL,NULL),(26462,'29147','P','State Park','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.113735,-80.954384,0,'2013-07-06 12:44:31',NULL,NULL),(11924,'12422','S','Durham','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.409931,-74.182742,0,'2013-07-06 12:44:30',NULL,NULL),(74180,'92275','P','Thermal','A','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.640389,-116.141879,0,'2013-07-06 12:44:34',NULL,NULL),(19389,'20067','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898458,-77.043288,0,'2013-07-06 12:44:31',NULL,NULL),(39425,'44679','P','Stillwater','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.320910,-81.309501,0,'2013-07-06 12:44:32',NULL,NULL),(31373,'34211','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(26770,'29439','P','Folly Beach','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.661442,-79.937395,0,'2013-07-06 12:44:31',NULL,NULL),(3022,'01089','S','W Springfield','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.117059,-72.639407,0,'2013-07-06 12:44:30',NULL,NULL),(76873,'95973','S','Cohasset','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.737451,-121.830460,0,'2013-07-06 12:44:34',NULL,NULL),(7705,'07184','U','Cenlar Bank','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.725585,-74.218488,0,'2013-07-06 12:44:30',NULL,NULL),(14966,'15627','S','Derry','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.351649,-79.289656,0,'2013-07-06 12:44:31',NULL,NULL),(30289,'33265','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737256,-80.411116,0,'2013-07-06 12:44:32',NULL,NULL),(32377,'35903','S','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.993300,-85.905900,0,'2013-07-06 12:44:32',NULL,NULL),(40595,'45883','S','Saint Henry','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.409173,-84.633077,0,'2013-07-06 12:44:32',NULL,NULL),(36273,'40336','S','Winston','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(50769,'58421','S','Rose Hill','N','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(7567,'07026','S','Garfield','D','Bergen','34003','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.879414,-74.109454,0,'2013-07-06 12:44:30',NULL,NULL),(9743,'10095','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748793,-73.989926,0,'2013-07-06 12:44:30',NULL,NULL),(37232,'41543','S','Mc Andrews','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537673,-82.262326,0,'2013-07-06 12:44:32',NULL,NULL),(57596,'67104','S','Medicine Lodge','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.283493,-98.578275,0,'2013-07-06 12:44:33',NULL,NULL),(47383,'54631','S','Gays Mills','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.291823,-90.867048,0,'2013-07-06 12:44:32',NULL,NULL),(72506,'89151','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.145667,-115.227731,0,'2013-07-06 12:44:34',NULL,NULL),(79924,'99609','P','Kasigluk','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.880393,-162.042542,0,'2013-07-06 12:44:34',NULL,NULL),(51359,'59338','S','Kinsey','D','Custer','30017','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.662103,-105.872622,0,'2013-07-06 12:44:33',NULL,NULL),(20756,'21411','U','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.971614,-76.499864,0,'2013-07-06 12:44:31',NULL,NULL),(37662,'42210','S','Sunfish','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.198402,-86.277888,0,'2013-07-06 12:44:32',NULL,NULL),(71198,'86053','P','Kaibeto','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.590000,-111.070000,0,'2013-07-06 12:44:34',NULL,NULL),(78264,'97848','S','Kimberly','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.695458,-119.581679,0,'2013-07-06 12:44:34',NULL,NULL),(7465,'06877','S','Ridgefield','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.299046,-73.497650,0,'2013-07-06 12:44:30',NULL,NULL),(32068,'35282','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.495620,-86.794338,0,'2013-07-06 12:44:32',NULL,NULL),(68493,'81301','S','Durango','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.326840,-107.831460,0,'2013-07-06 12:44:34',NULL,NULL),(77717,'97060','S','Springdale','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.527631,-122.397778,0,'2013-07-06 12:44:34',NULL,NULL),(39155,'44288','S','Drakesburg','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.242226,-81.056024,0,'2013-07-06 12:44:32',NULL,NULL),(34769,'38863','S','Plymouth','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(73023,'90071','S','Arco Plaza','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.053598,-118.255851,0,'2013-07-06 12:44:34',NULL,NULL),(15203,'15959','P','Tire Hill','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.269128,-78.917762,0,'2013-07-06 12:44:31',NULL,NULL),(11152,'11717','S','West Brentwood','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.780920,-73.254540,0,'2013-07-06 12:44:30',NULL,NULL),(48811,'56024','S','Eagle Lake','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.165184,-93.882855,0,'2013-07-06 12:44:33',NULL,NULL),(31171,'33918','P','No Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(27636,'30315','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.708343,-84.384090,0,'2013-07-06 12:44:31',NULL,NULL),(26488,'29164','S','New Holland','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.654721,-81.433390,0,'2013-07-06 12:44:31',NULL,NULL),(19536,'20191','S','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.941053,-77.346029,0,'2013-07-06 12:44:31',NULL,NULL),(8595,'08232','S','Bargaintown','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(26750,'29424','U','The College of Charleston','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.783715,-79.939185,0,'2013-07-06 12:44:31',NULL,NULL),(13028,'13431','S','Russia','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.205100,-75.072600,0,'2013-07-06 12:44:30',NULL,NULL),(40109,'45318','S','Covington','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.127549,-84.348416,0,'2013-07-06 12:44:32',NULL,NULL),(33209,'37048','S','Walnut Grove','A','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.491451,-86.594531,0,'2013-07-06 12:44:32',NULL,NULL),(29358,'32568','S','Mc David','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.869340,-87.453840,0,'2013-07-06 12:44:32',NULL,NULL),(29126,'32317','S','Centerville','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.567200,-84.111895,0,'2013-07-06 12:44:32',NULL,NULL),(75126,'93552','S','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.558636,-118.040632,0,'2013-07-06 12:44:34',NULL,NULL),(61336,'72460','S','Ravenden Springs','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.360741,-91.243680,0,'2013-07-06 12:44:33',NULL,NULL),(8393,'08060','S','Westampton Township','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(58686,'68923','P','Rock Falls','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.453315,-99.343230,0,'2013-07-06 12:44:33',NULL,NULL),(31740,'34986','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.321528,-80.418405,0,'2013-07-06 12:44:32',NULL,NULL),(76580,'95679','P','Rumsey','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.899229,-122.290850,0,'2013-07-06 12:44:34',NULL,NULL),(78839,'98335','S','Warren','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(40810,'46186','S','Wilkinson','D','Hancock','18059','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.885591,-85.608655,0,'2013-07-06 12:44:32',NULL,NULL),(24197,'26675','P','Keslers Cross Lanes','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.234705,-80.936228,0,'2013-07-06 12:44:31',NULL,NULL),(39161,'44303','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.102498,-81.534990,0,'2013-07-06 12:44:32',NULL,NULL),(30783,'33594','S','Valrico','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.916416,-82.249089,0,'2013-07-06 12:44:32',NULL,NULL),(23193,'25054','P','Dawes','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.144612,-81.449858,0,'2013-07-06 12:44:31',NULL,NULL),(63453,'75682','P','Old London','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.242434,-94.946652,0,'2013-07-06 12:44:33',NULL,NULL),(57382,'66751','S','La Harpe','D','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.917335,-95.313982,0,'2013-07-06 12:44:33',NULL,NULL),(40471,'45767','S','New Matamoras','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.603478,-81.082854,0,'2013-07-06 12:44:32',NULL,NULL),(58312,'68438','P','Sprague','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.625890,-96.743445,0,'2013-07-06 12:44:33',NULL,NULL),(28114,'30808','S','Dearing','D','McDuffie','13189','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.463274,-82.495096,0,'2013-07-06 12:44:31',NULL,NULL),(59171,'70343','S','Bourg','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.550346,-90.609110,0,'2013-07-06 12:44:33',NULL,NULL),(74501,'92628','P','Costa Mesa','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.640149,-117.915876,0,'2013-07-06 12:44:34',NULL,NULL),(66901,'79256','S','Roaring Springs','D','Motley','48345','Texas','TX','48','0000','806','Central',-6.0,'Y',33.901550,-100.855415,0,'2013-07-06 12:44:34',NULL,NULL),(65430,'77583','S','Iowa Colony','N','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.408146,-95.441666,0,'2013-07-06 12:44:34',NULL,NULL),(60953,'72101','S','Pumpkin Bend','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(51482,'59547','S','Zurich','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.654051,-109.212878,0,'2013-07-06 12:44:33',NULL,NULL),(45712,'52065','S','New Vienna','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.560057,-91.088019,0,'2013-07-06 12:44:32',NULL,NULL),(45580,'51536','S','Hancock','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.389497,-95.357103,0,'2013-07-06 12:44:32',NULL,NULL),(17160,'17813','S','Beavertown','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.752664,-77.170638,0,'2013-07-06 12:44:31',NULL,NULL),(9719,'10081','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(37568,'42076','S','Hamlin','A','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.598904,-88.067577,0,'2013-07-06 12:44:32',NULL,NULL),(44061,'49441','S','Roosevelt Pk','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168889,-86.263889,0,'2013-07-06 12:44:32',NULL,NULL),(45073,'50523','S','Callender','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.360744,-94.292047,0,'2013-07-06 12:44:32',NULL,NULL),(55867,'64188','P','K C','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.099722,-94.578333,0,'2013-07-06 12:44:33',NULL,NULL),(49705,'57033','S','Hartford','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.627967,-96.942970,0,'2013-07-06 12:44:33',NULL,NULL),(33095,'36849','U','Auburn Univ','A','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.602139,-85.508496,0,'2013-07-06 12:44:32',NULL,NULL),(64756,'76936','S','Eldorado','D','Schleicher','48413','Texas','TX','48','0000','325','Central',-6.0,'Y',30.861414,-100.591893,0,'2013-07-06 12:44:34',NULL,NULL),(62509,'74401','S','Beland','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(46709,'53794','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.098373,-89.324921,0,'2013-07-06 12:44:32',NULL,NULL),(66640,'78834','S','Carrizo Springs','D','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.520700,-99.888480,0,'2013-07-06 12:44:34',NULL,NULL),(35674,'39654','S','Robinwood','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(18324,'19025','S','Dresher','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.139401,-75.223398,0,'2013-07-06 12:44:31',NULL,NULL),(34369,'38610','S','Cotton Plant','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.670141,-89.019896,0,'2013-07-06 12:44:32',NULL,NULL),(21689,'22963','S','Palmyra','D','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(34743,'38851','S','Sonora','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897840,-88.990980,0,'2013-07-06 12:44:32',NULL,NULL),(15690,'16839','S','Grassflat','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.005040,-78.134037,0,'2013-07-06 12:44:31',NULL,NULL),(24346,'27041','S','Pilot Mnt','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.450094,-80.489865,0,'2013-07-06 12:44:31',NULL,NULL),(73599,'91390','S','Canyon Country','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(4832,'04002','S','Lyman','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.492177,-70.705903,0,'2013-07-06 12:44:30',NULL,NULL),(73737,'91708','S','Chino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.022678,-117.686018,0,'2013-07-06 12:44:34',NULL,NULL),(20350,'20860','S','Sandy Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.149764,-77.027379,0,'2013-07-06 12:44:31',NULL,NULL),(17821,'18411','S','South Abington Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(49169,'56398','P','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.482713,-94.248423,0,'2013-07-06 12:44:33',NULL,NULL),(39076,'44215','S','Chippewa Lake','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.068001,-81.904211,0,'2013-07-06 12:44:32',NULL,NULL),(77402,'96781','S','Papaikou','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.793534,-155.191151,0,'2013-07-06 12:44:34',NULL,NULL),(53427,'61856','S','Lodge','A','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.021922,-88.574094,0,'2013-07-06 12:44:33',NULL,NULL),(32867,'36521','S','Georgetown','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.974220,-88.126860,0,'2013-07-06 12:44:32',NULL,NULL),(23468,'25441','P','Rippon','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.228204,-77.922225,0,'2013-07-06 12:44:31',NULL,NULL),(73919,'92024','S','Encinitas','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.055326,-117.263733,0,'2013-07-06 12:44:34',NULL,NULL),(22976,'24732','P','Kellysville','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.341698,-80.927810,0,'2013-07-06 12:44:31',NULL,NULL),(870,'00698','S','Urb San Francisco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(15060,'15727','P','Clune','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.548374,-79.307780,0,'2013-07-06 12:44:31',NULL,NULL),(23672,'25836','P','Eccles','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.782512,-81.265817,0,'2013-07-06 12:44:31',NULL,NULL),(69011,'83209','U','ISU','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.875640,-112.470880,0,'2013-07-06 12:44:34',NULL,NULL),(71691,'87518','P','Cebolla','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.674238,-106.551589,0,'2013-07-06 12:44:34',NULL,NULL),(63401,'75652','S','Chapman','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(17205,'17821','S','Valley','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(2624,'00962','S','Urb Bay View','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(76770,'95930','S','La Porte','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.524451,-121.230273,0,'2013-07-06 12:44:34',NULL,NULL),(70795,'85361','S','Wittmann','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.752969,-112.511086,0,'2013-07-06 12:44:34',NULL,NULL),(68259,'81067','S','Rocky Ford','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.044708,-103.717601,0,'2013-07-06 12:44:34',NULL,NULL),(34697,'38829','S','Blackland','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(51526,'59713','P','Avon','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.781637,-112.757140,0,'2013-07-06 12:44:33',NULL,NULL),(61033,'72117','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(14335,'15004','P','Atlasburg','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.383783,-80.389826,0,'2013-07-06 12:44:31',NULL,NULL),(66232,'78566','S','Indian Lake','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.085000,-97.461600,0,'2013-07-06 12:44:34',NULL,NULL),(21677,'22958','S','Wintergreen','N','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.863180,-78.871080,0,'2013-07-06 12:44:31',NULL,NULL),(72151,'88325','P','Hi Rls Mtn Pk','A','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.076011,-106.025093,0,'2013-07-06 12:44:34',NULL,NULL),(11745,'12187','S','Patria','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.614747,-74.475755,0,'2013-07-06 12:44:30',NULL,NULL),(678,'00683','S','Urb Riverside','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(67088,'79698','U','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.474862,-99.732695,0,'2013-07-06 12:44:34',NULL,NULL),(20653,'21226','S','Baltimore','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(45688,'52047','S','Farmersburg','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.947298,-91.311574,0,'2013-07-06 12:44:32',NULL,NULL),(19702,'20376','S','Washington Navy Yard','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916809,-76.993655,0,'2013-07-06 12:44:31',NULL,NULL),(9350,'09805','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(67214,'79918','S','Fort Bliss','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.847479,-106.378199,0,'2013-07-06 12:44:34',NULL,NULL),(62209,'73844','S','Knowles','A','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.914570,-100.128511,0,'2013-07-06 12:44:33',NULL,NULL),(51792,'60046','S','Lake Villa','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(33730,'37816','P','Morristown','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.192124,-83.372532,0,'2013-07-06 12:44:32',NULL,NULL),(533,'00674','S','Villa Nitza','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(28035,'30645','P','High Shoals','D','Oconee','13219','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.820756,-83.502472,0,'2013-07-06 12:44:31',NULL,NULL),(29992,'33111','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.766472,-80.194770,0,'2013-07-06 12:44:32',NULL,NULL),(58102,'68113','S','Offutt AFB','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.124900,-95.916720,0,'2013-07-06 12:44:33',NULL,NULL),(72001,'88038','P','Gila','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.018554,-108.282532,0,'2013-07-06 12:44:34',NULL,NULL),(21261,'22305','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.838240,-77.066036,0,'2013-07-06 12:44:31',NULL,NULL),(64134,'76193','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.747377,-97.330613,0,'2013-07-06 12:44:34',NULL,NULL),(53326,'61747','S','Hopedale','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.424930,-89.415612,0,'2013-07-06 12:44:33',NULL,NULL),(43996,'49342','S','Rodney','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.698234,-85.311467,0,'2013-07-06 12:44:32',NULL,NULL),(39403,'44662','S','Harmon','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.717968,-81.530814,0,'2013-07-06 12:44:32',NULL,NULL),(43259,'48325','P','W Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595072,-83.389939,0,'2013-07-06 12:44:32',NULL,NULL),(29622,'32869','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.591236,-81.492691,0,'2013-07-06 12:44:32',NULL,NULL),(33518,'37375','S','Sewanee','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.204551,-85.919546,0,'2013-07-06 12:44:32',NULL,NULL),(49296,'56525','P','Comstock','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.677765,-96.742324,0,'2013-07-06 12:44:33',NULL,NULL),(65207,'77436','P','Egypt','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.404861,-96.239193,0,'2013-07-06 12:44:34',NULL,NULL),(46195,'52750','S','Goose Lake','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.993759,-90.411063,0,'2013-07-06 12:44:32',NULL,NULL),(47222,'54498','S','Clark','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953103,-90.595538,0,'2013-07-06 12:44:32',NULL,NULL),(25914,'28645','S','Valmead','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(63650,'75845','S','Helmic','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(67067,'79567','S','Bradshaw','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(65362,'77535','S','Dayton','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(60268,'71447','S','Clifton','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(49471,'56654','S','Black River','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.517326,-93.899334,0,'2013-07-06 12:44:33',NULL,NULL),(72152,'88325','P','Hi Rolls Mt Park','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.076011,-106.025093,0,'2013-07-06 12:44:34',NULL,NULL),(16094,'17051','S','McVeytwn','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(46538,'53403','S','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.704176,-87.806580,0,'2013-07-06 12:44:32',NULL,NULL),(44085,'49456','S','Spring Lake','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.086511,-86.189307,0,'2013-07-06 12:44:32',NULL,NULL),(3736,'02156','P','West Medford','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.424333,-71.132274,0,'2013-07-06 12:44:30',NULL,NULL),(25466,'28338','S','Ellerbe','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.065733,-79.756549,0,'2013-07-06 12:44:31',NULL,NULL),(28137,'30818','S','Noah','N','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.215285,-82.287101,0,'2013-07-06 12:44:31',NULL,NULL),(43814,'49074','P','Nazareth','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.288107,-85.598653,0,'2013-07-06 12:44:32',NULL,NULL),(33311,'37133','P','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.840269,-86.394053,0,'2013-07-06 12:44:32',NULL,NULL),(72821,'89821','S','Beowawe','A','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.580000,-116.480000,0,'2013-07-06 12:44:34',NULL,NULL),(44328,'49755','S','Levering','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.644468,-84.840450,0,'2013-07-06 12:44:32',NULL,NULL),(26782,'29449','S','Yonges Island','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.711040,-80.276820,0,'2013-07-06 12:44:31',NULL,NULL),(40658,'46041','S','Hillisburg','A','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.264620,-86.528460,0,'2013-07-06 12:44:32',NULL,NULL),(71288,'86440','S','Mohave Valley','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.908895,-114.541298,0,'2013-07-06 12:44:34',NULL,NULL),(71108,'86002','P','Flagstaff','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.233740,-111.565921,0,'2013-07-06 12:44:34',NULL,NULL),(70021,'84128','S','West Valley','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(2518,'00957','S','Urb Patio de Rexville','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(63771,'75948','S','Fairmount','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.308720,-93.771600,0,'2013-07-06 12:44:34',NULL,NULL),(2956,'01036','S','Hampden','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.062919,-72.430251,0,'2013-07-06 12:44:30',NULL,NULL),(73258,'90714','P','Lakewood','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.851492,-118.136024,0,'2013-07-06 12:44:34',NULL,NULL),(77772,'97121','S','Hammond','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.196897,-123.949498,0,'2013-07-06 12:44:34',NULL,NULL),(40212,'45403','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.763897,-84.154772,0,'2013-07-06 12:44:32',NULL,NULL),(19466,'20135','S','Bluemont','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.091285,-77.841619,0,'2013-07-06 12:44:31',NULL,NULL),(35856,'39826','S','Bronwood','D','Terrell','13273','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.828520,-84.359918,0,'2013-07-06 12:44:32',NULL,NULL),(11343,'11794','U','Stony Brook','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.914561,-73.125169,0,'2013-07-06 12:44:30',NULL,NULL),(22977,'24733','S','Lashmeet','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.445081,-81.217426,0,'2013-07-06 12:44:31',NULL,NULL),(23662,'25823','S','Whitby','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.666111,-81.184444,0,'2013-07-06 12:44:31',NULL,NULL),(55320,'63543','S','Gorin','D','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.356102,-92.004461,0,'2013-07-06 12:44:33',NULL,NULL),(55361,'63563','S','Sand Hill','N','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.348929,-92.107301,0,'2013-07-06 12:44:33',NULL,NULL),(60989,'72111','S','Mount Vernon','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.185421,-92.073842,0,'2013-07-06 12:44:33',NULL,NULL),(37702,'42259','S','Ollie','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.284708,-86.189466,0,'2013-07-06 12:44:32',NULL,NULL),(52179,'60461','S','Olympia Flds','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.515245,-87.687123,0,'2013-07-06 12:44:33',NULL,NULL),(18980,'19520','S','Loag','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(29555,'32809','S','Edgewood','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.471095,-81.389356,0,'2013-07-06 12:44:32',NULL,NULL),(13189,'13619','S','Champion Huddle','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(4339,'03038','S','Derry','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.888158,-71.298963,0,'2013-07-06 12:44:30',NULL,NULL),(70165,'84320','S','Lewiston','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.962200,-111.873480,0,'2013-07-06 12:44:34',NULL,NULL),(78712,'98271','S','Tulalip','A','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.098404,-122.237318,0,'2013-07-06 12:44:34',NULL,NULL),(18347,'19034','S','Ft Wash','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.135875,-75.206603,0,'2013-07-06 12:44:31',NULL,NULL),(34785,'38868','S','Brewer','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.120111,-88.714124,0,'2013-07-06 12:44:32',NULL,NULL),(53404,'61832','S','Danville','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.136438,-87.632393,0,'2013-07-06 12:44:33',NULL,NULL),(11818,'12235','U','NY Agr And Mkts','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.649742,-73.756061,0,'2013-07-06 12:44:30',NULL,NULL),(68901,'82729','S','Sundance','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.400249,-104.372054,0,'2013-07-06 12:44:34',NULL,NULL),(38894,'44112','S','E Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.534374,-81.574679,0,'2013-07-06 12:44:32',NULL,NULL),(39175,'44312','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.029977,-81.439236,0,'2013-07-06 12:44:32',NULL,NULL),(39079,'44215','S','Medina','A','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.068001,-81.904211,0,'2013-07-06 12:44:32',NULL,NULL),(7332,'06706','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.535363,-73.027806,0,'2013-07-06 12:44:30',NULL,NULL),(61401,'72545','U','Heber Springs','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.487914,-92.055731,0,'2013-07-06 12:44:33',NULL,NULL),(62233,'73947','S','Keyes','D','Cimarron','40025','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.807788,-102.252542,0,'2013-07-06 12:44:33',NULL,NULL),(69303,'83451','S','Teton','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.905534,-111.657469,0,'2013-07-06 12:44:34',NULL,NULL),(70938,'85640','S','Carmen','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.596899,-111.047790,0,'2013-07-06 12:44:34',NULL,NULL),(72564,'89311','S','Baker','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.000092,-114.164202,0,'2013-07-06 12:44:34',NULL,NULL),(18866,'19446','S','Lansdale','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.235193,-75.289081,0,'2013-07-06 12:44:31',NULL,NULL),(64459,'76574','S','Frame Switch','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(31683,'34777','P','Winter Garden','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.486449,-81.606630,0,'2013-07-06 12:44:32',NULL,NULL),(51953,'60135','S','Genoa','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.105564,-88.669624,0,'2013-07-06 12:44:33',NULL,NULL),(66338,'78605','S','Mahomet','N','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.745034,-98.053979,0,'2013-07-06 12:44:34',NULL,NULL),(49505,'56667','S','Liberty','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(2854,'00983','S','Villa Fontana Pk','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(5438,'04685','S','Minturn','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.145000,-68.452222,0,'2013-07-06 12:44:30',NULL,NULL),(3757,'02184','S','Braintree Highlands','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.208818,-71.000729,0,'2013-07-06 12:44:30',NULL,NULL),(50373,'57758','S','Mud Butte','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.892550,-102.451810,0,'2013-07-06 12:44:33',NULL,NULL),(35897,'40010','S','Buckner','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.383365,-85.450819,0,'2013-07-06 12:44:32',NULL,NULL),(31682,'34773','S','Saint Cloud','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.060933,-81.052530,0,'2013-07-06 12:44:32',NULL,NULL),(62783,'74875','S','Tryon','D','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.862942,-97.041060,0,'2013-07-06 12:44:33',NULL,NULL),(55555,'63855','S','Hornersville','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.041107,-90.110624,0,'2013-07-06 12:44:33',NULL,NULL),(968,'00716','S','Urb Costa Sabana','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(26951,'29604','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.830301,-82.394264,0,'2013-07-06 12:44:31',NULL,NULL),(65764,'78075','S','Whitsett','D','Live Oak','48297','Texas','TX','48','0000','830','Central',-6.0,'Y',28.633889,-98.271667,0,'2013-07-06 12:44:34',NULL,NULL),(72642,'89425','S','Rebel Creek','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.738584,-118.090715,0,'2013-07-06 12:44:34',NULL,NULL),(12648,'13112','S','Memphis','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.098720,-76.414260,0,'2013-07-06 12:44:30',NULL,NULL),(78166,'97633','S','Merrill','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.025892,-121.569831,0,'2013-07-06 12:44:34',NULL,NULL),(27055,'29679','P','Seneca','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.685966,-82.944821,0,'2013-07-06 12:44:31',NULL,NULL),(40131,'45334','S','Jackson Ctr','A','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.446262,-84.043697,0,'2013-07-06 12:44:32',NULL,NULL),(15351,'16240','S','Mayport','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.976669,-79.251270,0,'2013-07-06 12:44:31',NULL,NULL),(19796,'20435','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916398,-77.077870,0,'2013-07-06 12:44:31',NULL,NULL),(33106,'36854','S','Valley','D','Chambers','01017','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.810093,-85.181624,0,'2013-07-06 12:44:32',NULL,NULL),(23144,'24986','S','Neola','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797867,-80.296195,0,'2013-07-06 12:44:31',NULL,NULL),(25630,'28465','S','Caswell Beach','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(25857,'28627','S','Hare','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.440899,-81.017500,0,'2013-07-06 12:44:31',NULL,NULL),(42170,'47527','S','Dubois Crossroads','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(44664,'50111','S','Grimes','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.685291,-93.782087,0,'2013-07-06 12:44:32',NULL,NULL),(73881,'91945','S','Lemon Grove','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.735489,-117.030797,0,'2013-07-06 12:44:34',NULL,NULL),(75383,'93944','P','Monterey','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.579877,-121.834074,0,'2013-07-06 12:44:34',NULL,NULL),(77106,'96142','P','Tahoma','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.063924,-120.138469,0,'2013-07-06 12:44:34',NULL,NULL),(79885,'99576','P','Dillingham','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.070280,-160.266870,0,'2013-07-06 12:44:34',NULL,NULL),(50448,'58016','S','Clifford','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.367090,-97.410181,0,'2013-07-06 12:44:33',NULL,NULL),(11035,'11569','P','Pt Lookout','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.593413,-73.580963,0,'2013-07-06 12:44:30',NULL,NULL),(6012,'05360','S','W Wardsboro','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.074420,-72.898920,0,'2013-07-06 12:44:30',NULL,NULL),(29597,'32831','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.473036,-81.136938,0,'2013-07-06 12:44:32',NULL,NULL),(15254,'16055','S','Sarver','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.712165,-79.750278,0,'2013-07-06 12:44:31',NULL,NULL),(41943,'47393','S','Williamsburg','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.951307,-84.994159,0,'2013-07-06 12:44:32',NULL,NULL),(13716,'14080','S','Holland','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.640921,-78.538651,0,'2013-07-06 12:44:31',NULL,NULL),(24490,'27259','P','Highfalls','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.460991,-79.570310,0,'2013-07-06 12:44:31',NULL,NULL),(57768,'67456','S','Lindsborg','D','McPherson','20113','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.573248,-97.674221,0,'2013-07-06 12:44:33',NULL,NULL),(71763,'87552','S','Lower Laposada','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(75740,'94604','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.801260,-122.265751,0,'2013-07-06 12:44:34',NULL,NULL),(1558,'00766','S','Bo Camarrones','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(46873,'54103','S','Armstrong Crk','A','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.667445,-88.447142,0,'2013-07-06 12:44:32',NULL,NULL),(22783,'24457','P','Lowmoor','N','Alleghany','51005','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.789907,-79.885378,0,'2013-07-06 12:44:31',NULL,NULL),(14348,'15012','S','Belle Vrn Br','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(26687,'29405','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(66726,'78956','S','Engle','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(79217,'98541','S','Elma','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.010231,-123.411051,0,'2013-07-06 12:44:34',NULL,NULL),(56445,'65276','S','Pilot Grove','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.870589,-92.907783,0,'2013-07-06 12:44:33',NULL,NULL),(55458,'63736','S','Lambert','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.072200,-89.569800,0,'2013-07-06 12:44:33',NULL,NULL),(46908,'54131','P','Freedom','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.386389,-88.288611,0,'2013-07-06 12:44:32',NULL,NULL),(67293,'80012','S','Denver','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.694487,-104.832515,0,'2013-07-06 12:44:34',NULL,NULL),(71392,'87007','P','Seama','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.000475,-107.413240,0,'2013-07-06 12:44:34',NULL,NULL),(1234,'00729','S','Canovanas','D','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(39243,'44430','S','Leavittsburg','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.239301,-80.887941,0,'2013-07-06 12:44:32',NULL,NULL),(37015,'41231','S','Lovely','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.781435,-82.362500,0,'2013-07-06 12:44:32',NULL,NULL),(28912,'32141','S','Edgewater','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.940925,-80.894574,0,'2013-07-06 12:44:32',NULL,NULL),(26613,'29304','P','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.958086,-81.905765,0,'2013-07-06 12:44:31',NULL,NULL),(22980,'24736','S','Matoaka','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.419663,-81.244363,0,'2013-07-06 12:44:31',NULL,NULL),(7371,'06770','S','Naugatuck','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.492039,-73.048550,0,'2013-07-06 12:44:30',NULL,NULL),(10439,'10913','S','Blauvelt','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.060202,-73.961158,0,'2013-07-06 12:44:30',NULL,NULL),(47960,'55120','S','Mendota Hts','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.873820,-93.140700,0,'2013-07-06 12:44:33',NULL,NULL),(49095,'56334','S','Sedan','A','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.651444,-95.386131,0,'2013-07-06 12:44:33',NULL,NULL),(50645,'58313','S','Balta','D','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.164163,-100.036310,0,'2013-07-06 12:44:33',NULL,NULL),(52655,'61065','S','Blaine','N','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.380237,-88.844362,0,'2013-07-06 12:44:33',NULL,NULL),(18833,'19423','P','Cedars','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.212000,-75.378308,0,'2013-07-06 12:44:31',NULL,NULL),(14025,'14543','S','Industry','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.994532,-77.664004,0,'2013-07-06 12:44:31',NULL,NULL),(69908,'84107','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(77927,'97327','S','Brownsville','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.388829,-122.966802,0,'2013-07-06 12:44:34',NULL,NULL),(58145,'68157','S','Bellevue','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.184654,-95.994302,0,'2013-07-06 12:44:33',NULL,NULL),(53151,'61559','S','Monica','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.894140,-89.775420,0,'2013-07-06 12:44:33',NULL,NULL),(18351,'19036','S','Briarcliff','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.906381,-75.293696,0,'2013-07-06 12:44:31',NULL,NULL),(7341,'06720','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.557028,-73.038046,0,'2013-07-06 12:44:30',NULL,NULL),(53024,'61470','S','Prairie City','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.606546,-90.501629,0,'2013-07-06 12:44:33',NULL,NULL),(44625,'50062','S','Melcher Dal','A','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.232661,-93.237493,0,'2013-07-06 12:44:32',NULL,NULL),(6017,'05363','S','Searsburg','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.883215,-72.898726,0,'2013-07-06 12:44:30',NULL,NULL),(18670,'19181','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951446,-75.147020,0,'2013-07-06 12:44:31',NULL,NULL),(17896,'18446','S','Clifford Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.627472,-75.785332,0,'2013-07-06 12:44:31',NULL,NULL),(28835,'32084','S','St Aug Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.885160,-81.313980,0,'2013-07-06 12:44:32',NULL,NULL),(29829,'33029','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.006742,-80.428893,0,'2013-07-06 12:44:32',NULL,NULL),(77517,'96841','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.309296,-157.859620,0,'2013-07-06 12:44:34',NULL,NULL),(51787,'60045','S','Lake Forest','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.233956,-87.863856,0,'2013-07-06 12:44:33',NULL,NULL),(57738,'67425','S','Brookville','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.821582,-97.859072,0,'2013-07-06 12:44:33',NULL,NULL),(46913,'54138','S','Lakewood','D','Oconto','55083','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.322736,-88.486596,0,'2013-07-06 12:44:32',NULL,NULL),(43904,'49249','S','Jerome','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.043416,-84.445244,0,'2013-07-06 12:44:32',NULL,NULL),(32221,'35573','P','Kansas','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.901154,-87.552160,0,'2013-07-06 12:44:32',NULL,NULL),(20093,'20701','S','Annapolis Junction','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.121614,-76.790430,0,'2013-07-06 12:44:31',NULL,NULL),(5978,'05344','P','Marlboro College','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.860125,-72.728912,0,'2013-07-06 12:44:30',NULL,NULL),(16100,'17052','S','Mapleton Dep','A','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(15366,'16258','S','Strattanville','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.257668,-79.237595,0,'2013-07-06 12:44:31',NULL,NULL),(38383,'43511','S','Custar','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.261582,-83.820803,0,'2013-07-06 12:44:32',NULL,NULL),(28529,'31551','S','Mershon','D','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.481294,-82.219597,0,'2013-07-06 12:44:32',NULL,NULL),(76392,'95537','P','Fields Landing','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.727358,-124.211781,0,'2013-07-06 12:44:34',NULL,NULL),(76456,'95612','S','Clarksburg','D','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.415587,-121.531796,0,'2013-07-06 12:44:34',NULL,NULL),(56835,'65805','P','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.254806,-93.315329,0,'2013-07-06 12:44:33',NULL,NULL),(63191,'75424','S','Blue Ridge','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.306343,-96.385782,0,'2013-07-06 12:44:33',NULL,NULL),(75821,'94901','S','San Rafael','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.974155,-122.509463,0,'2013-07-06 12:44:34',NULL,NULL),(58156,'68178','U','Creighton Univ','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.266599,-95.946811,0,'2013-07-06 12:44:33',NULL,NULL),(21613,'22903','S','University','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.037660,-78.519202,0,'2013-07-06 12:44:31',NULL,NULL),(50855,'58495','S','Burnstad','A','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.255140,-99.554676,0,'2013-07-06 12:44:33',NULL,NULL),(45393,'51031','S','Struble','A','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.786590,-96.172617,0,'2013-07-06 12:44:32',NULL,NULL),(34363,'38606','S','Batesville','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.316846,-89.949955,0,'2013-07-06 12:44:32',NULL,NULL),(31012,'33779','P','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.910349,-82.760117,0,'2013-07-06 12:44:32',NULL,NULL),(67516,'80241','S','Westminster','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.928789,-104.945551,0,'2013-07-06 12:44:34',NULL,NULL),(75399,'94011','P','Burlingame','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.579502,-122.344321,0,'2013-07-06 12:44:34',NULL,NULL),(36790,'41049','S','Sharkey','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.285556,-83.678852,0,'2013-07-06 12:44:32',NULL,NULL),(13152,'13602','S','Wtown','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.054057,-75.750531,0,'2013-07-06 12:44:30',NULL,NULL),(2517,'00957','S','Urb Panorama Vlg','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(16564,'17314','S','West Bangor','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.730000,-76.313333,0,'2013-07-06 12:44:31',NULL,NULL),(77564,'96910','S','Asan','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(52569,'60961','S','Reddick','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.097063,-88.250941,0,'2013-07-06 12:44:33',NULL,NULL),(40329,'45490','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.893349,-84.219043,0,'2013-07-06 12:44:32',NULL,NULL),(40311,'45459','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(39419,'44672','S','Sebring','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.919938,-81.026671,0,'2013-07-06 12:44:32',NULL,NULL),(8843,'08640','S','Ft Dix','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.008420,-74.589540,0,'2013-07-06 12:44:30',NULL,NULL),(27172,'29841','S','Clearwater','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.512008,-81.932644,0,'2013-07-06 12:44:31',NULL,NULL),(27053,'29677','P','Sandy Springs','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.595195,-82.737557,0,'2013-07-06 12:44:31',NULL,NULL),(19665,'20314','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895872,-77.009157,0,'2013-07-06 12:44:31',NULL,NULL),(14203,'14775','S','Forsyth','N','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.264580,-79.707146,0,'2013-07-06 12:44:31',NULL,NULL),(13315,'13676','S','Eben','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(52861,'61330','S','La Moille','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.530997,-89.280508,0,'2013-07-06 12:44:33',NULL,NULL),(62667,'74644','S','Marland','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.558251,-97.153129,0,'2013-07-06 12:44:33',NULL,NULL),(64190,'76241','P','Gainesville','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.623974,-97.149609,0,'2013-07-06 12:44:34',NULL,NULL),(75990,'95076','S','Mt Madonna','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.941261,-121.782524,0,'2013-07-06 12:44:34',NULL,NULL),(57108,'66221','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(33365,'37202','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.149245,-86.792828,0,'2013-07-06 12:44:32',NULL,NULL),(43929,'49272','S','Pleasant Lake','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.396206,-84.344252,0,'2013-07-06 12:44:32',NULL,NULL),(68940,'82933','S','Piedmont','A','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.299522,-110.390080,0,'2013-07-06 12:44:34',NULL,NULL),(69373,'83605','S','Caldwell','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(76063,'95202','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.958445,-121.287890,0,'2013-07-06 12:44:34',NULL,NULL),(56953,'66102','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.114418,-94.681239,0,'2013-07-06 12:44:33',NULL,NULL),(33596,'37615','S','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.373920,-82.445040,0,'2013-07-06 12:44:32',NULL,NULL),(49417,'56630','S','Birch','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(62763,'74855','S','Meeker','D','Lincoln','40081','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.501783,-96.896055,0,'2013-07-06 12:44:33',NULL,NULL),(73,'00612','S','Est de Balseiro','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(42253,'47577','S','Saint Meinrad','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.186231,-86.847745,0,'2013-07-06 12:44:32',NULL,NULL),(12435,'12956','S','Mineville','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.078155,-73.517787,0,'2013-07-06 12:44:30',NULL,NULL),(28199,'31021','S','Lollie','N','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.542986,-82.909684,0,'2013-07-06 12:44:31',NULL,NULL),(16498,'17260','S','Mount Union','A','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.321076,-77.848669,0,'2013-07-06 12:44:31',NULL,NULL),(15442,'16401','S','Elk Creek Twp','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(50439,'58005','S','Argusville','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.143799,-96.887381,0,'2013-07-06 12:44:33',NULL,NULL),(59981,'71326','S','Clayton Junction','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.746480,-91.495320,0,'2013-07-06 12:44:33',NULL,NULL),(76208,'95363','S','Diablo Grande','A','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.486062,-121.129906,0,'2013-07-06 12:44:34',NULL,NULL),(64212,'76262','S','Westlake','A','Denton','48121','Texas','TX','48','1920','817','Central',-6.0,'Y',33.007049,-97.194352,0,'2013-07-06 12:44:34',NULL,NULL),(8017,'07724','S','Shrewsbury Township','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.299859,-74.070754,0,'2013-07-06 12:44:30',NULL,NULL),(78154,'97604','P','Crater Lake','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.900000,-122.130000,0,'2013-07-06 12:44:34',NULL,NULL),(51832,'60064','S','Downey','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.326825,-87.857674,0,'2013-07-06 12:44:33',NULL,NULL),(11027,'11563','S','Lynbrook','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.659727,-73.675918,0,'2013-07-06 12:44:30',NULL,NULL),(3932,'02465','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348882,-71.225607,0,'2013-07-06 12:44:30',NULL,NULL),(37444,'41839','S','Mousie','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.439323,-82.911153,0,'2013-07-06 12:44:32',NULL,NULL),(36221,'40283','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(14314,'14894','S','Wellsburg','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.010247,-76.730286,0,'2013-07-06 12:44:31',NULL,NULL),(10175,'10281','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(12162,'12749','P','Kauneonga Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.690769,-74.844513,0,'2013-07-06 12:44:30',NULL,NULL),(56545,'65453','S','Cuba','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.068626,-91.414238,0,'2013-07-06 12:44:33',NULL,NULL),(73478,'91319','P','Thousand Oaks','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.184847,-118.916417,0,'2013-07-06 12:44:34',NULL,NULL),(941,'00716','S','BO Campo Alegre','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(41773,'47303','S','Woodlawn Park','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(15562,'16638','S','Entriken','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.334395,-78.195693,0,'2013-07-06 12:44:31',NULL,NULL),(13693,'14055','S','Concord','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.553172,-78.608173,0,'2013-07-06 12:44:31',NULL,NULL),(30799,'33607','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.965627,-82.510542,0,'2013-07-06 12:44:32',NULL,NULL),(75325,'93775','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.733005,-119.747107,0,'2013-07-06 12:44:34',NULL,NULL),(67248,'79947','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761334,-106.478777,0,'2013-07-06 12:44:34',NULL,NULL),(42318,'47616','S','Griffin','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.209290,-87.927619,0,'2013-07-06 12:44:32',NULL,NULL),(37890,'42602','S','Snow','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(36350,'40440','S','Junction City','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.579154,-84.819559,0,'2013-07-06 12:44:32',NULL,NULL),(14499,'15145','S','Turtle Creek','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.408017,-79.825060,0,'2013-07-06 12:44:31',NULL,NULL),(11269,'11770','P','Ocean Beach','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.647098,-73.151777,0,'2013-07-06 12:44:30',NULL,NULL),(24266,'26836','S','Moorefield','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.087480,-78.995940,0,'2013-07-06 12:44:31',NULL,NULL),(20938,'21758','S','Knoxville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.341495,-77.653907,0,'2013-07-06 12:44:31',NULL,NULL),(42793,'48047','S','Chesterfield Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.674168,-82.780566,0,'2013-07-06 12:44:32',NULL,NULL),(43690,'48882','P','Shaftsburg','D','Shiawassee','26155','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.809922,-84.295427,0,'2013-07-06 12:44:32',NULL,NULL),(45868,'52247','S','Frytown','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.487300,-91.707929,0,'2013-07-06 12:44:32',NULL,NULL),(47759,'55029','P','Grandy','D','Isanti','27059','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.563895,-93.341851,0,'2013-07-06 12:44:33',NULL,NULL),(70409,'84720','S','Cedar City','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.713174,-113.085548,0,'2013-07-06 12:44:34',NULL,NULL),(72922,'90028','S','Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.099218,-118.327098,0,'2013-07-06 12:44:34',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (78695,'98255','P','Hamilton','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.522344,-121.989235,0,'2013-07-06 12:44:34',NULL,NULL),(26959,'29608','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.901963,-82.409599,0,'2013-07-06 12:44:31',NULL,NULL),(5689,'04973','S','Searsmont','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.361172,-69.192186,0,'2013-07-06 12:44:30',NULL,NULL),(65909,'78236','S','Lackland AFB','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(38845,'44090','S','Rochester','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.155380,-82.206840,0,'2013-07-06 12:44:32',NULL,NULL),(53201,'61612','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.681656,-89.594486,0,'2013-07-06 12:44:33',NULL,NULL),(26884,'29563','S','Lake View','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.346041,-79.166819,0,'2013-07-06 12:44:31',NULL,NULL),(50074,'57451','S','Craven','N','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.448625,-99.029411,0,'2013-07-06 12:44:33',NULL,NULL),(13950,'14453','P','Fishers','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.012541,-77.462743,0,'2013-07-06 12:44:31',NULL,NULL),(16889,'17578','S','Schoeneck','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.241389,-76.174444,0,'2013-07-06 12:44:31',NULL,NULL),(32735,'36319','S','Columbia','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.315380,-85.123620,0,'2013-07-06 12:44:32',NULL,NULL),(20468,'21035','S','Davidsonville','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.936803,-76.630272,0,'2013-07-06 12:44:31',NULL,NULL),(65499,'77662','S','North Vidor','N','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.145872,-94.010918,0,'2013-07-06 12:44:34',NULL,NULL),(66462,'78654','S','Meadowlakes','A','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(73694,'91607','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(79054,'98417','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255131,-122.441650,0,'2013-07-06 12:44:34',NULL,NULL),(4613,'03593','S','Randolph','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.475301,-71.177733,0,'2013-07-06 12:44:30',NULL,NULL),(45557,'51501','S','Manawa','A','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.254887,-95.852753,0,'2013-07-06 12:44:32',NULL,NULL),(42821,'48060','S','Port Huron Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.986100,-82.467480,0,'2013-07-06 12:44:32',NULL,NULL),(32948,'36576','S','Silverhill','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.533306,-87.761816,0,'2013-07-06 12:44:32',NULL,NULL),(4183,'02815','S','Scituate','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.794176,-71.652718,0,'2013-07-06 12:44:30',NULL,NULL),(12099,'12572','S','Rhinebeck','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.926105,-73.894669,0,'2013-07-06 12:44:30',NULL,NULL),(37895,'42629','S','Jamestown','D','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.976422,-85.093378,0,'2013-07-06 12:44:32',NULL,NULL),(36154,'40241','S','Hills Dales','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(9467,'10009','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(31899,'35144','P','Elliotsvl','N','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.200000,-86.783333,0,'2013-07-06 12:44:32',NULL,NULL),(25758,'28583','P','Stonewall','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.137460,-76.738621,0,'2013-07-06 12:44:31',NULL,NULL),(45155,'50588','S','Lakeside','A','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(64645,'76712','S','Woodway','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.491114,-97.225849,0,'2013-07-06 12:44:34',NULL,NULL),(69541,'83801','S','Granite','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.936824,-116.675482,0,'2013-07-06 12:44:34',NULL,NULL),(77788,'97131','S','Neahkahnie','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.720000,-123.859980,0,'2013-07-06 12:44:34',NULL,NULL),(79059,'98422','S','Dash Point','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293639,-122.392048,0,'2013-07-06 12:44:34',NULL,NULL),(16748,'17509','S','Ninepoints','A','Lancaster','42071','Pennsylvania','PA','42','4000','610/484','Eastern',-5.0,'Y',39.912600,-76.043820,0,'2013-07-06 12:44:31',NULL,NULL),(4074,'02653','S','Orleans','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.781789,-69.980489,0,'2013-07-06 12:44:30',NULL,NULL),(12325,'12865','S','E Greenwich','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(30373,'33317','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.093836,-80.239494,0,'2013-07-06 12:44:32',NULL,NULL),(75340,'93888','U','IRS Service Center','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.753596,-119.678137,0,'2013-07-06 12:44:34',NULL,NULL),(26494,'29169','S','Cayce','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(21620,'22906','P','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.030177,-78.475550,0,'2013-07-06 12:44:31',NULL,NULL),(28766,'32024','S','Lake City','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.190547,-82.641240,0,'2013-07-06 12:44:32',NULL,NULL),(48144,'55366','P','New Auburn','D','Sibley','27143','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.677597,-94.206761,0,'2013-07-06 12:44:33',NULL,NULL),(19206,'19886','U','Bank of America','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.748270,-75.545647,0,'2013-07-06 12:44:31',NULL,NULL),(3754,'02176','S','Melrose','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.459952,-71.058890,0,'2013-07-06 12:44:30',NULL,NULL),(2388,'00949','S','Urb Las Gaviotas','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(26353,'29069','S','Oats','N','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.181109,-80.057782,0,'2013-07-06 12:44:31',NULL,NULL),(54406,'62827','S','Phillips','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.169678,-88.066046,0,'2013-07-06 12:44:33',NULL,NULL),(266,'00641','S','Urb Jesus M Lago','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(36562,'40927','S','Closplint','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.900366,-83.085472,0,'2013-07-06 12:44:32',NULL,NULL),(14960,'15621','P','Calumet','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.211200,-79.485814,0,'2013-07-06 12:44:31',NULL,NULL),(31077,'33856','P','Lake Wales','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.870875,-81.474398,0,'2013-07-06 12:44:32',NULL,NULL),(28767,'32025','S','Lake City','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.189356,-82.636764,0,'2013-07-06 12:44:32',NULL,NULL),(76522,'95646','P','Iron Mountain','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(27419,'30101','S','Acworth','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.035593,-84.708375,0,'2013-07-06 12:44:31',NULL,NULL),(28560,'31598','P','Jesup','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.506075,-81.822960,0,'2013-07-06 12:44:32',NULL,NULL),(2017,'00915','S','Sect Cantera','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(66514,'78709','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.235021,-97.847636,0,'2013-07-06 12:44:34',NULL,NULL),(68702,'82059','P','Granite Canon','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.017795,-105.249499,0,'2013-07-06 12:44:34',NULL,NULL),(5384,'04643','S','Harrington','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.599715,-67.815335,0,'2013-07-06 12:44:30',NULL,NULL),(39251,'44440','S','Mineral Ridge','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.143100,-80.774484,0,'2013-07-06 12:44:32',NULL,NULL),(36570,'40939','S','Ivy Grove','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.742655,-83.693032,0,'2013-07-06 12:44:32',NULL,NULL),(32316,'35761','S','New Market','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.901198,-86.446794,0,'2013-07-06 12:44:32',NULL,NULL),(30153,'33169','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.935490,-80.214010,0,'2013-07-06 12:44:32',NULL,NULL),(4383,'03103','S','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.965798,-71.438793,0,'2013-07-06 12:44:30',NULL,NULL),(42442,'47805','S','North Terre Haute','A','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(43112,'48223','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.388698,-83.250589,0,'2013-07-06 12:44:32',NULL,NULL),(54329,'62757','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.799583,-89.645158,0,'2013-07-06 12:44:33',NULL,NULL),(58370,'68526','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.730880,-96.551460,0,'2013-07-06 12:44:33',NULL,NULL),(77793,'97135','P','Pacific City','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.208152,-123.958657,0,'2013-07-06 12:44:34',NULL,NULL),(5656,'04958','S','North Anson','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.953794,-69.946150,0,'2013-07-06 12:44:30',NULL,NULL),(23705,'25875','P','Mc Graws','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.678374,-81.465791,0,'2013-07-06 12:44:31',NULL,NULL),(22293,'23806','U','VA State Univ','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.226377,-77.403086,0,'2013-07-06 12:44:31',NULL,NULL),(22474,'24054','S','Axton','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.659078,-79.714557,0,'2013-07-06 12:44:31',NULL,NULL),(76218,'95370','S','Sonora','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.996763,-120.330797,0,'2013-07-06 12:44:34',NULL,NULL),(79581,'99026','S','Nine Mile Falls','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.784513,-117.599788,0,'2013-07-06 12:44:34',NULL,NULL),(80158,'99802','P','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.304182,-134.427014,0,'2013-07-06 12:44:34',NULL,NULL),(33879,'38021','P','Crockett Mls','A','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.911875,-89.190532,0,'2013-07-06 12:44:32',NULL,NULL),(30812,'33617','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.036676,-82.396230,0,'2013-07-06 12:44:32',NULL,NULL),(14007,'14525','S','Pavilion','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.898777,-78.030271,0,'2013-07-06 12:44:31',NULL,NULL),(26699,'29407','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.800052,-80.010928,0,'2013-07-06 12:44:31',NULL,NULL),(19425,'20101','U','Dulles','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.988346,-77.451916,0,'2013-07-06 12:44:31',NULL,NULL),(47410,'54653','S','Rockland','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.905028,-90.915548,0,'2013-07-06 12:44:32',NULL,NULL),(55799,'64131','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.967545,-94.573365,0,'2013-07-06 12:44:33',NULL,NULL),(57947,'67745','S','McDonald','N','Rawlins','20153','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.785928,-101.296984,0,'2013-07-06 12:44:33',NULL,NULL),(58830,'69046','S','Wilsonville','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.091024,-100.135732,0,'2013-07-06 12:44:33',NULL,NULL),(61974,'73189','P','okc','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.395812,-97.578752,0,'2013-07-06 12:44:33',NULL,NULL),(67677,'80504','S','Firestone','A','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.160065,-104.966226,0,'2013-07-06 12:44:34',NULL,NULL),(29596,'32831','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.473036,-81.136938,0,'2013-07-06 12:44:32',NULL,NULL),(53672,'62216','S','Aviston','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.611076,-89.607818,0,'2013-07-06 12:44:33',NULL,NULL),(28641,'31758','P','Thomasville','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.837608,-83.978538,0,'2013-07-06 12:44:32',NULL,NULL),(73672,'91601','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(51033,'58721','S','Bowbells','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.812366,-102.205909,0,'2013-07-06 12:44:33',NULL,NULL),(50834,'58477','S','Regan','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',47.157277,-100.522793,0,'2013-07-06 12:44:33',NULL,NULL),(17580,'18015','S','Fountain Hill','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.601395,-75.369112,0,'2013-07-06 12:44:31',NULL,NULL),(14393,'15049','S','Harwick','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.557931,-79.806002,0,'2013-07-06 12:44:31',NULL,NULL),(22521,'24090','S','Fincastle','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.494715,-79.878228,0,'2013-07-06 12:44:31',NULL,NULL),(22171,'23465','U','Chrstn Brdcst Ntwrk Brm','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.797995,-76.176483,0,'2013-07-06 12:44:31',NULL,NULL),(70152,'84312','S','Garland','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.746854,-112.149193,0,'2013-07-06 12:44:34',NULL,NULL),(75331,'93786','U','Fresno Bee','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.638642,-119.903110,0,'2013-07-06 12:44:34',NULL,NULL),(38392,'43521','S','Fayette','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.657148,-84.307721,0,'2013-07-06 12:44:32',NULL,NULL),(353,'00656','S','Villa del Rio','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(15972,'17032','S','Enterline','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(33558,'37408','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.031670,-85.306753,0,'2013-07-06 12:44:32',NULL,NULL),(14447,'15101','S','Allison Park','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.567823,-79.970270,0,'2013-07-06 12:44:31',NULL,NULL),(19604,'20230','U','Dept Commerce','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899945,-77.035749,0,'2013-07-06 12:44:31',NULL,NULL),(40704,'46105','S','Bainbridge','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.762383,-86.814179,0,'2013-07-06 12:44:32',NULL,NULL),(20811,'21607','S','Barclay','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.120416,-75.843492,0,'2013-07-06 12:44:31',NULL,NULL),(41912,'47374','S','Richmond Square','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(43426,'48470','S','Ruth','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.732849,-82.749407,0,'2013-07-06 12:44:32',NULL,NULL),(44153,'49528','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881100,-85.623900,0,'2013-07-06 12:44:32',NULL,NULL),(62617,'74538','S','Olney','N','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.534003,-96.219571,0,'2013-07-06 12:44:33',NULL,NULL),(64839,'77040','S','Satsuma','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(66337,'78605','S','Joppa','N','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.745034,-98.053979,0,'2013-07-06 12:44:34',NULL,NULL),(71441,'87036','S','Mountainair','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.524327,-106.237998,0,'2013-07-06 12:44:34',NULL,NULL),(62830,'74966','S','Summerfield','N','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.941720,-94.815000,0,'2013-07-06 12:44:33',NULL,NULL),(12836,'13313','P','Bridgewater','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.878013,-75.249924,0,'2013-07-06 12:44:30',NULL,NULL),(63052,'75220','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.863782,-96.873944,0,'2013-07-06 12:44:33',NULL,NULL),(17684,'18201','S','Hazleton','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.961962,-75.978971,0,'2013-07-06 12:44:31',NULL,NULL),(48950,'56171','S','Sherburn','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.653934,-94.726837,0,'2013-07-06 12:44:33',NULL,NULL),(40038,'45251','S','Groesbeck','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.255230,-84.589734,0,'2013-07-06 12:44:32',NULL,NULL),(73106,'90247','S','Gardena','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.888193,-118.295204,0,'2013-07-06 12:44:34',NULL,NULL),(78133,'97531','S','Kerby','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.163056,-123.646944,0,'2013-07-06 12:44:34',NULL,NULL),(19518,'20180','S','Lovettsville','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.275423,-77.637821,0,'2013-07-06 12:44:31',NULL,NULL),(66585,'78746','S','West Lake Hls','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.301080,-97.814880,0,'2013-07-06 12:44:34',NULL,NULL),(79412,'98816','S','Lakeside','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.850024,-120.044073,0,'2013-07-06 12:44:34',NULL,NULL),(24448,'27214','S','Monticello','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(32307,'35752','S','Hollywood','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.737220,-85.961102,0,'2013-07-06 12:44:32',NULL,NULL),(20735,'21289','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.312384,-76.727934,0,'2013-07-06 12:44:31',NULL,NULL),(65493,'77657','S','Rose Hl Acres','A','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.249112,-94.191872,0,'2013-07-06 12:44:34',NULL,NULL),(78208,'97751','S','Paulina','D','Crook','41013','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.194088,-119.855595,0,'2013-07-06 12:44:34',NULL,NULL),(59836,'71243','S','Extension','A','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.044920,-91.820280,0,'2013-07-06 12:44:33',NULL,NULL),(46157,'52722','S','Panorama Park','N','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.567220,-90.462000,0,'2013-07-06 12:44:32',NULL,NULL),(30354,'33313','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.148778,-80.227624,0,'2013-07-06 12:44:32',NULL,NULL),(35962,'40069','S','Maud','A','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.713360,-85.201800,0,'2013-07-06 12:44:32',NULL,NULL),(7830,'07460','S','Lake Stockholm','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(2759,'00969','S','Villa Avila','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(3105,'01230','S','Great Barrington','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(5451,'04730','S','Houlton','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(23286,'25164','S','Procious','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.470869,-81.222751,0,'2013-07-06 12:44:31',NULL,NULL),(24588,'27320','S','Midway','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(28182,'31008','S','Byron','D','Peach','13225','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.646227,-83.754589,0,'2013-07-06 12:44:31',NULL,NULL),(7136,'06401','S','Ansonia','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.342081,-73.071690,0,'2013-07-06 12:44:30',NULL,NULL),(40405,'45679','S','Seaman','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.963935,-83.563138,0,'2013-07-06 12:44:32',NULL,NULL),(61240,'72339','P','Gilmore','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.395515,-90.249020,0,'2013-07-06 12:44:33',NULL,NULL),(45105,'50546','S','Havelock','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.842849,-94.734536,0,'2013-07-06 12:44:32',NULL,NULL),(67537,'80259','U','Small Business Adm','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.740324,-104.987582,0,'2013-07-06 12:44:34',NULL,NULL),(77380,'96757','P','Kualapuu','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.156224,-157.039972,0,'2013-07-06 12:44:34',NULL,NULL),(16736,'17502','S','Falmouth','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.121860,-76.654353,0,'2013-07-06 12:44:31',NULL,NULL),(76837,'95961','S','West Linda','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.088781,-121.550818,0,'2013-07-06 12:44:34',NULL,NULL),(75928,'95017','S','Davenport','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.048041,-122.220016,0,'2013-07-06 12:44:34',NULL,NULL),(74257,'92338','S','Newberry Springs','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.721111,-116.159167,0,'2013-07-06 12:44:34',NULL,NULL),(69949,'84117','S','Murray','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(53095,'61531','S','Middlegrove','A','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.704444,-90.099444,0,'2013-07-06 12:44:33',NULL,NULL),(43593,'48757','S','Reese','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.463098,-83.671606,0,'2013-07-06 12:44:32',NULL,NULL),(21540,'22736','S','Richardsville','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.395739,-77.691652,0,'2013-07-06 12:44:31',NULL,NULL),(5152,'04419','S','Carmel','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.800710,-69.009422,0,'2013-07-06 12:44:30',NULL,NULL),(5908,'05201','S','Bennington','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.879586,-73.197676,0,'2013-07-06 12:44:30',NULL,NULL),(3071,'01129','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122932,-72.486989,0,'2013-07-06 12:44:30',NULL,NULL),(52100,'60411','S','S Chicago Hts','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(47659,'54935','S','Taycheedah','A','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.775242,-88.431561,0,'2013-07-06 12:44:33',NULL,NULL),(46469,'53217','S','Fox Point','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(43384,'48430','S','Fenton','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.814469,-83.715874,0,'2013-07-06 12:44:32',NULL,NULL),(78256,'97839','S','Lexington','D','Morrow','41049','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.390327,-119.808273,0,'2013-07-06 12:44:34',NULL,NULL),(76510,'95641','S','Brannan Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.145589,-121.598217,0,'2013-07-06 12:44:34',NULL,NULL),(69295,'83445','S','Wilford','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(59118,'70151','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.946059,-90.083357,0,'2013-07-06 12:44:33',NULL,NULL),(57801,'67502','S','Hutchinson','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.102658,-97.919629,0,'2013-07-06 12:44:33',NULL,NULL),(51142,'58835','S','Arnegard','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.809287,-103.439855,0,'2013-07-06 12:44:33',NULL,NULL),(41941,'47390','S','Union City','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.202822,-84.817856,0,'2013-07-06 12:44:32',NULL,NULL),(11981,'12469','S','Preston Holw','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.456600,-74.220660,0,'2013-07-06 12:44:30',NULL,NULL),(22167,'23464','S','VAB','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.798333,-76.177537,0,'2013-07-06 12:44:31',NULL,NULL),(13277,'13656','S','La Fargeville','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.191020,-75.955560,0,'2013-07-06 12:44:30',NULL,NULL),(25815,'28609','S','Catawba','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.667368,-80.999551,0,'2013-07-06 12:44:31',NULL,NULL),(26601,'29240','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.027608,-81.009201,0,'2013-07-06 12:44:31',NULL,NULL),(37290,'41619','S','Drift','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.481429,-82.749080,0,'2013-07-06 12:44:32',NULL,NULL),(23780,'25981','S','Crichton','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.055556,-80.691389,0,'2013-07-06 12:44:31',NULL,NULL),(27396,'30086','P','Stone Mtn','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.803359,-84.103425,0,'2013-07-06 12:44:31',NULL,NULL),(76997,'96076','S','Wildwood','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.370400,-122.952720,0,'2013-07-06 12:44:34',NULL,NULL),(32562,'36114','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405544,-86.248050,0,'2013-07-06 12:44:32',NULL,NULL),(55812,'64145','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.883941,-94.595219,0,'2013-07-06 12:44:33',NULL,NULL),(15459,'16413','P','Elgin','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.902099,-79.744053,0,'2013-07-06 12:44:31',NULL,NULL),(14318,'14901','S','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.098491,-76.808792,0,'2013-07-06 12:44:31',NULL,NULL),(36754,'41040','S','Neave','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(58566,'68825','S','Ryno','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(51948,'60132','U','Citicorp','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.919511,-88.100953,0,'2013-07-06 12:44:33',NULL,NULL),(43532,'48662','S','Wheeler','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.388718,-84.416657,0,'2013-07-06 12:44:32',NULL,NULL),(13108,'13482','S','W Burlington','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.694287,-75.193783,0,'2013-07-06 12:44:30',NULL,NULL),(19168,'19726','U','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.684577,-75.735242,0,'2013-07-06 12:44:31',NULL,NULL),(21456,'22610','S','Overall','N','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.818140,-78.258120,0,'2013-07-06 12:44:31',NULL,NULL),(16253,'17084','S','Barrville','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.677620,-77.606927,0,'2013-07-06 12:44:31',NULL,NULL),(64591,'76676','S','Penelope','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.855369,-96.943156,0,'2013-07-06 12:44:34',NULL,NULL),(52489,'60696','U','Fleet','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.848295,-87.649618,0,'2013-07-06 12:44:33',NULL,NULL),(32110,'35401','S','Veterans Hospital','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.191809,-87.564581,0,'2013-07-06 12:44:32',NULL,NULL),(37721,'42275','S','Roundhill','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.199181,-86.454521,0,'2013-07-06 12:44:32',NULL,NULL),(791,'00693','S','Colinas del Marquez','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(42465,'47834','S','Benwood','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(30885,'33688','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.061605,-82.505549,0,'2013-07-06 12:44:32',NULL,NULL),(10928,'11432','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715744,-73.794362,0,'2013-07-06 12:44:30',NULL,NULL),(12220,'12808','S','Adirondack','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.733474,-73.757263,0,'2013-07-06 12:44:30',NULL,NULL),(73268,'90723','S','Paramount','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.897236,-118.160018,0,'2013-07-06 12:44:34',NULL,NULL),(76403,'95546','S','Weitchpec','N','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',41.168795,-123.727286,0,'2013-07-06 12:44:34',NULL,NULL),(17531,'17972','S','Schuykl Havn','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.632720,-76.155120,0,'2013-07-06 12:44:31',NULL,NULL),(17285,'17847','S','E Chillisquaq','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.014839,-76.846934,0,'2013-07-06 12:44:31',NULL,NULL),(57878,'67621','S','Agra','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.874950,-99.137608,0,'2013-07-06 12:44:33',NULL,NULL),(26735,'29419','P','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.936047,-80.100088,0,'2013-07-06 12:44:31',NULL,NULL),(25734,'28555','S','Maysville','D','Jones','37103','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.842466,-77.247090,0,'2013-07-06 12:44:31',NULL,NULL),(10792,'11370','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760333,-73.890833,0,'2013-07-06 12:44:30',NULL,NULL),(61254,'72354','S','Lepanto','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.607107,-90.335520,0,'2013-07-06 12:44:33',NULL,NULL),(73521,'91344','S','San Fernando','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.279812,-118.500354,0,'2013-07-06 12:44:34',NULL,NULL),(66332,'78602','S','Clearview','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.115800,-97.274640,0,'2013-07-06 12:44:34',NULL,NULL),(65981,'78332','S','Alice','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742680,-98.085900,0,'2013-07-06 12:44:34',NULL,NULL),(61546,'72687','S','Yellville','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.223245,-92.682994,0,'2013-07-06 12:44:33',NULL,NULL),(51085,'58763','S','New Town','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.972700,-102.481620,0,'2013-07-06 12:44:33',NULL,NULL),(32014,'35235','S','Center Point','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(19490,'20152','S','South Riding','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.907611,-77.518015,0,'2013-07-06 12:44:31',NULL,NULL),(12018,'12507','S','Barrytown','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.995000,-73.875833,0,'2013-07-06 12:44:30',NULL,NULL),(5807,'05068','S','S Royalton','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.801620,-72.530880,0,'2013-07-06 12:44:30',NULL,NULL),(38217,'43220','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.000000,-83.066667,0,'2013-07-06 12:44:32',NULL,NULL),(39398,'44657','S','Pekin','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(37915,'42633','S','Pueblo','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(37457,'41855','S','Thornton','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.134175,-82.744792,0,'2013-07-06 12:44:32',NULL,NULL),(8031,'07728','S','Millhurst','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.243519,-74.277392,0,'2013-07-06 12:44:30',NULL,NULL),(47632,'54913','S','Grand Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.263597,-88.413736,0,'2013-07-06 12:44:33',NULL,NULL),(4222,'02842','S','Middletown','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.516863,-71.286792,0,'2013-07-06 12:44:30',NULL,NULL),(61367,'72517','S','Brockwell','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.132138,-91.962572,0,'2013-07-06 12:44:33',NULL,NULL),(55007,'63131','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(32753,'36344','S','Highbluff','N','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.101347,-85.700671,0,'2013-07-06 12:44:32',NULL,NULL),(30378,'33319','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(70479,'84765','S','Santa Clara','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.131214,-113.642055,0,'2013-07-06 12:44:34',NULL,NULL),(35602,'39601','S','Bhaven','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(74508,'92637','S','Laguna Woods','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.615016,-117.711378,0,'2013-07-06 12:44:34',NULL,NULL),(72512,'89154','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.086541,-115.146079,0,'2013-07-06 12:44:34',NULL,NULL),(53717,'62241','S','Ellis Grove','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.004300,-89.898760,0,'2013-07-06 12:44:33',NULL,NULL),(48970,'56210','P','Barry','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.553791,-96.557068,0,'2013-07-06 12:44:33',NULL,NULL),(22098,'23414','P','Nelsonia','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.832292,-75.570013,0,'2013-07-06 12:44:31',NULL,NULL),(27597,'30296','S','Riverdale','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.568229,-84.432301,0,'2013-07-06 12:44:31',NULL,NULL),(49101,'56340','S','Holdingford','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.734930,-94.431926,0,'2013-07-06 12:44:33',NULL,NULL),(20732,'21287','U','Johns Hopkins Hospital','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304023,-76.562557,0,'2013-07-06 12:44:31',NULL,NULL),(34167,'38281','P','Union Cty','N','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.425852,-89.049841,0,'2013-07-06 12:44:32',NULL,NULL),(69110,'83271','S','Rockland','D','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.521281,-112.846469,0,'2013-07-06 12:44:34',NULL,NULL),(16270,'17094','S','Locust Run','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.564068,-77.237090,0,'2013-07-06 12:44:31',NULL,NULL),(12948,'13354','S','Steuben','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.253640,-75.284520,0,'2013-07-06 12:44:30',NULL,NULL),(2795,'00976','S','Urb Interamericana Gdn','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(38215,'43218','P','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.966616,-83.012341,0,'2013-07-06 12:44:32',NULL,NULL),(68167,'81007','S','Pueblo West','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.346600,-104.788860,0,'2013-07-06 12:44:34',NULL,NULL),(70862,'85602','S','Mescal','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.965389,-110.296656,0,'2013-07-06 12:44:34',NULL,NULL),(591,'00680','S','Repto Brisas De Rio Hondo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(10365,'10583','S','Heathcote','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.989799,-73.800070,0,'2013-07-06 12:44:30',NULL,NULL),(3303,'01516','S','Douglas','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.057720,-71.755020,0,'2013-07-06 12:44:30',NULL,NULL),(2107,'00923','S','Urb San Jose','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(6279,'05641','S','Barre Jct','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(24347,'27041','S','Pilot Mountain','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.450094,-80.489865,0,'2013-07-06 12:44:31',NULL,NULL),(23643,'25777','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.416149,-82.477547,0,'2013-07-06 12:44:31',NULL,NULL),(66157,'78505','P','Kane','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.200156,-98.232966,0,'2013-07-06 12:44:34',NULL,NULL),(12155,'12742','S','Harris','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.718078,-74.728470,0,'2013-07-06 12:44:30',NULL,NULL),(37684,'42221','P','Fairview','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.894485,-87.485341,0,'2013-07-06 12:44:32',NULL,NULL),(73863,'91912','P','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.639988,-117.080648,0,'2013-07-06 12:44:34',NULL,NULL),(78294,'97882','S','McNary','A','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.915922,-119.296745,0,'2013-07-06 12:44:34',NULL,NULL),(10267,'10507','S','Bedford Hills','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.231606,-73.690681,0,'2013-07-06 12:44:30',NULL,NULL),(52349,'60605','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.865699,-87.627039,0,'2013-07-06 12:44:33',NULL,NULL),(38574,'43786','P','Stafford','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.715067,-81.276377,0,'2013-07-06 12:44:32',NULL,NULL),(16056,'17047','S','Bixler','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(37882,'42567','S','Pulaski','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.258848,-84.598938,0,'2013-07-06 12:44:32',NULL,NULL),(36691,'41017','S','Covington','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(35407,'39464','S','Ouetti','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.403056,-89.093336,0,'2013-07-06 12:44:32',NULL,NULL),(3916,'02459','S','Newton Center','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.308823,-71.191835,0,'2013-07-06 12:44:30',NULL,NULL),(54081,'62519','P','Cornland','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.935898,-89.400570,0,'2013-07-06 12:44:33',NULL,NULL),(4835,'04005','S','Biddeford','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.474441,-70.452039,0,'2013-07-06 12:44:30',NULL,NULL),(9138,'09229','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71932,'87832','S','San Antonio','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.910833,-106.348889,0,'2013-07-06 12:44:34',NULL,NULL),(76823,'95958','P','Durham','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.555497,-121.772180,0,'2013-07-06 12:44:34',NULL,NULL),(77816,'97148','S','Yamhill','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.351433,-123.218167,0,'2013-07-06 12:44:34',NULL,NULL),(4078,'02660','S','S Dennis','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.705465,-70.157465,0,'2013-07-06 12:44:30',NULL,NULL),(33240,'37072','S','Goodlettsville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.325144,-86.737474,0,'2013-07-06 12:44:32',NULL,NULL),(68780,'82327','S','Kortes Dam','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.878504,-106.556303,0,'2013-07-06 12:44:34',NULL,NULL),(19620,'20241','U','Bureau of Mines','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894725,-77.052712,0,'2013-07-06 12:44:31',NULL,NULL),(60087,'71357','S','Tensas Bluff','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(46077,'52586','S','Rose Hill','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.180138,-92.313516,0,'2013-07-06 12:44:32',NULL,NULL),(17396,'17901','S','Glenworth','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(3081,'01152','S','General Mail Facility-Bmc','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.152789,-72.511258,0,'2013-07-06 12:44:30',NULL,NULL),(7434,'06828','U','General Electric','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.218272,-73.252765,0,'2013-07-06 12:44:30',NULL,NULL),(73114,'90255','S','Huntington Park','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.980311,-118.209874,0,'2013-07-06 12:44:34',NULL,NULL),(76440,'95604','P','Auburn','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.902920,-121.066980,0,'2013-07-06 12:44:34',NULL,NULL),(58242,'68355','S','Falls City','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.063372,-95.601580,0,'2013-07-06 12:44:33',NULL,NULL),(65511,'77704','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.072586,-94.103117,0,'2013-07-06 12:44:34',NULL,NULL),(58255,'68370','S','Hebron','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.169252,-97.588399,0,'2013-07-06 12:44:33',NULL,NULL),(49865,'57255','S','Hammer','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.877140,-96.918980,0,'2013-07-06 12:44:33',NULL,NULL),(72384,'89039','S','Cal Nev Ari','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.316311,-114.885400,0,'2013-07-06 12:44:34',NULL,NULL),(74722,'93024','P','Ojai','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.440233,-119.260634,0,'2013-07-06 12:44:34',NULL,NULL),(16958,'17702','S','Oval','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(61061,'72122','S','Paron','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.804630,-92.850568,0,'2013-07-06 12:44:33',NULL,NULL),(20274,'20787','P','Langley Park','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.001883,-76.969387,0,'2013-07-06 12:44:31',NULL,NULL),(20011,'20616','S','Bryans Road','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.648082,-77.084535,0,'2013-07-06 12:44:31',NULL,NULL),(74532,'92656','S','Aliso Viejo','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.576120,-117.736380,0,'2013-07-06 12:44:34',NULL,NULL),(75327,'93777','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.751091,-119.790000,0,'2013-07-06 12:44:34',NULL,NULL),(151,'00617','S','Urb Cimarrona Ct','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(62425,'74147','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.097393,-95.887182,0,'2013-07-06 12:44:33',NULL,NULL),(58702,'68930','S','Cowles','A','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.329281,-98.450890,0,'2013-07-06 12:44:33',NULL,NULL),(51950,'60133','S','Bartlett','A','Cook','17031','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.966626,-88.161383,0,'2013-07-06 12:44:33',NULL,NULL),(51137,'58830','S','Corinth','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589714,-103.408726,0,'2013-07-06 12:44:33',NULL,NULL),(22325,'23851','S','Franklin','D','Franklin City','51620','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.672869,-76.940007,0,'2013-07-06 12:44:31',NULL,NULL),(75094,'93536','S','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.775252,-118.471697,0,'2013-07-06 12:44:34',NULL,NULL),(66661,'78870','S','Knippa','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.291676,-99.634336,0,'2013-07-06 12:44:34',NULL,NULL),(50245,'57626','S','Auance','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(15014,'15674','P','Norvelt','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.208944,-79.496395,0,'2013-07-06 12:44:31',NULL,NULL),(31313,'34108','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.236315,-81.805998,0,'2013-07-06 12:44:32',NULL,NULL),(6418,'05739','S','South End','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(69996,'84123','S','S Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(70473,'84762','P','Duck Crk Vlg','A','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.529935,-112.666908,0,'2013-07-06 12:44:34',NULL,NULL),(8640,'08270','S','Steelmantown','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(52672,'61074','S','Savanna Army Depot','N','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.099549,-90.124934,0,'2013-07-06 12:44:33',NULL,NULL),(28329,'31150','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.982371,-84.333684,0,'2013-07-06 12:44:32',NULL,NULL),(11226,'11751','S','Bayberry Point','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732034,-73.213359,0,'2013-07-06 12:44:30',NULL,NULL),(20091,'20697','U','Sthrn MD Fac','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.032920,-76.904253,0,'2013-07-06 12:44:31',NULL,NULL),(7604,'07046','S','Mountain Lakes','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.891687,-74.439534,0,'2013-07-06 12:44:30',NULL,NULL),(74018,'92124','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.823430,-117.097296,0,'2013-07-06 12:44:34',NULL,NULL),(3710,'02141','S','East Cambridge','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.368312,-71.082436,0,'2013-07-06 12:44:30',NULL,NULL),(61553,'72712','S','Bentonville','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.375647,-94.209338,0,'2013-07-06 12:44:33',NULL,NULL),(8511,'08102','S','Camden','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.945816,-75.113529,0,'2013-07-06 12:44:30',NULL,NULL),(46853,'54022','S','Troy','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.880780,-92.632260,0,'2013-07-06 12:44:32',NULL,NULL),(7842,'07462','S','Vernon','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.182125,-74.505004,0,'2013-07-06 12:44:30',NULL,NULL),(2750,'00969','S','Urb Santa Clara','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(377,'00660','S','Hormigueros','D','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(69886,'84102','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.758805,-111.865417,0,'2013-07-06 12:44:34',NULL,NULL),(11723,'12180','S','Brunswick','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(78143,'97541','S','Trail','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.676521,-122.759724,0,'2013-07-06 12:44:34',NULL,NULL),(56694,'65656','S','Galena','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.837668,-93.479981,0,'2013-07-06 12:44:33',NULL,NULL),(57291,'66615','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.054663,-95.853761,0,'2013-07-06 12:44:33',NULL,NULL),(25445,'28315','S','Aberdeen','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.146104,-79.424275,0,'2013-07-06 12:44:31',NULL,NULL),(15522,'16538','U','National City of PA','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.129086,-80.085881,0,'2013-07-06 12:44:31',NULL,NULL),(37482,'42001','S','Saint Johns','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(77914,'97311','U','Dept Employment','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.943754,-123.028070,0,'2013-07-06 12:44:34',NULL,NULL),(66034,'78368','S','Argenta','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(15583,'16660','P','Mc Connellstown','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.449212,-78.082861,0,'2013-07-06 12:44:31',NULL,NULL),(26310,'29039','S','Cordova','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.456975,-80.894539,0,'2013-07-06 12:44:31',NULL,NULL),(8079,'07755','S','Elberon Park','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.264603,-74.023335,0,'2013-07-06 12:44:30',NULL,NULL),(78950,'98368','S','Port Townsend','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(35371,'39452','S','Agricola','A','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(24202,'26679','S','Runa','A','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.205180,-80.821920,0,'2013-07-06 12:44:31',NULL,NULL),(22384,'23938','S','Dundas','D','Lunenburg','51111','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.906808,-78.004803,0,'2013-07-06 12:44:31',NULL,NULL),(13022,'13425','S','Oriskany Fls','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.939058,-75.459424,0,'2013-07-06 12:44:30',NULL,NULL),(60281,'71449','S','Rattan','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(8182,'07881','S','Wallpack Center','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.204221,-74.819332,0,'2013-07-06 12:44:30',NULL,NULL),(32194,'35544','S','Beaverton','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.965374,-88.016495,0,'2013-07-06 12:44:32',NULL,NULL),(43841,'49098','S','Watervliet','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.187078,-86.256124,0,'2013-07-06 12:44:32',NULL,NULL),(41002,'46360','S','Town Of Pines','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(70490,'84771','P','Saint George','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.133484,-113.490057,0,'2013-07-06 12:44:34',NULL,NULL),(78156,'97621','S','Beatty','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.425062,-121.178515,0,'2013-07-06 12:44:34',NULL,NULL),(79616,'99116','S','Coulee Dam','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.972127,-118.972135,0,'2013-07-06 12:44:34',NULL,NULL),(49216,'56464','S','Shell River','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(23667,'25831','S','Danese','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.883531,-80.971211,0,'2013-07-06 12:44:31',NULL,NULL),(29376,'32604','P','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.649826,-82.345893,0,'2013-07-06 12:44:32',NULL,NULL),(17015,'17740','S','Rauchtown','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(64499,'76629','S','Petteway','N','Robertson','48395','Texas','TX','48','0000','254','Central',-6.0,'Y',31.149300,-96.676320,0,'2013-07-06 12:44:34',NULL,NULL),(33352,'37179','S','Thompsons Stn','A','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.799949,-86.904828,0,'2013-07-06 12:44:32',NULL,NULL),(5167,'04428','S','Clifton','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.800839,-68.562980,0,'2013-07-06 12:44:30',NULL,NULL),(62912,'75075','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.015315,-96.738972,0,'2013-07-06 12:44:33',NULL,NULL),(15975,'17032','S','Inglenook','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(66709,'78948','S','Doak Springs','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.316524,-96.976370,0,'2013-07-06 12:44:34',NULL,NULL),(2099,'00923','S','Urb del Carmen','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(40350,'45628','S','Frankfort','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.387932,-83.194166,0,'2013-07-06 12:44:32',NULL,NULL),(52914,'61364','S','Streator','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(54331,'62761','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.804222,-89.660644,0,'2013-07-06 12:44:33',NULL,NULL),(17938,'18504','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.413309,-75.690906,0,'2013-07-06 12:44:31',NULL,NULL),(38660,'43943','S','Rayland','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.179877,-80.707940,0,'2013-07-06 12:44:32',NULL,NULL),(2866,'00985','S','Jard de Buena Vista','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(36088,'40218','S','Watterson Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192865,-85.653204,0,'2013-07-06 12:44:32',NULL,NULL),(38836,'44085','S','Roaming Shrs','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.615188,-80.856141,0,'2013-07-06 12:44:32',NULL,NULL),(57555,'67037','S','Derby','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.557150,-97.243212,0,'2013-07-06 12:44:33',NULL,NULL),(30059,'33147','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.853411,-80.237002,0,'2013-07-06 12:44:32',NULL,NULL),(78711,'98271','S','Marysville','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.098404,-122.237318,0,'2013-07-06 12:44:34',NULL,NULL),(64393,'76538','S','Ireland','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.598240,-97.759127,0,'2013-07-06 12:44:34',NULL,NULL),(59993,'71328','S','Deville','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(64831,'77038','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.917841,-95.439728,0,'2013-07-06 12:44:34',NULL,NULL),(6739,'06079','P','Twin Lakes','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',42.035556,-73.408333,0,'2013-07-06 12:44:30',NULL,NULL),(77139,'96158','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.925696,-119.966045,0,'2013-07-06 12:44:34',NULL,NULL),(2250,'00926','S','Urb Los Adoquines','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(42758,'48032','S','Grant Township','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.173246,-82.593346,0,'2013-07-06 12:44:32',NULL,NULL),(1213,'00728','S','Urb Baldorioty','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(14695,'15258','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441892,-79.997266,0,'2013-07-06 12:44:31',NULL,NULL),(37563,'42071','S','Lynn Grove','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(72118,'88254','P','Seven Rivers','N','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.638836,-104.375963,0,'2013-07-06 12:44:34',NULL,NULL),(54309,'62715','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803359,-89.646811,0,'2013-07-06 12:44:33',NULL,NULL),(9317,'09729','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(74131,'92241','S','Sky Valley','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.899772,-116.390191,0,'2013-07-06 12:44:34',NULL,NULL),(63950,'76087','S','Brock','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699394,-97.772650,0,'2013-07-06 12:44:34',NULL,NULL),(9685,'10044','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(7111,'06374','S','Plainfield','D','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.677430,-71.922932,0,'2013-07-06 12:44:30',NULL,NULL),(7752,'07311','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.720815,-74.045882,0,'2013-07-06 12:44:30',NULL,NULL),(11047,'11572','S','Rockville Centre','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.658611,-73.641667,0,'2013-07-06 12:44:30',NULL,NULL),(10271,'10510','S','Briarcliff','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.145661,-73.833747,0,'2013-07-06 12:44:30',NULL,NULL),(17942,'18508','S','N Scranton','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.437061,-75.663443,0,'2013-07-06 12:44:31',NULL,NULL),(14419,'15068','S','Parnassus','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(69720,'84037','S','West Kaysville','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.031000,-111.942000,0,'2013-07-06 12:44:34',NULL,NULL),(74649,'92833','S','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.876643,-117.955051,0,'2013-07-06 12:44:34',NULL,NULL),(69377,'83605','S','Sunnyslope','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(75366,'93924','S','Tassajara Hot Springs','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.393660,-121.675020,0,'2013-07-06 12:44:34',NULL,NULL),(6411,'05738','S','Russellville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.531020,-72.864480,0,'2013-07-06 12:44:30',NULL,NULL),(63262,'75494','S','Winnsboro','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.948208,-95.293669,0,'2013-07-06 12:44:33',NULL,NULL),(51823,'60055','U','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.125215,-88.075032,0,'2013-07-06 12:44:33',NULL,NULL),(45562,'51503','S','Council Blfs','A','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.263360,-95.819074,0,'2013-07-06 12:44:32',NULL,NULL),(20652,'21225','S','Brooklyn Park','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.230400,-76.617360,0,'2013-07-06 12:44:31',NULL,NULL),(35260,'39354','S','Preston','D','Kemper','28069','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.862463,-88.833533,0,'2013-07-06 12:44:32',NULL,NULL),(29734,'32963','S','Indian River Shores','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.647905,-80.360668,0,'2013-07-06 12:44:32',NULL,NULL),(29797,'33021','S','Pembroke Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.026253,-80.189124,0,'2013-07-06 12:44:32',NULL,NULL),(71151,'86033','P','Black Mesa','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.630720,-110.277720,0,'2013-07-06 12:44:34',NULL,NULL),(23015,'24827','S','Cyclone','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.740116,-81.664871,0,'2013-07-06 12:44:31',NULL,NULL),(61436,'72583','S','Viola','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.386789,-91.991298,0,'2013-07-06 12:44:33',NULL,NULL),(76154,'95306','S','Catheys Valley','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.437371,-120.090278,0,'2013-07-06 12:44:34',NULL,NULL),(77499,'96830','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286315,-157.834651,0,'2013-07-06 12:44:34',NULL,NULL),(2110,'00923','S','Urb Victoria','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(15089,'15757','S','McGees Mills','A','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.900980,-78.725700,0,'2013-07-06 12:44:31',NULL,NULL),(16484,'17253','P','Saltillo','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.211755,-78.005190,0,'2013-07-06 12:44:31',NULL,NULL),(39877,'45208','S','Hyde Park','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.132484,-84.435285,0,'2013-07-06 12:44:32',NULL,NULL),(23835,'26106','U','Parkersburg','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.324681,-81.500999,0,'2013-07-06 12:44:31',NULL,NULL),(74061,'92161','U','Va Hospital','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.879947,-117.228751,0,'2013-07-06 12:44:34',NULL,NULL),(33647,'37705','S','Andersonville','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.212392,-84.018115,0,'2013-07-06 12:44:32',NULL,NULL),(12732,'13160','S','Springport','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.842257,-76.688186,0,'2013-07-06 12:44:30',NULL,NULL),(60152,'71378','S','Elam','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.971417,-91.657424,0,'2013-07-06 12:44:33',NULL,NULL),(13099,'13476','S','Vernon','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.076874,-75.533524,0,'2013-07-06 12:44:30',NULL,NULL),(14000,'14518','P','Oaks Corners','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.930174,-77.012457,0,'2013-07-06 12:44:31',NULL,NULL),(15966,'17028','S','Shellsville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.374960,-76.694820,0,'2013-07-06 12:44:31',NULL,NULL),(26753,'29425','U','Medical University of SC','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.785741,-79.947783,0,'2013-07-06 12:44:31',NULL,NULL),(40027,'45248','S','Mack','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159624,-84.661853,0,'2013-07-06 12:44:32',NULL,NULL),(20828,'21631','S','East New Market','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.596813,-75.935069,0,'2013-07-06 12:44:31',NULL,NULL),(34990,'39110','S','Madison','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.467942,-90.121854,0,'2013-07-06 12:44:32',NULL,NULL),(62400,'74110','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.182072,-95.949848,0,'2013-07-06 12:44:33',NULL,NULL),(12083,'12555','P','Newburgh','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.508604,-74.013373,0,'2013-07-06 12:44:30',NULL,NULL),(40448,'45734','S','Graysville','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.656927,-81.187313,0,'2013-07-06 12:44:32',NULL,NULL),(58442,'68713','S','Atkinson','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.530554,-98.978943,0,'2013-07-06 12:44:33',NULL,NULL),(44077,'49449','S','Pentwater','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.796820,-86.371320,0,'2013-07-06 12:44:32',NULL,NULL),(55208,'63388','S','Williamsburg','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.836617,-92.002176,0,'2013-07-06 12:44:33',NULL,NULL),(50014,'57384','S','Wolsey','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.413182,-98.472035,0,'2013-07-06 12:44:33',NULL,NULL),(2502,'00957','S','Colinas de Bayoan','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(65910,'78236','S','San Antonio','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(6511,'05821','S','South Peacham','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.314722,-72.166389,0,'2013-07-06 12:44:30',NULL,NULL),(11471,'12018','S','Alps','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(31867,'35121','S','Rosa','A','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.948154,-86.470543,0,'2013-07-06 12:44:32',NULL,NULL),(52650,'61062','S','Pearl City','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.259707,-89.829814,0,'2013-07-06 12:44:33',NULL,NULL),(25705,'28538','S','Hookerton','D','Greene','37079','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.427634,-77.548050,0,'2013-07-06 12:44:31',NULL,NULL),(60415,'71640','S','Boueff','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(17798,'18371','S','Bushkill','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.093333,-75.002222,0,'2013-07-06 12:44:31',NULL,NULL),(18384,'19047','S','Upper Holland','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.179301,-74.905397,0,'2013-07-06 12:44:31',NULL,NULL),(8116,'07822','S','Augusta','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.143214,-74.696658,0,'2013-07-06 12:44:30',NULL,NULL),(11478,'12019','S','Ballston Lake','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.921720,-73.890600,0,'2013-07-06 12:44:30',NULL,NULL),(55328,'63546','S','Willmathsville','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.344581,-92.537453,0,'2013-07-06 12:44:33',NULL,NULL),(3938,'02467','S','Boston College','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.318527,-71.157052,0,'2013-07-06 12:44:30',NULL,NULL),(51419,'59447','S','Geyser','D','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.220782,-110.430563,0,'2013-07-06 12:44:33',NULL,NULL),(14776,'15349','S','Davistown','A','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.745620,-80.092800,0,'2013-07-06 12:44:31',NULL,NULL),(66733,'78957','S','Kirtley','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.013892,-97.156138,0,'2013-07-06 12:44:34',NULL,NULL),(70530,'85014','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.513505,-112.052730,0,'2013-07-06 12:44:34',NULL,NULL),(59916,'71282','S','Thomastown','N','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(52492,'60699','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875983,-87.646718,0,'2013-07-06 12:44:33',NULL,NULL),(30453,'33332','S','Weston','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(31795,'35038','P','Burnwell','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.906385,-87.316333,0,'2013-07-06 12:44:32',NULL,NULL),(5582,'04915','S','Belfast','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.418374,-69.007415,0,'2013-07-06 12:44:30',NULL,NULL),(579,'00680','S','Bo La Quinta','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(55206,'63386','S','West Alton','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.869479,-90.215269,0,'2013-07-06 12:44:33',NULL,NULL),(78803,'98326','S','Ozette','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.171357,-124.279900,0,'2013-07-06 12:44:34',NULL,NULL),(38174,'43158','P','Union Furnace','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.451134,-82.362582,0,'2013-07-06 12:44:32',NULL,NULL),(49601,'56756','S','Salol','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.842985,-95.549737,0,'2013-07-06 12:44:33',NULL,NULL),(12608,'13083','S','Lacona','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.647853,-76.060983,0,'2013-07-06 12:44:30',NULL,NULL),(32993,'36625','U','Morrisons Cafeteria','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.694869,-88.045798,0,'2013-07-06 12:44:32',NULL,NULL),(47443,'54725','S','Connorsville','N','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.042696,-92.037334,0,'2013-07-06 12:44:32',NULL,NULL),(69879,'84098','S','Snyderville','A','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.657510,-111.495033,0,'2013-07-06 12:44:34',NULL,NULL),(76591,'95684','S','Omo Ranch','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.602860,-120.630000,0,'2013-07-06 12:44:34',NULL,NULL),(20521,'21090','S','Linthicum Heights','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.205670,-76.657567,0,'2013-07-06 12:44:31',NULL,NULL),(10868,'11417','S','Ozone Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674260,-73.843796,0,'2013-07-06 12:44:30',NULL,NULL),(58795,'68981','S','Upland','D','Franklin','31061','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.306386,-98.894267,0,'2013-07-06 12:44:33',NULL,NULL),(55059,'63157','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616454,-90.215267,0,'2013-07-06 12:44:33',NULL,NULL),(69891,'84104','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.749850,-111.934638,0,'2013-07-06 12:44:34',NULL,NULL),(79316,'98599','U','Olympia Brm','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.997332,-122.874737,0,'2013-07-06 12:44:34',NULL,NULL),(957,'00716','S','Repto Sabanetas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(38181,'43164','S','Williamsport','D','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.600994,-83.122085,0,'2013-07-06 12:44:32',NULL,NULL),(16055,'17047','S','Andersonburg','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(28248,'31061','S','Mville','N','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.085732,-83.245046,0,'2013-07-06 12:44:31',NULL,NULL),(23490,'25515','S','Galipolis Fry','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.699313,-82.120471,0,'2013-07-06 12:44:31',NULL,NULL),(25872,'28634','S','Harmony','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.956738,-80.772702,0,'2013-07-06 12:44:31',NULL,NULL),(46580,'53533','S','Dodgeville','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.963649,-90.134169,0,'2013-07-06 12:44:32',NULL,NULL),(50922,'58563','S','New Salem','D','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.853700,-101.435580,0,'2013-07-06 12:44:33',NULL,NULL),(51587,'59806','P','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.916293,-114.152007,0,'2013-07-06 12:44:33',NULL,NULL),(54804,'63017','S','Town and Country','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.647818,-90.545814,0,'2013-07-06 12:44:33',NULL,NULL),(68500,'81321','S','Arriola','N','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.347000,-108.736320,0,'2013-07-06 12:44:34',NULL,NULL),(76854,'95965','S','South Oroville','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(10629,'11052','U','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.844414,-73.701934,0,'2013-07-06 12:44:30',NULL,NULL),(28207,'31027','S','Dublin','A','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.548593,-82.870112,0,'2013-07-06 12:44:31',NULL,NULL),(66815,'79084','S','Stratford','D','Sherman','48421','Texas','TX','48','0000','806','Central',-6.0,'Y',36.337253,-102.072473,0,'2013-07-06 12:44:34',NULL,NULL),(69111,'83271','S','Roy','N','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.521281,-112.846469,0,'2013-07-06 12:44:34',NULL,NULL),(71098,'85937','S','Snowflake','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.510876,-110.094754,0,'2013-07-06 12:44:34',NULL,NULL),(77598,'96939','U','Koror','N','Palau','70030','Palau','PW','70','0000','671','UTC+9',9.0,'N',13.494468,144.777645,0,'2013-07-06 12:44:34',NULL,NULL),(61959,'73170','S','Oklahoma City','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.373300,-97.562460,0,'2013-07-06 12:44:33',NULL,NULL),(57035,'66208','S','Prairie Vlg','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(24096,'26506','S','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.618877,-79.973319,0,'2013-07-06 12:44:31',NULL,NULL),(54361,'62801','S','Finney Heights','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(35336,'39437','S','Crotts','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(14977,'15636','S','Harrison City','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.382751,-79.651174,0,'2013-07-06 12:44:31',NULL,NULL),(40306,'45458','S','Sugarcrk Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(25443,'28312','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.066291,-78.866574,0,'2013-07-06 12:44:31',NULL,NULL),(38567,'43773','S','Quaker City','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.036335,-81.297511,0,'2013-07-06 12:44:32',NULL,NULL),(25658,'28480','S','Wrightsville Beach','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.207240,-77.796330,0,'2013-07-06 12:44:31',NULL,NULL),(30504,'33403','S','Lake Park','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(34011,'38125','S','Hickory Hill','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.029029,-89.810269,0,'2013-07-06 12:44:32',NULL,NULL),(33685,'37745','S','Greeneville','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.186641,-82.815175,0,'2013-07-06 12:44:32',NULL,NULL),(52973,'61428','S','Dahinda','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.963678,-90.139944,0,'2013-07-06 12:44:33',NULL,NULL),(55174,'63369','S','Ethlyn','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.942597,-90.763542,0,'2013-07-06 12:44:33',NULL,NULL),(73954,'92061','S','Pala','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.306639,-116.974166,0,'2013-07-06 12:44:34',NULL,NULL),(39909,'45216','S','Valleydale','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(59034,'70083','S','Port Sulphur','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(46800,'54001','S','Wanderoos','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(51667,'59915','S','Elmo','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.817641,-114.391045,0,'2013-07-06 12:44:33',NULL,NULL),(72929,'90031','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.078396,-118.211918,0,'2013-07-06 12:44:34',NULL,NULL),(74065,'92166','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.721660,-117.231158,0,'2013-07-06 12:44:34',NULL,NULL),(52301,'60542','S','North Aurora','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.807193,-88.324757,0,'2013-07-06 12:44:33',NULL,NULL),(78523,'98125','S','Lake City','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.718413,-122.301588,0,'2013-07-06 12:44:34',NULL,NULL),(73479,'91320','S','Dos Vientos Ranch','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.185360,-118.926480,0,'2013-07-06 12:44:34',NULL,NULL),(71812,'87571','S','Pilar','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(65870,'78217','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.543976,-98.419822,0,'2013-07-06 12:44:34',NULL,NULL),(63393,'75644','S','Suffolk','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(11666,'12139','S','Piseco','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.390766,-74.606599,0,'2013-07-06 12:44:30',NULL,NULL),(44053,'49436','S','Mears','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.681967,-86.464667,0,'2013-07-06 12:44:32',NULL,NULL),(8861,'08650','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.137834,-74.627816,0,'2013-07-06 12:44:30',NULL,NULL),(7924,'07644','S','Lodi','D','Bergen','34003','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.878259,-74.080661,0,'2013-07-06 12:44:30',NULL,NULL),(14246,'14822','S','Canaseraga','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.453413,-77.787943,0,'2013-07-06 12:44:31',NULL,NULL),(12956,'13357','S','South Ilion','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(39114,'44254','S','Lodi','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.041984,-82.015606,0,'2013-07-06 12:44:32',NULL,NULL),(7085,'06350','P','Hanover','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.645060,-72.066019,0,'2013-07-06 12:44:30',NULL,NULL),(35849,'39818','P','Bainbridge','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.908890,-84.578618,0,'2013-07-06 12:44:32',NULL,NULL),(80136,'99776','P','Tanacross','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.354709,-143.360570,0,'2013-07-06 12:44:34',NULL,NULL),(61668,'72919','U','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.352237,-94.353023,0,'2013-07-06 12:44:33',NULL,NULL),(30787,'33597','S','Ridge Manor Estates','A','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.582156,-82.172936,0,'2013-07-06 12:44:32',NULL,NULL),(45754,'52142','S','Albany','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.857326,-91.809593,0,'2013-07-06 12:44:32',NULL,NULL),(72650,'89429','S','Stagecoach','A','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.358200,-119.295180,0,'2013-07-06 12:44:34',NULL,NULL),(64211,'76262','S','Trophy Club','A','Denton','48121','Texas','TX','48','1920','817','Central',-6.0,'Y',33.007049,-97.194352,0,'2013-07-06 12:44:34',NULL,NULL),(63730,'75933','S','Old Salem','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.517146,-93.809106,0,'2013-07-06 12:44:34',NULL,NULL),(61478,'72635','S','East Cotter','N','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.302640,-92.484480,0,'2013-07-06 12:44:33',NULL,NULL),(58681,'68920','S','Prairie Dog','N','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.102175,-99.361810,0,'2013-07-06 12:44:33',NULL,NULL),(38113,'43106','S','Bloomingburg','D','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.632887,-83.401809,0,'2013-07-06 12:44:32',NULL,NULL),(12443,'12962','S','Morrisonville','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.703540,-73.575720,0,'2013-07-06 12:44:30',NULL,NULL),(43192,'48302','S','Bloomfld Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(66336,'78605','S','Bertram','D','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.745034,-98.053979,0,'2013-07-06 12:44:34',NULL,NULL),(52909,'61364','S','Kangley','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(68431,'81215','P','Canon City','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.447689,-105.222893,0,'2013-07-06 12:44:34',NULL,NULL),(41695,'47223','S','Muscatatuck','A','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.120056,-85.492249,0,'2013-07-06 12:44:32',NULL,NULL),(17885,'18444','S','Elmhurst Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(61352,'72475','P','Waldenburg','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.565622,-90.936173,0,'2013-07-06 12:44:33',NULL,NULL),(14867,'15463','P','Merrittstown','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.963805,-79.875373,0,'2013-07-06 12:44:31',NULL,NULL),(23628,'25724','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.426357,-82.440990,0,'2013-07-06 12:44:31',NULL,NULL),(62403,'74115','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.178703,-95.908519,0,'2013-07-06 12:44:33',NULL,NULL),(67555,'80273','U','Blue Cross Blue Shield of CO','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.727577,-104.988288,0,'2013-07-06 12:44:34',NULL,NULL),(58920,'69336','S','Redington','N','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.674740,-103.054260,0,'2013-07-06 12:44:33',NULL,NULL),(58320,'68444','S','Hamilton','N','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.396596,-97.540543,0,'2013-07-06 12:44:33',NULL,NULL),(51687,'59934','P','Trego','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.702155,-114.871301,0,'2013-07-06 12:44:33',NULL,NULL),(48764,'55981','S','Dumfries','N','Wabasha','27157','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.359337,-92.023834,0,'2013-07-06 12:44:33',NULL,NULL),(26214,'28786','S','Waynesville','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.500644,-82.995090,0,'2013-07-06 12:44:31',NULL,NULL),(28193,'31017','S','Danville','D','Twiggs','13289','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.604257,-83.248013,0,'2013-07-06 12:44:31',NULL,NULL),(22190,'23502','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.852645,-76.212650,0,'2013-07-06 12:44:31',NULL,NULL),(41888,'47371','S','Bellefountain','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(42246,'47574','S','Tobin','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.947643,-86.588212,0,'2013-07-06 12:44:32',NULL,NULL),(10224,'10460','S','West Farms','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.837082,-73.880734,0,'2013-07-06 12:44:30',NULL,NULL),(56798,'65762','S','Thornfield','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.707587,-92.654958,0,'2013-07-06 12:44:33',NULL,NULL),(68311,'81101','S','Sand Dunes Mo','A','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(79951,'99629','P','Wasilla','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593474,-149.414543,0,'2013-07-06 12:44:34',NULL,NULL),(15207,'15963','S','Windber','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.224797,-78.809802,0,'2013-07-06 12:44:31',NULL,NULL),(13330,'13682','S','Rodman','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.847382,-75.859853,0,'2013-07-06 12:44:30',NULL,NULL),(3203,'01354','S','Mount Hermon','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711180,-72.448620,0,'2013-07-06 12:44:30',NULL,NULL),(22273,'23702','S','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.805570,-76.326550,0,'2013-07-06 12:44:31',NULL,NULL),(22139,'23453','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.774472,-76.075562,0,'2013-07-06 12:44:31',NULL,NULL),(55117,'63336','S','Clarksville','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.367306,-90.901583,0,'2013-07-06 12:44:33',NULL,NULL),(5702,'04983','S','Strong','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.868494,-70.234780,0,'2013-07-06 12:44:30',NULL,NULL),(79604,'99104','S','Belmont','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.085311,-117.161106,0,'2013-07-06 12:44:34',NULL,NULL),(76752,'95920','S','Butte City','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.463470,-121.943844,0,'2013-07-06 12:44:34',NULL,NULL),(70246,'84408','U','Weber State University','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.188154,-111.942473,0,'2013-07-06 12:44:34',NULL,NULL),(68777,'82325','S','Riverside','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.217500,-106.778333,0,'2013-07-06 12:44:34',NULL,NULL),(54647,'62928','S','Eddyville','D','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.537118,-88.596434,0,'2013-07-06 12:44:33',NULL,NULL),(29230,'32427','S','Caryville','D','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.816993,-85.804293,0,'2013-07-06 12:44:32',NULL,NULL),(37334,'41660','S','Teaberry','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.422387,-82.638021,0,'2013-07-06 12:44:32',NULL,NULL),(19861,'20522','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893759,-77.050641,0,'2013-07-06 12:44:31',NULL,NULL),(22664,'24277','S','Pennington Gap','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.755012,-83.033078,0,'2013-07-06 12:44:31',NULL,NULL),(53684,'62223','S','Belleville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.535955,-90.002379,0,'2013-07-06 12:44:33',NULL,NULL),(24947,'27828','S','Farmville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.593280,-77.588657,0,'2013-07-06 12:44:31',NULL,NULL),(61652,'72863','S','Scranton','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.330908,-93.544797,0,'2013-07-06 12:44:33',NULL,NULL),(31317,'34113','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.059541,-81.745430,0,'2013-07-06 12:44:32',NULL,NULL),(36393,'40502','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.002247,-84.480071,0,'2013-07-06 12:44:32',NULL,NULL),(73352,'91010','S','Bradbury','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138594,-117.963204,0,'2013-07-06 12:44:34',NULL,NULL),(50617,'58261','S','Voss','A','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.291130,-97.372047,0,'2013-07-06 12:44:33',NULL,NULL),(40878,'46240','S','Nora','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.905944,-86.128201,0,'2013-07-06 12:44:32',NULL,NULL),(17802,'18373','P','Bushkill','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.148666,-75.009201,0,'2013-07-06 12:44:31',NULL,NULL),(40312,'45459','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(77599,'96939','U','Palau','D','Palau','70030','Palau','PW','70','0000','671','UTC+9',9.0,'N',13.494468,144.777645,0,'2013-07-06 12:44:34',NULL,NULL),(35535,'39558','P','Lakeshore','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.241870,-89.434728,0,'2013-07-06 12:44:32',NULL,NULL),(29185,'32399','U','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.429675,-84.258538,0,'2013-07-06 12:44:32',NULL,NULL),(56410,'65250','S','Petersburg','N','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.062310,-92.839917,0,'2013-07-06 12:44:33',NULL,NULL),(7342,'06720','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.557028,-73.038046,0,'2013-07-06 12:44:30',NULL,NULL),(49849,'57238','S','Bemis','A','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.894100,-96.792780,0,'2013-07-06 12:44:33',NULL,NULL),(28246,'31060','S','Milan','D','Dodge','13091','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.930995,-83.066296,0,'2013-07-06 12:44:31',NULL,NULL),(38399,'43527','S','Holgate','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.249834,-84.132736,0,'2013-07-06 12:44:32',NULL,NULL),(65306,'77497','P','Stafford','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.615581,-95.554671,0,'2013-07-06 12:44:34',NULL,NULL),(2296,'00927','S','Jard de Vedruna','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(32387,'35950','S','Albertville','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.263566,-86.207048,0,'2013-07-06 12:44:32',NULL,NULL),(59438,'70711','S','Albany','D','Livingston','22063','Louisiana','LA','22','0760','985','Central',-6.0,'Y',30.517830,-90.591870,0,'2013-07-06 12:44:33',NULL,NULL),(37638,'42164','S','Scottsville','D','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.782160,-86.190120,0,'2013-07-06 12:44:32',NULL,NULL),(12946,'13354','S','Holland Patent','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.253640,-75.284520,0,'2013-07-06 12:44:30',NULL,NULL),(41202,'46725','S','Goose Lake','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(38730,'44023','S','Chagrin Falls','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.390948,-81.336689,0,'2013-07-06 12:44:32',NULL,NULL),(7844,'07465','S','Midvale','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.053747,-74.281246,0,'2013-07-06 12:44:30',NULL,NULL),(1819,'00784','S','Hacienda Los Recreos','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(60556,'71743','S','Gurdon','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.917085,-93.145662,0,'2013-07-06 12:44:33',NULL,NULL),(34008,'38124','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.111049,-89.907808,0,'2013-07-06 12:44:32',NULL,NULL),(34680,'38824','S','Jericho','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.520100,-88.672560,0,'2013-07-06 12:44:32',NULL,NULL),(55192,'63379','S','Old Alexandria','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.005640,-90.962460,0,'2013-07-06 12:44:33',NULL,NULL),(40939,'46295','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.673619,-86.194091,0,'2013-07-06 12:44:32',NULL,NULL),(41477,'46930','P','Fowlerton','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.409777,-85.571366,0,'2013-07-06 12:44:32',NULL,NULL),(19900,'20542','U','Library of Congress Handicap','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.940478,-77.029433,0,'2013-07-06 12:44:31',NULL,NULL),(59127,'70159','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.969507,-90.028428,0,'2013-07-06 12:44:33',NULL,NULL),(51361,'59341','S','Fallon','A','Prairie','30079','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.741221,-104.782243,0,'2013-07-06 12:44:33',NULL,NULL),(49397,'56621','S','Popple','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(46994,'54235','S','Sevastopol','N','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(25808,'28607','S','Meat Camp','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(60620,'71865','P','Wilton','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.739315,-94.111223,0,'2013-07-06 12:44:33',NULL,NULL),(60412,'71639','S','Mitchellville','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(50185,'57564','S','Kasper','N','Sully','46119','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.703712,-100.063844,0,'2013-07-06 12:44:33',NULL,NULL),(48932,'56156','S','Luverne','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.659593,-96.207701,0,'2013-07-06 12:44:33',NULL,NULL),(41176,'46711','S','Berne','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.645000,-85.033056,0,'2013-07-06 12:44:32',NULL,NULL),(69475,'83661','S','Payette','D','Payette','16075','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.075448,-116.901792,0,'2013-07-06 12:44:34',NULL,NULL),(77140,'96158','P','Tahoe Valley','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.925696,-119.966045,0,'2013-07-06 12:44:34',NULL,NULL),(17333,'17864','S','Port Trevorton','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(4698,'03813','S','North Chatham','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.163170,-71.012330,0,'2013-07-06 12:44:30',NULL,NULL),(54466,'62858','S','Bible Grove','A','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(649,'00682','S','Urb San Jose','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(22953,'24651','S','Tazewell','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.114440,-81.522480,0,'2013-07-06 12:44:31',NULL,NULL),(49013,'56258','S','Marshall','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445234,-95.782620,0,'2013-07-06 12:44:33',NULL,NULL),(47491,'54755','S','Mondovi','D','Buffalo','55011','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.566394,-91.671809,0,'2013-07-06 12:44:32',NULL,NULL),(45098,'50541','S','Pioneer','N','Pocahontas','19151','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.717660,-94.425000,0,'2013-07-06 12:44:32',NULL,NULL),(29481,'32728','P','Deltona','D','Volusia','12127','Florida','FL','12','2020','407/321','Eastern',-5.0,'Y',28.871490,-81.238270,0,'2013-07-06 12:44:32',NULL,NULL),(28862,'32113','S','Citra','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.386926,-82.118936,0,'2013-07-06 12:44:32',NULL,NULL),(25656,'28478','S','Willard','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.665443,-78.066376,0,'2013-07-06 12:44:31',NULL,NULL),(50241,'57625','S','Cheyenne River Reservation','N','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.994139,-101.237386,0,'2013-07-06 12:44:33',NULL,NULL),(49215,'56464','S','Runeberg','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(31674,'34762','S','Okahumpka','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.753723,-81.885779,0,'2013-07-06 12:44:32',NULL,NULL),(40363,'45638','S','Ironton','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.524095,-82.664084,0,'2013-07-06 12:44:32',NULL,NULL),(71275,'86433','P','Oatman','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.027862,-114.382287,0,'2013-07-06 12:44:34',NULL,NULL),(73441,'91226','P','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.160034,-118.213223,0,'2013-07-06 12:44:34',NULL,NULL),(10221,'10459','S','Longwood','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.827628,-73.896045,0,'2013-07-06 12:44:30',NULL,NULL),(38365,'43458','P','Rocky Ridge','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531155,-83.216285,0,'2013-07-06 12:44:32',NULL,NULL),(39813,'45140','S','Twightwee','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(64742,'76905','S','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.463731,-100.392259,0,'2013-07-06 12:44:34',NULL,NULL),(63557,'75766','S','Pine Hill','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:34',NULL,NULL),(60059,'71351','S','Marksville','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.161480,-92.095020,0,'2013-07-06 12:44:33',NULL,NULL),(57424,'66778','S','Treece','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.003569,-94.844982,0,'2013-07-06 12:44:33',NULL,NULL),(27182,'29847','S','Trenton','D','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.701160,-81.819780,0,'2013-07-06 12:44:31',NULL,NULL),(46023,'52549','S','Cincinnati','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.634270,-92.923794,0,'2013-07-06 12:44:32',NULL,NULL),(45730,'52099','U','Dubuque','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.495882,-90.667512,0,'2013-07-06 12:44:32',NULL,NULL),(45308,'50839','S','Carbon','D','Adams','19003','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.940320,-94.870974,0,'2013-07-06 12:44:32',NULL,NULL),(42607,'47885','S','W Terre Haute','A','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(36248,'40299','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.163000,-85.521300,0,'2013-07-06 12:44:32',NULL,NULL),(39177,'44313','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.134604,-81.595710,0,'2013-07-06 12:44:32',NULL,NULL),(78022,'97423','S','Coquille','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.183740,-124.208400,0,'2013-07-06 12:44:34',NULL,NULL),(61737,'73029','S','Cyril','D','Caddo','40015','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.897244,-98.203676,0,'2013-07-06 12:44:33',NULL,NULL),(12048,'12527','P','Glenham','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.521756,-73.937292,0,'2013-07-06 12:44:30',NULL,NULL),(44537,'49968','S','Wakefield','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.478287,-89.936616,0,'2013-07-06 12:44:32',NULL,NULL),(16374,'17201','S','Stoufferstown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(10296,'10523','S','Elmsford','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.055081,-73.816734,0,'2013-07-06 12:44:30',NULL,NULL),(24899,'27710','U','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.001767,-78.940724,0,'2013-07-06 12:44:31',NULL,NULL),(35094,'39206','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364777,-90.171740,0,'2013-07-06 12:44:32',NULL,NULL),(25191,'28056','S','Gastonia','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.209997,-81.146871,0,'2013-07-06 12:44:31',NULL,NULL),(31609,'34683','S','Palm Harbor','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.077455,-82.761109,0,'2013-07-06 12:44:32',NULL,NULL),(75768,'94624','P','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.747304,-122.172356,0,'2013-07-06 12:44:34',NULL,NULL),(76670,'95762','S','Folsom','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.715279,-121.078888,0,'2013-07-06 12:44:34',NULL,NULL),(55530,'63828','P','Canalou','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.754307,-89.686524,0,'2013-07-06 12:44:33',NULL,NULL),(23230,'25086','P','Glasgow','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.208152,-81.419467,0,'2013-07-06 12:44:31',NULL,NULL),(66656,'78852','S','Eagle Pass','D','Maverick','48323','Texas','TX','48','0000','830','Central',-6.0,'Y',28.715762,-100.492839,0,'2013-07-06 12:44:34',NULL,NULL),(33499,'37356','S','Monteagle','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.219746,-85.850668,0,'2013-07-06 12:44:32',NULL,NULL),(57363,'66739','S','Galena','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.069390,-94.633351,0,'2013-07-06 12:44:33',NULL,NULL),(9282,'09631','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(10503,'10965','S','Pearl River','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.062979,-74.018824,0,'2013-07-06 12:44:30',NULL,NULL),(63382,'75644','S','Latch','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(1484,'00751','S','Bo Coco Viejo','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(61921,'73150','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.403293,-97.341978,0,'2013-07-06 12:44:33',NULL,NULL),(55954,'64490','S','Hemple','A','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.753900,-94.502700,0,'2013-07-06 12:44:33',NULL,NULL),(53855,'62326','S','Fandon','N','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.423848,-90.792932,0,'2013-07-06 12:44:33',NULL,NULL),(52963,'61422','S','Bushnell','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.553035,-90.508826,0,'2013-07-06 12:44:33',NULL,NULL),(3683,'02130','S','Jamaica Plain','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.294720,-71.130540,0,'2013-07-06 12:44:30',NULL,NULL),(10594,'11030','S','Plandome','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.795533,-73.684954,0,'2013-07-06 12:44:30',NULL,NULL),(35489,'39522','U','Stennis Sp Ct','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(5398,'04654','S','Northfield','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.720530,-67.467043,0,'2013-07-06 12:44:30',NULL,NULL),(48061,'55324','S','Darwin','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.108352,-94.438355,0,'2013-07-06 12:44:33',NULL,NULL),(58757,'68959','S','Norman','A','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.493757,-98.949409,0,'2013-07-06 12:44:33',NULL,NULL),(53347,'61760','S','Spires','N','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.893180,-89.035680,0,'2013-07-06 12:44:33',NULL,NULL),(75308,'93745','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.707049,-119.753500,0,'2013-07-06 12:44:34',NULL,NULL),(14420,'15069','U','Alcoa Center','N','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.569677,-79.749317,0,'2013-07-06 12:44:31',NULL,NULL),(21651,'22937','S','Esmont','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.802102,-78.624774,0,'2013-07-06 12:44:31',NULL,NULL),(25041,'27909','S','Eliz City','N','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.295010,-76.233334,0,'2013-07-06 12:44:31',NULL,NULL),(61050,'72120','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.892804,-92.231859,0,'2013-07-06 12:44:33',NULL,NULL),(43579,'48743','S','Long Lake','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.429715,-83.877280,0,'2013-07-06 12:44:32',NULL,NULL),(35321,'39426','S','Carriere','D','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.592349,-89.639175,0,'2013-07-06 12:44:32',NULL,NULL),(53029,'61473','S','Swan Creek','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.667778,-90.654722,0,'2013-07-06 12:44:33',NULL,NULL),(30465,'33337','U','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110891,-80.274099,0,'2013-07-06 12:44:32',NULL,NULL),(4847,'04011','S','NAS Brunswick','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.905571,-69.964566,0,'2013-07-06 12:44:30',NULL,NULL),(26703,'29409','U','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.794242,-79.960770,0,'2013-07-06 12:44:31',NULL,NULL),(26783,'29450','S','Huger','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.020910,-79.790845,0,'2013-07-06 12:44:31',NULL,NULL),(33783,'37876','S','Pittman Center','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.839522,-83.480286,0,'2013-07-06 12:44:32',NULL,NULL),(40399,'45673','S','Richmond Dale','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.203081,-82.816583,0,'2013-07-06 12:44:32',NULL,NULL),(70608,'85118','S','Suprstitn Mtn','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(42543,'47868','S','Hoosier Highlands','N','Owen','18119','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.450742,-86.974712,0,'2013-07-06 12:44:32',NULL,NULL),(14553,'15212','S','Allegheny','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.469880,-80.015700,0,'2013-07-06 12:44:31',NULL,NULL),(61609,'72801','S','Russellville','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.282948,-93.138428,0,'2013-07-06 12:44:33',NULL,NULL),(79913,'99603','S','Homer','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(3287,'01504','S','Blackstone','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.026266,-71.528483,0,'2013-07-06 12:44:30',NULL,NULL),(21181,'22161','U','Dept of Commerce','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.787863,-77.187222,0,'2013-07-06 12:44:31',NULL,NULL),(54176,'62621','S','Bluffs','D','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.734110,-90.522678,0,'2013-07-06 12:44:33',NULL,NULL),(33707,'37766','S','Morley','A','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.338280,-84.069600,0,'2013-07-06 12:44:32',NULL,NULL),(23342,'25252','S','Duncan','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.957697,-81.571231,0,'2013-07-06 12:44:31',NULL,NULL),(13363,'13732','S','South Apalachin','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.057017,-76.137903,0,'2013-07-06 12:44:31',NULL,NULL),(79379,'98670','S','Wahkiacus','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.827577,-121.274857,0,'2013-07-06 12:44:34',NULL,NULL),(33711,'37772','S','Lenoir City','D','Loudon','47105','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.787215,-84.220049,0,'2013-07-06 12:44:32',NULL,NULL),(15792,'16923','S','West Bingham','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(48120,'55357','S','Corcoran','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.100321,-93.661093,0,'2013-07-06 12:44:33',NULL,NULL),(37955,'42718','S','Campbellsvlle','A','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.461291,-85.462912,0,'2013-07-06 12:44:32',NULL,NULL),(32779,'36420','S','Andalusia','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(29719,'32952','S','Merritt Is','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.342491,-80.675378,0,'2013-07-06 12:44:32',NULL,NULL),(69311,'83462','S','Carmen','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.269758,-113.845022,0,'2013-07-06 12:44:34',NULL,NULL),(74254,'92337','S','Fontana','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.044560,-117.485731,0,'2013-07-06 12:44:34',NULL,NULL),(58222,'68342','S','Diller','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.110011,-96.934026,0,'2013-07-06 12:44:33',NULL,NULL),(48337,'55470','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.986577,-93.271874,0,'2013-07-06 12:44:33',NULL,NULL),(15864,'16948','S','Bingham','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846520,-77.709720,0,'2013-07-06 12:44:31',NULL,NULL),(16293,'17107','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.296479,-76.874607,0,'2013-07-06 12:44:31',NULL,NULL),(25351,'28227','S','Mint Hill','A','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.184960,-80.654820,0,'2013-07-06 12:44:31',NULL,NULL),(47332,'54564','S','Tripoli','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.646975,-89.982350,0,'2013-07-06 12:44:32',NULL,NULL),(40446,'45732','S','Glouster','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.498216,-82.085766,0,'2013-07-06 12:44:32',NULL,NULL),(73059,'90091','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.989658,-118.149153,0,'2013-07-06 12:44:34',NULL,NULL),(79729,'99215','P','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.690874,-117.209831,0,'2013-07-06 12:44:34',NULL,NULL),(63203,'75438','S','Dodd City','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.577173,-96.075681,0,'2013-07-06 12:44:33',NULL,NULL),(58257,'68371','S','Lushton','N','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.785000,-97.783320,0,'2013-07-06 12:44:33',NULL,NULL),(70630,'85140','S','Queen Creek','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.236620,-111.543690,0,'2013-07-06 12:44:34',NULL,NULL),(11983,'12471','P','Rifton','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.832741,-74.037450,0,'2013-07-06 12:44:30',NULL,NULL),(70443,'84742','P','Kanarraville','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.535865,-113.176078,0,'2013-07-06 12:44:34',NULL,NULL),(46393,'53153','S','North Prairie','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.945745,-88.424589,0,'2013-07-06 12:44:32',NULL,NULL),(50224,'57585','S','Wood','D','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.563165,-100.408076,0,'2013-07-06 12:44:33',NULL,NULL),(52299,'60541','S','Nettlecreek','N','Kendall','17093','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.514251,-88.510263,0,'2013-07-06 12:44:33',NULL,NULL),(788,'00693','S','Brisas De Tortuguero','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(60339,'71465','S','Standard','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.907286,-92.223113,0,'2013-07-06 12:44:33',NULL,NULL),(10982,'11545','S','Old Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(9345,'09798','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(25463,'28335','P','Dunn','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.309700,-78.608202,0,'2013-07-06 12:44:31',NULL,NULL),(36173,'40243','S','Middletown','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(22963,'24701','S','Littlesburg','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(18893,'19470','P','St Peters','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.173768,-75.732305,0,'2013-07-06 12:44:31',NULL,NULL),(17874,'18438','S','Lakeville','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.475833,-75.182500,0,'2013-07-06 12:44:31',NULL,NULL),(39075,'44215','S','Briarwood Beach','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.068001,-81.904211,0,'2013-07-06 12:44:32',NULL,NULL),(16755,'17516','S','Highville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.925500,-76.366080,0,'2013-07-06 12:44:31',NULL,NULL),(49608,'56761','S','Wannaska','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.630234,-95.733971,0,'2013-07-06 12:44:33',NULL,NULL),(69855,'84089','P','Clearfield','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.110730,-112.024956,0,'2013-07-06 12:44:34',NULL,NULL),(31471,'34291','S','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.091905,-82.232783,0,'2013-07-06 12:44:32',NULL,NULL),(29744,'32968','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.596949,-80.452283,0,'2013-07-06 12:44:32',NULL,NULL),(8832,'08628','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.273620,-74.817480,0,'2013-07-06 12:44:30',NULL,NULL),(64395,'76538','S','Lanham','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.598240,-97.759127,0,'2013-07-06 12:44:34',NULL,NULL),(63112,'75285','U','Bank of America','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.767941,-96.827934,0,'2013-07-06 12:44:33',NULL,NULL),(4205,'02831','S','Hope','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.745013,-71.571255,0,'2013-07-06 12:44:30',NULL,NULL),(47613,'54891','S','Washburn','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.672529,-90.896655,0,'2013-07-06 12:44:33',NULL,NULL),(32134,'35449','P','Coaling','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.157283,-87.338672,0,'2013-07-06 12:44:32',NULL,NULL),(77227,'96503','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(5171,'04429','S','Holden','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.761927,-68.642786,0,'2013-07-06 12:44:30',NULL,NULL),(63969,'76103','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.747249,-97.265412,0,'2013-07-06 12:44:34',NULL,NULL),(11265,'11769','S','Oakdale','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.739823,-73.133122,0,'2013-07-06 12:44:30',NULL,NULL),(50540,'58124','U','Bank of the West','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.873899,-96.786609,0,'2013-07-06 12:44:33',NULL,NULL),(39904,'45216','S','Carthage','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197614,-84.478537,0,'2013-07-06 12:44:32',NULL,NULL),(31356,'34203','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.443170,-82.531219,0,'2013-07-06 12:44:32',NULL,NULL),(26373,'29079','P','Lydia','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.285597,-80.034022,0,'2013-07-06 12:44:31',NULL,NULL),(53913,'62374','S','Tennessee','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.424866,-90.799019,0,'2013-07-06 12:44:33',NULL,NULL),(71589,'87316','P','McGaffey','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432945,-108.725842,0,'2013-07-06 12:44:34',NULL,NULL),(73199,'90601','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',34.005998,-118.032175,0,'2013-07-06 12:44:34',NULL,NULL),(75974,'95061','P','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.976735,-122.023603,0,'2013-07-06 12:44:34',NULL,NULL),(8490,'08095','P','Winslow','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.657713,-74.867102,0,'2013-07-06 12:44:30',NULL,NULL),(32804,'36439','P','Excel','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.393663,-87.420921,0,'2013-07-06 12:44:32',NULL,NULL),(46090,'52619','S','Charleston','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.564680,-91.579860,0,'2013-07-06 12:44:32',NULL,NULL),(33089,'36803','P','Opelika','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.645558,-85.374434,0,'2013-07-06 12:44:32',NULL,NULL),(38479,'43656','U','Blue Cross Hosp Serv','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.704746,-83.650800,0,'2013-07-06 12:44:32',NULL,NULL),(63295,'75561','S','Barkman','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(45563,'51503','S','Council Bluffs','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.263360,-95.819074,0,'2013-07-06 12:44:32',NULL,NULL),(71777,'87557','S','Rancho Taos','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(73223,'90631','S','La Habra Hts','N','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.941040,-117.954420,0,'2013-07-06 12:44:34',NULL,NULL),(73471,'91310','P','Castaic','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.494638,-118.614455,0,'2013-07-06 12:44:34',NULL,NULL),(75513,'94145','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.794247,-122.400377,0,'2013-07-06 12:44:34',NULL,NULL),(52775,'61263','P','Matherville','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.275080,-90.609390,0,'2013-07-06 12:44:33',NULL,NULL),(16575,'17319','S','Newberrytown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.152317,-76.794239,0,'2013-07-06 12:44:31',NULL,NULL),(52359,'60611','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.894244,-87.622841,0,'2013-07-06 12:44:33',NULL,NULL),(28580,'31629','S','Dixie','D','Brooks','13027','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.745881,-83.679723,0,'2013-07-06 12:44:32',NULL,NULL),(47641,'54923','S','Auroraville','N','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.969316,-88.947033,0,'2013-07-06 12:44:33',NULL,NULL),(43380,'48427','S','Deckerville','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.530187,-82.706551,0,'2013-07-06 12:44:32',NULL,NULL),(9342,'09769','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(63277,'75551','S','Atlanta','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.115529,-94.170131,0,'2013-07-06 12:44:33',NULL,NULL),(60598,'71840','P','Genoa','D','Miller','05091','Arkansas','AR','05','8360','870','Central',-6.0,'Y',33.383776,-93.908965,0,'2013-07-06 12:44:33',NULL,NULL),(23068,'24879','S','Atwell','N','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.349167,-81.762778,0,'2013-07-06 12:44:31',NULL,NULL),(17836,'18421','S','Clifford Twp','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(72042,'88062','P','Silver City','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.760196,-108.276695,0,'2013-07-06 12:44:34',NULL,NULL),(72876,'90009','P','Los Angls AFB','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.946348,-118.379884,0,'2013-07-06 12:44:34',NULL,NULL),(73466,'91307','S','Canoga Park','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201920,-118.660980,0,'2013-07-06 12:44:34',NULL,NULL),(76675,'95798','P','West Sacramento','D','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.574918,-121.561857,0,'2013-07-06 12:44:34',NULL,NULL),(24759,'27542','S','Bagley','N','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.590858,-78.122283,0,'2013-07-06 12:44:31',NULL,NULL),(23267,'25140','S','Naoma','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.897184,-81.525084,0,'2013-07-06 12:44:31',NULL,NULL),(60151,'71377','P','Wildsville','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.614891,-91.781568,0,'2013-07-06 12:44:33',NULL,NULL),(34459,'38659','S','Lake Center','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(40791,'46170','S','Putnamville','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.573590,-86.862163,0,'2013-07-06 12:44:32',NULL,NULL),(43258,'48324','S','West Bloomfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595440,-83.383020,0,'2013-07-06 12:44:32',NULL,NULL),(52124,'60428','S','Markham','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.608419,-87.666114,0,'2013-07-06 12:44:33',NULL,NULL),(19063,'19547','S','Pike','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(8543,'08201','S','Smithville','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(63563,'75770','S','New York','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.149920,-95.613600,0,'2013-07-06 12:44:34',NULL,NULL),(54774,'62995','S','Vienna','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.418189,-88.898747,0,'2013-07-06 12:44:33',NULL,NULL),(79771,'99333','P','Hooper','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.754267,-118.144685,0,'2013-07-06 12:44:34',NULL,NULL),(11075,'11598','S','Woodmere','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.633418,-73.714284,0,'2013-07-06 12:44:30',NULL,NULL),(36435,'40591','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.048061,-84.493671,0,'2013-07-06 12:44:32',NULL,NULL),(66550,'78733','S','Bee Caves','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.321780,-97.895100,0,'2013-07-06 12:44:34',NULL,NULL),(53748,'62258','S','Mascoutah','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.451780,-89.761020,0,'2013-07-06 12:44:33',NULL,NULL),(77682,'97035','S','Lake Grove','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.411593,-122.725222,0,'2013-07-06 12:44:34',NULL,NULL),(78982,'98376','S','Center','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.813700,-122.850480,0,'2013-07-06 12:44:34',NULL,NULL),(41856,'47354','S','Blountsville','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.039740,-85.201920,0,'2013-07-06 12:44:32',NULL,NULL),(75967,'95054','S','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.352976,-121.957963,0,'2013-07-06 12:44:34',NULL,NULL),(55434,'63670','S','Lake Forest','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(54784,'63005','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634884,-90.619343,0,'2013-07-06 12:44:33',NULL,NULL),(32402,'35958','S','Bryant','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.950090,-85.643668,0,'2013-07-06 12:44:32',NULL,NULL),(32754,'36345','S','Headland','D','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.354177,-85.342013,0,'2013-07-06 12:44:32',NULL,NULL),(39505,'44807','S','Caroline','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(69156,'83318','S','Burley','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.528311,-113.790822,0,'2013-07-06 12:44:34',NULL,NULL),(78356,'98012','S','Bothell','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.841300,-122.205819,0,'2013-07-06 12:44:34',NULL,NULL),(60494,'71662','S','Pickens','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.812280,-91.403100,0,'2013-07-06 12:44:33',NULL,NULL),(58385,'68588','P','University of Nebraska','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.821099,-96.711844,0,'2013-07-06 12:44:33',NULL,NULL),(43850,'49104','U','Andrews University','N','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.945755,-86.340672,0,'2013-07-06 12:44:32',NULL,NULL),(67252,'79951','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.758593,-106.483795,0,'2013-07-06 12:44:34',NULL,NULL),(79475,'98858','S','Waterville','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.677620,-119.909880,0,'2013-07-06 12:44:34',NULL,NULL),(4366,'03064','S','Nashua','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.766575,-71.465576,0,'2013-07-06 12:44:30',NULL,NULL),(26619,'29307','S','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.998752,-81.746450,0,'2013-07-06 12:44:31',NULL,NULL),(27089,'29709','S','Chesterfield','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.736824,-80.095126,0,'2013-07-06 12:44:31',NULL,NULL),(38978,'44130','S','Middleburg Hts','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(71338,'86511','P','Cross Canyon','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.853888,-109.299177,0,'2013-07-06 12:44:34',NULL,NULL),(72575,'89404','P','Denio','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(15358,'16248','S','Rimersburg','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.041825,-79.501697,0,'2013-07-06 12:44:31',NULL,NULL),(62729,'74820','S','Byng','A','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.771920,-96.679980,0,'2013-07-06 12:44:33',NULL,NULL),(56109,'64801','S','Duquesne','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(15416,'16354','S','Titusville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.624676,-79.685623,0,'2013-07-06 12:44:31',NULL,NULL),(10662,'11105','S','Long Island City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.778285,-73.910175,0,'2013-07-06 12:44:30',NULL,NULL),(2760,'00969','S','Villa Clementina','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(43564,'48727','S','Clifford','D','Lapeer','26087','Michigan','MI','26','2160','989','Eastern',-5.0,'Y',43.306457,-83.176628,0,'2013-07-06 12:44:32',NULL,NULL),(29209,'32413','S','P C Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(25387,'28266','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.231320,-80.844515,0,'2013-07-06 12:44:31',NULL,NULL),(16210,'17071','P','New Germantown','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.282231,-77.577883,0,'2013-07-06 12:44:31',NULL,NULL),(15520,'16534','U','Times Publishing Co','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.124628,-80.085466,0,'2013-07-06 12:44:31',NULL,NULL),(4886,'04042','S','Hollis Center','D','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.630376,-70.640245,0,'2013-07-06 12:44:30',NULL,NULL),(20322,'20833','S','Brookeville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.206400,-77.050740,0,'2013-07-06 12:44:31',NULL,NULL),(40155,'45353','P','Pemberton','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.291694,-84.032709,0,'2013-07-06 12:44:32',NULL,NULL),(36223,'40283','U','Pleasure Ridge Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(16858,'17563','S','Oakryn','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(22268,'23693','S','Tabb','A','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.122300,-76.448400,0,'2013-07-06 12:44:31',NULL,NULL),(28031,'30641','S','Good Hope','D','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.777502,-83.566916,0,'2013-07-06 12:44:31',NULL,NULL),(10828,'11380','P','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742946,-73.884618,0,'2013-07-06 12:44:30',NULL,NULL),(56615,'65582','S','Vienna','D','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.199868,-91.933432,0,'2013-07-06 12:44:33',NULL,NULL),(44884,'50317','S','Capitol Heights','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(42300,'47598','S','Cato','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(74000,'92108','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.771930,-117.135062,0,'2013-07-06 12:44:34',NULL,NULL),(2765,'00970','P','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385147,-66.115683,0,'2013-07-06 12:44:30',NULL,NULL),(26193,'28770','P','Ridgecrest','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.615404,-82.318031,0,'2013-07-06 12:44:31',NULL,NULL),(37682,'42220','S','Allegre','A','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.874485,-87.176140,0,'2013-07-06 12:44:32',NULL,NULL),(71538,'87153','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.066407,-106.503424,0,'2013-07-06 12:44:34',NULL,NULL),(64411,'76547','P','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.118935,-97.726595,0,'2013-07-06 12:44:34',NULL,NULL),(8681,'08330','S','Weymouth','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440760,-74.728980,0,'2013-07-06 12:44:30',NULL,NULL),(24411,'27114','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.103243,-80.243693,0,'2013-07-06 12:44:31',NULL,NULL),(18496,'19095','S','Cedarbrook','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.086592,-75.150296,0,'2013-07-06 12:44:31',NULL,NULL),(60512,'71666','P','Rohwer','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.659552,-91.194003,0,'2013-07-06 12:44:33',NULL,NULL),(19926,'20558','U','Comm Tech Uses Copyrights','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896381,-77.037179,0,'2013-07-06 12:44:31',NULL,NULL),(42079,'47454','S','Stampers Crk','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(26773,'29442','P','Georgetown','D','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.383786,-79.286956,0,'2013-07-06 12:44:31',NULL,NULL),(77124,'96152','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.942280,-119.976119,0,'2013-07-06 12:44:34',NULL,NULL),(64079,'76148','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(38792,'44060','S','Kirtland Hills','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(2300,'00927','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(8011,'07722','S','Phalanx','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.309639,-74.182060,0,'2013-07-06 12:44:30',NULL,NULL),(66243,'78570','S','Thayer','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160480,-97.919820,0,'2013-07-06 12:44:34',NULL,NULL),(64824,'77032','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.940786,-95.345853,0,'2013-07-06 12:44:34',NULL,NULL),(22489,'24066','S','Buchanan','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.531800,-79.683720,0,'2013-07-06 12:44:31',NULL,NULL),(47024,'54324','P','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.479479,-88.021349,0,'2013-07-06 12:44:32',NULL,NULL),(25993,'28669','S','Roaring River','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.190998,-80.999456,0,'2013-07-06 12:44:31',NULL,NULL),(77558,'96861','S','Camp Smith','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.395150,-157.899220,0,'2013-07-06 12:44:34',NULL,NULL),(79331,'98612','S','Cathlamet','D','Wahkiakum','53069','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.210920,-123.335040,0,'2013-07-06 12:44:34',NULL,NULL),(52849,'61322','P','Depue Junction','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.325484,-89.303078,0,'2013-07-06 12:44:33',NULL,NULL),(66981,'79430','U','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.592746,-101.898787,0,'2013-07-06 12:44:34',NULL,NULL),(2497,'00957','S','Alt de Cana','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(26452,'29137','S','Salley','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.637039,-81.295434,0,'2013-07-06 12:44:31',NULL,NULL),(70114,'84184','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.679483,-111.954813,0,'2013-07-06 12:44:34',NULL,NULL),(66748,'79005','S','Booker','D','Lipscomb','48295','Texas','TX','48','0000','806','Central',-6.0,'Y',36.455591,-100.524472,0,'2013-07-06 12:44:34',NULL,NULL),(6466,'05761','S','Spankerton','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(68157,'81002','P','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.253797,-104.607766,0,'2013-07-06 12:44:34',NULL,NULL),(23811,'26055','S','Proctor','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.720438,-80.752102,0,'2013-07-06 12:44:31',NULL,NULL),(42796,'48048','S','Lenox Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.738060,-82.801020,0,'2013-07-06 12:44:32',NULL,NULL),(5588,'04920','S','Bingham','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.128441,-69.858003,0,'2013-07-06 12:44:30',NULL,NULL),(36639,'41004','S','Woolcott','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(18119,'18813','P','Brooklyn','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.751582,-75.808429,0,'2013-07-06 12:44:31',NULL,NULL),(15876,'17001','P','Camp Hill','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.239470,-76.918627,0,'2013-07-06 12:44:31',NULL,NULL),(69767,'84056','S','Hill Air Force Base','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.120889,-111.982055,0,'2013-07-06 12:44:34',NULL,NULL),(74333,'92404','S','Del Rosa','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.148310,-117.257233,0,'2013-07-06 12:44:34',NULL,NULL),(902,'00705','S','Ext Bella Vista','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(1715,'00778','S','Est de Santa Barbara','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(45750,'52136','S','Vernon Springs','N','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.376062,-92.114632,0,'2013-07-06 12:44:32',NULL,NULL),(34112,'38183','P','Germantown','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.097353,-89.805551,0,'2013-07-06 12:44:32',NULL,NULL),(74021,'92128','S','Rancho Bernardo','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',33.010498,-117.070512,0,'2013-07-06 12:44:34',NULL,NULL),(61017,'72115','P','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.766295,-92.259072,0,'2013-07-06 12:44:33',NULL,NULL),(58029,'68004','S','Bancroft','D','Cuming','31039','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.013383,-96.574975,0,'2013-07-06 12:44:33',NULL,NULL),(54171,'62615','S','Auburn','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.589571,-89.746086,0,'2013-07-06 12:44:33',NULL,NULL),(31224,'33965','U','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637271,-81.872508,0,'2013-07-06 12:44:32',NULL,NULL),(40813,'46197','U','Usps Critical Parts','N','Hendricks','18063','Indiana','IN','18','3480','317/765','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(40354,'45630','P','Friendship','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.698862,-83.092030,0,'2013-07-06 12:44:32',NULL,NULL),(14841,'15439','P','Lake Lynn','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.733333,-79.866667,0,'2013-07-06 12:44:31',NULL,NULL),(53989,'62441','S','Marshall','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.400200,-87.694680,0,'2013-07-06 12:44:33',NULL,NULL),(2964,'01040','S','Holyoke','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.204025,-72.630051,0,'2013-07-06 12:44:30',NULL,NULL),(28679,'31795','S','Tyty','N','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.469259,-83.540717,0,'2013-07-06 12:44:32',NULL,NULL),(598,'00680','S','Urb Ensanche Vivaldi','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(66252,'78572','S','Palmview','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(12777,'13212','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.110960,-76.139280,0,'2013-07-06 12:44:30',NULL,NULL),(63440,'75670','S','Cave Springs','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(5125,'04406','S','Abbot','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.306850,-69.558284,0,'2013-07-06 12:44:30',NULL,NULL),(5536,'04783','S','Westmanland','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.055284,-68.256011,0,'2013-07-06 12:44:30',NULL,NULL),(75934,'95023','S','Hollister','D','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.848759,-121.388323,0,'2013-07-06 12:44:34',NULL,NULL),(12866,'13324','S','Cold Brook','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(68590,'81526','S','East Orchard Mesa','N','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.097318,-108.363606,0,'2013-07-06 12:44:34',NULL,NULL),(2013,'00915','S','Bda Buena Vista','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(38252,'43272','U','Main Office Box Brm','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.960349,-83.005660,0,'2013-07-06 12:44:32',NULL,NULL),(19360,'20051','U','Woodward and Lothrop','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897965,-77.025424,0,'2013-07-06 12:44:31',NULL,NULL),(15469,'16426','S','Mc Kean','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.990841,-80.144052,0,'2013-07-06 12:44:31',NULL,NULL),(14661,'15238','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.530285,-79.876419,0,'2013-07-06 12:44:31',NULL,NULL),(41467,'46917','S','Deer Creek','N','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.598280,-86.500680,0,'2013-07-06 12:44:32',NULL,NULL),(20883,'21690','U','Usa Fulfillment','N','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.218890,-76.071011,0,'2013-07-06 12:44:31',NULL,NULL),(66873,'79225','S','Chillicothe','D','Hardeman','48197','Texas','TX','48','0000','254','Central',-6.0,'Y',34.254787,-99.514254,0,'2013-07-06 12:44:34',NULL,NULL),(998,'00717','S','Urb Buena Vista','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(58994,'70057','S','Hahnville','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.938506,-90.480590,0,'2013-07-06 12:44:33',NULL,NULL),(71524,'87121','S','Five Points','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.016799,-106.755725,0,'2013-07-06 12:44:34',NULL,NULL),(8269,'08009','S','Berlin Boro','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.759420,-74.927340,0,'2013-07-06 12:44:30',NULL,NULL),(11524,'12036','S','Charlottevle','A','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.541441,-74.657149,0,'2013-07-06 12:44:30',NULL,NULL),(25313,'28164','S','Lowesville','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.352840,-81.101940,0,'2013-07-06 12:44:31',NULL,NULL),(72906,'90023','S','Commerce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.025925,-118.200657,0,'2013-07-06 12:44:34',NULL,NULL),(64782,'77006','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.742676,-95.390925,0,'2013-07-06 12:44:34',NULL,NULL),(12236,'12819','S','Clemons','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.639502,-73.441071,0,'2013-07-06 12:44:30',NULL,NULL),(64107,'76180','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(78171,'97637','S','Plush','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.609650,-119.972593,0,'2013-07-06 12:44:34',NULL,NULL),(4327,'02918','U','Providence College','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821945,-71.419150,0,'2013-07-06 12:44:30',NULL,NULL),(30471,'33340','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.143611,-80.173524,0,'2013-07-06 12:44:32',NULL,NULL),(70094,'84165','P','South Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(66132,'78463','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.774768,-97.396997,0,'2013-07-06 12:44:34',NULL,NULL),(11650,'12131','S','N Blenheim','A','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.487846,-74.429697,0,'2013-07-06 12:44:30',NULL,NULL),(21938,'23230','S','Richmond','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.592154,-77.497969,0,'2013-07-06 12:44:31',NULL,NULL),(60069,'71354','S','Kemps Landing','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.345723,-91.668555,0,'2013-07-06 12:44:33',NULL,NULL),(6113,'05457','S','East Franklin','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.968200,-72.895920,0,'2013-07-06 12:44:30',NULL,NULL),(36521,'40831','S','Smith','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.846189,-83.314477,0,'2013-07-06 12:44:32',NULL,NULL),(66285,'78582','S','Rio Grande City','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(65102,'77365','S','Porter','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.105908,-95.260353,0,'2013-07-06 12:44:34',NULL,NULL),(64429,'76557','S','Whitson','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(59343,'70551','P','Leonville','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.466648,-91.991172,0,'2013-07-06 12:44:33',NULL,NULL),(53447,'61882','S','Weldon','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.123992,-88.750523,0,'2013-07-06 12:44:33',NULL,NULL),(38438,'43565','P','Tontogany','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.417956,-83.740816,0,'2013-07-06 12:44:32',NULL,NULL),(76177,'95329','S','La Grange','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.690540,-120.353143,0,'2013-07-06 12:44:34',NULL,NULL),(22389,'23943','P','Farmville','A','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.240559,-78.457075,0,'2013-07-06 12:44:31',NULL,NULL),(74931,'93405','S','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.278280,-120.692170,0,'2013-07-06 12:44:34',NULL,NULL),(73317,'90815','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.794234,-118.115561,0,'2013-07-06 12:44:34',NULL,NULL),(70914,'85629','S','Sahuarita','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.952136,-110.997432,0,'2013-07-06 12:44:34',NULL,NULL),(53464,'61925','S','Dalton City','D','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.713827,-88.807278,0,'2013-07-06 12:44:33',NULL,NULL),(52893,'61350','S','Stoneyville','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(52187,'60467','S','Orland Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.587062,-87.883775,0,'2013-07-06 12:44:33',NULL,NULL),(44704,'50138','S','Pershing','A','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.320318,-93.103486,0,'2013-07-06 12:44:32',NULL,NULL),(25461,'28333','S','Dudley','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.295690,-78.021263,0,'2013-07-06 12:44:31',NULL,NULL),(33816,'37921','S','Karns','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.972950,-83.986531,0,'2013-07-06 12:44:32',NULL,NULL),(25034,'27896','S','Wilson','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.755620,-77.944711,0,'2013-07-06 12:44:31',NULL,NULL),(32292,'35677','S','Waterloo','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.949906,-88.005186,0,'2013-07-06 12:44:32',NULL,NULL),(37802,'42402','P','Baskett','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.868596,-87.461396,0,'2013-07-06 12:44:32',NULL,NULL),(61176,'72199','U','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.785804,-92.255214,0,'2013-07-06 12:44:33',NULL,NULL),(54420,'62835','S','Enfield','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.101164,-88.336661,0,'2013-07-06 12:44:33',NULL,NULL),(78970,'98371','S','Meeker','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(77925,'97325','S','West Stayton','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.838831,-122.858581,0,'2013-07-06 12:44:34',NULL,NULL),(78312,'97910','S','Burns Junction','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',42.682800,-117.430320,0,'2013-07-06 12:44:34',NULL,NULL),(43262,'48326','S','Lake Angelus','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.664620,-83.273880,0,'2013-07-06 12:44:32',NULL,NULL),(19884,'20534','U','Bureau of Prisons','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892271,-77.011002,0,'2013-07-06 12:44:31',NULL,NULL),(73235,'90652','P','Norwalk','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.920448,-118.072097,0,'2013-07-06 12:44:34',NULL,NULL),(51914,'60110','S','Carpentersville','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.125226,-88.263423,0,'2013-07-06 12:44:33',NULL,NULL),(10798,'11371','S','La Gurda Arpt','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.775842,-73.874904,0,'2013-07-06 12:44:30',NULL,NULL),(8158,'07855','P','Middleville','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.054435,-74.862719,0,'2013-07-06 12:44:30',NULL,NULL),(45217,'50636','S','Greene','D','Butler','19023','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.897631,-92.805586,0,'2013-07-06 12:44:32',NULL,NULL),(14667,'15239','S','Plum','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.479721,-79.749820,0,'2013-07-06 12:44:31',NULL,NULL),(23568,'25650','S','Emmett','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.660000,-81.850000,0,'2013-07-06 12:44:31',NULL,NULL),(51448,'59479','S','Stanford','D','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.143920,-110.170380,0,'2013-07-06 12:44:33',NULL,NULL),(27468,'30143','S','Big Canoe','A','Pickens','13227','Georgia','GA','13','0520','706/762','Eastern',-5.0,'Y',34.458900,-84.504060,0,'2013-07-06 12:44:31',NULL,NULL),(29451,'32707','S','Casselberry','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.660803,-81.309834,0,'2013-07-06 12:44:32',NULL,NULL),(66803,'79068','S','Panhandle','D','Carson','48065','Texas','TX','48','0000','806','Central',-6.0,'Y',35.348164,-101.380933,0,'2013-07-06 12:44:34',NULL,NULL),(63725,'75932','S','Burkeville','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.028220,-93.643080,0,'2013-07-06 12:44:34',NULL,NULL),(34346,'38580','S','Rickman','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.301898,-85.388794,0,'2013-07-06 12:44:32',NULL,NULL),(19080,'19562','S','Topton','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.502920,-75.703015,0,'2013-07-06 12:44:31',NULL,NULL),(4945,'04094','P','W Kennebunk','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.426443,-70.630455,0,'2013-07-06 12:44:30',NULL,NULL),(65234,'77451','P','Kendleton','D','Fort Bend','48157','Texas','TX','48','3360','979','Central',-6.0,'Y',29.447929,-96.001002,0,'2013-07-06 12:44:34',NULL,NULL),(59669,'71055','S','McIntyre','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.617484,-93.281086,0,'2013-07-06 12:44:33',NULL,NULL),(40776,'46160','S','Fruitdale','N','Morgan','18109','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.380093,-86.264593,0,'2013-07-06 12:44:32',NULL,NULL),(40601,'45886','S','Scott','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.985439,-84.580964,0,'2013-07-06 12:44:32',NULL,NULL),(46881,'54111','S','Cecil','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.810409,-88.449834,0,'2013-07-06 12:44:32',NULL,NULL),(8899,'08733','S','Lakehurst Nae','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(63960,'76095','P','Bedford','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.855376,-97.149283,0,'2013-07-06 12:44:34',NULL,NULL),(25223,'28090','S','Belwood','N','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.465460,-81.532440,0,'2013-07-06 12:44:31',NULL,NULL),(8975,'08824','S','Kendall Park','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.419345,-74.550090,0,'2013-07-06 12:44:30',NULL,NULL),(70857,'85553','P','Tonto Basin','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.090332,-111.170694,0,'2013-07-06 12:44:34',NULL,NULL),(51289,'59211','S','Antelope','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.689739,-104.451099,0,'2013-07-06 12:44:33',NULL,NULL),(40095,'45305','S','Sugarcrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(40096,'45306','S','Botkins','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.463867,-84.182685,0,'2013-07-06 12:44:32',NULL,NULL),(41277,'46755','S','Wakefield Village','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(43613,'48805','P','Okemos','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.707511,-84.415014,0,'2013-07-06 12:44:32',NULL,NULL),(48960,'56181','S','Welcome','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.669710,-94.621039,0,'2013-07-06 12:44:33',NULL,NULL),(72287,'88568','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769406,-106.331351,0,'2013-07-06 12:44:34',NULL,NULL),(72403,'89044','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.994630,-115.118970,0,'2013-07-06 12:44:34',NULL,NULL),(65886,'78230','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.539652,-98.551914,0,'2013-07-06 12:44:34',NULL,NULL),(39089,'44224','S','Cuyahoga Falls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.173500,-81.449700,0,'2013-07-06 12:44:32',NULL,NULL),(42559,'47874','S','Coal Bluff','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(11270,'11770','P','Seaview','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.647098,-73.151777,0,'2013-07-06 12:44:30',NULL,NULL),(55398,'63636','S','Des Arc','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.306207,-90.613975,0,'2013-07-06 12:44:33',NULL,NULL),(41885,'47370','P','East Germantown','A','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.815011,-85.136637,0,'2013-07-06 12:44:32',NULL,NULL),(65264,'77470','S','Rock Island','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.531750,-96.574977,0,'2013-07-06 12:44:34',NULL,NULL),(43460,'48551','U','Gm Truck and Bus','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.987259,-83.711956,0,'2013-07-06 12:44:32',NULL,NULL),(59665,'71052','S','S Mansfield','A','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.034409,-93.700560,0,'2013-07-06 12:44:33',NULL,NULL),(58752,'68957','S','St Stephens','N','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.261367,-98.214325,0,'2013-07-06 12:44:33',NULL,NULL),(71562,'87199','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.161545,-106.579538,0,'2013-07-06 12:44:34',NULL,NULL),(51434,'59462','S','Moccasin','D','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.108054,-109.880806,0,'2013-07-06 12:44:33',NULL,NULL),(54124,'62555','S','Owaneco','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.481883,-89.192031,0,'2013-07-06 12:44:33',NULL,NULL),(36707,'41017','S','South Fort Mitchell','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(40994,'46360','S','Long Beach','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(27755,'30360','S','Doraville','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928090,-84.278530,0,'2013-07-06 12:44:31',NULL,NULL),(63996,'76113','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.746555,-97.328024,0,'2013-07-06 12:44:34',NULL,NULL),(48604,'55786','P','Taconite','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.309263,-93.382691,0,'2013-07-06 12:44:33',NULL,NULL),(70891,'85615','S','Parker Lake','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.402920,-110.207340,0,'2013-07-06 12:44:34',NULL,NULL),(64825,'77033','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.663012,-95.339493,0,'2013-07-06 12:44:34',NULL,NULL),(39845,'45166','P','Reesville','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.481320,-83.677691,0,'2013-07-06 12:44:32',NULL,NULL),(71579,'87312','S','Continental Divide','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.468748,-108.455845,0,'2013-07-06 12:44:34',NULL,NULL),(62650,'74578','S','Wilburton','D','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.914894,-95.309389,0,'2013-07-06 12:44:33',NULL,NULL),(51490,'59624','P','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.597949,-112.031022,0,'2013-07-06 12:44:33',NULL,NULL),(3344,'01546','U','Shrewsbury','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.291820,-71.745989,0,'2013-07-06 12:44:30',NULL,NULL),(13987,'14506','S','Mendon','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.998096,-77.499835,0,'2013-07-06 12:44:31',NULL,NULL),(28692,'31808','S','Fortson','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.595608,-84.970919,0,'2013-07-06 12:44:32',NULL,NULL),(61376,'72525','P','Cherokee Vlg','A','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.315833,-91.482500,0,'2013-07-06 12:44:33',NULL,NULL),(51939,'60126','S','Elmhurst','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.893914,-87.940580,0,'2013-07-06 12:44:33',NULL,NULL),(24878,'27698','U','Carolina Power and Light Co','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772821,-78.639812,0,'2013-07-06 12:44:31',NULL,NULL),(8756,'08534','S','Pennington','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.332828,-74.775218,0,'2013-07-06 12:44:30',NULL,NULL),(20733,'21288','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.291729,-76.608616,0,'2013-07-06 12:44:31',NULL,NULL),(12536,'13037','S','Chtg','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(44950,'50381','U','HP Other','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585640,-93.640154,0,'2013-07-06 12:44:32',NULL,NULL),(6010,'05359','S','Windham','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.163746,-72.719255,0,'2013-07-06 12:44:30',NULL,NULL),(17504,'17963','S','De Turksville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(62262,'74010','S','Bristow','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.831459,-96.387712,0,'2013-07-06 12:44:33',NULL,NULL),(37453,'41847','S','Carr Creek','N','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.231111,-82.968056,0,'2013-07-06 12:44:32',NULL,NULL),(41288,'46761','S','Plato','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(42070,'47452','S','Pumpkin Center','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(50881,'58530','S','Hensler','A','Oliver','38065','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.086010,-100.941390,0,'2013-07-06 12:44:33',NULL,NULL),(69749,'84049','S','Midway','D','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.521857,-111.468543,0,'2013-07-06 12:44:34',NULL,NULL),(33643,'37694','S','Watauga','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.414288,-82.270814,0,'2013-07-06 12:44:32',NULL,NULL),(76027,'95139','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.223089,-121.768381,0,'2013-07-06 12:44:34',NULL,NULL),(39649,'45001','P','Addyston','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.137789,-84.709626,0,'2013-07-06 12:44:32',NULL,NULL),(62701,'74738','S','Grant','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.911250,-95.467687,0,'2013-07-06 12:44:33',NULL,NULL),(65153,'77391','P','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.021537,-95.569341,0,'2013-07-06 12:44:34',NULL,NULL),(71596,'87320','P','Mexican Spgs','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.775385,-108.841337,0,'2013-07-06 12:44:34',NULL,NULL),(73906,'92011','S','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.150800,-117.306000,0,'2013-07-06 12:44:34',NULL,NULL),(63360,'75639','S','De Berry','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.250480,-94.139400,0,'2013-07-06 12:44:33',NULL,NULL),(14901,'15510','U','Somerset','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.009196,-79.080641,0,'2013-07-06 12:44:31',NULL,NULL),(14086,'14616','S','Greece','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.229040,-77.680740,0,'2013-07-06 12:44:31',NULL,NULL),(23455,'25425','S','Harpers Ferry','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.338935,-77.777029,0,'2013-07-06 12:44:31',NULL,NULL),(25124,'28001','S','Plyler','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(58672,'68901','S','Hansen','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(71754,'87548','P','Medalanes','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.152065,-106.236296,0,'2013-07-06 12:44:34',NULL,NULL),(71988,'88028','P','Cliff','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.961546,-108.614846,0,'2013-07-06 12:44:34',NULL,NULL),(5967,'05302','P','Brattleboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.855311,-72.656193,0,'2013-07-06 12:44:30',NULL,NULL),(9116,'09126','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21103,'22043','S','Pimmit','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.900669,-77.193846,0,'2013-07-06 12:44:31',NULL,NULL),(67169,'79837','P','Dell City','D','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.957919,-105.202440,0,'2013-07-06 12:44:34',NULL,NULL),(58041,'68019','S','Craig','D','Burt','31021','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.781961,-96.354588,0,'2013-07-06 12:44:33',NULL,NULL),(52874,'61340','P','Mark','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.263937,-89.247680,0,'2013-07-06 12:44:33',NULL,NULL),(31124,'33902','P','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.604733,-81.863805,0,'2013-07-06 12:44:32',NULL,NULL),(43323,'48360','S','Orion Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.766320,-83.278020,0,'2013-07-06 12:44:32',NULL,NULL),(40995,'46360','S','Mich City','N','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(74167,'92268','P','Pioneertown','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.184357,-116.516406,0,'2013-07-06 12:44:34',NULL,NULL),(29366,'32578','S','Choctaw Beach','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.505216,-86.454252,0,'2013-07-06 12:44:32',NULL,NULL),(78488,'98104','S','Pioneer Square','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.604727,-122.325941,0,'2013-07-06 12:44:34',NULL,NULL),(65943,'78258','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.665238,-98.502296,0,'2013-07-06 12:44:34',NULL,NULL),(11072,'11596','S','Williston Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757885,-73.644633,0,'2013-07-06 12:44:30',NULL,NULL),(54101,'62537','P','Harristown','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.839537,-89.059370,0,'2013-07-06 12:44:33',NULL,NULL),(37641,'42166','S','Willow Shade','A','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.891240,-85.715460,0,'2013-07-06 12:44:32',NULL,NULL),(52374,'60620','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.742065,-87.655494,0,'2013-07-06 12:44:33',NULL,NULL),(8033,'07731','S','Howell','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.147323,-74.206531,0,'2013-07-06 12:44:30',NULL,NULL),(25506,'28377','S','Red Springs','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.810391,-79.184698,0,'2013-07-06 12:44:31',NULL,NULL),(77087,'96134','S','Newell','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.949725,-121.472495,0,'2013-07-06 12:44:34',NULL,NULL),(10533,'10988','P','Unionville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.303157,-74.565904,0,'2013-07-06 12:44:30',NULL,NULL),(17720,'18241','S','Fern Glen','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.938327,-76.189558,0,'2013-07-06 12:44:31',NULL,NULL),(12389,'12922','S','Childwold','D','Saint Lawrence','36089','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.272016,-74.712447,0,'2013-07-06 12:44:30',NULL,NULL),(64992,'77282','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.745408,-95.613335,0,'2013-07-06 12:44:34',NULL,NULL),(35921,'40032','U','La Grange','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.422760,-85.393054,0,'2013-07-06 12:44:32',NULL,NULL),(61558,'72716','U','Wal-Mart Inc','N','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.322580,-94.180850,0,'2013-07-06 12:44:33',NULL,NULL),(42750,'48025','S','Southfield Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.523195,-83.265758,0,'2013-07-06 12:44:32',NULL,NULL),(53617,'62087','S','South Roxana','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.828197,-90.056705,0,'2013-07-06 12:44:33',NULL,NULL),(41440,'46863','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069243,-85.167029,0,'2013-07-06 12:44:32',NULL,NULL),(54067,'62480','S','Willow Hill','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.976776,-88.011300,0,'2013-07-06 12:44:33',NULL,NULL),(19127,'19608','S','South Heidelberg Twp','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(44707,'50140','S','Lamoni','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.622185,-93.931971,0,'2013-07-06 12:44:32',NULL,NULL),(29947,'33071','S','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.243112,-80.261973,0,'2013-07-06 12:44:32',NULL,NULL),(38294,'43341','S','New Bloomngtn','A','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.591276,-83.317071,0,'2013-07-06 12:44:32',NULL,NULL),(51644,'59868','S','Greenough','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.224412,-113.499488,0,'2013-07-06 12:44:33',NULL,NULL),(73248,'90703','S','Cerritos','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.866635,-118.048458,0,'2013-07-06 12:44:34',NULL,NULL),(74057,'92158','U','San Diego County Jail','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.563682,-116.972887,0,'2013-07-06 12:44:34',NULL,NULL),(614,'00680','S','Villas del Sol','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(43683,'48875','S','Portland','D','Ionia','26067','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.860218,-84.931002,0,'2013-07-06 12:44:32',NULL,NULL),(32674,'36266','S','Erin','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(36748,'41040','S','Four Oaks','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(71667,'87505','S','La Cienga','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.621141,-105.967103,0,'2013-07-06 12:44:34',NULL,NULL),(9144,'09264','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(55697,'64063','S','Unity Vlg','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(52023,'60178','S','Sycamore','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.003043,-88.681897,0,'2013-07-06 12:44:33',NULL,NULL),(41925,'47383','S','Hlls & Dles','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.185979,-85.275224,0,'2013-07-06 12:44:32',NULL,NULL),(29789,'33017','P','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.943386,-80.318215,0,'2013-07-06 12:44:32',NULL,NULL),(34736,'38849','S','Guntown','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(77902,'97303','S','Keizer','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.011820,-123.015660,0,'2013-07-06 12:44:34',NULL,NULL),(77538,'96853','S','Hickam AFB','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.339051,-157.943329,0,'2013-07-06 12:44:34',NULL,NULL),(61467,'72631','S','Eureka Spgs','A','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.400948,-93.736695,0,'2013-07-06 12:44:33',NULL,NULL),(37729,'42280','S','Sharon Grove','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.941844,-87.107304,0,'2013-07-06 12:44:32',NULL,NULL),(61884,'73132','S','Warr Acres','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.545017,-97.635324,0,'2013-07-06 12:44:33',NULL,NULL),(20069,'20678','S','Prince Frederick','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.531530,-76.586745,0,'2013-07-06 12:44:31',NULL,NULL),(64910,'77096','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.671906,-95.479578,0,'2013-07-06 12:44:34',NULL,NULL),(24844,'27620','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.765078,-78.587276,0,'2013-07-06 12:44:31',NULL,NULL),(43788,'49046','S','Delton','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.516236,-85.400453,0,'2013-07-06 12:44:32',NULL,NULL),(59198,'70374','S','Lockport','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.617440,-90.463140,0,'2013-07-06 12:44:33',NULL,NULL),(62132,'73667','S','Taloga','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.043902,-98.959272,0,'2013-07-06 12:44:33',NULL,NULL),(20470,'21037','S','Edgewater','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.921302,-76.542804,0,'2013-07-06 12:44:31',NULL,NULL),(48883,'56097','S','Walters','A','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.741740,-93.728328,0,'2013-07-06 12:44:33',NULL,NULL),(46693,'53785','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075404,-89.383079,0,'2013-07-06 12:44:32',NULL,NULL),(43818,'49078','S','Otsego','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.468819,-85.713723,0,'2013-07-06 12:44:32',NULL,NULL),(70395,'84711','P','Annabella','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.707368,-112.062387,0,'2013-07-06 12:44:34',NULL,NULL),(71460,'87051','P','San Rafael','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.151665,-107.873851,0,'2013-07-06 12:44:34',NULL,NULL),(78917,'98365','S','Port Ludlow','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.915179,-122.688171,0,'2013-07-06 12:44:34',NULL,NULL),(21585,'22841','S','Mount Crawford','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.350903,-78.955919,0,'2013-07-06 12:44:31',NULL,NULL),(44937,'50362','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.596486,-93.765012,0,'2013-07-06 12:44:32',NULL,NULL),(52259,'60522','S','Hinsdale','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.832778,-87.928889,0,'2013-07-06 12:44:33',NULL,NULL),(57510,'66959','S','Munden','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.901903,-97.534541,0,'2013-07-06 12:44:33',NULL,NULL),(72756,'89511','S','Pleasant Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.382155,-119.751830,0,'2013-07-06 12:44:34',NULL,NULL),(74473,'92605','P','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.715124,-118.007674,0,'2013-07-06 12:44:34',NULL,NULL),(62463,'74332','S','Big Cabin','D','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.674801,-95.297955,0,'2013-07-06 12:44:33',NULL,NULL),(6024,'05401','S','Burlngtn','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487240,-73.227780,0,'2013-07-06 12:44:30',NULL,NULL),(8548,'08204','S','Cold Spring','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(57092,'66218','S','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.014399,-94.817167,0,'2013-07-06 12:44:33',NULL,NULL),(36230,'40290','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.201276,-85.698130,0,'2013-07-06 12:44:32',NULL,NULL),(14312,'14892','S','Waverly','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.015892,-76.533539,0,'2013-07-06 12:44:31',NULL,NULL),(42728,'48006','S','Kenockee','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(43164,'48267','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331484,-83.051320,0,'2013-07-06 12:44:32',NULL,NULL),(62769,'74860','S','Paden','D','Okfuskee','40107','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.506603,-96.567615,0,'2013-07-06 12:44:33',NULL,NULL),(62532,'74428','S','Council Hill','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.536613,-95.713225,0,'2013-07-06 12:44:33',NULL,NULL),(9163,'09337','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58204,'68326','S','Carleton','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.297938,-97.665585,0,'2013-07-06 12:44:33',NULL,NULL),(18532,'19109','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.950326,-75.156065,0,'2013-07-06 12:44:31',NULL,NULL),(17105,'17771','S','Calvert','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(55082,'63195','U','US Bank','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.651601,-90.339813,0,'2013-07-06 12:44:33',NULL,NULL),(29204,'32410','P','Mexico Beach','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',29.943990,-85.409019,0,'2013-07-06 12:44:32',NULL,NULL),(2034,'00917','S','Urb Quintana','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(10657,'11104','S','Long Island City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.744648,-73.917792,0,'2013-07-06 12:44:30',NULL,NULL),(32630,'36191','U','Alfa Ins Co','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.326539,-86.276619,0,'2013-07-06 12:44:32',NULL,NULL),(25794,'28604','S','Sugar Mtn','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(28512,'31537','S','Folkston','D','Charlton','13049','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.840664,-82.010728,0,'2013-07-06 12:44:32',NULL,NULL),(47999,'55146','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.941944,-93.084462,0,'2013-07-06 12:44:33',NULL,NULL),(55253,'63453','S','Ashton','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.510718,-91.888478,0,'2013-07-06 12:44:33',NULL,NULL),(60909,'72076','S','Lr AFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(62527,'74426','S','Bond','N','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.417700,-95.553780,0,'2013-07-06 12:44:33',NULL,NULL),(64883,'77071','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.645598,-95.523668,0,'2013-07-06 12:44:34',NULL,NULL),(74485,'92614','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.682943,-117.829782,0,'2013-07-06 12:44:34',NULL,NULL),(18854,'19437','P','Gwynedd Vly','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.182564,-75.258744,0,'2013-07-06 12:44:31',NULL,NULL),(19889,'20536','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901010,-77.015942,0,'2013-07-06 12:44:31',NULL,NULL),(25394,'28274','U','Queens College','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.188792,-80.837133,0,'2013-07-06 12:44:31',NULL,NULL),(66205,'78549','P','Hargill','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.421554,-97.978474,0,'2013-07-06 12:44:34',NULL,NULL),(76717,'95852','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.605587,-121.441427,0,'2013-07-06 12:44:34',NULL,NULL),(72619,'89418','S','Imlay','D','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(75359,'93921','P','Carmel by the Sea','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.562001,-121.896409,0,'2013-07-06 12:44:34',NULL,NULL),(50289,'57657','S','Trail City','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.413510,-100.704693,0,'2013-07-06 12:44:33',NULL,NULL),(37795,'42372','S','Sacramento','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.422299,-87.278561,0,'2013-07-06 12:44:32',NULL,NULL),(3817,'02301','S','Brockton','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.090314,-71.038674,0,'2013-07-06 12:44:30',NULL,NULL),(30801,'33608','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.841617,-82.513107,0,'2013-07-06 12:44:32',NULL,NULL),(49044,'56291','S','Taunton','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.589436,-96.053997,0,'2013-07-06 12:44:33',NULL,NULL),(50850,'58492','S','Clementsville','N','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.172540,-98.458847,0,'2013-07-06 12:44:33',NULL,NULL),(55084,'63197','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.626874,-90.201876,0,'2013-07-06 12:44:33',NULL,NULL),(340,'00653','S','VISTA Mar','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(57804,'67505','S','Hutchinson','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.019420,-97.973340,0,'2013-07-06 12:44:33',NULL,NULL),(31157,'33916','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.630792,-81.834110,0,'2013-07-06 12:44:32',NULL,NULL),(23272,'25143','S','Nitro','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.410942,-81.828664,0,'2013-07-06 12:44:31',NULL,NULL),(14719,'15277','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441394,-80.097800,0,'2013-07-06 12:44:31',NULL,NULL),(15019,'15678','S','Rillton','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.286776,-79.715708,0,'2013-07-06 12:44:31',NULL,NULL),(10519,'10977','S','Wesley Hills','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(69956,'84118','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(71393,'87008','S','Cedar Crest','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.133954,-106.363191,0,'2013-07-06 12:44:34',NULL,NULL),(25770,'28601','S','Hickory','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(40872,'46236','S','Oaklandon','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.863210,-85.967360,0,'2013-07-06 12:44:32',NULL,NULL),(17496,'17961','S','Deer Lake','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.645200,-76.078440,0,'2013-07-06 12:44:31',NULL,NULL),(16716,'17405','P','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.971413,-76.677719,0,'2013-07-06 12:44:31',NULL,NULL),(33527,'37380','S','Orme','A','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.009705,-85.711704,0,'2013-07-06 12:44:32',NULL,NULL),(10201,'10311','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.604748,-74.180644,0,'2013-07-06 12:44:30',NULL,NULL),(47011,'54304','S','Ashwaubenon','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.503211,-88.067350,0,'2013-07-06 12:44:32',NULL,NULL),(63215,'75451','S','Leesburg','D','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.963146,-95.107158,0,'2013-07-06 12:44:33',NULL,NULL),(67141,'79765','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.934041,-102.385595,0,'2013-07-06 12:44:34',NULL,NULL),(38996,'44135','S','Linndale','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.434425,-81.801820,0,'2013-07-06 12:44:32',NULL,NULL),(59569,'70873','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.443359,-91.186981,0,'2013-07-06 12:44:33',NULL,NULL),(33300,'37130','S','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.870529,-86.341561,0,'2013-07-06 12:44:32',NULL,NULL),(7856,'07480','S','Shady Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.090615,-74.369917,0,'2013-07-06 12:44:30',NULL,NULL),(66202,'78547','P','Garciasville','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.376044,-98.652216,0,'2013-07-06 12:44:34',NULL,NULL),(68140,'80977','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.772039,-104.665048,0,'2013-07-06 12:44:34',NULL,NULL),(70106,'84171','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(19548,'20196','U','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.926126,-77.396695,0,'2013-07-06 12:44:31',NULL,NULL),(22476,'24055','S','Bassett Forks','N','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.751969,-79.987513,0,'2013-07-06 12:44:31',NULL,NULL),(67513,'80241','S','East Lake','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.928789,-104.945551,0,'2013-07-06 12:44:34',NULL,NULL),(41472,'46923','S','Delphi','D','Carroll','18015','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',40.589623,-86.669671,0,'2013-07-06 12:44:32',NULL,NULL),(11867,'12302','S','Scotia','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(40320,'45470','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.629744,-84.272496,0,'2013-07-06 12:44:32',NULL,NULL),(39660,'45011','S','Hamilton','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(35657,'39648','S','Bacots','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(21734,'23022','S','Bremo Bluff','D','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.737887,-78.266419,0,'2013-07-06 12:44:31',NULL,NULL),(26044,'28684','S','Toliver','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.311400,-81.579000,0,'2013-07-06 12:44:31',NULL,NULL),(57031,'66208','S','Mission Hills','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(57534,'67017','S','Benton','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.789149,-97.110068,0,'2013-07-06 12:44:33',NULL,NULL),(63544,'75763','S','Frankston','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(11207,'11743','S','Lloyd Harbor','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(59792,'71220','S','Beekman','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(47227,'54499','S','Franzen','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.825108,-89.169054,0,'2013-07-06 12:44:32',NULL,NULL),(23673,'25837','S','Edmond','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.053511,-81.037441,0,'2013-07-06 12:44:31',NULL,NULL),(22558,'24142','P','Radford','D','Radford City','51750','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.150649,-80.616629,0,'2013-07-06 12:44:31',NULL,NULL),(67729,'80546','P','Severance','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.525571,-104.850084,0,'2013-07-06 12:44:34',NULL,NULL),(70275,'84528','S','Huntington','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.315600,-110.980680,0,'2013-07-06 12:44:34',NULL,NULL),(74311,'92386','P','Big Bear City','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.261111,-116.844167,0,'2013-07-06 12:44:34',NULL,NULL),(54119,'62550','S','Moweaqua','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.624412,-89.016482,0,'2013-07-06 12:44:33',NULL,NULL),(11440,'11972','P','Speonk','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.819732,-72.706941,0,'2013-07-06 12:44:30',NULL,NULL),(35932,'40047','S','Mount Washington','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.044170,-85.555572,0,'2013-07-06 12:44:32',NULL,NULL),(7445,'06852','P','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.093595,-73.417257,0,'2013-07-06 12:44:30',NULL,NULL),(24855,'27634','U','NC Dept Revenue','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.779441,-78.638863,0,'2013-07-06 12:44:31',NULL,NULL),(46633,'53586','S','Shullsburg','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.577863,-90.225429,0,'2013-07-06 12:44:32',NULL,NULL),(48510,'55742','S','Goodland','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.195525,-93.128478,0,'2013-07-06 12:44:33',NULL,NULL),(50327,'57730','S','Custer','D','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(57392,'66756','S','Croweburg','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.549625,-94.679242,0,'2013-07-06 12:44:33',NULL,NULL),(72574,'89403','S','Dayton','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.270238,-119.538034,0,'2013-07-06 12:44:34',NULL,NULL),(77223,'96444','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79055,'98418','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.222751,-122.441183,0,'2013-07-06 12:44:34',NULL,NULL),(54249,'62670','S','New Berlin','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.734757,-89.908806,0,'2013-07-06 12:44:33',NULL,NULL),(1002,'00717','S','Urb Los Maestros','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(35142,'39218','S','Jackson','A','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.237700,-90.154800,0,'2013-07-06 12:44:32',NULL,NULL),(17244,'17837','S','Linntown','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(23772,'25972','P','Leslie','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.040659,-80.746855,0,'2013-07-06 12:44:31',NULL,NULL),(22005,'23282','U','Va Dept Tax','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.569356,-77.478092,0,'2013-07-06 12:44:31',NULL,NULL),(173,'00623','S','Ext Parc Elizabeth','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(42225,'47562','S','Farlen','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.842918,-86.990039,0,'2013-07-06 12:44:32',NULL,NULL),(15725,'16876','P','Wallaceton','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.961446,-78.292200,0,'2013-07-06 12:44:31',NULL,NULL),(33919,'38053','S','Rosemark','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(57833,'67545','S','Hudson','D','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.173212,-98.581480,0,'2013-07-06 12:44:33',NULL,NULL),(3805,'02241','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.354861,-71.057266,0,'2013-07-06 12:44:30',NULL,NULL),(48089,'55337','S','Burnsville','D','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.770175,-93.281177,0,'2013-07-06 12:44:33',NULL,NULL),(44668,'50112','S','Oakland Acres','A','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.767320,-92.765040,0,'2013-07-06 12:44:32',NULL,NULL),(69586,'83840','P','Kootenai','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.310200,-116.512500,0,'2013-07-06 12:44:34',NULL,NULL),(77534,'96849','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333358,-157.916104,0,'2013-07-06 12:44:34',NULL,NULL),(69124,'83278','S','Sunbeam','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.330002,-114.863022,0,'2013-07-06 12:44:34',NULL,NULL),(60075,'71355','S','Rexmere','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(3257,'01451','S','Harvard','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.503056,-71.575944,0,'2013-07-06 12:44:30',NULL,NULL),(17067,'17756','S','Pennsdale','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.199614,-76.786403,0,'2013-07-06 12:44:31',NULL,NULL),(75301,'93740','U','Ca State Univ Fresno','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.823910,-119.758958,0,'2013-07-06 12:44:34',NULL,NULL),(77433,'96805','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305636,-157.856474,0,'2013-07-06 12:44:34',NULL,NULL),(57511,'66960','S','Narka','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.959514,-97.422459,0,'2013-07-06 12:44:33',NULL,NULL),(53927,'62401','S','Heartville','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(27136,'29812','S','Kline','A','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.243078,-81.359153,0,'2013-07-06 12:44:31',NULL,NULL),(22001,'23279','U','anthem/blue cross blue shiel','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.583347,-77.491807,0,'2013-07-06 12:44:31',NULL,NULL),(76069,'95205','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.958243,-121.224519,0,'2013-07-06 12:44:34',NULL,NULL),(62577,'74462','S','Stigler','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.265840,-95.115060,0,'2013-07-06 12:44:33',NULL,NULL),(52466,'60682','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.835903,-87.686615,0,'2013-07-06 12:44:33',NULL,NULL),(51083,'58762','S','Russell','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.687180,-100.942800,0,'2013-07-06 12:44:33',NULL,NULL),(50908,'58554','S','Huff','A','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.828248,-100.892053,0,'2013-07-06 12:44:33',NULL,NULL),(46561,'53511','S','Beloit','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.558900,-89.087340,0,'2013-07-06 12:44:32',NULL,NULL),(42284,'47586','S','Gatchel','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(11120,'11704','S','Babylon','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.709193,-73.371464,0,'2013-07-06 12:44:30',NULL,NULL),(10458,'10925','S','Greenwood Lk','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.218950,-74.294664,0,'2013-07-06 12:44:30',NULL,NULL),(2261,'00926','S','Urb Park Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(12940,'13348','S','Snowden','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695880,-75.066180,0,'2013-07-06 12:44:30',NULL,NULL),(1486,'00751','S','BO Santa Ana I','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(24112,'26525','S','Hazelton','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.646175,-79.624337,0,'2013-07-06 12:44:31',NULL,NULL),(29984,'33097','P','Pompano Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.235803,-80.133635,0,'2013-07-06 12:44:32',NULL,NULL),(30663,'33464','U','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.584130,-80.049062,0,'2013-07-06 12:44:32',NULL,NULL),(31715,'34957','S','Jensen Beach','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.234550,-80.232374,0,'2013-07-06 12:44:32',NULL,NULL),(36224,'40283','U','Readers Digest','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(36859,'41081','P','Plummers Lndg','A','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.304959,-83.569924,0,'2013-07-06 12:44:32',NULL,NULL),(36949,'41168','S','Kilgore','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.308320,-82.746300,0,'2013-07-06 12:44:32',NULL,NULL),(17967,'18611','P','Cambra','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.196751,-76.304629,0,'2013-07-06 12:44:31',NULL,NULL),(4070,'02650','S','N Chatham','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.702293,-69.968343,0,'2013-07-06 12:44:30',NULL,NULL),(72993,'90058','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.002300,-118.211520,0,'2013-07-06 12:44:34',NULL,NULL),(49445,'56639','S','Craigville','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.852565,-93.622901,0,'2013-07-06 12:44:33',NULL,NULL),(31163,'33917','S','No Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(18717,'19310','S','Atglen','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.948925,-75.972001,0,'2013-07-06 12:44:31',NULL,NULL),(16131,'17057','S','Shope Gardens','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(9234,'09557','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71197,'86052','P','North Rim','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.212643,-112.058276,0,'2013-07-06 12:44:34',NULL,NULL),(67920,'80906','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.791623,-104.825814,0,'2013-07-06 12:44:34',NULL,NULL),(63297,'75561','S','Hooks','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(45145,'50579','S','Sherwood','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(8955,'08802','S','Asbury','D','Hunterdon','34019','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.665300,-75.024120,0,'2013-07-06 12:44:30',NULL,NULL),(27426,'30107','S','Ball Ground','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.333388,-84.346223,0,'2013-07-06 12:44:31',NULL,NULL),(35829,'39769','S','Morgantown','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.357720,-89.050020,0,'2013-07-06 12:44:32',NULL,NULL),(36711,'41018','S','Elsmere','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.009027,-84.598071,0,'2013-07-06 12:44:32',NULL,NULL),(38362,'43456','P','Put in Bay','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.648779,-82.821414,0,'2013-07-06 12:44:32',NULL,NULL),(6209,'05486','S','South Hero','D','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.866206,-73.251370,0,'2013-07-06 12:44:30',NULL,NULL),(31152,'33913','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.497190,-81.730739,0,'2013-07-06 12:44:32',NULL,NULL),(66950,'79371','S','Sudan','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.062057,-102.523858,0,'2013-07-06 12:44:34',NULL,NULL),(70916,'85631','S','San Manuel','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.592943,-110.614820,0,'2013-07-06 12:44:34',NULL,NULL),(646,'00682','S','Urb Petiteville','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(1299,'00730','S','Urb Santa Teresita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(70498,'84775','S','Fruita','N','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.302647,-111.367243,0,'2013-07-06 12:44:34',NULL,NULL),(23321,'25211','P','Widen','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.464696,-80.857277,0,'2013-07-06 12:44:31',NULL,NULL),(76834,'95961','S','Arboga','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.088781,-121.550818,0,'2013-07-06 12:44:34',NULL,NULL),(35327,'39428','S','Dry Creek','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(37291,'41621','S','Dwale','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.623520,-82.725022,0,'2013-07-06 12:44:32',NULL,NULL),(1557,'00766','S','Alts del Alba','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(47771,'55038','S','Lino Lakes','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.163580,-92.956430,0,'2013-07-06 12:44:33',NULL,NULL),(53251,'61701','S','Fletcher','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(60489,'71660','S','New Edinburg','D','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.763918,-92.192406,0,'2013-07-06 12:44:33',NULL,NULL),(73469,'91308','P','West Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201111,-118.597222,0,'2013-07-06 12:44:34',NULL,NULL),(51910,'60106','S','Bensenville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.955274,-87.948789,0,'2013-07-06 12:44:33',NULL,NULL),(70702,'85267','P','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.612228,-111.889294,0,'2013-07-06 12:44:34',NULL,NULL),(68402,'81154','S','Masonic Park','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.672402,-106.630824,0,'2013-07-06 12:44:34',NULL,NULL),(66499,'78677','S','Wrightsboro','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.351201,-97.503023,0,'2013-07-06 12:44:34',NULL,NULL),(57944,'67743','S','Levant','D','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.375878,-101.225432,0,'2013-07-06 12:44:33',NULL,NULL),(54598,'62906','S','Balcom','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.463400,-89.229960,0,'2013-07-06 12:44:33',NULL,NULL),(47544,'54822','S','Cameron','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.397937,-91.713596,0,'2013-07-06 12:44:32',NULL,NULL),(46861,'54025','S','Somerset','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.128445,-92.679907,0,'2013-07-06 12:44:32',NULL,NULL),(15977,'17032','S','Powells Vly','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(17271,'17844','S','Dice','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(26312,'29040','S','Gaillard Crossroads','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.002009,-80.482959,0,'2013-07-06 12:44:31',NULL,NULL),(278,'00646','S','Hacienda Mi Querido Viejo','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(44734,'50161','S','Farrar','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.881140,-93.411720,0,'2013-07-06 12:44:32',NULL,NULL),(67861,'80826','U','Limon Correctional Facility','N','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.263889,-103.692415,0,'2013-07-06 12:44:34',NULL,NULL),(68637,'81636','P','Parachute','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.438650,-108.025498,0,'2013-07-06 12:44:34',NULL,NULL),(71720,'87531','S','Rinconado','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.141996,-105.998001,0,'2013-07-06 12:44:34',NULL,NULL),(72368,'89030','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.210991,-115.128903,0,'2013-07-06 12:44:34',NULL,NULL),(78545,'98144','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.586883,-122.298008,0,'2013-07-06 12:44:34',NULL,NULL),(72726,'89503','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.538980,-119.838457,0,'2013-07-06 12:44:34',NULL,NULL),(21929,'23227','S','Richmond','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.610820,-77.439960,0,'2013-07-06 12:44:31',NULL,NULL),(20640,'21220','S','Middle River','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.342626,-76.412643,0,'2013-07-06 12:44:31',NULL,NULL),(45733,'52101','S','Burr Oak','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(61911,'73145','S','Tinker AFB','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.415801,-97.392307,0,'2013-07-06 12:44:33',NULL,NULL),(53956,'62426','S','La Clede','N','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.921946,-88.664835,0,'2013-07-06 12:44:33',NULL,NULL),(47460,'54731','S','Conrath','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.371134,-91.060975,0,'2013-07-06 12:44:32',NULL,NULL),(25497,'28368','P','Olivia','D','Harnett','37085','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.358676,-79.108813,0,'2013-07-06 12:44:31',NULL,NULL),(33559,'37409','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.001427,-85.332196,0,'2013-07-06 12:44:32',NULL,NULL),(35230,'39309','U','Nas Meridian','A','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.537503,-88.567935,0,'2013-07-06 12:44:32',NULL,NULL),(38301,'43348','S','Russells Point','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.468795,-83.879904,0,'2013-07-06 12:44:32',NULL,NULL),(40125,'45328','P','Gettysburg','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.115328,-84.494432,0,'2013-07-06 12:44:32',NULL,NULL),(24810,'27599','U','University of NC','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.928939,-79.040693,0,'2013-07-06 12:44:31',NULL,NULL),(67436,'80166','U','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.594031,-105.009802,0,'2013-07-06 12:44:34',NULL,NULL),(68997,'83201','S','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.882088,-112.423285,0,'2013-07-06 12:44:34',NULL,NULL),(15606,'16675','P','St Boniface','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.666730,-78.682970,0,'2013-07-06 12:44:31',NULL,NULL),(51257,'59083','P','Sumatra','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.616991,-107.553123,0,'2013-07-06 12:44:33',NULL,NULL),(47602,'54873','S','Bennett','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.399140,-91.748040,0,'2013-07-06 12:44:33',NULL,NULL),(77795,'97136','S','Manhattan Beach','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(41705,'47230','S','Deputy','D','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.781889,-85.625205,0,'2013-07-06 12:44:32',NULL,NULL),(61173,'72199','U','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.785804,-92.255214,0,'2013-07-06 12:44:33',NULL,NULL),(56559,'65466','S','Owls Bend','N','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.169700,-91.471080,0,'2013-07-06 12:44:33',NULL,NULL),(51102,'58779','S','Raub','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.851080,-101.789820,0,'2013-07-06 12:44:33',NULL,NULL),(50193,'57568','S','Presho','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.908664,-100.053403,0,'2013-07-06 12:44:33',NULL,NULL),(28393,'31313','S','Fort Stewart','A','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.843745,-81.603148,0,'2013-07-06 12:44:32',NULL,NULL),(11488,'12020','S','Malta Ridge','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(48474,'55721','S','Cohasset','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.239448,-93.619584,0,'2013-07-06 12:44:33',NULL,NULL),(18688,'19188','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963336,-75.159526,0,'2013-07-06 12:44:31',NULL,NULL),(51164,'59001','S','Absarokee','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.521872,-109.441232,0,'2013-07-06 12:44:33',NULL,NULL),(53988,'62441','S','Clarksville','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.400200,-87.694680,0,'2013-07-06 12:44:33',NULL,NULL),(62178,'73755','S','Longdale','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.114029,-98.556798,0,'2013-07-06 12:44:33',NULL,NULL),(63108,'75283','U','Bk of America','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768227,-96.830324,0,'2013-07-06 12:44:33',NULL,NULL),(38101,'43085','S','Riverlea','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098773,-83.017045,0,'2013-07-06 12:44:32',NULL,NULL),(30679,'33470','S','Loxahatchee Groves','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(29059,'32241','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.168289,-81.629109,0,'2013-07-06 12:44:32',NULL,NULL),(55382,'63623','S','Belleview','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.669675,-90.853916,0,'2013-07-06 12:44:33',NULL,NULL),(15871,'16950','S','Harrison Twp','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(44922,'50334','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.627111,-93.710893,0,'2013-07-06 12:44:32',NULL,NULL),(72400,'89043','S','Pioche','D','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.942563,-114.451659,0,'2013-07-06 12:44:34',NULL,NULL),(61462,'72628','S','Nail','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842526,-93.350809,0,'2013-07-06 12:44:33',NULL,NULL),(51578,'59801','S','East Missoula','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858650,-114.039769,0,'2013-07-06 12:44:33',NULL,NULL),(72859,'90003','S','Broadway Manchester','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.962989,-118.272517,0,'2013-07-06 12:44:34',NULL,NULL),(77832,'97215','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.514122,-122.601049,0,'2013-07-06 12:44:34',NULL,NULL),(65049,'77336','S','Huffman','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.043878,-95.101533,0,'2013-07-06 12:44:34',NULL,NULL),(18001,'18634','S','Nanticoke','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.196217,-76.003548,0,'2013-07-06 12:44:31',NULL,NULL),(30617,'33435','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524047,-80.068212,0,'2013-07-06 12:44:32',NULL,NULL),(27174,'29842','S','Beech Island','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.408592,-81.881677,0,'2013-07-06 12:44:31',NULL,NULL),(5297,'04548','S','Georgetown','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.806783,-69.763606,0,'2013-07-06 12:44:30',NULL,NULL),(24168,'26611','S','Flower','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.838066,-80.849384,0,'2013-07-06 12:44:31',NULL,NULL),(51286,'59117','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.783606,-108.505138,0,'2013-07-06 12:44:33',NULL,NULL),(51965,'60142','S','Huntley','D','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.187342,-88.434247,0,'2013-07-06 12:44:33',NULL,NULL),(56689,'65650','S','Flemington','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.773493,-93.447679,0,'2013-07-06 12:44:33',NULL,NULL),(36786,'41049','S','Colfax','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.285556,-83.678852,0,'2013-07-06 12:44:32',NULL,NULL),(21538,'22734','S','Remington','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.535968,-77.807557,0,'2013-07-06 12:44:31',NULL,NULL),(74051,'92153','P','Nestor','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.567607,-117.083390,0,'2013-07-06 12:44:34',NULL,NULL),(22323,'23847','S','Emporia','D','Greensville','51081','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.695563,-77.543942,0,'2013-07-06 12:44:31',NULL,NULL),(4817,'03903','S','Eliot','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.130826,-70.789695,0,'2013-07-06 12:44:30',NULL,NULL),(14806,'15410','S','Adah','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.887124,-79.890722,0,'2013-07-06 12:44:31',NULL,NULL),(802,'00693','S','Sect Brisas Del Rosario','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(42045,'47445','P','Midland','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.059161,-87.187140,0,'2013-07-06 12:44:32',NULL,NULL),(40327,'45482','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.721533,-84.101071,0,'2013-07-06 12:44:32',NULL,NULL),(38489,'43666','U','Owens Illinois','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.654455,-83.530392,0,'2013-07-06 12:44:32',NULL,NULL),(7237,'06509','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.319000,-72.927115,0,'2013-07-06 12:44:30',NULL,NULL),(32587,'36124','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.393633,-86.175738,0,'2013-07-06 12:44:32',NULL,NULL),(2607,'00961','S','Urb Sierra Bayamon','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(25040,'27907','P','Elizabeth Cty','A','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.292677,-76.221442,0,'2013-07-06 12:44:31',NULL,NULL),(23833,'26105','S','Vienna','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.325039,-81.542603,0,'2013-07-06 12:44:31',NULL,NULL),(23607,'25704','S','Huntington','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.374908,-82.512584,0,'2013-07-06 12:44:31',NULL,NULL),(38034,'43028','S','Howard','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.391040,-82.303860,0,'2013-07-06 12:44:32',NULL,NULL),(21838,'23125','S','New Point','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.349596,-76.279804,0,'2013-07-06 12:44:31',NULL,NULL),(18272,'19008','S','Radnor','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.975572,-75.360537,0,'2013-07-06 12:44:31',NULL,NULL),(74925,'93402','S','Los Osos','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.301420,-120.825000,0,'2013-07-06 12:44:34',NULL,NULL),(75846,'94926','U','State Farm Insurance','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.326476,-122.712308,0,'2013-07-06 12:44:34',NULL,NULL),(57517,'66967','S','Harlan','A','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.779397,-98.783094,0,'2013-07-06 12:44:33',NULL,NULL),(4433,'03241','S','East Hebron','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.712551,-71.875491,0,'2013-07-06 12:44:30',NULL,NULL),(42943,'48118','S','Lyndon Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(27791,'30384','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.897456,-84.451548,0,'2013-07-06 12:44:31',NULL,NULL),(6960,'06232','S','Andover','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.735446,-72.375647,0,'2013-07-06 12:44:30',NULL,NULL),(11855,'12257','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653571,-73.757472,0,'2013-07-06 12:44:30',NULL,NULL),(15108,'15775','S','Spangler','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.654687,-78.777941,0,'2013-07-06 12:44:31',NULL,NULL),(67903,'80902','S','Fort Carson','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(77074,'96127','P','Susanville','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417374,-120.649006,0,'2013-07-06 12:44:34',NULL,NULL),(35063,'39183','S','Vicksburg','D','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.390993,-90.829096,0,'2013-07-06 12:44:32',NULL,NULL),(45710,'52064','S','Green Island','A','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.081840,-90.326520,0,'2013-07-06 12:44:32',NULL,NULL),(32581,'36120','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.312846,-86.234558,0,'2013-07-06 12:44:32',NULL,NULL),(75364,'93924','S','Carmel Valley Village','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.393660,-121.675020,0,'2013-07-06 12:44:34',NULL,NULL),(76183,'95336','S','Manteca','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.805831,-121.221492,0,'2013-07-06 12:44:34',NULL,NULL),(8535,'08110','S','Pennsauken','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.954445,-75.074257,0,'2013-07-06 12:44:30',NULL,NULL),(18440,'19066','S','Merion Sta','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002386,-75.253465,0,'2013-07-06 12:44:31',NULL,NULL),(51243,'59072','S','Klein','N','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.410128,-108.546630,0,'2013-07-06 12:44:33',NULL,NULL),(50695,'58356','S','Bremen','A','Eddy','38027','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.684884,-99.133524,0,'2013-07-06 12:44:33',NULL,NULL),(10707,'11233','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671472,-73.924489,0,'2013-07-06 12:44:30',NULL,NULL),(71712,'87529','S','Des Montes','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.448620,-105.574980,0,'2013-07-06 12:44:34',NULL,NULL),(56,'00610','S','Jard de Anasco','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(1222,'00728','S','Urb Punto Oro','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(14392,'15047','P','Greenock','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.314017,-79.796017,0,'2013-07-06 12:44:31',NULL,NULL),(37694,'42252','S','Jetson','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.236542,-86.517041,0,'2013-07-06 12:44:32',NULL,NULL),(35800,'39755','S','Pheba','D','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.591536,-88.953093,0,'2013-07-06 12:44:32',NULL,NULL),(27296,'30009','S','Milton','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.096195,-84.261245,0,'2013-07-06 12:44:31',NULL,NULL),(49536,'56680','S','Sand Lake','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.633333,-93.966667,0,'2013-07-06 12:44:33',NULL,NULL),(49840,'57231','S','De Smet','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.387190,-97.551945,0,'2013-07-06 12:44:33',NULL,NULL),(55682,'64055','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.049222,-94.401477,0,'2013-07-06 12:44:33',NULL,NULL),(61043,'72118','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(63878,'76009','S','Alvarado','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.432973,-97.195949,0,'2013-07-06 12:44:34',NULL,NULL),(75313,'93760','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.735811,-119.778758,0,'2013-07-06 12:44:34',NULL,NULL),(17266,'17842','S','Swineford','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(56908,'66048','S','Leavenworth','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.306584,-94.928404,0,'2013-07-06 12:44:33',NULL,NULL),(11298,'11777','S','Pjs','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(37104,'41352','S','Grassy Creek','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.859190,-83.372286,0,'2013-07-06 12:44:32',NULL,NULL),(14900,'15510','U','SCI Somerset','N','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.009196,-79.080641,0,'2013-07-06 12:44:31',NULL,NULL),(631,'00682','S','Repto San Francisco','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(42034,'47441','S','Island City','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(2087,'00921','S','Villa Magna','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(16885,'17575','P','Forest Knolls','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.074020,-76.430012,0,'2013-07-06 12:44:31',NULL,NULL),(40191,'45381','S','West Alex','N','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.729736,-84.535455,0,'2013-07-06 12:44:32',NULL,NULL),(16472,'17243','S','Maddensville','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.239420,-77.907120,0,'2013-07-06 12:44:31',NULL,NULL),(33497,'37354','S','Madisonville','D','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.519160,-84.363478,0,'2013-07-06 12:44:32',NULL,NULL),(28744,'31995','P','Columbus','A','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.489923,-84.969539,0,'2013-07-06 12:44:32',NULL,NULL),(20448,'21012','S','Arnold','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.047216,-76.498751,0,'2013-07-06 12:44:31',NULL,NULL),(24755,'27537','S','Henderson','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.326401,-78.405647,0,'2013-07-06 12:44:31',NULL,NULL),(22459,'24033','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.273418,-79.955962,0,'2013-07-06 12:44:31',NULL,NULL),(47543,'54821','S','Cable','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.225837,-91.170886,0,'2013-07-06 12:44:32',NULL,NULL),(58085,'68071','S','Winnebago','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.238339,-96.472001,0,'2013-07-06 12:44:33',NULL,NULL),(62898,'75067','S','Louisville','N','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.077549,-97.049260,0,'2013-07-06 12:44:33',NULL,NULL),(66900,'79256','S','Roaring Spngs','A','Motley','48345','Texas','TX','48','0000','806','Central',-6.0,'Y',33.901550,-100.855415,0,'2013-07-06 12:44:34',NULL,NULL),(70503,'84780','S','Washington','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.134587,-113.509682,0,'2013-07-06 12:44:34',NULL,NULL),(79471,'98856','S','Twisp','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.376015,-120.121992,0,'2013-07-06 12:44:34',NULL,NULL),(40561,'45859','P','McGuffey','N','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.693751,-83.783763,0,'2013-07-06 12:44:32',NULL,NULL),(56670,'65629','S','Chadwick','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.919600,-93.039979,0,'2013-07-06 12:44:33',NULL,NULL),(40230,'45417','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.755810,-84.240573,0,'2013-07-06 12:44:32',NULL,NULL),(15952,'17024','S','Mansville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(35117,'39211','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.370898,-90.128060,0,'2013-07-06 12:44:32',NULL,NULL),(53711,'62237','S','Winkle','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.198220,-89.593740,0,'2013-07-06 12:44:33',NULL,NULL),(66431,'78643','S','Llano','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.664320,-98.577660,0,'2013-07-06 12:44:34',NULL,NULL),(5914,'05250','S','Chiselville','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(3982,'02535','S','Chilmark','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.334586,-70.746397,0,'2013-07-06 12:44:30',NULL,NULL),(58310,'68436','S','Shickley','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.415010,-97.726502,0,'2013-07-06 12:44:33',NULL,NULL),(35973,'40107','S','Boston','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.753515,-85.637791,0,'2013-07-06 12:44:32',NULL,NULL),(26885,'29564','S','Lane','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.462666,-79.833819,0,'2013-07-06 12:44:31',NULL,NULL),(21005,'21837','S','Mardela Springs','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.455644,-75.755948,0,'2013-07-06 12:44:31',NULL,NULL),(20878,'21677','S','Woolford','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.512230,-76.187230,0,'2013-07-06 12:44:31',NULL,NULL),(19710,'20389','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(46121,'52640','S','Morning Sun','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.093975,-91.252796,0,'2013-07-06 12:44:32',NULL,NULL),(46290,'53048','S','Knowles','A','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.590376,-88.447118,0,'2013-07-06 12:44:32',NULL,NULL),(65245,'77459','S','Missouri City','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.525902,-95.531735,0,'2013-07-06 12:44:34',NULL,NULL),(78718,'98276','S','Everson','A','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.929523,-122.320315,0,'2013-07-06 12:44:34',NULL,NULL),(6498,'05777','S','Ira','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.547778,-73.022778,0,'2013-07-06 12:44:30',NULL,NULL),(28070,'30711','S','Crandall','D','Murray','13213','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.940692,-84.759587,0,'2013-07-06 12:44:31',NULL,NULL),(76802,'95946','S','Lake Wildwood','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.216172,-121.194087,0,'2013-07-06 12:44:34',NULL,NULL),(34623,'38754','S','Isola','D','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.260452,-90.592415,0,'2013-07-06 12:44:32',NULL,NULL),(31423,'34250','P','Terra Ceia Island','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.575069,-82.576017,0,'2013-07-06 12:44:32',NULL,NULL),(18491,'19092','U','Firm Zip Concept (Brm)','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952579,-75.181778,0,'2013-07-06 12:44:31',NULL,NULL),(31613,'34688','S','Tarpon Spngs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143822,-82.680110,0,'2013-07-06 12:44:32',NULL,NULL),(95,'00612','S','Urb Brisas Del Mar Ii','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(40439,'45720','P','Chester','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.089442,-81.923112,0,'2013-07-06 12:44:32',NULL,NULL),(5784,'05054','P','N Thetford','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.842315,-72.183801,0,'2013-07-06 12:44:30',NULL,NULL),(36047,'40205','S','Strathmr Mnr','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(8926,'08750','S','Wall Township','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.134492,-74.045049,0,'2013-07-06 12:44:30',NULL,NULL),(13386,'13743','S','West Candor','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.217072,-76.337592,0,'2013-07-06 12:44:31',NULL,NULL),(32677,'36266','S','Ofelia','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(9606,'10031','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(30256,'33231','P','Brickell','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.773930,-80.194434,0,'2013-07-06 12:44:32',NULL,NULL),(45704,'52057','S','Thorpe','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.485840,-91.458289,0,'2013-07-06 12:44:32',NULL,NULL),(45837,'52217','S','Clutier','D','Tama','19171','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.079104,-92.402443,0,'2013-07-06 12:44:32',NULL,NULL),(57658,'67208','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.703821,-97.277212,0,'2013-07-06 12:44:33',NULL,NULL),(78068,'97461','S','Noti','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.096571,-123.465682,0,'2013-07-06 12:44:34',NULL,NULL),(39803,'45135','S','Samantha','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(15798,'16925','S','South Creek','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(28245,'31059','P','Milledgeville','D','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.086793,-83.244856,0,'2013-07-06 12:44:31',NULL,NULL),(22880,'24574','S','Monroe','D','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.519749,-79.184428,0,'2013-07-06 12:44:31',NULL,NULL),(19858,'20521','U','State Department','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899591,-77.051114,0,'2013-07-06 12:44:31',NULL,NULL),(10155,'10278','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(42419,'47802','S','Oak Grove','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(32886,'36530','S','Josephine','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.405780,-87.586380,0,'2013-07-06 12:44:32',NULL,NULL),(76137,'95255','S','West Point','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.403434,-120.515493,0,'2013-07-06 12:44:34',NULL,NULL),(41744,'47272','S','Saint Paul','D','Decatur','18031','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.430872,-85.633781,0,'2013-07-06 12:44:32',NULL,NULL),(9895,'10129','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755624,-73.990453,0,'2013-07-06 12:44:30',NULL,NULL),(46595,'53549','S','Jefferson','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.005551,-88.804618,0,'2013-07-06 12:44:32',NULL,NULL),(51428,'59456','S','Ledger','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.290217,-111.742416,0,'2013-07-06 12:44:33',NULL,NULL),(57298,'66621','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.043224,-95.726236,0,'2013-07-06 12:44:33',NULL,NULL),(61897,'73140','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.464047,-97.383601,0,'2013-07-06 12:44:33',NULL,NULL),(63256,'75489','P','Tom Bean','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.521558,-96.478321,0,'2013-07-06 12:44:33',NULL,NULL),(66578,'78744','S','Colton','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.145680,-97.700220,0,'2013-07-06 12:44:34',NULL,NULL),(77063,'96120','S','Mesa Vista','N','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(4307,'02909','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.820105,-71.451870,0,'2013-07-06 12:44:30',NULL,NULL),(6770,'06098','S','Winchester','N','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.921164,-73.067666,0,'2013-07-06 12:44:30',NULL,NULL),(21586,'22841','S','Mt Crawford','A','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.350903,-78.955919,0,'2013-07-06 12:44:31',NULL,NULL),(39593,'44866','S','Rowsburg','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.921560,-82.202280,0,'2013-07-06 12:44:32',NULL,NULL),(37844,'42462','S','Waverly','D','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.800053,-87.770721,0,'2013-07-06 12:44:32',NULL,NULL),(79043,'98407','S','Ruston','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.283011,-122.504689,0,'2013-07-06 12:44:34',NULL,NULL),(21640,'22923','S','Burnleys','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.166765,-78.365242,0,'2013-07-06 12:44:31',NULL,NULL),(23305,'25193','S','Sylvester','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.014457,-81.534634,0,'2013-07-06 12:44:31',NULL,NULL),(2775,'00976','S','Bosque del Lago','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(38493,'43681','U','Courtesy Reply Firm Zip','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.642211,-83.542156,0,'2013-07-06 12:44:32',NULL,NULL),(1577,'00767','S','Urb Santa Elena','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(12829,'13309','S','Hawkinsville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.453080,-75.336000,0,'2013-07-06 12:44:30',NULL,NULL),(72279,'88559','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770134,-106.331168,0,'2013-07-06 12:44:34',NULL,NULL),(75442,'94060','S','Pescadero','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.207186,-122.381050,0,'2013-07-06 12:44:34',NULL,NULL),(2740,'00969','S','Urb Monte Alvernia','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(1732,'00778','S','Urb El Vivero','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(29860,'33039','U','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.507761,-80.409021,0,'2013-07-06 12:44:32',NULL,NULL),(65128,'77381','S','Shenandoah','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.168480,-95.489640,0,'2013-07-06 12:44:34',NULL,NULL),(7410,'06796','S','West Cornwall','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.866633,-73.333200,0,'2013-07-06 12:44:30',NULL,NULL),(20466,'21032','S','Crownsville','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.045010,-76.596422,0,'2013-07-06 12:44:31',NULL,NULL),(22945,'24641','S','Richlands','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.093426,-81.807039,0,'2013-07-06 12:44:31',NULL,NULL),(66465,'78656','S','Reedville','N','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.861942,-97.858517,0,'2013-07-06 12:44:34',NULL,NULL),(69820,'84074','S','Stansbury Pk','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(898,'00705','S','Bo Llanos','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(8661,'08318','S','Elmer','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(20946,'21770','S','Monrovia','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.351327,-77.253345,0,'2013-07-06 12:44:31',NULL,NULL),(22121,'23435','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.849660,-76.479360,0,'2013-07-06 12:44:31',NULL,NULL),(23251,'25123','S','Arbuckle','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.746520,-81.955930,0,'2013-07-06 12:44:31',NULL,NULL),(67105,'79718','S','Balmorhea','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.034627,-103.642710,0,'2013-07-06 12:44:34',NULL,NULL),(75653,'94530','S','El Cerrito','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.920642,-122.302362,0,'2013-07-06 12:44:34',NULL,NULL),(78860,'98344','P','Kapowsin','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.986722,-122.227835,0,'2013-07-06 12:44:34',NULL,NULL),(79305,'98591','S','Knab','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.438939,-122.817048,0,'2013-07-06 12:44:34',NULL,NULL),(32238,'35587','S','Townley','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.840250,-87.450538,0,'2013-07-06 12:44:32',NULL,NULL),(46061,'52574','S','Walnut City','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.796400,-92.928720,0,'2013-07-06 12:44:32',NULL,NULL),(70579,'85071','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.593614,-112.108962,0,'2013-07-06 12:44:34',NULL,NULL),(77881,'97267','S','Portland','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(39339,'44619','P','Damascus','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.897775,-80.957630,0,'2013-07-06 12:44:32',NULL,NULL),(63376,'75644','S','Ewell','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(18835,'19424','U','Unisys','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.148617,-75.266159,0,'2013-07-06 12:44:31',NULL,NULL),(698,'00685','S','Urb La Estancia','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(20674,'21231','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290195,-76.593956,0,'2013-07-06 12:44:31',NULL,NULL),(25188,'28054','S','Ranlo','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229720,-81.142440,0,'2013-07-06 12:44:31',NULL,NULL),(14857,'15456','S','Lemont Frnce','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.922596,-79.787657,0,'2013-07-06 12:44:31',NULL,NULL),(19238,'19930','S','S Bethany','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.530364,-75.062715,0,'2013-07-06 12:44:31',NULL,NULL),(7758,'07403','S','Bloomingdale','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.013238,-74.333291,0,'2013-07-06 12:44:30',NULL,NULL),(17362,'17872','S','Sagon','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(34725,'38846','S','Glen','D','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.847072,-88.419386,0,'2013-07-06 12:44:32',NULL,NULL),(1845,'00784','S','Villa Universitaria','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(28850,'32092','S','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.956369,-81.524977,0,'2013-07-06 12:44:32',NULL,NULL),(9994,'10166','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(47234,'54501','S','Starks','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(52276,'60525','S','McCook','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(65302,'77493','S','Park Row','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.810252,-95.806907,0,'2013-07-06 12:44:34',NULL,NULL),(78079,'97470','S','Roseburg','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.223282,-123.366270,0,'2013-07-06 12:44:34',NULL,NULL),(6604,'05868','S','Troy','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.949273,-72.393535,0,'2013-07-06 12:44:30',NULL,NULL),(45890,'52305','S','Martelle','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.011938,-91.387767,0,'2013-07-06 12:44:32',NULL,NULL),(44493,'49917','P','Copper City','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.284178,-88.385855,0,'2013-07-06 12:44:32',NULL,NULL),(77886,'97280','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.453538,-122.698843,0,'2013-07-06 12:44:34',NULL,NULL),(78709,'98267','S','Marblemount','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.535003,-121.419068,0,'2013-07-06 12:44:34',NULL,NULL),(34286,'38486','S','Westpoint','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.154544,-87.533952,0,'2013-07-06 12:44:32',NULL,NULL),(29130,'32321','S','Bristol','D','Liberty','12077','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.421751,-84.979623,0,'2013-07-06 12:44:32',NULL,NULL),(33379,'37212','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.133012,-86.802764,0,'2013-07-06 12:44:32',NULL,NULL),(77903,'97303','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.011820,-123.015660,0,'2013-07-06 12:44:34',NULL,NULL),(79643,'99139','S','Ione','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.744729,-117.395807,0,'2013-07-06 12:44:34',NULL,NULL),(66185,'78537','S','La Tijera','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.171006,-98.055232,0,'2013-07-06 12:44:34',NULL,NULL),(15866,'16948','S','Newfield','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846520,-77.709720,0,'2013-07-06 12:44:31',NULL,NULL),(49182,'56435','S','Backus','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.855877,-94.369375,0,'2013-07-06 12:44:33',NULL,NULL),(47242,'54512','S','Boulder Jct','A','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.096191,-89.653823,0,'2013-07-06 12:44:32',NULL,NULL),(45949,'52348','P','Vining','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.974587,-92.364979,0,'2013-07-06 12:44:32',NULL,NULL),(16465,'17241','S','Lower Mifflin','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(15353,'16242','S','New Bethlehem','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.006608,-79.331190,0,'2013-07-06 12:44:31',NULL,NULL),(50558,'58207','U','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.916740,-97.367273,0,'2013-07-06 12:44:33',NULL,NULL),(30565,'33413','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.678715,-80.141603,0,'2013-07-06 12:44:32',NULL,NULL),(35088,'39204','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.285241,-90.230923,0,'2013-07-06 12:44:32',NULL,NULL),(77472,'96819','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.345402,-157.880907,0,'2013-07-06 12:44:34',NULL,NULL),(36266,'40334','S','Hope','D','Bath','21011','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.917111,-83.856444,0,'2013-07-06 12:44:32',NULL,NULL),(30645,'33454','P','Green Acres','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.594768,-80.200705,0,'2013-07-06 12:44:32',NULL,NULL),(69415,'83631','S','Centerville','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(11296,'11777','S','Belle Terre','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(62957,'75116','S','Duncanville','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.658363,-96.915110,0,'2013-07-06 12:44:33',NULL,NULL),(16823,'17551','S','Millersville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.000624,-76.358814,0,'2013-07-06 12:44:31',NULL,NULL),(57762,'67451','S','Hope','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.679420,-97.107720,0,'2013-07-06 12:44:33',NULL,NULL),(46771,'53948','S','Mauston','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.795494,-90.080098,0,'2013-07-06 12:44:32',NULL,NULL),(40485,'45779','P','Syracuse','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.997565,-81.973984,0,'2013-07-06 12:44:32',NULL,NULL),(6315,'05661','S','Garfield','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(5229,'04463','S','Orneville Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.248630,-68.986198,0,'2013-07-06 12:44:30',NULL,NULL),(76758,'95924','P','Cedar Ridge','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.198075,-121.018961,0,'2013-07-06 12:44:34',NULL,NULL),(4057,'02644','S','Forestdale','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.683249,-70.512191,0,'2013-07-06 12:44:30',NULL,NULL),(68333,'81121','P','Navajo State Park','N','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.026700,-107.483555,0,'2013-07-06 12:44:34',NULL,NULL),(58479,'68747','S','McLean','D','Pierce','31139','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.395646,-97.475489,0,'2013-07-06 12:44:33',NULL,NULL),(52104,'60412','P','Chicago Hts','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.510829,-87.636167,0,'2013-07-06 12:44:33',NULL,NULL),(49576,'56728','S','Northcote','N','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.774233,-96.944459,0,'2013-07-06 12:44:33',NULL,NULL),(19654,'20301','U','Pentagon','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891090,-77.020936,0,'2013-07-06 12:44:31',NULL,NULL),(50830,'58474','S','Oakes','D','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.133520,-98.100180,0,'2013-07-06 12:44:33',NULL,NULL),(21206,'22201','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.887343,-77.098842,0,'2013-07-06 12:44:31',NULL,NULL),(25791,'28604','S','Rominger','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(38941,'44124','S','Lyndhurst','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(64037,'76126','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.586584,-97.538996,0,'2013-07-06 12:44:34',NULL,NULL),(6781,'06104','P','Main Office','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.788898,-72.665246,0,'2013-07-06 12:44:30',NULL,NULL),(64281,'76436','S','Carlton','D','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.904013,-98.129873,0,'2013-07-06 12:44:34',NULL,NULL),(32384,'35906','S','Rbc','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.942000,-86.103720,0,'2013-07-06 12:44:32',NULL,NULL),(47778,'55043','S','Lakeland Shores','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(79500,'98904','P','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.602180,-120.504720,0,'2013-07-06 12:44:34',NULL,NULL),(63261,'75493','P','Winfield','D','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.164074,-95.110079,0,'2013-07-06 12:44:33',NULL,NULL),(26774,'29445','S','Goose Creek','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.028080,-80.047320,0,'2013-07-06 12:44:31',NULL,NULL),(38106,'43101','P','Adelphi','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.464919,-82.748279,0,'2013-07-06 12:44:32',NULL,NULL),(56795,'65761','S','Ocie','N','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.577980,-92.706780,0,'2013-07-06 12:44:33',NULL,NULL),(69001,'83202','S','Pocatello','D','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.937260,-112.488540,0,'2013-07-06 12:44:34',NULL,NULL),(60466,'71654','S','McArthur','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.656460,-91.408020,0,'2013-07-06 12:44:33',NULL,NULL),(59033,'70083','S','Myrtle Grove','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(36946,'41166','S','Quincy','D','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.631473,-83.095046,0,'2013-07-06 12:44:32',NULL,NULL),(77621,'96960','P','Majuro Marshall Islands','N','Marshall Islands','68020','Marshall Islands','MH','68','0000','692','UTC+12',12.0,'N',7.364758,170.855049,0,'2013-07-06 12:44:34',NULL,NULL),(20419,'20907','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998857,-77.032519,0,'2013-07-06 12:44:31',NULL,NULL),(36586,'40962','S','Eriline','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(29016,'32227','S','Jacksonville Beach','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(28840,'32086','S','Saint Augustine','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.759403,-81.303970,0,'2013-07-06 12:44:32',NULL,NULL),(67997,'80920','S','Co Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.958459,-104.757058,0,'2013-07-06 12:44:34',NULL,NULL),(9819,'10113','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(67609,'80432','P','Fairplay','A','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.218495,-105.745536,0,'2013-07-06 12:44:34',NULL,NULL),(50352,'57745','S','Rochford','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.124460,-103.719540,0,'2013-07-06 12:44:33',NULL,NULL),(19339,'20036','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905726,-77.038962,0,'2013-07-06 12:44:31',NULL,NULL),(36055,'40207','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(27763,'30363','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.841220,-84.385630,0,'2013-07-06 12:44:31',NULL,NULL),(75626,'94508','S','Angwin','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.574225,-122.445408,0,'2013-07-06 12:44:34',NULL,NULL),(35911,'40020','P','Fairfield','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.930175,-85.378486,0,'2013-07-06 12:44:32',NULL,NULL),(30215,'33184','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.756934,-80.404841,0,'2013-07-06 12:44:32',NULL,NULL),(70809,'85374','S','Sun City','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.629937,-112.350250,0,'2013-07-06 12:44:34',NULL,NULL),(174,'00623','S','Ext Sierra Linda','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(65444,'77590','S','West Texas City','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.396920,-94.920831,0,'2013-07-06 12:44:34',NULL,NULL),(54584,'62899','S','Zenith','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.697541,-88.638859,0,'2013-07-06 12:44:33',NULL,NULL),(69176,'83330','S','Gooding','D','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.937777,-114.717030,0,'2013-07-06 12:44:34',NULL,NULL),(46921,'54149','S','Mountain','D','Oconto','55083','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.209853,-88.504452,0,'2013-07-06 12:44:32',NULL,NULL),(36470,'40742','P','London','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.089649,-84.146587,0,'2013-07-06 12:44:32',NULL,NULL),(8854,'08647','U','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218571,-74.768936,0,'2013-07-06 12:44:30',NULL,NULL),(2206,'00926','S','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(9019,'08867','S','Pittstown','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.593311,-74.905975,0,'2013-07-06 12:44:30',NULL,NULL),(4432,'03241','S','E Hebron','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.712551,-71.875491,0,'2013-07-06 12:44:30',NULL,NULL),(52309,'60548','S','Sandwich','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.646803,-88.623355,0,'2013-07-06 12:44:33',NULL,NULL),(18872,'19453','S','Phoenixville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.138403,-75.502430,0,'2013-07-06 12:44:31',NULL,NULL),(36840,'41074','S','Dayton','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.110380,-84.468431,0,'2013-07-06 12:44:32',NULL,NULL),(59,'00610','S','Urb San Antonio','N','Anasco','72011','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.285948,-67.144161,0,'2013-07-06 12:44:30',NULL,NULL),(20131,'20722','S','Brentwood','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(56223,'65040','S','Henley','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.379720,-92.332906,0,'2013-07-06 12:44:33',NULL,NULL),(52729,'61232','S','Andalusia','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.436997,-90.725140,0,'2013-07-06 12:44:33',NULL,NULL),(25356,'28231','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.196190,-80.824359,0,'2013-07-06 12:44:31',NULL,NULL),(46453,'53211','S','Shorewood','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.082534,-87.884406,0,'2013-07-06 12:44:32',NULL,NULL),(29246,'32439','S','Freeport','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.457485,-86.215323,0,'2013-07-06 12:44:32',NULL,NULL),(43533,'48663','U','Ameritech','N','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.419367,-83.947813,0,'2013-07-06 12:44:32',NULL,NULL),(9199,'09459','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(15372,'16263','P','Yatesboro','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.798817,-79.333413,0,'2013-07-06 12:44:31',NULL,NULL),(79749,'99252','U','Avista Corp','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.657262,-117.377674,0,'2013-07-06 12:44:34',NULL,NULL),(78770,'98310','S','Gilberton','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(7689,'07105','S','Ironbound','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.722140,-74.140998,0,'2013-07-06 12:44:30',NULL,NULL),(2767,'00971','S','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388508,-66.115017,0,'2013-07-06 12:44:30',NULL,NULL),(19272,'19960','S','Lincoln','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.857908,-75.432843,0,'2013-07-06 12:44:31',NULL,NULL),(59229,'70427','S','Lees Creek','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(18113,'18769','U','Social Sec Admin','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.253872,-75.871166,0,'2013-07-06 12:44:31',NULL,NULL),(51273,'59106','S','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.767630,-108.662527,0,'2013-07-06 12:44:33',NULL,NULL),(17706,'18225','P','Harleigh','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.983978,-75.974463,0,'2013-07-06 12:44:31',NULL,NULL),(49086,'56329','S','Oak Park','A','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.689579,-93.912459,0,'2013-07-06 12:44:33',NULL,NULL),(9341,'09762','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4934,'04085','S','Steep Falls','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.747838,-70.639534,0,'2013-07-06 12:44:30',NULL,NULL),(52440,'60660','S','Rogers Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.990183,-87.664800,0,'2013-07-06 12:44:33',NULL,NULL),(74969,'93435','P','Harmony','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.512903,-121.008442,0,'2013-07-06 12:44:34',NULL,NULL),(59960,'71303','S','Weil','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(14116,'14643','U','JP Morgan Bank','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.155367,-77.607291,0,'2013-07-06 12:44:31',NULL,NULL),(5851,'05101','S','North Westminster','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185420,-72.488580,0,'2013-07-06 12:44:30',NULL,NULL),(49741,'57054','S','Ramona','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.118225,-97.211723,0,'2013-07-06 12:44:33',NULL,NULL),(46350,'53097','S','Mequon','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.236480,-87.984600,0,'2013-07-06 12:44:32',NULL,NULL),(61160,'72179','S','Wilburn','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.447510,-91.900253,0,'2013-07-06 12:44:33',NULL,NULL),(60644,'71903','P','Hot Springs National Park','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.525891,-92.996360,0,'2013-07-06 12:44:33',NULL,NULL),(49846,'57235','S','Florence','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.064359,-97.268930,0,'2013-07-06 12:44:33',NULL,NULL),(69751,'84050','S','Milton','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(74322,'92395','S','Victorville','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.486200,-117.366100,0,'2013-07-06 12:44:34',NULL,NULL),(74442,'92583','S','Gilman Hot Springs','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.791618,-116.918647,0,'2013-07-06 12:44:34',NULL,NULL),(74668,'92861','S','Orange','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.820489,-117.810430,0,'2013-07-06 12:44:34',NULL,NULL),(3819,'02303','P','Brockton','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.084757,-71.015162,0,'2013-07-06 12:44:30',NULL,NULL),(58990,'70054','P','Gretna','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.912367,-90.054585,0,'2013-07-06 12:44:33',NULL,NULL),(12692,'13138','P','Pompey','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.901818,-76.013663,0,'2013-07-06 12:44:30',NULL,NULL),(51064,'58750','S','Grano','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617118,-101.405976,0,'2013-07-06 12:44:33',NULL,NULL),(22345,'23881','S','Spring Grove','D','Surry','51181','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.214030,-77.070980,0,'2013-07-06 12:44:31',NULL,NULL),(60016,'71334','S','Turtle Lake','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(71758,'87551','S','Brazos','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.673323,-106.552060,0,'2013-07-06 12:44:34',NULL,NULL),(76157,'95309','P','Chinese Camp','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.863817,-120.440744,0,'2013-07-06 12:44:34',NULL,NULL),(104,'00612','S','Urb Los Corales','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(3520,'01886','S','Westford','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.589321,-71.437474,0,'2013-07-06 12:44:30',NULL,NULL),(19835,'20502','U','White House Ofc Staff','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896958,-77.034624,0,'2013-07-06 12:44:31',NULL,NULL),(29883,'33042','S','Middle Torch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(30672,'33468','P','Jupiter','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.937644,-80.111302,0,'2013-07-06 12:44:32',NULL,NULL),(19897,'20540','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889270,-77.004711,0,'2013-07-06 12:44:31',NULL,NULL),(17454,'17943','P','Lavelle','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.763136,-76.380483,0,'2013-07-06 12:44:31',NULL,NULL),(58803,'69021','S','Benkelman','D','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.051824,-101.532367,0,'2013-07-06 12:44:33',NULL,NULL),(1601,'00769','S','Urb El Mirador','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(28865,'32116','P','Dayt Bch Sh','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.212508,-81.008741,0,'2013-07-06 12:44:32',NULL,NULL),(79442,'98840','S','Okanogan','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.366451,-119.582819,0,'2013-07-06 12:44:34',NULL,NULL),(4564,'03466','S','W Chesterfld','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871118,-72.516627,0,'2013-07-06 12:44:30',NULL,NULL),(43492,'48618','S','Coleman','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.744516,-84.546925,0,'2013-07-06 12:44:32',NULL,NULL),(31638,'34715','S','Minneola','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.592359,-81.799392,0,'2013-07-06 12:44:32',NULL,NULL),(33821,'37922','S','Concord Farragut','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856420,-84.128340,0,'2013-07-06 12:44:32',NULL,NULL),(69928,'84112','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.763779,-111.838359,0,'2013-07-06 12:44:34',NULL,NULL),(74129,'92241','S','Desert Hot Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.899772,-116.390191,0,'2013-07-06 12:44:34',NULL,NULL),(16878,'17569','S','Vinemont','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.276083,-76.123914,0,'2013-07-06 12:44:31',NULL,NULL),(64889,'77077','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.750197,-95.611073,0,'2013-07-06 12:44:34',NULL,NULL),(4170,'02802','P','Albion','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.952338,-71.454151,0,'2013-07-06 12:44:30',NULL,NULL),(66355,'78613','S','Cedar Park','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.494138,-97.829836,0,'2013-07-06 12:44:34',NULL,NULL),(10853,'11413','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(68262,'81069','S','Greenwood','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.927576,-104.902916,0,'2013-07-06 12:44:34',NULL,NULL),(70070,'84148','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.755635,-111.835281,0,'2013-07-06 12:44:34',NULL,NULL),(32481,'36046','S','Lapine','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',31.985756,-86.281073,0,'2013-07-06 12:44:32',NULL,NULL),(31654,'34743','S','Buena Ventura Lakes','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.328203,-81.354643,0,'2013-07-06 12:44:32',NULL,NULL),(16480,'17250','P','Rouzerville','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.735149,-77.526368,0,'2013-07-06 12:44:31',NULL,NULL),(30341,'33311','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(8124,'07827','S','Montague','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.306160,-74.748900,0,'2013-07-06 12:44:30',NULL,NULL),(45835,'52215','S','Chelsea','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.918570,-92.393781,0,'2013-07-06 12:44:32',NULL,NULL),(64675,'76825','S','Fife','A','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.390710,-99.384310,0,'2013-07-06 12:44:34',NULL,NULL),(56554,'65464','S','Grogan','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.215181,-91.994666,0,'2013-07-06 12:44:33',NULL,NULL),(54534,'62882','S','Glen Ridge','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.612584,-89.121037,0,'2013-07-06 12:44:33',NULL,NULL),(50747,'58401','S','Sydney','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(48389,'55577','P','Rockford','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.994299,-93.710007,0,'2013-07-06 12:44:33',NULL,NULL),(47868,'55082','S','Oak Park Hts','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(22782,'24457','P','Low Moor','D','Alleghany','51005','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.789907,-79.885378,0,'2013-07-06 12:44:31',NULL,NULL),(43387,'48434','P','Forestville','D','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.657845,-82.609493,0,'2013-07-06 12:44:32',NULL,NULL),(39618,'44882','S','Sycamore','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(32161,'35474','S','Cypress','A','Hale','01065','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.007906,-87.600750,0,'2013-07-06 12:44:32',NULL,NULL),(31084,'33863','P','Nichols','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.866121,-81.805848,0,'2013-07-06 12:44:32',NULL,NULL),(30010,'33127','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.816413,-80.206972,0,'2013-07-06 12:44:32',NULL,NULL),(56229,'65042','P','California','A','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.478593,-92.606101,0,'2013-07-06 12:44:33',NULL,NULL),(24692,'27420','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.064672,-79.843907,0,'2013-07-06 12:44:31',NULL,NULL),(63259,'75491','S','Whitewright','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.508961,-96.401740,0,'2013-07-06 12:44:33',NULL,NULL),(62255,'74005','P','Brtlsville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.748499,-95.980696,0,'2013-07-06 12:44:33',NULL,NULL),(56432,'65264','S','Martinsburg','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.099199,-91.646881,0,'2013-07-06 12:44:33',NULL,NULL),(15157,'15902','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.309671,-78.891648,0,'2013-07-06 12:44:31',NULL,NULL),(52969,'61425','S','Shokokon','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.764786,-91.060793,0,'2013-07-06 12:44:33',NULL,NULL),(51898,'60099','S','Zion','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.450382,-87.859034,0,'2013-07-06 12:44:33',NULL,NULL),(44308,'49737','P','Good Hart','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.562761,-85.097009,0,'2013-07-06 12:44:32',NULL,NULL),(26934,'29590','S','Trio','A','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.562975,-79.827528,0,'2013-07-06 12:44:31',NULL,NULL),(75063,'93524','U','Edwards Air Force Base','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.919545,-117.946773,0,'2013-07-06 12:44:34',NULL,NULL),(51074,'58759','S','Max','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.819626,-101.296615,0,'2013-07-06 12:44:33',NULL,NULL),(43312,'48350','S','Springfld Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.742927,-83.530899,0,'2013-07-06 12:44:32',NULL,NULL),(7045,'06278','S','Ashford','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.896620,-72.141240,0,'2013-07-06 12:44:30',NULL,NULL),(21361,'22443','S','Colonial Beach','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.248998,-76.962438,0,'2013-07-06 12:44:31',NULL,NULL),(55658,'64024','S','Homestead Vlg','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(51364,'59344','S','Plevna','D','Fallon','30025','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.388263,-104.642861,0,'2013-07-06 12:44:33',NULL,NULL),(40782,'46163','S','Brookville Hts','N','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.734334,-85.908374,0,'2013-07-06 12:44:32',NULL,NULL),(39782,'45123','S','Ross County','A','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.333281,-83.413658,0,'2013-07-06 12:44:32',NULL,NULL),(37262,'41566','S','Steele','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.400823,-82.203687,0,'2013-07-06 12:44:32',NULL,NULL),(56268,'65065','S','Osage Beach','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.136059,-92.670500,0,'2013-07-06 12:44:33',NULL,NULL),(55587,'63931','S','Briar','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.641594,-90.959266,0,'2013-07-06 12:44:33',NULL,NULL),(55115,'63334','S','Tarrants','N','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.339811,-91.197015,0,'2013-07-06 12:44:33',NULL,NULL),(47686,'54963','S','Omro','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.044243,-88.759053,0,'2013-07-06 12:44:33',NULL,NULL),(58831,'69101','S','North Platte','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.133414,-100.771684,0,'2013-07-06 12:44:33',NULL,NULL),(25218,'28083','S','Kannapolis','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.483897,-80.599575,0,'2013-07-06 12:44:31',NULL,NULL),(41110,'46565','S','Shipshewana','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.675713,-85.576964,0,'2013-07-06 12:44:32',NULL,NULL),(66297,'78586','S','Colaboz','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(18599,'19140','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.013413,-75.144023,0,'2013-07-06 12:44:31',NULL,NULL),(48924,'56149','S','Lake Benton','D','Lincoln','27081','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.259146,-96.285442,0,'2013-07-06 12:44:33',NULL,NULL),(18369,'19044','S','Horsham','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.182463,-75.150115,0,'2013-07-06 12:44:31',NULL,NULL),(44572,'50025','S','Ross','N','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.726100,-94.918560,0,'2013-07-06 12:44:32',NULL,NULL),(60111,'71366','S','Saranac','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(34567,'38732','S','Delta State','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740820,-90.724995,0,'2013-07-06 12:44:32',NULL,NULL),(57390,'66756','S','Barber','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.549625,-94.679242,0,'2013-07-06 12:44:33',NULL,NULL),(52028,'60180','S','Union','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.223418,-88.525155,0,'2013-07-06 12:44:33',NULL,NULL),(44094,'49463','P','Sylvan Beach','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.370564,-86.423252,0,'2013-07-06 12:44:32',NULL,NULL),(63841,'75974','S','Tenoka','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(24594,'27326','S','Allison','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(53967,'62428','S','Union Center','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(13404,'13753','S','Delhi','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.282872,-74.910178,0,'2013-07-06 12:44:31',NULL,NULL),(63852,'75977','S','Jamestown','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.073640,-93.809691,0,'2013-07-06 12:44:34',NULL,NULL),(27942,'30534','S','Dawsonville','D','Dawson','13085','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.388619,-84.096464,0,'2013-07-06 12:44:31',NULL,NULL),(53527,'62031','S','East Hardin','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.101331,-90.556238,0,'2013-07-06 12:44:33',NULL,NULL),(29138,'32327','S','Wakulla Springs','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.194005,-84.263529,0,'2013-07-06 12:44:32',NULL,NULL),(39655,'45005','S','Carlisle','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.528960,-84.297420,0,'2013-07-06 12:44:32',NULL,NULL),(44072,'49445','S','Muskegon','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.293180,-86.282880,0,'2013-07-06 12:44:32',NULL,NULL),(4747,'03841','S','Hampstead','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.881399,-71.178667,0,'2013-07-06 12:44:30',NULL,NULL),(28530,'31552','S','Fairfax','N','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.270467,-82.638049,0,'2013-07-06 12:44:32',NULL,NULL),(55089,'63301','S','Kampville Beach','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(30920,'33708','S','Redington Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(37357,'41722','S','Heiner','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(47401,'54645','P','Mount Sterling','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.314232,-90.930144,0,'2013-07-06 12:44:32',NULL,NULL),(70023,'84129','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696347,-112.017349,0,'2013-07-06 12:44:34',NULL,NULL),(79464,'98852','P','Stehekin','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.237614,-120.533184,0,'2013-07-06 12:44:34',NULL,NULL),(44239,'49660','S','Stronach','A','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.176440,-86.209560,0,'2013-07-06 12:44:32',NULL,NULL),(8571,'08215','S','Egg Harbor','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(14550,'15211','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.432740,-79.945680,0,'2013-07-06 12:44:31',NULL,NULL),(12530,'13035','S','Fenner','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968760,-75.820020,0,'2013-07-06 12:44:30',NULL,NULL),(47298,'54548','S','Minocqua','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.862814,-89.759011,0,'2013-07-06 12:44:32',NULL,NULL),(70110,'84180','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767274,-111.898078,0,'2013-07-06 12:44:34',NULL,NULL),(79570,'99018','S','Latah','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.292903,-117.132885,0,'2013-07-06 12:44:34',NULL,NULL),(14654,'15237','S','Mc Knight','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.549733,-80.039957,0,'2013-07-06 12:44:31',NULL,NULL),(72777,'89595','U','Grand Sierra Hotel','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.527847,-119.782389,0,'2013-07-06 12:44:34',NULL,NULL),(21223,'22214','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.854651,-77.070177,0,'2013-07-06 12:44:31',NULL,NULL),(27022,'29647','U','Gwd','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.189754,-82.153840,0,'2013-07-06 12:44:31',NULL,NULL),(5253,'04481','P','Brownville','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.271763,-69.117916,0,'2013-07-06 12:44:30',NULL,NULL),(65911,'78236','S','Security Services','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(79052,'98416','U','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.265185,-122.482216,0,'2013-07-06 12:44:34',NULL,NULL),(69903,'84107','S','Millcreek','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(5284,'04530','S','West Bath','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.913876,-69.824845,0,'2013-07-06 12:44:30',NULL,NULL),(23189,'25048','S','Colcord','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.936091,-81.458341,0,'2013-07-06 12:44:31',NULL,NULL),(48765,'55981','S','Wabasha','D','Wabasha','27157','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.359337,-92.023834,0,'2013-07-06 12:44:33',NULL,NULL),(19534,'20190','S','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.958168,-77.341846,0,'2013-07-06 12:44:31',NULL,NULL),(34715,'38835','P','Corinth','D','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.932281,-88.518647,0,'2013-07-06 12:44:32',NULL,NULL),(74360,'92413','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.150103,-117.256720,0,'2013-07-06 12:44:34',NULL,NULL),(76331,'95462','S','Russian River Mdws','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.469285,-123.012010,0,'2013-07-06 12:44:34',NULL,NULL),(46188,'52745','S','Big Rock','A','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.770278,-90.826111,0,'2013-07-06 12:44:32',NULL,NULL),(56030,'64679','S','Spickard','D','Grundy','29079','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.233193,-93.498769,0,'2013-07-06 12:44:33',NULL,NULL),(20278,'20790','U','Capitol Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854641,-76.931528,0,'2013-07-06 12:44:31',NULL,NULL),(58345,'68501','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.823788,-96.775090,0,'2013-07-06 12:44:33',NULL,NULL),(5090,'04338','P','Augusta','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.319709,-69.776569,0,'2013-07-06 12:44:30',NULL,NULL),(17297,'17851','S','Mount Carmel','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(30263,'33234','P','Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.750799,-80.274412,0,'2013-07-06 12:44:32',NULL,NULL),(54641,'62923','S','Cypress','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.451755,-89.273521,0,'2013-07-06 12:44:33',NULL,NULL),(49449,'56644','S','Gonvick','D','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.849231,-95.480640,0,'2013-07-06 12:44:33',NULL,NULL),(62552,'74439','P','Braggs','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.667770,-95.198709,0,'2013-07-06 12:44:33',NULL,NULL),(51732,'60012','S','Prairie Grove','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.270000,-88.304220,0,'2013-07-06 12:44:33',NULL,NULL),(21513,'22716','S','Castleton','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.607228,-78.114936,0,'2013-07-06 12:44:31',NULL,NULL),(34032,'38133','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.206829,-89.791238,0,'2013-07-06 12:44:32',NULL,NULL),(11346,'11795','S','W Islip','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.709304,-73.299311,0,'2013-07-06 12:44:30',NULL,NULL),(55977,'64601','S','Chillicothe','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.793244,-93.553948,0,'2013-07-06 12:44:33',NULL,NULL),(72058,'88114','S','Crossroads','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.507396,-103.341671,0,'2013-07-06 12:44:34',NULL,NULL),(78506,'98113','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.675126,-122.344156,0,'2013-07-06 12:44:34',NULL,NULL),(68693,'82051','S','Laramie','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.576111,-105.694722,0,'2013-07-06 12:44:34',NULL,NULL),(15121,'15821','S','Benezette','A','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.315960,-78.333781,0,'2013-07-06 12:44:31',NULL,NULL),(36332,'40391','S','Ford','A','Clark','21049','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.980177,-84.168803,0,'2013-07-06 12:44:32',NULL,NULL),(43343,'48380','S','Milford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.585954,-83.650740,0,'2013-07-06 12:44:32',NULL,NULL),(41796,'47326','S','Poling','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.536527,-84.963031,0,'2013-07-06 12:44:32',NULL,NULL),(64086,'76150','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.751455,-97.338993,0,'2013-07-06 12:44:34',NULL,NULL),(57145,'66250','U','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955067,-94.786621,0,'2013-07-06 12:44:33',NULL,NULL),(44451,'49868','S','Newberry','D','Luce','26095','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.344668,-85.508112,0,'2013-07-06 12:44:32',NULL,NULL),(14641,'15234','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(7416,'06807','S','Cos Cob','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.049767,-73.589652,0,'2013-07-06 12:44:30',NULL,NULL),(32615,'36140','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382875,-86.146711,0,'2013-07-06 12:44:32',NULL,NULL),(13048,'13440','S','Coonrod','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(72236,'88512','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811289,-106.418964,0,'2013-07-06 12:44:34',NULL,NULL),(21972,'23242','P','Richmnd','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.619818,-77.613981,0,'2013-07-06 12:44:31',NULL,NULL),(62848,'75021','S','Denison','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.755548,-96.537942,0,'2013-07-06 12:44:33',NULL,NULL),(11022,'11561','S','E Atlantc Bch','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.585753,-73.657497,0,'2013-07-06 12:44:30',NULL,NULL),(28371,'31221','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.880489,-83.818616,0,'2013-07-06 12:44:32',NULL,NULL),(6313,'05661','S','Cleveland Corner','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(14064,'14590','S','Wolcott','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.245974,-76.832666,0,'2013-07-06 12:44:31',NULL,NULL),(62931,'75090','S','Sherman','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.642018,-96.607173,0,'2013-07-06 12:44:33',NULL,NULL),(59513,'70786','P','Watson','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.585614,-90.939345,0,'2013-07-06 12:44:33',NULL,NULL),(7039,'06269','U','Storrs Mansfield','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.811419,-72.247553,0,'2013-07-06 12:44:30',NULL,NULL),(76420,'95565','S','Scotia','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.449567,-124.001904,0,'2013-07-06 12:44:34',NULL,NULL),(41662,'47146','P','Mount Saint Francis','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.318232,-85.911798,0,'2013-07-06 12:44:32',NULL,NULL),(2384,'00949','S','Urb La Rosaleda I','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(1839,'00784','S','Urb Vives','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(59791,'71220','S','Bastrop','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(52648,'61061','S','Oregon','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.002186,-89.338593,0,'2013-07-06 12:44:33',NULL,NULL),(54561,'62894','S','Waltonville','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316963,-88.911647,0,'2013-07-06 12:44:33',NULL,NULL),(22565,'24150','S','Goldbond','A','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.378380,-80.656200,0,'2013-07-06 12:44:31',NULL,NULL),(31173,'33918','P','North Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(37698,'42256','S','Lewisburg','D','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.008924,-86.979116,0,'2013-07-06 12:44:32',NULL,NULL),(39886,'45212','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.175321,-84.440014,0,'2013-07-06 12:44:32',NULL,NULL),(12788,'13218','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.047082,-76.148417,0,'2013-07-06 12:44:30',NULL,NULL),(22184,'23482','P','Wardtown','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.507734,-75.870350,0,'2013-07-06 12:44:31',NULL,NULL),(66476,'78662','S','Red Rock','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.946816,-97.438931,0,'2013-07-06 12:44:34',NULL,NULL),(64787,'77009','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.796922,-95.368503,0,'2013-07-06 12:44:34',NULL,NULL),(64138,'76196','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755869,-97.338178,0,'2013-07-06 12:44:34',NULL,NULL),(61651,'72860','S','Rover','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.932257,-93.403880,0,'2013-07-06 12:44:33',NULL,NULL),(60304,'71454','S','Patch Leg','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(77051,'96113','P','Sierra Army Depot','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.138912,-120.156585,0,'2013-07-06 12:44:34',NULL,NULL),(12300,'12850','S','Providence','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.118700,-73.987500,0,'2013-07-06 12:44:30',NULL,NULL),(43120,'48228','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.353376,-83.212913,0,'2013-07-06 12:44:32',NULL,NULL),(33714,'37777','S','Louisville','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.831102,-84.048154,0,'2013-07-06 12:44:32',NULL,NULL),(77067,'96122','S','Portola','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.842100,-120.468060,0,'2013-07-06 12:44:34',NULL,NULL),(9433,'10004','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(64304,'76462','S','Lipan','D','Hood','48221','Texas','TX','48','2800','254','Central',-6.0,'Y',32.479209,-98.050086,0,'2013-07-06 12:44:34',NULL,NULL),(11963,'12456','S','Mount Marion','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.036600,-73.998840,0,'2013-07-06 12:44:30',NULL,NULL),(66886,'79239','S','Lakeview','D','Hall','48191','Texas','TX','48','0000','806','Central',-6.0,'Y',34.664285,-100.759763,0,'2013-07-06 12:44:34',NULL,NULL),(54297,'62707','S','Andrew','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(28494,'31522','S','Saint Simons Island','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.165091,-81.384700,0,'2013-07-06 12:44:32',NULL,NULL),(1249,'00729','S','Urb Forest Plantation','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(62405,'74117','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.235013,-95.885947,0,'2013-07-06 12:44:33',NULL,NULL),(61041,'72118','S','N LR','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(57860,'67573','S','Raymond','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.263006,-98.418850,0,'2013-07-06 12:44:33',NULL,NULL),(55289,'63501','S','Millard','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(43586,'48750','S','Au Sable','A','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.448307,-83.380374,0,'2013-07-06 12:44:32',NULL,NULL),(43786,'49043','S','Covert','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.294025,-86.272654,0,'2013-07-06 12:44:32',NULL,NULL),(70696,'85262','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.815653,-111.784575,0,'2013-07-06 12:44:34',NULL,NULL),(19264,'19951','S','Harbeson','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.661180,-75.176994,0,'2013-07-06 12:44:31',NULL,NULL),(20635,'21219','S','Dundalk Sparrows Point','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.250556,-76.520833,0,'2013-07-06 12:44:31',NULL,NULL),(16507,'17264','S','Three Springs','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.174380,-77.988180,0,'2013-07-06 12:44:31',NULL,NULL),(8110,'07820','P','Allamuchy','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.913524,-74.831169,0,'2013-07-06 12:44:30',NULL,NULL),(38539,'43748','S','Jnctn City','N','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.714915,-82.310414,0,'2013-07-06 12:44:32',NULL,NULL),(70461,'84754','S','Central Vly','A','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.642486,-112.135978,0,'2013-07-06 12:44:34',NULL,NULL),(10787,'11368','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.752572,-73.854759,0,'2013-07-06 12:44:30',NULL,NULL),(29950,'33073','S','Coconut Creek','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.305181,-80.187797,0,'2013-07-06 12:44:32',NULL,NULL),(79763,'99321','S','Schawana','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.863736,-119.865074,0,'2013-07-06 12:44:34',NULL,NULL),(66795,'79059','S','Miami','D','Roberts','48393','Texas','TX','48','0000','806','Central',-6.0,'Y',35.690100,-100.639117,0,'2013-07-06 12:44:34',NULL,NULL),(28486,'31519','S','Lotts','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.627081,-82.891582,0,'2013-07-06 12:44:32',NULL,NULL),(48587,'55779','S','Culver','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(1721,'00778','S','Lomas Del Sol','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(50623,'58267','S','Northwood','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.743920,-97.583880,0,'2013-07-06 12:44:33',NULL,NULL),(20502,'21071','P','Glyndon','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.485037,-76.775877,0,'2013-07-06 12:44:31',NULL,NULL),(54929,'63106','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.643705,-90.203509,0,'2013-07-06 12:44:33',NULL,NULL),(50089,'57467','S','Polo','N','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.835346,-99.110013,0,'2013-07-06 12:44:33',NULL,NULL),(53086,'61526','S','Lawn Ridge','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.958700,-89.588220,0,'2013-07-06 12:44:33',NULL,NULL),(28280,'31088','S','Centerville','N','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.595758,-83.638378,0,'2013-07-06 12:44:31',NULL,NULL),(77476,'96820','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.351908,-157.878057,0,'2013-07-06 12:44:34',NULL,NULL),(57563,'67049','S','Freeport','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.179576,-97.857772,0,'2013-07-06 12:44:33',NULL,NULL),(26535,'29203','S','Killian','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(50182,'57560','S','Wanamaker','N','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.473034,-101.079381,0,'2013-07-06 12:44:33',NULL,NULL),(32788,'36420','S','Straughn','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(6563,'05849','P','Lyndon Corners','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.532888,-72.000285,0,'2013-07-06 12:44:30',NULL,NULL),(9863,'10120','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(14796,'15370','S','Waynesburg','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.894897,-80.174254,0,'2013-07-06 12:44:31',NULL,NULL),(69967,'84119','S','South Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(78948,'98368','S','Leland','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(64707,'76858','S','Melvin','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.140851,-99.521319,0,'2013-07-06 12:44:34',NULL,NULL),(47702,'54981','S','Waupaca','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.354239,-89.084923,0,'2013-07-06 12:44:33',NULL,NULL),(19750,'20410','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885547,-77.021382,0,'2013-07-06 12:44:31',NULL,NULL),(15058,'15724','S','Cherry Tree','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.768993,-78.848701,0,'2013-07-06 12:44:31',NULL,NULL),(76492,'95633','S','Garden Valley','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.848412,-120.843022,0,'2013-07-06 12:44:34',NULL,NULL),(78733,'98283','S','Diablo','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.482400,-121.527120,0,'2013-07-06 12:44:34',NULL,NULL),(57069,'66214','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(30056,'33146','S','Univ of Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(22940,'24635','P','Pocahontas','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.303883,-81.335643,0,'2013-07-06 12:44:31',NULL,NULL),(67224,'79927','S','Horizon City','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.655220,-106.228260,0,'2013-07-06 12:44:34',NULL,NULL),(57177,'66402','S','Auburn','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.907621,-95.829763,0,'2013-07-06 12:44:33',NULL,NULL),(16854,'17563','S','Fulton','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(26852,'29519','P','Centenary','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.029377,-79.356406,0,'2013-07-06 12:44:31',NULL,NULL),(32414,'35968','S','Pine Ridge','A','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.441634,-85.719381,0,'2013-07-06 12:44:32',NULL,NULL),(12987,'13407','S','German Flatts','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.991140,-74.980560,0,'2013-07-06 12:44:30',NULL,NULL),(3185,'01340','S','Colrain','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711706,-72.719125,0,'2013-07-06 12:44:30',NULL,NULL),(5138,'04414','S','Ebeemee Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.307433,-69.030278,0,'2013-07-06 12:44:30',NULL,NULL),(42665,'47958','P','Mellott','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.161228,-87.149075,0,'2013-07-06 12:44:32',NULL,NULL),(31931,'35181','P','Watson','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.624644,-86.890530,0,'2013-07-06 12:44:32',NULL,NULL),(69417,'83631','S','New Centerville','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.869698,-115.774376,0,'2013-07-06 12:44:34',NULL,NULL),(10311,'10535','S','Jefferson Vly','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.339561,-73.798456,0,'2013-07-06 12:44:30',NULL,NULL),(15070,'15738','P','Emeigh','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.694023,-78.785167,0,'2013-07-06 12:44:31',NULL,NULL),(67208,'79915','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.751969,-106.381303,0,'2013-07-06 12:44:34',NULL,NULL),(62498,'74362','P','Pryor Creek','N','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.288695,-95.319273,0,'2013-07-06 12:44:33',NULL,NULL),(26819,'29482','S','Sullivans Is','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.761726,-79.837391,0,'2013-07-06 12:44:31',NULL,NULL),(53899,'62362','P','Perry','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.785162,-90.744207,0,'2013-07-06 12:44:33',NULL,NULL),(28078,'30728','S','La Fayette','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.708605,-85.286695,0,'2013-07-06 12:44:31',NULL,NULL),(28663,'31783','S','Rebecca','D','Turner','13287','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.784845,-83.532927,0,'2013-07-06 12:44:32',NULL,NULL),(43553,'48710','U','University Center','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.561826,-83.987515,0,'2013-07-06 12:44:32',NULL,NULL),(35626,'39631','S','Centreville','D','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.088728,-91.067021,0,'2013-07-06 12:44:32',NULL,NULL),(66695,'78945','S','La Grange','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(26882,'29556','S','Kingstree','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.678350,-79.824331,0,'2013-07-06 12:44:31',NULL,NULL),(27666,'30327','S','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.865889,-84.425245,0,'2013-07-06 12:44:31',NULL,NULL),(3616,'02055','P','Scituate','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.238834,-70.761576,0,'2013-07-06 12:44:30',NULL,NULL),(68441,'81225','P','Meridian Lake','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(40506,'45809','S','Lima','A','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.845893,-84.183369,0,'2013-07-06 12:44:32',NULL,NULL),(66342,'78607','S','Bluffton','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.832905,-98.492899,0,'2013-07-06 12:44:34',NULL,NULL),(59111,'70145','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.961146,-90.035413,0,'2013-07-06 12:44:33',NULL,NULL),(65737,'78050','P','Leming','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',29.072213,-98.485195,0,'2013-07-06 12:44:34',NULL,NULL),(79490,'98902','S','Tampico','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(64178,'76230','S','Fruitland','N','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.561402,-97.838818,0,'2013-07-06 12:44:34',NULL,NULL),(15710,'16860','S','Munson','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.968776,-78.182212,0,'2013-07-06 12:44:31',NULL,NULL),(36316,'40379','S','Stamping Ground','D','Scott','21209','Kentucky','KY','21','4280','502','Eastern',-5.0,'Y',38.296886,-84.675833,0,'2013-07-06 12:44:32',NULL,NULL),(12865,'13323','S','Lairdsville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.056309,-75.375791,0,'2013-07-06 12:44:30',NULL,NULL),(71865,'87714','S','Philmont','N','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.574377,-105.053005,0,'2013-07-06 12:44:34',NULL,NULL),(40035,'45251','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.255230,-84.589734,0,'2013-07-06 12:44:32',NULL,NULL),(42179,'47532','S','St Henry','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.226646,-86.862058,0,'2013-07-06 12:44:32',NULL,NULL),(8664,'08318','S','Pittsgrove Township','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.568620,-75.181860,0,'2013-07-06 12:44:30',NULL,NULL),(62560,'74447','S','Okmulgee','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.623341,-95.970246,0,'2013-07-06 12:44:33',NULL,NULL),(9409,'10001','S','Gpo','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(41866,'47358','S','Modoc','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.994052,-85.080636,0,'2013-07-06 12:44:32',NULL,NULL),(35394,'39457','P','McNeill','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.668484,-89.638961,0,'2013-07-06 12:44:32',NULL,NULL),(77046,'96111','P','Truckee','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.391046,-120.023279,0,'2013-07-06 12:44:34',NULL,NULL),(43645,'48838','S','Greenville','D','Montcalm','26117','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.190086,-85.247315,0,'2013-07-06 12:44:32',NULL,NULL),(58684,'68923','P','Industry','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.453315,-99.343230,0,'2013-07-06 12:44:33',NULL,NULL),(27442,'30118','U','University of West Georgia','N','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.571798,-85.106910,0,'2013-07-06 12:44:31',NULL,NULL),(29846,'33034','S','Florida City','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.450256,-80.489973,0,'2013-07-06 12:44:32',NULL,NULL),(33445,'37311','S','Cleveld','N','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.157330,-84.870390,0,'2013-07-06 12:44:32',NULL,NULL),(68172,'81010','U','CO Lottery','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.275773,-104.607888,0,'2013-07-06 12:44:34',NULL,NULL),(7227,'06504','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.291641,-72.964292,0,'2013-07-06 12:44:30',NULL,NULL),(33819,'37922','S','Concord','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856420,-84.128340,0,'2013-07-06 12:44:32',NULL,NULL),(74915,'93384','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.373201,-119.017675,0,'2013-07-06 12:44:34',NULL,NULL),(79158,'98506','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.103780,-122.868360,0,'2013-07-06 12:44:34',NULL,NULL),(15173,'15928','S','Davidsville','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.224988,-78.931350,0,'2013-07-06 12:44:31',NULL,NULL),(30078,'33155','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737315,-80.309137,0,'2013-07-06 12:44:32',NULL,NULL),(49163,'56393','U','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.567555,-94.217111,0,'2013-07-06 12:44:33',NULL,NULL),(55178,'63373','S','Machens','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.924848,-90.364053,0,'2013-07-06 12:44:33',NULL,NULL),(9018,'08865','S','Phillipsburg','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.698180,-75.135480,0,'2013-07-06 12:44:30',NULL,NULL),(9000,'08852','S','Monmouth Junction','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.394077,-74.544739,0,'2013-07-06 12:44:30',NULL,NULL),(6906,'06151','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766300,-72.673122,0,'2013-07-06 12:44:30',NULL,NULL),(29322,'32542','S','Dfafs','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(24599,'27326','S','Ruffin','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(2886,'00987','S','Jard de Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(37119,'41413','P','Crockett','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.987468,-83.091171,0,'2013-07-06 12:44:32',NULL,NULL),(44015,'49402','S','Branch','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.920128,-86.067294,0,'2013-07-06 12:44:32',NULL,NULL),(68975,'83111','S','Auburn','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.791902,-110.962688,0,'2013-07-06 12:44:34',NULL,NULL),(66586,'78747','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.118260,-97.749540,0,'2013-07-06 12:44:34',NULL,NULL),(48919,'56144','S','Jasper','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.854508,-96.397055,0,'2013-07-06 12:44:33',NULL,NULL),(26875,'29547','S','South of the Border','A','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.508632,-79.405977,0,'2013-07-06 12:44:31',NULL,NULL),(70505,'84782','S','Brookside','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.376940,-113.661480,0,'2013-07-06 12:44:34',NULL,NULL),(70565,'85051','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.560619,-112.134084,0,'2013-07-06 12:44:34',NULL,NULL),(62357,'74063','S','SS','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.122622,-96.150607,0,'2013-07-06 12:44:33',NULL,NULL),(54679,'62942','S','Grand Tower','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.639885,-89.467041,0,'2013-07-06 12:44:33',NULL,NULL),(38513,'43720','S','Blue Rock','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.797077,-81.879055,0,'2013-07-06 12:44:32',NULL,NULL),(38309,'43358','S','W Mansfield','A','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.416420,-83.486218,0,'2013-07-06 12:44:32',NULL,NULL),(54786,'63010','S','Arnold','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.431711,-90.398001,0,'2013-07-06 12:44:33',NULL,NULL),(74856,'93252','S','Maricopa','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.058817,-119.403149,0,'2013-07-06 12:44:34',NULL,NULL),(21676,'22958','S','Nellysford','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.863180,-78.871080,0,'2013-07-06 12:44:31',NULL,NULL),(33949,'38080','S','Miston','A','Lake','47095','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.263847,-89.484004,0,'2013-07-06 12:44:32',NULL,NULL),(10164,'10279','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(52892,'61350','S','Prairie Center','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(64121,'76182','S','North Richland Hills','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.798211,-97.191792,0,'2013-07-06 12:44:34',NULL,NULL),(19300,'19980','P','Woodside','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.069528,-75.566951,0,'2013-07-06 12:44:31',NULL,NULL),(64462,'76574','S','Laneport','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(15933,'17021','S','Perulack','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(58995,'70057','S','Killona','A','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.938506,-90.480590,0,'2013-07-06 12:44:33',NULL,NULL),(14660,'15238','S','Fox Chapel','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.530285,-79.876419,0,'2013-07-06 12:44:31',NULL,NULL),(47979,'55127','S','North Oaks','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079980,-93.087120,0,'2013-07-06 12:44:33',NULL,NULL),(12283,'12843','S','Garnet Lake','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.593550,-73.974572,0,'2013-07-06 12:44:30',NULL,NULL),(72865,'90006','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.045817,-118.290338,0,'2013-07-06 12:44:34',NULL,NULL),(78013,'97415','S','Brookings','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.054175,-124.260145,0,'2013-07-06 12:44:34',NULL,NULL),(8301,'08025','P','Ewan','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.697566,-75.182739,0,'2013-07-06 12:44:30',NULL,NULL),(74954,'93421','P','Halcyon','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.120678,-120.574422,0,'2013-07-06 12:44:34',NULL,NULL),(34870,'38940','S','Nason','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.691186,-89.939080,0,'2013-07-06 12:44:32',NULL,NULL),(26334,'29056','S','Greeleyville','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.789296,-79.832893,0,'2013-07-06 12:44:31',NULL,NULL),(40519,'45822','S','Carthagena','A','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.549433,-84.578000,0,'2013-07-06 12:44:32',NULL,NULL),(38805,'44067','S','Sagamore Hills','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(35390,'39456','S','Leaf','A','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.073880,-88.816080,0,'2013-07-06 12:44:32',NULL,NULL),(34307,'38548','S','Buffalo Vly','A','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.182066,-85.756226,0,'2013-07-06 12:44:32',NULL,NULL),(30374,'33317','S','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.093836,-80.239494,0,'2013-07-06 12:44:32',NULL,NULL),(16435,'17233','S','Mc Connellsburg','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(15599,'16671','P','Ramey','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.801988,-78.400187,0,'2013-07-06 12:44:31',NULL,NULL),(14924,'15548','S','Kantner','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.104448,-78.939815,0,'2013-07-06 12:44:31',NULL,NULL),(27331,'30034','S','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.689216,-84.247271,0,'2013-07-06 12:44:31',NULL,NULL),(21759,'23059','S','Glen Allen','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.716392,-77.578346,0,'2013-07-06 12:44:31',NULL,NULL),(68352,'81132','S','Plaza','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(73705,'91609','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.188269,-118.386781,0,'2013-07-06 12:44:34',NULL,NULL),(77876,'97267','S','Jennings Lodge','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(78099,'97488','S','Vida','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.133120,-122.463360,0,'2013-07-06 12:44:34',NULL,NULL),(64928,'77212','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.763737,-95.365297,0,'2013-07-06 12:44:34',NULL,NULL),(51871,'60083','S','Wadsworth','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.429918,-87.932049,0,'2013-07-06 12:44:33',NULL,NULL),(28818,'32080','S','Anastasia Is','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(7329,'06705','S','Wolcott','A','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.549583,-72.995890,0,'2013-07-06 12:44:30',NULL,NULL),(40261,'45431','S','Riverside','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(23947,'26273','S','Huttonsville','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.634407,-79.955699,0,'2013-07-06 12:44:31',NULL,NULL),(35570,'39567','S','Three Rivers','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(33874,'38017','S','Piperton','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.054102,-89.679063,0,'2013-07-06 12:44:32',NULL,NULL),(16800,'17543','S','Brickerville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(15281,'16117','S','Ellwood City','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.861599,-80.268252,0,'2013-07-06 12:44:31',NULL,NULL),(52366,'60614','S','Lincoln Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.923621,-87.653367,0,'2013-07-06 12:44:33',NULL,NULL),(17866,'18436','S','Jefferson Township','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(39186,'44319','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.987174,-81.531004,0,'2013-07-06 12:44:32',NULL,NULL),(2933,'01026','S','West Cummington','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.427860,-72.900300,0,'2013-07-06 12:44:30',NULL,NULL),(5290,'04538','S','Capitol Island','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.851438,-69.626454,0,'2013-07-06 12:44:30',NULL,NULL),(2249,'00926','S','Urb Litheda Hts','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(10617,'11050','S','Manorhaven','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(20480,'21043','S','Oella','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.266016,-76.845513,0,'2013-07-06 12:44:31',NULL,NULL),(44963,'50398','U','Marsh Inc','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.577582,-93.708707,0,'2013-07-06 12:44:32',NULL,NULL),(48358,'55487','U','Hennepin County Govt Ctr','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.978547,-93.265919,0,'2013-07-06 12:44:33',NULL,NULL),(60795,'72027','S','Middleton','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.401579,-92.560518,0,'2013-07-06 12:44:33',NULL,NULL),(61826,'73110','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460687,-97.397356,0,'2013-07-06 12:44:33',NULL,NULL),(76633,'95713','S','Shady Glen','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(432,'00662','S','Sect Pueblo Nuevo','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(55643,'64018','S','Camden Point','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.449535,-94.731841,0,'2013-07-06 12:44:33',NULL,NULL),(27067,'29690','S','Travelers Rst','A','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.004060,-82.435522,0,'2013-07-06 12:44:31',NULL,NULL),(50962,'58625','S','Dodge','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.300721,-102.177895,0,'2013-07-06 12:44:33',NULL,NULL),(51103,'58779','S','Ryder','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.851080,-101.789820,0,'2013-07-06 12:44:33',NULL,NULL),(69614,'83861','S','St Maries','A','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.316709,-116.572684,0,'2013-07-06 12:44:34',NULL,NULL),(80001,'99668','P','Sleetmute','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.596791,-157.045930,0,'2013-07-06 12:44:34',NULL,NULL),(37575,'42082','S','Symsonia','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.961114,-88.511278,0,'2013-07-06 12:44:32',NULL,NULL),(28836,'32084','S','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.885160,-81.313980,0,'2013-07-06 12:44:32',NULL,NULL),(24454,'27216','P','Burlington','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.081690,-79.412697,0,'2013-07-06 12:44:31',NULL,NULL),(10860,'11414','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.658635,-73.843765,0,'2013-07-06 12:44:30',NULL,NULL),(20574,'21152','S','Sparks','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.543240,-76.682820,0,'2013-07-06 12:44:31',NULL,NULL),(14748,'15317','S','McMurray','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.269407,-80.150995,0,'2013-07-06 12:44:31',NULL,NULL),(46950,'54171','S','Krakow','A','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.721600,-88.124160,0,'2013-07-06 12:44:32',NULL,NULL),(51481,'59546','S','Zortman','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.917430,-108.530180,0,'2013-07-06 12:44:33',NULL,NULL),(57903,'67648','S','Lucas','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.061163,-98.537771,0,'2013-07-06 12:44:33',NULL,NULL),(71446,'87041','S','Pena Blanca','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.638320,-106.348620,0,'2013-07-06 12:44:34',NULL,NULL),(71804,'87566','S','Pueblito','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(72308,'88589','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812479,-106.418331,0,'2013-07-06 12:44:34',NULL,NULL),(23587,'25672','S','Thacker','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.578967,-82.106525,0,'2013-07-06 12:44:31',NULL,NULL),(4351,'03048','S','Greenville','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.745620,-71.782200,0,'2013-07-06 12:44:30',NULL,NULL),(15851,'16940','P','Nelson','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.973794,-77.227277,0,'2013-07-06 12:44:31',NULL,NULL),(57923,'67669','S','Stockton','D','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.436278,-99.270791,0,'2013-07-06 12:44:33',NULL,NULL),(77575,'96913','S','Mangilao','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(61586,'72752','S','Pettigrew','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.839705,-93.597634,0,'2013-07-06 12:44:33',NULL,NULL),(7750,'07308','P','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.731521,-74.061754,0,'2013-07-06 12:44:30',NULL,NULL),(55352,'63559','S','Pure Air','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(25767,'28590','S','Winterville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.535325,-77.395248,0,'2013-07-06 12:44:31',NULL,NULL),(51327,'59260','S','Richland','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.715921,-106.267026,0,'2013-07-06 12:44:33',NULL,NULL),(41206,'46725','S','Ormas','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(73429,'91207','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169742,-118.240027,0,'2013-07-06 12:44:34',NULL,NULL),(38778,'44054','S','Sheffield Lk','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(12649,'13113','P','Meridian','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.162731,-76.538014,0,'2013-07-06 12:44:30',NULL,NULL),(53753,'62261','S','Prairie du Rocher','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.037120,-90.007380,0,'2013-07-06 12:44:33',NULL,NULL),(56376,'65230','S','Roanoke','N','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.269004,-92.703942,0,'2013-07-06 12:44:33',NULL,NULL),(59282,'70463','P','Sun','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.622959,-89.971746,0,'2013-07-06 12:44:33',NULL,NULL),(18427,'19063','S','Elwyn','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(33079,'36783','S','Thomaston','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.268145,-87.627712,0,'2013-07-06 12:44:32',NULL,NULL),(7180,'06461','S','Milford','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.264530,-73.078505,0,'2013-07-06 12:44:30',NULL,NULL),(29696,'32936','P','Eau Gallie','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.137568,-80.650157,0,'2013-07-06 12:44:32',NULL,NULL),(53007,'61454','S','Lomax','D','Henderson','17071','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.679418,-91.010819,0,'2013-07-06 12:44:33',NULL,NULL),(68973,'83110','S','Afton','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.720239,-110.943627,0,'2013-07-06 12:44:34',NULL,NULL),(36749,'41040','S','Goforth','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(28324,'31146','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.925442,-84.341206,0,'2013-07-06 12:44:31',NULL,NULL),(20596,'21204','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404090,-76.608279,0,'2013-07-06 12:44:31',NULL,NULL),(43177,'48279','U','Bank of America','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.327887,-83.042036,0,'2013-07-06 12:44:32',NULL,NULL),(77327,'96708','S','Haiku','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.911118,-156.297453,0,'2013-07-06 12:44:34',NULL,NULL),(41500,'46958','P','Mexico','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.824343,-86.115164,0,'2013-07-06 12:44:32',NULL,NULL),(31874,'35124','S','Pelham','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.301860,-86.791800,0,'2013-07-06 12:44:32',NULL,NULL),(29934,'33065','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.268785,-80.255243,0,'2013-07-06 12:44:32',NULL,NULL),(15717,'16868','P','Pine Grove Mills','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.730879,-77.886053,0,'2013-07-06 12:44:31',NULL,NULL),(20956,'21779','S','Gapland','A','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.438150,-77.659315,0,'2013-07-06 12:44:31',NULL,NULL),(48803,'56014','S','Bricelyn','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.562123,-93.814966,0,'2013-07-06 12:44:33',NULL,NULL),(51975,'60148','S','Lombard','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.869897,-88.011733,0,'2013-07-06 12:44:33',NULL,NULL),(57331,'66713','S','Lowell','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.022713,-94.739150,0,'2013-07-06 12:44:33',NULL,NULL),(62079,'73558','P','Meers','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.782945,-98.577817,0,'2013-07-06 12:44:33',NULL,NULL),(62913,'75076','S','Fink','N','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.772595,-96.668922,0,'2013-07-06 12:44:33',NULL,NULL),(72260,'88538','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.813386,-106.419114,0,'2013-07-06 12:44:34',NULL,NULL),(76227,'95378','P','Tracy','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.799140,-121.551767,0,'2013-07-06 12:44:34',NULL,NULL),(45024,'50461','S','Rock Creek','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.286734,-92.810092,0,'2013-07-06 12:44:32',NULL,NULL),(52568,'60960','S','Rankin','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.464320,-87.896604,0,'2013-07-06 12:44:33',NULL,NULL),(67888,'80863','S','Crystola','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.992976,-105.071027,0,'2013-07-06 12:44:34',NULL,NULL),(12469,'12981','S','Saranac','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.679046,-73.824306,0,'2013-07-06 12:44:30',NULL,NULL),(37234,'41544','S','Mc Carr','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.594087,-82.167909,0,'2013-07-06 12:44:32',NULL,NULL),(26440,'29130','S','Ridgeway','D','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.326001,-80.760553,0,'2013-07-06 12:44:31',NULL,NULL),(37264,'41568','S','Argo','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.519380,-82.054500,0,'2013-07-06 12:44:32',NULL,NULL),(68039,'80929','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.814846,-104.619185,0,'2013-07-06 12:44:34',NULL,NULL),(68443,'81225','P','Mt Crested Butte','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(32852,'36504','P','Atmore','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.019446,-87.479547,0,'2013-07-06 12:44:32',NULL,NULL),(8275,'08011','P','Birmingham','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.973028,-74.713019,0,'2013-07-06 12:44:30',NULL,NULL),(5163,'04426','S','Dvr Foxcroft','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(24944,'27825','P','Everetts','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.831579,-77.172397,0,'2013-07-06 12:44:31',NULL,NULL),(37300,'41635','S','Harold','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(28322,'31145','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.853136,-84.279625,0,'2013-07-06 12:44:31',NULL,NULL),(29952,'33073','S','Margate','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.305181,-80.187797,0,'2013-07-06 12:44:32',NULL,NULL),(30661,'33463','S','Greenacres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.593980,-80.127720,0,'2013-07-06 12:44:32',NULL,NULL),(32227,'35577','P','Natural Brg','A','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.088637,-87.604239,0,'2013-07-06 12:44:32',NULL,NULL),(49818,'57214','P','Badger','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.489359,-97.224349,0,'2013-07-06 12:44:33',NULL,NULL),(48921,'56145','S','Jeffers','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.056447,-95.196093,0,'2013-07-06 12:44:33',NULL,NULL),(45976,'52406','P','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.919897,-91.677991,0,'2013-07-06 12:44:32',NULL,NULL),(6930,'06160','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.771494,-72.707813,0,'2013-07-06 12:44:30',NULL,NULL),(40603,'45888','P','Uniopolis','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.601867,-84.084745,0,'2013-07-06 12:44:32',NULL,NULL),(10154,'10277','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.718432,-74.015507,0,'2013-07-06 12:44:30',NULL,NULL),(33463,'37325','S','Delano','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.251232,-84.623648,0,'2013-07-06 12:44:32',NULL,NULL),(61972,'73185','U','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.469690,-97.518506,0,'2013-07-06 12:44:33',NULL,NULL),(69432,'83639','S','Marsing','D','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.516707,-116.778404,0,'2013-07-06 12:44:34',NULL,NULL),(72719,'89460','S','Gardnerville','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.893575,-119.722788,0,'2013-07-06 12:44:34',NULL,NULL),(33,'00603','S','Urb Las Casitas Country Club','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(42062,'47448','S','Nashville','D','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(53822,'62298','S','Paderborn','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(35676,'39654','S','Tilton','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(75465,'94088','P','Onizuka AFB','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.390976,-122.037328,0,'2013-07-06 12:44:34',NULL,NULL),(3645,'02114','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.360587,-71.065447,0,'2013-07-06 12:44:30',NULL,NULL),(39386,'44654','S','Becks Mills','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.545778,-81.873263,0,'2013-07-06 12:44:32',NULL,NULL),(37884,'42602','S','Albany','D','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(37009,'41224','S','Threeforks','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.864560,-82.514588,0,'2013-07-06 12:44:32',NULL,NULL),(17465,'17948','S','Mahanoy Cty','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(31419,'34242','S','Siesta Key','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.270991,-82.547525,0,'2013-07-06 12:44:32',NULL,NULL),(31249,'33980','S','Port Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.978628,-82.059701,0,'2013-07-06 12:44:32',NULL,NULL),(29236,'32432','P','Cypress','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.710912,-85.074337,0,'2013-07-06 12:44:32',NULL,NULL),(11939,'12435','S','Greenfield Park','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.748780,-74.523180,0,'2013-07-06 12:44:30',NULL,NULL),(44206,'49630','S','Empire','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.837486,-86.032086,0,'2013-07-06 12:44:32',NULL,NULL),(44786,'50220','S','Berkley','N','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.840572,-94.098673,0,'2013-07-06 12:44:32',NULL,NULL),(46132,'52648','P','Pilot Grove','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.770301,-91.547576,0,'2013-07-06 12:44:32',NULL,NULL),(57968,'67764','S','Winona','D','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046384,-101.228293,0,'2013-07-06 12:44:33',NULL,NULL),(58621,'68860','S','East Custer','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.130711,-99.664931,0,'2013-07-06 12:44:33',NULL,NULL),(62105,'73628','S','Cheyenne','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.625120,-99.687180,0,'2013-07-06 12:44:33',NULL,NULL),(64899,'77085','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.623765,-95.493777,0,'2013-07-06 12:44:34',NULL,NULL),(68174,'81011','U','CO Lottery','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.276026,-104.610181,0,'2013-07-06 12:44:34',NULL,NULL),(72582,'89406','S','Carroll Station','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(74971,'93436','S','Vandenberg Village','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.651186,-120.435893,0,'2013-07-06 12:44:34',NULL,NULL),(78891,'98358','S','Marrowstone Island','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(7950,'07675','S','Westwood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.000621,-74.031463,0,'2013-07-06 12:44:30',NULL,NULL),(52347,'60603','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879623,-87.628479,0,'2013-07-06 12:44:33',NULL,NULL),(11162,'11722','S','S Hauppauge','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.779120,-73.191420,0,'2013-07-06 12:44:30',NULL,NULL),(75389,'93954','P','San Lucas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.124304,-121.021144,0,'2013-07-06 12:44:34',NULL,NULL),(26073,'28698','S','Mabel','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.331209,-81.739210,0,'2013-07-06 12:44:31',NULL,NULL),(54688,'62943','S','Wartrace','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(51767,'60033','S','Chemung','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.422653,-88.603857,0,'2013-07-06 12:44:33',NULL,NULL),(15985,'17033','S','Sandbeach','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(40073,'45277','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.028390,-84.519831,0,'2013-07-06 12:44:32',NULL,NULL),(18665,'19178','U','Wachovia Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953092,-75.184961,0,'2013-07-06 12:44:31',NULL,NULL),(13379,'13739','S','Bloomville','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.364324,-74.803449,0,'2013-07-06 12:44:31',NULL,NULL),(20491,'21054','S','Gambrills','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.036495,-76.671718,0,'2013-07-06 12:44:31',NULL,NULL),(43027,'48170','S','Plymouth','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.369118,-83.520276,0,'2013-07-06 12:44:32',NULL,NULL),(45829,'52211','S','Holiday Lake','N','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.729084,-92.445540,0,'2013-07-06 12:44:32',NULL,NULL),(58065,'68047','S','Pender','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.112399,-96.711991,0,'2013-07-06 12:44:33',NULL,NULL),(70185,'84333','S','Richmond','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.920704,-111.806595,0,'2013-07-06 12:44:34',NULL,NULL),(70547,'85031','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.495264,-112.170694,0,'2013-07-06 12:44:34',NULL,NULL),(72012,'88042','S','Kingston','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.916944,-107.705556,0,'2013-07-06 12:44:34',NULL,NULL),(34049,'38137','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.110214,-89.891356,0,'2013-07-06 12:44:32',NULL,NULL),(64860,'77055','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.797867,-95.497137,0,'2013-07-06 12:44:34',NULL,NULL),(16617,'17331','S','Hershey Heights','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(25716,'28543','S','Tarawa','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.734194,-77.377379,0,'2013-07-06 12:44:31',NULL,NULL),(52853,'61325','S','Farm Ridge','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.229420,-88.790820,0,'2013-07-06 12:44:33',NULL,NULL),(67776,'80648','S','Nunn','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.753345,-104.741291,0,'2013-07-06 12:44:34',NULL,NULL),(63663,'75851','S','Lovelady','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.101806,-95.519930,0,'2013-07-06 12:44:34',NULL,NULL),(15456,'16411','S','East Springfield','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.983870,-80.436629,0,'2013-07-06 12:44:31',NULL,NULL),(35086,'39204','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.285241,-90.230923,0,'2013-07-06 12:44:32',NULL,NULL),(32131,'35447','S','Carrollton','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.224370,-88.073930,0,'2013-07-06 12:44:32',NULL,NULL),(31247,'33976','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.612085,-81.663866,0,'2013-07-06 12:44:32',NULL,NULL),(31159,'33917','S','Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(25309,'28152','S','Shelby','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.254700,-81.560764,0,'2013-07-06 12:44:31',NULL,NULL),(19636,'20261','U','USPS Consumer Affairs','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885689,-77.019097,0,'2013-07-06 12:44:31',NULL,NULL),(44785,'50219','S','Pella','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.408313,-92.914645,0,'2013-07-06 12:44:32',NULL,NULL),(46778,'53954','S','Pardeeville','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.531481,-89.316283,0,'2013-07-06 12:44:32',NULL,NULL),(69592,'83844','U','University of Idaho','N','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.730287,-116.996847,0,'2013-07-06 12:44:34',NULL,NULL),(78516,'98118','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.541963,-122.267649,0,'2013-07-06 12:44:34',NULL,NULL),(79890,'99579','P','Egegik','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.161585,-157.193513,0,'2013-07-06 12:44:34',NULL,NULL),(80072,'99727','P','Buckland','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.842421,-160.704188,0,'2013-07-06 12:44:34',NULL,NULL),(5572,'04865','P','West Rockport','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.189569,-69.151833,0,'2013-07-06 12:44:30',NULL,NULL),(60455,'71653','S','Gaines Landing','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(12107,'12581','S','Stanfordville','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.890719,-73.666476,0,'2013-07-06 12:44:30',NULL,NULL),(10054,'10176','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(58916,'69334','S','Bayard','D','Morrill','31123','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.759415,-103.322311,0,'2013-07-06 12:44:33',NULL,NULL),(44769,'50208','S','Newton','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.697096,-93.046897,0,'2013-07-06 12:44:32',NULL,NULL),(22763,'24433','S','Doe Hill','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.395846,-79.485644,0,'2013-07-06 12:44:31',NULL,NULL),(73557,'91362','S','Thousand Oaks','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.192920,-118.822620,0,'2013-07-06 12:44:34',NULL,NULL),(2035,'00917','S','Urb Umpierre','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(19444,'20112','S','Manassas','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.673619,-77.426750,0,'2013-07-06 12:44:31',NULL,NULL),(2937,'01027','S','Mount Tom','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.291420,-72.717720,0,'2013-07-06 12:44:30',NULL,NULL),(36919,'41144','S','Lloyd','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.572275,-82.812737,0,'2013-07-06 12:44:32',NULL,NULL),(28128,'30817','S','Amity','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(23232,'25090','P','Glen Ferris','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.152850,-81.213882,0,'2013-07-06 12:44:31',NULL,NULL),(42890,'48095','S','Washington Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.783484,-83.041714,0,'2013-07-06 12:44:32',NULL,NULL),(44089,'49459','S','Walkerville','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.741411,-86.008534,0,'2013-07-06 12:44:32',NULL,NULL),(61232,'72331','S','Earle','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.269497,-90.461420,0,'2013-07-06 12:44:33',NULL,NULL),(76947,'96031','S','Forks of Salmon','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.218476,-123.245773,0,'2013-07-06 12:44:34',NULL,NULL),(38295,'43342','S','Prospect','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.474050,-83.175188,0,'2013-07-06 12:44:32',NULL,NULL),(33480,'37339','S','Gruetli Laager','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.372500,-85.598889,0,'2013-07-06 12:44:32',NULL,NULL),(7787,'07424','S','Singac','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(43659,'48852','P','Mcbride','A','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.350739,-85.050680,0,'2013-07-06 12:44:32',NULL,NULL),(13372,'13736','S','Jenksville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.313800,-76.190640,0,'2013-07-06 12:44:31',NULL,NULL),(59750,'71151','U','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.514610,-93.747269,0,'2013-07-06 12:44:33',NULL,NULL),(36236,'40293','S','Jp Morgan Chase','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258971,-85.758075,0,'2013-07-06 12:44:32',NULL,NULL),(32264,'35630','S','Saint Florian','A','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.819157,-87.658805,0,'2013-07-06 12:44:32',NULL,NULL),(22443,'24019','S','Hollins Clg','A','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.337160,-79.951680,0,'2013-07-06 12:44:31',NULL,NULL),(21246,'22244','U','Assistant Secretary of Navy','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855120,-77.050263,0,'2013-07-06 12:44:31',NULL,NULL),(78644,'98223','S','Oso','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.181800,-121.979640,0,'2013-07-06 12:44:34',NULL,NULL),(11439,'11971','S','Southold','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.057698,-72.415683,0,'2013-07-06 12:44:30',NULL,NULL),(37535,'42051','S','Viola','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(16739,'17504','P','Bausman','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.025640,-76.328043,0,'2013-07-06 12:44:31',NULL,NULL),(33536,'37385','S','Tellico Plains','D','Monroe','47123','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.338706,-84.234031,0,'2013-07-06 12:44:32',NULL,NULL),(16345,'17130','U','Pheaa','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.273135,-76.888847,0,'2013-07-06 12:44:31',NULL,NULL),(14437,'15087','P','Webster','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.187980,-79.850222,0,'2013-07-06 12:44:31',NULL,NULL),(20324,'20833','S','Unity','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.206400,-77.050740,0,'2013-07-06 12:44:31',NULL,NULL),(20734,'21288','U','Household Bank','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.291729,-76.608616,0,'2013-07-06 12:44:31',NULL,NULL),(47356,'54614','S','Bangor','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.890535,-90.983181,0,'2013-07-06 12:44:32',NULL,NULL),(51529,'59716','P','Big Sky','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.264965,-111.253120,0,'2013-07-06 12:44:33',NULL,NULL),(31796,'35040','S','Calera','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.151899,-86.719204,0,'2013-07-06 12:44:32',NULL,NULL),(30659,'33462','S','Manalapan','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.581130,-80.079020,0,'2013-07-06 12:44:32',NULL,NULL),(26904,'29577','S','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.660600,-78.923940,0,'2013-07-06 12:44:31',NULL,NULL),(24568,'27306','S','Wadeville','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.269440,-79.974000,0,'2013-07-06 12:44:31',NULL,NULL),(23813,'26056','P','New Manchestr','A','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.532923,-80.580463,0,'2013-07-06 12:44:31',NULL,NULL),(44522,'49950','S','Eagle River','A','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.316535,-88.344835,0,'2013-07-06 12:44:32',NULL,NULL),(57158,'66282','P','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.953539,-94.688284,0,'2013-07-06 12:44:33',NULL,NULL),(69334,'83531','P','Fenn','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.926329,-116.125155,0,'2013-07-06 12:44:34',NULL,NULL),(78089,'97477','S','Springfield','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.065622,-123.014262,0,'2013-07-06 12:44:34',NULL,NULL),(36277,'40340','P','Nicholasville','D','Jessamine','21113','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.878264,-84.578028,0,'2013-07-06 12:44:32',NULL,NULL),(56317,'65103','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578727,-92.174092,0,'2013-07-06 12:44:33',NULL,NULL),(33110,'36859','P','Holy Trinity','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.170732,-85.128717,0,'2013-07-06 12:44:32',NULL,NULL),(23907,'26208','S','Camden on Gauley','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.375220,-80.572320,0,'2013-07-06 12:44:31',NULL,NULL),(77220,'96389','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(48955,'56175','S','Tracy','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.234148,-95.619944,0,'2013-07-06 12:44:33',NULL,NULL),(8516,'08104','S','South Camden','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.919931,-75.108157,0,'2013-07-06 12:44:30',NULL,NULL),(17491,'17960','S','McKeansburg','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(37510,'42038','S','Confederate','N','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.045200,-88.050120,0,'2013-07-06 12:44:32',NULL,NULL),(36436,'40598','U','Amazon.com','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.050332,-84.497840,0,'2013-07-06 12:44:32',NULL,NULL),(3271,'01469','S','Townsend','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.653698,-71.691559,0,'2013-07-06 12:44:30',NULL,NULL),(14915,'15538','S','Glencoe','A','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.903600,-78.832680,0,'2013-07-06 12:44:31',NULL,NULL),(37632,'42159','S','Oakland','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.998289,-86.256896,0,'2013-07-06 12:44:32',NULL,NULL),(36406,'40514','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.981959,-84.570615,0,'2013-07-06 12:44:32',NULL,NULL),(22376,'23927','S','Clarksville','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.603986,-78.534312,0,'2013-07-06 12:44:31',NULL,NULL),(33231,'37066','S','Gallatin','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.389876,-86.454091,0,'2013-07-06 12:44:32',NULL,NULL),(30075,'33154','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(44348,'49775','S','Point Aux Pin','A','Mackinac','26097','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.764363,-84.467304,0,'2013-07-06 12:44:32',NULL,NULL),(52176,'60459','S','Oak Lawn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745512,-87.772445,0,'2013-07-06 12:44:33',NULL,NULL),(67543,'80260','S','Westminster','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(76825,'95959','S','Cherokee','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.273440,-121.022061,0,'2013-07-06 12:44:34',NULL,NULL),(737,'00690','S','Parq Ind San Antonio','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(41194,'46723','S','Blue Lake','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.222797,-85.273777,0,'2013-07-06 12:44:32',NULL,NULL),(2994,'01066','P','N Hatfield','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.410613,-72.625559,0,'2013-07-06 12:44:30',NULL,NULL),(2058,'00920','S','Puerto Nuevo','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(66170,'78520','S','Palm Village','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(77147,'96161','S','Prosser Lakeview','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(27700,'30339','S','Sandy Spgs','A','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(63600,'75792','S','Starrville','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.455404,-95.128624,0,'2013-07-06 12:44:34',NULL,NULL),(50738,'58401','S','Bloom','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(30405,'33324','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110295,-80.270027,0,'2013-07-06 12:44:32',NULL,NULL),(40984,'46349','S','Lake Village','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.127882,-87.461946,0,'2013-07-06 12:44:32',NULL,NULL),(30953,'33733','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770605,-82.677731,0,'2013-07-06 12:44:32',NULL,NULL),(7840,'07461','S','Wantage','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(2499,'00957','S','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(49184,'56437','S','Bertha','D','Todd','27153','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.215448,-95.049762,0,'2013-07-06 12:44:33',NULL,NULL),(50305,'57706','S','Ellsworth AFB','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.150732,-103.071312,0,'2013-07-06 12:44:33',NULL,NULL),(70746,'85318','P','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.660359,-112.184575,0,'2013-07-06 12:44:34',NULL,NULL),(60745,'71969','S','Gibbs','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.668050,-93.666032,0,'2013-07-06 12:44:33',NULL,NULL),(59292,'70502','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.224108,-92.022604,0,'2013-07-06 12:44:33',NULL,NULL),(54317,'62722','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797223,-89.653566,0,'2013-07-06 12:44:33',NULL,NULL),(50653,'58324','S','Cando','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.488286,-99.201112,0,'2013-07-06 12:44:33',NULL,NULL),(73346,'91003','P','Altadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.185055,-118.130218,0,'2013-07-06 12:44:34',NULL,NULL),(17751,'18325','S','Canadensis','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.245123,-75.227545,0,'2013-07-06 12:44:31',NULL,NULL),(17056,'17754','S','Lyc Co Airprt','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(51628,'59848','S','Lonepine','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.672451,-114.665611,0,'2013-07-06 12:44:33',NULL,NULL),(50809,'58456','S','Kulm','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.298329,-98.948073,0,'2013-07-06 12:44:33',NULL,NULL),(22315,'23839','S','Dendron','D','Surry','51181','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.999427,-76.963096,0,'2013-07-06 12:44:31',NULL,NULL),(32180,'35486','P','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.206738,-87.539186,0,'2013-07-06 12:44:32',NULL,NULL),(25837,'28619','P','Drexel','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753757,-81.606879,0,'2013-07-06 12:44:31',NULL,NULL),(7282,'06532','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.319206,-72.926573,0,'2013-07-06 12:44:30',NULL,NULL),(37372,'41731','S','Wentz','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.124133,-83.036516,0,'2013-07-06 12:44:32',NULL,NULL),(36796,'41054','P','Mason','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.578368,-84.584337,0,'2013-07-06 12:44:32',NULL,NULL),(33769,'37865','S','Seymour','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.863635,-83.739635,0,'2013-07-06 12:44:32',NULL,NULL),(33194,'37040','S','Clarksville','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.532026,-87.350258,0,'2013-07-06 12:44:32',NULL,NULL),(28411,'31321','S','Pembroke','D','Bryan','13029','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.134586,-81.628588,0,'2013-07-06 12:44:32',NULL,NULL),(52329,'60564','S','Naperville','D','Will','17197','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.710744,-88.200262,0,'2013-07-06 12:44:33',NULL,NULL),(63627,'75835','S','Hopewell','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(68897,'82721','S','Pine Haven','A','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.588080,-104.937920,0,'2013-07-06 12:44:34',NULL,NULL),(77348,'96727','S','Honokaa','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.087407,-155.518923,0,'2013-07-06 12:44:34',NULL,NULL),(33044,'36750','S','Maplesville','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.790938,-86.872036,0,'2013-07-06 12:44:32',NULL,NULL),(42900,'48099','P','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.561732,-83.146470,0,'2013-07-06 12:44:32',NULL,NULL),(68650,'81642','S','Meredith','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.343479,-106.678875,0,'2013-07-06 12:44:34',NULL,NULL),(56949,'66094','S','White Cloud','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.944895,-95.286941,0,'2013-07-06 12:44:33',NULL,NULL),(56759,'65732','S','Preston','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.944168,-93.163517,0,'2013-07-06 12:44:33',NULL,NULL),(51819,'60051','S','McHenry','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.342172,-88.289042,0,'2013-07-06 12:44:33',NULL,NULL),(50179,'57559','S','Van Metre','N','Jones','46075','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.958192,-100.699101,0,'2013-07-06 12:44:33',NULL,NULL),(6782,'06105','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.769774,-72.699048,0,'2013-07-06 12:44:30',NULL,NULL),(40163,'45361','P','Potsdam','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.961989,-84.414577,0,'2013-07-06 12:44:32',NULL,NULL),(31885,'35130','S','Praco','N','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.570865,-87.165507,0,'2013-07-06 12:44:32',NULL,NULL),(29565,'32815','P','Kennedy Sp Ct','A','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.592290,-80.656063,0,'2013-07-06 12:44:32',NULL,NULL),(1525,'00754','S','Urb Munoz Marin','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(43143,'48238','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.395040,-83.141885,0,'2013-07-06 12:44:32',NULL,NULL),(45876,'52251','S','Ladora','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.760470,-92.197012,0,'2013-07-06 12:44:32',NULL,NULL),(47690,'54967','S','Poy Sippi','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.121602,-88.924124,0,'2013-07-06 12:44:33',NULL,NULL),(48963,'56185','S','Wilmont','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.774250,-95.832133,0,'2013-07-06 12:44:33',NULL,NULL),(64324,'76487','S','Poolville','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.969424,-97.882911,0,'2013-07-06 12:44:34',NULL,NULL),(67874,'80834','S','Seibert','D','Kit Carson','08063','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.284699,-102.885676,0,'2013-07-06 12:44:34',NULL,NULL),(73088,'90221','S','E Rncho Dmngz','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.879540,-118.200540,0,'2013-07-06 12:44:34',NULL,NULL),(37678,'42215','S','Cerulean','D','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.994321,-87.648220,0,'2013-07-06 12:44:32',NULL,NULL),(17308,'17855','S','New Berlin','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.883152,-76.982883,0,'2013-07-06 12:44:31',NULL,NULL),(9593,'10029','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(1267,'00730','S','Bda Ferran','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(3725,'02151','S','Revere','D','Suffolk','25025','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.415223,-71.005325,0,'2013-07-06 12:44:30',NULL,NULL),(33817,'37921','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.972950,-83.986531,0,'2013-07-06 12:44:32',NULL,NULL),(24039,'26408','S','Mount Clare','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.199128,-80.270155,0,'2013-07-06 12:44:31',NULL,NULL),(76053,'95192','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.341891,-121.890214,0,'2013-07-06 12:44:34',NULL,NULL),(407,'00662','S','Parc Mora Guerrero','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(42765,'48035','S','Clinton Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.552959,-82.911875,0,'2013-07-06 12:44:32',NULL,NULL),(14248,'14824','S','Cayuta','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.276635,-76.701930,0,'2013-07-06 12:44:31',NULL,NULL),(30946,'33729','U','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878378,-82.669082,0,'2013-07-06 12:44:32',NULL,NULL),(26952,'29605','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.799312,-82.391757,0,'2013-07-06 12:44:31',NULL,NULL),(7076,'06340','S','Groton Long Point','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(45406,'51045','P','Oyens','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.822848,-96.057827,0,'2013-07-06 12:44:32',NULL,NULL),(49670,'57007','U','Sd State Univ','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.306715,-96.786041,0,'2013-07-06 12:44:33',NULL,NULL),(52915,'61364','S','Streator East','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(65419,'77575','S','Liberty','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.067839,-94.789652,0,'2013-07-06 12:44:34',NULL,NULL),(68077,'80938','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.797690,-104.837067,0,'2013-07-06 12:44:34',NULL,NULL),(72769,'89523','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.525676,-119.890959,0,'2013-07-06 12:44:34',NULL,NULL),(878,'00698','S','Vistas Del Palmar','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(57831,'67544','S','Hoisington','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.607687,-98.840160,0,'2013-07-06 12:44:33',NULL,NULL),(39520,'44818','S','Bloomville','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.013780,-82.990920,0,'2013-07-06 12:44:32',NULL,NULL),(55665,'64034','S','Greenwood','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.849040,-94.287060,0,'2013-07-06 12:44:33',NULL,NULL),(46755,'53932','S','Fall River','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.384756,-89.045623,0,'2013-07-06 12:44:32',NULL,NULL),(6642,'06013','S','Burlington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760236,-72.950679,0,'2013-07-06 12:44:30',NULL,NULL),(38206,'43212','S','Upper Arlington','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(36816,'41061','P','Milford','D','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.582646,-84.154860,0,'2013-07-06 12:44:32',NULL,NULL),(9923,'10151','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(34007,'38122','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.158002,-89.923644,0,'2013-07-06 12:44:32',NULL,NULL),(49389,'56601','S','Turtle River','A','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(70483,'84767','P','Zion Ntl Park','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.185515,-112.998069,0,'2013-07-06 12:44:34',NULL,NULL),(75634,'94515','S','Calistoga','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.584631,-122.568980,0,'2013-07-06 12:44:34',NULL,NULL),(36506,'40823','S','Oven Fork','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.975189,-82.986975,0,'2013-07-06 12:44:32',NULL,NULL),(59901,'71276','S','Sondheimer','D','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.571944,-91.182222,0,'2013-07-06 12:44:33',NULL,NULL),(56760,'65733','S','Protem','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.559987,-92.847701,0,'2013-07-06 12:44:33',NULL,NULL),(50597,'58244','S','Inkster','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.116880,-97.723380,0,'2013-07-06 12:44:33',NULL,NULL),(74430,'92563','S','Murrieta','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.564738,-117.171595,0,'2013-07-06 12:44:34',NULL,NULL),(19899,'20541','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.888643,-77.007109,0,'2013-07-06 12:44:31',NULL,NULL),(29004,'32222','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.222818,-81.815888,0,'2013-07-06 12:44:32',NULL,NULL),(3137,'01252','P','No Egremont','N','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.196701,-73.436284,0,'2013-07-06 12:44:30',NULL,NULL),(70011,'84126','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700114,-111.948523,0,'2013-07-06 12:44:34',NULL,NULL),(64955,'77238','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.920983,-95.443148,0,'2013-07-06 12:44:34',NULL,NULL),(40676,'46058','S','Mulberry','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.371179,-86.626904,0,'2013-07-06 12:44:32',NULL,NULL),(35727,'39701','S','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(31490,'34434','S','Dunnellon','D','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.998415,-82.431555,0,'2013-07-06 12:44:32',NULL,NULL),(31185,'33931','S','Ft Myers Bch','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.447226,-81.931788,0,'2013-07-06 12:44:32',NULL,NULL),(13815,'14213','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.917852,-78.889241,0,'2013-07-06 12:44:31',NULL,NULL),(28903,'32134','S','Fort Mc Coy','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.365867,-81.885231,0,'2013-07-06 12:44:32',NULL,NULL),(44900,'50323','S','Urbandale','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.626717,-93.801260,0,'2013-07-06 12:44:32',NULL,NULL),(46246,'53003','P','Ashippun','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.213134,-88.516950,0,'2013-07-06 12:44:32',NULL,NULL),(54497,'62864','S','Mount Vernon','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(64482,'76598','U','Gatesville','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.445596,-97.743272,0,'2013-07-06 12:44:34',NULL,NULL),(71892,'87742','S','Rociada','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.850000,-105.433333,0,'2013-07-06 12:44:34',NULL,NULL),(75962,'95050','S','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.349491,-121.957826,0,'2013-07-06 12:44:34',NULL,NULL),(7439,'06831','S','Greenwich','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.058575,-73.658439,0,'2013-07-06 12:44:30',NULL,NULL),(12851,'13317','S','Flat Creek','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(23792,'26003','S','Overbrook','A','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(61175,'72199','U','No Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.785804,-92.255214,0,'2013-07-06 12:44:33',NULL,NULL),(10326,'10546','S','Millwood','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.198444,-73.801573,0,'2013-07-06 12:44:30',NULL,NULL),(65426,'77581','S','Brookside Vl','A','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.560076,-95.275452,0,'2013-07-06 12:44:34',NULL,NULL),(19471,'20139','P','Casanova','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.660390,-77.715837,0,'2013-07-06 12:44:31',NULL,NULL),(28408,'31319','P','Valona','A','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421746,-81.423676,0,'2013-07-06 12:44:32',NULL,NULL),(27851,'30434','S','Vidette','N','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.000236,-82.407759,0,'2013-07-06 12:44:31',NULL,NULL),(8257,'08008','S','High Bar Harbor','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(4538,'03445','S','East Sullivan','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.995925,-72.191513,0,'2013-07-06 12:44:30',NULL,NULL),(42631,'47909','S','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.323451,-86.883198,0,'2013-07-06 12:44:32',NULL,NULL),(53223,'61635','U','IL Central College','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.708299,-89.522384,0,'2013-07-06 12:44:33',NULL,NULL),(54162,'62601','S','Alexander','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.731933,-90.038036,0,'2013-07-06 12:44:33',NULL,NULL),(56358,'65203','S','Easley','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.929931,-92.372948,0,'2013-07-06 12:44:33',NULL,NULL),(74934,'93407','S','Cal Poly SLO','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.298873,-120.658799,0,'2013-07-06 12:44:34',NULL,NULL),(76070,'95205','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.958243,-121.224519,0,'2013-07-06 12:44:34',NULL,NULL),(8462,'08088','S','Shamong','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(22507,'24079','S','Copper Hill','D','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.078372,-80.150507,0,'2013-07-06 12:44:31',NULL,NULL),(6927,'06156','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.758950,-72.732086,0,'2013-07-06 12:44:30',NULL,NULL),(44106,'49503','S','Wyoming','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963193,-85.659686,0,'2013-07-06 12:44:32',NULL,NULL),(78889,'98358','S','Indian Island','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(65060,'77341','U','Sam Houston State Univ','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.714355,-95.543506,0,'2013-07-06 12:44:34',NULL,NULL),(218,'00624','S','Sect Mal Paso','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(39361,'44632','S','Hartville','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.959926,-81.326086,0,'2013-07-06 12:44:32',NULL,NULL),(7496,'06914','U','Shared Zip For Brm','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.099971,-73.551538,0,'2013-07-06 12:44:30',NULL,NULL),(24210,'26704','S','Augusta','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.297814,-78.593960,0,'2013-07-06 12:44:31',NULL,NULL),(44049,'49430','P','Lamont','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.006717,-85.895150,0,'2013-07-06 12:44:32',NULL,NULL),(44555,'50009','S','Ivy','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.649151,-93.469244,0,'2013-07-06 12:44:32',NULL,NULL),(46276,'53032','S','Horicon','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.450498,-88.630976,0,'2013-07-06 12:44:32',NULL,NULL),(58353,'68507','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.850262,-96.626115,0,'2013-07-06 12:44:33',NULL,NULL),(65084,'77354','S','Magnolia','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.221346,-95.676720,0,'2013-07-06 12:44:34',NULL,NULL),(65955,'78268','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.470275,-98.617172,0,'2013-07-06 12:44:34',NULL,NULL),(65222,'77445','S','Hempstead','D','Waller','48473','Texas','TX','48','3360','979','Central',-6.0,'Y',30.072120,-96.081240,0,'2013-07-06 12:44:34',NULL,NULL),(10882,'11420','S','South Ozone Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674361,-73.813156,0,'2013-07-06 12:44:30',NULL,NULL),(65320,'77512','P','Alvin','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.421732,-95.247860,0,'2013-07-06 12:44:34',NULL,NULL),(50801,'58448','S','Revere','N','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.269722,-98.194167,0,'2013-07-06 12:44:33',NULL,NULL),(47963,'55121','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.848185,-93.145649,0,'2013-07-06 12:44:33',NULL,NULL),(46368,'53121','S','Elkhorn','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.682649,-88.539027,0,'2013-07-06 12:44:32',NULL,NULL),(54304,'62707','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(51991,'60157','S','Medinah','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.971617,-88.048633,0,'2013-07-06 12:44:33',NULL,NULL),(51264,'59088','S','Worden','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.988790,-108.173617,0,'2013-07-06 12:44:33',NULL,NULL),(47652,'54932','S','Eldorado','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.848173,-88.647961,0,'2013-07-06 12:44:33',NULL,NULL),(70206,'84401','S','Marriott-Slaterville City','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(78788,'98314','U','Bremerton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.560627,-122.648934,0,'2013-07-06 12:44:34',NULL,NULL),(5591,'04920','S','Pleasant Ridge Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.128441,-69.858003,0,'2013-07-06 12:44:30',NULL,NULL),(24927,'27810','S','Belhaven','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.540971,-76.618888,0,'2013-07-06 12:44:31',NULL,NULL),(24715,'27505','S','Broadway','D','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459283,-79.053129,0,'2013-07-06 12:44:31',NULL,NULL),(24248,'26767','S','Wiley Ford','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.614510,-78.761574,0,'2013-07-06 12:44:31',NULL,NULL),(21584,'22841','S','Crosskeys','N','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.350903,-78.955919,0,'2013-07-06 12:44:31',NULL,NULL),(10764,'11363','S','Little Neck','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.773215,-73.746899,0,'2013-07-06 12:44:30',NULL,NULL),(12004,'12492','S','West Kill','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.191667,-74.308056,0,'2013-07-06 12:44:30',NULL,NULL),(12463,'12977','P','Ray Brook','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.299084,-74.086284,0,'2013-07-06 12:44:30',NULL,NULL),(53981,'62439','S','Pinkstaff','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(59563,'70833','U','Louisiana Lottery','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.407464,-91.142909,0,'2013-07-06 12:44:33',NULL,NULL),(3160,'01264','P','Tyringham','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.243506,-73.205466,0,'2013-07-06 12:44:30',NULL,NULL),(19146,'19706','P','Delaware City','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.571134,-75.597542,0,'2013-07-06 12:44:31',NULL,NULL),(24964,'27841','P','Hassell','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.905492,-77.278880,0,'2013-07-06 12:44:31',NULL,NULL),(46840,'54017','S','Huntington','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(77828,'97211','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.568836,-122.642627,0,'2013-07-06 12:44:34',NULL,NULL),(20173,'20745','S','Forest Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.807841,-76.989145,0,'2013-07-06 12:44:31',NULL,NULL),(25293,'28139','S','Logan Station','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(73837,'91786','S','Upland','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.103660,-117.661893,0,'2013-07-06 12:44:34',NULL,NULL),(46313,'53066','S','Summit','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.105369,-88.479152,0,'2013-07-06 12:44:32',NULL,NULL),(6166,'05473','S','Kimballs','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(23348,'25259','S','Tariff','A','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.665790,-81.296596,0,'2013-07-06 12:44:31',NULL,NULL),(47168,'54475','S','Rudolph','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.479985,-89.802355,0,'2013-07-06 12:44:32',NULL,NULL),(54063,'62478','S','West York','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.206796,-87.728257,0,'2013-07-06 12:44:33',NULL,NULL),(67569,'80299','S','Western Area USPS','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.746870,-104.993120,0,'2013-07-06 12:44:34',NULL,NULL),(72208,'88419','S','Folsom','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.909886,-103.806885,0,'2013-07-06 12:44:34',NULL,NULL),(76682,'95814','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.582714,-121.489396,0,'2013-07-06 12:44:34',NULL,NULL),(58428,'68662','S','Shelby','D','Polk','31143','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.267341,-97.434860,0,'2013-07-06 12:44:33',NULL,NULL),(36080,'40215','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192575,-85.784280,0,'2013-07-06 12:44:32',NULL,NULL),(26297,'29030','S','Lone Star','A','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.550000,-80.710000,0,'2013-07-06 12:44:31',NULL,NULL),(16008,'17040','S','Landisburg','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.311569,-77.333589,0,'2013-07-06 12:44:31',NULL,NULL),(15540,'16611','S','Barree','A','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.556814,-78.096428,0,'2013-07-06 12:44:31',NULL,NULL),(68964,'83012','S','Jenny Lake','A','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.602951,-110.740568,0,'2013-07-06 12:44:34',NULL,NULL),(45605,'51560','S','Oakland','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.306383,-95.392741,0,'2013-07-06 12:44:32',NULL,NULL),(23978,'26306','U','Clarksburg','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281890,-80.332998,0,'2013-07-06 12:44:31',NULL,NULL),(77150,'96162','P','Donner','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.307577,-120.314785,0,'2013-07-06 12:44:34',NULL,NULL),(19624,'20244','U','Geological Survey','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914896,-76.996272,0,'2013-07-06 12:44:31',NULL,NULL),(37825,'42437','S','Morganfld','N','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.645920,-87.902700,0,'2013-07-06 12:44:32',NULL,NULL),(78708,'98266','S','Maple Falls','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.928922,-122.149469,0,'2013-07-06 12:44:34',NULL,NULL),(79625,'99123','S','Electric City','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.932095,-119.028984,0,'2013-07-06 12:44:34',NULL,NULL),(15335,'16223','P','Distant','D','Armstrong','42005','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.973111,-79.357155,0,'2013-07-06 12:44:31',NULL,NULL),(26413,'29115','S','Pecan Way Terrace','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.581944,-80.818056,0,'2013-07-06 12:44:31',NULL,NULL),(57286,'66609','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.991057,-95.654530,0,'2013-07-06 12:44:33',NULL,NULL),(43673,'48862','P','North Star','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.246419,-84.546396,0,'2013-07-06 12:44:32',NULL,NULL),(70721,'85287','U','Arizona State Univ','N','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.428352,-111.932123,0,'2013-07-06 12:44:34',NULL,NULL),(67672,'80498','S','Silverthorne','D','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.060000,-106.400000,0,'2013-07-06 12:44:34',NULL,NULL),(70934,'85637','S','Sonoita','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.622239,-110.706222,0,'2013-07-06 12:44:34',NULL,NULL),(14638,'15234','S','Castle Shann','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(51683,'59930','S','Rexford','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.917495,-115.173530,0,'2013-07-06 12:44:33',NULL,NULL),(23204,'25064','S','Dunbar','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.365209,-81.740204,0,'2013-07-06 12:44:31',NULL,NULL),(4133,'02747','S','N Dartmouth','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.645940,-70.997460,0,'2013-07-06 12:44:30',NULL,NULL),(14374,'15028','P','Coulters','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.297884,-79.801998,0,'2013-07-06 12:44:31',NULL,NULL),(57412,'66771','S','Saint Paul','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.517288,-95.169242,0,'2013-07-06 12:44:33',NULL,NULL),(52,'00606','S','Urb San Juan Bautista','N','Maricao','72093','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.185616,-66.977377,0,'2013-07-06 12:44:30',NULL,NULL),(35775,'39744','S','Grady','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(22831,'24514','U','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.365835,-79.215293,0,'2013-07-06 12:44:31',NULL,NULL),(19094,'19605','S','Berkley','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(49920,'57319','S','Dolton','A','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.529100,-97.446420,0,'2013-07-06 12:44:33',NULL,NULL),(43903,'49248','S','Jasper','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.767239,-84.012049,0,'2013-07-06 12:44:32',NULL,NULL),(78251,'97834','S','Halfway','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.960212,-117.126587,0,'2013-07-06 12:44:34',NULL,NULL),(4331,'02921','S','Cranston','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.759180,-71.506674,0,'2013-07-06 12:44:30',NULL,NULL),(74815,'93219','S','Allensworth','N','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.887086,-119.278166,0,'2013-07-06 12:44:34',NULL,NULL),(77704,'97049','S','Rhododendron','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.369060,-121.922640,0,'2013-07-06 12:44:34',NULL,NULL),(41,'00603','S','Villa Alegria','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(21265,'22307','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.772576,-77.056869,0,'2013-07-06 12:44:31',NULL,NULL),(64416,'76550','S','Lake Victor','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.066265,-98.180696,0,'2013-07-06 12:44:34',NULL,NULL),(64016,'76118','S','N Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(18850,'19436','S','Gwynedd','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.206010,-75.247779,0,'2013-07-06 12:44:31',NULL,NULL),(57888,'67634','S','Dorrance','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.846172,-98.586240,0,'2013-07-06 12:44:33',NULL,NULL),(31067,'33849','S','Kathleen','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.159532,-82.037045,0,'2013-07-06 12:44:32',NULL,NULL),(53472,'61933','S','Kansas','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.555979,-87.938472,0,'2013-07-06 12:44:33',NULL,NULL),(52751,'61244','S','E Moline','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(13938,'14433','S','Clyde','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.081270,-76.869374,0,'2013-07-06 12:44:31',NULL,NULL),(8738,'08518','S','Florence','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.113396,-74.806842,0,'2013-07-06 12:44:30',NULL,NULL),(7940,'07660','S','Ridgefield Pk','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.856838,-74.019390,0,'2013-07-06 12:44:30',NULL,NULL),(10513,'10977','S','Chestnut Rdg','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(23097,'24931','S','Crawley','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.880631,-80.587119,0,'2013-07-06 12:44:31',NULL,NULL),(10147,'10274','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.705920,-74.012392,0,'2013-07-06 12:44:30',NULL,NULL),(3392,'01611','S','Cherry Valley','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.242998,-71.873372,0,'2013-07-06 12:44:30',NULL,NULL),(28940,'32178','P','Palatka','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.646317,-81.639501,0,'2013-07-06 12:44:32',NULL,NULL),(24831,'27610','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.761643,-78.583787,0,'2013-07-06 12:44:31',NULL,NULL),(65399,'77561','P','Hardin','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.152624,-94.735691,0,'2013-07-06 12:44:34',NULL,NULL),(59063,'70094','S','Avondale','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(66868,'79201','S','Kirkland','N','Childress','48075','Texas','TX','48','0000','940','Central',-6.0,'Y',34.432500,-100.145820,0,'2013-07-06 12:44:34',NULL,NULL),(11212,'11746','S','Dix Hills','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(59105,'70142','U','Naval Support Act Westbank','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.947342,-90.030163,0,'2013-07-06 12:44:33',NULL,NULL),(55825,'64151','S','Northmoor','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(51408,'59434','P','Rising Sun','N','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(62816,'74951','P','Panama','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.166368,-94.667683,0,'2013-07-06 12:44:33',NULL,NULL),(4762,'03853','S','Mirror Lake','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.621480,-71.279494,0,'2013-07-06 12:44:30',NULL,NULL),(30994,'33767','S','Clearwater','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.982798,-82.817763,0,'2013-07-06 12:44:32',NULL,NULL),(27711,'30342','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.877890,-84.370698,0,'2013-07-06 12:44:31',NULL,NULL),(33653,'37710','S','Devonia','A','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.172200,-84.231480,0,'2013-07-06 12:44:32',NULL,NULL),(36896,'41105','P','Naples','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.430686,-82.667440,0,'2013-07-06 12:44:32',NULL,NULL),(19560,'20206','U','Soc Sec Bureau Hearing App','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.844053,-77.116300,0,'2013-07-06 12:44:31',NULL,NULL),(57730,'67416','S','Assaria','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.669599,-97.583065,0,'2013-07-06 12:44:33',NULL,NULL),(4707,'03816','S','Tuftonboro','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.656557,-71.251707,0,'2013-07-06 12:44:30',NULL,NULL),(12669,'13124','S','North Pitcher','D','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.638277,-75.820988,0,'2013-07-06 12:44:30',NULL,NULL),(65689,'78001','P','Artesia Wells','D','La Salle','48283','Texas','TX','48','0000','830','Central',-6.0,'Y',28.280605,-99.282621,0,'2013-07-06 12:44:34',NULL,NULL),(62870,'75039','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.888686,-96.943428,0,'2013-07-06 12:44:33',NULL,NULL),(19715,'20391','S','Dept Navy Fed Credit Union','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877045,-76.994981,0,'2013-07-06 12:44:31',NULL,NULL),(19165,'19721','U','New Castle','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.663657,-75.568203,0,'2013-07-06 12:44:31',NULL,NULL),(55672,'64040','S','Holden','D','Johnson','29101','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',38.716416,-93.987397,0,'2013-07-06 12:44:33',NULL,NULL),(47490,'54755','S','Modena','A','Buffalo','55011','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.566394,-91.671809,0,'2013-07-06 12:44:32',NULL,NULL),(14443,'15095','P','Bulk Mail Ctr','N','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.643305,-80.109507,0,'2013-07-06 12:44:31',NULL,NULL),(17565,'17985','S','Zion Grove','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.941300,-76.218000,0,'2013-07-06 12:44:31',NULL,NULL),(36020,'40165','S','Hunters Hlw','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(52310,'60549','S','Serena','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.458846,-88.768915,0,'2013-07-06 12:44:33',NULL,NULL),(52516,'60827','S','Riverdale','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.647040,-87.620670,0,'2013-07-06 12:44:33',NULL,NULL),(57719,'67357','S','Parsons','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.339316,-95.268057,0,'2013-07-06 12:44:33',NULL,NULL),(13414,'13754','S','North Sanford','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(68638,'81637','S','Dotsero','N','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.633376,-106.954148,0,'2013-07-06 12:44:34',NULL,NULL),(20018,'20621','S','Maddox','A','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.334840,-76.820400,0,'2013-07-06 12:44:31',NULL,NULL),(62109,'73639','S','Custer','N','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.693460,-98.923920,0,'2013-07-06 12:44:33',NULL,NULL),(55706,'64066','P','Levasy','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.135185,-94.137788,0,'2013-07-06 12:44:33',NULL,NULL),(39082,'44217','S','Creston','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.961849,-81.906308,0,'2013-07-06 12:44:32',NULL,NULL),(74674,'92866','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.787684,-117.842309,0,'2013-07-06 12:44:34',NULL,NULL),(13569,'13842','S','S Kortright','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.381469,-74.724897,0,'2013-07-06 12:44:31',NULL,NULL),(16939,'17701','S','Center City','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(15473,'16428','S','North East','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.201742,-79.827570,0,'2013-07-06 12:44:31',NULL,NULL),(404,'00662','S','Jard Miramar','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(41326,'46776','S','Wall Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.736790,-85.171469,0,'2013-07-06 12:44:32',NULL,NULL),(35443,'39479','S','Eminence','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.532820,-89.486580,0,'2013-07-06 12:44:32',NULL,NULL),(11573,'12066','S','Esperance','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.794700,-74.334660,0,'2013-07-06 12:44:30',NULL,NULL),(74653,'92837','P','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.869533,-117.961118,0,'2013-07-06 12:44:34',NULL,NULL),(57003,'66204','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(51080,'58761','S','Mohall','D','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.763084,-101.524319,0,'2013-07-06 12:44:33',NULL,NULL),(47825,'55065','S','Randolph','D','Dakota','27037','Minnesota','MN','27','5120','507','Central',-6.0,'Y',44.524884,-93.017991,0,'2013-07-06 12:44:33',NULL,NULL),(18566,'19124','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.013115,-75.094734,0,'2013-07-06 12:44:31',NULL,NULL),(71898,'87747','S','Abbott','N','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.383580,-104.344020,0,'2013-07-06 12:44:34',NULL,NULL),(62388,'74083','S','Noxie','N','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.931887,-95.771943,0,'2013-07-06 12:44:33',NULL,NULL),(15021,'15680','P','Salina','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.524991,-79.495127,0,'2013-07-06 12:44:31',NULL,NULL),(44431,'49848','S','Ingalls','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.379343,-87.613529,0,'2013-07-06 12:44:32',NULL,NULL),(17944,'18508','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.437061,-75.663443,0,'2013-07-06 12:44:31',NULL,NULL),(21111,'22067','S','Greenway','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.940622,-77.165123,0,'2013-07-06 12:44:31',NULL,NULL),(19584,'20219','U','Comptroller of Currency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882413,-77.016213,0,'2013-07-06 12:44:31',NULL,NULL),(50596,'58243','S','Hoople','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.506766,-97.581561,0,'2013-07-06 12:44:33',NULL,NULL),(49819,'57216','S','Big Stone','N','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.292796,-96.462397,0,'2013-07-06 12:44:33',NULL,NULL),(8792,'08561','P','Windsor','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.244389,-74.587139,0,'2013-07-06 12:44:30',NULL,NULL),(40098,'45308','S','Bradford','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.130219,-84.469290,0,'2013-07-06 12:44:32',NULL,NULL),(37843,'42461','S','Uniontown','D','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.776711,-87.811674,0,'2013-07-06 12:44:32',NULL,NULL),(32065,'35270','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205','Central',-6.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(75288,'93722','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.796753,-119.882901,0,'2013-07-06 12:44:34',NULL,NULL),(79072,'98431','U','Madigan Hospital','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(50648,'58318','S','Bottineau','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.905100,-100.424520,0,'2013-07-06 12:44:33',NULL,NULL),(21916,'23220','S','Saunders','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.553206,-77.456383,0,'2013-07-06 12:44:31',NULL,NULL),(48000,'55146','U','State Tax Dept','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.941944,-93.084462,0,'2013-07-06 12:44:33',NULL,NULL),(74217,'92310','S','Fort Irwin','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.343124,-116.617236,0,'2013-07-06 12:44:34',NULL,NULL),(535,'00674','S','Villas Tesoro','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(45109,'50552','P','Knierim','D','Calhoun','19025','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.457369,-94.459120,0,'2013-07-06 12:44:32',NULL,NULL),(40182,'45372','P','Tremont City','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.012740,-83.836200,0,'2013-07-06 12:44:32',NULL,NULL),(37443,'41838','S','Millstone','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.146815,-82.739237,0,'2013-07-06 12:44:32',NULL,NULL),(13831,'14219','S','Blasdell','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.785549,-78.822312,0,'2013-07-06 12:44:31',NULL,NULL),(23356,'25266','S','Uler','A','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.617778,-81.143333,0,'2013-07-06 12:44:31',NULL,NULL),(22228,'23604','S','Newport News','A','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.978927,-76.426918,0,'2013-07-06 12:44:31',NULL,NULL),(66545,'78732','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.374220,-97.892700,0,'2013-07-06 12:44:34',NULL,NULL),(58131,'68138','S','La Vista','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.169533,-96.127845,0,'2013-07-06 12:44:33',NULL,NULL),(47896,'55107','S','West St Paul','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.932638,-93.077152,0,'2013-07-06 12:44:33',NULL,NULL),(21564,'22815','S','Broadway','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.607291,-78.800864,0,'2013-07-06 12:44:31',NULL,NULL),(79018,'98391','S','Cedarview','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(11173,'11730','S','East Islip','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.728521,-73.186687,0,'2013-07-06 12:44:30',NULL,NULL),(46609,'53565','S','Mineral Point','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.862371,-90.182008,0,'2013-07-06 12:44:32',NULL,NULL),(2993,'01063','U','Smith College','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.319077,-72.644431,0,'2013-07-06 12:44:30',NULL,NULL),(8419,'08075','S','Delanco Township','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(41274,'46755','S','Kendallville','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(12505,'13022','P','Auburn','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.919963,-76.552920,0,'2013-07-06 12:44:30',NULL,NULL),(14765,'15338','S','Greensboro','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.816173,-79.948032,0,'2013-07-06 12:44:31',NULL,NULL),(42267,'47581','S','Hindostan Fls','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(35768,'39741','S','Waddell','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.613034,-88.845449,0,'2013-07-06 12:44:32',NULL,NULL),(24022,'26374','S','Independence','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.442306,-79.888485,0,'2013-07-06 12:44:31',NULL,NULL),(23236,'25106','S','Henderson','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.835600,-82.139177,0,'2013-07-06 12:44:31',NULL,NULL),(47816,'55057','S','Waterford','N','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445033,-93.181524,0,'2013-07-06 12:44:33',NULL,NULL),(38449,'43605','S','Oregon','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651460,-83.508660,0,'2013-07-06 12:44:32',NULL,NULL),(73285,'90747','U','Ca State Univ Dom Hills','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.866528,-118.253036,0,'2013-07-06 12:44:34',NULL,NULL),(7934,'07652','S','Paramus','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.947842,-74.070107,0,'2013-07-06 12:44:30',NULL,NULL),(39965,'45237','S','Amberley','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(73075,'90201','S','Cudahy','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.969157,-118.172903,0,'2013-07-06 12:44:34',NULL,NULL),(2076,'00921','S','Urb Altamesa','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(64469,'76577','S','Detmold','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.607440,-97.176720,0,'2013-07-06 12:44:34',NULL,NULL),(15238,'16038','S','Harrisville','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.136102,-80.004545,0,'2013-07-06 12:44:31',NULL,NULL),(10095,'10213','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.718440,-74.006344,0,'2013-07-06 12:44:30',NULL,NULL),(58859,'69147','S','Lewellen','D','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.441110,-102.109520,0,'2013-07-06 12:44:33',NULL,NULL),(8178,'07878','P','Mount Tabor','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.874494,-74.477334,0,'2013-07-06 12:44:30',NULL,NULL),(54921,'63099','U','Fenton','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.536522,-90.448052,0,'2013-07-06 12:44:33',NULL,NULL),(26901,'29576','S','Garden City Beach','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.586770,-79.009455,0,'2013-07-06 12:44:31',NULL,NULL),(42403,'47747','U','Deaconess Hospital','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.982273,-87.567901,0,'2013-07-06 12:44:32',NULL,NULL),(52625,'61041','S','Hanover','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.270660,-90.299921,0,'2013-07-06 12:44:33',NULL,NULL),(54451,'62849','S','Slap Out','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.613375,-88.790283,0,'2013-07-06 12:44:33',NULL,NULL),(79501,'98907','P','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.592546,-120.532091,0,'2013-07-06 12:44:34',NULL,NULL),(65931,'78249','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.567119,-98.605723,0,'2013-07-06 12:44:34',NULL,NULL),(26728,'29418','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(57917,'67663','S','Plainville','D','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.232902,-99.303102,0,'2013-07-06 12:44:33',NULL,NULL),(57609,'67118','S','Norwich','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.456046,-97.846473,0,'2013-07-06 12:44:33',NULL,NULL),(73415,'91185','U','Mellon Regional Lockbox Netw','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.169701,-117.981386,0,'2013-07-06 12:44:34',NULL,NULL),(61873,'73128','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.451515,-97.620639,0,'2013-07-06 12:44:33',NULL,NULL),(7082,'06349','P','Navsub Base','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.401943,-72.089280,0,'2013-07-06 12:44:30',NULL,NULL),(42855,'48079','S','St Clair Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.853850,-82.547092,0,'2013-07-06 12:44:32',NULL,NULL),(32064,'35266','P','Vestavia Hls','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(26798,'29458','S','McClellanvle','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.103751,-79.470346,0,'2013-07-06 12:44:31',NULL,NULL),(29196,'32407','S','P C Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.202980,-85.797960,0,'2013-07-06 12:44:32',NULL,NULL),(321,'00646','S','Villa Santa II','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(15186,'15945','S','Johnstown','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.326667,-78.922222,0,'2013-07-06 12:44:31',NULL,NULL),(12087,'12565','S','Philmont','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.248150,-73.649027,0,'2013-07-06 12:44:30',NULL,NULL),(71439,'87034','P','Pueblo of Acoma','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084674,-107.598482,0,'2013-07-06 12:44:34',NULL,NULL),(21457,'22611','S','Berryville','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.150938,-77.976972,0,'2013-07-06 12:44:31',NULL,NULL),(75243,'93653','S','Raymond','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.318338,-120.005507,0,'2013-07-06 12:44:34',NULL,NULL),(56805,'65770','S','Walnut Grove','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.413249,-93.548626,0,'2013-07-06 12:44:33',NULL,NULL),(16906,'17585','P','Witmer','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045774,-76.212436,0,'2013-07-06 12:44:31',NULL,NULL),(76111,'95231','S','French Camp','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.876234,-121.284100,0,'2013-07-06 12:44:34',NULL,NULL),(9050,'08889','S','White House Station','N','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.599026,-74.758720,0,'2013-07-06 12:44:30',NULL,NULL),(28458,'31412','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.076536,-81.091718,0,'2013-07-06 12:44:32',NULL,NULL),(51187,'59024','S','Custer','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',46.206932,-107.676388,0,'2013-07-06 12:44:33',NULL,NULL),(74301,'92375','P','Redlands','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.062806,-117.195587,0,'2013-07-06 12:44:34',NULL,NULL),(3884,'02375','S','S Easton','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.028515,-71.100880,0,'2013-07-06 12:44:30',NULL,NULL),(59456,'70729','S','Erwinville','D','West Baton Rouge','22121','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.534205,-91.395293,0,'2013-07-06 12:44:33',NULL,NULL),(52013,'60174','S','Campton Hills','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.922012,-88.304234,0,'2013-07-06 12:44:33',NULL,NULL),(12461,'12975','P','Port Kent','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.527154,-73.412205,0,'2013-07-06 12:44:30',NULL,NULL),(25921,'28649','S','McGrady','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.321231,-81.188583,0,'2013-07-06 12:44:31',NULL,NULL),(65304,'77494','S','Park Row','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.753968,-95.810176,0,'2013-07-06 12:44:34',NULL,NULL),(42741,'48022','S','Emmett','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.023041,-82.814127,0,'2013-07-06 12:44:32',NULL,NULL),(49030,'56277','S','Olivia','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.773937,-94.988415,0,'2013-07-06 12:44:33',NULL,NULL),(54151,'62568','S','Sharpsburg','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.549894,-89.297628,0,'2013-07-06 12:44:33',NULL,NULL),(54239,'62665','S','Naples','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.829660,-90.559448,0,'2013-07-06 12:44:33',NULL,NULL),(60848,'72042','S','Dewitt','A','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.292792,-91.337922,0,'2013-07-06 12:44:33',NULL,NULL),(129,'00612','S','VISTA Azul','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(55062,'63160','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.637559,-90.186991,0,'2013-07-06 12:44:33',NULL,NULL),(63934,'76066','S','Millsap','D','Parker','48367','Texas','TX','48','2800','940','Central',-6.0,'Y',32.757899,-98.005545,0,'2013-07-06 12:44:34',NULL,NULL),(59386,'70609','U','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.181629,-93.213153,0,'2013-07-06 12:44:33',NULL,NULL),(23760,'25962','S','Hilton Village','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(64870,'77062','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577603,-95.138853,0,'2013-07-06 12:44:34',NULL,NULL),(44294,'49726','S','Drummond Island','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.998200,-83.715920,0,'2013-07-06 12:44:32',NULL,NULL),(45848,'52228','S','Fairfax','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.911092,-91.782512,0,'2013-07-06 12:44:32',NULL,NULL),(70776,'85342','S','Morristown','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.850320,-112.609320,0,'2013-07-06 12:44:34',NULL,NULL),(2474,'00956','S','Mans de Sierra Taina','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(38406,'43533','S','Lyons','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.694752,-84.075981,0,'2013-07-06 12:44:32',NULL,NULL),(32017,'35235','S','Huffman','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(19707,'20388','S','Washington Na','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878851,-76.991728,0,'2013-07-06 12:44:31',NULL,NULL),(18817,'19406','S','Kng of Prussa','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.115940,-75.373740,0,'2013-07-06 12:44:31',NULL,NULL),(68023,'80925','S','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739647,-104.635922,0,'2013-07-06 12:44:34',NULL,NULL),(50784,'58433','S','Edgeley','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.321320,-98.721720,0,'2013-07-06 12:44:33',NULL,NULL),(71006,'85720','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.196799,-110.891702,0,'2013-07-06 12:44:34',NULL,NULL),(23076,'24892','S','Caretta','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.304104,-81.680662,0,'2013-07-06 12:44:31',NULL,NULL),(28347,'31195','U','Atlanta NDC','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.806070,-84.477521,0,'2013-07-06 12:44:32',NULL,NULL),(58747,'68956','S','Denman','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.625091,-98.657971,0,'2013-07-06 12:44:33',NULL,NULL),(8001,'07719','S','South Belmar','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(32153,'35469','S','Knoxville','D','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.973197,-87.805293,0,'2013-07-06 12:44:32',NULL,NULL),(13525,'13815','S','Springvale','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.530787,-75.524876,0,'2013-07-06 12:44:31',NULL,NULL),(1927,'00795','S','Urb Hermanos Santiago','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(28359,'31206','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.792100,-83.666700,0,'2013-07-06 12:44:32',NULL,NULL),(59536,'70812','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.505615,-91.119318,0,'2013-07-06 12:44:33',NULL,NULL),(28950,'32189','S','Satsuma','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.564126,-81.633232,0,'2013-07-06 12:44:32',NULL,NULL),(74241,'92327','S','Daggett','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.851756,-116.826854,0,'2013-07-06 12:44:34',NULL,NULL),(6826,'06115','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760560,-72.674050,0,'2013-07-06 12:44:30',NULL,NULL),(62315,'74036','S','Onola','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147671,-95.509727,0,'2013-07-06 12:44:33',NULL,NULL),(6274,'05633','U','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.259083,-72.580549,0,'2013-07-06 12:44:30',NULL,NULL),(58829,'69045','S','Wauneta','D','Chase','31029','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.414392,-101.371343,0,'2013-07-06 12:44:33',NULL,NULL),(20315,'20825','P','Bethesda','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.995496,-77.074994,0,'2013-07-06 12:44:31',NULL,NULL),(18450,'19073','S','Newtown Sq','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.983187,-75.412719,0,'2013-07-06 12:44:31',NULL,NULL),(79855,'99554','P','Alakanuk','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.721430,-164.579810,0,'2013-07-06 12:44:34',NULL,NULL),(939,'00715','S','Ponce','A','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(13643,'14001','S','Newstead','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.016719,-78.510497,0,'2013-07-06 12:44:31',NULL,NULL),(25340,'28217','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.154268,-80.928633,0,'2013-07-06 12:44:31',NULL,NULL),(26969,'29612','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.847835,-82.403959,0,'2013-07-06 12:44:31',NULL,NULL),(39200,'44333','S','Montrose','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.156040,-81.637740,0,'2013-07-06 12:44:32',NULL,NULL),(17743,'18320','P','Analomink','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.053321,-75.223773,0,'2013-07-06 12:44:31',NULL,NULL),(75532,'94203','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584351,-121.493764,0,'2013-07-06 12:44:34',NULL,NULL),(23757,'25958','S','Orient Hill','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.989769,-80.689842,0,'2013-07-06 12:44:31',NULL,NULL),(23191,'25051','S','Costa','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.151820,-81.713319,0,'2013-07-06 12:44:31',NULL,NULL),(61842,'73116','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.540626,-97.556678,0,'2013-07-06 12:44:33',NULL,NULL),(58877,'69157','S','Purdum','D','Blaine','31009','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.960068,-100.103031,0,'2013-07-06 12:44:33',NULL,NULL),(8426,'08077','S','Cinnaminson Township','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.008345,-75.010068,0,'2013-07-06 12:44:30',NULL,NULL),(31537,'34491','S','Summerfield','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.991165,-82.046372,0,'2013-07-06 12:44:32',NULL,NULL),(25821,'28613','S','Conover','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.711820,-81.209282,0,'2013-07-06 12:44:31',NULL,NULL),(71737,'87535','S','La Cueva','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.572980,-105.773580,0,'2013-07-06 12:44:34',NULL,NULL),(77874,'97258','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.513289,-122.674551,0,'2013-07-06 12:44:34',NULL,NULL),(67047,'79548','S','Sagerton','A','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.184444,-99.893333,0,'2013-07-06 12:44:34',NULL,NULL),(24055,'26426','S','Bristol','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281554,-80.559325,0,'2013-07-06 12:44:31',NULL,NULL),(11912,'12410','S','Oliverea','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.092940,-74.461860,0,'2013-07-06 12:44:30',NULL,NULL),(55472,'63746','P','Farrar','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.702070,-89.690412,0,'2013-07-06 12:44:33',NULL,NULL),(30910,'33707','S','S Pasadena','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(31155,'33914','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.580208,-81.998543,0,'2013-07-06 12:44:32',NULL,NULL),(71968,'88009','P','Playas','D','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.031636,-108.684444,0,'2013-07-06 12:44:34',NULL,NULL),(76467,'95618','S','El Macero','A','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.545000,-121.739444,0,'2013-07-06 12:44:34',NULL,NULL),(24566,'27305','S','Milton','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.514063,-79.220757,0,'2013-07-06 12:44:31',NULL,NULL),(64622,'76693','S','Wortham','D','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.784137,-96.463313,0,'2013-07-06 12:44:34',NULL,NULL),(1247,'00729','S','Urb Country View','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(61115,'72150','S','Cane Creek','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.305789,-92.400260,0,'2013-07-06 12:44:33',NULL,NULL),(60554,'71740','S','Emerson','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.093825,-93.188033,0,'2013-07-06 12:44:33',NULL,NULL),(58293,'68417','S','Otoe','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.724541,-96.121219,0,'2013-07-06 12:44:33',NULL,NULL),(6899,'06147','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791110,-72.668684,0,'2013-07-06 12:44:30',NULL,NULL),(18346,'19034','S','Fort Washington','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.135875,-75.206603,0,'2013-07-06 12:44:31',NULL,NULL),(25673,'28512','S','Fort Macon Coast Guard Base','N','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(53931,'62401','S','Park Hills','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(28847,'32091','S','Kngsly Lk','A','Bradford','12007','Florida','FL','12','0000','904','Eastern',-5.0,'Y',29.949586,-82.112253,0,'2013-07-06 12:44:32',NULL,NULL),(32338,'35775','S','Vlhrmoso Spgs','A','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.550490,-86.694970,0,'2013-07-06 12:44:32',NULL,NULL),(32981,'36613','S','Mobile','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.834480,-88.194240,0,'2013-07-06 12:44:32',NULL,NULL),(44058,'49441','S','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168889,-86.263889,0,'2013-07-06 12:44:32',NULL,NULL),(35448,'39481','S','Stringer','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.846712,-89.258554,0,'2013-07-06 12:44:32',NULL,NULL),(36941,'41164','S','Prater','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(79024,'98391','S','Prairie Ridge','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(60671,'71923','S','Dalark','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(77779,'97124','S','Hillsboro','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.535156,-122.956260,0,'2013-07-06 12:44:34',NULL,NULL),(78684,'98247','S','Strandell','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.906641,-122.329968,0,'2013-07-06 12:44:34',NULL,NULL),(61654,'72901','S','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.366000,-94.413642,0,'2013-07-06 12:44:33',NULL,NULL),(37544,'42060','P','Lovelaceville','D','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.970722,-88.831281,0,'2013-07-06 12:44:32',NULL,NULL),(33384,'37215','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.093978,-86.824688,0,'2013-07-06 12:44:32',NULL,NULL),(32299,'35744','S','Dutton','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.607613,-85.903990,0,'2013-07-06 12:44:32',NULL,NULL),(39713,'45050','S','Monroe','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.446195,-84.369751,0,'2013-07-06 12:44:32',NULL,NULL),(26380,'29082','S','Lodge','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.068810,-80.952920,0,'2013-07-06 12:44:31',NULL,NULL),(14508,'15201','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.470679,-79.954348,0,'2013-07-06 12:44:31',NULL,NULL),(51940,'60128','U','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.916845,-88.105772,0,'2013-07-06 12:44:33',NULL,NULL),(1801,'00783','S','Urb Sylvia','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(19841,'20505','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896385,-77.041564,0,'2013-07-06 12:44:31',NULL,NULL),(18191,'18934','S','Mechanicsvlle','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.346630,-75.072109,0,'2013-07-06 12:44:31',NULL,NULL),(50610,'58258','S','Mekinock','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.978812,-97.507382,0,'2013-07-06 12:44:33',NULL,NULL),(30348,'33311','S','Wilton Manors','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(60127,'71371','S','Trout','D','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(13371,'13736','S','East Berkshire','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.313800,-76.190640,0,'2013-07-06 12:44:31',NULL,NULL),(29456,'32710','P','Clarcona','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.610937,-81.496326,0,'2013-07-06 12:44:32',NULL,NULL),(22804,'24474','P','Selma','D','Alleghany','51005','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.804564,-79.850309,0,'2013-07-06 12:44:31',NULL,NULL),(21975,'23249','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.494632,-77.467640,0,'2013-07-06 12:44:31',NULL,NULL),(27567,'30266','P','Orchard Hill','D','Spalding','13255','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.174195,-84.215161,0,'2013-07-06 12:44:31',NULL,NULL),(57159,'66282','P','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.953539,-94.688284,0,'2013-07-06 12:44:33',NULL,NULL),(29305,'32521','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.375769,-87.276144,0,'2013-07-06 12:44:32',NULL,NULL),(32847,'36502','S','Atmore','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.021667,-87.484959,0,'2013-07-06 12:44:32',NULL,NULL),(72699,'89448','P','Elk Point','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(73057,'90091','P','Commerce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.989658,-118.149153,0,'2013-07-06 12:44:34',NULL,NULL),(69269,'83436','S','Canyon Creek','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.860779,-111.515462,0,'2013-07-06 12:44:34',NULL,NULL),(69750,'84050','S','Littleton','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(74204,'92286','P','Yucca Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.184966,-116.406627,0,'2013-07-06 12:44:34',NULL,NULL),(1623,'00771','S','Ext Las Mercedes','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(23754,'25958','S','Bingham','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.989769,-80.689842,0,'2013-07-06 12:44:31',NULL,NULL),(27712,'30342','S','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.877890,-84.370698,0,'2013-07-06 12:44:31',NULL,NULL),(74265,'92344','S','Hesperia','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.397300,-117.399400,0,'2013-07-06 12:44:34',NULL,NULL),(75907,'95002','P','Alviso','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.427296,-121.970884,0,'2013-07-06 12:44:34',NULL,NULL),(33656,'37714','S','Caryville','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.276059,-84.192974,0,'2013-07-06 12:44:32',NULL,NULL),(79359,'98643','S','Rosburg','D','Wahkiakum','53069','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.314753,-123.654500,0,'2013-07-06 12:44:34',NULL,NULL),(50992,'58650','S','Regent','D','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.437876,-102.613448,0,'2013-07-06 12:44:33',NULL,NULL),(58304,'68430','S','Roca','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.674181,-96.664510,0,'2013-07-06 12:44:33',NULL,NULL),(18030,'18644','S','Wyoming','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.330100,-75.853680,0,'2013-07-06 12:44:31',NULL,NULL),(46912,'54137','S','Krakow','D','Shawano','55115','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.764066,-88.228053,0,'2013-07-06 12:44:32',NULL,NULL),(79166,'98512','S','Tumwater','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.951987,-123.014667,0,'2013-07-06 12:44:34',NULL,NULL),(19089,'19602','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.329373,-75.921719,0,'2013-07-06 12:44:31',NULL,NULL),(38953,'44126','S','Fairview Park','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.446483,-81.856757,0,'2013-07-06 12:44:32',NULL,NULL),(43247,'48318','P','Utica','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.624463,-83.033255,0,'2013-07-06 12:44:32',NULL,NULL),(55505,'63775','S','Sereno','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(15800,'16926','S','Cowley','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.666415,-76.720268,0,'2013-07-06 12:44:31',NULL,NULL),(28249,'31062','U','Central State Hospital','N','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.086401,-83.239860,0,'2013-07-06 12:44:31',NULL,NULL),(50816,'58463','S','McClusky','D','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.483889,-100.443661,0,'2013-07-06 12:44:33',NULL,NULL),(30919,'33708','S','Redingtn Shor','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(38525,'43730','S','Rendville','A','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.630644,-82.090365,0,'2013-07-06 12:44:32',NULL,NULL),(45086,'50532','S','Evanston','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.470067,-93.993314,0,'2013-07-06 12:44:32',NULL,NULL),(12525,'13032','S','Whitelaw','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083843,-75.768034,0,'2013-07-06 12:44:30',NULL,NULL),(48934,'56158','S','Magnolia','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.631550,-96.111505,0,'2013-07-06 12:44:33',NULL,NULL),(47339,'54568','S','Woodruff','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.968160,-89.695260,0,'2013-07-06 12:44:32',NULL,NULL),(67524,'80247','S','Denver','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.675696,-104.885137,0,'2013-07-06 12:44:34',NULL,NULL),(45601,'51556','S','Modale','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.618555,-96.009070,0,'2013-07-06 12:44:32',NULL,NULL),(73686,'91604','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144568,-118.390161,0,'2013-07-06 12:44:34',NULL,NULL),(72630,'89419','S','Toulon','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(29767,'33009','S','Hallandle Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(49131,'56363','P','Pease','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.697754,-93.647912,0,'2013-07-06 12:44:33',NULL,NULL),(29078,'32256','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.191339,-81.494560,0,'2013-07-06 12:44:32',NULL,NULL),(36979,'41180','S','Cherokee','N','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.152071,-82.793657,0,'2013-07-06 12:44:32',NULL,NULL),(33595,'37615','S','Gray','A','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.373920,-82.445040,0,'2013-07-06 12:44:32',NULL,NULL),(32998,'36633','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.670807,-88.106466,0,'2013-07-06 12:44:32',NULL,NULL),(72195,'88411','S','San Jon','A','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.115660,-103.313220,0,'2013-07-06 12:44:34',NULL,NULL),(1790,'00783','S','Loma Linda','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(62669,'74647','S','Newkirk','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.884362,-97.055620,0,'2013-07-06 12:44:33',NULL,NULL),(74513,'92647','S','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.721030,-118.003329,0,'2013-07-06 12:44:34',NULL,NULL),(20380,'20885','P','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.133486,-77.229056,0,'2013-07-06 12:44:31',NULL,NULL),(20672,'21229','S','Carroll','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.284902,-76.689882,0,'2013-07-06 12:44:31',NULL,NULL),(69799,'84066','S','Roosevelt','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.298824,-109.998125,0,'2013-07-06 12:44:34',NULL,NULL),(1442,'00739','S','Urb Sabanera','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(23037,'24853','P','Vivian','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.424159,-81.509900,0,'2013-07-06 12:44:31',NULL,NULL),(49317,'56547','S','Averill','N','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.874486,-96.578028,0,'2013-07-06 12:44:33',NULL,NULL),(2321,'00930','P','San Jose','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405329,-66.062376,0,'2013-07-06 12:44:30',NULL,NULL),(32055,'35260','P','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.399765,-86.838955,0,'2013-07-06 12:44:32',NULL,NULL),(71497,'87107','S','Los Ranchos De Abq','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.135912,-106.643641,0,'2013-07-06 12:44:34',NULL,NULL),(22970,'24719','P','Covel','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.492361,-81.322125,0,'2013-07-06 12:44:31',NULL,NULL),(62285,'74017','S','Verdigris','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.343020,-95.596680,0,'2013-07-06 12:44:33',NULL,NULL),(6935,'06167','U','A A R P Pharmacy','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768325,-72.682921,0,'2013-07-06 12:44:30',NULL,NULL),(12588,'13073','S','Groton City','N','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.585725,-76.393025,0,'2013-07-06 12:44:30',NULL,NULL),(24502,'27263','S','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.908020,-79.980120,0,'2013-07-06 12:44:31',NULL,NULL),(54138,'62563','S','New City','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748414,-89.542262,0,'2013-07-06 12:44:33',NULL,NULL),(21740,'23027','S','Tamworth','A','Cumberland','51049','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.656780,-78.108900,0,'2013-07-06 12:44:31',NULL,NULL),(50400,'57772','S','Rockyford','N','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.497460,-102.501680,0,'2013-07-06 12:44:33',NULL,NULL),(7761,'07405','S','Fayson Lakes','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(17844,'18424','S','Covington Twp','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(11570,'12065','S','Halfmoon','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.851460,-73.798980,0,'2013-07-06 12:44:30',NULL,NULL),(77546,'96857','S','Schofield','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.494722,-158.066346,0,'2013-07-06 12:44:34',NULL,NULL),(49886,'57266','S','Summit','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.387337,-97.043929,0,'2013-07-06 12:44:33',NULL,NULL),(7454,'06857','U','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.094752,-73.434074,0,'2013-07-06 12:44:30',NULL,NULL),(66918,'79330','S','Justiceburg','D','Garza','48169','Texas','TX','48','0000','806','Central',-6.0,'Y',33.180818,-101.297478,0,'2013-07-06 12:44:34',NULL,NULL),(63760,'75941','S','Shady Grove','N','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.187357,-94.786365,0,'2013-07-06 12:44:34',NULL,NULL),(38728,'44023','S','Auburn Twp','A','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.390948,-81.336689,0,'2013-07-06 12:44:32',NULL,NULL),(58839,'69127','S','Brule','D','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.093785,-101.889393,0,'2013-07-06 12:44:33',NULL,NULL),(52057,'60201','S','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.057696,-87.696561,0,'2013-07-06 12:44:33',NULL,NULL),(79932,'99615','S','Akhiok','A','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.804109,-152.453963,0,'2013-07-06 12:44:34',NULL,NULL),(36134,'40225','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.188651,-85.651479,0,'2013-07-06 12:44:32',NULL,NULL),(76757,'95923','S','Seneca','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.208520,-121.155480,0,'2013-07-06 12:44:34',NULL,NULL),(11413,'11961','S','Lake Panamoka','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.896900,-72.884340,0,'2013-07-06 12:44:30',NULL,NULL),(4721,'03824','S','Lee','A','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.130400,-70.976700,0,'2013-07-06 12:44:30',NULL,NULL),(25548,'28407','P','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.156508,-77.894445,0,'2013-07-06 12:44:31',NULL,NULL),(53958,'62426','S','Larkinsburg','N','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.921946,-88.664835,0,'2013-07-06 12:44:33',NULL,NULL),(46708,'53793','U','Swiss Colony Bus Reply','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.098357,-89.325603,0,'2013-07-06 12:44:32',NULL,NULL),(42711,'48001','S','Pearl Beach','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(41060,'46506','S','Bremen','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.435747,-86.172511,0,'2013-07-06 12:44:32',NULL,NULL),(7326,'06704','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.578898,-73.032746,0,'2013-07-06 12:44:30',NULL,NULL),(27887,'30459','P','Statesboro','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.447552,-81.781293,0,'2013-07-06 12:44:31',NULL,NULL),(4687,'03805','S','Newington','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.239099,-70.824153,0,'2013-07-06 12:44:30',NULL,NULL),(19775,'20423','U','Surface Transportation Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893212,-77.027764,0,'2013-07-06 12:44:31',NULL,NULL),(71000,'85716','S','Sun','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.244884,-110.921446,0,'2013-07-06 12:44:34',NULL,NULL),(26431,'29128','S','Borden','A','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(33568,'37415','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.127000,-85.274040,0,'2013-07-06 12:44:32',NULL,NULL),(36214,'40281','U','Pleasure Rdge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.145981,-85.867083,0,'2013-07-06 12:44:32',NULL,NULL),(36623,'40995','S','Trosper','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.782335,-83.835499,0,'2013-07-06 12:44:32',NULL,NULL),(38627,'43917','S','Dunglen','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.147121,-80.831081,0,'2013-07-06 12:44:32',NULL,NULL),(11872,'12304','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.780295,-73.909969,0,'2013-07-06 12:44:30',NULL,NULL),(51263,'59087','S','Winnett','D','Petroleum','30069','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.065280,-108.005560,0,'2013-07-06 12:44:33',NULL,NULL),(40016,'45247','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(18367,'19041','S','Haverford','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.027962,-75.298984,0,'2013-07-06 12:44:31',NULL,NULL),(8227,'07976','S','New Vernon','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.731772,-74.480745,0,'2013-07-06 12:44:30',NULL,NULL),(72704,'89448','P','Marla Bay','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(78781,'98312','S','Holly','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(5071,'04287','S','W Bowdoin','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.985129,-70.094212,0,'2013-07-06 12:44:30',NULL,NULL),(39656,'45005','S','Franklin','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.528960,-84.297420,0,'2013-07-06 12:44:32',NULL,NULL),(27539,'30230','S','Hogansville','D','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.166257,-84.943787,0,'2013-07-06 12:44:31',NULL,NULL),(44833,'50255','P','Thornburg','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.467746,-92.354327,0,'2013-07-06 12:44:32',NULL,NULL),(22761,'24431','S','Crimora','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.165674,-78.833733,0,'2013-07-06 12:44:31',NULL,NULL),(48423,'55605','S','Grand Portage','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.961796,-89.760453,0,'2013-07-06 12:44:33',NULL,NULL),(47684,'54962','S','Ogdensburg','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.489062,-89.018982,0,'2013-07-06 12:44:33',NULL,NULL),(46722,'53811','S','Hazel Green','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.535981,-90.509343,0,'2013-07-06 12:44:32',NULL,NULL),(26364,'29072','S','Edmund','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.979860,-81.260520,0,'2013-07-06 12:44:31',NULL,NULL),(65112,'77372','S','Splendora','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.220286,-95.158358,0,'2013-07-06 12:44:34',NULL,NULL),(69919,'84109','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701306,-111.815899,0,'2013-07-06 12:44:34',NULL,NULL),(36259,'40322','S','Scranton','A','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.957240,-83.618623,0,'2013-07-06 12:44:32',NULL,NULL),(27430,'30110','S','Bremen','D','Haralson','13143','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.739322,-85.135317,0,'2013-07-06 12:44:31',NULL,NULL),(8711,'08404','P','Atlantic City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.362648,-74.425943,0,'2013-07-06 12:44:30',NULL,NULL),(69672,'84020','S','Draper','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.511080,-111.870014,0,'2013-07-06 12:44:34',NULL,NULL),(7957,'07676','S','Washington Twp','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(64877,'77065','S','Jersey Vlg','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.930003,-95.605601,0,'2013-07-06 12:44:34',NULL,NULL),(55124,'63343','S','Auburn','N','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.157945,-90.815451,0,'2013-07-06 12:44:33',NULL,NULL),(52039,'60189','S','Wheaton','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.836781,-88.128893,0,'2013-07-06 12:44:33',NULL,NULL),(30227,'33188','U','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.814728,-80.240372,0,'2013-07-06 12:44:32',NULL,NULL),(70581,'85073','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.451601,-112.073406,0,'2013-07-06 12:44:34',NULL,NULL),(73517,'91343','S','North Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.237131,-118.481042,0,'2013-07-06 12:44:34',NULL,NULL),(64114,'76180','S','Richland Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(28704,'31824','S','Preston','D','Webster','13307','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.081190,-84.544935,0,'2013-07-06 12:44:32',NULL,NULL),(5359,'04622','S','Deblois','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.601113,-67.926225,0,'2013-07-06 12:44:30',NULL,NULL),(50845,'58484','S','Sutton','D','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.372934,-98.431736,0,'2013-07-06 12:44:33',NULL,NULL),(55618,'63962','P','Rombauer','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.842527,-90.281788,0,'2013-07-06 12:44:33',NULL,NULL),(64243,'76360','S','Electra','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',34.018548,-98.896354,0,'2013-07-06 12:44:34',NULL,NULL),(22617,'24221','S','Blackwater','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.634666,-83.009063,0,'2013-07-06 12:44:31',NULL,NULL),(20444,'21010','S','Aber Prov Grd','A','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404700,-76.288320,0,'2013-07-06 12:44:31',NULL,NULL),(40514,'45817','S','Bluffton','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.882285,-83.911911,0,'2013-07-06 12:44:32',NULL,NULL),(17316,'17858','P','Numidia','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.878382,-76.403280,0,'2013-07-06 12:44:31',NULL,NULL),(62582,'74464','S','Thlequah','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.913588,-94.967828,0,'2013-07-06 12:44:33',NULL,NULL),(18873,'19454','S','Gwynedd','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.215532,-75.258606,0,'2013-07-06 12:44:31',NULL,NULL),(55661,'64028','P','Farley','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.283269,-94.831810,0,'2013-07-06 12:44:33',NULL,NULL),(72791,'89701','S','Washoe','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(66828,'79098','S','Wildorado','D','Oldham','48359','Texas','TX','48','0000','806','Central',-6.0,'Y',35.217620,-102.245498,0,'2013-07-06 12:44:34',NULL,NULL),(9939,'10154','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(61629,'72834','S','Dardanelle','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.221232,-93.160284,0,'2013-07-06 12:44:33',NULL,NULL),(51981,'60152','S','Marengo','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.233492,-88.630366,0,'2013-07-06 12:44:33',NULL,NULL),(46747,'53924','S','Cazenovia','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.503207,-90.272564,0,'2013-07-06 12:44:32',NULL,NULL),(72998,'90060','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',33.995744,-118.422017,0,'2013-07-06 12:44:34',NULL,NULL),(76511,'95641','S','Isleton','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.145589,-121.598217,0,'2013-07-06 12:44:34',NULL,NULL),(28859,'32110','S','Bunnell','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.466087,-81.247622,0,'2013-07-06 12:44:32',NULL,NULL),(29572,'32817','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.582385,-81.251475,0,'2013-07-06 12:44:32',NULL,NULL),(32926,'36558','S','Koenton','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(36747,'41040','S','Falmouth','D','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(39573,'44853','S','New Riegel','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.052873,-83.311555,0,'2013-07-06 12:44:32',NULL,NULL),(63213,'75449','S','Ladonia','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.421846,-95.970257,0,'2013-07-06 12:44:33',NULL,NULL),(52965,'61424','P','Camp Grove','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.078897,-89.632291,0,'2013-07-06 12:44:33',NULL,NULL),(13468,'13786','S','Harpersfield','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.434722,-74.723889,0,'2013-07-06 12:44:31',NULL,NULL),(10979,'11545','S','Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(69292,'83445','S','Heman','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(3219,'01366','S','Petersham','D','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.472326,-72.204057,0,'2013-07-06 12:44:30',NULL,NULL),(51879,'60087','S','Beach Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.405095,-87.859493,0,'2013-07-06 12:44:33',NULL,NULL),(61641,'72846','S','Lamar','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.438642,-93.391685,0,'2013-07-06 12:44:33',NULL,NULL),(77061,'96120','S','Hope Valley','A','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(39753,'45106','S','Bethel','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.948415,-84.096965,0,'2013-07-06 12:44:32',NULL,NULL),(80193,'99919','P','Ketchikan','A','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.689470,-132.524280,0,'2013-07-06 12:44:34',NULL,NULL),(39992,'45242','S','Blue Ash','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.245232,-84.353209,0,'2013-07-06 12:44:32',NULL,NULL),(57934,'67733','S','Edson','D','Sherman','20181','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',39.350422,-101.499003,0,'2013-07-06 12:44:33',NULL,NULL),(53118,'61544','S','Rapatee','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.710980,-90.265154,0,'2013-07-06 12:44:33',NULL,NULL),(53703,'62233','S','Bremen','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.923600,-89.818620,0,'2013-07-06 12:44:33',NULL,NULL),(72912,'90025','S','W Los Angeles','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.044073,-118.451381,0,'2013-07-06 12:44:34',NULL,NULL),(75055,'93523','S','Aerial Acres','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.950022,-117.901246,0,'2013-07-06 12:44:34',NULL,NULL),(18356,'19037','P','Glen Riddle Lima','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.901166,-75.442291,0,'2013-07-06 12:44:31',NULL,NULL),(32535,'36104','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.409628,-86.330198,0,'2013-07-06 12:44:32',NULL,NULL),(43813,'49073','S','Nashville','D','Barry','26015','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.585782,-85.122560,0,'2013-07-06 12:44:32',NULL,NULL),(19277,'19964','S','Marydel','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.101607,-75.727487,0,'2013-07-06 12:44:31',NULL,NULL),(29374,'32602','P','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.663326,-82.450099,0,'2013-07-06 12:44:32',NULL,NULL),(20021,'20623','S','Cheltenham','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.746143,-76.830091,0,'2013-07-06 12:44:31',NULL,NULL),(52216,'60482','S','Worth','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.688960,-87.774840,0,'2013-07-06 12:44:33',NULL,NULL),(24798,'27591','S','Wendell','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.792984,-78.387755,0,'2013-07-06 12:44:31',NULL,NULL),(36851,'41076','S','Crestview','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(5374,'04629','P','Surry','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.415507,-68.521466,0,'2013-07-06 12:44:30',NULL,NULL),(14679,'15243','S','Cedarhurst','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.383333,-80.066667,0,'2013-07-06 12:44:31',NULL,NULL),(10302,'10527','S','Granite Springs','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.317032,-73.764490,0,'2013-07-06 12:44:30',NULL,NULL),(32880,'36528','S','Dauphin Island','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.250952,-88.128610,0,'2013-07-06 12:44:32',NULL,NULL),(25296,'28139','S','Shingle Hollow','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(56003,'64646','S','Humphreys','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.116732,-93.295002,0,'2013-07-06 12:44:33',NULL,NULL),(76529,'95652','S','McClellan','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.685420,-121.381800,0,'2013-07-06 12:44:34',NULL,NULL),(9231,'09550','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(64684,'76834','S','Mozelle','N','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.833600,-99.415500,0,'2013-07-06 12:44:34',NULL,NULL),(22762,'24432','S','Deerfield','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.168708,-79.405410,0,'2013-07-06 12:44:31',NULL,NULL),(25825,'28615','S','Grayson','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.447180,-81.659280,0,'2013-07-06 12:44:31',NULL,NULL),(33437,'37305','S','Beershba Spgs','A','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.485212,-85.652867,0,'2013-07-06 12:44:32',NULL,NULL),(31445,'34278','P','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.332107,-82.530323,0,'2013-07-06 12:44:32',NULL,NULL),(51969,'60145','S','Kingston','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.111420,-88.800360,0,'2013-07-06 12:44:33',NULL,NULL),(20867,'21667','S','Still Pond','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.328122,-76.054372,0,'2013-07-06 12:44:31',NULL,NULL),(46489,'53224','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.156957,-88.044018,0,'2013-07-06 12:44:32',NULL,NULL),(23409,'25329','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351228,-81.629184,0,'2013-07-06 12:44:31',NULL,NULL),(79027,'98391','S','Sumner','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(16440,'17236','S','Charlestown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(15045,'15711','S','Anita','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.169633,-78.912621,0,'2013-07-06 12:44:31',NULL,NULL),(22437,'24017','S','Melrose','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.295707,-79.989389,0,'2013-07-06 12:44:31',NULL,NULL),(43561,'48725','S','Port Elizabeth','A','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.947964,-83.234180,0,'2013-07-06 12:44:32',NULL,NULL),(47454,'54729','S','Lafayette','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(51255,'59081','S','Silver Gate','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.104688,-110.221461,0,'2013-07-06 12:44:33',NULL,NULL),(57946,'67745','S','Mc Donald','D','Rawlins','20153','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.785928,-101.296984,0,'2013-07-06 12:44:33',NULL,NULL),(67915,'80905','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.836829,-104.837659,0,'2013-07-06 12:44:34',NULL,NULL),(77346,'96726','P','Honaunau','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.445139,-155.891182,0,'2013-07-06 12:44:34',NULL,NULL),(79722,'99214','P','Cty Spok Val','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.711392,-117.206773,0,'2013-07-06 12:44:34',NULL,NULL),(42002,'47426','P','Clear Creek','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.094733,-86.462329,0,'2013-07-06 12:44:32',NULL,NULL),(30449,'33332','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(25874,'28635','S','Hayes','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.356569,-81.127080,0,'2013-07-06 12:44:31',NULL,NULL),(32884,'36529','S','Seaboard','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.321111,-88.188611,0,'2013-07-06 12:44:32',NULL,NULL),(31041,'33811','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.962536,-82.008592,0,'2013-07-06 12:44:32',NULL,NULL),(18541,'19112','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.890037,-75.176966,0,'2013-07-06 12:44:31',NULL,NULL),(38706,'44004','S','East Ashtabula','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.850540,-80.777400,0,'2013-07-06 12:44:32',NULL,NULL),(843,'00698','S','Est de Yauco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(21465,'22625','S','Whitacre','A','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.370440,-78.303060,0,'2013-07-06 12:44:31',NULL,NULL),(28066,'30705','S','Chatsworth','D','Murray','13213','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.752332,-84.791600,0,'2013-07-06 12:44:31',NULL,NULL),(23283,'25162','P','Pratt','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.211569,-81.387264,0,'2013-07-06 12:44:31',NULL,NULL),(42819,'48059','S','North Lakeport','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(46601,'53556','S','Lone Rock','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.182834,-90.198719,0,'2013-07-06 12:44:32',NULL,NULL),(58527,'68789','S','Winnetoon','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.496222,-98.051704,0,'2013-07-06 12:44:33',NULL,NULL),(60493,'71662','S','Gourd','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.812280,-91.403100,0,'2013-07-06 12:44:33',NULL,NULL),(63856,'75978','P','Woden','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.503223,-94.522749,0,'2013-07-06 12:44:34',NULL,NULL),(55540,'63839','P','Cooter','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.045770,-89.808946,0,'2013-07-06 12:44:33',NULL,NULL),(47203,'54489','S','Seneca Cors','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.461390,-89.993344,0,'2013-07-06 12:44:32',NULL,NULL),(23177,'25035','S','Chelyan','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.195408,-81.486710,0,'2013-07-06 12:44:31',NULL,NULL),(23109,'24943','S','Grassy Meadows','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.844161,-80.743448,0,'2013-07-06 12:44:31',NULL,NULL),(15282,'16120','S','Enon Valley','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.841548,-80.460448,0,'2013-07-06 12:44:31',NULL,NULL),(72455,'89113','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.067463,-115.255782,0,'2013-07-06 12:44:34',NULL,NULL),(40862,'46228','S','Wynnedale','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(47911,'55110','S','Grant','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(23786,'25985','S','Sandstone','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.758808,-80.866671,0,'2013-07-06 12:44:31',NULL,NULL),(5550,'04849','S','Northport','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.312909,-69.092133,0,'2013-07-06 12:44:30',NULL,NULL),(3045,'01105','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.101072,-72.579177,0,'2013-07-06 12:44:30',NULL,NULL),(8288,'08016','S','Burlngtn TWP','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.070260,-74.841534,0,'2013-07-06 12:44:30',NULL,NULL),(5490,'04750','S','Caswell','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.912547,-67.826893,0,'2013-07-06 12:44:30',NULL,NULL),(30090,'33157','S','Cutler Ridge','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(29200,'32408','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.158417,-85.763888,0,'2013-07-06 12:44:32',NULL,NULL),(21093,'22039','S','Fairfax Sta','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.763405,-77.314652,0,'2013-07-06 12:44:31',NULL,NULL),(22868,'24558','S','Halifax','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.764205,-78.927758,0,'2013-07-06 12:44:31',NULL,NULL),(44850,'50268','S','What Cheer','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.377924,-92.353635,0,'2013-07-06 12:44:32',NULL,NULL),(45814,'52203','S','High Amana','N','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.804159,-91.867902,0,'2013-07-06 12:44:32',NULL,NULL),(48138,'55363','S','Montrose','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.065699,-93.912790,0,'2013-07-06 12:44:33',NULL,NULL),(51932,'60121','P','Elgin','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.037863,-88.279642,0,'2013-07-06 12:44:33',NULL,NULL),(60716,'71953','S','Mena','D','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(66057,'78379','S','Vattmanville','N','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.319380,-97.862520,0,'2013-07-06 12:44:34',NULL,NULL),(66344,'78608','S','Oakalla','A','Burnet','48053','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.935647,-97.969927,0,'2013-07-06 12:44:34',NULL,NULL),(49390,'56601','S','Wilton','A','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(23438,'25403','S','Martinsburg','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.461591,-77.969701,0,'2013-07-06 12:44:31',NULL,NULL),(70760,'85331','S','Cave Creek','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.823249,-111.949908,0,'2013-07-06 12:44:34',NULL,NULL),(73886,'91950','S','National City','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.668650,-117.091284,0,'2013-07-06 12:44:34',NULL,NULL),(77299,'96666','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(64390,'76537','S','Jarrell','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.788880,-97.606020,0,'2013-07-06 12:44:34',NULL,NULL),(47164,'54473','S','Alban','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.630777,-89.318589,0,'2013-07-06 12:44:32',NULL,NULL),(31032,'33802','P','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.064649,-81.943511,0,'2013-07-06 12:44:32',NULL,NULL),(66323,'78597','S','S Padre Isl E','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.109550,-97.168003,0,'2013-07-06 12:44:34',NULL,NULL),(1619,'00769','S','Vistas De Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(8793,'08562','S','Jacobstown','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.063017,-74.606180,0,'2013-07-06 12:44:30',NULL,NULL),(39930,'45224','S','N College Hl','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.201250,-84.531566,0,'2013-07-06 12:44:32',NULL,NULL),(30905,'33706','S','St Petersburg Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(29034,'32232','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.292563,-81.635312,0,'2013-07-06 12:44:32',NULL,NULL),(45377,'51018','S','Cushing','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.464908,-95.678858,0,'2013-07-06 12:44:32',NULL,NULL),(53811,'62295','S','Harrisonville','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.280452,-90.340506,0,'2013-07-06 12:44:33',NULL,NULL),(63591,'75788','P','Sacul','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.826668,-94.917381,0,'2013-07-06 12:44:34',NULL,NULL),(64513,'76634','S','Smiths Bend','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(40848,'46224','S','Spdway','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.792960,-86.257080,0,'2013-07-06 12:44:32',NULL,NULL),(62902,'75068','S','Oak Point','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.168674,-96.961589,0,'2013-07-06 12:44:33',NULL,NULL),(60621,'71866','S','Winthrop','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.869003,-94.403839,0,'2013-07-06 12:44:33',NULL,NULL),(50302,'57702','S','Rockerville','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.063037,-103.280916,0,'2013-07-06 12:44:33',NULL,NULL),(44561,'50013','U','Ames','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.019665,-93.645568,0,'2013-07-06 12:44:32',NULL,NULL),(22716,'24354','S','Seven Mile Fd','A','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(76255,'95407','S','Roseland','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.405151,-122.735183,0,'2013-07-06 12:44:34',NULL,NULL),(77073,'96126','S','Sierraville','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.593878,-120.281794,0,'2013-07-06 12:44:34',NULL,NULL),(18590,'19135','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.024203,-75.049991,0,'2013-07-06 12:44:31',NULL,NULL),(34734,'38849','S','Boggan Bend','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(16001,'17038','S','Jonestown','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.410665,-76.486339,0,'2013-07-06 12:44:31',NULL,NULL),(53215,'61630','U','Caterpillar Inc','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.682843,-89.601814,0,'2013-07-06 12:44:33',NULL,NULL),(6502,'05819','S','Johnsbury','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.434670,-72.038170,0,'2013-07-06 12:44:30',NULL,NULL),(70619,'85127','P','Chandler Hts','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.210185,-111.687173,0,'2013-07-06 12:44:34',NULL,NULL),(32071,'35283','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.517488,-86.809476,0,'2013-07-06 12:44:32',NULL,NULL),(13106,'13480','S','Stockwell','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.930337,-75.378181,0,'2013-07-06 12:44:30',NULL,NULL),(25804,'28607','S','Grandview Heights','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(3372,'01585','S','Westbrookfield','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.235246,-72.146449,0,'2013-07-06 12:44:30',NULL,NULL),(67021,'79533','S','Lueders','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.760281,-99.687839,0,'2013-07-06 12:44:34',NULL,NULL),(37190,'41514','S','Aflex','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(5543,'04841','S','Rockland','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.109348,-69.113281,0,'2013-07-06 12:44:30',NULL,NULL),(33428,'37246','U','Nashville Elec Serv','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.166280,-86.783735,0,'2013-07-06 12:44:32',NULL,NULL),(22021,'23290','U','Dominion Virginia Power','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.550454,-77.473709,0,'2013-07-06 12:44:31',NULL,NULL),(75759,'94618','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.824444,-122.230556,0,'2013-07-06 12:44:34',NULL,NULL),(10628,'11051','U','Publishers Clearing Hse Brm','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.841029,-73.694052,0,'2013-07-06 12:44:30',NULL,NULL),(51114,'58785','S','Surrey','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.239410,-101.135245,0,'2013-07-06 12:44:33',NULL,NULL),(55723,'64079','S','Tracy','N','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.354840,-94.796100,0,'2013-07-06 12:44:33',NULL,NULL),(60380,'71496','P','Leesville','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.143588,-93.258388,0,'2013-07-06 12:44:33',NULL,NULL),(65466,'77626','P','Mauriceville','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.202072,-93.884640,0,'2013-07-06 12:44:34',NULL,NULL),(67720,'80538','S','Loveland','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.427281,-105.093422,0,'2013-07-06 12:44:34',NULL,NULL),(67839,'80813','S','Cripple Creek','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.776126,-105.186093,0,'2013-07-06 12:44:34',NULL,NULL),(59062,'70094','S','9 Mile Point','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(13463,'13783','S','Hales Eddy','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(54887,'63068','S','New Haven','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(58333,'68457','S','Verdon','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.149112,-95.709711,0,'2013-07-06 12:44:33',NULL,NULL),(55390,'63628','S','Desloge','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.915562,-90.589053,0,'2013-07-06 12:44:33',NULL,NULL),(50900,'58542','S','Westfield','A','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.063690,-99.942884,0,'2013-07-06 12:44:33',NULL,NULL),(46842,'54017','S','New Johannesburg','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(46122,'52641','S','Mount Pleasant','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.968419,-91.548901,0,'2013-07-06 12:44:32',NULL,NULL),(274,'00646','S','Chalets de Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(37156,'41465','S','Sublett','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(36281,'40348','P','Millersburg','D','Bourbon','21017','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.301505,-84.142003,0,'2013-07-06 12:44:32',NULL,NULL),(27322,'30029','P','North Metro','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.977944,-84.147687,0,'2013-07-06 12:44:31',NULL,NULL),(26820,'29482','S','Sullivans Island','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.761726,-79.837391,0,'2013-07-06 12:44:31',NULL,NULL),(61537,'72680','S','Timbo','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842844,-92.354172,0,'2013-07-06 12:44:33',NULL,NULL),(71105,'85942','P','Woodruff','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.782119,-110.045248,0,'2013-07-06 12:44:34',NULL,NULL),(76919,'96007','S','Anderson','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.468980,-122.299500,0,'2013-07-06 12:44:34',NULL,NULL),(79846,'99547','P','Atka','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',52.121142,-174.428890,0,'2013-07-06 12:44:34',NULL,NULL),(61975,'73189','P','Oklahoma City','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.395812,-97.578752,0,'2013-07-06 12:44:33',NULL,NULL),(29485,'32733','P','Goldenrod','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.623648,-81.264139,0,'2013-07-06 12:44:32',NULL,NULL),(49482,'56660','S','Forest Grove','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.987810,-94.214799,0,'2013-07-06 12:44:33',NULL,NULL),(15958,'17025','S','West Enola','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(23347,'25259','S','Looneyville','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.665790,-81.296596,0,'2013-07-06 12:44:31',NULL,NULL),(21216,'22209','S','Rosslyn','A','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.894486,-77.074049,0,'2013-07-06 12:44:31',NULL,NULL),(17579,'18015','S','Bethlehem','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.601395,-75.369112,0,'2013-07-06 12:44:31',NULL,NULL),(29473,'32722','P','Glenwood','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.079239,-81.352956,0,'2013-07-06 12:44:32',NULL,NULL),(16346,'17140','U','Blue Shield','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259652,-76.807717,0,'2013-07-06 12:44:31',NULL,NULL),(29219,'32417','P','Panama City Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.184300,-85.811156,0,'2013-07-06 12:44:32',NULL,NULL),(8949,'08759','S','Lakehurst','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.952064,-74.365653,0,'2013-07-06 12:44:30',NULL,NULL),(18298,'19015','S','Upland','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868688,-75.385721,0,'2013-07-06 12:44:31',NULL,NULL),(13398,'13750','S','North Kortright','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.469080,-74.807400,0,'2013-07-06 12:44:31',NULL,NULL),(4380,'03101','S','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.988324,-71.465265,0,'2013-07-06 12:44:30',NULL,NULL),(27616,'30306','S','North Highland Finance','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.786536,-84.349237,0,'2013-07-06 12:44:31',NULL,NULL),(44847,'50266','S','West Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.586600,-93.765743,0,'2013-07-06 12:44:32',NULL,NULL),(51014,'58705','S','Mafb','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230700,-101.307900,0,'2013-07-06 12:44:33',NULL,NULL),(69609,'83857','S','Princeton','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.911973,-116.812875,0,'2013-07-06 12:44:34',NULL,NULL),(36062,'40207','S','Richlawn','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(61245,'72346','S','Heth','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.067120,-90.452280,0,'2013-07-06 12:44:33',NULL,NULL),(56910,'66049','S','Lawrence','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.970249,-95.279946,0,'2013-07-06 12:44:33',NULL,NULL),(23124,'24963','S','Peterstown','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.398643,-80.800140,0,'2013-07-06 12:44:31',NULL,NULL),(7450,'06855','S','East Norwalk','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.099161,-73.400423,0,'2013-07-06 12:44:30',NULL,NULL),(42331,'47633','S','Bugtown','N','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.155388,-87.775202,0,'2013-07-06 12:44:32',NULL,NULL),(6798,'06108','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(25032,'27894','P','Wilson','D','Wilson','37195','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.732528,-77.925919,0,'2013-07-06 12:44:31',NULL,NULL),(7412,'06801','S','Bethel','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.382468,-73.401404,0,'2013-07-06 12:44:30',NULL,NULL),(23302,'25186','P','Longacre','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.181843,-81.308979,0,'2013-07-06 12:44:31',NULL,NULL),(29315,'32535','S','Century','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.969246,-87.312300,0,'2013-07-06 12:44:32',NULL,NULL),(45531,'51446','S','Irwin','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.791120,-95.210119,0,'2013-07-06 12:44:32',NULL,NULL),(62186,'73761','S','Nash','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.665390,-98.052849,0,'2013-07-06 12:44:33',NULL,NULL),(20327,'20839','S','Beallsville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.176050,-77.406611,0,'2013-07-06 12:44:31',NULL,NULL),(3581,'01982','S','South Hamilton','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.619543,-70.861660,0,'2013-07-06 12:44:30',NULL,NULL),(40100,'45310','P','Burkettsville','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.352981,-84.643596,0,'2013-07-06 12:44:32',NULL,NULL),(33998,'38118','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.048583,-89.925961,0,'2013-07-06 12:44:32',NULL,NULL),(31100,'33881','S','Florence Villa','N','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.044545,-81.728425,0,'2013-07-06 12:44:32',NULL,NULL),(29169,'32353','P','Quincy','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.578986,-84.592801,0,'2013-07-06 12:44:32',NULL,NULL),(13748,'14113','S','North Java','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.674870,-78.338627,0,'2013-07-06 12:44:31',NULL,NULL),(28109,'30803','S','Avera','D','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.193064,-82.528161,0,'2013-07-06 12:44:31',NULL,NULL),(6214,'05488','S','Fonda Jct','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(22097,'23413','P','Weirwood','A','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.474680,-75.858600,0,'2013-07-06 12:44:31',NULL,NULL),(51309,'59231','P','St Marie','N','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.402929,-106.543693,0,'2013-07-06 12:44:33',NULL,NULL),(56701,'65663','S','Half Way','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.601355,-93.248196,0,'2013-07-06 12:44:33',NULL,NULL),(58152,'68175','U','Mutual of Omaha','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.266258,-95.964336,0,'2013-07-06 12:44:33',NULL,NULL),(64521,'76638','S','Ocee','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.571640,-97.382220,0,'2013-07-06 12:44:34',NULL,NULL),(69245,'83422','S','Driggs','D','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.734162,-111.221574,0,'2013-07-06 12:44:34',NULL,NULL),(72706,'89448','P','Round Hill','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(73462,'91305','P','Canoga Park','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201051,-118.604164,0,'2013-07-06 12:44:34',NULL,NULL),(75379,'93940','S','Point Sur','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.587700,-121.849200,0,'2013-07-06 12:44:34',NULL,NULL),(75386,'93950','S','Del Monte Park','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.616554,-121.921728,0,'2013-07-06 12:44:34',NULL,NULL),(79807,'99401','S','Anatone','D','Asotin','53003','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.140853,-117.069258,0,'2013-07-06 12:44:34',NULL,NULL),(18816,'19406','S','King of Prussia','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.115940,-75.373740,0,'2013-07-06 12:44:31',NULL,NULL),(53625,'62092','S','Drake','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.440324,-90.402625,0,'2013-07-06 12:44:33',NULL,NULL),(28169,'30916','P','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.419732,-82.019129,0,'2013-07-06 12:44:31',NULL,NULL),(44504,'49930','S','Hancock','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.144700,-88.526760,0,'2013-07-06 12:44:32',NULL,NULL),(2686,'00968','S','Rexco Ind Park','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(44166,'49546','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(27370,'30069','U','Dobbins Air Force Base','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.916908,-84.517971,0,'2013-07-06 12:44:31',NULL,NULL),(67989,'80918','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.915062,-104.773227,0,'2013-07-06 12:44:34',NULL,NULL),(57344,'66725','S','Hallowell','A','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(981,'00716','S','Villa del Sagrado Corazon','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(37196,'41514','S','Turkey Creek','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(36043,'40205','S','Seneca Gardens','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(18841,'19426','S','Trappe','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.188960,-75.426360,0,'2013-07-06 12:44:31',NULL,NULL),(5089,'04336','U','Central Me Power Co','N','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.334800,-69.742850,0,'2013-07-06 12:44:30',NULL,NULL),(56022,'64668','S','Norborne','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.299291,-93.677905,0,'2013-07-06 12:44:33',NULL,NULL),(67645,'80466','S','Nederland','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.963260,-105.492728,0,'2013-07-06 12:44:34',NULL,NULL),(35916,'40026','S','Goshen','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.415028,-85.562990,0,'2013-07-06 12:44:32',NULL,NULL),(20066,'20677','S','Port Tobacco','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.506797,-77.041996,0,'2013-07-06 12:44:31',NULL,NULL),(31092,'33873','S','Wauchula','D','Hardee','12049','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.543598,-81.820690,0,'2013-07-06 12:44:32',NULL,NULL),(50344,'57741','P','Fort Meade','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.409562,-103.474998,0,'2013-07-06 12:44:33',NULL,NULL),(25464,'28337','S','Elizabethtown','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.621800,-78.572100,0,'2013-07-06 12:44:31',NULL,NULL),(7846,'07470','S','Lionshead Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(73710,'91611','U','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186474,-118.395745,0,'2013-07-06 12:44:34',NULL,NULL),(65009,'77301','S','Tamina','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.311394,-95.433846,0,'2013-07-06 12:44:34',NULL,NULL),(3961,'02481','S','Wellesley Fms','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.316214,-71.265402,0,'2013-07-06 12:44:30',NULL,NULL),(56240,'65049','S','Four Seasons','A','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.200554,-92.711201,0,'2013-07-06 12:44:33',NULL,NULL),(1087,'00725','S','Urb Caguas Norte','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(47270,'54532','P','Heafford Junction','D','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.547200,-89.715180,0,'2013-07-06 12:44:32',NULL,NULL),(59827,'71235','S','Unionville','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.712180,-92.656020,0,'2013-07-06 12:44:33',NULL,NULL),(72537,'89173','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.177757,-115.134175,0,'2013-07-06 12:44:34',NULL,NULL),(78515,'98118','S','Columbia','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.541963,-122.267649,0,'2013-07-06 12:44:34',NULL,NULL),(55542,'63841','S','Dexter','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.794865,-89.959662,0,'2013-07-06 12:44:33',NULL,NULL),(47367,'54621','S','Chaseburg','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.655814,-91.012569,0,'2013-07-06 12:44:32',NULL,NULL),(37406,'41775','S','Wendover','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164398,-83.378767,0,'2013-07-06 12:44:32',NULL,NULL),(72197,'88414','S','Capulin Mountain National Mo','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.726135,-103.973999,0,'2013-07-06 12:44:34',NULL,NULL),(75924,'95014','S','Cupertino','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.314123,-122.044411,0,'2013-07-06 12:44:34',NULL,NULL),(2737,'00969','S','Urb La Villa de Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(43448,'48519','S','Flint','A','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.989167,-83.615887,0,'2013-07-06 12:44:32',NULL,NULL),(71117,'86016','P','Gray Mountain','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.746955,-111.474916,0,'2013-07-06 12:44:34',NULL,NULL),(18900,'19473','S','Schwenksville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.237680,-75.481440,0,'2013-07-06 12:44:31',NULL,NULL),(1805,'00784','S','Bda Borinquen','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(36479,'40769','S','Cumberlnd Clg','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.744037,-84.165125,0,'2013-07-06 12:44:32',NULL,NULL),(34534,'38686','U','Walls','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.956644,-90.152037,0,'2013-07-06 12:44:32',NULL,NULL),(15493,'16475','U','Albion Correctional Inst','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.892661,-80.377278,0,'2013-07-06 12:44:31',NULL,NULL),(15449,'16404','S','Centerville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.724924,-79.892407,0,'2013-07-06 12:44:31',NULL,NULL),(15192,'15951','P','Saint Michael','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.335698,-78.781204,0,'2013-07-06 12:44:31',NULL,NULL),(45445,'51230','S','Alvord','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.303422,-96.284316,0,'2013-07-06 12:44:32',NULL,NULL),(47051,'54413','P','Remington','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.280850,-90.112996,0,'2013-07-06 12:44:32',NULL,NULL),(52156,'60447','S','Minooka','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.507187,-88.334647,0,'2013-07-06 12:44:33',NULL,NULL),(55081,'63195','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.651601,-90.339813,0,'2013-07-06 12:44:33',NULL,NULL),(70734,'85305','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.527535,-112.250863,0,'2013-07-06 12:44:34',NULL,NULL),(71477,'87063','S','Willard','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.449626,-106.011354,0,'2013-07-06 12:44:34',NULL,NULL),(78957,'98370','S','Island Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(56303,'65085','S','Westphalia','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.428260,-92.023140,0,'2013-07-06 12:44:33',NULL,NULL),(36890,'41101','S','Summitt','A','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(11263,'11768','S','Northport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(69119,'83277','S','Springfield','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.062037,-112.663946,0,'2013-07-06 12:44:34',NULL,NULL),(75772,'94659','U','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.809982,-122.269201,0,'2013-07-06 12:44:34',NULL,NULL),(76762,'95927','P','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.751744,-121.812533,0,'2013-07-06 12:44:34',NULL,NULL),(19207,'19886','U','Shared Firm Zip','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.748270,-75.545647,0,'2013-07-06 12:44:31',NULL,NULL),(17859,'18433','S','Mayfield','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.533400,-75.542375,0,'2013-07-06 12:44:31',NULL,NULL),(36648,'41006','S','Butler','D','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.791002,-84.321560,0,'2013-07-06 12:44:32',NULL,NULL),(57011,'66205','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(13654,'14013','S','Alabama','A','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.071553,-78.387693,0,'2013-07-06 12:44:31',NULL,NULL),(55874,'64197','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.956872,-94.571143,0,'2013-07-06 12:44:33',NULL,NULL),(8973,'08822','S','Flemington','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.519697,-74.852845,0,'2013-07-06 12:44:30',NULL,NULL),(54759,'62985','S','Robbs','A','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.443539,-88.639922,0,'2013-07-06 12:44:33',NULL,NULL),(44978,'50423','S','Hutchins','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.095207,-93.799817,0,'2013-07-06 12:44:32',NULL,NULL),(49596,'56751','S','Pinecreek','N','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.846666,-95.757088,0,'2013-07-06 12:44:33',NULL,NULL),(16300,'17109','S','Penbrook','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.301280,-76.799940,0,'2013-07-06 12:44:31',NULL,NULL),(16038,'17044','S','Horningford','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(35439,'39476','S','Sand Hill','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.335000,-88.946160,0,'2013-07-06 12:44:32',NULL,NULL),(13293,'13665','S','Natural Brg','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.099422,-75.476914,0,'2013-07-06 12:44:30',NULL,NULL),(10955,'11499','U','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.649401,-73.783733,0,'2013-07-06 12:44:30',NULL,NULL),(9238,'09567','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(24867,'27668','U','National Info Syst Supt Cntr','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.842959,-78.634483,0,'2013-07-06 12:44:31',NULL,NULL),(22816,'24486','S','Weyers Cave','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.265140,-78.899185,0,'2013-07-06 12:44:31',NULL,NULL),(22798,'24471','S','Port Republic','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.318464,-78.812924,0,'2013-07-06 12:44:31',NULL,NULL),(2050,'00920','S','Bechara Ind Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(6925,'06156','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.758950,-72.732086,0,'2013-07-06 12:44:30',NULL,NULL),(8004,'07719','S','Wall Township','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(73247,'90703','S','Artesia','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.866635,-118.048458,0,'2013-07-06 12:44:34',NULL,NULL),(76164,'95317','S','El Nido','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.127370,-120.477572,0,'2013-07-06 12:44:34',NULL,NULL),(76524,'95646','P','Peddler Hill','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(77251,'96546','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(60733,'71961','S','Huddleston','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.604027,-93.831820,0,'2013-07-06 12:44:33',NULL,NULL),(27448,'30121','S','Cartersville','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.228469,-84.789525,0,'2013-07-06 12:44:31',NULL,NULL),(56060,'64744','S','El Dorado Spg','A','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.871840,-94.022563,0,'2013-07-06 12:44:33',NULL,NULL),(8602,'08232','S','West Atlantic City','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(44422,'49837','S','Brampton','A','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.880140,-87.047580,0,'2013-07-06 12:44:32',NULL,NULL),(78221,'97760','S','Crooked River Ranch','A','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358649,-121.184384,0,'2013-07-06 12:44:34',NULL,NULL),(73476,'91316','S','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.162355,-118.514077,0,'2013-07-06 12:44:34',NULL,NULL),(41731,'47250','S','Brooksburg','A','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.755353,-85.397514,0,'2013-07-06 12:44:32',NULL,NULL),(3136,'01252','P','N Egremont','A','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.196701,-73.436284,0,'2013-07-06 12:44:30',NULL,NULL),(8235,'08001','P','Paradise Lakes','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.562902,-75.349456,0,'2013-07-06 12:44:30',NULL,NULL),(34830,'38917','S','Valley Hill','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.632500,-89.895000,0,'2013-07-06 12:44:32',NULL,NULL),(21741,'23030','S','Charles City','D','Charles City','51036','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.337419,-77.050923,0,'2013-07-06 12:44:31',NULL,NULL),(23287,'25165','S','Racine','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.159981,-81.657018,0,'2013-07-06 12:44:31',NULL,NULL),(46345,'53093','S','Waldo','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.676495,-87.941985,0,'2013-07-06 12:44:32',NULL,NULL),(56302,'65085','S','Folk','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.428260,-92.023140,0,'2013-07-06 12:44:33',NULL,NULL),(63237,'75472','S','Point','D','Rains','48379','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.892875,-95.866525,0,'2013-07-06 12:44:33',NULL,NULL),(35384,'39455','S','Seneca','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(62969,'75126','S','Heathridge','A','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.745419,-96.455203,0,'2013-07-06 12:44:33',NULL,NULL),(23492,'25517','S','Genoa','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.084520,-82.475580,0,'2013-07-06 12:44:31',NULL,NULL),(26256,'29006','S','Batesburg-Leesville','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(75502,'94137','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.793155,-122.404322,0,'2013-07-06 12:44:34',NULL,NULL),(19214,'19892','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.683601,-75.613075,0,'2013-07-06 12:44:31',NULL,NULL),(18459,'19080','U','TV Guide Brm','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041159,-75.388173,0,'2013-07-06 12:44:31',NULL,NULL),(40528,'45831','S','Continental','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.102664,-84.253759,0,'2013-07-06 12:44:32',NULL,NULL),(20527,'21093','S','Timonium','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.434940,-76.654860,0,'2013-07-06 12:44:31',NULL,NULL),(76371,'95514','S','Blocksburg','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.293504,-123.635475,0,'2013-07-06 12:44:34',NULL,NULL),(77173,'96275','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(4854,'04016','P','Center Lovell','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.172349,-70.873151,0,'2013-07-06 12:44:30',NULL,NULL),(19695,'20374','S','Washington Navy Yard','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.828906,-77.015495,0,'2013-07-06 12:44:31',NULL,NULL),(39204,'44396','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.065643,-81.520817,0,'2013-07-06 12:44:32',NULL,NULL),(37943,'42712','S','Big Clifty','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.511098,-86.146073,0,'2013-07-06 12:44:32',NULL,NULL),(46030,'52554','S','Eldon','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.917020,-92.221138,0,'2013-07-06 12:44:32',NULL,NULL),(51076,'58760','S','Dunning','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.799553,-101.327522,0,'2013-07-06 12:44:33',NULL,NULL),(56674,'65632','S','Conway','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.518099,-92.751594,0,'2013-07-06 12:44:33',NULL,NULL),(65810,'78135','S','Checks in the Mail','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.703865,-98.117523,0,'2013-07-06 12:44:34',NULL,NULL),(69539,'83801','S','Belmont','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.936824,-116.675482,0,'2013-07-06 12:44:34',NULL,NULL),(74802,'93203','S','Di Giorgio','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.213446,-118.854447,0,'2013-07-06 12:44:34',NULL,NULL),(79818,'99505','S','JBER','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.255993,-149.689138,0,'2013-07-06 12:44:34',NULL,NULL),(44638,'50071','S','Dows','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.654039,-93.502101,0,'2013-07-06 12:44:32',NULL,NULL),(39214,'44405','S','Campbell','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.075132,-80.589868,0,'2013-07-06 12:44:32',NULL,NULL),(9998,'10167','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(44390,'49806','S','Au Train','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.430403,-86.838416,0,'2013-07-06 12:44:32',NULL,NULL),(57343,'66725','S','Columbus','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(42627,'47907','S','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.368719,-86.877988,0,'2013-07-06 12:44:32',NULL,NULL),(42413,'47802','S','Kingswood Terra','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(40794,'46172','S','Fincastle','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.847885,-86.799339,0,'2013-07-06 12:44:32',NULL,NULL),(37921,'42633','S','Sunnybrook','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(13877,'14260','U','University Buffalo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.003074,-78.785924,0,'2013-07-06 12:44:31',NULL,NULL),(14578,'15218','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426383,-79.888677,0,'2013-07-06 12:44:31',NULL,NULL),(45832,'52213','S','Center Point','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.192358,-91.757115,0,'2013-07-06 12:44:32',NULL,NULL),(46753,'53930','S','Endeavor','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.715623,-89.468193,0,'2013-07-06 12:44:32',NULL,NULL),(50705,'58365','S','Rock Lake','N','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.857949,-99.129655,0,'2013-07-06 12:44:33',NULL,NULL),(56743,'65717','S','Norwood','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.038780,-92.421700,0,'2013-07-06 12:44:33',NULL,NULL),(62449,'74192','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.153591,-95.995611,0,'2013-07-06 12:44:33',NULL,NULL),(35518,'39534','P','Boloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413857,-88.910394,0,'2013-07-06 12:44:32',NULL,NULL),(32421,'35976','S','Guntersville','D','Marshall','01095','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.335961,-86.307211,0,'2013-07-06 12:44:32',NULL,NULL),(31622,'34691','S','Holiday','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.192041,-82.754164,0,'2013-07-06 12:44:32',NULL,NULL),(21127,'22101','S','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.929874,-77.175966,0,'2013-07-06 12:44:31',NULL,NULL),(44524,'49952','S','Nisula','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.633823,-88.880318,0,'2013-07-06 12:44:32',NULL,NULL),(45062,'50514','S','Armstrong','D','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.395460,-94.486346,0,'2013-07-06 12:44:32',NULL,NULL),(66436,'78645','S','Jonestown','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.447624,-97.980615,0,'2013-07-06 12:44:34',NULL,NULL),(66471,'78659','S','Hills','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.198600,-97.105380,0,'2013-07-06 12:44:34',NULL,NULL),(70012,'84126','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700114,-111.948523,0,'2013-07-06 12:44:34',NULL,NULL),(19175,'19734','S','Townsend','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.382560,-75.665280,0,'2013-07-06 12:44:31',NULL,NULL),(52078,'60401','S','Sollitt','N','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.355724,-87.607332,0,'2013-07-06 12:44:33',NULL,NULL),(10123,'10260','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(67282,'80005','S','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.841453,-105.117853,0,'2013-07-06 12:44:34',NULL,NULL),(63716,'75926','S','Apple Springs','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.259600,-94.971845,0,'2013-07-06 12:44:34',NULL,NULL),(19663,'20310','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(39364,'44636','P','Kidron','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.742337,-81.747030,0,'2013-07-06 12:44:32',NULL,NULL),(10991,'11548','S','Old Brookville','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.793611,-73.627500,0,'2013-07-06 12:44:30',NULL,NULL),(42813,'48059','S','Burtchville','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(24699,'27435','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','704/980','Eastern',-5.0,'Y',36.064515,-79.826975,0,'2013-07-06 12:44:31',NULL,NULL),(20662,'21226','S','Greenland Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(65745,'78059','S','Natalia','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.185640,-98.853745,0,'2013-07-06 12:44:34',NULL,NULL),(75341,'93901','S','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.667014,-121.654897,0,'2013-07-06 12:44:34',NULL,NULL),(75552,'94246','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584235,-121.492266,0,'2013-07-06 12:44:34',NULL,NULL),(11013,'11558','S','Barnum Island','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.600901,-73.654227,0,'2013-07-06 12:44:30',NULL,NULL),(31902,'35146','S','Springville','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.777300,-86.451650,0,'2013-07-06 12:44:32',NULL,NULL),(27759,'30361','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.789903,-84.378744,0,'2013-07-06 12:44:31',NULL,NULL),(21552,'22748','P','Wolftown','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.358118,-78.348203,0,'2013-07-06 12:44:31',NULL,NULL),(21879,'23169','S','Topping','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.599000,-76.451820,0,'2013-07-06 12:44:31',NULL,NULL),(22756,'24426','S','Camp Appalachia','N','Covington City','51580','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.751640,-80.045760,0,'2013-07-06 12:44:31',NULL,NULL),(46514,'53267','U','Chase Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.043798,-87.909801,0,'2013-07-06 12:44:32',NULL,NULL),(52294,'60539','S','Batavia','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.823889,-88.334722,0,'2013-07-06 12:44:33',NULL,NULL),(53940,'62417','S','Petrolia','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.710903,-87.758111,0,'2013-07-06 12:44:33',NULL,NULL),(56747,'65722','S','Phillipsburg','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.574495,-92.768681,0,'2013-07-06 12:44:33',NULL,NULL),(57137,'66226','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.004920,-94.858860,0,'2013-07-06 12:44:33',NULL,NULL),(72133,'88301','S','Jicarilla','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.642604,-105.878878,0,'2013-07-06 12:44:34',NULL,NULL),(8589,'08225','S','Northfield','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.368215,-74.557570,0,'2013-07-06 12:44:30',NULL,NULL),(53229,'61638','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.804240,-89.629708,0,'2013-07-06 12:44:33',NULL,NULL),(15996,'17036','S','Stoverdale','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.277580,-76.708800,0,'2013-07-06 12:44:31',NULL,NULL),(33753,'37851','P','Pruden','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.541011,-83.876133,0,'2013-07-06 12:44:32',NULL,NULL),(50351,'57745','S','Mystic','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.124460,-103.719540,0,'2013-07-06 12:44:33',NULL,NULL),(43423,'48467','S','Port Austin','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.008740,-82.980780,0,'2013-07-06 12:44:32',NULL,NULL),(23788,'25989','S','White Oak','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.685504,-81.031173,0,'2013-07-06 12:44:31',NULL,NULL),(25557,'28411','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.227651,-77.945987,0,'2013-07-06 12:44:31',NULL,NULL),(40331,'45501','P','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.925818,-83.854004,0,'2013-07-06 12:44:32',NULL,NULL),(48181,'55386','S','Victoria','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.869314,-93.668930,0,'2013-07-06 12:44:33',NULL,NULL),(27185,'29850','P','Vaucluse','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.608533,-81.805438,0,'2013-07-06 12:44:31',NULL,NULL),(46450,'53210','S','Wawatosa','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.068996,-87.978957,0,'2013-07-06 12:44:32',NULL,NULL),(26716,'29414','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.821883,-80.055197,0,'2013-07-06 12:44:31',NULL,NULL),(50986,'58646','S','Burt','A','Hettinger','38041','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.395780,-102.428160,0,'2013-07-06 12:44:33',NULL,NULL),(17575,'18013','S','East Bangor','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.873341,-75.187858,0,'2013-07-06 12:44:31',NULL,NULL),(39781,'45123','S','Rainsboro','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.333281,-83.413658,0,'2013-07-06 12:44:32',NULL,NULL),(38565,'43771','S','Philo','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.848280,-81.936488,0,'2013-07-06 12:44:32',NULL,NULL),(33238,'37070','P','Goodlettsvlle','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.323710,-86.715822,0,'2013-07-06 12:44:32',NULL,NULL),(30192,'33179','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.954530,-80.183568,0,'2013-07-06 12:44:32',NULL,NULL),(20342,'20854','S','Potomac','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.028740,-77.240940,0,'2013-07-06 12:44:31',NULL,NULL),(48219,'55416','S','Golden Valley','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.948525,-93.344253,0,'2013-07-06 12:44:33',NULL,NULL),(65418,'77575','S','Ames','A','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.067839,-94.789652,0,'2013-07-06 12:44:34',NULL,NULL),(66739,'78961','P','Round Top','A','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.017222,-96.731667,0,'2013-07-06 12:44:34',NULL,NULL),(72614,'89415','S','Thorne','N','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(59518,'70791','S','Zachary','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.656276,-91.135331,0,'2013-07-06 12:44:33',NULL,NULL),(7713,'07192','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.730050,-74.176568,0,'2013-07-06 12:44:30',NULL,NULL),(69263,'83431','S','Lewisville','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.695725,-112.011916,0,'2013-07-06 12:44:34',NULL,NULL),(11301,'11777','S','Port Jefferson Station','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(31270,'34007','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(56783,'65753','S','Elkhead','N','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.964680,-93.127200,0,'2013-07-06 12:44:33',NULL,NULL),(8287,'08016','S','Burlngtn City','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.070260,-74.841534,0,'2013-07-06 12:44:30',NULL,NULL),(38583,'43804','S','Baltic','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.463509,-81.734242,0,'2013-07-06 12:44:32',NULL,NULL),(3928,'02462','S','Newtonville','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.331200,-71.258208,0,'2013-07-06 12:44:30',NULL,NULL),(1889,'00791','S','Villa Universitaria','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(28627,'31733','S','Chula','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.546387,-83.555566,0,'2013-07-06 12:44:32',NULL,NULL),(26706,'29410','S','Chas','N','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.194932,-80.029749,0,'2013-07-06 12:44:31',NULL,NULL),(3047,'01106','S','Longmeadow','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.052405,-72.567774,0,'2013-07-06 12:44:30',NULL,NULL),(44630,'50065','S','Pleasanton','A','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.639458,-93.812081,0,'2013-07-06 12:44:32',NULL,NULL),(48179,'55384','S','Spring Park','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.932917,-93.632453,0,'2013-07-06 12:44:33',NULL,NULL),(53963,'62428','S','Greenup','D','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(56724,'65692','S','Koshkonong','D','Oregon','29149','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.615535,-91.619978,0,'2013-07-06 12:44:33',NULL,NULL),(58822,'69039','S','Moorefield','D','Frontier','31063','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.548890,-100.287277,0,'2013-07-06 12:44:33',NULL,NULL),(62307,'74032','S','Glencoe','D','Payne','40119','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.224896,-96.927932,0,'2013-07-06 12:44:33',NULL,NULL),(72804,'89712','U','Nevada Highway Dept','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.163703,-119.764433,0,'2013-07-06 12:44:34',NULL,NULL),(76788,'95944','P','Goodyears Bar','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.586529,-120.818557,0,'2013-07-06 12:44:34',NULL,NULL),(867,'00698','S','Urb Mifedo','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(45199,'50622','S','Denver','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.669107,-92.334160,0,'2013-07-06 12:44:32',NULL,NULL),(22372,'23923','S','Charlotte C H','A','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.091464,-78.658894,0,'2013-07-06 12:44:31',NULL,NULL),(49148,'56377','S','Sartell','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.619260,-94.207387,0,'2013-07-06 12:44:33',NULL,NULL),(33345,'37174','S','Spring Hill','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.755896,-86.884965,0,'2013-07-06 12:44:32',NULL,NULL),(21009,'21840','S','Nanticoke','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.267147,-75.904241,0,'2013-07-06 12:44:31',NULL,NULL),(9003,'08853','S','Neshanic Station','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.508543,-74.717562,0,'2013-07-06 12:44:30',NULL,NULL),(18746,'19341','S','Franklin Ctr','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.040047,-75.636825,0,'2013-07-06 12:44:31',NULL,NULL),(42637,'47921','S','Boswell','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.518401,-87.357588,0,'2013-07-06 12:44:32',NULL,NULL),(16424,'17228','S','Harrisonville','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.977362,-78.082703,0,'2013-07-06 12:44:31',NULL,NULL),(8308,'08030','S','Gloucester','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.887704,-75.115680,0,'2013-07-06 12:44:30',NULL,NULL),(9532,'10020','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(25481,'28352','S','East Laurinburg','N','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.767212,-79.468392,0,'2013-07-06 12:44:31',NULL,NULL),(47797,'55049','S','Deerfield','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.171579,-93.246887,0,'2013-07-06 12:44:33',NULL,NULL),(49381,'56601','S','Bemidji','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(50538,'58122','U','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.881557,-96.784709,0,'2013-07-06 12:44:33',NULL,NULL),(61119,'72150','S','South Sheridan','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.305789,-92.400260,0,'2013-07-06 12:44:33',NULL,NULL),(67442,'80206','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.728500,-104.954037,0,'2013-07-06 12:44:34',NULL,NULL),(68603,'81610','S','Massadona','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.334596,-108.822045,0,'2013-07-06 12:44:34',NULL,NULL),(74385,'92509','S','Jurupa Valley','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.996714,-117.445775,0,'2013-07-06 12:44:34',NULL,NULL),(79286,'98580','S','Roy','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',46.962746,-122.483658,0,'2013-07-06 12:44:34',NULL,NULL),(54994,'63129','S','Mehlville','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.464400,-90.332031,0,'2013-07-06 12:44:33',NULL,NULL),(53612,'62083','S','Rosamond','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.393306,-89.194206,0,'2013-07-06 12:44:33',NULL,NULL),(52204,'60478','S','Country Club Hills','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.559523,-87.722149,0,'2013-07-06 12:44:33',NULL,NULL),(38139,'43130','S','Lancaster','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.707280,-82.607880,0,'2013-07-06 12:44:32',NULL,NULL),(46089,'52619','S','Argyle','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.564680,-91.579860,0,'2013-07-06 12:44:32',NULL,NULL),(69709,'84035','S','Jensen','D','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.382255,-109.314471,0,'2013-07-06 12:44:34',NULL,NULL),(75286,'93720','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.864207,-119.763501,0,'2013-07-06 12:44:34',NULL,NULL),(79450,'98846','S','Azwell','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.233413,-119.814273,0,'2013-07-06 12:44:34',NULL,NULL),(20375,'20880','P','Washington Grove','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.140721,-77.176247,0,'2013-07-06 12:44:31',NULL,NULL),(54712,'62957','S','Mc Clure','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.295028,-89.495807,0,'2013-07-06 12:44:33',NULL,NULL),(12532,'13036','S','Central Sq','A','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.306800,-76.178280,0,'2013-07-06 12:44:30',NULL,NULL),(49834,'57226','S','Altamont','A','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.758347,-96.683015,0,'2013-07-06 12:44:33',NULL,NULL),(27408,'30093','S','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.905579,-84.179966,0,'2013-07-06 12:44:31',NULL,NULL),(10040,'10174','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(79874,'99568','S','Clam Gulch','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.185789,-151.390457,0,'2013-07-06 12:44:34',NULL,NULL),(16268,'17090','S','Shermansdale','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.341440,-77.177825,0,'2013-07-06 12:44:31',NULL,NULL),(3571,'01960','S','West Peabody','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.533241,-70.972639,0,'2013-07-06 12:44:30',NULL,NULL),(59658,'71050','P','Longstreet','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.098082,-93.950883,0,'2013-07-06 12:44:33',NULL,NULL),(30579,'33415','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.663672,-80.126382,0,'2013-07-06 12:44:32',NULL,NULL),(42602,'47885','S','South Lake','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(28219,'31035','S','Harrison','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.877871,-82.744513,0,'2013-07-06 12:44:31',NULL,NULL),(41117,'46580','S','Warsaw','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.238354,-85.851876,0,'2013-07-06 12:44:32',NULL,NULL),(71186,'86045','P','Moenave','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.133993,-111.242465,0,'2013-07-06 12:44:34',NULL,NULL),(65939,'78255','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.643943,-98.664338,0,'2013-07-06 12:44:34',NULL,NULL),(19920,'20554','U','Fed Communications Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917033,-77.041158,0,'2013-07-06 12:44:31',NULL,NULL),(15415,'16353','S','Tionesta','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.493407,-79.458434,0,'2013-07-06 12:44:31',NULL,NULL),(73222,'90631','S','La Habra Hgts','A','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.941040,-117.954420,0,'2013-07-06 12:44:34',NULL,NULL),(13091,'13471','S','Annsville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.395357,-75.611063,0,'2013-07-06 12:44:30',NULL,NULL),(21143,'22108','U','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.936723,-77.177728,0,'2013-07-06 12:44:31',NULL,NULL),(65875,'78220','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.411125,-98.403840,0,'2013-07-06 12:44:34',NULL,NULL),(50423,'57787','S','Union Center','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.733611,-102.654167,0,'2013-07-06 12:44:33',NULL,NULL),(30265,'33238','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.854728,-80.182494,0,'2013-07-06 12:44:32',NULL,NULL),(6203,'05485','P','Sheldon Spgs','A','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.910556,-72.907500,0,'2013-07-06 12:44:30',NULL,NULL),(79877,'99571','P','Cold Bay','D','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.180000,-162.720000,0,'2013-07-06 12:44:34',NULL,NULL),(20286,'20794','S','Jessup','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.154739,-76.811082,0,'2013-07-06 12:44:31',NULL,NULL),(37948,'42717','S','Bow','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(44915,'50330','U','Wells Fargo Mortgage','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587059,-93.637291,0,'2013-07-06 12:44:32',NULL,NULL),(47423,'54662','P','Tunnel City','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.999554,-90.560139,0,'2013-07-06 12:44:32',NULL,NULL),(9908,'10133','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.776988,-73.983519,0,'2013-07-06 12:44:30',NULL,NULL),(17739,'18302','S','E Strodsburg','N','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024159,-75.185836,0,'2013-07-06 12:44:31',NULL,NULL),(16252,'17083','P','Quentin','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.281931,-76.437757,0,'2013-07-06 12:44:31',NULL,NULL),(1034,'00720','S','Urb Santa Teresita','N','Orocovis','72107','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.229109,-66.391520,0,'2013-07-06 12:44:30',NULL,NULL),(62637,'74562','S','Rattan','D','Pushmataha','40127','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.308134,-95.266861,0,'2013-07-06 12:44:33',NULL,NULL),(11832,'12242','U','Ny Standards and Purc','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652754,-73.757551,0,'2013-07-06 12:44:30',NULL,NULL),(46172,'52732','S','Six Mile','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.849037,-90.208697,0,'2013-07-06 12:44:32',NULL,NULL),(31062,'33845','P','Haines City','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.110209,-81.629416,0,'2013-07-06 12:44:32',NULL,NULL),(63957,'76092','S','Southlake','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.953968,-97.150453,0,'2013-07-06 12:44:34',NULL,NULL),(8557,'08205','S','Galloway Township','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.420254,-74.502031,0,'2013-07-06 12:44:30',NULL,NULL),(21573,'22831','S','Rawley Sprngs','N','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.485855,-79.006346,0,'2013-07-06 12:44:31',NULL,NULL),(25014,'27881','P','Speed','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.897439,-77.542637,0,'2013-07-06 12:44:31',NULL,NULL),(65736,'78049','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.532778,-99.467816,0,'2013-07-06 12:44:34',NULL,NULL),(65409,'77568','S','La Marque','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.365073,-94.974666,0,'2013-07-06 12:44:34',NULL,NULL),(20183,'20747','S','District Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854982,-76.887745,0,'2013-07-06 12:44:31',NULL,NULL),(50966,'58627','S','Gorham','A','Billings','38007','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.120520,-103.314000,0,'2013-07-06 12:44:33',NULL,NULL),(41021,'46380','P','Tefft','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.199044,-86.972303,0,'2013-07-06 12:44:32',NULL,NULL),(8198,'07928','S','Chatham Twp','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.733044,-74.403459,0,'2013-07-06 12:44:30',NULL,NULL),(20600,'21204','S','Towson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404090,-76.608279,0,'2013-07-06 12:44:31',NULL,NULL),(65332,'77517','S','Santa Fe','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.383481,-95.127808,0,'2013-07-06 12:44:34',NULL,NULL),(1075,'00725','S','Repto Solano','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(57691,'67276','S','USPS Offical Mail','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.660214,-97.415614,0,'2013-07-06 12:44:33',NULL,NULL),(50848,'58488','S','Tuttle','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.200872,-99.991392,0,'2013-07-06 12:44:33',NULL,NULL),(43196,'48303','P','Bloomfield Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(78454,'98068','P','Alpental','N','Kittitas','53037','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.412300,-121.418723,0,'2013-07-06 12:44:34',NULL,NULL),(3007,'01075','S','South Hadley Falls','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.253320,-72.579900,0,'2013-07-06 12:44:30',NULL,NULL),(50284,'57650','S','Ralph','D','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.854527,-103.034233,0,'2013-07-06 12:44:33',NULL,NULL),(43180,'48288','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.418809,-83.104982,0,'2013-07-06 12:44:32',NULL,NULL),(11617,'12095','S','Northbush','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.021140,-74.395500,0,'2013-07-06 12:44:30',NULL,NULL),(70506,'84782','S','Veyo','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.376940,-113.661480,0,'2013-07-06 12:44:34',NULL,NULL),(70846,'85543','S','Eden','N','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.883664,-109.832708,0,'2013-07-06 12:44:34',NULL,NULL),(77288,'96628','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(25501,'28372','S','Pembroke','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.682421,-79.194731,0,'2013-07-06 12:44:31',NULL,NULL),(59104,'70141','P','New Orleans','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.990560,-90.255338,0,'2013-07-06 12:44:33',NULL,NULL),(558,'00678','S','Bo Cacao','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(10046,'10175','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(26689,'29405','S','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(74626,'92805','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.835916,-117.908583,0,'2013-07-06 12:44:34',NULL,NULL),(75253,'93661','P','Santa Rita Pk','A','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.108668,-120.597447,0,'2013-07-06 12:44:34',NULL,NULL),(76609,'95690','S','Walnut Grove','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(77196,'96348','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(18452,'19074','S','Norwood','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.888802,-75.298020,0,'2013-07-06 12:44:31',NULL,NULL),(26206,'28779','S','Sylva','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.377705,-83.212160,0,'2013-07-06 12:44:31',NULL,NULL),(31672,'34760','P','Oakland','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.557035,-81.636210,0,'2013-07-06 12:44:32',NULL,NULL),(51190,'59027','S','Emigrant','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.182840,-110.937072,0,'2013-07-06 12:44:33',NULL,NULL),(40652,'46037','S','Fishers','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.947900,-85.975000,0,'2013-07-06 12:44:32',NULL,NULL),(24769,'27553','S','Manson','D','Vance','37181','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.468780,-78.292380,0,'2013-07-06 12:44:31',NULL,NULL),(66271,'78578','S','Port Isabel','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(65301,'77493','S','Katy','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.810252,-95.806907,0,'2013-07-06 12:44:34',NULL,NULL),(17323,'17860','S','Meadowview','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.833938,-76.639647,0,'2013-07-06 12:44:31',NULL,NULL),(39333,'44615','S','Harlem Springs','A','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(48789,'56002','P','No Mankato','N','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.161464,-94.005528,0,'2013-07-06 12:44:33',NULL,NULL),(66422,'78639','S','Kingsland','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.662580,-98.454420,0,'2013-07-06 12:44:34',NULL,NULL),(64203,'76253','P','Myra','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.624448,-97.314779,0,'2013-07-06 12:44:34',NULL,NULL),(52277,'60526','S','La Grange Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.831029,-87.873348,0,'2013-07-06 12:44:33',NULL,NULL),(62869,'75038','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.868383,-96.979437,0,'2013-07-06 12:44:33',NULL,NULL),(43979,'49329','S','Howard City','D','Montcalm','26117','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.412482,-85.459684,0,'2013-07-06 12:44:32',NULL,NULL),(79389,'98686','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.717060,-122.633301,0,'2013-07-06 12:44:34',NULL,NULL),(56305,'65101','S','Honey Creek','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(828,'00693','S','Villa Los Pescadores','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(67651,'80473','P','Rand','D','Jackson','08057','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.464742,-106.185505,0,'2013-07-06 12:44:34',NULL,NULL),(74790,'93140','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.421908,-119.678834,0,'2013-07-06 12:44:34',NULL,NULL),(30212,'33183','S','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.700327,-80.408398,0,'2013-07-06 12:44:32',NULL,NULL),(41153,'46701','S','Merriam','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(70625,'85135','S','Hayden','D','Gila','04007','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.998859,-110.786873,0,'2013-07-06 12:44:34',NULL,NULL),(74768,'93106','U','Univ of Ca Santa Barbara','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.431306,-119.834277,0,'2013-07-06 12:44:34',NULL,NULL),(35157,'39236','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364207,-90.145180,0,'2013-07-06 12:44:32',NULL,NULL),(28265,'31076','S','Reynolds','D','Taylor','13269','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.561496,-84.092692,0,'2013-07-06 12:44:31',NULL,NULL),(20957,'21779','S','Rohrersville','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.438150,-77.659315,0,'2013-07-06 12:44:31',NULL,NULL),(34118,'38187','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.076070,-89.843603,0,'2013-07-06 12:44:32',NULL,NULL),(76408,'95551','S','Loleta','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.653296,-124.227048,0,'2013-07-06 12:44:34',NULL,NULL),(68681,'82006','U','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.404407,-104.857277,0,'2013-07-06 12:44:34',NULL,NULL),(54645,'62926','S','Wetaug','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.360690,-89.167094,0,'2013-07-06 12:44:33',NULL,NULL),(31595,'34667','S','Bayonet Point','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.393847,-82.651438,0,'2013-07-06 12:44:32',NULL,NULL),(48276,'55431','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.824971,-93.316218,0,'2013-07-06 12:44:33',NULL,NULL),(32288,'35671','S','Tanner','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.720922,-86.974811,0,'2013-07-06 12:44:32',NULL,NULL),(1762,'00780','S','Haciendas del Monte','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(54906,'63080','S','Pea Ridge','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(52935,'61377','S','Evans','N','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.051074,-89.052018,0,'2013-07-06 12:44:33',NULL,NULL),(6504,'05819','S','St Johnsbury','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.434670,-72.038170,0,'2013-07-06 12:44:30',NULL,NULL),(63794,'75959','S','Miland','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.481280,-93.838320,0,'2013-07-06 12:44:34',NULL,NULL),(52215,'60481','S','Wilmington','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(10650,'11102','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770391,-73.923967,0,'2013-07-06 12:44:30',NULL,NULL),(28194,'31018','S','Davisboro','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.983468,-82.599047,0,'2013-07-06 12:44:31',NULL,NULL),(10142,'10271','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706437,-74.006835,0,'2013-07-06 12:44:30',NULL,NULL),(4935,'04086','S','Pejepscot','A','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.955940,-69.986340,0,'2013-07-06 12:44:30',NULL,NULL),(36740,'41034','S','Dover','D','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.636219,-83.789157,0,'2013-07-06 12:44:32',NULL,NULL),(38582,'43803','P','Bakersville','D','Coshocton','39031','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.355315,-81.643974,0,'2013-07-06 12:44:32',NULL,NULL),(40257,'45431','S','Beavercreek','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(12480,'12987','S','Upper Jay','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.329626,-73.840421,0,'2013-07-06 12:44:30',NULL,NULL),(51916,'60111','S','Clare','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.026711,-88.843818,0,'2013-07-06 12:44:33',NULL,NULL),(48686,'55927','S','Wasioja','N','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.033819,-92.866730,0,'2013-07-06 12:44:33',NULL,NULL),(61384,'72530','S','Wolf Bayou','N','Cleburne','05023','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.512977,-92.031354,0,'2013-07-06 12:44:33',NULL,NULL),(40903,'46255','U','Pnc Bank','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.766744,-86.163967,0,'2013-07-06 12:44:32',NULL,NULL),(45476,'51334','S','Gruver','A','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.407540,-94.824120,0,'2013-07-06 12:44:32',NULL,NULL),(33444,'37311','S','Cleveland','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.157330,-84.870390,0,'2013-07-06 12:44:32',NULL,NULL),(68520,'81332','P','Rico','D','Dolores','08033','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.687010,-108.030947,0,'2013-07-06 12:44:34',NULL,NULL),(62725,'74804','S','Shawnee','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.405591,-96.853291,0,'2013-07-06 12:44:33',NULL,NULL),(7788,'07424','S','W Paterson','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(54449,'62849','S','Iuka','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.613375,-88.790283,0,'2013-07-06 12:44:33',NULL,NULL),(4514,'03299','U','Tilton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.639447,-71.526265,0,'2013-07-06 12:44:30',NULL,NULL),(2118,'00924','S','Bda Hernandez','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(14866,'15462','S','Melcroft','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.062918,-79.356337,0,'2013-07-06 12:44:31',NULL,NULL),(28640,'31757','S','Tville','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.865689,-83.906478,0,'2013-07-06 12:44:32',NULL,NULL),(36510,'40828','S','Bailey Creek','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(53882,'62351','S','Tioga','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.086590,-91.284958,0,'2013-07-06 12:44:33',NULL,NULL),(70716,'85283','S','Guadalupe','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.365103,-111.928523,0,'2013-07-06 12:44:34',NULL,NULL),(76016,'95127','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.369641,-121.817818,0,'2013-07-06 12:44:34',NULL,NULL),(22078,'23358','S','Hacks Neck','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.581160,-75.796356,0,'2013-07-06 12:44:31',NULL,NULL),(1711,'00778','S','Bda Campamento','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(67336,'80047','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.698910,-104.765103,0,'2013-07-06 12:44:34',NULL,NULL),(5076,'04290','S','West Peru','N','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.474094,-70.449296,0,'2013-07-06 12:44:30',NULL,NULL),(78791,'98315','S','Bangor Submarine Base','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.697060,-122.722320,0,'2013-07-06 12:44:34',NULL,NULL),(43142,'48237','S','Oak Park','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465540,-83.197380,0,'2013-07-06 12:44:32',NULL,NULL),(61182,'72206','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.681307,-92.277760,0,'2013-07-06 12:44:33',NULL,NULL),(20427,'20913','P','Takoma Park','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.981883,-77.003878,0,'2013-07-06 12:44:31',NULL,NULL),(15467,'16424','S','Espyville','A','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.643900,-80.452080,0,'2013-07-06 12:44:31',NULL,NULL),(61600,'72765','P','Springdale','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.195888,-94.102795,0,'2013-07-06 12:44:33',NULL,NULL),(74601,'92705','S','North Tustin','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.753989,-117.791852,0,'2013-07-06 12:44:34',NULL,NULL),(45998,'52530','S','Agency','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.994699,-92.305353,0,'2013-07-06 12:44:32',NULL,NULL),(18614,'19147','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.936737,-75.154764,0,'2013-07-06 12:44:31',NULL,NULL),(77407,'96786','S','Wahiawa','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.503956,-158.032126,0,'2013-07-06 12:44:34',NULL,NULL),(75270,'93703','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.766864,-119.760866,0,'2013-07-06 12:44:34',NULL,NULL),(70001,'84123','S','Ssl','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(17121,'17774','S','Lungerville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.242038,-76.522091,0,'2013-07-06 12:44:31',NULL,NULL),(12810,'13252','U','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048582,-76.156564,0,'2013-07-06 12:44:30',NULL,NULL),(63873,'76008','S','Aledo','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699617,-97.628794,0,'2013-07-06 12:44:34',NULL,NULL),(44193,'49616','S','Benzonia','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.588594,-86.097228,0,'2013-07-06 12:44:32',NULL,NULL),(42656,'47949','S','Hillsboro','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.111682,-87.155988,0,'2013-07-06 12:44:32',NULL,NULL),(7346,'06722','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.556468,-73.038582,0,'2013-07-06 12:44:30',NULL,NULL),(70357,'84645','S','Rocky Ridge Town','A','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.819573,-111.852966,0,'2013-07-06 12:44:34',NULL,NULL),(76704,'95833','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.617200,-121.497424,0,'2013-07-06 12:44:34',NULL,NULL),(8768,'08543','P','Princeton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.311170,-74.651627,0,'2013-07-06 12:44:30',NULL,NULL),(15350,'16239','S','Marienville','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.471105,-79.125330,0,'2013-07-06 12:44:31',NULL,NULL),(61843,'73117','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.480060,-97.473067,0,'2013-07-06 12:44:33',NULL,NULL),(41868,'47359','S','Montpelier','D','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.553124,-85.277033,0,'2013-07-06 12:44:32',NULL,NULL),(61709,'73006','S','Apache','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.896478,-98.358744,0,'2013-07-06 12:44:33',NULL,NULL),(428,'00662','S','Sect Las Colinas','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(18095,'18708','S','Shavertown','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.300280,-75.965880,0,'2013-07-06 12:44:31',NULL,NULL),(70279,'84531','P','Mexican Hat','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.090427,-109.963375,0,'2013-07-06 12:44:34',NULL,NULL),(78217,'97759','S','Sisters','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.323931,-121.575944,0,'2013-07-06 12:44:34',NULL,NULL),(80077,'99731','S','Fort Greely','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.007436,-145.352807,0,'2013-07-06 12:44:34',NULL,NULL),(9474,'10010','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(63578,'75778','S','Murchison','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.332800,-95.773080,0,'2013-07-06 12:44:34',NULL,NULL),(40246,'45428','P','Veterans Administration','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.751559,-84.250474,0,'2013-07-06 12:44:32',NULL,NULL),(16486,'17255','S','Shade Gap','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.178946,-77.864435,0,'2013-07-06 12:44:31',NULL,NULL),(62704,'74741','S','Hendrix','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.792515,-96.312344,0,'2013-07-06 12:44:33',NULL,NULL),(40453,'45741','S','Dexter','A','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.062820,-82.249860,0,'2013-07-06 12:44:32',NULL,NULL),(34858,'38927','S','Teasdale','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.123299,-90.037402,0,'2013-07-06 12:44:32',NULL,NULL),(40115,'45323','S','Enon','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.866384,-83.934445,0,'2013-07-06 12:44:32',NULL,NULL),(36021,'40165','S','Hunters Hollow','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(44107,'49504','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.986465,-85.721042,0,'2013-07-06 12:44:32',NULL,NULL),(47321,'54559','S','Gurney','A','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.522463,-90.556240,0,'2013-07-06 12:44:32',NULL,NULL),(22460,'24034','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.280120,-79.938256,0,'2013-07-06 12:44:31',NULL,NULL),(21260,'22304','S','Trade Center','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.817208,-77.122599,0,'2013-07-06 12:44:31',NULL,NULL),(68061,'80934','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.844726,-104.860092,0,'2013-07-06 12:44:34',NULL,NULL),(48096,'55342','S','Hector','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.742203,-94.718005,0,'2013-07-06 12:44:33',NULL,NULL),(24700,'27438','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.055746,-79.804258,0,'2013-07-06 12:44:31',NULL,NULL),(42132,'47512','S','Indian Creek Settlement','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772909,-87.307853,0,'2013-07-06 12:44:32',NULL,NULL),(33849,'37995','U','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.963474,-83.915580,0,'2013-07-06 12:44:32',NULL,NULL),(74894,'93291','S','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.339890,-119.302225,0,'2013-07-06 12:44:34',NULL,NULL),(45977,'52407','P','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.975840,-91.655362,0,'2013-07-06 12:44:32',NULL,NULL),(24941,'27822','S','Elm City','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.804683,-77.861500,0,'2013-07-06 12:44:31',NULL,NULL),(75659,'94535','S','Travis AFB','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.249444,-122.038889,0,'2013-07-06 12:44:34',NULL,NULL),(5817,'05072','S','Strafford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.875457,-72.368589,0,'2013-07-06 12:44:30',NULL,NULL),(7872,'07508','S','North Haledon','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.951433,-74.185795,0,'2013-07-06 12:44:30',NULL,NULL),(67124,'79744','P','Iraan','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',30.914266,-101.898345,0,'2013-07-06 12:44:34',NULL,NULL),(71003,'85718','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.311140,-110.920394,0,'2013-07-06 12:44:34',NULL,NULL),(73593,'91387','S','Canyon Cntry','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425030,-118.444260,0,'2013-07-06 12:44:34',NULL,NULL),(14141,'14707','P','Allentown','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.090634,-78.062163,0,'2013-07-06 12:44:31',NULL,NULL),(42716,'48002','S','Berlin Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.908333,-82.883056,0,'2013-07-06 12:44:32',NULL,NULL),(42526,'47858','S','Brown Jug Corner','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.284987,-87.269499,0,'2013-07-06 12:44:32',NULL,NULL),(30913,'33707','S','St Pete Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(33712,'37773','P','Lone Mountain','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.392041,-83.584627,0,'2013-07-06 12:44:32',NULL,NULL),(35098,'39207','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.306196,-90.198595,0,'2013-07-06 12:44:32',NULL,NULL),(69476,'83666','S','Placerville','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.939898,-115.943131,0,'2013-07-06 12:44:34',NULL,NULL),(12578,'13069','S','Fulton','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(56797,'65762','S','Nottinghill','A','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.707587,-92.654958,0,'2013-07-06 12:44:33',NULL,NULL),(46931,'54156','S','Beecher','N','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.610380,-87.944100,0,'2013-07-06 12:44:32',NULL,NULL),(45703,'52057','S','Oneida','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.485840,-91.458289,0,'2013-07-06 12:44:32',NULL,NULL),(7867,'07504','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.910693,-74.144663,0,'2013-07-06 12:44:30',NULL,NULL),(36356,'40446','U','Lancaster','D','Garrard','21079','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.615778,-84.576415,0,'2013-07-06 12:44:32',NULL,NULL),(73773,'91739','S','Rancho Cucamonga','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.124307,-117.519639,0,'2013-07-06 12:44:34',NULL,NULL),(77583,'96915','S','Talofofo','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(66716,'78950','S','New Ulm','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.886455,-96.485737,0,'2013-07-06 12:44:34',NULL,NULL),(65670,'77984','S','Dreyer','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.432036,-97.175420,0,'2013-07-06 12:44:34',NULL,NULL),(5003,'04220','S','Buckfield','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.284737,-70.369237,0,'2013-07-06 12:44:30',NULL,NULL),(37133,'41465','S','Cyrus','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(58298,'68422','S','Pickrell','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.392206,-96.741093,0,'2013-07-06 12:44:33',NULL,NULL),(44364,'49785','U','Chippewa Temp Correction Fac','N','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.264580,-84.449270,0,'2013-07-06 12:44:32',NULL,NULL),(49413,'56629','P','Indus','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.564892,-94.239618,0,'2013-07-06 12:44:33',NULL,NULL),(51441,'59468','S','Power','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.650996,-111.479871,0,'2013-07-06 12:44:33',NULL,NULL),(6248,'05495','S','Saint George','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.427660,-73.087980,0,'2013-07-06 12:44:30',NULL,NULL),(33277,'37110','S','McMinnville','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.683587,-85.776477,0,'2013-07-06 12:44:32',NULL,NULL),(42791,'48046','P','Mount Clemens','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.592130,-82.883759,0,'2013-07-06 12:44:32',NULL,NULL),(23865,'26149','S','Middlebourne','D','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.500700,-80.890860,0,'2013-07-06 12:44:31',NULL,NULL),(31982,'35218','S','Ensley','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504425,-86.894499,0,'2013-07-06 12:44:32',NULL,NULL),(52557,'60951','S','Martinton','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.913951,-87.726692,0,'2013-07-06 12:44:33',NULL,NULL),(66784,'79043','S','Hart','D','Castro','48069','Texas','TX','48','0000','806','Central',-6.0,'Y',34.392192,-102.114554,0,'2013-07-06 12:44:34',NULL,NULL),(64266,'76389','S','Windthorst','D','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.580829,-98.431065,0,'2013-07-06 12:44:34',NULL,NULL),(57784,'67474','S','Portis','D','Osborne','20141','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.522247,-98.711636,0,'2013-07-06 12:44:33',NULL,NULL),(29872,'33040','S','Stock Island','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(45320,'50849','S','Stanzel','N','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.308687,-94.461680,0,'2013-07-06 12:44:32',NULL,NULL),(36743,'41037','P','Elizaville','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.419974,-83.824136,0,'2013-07-06 12:44:32',NULL,NULL),(78966,'98371','S','Edgewood','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(67630,'80448','P','Grant','D','Park','08093','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.484320,-105.741810,0,'2013-07-06 12:44:34',NULL,NULL),(13747,'14113','S','N Java','N','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.674870,-78.338627,0,'2013-07-06 12:44:31',NULL,NULL),(71638,'87415','S','Flora Vista','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.810837,-108.085388,0,'2013-07-06 12:44:34',NULL,NULL),(52717,'61201','S','Rock Island','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.487481,-90.569937,0,'2013-07-06 12:44:33',NULL,NULL),(44640,'50072','S','Pitzer','N','Madison','19121','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.491725,-94.122623,0,'2013-07-06 12:44:32',NULL,NULL),(43764,'49022','S','Benton Harbor','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.110957,-86.403985,0,'2013-07-06 12:44:32',NULL,NULL),(53014,'61462','S','Larchland','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.855000,-90.613056,0,'2013-07-06 12:44:33',NULL,NULL),(5923,'05252','S','Chiselville','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.057869,-73.137659,0,'2013-07-06 12:44:30',NULL,NULL),(66267,'78578','S','Isabel','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(76116,'95236','S','Linden','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.027781,-121.062818,0,'2013-07-06 12:44:34',NULL,NULL),(36311,'40374','S','Sharpsburg','D','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.245000,-83.868056,0,'2013-07-06 12:44:32',NULL,NULL),(42736,'48014','S','Mussey','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.023996,-82.924320,0,'2013-07-06 12:44:32',NULL,NULL),(74251,'92334','P','Fontana','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.075030,-117.469021,0,'2013-07-06 12:44:34',NULL,NULL),(74182,'92276','S','Thousand Palms','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.810639,-116.376227,0,'2013-07-06 12:44:34',NULL,NULL),(2417,'00953','S','Jard De Mediterraneo','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(14833,'15433','S','E Millsboro','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.971652,-79.964711,0,'2013-07-06 12:44:31',NULL,NULL),(9854,'10119','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(7322,'06702','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.555258,-73.039627,0,'2013-07-06 12:44:30',NULL,NULL),(43530,'48659','S','Sterling','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.064327,-84.025337,0,'2013-07-06 12:44:32',NULL,NULL),(13283,'13659','S','Diamond','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.791138,-75.824986,0,'2013-07-06 12:44:30',NULL,NULL),(40534,'45837','P','Dupont','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.056211,-84.300289,0,'2013-07-06 12:44:32',NULL,NULL),(40164,'45362','S','Rossburg','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.287418,-84.630866,0,'2013-07-06 12:44:32',NULL,NULL),(39281,'44483','S','Champion','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.278140,-80.817300,0,'2013-07-06 12:44:32',NULL,NULL),(9736,'10090','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(6682,'06039','S','Lakeville','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.952050,-73.433986,0,'2013-07-06 12:44:30',NULL,NULL),(54662,'62935','S','Brushy','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.844203,-88.609011,0,'2013-07-06 12:44:33',NULL,NULL),(7693,'07107','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.759519,-74.190730,0,'2013-07-06 12:44:30',NULL,NULL),(54328,'62757','U','Dept Public Property Cwlp','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.799583,-89.645158,0,'2013-07-06 12:44:33',NULL,NULL),(41030,'46385','S','Valparaiso','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.473056,-87.061111,0,'2013-07-06 12:44:32',NULL,NULL),(58546,'68815','S','Davis Creek','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.524360,-99.039205,0,'2013-07-06 12:44:33',NULL,NULL),(54792,'63012','S','Barnhart','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.336208,-90.437797,0,'2013-07-06 12:44:33',NULL,NULL),(77248,'96543','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(78975,'98372','S','Puyallup','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.205996,-122.271245,0,'2013-07-06 12:44:34',NULL,NULL),(67328,'80037','P','Commerce City','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.819298,-104.916784,0,'2013-07-06 12:44:34',NULL,NULL),(58993,'70056','S','Terrytown','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.890719,-90.030182,0,'2013-07-06 12:44:33',NULL,NULL),(54990,'63127','S','Sappington','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.541300,-90.407963,0,'2013-07-06 12:44:33',NULL,NULL),(34471,'38664','S','Banks','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(53521,'62026','U','Southern Illinois University','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.811295,-89.956641,0,'2013-07-06 12:44:33',NULL,NULL),(76122,'95245','S','Mokelumne Hl','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.305939,-120.598225,0,'2013-07-06 12:44:34',NULL,NULL),(47774,'55042','S','Lake Elmo','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.993774,-92.907951,0,'2013-07-06 12:44:33',NULL,NULL),(1651,'00772','S','Loiza','D','Loiza','72087','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.433938,-65.880795,0,'2013-07-06 12:44:30',NULL,NULL),(52212,'60481','S','Lorenzo','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(78848,'98338','S','Harbor Heights','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.033524,-122.293101,0,'2013-07-06 12:44:34',NULL,NULL),(60149,'71375','S','Montecello','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(25059,'27927','S','Corolla','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.325080,-75.809220,0,'2013-07-06 12:44:31',NULL,NULL),(19531,'20188','P','Vint Hill Frm','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.705891,-77.839374,0,'2013-07-06 12:44:31',NULL,NULL),(12581,'13069','S','Palermo','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(8943,'08757','S','Berkeley Township','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(67650,'80471','P','Pinecliffe','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.940262,-105.463365,0,'2013-07-06 12:44:34',NULL,NULL),(40071,'45275','P','Cin Arprt','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138322,-84.504469,0,'2013-07-06 12:44:32',NULL,NULL),(31587,'34655','S','New Pt Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.210274,-82.682809,0,'2013-07-06 12:44:32',NULL,NULL),(276,'00646','S','Comunidad Arenales II','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(8036,'07731','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.147323,-74.206531,0,'2013-07-06 12:44:30',NULL,NULL),(51416,'59444','S','Galata','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.734732,-111.468320,0,'2013-07-06 12:44:33',NULL,NULL),(7388,'06781','P','Pequabuck','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.671733,-73.032289,0,'2013-07-06 12:44:30',NULL,NULL),(22991,'24751','P','Wolfe','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.307986,-81.330659,0,'2013-07-06 12:44:31',NULL,NULL),(25901,'28644','S','Laurel Springs','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.448151,-81.252551,0,'2013-07-06 12:44:31',NULL,NULL),(29007,'32223','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.158207,-81.624997,0,'2013-07-06 12:44:32',NULL,NULL),(34420,'38635','S','Mt Pleasant','A','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.772162,-89.450965,0,'2013-07-06 12:44:32',NULL,NULL),(77279,'96614','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(45502,'51360','S','Montgomery','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(45390,'51030','S','Lawton','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.479685,-96.185734,0,'2013-07-06 12:44:32',NULL,NULL),(76816,'95954','S','Nimshew','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.835983,-121.595496,0,'2013-07-06 12:44:34',NULL,NULL),(23413,'25333','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352941,-81.633099,0,'2013-07-06 12:44:31',NULL,NULL),(22387,'23942','S','Green Bay','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.132330,-78.307103,0,'2013-07-06 12:44:31',NULL,NULL),(41193,'46723','S','Ari','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.222797,-85.273777,0,'2013-07-06 12:44:32',NULL,NULL),(19195,'19809','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.771847,-75.496485,0,'2013-07-06 12:44:31',NULL,NULL),(16647,'17343','P','McKnightstown','A','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.864464,-77.336847,0,'2013-07-06 12:44:31',NULL,NULL),(16317,'17121','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.314697,-76.874265,0,'2013-07-06 12:44:31',NULL,NULL),(36571,'40940','S','Fonde','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.629745,-83.888424,0,'2013-07-06 12:44:32',NULL,NULL),(29328,'32544','S','Hurlburt Field','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.421136,-86.695646,0,'2013-07-06 12:44:32',NULL,NULL),(14259,'14838','S','Erin','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.197260,-76.684904,0,'2013-07-06 12:44:31',NULL,NULL),(23449,'25419','S','Falling Wtrs','A','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.575745,-77.891093,0,'2013-07-06 12:44:31',NULL,NULL),(59687,'71070','S','Creston','A','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.118780,-92.975340,0,'2013-07-06 12:44:33',NULL,NULL),(15829,'16933','S','Whitneyville','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(1722,'00778','S','Mans de Navarro','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(4624,'03602','S','East Alstead','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.154442,-72.304628,0,'2013-07-06 12:44:30',NULL,NULL),(80175,'99833','P','Petersburg','D','Petersburg','02280','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.806343,-132.969633,0,'2013-07-06 12:44:34',NULL,NULL),(11857,'12260','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.669387,-73.773554,0,'2013-07-06 12:44:30',NULL,NULL),(69657,'84013','S','Fairfield','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.247580,-112.062060,0,'2013-07-06 12:44:34',NULL,NULL),(58973,'70040','S','Braithwaite','D','Plaquemines','22075','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.827869,-89.963279,0,'2013-07-06 12:44:33',NULL,NULL),(39851,'45169','S','Lees Creek','A','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.491952,-83.654601,0,'2013-07-06 12:44:32',NULL,NULL),(29166,'32352','S','Mount Pleasant','A','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.686033,-84.826115,0,'2013-07-06 12:44:32',NULL,NULL),(78844,'98336','S','Kosmos','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.526804,-122.119918,0,'2013-07-06 12:44:34',NULL,NULL),(16177,'17066','S','Mount Union','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.386060,-77.874060,0,'2013-07-06 12:44:31',NULL,NULL),(15492,'16475','U','Albion','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.892661,-80.377278,0,'2013-07-06 12:44:31',NULL,NULL),(3343,'01546','U','Central Mass P & D Ctr','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.291820,-71.745989,0,'2013-07-06 12:44:30',NULL,NULL),(43103,'48218','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331389,-83.045833,0,'2013-07-06 12:44:32',NULL,NULL),(7306,'06608','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.188008,-73.178690,0,'2013-07-06 12:44:30',NULL,NULL),(1184,'00727','S','Villa Esperanza','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(36616,'40977','S','Tinsley','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(38037,'43031','S','Johnstown','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.160799,-82.655946,0,'2013-07-06 12:44:32',NULL,NULL),(23824,'26101','S','Vienna','N','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.263058,-81.536120,0,'2013-07-06 12:44:31',NULL,NULL),(54684,'62943','S','Grantsburg','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(49538,'56681','S','Good Hope','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.631447,-94.176224,0,'2013-07-06 12:44:33',NULL,NULL),(30245,'33196','S','West Dade','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.651234,-80.481360,0,'2013-07-06 12:44:32',NULL,NULL),(8684,'08332','S','Millville','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.330240,-75.027540,0,'2013-07-06 12:44:30',NULL,NULL),(8848,'08645','U','State Income Tax','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.217190,-74.769632,0,'2013-07-06 12:44:30',NULL,NULL),(77825,'97208','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.530692,-122.565269,0,'2013-07-06 12:44:34',NULL,NULL),(28747,'31997','U','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.485272,-84.830872,0,'2013-07-06 12:44:32',NULL,NULL),(23071,'24881','P','Roderfield','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.449608,-81.709060,0,'2013-07-06 12:44:31',NULL,NULL),(120,'00612','S','Urb Villamar','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(2288,'00926','S','Villas de Carraizo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(78132,'97531','S','Cave Junction','A','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.163056,-123.646944,0,'2013-07-06 12:44:34',NULL,NULL),(32267,'35632','U','Univ of North Ala','N','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.841710,-87.606651,0,'2013-07-06 12:44:32',NULL,NULL),(4760,'03851','S','Milton','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.442259,-71.015713,0,'2013-07-06 12:44:30',NULL,NULL),(5565,'04860','S','Tenants Harbor','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.966485,-69.212306,0,'2013-07-06 12:44:30',NULL,NULL),(42923,'48111','S','Van Buren Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.174217,-83.489647,0,'2013-07-06 12:44:32',NULL,NULL),(14321,'14903','S','Elmira Heights','A','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.127740,-76.869660,0,'2013-07-06 12:44:31',NULL,NULL),(23473,'25446','S','Summit Point','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.241390,-77.970484,0,'2013-07-06 12:44:31',NULL,NULL),(21032,'21867','P','Fairmount','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.102657,-75.794628,0,'2013-07-06 12:44:31',NULL,NULL),(71653,'87501','S','Cuyamungue','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(71907,'87801','S','Escondida','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.006320,-106.793820,0,'2013-07-06 12:44:34',NULL,NULL),(63592,'75789','S','Griffin','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(23216,'25076','P','Ethel','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.864393,-81.913068,0,'2013-07-06 12:44:31',NULL,NULL),(9641,'10036','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(30709,'33497','P','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.349695,-80.231420,0,'2013-07-06 12:44:32',NULL,NULL),(43774,'49033','S','Ceresco','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.225723,-85.096442,0,'2013-07-06 12:44:32',NULL,NULL),(5603,'04929','S','Detroit','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.760918,-69.314253,0,'2013-07-06 12:44:30',NULL,NULL),(25682,'28518','S','Beulaville','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.920149,-77.821894,0,'2013-07-06 12:44:31',NULL,NULL),(21769,'23061','S','Pinero','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.435603,-76.547405,0,'2013-07-06 12:44:31',NULL,NULL),(53239,'61651','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.679871,-89.602186,0,'2013-07-06 12:44:33',NULL,NULL),(72017,'88044','S','Santo Tomas','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.100222,-106.686211,0,'2013-07-06 12:44:34',NULL,NULL),(62687,'74726','S','Bokchito','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.016496,-96.139454,0,'2013-07-06 12:44:33',NULL,NULL),(4637,'03609','S','No Walpole','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.141354,-72.445147,0,'2013-07-06 12:44:30',NULL,NULL),(38616,'43908','S','Bergholz','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.547038,-80.929703,0,'2013-07-06 12:44:32',NULL,NULL),(70814,'85377','P','Carefree','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.823262,-111.904780,0,'2013-07-06 12:44:34',NULL,NULL),(73047,'90084','U','Wells Fargo','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.056524,-118.265252,0,'2013-07-06 12:44:34',NULL,NULL),(69404,'83622','S','Silver Creek Plunge','N','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.055720,-115.624380,0,'2013-07-06 12:44:34',NULL,NULL),(14090,'14618','S','Loehmanns Plaza','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.119768,-77.556663,0,'2013-07-06 12:44:31',NULL,NULL),(23560,'25638','S','Barnabus','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.738800,-82.008780,0,'2013-07-06 12:44:31',NULL,NULL),(7533,'07006','S','North Caldwell','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.855020,-74.277840,0,'2013-07-06 12:44:30',NULL,NULL),(59856,'71256','S','Junction City','A','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.925196,-92.691728,0,'2013-07-06 12:44:33',NULL,NULL),(41212,'46730','S','Corunna','D','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.438215,-85.154373,0,'2013-07-06 12:44:32',NULL,NULL),(52293,'60538','S','Montgomery','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.709552,-88.336361,0,'2013-07-06 12:44:33',NULL,NULL),(41353,'46792','S','Meth Mem Home','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(6255,'05601','P','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.204239,-72.555100,0,'2013-07-06 12:44:30',NULL,NULL),(67515,'80241','S','Thornton','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.928789,-104.945551,0,'2013-07-06 12:44:34',NULL,NULL),(17049,'17751','S','Parvin','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(45187,'50613','S','Cedar Falls','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(79153,'98504','U','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.021117,-122.868044,0,'2013-07-06 12:44:34',NULL,NULL),(78731,'98282','S','Camano Island','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.174882,-122.521693,0,'2013-07-06 12:44:34',NULL,NULL),(29373,'32601','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.648924,-82.304742,0,'2013-07-06 12:44:32',NULL,NULL),(78480,'98101','S','Times Square','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.611330,-122.333219,0,'2013-07-06 12:44:34',NULL,NULL),(4447,'03247','P','Laconia','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.547500,-71.407222,0,'2013-07-06 12:44:30',NULL,NULL),(12179,'12764','S','Narrowsburg','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.587155,-74.978315,0,'2013-07-06 12:44:30',NULL,NULL),(62888,'75056','S','The Colony','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.097680,-96.883920,0,'2013-07-06 12:44:33',NULL,NULL),(3161,'01266','S','Alford','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.333061,-73.380396,0,'2013-07-06 12:44:30',NULL,NULL),(44809,'50238','S','Bethlehem','N','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.983991,-93.199488,0,'2013-07-06 12:44:32',NULL,NULL),(53116,'61543','P','Liverpool','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.425856,-90.035203,0,'2013-07-06 12:44:33',NULL,NULL),(7013,'06259','S','Ponfret Center','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.876521,-72.011578,0,'2013-07-06 12:44:30',NULL,NULL),(34242,'38388','S','Parker Crossroads','A','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.721022,-88.390326,0,'2013-07-06 12:44:32',NULL,NULL),(75045,'93516','S','Desert Lake','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.008562,-117.655982,0,'2013-07-06 12:44:34',NULL,NULL),(389,'00662','S','Comunidad Capiro','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(56677,'65635','S','Dadeville','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.529834,-93.708779,0,'2013-07-06 12:44:33',NULL,NULL),(21098,'22041','S','Baileys Xrds','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.846929,-77.142525,0,'2013-07-06 12:44:31',NULL,NULL),(45530,'51445','S','Ida Grove','D','Ida','19093','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.341791,-95.465297,0,'2013-07-06 12:44:32',NULL,NULL),(35165,'39269','S','A H McCoy Federal Bldg','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.299021,-90.185387,0,'2013-07-06 12:44:32',NULL,NULL),(1681,'00777','S','Ext Jard de Barcelona','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(31625,'34691','S','Tarpon Springs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.192041,-82.754164,0,'2013-07-06 12:44:32',NULL,NULL),(63287,'75559','S','Beaver Dam','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.503381,-94.615520,0,'2013-07-06 12:44:33',NULL,NULL),(57693,'67277','P','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.662437,-97.428894,0,'2013-07-06 12:44:33',NULL,NULL),(56750,'65724','S','Pittsburg','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.844802,-93.330659,0,'2013-07-06 12:44:33',NULL,NULL),(51840,'60069','S','Half Day','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194460,-87.910740,0,'2013-07-06 12:44:33',NULL,NULL),(74260,'92340','P','Hesperia','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.420224,-117.276583,0,'2013-07-06 12:44:34',NULL,NULL),(46358,'53104','S','Bristol','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.541955,-88.045185,0,'2013-07-06 12:44:32',NULL,NULL),(22848,'24531','S','Chatham','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.829539,-79.395110,0,'2013-07-06 12:44:31',NULL,NULL),(34192,'38331','P','Eaton','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.972969,-89.133432,0,'2013-07-06 12:44:32',NULL,NULL),(36405,'40513','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.015394,-84.593769,0,'2013-07-06 12:44:32',NULL,NULL),(46259,'53015','S','Cleveland','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.918804,-87.767648,0,'2013-07-06 12:44:32',NULL,NULL),(33551,'37401','P','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.038520,-85.308854,0,'2013-07-06 12:44:32',NULL,NULL),(12693,'13139','P','Poplar Ridge','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.740575,-76.597936,0,'2013-07-06 12:44:30',NULL,NULL),(23785,'25984','S','Rupert','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.961580,-80.692200,0,'2013-07-06 12:44:31',NULL,NULL),(56887,'66035','S','Highland','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.860584,-95.266266,0,'2013-07-06 12:44:33',NULL,NULL),(21897,'23185','S','Wlmg','N','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.266334,-76.709764,0,'2013-07-06 12:44:31',NULL,NULL),(42554,'47872','S','Mansfield','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(39744,'45071','P','West Chester','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.333798,-84.405623,0,'2013-07-06 12:44:32',NULL,NULL),(36175,'40243','S','Woodland Hls','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(75298,'93729','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.852444,-119.765566,0,'2013-07-06 12:44:34',NULL,NULL),(59546,'70821','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.457289,-91.124882,0,'2013-07-06 12:44:33',NULL,NULL),(24946,'27827','P','Falkland','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.698881,-77.513436,0,'2013-07-06 12:44:31',NULL,NULL),(10289,'10520','S','Croton Hdsn','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.216760,-73.896720,0,'2013-07-06 12:44:30',NULL,NULL),(23457,'25427','S','Hedgesville','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.549480,-78.070560,0,'2013-07-06 12:44:31',NULL,NULL),(40980,'46346','P','Kingsford Heights','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.479434,-86.694760,0,'2013-07-06 12:44:32',NULL,NULL),(28713,'31833','S','West Point','D','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.887649,-85.138122,0,'2013-07-06 12:44:32',NULL,NULL),(35931,'40046','S','Mount Eden','D','Spencer','21215','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.021586,-85.135305,0,'2013-07-06 12:44:32',NULL,NULL),(36379,'40472','S','Ravenna','D','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.685220,-83.942700,0,'2013-07-06 12:44:32',NULL,NULL),(66030,'78363','S','Kingsvl Naval','A','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.514425,-97.860850,0,'2013-07-06 12:44:34',NULL,NULL),(65828,'78150','S','Randolph AIR','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(28450,'31408','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.172908,-81.206224,0,'2013-07-06 12:44:32',NULL,NULL),(55346,'63558','S','New Cambria','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.758059,-92.769919,0,'2013-07-06 12:44:33',NULL,NULL),(42116,'47469','S','Roland','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(38744,'44030','S','Monroe Center','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(73941,'92054','S','Camp Pendleton','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.205217,-117.352732,0,'2013-07-06 12:44:34',NULL,NULL),(21801,'23085','S','King and Queen Court House','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.728500,-76.845215,0,'2013-07-06 12:44:31',NULL,NULL),(69864,'84092','S','Snowbird','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(46528,'53293','U','WI Dept Transportion','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.042193,-87.920190,0,'2013-07-06 12:44:32',NULL,NULL),(46958,'54182','P','Zachow','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.733306,-88.358285,0,'2013-07-06 12:44:32',NULL,NULL),(13717,'14081','S','Irving','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.556143,-79.122894,0,'2013-07-06 12:44:31',NULL,NULL),(79812,'99503','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.193435,-149.888062,0,'2013-07-06 12:44:34',NULL,NULL),(77408,'96788','P','Pukalani','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.834756,-156.338783,0,'2013-07-06 12:44:34',NULL,NULL),(61636,'72841','S','Harvey','D','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.862851,-93.763621,0,'2013-07-06 12:44:33',NULL,NULL),(4630,'03605','S','East Lempster','A','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.212734,-72.161103,0,'2013-07-06 12:44:30',NULL,NULL),(55227,'63435','S','Canton','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.130488,-91.527483,0,'2013-07-06 12:44:33',NULL,NULL),(78763,'98304','S','National','N','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.741603,-121.974327,0,'2013-07-06 12:44:34',NULL,NULL),(36483,'40801','P','Ages','N','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.859167,-83.249444,0,'2013-07-06 12:44:32',NULL,NULL),(12326,'12865','S','East Greenwich','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(5292,'04541','S','Chamberlain','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.887245,-69.499333,0,'2013-07-06 12:44:30',NULL,NULL),(66448,'78652','S','Manchaca','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.131837,-97.824948,0,'2013-07-06 12:44:34',NULL,NULL),(46392,'53152','P','New Munster','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.577244,-88.226018,0,'2013-07-06 12:44:32',NULL,NULL),(15742,'16901','S','Wellsboro','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(16279,'17101','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.262172,-76.880556,0,'2013-07-06 12:44:31',NULL,NULL),(77847,'97224','S','Durham','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.408703,-122.789445,0,'2013-07-06 12:44:34',NULL,NULL),(10505,'10968','S','Piermont','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.039429,-73.921498,0,'2013-07-06 12:44:30',NULL,NULL),(22768,'24440','S','Greenville','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.978489,-79.128091,0,'2013-07-06 12:44:31',NULL,NULL),(33940,'38071','P','Tipton','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.423532,-89.807982,0,'2013-07-06 12:44:32',NULL,NULL),(40319,'45469','U','University of Dayton','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.721166,-84.190652,0,'2013-07-06 12:44:32',NULL,NULL),(64550,'76652','S','Kopperl','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.121465,-97.581963,0,'2013-07-06 12:44:34',NULL,NULL),(76577,'95677','S','Rocklin','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.790376,-121.240241,0,'2013-07-06 12:44:34',NULL,NULL),(78271,'97859','P','Meacham','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.508204,-118.418869,0,'2013-07-06 12:44:34',NULL,NULL),(318,'00646','S','Valle Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(63548,'75765','S','Hawkins','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.655720,-95.197003,0,'2013-07-06 12:44:33',NULL,NULL),(59184,'70356','S','Gibson','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.657141,-90.958940,0,'2013-07-06 12:44:33',NULL,NULL),(18123,'18817','S','E Smithfield','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.861211,-76.614065,0,'2013-07-06 12:44:31',NULL,NULL),(47127,'54452','S','Schley','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.182325,-89.694701,0,'2013-07-06 12:44:32',NULL,NULL),(30279,'33256','P','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661865,-80.326386,0,'2013-07-06 12:44:32',NULL,NULL),(80005,'99671','P','Stebbins','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.470041,-162.259170,0,'2013-07-06 12:44:34',NULL,NULL),(57647,'67202','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.687225,-97.335079,0,'2013-07-06 12:44:33',NULL,NULL),(32533,'36103','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.397938,-86.326829,0,'2013-07-06 12:44:32',NULL,NULL),(78345,'98006','S','Eastgate','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.564251,-122.150636,0,'2013-07-06 12:44:34',NULL,NULL),(61564,'72727','S','Elkins','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.052406,-93.995694,0,'2013-07-06 12:44:33',NULL,NULL),(34871,'38940','S','Oxberry','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.691186,-89.939080,0,'2013-07-06 12:44:32',NULL,NULL),(10163,'10279','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(51279,'59112','U','Mt Dakota Util Co','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.791631,-108.539787,0,'2013-07-06 12:44:33',NULL,NULL),(59585,'71003','S','Athens','D','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.781553,-92.996060,0,'2013-07-06 12:44:33',NULL,NULL),(72373,'89032','S','College Park','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.224370,-115.171642,0,'2013-07-06 12:44:34',NULL,NULL),(61010,'72114','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(60454,'71653','S','Fairview','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(56838,'65808','P','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.189794,-93.262342,0,'2013-07-06 12:44:33',NULL,NULL),(52222,'60490','S','Bolingbrook','D','Will','17197','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.698611,-88.068333,0,'2013-07-06 12:44:33',NULL,NULL),(5876,'05149','S','Ludlow','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.392420,-72.697140,0,'2013-07-06 12:44:30',NULL,NULL),(71857,'87710','P','Eagle Nest','A','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.393000,-105.284400,0,'2013-07-06 12:44:34',NULL,NULL),(57743,'67432','S','Clay Center','D','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.382490,-97.120208,0,'2013-07-06 12:44:33',NULL,NULL),(37361,'41723','S','Toulouse','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.269914,-83.271246,0,'2013-07-06 12:44:32',NULL,NULL),(48291,'55436','S','Saint Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.901982,-93.372906,0,'2013-07-06 12:44:33',NULL,NULL),(26823,'29483','S','Summerville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.017824,-80.211350,0,'2013-07-06 12:44:31',NULL,NULL),(64558,'76655','S','Lorena','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.422120,-97.237920,0,'2013-07-06 12:44:34',NULL,NULL),(39322,'44609','S','Beloit','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.931159,-80.988990,0,'2013-07-06 12:44:32',NULL,NULL),(20840,'21644','S','Ingleside','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.128407,-75.881400,0,'2013-07-06 12:44:31',NULL,NULL),(31903,'35147','S','Sterrett','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.425188,-86.506690,0,'2013-07-06 12:44:32',NULL,NULL),(20993,'21821','S','Deal Island','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.167252,-75.905948,0,'2013-07-06 12:44:31',NULL,NULL),(59046,'70085','S','Shell Beach','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(60623,'71901','S','Central City','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(5480,'04744','P','Fort Kent Mills','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.237810,-68.581454,0,'2013-07-06 12:44:30',NULL,NULL),(17399,'17901','S','Heckscherville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(68952,'82942','P','Pt of Rocks','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.680884,-108.784929,0,'2013-07-06 12:44:34',NULL,NULL),(4043,'02630','S','Barnstable','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.700109,-70.302083,0,'2013-07-06 12:44:30',NULL,NULL),(8928,'08751','S','Ortley Beach','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.937620,-74.080080,0,'2013-07-06 12:44:30',NULL,NULL),(33732,'37819','S','Newcomb','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.544131,-84.186377,0,'2013-07-06 12:44:32',NULL,NULL),(31353,'34202','S','Lakewood Ranch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.475504,-82.392128,0,'2013-07-06 12:44:32',NULL,NULL),(18642,'19162','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955702,-75.181007,0,'2013-07-06 12:44:31',NULL,NULL),(45297,'50830','S','Afton','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.025666,-94.197746,0,'2013-07-06 12:44:32',NULL,NULL),(50244,'57625','S','Standing Rock Reservation','N','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.994139,-101.237386,0,'2013-07-06 12:44:33',NULL,NULL),(55297,'63530','S','Plainview','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.928400,-92.451724,0,'2013-07-06 12:44:33',NULL,NULL),(61377,'72526','P','Cushman','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.877635,-91.760580,0,'2013-07-06 12:44:33',NULL,NULL),(77502,'96836','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289782,-157.836148,0,'2013-07-06 12:44:34',NULL,NULL),(35050,'39177','P','Valley Park','D','Issaquena','28055','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.585852,-90.846431,0,'2013-07-06 12:44:32',NULL,NULL),(64310,'76468','P','Proctor','D','Comanche','48093','Texas','TX','48','0000','254','Central',-6.0,'Y',31.985493,-98.430272,0,'2013-07-06 12:44:34',NULL,NULL),(56586,'65550','S','Newburg','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.920180,-91.886100,0,'2013-07-06 12:44:33',NULL,NULL),(69574,'83832','S','Genesee','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.556134,-116.943048,0,'2013-07-06 12:44:34',NULL,NULL),(34748,'38852','S','Iuka','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(29978,'33092','P','Princeton','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.546985,-80.424765,0,'2013-07-06 12:44:32',NULL,NULL),(60627,'71901','S','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(24648,'27377','S','Whitsett','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.035608,-79.602646,0,'2013-07-06 12:44:31',NULL,NULL),(10700,'11225','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.662208,-73.955270,0,'2013-07-06 12:44:30',NULL,NULL),(6621,'05902','S','Beecher Falls','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.005352,-71.518858,0,'2013-07-06 12:44:30',NULL,NULL),(47035,'54405','S','Abbotsford','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.948218,-90.321911,0,'2013-07-06 12:44:32',NULL,NULL),(4420,'03229','S','Hopkinton','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.203240,-71.673060,0,'2013-07-06 12:44:30',NULL,NULL),(20379,'20884','P','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.142686,-77.195078,0,'2013-07-06 12:44:31',NULL,NULL),(4664,'03773','S','Newport','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.369645,-72.158576,0,'2013-07-06 12:44:30',NULL,NULL),(34440,'38649','P','Mount Pleasant','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.737265,-89.500427,0,'2013-07-06 12:44:32',NULL,NULL),(27128,'29804','P','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.532298,-81.570882,0,'2013-07-06 12:44:31',NULL,NULL),(27028,'29650','S','Greer','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.902548,-82.265574,0,'2013-07-06 12:44:31',NULL,NULL),(14451,'15106','S','Carnegie','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405231,-80.093696,0,'2013-07-06 12:44:31',NULL,NULL),(15913,'17017','S','Dalmatia','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.647411,-76.877332,0,'2013-07-06 12:44:31',NULL,NULL),(53130,'61548','S','Metamora','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.788480,-89.427180,0,'2013-07-06 12:44:33',NULL,NULL),(58451,'68722','S','Anoka','A','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.916707,-98.831811,0,'2013-07-06 12:44:33',NULL,NULL),(66353,'78612','S','Cedar Creek','D','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.072856,-97.521573,0,'2013-07-06 12:44:34',NULL,NULL),(70921,'85633','P','Sasabe','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.486582,-111.543709,0,'2013-07-06 12:44:34',NULL,NULL),(71809,'87569','P','Bernal','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.392778,-105.316944,0,'2013-07-06 12:44:34',NULL,NULL),(79248,'98559','P','Malone','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.960635,-123.332273,0,'2013-07-06 12:44:34',NULL,NULL),(51806,'60048','S','Libertyville','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.293735,-87.944893,0,'2013-07-06 12:44:33',NULL,NULL),(68933,'82929','P','Little America','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.542836,-109.857942,0,'2013-07-06 12:44:34',NULL,NULL),(75817,'94820','P','El Sobrante','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.978266,-122.295281,0,'2013-07-06 12:44:34',NULL,NULL),(79869,'99564','P','Chignik','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.299937,-158.406727,0,'2013-07-06 12:44:34',NULL,NULL),(43322,'48360','S','Orion','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.766320,-83.278020,0,'2013-07-06 12:44:32',NULL,NULL),(14952,'15613','S','Apollo','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.540093,-79.603839,0,'2013-07-06 12:44:31',NULL,NULL),(13567,'13841','S','Smithville Flats','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.397440,-75.836580,0,'2013-07-06 12:44:31',NULL,NULL),(41419,'46819','S','Waynedale','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.996887,-85.132630,0,'2013-07-06 12:44:32',NULL,NULL),(49519,'56672','S','Smoky Hollow','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(35102,'39208','S','Jackson','A','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.271720,-90.104940,0,'2013-07-06 12:44:32',NULL,NULL),(22486,'24063','P','Blacksburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.228841,-80.415762,0,'2013-07-06 12:44:31',NULL,NULL),(67859,'80826','U','Limon','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.263889,-103.692415,0,'2013-07-06 12:44:34',NULL,NULL),(73034,'90075','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.064493,-118.309555,0,'2013-07-06 12:44:34',NULL,NULL),(16231,'17075','P','Newtn Hamltn','N','Mifflin','42087','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.393403,-77.835133,0,'2013-07-06 12:44:31',NULL,NULL),(52343,'60599','S','Fox Valley','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.772102,-88.357402,0,'2013-07-06 12:44:33',NULL,NULL),(69563,'83816','P','CDA','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.667270,-116.779061,0,'2013-07-06 12:44:34',NULL,NULL),(75299,'93730','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.889477,-119.755253,0,'2013-07-06 12:44:34',NULL,NULL),(54743,'62972','S','Tunnel Hl','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.533890,-88.763201,0,'2013-07-06 12:44:33',NULL,NULL),(10333,'10550','S','Mount Vernon','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.907698,-73.838538,0,'2013-07-06 12:44:30',NULL,NULL),(39915,'45219','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.126100,-84.517318,0,'2013-07-06 12:44:32',NULL,NULL),(66681,'78940','S','Fayetteville','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.942640,-96.681300,0,'2013-07-06 12:44:34',NULL,NULL),(14170,'14736','S','Findley Lake','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.107656,-79.732340,0,'2013-07-06 12:44:31',NULL,NULL),(23799,'26034','S','Chester','D','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.614822,-80.562027,0,'2013-07-06 12:44:31',NULL,NULL),(16629,'17332','U','Hanover','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.798105,-76.988197,0,'2013-07-06 12:44:31',NULL,NULL),(69250,'83423','S','Lidy Hot Springs','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(47021,'54313','S','Hobart','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.558732,-88.102722,0,'2013-07-06 12:44:32',NULL,NULL),(16178,'17066','S','Mt Union','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.386060,-77.874060,0,'2013-07-06 12:44:31',NULL,NULL),(15625,'16698','U','Houtzdale','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.828332,-78.352347,0,'2013-07-06 12:44:31',NULL,NULL),(7305,'06607','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.179009,-73.164520,0,'2013-07-06 12:44:30',NULL,NULL),(67183,'79851','P','Sierra Blanca','D','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.228663,-105.187150,0,'2013-07-06 12:44:34',NULL,NULL),(79249,'98560','S','Matlock','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.223003,-123.466948,0,'2013-07-06 12:44:34',NULL,NULL),(449,'00662','S','Urb Manuel Corchado','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(40421,'45694','S','Wheelersburg','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.736369,-82.839582,0,'2013-07-06 12:44:32',NULL,NULL),(39213,'44404','S','Burghill','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.335819,-80.548258,0,'2013-07-06 12:44:32',NULL,NULL),(3298,'01509','P','Charlton Dept','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.172996,-71.975620,0,'2013-07-06 12:44:30',NULL,NULL),(36413,'40526','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.040959,-84.505885,0,'2013-07-06 12:44:32',NULL,NULL),(32240,'35593','S','Burntout','N','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.366192,-88.081170,0,'2013-07-06 12:44:32',NULL,NULL),(32046,'35253','P','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.486215,-86.740394,0,'2013-07-06 12:44:32',NULL,NULL),(13630,'13903','S','Hawleyton','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.097500,-75.894240,0,'2013-07-06 12:44:31',NULL,NULL),(6853,'06128','P','East Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.781773,-72.622460,0,'2013-07-06 12:44:30',NULL,NULL),(31033,'33803','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.014670,-81.934529,0,'2013-07-06 12:44:32',NULL,NULL),(5357,'04622','S','Beddington','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.601113,-67.926225,0,'2013-07-06 12:44:30',NULL,NULL),(3413,'01718','S','Vlg Nagog Wds','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.517046,-71.412305,0,'2013-07-06 12:44:30',NULL,NULL),(11735,'12182','S','Speigletown','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.775992,-73.660085,0,'2013-07-06 12:44:30',NULL,NULL),(5725,'05009','U','White River Junction','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.652072,-72.322990,0,'2013-07-06 12:44:30',NULL,NULL),(30597,'33421','P','Royal Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(26503,'29169','S','Westover Acres','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(7358,'06751','S','Bethlehem','D','Litchfield','09005','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.641051,-73.212828,0,'2013-07-06 12:44:30',NULL,NULL),(21866,'23153','S','Sandy Hook','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.779513,-77.964754,0,'2013-07-06 12:44:31',NULL,NULL),(50399,'57772','S','Porcupine','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.497460,-102.501680,0,'2013-07-06 12:44:33',NULL,NULL),(52814,'61282','S','Silvis','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.500274,-90.416164,0,'2013-07-06 12:44:33',NULL,NULL),(16101,'17052','S','Mapleton Depot','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(34944,'39051','S','Edinburg','A','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.758440,-89.584740,0,'2013-07-06 12:44:32',NULL,NULL),(25246,'28108','P','Mineral Spgs','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.930216,-80.675564,0,'2013-07-06 12:44:31',NULL,NULL),(69337,'83533','S','Greencreek','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.048611,-116.348611,0,'2013-07-06 12:44:34',NULL,NULL),(39795,'45133','S','Sugar Tree Ridge','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(15960,'17026','S','Fredericksbrg','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.447500,-76.414800,0,'2013-07-06 12:44:31',NULL,NULL),(17921,'18462','S','Starrucca','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.904059,-75.440288,0,'2013-07-06 12:44:31',NULL,NULL),(16217,'17073','S','Stricklerstwn','N','Lebanon','42075','Pennsylvania','PA','42','3240','610/484','Eastern',-5.0,'Y',40.308720,-76.252800,0,'2013-07-06 12:44:31',NULL,NULL),(66039,'78368','S','Swinney Switch','A','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(4131,'02746','S','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.663407,-70.936230,0,'2013-07-06 12:44:30',NULL,NULL),(42349,'47647','S','Buckskin','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.229577,-87.445172,0,'2013-07-06 12:44:32',NULL,NULL),(19152,'19712','U','Avon Products Inc','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.682928,-75.719180,0,'2013-07-06 12:44:31',NULL,NULL),(7880,'07512','S','Paterson','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.902106,-74.218941,0,'2013-07-06 12:44:30',NULL,NULL),(29433,'32686','S','Flemington','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.358780,-82.252850,0,'2013-07-06 12:44:32',NULL,NULL),(25511,'28383','S','Raynham','A','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.536371,-79.290511,0,'2013-07-06 12:44:31',NULL,NULL),(14369,'15025','S','Jefferson Hills','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.295525,-79.916350,0,'2013-07-06 12:44:31',NULL,NULL),(52088,'60407','S','Braceville','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.240640,-88.260120,0,'2013-07-06 12:44:33',NULL,NULL),(5365,'04625','P','Cranberry Is','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.245487,-68.257422,0,'2013-07-06 12:44:30',NULL,NULL),(17773,'18341','P','Minisink Hills','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.999999,-75.136178,0,'2013-07-06 12:44:31',NULL,NULL),(20641,'21221','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.294840,-76.436520,0,'2013-07-06 12:44:31',NULL,NULL),(18198,'18940','S','Newtown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245694,-74.942426,0,'2013-07-06 12:44:31',NULL,NULL),(38795,'44060','S','Mentor on the Lake','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(74893,'93290','P','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.328598,-119.293861,0,'2013-07-06 12:44:34',NULL,NULL),(65620,'77957','S','Edna','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.974180,-96.649920,0,'2013-07-06 12:44:34',NULL,NULL),(9672,'10041','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(24111,'26525','S','Cuzzart','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.646175,-79.624337,0,'2013-07-06 12:44:31',NULL,NULL),(36634,'41004','S','Gertrude','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(34751,'38852','S','Oldham','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(31777,'35020','S','Bessemer','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.400980,-86.941560,0,'2013-07-06 12:44:32',NULL,NULL),(50191,'57568','S','Edna','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.908664,-100.053403,0,'2013-07-06 12:44:33',NULL,NULL),(52447,'60669','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875708,-87.650623,0,'2013-07-06 12:44:33',NULL,NULL),(54423,'62837','S','Big Mound','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(1718,'00778','S','Ext Villa Marina','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(66213,'78550','S','Stuart Place','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(75564,'94262','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583814,-121.492154,0,'2013-07-06 12:44:34',NULL,NULL),(64814,'77025','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.690087,-95.433831,0,'2013-07-06 12:44:34',NULL,NULL),(18017,'18640','S','Yatesville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(9846,'10118','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(8114,'07821','S','Green Township','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.967267,-74.766575,0,'2013-07-06 12:44:30',NULL,NULL),(69053,'83230','S','Conda','D','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.732720,-111.533520,0,'2013-07-06 12:44:34',NULL,NULL),(65623,'77960','P','Fannin','D','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.656210,-97.422517,0,'2013-07-06 12:44:34',NULL,NULL),(18887,'19464','S','Stowe','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.242360,-75.636660,0,'2013-07-06 12:44:31',NULL,NULL),(36592,'40962','S','Plank','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(33189,'37033','S','Shipps Bend','N','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(26941,'29597','P','North Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.812707,-78.700848,0,'2013-07-06 12:44:31',NULL,NULL),(15981,'17033','S','Derry Church','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(24459,'27229','S','Canden','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.226802,-79.791427,0,'2013-07-06 12:44:31',NULL,NULL),(14487,'15135','S','McKeesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.303777,-79.815605,0,'2013-07-06 12:44:31',NULL,NULL),(4627,'03603','S','Unity','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.236105,-72.426678,0,'2013-07-06 12:44:30',NULL,NULL),(13505,'13808','S','Morris','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.547176,-75.243080,0,'2013-07-06 12:44:31',NULL,NULL),(44306,'49736','S','Goetzville','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.095000,-84.067020,0,'2013-07-06 12:44:32',NULL,NULL),(62585,'74465','P','Thlequah','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.906127,-94.985529,0,'2013-07-06 12:44:33',NULL,NULL),(63776,'75951','S','Erin','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(73079,'90210','S','Beverly Hills','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.096629,-118.412426,0,'2013-07-06 12:44:34',NULL,NULL),(8341,'08041','S','Jobstown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.024583,-74.686183,0,'2013-07-06 12:44:30',NULL,NULL),(62867,'75034','S','Frisco','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.153776,-96.848685,0,'2013-07-06 12:44:33',NULL,NULL),(69633,'84002','S','Altonah','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.462397,-110.466900,0,'2013-07-06 12:44:34',NULL,NULL),(72161,'88339','S','Elk','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.908298,-105.467489,0,'2013-07-06 12:44:34',NULL,NULL),(75470,'94104','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.792480,-122.397651,0,'2013-07-06 12:44:34',NULL,NULL),(79393,'98801','S','Kenroy','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(38930,'44122','S','Shaker Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(621,'00682','S','Bo Tras Talleres','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(19342,'20039','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.954422,-77.026360,0,'2013-07-06 12:44:31',NULL,NULL),(38703,'44003','S','West Andover','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.627584,-80.585183,0,'2013-07-06 12:44:32',NULL,NULL),(38668,'43950','S','St Clairsville','N','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.082971,-80.912626,0,'2013-07-06 12:44:32',NULL,NULL),(27238,'29922','S','Robertville','N','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.601990,-81.241810,0,'2013-07-06 12:44:31',NULL,NULL),(28211,'31029','S','Forsyth','D','Monroe','13207','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.030828,-83.936093,0,'2013-07-06 12:44:31',NULL,NULL),(46178,'52737','S','Columbus City','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.264947,-91.370101,0,'2013-07-06 12:44:32',NULL,NULL),(50508,'58072','S','Valley City','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.924715,-98.002870,0,'2013-07-06 12:44:33',NULL,NULL),(55597,'63939','S','Fairdealing','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.675012,-90.644378,0,'2013-07-06 12:44:33',NULL,NULL),(58908,'69219','S','Nenzel','D','Cherry','31031','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.925420,-101.102445,0,'2013-07-06 12:44:33',NULL,NULL),(79740,'99220','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.648868,-117.412449,0,'2013-07-06 12:44:34',NULL,NULL),(20103,'20706','S','Seabrook','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.963377,-76.854396,0,'2013-07-06 12:44:31',NULL,NULL),(31525,'34479','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.237548,-82.096893,0,'2013-07-06 12:44:32',NULL,NULL),(55041,'63140','S','Kinloch','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.737643,-90.323138,0,'2013-07-06 12:44:33',NULL,NULL),(50734,'58384','S','Willow City','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.617340,-100.299168,0,'2013-07-06 12:44:33',NULL,NULL),(13506,'13809','S','Mount Upton','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.406126,-75.409032,0,'2013-07-06 12:44:31',NULL,NULL),(24230,'26731','S','Lahmansville','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.163155,-79.042152,0,'2013-07-06 12:44:31',NULL,NULL),(71255,'86405','P','Lk Havasu Cty','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.499836,-114.314100,0,'2013-07-06 12:44:34',NULL,NULL),(43318,'48359','S','Lake Orion','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722304,-83.277927,0,'2013-07-06 12:44:32',NULL,NULL),(70917,'85632','S','Hilltop','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.177580,-109.379880,0,'2013-07-06 12:44:34',NULL,NULL),(68726,'82083','S','McFadden','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.782089,-105.885219,0,'2013-07-06 12:44:34',NULL,NULL),(65181,'77418','S','Buckhorn','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(44476,'49896','S','Wilson','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.657788,-87.397580,0,'2013-07-06 12:44:32',NULL,NULL),(54155,'62571','S','Dollville','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.390541,-88.964526,0,'2013-07-06 12:44:33',NULL,NULL),(9632,'10035','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(19794,'20434','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892939,-77.038927,0,'2013-07-06 12:44:31',NULL,NULL),(30912,'33707','S','South Pasadena','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(18865,'19444','S','Miquon','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.086163,-75.250559,0,'2013-07-06 12:44:31',NULL,NULL),(29461,'32714','S','Forest City','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.666520,-81.413231,0,'2013-07-06 12:44:32',NULL,NULL),(18797,'19390','S','West Grove','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.821687,-75.841624,0,'2013-07-06 12:44:31',NULL,NULL),(22657,'24270','S','Mendota','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.729564,-82.251407,0,'2013-07-06 12:44:31',NULL,NULL),(5715,'04988','S','Unity','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.610793,-69.338402,0,'2013-07-06 12:44:30',NULL,NULL),(1540,'00757','S','Jard De Santa Isabel','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(15783,'16923','S','Eleven Mile','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(10012,'10169','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(43620,'48813','S','Charlotte','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.572390,-84.838031,0,'2013-07-06 12:44:32',NULL,NULL),(43881,'49224','S','Albion','D','Calhoun','26025','Michigan','MI','26','3720','517','Eastern',-5.0,'Y',42.261733,-84.761805,0,'2013-07-06 12:44:32',NULL,NULL),(46880,'54110','S','Brillion','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.174703,-88.065451,0,'2013-07-06 12:44:32',NULL,NULL),(71588,'87316','P','Fort Wingate','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432945,-108.725842,0,'2013-07-06 12:44:34',NULL,NULL),(5393,'04652','S','Lubec','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.864857,-66.991337,0,'2013-07-06 12:44:30',NULL,NULL),(18209,'18950','P','Point Pleasant','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.414930,-75.067576,0,'2013-07-06 12:44:31',NULL,NULL),(40655,'46040','S','Fishers','A','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.927526,-85.828673,0,'2013-07-06 12:44:32',NULL,NULL),(29657,'32907','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.015502,-80.669053,0,'2013-07-06 12:44:32',NULL,NULL),(23316,'25208','S','Wharton','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.903787,-81.676067,0,'2013-07-06 12:44:31',NULL,NULL),(49533,'56679','P','S Intl Falls','A','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.587388,-93.399406,0,'2013-07-06 12:44:33',NULL,NULL),(50097,'57471','S','Roscoe','D','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.429120,-99.336780,0,'2013-07-06 12:44:33',NULL,NULL),(52970,'61426','P','Castleton','D','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.117801,-89.706054,0,'2013-07-06 12:44:33',NULL,NULL),(70967,'85654','P','Rillito','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.422677,-111.105357,0,'2013-07-06 12:44:34',NULL,NULL),(19076,'19560','S','Alsace Manor','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.396140,-75.889620,0,'2013-07-06 12:44:31',NULL,NULL),(24854,'27629','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.819644,-78.572747,0,'2013-07-06 12:44:31',NULL,NULL),(6281,'05641','S','Berlin','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(45578,'51534','S','Glenwood','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.047534,-95.742473,0,'2013-07-06 12:44:32',NULL,NULL),(21245,'22244','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855120,-77.050263,0,'2013-07-06 12:44:31',NULL,NULL),(51766,'60031','S','Gurnee','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.372254,-87.932034,0,'2013-07-06 12:44:33',NULL,NULL),(16577,'17320','S','Carroll Valley','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.755100,-77.376290,0,'2013-07-06 12:44:31',NULL,NULL),(29517,'32776','S','Mount Plymouth','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.804779,-81.535369,0,'2013-07-06 12:44:32',NULL,NULL),(51703,'60007','S','Elk Grove Village','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.008834,-88.001385,0,'2013-07-06 12:44:33',NULL,NULL),(51125,'58792','S','Voltaire','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.933754,-100.775619,0,'2013-07-06 12:44:33',NULL,NULL),(45839,'52219','S','Prairieburg','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.237355,-91.427686,0,'2013-07-06 12:44:32',NULL,NULL),(74546,'92673','S','San Clemente','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.461494,-117.637465,0,'2013-07-06 12:44:34',NULL,NULL),(77412,'96791','S','Waialua','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.577540,-158.124575,0,'2013-07-06 12:44:34',NULL,NULL),(57830,'67543','S','Haven','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.915145,-97.789184,0,'2013-07-06 12:44:33',NULL,NULL),(17558,'17981','S','Joliett','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(16923,'17603','S','Roherstown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(31188,'33932','P','Ft Myers Bch','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.449073,-81.932449,0,'2013-07-06 12:44:32',NULL,NULL),(29824,'33028','S','Hollywood','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028900,-80.344700,0,'2013-07-06 12:44:32',NULL,NULL),(888,'00704','S','Parc Parque','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(40256,'45431','S','Beaver Creek','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(62967,'75126','S','Heartland','A','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.745419,-96.455203,0,'2013-07-06 12:44:33',NULL,NULL),(57932,'67731','S','Bird City','D','Cheyenne','20023','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.749763,-101.534504,0,'2013-07-06 12:44:33',NULL,NULL),(29632,'32887','U','Houghton Mifflin Harcourt','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.384748,-81.467936,0,'2013-07-06 12:44:32',NULL,NULL),(6937,'06167','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768325,-72.682921,0,'2013-07-06 12:44:30',NULL,NULL),(45738,'52101','S','Nordness','N','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.392000,-91.882740,0,'2013-07-06 12:44:32',NULL,NULL),(68741,'82214','S','Guernsey','D','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.272833,-104.766893,0,'2013-07-06 12:44:34',NULL,NULL),(6488,'05773','S','S Wallingford','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.463580,-72.990360,0,'2013-07-06 12:44:30',NULL,NULL),(2763,'00969','S','Villas Reales','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(33705,'37766','S','La Follette','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.338280,-84.069600,0,'2013-07-06 12:44:32',NULL,NULL),(13251,'13643','P','Great Bend','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.034705,-75.721520,0,'2013-07-06 12:44:30',NULL,NULL),(26106,'28722','S','Columbus','D','Polk','37149','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.242270,-82.190564,0,'2013-07-06 12:44:31',NULL,NULL),(71967,'88009','P','Lordsburg','A','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.031636,-108.684444,0,'2013-07-06 12:44:34',NULL,NULL),(37296,'41632','S','Waldo','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.550571,-82.947420,0,'2013-07-06 12:44:32',NULL,NULL),(30072,'33154','S','Ind Crk Vlg','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(77023,'96096','S','Whitmore','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.646251,-121.913118,0,'2013-07-06 12:44:34',NULL,NULL),(60872,'72058','S','Springhill','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(55541,'63840','P','Deering','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.189281,-89.883509,0,'2013-07-06 12:44:33',NULL,NULL),(54809,'63020','S','Olympian Village','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.090460,-90.566700,0,'2013-07-06 12:44:33',NULL,NULL),(72148,'88323','P','Fort Stanton','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.498917,-105.523270,0,'2013-07-06 12:44:34',NULL,NULL),(64062,'76135','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.825756,-97.451279,0,'2013-07-06 12:44:34',NULL,NULL),(4137,'02748','S','Padanaram The Packet','N','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.598019,-70.954047,0,'2013-07-06 12:44:30',NULL,NULL),(16343,'17130','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.273135,-76.888847,0,'2013-07-06 12:44:31',NULL,NULL),(45237,'50650','S','Lamont','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.600344,-91.643904,0,'2013-07-06 12:44:32',NULL,NULL),(51583,'59803','S','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.821982,-114.017179,0,'2013-07-06 12:44:33',NULL,NULL),(55898,'64434','S','Conception Junction','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.276364,-94.718527,0,'2013-07-06 12:44:33',NULL,NULL),(58843,'69130','S','Darr','N','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.861917,-99.983057,0,'2013-07-06 12:44:33',NULL,NULL),(59268,'70454','S','Ponchatoula','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.441160,-90.397448,0,'2013-07-06 12:44:33',NULL,NULL),(66808,'79078','P','Sanford','D','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.700908,-101.531288,0,'2013-07-06 12:44:34',NULL,NULL),(60359,'71472','S','Sieper','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.205098,-92.787908,0,'2013-07-06 12:44:33',NULL,NULL),(58967,'70033','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.997577,-90.213594,0,'2013-07-06 12:44:33',NULL,NULL),(15919,'17019','S','Bermudian','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.098851,-77.022403,0,'2013-07-06 12:44:31',NULL,NULL),(58517,'68778','S','Springview','D','Keya Paha','31103','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.871901,-99.877057,0,'2013-07-06 12:44:33',NULL,NULL),(54707,'62954','S','Junction','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.680834,-88.257353,0,'2013-07-06 12:44:33',NULL,NULL),(54674,'62940','S','Grimsby','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.745311,-89.441223,0,'2013-07-06 12:44:33',NULL,NULL),(66564,'78737','S','Austin','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.216676,-97.915859,0,'2013-07-06 12:44:34',NULL,NULL),(70163,'84319','S','Hyrum','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.632165,-111.835497,0,'2013-07-06 12:44:34',NULL,NULL),(2368,'00949','S','Pradera','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(8532,'08109','S','Merchantville','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.950935,-75.052361,0,'2013-07-06 12:44:30',NULL,NULL),(38825,'44080','P','Parkman','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370196,-81.065945,0,'2013-07-06 12:44:32',NULL,NULL),(36135,'40228','S','Highview','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.139470,-85.630403,0,'2013-07-06 12:44:32',NULL,NULL),(35679,'39656','S','Society Hill','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.439273,-90.000185,0,'2013-07-06 12:44:32',NULL,NULL),(9581,'10027','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(31125,'33903','S','Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(12407,'12934','S','Ellenburg Center','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.829883,-73.859154,0,'2013-07-06 12:44:30',NULL,NULL),(21470,'22630','S','Lake Frederick','A','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.946389,-78.199722,0,'2013-07-06 12:44:31',NULL,NULL),(53569,'62056','S','Hornsby','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.190380,-89.637780,0,'2013-07-06 12:44:33',NULL,NULL),(78965,'98371','S','Alderton','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(64500,'76629','S','Tidwell Prairie','N','Robertson','48395','Texas','TX','48','0000','254','Central',-6.0,'Y',31.149300,-96.676320,0,'2013-07-06 12:44:34',NULL,NULL),(61020,'72116','S','N LR','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(28984,'32212','S','JAX Naval AIR','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(77671,'97028','S','Timbrline Ldg','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.306268,-121.746016,0,'2013-07-06 12:44:34',NULL,NULL),(3626,'02065','P','Ocean Bluff','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.091667,-70.706111,0,'2013-07-06 12:44:30',NULL,NULL),(27502,'30175','S','White Stone','N','Pickens','13227','Georgia','GA','13','0520','706/762','Eastern',-5.0,'Y',34.545086,-84.527119,0,'2013-07-06 12:44:31',NULL,NULL),(5106,'04352','S','Mount Vernon','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.508660,-69.990496,0,'2013-07-06 12:44:30',NULL,NULL),(2821,'00979','S','Parq de Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(6542,'05839','S','Barton','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.702820,-72.209220,0,'2013-07-06 12:44:30',NULL,NULL),(42597,'47885','S','Liggett','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(5511,'04769','S','Presque Isle','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.679927,-68.009785,0,'2013-07-06 12:44:30',NULL,NULL),(9940,'10155','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(27097,'29715','S','Fort Mill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.026320,-80.947200,0,'2013-07-06 12:44:31',NULL,NULL),(22678,'24313','S','Barren Springs','D','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.913901,-80.807836,0,'2013-07-06 12:44:31',NULL,NULL),(58589,'68840','S','Newark','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.745127,-98.841582,0,'2013-07-06 12:44:33',NULL,NULL),(59004,'70064','P','Kenner','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.023196,-90.251979,0,'2013-07-06 12:44:33',NULL,NULL),(69461,'83650','S','Silver City','N','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.053611,-116.394167,0,'2013-07-06 12:44:34',NULL,NULL),(73852,'91899','P','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.080816,-118.135414,0,'2013-07-06 12:44:34',NULL,NULL),(8319,'08034','S','Ashland','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908086,-75.004604,0,'2013-07-06 12:44:30',NULL,NULL),(33137,'36907','S','Cuba','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.391122,-88.359194,0,'2013-07-06 12:44:32',NULL,NULL),(40375,'45651','S','McArthur','N','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.249907,-82.478264,0,'2013-07-06 12:44:32',NULL,NULL),(7749,'07308','P','Five Corners','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.731521,-74.061754,0,'2013-07-06 12:44:30',NULL,NULL),(38724,'44022','S','Orange Village','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(43703,'48893','S','Weidman','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.671739,-84.988416,0,'2013-07-06 12:44:32',NULL,NULL),(58543,'68814','S','Myrtle','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.329198,-99.326790,0,'2013-07-06 12:44:33',NULL,NULL),(65154,'77393','P','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.175872,-95.504233,0,'2013-07-06 12:44:34',NULL,NULL),(79496,'98903','S','Sumach','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.561980,-120.667800,0,'2013-07-06 12:44:34',NULL,NULL),(8795,'08562','S','Wrightstown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.063017,-74.606180,0,'2013-07-06 12:44:30',NULL,NULL),(64104,'76179','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.906400,-97.433220,0,'2013-07-06 12:44:34',NULL,NULL),(40649,'46036','S','Pipe Creek','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(32978,'36612','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.751290,-88.110308,0,'2013-07-06 12:44:32',NULL,NULL),(2774,'00976','S','Bda Gonzalez','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(27357,'30060','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.936824,-84.529346,0,'2013-07-06 12:44:31',NULL,NULL),(66487,'78669','S','Spicewood','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.418049,-98.052665,0,'2013-07-06 12:44:34',NULL,NULL),(70980,'85706','S','Mission','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.117700,-110.894100,0,'2013-07-06 12:44:34',NULL,NULL),(51994,'60161','P','Melrose Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.904029,-87.861129,0,'2013-07-06 12:44:33',NULL,NULL),(44285,'49719','S','Cedarville','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.924883,-84.398988,0,'2013-07-06 12:44:32',NULL,NULL),(44240,'49663','S','Manton','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.420163,-85.432435,0,'2013-07-06 12:44:32',NULL,NULL),(3041,'01103','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.102044,-72.587143,0,'2013-07-06 12:44:30',NULL,NULL),(40482,'45776','S','Shade','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.167515,-82.025534,0,'2013-07-06 12:44:32',NULL,NULL),(37805,'42404','S','Clay','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.490563,-87.793465,0,'2013-07-06 12:44:32',NULL,NULL),(44742,'50164','S','Barrett Superette','N','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.558007,-94.416659,0,'2013-07-06 12:44:32',NULL,NULL),(56213,'65034','S','Fortuna','D','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.577840,-92.771549,0,'2013-07-06 12:44:33',NULL,NULL),(74713,'93013','S','Carpinteria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.402368,-119.518748,0,'2013-07-06 12:44:34',NULL,NULL),(7766,'07410','S','Fair Lawn','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.934411,-74.117638,0,'2013-07-06 12:44:30',NULL,NULL),(3583,'01984','S','Wenham','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.603665,-70.888664,0,'2013-07-06 12:44:30',NULL,NULL),(61969,'73184','U','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.620834,-97.571442,0,'2013-07-06 12:44:33',NULL,NULL),(54782,'63005','S','Clarkson Valley','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634884,-90.619343,0,'2013-07-06 12:44:33',NULL,NULL),(4888,'04046','S','Arundel','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.393701,-70.452320,0,'2013-07-06 12:44:30',NULL,NULL),(11953,'12449','S','Lake Katrine','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.997672,-74.003214,0,'2013-07-06 12:44:30',NULL,NULL),(53126,'61547','S','Lake Lancelot','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613781,-89.743465,0,'2013-07-06 12:44:33',NULL,NULL),(76911,'95991','S','Yuba City','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.995493,-121.621973,0,'2013-07-06 12:44:34',NULL,NULL),(74149,'92257','S','Bombay Beach','N','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.328560,-115.594200,0,'2013-07-06 12:44:34',NULL,NULL),(34452,'38654','S','Olive Branch','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.950007,-89.862634,0,'2013-07-06 12:44:32',NULL,NULL),(12775,'13212','S','North Syracuse','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.110960,-76.139280,0,'2013-07-06 12:44:30',NULL,NULL),(30860,'33661','U','Time Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.971525,-82.348109,0,'2013-07-06 12:44:32',NULL,NULL),(28118,'30811','P','Gough','D','Burke','13033','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.093410,-82.225707,0,'2013-07-06 12:44:31',NULL,NULL),(28564,'31601','S','Dasher','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.825593,-83.284447,0,'2013-07-06 12:44:32',NULL,NULL),(2491,'00956','S','Valle Bello Chalets','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(13910,'14303','S','Niagara Falls','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.087115,-79.037731,0,'2013-07-06 12:44:31',NULL,NULL),(24613,'27332','S','Sanford','D','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.462395,-79.172874,0,'2013-07-06 12:44:31',NULL,NULL),(24846,'27622','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.850683,-78.692667,0,'2013-07-06 12:44:31',NULL,NULL),(25149,'28023','S','China Grove','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.569405,-80.589620,0,'2013-07-06 12:44:31',NULL,NULL),(27973,'30563','S','Mount Airy','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.556772,-83.466688,0,'2013-07-06 12:44:31',NULL,NULL),(44480,'49905','S','Atlantic Mine','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.066379,-88.652963,0,'2013-07-06 12:44:32',NULL,NULL),(66452,'78653','S','Kimbro','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(74138,'92249','S','Heber','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.724409,-115.495553,0,'2013-07-06 12:44:34',NULL,NULL),(77482,'96822','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312545,-157.821044,0,'2013-07-06 12:44:34',NULL,NULL),(37551,'42064','S','Mexico','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(463,'00664','S','Alts De Borinquen','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(66141,'78468','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.706826,-97.355976,0,'2013-07-06 12:44:34',NULL,NULL),(73867,'91916','S','Descanso','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.922718,-116.631458,0,'2013-07-06 12:44:34',NULL,NULL),(35482,'39521','P','Bay Saint Louis','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.329135,-89.370668,0,'2013-07-06 12:44:32',NULL,NULL),(12246,'12827','S','Fort Ann','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.431600,-73.509180,0,'2013-07-06 12:44:30',NULL,NULL),(63455,'75684','S','Friar','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(42486,'47838','S','Haddon','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.117887,-87.465105,0,'2013-07-06 12:44:32',NULL,NULL),(19164,'19721','U','Citibank','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.663657,-75.568203,0,'2013-07-06 12:44:31',NULL,NULL),(6339,'05669','S','Roxbury','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(34526,'38683','S','Brownfield','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.947755,-88.899821,0,'2013-07-06 12:44:32',NULL,NULL),(25255,'28115','S','Mayhew','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.575801,-80.819083,0,'2013-07-06 12:44:31',NULL,NULL),(4616,'03597','P','W Stewartstwn','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.992788,-71.534456,0,'2013-07-06 12:44:30',NULL,NULL),(13325,'13679','S','Redwood','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.304223,-75.809610,0,'2013-07-06 12:44:30',NULL,NULL),(58200,'68322','S','Bruning','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.336633,-97.564394,0,'2013-07-06 12:44:33',NULL,NULL),(59301,'70510','S','Abbeville','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.904840,-92.133480,0,'2013-07-06 12:44:33',NULL,NULL),(60962,'72104','S','Butterfield','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(10351,'10573','S','Portchester','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.011395,-73.678286,0,'2013-07-06 12:44:30',NULL,NULL),(66706,'78947','S','Leo','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.391667,-97.147222,0,'2013-07-06 12:44:34',NULL,NULL),(71313,'86505','S','Cornfields','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(23098,'24931','S','Kieffer','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.880631,-80.587119,0,'2013-07-06 12:44:31',NULL,NULL),(55864,'64184','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.107300,-94.592461,0,'2013-07-06 12:44:33',NULL,NULL),(17667,'18098','U','Emmaus','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.527440,-75.500014,0,'2013-07-06 12:44:31',NULL,NULL),(16093,'17051','S','McVeytown','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(37740,'42304','P','Owensboro','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.777706,-87.168648,0,'2013-07-06 12:44:32',NULL,NULL),(15128,'15828','S','Clarington','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.325957,-79.150142,0,'2013-07-06 12:44:31',NULL,NULL),(33346,'37175','S','Stewart','D','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.323063,-87.895927,0,'2013-07-06 12:44:32',NULL,NULL),(2723,'00969','S','Urb Bellomonte','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(24630,'27360','S','Erwin Heights','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.880803,-80.083016,0,'2013-07-06 12:44:31',NULL,NULL),(11192,'11737','S','Farmingdale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.734914,-73.445600,0,'2013-07-06 12:44:30',NULL,NULL),(49597,'56751','S','Roseau','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.846666,-95.757088,0,'2013-07-06 12:44:33',NULL,NULL),(49874,'57260','S','Victor','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.878034,-96.713253,0,'2013-07-06 12:44:33',NULL,NULL),(69121,'83278','S','Lower Stanley','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.330002,-114.863022,0,'2013-07-06 12:44:34',NULL,NULL),(64030,'76122','U','Sw Baptist Theological Smry','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.725278,-97.320556,0,'2013-07-06 12:44:34',NULL,NULL),(46828,'54013','S','Glenwood City','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.064774,-92.196624,0,'2013-07-06 12:44:32',NULL,NULL),(20994,'21821','S','Wenona','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.167252,-75.905948,0,'2013-07-06 12:44:31',NULL,NULL),(3944,'02471','P','Watertown','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.369843,-71.174994,0,'2013-07-06 12:44:30',NULL,NULL),(26481,'29161','S','Peniel Crossroads','N','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.119660,-79.973820,0,'2013-07-06 12:44:31',NULL,NULL),(75870,'94949','S','Bel Marin Keyes','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.060614,-122.540903,0,'2013-07-06 12:44:34',NULL,NULL),(58965,'70031','S','Ama','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.853609,-90.298706,0,'2013-07-06 12:44:33',NULL,NULL),(26639,'29336','P','Fairforest','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.950367,-82.014946,0,'2013-07-06 12:44:31',NULL,NULL),(63176,'75407','S','Princeton','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.172085,-96.492064,0,'2013-07-06 12:44:33',NULL,NULL),(9267,'09608','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(39126,'44266','S','Black Horse','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.159227,-81.233714,0,'2013-07-06 12:44:32',NULL,NULL),(7490,'06907','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.094957,-73.519697,0,'2013-07-06 12:44:30',NULL,NULL),(15266,'16102','S','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.972448,-80.371590,0,'2013-07-06 12:44:31',NULL,NULL),(15142,'15853','S','Portland Mls','A','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.457360,-78.726660,0,'2013-07-06 12:44:31',NULL,NULL),(14842,'15440','S','Gibbon Glade','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.738983,-79.569951,0,'2013-07-06 12:44:31',NULL,NULL),(26522,'29201','S','State Hospital','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998223,-81.032546,0,'2013-07-06 12:44:31',NULL,NULL),(23616,'25712','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.397513,-82.448552,0,'2013-07-06 12:44:31',NULL,NULL),(23613,'25709','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.423996,-82.439606,0,'2013-07-06 12:44:31',NULL,NULL),(66547,'78732','S','Marshall Ford','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.374220,-97.892700,0,'2013-07-06 12:44:34',NULL,NULL),(75715,'94580','S','San Lorenzo','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.680307,-122.129440,0,'2013-07-06 12:44:34',NULL,NULL),(5237,'04471','S','Amity','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.890612,-67.847255,0,'2013-07-06 12:44:30',NULL,NULL),(33566,'37414','P','Chatta','N','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.026201,-85.230406,0,'2013-07-06 12:44:32',NULL,NULL),(43160,'48265','U','General Motors','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.441129,-82.930987,0,'2013-07-06 12:44:32',NULL,NULL),(77152,'96162','P','West Truckee','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.307577,-120.314785,0,'2013-07-06 12:44:34',NULL,NULL),(58452,'68722','S','Butte','D','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.916707,-98.831811,0,'2013-07-06 12:44:33',NULL,NULL),(19991,'20599','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893588,-77.001294,0,'2013-07-06 12:44:31',NULL,NULL),(36400,'40508','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.055734,-84.502272,0,'2013-07-06 12:44:32',NULL,NULL),(18428,'19063','S','Garden City','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(9883,'10124','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757053,-73.970342,0,'2013-07-06 12:44:30',NULL,NULL),(26662,'29376','S','Roebuck','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.860123,-81.950767,0,'2013-07-06 12:44:31',NULL,NULL),(11111,'11702','S','Captree Island','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(20609,'21207','S','Woodlawn','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.323820,-76.714260,0,'2013-07-06 12:44:31',NULL,NULL),(46583,'53536','S','Evansville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.770303,-89.271419,0,'2013-07-06 12:44:32',NULL,NULL),(46626,'53581','S','Richland Center','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.351140,-90.389940,0,'2013-07-06 12:44:32',NULL,NULL),(50060,'57440','S','Frankfort','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.760514,-98.279710,0,'2013-07-06 12:44:33',NULL,NULL),(53772,'62271','S','Okawville','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.418120,-89.524620,0,'2013-07-06 12:44:33',NULL,NULL),(65381,'77546','S','Friendswood','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.517354,-95.201259,0,'2013-07-06 12:44:34',NULL,NULL),(79931,'99614','P','Kipnuk','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.921938,-164.056522,0,'2013-07-06 12:44:34',NULL,NULL),(38498,'43699','P','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.631065,-83.618751,0,'2013-07-06 12:44:32',NULL,NULL),(20411,'20905','S','Colesville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.101870,-76.991042,0,'2013-07-06 12:44:31',NULL,NULL),(29558,'32810','S','Lockhart','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.618210,-81.442060,0,'2013-07-06 12:44:32',NULL,NULL),(56123,'64832','S','Asbury','D','Barton','29011','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.272981,-94.609466,0,'2013-07-06 12:44:33',NULL,NULL),(6557,'05846','S','Brighton','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.796300,-71.855580,0,'2013-07-06 12:44:30',NULL,NULL),(53300,'61734','S','Delavan','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.372475,-89.541913,0,'2013-07-06 12:44:33',NULL,NULL),(45382,'51024','S','Hinton','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.621194,-96.295955,0,'2013-07-06 12:44:32',NULL,NULL),(69643,'84006','S','Bingham Canyon','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.533333,-112.150000,0,'2013-07-06 12:44:34',NULL,NULL),(73673,'91601','S','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(534,'00674','S','Villas del Manati','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(36271,'40336','S','Pryse','A','Estill','21065','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.602680,-83.887230,0,'2013-07-06 12:44:32',NULL,NULL),(4669,'03777','S','Orford','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.895622,-72.066824,0,'2013-07-06 12:44:30',NULL,NULL),(17669,'18099','U','Emmaus','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.533963,-75.497936,0,'2013-07-06 12:44:31',NULL,NULL),(72485,'89131','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.300613,-115.237936,0,'2013-07-06 12:44:34',NULL,NULL),(72825,'89821','S','Emigrant Pass','A','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.580000,-116.480000,0,'2013-07-06 12:44:34',NULL,NULL),(57748,'67439','S','Ellsworth','D','Ellsworth','20053','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.732749,-98.225710,0,'2013-07-06 12:44:33',NULL,NULL),(73692,'91606','S','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186265,-118.391357,0,'2013-07-06 12:44:34',NULL,NULL),(76263,'95416','P','Boyes Hot Spg','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.312407,-122.482861,0,'2013-07-06 12:44:34',NULL,NULL),(78450,'98063','P','Auburn','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.305546,-122.320901,0,'2013-07-06 12:44:34',NULL,NULL),(79222,'98544','P','Galvin','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.743302,-123.026229,0,'2013-07-06 12:44:34',NULL,NULL),(15016,'15676','P','Pleasant Unity','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.237179,-79.451409,0,'2013-07-06 12:44:31',NULL,NULL),(68007,'80922','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.898824,-104.700007,0,'2013-07-06 12:44:34',NULL,NULL),(66301,'78586','S','Laureles','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(65480,'77640','S','Sabine','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(52287,'60532','S','Lisle','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.790983,-88.075644,0,'2013-07-06 12:44:33',NULL,NULL),(15669,'16805','P','State College','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.787354,-77.900156,0,'2013-07-06 12:44:31',NULL,NULL),(77360,'96739','P','Keauhou','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.648570,-155.999276,0,'2013-07-06 12:44:34',NULL,NULL),(62083,'73561','S','Terral','A','Jefferson','40067','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.959973,-97.761343,0,'2013-07-06 12:44:33',NULL,NULL),(20027,'20629','P','Dowell','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.340604,-76.453574,0,'2013-07-06 12:44:31',NULL,NULL),(3885,'02375','S','So Easton','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.028515,-71.100880,0,'2013-07-06 12:44:30',NULL,NULL),(12256,'12832','S','Granville','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(34728,'38848','S','Greenwood Spg','A','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.850186,-88.364251,0,'2013-07-06 12:44:32',NULL,NULL),(45172,'50601','S','Robertson','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.552024,-93.052562,0,'2013-07-06 12:44:32',NULL,NULL),(71008,'85721','U','Univ of Arizona','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.228886,-110.952157,0,'2013-07-06 12:44:34',NULL,NULL),(71736,'87535','S','Glorieta','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.572980,-105.773580,0,'2013-07-06 12:44:34',NULL,NULL),(69520,'83724','U','Federal Bldg','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.618309,-116.195538,0,'2013-07-06 12:44:34',NULL,NULL),(13535,'13826','S','Ouaquaga','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.111157,-75.645249,0,'2013-07-06 12:44:31',NULL,NULL),(3602,'02043','S','Hingham','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.227974,-70.891150,0,'2013-07-06 12:44:30',NULL,NULL),(67521,'80246','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.703000,-104.929994,0,'2013-07-06 12:44:34',NULL,NULL),(6538,'05836','S','East Hardwick','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.518538,-72.304708,0,'2013-07-06 12:44:30',NULL,NULL),(31569,'34614','S','Weeki Wachee','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.623474,-82.533927,0,'2013-07-06 12:44:32',NULL,NULL),(57452,'66846','S','Dunlap','A','Morris','20127','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.660778,-96.489119,0,'2013-07-06 12:44:33',NULL,NULL),(46284,'53040','S','Kewaskum','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.510597,-88.204941,0,'2013-07-06 12:44:32',NULL,NULL),(18321,'19023','S','Collingdale','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.917217,-75.266969,0,'2013-07-06 12:44:31',NULL,NULL),(77706,'97050','P','Rufus','D','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.680008,-120.699206,0,'2013-07-06 12:44:34',NULL,NULL),(80150,'99788','P','Chalkyitsik','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.564722,-145.273889,0,'2013-07-06 12:44:34',NULL,NULL),(66814,'79083','S','Stinnett','D','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.822707,-101.443863,0,'2013-07-06 12:44:34',NULL,NULL),(59525,'70804','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.449243,-91.174051,0,'2013-07-06 12:44:33',NULL,NULL),(57109,'66221','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(51328,'59261','S','Saco','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.457358,-107.338613,0,'2013-07-06 12:44:33',NULL,NULL),(48253,'55426','S','Golden Valley','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.952405,-93.377860,0,'2013-07-06 12:44:33',NULL,NULL),(16592,'17324','S','Pine Grove Furnace','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(29242,'32435','S','Defuniak Spgs','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.719521,-86.121763,0,'2013-07-06 12:44:32',NULL,NULL),(9596,'10030','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(78017,'97419','S','Cheshire','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.171738,-123.374306,0,'2013-07-06 12:44:34',NULL,NULL),(26011,'28676','S','State Rd','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.396418,-80.892260,0,'2013-07-06 12:44:31',NULL,NULL),(67448,'80211','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.767956,-105.014457,0,'2013-07-06 12:44:34',NULL,NULL),(52961,'61421','S','Milo','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.177575,-89.653011,0,'2013-07-06 12:44:33',NULL,NULL),(50587,'58235','S','Honeyford','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.104302,-97.450273,0,'2013-07-06 12:44:33',NULL,NULL),(70277,'84529','S','Kenilworth','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.689784,-110.807257,0,'2013-07-06 12:44:34',NULL,NULL),(47009,'54303','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.529758,-88.061259,0,'2013-07-06 12:44:32',NULL,NULL),(43394,'48440','P','Hadley','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.954184,-83.400690,0,'2013-07-06 12:44:32',NULL,NULL),(30652,'33461','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.612961,-80.089250,0,'2013-07-06 12:44:32',NULL,NULL),(31840,'35083','S','Holly Pond','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.181612,-86.618121,0,'2013-07-06 12:44:32',NULL,NULL),(13194,'13620','S','Castorland','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.888863,-75.459474,0,'2013-07-06 12:44:30',NULL,NULL),(18485,'19089','U','Chilton Co','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.045461,-75.387632,0,'2013-07-06 12:44:31',NULL,NULL),(1089,'00725','S','Urb Condado Moderno','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(47850,'55076','S','Inver Grove','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.849779,-93.034529,0,'2013-07-06 12:44:33',NULL,NULL),(78368,'98021','S','Queensborough','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791648,-122.217445,0,'2013-07-06 12:44:34',NULL,NULL),(61936,'73157','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.423290,-97.569614,0,'2013-07-06 12:44:33',NULL,NULL),(49446,'56639','S','Effie','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.852565,-93.622901,0,'2013-07-06 12:44:33',NULL,NULL),(63913,'76043','S','Glen Rose','D','Somervell','48425','Texas','TX','48','0000','254','Central',-6.0,'Y',32.233527,-97.750119,0,'2013-07-06 12:44:34',NULL,NULL),(60497,'71665','S','Calmer','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(73486,'91322','P','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.384669,-118.530023,0,'2013-07-06 12:44:34',NULL,NULL),(77021,'96094','S','Weed','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.466318,-122.383688,0,'2013-07-06 12:44:34',NULL,NULL),(75007,'93454','S','Sisquoc','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.877520,-120.331800,0,'2013-07-06 12:44:34',NULL,NULL),(75835,'94920','S','Bel Tiburon','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.893723,-122.471124,0,'2013-07-06 12:44:34',NULL,NULL),(77576,'96913','S','Tamuning','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(13161,'13607','S','Alexandria Bay','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(26378,'29080','S','South Lynchburg','N','Lee','45061','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.038853,-80.110297,0,'2013-07-06 12:44:31',NULL,NULL),(64394,'76538','S','Jonesboro','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.598240,-97.759127,0,'2013-07-06 12:44:34',NULL,NULL),(45119,'50560','S','Lu Verne','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.912847,-94.084571,0,'2013-07-06 12:44:32',NULL,NULL),(41787,'47320','S','Albany','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.295554,-85.241905,0,'2013-07-06 12:44:32',NULL,NULL),(15651,'16743','S','Pt Allegany','N','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.818170,-78.285029,0,'2013-07-06 12:44:31',NULL,NULL),(76820,'95956','P','Spanish Ranch','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.938546,-121.065083,0,'2013-07-06 12:44:34',NULL,NULL),(19921,'20554','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917033,-77.041158,0,'2013-07-06 12:44:31',NULL,NULL),(15721,'16872','S','Rebersburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.956168,-77.402514,0,'2013-07-06 12:44:31',NULL,NULL),(30488,'33355','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.112790,-80.303694,0,'2013-07-06 12:44:32',NULL,NULL),(44221,'49644','S','Peacock','N','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.165877,-85.958375,0,'2013-07-06 12:44:32',NULL,NULL),(77167,'96260','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77281,'96616','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(11329,'11789','S','Sound Beach','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.955253,-72.973851,0,'2013-07-06 12:44:30',NULL,NULL),(34559,'38726','S','Lobdell','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.786816,-90.981417,0,'2013-07-06 12:44:32',NULL,NULL),(45331,'50859','S','Prescott','D','Adams','19003','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.026690,-94.526282,0,'2013-07-06 12:44:32',NULL,NULL),(38323,'43412','S','Reno Beach','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.651607,-83.283540,0,'2013-07-06 12:44:32',NULL,NULL),(41235,'46738','S','Dutch Town','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(6785,'06105','S','West Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.769774,-72.699048,0,'2013-07-06 12:44:30',NULL,NULL),(64005,'76116','S','Benbrook','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.714361,-97.464571,0,'2013-07-06 12:44:34',NULL,NULL),(5847,'05091','S','Wood Stock','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627860,-72.537180,0,'2013-07-06 12:44:30',NULL,NULL),(50003,'57376','S','Tripp','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.254844,-97.989423,0,'2013-07-06 12:44:33',NULL,NULL),(29886,'33042','S','Sugarloaf','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(3557,'01944','S','Manchester','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.580512,-70.767075,0,'2013-07-06 12:44:30',NULL,NULL),(20195,'20751','S','Deale','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.785008,-76.552091,0,'2013-07-06 12:44:31',NULL,NULL),(72992,'90057','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.060269,-118.276734,0,'2013-07-06 12:44:34',NULL,NULL),(55619,'63964','S','Coldwater','N','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.225980,-90.441900,0,'2013-07-06 12:44:33',NULL,NULL),(74560,'92679','S','Portola Hills','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(78630,'98208','S','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.894914,-122.193377,0,'2013-07-06 12:44:34',NULL,NULL),(3540,'01910','U','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.473328,-70.961315,0,'2013-07-06 12:44:30',NULL,NULL),(25672,'28512','S','Atlanticbeach','N','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(66315,'78593','S','Rogerslacy','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.250864,-97.825711,0,'2013-07-06 12:44:34',NULL,NULL),(59974,'71322','S','Whiteville','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.943380,-92.185260,0,'2013-07-06 12:44:33',NULL,NULL),(24668,'27407','S','Sedgefield','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.012660,-79.869960,0,'2013-07-06 12:44:31',NULL,NULL),(20923,'21742','S','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.657087,-77.709741,0,'2013-07-06 12:44:31',NULL,NULL),(63119,'75312','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.769299,-96.827010,0,'2013-07-06 12:44:33',NULL,NULL),(51958,'60138','P','Glen Ellyn','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.879817,-88.064336,0,'2013-07-06 12:44:33',NULL,NULL),(78793,'98320','S','Brinnon','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.692975,-122.921442,0,'2013-07-06 12:44:34',NULL,NULL),(79034,'98397','P','Longmire','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.750763,-121.812001,0,'2013-07-06 12:44:34',NULL,NULL),(359,'00659','S','Est De La Ceiba','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(20764,'21503','P','Cumberland','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.647079,-78.759684,0,'2013-07-06 12:44:31',NULL,NULL),(54052,'62469','S','Trilla','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.389938,-88.339580,0,'2013-07-06 12:44:33',NULL,NULL),(47303,'54552','S','Lake','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(40976,'46341','S','Hebron','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.340420,-87.198181,0,'2013-07-06 12:44:32',NULL,NULL),(52904,'61361','S','Sheffield','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.354486,-89.738058,0,'2013-07-06 12:44:33',NULL,NULL),(66495,'78676','S','Pioneer Town','N','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.039060,-98.139780,0,'2013-07-06 12:44:34',NULL,NULL),(22480,'24058','P','Belspring','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136091,-80.661550,0,'2013-07-06 12:44:31',NULL,NULL),(22876,'24571','S','Lynch Station','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.146730,-79.364812,0,'2013-07-06 12:44:31',NULL,NULL),(8422,'08075','S','North Delran','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(35272,'39364','S','Toomsuba','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.431620,-88.466100,0,'2013-07-06 12:44:32',NULL,NULL),(73383,'91103','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.162838,-118.165209,0,'2013-07-06 12:44:34',NULL,NULL),(7461,'06870','S','Old Greenwich','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.035892,-73.567475,0,'2013-07-06 12:44:30',NULL,NULL),(17247,'17837','S','West Acres','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(58082,'68068','S','Washington','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.394305,-96.207856,0,'2013-07-06 12:44:33',NULL,NULL),(40940,'46295','U','USPS Scanner REpair','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.673619,-86.194091,0,'2013-07-06 12:44:32',NULL,NULL),(70474,'84763','P','Rockville','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.151777,-113.060415,0,'2013-07-06 12:44:34',NULL,NULL),(69162,'83320','S','Muldoon','N','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.287180,-113.924700,0,'2013-07-06 12:44:34',NULL,NULL),(8946,'08757','S','South Toms River','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(54950,'63117','S','Richmond Hts','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.628611,-90.319444,0,'2013-07-06 12:44:33',NULL,NULL),(40975,'46340','S','Hanna','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.412040,-86.777964,0,'2013-07-06 12:44:32',NULL,NULL),(34305,'38547','S','Brush Creek','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.125275,-86.020700,0,'2013-07-06 12:44:32',NULL,NULL),(1389,'00738','S','La Costa Apts','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(61205,'72260','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.747293,-92.286658,0,'2013-07-06 12:44:33',NULL,NULL),(39073,'44212','S','Brunswick','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.248756,-81.828533,0,'2013-07-06 12:44:32',NULL,NULL),(42640,'47924','P','Buck Creek','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.485527,-86.759583,0,'2013-07-06 12:44:32',NULL,NULL),(69671,'84018','S','Croydon','D','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.098081,-111.501214,0,'2013-07-06 12:44:34',NULL,NULL),(27626,'30310','S','Fort McPherson','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.725127,-84.422754,0,'2013-07-06 12:44:31',NULL,NULL),(37050,'41301','S','Burkhart','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(11316,'11782','S','Cherry Grove','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746049,-73.080662,0,'2013-07-06 12:44:30',NULL,NULL),(19977,'20598','U','Arlington','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(62745,'74837','P','Cromwell','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.347991,-96.457583,0,'2013-07-06 12:44:33',NULL,NULL),(5373,'04629','P','East Blue Hill','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.415507,-68.521466,0,'2013-07-06 12:44:30',NULL,NULL),(36537,'40868','S','Stinnett','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.088942,-83.366316,0,'2013-07-06 12:44:32',NULL,NULL),(47426,'54666','S','Warrens','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.130962,-90.500162,0,'2013-07-06 12:44:32',NULL,NULL),(42642,'47926','S','Burnettsville','D','White','18181','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.706849,-86.575464,0,'2013-07-06 12:44:32',NULL,NULL),(40886,'46241','S','Park Fletcher','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(1895,'00794','S','Barranquitas','D','Barranquitas','72019','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.187596,-66.307408,0,'2013-07-06 12:44:30',NULL,NULL),(29870,'33040','S','Munson Island','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(49579,'56732','S','Karlstad','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.579667,-96.528558,0,'2013-07-06 12:44:33',NULL,NULL),(56970,'66160','U','K U Med Center','N','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.058215,-94.609992,0,'2013-07-06 12:44:33',NULL,NULL),(13514,'13812','S','East Nichols','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.042960,-76.358700,0,'2013-07-06 12:44:31',NULL,NULL),(10145,'10273','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711049,-74.003348,0,'2013-07-06 12:44:30',NULL,NULL),(26000,'28672','S','Scottville','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.473151,-81.380417,0,'2013-07-06 12:44:31',NULL,NULL),(47788,'55045','S','Lindstrom','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.388851,-92.838679,0,'2013-07-06 12:44:33',NULL,NULL),(73720,'91615','P','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.200891,-118.394821,0,'2013-07-06 12:44:34',NULL,NULL),(74555,'92677','S','Laguna Niguel','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.525540,-117.714360,0,'2013-07-06 12:44:34',NULL,NULL),(24883,'27701','S','East Durham','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.998900,-78.899063,0,'2013-07-06 12:44:31',NULL,NULL),(7853,'07474','P','Wayne','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.949361,-74.247450,0,'2013-07-06 12:44:30',NULL,NULL),(13686,'14048','S','Van Buren Bay','A','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.479473,-79.328465,0,'2013-07-06 12:44:31',NULL,NULL),(27101,'29720','S','Lancaster','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.709391,-80.775133,0,'2013-07-06 12:44:31',NULL,NULL),(39194,'44326','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.083101,-81.517487,0,'2013-07-06 12:44:32',NULL,NULL),(41708,'47232','S','Grammer','N','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.112200,-85.809480,0,'2013-07-06 12:44:32',NULL,NULL),(67716,'80535','S','Laporte','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.658354,-105.160262,0,'2013-07-06 12:44:34',NULL,NULL),(67629,'80447','S','Grand Lake','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.212899,-105.855002,0,'2013-07-06 12:44:34',NULL,NULL),(5272,'04493','S','Lowell','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.243333,-68.650278,0,'2013-07-06 12:44:30',NULL,NULL),(78067,'97459','S','North Bend','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.436241,-124.214978,0,'2013-07-06 12:44:34',NULL,NULL),(61482,'72636','P','Gilbert','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.966279,-92.813057,0,'2013-07-06 12:44:33',NULL,NULL),(56768,'65740','S','Merriam Vlg','A','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.701943,-93.161158,0,'2013-07-06 12:44:33',NULL,NULL),(17485,'17959','S','Valley Furnace','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.738984,-76.109152,0,'2013-07-06 12:44:31',NULL,NULL),(55106,'63332','S','Augusta','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.595378,-90.883880,0,'2013-07-06 12:44:33',NULL,NULL),(53537,'62033','S','East Gillespie','N','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.107340,-89.842080,0,'2013-07-06 12:44:33',NULL,NULL),(53511,'62019','S','Donnellson','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.035736,-89.476722,0,'2013-07-06 12:44:33',NULL,NULL),(45229,'50645','S','Chickasaw','N','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.047060,-92.485200,0,'2013-07-06 12:44:32',NULL,NULL),(39474,'44718','S','Jackson Belden','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.851462,-81.443104,0,'2013-07-06 12:44:32',NULL,NULL),(37758,'42330','S','Central City','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294778,-87.126648,0,'2013-07-06 12:44:32',NULL,NULL),(4022,'02564','P','Siasconset','D','Nantucket','25019','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.283333,-70.100000,0,'2013-07-06 12:44:30',NULL,NULL),(20436,'20993','U','Us Food and Drug Admin','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.990556,-77.026389,0,'2013-07-06 12:44:31',NULL,NULL),(57713,'67352','S','Longton','D','Elk','20049','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.426126,-96.070333,0,'2013-07-06 12:44:33',NULL,NULL),(7991,'07716','S','Atlantic Hl','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.404595,-74.035623,0,'2013-07-06 12:44:30',NULL,NULL),(67118,'79739','S','Garden City','D','Glasscock','48173','Texas','TX','48','0000','432','Central',-6.0,'Y',31.867441,-101.521411,0,'2013-07-06 12:44:34',NULL,NULL),(15709,'16859','S','Moshannon','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',41.024152,-78.021894,0,'2013-07-06 12:44:31',NULL,NULL),(50058,'57438','S','Wecota','A','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.035596,-99.120562,0,'2013-07-06 12:44:33',NULL,NULL),(44007,'49351','U','Wolverine World Wide','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.125261,-85.559025,0,'2013-07-06 12:44:32',NULL,NULL),(40875,'46239','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.717557,-86.000421,0,'2013-07-06 12:44:32',NULL,NULL),(21886,'23175','S','Warner','A','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.652942,-76.612774,0,'2013-07-06 12:44:31',NULL,NULL),(49450,'56644','S','Hangaard','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.849231,-95.480640,0,'2013-07-06 12:44:33',NULL,NULL),(51335,'59275','S','Westby','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.844757,-104.193137,0,'2013-07-06 12:44:33',NULL,NULL),(10742,'11357','S','Whitestone','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.783792,-73.812287,0,'2013-07-06 12:44:30',NULL,NULL),(67156,'79786','P','Toyahvale','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',30.942795,-103.769038,0,'2013-07-06 12:44:34',NULL,NULL),(24851,'27626','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.777685,-78.634524,0,'2013-07-06 12:44:31',NULL,NULL),(52191,'60471','S','Richton Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.481197,-87.725978,0,'2013-07-06 12:44:33',NULL,NULL),(49673,'57012','S','Canistota','D','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.596280,-97.293355,0,'2013-07-06 12:44:33',NULL,NULL),(71097,'85936','S','Witch Wells','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.506335,-109.378069,0,'2013-07-06 12:44:34',NULL,NULL),(60692,'71937','S','Hatton','A','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.429351,-94.417896,0,'2013-07-06 12:44:33',NULL,NULL),(78681,'98244','S','Welcome','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.824220,-121.958340,0,'2013-07-06 12:44:34',NULL,NULL),(36407,'40515','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.963113,-84.467883,0,'2013-07-06 12:44:32',NULL,NULL),(33574,'37424','P','Chatt','N','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.030239,-85.148472,0,'2013-07-06 12:44:32',NULL,NULL),(39730,'45064','S','Somerville','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.552619,-84.633421,0,'2013-07-06 12:44:32',NULL,NULL),(42770,'48038','S','Clinton Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.599508,-82.953544,0,'2013-07-06 12:44:32',NULL,NULL),(47106,'54446','S','Spokeville','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.736705,-90.493341,0,'2013-07-06 12:44:32',NULL,NULL),(54291,'62704','S','Jerome','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.772500,-89.683680,0,'2013-07-06 12:44:33',NULL,NULL),(7192,'06474','P','N Westchester','A','New London','09011','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.588161,-72.397834,0,'2013-07-06 12:44:30',NULL,NULL),(3031,'01095','S','Wilbraham','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.120823,-72.443270,0,'2013-07-06 12:44:30',NULL,NULL),(63750,'75939','S','Barnum','A','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(55043,'63141','S','Creve Coeur','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.659172,-90.456634,0,'2013-07-06 12:44:33',NULL,NULL),(31967,'35213','S','Crestline Hts','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504565,-86.747150,0,'2013-07-06 12:44:32',NULL,NULL),(42279,'47585','S','Zoar','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.277754,-87.128319,0,'2013-07-06 12:44:32',NULL,NULL),(74488,'92616','P','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.651930,-117.836104,0,'2013-07-06 12:44:34',NULL,NULL),(2632,'00963','P','Catano','D','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446236,-66.140218,0,'2013-07-06 12:44:30',NULL,NULL),(45219,'50638','S','Grundy Center','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.360271,-92.773756,0,'2013-07-06 12:44:32',NULL,NULL),(48836,'56050','S','Kasota','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.269587,-93.966467,0,'2013-07-06 12:44:33',NULL,NULL),(67194,'79905','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766785,-106.428416,0,'2013-07-06 12:44:34',NULL,NULL),(58055,'68037','S','Louisville','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.999850,-96.159694,0,'2013-07-06 12:44:33',NULL,NULL),(53835,'62312','S','Barry','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.691709,-91.023573,0,'2013-07-06 12:44:33',NULL,NULL),(30376,'33318','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118323,-80.251273,0,'2013-07-06 12:44:32',NULL,NULL),(34316,'38555','S','Fairfield','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951220,-85.029780,0,'2013-07-06 12:44:32',NULL,NULL),(65199,'77431','P','Danciger','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.169311,-95.811747,0,'2013-07-06 12:44:34',NULL,NULL),(13279,'13656','S','Omar','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.191020,-75.955560,0,'2013-07-06 12:44:30',NULL,NULL),(50628,'58271','S','Pembina','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.818056,-97.227222,0,'2013-07-06 12:44:33',NULL,NULL),(49980,'57362','S','Como','N','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.522526,-98.983752,0,'2013-07-06 12:44:33',NULL,NULL),(63041,'75210','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770501,-96.750436,0,'2013-07-06 12:44:33',NULL,NULL),(16566,'17315','S','Davidsburg','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.013820,-76.815840,0,'2013-07-06 12:44:31',NULL,NULL),(65055,'77339','S','Kingwood','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.052800,-95.220720,0,'2013-07-06 12:44:34',NULL,NULL),(61165,'72183','P','Tafton','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.598156,-92.216135,0,'2013-07-06 12:44:33',NULL,NULL),(51710,'60010','S','Barrington Hills','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(66006,'78350','P','Dinero','D','Live Oak','48297','Texas','TX','48','0000','361','Central',-6.0,'Y',28.226100,-97.961280,0,'2013-07-06 12:44:34',NULL,NULL),(61885,'73134','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.616422,-97.571744,0,'2013-07-06 12:44:33',NULL,NULL),(61154,'72175','S','Wabbaseka','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.360225,-91.793010,0,'2013-07-06 12:44:33',NULL,NULL),(70672,'85225','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.316290,-111.831035,0,'2013-07-06 12:44:34',NULL,NULL),(25591,'28445','S','Topsail Beach','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.479960,-77.502360,0,'2013-07-06 12:44:31',NULL,NULL),(54789,'63011','S','Manchester','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.598725,-90.547046,0,'2013-07-06 12:44:33',NULL,NULL),(48849,'56068','S','Minnesota Lake','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.840609,-93.831847,0,'2013-07-06 12:44:33',NULL,NULL),(6683,'06040','S','Manchester','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777443,-72.524997,0,'2013-07-06 12:44:30',NULL,NULL),(71249,'86403','S','Havasu City','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.487063,-114.330287,0,'2013-07-06 12:44:34',NULL,NULL),(79049,'98412','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.174534,-122.441516,0,'2013-07-06 12:44:34',NULL,NULL),(11671,'12144','S','Rensselaer','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.624600,-73.710120,0,'2013-07-06 12:44:30',NULL,NULL),(58484,'68753','S','Mills','D','Keya Paha','31103','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.890184,-99.453616,0,'2013-07-06 12:44:33',NULL,NULL),(18892,'19470','P','Saint Peters','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.173768,-75.732305,0,'2013-07-06 12:44:31',NULL,NULL),(16897,'17582','S','Letort','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.996531,-76.452756,0,'2013-07-06 12:44:31',NULL,NULL),(4145,'02762','S','N Attleboro','N','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.012510,-71.328629,0,'2013-07-06 12:44:30',NULL,NULL),(30208,'33182','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.778250,-80.414948,0,'2013-07-06 12:44:32',NULL,NULL),(9678,'10043','U','Citibank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(75018,'93463','S','Solvang','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.632120,-120.116581,0,'2013-07-06 12:44:34',NULL,NULL),(58438,'68702','P','Norfolk','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.026207,-97.419556,0,'2013-07-06 12:44:33',NULL,NULL),(21665,'22947','S','Campbell','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(48867,'56082','S','Saint Peter','D','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.330953,-93.959962,0,'2013-07-06 12:44:33',NULL,NULL),(425,'00662','S','Sect Casimiro Perez','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(36713,'41019','U','Covington','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.069636,-84.529815,0,'2013-07-06 12:44:32',NULL,NULL),(75066,'93527','S','Inyokern','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.685858,-117.832494,0,'2013-07-06 12:44:34',NULL,NULL),(77798,'97136','S','Rockaway Beach','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(8337,'08037','S','Sweetwater','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(20430,'20915','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.043731,-77.046791,0,'2013-07-06 12:44:31',NULL,NULL),(9914,'10150','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(9017,'08865','S','Lopatcong','N','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.698180,-75.135480,0,'2013-07-06 12:44:30',NULL,NULL),(9054,'08899','S','Edison','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.518788,-74.398608,0,'2013-07-06 12:44:30',NULL,NULL),(77240,'96534','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(42332,'47633','S','Poseyville','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.155388,-87.775202,0,'2013-07-06 12:44:32',NULL,NULL),(22514,'24087','S','Elliston','D','Montgomery','51121','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.197300,-80.221200,0,'2013-07-06 12:44:31',NULL,NULL),(36610,'40977','S','East Pineville','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(16492,'17257','S','Mongul','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(23447,'25414','S','Charles Town','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.262652,-77.857813,0,'2013-07-06 12:44:31',NULL,NULL),(45551,'51465','S','Vail','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.064094,-95.203183,0,'2013-07-06 12:44:32',NULL,NULL),(661,'00683','S','Mans Reales','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(66944,'79364','S','Southland','A','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.436854,-101.646192,0,'2013-07-06 12:44:34',NULL,NULL),(49956,'57348','S','Bonilla','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.631361,-98.408782,0,'2013-07-06 12:44:33',NULL,NULL),(35567,'39567','S','Pascagoula','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(4116,'02722','P','Fall River','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.699520,-71.155149,0,'2013-07-06 12:44:30',NULL,NULL),(72258,'88535','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811411,-106.417289,0,'2013-07-06 12:44:34',NULL,NULL),(74564,'92679','S','Trabuco Canyon','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(76560,'95667','S','Pleasant Valley','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(77941,'97343','S','Eddyville','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.585760,-123.777360,0,'2013-07-06 12:44:34',NULL,NULL),(14435,'15085','S','Trafford','D','Westmoreland','42129','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.386720,-79.741500,0,'2013-07-06 12:44:31',NULL,NULL),(22825,'24503','S','Rivermont','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.434734,-79.200804,0,'2013-07-06 12:44:31',NULL,NULL),(1457,'00745','S','Bda Shangai','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(56442,'65275','S','Granville','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.481474,-92.009398,0,'2013-07-06 12:44:33',NULL,NULL),(6147,'05465','S','Jericho Ctr','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.476140,-72.949800,0,'2013-07-06 12:44:30',NULL,NULL),(2712,'00969','S','Parq de Bucare Ii','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(1799,'00783','S','Urb San Feliz','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(50643,'58311','S','Loma','A','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629815,-98.589847,0,'2013-07-06 12:44:33',NULL,NULL),(44006,'49351','U','Rockford','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.125261,-85.559025,0,'2013-07-06 12:44:32',NULL,NULL),(76471,'95620','S','Liberty Farms','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.440059,-121.822861,0,'2013-07-06 12:44:34',NULL,NULL),(18471,'19085','S','Villanova','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.036200,-75.349320,0,'2013-07-06 12:44:31',NULL,NULL),(21696,'22967','S','Massies Ml','N','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(21101,'22042','S','Mosby','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.864751,-77.194735,0,'2013-07-06 12:44:31',NULL,NULL),(8614,'08243','S','Townsends Inlet','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.152160,-74.693700,0,'2013-07-06 12:44:30',NULL,NULL),(9697,'10045','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(62471,'74339','S','Commerce','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.931772,-94.869953,0,'2013-07-06 12:44:33',NULL,NULL),(57539,'67022','S','Caldwell','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.040523,-97.615566,0,'2013-07-06 12:44:33',NULL,NULL),(51930,'60120','S','Elgin','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.039135,-88.281994,0,'2013-07-06 12:44:33',NULL,NULL),(45120,'50561','S','Lytton','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.426042,-94.862217,0,'2013-07-06 12:44:32',NULL,NULL),(30743,'33545','S','Wesley Chapel','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.229620,-82.282896,0,'2013-07-06 12:44:32',NULL,NULL),(16225,'17074','S','Newport','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(24119,'26542','S','Cascade','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.582126,-79.799220,0,'2013-07-06 12:44:31',NULL,NULL),(32430,'35986','S','Powell','A','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.497002,-85.843760,0,'2013-07-06 12:44:32',NULL,NULL),(2187,'00926','S','Mans de Romany','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(20498,'21065','U','Cockys Ht Vly','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.478149,-76.645140,0,'2013-07-06 12:44:31',NULL,NULL),(9471,'10009','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(27870,'30442','S','Scarboro','N','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(64516,'76635','S','Echols','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.742700,-96.672420,0,'2013-07-06 12:44:34',NULL,NULL),(62849,'75022','S','Flower Mound','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.014444,-97.096667,0,'2013-07-06 12:44:33',NULL,NULL),(50133,'57532','S','Lacy','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(43210,'48306','S','Rochester','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(46397,'53158','S','Kenosha','A','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.551177,-87.931552,0,'2013-07-06 12:44:32',NULL,NULL),(41412,'46816','S','Southtown','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(71428,'87027','S','Llaves','A','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',36.110729,-106.993790,0,'2013-07-06 12:44:34',NULL,NULL),(72892,'90017','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.053387,-118.265378,0,'2013-07-06 12:44:34',NULL,NULL),(74078,'92178','P','Coronado','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.681525,-117.175900,0,'2013-07-06 12:44:34',NULL,NULL),(75961,'95046','S','San Martin','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.090149,-121.595743,0,'2013-07-06 12:44:34',NULL,NULL),(25365,'28242','U','Duke Power Co','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.211849,-80.861761,0,'2013-07-06 12:44:31',NULL,NULL),(24757,'27540','S','Holly Springs','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.623511,-78.834978,0,'2013-07-06 12:44:31',NULL,NULL),(2534,'00959','S','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(74544,'92663','S','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.620985,-117.932110,0,'2013-07-06 12:44:34',NULL,NULL),(73936,'92040','S','Lakeside','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.861292,-116.915988,0,'2013-07-06 12:44:34',NULL,NULL),(62244,'74003','S','Bartlesville','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(47256,'54521','S','Washington','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.910500,-89.224500,0,'2013-07-06 12:44:32',NULL,NULL),(28405,'31318','P','Meldrim','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.142635,-81.376965,0,'2013-07-06 12:44:32',NULL,NULL),(13955,'14463','P','Hall','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.797345,-77.069035,0,'2013-07-06 12:44:31',NULL,NULL),(17483,'17959','S','New Philadelphia','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.738984,-76.109152,0,'2013-07-06 12:44:31',NULL,NULL),(8728,'08511','S','Cookstown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.043406,-74.553498,0,'2013-07-06 12:44:30',NULL,NULL),(71780,'87557','S','Rnch de Taos','A','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(52340,'60585','S','Plainfield','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.655300,-88.207900,0,'2013-07-06 12:44:33',NULL,NULL),(49168,'56397','P','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.482753,-94.250285,0,'2013-07-06 12:44:33',NULL,NULL),(35310,'39406','U','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.330181,-89.338932,0,'2013-07-06 12:44:32',NULL,NULL),(16811,'17545','S','Elstonville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(27140,'29817','S','Blackville','D','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.356585,-81.275630,0,'2013-07-06 12:44:31',NULL,NULL),(44906,'50325','S','Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.604998,-93.747731,0,'2013-07-06 12:44:32',NULL,NULL),(36597,'40965','S','Middlesboro','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.609522,-83.721655,0,'2013-07-06 12:44:32',NULL,NULL),(78655,'98228','P','Bellingham','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.743723,-122.467665,0,'2013-07-06 12:44:34',NULL,NULL),(79823,'99508','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.201281,-149.815886,0,'2013-07-06 12:44:34',NULL,NULL),(10593,'11030','S','Manhasset','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.795533,-73.684954,0,'2013-07-06 12:44:30',NULL,NULL),(26751,'29425','U','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.785741,-79.947783,0,'2013-07-06 12:44:31',NULL,NULL),(4724,'03826','S','East Hampstead','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.890279,-71.137885,0,'2013-07-06 12:44:30',NULL,NULL),(68951,'82942','P','Point of Rocks','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.680884,-108.784929,0,'2013-07-06 12:44:34',NULL,NULL),(5222,'04462','S','Indian Purchase Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.654650,-68.702349,0,'2013-07-06 12:44:30',NULL,NULL),(5880,'05150','S','N Springfld','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.335916,-72.524997,0,'2013-07-06 12:44:30',NULL,NULL),(59211,'70394','S','Raceland','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.709855,-90.605109,0,'2013-07-06 12:44:33',NULL,NULL),(55790,'64123','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.111153,-94.523025,0,'2013-07-06 12:44:33',NULL,NULL),(26955,'29606','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.858052,-82.321696,0,'2013-07-06 12:44:31',NULL,NULL),(56027,'64673','S','Princeton','D','Mercer','29129','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.396487,-93.583391,0,'2013-07-06 12:44:33',NULL,NULL),(40154,'45352','P','Palestine','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.049672,-84.744526,0,'2013-07-06 12:44:32',NULL,NULL),(71408,'87017','S','Gallina','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.166615,-106.610265,0,'2013-07-06 12:44:34',NULL,NULL),(61345,'72469','S','Calamine','A','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.972820,-91.383900,0,'2013-07-06 12:44:33',NULL,NULL),(17190,'17820','S','Queen City','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(39041,'44147','S','Broadview Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.320684,-81.676508,0,'2013-07-06 12:44:32',NULL,NULL),(43347,'48382','S','Commerce','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.583560,-83.500320,0,'2013-07-06 12:44:32',NULL,NULL),(76810,'95950','P','Grimes','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.052777,-121.884418,0,'2013-07-06 12:44:34',NULL,NULL),(77439,'96807','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306339,-157.861146,0,'2013-07-06 12:44:34',NULL,NULL),(10398,'10604','S','W Harrison','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.035020,-73.743600,0,'2013-07-06 12:44:30',NULL,NULL),(75176,'93604','S','Bass Lake','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.313000,-119.548394,0,'2013-07-06 12:44:34',NULL,NULL),(69037,'83221','S','Groveland','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(66774,'79032','P','Edmonson','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',34.201031,-101.786421,0,'2013-07-06 12:44:34',NULL,NULL),(22930,'24624','P','Keen Mountain','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.204379,-81.987056,0,'2013-07-06 12:44:31',NULL,NULL),(55995,'64640','S','Gallatin','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.902820,-93.968700,0,'2013-07-06 12:44:33',NULL,NULL),(44994,'50438','S','Miller','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.114320,-93.553740,0,'2013-07-06 12:44:32',NULL,NULL),(63877,'76008','S','Willow Park','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699617,-97.628794,0,'2013-07-06 12:44:34',NULL,NULL),(39388,'44654','S','Millersburg','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.545778,-81.873263,0,'2013-07-06 12:44:32',NULL,NULL),(74866,'93260','S','Posey','D','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.802184,-118.629785,0,'2013-07-06 12:44:34',NULL,NULL),(3535,'01905','S','West Lynn','A','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.464742,-70.973863,0,'2013-07-06 12:44:30',NULL,NULL),(48233,'55421','S','Columbia Hts','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(71326,'86506','P','Houck','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.389139,-109.283418,0,'2013-07-06 12:44:34',NULL,NULL),(67830,'80807','S','Burlington','D','Kit Carson','08063','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.304827,-102.246973,0,'2013-07-06 12:44:34',NULL,NULL),(15236,'16037','S','Harmony','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.852733,-80.128984,0,'2013-07-06 12:44:31',NULL,NULL),(30700,'33484','S','W Delray Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.457619,-80.135160,0,'2013-07-06 12:44:32',NULL,NULL),(14963,'15624','P','Crabtree','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.360325,-79.469644,0,'2013-07-06 12:44:31',NULL,NULL),(4370,'03073','P','No Salem','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.835016,-71.224246,0,'2013-07-06 12:44:30',NULL,NULL),(21070,'22009','P','Burke','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.793333,-77.271944,0,'2013-07-06 12:44:31',NULL,NULL),(18122,'18816','P','Dimock','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.744822,-75.896269,0,'2013-07-06 12:44:31',NULL,NULL),(17222,'17830','S','Hebe','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690745,-76.789710,0,'2013-07-06 12:44:31',NULL,NULL),(51518,'59703','P','Butte','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.988187,-112.551908,0,'2013-07-06 12:44:33',NULL,NULL),(39960,'45236','S','Reading','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(1503,'00751','S','Urb Salimar','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(14156,'14721','S','Ceres','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.011321,-78.271295,0,'2013-07-06 12:44:31',NULL,NULL),(60907,'72076','S','JAX','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(1343,'00736','S','Chalets Las Muesas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(43657,'48850','S','Lakeview','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.426823,-85.249843,0,'2013-07-06 12:44:32',NULL,NULL),(37604,'42129','S','Cedar Flat','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(57999,'67861','S','Selkirk','N','Wichita','20203','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.483861,-101.356671,0,'2013-07-06 12:44:33',NULL,NULL),(53663,'62207','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.610300,-90.156180,0,'2013-07-06 12:44:33',NULL,NULL),(34409,'38629','S','Falkner','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.840977,-88.961435,0,'2013-07-06 12:44:32',NULL,NULL),(25864,'28630','S','Granite Falls','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.816100,-81.457140,0,'2013-07-06 12:44:31',NULL,NULL),(33417,'37240','U','Vanderbilt University','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.143381,-86.803365,0,'2013-07-06 12:44:32',NULL,NULL),(43031,'48173','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(11103,'11697','S','Rockaway Point','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.556389,-73.926667,0,'2013-07-06 12:44:30',NULL,NULL),(42027,'47438','S','Buchanan Cnr','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(71273,'86432','P','Beaver Dam','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',36.883333,-113.933333,0,'2013-07-06 12:44:34',NULL,NULL),(68090,'80941','U','Current Inc','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.866594,-104.755324,0,'2013-07-06 12:44:34',NULL,NULL),(76307,'95445','S','Gualala','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.805573,-123.562187,0,'2013-07-06 12:44:34',NULL,NULL),(688,'00685','S','Bda Tablastilla','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(68080,'80938','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.797690,-104.837067,0,'2013-07-06 12:44:34',NULL,NULL),(7598,'07043','S','Upper Montclair','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.841403,-74.201411,0,'2013-07-06 12:44:30',NULL,NULL),(2164,'00926','S','Bo Buen Consejo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(61894,'73139','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.393759,-97.524997,0,'2013-07-06 12:44:33',NULL,NULL),(29325,'32542','S','Eglin AFB','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(43559,'48724','P','Carrollton','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.461778,-83.926020,0,'2013-07-06 12:44:32',NULL,NULL),(57841,'67552','S','Lewis','D','Edwards','20047','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.935830,-99.255148,0,'2013-07-06 12:44:33',NULL,NULL),(71145,'86030','P','Hotevilla','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.921410,-110.673460,0,'2013-07-06 12:44:34',NULL,NULL),(78691,'98250','S','San Juan Island','N','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.543044,-123.068308,0,'2013-07-06 12:44:34',NULL,NULL),(80063,'99721','P','Anaktuvuk','A','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',68.240851,-151.892653,0,'2013-07-06 12:44:34',NULL,NULL),(26589,'29223','S','Northeast','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.088460,-80.922870,0,'2013-07-06 12:44:31',NULL,NULL),(12670,'13126','S','Bundyville','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(63614,'75831','S','Flo','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.461433,-96.074604,0,'2013-07-06 12:44:34',NULL,NULL),(49207,'56459','P','Lake Hubert','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.502147,-94.257255,0,'2013-07-06 12:44:33',NULL,NULL),(47729,'55009','S','Wastedo','N','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.507743,-92.905112,0,'2013-07-06 12:44:33',NULL,NULL),(45107,'50548','S','Humboldt','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.722941,-94.220119,0,'2013-07-06 12:44:32',NULL,NULL),(41798,'47327','S','Cambridge City','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.822189,-85.164134,0,'2013-07-06 12:44:32',NULL,NULL),(72293,'88574','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.764258,-106.330912,0,'2013-07-06 12:44:34',NULL,NULL),(74486,'92615','P','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.656552,-117.969874,0,'2013-07-06 12:44:34',NULL,NULL),(76880,'95976','U','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.753844,-121.870112,0,'2013-07-06 12:44:34',NULL,NULL),(24026,'26377','S','Jacksonburg','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.499919,-80.641416,0,'2013-07-06 12:44:31',NULL,NULL),(65544,'77831','S','Bedias','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.747332,-95.921935,0,'2013-07-06 12:44:34',NULL,NULL),(27724,'30346','S','Dunwoody','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.927811,-84.344192,0,'2013-07-06 12:44:31',NULL,NULL),(46401,'53167','P','Rochester','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.742634,-88.225342,0,'2013-07-06 12:44:32',NULL,NULL),(40301,'45449','S','West Carrollton','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.668355,-84.246864,0,'2013-07-06 12:44:32',NULL,NULL),(72501,'89147','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.113539,-115.272705,0,'2013-07-06 12:44:34',NULL,NULL),(76819,'95956','P','Meadow Valley','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.938546,-121.065083,0,'2013-07-06 12:44:34',NULL,NULL),(4019,'02563','S','Sandwich','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.726496,-70.481950,0,'2013-07-06 12:44:30',NULL,NULL),(69977,'84120','S','West Valley','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(33557,'37407','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.000945,-85.285097,0,'2013-07-06 12:44:32',NULL,NULL),(6070,'05446','S','Camp Johnson','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.548500,-73.215480,0,'2013-07-06 12:44:30',NULL,NULL),(22918,'24609','S','Indian','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083840,-81.768540,0,'2013-07-06 12:44:31',NULL,NULL),(79815,'99505','S','Anchorage','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.255993,-149.689138,0,'2013-07-06 12:44:34',NULL,NULL),(61910,'73145','S','T A F B','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.415801,-97.392307,0,'2013-07-06 12:44:33',NULL,NULL),(1393,'00738','S','Terr Demajagua 2','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(11202,'11743','S','Halesite','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(61798,'73092','S','Verden','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.074099,-98.056200,0,'2013-07-06 12:44:33',NULL,NULL),(37933,'42642','S','Webbs Cross Roads','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.055440,-85.091503,0,'2013-07-06 12:44:32',NULL,NULL),(72581,'89405','P','Empire','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',40.576889,-119.341788,0,'2013-07-06 12:44:34',NULL,NULL),(70861,'85602','S','Cascabel','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.965389,-110.296656,0,'2013-07-06 12:44:34',NULL,NULL),(28252,'31063','S','Montezuma','D','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.299090,-84.021341,0,'2013-07-06 12:44:31',NULL,NULL),(19598,'20227','U','Dept Treas Check Claims Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894569,-77.033661,0,'2013-07-06 12:44:31',NULL,NULL),(35397,'39459','S','Rainey','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.482740,-89.327507,0,'2013-07-06 12:44:32',NULL,NULL),(37451,'41844','S','Pippa Passes','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369951,-82.827928,0,'2013-07-06 12:44:32',NULL,NULL),(73751,'91724','S','Charter Oak','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.090101,-117.858739,0,'2013-07-06 12:44:34',NULL,NULL),(9791,'10108','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(63139,'75367','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.902155,-96.792763,0,'2013-07-06 12:44:33',NULL,NULL),(28652,'31771','S','Norman Park','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.239723,-83.715199,0,'2013-07-06 12:44:32',NULL,NULL),(24372,'27054','S','Woodleaf','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.790019,-80.612864,0,'2013-07-06 12:44:31',NULL,NULL),(8558,'08205','S','Smithville','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.420254,-74.502031,0,'2013-07-06 12:44:30',NULL,NULL),(25439,'28310','U','Fort Bragg','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.138766,-79.000019,0,'2013-07-06 12:44:31',NULL,NULL),(62202,'73835','S','Camargo','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.030675,-99.282535,0,'2013-07-06 12:44:33',NULL,NULL),(57068,'66214','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(56161,'64863','S','South West Cy','A','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.510903,-94.612197,0,'2013-07-06 12:44:33',NULL,NULL),(48517,'55746','S','Kitzville','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(47568,'54842','P','Hawthorne','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.503826,-91.863004,0,'2013-07-06 12:44:33',NULL,NULL),(7641,'07070','S','Rutherford','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.828658,-74.111834,0,'2013-07-06 12:44:30',NULL,NULL),(40621,'46011','S','River Forest','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(33867,'38014','P','Brunswick','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.266062,-89.772731,0,'2013-07-06 12:44:32',NULL,NULL),(31701,'34949','S','Hutchinson Is','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.475372,-80.302774,0,'2013-07-06 12:44:32',NULL,NULL),(29497,'32751','S','Maitland','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.625621,-81.355905,0,'2013-07-06 12:44:32',NULL,NULL),(3453,'01773','S','Lincoln Center','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.423884,-71.314205,0,'2013-07-06 12:44:30',NULL,NULL),(6472,'05763','S','Pittsford Mills','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.767228,-72.969037,0,'2013-07-06 12:44:30',NULL,NULL),(27890,'30461','S','Statesboro','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.515293,-81.708465,0,'2013-07-06 12:44:31',NULL,NULL),(7377,'06777','S','New Preston Marble Dale','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(61730,'73023','P','Chickasha','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.042198,-97.934517,0,'2013-07-06 12:44:33',NULL,NULL),(19275,'19963','S','Milford','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.903495,-75.432364,0,'2013-07-06 12:44:31',NULL,NULL),(49195,'56444','S','Deerwood','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.473714,-93.904656,0,'2013-07-06 12:44:33',NULL,NULL),(72069,'88123','S','Lingo','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652386,-103.141603,0,'2013-07-06 12:44:34',NULL,NULL),(64042,'76129','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.705900,-97.359380,0,'2013-07-06 12:44:34',NULL,NULL),(6003,'05357','P','W Dummerston','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.928208,-72.614048,0,'2013-07-06 12:44:30',NULL,NULL),(17537,'17976','S','Lower Shaft','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(38964,'44128','S','Garfield Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(23543,'25614','P','Cora','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.851030,-81.987834,0,'2013-07-06 12:44:31',NULL,NULL),(7967,'07701','S','Tinton Falls','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.353122,-74.074629,0,'2013-07-06 12:44:30',NULL,NULL),(18003,'18635','S','Nescopeck','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.053252,-76.218480,0,'2013-07-06 12:44:31',NULL,NULL),(62215,'73855','S','Rosston','D','Harper','40059','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.897670,-99.887961,0,'2013-07-06 12:44:33',NULL,NULL),(60193,'71418','S','Columbia','D','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(4838,'04006','P','Biddeford Pool','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.492500,-70.453889,0,'2013-07-06 12:44:30',NULL,NULL),(66171,'78520','S','Palo Alto Battlefield Nation','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(58037,'68015','S','Cedar Bluffs','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.397107,-96.608140,0,'2013-07-06 12:44:33',NULL,NULL),(1497,'00751','S','Urb La Arboleda','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(17996,'18629','S','Forkston Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.490456,-76.155214,0,'2013-07-06 12:44:31',NULL,NULL),(65744,'78058','S','Mountain Home','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',30.238758,-99.349106,0,'2013-07-06 12:44:34',NULL,NULL),(70015,'84127','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700486,-111.945715,0,'2013-07-06 12:44:34',NULL,NULL),(60010,'71334','S','Levee Heights','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(63556,'75766','S','Pierces Chapel','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:33',NULL,NULL),(53561,'62052','S','Jerseyville','D','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.135780,-90.333000,0,'2013-07-06 12:44:33',NULL,NULL),(44603,'50050','S','Churdan','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.130801,-94.461946,0,'2013-07-06 12:44:32',NULL,NULL),(42710,'48001','S','Clay Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(15275,'16112','S','Bessemer','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.977035,-80.493394,0,'2013-07-06 12:44:31',NULL,NULL),(22656,'24269','S','McClure','N','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.080985,-82.383101,0,'2013-07-06 12:44:31',NULL,NULL),(21398,'22509','S','Loretto','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.069719,-76.975087,0,'2013-07-06 12:44:31',NULL,NULL),(62289,'74019','S','Claremore','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.318395,-95.619824,0,'2013-07-06 12:44:33',NULL,NULL),(60865,'72055','S','Gillett','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.120469,-91.378469,0,'2013-07-06 12:44:33',NULL,NULL),(56452,'65281','S','Prairie Hill','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.420951,-92.803243,0,'2013-07-06 12:44:33',NULL,NULL),(69909,'84107','S','So Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(5113,'04358','S','South China','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.398705,-69.582961,0,'2013-07-06 12:44:30',NULL,NULL),(52142,'60437','S','Kinsman','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.193043,-88.557050,0,'2013-07-06 12:44:33',NULL,NULL),(6162,'05472','S','New Haven','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(28308,'31126','P','Lenox Square Finance','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.847924,-84.359054,0,'2013-07-06 12:44:31',NULL,NULL),(3686,'02132','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.275160,-71.147280,0,'2013-07-06 12:44:30',NULL,NULL),(53715,'62240','S','East Carondelet','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.525161,-90.223920,0,'2013-07-06 12:44:33',NULL,NULL),(40291,'45440','S','Centerville','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(8908,'08736','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.122204,-74.063541,0,'2013-07-06 12:44:30',NULL,NULL),(35943,'40056','S','Pewee Valley','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.304452,-85.483500,0,'2013-07-06 12:44:32',NULL,NULL),(41331,'46779','S','Golden Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.593680,-85.012980,0,'2013-07-06 12:44:32',NULL,NULL),(78936,'98366','S','Sunnyslope','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(55419,'63655','S','Buckhorn','N','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.403467,-90.197360,0,'2013-07-06 12:44:33',NULL,NULL),(45762,'52146','S','Waukon Junction','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.201376,-91.147423,0,'2013-07-06 12:44:32',NULL,NULL),(44122,'49508','S','Cutlerville','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.873625,-85.625143,0,'2013-07-06 12:44:32',NULL,NULL),(14987,'15642','S','North Irwin','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.328956,-79.721348,0,'2013-07-06 12:44:31',NULL,NULL),(62841,'75013','S','Allen','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.113364,-96.696357,0,'2013-07-06 12:44:33',NULL,NULL),(21484,'22649','S','Middletown','D','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.005182,-78.258327,0,'2013-07-06 12:44:31',NULL,NULL),(4394,'03111','U','Shared Firm Zip','N','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.937825,-71.453825,0,'2013-07-06 12:44:30',NULL,NULL),(52214,'60481','S','Symerton','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(32215,'35570','S','Bexar','N','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.167932,-87.979150,0,'2013-07-06 12:44:32',NULL,NULL),(34458,'38659','S','Cornersville','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(61573,'72735','P','Goshen','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.100183,-93.989097,0,'2013-07-06 12:44:33',NULL,NULL),(16501,'17261','P','South Mountain','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.834092,-77.474209,0,'2013-07-06 12:44:31',NULL,NULL),(44916,'50331','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587161,-93.634602,0,'2013-07-06 12:44:32',NULL,NULL),(65787,'78119','S','Kenedy','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.813002,-97.849725,0,'2013-07-06 12:44:34',NULL,NULL),(74455,'92589','P','Rancho California','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.516968,-117.110213,0,'2013-07-06 12:44:34',NULL,NULL),(72009,'88041','S','San Lorenzo','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.746667,-107.885833,0,'2013-07-06 12:44:34',NULL,NULL),(10138,'10269','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.701869,-74.010178,0,'2013-07-06 12:44:30',NULL,NULL),(5148,'04418','S','Greenbush','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(34866,'38930','S','Shellmound','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.504180,-90.161880,0,'2013-07-06 12:44:32',NULL,NULL),(33884,'38027','P','Colliervl','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056954,-89.676442,0,'2013-07-06 12:44:32',NULL,NULL),(3891,'02382','S','Whitman','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.081994,-70.937413,0,'2013-07-06 12:44:30',NULL,NULL),(31661,'34747','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.297785,-81.613279,0,'2013-07-06 12:44:32',NULL,NULL),(58148,'68164','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.295609,-96.109098,0,'2013-07-06 12:44:33',NULL,NULL),(13306,'13670','S','Lower Oswegatchie','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.179515,-75.082431,0,'2013-07-06 12:44:30',NULL,NULL),(69849,'84086','S','Woodruff','D','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.490256,-111.160080,0,'2013-07-06 12:44:34',NULL,NULL),(72422,'89060','S','Pahrump','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.269044,-116.027540,0,'2013-07-06 12:44:34',NULL,NULL),(70975,'85702','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.216662,-110.970699,0,'2013-07-06 12:44:34',NULL,NULL),(47905,'55109','S','North St Paul','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(29070,'32250','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.281220,-81.416820,0,'2013-07-06 12:44:32',NULL,NULL),(36255,'40317','P','Elliottville','D','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.182729,-83.276580,0,'2013-07-06 12:44:32',NULL,NULL),(79652,'99147','S','Lincoln','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.822043,-118.474960,0,'2013-07-06 12:44:34',NULL,NULL),(75415,'94024','S','Los Altos Hills','A','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.353924,-122.085935,0,'2013-07-06 12:44:34',NULL,NULL),(14087,'14616','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.229040,-77.680740,0,'2013-07-06 12:44:31',NULL,NULL),(63672,'75855','S','Red Lake','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.580983,-95.892859,0,'2013-07-06 12:44:34',NULL,NULL),(61117,'72150','S','Prague','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.305789,-92.400260,0,'2013-07-06 12:44:33',NULL,NULL),(38557,'43761','P','Moxahala','D','Perry','39127','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.661270,-82.141325,0,'2013-07-06 12:44:32',NULL,NULL),(70363,'84651','S','Elk Ridge','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.026844,-111.705036,0,'2013-07-06 12:44:34',NULL,NULL),(80181,'99841','P','Tenakee Spgs','A','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.779884,-135.188839,0,'2013-07-06 12:44:34',NULL,NULL),(16569,'17315','S','York','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.013820,-76.815840,0,'2013-07-06 12:44:31',NULL,NULL),(9070,'09003','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(64456,'76571','S','Prairie Dell','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.944482,-97.516912,0,'2013-07-06 12:44:34',NULL,NULL),(17177,'17815','S','Fernville','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(60141,'71373','S','Taconey','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(47304,'54552','S','Lymantown','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(67468,'80221','S','Thornton','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(33465,'37327','S','Dunlap','D','Sequatchie','47153','Tennessee','TN','47','0000','423','Central',-6.0,'Y',35.371135,-85.392644,0,'2013-07-06 12:44:32',NULL,NULL),(18147,'18840','S','South Waverly','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.983124,-76.530623,0,'2013-07-06 12:44:31',NULL,NULL),(19086,'19567','S','Womelsdorf','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386594,-76.216795,0,'2013-07-06 12:44:31',NULL,NULL),(63692,'75862','S','Sebastopol','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(62116,'73647','S','Foss','D','Washita','40149','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.396386,-99.108663,0,'2013-07-06 12:44:33',NULL,NULL),(56643,'65613','S','Bolivar','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.613564,-93.414989,0,'2013-07-06 12:44:33',NULL,NULL),(52289,'60536','P','Millbrook','D','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.595389,-88.563155,0,'2013-07-06 12:44:33',NULL,NULL),(65115,'77374','P','Thicket','D','Hardin','48199','Texas','TX','48','0840','936','Central',-6.0,'Y',30.397106,-94.629621,0,'2013-07-06 12:44:34',NULL,NULL),(56018,'64660','S','Mendon','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.589805,-93.132076,0,'2013-07-06 12:44:33',NULL,NULL),(10412,'10705','S','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.918301,-73.891148,0,'2013-07-06 12:44:30',NULL,NULL),(54852,'63042','S','Robertson','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.777796,-90.371867,0,'2013-07-06 12:44:33',NULL,NULL),(41108,'46563','S','Inwood','A','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.348915,-86.328202,0,'2013-07-06 12:44:32',NULL,NULL),(77131,'96156','P','Bijou','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.947065,-119.970227,0,'2013-07-06 12:44:34',NULL,NULL),(78888,'98358','S','Indian Is','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(20928,'21749','U','Citicorp Brm','N','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.637367,-77.744539,0,'2013-07-06 12:44:31',NULL,NULL),(3830,'02333','S','E Bridgewater','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.029586,-70.942499,0,'2013-07-06 12:44:30',NULL,NULL),(65448,'77597','S','Wallisville','D','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.864771,-94.692485,0,'2013-07-06 12:44:34',NULL,NULL),(56382,'65233','S','Boonville','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(2144,'00924','S','Urb San Martin','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(706,'00685','S','Villas de Piedra Blanca','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(3709,'02141','S','E Cambridge','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.368312,-71.082436,0,'2013-07-06 12:44:30',NULL,NULL),(51854,'60073','S','Round Lk Bch','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(42867,'48081','S','St Clr Shrs','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(35740,'39730','S','Aberdeen','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(80071,'99726','P','Bettles Field','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.906944,-151.683056,0,'2013-07-06 12:44:34',NULL,NULL),(76475,'95623','S','Nashville','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.672790,-120.847975,0,'2013-07-06 12:44:34',NULL,NULL),(1880,'00791','S','Urb Palmas Reales','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(54255,'62674','S','Palmyra','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.439755,-89.925200,0,'2013-07-06 12:44:33',NULL,NULL),(29314,'32534','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.525975,-87.279037,0,'2013-07-06 12:44:32',NULL,NULL),(48601,'55786','P','Holman','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.309263,-93.382691,0,'2013-07-06 12:44:33',NULL,NULL),(37309,'41643','S','Lackey','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.461984,-82.796111,0,'2013-07-06 12:44:32',NULL,NULL),(40713,'46117','S','Charlottesville','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.817766,-85.617132,0,'2013-07-06 12:44:32',NULL,NULL),(39802,'45135','S','Leesburg','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(74315,'92391','P','Twin Peaks','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.246725,-117.226889,0,'2013-07-06 12:44:34',NULL,NULL),(41219,'46732','S','Knapp Lake','N','Noble','18113','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.401608,-85.666412,0,'2013-07-06 12:44:32',NULL,NULL),(74002,'92109','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.791495,-117.236899,0,'2013-07-06 12:44:34',NULL,NULL),(66835,'79107','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.227161,-101.810403,0,'2013-07-06 12:44:34',NULL,NULL),(13334,'13684','S','Hatchs Corner','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.375880,-75.069180,0,'2013-07-06 12:44:30',NULL,NULL),(43263,'48327','S','Waterford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.647953,-83.407284,0,'2013-07-06 12:44:32',NULL,NULL),(59294,'70504','U','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.190224,-92.037106,0,'2013-07-06 12:44:33',NULL,NULL),(2443,'00953','S','Urb Palacios del Rio I','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(67146,'79772','S','Pecos','D','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.375544,-103.523013,0,'2013-07-06 12:44:34',NULL,NULL),(45768,'52154','S','Lawler','D','Chickasaw','19037','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.101911,-92.138892,0,'2013-07-06 12:44:32',NULL,NULL),(36855,'41076','S','Newport','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(496,'00674','S','Est de Manati','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(48707,'55945','S','Kellogg','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.308082,-91.996965,0,'2013-07-06 12:44:33',NULL,NULL),(76486,'95630','S','White Rock','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.683096,-121.160535,0,'2013-07-06 12:44:34',NULL,NULL),(41574,'47034','P','Napoleon','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.204178,-85.329689,0,'2013-07-06 12:44:32',NULL,NULL),(35726,'39669','S','Woodville','D','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(35251,'39341','S','Prairie Point','A','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.113434,-88.556999,0,'2013-07-06 12:44:32',NULL,NULL),(73965,'92069','S','Lake San Marcos','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.149519,-117.173018,0,'2013-07-06 12:44:34',NULL,NULL),(1360,'00736','S','Urb Bosch','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(66598,'78754','S','Sprinkle','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.345825,-97.661056,0,'2013-07-06 12:44:34',NULL,NULL),(24060,'26430','S','Stouts Mills','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.892107,-80.741255,0,'2013-07-06 12:44:31',NULL,NULL),(57374,'66743','S','Green Bush','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(22559,'24143','P','Radford','D','Radford City','51750','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.125895,-80.575240,0,'2013-07-06 12:44:31',NULL,NULL),(40114,'45322','S','Union','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.884040,-84.346800,0,'2013-07-06 12:44:32',NULL,NULL),(54129,'62557','S','Pana','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.386310,-89.080983,0,'2013-07-06 12:44:33',NULL,NULL),(39336,'44615','S','Scroggsfield','N','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(2136,'00924','S','Urb El Comandante','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(35622,'39629','S','Bogue Chitto','D','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.485120,-90.452940,0,'2013-07-06 12:44:32',NULL,NULL),(51670,'59918','P','Fortine','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.788062,-114.886730,0,'2013-07-06 12:44:33',NULL,NULL),(77460,'96814','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.301058,-157.848253,0,'2013-07-06 12:44:34',NULL,NULL),(77744,'97086','S','Happy Valley','D','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.443245,-122.514694,0,'2013-07-06 12:44:34',NULL,NULL),(78223,'97761','P','Kah Nee Ta','N','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.762816,-121.302390,0,'2013-07-06 12:44:34',NULL,NULL),(28898,'32130','S','De Leon Spgs','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.126886,-81.329806,0,'2013-07-06 12:44:32',NULL,NULL),(23965,'26294','S','Mingo','A','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.498611,-80.054444,0,'2013-07-06 12:44:31',NULL,NULL),(76095,'95221','P','Angels Camp','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.083800,-120.560820,0,'2013-07-06 12:44:34',NULL,NULL),(78812,'98331','S','Kalalock','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(67940,'80911','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(63922,'76052','S','Haslet','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.956360,-97.346030,0,'2013-07-06 12:44:34',NULL,NULL),(6376,'05681','S','Lake Valley','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.445762,-72.409821,0,'2013-07-06 12:44:30',NULL,NULL),(56671,'65630','S','Chestnutridge','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.859987,-93.124983,0,'2013-07-06 12:44:33',NULL,NULL),(50022,'57401','S','Ordway','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.464854,-98.492300,0,'2013-07-06 12:44:33',NULL,NULL),(30350,'33312','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.088164,-80.184514,0,'2013-07-06 12:44:32',NULL,NULL),(5645,'04952','S','Belmont','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.413305,-69.150780,0,'2013-07-06 12:44:30',NULL,NULL),(23721,'25904','P','Pax','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.912793,-81.262664,0,'2013-07-06 12:44:31',NULL,NULL),(29381,'32609','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.695004,-82.299594,0,'2013-07-06 12:44:32',NULL,NULL),(44244,'49667','S','Merritt','D','Missaukee','26113','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.343975,-84.930617,0,'2013-07-06 12:44:32',NULL,NULL),(77375,'96753','S','Kihei','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.733086,-156.449710,0,'2013-07-06 12:44:34',NULL,NULL),(68909,'82832','S','Banner','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.645411,-106.798869,0,'2013-07-06 12:44:34',NULL,NULL),(25072,'27943','P','Hatteras','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.230771,-75.626592,0,'2013-07-06 12:44:31',NULL,NULL),(61998,'73433','S','Elmore City','D','Garvin','40049','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.615413,-97.404541,0,'2013-07-06 12:44:33',NULL,NULL),(34075,'38150','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.147314,-90.048201,0,'2013-07-06 12:44:32',NULL,NULL),(60185,'71417','S','Fairmont','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(44779,'50214','S','Painted Rocks','N','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.459212,-93.038568,0,'2013-07-06 12:44:32',NULL,NULL),(22368,'23919','S','Bracey','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.581289,-78.112051,0,'2013-07-06 12:44:31',NULL,NULL),(60261,'71446','S','Hicks','A','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(43147,'48240','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.423668,-83.299778,0,'2013-07-06 12:44:32',NULL,NULL),(23049,'24868','S','Algoma','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(21472,'22630','S','Riverton','A','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.946389,-78.199722,0,'2013-07-06 12:44:31',NULL,NULL),(28005,'30606','S','Navy Supply Corps School','N','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.948996,-83.423229,0,'2013-07-06 12:44:31',NULL,NULL),(57759,'67449','S','Herington','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.689020,-96.992160,0,'2013-07-06 12:44:33',NULL,NULL),(65079,'77351','S','Livingston','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.577170,-94.686210,0,'2013-07-06 12:44:34',NULL,NULL),(57863,'67575','S','Timken','A','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.463652,-99.312553,0,'2013-07-06 12:44:33',NULL,NULL),(19210,'19890','U','Wilmington Trust','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.738223,-75.550288,0,'2013-07-06 12:44:31',NULL,NULL),(69850,'84087','S','W Bountiful','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.888560,-111.912240,0,'2013-07-06 12:44:34',NULL,NULL),(76888,'95979','S','Sites','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.308210,-122.511314,0,'2013-07-06 12:44:34',NULL,NULL),(25345,'28222','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.191264,-80.804196,0,'2013-07-06 12:44:31',NULL,NULL),(65926,'78245','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.406773,-98.734865,0,'2013-07-06 12:44:34',NULL,NULL),(11443,'11976','S','Water Mill','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.930979,-72.352790,0,'2013-07-06 12:44:30',NULL,NULL),(78202,'97739','S','E Lake','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.704905,-121.531851,0,'2013-07-06 12:44:34',NULL,NULL),(23874,'26160','S','Lynncamp','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(67009,'79517','S','Fluvanna','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.816035,-101.085495,0,'2013-07-06 12:44:34',NULL,NULL),(66282,'78582','S','La Casita','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(12248,'12827','S','West Fort Ann','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.431600,-73.509180,0,'2013-07-06 12:44:30',NULL,NULL),(34774,'38863','S','Troy','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(42256,'47579','S','Christmas Lake Village','A','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.104943,-86.928717,0,'2013-07-06 12:44:32',NULL,NULL),(26827,'29485','S','Lincolnville','A','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.975069,-80.180159,0,'2013-07-06 12:44:31',NULL,NULL),(62959,'75118','P','Elmo','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.685089,-96.214589,0,'2013-07-06 12:44:33',NULL,NULL),(17216,'17824','S','Happy Valley','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(11242,'11757','S','North Lindenhurst','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.688951,-73.376317,0,'2013-07-06 12:44:30',NULL,NULL),(33741,'37830','S','Oak Ridge','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.020634,-84.253983,0,'2013-07-06 12:44:32',NULL,NULL),(57225,'66505','P','Manhattan','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.188109,-96.590646,0,'2013-07-06 12:44:33',NULL,NULL),(54028,'62459','P','Ste Marie','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.934009,-88.021589,0,'2013-07-06 12:44:33',NULL,NULL),(28222,'31036','S','Hayneville','N','Pulaski','13235','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.281988,-83.473610,0,'2013-07-06 12:44:31',NULL,NULL),(30633,'33443','P','Deerfield Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.324699,-80.120509,0,'2013-07-06 12:44:32',NULL,NULL),(52098,'60411','S','S Chicago Hei','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(12050,'12529','S','Hillsdale','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.195120,-73.567140,0,'2013-07-06 12:44:30',NULL,NULL),(50427,'57790','S','Wall','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.255280,-102.207790,0,'2013-07-06 12:44:33',NULL,NULL),(10672,'11120','U','Long Island City','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747242,-73.949347,0,'2013-07-06 12:44:30',NULL,NULL),(79241,'98556','P','Littlerock','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.900933,-123.018977,0,'2013-07-06 12:44:34',NULL,NULL),(28665,'31787','S','Smithville','D','Lee','13177','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.904581,-84.249811,0,'2013-07-06 12:44:32',NULL,NULL),(9983,'10163','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755007,-73.967791,0,'2013-07-06 12:44:30',NULL,NULL),(22181,'23479','U','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.846156,-76.092025,0,'2013-07-06 12:44:31',NULL,NULL),(17114,'17771','S','Wallis Run','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(47025,'54324','P','Hansen Road','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.479479,-88.021349,0,'2013-07-06 12:44:32',NULL,NULL),(34778,'38864','S','Sarepta','A','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.171200,-89.188320,0,'2013-07-06 12:44:32',NULL,NULL),(78614,'98198','S','Seatac','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.405098,-122.310024,0,'2013-07-06 12:44:34',NULL,NULL),(33516,'37374','S','Sequatchie','D','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.191382,-85.659281,0,'2013-07-06 12:44:32',NULL,NULL),(77437,'96806','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304761,-157.857413,0,'2013-07-06 12:44:34',NULL,NULL),(78649,'98225','S','Fairhaven','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.746494,-122.493289,0,'2013-07-06 12:44:34',NULL,NULL),(63436,'75668','S','Lone Star','D','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.943829,-94.708459,0,'2013-07-06 12:44:33',NULL,NULL),(21131,'22102','S','McLean','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(4248,'02875','S','Shannock','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.457393,-71.639083,0,'2013-07-06 12:44:30',NULL,NULL),(40345,'45620','S','Cheshire','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.945159,-82.112882,0,'2013-07-06 12:44:32',NULL,NULL),(41045,'46404','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.585279,-87.374644,0,'2013-07-06 12:44:32',NULL,NULL),(27241,'29924','S','Hampton','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.867113,-81.116640,0,'2013-07-06 12:44:31',NULL,NULL),(59500,'70775','S','Bains','A','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.862864,-91.332969,0,'2013-07-06 12:44:33',NULL,NULL),(57578,'67061','S','Corwin','N','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.124251,-98.404243,0,'2013-07-06 12:44:33',NULL,NULL),(30459,'33335','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181775,-80.138566,0,'2013-07-06 12:44:32',NULL,NULL),(47107,'54447','S','Lublin','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.122508,-90.693652,0,'2013-07-06 12:44:32',NULL,NULL),(38992,'44133','S','North Royalton','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.315718,-81.741271,0,'2013-07-06 12:44:32',NULL,NULL),(57679,'67223','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.727416,-97.490242,0,'2013-07-06 12:44:33',NULL,NULL),(52990,'61441','S','Bernadotte','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.365743,-90.275106,0,'2013-07-06 12:44:33',NULL,NULL),(43336,'48370','S','Oxford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.843341,-83.198007,0,'2013-07-06 12:44:32',NULL,NULL),(34639,'38764','P','Renova','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.791689,-90.857201,0,'2013-07-06 12:44:32',NULL,NULL),(53003,'61452','S','Doddsville','N','Schuyler','17169','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.240692,-90.619987,0,'2013-07-06 12:44:33',NULL,NULL),(18084,'18706','S','Laurel Run','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(61306,'72429','S','Fisher','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.509779,-90.929907,0,'2013-07-06 12:44:33',NULL,NULL),(33755,'37852','S','Robbins','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.326828,-84.571266,0,'2013-07-06 12:44:32',NULL,NULL),(55341,'63556','S','Milan','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(45672,'52039','S','Durango','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.540470,-90.839326,0,'2013-07-06 12:44:32',NULL,NULL),(66879,'79230','S','Dodson','D','Collingsworth','48087','Texas','TX','48','0000','806','Central',-6.0,'Y',34.732132,-100.065137,0,'2013-07-06 12:44:34',NULL,NULL),(11555,'12057','S','White Creek','A','Rensselaer','36083','New York','NY','36','2975','518','Eastern',-5.0,'Y',42.956640,-73.361520,0,'2013-07-06 12:44:30',NULL,NULL),(79397,'98801','S','Wenatchee Heights','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(4159,'02771','S','Seekonk','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.838870,-71.323757,0,'2013-07-06 12:44:30',NULL,NULL),(14167,'14732','P','Ellington','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.219861,-79.103575,0,'2013-07-06 12:44:31',NULL,NULL),(51337,'59301','S','Miles City','D','Custer','30017','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.405886,-105.841129,0,'2013-07-06 12:44:33',NULL,NULL),(78687,'98248','S','Pleasant Valley','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.858300,-122.606024,0,'2013-07-06 12:44:34',NULL,NULL),(66909,'79314','P','Bledso','N','Cochran','48079','Texas','TX','48','0000','806','Central',-6.0,'Y',33.638888,-102.875067,0,'2013-07-06 12:44:34',NULL,NULL),(70236,'84405','S','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(48220,'55416','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.948525,-93.344253,0,'2013-07-06 12:44:33',NULL,NULL),(10903,'11427','S','Bellrs Manor','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(17670,'18099','U','Rodale Press','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.533963,-75.497936,0,'2013-07-06 12:44:31',NULL,NULL),(66719,'78953','S','Delhi','N','Bastrop','48021','Texas','TX','48','0640','830','Central',-6.0,'Y',29.881875,-97.323178,0,'2013-07-06 12:44:34',NULL,NULL),(28727,'31905','S','Fort Benning','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.430120,-84.918180,0,'2013-07-06 12:44:32',NULL,NULL),(53122,'61546','S','Parkland','N','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.421867,-89.779680,0,'2013-07-06 12:44:33',NULL,NULL),(51318,'59250','S','Opheim','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.892429,-106.475312,0,'2013-07-06 12:44:33',NULL,NULL),(50808,'58455','S','Kensal','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.301327,-98.735992,0,'2013-07-06 12:44:33',NULL,NULL),(34633,'38759','S','Merigold','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.834487,-90.729355,0,'2013-07-06 12:44:32',NULL,NULL),(47338,'54568','S','Arbor Vitae','A','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.968160,-89.695260,0,'2013-07-06 12:44:32',NULL,NULL),(47336,'54566','S','Soperton','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.438000,-88.631280,0,'2013-07-06 12:44:32',NULL,NULL),(73218,'90624','P','Buena Park','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.858383,-118.003267,0,'2013-07-06 12:44:34',NULL,NULL),(5557,'04855','P','Port Clyde','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.045405,-69.145805,0,'2013-07-06 12:44:30',NULL,NULL),(48737,'55965','S','Carimona','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.667591,-92.079343,0,'2013-07-06 12:44:33',NULL,NULL),(38074,'43068','S','Pataskala','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.962571,-82.783851,0,'2013-07-06 12:44:32',NULL,NULL),(36190,'40257','P','Saint Matthews','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(33593,'37614','P','JC','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.330892,-82.365584,0,'2013-07-06 12:44:32',NULL,NULL),(27457,'30129','P','Coosa','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.258619,-85.338529,0,'2013-07-06 12:44:31',NULL,NULL),(64640,'76710','S','Speegleville','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.541760,-97.184700,0,'2013-07-06 12:44:34',NULL,NULL),(2676,'00966','S','Villas de Prado Alto','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(9888,'10126','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760726,-73.970532,0,'2013-07-06 12:44:30',NULL,NULL),(50872,'58523','S','Beulah','D','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.269077,-101.779299,0,'2013-07-06 12:44:33',NULL,NULL),(1541,'00757','S','Paseo Jacaranda','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(3702,'02139','S','Cambridgeport','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.366036,-71.103492,0,'2013-07-06 12:44:30',NULL,NULL),(68414,'81201','S','Turret','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(61678,'72934','S','Chester','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.703482,-94.236518,0,'2013-07-06 12:44:33',NULL,NULL),(40533,'45837','P','Continental','A','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.056211,-84.300289,0,'2013-07-06 12:44:32',NULL,NULL),(37609,'42129','S','Subtle','A','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(36358,'40447','S','Eberle','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(56886,'66033','S','Greeley','D','Anderson','20003','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.367258,-95.126185,0,'2013-07-06 12:44:33',NULL,NULL),(39252,'44441','S','Negley','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.771152,-80.555526,0,'2013-07-06 12:44:32',NULL,NULL),(25932,'28655','S','Brindle Town','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(14384,'15037','S','Elizabeth','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.267795,-79.859115,0,'2013-07-06 12:44:31',NULL,NULL),(35770,'39743','S','Penns','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.341575,-88.514050,0,'2013-07-06 12:44:32',NULL,NULL),(74154,'92258','P','North Palm Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.922919,-116.549446,0,'2013-07-06 12:44:34',NULL,NULL),(64450,'76570','S','Cedar Springs','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(11976,'12466','S','Port Ewen','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.904729,-73.979877,0,'2013-07-06 12:44:30',NULL,NULL),(32496,'36062','P','Petrey','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.848193,-86.207276,0,'2013-07-06 12:44:32',NULL,NULL),(16966,'17705','U','BRO Dart','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.240610,-77.039118,0,'2013-07-06 12:44:31',NULL,NULL),(3979,'02532','S','Buzzards Bay','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.741040,-70.588920,0,'2013-07-06 12:44:30',NULL,NULL),(21304,'22404','P','Fredericksbrg','A','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.297717,-77.456462,0,'2013-07-06 12:44:31',NULL,NULL),(16735,'17502','S','Conoy','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.121860,-76.654353,0,'2013-07-06 12:44:31',NULL,NULL),(43914,'49257','P','Moscow','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.051081,-84.508969,0,'2013-07-06 12:44:32',NULL,NULL),(45629,'51632','S','Clarinda','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.736141,-95.038982,0,'2013-07-06 12:44:32',NULL,NULL),(70758,'85328','S','Cibola','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.533467,-114.432903,0,'2013-07-06 12:44:34',NULL,NULL),(72622,'89418','S','Thunder Mountain','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(79021,'98391','S','Lake Tapps','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(70695,'85261','P','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.497144,-111.920600,0,'2013-07-06 12:44:34',NULL,NULL),(37914,'42633','S','Powersburg','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(4154,'02767','S','Raynham','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.927678,-71.046473,0,'2013-07-06 12:44:30',NULL,NULL),(42965,'48133','S','Erie','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.782511,-83.490703,0,'2013-07-06 12:44:32',NULL,NULL),(69569,'83824','S','Desmet','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.145012,-116.916574,0,'2013-07-06 12:44:34',NULL,NULL),(12020,'12508','S','Beacon','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.487840,-73.949040,0,'2013-07-06 12:44:30',NULL,NULL),(78160,'97625','S','Dairy','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.260580,-121.658400,0,'2013-07-06 12:44:34',NULL,NULL),(41760,'47302','S','Medford','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(44622,'50061','S','WDM','A','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.489268,-93.753860,0,'2013-07-06 12:44:32',NULL,NULL),(18193,'18935','P','Milford Square','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.432188,-75.396928,0,'2013-07-06 12:44:31',NULL,NULL),(53889,'62354','S','Nauvoo','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.548906,-91.378490,0,'2013-07-06 12:44:33',NULL,NULL),(11229,'11752','S','Islip Terrace','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.751159,-73.184614,0,'2013-07-06 12:44:30',NULL,NULL),(5304,'04553','S','Newcastle','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.066869,-69.547937,0,'2013-07-06 12:44:30',NULL,NULL),(9451,'10006','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(63707,'75901','S','Lufkin','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.330215,-94.721876,0,'2013-07-06 12:44:34',NULL,NULL),(32244,'35602','P','Decatur','D','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.544077,-86.963369,0,'2013-07-06 12:44:32',NULL,NULL),(42213,'47553','S','Scenic Hill','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(2091,'00922','P','Caparra Terrace','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409982,-66.092553,0,'2013-07-06 12:44:30',NULL,NULL),(76075,'95208','P','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.955950,-121.441672,0,'2013-07-06 12:44:34',NULL,NULL),(57974,'67835','S','Kalvesta','A','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.904580,-100.332780,0,'2013-07-06 12:44:33',NULL,NULL),(3431,'01745','S','Southboro','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.292310,-71.504095,0,'2013-07-06 12:44:30',NULL,NULL),(43138,'48236','S','Grosse Pointe Park','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(25190,'28055','P','Gastonia','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.218503,-81.253100,0,'2013-07-06 12:44:31',NULL,NULL),(44836,'50258','S','Union','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.172317,-93.084639,0,'2013-07-06 12:44:32',NULL,NULL),(4103,'02702','S','Assonet','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.795588,-71.062877,0,'2013-07-06 12:44:30',NULL,NULL),(23740,'25921','P','Sophia','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.706351,-81.256171,0,'2013-07-06 12:44:31',NULL,NULL),(60571,'71763','S','Manning','A','Dallas','05039','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.021111,-92.792778,0,'2013-07-06 12:44:33',NULL,NULL),(60130,'71371','S','Zenoria','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(53758,'62263','S','Nashville','D','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441389,-89.370278,0,'2013-07-06 12:44:33',NULL,NULL),(49176,'56425','S','Baxter','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341560,-94.288961,0,'2013-07-06 12:44:33',NULL,NULL),(17592,'18034','S','Center Valley','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.548288,-75.425567,0,'2013-07-06 12:44:31',NULL,NULL),(43982,'49331','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.948478,-85.359091,0,'2013-07-06 12:44:32',NULL,NULL),(31560,'34610','S','Brooksville','A','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.397951,-82.537892,0,'2013-07-06 12:44:32',NULL,NULL),(30036,'33141','S','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(9642,'10036','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(71944,'87936','S','Garfield','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.747571,-107.266826,0,'2013-07-06 12:44:34',NULL,NULL),(78329,'97918','S','Willowcreek','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.013408,-117.288795,0,'2013-07-06 12:44:34',NULL,NULL),(65364,'77535','S','Eastgate','N','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.997780,-94.918320,0,'2013-07-06 12:44:34',NULL,NULL),(60667,'71921','S','Rosboro','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(2335,'00936','P','Cupey','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(3358,'01568','S','Upton','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.171445,-71.604409,0,'2013-07-06 12:44:30',NULL,NULL),(28572,'31606','S','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.812890,-83.166477,0,'2013-07-06 12:44:32',NULL,NULL),(28773,'32034','S','Amelia City','N','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.636954,-81.461340,0,'2013-07-06 12:44:32',NULL,NULL),(36880,'41099','U','Newport','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.032312,-84.463361,0,'2013-07-06 12:44:32',NULL,NULL),(34614,'38751','S','Kinlock','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(77805,'97138','S','Seaside','D','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.001224,-123.921677,0,'2013-07-06 12:44:34',NULL,NULL),(26922,'29584','S','Patrick','D','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.562239,-80.076179,0,'2013-07-06 12:44:31',NULL,NULL),(32944,'36572','S','Satsuma','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.854788,-88.056897,0,'2013-07-06 12:44:32',NULL,NULL),(34584,'38739','P','Dublin','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.188126,-90.625399,0,'2013-07-06 12:44:32',NULL,NULL),(57547,'67028','S','Coats','D','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.514225,-98.902140,0,'2013-07-06 12:44:33',NULL,NULL),(54783,'63005','S','Gumbo','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634884,-90.619343,0,'2013-07-06 12:44:33',NULL,NULL),(75688,'94558','S','Spanish Flat','A','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.343537,-122.305067,0,'2013-07-06 12:44:34',NULL,NULL),(76541,'95659','S','Verona Landing','N','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.870336,-121.567175,0,'2013-07-06 12:44:34',NULL,NULL),(16385,'17212','S','Big Cove Tannery','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.882480,-78.020400,0,'2013-07-06 12:44:31',NULL,NULL),(7389,'06782','S','Plymouth','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.664097,-73.049922,0,'2013-07-06 12:44:30',NULL,NULL),(15761,'16915','S','Inez','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(28524,'31546','S','Jesup','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.469865,-81.781564,0,'2013-07-06 12:44:32',NULL,NULL),(67117,'79738','S','Gail','D','Borden','48033','Texas','TX','48','0000','432','Central',-6.0,'Y',32.746164,-101.431131,0,'2013-07-06 12:44:34',NULL,NULL),(60156,'71403','S','Anacoco','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.210780,-93.391572,0,'2013-07-06 12:44:33',NULL,NULL),(56329,'65107','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578678,-92.173699,0,'2013-07-06 12:44:33',NULL,NULL),(51997,'60163','S','Hillside','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.884020,-87.908634,0,'2013-07-06 12:44:33',NULL,NULL),(29343,'32550','S','Miramar Beach','D','Walton','12131','Florida','FL','12','2750','850','Central',-6.0,'Y',30.393333,-86.495833,0,'2013-07-06 12:44:32',NULL,NULL),(45614,'51571','S','Silver City','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.113806,-95.633702,0,'2013-07-06 12:44:32',NULL,NULL),(41076,'46526','S','Goshen','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.586985,-85.835835,0,'2013-07-06 12:44:32',NULL,NULL),(30437,'33330','S','Pembroke Pines','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(25479,'28351','S','Laurel Hill','D','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.869052,-79.546721,0,'2013-07-06 12:44:31',NULL,NULL),(7537,'07007','P','West Caldwell','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.840833,-74.302222,0,'2013-07-06 12:44:30',NULL,NULL),(73313,'90810','S','Dominguez','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.817980,-118.223280,0,'2013-07-06 12:44:34',NULL,NULL),(75525,'94163','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.791422,-122.399414,0,'2013-07-06 12:44:34',NULL,NULL),(15407,'16345','S','Scandia','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.948820,-79.104480,0,'2013-07-06 12:44:31',NULL,NULL),(11375,'11933','S','Baiting Hollo','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.934460,-72.769140,0,'2013-07-06 12:44:30',NULL,NULL),(31540,'34601','S','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.565743,-82.376785,0,'2013-07-06 12:44:32',NULL,NULL),(3024,'01089','S','West Springfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.117059,-72.639407,0,'2013-07-06 12:44:30',NULL,NULL),(1885,'00791','S','Urb Sunrise','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(67022,'79534','S','Mc Caulley','D','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.798320,-100.225032,0,'2013-07-06 12:44:34',NULL,NULL),(35060,'39183','S','Bovina','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.390993,-90.829096,0,'2013-07-06 12:44:32',NULL,NULL),(8458,'08087','S','Tuckerton','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(22239,'23630','U','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.999882,-76.410732,0,'2013-07-06 12:44:31',NULL,NULL),(40710,'46112','S','Brownsburg','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.859746,-86.383573,0,'2013-07-06 12:44:32',NULL,NULL),(60868,'72058','S','Linder','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(58425,'68659','S','Rogers','D','Colfax','31037','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.468839,-96.955803,0,'2013-07-06 12:44:33',NULL,NULL),(45254,'50661','P','N Washington','A','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.057551,-92.312724,0,'2013-07-06 12:44:32',NULL,NULL),(37788,'42366','S','Philpot','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.738372,-86.943626,0,'2013-07-06 12:44:32',NULL,NULL),(38017,'43009','S','Cable','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.173885,-83.644285,0,'2013-07-06 12:44:32',NULL,NULL),(43719,'48916','U','Lucky Losers','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.671084,-84.573494,0,'2013-07-06 12:44:32',NULL,NULL),(72578,'89404','P','Jackson Mountain','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(12079,'12552','P','Newburgh','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.538018,-74.049012,0,'2013-07-06 12:44:30',NULL,NULL),(11196,'11741','S','Holbrook','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.798188,-73.076253,0,'2013-07-06 12:44:30',NULL,NULL),(16331,'17125','U','State General Services','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266171,-76.880912,0,'2013-07-06 12:44:31',NULL,NULL),(17441,'17935','S','Connerton','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.790036,-76.280325,0,'2013-07-06 12:44:31',NULL,NULL),(29798,'33022','P','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.009694,-80.144836,0,'2013-07-06 12:44:32',NULL,NULL),(46885,'54114','S','Beaver','A','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.293210,-87.992690,0,'2013-07-06 12:44:32',NULL,NULL),(43737,'48956','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.734814,-84.556691,0,'2013-07-06 12:44:32',NULL,NULL),(43463,'48553','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.974333,-83.716168,0,'2013-07-06 12:44:32',NULL,NULL),(14206,'14778','P','Saint Bonaventure','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.080151,-78.474616,0,'2013-07-06 12:44:31',NULL,NULL),(13163,'13607','S','Edgewood Park','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(20348,'20859','P','Potomac','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.022959,-77.199250,0,'2013-07-06 12:44:31',NULL,NULL),(63640,'75844','S','Denson Spring','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(75911,'95003','S','Seacliff','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.992640,-121.876740,0,'2013-07-06 12:44:34',NULL,NULL),(40094,'45305','S','Sugarcreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(30254,'33222','P','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.732873,-80.241591,0,'2013-07-06 12:44:32',NULL,NULL),(3448,'01760','S','South Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(31524,'34478','P','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.185467,-82.141799,0,'2013-07-06 12:44:32',NULL,NULL),(63504,'75709','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.331224,-95.364973,0,'2013-07-06 12:44:33',NULL,NULL),(40054,'45267','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.127931,-84.514462,0,'2013-07-06 12:44:32',NULL,NULL),(76000,'95110','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.336534,-121.899530,0,'2013-07-06 12:44:34',NULL,NULL),(4303,'02907','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821440,-71.433900,0,'2013-07-06 12:44:30',NULL,NULL),(42315,'47613','S','Wheatonville','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.160224,-87.449707,0,'2013-07-06 12:44:32',NULL,NULL),(75306,'93744','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.758680,-119.797616,0,'2013-07-06 12:44:34',NULL,NULL),(78598,'98188','S','Riverton','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(64292,'76449','S','Graford','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.925153,-98.303425,0,'2013-07-06 12:44:34',NULL,NULL),(70260,'84513','S','Castle Dale','D','Emery','49015','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.215189,-111.028483,0,'2013-07-06 12:44:34',NULL,NULL),(45625,'51603','U','Earl May Seed','N','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.766701,-95.371715,0,'2013-07-06 12:44:32',NULL,NULL),(3648,'02117','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.342166,-71.073298,0,'2013-07-06 12:44:30',NULL,NULL),(139,'00617','S','Est de Barceloneta','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(69208,'83352','S','Shoshone','D','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.939059,-114.405702,0,'2013-07-06 12:44:34',NULL,NULL),(24574,'27313','S','Pleasant Garden','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.952898,-79.757191,0,'2013-07-06 12:44:31',NULL,NULL),(23642,'25776','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.419181,-82.474658,0,'2013-07-06 12:44:31',NULL,NULL),(54839,'63036','S','French Vlg','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.764518,-90.427334,0,'2013-07-06 12:44:33',NULL,NULL),(19790,'20431','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895708,-77.044874,0,'2013-07-06 12:44:31',NULL,NULL),(40779,'46161','S','Morristown','D','Shelby','18145','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.674407,-85.699943,0,'2013-07-06 12:44:32',NULL,NULL),(4072,'02651','P','North Eastham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.852794,-69.973580,0,'2013-07-06 12:44:30',NULL,NULL),(38545,'43752','P','Laings','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.716010,-81.013102,0,'2013-07-06 12:44:32',NULL,NULL),(4365,'03063','S','Nashua','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.768667,-71.514276,0,'2013-07-06 12:44:30',NULL,NULL),(25099,'27962','S','Plymouth','D','Washington','37187','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.859301,-76.745346,0,'2013-07-06 12:44:31',NULL,NULL),(69640,'84005','S','Eagle Mtn','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.352471,-111.983329,0,'2013-07-06 12:44:34',NULL,NULL),(8706,'08362','P','Vineland','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.465559,-74.999200,0,'2013-07-06 12:44:30',NULL,NULL),(20889,'21702','S','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.494400,-77.453520,0,'2013-07-06 12:44:31',NULL,NULL),(18200,'18940','S','Upr Makefield','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245694,-74.942426,0,'2013-07-06 12:44:31',NULL,NULL),(18098,'18709','S','Luzerne','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.281505,-75.894483,0,'2013-07-06 12:44:31',NULL,NULL),(44655,'50104','S','Gibson','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.465855,-92.352805,0,'2013-07-06 12:44:32',NULL,NULL),(39639,'44903','S','Pavonia','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.760320,-82.520048,0,'2013-07-06 12:44:32',NULL,NULL),(28592,'31639','S','Nashville','D','Berrien','13019','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.202158,-83.237799,0,'2013-07-06 12:44:32',NULL,NULL),(26809,'29471','S','Reevesville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.179731,-80.685009,0,'2013-07-06 12:44:31',NULL,NULL),(3924,'02461','S','Newton Hlds','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.314739,-71.208012,0,'2013-07-06 12:44:30',NULL,NULL),(60681,'71929','S','Bismarck','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.336448,-93.193258,0,'2013-07-06 12:44:33',NULL,NULL),(48014,'55171','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.943845,-93.093553,0,'2013-07-06 12:44:33',NULL,NULL),(36455,'40701','S','Woodbine','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.937489,-84.114901,0,'2013-07-06 12:44:32',NULL,NULL),(35167,'39269','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.299021,-90.185387,0,'2013-07-06 12:44:32',NULL,NULL),(57706,'67342','S','Edna','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.064483,-95.357511,0,'2013-07-06 12:44:33',NULL,NULL),(53045,'61480','S','Stronghurst','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.746561,-90.908216,0,'2013-07-06 12:44:33',NULL,NULL),(37770,'42344','S','Graham','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.239171,-87.300028,0,'2013-07-06 12:44:32',NULL,NULL),(57081,'66216','S','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.008231,-94.740275,0,'2013-07-06 12:44:33',NULL,NULL),(5419,'04668','S','Big Lake Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.226109,-67.563119,0,'2013-07-06 12:44:30',NULL,NULL),(47990,'55129','S','Woodbury','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.889630,-92.918840,0,'2013-07-06 12:44:33',NULL,NULL),(40089,'45305','S','Beaver Creek','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(12782,'13215','S','Onon Hill','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.975120,-76.226340,0,'2013-07-06 12:44:30',NULL,NULL),(65010,'77302','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.244988,-95.403556,0,'2013-07-06 12:44:34',NULL,NULL),(55453,'63732','S','Altenburg','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.523700,-89.597280,0,'2013-07-06 12:44:33',NULL,NULL),(15174,'15929','P','Dilltown','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.469995,-79.002136,0,'2013-07-06 12:44:31',NULL,NULL),(8953,'08759','S','Whiting','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.952064,-74.365653,0,'2013-07-06 12:44:30',NULL,NULL),(74846,'93246','U','Lemoore Nas','A','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.290241,-119.847834,0,'2013-07-06 12:44:34',NULL,NULL),(66562,'78736','S','Circleville','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250073,-97.926724,0,'2013-07-06 12:44:34',NULL,NULL),(37439,'41835','S','Mc Roberts','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.208737,-82.669640,0,'2013-07-06 12:44:32',NULL,NULL),(46319,'53073','S','Plymouth','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.750559,-87.979314,0,'2013-07-06 12:44:32',NULL,NULL),(25763,'28585','S','Trenton','D','Jones','37103','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.066822,-77.410809,0,'2013-07-06 12:44:31',NULL,NULL),(3263,'01463','S','E Pepperell','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.667500,-71.599440,0,'2013-07-06 12:44:30',NULL,NULL),(40493,'45788','S','Whipple','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.471944,-81.411389,0,'2013-07-06 12:44:32',NULL,NULL),(19221,'19896','U','Verizon','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.758421,-75.527711,0,'2013-07-06 12:44:31',NULL,NULL),(23730,'25915','S','Mead','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.623930,-81.286203,0,'2013-07-06 12:44:31',NULL,NULL),(20490,'21053','S','Freeland','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.696325,-76.719225,0,'2013-07-06 12:44:31',NULL,NULL),(11107,'11701','S','N Amityville','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.686293,-73.412179,0,'2013-07-06 12:44:30',NULL,NULL),(11883,'12308','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.820842,-73.919980,0,'2013-07-06 12:44:30',NULL,NULL),(64768,'76951','S','Sterling City','D','Sterling','48431','Texas','TX','48','0000','325','Central',-6.0,'Y',31.836769,-100.981020,0,'2013-07-06 12:44:34',NULL,NULL),(68744,'82217','S','Hawk Springs','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.730644,-104.361015,0,'2013-07-06 12:44:34',NULL,NULL),(70341,'84632','P','Ftn Green','N','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.536945,-111.680191,0,'2013-07-06 12:44:34',NULL,NULL),(75556,'94250','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.581619,-121.491498,0,'2013-07-06 12:44:34',NULL,NULL),(39775,'45121','S','Hillman','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(26940,'29597','P','N Myrtle Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.812707,-78.700848,0,'2013-07-06 12:44:31',NULL,NULL),(4337,'03036','S','Chester','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.966560,-71.239990,0,'2013-07-06 12:44:30',NULL,NULL),(69842,'84083','S','Greenhaven','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.738100,-114.021398,0,'2013-07-06 12:44:34',NULL,NULL),(51757,'60025','S','Glenview','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.078155,-87.817359,0,'2013-07-06 12:44:33',NULL,NULL),(8536,'08201','S','Absecon','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(66086,'78402','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.824407,-97.388526,0,'2013-07-06 12:44:34',NULL,NULL),(71891,'87742','S','Pendaries','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.850000,-105.433333,0,'2013-07-06 12:44:34',NULL,NULL),(241,'00637','S','Est del Rio','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(42818,'48059','S','N Lakeport','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(29684,'32925','S','Patrick AFB','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.229987,-80.623528,0,'2013-07-06 12:44:32',NULL,NULL),(26419,'29123','S','Pelion','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.776254,-81.255322,0,'2013-07-06 12:44:31',NULL,NULL),(760,'00692','S','Urb Cielo Dorado','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(52123,'60428','S','Harvey','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.608419,-87.666114,0,'2013-07-06 12:44:33',NULL,NULL),(55816,'64148','P','K C','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.088651,-94.581287,0,'2013-07-06 12:44:33',NULL,NULL),(65935,'78252','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.349236,-98.694536,0,'2013-07-06 12:44:34',NULL,NULL),(71443,'87038','P','Encinal','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.002693,-107.413459,0,'2013-07-06 12:44:34',NULL,NULL),(73460,'91304','S','Canoga Park','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.218348,-118.625847,0,'2013-07-06 12:44:34',NULL,NULL),(78338,'98004','S','Beaux Arts Village','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(35297,'39401','S','McLaurin','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(64949,'77231','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.654326,-95.475403,0,'2013-07-06 12:44:34',NULL,NULL),(25371,'28250','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.223868,-80.839089,0,'2013-07-06 12:44:31',NULL,NULL),(8782,'08554','S','Roebling','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.114239,-74.779351,0,'2013-07-06 12:44:30',NULL,NULL),(6827,'06115','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760560,-72.674050,0,'2013-07-06 12:44:30',NULL,NULL),(37862,'42519','S','Sloans Valley','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.970557,-84.572994,0,'2013-07-06 12:44:32',NULL,NULL),(65031,'77327','S','Evergreen','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(17424,'17923','P','Branchdale','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.674527,-76.324675,0,'2013-07-06 12:44:31',NULL,NULL),(27225,'29916','S','Fechtig','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.635320,-81.034920,0,'2013-07-06 12:44:31',NULL,NULL),(73432,'91210','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.141910,-118.260565,0,'2013-07-06 12:44:34',NULL,NULL),(7411,'06798','S','Woodbury','D','Litchfield','09005','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.555937,-73.203211,0,'2013-07-06 12:44:30',NULL,NULL),(12747,'13203','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.060624,-76.139954,0,'2013-07-06 12:44:30',NULL,NULL),(16914,'17602','S','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(31944,'35205','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.496708,-86.804796,0,'2013-07-06 12:44:32',NULL,NULL),(47893,'55107','S','W Saint Paul','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.932638,-93.077152,0,'2013-07-06 12:44:33',NULL,NULL),(51270,'59103','P','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.637937,-108.361329,0,'2013-07-06 12:44:33',NULL,NULL),(55032,'63137','S','Glasgow Village','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748404,-90.218419,0,'2013-07-06 12:44:33',NULL,NULL),(55535,'63833','S','Catron','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.692876,-89.755250,0,'2013-07-06 12:44:33',NULL,NULL),(67464,'80221','S','Denver','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(71884,'87734','S','Aurora','N','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.018378,-105.001748,0,'2013-07-06 12:44:34',NULL,NULL),(76267,'95417','S','Branscomb','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.663318,-123.633905,0,'2013-07-06 12:44:34',NULL,NULL),(32208,'35559','P','Bazemore','N','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.882529,-87.744808,0,'2013-07-06 12:44:32',NULL,NULL),(64568,'76660','S','Malone','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.934685,-96.885797,0,'2013-07-06 12:44:34',NULL,NULL),(44869,'50308','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.583922,-93.621551,0,'2013-07-06 12:44:32',NULL,NULL),(71136,'86024','S','Flagstaff','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.662907,-111.479346,0,'2013-07-06 12:44:34',NULL,NULL),(41737,'47261','P','Millhousen','D','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.322551,-85.477772,0,'2013-07-06 12:44:32',NULL,NULL),(64810,'77024','S','Piney Point Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(28403,'31316','S','Elim','N','Long','13183','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.730688,-81.735664,0,'2013-07-06 12:44:32',NULL,NULL),(16123,'17057','S','HBG Inter Airp','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(13729,'14095','P','Lockport','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.171046,-78.688835,0,'2013-07-06 12:44:31',NULL,NULL),(27049,'29673','S','Piedmont','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.675130,-82.534256,0,'2013-07-06 12:44:31',NULL,NULL),(28929,'32168','S','New Smyrna','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.002944,-81.017002,0,'2013-07-06 12:44:32',NULL,NULL),(31436,'34269','S','Lake Suzy','A','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.166492,-81.804395,0,'2013-07-06 12:44:32',NULL,NULL),(46524,'53288','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.043453,-87.912413,0,'2013-07-06 12:44:32',NULL,NULL),(58217,'68337','S','Dawson','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.130784,-95.839206,0,'2013-07-06 12:44:33',NULL,NULL),(76034,'95151','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.291739,-121.783728,0,'2013-07-06 12:44:34',NULL,NULL),(79658,'99152','P','Metaline','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.849212,-117.387715,0,'2013-07-06 12:44:34',NULL,NULL),(15263,'16101','S','Castle','N','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.989418,-80.336151,0,'2013-07-06 12:44:31',NULL,NULL),(39756,'45111','S','Camp Dennison','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.197180,-84.291954,0,'2013-07-06 12:44:32',NULL,NULL),(53587,'62069','S','Mount Olive','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.072236,-89.724462,0,'2013-07-06 12:44:33',NULL,NULL),(53131,'61548','S','Oak Ridge','N','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.788480,-89.427180,0,'2013-07-06 12:44:33',NULL,NULL),(43320,'48359','S','Orion Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722304,-83.277927,0,'2013-07-06 12:44:32',NULL,NULL),(22356,'23893','S','White Plains','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.633235,-77.911891,0,'2013-07-06 12:44:31',NULL,NULL),(75430,'94035','P','Mountain View','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.412894,-122.049891,0,'2013-07-06 12:44:34',NULL,NULL),(76441,'95604','P','Bowman','A','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.902920,-121.066980,0,'2013-07-06 12:44:34',NULL,NULL),(76619,'95699','P','Drytown','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.444551,-120.847909,0,'2013-07-06 12:44:34',NULL,NULL),(70076,'84150','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.772019,-111.889801,0,'2013-07-06 12:44:34',NULL,NULL),(20029,'20632','S','Faulkner','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.440913,-76.961253,0,'2013-07-06 12:44:31',NULL,NULL),(38001,'42762','S','Millwood','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.442701,-86.409807,0,'2013-07-06 12:44:32',NULL,NULL),(54142,'62565','S','Henton','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(46530,'53295','U','Zablocki VA Medical Ctr','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.016381,-87.979711,0,'2013-07-06 12:44:32',NULL,NULL),(44702,'50137','S','Killduff','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.721789,-93.033905,0,'2013-07-06 12:44:32',NULL,NULL),(4164,'02783','U','Taunton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.018670,-71.053316,0,'2013-07-06 12:44:30',NULL,NULL),(40827,'46209','U','Indianapolis Brm','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.744999,-86.158607,0,'2013-07-06 12:44:32',NULL,NULL),(10342,'10560','S','North Salem','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.330181,-73.607527,0,'2013-07-06 12:44:30',NULL,NULL),(31026,'33786','S','Belleair Shores','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.922839,-82.834505,0,'2013-07-06 12:44:32',NULL,NULL),(27592,'30291','S','Union City','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.583587,-84.547325,0,'2013-07-06 12:44:31',NULL,NULL),(49901,'57276','S','Roland Colony','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.385480,-96.626520,0,'2013-07-06 12:44:33',NULL,NULL),(53541,'62035','S','Godfrey','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.961670,-90.217939,0,'2013-07-06 12:44:33',NULL,NULL),(60754,'71999','U','Arkadelphia','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.124529,-93.072399,0,'2013-07-06 12:44:33',NULL,NULL),(9786,'10107','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768216,-73.987951,0,'2013-07-06 12:44:30',NULL,NULL),(14049,'14560','S','Webster Crsng','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.711095,-77.553933,0,'2013-07-06 12:44:31',NULL,NULL),(4626,'03603','S','Charlestown','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.236105,-72.426678,0,'2013-07-06 12:44:30',NULL,NULL),(16671,'17356','S','Springvale','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(14768,'15340','S','Hickory','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.294868,-80.309223,0,'2013-07-06 12:44:31',NULL,NULL),(29243,'32435','S','Defuniak Springs','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.719521,-86.121763,0,'2013-07-06 12:44:32',NULL,NULL),(26762,'29433','P','Canadys','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.054685,-80.620733,0,'2013-07-06 12:44:31',NULL,NULL),(46186,'52742','S','De Witt','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.823540,-90.460200,0,'2013-07-06 12:44:32',NULL,NULL),(50959,'58623','S','Buffalo Springs','A','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.179366,-103.400993,0,'2013-07-06 12:44:33',NULL,NULL),(64535,'76645','S','Chat','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(67606,'80430','S','Coalmont','D','Jackson','08057','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.562500,-106.443889,0,'2013-07-06 12:44:34',NULL,NULL),(70964,'85650','S','Sierra Vista','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.495604,-110.262376,0,'2013-07-06 12:44:34',NULL,NULL),(1215,'00728','S','Urb Bello Horizonte','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(19912,'20549','U','Securities and Exchange Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891820,-77.019583,0,'2013-07-06 12:44:31',NULL,NULL),(3701,'02139','S','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.366036,-71.103492,0,'2013-07-06 12:44:30',NULL,NULL),(15570,'16648','S','Hollidaysburg','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.435661,-78.390414,0,'2013-07-06 12:44:31',NULL,NULL),(14040,'14551','S','Sodus Center','A','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.200120,-77.038500,0,'2013-07-06 12:44:31',NULL,NULL),(69421,'83632','S','Indian Valley','D','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.530683,-116.347764,0,'2013-07-06 12:44:34',NULL,NULL),(75005,'93454','S','Rancho Suey','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.877520,-120.331800,0,'2013-07-06 12:44:34',NULL,NULL),(66117,'78417','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.728238,-97.443545,0,'2013-07-06 12:44:34',NULL,NULL),(11155,'11719','S','S Haven','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.779227,-72.915009,0,'2013-07-06 12:44:30',NULL,NULL),(54083,'62521','S','Decatur','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.827104,-88.924086,0,'2013-07-06 12:44:33',NULL,NULL),(15290,'16131','S','Hartstown','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.555386,-80.440331,0,'2013-07-06 12:44:31',NULL,NULL),(13809,'14210','S','West Seneca','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.863725,-78.827208,0,'2013-07-06 12:44:31',NULL,NULL),(45271,'50672','S','Steamboat Rk','A','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.407668,-93.067862,0,'2013-07-06 12:44:32',NULL,NULL),(12206,'12787','S','Wht Sphr Spgs','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.789800,-74.828390,0,'2013-07-06 12:44:30',NULL,NULL),(66947,'79369','P','Spade','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',33.933813,-102.238376,0,'2013-07-06 12:44:34',NULL,NULL),(79548,'99001','S','Airway Hgts','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.650357,-117.616267,0,'2013-07-06 12:44:34',NULL,NULL),(79828,'99514','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.208882,-149.829945,0,'2013-07-06 12:44:34',NULL,NULL),(11562,'12062','S','East Nassau','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.531602,-73.502202,0,'2013-07-06 12:44:30',NULL,NULL),(21559,'22807','U','Hburg','N','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.434377,-78.874712,0,'2013-07-06 12:44:31',NULL,NULL),(24326,'27023','S','Lewisville','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.097444,-80.422826,0,'2013-07-06 12:44:31',NULL,NULL),(76590,'95684','S','Fair Play','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.602860,-120.630000,0,'2013-07-06 12:44:34',NULL,NULL),(63326,'75572','S','Lanark','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.175260,-94.152300,0,'2013-07-06 12:44:33',NULL,NULL),(37343,'41701','S','Typo','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.253627,-83.184866,0,'2013-07-06 12:44:32',NULL,NULL),(9197,'09447','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33418,'37241','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108116,-86.674720,0,'2013-07-06 12:44:32',NULL,NULL),(16552,'17307','S','Table Rock','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(16247,'17082','S','Port Royal','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(19942,'20573','U','Federal Maritime Commission','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899380,-77.008021,0,'2013-07-06 12:44:31',NULL,NULL),(46091,'52619','S','Sand Prairie','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.564680,-91.579860,0,'2013-07-06 12:44:32',NULL,NULL),(46256,'53012','S','Cedarburg','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.312977,-88.043817,0,'2013-07-06 12:44:32',NULL,NULL),(51818,'60051','S','Lakemoor','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.342172,-88.289042,0,'2013-07-06 12:44:33',NULL,NULL),(55307,'63534','S','Callao','D','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.739621,-92.645570,0,'2013-07-06 12:44:33',NULL,NULL),(66846,'79118','S','Timbercrk Cyn','A','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.065430,-101.852052,0,'2013-07-06 12:44:34',NULL,NULL),(33808,'37915','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.972359,-83.899560,0,'2013-07-06 12:44:32',NULL,NULL),(31696,'34945','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.424970,-80.450133,0,'2013-07-06 12:44:32',NULL,NULL),(27325,'30032','S','Belvedere','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.735464,-84.266983,0,'2013-07-06 12:44:31',NULL,NULL),(26658,'29373','P','Pacolet Mills','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.914539,-81.745893,0,'2013-07-06 12:44:31',NULL,NULL),(59285,'70466','S','Tickfaw','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.559296,-90.499148,0,'2013-07-06 12:44:33',NULL,NULL),(79402,'98807','P','Wenatchee','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.370261,-120.293544,0,'2013-07-06 12:44:34',NULL,NULL),(78205,'97741','S','Madras','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.650922,-121.136968,0,'2013-07-06 12:44:34',NULL,NULL),(14148,'14715','S','Alma','N','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.075166,-78.157392,0,'2013-07-06 12:44:31',NULL,NULL),(29363,'32571','S','Pace','A','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.669600,-87.154920,0,'2013-07-06 12:44:32',NULL,NULL),(70183,'84331','S','Washakie','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.975569,-112.191160,0,'2013-07-06 12:44:34',NULL,NULL),(73353,'91010','S','Duarte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138594,-117.963204,0,'2013-07-06 12:44:34',NULL,NULL),(71517,'87116','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.059190,-106.554193,0,'2013-07-06 12:44:34',NULL,NULL),(40761,'46148','S','Raysville','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.794447,-85.525839,0,'2013-07-06 12:44:32',NULL,NULL),(30774,'33578','S','Riverview','D','Hillsborough','12057','Florida','FL','12','8280','352','Eastern',-5.0,'Y',27.880697,-82.369066,0,'2013-07-06 12:44:32',NULL,NULL),(16580,'17320','S','Greenstone','A','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.755100,-77.376290,0,'2013-07-06 12:44:31',NULL,NULL),(28208,'31027','S','E Dublin','A','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.548593,-82.870112,0,'2013-07-06 12:44:31',NULL,NULL),(21178,'22159','U','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801702,-77.182270,0,'2013-07-06 12:44:31',NULL,NULL),(48719,'55952','S','Lewiston','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.984316,-91.867324,0,'2013-07-06 12:44:33',NULL,NULL),(59580,'70895','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.455864,-91.075438,0,'2013-07-06 12:44:33',NULL,NULL),(68481,'81248','P','White Pine','N','Saguache','08109','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.539419,-106.395042,0,'2013-07-06 12:44:34',NULL,NULL),(73959,'92066','S','Warner Spgs','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.219240,-116.528880,0,'2013-07-06 12:44:34',NULL,NULL),(1084,'00725','S','Urb Brooklyn','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(62426,'74148','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.190107,-96.004902,0,'2013-07-06 12:44:33',NULL,NULL),(19362,'20052','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898075,-77.043933,0,'2013-07-06 12:44:31',NULL,NULL),(58771,'68969','P','Ragan','D','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.310839,-99.254620,0,'2013-07-06 12:44:33',NULL,NULL),(1496,'00751','S','Urb Corales del Mar','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(7065,'06334','P','Bozrah','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.539470,-72.176914,0,'2013-07-06 12:44:30',NULL,NULL),(73116,'90255','S','Walnut Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.980311,-118.209874,0,'2013-07-06 12:44:34',NULL,NULL),(79782,'99344','S','Othello','D','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.819036,-119.168555,0,'2013-07-06 12:44:34',NULL,NULL),(35385,'39455','S','Talowah','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(32609,'36134','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.377274,-86.308425,0,'2013-07-06 12:44:32',NULL,NULL),(16503,'17263','P','State Line','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.722985,-77.719158,0,'2013-07-06 12:44:31',NULL,NULL),(60787,'72025','S','Divide','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.030179,-93.036863,0,'2013-07-06 12:44:33',NULL,NULL),(60378,'71485','S','Woodworth','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.160578,-92.499928,0,'2013-07-06 12:44:33',NULL,NULL),(41364,'46794','S','Brimfld','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(131,'00613','P','Arecibo','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.472737,-66.719283,0,'2013-07-06 12:44:30',NULL,NULL),(8887,'08723','S','Osbornville','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.051680,-74.106780,0,'2013-07-06 12:44:30',NULL,NULL),(18938,'19506','S','North Heidelberg','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.448100,-76.133040,0,'2013-07-06 12:44:31',NULL,NULL),(27524,'30215','S','Fayetteville','D','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.383599,-84.445716,0,'2013-07-06 12:44:31',NULL,NULL),(22276,'23705','P','Portsmouth','D','Portsmouth City','51740','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.838463,-76.340010,0,'2013-07-06 12:44:31',NULL,NULL),(22114,'23431','P','Smithfield','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.983696,-76.616759,0,'2013-07-06 12:44:31',NULL,NULL),(1765,'00780','S','Ponce','A','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(3158,'01263','U','Stockbridge','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.289010,-73.319529,0,'2013-07-06 12:44:30',NULL,NULL),(10535,'10989','S','Vly Cottage','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.123270,-73.942049,0,'2013-07-06 12:44:30',NULL,NULL),(61710,'73007','S','Arcadia','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.681792,-97.330576,0,'2013-07-06 12:44:33',NULL,NULL),(68550,'81427','P','Red Mountain','N','Ouray','08091','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.058846,-107.701590,0,'2013-07-06 12:44:34',NULL,NULL),(72950,'90040','S','Commerce','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.976980,-118.128840,0,'2013-07-06 12:44:34',NULL,NULL),(31975,'35216','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(1599,'00769','S','Urb El Bosque','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(936,'00715','S','Brisas de Maravilla','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(45321,'50851','S','Kent','A','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.882080,-94.560958,0,'2013-07-06 12:44:32',NULL,NULL),(57296,'66620','U','Ks State Bd of Health','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.946624,-95.715745,0,'2013-07-06 12:44:33',NULL,NULL),(75242,'93652','S','Raisin City','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.609193,-119.872470,0,'2013-07-06 12:44:34',NULL,NULL),(79712,'99212','S','Millwood','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(69770,'84057','S','Bunker','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.315140,-111.695870,0,'2013-07-06 12:44:34',NULL,NULL),(44818,'50242','S','Searsboro','D','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.555425,-92.697855,0,'2013-07-06 12:44:32',NULL,NULL),(23700,'25868','S','Lookout','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.052741,-80.896905,0,'2013-07-06 12:44:31',NULL,NULL),(38401,'43529','P','Hoytville','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.190741,-83.785403,0,'2013-07-06 12:44:32',NULL,NULL),(37522,'42045','S','Iuka','A','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.075980,-88.259940,0,'2013-07-06 12:44:32',NULL,NULL),(56607,'65565','S','Courtois','A','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.968536,-91.358000,0,'2013-07-06 12:44:33',NULL,NULL),(50021,'57401','S','Beebe','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.464854,-98.492300,0,'2013-07-06 12:44:33',NULL,NULL),(41146,'46699','U','South Bend Brm','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.671706,-86.252194,0,'2013-07-06 12:44:32',NULL,NULL),(20807,'21561','S','Swanton','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.496269,-79.261292,0,'2013-07-06 12:44:31',NULL,NULL),(38509,'43716','S','Beallsville','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.863880,-81.002760,0,'2013-07-06 12:44:32',NULL,NULL),(33772,'37868','P','Pigeon Forge','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.775608,-83.537836,0,'2013-07-06 12:44:32',NULL,NULL),(2287,'00926','S','Villa Olga','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(11541,'12047','S','Cohoes','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.774939,-73.715732,0,'2013-07-06 12:44:30',NULL,NULL),(63857,'75979','S','Dies','N','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.754889,-94.393444,0,'2013-07-06 12:44:34',NULL,NULL),(67506,'80236','S','Ft Logan','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.655391,-105.022433,0,'2013-07-06 12:44:34',NULL,NULL),(76147,'95297','U','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.970844,-121.307880,0,'2013-07-06 12:44:34',NULL,NULL),(24131,'26554','S','White Hall','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(23728,'25913','S','Ravencliff','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.701741,-81.478915,0,'2013-07-06 12:44:31',NULL,NULL),(14263,'14841','S','Valois','A','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.498593,-76.873441,0,'2013-07-06 12:44:31',NULL,NULL),(73080,'90211','S','Beverly Hills','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.062232,-118.381514,0,'2013-07-06 12:44:34',NULL,NULL),(61675,'72930','S','Cecil','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.434165,-93.944880,0,'2013-07-06 12:44:33',NULL,NULL),(33708,'37769','S','Lake City','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.215045,-84.153561,0,'2013-07-06 12:44:32',NULL,NULL),(77858,'97229','S','Rock Creek','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.540884,-122.829980,0,'2013-07-06 12:44:34',NULL,NULL),(2492,'00956','S','Villa Contessa','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(11649,'12130','S','Niverville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.442797,-73.657282,0,'2013-07-06 12:44:30',NULL,NULL),(36843,'41075','S','Ft Thomas','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.091389,-84.495833,0,'2013-07-06 12:44:32',NULL,NULL),(36343,'40409','S','Brodhead','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.367616,-84.437246,0,'2013-07-06 12:44:32',NULL,NULL),(31685,'34778','P','Wintergarden','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.497294,-81.615976,0,'2013-07-06 12:44:32',NULL,NULL),(54761,'62987','S','Dykersburg','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.637140,-88.740772,0,'2013-07-06 12:44:33',NULL,NULL),(54800,'63016','S','Labarque Crk','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.352981,-90.644798,0,'2013-07-06 12:44:33',NULL,NULL),(27960,'30549','S','Jefferson','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.112889,-83.580000,0,'2013-07-06 12:44:31',NULL,NULL),(7349,'06724','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.559608,-73.041406,0,'2013-07-06 12:44:30',NULL,NULL),(52346,'60602','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881490,-87.624392,0,'2013-07-06 12:44:33',NULL,NULL),(53444,'61877','S','Sidney','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.023964,-88.069269,0,'2013-07-06 12:44:33',NULL,NULL),(56629,'65603','S','Arcola','D','Dade','29057','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.533701,-93.862321,0,'2013-07-06 12:44:33',NULL,NULL),(60203,'71419','S','Benson','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(60859,'72051','S','Mozart','N','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.762178,-92.304721,0,'2013-07-06 12:44:33',NULL,NULL),(64581,'76667','S','Point Enterprise','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(66284,'78582','S','Rio Grande','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(62407,'74120','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.150477,-95.975853,0,'2013-07-06 12:44:33',NULL,NULL),(15959,'17025','S','West Fairview','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.289593,-76.959427,0,'2013-07-06 12:44:31',NULL,NULL),(50219,'57580','S','Weaver','N','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(48995,'56237','S','Echo','D','Yellow Medicine','27173','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.617955,-95.413718,0,'2013-07-06 12:44:33',NULL,NULL),(72731,'89506','S','Bordertown','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(70602,'85118','S','Apache Jct','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(33562,'37411','S','Ridgeside','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.025075,-85.237257,0,'2013-07-06 12:44:32',NULL,NULL),(39546,'44839','S','Shinrock','A','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388818,-82.561774,0,'2013-07-06 12:44:32',NULL,NULL),(42363,'47706','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.956930,-87.558672,0,'2013-07-06 12:44:32',NULL,NULL),(41439,'46862','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.068970,-85.167855,0,'2013-07-06 12:44:32',NULL,NULL),(19615,'20238','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904151,-77.045347,0,'2013-07-06 12:44:31',NULL,NULL),(6050,'05441','S','Bakersfield','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.932075,-73.094031,0,'2013-07-06 12:44:30',NULL,NULL),(36458,'40729','S','E Bernstadt','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.204331,-84.118241,0,'2013-07-06 12:44:32',NULL,NULL),(44534,'49965','S','Toivola','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.939867,-88.853406,0,'2013-07-06 12:44:32',NULL,NULL),(54488,'62863','S','Mt Carmell','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(75827,'94904','S','Kent Woodlands','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.951140,-122.539560,0,'2013-07-06 12:44:34',NULL,NULL),(991,'00717','S','Bda Santa Rosa','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(28756,'32004','P','Ponte Vedra','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.241583,-81.383434,0,'2013-07-06 12:44:32',NULL,NULL),(32265,'35631','P','Florence','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.810558,-87.653253,0,'2013-07-06 12:44:32',NULL,NULL),(4829,'03911','P','York Harbor','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.135724,-70.637154,0,'2013-07-06 12:44:30',NULL,NULL),(32435,'35989','S','Hammondville','A','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.504625,-85.681555,0,'2013-07-06 12:44:32',NULL,NULL),(40103,'45312','S','Casstown','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.059044,-84.089349,0,'2013-07-06 12:44:32',NULL,NULL),(70377,'84660','S','Cover Bridge Canyon','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(73113,'90254','S','Hermosa Beach','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.867406,-118.397481,0,'2013-07-06 12:44:34',NULL,NULL),(77839,'97220','S','Parkrose','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.543396,-122.553975,0,'2013-07-06 12:44:34',NULL,NULL),(70181,'84330','P','Plymouth','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.909014,-112.157140,0,'2013-07-06 12:44:34',NULL,NULL),(4739,'03835','S','Farmington','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.385946,-71.061069,0,'2013-07-06 12:44:30',NULL,NULL),(4722,'03825','S','Barrington','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.210850,-71.028547,0,'2013-07-06 12:44:30',NULL,NULL),(30100,'33158','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(3679,'02128','S','East Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.383079,-71.018049,0,'2013-07-06 12:44:30',NULL,NULL),(28231,'31042','S','Irwinton','D','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.809157,-83.173220,0,'2013-07-06 12:44:31',NULL,NULL),(5979,'05345','S','Brookline','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.983232,-72.656479,0,'2013-07-06 12:44:30',NULL,NULL),(9945,'10155','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760757,-73.965739,0,'2013-07-06 12:44:30',NULL,NULL),(11712,'12170','S','Bemis Heights','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.933960,-73.690380,0,'2013-07-06 12:44:30',NULL,NULL),(44196,'49619','S','Brethren','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.307001,-86.024596,0,'2013-07-06 12:44:32',NULL,NULL),(61500,'72645','S','Rumley','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.826780,-92.575020,0,'2013-07-06 12:44:33',NULL,NULL),(69859,'84092','S','Belmont Heights','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(71281,'86435','P','Supai','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.114214,-112.523252,0,'2013-07-06 12:44:34',NULL,NULL),(72705,'89448','P','Pinewild','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(62319,'74039','S','Kellyville','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.947865,-96.210406,0,'2013-07-06 12:44:33',NULL,NULL),(60610,'71857','S','Laneburg','A','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.802675,-93.377033,0,'2013-07-06 12:44:33',NULL,NULL),(57146,'66250','U','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955067,-94.786621,0,'2013-07-06 12:44:33',NULL,NULL),(30048,'33144','S','West Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.763251,-80.313357,0,'2013-07-06 12:44:32',NULL,NULL),(24354,'27043','S','Pinnacle','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.255873,-80.442780,0,'2013-07-06 12:44:31',NULL,NULL),(34836,'38920','S','Rosebloom','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(54289,'62703','S','Southern View','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.772322,-89.632328,0,'2013-07-06 12:44:33',NULL,NULL),(14255,'14831','U','Corning','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.147148,-77.056466,0,'2013-07-06 12:44:31',NULL,NULL),(69433,'83641','S','Givens Hot Springs','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.380775,-116.549761,0,'2013-07-06 12:44:34',NULL,NULL),(72072,'88125','S','Milnesand','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.631904,-103.286259,0,'2013-07-06 12:44:34',NULL,NULL),(63274,'75507','U','Red River Army Depot','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.354678,-94.219325,0,'2013-07-06 12:44:33',NULL,NULL),(30651,'33460','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.613877,-80.054114,0,'2013-07-06 12:44:32',NULL,NULL),(50837,'58479','S','Leal','A','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.054040,-98.211954,0,'2013-07-06 12:44:33',NULL,NULL),(51658,'59903','P','Kalispell','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.193033,-114.357878,0,'2013-07-06 12:44:33',NULL,NULL),(63180,'75412','S','Bagwell','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.829427,-95.149043,0,'2013-07-06 12:44:33',NULL,NULL),(63345,'75605','S','Longview','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.556050,-94.782395,0,'2013-07-06 12:44:33',NULL,NULL),(67487,'80230','S','Montclair','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.730904,-104.903794,0,'2013-07-06 12:44:34',NULL,NULL),(72702,'89448','P','Kingsbury','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(3739,'02163','S','Soldiers Field','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.369472,-71.124373,0,'2013-07-06 12:44:30',NULL,NULL),(65742,'78056','S','Mico','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.579640,-98.874960,0,'2013-07-06 12:44:34',NULL,NULL),(11581,'12073','P','Gallupville','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.662066,-74.229925,0,'2013-07-06 12:44:30',NULL,NULL),(21523,'22727','S','Aroda','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(24073,'26440','S','Thornton','D','Taylor','54091','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.330967,-79.906322,0,'2013-07-06 12:44:31',NULL,NULL),(70142,'84306','S','Wheelon','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.787743,-112.072730,0,'2013-07-06 12:44:34',NULL,NULL),(70249,'84414','S','Harrisville','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.315661,-111.978351,0,'2013-07-06 12:44:34',NULL,NULL),(70324,'84624','S','Sutherland','A','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(45017,'50459','S','Northwood','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.444547,-93.217706,0,'2013-07-06 12:44:32',NULL,NULL),(38855,'44094','S','Willoughby Hills','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(39002,'44137','S','Maple Heights','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.409495,-81.558216,0,'2013-07-06 12:44:32',NULL,NULL),(12516,'13028','S','Bernhards Bay','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.264959,-75.989179,0,'2013-07-06 12:44:30',NULL,NULL),(22379,'23936','S','Andersonville','N','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.520399,-78.476570,0,'2013-07-06 12:44:31',NULL,NULL),(31403,'34230','P','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.353613,-82.486627,0,'2013-07-06 12:44:32',NULL,NULL),(28395,'31313','S','Hinesville','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.843745,-81.603148,0,'2013-07-06 12:44:32',NULL,NULL),(47285,'54542','S','Long Lake','D','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.840000,-88.660000,0,'2013-07-06 12:44:32',NULL,NULL),(52685,'61085','S','Woodbine','N','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.330540,-90.049740,0,'2013-07-06 12:44:33',NULL,NULL),(66703,'78946','S','Post Oak','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.231900,-96.775620,0,'2013-07-06 12:44:34',NULL,NULL),(890,'00704','S','Sect Lanausse','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(12817,'13302','S','Pine Meadows','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(53382,'61799','U','Internal Revenue Service','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.428470,-88.986910,0,'2013-07-06 12:44:33',NULL,NULL),(6135,'05462','S','Huntingtn Ctr','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.310720,-73.003500,0,'2013-07-06 12:44:30',NULL,NULL),(14968,'15629','P','E Vandergrift','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.598731,-79.564877,0,'2013-07-06 12:44:31',NULL,NULL),(2182,'00926','S','Jard de Caldas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(53487,'61955','P','Vermilion','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.581259,-87.587427,0,'2013-07-06 12:44:33',NULL,NULL),(21080,'22030','S','Fairfax','D','Fairfax City','51600','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.832588,-77.338916,0,'2013-07-06 12:44:31',NULL,NULL),(49025,'56271','S','Murdock','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.224810,-95.391809,0,'2013-07-06 12:44:33',NULL,NULL),(18554,'19118','S','Springfield','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.086847,-75.197968,0,'2013-07-06 12:44:31',NULL,NULL),(38881,'44107','S','Edgewater','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.482343,-81.794563,0,'2013-07-06 12:44:32',NULL,NULL),(13736,'14105','S','Shelby','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.209014,-78.492391,0,'2013-07-06 12:44:31',NULL,NULL),(4278,'02891','S','Westerly','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.362200,-71.796000,0,'2013-07-06 12:44:30',NULL,NULL),(9836,'10115','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(11480,'12019','S','Charlton','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.921720,-73.890600,0,'2013-07-06 12:44:30',NULL,NULL),(60342,'71467','S','Antonia','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498140,-92.421420,0,'2013-07-06 12:44:33',NULL,NULL),(65088,'77355','S','Magnolia','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.151734,-95.743252,0,'2013-07-06 12:44:34',NULL,NULL),(67122,'79742','P','Royalty','N','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.374995,-102.887887,0,'2013-07-06 12:44:34',NULL,NULL),(68175,'81011','U','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.276026,-104.610181,0,'2013-07-06 12:44:34',NULL,NULL),(69579,'83835','S','Hayden Lake','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.790660,-116.764380,0,'2013-07-06 12:44:34',NULL,NULL),(76339,'95468','S','Point Arena Air Force Statio','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.895072,-123.653344,0,'2013-07-06 12:44:34',NULL,NULL),(78136,'97534','S','O Brien','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.043860,-123.717060,0,'2013-07-06 12:44:34',NULL,NULL),(1362,'00736','S','Urb El Remanso','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(27075,'29697','S','Williamston','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.618937,-82.496462,0,'2013-07-06 12:44:31',NULL,NULL),(49758,'57066','S','Kingsbury','N','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.989816,-97.860137,0,'2013-07-06 12:44:33',NULL,NULL),(70441,'84741','S','Glen Canyon','N','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.051804,-112.533746,0,'2013-07-06 12:44:34',NULL,NULL),(28470,'31501','S','Okefenokee','N','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.223540,-82.355739,0,'2013-07-06 12:44:32',NULL,NULL),(18129,'18823','S','Harford','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.778578,-75.678338,0,'2013-07-06 12:44:31',NULL,NULL),(9862,'10120','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(2959,'01038','S','Hatfield','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.381499,-72.607454,0,'2013-07-06 12:44:30',NULL,NULL),(78761,'98303','S','Yoman Ferry','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164386,-122.695768,0,'2013-07-06 12:44:34',NULL,NULL),(1998,'00910','P','Fdez Juncos','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.442966,-66.071521,0,'2013-07-06 12:44:30',NULL,NULL),(40317,'45469','U','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.721166,-84.190652,0,'2013-07-06 12:44:32',NULL,NULL),(24691,'27419','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.979131,-79.708835,0,'2013-07-06 12:44:31',NULL,NULL),(2052,'00920','S','Caparra Hills','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(41639,'47133','U','Bureau of the Census','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287708,-85.736180,0,'2013-07-06 12:44:32',NULL,NULL),(16659,'17352','S','Gatchellville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.751920,-76.495680,0,'2013-07-06 12:44:31',NULL,NULL),(1838,'00784','S','Urb Vistamar 3','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(25631,'28465','S','Fort Caswell','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(25182,'28052','S','Smyre','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(21278,'22315','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.784480,-77.125200,0,'2013-07-06 12:44:31',NULL,NULL),(44545,'50003','S','Adel','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.614486,-94.020176,0,'2013-07-06 12:44:32',NULL,NULL),(44815,'50240','S','Saint Charles','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.300602,-93.744062,0,'2013-07-06 12:44:32',NULL,NULL),(69810,'84071','S','Ophir','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.449676,-112.359074,0,'2013-07-06 12:44:34',NULL,NULL),(78051,'97449','S','Lakeside','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.581867,-124.159058,0,'2013-07-06 12:44:34',NULL,NULL),(49443,'56636','S','Zemple','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(47730,'55009','S','White Rock','N','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.507743,-92.905112,0,'2013-07-06 12:44:33',NULL,NULL),(1366,'00736','S','Urb La Planicie','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(32306,'35751','S','Hollytree','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.814839,-86.274440,0,'2013-07-06 12:44:32',NULL,NULL),(4054,'02641','P','East Dennis','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.740504,-70.158592,0,'2013-07-06 12:44:30',NULL,NULL),(15875,'16950','S','Westfield','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(77709,'97053','S','Warren','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.823043,-122.883264,0,'2013-07-06 12:44:34',NULL,NULL),(63324,'75571','S','Omaha','D','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.180927,-94.741576,0,'2013-07-06 12:44:33',NULL,NULL),(8968,'08816','S','East Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.429733,-74.407288,0,'2013-07-06 12:44:30',NULL,NULL),(17213,'17824','S','Bear Gap','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(42807,'48051','S','New Baltimore','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.688473,-82.809772,0,'2013-07-06 12:44:32',NULL,NULL),(12682,'13131','S','Colosse','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.423380,-76.078500,0,'2013-07-06 12:44:30',NULL,NULL),(6409,'05738','S','Cuttingsville','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.531020,-72.864480,0,'2013-07-06 12:44:30',NULL,NULL),(22243,'23662','S','Hampton','A','Poquoson City','51735','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.133100,-76.365900,0,'2013-07-06 12:44:31',NULL,NULL),(46865,'54027','S','Wilson','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.956333,-92.173468,0,'2013-07-06 12:44:32',NULL,NULL),(67013,'79521','S','Haskell','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.159597,-99.735874,0,'2013-07-06 12:44:34',NULL,NULL),(75610,'94403','S','San Mateo','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.539820,-122.303572,0,'2013-07-06 12:44:34',NULL,NULL),(3815,'02297','U','Cash Management','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358631,-71.056702,0,'2013-07-06 12:44:30',NULL,NULL),(41976,'47421','S','Englewood','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(57064,'66213','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.902439,-94.703976,0,'2013-07-06 12:44:33',NULL,NULL),(22330,'23866','S','Ivor','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.911869,-76.878981,0,'2013-07-06 12:44:31',NULL,NULL),(6773,'06098','S','Winsted','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.921164,-73.067666,0,'2013-07-06 12:44:30',NULL,NULL),(56528,'65402','P','Rolla','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.941764,-91.772150,0,'2013-07-06 12:44:33',NULL,NULL),(18759,'19350','S','Landenberg','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.758082,-75.790460,0,'2013-07-06 12:44:31',NULL,NULL),(2323,'00931','P','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409826,-66.062956,0,'2013-07-06 12:44:30',NULL,NULL),(4316,'02912','U','Brown Station','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.824987,-71.400763,0,'2013-07-06 12:44:30',NULL,NULL),(12721,'13155','S','South Otselic','D','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.665692,-75.760212,0,'2013-07-06 12:44:30',NULL,NULL),(78261,'97844','S','Irrigon','D','Morrow','41049','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.899530,-119.498387,0,'2013-07-06 12:44:34',NULL,NULL),(41909,'47374','S','Middleboro','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(40645,'46036','S','Leisure','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(6088,'05450','S','Herrick','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(28093,'30742','S','Ft Oglethorpe','A','Catoosa','13047','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.954118,-85.250532,0,'2013-07-06 12:44:31',NULL,NULL),(23220,'25082','S','Fraziers Btm','A','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.568197,-82.025774,0,'2013-07-06 12:44:31',NULL,NULL),(45821,'52206','S','Atkins','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.005960,-91.871945,0,'2013-07-06 12:44:32',NULL,NULL),(57474,'66866','S','Peabody','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.170926,-97.109433,0,'2013-07-06 12:44:33',NULL,NULL),(67986,'80917','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.887640,-104.738816,0,'2013-07-06 12:44:34',NULL,NULL),(70607,'85118','S','Superstition Mtn','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(54371,'62808','S','Bolo','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.328964,-89.188569,0,'2013-07-06 12:44:33',NULL,NULL),(9086,'09038','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(14830,'15430','P','Dickerson Run','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.030051,-79.663331,0,'2013-07-06 12:44:31',NULL,NULL),(4826,'03908','S','South Berwick','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.230935,-70.783559,0,'2013-07-06 12:44:30',NULL,NULL),(1102,'00725','S','Urb Myrlena','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(11663,'12138','S','Petersburgh','A','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.737100,-73.362660,0,'2013-07-06 12:44:30',NULL,NULL),(54777,'62997','P','Willisville','D','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.983109,-89.558480,0,'2013-07-06 12:44:33',NULL,NULL),(47618,'54901','S','Oshkosh','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.017138,-88.538364,0,'2013-07-06 12:44:33',NULL,NULL),(18446,'19070','S','Ridley','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.908428,-75.323818,0,'2013-07-06 12:44:31',NULL,NULL),(37635,'42164','S','Gainesville','N','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.782160,-86.190120,0,'2013-07-06 12:44:32',NULL,NULL),(32719,'36304','P','Dothan','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.233884,-85.403767,0,'2013-07-06 12:44:32',NULL,NULL),(30731,'33534','S','Gibsonton','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.829591,-82.368604,0,'2013-07-06 12:44:32',NULL,NULL),(24284,'27006','S','Advance','D','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(43899,'49245','S','Homer','D','Calhoun','26025','Michigan','MI','26','3720','517','Eastern',-5.0,'Y',42.150968,-84.811795,0,'2013-07-06 12:44:32',NULL,NULL),(49523,'56673','S','Roosevelt','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.779677,-95.251697,0,'2013-07-06 12:44:33',NULL,NULL),(75913,'95004','S','Aromas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.878180,-121.624400,0,'2013-07-06 12:44:34',NULL,NULL),(77809,'97141','S','Tillamook','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.466380,-123.716940,0,'2013-07-06 12:44:34',NULL,NULL),(9038,'08879','S','Laurence Harbor','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.463991,-74.275843,0,'2013-07-06 12:44:30',NULL,NULL),(19393,'20069','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880445,-77.230119,0,'2013-07-06 12:44:31',NULL,NULL),(40411,'45683','P','Stockdale','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.952953,-82.862523,0,'2013-07-06 12:44:32',NULL,NULL),(46024,'52549','S','Livingston','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.634270,-92.923794,0,'2013-07-06 12:44:32',NULL,NULL),(68837,'82520','S','S Pass City','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(79542,'98951','S','Donald','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.456917,-120.410065,0,'2013-07-06 12:44:34',NULL,NULL),(71687,'87515','P','Canjilon','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.670076,-106.553112,0,'2013-07-06 12:44:34',NULL,NULL),(69252,'83423','S','Small','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(29610,'32853','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.557246,-81.349131,0,'2013-07-06 12:44:32',NULL,NULL),(46425,'53189','S','Waukesha','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.013819,-88.228571,0,'2013-07-06 12:44:32',NULL,NULL),(43371,'48416','S','Brown City','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.225819,-82.945905,0,'2013-07-06 12:44:32',NULL,NULL),(18153,'18846','S','Sugar Run','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.593223,-76.268573,0,'2013-07-06 12:44:31',NULL,NULL),(22601,'24203','P','Bristol','D','Bristol City','51520','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.597166,-82.188623,0,'2013-07-06 12:44:31',NULL,NULL),(14711,'15268','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.486226,-79.735977,0,'2013-07-06 12:44:31',NULL,NULL),(57828,'67530','S','Great Bend','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.368828,-98.776747,0,'2013-07-06 12:44:33',NULL,NULL),(71741,'87538','S','Ilfeld','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.420980,-105.561446,0,'2013-07-06 12:44:34',NULL,NULL),(74047,'92149','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.676375,-117.065268,0,'2013-07-06 12:44:34',NULL,NULL),(1734,'00778','S','Urb Gran Vista Ii','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(63553,'75766','S','Enterprise','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:33',NULL,NULL),(55773,'64117','S','Avondale','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.154167,-94.546667,0,'2013-07-06 12:44:33',NULL,NULL),(36034,'40176','S','Webster','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.929066,-86.394425,0,'2013-07-06 12:44:32',NULL,NULL),(68852,'82609','S','Bar Nunn','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.846450,-106.274603,0,'2013-07-06 12:44:34',NULL,NULL),(76325,'95460','S','Mendocino','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.319440,-123.789058,0,'2013-07-06 12:44:34',NULL,NULL),(78794,'98321','S','Buckley','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.157444,-122.073282,0,'2013-07-06 12:44:34',NULL,NULL),(40222,'45412','U','National City Bank','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.760813,-84.193399,0,'2013-07-06 12:44:32',NULL,NULL),(55076,'63180','U','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.632421,-90.202951,0,'2013-07-06 12:44:33',NULL,NULL),(73769,'91737','S','Alta Loma','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.146529,-117.573112,0,'2013-07-06 12:44:34',NULL,NULL),(75174,'93603','S','Badger','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.588008,-119.015000,0,'2013-07-06 12:44:34',NULL,NULL),(13720,'14085','S','Lake View','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.719062,-78.934684,0,'2013-07-06 12:44:31',NULL,NULL),(34926,'38965','S','Water Valley','D','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.153955,-89.632766,0,'2013-07-06 12:44:32',NULL,NULL),(33424,'37243','U','Nashvle','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162894,-86.785734,0,'2013-07-06 12:44:32',NULL,NULL),(55944,'64482','S','Rock Port','D','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.411278,-95.516834,0,'2013-07-06 12:44:33',NULL,NULL),(56328,'65107','U','Div of Income Tax Due','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.578678,-92.173699,0,'2013-07-06 12:44:33',NULL,NULL),(59919,'71291','S','Cheniere','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(62273,'74014','S','Broken Arrow','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.054889,-95.716187,0,'2013-07-06 12:44:33',NULL,NULL),(68621,'81625','S','Craig','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.548784,-107.564262,0,'2013-07-06 12:44:34',NULL,NULL),(75462,'94085','S','Sunnyvale','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.366300,-122.033959,0,'2013-07-06 12:44:34',NULL,NULL),(77432,'96805','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305636,-157.856474,0,'2013-07-06 12:44:34',NULL,NULL),(288,'00646','S','Paseo Los Corales','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(63379,'75644','S','Grice','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(56481,'65326','S','Edwards','D','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.167610,-93.149233,0,'2013-07-06 12:44:33',NULL,NULL),(32502,'36067','S','Pville','N','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.487639,-86.508013,0,'2013-07-06 12:44:32',NULL,NULL),(74157,'92261','P','Palm Desert','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.617682,-116.430261,0,'2013-07-06 12:44:34',NULL,NULL),(77225,'96501','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79533,'98943','P','S Cle Elum','A','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.190225,-120.953413,0,'2013-07-06 12:44:34',NULL,NULL),(1333,'00736','S','Bo Beatriz','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(36498,'40816','S','Chappell','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.990603,-83.389842,0,'2013-07-06 12:44:32',NULL,NULL),(28873,'32119','S','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.139694,-81.012938,0,'2013-07-06 12:44:32',NULL,NULL),(4955,'04104','P','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.660577,-70.262378,0,'2013-07-06 12:44:30',NULL,NULL),(4725,'03827','S','E Kingston','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.911422,-70.983388,0,'2013-07-06 12:44:30',NULL,NULL),(37997,'42755','P','Leitchfield','D','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.478430,-86.291409,0,'2013-07-06 12:44:32',NULL,NULL),(79725,'99214','P','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.711392,-117.206773,0,'2013-07-06 12:44:34',NULL,NULL),(25369,'28246','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.225415,-80.845276,0,'2013-07-06 12:44:31',NULL,NULL),(67654,'80476','P','Silver Plume','D','Clear Creek','08019','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.694255,-105.735040,0,'2013-07-06 12:44:34',NULL,NULL),(53923,'62401','S','Douglas','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(34203,'38343','S','Humboldt','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.837590,-88.911952,0,'2013-07-06 12:44:32',NULL,NULL),(70373,'84655','S','Santaquin','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.056240,-111.754620,0,'2013-07-06 12:44:34',NULL,NULL),(35091,'39205','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.304324,-90.182529,0,'2013-07-06 12:44:32',NULL,NULL),(46612,'53570','S','Monticello','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.747446,-89.592433,0,'2013-07-06 12:44:32',NULL,NULL),(22129,'23441','P','Tasley','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.720070,-75.776007,0,'2013-07-06 12:44:31',NULL,NULL),(1498,'00751','S','Urb La Carmen','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(18310,'19019','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.117600,-75.014510,0,'2013-07-06 12:44:31',NULL,NULL),(30975,'33742','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.844686,-82.643445,0,'2013-07-06 12:44:32',NULL,NULL),(44535,'49967','S','Kenton','A','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.476821,-89.007955,0,'2013-07-06 12:44:32',NULL,NULL),(61771,'73061','S','Morrison','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.295834,-97.006773,0,'2013-07-06 12:44:33',NULL,NULL),(12232,'12816','S','Cambridge','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.040880,-73.380600,0,'2013-07-06 12:44:30',NULL,NULL),(69733,'84043','S','Lehi','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(28902,'32133','P','Eastlake Weir','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.022775,-81.907945,0,'2013-07-06 12:44:32',NULL,NULL),(50598,'58244','S','Orr','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.116880,-97.723380,0,'2013-07-06 12:44:33',NULL,NULL),(39497,'44804','S','Arcadia','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.108804,-83.523527,0,'2013-07-06 12:44:32',NULL,NULL),(73055,'90090','U','Los Angeles','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.013223,-118.138227,0,'2013-07-06 12:44:34',NULL,NULL),(75451,'94065','S','Redwood City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.533470,-122.250368,0,'2013-07-06 12:44:34',NULL,NULL),(79545,'98952','S','White Swan','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.372793,-120.701230,0,'2013-07-06 12:44:34',NULL,NULL),(26772,'29440','S','Maryville','N','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.526980,-79.298460,0,'2013-07-06 12:44:31',NULL,NULL),(26148,'28740','S','Green Mountain','D','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(5252,'04479','S','Sangerville','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.130069,-69.309215,0,'2013-07-06 12:44:30',NULL,NULL),(5856,'05143','S','Athens','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(75318,'93764','U','Fresno City Utilities','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.734126,-119.784633,0,'2013-07-06 12:44:34',NULL,NULL),(6157,'05471','S','Hutchins','N','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.860467,-72.593608,0,'2013-07-06 12:44:30',NULL,NULL),(6856,'06129','P','Weathersfield','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.708586,-72.659766,0,'2013-07-06 12:44:30',NULL,NULL),(50392,'57769','S','Grashul','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.229112,-103.390064,0,'2013-07-06 12:44:33',NULL,NULL),(1832,'00784','S','Urb Green Hls','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(38452,'43606','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.672103,-83.602649,0,'2013-07-06 12:44:32',NULL,NULL),(16824,'17551','S','Slackwater','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.000624,-76.358814,0,'2013-07-06 12:44:31',NULL,NULL),(28511,'31535','S','Douglas','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.507807,-82.849284,0,'2013-07-06 12:44:32',NULL,NULL),(34798,'38874','P','Toccopola','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.304862,-89.158498,0,'2013-07-06 12:44:32',NULL,NULL),(48126,'55358','S','Silver Creek','A','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.233674,-94.004626,0,'2013-07-06 12:44:33',NULL,NULL),(9648,'10037','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814876,-73.938236,0,'2013-07-06 12:44:30',NULL,NULL),(77022,'96095','P','Whiskeytown','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.711597,-122.601782,0,'2013-07-06 12:44:34',NULL,NULL),(1928,'00795','S','Urb Jacaguax','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(34864,'38930','S','G Wood','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.504180,-90.161880,0,'2013-07-06 12:44:32',NULL,NULL),(38674,'43953','S','Wintersville','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.376875,-80.700762,0,'2013-07-06 12:44:32',NULL,NULL),(41946,'47394','S','Stone','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.175183,-84.976721,0,'2013-07-06 12:44:32',NULL,NULL),(45191,'50614','U','Cedar Falls','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.509279,-92.460752,0,'2013-07-06 12:44:32',NULL,NULL),(79262,'98566','P','Neilton','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.413543,-123.880697,0,'2013-07-06 12:44:34',NULL,NULL),(6727,'06074','S','Bissell','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.834880,-72.571320,0,'2013-07-06 12:44:30',NULL,NULL),(69152,'83314','S','Tuttle','N','Gooding','16047','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.946860,-114.934200,0,'2013-07-06 12:44:34',NULL,NULL),(24872,'27690','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.834281,-78.666486,0,'2013-07-06 12:44:31',NULL,NULL),(69118,'83276','S','Soda Springs','D','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.702141,-111.569814,0,'2013-07-06 12:44:34',NULL,NULL),(65796,'78125','P','Mineral','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.550320,-97.903107,0,'2013-07-06 12:44:34',NULL,NULL),(22258,'23681','U','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.088709,-76.366965,0,'2013-07-06 12:44:31',NULL,NULL),(14568,'15216','S','Beechview','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(46343,'53092','S','Mequon','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.221480,-87.950520,0,'2013-07-06 12:44:32',NULL,NULL),(68593,'81601','S','Cardiff','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.528426,-107.338503,0,'2013-07-06 12:44:34',NULL,NULL),(35195,'39286','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.350653,-90.176499,0,'2013-07-06 12:44:32',NULL,NULL),(72632,'89419','S','Upper Valley','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(79383,'98674','S','Woodland','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',45.926972,-122.715769,0,'2013-07-06 12:44:34',NULL,NULL),(16348,'17140','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259652,-76.807717,0,'2013-07-06 12:44:31',NULL,NULL),(18251,'19001','S','Roslyn','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.123936,-75.131093,0,'2013-07-06 12:44:31',NULL,NULL),(54246,'62670','S','Bates','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.734757,-89.908806,0,'2013-07-06 12:44:33',NULL,NULL),(67985,'80917','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.887640,-104.738816,0,'2013-07-06 12:44:34',NULL,NULL),(58336,'68460','S','Waco','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.925505,-97.443237,0,'2013-07-06 12:44:33',NULL,NULL),(16594,'17324','S','Toland','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(50972,'58634','S','Rhoades','N','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.450197,-103.343816,0,'2013-07-06 12:44:33',NULL,NULL),(79396,'98801','S','Wenatchee','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(69660,'84015','S','Arsenal','N','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(316,'00646','S','Urb the Clusters','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(15293,'16133','S','Jackson Ctr','A','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.276916,-80.083724,0,'2013-07-06 12:44:31',NULL,NULL),(58722,'68940','S','Anderson','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.466264,-99.248065,0,'2013-07-06 12:44:33',NULL,NULL),(8089,'07760','S','Rumson','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.368572,-74.000172,0,'2013-07-06 12:44:30',NULL,NULL),(49994,'57369','S','Platte','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.405260,-98.888040,0,'2013-07-06 12:44:33',NULL,NULL),(30875,'33679','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.952793,-82.508216,0,'2013-07-06 12:44:32',NULL,NULL),(28921,'32158','P','Lady Lake','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.927270,-81.926955,0,'2013-07-06 12:44:32',NULL,NULL),(31364,'34207','S','Bayshore Gardens','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.437280,-82.576198,0,'2013-07-06 12:44:32',NULL,NULL),(31889,'35131','S','Ragland','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.758996,-86.205444,0,'2013-07-06 12:44:32',NULL,NULL),(57506,'66953','S','Linn','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.686371,-97.074530,0,'2013-07-06 12:44:33',NULL,NULL),(36449,'40621','U','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.200847,-84.872727,0,'2013-07-06 12:44:32',NULL,NULL),(41609,'47118','S','Sulphur','A','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.333768,-86.461871,0,'2013-07-06 12:44:32',NULL,NULL),(44123,'49508','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.873625,-85.625143,0,'2013-07-06 12:44:32',NULL,NULL),(56304,'65101','S','Cedar City','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(52895,'61353','S','Paw Paw','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.691444,-88.994013,0,'2013-07-06 12:44:33',NULL,NULL),(52062,'60208','U','Northwestern Univ Adminstrn','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.058010,-87.674825,0,'2013-07-06 12:44:33',NULL,NULL),(24936,'27818','S','Como','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.505558,-77.011770,0,'2013-07-06 12:44:31',NULL,NULL),(24178,'26623','S','Wilsie','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.630653,-80.876931,0,'2013-07-06 12:44:31',NULL,NULL),(66776,'79034','S','Follett','D','Lipscomb','48295','Texas','TX','48','0000','806','Central',-6.0,'Y',36.432488,-100.141057,0,'2013-07-06 12:44:34',NULL,NULL),(17857,'18431','S','Honesdale','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.569284,-75.257159,0,'2013-07-06 12:44:31',NULL,NULL),(59113,'70146','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.033612,-90.041438,0,'2013-07-06 12:44:33',NULL,NULL),(16054,'17046','S','Swatara Twp','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.357882,-76.432449,0,'2013-07-06 12:44:31',NULL,NULL),(31462,'34288','S','No Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.048529,-82.194897,0,'2013-07-06 12:44:32',NULL,NULL),(30969,'33740','P','Treasure Island','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770012,-82.766347,0,'2013-07-06 12:44:32',NULL,NULL),(40223,'45413','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.824011,-84.189799,0,'2013-07-06 12:44:32',NULL,NULL),(29354,'32565','S','Jay','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.916266,-87.147853,0,'2013-07-06 12:44:32',NULL,NULL),(30236,'33190','S','Perrine','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556771,-80.336864,0,'2013-07-06 12:44:32',NULL,NULL),(55752,'64109','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.063189,-94.569192,0,'2013-07-06 12:44:33',NULL,NULL),(1441,'00739','S','Urb Monte Primavera','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(19709,'20389','U','Naval Intelligence Com','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(2290,'00926','S','Villas de Parana','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(52562,'60956','P','Papineau','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.969356,-87.716292,0,'2013-07-06 12:44:33',NULL,NULL),(75371,'93928','P','Ft H Liggett','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.048776,-121.200408,0,'2013-07-06 12:44:34',NULL,NULL),(7094,'06355','S','Mystic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.358669,-71.979179,0,'2013-07-06 12:44:30',NULL,NULL),(45872,'52248','S','Clear Creek','N','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.363498,-91.954172,0,'2013-07-06 12:44:32',NULL,NULL),(75490,'94126','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.791853,-122.390378,0,'2013-07-06 12:44:34',NULL,NULL),(4956,'04105','S','Falmouth','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.743978,-70.281854,0,'2013-07-06 12:44:30',NULL,NULL),(60018,'71336','S','Kendricks Ferry','N','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.009880,-91.568530,0,'2013-07-06 12:44:33',NULL,NULL),(48021,'55188','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.919109,-92.941297,0,'2013-07-06 12:44:33',NULL,NULL),(27936,'30527','S','Clermont','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.475011,-83.789346,0,'2013-07-06 12:44:31',NULL,NULL),(39642,'44904','S','Steam Corners','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.677720,-82.614840,0,'2013-07-06 12:44:32',NULL,NULL),(76291,'95433','P','El Verano','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.299964,-122.489265,0,'2013-07-06 12:44:34',NULL,NULL),(53897,'62360','S','Payson','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.818387,-91.239589,0,'2013-07-06 12:44:33',NULL,NULL),(4085,'02664','S','S Yarmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.668281,-70.193806,0,'2013-07-06 12:44:30',NULL,NULL),(63881,'76012','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.756084,-97.135798,0,'2013-07-06 12:44:34',NULL,NULL),(20801,'21550','S','Mtin Lk Park','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(11030,'11566','S','N Merrick','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685085,-73.560710,0,'2013-07-06 12:44:30',NULL,NULL),(25542,'28405','S','New Hanover County Airport','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.281720,-77.824740,0,'2013-07-06 12:44:31',NULL,NULL),(3178,'01331','S','Royalston','N','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.588860,-72.224089,0,'2013-07-06 12:44:30',NULL,NULL),(3860,'02355','P','East Carver','N','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.917753,-70.797313,0,'2013-07-06 12:44:30',NULL,NULL),(18793,'19382','S','West Chester','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.942544,-75.597966,0,'2013-07-06 12:44:31',NULL,NULL),(8012,'07722','S','Vanderburg','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.309639,-74.182060,0,'2013-07-06 12:44:30',NULL,NULL),(61698,'72956','S','Van Buren','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.443498,-94.340220,0,'2013-07-06 12:44:33',NULL,NULL),(54848,'63040','S','Pond','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576576,-90.628174,0,'2013-07-06 12:44:33',NULL,NULL),(15109,'15776','S','Sprankle Mills','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.021239,-79.085612,0,'2013-07-06 12:44:31',NULL,NULL),(2566,'00959','S','Urb San Rafael Est Ii','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(41231,'46737','S','Ray','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.721900,-84.920220,0,'2013-07-06 12:44:32',NULL,NULL),(7021,'06260','S','Sawyer District','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(27773,'30369','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.803584,-84.471339,0,'2013-07-06 12:44:31',NULL,NULL),(550,'00677','S','Jard de Rincon','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(20968,'21788','S','Thurmont','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.600540,-77.429160,0,'2013-07-06 12:44:31',NULL,NULL),(17007,'17739','P','Pine Creek','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.408022,-77.457577,0,'2013-07-06 12:44:31',NULL,NULL),(63080,'75244','S','North Branch','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.939490,-96.838730,0,'2013-07-06 12:44:33',NULL,NULL),(30775,'33579','S','Riverview','D','Hillsborough','12057','Florida','FL','12','8280','352','Eastern',-5.0,'Y',27.813553,-82.319353,0,'2013-07-06 12:44:32',NULL,NULL),(31251,'33980','S','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.978628,-82.059701,0,'2013-07-06 12:44:32',NULL,NULL),(61791,'73082','S','Rush Springs','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.784317,-97.957507,0,'2013-07-06 12:44:33',NULL,NULL),(77642,'97013','S','Canby','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.241313,-122.677583,0,'2013-07-06 12:44:34',NULL,NULL),(14295,'14876','P','Reading Ctr','A','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.433722,-76.950153,0,'2013-07-06 12:44:31',NULL,NULL),(41648,'47137','S','Carefree','A','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.209645,-86.365045,0,'2013-07-06 12:44:32',NULL,NULL),(32271,'35643','S','Hillsboro','D','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.616663,-87.197904,0,'2013-07-06 12:44:32',NULL,NULL),(20388,'20892','U','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008260,-77.100290,0,'2013-07-06 12:44:31',NULL,NULL),(69851,'84087','S','West Bountiful','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.888560,-111.912240,0,'2013-07-06 12:44:34',NULL,NULL),(44634,'50068','S','Derby','D','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.943215,-93.498112,0,'2013-07-06 12:44:32',NULL,NULL),(59365,'70582','S','St Martinvlle','A','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.139877,-91.822998,0,'2013-07-06 12:44:33',NULL,NULL),(52840,'61317','P','Cherry','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.427679,-89.210064,0,'2013-07-06 12:44:33',NULL,NULL),(70555,'85039','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.493473,-112.288528,0,'2013-07-06 12:44:34',NULL,NULL),(60967,'72104','S','Malvern','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(54893,'63070','S','Pevely','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.283780,-90.440460,0,'2013-07-06 12:44:33',NULL,NULL),(17332,'17864','S','Port Trevortn','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702320,-76.909800,0,'2013-07-06 12:44:31',NULL,NULL),(37095,'41339','S','Saldee','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(6526,'05827','S','Craftsbury Common','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.650000,-72.383333,0,'2013-07-06 12:44:30',NULL,NULL),(9412,'10001','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(77183,'96321','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77877,'97267','S','Johnson City','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(78126,'97526','S','Grants Pass','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.468747,-123.348364,0,'2013-07-06 12:44:34',NULL,NULL),(66897,'79251','S','Quail','D','Collingsworth','48087','Texas','TX','48','0000','806','Central',-6.0,'Y',34.930795,-100.443044,0,'2013-07-06 12:44:34',NULL,NULL),(6167,'05473','S','Long Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(19246,'19934','S','Camden-Wyo','N','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(18923,'19496','U','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.097292,-75.468489,0,'2013-07-06 12:44:31',NULL,NULL),(2970,'01050','S','Knightville','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(74053,'92154','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.578188,-117.072374,0,'2013-07-06 12:44:34',NULL,NULL),(20550,'21120','S','Parkton','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.639703,-76.682750,0,'2013-07-06 12:44:31',NULL,NULL),(46867,'54028','S','Wildwood','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.955122,-92.285779,0,'2013-07-06 12:44:32',NULL,NULL),(44628,'50064','S','Dana','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.106874,-94.227054,0,'2013-07-06 12:44:32',NULL,NULL),(78007,'97412','S','Triangle Lake','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.185860,-123.533340,0,'2013-07-06 12:44:34',NULL,NULL),(77291,'96650','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(15422,'16365','S','Warren','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.854253,-79.159439,0,'2013-07-06 12:44:31',NULL,NULL),(23744,'25928','S','Stephenson','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.575758,-81.328798,0,'2013-07-06 12:44:31',NULL,NULL),(11472,'12018','S','Averill Park','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(53268,'61721','S','Burt','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.341244,-89.310815,0,'2013-07-06 12:44:33',NULL,NULL),(50277,'57646','S','Mound City','D','Campbell','46021','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.675300,-100.049220,0,'2013-07-06 12:44:33',NULL,NULL),(47895,'55107','S','West Saint Paul','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.932638,-93.077152,0,'2013-07-06 12:44:33',NULL,NULL),(44996,'50440','S','Grafton','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.328788,-93.072452,0,'2013-07-06 12:44:32',NULL,NULL),(5279,'04497','S','Haynesville','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(28409,'31320','S','Midway','D','Liberty','13179','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.822149,-81.392949,0,'2013-07-06 12:44:32',NULL,NULL),(36631,'41004','S','Bladeston','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(28130,'30817','S','Leathersville','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(78289,'97877','S','Granite','A','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.729195,-118.264168,0,'2013-07-06 12:44:34',NULL,NULL),(49060,'56308','S','Alex','N','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.892797,-95.365967,0,'2013-07-06 12:44:33',NULL,NULL),(13290,'13662','S','Massena Center','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.918160,-74.935980,0,'2013-07-06 12:44:30',NULL,NULL),(18690,'19190','S','National Passport Agency','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953099,-75.166343,0,'2013-07-06 12:44:31',NULL,NULL),(77185,'96323','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(25696,'28530','S','Grifton','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.379849,-77.429291,0,'2013-07-06 12:44:31',NULL,NULL),(68767,'82301','S','Rawlins','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.788870,-107.199009,0,'2013-07-06 12:44:34',NULL,NULL),(67589,'80403','S','Blackhawk','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.818028,-105.251370,0,'2013-07-06 12:44:34',NULL,NULL),(32476,'36041','S','Highland Home','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.922283,-86.300926,0,'2013-07-06 12:44:32',NULL,NULL),(70906,'85624','S','Patagonia','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.532257,-110.747116,0,'2013-07-06 12:44:34',NULL,NULL),(76694,'95824','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.517663,-121.439746,0,'2013-07-06 12:44:34',NULL,NULL),(8585,'08223','S','Beesleys Point','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.262920,-74.661780,0,'2013-07-06 12:44:30',NULL,NULL),(79927,'99611','S','Nikiski','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.552102,-151.205064,0,'2013-07-06 12:44:34',NULL,NULL),(11445,'11976','S','Wtr Mill','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.930979,-72.352790,0,'2013-07-06 12:44:30',NULL,NULL),(61388,'72533','S','Mountain View','A','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.012180,-92.215500,0,'2013-07-06 12:44:33',NULL,NULL),(44391,'49807','S','Bark River','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.698400,-87.235980,0,'2013-07-06 12:44:32',NULL,NULL),(34453,'38655','S','Lafayette','A','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.350360,-89.518980,0,'2013-07-06 12:44:32',NULL,NULL),(54251,'62671','S','New Holland','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.184210,-89.579853,0,'2013-07-06 12:44:33',NULL,NULL),(16478,'17249','P','Rockhill Furn','A','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.242980,-77.900687,0,'2013-07-06 12:44:31',NULL,NULL),(37018,'41238','S','Manila','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.842864,-82.940341,0,'2013-07-06 12:44:32',NULL,NULL),(11199,'11743','S','Baycrest','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(9591,'10029','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(68812,'82435','S','Powell','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(60947,'72101','S','Grays','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(34796,'38873','S','Tishomingo','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.644991,-88.238561,0,'2013-07-06 12:44:32',NULL,NULL),(46624,'53580','S','Rewey','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.842708,-90.393117,0,'2013-07-06 12:44:32',NULL,NULL),(65099,'77363','S','Todd Mission','A','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.269093,-95.865930,0,'2013-07-06 12:44:34',NULL,NULL),(13520,'13813','S','Vallonia Springs','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.154740,-75.542760,0,'2013-07-06 12:44:31',NULL,NULL),(43702,'48893','S','Lake Isabella','A','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.671739,-84.988416,0,'2013-07-06 12:44:32',NULL,NULL),(42006,'47427','S','Hubbell','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.249277,-86.989828,0,'2013-07-06 12:44:32',NULL,NULL),(30160,'33170','S','Goulds','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(2000,'00910','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.442966,-66.071521,0,'2013-07-06 12:44:30',NULL,NULL),(19503,'20166','S','Dulles','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.995686,-77.435025,0,'2013-07-06 12:44:31',NULL,NULL),(66143,'78469','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.796865,-97.445946,0,'2013-07-06 12:44:34',NULL,NULL),(52325,'60560','S','Plattville','N','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.622305,-88.432040,0,'2013-07-06 12:44:33',NULL,NULL),(48302,'55440','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.987435,-93.271271,0,'2013-07-06 12:44:33',NULL,NULL),(74574,'92690','P','San Juan Capistrano','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.611708,-117.642970,0,'2013-07-06 12:44:34',NULL,NULL),(20612,'21209','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.370500,-76.694460,0,'2013-07-06 12:44:31',NULL,NULL),(67174,'79843','S','Marfa','D','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',30.307094,-104.037151,0,'2013-07-06 12:44:34',NULL,NULL),(54025,'62458','S','Saint Elmo','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.029314,-88.854347,0,'2013-07-06 12:44:33',NULL,NULL),(14653,'15236','S','West Mifflin','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(37769,'42343','S','Yeaman','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.628160,-86.708700,0,'2013-07-06 12:44:32',NULL,NULL),(31316,'34112','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.118299,-81.734198,0,'2013-07-06 12:44:32',NULL,NULL),(72355,'89020','S','Lathrop Wells','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.490016,-116.390342,0,'2013-07-06 12:44:34',NULL,NULL),(69921,'84110','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.756105,-111.897245,0,'2013-07-06 12:44:34',NULL,NULL),(16018,'17042','S','Cornwall Borough','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(3471,'01815','U','Woburn','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.505881,-71.127147,0,'2013-07-06 12:44:30',NULL,NULL),(57348,'66725','S','Sherwin','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(10182,'10285','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710807,-74.015235,0,'2013-07-06 12:44:30',NULL,NULL),(67395,'80124','S','Lonetree','N','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.546295,-104.896772,0,'2013-07-06 12:44:34',NULL,NULL),(72435,'89084','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.302659,-115.142997,0,'2013-07-06 12:44:34',NULL,NULL),(55724,'64080','S','Pleasant Hill','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.794067,-94.269275,0,'2013-07-06 12:44:33',NULL,NULL),(65772,'78109','S','Converse','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.478932,-98.274069,0,'2013-07-06 12:44:34',NULL,NULL),(53657,'62206','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.561749,-90.161656,0,'2013-07-06 12:44:33',NULL,NULL),(23856,'26143','S','Limestone Hl','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(41034,'46390','S','Thomaston','N','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.435469,-86.892131,0,'2013-07-06 12:44:32',NULL,NULL),(68938,'82932','S','Farson','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.110000,-109.440000,0,'2013-07-06 12:44:34',NULL,NULL),(59097,'70127','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.030503,-89.979564,0,'2013-07-06 12:44:33',NULL,NULL),(59624,'71034','S','Hall Summit','D','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.174719,-93.301587,0,'2013-07-06 12:44:33',NULL,NULL),(74207,'92304','P','Amboy','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.634003,-115.751436,0,'2013-07-06 12:44:34',NULL,NULL),(26389,'29102','S','Paxville','A','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(8336,'08037','S','Rosedale','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(23008,'24815','S','Vallscreek','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.269547,-81.665130,0,'2013-07-06 12:44:31',NULL,NULL),(21781,'23066','P','Gwynn','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.500030,-76.289392,0,'2013-07-06 12:44:31',NULL,NULL),(76747,'95916','S','Brush Creek','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.638726,-121.386666,0,'2013-07-06 12:44:34',NULL,NULL),(69830,'84080','S','Faust','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.036117,-112.388825,0,'2013-07-06 12:44:34',NULL,NULL),(10325,'10545','P','Maryknoll','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.183530,-73.829151,0,'2013-07-06 12:44:30',NULL,NULL),(58020,'67905','P','Liberal','D','Seward','20175','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.029534,-100.931646,0,'2013-07-06 12:44:33',NULL,NULL),(46992,'54235','S','Jacksonport','N','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(20501,'21065','U','Pdp Group Inc','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.478149,-76.645140,0,'2013-07-06 12:44:31',NULL,NULL),(17233,'17836','S','Leckkill','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.711436,-76.629823,0,'2013-07-06 12:44:31',NULL,NULL),(13268,'13650','S','Rural Hill','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.849649,-76.228306,0,'2013-07-06 12:44:30',NULL,NULL),(720,'00687','S','Sect Berio','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(27463,'30138','P','Esom Hill','D','Polk','13233','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.001797,-85.268188,0,'2013-07-06 12:44:31',NULL,NULL),(31468,'34289','S','Northport','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.052555,-82.197321,0,'2013-07-06 12:44:32',NULL,NULL),(54040,'62465','S','Strasburg','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.385371,-88.644050,0,'2013-07-06 12:44:33',NULL,NULL),(14554,'15212','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.469880,-80.015700,0,'2013-07-06 12:44:31',NULL,NULL),(46388,'53148','P','Lyons','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.649186,-88.355887,0,'2013-07-06 12:44:32',NULL,NULL),(46341,'53090','S','Westbend','N','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.449492,-88.171297,0,'2013-07-06 12:44:32',NULL,NULL),(48112,'55352','S','Jordan','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.672093,-93.633196,0,'2013-07-06 12:44:33',NULL,NULL),(34154,'38251','S','Puryear','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.446292,-88.332515,0,'2013-07-06 12:44:32',NULL,NULL),(63188,'75421','S','Brookston','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.655490,-95.646227,0,'2013-07-06 12:44:33',NULL,NULL),(59770,'71201','S','Corey','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(38635,'43928','P','Glencoe','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.006406,-80.873509,0,'2013-07-06 12:44:32',NULL,NULL),(73380,'91077','P','Arcadia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.125390,-118.054680,0,'2013-07-06 12:44:34',NULL,NULL),(56542,'65446','S','Cherryville','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.783556,-91.235854,0,'2013-07-06 12:44:33',NULL,NULL),(23828,'26104','S','N Parkersburg','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.286068,-81.526137,0,'2013-07-06 12:44:31',NULL,NULL),(57854,'67567','S','Pawnee Rock','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.303688,-98.973377,0,'2013-07-06 12:44:33',NULL,NULL),(18490,'19091','U','Media','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919050,-75.387375,0,'2013-07-06 12:44:31',NULL,NULL),(9417,'10001','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(60607,'71853','S','Ogden','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.597070,-93.973796,0,'2013-07-06 12:44:33',NULL,NULL),(27250,'29927','S','Purysburgh','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.281300,-81.071015,0,'2013-07-06 12:44:31',NULL,NULL),(34227,'38369','S','Rutherford','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.125967,-88.975445,0,'2013-07-06 12:44:32',NULL,NULL),(33706,'37766','S','Lafollette','N','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.338280,-84.069600,0,'2013-07-06 12:44:32',NULL,NULL),(74987,'93446','S','Nacimiento Lake','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(64706,'76857','S','May','D','Brown','48049','Texas','TX','48','0000','254','Central',-6.0,'Y',31.977693,-98.996483,0,'2013-07-06 12:44:34',NULL,NULL),(47340,'54601','S','Barre Mills','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.795836,-91.221089,0,'2013-07-06 12:44:32',NULL,NULL),(42689,'47984','P','Talbot','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.506111,-87.452467,0,'2013-07-06 12:44:32',NULL,NULL),(18233,'18971','P','Tylersport','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.403022,-75.394221,0,'2013-07-06 12:44:31',NULL,NULL),(14802,'15379','P','West Middletown','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.242130,-80.426974,0,'2013-07-06 12:44:31',NULL,NULL),(32282,'35653','S','Russellville','D','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.508322,-87.740943,0,'2013-07-06 12:44:32',NULL,NULL),(15961,'17026','S','Fredericksburg','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.447500,-76.414800,0,'2013-07-06 12:44:31',NULL,NULL),(26933,'29590','S','Salters','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.562975,-79.827528,0,'2013-07-06 12:44:31',NULL,NULL),(12781,'13214','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.036965,-76.073608,0,'2013-07-06 12:44:30',NULL,NULL),(21115,'22081','S','Merrifield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.873376,-77.235978,0,'2013-07-06 12:44:31',NULL,NULL),(75046,'93516','S','Four Corners','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.008562,-117.655982,0,'2013-07-06 12:44:34',NULL,NULL),(79040,'98404','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.212637,-122.409590,0,'2013-07-06 12:44:34',NULL,NULL),(65341,'77520','S','Lakewood','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(25221,'28088','S','Landis','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.545742,-80.614074,0,'2013-07-06 12:44:31',NULL,NULL),(11900,'12404','S','Accord','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810460,-74.249820,0,'2013-07-06 12:44:30',NULL,NULL),(51313,'59243','S','Enid','N','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.757632,-104.736737,0,'2013-07-06 12:44:33',NULL,NULL),(43115,'48224','S','Grosse Pointe Park','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.411143,-82.943461,0,'2013-07-06 12:44:32',NULL,NULL),(72413,'89048','S','Johnnie','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.254480,-116.018558,0,'2013-07-06 12:44:34',NULL,NULL),(54110,'62545','S','Roby','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.809097,-89.397015,0,'2013-07-06 12:44:33',NULL,NULL),(39596,'44870','S','Bloomingville','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.404980,-82.731420,0,'2013-07-06 12:44:32',NULL,NULL),(34606,'38748','S','Willet','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(20098,'20705','S','Beltsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.044597,-76.906156,0,'2013-07-06 12:44:31',NULL,NULL),(67919,'80906','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.791623,-104.825814,0,'2013-07-06 12:44:34',NULL,NULL),(13521,'13814','P','North Norwich','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.616122,-75.526146,0,'2013-07-06 12:44:31',NULL,NULL),(26768,'29438','S','Edisto Beach','N','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.569486,-80.310046,0,'2013-07-06 12:44:31',NULL,NULL),(25140,'28018','S','Bostic Yard','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(46059,'52574','S','Garfield','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.796400,-92.928720,0,'2013-07-06 12:44:32',NULL,NULL),(39560,'44847','S','North Monroeville','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.214505,-82.714432,0,'2013-07-06 12:44:32',NULL,NULL),(21536,'22732','S','Radiant','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.321250,-78.176689,0,'2013-07-06 12:44:31',NULL,NULL),(62627,'74552','S','Kinta','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.176937,-95.297329,0,'2013-07-06 12:44:33',NULL,NULL),(1289,'00730','S','Urb Ferry Barranca','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(53867,'62340','S','Griggsville','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.710725,-90.727921,0,'2013-07-06 12:44:33',NULL,NULL),(72647,'89428','P','Silver City','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.265737,-119.640036,0,'2013-07-06 12:44:34',NULL,NULL),(623,'00682','S','Jard del Caribe','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(651,'00682','S','Urb Westernlake Vlg','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(69589,'83843','S','Moscow','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.728363,-116.968109,0,'2013-07-06 12:44:34',NULL,NULL),(9692,'10045','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(38247,'43270','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.964970,-83.000319,0,'2013-07-06 12:44:32',NULL,NULL),(56075,'64756','S','Jerico Sprgs','A','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.669139,-94.008138,0,'2013-07-06 12:44:33',NULL,NULL),(44650,'50101','S','Galt','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.688739,-93.596143,0,'2013-07-06 12:44:32',NULL,NULL),(48574,'55771','S','Cusson','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(76578,'95677','S','Sunset Whitney Ranch','N','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.790376,-121.240241,0,'2013-07-06 12:44:34',NULL,NULL),(70789,'85355','S','Waddell','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.568166,-112.436072,0,'2013-07-06 12:44:34',NULL,NULL),(65008,'77301','S','Lakeland','N','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.311394,-95.433846,0,'2013-07-06 12:44:34',NULL,NULL),(39719,'45054','S','Oregonia','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.441107,-84.067374,0,'2013-07-06 12:44:32',NULL,NULL),(23009,'24816','P','Big Sandy','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.465034,-81.697432,0,'2013-07-06 12:44:31',NULL,NULL),(69948,'84117','S','Millcreek','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(51249,'59076','S','Hysham','A','Treasure','30103','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.292117,-107.095156,0,'2013-07-06 12:44:33',NULL,NULL),(44447,'49864','P','Nahma','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.841551,-86.664264,0,'2013-07-06 12:44:32',NULL,NULL),(73685,'91603','P','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.172067,-118.376920,0,'2013-07-06 12:44:34',NULL,NULL),(75165,'93591','S','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.604861,-117.832601,0,'2013-07-06 12:44:34',NULL,NULL),(52641,'61053','S','Mt Carroll','N','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.098801,-89.975105,0,'2013-07-06 12:44:33',NULL,NULL),(7462,'06875','P','Redding Cen','A','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.324045,-73.370143,0,'2013-07-06 12:44:30',NULL,NULL),(35819,'39762','P','Mississippi State University','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(65015,'77304','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.342840,-95.477880,0,'2013-07-06 12:44:34',NULL,NULL),(10207,'10452','S','Highbridge','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.841676,-73.921773,0,'2013-07-06 12:44:30',NULL,NULL),(15336,'16224','S','Fairmount City','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.066180,-79.273214,0,'2013-07-06 12:44:31',NULL,NULL),(13073,'13454','S','Salisbury Ctr','A','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.231609,-74.791568,0,'2013-07-06 12:44:30',NULL,NULL),(67828,'80804','S','Arriba','D','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.285797,-103.297244,0,'2013-07-06 12:44:34',NULL,NULL),(49309,'56540','S','Fertile','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.524800,-96.240660,0,'2013-07-06 12:44:33',NULL,NULL),(68085,'80939','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798565,-104.836169,0,'2013-07-06 12:44:34',NULL,NULL),(4446,'03247','P','Gilford','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.547500,-71.407222,0,'2013-07-06 12:44:30',NULL,NULL),(1653,'00772','S','Urb Santiago','N','Loiza','72087','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.433938,-65.880795,0,'2013-07-06 12:44:30',NULL,NULL),(15249,'16051','S','Portersville','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.961226,-80.153974,0,'2013-07-06 12:44:31',NULL,NULL),(34989,'39110','S','Gluckstadt','N','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.467942,-90.121854,0,'2013-07-06 12:44:32',NULL,NULL),(65757,'78067','S','San Ygnacio','D','Zapata','48505','Texas','TX','48','0000','956','Central',-6.0,'Y',27.038421,-99.425687,0,'2013-07-06 12:44:34',NULL,NULL),(2513,'00957','S','Urb May Fair','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(48374,'55564','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814449,-93.920242,0,'2013-07-06 12:44:33',NULL,NULL),(36427,'40577','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.071498,-84.502984,0,'2013-07-06 12:44:32',NULL,NULL),(61598,'72764','S','Fayetteville','A','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.179938,-94.145696,0,'2013-07-06 12:44:33',NULL,NULL),(60008,'71334','S','Frogmore','A','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(79176,'98520','S','Junction City','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(79293,'98584','S','Skok','A','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.202699,-123.098863,0,'2013-07-06 12:44:34',NULL,NULL),(17047,'17751','S','Clintondale','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(44754,'50173','S','Montour','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.947260,-92.707811,0,'2013-07-06 12:44:32',NULL,NULL),(54912,'63087','S','Valles Mines','D','Saint Francois','29187','Missouri','MO','29','0000','636','Central',-6.0,'Y',37.934605,-90.452399,0,'2013-07-06 12:44:33',NULL,NULL),(109,'00612','S','Urb Martell','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(52610,'61027','P','Eleroy','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.339428,-89.754978,0,'2013-07-06 12:44:33',NULL,NULL),(14815,'15420','P','Cardale','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.955894,-79.866137,0,'2013-07-06 12:44:31',NULL,NULL),(48907,'56131','S','Fulda','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.871151,-95.602641,0,'2013-07-06 12:44:33',NULL,NULL),(49502,'56666','P','Ponemah','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.074235,-94.849018,0,'2013-07-06 12:44:33',NULL,NULL),(52408,'60638','S','Stickney','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781649,-87.774356,0,'2013-07-06 12:44:33',NULL,NULL),(25652,'28470','S','Shallotte','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.959446,-78.395981,0,'2013-07-06 12:44:31',NULL,NULL),(70944,'85641','S','Santa Rita','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(24181,'26627','S','Heaters','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.755689,-80.651789,0,'2013-07-06 12:44:31',NULL,NULL),(69637,'84003','S','Timpanogos','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.419240,-111.565260,0,'2013-07-06 12:44:34',NULL,NULL),(56735,'65711','S','Manes','N','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.378970,-92.367020,0,'2013-07-06 12:44:33',NULL,NULL),(34927,'38966','S','Albin','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.948357,-90.348145,0,'2013-07-06 12:44:32',NULL,NULL),(7997,'07719','S','Belmar','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(39977,'45239','S','Colerain Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(76062,'95201','P','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.906882,-121.223403,0,'2013-07-06 12:44:34',NULL,NULL),(78893,'98359','S','Fragaria','N','Kitsap','53035','Washington','WA','53','1150','253/564','Pacific',-8.0,'Y',47.427546,-122.575624,0,'2013-07-06 12:44:34',NULL,NULL),(5321,'04572','S','Waldoboro','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.045261,-69.544349,0,'2013-07-06 12:44:30',NULL,NULL),(71472,'87061','P','Torreon','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.744837,-106.156087,0,'2013-07-06 12:44:34',NULL,NULL),(71333,'86507','P','Upper Greasewood Trading Pos','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.432600,-109.238820,0,'2013-07-06 12:44:34',NULL,NULL),(30211,'33183','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.700327,-80.408398,0,'2013-07-06 12:44:32',NULL,NULL),(64419,'76550','S','Nix','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.066265,-98.180696,0,'2013-07-06 12:44:34',NULL,NULL),(61847,'73119','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.420064,-97.570604,0,'2013-07-06 12:44:33',NULL,NULL),(38950,'44125','S','Garfield Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(54987,'63126','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550063,-90.377582,0,'2013-07-06 12:44:33',NULL,NULL),(47621,'54904','S','Oshkosh','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.024527,-88.617096,0,'2013-07-06 12:44:33',NULL,NULL),(72217,'88426','S','Logan','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.378100,-103.430820,0,'2013-07-06 12:44:34',NULL,NULL),(76015,'95126','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.320261,-121.917689,0,'2013-07-06 12:44:34',NULL,NULL),(78555,'98148','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.425051,-122.332127,0,'2013-07-06 12:44:34',NULL,NULL),(38177,'43160','S','Washington Court House','D','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.536064,-83.442724,0,'2013-07-06 12:44:32',NULL,NULL),(70186,'84334','P','Riverside','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.785486,-112.132417,0,'2013-07-06 12:44:34',NULL,NULL),(19369,'20057','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905206,-77.075470,0,'2013-07-06 12:44:31',NULL,NULL),(7819,'07456','S','Erskine Lakes','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.100840,-74.290260,0,'2013-07-06 12:44:30',NULL,NULL),(48506,'55738','S','Forbes','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.271048,-92.618597,0,'2013-07-06 12:44:33',NULL,NULL),(45587,'51544','S','Lewis','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.304611,-95.086673,0,'2013-07-06 12:44:32',NULL,NULL),(17153,'17810','S','Elimsport','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.117860,-77.022795,0,'2013-07-06 12:44:31',NULL,NULL),(67736,'80553','U','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.565319,-105.045445,0,'2013-07-06 12:44:34',NULL,NULL),(35772,'39744','S','Eupora','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(7328,'06705','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.549583,-72.995890,0,'2013-07-06 12:44:30',NULL,NULL),(32700,'36277','S','Weaver','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.753391,-85.819377,0,'2013-07-06 12:44:32',NULL,NULL),(34449,'38652','S','Pumpkin Center','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(62610,'74533','S','Caney','D','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.212503,-96.268979,0,'2013-07-06 12:44:33',NULL,NULL),(37469,'41862','S','Dry Creek','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.324722,-82.768056,0,'2013-07-06 12:44:32',NULL,NULL),(39395,'44657','S','Minerva','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(45798,'52171','S','Alpha','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.058499,-91.990554,0,'2013-07-06 12:44:32',NULL,NULL),(52356,'60610','S','Chestnut Street','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.898992,-87.636455,0,'2013-07-06 12:44:33',NULL,NULL),(71272,'86431','P','Chloride','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.197885,-114.032518,0,'2013-07-06 12:44:34',NULL,NULL),(21352,'22436','S','Caret','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.978173,-76.944159,0,'2013-07-06 12:44:31',NULL,NULL),(4115,'02721','S','Fall River','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.685457,-71.157020,0,'2013-07-06 12:44:30',NULL,NULL),(61830,'73112','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.519414,-97.575300,0,'2013-07-06 12:44:33',NULL,NULL),(30116,'33161','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(8040,'07732','S','Sandy Hook','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.399752,-73.997462,0,'2013-07-06 12:44:30',NULL,NULL),(7478,'06896','S','Redding','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.299751,-73.405213,0,'2013-07-06 12:44:30',NULL,NULL),(5840,'05089','S','Fieldsville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.475040,-72.427380,0,'2013-07-06 12:44:30',NULL,NULL),(28630,'31739','P','Cotton','D','Mitchell','13205','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.123370,-84.152676,0,'2013-07-06 12:44:32',NULL,NULL),(34610,'38751','S','Boyer','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(54305,'62708','P','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.759789,-89.635179,0,'2013-07-06 12:44:33',NULL,NULL),(30404,'33323','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.162098,-80.306679,0,'2013-07-06 12:44:32',NULL,NULL),(42857,'48080','S','Saint Clair Shores','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465933,-82.903852,0,'2013-07-06 12:44:32',NULL,NULL),(53894,'62359','S','Paloma','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.052796,-91.224158,0,'2013-07-06 12:44:33',NULL,NULL),(62359,'74066','S','Sepulpa','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.000197,-96.113994,0,'2013-07-06 12:44:33',NULL,NULL),(72948,'90039','S','Griffith','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.107325,-118.260934,0,'2013-07-06 12:44:34',NULL,NULL),(72558,'89301','S','Lane','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(63355,'75633','S','Carthage','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.155436,-94.342182,0,'2013-07-06 12:44:33',NULL,NULL),(12148,'12736','S','Fremont Center','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.848718,-75.024350,0,'2013-07-06 12:44:30',NULL,NULL),(68306,'81101','S','Carmel','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(62963,'75123','P','Desoto','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.588347,-96.860320,0,'2013-07-06 12:44:33',NULL,NULL),(23132,'24976','S','Pickaway','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.668229,-80.523874,0,'2013-07-06 12:44:31',NULL,NULL),(43799,'49058','S','Hastings','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.639887,-85.294848,0,'2013-07-06 12:44:32',NULL,NULL),(3770,'02190','S','S Weymouth','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.171028,-70.948119,0,'2013-07-06 12:44:30',NULL,NULL),(79983,'99657','P','Russian Mission','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.768371,-160.975984,0,'2013-07-06 12:44:34',NULL,NULL),(37029,'41254','S','River','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.874684,-82.660393,0,'2013-07-06 12:44:32',NULL,NULL),(5899,'05156','S','Springfield','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.289460,-72.474780,0,'2013-07-06 12:44:30',NULL,NULL),(66038,'78368','S','San Patricio','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(57253,'66535','S','Saint George','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.224971,-96.438051,0,'2013-07-06 12:44:33',NULL,NULL),(17688,'18202','S','Pardeesville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(79677,'99170','S','Plaza','A','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.303675,-117.357249,0,'2013-07-06 12:44:34',NULL,NULL),(26410,'29115','S','Bolen Town','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.581944,-80.818056,0,'2013-07-06 12:44:31',NULL,NULL),(25105,'27969','P','Roduco','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.462769,-76.814597,0,'2013-07-06 12:44:31',NULL,NULL),(252,'00637','S','Vistas De Sabana Grande','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(13791,'14171','S','West Valley','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.417525,-78.638025,0,'2013-07-06 12:44:31',NULL,NULL),(33468,'37330','S','Estill Spgs','A','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.272280,-86.128690,0,'2013-07-06 12:44:32',NULL,NULL),(5132,'04413','S','Brookton','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.579310,-67.727269,0,'2013-07-06 12:44:30',NULL,NULL),(69786,'84062','S','Pl Grove','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.384620,-111.736380,0,'2013-07-06 12:44:34',NULL,NULL),(61179,'72203','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.633321,-92.226709,0,'2013-07-06 12:44:33',NULL,NULL),(8144,'07842','P','Hibernia','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.945607,-74.494819,0,'2013-07-06 12:44:30',NULL,NULL),(29764,'33009','S','Golden Isles','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986228,-80.149188,0,'2013-07-06 12:44:32',NULL,NULL),(39023,'44143','S','Mayfield Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(37165,'41472','S','Index','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(78845,'98337','S','Bremerton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.570043,-122.637038,0,'2013-07-06 12:44:34',NULL,NULL),(41240,'46741','S','Grabill','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.210406,-84.975439,0,'2013-07-06 12:44:32',NULL,NULL),(22937,'24631','S','Oakwood','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.264444,-81.976111,0,'2013-07-06 12:44:31',NULL,NULL),(22218,'23529','U','Old Dominion University','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.884721,-76.311064,0,'2013-07-06 12:44:31',NULL,NULL),(28159,'30905','S','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.403925,-82.120051,0,'2013-07-06 12:44:31',NULL,NULL),(76028,'95140','S','Mount Hamilton','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.354500,-121.721340,0,'2013-07-06 12:44:34',NULL,NULL),(76699,'95828','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.483025,-121.397358,0,'2013-07-06 12:44:34',NULL,NULL),(76,'00612','S','Ext Villa los Santos I','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(30368,'33316','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.103966,-80.124513,0,'2013-07-06 12:44:32',NULL,NULL),(70811,'85375','S','Sun City','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.661749,-112.345339,0,'2013-07-06 12:44:34',NULL,NULL),(30311,'33304','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140780,-80.124434,0,'2013-07-06 12:44:32',NULL,NULL),(68598,'81602','P','Glenwood','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.494181,-107.328253,0,'2013-07-06 12:44:34',NULL,NULL),(38441,'43569','S','Weston','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.351195,-83.790896,0,'2013-07-06 12:44:32',NULL,NULL),(18249,'19001','S','Abington','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.123936,-75.131093,0,'2013-07-06 12:44:31',NULL,NULL),(16283,'17102','S','West End','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.258980,-76.862940,0,'2013-07-06 12:44:31',NULL,NULL),(14104,'14625','S','Panorama','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.134240,-77.499600,0,'2013-07-06 12:44:31',NULL,NULL),(7304,'06606','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.213020,-73.211437,0,'2013-07-06 12:44:30',NULL,NULL),(47170,'54476','S','Schofield','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.906068,-89.571594,0,'2013-07-06 12:44:32',NULL,NULL),(50477,'58046','S','Colgate','A','Steele','38091','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.200020,-97.783920,0,'2013-07-06 12:44:33',NULL,NULL),(52833,'61312','S','Arlington','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.451376,-89.221462,0,'2013-07-06 12:44:33',NULL,NULL),(65718,'78023','S','Grey Forest','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.592512,-98.715028,0,'2013-07-06 12:44:34',NULL,NULL),(31515,'34471','S','Maricamp','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.170260,-82.091441,0,'2013-07-06 12:44:32',NULL,NULL),(16827,'17552','S','Farmdale','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(26156,'28740','S','Upper Pig Pen','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(14589,'15221','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(22204,'23511','S','Norfolk Naval Air Station','N','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(69585,'83839','S','Kingston','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.551860,-116.290620,0,'2013-07-06 12:44:34',NULL,NULL),(73540,'91353','P','Sun Valley','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.217534,-118.367514,0,'2013-07-06 12:44:34',NULL,NULL),(30517,'33404','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(8247,'08005','S','Barnegat Township','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.758880,-74.283480,0,'2013-07-06 12:44:30',NULL,NULL),(50019,'57399','U','United States Postal Service','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.363185,-98.218918,0,'2013-07-06 12:44:33',NULL,NULL),(1707,'00777','S','Villa Ana','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(38006,'42782','S','Summersville','D','Green','21087','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.336525,-85.699899,0,'2013-07-06 12:44:32',NULL,NULL),(30736,'33540','S','Zephyrhills','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.230447,-82.169298,0,'2013-07-06 12:44:32',NULL,NULL),(43709,'48906','S','Lansing','D','Clinton','26037','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.768210,-84.579742,0,'2013-07-06 12:44:32',NULL,NULL),(54490,'62863','S','Patton','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(56388,'65233','S','Windsor Place','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(65746,'78060','S','Oakville','D','Live Oak','48297','Texas','TX','48','0000','361','Central',-6.0,'Y',28.460000,-98.182222,0,'2013-07-06 12:44:34',NULL,NULL),(77091,'96136','S','Wendel','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.286700,-120.087720,0,'2013-07-06 12:44:34',NULL,NULL),(38673,'43953','S','Steubenville','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.376875,-80.700762,0,'2013-07-06 12:44:32',NULL,NULL),(25412,'28297','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.277971,-80.855263,0,'2013-07-06 12:44:31',NULL,NULL),(58205,'68327','S','Chester','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.009914,-97.619397,0,'2013-07-06 12:44:33',NULL,NULL),(74135,'92244','P','El Centro','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.794254,-115.579280,0,'2013-07-06 12:44:34',NULL,NULL),(46146,'52656','S','Saint Paul','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.716675,-91.454585,0,'2013-07-06 12:44:32',NULL,NULL),(52211,'60481','S','Custer Park','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.294293,-88.124154,0,'2013-07-06 12:44:33',NULL,NULL),(65705,'78013','S','Comfort','D','Kendall','48259','Texas','TX','48','0000','830','Central',-6.0,'Y',29.984861,-98.839637,0,'2013-07-06 12:44:34',NULL,NULL),(38061,'43056','S','Newark','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.004880,-82.346460,0,'2013-07-06 12:44:32',NULL,NULL),(24744,'27530','S','Patetown','N','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.379960,-78.097860,0,'2013-07-06 12:44:31',NULL,NULL),(9934,'10154','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(1186,'00727','S','Villa Nueva','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(29263,'32456','S','Overstreet','A','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.819214,-85.299275,0,'2013-07-06 12:44:32',NULL,NULL),(29106,'32306','U','Florida State University','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.442453,-84.299083,0,'2013-07-06 12:44:32',NULL,NULL),(25070,'27941','S','Harbinger','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.090072,-75.815398,0,'2013-07-06 12:44:31',NULL,NULL),(24704,'27497','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.044200,-79.859900,0,'2013-07-06 12:44:31',NULL,NULL),(23100,'24934','S','Dunmore','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.356916,-79.828665,0,'2013-07-06 12:44:31',NULL,NULL),(22564,'24149','S','Riner','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.026300,-80.435280,0,'2013-07-06 12:44:31',NULL,NULL),(2639,'00966','S','Alt de Torrimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(3651,'02119','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.288240,-71.047440,0,'2013-07-06 12:44:30',NULL,NULL),(12317,'12861','S','Putnam Sta','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.749622,-73.417889,0,'2013-07-06 12:44:30',NULL,NULL),(47276,'54536','P','Iron Belt','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.414662,-90.271853,0,'2013-07-06 12:44:32',NULL,NULL),(58321,'68444','S','Strang','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.396596,-97.540543,0,'2013-07-06 12:44:33',NULL,NULL),(58894,'69169','S','Wallace','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.836130,-101.159212,0,'2013-07-06 12:44:33',NULL,NULL),(59242,'70435','S','Covington','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.536408,-90.107225,0,'2013-07-06 12:44:33',NULL,NULL),(67147,'79772','S','Verhalen','A','Reeves','48389','Texas','TX','48','0000','432','Central',-6.0,'Y',31.375544,-103.523013,0,'2013-07-06 12:44:34',NULL,NULL),(70610,'85119','S','Apache Junction','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.417293,-111.528765,0,'2013-07-06 12:44:34',NULL,NULL),(20177,'20746','S','Hillcrest Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(30810,'33615','S','Twn N Cntry','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.009516,-82.585627,0,'2013-07-06 12:44:32',NULL,NULL),(7169,'06444','P','Marion','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.561975,-72.929327,0,'2013-07-06 12:44:30',NULL,NULL),(52638,'61051','S','Milledgeville','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.962847,-89.774668,0,'2013-07-06 12:44:33',NULL,NULL),(66895,'79248','S','Paducah','D','Cottle','48101','Texas','TX','48','0000','806','Central',-6.0,'Y',34.010623,-100.302278,0,'2013-07-06 12:44:34',NULL,NULL),(44416,'49833','P','Little Lake','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.286567,-87.333115,0,'2013-07-06 12:44:32',NULL,NULL),(45508,'51363','P','Superior','D','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.462491,-94.970139,0,'2013-07-06 12:44:32',NULL,NULL),(2926,'01013','S','Willimansett','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.162301,-72.604454,0,'2013-07-06 12:44:30',NULL,NULL),(39116,'44255','S','Shalersville','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.300880,-81.229860,0,'2013-07-06 12:44:32',NULL,NULL),(38003,'42765','S','Munfordville','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.293705,-85.916947,0,'2013-07-06 12:44:32',NULL,NULL),(15889,'17004','S','Menno','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.603109,-77.720588,0,'2013-07-06 12:44:31',NULL,NULL),(22855,'24539','S','Crystal Hill','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.870824,-78.966925,0,'2013-07-06 12:44:31',NULL,NULL),(21270,'22309','S','Engleside','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.727866,-77.109317,0,'2013-07-06 12:44:31',NULL,NULL),(67752,'80620','S','Evans','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.379688,-104.698376,0,'2013-07-06 12:44:34',NULL,NULL),(17415,'17921','S','Helfenstein','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(13875,'14260','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.003074,-78.785924,0,'2013-07-06 12:44:31',NULL,NULL),(13310,'13673','S','Phila','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.157023,-75.711455,0,'2013-07-06 12:44:30',NULL,NULL),(44923,'50335','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595639,-93.621050,0,'2013-07-06 12:44:32',NULL,NULL),(18926,'19504','S','Barto','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(14883,'15477','P','Roscoe','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.078404,-79.863306,0,'2013-07-06 12:44:31',NULL,NULL),(12867,'13324','S','Grant','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(37445,'41840','S','Fleming','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.212627,-82.707115,0,'2013-07-06 12:44:32',NULL,NULL),(35403,'39462','S','New Augusta','D','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.291608,-89.067446,0,'2013-07-06 12:44:32',NULL,NULL),(26871,'29546','S','Brittons Neck','A','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.930000,-79.410000,0,'2013-07-06 12:44:31',NULL,NULL),(77041,'96108','S','Davis Creek','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.826704,-120.310770,0,'2013-07-06 12:44:34',NULL,NULL),(56008,'64651','S','Laclede','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.787818,-93.166060,0,'2013-07-06 12:44:33',NULL,NULL),(49083,'56327','S','Farwell','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.769314,-95.626709,0,'2013-07-06 12:44:33',NULL,NULL),(6979,'06243','S','E Killingly','A','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.848174,-71.806468,0,'2013-07-06 12:44:30',NULL,NULL),(18074,'18705','S','Laflin','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(10537,'10992','S','Washingtonville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.424960,-74.171460,0,'2013-07-06 12:44:30',NULL,NULL),(66745,'79001','S','Adrian','D','Oldham','48359','Texas','TX','48','0000','806','Central',-6.0,'Y',35.382670,-102.854016,0,'2013-07-06 12:44:34',NULL,NULL),(71360,'86540','P','Nazlini','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.607281,-109.461036,0,'2013-07-06 12:44:34',NULL,NULL),(79168,'98513','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.007788,-122.750150,0,'2013-07-06 12:44:34',NULL,NULL),(79071,'98431','U','Madigan Hosp','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(68577,'81505','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.107861,-108.607362,0,'2013-07-06 12:44:34',NULL,NULL),(47518,'54801','S','Spooner','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.892439,-92.071809,0,'2013-07-06 12:44:32',NULL,NULL),(9466,'10009','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(61699,'72957','P','Van Buren','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.438608,-94.352594,0,'2013-07-06 12:44:33',NULL,NULL),(61233,'72331','S','Twist','A','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.269497,-90.461420,0,'2013-07-06 12:44:33',NULL,NULL),(3853,'02348','U','Talbots','N','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.877314,-70.946435,0,'2013-07-06 12:44:30',NULL,NULL),(15384,'16319','S','Cranberry','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.337921,-79.721721,0,'2013-07-06 12:44:31',NULL,NULL),(14969,'15629','P','East Vandergrift','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.598731,-79.564877,0,'2013-07-06 12:44:31',NULL,NULL),(13638,'13905','S','Dickinson','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(3150,'01258','S','So Egremont','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.107580,-73.465080,0,'2013-07-06 12:44:30',NULL,NULL),(51046,'58734','S','Coulee','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.475200,-101.904180,0,'2013-07-06 12:44:33',NULL,NULL),(52422,'60649','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.762027,-87.567858,0,'2013-07-06 12:44:33',NULL,NULL),(68799,'82423','P','Frannie','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.969383,-108.619848,0,'2013-07-06 12:44:34',NULL,NULL),(55431,'63666','P','Reynolds','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.243300,-90.952046,0,'2013-07-06 12:44:33',NULL,NULL),(62996,'75154','S','Ovilla','A','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.525442,-96.814963,0,'2013-07-06 12:44:33',NULL,NULL),(71620,'87357','P','Pinehill','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.134800,-108.495600,0,'2013-07-06 12:44:34',NULL,NULL),(50132,'57532','S','Fort Pierre','D','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(70027,'84130','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700770,-111.947110,0,'2013-07-06 12:44:34',NULL,NULL),(47075,'54428','S','Post Lake','N','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.458760,-89.110140,0,'2013-07-06 12:44:32',NULL,NULL),(793,'00693','S','Est de Tortuguero','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(41859,'47355','S','Bloomingport','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(25406,'28289','U','Branch Bank and Trust (BB&T)','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.225894,-80.841681,0,'2013-07-06 12:44:31',NULL,NULL),(23308,'25202','S','Upper Falls','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.340295,-81.846193,0,'2013-07-06 12:44:31',NULL,NULL),(78383,'98026','S','Edmonds','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.840770,-122.336731,0,'2013-07-06 12:44:34',NULL,NULL),(19887,'20535','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892434,-77.022821,0,'2013-07-06 12:44:31',NULL,NULL),(10281,'10516','S','Cold Spring','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422380,-73.950720,0,'2013-07-06 12:44:30',NULL,NULL),(41320,'46774','S','Milan Center','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(41006,'46366','S','North Judson','D','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.220866,-86.773298,0,'2013-07-06 12:44:32',NULL,NULL),(38067,'43062','S','Pataskala','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.005979,-82.676213,0,'2013-07-06 12:44:32',NULL,NULL),(37666,'42211','S','Canton','A','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(33206,'37046','S','College Grove','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.772714,-86.714662,0,'2013-07-06 12:44:32',NULL,NULL),(28992,'32216','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.279875,-81.583037,0,'2013-07-06 12:44:32',NULL,NULL),(60118,'71368','S','Peck','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.854570,-91.693483,0,'2013-07-06 12:44:33',NULL,NULL),(65148,'77388','S','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.050527,-95.465969,0,'2013-07-06 12:44:34',NULL,NULL),(66599,'78755','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.359842,-97.760930,0,'2013-07-06 12:44:34',NULL,NULL),(67715,'80534','S','Loveland','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.305750,-105.074550,0,'2013-07-06 12:44:34',NULL,NULL),(67826,'80801','S','Arickaree','N','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.709723,-103.281853,0,'2013-07-06 12:44:34',NULL,NULL),(79770,'99330','S','Eltopia','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.479358,-119.082902,0,'2013-07-06 12:44:34',NULL,NULL),(42688,'47984','P','Fowler','A','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.506111,-87.452467,0,'2013-07-06 12:44:32',NULL,NULL),(49893,'57271','S','Vienna','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.676806,-97.547404,0,'2013-07-06 12:44:33',NULL,NULL),(48689,'55932','S','Elgin','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.121402,-92.250206,0,'2013-07-06 12:44:33',NULL,NULL),(66468,'78657','S','Horseshoe Bay','D','Llano','48299','Texas','TX','48','0000','830','Central',-6.0,'Y',30.579706,-98.271069,0,'2013-07-06 12:44:34',NULL,NULL),(75354,'93920','S','Gorda','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.135880,-121.659477,0,'2013-07-06 12:44:34',NULL,NULL),(60309,'71454','S','Union Hill','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(8902,'08733','S','Manchester Township','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(76715,'95843','S','Sacramento','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.686118,-121.380837,0,'2013-07-06 12:44:34',NULL,NULL),(1055,'00725','S','Bda Morales','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(42025,'47437','P','Huron','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772039,-86.628500,0,'2013-07-06 12:44:32',NULL,NULL),(39884,'45211','S','Fairmont','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.158460,-84.594600,0,'2013-07-06 12:44:32',NULL,NULL),(39878,'45208','S','Mt Lookout','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.132484,-84.435285,0,'2013-07-06 12:44:32',NULL,NULL),(19540,'20192','U','Reston','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.946349,-77.363143,0,'2013-07-06 12:44:31',NULL,NULL),(27093,'29710','S','River Hills','A','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.105301,-81.184746,0,'2013-07-06 12:44:31',NULL,NULL),(26019,'28677','S','Loray','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(23264,'25136','S','Montgomery','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.178508,-81.321429,0,'2013-07-06 12:44:31',NULL,NULL),(9728,'10087','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(13922,'14416','S','Bergen','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.073730,-77.985432,0,'2013-07-06 12:44:31',NULL,NULL),(44120,'49507','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.934602,-85.652654,0,'2013-07-06 12:44:32',NULL,NULL),(58959,'70005','S','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.999098,-90.135663,0,'2013-07-06 12:44:33',NULL,NULL),(62275,'74015','S','Cotoosa','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.186268,-95.744614,0,'2013-07-06 12:44:33',NULL,NULL),(68535,'81414','P','Orchard City','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.788359,-107.986539,0,'2013-07-06 12:44:34',NULL,NULL),(70915,'85630','S','Saint David','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.921429,-110.233684,0,'2013-07-06 12:44:34',NULL,NULL),(75050,'93518','S','Havilah','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.318400,-118.462200,0,'2013-07-06 12:44:34',NULL,NULL),(21308,'22405','S','Fredericksbg','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.320601,-77.414651,0,'2013-07-06 12:44:31',NULL,NULL),(59795,'71220','S','Perryville','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(52757,'61244','S','Whites Addition','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(21067,'21922','P','Elkton','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.608040,-75.835670,0,'2013-07-06 12:44:31',NULL,NULL),(55560,'63862','S','North Lilbourn','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.588932,-89.617667,0,'2013-07-06 12:44:33',NULL,NULL),(68338,'81122','S','Vallecito','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.314420,-107.612280,0,'2013-07-06 12:44:34',NULL,NULL),(39071,'44210','P','Bath','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.188919,-81.629751,0,'2013-07-06 12:44:32',NULL,NULL),(40211,'45402','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.760218,-84.186840,0,'2013-07-06 12:44:32',NULL,NULL),(18097,'18708','S','Wilkes Barre','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.300280,-75.965880,0,'2013-07-06 12:44:31',NULL,NULL),(8263,'08008','S','Ship Bottom','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(20658,'21226','S','Clearwater Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(45068,'50519','S','Bode','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.865196,-94.283898,0,'2013-07-06 12:44:32',NULL,NULL),(45520,'51433','S','Auburn','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.271200,-94.891740,0,'2013-07-06 12:44:32',NULL,NULL),(54286,'62701','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.798379,-89.646561,0,'2013-07-06 12:44:33',NULL,NULL),(60365,'71474','P','Simpson','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.242969,-93.015952,0,'2013-07-06 12:44:33',NULL,NULL),(68087,'80941','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.866594,-104.755324,0,'2013-07-06 12:44:34',NULL,NULL),(19515,'20176','S','Lucketts','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.201977,-77.535473,0,'2013-07-06 12:44:31',NULL,NULL),(48550,'55760','S','Salo','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(20095,'20703','P','Lanham Seabrook','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.966944,-76.862222,0,'2013-07-06 12:44:31',NULL,NULL),(50675,'58341','S','Wellsburg','N','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(46855,'54023','S','Warren','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.989800,-92.560920,0,'2013-07-06 12:44:32',NULL,NULL),(24027,'26377','S','Lima','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.499919,-80.641416,0,'2013-07-06 12:44:31',NULL,NULL),(27961,'30552','S','Lakemont','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.752997,-83.395937,0,'2013-07-06 12:44:31',NULL,NULL),(893,'00704','S','Urb La Fabrica','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(7763,'07405','S','Kinnelon','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(5188,'04443','S','Guilford','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.214034,-69.409404,0,'2013-07-06 12:44:30',NULL,NULL),(39327,'44613','S','Brewster','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.713728,-81.598902,0,'2013-07-06 12:44:32',NULL,NULL),(46706,'53792','U','Univ of Wis Hosp Hlth Sc Ctr','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.076741,-89.433069,0,'2013-07-06 12:44:32',NULL,NULL),(49407,'56627','S','Big Falls','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.157929,-93.863003,0,'2013-07-06 12:44:33',NULL,NULL),(69372,'83604','S','Riddle','A','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.681724,-115.929733,0,'2013-07-06 12:44:34',NULL,NULL),(78743,'98290','S','Larimers Corner','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.939532,-122.016706,0,'2013-07-06 12:44:34',NULL,NULL),(79551,'99004','S','Amber','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.439420,-117.627360,0,'2013-07-06 12:44:34',NULL,NULL),(3174,'01330','S','Ashfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.521400,-72.813120,0,'2013-07-06 12:44:30',NULL,NULL),(65519,'77707','S','Lamar University','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.068757,-94.173922,0,'2013-07-06 12:44:34',NULL,NULL),(61001,'72112','S','Weldon','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(53551,'62045','S','Hamburg','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.213437,-90.690020,0,'2013-07-06 12:44:33',NULL,NULL),(21909,'23190','P','Woods Crs Rds','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.483538,-76.620692,0,'2013-07-06 12:44:31',NULL,NULL),(36256,'40319','P','Farmers','D','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.145208,-83.545594,0,'2013-07-06 12:44:32',NULL,NULL),(34185,'38321','S','Cedar Grove','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.861718,-88.520863,0,'2013-07-06 12:44:32',NULL,NULL),(71752,'87545','U','Los Alamos','D','Los Alamos','35028','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.893540,-106.285048,0,'2013-07-06 12:44:34',NULL,NULL),(70032,'84132','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.765465,-111.840905,0,'2013-07-06 12:44:34',NULL,NULL),(70852,'85547','P','Payson','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.258255,-111.279726,0,'2013-07-06 12:44:34',NULL,NULL),(1731,'00778','S','Urb Campinas De Navarro','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(40077,'45296','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.103702,-84.532826,0,'2013-07-06 12:44:32',NULL,NULL),(13376,'13737','P','Bible School Park','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.078376,-76.096835,0,'2013-07-06 12:44:31',NULL,NULL),(25581,'28438','S','Boardman','A','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.420210,-78.817830,0,'2013-07-06 12:44:31',NULL,NULL),(54525,'62879','P','Sailor Spgs','A','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.763612,-88.359594,0,'2013-07-06 12:44:33',NULL,NULL),(57817,'67520','S','Bison','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.518768,-99.199095,0,'2013-07-06 12:44:33',NULL,NULL),(63980,'76108','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.781540,-97.503780,0,'2013-07-06 12:44:34',NULL,NULL),(66024,'78361','S','Hebbronville','D','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',27.283639,-98.691312,0,'2013-07-06 12:44:34',NULL,NULL),(66535,'78725','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.234974,-97.597560,0,'2013-07-06 12:44:34',NULL,NULL),(30770,'33575','P','Ruskin','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.714551,-82.419142,0,'2013-07-06 12:44:32',NULL,NULL),(47175,'54480','S','Stetsonville','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.078102,-90.315158,0,'2013-07-06 12:44:32',NULL,NULL),(77163,'96218','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(19964,'20588','U','Dept HS','N','Howard','24027','Maryland','MD','24','8840','202','Eastern',-5.0,'Y',38.916044,-77.056499,0,'2013-07-06 12:44:31',NULL,NULL),(9013,'08863','S','Perth Amboy','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.536610,-74.315728,0,'2013-07-06 12:44:30',NULL,NULL),(62241,'74002','S','Pershing','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.558589,-96.162993,0,'2013-07-06 12:44:33',NULL,NULL),(16179,'17066','S','Silver Ford','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.386060,-77.874060,0,'2013-07-06 12:44:31',NULL,NULL),(25636,'28465','S','Sunny Point Military Ocean T','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(37978,'42728','S','Montpelier','A','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(31366,'34208','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.484276,-82.535488,0,'2013-07-06 12:44:32',NULL,NULL),(39352,'44626','S','Howenstein','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.694655,-81.377559,0,'2013-07-06 12:44:32',NULL,NULL),(33420,'37242','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.163122,-86.783343,0,'2013-07-06 12:44:32',NULL,NULL),(58348,'68504','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.837188,-96.659433,0,'2013-07-06 12:44:33',NULL,NULL),(61460,'72628','S','Deer','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.842526,-93.350809,0,'2013-07-06 12:44:33',NULL,NULL),(72278,'88558','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769043,-106.329586,0,'2013-07-06 12:44:34',NULL,NULL),(75090,'93535','S','Roosevelt Corner','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(77953,'97360','S','Mill City','D','Linn','41043','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',44.751239,-122.480247,0,'2013-07-06 12:44:34',NULL,NULL),(78753,'98294','S','Sultan','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.866673,-121.772083,0,'2013-07-06 12:44:34',NULL,NULL),(18785,'19375','P','Unionville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.905006,-75.730773,0,'2013-07-06 12:44:31',NULL,NULL),(44997,'50441','S','Hampton','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.745447,-93.208062,0,'2013-07-06 12:44:32',NULL,NULL),(44502,'49927','S','Gaastra','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.051469,-88.589010,0,'2013-07-06 12:44:32',NULL,NULL),(66318,'78595','S','Sullivan City','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.260256,-98.560333,0,'2013-07-06 12:44:34',NULL,NULL),(66533,'78723','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.306657,-97.683140,0,'2013-07-06 12:44:34',NULL,NULL),(68258,'81067','S','Hawley','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.044708,-103.717601,0,'2013-07-06 12:44:34',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (70793,'85359','P','Quartzsite','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.691042,-114.223077,0,'2013-07-06 12:44:34',NULL,NULL),(75312,'93755','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.787369,-119.793518,0,'2013-07-06 12:44:34',NULL,NULL),(34945,'39051','S','Ofahoma','N','Leake','28079','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.758440,-89.584740,0,'2013-07-06 12:44:32',NULL,NULL),(55386,'63625','S','Oates','N','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.555320,-91.003080,0,'2013-07-06 12:44:33',NULL,NULL),(23508,'25537','S','Lesage','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.506423,-82.290767,0,'2013-07-06 12:44:31',NULL,NULL),(28254,'31065','S','Montrose','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.561904,-83.160896,0,'2013-07-06 12:44:31',NULL,NULL),(57476,'66869','S','Strong City','D','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.395198,-96.536456,0,'2013-07-06 12:44:33',NULL,NULL),(31921,'35173','S','Trussville','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.642480,-86.584020,0,'2013-07-06 12:44:32',NULL,NULL),(64246,'76365','S','Henrietta','D','Clay','48077','Texas','TX','48','0000','940','Central',-6.0,'Y',33.816635,-98.186549,0,'2013-07-06 12:44:34',NULL,NULL),(18244,'18979','P','Woxall','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.315318,-75.458168,0,'2013-07-06 12:44:31',NULL,NULL),(9957,'10158','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(62312,'74035','S','Hominy','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.414067,-96.394679,0,'2013-07-06 12:44:33',NULL,NULL),(20289,'20797','U','Sthrn MD Fac','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.095953,-76.838956,0,'2013-07-06 12:44:31',NULL,NULL),(17224,'17830','S','Mandata','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690745,-76.789710,0,'2013-07-06 12:44:31',NULL,NULL),(8972,'08821','P','Flagtown','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.521402,-74.688156,0,'2013-07-06 12:44:30',NULL,NULL),(10517,'10977','S','New Square','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(31506,'34451','P','Inverness','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.838477,-82.331566,0,'2013-07-06 12:44:32',NULL,NULL),(30532,'33408','S','Juno Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(47670,'54944','S','Medina','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.320068,-88.622498,0,'2013-07-06 12:44:33',NULL,NULL),(51407,'59434','P','East Glacier Park','D','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.444373,-113.218214,0,'2013-07-06 12:44:33',NULL,NULL),(59804,'71225','S','Calhoun','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.527647,-92.314023,0,'2013-07-06 12:44:33',NULL,NULL),(60426,'71643','S','Meroney','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.984603,-91.556472,0,'2013-07-06 12:44:33',NULL,NULL),(66539,'78728','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.445565,-97.681089,0,'2013-07-06 12:44:34',NULL,NULL),(40711,'46113','S','Camby','D','Morgan','18109','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.640017,-86.308573,0,'2013-07-06 12:44:32',NULL,NULL),(22536,'24120','S','Meadows Dan','A','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.724210,-80.401341,0,'2013-07-06 12:44:31',NULL,NULL),(13475,'13788','S','Hobart','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.381997,-74.681185,0,'2013-07-06 12:44:31',NULL,NULL),(70402,'84714','S','Beryl','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.703796,-113.652604,0,'2013-07-06 12:44:34',NULL,NULL),(1914,'00795','S','Hacienda Casa Blanca','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(72925,'90029','S','Vermont','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.090213,-118.293835,0,'2013-07-06 12:44:34',NULL,NULL),(14885,'15479','S','Smithton','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.139958,-79.727931,0,'2013-07-06 12:44:31',NULL,NULL),(12261,'12832','S','Truthville','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(10693,'11218','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.641581,-73.975901,0,'2013-07-06 12:44:30',NULL,NULL),(49478,'56655','S','Wabedo','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(15508,'16510','S','Wesleyville','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.140278,-80.015278,0,'2013-07-06 12:44:31',NULL,NULL),(21757,'23058','P','Glenallen','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.662023,-77.484349,0,'2013-07-06 12:44:31',NULL,NULL),(34503,'38671','S','Southaven','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.974697,-89.993398,0,'2013-07-06 12:44:32',NULL,NULL),(33939,'38070','P','Tigrett','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.095127,-89.237293,0,'2013-07-06 12:44:32',NULL,NULL),(44838,'50261','S','Van Meter','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.526185,-93.955660,0,'2013-07-06 12:44:32',NULL,NULL),(61542,'72685','S','Mount Hersey','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.042357,-92.985835,0,'2013-07-06 12:44:33',NULL,NULL),(71576,'87311','P','Church Rock','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.532257,-108.606034,0,'2013-07-06 12:44:34',NULL,NULL),(36157,'40241','S','Manor Creek','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(53277,'61725','S','Carlock','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.583898,-89.131546,0,'2013-07-06 12:44:33',NULL,NULL),(23127,'24966','S','Renick','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.065844,-80.376621,0,'2013-07-06 12:44:31',NULL,NULL),(14275,'14853','S','Ithaca','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.439636,-76.487351,0,'2013-07-06 12:44:31',NULL,NULL),(63902,'76028','S','Briaroaks','A','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.529531,-97.311978,0,'2013-07-06 12:44:34',NULL,NULL),(47832,'55071','S','Grey Cloud Island','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.826000,-92.990100,0,'2013-07-06 12:44:33',NULL,NULL),(43978,'49328','S','Hopkins','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.630240,-85.750474,0,'2013-07-06 12:44:32',NULL,NULL),(1270,'00730','S','Bo Magueyes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(72167,'88342','P','Orogrande','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.379663,-106.091478,0,'2013-07-06 12:44:34',NULL,NULL),(27266,'29936','S','Switzerland','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481598,-80.984342,0,'2013-07-06 12:44:31',NULL,NULL),(20,'00603','S','Ext El Prado','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(19475,'20143','S','Catharpin','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.847611,-77.565954,0,'2013-07-06 12:44:31',NULL,NULL),(24661,'27406','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.021374,-79.767916,0,'2013-07-06 12:44:31',NULL,NULL),(22264,'23691','S','Yorktown','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.244023,-76.551905,0,'2013-07-06 12:44:31',NULL,NULL),(8539,'08201','S','Absecon Highlands','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(51837,'60067','S','Inverness','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.112431,-88.051211,0,'2013-07-06 12:44:33',NULL,NULL),(59783,'71210','P','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.504942,-92.103613,0,'2013-07-06 12:44:33',NULL,NULL),(65223,'77445','S','Monaville','N','Waller','48473','Texas','TX','48','3360','979','Central',-6.0,'Y',30.072120,-96.081240,0,'2013-07-06 12:44:34',NULL,NULL),(10052,'10176','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(25854,'28626','S','Fleetwood','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.404248,-81.493632,0,'2013-07-06 12:44:31',NULL,NULL),(6045,'05408','S','North Burlington','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446628,-73.175354,0,'2013-07-06 12:44:30',NULL,NULL),(74542,'92662','S','Balboa Island','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.606234,-117.893145,0,'2013-07-06 12:44:34',NULL,NULL),(41387,'46802','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.072951,-85.153427,0,'2013-07-06 12:44:32',NULL,NULL),(758,'00692','S','Parc Ponderosa','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(7523,'07005','S','Boonton Twp','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(48744,'55971','S','Bratsberg','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(29897,'33045','P','Key West','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.557701,-81.805496,0,'2013-07-06 12:44:32',NULL,NULL),(5911,'05201','S','Woodford','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.879586,-73.197676,0,'2013-07-06 12:44:30',NULL,NULL),(30521,'33406','S','Cloud Lake','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(69178,'83333','S','Hailey','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.520227,-114.306418,0,'2013-07-06 12:44:34',NULL,NULL),(79849,'99549','P','King Salmon','A','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.945595,-158.633989,0,'2013-07-06 12:44:34',NULL,NULL),(18,'00603','S','Bo Borinquen','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(39606,'44875','S','Taylortown','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(39224,'44413','S','E Palestine','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.838445,-80.548361,0,'2013-07-06 12:44:32',NULL,NULL),(35406,'39464','S','Blodgett','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.403056,-89.093336,0,'2013-07-06 12:44:32',NULL,NULL),(16272,'17094','S','Thompsontown','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.564068,-77.237090,0,'2013-07-06 12:44:31',NULL,NULL),(25483,'28353','P','Laurinburg','D','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.777024,-79.465083,0,'2013-07-06 12:44:31',NULL,NULL),(31395,'34223','S','Englewood Beach','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.013007,-82.380021,0,'2013-07-06 12:44:32',NULL,NULL),(29002,'32221','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.291357,-81.811864,0,'2013-07-06 12:44:32',NULL,NULL),(49237,'56470','S','Lake Itasca','A','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(54388,'62817','S','Mayberry','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.960013,-88.453753,0,'2013-07-06 12:44:33',NULL,NULL),(54511,'62870','S','Odin','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.614783,-89.051397,0,'2013-07-06 12:44:33',NULL,NULL),(58188,'68310','S','Riverside','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(63869,'76004','P','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.735488,-97.106764,0,'2013-07-06 12:44:34',NULL,NULL),(67923,'80907','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.881982,-104.814334,0,'2013-07-06 12:44:34',NULL,NULL),(77635,'97007','S','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.472666,-122.856983,0,'2013-07-06 12:44:34',NULL,NULL),(41728,'47247','S','Jonesville','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.059830,-85.892065,0,'2013-07-06 12:44:32',NULL,NULL),(30131,'33164','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.929334,-80.176758,0,'2013-07-06 12:44:32',NULL,NULL),(23880,'26161','S','Petroleum','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.181051,-81.254818,0,'2013-07-06 12:44:31',NULL,NULL),(28238,'31050','S','Knoxville','D','Crawford','13079','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.633030,-83.961232,0,'2013-07-06 12:44:31',NULL,NULL),(9548,'10022','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(41580,'47040','S','Rising Sun','D','Ohio','18115','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',38.949548,-84.857658,0,'2013-07-06 12:44:32',NULL,NULL),(36536,'40865','S','Putney','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.938143,-83.265739,0,'2013-07-06 12:44:32',NULL,NULL),(34247,'38391','S','Denmark','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.542234,-88.992348,0,'2013-07-06 12:44:32',NULL,NULL),(18375,'19046','S','Hollywood','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(24784,'27572','S','Rougemont','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.196439,-79.007426,0,'2013-07-06 12:44:31',NULL,NULL),(55217,'63401','S','Rensselaer','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(66312,'78591','S','Santa Elena','D','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.744100,-98.514780,0,'2013-07-06 12:44:34',NULL,NULL),(66396,'78627','P','Georgetown','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.636976,-97.674651,0,'2013-07-06 12:44:34',NULL,NULL),(77504,'96836','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289782,-157.836148,0,'2013-07-06 12:44:34',NULL,NULL),(10079,'10199','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(24882,'27701','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.998900,-78.899063,0,'2013-07-06 12:44:31',NULL,NULL),(28689,'31805','S','Cusseta','D','Chattahoochee','13053','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.286885,-84.781146,0,'2013-07-06 12:44:32',NULL,NULL),(11373,'11932','P','Bridge Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.962338,-72.306224,0,'2013-07-06 12:44:30',NULL,NULL),(34332,'38564','S','Granville','D','Jackson','47087','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.280031,-85.746245,0,'2013-07-06 12:44:32',NULL,NULL),(42850,'48076','S','Lathrup Vlg','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.497322,-83.233132,0,'2013-07-06 12:44:32',NULL,NULL),(18829,'19421','P','Birchrunville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.106440,-75.644244,0,'2013-07-06 12:44:31',NULL,NULL),(21715,'22989','P','Woodberry For','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.213226,-78.052185,0,'2013-07-06 12:44:31',NULL,NULL),(69453,'83647','S','Rocky Bar','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(2229,'00926','S','Urb El Remanso','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(7914,'07630','S','Emerson','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.973523,-74.030257,0,'2013-07-06 12:44:30',NULL,NULL),(43749,'49008','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.261774,-85.607934,0,'2013-07-06 12:44:32',NULL,NULL),(50165,'57552','S','Midland','D','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(51937,'60124','S','Elgin','D','Kane','17089','Illinois','IL','17','1600','847','Central',-6.0,'Y',42.040262,-88.310402,0,'2013-07-06 12:44:33',NULL,NULL),(27627,'30311','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.722171,-84.473898,0,'2013-07-06 12:44:31',NULL,NULL),(22027,'23292','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542580,-77.444722,0,'2013-07-06 12:44:31',NULL,NULL),(77846,'97223','S','Tigard','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.438890,-122.772276,0,'2013-07-06 12:44:34',NULL,NULL),(21479,'22642','S','Linden','D','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.889060,-78.075811,0,'2013-07-06 12:44:31',NULL,NULL),(40849,'46224','S','Spdwy','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.792960,-86.257080,0,'2013-07-06 12:44:32',NULL,NULL),(31526,'34480','S','Maricamp','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.105081,-82.098267,0,'2013-07-06 12:44:32',NULL,NULL),(1314,'00735','S','Jard de Ceiba II','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(9566,'10025','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(65177,'77417','S','Beasley','D','Fort Bend','48157','Texas','TX','48','3360','979','Central',-6.0,'Y',29.474580,-95.971320,0,'2013-07-06 12:44:34',NULL,NULL),(13083,'13464','S','Smyrna','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.691125,-75.632663,0,'2013-07-06 12:44:30',NULL,NULL),(577,'00680','S','Bo Carcel','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(54192,'62629','S','Chatham','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.674929,-89.696026,0,'2013-07-06 12:44:33',NULL,NULL),(47174,'54480','S','Deer Creek','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.078102,-90.315158,0,'2013-07-06 12:44:32',NULL,NULL),(80119,'99762','P','Nome','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.787400,-165.197220,0,'2013-07-06 12:44:34',NULL,NULL),(57268,'66546','S','Wakarusa','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.894226,-95.710815,0,'2013-07-06 12:44:33',NULL,NULL),(68855,'82615','S','Shirley Basin','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.031000,-106.545746,0,'2013-07-06 12:44:34',NULL,NULL),(55710,'64068','S','Pleasant Vly','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.276480,-94.423260,0,'2013-07-06 12:44:33',NULL,NULL),(12728,'13159','S','Tully','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.808860,-76.143600,0,'2013-07-06 12:44:30',NULL,NULL),(45935,'52337','S','Stanwood','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.890714,-91.147902,0,'2013-07-06 12:44:32',NULL,NULL),(44353,'49780','S','Fibre','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.185180,-84.483720,0,'2013-07-06 12:44:32',NULL,NULL),(66711,'78948','S','Lincoln','D','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.316524,-96.976370,0,'2013-07-06 12:44:34',NULL,NULL),(22936,'24630','S','Tiptop','A','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.154700,-81.511320,0,'2013-07-06 12:44:31',NULL,NULL),(79186,'98530','P','Bucoda','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.799211,-122.867652,0,'2013-07-06 12:44:34',NULL,NULL),(52609,'61025','S','Menominee','N','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.466380,-90.571020,0,'2013-07-06 12:44:33',NULL,NULL),(49843,'57233','S','Spirit Lake','N','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.498580,-97.410480,0,'2013-07-06 12:44:33',NULL,NULL),(47396,'54640','P','Lynxville','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.247471,-91.049339,0,'2013-07-06 12:44:32',NULL,NULL),(47098,'54441','S','Hewitt','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.642149,-90.103456,0,'2013-07-06 12:44:32',NULL,NULL),(39357,'44628','S','Greer','N','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.536455,-82.219421,0,'2013-07-06 12:44:32',NULL,NULL),(21591,'22844','S','New Market','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.648808,-78.674885,0,'2013-07-06 12:44:31',NULL,NULL),(15395,'16332','S','Lickingville','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.378581,-79.370701,0,'2013-07-06 12:44:31',NULL,NULL),(3536,'01906','S','Saugus','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.459776,-71.009684,0,'2013-07-06 12:44:30',NULL,NULL),(7262,'06518','S','Centerville-Mount Carmel','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.415836,-72.912377,0,'2013-07-06 12:44:30',NULL,NULL),(28856,'32099','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.334930,-81.770917,0,'2013-07-06 12:44:32',NULL,NULL),(56108,'64801','S','Central City','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(15663,'16802','S','Penn State University','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.870717,-77.834150,0,'2013-07-06 12:44:31',NULL,NULL),(66169,'78520','S','Kennedy Shores','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(21116,'22081','S','Northern Virginia','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.873376,-77.235978,0,'2013-07-06 12:44:31',NULL,NULL),(34088,'38161','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.136604,-89.860771,0,'2013-07-06 12:44:32',NULL,NULL),(27662,'30326','S','Brookhaven','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.852137,-84.360463,0,'2013-07-06 12:44:31',NULL,NULL),(4895,'04050','S','Long Island','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.688835,-70.158644,0,'2013-07-06 12:44:30',NULL,NULL),(24679,'27410','S','Guilford','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098395,-79.885035,0,'2013-07-06 12:44:31',NULL,NULL),(38810,'44072','S','Novelty','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.472300,-81.335220,0,'2013-07-06 12:44:32',NULL,NULL),(66225,'78563','S','Linn','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.581920,-98.171520,0,'2013-07-06 12:44:34',NULL,NULL),(1777,'00780','S','Villas Del Turey','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(5707,'04985','S','Indian Stream Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(9128,'09173','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7674,'07095','S','Woodbridge','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.558215,-74.287244,0,'2013-07-06 12:44:30',NULL,NULL),(74006,'92113','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.697656,-117.117688,0,'2013-07-06 12:44:34',NULL,NULL),(70270,'84526','S','Helper','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(50020,'57401','S','Aberdeen','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.464854,-98.492300,0,'2013-07-06 12:44:33',NULL,NULL),(31981,'35218','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.504425,-86.894499,0,'2013-07-06 12:44:32',NULL,NULL),(47439,'54723','S','Bay City','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.588796,-92.453380,0,'2013-07-06 12:44:32',NULL,NULL),(39044,'44181','P','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.461380,-81.786910,0,'2013-07-06 12:44:32',NULL,NULL),(40447,'45732','S','Wrightstown','N','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.498216,-82.085766,0,'2013-07-06 12:44:32',NULL,NULL),(72823,'89821','S','Crescent Vly','A','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.580000,-116.480000,0,'2013-07-06 12:44:34',NULL,NULL),(4765,'03855','S','New Durham','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.440508,-71.149994,0,'2013-07-06 12:44:30',NULL,NULL),(34291,'38502','P','Cookeville','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.161052,-85.499438,0,'2013-07-06 12:44:32',NULL,NULL),(33618,'37659','S','Jonesborough','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.272018,-82.487968,0,'2013-07-06 12:44:32',NULL,NULL),(27063,'29687','S','Taylors','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.933851,-82.317958,0,'2013-07-06 12:44:31',NULL,NULL),(22834,'24515','U','Thomas Rd Bapt Church Brm','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.349450,-79.157075,0,'2013-07-06 12:44:31',NULL,NULL),(68344,'81129','P','Conejos','D','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174976,-105.940061,0,'2013-07-06 12:44:34',NULL,NULL),(60313,'71456','S','Cane River','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.638660,-92.997060,0,'2013-07-06 12:44:33',NULL,NULL),(44324,'49749','S','Indian River','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.425299,-84.588537,0,'2013-07-06 12:44:32',NULL,NULL),(63229,'75461','P','Paris','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.661821,-95.552451,0,'2013-07-06 12:44:33',NULL,NULL),(21242,'22242','U','Navy Sea Systems Command','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856291,-77.050893,0,'2013-07-06 12:44:31',NULL,NULL),(47160,'54470','S','Rib Lake','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.320557,-90.194188,0,'2013-07-06 12:44:32',NULL,NULL),(11247,'11758','S','North Massapequa','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.686884,-73.469397,0,'2013-07-06 12:44:30',NULL,NULL),(9418,'10002','S','Knickerbocker','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(39787,'45132','P','Highland','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.346947,-83.602314,0,'2013-07-06 12:44:32',NULL,NULL),(69235,'83415','U','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.491978,-112.033059,0,'2013-07-06 12:44:34',NULL,NULL),(79508,'98922','S','Suncadia','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.163120,-120.849600,0,'2013-07-06 12:44:34',NULL,NULL),(40333,'45503','S','Springfield','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.952811,-83.780216,0,'2013-07-06 12:44:32',NULL,NULL),(16407,'17224','S','Cowans Gap','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(1245,'00729','S','Qtas de Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(63506,'75711','P','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.393615,-95.409413,0,'2013-07-06 12:44:33',NULL,NULL),(56475,'65322','S','Blackwater','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.979071,-92.993099,0,'2013-07-06 12:44:33',NULL,NULL),(50315,'57718','S','Summerset','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.156289,-103.325645,0,'2013-07-06 12:44:33',NULL,NULL),(23952,'26282','S','Monterville','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.512528,-80.162591,0,'2013-07-06 12:44:31',NULL,NULL),(5345,'04607','S','Gouldsboro','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.472300,-68.086980,0,'2013-07-06 12:44:30',NULL,NULL),(65011,'77302','S','Grangerland','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.244988,-95.403556,0,'2013-07-06 12:44:34',NULL,NULL),(4275,'02889','S','Warwick','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.709084,-71.386673,0,'2013-07-06 12:44:30',NULL,NULL),(62961,'75120','P','Ennis','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.354195,-96.625920,0,'2013-07-06 12:44:33',NULL,NULL),(59853,'71254','S','Millikin','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(76550,'95666','S','Pioneer','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.458140,-120.520020,0,'2013-07-06 12:44:34',NULL,NULL),(6330,'05665','P','N Hyde Park','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.671791,-72.598969,0,'2013-07-06 12:44:30',NULL,NULL),(65463,'77624','S','Hillister','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.683460,-94.411035,0,'2013-07-06 12:44:34',NULL,NULL),(35388,'39456','S','Avent','N','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.073880,-88.816080,0,'2013-07-06 12:44:32',NULL,NULL),(44404,'49820','S','Curtis','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.198098,-85.820506,0,'2013-07-06 12:44:32',NULL,NULL),(61292,'72412','S','Beech Grove','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.207876,-90.621506,0,'2013-07-06 12:44:33',NULL,NULL),(74796,'93199','U','Goleta','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.489743,-120.039532,0,'2013-07-06 12:44:34',NULL,NULL),(23249,'25119','S','Kincaid','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.031523,-81.263388,0,'2013-07-06 12:44:31',NULL,NULL),(9730,'10087','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(76437,'95603','S','Clipper Gap','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.921820,-121.098120,0,'2013-07-06 12:44:34',NULL,NULL),(10771,'11364','S','Oakland Gdns','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(39604,'44875','S','Sharon Township','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(49655,'56999','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8872','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(28831,'32082','S','Ponte Vedra Beach','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173444,-81.395785,0,'2013-07-06 12:44:32',NULL,NULL),(28201,'31023','S','Eastman','D','Dodge','13091','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.196771,-83.180079,0,'2013-07-06 12:44:31',NULL,NULL),(52600,'61020','S','Davis Jct','A','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.103439,-89.090160,0,'2013-07-06 12:44:33',NULL,NULL),(41432,'46855','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.068529,-85.167398,0,'2013-07-06 12:44:32',NULL,NULL),(23832,'26105','S','Parkersburg','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.325039,-81.542603,0,'2013-07-06 12:44:31',NULL,NULL),(62696,'74734','S','Eagletown','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.072256,-94.559329,0,'2013-07-06 12:44:33',NULL,NULL),(53034,'61475','S','Sciota','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.587814,-90.730089,0,'2013-07-06 12:44:33',NULL,NULL),(78578,'98168','S','Tukwila','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.490093,-122.291541,0,'2013-07-06 12:44:34',NULL,NULL),(5320,'04571','S','Trevett','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.900265,-69.676925,0,'2013-07-06 12:44:30',NULL,NULL),(33670,'37729','S','Duff','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.426894,-83.993190,0,'2013-07-06 12:44:32',NULL,NULL),(66818,'79087','S','Texline','D','Dallam','48111','Texas','TX','48','0000','806','Central',-6.0,'Y',36.377897,-103.020570,0,'2013-07-06 12:44:34',NULL,NULL),(62975,'75138','P','Duncanville','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.674151,-96.916724,0,'2013-07-06 12:44:33',NULL,NULL),(35333,'39428','S','Williamsburg','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(73846,'91793','P','West Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.067473,-117.927759,0,'2013-07-06 12:44:34',NULL,NULL),(41242,'46742','S','Circle Park','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(4802,'03883','S','South Tamworth','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.839632,-71.313989,0,'2013-07-06 12:44:30',NULL,NULL),(36148,'40241','S','Creekside','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(32914,'36549','S','Lillian','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.383906,-87.461113,0,'2013-07-06 12:44:32',NULL,NULL),(46942,'54165','S','Freedom','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.500193,-88.301344,0,'2013-07-06 12:44:32',NULL,NULL),(57890,'67637','S','Ellis','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.938253,-99.562205,0,'2013-07-06 12:44:33',NULL,NULL),(65942,'78257','S','Shavano Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.656582,-98.617388,0,'2013-07-06 12:44:34',NULL,NULL),(65969,'78289','U','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.532254,-98.412276,0,'2013-07-06 12:44:34',NULL,NULL),(69494,'83703','S','Garden City','A','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.627724,-116.263707,0,'2013-07-06 12:44:34',NULL,NULL),(73332,'90846','U','Boeing','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.825962,-118.120925,0,'2013-07-06 12:44:34',NULL,NULL),(74958,'93426','S','Bradley','D','Monterey','06053','California','CA','06','7120','805','Pacific',-8.0,'Y',35.755566,-120.978715,0,'2013-07-06 12:44:34',NULL,NULL),(79287,'98581','S','Ryderwood','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.376684,-123.045515,0,'2013-07-06 12:44:34',NULL,NULL),(9047,'08886','S','Stewartsville','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.693256,-75.111261,0,'2013-07-06 12:44:30',NULL,NULL),(66032,'78363','S','Ricardo','N','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.514425,-97.860850,0,'2013-07-06 12:44:34',NULL,NULL),(35875,'39852','P','Fowlstown','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.877745,-84.584575,0,'2013-07-06 12:44:32',NULL,NULL),(17246,'17837','S','Mazeppa','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(76777,'95938','S','Durham','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.639246,-121.782939,0,'2013-07-06 12:44:34',NULL,NULL),(19657,'20303','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.920577,-76.994500,0,'2013-07-06 12:44:31',NULL,NULL),(12771,'13211','S','Mdale','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.098535,-76.132190,0,'2013-07-06 12:44:30',NULL,NULL),(5088,'04336','U','Augusta','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.334800,-69.742850,0,'2013-07-06 12:44:30',NULL,NULL),(3752,'02171','S','Quincy','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(7425,'06817','U','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.396437,-73.456032,0,'2013-07-06 12:44:30',NULL,NULL),(17228,'17832','P','Marion Heights','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.806027,-76.461774,0,'2013-07-06 12:44:31',NULL,NULL),(16316,'17120','U','State of Pennsylvania','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.267283,-76.881635,0,'2013-07-06 12:44:31',NULL,NULL),(16097,'17052','S','Barneytown','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(6065,'05444','S','Cloverdale','N','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(6037,'05406','P','Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487168,-73.226267,0,'2013-07-06 12:44:30',NULL,NULL),(79614,'99114','S','Colville','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.588567,-117.838533,0,'2013-07-06 12:44:34',NULL,NULL),(35796,'39752','S','Sherwood','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.539394,-89.135634,0,'2013-07-06 12:44:32',NULL,NULL),(4709,'03818','S','Albany','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.925298,-71.134643,0,'2013-07-06 12:44:30',NULL,NULL),(27831,'30415','S','Denmark','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(27264,'29936','S','Mitchellville','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481598,-80.984342,0,'2013-07-06 12:44:31',NULL,NULL),(65783,'78116','S','Gillett','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',29.076588,-97.791088,0,'2013-07-06 12:44:34',NULL,NULL),(75971,'95060','S','Paradise Park','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.989018,-122.057824,0,'2013-07-06 12:44:34',NULL,NULL),(73496,'91329','U','J B Lansing Co','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.246037,-118.531914,0,'2013-07-06 12:44:34',NULL,NULL),(69952,'84117','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(42842,'48071','S','Madison Hts','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.504258,-83.104966,0,'2013-07-06 12:44:32',NULL,NULL),(19725,'20395','U','Naval Intelligence Support C','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.859014,-76.975556,0,'2013-07-06 12:44:31',NULL,NULL),(14372,'15026','S','Clinton','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.515445,-80.354016,0,'2013-07-06 12:44:31',NULL,NULL),(35777,'39744','S','Tomnolen','A','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(7786,'07424','S','Little Falls','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.887151,-74.218789,0,'2013-07-06 12:44:30',NULL,NULL),(38448,'43605','S','Northwood','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651460,-83.508660,0,'2013-07-06 12:44:32',NULL,NULL),(14293,'14874','S','Pulteney','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.531331,-77.171206,0,'2013-07-06 12:44:31',NULL,NULL),(49666,'57005','S','Rowena','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.587111,-96.580716,0,'2013-07-06 12:44:33',NULL,NULL),(73385,'91105','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.137436,-118.167057,0,'2013-07-06 12:44:34',NULL,NULL),(43345,'48381','S','Milford','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.574828,-83.594968,0,'2013-07-06 12:44:32',NULL,NULL),(19407,'20077','U','Washington Brm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.919481,-76.994663,0,'2013-07-06 12:44:31',NULL,NULL),(19262,'19950','S','Farmington','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.807972,-75.590786,0,'2013-07-06 12:44:31',NULL,NULL),(49421,'56630','S','Hornet','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(25042,'27909','S','Elizabeth City','D','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.295010,-76.233334,0,'2013-07-06 12:44:31',NULL,NULL),(17519,'17967','S','Brandonville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.849233,-76.231076,0,'2013-07-06 12:44:31',NULL,NULL),(17030,'17745','S','Sunset Pines','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(76473,'95621','S','Citrus Hts','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.697816,-121.311197,0,'2013-07-06 12:44:34',NULL,NULL),(66231,'78566','S','Bayview','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.085000,-97.461600,0,'2013-07-06 12:44:34',NULL,NULL),(60828,'72036','S','Maberry','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.003283,-91.250233,0,'2013-07-06 12:44:33',NULL,NULL),(63409,'75652','S','New Salem','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(4379,'03087','S','Windham','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.801406,-71.303561,0,'2013-07-06 12:44:30',NULL,NULL),(885,'00704','S','Est de Trinitaria','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(19211,'19891','U','Bank of America','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.682268,-75.693124,0,'2013-07-06 12:44:31',NULL,NULL),(43028,'48173','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(10621,'11050','S','Pr Wshngtn','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(22341,'23875','S','Prince George','D','Prince George','51149','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.216467,-77.241927,0,'2013-07-06 12:44:31',NULL,NULL),(22648,'24263','S','Jonesville','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.687405,-83.110200,0,'2013-07-06 12:44:31',NULL,NULL),(43968,'49317','P','Cannonsburg','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.130587,-85.482425,0,'2013-07-06 12:44:32',NULL,NULL),(77938,'97339','P','Corvallis','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.561601,-123.268633,0,'2013-07-06 12:44:34',NULL,NULL),(43598,'48762','S','Spruce','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.793554,-83.519384,0,'2013-07-06 12:44:32',NULL,NULL),(7456,'06858','U','Setan Industries','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.130471,-73.440439,0,'2013-07-06 12:44:30',NULL,NULL),(34874,'38941','S','Itta Bena','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(18265,'19007','S','Bristol','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.111586,-74.861944,0,'2013-07-06 12:44:31',NULL,NULL),(73617,'91403','S','Sherman Oaks','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.148353,-118.461005,0,'2013-07-06 12:44:34',NULL,NULL),(75543,'94234','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586063,-121.494453,0,'2013-07-06 12:44:34',NULL,NULL),(10139,'10269','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.701869,-74.010178,0,'2013-07-06 12:44:30',NULL,NULL),(40417,'45688','S','Waterloo','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.686389,-82.457135,0,'2013-07-06 12:44:32',NULL,NULL),(19315,'20015','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.963203,-77.065176,0,'2013-07-06 12:44:31',NULL,NULL),(61114,'72149','U','Searcy','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.247481,-91.726679,0,'2013-07-06 12:44:33',NULL,NULL),(57620,'67133','S','Rose Hill','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.574951,-97.131651,0,'2013-07-06 12:44:33',NULL,NULL),(71375,'87002','S','Pueblitos','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.656448,-106.759548,0,'2013-07-06 12:44:34',NULL,NULL),(76439,'95603','S','Ophir','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.921820,-121.098120,0,'2013-07-06 12:44:34',NULL,NULL),(15140,'15851','S','Reynoldsville','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.095215,-78.886043,0,'2013-07-06 12:44:31',NULL,NULL),(42211,'47553','S','Reeve','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(25448,'28320','S','Bladenboro','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.529407,-78.793874,0,'2013-07-06 12:44:31',NULL,NULL),(27422,'30103','S','Adairsville','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.349640,-84.914492,0,'2013-07-06 12:44:31',NULL,NULL),(32143,'35460','S','Epes','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.711667,-88.238889,0,'2013-07-06 12:44:32',NULL,NULL),(45385,'51026','S','Hornick','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.349080,-96.065280,0,'2013-07-06 12:44:32',NULL,NULL),(49200,'56450','S','Garrison','D','Crow Wing','27035','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.240872,-93.936433,0,'2013-07-06 12:44:33',NULL,NULL),(65336,'77520','S','Bayway','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(70651,'85192','S','Dudleyville','A','Gila','04007','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.915624,-110.721518,0,'2013-07-06 12:44:34',NULL,NULL),(72964,'90045','S','Bradley International','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.957494,-118.397884,0,'2013-07-06 12:44:34',NULL,NULL),(77463,'96815','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.278625,-157.820909,0,'2013-07-06 12:44:34',NULL,NULL),(65809,'78133','S','Startzville','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.880900,-98.215200,0,'2013-07-06 12:44:34',NULL,NULL),(38720,'44022','S','Moreland Hls','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(26960,'29608','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.901963,-82.409599,0,'2013-07-06 12:44:31',NULL,NULL),(79198,'98532','S','Guerrier','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(43286,'48334','S','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505423,-83.351825,0,'2013-07-06 12:44:32',NULL,NULL),(55848,'64165','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.325453,-94.562798,0,'2013-07-06 12:44:33',NULL,NULL),(9420,'10002','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(64542,'76648','S','Hubbard','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.846845,-96.799912,0,'2013-07-06 12:44:34',NULL,NULL),(66573,'78741','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.234123,-97.718296,0,'2013-07-06 12:44:34',NULL,NULL),(20290,'20799','U','Capitol Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.881409,-76.856119,0,'2013-07-06 12:44:31',NULL,NULL),(18144,'18837','S','Rome','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.870052,-76.297717,0,'2013-07-06 12:44:31',NULL,NULL),(39377,'44644','S','Oneida','N','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.685014,-81.195285,0,'2013-07-06 12:44:32',NULL,NULL),(37855,'42501','S','Walnut Grove','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(35522,'39535','P','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.415255,-88.930352,0,'2013-07-06 12:44:32',NULL,NULL),(23113,'24946','S','Hillsboro','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.132820,-80.243820,0,'2013-07-06 12:44:31',NULL,NULL),(33966,'38107','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.168302,-90.028300,0,'2013-07-06 12:44:32',NULL,NULL),(33393,'37220','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.067492,-86.781198,0,'2013-07-06 12:44:32',NULL,NULL),(29706,'32940','S','Viera','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.225810,-80.688308,0,'2013-07-06 12:44:32',NULL,NULL),(32146,'35462','S','Eutaw','D','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.837265,-87.890002,0,'2013-07-06 12:44:32',NULL,NULL),(51988,'60156','S','Lake in the Hills','D','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.180245,-88.331470,0,'2013-07-06 12:44:33',NULL,NULL),(54047,'62468','S','Bradbury','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.269624,-88.244943,0,'2013-07-06 12:44:33',NULL,NULL),(56299,'65084','S','Marvin','N','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.432613,-92.844180,0,'2013-07-06 12:44:33',NULL,NULL),(47161,'54471','S','Ringle','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.896444,-89.426641,0,'2013-07-06 12:44:32',NULL,NULL),(41200,'46725','S','Columbia City','D','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(8896,'08732','P','Island Heights','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.994447,-74.119283,0,'2013-07-06 12:44:30',NULL,NULL),(12963,'13363','S','West Lee','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.314420,-75.512100,0,'2013-07-06 12:44:30',NULL,NULL),(18669,'19181','U','Colonial Penn Group','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951446,-75.147020,0,'2013-07-06 12:44:31',NULL,NULL),(44506,'49931','S','Houghton','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.115232,-88.563407,0,'2013-07-06 12:44:32',NULL,NULL),(43036,'48174','S','Brownstown TWP','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.215215,-83.344726,0,'2013-07-06 12:44:32',NULL,NULL),(46105,'52630','S','Hillsboro','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.827784,-91.708242,0,'2013-07-06 12:44:32',NULL,NULL),(46065,'52577','S','Keomah Vlg','A','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.286600,-92.600280,0,'2013-07-06 12:44:32',NULL,NULL),(6865,'06133','P','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753216,-72.704041,0,'2013-07-06 12:44:30',NULL,NULL),(3670,'02125','S','Uphams Corner','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.313703,-71.062976,0,'2013-07-06 12:44:30',NULL,NULL),(15857,'16943','S','Sabinsville','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843054,-77.545629,0,'2013-07-06 12:44:31',NULL,NULL),(7732,'07204','S','Roselle Park','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.663360,-74.269618,0,'2013-07-06 12:44:30',NULL,NULL),(27466,'30141','S','Hiram','D','Paulding','13223','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.869888,-84.768038,0,'2013-07-06 12:44:31',NULL,NULL),(3913,'02458','S','Newtonville','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.352515,-71.190702,0,'2013-07-06 12:44:30',NULL,NULL),(27906,'30477','S','Wadley','D','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.862048,-82.407315,0,'2013-07-06 12:44:31',NULL,NULL),(43033,'48173','S','Rockwood','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(50105,'57476','S','Spottwood','N','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.718766,-98.584758,0,'2013-07-06 12:44:33',NULL,NULL),(28243,'31057','S','Marshallville','D','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.454415,-83.942245,0,'2013-07-06 12:44:31',NULL,NULL),(5528,'04779','S','Sinclair','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.170980,-68.304902,0,'2013-07-06 12:44:30',NULL,NULL),(11598,'12083','S','South Westerlo','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.416705,-74.011373,0,'2013-07-06 12:44:30',NULL,NULL),(10661,'11105','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.778285,-73.910175,0,'2013-07-06 12:44:30',NULL,NULL),(54934,'63111','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.558540,-90.251529,0,'2013-07-06 12:44:33',NULL,NULL),(7937,'07657','S','Morsemere','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.832120,-73.999158,0,'2013-07-06 12:44:30',NULL,NULL),(33640,'37690','S','Telford','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.232998,-82.548390,0,'2013-07-06 12:44:32',NULL,NULL),(27230,'29920','S','Fripp Island','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(70044,'84136','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767474,-111.887633,0,'2013-07-06 12:44:34',NULL,NULL),(1350,'00736','S','Jard de Cayey','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(14081,'14612','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.256923,-77.669136,0,'2013-07-06 12:44:31',NULL,NULL),(45929,'52334','S','South Amana','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.757980,-91.927486,0,'2013-07-06 12:44:32',NULL,NULL),(50970,'58632','S','Golva','D','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.662838,-103.940794,0,'2013-07-06 12:44:33',NULL,NULL),(25570,'28428','S','Carolina Beach','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.037053,-77.901405,0,'2013-07-06 12:44:31',NULL,NULL),(6381,'05701','S','Clementwood','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(34086,'38159','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.148592,-90.054728,0,'2013-07-06 12:44:32',NULL,NULL),(20518,'21088','P','Lineboro','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.717480,-76.830000,0,'2013-07-06 12:44:31',NULL,NULL),(57287,'66610','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.981187,-95.797562,0,'2013-07-06 12:44:33',NULL,NULL),(36996,'41219','S','Flatgap','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(74354,'92411','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.124542,-117.321697,0,'2013-07-06 12:44:34',NULL,NULL),(21028,'21863','S','Snow Hill','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.183588,-75.391585,0,'2013-07-06 12:44:31',NULL,NULL),(2546,'00959','S','Parq de Torrimar','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(27498,'30171','S','Rydal','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.346521,-84.737632,0,'2013-07-06 12:44:31',NULL,NULL),(63330,'75574','S','Bassett','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.487706,-94.579844,0,'2013-07-06 12:44:33',NULL,NULL),(64088,'76155','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.823263,-97.054863,0,'2013-07-06 12:44:34',NULL,NULL),(20525,'21093','S','Lutherville Timonium','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.434940,-76.654860,0,'2013-07-06 12:44:31',NULL,NULL),(34197,'38337','S','Gadsden','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.772006,-88.988408,0,'2013-07-06 12:44:32',NULL,NULL),(67898,'80901','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834608,-104.822550,0,'2013-07-06 12:44:34',NULL,NULL),(49725,'57042','S','Orland','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.008120,-97.113629,0,'2013-07-06 12:44:33',NULL,NULL),(4678,'03785','S','Easton','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.149423,-72.034577,0,'2013-07-06 12:44:30',NULL,NULL),(70556,'85040','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.408851,-112.026341,0,'2013-07-06 12:44:34',NULL,NULL),(27039,'29662','S','Mauldin','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.778801,-82.302512,0,'2013-07-06 12:44:31',NULL,NULL),(24434,'27203','S','Asheboro','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.651040,-79.831620,0,'2013-07-06 12:44:31',NULL,NULL),(62195,'73773','S','Waukomis','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.281331,-97.898034,0,'2013-07-06 12:44:33',NULL,NULL),(57665,'67214','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.702727,-97.318572,0,'2013-07-06 12:44:33',NULL,NULL),(54940,'63114','S','Brecknrdg Hls','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(52406,'60638','S','Clearing','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781649,-87.774356,0,'2013-07-06 12:44:33',NULL,NULL),(21427,'22553','S','Snell','A','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.200620,-77.685420,0,'2013-07-06 12:44:31',NULL,NULL),(38531,'43735','P','East Fultonham','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.853633,-82.122518,0,'2013-07-06 12:44:32',NULL,NULL),(34656,'38776','P','Stoneville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.407570,-90.911217,0,'2013-07-06 12:44:32',NULL,NULL),(32673,'36266','S','Campbells Crossroads','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(73340,'90895','U','Carson','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.839680,-118.259590,0,'2013-07-06 12:44:34',NULL,NULL),(78004,'97411','S','Bandon','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.117384,-124.407217,0,'2013-07-06 12:44:34',NULL,NULL),(80051,'99708','P','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.876268,-147.898163,0,'2013-07-06 12:44:34',NULL,NULL),(26195,'28771','S','Lk Santeetlah','A','Graham','37075','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.346072,-83.874306,0,'2013-07-06 12:44:31',NULL,NULL),(2128,'00924','S','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(71036,'85740','P','Casas Adobes','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.357607,-111.076619,0,'2013-07-06 12:44:34',NULL,NULL),(16932,'17608','P','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.023731,-76.331711,0,'2013-07-06 12:44:31',NULL,NULL),(54349,'62777','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.800049,-89.654254,0,'2013-07-06 12:44:33',NULL,NULL),(44483,'49910','S','Bergland','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.591148,-89.566364,0,'2013-07-06 12:44:32',NULL,NULL),(5029,'04253','S','Livermore','D','Androscoggin','23001','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.416685,-70.198765,0,'2013-07-06 12:44:30',NULL,NULL),(11466,'12010','S','West Glenville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923640,-74.170860,0,'2013-07-06 12:44:30',NULL,NULL),(38044,'43037','S','Martinsburg','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.272989,-82.333037,0,'2013-07-06 12:44:32',NULL,NULL),(65650,'77975','S','Moulton','D','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.568900,-97.085580,0,'2013-07-06 12:44:34',NULL,NULL),(49842,'57233','S','Erwin','D','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.498580,-97.410480,0,'2013-07-06 12:44:33',NULL,NULL),(11685,'12154','S','Easton','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.897909,-73.589565,0,'2013-07-06 12:44:30',NULL,NULL),(39335,'44615','S','New Harrisburg','N','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(65541,'77808','S','Wixon Valley','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.704715,-96.335583,0,'2013-07-06 12:44:34',NULL,NULL),(58962,'70010','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.010121,-90.161717,0,'2013-07-06 12:44:33',NULL,NULL),(72504,'89150','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.127385,-115.216214,0,'2013-07-06 12:44:34',NULL,NULL),(27106,'29726','S','Mc Connells','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.872034,-81.223083,0,'2013-07-06 12:44:31',NULL,NULL),(57765,'67454','S','Kanopolis','D','Ellsworth','20053','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.709641,-98.158302,0,'2013-07-06 12:44:33',NULL,NULL),(65790,'78122','S','Leesville','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.404362,-97.744031,0,'2013-07-06 12:44:34',NULL,NULL),(38023,'43016','S','Dublin','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.127770,-83.096290,0,'2013-07-06 12:44:32',NULL,NULL),(40429,'45701','S','Athens','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.313710,-82.096417,0,'2013-07-06 12:44:32',NULL,NULL),(47977,'55126','S','Shoreview','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(21310,'22405','S','Fredericksburg','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.320601,-77.414651,0,'2013-07-06 12:44:31',NULL,NULL),(64493,'76626','S','Blooming Grove','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.093811,-96.720007,0,'2013-07-06 12:44:34',NULL,NULL),(21979,'23250','S','Rich Int Ap','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(8611,'08242','S','Rio Grande','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.018436,-74.869812,0,'2013-07-06 12:44:30',NULL,NULL),(9037,'08876','S','South Branch','N','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.543740,-74.660040,0,'2013-07-06 12:44:30',NULL,NULL),(74898,'93303','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.552180,-118.919040,0,'2013-07-06 12:44:34',NULL,NULL),(69958,'84118','S','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(2177,'00926','S','Ext Mans de Vilanova','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(62821,'74957','S','Octavia','A','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.481497,-94.582854,0,'2013-07-06 12:44:33',NULL,NULL),(31441,'34275','S','North Venice','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.136587,-82.450143,0,'2013-07-06 12:44:32',NULL,NULL),(48610,'55790','S','Kugler','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.795868,-92.353874,0,'2013-07-06 12:44:33',NULL,NULL),(76726,'95894','U','Ca Dept Motor Vehicle','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.556683,-121.498069,0,'2013-07-06 12:44:34',NULL,NULL),(27018,'29645','S','Ora','N','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.595760,-82.143840,0,'2013-07-06 12:44:31',NULL,NULL),(31189,'33932','P','Ft Myers Beach','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.449073,-81.932449,0,'2013-07-06 12:44:32',NULL,NULL),(42090,'47459','S','Solsberry','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.123646,-86.753712,0,'2013-07-06 12:44:32',NULL,NULL),(71673,'87506','S','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.585314,-106.024436,0,'2013-07-06 12:44:34',NULL,NULL),(53705,'62234','S','Collinsville','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.687371,-89.983306,0,'2013-07-06 12:44:33',NULL,NULL),(53640,'62202','P','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.616644,-90.160951,0,'2013-07-06 12:44:33',NULL,NULL),(46820,'54010','P','E Ellsworth','A','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.730383,-92.468244,0,'2013-07-06 12:44:32',NULL,NULL),(40549,'45851','S','Haviland','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.019254,-84.580420,0,'2013-07-06 12:44:32',NULL,NULL),(40786,'46165','S','North Salem','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.855141,-86.646545,0,'2013-07-06 12:44:32',NULL,NULL),(15664,'16802','S','State College','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.870717,-77.834150,0,'2013-07-06 12:44:31',NULL,NULL),(12580,'13069','S','Granby Center','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.296180,-76.403520,0,'2013-07-06 12:44:30',NULL,NULL),(45006,'50450','S','Lake Mills','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.421066,-93.532888,0,'2013-07-06 12:44:32',NULL,NULL),(34632,'38756','S','Rexburg','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(61016,'72115','P','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.766295,-92.259072,0,'2013-07-06 12:44:33',NULL,NULL),(49146,'56376','P','Saint Martin','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.498646,-94.663967,0,'2013-07-06 12:44:33',NULL,NULL),(34271,'38469','S','Loretto','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.079612,-87.436064,0,'2013-07-06 12:44:32',NULL,NULL),(76949,'96032','S','Fort Jones','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.606816,-122.882247,0,'2013-07-06 12:44:34',NULL,NULL),(69117,'83274','S','Woodville','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.379837,-112.124740,0,'2013-07-06 12:44:34',NULL,NULL),(66821,'79091','P','Umbarger','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',34.887430,-101.906946,0,'2013-07-06 12:44:34',NULL,NULL),(50911,'58554','S','St Anthony','N','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.828248,-100.892053,0,'2013-07-06 12:44:33',NULL,NULL),(72985,'90054','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.059368,-118.236094,0,'2013-07-06 12:44:34',NULL,NULL),(75309,'93747','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.803212,-119.679921,0,'2013-07-06 12:44:34',NULL,NULL),(12791,'13219','S','Taunton','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040139,-76.217020,0,'2013-07-06 12:44:30',NULL,NULL),(5422,'04668','S','Princeton','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.226109,-67.563119,0,'2013-07-06 12:44:30',NULL,NULL),(10800,'11372','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.749542,-73.883319,0,'2013-07-06 12:44:30',NULL,NULL),(24255,'26808','S','High View','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.212405,-78.435527,0,'2013-07-06 12:44:31',NULL,NULL),(17601,'18040','S','Forks Twp','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.719000,-75.220260,0,'2013-07-06 12:44:31',NULL,NULL),(64182,'76233','S','Collinsville','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.556066,-96.910921,0,'2013-07-06 12:44:34',NULL,NULL),(20234,'20776','S','Harwood','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.869837,-76.624179,0,'2013-07-06 12:44:31',NULL,NULL),(53534,'62032','S','South Fillmore','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.103643,-89.305669,0,'2013-07-06 12:44:33',NULL,NULL),(17879,'18441','S','Lenoxville','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.665200,-75.643680,0,'2013-07-06 12:44:31',NULL,NULL),(35817,'39762','P','Miss State','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(38653,'43939','P','Mt Pleasant','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.176383,-80.800676,0,'2013-07-06 12:44:32',NULL,NULL),(73386,'91106','S','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.142301,-118.125711,0,'2013-07-06 12:44:34',NULL,NULL),(2023,'00917','S','Bda Buena Vista','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(14375,'15030','S','Creighton','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.584756,-79.779785,0,'2013-07-06 12:44:31',NULL,NULL),(65152,'77391','P','Klein','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.021537,-95.569341,0,'2013-07-06 12:44:34',NULL,NULL),(55594,'63936','S','Dudley','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.818178,-90.132212,0,'2013-07-06 12:44:33',NULL,NULL),(46270,'53024','S','Grafton','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.326560,-87.930502,0,'2013-07-06 12:44:32',NULL,NULL),(43341,'48376','P','Novi','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.488585,-83.476005,0,'2013-07-06 12:44:32',NULL,NULL),(5569,'04862','S','Union','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.260518,-69.256594,0,'2013-07-06 12:44:30',NULL,NULL),(71605,'87325','S','Two Gray Hills','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.862100,-108.762199,0,'2013-07-06 12:44:34',NULL,NULL),(75495,'94129','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.795400,-122.463998,0,'2013-07-06 12:44:34',NULL,NULL),(64686,'76836','S','Doole','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.415361,-99.551339,0,'2013-07-06 12:44:34',NULL,NULL),(12202,'12785','P','Westbrookville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.495716,-74.561461,0,'2013-07-06 12:44:30',NULL,NULL),(11064,'11581','S','N Woodmere','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655430,-73.712757,0,'2013-07-06 12:44:30',NULL,NULL),(33932,'38061','S','Pocahontas','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.028862,-88.816731,0,'2013-07-06 12:44:32',NULL,NULL),(71914,'87821','S','Horse Springs','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.918300,-108.055080,0,'2013-07-06 12:44:34',NULL,NULL),(56588,'65552','S','Palace','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.494347,-92.183812,0,'2013-07-06 12:44:33',NULL,NULL),(50858,'58496','S','Woodworth','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.141743,-99.300422,0,'2013-07-06 12:44:33',NULL,NULL),(77324,'96707','S','Kalaeloa','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333426,-158.094993,0,'2013-07-06 12:44:34',NULL,NULL),(61444,'72602','P','Harrison','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.226960,-93.115091,0,'2013-07-06 12:44:33',NULL,NULL),(14262,'14841','S','Hector','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.498593,-76.873441,0,'2013-07-06 12:44:31',NULL,NULL),(19902,'20543','U','Us Supreme Court','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889169,-77.008796,0,'2013-07-06 12:44:31',NULL,NULL),(15224,'16023','S','Marwood','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.778889,-79.773333,0,'2013-07-06 12:44:31',NULL,NULL),(47609,'54880','S','Superior','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.705941,-92.074691,0,'2013-07-06 12:44:33',NULL,NULL),(48210,'55409','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.927946,-93.288078,0,'2013-07-06 12:44:33',NULL,NULL),(71824,'87575','S','Nutrias','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(72243,'88519','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811275,-106.421354,0,'2013-07-06 12:44:34',NULL,NULL),(73196,'90509','P','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.844351,-118.328784,0,'2013-07-06 12:44:34',NULL,NULL),(13070,'13452','S','Scotchbush','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(70541,'85025','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.454805,-112.073543,0,'2013-07-06 12:44:34',NULL,NULL),(28722,'31904','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.520024,-84.981542,0,'2013-07-06 12:44:32',NULL,NULL),(53297,'61732','S','Danvers','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.529284,-89.178783,0,'2013-07-06 12:44:33',NULL,NULL),(33487,'37345','S','Huntland','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.052997,-86.271617,0,'2013-07-06 12:44:32',NULL,NULL),(25626,'28462','S','Holden Beach','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.972720,-78.289860,0,'2013-07-06 12:44:31',NULL,NULL),(11781,'12206','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.672970,-73.776010,0,'2013-07-06 12:44:30',NULL,NULL),(68970,'83101','S','Fontenelle','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.796146,-110.539940,0,'2013-07-06 12:44:34',NULL,NULL),(79504,'98920','P','Brownstown','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.405389,-120.607498,0,'2013-07-06 12:44:34',NULL,NULL),(14454,'15106','S','Heidelberg','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405231,-80.093696,0,'2013-07-06 12:44:31',NULL,NULL),(41892,'47371','S','Brice','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(61514,'72654','P','Mtn Home','N','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.336533,-92.384535,0,'2013-07-06 12:44:33',NULL,NULL),(71178,'86043','P','Mishongnovi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.805000,-110.491944,0,'2013-07-06 12:44:34',NULL,NULL),(52804,'61277','S','Prophetstown','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(39034,'44146','S','Bedford Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(68183,'81022','S','Broadacre','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.179817,-104.390761,0,'2013-07-06 12:44:34',NULL,NULL),(67450,'80212','S','Lakeside','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.772488,-105.051110,0,'2013-07-06 12:44:34',NULL,NULL),(46857,'54024','S','Saint Croix Falls','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.412894,-92.633615,0,'2013-07-06 12:44:32',NULL,NULL),(65556,'77841','P','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.572808,-96.326388,0,'2013-07-06 12:44:34',NULL,NULL),(61924,'73152','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.518680,-97.505079,0,'2013-07-06 12:44:33',NULL,NULL),(58282,'68407','S','Wabash','N','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.923635,-96.282292,0,'2013-07-06 12:44:33',NULL,NULL),(25101,'27965','S','Poplar Branch','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.263218,-75.883639,0,'2013-07-06 12:44:31',NULL,NULL),(8971,'08820','S','Edison','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.575451,-74.364495,0,'2013-07-06 12:44:30',NULL,NULL),(7992,'07716','S','Atlantic Hlds','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.404595,-74.035623,0,'2013-07-06 12:44:30',NULL,NULL),(63009,'75161','S','Terrell','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.721077,-96.165376,0,'2013-07-06 12:44:33',NULL,NULL),(59696,'71078','S','Stonewall','D','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.314232,-93.777593,0,'2013-07-06 12:44:33',NULL,NULL),(51934,'60122','U','Chase Bank','N','DuPage','17043','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.036725,-88.288337,0,'2013-07-06 12:44:33',NULL,NULL),(50720,'58372','S','Sarles','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.945570,-98.934117,0,'2013-07-06 12:44:33',NULL,NULL),(47386,'54634','S','Hillsboro','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.653481,-90.344014,0,'2013-07-06 12:44:32',NULL,NULL),(42417,'47802','S','Maryland','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(30915,'33708','S','Johns Pass','N','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(33799,'37890','S','White Pine','D','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.061640,-83.260110,0,'2013-07-06 12:44:32',NULL,NULL),(76494,'95634','S','Georgetown','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917770,-120.790653,0,'2013-07-06 12:44:34',NULL,NULL),(77630,'97005','S','Progress','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.488582,-122.804382,0,'2013-07-06 12:44:34',NULL,NULL),(68356,'81133','S','Ft Garland','N','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.413562,-105.393706,0,'2013-07-06 12:44:34',NULL,NULL),(72041,'88061','S','Silver City','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.775733,-108.264777,0,'2013-07-06 12:44:34',NULL,NULL),(48597,'55785','S','Macville','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.877521,-93.682649,0,'2013-07-06 12:44:33',NULL,NULL),(66881,'79233','P','Estelline','D','Hall','48191','Texas','TX','48','0000','806','Central',-6.0,'Y',34.447478,-100.688935,0,'2013-07-06 12:44:34',NULL,NULL),(28697,'31815','S','Lumpkin','D','Stewart','13259','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.052799,-84.794747,0,'2013-07-06 12:44:32',NULL,NULL),(32495,'36061','P','Perote','D','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.991905,-85.751161,0,'2013-07-06 12:44:32',NULL,NULL),(61818,'73107','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483265,-97.577589,0,'2013-07-06 12:44:33',NULL,NULL),(56258,'65061','S','Morrison','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.502518,-91.534868,0,'2013-07-06 12:44:33',NULL,NULL),(57866,'67576','S','St John','N','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.003667,-98.761543,0,'2013-07-06 12:44:33',NULL,NULL),(62825,'74960','S','Stilwell','D','Adair','40001','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.817757,-94.626050,0,'2013-07-06 12:44:33',NULL,NULL),(15882,'17003','S','Harper Tavern','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(28569,'31604','P','Valdosta','D','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.881108,-83.280470,0,'2013-07-06 12:44:32',NULL,NULL),(6021,'05401','S','BURL','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487240,-73.227780,0,'2013-07-06 12:44:30',NULL,NULL),(5746,'05035','S','W Bridgewater','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(11946,'12441','P','Highmount','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.143627,-74.489371,0,'2013-07-06 12:44:30',NULL,NULL),(16051,'17045','S','Oriental','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.574018,-76.985771,0,'2013-07-06 12:44:31',NULL,NULL),(49263,'56481','S','Oylen','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.399714,-95.014769,0,'2013-07-06 12:44:33',NULL,NULL),(35069,'39192','S','West','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.204672,-89.782274,0,'2013-07-06 12:44:32',NULL,NULL),(294,'00646','S','Urb Dorado Country Ests','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(7747,'07306','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.733605,-74.065616,0,'2013-07-06 12:44:30',NULL,NULL),(61900,'73141','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.510127,-97.394891,0,'2013-07-06 12:44:33',NULL,NULL),(48750,'55972','S','Saint Charles','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.967246,-92.063039,0,'2013-07-06 12:44:33',NULL,NULL),(72941,'90037','S','Green','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.000915,-118.288342,0,'2013-07-06 12:44:34',NULL,NULL),(77870,'97242','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.483262,-122.638430,0,'2013-07-06 12:44:34',NULL,NULL),(13426,'13756','S','Peakville','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.023889,-75.113056,0,'2013-07-06 12:44:31',NULL,NULL),(70016,'84127','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700486,-111.945715,0,'2013-07-06 12:44:34',NULL,NULL),(62442,'74182','U','Bok Mail Service','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.154100,-95.994899,0,'2013-07-06 12:44:33',NULL,NULL),(62043,'73523','S','Altus AFB','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.682908,-99.344706,0,'2013-07-06 12:44:33',NULL,NULL),(27110,'29729','S','Lando','A','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.775868,-81.026327,0,'2013-07-06 12:44:31',NULL,NULL),(53108,'61537','S','Saratoga Center','N','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.113512,-89.361700,0,'2013-07-06 12:44:33',NULL,NULL),(35941,'40055','S','Pendleton','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.495040,-85.339571,0,'2013-07-06 12:44:32',NULL,NULL),(74956,'93423','P','Atascadero','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.487398,-120.645262,0,'2013-07-06 12:44:34',NULL,NULL),(31942,'35203','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.515462,-86.821045,0,'2013-07-06 12:44:32',NULL,NULL),(16457,'17241','S','Cobblerville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(39808,'45140','S','Seilcrest Acres','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(4949,'04097','S','N Yarmouth','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.845033,-70.235599,0,'2013-07-06 12:44:30',NULL,NULL),(499,'00674','S','Ext Oneill','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(667,'00683','S','Urb Borinquen','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(41145,'46699','U','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.671706,-86.252194,0,'2013-07-06 12:44:32',NULL,NULL),(21809,'23092','S','Locust Hill','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.587858,-76.496919,0,'2013-07-06 12:44:31',NULL,NULL),(62805,'74940','S','Howe','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.927980,-94.699886,0,'2013-07-06 12:44:33',NULL,NULL),(61432,'72578','S','Sturkie','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.465622,-91.990164,0,'2013-07-06 12:44:33',NULL,NULL),(33761,'37860','S','Russellville','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.246308,-83.195495,0,'2013-07-06 12:44:32',NULL,NULL),(36482,'40771','S','Woodbine','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.920970,-84.080605,0,'2013-07-06 12:44:32',NULL,NULL),(37023,'41240','S','Riceville','N','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(42863,'48081','S','Saint Clair Shrs','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(17237,'17837','S','College Park','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(51290,'59212','S','Bainville','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.139108,-104.222590,0,'2013-07-06 12:44:33',NULL,NULL),(76786,'95943','S','Glenn','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.593700,-122.052780,0,'2013-07-06 12:44:34',NULL,NULL),(65896,'78233','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.565000,-98.336111,0,'2013-07-06 12:44:34',NULL,NULL),(3079,'01151','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.151001,-72.506454,0,'2013-07-06 12:44:30',NULL,NULL),(7703,'07175','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.735659,-74.171397,0,'2013-07-06 12:44:30',NULL,NULL),(17027,'17745','S','Haneyville','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(68800,'82426','S','Greybull','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.491759,-108.042418,0,'2013-07-06 12:44:34',NULL,NULL),(4008,'02553','P','Monument Beach','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.717679,-70.614258,0,'2013-07-06 12:44:30',NULL,NULL),(61455,'72617','S','Harriet','A','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.031701,-92.357454,0,'2013-07-06 12:44:33',NULL,NULL),(43575,'48739','S','Hale','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.398678,-83.813915,0,'2013-07-06 12:44:32',NULL,NULL),(60783,'72023','S','Cabot','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.964998,-92.015595,0,'2013-07-06 12:44:33',NULL,NULL),(49314,'56544','S','Frazee','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.736683,-95.718421,0,'2013-07-06 12:44:33',NULL,NULL),(30891,'33702','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.844334,-82.643675,0,'2013-07-06 12:44:32',NULL,NULL),(3743,'02169','S','South Quincy','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.240464,-71.014144,0,'2013-07-06 12:44:30',NULL,NULL),(26839,'29501','S','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.182662,-79.782749,0,'2013-07-06 12:44:31',NULL,NULL),(14771,'15344','S','Jefferson','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.918783,-80.058301,0,'2013-07-06 12:44:31',NULL,NULL),(39035,'44146','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(19189,'19807','S','Greenville','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.794880,-75.616740,0,'2013-07-06 12:44:31',NULL,NULL),(71016,'85726','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.204294,-110.943319,0,'2013-07-06 12:44:34',NULL,NULL),(62557,'74445','S','Morris','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.608740,-95.861578,0,'2013-07-06 12:44:33',NULL,NULL),(50345,'57744','S','Folsom','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.838417,-103.190898,0,'2013-07-06 12:44:33',NULL,NULL),(32033,'35243','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(27798,'30388','U','Avon','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.647853,-84.388398,0,'2013-07-06 12:44:31',NULL,NULL),(63916,'76048','S','Granbury','D','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.431238,-97.762143,0,'2013-07-06 12:44:34',NULL,NULL),(7269,'06520','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.308633,-72.925779,0,'2013-07-06 12:44:30',NULL,NULL),(13696,'14056','P','E Pembroke','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.997572,-78.317822,0,'2013-07-06 12:44:31',NULL,NULL),(46859,'54024','S','St Croix Fls','A','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.412894,-92.633615,0,'2013-07-06 12:44:32',NULL,NULL),(72467,'89124','S','Calico Basin','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(78976,'98373','S','Puyallup','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.131712,-122.323280,0,'2013-07-06 12:44:34',NULL,NULL),(46916,'54140','S','Little Chute','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.283758,-88.309465,0,'2013-07-06 12:44:32',NULL,NULL),(32550,'36111','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.337152,-86.267594,0,'2013-07-06 12:44:32',NULL,NULL),(10613,'11042','S','New Hyde Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757711,-73.697796,0,'2013-07-06 12:44:30',NULL,NULL),(12315,'12859','S','Porter Cors','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.173660,-73.889760,0,'2013-07-06 12:44:30',NULL,NULL),(70682,'85250','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.523133,-111.906659,0,'2013-07-06 12:44:34',NULL,NULL),(25232,'28097','S','Locust','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.265418,-80.426782,0,'2013-07-06 12:44:31',NULL,NULL),(18015,'18640','S','Pittston Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(58739,'68949','S','Sheridan','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.440800,-99.370426,0,'2013-07-06 12:44:33',NULL,NULL),(58417,'68648','S','Morse Bluff','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.415490,-96.803662,0,'2013-07-06 12:44:33',NULL,NULL),(34510,'38676','S','Austin','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(42953,'48127','S','Dearborn Heights','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.334650,-83.284212,0,'2013-07-06 12:44:32',NULL,NULL),(64330,'76501','S','Ratibor','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(61431,'72577','S','Sidney','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.984477,-91.639615,0,'2013-07-06 12:44:33',NULL,NULL),(48328,'55449','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.166800,-93.189660,0,'2013-07-06 12:44:33',NULL,NULL),(54189,'62627','S','Panther Creek','A','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.051276,-90.147153,0,'2013-07-06 12:44:33',NULL,NULL),(57027,'66207','S','Prairie Vlg','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(58230,'68347','S','Eagle','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.815516,-96.430676,0,'2013-07-06 12:44:33',NULL,NULL),(59561,'70833','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.407464,-91.142909,0,'2013-07-06 12:44:33',NULL,NULL),(76275,'95423','S','Clearlake Oaks','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.025340,-122.667855,0,'2013-07-06 12:44:34',NULL,NULL),(10824,'11379','S','Middle Village','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715870,-73.882583,0,'2013-07-06 12:44:30',NULL,NULL),(65250,'77461','S','Long Point','N','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.394555,-95.817313,0,'2013-07-06 12:44:34',NULL,NULL),(869,'00698','S','Urb Roosevelt','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(854,'00698','S','Sect La Vega','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(60714,'71953','S','Dallas','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(10316,'10538','S','Larchmont','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.936489,-73.755346,0,'2013-07-06 12:44:30',NULL,NULL),(19465,'20134','P','Purcellville','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.142329,-77.711386,0,'2013-07-06 12:44:31',NULL,NULL),(41686,'47190','S','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.279200,-85.722700,0,'2013-07-06 12:44:32',NULL,NULL),(39056,'44194','U','Key Bank','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.516028,-81.672288,0,'2013-07-06 12:44:32',NULL,NULL),(34104,'38175','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.046145,-89.865973,0,'2013-07-06 12:44:32',NULL,NULL),(59704,'71103','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.491335,-93.773159,0,'2013-07-06 12:44:33',NULL,NULL),(26979,'29616','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.854817,-82.393105,0,'2013-07-06 12:44:31',NULL,NULL),(70800,'85365','S','Ypg','A','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.672337,-114.502398,0,'2013-07-06 12:44:34',NULL,NULL),(28559,'31569','S','Woodbine','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.900325,-81.667732,0,'2013-07-06 12:44:32',NULL,NULL),(31262,'33993','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.713725,-82.026694,0,'2013-07-06 12:44:32',NULL,NULL),(54977,'63123','S','Green Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.543880,-90.318420,0,'2013-07-06 12:44:33',NULL,NULL),(40885,'46241','S','Maywood','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.725953,-86.254730,0,'2013-07-06 12:44:32',NULL,NULL),(46917,'54141','S','Little Suamico','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.643255,-88.035252,0,'2013-07-06 12:44:32',NULL,NULL),(43363,'48401','S','Applegate','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.356418,-82.647034,0,'2013-07-06 12:44:32',NULL,NULL),(42683,'47978','S','Rensselaer','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.939522,-87.153854,0,'2013-07-06 12:44:32',NULL,NULL),(69320,'83467','S','Salmon','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.172897,-113.898929,0,'2013-07-06 12:44:34',NULL,NULL),(8165,'07860','S','Newton','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.036057,-74.764550,0,'2013-07-06 12:44:30',NULL,NULL),(64572,'76664','S','Ben Hur','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.548099,-96.837534,0,'2013-07-06 12:44:34',NULL,NULL),(77392,'96770','P','Maunaloa','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.135794,-157.214695,0,'2013-07-06 12:44:34',NULL,NULL),(58611,'68855','S','Mason City','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.162665,-99.310489,0,'2013-07-06 12:44:33',NULL,NULL),(46952,'54173','S','Suamico','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.639018,-88.035848,0,'2013-07-06 12:44:32',NULL,NULL),(11659,'12137','S','Pattersonville','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.855720,-74.127900,0,'2013-07-06 12:44:30',NULL,NULL),(33074,'36769','S','Yellow Bluff','A','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.949033,-87.557784,0,'2013-07-06 12:44:32',NULL,NULL),(32415,'35971','S','Fyffe','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.506569,-85.904300,0,'2013-07-06 12:44:32',NULL,NULL),(29913,'33055','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.943016,-80.276516,0,'2013-07-06 12:44:32',NULL,NULL),(13483,'13796','S','Laurens','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.543720,-75.140700,0,'2013-07-06 12:44:31',NULL,NULL),(3494,'01844','S','Methuen','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.728753,-71.180274,0,'2013-07-06 12:44:30',NULL,NULL),(51009,'58704','S','Mafb','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.232500,-101.295833,0,'2013-07-06 12:44:33',NULL,NULL),(75781,'94702','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.866632,-122.282429,0,'2013-07-06 12:44:34',NULL,NULL),(67316,'80025','P','ElDorado Sprg','A','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.935729,-105.280038,0,'2013-07-06 12:44:34',NULL,NULL),(27897,'30473','S','Uvalda','D','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.037807,-82.514539,0,'2013-07-06 12:44:31',NULL,NULL),(60533,'71674','S','Yancopin','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.798097,-91.302406,0,'2013-07-06 12:44:33',NULL,NULL),(54321,'62726','U','State Rev 3386','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.805194,-89.652979,0,'2013-07-06 12:44:33',NULL,NULL),(17515,'17964','S','Pitman','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.702567,-76.512376,0,'2013-07-06 12:44:31',NULL,NULL),(41317,'46773','S','Zulu','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(46017,'52542','S','Cantril','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.642819,-92.070389,0,'2013-07-06 12:44:32',NULL,NULL),(41933,'47387','S','Dudley','N','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.829411,-85.270894,0,'2013-07-06 12:44:32',NULL,NULL),(15111,'15777','S','Starford','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.699952,-78.979228,0,'2013-07-06 12:44:31',NULL,NULL),(9985,'10164','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751519,-73.977272,0,'2013-07-06 12:44:30',NULL,NULL),(71113,'86011','U','Nau','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.188945,-111.620766,0,'2013-07-06 12:44:34',NULL,NULL),(5520,'04776','S','Silver Ridge TWP','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.815245,-68.309550,0,'2013-07-06 12:44:30',NULL,NULL),(27544,'30237','P','Jonesboro','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.522896,-84.353002,0,'2013-07-06 12:44:31',NULL,NULL),(34749,'38852','S','Midway','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(38519,'43725','S','Claysville','A','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.027358,-81.593383,0,'2013-07-06 12:44:32',NULL,NULL),(39013,'44141','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.308320,-81.620760,0,'2013-07-06 12:44:32',NULL,NULL),(47397,'54641','P','Mather','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.144423,-90.308515,0,'2013-07-06 12:44:32',NULL,NULL),(49331,'56557','S','Mahnomen','D','Mahnomen','27087','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.324040,-95.929380,0,'2013-07-06 12:44:33',NULL,NULL),(24279,'26865','S','Lehew','A','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.199167,-78.438333,0,'2013-07-06 12:44:31',NULL,NULL),(71934,'87901','S','T Or C','A','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.129932,-107.251636,0,'2013-07-06 12:44:34',NULL,NULL),(55220,'63401','S','Withers Mill','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(24199,'26676','S','Leivasy','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.128092,-80.738271,0,'2013-07-06 12:44:31',NULL,NULL),(8696,'08348','S','Prt Elizabeth','A','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.233423,-75.010390,0,'2013-07-06 12:44:30',NULL,NULL),(4744,'03839','S','Gonic','N','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.265580,-71.010420,0,'2013-07-06 12:44:30',NULL,NULL),(65638,'77964','S','Speaks','A','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(25067,'27937','S','Gates','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.505563,-76.783424,0,'2013-07-06 12:44:31',NULL,NULL),(48991,'56232','S','Dawson','D','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.935077,-96.064883,0,'2013-07-06 12:44:33',NULL,NULL),(37200,'41522','S','Beaver Bottom','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(39436,'44685','S','Uniontown','D','Stark','39151','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.961109,-81.388948,0,'2013-07-06 12:44:32',NULL,NULL),(76546,'95662','S','Ovale','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.684510,-121.225634,0,'2013-07-06 12:44:34',NULL,NULL),(77604,'96941','P','Pohnpei Caroline Islands','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',6.890254,158.209053,0,'2013-07-06 12:44:34',NULL,NULL),(47617,'54896','S','Winter','D','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.842100,-90.907620,0,'2013-07-06 12:44:33',NULL,NULL),(79237,'98552','S','Humptulips','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.196483,-123.942249,0,'2013-07-06 12:44:34',NULL,NULL),(2882,'00987','S','Est del Parque','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(71971,'88013','P','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.313160,-106.777481,0,'2013-07-06 12:44:34',NULL,NULL),(65100,'77364','S','Pointblank','D','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.767519,-95.251998,0,'2013-07-06 12:44:34',NULL,NULL),(52530,'60921','S','Chatsworth','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.752055,-88.291202,0,'2013-07-06 12:44:33',NULL,NULL),(44694,'50131','S','Camp Dodge','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.682602,-93.709577,0,'2013-07-06 12:44:32',NULL,NULL),(32278,'35651','S','Mount Hope','D','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.459229,-87.480038,0,'2013-07-06 12:44:32',NULL,NULL),(29548,'32805','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.531427,-81.407510,0,'2013-07-06 12:44:32',NULL,NULL),(77383,'96761','S','Lahaina','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.920697,-156.678779,0,'2013-07-06 12:44:34',NULL,NULL),(40613,'45898','S','Willshire','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.696324,-84.781616,0,'2013-07-06 12:44:32',NULL,NULL),(16310,'17113','S','Bressler','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.247280,-76.842480,0,'2013-07-06 12:44:31',NULL,NULL),(27865,'30442','S','Birdsville','N','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(55739,'64089','S','Paradise','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.398160,-94.539780,0,'2013-07-06 12:44:33',NULL,NULL),(55165,'63367','S','LSL','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.793015,-90.782477,0,'2013-07-06 12:44:33',NULL,NULL),(48990,'56231','S','Danvers','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.283861,-95.754014,0,'2013-07-06 12:44:33',NULL,NULL),(79436,'98834','S','Methow','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.071087,-120.037904,0,'2013-07-06 12:44:34',NULL,NULL),(7816,'07452','S','Glen Rock','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.966029,-74.123474,0,'2013-07-06 12:44:30',NULL,NULL),(20041,'20646','S','La Plata','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.524678,-76.973630,0,'2013-07-06 12:44:31',NULL,NULL),(68053,'80932','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848511,-104.780034,0,'2013-07-06 12:44:34',NULL,NULL),(12428,'12952','S','Lyon Mountain','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.689167,-73.949444,0,'2013-07-06 12:44:30',NULL,NULL),(52726,'61231','S','Shale City','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(52882,'61348','S','Jonesville','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.291493,-89.048588,0,'2013-07-06 12:44:33',NULL,NULL),(53501,'62013','S','Brussels','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.966280,-90.600120,0,'2013-07-06 12:44:33',NULL,NULL),(29726,'32955','S','Viera','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.313343,-80.723283,0,'2013-07-06 12:44:32',NULL,NULL),(61927,'73153','P','okc','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.335006,-97.492751,0,'2013-07-06 12:44:33',NULL,NULL),(24241,'26757','S','Three Chrs','A','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.344134,-78.758405,0,'2013-07-06 12:44:31',NULL,NULL),(24050,'26421','S','Pullman','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.188873,-80.914366,0,'2013-07-06 12:44:31',NULL,NULL),(29598,'32832','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.403960,-81.170142,0,'2013-07-06 12:44:32',NULL,NULL),(64890,'77078','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.858532,-95.255477,0,'2013-07-06 12:44:34',NULL,NULL),(30831,'33625','S','Carrollwood','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.071279,-82.555434,0,'2013-07-06 12:44:32',NULL,NULL),(38321,'43410','S','Clyde','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.315461,-82.963285,0,'2013-07-06 12:44:32',NULL,NULL),(44907,'50327','S','Des Moines','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.578216,-93.491427,0,'2013-07-06 12:44:32',NULL,NULL),(26605,'29292','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.909357,-81.076717,0,'2013-07-06 12:44:31',NULL,NULL),(45573,'51529','S','Dunlap','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.852301,-95.607663,0,'2013-07-06 12:44:32',NULL,NULL),(37239,'41549','P','Myra','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.293501,-82.590206,0,'2013-07-06 12:44:32',NULL,NULL),(73809,'91756','U','Southern California Gas Co','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.047565,-118.132799,0,'2013-07-06 12:44:34',NULL,NULL),(30414,'33326','S','Bonaventure','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(53175,'61602','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.682781,-89.601876,0,'2013-07-06 12:44:33',NULL,NULL),(42745,'48023','S','Ira Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.688876,-82.669348,0,'2013-07-06 12:44:32',NULL,NULL),(78226,'97801','S','Cayuse','A','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.666259,-118.793800,0,'2013-07-06 12:44:34',NULL,NULL),(28311,'31136','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.720331,-84.525484,0,'2013-07-06 12:44:31',NULL,NULL),(27943,'30535','S','Demorest','D','Habersham','13137','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.589561,-83.578838,0,'2013-07-06 12:44:31',NULL,NULL),(1376,'00737','P','Cayey','D','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.115422,-66.161026,0,'2013-07-06 12:44:30',NULL,NULL),(2065,'00920','S','Urb San Patricio','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(71806,'87566','S','San Juan Pueblo','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(70550,'85034','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.441779,-112.025717,0,'2013-07-06 12:44:34',NULL,NULL),(7631,'07063','S','N Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.609259,-74.453927,0,'2013-07-06 12:44:30',NULL,NULL),(51134,'58802','P','Williston','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.152834,-103.616711,0,'2013-07-06 12:44:33',NULL,NULL),(50563,'58216','S','Bathgate','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.860344,-97.489203,0,'2013-07-06 12:44:33',NULL,NULL),(39477,'44720','S','Canton','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.897320,-81.433440,0,'2013-07-06 12:44:32',NULL,NULL),(4203,'02830','S','Burrillville','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.976597,-71.656277,0,'2013-07-06 12:44:30',NULL,NULL),(23181,'25040','P','Charlton Hgts','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.124629,-81.235798,0,'2013-07-06 12:44:31',NULL,NULL),(57969,'67801','S','Dodge City','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.757785,-100.018943,0,'2013-07-06 12:44:33',NULL,NULL),(52547,'60939','P','Goodwine','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.569005,-87.785909,0,'2013-07-06 12:44:33',NULL,NULL),(34301,'38543','S','Alpine','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.366464,-85.148902,0,'2013-07-06 12:44:32',NULL,NULL),(54721,'62961','P','Mill Creek','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.351655,-89.272492,0,'2013-07-06 12:44:33',NULL,NULL),(78425,'98051','S','Kanaskat','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.362470,-121.896169,0,'2013-07-06 12:44:34',NULL,NULL),(78030,'97430','S','Deadwood','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.151420,-123.712080,0,'2013-07-06 12:44:34',NULL,NULL),(17078,'17760','P','Gleasonton','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.352627,-77.700989,0,'2013-07-06 12:44:31',NULL,NULL),(1549,'00757','S','Villa Retiro Sur','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(67389,'80123','S','Denver','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(61556,'72715','S','The Highlands','N','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.467949,-94.297268,0,'2013-07-06 12:44:33',NULL,NULL),(59990,'71328','S','Barron','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(25311,'28160','S','Spindale','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.357750,-81.925321,0,'2013-07-06 12:44:31',NULL,NULL),(52537,'60929','S','Cullom','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.879928,-88.267031,0,'2013-07-06 12:44:33',NULL,NULL),(19561,'20206','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.844053,-77.116300,0,'2013-07-06 12:44:31',NULL,NULL),(47078,'54432','P','Galloway','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.767380,-89.216040,0,'2013-07-06 12:44:32',NULL,NULL),(33436,'37304','S','Sale Creek','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.382222,-85.108889,0,'2013-07-06 12:44:32',NULL,NULL),(12839,'13315','S','Burlington Flats','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.753480,-75.169620,0,'2013-07-06 12:44:30',NULL,NULL),(13336,'13684','S','South Russell','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.375880,-75.069180,0,'2013-07-06 12:44:30',NULL,NULL),(28451,'31409','P','Hunter AAF','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.022510,-81.128570,0,'2013-07-06 12:44:32',NULL,NULL),(27963,'30554','S','Lula','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.393395,-83.684802,0,'2013-07-06 12:44:31',NULL,NULL),(5673,'04964','P','Adamstown Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.943193,-70.653585,0,'2013-07-06 12:44:30',NULL,NULL),(26527,'29203','S','Crane Forest','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(44052,'49435','S','Marne','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.023977,-85.837519,0,'2013-07-06 12:44:32',NULL,NULL),(17845,'18424','S','Gouldsboro','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(7481,'06901','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.051933,-73.538940,0,'2013-07-06 12:44:30',NULL,NULL),(67045,'79547','S','Rule','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.177322,-99.891093,0,'2013-07-06 12:44:34',NULL,NULL),(20754,'21405','S','Sherwood Frst','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.978333,-76.492500,0,'2013-07-06 12:44:31',NULL,NULL),(29264,'32456','S','Port Saint Joe','D','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.819214,-85.299275,0,'2013-07-06 12:44:32',NULL,NULL),(9726,'10087','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(54943,'63114','S','Saint John','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(20900,'21714','P','Braddock Heights','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.415134,-77.505881,0,'2013-07-06 12:44:31',NULL,NULL),(51071,'58757','S','Mandaree','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.845427,-102.709656,0,'2013-07-06 12:44:33',NULL,NULL),(50498,'58060','S','Milnor','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.256640,-97.434840,0,'2013-07-06 12:44:33',NULL,NULL),(79485,'98901','S','Yakima Firing Center','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606829,-120.465379,0,'2013-07-06 12:44:34',NULL,NULL),(79800,'99359','P','Starbuck','D','Columbia','53013','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.520154,-118.123101,0,'2013-07-06 12:44:34',NULL,NULL),(23297,'25181','S','Seth','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.089680,-81.643862,0,'2013-07-06 12:44:31',NULL,NULL),(59961,'71303','S','Wilshire Park','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.300867,-92.503466,0,'2013-07-06 12:44:33',NULL,NULL),(53573,'62059','P','Lovejoy','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.656184,-90.166082,0,'2013-07-06 12:44:33',NULL,NULL),(12077,'12550','S','Town Branch','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.517480,-74.060220,0,'2013-07-06 12:44:30',NULL,NULL),(26028,'28679','S','Sugar Grove','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273480,-81.876420,0,'2013-07-06 12:44:31',NULL,NULL),(51899,'60101','S','Addison','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.932660,-88.002222,0,'2013-07-06 12:44:33',NULL,NULL),(1109,'00725','S','Urb San Pedro Est','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(51092,'58771','S','Plaza','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.020768,-101.958837,0,'2013-07-06 12:44:33',NULL,NULL),(37973,'42728','S','Casey Creek','A','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.106526,-85.278233,0,'2013-07-06 12:44:32',NULL,NULL),(30702,'33486','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.346508,-80.113393,0,'2013-07-06 12:44:32',NULL,NULL),(68406,'81155','S','Villa Grove','D','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.248665,-106.081758,0,'2013-07-06 12:44:34',NULL,NULL),(21844,'23130','S','Onemo','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.401156,-76.279761,0,'2013-07-06 12:44:31',NULL,NULL),(1399,'00738','S','Urb Garcia Ponce','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(66819,'79088','S','Tulia','D','Swisher','48437','Texas','TX','48','0000','806','Central',-6.0,'Y',34.651640,-101.498380,0,'2013-07-06 12:44:34',NULL,NULL),(65127,'77381','S','Panther Creek','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.168480,-95.489640,0,'2013-07-06 12:44:34',NULL,NULL),(48135,'55361','P','Minnetonka Beach','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.940420,-93.597000,0,'2013-07-06 12:44:33',NULL,NULL),(15191,'15949','S','Robinson','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.414591,-79.139751,0,'2013-07-06 12:44:31',NULL,NULL),(23669,'25832','S','Daniels','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.737399,-81.134572,0,'2013-07-06 12:44:31',NULL,NULL),(62986,'75147','S','Mabank','D','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.319300,-96.118080,0,'2013-07-06 12:44:33',NULL,NULL),(26872,'29546','S','Gresham','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.930000,-79.410000,0,'2013-07-06 12:44:31',NULL,NULL),(13218,'13634','S','Dexter','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(44467,'49886','S','Spalding','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.697002,-87.504571,0,'2013-07-06 12:44:32',NULL,NULL),(70799,'85365','S','Martinez Lake','A','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.672337,-114.502398,0,'2013-07-06 12:44:34',NULL,NULL),(29731,'32960','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.651280,-80.417512,0,'2013-07-06 12:44:32',NULL,NULL),(57551,'67031','S','Conway Springs','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.388963,-97.644705,0,'2013-07-06 12:44:33',NULL,NULL),(46304,'53061','S','New Holstein','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.947588,-88.089299,0,'2013-07-06 12:44:32',NULL,NULL),(73259,'90715','S','Lakewood','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.843382,-118.076802,0,'2013-07-06 12:44:34',NULL,NULL),(6577,'05855','S','North Derby','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(47097,'54440','S','Hatley','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.822844,-89.379647,0,'2013-07-06 12:44:32',NULL,NULL),(45021,'50461','S','Mitchell','A','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.286734,-92.810092,0,'2013-07-06 12:44:32',NULL,NULL),(44575,'50027','S','Barnes City','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.507587,-92.473535,0,'2013-07-06 12:44:32',NULL,NULL),(30473,'33345','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.178308,-80.278398,0,'2013-07-06 12:44:32',NULL,NULL),(366,'00659','S','Urb Costa Norte','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(22701,'24330','S','Stevens Creek','N','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.731230,-81.029471,0,'2013-07-06 12:44:31',NULL,NULL),(22602,'24205','U','Bristol','D','Bristol City','51520','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.613682,-82.170691,0,'2013-07-06 12:44:31',NULL,NULL),(14588,'15221','S','Forest Hills','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(46092,'52620','S','Bonaparte','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.698766,-91.801994,0,'2013-07-06 12:44:32',NULL,NULL),(17618,'18045','S','Palmer TWP','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(44911,'50329','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585933,-93.635208,0,'2013-07-06 12:44:32',NULL,NULL),(43928,'49271','S','Prattville','A','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.835985,-84.461354,0,'2013-07-06 12:44:32',NULL,NULL),(71567,'87301','S','Senator Clarke Field','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(80049,'99706','P','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.833248,-147.880095,0,'2013-07-06 12:44:34',NULL,NULL),(3572,'01961','P','Peabody','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.534558,-70.968238,0,'2013-07-06 12:44:30',NULL,NULL),(48105,'55345','S','Minnetonka','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.921543,-93.482675,0,'2013-07-06 12:44:33',NULL,NULL),(30168,'33173','S','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.701363,-80.360874,0,'2013-07-06 12:44:32',NULL,NULL),(57325,'66711','S','Drywood','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.625557,-94.701799,0,'2013-07-06 12:44:33',NULL,NULL),(14143,'14709','S','Angelica','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.310729,-78.024817,0,'2013-07-06 12:44:31',NULL,NULL),(68690,'82010','U','Cheynne Shared Brm','N','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.103913,-104.783119,0,'2013-07-06 12:44:34',NULL,NULL),(24466,'27237','P','Sanford','A','Lee','37105','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',35.554722,-79.238056,0,'2013-07-06 12:44:31',NULL,NULL),(4636,'03609','S','N Walpole','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.141354,-72.445147,0,'2013-07-06 12:44:30',NULL,NULL),(77669,'97028','S','Government Cp','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.306268,-121.746016,0,'2013-07-06 12:44:34',NULL,NULL),(60314,'71456','S','Natchez','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.638660,-92.997060,0,'2013-07-06 12:44:33',NULL,NULL),(18761,'19352','S','Lincoln Univ','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.769645,-75.890630,0,'2013-07-06 12:44:31',NULL,NULL),(7512,'07001','S','Avenel','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.577272,-74.276173,0,'2013-07-06 12:44:30',NULL,NULL),(12981,'13403','S','Marcy','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.150854,-75.252080,0,'2013-07-06 12:44:30',NULL,NULL),(10919,'11430','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.661453,-73.811830,0,'2013-07-06 12:44:30',NULL,NULL),(31820,'35062','S','Dora','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.730666,-87.005126,0,'2013-07-06 12:44:32',NULL,NULL),(40747,'46135','S','Mt Meridian','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(58067,'68050','S','Prague','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.296249,-96.852961,0,'2013-07-06 12:44:33',NULL,NULL),(60840,'72040','S','Little Dixie','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(9246,'09577','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(66008,'78351','P','Driscoll','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.642001,-97.770569,0,'2013-07-06 12:44:34',NULL,NULL),(60719,'71953','S','Nunley','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(50298,'57701','S','Rockerville','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.080920,-103.172940,0,'2013-07-06 12:44:33',NULL,NULL),(75247,'93657','S','Centerville','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.784020,-119.468700,0,'2013-07-06 12:44:34',NULL,NULL),(7826,'07458','S','Upper Saddle River','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.045460,-74.099880,0,'2013-07-06 12:44:30',NULL,NULL),(71177,'86042','P','Walpi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.967439,-110.430862,0,'2013-07-06 12:44:34',NULL,NULL),(79218,'98541','S','Saginaw','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.010231,-123.411051,0,'2013-07-06 12:44:34',NULL,NULL),(60406,'71638','S','Halley','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(52748,'61243','S','Deer Grove','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.618286,-89.681883,0,'2013-07-06 12:44:33',NULL,NULL),(31238,'33973','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.610303,-81.691774,0,'2013-07-06 12:44:32',NULL,NULL),(35918,'40031','S','La Grange','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.406748,-85.388667,0,'2013-07-06 12:44:32',NULL,NULL),(37693,'42241','P','Hopkinsville','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.867091,-87.489755,0,'2013-07-06 12:44:32',NULL,NULL),(48348,'55479','U','Wells Fargo Bank','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.986463,-93.266403,0,'2013-07-06 12:44:33',NULL,NULL),(50952,'58620','S','Amidon','D','Slope','38087','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.478110,-103.322810,0,'2013-07-06 12:44:33',NULL,NULL),(14597,'15223','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.468740,-79.957200,0,'2013-07-06 12:44:31',NULL,NULL),(55567,'63870','S','Parma','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.612439,-89.818165,0,'2013-07-06 12:44:33',NULL,NULL),(63539,'75762','S','Flint','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.221740,-95.396400,0,'2013-07-06 12:44:33',NULL,NULL),(62664,'74641','S','Kaw','A','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.764350,-96.861771,0,'2013-07-06 12:44:33',NULL,NULL),(23920,'26222','S','Replete','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.700556,-80.464167,0,'2013-07-06 12:44:31',NULL,NULL),(39138,'44274','P','Sharon Center','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.096432,-81.738688,0,'2013-07-06 12:44:32',NULL,NULL),(36921,'41144','S','Oldtown','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.572275,-82.812737,0,'2013-07-06 12:44:32',NULL,NULL),(19825,'20469','U','GSA Consumer Products Info','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895209,-77.041986,0,'2013-07-06 12:44:31',NULL,NULL),(30112,'33160','S','Sunny Isles','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(11739,'12184','S','Chatham Center','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.440700,-73.679640,0,'2013-07-06 12:44:30',NULL,NULL),(67096,'79705','S','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',32.030406,-102.091318,0,'2013-07-06 12:44:34',NULL,NULL),(17232,'17836','S','Leck Kill','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.711436,-76.629823,0,'2013-07-06 12:44:31',NULL,NULL),(48905,'56129','S','Ellsworth','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.520829,-96.019571,0,'2013-07-06 12:44:33',NULL,NULL),(39354,'44627','S','Fredericksbrg','A','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.689496,-81.854261,0,'2013-07-06 12:44:32',NULL,NULL),(39266,'44450','S','Oakfield','N','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.460780,-80.830440,0,'2013-07-06 12:44:32',NULL,NULL),(27199,'29902','S','Laurel Bay','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.447460,-80.708640,0,'2013-07-06 12:44:31',NULL,NULL),(8860,'08650','P','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.137834,-74.627816,0,'2013-07-06 12:44:30',NULL,NULL),(8099,'07764','S','West Long Branch','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.289869,-74.022463,0,'2013-07-06 12:44:30',NULL,NULL),(27873,'30446','S','Newington','D','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.679721,-81.578871,0,'2013-07-06 12:44:31',NULL,NULL),(72867,'90007','S','Dockweiler','A','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.026525,-118.282408,0,'2013-07-06 12:44:34',NULL,NULL),(74069,'92170','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.695868,-117.135590,0,'2013-07-06 12:44:34',NULL,NULL),(61222,'72324','S','Birdeye','A','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.394814,-90.796630,0,'2013-07-06 12:44:33',NULL,NULL),(10609,'11040','S','North Hills','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(22849,'24533','P','Clifford','D','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.635880,-79.062428,0,'2013-07-06 12:44:31',NULL,NULL),(56383,'65233','S','Clarks Fork','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(35927,'40040','S','Mackville','D','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.720885,-85.087388,0,'2013-07-06 12:44:32',NULL,NULL),(42156,'47522','S','Crane Nav Dpt','A','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(15500,'16506','S','Presque Isle','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.072704,-80.153452,0,'2013-07-06 12:44:31',NULL,NULL),(26069,'28694','S','W Jefferson','A','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(16275,'17098','S','Williams','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.578618,-76.628591,0,'2013-07-06 12:44:31',NULL,NULL),(6755,'06088','S','Scantic','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.902833,-72.596403,0,'2013-07-06 12:44:30',NULL,NULL),(1345,'00736','S','Colinas View','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(34416,'38634','P','Holly Spgs','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.772071,-89.440463,0,'2013-07-06 12:44:32',NULL,NULL),(70430,'84734','P','Hanksville','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.322787,-110.693233,0,'2013-07-06 12:44:34',NULL,NULL),(58317,'68443','S','Saint Mary','A','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.462807,-96.379563,0,'2013-07-06 12:44:33',NULL,NULL),(36481,'40769','S','Williamsburg','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.744037,-84.165125,0,'2013-07-06 12:44:32',NULL,NULL),(42266,'47581','S','Hindostan Falls','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(11079,'11690','P','Far Rockaway','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.601071,-73.762108,0,'2013-07-06 12:44:30',NULL,NULL),(20933,'21756','S','Keedysville','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.463189,-77.695659,0,'2013-07-06 12:44:31',NULL,NULL),(65236,'77452','P','Kenney','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',30.046541,-96.319009,0,'2013-07-06 12:44:34',NULL,NULL),(8435,'08080','S','Sewell','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.749340,-75.096660,0,'2013-07-06 12:44:30',NULL,NULL),(54098,'62534','S','Yantisville','A','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.520163,-88.754757,0,'2013-07-06 12:44:33',NULL,NULL),(32563,'36115','S','Gunter A F B','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(14497,'15143','S','Sewickley','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.553334,-80.152982,0,'2013-07-06 12:44:31',NULL,NULL),(68424,'81212','S','Brookside','A','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(27536,'30224','S','Griffin','D','Spalding','13255','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.207433,-84.236153,0,'2013-07-06 12:44:31',NULL,NULL),(72472,'89124','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(5641,'04947','S','Kingfield','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.062466,-70.321604,0,'2013-07-06 12:44:30',NULL,NULL),(27640,'30317','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.749993,-84.314022,0,'2013-07-06 12:44:31',NULL,NULL),(53256,'61702','P','BLM','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.606096,-88.982513,0,'2013-07-06 12:44:33',NULL,NULL),(73851,'91896','P','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.092513,-118.128483,0,'2013-07-06 12:44:34',NULL,NULL),(21184,'22180','S','Vienna','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.896094,-77.256034,0,'2013-07-06 12:44:31',NULL,NULL),(65129,'77381','S','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.168480,-95.489640,0,'2013-07-06 12:44:34',NULL,NULL),(77997,'97405','S','Pleasant Hill','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.949460,-123.128040,0,'2013-07-06 12:44:34',NULL,NULL),(40193,'45382','S','W Manchester','A','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.898244,-84.621194,0,'2013-07-06 12:44:32',NULL,NULL),(61593,'72761','S','Siloam Spgs','A','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.183359,-94.539153,0,'2013-07-06 12:44:33',NULL,NULL),(69588,'83842','S','Medimont','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.437822,-116.535665,0,'2013-07-06 12:44:34',NULL,NULL),(42141,'47515','S','Siberia','A','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.167640,-86.715843,0,'2013-07-06 12:44:32',NULL,NULL),(53180,'61604','S','Norwood','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(15794,'16925','S','Berrytown','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(15217,'16018','U','Boyers','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091370,-79.908947,0,'2013-07-06 12:44:31',NULL,NULL),(46380,'53139','S','Kansasville','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.700056,-88.127065,0,'2013-07-06 12:44:32',NULL,NULL),(12331,'12866','S','Saratoga Springs','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.075993,-73.774821,0,'2013-07-06 12:44:30',NULL,NULL),(71813,'87571','S','Pot Creek','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(73306,'90807','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.827641,-118.179228,0,'2013-07-06 12:44:34',NULL,NULL),(29961,'33076','S','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.266880,-80.284560,0,'2013-07-06 12:44:32',NULL,NULL),(42733,'48012','P','Bham','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.544872,-83.208462,0,'2013-07-06 12:44:32',NULL,NULL),(7710,'07189','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.797515,-74.161810,0,'2013-07-06 12:44:30',NULL,NULL),(61487,'72640','S','Hasty','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.017949,-93.041336,0,'2013-07-06 12:44:33',NULL,NULL),(54866,'63051','S','Byrnes Mill','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.412034,-90.558900,0,'2013-07-06 12:44:33',NULL,NULL),(34194,'38333','S','Eva','D','Benton','47005','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.114028,-87.995028,0,'2013-07-06 12:44:32',NULL,NULL),(53448,'61883','S','Belgium','N','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.044517,-87.640012,0,'2013-07-06 12:44:33',NULL,NULL),(21176,'22159','U','Army Times','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801702,-77.182270,0,'2013-07-06 12:44:31',NULL,NULL),(50349,'57745','S','Deerfield','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.124460,-103.719540,0,'2013-07-06 12:44:33',NULL,NULL),(54334,'62763','U','Healthcare and Family Serv','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.786222,-89.656263,0,'2013-07-06 12:44:33',NULL,NULL),(11546,'12053','S','Braman Corners','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.722580,-74.171580,0,'2013-07-06 12:44:30',NULL,NULL),(15833,'16935','S','Middlebry Ctr','A','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(3774,'02191','S','N Weymouth','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.241032,-70.943260,0,'2013-07-06 12:44:30',NULL,NULL),(52183,'60465','S','Palos Hills','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.702277,-87.828350,0,'2013-07-06 12:44:33',NULL,NULL),(37645,'42167','S','Gum Tree','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(13166,'13607','S','Westminster Park','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(53100,'61535','S','Grand Oaks','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.593891,-89.535053,0,'2013-07-06 12:44:33',NULL,NULL),(17050,'17751','S','Rote','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(50388,'57766','S','Oral','D','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.363210,-103.135325,0,'2013-07-06 12:44:33',NULL,NULL),(38207,'43212','S','Upper Arlngtn','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(32041,'35246','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519522,-86.801880,0,'2013-07-06 12:44:32',NULL,NULL),(79084,'98438','P','Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(67285,'80007','S','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.858393,-105.196556,0,'2013-07-06 12:44:34',NULL,NULL),(71235,'86336','S','Sedona','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.840383,-111.797496,0,'2013-07-06 12:44:34',NULL,NULL),(2484,'00956','S','Urb Lomas Verde','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(23724,'25908','S','Princewick','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.656976,-81.239502,0,'2013-07-06 12:44:31',NULL,NULL),(73668,'91523','U','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169107,-118.336597,0,'2013-07-06 12:44:34',NULL,NULL),(27224,'29916','S','Early Branch','D','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.635320,-81.034920,0,'2013-07-06 12:44:31',NULL,NULL),(27223,'29916','S','Barkersville','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.635320,-81.034920,0,'2013-07-06 12:44:31',NULL,NULL),(63357,'75637','P','Clayton','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.100862,-94.472734,0,'2013-07-06 12:44:33',NULL,NULL),(35214,'39301','S','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.372903,-88.696221,0,'2013-07-06 12:44:32',NULL,NULL),(12257,'12832','S','Hebron','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(30786,'33597','S','Rdg Mnr Est','A','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.582156,-82.172936,0,'2013-07-06 12:44:32',NULL,NULL),(3276,'01472','P','W Groton','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.606629,-71.629140,0,'2013-07-06 12:44:30',NULL,NULL),(26563,'29209','S','Mountain Brook','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(71384,'87005','S','Bluewater','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.176910,-107.897097,0,'2013-07-06 12:44:34',NULL,NULL),(70294,'84533','S','Ticaboo','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(64560,'76656','S','Barclay','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(43269,'48329','S','Waterford Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.688849,-83.399301,0,'2013-07-06 12:44:32',NULL,NULL),(28421,'31328','S','Tybee Island','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.005769,-80.851185,0,'2013-07-06 12:44:32',NULL,NULL),(75220,'93637','S','Madera','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',36.958261,-120.070035,0,'2013-07-06 12:44:34',NULL,NULL),(77050,'96113','P','Patton Village','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.138912,-120.156585,0,'2013-07-06 12:44:34',NULL,NULL),(55027,'63136','S','Flordell Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(51492,'59625','U','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.609086,-112.039756,0,'2013-07-06 12:44:33',NULL,NULL),(48591,'55779','S','Saginaw','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(2337,'00936','P','Loiza Street','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(61299,'72421','S','Cash','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.840201,-90.956267,0,'2013-07-06 12:44:33',NULL,NULL),(56734,'65710','S','Morrisville','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.467448,-93.429803,0,'2013-07-06 12:44:33',NULL,NULL),(35424,'39470','S','Savannah','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(36414,'40526','U','University of Ky Res Halls','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.040959,-84.505885,0,'2013-07-06 12:44:32',NULL,NULL),(69726,'84040','S','Layton','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.075677,-111.891767,0,'2013-07-06 12:44:34',NULL,NULL),(55904,'64438','S','Darlington','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.188730,-94.413883,0,'2013-07-06 12:44:33',NULL,NULL),(48202,'55401','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.984777,-93.270181,0,'2013-07-06 12:44:33',NULL,NULL),(9700,'10055','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(11711,'12169','S','Stephentown','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.562000,-73.367385,0,'2013-07-06 12:44:30',NULL,NULL),(73227,'90638','S','La Mirada','D','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.906013,-118.005828,0,'2013-07-06 12:44:34',NULL,NULL),(76119,'95241','P','Lodi','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.152443,-121.306349,0,'2013-07-06 12:44:34',NULL,NULL),(10740,'11357','S','Malba','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.783792,-73.812287,0,'2013-07-06 12:44:30',NULL,NULL),(33813,'37920','S','Kimberlin Heights','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.923862,-83.877198,0,'2013-07-06 12:44:32',NULL,NULL),(1325,'00735','S','Urb Vegas de Ceiba','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(11124,'11705','S','Bayport','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746015,-73.053348,0,'2013-07-06 12:44:30',NULL,NULL),(38871,'44105','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(25882,'28640','S','Rhine','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.409140,-81.410460,0,'2013-07-06 12:44:31',NULL,NULL),(75665,'94541','S','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.673394,-122.081227,0,'2013-07-06 12:44:34',NULL,NULL),(10986,'11547','P','Glenwood Lndg','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.829786,-73.644155,0,'2013-07-06 12:44:30',NULL,NULL),(57099,'66219','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.965992,-94.764646,0,'2013-07-06 12:44:33',NULL,NULL),(13434,'13760','S','Endicott','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(59550,'70823','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.445781,-91.189226,0,'2013-07-06 12:44:33',NULL,NULL),(37123,'41451','P','Malone','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.873834,-83.258714,0,'2013-07-06 12:44:32',NULL,NULL),(929,'00714','S','Urb Las 500','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(25083,'27949','S','Southrn Shore','A','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.133440,-75.725400,0,'2013-07-06 12:44:31',NULL,NULL),(46608,'53563','S','Milton','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.777048,-88.953704,0,'2013-07-06 12:44:32',NULL,NULL),(79676,'99169','S','Ritzville','D','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.125853,-118.377738,0,'2013-07-06 12:44:34',NULL,NULL),(26499,'29169','S','Saluda Terrace','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(59565,'70835','P','Gateway','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.428404,-91.024943,0,'2013-07-06 12:44:33',NULL,NULL),(63068,'75234','S','Farmers Brnch','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.915750,-96.896140,0,'2013-07-06 12:44:33',NULL,NULL),(430,'00662','S','Sect Las Uvas','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(22667,'24281','S','Rose Hill','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.640839,-83.338920,0,'2013-07-06 12:44:31',NULL,NULL),(9555,'10023','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(8844,'08641','S','Mc Guire AFB','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.027821,-74.570679,0,'2013-07-06 12:44:30',NULL,NULL),(36014,'40160','S','Radcliff','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.826645,-85.942930,0,'2013-07-06 12:44:32',NULL,NULL),(32771,'36373','S','Shorterville','D','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.615301,-85.146248,0,'2013-07-06 12:44:32',NULL,NULL),(32602,'36133','U','AL Power Co','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.374861,-86.309891,0,'2013-07-06 12:44:32',NULL,NULL),(51007,'58702','P','Minot','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.228996,-101.308292,0,'2013-07-06 12:44:33',NULL,NULL),(46129,'52646','S','Huron','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.097250,-91.043310,0,'2013-07-06 12:44:32',NULL,NULL),(31190,'33935','S','Fort Denaud','A','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.634300,-81.341400,0,'2013-07-06 12:44:32',NULL,NULL),(32320,'35763','S','Hampton Cove','A','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.610433,-86.463316,0,'2013-07-06 12:44:32',NULL,NULL),(17003,'17737','S','Hughesville','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257740,-76.713780,0,'2013-07-06 12:44:31',NULL,NULL),(23151,'24993','S','Wolfcreek','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.627564,-80.605011,0,'2013-07-06 12:44:31',NULL,NULL),(31607,'34681','P','Crystal Beach','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.087767,-82.779052,0,'2013-07-06 12:44:32',NULL,NULL),(27373,'30071','S','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.939475,-84.197677,0,'2013-07-06 12:44:31',NULL,NULL),(24818,'27604','S','Wake Crossroads','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.866620,-78.531900,0,'2013-07-06 12:44:31',NULL,NULL),(8216,'07950','S','Morris Plains','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.844846,-74.476815,0,'2013-07-06 12:44:30',NULL,NULL),(66622,'78778','U','TX Workforce Commission','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.276212,-97.739618,0,'2013-07-06 12:44:34',NULL,NULL),(70656,'85202','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.382230,-111.867598,0,'2013-07-06 12:44:34',NULL,NULL),(7064,'06333','S','East Lyme','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.373026,-72.230753,0,'2013-07-06 12:44:30',NULL,NULL),(72585,'89406','S','Fallon','D','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(78028,'97426','S','Walker','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.907812,-123.034345,0,'2013-07-06 12:44:34',NULL,NULL),(57842,'67553','P','Liebenthal','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.653589,-99.321686,0,'2013-07-06 12:44:33',NULL,NULL),(49806,'57201','S','Appleby','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(6629,'05905','S','Lemington','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(17171,'17814','S','Talmar','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(69845,'84083','S','Wendover','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.738100,-114.021398,0,'2013-07-06 12:44:34',NULL,NULL),(53520,'62026','U','Edwardsville','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.811295,-89.956641,0,'2013-07-06 12:44:33',NULL,NULL),(35901,'40013','S','Deatsville','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.917352,-85.501392,0,'2013-07-06 12:44:32',NULL,NULL),(41555,'47019','P','E Enterprise','A','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.872221,-84.988910,0,'2013-07-06 12:44:32',NULL,NULL),(44145,'49518','P','Kentwood','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.875823,-85.625787,0,'2013-07-06 12:44:32',NULL,NULL),(53813,'62295','S','Valmeyer','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.280452,-90.340506,0,'2013-07-06 12:44:33',NULL,NULL),(47967,'55123','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.801532,-93.141757,0,'2013-07-06 12:44:33',NULL,NULL),(13600,'13856','S','Colchester','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(76387,'95532','U','Crescent City','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.756509,-124.203866,0,'2013-07-06 12:44:34',NULL,NULL),(11767,'12201','P','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.648322,-73.751608,0,'2013-07-06 12:44:30',NULL,NULL),(30675,'33469','S','Jupiter Inlet Colony','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.960459,-80.098465,0,'2013-07-06 12:44:32',NULL,NULL),(32463,'36030','S','Forest Home','D','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.875416,-86.796942,0,'2013-07-06 12:44:32',NULL,NULL),(52790,'61273','S','Sunny Hill','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.366880,-90.433140,0,'2013-07-06 12:44:33',NULL,NULL),(32565,'36115','S','Gunter AFB','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(34890,'38948','S','Oakland','D','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.121437,-89.791303,0,'2013-07-06 12:44:32',NULL,NULL),(39614,'44882','S','Benton','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(45444,'51201','S','Sheldon','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.184792,-95.847789,0,'2013-07-06 12:44:32',NULL,NULL),(80050,'99707','P','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.837257,-147.698775,0,'2013-07-06 12:44:34',NULL,NULL),(26666,'29384','S','Waterloo','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.335048,-82.084850,0,'2013-07-06 12:44:31',NULL,NULL),(48439,'55704','S','Aslo','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.272907,-92.812752,0,'2013-07-06 12:44:33',NULL,NULL),(80204,'99950','P','Kasaan','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.340000,-131.640000,0,'2013-07-06 12:44:34',NULL,NULL),(75034,'93514','S','Bishop','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(15476,'16432','S','Riceville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.779227,-79.799551,0,'2013-07-06 12:44:31',NULL,NULL),(21947,'23233','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.622840,-77.613493,0,'2013-07-06 12:44:31',NULL,NULL),(65443,'77590','S','Texas City','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.396920,-94.920831,0,'2013-07-06 12:44:34',NULL,NULL),(23743,'25927','P','Stanaford','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.817344,-81.161383,0,'2013-07-06 12:44:31',NULL,NULL),(50281,'57649','S','Imogene','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.603149,-102.825211,0,'2013-07-06 12:44:33',NULL,NULL),(10110,'10257','U','Bank of New York','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712067,-74.003313,0,'2013-07-06 12:44:30',NULL,NULL),(16296,'17108','P','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.281473,-76.846974,0,'2013-07-06 12:44:31',NULL,NULL),(62336,'74052','P','Oilton','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.089330,-96.582972,0,'2013-07-06 12:44:33',NULL,NULL),(31361,'34205','S','Cedar Hammock','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.484977,-82.585541,0,'2013-07-06 12:44:32',NULL,NULL),(8035,'07731','S','Wall Township','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.147323,-74.206531,0,'2013-07-06 12:44:30',NULL,NULL),(64478,'76596','U','Gatesville','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.489084,-97.737219,0,'2013-07-06 12:44:34',NULL,NULL),(77307,'96674','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(14024,'14542','P','Rose','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.156346,-76.873817,0,'2013-07-06 12:44:31',NULL,NULL),(1125,'00725','S','Villa Borinquen','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(21655,'22940','S','Mission Home','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.155282,-78.577674,0,'2013-07-06 12:44:31',NULL,NULL),(54997,'63130','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.664368,-90.323797,0,'2013-07-06 12:44:33',NULL,NULL),(46115,'52637','S','Mediapolis','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.007600,-91.097940,0,'2013-07-06 12:44:32',NULL,NULL),(38849,'44092','S','Wiloughby Hls','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.603368,-81.464859,0,'2013-07-06 12:44:32',NULL,NULL),(11380,'11935','S','Cutchogue','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.015049,-72.472897,0,'2013-07-06 12:44:30',NULL,NULL),(63846,'75975','S','Silas','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(28626,'31730','S','Camilla','D','Mitchell','13205','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.231372,-84.207215,0,'2013-07-06 12:44:32',NULL,NULL),(1423,'00739','S','Bosque Real','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(27417,'30099','U','Duluth','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.980117,-84.149338,0,'2013-07-06 12:44:31',NULL,NULL),(69557,'83814','S','Fernan Lake Village','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.687824,-116.779638,0,'2013-07-06 12:44:34',NULL,NULL),(60396,'71630','P','Arkansas City','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.590628,-91.248596,0,'2013-07-06 12:44:33',NULL,NULL),(15206,'15962','P','Wilmore','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.386427,-78.720253,0,'2013-07-06 12:44:31',NULL,NULL),(54646,'62927','P','Dowell','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.942727,-89.237983,0,'2013-07-06 12:44:33',NULL,NULL),(13888,'14267','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.916696,-78.877078,0,'2013-07-06 12:44:31',NULL,NULL),(11758,'12195','P','W Lebanon','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.490534,-73.448183,0,'2013-07-06 12:44:30',NULL,NULL),(48240,'55422','S','Crystal','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.008220,-93.339300,0,'2013-07-06 12:44:33',NULL,NULL),(6407,'05736','S','CTR Rutland','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.595502,-73.025348,0,'2013-07-06 12:44:30',NULL,NULL),(16147,'17060','S','Mill Creek','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.445595,-77.904057,0,'2013-07-06 12:44:31',NULL,NULL),(24432,'27201','P','Alamance','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.026457,-79.485877,0,'2013-07-06 12:44:31',NULL,NULL),(8091,'07762','S','Spring Heights','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(44056,'49440','S','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.232503,-86.251323,0,'2013-07-06 12:44:32',NULL,NULL),(40914,'46266','U','Chase Bank','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.767943,-86.160502,0,'2013-07-06 12:44:32',NULL,NULL),(29472,'32722','P','Deland','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.079239,-81.352956,0,'2013-07-06 12:44:32',NULL,NULL),(26474,'29150','S','Sumter','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(15417,'16360','S','Townville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.682223,-79.875279,0,'2013-07-06 12:44:31',NULL,NULL),(57585,'67068','S','Belmont','A','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.588441,-98.072269,0,'2013-07-06 12:44:33',NULL,NULL),(12601,'13080','S','Jordan','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.093320,-76.465560,0,'2013-07-06 12:44:30',NULL,NULL),(10972,'11530','S','Mitchell Field','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(48783,'55991','S','Zumbro Falls','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.224920,-92.434140,0,'2013-07-06 12:44:33',NULL,NULL),(44337,'49764','P','Oden','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.423794,-84.823640,0,'2013-07-06 12:44:32',NULL,NULL),(40283,'45439','S','Moraine','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(38016,'43008','P','Buckeye Lake','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.937333,-82.476328,0,'2013-07-06 12:44:32',NULL,NULL),(76549,'95665','S','Pine Grove','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.405489,-120.657894,0,'2013-07-06 12:44:34',NULL,NULL),(28338,'31169','U','Peachtree Cty','A','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396731,-84.595632,0,'2013-07-06 12:44:32',NULL,NULL),(71379,'87004','S','Ranchitos','N','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.308943,-106.546421,0,'2013-07-06 12:44:34',NULL,NULL),(30878,'33682','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.055906,-82.459060,0,'2013-07-06 12:44:32',NULL,NULL),(31720,'34972','S','Okeechobee','D','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.325224,-80.849484,0,'2013-07-06 12:44:32',NULL,NULL),(5195,'04448','S','Seboeis Plt','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.240115,-68.661207,0,'2013-07-06 12:44:30',NULL,NULL),(11496,'12023','S','Berne','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.606360,-74.143800,0,'2013-07-06 12:44:30',NULL,NULL),(55340,'63556','S','Cora','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(52682,'61084','S','Stillman Valley','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.114831,-89.191478,0,'2013-07-06 12:44:33',NULL,NULL),(47404,'54646','S','Necedah','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.033430,-90.083429,0,'2013-07-06 12:44:32',NULL,NULL),(3943,'02468','S','Waban','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.326111,-71.231512,0,'2013-07-06 12:44:30',NULL,NULL),(19372,'20059','U','Howard Univ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.923858,-77.016121,0,'2013-07-06 12:44:31',NULL,NULL),(62015,'73448','S','Marietta','D','Love','40085','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.938346,-97.123259,0,'2013-07-06 12:44:33',NULL,NULL),(48608,'55787','S','Tamarack','D','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.637586,-93.122746,0,'2013-07-06 12:44:33',NULL,NULL),(32340,'35801','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.725222,-86.566317,0,'2013-07-06 12:44:32',NULL,NULL),(38045,'43040','S','Marysville','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.256632,-83.375483,0,'2013-07-06 12:44:32',NULL,NULL),(77465,'96816','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286442,-157.801992,0,'2013-07-06 12:44:34',NULL,NULL),(78482,'98102','S','Capitol Hill','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.632744,-122.321885,0,'2013-07-06 12:44:34',NULL,NULL),(71217,'86321','S','Bagdad','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.578289,-113.173531,0,'2013-07-06 12:44:34',NULL,NULL),(18545,'19114','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.064913,-75.003036,0,'2013-07-06 12:44:31',NULL,NULL),(14949,'15610','S','Acme','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.124197,-79.460907,0,'2013-07-06 12:44:31',NULL,NULL),(48290,'55436','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.901982,-93.372906,0,'2013-07-06 12:44:33',NULL,NULL),(43698,'48889','S','Sumner','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.292719,-84.799875,0,'2013-07-06 12:44:32',NULL,NULL),(38129,'43117','P','Derby','D','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.764621,-83.208368,0,'2013-07-06 12:44:32',NULL,NULL),(77253,'96549','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79472,'98857','S','Warden','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.971374,-119.079797,0,'2013-07-06 12:44:34',NULL,NULL),(65660,'77979','S','Kamey','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(29280,'32464','S','Westville','D','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.770964,-85.853378,0,'2013-07-06 12:44:32',NULL,NULL),(7904,'07606','S','S Hackensack','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.867994,-74.049082,0,'2013-07-06 12:44:30',NULL,NULL),(4516,'03302','P','Concord','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.233870,-71.559670,0,'2013-07-06 12:44:30',NULL,NULL),(22659,'24272','S','Nora','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.027652,-82.347712,0,'2013-07-06 12:44:31',NULL,NULL),(10395,'10603','S','North White Plains','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.050315,-73.777527,0,'2013-07-06 12:44:30',NULL,NULL),(65883,'78227','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.415140,-98.635627,0,'2013-07-06 12:44:34',NULL,NULL),(9932,'10153','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(37099,'41347','P','Lone','D','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.532864,-83.601771,0,'2013-07-06 12:44:32',NULL,NULL),(7092,'06354','S','Moosup','D','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.712010,-71.872331,0,'2013-07-06 12:44:30',NULL,NULL),(1494,'00751','S','Salinas','D','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(25431,'28306','S','Fayetteville Municipal Airpo','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.010174,-78.930528,0,'2013-07-06 12:44:31',NULL,NULL),(24926,'27809','S','Drake','N','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',36.048686,-77.749014,0,'2013-07-06 12:44:31',NULL,NULL),(7392,'06785','S','South Kent','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.698481,-73.440523,0,'2013-07-06 12:44:30',NULL,NULL),(59315,'70520','S','Carencro','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.323535,-92.039176,0,'2013-07-06 12:44:33',NULL,NULL),(70240,'84405','S','Uintah','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(74405,'92531','P','Lk Elsinore','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.605257,-117.393897,0,'2013-07-06 12:44:34',NULL,NULL),(38191,'43204','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.955851,-83.082221,0,'2013-07-06 12:44:32',NULL,NULL),(66421,'78639','S','Granite Shoals Lake Shores','N','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.662580,-98.454420,0,'2013-07-06 12:44:34',NULL,NULL),(2525,'00957','S','Urb Santa Elenita','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(55688,'64060','S','Kearney','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.363857,-94.361037,0,'2013-07-06 12:44:33',NULL,NULL),(54682,'62943','S','Dixon Springs','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(50184,'57563','P','Okreek','D','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.360694,-100.389419,0,'2013-07-06 12:44:33',NULL,NULL),(29839,'33032','S','Princeton','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526149,-80.406867,0,'2013-07-06 12:44:32',NULL,NULL),(56381,'65233','S','Billingsville','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(27190,'29853','S','White Pond','N','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.397983,-81.424281,0,'2013-07-06 12:44:31',NULL,NULL),(15534,'16563','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.122676,-79.983259,0,'2013-07-06 12:44:31',NULL,NULL),(75699,'94566','S','Pleasanton','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.672870,-121.884393,0,'2013-07-06 12:44:34',NULL,NULL),(4020,'02564','P','Nantucket','A','Nantucket','25019','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.283333,-70.100000,0,'2013-07-06 12:44:30',NULL,NULL),(18461,'19081','S','Swarthmore','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.896544,-75.343979,0,'2013-07-06 12:44:31',NULL,NULL),(28164,'30907','S','Martinez','A','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.525000,-82.101420,0,'2013-07-06 12:44:31',NULL,NULL),(1455,'00744','P','Rio Blanco','D','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.217733,-65.795607,0,'2013-07-06 12:44:30',NULL,NULL),(3171,'01301','S','Greenfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.602912,-72.598574,0,'2013-07-06 12:44:30',NULL,NULL),(44632,'50067','S','Decatur','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.768448,-93.842967,0,'2013-07-06 12:44:32',NULL,NULL),(46593,'53547','P','Janesville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.705031,-89.006424,0,'2013-07-06 12:44:32',NULL,NULL),(48993,'56236','S','Dumont','D','Traverse','27155','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.716610,-96.423526,0,'2013-07-06 12:44:33',NULL,NULL),(56049,'64730','S','Passaic','A','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.256683,-94.337631,0,'2013-07-06 12:44:33',NULL,NULL),(61704,'73002','S','Alex','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.916023,-97.777631,0,'2013-07-06 12:44:33',NULL,NULL),(74826,'93227','P','Goshen','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.344771,-119.410988,0,'2013-07-06 12:44:34',NULL,NULL),(76865,'95971','S','Bucks Lake','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(43614,'48806','S','Ashley','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.174376,-84.504172,0,'2013-07-06 12:44:32',NULL,NULL),(54471,'62858','S','Riffel','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(24491,'27260','S','Deep River','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(54452,'62850','S','Johnsonville','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.526480,-88.590120,0,'2013-07-06 12:44:33',NULL,NULL),(48879,'56093','S','Meriden','A','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.080423,-93.503192,0,'2013-07-06 12:44:33',NULL,NULL),(4901,'04057','P','North Bridgton','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.042997,-70.737469,0,'2013-07-06 12:44:30',NULL,NULL),(29578,'32819','S','Sand Lake','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.460252,-81.475492,0,'2013-07-06 12:44:32',NULL,NULL),(930,'00714','S','Urb Miramar 1','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(40599,'45885','S','Saint Marys','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.546649,-84.395162,0,'2013-07-06 12:44:32',NULL,NULL),(8330,'08037','S','Blue Anchor','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(25327,'28204','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.214583,-80.828507,0,'2013-07-06 12:44:31',NULL,NULL),(17929,'18470','S','Clifford Township','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.713270,-75.550480,0,'2013-07-06 12:44:31',NULL,NULL),(46585,'53538','S','Fort Atkinson','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',42.924206,-88.840777,0,'2013-07-06 12:44:32',NULL,NULL),(52922,'61369','S','Toluca','D','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.004179,-89.126813,0,'2013-07-06 12:44:33',NULL,NULL),(67014,'79525','S','Hawley','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.595013,-99.864848,0,'2013-07-06 12:44:34',NULL,NULL),(78009,'97413','S','Ckenzie Bridge','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.179665,-122.120204,0,'2013-07-06 12:44:34',NULL,NULL),(79586,'99027','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.702089,-117.110984,0,'2013-07-06 12:44:34',NULL,NULL),(4628,'03604','P','Drewsville','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.129002,-72.392011,0,'2013-07-06 12:44:30',NULL,NULL),(6700,'06061','P','Pine Meadow','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917178,-73.063706,0,'2013-07-06 12:44:30',NULL,NULL),(42487,'47838','S','Pleasantville','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.117887,-87.465105,0,'2013-07-06 12:44:32',NULL,NULL),(40277,'45434','S','Dayton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.712421,-84.041488,0,'2013-07-06 12:44:32',NULL,NULL),(74172,'92274','S','Desert Shores','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(24122,'26544','P','Pentress','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.710345,-80.159708,0,'2013-07-06 12:44:31',NULL,NULL),(39169,'44308','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081525,-81.518551,0,'2013-07-06 12:44:32',NULL,NULL),(44112,'49506','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(54517,'62874','P','Orient','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916687,-88.973759,0,'2013-07-06 12:44:33',NULL,NULL),(58481,'68749','P','Magnet','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.476088,-97.435638,0,'2013-07-06 12:44:33',NULL,NULL),(59443,'70719','S','Brusly','D','West Baton Rouge','22121','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.388636,-91.254126,0,'2013-07-06 12:44:33',NULL,NULL),(60353,'71469','S','Robeline','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(60432,'71646','S','Berlin','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(62361,'74067','P','Sapulpa','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.986469,-96.117351,0,'2013-07-06 12:44:33',NULL,NULL),(72369,'89030','S','No Las Vegas','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.210991,-115.128903,0,'2013-07-06 12:44:34',NULL,NULL),(79398,'98801','S','West Wenatchee','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(4617,'03597','P','West Stewartstown','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.992788,-71.534456,0,'2013-07-06 12:44:30',NULL,NULL),(5021,'04238','S','Hebron','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.213315,-70.379196,0,'2013-07-06 12:44:30',NULL,NULL),(34474,'38664','S','Commerce','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(34022,'38128','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.219361,-89.925899,0,'2013-07-06 12:44:32',NULL,NULL),(41508,'46968','S','Ora','D','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.174795,-86.556486,0,'2013-07-06 12:44:32',NULL,NULL),(71922,'87829','S','Quemado','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.311420,-108.809880,0,'2013-07-06 12:44:34',NULL,NULL),(74561,'92679','S','Robinson Ranch','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(76664,'95747','S','Roseville','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.763756,-121.391419,0,'2013-07-06 12:44:34',NULL,NULL),(48356,'55486','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.974141,-93.267706,0,'2013-07-06 12:44:33',NULL,NULL),(24914,'27801','S','Rocky Mt','N','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.954100,-77.751840,0,'2013-07-06 12:44:31',NULL,NULL),(49698,'57029','S','Freeman','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.348042,-97.427889,0,'2013-07-06 12:44:33',NULL,NULL),(15988,'17034','S','High Spire','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.206340,-76.789304,0,'2013-07-06 12:44:31',NULL,NULL),(16082,'17050','S','Mechbg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(42532,'47861','S','Merom','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.014376,-87.525993,0,'2013-07-06 12:44:32',NULL,NULL),(41010,'46371','S','Rolling Prairie','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.686889,-86.609518,0,'2013-07-06 12:44:32',NULL,NULL),(16801,'17543','S','Fairland','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(37061,'41311','S','Beattyville','D','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(8386,'08059','S','West Collingswood Heights','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.879419,-75.092601,0,'2013-07-06 12:44:30',NULL,NULL),(25408,'28290','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.234982,-80.913799,0,'2013-07-06 12:44:31',NULL,NULL),(10132,'10261','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(3991,'02537','S','East Sandwich','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.726548,-70.440357,0,'2013-07-06 12:44:30',NULL,NULL),(19542,'20194','S','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.980241,-77.339946,0,'2013-07-06 12:44:31',NULL,NULL),(31709,'34953','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.256604,-80.384626,0,'2013-07-06 12:44:32',NULL,NULL),(44003,'49347','S','Trufant','D','Montcalm','26117','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.318080,-85.344102,0,'2013-07-06 12:44:32',NULL,NULL),(34983,'39097','S','Louise','D','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.977406,-90.591952,0,'2013-07-06 12:44:32',NULL,NULL),(2344,'00936','P','Santurce Station','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(25504,'28375','P','Proctorville','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.473871,-79.038584,0,'2013-07-06 12:44:31',NULL,NULL),(21994,'23273','U','Richmond','A','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.587216,-77.495005,0,'2013-07-06 12:44:31',NULL,NULL),(46484,'53222','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084153,-88.036961,0,'2013-07-06 12:44:32',NULL,NULL),(66464,'78656','S','Maxwell','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.861942,-97.858517,0,'2013-07-06 12:44:34',NULL,NULL),(78021,'97420','S','Eastside','N','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.332900,-124.233900,0,'2013-07-06 12:44:34',NULL,NULL),(66673,'78886','S','Yancey','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.139067,-99.141918,0,'2013-07-06 12:44:34',NULL,NULL),(62746,'74839','S','Dustin','D','Hughes','40063','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.225025,-96.067976,0,'2013-07-06 12:44:33',NULL,NULL),(50374,'57758','S','Opal','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.892550,-102.451810,0,'2013-07-06 12:44:33',NULL,NULL),(47205,'54490','S','Westboro','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.332916,-90.359136,0,'2013-07-06 12:44:32',NULL,NULL),(67708,'80527','P','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.533235,-105.071191,0,'2013-07-06 12:44:34',NULL,NULL),(10447,'10917','S','Central Vly','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.333541,-74.134438,0,'2013-07-06 12:44:30',NULL,NULL),(17221,'17830','S','Camp Grove','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690745,-76.789710,0,'2013-07-06 12:44:31',NULL,NULL),(3412,'01718','S','Village of Nagog Woods','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.517046,-71.412305,0,'2013-07-06 12:44:30',NULL,NULL),(19961,'20586','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905041,-77.047044,0,'2013-07-06 12:44:31',NULL,NULL),(41214,'46730','S','Indian Lake','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.438215,-85.154373,0,'2013-07-06 12:44:32',NULL,NULL),(12972,'13367','S','New Breman','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(12744,'13202','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.050827,-76.148300,0,'2013-07-06 12:44:30',NULL,NULL),(28671,'31792','S','Metcalf','A','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.836835,-83.972588,0,'2013-07-06 12:44:32',NULL,NULL),(24430,'27199','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.099201,-80.249323,0,'2013-07-06 12:44:31',NULL,NULL),(25550,'28408','P','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.226075,-77.946552,0,'2013-07-06 12:44:31',NULL,NULL),(50065,'57442','S','Gettysburg','D','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.013247,-99.998682,0,'2013-07-06 12:44:33',NULL,NULL),(69950,'84117','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(41321,'46774','S','New Haven','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(29394,'32618','S','Archer','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.544826,-82.514549,0,'2013-07-06 12:44:32',NULL,NULL),(4650,'03751','P','Georges Mills','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.432435,-72.069893,0,'2013-07-06 12:44:30',NULL,NULL),(75284,'93717','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.734019,-119.792056,0,'2013-07-06 12:44:34',NULL,NULL),(76666,'95758','S','Elk Grove','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.405311,-121.429597,0,'2013-07-06 12:44:34',NULL,NULL),(5400,'04654','S','Whitneyville','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.720530,-67.467043,0,'2013-07-06 12:44:30',NULL,NULL),(13599,'13856','S','Cleaver','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(74715,'93015','S','Fillmore','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.396980,-118.912542,0,'2013-07-06 12:44:34',NULL,NULL),(79845,'99546','P','Adak','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',51.877706,-176.658889,0,'2013-07-06 12:44:34',NULL,NULL),(44673,'50117','S','Hamlin','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.646818,-94.918972,0,'2013-07-06 12:44:32',NULL,NULL),(34294,'38505','U','Cookeville','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.182099,-85.461511,0,'2013-07-06 12:44:32',NULL,NULL),(23318,'25209','S','Packsville','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.970938,-81.529874,0,'2013-07-06 12:44:31',NULL,NULL),(20166,'20743','S','Capitol Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.885663,-76.901034,0,'2013-07-06 12:44:31',NULL,NULL),(19151,'19711','S','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.707850,-75.734964,0,'2013-07-06 12:44:31',NULL,NULL),(14611,'15227','S','Brentwood','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426740,-79.969140,0,'2013-07-06 12:44:31',NULL,NULL),(24736,'27524','S','Four Oaks','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.448202,-78.425508,0,'2013-07-06 12:44:31',NULL,NULL),(29088,'32259','S','Saint Johns','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(46394,'53154','S','Oak Creek','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.886060,-87.903062,0,'2013-07-06 12:44:32',NULL,NULL),(68755,'82227','S','Keeline','A','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.778823,-104.616179,0,'2013-07-06 12:44:34',NULL,NULL),(60617,'71861','S','Taylor','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.111405,-93.447276,0,'2013-07-06 12:44:33',NULL,NULL),(51565,'59752','S','Three Forks','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.880020,-111.576240,0,'2013-07-06 12:44:33',NULL,NULL),(4105,'02703','S','S Attleboro','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.939160,-71.302800,0,'2013-07-06 12:44:30',NULL,NULL),(13635,'13905','S','Binghamton','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(10210,'10453','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.852613,-73.914221,0,'2013-07-06 12:44:30',NULL,NULL),(18800,'19398','P','Southeastern','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847666,-75.699326,0,'2013-07-06 12:44:31',NULL,NULL),(34371,'38614','S','Baltzer','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(49432,'56633','S','Wilkinson','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(45012,'50455','S','Mc Intire','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.465027,-92.612882,0,'2013-07-06 12:44:32',NULL,NULL),(16773,'17522','S','Murrell','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(55446,'63701','S','Cpe Girardeau','A','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.318976,-89.540608,0,'2013-07-06 12:44:33',NULL,NULL),(79562,'99014','P','Four Lakes','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.562362,-117.591368,0,'2013-07-06 12:44:34',NULL,NULL),(71415,'87021','P','Milan','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.170117,-107.888998,0,'2013-07-06 12:44:34',NULL,NULL),(22653,'24266','S','Hansonville','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.890460,-82.084560,0,'2013-07-06 12:44:31',NULL,NULL),(7959,'07676','S','Washington Twsp','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(3220,'01367','S','Hoosac Tunnel','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.689349,-72.935421,0,'2013-07-06 12:44:30',NULL,NULL),(746,'00692','S','Comunidad Manantial','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(16376,'17201','S','Turkeyfoot','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(14401,'15057','S','Mc Donald','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.363602,-80.232468,0,'2013-07-06 12:44:31',NULL,NULL),(46220,'52771','S','Teeds Grove','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.011516,-90.244984,0,'2013-07-06 12:44:32',NULL,NULL),(47645,'54927','P','Butte des Morts','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.103693,-88.651664,0,'2013-07-06 12:44:33',NULL,NULL),(53600,'62077','P','Grisham','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.050000,-89.533333,0,'2013-07-06 12:44:33',NULL,NULL),(54285,'62695','P','Woodson','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.629808,-90.220028,0,'2013-07-06 12:44:33',NULL,NULL),(70725,'85295','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.317422,-111.730771,0,'2013-07-06 12:44:34',NULL,NULL),(35503,'39530','S','Biloxi','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400015,-88.897393,0,'2013-07-06 12:44:32',NULL,NULL),(16804,'17543','S','Lexington','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(45228,'50645','S','Bassett','N','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.047060,-92.485200,0,'2013-07-06 12:44:32',NULL,NULL),(5937,'05255','S','Manchster Ctr','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.194892,-73.065620,0,'2013-07-06 12:44:30',NULL,NULL),(67970,'80914','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(25790,'28604','S','Norwood Hollow','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(11000,'11552','S','W Hempstead','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685278,-73.653056,0,'2013-07-06 12:44:30',NULL,NULL),(33078,'36782','S','Sweet Water','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.082428,-87.944688,0,'2013-07-06 12:44:32',NULL,NULL),(57251,'66533','S','Rossville','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.152719,-95.965164,0,'2013-07-06 12:44:33',NULL,NULL),(41065,'46511','S','Clvr Mil Acad','A','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.226198,-86.415220,0,'2013-07-06 12:44:32',NULL,NULL),(3466,'01812','U','Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.648594,-71.182543,0,'2013-07-06 12:44:30',NULL,NULL),(19476,'20144','S','Delaplane','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.912253,-77.917386,0,'2013-07-06 12:44:31',NULL,NULL),(9097,'09067','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7599,'07043','S','Upr Montclair','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.841403,-74.201411,0,'2013-07-06 12:44:30',NULL,NULL),(40370,'45647','S','Londonderry','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.278034,-82.798955,0,'2013-07-06 12:44:32',NULL,NULL),(8324,'08035','S','Haddon Hts','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.877788,-75.066565,0,'2013-07-06 12:44:30',NULL,NULL),(28250,'31062','U','Milledgeville','D','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.086401,-83.239860,0,'2013-07-06 12:44:31',NULL,NULL),(67185,'79852','S','Terlingua','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',29.330664,-103.591563,0,'2013-07-06 12:44:34',NULL,NULL),(77438,'96807','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306339,-157.861146,0,'2013-07-06 12:44:34',NULL,NULL),(66418,'78636','S','Cypress Mill','N','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.276140,-98.408543,0,'2013-07-06 12:44:34',NULL,NULL),(63647,'75845','S','Crecy','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(16905,'17584','S','Willow Street','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.962325,-76.274759,0,'2013-07-06 12:44:31',NULL,NULL),(16847,'17562','S','Iva','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(683,'00683','S','Villas De Charied','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(3381,'01602','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.270180,-71.845149,0,'2013-07-06 12:44:30',NULL,NULL),(18294,'19014','S','Uppr Chichstr','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(848,'00698','S','Jard de Borinquen','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(24814,'27603','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.714307,-78.660593,0,'2013-07-06 12:44:31',NULL,NULL),(24234,'26753','S','Carpendale','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.600960,-78.784140,0,'2013-07-06 12:44:31',NULL,NULL),(21053,'21904','S','Bainbridge','A','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.635940,-76.079400,0,'2013-07-06 12:44:31',NULL,NULL),(13639,'13905','S','Hinmans Corners','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(42680,'47975','S','Pine Village','D','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.433584,-87.235324,0,'2013-07-06 12:44:32',NULL,NULL),(34098,'38168','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229844,-89.924595,0,'2013-07-06 12:44:32',NULL,NULL),(90,'00612','S','Sect Abra','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(3011,'01081','S','Wales','D','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.061203,-72.227590,0,'2013-07-06 12:44:30',NULL,NULL),(6132,'05461','S','Hinesburg','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.304622,-73.118170,0,'2013-07-06 12:44:30',NULL,NULL),(38281,'43326','S','Kenton','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.643700,-83.607011,0,'2013-07-06 12:44:32',NULL,NULL),(29964,'33077','P','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.246438,-80.263929,0,'2013-07-06 12:44:32',NULL,NULL),(25787,'28604','S','Grandfather','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(50672,'58341','S','Manfred','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(59479,'70756','S','Blanks','A','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.520831,-91.688091,0,'2013-07-06 12:44:33',NULL,NULL),(78032,'97431','S','Dexter','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.907365,-122.826298,0,'2013-07-06 12:44:34',NULL,NULL),(41361,'46793','S','Sedan','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.426955,-85.022802,0,'2013-07-06 12:44:32',NULL,NULL),(26081,'28704','S','Royal Pines','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.473046,-82.519301,0,'2013-07-06 12:44:31',NULL,NULL),(4997,'04217','S','Bethel','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.447236,-70.693616,0,'2013-07-06 12:44:30',NULL,NULL),(4411,'03225','S','Center Barnstead','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.379371,-71.231100,0,'2013-07-06 12:44:30',NULL,NULL),(29393,'32617','S','Anthony','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.293459,-82.108432,0,'2013-07-06 12:44:32',NULL,NULL),(12895,'13332','S','South Lebanon','N','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(68151,'81001','S','Belle Plain','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(34626,'38756','S','Elizabeth','A','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(72977,'90048','S','West Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.073253,-118.377034,0,'2013-07-06 12:44:34',NULL,NULL),(73654,'91501','S','Starlight Hills','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.188758,-118.296041,0,'2013-07-06 12:44:34',NULL,NULL),(17636,'18062','S','Macungie','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.527398,-75.560135,0,'2013-07-06 12:44:31',NULL,NULL),(14046,'14559','S','Spencerport','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.189174,-77.807274,0,'2013-07-06 12:44:31',NULL,NULL),(13913,'14304','S','Wheatfield','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.100160,-78.955200,0,'2013-07-06 12:44:31',NULL,NULL),(4361,'03057','S','Mt Vernon','N','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.898128,-71.677913,0,'2013-07-06 12:44:30',NULL,NULL),(9922,'10151','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(9974,'10162','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(10049,'10175','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(11300,'11777','S','Port Jefferson','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(70950,'85643','S','Fort Grant','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(32721,'36305','S','Rehobeth','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.222470,-85.390698,0,'2013-07-06 12:44:32',NULL,NULL),(23382,'25305','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.357935,-81.570810,0,'2013-07-06 12:44:31',NULL,NULL),(78135,'97533','P','Murphy','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.339015,-123.286308,0,'2013-07-06 12:44:34',NULL,NULL),(73039,'90078','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.099648,-118.328037,0,'2013-07-06 12:44:34',NULL,NULL),(37238,'41548','S','Toonerville','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.374131,-82.287581,0,'2013-07-06 12:44:32',NULL,NULL),(19186,'19805','S','Elsmere','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.731640,-75.624240,0,'2013-07-06 12:44:31',NULL,NULL),(69559,'83815','S','Coeur D Alene','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.725192,-116.786915,0,'2013-07-06 12:44:34',NULL,NULL),(15658,'16749','S','Keating Summit','N','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.807779,-78.449022,0,'2013-07-06 12:44:31',NULL,NULL),(12903,'13337','S','Fly Creek','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.734651,-74.991943,0,'2013-07-06 12:44:30',NULL,NULL),(24868,'27668','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.842959,-78.634483,0,'2013-07-06 12:44:31',NULL,NULL),(36936,'41164','S','Globe','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(6667,'06030','U','Farmington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.711768,-72.839345,0,'2013-07-06 12:44:30',NULL,NULL),(695,'00685','S','Urb Chinto Rodon','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(39227,'44416','P','Ellsworth','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.025292,-80.858693,0,'2013-07-06 12:44:32',NULL,NULL),(8195,'07926','P','Brookside','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.799951,-74.571628,0,'2013-07-06 12:44:30',NULL,NULL),(37785,'42361','S','Olaton','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.505252,-86.717486,0,'2013-07-06 12:44:32',NULL,NULL),(17139,'17801','S','Augustaville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(13769,'14139','S','S Wales','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.718999,-78.536856,0,'2013-07-06 12:44:31',NULL,NULL),(49297,'56527','S','Deer Creek','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.414918,-95.281404,0,'2013-07-06 12:44:33',NULL,NULL),(51918,'60113','P','Creston','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.928976,-88.966367,0,'2013-07-06 12:44:33',NULL,NULL),(54034,'62461','S','Shumway','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.193658,-88.639329,0,'2013-07-06 12:44:33',NULL,NULL),(55280,'63469','S','Plevna','A','Shelby','29205','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.822053,-92.070853,0,'2013-07-06 12:44:33',NULL,NULL),(55820,'64150','S','Northmoor','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.170613,-94.628810,0,'2013-07-06 12:44:33',NULL,NULL),(57176,'66401','S','Alma','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.963736,-96.242316,0,'2013-07-06 12:44:33',NULL,NULL),(62248,'74003','S','Hog Shooter','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(62925,'75083','P','Richardson','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.973276,-96.745268,0,'2013-07-06 12:44:33',NULL,NULL),(63444,'75670','S','Marshall','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(65231,'77449','S','Park Row','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.819538,-95.752260,0,'2013-07-06 12:44:34',NULL,NULL),(73480,'91320','S','Newbury Park','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.185360,-118.926480,0,'2013-07-06 12:44:34',NULL,NULL),(74231,'92322','P','Cedar Pines Pk','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.252934,-117.324200,0,'2013-07-06 12:44:34',NULL,NULL),(39157,'44288','S','Windham','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.242226,-81.056024,0,'2013-07-06 12:44:32',NULL,NULL),(3176,'01331','S','Athol','D','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.588860,-72.224089,0,'2013-07-06 12:44:30',NULL,NULL),(53341,'61755','S','Mackinaw','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.540609,-89.340753,0,'2013-07-06 12:44:33',NULL,NULL),(52662,'61068','S','Kings','A','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.948220,-89.055360,0,'2013-07-06 12:44:33',NULL,NULL),(79961,'99636','P','New Stuyahok','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.402591,-157.279625,0,'2013-07-06 12:44:34',NULL,NULL),(38038,'43032','P','Kilbourne','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.328600,-82.959025,0,'2013-07-06 12:44:32',NULL,NULL),(20317,'20827','P','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.013715,-77.158738,0,'2013-07-06 12:44:31',NULL,NULL),(45636,'51645','S','Imogene','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.879226,-95.426289,0,'2013-07-06 12:44:32',NULL,NULL),(14872,'15467','P','New Geneva','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.787757,-79.909079,0,'2013-07-06 12:44:31',NULL,NULL),(29447,'32702','S','Altoona','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',29.014274,-81.624817,0,'2013-07-06 12:44:32',NULL,NULL),(27641,'30318','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.787680,-84.443612,0,'2013-07-06 12:44:31',NULL,NULL),(68879,'82646','S','Natrona','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.029483,-106.809656,0,'2013-07-06 12:44:34',NULL,NULL),(74742,'93043','U','Port Hueneme CBC Base','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.162390,-119.201182,0,'2013-07-06 12:44:34',NULL,NULL),(74789,'93130','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.441228,-119.735418,0,'2013-07-06 12:44:34',NULL,NULL),(77175,'96278','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(4060,'02645','S','Hardwich','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.703441,-70.062208,0,'2013-07-06 12:44:30',NULL,NULL),(14351,'15012','S','N Belle Vrn','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(24548,'27292','S','Reeds Cross Roads','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(29079,'32257','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.193293,-81.601505,0,'2013-07-06 12:44:32',NULL,NULL),(30135,'33164','P','Uleta','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.929334,-80.176758,0,'2013-07-06 12:44:32',NULL,NULL),(47657,'54935','S','N Fond du Lac','A','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.775242,-88.431561,0,'2013-07-06 12:44:33',NULL,NULL),(57808,'67510','S','Abbyville','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.005433,-98.208083,0,'2013-07-06 12:44:33',NULL,NULL),(61184,'72207','S','Cammack Vlg','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.773082,-92.358471,0,'2013-07-06 12:44:33',NULL,NULL),(68795,'82414','S','Cody','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.511852,-109.136009,0,'2013-07-06 12:44:34',NULL,NULL),(65863,'78212','S','Olmos Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.478611,-98.487222,0,'2013-07-06 12:44:34',NULL,NULL),(12619,'13088','S','Lvpl','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(47089,'54435','S','Parrish','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.400965,-89.462214,0,'2013-07-06 12:44:32',NULL,NULL),(30699,'33484','S','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.457619,-80.135160,0,'2013-07-06 12:44:32',NULL,NULL),(30397,'33322','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.150168,-80.273686,0,'2013-07-06 12:44:32',NULL,NULL),(25722,'28545','S','Jacksonville','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.683745,-77.341910,0,'2013-07-06 12:44:31',NULL,NULL),(74418,'92552','P','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.925544,-117.248196,0,'2013-07-06 12:44:34',NULL,NULL),(78188,'97720','S','Lawen','A','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.524973,-118.762656,0,'2013-07-06 12:44:34',NULL,NULL),(42134,'47512','S','Jonestown','N','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772909,-87.307853,0,'2013-07-06 12:44:32',NULL,NULL),(78,'00612','S','Hacienda Toledo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(36756,'41040','S','Pendleton County','A','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(10580,'11021','S','Russell Gardens','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(25721,'28544','S','Midway Park','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.732620,-77.327640,0,'2013-07-06 12:44:31',NULL,NULL),(45466,'51247','S','Rock Valley','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.205229,-96.291066,0,'2013-07-06 12:44:32',NULL,NULL),(49214,'56464','S','Midway','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(61932,'73155','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.418558,-97.435219,0,'2013-07-06 12:44:33',NULL,NULL),(64498,'76629','S','Hammond','N','Robertson','48395','Texas','TX','48','0000','254','Central',-6.0,'Y',31.149300,-96.676320,0,'2013-07-06 12:44:34',NULL,NULL),(66884,'79236','P','Guthrie','D','King','48269','Texas','TX','48','0000','806','Central',-6.0,'Y',33.616903,-100.260065,0,'2013-07-06 12:44:34',NULL,NULL),(69462,'83651','S','Nampa','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.582086,-116.590913,0,'2013-07-06 12:44:34',NULL,NULL),(40660,'46045','P','Goldsmith','D','Tipton','18159','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.291970,-86.147711,0,'2013-07-06 12:44:32',NULL,NULL),(29636,'32896','U','GE Capital','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.537421,-81.381153,0,'2013-07-06 12:44:32',NULL,NULL),(27919,'30511','S','Baldwin','D','Banks','13011','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.522844,-83.532714,0,'2013-07-06 12:44:31',NULL,NULL),(23304,'25187','S','Southside','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.712584,-82.011011,0,'2013-07-06 12:44:31',NULL,NULL),(78961,'98370','S','Poulsbo','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(76847,'95965','S','Las Plumas','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(77149,'96161','S','Truckee','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(66779,'79036','S','Fritch','D','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.634953,-101.594623,0,'2013-07-06 12:44:34',NULL,NULL),(44118,'49506','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(23902,'26203','S','Erbacon','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.543012,-80.566448,0,'2013-07-06 12:44:31',NULL,NULL),(21919,'23222','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.581778,-77.418908,0,'2013-07-06 12:44:31',NULL,NULL),(34800,'38876','S','Cadamy','N','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.215232,-88.208583,0,'2013-07-06 12:44:32',NULL,NULL),(10571,'11020','S','GT Neck','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(19854,'20515','U','Us House of Representatives','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891068,-77.011322,0,'2013-07-06 12:44:31',NULL,NULL),(34661,'38782','P','Winterville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.504147,-91.057094,0,'2013-07-06 12:44:32',NULL,NULL),(27808,'30398','U','Bank America','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.650336,-84.389036,0,'2013-07-06 12:44:31',NULL,NULL),(62978,'75142','S','Kaufman','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.584662,-96.302241,0,'2013-07-06 12:44:33',NULL,NULL),(55952,'64487','S','Skidmore','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.290788,-95.073940,0,'2013-07-06 12:44:33',NULL,NULL),(53859,'62330','S','Burnside','A','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.632034,-91.172512,0,'2013-07-06 12:44:33',NULL,NULL),(35867,'39837','S','Colquitt','D','Miller','13201','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.174262,-84.730167,0,'2013-07-06 12:44:32',NULL,NULL),(27750,'30358','P','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.934524,-84.388655,0,'2013-07-06 12:44:31',NULL,NULL),(14197,'14766','P','Otto','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.349305,-78.828802,0,'2013-07-06 12:44:31',NULL,NULL),(67883,'80860','P','Goldfield','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.739224,-105.125564,0,'2013-07-06 12:44:34',NULL,NULL),(15808,'16927','S','Harrison Vly','A','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.951385,-77.702976,0,'2013-07-06 12:44:31',NULL,NULL),(19626,'20245','U','Bureau of Indian Affairs','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892480,-77.045778,0,'2013-07-06 12:44:31',NULL,NULL),(37333,'41659','S','Stanville','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.582237,-82.673955,0,'2013-07-06 12:44:32',NULL,NULL),(50671,'58341','S','Heimdal','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(66188,'78539','S','Edinburg','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(73789,'91746','S','La Puente','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.049002,-117.979948,0,'2013-07-06 12:44:34',NULL,NULL),(69044,'83221','S','Wapello','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(64606,'76686','P','Tehuacana','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.687428,-96.510048,0,'2013-07-06 12:44:34',NULL,NULL),(58422,'68654','S','Polk','D','Polk','31143','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.075128,-97.787548,0,'2013-07-06 12:44:33',NULL,NULL),(17414,'17921','S','Fountain Springs','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(4387,'03106','S','Manchester','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.056574,-71.448553,0,'2013-07-06 12:44:30',NULL,NULL),(43401,'48446','S','Lapeer','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.056009,-83.327865,0,'2013-07-06 12:44:32',NULL,NULL),(56347,'65201','S','Harg','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.896440,-92.246280,0,'2013-07-06 12:44:33',NULL,NULL),(5613,'04936','S','Eustis','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182634,-70.491461,0,'2013-07-06 12:44:30',NULL,NULL),(59695,'71075','S','Springhill','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',33.001957,-93.458909,0,'2013-07-06 12:44:33',NULL,NULL),(33347,'37178','S','Tenn Ridge','N','Houston','47083','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.313167,-87.764653,0,'2013-07-06 12:44:32',NULL,NULL),(32785,'36420','S','Pleasant Home','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(31346,'34145','S','Marco Island','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.940928,-81.719213,0,'2013-07-06 12:44:32',NULL,NULL),(67507,'80236','S','Lakewood','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.655391,-105.022433,0,'2013-07-06 12:44:34',NULL,NULL),(74582,'92693','P','San Juan Capistrano','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.497713,-117.665115,0,'2013-07-06 12:44:34',NULL,NULL),(27905,'30477','S','Moxley','N','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.862048,-82.407315,0,'2013-07-06 12:44:31',NULL,NULL),(74643,'92821','S','Brea','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.929135,-117.884454,0,'2013-07-06 12:44:34',NULL,NULL),(70896,'85617','S','McNeal','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.523874,-109.682735,0,'2013-07-06 12:44:34',NULL,NULL),(70121,'84190','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725005,-111.886915,0,'2013-07-06 12:44:34',NULL,NULL),(63460,'75684','S','Pirtle','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(60622,'71901','S','Blue Springs','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(19383,'20064','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.937522,-76.996839,0,'2013-07-06 12:44:31',NULL,NULL),(29277,'32461','P','Watersound','A','Walton','12131','Florida','FL','12','6015','850','Central',-6.0,'Y',30.251077,-85.950567,0,'2013-07-06 12:44:32',NULL,NULL),(79323,'98604','S','Battleground','N','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.794960,-122.520247,0,'2013-07-06 12:44:34',NULL,NULL),(11284,'11772','S','Patchogue','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.775040,-72.895740,0,'2013-07-06 12:44:30',NULL,NULL),(14422,'15069','U','New Kensington','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.569677,-79.749317,0,'2013-07-06 12:44:31',NULL,NULL),(16332,'17126','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265390,-76.880316,0,'2013-07-06 12:44:31',NULL,NULL),(45183,'50612','S','Buckingham','D','Tama','19171','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.310784,-92.376708,0,'2013-07-06 12:44:32',NULL,NULL),(48580,'55771','S','Portage','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(51597,'59821','S','Arlee','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.161056,-114.051408,0,'2013-07-06 12:44:33',NULL,NULL),(53893,'62358','S','Niota','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.615590,-91.286393,0,'2013-07-06 12:44:33',NULL,NULL),(7717,'07195','U','Bank of New York','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.729819,-74.175366,0,'2013-07-06 12:44:30',NULL,NULL),(25680,'28516','S','Beaufort','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.731559,-76.655049,0,'2013-07-06 12:44:31',NULL,NULL),(40929,'46282','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.769381,-86.160168,0,'2013-07-06 12:44:32',NULL,NULL),(35745,'39730','S','Gibson','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(78744,'98290','S','Machias','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.939532,-122.016706,0,'2013-07-06 12:44:34',NULL,NULL),(73303,'90805','S','North Long Beach','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.863555,-118.182163,0,'2013-07-06 12:44:34',NULL,NULL),(73264,'90720','S','Cypress','A','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.795614,-118.064756,0,'2013-07-06 12:44:34',NULL,NULL),(72479,'89125','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171247,-115.124266,0,'2013-07-06 12:44:34',NULL,NULL),(68754,'82225','S','Node','A','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.803734,-104.337239,0,'2013-07-06 12:44:34',NULL,NULL),(34938,'39045','S','Camden','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.732477,-89.816480,0,'2013-07-06 12:44:32',NULL,NULL),(16772,'17522','S','Hinkletown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(50885,'58532','S','Driscoll','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.851407,-100.140454,0,'2013-07-06 12:44:33',NULL,NULL),(32728,'36313','P','Bellwood','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.228197,-85.759117,0,'2013-07-06 12:44:32',NULL,NULL),(5412,'04664','S','North Sullivan','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.540556,-68.243611,0,'2013-07-06 12:44:30',NULL,NULL),(38725,'44022','S','Russell Township','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(17163,'17814','S','Coles Creek','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(21426,'22552','P','Sparta','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.991299,-77.228895,0,'2013-07-06 12:44:31',NULL,NULL),(25699,'28532','S','Havelock','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.893026,-76.901370,0,'2013-07-06 12:44:31',NULL,NULL),(31896,'35143','S','Shelby','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.099667,-86.501970,0,'2013-07-06 12:44:32',NULL,NULL),(26649,'29355','S','Kinards','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.353151,-81.766819,0,'2013-07-06 12:44:31',NULL,NULL),(64859,'77055','S','Hilshire Village','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.797867,-95.497137,0,'2013-07-06 12:44:34',NULL,NULL),(66587,'78748','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.168174,-97.822906,0,'2013-07-06 12:44:34',NULL,NULL),(1468,'00745','S','Urb Jose H Ramirez','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(65144,'77386','S','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.131735,-95.416441,0,'2013-07-06 12:44:34',NULL,NULL),(41138,'46637','S','Roseland','A','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.726797,-86.242770,0,'2013-07-06 12:44:32',NULL,NULL),(59159,'70195','U','Whitney National Bank','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.953286,-90.071666,0,'2013-07-06 12:44:33',NULL,NULL),(1556,'00766','S','Alt de Villalba','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(17119,'17772','S','Turbotville','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.100974,-76.773819,0,'2013-07-06 12:44:31',NULL,NULL),(22826,'24504','S','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.406392,-79.128255,0,'2013-07-06 12:44:31',NULL,NULL),(77969,'97374','S','Scio','D','Linn','41043','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',44.692750,-122.803046,0,'2013-07-06 12:44:34',NULL,NULL),(19105,'19606','S','Jacksonwald','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(15055,'15721','P','Burnside','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.809399,-78.792096,0,'2013-07-06 12:44:31',NULL,NULL),(43126,'48230','S','Grosse Pointe Farms','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(25866,'28631','S','Grassy Creek','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.547139,-81.434483,0,'2013-07-06 12:44:31',NULL,NULL),(23082,'24898','S','Wyoming','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.577932,-81.585334,0,'2013-07-06 12:44:31',NULL,NULL),(61526,'72663','S','Pleasant Hills','N','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.943278,-92.334065,0,'2013-07-06 12:44:33',NULL,NULL),(66769,'79024','P','Darrouzett','D','Lipscomb','48295','Texas','TX','48','0000','806','Central',-6.0,'Y',36.442021,-100.326189,0,'2013-07-06 12:44:34',NULL,NULL),(69411,'83629','S','Gardena','N','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.928831,-116.292814,0,'2013-07-06 12:44:34',NULL,NULL),(39825,'45150','S','Mt Repose','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.178746,-84.246032,0,'2013-07-06 12:44:32',NULL,NULL),(61134,'72160','S','Bayou Meto','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(5754,'05039','S','Corinth Center','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(22510,'24083','S','Daleville','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.415209,-79.913412,0,'2013-07-06 12:44:31',NULL,NULL),(21608,'22902','S','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000280,-78.463620,0,'2013-07-06 12:44:31',NULL,NULL),(15227,'16027','P','Connoquenessing','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.814001,-80.014343,0,'2013-07-06 12:44:31',NULL,NULL),(16977,'17724','S','Gleason','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(78960,'98370','S','Pearson','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(65097,'77362','S','Pinehurst','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.163100,-95.682001,0,'2013-07-06 12:44:34',NULL,NULL),(4328,'02919','S','Johnston','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.820830,-71.505188,0,'2013-07-06 12:44:30',NULL,NULL),(37159,'41472','S','Blairs Mill','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(34695,'38828','S','New Harmony','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(25079,'27949','S','Collington','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.133440,-75.725400,0,'2013-07-06 12:44:31',NULL,NULL),(52318,'60555','S','Warrenville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.825491,-88.183156,0,'2013-07-06 12:44:33',NULL,NULL),(68753,'82225','S','Lusk','D','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.803734,-104.337239,0,'2013-07-06 12:44:34',NULL,NULL),(74858,'93254','S','New Cuyama','D','Santa Barbara','06083','California','CA','06','7480','661','Pacific',-8.0,'Y',34.942355,-119.664181,0,'2013-07-06 12:44:34',NULL,NULL),(76680,'95812','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.581929,-121.496349,0,'2013-07-06 12:44:34',NULL,NULL),(39768,'45120','S','Stringtown','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.823814,-84.104901,0,'2013-07-06 12:44:32',NULL,NULL),(6984,'06245','P','Fabyan','D','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',42.014244,-71.937164,0,'2013-07-06 12:44:30',NULL,NULL),(68272,'81076','S','Sugar City','D','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.251787,-103.665519,0,'2013-07-06 12:44:34',NULL,NULL),(58693,'68927','S','Bertrand','D','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.526584,-99.632651,0,'2013-07-06 12:44:33',NULL,NULL),(73744,'91714','P','City of Industry','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.019446,-117.957126,0,'2013-07-06 12:44:34',NULL,NULL),(3051,'01107','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122891,-72.607189,0,'2013-07-06 12:44:30',NULL,NULL),(41581,'47041','S','Blue Creek','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(5882,'05151','S','Greenbush','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.416944,-72.518333,0,'2013-07-06 12:44:30',NULL,NULL),(17488,'17960','S','Hecla','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(12117,'12590','S','Wappinger','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.595832,-73.887450,0,'2013-07-06 12:44:30',NULL,NULL),(23057,'24869','S','North Spring','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.523136,-81.799159,0,'2013-07-06 12:44:31',NULL,NULL),(60104,'71362','S','Choupique','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.920973,-91.990157,0,'2013-07-06 12:44:33',NULL,NULL),(41772,'47303','S','Royerton','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(30224,'33187','S','Perrine','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.585600,-80.504660,0,'2013-07-06 12:44:32',NULL,NULL),(19768,'20419','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902312,-77.031757,0,'2013-07-06 12:44:31',NULL,NULL),(29946,'33070','S','Tavernier','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',25.000353,-80.537936,0,'2013-07-06 12:44:32',NULL,NULL),(18388,'19048','U','Union Fidelity Busi Reply','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.176074,-74.924818,0,'2013-07-06 12:44:31',NULL,NULL),(69087,'83252','S','Malad','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(69893,'84105','S','S Salt Lake','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.734214,-111.856179,0,'2013-07-06 12:44:34',NULL,NULL),(70974,'85701','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.218157,-110.971902,0,'2013-07-06 12:44:34',NULL,NULL),(66604,'78759','S','Balcones','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.397200,-97.751760,0,'2013-07-06 12:44:34',NULL,NULL),(19986,'20598','U','McLean','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(37748,'42320','S','Schultztown','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(74799,'93201','P','Alpaugh','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',35.958590,-119.454962,0,'2013-07-06 12:44:34',NULL,NULL),(6594,'05861','P','Morses Mills','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.377353,-72.031425,0,'2013-07-06 12:44:30',NULL,NULL),(25980,'28661','P','Patterson','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.998515,-81.563991,0,'2013-07-06 12:44:31',NULL,NULL),(28649,'31768','S','Moultrie Municipal Airport','N','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.171229,-83.782941,0,'2013-07-06 12:44:32',NULL,NULL),(36965,'41175','S','South Shore','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.720129,-82.953687,0,'2013-07-06 12:44:32',NULL,NULL),(45194,'50616','S','Maple Heights','N','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.063262,-92.671092,0,'2013-07-06 12:44:32',NULL,NULL),(50119,'57501','S','Rousseau','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(58635,'68869','S','Cherry Creek','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(61171,'72190','P','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.798097,-92.256024,0,'2013-07-06 12:44:33',NULL,NULL),(69711,'84036','S','Deer Mountain','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(73922,'92025','S','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.098448,-117.084591,0,'2013-07-06 12:44:34',NULL,NULL),(21219,'22211','S','Ft Myer','A','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.886949,-77.078211,0,'2013-07-06 12:44:31',NULL,NULL),(43372,'48417','S','Burt','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.256877,-83.934520,0,'2013-07-06 12:44:32',NULL,NULL),(19230,'19902','S','Dover','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.120867,-75.478601,0,'2013-07-06 12:44:31',NULL,NULL),(58860,'69148','S','Lisco','D','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.567373,-102.545654,0,'2013-07-06 12:44:33',NULL,NULL),(48861,'56075','P','Northrop','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.720118,-94.442171,0,'2013-07-06 12:44:33',NULL,NULL),(36558,'40914','S','Peabody','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.151896,-83.620829,0,'2013-07-06 12:44:32',NULL,NULL),(27821,'30410','S','Ailey','D','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210400,-82.483320,0,'2013-07-06 12:44:31',NULL,NULL),(74171,'92274','S','100 Palms','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(76103,'95226','P','Campo Seco','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.224462,-120.859612,0,'2013-07-06 12:44:34',NULL,NULL),(60106,'71363','P','Rhinehart','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.633967,-91.998846,0,'2013-07-06 12:44:33',NULL,NULL),(65425,'77581','S','Brookside Village','A','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.560076,-95.275452,0,'2013-07-06 12:44:34',NULL,NULL),(6956,'06226','S','Perkins Corner','N','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.714269,-72.211943,0,'2013-07-06 12:44:30',NULL,NULL),(21044,'21874','S','Willards','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.402056,-75.353987,0,'2013-07-06 12:44:31',NULL,NULL),(48775,'55987','S','Wilson','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(59239,'70433','S','Saint Gertrude','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.457687,-90.114529,0,'2013-07-06 12:44:33',NULL,NULL),(59866,'71263','S','Chickasaw','N','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.840160,-91.467780,0,'2013-07-06 12:44:33',NULL,NULL),(8155,'07851','S','Sandyston','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.202354,-74.835004,0,'2013-07-06 12:44:30',NULL,NULL),(37894,'42629','S','Creelsboro','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.976422,-85.093378,0,'2013-07-06 12:44:32',NULL,NULL),(30807,'33614','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.007355,-82.515710,0,'2013-07-06 12:44:32',NULL,NULL),(59424,'70659','P','Rosepine','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.917057,-93.284478,0,'2013-07-06 12:44:33',NULL,NULL),(56752,'65726','P','Point Lookout','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.591308,-93.237370,0,'2013-07-06 12:44:33',NULL,NULL),(53255,'61701','S','Yuton','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(24348,'27041','S','Pilot Mt','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.450094,-80.489865,0,'2013-07-06 12:44:31',NULL,NULL),(32900,'36539','S','Yellow Pine','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.326277,-88.315502,0,'2013-07-06 12:44:32',NULL,NULL),(8703,'08360','S','South Vineland','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.480900,-75.010192,0,'2013-07-06 12:44:30',NULL,NULL),(60217,'71423','S','Rock Hill','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.618500,-92.570400,0,'2013-07-06 12:44:33',NULL,NULL),(1574,'00767','S','Urb Jaime C Rodriguez','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(55185,'63376','S','St Peters','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.780270,-90.624050,0,'2013-07-06 12:44:33',NULL,NULL),(52510,'60804','S','Cicero','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.843375,-87.763267,0,'2013-07-06 12:44:33',NULL,NULL),(17241,'17837','S','Kelly Point','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(67011,'79519','S','Goldsboro','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',32.049645,-99.654439,0,'2013-07-06 12:44:34',NULL,NULL),(61555,'72715','S','Bella Vista','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.467949,-94.297268,0,'2013-07-06 12:44:33',NULL,NULL),(32477,'36042','S','Honoraville','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.877638,-86.398740,0,'2013-07-06 12:44:32',NULL,NULL),(51325,'59258','S','Reserve','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.571511,-104.690538,0,'2013-07-06 12:44:33',NULL,NULL),(15747,'16911','P','Bloss','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.661491,-77.120959,0,'2013-07-06 12:44:31',NULL,NULL),(75789,'94707','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.899300,-122.276520,0,'2013-07-06 12:44:34',NULL,NULL),(74233,'92322','P','Cedarpines Pk','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.252934,-117.324200,0,'2013-07-06 12:44:34',NULL,NULL),(47781,'55043','S','St Croix Bch','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(67952,'80912','S','Falcon AFB','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(7303,'06605','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.167918,-73.216455,0,'2013-07-06 12:44:30',NULL,NULL),(33309,'37133','P','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.840269,-86.394053,0,'2013-07-06 12:44:32',NULL,NULL),(9607,'10031','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(52818,'61284','S','Taylor Ridge','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.389380,-90.725160,0,'2013-07-06 12:44:33',NULL,NULL),(10706,'11232','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.657218,-74.005878,0,'2013-07-06 12:44:30',NULL,NULL),(43199,'48303','P','Bloomfld Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(29378,'32606','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.696881,-82.411723,0,'2013-07-06 12:44:32',NULL,NULL),(15274,'16111','S','Atlantic','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.533678,-80.277496,0,'2013-07-06 12:44:31',NULL,NULL),(9760,'10103','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756711,-73.975074,0,'2013-07-06 12:44:30',NULL,NULL),(1058,'00725','S','Brisas del Parque II','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(33514,'37373','S','Bakewell','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.386080,-85.095951,0,'2013-07-06 12:44:32',NULL,NULL),(27778,'30374','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.576833,-84.394740,0,'2013-07-06 12:44:31',NULL,NULL),(13481,'13795','S','Kirkwood','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.067223,-75.796242,0,'2013-07-06 12:44:31',NULL,NULL),(21330,'22408','S','Frederickbg','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(55888,'64427','S','Bolckow','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',40.112616,-94.822092,0,'2013-07-06 12:44:33',NULL,NULL),(40806,'46183','P','West Newton','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.654145,-86.276621,0,'2013-07-06 12:44:32',NULL,NULL),(23511,'25544','S','Myra','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.228793,-82.136691,0,'2013-07-06 12:44:31',NULL,NULL),(22515,'24087','S','Ironto','A','Montgomery','51121','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.197300,-80.221200,0,'2013-07-06 12:44:31',NULL,NULL),(19788,'20429','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891450,-77.040790,0,'2013-07-06 12:44:31',NULL,NULL),(22242,'23661','S','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.005206,-76.382577,0,'2013-07-06 12:44:31',NULL,NULL),(3825,'02325','U','Bridgewater State College','N','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.992179,-70.972402,0,'2013-07-06 12:44:30',NULL,NULL),(27066,'29690','S','Travelers Rest','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.004060,-82.435522,0,'2013-07-06 12:44:31',NULL,NULL),(2581,'00961','S','Bda La Cambija','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(37716,'42274','S','Cavehill','N','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.951025,-86.601859,0,'2013-07-06 12:44:32',NULL,NULL),(52684,'61085','S','Stockton','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.330540,-90.049740,0,'2013-07-06 12:44:33',NULL,NULL),(71534,'87131','U','UNM','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.089423,-106.619821,0,'2013-07-06 12:44:34',NULL,NULL),(25278,'28129','S','Frog Pond','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.240371,-80.331644,0,'2013-07-06 12:44:31',NULL,NULL),(69485,'83677','S','Stibnite','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.043964,-115.369443,0,'2013-07-06 12:44:34',NULL,NULL),(47292,'54545','S','Manitowsh Wtr','A','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.088375,-89.821821,0,'2013-07-06 12:44:32',NULL,NULL),(78665,'98233','S','Burlington','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.503280,-122.360460,0,'2013-07-06 12:44:34',NULL,NULL),(4690,'03810','S','Alton Bay','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.481209,-71.247630,0,'2013-07-06 12:44:30',NULL,NULL),(7378,'06777','S','New Preston Marbledale','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(19192,'19808','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.731712,-75.669224,0,'2013-07-06 12:44:31',NULL,NULL),(69020,'83211','S','Raft River','N','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(67618,'80437','P','Evergreen','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.635589,-105.340787,0,'2013-07-06 12:44:34',NULL,NULL),(73701,'91608','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140376,-118.354334,0,'2013-07-06 12:44:34',NULL,NULL),(77265,'96598','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69468,'83655','S','New Plymouth','D','Payette','16075','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.958901,-116.807565,0,'2013-07-06 12:44:34',NULL,NULL),(68261,'81069','S','Cedarwood','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.927576,-104.902916,0,'2013-07-06 12:44:34',NULL,NULL),(67733,'80550','S','Windsor','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.480502,-104.904076,0,'2013-07-06 12:44:34',NULL,NULL),(30240,'33194','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.758515,-80.391867,0,'2013-07-06 12:44:32',NULL,NULL),(14379,'15034','S','Dravosburg','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.354283,-79.891157,0,'2013-07-06 12:44:31',NULL,NULL),(57781,'67468','S','Morganville','D','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.487741,-97.271667,0,'2013-07-06 12:44:33',NULL,NULL),(46606,'53561','S','Merrimac','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.374059,-89.674731,0,'2013-07-06 12:44:32',NULL,NULL),(19629,'20250','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884663,-77.030371,0,'2013-07-06 12:44:31',NULL,NULL),(25010,'27877','P','Severn','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.514701,-77.191721,0,'2013-07-06 12:44:31',NULL,NULL),(38467,'43617','S','Sylvania Twp','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.664110,-83.717316,0,'2013-07-06 12:44:32',NULL,NULL),(59001,'70062','S','Green Lawn Terrace','N','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.988618,-90.250441,0,'2013-07-06 12:44:33',NULL,NULL),(56623,'65588','S','Winona','D','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.056692,-91.230196,0,'2013-07-06 12:44:33',NULL,NULL),(75511,'94144','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.783348,-122.459783,0,'2013-07-06 12:44:34',NULL,NULL),(69134,'83301','S','CSI','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.447360,-114.538200,0,'2013-07-06 12:44:34',NULL,NULL),(52876,'61341','S','Marseilles','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.330121,-88.708340,0,'2013-07-06 12:44:33',NULL,NULL),(52355,'60609','S','Stock Yards','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.812837,-87.654243,0,'2013-07-06 12:44:33',NULL,NULL),(45796,'52170','S','Elon','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.271561,-91.258309,0,'2013-07-06 12:44:32',NULL,NULL),(1204,'00728','S','Parc Quebrada Limon','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(72109,'88241','P','Hobbs','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.752138,-103.164834,0,'2013-07-06 12:44:34',NULL,NULL),(65356,'77530','S','Channelview','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.789616,-95.120167,0,'2013-07-06 12:44:34',NULL,NULL),(63765,'75946','S','Fitze','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.799280,-94.485300,0,'2013-07-06 12:44:34',NULL,NULL),(53796,'62285','S','Smithton','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.390956,-90.011007,0,'2013-07-06 12:44:33',NULL,NULL),(53510,'62018','S','Cottage Hills','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.910511,-90.080602,0,'2013-07-06 12:44:33',NULL,NULL),(30519,'33405','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.671543,-80.059678,0,'2013-07-06 12:44:32',NULL,NULL),(34214,'38356','S','Medon','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.468906,-88.895631,0,'2013-07-06 12:44:32',NULL,NULL),(27011,'29640','S','Easley','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.830936,-82.589822,0,'2013-07-06 12:44:31',NULL,NULL),(24991,'27862','S','Pendleton','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.493067,-77.188974,0,'2013-07-06 12:44:31',NULL,NULL),(41407,'46815','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.113302,-85.061006,0,'2013-07-06 12:44:32',NULL,NULL),(56518,'65354','S','Syracuse','D','Morgan','29141','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.613552,-92.889351,0,'2013-07-06 12:44:33',NULL,NULL),(43004,'48160','S','York Twp','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(45121,'50562','S','Mallard','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.944100,-94.679280,0,'2013-07-06 12:44:32',NULL,NULL),(52951,'61415','S','Check Row','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.660240,-90.433285,0,'2013-07-06 12:44:33',NULL,NULL),(18901,'19474','P','Skippack','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.222746,-75.398674,0,'2013-07-06 12:44:31',NULL,NULL),(73160,'90295','P','Marina dl Rey','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.980879,-118.438136,0,'2013-07-06 12:44:34',NULL,NULL),(12748,'13204','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.052042,-76.177065,0,'2013-07-06 12:44:30',NULL,NULL),(66671,'78884','S','Utopia','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.567999,-99.569137,0,'2013-07-06 12:44:34',NULL,NULL),(59219,'70403','S','Hammond','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.485720,-90.475340,0,'2013-07-06 12:44:33',NULL,NULL),(45242,'50653','S','Marble Rock','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.966180,-92.880960,0,'2013-07-06 12:44:32',NULL,NULL),(40254,'45430','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(57593,'67102','S','Maple City','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.075655,-96.787476,0,'2013-07-06 12:44:33',NULL,NULL),(3690,'02134','S','Allston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358096,-71.130571,0,'2013-07-06 12:44:30',NULL,NULL),(67585,'80401','S','Golden','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.712606,-105.229868,0,'2013-07-06 12:44:34',NULL,NULL),(67123,'79743','P','Imperial','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',31.174613,-102.758500,0,'2013-07-06 12:44:34',NULL,NULL),(46145,'52655','S','West Burlington','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.826742,-91.165656,0,'2013-07-06 12:44:32',NULL,NULL),(75760,'94618','S','Piedmont','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.824444,-122.230556,0,'2013-07-06 12:44:34',NULL,NULL),(79918,'99605','S','Hope','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.915835,-149.635647,0,'2013-07-06 12:44:34',NULL,NULL),(72845,'89835','S','Oasis','A','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(49546,'56686','S','Long Point','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.977222,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(48284,'55434','S','Blaine','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.167369,-93.248268,0,'2013-07-06 12:44:33',NULL,NULL),(45971,'52403','S','Bertram','A','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.982434,-91.607252,0,'2013-07-06 12:44:32',NULL,NULL),(79126,'98497','P','Lakewood','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.177943,-122.547217,0,'2013-07-06 12:44:34',NULL,NULL),(75185,'93610','S','Fairmead','N','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.110099,-120.262938,0,'2013-07-06 12:44:34',NULL,NULL),(42290,'47588','S','Troy','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.996498,-86.801594,0,'2013-07-06 12:44:32',NULL,NULL),(17036,'17747','S','Loganton','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(18010,'18640','S','Inkerman','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(80186,'99901','S','Ketchikan','D','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.373751,-131.692560,0,'2013-07-06 12:44:34',NULL,NULL),(26896,'29575','S','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.626586,-78.983446,0,'2013-07-06 12:44:31',NULL,NULL),(26387,'29102','S','Jordan','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(60250,'71438','S','La Camp','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.149021,-92.748532,0,'2013-07-06 12:44:33',NULL,NULL),(44583,'50036','S','Boone','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.061308,-93.887441,0,'2013-07-06 12:44:32',NULL,NULL),(18237,'18974','S','Ivyland','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.208672,-75.079555,0,'2013-07-06 12:44:31',NULL,NULL),(70368,'84653','S','Woodland Hills','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.032330,-111.658857,0,'2013-07-06 12:44:34',NULL,NULL),(44928,'50340','P','Communications Data Service','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587244,-93.617538,0,'2013-07-06 12:44:32',NULL,NULL),(14126,'14650','U','Kodak Office','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.162172,-77.621673,0,'2013-07-06 12:44:31',NULL,NULL),(25161,'28034','S','Dallas','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.327855,-81.180475,0,'2013-07-06 12:44:31',NULL,NULL),(19873,'20528','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894924,-77.038234,0,'2013-07-06 12:44:31',NULL,NULL),(7441,'06838','P','Greens Farms','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.124408,-73.313937,0,'2013-07-06 12:44:30',NULL,NULL),(71082,'85927','S','Greer','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.013292,-109.457688,0,'2013-07-06 12:44:34',NULL,NULL),(15487,'16442','S','Wattsburg','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.025336,-79.824940,0,'2013-07-06 12:44:31',NULL,NULL),(27104,'29722','U','Lancaster','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.749579,-80.720816,0,'2013-07-06 12:44:31',NULL,NULL),(16443,'17236','S','Dickey','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(51201,'59035','P','Fort Smith','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.294259,-107.822552,0,'2013-07-06 12:44:33',NULL,NULL),(45635,'51640','S','Hamburg','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.636691,-95.653933,0,'2013-07-06 12:44:32',NULL,NULL),(13843,'14223','S','Tn of Tona','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(80170,'99827','S','Haines','D','Haines','02100','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.246751,-135.473655,0,'2013-07-06 12:44:34',NULL,NULL),(55749,'64105','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.105634,-94.518958,0,'2013-07-06 12:44:33',NULL,NULL),(22641,'24256','S','Haysi','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.222888,-82.286413,0,'2013-07-06 12:44:31',NULL,NULL),(4376,'03082','S','Lyndeborough','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.903214,-71.778697,0,'2013-07-06 12:44:30',NULL,NULL),(46688,'53782','U','WI Cheeseman','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.063213,-89.315194,0,'2013-07-06 12:44:32',NULL,NULL),(76898,'95981','S','Strawbrry Vly','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.564167,-121.105833,0,'2013-07-06 12:44:34',NULL,NULL),(57525,'67005','S','Arkansas City','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.071000,-97.059720,0,'2013-07-06 12:44:33',NULL,NULL),(20739,'21297','P','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295383,-76.609172,0,'2013-07-06 12:44:31',NULL,NULL),(16384,'17212','S','Big Cove Tann','A','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.882480,-78.020400,0,'2013-07-06 12:44:31',NULL,NULL),(30527,'33406','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(45307,'50837','S','Bridgewater','D','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.179961,-94.641678,0,'2013-07-06 12:44:32',NULL,NULL),(76144,'95296','U','Defense Dist Region','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.025975,-121.297271,0,'2013-07-06 12:44:34',NULL,NULL),(39270,'44454','S','Petersburg','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.919478,-80.537955,0,'2013-07-06 12:44:32',NULL,NULL),(56909,'66049','S','Laurence','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.970249,-95.279946,0,'2013-07-06 12:44:33',NULL,NULL),(38196,'43207','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.893940,-82.954080,0,'2013-07-06 12:44:32',NULL,NULL),(41018,'46377','P','Shelby','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.192768,-87.345317,0,'2013-07-06 12:44:32',NULL,NULL),(52407,'60638','S','Forest View','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781649,-87.774356,0,'2013-07-06 12:44:33',NULL,NULL),(26554,'29208','U','USC','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.975039,-81.007842,0,'2013-07-06 12:44:31',NULL,NULL),(21172,'22156','U','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.776500,-77.186403,0,'2013-07-06 12:44:31',NULL,NULL),(45063,'50514','S','Maple Hill','N','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.395460,-94.486346,0,'2013-07-06 12:44:32',NULL,NULL),(11442,'11975','P','Wainscott','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.952826,-72.249776,0,'2013-07-06 12:44:30',NULL,NULL),(32997,'36630','U','Press Register Inc','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.690024,-88.040823,0,'2013-07-06 12:44:32',NULL,NULL),(57834,'67546','S','Inman','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.228449,-97.772035,0,'2013-07-06 12:44:33',NULL,NULL),(27460,'30134','S','Douglasville','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.759987,-84.740136,0,'2013-07-06 12:44:31',NULL,NULL),(22212,'23518','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.916006,-76.221420,0,'2013-07-06 12:44:31',NULL,NULL),(72708,'89448','P','Wittell','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(21087,'22035','S','Fairfax County Government','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855217,-77.361501,0,'2013-07-06 12:44:31',NULL,NULL),(61407,'72554','S','Mammoth Spring','D','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.497654,-91.541940,0,'2013-07-06 12:44:33',NULL,NULL),(78939,'98366','S','Wautauga Beach','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(70177,'84328','S','Avon','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.556660,-111.818340,0,'2013-07-06 12:44:34',NULL,NULL),(72089,'88201','S','Pine Lodge','A','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.393099,-104.522917,0,'2013-07-06 12:44:34',NULL,NULL),(67538,'80260','S','Denver','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(63645,'75844','S','Reynard','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(16392,'17214','S','Blue Ridge Sm','A','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.730375,-77.470658,0,'2013-07-06 12:44:31',NULL,NULL),(58104,'68113','S','Omaha','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.124900,-95.916720,0,'2013-07-06 12:44:33',NULL,NULL),(55664,'64030','S','Grandview','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.884351,-94.519596,0,'2013-07-06 12:44:33',NULL,NULL),(54454,'62851','S','Keenes','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.364300,-88.656120,0,'2013-07-06 12:44:33',NULL,NULL),(31970,'35214','S','Forestdale','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573360,-86.893260,0,'2013-07-06 12:44:32',NULL,NULL),(9695,'10045','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(25689,'28525','S','Deep Run','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.127332,-77.727139,0,'2013-07-06 12:44:31',NULL,NULL),(64173,'76227','S','Providence Village','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(22938,'24631','S','Patterson','A','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.264444,-81.976111,0,'2013-07-06 12:44:31',NULL,NULL),(35781,'39747','S','Hendrix','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444845,-89.567673,0,'2013-07-06 12:44:32',NULL,NULL),(5764,'05042','S','Ryegate','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270278,-72.144444,0,'2013-07-06 12:44:30',NULL,NULL),(51011,'58704','S','Minot A F B','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.232500,-101.295833,0,'2013-07-06 12:44:33',NULL,NULL),(79741,'99223','S','Manito','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.611523,-117.358133,0,'2013-07-06 12:44:34',NULL,NULL),(23682,'25843','S','Ghent','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.615770,-81.098481,0,'2013-07-06 12:44:31',NULL,NULL),(23224,'25083','S','Livingston','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(61083,'72131','S','Enders','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.378007,-92.210229,0,'2013-07-06 12:44:33',NULL,NULL),(17031,'17745','S','Swissdale','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(33550,'37398','S','Winchester','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.188876,-86.111111,0,'2013-07-06 12:44:32',NULL,NULL),(74165,'92267','S','Black Meadow Landing','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.295930,-114.189406,0,'2013-07-06 12:44:34',NULL,NULL),(12239,'12821','S','Comstock','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.462256,-73.370925,0,'2013-07-06 12:44:30',NULL,NULL),(65777,'78113','S','Cestohowa','N','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.931521,-98.063035,0,'2013-07-06 12:44:34',NULL,NULL),(5773,'05048','S','Hartland','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.593558,-72.405864,0,'2013-07-06 12:44:30',NULL,NULL),(19297,'19975','S','West Fenwick','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.466300,-75.149820,0,'2013-07-06 12:44:31',NULL,NULL),(33745,'37841','S','Oneida','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.506945,-84.514883,0,'2013-07-06 12:44:32',NULL,NULL),(45731,'52099','U','McGraw Hill Companies','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.495882,-90.667512,0,'2013-07-06 12:44:32',NULL,NULL),(34984,'39098','P','Ludlow','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.572980,-89.709348,0,'2013-07-06 12:44:32',NULL,NULL),(4350,'03047','S','Greenfield','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.952011,-71.909796,0,'2013-07-06 12:44:30',NULL,NULL),(62612,'74535','P','Clarita','D','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.485498,-96.430578,0,'2013-07-06 12:44:33',NULL,NULL),(23053,'24868','S','Mc Dowell','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(8958,'08805','S','Bound Brk','N','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.569275,-74.539176,0,'2013-07-06 12:44:30',NULL,NULL),(74597,'92704','S','Diamond','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.724888,-117.908994,0,'2013-07-06 12:44:34',NULL,NULL),(70222,'84404','S','Harrisville','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(35181,'39282','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.254854,-90.248918,0,'2013-07-06 12:44:32',NULL,NULL),(33088,'36802','P','Opelika','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.594907,-85.314202,0,'2013-07-06 12:44:32',NULL,NULL),(19442,'20111','S','Manassas','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.737900,-77.422197,0,'2013-07-06 12:44:31',NULL,NULL),(11806,'12229','U','Mental Hygiene Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.650418,-73.814413,0,'2013-07-06 12:44:30',NULL,NULL),(17103,'17769','P','Slate Run','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.497576,-77.494553,0,'2013-07-06 12:44:31',NULL,NULL),(29431,'32681','P','Orange Lake','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.418125,-82.215695,0,'2013-07-06 12:44:32',NULL,NULL),(19198,'19810','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.820580,-75.508102,0,'2013-07-06 12:44:31',NULL,NULL),(22432,'24014','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.234614,-79.934731,0,'2013-07-06 12:44:31',NULL,NULL),(57278,'66554','S','Randolph','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.419266,-96.771329,0,'2013-07-06 12:44:33',NULL,NULL),(35288,'39401','S','Hattiesburg','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(15592,'16667','S','Saint Clairsv','A','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.160648,-78.508616,0,'2013-07-06 12:44:31',NULL,NULL),(17384,'17887','P','Whtdeer','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.077886,-76.875075,0,'2013-07-06 12:44:31',NULL,NULL),(66676,'78933','S','Cat Spring','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.745600,-96.391980,0,'2013-07-06 12:44:34',NULL,NULL),(40694,'46074','S','Westfield','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.037435,-86.153185,0,'2013-07-06 12:44:32',NULL,NULL),(8811,'08611','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.209791,-74.754696,0,'2013-07-06 12:44:30',NULL,NULL),(73864,'91913','S','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.651899,-116.982772,0,'2013-07-06 12:44:34',NULL,NULL),(76332,'95463','S','Navarro','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.126480,-123.547020,0,'2013-07-06 12:44:34',NULL,NULL),(29449,'32704','P','Apopka','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.611586,-81.498583,0,'2013-07-06 12:44:32',NULL,NULL),(33635,'37684','P','Mountain Home','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.306702,-82.377444,0,'2013-07-06 12:44:32',NULL,NULL),(44350,'49776','S','Posen','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.259026,-83.687804,0,'2013-07-06 12:44:32',NULL,NULL),(24923,'27807','S','Bailey','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.781949,-78.112790,0,'2013-07-06 12:44:31',NULL,NULL),(23615,'25711','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.399326,-82.449496,0,'2013-07-06 12:44:31',NULL,NULL),(28277,'31086','P','Smarr','D','Monroe','13207','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.876605,-84.058444,0,'2013-07-06 12:44:31',NULL,NULL),(37421,'41817','S','Garner','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.376981,-82.888568,0,'2013-07-06 12:44:32',NULL,NULL),(66493,'78674','P','Weir','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.673248,-97.588641,0,'2013-07-06 12:44:34',NULL,NULL),(68429,'81212','S','Penitentiary','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(67590,'80403','S','Golden','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.818028,-105.251370,0,'2013-07-06 12:44:34',NULL,NULL),(32045,'35253','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.486215,-86.740394,0,'2013-07-06 12:44:32',NULL,NULL),(56496,'65338','S','Lakeview Heights','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.436452,-93.404512,0,'2013-07-06 12:44:33',NULL,NULL),(43992,'49338','S','Paris','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.782718,-85.511821,0,'2013-07-06 12:44:32',NULL,NULL),(43693,'48885','S','Sidney','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.251891,-85.143329,0,'2013-07-06 12:44:32',NULL,NULL),(26023,'28677','S','Statesville West','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(35039,'39169','S','Tchula','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.179923,-90.223094,0,'2013-07-06 12:44:32',NULL,NULL),(37178,'41501','S','Gulnare','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(69932,'84113','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775548,-111.831028,0,'2013-07-06 12:44:34',NULL,NULL),(38328,'43430','S','Genoa','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.528738,-83.366522,0,'2013-07-06 12:44:32',NULL,NULL),(42334,'47634','S','Richland','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.912579,-87.201577,0,'2013-07-06 12:44:32',NULL,NULL),(18630,'19153','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.887687,-75.233918,0,'2013-07-06 12:44:31',NULL,NULL),(21964,'23238','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602561,-77.663297,0,'2013-07-06 12:44:31',NULL,NULL),(78532,'98132','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.466877,-122.290811,0,'2013-07-06 12:44:34',NULL,NULL),(7489,'06907','S','Springdale','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.094957,-73.519697,0,'2013-07-06 12:44:30',NULL,NULL),(17683,'18201','S','Hazle Townshp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.961962,-75.978971,0,'2013-07-06 12:44:31',NULL,NULL),(47259,'54526','S','Cedar Rapids','N','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.504780,-90.859620,0,'2013-07-06 12:44:32',NULL,NULL),(77906,'97305','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.016500,-122.912220,0,'2013-07-06 12:44:34',NULL,NULL),(26697,'29406','S','North Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.928960,-80.028420,0,'2013-07-06 12:44:31',NULL,NULL),(33354,'37181','S','Vanleer','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.223832,-87.460610,0,'2013-07-06 12:44:32',NULL,NULL),(70313,'84604','S','Sundance','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.264063,-111.623041,0,'2013-07-06 12:44:34',NULL,NULL),(79515,'98932','S','Granger','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.356411,-120.177287,0,'2013-07-06 12:44:34',NULL,NULL),(42804,'48050','S','New Haven','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.784440,-82.916880,0,'2013-07-06 12:44:32',NULL,NULL),(41661,'47145','S','Milltown','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.343123,-86.265723,0,'2013-07-06 12:44:32',NULL,NULL),(34356,'38589','S','Wilder','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.267190,-85.088335,0,'2013-07-06 12:44:32',NULL,NULL),(57293,'66617','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.128896,-95.639498,0,'2013-07-06 12:44:33',NULL,NULL),(5203,'04454','P','Lambert Lake','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.535033,-67.532780,0,'2013-07-06 12:44:30',NULL,NULL),(72740,'89506','S','Stead','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(6496,'05777','S','Clarendn Spgs','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.547778,-73.022778,0,'2013-07-06 12:44:30',NULL,NULL),(38488,'43661','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.652881,-83.604687,0,'2013-07-06 12:44:32',NULL,NULL),(41952,'47402','P','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.095551,-86.472738,0,'2013-07-06 12:44:32',NULL,NULL),(47852,'55076','S','South Saint Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.849779,-93.034529,0,'2013-07-06 12:44:33',NULL,NULL),(78113,'97499','S','Yoncalla','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.594580,-123.241089,0,'2013-07-06 12:44:34',NULL,NULL),(8452,'08087','S','Little Egg Harbor','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(43092,'48211','S','Hamtramck','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.380130,-83.051750,0,'2013-07-06 12:44:32',NULL,NULL),(11172,'11730','S','E Islip','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.728521,-73.186687,0,'2013-07-06 12:44:30',NULL,NULL),(55314,'63538','S','Mercyville','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.931558,-92.652345,0,'2013-07-06 12:44:33',NULL,NULL),(46325,'53079','S','Saint Cloud','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.795101,-88.175712,0,'2013-07-06 12:44:32',NULL,NULL),(60427,'71644','S','Grady','D','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.089960,-91.734240,0,'2013-07-06 12:44:33',NULL,NULL),(59078,'70117','S','Bywater','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.969240,-90.029607,0,'2013-07-06 12:44:33',NULL,NULL),(25714,'28542','P','Lejeune','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.697778,-77.352038,0,'2013-07-06 12:44:31',NULL,NULL),(57179,'66404','S','Baileyville','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.842643,-96.184862,0,'2013-07-06 12:44:33',NULL,NULL),(12488,'12993','S','Westport','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.229722,-73.460833,0,'2013-07-06 12:44:30',NULL,NULL),(35300,'39401','S','Oak Grove','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(6283,'05641','S','East Hill','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(53168,'61569','S','Trivoli','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.674929,-89.900903,0,'2013-07-06 12:44:33',NULL,NULL),(73004,'90063','S','Hazard','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.042454,-118.184723,0,'2013-07-06 12:44:34',NULL,NULL),(27252,'29928','S','Hilton Head','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.161512,-80.752518,0,'2013-07-06 12:44:31',NULL,NULL),(2415,'00953','S','Jard De Escorial','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(12953,'13357','S','Columbia Center','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(40548,'45850','S','Harrod','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.722062,-83.934773,0,'2013-07-06 12:44:32',NULL,NULL),(29404,'32634','P','Fairfield','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.371891,-82.278007,0,'2013-07-06 12:44:32',NULL,NULL),(73640,'91436','S','Encino','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165910,-118.463570,0,'2013-07-06 12:44:34',NULL,NULL),(6081,'05450','S','Bordoville','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(49509,'56667','S','Puposky','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(49190,'56442','S','Crosslake','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.677300,-94.112100,0,'2013-07-06 12:44:33',NULL,NULL),(43969,'49318','S','Casnovia','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.234973,-85.822420,0,'2013-07-06 12:44:32',NULL,NULL),(14780,'15351','P','Nemacolin','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.878790,-79.923804,0,'2013-07-06 12:44:31',NULL,NULL),(4944,'04093','S','West Buxton','N','York','23031','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.650262,-70.620203,0,'2013-07-06 12:44:30',NULL,NULL),(78675,'98241','S','Darrington','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.260325,-121.598034,0,'2013-07-06 12:44:34',NULL,NULL),(27971,'30560','S','Morganton','D','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.871631,-84.243732,0,'2013-07-06 12:44:31',NULL,NULL),(70657,'85203','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.438641,-111.800882,0,'2013-07-06 12:44:34',NULL,NULL),(14130,'14652','U','Kodak Park','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.150617,-77.728304,0,'2013-07-06 12:44:31',NULL,NULL),(48979,'56220','S','Canby','D','Yellow Medicine','27173','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.718043,-96.267661,0,'2013-07-06 12:44:33',NULL,NULL),(5578,'04911','S','Anson','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.796485,-69.894103,0,'2013-07-06 12:44:30',NULL,NULL),(35908,'40014','S','Orchard Grass Hills','A','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.337990,-85.443424,0,'2013-07-06 12:44:32',NULL,NULL),(41729,'47249','P','Freetown','A','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.956371,-86.204228,0,'2013-07-06 12:44:32',NULL,NULL),(16715,'17404','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.971839,-76.774584,0,'2013-07-06 12:44:31',NULL,NULL),(27001,'29632','U','Clemson University','N','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.685014,-82.811204,0,'2013-07-06 12:44:31',NULL,NULL),(25193,'28071','S','Gold Hill','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.476333,-80.346732,0,'2013-07-06 12:44:31',NULL,NULL),(68684,'82008','U','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.110745,-104.832693,0,'2013-07-06 12:44:34',NULL,NULL),(62915,'75077','S','Copper Canyon','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.047969,-96.994857,0,'2013-07-06 12:44:33',NULL,NULL),(53539,'62033','S','Mount Clare','N','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.107340,-89.842080,0,'2013-07-06 12:44:33',NULL,NULL),(31516,'34471','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.170260,-82.091441,0,'2013-07-06 12:44:32',NULL,NULL),(6373,'05680','S','North Wolcott','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.546700,-72.497820,0,'2013-07-06 12:44:30',NULL,NULL),(57526,'67005','S','Parkerfield','A','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.071000,-97.059720,0,'2013-07-06 12:44:33',NULL,NULL),(20367,'20878','S','N Potomac','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.105531,-77.240190,0,'2013-07-06 12:44:31',NULL,NULL),(32133,'35448','P','Clinton','D','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.915713,-87.991932,0,'2013-07-06 12:44:32',NULL,NULL),(210,'00624','S','Alt de Penuelas II','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(71511,'87114','S','Los Ranchos de Albuquerque','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(12377,'12916','S','Alburgh','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.827852,-74.530013,0,'2013-07-06 12:44:30',NULL,NULL),(58127,'68134','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.299209,-96.052153,0,'2013-07-06 12:44:33',NULL,NULL),(20156,'20738','P','Riverdale','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.963244,-76.929195,0,'2013-07-06 12:44:31',NULL,NULL),(42780,'48042','S','Macomb Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.684140,-82.918673,0,'2013-07-06 12:44:32',NULL,NULL),(4908,'04066','S','Orrs Island','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.775368,-69.956217,0,'2013-07-06 12:44:30',NULL,NULL),(73566,'91371','U','Pierce College','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.181136,-118.570613,0,'2013-07-06 12:44:34',NULL,NULL),(27554,'30256','S','Meansville','D','Pike','13231','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',32.981277,-84.328511,0,'2013-07-06 12:44:31',NULL,NULL),(67289,'80011','S','Buckley Air Force Base','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741650,-104.791421,0,'2013-07-06 12:44:34',NULL,NULL),(43058,'48188','S','Canton','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.288869,-83.477501,0,'2013-07-06 12:44:32',NULL,NULL),(29247,'32440','S','Graceville','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.957923,-85.510353,0,'2013-07-06 12:44:32',NULL,NULL),(75601,'94303','S','Palo Alto','D','Santa Clara','06085','California','CA','06','7360','650','Pacific',-8.0,'Y',37.449360,-122.125260,0,'2013-07-06 12:44:34',NULL,NULL),(39587,'44862','P','Ontario','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.757861,-82.646140,0,'2013-07-06 12:44:32',NULL,NULL),(38974,'44129','S','Parma','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386440,-81.737700,0,'2013-07-06 12:44:32',NULL,NULL),(27065,'29689','S','Townville','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.534882,-82.869969,0,'2013-07-06 12:44:31',NULL,NULL),(49943,'57339','S','Crow Creek','N','Buffalo','46017','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.065203,-99.326450,0,'2013-07-06 12:44:33',NULL,NULL),(43682,'48874','P','Pompeii','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.183115,-84.603069,0,'2013-07-06 12:44:32',NULL,NULL),(18965,'19512','S','Spangsville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(28223,'31036','S','Hville','N','Pulaski','13235','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.281988,-83.473610,0,'2013-07-06 12:44:31',NULL,NULL),(68678,'82003','P','Cheyenne','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.166322,-104.788243,0,'2013-07-06 12:44:34',NULL,NULL),(60423,'71642','S','Fountain Hill','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.344234,-91.818649,0,'2013-07-06 12:44:33',NULL,NULL),(59413,'70650','P','Lacassine','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.102183,-92.897773,0,'2013-07-06 12:44:33',NULL,NULL),(40172,'45369','S','S Vienna','N','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.956268,-83.612904,0,'2013-07-06 12:44:32',NULL,NULL),(47415,'54656','S','Fort McCoy','A','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.948001,-90.811171,0,'2013-07-06 12:44:32',NULL,NULL),(92,'00612','S','Sect Las Animas','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(32400,'35957','S','Boaz','D','Marshall','01095','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.148100,-86.148060,0,'2013-07-06 12:44:32',NULL,NULL),(8223,'07970','P','Mount Freedom','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.819130,-74.573930,0,'2013-07-06 12:44:30',NULL,NULL),(54904,'63080','S','Miramiguoa Park','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(70352,'84642','S','Manti','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.266611,-111.638160,0,'2013-07-06 12:44:34',NULL,NULL),(65908,'78236','S','Lackland A F B','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(55774,'64117','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.154167,-94.546667,0,'2013-07-06 12:44:33',NULL,NULL),(64382,'76530','S','Granger','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.730080,-97.435980,0,'2013-07-06 12:44:34',NULL,NULL),(59603,'71019','S','Edgefield','A','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(23767,'25969','S','Jumping Br','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.611675,-81.019615,0,'2013-07-06 12:44:31',NULL,NULL),(31858,'35118','S','Mulga','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.538080,-87.039240,0,'2013-07-06 12:44:32',NULL,NULL),(60774,'72016','S','Conway','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.881567,-92.692504,0,'2013-07-06 12:44:33',NULL,NULL),(55946,'64483','S','Rosendale','D','Andrew','29003','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',40.042615,-94.834753,0,'2013-07-06 12:44:33',NULL,NULL),(60789,'72025','S','Pontoon','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.030179,-93.036863,0,'2013-07-06 12:44:33',NULL,NULL),(68942,'82935','S','Green River','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.512073,-109.465736,0,'2013-07-06 12:44:34',NULL,NULL),(63074,'75241','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.656089,-96.746634,0,'2013-07-06 12:44:33',NULL,NULL),(54075,'62514','P','Boody','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.768379,-89.047204,0,'2013-07-06 12:44:33',NULL,NULL),(3852,'02348','U','Middleborough','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.877314,-70.946435,0,'2013-07-06 12:44:30',NULL,NULL),(18706,'19196','U','Classification & Rates Admin','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.957442,-75.184264,0,'2013-07-06 12:44:31',NULL,NULL),(71445,'87040','P','Paguate','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.875526,-107.282700,0,'2013-07-06 12:44:34',NULL,NULL),(33806,'37912','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.005751,-83.981348,0,'2013-07-06 12:44:32',NULL,NULL),(66166,'78520','S','Bville','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(76607,'95690','S','Vorden','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(60531,'71674','S','Red Fork','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.798097,-91.302406,0,'2013-07-06 12:44:33',NULL,NULL),(24227,'26726','S','Rocket Center','N','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.437003,-78.981107,0,'2013-07-06 12:44:31',NULL,NULL),(71493,'87106','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.079105,-106.617227,0,'2013-07-06 12:44:34',NULL,NULL),(51580,'59801','S','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858650,-114.039769,0,'2013-07-06 12:44:33',NULL,NULL),(66609,'78764','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.446819,-97.659758,0,'2013-07-06 12:44:34',NULL,NULL),(63332,'75574','S','Wards Creek','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.487706,-94.579844,0,'2013-07-06 12:44:33',NULL,NULL),(70411,'84720','S','Pintura','A','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.713174,-113.085548,0,'2013-07-06 12:44:34',NULL,NULL),(57970,'67801','S','Fort Dodge','A','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.757785,-100.018943,0,'2013-07-06 12:44:33',NULL,NULL),(51812,'60050','S','McCullom Lake','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(45246,'50657','S','Morrison','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.370549,-92.791105,0,'2013-07-06 12:44:32',NULL,NULL),(40756,'46144','P','Gwynneville','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.661231,-85.648483,0,'2013-07-06 12:44:32',NULL,NULL),(39315,'44555','U','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.101415,-80.643558,0,'2013-07-06 12:44:32',NULL,NULL),(12055,'12533','S','East Fishkill','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.573590,-73.796075,0,'2013-07-06 12:44:30',NULL,NULL),(20467,'21034','S','Darlington','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.646631,-76.223142,0,'2013-07-06 12:44:31',NULL,NULL),(60972,'72105','P','Jones Mill','D','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.437500,-92.887500,0,'2013-07-06 12:44:33',NULL,NULL),(60073,'71355','S','Lemoine Town','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.042265,-91.981920,0,'2013-07-06 12:44:33',NULL,NULL),(58153,'68175','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.266258,-95.964336,0,'2013-07-06 12:44:33',NULL,NULL),(74694,'93001','S','La Conchita','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.295546,-119.291976,0,'2013-07-06 12:44:34',NULL,NULL),(79711,'99212','S','Cty Spok Val','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(39344,'44622','S','Parral','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.551120,-81.445800,0,'2013-07-06 12:44:32',NULL,NULL),(40831,'46213','U','Ww Grainger Inc','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(77037,'96105','S','Chilcoot','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.814658,-120.211585,0,'2013-07-06 12:44:34',NULL,NULL),(78855,'98342','S','Indianola','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.760123,-122.531403,0,'2013-07-06 12:44:34',NULL,NULL),(11166,'11725','S','Commack','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.837825,-73.281154,0,'2013-07-06 12:44:30',NULL,NULL),(69593,'83845','S','Moyie Springs','D','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.698926,-116.305595,0,'2013-07-06 12:44:34',NULL,NULL),(21086,'22035','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855217,-77.361501,0,'2013-07-06 12:44:31',NULL,NULL),(56712,'65679','S','Kirbyville','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.567600,-93.114480,0,'2013-07-06 12:44:33',NULL,NULL),(50717,'58369','S','St John','N','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.943535,-99.785137,0,'2013-07-06 12:44:33',NULL,NULL),(77447,'96810','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304604,-157.858316,0,'2013-07-06 12:44:34',NULL,NULL),(19405,'20076','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(72544,'89185','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.150862,-115.113136,0,'2013-07-06 12:44:34',NULL,NULL),(3469,'01813','U','Woburn','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.508236,-71.123401,0,'2013-07-06 12:44:30',NULL,NULL),(79825,'99510','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.221987,-149.881690,0,'2013-07-06 12:44:34',NULL,NULL),(77443,'96808','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304528,-157.859432,0,'2013-07-06 12:44:34',NULL,NULL),(47133,'54455','S','Knowlton','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(53755,'62262','S','Mulberry Grv','A','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.924180,-89.270352,0,'2013-07-06 12:44:33',NULL,NULL),(13146,'13599','U','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.097704,-75.229256,0,'2013-07-06 12:44:30',NULL,NULL),(63220,'75455','S','Mt Pleasant','A','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.156354,-94.968910,0,'2013-07-06 12:44:33',NULL,NULL),(42653,'47944','S','Fowler','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.616380,-87.319872,0,'2013-07-06 12:44:32',NULL,NULL),(71442,'87037','P','Nageezi','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.420833,-107.866542,0,'2013-07-06 12:44:34',NULL,NULL),(64302,'76460','S','Loving','D','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',33.271184,-98.488628,0,'2013-07-06 12:44:34',NULL,NULL),(42092,'47460','S','Carp','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(57711,'67349','S','Howard','D','Elk','20049','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.513469,-96.231906,0,'2013-07-06 12:44:33',NULL,NULL),(57313,'66675','P','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.068882,-95.666739,0,'2013-07-06 12:44:33',NULL,NULL),(51724,'60010','S','Pt Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(17611,'18042','S','Williams Twp','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(23893,'26181','S','New England','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.244260,-81.639000,0,'2013-07-06 12:44:31',NULL,NULL),(20915,'21727','S','Emmitsburg','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.690794,-77.325830,0,'2013-07-06 12:44:31',NULL,NULL),(17571,'18010','P','Bangor','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.864800,-75.207300,0,'2013-07-06 12:44:31',NULL,NULL),(56757,'65730','S','Powell','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.576950,-94.155588,0,'2013-07-06 12:44:33',NULL,NULL),(55226,'63434','S','Bethel','D','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.906987,-92.040748,0,'2013-07-06 12:44:33',NULL,NULL),(50666,'58335','P','Ft Totten','N','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.975298,-98.994286,0,'2013-07-06 12:44:33',NULL,NULL),(46222,'52772','S','Cedar Bluff','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.788260,-91.131240,0,'2013-07-06 12:44:32',NULL,NULL),(59300,'70509','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.235928,-92.006147,0,'2013-07-06 12:44:33',NULL,NULL),(4548,'03449','S','Hancock','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.965726,-71.958274,0,'2013-07-06 12:44:30',NULL,NULL),(34744,'38851','S','Thorn','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897840,-88.990980,0,'2013-07-06 12:44:32',NULL,NULL),(72766,'89521','S','V C Highlands','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.379920,-119.753303,0,'2013-07-06 12:44:34',NULL,NULL),(66867,'79201','S','Childress','D','Childress','48075','Texas','TX','48','0000','940','Central',-6.0,'Y',34.432500,-100.145820,0,'2013-07-06 12:44:34',NULL,NULL),(73567,'91371','U','Woodland Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.181136,-118.570613,0,'2013-07-06 12:44:34',NULL,NULL),(18332,'19027','S','Lamott','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.017822,-75.135978,0,'2013-07-06 12:44:31',NULL,NULL),(30134,'33164','P','North Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.929334,-80.176758,0,'2013-07-06 12:44:32',NULL,NULL),(5650,'04954','P','North New Portland','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.883149,-70.088461,0,'2013-07-06 12:44:30',NULL,NULL),(17459,'17948','S','Boston Run','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(16850,'17562','S','Nickel Mines','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(64285,'76442','S','Hasse','A','Comanche','48093','Texas','TX','48','0000','325','Central',-6.0,'Y',31.936389,-98.488333,0,'2013-07-06 12:44:34',NULL,NULL),(39936,'45227','S','Fairfax','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.156000,-84.371400,0,'2013-07-06 12:44:32',NULL,NULL),(59577,'70892','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.447143,-91.156736,0,'2013-07-06 12:44:33',NULL,NULL),(41421,'46825','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.160774,-85.115233,0,'2013-07-06 12:44:32',NULL,NULL),(70658,'85204','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.401183,-111.790791,0,'2013-07-06 12:44:34',NULL,NULL),(126,'00612','S','Villa Toledo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(15466,'16423','S','Lake City','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.023251,-80.342156,0,'2013-07-06 12:44:31',NULL,NULL),(75411,'94022','S','Los Altos','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.366560,-122.136960,0,'2013-07-06 12:44:34',NULL,NULL),(78426,'98051','S','Palmer','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.362470,-121.896169,0,'2013-07-06 12:44:34',NULL,NULL),(64629,'76705','S','Gholson','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(42471,'47834','S','Dick Johnson','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(36581,'40955','P','Ingram','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.728551,-83.800519,0,'2013-07-06 12:44:32',NULL,NULL),(10051,'10175','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754254,-73.983164,0,'2013-07-06 12:44:30',NULL,NULL),(23398,'25317','U','WV Dept Of Motor Veh','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.360057,-81.570732,0,'2013-07-06 12:44:31',NULL,NULL),(5950,'05261','S','South Pownal','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.797700,-73.216680,0,'2013-07-06 12:44:30',NULL,NULL),(27385,'30081','P','Smyrna','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.870025,-84.518265,0,'2013-07-06 12:44:31',NULL,NULL),(31848,'35098','S','Logan','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.184538,-87.043005,0,'2013-07-06 12:44:32',NULL,NULL),(55718,'64076','S','Lake Lafayette','N','Lafayette','29107','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.996451,-93.953938,0,'2013-07-06 12:44:33',NULL,NULL),(36902,'41124','S','Cordell','N','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.035564,-82.858564,0,'2013-07-06 12:44:32',NULL,NULL),(48981,'56222','S','Clara City','D','Chippewa','27023','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.956332,-95.366841,0,'2013-07-06 12:44:33',NULL,NULL),(5951,'05262','S','North Shaftsbury','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.133333,-73.066667,0,'2013-07-06 12:44:30',NULL,NULL),(56065,'64746','S','Lake Annette','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.610172,-94.477945,0,'2013-07-06 12:44:33',NULL,NULL),(6815,'06110','S','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(41276,'46755','S','Round Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(13557,'13834','S','Portlandville','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.510775,-74.963599,0,'2013-07-06 12:44:31',NULL,NULL),(8050,'07735','S','Keyport','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.438200,-74.201940,0,'2013-07-06 12:44:30',NULL,NULL),(62719,'74764','S','Valliant','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.000260,-95.092994,0,'2013-07-06 12:44:33',NULL,NULL),(57300,'66622','U','Va Hospital','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.012994,-95.824145,0,'2013-07-06 12:44:33',NULL,NULL),(48726,'55959','S','Minn City','A','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087785,-91.743808,0,'2013-07-06 12:44:33',NULL,NULL),(6006,'05358','S','West Halifax','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.785580,-72.769500,0,'2013-07-06 12:44:30',NULL,NULL),(59920,'71291','S','Dean Chapel','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(27813,'30401','S','Gary','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(76223,'95375','P','Pinecrest','A','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.196233,-120.013415,0,'2013-07-06 12:44:34',NULL,NULL),(50025,'57421','S','Amherst','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.717219,-97.920215,0,'2013-07-06 12:44:33',NULL,NULL),(49964,'57350','S','Huron Colony','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.359540,-98.217645,0,'2013-07-06 12:44:33',NULL,NULL),(5971,'05340','S','Winhall','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.155180,-72.907980,0,'2013-07-06 12:44:30',NULL,NULL),(11299,'11777','S','Port Jeff Sta','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.925278,-73.047778,0,'2013-07-06 12:44:30',NULL,NULL),(61732,'73025','S','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.707680,-97.605383,0,'2013-07-06 12:44:33',NULL,NULL),(72944,'90038','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091104,-118.343030,0,'2013-07-06 12:44:34',NULL,NULL),(23392,'25313','S','Cross Lanes','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.410380,-81.753720,0,'2013-07-06 12:44:31',NULL,NULL),(31451,'34282','P','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.442104,-82.582522,0,'2013-07-06 12:44:32',NULL,NULL),(70475,'84764','P','Bryce','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.677100,-112.155661,0,'2013-07-06 12:44:34',NULL,NULL),(70936,'85639','P','Topawa','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.811855,-111.830315,0,'2013-07-06 12:44:34',NULL,NULL),(118,'00612','S','Urb Victor Rojas 1','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(64678,'76828','S','Burkett','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',32.008116,-99.311070,0,'2013-07-06 12:44:34',NULL,NULL),(3357,'01566','S','Sturbridge','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.110485,-72.076312,0,'2013-07-06 12:44:30',NULL,NULL),(59690,'71071','S','Sarepta','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.938210,-93.434653,0,'2013-07-06 12:44:33',NULL,NULL),(70295,'84534','P','Montezuma Creek','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.258327,-109.313639,0,'2013-07-06 12:44:34',NULL,NULL),(21403,'22514','S','Milford','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.008260,-77.345880,0,'2013-07-06 12:44:31',NULL,NULL),(28464,'31418','P','Garden City','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.150637,-81.194558,0,'2013-07-06 12:44:32',NULL,NULL),(39365,'44637','S','Killbuck','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.502447,-81.988483,0,'2013-07-06 12:44:32',NULL,NULL),(31086,'33867','S','Lake Wales','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.884462,-81.479590,0,'2013-07-06 12:44:32',NULL,NULL),(18779,'19369','P','Sadsburyville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.980041,-75.892351,0,'2013-07-06 12:44:31',NULL,NULL),(26302,'29033','S','Cayce','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.965536,-81.069156,0,'2013-07-06 12:44:31',NULL,NULL),(24638,'27371','S','Ophir','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(14710,'15268','U','National City Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.486226,-79.735977,0,'2013-07-06 12:44:31',NULL,NULL),(46471,'53217','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(55343,'63556','S','Reger','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(63021,'75181','S','Balch Springs','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.722807,-96.552108,0,'2013-07-06 12:44:33',NULL,NULL),(63686,'75861','S','Yard','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.885591,-95.920349,0,'2013-07-06 12:44:34',NULL,NULL),(65892,'78232','S','Hollywood Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584537,-98.475424,0,'2013-07-06 12:44:34',NULL,NULL),(68235,'81054','S','Deora','A','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(75948,'95039','S','Moss Landing','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.795167,-121.785283,0,'2013-07-06 12:44:34',NULL,NULL),(29319,'32539','S','Crestview','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.763784,-86.564408,0,'2013-07-06 12:44:32',NULL,NULL),(57565,'67051','S','Ashton','N','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.061520,-97.169220,0,'2013-07-06 12:44:33',NULL,NULL),(56726,'65704','S','Mansfield','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.111073,-92.584098,0,'2013-07-06 12:44:33',NULL,NULL),(13297,'13667','S','Norfolk','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.799692,-74.994368,0,'2013-07-06 12:44:30',NULL,NULL),(22481,'24059','S','Bent Mountain','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.153198,-80.128472,0,'2013-07-06 12:44:31',NULL,NULL),(15743,'16910','S','Alba','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.705551,-76.828782,0,'2013-07-06 12:44:31',NULL,NULL),(26289,'29021','P','Camden','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(68464,'81236','S','Alpine Village','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.700006,-106.141598,0,'2013-07-06 12:44:34',NULL,NULL),(56013,'64656','S','Ludlow','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.655647,-93.703058,0,'2013-07-06 12:44:33',NULL,NULL),(7300,'06601','P','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.176452,-73.202928,0,'2013-07-06 12:44:30',NULL,NULL),(30528,'33407','S','Mangonia Park','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.760988,-80.085606,0,'2013-07-06 12:44:32',NULL,NULL),(29033,'32232','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.292563,-81.635312,0,'2013-07-06 12:44:32',NULL,NULL),(52888,'61350','S','Dayton','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(3660,'02121','S','Grove Hall','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.306015,-71.084811,0,'2013-07-06 12:44:30',NULL,NULL),(5251,'04478','S','Tomhegan Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(17903,'18447','S','Scott Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.468875,-75.598476,0,'2013-07-06 12:44:31',NULL,NULL),(37542,'42056','S','La Center','D','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.101200,-88.969174,0,'2013-07-06 12:44:32',NULL,NULL),(13787,'14169','P','Wales Center','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.766324,-78.527795,0,'2013-07-06 12:44:31',NULL,NULL),(34028,'38132','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.062992,-89.976596,0,'2013-07-06 12:44:32',NULL,NULL),(16456,'17241','S','Bloserville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(14486,'15135','S','Boston','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.303777,-79.815605,0,'2013-07-06 12:44:31',NULL,NULL),(29327,'32542','S','Elgin AFB','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(27133,'29810','S','Allendale','D','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.006169,-81.306627,0,'2013-07-06 12:44:31',NULL,NULL),(45959,'52358','S','Cedar Valley','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(74869,'93262','S','Sequoia National Park','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.595201,-118.840408,0,'2013-07-06 12:44:34',NULL,NULL),(76738,'95912','S','Arbuckle','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.032646,-122.014634,0,'2013-07-06 12:44:34',NULL,NULL),(43292,'48335','S','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.466205,-83.401727,0,'2013-07-06 12:44:32',NULL,NULL),(45870,'52247','S','Kalona','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.487300,-91.707929,0,'2013-07-06 12:44:32',NULL,NULL),(11763,'12197','S','South Worcester','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.517778,-74.750278,0,'2013-07-06 12:44:30',NULL,NULL),(14555,'15212','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.469880,-80.015700,0,'2013-07-06 12:44:31',NULL,NULL),(35920,'40032','U','Ky State Reformatory','N','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.422760,-85.393054,0,'2013-07-06 12:44:32',NULL,NULL),(33529,'37380','S','South Pittsburg','D','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.009705,-85.711704,0,'2013-07-06 12:44:32',NULL,NULL),(78097,'97487','S','Veneta','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.046249,-123.349478,0,'2013-07-06 12:44:34',NULL,NULL),(47232,'54501','S','Pelican','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(53939,'62417','S','Lukin','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.710903,-87.758111,0,'2013-07-06 12:44:33',NULL,NULL),(55349,'63559','S','Martinstown','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.297763,-92.752391,0,'2013-07-06 12:44:33',NULL,NULL),(42264,'47581','S','East Shoals','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(38590,'43821','S','Adams Mills','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.122240,-81.986160,0,'2013-07-06 12:44:32',NULL,NULL),(11048,'11572','S','Rockville Ctr','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.658611,-73.641667,0,'2013-07-06 12:44:30',NULL,NULL),(30476,'33346','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.123836,-80.142332,0,'2013-07-06 12:44:32',NULL,NULL),(29270,'32459','S','Santa Rosa Beach','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.359723,-86.237832,0,'2013-07-06 12:44:32',NULL,NULL),(22354,'23891','U','Sussex Correctional Facility','N','Sussex','51183','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.036209,-77.096824,0,'2013-07-06 12:44:31',NULL,NULL),(52462,'60678','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.883935,-87.631729,0,'2013-07-06 12:44:33',NULL,NULL),(53887,'62353','S','Mt Sterling','A','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985995,-90.767312,0,'2013-07-06 12:44:33',NULL,NULL),(59162,'70310','U','Nicholls State University','N','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.789115,-90.822503,0,'2013-07-06 12:44:33',NULL,NULL),(65000,'77293','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.861517,-95.343954,0,'2013-07-06 12:44:34',NULL,NULL),(66386,'78624','S','Fredericksbg','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(38667,'43950','S','Saint Clairsville','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.082971,-80.912626,0,'2013-07-06 12:44:32',NULL,NULL),(33427,'37246','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.166280,-86.783735,0,'2013-07-06 12:44:32',NULL,NULL),(54417,'62832','S','Saint Johns','N','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.009216,-89.237329,0,'2013-07-06 12:44:33',NULL,NULL),(52109,'60416','S','Eileen','N','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.291648,-88.285221,0,'2013-07-06 12:44:33',NULL,NULL),(49712,'57036','S','Flyger','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.287240,-97.160340,0,'2013-07-06 12:44:33',NULL,NULL),(7635,'07065','S','Rahway','D','Union','34039','New Jersey','NJ','34','5640','732/848','Eastern',-5.0,'Y',40.609500,-74.280683,0,'2013-07-06 12:44:30',NULL,NULL),(40137,'45339','S','Ludlow Falls','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.002325,-84.346362,0,'2013-07-06 12:44:32',NULL,NULL),(34763,'38862','S','Plantersville','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.197376,-88.663986,0,'2013-07-06 12:44:32',NULL,NULL),(64666,'76820','S','Art','D','Mason','48319','Texas','TX','48','0000','325','Central',-6.0,'Y',30.773207,-99.068384,0,'2013-07-06 12:44:34',NULL,NULL),(25494,'28365','S','Mount Olive','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.197486,-78.066179,0,'2013-07-06 12:44:31',NULL,NULL),(44591,'50043','P','Buckeye','D','Hardin','19083','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.520278,-93.375833,0,'2013-07-06 12:44:32',NULL,NULL),(48372,'55560','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814543,-93.919775,0,'2013-07-06 12:44:33',NULL,NULL),(68663,'81650','S','Rulison','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.540153,-107.790633,0,'2013-07-06 12:44:34',NULL,NULL),(69163,'83321','S','Castleford','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.522145,-114.871179,0,'2013-07-06 12:44:34',NULL,NULL),(70013,'84126','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700114,-111.948523,0,'2013-07-06 12:44:34',NULL,NULL),(71430,'87028','S','La Joya','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.390372,-106.803839,0,'2013-07-06 12:44:34',NULL,NULL),(5510,'04768','S','Portage Lake','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.789204,-68.541710,0,'2013-07-06 12:44:30',NULL,NULL),(30493,'33388','S','Fort Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.117073,-80.254184,0,'2013-07-06 12:44:32',NULL,NULL),(79482,'98901','S','Sumach','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606829,-120.465379,0,'2013-07-06 12:44:34',NULL,NULL),(78775,'98312','S','Brem','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(40841,'46219','S','Irvington','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.780423,-86.044659,0,'2013-07-06 12:44:32',NULL,NULL),(9612,'10032','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(10313,'10536','S','Lake Katonah','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.272380,-73.689240,0,'2013-07-06 12:44:30',NULL,NULL),(74200,'92285','S','Johnson Valley','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.313640,-116.448000,0,'2013-07-06 12:44:34',NULL,NULL),(6741,'06080','U','Suffield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.982198,-72.649731,0,'2013-07-06 12:44:30',NULL,NULL),(32286,'35662','P','Muscle Shoals','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.744680,-87.667500,0,'2013-07-06 12:44:32',NULL,NULL),(56148,'64850','S','Neosho','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.863757,-94.373223,0,'2013-07-06 12:44:33',NULL,NULL),(9858,'10120','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(41232,'46738','S','Altona','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(40124,'45327','S','Germantown','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.631562,-84.383463,0,'2013-07-06 12:44:32',NULL,NULL),(39451,'44704','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.800224,-81.353797,0,'2013-07-06 12:44:32',NULL,NULL),(3442,'01760','S','N Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(3143,'01255','S','Sandisfield','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.117840,-73.134120,0,'2013-07-06 12:44:30',NULL,NULL),(23574,'25654','S','Yolyn','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.870920,-81.873300,0,'2013-07-06 12:44:31',NULL,NULL),(25664,'28508','S','Albertson','D','Duplin','37061','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.113254,-77.852057,0,'2013-07-06 12:44:31',NULL,NULL),(32672,'36266','S','Barfield','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(32488,'36052','S','Mathews','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.128288,-86.041262,0,'2013-07-06 12:44:32',NULL,NULL),(49850,'57238','S','Goodwin','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.894100,-96.792780,0,'2013-07-06 12:44:33',NULL,NULL),(68185,'81022','S','North Avondale','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.179817,-104.390761,0,'2013-07-06 12:44:34',NULL,NULL),(72946,'90038','S','West Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091104,-118.343030,0,'2013-07-06 12:44:34',NULL,NULL),(73082,'90213','P','Beverly Hills','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.054812,-118.404164,0,'2013-07-06 12:44:34',NULL,NULL),(66574,'78741','S','Montopolis','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.234123,-97.718296,0,'2013-07-06 12:44:34',NULL,NULL),(5403,'04657','S','Cathance Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.019171,-67.386095,0,'2013-07-06 12:44:30',NULL,NULL),(62206,'73842','S','Freedom','D','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.881486,-99.165009,0,'2013-07-06 12:44:33',NULL,NULL),(14870,'15465','P','Mt Braddock','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.940953,-79.645633,0,'2013-07-06 12:44:31',NULL,NULL),(57303,'66625','U','Ks Dept of Revenue Taxation','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.047811,-95.683248,0,'2013-07-06 12:44:33',NULL,NULL),(51613,'59833','S','Florence','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.628966,-114.065961,0,'2013-07-06 12:44:33',NULL,NULL),(51367,'59349','S','Terry','D','Prairie','30079','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.791173,-105.314661,0,'2013-07-06 12:44:33',NULL,NULL),(75748,'94610','S','Piedmont','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.815060,-122.239672,0,'2013-07-06 12:44:34',NULL,NULL),(26056,'28691','P','Banner Elk','A','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.207601,-81.885029,0,'2013-07-06 12:44:31',NULL,NULL),(18156,'18848','S','Burlington Township','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.770672,-76.447490,0,'2013-07-06 12:44:31',NULL,NULL),(12168,'12754','S','Liberty','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.798793,-74.749431,0,'2013-07-06 12:44:30',NULL,NULL),(24365,'27051','S','Walkertown','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.176386,-80.164168,0,'2013-07-06 12:44:31',NULL,NULL),(8835,'08629','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218249,-74.730652,0,'2013-07-06 12:44:30',NULL,NULL),(34514,'38676','S','North Tunica','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(28256,'31067','P','Oconee','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.864936,-82.874224,0,'2013-07-06 12:44:31',NULL,NULL),(3035,'01097','P','Woronoco','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.160733,-72.839797,0,'2013-07-06 12:44:30',NULL,NULL),(53057,'61490','S','Nekoma','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.178623,-90.315302,0,'2013-07-06 12:44:33',NULL,NULL),(73103,'90241','S','Downey','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.940169,-118.129391,0,'2013-07-06 12:44:34',NULL,NULL),(75654,'94531','S','Antioch','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.996725,-121.807911,0,'2013-07-06 12:44:34',NULL,NULL),(38799,'44064','S','Montville','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.597486,-81.050426,0,'2013-07-06 12:44:32',NULL,NULL),(66087,'78402','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.824407,-97.388526,0,'2013-07-06 12:44:34',NULL,NULL),(55563,'63867','S','Matthews','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.757869,-89.587967,0,'2013-07-06 12:44:33',NULL,NULL),(47804,'55052','S','Morristown','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.231894,-93.437267,0,'2013-07-06 12:44:33',NULL,NULL),(11085,'11692','S','Far Rockaway','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.590874,-73.796576,0,'2013-07-06 12:44:30',NULL,NULL),(43303,'48346','S','Independence','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722381,-83.418152,0,'2013-07-06 12:44:32',NULL,NULL),(77607,'96942','P','Chuuk Caroline Islands','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',7.323877,151.653461,0,'2013-07-06 12:44:34',NULL,NULL),(13712,'14069','S','Glenwood','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.598702,-78.639675,0,'2013-07-06 12:44:31',NULL,NULL),(29453,'32708','S','Winter Spgs','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.681020,-81.280800,0,'2013-07-06 12:44:32',NULL,NULL),(34894,'38950','S','Philipp','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.745493,-90.213618,0,'2013-07-06 12:44:32',NULL,NULL),(36299,'40360','S','Owingsville','D','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.143221,-83.767490,0,'2013-07-06 12:44:32',NULL,NULL),(43098,'48215','S','Grosse Pointe','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.387720,-82.950600,0,'2013-07-06 12:44:32',NULL,NULL),(6970,'06238','S','Coventry','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780214,-72.330677,0,'2013-07-06 12:44:30',NULL,NULL),(70598,'85098','U','Ctc Florist','N','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.448261,-112.075768,0,'2013-07-06 12:44:34',NULL,NULL),(33077,'36776','S','Sawyerville','D','Hale','01065','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.705802,-87.599073,0,'2013-07-06 12:44:32',NULL,NULL),(9679,'10043','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759473,-73.973389,0,'2013-07-06 12:44:30',NULL,NULL),(42692,'47987','S','Veedersburg','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.114114,-87.265455,0,'2013-07-06 12:44:32',NULL,NULL),(44992,'50438','S','Garner','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.114320,-93.553740,0,'2013-07-06 12:44:32',NULL,NULL),(13714,'14072','S','Grand Island','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.013771,-78.958496,0,'2013-07-06 12:44:31',NULL,NULL),(35782,'39747','S','Kilmichael','D','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.444845,-89.567673,0,'2013-07-06 12:44:32',NULL,NULL),(28358,'31205','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.750172,-83.661143,0,'2013-07-06 12:44:32',NULL,NULL),(6711,'06066','S','Vernon','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(35542,'39563','S','Eastside','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(33513,'37371','P','Athens','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.443149,-84.594792,0,'2013-07-06 12:44:32',NULL,NULL),(15343,'16232','S','Knox','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.238308,-79.542215,0,'2013-07-06 12:44:31',NULL,NULL),(17012,'17740','S','Oriole','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(78370,'98022','S','Crystal Mountain','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(70129,'84244','U','Internal Revenue Service','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.260364,-111.970792,0,'2013-07-06 12:44:34',NULL,NULL),(48864,'56080','P','St Clair','N','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.080602,-93.853972,0,'2013-07-06 12:44:33',NULL,NULL),(48117,'55355','S','Litchfield','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.126741,-94.527010,0,'2013-07-06 12:44:33',NULL,NULL),(6422,'05741','P','Poultney','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.527104,-73.206396,0,'2013-07-06 12:44:30',NULL,NULL),(36314,'40379','S','Minorsville','N','Scott','21209','Kentucky','KY','21','4280','502','Eastern',-5.0,'Y',38.296886,-84.675833,0,'2013-07-06 12:44:32',NULL,NULL),(15734,'16901','S','Delmar','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(26907,'29579','S','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.655004,-78.945276,0,'2013-07-06 12:44:31',NULL,NULL),(38791,'44060','S','Concord Twp','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(49162,'56393','U','Fingerhut Sweepstakes','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.567555,-94.217111,0,'2013-07-06 12:44:33',NULL,NULL),(57728,'67410','S','Industry','A','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.921079,-97.220096,0,'2013-07-06 12:44:33',NULL,NULL),(60721,'71953','S','Potter Junction','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(73636,'91423','S','Sherman Oaks','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151353,-118.435422,0,'2013-07-06 12:44:34',NULL,NULL),(80176,'99835','S','Sitka','D','Sitka','02220','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.061324,-135.339294,0,'2013-07-06 12:44:34',NULL,NULL),(39308,'44512','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.041680,-80.685600,0,'2013-07-06 12:44:32',NULL,NULL),(23685,'25846','S','Glen Jean','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.898425,-81.161008,0,'2013-07-06 12:44:31',NULL,NULL),(61744,'73038','S','Fort Cobb','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.119620,-98.433720,0,'2013-07-06 12:44:33',NULL,NULL),(4098,'02672','P','West Hyannisport','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.633467,-70.326399,0,'2013-07-06 12:44:30',NULL,NULL),(37475,'42001','S','Kentucky Oaks Mall','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(31260,'33991','S','Matlacha Isle','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.629052,-82.002027,0,'2013-07-06 12:44:32',NULL,NULL),(78890,'98358','S','Marrowstone Is','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(24120,'26542','S','Masontown','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.582126,-79.799220,0,'2013-07-06 12:44:31',NULL,NULL),(78617,'98199','S','Magnolia','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.649774,-122.398314,0,'2013-07-06 12:44:34',NULL,NULL),(28519,'31545','S','Doctortown','N','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.612517,-81.885560,0,'2013-07-06 12:44:32',NULL,NULL),(13772,'14140','P','Springbrook','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.801249,-78.665071,0,'2013-07-06 12:44:31',NULL,NULL),(32980,'36613','S','Eight Mile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.834480,-88.194240,0,'2013-07-06 12:44:32',NULL,NULL),(36861,'41083','S','Sanders','D','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.664881,-84.996614,0,'2013-07-06 12:44:32',NULL,NULL),(39797,'45135','S','Clinton County','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(19153,'19712','U','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.682928,-75.719180,0,'2013-07-06 12:44:31',NULL,NULL),(12769,'13210','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.034249,-76.126286,0,'2013-07-06 12:44:30',NULL,NULL),(32150,'35466','S','Gordo','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.397012,-87.891649,0,'2013-07-06 12:44:32',NULL,NULL),(25890,'28643','S','Bly','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(24377,'27055','S','Lone Hickory','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(63842,'75974','S','Woods','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(62605,'74528','S','Blanco','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.769841,-95.795960,0,'2013-07-06 12:44:33',NULL,NULL),(52323,'60558','S','Western Springs','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.804602,-87.896988,0,'2013-07-06 12:44:33',NULL,NULL),(1397,'00738','S','Urb Batey','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(79657,'99151','P','Marcus','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.665471,-118.067892,0,'2013-07-06 12:44:34',NULL,NULL),(79587,'99029','S','Reardan','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.732251,-117.765723,0,'2013-07-06 12:44:34',NULL,NULL),(79314,'98597','S','Yelm','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.898012,-122.559896,0,'2013-07-06 12:44:34',NULL,NULL),(75274,'93706','S','Rolinda','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.702391,-119.837956,0,'2013-07-06 12:44:34',NULL,NULL),(65126,'77380','S','The Woodlands','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.140487,-95.471451,0,'2013-07-06 12:44:34',NULL,NULL),(17957,'18519','S','Dickson City','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.462308,-75.625366,0,'2013-07-06 12:44:31',NULL,NULL),(22639,'24251','S','Gate City','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.633269,-82.573483,0,'2013-07-06 12:44:31',NULL,NULL),(32913,'36548','S','Prestwick','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.516479,-87.896552,0,'2013-07-06 12:44:32',NULL,NULL),(33154,'37012','S','Alexandria','D','DeKalb','47041','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.076957,-86.036250,0,'2013-07-06 12:44:32',NULL,NULL),(36193,'40258','S','Pleasure Rdge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.142310,-85.861886,0,'2013-07-06 12:44:32',NULL,NULL),(9842,'10116','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(37036,'41260','S','Thelma','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.803373,-82.771002,0,'2013-07-06 12:44:32',NULL,NULL),(9136,'09226','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(17300,'17851','S','Natalie','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(70399,'84713','S','Cove Fort','N','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.298252,-112.716345,0,'2013-07-06 12:44:34',NULL,NULL),(73108,'90249','S','Gardena','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.897921,-118.318018,0,'2013-07-06 12:44:34',NULL,NULL),(44474,'49894','S','Wells','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.778408,-87.074986,0,'2013-07-06 12:44:32',NULL,NULL),(36997,'41219','S','Fuget','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.947400,-82.887743,0,'2013-07-06 12:44:32',NULL,NULL),(44733,'50160','P','Martensdale','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.375259,-93.741040,0,'2013-07-06 12:44:32',NULL,NULL),(67574,'80305','S','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.015905,-105.270922,0,'2013-07-06 12:44:34',NULL,NULL),(69944,'84116','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.785043,-111.930074,0,'2013-07-06 12:44:34',NULL,NULL),(62588,'74469','S','Warner','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.489455,-95.302917,0,'2013-07-06 12:44:33',NULL,NULL),(56990,'66203','S','Op','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(52461,'60678','U','American National Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.883935,-87.631729,0,'2013-07-06 12:44:33',NULL,NULL),(48067,'55328','S','Delano','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.036101,-93.816580,0,'2013-07-06 12:44:33',NULL,NULL),(17656,'18080','S','Emerald','A','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.734472,-75.615565,0,'2013-07-06 12:44:31',NULL,NULL),(21917,'23221','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.558348,-77.488650,0,'2013-07-06 12:44:31',NULL,NULL),(44511,'49942','P','Calumet','A','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.269521,-88.416753,0,'2013-07-06 12:44:32',NULL,NULL),(17,'00603','S','Bda Esteves','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(63230,'75462','S','Paris','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.667380,-95.500320,0,'2013-07-06 12:44:33',NULL,NULL),(26038,'28682','S','Terrell','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.583276,-80.964993,0,'2013-07-06 12:44:31',NULL,NULL),(69679,'84023','S','Greendale','N','Daggett','49009','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.932867,-109.392096,0,'2013-07-06 12:44:34',NULL,NULL),(75110,'93545','S','Lone Pine','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.588000,-118.056263,0,'2013-07-06 12:44:34',NULL,NULL),(79148,'98501','S','Tumwater','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(64170,'76227','S','Aubrey','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(57655,'67207','S','Eastborough','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.668530,-97.231169,0,'2013-07-06 12:44:33',NULL,NULL),(34150,'38238','U','University of Tn','N','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.344329,-88.858264,0,'2013-07-06 12:44:32',NULL,NULL),(17745,'18322','S','Brodheadsville','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.954238,-75.359905,0,'2013-07-06 12:44:31',NULL,NULL),(39911,'45217','S','Ivorydale','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.165637,-84.495829,0,'2013-07-06 12:44:32',NULL,NULL),(19122,'19608','S','Mohns Hill','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(43747,'49006','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.293748,-85.624140,0,'2013-07-06 12:44:32',NULL,NULL),(20853,'21657','S','Queen Anne','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.956946,-75.993085,0,'2013-07-06 12:44:31',NULL,NULL),(7369,'06762','S','Middlebury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.528087,-73.119229,0,'2013-07-06 12:44:30',NULL,NULL),(38614,'43907','S','Moorefield','A','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.258860,-81.031320,0,'2013-07-06 12:44:32',NULL,NULL),(70718,'85284','S','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.336825,-111.921246,0,'2013-07-06 12:44:34',NULL,NULL),(8213,'07946','S','Millington','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.685934,-74.514584,0,'2013-07-06 12:44:30',NULL,NULL),(44608,'50054','S','Green Castle','N','Jasper','19099','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.681400,-93.267900,0,'2013-07-06 12:44:32',NULL,NULL),(15932,'17021','S','Ewtrford','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(61242,'72341','P','Haynes','D','Lee','05077','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.871575,-90.729171,0,'2013-07-06 12:44:33',NULL,NULL),(78196,'97733','S','Crescent Lake','A','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.509329,-121.741618,0,'2013-07-06 12:44:34',NULL,NULL),(34902,'38954','S','Sidon','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.461906,-90.211639,0,'2013-07-06 12:44:32',NULL,NULL),(12697,'13142','S','Fernwood','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.557794,-76.128407,0,'2013-07-06 12:44:30',NULL,NULL),(41882,'47369','S','Balbee','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.492708,-85.149190,0,'2013-07-06 12:44:32',NULL,NULL),(2606,'00961','S','Urb Santa Cruz','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(77634,'97007','S','Aloha','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.472666,-122.856983,0,'2013-07-06 12:44:34',NULL,NULL),(70876,'85607','S','Paul Spur','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.351622,-109.543515,0,'2013-07-06 12:44:34',NULL,NULL),(28514,'31539','S','Hazlehurst','D','Jeff Davis','13161','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.866984,-82.600623,0,'2013-07-06 12:44:32',NULL,NULL),(18069,'18704','S','Pringle','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(13383,'13740','S','Bovina Center','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.261944,-74.785000,0,'2013-07-06 12:44:31',NULL,NULL),(15519,'16534','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.124628,-80.085466,0,'2013-07-06 12:44:31',NULL,NULL),(64621,'76693','S','Currie','N','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.784137,-96.463313,0,'2013-07-06 12:44:34',NULL,NULL),(35964,'40070','S','Sulphur','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.488992,-85.232317,0,'2013-07-06 12:44:32',NULL,NULL),(35472,'39507','S','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.394254,-89.037041,0,'2013-07-06 12:44:32',NULL,NULL),(16639,'17339','S','Lewisberry','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.126080,-76.876560,0,'2013-07-06 12:44:31',NULL,NULL),(71368,'87001','S','Algodones','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.382532,-106.479515,0,'2013-07-06 12:44:34',NULL,NULL),(75296,'93727','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.753992,-119.698212,0,'2013-07-06 12:44:34',NULL,NULL),(57354,'66735','S','Franklin','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.526013,-94.712368,0,'2013-07-06 12:44:33',NULL,NULL),(71692,'87519','P','Cerro','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.736728,-105.473869,0,'2013-07-06 12:44:34',NULL,NULL),(69356,'83547','S','Pollock','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.283647,-116.351230,0,'2013-07-06 12:44:34',NULL,NULL),(66219,'78558','P','La Blanca','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.310755,-97.938575,0,'2013-07-06 12:44:34',NULL,NULL),(61851,'73120','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.584064,-97.574272,0,'2013-07-06 12:44:33',NULL,NULL),(54832,'63031','S','Flor','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.806089,-90.343437,0,'2013-07-06 12:44:33',NULL,NULL),(53978,'62439','S','Bond','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(14614,'15227','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426740,-79.969140,0,'2013-07-06 12:44:31',NULL,NULL),(27447,'30120','S','North Corners','N','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.177555,-84.854308,0,'2013-07-06 12:44:31',NULL,NULL),(30062,'33150','S','El Portal','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849298,-80.205791,0,'2013-07-06 12:44:32',NULL,NULL),(30383,'33319','S','Lauderhill','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(37286,'41607','S','Blue River','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.640057,-82.832048,0,'2013-07-06 12:44:32',NULL,NULL),(16883,'17573','U','JAY Advertising','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.028850,-76.167332,0,'2013-07-06 12:44:31',NULL,NULL),(1067,'00725','S','La Cima I','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(46235,'52801','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.522295,-90.577561,0,'2013-07-06 12:44:32',NULL,NULL),(2743,'00969','S','Urb Oasis Gdns','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(17394,'17901','S','Glen Carbon','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(35983,'40118','S','Hollyvilla','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.110096,-85.755717,0,'2013-07-06 12:44:32',NULL,NULL),(72140,'88312','S','Sierra Vista','N','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.394388,-105.666923,0,'2013-07-06 12:44:34',NULL,NULL),(77094,'96137','S','Lake Almanor Sports & Spirit','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.349400,-121.071420,0,'2013-07-06 12:44:34',NULL,NULL),(64249,'76367','S','Iowa Park','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.946652,-98.690180,0,'2013-07-06 12:44:34',NULL,NULL),(9849,'10118','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(39331,'44615','S','Carrollton','D','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(50537,'58121','U','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.865114,-96.861885,0,'2013-07-06 12:44:33',NULL,NULL),(53745,'62257','S','Marissa','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.253730,-89.758689,0,'2013-07-06 12:44:33',NULL,NULL),(79600,'99040','S','Wellpinit','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.883455,-118.033976,0,'2013-07-06 12:44:34',NULL,NULL),(63124,'75320','U','Wells Fargo Bank','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.777839,-96.798630,0,'2013-07-06 12:44:33',NULL,NULL),(62055,'73536','U','Halliburton','N','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.449703,-97.832209,0,'2013-07-06 12:44:33',NULL,NULL),(57276,'66550','S','Wetmore','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.653054,-95.846655,0,'2013-07-06 12:44:33',NULL,NULL),(56519,'65355','S','Fristoe','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(51831,'60064','S','Abbott Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.326825,-87.857674,0,'2013-07-06 12:44:33',NULL,NULL),(894,'00704','S','Urb Monte Soria 2','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(13317,'13676','S','Potsdam','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(5904,'05159','P','Westminster Station','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.085978,-72.440728,0,'2013-07-06 12:44:30',NULL,NULL),(29542,'32798','S','Zellwood','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.720080,-81.573895,0,'2013-07-06 12:44:32',NULL,NULL),(543,'00676','S','Urb Moca Gdns','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(42773,'48039','S','Cottrellville Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.719047,-82.521691,0,'2013-07-06 12:44:32',NULL,NULL),(57138,'66227','S','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.980518,-94.869055,0,'2013-07-06 12:44:33',NULL,NULL),(63829,'75973','S','Halbert','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(7370,'06763','S','Morris','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.687716,-73.198108,0,'2013-07-06 12:44:30',NULL,NULL),(8576,'08215','S','Green Bank','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(54316,'62722','U','Secy of State Vehicle Svcs','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.797223,-89.653566,0,'2013-07-06 12:44:33',NULL,NULL),(64762,'76941','S','Sherwood','N','Irion','48235','Texas','TX','48','0000','325','Central',-6.0,'Y',31.291680,-100.860180,0,'2013-07-06 12:44:34',NULL,NULL),(79693,'99204','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.639350,-117.477612,0,'2013-07-06 12:44:34',NULL,NULL),(68999,'83201','S','Westwood Village','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.882088,-112.423285,0,'2013-07-06 12:44:34',NULL,NULL),(58028,'68003','S','Ashland','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.042189,-96.375917,0,'2013-07-06 12:44:33',NULL,NULL),(45346,'50950','U','Communications Data Service','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.580273,-93.628420,0,'2013-07-06 12:44:32',NULL,NULL),(34747,'38852','S','Holcut','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(2392,'00949','S','Urb Pabellones','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(71304,'86503','S','Huachuca Terrace','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(28151,'30828','S','Warrenton','D','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.408859,-82.665215,0,'2013-07-06 12:44:31',NULL,NULL),(15577,'16654','U','SCI Huntingdon','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.487207,-78.009794,0,'2013-07-06 12:44:31',NULL,NULL),(63654,'75845','S','Trevat','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(3282,'01475','S','Winchendon','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.677984,-72.045113,0,'2013-07-06 12:44:30',NULL,NULL),(57156,'66276','U','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.002659,-94.669998,0,'2013-07-06 12:44:33',NULL,NULL),(15392,'16328','P','Hydetown','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.651238,-79.724503,0,'2013-07-06 12:44:31',NULL,NULL),(72638,'89423','S','Minden','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.005489,-119.735877,0,'2013-07-06 12:44:34',NULL,NULL),(63392,'75644','S','Stamps','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(63474,'75686','S','New Mine','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(55423,'63660','S','Hopewell','N','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.916100,-90.710280,0,'2013-07-06 12:44:33',NULL,NULL),(51100,'58776','S','Ross','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.328261,-102.500895,0,'2013-07-06 12:44:33',NULL,NULL),(48525,'55746','S','Stuntz','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(45718,'52070','S','Sabula','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.070681,-90.174281,0,'2013-07-06 12:44:32',NULL,NULL),(5137,'04414','S','Brownville','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.307433,-69.030278,0,'2013-07-06 12:44:30',NULL,NULL),(41754,'47283','S','Sardinia','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.175635,-85.575619,0,'2013-07-06 12:44:32',NULL,NULL),(11146,'11715','S','Blue Point','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.750866,-73.034128,0,'2013-07-06 12:44:30',NULL,NULL),(41413,'46816','S','Southtown Mall','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(4786,'03868','S','Rochester','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.336620,-70.947300,0,'2013-07-06 12:44:30',NULL,NULL),(57477,'66870','S','Virgil','D','Greenwood','20073','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.869892,-96.036586,0,'2013-07-06 12:44:33',NULL,NULL),(48229,'55419','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.903308,-93.289371,0,'2013-07-06 12:44:33',NULL,NULL),(43882,'49227','S','Allen','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.949885,-84.768253,0,'2013-07-06 12:44:32',NULL,NULL),(79593,'99034','S','Tumtum','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.890134,-117.774983,0,'2013-07-06 12:44:34',NULL,NULL),(71612,'87327','P','Ramah Community','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(53019,'61466','S','North Henderson','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.105464,-90.476855,0,'2013-07-06 12:44:33',NULL,NULL),(75889,'94965','S','Marin City','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.865100,-122.530980,0,'2013-07-06 12:44:34',NULL,NULL),(73836,'91785','P','Upland','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.100760,-117.647655,0,'2013-07-06 12:44:34',NULL,NULL),(51753,'60021','S','Barrington Hills','N','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.192301,-88.222307,0,'2013-07-06 12:44:33',NULL,NULL),(34179,'38315','S','Bethel Spgs','A','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.225473,-88.661743,0,'2013-07-06 12:44:32',NULL,NULL),(70308,'84602','S','BYU','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.226908,-111.691400,0,'2013-07-06 12:44:34',NULL,NULL),(4526,'03431','S','N Swanzey','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.938975,-72.285756,0,'2013-07-06 12:44:30',NULL,NULL),(7016,'06260','S','Putman','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(6068,'05445','S','Cedar Beach','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.309280,-73.238700,0,'2013-07-06 12:44:30',NULL,NULL),(35456,'39483','S','Morgantown','A','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(45392,'51031','S','Lemars','N','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.786590,-96.172617,0,'2013-07-06 12:44:32',NULL,NULL),(53076,'61523','S','North Hampton','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(56088,'64770','S','Montrose','D','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.258039,-93.984093,0,'2013-07-06 12:44:33',NULL,NULL),(67426,'80160','P','Littleton','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612973,-105.016519,0,'2013-07-06 12:44:34',NULL,NULL),(71706,'87525','P','Taos Ski Vly','A','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.403577,-105.576960,0,'2013-07-06 12:44:34',NULL,NULL),(19839,'20504','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897725,-77.042875,0,'2013-07-06 12:44:31',NULL,NULL),(36525,'40844','P','Hoskinston','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.077258,-83.390639,0,'2013-07-06 12:44:32',NULL,NULL),(5833,'05083','S','West Fairlee','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.936397,-72.248387,0,'2013-07-06 12:44:30',NULL,NULL),(40968,'46322','S','Highland','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.551945,-87.457161,0,'2013-07-06 12:44:32',NULL,NULL),(13903,'14280','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.886929,-78.871237,0,'2013-07-06 12:44:31',NULL,NULL),(13358,'13730','S','Afton Lake','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.209640,-75.490260,0,'2013-07-06 12:44:31',NULL,NULL),(3895,'02446','S','Brookline','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344328,-71.122217,0,'2013-07-06 12:44:30',NULL,NULL),(42493,'47841','S','Barrick Corner','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.273442,-87.115129,0,'2013-07-06 12:44:32',NULL,NULL),(8463,'08088','S','Shamong Township','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(33265,'37091','S','Lewisburg','D','Marshall','47117','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.450839,-86.795069,0,'2013-07-06 12:44:32',NULL,NULL),(50258,'57634','S','Keldron','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.880133,-101.912927,0,'2013-07-06 12:44:33',NULL,NULL),(51272,'59105','S','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.840397,-108.464534,0,'2013-07-06 12:44:33',NULL,NULL),(66730,'78956','S','Moravia','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(69773,'84057','S','Vineyard','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.315140,-111.695870,0,'2013-07-06 12:44:34',NULL,NULL),(74316,'92392','S','Victorville','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.510298,-117.318390,0,'2013-07-06 12:44:34',NULL,NULL),(38551,'43756','S','McConnelsvle','A','Morgan','39115','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.690000,-81.835980,0,'2013-07-06 12:44:32',NULL,NULL),(27895,'30471','S','Canoochee','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.652254,-82.155942,0,'2013-07-06 12:44:31',NULL,NULL),(72811,'89801','S','Halleck','A','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.834645,-115.757583,0,'2013-07-06 12:44:34',NULL,NULL),(73096,'90230','S','Culver City','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.001758,-118.394799,0,'2013-07-06 12:44:34',NULL,NULL),(64731,'76885','S','Valley Spring','D','Llano','48299','Texas','TX','48','0000','325','Central',-6.0,'Y',30.838374,-98.843426,0,'2013-07-06 12:44:34',NULL,NULL),(6395,'05732','S','Crystal Beach','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.643611,-73.199167,0,'2013-07-06 12:44:30',NULL,NULL),(14502,'15148','S','Wall','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.388580,-79.796940,0,'2013-07-06 12:44:31',NULL,NULL),(10167,'10280','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711844,-74.019133,0,'2013-07-06 12:44:30',NULL,NULL),(9586,'10028','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.778345,-73.955085,0,'2013-07-06 12:44:30',NULL,NULL),(31280,'34031','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(14852,'15451','S','Lake Lynn','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.738060,-79.816691,0,'2013-07-06 12:44:31',NULL,NULL),(55507,'63775','S','Yount','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(58646,'68871','S','Rockville','D','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.119338,-98.859015,0,'2013-07-06 12:44:33',NULL,NULL),(62999,'75156','S','Enchanted Oak','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295960,-96.118738,0,'2013-07-06 12:44:33',NULL,NULL),(63797,'75960','S','Barnes','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.921945,-94.936938,0,'2013-07-06 12:44:34',NULL,NULL),(70146,'84308','S','Utida','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.967723,-112.004942,0,'2013-07-06 12:44:34',NULL,NULL),(70315,'84606','S','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.215754,-111.634446,0,'2013-07-06 12:44:34',NULL,NULL),(73876,'91935','S','Jamul','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.685568,-116.814071,0,'2013-07-06 12:44:34',NULL,NULL),(78595,'98185','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.665276,-122.291979,0,'2013-07-06 12:44:34',NULL,NULL),(36556,'40913','S','Red Bird','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.940872,-83.564677,0,'2013-07-06 12:44:32',NULL,NULL),(44399,'49816','S','Limestone','A','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.288490,-86.760174,0,'2013-07-06 12:44:32',NULL,NULL),(28550,'31563','S','Surrency','D','Appling','13001','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.664666,-82.188613,0,'2013-07-06 12:44:32',NULL,NULL),(7059,'06330','S','Sprague','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.612919,-72.070615,0,'2013-07-06 12:44:30',NULL,NULL),(7163,'06438','S','Haddam','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.464202,-72.518015,0,'2013-07-06 12:44:30',NULL,NULL),(68024,'80926','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.663492,-104.909353,0,'2013-07-06 12:44:34',NULL,NULL),(64809,'77024','S','Piney Point','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(32571,'36117','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.383690,-86.132460,0,'2013-07-06 12:44:32',NULL,NULL),(45591,'51548','S','McClelland','N','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.303365,-95.672529,0,'2013-07-06 12:44:32',NULL,NULL),(69608,'83856','S','Priest River','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.186078,-116.913115,0,'2013-07-06 12:44:34',NULL,NULL),(71267,'86426','S','Fort Mohave','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.001660,-114.563060,0,'2013-07-06 12:44:34',NULL,NULL),(79280,'98577','S','Holcomb','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(43708,'48901','P','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.732308,-84.553263,0,'2013-07-06 12:44:32',NULL,NULL),(562,'00678','S','Parc Terranova','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(7291,'06536','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.317391,-72.926719,0,'2013-07-06 12:44:30',NULL,NULL),(4520,'03303','S','Webster','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.303680,-71.638500,0,'2013-07-06 12:44:30',NULL,NULL),(31244,'33975','P','Labelle','D','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.758822,-81.441010,0,'2013-07-06 12:44:32',NULL,NULL),(53766,'62268','S','Lively Grove','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.263313,-89.588808,0,'2013-07-06 12:44:33',NULL,NULL),(55393,'63630','S','Old Mines','N','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.034480,-90.721680,0,'2013-07-06 12:44:33',NULL,NULL),(61018,'72116','S','N L R','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(61547,'72701','S','Fayetteville','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.050940,-94.136400,0,'2013-07-06 12:44:33',NULL,NULL),(68834,'82520','S','Atlantic City','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(75263,'93669','S','Wishon','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.320000,-119.556667,0,'2013-07-06 12:44:34',NULL,NULL),(2059,'00920','S','Rio Piedras','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(50592,'58238','S','Hamilton','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.773014,-97.492711,0,'2013-07-06 12:44:33',NULL,NULL),(45515,'51401','S','Roselle','N','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.047220,-94.865160,0,'2013-07-06 12:44:32',NULL,NULL),(78916,'98365','S','Port Hadlock','A','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.915179,-122.688171,0,'2013-07-06 12:44:34',NULL,NULL),(45301,'50833','S','Siam','N','Taylor','19173','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.705800,-94.758900,0,'2013-07-06 12:44:32',NULL,NULL),(52470,'60685','U','CNA Center','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881488,-87.624120,0,'2013-07-06 12:44:33',NULL,NULL),(56509,'65349','S','Sharon','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.214173,-93.069492,0,'2013-07-06 12:44:33',NULL,NULL),(20712,'21275','U','Wells Fargo','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.287029,-76.614130,0,'2013-07-06 12:44:31',NULL,NULL),(1817,'00784','S','Hacienda Guamani','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(42742,'48022','S','Emmett Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.023041,-82.814127,0,'2013-07-06 12:44:32',NULL,NULL),(9208,'09498','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4937,'04087','S','Waterboro','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.555304,-70.741806,0,'2013-07-06 12:44:30',NULL,NULL),(22674,'24301','S','Snowville','N','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.050533,-80.771948,0,'2013-07-06 12:44:31',NULL,NULL),(61045,'72118','S','West Marche','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802369,-92.316960,0,'2013-07-06 12:44:33',NULL,NULL),(66629,'78801','S','Uvalde','D','Uvalde','48463','Texas','TX','48','0000','830','Central',-6.0,'Y',29.213418,-99.791665,0,'2013-07-06 12:44:34',NULL,NULL),(74076,'92176','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.761794,-117.120515,0,'2013-07-06 12:44:34',NULL,NULL),(4239,'02863','S','Central Falls','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.887705,-71.393308,0,'2013-07-06 12:44:30',NULL,NULL),(18462,'19082','S','Bywood','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.956267,-75.274357,0,'2013-07-06 12:44:31',NULL,NULL),(32585,'36123','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.364931,-86.298471,0,'2013-07-06 12:44:32',NULL,NULL),(67480,'80228','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.697980,-105.155880,0,'2013-07-06 12:44:34',NULL,NULL),(68035,'80928','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.588656,-104.442148,0,'2013-07-06 12:44:34',NULL,NULL),(69181,'83334','S','Rock Creek','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.515005,-114.303296,0,'2013-07-06 12:44:34',NULL,NULL),(75489,'94125','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.731384,-122.384963,0,'2013-07-06 12:44:34',NULL,NULL),(78212,'97756','S','Eagle Crest','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.275433,-121.205705,0,'2013-07-06 12:44:34',NULL,NULL),(7185,'06469','S','Moodus','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.505260,-72.450851,0,'2013-07-06 12:44:30',NULL,NULL),(15471,'16426','S','McLane','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.990841,-80.144052,0,'2013-07-06 12:44:31',NULL,NULL),(77451,'96811','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.326884,-157.828158,0,'2013-07-06 12:44:34',NULL,NULL),(73989,'92093','U','Uc Santa Barbara','N','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.877058,-117.230578,0,'2013-07-06 12:44:34',NULL,NULL),(140,'00617','S','Est de Florida','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(39219,'44410','S','Mecca','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.331036,-80.729796,0,'2013-07-06 12:44:32',NULL,NULL),(31846,'35096','S','Lincoln','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.593989,-86.132344,0,'2013-07-06 12:44:32',NULL,NULL),(30710,'33498','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.393289,-80.215643,0,'2013-07-06 12:44:32',NULL,NULL),(30068,'33153','P','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.863568,-80.192551,0,'2013-07-06 12:44:32',NULL,NULL),(24041,'26411','S','New Milton','D','Doddridge','54017','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.176338,-80.717586,0,'2013-07-06 12:44:31',NULL,NULL),(21681,'22960','S','Montford','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.245110,-78.108521,0,'2013-07-06 12:44:31',NULL,NULL),(8868,'08690','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(8425,'08077','S','Cinnaminson','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.008345,-75.010068,0,'2013-07-06 12:44:30',NULL,NULL),(14137,'14701','S','Jamestown','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.094174,-79.251081,0,'2013-07-06 12:44:31',NULL,NULL),(17552,'17980','S','Rush','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.591905,-76.538022,0,'2013-07-06 12:44:31',NULL,NULL),(67604,'80429','P','Climax','D','Lake','08065','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.326580,-106.234080,0,'2013-07-06 12:44:34',NULL,NULL),(68360,'81135','P','Monte Vista','A','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.578239,-106.147242,0,'2013-07-06 12:44:34',NULL,NULL),(64254,'76372','S','Newcastle','D','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',33.192720,-98.808480,0,'2013-07-06 12:44:34',NULL,NULL),(54945,'63114','S','Vinita Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(75925,'95014','S','Monte Vista','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.314123,-122.044411,0,'2013-07-06 12:44:34',NULL,NULL),(20542,'21111','S','Hereford','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.569940,-76.592880,0,'2013-07-06 12:44:31',NULL,NULL),(16069,'17049','S','Mc Alistervl','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(18671,'19181','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951446,-75.147020,0,'2013-07-06 12:44:31',NULL,NULL),(56255,'65061','S','Fredericksburg','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.502518,-91.534868,0,'2013-07-06 12:44:33',NULL,NULL),(3844,'02344','U','Middleboro','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.894218,-70.920815,0,'2013-07-06 12:44:30',NULL,NULL),(33915,'38053','S','Locke','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(36951,'41169','S','Raceland','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.520060,-82.724160,0,'2013-07-06 12:44:32',NULL,NULL),(34952,'39059','S','Crystal Springs','D','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.983819,-90.358823,0,'2013-07-06 12:44:32',NULL,NULL),(74464,'92593','P','Temecula','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.502066,-117.154829,0,'2013-07-06 12:44:34',NULL,NULL),(75869,'94948','P','Novato','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.135776,-122.562237,0,'2013-07-06 12:44:34',NULL,NULL),(24542,'27292','S','Hannersville','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(7868,'07505','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.913645,-74.173944,0,'2013-07-06 12:44:30',NULL,NULL),(58576,'68831','S','Nysted','N','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.126147,-98.544364,0,'2013-07-06 12:44:33',NULL,NULL),(14115,'14642','U','Strong Memorial Hospital','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.122242,-77.625204,0,'2013-07-06 12:44:31',NULL,NULL),(64082,'76148','S','N Richlnd Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(50773,'58424','S','Cleveland','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.894080,-99.095940,0,'2013-07-06 12:44:33',NULL,NULL),(45338,'50864','S','Tenville Junction','N','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.926401,-94.974732,0,'2013-07-06 12:44:32',NULL,NULL),(67612,'80433','S','Foxton','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.515866,-105.311973,0,'2013-07-06 12:44:34',NULL,NULL),(30338,'33309','S','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(58489,'68758','S','Newman Grove','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.745732,-97.776985,0,'2013-07-06 12:44:33',NULL,NULL),(54041,'62466','S','Chauncey','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.730600,-87.772380,0,'2013-07-06 12:44:33',NULL,NULL),(46781,'53957','U','J W Jung Seed Co','N','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.541272,-89.005699,0,'2013-07-06 12:44:32',NULL,NULL),(77477,'96820','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.351908,-157.878057,0,'2013-07-06 12:44:34',NULL,NULL),(6369,'05678','P','Websterville','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.162280,-72.469246,0,'2013-07-06 12:44:30',NULL,NULL),(79975,'99650','P','Pilot Station','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.680853,-163.184290,0,'2013-07-06 12:44:34',NULL,NULL),(46725,'53816','S','Mount Hope','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.971007,-90.844711,0,'2013-07-06 12:44:32',NULL,NULL),(49715,'57037','S','Irene','D','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.111845,-97.285292,0,'2013-07-06 12:44:33',NULL,NULL),(2316,'00928','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.393175,-66.061744,0,'2013-07-06 12:44:30',NULL,NULL),(53351,'61761','S','Normal','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.510903,-88.987912,0,'2013-07-06 12:44:33',NULL,NULL),(29450,'32706','P','Cassadaga','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.967199,-81.236308,0,'2013-07-06 12:44:32',NULL,NULL),(35873,'39846','S','Edison','D','Calhoun','13037','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.561815,-84.738841,0,'2013-07-06 12:44:32',NULL,NULL),(40502,'45807','S','Elida','A','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.795920,-84.119340,0,'2013-07-06 12:44:32',NULL,NULL),(74268,'92346','S','Highland','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.129046,-117.196920,0,'2013-07-06 12:44:34',NULL,NULL),(79794,'99352','S','West Richland','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.280602,-119.291215,0,'2013-07-06 12:44:34',NULL,NULL),(53335,'61753','S','Lexington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.620011,-88.806012,0,'2013-07-06 12:44:33',NULL,NULL),(68010,'80923','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.899457,-104.699208,0,'2013-07-06 12:44:34',NULL,NULL),(4991,'04124','U','Union Mutual Life Ins','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.652070,-70.330016,0,'2013-07-06 12:44:30',NULL,NULL),(71193,'86047','S','Tolani','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.275380,-110.315820,0,'2013-07-06 12:44:34',NULL,NULL),(5637,'04945','S','Parlin Pond Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(25021,'27886','S','Tarboro','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.898660,-77.558220,0,'2013-07-06 12:44:31',NULL,NULL),(37626,'42151','S','Hestand','D','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.663020,-85.599734,0,'2013-07-06 12:44:32',NULL,NULL),(57388,'66754','S','Mapleton','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.017399,-94.876798,0,'2013-07-06 12:44:33',NULL,NULL),(51528,'59715','S','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.674022,-111.064218,0,'2013-07-06 12:44:33',NULL,NULL),(34421,'38637','S','Horn Lake','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.950244,-90.037659,0,'2013-07-06 12:44:32',NULL,NULL),(71575,'87310','P','Gallup','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.809225,-108.576279,0,'2013-07-06 12:44:34',NULL,NULL),(110,'00612','S','Urb Ocean Vw','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(14515,'15202','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(32748,'36340','S','Eunola','N','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.038911,-85.879322,0,'2013-07-06 12:44:32',NULL,NULL),(41806,'47331','S','Connersville','D','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(40069,'45274','U','Commercial Accts','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.138138,-84.536318,0,'2013-07-06 12:44:32',NULL,NULL),(46545,'53405','S','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.716356,-87.823291,0,'2013-07-06 12:44:32',NULL,NULL),(36674,'41014','S','Covington','D','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.063763,-84.506679,0,'2013-07-06 12:44:32',NULL,NULL),(12757,'13207','S','Colvin Elmwood','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.017354,-76.167626,0,'2013-07-06 12:44:30',NULL,NULL),(30604,'33422','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.750328,-80.128524,0,'2013-07-06 12:44:32',NULL,NULL),(69403,'83622','S','Garden Valley','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.055720,-115.624380,0,'2013-07-06 12:44:34',NULL,NULL),(65190,'77422','S','Old Brazoria','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.043342,-95.567119,0,'2013-07-06 12:44:34',NULL,NULL),(54486,'62863','S','Maud','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(35120,'39211','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.370898,-90.128060,0,'2013-07-06 12:44:32',NULL,NULL),(6002,'05356','S','West Dover','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.933333,-72.833333,0,'2013-07-06 12:44:30',NULL,NULL),(71930,'87831','S','San Acacia','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.233049,-106.913944,0,'2013-07-06 12:44:34',NULL,NULL),(67627,'80446','S','Granby','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.061700,-105.878940,0,'2013-07-06 12:44:34',NULL,NULL),(77863,'97232','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.530982,-122.632832,0,'2013-07-06 12:44:34',NULL,NULL),(29593,'32830','P','Lake Buena Vista','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.370015,-81.556799,0,'2013-07-06 12:44:32',NULL,NULL),(21017,'21851','S','Pocomoke','N','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.066608,-75.540891,0,'2013-07-06 12:44:31',NULL,NULL),(1909,'00795','S','Est El Guayabal','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(8913,'08739','P','Normandy Beach','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.999746,-74.064221,0,'2013-07-06 12:44:30',NULL,NULL),(56335,'65109','S','Elston','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.555400,-92.280540,0,'2013-07-06 12:44:33',NULL,NULL),(12863,'13323','S','Clinton','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.056309,-75.375791,0,'2013-07-06 12:44:30',NULL,NULL),(38431,'43555','P','Rdgville Cors','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.438435,-84.257991,0,'2013-07-06 12:44:32',NULL,NULL),(22696,'24326','S','Comers Rock','N','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.729391,-81.194399,0,'2013-07-06 12:44:31',NULL,NULL),(22721,'24360','S','Fort Chiswell','A','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.924480,-80.911800,0,'2013-07-06 12:44:31',NULL,NULL),(23023,'24834','P','Fanrock','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.566531,-81.615628,0,'2013-07-06 12:44:31',NULL,NULL),(22739,'24381','S','Woodlawn','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.713850,-80.806839,0,'2013-07-06 12:44:31',NULL,NULL),(64576,'76665','S','Meridian','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.923900,-97.656966,0,'2013-07-06 12:44:34',NULL,NULL),(24452,'27215','S','Burlington','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.033420,-79.490880,0,'2013-07-06 12:44:31',NULL,NULL),(13607,'13860','P','W Davenport','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.446027,-74.965139,0,'2013-07-06 12:44:31',NULL,NULL),(9213,'09505','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(75975,'95062','S','Santa Cruz','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.971541,-121.985008,0,'2013-07-06 12:44:34',NULL,NULL),(80043,'99703','S','Fort Wainwright','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.821983,-147.635602,0,'2013-07-06 12:44:34',NULL,NULL),(27424,'30105','S','Armuchee','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.426568,-85.168719,0,'2013-07-06 12:44:31',NULL,NULL),(72196,'88414','S','Capulin','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.726135,-103.973999,0,'2013-07-06 12:44:34',NULL,NULL),(72117,'88254','P','Lakewood','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.638836,-104.375963,0,'2013-07-06 12:44:34',NULL,NULL),(44814,'50240','S','Hanley','N','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.300602,-93.744062,0,'2013-07-06 12:44:32',NULL,NULL),(43355,'48390','S','Commerce Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(37925,'42634','S','Greenwood','A','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.845915,-84.451334,0,'2013-07-06 12:44:32',NULL,NULL),(17451,'17941','S','Line Mountain','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.726516,-76.605887,0,'2013-07-06 12:44:31',NULL,NULL),(70780,'85346','P','Quartzsite','D','La Paz','04012','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.666731,-114.214619,0,'2013-07-06 12:44:34',NULL,NULL),(69602,'83854','S','Hauser','A','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.740920,-116.944800,0,'2013-07-06 12:44:34',NULL,NULL),(45641,'51650','S','Riverton','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.687799,-95.569399,0,'2013-07-06 12:44:32',NULL,NULL),(20572,'21150','P','Simpsonville','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.174404,-76.867087,0,'2013-07-06 12:44:31',NULL,NULL),(6971,'06239','S','Danielson','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.790480,-71.855880,0,'2013-07-06 12:44:30',NULL,NULL),(34438,'38647','S','Spring Hill','N','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.932778,-89.211111,0,'2013-07-06 12:44:32',NULL,NULL),(35573,'39569','P','Pascagoula','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.369087,-88.558091,0,'2013-07-06 12:44:32',NULL,NULL),(52627,'61043','P','Holcomb','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.066698,-89.098415,0,'2013-07-06 12:44:33',NULL,NULL),(26673,'29401','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.779122,-79.939806,0,'2013-07-06 12:44:31',NULL,NULL),(45910,'52322','S','Cosgrove','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.722093,-91.785552,0,'2013-07-06 12:44:32',NULL,NULL),(77016,'96091','S','Trinity Ctr','A','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',41.087390,-122.716384,0,'2013-07-06 12:44:34',NULL,NULL),(27121,'29743','S','Smyrna','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.031662,-81.412116,0,'2013-07-06 12:44:31',NULL,NULL),(43045,'48180','S','Taylor','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.234324,-83.269312,0,'2013-07-06 12:44:32',NULL,NULL),(80097,'99748','P','Kaltag','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.340945,-158.721325,0,'2013-07-06 12:44:34',NULL,NULL),(63302,'75563','S','Carterville','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.009734,-94.366056,0,'2013-07-06 12:44:33',NULL,NULL),(26841,'29503','P','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.192315,-79.803716,0,'2013-07-06 12:44:31',NULL,NULL),(57582,'67065','S','Isabel','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.427224,-98.522012,0,'2013-07-06 12:44:33',NULL,NULL),(46775,'53952','S','Brooks','A','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.802455,-89.641674,0,'2013-07-06 12:44:32',NULL,NULL),(75123,'93551','S','Leona Valley','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.600777,-118.190371,0,'2013-07-06 12:44:34',NULL,NULL),(29021,'32227','S','Maypt Nav Hou','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(30181,'33176','S','Richmond Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(52591,'61013','P','Cedarville','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.376654,-89.635738,0,'2013-07-06 12:44:33',NULL,NULL),(39098,'44232','P','Greensburg','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.945800,-81.483300,0,'2013-07-06 12:44:32',NULL,NULL),(58533,'68802','P','Grand Island','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.910403,-98.350673,0,'2013-07-06 12:44:33',NULL,NULL),(44484,'49911','S','Bessemer','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.476713,-90.052014,0,'2013-07-06 12:44:32',NULL,NULL),(77109,'96145','P','Alpine Mdws','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.174073,-120.155846,0,'2013-07-06 12:44:34',NULL,NULL),(79000,'98383','S','Olympic View','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.663935,-122.707438,0,'2013-07-06 12:44:34',NULL,NULL),(26167,'28745','S','Assembly','N','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.524801,-82.972902,0,'2013-07-06 12:44:31',NULL,NULL),(30339,'33310','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.171944,-80.132222,0,'2013-07-06 12:44:32',NULL,NULL),(4161,'02779','S','Berkley','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.827125,-71.080384,0,'2013-07-06 12:44:30',NULL,NULL),(66802,'79066','P','Pampa','D','Gray','48179','Texas','TX','48','0000','806','Central',-6.0,'Y',35.531480,-100.976929,0,'2013-07-06 12:44:34',NULL,NULL),(24887,'27704','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.034161,-78.869276,0,'2013-07-06 12:44:31',NULL,NULL),(61753,'73047','S','Hinton','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.473849,-98.355464,0,'2013-07-06 12:44:33',NULL,NULL),(60773,'72016','S','Bigelow','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.881567,-92.692504,0,'2013-07-06 12:44:33',NULL,NULL),(59779,'71203','S','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.547557,-92.044046,0,'2013-07-06 12:44:33',NULL,NULL),(48621,'55797','S','Nickerson','N','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.467500,-92.388333,0,'2013-07-06 12:44:33',NULL,NULL),(46736,'53910','S','Adams','D','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.911421,-89.801303,0,'2013-07-06 12:44:32',NULL,NULL),(39532,'44828','P','Flat Rock','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.236043,-82.861254,0,'2013-07-06 12:44:32',NULL,NULL),(15386,'16321','P','Endeavor','A','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.583889,-79.401944,0,'2013-07-06 12:44:31',NULL,NULL),(16626,'17331','S','Shorbes Hill','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(61213,'72315','S','Blytheville','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.943180,-89.899320,0,'2013-07-06 12:44:33',NULL,NULL),(12818,'13302','S','Ricard','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.505683,-75.992926,0,'2013-07-06 12:44:30',NULL,NULL),(5274,'04495','S','Winn','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.455265,-68.332248,0,'2013-07-06 12:44:30',NULL,NULL),(66119,'78418','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.641172,-97.277723,0,'2013-07-06 12:44:34',NULL,NULL),(32032,'35243','S','Cahaba Hts','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(35445,'39479','S','Sanford','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.532820,-89.486580,0,'2013-07-06 12:44:32',NULL,NULL),(75883,'94956','S','Point Reyes Station','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.063493,-122.809164,0,'2013-07-06 12:44:34',NULL,NULL),(24933,'27815','U','Rocky Mount','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.935230,-77.775237,0,'2013-07-06 12:44:31',NULL,NULL),(62198,'73832','S','Arnett','D','Ellis','40045','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.083700,-99.745800,0,'2013-07-06 12:44:33',NULL,NULL),(2478,'00956','S','Urb Country Est','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(60674,'71923','S','Gum Springs','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(60090,'71359','U','La College','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.323914,-92.427031,0,'2013-07-06 12:44:33',NULL,NULL),(3182,'01339','S','Charlemont','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.645420,-72.880260,0,'2013-07-06 12:44:30',NULL,NULL),(29587,'32826','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.580464,-81.186488,0,'2013-07-06 12:44:32',NULL,NULL),(8476,'08091','S','Berlin Twp','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.815979,-74.940718,0,'2013-07-06 12:44:30',NULL,NULL),(5980,'05345','S','Newfane','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.983232,-72.656479,0,'2013-07-06 12:44:30',NULL,NULL),(5444,'04694','S','Alexander','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.154958,-67.407874,0,'2013-07-06 12:44:30',NULL,NULL),(11529,'12042','S','Climax','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.372564,-73.865815,0,'2013-07-06 12:44:30',NULL,NULL),(60437,'71646','S','Milo','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(36547,'40906','S','Crane Nest','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(57500,'66948','S','Jamestown','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.600603,-97.857281,0,'2013-07-06 12:44:33',NULL,NULL),(76064,'95202','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.958445,-121.287890,0,'2013-07-06 12:44:34',NULL,NULL),(26857,'29527','S','Conway','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.745620,-79.074900,0,'2013-07-06 12:44:31',NULL,NULL),(11511,'12031','S','Carlisle','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.746768,-74.457410,0,'2013-07-06 12:44:30',NULL,NULL),(20713,'21278','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.316363,-76.614724,0,'2013-07-06 12:44:31',NULL,NULL),(54200,'62634','S','Elkhart','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.016327,-89.480200,0,'2013-07-06 12:44:33',NULL,NULL),(74281,'92358','S','Lytle Creek','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.275929,-117.531486,0,'2013-07-06 12:44:34',NULL,NULL),(39170,'44309','P','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.099536,-81.514473,0,'2013-07-06 12:44:32',NULL,NULL),(15852,'16941','S','Genesee','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.981572,-77.769980,0,'2013-07-06 12:44:31',NULL,NULL),(17664,'18088','S','Walnutport','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.761638,-75.563570,0,'2013-07-06 12:44:31',NULL,NULL),(34611,'38751','S','Fairview','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(67694,'80521','S','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.584979,-105.114124,0,'2013-07-06 12:44:34',NULL,NULL),(21141,'22107','U','Gannett','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.933696,-77.179240,0,'2013-07-06 12:44:31',NULL,NULL),(37060,'41310','S','Bays','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.622355,-83.214006,0,'2013-07-06 12:44:32',NULL,NULL),(56444,'65275','S','Strother','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.481474,-92.009398,0,'2013-07-06 12:44:33',NULL,NULL),(14918,'15541','S','Friedens','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.005681,-78.895887,0,'2013-07-06 12:44:31',NULL,NULL),(54669,'62938','S','Temple Hill','A','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.357533,-88.488804,0,'2013-07-06 12:44:33',NULL,NULL),(14876,'15472','P','Oliver','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.921503,-79.716332,0,'2013-07-06 12:44:31',NULL,NULL),(17953,'18517','S','Scranton','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350889,-75.727898,0,'2013-07-06 12:44:31',NULL,NULL),(37545,'42061','P','Lowes','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.890127,-88.774431,0,'2013-07-06 12:44:32',NULL,NULL),(52862,'61331','P','Lee Center','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.748893,-89.275340,0,'2013-07-06 12:44:33',NULL,NULL),(73041,'90079','S','Textile Boxes','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.038986,-118.256235,0,'2013-07-06 12:44:34',NULL,NULL),(73261,'90716','S','Hawaiian Gdns','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.853611,-118.133056,0,'2013-07-06 12:44:34',NULL,NULL),(69171,'83324','S','Shoshone','A','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.921960,-114.273840,0,'2013-07-06 12:44:34',NULL,NULL),(33452,'37317','S','Copperhill','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',34.987120,-84.372874,0,'2013-07-06 12:44:32',NULL,NULL),(10970,'11530','S','Garden City S','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(12270,'12835','S','Conklingville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.336182,-73.985758,0,'2013-07-06 12:44:30',NULL,NULL),(62797,'74902','S','Pocola','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.275011,-94.448501,0,'2013-07-06 12:44:33',NULL,NULL),(7569,'07026','S','Ritz','N','Bergen','34003','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.879414,-74.109454,0,'2013-07-06 12:44:30',NULL,NULL),(38153,'43146','S','Pleasant Corners','A','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.771545,-83.148051,0,'2013-07-06 12:44:32',NULL,NULL),(51038,'58725','S','Carpio','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.414749,-101.712035,0,'2013-07-06 12:44:33',NULL,NULL),(34908,'38955','P','Slate Spring','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(39369,'44638','S','McZena','N','Holmes','39075','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.623008,-82.136093,0,'2013-07-06 12:44:32',NULL,NULL),(79352,'98637','P','Nahcotta','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.497902,-124.033568,0,'2013-07-06 12:44:34',NULL,NULL),(69469,'83656','P','Notus','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.729743,-116.802904,0,'2013-07-06 12:44:34',NULL,NULL),(64712,'76865','S','Norton','D','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.888355,-100.132829,0,'2013-07-06 12:44:34',NULL,NULL),(61928,'73153','P','Oklahoma City','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.335006,-97.492751,0,'2013-07-06 12:44:33',NULL,NULL),(58214,'68333','S','Kramer','N','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.622672,-96.959633,0,'2013-07-06 12:44:33',NULL,NULL),(18202,'18942','S','Ottsville','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.462392,-75.160404,0,'2013-07-06 12:44:31',NULL,NULL),(18745,'19341','S','Franklin Center','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.040047,-75.636825,0,'2013-07-06 12:44:31',NULL,NULL),(29202,'32409','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.348960,-85.676400,0,'2013-07-06 12:44:32',NULL,NULL),(37413,'41777','S','Yeaddiss','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.046606,-83.220511,0,'2013-07-06 12:44:32',NULL,NULL),(3866,'02357','U','Stonehill Col','A','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.059436,-71.080861,0,'2013-07-06 12:44:30',NULL,NULL),(64153,'76204','P','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.214045,-97.132650,0,'2013-07-06 12:44:34',NULL,NULL),(2511,'00957','S','Urb Flamingo Ter','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(8687,'08342','P','Mizpah','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.488076,-74.834314,0,'2013-07-06 12:44:30',NULL,NULL),(6861,'06132','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768695,-72.683515,0,'2013-07-06 12:44:30',NULL,NULL),(61525,'72663','S','Onia','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.943278,-92.334065,0,'2013-07-06 12:44:33',NULL,NULL),(40492,'45787','P','Watertown','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.465803,-81.634639,0,'2013-07-06 12:44:32',NULL,NULL),(34045,'38136','U','Memphis Networks Dist Ctr','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099619,-90.036265,0,'2013-07-06 12:44:32',NULL,NULL),(24969,'27845','S','Jackson','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.393280,-77.420095,0,'2013-07-06 12:44:31',NULL,NULL),(14795,'15368','P','Vestaburg','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.018518,-79.989583,0,'2013-07-06 12:44:31',NULL,NULL),(7079,'06340','S','Poquonock Bridge','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(53596,'62075','S','Coalton','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.285840,-89.312580,0,'2013-07-06 12:44:33',NULL,NULL),(78490,'98105','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.661442,-122.292906,0,'2013-07-06 12:44:34',NULL,NULL),(31833,'35077','S','Hanceville','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.064328,-86.758497,0,'2013-07-06 12:44:32',NULL,NULL),(1847,'00786','P','La Plata','D','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.158211,-66.235998,0,'2013-07-06 12:44:30',NULL,NULL),(13573,'13843','S','Lathams Corners','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(65401,'77563','S','Bayou Vista','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.342457,-95.001043,0,'2013-07-06 12:44:34',NULL,NULL),(6916,'06154','U','C T Mutual Insurance Co','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.773119,-72.707051,0,'2013-07-06 12:44:30',NULL,NULL),(53652,'62205','S','E St Louis','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(71872,'87728','S','Maxwell','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.538252,-104.539719,0,'2013-07-06 12:44:34',NULL,NULL),(51442,'59469','S','Raynesford','D','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.248401,-110.684347,0,'2013-07-06 12:44:33',NULL,NULL),(49492,'56661','S','Northome','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(49405,'56623','S','Spooner','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(37754,'42325','S','Bremen','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.343773,-87.254214,0,'2013-07-06 12:44:32',NULL,NULL),(13288,'13661','S','Mannsville','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.709861,-76.079638,0,'2013-07-06 12:44:30',NULL,NULL),(32304,'35749','S','Harvest','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.834779,-86.739500,0,'2013-07-06 12:44:32',NULL,NULL),(2847,'00983','S','Urb Eduardo J Saldana','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(2195,'00926','S','Paseo Las Brisas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(35220,'39303','P','Mdn','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.424433,-88.704863,0,'2013-07-06 12:44:32',NULL,NULL),(64893,'77080','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.816840,-95.522482,0,'2013-07-06 12:44:34',NULL,NULL),(67152,'79781','P','Sheffield','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',30.687886,-101.846066,0,'2013-07-06 12:44:34',NULL,NULL),(3447,'01760','S','So Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(64785,'77008','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.796325,-95.417235,0,'2013-07-06 12:44:34',NULL,NULL),(5542,'04787','S','Westfield','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.607525,-67.935610,0,'2013-07-06 12:44:30',NULL,NULL),(9927,'10152','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759241,-73.971816,0,'2013-07-06 12:44:30',NULL,NULL),(40768,'46151','S','Paradise Lake','N','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(58630,'68865','S','Phillips','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.898339,-98.215040,0,'2013-07-06 12:44:33',NULL,NULL),(61754,'73048','S','Hydro','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.543372,-98.558410,0,'2013-07-06 12:44:33',NULL,NULL),(68117,'80949','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.929049,-104.855865,0,'2013-07-06 12:44:34',NULL,NULL),(70609,'85119','S','Apache Jct','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.417293,-111.528765,0,'2013-07-06 12:44:34',NULL,NULL),(15768,'16915','S','Sweden Valley','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(5145,'04417','S','Burlington','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.179999,-68.440203,0,'2013-07-06 12:44:30',NULL,NULL),(18997,'19525','S','Fagleysville','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.311960,-75.589380,0,'2013-07-06 12:44:31',NULL,NULL),(3724,'02151','S','Beachmont','N','Suffolk','25025','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.415223,-71.005325,0,'2013-07-06 12:44:30',NULL,NULL),(1964,'00824','P','St Croix','A','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.745183,-64.704271,0,'2013-07-06 12:44:30',NULL,NULL),(55198,'63383','S','Pendleton','N','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.771220,-91.224360,0,'2013-07-06 12:44:33',NULL,NULL),(78667,'98235','P','Clearlake','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.459276,-122.237986,0,'2013-07-06 12:44:34',NULL,NULL),(5155,'04421','S','Castine','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.392815,-68.803969,0,'2013-07-06 12:44:30',NULL,NULL),(72735,'89506','S','Rancho Haven','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(2550,'00959','S','Qtas de Flamingo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(30895,'33704','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.794804,-82.635433,0,'2013-07-06 12:44:32',NULL,NULL),(73112,'90251','P','Hawthorne','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.916941,-118.359436,0,'2013-07-06 12:44:34',NULL,NULL),(49290,'56521','S','Callaway','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.022579,-95.999418,0,'2013-07-06 12:44:33',NULL,NULL),(31571,'34637','S','Land O Lakes','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.261247,-82.464882,0,'2013-07-06 12:44:32',NULL,NULL),(3030,'01094','P','Wheelwright','D','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.349508,-72.140099,0,'2013-07-06 12:44:30',NULL,NULL),(25233,'28097','S','Western Hills','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.265418,-80.426782,0,'2013-07-06 12:44:31',NULL,NULL),(51661,'59911','S','Bigfork','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.881860,-113.965080,0,'2013-07-06 12:44:33',NULL,NULL),(77904,'97304','S','Salem','D','Polk','41053','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.013080,-123.101280,0,'2013-07-06 12:44:34',NULL,NULL),(25016,'27883','S','Stantonsburg','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.603896,-77.818704,0,'2013-07-06 12:44:31',NULL,NULL),(71973,'88020','S','Cloverdale','N','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.948375,-108.813066,0,'2013-07-06 12:44:34',NULL,NULL),(16762,'17519','S','East Earl','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.127373,-76.024073,0,'2013-07-06 12:44:31',NULL,NULL),(67261,'79961','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.774025,-106.375278,0,'2013-07-06 12:44:34',NULL,NULL),(77002,'96079','P','Shasta Lake','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.691415,-122.344769,0,'2013-07-06 12:44:34',NULL,NULL),(5632,'04945','S','Jhnsn Mtn TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(58195,'68317','S','Bennet','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.679200,-96.512593,0,'2013-07-06 12:44:33',NULL,NULL),(73715,'91612','U','Us Purchasing Exchange','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186548,-118.396887,0,'2013-07-06 12:44:34',NULL,NULL),(50759,'58416','S','Binford','D','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.583836,-98.369868,0,'2013-07-06 12:44:33',NULL,NULL),(2629,'00962','S','Urb Proyecto 141','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(20171,'20744','S','Ft Washington','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.752955,-76.981503,0,'2013-07-06 12:44:31',NULL,NULL),(62807,'74941','S','Keota','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.289455,-94.900018,0,'2013-07-06 12:44:33',NULL,NULL),(59279,'70462','S','Head of Island','N','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.383769,-90.574931,0,'2013-07-06 12:44:33',NULL,NULL),(14727,'15282','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.436290,-79.991277,0,'2013-07-06 12:44:31',NULL,NULL),(56178,'65011','S','Barnett','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.400396,-92.756743,0,'2013-07-06 12:44:33',NULL,NULL),(51192,'59028','S','Fishtail','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.298974,-109.788067,0,'2013-07-06 12:44:33',NULL,NULL),(39321,'44608','S','Beach City','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.656862,-81.585627,0,'2013-07-06 12:44:32',NULL,NULL),(78623,'98204','S','Eastmont','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.898431,-122.254822,0,'2013-07-06 12:44:34',NULL,NULL),(61719,'73014','S','Calumet','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.603749,-98.176851,0,'2013-07-06 12:44:33',NULL,NULL),(43923,'49267','S','Ottawa Lake','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.758173,-83.692281,0,'2013-07-06 12:44:32',NULL,NULL),(14528,'15205','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437059,-80.074137,0,'2013-07-06 12:44:31',NULL,NULL),(9658,'10039','S','Colonial Park','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(29364,'32572','P','Milton','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.627804,-87.048607,0,'2013-07-06 12:44:32',NULL,NULL),(60965,'72104','S','Glen Rose','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(13187,'13619','S','Carthage','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(9880,'10123','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(23172,'25028','S','Bob White','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.958740,-81.727818,0,'2013-07-06 12:44:31',NULL,NULL),(34302,'38544','S','Baxter','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.156092,-85.640158,0,'2013-07-06 12:44:32',NULL,NULL),(13360,'13730','S','North Afton','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.209640,-75.490260,0,'2013-07-06 12:44:31',NULL,NULL),(61312,'72435','S','Knobel','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.315336,-90.586579,0,'2013-07-06 12:44:33',NULL,NULL),(47931,'55113','S','Lauderdale','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(46150,'52658','S','Wever','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.683871,-91.199609,0,'2013-07-06 12:44:32',NULL,NULL),(22962,'24701','S','Green Valley','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(22891,'24581','S','Norwood','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.626118,-78.757592,0,'2013-07-06 12:44:31',NULL,NULL),(8447,'08085','S','Woolwich Township','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(8076,'07753','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(37596,'42122','S','Alvaton','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.866581,-86.361492,0,'2013-07-06 12:44:32',NULL,NULL),(54267,'62681','S','Ray','A','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.121657,-90.560514,0,'2013-07-06 12:44:33',NULL,NULL),(51053,'58740','S','Glenburn','D','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.519799,-101.238037,0,'2013-07-06 12:44:33',NULL,NULL),(14048,'14560','S','Webster Crossing','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.711095,-77.553933,0,'2013-07-06 12:44:31',NULL,NULL),(24517,'27284','S','Guthrie','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.116290,-80.092145,0,'2013-07-06 12:44:31',NULL,NULL),(60458,'71653','S','Luna','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(45011,'50454','S','Little Cedar','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.390835,-92.732723,0,'2013-07-06 12:44:32',NULL,NULL),(31901,'35144','P','Siluria','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.200000,-86.783333,0,'2013-07-06 12:44:32',NULL,NULL),(78061,'97456','S','Alpine','N','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.324340,-123.319140,0,'2013-07-06 12:44:34',NULL,NULL),(26726,'29418','S','Charleston Heights','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(57774,'67460','S','Mc Pherson','A','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.387160,-97.656540,0,'2013-07-06 12:44:33',NULL,NULL),(32149,'35464','S','Gainesville','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.819013,-88.154657,0,'2013-07-06 12:44:32',NULL,NULL),(32918,'36555','S','Magnolia Spgs','A','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.399119,-87.787327,0,'2013-07-06 12:44:32',NULL,NULL),(616,'00682','S','Alt de Algarrobo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(37267,'41571','S','Varney','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.609843,-82.418289,0,'2013-07-06 12:44:32',NULL,NULL),(71251,'86403','S','Lk Havasu Cty','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.487063,-114.330287,0,'2013-07-06 12:44:34',NULL,NULL),(38379,'43504','S','Berkey','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.699935,-83.833263,0,'2013-07-06 12:44:32',NULL,NULL),(63718,'75926','S','North Cedar','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.259600,-94.971845,0,'2013-07-06 12:44:34',NULL,NULL),(63671,'75855','S','Oakwood','D','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.580983,-95.892859,0,'2013-07-06 12:44:34',NULL,NULL),(24204,'26680','S','Russelville','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.100120,-80.886900,0,'2013-07-06 12:44:31',NULL,NULL),(21999,'23278','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.558671,-77.443034,0,'2013-07-06 12:44:31',NULL,NULL),(50689,'58352','S','Calio','A','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.655800,-98.850720,0,'2013-07-06 12:44:33',NULL,NULL),(71547,'87184','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.199435,-106.660676,0,'2013-07-06 12:44:34',NULL,NULL),(17554,'17981','S','Donaldson','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(12102,'12577','S','Salisbury Mills','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.433031,-74.121400,0,'2013-07-06 12:44:30',NULL,NULL),(40725,'46124','S','Camp atterbry','A','Johnson','18081','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.353574,-85.964085,0,'2013-07-06 12:44:32',NULL,NULL),(46883,'54113','S','Combined Lcks','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.268294,-88.309953,0,'2013-07-06 12:44:32',NULL,NULL),(49872,'57259','S','Revillo','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.017266,-96.548264,0,'2013-07-06 12:44:33',NULL,NULL),(48035,'55304','S','Soderville','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.254700,-93.240480,0,'2013-07-06 12:44:33',NULL,NULL),(21256,'22303','S','Jefferson Mnr','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.794024,-77.074314,0,'2013-07-06 12:44:31',NULL,NULL),(40544,'45846','S','Fort Recovery','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.418548,-84.748829,0,'2013-07-06 12:44:32',NULL,NULL),(65400,'77562','S','Highlands','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.819654,-95.046222,0,'2013-07-06 12:44:34',NULL,NULL),(25576,'28433','S','Emerson','N','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.518659,-78.643650,0,'2013-07-06 12:44:31',NULL,NULL),(33999,'38119','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.085796,-89.848658,0,'2013-07-06 12:44:32',NULL,NULL),(34031,'38133','S','Bartlett','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.206829,-89.791238,0,'2013-07-06 12:44:32',NULL,NULL),(39259,'44445','S','New Waterford','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.848035,-80.619830,0,'2013-07-06 12:44:32',NULL,NULL),(37315,'41647','S','Orkney','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.427384,-82.743993,0,'2013-07-06 12:44:32',NULL,NULL),(6519,'05824','S','Kirby','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.435400,-71.854320,0,'2013-07-06 12:44:30',NULL,NULL),(74351,'92410','S','Base Line','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.105653,-117.294667,0,'2013-07-06 12:44:34',NULL,NULL),(69198,'83346','S','Churchill','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.303000,-113.996280,0,'2013-07-06 12:44:34',NULL,NULL),(61757,'73051','S','Lexington','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.016330,-97.333336,0,'2013-07-06 12:44:33',NULL,NULL),(59014,'70071','S','Lutcher','D','Saint James','22093','Louisiana','LA','22','5560','225','Central',-6.0,'Y',30.060777,-90.709558,0,'2013-07-06 12:44:33',NULL,NULL),(55642,'64017','S','Camden','D','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.192889,-94.012716,0,'2013-07-06 12:44:33',NULL,NULL),(43034,'48174','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.215215,-83.344726,0,'2013-07-06 12:44:32',NULL,NULL),(39817,'45144','S','Manchester','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.702000,-83.612593,0,'2013-07-06 12:44:32',NULL,NULL),(73771,'91737','S','Rch Cucamonga','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.146529,-117.573112,0,'2013-07-06 12:44:34',NULL,NULL),(67994,'80919','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.928018,-104.848484,0,'2013-07-06 12:44:34',NULL,NULL),(22587,'24168','S','Stanleytown','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.735940,-79.941103,0,'2013-07-06 12:44:31',NULL,NULL),(74088,'92192','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.854108,-117.211801,0,'2013-07-06 12:44:34',NULL,NULL),(27257,'29931','P','Lobeco','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.553916,-80.745388,0,'2013-07-06 12:44:31',NULL,NULL),(16675,'17362','S','Menges Mills','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.874292,-76.864491,0,'2013-07-06 12:44:31',NULL,NULL),(5781,'05052','S','N Hartland','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.592240,-72.354055,0,'2013-07-06 12:44:30',NULL,NULL),(53998,'62444','S','Fancher','N','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.278154,-88.636713,0,'2013-07-06 12:44:33',NULL,NULL),(53380,'61791','U','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.474272,-88.955768,0,'2013-07-06 12:44:33',NULL,NULL),(34882,'38944','S','Highlandale','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.696389,-90.295000,0,'2013-07-06 12:44:32',NULL,NULL),(35520,'39534','P','Keesler Air Force Base','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.413857,-88.910394,0,'2013-07-06 12:44:32',NULL,NULL),(50490,'58054','S','Elliott','A','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.415340,-97.653120,0,'2013-07-06 12:44:33',NULL,NULL),(38231,'43230','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.044616,-82.856435,0,'2013-07-06 12:44:32',NULL,NULL),(46657,'53705','S','Shorewood Hills','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075083,-89.459898,0,'2013-07-06 12:44:32',NULL,NULL),(2346,'00939','U','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.408286,-66.064668,0,'2013-07-06 12:44:30',NULL,NULL),(57051,'66211','S','Leawood','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(19252,'19940','S','Delmar','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.455711,-75.574361,0,'2013-07-06 12:44:31',NULL,NULL),(76668,'95762','S','El Dorado Hills','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.715279,-121.078888,0,'2013-07-06 12:44:34',NULL,NULL),(77662,'97024','S','Fairview','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.539229,-122.437076,0,'2013-07-06 12:44:34',NULL,NULL),(79882,'99574','P','Chenega Bay','A','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.074390,-147.992410,0,'2013-07-06 12:44:34',NULL,NULL),(28429,'31331','S','Shellman Bluff','A','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(40723,'46123','S','Avon','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.760556,-86.526389,0,'2013-07-06 12:44:32',NULL,NULL),(72900,'90021','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.027564,-118.241023,0,'2013-07-06 12:44:34',NULL,NULL),(30234,'33190','S','Cutler Ridge','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556771,-80.336864,0,'2013-07-06 12:44:32',NULL,NULL),(44174,'49548','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866570,-85.660484,0,'2013-07-06 12:44:32',NULL,NULL),(35138,'39217','U','Jackson State University','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.288941,-90.186095,0,'2013-07-06 12:44:32',NULL,NULL),(10886,'11422','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.663176,-73.733191,0,'2013-07-06 12:44:30',NULL,NULL),(10879,'11420','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674361,-73.813156,0,'2013-07-06 12:44:30',NULL,NULL),(20043,'20650','S','Leonardtown','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.297340,-76.648620,0,'2013-07-06 12:44:31',NULL,NULL),(23583,'25670','S','Myrtle','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.726001,-82.126879,0,'2013-07-06 12:44:31',NULL,NULL),(22815,'24486','S','Shenandoah Valley Airpot','N','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.265140,-78.899185,0,'2013-07-06 12:44:31',NULL,NULL),(22262,'23691','S','Naval Weapons Sta','N','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.244023,-76.551905,0,'2013-07-06 12:44:31',NULL,NULL),(42774,'48039','S','Marine City','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.719047,-82.521691,0,'2013-07-06 12:44:32',NULL,NULL),(67247,'79946','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.762602,-106.478650,0,'2013-07-06 12:44:34',NULL,NULL),(52593,'61015','S','Chana','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.989953,-89.208021,0,'2013-07-06 12:44:33',NULL,NULL),(49097,'56335','P','Greenwald','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.598995,-94.859424,0,'2013-07-06 12:44:33',NULL,NULL),(36873,'41094','S','Walton','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.884714,-84.634472,0,'2013-07-06 12:44:32',NULL,NULL),(27747,'30358','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.934524,-84.388655,0,'2013-07-06 12:44:31',NULL,NULL),(25535,'28402','P','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.238808,-77.948973,0,'2013-07-06 12:44:31',NULL,NULL),(16887,'17576','S','Smoketown','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.035728,-76.199636,0,'2013-07-06 12:44:31',NULL,NULL),(56512,'65350','S','Beaman','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.680224,-93.092795,0,'2013-07-06 12:44:33',NULL,NULL),(46841,'54017','S','Jewett','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(15557,'16634','P','Dudley','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.222518,-78.165792,0,'2013-07-06 12:44:31',NULL,NULL),(71722,'87532','S','El Rancho','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(6071,'05446','S','Colchester','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.548500,-73.215480,0,'2013-07-06 12:44:30',NULL,NULL),(7834,'07461','S','Beemerville','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.243526,-74.597544,0,'2013-07-06 12:44:30',NULL,NULL),(63918,'76049','S','Decordova','A','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.449949,-97.737417,0,'2013-07-06 12:44:34',NULL,NULL),(9460,'10008','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(7154,'06419','S','Killingworth','D','Middlesex','09007','Connecticut','CT','09','5480','860/959','Eastern',-5.0,'Y',41.375700,-72.581460,0,'2013-07-06 12:44:30',NULL,NULL),(69533,'83735','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.610738,-116.199409,0,'2013-07-06 12:44:34',NULL,NULL),(64940,'77224','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.771587,-95.516816,0,'2013-07-06 12:44:34',NULL,NULL),(60278,'71449','S','Clare','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.564189,-93.481045,0,'2013-07-06 12:44:33',NULL,NULL),(52864,'61333','S','Long Point','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.003788,-88.895310,0,'2013-07-06 12:44:33',NULL,NULL),(21935,'23229','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602592,-77.557517,0,'2013-07-06 12:44:31',NULL,NULL),(13636,'13905','S','Broadacres','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(7193,'06474','P','North Westchester','D','New London','09011','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.588161,-72.397834,0,'2013-07-06 12:44:30',NULL,NULL),(75880,'94953','P','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.261520,-122.639077,0,'2013-07-06 12:44:34',NULL,NULL),(343,'00656','S','Ext Santa Elena 2','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(5638,'04945','S','Sandy Bay TWP','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(72085,'88136','S','Ramon','N','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.351148,-104.598484,0,'2013-07-06 12:44:34',NULL,NULL),(53873,'62345','S','Kinderhook','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.647467,-91.185504,0,'2013-07-06 12:44:33',NULL,NULL),(15934,'17021','S','Scyoc','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(21874,'23162','P','Studley','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.675314,-77.290214,0,'2013-07-06 12:44:31',NULL,NULL),(4575,'03570','S','Berlin','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.476298,-71.176748,0,'2013-07-06 12:44:30',NULL,NULL),(3573,'01965','P','Prides Crossing','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.561561,-70.833711,0,'2013-07-06 12:44:30',NULL,NULL),(64350,'76519','S','Burlington','D','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.959980,-96.867177,0,'2013-07-06 12:44:34',NULL,NULL),(31182,'33929','P','Estero','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.436857,-81.809864,0,'2013-07-06 12:44:32',NULL,NULL),(34731,'38848','S','Splunge','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.850186,-88.364251,0,'2013-07-06 12:44:32',NULL,NULL),(77388,'96766','S','Lihue','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.978912,-159.367250,0,'2013-07-06 12:44:34',NULL,NULL),(13744,'14111','S','North Collins','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.583510,-78.908047,0,'2013-07-06 12:44:31',NULL,NULL),(5488,'04747','S','Dyer Brook','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.011654,-68.271262,0,'2013-07-06 12:44:30',NULL,NULL),(921,'00714','S','Ext Jard de Arroyo','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(66628,'78799','S','Rmx','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.267104,-97.744615,0,'2013-07-06 12:44:34',NULL,NULL),(10795,'11371','S','East Elmhurst','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.775842,-73.874904,0,'2013-07-06 12:44:30',NULL,NULL),(63319,'75570','S','Boston','A','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.457080,-94.450920,0,'2013-07-06 12:44:33',NULL,NULL),(51640,'59865','S','St Ignatius','A','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.357879,-114.052628,0,'2013-07-06 12:44:33',NULL,NULL),(49961,'57349','S','Vilas','N','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.014323,-97.529484,0,'2013-07-06 12:44:33',NULL,NULL),(44264,'49688','S','Tustin','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.113680,-85.430879,0,'2013-07-06 12:44:32',NULL,NULL),(19501,'20165','S','Potomac Falls','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.053592,-77.392876,0,'2013-07-06 12:44:31',NULL,NULL),(33739,'37828','P','Norris','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.194145,-84.069274,0,'2013-07-06 12:44:32',NULL,NULL),(52008,'60172','S','Keeneyville','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.977560,-88.073640,0,'2013-07-06 12:44:33',NULL,NULL),(17407,'17901','S','Primrose','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(65108,'77369','P','Rye','D','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.450867,-94.765224,0,'2013-07-06 12:44:34',NULL,NULL),(75539,'94211','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586276,-121.495459,0,'2013-07-06 12:44:34',NULL,NULL),(28396,'31314','S','Fort Stewart','D','Liberty','13179','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.866667,-81.583333,0,'2013-07-06 12:44:32',NULL,NULL),(62316,'74037','S','Jenks','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.013289,-95.979724,0,'2013-07-06 12:44:33',NULL,NULL),(24451,'27215','S','BURL','N','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.033420,-79.490880,0,'2013-07-06 12:44:31',NULL,NULL),(59534,'70811','S','Scotlandville','A','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.532352,-91.124008,0,'2013-07-06 12:44:33',NULL,NULL),(48472,'55720','S','Scanlon','N','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.729380,-92.459220,0,'2013-07-06 12:44:33',NULL,NULL),(77528,'96848','U','East West Center','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.321456,-157.813409,0,'2013-07-06 12:44:34',NULL,NULL),(65621,'77957','S','El Toro','N','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.974180,-96.649920,0,'2013-07-06 12:44:34',NULL,NULL),(16644,'17340','S','White Hall','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.763200,-77.117160,0,'2013-07-06 12:44:31',NULL,NULL),(1843,'00784','S','Villa Rosa 2','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(9048,'08887','S','Three Bridges','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.529051,-74.779412,0,'2013-07-06 12:44:30',NULL,NULL),(19927,'20558','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896381,-77.037179,0,'2013-07-06 12:44:31',NULL,NULL),(37950,'42717','S','Dubre','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(77792,'97134','P','Oceanside','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.461968,-123.966459,0,'2013-07-06 12:44:34',NULL,NULL),(61708,'73005','S','Washita','A','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.072673,-98.245206,0,'2013-07-06 12:44:33',NULL,NULL),(2777,'00976','S','Colinas de Fairview','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(53389,'61813','S','Bement','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.923087,-88.579119,0,'2013-07-06 12:44:33',NULL,NULL),(12896,'13333','S','E Springfield','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.831907,-74.761141,0,'2013-07-06 12:44:30',NULL,NULL),(12607,'13083','S','Boylston','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.647853,-76.060983,0,'2013-07-06 12:44:30',NULL,NULL),(69139,'83302','S','Rogerson','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.208715,-114.593476,0,'2013-07-06 12:44:34',NULL,NULL),(24311,'27017','S','Fairview Cross Roads','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(38337,'43436','P','Isle Saint George','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.715585,-82.819135,0,'2013-07-06 12:44:32',NULL,NULL),(51276,'59111','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.634161,-108.361047,0,'2013-07-06 12:44:33',NULL,NULL),(78698,'98258','S','Hartford','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',48.027419,-122.062363,0,'2013-07-06 12:44:34',NULL,NULL),(14034,'14548','S','Shortsville','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.963180,-77.238668,0,'2013-07-06 12:44:31',NULL,NULL),(9602,'10031','S','Hamilton Grange','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(76698,'95827','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.552817,-121.333407,0,'2013-07-06 12:44:34',NULL,NULL),(79460,'98851','S','Adco','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.395140,-119.452020,0,'2013-07-06 12:44:34',NULL,NULL),(77216,'96385','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(3733,'02155','S','West Medford','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.421320,-71.113443,0,'2013-07-06 12:44:30',NULL,NULL),(21497,'22660','S','Toms Brook','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.949385,-78.430840,0,'2013-07-06 12:44:31',NULL,NULL),(60045,'71346','S','Chambers','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(58329,'68453','S','Tobias','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.420152,-97.340201,0,'2013-07-06 12:44:33',NULL,NULL),(12053,'12531','S','Homes','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.504700,-73.661640,0,'2013-07-06 12:44:30',NULL,NULL),(31374,'34211','S','Bradington','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(56209,'65026','S','Rocky Mount','A','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(68636,'81636','P','Btlmt Mesa','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.438650,-108.025498,0,'2013-07-06 12:44:34',NULL,NULL),(76249,'95402','P','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.471813,-122.607592,0,'2013-07-06 12:44:34',NULL,NULL),(19866,'20525','U','Action','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900624,-77.030204,0,'2013-07-06 12:44:31',NULL,NULL),(37243,'41553','S','Phelps','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492791,-82.167535,0,'2013-07-06 12:44:32',NULL,NULL),(61566,'72729','S','Evansville','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.803586,-94.473781,0,'2013-07-06 12:44:33',NULL,NULL),(7517,'07003','S','Brookdale','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.805311,-74.187412,0,'2013-07-06 12:44:30',NULL,NULL),(55691,'64062','S','Lawson','D','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.438047,-94.203353,0,'2013-07-06 12:44:33',NULL,NULL),(35232,'39309','U','Naval Air Station','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.537503,-88.567935,0,'2013-07-06 12:44:32',NULL,NULL),(23774,'25976','S','Lockbridge','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.866798,-80.852381,0,'2013-07-06 12:44:31',NULL,NULL),(33432,'37301','S','Altamont','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.418786,-85.797724,0,'2013-07-06 12:44:32',NULL,NULL),(33488,'37347','S','Jasper','D','Marion','47115','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.069280,-85.602300,0,'2013-07-06 12:44:32',NULL,NULL),(65567,'77845','S','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.583511,-96.294277,0,'2013-07-06 12:44:34',NULL,NULL),(8588,'08224','P','New Gretna','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.605078,-74.456484,0,'2013-07-06 12:44:30',NULL,NULL),(29904,'33051','P','Key Col Bch','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.721329,-81.021245,0,'2013-07-06 12:44:32',NULL,NULL),(39986,'45240','S','Pleasant Run Farms','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.285863,-84.524542,0,'2013-07-06 12:44:32',NULL,NULL),(9489,'10012','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(39570,'44851','S','New London','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.101292,-82.421414,0,'2013-07-06 12:44:32',NULL,NULL),(17183,'17815','S','Shumans','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(29171,'32356','S','Salem','D','Taylor','12123','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.790746,-83.383125,0,'2013-07-06 12:44:32',NULL,NULL),(60727,'71958','S','Billstown','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.060950,-93.689939,0,'2013-07-06 12:44:33',NULL,NULL),(61773,'73063','S','Mulhall','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',36.053460,-97.419230,0,'2013-07-06 12:44:33',NULL,NULL),(62180,'73757','S','Lucien','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.271246,-97.450039,0,'2013-07-06 12:44:33',NULL,NULL),(69998,'84123','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(71104,'85942','P','Snowflake','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.782119,-110.045248,0,'2013-07-06 12:44:34',NULL,NULL),(9170,'09353','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(61544,'72685','S','Yardelle','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.042357,-92.985835,0,'2013-07-06 12:44:33',NULL,NULL),(24625,'27355','S','Staley','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.805737,-79.536595,0,'2013-07-06 12:44:31',NULL,NULL),(44230,'49654','S','Leland','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.025065,-85.752371,0,'2013-07-06 12:44:32',NULL,NULL),(14044,'14558','P','South Lima','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.853824,-77.677651,0,'2013-07-06 12:44:31',NULL,NULL),(8016,'07724','S','Monmouth','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.299859,-74.070754,0,'2013-07-06 12:44:30',NULL,NULL),(66044,'78370','S','Odem','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.947711,-97.586188,0,'2013-07-06 12:44:34',NULL,NULL),(72129,'88268','P','Whites City','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.174578,-104.374040,0,'2013-07-06 12:44:34',NULL,NULL),(76855,'95965','S','Thermalito','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(27040,'29664','S','Mountain Rest','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.805775,-83.258248,0,'2013-07-06 12:44:31',NULL,NULL),(24550,'27292','S','Silver Valley','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(19668,'20318','U','Army Criminal Invest','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.864971,-77.012219,0,'2013-07-06 12:44:31',NULL,NULL),(60356,'71469','S','Vowells Mill','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(64773,'77001','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.720395,-95.222061,0,'2013-07-06 12:44:34',NULL,NULL),(67042,'79546','S','Raytown','N','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.854577,-100.463181,0,'2013-07-06 12:44:34',NULL,NULL),(72860,'90003','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.962989,-118.272517,0,'2013-07-06 12:44:34',NULL,NULL),(1613,'00769','S','Valle Escondido','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(55304,'63532','S','Number Eight','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.750077,-92.562520,0,'2013-07-06 12:44:33',NULL,NULL),(54749,'62977','S','Raleigh','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.824107,-88.545944,0,'2013-07-06 12:44:33',NULL,NULL),(49005,'56251','S','Kandiyohi','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.143967,-94.926175,0,'2013-07-06 12:44:33',NULL,NULL),(72204,'88416','P','Conchas Dam','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.351226,-104.048850,0,'2013-07-06 12:44:34',NULL,NULL),(37391,'41760','S','Scuddy','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.213406,-83.091384,0,'2013-07-06 12:44:32',NULL,NULL),(32992,'36625','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.694869,-88.045798,0,'2013-07-06 12:44:32',NULL,NULL),(26948,'29603','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.850619,-82.396693,0,'2013-07-06 12:44:31',NULL,NULL),(24062,'26431','S','Francis Mine','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.388634,-80.299510,0,'2013-07-06 12:44:31',NULL,NULL),(40361,'45638','S','Coal Grove','A','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.524095,-82.664084,0,'2013-07-06 12:44:32',NULL,NULL),(11400,'11951','S','Old Mastic','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.764527,-72.843517,0,'2013-07-06 12:44:30',NULL,NULL),(7892,'07538','P','Paterson','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.936601,-74.189611,0,'2013-07-06 12:44:30',NULL,NULL),(43300,'48342','S','Pontiac','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.646052,-83.273628,0,'2013-07-06 12:44:32',NULL,NULL),(16729,'17408','S','West Manchester Twp','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015315,-76.597579,0,'2013-07-06 12:44:31',NULL,NULL),(11017,'11559','S','Lawrence','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.611795,-73.732344,0,'2013-07-06 12:44:30',NULL,NULL),(48455,'55711','S','Brkston','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.856672,-92.673076,0,'2013-07-06 12:44:33',NULL,NULL),(78988,'98378','P','Retsil','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.544889,-122.618001,0,'2013-07-06 12:44:34',NULL,NULL),(64084,'76148','S','Watauga','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(57990,'67851','S','Holcomb','D','Finney','20055','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.005295,-100.984166,0,'2013-07-06 12:44:33',NULL,NULL),(39584,'44859','S','Nova','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.001752,-82.345248,0,'2013-07-06 12:44:32',NULL,NULL),(16027,'17042','S','N Cornwall','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(25939,'28655','S','Petersburg','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(14166,'14731','S','Ellicottville','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.292555,-78.658909,0,'2013-07-06 12:44:31',NULL,NULL),(19299,'19979','S','Viola','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.038951,-75.569599,0,'2013-07-06 12:44:31',NULL,NULL),(4676,'03784','S','West Lebanon','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.652405,-72.304175,0,'2013-07-06 12:44:30',NULL,NULL),(54351,'62781','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.810838,-89.655757,0,'2013-07-06 12:44:33',NULL,NULL),(13721,'14085','S','Lakeview','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.719062,-78.934684,0,'2013-07-06 12:44:31',NULL,NULL),(45747,'52136','S','Florenceville','N','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.376062,-92.114632,0,'2013-07-06 12:44:32',NULL,NULL),(40868,'46234','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.807710,-86.337590,0,'2013-07-06 12:44:32',NULL,NULL),(8722,'08505','S','Bordentown','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.128420,-74.716860,0,'2013-07-06 12:44:30',NULL,NULL),(4754,'03846','S','Jackson','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.184322,-71.189585,0,'2013-07-06 12:44:30',NULL,NULL),(49497,'56662','S','Outing','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.846424,-93.901398,0,'2013-07-06 12:44:33',NULL,NULL),(49778,'57075','S','Lake Madison','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.998194,-96.968790,0,'2013-07-06 12:44:33',NULL,NULL),(64108,'76180','S','Haltom City','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(36291,'40356','S','Nicholasville','D','Jessamine','21113','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.883596,-84.566606,0,'2013-07-06 12:44:32',NULL,NULL),(58220,'68340','S','Deshler','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.137330,-97.723815,0,'2013-07-06 12:44:33',NULL,NULL),(10295,'10522','S','Dobbs Ferry','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.011736,-73.865605,0,'2013-07-06 12:44:30',NULL,NULL),(23892,'26180','S','Walker','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.181974,-81.367925,0,'2013-07-06 12:44:31',NULL,NULL),(68227,'81050','S','Timpas','A','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(36297,'40359','S','Owenton','D','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.478600,-84.814080,0,'2013-07-06 12:44:32',NULL,NULL),(21239,'22241','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.858702,-77.056354,0,'2013-07-06 12:44:31',NULL,NULL),(8883,'08721','S','Berkeley Twp','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.906120,-74.174220,0,'2013-07-06 12:44:30',NULL,NULL),(14957,'15618','S','Edmon','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.528479,-79.465500,0,'2013-07-06 12:44:31',NULL,NULL),(31382,'34217','S','Bradenton Bch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.508565,-82.716234,0,'2013-07-06 12:44:32',NULL,NULL),(26756,'29426','S','Osborn','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.789760,-80.352960,0,'2013-07-06 12:44:31',NULL,NULL),(24352,'27043','S','Dalton','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.255873,-80.442780,0,'2013-07-06 12:44:31',NULL,NULL),(21607,'22901','S','Chville','N','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.057163,-78.493130,0,'2013-07-06 12:44:31',NULL,NULL),(4964,'04107','S','Cape Elizabeth','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.610918,-70.232964,0,'2013-07-06 12:44:30',NULL,NULL),(6223,'05489','S','Underhill','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.538900,-72.920580,0,'2013-07-06 12:44:30',NULL,NULL),(5186,'04443','S','Eliotsvle Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.214034,-69.409404,0,'2013-07-06 12:44:30',NULL,NULL),(47038,'54407','S','Amherst Junction','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.518339,-89.294289,0,'2013-07-06 12:44:32',NULL,NULL),(61099,'72136','S','Gravel Hill','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.216583,-92.069911,0,'2013-07-06 12:44:33',NULL,NULL),(70406,'84716','P','Boulder Town','N','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.831807,-111.204558,0,'2013-07-06 12:44:34',NULL,NULL),(38424,'43550','P','Napoleon','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.392207,-84.123017,0,'2013-07-06 12:44:32',NULL,NULL),(47964,'55122','S','Eagan','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.801661,-93.199294,0,'2013-07-06 12:44:33',NULL,NULL),(2724,'00969','S','Urb Bucare','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(7644,'07073','S','E Rutherford','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.839748,-74.102949,0,'2013-07-06 12:44:30',NULL,NULL),(9083,'09028','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19154,'19713','S','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.670132,-75.719978,0,'2013-07-06 12:44:31',NULL,NULL),(72137,'88310','S','White Sands National Monumen','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.899416,-105.951065,0,'2013-07-06 12:44:34',NULL,NULL),(864,'00698','S','Urb Los Angeles','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(73253,'90707','P','Bellflower','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.882350,-118.122206,0,'2013-07-06 12:44:34',NULL,NULL),(26513,'29177','P','White Rock','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.157696,-81.282809,0,'2013-07-06 12:44:31',NULL,NULL),(65507,'77670','P','Vidor','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.121730,-94.012004,0,'2013-07-06 12:44:34',NULL,NULL),(30466,'33338','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140429,-80.125290,0,'2013-07-06 12:44:32',NULL,NULL),(49564,'56720','P','Donaldson','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.586837,-96.863331,0,'2013-07-06 12:44:33',NULL,NULL),(3789,'02211','U','Bank of America','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358069,-71.056709,0,'2013-07-06 12:44:30',NULL,NULL),(8856,'08648','S','Lawrence Township','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.265940,-74.695860,0,'2013-07-06 12:44:30',NULL,NULL),(33709,'37770','S','Lancing','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.151530,-84.688941,0,'2013-07-06 12:44:32',NULL,NULL),(28285,'31091','S','Unidilla','N','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.259597,-83.746979,0,'2013-07-06 12:44:31',NULL,NULL),(26320,'29045','S','Elgin','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.180379,-80.797725,0,'2013-07-06 12:44:31',NULL,NULL),(5481,'04744','P','Ft Kent Mls','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.237810,-68.581454,0,'2013-07-06 12:44:30',NULL,NULL),(21834,'23119','S','Moon','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.448456,-76.305783,0,'2013-07-06 12:44:31',NULL,NULL),(41919,'47380','S','Randolph','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.292380,-85.028052,0,'2013-07-06 12:44:32',NULL,NULL),(43108,'48220','S','Royal Oak Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458803,-83.138618,0,'2013-07-06 12:44:32',NULL,NULL),(2166,'00926','S','BO Carraizo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(5440,'04686','S','Machias','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.952222,-67.661389,0,'2013-07-06 12:44:30',NULL,NULL),(15219,'16020','S','Annandale','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.110539,-79.900944,0,'2013-07-06 12:44:31',NULL,NULL),(54851,'63042','S','Hazelwood','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.777796,-90.371867,0,'2013-07-06 12:44:33',NULL,NULL),(37414,'41778','P','Yerkes','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.278519,-83.300052,0,'2013-07-06 12:44:32',NULL,NULL),(24985,'27856','S','Momeyer','A','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.965691,-77.958946,0,'2013-07-06 12:44:31',NULL,NULL),(66261,'78575','S','Olmito','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.021280,-97.533780,0,'2013-07-06 12:44:34',NULL,NULL),(60927,'72084','S','Lono','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.219063,-92.603497,0,'2013-07-06 12:44:33',NULL,NULL),(19096,'19605','S','Laureldale','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(19024,'19530','S','Schofer','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.533780,-75.789540,0,'2013-07-06 12:44:31',NULL,NULL),(18080,'18705','S','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(63562,'75770','S','Moore Station','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.149920,-95.613600,0,'2013-07-06 12:44:34',NULL,NULL),(77712,'97056','S','Scappoose','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.760391,-122.933635,0,'2013-07-06 12:44:34',NULL,NULL),(76051,'95191','U','A M O R C','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.324072,-121.917236,0,'2013-07-06 12:44:34',NULL,NULL),(71980,'88023','S','Bayard','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.765190,-108.135124,0,'2013-07-06 12:44:34',NULL,NULL),(64579,'76667','S','Forest Glade','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.680599,-96.478818,0,'2013-07-06 12:44:34',NULL,NULL),(58203,'68325','S','Byron','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.041978,-97.752191,0,'2013-07-06 12:44:33',NULL,NULL),(56635,'65607','P','Caplinger Mls','A','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.794964,-93.804523,0,'2013-07-06 12:44:33',NULL,NULL),(48002,'55150','P','Saint Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.886247,-93.161578,0,'2013-07-06 12:44:33',NULL,NULL),(13672,'14035','P','Collins Center','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.493611,-78.851667,0,'2013-07-06 12:44:31',NULL,NULL),(22230,'23605','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.019385,-76.437883,0,'2013-07-06 12:44:31',NULL,NULL),(11361,'11819','U','Hicksville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.763511,-73.532506,0,'2013-07-06 12:44:30',NULL,NULL),(40147,'45348','S','New Weston','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.321680,-84.627120,0,'2013-07-06 12:44:32',NULL,NULL),(20414,'20906','S','Glenmont','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(41081,'46532','S','Hamlet','D','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.382638,-86.585826,0,'2013-07-06 12:44:32',NULL,NULL),(44345,'49774','S','Pickford','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.168679,-84.181686,0,'2013-07-06 12:44:32',NULL,NULL),(18981,'19520','S','Marsh','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(25625,'28461','S','Southport','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(58756,'68959','S','Minden','D','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.493757,-98.949409,0,'2013-07-06 12:44:33',NULL,NULL),(49896,'57273','S','Waubay','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.335539,-97.310586,0,'2013-07-06 12:44:33',NULL,NULL),(53410,'61839','S','De Land','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.122514,-88.649386,0,'2013-07-06 12:44:33',NULL,NULL),(690,'00685','S','Comunidad Gonzalez','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(42903,'48103','S','Delhi','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.270780,-83.808660,0,'2013-07-06 12:44:32',NULL,NULL),(71728,'87532','S','Quarteles','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(71050,'85749','S','Fort Lowell','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.270941,-110.767721,0,'2013-07-06 12:44:34',NULL,NULL),(61079,'72129','S','Buie','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.294448,-92.504614,0,'2013-07-06 12:44:33',NULL,NULL),(33962,'38106','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.107211,-90.042832,0,'2013-07-06 12:44:32',NULL,NULL),(36553,'40906','S','Tedders','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(11083,'11691','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.602157,-73.760226,0,'2013-07-06 12:44:30',NULL,NULL),(1398,'00738','S','Urb Fajardo Gdns','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(4194,'02825','S','Scituate','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.785822,-71.728016,0,'2013-07-06 12:44:30',NULL,NULL),(16204,'17070','S','Nw Cumb','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(2135,'00924','S','Urb El Cemi','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(78658,'98230','S','Blaine','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.961751,-122.743093,0,'2013-07-06 12:44:34',NULL,NULL),(36472,'40744','S','London','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.068625,-84.020634,0,'2013-07-06 12:44:32',NULL,NULL),(65636,'77964','S','Koerth','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(61449,'72616','S','Berryville','D','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367020,-93.580140,0,'2013-07-06 12:44:33',NULL,NULL),(53368,'61772','S','Shirley','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.418702,-89.091981,0,'2013-07-06 12:44:33',NULL,NULL),(49703,'57032','S','Harrisburg','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.427784,-96.697425,0,'2013-07-06 12:44:33',NULL,NULL),(46272,'53027','S','Hartford','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.300873,-88.364442,0,'2013-07-06 12:44:32',NULL,NULL),(38162,'43151','P','Sedalia','D','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.729960,-83.471690,0,'2013-07-06 12:44:32',NULL,NULL),(78806,'98328','S','Eatonville','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',46.867140,-122.289000,0,'2013-07-06 12:44:34',NULL,NULL),(79369,'98660','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.642953,-122.675812,0,'2013-07-06 12:44:34',NULL,NULL),(34142,'38233','S','Kenton','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.177966,-89.025271,0,'2013-07-06 12:44:32',NULL,NULL),(69970,'84119','S','West Valley','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(69123,'83278','S','Stanley','D','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.330002,-114.863022,0,'2013-07-06 12:44:34',NULL,NULL),(68289,'81089','S','Mutual','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(52808,'61279','S','Perryton','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.342093,-90.705564,0,'2013-07-06 12:44:33',NULL,NULL),(4089,'02667','S','Wellfleet','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.931957,-70.085896,0,'2013-07-06 12:44:30',NULL,NULL),(7546,'07011','S','Main Avenue Station','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.877054,-74.145198,0,'2013-07-06 12:44:30',NULL,NULL),(19505,'20167','P','Sterling','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.017034,-77.394089,0,'2013-07-06 12:44:31',NULL,NULL),(31930,'35180','S','Warrior','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.801525,-86.836468,0,'2013-07-06 12:44:32',NULL,NULL),(38594,'43824','S','New Bedford','A','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.347220,-81.738511,0,'2013-07-06 12:44:32',NULL,NULL),(44318,'49743','S','Hawks','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.294167,-83.873513,0,'2013-07-06 12:44:32',NULL,NULL),(10071,'10179','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754518,-73.976308,0,'2013-07-06 12:44:30',NULL,NULL),(25159,'28032','S','Cramerton','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.239413,-81.076081,0,'2013-07-06 12:44:31',NULL,NULL),(18780,'19371','P','Suplee','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.098036,-75.879527,0,'2013-07-06 12:44:31',NULL,NULL),(67723,'80541','P','Masonville','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.554970,-105.389763,0,'2013-07-06 12:44:34',NULL,NULL),(72054,'88103','P','Clovis','A','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.395300,-103.324380,0,'2013-07-06 12:44:34',NULL,NULL),(74029,'92134','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.727421,-117.147060,0,'2013-07-06 12:44:34',NULL,NULL),(77739,'97077','U','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.493610,-122.800298,0,'2013-07-06 12:44:34',NULL,NULL),(40542,'45845','S','Fort Loramie','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.327233,-84.374535,0,'2013-07-06 12:44:32',NULL,NULL),(22289,'23805','S','Petersburg','D','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.136328,-77.391900,0,'2013-07-06 12:44:31',NULL,NULL),(2528,'00957','S','Valle de Cerro Gordo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(22094,'23410','S','Melfa','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.639778,-75.748841,0,'2013-07-06 12:44:31',NULL,NULL),(73450,'91301','S','Saratoga Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(25419,'28301','S','Fay','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.064922,-78.864925,0,'2013-07-06 12:44:31',NULL,NULL),(80084,'99737','S','Dot Lake','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.022280,-145.516080,0,'2013-07-06 12:44:34',NULL,NULL),(70732,'85303','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.522173,-112.218359,0,'2013-07-06 12:44:34',NULL,NULL),(53688,'62225','S','Scott Air Force Base','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.539124,-89.851513,0,'2013-07-06 12:44:33',NULL,NULL),(47153,'54466','S','Pittsville','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.448100,-90.177921,0,'2013-07-06 12:44:32',NULL,NULL),(46746,'53923','S','Friesland','A','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.546952,-89.105675,0,'2013-07-06 12:44:32',NULL,NULL),(33107,'36855','S','Five Points','D','Chambers','01017','Alabama','AL','01','0000','334','Central',-6.0,'Y',33.049589,-85.270722,0,'2013-07-06 12:44:32',NULL,NULL),(41743,'47270','S','Paris Xing','A','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.855889,-85.743535,0,'2013-07-06 12:44:32',NULL,NULL),(6262,'05602','S','Middlesex Ctr','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(43678,'48870','P','Palo','D','Ionia','26067','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.107474,-84.987566,0,'2013-07-06 12:44:32',NULL,NULL),(18766,'19353','P','Exton','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.053600,-75.660180,0,'2013-07-06 12:44:31',NULL,NULL),(45069,'50519','S','Saint Joseph','N','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.865196,-94.283898,0,'2013-07-06 12:44:32',NULL,NULL),(70605,'85118','S','Queen Valley','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(5538,'04785','S','Hamlin','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.163199,-67.942329,0,'2013-07-06 12:44:30',NULL,NULL),(48478,'55723','S','Cook','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.867400,-92.779260,0,'2013-07-06 12:44:33',NULL,NULL),(78958,'98370','S','Lemolo','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(65771,'78108','S','Schertz','A','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.568245,-98.229209,0,'2013-07-06 12:44:34',NULL,NULL),(63959,'76094','P','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.724092,-97.150735,0,'2013-07-06 12:44:34',NULL,NULL),(30836,'33629','S','Palma Ceia','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.921224,-82.508478,0,'2013-07-06 12:44:32',NULL,NULL),(30671,'33467','S','Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.606929,-80.177700,0,'2013-07-06 12:44:32',NULL,NULL),(15993,'17036','S','Hoernerstown','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.277580,-76.708800,0,'2013-07-06 12:44:31',NULL,NULL),(31193,'33935','S','Labelle','D','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.634300,-81.341400,0,'2013-07-06 12:44:32',NULL,NULL),(34601,'38748','S','Foote','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(75013,'93458','S','Santa Maria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.952802,-120.431903,0,'2013-07-06 12:44:34',NULL,NULL),(76452,'95610','S','Citrus Heights','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.696835,-121.265911,0,'2013-07-06 12:44:34',NULL,NULL),(42108,'47465','S','Fairplay','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.038049,-87.047701,0,'2013-07-06 12:44:32',NULL,NULL),(1108,'00725','S','Urb San Marcos','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(12786,'13217','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.051842,-76.123159,0,'2013-07-06 12:44:30',NULL,NULL),(39375,'44643','S','Morges','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.667895,-81.306958,0,'2013-07-06 12:44:32',NULL,NULL),(15457,'16412','S','Crossingville','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.885747,-80.143902,0,'2013-07-06 12:44:31',NULL,NULL),(33097,'36849','U','Auburn Unvrsty','N','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.602139,-85.508496,0,'2013-07-06 12:44:32',NULL,NULL),(73210,'90609','P','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.981609,-118.030546,0,'2013-07-06 12:44:34',NULL,NULL),(76600,'95689','S','Volcano','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.472430,-120.602994,0,'2013-07-06 12:44:34',NULL,NULL),(3593,'02030','S','Dover','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.234095,-71.286110,0,'2013-07-06 12:44:30',NULL,NULL),(29692,'32934','S','Eau Gallie','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.142973,-80.696349,0,'2013-07-06 12:44:32',NULL,NULL),(31275,'34022','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(69582,'83837','S','Kellogg','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.585040,-116.134800,0,'2013-07-06 12:44:34',NULL,NULL),(75356,'93920','S','Pacific Valley','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.135880,-121.659477,0,'2013-07-06 12:44:34',NULL,NULL),(6980,'06243','S','East Killingly','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.848174,-71.806468,0,'2013-07-06 12:44:30',NULL,NULL),(60393,'71612','P','White Hall','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.228866,-92.000890,0,'2013-07-06 12:44:33',NULL,NULL),(48893,'56115','S','Balaton','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.234463,-95.871098,0,'2013-07-06 12:44:33',NULL,NULL),(39490,'44767','U','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.894428,-81.422107,0,'2013-07-06 12:44:32',NULL,NULL),(15208,'16001','S','Butler','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.858537,-79.902516,0,'2013-07-06 12:44:31',NULL,NULL),(31985,'35219','P','Homewood','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473661,-86.825878,0,'2013-07-06 12:44:32',NULL,NULL),(876,'00698','S','Vista Real','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(43948,'49301','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.955202,-85.471385,0,'2013-07-06 12:44:32',NULL,NULL),(60936,'72087','S','Owensville','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.566522,-92.816237,0,'2013-07-06 12:44:33',NULL,NULL),(2453,'00953','S','Urb Woodbridge Pk','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(39236,'44424','P','Hartford','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.317268,-80.569501,0,'2013-07-06 12:44:32',NULL,NULL),(35329,'39428','S','Kola','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(77818,'97201','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.498618,-122.692000,0,'2013-07-06 12:44:34',NULL,NULL),(65397,'77560','S','Hankamer','D','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.875851,-94.578420,0,'2013-07-06 12:44:34',NULL,NULL),(9988,'10165','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(39785,'45130','S','Yankeetown','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.910678,-83.984564,0,'2013-07-06 12:44:32',NULL,NULL),(8400,'08063','S','National Park','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862622,-75.176008,0,'2013-07-06 12:44:30',NULL,NULL),(31797,'35042','S','Centreville','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.953666,-87.138868,0,'2013-07-06 12:44:32',NULL,NULL),(35844,'39813','S','Arlington','D','Calhoun','13037','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.443443,-84.723823,0,'2013-07-06 12:44:32',NULL,NULL),(37338,'41667','S','Weeksbury','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.327206,-82.687520,0,'2013-07-06 12:44:32',NULL,NULL),(38580,'43793','S','Woodsfield','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.755116,-81.112949,0,'2013-07-06 12:44:32',NULL,NULL),(74841,'93243','S','Lebec','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.829880,-118.863480,0,'2013-07-06 12:44:34',NULL,NULL),(78487,'98104','S','International','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.604727,-122.325941,0,'2013-07-06 12:44:34',NULL,NULL),(5583,'04915','S','Swanville','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.418374,-69.007415,0,'2013-07-06 12:44:30',NULL,NULL),(19321,'20022','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906942,-76.991340,0,'2013-07-06 12:44:31',NULL,NULL),(63320,'75570','S','Malta','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.457080,-94.450920,0,'2013-07-06 12:44:33',NULL,NULL),(63048,'75217','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.720150,-96.676927,0,'2013-07-06 12:44:33',NULL,NULL),(46097,'52624','P','Denmark','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.742750,-91.340151,0,'2013-07-06 12:44:32',NULL,NULL),(45546,'51459','P','Ralston','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.078806,-94.567738,0,'2013-07-06 12:44:32',NULL,NULL),(37410,'41776','S','Wooton','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.201089,-83.298307,0,'2013-07-06 12:44:32',NULL,NULL),(73944,'92055','S','Camp Pendleton','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.291239,-117.301241,0,'2013-07-06 12:44:34',NULL,NULL),(1804,'00784','S','Bda Blondet','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(79926,'99611','S','Kenai','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.552102,-151.205064,0,'2013-07-06 12:44:34',NULL,NULL),(18374,'19046','S','Foxcroft Square','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(71180,'86043','P','Shipolovi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.805000,-110.491944,0,'2013-07-06 12:44:34',NULL,NULL),(4890,'04047','S','Kezar Falls','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.802761,-70.891033,0,'2013-07-06 12:44:30',NULL,NULL),(13909,'14303','S','N Falls','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.087115,-79.037731,0,'2013-07-06 12:44:31',NULL,NULL),(74877,'93272','S','Tipton','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.057937,-119.308812,0,'2013-07-06 12:44:34',NULL,NULL),(8666,'08320','P','Fairton','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.377963,-75.224715,0,'2013-07-06 12:44:30',NULL,NULL),(38731,'44024','S','Chardon','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.569436,-81.203372,0,'2013-07-06 12:44:32',NULL,NULL),(38055,'43050','S','Mount Vernon','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.382215,-82.483862,0,'2013-07-06 12:44:32',NULL,NULL),(26694,'29406','S','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.928960,-80.028420,0,'2013-07-06 12:44:31',NULL,NULL),(70296,'84534','P','Montezuma Crk','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.258327,-109.313639,0,'2013-07-06 12:44:34',NULL,NULL),(69004,'83203','P','Ft Hall','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.990305,-112.424758,0,'2013-07-06 12:44:34',NULL,NULL),(48897,'56119','S','Brewster','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.696031,-95.464780,0,'2013-07-06 12:44:33',NULL,NULL),(79468,'98855','S','Havillah','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.704499,-119.439348,0,'2013-07-06 12:44:34',NULL,NULL),(7731,'07203','S','Roselle','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.650599,-74.260873,0,'2013-07-06 12:44:30',NULL,NULL),(62507,'74370','S','Wyandotte','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.798358,-94.718688,0,'2013-07-06 12:44:33',NULL,NULL),(6228,'05491','S','Arnold Bay','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(18530,'19108','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.062989,-75.200974,0,'2013-07-06 12:44:31',NULL,NULL),(74287,'92363','S','Needles','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.833512,-114.602406,0,'2013-07-06 12:44:34',NULL,NULL),(78985,'98376','S','Mount Walker','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.813700,-122.850480,0,'2013-07-06 12:44:34',NULL,NULL),(12126,'12603','S','Poughkeepsie','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.697060,-73.862400,0,'2013-07-06 12:44:30',NULL,NULL),(31841,'35085','S','Jemison','D','Chilton','01021','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.990905,-86.678329,0,'2013-07-06 12:44:32',NULL,NULL),(56187,'65014','S','Cleavesville','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(65125,'77380','S','Spring','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.140487,-95.471451,0,'2013-07-06 12:44:34',NULL,NULL),(57281,'66604','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.041200,-95.728358,0,'2013-07-06 12:44:33',NULL,NULL),(46930,'54155','S','Oneida','D','Brown','55009','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.532148,-88.162973,0,'2013-07-06 12:44:32',NULL,NULL),(79357,'98641','P','Oysterville','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.547504,-124.053228,0,'2013-07-06 12:44:34',NULL,NULL),(28054,'30669','S','Penfield','N','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.644580,-83.085879,0,'2013-07-06 12:44:31',NULL,NULL),(59883,'71269','S','Rayville','D','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(5049,'04268','S','Norway','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.212637,-70.538351,0,'2013-07-06 12:44:30',NULL,NULL),(78377,'98023','S','Auburn','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.304480,-122.372580,0,'2013-07-06 12:44:34',NULL,NULL),(61102,'72137','S','Sidon','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.312759,-91.980405,0,'2013-07-06 12:44:33',NULL,NULL),(23983,'26321','S','Vadis','A','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.046920,-80.698020,0,'2013-07-06 12:44:31',NULL,NULL),(54933,'63110','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.618380,-90.259354,0,'2013-07-06 12:44:33',NULL,NULL),(42551,'47872','S','Guion','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(30014,'33131','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.766457,-80.191319,0,'2013-07-06 12:44:32',NULL,NULL),(53972,'62434','S','Ingraham','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.842024,-88.311120,0,'2013-07-06 12:44:33',NULL,NULL),(45197,'50620','S','Colwell','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.068536,-92.711538,0,'2013-07-06 12:44:32',NULL,NULL),(75222,'93639','P','Madera','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',36.964783,-120.084565,0,'2013-07-06 12:44:34',NULL,NULL),(74045,'92147','U','ASW Training Ctr','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.696705,-117.203572,0,'2013-07-06 12:44:34',NULL,NULL),(72947,'90038','S','Wilcox','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091104,-118.343030,0,'2013-07-06 12:44:34',NULL,NULL),(2580,'00961','S','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(3355,'01564','S','Sterling','D','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.441660,-71.774580,0,'2013-07-06 12:44:30',NULL,NULL),(31141,'33908','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.506918,-81.928540,0,'2013-07-06 12:44:32',NULL,NULL),(42191,'47546','S','Hall','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.395440,-86.932333,0,'2013-07-06 12:44:32',NULL,NULL),(29651,'32904','S','W Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074548,-80.694237,0,'2013-07-06 12:44:32',NULL,NULL),(7376,'06777','S','New Preston','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(39950,'45232','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.176213,-84.513602,0,'2013-07-06 12:44:32',NULL,NULL),(43157,'48264','U','Comerica Incorporated','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.329958,-83.045066,0,'2013-07-06 12:44:32',NULL,NULL),(44062,'49442','S','Meskegon','N','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.233938,-86.169837,0,'2013-07-06 12:44:32',NULL,NULL),(79190,'98531','S','Waunch Prairie','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.723564,-122.958491,0,'2013-07-06 12:44:34',NULL,NULL),(4326,'02918','U','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821945,-71.419150,0,'2013-07-06 12:44:30',NULL,NULL),(11312,'11780','S','Head of the Harbor','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(77896,'97293','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.511217,-122.641339,0,'2013-07-06 12:44:34',NULL,NULL),(65588,'77871','S','Hilltop Lakes','A','Leon','48289','Texas','TX','48','0000','936','Central',-6.0,'Y',31.088820,-96.153300,0,'2013-07-06 12:44:34',NULL,NULL),(53006,'61453','S','Little York','D','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.009373,-90.745049,0,'2013-07-06 12:44:33',NULL,NULL),(49637,'56944','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(44759,'50201','S','Shipley','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.018291,-93.450971,0,'2013-07-06 12:44:32',NULL,NULL),(8669,'08323','S','Greenwich','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.390568,-75.341496,0,'2013-07-06 12:44:30',NULL,NULL),(15315,'16157','S','Wampum','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.895009,-80.344547,0,'2013-07-06 12:44:31',NULL,NULL),(22888,'24579','S','Natural Bridge Station','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.588035,-79.502939,0,'2013-07-06 12:44:31',NULL,NULL),(56219,'65038','P','Gravois Mills','A','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.199727,-92.833349,0,'2013-07-06 12:44:33',NULL,NULL),(7549,'07013','S','Clifton','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.868681,-74.169979,0,'2013-07-06 12:44:30',NULL,NULL),(13524,'13815','S','Norwich','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.530787,-75.524876,0,'2013-07-06 12:44:31',NULL,NULL),(17600,'18040','S','Forks Township','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.719000,-75.220260,0,'2013-07-06 12:44:31',NULL,NULL),(31476,'34295','P','Inglewood','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',26.930149,-82.283757,0,'2013-07-06 12:44:32',NULL,NULL),(36603,'40977','S','Chenoa','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(74585,'92694','S','Mission Viejo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.555120,-117.666532,0,'2013-07-06 12:44:34',NULL,NULL),(5449,'04730','S','Hammond','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(32827,'36467','S','Horn Hill','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.285500,-86.264760,0,'2013-07-06 12:44:32',NULL,NULL),(5299,'04549','S','Boothbay','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.897252,-69.629746,0,'2013-07-06 12:44:30',NULL,NULL),(54219,'62650','S','Jacksonville','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(46487,'53223','S','Brown Deer','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.158245,-87.989707,0,'2013-07-06 12:44:32',NULL,NULL),(78417,'98043','S','Mountlake Terrace','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791785,-122.304134,0,'2013-07-06 12:44:34',NULL,NULL),(71979,'88022','S','Silver City','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.788740,-108.194340,0,'2013-07-06 12:44:34',NULL,NULL),(23292,'25174','S','Rock Creek','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.838718,-81.487447,0,'2013-07-06 12:44:31',NULL,NULL),(50639,'58301','S','Devils Lake','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.112685,-98.856665,0,'2013-07-06 12:44:33',NULL,NULL),(40956,'46307','S','Winfield','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.419705,-87.354291,0,'2013-07-06 12:44:32',NULL,NULL),(77129,'96155','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',39.018968,-120.123053,0,'2013-07-06 12:44:34',NULL,NULL),(78410,'98039','S','Medina','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617654,-122.233674,0,'2013-07-06 12:44:34',NULL,NULL),(9891,'10128','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(60403,'71638','S','Bellaire','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(74736,'93042','U','Naval Base Ventura County','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.122182,-119.092865,0,'2013-07-06 12:44:34',NULL,NULL),(15821,'16933','S','Bungy','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(72282,'88562','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769831,-106.331231,0,'2013-07-06 12:44:34',NULL,NULL),(6639,'06010','S','Bristol','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.679705,-72.931387,0,'2013-07-06 12:44:30',NULL,NULL),(57100,'66219','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.965992,-94.764646,0,'2013-07-06 12:44:33',NULL,NULL),(3230,'01373','S','S Deerfield','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.486240,-72.610200,0,'2013-07-06 12:44:30',NULL,NULL),(54556,'62890','S','Thompsonville','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.916668,-88.763454,0,'2013-07-06 12:44:33',NULL,NULL),(7960,'07677','S','Westwood','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.024537,-74.060304,0,'2013-07-06 12:44:30',NULL,NULL),(35044,'39174','P','Tougaloo','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.397137,-90.153459,0,'2013-07-06 12:44:32',NULL,NULL),(77035,'96103','S','Johnsville','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(44867,'50306','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.605028,-93.631799,0,'2013-07-06 12:44:32',NULL,NULL),(40384,'45659','S','Pedro','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.656080,-82.639620,0,'2013-07-06 12:44:32',NULL,NULL),(34200,'38340','S','Henderson','D','Chester','47023','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.424648,-88.653725,0,'2013-07-06 12:44:32',NULL,NULL),(32010,'35232','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.535892,-86.758358,0,'2013-07-06 12:44:32',NULL,NULL),(70118,'84189','U','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.764906,-111.886965,0,'2013-07-06 12:44:34',NULL,NULL),(56716,'65681','S','Lampe','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.582305,-93.444246,0,'2013-07-06 12:44:33',NULL,NULL),(51514,'59701','S','Butte','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.946740,-112.517340,0,'2013-07-06 12:44:33',NULL,NULL),(46180,'52738','S','Columbus Jct','A','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(25639,'28467','S','Calabash','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.898397,-78.578267,0,'2013-07-06 12:44:31',NULL,NULL),(25713,'28542','P','Jacksonville','A','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.697778,-77.352038,0,'2013-07-06 12:44:31',NULL,NULL),(37838,'42456','S','Slaughters','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.506005,-87.444474,0,'2013-07-06 12:44:32',NULL,NULL),(27019,'29646','S','Greenwood','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.184847,-82.152009,0,'2013-07-06 12:44:31',NULL,NULL),(7768,'07410','S','Radburn','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.934411,-74.117638,0,'2013-07-06 12:44:30',NULL,NULL),(15589,'16665','P','Newry','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.394638,-78.438216,0,'2013-07-06 12:44:31',NULL,NULL),(7734,'07205','S','Ind Hillside','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.693929,-74.228806,0,'2013-07-06 12:44:30',NULL,NULL),(56965,'66113','P','Kansas City','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.061080,-94.819380,0,'2013-07-06 12:44:33',NULL,NULL),(29468,'32719','P','Winter Spgs','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.683684,-81.276404,0,'2013-07-06 12:44:32',NULL,NULL),(68524,'81401','S','Colona','N','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.412000,-107.862900,0,'2013-07-06 12:44:34',NULL,NULL),(21323,'22407','S','Frederickbur','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(34548,'38721','S','Straight Bayou','N','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.974616,-90.831462,0,'2013-07-06 12:44:32',NULL,NULL),(38967,'44128','S','Highland Hls','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(35025,'39158','P','Ridgeland','D','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.418992,-90.132277,0,'2013-07-06 12:44:32',NULL,NULL),(76049,'95190','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.376143,-121.902320,0,'2013-07-06 12:44:34',NULL,NULL),(76807,'95948','S','Gridley','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.358225,-121.696103,0,'2013-07-06 12:44:34',NULL,NULL),(60535,'71675','S','Rock Springs','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.621420,-91.927800,0,'2013-07-06 12:44:33',NULL,NULL),(67090,'79699','U','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.470981,-99.707622,0,'2013-07-06 12:44:34',NULL,NULL),(47787,'55044','S','Lakeville','D','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.652317,-93.247168,0,'2013-07-06 12:44:33',NULL,NULL),(9348,'09803','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(70286,'84533','S','Bullfrog','A','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(19722,'20393','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.943574,-77.082429,0,'2013-07-06 12:44:31',NULL,NULL),(1607,'00769','S','Urb Paraiso De Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(29796,'33021','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.026253,-80.189124,0,'2013-07-06 12:44:32',NULL,NULL),(23257,'25125','S','Bentree','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.337121,-81.164391,0,'2013-07-06 12:44:31',NULL,NULL),(70458,'84753','S','Uvada','N','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.798279,-113.906685,0,'2013-07-06 12:44:34',NULL,NULL),(56451,'65281','S','Forest Green','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.420951,-92.803243,0,'2013-07-06 12:44:33',NULL,NULL),(3846,'02345','P','Manomet','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.903376,-70.552785,0,'2013-07-06 12:44:30',NULL,NULL),(38271,'43317','P','Chesterville','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.479777,-82.684801,0,'2013-07-06 12:44:32',NULL,NULL),(15490,'16444','U','Edinboro','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.875950,-80.130328,0,'2013-07-06 12:44:31',NULL,NULL),(9909,'10133','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.776988,-73.983519,0,'2013-07-06 12:44:30',NULL,NULL),(30618,'33435','S','Briny Breezes','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524047,-80.068212,0,'2013-07-06 12:44:32',NULL,NULL),(80061,'99716','P','Two Rivers','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.875857,-146.876181,0,'2013-07-06 12:44:34',NULL,NULL),(32800,'36432','S','Castleberry','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.303173,-87.025313,0,'2013-07-06 12:44:32',NULL,NULL),(71167,'86039','P','Old Oraibi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(23605,'25702','S','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.427845,-82.370681,0,'2013-07-06 12:44:31',NULL,NULL),(56416,'65255','S','Hallsville','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.104694,-92.223060,0,'2013-07-06 12:44:33',NULL,NULL),(32751,'36343','S','Grangeburg','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.152278,-85.075175,0,'2013-07-06 12:44:32',NULL,NULL),(51883,'60089','S','Buffalo Grove','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.174011,-87.964322,0,'2013-07-06 12:44:33',NULL,NULL),(72451,'89110','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.173684,-115.059521,0,'2013-07-06 12:44:34',NULL,NULL),(6008,'05359','S','W Townshend','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.163746,-72.719255,0,'2013-07-06 12:44:30',NULL,NULL),(20619,'21212','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.367800,-76.618560,0,'2013-07-06 12:44:31',NULL,NULL),(61121,'72152','S','Pastoria','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.356360,-91.987080,0,'2013-07-06 12:44:33',NULL,NULL),(47289,'54543','P','Mc Naughton','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.767082,-89.514971,0,'2013-07-06 12:44:32',NULL,NULL),(24695,'27425','P','Amf Greensboro','A','Guilford','37081','North Carolina','NC','37','3120','704/980','Eastern',-5.0,'Y',36.127293,-79.942762,0,'2013-07-06 12:44:31',NULL,NULL),(29110,'32307','U','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.431483,-84.288359,0,'2013-07-06 12:44:32',NULL,NULL),(34378,'38614','S','Stovall','A','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(38641,'43933','S','Armstrong Mls','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.945410,-80.902208,0,'2013-07-06 12:44:32',NULL,NULL),(47113,'54449','S','Lindsey','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.612100,-90.187920,0,'2013-07-06 12:44:32',NULL,NULL),(78723,'98278','U','Naval Air Station','N','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.281520,-122.625637,0,'2013-07-06 12:44:34',NULL,NULL),(63979,'76107','S','Westover Hills','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.743320,-97.380480,0,'2013-07-06 12:44:34',NULL,NULL),(23514,'25550','S','Point Pleasant','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.860965,-82.131564,0,'2013-07-06 12:44:31',NULL,NULL),(23154,'25005','S','Amma','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.561614,-81.264914,0,'2013-07-06 12:44:31',NULL,NULL),(61137,'72160','S','Lodge Corner','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(27399,'30087','S','Stone Mtn','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.801564,-84.138154,0,'2013-07-06 12:44:31',NULL,NULL),(45218,'50636','S','Powersville','N','Butler','19023','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.897631,-92.805586,0,'2013-07-06 12:44:32',NULL,NULL),(69096,'83254','S','Liberty','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(48247,'55424','S','Edina','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.902538,-93.339411,0,'2013-07-06 12:44:33',NULL,NULL),(43076,'48198','S','Superior Township','A','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.248536,-83.586753,0,'2013-07-06 12:44:32',NULL,NULL),(45059,'50511','S','Algona','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.072355,-94.229492,0,'2013-07-06 12:44:32',NULL,NULL),(9948,'10156','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(39554,'44844','S','Mc Cutchenvle','A','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.981166,-83.270538,0,'2013-07-06 12:44:32',NULL,NULL),(61241,'72340','P','Goodwin','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.970296,-90.992775,0,'2013-07-06 12:44:33',NULL,NULL),(53157,'61563','P','Saint David','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.494712,-90.046750,0,'2013-07-06 12:44:33',NULL,NULL),(2615,'00962','S','Bo Palmas','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(49575,'56728','S','Hallock','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.774233,-96.944459,0,'2013-07-06 12:44:33',NULL,NULL),(30815,'33617','S','Temple Terrace','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.036676,-82.396230,0,'2013-07-06 12:44:32',NULL,NULL),(74661,'92846','P','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.788031,-118.032536,0,'2013-07-06 12:44:34',NULL,NULL),(71029,'85737','S','Oro Valley','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.425216,-110.957657,0,'2013-07-06 12:44:34',NULL,NULL),(295,'00646','S','Urb Dorado del Mar','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(67913,'80905','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.836829,-104.837659,0,'2013-07-06 12:44:34',NULL,NULL),(63066,'75234','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.915750,-96.896140,0,'2013-07-06 12:44:33',NULL,NULL),(26184,'28758','P','Mountain Home','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378626,-82.477763,0,'2013-07-06 12:44:31',NULL,NULL),(21622,'22907','U','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.952452,-78.492913,0,'2013-07-06 12:44:31',NULL,NULL),(20233,'20775','P','Uppr Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.782687,-76.767816,0,'2013-07-06 12:44:31',NULL,NULL),(43524,'48653','S','Roscommon','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.466131,-84.678344,0,'2013-07-06 12:44:32',NULL,NULL),(36871,'41094','S','Beaverlick','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.884714,-84.634472,0,'2013-07-06 12:44:32',NULL,NULL),(77964,'97369','S','Otter Rock','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.747559,-124.060606,0,'2013-07-06 12:44:34',NULL,NULL),(78901,'98362','S','Agnew','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(12563,'13054','S','Higginsville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.141800,-75.670020,0,'2013-07-06 12:44:30',NULL,NULL),(21599,'22848','P','Pleasant Valley','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.384318,-78.900024,0,'2013-07-06 12:44:31',NULL,NULL),(75876,'94952','S','Fallon','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.244916,-122.659988,0,'2013-07-06 12:44:34',NULL,NULL),(60657,'71914','P','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.529159,-93.051519,0,'2013-07-06 12:44:33',NULL,NULL),(61893,'73137','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.481011,-97.633607,0,'2013-07-06 12:44:33',NULL,NULL),(24235,'26753','S','Patterson Creek','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.600960,-78.784140,0,'2013-07-06 12:44:31',NULL,NULL),(41533,'46994','S','Walton','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.660177,-86.242730,0,'2013-07-06 12:44:32',NULL,NULL),(3931,'02464','S','Newton Upper Falls','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.311972,-71.220047,0,'2013-07-06 12:44:30',NULL,NULL),(79483,'98901','S','Union Gap','A','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606829,-120.465379,0,'2013-07-06 12:44:34',NULL,NULL),(58087,'68073','S','Yutan','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.241200,-96.400277,0,'2013-07-06 12:44:33',NULL,NULL),(45880,'52254','S','Elwood','A','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.966532,-90.817621,0,'2013-07-06 12:44:32',NULL,NULL),(2422,'00953','S','Praderas Del Rio','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(18277,'19013','S','Chester','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(15946,'17023','S','Eville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.555025,-76.826794,0,'2013-07-06 12:44:31',NULL,NULL),(48345,'55478','U','Macys','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.983515,-93.264921,0,'2013-07-06 12:44:33',NULL,NULL),(44261,'49685','S','Traverse City','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.674614,-85.654239,0,'2013-07-06 12:44:32',NULL,NULL),(41842,'47348','S','Mill Grove','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(78564,'98158','S','Seatac','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445664,-122.311881,0,'2013-07-06 12:44:34',NULL,NULL),(490,'00670','S','Urb Lavergne','N','Las Marias','72083','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.296381,-67.146608,0,'2013-07-06 12:44:30',NULL,NULL),(18449,'19072','S','Penn Valley','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.018469,-75.264095,0,'2013-07-06 12:44:31',NULL,NULL),(52345,'60601','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.885144,-87.625994,0,'2013-07-06 12:44:33',NULL,NULL),(11249,'11762','S','Bar Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.683043,-73.446969,0,'2013-07-06 12:44:30',NULL,NULL),(14362,'15021','S','Paris','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.412700,-80.431260,0,'2013-07-06 12:44:31',NULL,NULL),(32279,'35652','S','Rogersville','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.828765,-87.292792,0,'2013-07-06 12:44:32',NULL,NULL),(76677,'95799','P','W Sacramento','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.540783,-121.557001,0,'2013-07-06 12:44:34',NULL,NULL),(23527,'25571','S','West Hamlin','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.281486,-82.167017,0,'2013-07-06 12:44:31',NULL,NULL),(8910,'08736','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.122204,-74.063541,0,'2013-07-06 12:44:30',NULL,NULL),(22635,'24248','S','Ewing','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.625839,-83.515719,0,'2013-07-06 12:44:31',NULL,NULL),(47318,'54558','S','Saint Germain','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.926415,-89.481221,0,'2013-07-06 12:44:32',NULL,NULL),(42854,'48079','S','St Clair','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.853850,-82.547092,0,'2013-07-06 12:44:32',NULL,NULL),(8338,'08038','P','Hancocks Brg','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.503201,-75.461092,0,'2013-07-06 12:44:30',NULL,NULL),(37589,'42101','S','Plum Springs','A','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.018172,-86.458733,0,'2013-07-06 12:44:32',NULL,NULL),(69811,'84071','S','South Rim','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.449676,-112.359074,0,'2013-07-06 12:44:34',NULL,NULL),(5467,'04738','P','Crouseville','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.758541,-68.095829,0,'2013-07-06 12:44:30',NULL,NULL),(72326,'89007','P','Bunkerville','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.771438,-114.126860,0,'2013-07-06 12:44:34',NULL,NULL),(21057,'21913','P','Cecilton','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.416732,-75.864757,0,'2013-07-06 12:44:31',NULL,NULL),(8421,'08075','S','Delran Township','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(45292,'50707','S','Elk Run Hgts','A','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.482880,-92.277060,0,'2013-07-06 12:44:32',NULL,NULL),(15361,'16253','S','Seminole','D','Armstrong','42005','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.955566,-79.341934,0,'2013-07-06 12:44:31',NULL,NULL),(4047,'02634','P','Centerville','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.657773,-70.353600,0,'2013-07-06 12:44:30',NULL,NULL),(67842,'80816','S','Florissant','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.891057,-105.264451,0,'2013-07-06 12:44:34',NULL,NULL),(11115,'11702','S','W Gilgo Beach','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(48354,'55485','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.936905,-93.221555,0,'2013-07-06 12:44:33',NULL,NULL),(39171,'44310','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.106498,-81.497681,0,'2013-07-06 12:44:32',NULL,NULL),(39721,'45056','S','Darrtown','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(61267,'72372','S','Palestine','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.952070,-90.904029,0,'2013-07-06 12:44:33',NULL,NULL),(57646,'67201','P','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.688210,-97.343000,0,'2013-07-06 12:44:33',NULL,NULL),(71911,'87820','S','Aragon','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.949373,-108.678540,0,'2013-07-06 12:44:34',NULL,NULL),(66990,'79491','U','United Marketing of Texas','N','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.504419,-101.877558,0,'2013-07-06 12:44:34',NULL,NULL),(20644,'21222','S','Dundalk','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.263020,-76.499604,0,'2013-07-06 12:44:31',NULL,NULL),(76587,'95683','S','Rancho Murieta','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.496180,-121.127280,0,'2013-07-06 12:44:34',NULL,NULL),(37047,'41271','S','Williamsport','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.815261,-82.713247,0,'2013-07-06 12:44:32',NULL,NULL),(34688,'38828','S','Branyan','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(11839,'12246','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.689007,-73.821157,0,'2013-07-06 12:44:30',NULL,NULL),(10222,'10460','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.837082,-73.880734,0,'2013-07-06 12:44:30',NULL,NULL),(17959,'18540','U','Brm Zip','N','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.372284,-75.657800,0,'2013-07-06 12:44:31',NULL,NULL),(28743,'31995','P','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.489923,-84.969539,0,'2013-07-06 12:44:32',NULL,NULL),(41128,'46616','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.689863,-86.264884,0,'2013-07-06 12:44:32',NULL,NULL),(4821,'03906','S','No Berwick','N','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.305842,-70.742523,0,'2013-07-06 12:44:30',NULL,NULL),(11533,'12043','S','Janesville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(12752,'13205','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.006472,-76.148241,0,'2013-07-06 12:44:30',NULL,NULL),(27639,'30317','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.749993,-84.314022,0,'2013-07-06 12:44:31',NULL,NULL),(24543,'27292','S','Hedrick Grove','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(69545,'83805','S','Bonners Ferry','D','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.698029,-116.318139,0,'2013-07-06 12:44:34',NULL,NULL),(3647,'02116','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.347026,-71.074793,0,'2013-07-06 12:44:30',NULL,NULL),(79477,'98859','S','Bodie','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.716453,-118.950457,0,'2013-07-06 12:44:34',NULL,NULL),(78880,'98356','S','Morton','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.560848,-122.287340,0,'2013-07-06 12:44:34',NULL,NULL),(46662,'53711','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.030573,-89.444075,0,'2013-07-06 12:44:32',NULL,NULL),(53630,'62095','S','Wood River','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.861219,-90.089817,0,'2013-07-06 12:44:33',NULL,NULL),(39247,'44436','S','Lowellville','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.051961,-80.544699,0,'2013-07-06 12:44:32',NULL,NULL),(46113,'52637','S','Kingston','N','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.007600,-91.097940,0,'2013-07-06 12:44:32',NULL,NULL),(2906,'00987','S','Valle Escondido','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(14673,'15241','S','South Hills Village','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.357620,-80.059980,0,'2013-07-06 12:44:31',NULL,NULL),(36878,'41098','S','Worthville','D','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.635167,-85.059062,0,'2013-07-06 12:44:32',NULL,NULL),(17132,'17777','S','Watsonville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.092752,-76.861603,0,'2013-07-06 12:44:31',NULL,NULL),(11637,'12122','S','Huntersland','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540360,-74.270820,0,'2013-07-06 12:44:30',NULL,NULL),(33255,'37082','S','Kingston Springs','D','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.085361,-87.121788,0,'2013-07-06 12:44:32',NULL,NULL),(1872,'00791','S','Urb Las Leandras','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(11852,'12255','U','NY Hghr Educ Serv Corp','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.654469,-73.759719,0,'2013-07-06 12:44:30',NULL,NULL),(53004,'61452','S','Littleton','D','Schuyler','17169','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.240692,-90.619987,0,'2013-07-06 12:44:33',NULL,NULL),(49128,'56362','S','Lake Henry','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.407807,-94.699248,0,'2013-07-06 12:44:33',NULL,NULL),(34876,'38941','S','Murdock Crossing','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(34525,'38680','S','Walls','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.961644,-90.119278,0,'2013-07-06 12:44:32',NULL,NULL),(4797,'03882','S','S Effingham','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715503,-71.004712,0,'2013-07-06 12:44:30',NULL,NULL),(25848,'28624','S','Champion','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.156660,-81.393840,0,'2013-07-06 12:44:31',NULL,NULL),(4373,'03077','S','Raymond','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',43.034813,-71.192767,0,'2013-07-06 12:44:30',NULL,NULL),(40904,'46256','S','Castleton','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.901691,-86.015662,0,'2013-07-06 12:44:32',NULL,NULL),(34486,'38666','S','Sardis','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.437126,-89.917698,0,'2013-07-06 12:44:32',NULL,NULL),(69819,'84074','S','Stansbury Park','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(75501,'94137','U','Bank of America','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.793155,-122.404322,0,'2013-07-06 12:44:34',NULL,NULL),(16033,'17043','S','Wormleysbg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.254300,-76.898040,0,'2013-07-06 12:44:31',NULL,NULL),(63859,'75979','S','Pedigo','N','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.754889,-94.393444,0,'2013-07-06 12:44:34',NULL,NULL),(47777,'55043','S','Lakeland','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(23327,'25235','S','Chloe','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.677705,-81.093441,0,'2013-07-06 12:44:31',NULL,NULL),(56086,'64767','S','Milo','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.736932,-94.297334,0,'2013-07-06 12:44:33',NULL,NULL),(1326,'00735','S','Villa del Pilar','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(14523,'15204','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.452082,-80.056352,0,'2013-07-06 12:44:31',NULL,NULL),(77588,'96919','S','Agana Heights','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.464168,144.744466,0,'2013-07-06 12:44:34',NULL,NULL),(72111,'88244','U','Hobbs','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.630065,-103.334409,0,'2013-07-06 12:44:34',NULL,NULL),(72160,'88338','S','Lincoln','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.488918,-105.533019,0,'2013-07-06 12:44:34',NULL,NULL),(24824,'27607','S','Ncsu Student Housing','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.804021,-78.697656,0,'2013-07-06 12:44:31',NULL,NULL),(54973,'63122','S','Oakland','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.584479,-90.414020,0,'2013-07-06 12:44:33',NULL,NULL),(50995,'58653','S','Gascoyne','A','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.112711,-103.120110,0,'2013-07-06 12:44:33',NULL,NULL),(69804,'84070','S','Belmont Heights','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.571551,-111.884711,0,'2013-07-06 12:44:34',NULL,NULL),(67587,'80402','P','Golden','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.756447,-105.216934,0,'2013-07-06 12:44:34',NULL,NULL),(58587,'68840','S','Gibbon','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.745127,-98.841582,0,'2013-07-06 12:44:33',NULL,NULL),(11539,'12046','S','Coeymans Holw','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.498420,-73.912260,0,'2013-07-06 12:44:30',NULL,NULL),(71592,'87317','S','Gamerco','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.570550,-108.763745,0,'2013-07-06 12:44:34',NULL,NULL),(23928,'26238','S','Volga','D','Barbour','54001','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.067667,-80.122357,0,'2013-07-06 12:44:31',NULL,NULL),(69000,'83202','S','Chubbuck','A','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.937260,-112.488540,0,'2013-07-06 12:44:34',NULL,NULL),(23299,'25183','P','Sharples','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.918049,-81.827781,0,'2013-07-06 12:44:31',NULL,NULL),(22176,'23467','P','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.801711,-76.174222,0,'2013-07-06 12:44:31',NULL,NULL),(54275,'62685','S','Shipman','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.116628,-90.005444,0,'2013-07-06 12:44:33',NULL,NULL),(45130,'50570','S','Ottosen','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.895295,-94.379185,0,'2013-07-06 12:44:32',NULL,NULL),(37527,'42048','S','Hardin','D','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.781080,-88.252740,0,'2013-07-06 12:44:32',NULL,NULL),(2603,'00961','S','Urb Rio Plantation','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(18960,'19512','S','Griesemersville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(18622,'19150','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.070910,-75.171390,0,'2013-07-06 12:44:31',NULL,NULL),(25602,'28453','S','Magnolia','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.895031,-78.043144,0,'2013-07-06 12:44:31',NULL,NULL),(25434,'28307','S','Fort Bragg','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.140740,-78.998040,0,'2013-07-06 12:44:31',NULL,NULL),(963,'00716','S','Urb Alta Vista','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(22614,'24218','P','Ben Hur','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.753377,-83.036139,0,'2013-07-06 12:44:31',NULL,NULL),(14308,'14886','S','Trumansburg','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.521119,-76.643605,0,'2013-07-06 12:44:31',NULL,NULL),(20581,'21156','S','Upper Falls','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.436501,-76.399072,0,'2013-07-06 12:44:31',NULL,NULL),(72334,'89012','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.009449,-115.049220,0,'2013-07-06 12:44:34',NULL,NULL),(682,'00683','S','Villa Interamericana','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(68567,'81501','S','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.080461,-108.541256,0,'2013-07-06 12:44:34',NULL,NULL),(54295,'62706','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.799900,-89.654773,0,'2013-07-06 12:44:33',NULL,NULL),(77536,'96850','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308944,-157.861150,0,'2013-07-06 12:44:34',NULL,NULL),(14284,'14863','P','Mecklenburg','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.455504,-76.711047,0,'2013-07-06 12:44:31',NULL,NULL),(20761,'21502','S','Cresaptown','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.596959,-78.834511,0,'2013-07-06 12:44:31',NULL,NULL),(66529,'78719','S','Moores Crossing','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.127369,-97.672339,0,'2013-07-06 12:44:34',NULL,NULL),(58132,'68138','S','Omaha','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.169533,-96.127845,0,'2013-07-06 12:44:33',NULL,NULL),(48889,'56110','S','Adrian','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.632558,-95.938582,0,'2013-07-06 12:44:33',NULL,NULL),(40474,'45769','S','Hemlock Grove','N','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.088080,-82.031760,0,'2013-07-06 12:44:32',NULL,NULL),(6884,'06142','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.775997,-72.697466,0,'2013-07-06 12:44:30',NULL,NULL),(75101,'93541','P','Mono Lake','N','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.002080,-119.069580,0,'2013-07-06 12:44:34',NULL,NULL),(35824,'39762','P','State College','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(71210,'86312','P','Prescott Vly','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.616549,-112.325635,0,'2013-07-06 12:44:34',NULL,NULL),(69395,'83615','S','Roseberry','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.710118,-116.095636,0,'2013-07-06 12:44:34',NULL,NULL),(30728,'33526','P','Dade City','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.406950,-82.190328,0,'2013-07-06 12:44:32',NULL,NULL),(46014,'52540','S','East Pleasant Plain','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.173994,-91.823207,0,'2013-07-06 12:44:32',NULL,NULL),(27409,'30094','S','Conyers','D','Rockdale','13247','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.601564,-84.060376,0,'2013-07-06 12:44:31',NULL,NULL),(14385,'15038','P','Elrama','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.255228,-79.922068,0,'2013-07-06 12:44:31',NULL,NULL),(74388,'92513','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.913065,-117.459088,0,'2013-07-06 12:44:34',NULL,NULL),(35249,'39341','S','Macon','D','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.113434,-88.556999,0,'2013-07-06 12:44:32',NULL,NULL),(19809,'20444','U','Tennessee Valley Auth','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896916,-77.008805,0,'2013-07-06 12:44:31',NULL,NULL),(58949,'69360','S','Rushville','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.719148,-102.456609,0,'2013-07-06 12:44:33',NULL,NULL),(23793,'26003','S','Warwood','A','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(45973,'52404','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.947254,-91.690122,0,'2013-07-06 12:44:32',NULL,NULL),(40231,'45419','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.714561,-84.165115,0,'2013-07-06 12:44:32',NULL,NULL),(40607,'45893','P','Vaughnsville','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.884509,-84.147928,0,'2013-07-06 12:44:32',NULL,NULL),(76638,'95715','P','Emigrant Gap','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.270480,-120.616200,0,'2013-07-06 12:44:34',NULL,NULL),(22951,'24651','S','Gratton','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.114440,-81.522480,0,'2013-07-06 12:44:31',NULL,NULL),(35386,'39455','S','Villa Ridge','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(48892,'56114','S','Avoca','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.946521,-95.646379,0,'2013-07-06 12:44:33',NULL,NULL),(24789,'27581','S','Stem','D','Granville','37077','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',36.200116,-78.724476,0,'2013-07-06 12:44:31',NULL,NULL),(35499,'39529','U','Stennis Ctr','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(1626,'00771','S','Mans de las Piedras','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(15318,'16160','P','W Pittsburg','A','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.933740,-80.363091,0,'2013-07-06 12:44:31',NULL,NULL),(64144,'76198','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755079,-97.332446,0,'2013-07-06 12:44:34',NULL,NULL),(3048,'01106','S','Spfld (Long)','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.052405,-72.567774,0,'2013-07-06 12:44:30',NULL,NULL),(65182,'77418','S','Burleigh','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(26516,'29180','S','White Oak','A','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.372149,-81.086971,0,'2013-07-06 12:44:31',NULL,NULL),(62561,'74447','S','Twin Hills','N','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.623341,-95.970246,0,'2013-07-06 12:44:33',NULL,NULL),(41552,'47018','S','Dillsboro','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',38.967420,-85.051860,0,'2013-07-06 12:44:32',NULL,NULL),(15705,'16855','P','Mineral Spgs','A','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.001571,-78.363433,0,'2013-07-06 12:44:31',NULL,NULL),(15324,'16201','S','Kittanning','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.818568,-79.524790,0,'2013-07-06 12:44:31',NULL,NULL),(75273,'93706','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.702391,-119.837956,0,'2013-07-06 12:44:34',NULL,NULL),(76433,'95601','P','Amador City','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.423289,-120.826231,0,'2013-07-06 12:44:34',NULL,NULL),(53038,'61477','S','Smithfield','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.495882,-90.287939,0,'2013-07-06 12:44:33',NULL,NULL),(22995,'24801','S','Hemphill','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(549,'00677','S','Ext Jard de Rincon','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(34588,'38740','S','Rochdale','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.777156,-90.722884,0,'2013-07-06 12:44:32',NULL,NULL),(29392,'32616','P','Alachua','D','Alachua','12001','Florida','FL','12','2900','386','Eastern',-5.0,'Y',29.780604,-82.480289,0,'2013-07-06 12:44:32',NULL,NULL),(61109,'72142','S','Toltec','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.776533,-92.063990,0,'2013-07-06 12:44:33',NULL,NULL),(37158,'41465','S','Wonnie','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(36573,'40940','S','Laurel Fork','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.629745,-83.888424,0,'2013-07-06 12:44:32',NULL,NULL),(77730,'97068','S','Wankers Corners','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.366874,-122.650360,0,'2013-07-06 12:44:34',NULL,NULL),(349,'00656','S','Urb Santa Elena','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(75877,'94952','S','Lakeville','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.244916,-122.659988,0,'2013-07-06 12:44:34',NULL,NULL),(52628,'61044','S','Kent','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.322141,-89.902021,0,'2013-07-06 12:44:33',NULL,NULL),(59719,'71107','S','Sentell','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.608620,-93.862080,0,'2013-07-06 12:44:33',NULL,NULL),(24852,'27627','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772008,-78.713778,0,'2013-07-06 12:44:31',NULL,NULL),(54292,'62704','S','Leland Grove','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.772500,-89.683680,0,'2013-07-06 12:44:33',NULL,NULL),(27324,'30031','P','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.767202,-84.285482,0,'2013-07-06 12:44:31',NULL,NULL),(69454,'83647','S','Tipanuk','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(49644,'56965','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(79370,'98661','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.644628,-122.623251,0,'2013-07-06 12:44:34',NULL,NULL),(1237,'00729','S','Ext Villas de Loiza','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(24988,'27858','S','Greenville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.589407,-77.351275,0,'2013-07-06 12:44:31',NULL,NULL),(3465,'01810','S','Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.648787,-71.162026,0,'2013-07-06 12:44:30',NULL,NULL),(71147,'86031','P','Holbrook','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.404662,-110.085614,0,'2013-07-06 12:44:34',NULL,NULL),(69601,'83853','S','Porthill','D','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.976571,-116.478266,0,'2013-07-06 12:44:34',NULL,NULL),(45431,'51101','S','Sioux City','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.494368,-96.395068,0,'2013-07-06 12:44:32',NULL,NULL),(8074,'07753','S','Shark River Hills','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(75335,'93793','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.787165,-119.830210,0,'2013-07-06 12:44:34',NULL,NULL),(24532,'27291','S','Leasburg','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.416444,-79.191618,0,'2013-07-06 12:44:31',NULL,NULL),(74550,'92675','S','San Juan Capo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.508513,-117.656472,0,'2013-07-06 12:44:34',NULL,NULL),(36518,'40830','S','Gulston','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.757527,-83.334349,0,'2013-07-06 12:44:32',NULL,NULL),(39980,'45239','S','N College Hl','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(30108,'33160','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(17530,'17972','S','Landingville','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.632720,-76.155120,0,'2013-07-06 12:44:31',NULL,NULL),(56127,'64834','S','Smithfield','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.170235,-94.542468,0,'2013-07-06 12:44:33',NULL,NULL),(48636,'55810','S','Proctor','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.764120,-92.254200,0,'2013-07-06 12:44:33',NULL,NULL),(28346,'31195','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.806070,-84.477521,0,'2013-07-06 12:44:32',NULL,NULL),(65101,'77365','S','Dogwood Acres','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.105908,-95.260353,0,'2013-07-06 12:44:34',NULL,NULL),(9458,'10007','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(34410,'38630','P','Farrell','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.201017,-90.570892,0,'2013-07-06 12:44:32',NULL,NULL),(43628,'48821','S','Dimondale','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.648912,-84.645594,0,'2013-07-06 12:44:32',NULL,NULL),(41137,'46635','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.715250,-86.210153,0,'2013-07-06 12:44:32',NULL,NULL),(69304,'83452','S','Tetonia','D','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.798700,-111.181167,0,'2013-07-06 12:44:34',NULL,NULL),(28455,'31410','S','Wilmington Is','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.013342,-80.953521,0,'2013-07-06 12:44:32',NULL,NULL),(20363,'20877','S','Montgomery Village','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.141703,-77.193419,0,'2013-07-06 12:44:31',NULL,NULL),(48632,'55808','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.676959,-92.231918,0,'2013-07-06 12:44:33',NULL,NULL),(9534,'10020','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(54920,'63091','S','Rosebud','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.381574,-91.390301,0,'2013-07-06 12:44:33',NULL,NULL),(66954,'79377','S','Welch','D','Dawson','48115','Texas','TX','48','0000','806','Central',-6.0,'Y',32.838864,-102.099742,0,'2013-07-06 12:44:34',NULL,NULL),(69090,'83252','S','Stone','A','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(1899,'00794','S','Vistas De Montecielo','N','Barranquitas','72019','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.187596,-66.307408,0,'2013-07-06 12:44:30',NULL,NULL),(25385,'28263','U','First Citizens Bank','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.151538,-80.873152,0,'2013-07-06 12:44:31',NULL,NULL),(12857,'13318','S','North Bridgewater','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.940901,-75.285826,0,'2013-07-06 12:44:30',NULL,NULL),(3173,'01302','P','Greenfield','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.652020,-72.609653,0,'2013-07-06 12:44:30',NULL,NULL),(8242,'08003','S','Woodcrest','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.881958,-74.970489,0,'2013-07-06 12:44:30',NULL,NULL),(51067,'58752','S','Lignite','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.805920,-102.549291,0,'2013-07-06 12:44:33',NULL,NULL),(48165,'55375','S','Minnetrista','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.904785,-93.749054,0,'2013-07-06 12:44:33',NULL,NULL),(50958,'58623','S','Buffalo Spg','A','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.179366,-103.400993,0,'2013-07-06 12:44:33',NULL,NULL),(22944,'24640','P','Red Ash','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.106469,-81.862722,0,'2013-07-06 12:44:31',NULL,NULL),(18482,'19088','U','Radnor','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.048256,-75.355995,0,'2013-07-06 12:44:31',NULL,NULL),(35510,'39532','S','BLX','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.461218,-88.949246,0,'2013-07-06 12:44:32',NULL,NULL),(20720,'21282','P','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.387100,-76.722830,0,'2013-07-06 12:44:31',NULL,NULL),(41281,'46760','S','Sparta','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.348810,-85.609076,0,'2013-07-06 12:44:32',NULL,NULL),(72927,'90031','S','Lincoln Heights','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.078396,-118.211918,0,'2013-07-06 12:44:34',NULL,NULL),(78947,'98368','S','Glen Cove','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(1042,'00723','S','Patillas','D','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(66892,'79247','S','Odell','D','Wilbarger','48487','Texas','TX','48','0000','940','Central',-6.0,'Y',34.116390,-99.342030,0,'2013-07-06 12:44:34',NULL,NULL),(18481,'19087','S','Wayne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.038508,-75.383299,0,'2013-07-06 12:44:31',NULL,NULL),(4381,'03102','S','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.975161,-71.506713,0,'2013-07-06 12:44:30',NULL,NULL),(75912,'95003','S','Seascape','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.992640,-121.876740,0,'2013-07-06 12:44:34',NULL,NULL),(39468,'44710','S','Reedurban','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.793793,-81.421951,0,'2013-07-06 12:44:32',NULL,NULL),(47445,'54726','S','Edson','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.951426,-91.041064,0,'2013-07-06 12:44:32',NULL,NULL),(76833,'95960','S','Sweetland','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.339635,-121.132146,0,'2013-07-06 12:44:34',NULL,NULL),(12021,'12510','P','Billings','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.672319,-73.762471,0,'2013-07-06 12:44:30',NULL,NULL),(17155,'17812','S','Beaver Spgs','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.770100,-77.247271,0,'2013-07-06 12:44:31',NULL,NULL),(37386,'41751','S','Jeff','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.206923,-83.187841,0,'2013-07-06 12:44:32',NULL,NULL),(12978,'13401','P','Mc Conelsvile','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.291320,-75.668520,0,'2013-07-06 12:44:30',NULL,NULL),(30533,'33408','S','N Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(12369,'12911','S','Keeseville','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.533729,-73.500290,0,'2013-07-06 12:44:30',NULL,NULL),(56657,'65619','S','Battlefield','A','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.129140,-93.386700,0,'2013-07-06 12:44:33',NULL,NULL),(61656,'72903','S','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.345500,-94.377580,0,'2013-07-06 12:44:33',NULL,NULL),(64927,'77212','U','Chase Bank','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.763737,-95.365297,0,'2013-07-06 12:44:34',NULL,NULL),(72808,'89714','U','Nevada Industrial Comm','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.135730,-119.664200,0,'2013-07-06 12:44:34',NULL,NULL),(43761,'49019','P','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.272881,-85.587416,0,'2013-07-06 12:44:32',NULL,NULL),(12770,'13211','S','Mattydale','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.098535,-76.132190,0,'2013-07-06 12:44:30',NULL,NULL),(7215,'06494','U','Fosdick Corp','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.469621,-72.818052,0,'2013-07-06 12:44:30',NULL,NULL),(32501,'36067','S','Prattville','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.487639,-86.508013,0,'2013-07-06 12:44:32',NULL,NULL),(16198,'17070','S','New Cumb','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(34645,'38769','S','Rosedale','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.846420,-91.001880,0,'2013-07-06 12:44:32',NULL,NULL),(59877,'71269','S','Bee Bayou','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(72223,'88433','S','Quay','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.960345,-103.807602,0,'2013-07-06 12:44:34',NULL,NULL),(71501,'87108','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.072326,-106.577980,0,'2013-07-06 12:44:34',NULL,NULL),(63801,'75962','U','Nacogdoches S F Austin Univ','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(56486,'65330','S','Gilliam','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.231979,-93.005248,0,'2013-07-06 12:44:33',NULL,NULL),(27432,'30112','P','Carrollton','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.580424,-85.087792,0,'2013-07-06 12:44:31',NULL,NULL),(35605,'39601','S','East Lincoln','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(20973,'21793','S','Walkersville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.484762,-77.345888,0,'2013-07-06 12:44:31',NULL,NULL),(16696,'17402','S','Fayfield','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(49403,'56623','S','Hackett','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(25540,'28404','P','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.927021,-78.069326,0,'2013-07-06 12:44:31',NULL,NULL),(43062,'48189','S','Whitmore Lake','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.399875,-83.771630,0,'2013-07-06 12:44:32',NULL,NULL),(21169,'22152','S','West Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.777214,-77.235211,0,'2013-07-06 12:44:31',NULL,NULL),(9976,'10162','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(26471,'29150','S','Hoyt Heights','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(42511,'47848','S','Ellis','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.064996,-87.253689,0,'2013-07-06 12:44:32',NULL,NULL),(65804,'78132','S','Sattler','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.777220,-98.152980,0,'2013-07-06 12:44:34',NULL,NULL),(58553,'68818','S','Aurora','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.855080,-98.012700,0,'2013-07-06 12:44:33',NULL,NULL),(54531,'62880','S','St Peter','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.868041,-88.865839,0,'2013-07-06 12:44:33',NULL,NULL),(10933,'11434','S','Addisleigh Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(28360,'31207','U','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.832198,-83.656205,0,'2013-07-06 12:44:32',NULL,NULL),(28812,'32068','S','Middleburg','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.092929,-81.867697,0,'2013-07-06 12:44:32',NULL,NULL),(29320,'32540','P','Destin','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.392838,-86.481823,0,'2013-07-06 12:44:32',NULL,NULL),(7929,'07647','S','Rockleigh','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.010086,-73.950666,0,'2013-07-06 12:44:30',NULL,NULL),(16669,'17356','S','Red Lion','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(60693,'71940','S','Bowen','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(71139,'86028','P','Holbrook','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.791446,-109.878946,0,'2013-07-06 12:44:34',NULL,NULL),(2788,'00976','S','Trujillo Alto','D','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(61095,'72135','S','Natural Steps','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.869776,-92.522556,0,'2013-07-06 12:44:33',NULL,NULL),(49140,'56372','U','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.562988,-94.218716,0,'2013-07-06 12:44:33',NULL,NULL),(71718,'87531','S','La Bolsa','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.141996,-105.998001,0,'2013-07-06 12:44:34',NULL,NULL),(55747,'64101','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.104257,-94.597017,0,'2013-07-06 12:44:33',NULL,NULL),(64241,'76354','S','Burkburnett','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',34.088591,-98.579862,0,'2013-07-06 12:44:34',NULL,NULL),(53278,'61726','S','Chenoa','D','McLean','17113','Illinois','IL','17','1040','815/779','Central',-6.0,'Y',40.743720,-88.717320,0,'2013-07-06 12:44:33',NULL,NULL),(6795,'06108','S','East Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(17202,'17821','S','Ridgeville','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(35188,'39284','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.275332,-90.218859,0,'2013-07-06 12:44:32',NULL,NULL),(21577,'22835','S','Luray','D','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.665612,-78.456879,0,'2013-07-06 12:44:31',NULL,NULL),(65770,'78108','S','Cibolo','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.568245,-98.229209,0,'2013-07-06 12:44:34',NULL,NULL),(40523,'45827','S','Cloverdale','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.011628,-84.286099,0,'2013-07-06 12:44:32',NULL,NULL),(23245,'25114','S','Jeffrey','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.959900,-81.811980,0,'2013-07-06 12:44:31',NULL,NULL),(11233,'11754','S','San Remo','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.886446,-73.244857,0,'2013-07-06 12:44:30',NULL,NULL),(59753,'71152','U','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.440924,-93.788435,0,'2013-07-06 12:44:33',NULL,NULL),(43862,'49117','S','Michiana','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.786972,-86.754132,0,'2013-07-06 12:44:32',NULL,NULL),(42094,'47460','S','Freeman','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(8921,'08742','S','Pt Pleasant','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(22339,'23874','S','Neusons','N','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.614061,-77.096376,0,'2013-07-06 12:44:31',NULL,NULL),(74981,'93444','S','Nipomo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.031218,-120.495313,0,'2013-07-06 12:44:34',NULL,NULL),(77318,'96701','S','Aiea','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.384548,-157.933730,0,'2013-07-06 12:44:34',NULL,NULL),(72471,'89124','S','Enterprise','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(67833,'80809','S','Cascade','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.911495,-104.985682,0,'2013-07-06 12:44:34',NULL,NULL),(53073,'61523','S','Edgewater Terrace','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(49600,'56755','S','Saint Vincent','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.936466,-97.165652,0,'2013-07-06 12:44:33',NULL,NULL),(26058,'28692','S','Reese','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273369,-81.786913,0,'2013-07-06 12:44:31',NULL,NULL),(13049,'13440','S','Floyd','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(13114,'13486','S','Big Brook','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.347210,-75.324999,0,'2013-07-06 12:44:30',NULL,NULL),(38104,'43093','U','Newark','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.058168,-82.452320,0,'2013-07-06 12:44:32',NULL,NULL),(1294,'00730','S','Urb La Lula','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(46701,'53790','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.073534,-89.382948,0,'2013-07-06 12:44:32',NULL,NULL),(16085,'17050','S','Silver Spg Tp','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(18405,'19053','S','Upper Holland','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(130,'00612','S','Vista del Atlantico','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(39748,'45102','S','Hamlet','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.022200,-84.225600,0,'2013-07-06 12:44:32',NULL,NULL),(51701,'60006','P','Arlington Heights','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.130610,-88.092341,0,'2013-07-06 12:44:33',NULL,NULL),(34390,'38618','S','Wallhill','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(11084,'11692','S','Arverne','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.590874,-73.796576,0,'2013-07-06 12:44:30',NULL,NULL),(49388,'56601','S','Ten Lake','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(74478,'92609','P','El Toro','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.624010,-117.690845,0,'2013-07-06 12:44:34',NULL,NULL),(76083,'95211','U','Univ of the Pacific','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.982119,-121.309791,0,'2013-07-06 12:44:34',NULL,NULL),(79493,'98902','S','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(65445,'77591','S','Texas City','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.386598,-94.987485,0,'2013-07-06 12:44:34',NULL,NULL),(75853,'94931','S','Cotati','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.326317,-122.704613,0,'2013-07-06 12:44:34',NULL,NULL),(67966,'80914','P','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(65993,'78338','P','Rudolph','N','Kenedy','48261','Texas','TX','48','0000','361','Central',-6.0,'Y',26.826414,-97.750931,0,'2013-07-06 12:44:34',NULL,NULL),(59991,'71328','S','Big Island','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(49398,'56621','S','Zerkel','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(23206,'25067','S','East Bank','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.220630,-81.441267,0,'2013-07-06 12:44:31',NULL,NULL),(25331,'28208','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.235370,-80.906716,0,'2013-07-06 12:44:31',NULL,NULL),(2011,'00914','P','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.448288,-66.016711,0,'2013-07-06 12:44:30',NULL,NULL),(40755,'46143','S','Grnwood','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.601573,-86.133793,0,'2013-07-06 12:44:32',NULL,NULL),(632,'00682','S','Urb Bella Lomas','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(61028,'72117','S','McAlmont','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(25892,'28643','S','Comet','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(4749,'03842','S','Hampton Beach','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.932595,-70.823853,0,'2013-07-06 12:44:30',NULL,NULL),(76496,'95634','S','Volcanoville','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917770,-120.790653,0,'2013-07-06 12:44:34',NULL,NULL),(38899,'44116','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.467062,-81.860125,0,'2013-07-06 12:44:32',NULL,NULL),(51813,'60050','S','McHenry','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(27638,'30316','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.718321,-84.326190,0,'2013-07-06 12:44:31',NULL,NULL),(29418,'32656','S','Keystone Hgts','A','Clay','12019','Florida','FL','12','3600','352','Eastern',-5.0,'Y',29.798149,-81.989223,0,'2013-07-06 12:44:32',NULL,NULL),(13822,'14217','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.972758,-78.876061,0,'2013-07-06 12:44:31',NULL,NULL),(21475,'22640','S','Huntly','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.806691,-78.140273,0,'2013-07-06 12:44:31',NULL,NULL),(40633,'46031','S','Aroma','N','Hamilton','18057','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.162140,-85.935600,0,'2013-07-06 12:44:32',NULL,NULL),(31694,'34797','S','Howey in the Hills','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.742227,-81.820758,0,'2013-07-06 12:44:32',NULL,NULL),(46864,'54027','S','Hersey','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.956333,-92.173468,0,'2013-07-06 12:44:32',NULL,NULL),(731,'00687','S','Villas del Norte','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(4172,'02806','S','Barrington','D','Bristol','44001','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.744068,-71.315024,0,'2013-07-06 12:44:30',NULL,NULL),(78785,'98312','S','Rocky Point','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(73065,'90096','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.967004,-118.172186,0,'2013-07-06 12:44:34',NULL,NULL),(72203,'88415','S','Thomas','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(64999,'77292','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.826185,-95.428773,0,'2013-07-06 12:44:34',NULL,NULL),(60549,'71726','S','Chidester','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.707156,-93.028850,0,'2013-07-06 12:44:33',NULL,NULL),(28941,'32179','S','Ocklawaha','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.052240,-81.920160,0,'2013-07-06 12:44:32',NULL,NULL),(35118,'39211','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.370898,-90.128060,0,'2013-07-06 12:44:32',NULL,NULL),(18355,'19037','P','Glen Riddle','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.901166,-75.442291,0,'2013-07-06 12:44:31',NULL,NULL),(19251,'19939','S','Dagsboro','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.554789,-75.218796,0,'2013-07-06 12:44:31',NULL,NULL),(4353,'03049','S','Hollis','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.750536,-71.577679,0,'2013-07-06 12:44:30',NULL,NULL),(971,'00716','S','Urb Las Monjitas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(63008,'75160','S','Terrell','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.748186,-96.316878,0,'2013-07-06 12:44:33',NULL,NULL),(37195,'41514','S','Toler','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(34959,'39066','S','Edwards','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.281639,-90.586512,0,'2013-07-06 12:44:32',NULL,NULL),(10126,'10260','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(69722,'84038','S','Meadowville','N','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.847331,-111.346321,0,'2013-07-06 12:44:34',NULL,NULL),(75277,'93709','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.731597,-119.784692,0,'2013-07-06 12:44:34',NULL,NULL),(19913,'20549','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891820,-77.019583,0,'2013-07-06 12:44:31',NULL,NULL),(69718,'84037','S','Fruit Heights','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.031000,-111.942000,0,'2013-07-06 12:44:34',NULL,NULL),(68792,'82410','S','Basin','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.378527,-108.035395,0,'2013-07-06 12:44:34',NULL,NULL),(56582,'65543','S','Lynchburg','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.494383,-92.308408,0,'2013-07-06 12:44:33',NULL,NULL),(52520,'60911','S','Ashkum','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.877958,-87.946738,0,'2013-07-06 12:44:33',NULL,NULL),(47003,'54247','S','Whitelaw','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.183956,-87.792516,0,'2013-07-06 12:44:32',NULL,NULL),(11638,'12122','S','Livingstonville','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540360,-74.270820,0,'2013-07-06 12:44:30',NULL,NULL),(11672,'12147','S','Rensselaerville','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.504660,-74.147340,0,'2013-07-06 12:44:30',NULL,NULL),(28127,'30817','S','Agnes','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(13767,'14138','S','S Dayton','N','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.399405,-79.100331,0,'2013-07-06 12:44:31',NULL,NULL),(10983,'11545','S','Roslyn Harbor','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.816389,-73.637500,0,'2013-07-06 12:44:30',NULL,NULL),(32813,'36451','S','Allen','A','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.705769,-87.780178,0,'2013-07-06 12:44:32',NULL,NULL),(5883,'05151','S','Perkinsville','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.416944,-72.518333,0,'2013-07-06 12:44:30',NULL,NULL),(14603,'15224','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465933,-79.946627,0,'2013-07-06 12:44:31',NULL,NULL),(15313,'16155','P','Villa Maria','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.072335,-80.510213,0,'2013-07-06 12:44:31',NULL,NULL),(17453,'17941','S','Upper Mahantongo','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.726516,-76.605887,0,'2013-07-06 12:44:31',NULL,NULL),(35926,'40037','S','Loretto','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.690697,-85.454674,0,'2013-07-06 12:44:32',NULL,NULL),(19317,'20017','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.938481,-76.994394,0,'2013-07-06 12:44:31',NULL,NULL),(7487,'06906','S','Glenbrook','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.070278,-73.523724,0,'2013-07-06 12:44:30',NULL,NULL),(11966,'12458','S','Napanoch','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.813621,-74.413644,0,'2013-07-06 12:44:30',NULL,NULL),(32469,'36035','S','Goshen','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.854466,-86.108579,0,'2013-07-06 12:44:32',NULL,NULL),(16062,'17047','S','SW Madison','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(64851,'77048','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.620649,-95.330504,0,'2013-07-06 12:44:34',NULL,NULL),(75218,'93636','S','Madera','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',36.958056,-120.070391,0,'2013-07-06 12:44:34',NULL,NULL),(76269,'95418','P','Calpella','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.151320,-123.208800,0,'2013-07-06 12:44:34',NULL,NULL),(77806,'97140','S','Sherwood','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.355263,-122.833791,0,'2013-07-06 12:44:34',NULL,NULL),(62207,'73843','S','Gage','D','Ellis','40045','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.316177,-99.756588,0,'2013-07-06 12:44:33',NULL,NULL),(73011,'90066','S','Culver Cty','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.993713,-118.428320,0,'2013-07-06 12:44:34',NULL,NULL),(68978,'83113','S','Big Piney','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.557100,-110.113440,0,'2013-07-06 12:44:34',NULL,NULL),(64376,'76528','S','Levita','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(58464,'68732','S','Dixon','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.414922,-96.955534,0,'2013-07-06 12:44:33',NULL,NULL),(46112,'52635','S','Lockridge','D','Jefferson','19101','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.997720,-91.752281,0,'2013-07-06 12:44:32',NULL,NULL),(26661,'29375','P','Reidville','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.857948,-82.114151,0,'2013-07-06 12:44:31',NULL,NULL),(30870,'33673','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.997099,-82.459984,0,'2013-07-06 12:44:32',NULL,NULL),(16774,'17522','S','Napierville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(7580,'07032','S','Arlington','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.762320,-74.123220,0,'2013-07-06 12:44:30',NULL,NULL),(61811,'73103','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.488990,-97.518950,0,'2013-07-06 12:44:33',NULL,NULL),(78856,'98343','P','Agate Beach','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.139728,-123.732852,0,'2013-07-06 12:44:34',NULL,NULL),(22180,'23479','U','Lillian Vernon','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.846156,-76.092025,0,'2013-07-06 12:44:31',NULL,NULL),(39840,'45162','S','Butlerville','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.296640,-84.086520,0,'2013-07-06 12:44:32',NULL,NULL),(68996,'83201','S','ISU','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.882088,-112.423285,0,'2013-07-06 12:44:34',NULL,NULL),(61596,'72764','S','Bethel Heights','A','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.179938,-94.145696,0,'2013-07-06 12:44:33',NULL,NULL),(60470,'71655','S','Cominto','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(57000,'66204','S','Prairie Village','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(55881,'64402','S','Gentryville','N','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.248635,-94.331441,0,'2013-07-06 12:44:33',NULL,NULL),(50616,'58261','S','Minto','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.291130,-97.372047,0,'2013-07-06 12:44:33',NULL,NULL),(45697,'52052','S','Turkey River','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.711000,-91.078680,0,'2013-07-06 12:44:32',NULL,NULL),(3019,'01086','P','Westfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.140180,-72.756066,0,'2013-07-06 12:44:30',NULL,NULL),(28206,'31026','U','Haband','N','Putnam','13237','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.303533,-83.377912,0,'2013-07-06 12:44:31',NULL,NULL),(30446,'33331','S','Sw Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(31214,'33953','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.000048,-82.209983,0,'2013-07-06 12:44:32',NULL,NULL),(43828,'49085','S','St Joe','N','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.068065,-86.475496,0,'2013-07-06 12:44:32',NULL,NULL),(44298,'49729','S','Ellsworth','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.145270,-85.211919,0,'2013-07-06 12:44:32',NULL,NULL),(2,'00501','U','Internal Revenue Service','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.813078,-73.046388,0,'2013-07-06 12:44:30',NULL,NULL),(66305,'78586','S','San Benito','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(19798,'20436','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897567,-77.024098,0,'2013-07-06 12:44:31',NULL,NULL),(52431,'60655','S','Merrionette Park','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.691946,-87.709304,0,'2013-07-06 12:44:33',NULL,NULL),(3350,'01561','P','S Lancaster','A','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.441040,-71.689995,0,'2013-07-06 12:44:30',NULL,NULL),(47661,'54937','S','Fond du Lac','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.808088,-88.480729,0,'2013-07-06 12:44:33',NULL,NULL),(71756,'87548','P','Medenales','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.152065,-106.236296,0,'2013-07-06 12:44:34',NULL,NULL),(20146,'20731','P','Capitol Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.887677,-76.912147,0,'2013-07-06 12:44:31',NULL,NULL),(3446,'01760','S','S Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(56725,'65702','S','Macomb','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.105865,-92.483028,0,'2013-07-06 12:44:33',NULL,NULL),(46069,'52580','S','Packwood','D','Jefferson','19101','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.118406,-92.061888,0,'2013-07-06 12:44:32',NULL,NULL),(73953,'92060','P','Palomar Mtn','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.336039,-116.799561,0,'2013-07-06 12:44:34',NULL,NULL),(44441,'49858','S','Menominee','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.123103,-87.615268,0,'2013-07-06 12:44:32',NULL,NULL),(75089,'93535','S','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(72604,'89412','P','Gerlach','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',40.651975,-119.355692,0,'2013-07-06 12:44:34',NULL,NULL),(62108,'73638','S','Crawford','D','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.848214,-99.810085,0,'2013-07-06 12:44:33',NULL,NULL),(57223,'66502','S','Manhattan','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.197419,-96.597280,0,'2013-07-06 12:44:33',NULL,NULL),(53547,'62040','S','Mitchell','A','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.761356,-90.096335,0,'2013-07-06 12:44:33',NULL,NULL),(49404,'56623','S','Pitt','A','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(6636,'06002','S','Bloomfield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.839367,-72.741195,0,'2013-07-06 12:44:30',NULL,NULL),(6495,'05777','S','Chippenhook','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.547778,-73.022778,0,'2013-07-06 12:44:30',NULL,NULL),(9627,'10034','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(35429,'39474','S','Terrell','N','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.595381,-89.875941,0,'2013-07-06 12:44:32',NULL,NULL),(52255,'60521','S','Hinsdale','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.790281,-87.948130,0,'2013-07-06 12:44:33',NULL,NULL),(48413,'55602','S','Ault','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.309551,-91.835899,0,'2013-07-06 12:44:33',NULL,NULL),(30370,'33316','S','Port Everglades','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.103966,-80.124513,0,'2013-07-06 12:44:32',NULL,NULL),(78371,'98022','S','Cumberland','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(41409,'46816','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.017810,-85.076819,0,'2013-07-06 12:44:32',NULL,NULL),(69243,'83421','P','Chester','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.999806,-111.568989,0,'2013-07-06 12:44:34',NULL,NULL),(59809,'71226','S','Womack','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.249460,-92.416800,0,'2013-07-06 12:44:33',NULL,NULL),(57030,'66207','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(13121,'13490','S','Westmoreland','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.113737,-75.416336,0,'2013-07-06 12:44:30',NULL,NULL),(46074,'52585','S','Richland','D','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.182995,-91.991490,0,'2013-07-06 12:44:32',NULL,NULL),(57204,'66431','S','Harveyville','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.791821,-95.961435,0,'2013-07-06 12:44:33',NULL,NULL),(76887,'95979','S','Lodoga','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.308210,-122.511314,0,'2013-07-06 12:44:34',NULL,NULL),(35917,'40027','P','Harrods Creek','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.316932,-85.631873,0,'2013-07-06 12:44:32',NULL,NULL),(56210,'65032','S','Eugene','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.386782,-92.366414,0,'2013-07-06 12:44:33',NULL,NULL),(44598,'50047','S','Scotch Ridge','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.477985,-93.476846,0,'2013-07-06 12:44:32',NULL,NULL),(384,'00660','S','Valle Hermoso','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(27138,'29813','P','Hilda','D','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.241913,-81.361784,0,'2013-07-06 12:44:31',NULL,NULL),(20417,'20906','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(36325,'40385','S','College Hill','A','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.747999,-84.128552,0,'2013-07-06 12:44:32',NULL,NULL),(39307,'44512','S','Boardman','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.041680,-80.685600,0,'2013-07-06 12:44:32',NULL,NULL),(64154,'76205','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.165180,-97.105380,0,'2013-07-06 12:44:34',NULL,NULL),(9262,'09603','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(43528,'48657','S','Sanford','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.703198,-84.393657,0,'2013-07-06 12:44:32',NULL,NULL),(39239,'44428','S','Kinsman','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.437474,-80.580228,0,'2013-07-06 12:44:32',NULL,NULL),(51971,'60146','S','Fairdale','N','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.119640,-88.891020,0,'2013-07-06 12:44:33',NULL,NULL),(74698,'93003','S','San Buenaventura','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.270548,-119.217135,0,'2013-07-06 12:44:34',NULL,NULL),(77242,'96537','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(54676,'62941','S','Grand Chain','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.250785,-89.010847,0,'2013-07-06 12:44:33',NULL,NULL),(53204,'61614','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.746805,-89.575662,0,'2013-07-06 12:44:33',NULL,NULL),(52067,'60301','S','Oak Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.888041,-87.797275,0,'2013-07-06 12:44:33',NULL,NULL),(44099,'49468','P','Grandville','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.905879,-85.755280,0,'2013-07-06 12:44:32',NULL,NULL),(80197,'99923','P','Hyder','D','Prince Wales Hyder','02198','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.963022,-130.392595,0,'2013-07-06 12:44:34',NULL,NULL),(37676,'42211','S','Trigg Furnace','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(19057,'19545','P','New Berlinvle','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.344188,-75.633347,0,'2013-07-06 12:44:31',NULL,NULL),(65151,'77389','S','The Woodlands','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.047500,-95.532222,0,'2013-07-06 12:44:34',NULL,NULL),(33869,'38015','S','Gilt Edge','A','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.560536,-89.838101,0,'2013-07-06 12:44:32',NULL,NULL),(36792,'41051','S','Nicholson','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.941955,-84.552352,0,'2013-07-06 12:44:32',NULL,NULL),(26032,'28681','S','Ellendale','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(4930,'04082','P','Windham','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.733601,-70.441554,0,'2013-07-06 12:44:30',NULL,NULL),(10854,'11413','S','Rosedale','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(2715,'00969','S','Qtas Reales','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(30023,'33135','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.766858,-80.238741,0,'2013-07-06 12:44:32',NULL,NULL),(38173,'43157','P','Thurston','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.840416,-82.544840,0,'2013-07-06 12:44:32',NULL,NULL),(31758,'34995','P','Stuart','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.159963,-80.235098,0,'2013-07-06 12:44:32',NULL,NULL),(36772,'41042','S','Hopeful Heights','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.986125,-84.648281,0,'2013-07-06 12:44:32',NULL,NULL),(51634,'59858','S','Philipsburg','D','Granite','30039','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.298846,-113.361385,0,'2013-07-06 12:44:33',NULL,NULL),(55875,'64197','U','Marine Corps Finance Center','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.956872,-94.571143,0,'2013-07-06 12:44:33',NULL,NULL),(71144,'86030','P','Bacobi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.921410,-110.673460,0,'2013-07-06 12:44:34',NULL,NULL),(18072,'18705','S','Hilldale','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(13093,'13471','S','Taberg','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.395357,-75.611063,0,'2013-07-06 12:44:30',NULL,NULL),(46236,'52802','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.512014,-90.624540,0,'2013-07-06 12:44:32',NULL,NULL),(35954,'40062','S','Saint Francis','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.626449,-85.465732,0,'2013-07-06 12:44:32',NULL,NULL),(49067,'56312','S','Spring Hill','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.486795,-94.955270,0,'2013-07-06 12:44:33',NULL,NULL),(47351,'54611','S','Alma Center','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.433888,-90.911967,0,'2013-07-06 12:44:32',NULL,NULL),(26561,'29209','S','Hazelwood Acres','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(67531,'80252','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.792550,-104.897260,0,'2013-07-06 12:44:34',NULL,NULL),(4238,'02862','P','Pawtucket','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.871125,-71.375669,0,'2013-07-06 12:44:30',NULL,NULL),(39895,'45215','S','Arlington Heights','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(38544,'43750','P','Kipling','D','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.994618,-81.506178,0,'2013-07-06 12:44:32',NULL,NULL),(20336,'20851','S','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.077214,-77.126217,0,'2013-07-06 12:44:31',NULL,NULL),(36284,'40351','S','Lakeview Heights','A','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.194098,-83.439956,0,'2013-07-06 12:44:32',NULL,NULL),(2908,'00987','S','Villa del Madrigal','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(28384,'31305','S','Darien','D','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.377338,-81.424380,0,'2013-07-06 12:44:32',NULL,NULL),(22986,'24740','S','Oakvale','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.411080,-81.027240,0,'2013-07-06 12:44:31',NULL,NULL),(50687,'58351','S','Brinsmade','A','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.068926,-99.258727,0,'2013-07-06 12:44:33',NULL,NULL),(53138,'61553','P','Norris','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.628846,-90.031799,0,'2013-07-06 12:44:33',NULL,NULL),(61950,'73165','S','Moore','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.334300,-97.345860,0,'2013-07-06 12:44:33',NULL,NULL),(67369,'80113','S','Cherry Hl Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643479,-104.956040,0,'2013-07-06 12:44:34',NULL,NULL),(73044,'90082','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.000545,-118.279071,0,'2013-07-06 12:44:34',NULL,NULL),(80173,'99832','P','Pelican','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.126780,-135.648668,0,'2013-07-06 12:44:34',NULL,NULL),(20731,'21287','U','Johns Hopkins','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.304023,-76.562557,0,'2013-07-06 12:44:31',NULL,NULL),(37597,'42123','S','Austin','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.822874,-85.994572,0,'2013-07-06 12:44:32',NULL,NULL),(58347,'68503','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.823017,-96.673442,0,'2013-07-06 12:44:33',NULL,NULL),(56834,'65804','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.164369,-93.244291,0,'2013-07-06 12:44:33',NULL,NULL),(54611,'62912','S','Elvira','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.464327,-88.986086,0,'2013-07-06 12:44:33',NULL,NULL),(49423,'56630','S','Moose Park','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(49111,'56349','S','Lowry','D','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.702683,-95.524007,0,'2013-07-06 12:44:33',NULL,NULL),(20465,'21031','S','Hunt Valley','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.490349,-76.659398,0,'2013-07-06 12:44:31',NULL,NULL),(31398,'34224','S','Grove City','A','Charlotte','12015','Florida','FL','12','7510','941','Eastern',-5.0,'Y',26.925390,-82.302641,0,'2013-07-06 12:44:32',NULL,NULL),(8605,'08234','S','Egg Harbor Twp','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(16146,'17059','S','Zooks Dam','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(62114,'73645','S','Erick','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.212348,-99.868165,0,'2013-07-06 12:44:33',NULL,NULL),(42980,'48141','S','Inkster','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.292417,-83.317050,0,'2013-07-06 12:44:32',NULL,NULL),(17875,'18439','S','Lakewood','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.814208,-75.369590,0,'2013-07-06 12:44:31',NULL,NULL),(3955,'02477','U','Field Premium Inc','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.377202,-71.153710,0,'2013-07-06 12:44:30',NULL,NULL),(12327,'12865','S','East Hebron','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(19092,'19603','P','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.373990,-75.927958,0,'2013-07-06 12:44:31',NULL,NULL),(74966,'93432','S','Creston','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.492172,-120.496085,0,'2013-07-06 12:44:34',NULL,NULL),(34353,'38585','S','Spencer','D','Van Buren','47175','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.703319,-85.414206,0,'2013-07-06 12:44:32',NULL,NULL),(21789,'23072','S','Hayes','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.283333,-76.500000,0,'2013-07-06 12:44:31',NULL,NULL),(64930,'77215','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.736504,-95.521168,0,'2013-07-06 12:44:34',NULL,NULL),(56197,'65020','S','Camdenton','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.025300,-92.778660,0,'2013-07-06 12:44:33',NULL,NULL),(20126,'20719','P','W Bowie','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.959850,-76.737130,0,'2013-07-06 12:44:31',NULL,NULL),(23896,'26187','S','Williamstown','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.390693,-81.452216,0,'2013-07-06 12:44:31',NULL,NULL),(8424,'08076','P','Riverton','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.010680,-75.015535,0,'2013-07-06 12:44:30',NULL,NULL),(17548,'17979','P','Summit Station','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.576003,-76.192712,0,'2013-07-06 12:44:31',NULL,NULL),(27329,'30033','S','North Decatur','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.817078,-84.281903,0,'2013-07-06 12:44:31',NULL,NULL),(12998,'13411','S','Hoboken','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(49285,'56518','S','Bluffton','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.497703,-95.220066,0,'2013-07-06 12:44:33',NULL,NULL),(62692,'74729','S','Caddo','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.125607,-96.265459,0,'2013-07-06 12:44:33',NULL,NULL),(64530,'76642','S','Lk Limestone','A','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.546200,-96.529080,0,'2013-07-06 12:44:34',NULL,NULL),(76606,'95690','S','Ryer Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(78283,'97869','S','Prairie City','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.457199,-118.711413,0,'2013-07-06 12:44:34',NULL,NULL),(21542,'22738','S','Rochelle','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.265908,-78.251320,0,'2013-07-06 12:44:31',NULL,NULL),(43529,'48658','S','Standish','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.977133,-83.934633,0,'2013-07-06 12:44:32',NULL,NULL),(42425,'47802','S','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(39918,'45220','S','Burnet Woods','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.146959,-84.518750,0,'2013-07-06 12:44:32',NULL,NULL),(50651,'58321','S','Brocket','D','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.239414,-98.356267,0,'2013-07-06 12:44:33',NULL,NULL),(13316,'13676','S','Parishville Center','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(12314,'12859','S','Porter Corners','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.173660,-73.889760,0,'2013-07-06 12:44:30',NULL,NULL),(17374,'17883','P','Vicksburg','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.937764,-76.990613,0,'2013-07-06 12:44:31',NULL,NULL),(61523,'72661','S','Price Place','A','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.449464,-92.574135,0,'2013-07-06 12:44:33',NULL,NULL),(12977,'13368','S','Lyonsdale','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.630920,-75.348480,0,'2013-07-06 12:44:30',NULL,NULL),(1122,'00725','S','Valles Del Lago','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(43854,'49107','S','Buchanan','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.831760,-86.402880,0,'2013-07-06 12:44:32',NULL,NULL),(30394,'33321','S','Lauderhill','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(6408,'05737','S','Chittenden','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.709009,-72.961526,0,'2013-07-06 12:44:30',NULL,NULL),(18020,'18641','S','Pittston','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.329128,-75.746729,0,'2013-07-06 12:44:31',NULL,NULL),(14720,'15278','U','National City Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.511937,-80.079685,0,'2013-07-06 12:44:31',NULL,NULL),(50712,'58368','S','Orrin','A','Pierce','38069','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.303660,-99.994440,0,'2013-07-06 12:44:33',NULL,NULL),(74743,'93043','U','Port Hueneme Naval Construct','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.162390,-119.201182,0,'2013-07-06 12:44:34',NULL,NULL),(7357,'06750','S','Bantam','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.713845,-73.253929,0,'2013-07-06 12:44:30',NULL,NULL),(52827,'61310','S','Amboy','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.704186,-89.342017,0,'2013-07-06 12:44:33',NULL,NULL),(45673,'52040','S','Dyersville','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.492540,-91.080300,0,'2013-07-06 12:44:32',NULL,NULL),(45178,'50606','S','Maryville','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.768576,-91.693918,0,'2013-07-06 12:44:32',NULL,NULL),(31705,'34952','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.298140,-80.296740,0,'2013-07-06 12:44:32',NULL,NULL),(11503,'12025','S','Honeywell Corners','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(37733,'42288','P','Woodbury','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.181719,-86.636201,0,'2013-07-06 12:44:32',NULL,NULL),(3544,'01921','S','Boxford','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.674498,-71.003708,0,'2013-07-06 12:44:30',NULL,NULL),(62318,'74038','S','Silver City','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.190677,-96.587636,0,'2013-07-06 12:44:33',NULL,NULL),(37218,'41531','S','Hardy','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.611104,-82.250507,0,'2013-07-06 12:44:32',NULL,NULL),(54991,'63127','S','Sunset Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.541300,-90.407963,0,'2013-07-06 12:44:33',NULL,NULL),(27684,'30336','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.749608,-84.551548,0,'2013-07-06 12:44:31',NULL,NULL),(74036,'92138','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.762758,-117.200398,0,'2013-07-06 12:44:34',NULL,NULL),(77883,'97268','P','Portland','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.416944,-122.638889,0,'2013-07-06 12:44:34',NULL,NULL),(23650,'25810','P','Allen Jct','A','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.591606,-81.349909,0,'2013-07-06 12:44:31',NULL,NULL),(73350,'91008','S','Duarte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.152274,-117.968170,0,'2013-07-06 12:44:34',NULL,NULL),(70478,'84764','P','Bryce Cyn Cty','A','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.677100,-112.155661,0,'2013-07-06 12:44:34',NULL,NULL),(68244,'81055','S','Wahatoya','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.461120,-105.039180,0,'2013-07-06 12:44:34',NULL,NULL),(64652,'76799','U','VA Regional Office','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.531269,-97.192230,0,'2013-07-06 12:44:34',NULL,NULL),(59331,'70538','S','Cypremort Point','A','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.796186,-91.507053,0,'2013-07-06 12:44:33',NULL,NULL),(55586,'63931','S','Bennett','N','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.641594,-90.959266,0,'2013-07-06 12:44:33',NULL,NULL),(35638,'39638','S','Cassels','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(25110,'27976','S','South Mills','D','Camden','37029','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.511770,-76.348226,0,'2013-07-06 12:44:31',NULL,NULL),(37367,'41729','S','Lennut','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.295690,-83.200168,0,'2013-07-06 12:44:32',NULL,NULL),(9069,'09002','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42609,'47885','S','West Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(43442,'48506','S','Northeast','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.051354,-83.637617,0,'2013-07-06 12:44:32',NULL,NULL),(55324,'63545','S','Mystic','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.266332,-92.952465,0,'2013-07-06 12:44:33',NULL,NULL),(63812,'75966','S','Newton','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.842427,-93.758074,0,'2013-07-06 12:44:34',NULL,NULL),(56196,'65018','S','Kliever','N','Moniteau','29135','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.631897,-92.567720,0,'2013-07-06 12:44:33',NULL,NULL),(37815,'42411','S','Fredonia','D','Caldwell','21033','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.218831,-87.986254,0,'2013-07-06 12:44:32',NULL,NULL),(54644,'62926','S','Dongola','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.360690,-89.167094,0,'2013-07-06 12:44:33',NULL,NULL),(51236,'59068','S','Luther','A','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.186715,-109.251476,0,'2013-07-06 12:44:33',NULL,NULL),(22197,'23509','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.880723,-76.263506,0,'2013-07-06 12:44:31',NULL,NULL),(15015,'15675','S','Penn','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.333591,-79.643377,0,'2013-07-06 12:44:31',NULL,NULL),(6725,'06073','S','S Glastonbury','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.663072,-72.573262,0,'2013-07-06 12:44:30',NULL,NULL),(51693,'60001','P','Alden','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.458101,-88.520013,0,'2013-07-06 12:44:33',NULL,NULL),(64746,'76908','S','San Angelo','A','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.387191,-100.562725,0,'2013-07-06 12:44:34',NULL,NULL),(62065,'73546','S','Loveland','N','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.229710,-98.690114,0,'2013-07-06 12:44:33',NULL,NULL),(60793,'72027','S','Center Ridge','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.401579,-92.560518,0,'2013-07-06 12:44:33',NULL,NULL),(58511,'68774','S','Saint Helena','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.821267,-97.340702,0,'2013-07-06 12:44:33',NULL,NULL),(44896,'50321','S','South Des Moines','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543913,-93.676872,0,'2013-07-06 12:44:32',NULL,NULL),(2563,'00959','S','Urb Las Americas','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(11347,'11795','S','West Islip','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.709304,-73.299311,0,'2013-07-06 12:44:30',NULL,NULL),(12380,'12916','S','Irish Corners','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.827852,-74.530013,0,'2013-07-06 12:44:30',NULL,NULL),(5234,'04468','S','Old Town','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.930939,-68.654151,0,'2013-07-06 12:44:30',NULL,NULL),(29051,'32238','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.221453,-81.763006,0,'2013-07-06 12:44:32',NULL,NULL),(32857,'36507','S','Pinegrove','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.874562,-87.775538,0,'2013-07-06 12:44:32',NULL,NULL),(20203,'20755','S','Fort Meade','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.109680,-76.736935,0,'2013-07-06 12:44:31',NULL,NULL),(11587,'12077','S','Bethlehem Center','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.596487,-73.794423,0,'2013-07-06 12:44:30',NULL,NULL),(5482,'04745','S','Frenchville','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.277889,-68.386251,0,'2013-07-06 12:44:30',NULL,NULL),(43013,'48164','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(38435,'43557','S','Stryker','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.502278,-84.412734,0,'2013-07-06 12:44:32',NULL,NULL),(37560,'42071','S','Coldwater','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(13908,'14302','P','Niagara Falls','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.087809,-79.061883,0,'2013-07-06 12:44:31',NULL,NULL),(75171,'93601','S','Nipinnawassee','N','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.380335,-119.718301,0,'2013-07-06 12:44:34',NULL,NULL),(20633,'21218','S','Waverly','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.325256,-76.605131,0,'2013-07-06 12:44:31',NULL,NULL),(78928,'98366','S','Orchard Heights','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(75384,'93944','P','Presidio Mtry','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.579877,-121.834074,0,'2013-07-06 12:44:34',NULL,NULL),(74524,'92653','S','Aliso Viejo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.601535,-117.711678,0,'2013-07-06 12:44:34',NULL,NULL),(63489,'75701','S','St Louis','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.326456,-95.294488,0,'2013-07-06 12:44:33',NULL,NULL),(63304,'75563','S','Linden','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.009734,-94.366056,0,'2013-07-06 12:44:33',NULL,NULL),(59996,'71329','P','Dupont','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.930210,-91.947325,0,'2013-07-06 12:44:33',NULL,NULL),(49339,'56565','S','Nashua','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.059997,-96.345073,0,'2013-07-06 12:44:33',NULL,NULL),(29334,'32548','S','Ft Walton Bch','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(10540,'10993','S','West Haverstraw','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.205428,-73.983291,0,'2013-07-06 12:44:30',NULL,NULL),(36803,'41055','S','Shannon','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(38840,'44088','P','Unionville','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.779353,-81.007653,0,'2013-07-06 12:44:32',NULL,NULL),(40342,'45617','P','Bourneville','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.282733,-83.161784,0,'2013-07-06 12:44:32',NULL,NULL),(5669,'04962','S','N Vassalboro','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.475695,-69.624563,0,'2013-07-06 12:44:30',NULL,NULL),(71053,'85750','S','Fort Lowell','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.291010,-110.842443,0,'2013-07-06 12:44:34',NULL,NULL),(65321,'77514','S','Anahuac','D','Chambers','48071','Texas','TX','48','3360','409','Central',-6.0,'Y',29.768783,-94.665834,0,'2013-07-06 12:44:34',NULL,NULL),(55857,'64171','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.050940,-94.588104,0,'2013-07-06 12:44:33',NULL,NULL),(51775,'60039','P','Crystal Lake','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.228371,-88.331231,0,'2013-07-06 12:44:33',NULL,NULL),(48223,'55417','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.904554,-93.227606,0,'2013-07-06 12:44:33',NULL,NULL),(71196,'86052','P','Fredonia','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.212643,-112.058276,0,'2013-07-06 12:44:34',NULL,NULL),(17489,'17960','S','Kepner','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(59089,'70123','S','Harahan','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.956536,-90.207527,0,'2013-07-06 12:44:33',NULL,NULL),(55985,'64628','S','St Catharine','A','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.788893,-93.073091,0,'2013-07-06 12:44:33',NULL,NULL),(6394,'05732','S','Bomoseen','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.643611,-73.199167,0,'2013-07-06 12:44:30',NULL,NULL),(25109,'27974','S','Shiloh','D','Camden','37029','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.243568,-76.078238,0,'2013-07-06 12:44:31',NULL,NULL),(25894,'28643','S','Farmers Store','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(20791,'21543','P','Midlothian','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.632075,-78.946487,0,'2013-07-06 12:44:31',NULL,NULL),(30021,'33134','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753678,-80.272023,0,'2013-07-06 12:44:32',NULL,NULL),(8384,'08059','S','Mount Ephraim','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.879419,-75.092601,0,'2013-07-06 12:44:30',NULL,NULL),(3870,'02358','P','North Pembroke','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.094410,-70.787885,0,'2013-07-06 12:44:30',NULL,NULL),(22203,'23511','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(39556,'44845','P','Melmore','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.031153,-83.133461,0,'2013-07-06 12:44:32',NULL,NULL),(5489,'04747','S','Island Falls','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.011654,-68.271262,0,'2013-07-06 12:44:30',NULL,NULL),(30003,'33124','P','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.726412,-80.238000,0,'2013-07-06 12:44:32',NULL,NULL),(71549,'87187','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.170145,-106.834189,0,'2013-07-06 12:44:34',NULL,NULL),(74371,'92501','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.992846,-117.371026,0,'2013-07-06 12:44:34',NULL,NULL),(15541,'16613','S','Ashville','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.558541,-78.541297,0,'2013-07-06 12:44:31',NULL,NULL),(38213,'43217','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.825664,-82.947527,0,'2013-07-06 12:44:32',NULL,NULL),(60811,'72032','S','Beryl','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(3077,'01151','S','Indian Orch','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.151001,-72.506454,0,'2013-07-06 12:44:30',NULL,NULL),(7783,'07422','S','Highland Lks','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.187240,-74.453760,0,'2013-07-06 12:44:30',NULL,NULL),(56964,'66113','P','Edwardsville','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.061080,-94.819380,0,'2013-07-06 12:44:33',NULL,NULL),(19064,'19547','S','Pikeville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(75127,'93553','S','Juniper Hills','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.470395,-117.896351,0,'2013-07-06 12:44:34',NULL,NULL),(51773,'60038','U','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.096596,-88.011307,0,'2013-07-06 12:44:33',NULL,NULL),(12129,'12701','S','Monticello','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.689320,-74.680800,0,'2013-07-06 12:44:30',NULL,NULL),(6337,'05669','S','E Granville','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(40023,'45247','S','White Oak','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(32839,'36480','S','Uriah','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.326580,-87.605287,0,'2013-07-06 12:44:32',NULL,NULL),(65734,'78046','S','El Cenizo','A','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.434650,-99.473074,0,'2013-07-06 12:44:34',NULL,NULL),(55429,'63664','S','Potosi','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.938045,-90.784876,0,'2013-07-06 12:44:33',NULL,NULL),(17280,'17846','S','Eyers Grove','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.135280,-76.519320,0,'2013-07-06 12:44:31',NULL,NULL),(43030,'48173','S','Brownstown TWP','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(14856,'15456','S','Lemont Frnc','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.922596,-79.787657,0,'2013-07-06 12:44:31',NULL,NULL),(43541,'48674','U','Dow Chemical USA','N','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.707462,-84.228673,0,'2013-07-06 12:44:32',NULL,NULL),(46884,'54113','S','Combined Locks','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.268294,-88.309953,0,'2013-07-06 12:44:32',NULL,NULL),(71231,'86333','S','Mayer','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.316282,-112.121385,0,'2013-07-06 12:44:34',NULL,NULL),(52917,'61367','S','Sublette','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.627163,-89.256614,0,'2013-07-06 12:44:33',NULL,NULL),(4701,'03814','S','CTR Ossipee','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.749840,-71.105236,0,'2013-07-06 12:44:30',NULL,NULL),(20445,'21010','S','Aberdeen Proving Ground','A','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404700,-76.288320,0,'2013-07-06 12:44:31',NULL,NULL),(19559,'20204','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885381,-77.017440,0,'2013-07-06 12:44:31',NULL,NULL),(5022,'04239','S','Jay','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.481587,-70.191149,0,'2013-07-06 12:44:30',NULL,NULL),(34381,'38617','S','Rich','A','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.393358,-90.490310,0,'2013-07-06 12:44:32',NULL,NULL),(27156,'29831','S','Jackson','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.343729,-81.807960,0,'2013-07-06 12:44:31',NULL,NULL),(26519,'29201','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.998223,-81.032546,0,'2013-07-06 12:44:31',NULL,NULL),(73137,'90274','S','Rolling Hills','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(65916,'78238','S','Leon Valley','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.479990,-98.610330,0,'2013-07-06 12:44:34',NULL,NULL),(37620,'42140','S','Gamaliel','D','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.660772,-85.813348,0,'2013-07-06 12:44:32',NULL,NULL),(10962,'11510','S','N Baldwin','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655358,-73.607376,0,'2013-07-06 12:44:30',NULL,NULL),(394,'00662','S','Comunidad Los Ponce','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(25608,'28456','S','Riegelwood','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.344900,-78.257820,0,'2013-07-06 12:44:31',NULL,NULL),(52234,'60502','S','Aurora','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.784300,-88.251300,0,'2013-07-06 12:44:33',NULL,NULL),(5972,'05341','S','East Dover','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.943611,-72.804444,0,'2013-07-06 12:44:30',NULL,NULL),(71852,'87654','U','Spaceport Cty','A','Sierra','35051','New Mexico','NM','35','0000','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69024,'83213','S','Craters of the Moon National','N','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.636568,-113.293312,0,'2013-07-06 12:44:34',NULL,NULL),(52033,'60184','S','Wayne','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.948067,-88.230588,0,'2013-07-06 12:44:33',NULL,NULL),(73748,'91716','P','City of Industry','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.003756,-117.974564,0,'2013-07-06 12:44:34',NULL,NULL),(32618,'36141','U','Bass Anglers Sports Soc','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386911,-86.148084,0,'2013-07-06 12:44:32',NULL,NULL),(39458,'44707','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.780264,-81.361212,0,'2013-07-06 12:44:32',NULL,NULL),(19681,'20370','U','Navy Annex','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878761,-76.994199,0,'2013-07-06 12:44:31',NULL,NULL),(19871,'20527','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901910,-77.025942,0,'2013-07-06 12:44:31',NULL,NULL),(2838,'00982','S','Urb El Comandante','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(5854,'05142','S','Cavendish','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.368371,-72.605995,0,'2013-07-06 12:44:30',NULL,NULL),(49055,'56303','S','Forada','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.583801,-94.203700,0,'2013-07-06 12:44:33',NULL,NULL),(4397,'03215','P','Watervl Vly','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.951855,-71.500298,0,'2013-07-06 12:44:30',NULL,NULL),(27760,'30362','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.900867,-84.276425,0,'2013-07-06 12:44:31',NULL,NULL),(7387,'06779','S','Watertown','A','Litchfield','09005','Connecticut','CT','09','8880','860/959','Eastern',-5.0,'Y',41.593909,-73.087086,0,'2013-07-06 12:44:30',NULL,NULL),(62948,'75103','S','Canton','D','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.552553,-95.870563,0,'2013-07-06 12:44:33',NULL,NULL),(16972,'17723','S','Ross Siding','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.391600,-77.471280,0,'2013-07-06 12:44:31',NULL,NULL),(42641,'47925','P','Buffalo','D','White','18181','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.882225,-86.744955,0,'2013-07-06 12:44:32',NULL,NULL),(7982,'07712','S','Asbury Park','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(15114,'15780','S','Valier','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.922566,-79.084851,0,'2013-07-06 12:44:31',NULL,NULL),(50545,'58126','U','Wells Fargo','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.874888,-96.784488,0,'2013-07-06 12:44:33',NULL,NULL),(24509,'27281','S','Foxfire Village','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(12701,'13144','S','Richland','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.561546,-76.014406,0,'2013-07-06 12:44:30',NULL,NULL),(44678,'50122','S','Hubbard','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.305273,-93.297256,0,'2013-07-06 12:44:32',NULL,NULL),(80127,'99769','P','Savoonga','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.250538,-169.597210,0,'2013-07-06 12:44:34',NULL,NULL),(18516,'19104','S','30th Street','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963766,-75.198203,0,'2013-07-06 12:44:31',NULL,NULL),(38292,'43340','S','Mount Victory','D','Hardin','39065','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.552721,-83.495057,0,'2013-07-06 12:44:32',NULL,NULL),(5975,'05343','S','Jamaica','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.104420,-72.807180,0,'2013-07-06 12:44:30',NULL,NULL),(2583,'00961','S','Bo Volcan','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(69933,'84114','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775628,-111.891834,0,'2013-07-06 12:44:34',NULL,NULL),(65415,'77572','P','La Porte','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.664261,-95.004094,0,'2013-07-06 12:44:34',NULL,NULL),(33100,'36852','S','Cusseta','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.759234,-85.241701,0,'2013-07-06 12:44:32',NULL,NULL),(33510,'37367','S','Pikeville','D','Bledsoe','47007','Tennessee','TN','47','0000','423','Central',-6.0,'Y',35.613924,-85.193725,0,'2013-07-06 12:44:32',NULL,NULL),(35379,'39452','S','Vernal','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(60536,'71675','S','Wilmar','D','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.621420,-91.927800,0,'2013-07-06 12:44:33',NULL,NULL),(74468,'92599','U','Perris','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.830356,-117.198023,0,'2013-07-06 12:44:34',NULL,NULL),(13292,'13664','S','Morristown','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583173,-75.646493,0,'2013-07-06 12:44:30',NULL,NULL),(20137,'20722','S','North Brentwood','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(44030,'49416','P','Glenn','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.521987,-86.232601,0,'2013-07-06 12:44:32',NULL,NULL),(12237,'12820','P','Cleverdale','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.471968,-73.639216,0,'2013-07-06 12:44:30',NULL,NULL),(50902,'58545','S','Hazen','D','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.335320,-101.623920,0,'2013-07-06 12:44:33',NULL,NULL),(39575,'44854','S','New Washington','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.951507,-82.851713,0,'2013-07-06 12:44:32',NULL,NULL),(29075,'32255','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.280202,-81.546387,0,'2013-07-06 12:44:32',NULL,NULL),(5417,'04667','S','Pleasant Point','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983450,-67.107224,0,'2013-07-06 12:44:30',NULL,NULL),(69954,'84118','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(56043,'64724','S','Appleton City','D','Saint Clair','29185','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.188111,-94.027023,0,'2013-07-06 12:44:33',NULL,NULL),(48802,'56013','S','Blue Earth','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.642656,-94.093292,0,'2013-07-06 12:44:33',NULL,NULL),(27787,'30380','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.646308,-84.389514,0,'2013-07-06 12:44:31',NULL,NULL),(68872,'82639','S','Sussex','A','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.748572,-106.551114,0,'2013-07-06 12:44:34',NULL,NULL),(60451,'71652','S','Saline','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.877586,-92.306949,0,'2013-07-06 12:44:33',NULL,NULL),(36355,'40446','U','Christian Appalachian','N','Garrard','21079','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.615778,-84.576415,0,'2013-07-06 12:44:32',NULL,NULL),(37715,'42274','S','Browning','A','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.951025,-86.601859,0,'2013-07-06 12:44:32',NULL,NULL),(22946,'24646','S','Rowe','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.126630,-82.036580,0,'2013-07-06 12:44:31',NULL,NULL),(46638,'53593','S','Fitchburg','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.992600,-89.570110,0,'2013-07-06 12:44:32',NULL,NULL),(59038,'70084','S','Lions','N','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.069968,-90.557182,0,'2013-07-06 12:44:33',NULL,NULL),(49595,'56751','S','Pencer','A','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.846666,-95.757088,0,'2013-07-06 12:44:33',NULL,NULL),(76650,'95726','S','Pollock Pines','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.756220,-120.546600,0,'2013-07-06 12:44:34',NULL,NULL),(18387,'19048','U','Trevose','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.176074,-74.924818,0,'2013-07-06 12:44:31',NULL,NULL),(2844,'00983','S','Mans de Vistamar Marina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(22429,'24012','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.306500,-79.940340,0,'2013-07-06 12:44:31',NULL,NULL),(63406,'75652','S','Henderson','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(11592,'12078','S','Riceville','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.054502,-74.338330,0,'2013-07-06 12:44:30',NULL,NULL),(5199,'04451','S','Kingman Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.604763,-68.227102,0,'2013-07-06 12:44:30',NULL,NULL),(74724,'93031','P','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.220474,-119.181244,0,'2013-07-06 12:44:34',NULL,NULL),(75657,'94534','S','Suisun City','A','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.286723,-122.011695,0,'2013-07-06 12:44:34',NULL,NULL),(71166,'86039','P','New Oraibi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(56563,'65470','S','Falcon','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.611420,-92.350500,0,'2013-07-06 12:44:33',NULL,NULL),(73688,'91604','S','Studio City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144568,-118.390161,0,'2013-07-06 12:44:34',NULL,NULL),(67028,'79537','S','Nolan','D','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.284164,-100.247928,0,'2013-07-06 12:44:34',NULL,NULL),(64938,'77222','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.829642,-95.372234,0,'2013-07-06 12:44:34',NULL,NULL),(56093,'64776','S','Osceola','D','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.040765,-93.704717,0,'2013-07-06 12:44:33',NULL,NULL),(59196,'70372','S','Labadieville','D','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.834073,-90.958964,0,'2013-07-06 12:44:33',NULL,NULL),(29994,'33112','U','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796650,-80.341619,0,'2013-07-06 12:44:32',NULL,NULL),(71904,'87752','S','Wagon Mound','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.010540,-104.701530,0,'2013-07-06 12:44:34',NULL,NULL),(59352,'70562','P','New Iberia','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.990518,-91.817232,0,'2013-07-06 12:44:33',NULL,NULL),(58982,'70047','S','Destrehan','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.963928,-90.375524,0,'2013-07-06 12:44:33',NULL,NULL),(43466,'48554','U','Gm Service Parts Operations','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.936862,-83.823819,0,'2013-07-06 12:44:32',NULL,NULL),(71546,'87184','P','Alameda','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.199435,-106.660676,0,'2013-07-06 12:44:34',NULL,NULL),(94,'00612','S','Urb Arecibo Gdns','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(30475,'33346','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.123836,-80.142332,0,'2013-07-06 12:44:32',NULL,NULL),(40459,'45745','S','Lower Salem','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.607800,-81.350400,0,'2013-07-06 12:44:32',NULL,NULL),(62855,'75026','P','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.039326,-96.733277,0,'2013-07-06 12:44:33',NULL,NULL),(67761,'80632','P','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.422987,-104.698006,0,'2013-07-06 12:44:34',NULL,NULL),(67099,'79708','P','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',32.018202,-102.123854,0,'2013-07-06 12:44:34',NULL,NULL),(63519,'75754','S','Edom','A','Van Zandt','48467','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.414520,-95.649120,0,'2013-07-06 12:44:33',NULL,NULL),(9431,'10003','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(12376,'12915','P','Brainardsvle','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.857117,-74.034613,0,'2013-07-06 12:44:30',NULL,NULL),(36604,'40977','S','Clear Creek','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(71448,'87042','S','Bosque Farms','A','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.832700,-106.662840,0,'2013-07-06 12:44:34',NULL,NULL),(45399,'51038','S','Merrill','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.724946,-96.248252,0,'2013-07-06 12:44:32',NULL,NULL),(71350,'86515','P','Navajo Indian Reservation','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.660965,-109.102204,0,'2013-07-06 12:44:34',NULL,NULL),(49937,'57331','S','Dimock','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.463498,-97.994630,0,'2013-07-06 12:44:33',NULL,NULL),(9701,'10055','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(46441,'53207','S','St Francis','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.980668,-87.892825,0,'2013-07-06 12:44:32',NULL,NULL),(40116,'45324','S','Beaver Creek','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.807279,-84.019499,0,'2013-07-06 12:44:32',NULL,NULL),(60122,'71369','S','Red Fish','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.989911,-91.825861,0,'2013-07-06 12:44:33',NULL,NULL),(56034,'64682','S','Tina','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.570852,-93.476707,0,'2013-07-06 12:44:33',NULL,NULL),(29932,'33065','S','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.268785,-80.255243,0,'2013-07-06 12:44:32',NULL,NULL),(47528,'54806','S','Sanborn','A','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(41726,'47245','P','Hayden','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.983934,-85.741159,0,'2013-07-06 12:44:32',NULL,NULL),(67584,'80401','S','Evergreen','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.712606,-105.229868,0,'2013-07-06 12:44:34',NULL,NULL),(18300,'19017','P','Chester Heights','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.888886,-75.471423,0,'2013-07-06 12:44:31',NULL,NULL),(38639,'43932','S','Irondale','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.590849,-80.708824,0,'2013-07-06 12:44:32',NULL,NULL),(75332,'93790','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.789440,-119.827606,0,'2013-07-06 12:44:34',NULL,NULL),(27323,'30030','S','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.773883,-84.295376,0,'2013-07-06 12:44:31',NULL,NULL),(68195,'81036','S','Brandon','N','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.463000,-102.652860,0,'2013-07-06 12:44:34',NULL,NULL),(62453,'74301','S','Pensacola','A','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.642087,-95.156105,0,'2013-07-06 12:44:33',NULL,NULL),(1390,'00738','S','Mans Punta del Este','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(19124,'19608','S','S Heidelberg','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(50039,'57432','S','Claremont','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.667260,-98.064619,0,'2013-07-06 12:44:33',NULL,NULL),(41730,'47249','P','Kurtz','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.956371,-86.204228,0,'2013-07-06 12:44:32',NULL,NULL),(4146,'02762','S','Plainville','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.012510,-71.328629,0,'2013-07-06 12:44:30',NULL,NULL),(7502,'06922','U','Clairol Co','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.056955,-73.514770,0,'2013-07-06 12:44:30',NULL,NULL),(30602,'33421','P','West Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.680200,-80.204984,0,'2013-07-06 12:44:32',NULL,NULL),(46758,'53935','P','Friesland','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.589562,-89.067739,0,'2013-07-06 12:44:32',NULL,NULL),(43510,'48633','P','Lake George','D','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.980222,-84.906123,0,'2013-07-06 12:44:32',NULL,NULL),(33063,'36764','P','Nanafalia','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.111618,-87.986397,0,'2013-07-06 12:44:32',NULL,NULL),(43795,'49055','S','Gobles','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.363768,-85.871346,0,'2013-07-06 12:44:32',NULL,NULL),(16783,'17532','S','Rawlinsville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.856500,-76.300080,0,'2013-07-06 12:44:31',NULL,NULL),(2315,'00928','P','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.393175,-66.061744,0,'2013-07-06 12:44:30',NULL,NULL),(20150,'20733','S','Churchton','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.808321,-76.531195,0,'2013-07-06 12:44:31',NULL,NULL),(5211,'04457','S','Mattamiscontis Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(9368,'09826','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18071,'18704','S','Wilkes Barre','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(18304,'19018','S','Clifton Hts','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(72045,'88072','S','Vado','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.121944,-106.707222,0,'2013-07-06 12:44:34',NULL,NULL),(9012,'08863','S','Fords','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.536610,-74.315728,0,'2013-07-06 12:44:30',NULL,NULL),(64887,'77075','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.620035,-95.268602,0,'2013-07-06 12:44:34',NULL,NULL),(11044,'11571','P','Rvc','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.657461,-73.648593,0,'2013-07-06 12:44:30',NULL,NULL),(76320,'95456','S','Littleriver','A','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.266551,-123.763145,0,'2013-07-06 12:44:34',NULL,NULL),(25545,'28406','P','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.178185,-77.885847,0,'2013-07-06 12:44:31',NULL,NULL),(51232,'59065','S','Pray','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.437484,-110.684001,0,'2013-07-06 12:44:33',NULL,NULL),(37652,'42202','S','Adairville','D','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.684982,-86.851839,0,'2013-07-06 12:44:32',NULL,NULL),(61062,'72123','P','Patterson','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.255496,-91.235121,0,'2013-07-06 12:44:33',NULL,NULL),(8181,'07880','P','Vienna','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.874466,-74.891930,0,'2013-07-06 12:44:30',NULL,NULL),(470,'00664','S','Urb Vega Linda','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(66198,'78543','P','Engelman','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.297711,-97.993340,0,'2013-07-06 12:44:34',NULL,NULL),(29495,'32750','S','Longwood','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.704260,-81.362395,0,'2013-07-06 12:44:32',NULL,NULL),(38349,'43442','S','Lindsey','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.422606,-83.220463,0,'2013-07-06 12:44:32',NULL,NULL),(52192,'60472','S','Robbins','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.641841,-87.700278,0,'2013-07-06 12:44:33',NULL,NULL),(55712,'64070','S','Lone Jack','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.895637,-94.160372,0,'2013-07-06 12:44:33',NULL,NULL),(53479,'61942','S','Newman','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.797928,-87.988218,0,'2013-07-06 12:44:33',NULL,NULL),(27772,'30368','U','Suntrust','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.649172,-84.392574,0,'2013-07-06 12:44:31',NULL,NULL),(70835,'85532','P','Claypool','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.411965,-110.831503,0,'2013-07-06 12:44:34',NULL,NULL),(3307,'01518','S','Fiskdale','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.120891,-72.110243,0,'2013-07-06 12:44:30',NULL,NULL),(1096,'00725','S','Urb Jose Mercado','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(44466,'49885','S','Skandia','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.349760,-87.251184,0,'2013-07-06 12:44:32',NULL,NULL),(43817,'49077','P','Oshtemo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.255524,-85.676998,0,'2013-07-06 12:44:32',NULL,NULL),(6643,'06013','S','Unionville','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760236,-72.950679,0,'2013-07-06 12:44:30',NULL,NULL),(61357,'72478','S','Warm Springs','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.465273,-91.042048,0,'2013-07-06 12:44:33',NULL,NULL),(14097,'14621','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.182834,-77.602085,0,'2013-07-06 12:44:31',NULL,NULL),(19529,'20187','S','Warrenton','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.722482,-77.719815,0,'2013-07-06 12:44:31',NULL,NULL),(61777,'73067','S','Ninnekah','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.945945,-97.916959,0,'2013-07-06 12:44:33',NULL,NULL),(57958,'67756','S','Wheeler','A','Cheyenne','20023','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.774780,-101.810400,0,'2013-07-06 12:44:33',NULL,NULL),(79020,'98391','S','Inlet Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(68456,'81230','S','Gunnison','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.453420,-106.609860,0,'2013-07-06 12:44:34',NULL,NULL),(45116,'50560','S','Galbraith','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.912847,-94.084571,0,'2013-07-06 12:44:32',NULL,NULL),(15662,'16802','S','Penn St Univ','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.870717,-77.834150,0,'2013-07-06 12:44:31',NULL,NULL),(3972,'02493','S','Weston','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(10374,'10590','S','South Salem','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.251239,-73.543589,0,'2013-07-06 12:44:30',NULL,NULL),(8186,'07890','U','Branchville','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.144891,-74.752093,0,'2013-07-06 12:44:30',NULL,NULL),(30634,'33444','S','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.461443,-80.077804,0,'2013-07-06 12:44:32',NULL,NULL),(80166,'99824','S','Douglas','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.276465,-134.391690,0,'2013-07-06 12:44:34',NULL,NULL),(44853,'50272','P','Williamson','D','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.114545,-93.268297,0,'2013-07-06 12:44:32',NULL,NULL),(46600,'53555','S','Lodi','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.328456,-89.563763,0,'2013-07-06 12:44:32',NULL,NULL),(54550,'62889','S','Divide','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.466107,-88.752074,0,'2013-07-06 12:44:33',NULL,NULL),(77878,'97267','S','Milwaukie','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(51260,'59085','S','Two Dot','D','Wheatland','30107','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.424441,-110.068651,0,'2013-07-06 12:44:33',NULL,NULL),(34298,'38506','S','Cookevle','N','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.146202,-85.527440,0,'2013-07-06 12:44:32',NULL,NULL),(36874,'41095','S','Napoleon','A','Gallatin','21077','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.785010,-84.902852,0,'2013-07-06 12:44:32',NULL,NULL),(37011,'41230','S','Clifford','A','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.109540,-82.626840,0,'2013-07-06 12:44:32',NULL,NULL),(72064,'88119','S','Lake Sumner','A','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.471919,-104.234002,0,'2013-07-06 12:44:34',NULL,NULL),(38757,'44039','S','North Ridgeville','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.391979,-82.019396,0,'2013-07-06 12:44:32',NULL,NULL),(6413,'05739','S','Chipman Lake','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(2577,'00959','S','Villas de San Miguel','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(32960,'36585','S','Hawthorn','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.392178,-88.062461,0,'2013-07-06 12:44:32',NULL,NULL),(28621,'31719','S','Americus','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.075442,-84.223306,0,'2013-07-06 12:44:32',NULL,NULL),(20410,'20904','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.065040,-76.981500,0,'2013-07-06 12:44:31',NULL,NULL),(24793,'27586','P','Vaughan','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.426794,-78.004293,0,'2013-07-06 12:44:31',NULL,NULL),(29346,'32559','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.465303,-87.338781,0,'2013-07-06 12:44:32',NULL,NULL),(38853,'44094','S','Waite Hill','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(69277,'83440','S','Plano','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(73449,'91301','S','Saratoga Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(66020,'78360','S','Guerra','D','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',26.926237,-98.886303,0,'2013-07-06 12:44:34',NULL,NULL),(63085,'75250','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.782956,-96.800159,0,'2013-07-06 12:44:33',NULL,NULL),(3798,'02222','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.362372,-71.066194,0,'2013-07-06 12:44:30',NULL,NULL),(36176,'40245','S','Coldstream','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.264541,-85.495953,0,'2013-07-06 12:44:32',NULL,NULL),(54843,'63038','S','Pond','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.582772,-90.652220,0,'2013-07-06 12:44:33',NULL,NULL),(37718,'42274','S','Rockfield','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.951025,-86.601859,0,'2013-07-06 12:44:32',NULL,NULL),(74718,'93021','S','Moorpark','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.280332,-118.889449,0,'2013-07-06 12:44:34',NULL,NULL),(11112,'11702','S','Gilgo Beach','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(61131,'72157','S','Mallet Town','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.280120,-92.536920,0,'2013-07-06 12:44:33',NULL,NULL),(41167,'46703','S','York','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(48451,'55709','S','Bovey','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.248534,-93.364213,0,'2013-07-06 12:44:33',NULL,NULL),(48693,'55934','S','Predmore','N','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.022060,-92.276760,0,'2013-07-06 12:44:33',NULL,NULL),(43294,'48336','S','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458873,-83.346843,0,'2013-07-06 12:44:32',NULL,NULL),(59566,'70836','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.451013,-91.183204,0,'2013-07-06 12:44:33',NULL,NULL),(76131,'95249','S','San Andreas','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.198764,-120.654173,0,'2013-07-06 12:44:34',NULL,NULL),(47297,'54547','S','Mercer','D','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.189200,-90.076680,0,'2013-07-06 12:44:32',NULL,NULL),(78721,'98277','S','Oak Harbor','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.302951,-122.640714,0,'2013-07-06 12:44:34',NULL,NULL),(21641,'22923','S','Eheart','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.166765,-78.365242,0,'2013-07-06 12:44:31',NULL,NULL),(71225,'86331','P','Jerome','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.749967,-112.105875,0,'2013-07-06 12:44:34',NULL,NULL),(56293,'65080','S','Tebbetts','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.646909,-91.957996,0,'2013-07-06 12:44:33',NULL,NULL),(50172,'57553','S','Milesville','D','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.417024,-101.804790,0,'2013-07-06 12:44:33',NULL,NULL),(49900,'57276','S','Bushnell','A','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.385480,-96.626520,0,'2013-07-06 12:44:33',NULL,NULL),(40559,'45858','S','McComb','N','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.105322,-83.806293,0,'2013-07-06 12:44:32',NULL,NULL),(38829,'44084','S','Roaming Shores','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.666663,-80.872296,0,'2013-07-06 12:44:32',NULL,NULL),(37569,'42076','S','New Concord','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.598904,-88.067577,0,'2013-07-06 12:44:32',NULL,NULL),(77958,'97365','S','Newport','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.687599,-124.007012,0,'2013-07-06 12:44:34',NULL,NULL),(13669,'14033','S','Colden','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.657503,-78.685041,0,'2013-07-06 12:44:31',NULL,NULL),(42,'00603','S','Villa Linda','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(70583,'85075','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.498318,-112.213836,0,'2013-07-06 12:44:34',NULL,NULL),(1612,'00769','S','Valle Arriba','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(1143,'00727','S','Chalets de Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(38497,'43697','P','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.644777,-83.543436,0,'2013-07-06 12:44:32',NULL,NULL),(12637,'13103','S','Mallory','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.324996,-76.098694,0,'2013-07-06 12:44:30',NULL,NULL),(73182,'90406','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.018176,-118.497198,0,'2013-07-06 12:44:34',NULL,NULL),(31988,'35220','P','Center Point','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.441667,-86.905801,0,'2013-07-06 12:44:32',NULL,NULL),(68820,'82450','P','Wapiti','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.480556,-109.724470,0,'2013-07-06 12:44:34',NULL,NULL),(48808,'56021','S','Courtland','D','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.260120,-94.338504,0,'2013-07-06 12:44:33',NULL,NULL),(74912,'93383','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.264987,-119.031953,0,'2013-07-06 12:44:34',NULL,NULL),(77435,'96806','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304761,-157.857413,0,'2013-07-06 12:44:34',NULL,NULL),(13947,'14449','P','East Williamson','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.232738,-77.150121,0,'2013-07-06 12:44:31',NULL,NULL),(32345,'35806','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.757300,-86.678606,0,'2013-07-06 12:44:32',NULL,NULL),(8057,'07740','S','Long Branch','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.295596,-73.994230,0,'2013-07-06 12:44:30',NULL,NULL),(28939,'32177','S','Palatka','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.644139,-81.659574,0,'2013-07-06 12:44:32',NULL,NULL),(6996,'06251','P','Mansfield Depot','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.815888,-72.285998,0,'2013-07-06 12:44:30',NULL,NULL),(62119,'73651','S','Hobart','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.024018,-99.091370,0,'2013-07-06 12:44:33',NULL,NULL),(47806,'55053','S','Wheeling','N','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.346698,-93.090205,0,'2013-07-06 12:44:33',NULL,NULL),(31407,'34234','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.369954,-82.528624,0,'2013-07-06 12:44:32',NULL,NULL),(9924,'10151','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764360,-73.976490,0,'2013-07-06 12:44:30',NULL,NULL),(9739,'10090','S','So Pole','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(180,'00623','S','Mansiones','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(67112,'79733','P','Forsan','D','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.111014,-101.365484,0,'2013-07-06 12:44:34',NULL,NULL),(21417,'22539','S','Reedville','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.866249,-76.287053,0,'2013-07-06 12:44:31',NULL,NULL),(50256,'57633','S','Isabel','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.392234,-101.430938,0,'2013-07-06 12:44:33',NULL,NULL),(19190,'19807','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.794880,-75.616740,0,'2013-07-06 12:44:31',NULL,NULL),(35566,'39567','S','Orange Grove','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(35359,'39440','S','Pine Belt Regional Airport','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(30426,'33328','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.066580,-80.272800,0,'2013-07-06 12:44:32',NULL,NULL),(75527,'94164','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.787312,-122.422055,0,'2013-07-06 12:44:34',NULL,NULL),(61861,'73123','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.537598,-97.621042,0,'2013-07-06 12:44:33',NULL,NULL),(21606,'22901','S','Charlottesvle','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.057163,-78.493130,0,'2013-07-06 12:44:31',NULL,NULL),(52738,'61238','S','Cambridge','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.305313,-90.190486,0,'2013-07-06 12:44:33',NULL,NULL),(38020,'43013','S','Croton','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.234813,-82.691307,0,'2013-07-06 12:44:32',NULL,NULL),(11497,'12023','S','South Berne','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.606360,-74.143800,0,'2013-07-06 12:44:30',NULL,NULL),(3735,'02156','P','W Medford','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.424333,-71.132274,0,'2013-07-06 12:44:30',NULL,NULL),(78624,'98204','S','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.898431,-122.254822,0,'2013-07-06 12:44:34',NULL,NULL),(568,'00678','S','Urb El Retiro','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(7365,'06756','S','Goshen','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.845027,-73.229231,0,'2013-07-06 12:44:30',NULL,NULL),(73270,'90731','S','Ft Macarthur','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.743520,-118.279440,0,'2013-07-06 12:44:34',NULL,NULL),(3827,'02330','S','Carver','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.880517,-70.767478,0,'2013-07-06 12:44:30',NULL,NULL),(9699,'10055','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(41188,'46714','S','Villa North','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(31065,'33848','P','Intercession City','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.263539,-81.506217,0,'2013-07-06 12:44:32',NULL,NULL),(31520,'34474','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.156224,-82.196036,0,'2013-07-06 12:44:32',NULL,NULL),(37772,'42347','S','Hartford','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.492020,-86.926080,0,'2013-07-06 12:44:32',NULL,NULL),(62485,'74352','S','Locust Grove','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.199737,-95.167459,0,'2013-07-06 12:44:33',NULL,NULL),(31167,'33918','P','Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(34048,'38137','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.110214,-89.891356,0,'2013-07-06 12:44:32',NULL,NULL),(37038,'41262','S','Milo','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.827120,-82.622820,0,'2013-07-06 12:44:32',NULL,NULL),(818,'00693','S','Urb Los Hucares','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(4193,'02825','S','Foster','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.785822,-71.728016,0,'2013-07-06 12:44:30',NULL,NULL),(48615,'55795','S','Norman','N','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.311725,-92.860123,0,'2013-07-06 12:44:33',NULL,NULL),(12252,'12831','S','Gansevoort','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.198440,-73.678260,0,'2013-07-06 12:44:30',NULL,NULL),(36605,'40977','S','Clear Creek Springs','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(75215,'93634','P','Lakeshore','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.252980,-119.173800,0,'2013-07-06 12:44:34',NULL,NULL),(66755,'79010','P','Valle de Oro','A','Oldham','48359','Texas','TX','48','0320','806','Central',-6.0,'Y',35.433035,-102.442266,0,'2013-07-06 12:44:34',NULL,NULL),(39937,'45227','S','Mariemont','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.156000,-84.371400,0,'2013-07-06 12:44:32',NULL,NULL),(34833,'38920','S','Leverett','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(74184,'92277','S','29 Palms','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.161757,-116.045717,0,'2013-07-06 12:44:34',NULL,NULL),(17389,'17901','S','Becks','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(3566,'01951','S','Plum Island','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.789959,-70.844019,0,'2013-07-06 12:44:30',NULL,NULL),(72292,'88573','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769544,-106.331668,0,'2013-07-06 12:44:34',NULL,NULL),(27986,'30575','S','Talmo','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.220844,-83.731019,0,'2013-07-06 12:44:31',NULL,NULL),(63329,'75573','P','Redwater','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.358117,-94.255285,0,'2013-07-06 12:44:33',NULL,NULL),(32791,'36425','S','Buena Vista','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.746433,-87.105274,0,'2013-07-06 12:44:32',NULL,NULL),(44804,'50234','S','Harvester','A','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.908955,-93.182342,0,'2013-07-06 12:44:32',NULL,NULL),(36425,'40575','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.136382,-84.470769,0,'2013-07-06 12:44:32',NULL,NULL),(25775,'28602','S','Hickory','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.661600,-81.370320,0,'2013-07-06 12:44:31',NULL,NULL),(71859,'87711','S','Dahlia','N','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.084468,-105.060585,0,'2013-07-06 12:44:34',NULL,NULL),(55978,'64620','S','Altamont','D','Daviess','29061','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.932494,-94.078627,0,'2013-07-06 12:44:33',NULL,NULL),(12599,'13078','S','Sentinel Heights','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.967440,-76.060740,0,'2013-07-06 12:44:30',NULL,NULL),(9457,'10007','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(25704,'28537','S','Hobucken','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.270599,-76.539775,0,'2013-07-06 12:44:31',NULL,NULL),(29525,'32779','S','Wekiva Springs','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.705154,-81.420524,0,'2013-07-06 12:44:32',NULL,NULL),(2894,'00987','S','Qtas de Campeche','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(7207,'06488','S','Southbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.472721,-73.220013,0,'2013-07-06 12:44:30',NULL,NULL),(46962,'54202','S','Baileys Hbr','A','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.067316,-87.143147,0,'2013-07-06 12:44:32',NULL,NULL),(17378,'17885','P','Weikert','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.859144,-77.298172,0,'2013-07-06 12:44:31',NULL,NULL),(74530,'92654','P','Laguna Woods','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.604203,-117.715359,0,'2013-07-06 12:44:34',NULL,NULL),(69639,'84005','S','Eagle Mountain','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.352471,-111.983329,0,'2013-07-06 12:44:34',NULL,NULL),(65649,'77974','S','Meyersville','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',28.929757,-97.302624,0,'2013-07-06 12:44:34',NULL,NULL),(24488,'27256','P','Gulf','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.562337,-79.279304,0,'2013-07-06 12:44:31',NULL,NULL),(45785,'52162','S','Frankville','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.045500,-91.566000,0,'2013-07-06 12:44:32',NULL,NULL),(42795,'48048','S','Lenox','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.738060,-82.801020,0,'2013-07-06 12:44:32',NULL,NULL),(40817,'46204','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.774822,-86.158971,0,'2013-07-06 12:44:32',NULL,NULL),(12301,'12851','S','Minerva','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.787706,-73.997818,0,'2013-07-06 12:44:30',NULL,NULL),(54260,'62675','S','Tice','A','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.003483,-89.851315,0,'2013-07-06 12:44:33',NULL,NULL),(26155,'28740','S','Relief','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(21971,'23242','P','Rich','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.619818,-77.613981,0,'2013-07-06 12:44:31',NULL,NULL),(16683,'17365','S','Wellsville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.057136,-76.938746,0,'2013-07-06 12:44:31',NULL,NULL),(35595,'39576','S','Waveland','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.289530,-89.379444,0,'2013-07-06 12:44:32',NULL,NULL),(42405,'47750','U','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.961584,-87.508593,0,'2013-07-06 12:44:32',NULL,NULL),(73125,'90266','S','Manhattan Beach','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.889584,-118.399020,0,'2013-07-06 12:44:34',NULL,NULL),(240,'00637','S','Bda San Isidro','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(79156,'98505','U','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.068915,-122.979513,0,'2013-07-06 12:44:34',NULL,NULL),(11040,'11570','S','Rvc','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.665099,-73.637798,0,'2013-07-06 12:44:30',NULL,NULL),(70095,'84165','P','Ssl','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(27072,'29695','U','Hodges','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.287453,-82.245208,0,'2013-07-06 12:44:31',NULL,NULL),(52159,'60450','S','Morris','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.364155,-88.421363,0,'2013-07-06 12:44:33',NULL,NULL),(15510,'16512','P','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.108958,-79.960153,0,'2013-07-06 12:44:31',NULL,NULL),(49650,'56972','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(34849,'38923','S','Coila','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.371212,-89.976844,0,'2013-07-06 12:44:32',NULL,NULL),(11688,'12155','S','Fergusonville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597180,-74.818920,0,'2013-07-06 12:44:30',NULL,NULL),(43515,'48638','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.422100,-84.013800,0,'2013-07-06 12:44:32',NULL,NULL),(10029,'10172','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(31581,'34653','S','New Pt Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.248579,-82.701991,0,'2013-07-06 12:44:32',NULL,NULL),(15513,'16522','U','Citizens Bank','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.125235,-80.080625,0,'2013-07-06 12:44:31',NULL,NULL),(53016,'61462','S','Ormonde','N','Warren','17187','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.855000,-90.613056,0,'2013-07-06 12:44:33',NULL,NULL),(79426,'98826','S','Winton','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(16794,'17538','S','Salunga','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.100343,-76.427234,0,'2013-07-06 12:44:31',NULL,NULL),(10641,'11096','S','Far Rockaway','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.618459,-73.748859,0,'2013-07-06 12:44:30',NULL,NULL),(17588,'18025','U','Dun & Bradstreet','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.625072,-75.371201,0,'2013-07-06 12:44:31',NULL,NULL),(23454,'25425','S','Bolivar','A','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.338935,-77.777029,0,'2013-07-06 12:44:31',NULL,NULL),(52250,'60518','S','Earlville','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.592720,-88.892220,0,'2013-07-06 12:44:33',NULL,NULL),(16155,'17061','S','Upper Paxton','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(30105,'33159','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.793052,-80.293310,0,'2013-07-06 12:44:32',NULL,NULL),(24913,'27801','S','Rocky Mount','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.954100,-77.751840,0,'2013-07-06 12:44:31',NULL,NULL),(29925,'33063','S','Coconut Creek','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.248973,-80.206871,0,'2013-07-06 12:44:32',NULL,NULL),(19577,'20215','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894207,-77.012508,0,'2013-07-06 12:44:31',NULL,NULL),(40691,'46071','S','Thorntown','D','Boone','18011','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.125801,-86.611995,0,'2013-07-06 12:44:32',NULL,NULL),(34373,'38614','S','Clarksdale','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(58360,'68516','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.752821,-96.645302,0,'2013-07-06 12:44:33',NULL,NULL),(48734,'55962','S','Rushford Vlg','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.774230,-91.848858,0,'2013-07-06 12:44:33',NULL,NULL),(22088,'23401','P','Keller','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.640943,-75.745171,0,'2013-07-06 12:44:31',NULL,NULL),(6120,'05458','S','Pearl','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.717862,-73.300101,0,'2013-07-06 12:44:30',NULL,NULL),(30000,'33122','S','Air Mail Facility','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.799007,-80.300688,0,'2013-07-06 12:44:32',NULL,NULL),(55775,'64117','S','Kansas City North','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.154167,-94.546667,0,'2013-07-06 12:44:33',NULL,NULL),(52871,'61337','S','Malden','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.425406,-89.368028,0,'2013-07-06 12:44:33',NULL,NULL),(25862,'28630','S','Dudley Shoals','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.816100,-81.457140,0,'2013-07-06 12:44:31',NULL,NULL),(2903,'00987','S','Urb Paraiso de Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(47217,'54494','S','Lake Wazeecha','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(21382,'22485','S','King George','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299944,-77.147624,0,'2013-07-06 12:44:31',NULL,NULL),(30918,'33708','S','North Redington Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(12522,'13032','S','Canastota','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083843,-75.768034,0,'2013-07-06 12:44:30',NULL,NULL),(23248,'25118','S','Kimberly','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.124236,-81.324504,0,'2013-07-06 12:44:31',NULL,NULL),(68891,'82718','S','Gillette','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.266688,-105.525118,0,'2013-07-06 12:44:34',NULL,NULL),(52341,'60586','S','Plainfield','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.567700,-88.210600,0,'2013-07-06 12:44:33',NULL,NULL),(58571,'68827','S','Vieregg','N','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.999123,-98.204492,0,'2013-07-06 12:44:33',NULL,NULL),(15232,'16033','S','Evans City','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.790505,-80.043651,0,'2013-07-06 12:44:31',NULL,NULL),(70379,'84660','S','Lake Shore','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(33035,'36738','S','Faunsdale','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.405885,-87.612440,0,'2013-07-06 12:44:32',NULL,NULL),(63182,'75414','S','Bells','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.614156,-96.423406,0,'2013-07-06 12:44:33',NULL,NULL),(62223,'73932','S','Elmwood','A','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.738180,-100.548300,0,'2013-07-06 12:44:33',NULL,NULL),(60931,'72086','S','Furlow','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.788120,-91.948860,0,'2013-07-06 12:44:33',NULL,NULL),(49110,'56347','S','Long Prairie','D','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.863889,-94.918056,0,'2013-07-06 12:44:33',NULL,NULL),(29128,'32318','P','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.440983,-84.281514,0,'2013-07-06 12:44:32',NULL,NULL),(70428,'84732','S','Greenwich','D','Piute','49031','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.288642,-112.066087,0,'2013-07-06 12:44:34',NULL,NULL),(51135,'58830','S','Alamo','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589714,-103.408726,0,'2013-07-06 12:44:33',NULL,NULL),(17698,'18216','S','Coxeville','N','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.929263,-75.912405,0,'2013-07-06 12:44:31',NULL,NULL),(50386,'57763','S','Oelrichs','D','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.179100,-103.232005,0,'2013-07-06 12:44:33',NULL,NULL),(40224,'45413','P','Northridge','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.824011,-84.189799,0,'2013-07-06 12:44:32',NULL,NULL),(13511,'13811','S','Tiona','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.232380,-76.176420,0,'2013-07-06 12:44:31',NULL,NULL),(55046,'63143','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.741558,-90.362467,0,'2013-07-06 12:44:33',NULL,NULL),(23150,'24991','S','Williamsburg','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.951530,-80.512983,0,'2013-07-06 12:44:31',NULL,NULL),(40562,'45860','S','Maria Stein','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.395982,-84.516707,0,'2013-07-06 12:44:32',NULL,NULL),(76014,'95125','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.293628,-121.897822,0,'2013-07-06 12:44:34',NULL,NULL),(3802,'02238','P','Harvard Sq','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.374067,-71.117136,0,'2013-07-06 12:44:30',NULL,NULL),(52735,'61236','P','Barstow','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.516890,-90.371243,0,'2013-07-06 12:44:33',NULL,NULL),(42362,'47705','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.955129,-87.558210,0,'2013-07-06 12:44:32',NULL,NULL),(51807,'60048','S','Mettawa','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.293735,-87.944893,0,'2013-07-06 12:44:33',NULL,NULL),(50120,'57501','S','Wendt','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(16237,'17078','S','N Londonderry','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299264,-76.586642,0,'2013-07-06 12:44:31',NULL,NULL),(26633,'29330','S','Cowpens','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.030555,-81.817377,0,'2013-07-06 12:44:31',NULL,NULL),(68161,'81005','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.233107,-104.710769,0,'2013-07-06 12:44:34',NULL,NULL),(61374,'72524','S','Cord','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.830770,-91.348165,0,'2013-07-06 12:44:33',NULL,NULL),(12973,'13367','S','Watson','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(68469,'81237','S','Ohio City','D','Gunnison','08051','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.579635,-106.579304,0,'2013-07-06 12:44:34',NULL,NULL),(64993,'77284','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.755455,-95.367866,0,'2013-07-06 12:44:34',NULL,NULL),(59803,'71223','S','Bonita','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.901055,-91.680149,0,'2013-07-06 12:44:33',NULL,NULL),(69370,'83604','S','Bruneau Valley','N','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.681724,-115.929733,0,'2013-07-06 12:44:34',NULL,NULL),(79315,'98599','U','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.997332,-122.874737,0,'2013-07-06 12:44:34',NULL,NULL),(78403,'98035','P','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.385642,-122.201891,0,'2013-07-06 12:44:34',NULL,NULL),(54022,'62454','S','New Hebron','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(51992,'60159','P','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.036623,-88.083304,0,'2013-07-06 12:44:33',NULL,NULL),(30909,'33707','S','Pasadena','N','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(20702,'21252','U','Towson State University','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.394959,-76.612936,0,'2013-07-06 12:44:31',NULL,NULL),(11223,'11749','S','Hauppauge','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.809863,-73.179536,0,'2013-07-06 12:44:30',NULL,NULL),(57829,'67530','S','Heizer','A','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.368828,-98.776747,0,'2013-07-06 12:44:33',NULL,NULL),(17470,'17948','S','Park Place','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(66278,'78582','S','El Sauz','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(76924,'96011','P','Big Bend','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.969670,-122.000419,0,'2013-07-06 12:44:34',NULL,NULL),(23346,'25259','S','Linden','A','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.665790,-81.296596,0,'2013-07-06 12:44:31',NULL,NULL),(59348,'70558','P','Milton','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.103997,-92.077768,0,'2013-07-06 12:44:33',NULL,NULL),(76019,'95130','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.289556,-121.975824,0,'2013-07-06 12:44:34',NULL,NULL),(1789,'00783','S','Ext Sylvia','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(28135,'30817','S','Sybert','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(39326,'44612','S','Bolivar','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.643022,-81.442740,0,'2013-07-06 12:44:32',NULL,NULL),(17218,'17824','S','Reeders Grove','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(12754,'13206','S','Eastwood','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.070202,-76.106706,0,'2013-07-06 12:44:30',NULL,NULL),(72235,'88511','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.808327,-106.417641,0,'2013-07-06 12:44:34',NULL,NULL),(59254,'70444','S','New Zion','A','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.936684,-90.517939,0,'2013-07-06 12:44:33',NULL,NULL),(52358,'60610','S','Fort Dearborn','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.898992,-87.636455,0,'2013-07-06 12:44:33',NULL,NULL),(48323,'55447','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.000722,-93.488055,0,'2013-07-06 12:44:33',NULL,NULL),(5062,'04276','S','Rumford Point','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.546376,-70.554444,0,'2013-07-06 12:44:30',NULL,NULL),(36974,'41179','S','Kinniconick','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(37058,'41301','S','Valeria','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(70700,'85264','S','Scottsdale','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.625402,-111.662260,0,'2013-07-06 12:44:34',NULL,NULL),(7543,'07010','S','Cliffside Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.819853,-73.988554,0,'2013-07-06 12:44:30',NULL,NULL),(63944,'76078','S','Rhome','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.046961,-97.472602,0,'2013-07-06 12:44:34',NULL,NULL),(18973,'19518','S','Worman','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(17756,'18327','P','De Water Gap','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.988659,-75.147989,0,'2013-07-06 12:44:31',NULL,NULL),(44749,'50169','S','Mitchellville','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.665549,-93.367550,0,'2013-07-06 12:44:32',NULL,NULL),(52942,'61401','S','Henderson Grove','N','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.949094,-90.369290,0,'2013-07-06 12:44:33',NULL,NULL),(72516,'89156','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.224390,-115.026222,0,'2013-07-06 12:44:34',NULL,NULL),(29968,'33082','P','Pembroke Pines','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.013469,-80.203516,0,'2013-07-06 12:44:32',NULL,NULL),(23227,'25083','S','Whittaker','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(54694,'62950','S','Degognia','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.747337,-89.546002,0,'2013-07-06 12:44:33',NULL,NULL),(53549,'62044','S','Fayette','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.340418,-90.214125,0,'2013-07-06 12:44:33',NULL,NULL),(42932,'48116','S','Brighton Twp','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.532103,-83.773187,0,'2013-07-06 12:44:32',NULL,NULL),(57025,'66207','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(76724,'95867','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584856,-121.493723,0,'2013-07-06 12:44:34',NULL,NULL),(7024,'06263','P','Rogers','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.838480,-71.904924,0,'2013-07-06 12:44:30',NULL,NULL),(58176,'68305','S','Glenrock','N','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.390284,-95.842607,0,'2013-07-06 12:44:33',NULL,NULL),(39807,'45140','S','Murdock','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(44297,'49728','S','Strongs','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.332529,-85.176969,0,'2013-07-06 12:44:32',NULL,NULL),(62662,'74637','S','Fairfax','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.570143,-96.705536,0,'2013-07-06 12:44:33',NULL,NULL),(23633,'25729','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.399173,-82.448689,0,'2013-07-06 12:44:31',NULL,NULL),(26451,'29137','S','Perry','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.637039,-81.295434,0,'2013-07-06 12:44:31',NULL,NULL),(58086,'68072','P','Winslow','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.608193,-96.505496,0,'2013-07-06 12:44:33',NULL,NULL),(57330,'66713','S','Big Elk','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.022713,-94.739150,0,'2013-07-06 12:44:33',NULL,NULL),(53680,'62221','S','Rentchler','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.550823,-89.984437,0,'2013-07-06 12:44:33',NULL,NULL),(10498,'10960','S','Upper Nyack','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(37368,'41731','S','Cornettsville','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.124133,-83.036516,0,'2013-07-06 12:44:32',NULL,NULL),(28612,'31705','S','Radium Springs','N','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.558731,-84.090313,0,'2013-07-06 12:44:32',NULL,NULL),(45050,'50484','S','Woden','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.229647,-93.907928,0,'2013-07-06 12:44:32',NULL,NULL),(227,'00624','S','Villa Esmeralda','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(9549,'10022','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(44331,'49757','P','Mackinac Island','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.859701,-84.615503,0,'2013-07-06 12:44:32',NULL,NULL),(29909,'33052','P','Marathon Shrs','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.724766,-81.062436,0,'2013-07-06 12:44:32',NULL,NULL),(70457,'84753','S','Modena','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.798279,-113.906685,0,'2013-07-06 12:44:34',NULL,NULL),(51062,'58746','S','Spencer','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678244,-102.068686,0,'2013-07-06 12:44:33',NULL,NULL),(43519,'48647','S','Mio','D','Oscoda','26135','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.659301,-84.115729,0,'2013-07-06 12:44:32',NULL,NULL),(35537,'39561','S','Mc Henry','D','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.688163,-89.180838,0,'2013-07-06 12:44:32',NULL,NULL),(35986,'40119','S','Glen Dean','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.587960,-86.493600,0,'2013-07-06 12:44:32',NULL,NULL),(13828,'14218','S','Lackawanna','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.810099,-78.781921,0,'2013-07-06 12:44:31',NULL,NULL),(59688,'71070','S','Saline','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.118780,-92.975340,0,'2013-07-06 12:44:33',NULL,NULL),(8746,'08527','S','Jackson','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.106820,-74.341020,0,'2013-07-06 12:44:30',NULL,NULL),(51532,'59718','S','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.646519,-111.204847,0,'2013-07-06 12:44:33',NULL,NULL),(22646,'24260','S','Putnam','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.029515,-82.003511,0,'2013-07-06 12:44:31',NULL,NULL),(20464,'21030','S','Hunt Valley','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.491520,-76.660860,0,'2013-07-06 12:44:31',NULL,NULL),(14509,'15202','S','Avalon','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(18821,'19408','P','Eagleville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.154128,-75.414151,0,'2013-07-06 12:44:31',NULL,NULL),(72487,'89133','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.205255,-115.250871,0,'2013-07-06 12:44:34',NULL,NULL),(70863,'85602','S','Redington','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.965389,-110.296656,0,'2013-07-06 12:44:34',NULL,NULL),(65867,'78214','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.365513,-98.487443,0,'2013-07-06 12:44:34',NULL,NULL),(64043,'76129','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.705900,-97.359380,0,'2013-07-06 12:44:34',NULL,NULL),(35529,'39553','S','Iowana','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400064,-88.643006,0,'2013-07-06 12:44:32',NULL,NULL),(28909,'32138','P','Grandin','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.724316,-81.919683,0,'2013-07-06 12:44:32',NULL,NULL),(64346,'76518','S','South Elm','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.894745,-97.123059,0,'2013-07-06 12:44:34',NULL,NULL),(7287,'06534','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.318581,-72.927510,0,'2013-07-06 12:44:30',NULL,NULL),(67157,'79788','P','Wickett','D','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.565637,-103.005351,0,'2013-07-06 12:44:34',NULL,NULL),(72896,'90019','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.048281,-118.342487,0,'2013-07-06 12:44:34',NULL,NULL),(45158,'50588','S','West Storm Lake','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(28129,'30817','S','Honora','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(17742,'18302','S','East Stroudsburg','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024159,-75.185836,0,'2013-07-06 12:44:31',NULL,NULL),(68353,'81132','S','Summitville','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(64397,'76539','S','Kempner','D','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.080030,-98.000076,0,'2013-07-06 12:44:34',NULL,NULL),(8837,'08629','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218249,-74.730652,0,'2013-07-06 12:44:30',NULL,NULL),(6792,'06107','S','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.756512,-72.758753,0,'2013-07-06 12:44:30',NULL,NULL),(59785,'71212','U','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.510013,-92.120718,0,'2013-07-06 12:44:33',NULL,NULL),(8262,'08008','S','North Beach','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(39176,'44312','S','Ellet','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.029977,-81.439236,0,'2013-07-06 12:44:32',NULL,NULL),(41496,'46951','S','Nyona Lake','N','Miami','18103','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.968780,-86.126400,0,'2013-07-06 12:44:32',NULL,NULL),(41674,'47165','S','Pekin','D','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.397297,-85.994776,0,'2013-07-06 12:44:32',NULL,NULL),(58356,'68509','P','State House','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.816704,-96.709171,0,'2013-07-06 12:44:33',NULL,NULL),(43049,'48183','S','Brownstown TWP','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(18141,'18832','S','Monroeton','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.713247,-76.471178,0,'2013-07-06 12:44:31',NULL,NULL),(23237,'25107','S','Hernshaw','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.203334,-81.612435,0,'2013-07-06 12:44:31',NULL,NULL),(30957,'33734','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.805743,-82.647994,0,'2013-07-06 12:44:32',NULL,NULL),(56012,'64655','S','Lucerne','D','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.430295,-93.284993,0,'2013-07-06 12:44:33',NULL,NULL),(34630,'38756','S','Long','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(32568,'36115','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405177,-86.250295,0,'2013-07-06 12:44:32',NULL,NULL),(75711,'94576','S','Deer Park','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.529291,-122.468362,0,'2013-07-06 12:44:34',NULL,NULL),(58326,'68450','S','Graf','N','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.369300,-96.193526,0,'2013-07-06 12:44:33',NULL,NULL),(74570,'92688','S','Rancho Sta Marg','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.651232,-117.593834,0,'2013-07-06 12:44:34',NULL,NULL),(11285,'11773','U','Publishers Clearing House','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.828208,-73.503625,0,'2013-07-06 12:44:30',NULL,NULL),(31127,'33903','S','N Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(32060,'35266','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(42762,'48033','S','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248','Eastern',-5.0,'Y',42.472345,-83.293971,0,'2013-07-06 12:44:32',NULL,NULL),(32874,'36523','S','Mon Louis','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.387102,-88.167787,0,'2013-07-06 12:44:32',NULL,NULL),(75995,'95101','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.385199,-121.896535,0,'2013-07-06 12:44:34',NULL,NULL),(30751,'33559','S','Lutz','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.165438,-82.407004,0,'2013-07-06 12:44:32',NULL,NULL),(62877,'75046','P','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.918699,-96.644353,0,'2013-07-06 12:44:33',NULL,NULL),(22465,'24040','U','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.277095,-79.934639,0,'2013-07-06 12:44:31',NULL,NULL),(21783,'23068','S','Hallieford','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.494525,-76.341224,0,'2013-07-06 12:44:31',NULL,NULL),(45232,'50647','S','Janesville','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.632632,-92.495481,0,'2013-07-06 12:44:32',NULL,NULL),(50893,'58538','S','Ft Yates','N','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.075961,-100.641076,0,'2013-07-06 12:44:33',NULL,NULL),(18802,'19401','S','Black Horse','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.130580,-75.347520,0,'2013-07-06 12:44:31',NULL,NULL),(69333,'83530','S','Grangeville','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.929393,-116.118593,0,'2013-07-06 12:44:34',NULL,NULL),(80162,'99812','U','State Of Alaska  Brm','N','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.475528,-134.149850,0,'2013-07-06 12:44:34',NULL,NULL),(25595,'28449','S','Kure Beach','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.997171,-77.909349,0,'2013-07-06 12:44:31',NULL,NULL),(69604,'83854','S','State Line','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.740920,-116.944800,0,'2013-07-06 12:44:34',NULL,NULL),(17705,'18224','S','Freeland','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.016460,-75.898898,0,'2013-07-06 12:44:31',NULL,NULL),(59772,'71201','S','Lamkin','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(52177,'60460','S','Odell','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.005650,-88.522179,0,'2013-07-06 12:44:33',NULL,NULL),(31130,'33903','S','No Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(10890,'11423','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.716723,-73.768410,0,'2013-07-06 12:44:30',NULL,NULL),(21291,'22350','U','DOD','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853006,-77.123393,0,'2013-07-06 12:44:31',NULL,NULL),(31109,'33885','P','Florence Villa','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.053367,-81.712064,0,'2013-07-06 12:44:32',NULL,NULL),(64547,'76652','S','Brazos Point','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.121465,-97.581963,0,'2013-07-06 12:44:34',NULL,NULL),(41258,'46747','S','Gravel Beach','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.531111,-85.170278,0,'2013-07-06 12:44:32',NULL,NULL),(54723,'62962','S','Miller City','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.086225,-89.352866,0,'2013-07-06 12:44:33',NULL,NULL),(55477,'63750','S','Gipsy','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.131004,-90.199333,0,'2013-07-06 12:44:33',NULL,NULL),(56228,'65041','S','Swiss','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.697938,-91.437726,0,'2013-07-06 12:44:33',NULL,NULL),(75421,'94027','S','Atherton','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.456184,-122.204497,0,'2013-07-06 12:44:34',NULL,NULL),(74689,'92885','P','Yorba Linda','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.891091,-117.822191,0,'2013-07-06 12:44:34',NULL,NULL),(32253,'35616','S','Cherokee','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.718885,-88.000065,0,'2013-07-06 12:44:32',NULL,NULL),(30552,'33411','S','Ryl Palm Bch','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(62634,'74559','P','Panola','D','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.928265,-95.211064,0,'2013-07-06 12:44:33',NULL,NULL),(50945,'58579','S','Wilton','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.158773,-100.783228,0,'2013-07-06 12:44:33',NULL,NULL),(23080,'24894','P','Warriormine','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.291751,-81.696432,0,'2013-07-06 12:44:31',NULL,NULL),(11251,'11762','S','Massapequa Pk','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.683043,-73.446969,0,'2013-07-06 12:44:30',NULL,NULL),(8690,'08344','S','Willow Grove','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.563197,-74.980592,0,'2013-07-06 12:44:30',NULL,NULL),(17176,'17815','S','Espy','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(16993,'17728','S','Lycoming','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(68513,'81326','S','Redmesa','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.215884,-108.087279,0,'2013-07-06 12:44:34',NULL,NULL),(51630,'59853','S','Noxon','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.038456,-115.821818,0,'2013-07-06 12:44:33',NULL,NULL),(3764,'02187','P','Milton Village','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.260688,-71.078672,0,'2013-07-06 12:44:30',NULL,NULL),(20247,'20782','S','Chillum','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(33116,'36863','S','Lanett','D','Chambers','01017','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.868458,-85.239722,0,'2013-07-06 12:44:32',NULL,NULL),(77771,'97119','S','Gaston','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.403981,-123.149289,0,'2013-07-06 12:44:34',NULL,NULL),(78161,'97625','S','Klamath Falls','A','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.260580,-121.658400,0,'2013-07-06 12:44:34',NULL,NULL),(64334,'76502','S','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.090167,-97.379055,0,'2013-07-06 12:44:34',NULL,NULL),(15595,'16667','S','St Clrsville','A','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.160648,-78.508616,0,'2013-07-06 12:44:31',NULL,NULL),(6178,'05474','S','Lagrange','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(10407,'10610','P','White Plains','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.022482,-73.812614,0,'2013-07-06 12:44:30',NULL,NULL),(19495,'20158','S','Hamilton','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.129310,-77.659616,0,'2013-07-06 12:44:31',NULL,NULL),(29115,'32309','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.597156,-84.041559,0,'2013-07-06 12:44:32',NULL,NULL),(50178,'57559','S','Murdo','D','Jones','46075','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.958192,-100.699101,0,'2013-07-06 12:44:33',NULL,NULL),(51727,'60010','S','Timber Lake','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(21849,'23139','S','Macon','A','Powhatan','51145','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.544219,-77.877814,0,'2013-07-06 12:44:31',NULL,NULL),(47876,'55087','S','Warsaw','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.241970,-93.399857,0,'2013-07-06 12:44:33',NULL,NULL),(38039,'43033','P','Kirkersville','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.960707,-82.602939,0,'2013-07-06 12:44:32',NULL,NULL),(69143,'83303','P','Twin Falls','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.560847,-114.464815,0,'2013-07-06 12:44:34',NULL,NULL),(6740,'06080','U','McDougal Correctional Fclty','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.982198,-72.649731,0,'2013-07-06 12:44:30',NULL,NULL),(25730,'28551','S','La Grange','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.307956,-77.789886,0,'2013-07-06 12:44:31',NULL,NULL),(7361,'06754','S','Cornwall Brg','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.770620,-73.367400,0,'2013-07-06 12:44:30',NULL,NULL),(49503,'56667','S','Alaska','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.746320,-95.006220,0,'2013-07-06 12:44:33',NULL,NULL),(46598,'53553','S','Linden','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.918177,-90.276860,0,'2013-07-06 12:44:32',NULL,NULL),(14747,'15317','S','Mc Murray','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.269407,-80.150995,0,'2013-07-06 12:44:31',NULL,NULL),(14701,'15261','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441907,-79.956393,0,'2013-07-06 12:44:31',NULL,NULL),(13159,'13607','S','Alexandra Bay','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(41678,'47170','S','Scottsburg','D','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.685010,-85.777663,0,'2013-07-06 12:44:32',NULL,NULL),(74058,'92159','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.806702,-117.025920,0,'2013-07-06 12:44:34',NULL,NULL),(4954,'04103','S','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.686849,-70.291333,0,'2013-07-06 12:44:30',NULL,NULL),(43527,'48656','S','Saint Helen','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.364342,-84.430308,0,'2013-07-06 12:44:32',NULL,NULL),(25024,'27889','S','Wash','N','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.549639,-77.039376,0,'2013-07-06 12:44:31',NULL,NULL),(44197,'49620','S','Buckley','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.548612,-85.716975,0,'2013-07-06 12:44:32',NULL,NULL),(47027,'54344','U','Employers Hlt Ins Co','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.419190,-88.104737,0,'2013-07-06 12:44:32',NULL,NULL),(45942,'52341','S','Toddville','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.108842,-91.736923,0,'2013-07-06 12:44:32',NULL,NULL),(39576,'44855','S','N Fairfield','A','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.103830,-82.597828,0,'2013-07-06 12:44:32',NULL,NULL),(19416,'20088','P','Friendship Heights','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.965266,-77.055986,0,'2013-07-06 12:44:31',NULL,NULL),(28100,'30752','S','Trenton','D','Dade','13083','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.870608,-85.508537,0,'2013-07-06 12:44:31',NULL,NULL),(67646,'80467','S','Oak Creek','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.263177,-106.887857,0,'2013-07-06 12:44:34',NULL,NULL),(59074,'70114','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.930760,-90.032820,0,'2013-07-06 12:44:33',NULL,NULL),(21478,'22641','S','Strasburg','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.062322,-78.362403,0,'2013-07-06 12:44:31',NULL,NULL),(47930,'55113','S','Falcon Hgts','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(29635,'32891','U','Suntrust Service Corporation','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.556599,-81.349587,0,'2013-07-06 12:44:32',NULL,NULL),(42252,'47576','S','St Croix','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.227647,-86.609796,0,'2013-07-06 12:44:32',NULL,NULL),(76226,'95377','S','Tracy','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.718503,-121.453328,0,'2013-07-06 12:44:34',NULL,NULL),(9557,'10024','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(53442,'61875','S','Seymour','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.159817,-88.434465,0,'2013-07-06 12:44:33',NULL,NULL),(18483,'19088','U','Tv Guide','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.048256,-75.355995,0,'2013-07-06 12:44:31',NULL,NULL),(57271,'66547','S','Louisvle','N','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.211156,-96.316796,0,'2013-07-06 12:44:33',NULL,NULL),(33341,'37166','S','Smithville','D','DeKalb','47041','Tennessee','TN','47','0000','615','Central',-6.0,'Y',35.958669,-85.824729,0,'2013-07-06 12:44:32',NULL,NULL),(51395,'59424','S','Coffee Creek','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.350313,-110.085182,0,'2013-07-06 12:44:33',NULL,NULL),(50647,'58317','S','Bisbee','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.624825,-99.379428,0,'2013-07-06 12:44:33',NULL,NULL),(71462,'87052','S','Santo Domingo Pueblo','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.533365,-106.392193,0,'2013-07-06 12:44:34',NULL,NULL),(58874,'69155','S','Sarben','N','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.211049,-101.375901,0,'2013-07-06 12:44:33',NULL,NULL),(39192,'44325','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.076672,-81.510338,0,'2013-07-06 12:44:32',NULL,NULL),(4689,'03809','S','Alton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.473210,-71.240373,0,'2013-07-06 12:44:30',NULL,NULL),(4045,'02632','S','Centerville','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.657957,-70.344642,0,'2013-07-06 12:44:30',NULL,NULL),(358,'00659','S','Est De Carrizales','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(29436,'32692','P','Suwanee','N','Dixie','12029','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.327937,-83.145284,0,'2013-07-06 12:44:32',NULL,NULL),(5910,'05201','S','Old Bennington','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.879586,-73.197676,0,'2013-07-06 12:44:30',NULL,NULL),(60468,'71654','S','Trippe','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.656460,-91.408020,0,'2013-07-06 12:44:33',NULL,NULL),(4868,'04029','S','East Sebago','N','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.888056,-70.632500,0,'2013-07-06 12:44:30',NULL,NULL),(24385,'27099','U','Rural Hall','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.228578,-80.303201,0,'2013-07-06 12:44:31',NULL,NULL),(20810,'21601','S','Easton','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.773948,-76.069080,0,'2013-07-06 12:44:31',NULL,NULL),(32596,'36131','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.379353,-86.298504,0,'2013-07-06 12:44:32',NULL,NULL),(62754,'74848','S','Horntown','A','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.083745,-96.399050,0,'2013-07-06 12:44:33',NULL,NULL),(59875,'71268','S','Union Church','N','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.363260,-92.650820,0,'2013-07-06 12:44:33',NULL,NULL),(30478,'33348','P','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.187318,-80.108851,0,'2013-07-06 12:44:32',NULL,NULL),(39238,'44427','S','Kensington','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.732793,-80.953074,0,'2013-07-06 12:44:32',NULL,NULL),(14791,'15364','S','Sycamore','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.952121,-80.224504,0,'2013-07-06 12:44:31',NULL,NULL),(75120,'93550','S','Lake Los Angeles','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.568461,-118.062387,0,'2013-07-06 12:44:34',NULL,NULL),(43950,'49302','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.829750,-85.422188,0,'2013-07-06 12:44:32',NULL,NULL),(58623,'68861','S','Odessa','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.711415,-99.262025,0,'2013-07-06 12:44:33',NULL,NULL),(73943,'92054','S','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.205217,-117.352732,0,'2013-07-06 12:44:34',NULL,NULL),(23010,'24817','P','Bradshaw','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.354998,-81.798608,0,'2013-07-06 12:44:31',NULL,NULL),(29145,'32331','S','Greenville','D','Madison','12079','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.468234,-83.631594,0,'2013-07-06 12:44:32',NULL,NULL),(11668,'12141','P','Quaker Street','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.732998,-74.186598,0,'2013-07-06 12:44:30',NULL,NULL),(62228,'73942','S','Guymon','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.684157,-101.479147,0,'2013-07-06 12:44:33',NULL,NULL),(49547,'56686','S','Lude','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.977222,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(51497,'59634','S','Clancy','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.495380,-111.967500,0,'2013-07-06 12:44:33',NULL,NULL),(75955,'95043','S','San Benito','N','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.548040,-121.016280,0,'2013-07-06 12:44:34',NULL,NULL),(23142,'24984','S','Waiteville','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.464502,-80.460659,0,'2013-07-06 12:44:31',NULL,NULL),(54629,'62918','S','Hafer','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.789020,-89.096520,0,'2013-07-06 12:44:33',NULL,NULL),(11262,'11768','S','Fort Salonga','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(73547,'91358','P','Thousand Oaks','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.178907,-118.874405,0,'2013-07-06 12:44:34',NULL,NULL),(76374,'95521','S','Arcata','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.928760,-124.060080,0,'2013-07-06 12:44:34',NULL,NULL),(44415,'49831','S','Northland','N','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.998379,-87.826892,0,'2013-07-06 12:44:32',NULL,NULL),(1512,'00754','S','Ext Jard de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(54588,'62901','S','Carbondale','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(53651,'62205','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(29686,'32926','S','Cocoa','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.387668,-80.791132,0,'2013-07-06 12:44:32',NULL,NULL),(43804,'49063','P','Lacota','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.413544,-86.131234,0,'2013-07-06 12:44:32',NULL,NULL),(23969,'26298','P','Bergoo','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.474069,-80.329775,0,'2013-07-06 12:44:31',NULL,NULL),(13304,'13669','S','Ogdensburg','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.666280,-75.499440,0,'2013-07-06 12:44:30',NULL,NULL),(77442,'96808','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304528,-157.859432,0,'2013-07-06 12:44:34',NULL,NULL),(80090,'99742','P','Gambell','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.508354,-171.429044,0,'2013-07-06 12:44:34',NULL,NULL),(18488,'19090','S','Willow Grove','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.145928,-75.122767,0,'2013-07-06 12:44:31',NULL,NULL),(15831,'16935','S','Keeneyville','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(34318,'38555','S','Fairfld Glde','A','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951220,-85.029780,0,'2013-07-06 12:44:32',NULL,NULL),(79810,'99501','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.218665,-149.867089,0,'2013-07-06 12:44:34',NULL,NULL),(75186,'93610','S','Sharon','N','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.110099,-120.262938,0,'2013-07-06 12:44:34',NULL,NULL),(62952,'75109','S','Corsicana','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.091381,-96.474504,0,'2013-07-06 12:44:33',NULL,NULL),(16718,'17406','S','Hallam','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(14456,'15108','S','Carpolis','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.510530,-80.182409,0,'2013-07-06 12:44:31',NULL,NULL),(53401,'61830','S','Cisco','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985463,-88.678689,0,'2013-07-06 12:44:33',NULL,NULL),(23830,'26104','S','North Parkersburg','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.286068,-81.526137,0,'2013-07-06 12:44:31',NULL,NULL),(22706,'24343','S','Hillsville','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.764206,-80.736826,0,'2013-07-06 12:44:31',NULL,NULL),(53017,'61465','S','New Windsor','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.201390,-90.439906,0,'2013-07-06 12:44:33',NULL,NULL),(45180,'50608','S','Austinville','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.599205,-92.965967,0,'2013-07-06 12:44:32',NULL,NULL),(52962,'61421','S','Osceola','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.177575,-89.653011,0,'2013-07-06 12:44:33',NULL,NULL),(68060,'80933','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.934825,-105.004782,0,'2013-07-06 12:44:34',NULL,NULL),(54418,'62833','S','Ellery','D','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.357770,-88.133643,0,'2013-07-06 12:44:33',NULL,NULL),(24038,'26408','S','Craigmoore','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.199128,-80.270155,0,'2013-07-06 12:44:31',NULL,NULL),(7581,'07032','S','Kearny','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.762320,-74.123220,0,'2013-07-06 12:44:30',NULL,NULL),(49689,'57024','S','Egan','D','Moody','46101','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.999147,-96.642860,0,'2013-07-06 12:44:33',NULL,NULL),(51483,'59601','S','Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.625304,-112.009553,0,'2013-07-06 12:44:33',NULL,NULL),(24622,'27350','S','Sophia','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.817055,-79.892763,0,'2013-07-06 12:44:31',NULL,NULL),(18511,'19102','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952547,-75.163950,0,'2013-07-06 12:44:31',NULL,NULL),(59511,'70784','P','Wakefield','D','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.886627,-91.353153,0,'2013-07-06 12:44:33',NULL,NULL),(24415,'27120','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.107889,-80.240590,0,'2013-07-06 12:44:31',NULL,NULL),(61321,'72443','S','Marmaduke','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.190078,-90.383190,0,'2013-07-06 12:44:33',NULL,NULL),(50633,'58276','S','Saint Thomas','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629700,-97.469949,0,'2013-07-06 12:44:33',NULL,NULL),(487,'00670','S','Las Marias','D','Las Marias','72083','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.296381,-67.146608,0,'2013-07-06 12:44:30',NULL,NULL),(43677,'48867','S','Owosso','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.004634,-84.184189,0,'2013-07-06 12:44:32',NULL,NULL),(80017,'99680','P','Bethel','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.360000,-162.630000,0,'2013-07-06 12:44:34',NULL,NULL),(16640,'17339','S','Pinetown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.126080,-76.876560,0,'2013-07-06 12:44:31',NULL,NULL),(67128,'79752','S','Mc Camey','D','Upton','48461','Texas','TX','48','0000','432','Central',-6.0,'Y',31.131143,-102.220417,0,'2013-07-06 12:44:34',NULL,NULL),(65755,'78065','S','Poteet','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',29.131280,-98.534502,0,'2013-07-06 12:44:34',NULL,NULL),(8477,'08091','S','West Berlin','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.815979,-74.940718,0,'2013-07-06 12:44:30',NULL,NULL),(14511,'15202','S','Bellvue','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(3791,'02212','U','Bank of America','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.355722,-71.055772,0,'2013-07-06 12:44:30',NULL,NULL),(57595,'67104','S','Medicine Ldg','A','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.283493,-98.578275,0,'2013-07-06 12:44:33',NULL,NULL),(73372,'91031','P','South Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.117536,-118.151757,0,'2013-07-06 12:44:34',NULL,NULL),(47547,'54827','S','Cornucopia','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.853475,-91.092584,0,'2013-07-06 12:44:32',NULL,NULL),(43427,'48471','S','Sandusky','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.420077,-82.851553,0,'2013-07-06 12:44:32',NULL,NULL),(32662,'36258','S','Fishhead','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.454247,-85.684409,0,'2013-07-06 12:44:32',NULL,NULL),(77577,'96913','S','Tiyan','N','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(43590,'48755','S','Sand Point','A','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.854179,-83.289645,0,'2013-07-06 12:44:32',NULL,NULL),(39043,'44149','S','Strongsville','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.308372,-81.856213,0,'2013-07-06 12:44:32',NULL,NULL),(27609,'30303','S','Georgia State University','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.750591,-84.387699,0,'2013-07-06 12:44:31',NULL,NULL),(71526,'87123','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.073228,-106.504635,0,'2013-07-06 12:44:34',NULL,NULL),(34635,'38761','S','Moorhead','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.449634,-90.504159,0,'2013-07-06 12:44:32',NULL,NULL),(45395,'51034','S','Mapleton','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.160798,-95.806022,0,'2013-07-06 12:44:32',NULL,NULL),(25426,'28304','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.029744,-78.970982,0,'2013-07-06 12:44:31',NULL,NULL),(58867,'69153','S','Ogallala','D','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.154960,-101.677440,0,'2013-07-06 12:44:33',NULL,NULL),(49593,'56750','S','Red Lake Falls','D','Red Lake','27125','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.882061,-96.271559,0,'2013-07-06 12:44:33',NULL,NULL),(46754,'53931','P','Fairwater','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.744890,-88.865140,0,'2013-07-06 12:44:32',NULL,NULL),(17098,'17765','S','Roaring Brnch','A','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(32838,'36480','S','Chrysler','N','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.326580,-87.605287,0,'2013-07-06 12:44:32',NULL,NULL),(40404,'45678','S','Scottown','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.612469,-82.397919,0,'2013-07-06 12:44:32',NULL,NULL),(35797,'39753','P','Mayhew','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.448130,-88.481457,0,'2013-07-06 12:44:32',NULL,NULL),(78279,'97865','S','Mt Vernon','N','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.420455,-119.113641,0,'2013-07-06 12:44:34',NULL,NULL),(117,'00612','S','Urb University Gdns','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(69126,'83283','S','Grace','A','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.387191,-111.717415,0,'2013-07-06 12:44:34',NULL,NULL),(68906,'82732','P','Wright','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.291111,-105.501667,0,'2013-07-06 12:44:34',NULL,NULL),(67065,'79566','S','Shep','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',32.017027,-100.147498,0,'2013-07-06 12:44:34',NULL,NULL),(63461,'75684','S','Pitner Junction','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(7587,'07035','S','Lincoln Park','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.924465,-74.302643,0,'2013-07-06 12:44:30',NULL,NULL),(18502,'19098','U','National Fulfillment Serv','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.904384,-75.308537,0,'2013-07-06 12:44:31',NULL,NULL),(29156,'32345','P','Monticello','D','Jefferson','12065','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.544019,-83.872485,0,'2013-07-06 12:44:32',NULL,NULL),(57892,'67639','S','Glade','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.644062,-99.288625,0,'2013-07-06 12:44:33',NULL,NULL),(21649,'22935','S','St George','A','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.264055,-78.574641,0,'2013-07-06 12:44:31',NULL,NULL),(37588,'42101','S','Hadley','A','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.018172,-86.458733,0,'2013-07-06 12:44:32',NULL,NULL),(64339,'76508','U','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.092892,-97.364817,0,'2013-07-06 12:44:34',NULL,NULL),(57487,'66933','S','Barnes','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.654157,-96.862314,0,'2013-07-06 12:44:33',NULL,NULL),(52802,'61277','S','Portland','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(15424,'16366','U','Warren','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843956,-79.141103,0,'2013-07-06 12:44:31',NULL,NULL),(15609,'16679','S','Six Mile Run','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.154383,-78.202269,0,'2013-07-06 12:44:31',NULL,NULL),(15845,'16938','S','Lorenton','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(71669,'87506','S','Jaconita','A','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.585314,-106.024436,0,'2013-07-06 12:44:34',NULL,NULL),(19460,'20130','S','Paris','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.035313,-77.943225,0,'2013-07-06 12:44:31',NULL,NULL),(73712,'91611','U','Us Purchasing Exchange','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186474,-118.395745,0,'2013-07-06 12:44:34',NULL,NULL),(67265,'79976','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.817144,-106.442286,0,'2013-07-06 12:44:34',NULL,NULL),(59494,'70769','S','Lake','N','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.311773,-90.937896,0,'2013-07-06 12:44:33',NULL,NULL),(55014,'63133','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.678252,-90.305602,0,'2013-07-06 12:44:33',NULL,NULL),(7742,'07303','P','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.717652,-74.045298,0,'2013-07-06 12:44:30',NULL,NULL),(20509,'21078','S','Havre de Grace','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.583804,-76.151327,0,'2013-07-06 12:44:31',NULL,NULL),(51256,'59082','S','Springdale','D','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.736616,-110.227181,0,'2013-07-06 12:44:33',NULL,NULL),(6139,'05463','S','Isle La Motte','D','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.870004,-73.340820,0,'2013-07-06 12:44:30',NULL,NULL),(32176,'35481','S','Reform','D','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.385953,-88.014060,0,'2013-07-06 12:44:32',NULL,NULL),(5714,'04987','S','Troy','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.678202,-69.253760,0,'2013-07-06 12:44:30',NULL,NULL),(4233,'02859','S','Glocester','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.963364,-71.717450,0,'2013-07-06 12:44:30',NULL,NULL),(2466,'00956','S','Est Del Bosque','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(54856,'63043','S','Maryland Hts','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.724027,-90.439555,0,'2013-07-06 12:44:33',NULL,NULL),(42839,'48070','S','Huntington Wd','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.480041,-83.166602,0,'2013-07-06 12:44:32',NULL,NULL),(29752,'32978','P','Sebastian','D','Indian River','12061','Florida','FL','12','4900','772','Eastern',-5.0,'Y',27.792642,-80.486816,0,'2013-07-06 12:44:32',NULL,NULL),(21007,'21838','S','Marion Sta','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.025060,-75.729060,0,'2013-07-06 12:44:31',NULL,NULL),(40018,'45247','S','Colerain TWP','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(15433,'16372','P','Clintonville','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.202094,-79.872501,0,'2013-07-06 12:44:31',NULL,NULL),(27745,'30357','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.799057,-84.387174,0,'2013-07-06 12:44:31',NULL,NULL),(12518,'13030','S','Bridgeport','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.160577,-75.984540,0,'2013-07-06 12:44:30',NULL,NULL),(71704,'87524','P','Costilla','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.914490,-105.460249,0,'2013-07-06 12:44:34',NULL,NULL),(18597,'19139','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.962447,-75.230101,0,'2013-07-06 12:44:31',NULL,NULL),(26775,'29446','S','Green Pond','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.655449,-80.515240,0,'2013-07-06 12:44:31',NULL,NULL),(67949,'80912','S','Consolidated Space Operation','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(65963,'78284','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.472455,-98.518993,0,'2013-07-06 12:44:34',NULL,NULL),(8685,'08340','S','Milmay','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440969,-74.862877,0,'2013-07-06 12:44:30',NULL,NULL),(205,'00623','S','Urb Sierra Linda','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(49632,'56935','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(45364,'51005','S','Diamond Center','N','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.715939,-95.435448,0,'2013-07-06 12:44:32',NULL,NULL),(16052,'17046','S','Lebanon','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.357882,-76.432449,0,'2013-07-06 12:44:31',NULL,NULL),(52968,'61425','S','Gulfport','N','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.764786,-91.060793,0,'2013-07-06 12:44:33',NULL,NULL),(47465,'54735','P','Downsville','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.775978,-91.930577,0,'2013-07-06 12:44:32',NULL,NULL),(57669,'67216','S','Oaklawn','N','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.618484,-97.317836,0,'2013-07-06 12:44:33',NULL,NULL),(49803,'57197','U','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.521917,-96.740725,0,'2013-07-06 12:44:33',NULL,NULL),(32576,'36118','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.406982,-86.247828,0,'2013-07-06 12:44:32',NULL,NULL),(12269,'12834','S','Thomson','A','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.090326,-73.500080,0,'2013-07-06 12:44:30',NULL,NULL),(24982,'27853','S','Margarettsville','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.525209,-77.292806,0,'2013-07-06 12:44:31',NULL,NULL),(67317,'80025','P','Eldorado Springs','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.935729,-105.280038,0,'2013-07-06 12:44:34',NULL,NULL),(35677,'39654','S','Wanilla','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(46642,'53595','U','Lands End','N','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.967480,-90.132036,0,'2013-07-06 12:44:32',NULL,NULL),(74289,'92364','S','Nipton','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.466595,-115.482713,0,'2013-07-06 12:44:34',NULL,NULL),(27237,'29922','S','Garnett','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.601990,-81.241810,0,'2013-07-06 12:44:31',NULL,NULL),(12250,'12828','S','Fort Miller','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.271395,-73.587390,0,'2013-07-06 12:44:30',NULL,NULL),(35475,'39520','S','Bay St Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(55759,'64116','S','Kans City','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.147840,-94.568880,0,'2013-07-06 12:44:33',NULL,NULL),(61659,'72905','U','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.286594,-94.276239,0,'2013-07-06 12:44:33',NULL,NULL),(29408,'32640','S','Hawthorne','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.591884,-82.112532,0,'2013-07-06 12:44:32',NULL,NULL),(73740,'91710','S','Montclair','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.016105,-117.686207,0,'2013-07-06 12:44:34',NULL,NULL),(38768,'44047','S','Lenox','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.650287,-80.769918,0,'2013-07-06 12:44:32',NULL,NULL),(79714,'99212','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(895,'00704','S','Villas del Coqui','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(3443,'01760','S','Natick','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(75267,'93675','S','Squaw Valley','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.624444,-119.312778,0,'2013-07-06 12:44:34',NULL,NULL),(67195,'79906','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.823040,-106.423800,0,'2013-07-06 12:44:34',NULL,NULL),(12916,'13339','S','Hallsville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(28321,'31145','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.853136,-84.279625,0,'2013-07-06 12:44:31',NULL,NULL),(14120,'14646','U','Frontier','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.151509,-77.605675,0,'2013-07-06 12:44:31',NULL,NULL),(69187,'83338','S','Jerome','D','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.709237,-114.464322,0,'2013-07-06 12:44:34',NULL,NULL),(59161,'70302','P','Thibodaux','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.803372,-90.830448,0,'2013-07-06 12:44:33',NULL,NULL),(13435,'13760','S','Endwell','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(28480,'31513','S','Pine Grove','N','Appling','13001','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.772585,-82.351151,0,'2013-07-06 12:44:32',NULL,NULL),(22912,'24606','P','Boissevain','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.284352,-81.382042,0,'2013-07-06 12:44:31',NULL,NULL),(2752,'00969','S','Urb Sierra Berdecia','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(58690,'68925','S','Ayr','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.440577,-98.442822,0,'2013-07-06 12:44:33',NULL,NULL),(9702,'10055','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759658,-73.968580,0,'2013-07-06 12:44:30',NULL,NULL),(48225,'55418','S','Saint Anthony','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.022134,-93.244686,0,'2013-07-06 12:44:33',NULL,NULL),(1966,'00830','S','St John','D','Saint John','78020','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.335154,-64.790707,0,'2013-07-06 12:44:30',NULL,NULL),(27247,'29927','S','Harbville','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.281300,-81.071015,0,'2013-07-06 12:44:31',NULL,NULL),(26860,'29532','S','Darlington','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.300363,-79.870170,0,'2013-07-06 12:44:31',NULL,NULL),(35547,'39564','S','Fontainebleau','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(35639,'39638','S','Eunice','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.247530,-91.030450,0,'2013-07-06 12:44:32',NULL,NULL),(79521,'98937','S','Cliffdell','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(41822,'47338','S','Niles','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.342989,-85.353750,0,'2013-07-06 12:44:32',NULL,NULL),(9481,'10011','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(64058,'76134','S','Edgecliff Vlg','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.642955,-97.327416,0,'2013-07-06 12:44:34',NULL,NULL),(60014,'71334','S','Ridgecrest','A','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(59752,'71152','U','Commercial National Bank','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.440924,-93.788435,0,'2013-07-06 12:44:33',NULL,NULL),(44121,'49507','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.934602,-85.652654,0,'2013-07-06 12:44:32',NULL,NULL),(51043,'58731','S','Deering','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.415654,-100.993250,0,'2013-07-06 12:44:33',NULL,NULL),(46719,'53808','P','Dickeyville','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.625866,-90.593685,0,'2013-07-06 12:44:32',NULL,NULL),(35072,'39194','S','Yazoo','N','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.857919,-90.405161,0,'2013-07-06 12:44:32',NULL,NULL),(39572,'44853','S','Berwick','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.052873,-83.311555,0,'2013-07-06 12:44:32',NULL,NULL),(16086,'17050','S','Silver Spring Township','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(43042,'48178','S','South Lyon','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.447611,-83.662388,0,'2013-07-06 12:44:32',NULL,NULL),(19043,'19540','S','Angelica','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(6981,'06243','S','Killingly','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.848174,-71.806468,0,'2013-07-06 12:44:30',NULL,NULL),(27222,'29915','S','Daufuskie Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.216111,-80.752778,0,'2013-07-06 12:44:31',NULL,NULL),(43043,'48179','S','S Rockwood','A','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.051676,-83.258881,0,'2013-07-06 12:44:32',NULL,NULL),(16129,'17057','S','Midltwn','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(9753,'10102','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(49440,'56636','S','Inger','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(28292,'31097','S','Yatesville','D','Upson','13293','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.925363,-84.163891,0,'2013-07-06 12:44:31',NULL,NULL),(41283,'46761','S','Elmira','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(11332,'11790','S','Stonybrook','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.905287,-73.125351,0,'2013-07-06 12:44:30',NULL,NULL),(1491,'00751','S','Ext Carmen','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(71566,'87301','S','Pinedale','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(69512,'83716','S','Mayfield','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.531746,-116.140200,0,'2013-07-06 12:44:34',NULL,NULL),(49047,'56294','P','Wanda','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.320054,-95.178001,0,'2013-07-06 12:44:33',NULL,NULL),(47740,'55014','S','Circle Pines','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.179760,-93.132240,0,'2013-07-06 12:44:33',NULL,NULL),(23603,'25699','S','Wilsondale','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',37.957334,-82.367160,0,'2013-07-06 12:44:31',NULL,NULL),(26340,'29061','S','Hopkins','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.932888,-80.844488,0,'2013-07-06 12:44:31',NULL,NULL),(29122,'32313','U','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430000,-84.280000,0,'2013-07-06 12:44:32',NULL,NULL),(15138,'15848','S','Luthersburg','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.036970,-78.741205,0,'2013-07-06 12:44:31',NULL,NULL),(35560,'39566','P','Ocean Spgs','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.414895,-88.823565,0,'2013-07-06 12:44:32',NULL,NULL),(16366,'17201','S','Kauffman','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(12565,'13056','P','East Homer','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.672626,-76.096831,0,'2013-07-06 12:44:30',NULL,NULL),(12467,'12980','S','Santa Clara','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.656564,-74.564467,0,'2013-07-06 12:44:30',NULL,NULL),(16464,'17241','S','Little Wash','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(22917,'24609','S','Cedar Bluff','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083840,-81.768540,0,'2013-07-06 12:44:31',NULL,NULL),(42288,'47586','S','Tell City','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(61494,'72644','S','Diamond City','A','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.469449,-92.916329,0,'2013-07-06 12:44:33',NULL,NULL),(47254,'54521','S','Cloverland','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.910500,-89.224500,0,'2013-07-06 12:44:32',NULL,NULL),(14438,'15088','P','W Elizabeth','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.272744,-79.895350,0,'2013-07-06 12:44:31',NULL,NULL),(78825,'98335','S','Gig Harbor','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(60316,'71457','S','Hagewood','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(56727,'65705','S','Marionville','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.001346,-93.642179,0,'2013-07-06 12:44:33',NULL,NULL),(52494,'60701','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.029394,-87.807553,0,'2013-07-06 12:44:33',NULL,NULL),(47857,'55077','S','South St Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.839723,-93.076930,0,'2013-07-06 12:44:33',NULL,NULL),(26262,'29006','S','Summerland','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.886910,-81.534141,0,'2013-07-06 12:44:31',NULL,NULL),(23026,'24843','P','Hensley','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.478213,-81.676884,0,'2013-07-06 12:44:31',NULL,NULL),(38421,'43547','P','Neapolis','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.488639,-83.872248,0,'2013-07-06 12:44:32',NULL,NULL),(38874,'44105','S','Garfield Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(18544,'19113','S','Philadelphia','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868191,-75.284889,0,'2013-07-06 12:44:31',NULL,NULL),(18546,'19114','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.064913,-75.003036,0,'2013-07-06 12:44:31',NULL,NULL),(17999,'18631','P','Mifflinville','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.029799,-76.308789,0,'2013-07-06 12:44:31',NULL,NULL),(58101,'68112','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.338789,-95.974358,0,'2013-07-06 12:44:33',NULL,NULL),(47606,'54875','S','Springbrook','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.986961,-91.676053,0,'2013-07-06 12:44:33',NULL,NULL),(65446,'77591','S','West Texas City','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.386598,-94.987485,0,'2013-07-06 12:44:34',NULL,NULL),(29954,'33073','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.305181,-80.187797,0,'2013-07-06 12:44:32',NULL,NULL),(43769,'49028','S','Bronson','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.848158,-85.192123,0,'2013-07-06 12:44:32',NULL,NULL),(78036,'97435','S','Drain','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.654055,-123.362827,0,'2013-07-06 12:44:34',NULL,NULL),(68915,'82837','P','Leiter','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.748625,-106.215831,0,'2013-07-06 12:44:34',NULL,NULL),(65065,'77344','U','Tx State Prison','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722043,-95.552789,0,'2013-07-06 12:44:34',NULL,NULL),(61340,'72465','P','Sedgwick','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.986948,-90.879291,0,'2013-07-06 12:44:33',NULL,NULL),(57838,'67550','S','Larned','D','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.188320,-99.120720,0,'2013-07-06 12:44:33',NULL,NULL),(55167,'63367','S','Ofallon','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.793015,-90.782477,0,'2013-07-06 12:44:33',NULL,NULL),(53433,'61863','S','Pesotum','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.916306,-88.276128,0,'2013-07-06 12:44:33',NULL,NULL),(52490,'60697','U','Bank of America','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879482,-87.615588,0,'2013-07-06 12:44:33',NULL,NULL),(45545,'51458','S','Odebolt','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.310153,-95.249138,0,'2013-07-06 12:44:32',NULL,NULL),(22172,'23465','U','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.797995,-76.176483,0,'2013-07-06 12:44:31',NULL,NULL),(12136,'12724','P','Callicoon Ctr','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.839043,-74.946526,0,'2013-07-06 12:44:30',NULL,NULL),(4334,'03032','S','Auburn','D','Rockingham','33015','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.997422,-71.351590,0,'2013-07-06 12:44:30',NULL,NULL),(30486,'33355','P','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.112790,-80.303694,0,'2013-07-06 12:44:32',NULL,NULL),(2018,'00915','S','Sect La Playita','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(29553,'32808','S','Pine Hills','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.572630,-81.442973,0,'2013-07-06 12:44:32',NULL,NULL),(40373,'45651','S','Allensville','A','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.249907,-82.478264,0,'2013-07-06 12:44:32',NULL,NULL),(4914,'04071','S','Frye Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.914064,-70.444240,0,'2013-07-06 12:44:30',NULL,NULL),(20798,'21550','S','Mnt Lake Park','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(39282,'44483','S','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.278140,-80.817300,0,'2013-07-06 12:44:32',NULL,NULL),(55177,'63370','P','Olney','D','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.097858,-91.212285,0,'2013-07-06 12:44:33',NULL,NULL),(22629,'24243','S','Dryden','D','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.795985,-82.915693,0,'2013-07-06 12:44:31',NULL,NULL),(29551,'32807','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.559275,-81.302867,0,'2013-07-06 12:44:32',NULL,NULL),(27281,'29945','S','White Hall','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(77869,'97240','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.502418,-122.656443,0,'2013-07-06 12:44:34',NULL,NULL),(79083,'98438','P','Joint Base Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(76971,'96054','P','Lookout','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.118315,-121.139856,0,'2013-07-06 12:44:34',NULL,NULL),(68497,'81302','P','Durango','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.313813,-107.877231,0,'2013-07-06 12:44:34',NULL,NULL),(65776,'78112','S','Saspamco','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.226523,-98.366970,0,'2013-07-06 12:44:34',NULL,NULL),(59732,'71115','S','Caspiana','A','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.383613,-93.665812,0,'2013-07-06 12:44:33',NULL,NULL),(46918,'54141','S','Ltl Suamico','A','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.643255,-88.035252,0,'2013-07-06 12:44:32',NULL,NULL),(33020,'36702','P','Selma','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.406235,-87.022431,0,'2013-07-06 12:44:32',NULL,NULL),(33303,'37131','U','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.853243,-86.396024,0,'2013-07-06 12:44:32',NULL,NULL),(19609,'20233','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(21164,'22151','S','N Springfld','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801146,-77.207526,0,'2013-07-06 12:44:31',NULL,NULL),(3707,'02140','S','Porter Square','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.392350,-71.131259,0,'2013-07-06 12:44:30',NULL,NULL),(45094,'50539','S','Seneca','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.216976,-94.411098,0,'2013-07-06 12:44:32',NULL,NULL),(42994,'48158','S','Sharon Hollow','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.162540,-84.020040,0,'2013-07-06 12:44:32',NULL,NULL),(20267,'20785','S','Cheverly','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(63280,'75551','S','Smyrna','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.115529,-94.170131,0,'2013-07-06 12:44:33',NULL,NULL),(42925,'48113','P','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.274234,-83.730952,0,'2013-07-06 12:44:32',NULL,NULL),(67043,'79546','S','Rotan','D','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.854577,-100.463181,0,'2013-07-06 12:44:34',NULL,NULL),(66840,'79114','P','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.165864,-101.879301,0,'2013-07-06 12:44:34',NULL,NULL),(31989,'35220','P','Centerpoint','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.441667,-86.905801,0,'2013-07-06 12:44:32',NULL,NULL),(63061,'75229','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.893259,-96.864726,0,'2013-07-06 12:44:33',NULL,NULL),(48558,'55764','P','Greenway','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.322198,-93.302759,0,'2013-07-06 12:44:33',NULL,NULL),(64562,'76656','S','Goodville','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(78108,'97496','S','Camas Valley','N','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.100381,-123.454748,0,'2013-07-06 12:44:34',NULL,NULL),(59353,'70563','S','New Iberia','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.045023,-91.742451,0,'2013-07-06 12:44:33',NULL,NULL),(54658,'62932','S','Elkville','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.911722,-89.233161,0,'2013-07-06 12:44:33',NULL,NULL),(5894,'05155','S','Stratton Mountain','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(63964,'76099','P','Grapevine','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.931793,-97.078104,0,'2013-07-06 12:44:34',NULL,NULL),(57942,'67740','S','Studley','A','Sheridan','20179','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.352780,-100.163780,0,'2013-07-06 12:44:33',NULL,NULL),(44042,'49426','S','Hudsonville','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.875583,-85.877048,0,'2013-07-06 12:44:32',NULL,NULL),(42718,'48002','S','Berville','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.908333,-82.883056,0,'2013-07-06 12:44:32',NULL,NULL),(48881,'56093','S','Waseca','D','Waseca','27161','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.080423,-93.503192,0,'2013-07-06 12:44:33',NULL,NULL),(51344,'59317','S','Broadus','D','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.413540,-105.829860,0,'2013-07-06 12:44:33',NULL,NULL),(70425,'84730','P','Glenwood','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.763372,-111.973567,0,'2013-07-06 12:44:34',NULL,NULL),(22284,'23803','S','Petersburg','D','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.213860,-77.455680,0,'2013-07-06 12:44:31',NULL,NULL),(57746,'67437','S','Downs','D','Osborne','20141','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.504401,-98.545281,0,'2013-07-06 12:44:33',NULL,NULL),(13448,'13776','S','Gilbertsville','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.434400,-75.362580,0,'2013-07-06 12:44:31',NULL,NULL),(13745,'14112','P','N Evans','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.697844,-78.984930,0,'2013-07-06 12:44:31',NULL,NULL),(24141,'26563','P','Carolina','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.481540,-80.273362,0,'2013-07-06 12:44:31',NULL,NULL),(47354,'54613','S','Big Flats','N','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.064139,-89.898982,0,'2013-07-06 12:44:32',NULL,NULL),(77568,'96910','S','Mongmong','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(33128,'36877','S','Smiths','A','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.537478,-85.099853,0,'2013-07-06 12:44:32',NULL,NULL),(2200,'00926','S','Qtas de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(57075,'66215','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(32328,'35768','S','Hytop','A','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.916550,-86.087910,0,'2013-07-06 12:44:32',NULL,NULL),(36909,'41135','S','Head of Grass','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.380556,-83.260136,0,'2013-07-06 12:44:32',NULL,NULL),(56791,'65760','S','Sycamore','A','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.584742,-92.258059,0,'2013-07-06 12:44:33',NULL,NULL),(8674,'08327','S','Leesburg','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.256041,-74.987716,0,'2013-07-06 12:44:30',NULL,NULL),(8039,'07732','S','Monmouth Hills','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.399752,-73.997462,0,'2013-07-06 12:44:30',NULL,NULL),(39319,'44606','S','Apple Creek','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.737325,-81.805321,0,'2013-07-06 12:44:32',NULL,NULL),(22781,'24450','S','West Lexington','N','Lexington City','51678','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.779731,-79.444573,0,'2013-07-06 12:44:31',NULL,NULL),(34213,'38355','S','Medina','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.761901,-88.783090,0,'2013-07-06 12:44:32',NULL,NULL),(61676,'72932','S','Cedarville','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.606741,-94.327052,0,'2013-07-06 12:44:33',NULL,NULL),(56237,'65046','S','Sandy Hook','N','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.790635,-92.483677,0,'2013-07-06 12:44:33',NULL,NULL),(31261,'33991','S','Matlacha Isles','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.629052,-82.002027,0,'2013-07-06 12:44:32',NULL,NULL),(76737,'95910','S','Forest City','N','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.536220,-120.663120,0,'2013-07-06 12:44:34',NULL,NULL),(10226,'10461','S','Morris Park','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.844984,-73.843255,0,'2013-07-06 12:44:30',NULL,NULL),(60605,'71851','S','Mineral Springs','D','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.871355,-93.917645,0,'2013-07-06 12:44:33',NULL,NULL),(2125,'00924','S','Mans de San Martin','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(22185,'23483','P','Wattsville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.961523,-75.513407,0,'2013-07-06 12:44:31',NULL,NULL),(51240,'59070','S','Roberts','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.395254,-109.169029,0,'2013-07-06 12:44:33',NULL,NULL),(47376,'54626','S','Lynxville','A','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.193536,-91.014896,0,'2013-07-06 12:44:32',NULL,NULL),(45806,'52175','S','Eldorado','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.969660,-91.800840,0,'2013-07-06 12:44:32',NULL,NULL),(13225,'13635','S','S Edwards','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.308020,-75.256080,0,'2013-07-06 12:44:30',NULL,NULL),(31248,'33976','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.612085,-81.663866,0,'2013-07-06 12:44:32',NULL,NULL),(31136,'33906','P','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.592680,-81.857155,0,'2013-07-06 12:44:32',NULL,NULL),(71200,'86054','P','Shonto','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.592945,-110.656759,0,'2013-07-06 12:44:34',NULL,NULL),(5568,'04862','S','Appleton','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.260518,-69.256594,0,'2013-07-06 12:44:30',NULL,NULL),(73117,'90260','S','Lawndale','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.888172,-118.348328,0,'2013-07-06 12:44:34',NULL,NULL),(31060,'33843','S','Frostproof','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.741623,-81.547806,0,'2013-07-06 12:44:32',NULL,NULL),(22022,'23290','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.550454,-77.473709,0,'2013-07-06 12:44:31',NULL,NULL),(6645,'06016','S','Melrose','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.908366,-72.542144,0,'2013-07-06 12:44:30',NULL,NULL),(38683,'43972','P','Bannock','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.100473,-80.975753,0,'2013-07-06 12:44:32',NULL,NULL),(24920,'27805','S','Aulander','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.101660,-77.043930,0,'2013-07-06 12:44:31',NULL,NULL),(22353,'23890','S','Waverly','D','Sussex','51183','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.035798,-77.095681,0,'2013-07-06 12:44:31',NULL,NULL),(48576,'55771','S','Glendale','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(15929,'17021','S','E Waterford','A','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(40425,'45697','S','Winchester','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.907484,-83.636488,0,'2013-07-06 12:44:32',NULL,NULL),(39922,'45222','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.193649,-84.446420,0,'2013-07-06 12:44:32',NULL,NULL),(36238,'40294','U','Bank One','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258043,-85.759137,0,'2013-07-06 12:44:32',NULL,NULL),(13959,'14468','S','Hilton','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.295049,-77.789588,0,'2013-07-06 12:44:31',NULL,NULL),(27970,'30559','S','Mineral Bluff','D','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.940401,-84.267308,0,'2013-07-06 12:44:31',NULL,NULL),(48150,'55369','S','Maple Grove','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.121860,-93.457200,0,'2013-07-06 12:44:33',NULL,NULL),(73972,'92078','S','San Marcos','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.114432,-117.168445,0,'2013-07-06 12:44:34',NULL,NULL),(74767,'93106','U','Uc Santa Barbara','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.431306,-119.834277,0,'2013-07-06 12:44:34',NULL,NULL),(62873,'75042','S','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.911721,-96.672526,0,'2013-07-06 12:44:33',NULL,NULL),(15176,'15931','S','Ebensburg','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.483822,-78.732605,0,'2013-07-06 12:44:31',NULL,NULL),(65845,'78162','P','Tuleta','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.571375,-97.796871,0,'2013-07-06 12:44:34',NULL,NULL),(9837,'10115','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.815047,-73.953521,0,'2013-07-06 12:44:30',NULL,NULL),(51855,'60073','S','Round Lk Hts','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(19227,'19899','P','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.735632,-75.547657,0,'2013-07-06 12:44:31',NULL,NULL),(23820,'26074','P','West Liberty','D','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.168725,-80.595143,0,'2013-07-06 12:44:31',NULL,NULL),(77361,'96740','S','Kailua Kona','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.664709,-155.981431,0,'2013-07-06 12:44:34',NULL,NULL),(19751,'20411','U','Hud Fed Housing Adm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885195,-77.023632,0,'2013-07-06 12:44:31',NULL,NULL),(16856,'17563','S','McSparren','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(15552,'16627','S','Coalport','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.751583,-78.533246,0,'2013-07-06 12:44:31',NULL,NULL),(51983,'60153','S','Maywood','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.872080,-87.847320,0,'2013-07-06 12:44:33',NULL,NULL),(75633,'94514','S','Discovery Bay','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.872000,-121.613640,0,'2013-07-06 12:44:34',NULL,NULL),(36576,'40944','P','Goose Rock','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.090083,-83.693057,0,'2013-07-06 12:44:32',NULL,NULL),(41024,'46382','S','Union Mills','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.476020,-86.779080,0,'2013-07-06 12:44:32',NULL,NULL),(28808,'32065','S','Orange Pk','N','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.134405,-81.774717,0,'2013-07-06 12:44:32',NULL,NULL),(32899,'36539','S','Fruitdale','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.326277,-88.315502,0,'2013-07-06 12:44:32',NULL,NULL),(39121,'44260','S','Suffield','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.036803,-81.348875,0,'2013-07-06 12:44:32',NULL,NULL),(36028,'40170','S','Stephensport','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.897704,-86.534884,0,'2013-07-06 12:44:32',NULL,NULL),(67635,'80453','P','Idledale','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.666725,-105.253606,0,'2013-07-06 12:44:34',NULL,NULL),(16039,'17044','S','Juniata Terr','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(5031,'04254','S','Livermore Fls','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.472043,-70.184517,0,'2013-07-06 12:44:30',NULL,NULL),(66831,'79103','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.186941,-101.804473,0,'2013-07-06 12:44:34',NULL,NULL),(54526,'62879','P','Sailor Springs','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.763612,-88.359594,0,'2013-07-06 12:44:33',NULL,NULL),(60128,'71371','S','Whatley Landing','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.705000,-92.228056,0,'2013-07-06 12:44:33',NULL,NULL),(3281,'01474','S','West Townsend','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.671160,-71.713080,0,'2013-07-06 12:44:30',NULL,NULL),(66597,'78754','S','Dell Computers','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.345825,-97.661056,0,'2013-07-06 12:44:34',NULL,NULL),(78354,'98011','S','Inglewood','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.755500,-122.191349,0,'2013-07-06 12:44:34',NULL,NULL),(78745,'98290','S','Maltby','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.939532,-122.016706,0,'2013-07-06 12:44:34',NULL,NULL),(60882,'72064','S','Screeton','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.797715,-91.570184,0,'2013-07-06 12:44:33',NULL,NULL),(412,'00662','S','Repto Duran','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(42981,'48143','P','Lakeland','D','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.456748,-83.897356,0,'2013-07-06 12:44:32',NULL,NULL),(70671,'85224','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.321325,-111.877926,0,'2013-07-06 12:44:34',NULL,NULL),(23891,'26180','S','Freeport','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.181974,-81.367925,0,'2013-07-06 12:44:31',NULL,NULL),(24893,'27708','U','Duke University','N','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.997189,-78.938612,0,'2013-07-06 12:44:31',NULL,NULL),(48575,'55771','S','Gheen','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.168240,-92.779920,0,'2013-07-06 12:44:33',NULL,NULL),(48065,'55327','S','Hassan','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.202456,-93.468790,0,'2013-07-06 12:44:33',NULL,NULL),(44251,'49675','S','Onekama','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.368783,-86.218269,0,'2013-07-06 12:44:32',NULL,NULL),(3356,'01564','S','Sterling Junction','N','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.441660,-71.774580,0,'2013-07-06 12:44:30',NULL,NULL),(64565,'76656','S','Westphalia','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(25738,'28561','P','New Bern','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.101125,-77.077035,0,'2013-07-06 12:44:31',NULL,NULL),(40673,'46057','S','Boyleston','N','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.327309,-86.424171,0,'2013-07-06 12:44:32',NULL,NULL),(77099,'96140','P','Flick Point','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(22458,'24032','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.278278,-79.935296,0,'2013-07-06 12:44:31',NULL,NULL),(40641,'46035','S','Colfax','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.193307,-86.665691,0,'2013-07-06 12:44:32',NULL,NULL),(40689,'46069','S','Sheridan','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.137561,-86.211590,0,'2013-07-06 12:44:32',NULL,NULL),(69232,'83406','S','Ammon','A','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.451050,-111.965181,0,'2013-07-06 12:44:34',NULL,NULL),(61406,'72554','S','Mammoth Spg','A','Fulton','05049','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.497654,-91.541940,0,'2013-07-06 12:44:33',NULL,NULL),(31495,'34445','P','Holder','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.914824,-82.459029,0,'2013-07-06 12:44:32',NULL,NULL),(33119,'36867','S','Phenix City','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.473217,-85.019990,0,'2013-07-06 12:44:32',NULL,NULL),(45535,'51448','S','Kiron','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.188040,-95.317860,0,'2013-07-06 12:44:32',NULL,NULL),(73188,'90501','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.829914,-118.314527,0,'2013-07-06 12:44:34',NULL,NULL),(75079,'93532','S','Three Points','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(74936,'93407','S','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.298873,-120.658799,0,'2013-07-06 12:44:34',NULL,NULL),(50358,'57748','S','Howes','D','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.541189,-102.211846,0,'2013-07-06 12:44:33',NULL,NULL),(2572,'00959','S','Villa de San Agustin','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(61563,'72722','S','Decatur','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.342647,-94.439340,0,'2013-07-06 12:44:33',NULL,NULL),(9381,'09839','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(24545,'27292','S','LEX','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(19298,'19977','S','Smyrna','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.291184,-75.606382,0,'2013-07-06 12:44:31',NULL,NULL),(26173,'28749','P','Little Switzerland','D','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.847794,-82.097662,0,'2013-07-06 12:44:31',NULL,NULL),(26965,'29610','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.931778,-82.471944,0,'2013-07-06 12:44:31',NULL,NULL),(28097,'30750','S','Lookout Mountain','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.975006,-85.355133,0,'2013-07-06 12:44:31',NULL,NULL),(21889,'23178','P','Ware Neck','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.401767,-76.455747,0,'2013-07-06 12:44:31',NULL,NULL),(66260,'78574','S','Palmview','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.219063,-98.325099,0,'2013-07-06 12:44:34',NULL,NULL),(48083,'55332','S','Fairfax','D','Renville','27129','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.544084,-94.746915,0,'2013-07-06 12:44:33',NULL,NULL),(77415,'96793','S','Wailuku','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.896769,-156.504013,0,'2013-07-06 12:44:34',NULL,NULL),(78012,'97414','S','Broadbent','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.981009,-124.122107,0,'2013-07-06 12:44:34',NULL,NULL),(38929,'44122','S','Shaker Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(37870,'42544','S','Ingle','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(64637,'76708','S','Bosqueville','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.609500,-97.213440,0,'2013-07-06 12:44:34',NULL,NULL),(17122,'17774','S','Richards Grv','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.242038,-76.522091,0,'2013-07-06 12:44:31',NULL,NULL),(73237,'90661','P','Pico Rivera','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.998236,-118.080655,0,'2013-07-06 12:44:34',NULL,NULL),(70164,'84320','S','Cove','A','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.962200,-111.873480,0,'2013-07-06 12:44:34',NULL,NULL),(56917,'66056','S','Mound City','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.142278,-94.808789,0,'2013-07-06 12:44:33',NULL,NULL),(52181,'60463','S','Palos Heights','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.658291,-87.787612,0,'2013-07-06 12:44:33',NULL,NULL),(50867,'58505','S','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.847657,-100.716693,0,'2013-07-06 12:44:33',NULL,NULL),(48912,'56137','S','Heron Lake','D','Jackson','27063','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.793828,-95.319084,0,'2013-07-06 12:44:33',NULL,NULL),(12501,'13021','S','Fleming','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.920644,-76.559964,0,'2013-07-06 12:44:30',NULL,NULL),(27713,'30342','S','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.877890,-84.370698,0,'2013-07-06 12:44:31',NULL,NULL),(15816,'16930','S','Hartsfield','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.550000,-77.100000,0,'2013-07-06 12:44:31',NULL,NULL),(32837,'36477','S','Samson','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.109288,-86.048186,0,'2013-07-06 12:44:32',NULL,NULL),(20620,'21212','S','Govans','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.367800,-76.618560,0,'2013-07-06 12:44:31',NULL,NULL),(8753,'08533','S','Plumsted','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.083333,-74.500000,0,'2013-07-06 12:44:30',NULL,NULL),(28004,'30606','S','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.948996,-83.423229,0,'2013-07-06 12:44:31',NULL,NULL),(40647,'46036','S','Meadowood Estates','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(32159,'35473','S','Northport','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.228904,-87.577424,0,'2013-07-06 12:44:32',NULL,NULL),(47559,'54837','S','Clam Falls','A','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.703572,-92.475946,0,'2013-07-06 12:44:32',NULL,NULL),(79917,'99604','P','Hooper Bay','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.500334,-165.710965,0,'2013-07-06 12:44:34',NULL,NULL),(33624,'37664','S','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.524127,-82.494146,0,'2013-07-06 12:44:32',NULL,NULL),(65884,'78228','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.459623,-98.574755,0,'2013-07-06 12:44:34',NULL,NULL),(65452,'77612','S','Buna','D','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.293933,-94.085399,0,'2013-07-06 12:44:34',NULL,NULL),(64443,'76567','S','Salty','N','Milam','48331','Texas','TX','48','0000','512/737','Central',-6.0,'Y',30.657577,-97.009947,0,'2013-07-06 12:44:34',NULL,NULL),(60082,'71357','S','Lake Bruin','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(51022,'58710','S','Aylmer','N','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.848945,-100.262163,0,'2013-07-06 12:44:33',NULL,NULL),(32931,'36560','S','Mount Vernon','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.069380,-88.053120,0,'2013-07-06 12:44:32',NULL,NULL),(26892,'29570','S','McColl','N','Marlboro','45069','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.662498,-79.544259,0,'2013-07-06 12:44:31',NULL,NULL),(16681,'17363','S','Stewartstown','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.757217,-76.601719,0,'2013-07-06 12:44:31',NULL,NULL),(43377,'48422','S','Croswell','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.268333,-82.632042,0,'2013-07-06 12:44:32',NULL,NULL),(11513,'12032','S','Caroga Lake','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.161683,-74.493710,0,'2013-07-06 12:44:30',NULL,NULL),(76495,'95634','S','Virner','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917770,-120.790653,0,'2013-07-06 12:44:34',NULL,NULL),(54520,'62875','S','Pope','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.753045,-89.096352,0,'2013-07-06 12:44:33',NULL,NULL),(405,'00662','S','Mans del Atlantico','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(44473,'49893','S','Wallace','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.334797,-87.609864,0,'2013-07-06 12:44:32',NULL,NULL),(52297,'60541','S','Helmar','N','Kendall','17093','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.514251,-88.510263,0,'2013-07-06 12:44:33',NULL,NULL),(44762,'50206','S','New Providnce','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.198187,-93.188548,0,'2013-07-06 12:44:32',NULL,NULL),(75080,'93534','S','Del Sur','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(52083,'60403','S','Joliet','A','Will','17197','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.839745,-87.790481,0,'2013-07-06 12:44:33',NULL,NULL),(71602,'87323','S','Thoreau','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.405658,-108.218449,0,'2013-07-06 12:44:34',NULL,NULL),(69448,'83647','S','Oasis','A','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.169760,-115.713780,0,'2013-07-06 12:44:34',NULL,NULL),(56042,'64723','S','Amsterdam','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.394087,-94.563040,0,'2013-07-06 12:44:33',NULL,NULL),(54206,'62640','S','Girard','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.446714,-89.796627,0,'2013-07-06 12:44:33',NULL,NULL),(52747,'61242','S','Cordova','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.687319,-90.292709,0,'2013-07-06 12:44:33',NULL,NULL),(51694,'60002','S','Antioch','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.468500,-88.109296,0,'2013-07-06 12:44:33',NULL,NULL),(50804,'58452','S','Jessie','D','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.541441,-98.237747,0,'2013-07-06 12:44:33',NULL,NULL),(48449,'55708','P','Biwabik','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.546084,-92.335052,0,'2013-07-06 12:44:33',NULL,NULL),(6076,'05447','S','East Berkshire','D','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.930619,-72.710708,0,'2013-07-06 12:44:30',NULL,NULL),(7977,'07710','P','Adelphia','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.214096,-74.262255,0,'2013-07-06 12:44:30',NULL,NULL),(20776,'21530','S','Flintstone','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.689276,-78.698799,0,'2013-07-06 12:44:31',NULL,NULL),(2255,'00926','S','Urb Mirador De Borinquen Gdn','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(13785,'14167','S','Varysburg','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.737511,-78.317594,0,'2013-07-06 12:44:31',NULL,NULL),(73452,'91302','S','Hidden Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.134741,-118.656723,0,'2013-07-06 12:44:34',NULL,NULL),(52932,'61376','S','Normandy','A','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.534821,-89.602442,0,'2013-07-06 12:44:33',NULL,NULL),(3181,'01338','S','Buckland','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.598874,-72.740885,0,'2013-07-06 12:44:30',NULL,NULL),(70808,'85373','S','Sun City','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.782816,-112.365348,0,'2013-07-06 12:44:34',NULL,NULL),(73633,'91413','P','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164355,-118.458352,0,'2013-07-06 12:44:34',NULL,NULL),(74770,'93107','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.421154,-119.858056,0,'2013-07-06 12:44:34',NULL,NULL),(65138,'77385','S','Oak Ridge N','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.185643,-95.428944,0,'2013-07-06 12:44:34',NULL,NULL),(74909,'93313','S','Pumpkin Ctr','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.254233,-119.060086,0,'2013-07-06 12:44:34',NULL,NULL),(70991,'85711','S','Coronado','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.218469,-110.887678,0,'2013-07-06 12:44:34',NULL,NULL),(30148,'33167','S','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885455,-80.228537,0,'2013-07-06 12:44:32',NULL,NULL),(27979,'30571','S','Saute Nacoche','A','White','13311','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.743332,-83.716475,0,'2013-07-06 12:44:31',NULL,NULL),(31655,'34743','S','BVL','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.328203,-81.354643,0,'2013-07-06 12:44:32',NULL,NULL),(32692,'36276','S','Almond','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(34597,'38746','S','Waxhaw','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.977222,-90.912222,0,'2013-07-06 12:44:32',NULL,NULL),(40894,'46250','S','Castleton','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.903249,-86.068818,0,'2013-07-06 12:44:32',NULL,NULL),(42517,'47851','P','Fontanet','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.543778,-87.319509,0,'2013-07-06 12:44:32',NULL,NULL),(61819,'73107','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483265,-97.577589,0,'2013-07-06 12:44:33',NULL,NULL),(24331,'27027','S','Ayersville','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.411918,-79.976025,0,'2013-07-06 12:44:31',NULL,NULL),(26376,'29080','S','Motbridge','N','Lee','45061','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.038853,-80.110297,0,'2013-07-06 12:44:31',NULL,NULL),(80059,'99714','S','Salcha','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.468564,-146.936418,0,'2013-07-06 12:44:34',NULL,NULL),(5432,'04679','S','Southwest Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.279865,-68.330071,0,'2013-07-06 12:44:30',NULL,NULL),(30497,'33394','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.121148,-80.139899,0,'2013-07-06 12:44:32',NULL,NULL),(57361,'66738','S','Fulton','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.009208,-94.718191,0,'2013-07-06 12:44:33',NULL,NULL),(70993,'85712','S','Coronado','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.253883,-110.884936,0,'2013-07-06 12:44:34',NULL,NULL),(79993,'99660','P','St Paul Isle','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',57.184029,-170.273301,0,'2013-07-06 12:44:34',NULL,NULL),(59181,'70353','S','Dulac','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.399038,-90.707271,0,'2013-07-06 12:44:33',NULL,NULL),(75766,'94622','U','Oakland Intrntl Service Ctr','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.749508,-122.194169,0,'2013-07-06 12:44:34',NULL,NULL),(67578,'80309','U','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.009437,-105.269917,0,'2013-07-06 12:44:34',NULL,NULL),(59116,'70148','U','University of New Orleans','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.029172,-90.068447,0,'2013-07-06 12:44:33',NULL,NULL),(58955,'70001','S','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.986801,-90.166314,0,'2013-07-06 12:44:33',NULL,NULL),(58081,'68067','S','Walthill','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.147000,-96.490211,0,'2013-07-06 12:44:33',NULL,NULL),(48937,'56160','S','Odin','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.864519,-94.743310,0,'2013-07-06 12:44:33',NULL,NULL),(28304,'31119','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.857043,-84.344412,0,'2013-07-06 12:44:31',NULL,NULL),(15630,'16701','S','Kendall Creek','N','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.953308,-78.645295,0,'2013-07-06 12:44:31',NULL,NULL),(21234,'22227','U','Us Air','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.854079,-77.054897,0,'2013-07-06 12:44:31',NULL,NULL),(43675,'48865','S','Orleans','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',43.084881,-85.116760,0,'2013-07-06 12:44:32',NULL,NULL),(9239,'09568','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(41324,'46774','S','Thurman','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(20538,'21104','S','Woodstock','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.343680,-76.907220,0,'2013-07-06 12:44:31',NULL,NULL),(8460,'08087','S','West Tuckerton','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(18317,'19021','S','Croydon','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.094171,-74.909281,0,'2013-07-06 12:44:31',NULL,NULL),(65423,'77578','S','Manvel','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.478816,-95.352086,0,'2013-07-06 12:44:34',NULL,NULL),(48809,'56022','P','Darfur','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.049791,-94.836180,0,'2013-07-06 12:44:33',NULL,NULL),(47380,'54630','S','Centerville','N','Trempealeau','55121','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.076034,-91.362035,0,'2013-07-06 12:44:32',NULL,NULL),(38546,'43754','S','Lewisville','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.762764,-81.237672,0,'2013-07-06 12:44:32',NULL,NULL),(20453,'21017','S','Riverside','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.472249,-76.237972,0,'2013-07-06 12:44:31',NULL,NULL),(66677,'78934','S','Columbus','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.698260,-96.566400,0,'2013-07-06 12:44:34',NULL,NULL),(59005,'70065','S','Kenner','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.024262,-90.249125,0,'2013-07-06 12:44:33',NULL,NULL),(7073,'06340','S','Borough','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(9963,'10159','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(65897,'78234','S','Fort Sam Houston','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.457977,-98.493044,0,'2013-07-06 12:44:34',NULL,NULL),(408,'00662','S','Pradera Real','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(77608,'96942','P','Truk','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',7.323877,151.653461,0,'2013-07-06 12:44:34',NULL,NULL),(76066,'95203','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.954003,-121.309883,0,'2013-07-06 12:44:34',NULL,NULL),(62147,'73719','S','Amorita','D','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.953667,-98.225375,0,'2013-07-06 12:44:33',NULL,NULL),(49549,'56687','P','Eckles','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522450,-94.996355,0,'2013-07-06 12:44:33',NULL,NULL),(26422,'29125','S','Panola','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.742260,-80.481720,0,'2013-07-06 12:44:31',NULL,NULL),(29892,'33042','S','Upr Sugarloaf','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(33680,'37743','S','Baileyton','N','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.162752,-82.818898,0,'2013-07-06 12:44:32',NULL,NULL),(13318,'13676','S','Sandfordville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(16474,'17243','S','Orbisonia','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.239420,-77.907120,0,'2013-07-06 12:44:31',NULL,NULL),(41502,'46960','S','Monterey','D','Pulaski','18131','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.127883,-86.524856,0,'2013-07-06 12:44:32',NULL,NULL),(9022,'08870','P','Readington','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.566487,-74.739942,0,'2013-07-06 12:44:30',NULL,NULL),(9272,'09618','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(54000,'62445','S','Gila','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.148880,-88.320381,0,'2013-07-06 12:44:33',NULL,NULL),(63527,'75755','S','Rhonesboro','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.583260,-95.112002,0,'2013-07-06 12:44:33',NULL,NULL),(10829,'11380','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742946,-73.884618,0,'2013-07-06 12:44:30',NULL,NULL),(14803,'15380','S','Wind Ridge','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.889366,-80.466955,0,'2013-07-06 12:44:31',NULL,NULL),(19836,'20503','U','Office of Mgmt and Budget','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902115,-77.036165,0,'2013-07-06 12:44:31',NULL,NULL),(12758,'13207','S','Elmwood','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.017354,-76.167626,0,'2013-07-06 12:44:30',NULL,NULL),(35065,'39190','P','Washington','D','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.576072,-91.299180,0,'2013-07-06 12:44:32',NULL,NULL),(51558,'59746','S','Polaris','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.368244,-113.118995,0,'2013-07-06 12:44:33',NULL,NULL),(13417,'13754','S','Stilesville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(46370,'53125','S','Fontana','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.543140,-88.566930,0,'2013-07-06 12:44:32',NULL,NULL),(46247,'53004','S','Belgium','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.498221,-87.860708,0,'2013-07-06 12:44:32',NULL,NULL),(45529,'51444','P','Halbur','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.008270,-94.973752,0,'2013-07-06 12:44:32',NULL,NULL),(45283,'50680','S','Wellsburg','D','Grundy','19075','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.433838,-92.927069,0,'2013-07-06 12:44:32',NULL,NULL),(27978,'30568','S','Rabun Gap','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.957065,-83.394861,0,'2013-07-06 12:44:31',NULL,NULL),(17728,'18249','S','Sugarloaf','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.992038,-76.073490,0,'2013-07-06 12:44:31',NULL,NULL),(8173,'07871','S','Sparta','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.039507,-74.623781,0,'2013-07-06 12:44:30',NULL,NULL),(20690,'21240','S','Millersville','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.175794,-76.666332,0,'2013-07-06 12:44:31',NULL,NULL),(33710,'37771','S','Lenoir City','D','Loudon','47105','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.792702,-84.266138,0,'2013-07-06 12:44:32',NULL,NULL),(56208,'65026','S','Lakeland','N','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(52354,'60609','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.812837,-87.654243,0,'2013-07-06 12:44:33',NULL,NULL),(33281,'37111','P','McMinnville','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.687754,-85.775514,0,'2013-07-06 12:44:32',NULL,NULL),(74465,'92595','S','Wildomar','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.594838,-117.256708,0,'2013-07-06 12:44:34',NULL,NULL),(75837,'94920','S','Belvedere Tiburon','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.893723,-122.471124,0,'2013-07-06 12:44:34',NULL,NULL),(66540,'78729','S','Austin','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.456180,-97.765080,0,'2013-07-06 12:44:34',NULL,NULL),(71948,'87940','S','Rincon','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.669772,-107.155647,0,'2013-07-06 12:44:34',NULL,NULL),(70235,'84404','S','West Warren','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(67373,'80118','S','Larkspur','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.206007,-104.888401,0,'2013-07-06 12:44:34',NULL,NULL),(45426,'51061','S','Washta','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.577838,-95.726145,0,'2013-07-06 12:44:32',NULL,NULL),(21728,'23009','S','Aylett','D','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.752552,-77.166999,0,'2013-07-06 12:44:31',NULL,NULL),(28037,'30647','P','Ila','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.172693,-83.292410,0,'2013-07-06 12:44:31',NULL,NULL),(37311,'41645','S','Warco','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.548556,-82.775409,0,'2013-07-06 12:44:32',NULL,NULL),(6145,'05465','S','Jericho','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.476140,-72.949800,0,'2013-07-06 12:44:30',NULL,NULL),(41799,'47327','S','Cambridge Cty','A','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.822189,-85.164134,0,'2013-07-06 12:44:32',NULL,NULL),(9987,'10165','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(75103,'93543','S','Juniper Hills','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.520996,-117.951674,0,'2013-07-06 12:44:34',NULL,NULL),(47467,'54737','S','Eau Galle','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.723211,-92.050773,0,'2013-07-06 12:44:32',NULL,NULL),(6600,'05866','S','Sheffield','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.639720,-72.125008,0,'2013-07-06 12:44:30',NULL,NULL),(19254,'19943','S','Felton','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.013699,-75.572862,0,'2013-07-06 12:44:31',NULL,NULL),(40216,'45406','S','Trotwood','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.794210,-84.270110,0,'2013-07-06 12:44:32',NULL,NULL),(27282,'29945','S','Whitehall','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(64827,'77035','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.651703,-95.479871,0,'2013-07-06 12:44:34',NULL,NULL),(57380,'66749','S','Carlyle','A','Allen','20001','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.926480,-95.402820,0,'2013-07-06 12:44:33',NULL,NULL),(53555,'62049','S','Hillsboro','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.155644,-89.482574,0,'2013-07-06 12:44:33',NULL,NULL),(66994,'79501','S','Radium','N','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.759811,-99.892214,0,'2013-07-06 12:44:34',NULL,NULL),(61332,'72457','P','Portia','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.077829,-91.064155,0,'2013-07-06 12:44:33',NULL,NULL),(59811,'71227','S','Choudrant','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.496780,-92.473320,0,'2013-07-06 12:44:33',NULL,NULL),(56014,'64657','S','Mc Fall','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.104867,-94.328531,0,'2013-07-06 12:44:33',NULL,NULL),(11932,'12430','S','Fleischmanns','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.195000,-74.550556,0,'2013-07-06 12:44:30',NULL,NULL),(3438,'01752','S','Marlborough','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.349703,-71.546947,0,'2013-07-06 12:44:30',NULL,NULL),(2696,'00969','S','Chalets De Altavista','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(27360,'30063','U','Lockheed','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928513,-84.522094,0,'2013-07-06 12:44:31',NULL,NULL),(1231,'00728','S','Villa Rio Canas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(39567,'44849','S','Wyandot','N','Wyandot','39175','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.826400,-83.130900,0,'2013-07-06 12:44:32',NULL,NULL),(19590,'20222','U','Us Treasurer','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898336,-77.032305,0,'2013-07-06 12:44:31',NULL,NULL),(21420,'22545','P','Ruby','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.504345,-77.517683,0,'2013-07-06 12:44:31',NULL,NULL),(313,'00646','S','Urb Palmar Dorado Norte','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(62220,'73901','P','Adams','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.829861,-101.155354,0,'2013-07-06 12:44:33',NULL,NULL),(18925,'19503','S','Bally','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.401509,-75.587981,0,'2013-07-06 12:44:31',NULL,NULL),(62989,'75149','S','Mesquite','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770243,-96.613013,0,'2013-07-06 12:44:33',NULL,NULL),(63583,'75782','P','Poynor','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.077631,-95.593471,0,'2013-07-06 12:44:34',NULL,NULL),(29369,'32580','S','Valparaiso','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.507402,-86.493872,0,'2013-07-06 12:44:32',NULL,NULL),(3409,'01704','P','Framingham','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.318232,-71.442658,0,'2013-07-06 12:44:30',NULL,NULL),(74678,'92869','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.786830,-117.793410,0,'2013-07-06 12:44:34',NULL,NULL),(75707,'94573','P','Rutherford','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.457920,-122.413366,0,'2013-07-06 12:44:34',NULL,NULL),(61805,'73099','S','Yukon','D','Canadian','40017','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.496256,-97.732383,0,'2013-07-06 12:44:33',NULL,NULL),(74085,'92187','U','San Diego Water Utilities','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.724875,-117.166229,0,'2013-07-06 12:44:34',NULL,NULL),(73978,'92085','P','Vista','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.191119,-117.228812,0,'2013-07-06 12:44:34',NULL,NULL),(72716,'89451','S','Incline Vlg','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.252736,-119.954554,0,'2013-07-06 12:44:34',NULL,NULL),(70729,'85299','P','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.332877,-111.763848,0,'2013-07-06 12:44:34',NULL,NULL),(64648,'76716','P','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.456986,-97.096657,0,'2013-07-06 12:44:34',NULL,NULL),(56581,'65542','S','Licking','D','Texas','29215','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.497845,-91.860699,0,'2013-07-06 12:44:33',NULL,NULL),(53402,'61831','S','Collison','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.215157,-87.804838,0,'2013-07-06 12:44:33',NULL,NULL),(22013,'23286','U','Richmond Brm','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557404,-77.447536,0,'2013-07-06 12:44:31',NULL,NULL),(12139,'12727','P','Cochecton Center','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.640608,-74.968130,0,'2013-07-06 12:44:30',NULL,NULL),(23715,'25888','U','Mount Hope','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.893074,-81.167686,0,'2013-07-06 12:44:31',NULL,NULL),(31721,'34972','S','Yeehaw','A','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.325224,-80.849484,0,'2013-07-06 12:44:32',NULL,NULL),(10060,'10177','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(15935,'17021','S','Spears Grove','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(16061,'17047','S','NE Madison','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(22961,'24701','S','Ceres','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(17707,'18229','S','Jim Thorpe','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.878328,-75.737345,0,'2013-07-06 12:44:31',NULL,NULL),(54284,'62694','S','Winchester','D','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.550556,-90.480000,0,'2013-07-06 12:44:33',NULL,NULL),(63593,'75789','S','Henrys Chapel','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(19797,'20436','U','International Trade Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897567,-77.024098,0,'2013-07-06 12:44:31',NULL,NULL),(57426,'66780','S','Porterville','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.600473,-95.081169,0,'2013-07-06 12:44:33',NULL,NULL),(51746,'60018','S','Des Plaines','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.002700,-87.900840,0,'2013-07-06 12:44:33',NULL,NULL),(36643,'41005','S','Camp Ernest','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(45353,'50982','U','HP Enterprise Services','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582732,-93.639236,0,'2013-07-06 12:44:32',NULL,NULL),(72166,'88341','S','Nogal','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.498498,-105.738234,0,'2013-07-06 12:44:34',NULL,NULL),(79928,'99612','P','King Cove','D','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.376913,-161.942503,0,'2013-07-06 12:44:34',NULL,NULL),(78899,'98360','S','Orting','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.087937,-122.185345,0,'2013-07-06 12:44:34',NULL,NULL),(76861,'95968','S','Palermo','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.439932,-121.547060,0,'2013-07-06 12:44:34',NULL,NULL),(76635,'95714','P','Dutch Flat','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.203253,-120.824838,0,'2013-07-06 12:44:34',NULL,NULL),(75394,'93962','P','Spreckels','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.677778,-121.654444,0,'2013-07-06 12:44:34',NULL,NULL),(69669,'84017','S','Upton','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.804680,-111.296340,0,'2013-07-06 12:44:34',NULL,NULL),(61677,'72933','S','Charleston','D','Franklin','05047','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.301920,-94.042905,0,'2013-07-06 12:44:33',NULL,NULL),(61155,'72176','S','Butlerville','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.018174,-91.946490,0,'2013-07-06 12:44:33',NULL,NULL),(60020,'71340','S','Harrisonburg','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.795110,-91.893312,0,'2013-07-06 12:44:33',NULL,NULL),(53193,'61610','S','Creve Coeur','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.660110,-89.578136,0,'2013-07-06 12:44:33',NULL,NULL),(52061,'60208','U','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.058010,-87.674825,0,'2013-07-06 12:44:33',NULL,NULL),(79853,'99552','P','Akiak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.879032,-161.190193,0,'2013-07-06 12:44:34',NULL,NULL),(30681,'33470','S','Village of Wellington','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(49661,'57004','S','Alsen','N','Union','46127','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.084200,-96.780660,0,'2013-07-06 12:44:33',NULL,NULL),(40041,'45252','S','Colerain TWP','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.272712,-84.627394,0,'2013-07-06 12:44:32',NULL,NULL),(59509,'70782','P','Tunica','D','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.929599,-91.555010,0,'2013-07-06 12:44:33',NULL,NULL),(64145,'76198','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755079,-97.332446,0,'2013-07-06 12:44:34',NULL,NULL),(28938,'32176','S','Ormond Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.325915,-81.057810,0,'2013-07-06 12:44:32',NULL,NULL),(39298,'44503','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.097435,-80.652249,0,'2013-07-06 12:44:32',NULL,NULL),(41592,'47102','S','Austin','D','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.743476,-85.804590,0,'2013-07-06 12:44:32',NULL,NULL),(6284,'05641','S','Lower Websterville','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(1241,'00729','S','Parc Central','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(48677,'55923','S','Chatfield','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.842309,-92.183188,0,'2013-07-06 12:44:33',NULL,NULL),(48184,'55388','S','Minnetrista','A','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.954544,-93.846907,0,'2013-07-06 12:44:33',NULL,NULL),(19228,'19901','S','Dover','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.149969,-75.531543,0,'2013-07-06 12:44:31',NULL,NULL),(21264,'22306','S','Community','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.760953,-77.095861,0,'2013-07-06 12:44:31',NULL,NULL),(47560,'54837','S','Frederic','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.703572,-92.475946,0,'2013-07-06 12:44:32',NULL,NULL),(47534,'54814','S','Apostle Islands National Lak','N','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.824360,-90.830460,0,'2013-07-06 12:44:32',NULL,NULL),(73378,'91046','P','Verdugo City','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.209793,-118.241838,0,'2013-07-06 12:44:34',NULL,NULL),(72473,'89124','S','Mount Charleston','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(56137,'64840','S','Diamond','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.837638,-94.376662,0,'2013-07-06 12:44:33',NULL,NULL),(5210,'04457','S','Mattamisc Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(37550,'42064','S','Mattoon','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(45350,'50981','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582831,-93.639369,0,'2013-07-06 12:44:32',NULL,NULL),(70859,'85601','P','Arivaca','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.577995,-111.329883,0,'2013-07-06 12:44:34',NULL,NULL),(23061,'24870','S','Rollins Branch','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.711020,-81.604020,0,'2013-07-06 12:44:31',NULL,NULL),(12207,'12788','S','Woodbourne','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.807448,-74.609122,0,'2013-07-06 12:44:30',NULL,NULL),(60100,'71360','S','Paradise','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(5009,'04224','S','Dixfield','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.542585,-70.453768,0,'2013-07-06 12:44:30',NULL,NULL),(51431,'59460','S','Loma','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.003340,-110.389738,0,'2013-07-06 12:44:33',NULL,NULL),(16113,'17055','S','Mechbg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(74219,'92311','S','Hodge','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.887322,-117.037597,0,'2013-07-06 12:44:34',NULL,NULL),(10069,'10178','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(65973,'78294','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.427115,-98.486051,0,'2013-07-06 12:44:34',NULL,NULL),(45313,'50842','S','Cromwell','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.078174,-94.391882,0,'2013-07-06 12:44:32',NULL,NULL),(60063,'71353','S','Elba','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(27160,'29834','P','Langley','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.513651,-81.847009,0,'2013-07-06 12:44:31',NULL,NULL),(24870,'27675','P','Westgate','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.904343,-78.742412,0,'2013-07-06 12:44:31',NULL,NULL),(32519,'36088','S','Tuskegee Inst','A','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.413395,-85.721531,0,'2013-07-06 12:44:32',NULL,NULL),(2678,'00966','S','Villas De Trujillo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(36105,'40220','S','Saint Regis Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(52417,'60644','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.881955,-87.757606,0,'2013-07-06 12:44:33',NULL,NULL),(11311,'11780','S','Flowerfield','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(5260,'04487','S','Prentiss Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.393599,-68.101456,0,'2013-07-06 12:44:30',NULL,NULL),(61452,'72616','S','Rudd','N','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367020,-93.580140,0,'2013-07-06 12:44:33',NULL,NULL),(49126,'56361','S','Parkers Pr','A','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.153362,-95.330911,0,'2013-07-06 12:44:33',NULL,NULL),(24525,'27288','S','Eden','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(46208,'52757','P','Low Moor','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.838174,-90.478930,0,'2013-07-06 12:44:32',NULL,NULL),(22320,'23844','S','Drewryville','D','Southampton','51175','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.682602,-77.360606,0,'2013-07-06 12:44:31',NULL,NULL),(73228,'90638','S','Lamirada','A','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.906013,-118.005828,0,'2013-07-06 12:44:34',NULL,NULL),(7555,'07017','S','Doddtown','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.772043,-74.209455,0,'2013-07-06 12:44:30',NULL,NULL),(64502,'76630','S','Bruceville Eddy','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.331159,-97.249823,0,'2013-07-06 12:44:34',NULL,NULL),(9840,'10116','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(30865,'33664','U','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.967760,-82.518250,0,'2013-07-06 12:44:32',NULL,NULL),(39883,'45211','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.158460,-84.594600,0,'2013-07-06 12:44:32',NULL,NULL),(79209,'98538','S','Curtis','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.522826,-123.121792,0,'2013-07-06 12:44:34',NULL,NULL),(15736,'16901','S','Duncan','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(12471,'12983','S','Lake Colby','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.316720,-74.133540,0,'2013-07-06 12:44:30',NULL,NULL),(29466,'32718','P','Casselberry','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.663263,-81.324774,0,'2013-07-06 12:44:32',NULL,NULL),(51172,'59007','S','Washoe','A','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.161087,-109.156095,0,'2013-07-06 12:44:33',NULL,NULL),(75319,'93765','U','Aetna Life and Casualty','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.833866,-119.828970,0,'2013-07-06 12:44:34',NULL,NULL),(57246,'66527','S','Powhattan','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.761740,-95.633310,0,'2013-07-06 12:44:33',NULL,NULL),(699,'00685','S','Urb Los Alamos','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(67323,'80033','S','Denver','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.772041,-105.101411,0,'2013-07-06 12:44:34',NULL,NULL),(20649,'21224','S','Highlandtown','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.280680,-76.537980,0,'2013-07-06 12:44:31',NULL,NULL),(46951,'54171','S','Sobieski','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.721600,-88.124160,0,'2013-07-06 12:44:32',NULL,NULL),(66443,'78648','S','Stairtown','N','Caldwell','48055','Texas','TX','48','0640','830','Central',-6.0,'Y',29.678992,-97.646226,0,'2013-07-06 12:44:34',NULL,NULL),(5845,'05091','S','W Woodstock','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627860,-72.537180,0,'2013-07-06 12:44:30',NULL,NULL),(24954,'27833','P','Greenville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.597011,-77.375799,0,'2013-07-06 12:44:31',NULL,NULL),(52476,'60688','U','Jt Weeker Isc','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.846809,-87.649947,0,'2013-07-06 12:44:33',NULL,NULL),(76579,'95678','S','Roseville','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.765901,-121.289424,0,'2013-07-06 12:44:34',NULL,NULL),(66524,'78716','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.322895,-97.864038,0,'2013-07-06 12:44:34',NULL,NULL),(73146,'90275','S','Rolling Hills Estates','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(25593,'28448','S','Kelly','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.478193,-78.314764,0,'2013-07-06 12:44:31',NULL,NULL),(9973,'10162','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(53853,'62325','S','Coatsburg','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.031870,-91.158865,0,'2013-07-06 12:44:33',NULL,NULL),(61867,'73125','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.456217,-97.528691,0,'2013-07-06 12:44:33',NULL,NULL),(32891,'36533','P','Fairhope','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.491518,-87.855545,0,'2013-07-06 12:44:32',NULL,NULL),(21224,'22215','P','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.858463,-77.048962,0,'2013-07-06 12:44:31',NULL,NULL),(25613,'28459','P','Shallotte','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.907639,-78.482064,0,'2013-07-06 12:44:31',NULL,NULL),(30990,'33763','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.001976,-82.746528,0,'2013-07-06 12:44:32',NULL,NULL),(16453,'17238','S','Sipes Mill','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.873300,-78.140520,0,'2013-07-06 12:44:31',NULL,NULL),(66470,'78658','P','Ottine','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.599030,-97.584414,0,'2013-07-06 12:44:34',NULL,NULL),(32209,'35559','P','Glen Allen','D','Fayette','01057','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.882529,-87.744808,0,'2013-07-06 12:44:32',NULL,NULL),(76585,'95682','S','Shingle Spgs','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.656055,-120.961681,0,'2013-07-06 12:44:34',NULL,NULL),(77697,'97041','S','Parkdale','N','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(7147,'06413','S','Clinton','D','Middlesex','09007','Connecticut','CT','09','5480','860/959','Eastern',-5.0,'Y',41.291966,-72.530871,0,'2013-07-06 12:44:30',NULL,NULL),(74629,'92806','S','Sunkist','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.835569,-117.868059,0,'2013-07-06 12:44:34',NULL,NULL),(38613,'43907','S','Cadiz','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.258860,-81.031320,0,'2013-07-06 12:44:32',NULL,NULL),(61339,'72464','P','Saint Francis','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.452763,-90.141674,0,'2013-07-06 12:44:33',NULL,NULL),(78700,'98259','P','N Lakewood','A','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.164986,-122.299200,0,'2013-07-06 12:44:34',NULL,NULL),(17400,'17901','S','Hillside','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(75223,'93640','S','Mendota','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.729057,-120.389166,0,'2013-07-06 12:44:34',NULL,NULL),(14160,'14726','S','Conewango Valley','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.238377,-79.060848,0,'2013-07-06 12:44:31',NULL,NULL),(79760,'99320','S','Benton City','D','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.256964,-119.471504,0,'2013-07-06 12:44:34',NULL,NULL),(73628,'91411','S','Sherman Oaks','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.179000,-118.447380,0,'2013-07-06 12:44:34',NULL,NULL),(38875,'44105','S','Newburgh Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.452479,-81.625585,0,'2013-07-06 12:44:32',NULL,NULL),(25650,'28469','S','Shallotte','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.923901,-78.459091,0,'2013-07-06 12:44:31',NULL,NULL),(37352,'41721','S','Buckhorn','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.304153,-83.492093,0,'2013-07-06 12:44:32',NULL,NULL),(8320,'08034','S','Cherry Hill','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908086,-75.004604,0,'2013-07-06 12:44:30',NULL,NULL),(21726,'23005','S','Ashaiiu','N','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.747553,-77.471865,0,'2013-07-06 12:44:31',NULL,NULL),(27589,'30288','S','Conley','D','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.655490,-84.331675,0,'2013-07-06 12:44:31',NULL,NULL),(53905,'62365','S','Richfield','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.828285,-91.193150,0,'2013-07-06 12:44:33',NULL,NULL),(43418,'48465','S','Minden City','A','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.629223,-82.631547,0,'2013-07-06 12:44:32',NULL,NULL),(76794,'95945','S','Grass Valley','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(55028,'63136','S','Jennings','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.743590,-90.261616,0,'2013-07-06 12:44:33',NULL,NULL),(46970,'54210','S','Ellison Bay','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.261249,-87.042797,0,'2013-07-06 12:44:32',NULL,NULL),(13544,'13827','S','Waits','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(77850,'97224','S','Tigard','A','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.408703,-122.789445,0,'2013-07-06 12:44:34',NULL,NULL),(77981,'97388','P','Gleneden Beach','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.884662,-124.031114,0,'2013-07-06 12:44:34',NULL,NULL),(64722,'76877','S','Algerita','N','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.195610,-98.725363,0,'2013-07-06 12:44:34',NULL,NULL),(1105,'00725','S','Urb Paradise','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(18729,'19320','S','Romansville','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(50071,'57448','S','Hosmer','D','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.548331,-99.524184,0,'2013-07-06 12:44:33',NULL,NULL),(49433,'56634','S','Clearbrook','D','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.831879,-95.319135,0,'2013-07-06 12:44:33',NULL,NULL),(4318,'02912','U','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.824987,-71.400763,0,'2013-07-06 12:44:30',NULL,NULL),(76121,'95245','S','Mokelumne Hill','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.305939,-120.598225,0,'2013-07-06 12:44:34',NULL,NULL),(77078,'96130','S','California Conservation Cent','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417140,-120.641220,0,'2013-07-06 12:44:34',NULL,NULL),(29760,'33008','P','Golden Isles','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986952,-80.140539,0,'2013-07-06 12:44:32',NULL,NULL),(71762,'87552','S','Los Pachecos','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(65509,'77702','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.085202,-94.133166,0,'2013-07-06 12:44:34',NULL,NULL),(56744,'65720','S','Oldfield','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.967713,-93.024561,0,'2013-07-06 12:44:33',NULL,NULL),(14743,'15314','S','Bentleyville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.133934,-80.012058,0,'2013-07-06 12:44:31',NULL,NULL),(23695,'25864','S','Lawton','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.871329,-80.996894,0,'2013-07-06 12:44:31',NULL,NULL),(62595,'74501','S','Haywood','A','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.935281,-95.767139,0,'2013-07-06 12:44:33',NULL,NULL),(42342,'47637','S','Tennyson','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.128740,-87.148763,0,'2013-07-06 12:44:32',NULL,NULL),(36582,'40958','S','Kettle Island','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.818992,-83.585177,0,'2013-07-06 12:44:32',NULL,NULL),(76705,'95834','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.642678,-121.520969,0,'2013-07-06 12:44:34',NULL,NULL),(30176,'33175','S','Olympia Heights','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729688,-80.410127,0,'2013-07-06 12:44:32',NULL,NULL),(49663,'57004','S','Emmet','N','Union','46127','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.084200,-96.780660,0,'2013-07-06 12:44:33',NULL,NULL),(45844,'52223','S','Hazel Green','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.429786,-91.330245,0,'2013-07-06 12:44:32',NULL,NULL),(78868,'98349','S','Lakebay','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.280780,-122.773440,0,'2013-07-06 12:44:34',NULL,NULL),(47770,'55038','S','Hugo','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.163580,-92.956430,0,'2013-07-06 12:44:33',NULL,NULL),(37812,'42408','S','Dawson Springs','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.189860,-87.687240,0,'2013-07-06 12:44:32',NULL,NULL),(64867,'77059','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.608785,-95.114041,0,'2013-07-06 12:44:34',NULL,NULL),(64326,'76491','S','Woodson','D','Throckmorton','48447','Texas','TX','48','0000','940','Central',-6.0,'Y',33.015230,-99.055980,0,'2013-07-06 12:44:34',NULL,NULL),(57607,'67117','S','Newton','A','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.134080,-97.321620,0,'2013-07-06 12:44:33',NULL,NULL),(41083,'46534','S','Knox','D','Starke','18149','Indiana','IN','18','0000','574','Central',-6.0,'Y',41.299044,-86.616720,0,'2013-07-06 12:44:32',NULL,NULL),(73194,'90507','P','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.831799,-118.318215,0,'2013-07-06 12:44:34',NULL,NULL),(67191,'79902','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.789027,-106.499183,0,'2013-07-06 12:44:34',NULL,NULL),(52673,'61075','S','Scales Mound','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.466454,-90.253838,0,'2013-07-06 12:44:33',NULL,NULL),(17753,'18326','S','Laanna','N','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.160326,-75.252633,0,'2013-07-06 12:44:31',NULL,NULL),(33057,'36759','S','Marion Junction','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.440860,-87.349080,0,'2013-07-06 12:44:32',NULL,NULL),(985,'00716','S','Villa Tabaiba','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(30079,'33155','S','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737315,-80.309137,0,'2013-07-06 12:44:32',NULL,NULL),(73697,'91607','S','Sherman Vlg','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(2790,'00976','S','Urb Antillana','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(66263,'78576','S','Penitas','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.314445,-98.391453,0,'2013-07-06 12:44:34',NULL,NULL),(60055,'71350','S','Mansura Junction','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.083712,-92.022496,0,'2013-07-06 12:44:33',NULL,NULL),(11838,'12245','U','NY Dept Commerce','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.671218,-73.772898,0,'2013-07-06 12:44:30',NULL,NULL),(72228,'88435','S','Pintada','N','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.936606,-104.684358,0,'2013-07-06 12:44:34',NULL,NULL),(30518,'33404','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(30159,'33170','S','Cutler Ridge','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556966,-80.464922,0,'2013-07-06 12:44:32',NULL,NULL),(142,'00617','S','Ext Parc Punta Palmas','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(71179,'86043','P','Second Mesa','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.805000,-110.491944,0,'2013-07-06 12:44:34',NULL,NULL),(19493,'20155','S','Gainesville','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.783480,-77.655222,0,'2013-07-06 12:44:31',NULL,NULL),(5114,'04358','S','Weeks Mills','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.398705,-69.582961,0,'2013-07-06 12:44:30',NULL,NULL),(34810,'38879','P','Verona','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.185371,-88.721819,0,'2013-07-06 12:44:32',NULL,NULL),(6194,'05483','S','Fairfield Pond','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(24484,'27248','S','Millboro','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.749129,-79.701339,0,'2013-07-06 12:44:31',NULL,NULL),(14973,'15633','P','Forbes Rd','N','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.358425,-79.524654,0,'2013-07-06 12:44:31',NULL,NULL),(30761,'33571','P','Ruskin','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.720556,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(72036,'88058','P','San Miguel','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.108622,-106.679250,0,'2013-07-06 12:44:34',NULL,NULL),(63758,'75941','S','Diboll','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.187357,-94.786365,0,'2013-07-06 12:44:34',NULL,NULL),(59358,'70576','P','Pine Prairie','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.784223,-92.424430,0,'2013-07-06 12:44:33',NULL,NULL),(57227,'66507','S','Maple Hill','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.084901,-96.027133,0,'2013-07-06 12:44:33',NULL,NULL),(52839,'61316','P','Cedar Point','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.261982,-89.126798,0,'2013-07-06 12:44:33',NULL,NULL),(47434,'54703','S','Eau Claire','D','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.824477,-91.498625,0,'2013-07-06 12:44:32',NULL,NULL),(24664,'27406','S','Vandalia','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.021374,-79.767916,0,'2013-07-06 12:44:31',NULL,NULL),(64552,'76653','S','Denny','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.314780,-96.621000,0,'2013-07-06 12:44:34',NULL,NULL),(62572,'74458','P','Redbird','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.885284,-95.587137,0,'2013-07-06 12:44:33',NULL,NULL),(62071,'73552','S','Indiahoma','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.619739,-98.754144,0,'2013-07-06 12:44:33',NULL,NULL),(1936,'00795','S','Urb San Martin','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(32650,'36251','S','Harkins Crossroads','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(44826,'50250','S','Dale','N','Guthrie','19077','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.502010,-94.316481,0,'2013-07-06 12:44:32',NULL,NULL),(47875,'55085','P','Vermillion','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.672835,-92.966482,0,'2013-07-06 12:44:33',NULL,NULL),(68697,'82053','S','Egbert','A','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.218272,-104.362776,0,'2013-07-06 12:44:34',NULL,NULL),(62613,'74536','S','Clayton','D','Pushmataha','40127','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.574176,-95.482504,0,'2013-07-06 12:44:33',NULL,NULL),(27663,'30327','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.865889,-84.425245,0,'2013-07-06 12:44:31',NULL,NULL),(15322,'16172','U','New Wilmngtn','A','Lawrence','42073','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.122710,-80.336002,0,'2013-07-06 12:44:31',NULL,NULL),(33757,'37854','S','Ozone','A','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.862451,-84.679796,0,'2013-07-06 12:44:32',NULL,NULL),(31229,'33967','S','S Fort Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637179,-81.872520,0,'2013-07-06 12:44:32',NULL,NULL),(34013,'38125','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.029029,-89.810269,0,'2013-07-06 12:44:32',NULL,NULL),(60414,'71639','S','Reedville','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(76548,'95664','S','Pilot Hill','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.820434,-121.023542,0,'2013-07-06 12:44:34',NULL,NULL),(64608,'76687','S','Davis Prairie','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.402692,-96.489597,0,'2013-07-06 12:44:34',NULL,NULL),(61653,'72865','S','Subiaco','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.327466,-93.634301,0,'2013-07-06 12:44:33',NULL,NULL),(54020,'62454','S','Gordons','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(60178,'71414','P','Clarence','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.820111,-93.027243,0,'2013-07-06 12:44:33',NULL,NULL),(51690,'59936','P','Apgar','N','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.497200,-113.989197,0,'2013-07-06 12:44:33',NULL,NULL),(30300,'33283','P','Town & Country Postal Store','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.699280,-80.381577,0,'2013-07-06 12:44:32',NULL,NULL),(46033,'52556','S','Fairfield','D','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005170,-91.968732,0,'2013-07-06 12:44:32',NULL,NULL),(21511,'22714','S','Brandy Station','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.523104,-77.898372,0,'2013-07-06 12:44:31',NULL,NULL),(4407,'03223','S','Campton','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.876228,-71.679742,0,'2013-07-06 12:44:30',NULL,NULL),(2529,'00957','S','Villa Arrieta','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(55993,'64638','S','Dawn','D','Livingston','29117','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.664408,-93.588363,0,'2013-07-06 12:44:33',NULL,NULL),(49511,'56669','S','Kabetogama','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.411180,-93.194700,0,'2013-07-06 12:44:33',NULL,NULL),(21188,'22182','S','Vienna','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.928478,-77.261486,0,'2013-07-06 12:44:31',NULL,NULL),(36767,'41041','S','Sherburne','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(1510,'00754','S','Ext Alt de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(76110,'95230','S','Farmington','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.908184,-120.980728,0,'2013-07-06 12:44:34',NULL,NULL),(62724,'74802','P','Shawnee','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.325355,-96.922237,0,'2013-07-06 12:44:33',NULL,NULL),(39509,'44807','S','Siam','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(51211,'59044','S','Laurel','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.672778,-108.760361,0,'2013-07-06 12:44:33',NULL,NULL),(46521,'53278','U','US Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.039450,-87.900295,0,'2013-07-06 12:44:32',NULL,NULL),(37247,'41557','S','Fishtrap','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.498447,-82.428405,0,'2013-07-06 12:44:32',NULL,NULL),(44929,'50340','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587244,-93.617538,0,'2013-07-06 12:44:32',NULL,NULL),(49516,'56672','S','Lima','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(63122,'75315','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770497,-96.769117,0,'2013-07-06 12:44:33',NULL,NULL),(45992,'52501','S','Dahlonega','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(52799,'61276','P','Preemption','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.275943,-90.608721,0,'2013-07-06 12:44:33',NULL,NULL),(77996,'97405','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.949460,-123.128040,0,'2013-07-06 12:44:34',NULL,NULL),(78561,'98155','S','North City','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(31922,'35173','S','Whites Chapel','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.642480,-86.584020,0,'2013-07-06 12:44:32',NULL,NULL),(2804,'00976','S','Urb Riachuelo','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(65278,'77480','S','Ashwood','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.059338,-95.705377,0,'2013-07-06 12:44:34',NULL,NULL),(14366,'15024','S','Cheswick','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.565385,-79.831793,0,'2013-07-06 12:44:31',NULL,NULL),(31804,'35048','P','Clay','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.735659,-86.570205,0,'2013-07-06 12:44:32',NULL,NULL),(34631,'38756','S','Magenta','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(53990,'62441','S','Oliver','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.400200,-87.694680,0,'2013-07-06 12:44:33',NULL,NULL),(8141,'07839','P','Greendell','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.974687,-74.820705,0,'2013-07-06 12:44:30',NULL,NULL),(29583,'32822','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.505058,-81.290138,0,'2013-07-06 12:44:32',NULL,NULL),(27179,'29845','S','Plum Branch','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.816772,-82.235638,0,'2013-07-06 12:44:31',NULL,NULL),(19850,'20510','U','US Senate','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889190,-77.008664,0,'2013-07-06 12:44:31',NULL,NULL),(74406,'92532','S','Lake Elsinore','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.661456,-117.278423,0,'2013-07-06 12:44:34',NULL,NULL),(27757,'30360','S','Winters Chapel','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928090,-84.278530,0,'2013-07-06 12:44:31',NULL,NULL),(23962,'26291','S','Slatyfork','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.388523,-80.065331,0,'2013-07-06 12:44:31',NULL,NULL),(60662,'71921','S','Amity','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(58352,'68506','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.787792,-96.653231,0,'2013-07-06 12:44:33',NULL,NULL),(14605,'15225','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.515120,-80.087760,0,'2013-07-06 12:44:31',NULL,NULL),(32000,'35226','S','Hoover','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(23823,'26101','S','Parkersburg','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.263058,-81.536120,0,'2013-07-06 12:44:31',NULL,NULL),(17313,'17857','S','Northumberland','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893520,-76.797765,0,'2013-07-06 12:44:31',NULL,NULL),(3562,'01950','S','Newburyport','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.811261,-70.877264,0,'2013-07-06 12:44:30',NULL,NULL),(279,'00646','S','Jard de Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(27290,'30005','S','Alpharetta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.080610,-84.200785,0,'2013-07-06 12:44:31',NULL,NULL),(73351,'91009','P','Duarte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.139758,-117.967298,0,'2013-07-06 12:44:34',NULL,NULL),(50250,'57626','S','Moreau','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(43054,'48185','S','Westland','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.341489,-83.397113,0,'2013-07-06 12:44:32',NULL,NULL),(37382,'41749','S','Confluence','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164468,-83.437621,0,'2013-07-06 12:44:32',NULL,NULL),(33520,'37377','S','Signal Mountain','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.147329,-85.330097,0,'2013-07-06 12:44:32',NULL,NULL),(31755,'34991','P','Palm City','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.161314,-80.268451,0,'2013-07-06 12:44:32',NULL,NULL),(2093,'00923','S','65th Infantry','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(2832,'00981','P','Isla Verde','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.406458,-65.978643,0,'2013-07-06 12:44:30',NULL,NULL),(17838,'18421','S','Richmondale','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(14381,'15035','S','E McKeesport','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.380214,-79.806760,0,'2013-07-06 12:44:31',NULL,NULL),(79646,'99143','S','La Crosse','N','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.773540,-117.863160,0,'2013-07-06 12:44:34',NULL,NULL),(7061,'06331','S','South Canterbury','N','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.693971,-72.004297,0,'2013-07-06 12:44:30',NULL,NULL),(74118,'92234','S','Cathedral City','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.822485,-116.462762,0,'2013-07-06 12:44:34',NULL,NULL),(24530,'27289','P','Eden','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.504390,-79.741267,0,'2013-07-06 12:44:31',NULL,NULL),(14779,'15350','P','Muse','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.294494,-80.201573,0,'2013-07-06 12:44:31',NULL,NULL),(16369,'17201','S','Letterkenny Army Depo','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(61443,'72601','S','Zinc','N','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.238821,-93.114328,0,'2013-07-06 12:44:33',NULL,NULL),(34750,'38852','S','North Crossroads','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(57322,'66711','S','Arcadia','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.625557,-94.701799,0,'2013-07-06 12:44:33',NULL,NULL),(74023,'92129','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.966476,-117.119682,0,'2013-07-06 12:44:34',NULL,NULL),(9352,'09807','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(25422,'28302','P','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.033259,-78.929040,0,'2013-07-06 12:44:31',NULL,NULL),(6596,'05862','S','East Peacham','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.338056,-72.157778,0,'2013-07-06 12:44:30',NULL,NULL),(36149,'40241','S','Fincastle','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(60017,'71336','S','Gilbert','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.009880,-91.568530,0,'2013-07-06 12:44:33',NULL,NULL),(58116,'68124','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.238073,-96.055759,0,'2013-07-06 12:44:33',NULL,NULL),(38332,'43433','P','Gypsum','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.502503,-82.871469,0,'2013-07-06 12:44:32',NULL,NULL),(52878,'61342','S','Meriden','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.540805,-89.106262,0,'2013-07-06 12:44:33',NULL,NULL),(73028,'90073','P','Veterans Adm','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.052501,-118.455227,0,'2013-07-06 12:44:34',NULL,NULL),(65826,'78150','S','Jbsa Randolph','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(23503,'25529','S','Julian','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.149998,-81.862075,0,'2013-07-06 12:44:31',NULL,NULL),(74391,'92516','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.953169,-117.394835,0,'2013-07-06 12:44:34',NULL,NULL),(75550,'94244','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.588001,-121.493785,0,'2013-07-06 12:44:34',NULL,NULL),(993,'00717','S','Bo Cuatro Calles','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(39841,'45162','S','Edenton','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.296640,-84.086520,0,'2013-07-06 12:44:32',NULL,NULL),(49346,'56570','S','Osage','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.932684,-95.224283,0,'2013-07-06 12:44:33',NULL,NULL),(14306,'14884','S','Swain','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.454043,-77.895389,0,'2013-07-06 12:44:31',NULL,NULL),(67508,'80237','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.644373,-104.899832,0,'2013-07-06 12:44:34',NULL,NULL),(19128,'19608','S','Wyomissing','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(77014,'96090','P','Tehama','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.025341,-122.124208,0,'2013-07-06 12:44:34',NULL,NULL),(10865,'11416','S','Ozone Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.684494,-73.850427,0,'2013-07-06 12:44:30',NULL,NULL),(9444,'10005','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(40080,'45299','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.103830,-84.507547,0,'2013-07-06 12:44:32',NULL,NULL),(33315,'37135','S','Nolensville','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.944130,-86.672903,0,'2013-07-06 12:44:32',NULL,NULL),(32787,'36420','S','Sanford','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(29879,'33042','S','Lower Sugarloaf Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(67682,'80511','P','Estes Park','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.338655,-105.563994,0,'2013-07-06 12:44:34',NULL,NULL),(7102,'06365','S','Norwich','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.513587,-71.999442,0,'2013-07-06 12:44:30',NULL,NULL),(31351,'34201','S','University Pk','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.390254,-82.481246,0,'2013-07-06 12:44:32',NULL,NULL),(8752,'08533','S','New Egypt','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.083333,-74.500000,0,'2013-07-06 12:44:30',NULL,NULL),(58361,'68517','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.926162,-96.604232,0,'2013-07-06 12:44:33',NULL,NULL),(60707,'71949','S','Buckville','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.710102,-93.220625,0,'2013-07-06 12:44:33',NULL,NULL),(24312,'27017','S','Rockford','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(56474,'65321','S','Elmwood','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.104512,-93.486773,0,'2013-07-06 12:44:33',NULL,NULL),(55323,'63545','S','Green City','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.266332,-92.952465,0,'2013-07-06 12:44:33',NULL,NULL),(42896,'48097','S','Lynn','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.116201,-82.794016,0,'2013-07-06 12:44:32',NULL,NULL),(31045,'33820','P','Alturas','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.862327,-81.710585,0,'2013-07-06 12:44:32',NULL,NULL),(36310,'40374','S','Bethel','A','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.245000,-83.868056,0,'2013-07-06 12:44:32',NULL,NULL),(32821,'36458','P','Mexia','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.394385,-87.416332,0,'2013-07-06 12:44:32',NULL,NULL),(57849,'67563','S','Offerle','D','Edwards','20047','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.869811,-99.515779,0,'2013-07-06 12:44:33',NULL,NULL),(68474,'81242','P','Poncha Springs','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.514511,-106.074083,0,'2013-07-06 12:44:34',NULL,NULL),(28877,'32120','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.195928,-81.049011,0,'2013-07-06 12:44:32',NULL,NULL),(67759,'80631','S','Garden City','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.418082,-104.708389,0,'2013-07-06 12:44:34',NULL,NULL),(62547,'74437','S','Henryetta','D','Okmulgee','40111','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.441280,-95.968680,0,'2013-07-06 12:44:33',NULL,NULL),(6968,'06235','S','North Windham','A','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.808838,-72.115007,0,'2013-07-06 12:44:30',NULL,NULL),(3824,'02325','U','Bridgewater','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.992179,-70.972402,0,'2013-07-06 12:44:30',NULL,NULL),(6507,'05820','S','Albany','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.882839,-72.215376,0,'2013-07-06 12:44:30',NULL,NULL),(47965,'55122','S','Saint Paul','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.801661,-93.199294,0,'2013-07-06 12:44:33',NULL,NULL),(66641,'78836','P','Asherton','N','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.347138,-99.612818,0,'2013-07-06 12:44:34',NULL,NULL),(61782,'73071','S','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.244565,-97.415094,0,'2013-07-06 12:44:33',NULL,NULL),(9959,'10158','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(15590,'16666','S','Osceola Mills','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.851689,-78.271985,0,'2013-07-06 12:44:31',NULL,NULL),(12990,'13408','S','Morrisville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.905156,-75.677630,0,'2013-07-06 12:44:30',NULL,NULL),(31117,'33897','S','Davenport','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.199309,-81.618630,0,'2013-07-06 12:44:32',NULL,NULL),(32478,'36043','S','Hope Hull','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.230319,-86.367123,0,'2013-07-06 12:44:32',NULL,NULL),(34771,'38863','S','Possum Trot','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(44713,'50145','P','Liberty Center','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.206742,-93.498722,0,'2013-07-06 12:44:32',NULL,NULL),(15828,'16933','S','Rutland','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(62679,'74702','P','Durant','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.932203,-96.435229,0,'2013-07-06 12:44:33',NULL,NULL),(42536,'47862','S','Reserve','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.789289,-87.373004,0,'2013-07-06 12:44:32',NULL,NULL),(22887,'24578','S','Natural Bridge','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.665785,-79.551093,0,'2013-07-06 12:44:31',NULL,NULL),(76191,'95346','S','Mi Wuk Village','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.067102,-120.180965,0,'2013-07-06 12:44:34',NULL,NULL),(277,'00646','S','Dorado','D','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(6517,'05824','S','Concord','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.435400,-71.854320,0,'2013-07-06 12:44:30',NULL,NULL),(18890,'19468','S','Linfield','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.196820,-75.539280,0,'2013-07-06 12:44:31',NULL,NULL),(66942,'79364','S','Ransom Canyon','A','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.436854,-101.646192,0,'2013-07-06 12:44:34',NULL,NULL),(65345,'77520','S','Old River-Winfree','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(65178,'77418','S','Bellview','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(57297,'66620','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',38.946624,-95.715745,0,'2013-07-06 12:44:33',NULL,NULL),(3712,'02142','S','Kendall Square','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.366561,-71.087556,0,'2013-07-06 12:44:30',NULL,NULL),(9589,'10029','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.790284,-73.946781,0,'2013-07-06 12:44:30',NULL,NULL),(10905,'11427','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(25204,'28078','S','Long Creek','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.414040,-80.852580,0,'2013-07-06 12:44:31',NULL,NULL),(16477,'17247','P','Quincy','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.802622,-77.573943,0,'2013-07-06 12:44:31',NULL,NULL),(6551,'05843','S','Hardwick','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.504809,-72.357211,0,'2013-07-06 12:44:30',NULL,NULL),(3728,'02153','P','Medford','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.419023,-71.109862,0,'2013-07-06 12:44:30',NULL,NULL),(75650,'94529','U','Chevron','N','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.874619,-122.047244,0,'2013-07-06 12:44:34',NULL,NULL),(23089,'24916','S','Asbury','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.834853,-80.573425,0,'2013-07-06 12:44:31',NULL,NULL),(55674,'64050','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.094148,-94.399135,0,'2013-07-06 12:44:33',NULL,NULL),(29834,'33030','S','Modello','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.481403,-80.505418,0,'2013-07-06 12:44:32',NULL,NULL),(27398,'30087','S','Stone Mountain','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.801564,-84.138154,0,'2013-07-06 12:44:31',NULL,NULL),(70469,'84759','S','Spry','N','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.774394,-112.590019,0,'2013-07-06 12:44:34',NULL,NULL),(69234,'83414','S','Alta','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.736450,-111.221892,0,'2013-07-06 12:44:34',NULL,NULL),(62758,'74850','S','Lamar','D','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.102236,-96.095414,0,'2013-07-06 12:44:33',NULL,NULL),(56239,'65048','S','Koeltztown','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.321876,-92.052887,0,'2013-07-06 12:44:33',NULL,NULL),(43368,'48413','S','Bad Axe','D','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.804425,-82.996869,0,'2013-07-06 12:44:32',NULL,NULL),(35000,'39117','S','Polkville','N','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.352309,-89.654064,0,'2013-07-06 12:44:32',NULL,NULL),(7772,'07417','S','Franklin Lks','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.010518,-74.208897,0,'2013-07-06 12:44:30',NULL,NULL),(32103,'35297','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.493207,-86.781750,0,'2013-07-06 12:44:32',NULL,NULL),(34826,'38915','S','Skuna','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.004880,-89.360460,0,'2013-07-06 12:44:32',NULL,NULL),(5303,'04551','S','Medomak','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.008174,-69.437857,0,'2013-07-06 12:44:30',NULL,NULL),(8285,'08016','S','Burlington City','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.070260,-74.841534,0,'2013-07-06 12:44:30',NULL,NULL),(74108,'92225','S','Blythe','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609354,-114.615439,0,'2013-07-06 12:44:34',NULL,NULL),(68529,'81410','S','Orchard City','A','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.792114,-107.972510,0,'2013-07-06 12:44:34',NULL,NULL),(65262,'77469','S','Richmond','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(54829,'63026','S','Murphy','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.501758,-90.456792,0,'2013-07-06 12:44:33',NULL,NULL),(32413,'35968','S','Ft Payne','N','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.441634,-85.719381,0,'2013-07-06 12:44:32',NULL,NULL),(53509,'62017','S','East Fork','N','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.090493,-89.394809,0,'2013-07-06 12:44:33',NULL,NULL),(1873,'00791','S','Urb Los Maestros','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(10303,'10528','S','Harrison','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.980573,-73.724601,0,'2013-07-06 12:44:30',NULL,NULL),(32043,'35249','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.519034,-86.803591,0,'2013-07-06 12:44:32',NULL,NULL),(40979,'46345','P','Kingsbury','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.528451,-86.697613,0,'2013-07-06 12:44:32',NULL,NULL),(29425,'32667','S','Micanopy','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.441958,-82.298007,0,'2013-07-06 12:44:32',NULL,NULL),(59436,'70707','P','Gonzales','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.231692,-90.905390,0,'2013-07-06 12:44:33',NULL,NULL),(49647,'56967','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(48399,'55587','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.280407,-93.807318,0,'2013-07-06 12:44:33',NULL,NULL),(46902,'54126','S','Wayside','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.306220,-88.024800,0,'2013-07-06 12:44:32',NULL,NULL),(28481,'31515','P','Baxley','D','Appling','13001','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.776021,-82.350157,0,'2013-07-06 12:44:32',NULL,NULL),(4421,'03230','S','Danbury','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.512128,-71.868512,0,'2013-07-06 12:44:30',NULL,NULL),(63164,'75394','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.830895,-96.706192,0,'2013-07-06 12:44:33',NULL,NULL),(7030,'06267','P','South Woodstock','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.930199,-71.958971,0,'2013-07-06 12:44:30',NULL,NULL),(57916,'67663','S','Codell','A','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.232902,-99.303102,0,'2013-07-06 12:44:33',NULL,NULL),(57009,'66205','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(42591,'47885','S','Dresser','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(11274,'11771','S','Muttontown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.866007,-73.526305,0,'2013-07-06 12:44:30',NULL,NULL),(57353,'66734','S','Farlington','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.618046,-94.863425,0,'2013-07-06 12:44:33',NULL,NULL),(41296,'46765','S','Cedar Shores','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(13351,'13695','P','Wanakena','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.211318,-75.083927,0,'2013-07-06 12:44:30',NULL,NULL),(785,'00693','S','Bo Ojo de Agua','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(60604,'71851','S','Mineral Spgs','A','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.871355,-93.917645,0,'2013-07-06 12:44:33',NULL,NULL),(2648,'00966','S','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(71130,'86022','S','Kaibab Indian Reservation','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(47239,'54511','S','Cavour','A','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.724974,-88.860373,0,'2013-07-06 12:44:32',NULL,NULL),(11145,'11714','S','Bethpage','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.738540,-73.488866,0,'2013-07-06 12:44:30',NULL,NULL),(30175,'33175','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729688,-80.410127,0,'2013-07-06 12:44:32',NULL,NULL),(65456,'77616','S','Fred','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.608112,-94.186829,0,'2013-07-06 12:44:34',NULL,NULL),(47178,'54481','S','Ellis','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(53892,'62357','S','New Salem','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.694763,-90.855380,0,'2013-07-06 12:44:33',NULL,NULL),(4728,'03827','S','So Hampton','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.911422,-70.983388,0,'2013-07-06 12:44:30',NULL,NULL),(9248,'09579','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58014,'67877','S','Sublette','D','Haskell','20081','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.483963,-100.842343,0,'2013-07-06 12:44:33',NULL,NULL),(66701,'78946','S','Ledbetter','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.231900,-96.775620,0,'2013-07-06 12:44:34',NULL,NULL),(66503,'78682','U','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.515111,-97.672706,0,'2013-07-06 12:44:34',NULL,NULL),(42946,'48121','P','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.312720,-83.192258,0,'2013-07-06 12:44:32',NULL,NULL),(35635,'39635','P','Fernwood','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.183043,-90.447396,0,'2013-07-06 12:44:32',NULL,NULL),(13540,'13827','S','Hullsville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(13961,'14469','S','E Bloomfield','N','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.877952,-77.456375,0,'2013-07-06 12:44:31',NULL,NULL),(54433,'62838','S','Loogootee','A','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.831400,-88.770151,0,'2013-07-06 12:44:33',NULL,NULL),(70312,'84604','S','Provo Canyon','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.264063,-111.623041,0,'2013-07-06 12:44:34',NULL,NULL),(17832,'18419','S','Factoryville','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.561219,-75.786848,0,'2013-07-06 12:44:31',NULL,NULL),(24194,'26667','P','Drennen','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.249394,-81.016823,0,'2013-07-06 12:44:31',NULL,NULL),(66651,'78843','S','Laughlin AFB','D','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.361815,-100.894575,0,'2013-07-06 12:44:34',NULL,NULL),(63830,'75973','S','Hurstown','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(63350,'75630','S','Avinger','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.868195,-94.579545,0,'2013-07-06 12:44:33',NULL,NULL),(46578,'53531','S','Deerfield','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.052390,-89.097446,0,'2013-07-06 12:44:32',NULL,NULL),(71285,'86437','S','Valentine','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.384257,-113.657991,0,'2013-07-06 12:44:34',NULL,NULL),(25273,'28127','S','Nw London','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.400410,-80.204216,0,'2013-07-06 12:44:31',NULL,NULL),(61571,'72734','S','Gentry','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.268323,-94.486877,0,'2013-07-06 12:44:33',NULL,NULL),(39836,'45158','P','Newtonsville','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.181677,-84.087426,0,'2013-07-06 12:44:32',NULL,NULL),(74480,'92610','S','El Toro','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.681780,-117.631980,0,'2013-07-06 12:44:34',NULL,NULL),(6253,'05544','U','Andover','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.649524,-71.184214,0,'2013-07-06 12:44:30',NULL,NULL),(10633,'11053','U','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.839189,-73.703262,0,'2013-07-06 12:44:30',NULL,NULL),(29942,'33068','S','North Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.216234,-80.216437,0,'2013-07-06 12:44:32',NULL,NULL),(70192,'84337','S','Elwood','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.676420,-112.267800,0,'2013-07-06 12:44:34',NULL,NULL),(56714,'65679','S','Mincy','N','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.567600,-93.114480,0,'2013-07-06 12:44:33',NULL,NULL),(29503,'32759','S','Oak Hill','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',28.863237,-80.861361,0,'2013-07-06 12:44:32',NULL,NULL),(45010,'50453','S','Neils','N','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.338260,-93.633413,0,'2013-07-06 12:44:32',NULL,NULL),(43278,'48332','P','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.465819,-83.378683,0,'2013-07-06 12:44:32',NULL,NULL),(15462,'16417','S','Girard','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.987875,-80.313199,0,'2013-07-06 12:44:31',NULL,NULL),(71520,'87117','U','Kirtland AFB','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.052085,-106.545052,0,'2013-07-06 12:44:34',NULL,NULL),(77505,'96837','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312064,-157.864195,0,'2013-07-06 12:44:34',NULL,NULL),(1317,'00735','S','Paseo de la Costa','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(62564,'74451','S','Pettit','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.649292,-95.023172,0,'2013-07-06 12:44:33',NULL,NULL),(22075,'23356','S','Greenbackvile','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',38.001245,-75.413882,0,'2013-07-06 12:44:31',NULL,NULL),(19426,'20101','U','Dulles P & D Center','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.988346,-77.451916,0,'2013-07-06 12:44:31',NULL,NULL),(15179,'15936','S','Hooversville','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.150303,-78.912825,0,'2013-07-06 12:44:31',NULL,NULL),(59325,'70531','S','Egan','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.257687,-92.492462,0,'2013-07-06 12:44:33',NULL,NULL),(64253,'76372','S','Elbert','A','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',33.192720,-98.808480,0,'2013-07-06 12:44:34',NULL,NULL),(40583,'45873','S','Oakwood','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.096528,-84.403657,0,'2013-07-06 12:44:32',NULL,NULL),(43952,'49303','S','Bailey','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.276495,-85.841572,0,'2013-07-06 12:44:32',NULL,NULL),(47083,'54434','P','Gilman','A','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.329087,-90.742860,0,'2013-07-06 12:44:32',NULL,NULL),(59461,'70734','S','Geismar','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.243229,-90.990969,0,'2013-07-06 12:44:33',NULL,NULL),(11186,'11733','S','Strongs Neck','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(17806,'18405','S','Beach Lake','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.590216,-75.115025,0,'2013-07-06 12:44:31',NULL,NULL),(58884,'69162','S','Sidney','D','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.131320,-103.031580,0,'2013-07-06 12:44:33',NULL,NULL),(35663,'39648','S','South McComb','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(70989,'85710','S','Rincon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.214160,-110.829230,0,'2013-07-06 12:44:34',NULL,NULL),(25873,'28634','S','Houstonville','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.956738,-80.772702,0,'2013-07-06 12:44:31',NULL,NULL),(15271,'16107','P','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.988668,-80.293105,0,'2013-07-06 12:44:31',NULL,NULL),(61021,'72116','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(60438,'71646','S','Mist','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(38395,'43523','P','Mc Clure','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.342644,-84.000355,0,'2013-07-06 12:44:32',NULL,NULL),(78784,'98312','S','Navy Yard City','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(3809,'02269','P','Quincy','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.251391,-71.003943,0,'2013-07-06 12:44:30',NULL,NULL),(18360,'19038','S','Glenside','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(10088,'10211','U','Cooper','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.731775,-73.989953,0,'2013-07-06 12:44:30',NULL,NULL),(50745,'58401','S','Lippert','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(45877,'52252','S','Langworthy','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.194237,-91.225157,0,'2013-07-06 12:44:32',NULL,NULL),(65075,'77349','U','Tx State Prison','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.721806,-95.551140,0,'2013-07-06 12:44:34',NULL,NULL),(76427,'95573','S','Willow Creek','D','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',40.953614,-123.648588,0,'2013-07-06 12:44:34',NULL,NULL),(12971,'13367','S','Montague','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(73616,'91402','S','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.222187,-118.442663,0,'2013-07-06 12:44:34',NULL,NULL),(18186,'18932','S','Line Lexington','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.292841,-75.259314,0,'2013-07-06 12:44:31',NULL,NULL),(7250,'06514','S','Hamden','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.372400,-72.939720,0,'2013-07-06 12:44:30',NULL,NULL),(5590,'04920','S','Moscow','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.128441,-69.858003,0,'2013-07-06 12:44:30',NULL,NULL),(39166,'44306','S','South Arlington','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.047753,-81.488189,0,'2013-07-06 12:44:32',NULL,NULL),(4261,'02880','P','Wakefield','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.423326,-71.484163,0,'2013-07-06 12:44:30',NULL,NULL),(23573,'25654','S','Dehue','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.870920,-81.873300,0,'2013-07-06 12:44:31',NULL,NULL),(51433,'59462','S','Benchland','N','Judith Basin','30045','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.108054,-109.880806,0,'2013-07-06 12:44:33',NULL,NULL),(48543,'55758','S','Kinney','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.517125,-92.727835,0,'2013-07-06 12:44:33',NULL,NULL),(48412,'55601','P','Beaver Bay','D','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.265555,-91.315132,0,'2013-07-06 12:44:33',NULL,NULL),(35237,'39325','S','Collinsville','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.524029,-88.815609,0,'2013-07-06 12:44:32',NULL,NULL),(52230,'60501','S','Bedford Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782868,-87.813794,0,'2013-07-06 12:44:33',NULL,NULL),(19479,'20147','S','Ashburn','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.032894,-77.486598,0,'2013-07-06 12:44:31',NULL,NULL),(60043,'71345','P','Lebeau','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.733570,-91.976292,0,'2013-07-06 12:44:33',NULL,NULL),(7902,'07604','S','Hasbrouck Hts','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.865727,-74.076151,0,'2013-07-06 12:44:30',NULL,NULL),(5622,'04941','S','Freedom','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.466565,-69.309221,0,'2013-07-06 12:44:30',NULL,NULL),(50528,'58104','S','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.819706,-96.808039,0,'2013-07-06 12:44:33',NULL,NULL),(32691,'36275','P','Spring Garden','D','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.975661,-85.555920,0,'2013-07-06 12:44:32',NULL,NULL),(40377,'45652','S','McDermott','N','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.842800,-83.081400,0,'2013-07-06 12:44:32',NULL,NULL),(63238,'75473','S','Powderly','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.777112,-95.533147,0,'2013-07-06 12:44:33',NULL,NULL),(5354,'04616','S','Brooklin','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.248351,-68.548601,0,'2013-07-06 12:44:30',NULL,NULL),(53200,'61611','S','Spring Bay','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(36823,'41064','S','Mount Olivet','D','Robertson','21201','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.532132,-84.039003,0,'2013-07-06 12:44:32',NULL,NULL),(35250,'39341','S','Paulette','N','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.113434,-88.556999,0,'2013-07-06 12:44:32',NULL,NULL),(73022,'90071','S','Arco','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.053598,-118.255851,0,'2013-07-06 12:44:34',NULL,NULL),(19774,'20422','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.931850,-77.031546,0,'2013-07-06 12:44:31',NULL,NULL),(2227,'00926','S','Urb El Paraiso','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(23067,'24878','P','Premier','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.434771,-81.633844,0,'2013-07-06 12:44:31',NULL,NULL),(4925,'04078','P','South Freeport','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.821360,-70.111614,0,'2013-07-06 12:44:30',NULL,NULL),(13698,'14057','S','Eden','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.645290,-78.871317,0,'2013-07-06 12:44:31',NULL,NULL),(48637,'55811','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.837380,-92.201400,0,'2013-07-06 12:44:33',NULL,NULL),(79895,'99586','S','Gakona','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.714253,-143.985789,0,'2013-07-06 12:44:34',NULL,NULL),(48069,'55329','S','Eden Valley','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.344424,-94.562439,0,'2013-07-06 12:44:33',NULL,NULL),(75508,'94142','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.784406,-122.412228,0,'2013-07-06 12:44:34',NULL,NULL),(78122,'97523','S','Cave Junction','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.140230,-123.623029,0,'2013-07-06 12:44:34',NULL,NULL),(10560,'11003','S','Floral Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.699109,-73.703659,0,'2013-07-06 12:44:30',NULL,NULL),(54113,'62547','S','Mt Auburn','N','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.761091,-89.213265,0,'2013-07-06 12:44:33',NULL,NULL),(27086,'29708','S','Fort Mill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006322,-80.942526,0,'2013-07-06 12:44:31',NULL,NULL),(46579,'53532','S','De Forest','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.236225,-89.333063,0,'2013-07-06 12:44:32',NULL,NULL),(45518,'51431','S','Arthur','D','Ida','19093','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.336733,-95.344980,0,'2013-07-06 12:44:32',NULL,NULL),(32367,'35897','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.716742,-86.631183,0,'2013-07-06 12:44:32',NULL,NULL),(69706,'84033','P','Henefer','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.020988,-111.501774,0,'2013-07-06 12:44:34',NULL,NULL),(49539,'56681','S','Squaw Lake','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.631447,-94.176224,0,'2013-07-06 12:44:33',NULL,NULL),(26325,'29048','S','Eutaw Springs','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.408960,-80.328420,0,'2013-07-06 12:44:31',NULL,NULL),(16983,'17727','S','Cedar Run','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.497301,-77.490054,0,'2013-07-06 12:44:31',NULL,NULL),(4095,'02670','S','West Dennis','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.660127,-70.167457,0,'2013-07-06 12:44:30',NULL,NULL),(24447,'27214','S','Busick','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(54369,'62807','S','Alma','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.735222,-88.922226,0,'2013-07-06 12:44:33',NULL,NULL),(27817,'30401','S','Oak Park','A','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(31614,'34688','S','Tarpon Springs','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143822,-82.680110,0,'2013-07-06 12:44:32',NULL,NULL),(76335,'95466','S','Philo','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.111417,-123.515190,0,'2013-07-06 12:44:34',NULL,NULL),(74862,'93257','S','Porterville','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.069871,-119.021504,0,'2013-07-06 12:44:34',NULL,NULL),(29920,'33062','S','Hillsboro Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.234821,-80.093841,0,'2013-07-06 12:44:32',NULL,NULL),(62076,'73556','P','Martha','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.722941,-99.386429,0,'2013-07-06 12:44:33',NULL,NULL),(55755,'64112','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.038303,-94.593927,0,'2013-07-06 12:44:33',NULL,NULL),(43267,'48328','S','Waterford Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.644305,-83.356394,0,'2013-07-06 12:44:32',NULL,NULL),(42273,'47581','S','Trinity Springs','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(36725,'41031','S','Lair','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(77188,'96330','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(30559,'33412','S','Royal Plm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.788572,-80.243519,0,'2013-07-06 12:44:32',NULL,NULL),(56947,'66092','S','Wellsville','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.695895,-95.149356,0,'2013-07-06 12:44:33',NULL,NULL),(46063,'52577','S','Evans','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.286600,-92.600280,0,'2013-07-06 12:44:32',NULL,NULL),(24547,'27292','S','Petersville','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(79906,'99591','P','St George Is','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',56.591517,-169.620701,0,'2013-07-06 12:44:34',NULL,NULL),(7084,'06349','P','Submarine Base','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.401943,-72.089280,0,'2013-07-06 12:44:30',NULL,NULL),(26049,'28685','S','Moxley','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.346465,-81.027968,0,'2013-07-06 12:44:31',NULL,NULL),(59052,'70087','S','Saint Rose','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.982463,-90.313325,0,'2013-07-06 12:44:33',NULL,NULL),(25712,'28542','P','Cp Lejeunemcb','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.697778,-77.352038,0,'2013-07-06 12:44:31',NULL,NULL),(20065,'20676','S','Port Republic','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.492477,-76.534133,0,'2013-07-06 12:44:31',NULL,NULL),(21162,'22150','S','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.773578,-77.187020,0,'2013-07-06 12:44:31',NULL,NULL),(79603,'99103','S','Almira','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.714362,-118.941564,0,'2013-07-06 12:44:34',NULL,NULL),(7939,'07660','S','Ridgefield Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.856838,-74.019390,0,'2013-07-06 12:44:30',NULL,NULL),(18559,'19121','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.980775,-75.172170,0,'2013-07-06 12:44:31',NULL,NULL),(29976,'33092','P','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.546985,-80.424765,0,'2013-07-06 12:44:32',NULL,NULL),(18377,'19046','S','Meadowbrook','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(15754,'16914','S','Columbia X Rd','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(10959,'11509','S','Atlantic Beach','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.592092,-73.728017,0,'2013-07-06 12:44:30',NULL,NULL),(31078,'33856','P','Nalcrest','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.870875,-81.474398,0,'2013-07-06 12:44:32',NULL,NULL),(68491,'81290','U','Florence','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.388104,-105.118653,0,'2013-07-06 12:44:34',NULL,NULL),(66194,'78540','P','Edinburg','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.301321,-98.159909,0,'2013-07-06 12:44:34',NULL,NULL),(70958,'85643','S','Willcox','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(16740,'17505','S','Bird in Hand','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.053862,-76.178815,0,'2013-07-06 12:44:31',NULL,NULL),(14650,'15236','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(8841,'08638','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.266540,-74.712840,0,'2013-07-06 12:44:30',NULL,NULL),(41289,'46761','S','Royer Lake','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(58732,'68945','S','Heartwell','D','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.569121,-98.779825,0,'2013-07-06 12:44:33',NULL,NULL),(68791,'82401','S','Worland','D','Washakie','56043','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.026278,-107.955070,0,'2013-07-06 12:44:34',NULL,NULL),(42192,'47546','S','Jasper','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.395440,-86.932333,0,'2013-07-06 12:44:32',NULL,NULL),(79414,'98817','P','Chelan Falls','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.801069,-119.986527,0,'2013-07-06 12:44:34',NULL,NULL),(30568,'33414','S','Royal Plm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.661979,-80.259339,0,'2013-07-06 12:44:32',NULL,NULL),(27751,'30359','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.822811,-84.323174,0,'2013-07-06 12:44:31',NULL,NULL),(24720,'27510','S','Carrboro','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.915484,-79.078537,0,'2013-07-06 12:44:31',NULL,NULL),(58338,'68462','S','Waverly','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.918377,-96.528739,0,'2013-07-06 12:44:33',NULL,NULL),(33519,'37376','S','Sherwood','D','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.056960,-85.962402,0,'2013-07-06 12:44:32',NULL,NULL),(55476,'63748','S','Wittenberg','A','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.675720,-89.667036,0,'2013-07-06 12:44:33',NULL,NULL),(73574,'91377','S','Agoura Hills','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.145227,-118.756588,0,'2013-07-06 12:44:34',NULL,NULL),(78052,'97450','S','Langlois','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.915704,-124.427829,0,'2013-07-06 12:44:34',NULL,NULL),(714,'00687','S','Morovis','D','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(3126,'01242','P','Lenox Dale','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.330029,-73.250299,0,'2013-07-06 12:44:30',NULL,NULL),(22484,'24061','U','Virginia Tech','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.255026,-80.431691,0,'2013-07-06 12:44:31',NULL,NULL),(42700,'47993','S','Williamsport','D','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.300200,-87.317520,0,'2013-07-06 12:44:32',NULL,NULL),(50898,'58541','S','Goldenvalley','N','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.299471,-102.067172,0,'2013-07-06 12:44:33',NULL,NULL),(49584,'56736','S','Mentor','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.671395,-96.211116,0,'2013-07-06 12:44:33',NULL,NULL),(26344,'29065','S','Jenkinsville','D','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.244829,-81.264483,0,'2013-07-06 12:44:31',NULL,NULL),(73456,'91303','S','Canoga Park','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.196941,-118.603090,0,'2013-07-06 12:44:34',NULL,NULL),(74870,'93263','S','Shafter','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.493768,-119.289345,0,'2013-07-06 12:44:34',NULL,NULL),(70394,'84710','P','Alton','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.475471,-112.586334,0,'2013-07-06 12:44:34',NULL,NULL),(42869,'48082','S','St Clair Shores','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.529366,-82.887803,0,'2013-07-06 12:44:32',NULL,NULL),(6606,'05871','S','Newark','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.616667,-71.933333,0,'2013-07-06 12:44:30',NULL,NULL),(35616,'39601','S','Zetus','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(38937,'44123','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.593056,-81.526944,0,'2013-07-06 12:44:32',NULL,NULL),(54123,'62554','S','Oreana','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.932312,-88.860876,0,'2013-07-06 12:44:33',NULL,NULL),(66055,'78379','S','Riviera','D','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.319380,-97.862520,0,'2013-07-06 12:44:34',NULL,NULL),(63171,'75401','S','Floyd','N','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.147180,-96.103980,0,'2013-07-06 12:44:33',NULL,NULL),(20332,'20848','P','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.073081,-77.118289,0,'2013-07-06 12:44:31',NULL,NULL),(22,'00603','S','Ramey','A','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(32142,'35459','S','Geiger','N','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.761720,-88.309687,0,'2013-07-06 12:44:32',NULL,NULL),(75385,'93944','P','Presidio of Monterey','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.579877,-121.834074,0,'2013-07-06 12:44:34',NULL,NULL),(63992,'76111','S','Haltom City','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779783,-97.302729,0,'2013-07-06 12:44:34',NULL,NULL),(72966,'90045','S','Playa Vista','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.957494,-118.397884,0,'2013-07-06 12:44:34',NULL,NULL),(68658,'81648','S','Rangely','D','Rio Blanco','08103','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.090824,-108.800790,0,'2013-07-06 12:44:34',NULL,NULL),(52671,'61074','S','Savanna','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.099549,-90.124934,0,'2013-07-06 12:44:33',NULL,NULL),(51557,'59745','S','Norris','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.542794,-111.721642,0,'2013-07-06 12:44:33',NULL,NULL),(46854,'54023','S','Roberts','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.989800,-92.560920,0,'2013-07-06 12:44:32',NULL,NULL),(45424,'51060','S','Berne','N','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.050911,-95.707888,0,'2013-07-06 12:44:32',NULL,NULL),(32971,'36608','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.692961,-88.194383,0,'2013-07-06 12:44:32',NULL,NULL),(2208,'00926','S','Sect Betancourt','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(2613,'00962','S','Bda Vietnam','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(40488,'45783','P','Tuppers Plains','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.166430,-81.835292,0,'2013-07-06 12:44:32',NULL,NULL),(44370,'49786','U','Sault S Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.266667,-84.483333,0,'2013-07-06 12:44:32',NULL,NULL),(338,'00653','S','Urb Sagrado Corazon','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(2735,'00969','S','Urb La Colina','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(22456,'24030','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270962,-79.954331,0,'2013-07-06 12:44:31',NULL,NULL),(21402,'22514','S','Gether','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.008260,-77.345880,0,'2013-07-06 12:44:31',NULL,NULL),(36445,'40619','U','Division of Sales Use Tax','N','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.177910,-84.899138,0,'2013-07-06 12:44:32',NULL,NULL),(64199,'76249','S','Krum','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.260888,-97.237388,0,'2013-07-06 12:44:34',NULL,NULL),(59226,'70422','S','Montpelier','A','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.725646,-90.507562,0,'2013-07-06 12:44:33',NULL,NULL),(20806,'21560','P','Spring Gap','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.563513,-78.716162,0,'2013-07-06 12:44:31',NULL,NULL),(24401,'27107','S','Gumtree','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.062543,-80.183453,0,'2013-07-06 12:44:31',NULL,NULL),(36097,'40220','S','Cambridge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(7828,'07460','S','Gerard','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(78249,'97830','S','Mayville','A','Wheeler','41069','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.998369,-120.212626,0,'2013-07-06 12:44:34',NULL,NULL),(77325,'96707','S','Kapolei','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333426,-158.094993,0,'2013-07-06 12:44:34',NULL,NULL),(13733,'14103','S','Medina','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.217164,-78.385469,0,'2013-07-06 12:44:31',NULL,NULL),(16265,'17089','U','Camp Hill','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.253878,-76.927333,0,'2013-07-06 12:44:31',NULL,NULL),(18578,'19129','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.010366,-75.183597,0,'2013-07-06 12:44:31',NULL,NULL),(20155,'20737','S','Riverdale Pk','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.959262,-76.920047,0,'2013-07-06 12:44:31',NULL,NULL),(20224,'20774','S','Glenarden','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(41463,'46914','S','Bunker Hill','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.658549,-86.099518,0,'2013-07-06 12:44:32',NULL,NULL),(10282,'10516','S','Nelsonville','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.422380,-73.950720,0,'2013-07-06 12:44:30',NULL,NULL),(7776,'07420','S','Haskell','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.028150,-74.298139,0,'2013-07-06 12:44:30',NULL,NULL),(23435,'25396','U','Verizon','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351027,-81.629411,0,'2013-07-06 12:44:31',NULL,NULL),(12274,'12836','S','Hague','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.788709,-73.497895,0,'2013-07-06 12:44:30',NULL,NULL),(20062,'20674','S','Piney Point','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.141300,-76.510191,0,'2013-07-06 12:44:31',NULL,NULL),(30580,'33416','P','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.664190,-80.090666,0,'2013-07-06 12:44:32',NULL,NULL),(57124,'66224','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(69133,'83287','S','Fish Haven','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.019022,-111.423286,0,'2013-07-06 12:44:34',NULL,NULL),(74409,'92536','S','Holcomb Village','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.424735,-116.802848,0,'2013-07-06 12:44:34',NULL,NULL),(8075,'07753','S','Tinton Falls','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.209704,-74.062049,0,'2013-07-06 12:44:30',NULL,NULL),(73975,'92082','S','Valley Center','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.252897,-117.036867,0,'2013-07-06 12:44:34',NULL,NULL),(66904,'79259','S','Tell','D','Childress','48075','Texas','TX','48','0000','940','Central',-6.0,'Y',34.357313,-100.390466,0,'2013-07-06 12:44:34',NULL,NULL),(62430,'74153','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.096902,-95.921925,0,'2013-07-06 12:44:33',NULL,NULL),(51131,'58801','S','Buford','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.416870,-103.823860,0,'2013-07-06 12:44:33',NULL,NULL),(46900,'54125','S','Goodman','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.627299,-88.356646,0,'2013-07-06 12:44:32',NULL,NULL),(35292,'39401','S','Leeville','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(53701,'62232','S','Fairview Hieghts','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.634957,-90.012889,0,'2013-07-06 12:44:33',NULL,NULL),(54648,'62930','S','Beulah Heights','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(64914,'77201','S','USPS Official','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.763934,-95.363754,0,'2013-07-06 12:44:34',NULL,NULL),(1676,'00777','S','Brisas del Prado','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(19761,'20416','U','Small Business Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882620,-77.017393,0,'2013-07-06 12:44:31',NULL,NULL),(32648,'36251','S','Carr Mill','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(44016,'49403','S','Conklin','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.136209,-85.856936,0,'2013-07-06 12:44:32',NULL,NULL),(25531,'28399','S','White Oak','D','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.787670,-78.722092,0,'2013-07-06 12:44:31',NULL,NULL),(17908,'18451','S','Paupack','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.383267,-75.217471,0,'2013-07-06 12:44:31',NULL,NULL),(19000,'19525','S','New Hanover Twp','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.311960,-75.589380,0,'2013-07-06 12:44:31',NULL,NULL),(19209,'19890','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.738223,-75.550288,0,'2013-07-06 12:44:31',NULL,NULL),(60373,'71483','S','Winnfield','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.922636,-92.645336,0,'2013-07-06 12:44:33',NULL,NULL),(34005,'38122','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.158002,-89.923644,0,'2013-07-06 12:44:32',NULL,NULL),(38243,'43266','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.056417,-82.968199,0,'2013-07-06 12:44:32',NULL,NULL),(3606,'02045','S','Nantasket Beach','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.230785,-70.839051,0,'2013-07-06 12:44:30',NULL,NULL),(77103,'96141','P','Tahoe Pines','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.097839,-120.169341,0,'2013-07-06 12:44:34',NULL,NULL),(74535,'92657','S','Newport Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.588320,-117.808426,0,'2013-07-06 12:44:34',NULL,NULL),(54863,'63049','S','Byrnes Mill','A','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.470505,-90.523777,0,'2013-07-06 12:44:33',NULL,NULL),(53583,'62063','S','Summerville','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.205251,-90.162210,0,'2013-07-06 12:44:33',NULL,NULL),(11884,'12308','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.820842,-73.919980,0,'2013-07-06 12:44:30',NULL,NULL),(21010,'21841','S','Newark','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.241807,-75.282442,0,'2013-07-06 12:44:31',NULL,NULL),(32738,'36320','S','Madrid','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.075800,-85.302240,0,'2013-07-06 12:44:32',NULL,NULL),(21454,'22610','S','Bentonville','D','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.818140,-78.258120,0,'2013-07-06 12:44:31',NULL,NULL),(42142,'47515','S','Uniontown','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.167640,-86.715843,0,'2013-07-06 12:44:32',NULL,NULL),(78372,'98022','S','Enumclaw','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(76045,'95164','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.392519,-121.923858,0,'2013-07-06 12:44:34',NULL,NULL),(11626,'12115','S','Malden Brg','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.456040,-73.591434,0,'2013-07-06 12:44:30',NULL,NULL),(53646,'62203','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.598771,-90.076739,0,'2013-07-06 12:44:33',NULL,NULL),(33321,'37141','S','Orlinda','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.613179,-86.686512,0,'2013-07-06 12:44:32',NULL,NULL),(63328,'75572','S','Springdale','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.175260,-94.152300,0,'2013-07-06 12:44:33',NULL,NULL),(7223,'06502','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.308684,-72.924444,0,'2013-07-06 12:44:30',NULL,NULL),(31972,'35215','S','Center Point','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.639053,-86.691875,0,'2013-07-06 12:44:32',NULL,NULL),(52485,'60695','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.878332,-87.633108,0,'2013-07-06 12:44:33',NULL,NULL),(26646,'29349','S','Inman','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.061669,-82.059864,0,'2013-07-06 12:44:31',NULL,NULL),(76559,'95667','S','Placerville','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(79297,'98585','S','Silver Creek','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.535252,-122.576294,0,'2013-07-06 12:44:34',NULL,NULL),(74688,'92883','S','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.760266,-117.488216,0,'2013-07-06 12:44:34',NULL,NULL),(80000,'99667','P','Skwentna','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.697031,-152.081309,0,'2013-07-06 12:44:34',NULL,NULL),(78326,'97914','S','Ontario','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.052879,-116.984744,0,'2013-07-06 12:44:34',NULL,NULL),(71141,'86028','P','Petrified Forest Natl Pk','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.791446,-109.878946,0,'2013-07-06 12:44:34',NULL,NULL),(70372,'84655','S','Genola','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.056240,-111.754620,0,'2013-07-06 12:44:34',NULL,NULL),(53286,'61727','S','Hallsville','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(2587,'00961','S','Qta del Rio','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(15548,'16622','S','Calvin','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.306084,-78.032555,0,'2013-07-06 12:44:31',NULL,NULL),(2685,'00968','S','Parq San Patricio','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(5739,'05035','S','Brdgewtr Cors','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(10441,'10914','P','Blooming Grv','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.382548,-74.179202,0,'2013-07-06 12:44:30',NULL,NULL),(27853,'30436','S','Lyons','D','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.201196,-82.323239,0,'2013-07-06 12:44:31',NULL,NULL),(41381,'46797','S','Maumee','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.130094,-84.866509,0,'2013-07-06 12:44:32',NULL,NULL),(70226,'84404','S','Mriott Sltrvl','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(46811,'54005','S','Clear Lake','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.249537,-92.272632,0,'2013-07-06 12:44:32',NULL,NULL),(62822,'74957','S','Smithville','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.481497,-94.582854,0,'2013-07-06 12:44:33',NULL,NULL),(64461,'76574','S','Hoxie','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(24056,'26426','S','Industrial','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281554,-80.559325,0,'2013-07-06 12:44:31',NULL,NULL),(12705,'13147','S','Scipio','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(20000,'20607','S','Accokeek','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.671615,-77.022910,0,'2013-07-06 12:44:31',NULL,NULL),(15405,'16344','P','Rouseville','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.470084,-79.691752,0,'2013-07-06 12:44:31',NULL,NULL),(45763,'52147','S','Hawkeye','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.940399,-91.948173,0,'2013-07-06 12:44:32',NULL,NULL),(55508,'63776','P','Mc Bride','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.714454,-89.890647,0,'2013-07-06 12:44:33',NULL,NULL),(58977,'70041','S','Ostrica','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.352900,-89.502060,0,'2013-07-06 12:44:33',NULL,NULL),(58703,'68930','S','Rosemont','A','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.329281,-98.450890,0,'2013-07-06 12:44:33',NULL,NULL),(57067,'66214','S','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.991480,-94.710420,0,'2013-07-06 12:44:33',NULL,NULL),(23173,'25030','S','Bomont','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.407900,-81.213881,0,'2013-07-06 12:44:31',NULL,NULL),(1807,'00784','S','Bda Santa Ana','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(14430,'15078','S','Slovan','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.362051,-80.406778,0,'2013-07-06 12:44:31',NULL,NULL),(16258,'17086','S','Evendale','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.698624,-77.126607,0,'2013-07-06 12:44:31',NULL,NULL),(9324,'09736','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21450,'22602','S','Winchester','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.165663,-78.148614,0,'2013-07-06 12:44:31',NULL,NULL),(70140,'84306','S','Beaverdam','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.787743,-112.072730,0,'2013-07-06 12:44:34',NULL,NULL),(42394,'47731','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974343,-87.574709,0,'2013-07-06 12:44:32',NULL,NULL),(63024,'75182','S','Sunnyvale','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.782434,-96.554366,0,'2013-07-06 12:44:33',NULL,NULL),(20549,'21120','S','Bentley Springs','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.639703,-76.682750,0,'2013-07-06 12:44:31',NULL,NULL),(54069,'62501','S','Argenta','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.984413,-88.818350,0,'2013-07-06 12:44:33',NULL,NULL),(4423,'03231','P','East Andover','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.480087,-71.768205,0,'2013-07-06 12:44:30',NULL,NULL),(26543,'29205','S','Five Points','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.992894,-80.994240,0,'2013-07-06 12:44:31',NULL,NULL),(39708,'45044','S','Liberty Twp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.484738,-84.383452,0,'2013-07-06 12:44:32',NULL,NULL),(62264,'74010','S','Newby','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.831459,-96.387712,0,'2013-07-06 12:44:33',NULL,NULL),(62936,'75093','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.032072,-96.802811,0,'2013-07-06 12:44:33',NULL,NULL),(46679,'53774','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.072549,-89.402181,0,'2013-07-06 12:44:32',NULL,NULL),(31307,'34104','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.160499,-81.735857,0,'2013-07-06 12:44:32',NULL,NULL),(33570,'37416','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.095902,-85.156600,0,'2013-07-06 12:44:32',NULL,NULL),(5940,'05257','S','No Bennington','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(78016,'97417','S','Canyonville','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.934716,-123.271666,0,'2013-07-06 12:44:34',NULL,NULL),(20627,'21215','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.346278,-76.681280,0,'2013-07-06 12:44:31',NULL,NULL),(19979,'20598','U','Dept HS','N','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(54070,'62501','S','Newburg','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.984413,-88.818350,0,'2013-07-06 12:44:33',NULL,NULL),(48844,'56058','S','Le Sueur','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.457962,-93.905418,0,'2013-07-06 12:44:33',NULL,NULL),(14718,'15277','U','Eastern Area','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441394,-80.097800,0,'2013-07-06 12:44:31',NULL,NULL),(31551,'34607','S','Brooksville','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.505114,-82.636115,0,'2013-07-06 12:44:32',NULL,NULL),(79157,'98506','S','Lacey','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.103780,-122.868360,0,'2013-07-06 12:44:34',NULL,NULL),(79902,'99590','P','Grayling','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.270150,-160.029370,0,'2013-07-06 12:44:34',NULL,NULL),(18551,'19116','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.121574,-75.018481,0,'2013-07-06 12:44:31',NULL,NULL),(72943,'90038','S','Hollywood','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.091104,-118.343030,0,'2013-07-06 12:44:34',NULL,NULL),(68027,'80926','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.663492,-104.909353,0,'2013-07-06 12:44:34',NULL,NULL),(58818,'69034','S','Indianola','D','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.238760,-100.420615,0,'2013-07-06 12:44:33',NULL,NULL),(49743,'57055','S','Renner','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.669327,-96.702890,0,'2013-07-06 12:44:33',NULL,NULL),(31312,'34108','S','Coco River','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.236315,-81.805998,0,'2013-07-06 12:44:32',NULL,NULL),(36036,'40178','S','Westview','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.629802,-86.394256,0,'2013-07-06 12:44:32',NULL,NULL),(41131,'46624','P','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.656358,-86.288349,0,'2013-07-06 12:44:32',NULL,NULL),(5085,'04332','P','Augusta','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.335362,-69.744565,0,'2013-07-06 12:44:30',NULL,NULL),(61031,'72117','S','N LR','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(41489,'46942','P','Lake Cicott','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.764992,-86.539280,0,'2013-07-06 12:44:32',NULL,NULL),(31729,'34983','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308284,-80.348414,0,'2013-07-06 12:44:32',NULL,NULL),(64830,'77037','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.888126,-95.390473,0,'2013-07-06 12:44:34',NULL,NULL),(41756,'47302','S','Breezewood Park','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(14147,'14714','S','Black Creek','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.285552,-78.256921,0,'2013-07-06 12:44:31',NULL,NULL),(56050,'64733','S','Chilhowee','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.586839,-93.857218,0,'2013-07-06 12:44:33',NULL,NULL),(42988,'48153','P','Livonia','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.364800,-83.387650,0,'2013-07-06 12:44:32',NULL,NULL),(73081,'90212','S','Beverly Hills','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.061673,-118.400135,0,'2013-07-06 12:44:34',NULL,NULL),(75893,'94970','S','Stinson Beach','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.902526,-122.643355,0,'2013-07-06 12:44:34',NULL,NULL),(69099,'83254','S','Ovid','A','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(51909,'60105','U','Bradford Group','N','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.956863,-87.941819,0,'2013-07-06 12:44:33',NULL,NULL),(50257,'57633','S','Lightcap','N','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.392234,-101.430938,0,'2013-07-06 12:44:33',NULL,NULL),(49379,'56593','P','Wolf Lake','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.837826,-95.369866,0,'2013-07-06 12:44:33',NULL,NULL),(46824,'54011','S','Lostcreek','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.735213,-92.480939,0,'2013-07-06 12:44:32',NULL,NULL),(45726,'52077','S','Volga','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.804486,-91.541051,0,'2013-07-06 12:44:32',NULL,NULL),(23982,'26321','S','Alum Bridge','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.046920,-80.698020,0,'2013-07-06 12:44:31',NULL,NULL),(35704,'39666','S','Pricedale','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(37707,'42261','S','Provo','A','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(48716,'55949','S','Whalan','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.716900,-92.006580,0,'2013-07-06 12:44:33',NULL,NULL),(18787,'19380','S','W Chester','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.982089,-75.603385,0,'2013-07-06 12:44:31',NULL,NULL),(57599,'67107','S','Moundridge','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.205168,-97.520678,0,'2013-07-06 12:44:33',NULL,NULL),(29563,'32812','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.488781,-81.324101,0,'2013-07-06 12:44:32',NULL,NULL),(28142,'30821','S','Barnett','N','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.462193,-82.706161,0,'2013-07-06 12:44:31',NULL,NULL),(1085,'00725','S','Urb Bunker','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(3775,'02191','S','North Weymouth','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.241032,-70.943260,0,'2013-07-06 12:44:30',NULL,NULL),(5602,'04928','S','Corinna','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.932715,-69.215070,0,'2013-07-06 12:44:30',NULL,NULL),(58034,'68010','P','Boys Town','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.259761,-96.128888,0,'2013-07-06 12:44:33',NULL,NULL),(11629,'12116','S','Cooperstown Junction','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.542837,-74.899432,0,'2013-07-06 12:44:30',NULL,NULL),(28573,'31620','S','Adel','D','Cook','13075','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.136179,-83.426493,0,'2013-07-06 12:44:32',NULL,NULL),(40308,'45458','S','Washington Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(36086,'40218','S','Buechel','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192865,-85.653204,0,'2013-07-06 12:44:32',NULL,NULL),(24710,'27499','U','Greensboro Brm','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.070576,-79.766148,0,'2013-07-06 12:44:31',NULL,NULL),(18187,'18932','S','Line Lxngtn','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.292841,-75.259314,0,'2013-07-06 12:44:31',NULL,NULL),(30451,'33332','S','Southwest Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.063246,-80.420398,0,'2013-07-06 12:44:32',NULL,NULL),(68403,'81154','S','South Fork','D','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.672402,-106.630824,0,'2013-07-06 12:44:34',NULL,NULL),(76369,'95503','S','Eureka','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.759043,-124.158947,0,'2013-07-06 12:44:34',NULL,NULL),(71049,'85748','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.212606,-110.769648,0,'2013-07-06 12:44:34',NULL,NULL),(71598,'87321','S','El Morro National Monument','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.135560,-108.505655,0,'2013-07-06 12:44:34',NULL,NULL),(65967,'78288','U','United Service Auto Assc','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425828,-98.491586,0,'2013-07-06 12:44:34',NULL,NULL),(64665,'76804','P','Brownwood','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.605035,-99.017479,0,'2013-07-06 12:44:34',NULL,NULL),(52261,'60523','S','Hinsdale','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.800833,-87.936944,0,'2013-07-06 12:44:33',NULL,NULL),(25180,'28052','S','Pinkney','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(12092,'12567','S','Shekomeko','N','Dutchess','36027','New York','NY','36','2281','518','Eastern',-5.0,'Y',41.993160,-73.666740,0,'2013-07-06 12:44:30',NULL,NULL),(29584,'32824','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.403466,-81.360078,0,'2013-07-06 12:44:32',NULL,NULL),(16792,'17538','S','Bamford','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.100343,-76.427234,0,'2013-07-06 12:44:31',NULL,NULL),(18333,'19027','S','Melrose','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.017822,-75.135978,0,'2013-07-06 12:44:31',NULL,NULL),(10583,'11022','P','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.787695,-73.731862,0,'2013-07-06 12:44:30',NULL,NULL),(59193,'70363','S','Houma','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.576504,-90.688555,0,'2013-07-06 12:44:33',NULL,NULL),(13813,'14212','S','Cheektowaga','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.862020,-78.818580,0,'2013-07-06 12:44:31',NULL,NULL),(38562,'43767','S','Norwich','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.996606,-81.802153,0,'2013-07-06 12:44:32',NULL,NULL),(13710,'14067','S','Gasport','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.207686,-78.563528,0,'2013-07-06 12:44:31',NULL,NULL),(23343,'25252','S','Le Roy','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.957697,-81.571231,0,'2013-07-06 12:44:31',NULL,NULL),(59030,'70082','P','Pt a la Hache','A','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.575598,-89.793242,0,'2013-07-06 12:44:33',NULL,NULL),(45919,'52325','S','Parnell','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.554231,-92.004947,0,'2013-07-06 12:44:32',NULL,NULL),(73134,'90274','S','Pls Vrds Est','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.772826,-118.370775,0,'2013-07-06 12:44:34',NULL,NULL),(44477,'49901','P','Ahmeek','D','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.295410,-88.395923,0,'2013-07-06 12:44:32',NULL,NULL),(78593,'98181','U','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.610729,-122.341403,0,'2013-07-06 12:44:34',NULL,NULL),(78153,'97603','S','Klamath Falls','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.195694,-121.724225,0,'2013-07-06 12:44:34',NULL,NULL),(74338,'92406','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.133983,-117.286246,0,'2013-07-06 12:44:34',NULL,NULL),(70589,'85083','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.709608,-112.121939,0,'2013-07-06 12:44:34',NULL,NULL),(68841,'82523','S','Pavillion','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.255946,-108.650790,0,'2013-07-06 12:44:34',NULL,NULL),(67576,'80307','P','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.985473,-105.235857,0,'2013-07-06 12:44:34',NULL,NULL),(58162,'68182','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.254745,-96.009873,0,'2013-07-06 12:44:33',NULL,NULL),(31847,'35097','S','Locust Fork','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.903495,-86.620468,0,'2013-07-06 12:44:32',NULL,NULL),(27575,'30270','U','Peachtree City Parcel Return','N','Fayette','13113','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.396971,-84.592052,0,'2013-07-06 12:44:31',NULL,NULL),(33917,'38053','S','Millington','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(15388,'16323','S','Franklin','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.384940,-79.813140,0,'2013-07-06 12:44:31',NULL,NULL),(39373,'44641','S','Louisville','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.845335,-81.258482,0,'2013-07-06 12:44:32',NULL,NULL),(16060,'17047','S','Loysville','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.369113,-77.437450,0,'2013-07-06 12:44:31',NULL,NULL),(2033,'00917','S','Urb Pinero','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(21660,'22942','S','Zion Crossroads','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.134847,-78.186346,0,'2013-07-06 12:44:31',NULL,NULL),(59517,'70789','S','Wilson','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.946656,-91.052709,0,'2013-07-06 12:44:33',NULL,NULL),(76620,'95699','P','Sutter Creek','A','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.444551,-120.847909,0,'2013-07-06 12:44:34',NULL,NULL),(31073,'33854','P','Lakeshore','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.857939,-81.412475,0,'2013-07-06 12:44:32',NULL,NULL),(13984,'14502','S','Macedon','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.087022,-77.333368,0,'2013-07-06 12:44:31',NULL,NULL),(13954,'14462','S','Groveland','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.680605,-77.749793,0,'2013-07-06 12:44:31',NULL,NULL),(72822,'89821','S','Crescent Valley','D','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.580000,-116.480000,0,'2013-07-06 12:44:34',NULL,NULL),(4408,'03223','S','Ellsworth','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.876228,-71.679742,0,'2013-07-06 12:44:30',NULL,NULL),(52725,'61231','S','Old Gilchrist','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.202727,-90.754088,0,'2013-07-06 12:44:33',NULL,NULL),(18783,'19373','S','Thornton','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.908260,-75.534890,0,'2013-07-06 12:44:31',NULL,NULL),(21699,'22967','S','Wintergrn Rst','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(61898,'73140','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.464047,-97.383601,0,'2013-07-06 12:44:33',NULL,NULL),(57945,'67744','S','Ludell','D','Rawlins','20153','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.871108,-100.940540,0,'2013-07-06 12:44:33',NULL,NULL),(16655,'17349','S','New Freedom','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.737783,-76.683516,0,'2013-07-06 12:44:31',NULL,NULL),(56794,'65761','S','Longrun','N','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.577980,-92.706780,0,'2013-07-06 12:44:33',NULL,NULL),(44171,'49546','S','Kentwood','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928581,-85.532040,0,'2013-07-06 12:44:32',NULL,NULL),(46669,'53716','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.065869,-89.312254,0,'2013-07-06 12:44:32',NULL,NULL),(17291,'17850','P','W Chillisquaq','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972467,-76.850729,0,'2013-07-06 12:44:31',NULL,NULL),(2913,'01002','S','Pelham','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.376860,-72.469140,0,'2013-07-06 12:44:30',NULL,NULL),(59799,'71221','P','Bastrop','D','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.756362,-91.876190,0,'2013-07-06 12:44:33',NULL,NULL),(16423,'17228','S','Gracey','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.977362,-78.082703,0,'2013-07-06 12:44:31',NULL,NULL),(46011,'52537','S','Bloomfield','D','Davis','19051','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.732680,-92.414100,0,'2013-07-06 12:44:32',NULL,NULL),(49369,'56584','S','Twin Valley','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.284811,-96.264019,0,'2013-07-06 12:44:33',NULL,NULL),(77610,'96943','P','Yap Caroline Islands','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',9.537287,138.126286,0,'2013-07-06 12:44:34',NULL,NULL),(73982,'92091','S','Rancho Santa Fe','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.014160,-117.241081,0,'2013-07-06 12:44:34',NULL,NULL),(72878,'90010','S','Sanford','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.063478,-118.314966,0,'2013-07-06 12:44:34',NULL,NULL),(13927,'14423','S','Mumford','N','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.941518,-77.843078,0,'2013-07-06 12:44:31',NULL,NULL),(19480,'20148','S','Arcola','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.994011,-77.531312,0,'2013-07-06 12:44:31',NULL,NULL),(68662,'81650','S','Rio Blanco','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.540153,-107.790633,0,'2013-07-06 12:44:34',NULL,NULL),(3934,'02465','S','West Newton','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348882,-71.225607,0,'2013-07-06 12:44:30',NULL,NULL),(4296,'02904','S','No Providence','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.832900,-71.437560,0,'2013-07-06 12:44:30',NULL,NULL),(34872,'38941','S','Berclair','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(71322,'86505','S','Sunrise Springs','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(15410,'16350','S','Sugar Grove','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.956020,-79.332720,0,'2013-07-06 12:44:31',NULL,NULL),(7949,'07675','S','Rivervale','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.000621,-74.031463,0,'2013-07-06 12:44:30',NULL,NULL),(49043,'56289','S','Sunburg','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.333396,-95.184601,0,'2013-07-06 12:44:33',NULL,NULL),(8678,'08330','S','English Creek','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440760,-74.728980,0,'2013-07-06 12:44:30',NULL,NULL),(75182,'93608','S','Three Rocks','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.519483,-120.349022,0,'2013-07-06 12:44:34',NULL,NULL),(46018,'52543','S','Cedar','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204581,-92.500570,0,'2013-07-06 12:44:32',NULL,NULL),(12652,'13116','S','Minoa','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.077436,-76.009926,0,'2013-07-06 12:44:30',NULL,NULL),(13703,'14060','S','Farmersvl Sta','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.436740,-78.302220,0,'2013-07-06 12:44:31',NULL,NULL),(20373,'20879','S','Montgomry Vlg','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.177540,-77.194392,0,'2013-07-06 12:44:31',NULL,NULL),(21226,'22217','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855660,-77.093001,0,'2013-07-06 12:44:31',NULL,NULL),(14845,'15444','S','Hiller','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.010782,-79.903624,0,'2013-07-06 12:44:31',NULL,NULL),(30898,'33706','S','Pass A Grille','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(1160,'00727','S','Urb Altos de la Fuente','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(64098,'76166','U','Cingular Wireless','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.783918,-97.347748,0,'2013-07-06 12:44:34',NULL,NULL),(42878,'48089','S','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.465547,-82.993978,0,'2013-07-06 12:44:32',NULL,NULL),(8398,'08062','S','S Harrison Twp','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722021,-75.221337,0,'2013-07-06 12:44:30',NULL,NULL),(13827,'14218','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.810099,-78.781921,0,'2013-07-06 12:44:31',NULL,NULL),(20511,'21082','S','Hydes','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.475606,-76.475639,0,'2013-07-06 12:44:31',NULL,NULL),(9257,'09593','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(26511,'29175','S','Dekalb','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.447043,-80.601334,0,'2013-07-06 12:44:31',NULL,NULL),(74128,'92241','S','Desert Edge','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.899772,-116.390191,0,'2013-07-06 12:44:34',NULL,NULL),(71328,'86506','P','Pine Springs','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.389139,-109.283418,0,'2013-07-06 12:44:34',NULL,NULL),(16447,'17236','S','Peters','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(49454,'56646','S','Olga','N','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.803463,-95.643510,0,'2013-07-06 12:44:33',NULL,NULL),(9847,'10118','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(6486,'05770','S','Shoreham','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.881442,-73.304785,0,'2013-07-06 12:44:30',NULL,NULL),(8566,'08212','P','Cape May Pt','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.939854,-74.963948,0,'2013-07-06 12:44:30',NULL,NULL),(74557,'92678','P','Trabuco Cyn','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.664297,-117.589602,0,'2013-07-06 12:44:34',NULL,NULL),(47005,'54301','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.477500,-88.016111,0,'2013-07-06 12:44:32',NULL,NULL),(4893,'04048','S','Limerick','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.680355,-70.756935,0,'2013-07-06 12:44:30',NULL,NULL),(63272,'75504','P','Texarkana','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.352727,-94.218718,0,'2013-07-06 12:44:33',NULL,NULL),(60022,'71341','S','New Belledeau','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.055529,-92.141657,0,'2013-07-06 12:44:33',NULL,NULL),(50933,'58570','S','Breien','A','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.276735,-100.808228,0,'2013-07-06 12:44:33',NULL,NULL),(48595,'55783','S','Sturgeon Lake','D','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.360574,-92.778625,0,'2013-07-06 12:44:33',NULL,NULL),(36376,'40461','S','Paint Lick','D','Garrard','21079','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.582697,-84.432837,0,'2013-07-06 12:44:32',NULL,NULL),(47871,'55082','S','West Lakeland','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(39622,'44887','S','Tiro','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.904316,-82.792556,0,'2013-07-06 12:44:32',NULL,NULL),(52666,'61071','S','Rock Falls','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.758470,-89.690648,0,'2013-07-06 12:44:33',NULL,NULL),(35341,'39437','S','Oak Bowery','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(41205,'46725','S','Lorane','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(29936,'33066','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.247211,-80.174433,0,'2013-07-06 12:44:32',NULL,NULL),(27201,'29903','P','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.424633,-80.725146,0,'2013-07-06 12:44:31',NULL,NULL),(71941,'87935','P','Elephant Butte','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.195236,-107.218449,0,'2013-07-06 12:44:34',NULL,NULL),(15756,'16914','S','Wetona','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(2699,'00969','S','Colinas de Parkville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(38780,'44054','S','Sheffield Village','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(42956,'48130','S','Dexter','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(2036,'00918','S','Bda Tokio','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(28636,'31753','P','Funston','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.213388,-83.968407,0,'2013-07-06 12:44:32',NULL,NULL),(27027,'29649','S','Gwd','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.219994,-82.160345,0,'2013-07-06 12:44:31',NULL,NULL),(60599,'71841','S','Gillham','D','Sevier','05133','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.149902,-94.314180,0,'2013-07-06 12:44:33',NULL,NULL),(47798,'55049','S','Medford','D','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.171579,-93.246887,0,'2013-07-06 12:44:33',NULL,NULL),(33028,'36726','S','Millers Ferry','N','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.996605,-87.296969,0,'2013-07-06 12:44:32',NULL,NULL),(27908,'30499','U','Reidsville','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.083302,-82.119056,0,'2013-07-06 12:44:31',NULL,NULL),(56068,'64747','S','Latour','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.555303,-94.188013,0,'2013-07-06 12:44:33',NULL,NULL),(60042,'71345','P','Bayou Petite Prairie','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.733570,-91.976292,0,'2013-07-06 12:44:33',NULL,NULL),(42180,'47535','P','Freelandville','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.849864,-87.415417,0,'2013-07-06 12:44:32',NULL,NULL),(2263,'00926','S','Urb Portal de los Pinos','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(37865,'42539','S','Clementsville','A','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.316700,-84.981180,0,'2013-07-06 12:44:32',NULL,NULL),(26236,'28813','P','Asheville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.554470,-82.510720,0,'2013-07-06 12:44:31',NULL,NULL),(42694,'47989','S','Waveland','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.878181,-87.041617,0,'2013-07-06 12:44:32',NULL,NULL),(44602,'50049','S','Oakley','N','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018686,-93.311392,0,'2013-07-06 12:44:32',NULL,NULL),(7183,'06468','S','Stepney','N','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.340900,-73.234440,0,'2013-07-06 12:44:30',NULL,NULL),(41936,'47388','P','Sulphur Springs','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.016569,-85.443170,0,'2013-07-06 12:44:32',NULL,NULL),(29389,'32614','P','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.610707,-82.375187,0,'2013-07-06 12:44:32',NULL,NULL),(66348,'78610','S','Creedmoor','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.082691,-97.843934,0,'2013-07-06 12:44:34',NULL,NULL),(2598,'00961','S','Urb Monte Claro','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(2004,'00912','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446583,-66.061072,0,'2013-07-06 12:44:30',NULL,NULL),(13004,'13413','S','New Hartford','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.066052,-75.290055,0,'2013-07-06 12:44:30',NULL,NULL),(40328,'45482','U','Dayton Business Reply Mail','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.721533,-84.101071,0,'2013-07-06 12:44:32',NULL,NULL),(77480,'96821','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.289359,-157.755003,0,'2013-07-06 12:44:34',NULL,NULL),(8310,'08030','S','Gloucester Cy','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.887704,-75.115680,0,'2013-07-06 12:44:30',NULL,NULL),(57226,'66506','S','Manhattan','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.185143,-96.571471,0,'2013-07-06 12:44:33',NULL,NULL),(18150,'18843','P','South Montrose','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.796640,-75.891646,0,'2013-07-06 12:44:31',NULL,NULL),(6484,'05769','S','Salisbury','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.903320,-73.095300,0,'2013-07-06 12:44:30',NULL,NULL),(26362,'29071','P','Lexington','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.980985,-81.235011,0,'2013-07-06 12:44:31',NULL,NULL),(51182,'59016','S','Kirby','N','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.516379,-106.872747,0,'2013-07-06 12:44:33',NULL,NULL),(54642,'62924','S','Bush','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.824180,-89.224860,0,'2013-07-06 12:44:33',NULL,NULL),(31591,'34656','P','New Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.243613,-82.709068,0,'2013-07-06 12:44:32',NULL,NULL),(25468,'28340','S','Fairmont','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.484940,-79.085880,0,'2013-07-06 12:44:31',NULL,NULL),(38732,'44024','S','Concord Township','A','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.569436,-81.203372,0,'2013-07-06 12:44:32',NULL,NULL),(10523,'10980','S','Stony Point','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.236440,-74.011260,0,'2013-07-06 12:44:30',NULL,NULL),(6009,'05359','S','West Townshend','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.163746,-72.719255,0,'2013-07-06 12:44:30',NULL,NULL),(61765,'73055','S','Central High','A','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.644252,-97.961450,0,'2013-07-06 12:44:33',NULL,NULL),(19800,'20437','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901872,-77.048950,0,'2013-07-06 12:44:31',NULL,NULL),(18648,'19171','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955628,-75.155260,0,'2013-07-06 12:44:31',NULL,NULL),(26975,'29614','U','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.910320,-82.409036,0,'2013-07-06 12:44:31',NULL,NULL),(9123,'09140','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(6901,'06150','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765671,-72.675155,0,'2013-07-06 12:44:30',NULL,NULL),(42785,'48045','S','Harrison Township','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(55800,'64132','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.988907,-94.545827,0,'2013-07-06 12:44:33',NULL,NULL),(34531,'38685','S','Laws Hill','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.640700,-89.469780,0,'2013-07-06 12:44:32',NULL,NULL),(13928,'14424','S','Canandaigua','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.843523,-77.301225,0,'2013-07-06 12:44:31',NULL,NULL),(2873,'00987','S','Alt de Parq Ecuestre','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(69721,'84038','S','Laketown','D','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.847331,-111.346321,0,'2013-07-06 12:44:34',NULL,NULL),(60650,'71910','P','Hot Springs','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.668247,-93.001118,0,'2013-07-06 12:44:33',NULL,NULL),(56188,'65014','S','Cooper Hill','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(50440,'58006','S','Arthur','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.109108,-97.195403,0,'2013-07-06 12:44:33',NULL,NULL),(33565,'37414','P','Chatt','N','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.026201,-85.230406,0,'2013-07-06 12:44:32',NULL,NULL),(34480,'38665','S','Buxton','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601919,-90.126392,0,'2013-07-06 12:44:32',NULL,NULL),(41346,'46788','S','Hurshtown','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.252712,-84.942553,0,'2013-07-06 12:44:32',NULL,NULL),(6256,'05602','S','Berlin','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(19431,'20104','U','Dulles','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.326264,-77.534628,0,'2013-07-06 12:44:31',NULL,NULL),(18606,'19143','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.943711,-75.229131,0,'2013-07-06 12:44:31',NULL,NULL),(48696,'55936','S','Bennington','N','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.704937,-92.570979,0,'2013-07-06 12:44:33',NULL,NULL),(37054,'41301','S','Lee City','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(506,'00674','S','Lomas del Manatuabon','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(52224,'60491','S','Lockport','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.607647,-88.014981,0,'2013-07-06 12:44:33',NULL,NULL),(25654,'28472','S','Whiteville','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.334306,-78.702996,0,'2013-07-06 12:44:31',NULL,NULL),(11490,'12020','S','Milton Center','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(70109,'84180','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767274,-111.898078,0,'2013-07-06 12:44:34',NULL,NULL),(61015,'72115','P','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.766295,-92.259072,0,'2013-07-06 12:44:33',NULL,NULL),(58400,'68632','S','David City','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.243121,-97.131923,0,'2013-07-06 12:44:33',NULL,NULL),(51052,'58737','S','Northgate','A','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.916096,-102.296386,0,'2013-07-06 12:44:33',NULL,NULL),(13410,'13754','S','China','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(4814,'03897','S','Wonalancet','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.906588,-71.347509,0,'2013-07-06 12:44:30',NULL,NULL),(8392,'08060','S','Westampton','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(19232,'19902','S','Dover Air Force Base','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.120867,-75.478601,0,'2013-07-06 12:44:31',NULL,NULL),(31986,'35219','P','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473661,-86.825878,0,'2013-07-06 12:44:32',NULL,NULL),(40300,'45449','S','W Carrollton','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.668355,-84.246864,0,'2013-07-06 12:44:32',NULL,NULL),(5994,'05353','S','Townshend','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.064489,-72.668569,0,'2013-07-06 12:44:30',NULL,NULL),(17135,'17778','S','East Keating','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.309029,-77.972308,0,'2013-07-06 12:44:31',NULL,NULL),(76232,'95383','S','Twain Harte','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.045218,-120.226725,0,'2013-07-06 12:44:34',NULL,NULL),(60651,'71910','P','Hot Springs National Park','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.668247,-93.001118,0,'2013-07-06 12:44:33',NULL,NULL),(33812,'37919','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.926579,-84.006405,0,'2013-07-06 12:44:32',NULL,NULL),(66115,'78416','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.751777,-97.435129,0,'2013-07-06 12:44:34',NULL,NULL),(20134,'20722','S','N Brentwood','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(52937,'61377','S','Leeds','N','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.051074,-89.052018,0,'2013-07-06 12:44:33',NULL,NULL),(16511,'17266','S','South Newton','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.104396,-77.525358,0,'2013-07-06 12:44:31',NULL,NULL),(44823,'50248','S','Story City','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.180091,-93.591611,0,'2013-07-06 12:44:32',NULL,NULL),(15304,'16146','S','Sharon','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.231776,-80.490019,0,'2013-07-06 12:44:31',NULL,NULL),(15744,'16910','S','Snydertown','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.705551,-76.828782,0,'2013-07-06 12:44:31',NULL,NULL),(36453,'40701','S','Corbin','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.937489,-84.114901,0,'2013-07-06 12:44:32',NULL,NULL),(54750,'62979','S','North Fork','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.804440,-88.260000,0,'2013-07-06 12:44:33',NULL,NULL),(54422,'62836','S','Frisco','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.074329,-88.801938,0,'2013-07-06 12:44:33',NULL,NULL),(18195,'18936','S','Montgomeryvle','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.244471,-75.243572,0,'2013-07-06 12:44:31',NULL,NULL),(17479,'17954','S','Minersville','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690509,-76.261655,0,'2013-07-06 12:44:31',NULL,NULL),(7025,'06264','S','Scotland','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.683569,-72.083980,0,'2013-07-06 12:44:30',NULL,NULL),(2991,'01063','U','North Hampton','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.319077,-72.644431,0,'2013-07-06 12:44:30',NULL,NULL),(15379,'16314','S','Cochranton','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.516840,-80.049158,0,'2013-07-06 12:44:31',NULL,NULL),(23688,'25851','P','Harper','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797567,-81.261582,0,'2013-07-06 12:44:31',NULL,NULL),(25333,'28210','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.133058,-80.859674,0,'2013-07-06 12:44:31',NULL,NULL),(27379,'30075','S','Sandy Plains','N','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.046659,-84.376691,0,'2013-07-06 12:44:31',NULL,NULL),(19552,'20201','U','Dept Hlth Human Serv','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887354,-77.017361,0,'2013-07-06 12:44:31',NULL,NULL),(39038,'44146','S','Orange Village','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(42847,'48074','S','Smiths Creek','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.944217,-82.559913,0,'2013-07-06 12:44:32',NULL,NULL),(172,'00623','S','Ext La Concepcion','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(19240,'19931','S','Bethel','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.565190,-75.626034,0,'2013-07-06 12:44:31',NULL,NULL),(36784,'41048','S','Hebron','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.073020,-84.713160,0,'2013-07-06 12:44:32',NULL,NULL),(49716,'57037','S','Mayfield','N','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.111845,-97.285292,0,'2013-07-06 12:44:33',NULL,NULL),(72495,'89141','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.992372,-115.211387,0,'2013-07-06 12:44:34',NULL,NULL),(32107,'35298','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.499493,-86.800795,0,'2013-07-06 12:44:32',NULL,NULL),(74250,'92333','P','Fawnskin','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.266659,-116.941287,0,'2013-07-06 12:44:34',NULL,NULL),(68635,'81636','P','Battlement Mesa','D','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.438650,-108.025498,0,'2013-07-06 12:44:34',NULL,NULL),(54509,'62869','S','Heralds Prairie','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.977903,-88.328317,0,'2013-07-06 12:44:33',NULL,NULL),(48985,'56226','S','Clontarf','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.377964,-95.679393,0,'2013-07-06 12:44:33',NULL,NULL),(48964,'56186','S','Woodstock','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.978957,-96.123573,0,'2013-07-06 12:44:33',NULL,NULL),(11411,'11959','P','Quogue','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.823016,-72.601639,0,'2013-07-06 12:44:30',NULL,NULL),(30422,'33327','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118498,-80.436434,0,'2013-07-06 12:44:32',NULL,NULL),(31272,'34011','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(30174,'33174','S','West Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.762543,-80.353593,0,'2013-07-06 12:44:32',NULL,NULL),(68410,'81201','S','Maysville','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(22007,'23284','P','VCU/West','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.553021,-77.457951,0,'2013-07-06 12:44:31',NULL,NULL),(35010,'39146','S','Pickens','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.889754,-89.971322,0,'2013-07-06 12:44:32',NULL,NULL),(31977,'35216','S','Vestavia Hills','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(16947,'17701','S','Plunketts Crk','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(6334,'05666','S','North Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.256675,-72.485785,0,'2013-07-06 12:44:30',NULL,NULL),(48658,'55910','S','Norton','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(73401,'91123','U','Ambassador College','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138331,-118.152775,0,'2013-07-06 12:44:34',NULL,NULL),(64918,'77204','U','University of Houston','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.765745,-95.389271,0,'2013-07-06 12:44:34',NULL,NULL),(74891,'93286','S','Woodlake','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.420258,-119.099560,0,'2013-07-06 12:44:34',NULL,NULL),(73347,'91006','S','Arcadia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.137650,-118.023582,0,'2013-07-06 12:44:34',NULL,NULL),(51828,'60061','S','Indian Creek','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.234248,-87.970272,0,'2013-07-06 12:44:33',NULL,NULL),(24601,'27330','S','Carbonton','N','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(27005,'29635','S','Cleveland','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.050003,-82.642050,0,'2013-07-06 12:44:31',NULL,NULL),(7234,'06508','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.307025,-72.923348,0,'2013-07-06 12:44:30',NULL,NULL),(33138,'36908','S','Gilbertown','D','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.862112,-88.342985,0,'2013-07-06 12:44:32',NULL,NULL),(6230,'05491','S','Button Bay','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(60486,'71659','P','Linwood','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.146589,-91.795504,0,'2013-07-06 12:44:33',NULL,NULL),(2281,'00926','S','Urb Venus Gdns Oeste','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(48051,'55316','S','Champlin','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.174742,-93.390657,0,'2013-07-06 12:44:33',NULL,NULL),(22592,'24176','S','Union Hall','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.036342,-79.630508,0,'2013-07-06 12:44:31',NULL,NULL),(50967,'58630','S','Gladstone','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.857633,-102.564564,0,'2013-07-06 12:44:33',NULL,NULL),(63257,'75490','S','Trenton','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.428209,-96.334339,0,'2013-07-06 12:44:33',NULL,NULL),(8445,'08085','S','Swedesboro','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(16561,'17314','S','Coal Cabin Beach','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.730000,-76.313333,0,'2013-07-06 12:44:31',NULL,NULL),(78107,'97495','S','Winchester','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.280412,-123.356002,0,'2013-07-06 12:44:34',NULL,NULL),(76483,'95630','S','Lake Natoma','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.683096,-121.160535,0,'2013-07-06 12:44:34',NULL,NULL),(12081,'12553','S','Newburgh','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.470200,-74.070060,0,'2013-07-06 12:44:30',NULL,NULL),(42904,'48103','S','Loch Alpine','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.270780,-83.808660,0,'2013-07-06 12:44:32',NULL,NULL),(5720,'05001','S','Russtown','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.662310,-72.359191,0,'2013-07-06 12:44:30',NULL,NULL),(45505,'51360','S','Templar Park','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(43250,'48321','P','Auburn Hills','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.674336,-83.242398,0,'2013-07-06 12:44:32',NULL,NULL),(42547,'47870','P','Prairieton','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.359042,-87.407122,0,'2013-07-06 12:44:32',NULL,NULL),(19712,'20390','U','Marine Barrks','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884615,-76.993490,0,'2013-07-06 12:44:31',NULL,NULL),(14289,'14870','S','Painted Post','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.155826,-77.115626,0,'2013-07-06 12:44:31',NULL,NULL),(29427,'32669','S','Jonesville','A','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.647073,-82.599723,0,'2013-07-06 12:44:32',NULL,NULL),(1378,'00738','S','Alts de San Pedro','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(12827,'13308','S','Vienna','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.241534,-75.652043,0,'2013-07-06 12:44:30',NULL,NULL),(75380,'93940','S','Presidio of Monterey','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.587700,-121.849200,0,'2013-07-06 12:44:34',NULL,NULL),(8628,'08260','S','N Wildwood','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(8575,'08215','S','Germania','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(7238,'06510','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310571,-72.922891,0,'2013-07-06 12:44:30',NULL,NULL),(47225,'54498','S','Redville','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953103,-90.595538,0,'2013-07-06 12:44:32',NULL,NULL),(42566,'47874','S','Numa','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (5333,'04579','S','Woolwich','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.964645,-69.790390,0,'2013-07-06 12:44:30',NULL,NULL),(75060,'93524','U','Edward','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.919545,-117.946773,0,'2013-07-06 12:44:34',NULL,NULL),(30965,'33738','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.801363,-82.801164,0,'2013-07-06 12:44:32',NULL,NULL),(61415,'72561','S','Mt Pleasant','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.964212,-91.806374,0,'2013-07-06 12:44:33',NULL,NULL),(59680,'71067','S','Princeton','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.569499,-93.551303,0,'2013-07-06 12:44:33',NULL,NULL),(47480,'54747','S','Independence','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.358587,-91.422932,0,'2013-07-06 12:44:32',NULL,NULL),(32994,'36628','U','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.693855,-88.045183,0,'2013-07-06 12:44:32',NULL,NULL),(34726,'38847','S','Fairview','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.468200,-88.181220,0,'2013-07-06 12:44:32',NULL,NULL),(57054,'66211','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(73518,'91343','S','Northridge','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.237131,-118.481042,0,'2013-07-06 12:44:34',NULL,NULL),(32966,'36603','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.689828,-88.055657,0,'2013-07-06 12:44:32',NULL,NULL),(10422,'10709','S','Eastchester','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955972,-73.807475,0,'2013-07-06 12:44:30',NULL,NULL),(68384,'81147','S','Pagosa Lakes','N','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.256494,-107.086521,0,'2013-07-06 12:44:34',NULL,NULL),(62580,'74464','S','Tahlequah','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.913588,-94.967828,0,'2013-07-06 12:44:33',NULL,NULL),(24924,'27808','S','Bath','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.475087,-76.812065,0,'2013-07-06 12:44:31',NULL,NULL),(56047,'64728','S','Bronaugh','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.690562,-94.463020,0,'2013-07-06 12:44:33',NULL,NULL),(40410,'45682','S','South Webster','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.863742,-82.750533,0,'2013-07-06 12:44:32',NULL,NULL),(40299,'45449','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.668355,-84.246864,0,'2013-07-06 12:44:32',NULL,NULL),(78158,'97623','S','Bonanza','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.293249,-121.185766,0,'2013-07-06 12:44:34',NULL,NULL),(69717,'84036','S','Woodland','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(11942,'12438','P','Halcottsville','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.208259,-74.601210,0,'2013-07-06 12:44:30',NULL,NULL),(48863,'56080','P','Saint Clair','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.080602,-93.853972,0,'2013-07-06 12:44:33',NULL,NULL),(47834,'55071','S','St Paul Park','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.826000,-92.990100,0,'2013-07-06 12:44:33',NULL,NULL),(17264,'17842','S','Middleburg','D','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(27878,'30450','S','Portal','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.569614,-81.903024,0,'2013-07-06 12:44:31',NULL,NULL),(60731,'71959','S','Newhope','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.219416,-93.852143,0,'2013-07-06 12:44:33',NULL,NULL),(75675,'94549','S','Lafayette','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.897485,-122.112374,0,'2013-07-06 12:44:34',NULL,NULL),(67347,'80109','S','Castle Rock','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.388964,-104.860057,0,'2013-07-06 12:44:34',NULL,NULL),(36745,'41039','S','Nepton','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.433060,-83.851740,0,'2013-07-06 12:44:32',NULL,NULL),(54753,'62983','S','Royalton','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.883227,-89.105089,0,'2013-07-06 12:44:33',NULL,NULL),(6217,'05488','S','Lakewood','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(2131,'00924','S','Urb Berwind Est','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(34071,'38148','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.146943,-90.046493,0,'2013-07-06 12:44:32',NULL,NULL),(48885,'56098','S','Winnebago','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.766076,-94.171269,0,'2013-07-06 12:44:33',NULL,NULL),(75317,'93764','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.734126,-119.784633,0,'2013-07-06 12:44:34',NULL,NULL),(77459,'96814','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.301058,-157.848253,0,'2013-07-06 12:44:34',NULL,NULL),(6433,'05745','P','Forest Dale','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.829518,-73.054531,0,'2013-07-06 12:44:30',NULL,NULL),(34051,'38138','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.072700,-89.902500,0,'2013-07-06 12:44:32',NULL,NULL),(26447,'29135','S','Singleton','N','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.661870,-80.781778,0,'2013-07-06 12:44:31',NULL,NULL),(23533,'25601','S','Monaville','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.868777,-81.988500,0,'2013-07-06 12:44:31',NULL,NULL),(26786,'29452','P','Jacksonboro','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.767539,-80.456879,0,'2013-07-06 12:44:31',NULL,NULL),(33578,'37450','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.047863,-85.305894,0,'2013-07-06 12:44:32',NULL,NULL),(32523,'36089','S','Roba','N','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.140539,-85.714718,0,'2013-07-06 12:44:32',NULL,NULL),(79656,'99150','S','Malo','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.805263,-118.605883,0,'2013-07-06 12:44:34',NULL,NULL),(4280,'02892','S','South Kingstown','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.502011,-71.593784,0,'2013-07-06 12:44:30',NULL,NULL),(9137,'09227','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(77834,'97217','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.574936,-122.688735,0,'2013-07-06 12:44:34',NULL,NULL),(33951,'38083','P','Millingtn','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.332201,-89.887885,0,'2013-07-06 12:44:32',NULL,NULL),(57441,'66835','S','Americus','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.505257,-96.263158,0,'2013-07-06 12:44:33',NULL,NULL),(49345,'56569','S','Ogema','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.107446,-95.998438,0,'2013-07-06 12:44:33',NULL,NULL),(50104,'57475','S','Tolstoy','D','Potter','46107','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.139364,-99.620884,0,'2013-07-06 12:44:33',NULL,NULL),(28289,'31094','S','Warthen','D','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.010838,-82.823711,0,'2013-07-06 12:44:31',NULL,NULL),(66952,'79373','S','Tahoka','D','Lynn','48305','Texas','TX','48','0000','806','Central',-6.0,'Y',33.169336,-101.802852,0,'2013-07-06 12:44:34',NULL,NULL),(14225,'14805','S','Alpine','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.362451,-76.731395,0,'2013-07-06 12:44:31',NULL,NULL),(38357,'43451','S','Portage','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.318391,-83.617545,0,'2013-07-06 12:44:32',NULL,NULL),(35627,'39632','P','Chatawa','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.169789,-90.473852,0,'2013-07-06 12:44:32',NULL,NULL),(32346,'35807','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.714111,-86.653531,0,'2013-07-06 12:44:32',NULL,NULL),(79764,'99322','S','Bickleton','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.960606,-120.321259,0,'2013-07-06 12:44:34',NULL,NULL),(59769,'71201','S','Bosco','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(31348,'34201','S','Braden River','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.390254,-82.481246,0,'2013-07-06 12:44:32',NULL,NULL),(9640,'10036','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(57171,'66285','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.016846,-94.663276,0,'2013-07-06 12:44:33',NULL,NULL),(51872,'60084','S','Lake Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.262122,-88.139439,0,'2013-07-06 12:44:33',NULL,NULL),(71038,'85741','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.357439,-111.044532,0,'2013-07-06 12:44:34',NULL,NULL),(75726,'94589','S','Vallejo','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.162340,-122.249400,0,'2013-07-06 12:44:34',NULL,NULL),(17712,'18234','P','Lattimer Mnes','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.994353,-75.961265,0,'2013-07-06 12:44:31',NULL,NULL),(49611,'56762','S','Warren','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.197279,-96.769251,0,'2013-07-06 12:44:33',NULL,NULL),(51797,'60046','S','West Miltmore','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(32641,'36205','S','Ft Mc Clellan','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.659722,-85.831667,0,'2013-07-06 12:44:32',NULL,NULL),(26517,'29180','S','Winnsboro','D','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.372149,-81.086971,0,'2013-07-06 12:44:31',NULL,NULL),(29049,'32237','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.243390,-81.619117,0,'2013-07-06 12:44:32',NULL,NULL),(34361,'38603','S','Cannon','N','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.831184,-89.170922,0,'2013-07-06 12:44:32',NULL,NULL),(56426,'65261','S','Musselfork','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.432638,-92.935494,0,'2013-07-06 12:44:33',NULL,NULL),(46379,'53138','P','Honey Creek','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.745569,-88.305445,0,'2013-07-06 12:44:32',NULL,NULL),(32078,'35287','U','Regions Bank','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513903,-86.807366,0,'2013-07-06 12:44:32',NULL,NULL),(41819,'47337','P','Dunreith','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.805006,-85.438100,0,'2013-07-06 12:44:32',NULL,NULL),(37672,'42211','S','Maple Grove','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(32583,'36121','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386094,-86.146989,0,'2013-07-06 12:44:32',NULL,NULL),(21648,'22935','S','Nortonsville','A','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.264055,-78.574641,0,'2013-07-06 12:44:31',NULL,NULL),(78983,'98376','S','Dabob','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.813700,-122.850480,0,'2013-07-06 12:44:34',NULL,NULL),(68014,'80923','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.899457,-104.699208,0,'2013-07-06 12:44:34',NULL,NULL),(37463,'41858','S','Kona','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(42348,'47640','S','Hazleton','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.489588,-87.542063,0,'2013-07-06 12:44:32',NULL,NULL),(11750,'12189','S','Watervliet','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.726113,-73.713355,0,'2013-07-06 12:44:30',NULL,NULL),(4852,'04014','P','Cape Porpoise','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.408905,-70.475730,0,'2013-07-06 12:44:30',NULL,NULL),(57533,'67016','P','Bentley','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.889978,-97.517609,0,'2013-07-06 12:44:33',NULL,NULL),(15160,'15906','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.348727,-78.934313,0,'2013-07-06 12:44:31',NULL,NULL),(38909,'44118','S','Shaker Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(25746,'28572','S','Pink Hill','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.052316,-77.745260,0,'2013-07-06 12:44:31',NULL,NULL),(30436,'33330','S','Laud Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(26175,'28750','P','Lynn','D','Polk','37149','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.226869,-82.222796,0,'2013-07-06 12:44:31',NULL,NULL),(71334,'86507','P','Upper Wheatfields','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.432600,-109.238820,0,'2013-07-06 12:44:34',NULL,NULL),(68811,'82435','S','Odonnell Spur','N','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(46500,'53228','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.966203,-88.043196,0,'2013-07-06 12:44:32',NULL,NULL),(28092,'30742','S','Fort Oglethorpe','D','Catoosa','13047','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.954118,-85.250532,0,'2013-07-06 12:44:31',NULL,NULL),(71947,'87939','S','Monticello','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.347489,-107.412653,0,'2013-07-06 12:44:34',NULL,NULL),(62795,'74884','S','Wewoka','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.160960,-96.503340,0,'2013-07-06 12:44:33',NULL,NULL),(824,'00693','S','Urb Vega Baja Lakes','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(19755,'20413','U','Housing Assistance Adm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894978,-77.021775,0,'2013-07-06 12:44:31',NULL,NULL),(47717,'55005','S','Linwood','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.392640,-93.211800,0,'2013-07-06 12:44:33',NULL,NULL),(42788,'48045','S','Selfridge','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(75901,'94978','P','Fairfax','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.984901,-122.580046,0,'2013-07-06 12:44:34',NULL,NULL),(22502,'24073','S','Christnsbrg','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136439,-80.404000,0,'2013-07-06 12:44:31',NULL,NULL),(69458,'83650','S','Murphy','D','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.053611,-116.394167,0,'2013-07-06 12:44:34',NULL,NULL),(61825,'73110','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460687,-97.397356,0,'2013-07-06 12:44:33',NULL,NULL),(31058,'33840','P','Eaton Park','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.008840,-81.904087,0,'2013-07-06 12:44:32',NULL,NULL),(60588,'71828','P','Cale','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.625138,-93.260649,0,'2013-07-06 12:44:33',NULL,NULL),(23995,'26339','S','Center Point','D','Doddridge','54017','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.420348,-80.617871,0,'2013-07-06 12:44:31',NULL,NULL),(14626,'15232','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.451373,-79.932761,0,'2013-07-06 12:44:31',NULL,NULL),(32169,'35476','S','North Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.255087,-87.586136,0,'2013-07-06 12:44:32',NULL,NULL),(42527,'47858','S','Lewis','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.284987,-87.269499,0,'2013-07-06 12:44:32',NULL,NULL),(9178,'09365','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3867,'02357','U','Stonehill Coll','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.059436,-71.080861,0,'2013-07-06 12:44:30',NULL,NULL),(26874,'29547','S','S of Border','A','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.508632,-79.405977,0,'2013-07-06 12:44:31',NULL,NULL),(25187,'28054','S','Ragan Village','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229720,-81.142440,0,'2013-07-06 12:44:31',NULL,NULL),(50771,'58422','S','Emrick','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.548080,-99.442500,0,'2013-07-06 12:44:33',NULL,NULL),(50012,'57383','S','Robey','N','Aurora','46003','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.804787,-98.684321,0,'2013-07-06 12:44:33',NULL,NULL),(17872,'18437','S','Lake Como','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.863322,-75.295137,0,'2013-07-06 12:44:31',NULL,NULL),(34655,'38774','S','Shelby','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.948680,-90.765417,0,'2013-07-06 12:44:32',NULL,NULL),(74448,'92585','S','Romoland','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.749416,-117.174455,0,'2013-07-06 12:44:34',NULL,NULL),(72732,'89506','S','Golden Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(68116,'80949','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.929049,-104.855865,0,'2013-07-06 12:44:34',NULL,NULL),(21532,'22728','S','Midland','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.633221,-77.721549,0,'2013-07-06 12:44:31',NULL,NULL),(67545,'80261','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.691209,-104.984621,0,'2013-07-06 12:44:34',NULL,NULL),(16680,'17363','S','Rinely','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.757217,-76.601719,0,'2013-07-06 12:44:31',NULL,NULL),(13726,'14092','S','Stella Niagara','A','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.171111,-79.018833,0,'2013-07-06 12:44:31',NULL,NULL),(11383,'11937','S','East Hampton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.004735,-72.178804,0,'2013-07-06 12:44:30',NULL,NULL),(35997,'40143','S','Sample','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.779180,-86.458980,0,'2013-07-06 12:44:32',NULL,NULL),(63658,'75847','S','Kennard','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.349522,-95.125937,0,'2013-07-06 12:44:34',NULL,NULL),(37899,'42631','P','Marshes Siding','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.742909,-84.481254,0,'2013-07-06 12:44:32',NULL,NULL),(52527,'60919','S','Cabery','D','Ford','17053','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.949053,-88.151418,0,'2013-07-06 12:44:33',NULL,NULL),(47395,'54639','S','West Lima','A','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.616403,-90.624741,0,'2013-07-06 12:44:32',NULL,NULL),(43966,'49316','S','Caledonia','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.787020,-85.546320,0,'2013-07-06 12:44:32',NULL,NULL),(9663,'10039','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(30314,'33305','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.156150,-80.122239,0,'2013-07-06 12:44:32',NULL,NULL),(22993,'24801','S','Coalwood','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(4300,'02905','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.789822,-71.404779,0,'2013-07-06 12:44:30',NULL,NULL),(59502,'70775','S','Saint Francisville','D','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.862864,-91.332969,0,'2013-07-06 12:44:33',NULL,NULL),(3008,'01077','S','Southwick','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.053564,-72.771922,0,'2013-07-06 12:44:30',NULL,NULL),(26692,'29405','S','Pinehaven','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(77867,'97238','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.576436,-122.600450,0,'2013-07-06 12:44:34',NULL,NULL),(1448,'00741','S','Punta Santiago','D','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.168687,-65.747221,0,'2013-07-06 12:44:30',NULL,NULL),(7175,'06456','P','Middle Haddam','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.553544,-72.553312,0,'2013-07-06 12:44:30',NULL,NULL),(34384,'38618','S','Cold Water','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(10838,'11386','P','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.700392,-73.894731,0,'2013-07-06 12:44:30',NULL,NULL),(62525,'74423','S','Braggs','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.666178,-95.179407,0,'2013-07-06 12:44:33',NULL,NULL),(52939,'61378','S','West Brooklyn','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.719636,-89.163410,0,'2013-07-06 12:44:33',NULL,NULL),(26919,'29582','S','Ocean Drive','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(45616,'51573','S','Stanton','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.980645,-95.101050,0,'2013-07-06 12:44:32',NULL,NULL),(37618,'42140','S','Fleet','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.660772,-85.813348,0,'2013-07-06 12:44:32',NULL,NULL),(37516,'42040','S','Farmington','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.678450,-88.535796,0,'2013-07-06 12:44:32',NULL,NULL),(24690,'27417','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.067592,-79.952645,0,'2013-07-06 12:44:31',NULL,NULL),(20540,'21106','P','Mayo','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.879899,-76.507456,0,'2013-07-06 12:44:31',NULL,NULL),(30620,'33436','S','Boynton Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524205,-80.107257,0,'2013-07-06 12:44:32',NULL,NULL),(13238,'13641','P','Fishers Landing','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.278171,-76.008350,0,'2013-07-06 12:44:30',NULL,NULL),(56611,'65567','S','Stoutland','D','Laclede','29105','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.849307,-92.439987,0,'2013-07-06 12:44:33',NULL,NULL),(13610,'13862','S','Clough Corners','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.357840,-75.938160,0,'2013-07-06 12:44:31',NULL,NULL),(44770,'50210','S','Jamison','N','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.205240,-93.670620,0,'2013-07-06 12:44:32',NULL,NULL),(8314,'08031','S','Gloucstr City','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.867047,-75.089079,0,'2013-07-06 12:44:30',NULL,NULL),(9425,'10003','S','Cooper','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(8760,'08535','S','Perrineville','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.220714,-74.440497,0,'2013-07-06 12:44:30',NULL,NULL),(42166,'47525','S','Derby','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.029575,-86.566656,0,'2013-07-06 12:44:32',NULL,NULL),(67288,'80011','S','Buckley AFB','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741650,-104.791421,0,'2013-07-06 12:44:34',NULL,NULL),(78151,'97601','S','Worden','N','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.221688,-121.796627,0,'2013-07-06 12:44:34',NULL,NULL),(2170,'00926','S','Bo Venezuela','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(8013,'07723','S','Deal','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.247668,-74.001279,0,'2013-07-06 12:44:30',NULL,NULL),(72315,'89001','S','Alamo','D','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.481400,-115.488420,0,'2013-07-06 12:44:34',NULL,NULL),(73099,'90232','S','Culver City','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.014991,-118.394848,0,'2013-07-06 12:44:34',NULL,NULL),(72410,'89046','S','Searchlight','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.466505,-114.918847,0,'2013-07-06 12:44:34',NULL,NULL),(63884,'76013','S','Dw Gdns','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.717191,-97.152038,0,'2013-07-06 12:44:34',NULL,NULL),(20297,'20812','S','Glen Echo','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.972080,-77.129817,0,'2013-07-06 12:44:31',NULL,NULL),(28617,'31711','S','Andersonville','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.195044,-84.145508,0,'2013-07-06 12:44:32',NULL,NULL),(239,'00637','S','Alts de San Jose','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(323,'00647','S','Urb Baco','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.967309,-66.939935,0,'2013-07-06 12:44:30',NULL,NULL),(20512,'21084','S','Jarrettsville','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.615377,-76.471101,0,'2013-07-06 12:44:31',NULL,NULL),(33839,'37934','S','Farragut','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(58554,'68818','S','Stockham','N','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.855080,-98.012700,0,'2013-07-06 12:44:33',NULL,NULL),(42594,'47885','S','Kenwood','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(49223,'56468','S','Lake Hubert','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.504936,-94.283424,0,'2013-07-06 12:44:33',NULL,NULL),(1380,'00738','S','Bda Roosevelt','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(49289,'56520','S','Everdell','N','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.268423,-96.587538,0,'2013-07-06 12:44:33',NULL,NULL),(74258,'92339','S','Fallsvale','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.064027,-117.035983,0,'2013-07-06 12:44:34',NULL,NULL),(71765,'87552','S','Pecos National Monument','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.583300,-105.618180,0,'2013-07-06 12:44:34',NULL,NULL),(44508,'49935','S','Beechwood','A','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.106840,-88.657064,0,'2013-07-06 12:44:32',NULL,NULL),(28619,'31714','S','Ashburn','D','Turner','13287','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.701024,-83.654748,0,'2013-07-06 12:44:32',NULL,NULL),(6133,'05461','S','Lake Iroquois','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.304622,-73.118170,0,'2013-07-06 12:44:30',NULL,NULL),(2251,'00926','S','Urb Los Campos Montehiedra','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(32391,'35952','S','Susan Moore','A','Etowah','01055','Alabama','AL','01','2880','205/659','Central',-6.0,'Y',34.026000,-86.299260,0,'2013-07-06 12:44:32',NULL,NULL),(72265,'88543','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770994,-106.429587,0,'2013-07-06 12:44:34',NULL,NULL),(33825,'37924','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.030778,-83.813882,0,'2013-07-06 12:44:32',NULL,NULL),(7874,'07508','S','Prospect Park','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.951433,-74.185795,0,'2013-07-06 12:44:30',NULL,NULL),(19838,'20504','U','National Security Counsel','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897725,-77.042875,0,'2013-07-06 12:44:31',NULL,NULL),(26612,'29304','P','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.958086,-81.905765,0,'2013-07-06 12:44:31',NULL,NULL),(71246,'86401','S','Kingman','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.524020,-113.992680,0,'2013-07-06 12:44:34',NULL,NULL),(65396,'77555','U','U of T Med Br at Galveston','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.311767,-94.782331,0,'2013-07-06 12:44:34',NULL,NULL),(65135,'77384','S','Shenandoah','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.230149,-95.490453,0,'2013-07-06 12:44:34',NULL,NULL),(36174,'40243','S','Woodland Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.239734,-85.539227,0,'2013-07-06 12:44:32',NULL,NULL),(21587,'22842','S','Mount Jackson','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.753381,-78.639309,0,'2013-07-06 12:44:31',NULL,NULL),(19440,'20109','S','Sudley Springs','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.799297,-77.546852,0,'2013-07-06 12:44:31',NULL,NULL),(29907,'33052','P','Marathon','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.724766,-81.062436,0,'2013-07-06 12:44:32',NULL,NULL),(65032,'77327','S','Everitt','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(10383,'10595','S','East View','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.088128,-73.777872,0,'2013-07-06 12:44:30',NULL,NULL),(55580,'63880','P','Whiteoak','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.128100,-90.159041,0,'2013-07-06 12:44:33',NULL,NULL),(36961,'41173','P','Soldier','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.260114,-83.299489,0,'2013-07-06 12:44:32',NULL,NULL),(270,'00646','S','Bo Arenal','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(53051,'61483','S','West Jersey','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.092649,-89.863127,0,'2013-07-06 12:44:33',NULL,NULL),(49672,'57010','S','Burbank','D','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.604183,-96.564281,0,'2013-07-06 12:44:33',NULL,NULL),(36704,'41017','S','Lakeside Park','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(2597,'00961','S','Urb Mirabella Vlg','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(54050,'62468','S','Sumpter','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.269624,-88.244943,0,'2013-07-06 12:44:33',NULL,NULL),(63286,'75558','S','Cookville','D','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.186780,-94.868280,0,'2013-07-06 12:44:33',NULL,NULL),(6137,'05462','S','Huntington Center','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.310720,-73.003500,0,'2013-07-06 12:44:30',NULL,NULL),(58254,'68368','S','Hallam','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.560143,-96.792049,0,'2013-07-06 12:44:33',NULL,NULL),(52273,'60525','S','La Grange Highlands','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(77864,'97233','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.514315,-122.503676,0,'2013-07-06 12:44:34',NULL,NULL),(8169,'07869','S','Dover','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.844283,-74.574152,0,'2013-07-06 12:44:30',NULL,NULL),(57375,'66743','S','Greenbush','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.506960,-94.863960,0,'2013-07-06 12:44:33',NULL,NULL),(29807,'33024','S','Cooper City','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.018670,-80.258199,0,'2013-07-06 12:44:32',NULL,NULL),(12909,'13338','S','Honnedaga Lake','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(39998,'45243','S','Columbia Township','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.185697,-84.352352,0,'2013-07-06 12:44:32',NULL,NULL),(40721,'46121','S','Reno','N','Putnam','18133','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.673090,-86.664333,0,'2013-07-06 12:44:32',NULL,NULL),(55615,'63960','S','Kinder','N','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.952919,-90.157210,0,'2013-07-06 12:44:33',NULL,NULL),(48057,'55321','S','Cokato','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.077418,-94.190139,0,'2013-07-06 12:44:33',NULL,NULL),(4349,'03046','S','Dunbarton','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.101422,-71.618832,0,'2013-07-06 12:44:30',NULL,NULL),(69547,'83806','P','Bovill','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.863681,-116.391792,0,'2013-07-06 12:44:34',NULL,NULL),(61230,'72329','P','Driver','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.550720,-89.949775,0,'2013-07-06 12:44:33',NULL,NULL),(53294,'61729','S','Congerville','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.619023,-89.207894,0,'2013-07-06 12:44:33',NULL,NULL),(53240,'61652','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.678847,-89.607597,0,'2013-07-06 12:44:33',NULL,NULL),(42074,'47453','S','Owensburg','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.946534,-86.755017,0,'2013-07-06 12:44:32',NULL,NULL),(76407,'95550','S','Korbel','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.777252,-123.881208,0,'2013-07-06 12:44:34',NULL,NULL),(6552,'05843','S','Mackville','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.504809,-72.357211,0,'2013-07-06 12:44:30',NULL,NULL),(57368,'66741','S','Garland','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.714958,-94.683076,0,'2013-07-06 12:44:33',NULL,NULL),(45769,'52154','S','Little Turkey','N','Chickasaw','19037','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.101911,-92.138892,0,'2013-07-06 12:44:32',NULL,NULL),(44150,'49523','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.965240,-85.672993,0,'2013-07-06 12:44:32',NULL,NULL),(34613,'38751','S','Indianola','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(39852,'45169','S','Sabina','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.491952,-83.654601,0,'2013-07-06 12:44:32',NULL,NULL),(76101,'95224','P','Avery','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.210180,-120.366866,0,'2013-07-06 12:44:34',NULL,NULL),(69085,'83252','S','Daniels','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(22983,'24739','S','Oakvale','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.330040,-80.967203,0,'2013-07-06 12:44:31',NULL,NULL),(7976,'07709','U','Red Bank','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.234142,-74.002173,0,'2013-07-06 12:44:30',NULL,NULL),(64772,'76958','P','Water Valley','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.666770,-100.716389,0,'2013-07-06 12:44:34',NULL,NULL),(75151,'93561','S','Tehachapi','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(27866,'30442','S','Butts','N','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(64309,'76467','P','Paluxy','D','Hood','48221','Texas','TX','48','2800','254','Central',-6.0,'Y',32.270586,-97.905031,0,'2013-07-06 12:44:34',NULL,NULL),(2418,'00953','S','Jard de Toa Alta','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(51200,'59034','S','Hardin','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.714719,-107.618740,0,'2013-07-06 12:44:33',NULL,NULL),(42672,'47965','P','New Market','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.954916,-86.920720,0,'2013-07-06 12:44:32',NULL,NULL),(79337,'98619','S','Glenwood','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.010833,-121.284698,0,'2013-07-06 12:44:34',NULL,NULL),(79385,'98682','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.671798,-122.511245,0,'2013-07-06 12:44:34',NULL,NULL),(79870,'99565','P','Chignik Lagn','A','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.187976,-158.445675,0,'2013-07-06 12:44:34',NULL,NULL),(16942,'17701','S','Grimesville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(79832,'99518','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.158028,-149.881079,0,'2013-07-06 12:44:34',NULL,NULL),(8327,'08036','S','Hainesprt Twp','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.984745,-74.830958,0,'2013-07-06 12:44:30',NULL,NULL),(67051,'79549','S','Union','N','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.764680,-100.858920,0,'2013-07-06 12:44:34',NULL,NULL),(61766,'73055','S','Marlow','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.644252,-97.961450,0,'2013-07-06 12:44:33',NULL,NULL),(57981,'67841','S','Ensign','D','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.652226,-100.230612,0,'2013-07-06 12:44:33',NULL,NULL),(19656,'20303','U','National Imaging and Mapping','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.920577,-76.994500,0,'2013-07-06 12:44:31',NULL,NULL),(2215,'00926','S','Urb Borinquen Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(11622,'12108','S','Lake Pleasant','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.469089,-74.416358,0,'2013-07-06 12:44:30',NULL,NULL),(79685,'99180','S','Usk','D','Pend Oreille','53051','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.279771,-117.308966,0,'2013-07-06 12:44:34',NULL,NULL),(3612,'02052','S','Medfield','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.177982,-71.305897,0,'2013-07-06 12:44:30',NULL,NULL),(2681,'00968','S','Caparra Hls Ind Park','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(30390,'33320','P','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.143950,-80.141327,0,'2013-07-06 12:44:32',NULL,NULL),(64421,'76554','S','Academy','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.988620,-97.365780,0,'2013-07-06 12:44:34',NULL,NULL),(2953,'01034','S','West Granville','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.081960,-72.950580,0,'2013-07-06 12:44:30',NULL,NULL),(58504,'68768','S','Pilger','D','Stanton','31167','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.007328,-97.052909,0,'2013-07-06 12:44:33',NULL,NULL),(25077,'27948','S','Kill Devil Hills','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.022095,-75.680394,0,'2013-07-06 12:44:31',NULL,NULL),(46411,'53177','S','Sturtevant','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.697861,-87.917460,0,'2013-07-06 12:44:32',NULL,NULL),(45365,'51006','S','Battle Creek','D','Ida','19093','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.325465,-95.590506,0,'2013-07-06 12:44:32',NULL,NULL),(39667,'45012','P','Hamilton','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.474907,-84.681954,0,'2013-07-06 12:44:32',NULL,NULL),(14214,'14785','P','Stow','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.157319,-79.404216,0,'2013-07-06 12:44:31',NULL,NULL),(18267,'19007','S','Tullytown','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.111586,-74.861944,0,'2013-07-06 12:44:31',NULL,NULL),(17317,'17859','S','Ashbury','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(62377,'74077','U','Stillwater','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.118222,-97.062130,0,'2013-07-06 12:44:33',NULL,NULL),(50495,'58059','S','Durbin','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.867140,-97.069320,0,'2013-07-06 12:44:33',NULL,NULL),(72146,'88321','S','Encino','D','Torrance','35057','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.593805,-105.496912,0,'2013-07-06 12:44:34',NULL,NULL),(1144,'00727','S','Ciudad Jardin de Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(74020,'92127','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',33.024076,-117.103864,0,'2013-07-06 12:44:34',NULL,NULL),(15280,'16117','S','Ellport','A','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.861599,-80.268252,0,'2013-07-06 12:44:31',NULL,NULL),(29803,'33023','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(52278,'60526','S','La Grange Pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.831029,-87.873348,0,'2013-07-06 12:44:33',NULL,NULL),(50957,'58623','S','Bowman','D','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.179366,-103.400993,0,'2013-07-06 12:44:33',NULL,NULL),(12594,'13074','S','South Hannibal','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.285920,-76.532580,0,'2013-07-06 12:44:30',NULL,NULL),(16757,'17517','S','Denver','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.241302,-76.137348,0,'2013-07-06 12:44:31',NULL,NULL),(73587,'91384','S','Val Verde','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.464820,-118.640594,0,'2013-07-06 12:44:34',NULL,NULL),(58837,'69123','S','Brady','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.062120,-100.373638,0,'2013-07-06 12:44:33',NULL,NULL),(24600,'27330','S','Buffalo Lake','A','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(3205,'01354','S','Northfield Mount Hermon','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711180,-72.448620,0,'2013-07-06 12:44:30',NULL,NULL),(6920,'06155','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757156,-72.743576,0,'2013-07-06 12:44:30',NULL,NULL),(55785,'64119','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.208712,-94.518737,0,'2013-07-06 12:44:33',NULL,NULL),(27563,'30263','S','Raymond','A','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.393182,-84.823447,0,'2013-07-06 12:44:31',NULL,NULL),(38425,'43550','P','Okolona','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.392207,-84.123017,0,'2013-07-06 12:44:32',NULL,NULL),(35478,'39520','S','St Louis','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(8118,'07825','S','Blairstown','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.982604,-74.950757,0,'2013-07-06 12:44:30',NULL,NULL),(32141,'35459','S','Emelle','D','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.761720,-88.309687,0,'2013-07-06 12:44:32',NULL,NULL),(55551,'63851','S','Hayti Heights','A','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.235589,-89.749057,0,'2013-07-06 12:44:33',NULL,NULL),(49700,'57030','S','Palisade','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.714740,-96.519420,0,'2013-07-06 12:44:33',NULL,NULL),(39582,'44857','S','Norwalk','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.238868,-82.602595,0,'2013-07-06 12:44:32',NULL,NULL),(58862,'69149','S','Sunol','N','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.167860,-102.655560,0,'2013-07-06 12:44:33',NULL,NULL),(39578,'44856','P','N Robinson','A','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.792386,-82.860196,0,'2013-07-06 12:44:32',NULL,NULL),(34278,'38476','S','Primm Springs','D','Williamson','47187','Tennessee','TN','47','5360','931','Central',-6.0,'Y',35.837001,-87.239841,0,'2013-07-06 12:44:32',NULL,NULL),(1309,'00735','S','Brisas de Ceiba','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(15180,'15937','P','Jerome','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.207079,-78.993522,0,'2013-07-06 12:44:31',NULL,NULL),(45570,'51527','S','Defiance','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.827307,-95.341633,0,'2013-07-06 12:44:32',NULL,NULL),(43727,'48924','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.699700,-84.527094,0,'2013-07-06 12:44:32',NULL,NULL),(41883,'47369','S','Pennville','D','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.492708,-85.149190,0,'2013-07-06 12:44:32',NULL,NULL),(38312,'43359','S','Wharton','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.870834,-83.449911,0,'2013-07-06 12:44:32',NULL,NULL),(12920,'13339','S','Sand Hill','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(31693,'34797','S','Howey In Hls','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.742227,-81.820758,0,'2013-07-06 12:44:32',NULL,NULL),(61364,'72512','S','Horseshoe Bnd','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.228348,-91.752774,0,'2013-07-06 12:44:33',NULL,NULL),(64368,'76526','P','Flat','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.312040,-97.572218,0,'2013-07-06 12:44:34',NULL,NULL),(16471,'17243','S','Blacklog','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.239420,-77.907120,0,'2013-07-06 12:44:31',NULL,NULL),(50682,'58346','S','Harlow','A','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.276420,-99.437460,0,'2013-07-06 12:44:33',NULL,NULL),(43744,'49004','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.347100,-85.547460,0,'2013-07-06 12:44:32',NULL,NULL),(74350,'92408','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.081612,-117.275214,0,'2013-07-06 12:44:34',NULL,NULL),(69146,'83313','S','Bellevue','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.414624,-114.198990,0,'2013-07-06 12:44:34',NULL,NULL),(59945,'71301','S','Castle Village','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(22612,'24216','S','Stonega','A','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.906361,-82.782620,0,'2013-07-06 12:44:31',NULL,NULL),(74692,'92899','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.837257,-117.871219,0,'2013-07-06 12:44:34',NULL,NULL),(14793,'15366','P','Van Voorhis','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.158092,-79.972806,0,'2013-07-06 12:44:31',NULL,NULL),(54916,'63089','S','Villa Ridge','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.463535,-90.874188,0,'2013-07-06 12:44:33',NULL,NULL),(35154,'39232','S','Jksn','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289828,-90.181404,0,'2013-07-06 12:44:32',NULL,NULL),(15785,'16923','S','Genesee','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(60502,'71665','S','Randall','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(38850,'44093','S','Williamsfield','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.528936,-80.609192,0,'2013-07-06 12:44:32',NULL,NULL),(36730,'41031','S','Poindexter','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(41838,'47346','S','Hagerstown','D','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.927181,-85.153805,0,'2013-07-06 12:44:32',NULL,NULL),(41945,'47394','S','Snow Hill','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.175183,-84.976721,0,'2013-07-06 12:44:32',NULL,NULL),(60390,'71603','S','Pine Bluff','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.198278,-92.034403,0,'2013-07-06 12:44:33',NULL,NULL),(57698,'67333','S','Caney','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.014294,-95.931916,0,'2013-07-06 12:44:33',NULL,NULL),(25647,'28469','S','Ocean Isl Bch','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.923901,-78.459091,0,'2013-07-06 12:44:31',NULL,NULL),(1683,'00777','S','Jard de Barcelona','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(45517,'51430','S','Arcadia','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.090226,-95.044867,0,'2013-07-06 12:44:32',NULL,NULL),(36421,'40550','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.141026,-84.466930,0,'2013-07-06 12:44:32',NULL,NULL),(4510,'03298','U','J Jill','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.634856,-71.531507,0,'2013-07-06 12:44:30',NULL,NULL),(71978,'88022','S','Arenas Valley','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.788740,-108.194340,0,'2013-07-06 12:44:34',NULL,NULL),(68126,'80951','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837139,-104.795539,0,'2013-07-06 12:44:34',NULL,NULL),(32682,'36268','S','Munford','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.528225,-85.977131,0,'2013-07-06 12:44:32',NULL,NULL),(47261,'54526','S','Ingram','A','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.504780,-90.859620,0,'2013-07-06 12:44:32',NULL,NULL),(76558,'95667','S','Old Fort Jim','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.726152,-120.803551,0,'2013-07-06 12:44:34',NULL,NULL),(67737,'80553','U','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.565319,-105.045445,0,'2013-07-06 12:44:34',NULL,NULL),(62859,'75028','S','Flower Mound','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.033405,-97.067657,0,'2013-07-06 12:44:33',NULL,NULL),(49447,'56641','S','Federal Dam','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.197495,-94.238032,0,'2013-07-06 12:44:33',NULL,NULL),(29602,'32834','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.563579,-81.206956,0,'2013-07-06 12:44:32',NULL,NULL),(3485,'01835','S','Bradford','A','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.754563,-71.087282,0,'2013-07-06 12:44:30',NULL,NULL),(2340,'00936','P','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(45708,'52060','S','Maquoketa','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.071208,-90.660765,0,'2013-07-06 12:44:32',NULL,NULL),(28540,'31554','S','Sessoms','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(74944,'93410','S','Cal Poly SLO','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.276728,-120.737489,0,'2013-07-06 12:44:34',NULL,NULL),(50408,'57780','S','Conata','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',43.794115,-102.431907,0,'2013-07-06 12:44:33',NULL,NULL),(47762,'55031','S','New Trier','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.606486,-93.000228,0,'2013-07-06 12:44:33',NULL,NULL),(2045,'00918','S','Urb Los Maestros','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(2691,'00968','S','Urb San Patricio Meadows','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(76244,'95391','S','Mtn House','A','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.760523,-121.546105,0,'2013-07-06 12:44:34',NULL,NULL),(78688,'98249','S','Freeland','D','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.023245,-122.547172,0,'2013-07-06 12:44:34',NULL,NULL),(27044,'29667','S','Norris','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.759485,-82.770568,0,'2013-07-06 12:44:31',NULL,NULL),(25338,'28215','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.239821,-80.725177,0,'2013-07-06 12:44:31',NULL,NULL),(16845,'17562','S','Bellemont','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.974340,-76.107420,0,'2013-07-06 12:44:31',NULL,NULL),(13876,'14260','U','University at Buffalo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.003074,-78.785924,0,'2013-07-06 12:44:31',NULL,NULL),(71651,'87501','S','Agua Fria','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(69983,'84121','S','Cottonwood Heights City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(59849,'71254','S','Gassoway','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(58655,'68874','S','West Union','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.639988,-99.371879,0,'2013-07-06 12:44:33',NULL,NULL),(7897,'07601','S','Hack','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.888613,-74.047760,0,'2013-07-06 12:44:30',NULL,NULL),(1300,'00730','S','Urb Tibes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(2098,'00923','S','Urb Casas Yoyo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(6233,'05491','S','Mile Point','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(829,'00693','S','Villa Pinares','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(78699,'98258','S','Lake Stevens','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',48.027419,-122.062363,0,'2013-07-06 12:44:34',NULL,NULL),(77511,'96839','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.322589,-157.812705,0,'2013-07-06 12:44:34',NULL,NULL),(39340,'44620','S','Dellroy','D','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.574692,-81.210512,0,'2013-07-06 12:44:32',NULL,NULL),(41390,'46804','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.055452,-85.243032,0,'2013-07-06 12:44:32',NULL,NULL),(78510,'98115','S','Wedgwood','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.683441,-122.291533,0,'2013-07-06 12:44:34',NULL,NULL),(34724,'38844','S','Gattman','D','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.883707,-88.234948,0,'2013-07-06 12:44:32',NULL,NULL),(34189,'38328','S','Darden','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.673536,-88.215747,0,'2013-07-06 12:44:32',NULL,NULL),(47668,'54943','S','Hancock','D','Waushara','55137','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.132261,-89.692475,0,'2013-07-06 12:44:33',NULL,NULL),(40945,'46301','P','Beverly Shores','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.672687,-86.973604,0,'2013-07-06 12:44:32',NULL,NULL),(13044,'13439','S','South Columbia','N','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(2557,'00959','S','Urb Braulio Dueno','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(47934,'55113','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(25988,'28666','P','Icard','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.647803,-81.263244,0,'2013-07-06 12:44:31',NULL,NULL),(39108,'44242','U','Kent State University','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.146742,-81.362684,0,'2013-07-06 12:44:32',NULL,NULL),(62897,'75067','S','Lewisville','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.077549,-97.049260,0,'2013-07-06 12:44:33',NULL,NULL),(30991,'33764','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.938898,-82.744839,0,'2013-07-06 12:44:32',NULL,NULL),(41309,'46772','S','Coppess Corner','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.740508,-84.944366,0,'2013-07-06 12:44:32',NULL,NULL),(21122,'22095','U','Reston','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.968942,-77.388697,0,'2013-07-06 12:44:31',NULL,NULL),(25633,'28465','S','Long Beach','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(79260,'98564','S','Mossyrock','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.510282,-122.501783,0,'2013-07-06 12:44:34',NULL,NULL),(24507,'27278','S','West Hillsborough','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.074580,-79.077660,0,'2013-07-06 12:44:31',NULL,NULL),(34014,'38125','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.029029,-89.810269,0,'2013-07-06 12:44:32',NULL,NULL),(2189,'00926','S','Palmares De Monteverde','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(25936,'28655','S','Joy','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(25692,'28527','S','Ernul','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.243238,-77.026924,0,'2013-07-06 12:44:31',NULL,NULL),(6296,'05652','S','Eden','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.743658,-72.621668,0,'2013-07-06 12:44:30',NULL,NULL),(79541,'98950','P','Vantage','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.946109,-119.985319,0,'2013-07-06 12:44:34',NULL,NULL),(75346,'93907','S','Prunedale','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.757320,-121.668120,0,'2013-07-06 12:44:34',NULL,NULL),(12363,'12910','S','Alder Bend','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.882237,-73.662504,0,'2013-07-06 12:44:30',NULL,NULL),(22072,'23350','S','Exmore','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.535807,-75.824342,0,'2013-07-06 12:44:31',NULL,NULL),(77212,'96379','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(32720,'36305','S','Dothan','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.222470,-85.390698,0,'2013-07-06 12:44:32',NULL,NULL),(39459,'44707','S','N Industry','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.780264,-81.361212,0,'2013-07-06 12:44:32',NULL,NULL),(11556,'12058','S','Earlton','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.349583,-73.902962,0,'2013-07-06 12:44:30',NULL,NULL),(41162,'46703','S','Glen Eden','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.667180,-84.989640,0,'2013-07-06 12:44:32',NULL,NULL),(36543,'40903','S','Artemus','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.843261,-83.828011,0,'2013-07-06 12:44:32',NULL,NULL),(67691,'80517','S','Estes Park','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.365932,-105.515995,0,'2013-07-06 12:44:34',NULL,NULL),(2975,'01054','S','East Leverett','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.474743,-72.482496,0,'2013-07-06 12:44:30',NULL,NULL),(69692,'84029','S','Burmester','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.604525,-112.456180,0,'2013-07-06 12:44:34',NULL,NULL),(13881,'14261','U','University Buffalo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.002450,-78.781965,0,'2013-07-06 12:44:31',NULL,NULL),(56870,'66018','S','De Soto','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.970431,-94.967565,0,'2013-07-06 12:44:33',NULL,NULL),(9372,'09830','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(36126,'40223','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(78187,'97720','S','Burns','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.524973,-118.762656,0,'2013-07-06 12:44:34',NULL,NULL),(67988,'80918','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.915062,-104.773227,0,'2013-07-06 12:44:34',NULL,NULL),(62625,'74549','S','Kiamichi','A','Le Flore','40079','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.539310,-94.938190,0,'2013-07-06 12:44:33',NULL,NULL),(47214,'54494','S','Biron','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.353320,-89.748720,0,'2013-07-06 12:44:32',NULL,NULL),(45644,'51653','S','Tabor','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.896392,-95.671390,0,'2013-07-06 12:44:32',NULL,NULL),(68120,'80950','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837558,-104.795156,0,'2013-07-06 12:44:34',NULL,NULL),(8492,'08096','S','Blackwood Ter','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(28266,'31077','S','Rhine','D','Dodge','13091','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.011250,-83.198326,0,'2013-07-06 12:44:31',NULL,NULL),(14887,'15480','S','Smock','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.987169,-79.777218,0,'2013-07-06 12:44:31',NULL,NULL),(53519,'62025','S','Holiday Shores','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.808317,-89.950081,0,'2013-07-06 12:44:33',NULL,NULL),(72591,'89406','S','Salt Wells','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(68153,'81001','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(48749,'55971','S','South Rushford','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(41042,'46401','P','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.460909,-87.285371,0,'2013-07-06 12:44:32',NULL,NULL),(68260,'81067','S','Vroman','N','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.044708,-103.717601,0,'2013-07-06 12:44:34',NULL,NULL),(67111,'79731','S','Crane','D','Crane','48103','Texas','TX','48','0000','432','Central',-6.0,'Y',31.392825,-102.351610,0,'2013-07-06 12:44:34',NULL,NULL),(62927,'75086','P','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.025974,-96.699035,0,'2013-07-06 12:44:33',NULL,NULL),(60539,'71677','P','Yukon','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.750509,-91.549042,0,'2013-07-06 12:44:33',NULL,NULL),(4121,'02738','S','Marion','D','Plymouth','25023','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.709414,-70.758377,0,'2013-07-06 12:44:30',NULL,NULL),(3280,'01474','S','W Townsend','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.671160,-71.713080,0,'2013-07-06 12:44:30',NULL,NULL),(76120,'95242','S','Lodi','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.127032,-121.322128,0,'2013-07-06 12:44:34',NULL,NULL),(6168,'05473','S','Monkton Ridge','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(6249,'05495','S','St George','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.427660,-73.087980,0,'2013-07-06 12:44:30',NULL,NULL),(33220,'37058','S','Fort Donelson National Milit','N','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.482869,-87.833627,0,'2013-07-06 12:44:32',NULL,NULL),(25374,'28253','U','GMAC','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.323653,-80.782178,0,'2013-07-06 12:44:31',NULL,NULL),(50463,'58033','S','Fort Ransom','D','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.433700,-97.862400,0,'2013-07-06 12:44:33',NULL,NULL),(15837,'16935','S','Shortsville','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.855833,-77.237500,0,'2013-07-06 12:44:31',NULL,NULL),(37044,'41267','S','Hode','A','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.854000,-82.435020,0,'2013-07-06 12:44:32',NULL,NULL),(33357,'37185','S','Waverly','D','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.087613,-87.790907,0,'2013-07-06 12:44:32',NULL,NULL),(41063,'46510','S','Claypool','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.123175,-85.898042,0,'2013-07-06 12:44:32',NULL,NULL),(3810,'02283','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348748,-71.056723,0,'2013-07-06 12:44:30',NULL,NULL),(20186,'20748','S','Camp Springs','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(58814,'69030','S','Haigler','D','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.160205,-101.945280,0,'2013-07-06 12:44:33',NULL,NULL),(43055,'48186','S','Westland','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.299722,-83.379852,0,'2013-07-06 12:44:32',NULL,NULL),(32218,'35571','S','Hodges','D','Franklin','01059','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.344894,-87.968525,0,'2013-07-06 12:44:32',NULL,NULL),(30093,'33157','S','Perrine','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(60647,'71909','S','Hot Springs National','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.610580,-93.014760,0,'2013-07-06 12:44:33',NULL,NULL),(72297,'88578','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768648,-106.332785,0,'2013-07-06 12:44:34',NULL,NULL),(37093,'41339','S','Noctor','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(72682,'89444','S','Wellington','D','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.842200,-119.367900,0,'2013-07-06 12:44:34',NULL,NULL),(27319,'30026','P','North Metro','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.976579,-84.150049,0,'2013-07-06 12:44:31',NULL,NULL),(67564,'80293','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745651,-104.990424,0,'2013-07-06 12:44:34',NULL,NULL),(39931,'45225','S','Camp Washington','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.141820,-84.552967,0,'2013-07-06 12:44:32',NULL,NULL),(29640,'32899','U','Kennedy Sp Ct','A','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.611682,-80.677691,0,'2013-07-06 12:44:32',NULL,NULL),(29432,'32683','P','Otter Creek','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.325365,-82.772815,0,'2013-07-06 12:44:32',NULL,NULL),(60180,'71416','S','Cloutierville','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.584840,-92.901000,0,'2013-07-06 12:44:33',NULL,NULL),(33288,'37122','S','Mount Juliet','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.215209,-86.517501,0,'2013-07-06 12:44:32',NULL,NULL),(23619,'25715','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.395114,-82.451782,0,'2013-07-06 12:44:31',NULL,NULL),(70576,'85068','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.677489,-112.061267,0,'2013-07-06 12:44:34',NULL,NULL),(14890,'15484','P','Uledi','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.892013,-79.788687,0,'2013-07-06 12:44:31',NULL,NULL),(59596,'71009','P','Blanchard','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.584935,-93.895957,0,'2013-07-06 12:44:33',NULL,NULL),(51110,'58784','S','Belden','A','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.312403,-102.392847,0,'2013-07-06 12:44:33',NULL,NULL),(32444,'36013','S','Cecil','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.297340,-86.018460,0,'2013-07-06 12:44:32',NULL,NULL),(38477,'43654','U','Natl Family Opinion','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.605962,-83.537003,0,'2013-07-06 12:44:32',NULL,NULL),(37478,'42001','S','Oakdale','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(32955,'36582','S','Theodore','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.532137,-88.179287,0,'2013-07-06 12:44:32',NULL,NULL),(34956,'39062','P','D\' LO','N','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.984304,-89.898049,0,'2013-07-06 12:44:32',NULL,NULL),(31983,'35219','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473661,-86.825878,0,'2013-07-06 12:44:32',NULL,NULL),(75232,'93646','S','Orange Cove','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.625475,-119.320410,0,'2013-07-06 12:44:34',NULL,NULL),(25687,'28523','S','Cove City','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.209185,-77.290206,0,'2013-07-06 12:44:31',NULL,NULL),(8915,'08741','S','Pine Beach','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.933096,-74.165383,0,'2013-07-06 12:44:30',NULL,NULL),(74083,'92186','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.747783,-117.202029,0,'2013-07-06 12:44:34',NULL,NULL),(67397,'80125','S','Roxborough','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.482672,-105.055501,0,'2013-07-06 12:44:34',NULL,NULL),(52402,'60637','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.781280,-87.603401,0,'2013-07-06 12:44:33',NULL,NULL),(51841,'60069','S','Lincolnshire','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194460,-87.910740,0,'2013-07-06 12:44:33',NULL,NULL),(49119,'56356','P','New Munich','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.630092,-94.753033,0,'2013-07-06 12:44:33',NULL,NULL),(15094,'15762','S','Nicktown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.591372,-78.810834,0,'2013-07-06 12:44:31',NULL,NULL),(12492,'12996','S','Willsboro Point','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.374140,-73.417200,0,'2013-07-06 12:44:30',NULL,NULL),(36131,'40223','S','Wildwood','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(58983,'70047','S','Ormond','N','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.963928,-90.375524,0,'2013-07-06 12:44:33',NULL,NULL),(49094,'56334','S','Long Beach','A','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.651444,-95.386131,0,'2013-07-06 12:44:33',NULL,NULL),(64737,'76901','S','Grape Creek','A','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.465353,-100.493525,0,'2013-07-06 12:44:34',NULL,NULL),(62066,'73547','S','Granite','D','Greer','40055','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.960595,-99.380775,0,'2013-07-06 12:44:33',NULL,NULL),(61501,'72648','S','Dogpatch','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.084759,-93.146930,0,'2013-07-06 12:44:33',NULL,NULL),(61362,'72512','S','Franklin','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.228348,-91.752774,0,'2013-07-06 12:44:33',NULL,NULL),(41351,'46792','S','Buckeye','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(33355,'37183','S','Wartrace','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.502048,-86.340949,0,'2013-07-06 12:44:32',NULL,NULL),(71594,'87319','P','Gallup','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.493375,-108.855190,0,'2013-07-06 12:44:34',NULL,NULL),(40622,'46011','S','Woodlawn Heights','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(36048,'40205','S','Strathmr Vlg','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(3294,'01507','S','Charlton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.148385,-71.941347,0,'2013-07-06 12:44:30',NULL,NULL),(8513,'08104','S','Camden','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.919931,-75.108157,0,'2013-07-06 12:44:30',NULL,NULL),(64020,'76118','S','Richland Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(17019,'17744','S','Level Corner','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.271905,-77.162229,0,'2013-07-06 12:44:31',NULL,NULL),(47793,'55047','S','Marine on St Croix','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(69026,'83214','S','Garden Creek','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.554001,-112.229068,0,'2013-07-06 12:44:34',NULL,NULL),(72645,'89427','P','Schurz','D','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.948754,-118.818822,0,'2013-07-06 12:44:34',NULL,NULL),(78385,'98027','S','Issaquah','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.533481,-122.068701,0,'2013-07-06 12:44:34',NULL,NULL),(45009,'50453','S','Leland','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.338260,-93.633413,0,'2013-07-06 12:44:32',NULL,NULL),(38885,'44109','S','Brooklyn Heights','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.450419,-81.701900,0,'2013-07-06 12:44:32',NULL,NULL),(1988,'00907','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.454321,-66.076621,0,'2013-07-06 12:44:30',NULL,NULL),(63252,'75485','P','Westminster','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.305597,-96.384095,0,'2013-07-06 12:44:33',NULL,NULL),(8162,'07860','S','Fredon','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.036057,-74.764550,0,'2013-07-06 12:44:30',NULL,NULL),(3042,'01103','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.102044,-72.587143,0,'2013-07-06 12:44:30',NULL,NULL),(13972,'14478','S','Keuka Park','D','Yates','36123','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.587954,-77.124490,0,'2013-07-06 12:44:31',NULL,NULL),(7074,'06340','S','Center Groton','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(69665,'84016','P','Clearfield','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.104372,-112.020693,0,'2013-07-06 12:44:34',NULL,NULL),(66775,'79033','P','Farnsworth','D','Ochiltree','48357','Texas','TX','48','0000','806','Central',-6.0,'Y',36.393458,-100.760558,0,'2013-07-06 12:44:34',NULL,NULL),(37713,'42273','S','Rochester','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.219089,-86.868909,0,'2013-07-06 12:44:32',NULL,NULL),(41915,'47374','S','Spring Grv Hts','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(47968,'55124','S','Apple Valley','A','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.746620,-93.201840,0,'2013-07-06 12:44:33',NULL,NULL),(8871,'08691','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(8836,'08629','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218249,-74.730652,0,'2013-07-06 12:44:30',NULL,NULL),(17962,'18577','U','United Parcel Service','N','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.421090,-75.602820,0,'2013-07-06 12:44:31',NULL,NULL),(39216,'44408','S','Columbiana','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.873824,-80.681892,0,'2013-07-06 12:44:32',NULL,NULL),(45311,'50841','S','Carl','N','Adams','19003','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.004900,-94.742880,0,'2013-07-06 12:44:32',NULL,NULL),(60664,'71921','S','Elm','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.244100,-93.379920,0,'2013-07-06 12:44:33',NULL,NULL),(56812,'65775','S','West Plains','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.513880,-91.801540,0,'2013-07-06 12:44:33',NULL,NULL),(55860,'64179','U','Kansas City Brm','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.123220,-94.555049,0,'2013-07-06 12:44:33',NULL,NULL),(28814,'32072','P','Olustee','D','Baker','12003','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.202771,-82.430793,0,'2013-07-06 12:44:32',NULL,NULL),(46739,'53913','S','West Baraboo','N','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.525920,-89.774040,0,'2013-07-06 12:44:32',NULL,NULL),(13629,'13903','S','East Vestal','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.097500,-75.894240,0,'2013-07-06 12:44:31',NULL,NULL),(56449,'65280','S','Rush Hill','D','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.192334,-91.678711,0,'2013-07-06 12:44:33',NULL,NULL),(18878,'19456','P','Oaks','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.135328,-75.453612,0,'2013-07-06 12:44:31',NULL,NULL),(63070,'75236','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.688333,-96.938424,0,'2013-07-06 12:44:33',NULL,NULL),(46548,'53406','S','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.725720,-87.856436,0,'2013-07-06 12:44:32',NULL,NULL),(41999,'47424','S','Plummer','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(41562,'47023','S','Dabney','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.021348,-85.387979,0,'2013-07-06 12:44:32',NULL,NULL),(73500,'91331','S','Arleta','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252512,-118.425349,0,'2013-07-06 12:44:34',NULL,NULL),(6379,'05682','S','North Middlesex','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.408965,-72.573124,0,'2013-07-06 12:44:30',NULL,NULL),(39502,'44807','S','Attica','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(57992,'67854','S','Jetmore','D','Hodgeman','20083','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.080999,-99.894098,0,'2013-07-06 12:44:33',NULL,NULL),(31210,'33952','S','Ft Charlotte','N','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.991101,-82.099054,0,'2013-07-06 12:44:32',NULL,NULL),(43976,'49326','S','Gowen','D','Kent','26081','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.235020,-85.340378,0,'2013-07-06 12:44:32',NULL,NULL),(64641,'76710','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.541760,-97.184700,0,'2013-07-06 12:44:34',NULL,NULL),(42409,'47802','S','Dowden Acres','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(21709,'22976','S','Roseland','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.921586,-78.945010,0,'2013-07-06 12:44:31',NULL,NULL),(1788,'00783','S','Corozal','D','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(67608,'80432','P','Como','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.218495,-105.745536,0,'2013-07-06 12:44:34',NULL,NULL),(33955,'38103','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145357,-90.049688,0,'2013-07-06 12:44:32',NULL,NULL),(3274,'01471','U','Groton','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.607854,-71.572329,0,'2013-07-06 12:44:30',NULL,NULL),(3971,'02493','S','Stony Brook','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(30696,'33482','P','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.453951,-80.087116,0,'2013-07-06 12:44:32',NULL,NULL),(62468,'74338','S','Colcord','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.248548,-94.673222,0,'2013-07-06 12:44:33',NULL,NULL),(57954,'67753','S','Menlo','A','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.413220,-100.742340,0,'2013-07-06 12:44:33',NULL,NULL),(52475,'60688','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.846809,-87.649947,0,'2013-07-06 12:44:33',NULL,NULL),(42901,'48101','S','Allen Park','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.253333,-83.208255,0,'2013-07-06 12:44:32',NULL,NULL),(27210,'29909','S','Callawassie Island','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.262421,-80.867479,0,'2013-07-06 12:44:31',NULL,NULL),(46357,'53103','S','Big Bend','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.878515,-88.217994,0,'2013-07-06 12:44:32',NULL,NULL),(38469,'43619','S','Northwood','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.601962,-83.480669,0,'2013-07-06 12:44:32',NULL,NULL),(71648,'87455','P','Newcomb','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.283561,-108.708314,0,'2013-07-06 12:44:34',NULL,NULL),(41691,'47202','P','Columbus','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.207308,-85.918098,0,'2013-07-06 12:44:32',NULL,NULL),(79163,'98511','P','Olympia','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.039781,-122.900904,0,'2013-07-06 12:44:34',NULL,NULL),(8184,'07882','S','Washington','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.759714,-75.008161,0,'2013-07-06 12:44:30',NULL,NULL),(65824,'78148','S','Universal City','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.551704,-98.302464,0,'2013-07-06 12:44:34',NULL,NULL),(5396,'04654','S','Machias','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.720530,-67.467043,0,'2013-07-06 12:44:30',NULL,NULL),(40310,'45459','S','Centerville','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(46147,'52656','S','West Point','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.716675,-91.454585,0,'2013-07-06 12:44:32',NULL,NULL),(78248,'97830','S','Kinzua','A','Wheeler','41069','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.998369,-120.212626,0,'2013-07-06 12:44:34',NULL,NULL),(30239,'33193','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.693575,-80.445767,0,'2013-07-06 12:44:32',NULL,NULL),(4761,'03852','S','Milton Mills','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.504592,-70.978108,0,'2013-07-06 12:44:30',NULL,NULL),(7335,'06710','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.568003,-73.045373,0,'2013-07-06 12:44:30',NULL,NULL),(26466,'29148','S','Summerton','D','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.589744,-80.341999,0,'2013-07-06 12:44:31',NULL,NULL),(35077,'39201','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.292867,-90.184187,0,'2013-07-06 12:44:32',NULL,NULL),(50803,'58451','S','Hurdsfield','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.413057,-99.972447,0,'2013-07-06 12:44:33',NULL,NULL),(31877,'35125','S','Harrisburg','N','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573051,-86.276572,0,'2013-07-06 12:44:32',NULL,NULL),(33229,'37064','S','Rudderville','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.923225,-86.887821,0,'2013-07-06 12:44:32',NULL,NULL),(8171,'07870','P','Schooleys Mountain','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.820164,-74.761778,0,'2013-07-06 12:44:30',NULL,NULL),(71790,'87560','S','Leyba','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(15184,'15943','S','Nanty Glo','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.470680,-78.840081,0,'2013-07-06 12:44:31',NULL,NULL),(34694,'38828','S','Mound City','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(43717,'48915','S','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.740498,-84.572112,0,'2013-07-06 12:44:32',NULL,NULL),(30233,'33190','S','Cutler Bay','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.556771,-80.336864,0,'2013-07-06 12:44:32',NULL,NULL),(75170,'93601','S','Ahwahnee','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.380335,-119.718301,0,'2013-07-06 12:44:34',NULL,NULL),(61075,'72126','S','Williams Junction','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(38283,'43331','S','Lakeview','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.498480,-83.907723,0,'2013-07-06 12:44:32',NULL,NULL),(42738,'48017','S','Clawson','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.535396,-83.151815,0,'2013-07-06 12:44:32',NULL,NULL),(53804,'62289','P','Summerfield','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.595452,-89.752268,0,'2013-07-06 12:44:33',NULL,NULL),(76224,'95375','P','Strawberry','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.196233,-120.013415,0,'2013-07-06 12:44:34',NULL,NULL),(3090,'01220','S','Adams','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.619977,-73.120780,0,'2013-07-06 12:44:30',NULL,NULL),(4477,'03266','S','Groton','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.787467,-71.855141,0,'2013-07-06 12:44:30',NULL,NULL),(73219,'90630','S','Cypress','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.818073,-118.035677,0,'2013-07-06 12:44:34',NULL,NULL),(67148,'79776','P','Penwell','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.735015,-102.590183,0,'2013-07-06 12:44:34',NULL,NULL),(38197,'43207','S','Obetz','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.893940,-82.954080,0,'2013-07-06 12:44:32',NULL,NULL),(55259,'63457','S','Monticello','D','Lewis','29111','Missouri','MO','29','0000','573','Central',-6.0,'Y',40.115404,-91.708634,0,'2013-07-06 12:44:33',NULL,NULL),(16412,'17224','S','Richmond Furn','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(27021,'29647','U','Greenwood','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.189754,-82.153840,0,'2013-07-06 12:44:31',NULL,NULL),(45954,'52353','S','Washington','D','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.299109,-91.688587,0,'2013-07-06 12:44:32',NULL,NULL),(80058,'99714','S','Fairbanks','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.468564,-146.936418,0,'2013-07-06 12:44:34',NULL,NULL),(78282,'97868','S','Pilot Rock','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.484282,-118.832536,0,'2013-07-06 12:44:34',NULL,NULL),(39460,'44707','S','North Industry','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.780264,-81.361212,0,'2013-07-06 12:44:32',NULL,NULL),(4452,'03251','S','Lincoln','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.046117,-71.659913,0,'2013-07-06 12:44:30',NULL,NULL),(63100,'75266','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.780984,-96.881769,0,'2013-07-06 12:44:33',NULL,NULL),(30605,'33422','P','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.750328,-80.128524,0,'2013-07-06 12:44:32',NULL,NULL),(28657,'31776','P','Moultrie','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.155653,-83.793903,0,'2013-07-06 12:44:32',NULL,NULL),(2002,'00911','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451416,-66.061581,0,'2013-07-06 12:44:30',NULL,NULL),(49527,'56676','S','Pinewood','A','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.383450,-95.232970,0,'2013-07-06 12:44:33',NULL,NULL),(7318,'06701','U','Us Postal Service','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.558763,-73.052179,0,'2013-07-06 12:44:30',NULL,NULL),(7156,'06420','S','Salem','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.487578,-72.271646,0,'2013-07-06 12:44:30',NULL,NULL),(72153,'88325','P','High Rolls','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.076011,-106.025093,0,'2013-07-06 12:44:34',NULL,NULL),(34229,'38371','S','Sardis','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.437411,-88.307156,0,'2013-07-06 12:44:32',NULL,NULL),(35939,'40051','S','Trappist','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.671684,-85.546062,0,'2013-07-06 12:44:32',NULL,NULL),(47029,'54401','S','Rib Mountain','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.960540,-89.656218,0,'2013-07-06 12:44:32',NULL,NULL),(38819,'44076','S','East Orwell','A','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.532299,-80.830144,0,'2013-07-06 12:44:32',NULL,NULL),(60869,'72058','S','McGintytown','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(76672,'95765','S','Rocklin','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.822133,-121.271644,0,'2013-07-06 12:44:34',NULL,NULL),(77699,'97044','P','Odell','D','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.625313,-121.539710,0,'2013-07-06 12:44:34',NULL,NULL),(25637,'28465','S','Yaupon Beach','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(31663,'34748','S','Leesburg','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.804183,-81.885627,0,'2013-07-06 12:44:32',NULL,NULL),(69188,'83338','S','Sugar Loaf','N','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.709237,-114.464322,0,'2013-07-06 12:44:34',NULL,NULL),(18647,'19171','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955628,-75.155260,0,'2013-07-06 12:44:31',NULL,NULL),(23831,'26104','S','Parkersburg','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.286068,-81.526137,0,'2013-07-06 12:44:31',NULL,NULL),(64081,'76148','S','N Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(56066,'64747','S','Garden City','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.555303,-94.188013,0,'2013-07-06 12:44:33',NULL,NULL),(54885,'63068','S','Dissen','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(7401,'06793','S','Washington','D','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.640788,-73.293104,0,'2013-07-06 12:44:30',NULL,NULL),(5380,'04637','P','Grand Lake Stream','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.223333,-67.572778,0,'2013-07-06 12:44:30',NULL,NULL),(1518,'00754','S','Paseo de las Flores','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(78260,'97843','S','Ione','D','Morrow','41049','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.502734,-119.823955,0,'2013-07-06 12:44:34',NULL,NULL),(61427,'72573','S','Sage','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.040356,-91.821692,0,'2013-07-06 12:44:33',NULL,NULL),(71156,'86034','P','Keams Canyon','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.777580,-110.171820,0,'2013-07-06 12:44:34',NULL,NULL),(284,'00646','S','Paseo del Mar','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(34504,'38672','S','Southaven','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.991000,-90.023100,0,'2013-07-06 12:44:32',NULL,NULL),(35910,'40019','S','Eminence','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.380212,-85.182994,0,'2013-07-06 12:44:32',NULL,NULL),(31137,'33906','P','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.592680,-81.857155,0,'2013-07-06 12:44:32',NULL,NULL),(51388,'59417','S','St Mary','N','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.571299,-113.206612,0,'2013-07-06 12:44:33',NULL,NULL),(2455,'00953','S','Villa del Monte','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(64023,'76119','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.680500,-97.264980,0,'2013-07-06 12:44:34',NULL,NULL),(53091,'61529','S','Elmwood','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.778521,-89.950179,0,'2013-07-06 12:44:33',NULL,NULL),(9040,'08879','S','Morgan','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.463991,-74.275843,0,'2013-07-06 12:44:30',NULL,NULL),(50098,'57472','S','Lowry','A','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.412860,-100.021500,0,'2013-07-06 12:44:33',NULL,NULL),(32517,'36087','P','Tuskegee Inst','A','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.412992,-85.681539,0,'2013-07-06 12:44:32',NULL,NULL),(79561,'99013','S','Ford','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.809752,-117.770736,0,'2013-07-06 12:44:34',NULL,NULL),(29387,'32612','U','Univ of FL Student Dorms','N','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.652878,-82.351153,0,'2013-07-06 12:44:32',NULL,NULL),(7362,'06754','S','Cornwall Bridge','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.770620,-73.367400,0,'2013-07-06 12:44:30',NULL,NULL),(4691,'03810','S','West Alton','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.481209,-71.247630,0,'2013-07-06 12:44:30',NULL,NULL),(14215,'14786','P','W Clarksville','A','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.125215,-78.229883,0,'2013-07-06 12:44:31',NULL,NULL),(10423,'10709','S','Yonkers','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955972,-73.807475,0,'2013-07-06 12:44:30',NULL,NULL),(60265,'71447','S','Burns Town','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(8278,'08012','S','Chews Landing','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(4561,'03464','S','Stoddard','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.091956,-72.086878,0,'2013-07-06 12:44:30',NULL,NULL),(52512,'60805','S','Evergreen Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.722096,-87.702938,0,'2013-07-06 12:44:33',NULL,NULL),(77160,'96209','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(66290,'78583','S','Rio Hondo','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.236846,-97.578736,0,'2013-07-06 12:44:34',NULL,NULL),(65617,'77954','S','Lindenau','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(16900,'17583','P','West Willow','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.971229,-76.288109,0,'2013-07-06 12:44:31',NULL,NULL),(9806,'10110','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(55191,'63379','S','Davis','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.005640,-90.962460,0,'2013-07-06 12:44:33',NULL,NULL),(53411,'61840','S','Dewey','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.316175,-88.286483,0,'2013-07-06 12:44:33',NULL,NULL),(8339,'08038','P','Hancocks Bridge','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.503201,-75.461092,0,'2013-07-06 12:44:30',NULL,NULL),(70075,'84150','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.772019,-111.889801,0,'2013-07-06 12:44:34',NULL,NULL),(76488,'95631','S','Foresthill','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.009228,-120.852443,0,'2013-07-06 12:44:34',NULL,NULL),(28484,'31518','S','Bristol','D','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.418330,-82.265423,0,'2013-07-06 12:44:32',NULL,NULL),(27585,'30284','P','Sunny Side','D','Spalding','13255','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.339156,-84.291395,0,'2013-07-06 12:44:31',NULL,NULL),(17946,'18509','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.423216,-75.640635,0,'2013-07-06 12:44:31',NULL,NULL),(59691,'71072','S','Shongaloo','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.958698,-93.281039,0,'2013-07-06 12:44:33',NULL,NULL),(11081,'11690','P','Wave Crest','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.601071,-73.762108,0,'2013-07-06 12:44:30',NULL,NULL),(78053,'97451','S','Lorane','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.818474,-123.243039,0,'2013-07-06 12:44:34',NULL,NULL),(55520,'63801','S','Miner','A','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.889917,-89.578212,0,'2013-07-06 12:44:33',NULL,NULL),(2283,'00926','S','Villa Andalucia','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(44102,'49502','U','Business Reply Mail','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.961458,-85.661874,0,'2013-07-06 12:44:32',NULL,NULL),(78895,'98359','S','Olalla Valley','N','Kitsap','53035','Washington','WA','53','1150','253/564','Pacific',-8.0,'Y',47.427546,-122.575624,0,'2013-07-06 12:44:34',NULL,NULL),(41230,'46737','S','Otter Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.721900,-84.920220,0,'2013-07-06 12:44:32',NULL,NULL),(4007,'02553','P','Monument Bch','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.717679,-70.614258,0,'2013-07-06 12:44:30',NULL,NULL),(9560,'10024','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(16250,'17082','S','Spruce Hill','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(54634,'62921','P','Colp','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.804393,-89.081265,0,'2013-07-06 12:44:33',NULL,NULL),(19898,'20541','U','Library of Congress Card Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.888643,-77.007109,0,'2013-07-06 12:44:31',NULL,NULL),(17079,'17760','P','North Bend','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.352627,-77.700989,0,'2013-07-06 12:44:31',NULL,NULL),(54323,'62736','U','State Rev 3667','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803461,-89.651934,0,'2013-07-06 12:44:33',NULL,NULL),(52574,'60964','S','Sun River Ter','A','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.023177,-87.716807,0,'2013-07-06 12:44:33',NULL,NULL),(46808,'54004','S','Reeve','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.330762,-92.170455,0,'2013-07-06 12:44:32',NULL,NULL),(940,'00716','S','Bo Bucana','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(37253,'41560','S','Robinson Creek','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.328847,-82.570316,0,'2013-07-06 12:44:32',NULL,NULL),(73251,'90704','P','Santa Catalina','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.342834,-118.327634,0,'2013-07-06 12:44:34',NULL,NULL),(50716,'58369','S','Saint John','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.943535,-99.785137,0,'2013-07-06 12:44:33',NULL,NULL),(3517,'01885','P','West Boxford','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.709481,-71.058483,0,'2013-07-06 12:44:30',NULL,NULL),(8898,'08733','S','Lakehurst','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.002360,-74.320140,0,'2013-07-06 12:44:30',NULL,NULL),(76424,'95569','S','Redcrest','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.390817,-123.920383,0,'2013-07-06 12:44:34',NULL,NULL),(12349,'12883','S','Ticonderoga','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.843857,-73.431459,0,'2013-07-06 12:44:30',NULL,NULL),(72500,'89146','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.139370,-115.225442,0,'2013-07-06 12:44:34',NULL,NULL),(67529,'80251','U','National Farmers Union','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.662790,-104.853146,0,'2013-07-06 12:44:34',NULL,NULL),(7423,'06816','U','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.410366,-73.406983,0,'2013-07-06 12:44:30',NULL,NULL),(45985,'52498','U','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.021791,-91.661092,0,'2013-07-06 12:44:32',NULL,NULL),(49022,'56267','S','Morris','D','Stevens','27149','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.583270,-95.913998,0,'2013-07-06 12:44:33',NULL,NULL),(14824,'15425','S','Greene Junction','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.027320,-79.588740,0,'2013-07-06 12:44:31',NULL,NULL),(74345,'92407','S','Muscoy','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(22873,'24566','S','Keeling','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.723243,-79.260990,0,'2013-07-06 12:44:31',NULL,NULL),(58971,'70039','S','Boutte','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.885582,-90.389950,0,'2013-07-06 12:44:33',NULL,NULL),(17360,'17872','S','Marshallton','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(43480,'48606','P','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.431558,-83.936240,0,'2013-07-06 12:44:32',NULL,NULL),(10488,'10958','S','New Hampton','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.344004,-74.451815,0,'2013-07-06 12:44:30',NULL,NULL),(13308,'13671','P','Oxbow','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.284315,-75.618389,0,'2013-07-06 12:44:30',NULL,NULL),(23694,'25862','S','Lansing','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.110771,-81.030463,0,'2013-07-06 12:44:31',NULL,NULL),(62473,'74342','S','Eucha','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.372818,-94.915470,0,'2013-07-06 12:44:33',NULL,NULL),(52654,'61064','S','Stratford','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.993531,-89.587964,0,'2013-07-06 12:44:33',NULL,NULL),(40430,'45710','S','Albany','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.210840,-82.192680,0,'2013-07-06 12:44:32',NULL,NULL),(78393,'98032','S','Midway','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.392732,-122.260066,0,'2013-07-06 12:44:34',NULL,NULL),(30267,'33239','P','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.790887,-80.141386,0,'2013-07-06 12:44:32',NULL,NULL),(30186,'33177','S','Perrine','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.592736,-80.405844,0,'2013-07-06 12:44:32',NULL,NULL),(20959,'21781','P','Hagerstown','N','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.562227,-77.759294,0,'2013-07-06 12:44:31',NULL,NULL),(36669,'41011','S','Ft Wright','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.068663,-84.529476,0,'2013-07-06 12:44:32',NULL,NULL),(12512,'13027','S','Lysander','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(71888,'87736','P','Rainsville','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.979921,-105.208863,0,'2013-07-06 12:44:34',NULL,NULL),(67131,'79755','S','Midkiff','D','Upton','48461','Texas','TX','48','0000','432','Central',-6.0,'Y',31.387007,-101.958596,0,'2013-07-06 12:44:34',NULL,NULL),(26725,'29418','S','Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(26659,'29374','S','Glenn Springs','A','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.773660,-81.857040,0,'2013-07-06 12:44:31',NULL,NULL),(18259,'19004','S','Bala Cynwyd','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.013801,-75.231706,0,'2013-07-06 12:44:31',NULL,NULL),(13981,'14488','P','Livonia Center','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.818813,-77.642260,0,'2013-07-06 12:44:31',NULL,NULL),(68122,'80950','U','Us Olympic Committee','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837558,-104.795156,0,'2013-07-06 12:44:34',NULL,NULL),(52175,'60459','S','Burbank','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745512,-87.772445,0,'2013-07-06 12:44:33',NULL,NULL),(51601,'59824','S','Charlo','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.370556,-114.265000,0,'2013-07-06 12:44:33',NULL,NULL),(42248,'47575','S','Saint Anthony','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.333863,-86.821988,0,'2013-07-06 12:44:32',NULL,NULL),(42743,'48023','S','Fair Haven','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.688876,-82.669348,0,'2013-07-06 12:44:32',NULL,NULL),(475,'00667','S','Est De Lajas','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(57619,'67132','S','Rosalia','D','Butler','20015','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.781806,-96.622408,0,'2013-07-06 12:44:33',NULL,NULL),(28528,'31550','S','Manor','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.103827,-82.573330,0,'2013-07-06 12:44:32',NULL,NULL),(67489,'80232','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.690079,-105.085043,0,'2013-07-06 12:44:34',NULL,NULL),(51756,'60022','S','Glencoe','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.134264,-87.764318,0,'2013-07-06 12:44:33',NULL,NULL),(17169,'17814','S','Raven Creek','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(72796,'89704','S','Carson City','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.283073,-119.794595,0,'2013-07-06 12:44:34',NULL,NULL),(74040,'92142','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.842037,-117.096454,0,'2013-07-06 12:44:34',NULL,NULL),(28025,'30633','S','Danielsville','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.160936,-83.242089,0,'2013-07-06 12:44:31',NULL,NULL),(17462,'17948','S','Craigs','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(62607,'74530','P','Bromide','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.418606,-96.498273,0,'2013-07-06 12:44:33',NULL,NULL),(48623,'55798','S','Wright','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.674720,-92.985420,0,'2013-07-06 12:44:33',NULL,NULL),(70615,'85122','S','Eleven Mile','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.893933,-111.745030,0,'2013-07-06 12:44:34',NULL,NULL),(34947,'39056','S','Clinton','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.337754,-90.325380,0,'2013-07-06 12:44:32',NULL,NULL),(59092,'70124','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.008520,-90.106859,0,'2013-07-06 12:44:33',NULL,NULL),(10756,'11361','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.764760,-73.777510,0,'2013-07-06 12:44:30',NULL,NULL),(45824,'52208','S','Belle Plaine','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.898779,-92.274878,0,'2013-07-06 12:44:32',NULL,NULL),(46686,'53779','U','Swiss Colony','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.095268,-89.326410,0,'2013-07-06 12:44:32',NULL,NULL),(55018,'63134','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.738992,-90.342092,0,'2013-07-06 12:44:33',NULL,NULL),(54661,'62934','S','Equality','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.731422,-88.343470,0,'2013-07-06 12:44:33',NULL,NULL),(51836,'60067','S','Hoffman Estates','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.112431,-88.051211,0,'2013-07-06 12:44:33',NULL,NULL),(69254,'83424','S','Tetonia','A','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.888177,-111.176883,0,'2013-07-06 12:44:34',NULL,NULL),(72298,'88579','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766416,-106.330344,0,'2013-07-06 12:44:34',NULL,NULL),(60634,'71901','S','Oaklawn','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(55970,'64505','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.791709,-94.841238,0,'2013-07-06 12:44:33',NULL,NULL),(1364,'00736','S','Urb El Torito','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(62543,'74435','S','Paradise Hill','A','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.530194,-95.117900,0,'2013-07-06 12:44:33',NULL,NULL),(39332,'44615','S','Harlem Spgs','A','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.559162,-81.083154,0,'2013-07-06 12:44:32',NULL,NULL),(3252,'01438','P','East Templeton','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.563733,-72.040368,0,'2013-07-06 12:44:30',NULL,NULL),(7408,'06795','S','Oakville','N','Litchfield','09005','Connecticut','CT','09','8880','860/959','Eastern',-5.0,'Y',41.605821,-73.125700,0,'2013-07-06 12:44:30',NULL,NULL),(71411,'87020','S','Anaconda','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.159241,-107.836997,0,'2013-07-06 12:44:34',NULL,NULL),(4643,'03743','S','Unity','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.368783,-72.345829,0,'2013-07-06 12:44:30',NULL,NULL),(62298,'74023','S','Cushing','D','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.976349,-96.764819,0,'2013-07-06 12:44:33',NULL,NULL),(56115,'64801','S','Redings Mill','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(55692,'64063','S','Lake Lotawana','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(19301,'20001','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.906639,-77.016577,0,'2013-07-06 12:44:31',NULL,NULL),(43540,'48670','U','Midland Hospital Center','N','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.636969,-84.256060,0,'2013-07-06 12:44:32',NULL,NULL),(3209,'01360','S','No Field','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.700499,-72.450887,0,'2013-07-06 12:44:30',NULL,NULL),(40486,'45780','S','The Plains','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.368277,-82.132234,0,'2013-07-06 12:44:32',NULL,NULL),(70850,'85545','S','Roosevelt','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.619048,-111.000270,0,'2013-07-06 12:44:34',NULL,NULL),(28367,'31213','U','USPS Official Mail','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.821378,-83.647007,0,'2013-07-06 12:44:32',NULL,NULL),(2969,'01050','S','Huntington','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.272328,-72.865189,0,'2013-07-06 12:44:30',NULL,NULL),(42888,'48095','S','Washington','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.783484,-83.041714,0,'2013-07-06 12:44:32',NULL,NULL),(31223,'33965','U','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637271,-81.872508,0,'2013-07-06 12:44:32',NULL,NULL),(61316,'72437','S','Lake City','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.816616,-90.441207,0,'2013-07-06 12:44:33',NULL,NULL),(14788,'15361','P','Southview','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.329204,-80.259561,0,'2013-07-06 12:44:31',NULL,NULL),(46264,'53020','S','Elkhart Lake','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.829547,-88.018150,0,'2013-07-06 12:44:32',NULL,NULL),(42570,'47875','P','St Bernice','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.755202,-87.487061,0,'2013-07-06 12:44:32',NULL,NULL),(311,'00646','S','Urb Montereal','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(25561,'28420','S','Ash','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.056040,-78.517548,0,'2013-07-06 12:44:31',NULL,NULL),(12919,'13339','S','Mindenville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(12995,'13409','S','Valley Mills','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.950700,-75.568980,0,'2013-07-06 12:44:30',NULL,NULL),(4187,'02818','S','E Greenwich','A','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.639217,-71.502017,0,'2013-07-06 12:44:30',NULL,NULL),(26250,'28909','S','Warne','D','Clay','37043','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.000176,-83.911806,0,'2013-07-06 12:44:31',NULL,NULL),(1483,'00751','S','Bo Coco Nuevo','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(11123,'11705','S','Bay Port','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746015,-73.053348,0,'2013-07-06 12:44:30',NULL,NULL),(50143,'57534','S','Hamill','D','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.669954,-99.699051,0,'2013-07-06 12:44:33',NULL,NULL),(25952,'28657','S','Newland','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(78416,'98043','S','Mountlake Ter','A','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791785,-122.304134,0,'2013-07-06 12:44:34',NULL,NULL),(7289,'06535','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.314321,-72.929008,0,'2013-07-06 12:44:30',NULL,NULL),(71120,'86018','P','Flagstaff','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.260485,-111.947488,0,'2013-07-06 12:44:34',NULL,NULL),(61644,'72852','S','Oark','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.714433,-93.575230,0,'2013-07-06 12:44:33',NULL,NULL),(44696,'50132','S','Kamrar','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.390238,-93.730273,0,'2013-07-06 12:44:32',NULL,NULL),(49253,'56474','S','Wilson','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(47314,'54555','S','Worcester','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(72646,'89427','P','Sheelite','N','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.948754,-118.818822,0,'2013-07-06 12:44:34',NULL,NULL),(62288,'74019','S','Clairemore','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.318395,-95.619824,0,'2013-07-06 12:44:33',NULL,NULL),(39487,'44735','P','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.847950,-81.441359,0,'2013-07-06 12:44:32',NULL,NULL),(38245,'43268','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.964398,-82.994319,0,'2013-07-06 12:44:32',NULL,NULL),(74264,'92342','S','Silver Lakes','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.688400,-117.290220,0,'2013-07-06 12:44:34',NULL,NULL),(20593,'21202','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295835,-76.609089,0,'2013-07-06 12:44:31',NULL,NULL),(15948,'17024','S','Erly','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(28918,'32149','P','Edgar','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.619345,-81.897928,0,'2013-07-06 12:44:32',NULL,NULL),(31892,'35136','S','Rockford','D','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.863614,-86.271333,0,'2013-07-06 12:44:32',NULL,NULL),(19283,'19969','P','Nassau','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.754434,-75.187853,0,'2013-07-06 12:44:31',NULL,NULL),(18364,'19039','P','Gradyville','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936739,-75.463630,0,'2013-07-06 12:44:31',NULL,NULL),(25584,'28441','S','Garland','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.822280,-78.329017,0,'2013-07-06 12:44:31',NULL,NULL),(663,'00683','S','Paseos Del Valle','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(17586,'18020','S','Bethlehem','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.626883,-75.369570,0,'2013-07-06 12:44:31',NULL,NULL),(1021,'00718','S','Urb Casabella','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(30171,'33174','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.762543,-80.353593,0,'2013-07-06 12:44:32',NULL,NULL),(45388,'51028','S','Kingsley','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.631894,-96.061191,0,'2013-07-06 12:44:32',NULL,NULL),(20943,'21766','S','Ltl Orleans','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.660121,-78.402968,0,'2013-07-06 12:44:31',NULL,NULL),(34218,'38359','S','Milledgeville','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.342148,-88.406142,0,'2013-07-06 12:44:32',NULL,NULL),(34940,'39046','S','Farmhaven','N','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.639280,-90.007500,0,'2013-07-06 12:44:32',NULL,NULL),(35685,'39661','S','Kirby','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(19589,'20221','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894103,-77.028884,0,'2013-07-06 12:44:31',NULL,NULL),(73128,'90270','S','Bell Gardens','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.977500,-118.186111,0,'2013-07-06 12:44:34',NULL,NULL),(65253,'77464','P','Orchard','D','Fort Bend','48157','Texas','TX','48','3360','979','Central',-6.0,'Y',29.602928,-95.965400,0,'2013-07-06 12:44:34',NULL,NULL),(17550,'17980','S','Porter','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.591905,-76.538022,0,'2013-07-06 12:44:31',NULL,NULL),(53443,'61876','S','Sidell','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.908281,-87.824884,0,'2013-07-06 12:44:33',NULL,NULL),(46331,'53083','S','Howards Grove Br #4','N','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.802340,-87.769800,0,'2013-07-06 12:44:32',NULL,NULL),(23966,'26294','S','Valley Head','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.498611,-80.054444,0,'2013-07-06 12:44:31',NULL,NULL),(36937,'41164','S','Ibex','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(8737,'08515','S','Crosswicks','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.153936,-74.650330,0,'2013-07-06 12:44:30',NULL,NULL),(38642,'43933','S','Jacobsburg','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.945410,-80.902208,0,'2013-07-06 12:44:32',NULL,NULL),(10847,'11411','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694491,-73.737461,0,'2013-07-06 12:44:30',NULL,NULL),(35267,'39360','S','Shubuta','D','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.878000,-88.708080,0,'2013-07-06 12:44:32',NULL,NULL),(4768,'03858','S','Newton','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.871206,-71.045821,0,'2013-07-06 12:44:30',NULL,NULL),(19634,'20260','S','USPS Headquarters','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880340,-77.015833,0,'2013-07-06 12:44:31',NULL,NULL),(41973,'47421','S','Buddha','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(41632,'47130','S','Watson','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(14428,'15076','S','Russellton','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.608758,-79.836455,0,'2013-07-06 12:44:31',NULL,NULL),(20948,'21773','S','Myersville','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.530125,-77.553669,0,'2013-07-06 12:44:31',NULL,NULL),(12200,'12784','P','Thompsonville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.671144,-74.626556,0,'2013-07-06 12:44:30',NULL,NULL),(36007,'40152','S','Mc Daniels','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.626288,-86.447899,0,'2013-07-06 12:44:32',NULL,NULL),(78438,'98056','S','Newcastle','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.512620,-122.193420,0,'2013-07-06 12:44:34',NULL,NULL),(38163,'43152','S','Laurelville','A','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.407940,-82.611540,0,'2013-07-06 12:44:32',NULL,NULL),(58495,'68763','S','O\' Neill','A','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.456401,-98.648879,0,'2013-07-06 12:44:33',NULL,NULL),(43078,'48198','S','Willow Run','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.248536,-83.586753,0,'2013-07-06 12:44:32',NULL,NULL),(27898,'30474','S','Center','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(36181,'40251','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.250649,-85.799994,0,'2013-07-06 12:44:32',NULL,NULL),(37732,'42286','S','Trenton','D','Todd','21219','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.728871,-87.255257,0,'2013-07-06 12:44:32',NULL,NULL),(28758,'32006','P','Fleming Island','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.157247,-81.704123,0,'2013-07-06 12:44:32',NULL,NULL),(67748,'80612','S','Carr','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.850290,-104.860040,0,'2013-07-06 12:44:34',NULL,NULL),(25895,'28643','S','Husk','A','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(22505,'24077','S','Cloverdale','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.366347,-79.903795,0,'2013-07-06 12:44:31',NULL,NULL),(32293,'35699','U','Decatur','D','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.607691,-87.021300,0,'2013-07-06 12:44:32',NULL,NULL),(30992,'33765','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.974032,-82.745337,0,'2013-07-06 12:44:32',NULL,NULL),(2167,'00926','S','BO Dulce','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(25571,'28429','S','Castle Hayne','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.325657,-77.908843,0,'2013-07-06 12:44:31',NULL,NULL),(50501,'58063','S','Oriska','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.948433,-97.776839,0,'2013-07-06 12:44:33',NULL,NULL),(37217,'41528','S','Johnson Bottom','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.543483,-82.135640,0,'2013-07-06 12:44:32',NULL,NULL),(5397,'04654','S','Marshfield','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.720530,-67.467043,0,'2013-07-06 12:44:30',NULL,NULL),(1892,'00791','S','Vista Alegre','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(51078,'58760','S','Maxbass','D','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.799553,-101.327522,0,'2013-07-06 12:44:33',NULL,NULL),(12144,'12732','S','Eldred','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.526668,-74.889314,0,'2013-07-06 12:44:30',NULL,NULL),(66938,'79358','S','Ropesville','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.414944,-102.151007,0,'2013-07-06 12:44:34',NULL,NULL),(51627,'59848','S','Hot Springs','A','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.672451,-114.665611,0,'2013-07-06 12:44:33',NULL,NULL),(15049,'15714','S','N Cambria','A','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.663026,-78.778938,0,'2013-07-06 12:44:31',NULL,NULL),(20747,'21402','S','Naval Academy','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.987681,-76.487016,0,'2013-07-06 12:44:31',NULL,NULL),(4037,'02575','P','Tisbury','N','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.402414,-70.630193,0,'2013-07-06 12:44:30',NULL,NULL),(65330,'77516','P','Angleton','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168838,-95.431359,0,'2013-07-06 12:44:34',NULL,NULL),(44442,'49861','S','Michigamme','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.531489,-88.086335,0,'2013-07-06 12:44:32',NULL,NULL),(53022,'61468','S','Ophiem','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.252242,-90.382634,0,'2013-07-06 12:44:33',NULL,NULL),(70810,'85374','S','Surprise','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.629937,-112.350250,0,'2013-07-06 12:44:34',NULL,NULL),(43583,'48747','S','Munger','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.524928,-83.756592,0,'2013-07-06 12:44:32',NULL,NULL),(39290,'44490','S','Washingtonville','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.899998,-80.761464,0,'2013-07-06 12:44:32',NULL,NULL),(60901,'72073','S','Humphrey','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.380437,-91.660081,0,'2013-07-06 12:44:33',NULL,NULL),(63813,'75968','S','Pineland','D','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.247979,-93.978384,0,'2013-07-06 12:44:34',NULL,NULL),(21981,'23250','S','Richmond','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(69656,'84013','S','Cedar Valley','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.247580,-112.062060,0,'2013-07-06 12:44:34',NULL,NULL),(10544,'10996','S','West Point Military Reservat','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.388670,-73.982179,0,'2013-07-06 12:44:30',NULL,NULL),(60652,'71910','P','Hot Springs Village','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.668247,-93.001118,0,'2013-07-06 12:44:33',NULL,NULL),(58461,'68729','S','Creighton','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.462700,-97.906128,0,'2013-07-06 12:44:33',NULL,NULL),(56653,'65616','S','Marvel Cave Park','A','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(45939,'52339','S','Haven','N','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.966336,-92.573220,0,'2013-07-06 12:44:32',NULL,NULL),(49856,'57245','P','Kranzburg','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.878739,-96.943631,0,'2013-07-06 12:44:33',NULL,NULL),(16419,'17225','S','Upton','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(65073,'77348','U','Tx State Prison','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722858,-95.553325,0,'2013-07-06 12:44:34',NULL,NULL),(62886,'75054','S','Grand Prairie','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.747058,-96.996460,0,'2013-07-06 12:44:33',NULL,NULL),(24458,'27228','P','Pittsboro','A','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772618,-79.137819,0,'2013-07-06 12:44:31',NULL,NULL),(52152,'60445','S','Crestwood','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.635673,-87.738641,0,'2013-07-06 12:44:33',NULL,NULL),(22108,'23423','P','Quinby','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.579482,-75.793864,0,'2013-07-06 12:44:31',NULL,NULL),(12966,'13365','S','Salisbury','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.086420,-74.904000,0,'2013-07-06 12:44:30',NULL,NULL),(12904,'13337','S','Oaksville','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.734651,-74.991943,0,'2013-07-06 12:44:30',NULL,NULL),(4087,'02664','S','South Yarmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.668281,-70.193806,0,'2013-07-06 12:44:30',NULL,NULL),(8991,'08837','S','Edison','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.505704,-74.354187,0,'2013-07-06 12:44:30',NULL,NULL),(70673,'85226','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.306009,-111.919281,0,'2013-07-06 12:44:34',NULL,NULL),(65750,'78063','S','Lake Hills','N','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.656800,-98.907540,0,'2013-07-06 12:44:34',NULL,NULL),(20120,'20716','S','S Bowie','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.925300,-76.715460,0,'2013-07-06 12:44:31',NULL,NULL),(25211,'28081','S','Centerview','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.485398,-80.626317,0,'2013-07-06 12:44:31',NULL,NULL),(3729,'02153','P','Tufts Univ','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.419023,-71.109862,0,'2013-07-06 12:44:30',NULL,NULL),(33934,'38066','S','Rossville','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.072957,-89.536230,0,'2013-07-06 12:44:32',NULL,NULL),(62677,'74701','S','Durant','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.003629,-96.383237,0,'2013-07-06 12:44:33',NULL,NULL),(58236,'68352','S','Gladstone','A','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.156080,-97.171800,0,'2013-07-06 12:44:33',NULL,NULL),(49098,'56336','S','Grey Eagle','D','Todd','27153','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.820975,-94.747578,0,'2013-07-06 12:44:33',NULL,NULL),(16778,'17527','S','White Horse','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.010580,-75.992040,0,'2013-07-06 12:44:31',NULL,NULL),(21022,'21856','S','Quantico','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.333919,-75.806911,0,'2013-07-06 12:44:31',NULL,NULL),(63942,'76077','S','Rainbow','D','Somervell','48425','Texas','TX','48','0000','254','Central',-6.0,'Y',32.288273,-97.698503,0,'2013-07-06 12:44:34',NULL,NULL),(70073,'84150','U','Church of Jesus Christ/LDS','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.772019,-111.889801,0,'2013-07-06 12:44:34',NULL,NULL),(35241,'39330','S','Enterprise','D','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.082172,-88.745621,0,'2013-07-06 12:44:32',NULL,NULL),(65212,'77437','S','Sandy Corner','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(29421,'32663','P','Lowell','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.332676,-82.198554,0,'2013-07-06 12:44:32',NULL,NULL),(27629,'30312','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.743314,-84.378489,0,'2013-07-06 12:44:31',NULL,NULL),(33689,'37748','S','Midtown','N','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.942220,-84.500460,0,'2013-07-06 12:44:32',NULL,NULL),(10473,'10941','S','Scotchtown Branch','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.463349,-74.421398,0,'2013-07-06 12:44:30',NULL,NULL),(41245,'46742','S','Forest Park Beach','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(7922,'07642','S','Hillsdale','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.008576,-74.041923,0,'2013-07-06 12:44:30',NULL,NULL),(74641,'92817','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.851223,-117.791464,0,'2013-07-06 12:44:34',NULL,NULL),(1048,'00723','S','Urb San Martin','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(47675,'54948','S','Leopolis','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.778897,-88.888412,0,'2013-07-06 12:44:33',NULL,NULL),(79446,'98844','S','Chesaw','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.946111,-119.050278,0,'2013-07-06 12:44:34',NULL,NULL),(16835,'17555','S','Narvon','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.133056,-75.965000,0,'2013-07-06 12:44:31',NULL,NULL),(79509,'98922','S','Teanaway','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.163120,-120.849600,0,'2013-07-06 12:44:34',NULL,NULL),(10967,'11518','S','East Rockaway','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.641066,-73.666046,0,'2013-07-06 12:44:30',NULL,NULL),(63462,'75684','S','Sexton City','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(47128,'54454','S','Milladore','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.602472,-89.883051,0,'2013-07-06 12:44:32',NULL,NULL),(33210,'37049','S','Cross Plains','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.556184,-86.681910,0,'2013-07-06 12:44:32',NULL,NULL),(76678,'95799','P','West Sacramento','D','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.540783,-121.557001,0,'2013-07-06 12:44:34',NULL,NULL),(4995,'04216','S','Andover','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.744379,-70.904409,0,'2013-07-06 12:44:30',NULL,NULL),(18959,'19512','S','Greshville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(17818,'18411','S','S Abington TWP','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(54045,'62467','S','St Francis','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.131471,-88.475901,0,'2013-07-06 12:44:33',NULL,NULL),(57403,'66762','S','Capaldo','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.412275,-94.698359,0,'2013-07-06 12:44:33',NULL,NULL),(24998,'27869','S','Rich Square','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.270766,-77.286338,0,'2013-07-06 12:44:31',NULL,NULL),(39110,'44250','P','Lakemore','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.020998,-81.434099,0,'2013-07-06 12:44:32',NULL,NULL),(69210,'83353','P','Sun Valley','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.727645,-114.264930,0,'2013-07-06 12:44:34',NULL,NULL),(76665,'95757','S','Elk Grove','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.408142,-121.429400,0,'2013-07-06 12:44:34',NULL,NULL),(22020,'23289','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542258,-77.434021,0,'2013-07-06 12:44:31',NULL,NULL),(61223,'72324','S','Cherry Valley','D','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.394814,-90.796630,0,'2013-07-06 12:44:33',NULL,NULL),(19448,'20116','P','Marshall','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.868361,-77.852454,0,'2013-07-06 12:44:31',NULL,NULL),(2112,'00923','S','Villa Dos Pinos','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(14291,'14872','S','Pine Valley','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.227341,-76.852554,0,'2013-07-06 12:44:31',NULL,NULL),(28073,'30721','S','Dalton','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.784599,-84.932948,0,'2013-07-06 12:44:31',NULL,NULL),(27416,'30098','U','State Farm Insurance Co','N','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.025560,-84.145413,0,'2013-07-06 12:44:31',NULL,NULL),(55264,'63461','S','Palmyra','D','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.797789,-91.526300,0,'2013-07-06 12:44:33',NULL,NULL),(64436,'76564','P','Pendleton','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.156371,-97.255613,0,'2013-07-06 12:44:34',NULL,NULL),(34444,'38651','S','Nesbit','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.887540,-89.993100,0,'2013-07-06 12:44:32',NULL,NULL),(35543,'39563','S','Kreole','A','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(48814,'56027','S','Elmore','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.503204,-94.082426,0,'2013-07-06 12:44:33',NULL,NULL),(16257,'17085','P','Rexmont','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.275485,-76.383567,0,'2013-07-06 12:44:31',NULL,NULL),(11525,'12037','S','Chatham','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.359632,-73.589364,0,'2013-07-06 12:44:30',NULL,NULL),(30877,'33681','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.893868,-82.525675,0,'2013-07-06 12:44:32',NULL,NULL),(79560,'99012','S','Fairfield','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.388242,-117.206454,0,'2013-07-06 12:44:34',NULL,NULL),(55626,'63965','S','Van Buren','D','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.999120,-90.987120,0,'2013-07-06 12:44:33',NULL,NULL),(74235,'92324','S','Colton','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.032420,-117.282300,0,'2013-07-06 12:44:34',NULL,NULL),(79911,'99603','S','Fritz Creek','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL),(52012,'60173','S','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.042778,-88.079722,0,'2013-07-06 12:44:33',NULL,NULL),(23110,'24944','S','Green Bank','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.392363,-79.785780,0,'2013-07-06 12:44:31',NULL,NULL),(12567,'13057','S','East Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.075530,-76.051820,0,'2013-07-06 12:44:30',NULL,NULL),(10998,'11551','P','Hempstead','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.703341,-73.628577,0,'2013-07-06 12:44:30',NULL,NULL),(58782,'68975','S','Saronville','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.570578,-97.938162,0,'2013-07-06 12:44:33',NULL,NULL),(5007,'04223','P','Danville','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.030305,-70.274326,0,'2013-07-06 12:44:30',NULL,NULL),(52426,'60653','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.820185,-87.612036,0,'2013-07-06 12:44:33',NULL,NULL),(38249,'43271','U','Bank One','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.970935,-83.026273,0,'2013-07-06 12:44:32',NULL,NULL),(78453,'98065','S','Snoqualmie','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.527102,-121.823613,0,'2013-07-06 12:44:34',NULL,NULL),(78780,'98312','S','Erlands Point','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(61214,'72315','S','Gosnell','A','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.943180,-89.899320,0,'2013-07-06 12:44:33',NULL,NULL),(46737,'53911','S','Arlington','D','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.282786,-89.389648,0,'2013-07-06 12:44:32',NULL,NULL),(39792,'45133','S','Hillsboro','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(12371,'12912','S','Au Sable Frks','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.459424,-73.713927,0,'2013-07-06 12:44:30',NULL,NULL),(1809,'00784','S','Bo Olimpo','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(72580,'89404','P','Quinn River Crossing','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(34137,'38226','S','Dukedom','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.472923,-88.667300,0,'2013-07-06 12:44:32',NULL,NULL),(22875,'24570','S','Lowry','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.344787,-79.451814,0,'2013-07-06 12:44:31',NULL,NULL),(1224,'00728','S','Urb San Antonio','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(19723,'20394','U','Naval Telecommunications Com','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.941666,-77.087409,0,'2013-07-06 12:44:31',NULL,NULL),(3020,'01088','S','W Hatfield','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.386547,-72.639767,0,'2013-07-06 12:44:30',NULL,NULL),(6126,'05459','S','Highgate Ctr','A','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(5217,'04460','S','Medway','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.617950,-68.497973,0,'2013-07-06 12:44:30',NULL,NULL),(26565,'29210','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.040812,-81.095436,0,'2013-07-06 12:44:31',NULL,NULL),(5570,'04863','S','Vinalhaven','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.046856,-68.816456,0,'2013-07-06 12:44:30',NULL,NULL),(70090,'84165','P','S Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(42071,'47452','S','Pumpkin Ctr','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(16590,'17324','S','Hunters Run','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(3693,'02135','S','Brighton','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.350820,-71.118420,0,'2013-07-06 12:44:30',NULL,NULL),(13145,'13599','U','BRM Customer','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.097704,-75.229256,0,'2013-07-06 12:44:30',NULL,NULL),(22870,'24562','S','Scottsville','A','Buckingham','51029','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.767311,-78.589328,0,'2013-07-06 12:44:31',NULL,NULL),(71258,'86409','S','Hualapai','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.244500,-114.016400,0,'2013-07-06 12:44:34',NULL,NULL),(58477,'68746','S','Monowi','A','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.859206,-98.439970,0,'2013-07-06 12:44:33',NULL,NULL),(12624,'13090','S','Dominion Park','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(5030,'04254','S','Livermore Falls','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.472043,-70.184517,0,'2013-07-06 12:44:30',NULL,NULL),(71233,'86334','S','Paulden','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.885556,-112.467500,0,'2013-07-06 12:44:34',NULL,NULL),(65382,'77547','S','Galena Park','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.739015,-95.234217,0,'2013-07-06 12:44:34',NULL,NULL),(75863,'94942','P','Mill Valley','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.904574,-122.522903,0,'2013-07-06 12:44:34',NULL,NULL),(18978,'19520','S','Elverson','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(48281,'55432','S','Spring Lk Pk','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.098640,-93.254963,0,'2013-07-06 12:44:33',NULL,NULL),(14480,'15131','S','McKeesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.330620,-79.806180,0,'2013-07-06 12:44:31',NULL,NULL),(21819,'23108','S','Mascot','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.587586,-76.723826,0,'2013-07-06 12:44:31',NULL,NULL),(16024,'17042','S','LEB','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(78626,'98205','S','Everett','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.990546,-122.114079,0,'2013-07-06 12:44:34',NULL,NULL),(6148,'05465','S','West Bolton','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.476140,-72.949800,0,'2013-07-06 12:44:30',NULL,NULL),(52972,'61428','S','Appleton','N','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.963678,-90.139944,0,'2013-07-06 12:44:33',NULL,NULL),(49930,'57325','S','Chamberlain','D','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.806473,-99.327811,0,'2013-07-06 12:44:33',NULL,NULL),(79361,'98645','S','Silverlake','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.309905,-122.766403,0,'2013-07-06 12:44:34',NULL,NULL),(18705,'19195','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952500,-75.164500,0,'2013-07-06 12:44:31',NULL,NULL),(9134,'09213','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(78499,'98109','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.628934,-122.343181,0,'2013-07-06 12:44:34',NULL,NULL),(76727,'95894','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.556683,-121.498069,0,'2013-07-06 12:44:34',NULL,NULL),(71361,'86544','P','Red Valley','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750097,-109.365708,0,'2013-07-06 12:44:34',NULL,NULL),(9809,'10111','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(64655,'76801','S','Grosvenor','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(3855,'02349','U','Middleborough','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.870977,-70.908380,0,'2013-07-06 12:44:30',NULL,NULL),(48046,'55311','S','Osseo','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.118800,-93.486660,0,'2013-07-06 12:44:33',NULL,NULL),(65484,'77643','P','Port Arthur','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.900750,-93.931943,0,'2013-07-06 12:44:34',NULL,NULL),(26426,'29126','S','Pomaria','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.323669,-81.444178,0,'2013-07-06 12:44:31',NULL,NULL),(52207,'60479','S','Verona','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.227482,-88.522792,0,'2013-07-06 12:44:33',NULL,NULL),(6518,'05824','S','Concord Corner','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.435400,-71.854320,0,'2013-07-06 12:44:30',NULL,NULL),(77038,'96106','P','Clio','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.730768,-120.552796,0,'2013-07-06 12:44:34',NULL,NULL),(15270,'16105','S','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.031190,-80.343765,0,'2013-07-06 12:44:31',NULL,NULL),(61465,'72630','P','Diamond City','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.464444,-92.920000,0,'2013-07-06 12:44:33',NULL,NULL),(13374,'13736','S','Speedsville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.313800,-76.190640,0,'2013-07-06 12:44:31',NULL,NULL),(16635,'17335','U','Hanover','D','York','42133','Pennsylvania','PA','42','8840','202','Eastern',-5.0,'Y',39.807895,-76.965786,0,'2013-07-06 12:44:31',NULL,NULL),(19988,'20598','U','Springfield','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(48929,'56152','S','Lamberton','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.228272,-95.266139,0,'2013-07-06 12:44:33',NULL,NULL),(16322,'17122','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263288,-76.881597,0,'2013-07-06 12:44:31',NULL,NULL),(57532,'67013','S','Belle Plaine','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.395834,-97.277595,0,'2013-07-06 12:44:33',NULL,NULL),(199,'00623','S','Urb Monte Grande','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(4686,'03804','P','Portsmouth','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.075938,-70.759040,0,'2013-07-06 12:44:30',NULL,NULL),(57985,'67843','S','Fort Dodge','D','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.665605,-99.944540,0,'2013-07-06 12:44:33',NULL,NULL),(52145,'60440','S','Bolingbrook','D','Will','17197','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.704671,-88.075236,0,'2013-07-06 12:44:33',NULL,NULL),(31332,'34135','S','Bonita Springs','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.387185,-81.735987,0,'2013-07-06 12:44:32',NULL,NULL),(46785,'53959','S','Reedsburg','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.536320,-90.000631,0,'2013-07-06 12:44:32',NULL,NULL),(44234,'49655','S','Leroy','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.049480,-85.443900,0,'2013-07-06 12:44:32',NULL,NULL),(34980,'39095','S','Lexington','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.111605,-90.051110,0,'2013-07-06 12:44:32',NULL,NULL),(32617,'36140','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382875,-86.146711,0,'2013-07-06 12:44:32',NULL,NULL),(70046,'84136','U','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767474,-111.887633,0,'2013-07-06 12:44:34',NULL,NULL),(71254,'86405','P','Lake Havasu City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.499836,-114.314100,0,'2013-07-06 12:44:34',NULL,NULL),(391,'00662','S','Comunidad El Ramal','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(77064,'96120','S','Woodfords','N','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(73814,'91762','S','Ontario','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.058501,-117.667472,0,'2013-07-06 12:44:34',NULL,NULL),(22208,'23514','P','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.851923,-76.292261,0,'2013-07-06 12:44:31',NULL,NULL),(64303,'76461','P','Lingleville','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.244567,-98.375276,0,'2013-07-06 12:44:34',NULL,NULL),(54536,'62882','S','Sandoval','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.612584,-89.121037,0,'2013-07-06 12:44:33',NULL,NULL),(9780,'10106','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(33974,'38111','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.112624,-89.946832,0,'2013-07-06 12:44:32',NULL,NULL),(33826,'37927','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.999238,-83.910770,0,'2013-07-06 12:44:32',NULL,NULL),(41307,'46770','S','Markle','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.831539,-85.326409,0,'2013-07-06 12:44:32',NULL,NULL),(9030,'08875','P','E Millstone','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.486000,-74.465000,0,'2013-07-06 12:44:30',NULL,NULL),(36635,'41004','S','Petra','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(28933,'32170','P','New Smyrna','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.034832,-80.918544,0,'2013-07-06 12:44:32',NULL,NULL),(32999,'36640','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.681274,-88.067832,0,'2013-07-06 12:44:32',NULL,NULL),(10727,'11351','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.781091,-73.830914,0,'2013-07-06 12:44:30',NULL,NULL),(742,'00692','S','Alts de Cerro Gordo 1&2','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(60591,'71833','S','Dierks','D','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.993503,-93.841005,0,'2013-07-06 12:44:33',NULL,NULL),(30744,'33545','S','Zephyrhills','A','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.229620,-82.282896,0,'2013-07-06 12:44:32',NULL,NULL),(49529,'56678','S','Becida','A','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.555400,-95.132820,0,'2013-07-06 12:44:33',NULL,NULL),(32510,'36079','S','Troy','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.712313,-85.974013,0,'2013-07-06 12:44:32',NULL,NULL),(39755,'45107','S','Blanchester','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.306863,-83.965200,0,'2013-07-06 12:44:32',NULL,NULL),(16705,'17402','S','Yorklyn','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(16546,'17306','P','Bendersville','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.981919,-77.252284,0,'2013-07-06 12:44:31',NULL,NULL),(68355,'81133','S','Fort Garland','D','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.413562,-105.393706,0,'2013-07-06 12:44:34',NULL,NULL),(67877,'80840','S','United States Air Force Acad','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.999759,-104.695596,0,'2013-07-06 12:44:34',NULL,NULL),(9135,'09214','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18475,'19086','S','Wallingford','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889823,-75.370994,0,'2013-07-06 12:44:31',NULL,NULL),(25491,'28362','P','Marietta','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.367126,-79.119140,0,'2013-07-06 12:44:31',NULL,NULL),(31493,'34442','S','Citrus Hills','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.930770,-82.373430,0,'2013-07-06 12:44:32',NULL,NULL),(2348,'00940','P','Minillas','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410886,-66.065084,0,'2013-07-06 12:44:30',NULL,NULL),(74010,'92117','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.824555,-117.200178,0,'2013-07-06 12:44:34',NULL,NULL),(33126,'36874','S','Salem','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.537244,-85.220329,0,'2013-07-06 12:44:32',NULL,NULL),(47588,'54857','P','Mikana','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.590843,-91.599726,0,'2013-07-06 12:44:33',NULL,NULL),(10956,'11501','S','Mineola','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.745251,-73.641110,0,'2013-07-06 12:44:30',NULL,NULL),(50977,'58639','S','Bucyrus','A','Adams','38001','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.035840,-102.570120,0,'2013-07-06 12:44:33',NULL,NULL),(589,'00680','S','Mayaguez','D','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(55521,'63801','S','Sikeston','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.889917,-89.578212,0,'2013-07-06 12:44:33',NULL,NULL),(47541,'54819','S','Bruce','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.458529,-91.274154,0,'2013-07-06 12:44:32',NULL,NULL),(38514,'43721','P','Brownsville','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.939964,-82.252329,0,'2013-07-06 12:44:32',NULL,NULL),(74489,'92617','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648520,-117.821360,0,'2013-07-06 12:44:34',NULL,NULL),(24654,'27405','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(42474,'47834','S','Prairie City','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(45082,'50530','S','Dayton','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.268384,-94.062724,0,'2013-07-06 12:44:32',NULL,NULL),(46029,'52553','S','Eddyville','D','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.155807,-92.635110,0,'2013-07-06 12:44:32',NULL,NULL),(7447,'06853','S','Rowayton','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.069465,-73.442358,0,'2013-07-06 12:44:30',NULL,NULL),(2816,'00977','P','Trujillo Alto','D','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362817,-66.017273,0,'2013-07-06 12:44:30',NULL,NULL),(6613,'05873','S','Walden','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.445900,-72.224520,0,'2013-07-06 12:44:30',NULL,NULL),(68058,'80933','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.934825,-105.004782,0,'2013-07-06 12:44:34',NULL,NULL),(7938,'07657','S','Ridgefield','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.832120,-73.999158,0,'2013-07-06 12:44:30',NULL,NULL),(4978,'04109','S','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(4306,'02908','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.847393,-71.449537,0,'2013-07-06 12:44:30',NULL,NULL),(16839,'17557','S','Laurelville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101003,-76.079601,0,'2013-07-06 12:44:31',NULL,NULL),(1043,'00723','S','Portales de Jacaboa','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(7670,'07093','S','Monitor','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.788201,-74.013854,0,'2013-07-06 12:44:30',NULL,NULL),(83,'00612','S','Parc Perez','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(32883,'36529','S','Hawthorne','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.321111,-88.188611,0,'2013-07-06 12:44:32',NULL,NULL),(33092,'36831','P','Auburn','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.606785,-85.480344,0,'2013-07-06 12:44:32',NULL,NULL),(12460,'12974','S','Port Henry','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.045341,-73.465362,0,'2013-07-06 12:44:30',NULL,NULL),(67080,'79604','P','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.453184,-99.732364,0,'2013-07-06 12:44:34',NULL,NULL),(45394,'51033','S','Linn Grove','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.886847,-95.246989,0,'2013-07-06 12:44:32',NULL,NULL),(12387,'12921','S','Chazy','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.889987,-73.466593,0,'2013-07-06 12:44:30',NULL,NULL),(38132,'43123','S','Grove City','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.881816,-83.091047,0,'2013-07-06 12:44:32',NULL,NULL),(12271,'12835','S','Day','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.336182,-73.985758,0,'2013-07-06 12:44:30',NULL,NULL),(33313,'37134','S','New Johnsonville','D','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.010324,-87.967812,0,'2013-07-06 12:44:32',NULL,NULL),(40250,'45430','S','Beaver Creek','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(9545,'10022','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(45458,'51242','P','Lester','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.437959,-96.331648,0,'2013-07-06 12:44:32',NULL,NULL),(41841,'47348','S','Licking','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(37761,'42333','S','Cromwell','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.336050,-86.770330,0,'2013-07-06 12:44:32',NULL,NULL),(75195,'93619','S','Clovis','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.843192,-119.651814,0,'2013-07-06 12:44:34',NULL,NULL),(24422,'27152','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.104411,-80.206453,0,'2013-07-06 12:44:31',NULL,NULL),(73008,'90065','S','Glassell','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105980,-118.229781,0,'2013-07-06 12:44:34',NULL,NULL),(6355,'05674','S','Warren','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.129916,-72.879337,0,'2013-07-06 12:44:30',NULL,NULL),(51220,'59053','S','Martinsdale','D','Meagher','30059','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.416111,-110.542500,0,'2013-07-06 12:44:33',NULL,NULL),(6524,'05827','S','Craftsbry Cmn','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.650000,-72.383333,0,'2013-07-06 12:44:30',NULL,NULL),(16576,'17319','S','Yocumtown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.152317,-76.794239,0,'2013-07-06 12:44:31',NULL,NULL),(23759,'25962','S','Corliss','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(44357,'49782','S','Saint James','N','Charlevoix','26029','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.666667,-85.550000,0,'2013-07-06 12:44:32',NULL,NULL),(24243,'26761','S','Shanks','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.266259,-78.703294,0,'2013-07-06 12:44:31',NULL,NULL),(26189,'28763','S','Otto','D','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.046523,-83.396898,0,'2013-07-06 12:44:31',NULL,NULL),(38221,'43221','S','Upper Arlington','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.014525,-83.068936,0,'2013-07-06 12:44:32',NULL,NULL),(52918,'61368','S','Lone Tree','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.293034,-89.507464,0,'2013-07-06 12:44:33',NULL,NULL),(17941,'18507','S','Scranton','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.370930,-75.703801,0,'2013-07-06 12:44:31',NULL,NULL),(3777,'02196','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.351300,-71.060861,0,'2013-07-06 12:44:30',NULL,NULL),(12790,'13219','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.040139,-76.217020,0,'2013-07-06 12:44:30',NULL,NULL),(34199,'38339','S','Guys','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.016979,-88.528146,0,'2013-07-06 12:44:32',NULL,NULL),(70383,'84662','P','Spring City','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.483558,-111.494443,0,'2013-07-06 12:44:34',NULL,NULL),(25830,'28617','S','Nathans Creek','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.460860,-81.413640,0,'2013-07-06 12:44:31',NULL,NULL),(66321,'78596','S','Ramona','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160167,-97.986360,0,'2013-07-06 12:44:34',NULL,NULL),(79630,'99128','S','Farmington','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.089433,-117.043535,0,'2013-07-06 12:44:34',NULL,NULL),(48462,'55716','P','Calumet','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.313938,-93.280715,0,'2013-07-06 12:44:33',NULL,NULL),(50614,'58260','S','Union','A','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629355,-97.990765,0,'2013-07-06 12:44:33',NULL,NULL),(43870,'49128','S','Three Oaks','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.822485,-86.616550,0,'2013-07-06 12:44:32',NULL,NULL),(42886,'48094','S','Washington Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.734460,-82.998120,0,'2013-07-06 12:44:32',NULL,NULL),(13646,'14005','S','Alexander','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.918368,-78.252988,0,'2013-07-06 12:44:31',NULL,NULL),(66715,'78949','S','Stellar','N','Fayette','48149','Texas','TX','48','0000','512/737','Central',-6.0,'Y',29.798228,-97.092113,0,'2013-07-06 12:44:34',NULL,NULL),(21566,'22821','S','Dayton','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.417387,-78.954792,0,'2013-07-06 12:44:31',NULL,NULL),(14355,'15017','S','Bridgeville','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.355855,-80.113491,0,'2013-07-06 12:44:31',NULL,NULL),(56064,'64746','S','Freeman','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.610172,-94.477945,0,'2013-07-06 12:44:33',NULL,NULL),(55375,'63601','S','Leadwood','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(4546,'03447','S','Fitzwilliam','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.752214,-72.147748,0,'2013-07-06 12:44:30',NULL,NULL),(38961,'44128','S','Bedford Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(70007,'84124','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.685813,-111.829118,0,'2013-07-06 12:44:34',NULL,NULL),(78473,'98087','S','Lynnwood','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.872630,-122.270929,0,'2013-07-06 12:44:34',NULL,NULL),(57750,'67442','S','Falun','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.656835,-97.730557,0,'2013-07-06 12:44:33',NULL,NULL),(34180,'38315','S','Bethel Springs','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.225473,-88.661743,0,'2013-07-06 12:44:32',NULL,NULL),(63477,'75686','S','Thomas','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(61221,'72322','P','Caldwell','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.105433,-90.771374,0,'2013-07-06 12:44:33',NULL,NULL),(16895,'17581','S','Terre Hill','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.158653,-76.047759,0,'2013-07-06 12:44:31',NULL,NULL),(40398,'45672','S','Ray','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.175482,-82.709789,0,'2013-07-06 12:44:32',NULL,NULL),(71919,'87827','S','Pie Town','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.329535,-108.282746,0,'2013-07-06 12:44:34',NULL,NULL),(74817,'93220','P','Edison','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.331355,-118.861206,0,'2013-07-06 12:44:34',NULL,NULL),(59972,'71322','S','Eola','A','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.943380,-92.185260,0,'2013-07-06 12:44:33',NULL,NULL),(55595,'63937','S','Ellsinore','D','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.968779,-90.751065,0,'2013-07-06 12:44:33',NULL,NULL),(21694,'22967','S','Lowesville','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(79988,'99659','P','St Michael','N','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.278964,-161.772514,0,'2013-07-06 12:44:34',NULL,NULL),(79284,'98579','S','Gate','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.824952,-123.052537,0,'2013-07-06 12:44:34',NULL,NULL),(77501,'96830','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.286315,-157.834651,0,'2013-07-06 12:44:34',NULL,NULL),(27265,'29936','S','Ridgeland','D','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481598,-80.984342,0,'2013-07-06 12:44:31',NULL,NULL),(68083,'80939','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798565,-104.836169,0,'2013-07-06 12:44:34',NULL,NULL),(1207,'00728','S','Res Canas Housing','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(15619,'16691','S','Wells Tannery','D','Fulton','42057','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.091995,-78.142574,0,'2013-07-06 12:44:31',NULL,NULL),(67964,'80914','P','Cheyenne Mt Complex','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(22050,'23315','S','Walters','A','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.743516,-76.837238,0,'2013-07-06 12:44:31',NULL,NULL),(51499,'59635','S','East Helena','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.601240,-111.890548,0,'2013-07-06 12:44:33',NULL,NULL),(43447,'48519','S','Burton','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.989167,-83.615887,0,'2013-07-06 12:44:32',NULL,NULL),(37525,'42047','S','Joy','N','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332744,-88.400437,0,'2013-07-06 12:44:32',NULL,NULL),(19020,'19530','S','Greenwich','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.533780,-75.789540,0,'2013-07-06 12:44:31',NULL,NULL),(18013,'18640','S','Pittston','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(79183,'98526','S','Amanda Park','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.431267,-124.020420,0,'2013-07-06 12:44:34',NULL,NULL),(78896,'98360','S','Crocker','N','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.087937,-122.185345,0,'2013-07-06 12:44:34',NULL,NULL),(11569,'12065','S','Elnora','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.851460,-73.798980,0,'2013-07-06 12:44:30',NULL,NULL),(19917,'20552','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899758,-77.024429,0,'2013-07-06 12:44:31',NULL,NULL),(14014,'14533','S','Piffard','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.829598,-77.897767,0,'2013-07-06 12:44:31',NULL,NULL),(14354,'15015','S','Bradfordwoods','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.638488,-80.084285,0,'2013-07-06 12:44:31',NULL,NULL),(61796,'73089','S','Tuttle','D','Grady','40051','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.289877,-97.781780,0,'2013-07-06 12:44:33',NULL,NULL),(56516,'65351','S','Salt Pond','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964117,-93.418774,0,'2013-07-06 12:44:33',NULL,NULL),(54467,'62858','S','Blair','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(36785,'41048','S','Taylorsport','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.073020,-84.713160,0,'2013-07-06 12:44:32',NULL,NULL),(65388,'77551','S','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.277415,-94.838382,0,'2013-07-06 12:44:34',NULL,NULL),(6442,'05753','S','Cornwall','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.012313,-73.163211,0,'2013-07-06 12:44:30',NULL,NULL),(13186,'13618','S','Cape Vincent','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.130167,-76.329610,0,'2013-07-06 12:44:30',NULL,NULL),(20276,'20788','P','Prince George Plaza','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964901,-76.966704,0,'2013-07-06 12:44:31',NULL,NULL),(18519,'19105','P','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952879,-75.157935,0,'2013-07-06 12:44:31',NULL,NULL),(15363,'16255','S','Sligo','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.109821,-79.494153,0,'2013-07-06 12:44:31',NULL,NULL),(48613,'55792','S','Virginia','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.594940,-92.481120,0,'2013-07-06 12:44:33',NULL,NULL),(33284,'37118','S','Milton','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.916709,-86.179424,0,'2013-07-06 12:44:32',NULL,NULL),(33844,'37938','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.114021,-83.934826,0,'2013-07-06 12:44:32',NULL,NULL),(5560,'04858','S','South Thomaston','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.040168,-69.146550,0,'2013-07-06 12:44:30',NULL,NULL),(29159,'32346','S','Ochlockonee','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023822,-84.391553,0,'2013-07-06 12:44:32',NULL,NULL),(41516,'46977','P','Rockfield','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.641473,-86.573302,0,'2013-07-06 12:44:32',NULL,NULL),(65811,'78135','S','New Braunfels','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.703865,-98.117523,0,'2013-07-06 12:44:34',NULL,NULL),(59917,'71284','P','Tallulah','D','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.406598,-91.186321,0,'2013-07-06 12:44:33',NULL,NULL),(63400,'75651','S','Harleton','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.642141,-94.538825,0,'2013-07-06 12:44:33',NULL,NULL),(64002,'76114','S','Westworth Vlg','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(74995,'93451','S','Camp Roberts','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.750880,-120.636780,0,'2013-07-06 12:44:34',NULL,NULL),(19865,'20524','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902472,-77.031794,0,'2013-07-06 12:44:31',NULL,NULL),(38428,'43553','P','Pettisville','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.529269,-84.224413,0,'2013-07-06 12:44:32',NULL,NULL),(53287,'61727','S','Harp Township','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(79195,'98532','S','Claquato','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(51072,'58758','S','Clifton','N','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.719024,-100.120917,0,'2013-07-06 12:44:33',NULL,NULL),(73902,'92008','S','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.147395,-117.305150,0,'2013-07-06 12:44:34',NULL,NULL),(10949,'11439','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.722867,-73.788363,0,'2013-07-06 12:44:30',NULL,NULL),(13858,'14227','S','S Cheektowaga','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.876735,-78.744457,0,'2013-07-06 12:44:31',NULL,NULL),(62584,'74465','P','Talequah','N','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.906127,-94.985529,0,'2013-07-06 12:44:33',NULL,NULL),(58524,'68786','S','Wausa','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.498268,-97.538422,0,'2013-07-06 12:44:33',NULL,NULL),(47536,'54814','S','Red Cliff','N','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.824360,-90.830460,0,'2013-07-06 12:44:32',NULL,NULL),(6633,'05906','S','South Lunenburg','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.429167,-71.679722,0,'2013-07-06 12:44:30',NULL,NULL),(16436,'17233','S','McConnellsburg','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.956940,-77.963640,0,'2013-07-06 12:44:31',NULL,NULL),(24794,'27587','S','Wake Forest','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.963417,-78.516580,0,'2013-07-06 12:44:31',NULL,NULL),(52080,'60402','S','Forest View','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.838828,-87.791023,0,'2013-07-06 12:44:33',NULL,NULL),(39668,'45013','S','Hamilton','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.408216,-84.617598,0,'2013-07-06 12:44:32',NULL,NULL),(61178,'72202','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.738900,-92.274633,0,'2013-07-06 12:44:33',NULL,NULL),(57600,'67108','S','Mount Hope','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.859374,-97.663530,0,'2013-07-06 12:44:33',NULL,NULL),(40418,'45690','S','Waverly','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.124116,-83.008351,0,'2013-07-06 12:44:32',NULL,NULL),(74504,'92629','S','Monarch Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.474313,-117.696438,0,'2013-07-06 12:44:34',NULL,NULL),(47672,'54946','P','King','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.358509,-89.119468,0,'2013-07-06 12:44:33',NULL,NULL),(30688,'33475','P','Hobe Sound','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.040732,-80.120463,0,'2013-07-06 12:44:32',NULL,NULL),(31023,'33785','S','Indian Shores','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(65098,'77363','S','Plantersville','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.269093,-95.865930,0,'2013-07-06 12:44:34',NULL,NULL),(70920,'85632','S','San Simon','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.177580,-109.379880,0,'2013-07-06 12:44:34',NULL,NULL),(44137,'49514','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.965573,-85.655928,0,'2013-07-06 12:44:32',NULL,NULL),(46482,'53221','S','Greenfield','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.947637,-87.944575,0,'2013-07-06 12:44:32',NULL,NULL),(12277,'12839','S','Hudson Falls','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.320840,-73.576800,0,'2013-07-06 12:44:30',NULL,NULL),(15020,'15679','S','Ruffs Dale','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.154056,-79.636506,0,'2013-07-06 12:44:31',NULL,NULL),(53675,'62218','S','Santa Fe','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.522043,-89.480239,0,'2013-07-06 12:44:33',NULL,NULL),(52074,'60399','U','Wood Dale','D','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.958880,-87.941435,0,'2013-07-06 12:44:33',NULL,NULL),(48902,'56125','S','Dovray','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.052198,-95.548045,0,'2013-07-06 12:44:33',NULL,NULL),(40365,'45642','P','Jasper','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.047459,-83.049854,0,'2013-07-06 12:44:32',NULL,NULL),(40314,'45459','S','Sugarcreek Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(32358,'35824','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.621292,-86.733809,0,'2013-07-06 12:44:32',NULL,NULL),(71993,'88031','P','Deming','D','Luna','35029','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.254211,-107.754880,0,'2013-07-06 12:44:34',NULL,NULL),(76429,'95587','S','Piercy','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.950369,-123.746566,0,'2013-07-06 12:44:34',NULL,NULL),(68158,'81003','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.282078,-104.625815,0,'2013-07-06 12:44:34',NULL,NULL),(51911,'60107','S','Streamwood','D','Cook','17031','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',42.022506,-88.168156,0,'2013-07-06 12:44:33',NULL,NULL),(49586,'56738','S','Holt','A','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.284400,-96.227280,0,'2013-07-06 12:44:33',NULL,NULL),(46933,'54157','S','Peshtigo','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.055220,-87.758537,0,'2013-07-06 12:44:32',NULL,NULL),(7390,'06783','S','Roxbury','D','Litchfield','09005','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.557292,-73.302289,0,'2013-07-06 12:44:30',NULL,NULL),(17666,'18092','S','Zionsville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.452403,-75.510005,0,'2013-07-06 12:44:31',NULL,NULL),(48162,'55374','S','Rogers','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.173877,-93.567994,0,'2013-07-06 12:44:33',NULL,NULL),(24804,'27594','P','Wise','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.485467,-78.171513,0,'2013-07-06 12:44:31',NULL,NULL),(14009,'14527','S','Penn Yan','D','Yates','36123','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.658509,-77.061185,0,'2013-07-06 12:44:31',NULL,NULL),(60162,'71405','S','Ball','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.415594,-92.405924,0,'2013-07-06 12:44:33',NULL,NULL),(49048,'56295','S','Watson','D','Chippewa','27023','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.024558,-95.789905,0,'2013-07-06 12:44:33',NULL,NULL),(23443,'25411','S','Berkeley Springs','D','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.549780,-78.188160,0,'2013-07-06 12:44:31',NULL,NULL),(47510,'54769','S','Stockholm','D','Pepin','55091','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.483986,-92.266896,0,'2013-07-06 12:44:32',NULL,NULL),(26231,'28804','S','Woodfin','A','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.637430,-82.558381,0,'2013-07-06 12:44:31',NULL,NULL),(7189,'06472','S','Northford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.393810,-72.784752,0,'2013-07-06 12:44:30',NULL,NULL),(34491,'38668','S','Northwest Junior College','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(39912,'45217','S','Saint Bernard','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.165637,-84.495829,0,'2013-07-06 12:44:32',NULL,NULL),(36903,'41124','S','Wilbur','N','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.035564,-82.858564,0,'2013-07-06 12:44:32',NULL,NULL),(51954,'60136','S','Gilberts','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.090606,-88.361975,0,'2013-07-06 12:44:33',NULL,NULL),(54003,'62446','S','Mount Erie','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.380617,-88.406635,0,'2013-07-06 12:44:33',NULL,NULL),(69713,'84036','S','Hideout','A','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(66984,'79453','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.576480,-101.854349,0,'2013-07-06 12:44:34',NULL,NULL),(60737,'71962','S','Okolona','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.080979,-93.314393,0,'2013-07-06 12:44:33',NULL,NULL),(47933,'55113','S','Roseville','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.994900,-93.181200,0,'2013-07-06 12:44:33',NULL,NULL),(17256,'17841','S','McClure','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(18180,'18926','P','Gardenville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.381220,-75.094170,0,'2013-07-06 12:44:31',NULL,NULL),(27311,'30021','S','Clarkston','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.805596,-84.236301,0,'2013-07-06 12:44:31',NULL,NULL),(19248,'19934','S','Wyoming','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(19783,'20427','U','Fed Mediation and Concil Ser','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899040,-77.037241,0,'2013-07-06 12:44:31',NULL,NULL),(33894,'38039','S','Grand Jct','A','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.272747,-89.154588,0,'2013-07-06 12:44:32',NULL,NULL),(34717,'38838','S','Ellistown','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.561800,-88.204080,0,'2013-07-06 12:44:32',NULL,NULL),(34835,'38920','S','Paynes','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(2600,'00961','S','Urb Rio Hondo 2','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(41393,'46805','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.099088,-85.115003,0,'2013-07-06 12:44:32',NULL,NULL),(251,'00637','S','Urb Santa Maria','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(38141,'43136','S','Lithopolis','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.804527,-82.808331,0,'2013-07-06 12:44:32',NULL,NULL),(6470,'05763','S','North Chittenden','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.767228,-72.969037,0,'2013-07-06 12:44:30',NULL,NULL),(15269,'16105','S','Neshannock','A','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.031190,-80.343765,0,'2013-07-06 12:44:31',NULL,NULL),(25824,'28615','S','Fig','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.447180,-81.659280,0,'2013-07-06 12:44:31',NULL,NULL),(31392,'34221','S','Rubonia','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.538108,-82.552860,0,'2013-07-06 12:44:32',NULL,NULL),(10216,'10456','S','Morrisania','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.830175,-73.906791,0,'2013-07-06 12:44:30',NULL,NULL),(43221,'48310','S','St Heights','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.566407,-83.068010,0,'2013-07-06 12:44:32',NULL,NULL),(52306,'60546','S','N Riverside','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.835506,-87.821640,0,'2013-07-06 12:44:33',NULL,NULL),(73195,'90508','P','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.834595,-118.315387,0,'2013-07-06 12:44:34',NULL,NULL),(80165,'99821','P','Juneau','A','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.301944,-134.419722,0,'2013-07-06 12:44:34',NULL,NULL),(51226,'59061','S','Beehive','N','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.439173,-109.832978,0,'2013-07-06 12:44:33',NULL,NULL),(79863,'99559','P','Atmautluak','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.940000,-164.620000,0,'2013-07-06 12:44:34',NULL,NULL),(74132,'92242','S','Big River','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.153020,-114.377820,0,'2013-07-06 12:44:34',NULL,NULL),(68307,'81101','S','East Alamosa','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(55701,'64064','S','Unity Village','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.982769,-94.365575,0,'2013-07-06 12:44:33',NULL,NULL),(31824,'35068','S','Fulton Springs','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.612000,-86.826540,0,'2013-07-06 12:44:32',NULL,NULL),(15974,'17032','S','Halifax','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(37660,'42210','S','Huff','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.198402,-86.277888,0,'2013-07-06 12:44:32',NULL,NULL),(11431,'11968','S','S Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.907565,-72.411077,0,'2013-07-06 12:44:30',NULL,NULL),(4389,'03107','U','Nh Insurance','N','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.003767,-71.467549,0,'2013-07-06 12:44:30',NULL,NULL),(13808,'14210','S','W Seneca','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.863725,-78.827208,0,'2013-07-06 12:44:31',NULL,NULL),(36210,'40272','S','Valley Statn','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.087506,-85.844480,0,'2013-07-06 12:44:32',NULL,NULL),(67781,'80653','S','Weldona','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.360170,-104.019750,0,'2013-07-06 12:44:34',NULL,NULL),(21911,'23218','P','Capitol','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.538272,-77.439111,0,'2013-07-06 12:44:31',NULL,NULL),(58638,'68869','S','Sodtown','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(944,'00716','S','Comunidad Tabaiba','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(19558,'20204','U','Food and Drug Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885381,-77.017440,0,'2013-07-06 12:44:31',NULL,NULL),(12842,'13316','S','Camden','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.354631,-75.746699,0,'2013-07-06 12:44:30',NULL,NULL),(75119,'93550','S','Lake La','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.568461,-118.062387,0,'2013-07-06 12:44:34',NULL,NULL),(21872,'23160','S','State Farm','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.646444,-77.845488,0,'2013-07-06 12:44:31',NULL,NULL),(67892,'80864','S','Truckton','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.751983,-104.200640,0,'2013-07-06 12:44:34',NULL,NULL),(64387,'76534','S','Holland','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.877288,-97.404648,0,'2013-07-06 12:44:34',NULL,NULL),(58854,'69142','S','Halsey','D','Thomas','31171','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.890944,-100.352183,0,'2013-07-06 12:44:33',NULL,NULL),(56830,'65793','S','Willow Springs','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.994754,-91.969717,0,'2013-07-06 12:44:33',NULL,NULL),(46510,'53259','U','US Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036290,-87.912848,0,'2013-07-06 12:44:32',NULL,NULL),(14737,'15301','S','Washington','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.175267,-80.251514,0,'2013-07-06 12:44:31',NULL,NULL),(16064,'17048','S','Loyalton','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.595220,-76.713900,0,'2013-07-06 12:44:31',NULL,NULL),(26980,'29616','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.854817,-82.393105,0,'2013-07-06 12:44:31',NULL,NULL),(28597,'31647','S','Sparks','D','Cook','13075','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.179638,-83.434243,0,'2013-07-06 12:44:32',NULL,NULL),(29118,'32312','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.528764,-84.261941,0,'2013-07-06 12:44:32',NULL,NULL),(33182,'37032','S','Cedar Hill','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.512059,-87.020325,0,'2013-07-06 12:44:32',NULL,NULL),(2123,'00924','S','Ext Colinas Verde','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(66974,'79412','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.545120,-101.854537,0,'2013-07-06 12:44:34',NULL,NULL),(66860,'79174','U','Boys Ranch','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.203258,-101.834253,0,'2013-07-06 12:44:34',NULL,NULL),(58824,'69040','S','Palisade','D','Hitchcock','31087','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.293079,-101.075084,0,'2013-07-06 12:44:33',NULL,NULL),(77573,'96913','S','Barrigada','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.461978,144.794011,0,'2013-07-06 12:44:34',NULL,NULL),(45632,'51637','P','College Springs','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.620338,-95.109800,0,'2013-07-06 12:44:32',NULL,NULL),(10872,'11418','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.698520,-73.835575,0,'2013-07-06 12:44:30',NULL,NULL),(47476,'54745','S','Holcombe','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.243772,-91.204691,0,'2013-07-06 12:44:32',NULL,NULL),(37579,'42086','S','Grahamville','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.087107,-88.767014,0,'2013-07-06 12:44:32',NULL,NULL),(76002,'95112','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.345558,-121.883995,0,'2013-07-06 12:44:34',NULL,NULL),(40390,'45662','S','Portsmouth','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.783520,-82.941300,0,'2013-07-06 12:44:32',NULL,NULL),(67418,'80137','S','Watkins','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.764027,-104.653104,0,'2013-07-06 12:44:34',NULL,NULL),(67181,'79848','P','Sanderson','D','Terrell','48443','Texas','TX','48','0000','432','Central',-6.0,'Y',30.141379,-102.389078,0,'2013-07-06 12:44:34',NULL,NULL),(57588,'67071','S','Lake City','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.335115,-98.803382,0,'2013-07-06 12:44:33',NULL,NULL),(47897,'55108','S','Falcon Heights','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.982543,-93.179571,0,'2013-07-06 12:44:33',NULL,NULL),(34873,'38941','S','Colony Town','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(42468,'47834','S','Brazil','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(33905,'38048','P','Macon','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.151834,-89.489494,0,'2013-07-06 12:44:32',NULL,NULL),(55607,'63952','S','Mill Spring','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.046271,-90.642507,0,'2013-07-06 12:44:33',NULL,NULL),(9807,'10111','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(5537,'04785','S','Cyr Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.163199,-67.942329,0,'2013-07-06 12:44:30',NULL,NULL),(14277,'14855','S','Jasper','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.103259,-77.528682,0,'2013-07-06 12:44:31',NULL,NULL),(14888,'15482','P','Star Junction','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.062397,-79.758628,0,'2013-07-06 12:44:31',NULL,NULL),(58713,'68935','S','Sedan','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.371362,-97.974067,0,'2013-07-06 12:44:33',NULL,NULL),(52401,'60636','S','Ogden Park','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.774317,-87.670123,0,'2013-07-06 12:44:33',NULL,NULL),(20638,'21219','S','Sparrows Pt','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.250556,-76.520833,0,'2013-07-06 12:44:31',NULL,NULL),(18660,'19177','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951003,-75.149750,0,'2013-07-06 12:44:31',NULL,NULL),(12906,'13338','S','Atwell','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(76252,'95404','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.458382,-122.685265,0,'2013-07-06 12:44:34',NULL,NULL),(76725,'95887','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.616828,-121.367952,0,'2013-07-06 12:44:34',NULL,NULL),(76231,'95382','S','Turlock','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.520139,-120.850092,0,'2013-07-06 12:44:34',NULL,NULL),(71458,'87049','P','McCartys','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.083765,-107.608587,0,'2013-07-06 12:44:34',NULL,NULL),(61643,'72851','S','New Blaine','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.330381,-93.441665,0,'2013-07-06 12:44:33',NULL,NULL),(60049,'71346','S','Lecompte','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.107087,-92.401052,0,'2013-07-06 12:44:33',NULL,NULL),(52584,'61006','S','Ashton','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.848194,-89.201650,0,'2013-07-06 12:44:33',NULL,NULL),(30026,'33138','S','El Portal','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849350,-80.181844,0,'2013-07-06 12:44:32',NULL,NULL),(6410,'05738','S','North Shrewsbury','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.531020,-72.864480,0,'2013-07-06 12:44:30',NULL,NULL),(37420,'41815','S','Ermine','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.173071,-82.825294,0,'2013-07-06 12:44:32',NULL,NULL),(5661,'04961','S','Highland Plt','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(59324,'70529','S','Duson','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.192719,-92.149791,0,'2013-07-06 12:44:33',NULL,NULL),(51739,'60014','S','Village of Lakewood','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.230860,-88.326944,0,'2013-07-06 12:44:33',NULL,NULL),(50938,'58572','S','Sterling','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.850141,-100.264685,0,'2013-07-06 12:44:33',NULL,NULL),(27811,'30401','S','Covena','A','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(64065,'76136','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.899378,-97.458124,0,'2013-07-06 12:44:34',NULL,NULL),(31399,'34224','S','Inglewood','N','Charlotte','12015','Florida','FL','12','7510','941','Eastern',-5.0,'Y',26.925390,-82.302641,0,'2013-07-06 12:44:32',NULL,NULL),(51648,'59872','S','Superior','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.178911,-114.885047,0,'2013-07-06 12:44:33',NULL,NULL),(44721,'50150','S','Weller','N','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.132809,-92.906584,0,'2013-07-06 12:44:32',NULL,NULL),(74602,'92705','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.753989,-117.791852,0,'2013-07-06 12:44:34',NULL,NULL),(7667,'07091','P','Westfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.693796,-74.382617,0,'2013-07-06 12:44:30',NULL,NULL),(19005,'19526','S','Moselem','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(44435,'49853','S','Mc Millan','D','Luce','26095','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.371164,-85.738692,0,'2013-07-06 12:44:32',NULL,NULL),(4006,'02552','P','Menemsha','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.356664,-70.740920,0,'2013-07-06 12:44:30',NULL,NULL),(10440,'10914','P','Blooming Grove','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.382548,-74.179202,0,'2013-07-06 12:44:30',NULL,NULL),(20862,'21663','S','Saint Michaels','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.788100,-76.225239,0,'2013-07-06 12:44:31',NULL,NULL),(76616,'95696','P','Vacaville','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.317497,-121.920793,0,'2013-07-06 12:44:34',NULL,NULL),(26730,'29418','S','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(20215,'20769','S','Glenn Dale','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.978884,-76.805732,0,'2013-07-06 12:44:31',NULL,NULL),(1736,'00778','S','Urb Horizonte','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(31773,'35014','S','Alpine','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.331742,-86.186598,0,'2013-07-06 12:44:32',NULL,NULL),(28967,'32205','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.303160,-81.726849,0,'2013-07-06 12:44:32',NULL,NULL),(62062,'73543','S','Geronimo','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.481839,-98.379366,0,'2013-07-06 12:44:33',NULL,NULL),(26552,'29208','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.975039,-81.007842,0,'2013-07-06 12:44:31',NULL,NULL),(42375,'47713','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.964898,-87.556864,0,'2013-07-06 12:44:32',NULL,NULL),(13684,'14048','S','Chadwick Bay','N','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.479473,-79.328465,0,'2013-07-06 12:44:31',NULL,NULL),(13178,'13617','S','Canton','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(38204,'43212','S','Grandview Heights','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(23324,'25231','S','Advent','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.626641,-81.566981,0,'2013-07-06 12:44:31',NULL,NULL),(76143,'95269','P','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.018991,-121.322247,0,'2013-07-06 12:44:34',NULL,NULL),(28926,'32162','S','The Villages','D','Sumter','12119','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.915470,-81.922679,0,'2013-07-06 12:44:32',NULL,NULL),(70415,'84722','S','Central','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.403728,-113.560056,0,'2013-07-06 12:44:34',NULL,NULL),(52385,'60628','S','Roseland','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.691540,-87.621710,0,'2013-07-06 12:44:33',NULL,NULL),(29711,'32949','S','Grant Vlkria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.925540,-80.531790,0,'2013-07-06 12:44:32',NULL,NULL),(62864,'75032','S','Heath','A','Rockwall','48397','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.869410,-96.408950,0,'2013-07-06 12:44:33',NULL,NULL),(28454,'31410','S','Thunderbolt','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.013342,-80.953521,0,'2013-07-06 12:44:32',NULL,NULL),(79344,'98625','S','Kalama','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.006782,-122.805876,0,'2013-07-06 12:44:34',NULL,NULL),(2479,'00956','S','Urb El Cortijo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(14951,'15612','S','Alverton','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.129489,-79.563541,0,'2013-07-06 12:44:31',NULL,NULL),(25601,'28452','S','Longwood','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.955560,-78.550208,0,'2013-07-06 12:44:31',NULL,NULL),(63006,'75159','S','Combine','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.649678,-96.563503,0,'2013-07-06 12:44:33',NULL,NULL),(60611,'71857','S','Prescott','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.802675,-93.377033,0,'2013-07-06 12:44:33',NULL,NULL),(58600,'68850','S','Lexington','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.781237,-99.742805,0,'2013-07-06 12:44:33',NULL,NULL),(52445,'60668','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881773,-87.626480,0,'2013-07-06 12:44:33',NULL,NULL),(45627,'51630','S','Blanchard','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.600218,-95.208207,0,'2013-07-06 12:44:32',NULL,NULL),(3863,'02356','S','No Easton','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.057491,-71.115498,0,'2013-07-06 12:44:30',NULL,NULL),(5243,'04474','S','Orrington','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.715764,-68.777683,0,'2013-07-06 12:44:30',NULL,NULL),(10665,'11106','S','Long Island City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761688,-73.930747,0,'2013-07-06 12:44:30',NULL,NULL),(74458,'92590','S','Temecula','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.483865,-117.225540,0,'2013-07-06 12:44:34',NULL,NULL),(58980,'70043','S','Chalmette','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.946707,-89.963929,0,'2013-07-06 12:44:33',NULL,NULL),(34078,'38151','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.149052,-89.977749,0,'2013-07-06 12:44:32',NULL,NULL),(42361,'47704','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.956970,-87.559870,0,'2013-07-06 12:44:32',NULL,NULL),(29307,'32523','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.516644,-87.218851,0,'2013-07-06 12:44:32',NULL,NULL),(72493,'89139','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.040915,-115.194368,0,'2013-07-06 12:44:34',NULL,NULL),(37708,'42261','S','Welchs Creek','A','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(47973,'55126','S','Lino Lakes','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.085314,-93.134715,0,'2013-07-06 12:44:33',NULL,NULL),(47315,'54556','S','Prentice','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.545892,-90.290937,0,'2013-07-06 12:44:32',NULL,NULL),(29724,'32954','P','Merritt Island','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.307863,-80.663103,0,'2013-07-06 12:44:32',NULL,NULL),(61067,'72124','P','Sherwood','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.811333,-92.234881,0,'2013-07-06 12:44:33',NULL,NULL),(13501,'13807','S','Milford','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.619949,-74.983832,0,'2013-07-06 12:44:31',NULL,NULL),(51545,'59730','S','Gallatin Gtwy','A','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.438705,-111.215519,0,'2013-07-06 12:44:33',NULL,NULL),(49211,'56464','S','Blueberry','N','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.761393,-94.974444,0,'2013-07-06 12:44:33',NULL,NULL),(20499,'21065','U','Hunt Valley','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.478149,-76.645140,0,'2013-07-06 12:44:31',NULL,NULL),(15088,'15757','S','Mc Gees Mills','N','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.900980,-78.725700,0,'2013-07-06 12:44:31',NULL,NULL),(73635,'91416','P','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.178039,-118.517445,0,'2013-07-06 12:44:34',NULL,NULL),(53924,'62401','S','Effingham','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(23493,'25517','S','Radnor','A','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.084520,-82.475580,0,'2013-07-06 12:44:31',NULL,NULL),(48473,'55721','S','Bass Brook','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.239448,-93.619584,0,'2013-07-06 12:44:33',NULL,NULL),(42056,'47448','S','Cloud Crest Hills','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(32868,'36521','S','Gulf Crest','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.974220,-88.126860,0,'2013-07-06 12:44:32',NULL,NULL),(32353,'35812','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.632494,-86.652732,0,'2013-07-06 12:44:32',NULL,NULL),(16844,'17560','S','Smithville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.252500,0,'2013-07-06 12:44:31',NULL,NULL),(70764,'85335','S','El Mirage','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.613480,-112.317690,0,'2013-07-06 12:44:34',NULL,NULL),(9928,'10153','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(55679,'64053','S','Sugar Creek','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.106160,-94.463378,0,'2013-07-06 12:44:33',NULL,NULL),(75250,'93657','S','Tivy Valley','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.784020,-119.468700,0,'2013-07-06 12:44:34',NULL,NULL),(54209,'62642','S','Greenview','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.081772,-89.743074,0,'2013-07-06 12:44:33',NULL,NULL),(33184,'37033','S','Centerville','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(40752,'46142','S','Greenwood','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.621324,-86.142110,0,'2013-07-06 12:44:32',NULL,NULL),(58276,'68404','S','Martell','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.642620,-96.747120,0,'2013-07-06 12:44:33',NULL,NULL),(66241,'78570','S','Relampago','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160480,-97.919820,0,'2013-07-06 12:44:34',NULL,NULL),(65599,'77882','P','Wheelock','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',30.897142,-96.390924,0,'2013-07-06 12:44:34',NULL,NULL),(60462,'71653','S','Red Leaf','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(49248,'56474','S','Jenkins','A','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(31149,'33912','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.509195,-81.832204,0,'2013-07-06 12:44:32',NULL,NULL),(28563,'31601','S','Clyattville','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.825593,-83.284447,0,'2013-07-06 12:44:32',NULL,NULL),(49049,'56296','S','Wheaton','D','Traverse','27155','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.804163,-96.496006,0,'2013-07-06 12:44:33',NULL,NULL),(69505,'83714','S','Boise','A','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.641900,-116.293500,0,'2013-07-06 12:44:34',NULL,NULL),(2274,'00926','S','Urb San Gerardo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(27863,'30441','S','Herndon','N','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(73968,'92071','S','Santee','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.846307,-116.988769,0,'2013-07-06 12:44:34',NULL,NULL),(14878,'15473','S','Perryopolis','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.087523,-79.750761,0,'2013-07-06 12:44:31',NULL,NULL),(60229,'71429','S','Toro','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.562771,-93.478790,0,'2013-07-06 12:44:33',NULL,NULL),(44104,'49503','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963193,-85.659686,0,'2013-07-06 12:44:32',NULL,NULL),(8650,'08312','S','Clayton','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.667629,-75.084944,0,'2013-07-06 12:44:30',NULL,NULL),(36905,'41128','P','Smiths Creek','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.427399,-83.119767,0,'2013-07-06 12:44:32',NULL,NULL),(6067,'05444','S','Pleasant Valley','N','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(16327,'17124','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.266009,-76.881673,0,'2013-07-06 12:44:31',NULL,NULL),(23997,'26343','S','Crawford','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.843326,-80.408499,0,'2013-07-06 12:44:31',NULL,NULL),(53971,'62433','S','Hutsonville','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.109922,-87.659516,0,'2013-07-06 12:44:33',NULL,NULL),(48857,'56073','S','New Ulm','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.312771,-94.465735,0,'2013-07-06 12:44:33',NULL,NULL),(11476,'12018','S','Glass Lake','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(79200,'98532','S','Marys Corner','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(79578,'99023','S','Valleyford','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.544258,-117.213397,0,'2013-07-06 12:44:34',NULL,NULL),(20774,'21528','P','Eckhart Mines','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.650221,-78.905479,0,'2013-07-06 12:44:31',NULL,NULL),(57626,'67138','S','Sharon','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.251556,-98.415419,0,'2013-07-06 12:44:33',NULL,NULL),(58413,'68642','S','Tarnov','A','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.688712,-97.489112,0,'2013-07-06 12:44:33',NULL,NULL),(11535,'12043','S','Mineral Springs','N','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(30261,'33234','P','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.750799,-80.274412,0,'2013-07-06 12:44:32',NULL,NULL),(72914,'90025','S','WLA','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.044073,-118.451381,0,'2013-07-06 12:44:34',NULL,NULL),(68365,'81137','S','Oxford','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(50763,'58420','S','Buchanan','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.060715,-98.831051,0,'2013-07-06 12:44:33',NULL,NULL),(65479,'77640','S','Pt Acres','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(64942,'77225','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.693106,-95.416462,0,'2013-07-06 12:44:34',NULL,NULL),(45023,'50461','S','Osage','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.286734,-92.810092,0,'2013-07-06 12:44:32',NULL,NULL),(41740,'47265','S','North Vernon','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.018614,-85.652437,0,'2013-07-06 12:44:32',NULL,NULL),(2047,'00918','S','Villa Pica','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(59948,'71301','S','Cherokee Village','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(28448,'31408','S','Garden City','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.172908,-81.206224,0,'2013-07-06 12:44:32',NULL,NULL),(23565,'25646','P','Stollings','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.825556,-81.966944,0,'2013-07-06 12:44:31',NULL,NULL),(11647,'12128','P','Latham','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.724446,-73.750908,0,'2013-07-06 12:44:30',NULL,NULL),(25678,'28515','S','Bayboro','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.132651,-76.760131,0,'2013-07-06 12:44:31',NULL,NULL),(34685,'38827','S','Bloody Springs','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.512414,-88.210005,0,'2013-07-06 12:44:32',NULL,NULL),(13438,'13760','S','West Endicott','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(15586,'16663','P','Morann','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.786803,-78.367068,0,'2013-07-06 12:44:31',NULL,NULL),(17523,'17968','S','Sacramento','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.643889,-76.636667,0,'2013-07-06 12:44:31',NULL,NULL),(74924,'93402','S','Baywood Park','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.301420,-120.825000,0,'2013-07-06 12:44:34',NULL,NULL),(65712,'78017','S','Derby','N','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',28.689120,-99.196560,0,'2013-07-06 12:44:34',NULL,NULL),(35281,'39401','S','Bon Homme','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(36446,'40619','U','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.177910,-84.899138,0,'2013-07-06 12:44:32',NULL,NULL),(54867,'63051','S','House Springs','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.412034,-90.558900,0,'2013-07-06 12:44:33',NULL,NULL),(78448,'98062','P','Burien','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.469145,-122.360015,0,'2013-07-06 12:44:34',NULL,NULL),(74461,'92592','S','Rancho California','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.505961,-117.003920,0,'2013-07-06 12:44:34',NULL,NULL),(22795,'24467','S','Mount Sidney','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.258200,-78.960354,0,'2013-07-06 12:44:31',NULL,NULL),(20473,'21041','P','Ellicott City','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.273952,-76.836061,0,'2013-07-06 12:44:31',NULL,NULL),(38107,'43102','S','Amanda','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.640743,-82.757046,0,'2013-07-06 12:44:32',NULL,NULL),(29370,'32583','S','Milton','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.586770,-87.025229,0,'2013-07-06 12:44:32',NULL,NULL),(69737,'84044','S','Magna','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.669490,-112.140714,0,'2013-07-06 12:44:34',NULL,NULL),(35191,'39284','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.275332,-90.218859,0,'2013-07-06 12:44:32',NULL,NULL),(58426,'68660','S','Saint Edward','D','Boone','31011','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.572148,-97.861191,0,'2013-07-06 12:44:33',NULL,NULL),(73895,'91987','U','Tecate','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.592436,-116.638994,0,'2013-07-06 12:44:34',NULL,NULL),(12659,'13120','S','Nedrow','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(47597,'54868','S','Rice Lake','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.516544,-91.733836,0,'2013-07-06 12:44:33',NULL,NULL),(42230,'47567','S','Alford','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(2356,'00949','S','Brisas De Campanero','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(9531,'10019','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764248,-73.987442,0,'2013-07-06 12:44:30',NULL,NULL),(23918,'26219','P','Frenchton','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.838055,-80.259341,0,'2013-07-06 12:44:31',NULL,NULL),(15006,'15666','S','Mount Pleasant','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.151156,-79.543060,0,'2013-07-06 12:44:31',NULL,NULL),(60467,'71654','S','McGehee','A','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.656460,-91.408020,0,'2013-07-06 12:44:33',NULL,NULL),(10973,'11530','S','Roosevelt Field','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(16152,'17061','S','Millersbg','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(45327,'50857','S','Nodaway','D','Adams','19003','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.943672,-94.874173,0,'2013-07-06 12:44:32',NULL,NULL),(8087,'07758','S','Port Monmouth','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.430608,-74.106861,0,'2013-07-06 12:44:30',NULL,NULL),(7716,'07193','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.729343,-74.176946,0,'2013-07-06 12:44:30',NULL,NULL),(238,'00636','P','Rosario','D','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.162126,-67.077928,0,'2013-07-06 12:44:30',NULL,NULL),(13957,'14466','S','Hemlock','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.771550,-77.559436,0,'2013-07-06 12:44:31',NULL,NULL),(55703,'64065','U','Unity School of Christianity','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.949632,-94.405068,0,'2013-07-06 12:44:33',NULL,NULL),(28022,'30629','S','Comer','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.066604,-83.123296,0,'2013-07-06 12:44:31',NULL,NULL),(19180,'19802','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.755190,-75.530870,0,'2013-07-06 12:44:31',NULL,NULL),(61761,'73052','S','Lindsay','D','Garvin','40049','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.840396,-97.607974,0,'2013-07-06 12:44:33',NULL,NULL),(24666,'27407','S','Groomtown','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.012660,-79.869960,0,'2013-07-06 12:44:31',NULL,NULL),(11656,'12134','S','Northville','D','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.234942,-74.156837,0,'2013-07-06 12:44:30',NULL,NULL),(78439,'98056','S','Renton','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.512620,-122.193420,0,'2013-07-06 12:44:34',NULL,NULL),(52980,'61432','S','Joshua','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.632317,-90.164403,0,'2013-07-06 12:44:33',NULL,NULL),(49233,'56470','S','Arago','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(10786,'11368','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.752572,-73.854759,0,'2013-07-06 12:44:30',NULL,NULL),(40021,'45247','S','Green Township','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(19511,'20172','P','Herndon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.969316,-77.383247,0,'2013-07-06 12:44:31',NULL,NULL),(67402,'80127','S','Littleton','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.593034,-105.138642,0,'2013-07-06 12:44:34',NULL,NULL),(64605,'76685','P','Satin','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.299710,-97.112340,0,'2013-07-06 12:44:34',NULL,NULL),(2397,'00949','S','Villa de Levittown','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(17873,'18438','S','Hawley','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.475833,-75.182500,0,'2013-07-06 12:44:31',NULL,NULL),(35868,'39840','S','Cuthbert','D','Randolph','13243','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.772884,-84.791311,0,'2013-07-06 12:44:32',NULL,NULL),(28021,'30628','S','Colbert','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.040327,-83.213298,0,'2013-07-06 12:44:31',NULL,NULL),(52831,'61311','S','Ancona','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.050980,-88.930999,0,'2013-07-06 12:44:33',NULL,NULL),(5161,'04426','S','Dover Foxcroft','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(79852,'99551','P','Akiachak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.876431,-161.402745,0,'2013-07-06 12:44:34',NULL,NULL),(74992,'93449','S','Pismo Beach','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.158200,-120.655200,0,'2013-07-06 12:44:34',NULL,NULL),(3228,'01370','S','Shelburne Falls','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.583380,-72.771540,0,'2013-07-06 12:44:30',NULL,NULL),(52004,'60169','S','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847','Central',-6.0,'Y',42.045153,-88.125805,0,'2013-07-06 12:44:33',NULL,NULL),(4705,'03816','S','CTR Tuftnboro','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.656557,-71.251707,0,'2013-07-06 12:44:30',NULL,NULL),(66174,'78520','S','Villa Nueva','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(1849,'00791','S','Bda Azucena','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(56487,'65332','S','Green Ridge','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.615745,-93.452496,0,'2013-07-06 12:44:33',NULL,NULL),(64076,'76147','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.748100,-97.365374,0,'2013-07-06 12:44:34',NULL,NULL),(65180,'77418','S','Bellvue','N','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(30722,'33523','S','Dade City','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.400100,-82.228620,0,'2013-07-06 12:44:32',NULL,NULL),(28662,'31782','P','Putney','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.465321,-83.983681,0,'2013-07-06 12:44:32',NULL,NULL),(61453,'72616','S','Urbanette','N','Carroll','05015','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.367020,-93.580140,0,'2013-07-06 12:44:33',NULL,NULL),(13530,'13820','S','Oneonta','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.481020,-75.070440,0,'2013-07-06 12:44:31',NULL,NULL),(16135,'17058','S','Nook','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.565928,-77.406815,0,'2013-07-06 12:44:31',NULL,NULL),(67969,'80914','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(8718,'08501','S','Upper Freehold','N','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.134060,-74.597340,0,'2013-07-06 12:44:30',NULL,NULL),(26755,'29426','S','Jericho','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.789760,-80.352960,0,'2013-07-06 12:44:31',NULL,NULL),(54133,'62561','S','Riverton','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.854460,-89.507700,0,'2013-07-06 12:44:33',NULL,NULL),(18888,'19465','S','Pottstown','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.217022,-75.648374,0,'2013-07-06 12:44:31',NULL,NULL),(12427,'12950','S','Lewis','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.314607,-73.582276,0,'2013-07-06 12:44:30',NULL,NULL),(55515,'63783','S','Uniontown','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608770,-89.716808,0,'2013-07-06 12:44:33',NULL,NULL),(16826,'17552','S','Donegal Springs','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(76444,'95605','S','River Bank','N','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.594722,-121.540556,0,'2013-07-06 12:44:34',NULL,NULL),(59628,'71037','S','Fillmore','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(25502,'28373','S','Pinebluff','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.103517,-79.474031,0,'2013-07-06 12:44:31',NULL,NULL),(33983,'38114','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.102122,-89.980902,0,'2013-07-06 12:44:32',NULL,NULL),(12650,'13114','S','Mexico','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.461264,-76.233234,0,'2013-07-06 12:44:30',NULL,NULL),(78741,'98288','P','Skykomish','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.703900,-121.304580,0,'2013-07-06 12:44:34',NULL,NULL),(8954,'08801','S','Annandale','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.631280,-74.885604,0,'2013-07-06 12:44:30',NULL,NULL),(29876,'33042','S','Big Torch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(73127,'90267','P','Manhattan Beach','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.874322,-118.395460,0,'2013-07-06 12:44:34',NULL,NULL),(71494,'87106','S','UNM','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.079105,-106.617227,0,'2013-07-06 12:44:34',NULL,NULL),(61963,'73173','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.339186,-97.618675,0,'2013-07-06 12:44:33',NULL,NULL),(8553,'08204','S','Town Bank','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(46398,'53158','S','Pleasant Pr','A','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.551177,-87.931552,0,'2013-07-06 12:44:32',NULL,NULL),(46308,'53062','U','Society of the Divine Savior','N','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.947498,-88.101978,0,'2013-07-06 12:44:32',NULL,NULL),(6921,'06155','U','Hartford Insurance Group','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757156,-72.743576,0,'2013-07-06 12:44:30',NULL,NULL),(37829,'42441','S','Nebo','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.352328,-87.658687,0,'2013-07-06 12:44:32',NULL,NULL),(71001,'85716','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.244884,-110.921446,0,'2013-07-06 12:44:34',NULL,NULL),(2424,'00953','S','Repto San Jose','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(60142,'71373','S','Vidalia','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(57685,'67230','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.675534,-97.175784,0,'2013-07-06 12:44:33',NULL,NULL),(55230,'63437','S','Cherry Box','N','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.738419,-92.263023,0,'2013-07-06 12:44:33',NULL,NULL),(49186,'56440','S','Clarissa','D','Todd','27153','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.132806,-94.948964,0,'2013-07-06 12:44:33',NULL,NULL),(46724,'53813','S','Lancaster','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.844351,-90.710641,0,'2013-07-06 12:44:32',NULL,NULL),(16137,'17059','S','Cuba Mills','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(46901,'54126','S','Greenleaf','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.306220,-88.024800,0,'2013-07-06 12:44:32',NULL,NULL),(12943,'13352','P','Hinckley','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.274500,-75.180460,0,'2013-07-06 12:44:30',NULL,NULL),(72120,'88256','S','Loving','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.283356,-104.097451,0,'2013-07-06 12:44:34',NULL,NULL),(31651,'34740','P','Oakland','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.545029,-81.648835,0,'2013-07-06 12:44:32',NULL,NULL),(71569,'87301','S','Twin Lakes','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(58552,'68817','S','Schaupps','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.302577,-98.817867,0,'2013-07-06 12:44:33',NULL,NULL),(24441,'27212','S','Blanch','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.529874,-79.302902,0,'2013-07-06 12:44:31',NULL,NULL),(11610,'12092','S','Howes Cave','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.711693,-74.363530,0,'2013-07-06 12:44:30',NULL,NULL),(43188,'48302','S','Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(34106,'38181','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.052297,-89.942237,0,'2013-07-06 12:44:32',NULL,NULL),(8000,'07719','S','Shark River Manor','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(30625,'33438','S','Bryant','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.860317,-80.632842,0,'2013-07-06 12:44:32',NULL,NULL),(59988,'71327','S','Hickory','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.988947,-92.052747,0,'2013-07-06 12:44:33',NULL,NULL),(56389,'65236','S','Brunswick','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.430800,-93.123900,0,'2013-07-06 12:44:33',NULL,NULL),(13512,'13811','S','Weltonville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.232380,-76.176420,0,'2013-07-06 12:44:31',NULL,NULL),(33071,'36768','S','Snowhill','N','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.936892,-87.008880,0,'2013-07-06 12:44:32',NULL,NULL),(47900,'55108','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.982543,-93.179571,0,'2013-07-06 12:44:33',NULL,NULL),(46434,'53204','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.017316,-87.924759,0,'2013-07-06 12:44:32',NULL,NULL),(43901,'49247','S','Hudson','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.853146,-84.330032,0,'2013-07-06 12:44:32',NULL,NULL),(39391,'44656','S','New Cumberland','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.609320,-81.358200,0,'2013-07-06 12:44:32',NULL,NULL),(31736,'34985','P','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.295090,-80.349568,0,'2013-07-06 12:44:32',NULL,NULL),(9564,'10025','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(61153,'72173','S','Vilonia','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.066940,-92.174760,0,'2013-07-06 12:44:33',NULL,NULL),(33258,'37085','S','Lascassas','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.938527,-86.272023,0,'2013-07-06 12:44:32',NULL,NULL),(34258,'38453','S','Dellrose','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.154174,-87.090310,0,'2013-07-06 12:44:32',NULL,NULL),(18548,'19115','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.092863,-75.041136,0,'2013-07-06 12:44:31',NULL,NULL),(37375,'41739','P','Dwarf','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.337744,-83.130217,0,'2013-07-06 12:44:32',NULL,NULL),(3386,'01606','S','Greendale','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.310950,-71.801404,0,'2013-07-06 12:44:30',NULL,NULL),(70081,'84152','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725327,-111.859692,0,'2013-07-06 12:44:34',NULL,NULL),(64284,'76442','S','Comanche','D','Comanche','48093','Texas','TX','48','0000','325','Central',-6.0,'Y',31.936389,-98.488333,0,'2013-07-06 12:44:34',NULL,NULL),(79691,'99203','S','Manito','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.629799,-117.389448,0,'2013-07-06 12:44:34',NULL,NULL),(13205,'13626','S','Barnes Cors','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.895883,-75.707121,0,'2013-07-06 12:44:30',NULL,NULL),(66460,'78654','S','Highland Havn','A','Burnet','48053','Texas','TX','48','0000','830','Central',-6.0,'Y',30.581130,-98.336553,0,'2013-07-06 12:44:34',NULL,NULL),(56231,'65043','S','Holts Summit','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.639139,-92.116345,0,'2013-07-06 12:44:33',NULL,NULL),(12238,'12820','P','Rockhurst','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.471968,-73.639216,0,'2013-07-06 12:44:30',NULL,NULL),(70647,'85178','P','Apache Junction','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.423180,-111.546089,0,'2013-07-06 12:44:34',NULL,NULL),(39798,'45135','S','East Monroe','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(47887,'55103','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.963030,-93.125559,0,'2013-07-06 12:44:33',NULL,NULL),(58189,'68310','S','Rockford','N','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.267056,-96.743096,0,'2013-07-06 12:44:33',NULL,NULL),(49224,'56468','S','Lake Shore','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.504936,-94.283424,0,'2013-07-06 12:44:33',NULL,NULL),(43775,'49034','S','Climax','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.232378,-85.345777,0,'2013-07-06 12:44:32',NULL,NULL),(13695,'14055','S','East Concord','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.553172,-78.608173,0,'2013-07-06 12:44:31',NULL,NULL),(9483,'10011','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(65281,'77481','P','Thompsons','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.488833,-95.595741,0,'2013-07-06 12:44:34',NULL,NULL),(23770,'25971','S','Lerona','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.497942,-80.992166,0,'2013-07-06 12:44:31',NULL,NULL),(23453,'25423','P','Halltown','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.314488,-77.798229,0,'2013-07-06 12:44:31',NULL,NULL),(78858,'98343','P','Crescent Beach','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.139728,-123.732852,0,'2013-07-06 12:44:34',NULL,NULL),(10618,'11050','S','Port Wash','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(11843,'12248','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653981,-73.758374,0,'2013-07-06 12:44:30',NULL,NULL),(45664,'52033','S','Cascade','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.310784,-91.005487,0,'2013-07-06 12:44:32',NULL,NULL),(64659,'76801','S','Shamrock Shores','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(21582,'22840','S','Mc Gaheysvlle','N','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.404045,-78.719342,0,'2013-07-06 12:44:31',NULL,NULL),(757,'00692','S','Parc Carmen','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(18037,'18656','S','Sweet Valley','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.329275,-76.161463,0,'2013-07-06 12:44:31',NULL,NULL),(18808,'19403','S','East Norriton','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.147771,-75.375422,0,'2013-07-06 12:44:31',NULL,NULL),(66649,'78842','P','Del Rio','D','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.381977,-100.900262,0,'2013-07-06 12:44:34',NULL,NULL),(57455,'66851','S','Florence','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.241223,-96.926666,0,'2013-07-06 12:44:33',NULL,NULL),(53979,'62439','S','Lawrence','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(52822,'61299','U','Rock Island Arsonal','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.517464,-90.531148,0,'2013-07-06 12:44:33',NULL,NULL),(32170,'35476','S','Northport','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.255087,-87.586136,0,'2013-07-06 12:44:32',NULL,NULL),(23054,'24868','S','Northfork','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(17288,'17847','S','Milton','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.014839,-76.846934,0,'2013-07-06 12:44:31',NULL,NULL),(5792,'05060','S','Braintree','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.931946,-72.644794,0,'2013-07-06 12:44:30',NULL,NULL),(72743,'89508','S','Bordertown','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.630232,-119.870037,0,'2013-07-06 12:44:34',NULL,NULL),(68255,'81063','S','Punkin Center','N','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.237711,-103.784046,0,'2013-07-06 12:44:34',NULL,NULL),(60395,'71630','P','Ark City','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.590628,-91.248596,0,'2013-07-06 12:44:33',NULL,NULL),(47456,'54729','S','Lake Wissota','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(6053,'05442','S','Belvidere Corners','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.772686,-72.663680,0,'2013-07-06 12:44:30',NULL,NULL),(30716,'33510','S','Brandon','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.952410,-82.295627,0,'2013-07-06 12:44:32',NULL,NULL),(26721,'29416','P','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.877670,-80.054864,0,'2013-07-06 12:44:31',NULL,NULL),(21023,'21856','S','Whitehaven','N','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.333919,-75.806911,0,'2013-07-06 12:44:31',NULL,NULL),(12391,'12924','S','Clintonville','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.473734,-73.589677,0,'2013-07-06 12:44:30',NULL,NULL),(74214,'92309','S','Baker','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.273234,-116.067330,0,'2013-07-06 12:44:34',NULL,NULL),(17480,'17957','S','Muir','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.595974,-76.518548,0,'2013-07-06 12:44:31',NULL,NULL),(17133,'17778','S','Bitumen','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.309029,-77.972308,0,'2013-07-06 12:44:31',NULL,NULL),(59197,'70373','S','Larose','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.570192,-90.387385,0,'2013-07-06 12:44:33',NULL,NULL),(59082,'70119','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.974249,-90.087137,0,'2013-07-06 12:44:33',NULL,NULL),(35855,'39825','S','Brinson','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.942154,-84.676803,0,'2013-07-06 12:44:32',NULL,NULL),(40259,'45431','S','Beavercrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(57594,'67103','S','Mayfield','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.256785,-97.530549,0,'2013-07-06 12:44:33',NULL,NULL),(76601,'95690','S','Eagle Tree','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(57185,'66412','S','Bremen','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.872869,-96.746923,0,'2013-07-06 12:44:33',NULL,NULL),(12641,'13108','S','Marcellus Falls','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.970080,-76.324080,0,'2013-07-06 12:44:30',NULL,NULL),(17131,'17777','S','Watsontown','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.092752,-76.861603,0,'2013-07-06 12:44:31',NULL,NULL),(55923,'64461','S','Hopkins','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.541882,-94.820256,0,'2013-07-06 12:44:33',NULL,NULL),(32147,'35462','S','Union','A','Greene','01063','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.837265,-87.890002,0,'2013-07-06 12:44:32',NULL,NULL),(8657,'08316','P','Dorchester','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.271298,-74.975752,0,'2013-07-06 12:44:30',NULL,NULL),(29482,'32730','S','Casselberry','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.651184,-81.345343,0,'2013-07-06 12:44:32',NULL,NULL),(74319,'92394','S','Victorville','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.585299,-117.369903,0,'2013-07-06 12:44:34',NULL,NULL),(25969,'28659','S','Cricket','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(54442,'62843','S','Golden Gate','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.361539,-88.203910,0,'2013-07-06 12:44:33',NULL,NULL),(54670,'62939','S','Eagle Point Bay','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.554162,-88.969995,0,'2013-07-06 12:44:33',NULL,NULL),(61342,'72467','P','St University','N','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.849336,-90.679349,0,'2013-07-06 12:44:33',NULL,NULL),(38624,'43915','S','Clarington','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.747461,-80.893816,0,'2013-07-06 12:44:32',NULL,NULL),(39015,'44142','S','Brookpark','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.398708,-81.832392,0,'2013-07-06 12:44:32',NULL,NULL),(11060,'11579','S','Sea Cliff','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.844990,-73.642613,0,'2013-07-06 12:44:30',NULL,NULL),(64401,'76542','S','Killeen','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.046520,-97.723800,0,'2013-07-06 12:44:34',NULL,NULL),(60957,'72102','S','McRae','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.114602,-91.823524,0,'2013-07-06 12:44:33',NULL,NULL),(56522,'65355','S','Warsaw','D','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.248320,-93.358800,0,'2013-07-06 12:44:33',NULL,NULL),(74271,'92350','U','Loma Linda','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.052083,-117.263767,0,'2013-07-06 12:44:34',NULL,NULL),(13212,'13630','S','De Kalb Junction','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.483181,-75.298577,0,'2013-07-06 12:44:30',NULL,NULL),(8404,'08066','S','Billingsport','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.825920,-75.212157,0,'2013-07-06 12:44:30',NULL,NULL),(55454,'63732','S','New Wells','A','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.523700,-89.597280,0,'2013-07-06 12:44:33',NULL,NULL),(53641,'62202','P','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.616644,-90.160951,0,'2013-07-06 12:44:33',NULL,NULL),(49039,'56284','S','Renville','D','Renville','27129','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.912520,-95.190513,0,'2013-07-06 12:44:33',NULL,NULL),(25605,'28456','S','Acme','N','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.344900,-78.257820,0,'2013-07-06 12:44:31',NULL,NULL),(5846,'05091','S','West Woodstock','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627860,-72.537180,0,'2013-07-06 12:44:30',NULL,NULL),(3016,'01084','S','West Chesterfield','D','Hampshire','25015','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.408674,-72.889157,0,'2013-07-06 12:44:30',NULL,NULL),(48485,'55731','S','Ely','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.895235,-91.887968,0,'2013-07-06 12:44:33',NULL,NULL),(40795,'46172','S','New Maysville','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.847885,-86.799339,0,'2013-07-06 12:44:32',NULL,NULL),(36422,'40550','U','Lexmark','N','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.141026,-84.466930,0,'2013-07-06 12:44:32',NULL,NULL),(22774,'24445','S','Falling Sprng','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(32332,'35772','S','Stevenson','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.868205,-85.833355,0,'2013-07-06 12:44:32',NULL,NULL),(63279,'75551','S','Ofarrell','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.115529,-94.170131,0,'2013-07-06 12:44:33',NULL,NULL),(62773,'74866','P','Saint Louis','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.081038,-96.853480,0,'2013-07-06 12:44:33',NULL,NULL),(26012,'28676','S','State Road','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.396418,-80.892260,0,'2013-07-06 12:44:31',NULL,NULL),(24565,'27305','S','Estelle','N','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.514063,-79.220757,0,'2013-07-06 12:44:31',NULL,NULL),(40565,'45863','S','Middle Point','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.854860,-84.447417,0,'2013-07-06 12:44:32',NULL,NULL),(35484,'39522','U','Bay Saint Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(20337,'20852','S','N Bethesda','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.046797,-77.119654,0,'2013-07-06 12:44:31',NULL,NULL),(47517,'54774','U','Mason Shoe','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.933706,-91.391510,0,'2013-07-06 12:44:32',NULL,NULL),(12449,'12966','S','Bangor','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.818980,-74.415000,0,'2013-07-06 12:44:30',NULL,NULL),(62038,'73507','S','Lawton','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.621344,-98.380949,0,'2013-07-06 12:44:33',NULL,NULL),(2992,'01063','U','Northampton','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.319077,-72.644431,0,'2013-07-06 12:44:30',NULL,NULL),(1760,'00780','S','Est Del Laurel','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(77446,'96809','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305003,-157.859366,0,'2013-07-06 12:44:34',NULL,NULL),(73722,'91616','P','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.184197,-118.396049,0,'2013-07-06 12:44:34',NULL,NULL),(42433,'47804','S','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.495950,-87.391373,0,'2013-07-06 12:44:32',NULL,NULL),(50674,'58341','S','Selz','A','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(16106,'17055','S','Brandtsville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(11866,'12302','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(7697,'07110','S','Nutley','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.819621,-74.163016,0,'2013-07-06 12:44:30',NULL,NULL),(53911,'62370','S','Rockport','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.535316,-91.017575,0,'2013-07-06 12:44:33',NULL,NULL),(43694,'48886','S','Six Lakes','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.416761,-85.161881,0,'2013-07-06 12:44:32',NULL,NULL),(1181,'00727','S','Villa del Rey 3','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(5473,'04741','P','Estcourt Sta','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.442350,-69.210741,0,'2013-07-06 12:44:30',NULL,NULL),(9861,'10120','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(53570,'62056','S','Litchfield','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.190380,-89.637780,0,'2013-07-06 12:44:33',NULL,NULL),(47721,'55006','S','Grass Lake','N','Isanti','27059','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.724622,-93.172881,0,'2013-07-06 12:44:33',NULL,NULL),(16615,'17331','S','Green Springs','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(4820,'03906','S','N Berwick','N','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.305842,-70.742523,0,'2013-07-06 12:44:30',NULL,NULL),(16070,'17049','S','Mc Alistervle','A','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(16563,'17314','S','Slate Hill','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.730000,-76.313333,0,'2013-07-06 12:44:31',NULL,NULL),(70525,'85009','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.456603,-112.123087,0,'2013-07-06 12:44:34',NULL,NULL),(5239,'04471','S','North Amity','N','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.890612,-67.847255,0,'2013-07-06 12:44:30',NULL,NULL),(72494,'89140','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171909,-115.139969,0,'2013-07-06 12:44:34',NULL,NULL),(452,'00662','S','Urb Santa Rosa','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(943,'00716','S','Bo Tenerias','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(46791,'53965','S','Wisc Dells','A','Columbia','55021','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.727182,-89.759168,0,'2013-07-06 12:44:32',NULL,NULL),(22427,'24011','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271198,-79.942884,0,'2013-07-06 12:44:31',NULL,NULL),(37146,'41465','S','Hendricks','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(18886,'19464','S','Sanatoga','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.242360,-75.636660,0,'2013-07-06 12:44:31',NULL,NULL),(35236,'39324','P','Clara','D','Wayne','28153','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.580476,-88.694206,0,'2013-07-06 12:44:32',NULL,NULL),(34436,'38646','S','Sabino','N','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.250150,-90.274085,0,'2013-07-06 12:44:32',NULL,NULL),(8862,'08666','U','NJ Motor Vehicles','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.219539,-74.769690,0,'2013-07-06 12:44:30',NULL,NULL),(2237,'00926','S','Urb Hollywood Est','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(29385,'32611','U','University of FL','N','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.643443,-82.349637,0,'2013-07-06 12:44:32',NULL,NULL),(75630,'94512','S','Birds Landing','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.126085,-121.825908,0,'2013-07-06 12:44:34',NULL,NULL),(68895,'82721','S','Moorcroft','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.588080,-104.937920,0,'2013-07-06 12:44:34',NULL,NULL),(64038,'76127','S','Fort Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.776500,-97.423380,0,'2013-07-06 12:44:34',NULL,NULL),(63729,'75933','S','Call','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.517146,-93.809106,0,'2013-07-06 12:44:34',NULL,NULL),(20217,'20771','U','Goddard Flight Center','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008275,-76.865678,0,'2013-07-06 12:44:31',NULL,NULL),(50751,'58405','U','Jamestown','D','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910278,-98.696046,0,'2013-07-06 12:44:33',NULL,NULL),(50719,'58370','S','St Michael','N','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.941869,-98.905060,0,'2013-07-06 12:44:33',NULL,NULL),(40511,'45815','P','Belmore','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.153280,-83.938620,0,'2013-07-06 12:44:32',NULL,NULL),(34515,'38676','S','Prichard','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(30590,'33419','P','Riviera Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.781477,-80.092135,0,'2013-07-06 12:44:32',NULL,NULL),(72216,'88426','S','Gallegos','N','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.378100,-103.430820,0,'2013-07-06 12:44:34',NULL,NULL),(3545,'01922','S','Byfield','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.755852,-70.931083,0,'2013-07-06 12:44:30',NULL,NULL),(23370,'25285','S','Wallback','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.580248,-81.087658,0,'2013-07-06 12:44:31',NULL,NULL),(18204,'18944','S','Perkasie','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.369436,-75.254135,0,'2013-07-06 12:44:31',NULL,NULL),(23819,'26070','S','Wellsburg','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.274036,-80.588162,0,'2013-07-06 12:44:31',NULL,NULL),(30704,'33487','S','Highland Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.399700,-80.101680,0,'2013-07-06 12:44:32',NULL,NULL),(72660,'89434','S','McCarran','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(4596,'03584','S','Lancaster','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.488551,-71.567367,0,'2013-07-06 12:44:30',NULL,NULL),(52705,'61111','S','Machesney Park','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.328100,-89.026827,0,'2013-07-06 12:44:33',NULL,NULL),(49781,'57076','S','Winfred','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.956631,-97.308946,0,'2013-07-06 12:44:33',NULL,NULL),(32200,'35550','S','Cordova','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.770460,-87.177780,0,'2013-07-06 12:44:32',NULL,NULL),(16882,'17572','S','Soudersburg','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014588,-76.149820,0,'2013-07-06 12:44:31',NULL,NULL),(75486,'94122','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.760276,-122.482029,0,'2013-07-06 12:44:34',NULL,NULL),(12799,'13225','U','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.129510,-76.131355,0,'2013-07-06 12:44:30',NULL,NULL),(22581,'24161','S','Sandy Level','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.989339,-79.546813,0,'2013-07-06 12:44:31',NULL,NULL),(46274,'53029','S','Hartland','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.106382,-88.351136,0,'2013-07-06 12:44:32',NULL,NULL),(46051,'52570','S','Milton','D','Van Buren','19177','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.676337,-92.138273,0,'2013-07-06 12:44:32',NULL,NULL),(20748,'21402','S','North Severn Village','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.987681,-76.487016,0,'2013-07-06 12:44:31',NULL,NULL),(20504,'21074','S','Hampstead','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.610628,-76.848152,0,'2013-07-06 12:44:31',NULL,NULL),(72240,'88516','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812717,-106.418588,0,'2013-07-06 12:44:34',NULL,NULL),(79544,'98951','S','Wapato','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.456917,-120.410065,0,'2013-07-06 12:44:34',NULL,NULL),(3383,'01603','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.240138,-71.837010,0,'2013-07-06 12:44:30',NULL,NULL),(23687,'25849','P','Glen White','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.729884,-81.277059,0,'2013-07-06 12:44:31',NULL,NULL),(32951,'36579','S','Stockton','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.085651,-87.824349,0,'2013-07-06 12:44:32',NULL,NULL),(4343,'03041','P','E Derry','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.889640,-71.297132,0,'2013-07-06 12:44:30',NULL,NULL),(51491,'59625','U','Carroll College','N','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.609086,-112.039756,0,'2013-07-06 12:44:33',NULL,NULL),(10174,'10281','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(25409,'28290','U','JP Morgan Chase','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.234982,-80.913799,0,'2013-07-06 12:44:31',NULL,NULL),(34756,'38858','S','Carolina','N','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.076707,-88.619807,0,'2013-07-06 12:44:32',NULL,NULL),(7528,'07005','S','Powerville','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(77294,'96661','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(20744,'21401','S','Cape Saint Claire','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.002488,-76.510357,0,'2013-07-06 12:44:31',NULL,NULL),(75444,'94061','S','Woodside','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.462453,-122.234484,0,'2013-07-06 12:44:34',NULL,NULL),(73607,'91393','P','Sepulveda','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.230541,-118.466992,0,'2013-07-06 12:44:34',NULL,NULL),(13054,'13440','S','Ridge Mills','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(65294,'77488','S','Magnet','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.329680,-96.061200,0,'2013-07-06 12:44:34',NULL,NULL),(59879,'71269','S','Dehlco','N','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.481360,-91.761660,0,'2013-07-06 12:44:33',NULL,NULL),(58999,'70060','U','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.867768,-90.068648,0,'2013-07-06 12:44:33',NULL,NULL),(57440,'66834','S','Alta Vista','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.866739,-96.488220,0,'2013-07-06 12:44:33',NULL,NULL),(52943,'61402','P','Galesburg','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.948927,-90.368798,0,'2013-07-06 12:44:33',NULL,NULL),(48778,'55987','S','Witoka','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(46797,'54001','S','Joel','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(23444,'25411','S','Hancock','A','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.549780,-78.188160,0,'2013-07-06 12:44:31',NULL,NULL),(37741,'42320','S','Beaver Dam','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(73454,'91302','S','Woodland Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.134741,-118.656723,0,'2013-07-06 12:44:34',NULL,NULL),(73375,'91041','P','Sunland','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.262512,-118.318113,0,'2013-07-06 12:44:34',NULL,NULL),(60920,'72081','S','Steprock','A','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.429280,-91.690920,0,'2013-07-06 12:44:33',NULL,NULL),(33617,'37659','S','Jonesboro','N','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.272018,-82.487968,0,'2013-07-06 12:44:32',NULL,NULL),(39133,'44272','S','Edinburg','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.097130,-81.216588,0,'2013-07-06 12:44:32',NULL,NULL),(45797,'52170','S','Waterville','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.271561,-91.258309,0,'2013-07-06 12:44:32',NULL,NULL),(59451,'70726','S','Port Vincent','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.495187,-90.921746,0,'2013-07-06 12:44:33',NULL,NULL),(52063,'60209','U','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.046820,-87.695708,0,'2013-07-06 12:44:33',NULL,NULL),(17561,'17982','P','Tuscarora','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.766589,-76.041850,0,'2013-07-06 12:44:31',NULL,NULL),(3711,'02142','S','Cambridge','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.366561,-71.087556,0,'2013-07-06 12:44:30',NULL,NULL),(26825,'29484','P','Summerville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.016437,-80.203762,0,'2013-07-06 12:44:31',NULL,NULL),(67070,'79567','S','Hatchel','N','Runnels','48399','Texas','TX','48','0000','325','Central',-6.0,'Y',31.976160,-99.902460,0,'2013-07-06 12:44:34',NULL,NULL),(62266,'74011','S','Brkn Arw','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.987755,-95.810740,0,'2013-07-06 12:44:33',NULL,NULL),(48134,'55361','P','Minnetnka Bch','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.940420,-93.597000,0,'2013-07-06 12:44:33',NULL,NULL),(50307,'57714','S','Allen','D','Bennett','46007','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.303738,-101.912773,0,'2013-07-06 12:44:33',NULL,NULL),(56083,'64765','P','Metz','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.996719,-94.444093,0,'2013-07-06 12:44:33',NULL,NULL),(58675,'68901','S','Hastings Municipal Airport','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(50576,'58227','S','Edinburg','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.488220,-97.915800,0,'2013-07-06 12:44:33',NULL,NULL),(17897,'18446','S','Clifford Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.627472,-75.785332,0,'2013-07-06 12:44:31',NULL,NULL),(37129,'41465','S','Carver','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(13104,'13480','S','Conger Corners','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.930337,-75.378181,0,'2013-07-06 12:44:30',NULL,NULL),(31422,'34250','P','Terra Ceia Is','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.575069,-82.576017,0,'2013-07-06 12:44:32',NULL,NULL),(2070,'00921','S','Pto Nuevo','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(4845,'04011','S','Cundys Harbor','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.905571,-69.964566,0,'2013-07-06 12:44:30',NULL,NULL),(5677,'04966','S','Madrid Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.843444,-70.376629,0,'2013-07-06 12:44:30',NULL,NULL),(43754,'49013','S','Bangor','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.304881,-86.116634,0,'2013-07-06 12:44:32',NULL,NULL),(16109,'17055','S','Locust Point','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(47066,'54424','S','Kempster','A','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.242450,-89.156160,0,'2013-07-06 12:44:32',NULL,NULL),(5459,'04732','S','Sheridan','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.626925,-68.418941,0,'2013-07-06 12:44:30',NULL,NULL),(70562,'85046','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.623245,-112.003464,0,'2013-07-06 12:44:34',NULL,NULL),(57133,'66225','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.888339,-94.686133,0,'2013-07-06 12:44:33',NULL,NULL),(3323,'01529','S','Millville','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.023722,-71.583810,0,'2013-07-06 12:44:30',NULL,NULL),(39885,'45211','S','Mack','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.158460,-84.594600,0,'2013-07-06 12:44:32',NULL,NULL),(37831,'42444','P','Poole','D','Webster','21233','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.639435,-87.643948,0,'2013-07-06 12:44:32',NULL,NULL),(25462,'28334','S','Dunn','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.310491,-78.619199,0,'2013-07-06 12:44:31',NULL,NULL),(34340,'38573','S','Monroe','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.453959,-85.201425,0,'2013-07-06 12:44:32',NULL,NULL),(2041,'00918','S','Urb El Vedado','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(11462,'12009','S','Thompsons Lake','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.697778,-74.025728,0,'2013-07-06 12:44:30',NULL,NULL),(67335,'80046','P','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.628034,-104.798698,0,'2013-07-06 12:44:34',NULL,NULL),(65662,'77979','S','Magnolia Beach','N','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(39595,'44870','S','Bay View','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.404980,-82.731420,0,'2013-07-06 12:44:32',NULL,NULL),(31807,'35051','S','Columbiana','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.182346,-86.604992,0,'2013-07-06 12:44:32',NULL,NULL),(76393,'95537','P','Fields Ldg','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.727358,-124.211781,0,'2013-07-06 12:44:34',NULL,NULL),(17423,'17923','P','Branch Dale','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.674527,-76.324675,0,'2013-07-06 12:44:31',NULL,NULL),(71418,'87024','S','Jemez','N','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.608527,-106.741853,0,'2013-07-06 12:44:34',NULL,NULL),(68237,'81054','S','Ft Lyon','N','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(23111,'24945','S','Greenville','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.532578,-80.666547,0,'2013-07-06 12:44:31',NULL,NULL),(49903,'57278','S','Willow Lake','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.632757,-97.734977,0,'2013-07-06 12:44:33',NULL,NULL),(48538,'55752','S','Jacobson','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.941037,-93.313905,0,'2013-07-06 12:44:33',NULL,NULL),(39722,'45056','S','Miami','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(17416,'17921','S','Homesville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(15886,'17004','S','Alexander Spr','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.603109,-77.720588,0,'2013-07-06 12:44:31',NULL,NULL),(32189,'35540','S','Addison','D','Winston','01133','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.213763,-87.289271,0,'2013-07-06 12:44:32',NULL,NULL),(70029,'84131','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700156,-111.944519,0,'2013-07-06 12:44:34',NULL,NULL),(59537,'70813','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.426458,-91.109438,0,'2013-07-06 12:44:33',NULL,NULL),(58109,'68119','P','Air Mail Facility','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.306600,-95.905130,0,'2013-07-06 12:44:33',NULL,NULL),(27014,'29642','S','Powdersville','A','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.805816,-82.562178,0,'2013-07-06 12:44:31',NULL,NULL),(754,'00692','S','Ext Santa Maria','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(15211,'16003','P','Butler','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.857115,-79.894752,0,'2013-07-06 12:44:31',NULL,NULL),(73212,'90610','P','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.969836,-118.071934,0,'2013-07-06 12:44:34',NULL,NULL),(68002,'80921','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047737,-104.816446,0,'2013-07-06 12:44:34',NULL,NULL),(24100,'26508','S','Little Falls','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.589081,-79.896108,0,'2013-07-06 12:44:31',NULL,NULL),(44060,'49441','S','Norton Shores','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168889,-86.263889,0,'2013-07-06 12:44:32',NULL,NULL),(32907,'36545','S','Salipta','A','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.527175,-87.891357,0,'2013-07-06 12:44:32',NULL,NULL),(66842,'79117','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.223025,-101.810326,0,'2013-07-06 12:44:34',NULL,NULL),(6338,'05669','S','East Granville','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(16269,'17093','P','Summerdale','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.294042,-76.929935,0,'2013-07-06 12:44:31',NULL,NULL),(13142,'13503','P','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.100145,-75.232910,0,'2013-07-06 12:44:30',NULL,NULL),(43297,'48340','S','MI Metro','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.672494,-83.288704,0,'2013-07-06 12:44:32',NULL,NULL),(69065,'83238','S','Geneva','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.319818,-111.061024,0,'2013-07-06 12:44:34',NULL,NULL),(951,'00716','S','Mercedita','A','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(37364,'41727','S','Engle','N','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.361634,-83.321070,0,'2013-07-06 12:44:32',NULL,NULL),(47601,'54873','S','Barnes','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.399140,-91.748040,0,'2013-07-06 12:44:33',NULL,NULL),(79487,'98902','S','Fruitvale','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(9119,'09136','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(27739,'30354','S','Hapeville','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.658320,-84.384600,0,'2013-07-06 12:44:31',NULL,NULL),(46718,'53807','S','Cuba City','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.598203,-90.509698,0,'2013-07-06 12:44:32',NULL,NULL),(14368,'15025','S','Floreffe','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.295525,-79.916350,0,'2013-07-06 12:44:31',NULL,NULL),(20216,'20770','S','Greenbelt','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.996883,-76.884085,0,'2013-07-06 12:44:31',NULL,NULL),(66220,'78559','S','La Feria','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.156158,-97.824324,0,'2013-07-06 12:44:34',NULL,NULL),(37928,'42634','S','Sawyer','A','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.845915,-84.451334,0,'2013-07-06 12:44:32',NULL,NULL),(63896,'76020','S','Azle','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.910000,-97.557240,0,'2013-07-06 12:44:34',NULL,NULL),(49515,'56672','S','Boy River','A','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(50096,'57471','S','Loyalton','N','Edmunds','46045','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.429120,-99.336780,0,'2013-07-06 12:44:33',NULL,NULL),(60070,'71354','S','Monterey','D','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.345723,-91.668555,0,'2013-07-06 12:44:33',NULL,NULL),(20530,'21094','P','Luthvle Timon','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.421320,-76.623102,0,'2013-07-06 12:44:31',NULL,NULL),(35700,'39666','S','Irene','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(65716,'78021','S','Fowlerton','D','La Salle','48283','Texas','TX','48','0000','830','Central',-6.0,'Y',28.530703,-98.832454,0,'2013-07-06 12:44:34',NULL,NULL),(47325,'54561','S','Star Lake','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.054444,-89.457952,0,'2013-07-06 12:44:32',NULL,NULL),(74033,'92136','U','Naval Station 32nd St','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.678744,-117.119958,0,'2013-07-06 12:44:34',NULL,NULL),(68176,'81012','U','CO Lottery','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.272962,-104.609114,0,'2013-07-06 12:44:34',NULL,NULL),(45553,'51467','S','Westside','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.074661,-95.101101,0,'2013-07-06 12:44:32',NULL,NULL),(22413,'23970','S','Southill','N','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.727549,-78.134748,0,'2013-07-06 12:44:31',NULL,NULL),(62130,'73666','S','Mayfield','N','Roger Mills','40129','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.443145,-99.912331,0,'2013-07-06 12:44:33',NULL,NULL),(29742,'32967','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.702306,-80.456836,0,'2013-07-06 12:44:32',NULL,NULL),(2504,'00957','S','Ext Rexville','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(74025,'92131','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.909138,-117.086690,0,'2013-07-06 12:44:34',NULL,NULL),(71798,'87565','S','South San Ysidro','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.415556,-105.493611,0,'2013-07-06 12:44:34',NULL,NULL),(27839,'30421','S','Collins','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.175248,-82.110804,0,'2013-07-06 12:44:31',NULL,NULL),(38192,'43204','S','San Margherita','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.955851,-83.082221,0,'2013-07-06 12:44:32',NULL,NULL),(52660,'61068','S','Flagg','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.948220,-89.055360,0,'2013-07-06 12:44:33',NULL,NULL),(26252,'29002','P','Ballentine','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.160607,-81.262000,0,'2013-07-06 12:44:31',NULL,NULL),(24629,'27359','P','Swepsonville','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.034143,-79.368377,0,'2013-07-06 12:44:31',NULL,NULL),(54021,'62454','S','Hardinville','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(59073,'70114','S','Algiers','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.930760,-90.032820,0,'2013-07-06 12:44:33',NULL,NULL),(37636,'42164','S','Halfway','A','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.782160,-86.190120,0,'2013-07-06 12:44:32',NULL,NULL),(53704,'62233','S','Chester','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.923600,-89.818620,0,'2013-07-06 12:44:33',NULL,NULL),(67722,'80540','S','Lyons','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.217295,-105.300570,0,'2013-07-06 12:44:34',NULL,NULL),(70092,'84165','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(17557,'17981','S','Good Spring','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.626600,-76.407120,0,'2013-07-06 12:44:31',NULL,NULL),(5822,'05075','S','Thet Ctr','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.823651,-72.272568,0,'2013-07-06 12:44:30',NULL,NULL),(75734,'94598','S','Walnut Creek','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.915859,-122.023678,0,'2013-07-06 12:44:34',NULL,NULL),(59241,'70434','P','Covington','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.466355,-90.092629,0,'2013-07-06 12:44:33',NULL,NULL),(54014,'62450','S','Orchard Heights','N','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.730805,-88.084555,0,'2013-07-06 12:44:33',NULL,NULL),(50985,'58645','S','Medora','D','Billings','38007','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.769016,-103.424849,0,'2013-07-06 12:44:33',NULL,NULL),(63999,'76114','S','River Oaks','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.779320,-97.391880,0,'2013-07-06 12:44:34',NULL,NULL),(39164,'44305','S','East Akron','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.073760,-81.465332,0,'2013-07-06 12:44:32',NULL,NULL),(1986,'00907','S','Miramar','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.454321,-66.076621,0,'2013-07-06 12:44:30',NULL,NULL),(12182,'12767','P','Obernburg','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.846503,-75.007705,0,'2013-07-06 12:44:30',NULL,NULL),(14781,'15352','S','New Freeport','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.757908,-80.461303,0,'2013-07-06 12:44:31',NULL,NULL),(19583,'20218','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891183,-76.942515,0,'2013-07-06 12:44:31',NULL,NULL),(29292,'32508','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.353315,-87.276065,0,'2013-07-06 12:44:32',NULL,NULL),(19579,'20216','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891861,-77.012777,0,'2013-07-06 12:44:31',NULL,NULL),(13609,'13861','S','West Oneonta','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.446255,-75.111607,0,'2013-07-06 12:44:31',NULL,NULL),(70318,'84622','P','Centerfield','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.121114,-111.818428,0,'2013-07-06 12:44:34',NULL,NULL),(61098,'72135','S','Roland','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.869776,-92.522556,0,'2013-07-06 12:44:33',NULL,NULL),(49016,'56263','S','Milroy','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.450251,-95.550562,0,'2013-07-06 12:44:33',NULL,NULL),(46267,'53022','S','Germantown','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.224428,-88.145134,0,'2013-07-06 12:44:32',NULL,NULL),(12243,'12823','S','Cossayuna Lake','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.173480,-73.411500,0,'2013-07-06 12:44:30',NULL,NULL),(40972,'46324','S','South Calumet Avenue','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.585919,-87.502396,0,'2013-07-06 12:44:32',NULL,NULL),(79739,'99220','P','Liberty Park','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.648868,-117.412449,0,'2013-07-06 12:44:34',NULL,NULL),(75075,'93532','S','Lake Elizabeth','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(17472,'17948','S','St Nicholas','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(72049,'88101','S','Cannon Air Force Base','N','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.405380,-103.248420,0,'2013-07-06 12:44:34',NULL,NULL),(61325,'72449','P','O Kean','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.180656,-90.834326,0,'2013-07-06 12:44:33',NULL,NULL),(19188,'19806','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.759555,-75.566524,0,'2013-07-06 12:44:31',NULL,NULL),(19062,'19547','S','Oley Furnace','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(70413,'84721','S','Enoch','A','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.662085,-113.196253,0,'2013-07-06 12:44:34',NULL,NULL),(64736,'76890','S','Zephyr','D','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.654972,-98.832717,0,'2013-07-06 12:44:34',NULL,NULL),(8085,'07757','S','Sands Point','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315089,-74.017467,0,'2013-07-06 12:44:30',NULL,NULL),(47562,'54837','S','Trade Lake','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.703572,-92.475946,0,'2013-07-06 12:44:32',NULL,NULL),(44739,'50163','P','Melcher','A','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.225249,-93.238708,0,'2013-07-06 12:44:32',NULL,NULL),(67774,'80645','S','La Salle','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.336011,-104.686585,0,'2013-07-06 12:44:34',NULL,NULL),(59259,'70447','S','Madisonville','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.429143,-90.182432,0,'2013-07-06 12:44:33',NULL,NULL),(15770,'16917','S','Covngtn','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.757299,-77.067597,0,'2013-07-06 12:44:31',NULL,NULL),(14033,'14547','P','Seneca Castle','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.904938,-77.126529,0,'2013-07-06 12:44:31',NULL,NULL),(25953,'28657','S','Pyatte','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(54568,'62896','S','Deering','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(64489,'76623','P','Avalon','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.309699,-96.795874,0,'2013-07-06 12:44:34',NULL,NULL),(30840,'33633','U','Business Reply','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.977884,-82.487078,0,'2013-07-06 12:44:32',NULL,NULL),(73326,'90840','U','Ca State Univ Long Beach','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.781444,-118.118257,0,'2013-07-06 12:44:34',NULL,NULL),(41640,'47133','U','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287708,-85.736180,0,'2013-07-06 12:44:32',NULL,NULL),(43097,'48215','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.387720,-82.950600,0,'2013-07-06 12:44:32',NULL,NULL),(60802,'72031','S','Clinton','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(58260,'68375','S','Hubbell','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.010558,-97.501680,0,'2013-07-06 12:44:33',NULL,NULL),(8556,'08205','S','Galloway','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.420254,-74.502031,0,'2013-07-06 12:44:30',NULL,NULL),(21254,'22303','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.794024,-77.074314,0,'2013-07-06 12:44:31',NULL,NULL),(55080,'63195','U','Firstar Bank','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.651601,-90.339813,0,'2013-07-06 12:44:33',NULL,NULL),(26282,'29020','S','Camden','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(2963,'01040','S','Halyoke','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.204025,-72.630051,0,'2013-07-06 12:44:30',NULL,NULL),(73632,'91413','P','Sherman Oaks','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.164355,-118.458352,0,'2013-07-06 12:44:34',NULL,NULL),(45767,'52151','S','Village Creek','N','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.359099,-91.221890,0,'2013-07-06 12:44:32',NULL,NULL),(32740,'36322','S','Clayhatchee','N','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.284660,-85.730340,0,'2013-07-06 12:44:32',NULL,NULL),(21686,'22963','S','Cunningham','A','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(80123,'99766','P','Point Hope','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',68.530422,-165.797572,0,'2013-07-06 12:44:34',NULL,NULL),(17510,'17963','S','Outwood','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(14023,'14541','S','Romulus','D','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.750765,-76.870680,0,'2013-07-06 12:44:31',NULL,NULL),(65985,'78333','P','Alice','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.742522,-98.073138,0,'2013-07-06 12:44:34',NULL,NULL),(77082,'96130','S','Susanville','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417140,-120.641220,0,'2013-07-06 12:44:34',NULL,NULL),(48922,'56146','S','Kanaranzi','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.548093,-96.110546,0,'2013-07-06 12:44:33',NULL,NULL),(60615,'71859','S','Saratoga','D','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.774332,-93.884417,0,'2013-07-06 12:44:33',NULL,NULL),(64240,'76352','P','Bluegrove','D','Clay','48077','Texas','TX','48','0000','940','Central',-6.0,'Y',33.676136,-98.229576,0,'2013-07-06 12:44:34',NULL,NULL),(18341,'19030','S','Fairless Hls','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.173040,-74.848169,0,'2013-07-06 12:44:31',NULL,NULL),(44236,'49657','S','Mc Bain','D','Missaukee','26113','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.219400,-85.193294,0,'2013-07-06 12:44:32',NULL,NULL),(46161,'52728','P','Buffalo','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.454459,-90.726424,0,'2013-07-06 12:44:32',NULL,NULL),(25179,'28052','S','Groves','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(37790,'42368','S','Reynolds Sta','A','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.698386,-86.772446,0,'2013-07-06 12:44:32',NULL,NULL),(22754,'24422','S','Clifton Forge','D','Alleghany','51005','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.817394,-79.824624,0,'2013-07-06 12:44:31',NULL,NULL),(32442,'36009','S','Brantley','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.585788,-86.247921,0,'2013-07-06 12:44:32',NULL,NULL),(47263,'54529','S','Cassian','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.673020,-89.671560,0,'2013-07-06 12:44:32',NULL,NULL),(36263,'40330','S','Harrodsburg','D','Mercer','21167','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.789200,-84.861780,0,'2013-07-06 12:44:32',NULL,NULL),(75631,'94513','S','Brentwood','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.937735,-121.695234,0,'2013-07-06 12:44:34',NULL,NULL),(65822,'78148','S','Randolph AFB','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.551704,-98.302464,0,'2013-07-06 12:44:34',NULL,NULL),(9634,'10035','S','Randalls Island','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(32832,'36471','S','Peterman','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.607468,-87.263850,0,'2013-07-06 12:44:32',NULL,NULL),(45478,'51340','S','Fostoria','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.212453,-95.210212,0,'2013-07-06 12:44:32',NULL,NULL),(27648,'30320','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.635644,-84.433286,0,'2013-07-06 12:44:31',NULL,NULL),(27525,'30216','S','Flovilla','D','Butts','13035','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.244230,-83.896090,0,'2013-07-06 12:44:31',NULL,NULL),(75091,'93535','S','Wilsona Gardens','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(56147,'64849','P','Neck City','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.258053,-94.444753,0,'2013-07-06 12:44:33',NULL,NULL),(21195,'22191','S','Woodbridge','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.626232,-77.274322,0,'2013-07-06 12:44:31',NULL,NULL),(17650,'18074','S','Perkiomenville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.319879,-75.517672,0,'2013-07-06 12:44:31',NULL,NULL),(76271,'95419','P','Camp Meeker','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.426039,-122.958796,0,'2013-07-06 12:44:34',NULL,NULL),(396,'00662','S','Comunidad Ramal','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(52450,'60670','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.886480,-87.622247,0,'2013-07-06 12:44:33',NULL,NULL),(37990,'42746','S','Hardyville','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.222229,-85.746864,0,'2013-07-06 12:44:32',NULL,NULL),(43307,'48348','S','Independence','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.767149,-83.400047,0,'2013-07-06 12:44:32',NULL,NULL),(49829,'57221','S','Bryant','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.629708,-97.429998,0,'2013-07-06 12:44:33',NULL,NULL),(20408,'20904','S','Cloverly','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.065040,-76.981500,0,'2013-07-06 12:44:31',NULL,NULL),(11787,'12211','S','Loudonville','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.707382,-73.772002,0,'2013-07-06 12:44:30',NULL,NULL),(23059,'24870','S','Hatcher','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.711020,-81.604020,0,'2013-07-06 12:44:31',NULL,NULL),(53167,'61568','S','Tremont','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.525564,-89.488301,0,'2013-07-06 12:44:33',NULL,NULL),(34405,'38626','S','Powell','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.534380,-90.396000,0,'2013-07-06 12:44:32',NULL,NULL),(38897,'44114','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.508496,-81.675394,0,'2013-07-06 12:44:32',NULL,NULL),(44225,'49649','S','Kingsley','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.576008,-85.544315,0,'2013-07-06 12:44:32',NULL,NULL),(68118,'80949','P','Rockrimmon','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.929049,-104.855865,0,'2013-07-06 12:44:34',NULL,NULL),(3117,'01235','S','Peru','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.430860,-73.069380,0,'2013-07-06 12:44:30',NULL,NULL),(24602,'27330','S','Colon','A','Lee','37105','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.459277,-79.168611,0,'2013-07-06 12:44:31',NULL,NULL),(25700,'28533','S','Cherry Point','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.878889,-76.901667,0,'2013-07-06 12:44:31',NULL,NULL),(1444,'00739','S','Villa del Carmen','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(19266,'19953','S','Hartly','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.150871,-75.693133,0,'2013-07-06 12:44:31',NULL,NULL),(26183,'28758','P','Hendersonville','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378626,-82.477763,0,'2013-07-06 12:44:31',NULL,NULL),(56703,'65666','S','Hardenville','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.594912,-92.371990,0,'2013-07-06 12:44:33',NULL,NULL),(35003,'39120','S','Natchez','D','Adams','28001','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.536480,-91.326600,0,'2013-07-06 12:44:32',NULL,NULL),(46594,'53548','S','Janesville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.678230,-89.016451,0,'2013-07-06 12:44:32',NULL,NULL),(41512,'46971','S','Grissom ARB','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.673495,-86.158752,0,'2013-07-06 12:44:32',NULL,NULL),(38896,'44113','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.482850,-81.694321,0,'2013-07-06 12:44:32',NULL,NULL),(59925,'71291','S','Splane Place','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(56680,'65638','S','Drury','D','Douglas','29067','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.930415,-92.365377,0,'2013-07-06 12:44:33',NULL,NULL),(42790,'48045','S','Selfridge Angb','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(34120,'38187','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.076070,-89.843603,0,'2013-07-06 12:44:32',NULL,NULL),(70839,'85535','S','Eden','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.976244,-109.899988,0,'2013-07-06 12:44:34',NULL,NULL),(38644,'43934','P','Lansing','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.073876,-80.788268,0,'2013-07-06 12:44:32',NULL,NULL),(66717,'78951','P','Oakland','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.603491,-96.828916,0,'2013-07-06 12:44:34',NULL,NULL),(40360,'45636','P','Haverhill','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.584164,-82.830812,0,'2013-07-06 12:44:32',NULL,NULL),(42587,'47882','S','Turman','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.098637,-87.402599,0,'2013-07-06 12:44:32',NULL,NULL),(48769,'55985','S','Concord','N','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.147500,-92.836111,0,'2013-07-06 12:44:33',NULL,NULL),(77409,'96788','P','Pukalani Maui','N','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.834756,-156.338783,0,'2013-07-06 12:44:34',NULL,NULL),(25607,'28456','S','Northwest','N','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.344900,-78.257820,0,'2013-07-06 12:44:31',NULL,NULL),(2620,'00962','S','Repto Paraiso','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(250,'00637','S','Urb Santa Elena','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(66829,'79101','S','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.207679,-101.839393,0,'2013-07-06 12:44:34',NULL,NULL),(5696,'04981','S','Prospect','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.533378,-68.860272,0,'2013-07-06 12:44:30',NULL,NULL),(38999,'44136','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.312880,-81.834720,0,'2013-07-06 12:44:32',NULL,NULL),(50434,'57799','U','Black Hills State University','N','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.485188,-103.859540,0,'2013-07-06 12:44:33',NULL,NULL),(49895,'57273','S','Blue Dog Lake','N','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.335539,-97.310586,0,'2013-07-06 12:44:33',NULL,NULL),(68454,'81230','S','Baldwin','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.453420,-106.609860,0,'2013-07-06 12:44:34',NULL,NULL),(50677,'58343','S','Wolford','N','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.327756,-99.654741,0,'2013-07-06 12:44:33',NULL,NULL),(37153,'41465','S','Salyersville','D','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(19799,'20437','U','Food and Drug Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901872,-77.048950,0,'2013-07-06 12:44:31',NULL,NULL),(69230,'83404','S','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.474620,-112.012784,0,'2013-07-06 12:44:34',NULL,NULL),(68894,'82721','S','Carlile','A','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.588080,-104.937920,0,'2013-07-06 12:44:34',NULL,NULL),(28666,'31788','S','Moultrie','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.171588,-83.788569,0,'2013-07-06 12:44:32',NULL,NULL),(26404,'29111','S','Union Crossroads','N','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.780339,-80.018183,0,'2013-07-06 12:44:31',NULL,NULL),(46973,'54213','S','Forestville','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.703669,-87.502686,0,'2013-07-06 12:44:32',NULL,NULL),(24071,'26437','S','Smithfield','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.504724,-80.567131,0,'2013-07-06 12:44:31',NULL,NULL),(14517,'15202','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(32872,'36523','S','Coden','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.387102,-88.167787,0,'2013-07-06 12:44:32',NULL,NULL),(69860,'84092','S','Crescent','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(64799,'77019','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.754852,-95.415733,0,'2013-07-06 12:44:34',NULL,NULL),(33344,'37172','S','Springfield','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.524986,-86.867133,0,'2013-07-06 12:44:32',NULL,NULL),(48183,'55387','S','Waconia','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.847413,-93.788794,0,'2013-07-06 12:44:33',NULL,NULL),(24384,'27099','U','Hanes Brands Inc','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.228578,-80.303201,0,'2013-07-06 12:44:31',NULL,NULL),(26192,'28768','S','Pisgah Forest','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.256930,-82.668289,0,'2013-07-06 12:44:31',NULL,NULL),(21908,'23190','P','Woods Cross Roads','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.483538,-76.620692,0,'2013-07-06 12:44:31',NULL,NULL),(19777,'20424','U','Fed Labor Relations Auth','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895393,-77.031186,0,'2013-07-06 12:44:31',NULL,NULL),(51060,'58746','S','Niobe','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.678244,-102.068686,0,'2013-07-06 12:44:33',NULL,NULL),(6277,'05640','S','Bliss Pond','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.329167,-72.503333,0,'2013-07-06 12:44:30',NULL,NULL),(49873,'57260','S','Rosholt','D','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.878034,-96.713253,0,'2013-07-06 12:44:33',NULL,NULL),(73089,'90221','S','East Rancho Dominguez','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.879540,-118.200540,0,'2013-07-06 12:44:34',NULL,NULL),(3687,'02132','S','W Roxbury','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.275160,-71.147280,0,'2013-07-06 12:44:30',NULL,NULL),(75283,'93716','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.731026,-119.786485,0,'2013-07-06 12:44:34',NULL,NULL),(30966,'33740','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770012,-82.766347,0,'2013-07-06 12:44:32',NULL,NULL),(65611,'77951','P','Bloomington','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.648992,-96.893563,0,'2013-07-06 12:44:34',NULL,NULL),(62018,'73453','S','Overbrook','D','Love','40085','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.047702,-97.119298,0,'2013-07-06 12:44:33',NULL,NULL),(27560,'30261','P','Lagrange','D','Troup','13285','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.061746,-84.890953,0,'2013-07-06 12:44:31',NULL,NULL),(57230,'66509','S','Mayetta','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.339878,-95.717014,0,'2013-07-06 12:44:33',NULL,NULL),(42261,'47580','S','Schnellville','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.342295,-86.755119,0,'2013-07-06 12:44:32',NULL,NULL),(23720,'25902','S','Odd','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.571017,-81.231729,0,'2013-07-06 12:44:31',NULL,NULL),(21785,'23069','S','Mangohick','A','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.781421,-77.309839,0,'2013-07-06 12:44:31',NULL,NULL),(15704,'16854','S','Millheim','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.892507,-77.473279,0,'2013-07-06 12:44:31',NULL,NULL),(40597,'45884','P','Saint Johns','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.553727,-84.081758,0,'2013-07-06 12:44:32',NULL,NULL),(8974,'08823','S','Franklin Park','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.442493,-74.543499,0,'2013-07-06 12:44:30',NULL,NULL),(61417,'72564','S','Oil Trough','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.612233,-91.438675,0,'2013-07-06 12:44:33',NULL,NULL),(41374,'46795','S','Witmer Manor','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(54795,'63014','S','Etlah','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.652660,-91.319280,0,'2013-07-06 12:44:33',NULL,NULL),(63483,'75691','S','Tatum','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.329081,-94.530614,0,'2013-07-06 12:44:33',NULL,NULL),(56409,'65250','S','Franklin','D','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.062310,-92.839917,0,'2013-07-06 12:44:33',NULL,NULL),(74457,'92590','S','Rancho California','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.483865,-117.225540,0,'2013-07-06 12:44:34',NULL,NULL),(69806,'84070','S','Sandy','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.571551,-111.884711,0,'2013-07-06 12:44:34',NULL,NULL),(35820,'39762','P','Ms St','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.457993,-88.786062,0,'2013-07-06 12:44:32',NULL,NULL),(41295,'46765','S','Cedar Canyon','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(44224,'49648','S','Kewadin','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.926163,-85.354490,0,'2013-07-06 12:44:32',NULL,NULL),(65121,'77378','S','Willis','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.417704,-95.408157,0,'2013-07-06 12:44:34',NULL,NULL),(1520,'00754','S','San Lorenzo','D','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(51606,'59826','S','Swan Valley','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.490393,-113.715644,0,'2013-07-06 12:44:33',NULL,NULL),(69479,'83671','P','Warren','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',45.264266,-115.675808,0,'2013-07-06 12:44:34',NULL,NULL),(66692,'78945','S','Ammansville','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(76030,'95140','S','San Jose','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.354500,-121.721340,0,'2013-07-06 12:44:34',NULL,NULL),(25314,'28164','S','Stanley','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.352840,-81.101940,0,'2013-07-06 12:44:31',NULL,NULL),(18240,'18976','S','Warrington','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.241554,-75.129493,0,'2013-07-06 12:44:31',NULL,NULL),(21595,'22846','S','Penn Laird','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.372896,-78.804180,0,'2013-07-06 12:44:31',NULL,NULL),(63069,'75235','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.828634,-96.842696,0,'2013-07-06 12:44:33',NULL,NULL),(65966,'78288','U','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425828,-98.491586,0,'2013-07-06 12:44:34',NULL,NULL),(71424,'87026','S','Mesita','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(13830,'14218','S','West Seneca','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.810099,-78.781921,0,'2013-07-06 12:44:31',NULL,NULL),(50130,'57529','S','Paxton','N','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.234545,-99.511640,0,'2013-07-06 12:44:33',NULL,NULL),(58639,'68869','S','St Michael','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(55912,'64446','S','Fairfax','D','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.339060,-95.392618,0,'2013-07-06 12:44:33',NULL,NULL),(55705,'64065','U','Unity Vlg','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.949632,-94.405068,0,'2013-07-06 12:44:33',NULL,NULL),(6375,'05680','S','Wolcott','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.546700,-72.497820,0,'2013-07-06 12:44:30',NULL,NULL),(68899,'82725','S','Recluse','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.899551,-105.670440,0,'2013-07-06 12:44:34',NULL,NULL),(67823,'80758','S','Wray','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.192680,-102.271860,0,'2013-07-06 12:44:34',NULL,NULL),(49764,'57068','S','Valley Springs','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.582880,-96.464847,0,'2013-07-06 12:44:33',NULL,NULL),(18556,'19119','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.069561,-75.210372,0,'2013-07-06 12:44:31',NULL,NULL),(27915,'30504','S','Gainesville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.262306,-83.890081,0,'2013-07-06 12:44:31',NULL,NULL),(8923,'08742','S','Pt Pleasant Beach','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(42963,'48131','S','Dundee','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.965760,-83.668534,0,'2013-07-06 12:44:32',NULL,NULL),(44735,'50161','S','Iowa Center','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.881140,-93.411720,0,'2013-07-06 12:44:32',NULL,NULL),(48626,'55803','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.913546,-92.116488,0,'2013-07-06 12:44:33',NULL,NULL),(57056,'66211','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924984,-94.642170,0,'2013-07-06 12:44:33',NULL,NULL),(55358,'63561','S','Worthington','A','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.420358,-92.567187,0,'2013-07-06 12:44:33',NULL,NULL),(54473,'62859','S','Dale','A','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(74695,'93001','S','San Buenaventura','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.295546,-119.291976,0,'2013-07-06 12:44:34',NULL,NULL),(17952,'18515','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.449536,-75.664120,0,'2013-07-06 12:44:31',NULL,NULL),(13348,'13693','S','Three Mile Bay','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.040710,-76.244192,0,'2013-07-06 12:44:30',NULL,NULL),(33473,'37334','S','Fayetteville','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.151295,-86.574002,0,'2013-07-06 12:44:32',NULL,NULL),(67713,'80533','P','Hygiene','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.199537,-105.188054,0,'2013-07-06 12:44:34',NULL,NULL),(75447,'94062','S','Redwood City','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.448337,-122.268736,0,'2013-07-06 12:44:34',NULL,NULL),(32461,'36028','S','Dozier','D','Crenshaw','01041','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.523436,-86.363431,0,'2013-07-06 12:44:32',NULL,NULL),(74712,'93012','S','Santa Rosa Valley','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.224457,-118.978052,0,'2013-07-06 12:44:34',NULL,NULL),(33226,'37064','S','Franklin','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.923225,-86.887821,0,'2013-07-06 12:44:32',NULL,NULL),(33850,'37996','U','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.956034,-83.937037,0,'2013-07-06 12:44:32',NULL,NULL),(52950,'61415','S','Avon','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.660240,-90.433285,0,'2013-07-06 12:44:33',NULL,NULL),(79803,'99361','S','Waitsburg','D','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.264939,-118.152543,0,'2013-07-06 12:44:34',NULL,NULL),(65646,'77971','S','Lolita','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.817071,-96.440565,0,'2013-07-06 12:44:34',NULL,NULL),(6452,'05758','S','Summit','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.450800,-72.791580,0,'2013-07-06 12:44:30',NULL,NULL),(47860,'55079','S','Lent','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.397384,-92.987057,0,'2013-07-06 12:44:33',NULL,NULL),(71632,'87412','S','Blanco','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.777110,-107.736433,0,'2013-07-06 12:44:34',NULL,NULL),(15479,'16435','S','Springboro','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.798277,-80.369185,0,'2013-07-06 12:44:31',NULL,NULL),(73501,'91331','S','Hansen Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252512,-118.425349,0,'2013-07-06 12:44:34',NULL,NULL),(72318,'89002','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.057986,-114.960279,0,'2013-07-06 12:44:34',NULL,NULL),(1432,'00739','S','Sect Campobello','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(44706,'50139','S','Newbern','N','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.196919,-93.394123,0,'2013-07-06 12:44:32',NULL,NULL),(76890,'95980','P','Belden','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(65002,'77297','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.762572,-95.364143,0,'2013-07-06 12:44:34',NULL,NULL),(8842,'08640','S','Fort Dix','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.008420,-74.589540,0,'2013-07-06 12:44:30',NULL,NULL),(42779,'48042','S','Macomb','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.684140,-82.918673,0,'2013-07-06 12:44:32',NULL,NULL),(21965,'23238','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602561,-77.663297,0,'2013-07-06 12:44:31',NULL,NULL),(10102,'10249','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714735,-74.008556,0,'2013-07-06 12:44:30',NULL,NULL),(3964,'02482','S','Wellesley','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.291931,-71.298538,0,'2013-07-06 12:44:30',NULL,NULL),(63564,'75771','S','Garden Valley','A','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(53463,'61924','S','Chrisman','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.801374,-87.674371,0,'2013-07-06 12:44:33',NULL,NULL),(46730,'53821','S','Prairie du Chien','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.047250,-91.135493,0,'2013-07-06 12:44:32',NULL,NULL),(65690,'78002','S','Atascosa','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.287174,-98.733294,0,'2013-07-06 12:44:34',NULL,NULL),(8049,'07735','S','Cliffwood Beach','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.438200,-74.201940,0,'2013-07-06 12:44:30',NULL,NULL),(51178,'59014','S','Bridger','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.292794,-108.913596,0,'2013-07-06 12:44:33',NULL,NULL),(38350,'43443','S','Luckey','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.460907,-83.476317,0,'2013-07-06 12:44:32',NULL,NULL),(46587,'53541','S','Gratiot','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.585999,-90.019817,0,'2013-07-06 12:44:32',NULL,NULL),(39976,'45239','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(169,'00623','S','Est De Miramar','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(74346,'92407','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(32091,'35293','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.463859,-86.823031,0,'2013-07-06 12:44:32',NULL,NULL),(52324,'60559','S','Westmont','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.794210,-87.977021,0,'2013-07-06 12:44:33',NULL,NULL),(45847,'52227','S','Ely','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.896190,-91.567417,0,'2013-07-06 12:44:32',NULL,NULL),(42263,'47581','S','Dover Hill','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(10518,'10977','S','Spring Valley','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(69471,'83657','S','Ola','D','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.250761,-116.298415,0,'2013-07-06 12:44:34',NULL,NULL),(61735,'73028','S','Cimarron City','A','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.952496,-97.595964,0,'2013-07-06 12:44:33',NULL,NULL),(49291,'56522','S','Campbell','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.125900,-96.441780,0,'2013-07-06 12:44:33',NULL,NULL),(51768,'60033','S','Harvard','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.422653,-88.603857,0,'2013-07-06 12:44:33',NULL,NULL),(60757,'72002','S','Alexander','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.632983,-92.486426,0,'2013-07-06 12:44:33',NULL,NULL),(71369,'87001','S','Budaghers','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.382532,-106.479515,0,'2013-07-06 12:44:34',NULL,NULL),(40762,'46149','S','Lizton','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.886653,-86.546411,0,'2013-07-06 12:44:32',NULL,NULL),(56275,'65067','S','Readsville','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.797987,-91.700471,0,'2013-07-06 12:44:33',NULL,NULL),(42302,'47598','S','Muren','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(32411,'35967','S','Fort Payne','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.445502,-85.711553,0,'2013-07-06 12:44:32',NULL,NULL),(62618,'74538','S','Phillips','N','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.534003,-96.219571,0,'2013-07-06 12:44:33',NULL,NULL),(33716,'37778','P','Lowland','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.162053,-83.249062,0,'2013-07-06 12:44:32',NULL,NULL),(44287,'49721','S','Cheboygan','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.593079,-84.471635,0,'2013-07-06 12:44:32',NULL,NULL),(50877,'58529','S','Carson','D','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.502100,-101.502900,0,'2013-07-06 12:44:33',NULL,NULL),(72787,'89701','S','Lakeview','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(605,'00680','S','Urb Rio Cristal','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(25075,'27946','S','Hobbsville','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.353318,-76.640451,0,'2013-07-06 12:44:31',NULL,NULL),(7333,'06708','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.552917,-73.066488,0,'2013-07-06 12:44:30',NULL,NULL),(10477,'10950','S','S Bloomng Grv','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.338274,-74.185886,0,'2013-07-06 12:44:30',NULL,NULL),(69599,'83851','S','Plummer','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.341163,-116.878709,0,'2013-07-06 12:44:34',NULL,NULL),(51464,'59524','S','Dodson','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.201646,-108.522788,0,'2013-07-06 12:44:33',NULL,NULL),(4013,'02558','P','Onset','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.747314,-70.660179,0,'2013-07-06 12:44:30',NULL,NULL),(4276,'02891','S','Misquamicut','N','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.362200,-71.796000,0,'2013-07-06 12:44:30',NULL,NULL),(50960,'58623','S','Griffin','N','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.179366,-103.400993,0,'2013-07-06 12:44:33',NULL,NULL),(11594,'12082','P','Grafton','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.768623,-73.447387,0,'2013-07-06 12:44:30',NULL,NULL),(67539,'80260','S','Federal Heights','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(64087,'76150','U','Shared Unique','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.751455,-97.338993,0,'2013-07-06 12:44:34',NULL,NULL),(19718,'20391','S','Washington Navy Yard','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.877045,-76.994981,0,'2013-07-06 12:44:31',NULL,NULL),(17704,'18223','P','Ebervale','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.983094,-75.957942,0,'2013-07-06 12:44:31',NULL,NULL),(54802,'63017','S','Chesterfield','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.647818,-90.545814,0,'2013-07-06 12:44:33',NULL,NULL),(17158,'17812','S','Benfer','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.770100,-77.247271,0,'2013-07-06 12:44:31',NULL,NULL),(16763,'17519','S','Weaverland','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.127373,-76.024073,0,'2013-07-06 12:44:31',NULL,NULL),(32350,'35809','P','Redstone Arsenal','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.730278,-86.586111,0,'2013-07-06 12:44:32',NULL,NULL),(43432,'48476','P','Vernon','D','Shiawassee','26155','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.939227,-84.027904,0,'2013-07-06 12:44:32',NULL,NULL),(79017,'98391','S','Bonney Lk','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(3021,'01088','S','West Hatfield','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.386547,-72.639767,0,'2013-07-06 12:44:30',NULL,NULL),(18278,'19013','S','Chester Township','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(35802,'39759','S','Adaton','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(35825,'39766','S','Steens','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.577565,-88.354769,0,'2013-07-06 12:44:32',NULL,NULL),(59529,'70807','S','Scotlandville','A','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.536692,-91.174565,0,'2013-07-06 12:44:33',NULL,NULL),(75915,'95006','S','Big Basin','N','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.148282,-122.131711,0,'2013-07-06 12:44:34',NULL,NULL),(41262,'46748','S','Huntertown','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.242357,-85.156411,0,'2013-07-06 12:44:32',NULL,NULL),(47665,'54940','S','Tustin','N','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.211350,-88.827485,0,'2013-07-06 12:44:33',NULL,NULL),(54269,'62682','S','San Jose','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.302815,-89.605112,0,'2013-07-06 12:44:33',NULL,NULL),(30173,'33174','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.762543,-80.353593,0,'2013-07-06 12:44:32',NULL,NULL),(30855,'33655','U','Bank of America','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.948815,-82.455581,0,'2013-07-06 12:44:32',NULL,NULL),(65723,'78027','S','Kendalia','D','Kendall','48259','Texas','TX','48','0000','830','Central',-6.0,'Y',29.941569,-98.505910,0,'2013-07-06 12:44:34',NULL,NULL),(36717,'41030','S','Crittenden','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.769713,-84.573036,0,'2013-07-06 12:44:32',NULL,NULL),(4948,'04096','S','Yarmouth','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.796417,-70.180511,0,'2013-07-06 12:44:30',NULL,NULL),(53725,'62246','S','Beaver Creek','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(22871,'24563','S','Hurt','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',37.093845,-79.295074,0,'2013-07-06 12:44:31',NULL,NULL),(56256,'65061','S','Gasconade','A','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.502518,-91.534868,0,'2013-07-06 12:44:33',NULL,NULL),(45310,'50841','S','Brooks','N','Adams','19003','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.004900,-94.742880,0,'2013-07-06 12:44:32',NULL,NULL),(43765,'49023','P','Benton Harbor','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.107543,-86.466051,0,'2013-07-06 12:44:32',NULL,NULL),(63889,'76016','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.689966,-97.191463,0,'2013-07-06 12:44:34',NULL,NULL),(42107,'47464','P','Stinesville','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.299521,-86.647398,0,'2013-07-06 12:44:32',NULL,NULL),(13774,'14143','S','Stafford','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.981048,-78.080897,0,'2013-07-06 12:44:31',NULL,NULL),(24879,'27698','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772821,-78.639812,0,'2013-07-06 12:44:31',NULL,NULL),(75674,'94548','P','Knightsen','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.974007,-121.658741,0,'2013-07-06 12:44:34',NULL,NULL),(61346,'72469','S','Strawberry','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.972820,-91.383900,0,'2013-07-06 12:44:33',NULL,NULL),(68378,'81144','S','Lariat','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.566562,-106.148089,0,'2013-07-06 12:44:34',NULL,NULL),(16634,'17335','U','Direct Brands','N','York','42133','Pennsylvania','PA','42','8840','202','Eastern',-5.0,'Y',39.807895,-76.965786,0,'2013-07-06 12:44:31',NULL,NULL),(5418,'04667','S','Pleasant Pt','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983450,-67.107224,0,'2013-07-06 12:44:30',NULL,NULL),(36598,'40965','S','Middlesborough','N','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.609522,-83.721655,0,'2013-07-06 12:44:32',NULL,NULL),(40623,'46011','S','Woodlawn Hgts','A','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(64694,'76848','S','Hext','D','Menard','48327','Texas','TX','48','0000','325','Central',-6.0,'Y',30.882662,-99.543216,0,'2013-07-06 12:44:34',NULL,NULL),(6881,'06141','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.792221,-72.665323,0,'2013-07-06 12:44:30',NULL,NULL),(48170,'55378','S','Savage','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.763814,-93.350815,0,'2013-07-06 12:44:33',NULL,NULL),(44488,'49913','S','Centennial Heights','N','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.241904,-88.450576,0,'2013-07-06 12:44:32',NULL,NULL),(60431,'71646','S','Berea','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(65735,'78046','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.434650,-99.473074,0,'2013-07-06 12:44:34',NULL,NULL),(4271,'02886','S','Warwick','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.702720,-71.444271,0,'2013-07-06 12:44:30',NULL,NULL),(16251,'17082','S','Turbett','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(62578,'74462','S','Tamaha','N','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.265840,-95.115060,0,'2013-07-06 12:44:33',NULL,NULL),(14914,'15538','S','Fairhope','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.903600,-78.832680,0,'2013-07-06 12:44:31',NULL,NULL),(7652,'07079','S','South Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.746197,-74.260788,0,'2013-07-06 12:44:30',NULL,NULL),(52869,'61336','S','Lake Wildwood','N','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.122586,-89.249640,0,'2013-07-06 12:44:33',NULL,NULL),(32263,'35630','S','North Florence','N','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.819157,-87.658805,0,'2013-07-06 12:44:32',NULL,NULL),(75141,'93560','S','Willow Springs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.863793,-118.257708,0,'2013-07-06 12:44:34',NULL,NULL),(77200,'96362','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(12420,'12943','S','Saint Huberts','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.190442,-73.785574,0,'2013-07-06 12:44:30',NULL,NULL),(76476,'95624','S','Elk Grove','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.435247,-121.279837,0,'2013-07-06 12:44:34',NULL,NULL),(2779,'00976','S','Lomas de Trujillo','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(58355,'68509','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.816704,-96.709171,0,'2013-07-06 12:44:33',NULL,NULL),(61046,'72119','P','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.763985,-92.258586,0,'2013-07-06 12:44:33',NULL,NULL),(61477,'72634','S','Rea Valley','N','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.279343,-92.593895,0,'2013-07-06 12:44:33',NULL,NULL),(21413,'22535','S','Port Royal','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.170649,-77.192640,0,'2013-07-06 12:44:31',NULL,NULL),(64312,'76470','S','Ranger','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.457305,-98.688287,0,'2013-07-06 12:44:34',NULL,NULL),(2674,'00966','S','Villa Verde','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(26629,'29323','S','Chesnee','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.120234,-81.909469,0,'2013-07-06 12:44:31',NULL,NULL),(38884,'44108','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.539143,-81.611674,0,'2013-07-06 12:44:32',NULL,NULL),(36555,'40913','S','Beverly','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.940872,-83.564677,0,'2013-07-06 12:44:32',NULL,NULL),(35833,'39772','S','Bankston','N','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.266100,-89.282520,0,'2013-07-06 12:44:32',NULL,NULL),(8289,'08018','P','Cedar Brook','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.710736,-74.901297,0,'2013-07-06 12:44:30',NULL,NULL),(69707,'84034','S','Callao','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.037817,-113.985828,0,'2013-07-06 12:44:34',NULL,NULL),(52736,'61237','P','Buffalo Pr','A','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.384604,-90.911022,0,'2013-07-06 12:44:33',NULL,NULL),(59499,'70774','S','Saint Amant','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.237841,-90.848047,0,'2013-07-06 12:44:33',NULL,NULL),(70924,'85634','S','Gu Achi','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(77494,'96826','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.294061,-157.826123,0,'2013-07-06 12:44:34',NULL,NULL),(11240,'11757','S','Lindenhurst','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.688951,-73.376317,0,'2013-07-06 12:44:30',NULL,NULL),(75723,'94588','S','Pleasanton','D','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.687222,-121.894449,0,'2013-07-06 12:44:34',NULL,NULL),(76719,'95860','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.608329,-121.381689,0,'2013-07-06 12:44:34',NULL,NULL),(32559,'36114','S','Mafb Gun Annx','A','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.405544,-86.248050,0,'2013-07-06 12:44:32',NULL,NULL),(15676,'16823','S','Wingate','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.938060,-77.721720,0,'2013-07-06 12:44:31',NULL,NULL),(6402,'05735','S','Castleton','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627980,-73.170780,0,'2013-07-06 12:44:30',NULL,NULL),(65412,'77571','S','Morgans Point','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.658283,-95.049187,0,'2013-07-06 12:44:34',NULL,NULL),(53302,'61735','S','Dewitt','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.185739,-88.787860,0,'2013-07-06 12:44:33',NULL,NULL),(35882,'39870','S','Newton','D','Baker','13007','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.321697,-84.458675,0,'2013-07-06 12:44:32',NULL,NULL),(71058,'85754','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.233911,-111.004513,0,'2013-07-06 12:44:34',NULL,NULL),(73407,'91126','U','Cal Tech','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.136757,-118.125896,0,'2013-07-06 12:44:34',NULL,NULL),(10034,'10173','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(37987,'42741','S','Glens Fork','D','Adair','21001','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.000018,-85.247221,0,'2013-07-06 12:44:32',NULL,NULL),(55292,'63501','S','Spring Lake','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(53938,'62417','S','Bridgeport','D','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.710903,-87.758111,0,'2013-07-06 12:44:33',NULL,NULL),(37631,'42157','S','Mount Hermon','D','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.832888,-85.845417,0,'2013-07-06 12:44:32',NULL,NULL),(52481,'60693','U','Bank of America','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.879153,-87.612931,0,'2013-07-06 12:44:33',NULL,NULL),(44303,'49735','S','Treetops','N','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.987952,-84.675724,0,'2013-07-06 12:44:32',NULL,NULL),(38861,'44095','S','Willowick','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.654810,-81.440913,0,'2013-07-06 12:44:32',NULL,NULL),(79996,'99663','P','Seldovia','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.438640,-151.709612,0,'2013-07-06 12:44:34',NULL,NULL),(20279,'20790','U','Capitol Heights PO','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.854641,-76.931528,0,'2013-07-06 12:44:31',NULL,NULL),(35591,'39574','S','Howison','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.600720,-89.112240,0,'2013-07-06 12:44:32',NULL,NULL),(46870,'54101','S','Abrams','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.784427,-88.046008,0,'2013-07-06 12:44:32',NULL,NULL),(35947,'40057','S','Pleasureville','D','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.369196,-85.063919,0,'2013-07-06 12:44:32',NULL,NULL),(45111,'50556','S','Ledyard','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.440882,-94.148411,0,'2013-07-06 12:44:32',NULL,NULL),(42308,'47601','S','Greenbrier','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(72605,'89412','P','Smoke Creek','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',40.651975,-119.355692,0,'2013-07-06 12:44:34',NULL,NULL),(80044,'99703','S','Ft Wainwright','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.821983,-147.635602,0,'2013-07-06 12:44:34',NULL,NULL),(9385,'09844','M','APO','A','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(17046,'17751','S','Cedar Springs','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(58323,'68446','S','Syracuse','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.658087,-96.183226,0,'2013-07-06 12:44:33',NULL,NULL),(47187,'54484','S','Rozellville','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.797647,-90.067948,0,'2013-07-06 12:44:32',NULL,NULL),(43599,'48763','S','Alabaster','A','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.265786,-83.563369,0,'2013-07-06 12:44:32',NULL,NULL),(8469,'08089','S','Chesilhurst','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722580,-74.859000,0,'2013-07-06 12:44:30',NULL,NULL),(24015,'26362','S','Harrisville','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.211147,-81.050312,0,'2013-07-06 12:44:31',NULL,NULL),(74052,'92153','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.567607,-117.083390,0,'2013-07-06 12:44:34',NULL,NULL),(56618,'65584','S','Saint Robert','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.828919,-92.200348,0,'2013-07-06 12:44:33',NULL,NULL),(48611,'55790','S','Tower','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.795868,-92.353874,0,'2013-07-06 12:44:33',NULL,NULL),(31887,'35130','S','W Jefferson','A','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.570865,-87.165507,0,'2013-07-06 12:44:32',NULL,NULL),(30081,'33156','S','Coral Gables','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(30697,'33483','S','Delray Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.463927,-80.062263,0,'2013-07-06 12:44:32',NULL,NULL),(48899,'56121','S','Ceylon','D','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.534586,-94.636503,0,'2013-07-06 12:44:33',NULL,NULL),(36970,'41179','S','Concord','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(46508,'53237','P','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.041809,-87.906837,0,'2013-07-06 12:44:32',NULL,NULL),(56567,'65479','S','Hartshorn','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.293088,-91.699999,0,'2013-07-06 12:44:33',NULL,NULL),(26318,'29044','S','McEntire Air National Guard','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.918360,-80.732160,0,'2013-07-06 12:44:31',NULL,NULL),(35938,'40051','S','New Haven','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.671684,-85.546062,0,'2013-07-06 12:44:32',NULL,NULL),(11140,'11710','S','N Bellmore','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.679031,-73.534402,0,'2013-07-06 12:44:30',NULL,NULL),(42828,'48064','S','Casco Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767640,-82.672380,0,'2013-07-06 12:44:32',NULL,NULL),(63072,'75238','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.878483,-96.709053,0,'2013-07-06 12:44:33',NULL,NULL),(30420,'33326','S','Weston','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(48242,'55422','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.008220,-93.339300,0,'2013-07-06 12:44:33',NULL,NULL),(4568,'03468','P','W Peterborough','N','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871737,-71.969706,0,'2013-07-06 12:44:30',NULL,NULL),(19526,'20187','S','New Baltimore','A','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.722482,-77.719815,0,'2013-07-06 12:44:31',NULL,NULL),(63065,'75233','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.702691,-96.877091,0,'2013-07-06 12:44:33',NULL,NULL),(73246,'90702','P','Artesia','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.863402,-118.082521,0,'2013-07-06 12:44:34',NULL,NULL),(50638,'58282','S','Walhalla','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.916140,-97.891560,0,'2013-07-06 12:44:33',NULL,NULL),(41759,'47302','S','Hyde Park','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(9325,'09737','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(44671,'50116','S','Hamilton','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.176154,-92.929975,0,'2013-07-06 12:44:32',NULL,NULL),(726,'00687','S','Urb Rose Valley','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(41444,'46867','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.069068,-85.165857,0,'2013-07-06 12:44:32',NULL,NULL),(28034,'30643','S','Hartwell','D','Hart','13147','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.358844,-82.922270,0,'2013-07-06 12:44:31',NULL,NULL),(63784,'75956','S','Bleakwood','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(15561,'16637','S','East Freedom','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.335097,-78.432871,0,'2013-07-06 12:44:31',NULL,NULL),(65522,'77710','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.068870,-94.099348,0,'2013-07-06 12:44:34',NULL,NULL),(49412,'56629','P','Birchdale','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.564892,-94.239618,0,'2013-07-06 12:44:33',NULL,NULL),(36179,'40245','S','Worthngtn Hls','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.264541,-85.495953,0,'2013-07-06 12:44:32',NULL,NULL),(36063,'40207','S','Riverwood','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(30194,'33179','S','North Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.954530,-80.183568,0,'2013-07-06 12:44:32',NULL,NULL),(25250,'28110','S','Unionville','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.010982,-80.551224,0,'2013-07-06 12:44:31',NULL,NULL),(9164,'09339','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4565,'03466','S','West Chesterfield','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871118,-72.516627,0,'2013-07-06 12:44:30',NULL,NULL),(23794,'26003','S','Wheeling','D','Ohio','54069','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',40.069414,-80.687797,0,'2013-07-06 12:44:31',NULL,NULL),(63390,'75644','S','Simmonsville','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(52448,'60669','U','Div of Postal Inspectors','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875708,-87.650623,0,'2013-07-06 12:44:33',NULL,NULL),(51973,'60147','P','Lafox','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.884161,-88.432446,0,'2013-07-06 12:44:33',NULL,NULL),(46887,'54114','S','Middle Inlet','A','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.293210,-87.992690,0,'2013-07-06 12:44:32',NULL,NULL),(47865,'55082','S','Grant Township','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(77661,'97023','S','Estacada','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.280759,-122.313251,0,'2013-07-06 12:44:34',NULL,NULL),(42512,'47848','S','Gambill','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.064996,-87.253689,0,'2013-07-06 12:44:32',NULL,NULL),(73785,'91745','S','La Puente','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.998974,-117.965163,0,'2013-07-06 12:44:34',NULL,NULL),(67238,'79936','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.786132,-106.260892,0,'2013-07-06 12:44:34',NULL,NULL),(60781,'72022','S','Benton','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.598058,-92.488227,0,'2013-07-06 12:44:33',NULL,NULL),(50824,'58472','S','Adrian','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.666944,-98.759167,0,'2013-07-06 12:44:33',NULL,NULL),(8518,'08105','S','East Camden','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.948670,-75.087161,0,'2013-07-06 12:44:30',NULL,NULL),(42124,'47471','S','Worthington','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.118499,-86.979363,0,'2013-07-06 12:44:32',NULL,NULL),(76072,'95206','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.918977,-121.312883,0,'2013-07-06 12:44:34',NULL,NULL),(56695,'65657','S','Garrison','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.855073,-92.987344,0,'2013-07-06 12:44:33',NULL,NULL),(44986,'50431','P','Coulter','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.735954,-93.368072,0,'2013-07-06 12:44:32',NULL,NULL),(29272,'32460','S','Sneads','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.714280,-84.930687,0,'2013-07-06 12:44:32',NULL,NULL),(6308,'05660','S','N Fayston','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.252162,-72.748572,0,'2013-07-06 12:44:30',NULL,NULL),(77440,'96807','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.306339,-157.861146,0,'2013-07-06 12:44:34',NULL,NULL),(18245,'18980','P','Wycombe','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.274000,-75.020597,0,'2013-07-06 12:44:31',NULL,NULL),(4236,'02861','S','Darlington','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.881170,-71.355799,0,'2013-07-06 12:44:30',NULL,NULL),(71060,'85755','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.448600,-110.964800,0,'2013-07-06 12:44:34',NULL,NULL),(64403,'76542','S','Youngsport','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.046520,-97.723800,0,'2013-07-06 12:44:34',NULL,NULL),(63046,'75215','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.750302,-96.761227,0,'2013-07-06 12:44:33',NULL,NULL),(75540,'94229','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587116,-121.495126,0,'2013-07-06 12:44:34',NULL,NULL),(23894,'26181','S','Washington','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.244260,-81.639000,0,'2013-07-06 12:44:31',NULL,NULL),(24767,'27551','S','Macon','D','Warren','37185','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.434413,-78.002225,0,'2013-07-06 12:44:31',NULL,NULL),(28501,'31525','S','Brunswick','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.233616,-81.501727,0,'2013-07-06 12:44:32',NULL,NULL),(75355,'93920','S','Lucia','N','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.135880,-121.659477,0,'2013-07-06 12:44:34',NULL,NULL),(79184,'98527','P','Bay Center','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639753,-123.939226,0,'2013-07-06 12:44:34',NULL,NULL),(2365,'00949','S','Mans del Norte','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(19143,'19702','S','Christiana','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.604610,-75.746270,0,'2013-07-06 12:44:31',NULL,NULL),(51079,'58761','S','Loraine','A','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.763084,-101.524319,0,'2013-07-06 12:44:33',NULL,NULL),(77727,'97067','S','Welches','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.339237,-121.965273,0,'2013-07-06 12:44:34',NULL,NULL),(33969,'38108','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.180649,-89.954309,0,'2013-07-06 12:44:32',NULL,NULL),(31301,'34095','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(14659,'15238','S','Blawnox','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.530285,-79.876419,0,'2013-07-06 12:44:31',NULL,NULL),(40271,'45433','S','Wright Patter','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.791449,-84.068804,0,'2013-07-06 12:44:32',NULL,NULL),(48461,'55713','P','Great Scott','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.493443,-92.773072,0,'2013-07-06 12:44:33',NULL,NULL),(17893,'18445','S','Newfoundland','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.289870,-75.399598,0,'2013-07-06 12:44:31',NULL,NULL),(41780,'47304','S','Westport Addn','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(10177,'10282','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(57623,'67135','S','Sedgwick','D','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.894180,-97.438249,0,'2013-07-06 12:44:33',NULL,NULL),(48108,'55348','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.007501,-93.655707,0,'2013-07-06 12:44:33',NULL,NULL),(14285,'14864','S','Millport','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.267100,-76.840236,0,'2013-07-06 12:44:31',NULL,NULL),(24431,'27199','U','Winston Salem Brm','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.099201,-80.249323,0,'2013-07-06 12:44:31',NULL,NULL),(32031,'35243','S','Cahaba Heights','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(71342,'86511','P','Two Story','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.853888,-109.299177,0,'2013-07-06 12:44:34',NULL,NULL),(72444,'89103','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.114166,-115.215839,0,'2013-07-06 12:44:34',NULL,NULL),(58322,'68445','S','Swanton','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.392864,-97.086327,0,'2013-07-06 12:44:33',NULL,NULL),(2934,'01027','S','E Hampton','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.291420,-72.717720,0,'2013-07-06 12:44:30',NULL,NULL),(25226,'28090','S','Lawndale','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.465460,-81.532440,0,'2013-07-06 12:44:31',NULL,NULL),(50726,'58380','S','Tolna','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.790000,-98.506800,0,'2013-07-06 12:44:33',NULL,NULL),(75350,'93908','S','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.603909,-121.654754,0,'2013-07-06 12:44:34',NULL,NULL),(68110,'80946','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.847888,-104.824771,0,'2013-07-06 12:44:34',NULL,NULL),(52075,'60401','S','Beecher','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.355724,-87.607332,0,'2013-07-06 12:44:33',NULL,NULL),(4958,'04105','S','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.743978,-70.281854,0,'2013-07-06 12:44:30',NULL,NULL),(20161,'20740','S','North College Park','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998722,-76.928721,0,'2013-07-06 12:44:31',NULL,NULL),(14559,'15214','S','Observatory','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.481784,-80.018549,0,'2013-07-06 12:44:31',NULL,NULL),(58072,'68059','S','Richfield','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.068450,-96.150271,0,'2013-07-06 12:44:33',NULL,NULL),(28050,'30666','S','Statham','D','Barrow','13013','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.967529,-83.596167,0,'2013-07-06 12:44:31',NULL,NULL),(36318,'40380','S','Patsey','A','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.851590,-83.854413,0,'2013-07-06 12:44:32',NULL,NULL),(42096,'47460','S','Hts Crnr','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(1210,'00728','S','Sect Las Batatas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(45685,'52045','S','Bankston','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.440820,-90.928680,0,'2013-07-06 12:44:32',NULL,NULL),(48500,'55736','S','Cedar Valley','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.891020,-92.918520,0,'2013-07-06 12:44:33',NULL,NULL),(64646,'76714','P','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.528528,-97.194540,0,'2013-07-06 12:44:34',NULL,NULL),(26570,'29212','S','Harbison','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.081140,-81.194940,0,'2013-07-06 12:44:31',NULL,NULL),(65713,'78017','S','Dilley','D','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',28.689120,-99.196560,0,'2013-07-06 12:44:34',NULL,NULL),(62865,'75032','S','Rockwall','D','Rockwall','48397','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.869410,-96.408950,0,'2013-07-06 12:44:33',NULL,NULL),(60875,'72061','S','Guy','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.320292,-92.327885,0,'2013-07-06 12:44:33',NULL,NULL),(60332,'71463','S','Beaver','N','Allen','22003','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.817482,-92.658202,0,'2013-07-06 12:44:33',NULL,NULL),(54862,'63048','S','Herculaneum','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.265637,-90.384048,0,'2013-07-06 12:44:33',NULL,NULL),(77729,'97068','S','W Linn','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.366874,-122.650360,0,'2013-07-06 12:44:34',NULL,NULL),(76885,'95978','P','Stirling City','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.954990,-121.512036,0,'2013-07-06 12:44:34',NULL,NULL),(75037,'93514','S','Chalfant Vly','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(67358,'80111','S','Cherry Hl Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(65917,'78238','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.479990,-98.610330,0,'2013-07-06 12:44:34',NULL,NULL),(55565,'63869','S','Howardville','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.594000,-89.558640,0,'2013-07-06 12:44:33',NULL,NULL),(47450,'54729','S','Chippewa Falls','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(10117,'10259','U','New York City','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(20893,'21705','P','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.412463,-77.407380,0,'2013-07-06 12:44:31',NULL,NULL),(44821,'50246','S','Stanhope','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.285678,-93.791679,0,'2013-07-06 12:44:32',NULL,NULL),(7402,'06793','S','Washington Depot','A','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.640788,-73.293104,0,'2013-07-06 12:44:30',NULL,NULL),(31905,'35148','S','Gravleeton','N','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.753152,-87.050730,0,'2013-07-06 12:44:32',NULL,NULL),(76695,'95825','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.592979,-121.403108,0,'2013-07-06 12:44:34',NULL,NULL),(65999,'78343','S','Bishop','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.585618,-97.797045,0,'2013-07-06 12:44:34',NULL,NULL),(40065,'45273','U','Business Reply','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.101063,-84.514066,0,'2013-07-06 12:44:32',NULL,NULL),(59698,'71080','P','Taylor','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.501239,-93.072806,0,'2013-07-06 12:44:33',NULL,NULL),(34539,'38701','S','Swiftwater','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.288780,-90.990720,0,'2013-07-06 12:44:32',NULL,NULL),(53137,'61552','P','Mossville','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.816227,-89.565188,0,'2013-07-06 12:44:33',NULL,NULL),(29714,'32950','S','Malabar','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.985689,-80.589258,0,'2013-07-06 12:44:32',NULL,NULL),(3966,'02492','S','Needham Jct','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.276004,-71.243064,0,'2013-07-06 12:44:30',NULL,NULL),(22424,'24008','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271345,-79.944351,0,'2013-07-06 12:44:31',NULL,NULL),(47714,'55003','S','Douglas','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.014760,-92.781480,0,'2013-07-06 12:44:33',NULL,NULL),(13541,'13827','S','Owego','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(63570,'75771','S','Thedford','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.514723,-95.430859,0,'2013-07-06 12:44:34',NULL,NULL),(66638,'78834','S','Brundage','N','Dimmit','48127','Texas','TX','48','0000','830','Central',-6.0,'Y',28.520700,-99.888480,0,'2013-07-06 12:44:34',NULL,NULL),(4356,'03053','S','Londonderry','D','Rockingham','33015','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.867120,-71.377586,0,'2013-07-06 12:44:30',NULL,NULL),(60026,'71342','S','Nebo','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(59336,'70542','S','Gueydan','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.025500,-92.510120,0,'2013-07-06 12:44:33',NULL,NULL),(13101,'13478','S','Verona','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.153620,-75.586020,0,'2013-07-06 12:44:30',NULL,NULL),(34290,'38501','S','Cookeville','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.199620,-85.522740,0,'2013-07-06 12:44:32',NULL,NULL),(69061,'83236','S','Firth','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.286660,-112.129557,0,'2013-07-06 12:44:34',NULL,NULL),(9196,'09421','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(53486,'61953','S','Tuscola','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.796141,-88.282209,0,'2013-07-06 12:44:33',NULL,NULL),(30914,'33707','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(7610,'07051','P','Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.770586,-74.239153,0,'2013-07-06 12:44:30',NULL,NULL),(35357,'39440','S','Pendorff','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(69517,'83722','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.614327,-116.216254,0,'2013-07-06 12:44:34',NULL,NULL),(9509,'10016','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(29286,'32503','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.452842,-87.211049,0,'2013-07-06 12:44:32',NULL,NULL),(51311,'59241','S','Hinsdale','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.393109,-107.084294,0,'2013-07-06 12:44:33',NULL,NULL),(66341,'78606','S','Blanco','D','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.106568,-98.420607,0,'2013-07-06 12:44:34',NULL,NULL),(2938,'01027','S','Westhampton','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.291420,-72.717720,0,'2013-07-06 12:44:30',NULL,NULL),(20418,'20906','S','Wheaton','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(26573,'29215','U','Bell South','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.026843,-81.001189,0,'2013-07-06 12:44:31',NULL,NULL),(53993,'62442','S','Moonshine','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.330353,-87.886995,0,'2013-07-06 12:44:33',NULL,NULL),(40145,'45346','S','New Madison','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.982307,-84.713975,0,'2013-07-06 12:44:32',NULL,NULL),(74567,'92684','P','Westminster','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.762656,-118.007203,0,'2013-07-06 12:44:34',NULL,NULL),(19125,'19608','S','Sinking Spg','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(58066,'68048','S','Plattsmouth','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.011668,-95.889911,0,'2013-07-06 12:44:33',NULL,NULL),(68803,'82430','P','Worland','A','Hot Springs','56017','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.804158,-108.174567,0,'2013-07-06 12:44:34',NULL,NULL),(54382,'62814','S','Bluford','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.438972,-88.714863,0,'2013-07-06 12:44:33',NULL,NULL),(10459,'10926','S','Harriman','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.307707,-74.150676,0,'2013-07-06 12:44:30',NULL,NULL),(3199,'01350','P','Monroe','A','Franklin','25011','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.716667,-72.983333,0,'2013-07-06 12:44:30',NULL,NULL),(79,'00612','S','Jard de Arecibo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(64794,'77015','S','Greens Bayou','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770126,-95.173187,0,'2013-07-06 12:44:34',NULL,NULL),(62382,'74078','U','STW','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.115627,-97.058038,0,'2013-07-06 12:44:33',NULL,NULL),(59654,'71048','S','Holsey','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.842916,-92.857990,0,'2013-07-06 12:44:33',NULL,NULL),(2828,'00979','S','Urb Palmar Sur','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(31946,'35206','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.567997,-86.720742,0,'2013-07-06 12:44:32',NULL,NULL),(47673,'54947','S','Larsen','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.195234,-88.695873,0,'2013-07-06 12:44:33',NULL,NULL),(44283,'49717','P','Burt Lake','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.435582,-84.696901,0,'2013-07-06 12:44:32',NULL,NULL),(33768,'37864','P','Sevierville','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.856862,-83.577319,0,'2013-07-06 12:44:32',NULL,NULL),(32220,'35572','S','Houston','D','Winston','01133','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.280278,-87.319444,0,'2013-07-06 12:44:32',NULL,NULL),(56120,'64804','S','Loma Linda','A','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.064704,-94.509874,0,'2013-07-06 12:44:33',NULL,NULL),(61237,'72336','P','Forrest City','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.013162,-90.785455,0,'2013-07-06 12:44:33',NULL,NULL),(53305,'61737','S','Dawson Township','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.446184,-88.718903,0,'2013-07-06 12:44:33',NULL,NULL),(18457,'19080','U','Firm Zip Concept (Brm)','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041159,-75.388173,0,'2013-07-06 12:44:31',NULL,NULL),(50460,'58031','S','Fingal','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.761371,-97.791535,0,'2013-07-06 12:44:33',NULL,NULL),(38917,'44120','S','Shaker Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472129,-81.578028,0,'2013-07-06 12:44:32',NULL,NULL),(3318,'01524','S','Leicester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.232557,-71.918280,0,'2013-07-06 12:44:30',NULL,NULL),(10238,'10467','S','Allerton','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.873256,-73.870576,0,'2013-07-06 12:44:30',NULL,NULL),(12524,'13032','S','South Bay','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083843,-75.768034,0,'2013-07-06 12:44:30',NULL,NULL),(20451,'21015','S','Bel Air','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.535341,-76.289260,0,'2013-07-06 12:44:31',NULL,NULL),(75823,'94903','S','San Rafael','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.013354,-122.548797,0,'2013-07-06 12:44:34',NULL,NULL),(79494,'98903','S','Fairview','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.561980,-120.667800,0,'2013-07-06 12:44:34',NULL,NULL),(68003,'80921','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047737,-104.816446,0,'2013-07-06 12:44:34',NULL,NULL),(11104,'11697','S','Rockaway Pt','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.556389,-73.926667,0,'2013-07-06 12:44:30',NULL,NULL),(21946,'23232','S','Richmond Main','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.560246,-77.447422,0,'2013-07-06 12:44:31',NULL,NULL),(63822,'75972','S','San Augustine','D','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(41254,'46745','S','Hoagland','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.949213,-85.004562,0,'2013-07-06 12:44:32',NULL,NULL),(68695,'82052','S','Buford','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.111872,-105.308655,0,'2013-07-06 12:44:34',NULL,NULL),(37106,'41360','S','Pine Ridge','D','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.769383,-83.626315,0,'2013-07-06 12:44:32',NULL,NULL),(14364,'15022','S','N Charleroi','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.134660,-79.916040,0,'2013-07-06 12:44:31',NULL,NULL),(9430,'10003','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(72087,'88201','S','Border Hill','A','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.393099,-104.522917,0,'2013-07-06 12:44:34',NULL,NULL),(26245,'28902','S','Brasstown','D','Clay','37043','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.043243,-83.937634,0,'2013-07-06 12:44:31',NULL,NULL),(30989,'33762','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.895316,-82.677117,0,'2013-07-06 12:44:32',NULL,NULL),(644,'00682','S','Urb Miradero Gdns','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(66659,'78861','S','Dunlay','A','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.356920,-99.101580,0,'2013-07-06 12:44:34',NULL,NULL),(58307,'68433','S','Salem','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.043233,-95.726489,0,'2013-07-06 12:44:33',NULL,NULL),(57943,'67741','S','Kanorado','D','Sherman','20181','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',39.339102,-102.036209,0,'2013-07-06 12:44:33',NULL,NULL),(53574,'62059','P','Stites','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.656184,-90.166082,0,'2013-07-06 12:44:33',NULL,NULL),(3768,'02189','S','East Weymouth','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.213831,-70.932791,0,'2013-07-06 12:44:30',NULL,NULL),(40754,'46143','S','Greenwood','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.601573,-86.133793,0,'2013-07-06 12:44:32',NULL,NULL),(40217,'45409','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.724144,-84.183354,0,'2013-07-06 12:44:32',NULL,NULL),(25578,'28435','S','Currie','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.410005,-78.101347,0,'2013-07-06 12:44:31',NULL,NULL),(73206,'90606','S','Los Nietos','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.980225,-118.066303,0,'2013-07-06 12:44:34',NULL,NULL),(21439,'22572','S','Nomini Grove','N','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.957415,-76.762507,0,'2013-07-06 12:44:31',NULL,NULL),(47953,'55118','S','W St Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(46004,'52533','S','Batavia','D','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.997808,-92.159295,0,'2013-07-06 12:44:32',NULL,NULL),(35483,'39521','P','Bay St Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.329135,-89.370668,0,'2013-07-06 12:44:32',NULL,NULL),(50991,'58649','S','Reeder','D','Adams','38001','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.113167,-102.932725,0,'2013-07-06 12:44:33',NULL,NULL),(60103,'71362','S','Bodoc','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.920973,-91.990157,0,'2013-07-06 12:44:33',NULL,NULL),(32261,'35622','S','Falkville','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.381767,-86.903816,0,'2013-07-06 12:44:32',NULL,NULL),(51520,'59707','U','Northwestern Energy','N','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.005208,-112.534930,0,'2013-07-06 12:44:33',NULL,NULL),(27236,'29922','S','Brighton','N','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.601990,-81.241810,0,'2013-07-06 12:44:31',NULL,NULL),(55756,'64113','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.012892,-94.596815,0,'2013-07-06 12:44:33',NULL,NULL),(12061,'12537','P','Hughsonville','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.583149,-73.927217,0,'2013-07-06 12:44:30',NULL,NULL),(20664,'21226','S','Stoney Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(56796,'65761','S','Theodosia','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.577980,-92.706780,0,'2013-07-06 12:44:33',NULL,NULL),(30541,'33409','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.708576,-80.096654,0,'2013-07-06 12:44:32',NULL,NULL),(38759,'44040','S','Mayfield Village','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.527765,-81.412458,0,'2013-07-06 12:44:32',NULL,NULL),(39685,'45030','S','Crosby','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.251160,-84.739620,0,'2013-07-06 12:44:32',NULL,NULL),(39306,'44511','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.071321,-80.698827,0,'2013-07-06 12:44:32',NULL,NULL),(78197,'97734','S','Culver','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.509523,-121.212150,0,'2013-07-06 12:44:34',NULL,NULL),(2426,'00953','S','Terr del Toa','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(52360,'60611','S','Fort Dearborn','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.894244,-87.622841,0,'2013-07-06 12:44:33',NULL,NULL),(43407,'48455','S','Metamora','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.941257,-83.308589,0,'2013-07-06 12:44:32',NULL,NULL),(5831,'05081','S','Wells River','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157600,-72.069600,0,'2013-07-06 12:44:30',NULL,NULL),(79738,'99219','P','Sunset Hill','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.629754,-117.542356,0,'2013-07-06 12:44:34',NULL,NULL),(27984,'30573','P','Tallulah Falls','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.726029,-83.382319,0,'2013-07-06 12:44:31',NULL,NULL),(15512,'16515','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.107601,-79.956036,0,'2013-07-06 12:44:31',NULL,NULL),(17095,'17765','S','McNett','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(45375,'51016','S','Correctionville','D','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.478073,-95.782566,0,'2013-07-06 12:44:32',NULL,NULL),(18743,'19340','U','State Farm Insurance','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.886723,-75.518894,0,'2013-07-06 12:44:31',NULL,NULL),(2126,'00924','S','Parc Falu','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(72309,'88590','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770296,-106.426337,0,'2013-07-06 12:44:34',NULL,NULL),(29896,'33043','S','Summrlnd Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.678501,-81.368387,0,'2013-07-06 12:44:32',NULL,NULL),(37498,'42029','S','Calvert City','D','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.019627,-88.347552,0,'2013-07-06 12:44:32',NULL,NULL),(5801,'05062','S','Reading','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.494300,-72.584520,0,'2013-07-06 12:44:30',NULL,NULL),(8145,'07843','S','Hopatcong','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.941320,-74.668755,0,'2013-07-06 12:44:30',NULL,NULL),(29296,'32511','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.396956,-87.352515,0,'2013-07-06 12:44:32',NULL,NULL),(71573,'87305','P','Gallup','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.469202,-108.819415,0,'2013-07-06 12:44:34',NULL,NULL),(68462,'81233','S','Howard','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.426401,-105.833365,0,'2013-07-06 12:44:34',NULL,NULL),(70690,'85256','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.525852,-111.785406,0,'2013-07-06 12:44:34',NULL,NULL),(40510,'45814','S','Arlington','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.901358,-83.630699,0,'2013-07-06 12:44:32',NULL,NULL),(60574,'71765','S','Strong','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.209097,-92.443857,0,'2013-07-06 12:44:33',NULL,NULL),(22583,'24162','S','Shawsville','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.140086,-80.324560,0,'2013-07-06 12:44:31',NULL,NULL),(43820,'49080','S','Plainwell','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.456287,-85.628925,0,'2013-07-06 12:44:32',NULL,NULL),(42007,'47429','S','Ellettsville','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.247016,-86.620515,0,'2013-07-06 12:44:32',NULL,NULL),(51081,'58762','S','Newberg','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.687180,-100.942800,0,'2013-07-06 12:44:33',NULL,NULL),(27922,'30514','P','Blairsville','D','Union','13291','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.876134,-83.952809,0,'2013-07-06 12:44:31',NULL,NULL),(11447,'11977','S','West Hampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.819853,-72.666788,0,'2013-07-06 12:44:30',NULL,NULL),(21959,'23236','S','North Chesterfield','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.478368,-77.582532,0,'2013-07-06 12:44:31',NULL,NULL),(49588,'56740','S','Noyes','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.977594,-97.142343,0,'2013-07-06 12:44:33',NULL,NULL),(18684,'19187','U','A A R P Ins','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954771,-75.167691,0,'2013-07-06 12:44:31',NULL,NULL),(70770,'85339','S','Laveen','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.350644,-112.198727,0,'2013-07-06 12:44:34',NULL,NULL),(22367,'23917','S','Palmersprings','N','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.655688,-78.378914,0,'2013-07-06 12:44:31',NULL,NULL),(27410,'30095','P','Duluth','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.977522,-84.148704,0,'2013-07-06 12:44:31',NULL,NULL),(73653,'91501','S','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.188758,-118.296041,0,'2013-07-06 12:44:34',NULL,NULL),(4136,'02748','S','Nonquitt','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.598019,-70.954047,0,'2013-07-06 12:44:30',NULL,NULL),(32005,'35228','S','Midfield','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.500280,-86.917620,0,'2013-07-06 12:44:32',NULL,NULL),(44440,'49855','S','Marquette','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.550000,-87.400000,0,'2013-07-06 12:44:32',NULL,NULL),(47453,'54729','S','Hallie','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.031667,-91.395833,0,'2013-07-06 12:44:32',NULL,NULL),(20269,'20785','S','Landover','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(19852,'20511','U','Dir National Intelligence','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.840700,-77.016700,0,'2013-07-06 12:44:31',NULL,NULL),(57419,'66775','S','Stark','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.688022,-95.127942,0,'2013-07-06 12:44:33',NULL,NULL),(19224,'19897','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.798051,-75.545651,0,'2013-07-06 12:44:31',NULL,NULL),(17771,'18337','S','Milford','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.325855,-74.801827,0,'2013-07-06 12:44:31',NULL,NULL),(16918,'17602','S','Zooks Corner','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(76058,'95194','U','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.343655,-121.881178,0,'2013-07-06 12:44:34',NULL,NULL),(77980,'97388','P','Gleneden Bch','A','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.884662,-124.031114,0,'2013-07-06 12:44:34',NULL,NULL),(8618,'08246','P','South Seaville','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.176868,-74.761084,0,'2013-07-06 12:44:30',NULL,NULL),(43811,'49071','S','Mattawan','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.234495,-85.791411,0,'2013-07-06 12:44:32',NULL,NULL),(48901,'56123','S','Currie','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.041029,-95.435345,0,'2013-07-06 12:44:33',NULL,NULL),(4741,'03837','S','Gilmanton Iron Works','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.431240,-71.299440,0,'2013-07-06 12:44:30',NULL,NULL),(42104,'47462','S','Popcorn','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003349,-86.589842,0,'2013-07-06 12:44:32',NULL,NULL),(53975,'62438','S','Lakewood','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.313558,-88.860318,0,'2013-07-06 12:44:33',NULL,NULL),(58402,'68632','S','Octavia','A','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.243121,-97.131923,0,'2013-07-06 12:44:33',NULL,NULL),(60904,'72076','S','Air Base','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(15980,'17033','S','Bachmanville','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(66825,'79095','S','Wellington','D','Collingsworth','48087','Texas','TX','48','0000','806','Central',-6.0,'Y',34.851051,-100.214468,0,'2013-07-06 12:44:34',NULL,NULL),(58617,'68859','S','Enterprise','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.466866,-98.705890,0,'2013-07-06 12:44:33',NULL,NULL),(55153,'63365','P','New Melle','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.711202,-90.880752,0,'2013-07-06 12:44:33',NULL,NULL),(37983,'42732','S','Meeting Creek','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.606912,-86.114062,0,'2013-07-06 12:44:32',NULL,NULL),(74647,'92831','S','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.887306,-117.894628,0,'2013-07-06 12:44:34',NULL,NULL),(79701,'99208','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.738148,-117.446326,0,'2013-07-06 12:44:34',NULL,NULL),(3963,'02481','S','Wellesley Hls','A','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.316214,-71.265402,0,'2013-07-06 12:44:30',NULL,NULL),(37594,'42120','S','Adolphus','D','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.668405,-86.276025,0,'2013-07-06 12:44:32',NULL,NULL),(58842,'69130','S','Cozad','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.861917,-99.983057,0,'2013-07-06 12:44:33',NULL,NULL),(58141,'68152','S','Florence','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.341128,-95.998908,0,'2013-07-06 12:44:33',NULL,NULL),(79811,'99502','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.149085,-149.942780,0,'2013-07-06 12:44:34',NULL,NULL),(4126,'02743','S','Acushnet','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.711280,-70.909680,0,'2013-07-06 12:44:30',NULL,NULL),(37322,'41653','S','Cliff','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(35420,'39470','S','Derby','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(37984,'42732','S','Summit','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.606912,-86.114062,0,'2013-07-06 12:44:32',NULL,NULL),(68739,'82212','S','Fort Laramie','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.212319,-104.514555,0,'2013-07-06 12:44:34',NULL,NULL),(43186,'48301','S','Bloomfld Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(44752,'50171','S','Ewart','N','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.584863,-92.525294,0,'2013-07-06 12:44:32',NULL,NULL),(56806,'65771','S','Walnut Shade','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.767530,-93.228332,0,'2013-07-06 12:44:33',NULL,NULL),(71757,'87549','S','Ojo Caliente','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.303317,-106.044584,0,'2013-07-06 12:44:34',NULL,NULL),(73324,'90835','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.769489,-118.200353,0,'2013-07-06 12:44:34',NULL,NULL),(60064,'71353','S','Goodwood','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(74868,'93262','S','Seq Natl Pk','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.595201,-118.840408,0,'2013-07-06 12:44:34',NULL,NULL),(30868,'33664','U','Time Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.967760,-82.518250,0,'2013-07-06 12:44:32',NULL,NULL),(9338,'09752','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60344,'71467','S','Fishville','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498140,-92.421420,0,'2013-07-06 12:44:33',NULL,NULL),(60189,'71418','S','Bellview','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(24257,'26810','S','Lost River','A','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.907535,-78.801085,0,'2013-07-06 12:44:31',NULL,NULL),(49365,'56583','S','Tintah','D','Traverse','27155','Minnesota','MN','27','0000','218','Central',-6.0,'Y',45.986280,-96.405780,0,'2013-07-06 12:44:33',NULL,NULL),(4385,'03105','P','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.967657,-71.417481,0,'2013-07-06 12:44:30',NULL,NULL),(26575,'29216','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.997822,-81.036511,0,'2013-07-06 12:44:31',NULL,NULL),(33053,'36756','S','Marion','D','Perry','01105','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.674170,-87.223090,0,'2013-07-06 12:44:32',NULL,NULL),(46442,'53208','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.048166,-87.964638,0,'2013-07-06 12:44:32',NULL,NULL),(34556,'38725','S','Grapeland','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(76687,'95818','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.560217,-121.494112,0,'2013-07-06 12:44:34',NULL,NULL),(62283,'74017','S','Tiawah','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.343020,-95.596680,0,'2013-07-06 12:44:33',NULL,NULL),(68829,'82512','S','Crowheart','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.379445,-109.188086,0,'2013-07-06 12:44:34',NULL,NULL),(75138,'93560','S','Rosamond','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.863793,-118.257708,0,'2013-07-06 12:44:34',NULL,NULL),(51734,'60013','S','Cary','D','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.219192,-88.239708,0,'2013-07-06 12:44:33',NULL,NULL),(15633,'16725','P','Custer City','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.905132,-78.650729,0,'2013-07-06 12:44:31',NULL,NULL),(14304,'14883','S','Spencer','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.251460,-76.480800,0,'2013-07-06 12:44:31',NULL,NULL),(7393,'06786','S','Terryville','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.676470,-73.008551,0,'2013-07-06 12:44:30',NULL,NULL),(79406,'98812','S','Rocky Butte','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.167400,-119.790720,0,'2013-07-06 12:44:34',NULL,NULL),(65724,'78028','S','Kerrville','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',30.038845,-99.151308,0,'2013-07-06 12:44:34',NULL,NULL),(10009,'10168','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(74505,'92630','S','El Toro','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.645780,-117.669120,0,'2013-07-06 12:44:34',NULL,NULL),(71618,'87347','P','Contnental Dv','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432459,-108.729828,0,'2013-07-06 12:44:34',NULL,NULL),(16353,'17177','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.290362,-76.812588,0,'2013-07-06 12:44:31',NULL,NULL),(47720,'55006','S','Day','N','Isanti','27059','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.724622,-93.172881,0,'2013-07-06 12:44:33',NULL,NULL),(12012,'12502','S','Ancram','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.107220,-73.679520,0,'2013-07-06 12:44:30',NULL,NULL),(46225,'52773','S','Maysville','A','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.636460,-90.758940,0,'2013-07-06 12:44:32',NULL,NULL),(38114,'43107','S','Bremen','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.696084,-82.422138,0,'2013-07-06 12:44:32',NULL,NULL),(8009,'07722','S','Colts Neck','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.309639,-74.182060,0,'2013-07-06 12:44:30',NULL,NULL),(31110,'33885','P','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.053367,-81.712064,0,'2013-07-06 12:44:32',NULL,NULL),(73555,'91361','S','Westlake Village','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.152136,-118.846704,0,'2013-07-06 12:44:34',NULL,NULL),(12286,'12844','S','Pilot Knob','A','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.515833,-73.629722,0,'2013-07-06 12:44:30',NULL,NULL),(22365,'23917','S','Boydton','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.655688,-78.378914,0,'2013-07-06 12:44:31',NULL,NULL),(44700,'50135','S','Kellogg','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.731036,-92.920132,0,'2013-07-06 12:44:32',NULL,NULL),(32888,'36530','S','Perdido Beach','A','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.405780,-87.586380,0,'2013-07-06 12:44:32',NULL,NULL),(6715,'06067','S','Rocky Hill','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.662537,-72.668832,0,'2013-07-06 12:44:30',NULL,NULL),(26895,'29574','S','Mullins','D','Marion','45067','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.203923,-79.256820,0,'2013-07-06 12:44:31',NULL,NULL),(56503,'65340','S','Napton','A','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.114311,-93.196522,0,'2013-07-06 12:44:33',NULL,NULL),(33308,'37132','U','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.850303,-86.361672,0,'2013-07-06 12:44:32',NULL,NULL),(13803,'14207','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.945566,-78.896412,0,'2013-07-06 12:44:31',NULL,NULL),(61424,'72569','S','Poughkeepsie','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.083169,-91.437209,0,'2013-07-06 12:44:33',NULL,NULL),(27025,'29648','P','Gwd','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.189151,-82.156129,0,'2013-07-06 12:44:31',NULL,NULL),(20200,'20754','S','Dunkirk','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.730532,-76.656015,0,'2013-07-06 12:44:31',NULL,NULL),(1883,'00791','S','Urb San Antonio','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(29252,'32446','S','Marianna','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.776351,-85.229988,0,'2013-07-06 12:44:32',NULL,NULL),(28215,'31031','S','Stevens Pottery','N','Wilkinson','13319','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.901291,-83.317179,0,'2013-07-06 12:44:31',NULL,NULL),(30507,'33403','S','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(50146,'57537','S','Hayes','D','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.433640,-100.547120,0,'2013-07-06 12:44:33',NULL,NULL),(45788,'52163','P','Protivin','D','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.361128,-92.167992,0,'2013-07-06 12:44:32',NULL,NULL),(38050,'43045','S','Milford Ctr','A','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.174261,-83.443176,0,'2013-07-06 12:44:32',NULL,NULL),(40811,'46186','S','Willow Branch','A','Hancock','18059','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.885591,-85.608655,0,'2013-07-06 12:44:32',NULL,NULL),(79822,'99507','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.151981,-149.828176,0,'2013-07-06 12:44:34',NULL,NULL),(53000,'61450','S','La Harpe','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.584041,-90.968298,0,'2013-07-06 12:44:33',NULL,NULL),(77217,'96386','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76748,'95917','S','Biggs','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.415882,-121.692678,0,'2013-07-06 12:44:34',NULL,NULL),(74247,'92331','P','Fontana','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.092178,-117.460591,0,'2013-07-06 12:44:34',NULL,NULL),(54601,'62907','S','Kinkaid','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.882657,-89.448679,0,'2013-07-06 12:44:33',NULL,NULL),(9072,'09005','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18855,'19438','S','Harleysville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.267589,-75.382781,0,'2013-07-06 12:44:31',NULL,NULL),(38282,'43330','P','Kirby','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.810973,-83.420189,0,'2013-07-06 12:44:32',NULL,NULL),(36038,'40202','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256394,-85.750706,0,'2013-07-06 12:44:32',NULL,NULL),(25597,'28451','S','Belville','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.213760,-78.038355,0,'2013-07-06 12:44:31',NULL,NULL),(18526,'19107','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.948927,-75.158663,0,'2013-07-06 12:44:31',NULL,NULL),(66546,'78732','S','Four Points','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.374220,-97.892700,0,'2013-07-06 12:44:34',NULL,NULL),(15000,'15660','P','Lowber','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.251892,-79.754051,0,'2013-07-06 12:44:31',NULL,NULL),(64046,'76130','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.706926,-97.362225,0,'2013-07-06 12:44:34',NULL,NULL),(77116,'96146','S','Tahoe City','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.150000,-120.150000,0,'2013-07-06 12:44:34',NULL,NULL),(53982,'62439','S','Russellville','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(50405,'57775','S','Quinn','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.097300,-102.109920,0,'2013-07-06 12:44:33',NULL,NULL),(7855,'07480','S','Pine Cliff Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.090615,-74.369917,0,'2013-07-06 12:44:30',NULL,NULL),(74951,'93420','S','Arroyo Grande','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.120444,-120.564172,0,'2013-07-06 12:44:34',NULL,NULL),(68363,'81137','S','Ignacio','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(44725,'50153','S','Lynnville','D','Jasper','19099','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.578090,-92.783547,0,'2013-07-06 12:44:32',NULL,NULL),(54884,'63068','S','Detmold','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.556540,-91.250460,0,'2013-07-06 12:44:33',NULL,NULL),(59682,'71068','S','Ringgold','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.316980,-93.299756,0,'2013-07-06 12:44:33',NULL,NULL),(8015,'07724','S','Eatontown','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.299859,-74.070754,0,'2013-07-06 12:44:30',NULL,NULL),(10726,'11351','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.781091,-73.830914,0,'2013-07-06 12:44:30',NULL,NULL),(62051,'73533','S','Duncan','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.513258,-97.960374,0,'2013-07-06 12:44:33',NULL,NULL),(11374,'11932','P','Bridgehampton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.962338,-72.306224,0,'2013-07-06 12:44:30',NULL,NULL),(69502,'83711','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.653226,-116.281124,0,'2013-07-06 12:44:34',NULL,NULL),(68385,'81147','S','Pagosa Spgs','A','Archuleta','08007','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.256494,-107.086521,0,'2013-07-06 12:44:34',NULL,NULL),(62878,'75047','P','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.876253,-96.647106,0,'2013-07-06 12:44:33',NULL,NULL),(36512,'40828','S','Evarts','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(59589,'71007','S','Bethany','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.364041,-94.017496,0,'2013-07-06 12:44:33',NULL,NULL),(58248,'68361','S','Geneva','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.529762,-97.599851,0,'2013-07-06 12:44:33',NULL,NULL),(58201,'68323','S','Burchard','D','Pawnee','31133','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.089542,-96.352947,0,'2013-07-06 12:44:33',NULL,NULL),(44191,'49614','S','Pierport','A','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.423101,-86.126289,0,'2013-07-06 12:44:32',NULL,NULL),(5757,'05039','S','West Corinth','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.034389,-72.292160,0,'2013-07-06 12:44:30',NULL,NULL),(9233,'09556','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28678,'31795','S','Ty Ty','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.469259,-83.540717,0,'2013-07-06 12:44:32',NULL,NULL),(31716,'34957','S','Ocean Breeze Park','A','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.234550,-80.232374,0,'2013-07-06 12:44:32',NULL,NULL),(76629,'95713','S','Cape Horn','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(14027,'14543','S','West Rush','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.994532,-77.664004,0,'2013-07-06 12:44:31',NULL,NULL),(58456,'68725','S','Chambers','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.145872,-98.734888,0,'2013-07-06 12:44:33',NULL,NULL),(57269,'66547','S','Louisville','A','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.211156,-96.316796,0,'2013-07-06 12:44:33',NULL,NULL),(56085,'64766','P','Milford','D','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.586167,-94.155511,0,'2013-07-06 12:44:33',NULL,NULL),(55166,'63367','S','O Fallon','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.793015,-90.782477,0,'2013-07-06 12:44:33',NULL,NULL),(63049,'75218','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.843593,-96.697965,0,'2013-07-06 12:44:33',NULL,NULL),(41155,'46701','S','Upper Long Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(40472,'45767','S','Rinard Mills','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.603478,-81.082854,0,'2013-07-06 12:44:32',NULL,NULL),(66939,'79359','S','Seagraves','D','Gaines','48165','Texas','TX','48','0000','806','Central',-6.0,'Y',32.940274,-102.560095,0,'2013-07-06 12:44:34',NULL,NULL),(79051,'98415','P','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250283,-122.448755,0,'2013-07-06 12:44:34',NULL,NULL),(75432,'94038','S','Moss Beach','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.546285,-122.498524,0,'2013-07-06 12:44:34',NULL,NULL),(27607,'30303','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.750591,-84.387699,0,'2013-07-06 12:44:31',NULL,NULL),(22645,'24260','S','Honaker','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.029515,-82.003511,0,'2013-07-06 12:44:31',NULL,NULL),(20888,'21702','S','Fort Detrick','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.494400,-77.453520,0,'2013-07-06 12:44:31',NULL,NULL),(70085,'84157','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.660687,-111.884858,0,'2013-07-06 12:44:34',NULL,NULL),(5804,'05067','S','South Pomfret','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.692881,-72.536671,0,'2013-07-06 12:44:30',NULL,NULL),(40093,'45305','S','Bellbrook','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(76659,'95741','P','Rncho Cordova','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.588819,-121.300677,0,'2013-07-06 12:44:34',NULL,NULL),(22103,'23419','P','Oyster','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.284567,-75.924132,0,'2013-07-06 12:44:31',NULL,NULL),(21610,'22902','S','Monticello','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.000280,-78.463620,0,'2013-07-06 12:44:31',NULL,NULL),(21274,'22312','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.821508,-77.152254,0,'2013-07-06 12:44:31',NULL,NULL),(68512,'81326','S','Kline','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.215884,-108.087279,0,'2013-07-06 12:44:34',NULL,NULL),(58825,'69041','S','Parks','D','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.174827,-101.766836,0,'2013-07-06 12:44:33',NULL,NULL),(78946,'98368','S','Ft Worden','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(61696,'72952','S','Rudy','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.466713,-94.316469,0,'2013-07-06 12:44:33',NULL,NULL),(46309,'53063','S','Newton','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.969789,-87.794434,0,'2013-07-06 12:44:32',NULL,NULL),(42446,'47805','S','Shawville','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(36596,'40964','S','Mary Alice','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.699988,-83.419993,0,'2013-07-06 12:44:32',NULL,NULL),(74152,'92258','P','N Palm Springs','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.922919,-116.549446,0,'2013-07-06 12:44:34',NULL,NULL),(78635,'98221','S','Decatur Island','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.498900,-122.607300,0,'2013-07-06 12:44:34',NULL,NULL),(4265,'02882','S','Narragansett','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.432140,-71.468662,0,'2013-07-06 12:44:30',NULL,NULL),(6192,'05482','S','Shelburne','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.391173,-73.214352,0,'2013-07-06 12:44:30',NULL,NULL),(66979,'79423','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.515300,-101.882849,0,'2013-07-06 12:44:34',NULL,NULL),(16973,'17724','S','Beech Flats','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(55060,'63158','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.604594,-90.223675,0,'2013-07-06 12:44:33',NULL,NULL),(13100,'13477','S','Vernon Center','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.044137,-75.524912,0,'2013-07-06 12:44:30',NULL,NULL),(74263,'92342','S','Helendale','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.688400,-117.290220,0,'2013-07-06 12:44:34',NULL,NULL),(34448,'38652','S','North Haven','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.491548,-89.012762,0,'2013-07-06 12:44:32',NULL,NULL),(43047,'48183','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(32401,'35957','S','Sardis City','A','Marshall','01095','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.148100,-86.148060,0,'2013-07-06 12:44:32',NULL,NULL),(64237,'76310','S','Wichita Falls','D','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.862452,-98.576512,0,'2013-07-06 12:44:34',NULL,NULL),(35930,'40045','S','Milton','D','Trimble','21223','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.690280,-85.371180,0,'2013-07-06 12:44:32',NULL,NULL),(72539,'89177','U','MGM Properties','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.083659,-115.148315,0,'2013-07-06 12:44:34',NULL,NULL),(78613,'98198','S','Redondo Beach','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.405098,-122.310024,0,'2013-07-06 12:44:34',NULL,NULL),(76980,'96061','S','Mineral','A','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.320900,-121.500420,0,'2013-07-06 12:44:34',NULL,NULL),(74608,'92708','S','Fountain Vly','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.716650,-117.944594,0,'2013-07-06 12:44:34',NULL,NULL),(65871,'78218','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.501300,-98.397733,0,'2013-07-06 12:44:34',NULL,NULL),(63054,'75222','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.754611,-96.840877,0,'2013-07-06 12:44:33',NULL,NULL),(50385,'57762','S','Nisland','D','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.673863,-103.556841,0,'2013-07-06 12:44:33',NULL,NULL),(44957,'50394','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.628965,-93.674410,0,'2013-07-06 12:44:32',NULL,NULL),(19575,'20214','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917561,-76.993932,0,'2013-07-06 12:44:31',NULL,NULL),(57524,'67004','S','Argonia','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.265660,-97.765940,0,'2013-07-06 12:44:33',NULL,NULL),(12958,'13360','S','Inlet','D','Hamilton','36041','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.732253,-74.736820,0,'2013-07-06 12:44:30',NULL,NULL),(44515,'49946','S','L Anse','N','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.759740,-88.409340,0,'2013-07-06 12:44:32',NULL,NULL),(39600,'44874','P','Savannah','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.966349,-82.366717,0,'2013-07-06 12:44:32',NULL,NULL),(10114,'10259','U','HSBC Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(74086,'92190','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.783150,-117.094510,0,'2013-07-06 12:44:34',NULL,NULL),(50311,'57717','S','Fruitdale','A','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.665219,-103.847783,0,'2013-07-06 12:44:33',NULL,NULL),(5312,'04564','S','Round Pond','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.918319,-69.466978,0,'2013-07-06 12:44:30',NULL,NULL),(65781,'78114','S','Floresville','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.160100,-98.179706,0,'2013-07-06 12:44:34',NULL,NULL),(35994,'40143','S','Axtel','N','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.779180,-86.458980,0,'2013-07-06 12:44:32',NULL,NULL),(17665,'18091','S','Wind Gap','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.828909,-75.330959,0,'2013-07-06 12:44:31',NULL,NULL),(846,'00698','S','Ext Alts De Yauco II','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(77339,'96718','P','Hawaii Natl Park','N','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.410522,-155.274653,0,'2013-07-06 12:44:34',NULL,NULL),(482,'00667','S','Urb Linda Vista','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(73393,'91114','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.168363,-118.126440,0,'2013-07-06 12:44:34',NULL,NULL),(39527,'44825','P','Chatfield','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.950456,-82.942070,0,'2013-07-06 12:44:32',NULL,NULL),(71536,'87151','U','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.025130,-106.856084,0,'2013-07-06 12:44:34',NULL,NULL),(67726,'80544','P','Niwot','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.102204,-105.174894,0,'2013-07-06 12:44:34',NULL,NULL),(63136,'75358','U','LSI','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.812543,-96.686454,0,'2013-07-06 12:44:33',NULL,NULL),(74349,'92408','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.081612,-117.275214,0,'2013-07-06 12:44:34',NULL,NULL),(14047,'14560','S','Springwater','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.711095,-77.553933,0,'2013-07-06 12:44:31',NULL,NULL),(6630,'05905','S','Maidstone','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(27043,'29667','S','Cateechee','A','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.759485,-82.770568,0,'2013-07-06 12:44:31',NULL,NULL),(78095,'97486','S','Umpqua','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.389225,-123.513406,0,'2013-07-06 12:44:34',NULL,NULL),(58755,'68959','S','Cosmo','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.493757,-98.949409,0,'2013-07-06 12:44:33',NULL,NULL),(44887,'50317','S','Norwoodville','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(41869,'47360','S','Mooreland','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.996465,-85.246526,0,'2013-07-06 12:44:32',NULL,NULL),(36347,'40423','P','Danville','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.643159,-84.771501,0,'2013-07-06 12:44:32',NULL,NULL),(64719,'76873','S','Rockwood','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.488285,-99.372601,0,'2013-07-06 12:44:34',NULL,NULL),(72959,'90043','S','View Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.990206,-118.335759,0,'2013-07-06 12:44:34',NULL,NULL),(20310,'20816','S','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.958169,-77.115563,0,'2013-07-06 12:44:31',NULL,NULL),(4508,'03293','P','Woodstock','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.978780,-71.686791,0,'2013-07-06 12:44:30',NULL,NULL),(9429,'10003','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(29919,'33061','P','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.236516,-80.120613,0,'2013-07-06 12:44:32',NULL,NULL),(23159,'25015','S','Belle','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(20033,'20637','S','Hughesville','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.522827,-76.771844,0,'2013-07-06 12:44:31',NULL,NULL),(7058,'06330','S','Baltic','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.612919,-72.070615,0,'2013-07-06 12:44:30',NULL,NULL),(59119,'70152','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.941971,-90.084458,0,'2013-07-06 12:44:33',NULL,NULL),(78352,'98010','S','Morganville','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.311403,-121.997673,0,'2013-07-06 12:44:34',NULL,NULL),(23875,'26160','S','Palestine','D','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(19110,'19606','S','Reading','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(7427,'06820','S','Darien','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.079898,-73.480707,0,'2013-07-06 12:44:30',NULL,NULL),(14108,'14626','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.209740,-77.703726,0,'2013-07-06 12:44:31',NULL,NULL),(43374,'48419','S','Carsonville','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.434677,-82.631487,0,'2013-07-06 12:44:32',NULL,NULL),(10937,'11434','S','Rochdale','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(35690,'39661','S','White Apple','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(12438,'12958','S','Mooers','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.961265,-73.581139,0,'2013-07-06 12:44:30',NULL,NULL),(12611,'13084','S','Cardiff','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.887460,-76.119300,0,'2013-07-06 12:44:30',NULL,NULL),(13242,'13642','S','Elmdale','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(1904,'00795','S','Colinas De Verde Azul','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(17779,'18344','S','Mount Pocono','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.120587,-75.358352,0,'2013-07-06 12:44:31',NULL,NULL),(21793,'23076','S','Hudgins','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.468121,-76.323510,0,'2013-07-06 12:44:31',NULL,NULL),(9447,'10006','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(56529,'65409','U','Missouri S & T','N','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.956712,-91.771492,0,'2013-07-06 12:44:33',NULL,NULL),(56974,'66201','P','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.969026,-94.676138,0,'2013-07-06 12:44:33',NULL,NULL),(24007,'26351','S','Gilmer','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.938379,-80.837080,0,'2013-07-06 12:44:31',NULL,NULL),(72185,'88352','S','Tularosa','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.074578,-106.015424,0,'2013-07-06 12:44:34',NULL,NULL),(72016,'88044','S','La Mesa','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.100222,-106.686211,0,'2013-07-06 12:44:34',NULL,NULL),(67451,'80212','S','Wheat Ridge','A','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.772488,-105.051110,0,'2013-07-06 12:44:34',NULL,NULL),(56285,'65074','S','Russellville','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.485140,-92.403960,0,'2013-07-06 12:44:33',NULL,NULL),(2923,'01011','S','Chester','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.283726,-72.966900,0,'2013-07-06 12:44:30',NULL,NULL),(78989,'98380','S','Maple Beach','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.634664,-122.844456,0,'2013-07-06 12:44:34',NULL,NULL),(73732,'91701','S','Rch Cucamonga','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.155540,-117.589740,0,'2013-07-06 12:44:34',NULL,NULL),(70823,'85387','S','Sun City','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.678050,-112.468506,0,'2013-07-06 12:44:34',NULL,NULL),(61142,'72165','S','Thida','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.554588,-91.474166,0,'2013-07-06 12:44:33',NULL,NULL),(51430,'59457','S','Lewistown','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.049780,-109.425300,0,'2013-07-06 12:44:33',NULL,NULL),(30999,'33770','S','Belleair Bluffs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.920852,-82.799669,0,'2013-07-06 12:44:32',NULL,NULL),(75287,'93721','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.733290,-119.779567,0,'2013-07-06 12:44:34',NULL,NULL),(26606,'29301','S','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.933791,-81.965052,0,'2013-07-06 12:44:31',NULL,NULL),(21138,'22103','P','West McLean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.947768,-77.227954,0,'2013-07-06 12:44:31',NULL,NULL),(15214,'16017','U','Boyers','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091440,-79.907770,0,'2013-07-06 12:44:31',NULL,NULL),(11425,'11965','P','Shelter Island Heights','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.075213,-72.354368,0,'2013-07-06 12:44:30',NULL,NULL),(80132,'99774','P','Stevens Village','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.024206,-149.187155,0,'2013-07-06 12:44:34',NULL,NULL),(5216,'04460','S','Grindstone Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.617950,-68.497973,0,'2013-07-06 12:44:30',NULL,NULL),(73451,'91302','S','Calabasas','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.134741,-118.656723,0,'2013-07-06 12:44:34',NULL,NULL),(33381,'37214','S','Donelson','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.171900,-86.720700,0,'2013-07-06 12:44:32',NULL,NULL),(64769,'76953','P','Tennyson','D','Coke','48081','Texas','TX','48','0000','325','Central',-6.0,'Y',31.739252,-100.288223,0,'2013-07-06 12:44:34',NULL,NULL),(58529,'68791','S','Wisner','D','Cuming','31039','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.990286,-96.914729,0,'2013-07-06 12:44:33',NULL,NULL),(52134,'60435','S','Crest Hill','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.552040,-88.111620,0,'2013-07-06 12:44:33',NULL,NULL),(50668,'58339','S','Hansboro','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.848122,-99.381035,0,'2013-07-06 12:44:33',NULL,NULL),(41349,'46789','P','Wildwood Landing','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.580247,-85.199688,0,'2013-07-06 12:44:32',NULL,NULL),(41216,'46732','S','Cromwell','D','Noble','18113','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.401608,-85.666412,0,'2013-07-06 12:44:32',NULL,NULL),(65429,'77583','S','Arcola','A','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.408146,-95.441666,0,'2013-07-06 12:44:34',NULL,NULL),(38352,'43445','S','Martin','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.591940,-83.311500,0,'2013-07-06 12:44:32',NULL,NULL),(25899,'28643','S','Tuckerdale','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(15647,'16738','S','Lewis Run','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.871524,-78.662892,0,'2013-07-06 12:44:31',NULL,NULL),(5839,'05088','P','Wilder','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.674874,-72.317951,0,'2013-07-06 12:44:30',NULL,NULL),(76170,'95322','S','Santa Nella','A','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.188900,-120.986100,0,'2013-07-06 12:44:34',NULL,NULL),(76105,'95226','P','Valley Springs','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.224462,-120.859612,0,'2013-07-06 12:44:34',NULL,NULL),(57832,'67544','S','Susank','A','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.607687,-98.840160,0,'2013-07-06 12:44:33',NULL,NULL),(70499,'84775','S','Torrey','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.302647,-111.367243,0,'2013-07-06 12:44:34',NULL,NULL),(27899,'30474','S','Charles','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(45335,'50862','S','Sharpsburg','D','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.801122,-94.636076,0,'2013-07-06 12:44:32',NULL,NULL),(62583,'74465','P','Tahlequah','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.906127,-94.985529,0,'2013-07-06 12:44:33',NULL,NULL),(18515,'19103','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.964218,-75.200972,0,'2013-07-06 12:44:31',NULL,NULL),(28616,'31709','S','Americus','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',32.072500,-84.225141,0,'2013-07-06 12:44:32',NULL,NULL),(27414,'30097','S','Johns Creek','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.025741,-84.141816,0,'2013-07-06 12:44:31',NULL,NULL),(23253,'25123','S','Grimms Lndg','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.746520,-81.955930,0,'2013-07-06 12:44:31',NULL,NULL),(40753,'46143','S','Greenwd','N','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.601573,-86.133793,0,'2013-07-06 12:44:32',NULL,NULL),(9247,'09578','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8960,'08807','S','Bridgewater','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.593164,-74.619513,0,'2013-07-06 12:44:30',NULL,NULL),(7812,'07446','S','Darlington','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.059559,-74.146690,0,'2013-07-06 12:44:30',NULL,NULL),(53843,'62321','S','Bentley','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(48123,'55357','S','Loretto','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.100321,-93.661093,0,'2013-07-06 12:44:33',NULL,NULL),(44905,'50325','S','Clive','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.604998,-93.747731,0,'2013-07-06 12:44:32',NULL,NULL),(39338,'44618','S','Dalton','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.785331,-81.699322,0,'2013-07-06 12:44:32',NULL,NULL),(27180,'29846','P','Sycamore','D','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.037812,-81.224619,0,'2013-07-06 12:44:31',NULL,NULL),(26299,'29031','S','Leeds','N','Union','45087','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.683284,-81.636507,0,'2013-07-06 12:44:31',NULL,NULL),(6440,'05751','S','Killington','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.651386,-72.791802,0,'2013-07-06 12:44:30',NULL,NULL),(65064,'77344','U','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722043,-95.552789,0,'2013-07-06 12:44:34',NULL,NULL),(75737,'94602','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.802583,-122.208576,0,'2013-07-06 12:44:34',NULL,NULL),(73756,'91730','S','Cucamonga','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.099140,-117.581280,0,'2013-07-06 12:44:34',NULL,NULL),(73414,'91184','U','Tournament of Roses Assoc','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.141599,-118.157559,0,'2013-07-06 12:44:34',NULL,NULL),(58797,'68982','S','Oneida','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.392938,-99.121319,0,'2013-07-06 12:44:33',NULL,NULL),(53195,'61611','S','Bayview Garde','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(53129,'61548','S','Germantwn Hls','A','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.788480,-89.427180,0,'2013-07-06 12:44:33',NULL,NULL),(49958,'57349','S','Argonne','N','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.014323,-97.529484,0,'2013-07-06 12:44:33',NULL,NULL),(14266,'14843','S','North Hornell','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.328714,-77.656438,0,'2013-07-06 12:44:31',NULL,NULL),(63618,'75833','S','Centerview','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.249797,-95.973492,0,'2013-07-06 12:44:34',NULL,NULL),(59523,'70803','U','La St Univ','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.408018,-91.188669,0,'2013-07-06 12:44:33',NULL,NULL),(1547,'00757','S','Valle Costero','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(56035,'64683','S','Trenton','D','Grundy','29079','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.078927,-93.611226,0,'2013-07-06 12:44:33',NULL,NULL),(42060,'47448','S','Elkinsville','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(34339,'38572','S','Crossville','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.958592,-84.971393,0,'2013-07-06 12:44:32',NULL,NULL),(38972,'44128','S','Warrensvl Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(20256,'20783','S','Adelphi','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.999340,-76.975020,0,'2013-07-06 12:44:31',NULL,NULL),(31222,'33965','U','Florida Gulf Coast Univ','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637271,-81.872508,0,'2013-07-06 12:44:32',NULL,NULL),(22431,'24014','S','Garden City','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.234614,-79.934731,0,'2013-07-06 12:44:31',NULL,NULL),(4324,'02917','S','Smithfield','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.855160,-71.492220,0,'2013-07-06 12:44:30',NULL,NULL),(55844,'64162','U','Usps Stamp Distribution Ctr','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.161625,-94.466674,0,'2013-07-06 12:44:33',NULL,NULL),(8433,'08080','S','Cross Keys','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.749340,-75.096660,0,'2013-07-06 12:44:30',NULL,NULL),(48620,'55797','S','Holyoke','N','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.467500,-92.388333,0,'2013-07-06 12:44:33',NULL,NULL),(36016,'40162','S','Rineyville','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.751318,-86.005252,0,'2013-07-06 12:44:32',NULL,NULL),(39759,'45113','S','Clarksville','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.402232,-83.965563,0,'2013-07-06 12:44:32',NULL,NULL),(76373,'95519','S','McKinleyville','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.872600,-124.070640,0,'2013-07-06 12:44:34',NULL,NULL),(47193,'54486','S','Tigerton','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.743866,-89.041687,0,'2013-07-06 12:44:32',NULL,NULL),(49329,'56556','S','McIntosh','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.658180,-95.889900,0,'2013-07-06 12:44:33',NULL,NULL),(56375,'65230','S','Armstrong','D','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.269004,-92.703942,0,'2013-07-06 12:44:33',NULL,NULL),(76448,'95607','S','Capay','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.688170,-122.139102,0,'2013-07-06 12:44:34',NULL,NULL),(11095,'11694','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.576767,-73.844160,0,'2013-07-06 12:44:30',NULL,NULL),(66107,'78412','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.705823,-97.348066,0,'2013-07-06 12:44:34',NULL,NULL),(58123,'68131','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.271024,-95.962638,0,'2013-07-06 12:44:33',NULL,NULL),(59505,'70776','S','Saint Gabriel','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.287400,-91.073340,0,'2013-07-06 12:44:33',NULL,NULL),(76780,'95940','P','Feather Falls','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.511620,-121.556520,0,'2013-07-06 12:44:34',NULL,NULL),(36475,'40759','S','Meadow Creek','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.827380,-84.091590,0,'2013-07-06 12:44:32',NULL,NULL),(50531,'58105','P','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.911206,-96.793700,0,'2013-07-06 12:44:33',NULL,NULL),(16581,'17321','S','Fawn','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.752280,-76.447440,0,'2013-07-06 12:44:31',NULL,NULL),(76827,'95959','S','Nevada City','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.273440,-121.022061,0,'2013-07-06 12:44:34',NULL,NULL),(35864,'39832','P','Cedar Springs','D','Early','13099','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.184745,-85.004825,0,'2013-07-06 12:44:32',NULL,NULL),(52699,'61108','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.251933,-89.029605,0,'2013-07-06 12:44:33',NULL,NULL),(78689,'98250','S','Friday Harbor','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.543044,-123.068308,0,'2013-07-06 12:44:34',NULL,NULL),(32607,'36134','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.377274,-86.308425,0,'2013-07-06 12:44:32',NULL,NULL),(18042,'18657','S','Monroe Township','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(25283,'28133','S','Peachland','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.017385,-80.263528,0,'2013-07-06 12:44:31',NULL,NULL),(1269,'00730','S','Bo La Ponderosa','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(2635,'00965','S','Bo Sabana','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(39514,'44814','S','Berlin Heights','D','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.327386,-82.477219,0,'2013-07-06 12:44:32',NULL,NULL),(42876,'48086','P','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.473010,-83.260797,0,'2013-07-06 12:44:32',NULL,NULL),(65893,'78232','S','Hollywood Pk','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.584537,-98.475424,0,'2013-07-06 12:44:34',NULL,NULL),(61780,'73069','S','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.252751,-97.460386,0,'2013-07-06 12:44:33',NULL,NULL),(3391,'01610','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.249011,-71.807956,0,'2013-07-06 12:44:30',NULL,NULL),(25155,'28025','S','Stonewall Jackson Training S','N','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.400953,-80.583807,0,'2013-07-06 12:44:31',NULL,NULL),(5954,'05262','S','So Shaftsbury','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.133333,-73.066667,0,'2013-07-06 12:44:30',NULL,NULL),(33751,'37848','S','Powder Springs','D','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.252231,-83.668136,0,'2013-07-06 12:44:32',NULL,NULL),(20716,'21279','U','Sun Trust Bank','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.296632,-76.608209,0,'2013-07-06 12:44:31',NULL,NULL),(26729,'29418','S','Chas Hgts','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.892960,-80.059500,0,'2013-07-06 12:44:31',NULL,NULL),(15113,'15779','P','Torrance','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.420266,-79.221407,0,'2013-07-06 12:44:31',NULL,NULL),(1792,'00783','S','Urb Cerromonte','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(37465,'41858','S','Van','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(40744,'46135','S','Manhattan','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(53707,'62234','S','State Park Place','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.687371,-89.983306,0,'2013-07-06 12:44:33',NULL,NULL),(69795,'84066','S','Ballard','A','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.298824,-109.998125,0,'2013-07-06 12:44:34',NULL,NULL),(5800,'05062','S','Hammondsville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.494300,-72.584520,0,'2013-07-06 12:44:30',NULL,NULL),(68649,'81641','S','Meeker','D','Rio Blanco','08103','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.045459,-107.946922,0,'2013-07-06 12:44:34',NULL,NULL),(12616,'13088','S','Jewell Manor','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(11526,'12040','P','Cherry Plain','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.634921,-73.355054,0,'2013-07-06 12:44:30',NULL,NULL),(32183,'35490','S','Vance','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.290778,-87.157660,0,'2013-07-06 12:44:32',NULL,NULL),(28638,'31756','S','Hartville','N','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.215276,-83.970568,0,'2013-07-06 12:44:32',NULL,NULL),(52571,'60963','S','Rossville','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.380311,-87.664396,0,'2013-07-06 12:44:33',NULL,NULL),(75009,'93455','S','Santa Maria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.838280,-120.403560,0,'2013-07-06 12:44:34',NULL,NULL),(71128,'86022','S','Jacob Lake','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(79244,'98557','S','Mc Cleary','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.053140,-123.286440,0,'2013-07-06 12:44:34',NULL,NULL),(47843,'55073','S','Scandia','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.271900,-92.831860,0,'2013-07-06 12:44:33',NULL,NULL),(21192,'22185','U','Oakton','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.899292,-77.260327,0,'2013-07-06 12:44:31',NULL,NULL),(7683,'07102','S','Academy','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.732638,-74.171775,0,'2013-07-06 12:44:30',NULL,NULL),(70097,'84170','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701243,-112.010773,0,'2013-07-06 12:44:34',NULL,NULL),(69985,'84121','S','Holladay Cottonwood','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(50930,'58568','S','Selfridge','D','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.038271,-101.279372,0,'2013-07-06 12:44:33',NULL,NULL),(23231,'25088','S','Glen','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.355355,-81.230358,0,'2013-07-06 12:44:31',NULL,NULL),(45615,'51572','S','Soldier','D','Monona','19133','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.984662,-95.782170,0,'2013-07-06 12:44:32',NULL,NULL),(10917,'11429','S','Queens Village','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.711559,-73.742091,0,'2013-07-06 12:44:30',NULL,NULL),(60744,'71968','S','Royal','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.523895,-93.299582,0,'2013-07-06 12:44:33',NULL,NULL),(49078,'56321','P','Collegeville','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.573343,-94.368311,0,'2013-07-06 12:44:33',NULL,NULL),(44311,'49738','S','Grayling','D','Crawford','26039','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.660428,-84.727615,0,'2013-07-06 12:44:32',NULL,NULL),(36066,'40207','S','Saint Matthews','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(42553,'47872','S','Judson','A','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.773340,-87.270060,0,'2013-07-06 12:44:32',NULL,NULL),(65977,'78298','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.457351,-98.501991,0,'2013-07-06 12:44:34',NULL,NULL),(62815,'74949','S','Muse','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.676508,-94.691874,0,'2013-07-06 12:44:33',NULL,NULL),(7605,'07046','S','Mountain Lks','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.891687,-74.439534,0,'2013-07-06 12:44:30',NULL,NULL),(54216,'62649','S','Hettick','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.390113,-90.093325,0,'2013-07-06 12:44:33',NULL,NULL),(15287,'16125','S','Shenango','A','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.404860,-80.369580,0,'2013-07-06 12:44:31',NULL,NULL),(41571,'47031','S','Milan','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.162406,-85.140847,0,'2013-07-06 12:44:32',NULL,NULL),(43963,'49314','P','Burnips','D','Allegan','26005','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.731059,-85.851086,0,'2013-07-06 12:44:32',NULL,NULL),(50760,'58416','S','Kingsley','N','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.583836,-98.369868,0,'2013-07-06 12:44:33',NULL,NULL),(70321,'84624','S','Deseret','A','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(43526,'48655','S','Saint Charles','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.295333,-84.163650,0,'2013-07-06 12:44:32',NULL,NULL),(77831,'97214','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.516160,-122.642340,0,'2013-07-06 12:44:34',NULL,NULL),(77349,'96727','S','Paauhau','A','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.087407,-155.518923,0,'2013-07-06 12:44:34',NULL,NULL),(33460,'37323','S','Cleveld','N','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.125348,-84.866606,0,'2013-07-06 12:44:32',NULL,NULL),(7152,'06418','S','Derby','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.381890,-73.079662,0,'2013-07-06 12:44:30',NULL,NULL),(11605,'12090','S','Boyntonville','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.880260,-73.359060,0,'2013-07-06 12:44:30',NULL,NULL),(74890,'93286','S','Elderwood','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.420258,-119.099560,0,'2013-07-06 12:44:34',NULL,NULL),(21824,'23111','S','Mechanicsvlle','A','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.631363,-77.356146,0,'2013-07-06 12:44:31',NULL,NULL),(56333,'65108','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.573978,-92.171679,0,'2013-07-06 12:44:33',NULL,NULL),(35769,'39743','S','Crawford','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.341575,-88.514050,0,'2013-07-06 12:44:32',NULL,NULL),(70869,'85603','S','Sunset Acres','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(17713,'18235','S','Lehightn Bor0','A','Carbon','42025','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.843037,-75.694426,0,'2013-07-06 12:44:31',NULL,NULL),(52780,'61266','P','Moline','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.505858,-90.514070,0,'2013-07-06 12:44:33',NULL,NULL),(31114,'33896','S','Champions Gate','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.198079,-81.621088,0,'2013-07-06 12:44:32',NULL,NULL),(12933,'13343','S','Pine Grove','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.737780,-75.327900,0,'2013-07-06 12:44:30',NULL,NULL),(23808,'26047','S','New Cumberlnd','A','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.493050,-80.597570,0,'2013-07-06 12:44:31',NULL,NULL),(1940,'00795','S','Valle Serreno','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(28895,'32128','S','Pt Orange','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.130510,-81.118481,0,'2013-07-06 12:44:32',NULL,NULL),(41884,'47370','P','E Germantown','A','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.815011,-85.136637,0,'2013-07-06 12:44:32',NULL,NULL),(40707,'46107','S','Beech Grove','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.715417,-86.095646,0,'2013-07-06 12:44:32',NULL,NULL),(35183,'39282','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.254854,-90.248918,0,'2013-07-06 12:44:32',NULL,NULL),(43213,'48307','S','Rochester','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.657341,-83.123033,0,'2013-07-06 12:44:32',NULL,NULL),(27112,'29730','S','Rock Hill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.929113,-81.022958,0,'2013-07-06 12:44:31',NULL,NULL),(57845,'67557','S','Macksville','D','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.956812,-98.972472,0,'2013-07-06 12:44:33',NULL,NULL),(8381,'08056','S','Mickleton','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.785684,-75.250020,0,'2013-07-06 12:44:30',NULL,NULL),(7477,'06890','S','Southport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.140672,-73.288227,0,'2013-07-06 12:44:30',NULL,NULL),(15278,'16115','S','Darlington','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.766528,-80.466530,0,'2013-07-06 12:44:31',NULL,NULL),(79529,'98940','P','Ronald','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.229896,-121.020860,0,'2013-07-06 12:44:34',NULL,NULL),(74699,'93003','S','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.270548,-119.217135,0,'2013-07-06 12:44:34',NULL,NULL),(11518,'12033','S','Castleton on Hudson','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535438,-73.709070,0,'2013-07-06 12:44:30',NULL,NULL),(25962,'28658','S','Duan','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(23462,'25431','S','Levels','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.480000,-78.550000,0,'2013-07-06 12:44:31',NULL,NULL),(67540,'80260','S','Federal Hgts','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(10974,'11530','S','Stewart Manor','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(66583,'78746','S','Rollingwood','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.301080,-97.814880,0,'2013-07-06 12:44:34',NULL,NULL),(65369,'77536','S','Deer Park','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.696919,-95.112428,0,'2013-07-06 12:44:34',NULL,NULL),(31099,'33880','S','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.996505,-81.752285,0,'2013-07-06 12:44:32',NULL,NULL),(73473,'91311','S','Chatsworth','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.254498,-118.594763,0,'2013-07-06 12:44:34',NULL,NULL),(3417,'01719','S','Boxborough','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.484999,-71.518519,0,'2013-07-06 12:44:30',NULL,NULL),(6224,'05489','S','Underhill Flats','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.538900,-72.920580,0,'2013-07-06 12:44:30',NULL,NULL),(72115,'88252','S','Jal','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.112508,-103.194980,0,'2013-07-06 12:44:34',NULL,NULL),(48141,'55364','S','Orono','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.935114,-93.662910,0,'2013-07-06 12:44:33',NULL,NULL),(21958,'23236','S','N Chesterfld','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.478368,-77.582532,0,'2013-07-06 12:44:31',NULL,NULL),(55035,'63137','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748404,-90.218419,0,'2013-07-06 12:44:33',NULL,NULL),(56930,'66071','S','Paola','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.577177,-94.870515,0,'2013-07-06 12:44:33',NULL,NULL),(62756,'74848','S','Yeager','A','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.083745,-96.399050,0,'2013-07-06 12:44:33',NULL,NULL),(8282,'08014','S','Bridgeport','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.807532,-75.343044,0,'2013-07-06 12:44:30',NULL,NULL),(1604,'00769','S','Urb Las Fuentes De Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(72323,'89005','S','Boulder City','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.977834,-114.835850,0,'2013-07-06 12:44:34',NULL,NULL),(57921,'67667','P','Hays','A','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.713957,-99.331020,0,'2013-07-06 12:44:33',NULL,NULL),(71561,'87198','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.085096,-106.653084,0,'2013-07-06 12:44:34',NULL,NULL),(64921,'77206','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.827129,-95.426254,0,'2013-07-06 12:44:34',NULL,NULL),(50770,'58422','S','Cathay','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.548080,-99.442500,0,'2013-07-06 12:44:33',NULL,NULL),(50232,'57620','S','Cash','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(44679,'50123','S','Humeston','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.846920,-93.503520,0,'2013-07-06 12:44:32',NULL,NULL),(11798,'12225','P','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.682259,-73.838108,0,'2013-07-06 12:44:30',NULL,NULL),(12340,'12873','S','Shushan','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.127464,-73.307470,0,'2013-07-06 12:44:30',NULL,NULL),(7144,'06411','U','Bloomingdales by Mail Ltd','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.499696,-72.901815,0,'2013-07-06 12:44:30',NULL,NULL),(37706,'42261','S','Morgantown','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(63000,'75156','S','Enchanted Oaks','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295960,-96.118738,0,'2013-07-06 12:44:33',NULL,NULL),(17191,'17820','S','Roaring Creek','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(10339,'10552','S','Mt Vernon','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.922381,-73.829403,0,'2013-07-06 12:44:30',NULL,NULL),(57816,'67519','S','Belpre','D','Edwards','20047','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.924307,-99.090767,0,'2013-07-06 12:44:33',NULL,NULL),(14109,'14627','P','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.122454,-77.669125,0,'2013-07-06 12:44:31',NULL,NULL),(61150,'72173','S','Holland','A','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.066940,-92.174760,0,'2013-07-06 12:44:33',NULL,NULL),(62833,'75002','S','Allen','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.087120,-96.616980,0,'2013-07-06 12:44:33',NULL,NULL),(1990,'00908','P','Santurce','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444163,-66.079468,0,'2013-07-06 12:44:30',NULL,NULL),(32121,'35441','S','Stewart','A','Hale','01065','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.874480,-87.696780,0,'2013-07-06 12:44:32',NULL,NULL),(71755,'87548','P','Medanales','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.152065,-106.236296,0,'2013-07-06 12:44:34',NULL,NULL),(10797,'11371','S','La Guardia Airport','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.775842,-73.874904,0,'2013-07-06 12:44:30',NULL,NULL),(2915,'01003','P','Amherst','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.405240,-72.528427,0,'2013-07-06 12:44:30',NULL,NULL),(57362,'66739','S','Badger','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.069390,-94.633351,0,'2013-07-06 12:44:33',NULL,NULL),(52792,'61273','S','Warner','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.366880,-90.433140,0,'2013-07-06 12:44:33',NULL,NULL),(79629,'99126','S','Kettle Falls','A','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.693900,-118.011300,0,'2013-07-06 12:44:34',NULL,NULL),(66100,'78408','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.797109,-97.435885,0,'2013-07-06 12:44:34',NULL,NULL),(75741,'94605','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.762699,-122.160000,0,'2013-07-06 12:44:34',NULL,NULL),(33713,'37774','S','Loudon','D','Loudon','47105','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.707092,-84.297811,0,'2013-07-06 12:44:32',NULL,NULL),(70143,'84307','S','Corinne','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.406420,-112.293960,0,'2013-07-06 12:44:34',NULL,NULL),(48606,'55787','S','Clark','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.637586,-93.122746,0,'2013-07-06 12:44:33',NULL,NULL),(76916,'96002','S','Redding','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.540695,-122.324510,0,'2013-07-06 12:44:34',NULL,NULL),(65791,'78123','S','Mc Queeney','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.605956,-98.034172,0,'2013-07-06 12:44:34',NULL,NULL),(22943,'24639','S','Raven','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.272658,-82.105579,0,'2013-07-06 12:44:31',NULL,NULL),(10055,'10176','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(23058,'24870','S','Crany','N','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.711020,-81.604020,0,'2013-07-06 12:44:31',NULL,NULL),(74143,'92253','S','La Quinta','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.671158,-116.294219,0,'2013-07-06 12:44:34',NULL,NULL),(24049,'26419','S','Pine Grove','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.566100,-80.676780,0,'2013-07-06 12:44:31',NULL,NULL),(67253,'79952','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.761920,-106.480169,0,'2013-07-06 12:44:34',NULL,NULL),(53693,'62231','S','Boulder','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(35581,'39573','S','Crane Creek','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(52258,'60521','S','Oak Brook Mall','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.790281,-87.948130,0,'2013-07-06 12:44:33',NULL,NULL),(16134,'17058','S','Mifflin','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.565928,-77.406815,0,'2013-07-06 12:44:31',NULL,NULL),(14584,'15220','S','Rook','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425951,-80.048689,0,'2013-07-06 12:44:31',NULL,NULL),(1606,'00769','S','Urb Monte Real','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(19304,'20004','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892163,-77.027748,0,'2013-07-06 12:44:31',NULL,NULL),(19585,'20219','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882413,-77.016213,0,'2013-07-06 12:44:31',NULL,NULL),(24809,'27599','U','Univ of Nc','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.928939,-79.040693,0,'2013-07-06 12:44:31',NULL,NULL),(55098,'63303','S','St Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.752200,-90.537720,0,'2013-07-06 12:44:33',NULL,NULL),(70224,'84404','S','Marriott Slaterville','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(22929,'24622','S','Jewell Valley','A','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.226926,-81.810969,0,'2013-07-06 12:44:31',NULL,NULL),(72386,'89039','S','Searchlight','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.316311,-114.885400,0,'2013-07-06 12:44:34',NULL,NULL),(31281,'34032','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(31753,'34988','P','St Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.341002,-80.519774,0,'2013-07-06 12:44:32',NULL,NULL),(24696,'27425','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','704/980','Eastern',-5.0,'Y',36.127293,-79.942762,0,'2013-07-06 12:44:31',NULL,NULL),(5115,'04359','P','S Gardiner','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.202673,-69.781345,0,'2013-07-06 12:44:30',NULL,NULL),(1415,'00738','S','Urb Santa Isidra 4','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(6844,'06119','S','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760843,-72.729064,0,'2013-07-06 12:44:30',NULL,NULL),(10953,'11451','U','York College','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699605,-73.799982,0,'2013-07-06 12:44:30',NULL,NULL),(64557,'76655','S','Levi','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.422120,-97.237920,0,'2013-07-06 12:44:34',NULL,NULL),(32906,'36545','S','Jackson','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.527175,-87.891357,0,'2013-07-06 12:44:32',NULL,NULL),(32262,'35630','S','Florence','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.819157,-87.658805,0,'2013-07-06 12:44:32',NULL,NULL),(28237,'31049','S','Kite','D','Johnson','13167','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.718538,-82.530638,0,'2013-07-06 12:44:31',NULL,NULL),(35296,'39401','S','McCallum','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(45878,'52253','S','Lisbon','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.916168,-91.383473,0,'2013-07-06 12:44:32',NULL,NULL),(22450,'24024','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.275792,-79.934237,0,'2013-07-06 12:44:31',NULL,NULL),(56345,'65201','S','Deer Park','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.896440,-92.246280,0,'2013-07-06 12:44:33',NULL,NULL),(57955,'67753','S','Rexford','D','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.413220,-100.742340,0,'2013-07-06 12:44:33',NULL,NULL),(13652,'14011','S','Cowlesville','N','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.835713,-78.280907,0,'2013-07-06 12:44:31',NULL,NULL),(77696,'97041','S','Mt Hood Prkdl','A','Hood River','41027','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.498300,-121.592880,0,'2013-07-06 12:44:34',NULL,NULL),(29274,'32461','P','Panama City','A','Walton','12131','Florida','FL','12','6015','850','Central',-6.0,'Y',30.251077,-85.950567,0,'2013-07-06 12:44:32',NULL,NULL),(61256,'72358','S','Luxora','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.756918,-89.932328,0,'2013-07-06 12:44:33',NULL,NULL),(19553,'20201','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887354,-77.017361,0,'2013-07-06 12:44:31',NULL,NULL),(10085,'10203','U','Bank Of New York Brm','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711931,-74.011806,0,'2013-07-06 12:44:30',NULL,NULL),(20121,'20716','S','South Bowie','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.925300,-76.715460,0,'2013-07-06 12:44:31',NULL,NULL),(14397,'15053','S','Joffre','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.382702,-80.359702,0,'2013-07-06 12:44:31',NULL,NULL),(28738,'31914','P','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.556200,-85.005558,0,'2013-07-06 12:44:32',NULL,NULL),(12750,'13205','S','Colvin','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.006472,-76.148241,0,'2013-07-06 12:44:30',NULL,NULL),(22396,'23950','S','Forksville','A','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.752222,-78.046389,0,'2013-07-06 12:44:31',NULL,NULL),(18401,'19053','S','Fstrvl Trvose','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(74620,'92801','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.842832,-117.954595,0,'2013-07-06 12:44:34',NULL,NULL),(35748,'39730','S','New Wren','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(68839,'82520','S','Sweetwater Station','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(64344,'76518','S','Buckholts','D','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.894745,-97.123059,0,'2013-07-06 12:44:34',NULL,NULL),(52205,'60478','S','Ctry Clb Hls','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.559523,-87.722149,0,'2013-07-06 12:44:33',NULL,NULL),(56599,'65560','S','Gladden','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(8493,'08096','S','Blackwood Terrace','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(41913,'47374','S','Spring Grove','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(50822,'58467','S','Crystal Springs','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.893964,-99.302871,0,'2013-07-06 12:44:33',NULL,NULL),(68588,'81525','S','Mack','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.236370,-108.849029,0,'2013-07-06 12:44:34',NULL,NULL),(23180,'25040','P','Charlton Heights','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.124629,-81.235798,0,'2013-07-06 12:44:31',NULL,NULL),(22896,'24592','S','South Boston','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.709303,-78.901540,0,'2013-07-06 12:44:31',NULL,NULL),(67269,'79980','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.746134,-106.375219,0,'2013-07-06 12:44:34',NULL,NULL),(63728,'75932','S','Toledo','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.028220,-93.643080,0,'2013-07-06 12:44:34',NULL,NULL),(56472,'65320','P','Arrow Rock','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.005498,-93.045171,0,'2013-07-06 12:44:33',NULL,NULL),(45620,'51578','P','Westphalia','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.718477,-95.395176,0,'2013-07-06 12:44:32',NULL,NULL),(34923,'38965','S','Pine Valley','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.153955,-89.632766,0,'2013-07-06 12:44:32',NULL,NULL),(41476,'46929','S','Flora','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.545171,-86.523488,0,'2013-07-06 12:44:32',NULL,NULL),(10482,'10952','S','Wesley Hills','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.114522,-74.077510,0,'2013-07-06 12:44:30',NULL,NULL),(9855,'10119','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(7125,'06384','S','Voluntown','D','New London','09011','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.574260,-71.884653,0,'2013-07-06 12:44:30',NULL,NULL),(70327,'84627','S','Ephraim','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.324313,-111.614299,0,'2013-07-06 12:44:34',NULL,NULL),(12005,'12493','P','West Park','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810969,-74.003333,0,'2013-07-06 12:44:30',NULL,NULL),(44643,'50073','S','White Oak','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.789463,-93.515162,0,'2013-07-06 12:44:32',NULL,NULL),(35073,'39194','S','Yazoo City','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.857919,-90.405161,0,'2013-07-06 12:44:32',NULL,NULL),(2048,'00919','P','Hato Rey','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410997,-66.064914,0,'2013-07-06 12:44:30',NULL,NULL),(15169,'15924','S','Cairnbrook','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.156081,-78.711800,0,'2013-07-06 12:44:31',NULL,NULL),(64181,'76230','S','Stoneburg','N','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.561402,-97.838818,0,'2013-07-06 12:44:34',NULL,NULL),(22997,'24801','S','Skygusty','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(10818,'11377','S','Woodside','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.743107,-73.906134,0,'2013-07-06 12:44:30',NULL,NULL),(71475,'87063','S','Lucy','N','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.449626,-106.011354,0,'2013-07-06 12:44:34',NULL,NULL),(58146,'68157','S','Omaha','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.184654,-95.994302,0,'2013-07-06 12:44:33',NULL,NULL),(59406,'70640','P','Fenton','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.365246,-92.919012,0,'2013-07-06 12:44:33',NULL,NULL),(22120,'23435','S','Driver','N','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.849660,-76.479360,0,'2013-07-06 12:44:31',NULL,NULL),(29415,'32654','P','Island Grove','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.590092,-82.127367,0,'2013-07-06 12:44:32',NULL,NULL),(78462,'98072','S','Cottage Lake','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.748655,-122.095293,0,'2013-07-06 12:44:34',NULL,NULL),(27952,'30542','S','Flowery Br','A','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.188876,-83.905713,0,'2013-07-06 12:44:31',NULL,NULL),(76766,'95928','S','Dayton','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.724307,-121.813534,0,'2013-07-06 12:44:34',NULL,NULL),(5074,'04289','S','West Paris','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.332320,-70.597320,0,'2013-07-06 12:44:30',NULL,NULL),(74460,'92591','S','Temecula','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.531454,-117.100268,0,'2013-07-06 12:44:34',NULL,NULL),(3911,'02457','P','Wellesley','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.297040,-71.259784,0,'2013-07-06 12:44:30',NULL,NULL),(59174,'70344','S','Little Caillou','N','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.250580,-90.662180,0,'2013-07-06 12:44:33',NULL,NULL),(51474,'59537','S','Loring','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.818755,-107.913955,0,'2013-07-06 12:44:33',NULL,NULL),(56482,'65326','S','Hastain','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.167610,-93.149233,0,'2013-07-06 12:44:33',NULL,NULL),(62397,'74106','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.186382,-95.984320,0,'2013-07-06 12:44:33',NULL,NULL),(44138,'49514','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.965573,-85.655928,0,'2013-07-06 12:44:32',NULL,NULL),(1935,'00795','S','Urb Palacios Del Prado','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(38490,'43666','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.654455,-83.530392,0,'2013-07-06 12:44:32',NULL,NULL),(35578,'39572','S','Belle Isle','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.242297,-89.605365,0,'2013-07-06 12:44:32',NULL,NULL),(51112,'58784','S','Lunds Valley','N','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.312403,-102.392847,0,'2013-07-06 12:44:33',NULL,NULL),(12160,'12748','S','Jeffersonville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.745480,-74.746860,0,'2013-07-06 12:44:30',NULL,NULL),(70154,'84313','S','Grouse Creek','D','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.441690,-113.769269,0,'2013-07-06 12:44:34',NULL,NULL),(69735,'84043','S','Saratoga Spgs','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(9970,'10161','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.747012,-74.005347,0,'2013-07-06 12:44:30',NULL,NULL),(43089,'48209','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.307946,-83.109633,0,'2013-07-06 12:44:32',NULL,NULL),(44443,'49862','S','Christmas','A','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.416420,-86.623980,0,'2013-07-06 12:44:32',NULL,NULL),(44203,'49627','P','Eastport','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.088153,-85.310648,0,'2013-07-06 12:44:32',NULL,NULL),(5744,'05035','S','Bridgewtr Cor','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.600000,-72.749167,0,'2013-07-06 12:44:30',NULL,NULL),(42954,'48127','S','Dearborn Hts','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.334650,-83.284212,0,'2013-07-06 12:44:32',NULL,NULL),(47891,'55106','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.957208,-93.052916,0,'2013-07-06 12:44:33',NULL,NULL),(75072,'93531','S','Keene','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.236438,-118.602974,0,'2013-07-06 12:44:34',NULL,NULL),(21100,'22042','S','Falls Church','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.864751,-77.194735,0,'2013-07-06 12:44:31',NULL,NULL),(18263,'19006','S','Huntingdon Valley','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.129527,-75.060892,0,'2013-07-06 12:44:31',NULL,NULL),(59915,'71282','S','Tallulah','D','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(75903,'94998','U','Firemans Fund Ins','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.099734,-122.571446,0,'2013-07-06 12:44:34',NULL,NULL),(75604,'94305','S','Stanford','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.419371,-122.163685,0,'2013-07-06 12:44:34',NULL,NULL),(20648,'21224','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.280680,-76.537980,0,'2013-07-06 12:44:31',NULL,NULL),(17982,'18618','S','Monroe Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.341140,-76.017214,0,'2013-07-06 12:44:31',NULL,NULL),(17764,'18331','S','Gilbert','D','Monroe','42089','Pennsylvania','PA','42','0000','610/484','Eastern',-5.0,'Y',40.957059,-75.504758,0,'2013-07-06 12:44:31',NULL,NULL),(55286,'63474','S','Fairmont','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.336883,-91.890611,0,'2013-07-06 12:44:33',NULL,NULL),(38429,'43554','S','Holiday City','A','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.667305,-84.552070,0,'2013-07-06 12:44:32',NULL,NULL),(13459,'13782','S','Hamden','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.218008,-75.012581,0,'2013-07-06 12:44:31',NULL,NULL),(16733,'17501','S','Akron','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.156398,-76.203555,0,'2013-07-06 12:44:31',NULL,NULL),(23908,'26208','S','Camden On Gly','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.375220,-80.572320,0,'2013-07-06 12:44:31',NULL,NULL),(483,'00669','S','Haciendas de Borinquen II','N','Lares','72081','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.294354,-66.884391,0,'2013-07-06 12:44:30',NULL,NULL),(3529,'01901','S','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.463486,-70.943394,0,'2013-07-06 12:44:30',NULL,NULL),(44639,'50072','S','Earlham','D','Madison','19121','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.491725,-94.122623,0,'2013-07-06 12:44:32',NULL,NULL),(42154,'47522','S','Cran Nav Dpo','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(15158,'15904','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.286167,-78.866154,0,'2013-07-06 12:44:31',NULL,NULL),(12131,'12720','S','Bethel','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.662164,-74.907661,0,'2013-07-06 12:44:30',NULL,NULL),(527,'00674','S','Valle Encantado','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(42992,'48158','S','Podunk','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.162540,-84.020040,0,'2013-07-06 12:44:32',NULL,NULL),(55885,'64423','S','Barnard','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.357435,-94.891923,0,'2013-07-06 12:44:33',NULL,NULL),(70291,'84533','S','Irish Green','N','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(32612,'36135','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.387934,-86.151025,0,'2013-07-06 12:44:32',NULL,NULL),(75770,'94649','U','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.806936,-122.263828,0,'2013-07-06 12:44:34',NULL,NULL),(73084,'90220','S','Crystal City','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.890694,-118.239135,0,'2013-07-06 12:44:34',NULL,NULL),(46067,'52577','S','Wright','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.286600,-92.600280,0,'2013-07-06 12:44:32',NULL,NULL),(77673,'97030','S','Damascus','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.499394,-122.420435,0,'2013-07-06 12:44:34',NULL,NULL),(64962,'77248','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.799923,-95.417313,0,'2013-07-06 12:44:34',NULL,NULL),(954,'00716','S','Parq del Rio','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(11341,'11793','S','N Wantagh','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685767,-73.514020,0,'2013-07-06 12:44:30',NULL,NULL),(76185,'95338','S','Mariposa','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.483473,-119.905335,0,'2013-07-06 12:44:34',NULL,NULL),(72188,'88354','S','Weed','D','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.804351,-105.460756,0,'2013-07-06 12:44:34',NULL,NULL),(19091,'19602','S','West Reading','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.329373,-75.921719,0,'2013-07-06 12:44:31',NULL,NULL),(53676,'62219','P','Beckemeyer','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.604637,-89.435667,0,'2013-07-06 12:44:33',NULL,NULL),(42676,'47969','P','Newtown','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.205844,-87.148287,0,'2013-07-06 12:44:32',NULL,NULL),(70450,'84747','S','Fremont','A','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.441923,-111.593130,0,'2013-07-06 12:44:34',NULL,NULL),(70927,'85634','S','Sells','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(59830,'71238','S','Eros','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.364300,-92.361480,0,'2013-07-06 12:44:33',NULL,NULL),(46833,'54016','S','Boardman','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.981880,-92.690820,0,'2013-07-06 12:44:32',NULL,NULL),(10445,'10916','S','Campbell Hall','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.437341,-74.250632,0,'2013-07-06 12:44:30',NULL,NULL),(16598,'17325','S','Gettysburg','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.851653,-77.260693,0,'2013-07-06 12:44:31',NULL,NULL),(24190,'26651','S','Summersville','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.285274,-80.844612,0,'2013-07-06 12:44:31',NULL,NULL),(19294,'19973','S','Seaford','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.638740,-75.610980,0,'2013-07-06 12:44:31',NULL,NULL),(46919,'54143','S','Marinette','D','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.091002,-87.625627,0,'2013-07-06 12:44:32',NULL,NULL),(25574,'28432','S','Clarendon','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.175534,-78.794338,0,'2013-07-06 12:44:31',NULL,NULL),(65205,'77435','S','East Bernard','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.527948,-96.061715,0,'2013-07-06 12:44:34',NULL,NULL),(4492,'03278','S','Warner','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.278960,-71.803980,0,'2013-07-06 12:44:30',NULL,NULL),(30430,'33329','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111170,-80.274605,0,'2013-07-06 12:44:32',NULL,NULL),(62751,'74845','S','Hanna','D','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.215556,-95.925556,0,'2013-07-06 12:44:33',NULL,NULL),(62424,'74146','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.104742,-95.852838,0,'2013-07-06 12:44:33',NULL,NULL),(51020,'58707','U','Minot State University','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.235211,-101.294711,0,'2013-07-06 12:44:33',NULL,NULL),(75129,'93554','P','Garlock','N','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.375287,-117.664370,0,'2013-07-06 12:44:34',NULL,NULL),(9889,'10128','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(75606,'94309','P','Palo Alto','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.416667,-122.166667,0,'2013-07-06 12:44:34',NULL,NULL),(22618,'24224','S','Castlewood','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.880080,-82.279800,0,'2013-07-06 12:44:31',NULL,NULL),(73805,'91756','U','Mont Park','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.047565,-118.132799,0,'2013-07-06 12:44:34',NULL,NULL),(68349,'81132','S','Baxterville','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.680294,-106.365099,0,'2013-07-06 12:44:34',NULL,NULL),(36018,'40165','S','Hebron Estates','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(55753,'64110','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.034852,-94.572350,0,'2013-07-06 12:44:33',NULL,NULL),(43906,'49251','S','Leslie','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.466322,-84.417115,0,'2013-07-06 12:44:32',NULL,NULL),(12704,'13147','S','Merrifield','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(55112,'63334','S','Bowling Green','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.339811,-91.197015,0,'2013-07-06 12:44:33',NULL,NULL),(74902,'93307','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.316665,-118.975058,0,'2013-07-06 12:44:34',NULL,NULL),(2067,'00920','S','Villa Borinquen','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(9032,'08875','P','Somerset','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.486000,-74.465000,0,'2013-07-06 12:44:30',NULL,NULL),(26791,'29455','S','Seabrook Isl','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.691291,-80.091155,0,'2013-07-06 12:44:31',NULL,NULL),(42948,'48123','P','Dearborn','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.312720,-83.214361,0,'2013-07-06 12:44:32',NULL,NULL),(69071,'83241','S','Lago','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(23804,'26039','S','Glen Easton','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.831746,-80.657573,0,'2013-07-06 12:44:31',NULL,NULL),(5004,'04220','S','Hartford','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.284737,-70.369237,0,'2013-07-06 12:44:30',NULL,NULL),(78517,'98119','S','Interbay','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.638776,-122.366173,0,'2013-07-06 12:44:34',NULL,NULL),(69974,'84120','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(29658,'32907','S','Palm Bay','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.015502,-80.669053,0,'2013-07-06 12:44:32',NULL,NULL),(7888,'07533','P','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.897871,-74.154273,0,'2013-07-06 12:44:30',NULL,NULL),(51888,'60094','P','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.099153,-88.097509,0,'2013-07-06 12:44:33',NULL,NULL),(47817,'55060','S','Havana','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087587,-93.221024,0,'2013-07-06 12:44:33',NULL,NULL),(45917,'52324','S','Palo','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.052140,-91.792470,0,'2013-07-06 12:44:32',NULL,NULL),(3258,'01452','S','Hubbardston','D','Worcester','25027','Massachusetts','MA','25','0000','978/351','Eastern',-5.0,'Y',42.487928,-72.007111,0,'2013-07-06 12:44:30',NULL,NULL),(27517,'30204','S','Barnesville','D','Lamar','13171','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.055571,-84.156933,0,'2013-07-06 12:44:31',NULL,NULL),(63721,'75930','S','Bronson','D','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.328700,-94.019700,0,'2013-07-06 12:44:34',NULL,NULL),(10242,'10467','S','Williamsbridge','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.873256,-73.870576,0,'2013-07-06 12:44:30',NULL,NULL),(78717,'98275','S','Mukilteo','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.907142,-122.309121,0,'2013-07-06 12:44:34',NULL,NULL),(8522,'08107','S','Haddon Township','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(6156,'05471','S','Hectorville','N','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.860467,-72.593608,0,'2013-07-06 12:44:30',NULL,NULL),(6346,'05672','S','Stowe','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.499684,-72.646502,0,'2013-07-06 12:44:30',NULL,NULL),(60510,'71666','P','McGehee','A','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.659552,-91.194003,0,'2013-07-06 12:44:33',NULL,NULL),(19831,'20500','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898187,-77.033118,0,'2013-07-06 12:44:31',NULL,NULL),(13598,'13851','P','Vestal','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.035931,-76.019579,0,'2013-07-06 12:44:31',NULL,NULL),(78692,'98251','S','Gold Bar','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.830143,-121.627916,0,'2013-07-06 12:44:34',NULL,NULL),(54953,'63119','S','Rock Hill','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.588549,-90.350542,0,'2013-07-06 12:44:33',NULL,NULL),(55861,'64180','U','Commerce Bank','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.101274,-94.582363,0,'2013-07-06 12:44:33',NULL,NULL),(20595,'21203','P','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.297206,-76.607966,0,'2013-07-06 12:44:31',NULL,NULL),(41893,'47371','S','College Cnr','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(54118,'62549','S','Mt Zion','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.785894,-88.870832,0,'2013-07-06 12:44:33',NULL,NULL),(76478,'95626','S','Elverta','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.723216,-121.454520,0,'2013-07-06 12:44:34',NULL,NULL),(13320,'13676','S','Slab City','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(55822,'64151','S','Houston Lake','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.210632,-94.629615,0,'2013-07-06 12:44:33',NULL,NULL),(14326,'14925','S','Elmira','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.115940,-76.761776,0,'2013-07-06 12:44:31',NULL,NULL),(29116,'32310','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.398031,-84.319879,0,'2013-07-06 12:44:32',NULL,NULL),(44774,'50211','S','Lakewood','N','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.464165,-93.687138,0,'2013-07-06 12:44:32',NULL,NULL),(18218,'18958','P','Salfordville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.297622,-75.441288,0,'2013-07-06 12:44:31',NULL,NULL),(41607,'47117','S','Rosewood','A','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.115905,-86.055376,0,'2013-07-06 12:44:32',NULL,NULL),(10197,'10307','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.509906,-74.239854,0,'2013-07-06 12:44:30',NULL,NULL),(49512,'56669','S','Ray','A','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.411180,-93.194700,0,'2013-07-06 12:44:33',NULL,NULL),(61425,'72571','S','Rosie','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.645202,-91.533615,0,'2013-07-06 12:44:33',NULL,NULL),(44076,'49448','S','Nunica','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.080133,-86.083807,0,'2013-07-06 12:44:32',NULL,NULL),(73511,'91340','S','San Fernando','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.285498,-118.431945,0,'2013-07-06 12:44:34',NULL,NULL),(23269,'25140','S','Sundial','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.897184,-81.525084,0,'2013-07-06 12:44:31',NULL,NULL),(22578,'24155','U','Roanoke','D','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.292570,-80.063621,0,'2013-07-06 12:44:31',NULL,NULL),(36641,'41005','S','Bullittsville','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(37625,'42142','P','Glasgow','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.997611,-85.906299,0,'2013-07-06 12:44:32',NULL,NULL),(70281,'84532','S','Canyonlands','N','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(49500,'56663','S','Blackduck','A','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.455328,-94.478035,0,'2013-07-06 12:44:33',NULL,NULL),(56443,'65275','S','Paris','D','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.481474,-92.009398,0,'2013-07-06 12:44:33',NULL,NULL),(77524,'96846','U','Bank of Hawaii','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.318332,-157.869521,0,'2013-07-06 12:44:34',NULL,NULL),(53097,'61532','S','Forest City','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.225226,-90.006004,0,'2013-07-06 12:44:33',NULL,NULL),(39353,'44627','S','Fredericksbg','N','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.689496,-81.854261,0,'2013-07-06 12:44:32',NULL,NULL),(15708,'16858','S','Morrisdale','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.015138,-78.225217,0,'2013-07-06 12:44:31',NULL,NULL),(4974,'04109','S','Great Diamond Island','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(43313,'48353','S','Hartland','D','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.624245,-83.707663,0,'2013-07-06 12:44:32',NULL,NULL),(62205,'73841','S','Fort Supply','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.568109,-99.569072,0,'2013-07-06 12:44:33',NULL,NULL),(146,'00617','S','Parc Palenque','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(54340,'62766','U','Hwy Accident Bureau','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.774254,-89.607845,0,'2013-07-06 12:44:33',NULL,NULL),(55475,'63748','S','Frohna','D','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.675720,-89.667036,0,'2013-07-06 12:44:33',NULL,NULL),(66559,'78736','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250073,-97.926724,0,'2013-07-06 12:44:34',NULL,NULL),(74082,'92182','U','San Diego State University','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.762178,-117.069156,0,'2013-07-06 12:44:34',NULL,NULL),(34603,'38748','S','James','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(8499,'08097','S','Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.831240,-75.151020,0,'2013-07-06 12:44:30',NULL,NULL),(61827,'73111','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.508822,-97.472580,0,'2013-07-06 12:44:33',NULL,NULL),(35362,'39440','S','Shady Grove','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(50382,'57761','S','New Underwood','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.095452,-102.832789,0,'2013-07-06 12:44:33',NULL,NULL),(75622,'94505','S','Discovery Bay','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.903278,-121.602226,0,'2013-07-06 12:44:34',NULL,NULL),(25139,'28018','S','Bostic','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(46780,'53956','S','Randolph','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.540343,-88.999032,0,'2013-07-06 12:44:32',NULL,NULL),(74783,'93117','S','Isla Vista','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.437147,-119.866076,0,'2013-07-06 12:44:34',NULL,NULL),(30972,'33741','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.688063,-82.733847,0,'2013-07-06 12:44:32',NULL,NULL),(34795,'38873','S','Paden','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.644991,-88.238561,0,'2013-07-06 12:44:32',NULL,NULL),(11011,'11557','S','Hewlett Bay Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.638779,-73.693176,0,'2013-07-06 12:44:30',NULL,NULL),(51167,'59003','S','Ashland','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.546223,-106.268659,0,'2013-07-06 12:44:33',NULL,NULL),(66127,'78426','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.840566,-97.597016,0,'2013-07-06 12:44:34',NULL,NULL),(75849,'94928','S','Cotati','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.343934,-122.699887,0,'2013-07-06 12:44:34',NULL,NULL),(9174,'09357','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(67383,'80122','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.580440,-104.955859,0,'2013-07-06 12:44:34',NULL,NULL),(66624,'78779','U','TX Dept of Motor Vehicles','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.348092,-97.768262,0,'2013-07-06 12:44:34',NULL,NULL),(55088,'63301','S','Kampville','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.847420,-90.477000,0,'2013-07-06 12:44:33',NULL,NULL),(48235,'55421','S','Hilltop','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(40144,'45345','S','New Lebanon','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.736169,-84.390776,0,'2013-07-06 12:44:32',NULL,NULL),(20989,'21814','S','Bivalve','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.294737,-75.893814,0,'2013-07-06 12:44:31',NULL,NULL),(14657,'15237','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.549733,-80.039957,0,'2013-07-06 12:44:31',NULL,NULL),(71838,'87581','S','Las Tablas','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.698574,-106.136233,0,'2013-07-06 12:44:34',NULL,NULL),(8740,'08520','S','East Windsor','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.255080,-74.515680,0,'2013-07-06 12:44:30',NULL,NULL),(25074,'27944','S','Hertford','D','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.149640,-76.348920,0,'2013-07-06 12:44:31',NULL,NULL),(9292,'09702','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(107,'00612','S','Urb Los Pinos II','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(27354,'30060','S','Atlanta Naval Air Station','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.936824,-84.529346,0,'2013-07-06 12:44:31',NULL,NULL),(41132,'46626','U','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.657277,-86.295067,0,'2013-07-06 12:44:32',NULL,NULL),(57997,'67860','S','Lakin','D','Kearny','20093','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.944208,-101.258073,0,'2013-07-06 12:44:33',NULL,NULL),(43187,'48301','S','Bloomfld Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(37574,'42081','S','Smithland','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.397500,-88.374722,0,'2013-07-06 12:44:32',NULL,NULL),(22105,'23421','S','Lee Mont','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.788179,-75.655317,0,'2013-07-06 12:44:31',NULL,NULL),(11244,'11758','S','East Massapequa','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.686884,-73.469397,0,'2013-07-06 12:44:30',NULL,NULL),(72225,'88434','S','Glenrio','A','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.263046,-103.265336,0,'2013-07-06 12:44:34',NULL,NULL),(65687,'77995','S','Terryville','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(58231,'68348','S','Elk Creek','D','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.327170,-96.135905,0,'2013-07-06 12:44:33',NULL,NULL),(12720,'13154','P','South Butler','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.133174,-76.762628,0,'2013-07-06 12:44:30',NULL,NULL),(78380,'98024','S','Lake Alice','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.561848,-121.901429,0,'2013-07-06 12:44:34',NULL,NULL),(57775,'67460','S','McPherson','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.387160,-97.656540,0,'2013-07-06 12:44:33',NULL,NULL),(8439,'08083','S','Somerdale','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.843005,-75.031535,0,'2013-07-06 12:44:30',NULL,NULL),(68832,'82515','P','Hudson','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.912358,-108.565970,0,'2013-07-06 12:44:34',NULL,NULL),(15133,'15840','S','Falls Creek','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.144291,-78.806764,0,'2013-07-06 12:44:31',NULL,NULL),(69580,'83836','S','East Hope','N','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.241015,-116.292794,0,'2013-07-06 12:44:34',NULL,NULL),(59780,'71207','P','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.515839,-92.115614,0,'2013-07-06 12:44:33',NULL,NULL),(28588,'31636','S','Lakepark','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.687100,-83.202030,0,'2013-07-06 12:44:32',NULL,NULL),(51671,'59919','P','Hungry Horse','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.389687,-114.063005,0,'2013-07-06 12:44:33',NULL,NULL),(46277,'53033','S','Hubertus','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.233131,-88.248081,0,'2013-07-06 12:44:32',NULL,NULL),(12323,'12864','P','Sabael','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.728403,-74.305522,0,'2013-07-06 12:44:30',NULL,NULL),(11126,'11706','S','Bayshore','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(45091,'50538','S','Farnhamville','D','Calhoun','19025','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.280038,-94.405502,0,'2013-07-06 12:44:32',NULL,NULL),(69120,'83278','S','Bonanza','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.330002,-114.863022,0,'2013-07-06 12:44:34',NULL,NULL),(8559,'08210','S','Burleigh','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(27845,'30427','S','Mendes','N','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.933927,-81.925339,0,'2013-07-06 12:44:31',NULL,NULL),(56267,'65064','S','Olean','D','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.401211,-92.525250,0,'2013-07-06 12:44:33',NULL,NULL),(49292,'56522','S','Doran','A','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.125900,-96.441780,0,'2013-07-06 12:44:33',NULL,NULL),(59720,'71107','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.608620,-93.862080,0,'2013-07-06 12:44:33',NULL,NULL),(59383,'70606','P','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.165337,-93.232376,0,'2013-07-06 12:44:33',NULL,NULL),(19808,'20442','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892812,-77.014512,0,'2013-07-06 12:44:31',NULL,NULL),(6860,'06131','P','Newington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688690,-72.729814,0,'2013-07-06 12:44:30',NULL,NULL),(35557,'39565','S','Ocean Springs','A','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.568555,-88.740289,0,'2013-07-06 12:44:32',NULL,NULL),(39465,'44709','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.839184,-81.389308,0,'2013-07-06 12:44:32',NULL,NULL),(64147,'76199','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.752429,-97.334282,0,'2013-07-06 12:44:34',NULL,NULL),(61511,'72653','S','Mtn Home','N','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.352620,-92.366700,0,'2013-07-06 12:44:33',NULL,NULL),(21572,'22831','S','Rawley Springs','N','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.485855,-79.006346,0,'2013-07-06 12:44:31',NULL,NULL),(55456,'63736','S','Benton','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.072200,-89.569800,0,'2013-07-06 12:44:33',NULL,NULL),(78429,'98052','S','Ames Lake','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.683648,-122.121837,0,'2013-07-06 12:44:34',NULL,NULL),(25125,'28001','S','River Haven','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(2660,'00966','S','Urb Gardenville','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(35015,'39150','S','Port Gibson','D','Claiborne','28021','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.957545,-90.981874,0,'2013-07-06 12:44:32',NULL,NULL),(44192,'49615','S','Bellaire','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.966845,-85.213130,0,'2013-07-06 12:44:32',NULL,NULL),(49018,'56264','S','Saint Leo','A','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.563139,-95.985774,0,'2013-07-06 12:44:33',NULL,NULL),(65227,'77447','S','Hockley','D','Harris','48201','Texas','TX','48','3360','936','Central',-6.0,'Y',30.028362,-95.819420,0,'2013-07-06 12:44:34',NULL,NULL),(79781,'99344','S','Hatton','A','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.819036,-119.168555,0,'2013-07-06 12:44:34',NULL,NULL),(29190,'32403','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.090395,-85.629069,0,'2013-07-06 12:44:32',NULL,NULL),(6307,'05660','S','Moretown','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.252162,-72.748572,0,'2013-07-06 12:44:30',NULL,NULL),(15497,'16504','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.111025,-80.049695,0,'2013-07-06 12:44:31',NULL,NULL),(45500,'51360','S','Egralharve','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(68641,'81638','S','Hamilton','D','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.331158,-107.548854,0,'2013-07-06 12:44:34',NULL,NULL),(53920,'62380','S','West Point','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.243500,-91.251600,0,'2013-07-06 12:44:33',NULL,NULL),(77542,'96854','S','Wheeler AAF','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.486300,-158.034751,0,'2013-07-06 12:44:34',NULL,NULL),(2327,'00934','S','Urb Coconut Grove','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413161,-66.131635,0,'2013-07-06 12:44:30',NULL,NULL),(17898,'18446','S','Nicholson','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.627472,-75.785332,0,'2013-07-06 12:44:31',NULL,NULL),(60928,'72084','S','Willow','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.219063,-92.603497,0,'2013-07-06 12:44:33',NULL,NULL),(61426,'72572','S','Saffell','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.917914,-91.298942,0,'2013-07-06 12:44:33',NULL,NULL),(12908,'13338','S','Forestport Station','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(66729,'78956','S','High Hill','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(27339,'30041','S','Cumming','D','Forsyth','13117','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.203077,-84.074322,0,'2013-07-06 12:44:31',NULL,NULL),(4099,'02673','S','W Yarmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.652840,-70.241220,0,'2013-07-06 12:44:30',NULL,NULL),(55546,'63848','S','Gideon','D','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.450950,-89.916845,0,'2013-07-06 12:44:33',NULL,NULL),(32513,'36082','U','Troy','D','Pike','01109','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.797868,-85.959935,0,'2013-07-06 12:44:32',NULL,NULL),(28296,'31098','S','South Base','A','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.611973,-83.596726,0,'2013-07-06 12:44:31',NULL,NULL),(77891,'97286','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.479834,-122.597889,0,'2013-07-06 12:44:34',NULL,NULL),(63777,'75951','S','Harrisburg','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(8895,'08731','S','Lacey','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.871860,-74.237760,0,'2013-07-06 12:44:30',NULL,NULL),(2282,'00926','S','Valle Sereno','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(77342,'96720','S','Hilo','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.701093,-155.094595,0,'2013-07-06 12:44:34',NULL,NULL),(76696,'95826','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.551130,-121.368699,0,'2013-07-06 12:44:34',NULL,NULL),(6783,'06105','S','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.769774,-72.699048,0,'2013-07-06 12:44:30',NULL,NULL),(6845,'06120','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.782640,-72.671860,0,'2013-07-06 12:44:30',NULL,NULL),(59749,'71151','U','Arkla Gas','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.514610,-93.747269,0,'2013-07-06 12:44:33',NULL,NULL),(53212,'61625','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.845091,-89.582017,0,'2013-07-06 12:44:33',NULL,NULL),(68283,'81082','S','Trinidad','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(31852,'35114','S','Maylene','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.239695,-86.861764,0,'2013-07-06 12:44:32',NULL,NULL),(57686,'67232','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.642922,-97.167324,0,'2013-07-06 12:44:33',NULL,NULL),(1430,'00739','S','Parc Gandara','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(68981,'83115','S','Daniel','D','Sublette','56035','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.894680,-110.178746,0,'2013-07-06 12:44:34',NULL,NULL),(43980,'49330','S','Kent City','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.238562,-85.725110,0,'2013-07-06 12:44:32',NULL,NULL),(66610,'78765','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.308282,-97.728923,0,'2013-07-06 12:44:34',NULL,NULL),(77687,'97037','S','Pine Grove','N','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.076963,-121.376099,0,'2013-07-06 12:44:34',NULL,NULL),(45455,'51240','S','Inwood','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.305410,-96.429125,0,'2013-07-06 12:44:32',NULL,NULL),(71933,'87901','S','Cuchillo','A','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.129932,-107.251636,0,'2013-07-06 12:44:34',NULL,NULL),(68959,'83001','S','Jackson','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472028,-110.766160,0,'2013-07-06 12:44:34',NULL,NULL),(15356,'16246','P','Plumville','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.791984,-79.177525,0,'2013-07-06 12:44:31',NULL,NULL),(69207,'83352','S','Lone Star','A','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.939059,-114.405702,0,'2013-07-06 12:44:34',NULL,NULL),(56214,'65035','S','Freeburg','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.336520,-91.928220,0,'2013-07-06 12:44:33',NULL,NULL),(52467,'60684','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.870185,-87.671984,0,'2013-07-06 12:44:33',NULL,NULL),(49828,'57220','S','Oakwood Lake','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.485116,-96.934663,0,'2013-07-06 12:44:33',NULL,NULL),(1505,'00751','S','Villa Natalia','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(66917,'79329','S','Idalou','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.663106,-101.685738,0,'2013-07-06 12:44:34',NULL,NULL),(59249,'70441','S','Chipola','N','Saint Helena','22091','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.885526,-90.749525,0,'2013-07-06 12:44:33',NULL,NULL),(20128,'20721','S','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.930700,-76.785600,0,'2013-07-06 12:44:31',NULL,NULL),(28980,'32212','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.209823,-81.688591,0,'2013-07-06 12:44:32',NULL,NULL),(52430,'60655','S','Merrionett pk','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.691946,-87.709304,0,'2013-07-06 12:44:33',NULL,NULL),(57920,'67665','S','Russell','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.891284,-98.858436,0,'2013-07-06 12:44:33',NULL,NULL),(54322,'62736','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803461,-89.651934,0,'2013-07-06 12:44:33',NULL,NULL),(71643,'87420','S','Biklabito','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.574461,-108.590087,0,'2013-07-06 12:44:34',NULL,NULL),(51509,'59645','S','White Sulphur Springs','D','Meagher','30059','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.539963,-110.910288,0,'2013-07-06 12:44:33',NULL,NULL),(6215,'05488','S','Green Corner','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(35078,'39202','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.310057,-90.176007,0,'2013-07-06 12:44:32',NULL,NULL),(8888,'08724','S','Brick','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.086348,-74.118215,0,'2013-07-06 12:44:30',NULL,NULL),(67938,'80910','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.816626,-104.777849,0,'2013-07-06 12:44:34',NULL,NULL),(66490,'78671','S','Stonewall','D','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.209657,-98.657123,0,'2013-07-06 12:44:34',NULL,NULL),(61783,'73072','S','Norman','D','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.229803,-97.504824,0,'2013-07-06 12:44:33',NULL,NULL),(19616,'20239','U','Bureau of Public Debt','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879588,-77.032458,0,'2013-07-06 12:44:31',NULL,NULL),(6286,'05641','S','Trow Hill','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(23520,'25562','P','Shoals','D','Wayne','54099','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.326274,-82.472411,0,'2013-07-06 12:44:31',NULL,NULL),(39276,'44471','S','Struthers','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.051161,-80.592557,0,'2013-07-06 12:44:32',NULL,NULL),(12058,'12533','S','Hopewell Junction','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.573590,-73.796075,0,'2013-07-06 12:44:30',NULL,NULL),(1588,'00769','S','Est De Hucar','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(8231,'07980','S','Stirling','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.682373,-74.491575,0,'2013-07-06 12:44:30',NULL,NULL),(57358,'66736','S','Lafontaine','A','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.535127,-95.823027,0,'2013-07-06 12:44:33',NULL,NULL),(36830,'41071','S','South Newport','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(15731,'16901','S','Ansonia','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.777500,-77.309722,0,'2013-07-06 12:44:31',NULL,NULL),(71854,'87701','S','Romeroville','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.590200,-105.198120,0,'2013-07-06 12:44:34',NULL,NULL),(3643,'02112','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.357680,-71.057630,0,'2013-07-06 12:44:30',NULL,NULL),(43937,'49282','S','Somerset Ctr','A','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.052162,-84.418064,0,'2013-07-06 12:44:32',NULL,NULL),(21836,'23123','S','New Canton','D','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.646155,-78.286693,0,'2013-07-06 12:44:31',NULL,NULL),(15481,'16438','S','Canadohta Lake','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.924956,-79.856530,0,'2013-07-06 12:44:31',NULL,NULL),(2168,'00926','S','BO Quebrada Arena','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(21121,'22095','U','Herndon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.968942,-77.388697,0,'2013-07-06 12:44:31',NULL,NULL),(50234,'57620','S','Govert','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(38079,'43071','S','Saint Louisville','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.177388,-82.375739,0,'2013-07-06 12:44:32',NULL,NULL),(77737,'97075','P','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.492495,-122.804650,0,'2013-07-06 12:44:34',NULL,NULL),(35011,'39148','P','Piney Woods','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.065400,-89.994420,0,'2013-07-06 12:44:32',NULL,NULL),(6707,'06065','S','Riverton','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.981983,-73.004395,0,'2013-07-06 12:44:30',NULL,NULL),(55603,'63944','S','Hiram','A','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.092403,-90.451140,0,'2013-07-06 12:44:33',NULL,NULL),(33173,'37029','S','Burns','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.040722,-87.257250,0,'2013-07-06 12:44:32',NULL,NULL),(79699,'99206','S','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.651979,-117.275650,0,'2013-07-06 12:44:34',NULL,NULL),(71020,'85731','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.222821,-110.758947,0,'2013-07-06 12:44:34',NULL,NULL),(47954,'55118','S','West Saint Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(37318,'41649','S','Risner','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.545706,-82.758667,0,'2013-07-06 12:44:32',NULL,NULL),(69051,'83229','S','Challis','A','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.111576,-114.436081,0,'2013-07-06 12:44:34',NULL,NULL),(10172,'10281','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.716680,-74.012932,0,'2013-07-06 12:44:30',NULL,NULL),(33302,'37131','U','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.853243,-86.396024,0,'2013-07-06 12:44:32',NULL,NULL),(1704,'00777','S','Urb Valencia 1','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(21424,'22548','P','Sharps','D','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.825730,-76.697914,0,'2013-07-06 12:44:31',NULL,NULL),(61399,'72543','S','Heber Springs','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.493501,-92.031852,0,'2013-07-06 12:44:33',NULL,NULL),(47370,'54622','S','Waumandee','A','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.271780,-91.873200,0,'2013-07-06 12:44:32',NULL,NULL),(44514,'49945','S','Lake Linden','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.174820,-88.410780,0,'2013-07-06 12:44:32',NULL,NULL),(22681,'24314','S','Cove Creek','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.161780,-81.198480,0,'2013-07-06 12:44:31',NULL,NULL),(13709,'14066','S','Gainesville','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.637334,-78.190857,0,'2013-07-06 12:44:31',NULL,NULL),(72530,'89164','U','Citibank','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.127669,-115.277477,0,'2013-07-06 12:44:34',NULL,NULL),(26804,'29466','S','Mount Pleasant','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.792155,-79.863357,0,'2013-07-06 12:44:31',NULL,NULL),(26478,'29154','S','Sumter','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.896794,-80.418858,0,'2013-07-06 12:44:31',NULL,NULL),(76957,'96041','S','Hayfork','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.511880,-123.235800,0,'2013-07-06 12:44:34',NULL,NULL),(69673,'84021','S','Arcadia','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.169700,-110.398451,0,'2013-07-06 12:44:34',NULL,NULL),(60207,'71419','S','Mitchell','A','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(65442,'77588','P','Pearland','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.553150,-95.273774,0,'2013-07-06 12:44:34',NULL,NULL),(79432,'98832','S','Krupp','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.461144,-118.922067,0,'2013-07-06 12:44:34',NULL,NULL),(78222,'97760','S','Terrebonne','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358649,-121.184384,0,'2013-07-06 12:44:34',NULL,NULL),(37225,'41537','S','Lionilli','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(40076,'45296','U','Central Trust Co','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.103702,-84.532826,0,'2013-07-06 12:44:32',NULL,NULL),(22964,'24701','S','Lorton Lick','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(66523,'78715','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.206573,-97.796232,0,'2013-07-06 12:44:34',NULL,NULL),(31817,'35058','S','Cullman','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.174458,-86.843089,0,'2013-07-06 12:44:32',NULL,NULL),(69376,'83605','S','Knowlton Heights','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(67926,'80908','S','Black Forest','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.046410,-104.669910,0,'2013-07-06 12:44:34',NULL,NULL),(16468,'17241','S','North Newton','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(64322,'76485','P','Peaster','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.871991,-97.869134,0,'2013-07-06 12:44:34',NULL,NULL),(63118,'75303','U','Jp Morgan Chase','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.780372,-96.776012,0,'2013-07-06 12:44:33',NULL,NULL),(55114,'63334','S','Saint Clement','N','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.339811,-91.197015,0,'2013-07-06 12:44:33',NULL,NULL),(42782,'48044','S','Macomb','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.651262,-82.925811,0,'2013-07-06 12:44:32',NULL,NULL),(34190,'38329','S','Decaturville','D','Decatur','47039','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.543475,-88.107852,0,'2013-07-06 12:44:32',NULL,NULL),(2435,'00953','S','Urb Monte Sol','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(77985,'97392','S','Marion','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.810901,-122.944478,0,'2013-07-06 12:44:34',NULL,NULL),(34822,'38915','S','Bruce','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.004880,-89.360460,0,'2013-07-06 12:44:32',NULL,NULL),(3880,'02366','P','South Carver','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.840594,-70.744534,0,'2013-07-06 12:44:30',NULL,NULL),(21052,'21903','S','Perryville','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.571241,-76.046209,0,'2013-07-06 12:44:31',NULL,NULL),(74487,'92615','P','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.656552,-117.969874,0,'2013-07-06 12:44:34',NULL,NULL),(77548,'96858','S','Fort Shafter','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.345974,-157.891047,0,'2013-07-06 12:44:34',NULL,NULL),(24287,'27006','S','Fork','N','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(70522,'85006','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.468847,-112.045503,0,'2013-07-06 12:44:34',NULL,NULL),(54615,'62914','S','Future City','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.009840,-89.180112,0,'2013-07-06 12:44:33',NULL,NULL),(54633,'62920','S','Cobden','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.533523,-89.254303,0,'2013-07-06 12:44:33',NULL,NULL),(58209,'68331','S','Cortland','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.503475,-96.706289,0,'2013-07-06 12:44:33',NULL,NULL),(60005,'71334','S','Doty Garden','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(41906,'47374','S','East Haven','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.833930,-84.891208,0,'2013-07-06 12:44:32',NULL,NULL),(5351,'04612','S','West Tremont','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.240559,-68.362155,0,'2013-07-06 12:44:30',NULL,NULL),(32878,'36527','S','Spanish Fort','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.682370,-87.868223,0,'2013-07-06 12:44:32',NULL,NULL),(30124,'33162','S','Miami Shores','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(3659,'02121','S','Dorchester','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.306015,-71.084811,0,'2013-07-06 12:44:30',NULL,NULL),(1479,'00745','S','Villas de Rio Grande','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(26824,'29484','P','Summ','N','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.016437,-80.203762,0,'2013-07-06 12:44:31',NULL,NULL),(50613,'58260','S','Milton','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629355,-97.990765,0,'2013-07-06 12:44:33',NULL,NULL),(37647,'42167','S','T Ville','A','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(63187,'75420','S','Brashear','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.120054,-95.726889,0,'2013-07-06 12:44:33',NULL,NULL),(76604,'95690','S','Locke','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.242080,-121.566000,0,'2013-07-06 12:44:34',NULL,NULL),(27956,'30546','S','Hiawassee','D','Towns','13281','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.910001,-83.712789,0,'2013-07-06 12:44:31',NULL,NULL),(14514,'15202','S','Emsworth','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(46170,'52732','S','Elvira','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.849037,-90.208697,0,'2013-07-06 12:44:32',NULL,NULL),(54212,'62643','S','Hartsburg','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.252616,-89.439891,0,'2013-07-06 12:44:33',NULL,NULL),(35337,'39437','S','Ellisville','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(39864,'45201','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.108786,-84.501246,0,'2013-07-06 12:44:32',NULL,NULL),(48444,'55705','S','White','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.498700,-92.235780,0,'2013-07-06 12:44:33',NULL,NULL),(3403,'01701','S','Framingham','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.315117,-71.434120,0,'2013-07-06 12:44:30',NULL,NULL),(27643,'30319','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.875460,-84.333398,0,'2013-07-06 12:44:31',NULL,NULL),(65552,'77837','S','Calvert','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',30.976170,-96.667791,0,'2013-07-06 12:44:34',NULL,NULL),(59527,'70806','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.447231,-91.129088,0,'2013-07-06 12:44:33',NULL,NULL),(53070,'61520','S','Canton','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.516944,-89.908333,0,'2013-07-06 12:44:33',NULL,NULL),(52069,'60303','P','Oak Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.889253,-87.790848,0,'2013-07-06 12:44:33',NULL,NULL),(2809,'00976','S','Urb San Rafael Vlg','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(40732,'46128','S','Fillmore','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.651369,-86.745964,0,'2013-07-06 12:44:32',NULL,NULL),(27298,'30010','P','Peachtree Corners','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.966056,-84.218437,0,'2013-07-06 12:44:31',NULL,NULL),(25347,'28223','U','Unc Charlotte','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.327415,-80.759956,0,'2013-07-06 12:44:31',NULL,NULL),(39428,'44681','S','Shanesville','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.512840,-81.678300,0,'2013-07-06 12:44:32',NULL,NULL),(52138,'60435','S','Stateville','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.552040,-88.111620,0,'2013-07-06 12:44:33',NULL,NULL),(62798,'74930','S','Bokoshe','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.126751,-94.801363,0,'2013-07-06 12:44:33',NULL,NULL),(10087,'10211','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.731775,-73.989953,0,'2013-07-06 12:44:30',NULL,NULL),(7757,'07401','S','Allendale','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.032472,-74.133730,0,'2013-07-06 12:44:30',NULL,NULL),(30322,'33307','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181193,-80.277948,0,'2013-07-06 12:44:32',NULL,NULL),(11874,'12305','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.814529,-73.943411,0,'2013-07-06 12:44:30',NULL,NULL),(49967,'57353','S','Bancroft','A','Kingsbury','46077','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.365169,-97.849047,0,'2013-07-06 12:44:33',NULL,NULL),(28323,'31145','P','Northlake','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.853136,-84.279625,0,'2013-07-06 12:44:31',NULL,NULL),(27852,'30436','S','Cedar Crossing','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.201196,-82.323239,0,'2013-07-06 12:44:31',NULL,NULL),(21988,'23261','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.548641,-77.458413,0,'2013-07-06 12:44:31',NULL,NULL),(36662,'41010','S','Corinth','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.539046,-84.590182,0,'2013-07-06 12:44:32',NULL,NULL),(24341,'27031','P','White Plains','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.445556,-80.633611,0,'2013-07-06 12:44:31',NULL,NULL),(29953,'33073','S','Parkland','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.305181,-80.187797,0,'2013-07-06 12:44:32',NULL,NULL),(4840,'04008','S','Bowdoinham','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.012016,-69.889526,0,'2013-07-06 12:44:30',NULL,NULL),(1113,'00725','S','Urb Santa Elvira','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(28953,'32193','S','Welaka','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.480929,-81.672079,0,'2013-07-06 12:44:32',NULL,NULL),(54716,'62959','S','Marion','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.722939,-88.873368,0,'2013-07-06 12:44:33',NULL,NULL),(6987,'06247','S','Hampton','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.765695,-72.061672,0,'2013-07-06 12:44:30',NULL,NULL),(7832,'07460','S','Silver Lake','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(68892,'82720','S','Hulett','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.694848,-104.748765,0,'2013-07-06 12:44:34',NULL,NULL),(8086,'07758','S','Cedar Beach','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.430608,-74.106861,0,'2013-07-06 12:44:30',NULL,NULL),(67904,'80902','S','Ft Carson','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.759197,-104.809176,0,'2013-07-06 12:44:34',NULL,NULL),(3424,'01731','S','Hanscom AFB','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.453933,-71.278811,0,'2013-07-06 12:44:30',NULL,NULL),(48336,'55467','U','Wells Fargo Home Mortgage','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.980000,-93.263611,0,'2013-07-06 12:44:33',NULL,NULL),(10116,'10259','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(3850,'02348','U','Lakeville','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.877314,-70.946435,0,'2013-07-06 12:44:30',NULL,NULL),(46982,'54227','S','Maribel','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.283146,-87.809314,0,'2013-07-06 12:44:32',NULL,NULL),(65714,'78017','S','Divot','N','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',28.689120,-99.196560,0,'2013-07-06 12:44:34',NULL,NULL),(17240,'17837','S','Kelly','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(31615,'34689','S','Tarpon Spgs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143816,-82.747935,0,'2013-07-06 12:44:32',NULL,NULL),(51480,'59545','S','Whitlash','D','Liberty','30051','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.839116,-111.102519,0,'2013-07-06 12:44:33',NULL,NULL),(20616,'21210','S','Roland Park','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.354360,-76.635912,0,'2013-07-06 12:44:31',NULL,NULL),(62313,'74036','S','Inala','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147671,-95.509727,0,'2013-07-06 12:44:33',NULL,NULL),(70171,'84323','P','Logan','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.684762,-111.649874,0,'2013-07-06 12:44:34',NULL,NULL),(11899,'12402','P','Kingston','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.932386,-74.032331,0,'2013-07-06 12:44:30',NULL,NULL),(71896,'87745','S','Sapello','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.593889,-105.216667,0,'2013-07-06 12:44:34',NULL,NULL),(61030,'72117','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(78755,'98295','S','Sumas','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.964647,-122.202847,0,'2013-07-06 12:44:34',NULL,NULL),(33766,'37863','S','Sevierville','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.793902,-83.562814,0,'2013-07-06 12:44:32',NULL,NULL),(26888,'29567','S','Little Rock','D','Dillon','45033','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.405781,-79.303152,0,'2013-07-06 12:44:31',NULL,NULL),(451,'00662','S','Urb Salvador Rios','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(14967,'15628','S','Donegal','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.096836,-79.382949,0,'2013-07-06 12:44:31',NULL,NULL),(42675,'47968','S','New Ross','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.997991,-86.751969,0,'2013-07-06 12:44:32',NULL,NULL),(68288,'81089','S','Farista','A','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(191,'00623','S','Urb Ana Maria','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(43023,'48168','S','Northville','D','Wayne','26163','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.410700,-83.499300,0,'2013-07-06 12:44:32',NULL,NULL),(42157,'47522','S','Crane Nav Weap Spt','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.896688,-86.900331,0,'2013-07-06 12:44:32',NULL,NULL),(69565,'83821','S','Coolin','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.498602,-116.837884,0,'2013-07-06 12:44:34',NULL,NULL),(37280,'41604','S','Harold','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.369321,-82.670590,0,'2013-07-06 12:44:32',NULL,NULL),(63130,'75342','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.769998,-96.863516,0,'2013-07-06 12:44:33',NULL,NULL),(63027,'75189','S','Royse City','D','Rockwall','48397','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.966297,-96.303766,0,'2013-07-06 12:44:33',NULL,NULL),(54600,'62907','S','Ava','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.882657,-89.448679,0,'2013-07-06 12:44:33',NULL,NULL),(45325,'50854','S','Mount Ayr','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.714841,-94.236952,0,'2013-07-06 12:44:32',NULL,NULL),(35352,'39440','S','Hoy','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(77097,'96140','P','Carnelian Bay','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(72237,'88513','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810823,-106.419673,0,'2013-07-06 12:44:34',NULL,NULL),(13618,'13865','S','W Windsor','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.064020,-75.640380,0,'2013-07-06 12:44:31',NULL,NULL),(32669,'36264','S','Heflin','D','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.647368,-85.584872,0,'2013-07-06 12:44:32',NULL,NULL),(35998,'40144','S','Harned','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.750620,-86.371080,0,'2013-07-06 12:44:32',NULL,NULL),(33970,'38108','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.180649,-89.954309,0,'2013-07-06 12:44:32',NULL,NULL),(69925,'84111','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.753460,-111.879217,0,'2013-07-06 12:44:34',NULL,NULL),(76986,'96065','S','Montgomry Crk','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.971399,-122.000991,0,'2013-07-06 12:44:34',NULL,NULL),(47604,'54874','S','South Range','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.558560,-91.920960,0,'2013-07-06 12:44:33',NULL,NULL),(56940,'66085','S','Stilwell','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.800200,-94.647263,0,'2013-07-06 12:44:33',NULL,NULL),(5050,'04270','S','Otisfield','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.094340,-70.531443,0,'2013-07-06 12:44:30',NULL,NULL),(59745,'71148','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.457200,-93.777759,0,'2013-07-06 12:44:33',NULL,NULL),(14171,'14737','S','Franklinville','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.333354,-78.431625,0,'2013-07-06 12:44:31',NULL,NULL),(52592,'61014','S','Chadwick','D','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.919179,-89.829510,0,'2013-07-06 12:44:33',NULL,NULL),(35279,'39401','S','Barrontown','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(45995,'52501','S','Ottumwa Junction','N','Wapello','19179','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.018213,-92.416533,0,'2013-07-06 12:44:32',NULL,NULL),(45668,'52036','S','Delaware','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.483688,-91.267338,0,'2013-07-06 12:44:32',NULL,NULL),(42833,'48066','S','Roseville','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.503558,-82.936991,0,'2013-07-06 12:44:32',NULL,NULL),(18681,'19185','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.891542,-75.169424,0,'2013-07-06 12:44:31',NULL,NULL),(59121,'70154','U','Hibernia Natl Bank','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.920683,-90.097011,0,'2013-07-06 12:44:33',NULL,NULL),(76151,'95304','S','Banta','A','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.727820,-121.413900,0,'2013-07-06 12:44:34',NULL,NULL),(75908,'95002','P','San Jose','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.427296,-121.970884,0,'2013-07-06 12:44:34',NULL,NULL),(25768,'28594','S','Emerald Isle','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.663620,-77.005080,0,'2013-07-06 12:44:31',NULL,NULL),(46723,'53812','P','Kieler','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.580498,-90.597992,0,'2013-07-06 12:44:32',NULL,NULL),(11967,'12459','P','New Kingston','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.211411,-74.683175,0,'2013-07-06 12:44:30',NULL,NULL),(67197,'79907','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.711168,-106.331389,0,'2013-07-06 12:44:34',NULL,NULL),(60629,'71901','S','Hot Springs National Park','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(54395,'62821','S','Carmi','D','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.066220,-88.138320,0,'2013-07-06 12:44:33',NULL,NULL),(13017,'13421','S','Oneida Castle','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.064220,-75.648180,0,'2013-07-06 12:44:30',NULL,NULL),(43874,'49201','S','Jackson','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.248579,-84.384984,0,'2013-07-06 12:44:32',NULL,NULL),(29372,'32591','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.417805,-87.225370,0,'2013-07-06 12:44:32',NULL,NULL),(11474,'12018','S','Dunham Hollow','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.640620,-73.549500,0,'2013-07-06 12:44:30',NULL,NULL),(72721,'89496','U','Fallon Naval Air Station','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.477965,-118.780330,0,'2013-07-06 12:44:34',NULL,NULL),(46858,'54024','S','St Croix Falls','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.412894,-92.633615,0,'2013-07-06 12:44:32',NULL,NULL),(64486,'76621','S','Abbott','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.900080,-97.074180,0,'2013-07-06 12:44:34',NULL,NULL),(18211,'18951','S','Quakertown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.442831,-75.354501,0,'2013-07-06 12:44:31',NULL,NULL),(32707,'36280','S','Newell','A','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.357551,-85.348233,0,'2013-07-06 12:44:32',NULL,NULL),(46803,'54002','S','Rush River','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.974620,-92.350320,0,'2013-07-06 12:44:32',NULL,NULL),(60284,'71450','S','Ajax','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.793040,-93.399660,0,'2013-07-06 12:44:33',NULL,NULL),(51400,'59430','S','Denton','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.320831,-109.946899,0,'2013-07-06 12:44:33',NULL,NULL),(51084,'58763','S','Charlson','A','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.972700,-102.481620,0,'2013-07-06 12:44:33',NULL,NULL),(72257,'88534','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.812302,-106.417034,0,'2013-07-06 12:44:34',NULL,NULL),(34084,'38152','U','University of Memphis','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.120123,-89.939705,0,'2013-07-06 12:44:32',NULL,NULL),(10827,'11380','P','Elmhurst','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742946,-73.884618,0,'2013-07-06 12:44:30',NULL,NULL),(26060,'28692','S','Vilas','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273369,-81.786913,0,'2013-07-06 12:44:31',NULL,NULL),(33060,'36762','S','Morvin','D','Clarke','01025','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.985556,-87.993333,0,'2013-07-06 12:44:32',NULL,NULL),(66999,'79505','S','Benjamin','D','Knox','48275','Texas','TX','48','0000','940','Central',-6.0,'Y',33.633757,-99.797004,0,'2013-07-06 12:44:34',NULL,NULL),(72189,'88355','P','Ruidoso','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.367490,-105.643813,0,'2013-07-06 12:44:34',NULL,NULL),(60525,'71671','S','Carmel','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.609178,-92.070158,0,'2013-07-06 12:44:33',NULL,NULL),(64755,'76935','S','Christoval','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.198516,-100.534953,0,'2013-07-06 12:44:34',NULL,NULL),(28018,'30624','S','Bowman','D','Elbert','13105','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.094349,-82.818421,0,'2013-07-06 12:44:31',NULL,NULL),(5474,'04741','P','Estcourt Station','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.442350,-69.210741,0,'2013-07-06 12:44:30',NULL,NULL),(2931,'01022','S','Westover AFB','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.194752,-72.561933,0,'2013-07-06 12:44:30',NULL,NULL),(16009,'17040','S','Lebo','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.311569,-77.333589,0,'2013-07-06 12:44:31',NULL,NULL),(36656,'41007','S','Gubser Mill','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.894989,-84.294749,0,'2013-07-06 12:44:32',NULL,NULL),(78043,'97440','P','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.060728,-123.113894,0,'2013-07-06 12:44:34',NULL,NULL),(78327,'97917','S','Riverside','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.508121,-118.099310,0,'2013-07-06 12:44:34',NULL,NULL),(3534,'01905','S','Lynn','D','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.464742,-70.973863,0,'2013-07-06 12:44:30',NULL,NULL),(63284,'75556','S','Bloomburg','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.135162,-94.065436,0,'2013-07-06 12:44:33',NULL,NULL),(42816,'48059','S','Fort Gratiot Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(45457,'51241','S','Larchwood','D','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.453490,-96.435021,0,'2013-07-06 12:44:32',NULL,NULL),(50948,'58601','S','Dickinson','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.882628,-102.783495,0,'2013-07-06 12:44:33',NULL,NULL),(72352,'89019','S','Sandy Valley','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.804011,-115.635842,0,'2013-07-06 12:44:34',NULL,NULL),(67116,'79735','S','Fort Stockton','D','Pecos','48371','Texas','TX','48','0000','432','Central',-6.0,'Y',30.887216,-102.881646,0,'2013-07-06 12:44:34',NULL,NULL),(64418,'76550','S','Naruna','N','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.066265,-98.180696,0,'2013-07-06 12:44:34',NULL,NULL),(54478,'62859','S','Piopolis','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(37016,'41232','S','Lowmansville','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.000588,-82.715329,0,'2013-07-06 12:44:32',NULL,NULL),(14189,'14754','S','Little Genese','A','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.024649,-78.183950,0,'2013-07-06 12:44:31',NULL,NULL),(36695,'41017','S','Crescent Springs','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(10587,'11023','S','Saddle Rock','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.798973,-73.733349,0,'2013-07-06 12:44:30',NULL,NULL),(1327,'00735','S','Villa Flores','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(8446,'08085','S','Woolwich','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(16087,'17050','S','Trindle Sprg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(22919,'24609','S','Steeleburg','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083840,-81.768540,0,'2013-07-06 12:44:31',NULL,NULL),(33271,'37098','S','Lyles','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.888030,-87.337285,0,'2013-07-06 12:44:32',NULL,NULL),(31386,'34218','P','Bradenton Beach','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.501540,-82.709820,0,'2013-07-06 12:44:32',NULL,NULL),(34579,'38737','S','Fitzhugh','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(5169,'04429','S','Dedham','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.761927,-68.642786,0,'2013-07-06 12:44:30',NULL,NULL),(29024,'32228','P','Mayport','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(43600,'48763','S','Tawas City','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.265786,-83.563369,0,'2013-07-06 12:44:32',NULL,NULL),(41115,'46573','S','Wakarusa','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.537809,-86.082369,0,'2013-07-06 12:44:32',NULL,NULL),(73631,'91412','P','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.222076,-118.446033,0,'2013-07-06 12:44:34',NULL,NULL),(21787,'23071','S','Hartfield','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.559740,-76.480914,0,'2013-07-06 12:44:31',NULL,NULL),(26196,'28771','S','Robbinsville','D','Graham','37075','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.346072,-83.874306,0,'2013-07-06 12:44:31',NULL,NULL),(11604,'12089','P','Hoosick','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.864306,-73.327143,0,'2013-07-06 12:44:30',NULL,NULL),(68373,'81140','S','Morgan','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.308960,-106.035240,0,'2013-07-06 12:44:34',NULL,NULL),(41875,'47362','S','New Castle','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.919560,-85.340280,0,'2013-07-06 12:44:32',NULL,NULL),(26004,'28675','S','Edwards Crossroads','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.506191,-81.117283,0,'2013-07-06 12:44:31',NULL,NULL),(70529,'85013','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.509914,-112.080218,0,'2013-07-06 12:44:34',NULL,NULL),(44310,'49737','P','Harbor Springs','A','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.562761,-85.097009,0,'2013-07-06 12:44:32',NULL,NULL),(14705,'15264','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.444220,-79.955987,0,'2013-07-06 12:44:31',NULL,NULL),(35169,'39269','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.299021,-90.185387,0,'2013-07-06 12:44:32',NULL,NULL),(55601,'63943','S','Grandin','D','Carter','29035','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.816255,-90.766353,0,'2013-07-06 12:44:33',NULL,NULL),(32668,'36264','S','Chulafinnee','N','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.647368,-85.584872,0,'2013-07-06 12:44:32',NULL,NULL),(73221,'90631','S','La Habra Heights','A','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.941040,-117.954420,0,'2013-07-06 12:44:34',NULL,NULL),(21841,'23128','S','James Store','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.468590,-76.377198,0,'2013-07-06 12:44:31',NULL,NULL),(55947,'64484','S','Rushville','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.587737,-95.016396,0,'2013-07-06 12:44:33',NULL,NULL),(26558,'29209','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(45757,'52142','S','Lima','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.857326,-91.809593,0,'2013-07-06 12:44:32',NULL,NULL),(74829,'93234','S','Huron','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.185731,-120.092781,0,'2013-07-06 12:44:34',NULL,NULL),(13792,'14172','S','Wilson','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.276519,-78.809408,0,'2013-07-06 12:44:31',NULL,NULL),(31131,'33903','S','North Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(33984,'38114','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.102122,-89.980902,0,'2013-07-06 12:44:32',NULL,NULL),(41782,'47306','U','Ball State Univ','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.200890,-85.407098,0,'2013-07-06 12:44:32',NULL,NULL),(79035,'98398','P','Paradise','A','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',46.782679,-121.742713,0,'2013-07-06 12:44:34',NULL,NULL),(42811,'48054','S','East China Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.767172,-82.540934,0,'2013-07-06 12:44:32',NULL,NULL),(23477,'25504','S','Barboursville','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.394409,-82.284654,0,'2013-07-06 12:44:31',NULL,NULL),(71059,'85755','S','Oro Valley','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.448600,-110.964800,0,'2013-07-06 12:44:34',NULL,NULL),(64817,'77028','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.826296,-95.287438,0,'2013-07-06 12:44:34',NULL,NULL),(44856,'50275','S','Woodburn','D','Clarke','19039','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.983826,-93.616934,0,'2013-07-06 12:44:32',NULL,NULL),(25001,'27870','S','Roanoke Rapids Air Force Sta','A','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.451430,-77.655125,0,'2013-07-06 12:44:31',NULL,NULL),(20147,'20731','P','Capitol Hgts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.887677,-76.912147,0,'2013-07-06 12:44:31',NULL,NULL),(39734,'45068','S','Corwin','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.520020,-84.073920,0,'2013-07-06 12:44:32',NULL,NULL),(63891,'76017','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.656676,-97.160065,0,'2013-07-06 12:44:34',NULL,NULL),(63709,'75903','P','Lufkin','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.355643,-94.767354,0,'2013-07-06 12:44:34',NULL,NULL),(72570,'89318','P','Mc Gill','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.391389,-114.786899,0,'2013-07-06 12:44:34',NULL,NULL),(36022,'40165','S','Pioneer Village','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(35274,'39365','S','Union','D','Neshoba','28099','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.570827,-89.121425,0,'2013-07-06 12:44:32',NULL,NULL),(30982,'33756','S','Belleair','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.945940,-82.788362,0,'2013-07-06 12:44:32',NULL,NULL),(51075,'58759','S','Prairieview','N','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.819626,-101.296615,0,'2013-07-06 12:44:33',NULL,NULL),(15495,'16502','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.111146,-80.101825,0,'2013-07-06 12:44:31',NULL,NULL),(20231,'20775','P','Kettering','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.782687,-76.767816,0,'2013-07-06 12:44:31',NULL,NULL),(16719,'17406','S','Hellam','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(60239,'71432','S','Selma','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.738200,-92.391755,0,'2013-07-06 12:44:33',NULL,NULL),(20462,'21030','S','Cockeysville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.491520,-76.660860,0,'2013-07-06 12:44:31',NULL,NULL),(45290,'50704','P','Waterloo','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.527686,-92.271674,0,'2013-07-06 12:44:32',NULL,NULL),(76412,'95555','S','Orick','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',41.286807,-124.069950,0,'2013-07-06 12:44:34',NULL,NULL),(64757,'76936','S','Eldorado AFS','A','Schleicher','48413','Texas','TX','48','0000','325','Central',-6.0,'Y',30.861414,-100.591893,0,'2013-07-06 12:44:34',NULL,NULL),(78557,'98155','S','Forest Park','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(1226,'00728','S','Valle Altamira','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(5698,'04981','S','Stockton Springs','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.533378,-68.860272,0,'2013-07-06 12:44:30',NULL,NULL),(32744,'36330','S','Enterprise','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.325580,-85.844682,0,'2013-07-06 12:44:32',NULL,NULL),(59076,'70116','S','Custom House','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.967019,-90.068695,0,'2013-07-06 12:44:33',NULL,NULL),(55121,'63341','S','Defiance','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.664113,-90.817080,0,'2013-07-06 12:44:33',NULL,NULL),(50503,'58065','S','Pillsbury','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.207337,-97.798558,0,'2013-07-06 12:44:33',NULL,NULL),(44763,'50207','S','Lacey','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.467705,-92.649644,0,'2013-07-06 12:44:32',NULL,NULL),(701,'00685','S','Urb Pedro T Labayen','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(31443,'34277','P','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.336078,-82.324780,0,'2013-07-06 12:44:32',NULL,NULL),(72428,'89070','U','Indian Springs','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570319,-115.668132,0,'2013-07-06 12:44:34',NULL,NULL),(76362,'95493','S','Upper Lake','A','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.186429,-122.962942,0,'2013-07-06 12:44:34',NULL,NULL),(9954,'10158','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755219,-73.966956,0,'2013-07-06 12:44:30',NULL,NULL),(15382,'16316','S','Geneva','N','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.622180,-80.309520,0,'2013-07-06 12:44:31',NULL,NULL),(43971,'49320','P','Chippewa Lake','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.762265,-85.287660,0,'2013-07-06 12:44:32',NULL,NULL),(31911,'35150','S','Talladega Springs','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.175189,-86.255713,0,'2013-07-06 12:44:32',NULL,NULL),(31335,'34137','P','Copeland','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.946921,-81.358399,0,'2013-07-06 12:44:32',NULL,NULL),(4208,'02832','S','Richmond','A','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.502720,-71.731380,0,'2013-07-06 12:44:30',NULL,NULL),(79875,'99569','P','Clarks Point','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.834619,-157.985930,0,'2013-07-06 12:44:34',NULL,NULL),(78257,'97840','S','Oxbow','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.956612,-116.923026,0,'2013-07-06 12:44:34',NULL,NULL),(38697,'44001','S','S Amherst','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(34334,'38567','S','Hickman','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.106232,-85.908114,0,'2013-07-06 12:44:32',NULL,NULL),(17622,'18049','S','Emmaus','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.534857,-75.505965,0,'2013-07-06 12:44:31',NULL,NULL),(61091,'72134','S','Aberdeen','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.603333,-91.341667,0,'2013-07-06 12:44:33',NULL,NULL),(26588,'29223','S','North Pointe','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.088460,-80.922870,0,'2013-07-06 12:44:31',NULL,NULL),(51952,'60134','S','Geneva','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.887291,-88.309915,0,'2013-07-06 12:44:33',NULL,NULL),(34223,'38366','S','Pinson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.487021,-88.741874,0,'2013-07-06 12:44:32',NULL,NULL),(58568,'68826','S','Central City','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.111822,-98.002519,0,'2013-07-06 12:44:33',NULL,NULL),(53622,'62090','S','Venice','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.668857,-90.167405,0,'2013-07-06 12:44:33',NULL,NULL),(42612,'47901','S','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.415409,-86.892088,0,'2013-07-06 12:44:32',NULL,NULL),(50527,'58104','S','Briarwood','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.819706,-96.808039,0,'2013-07-06 12:44:33',NULL,NULL),(70493,'84773','S','Grover','N','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.283757,-111.472299,0,'2013-07-06 12:44:34',NULL,NULL),(22386,'23941','P','Fort Mitchell','D','Lunenburg','51111','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.917169,-78.488229,0,'2013-07-06 12:44:31',NULL,NULL),(45245,'50655','S','Maynard','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.774721,-91.881839,0,'2013-07-06 12:44:32',NULL,NULL),(28033,'30642','S','Reynolds Plantation','N','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.556831,-83.171996,0,'2013-07-06 12:44:31',NULL,NULL),(24747,'27531','S','Goldsboro','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.380000,-77.990000,0,'2013-07-06 12:44:31',NULL,NULL),(68405,'81155','S','Bonanza City','N','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.248665,-106.081758,0,'2013-07-06 12:44:34',NULL,NULL),(7214,'06493','U','Wallingford','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.486804,-72.822757,0,'2013-07-06 12:44:30',NULL,NULL),(21299,'22403','P','Falmouth','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.350856,-77.477360,0,'2013-07-06 12:44:31',NULL,NULL),(63198,'75433','S','Cumby','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.137761,-95.841890,0,'2013-07-06 12:44:33',NULL,NULL),(59213,'70395','S','Schriever','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.713283,-90.830197,0,'2013-07-06 12:44:33',NULL,NULL),(55628,'63967','S','Williamsville','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.961217,-90.489841,0,'2013-07-06 12:44:33',NULL,NULL),(52009,'60172','S','Roselle','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.977560,-88.073640,0,'2013-07-06 12:44:33',NULL,NULL),(42569,'47875','P','Saint Bernice','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.755202,-87.487061,0,'2013-07-06 12:44:32',NULL,NULL),(9652,'10038','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(40495,'45801','S','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.759246,-84.070041,0,'2013-07-06 12:44:32',NULL,NULL),(35235,'39323','S','Chunky','D','Newton','28101','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.256145,-88.948437,0,'2013-07-06 12:44:32',NULL,NULL),(24580,'27316','S','Parks Crossroads','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.703120,-79.624200,0,'2013-07-06 12:44:31',NULL,NULL),(74989,'93447','P','Paso Robles','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.658885,-120.695350,0,'2013-07-06 12:44:34',NULL,NULL),(20955,'21778','S','Rocky Ridge','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.614180,-77.340644,0,'2013-07-06 12:44:31',NULL,NULL),(2800,'00976','S','Urb Monte Trujillo','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(24369,'27052','S','Walnut Cove','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.313380,-80.155080,0,'2013-07-06 12:44:31',NULL,NULL),(16770,'17522','S','Farmersville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(46248,'53005','S','Brookfield','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.064855,-88.104493,0,'2013-07-06 12:44:32',NULL,NULL),(35575,'39571','S','Pass Chris','A','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.367611,-89.262586,0,'2013-07-06 12:44:32',NULL,NULL),(28422,'31329','S','Springfield','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.369473,-81.309239,0,'2013-07-06 12:44:32',NULL,NULL),(70514,'84790','S','St George','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.080345,-113.575391,0,'2013-07-06 12:44:34',NULL,NULL),(19826,'20469','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895209,-77.041986,0,'2013-07-06 12:44:31',NULL,NULL),(10619,'11050','S','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(26249,'28906','S','Murphy','D','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.067300,-84.126180,0,'2013-07-06 12:44:31',NULL,NULL),(56878,'66025','S','Eudora','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.941893,-95.101497,0,'2013-07-06 12:44:33',NULL,NULL),(31231,'33970','P','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.606435,-81.665841,0,'2013-07-06 12:44:32',NULL,NULL),(46347,'53094','S','Watertown','D','Jefferson','55055','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.187721,-88.723178,0,'2013-07-06 12:44:32',NULL,NULL),(29031,'32231','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.289991,-81.633454,0,'2013-07-06 12:44:32',NULL,NULL),(43672,'48861','S','Mulliken','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.723713,-84.924432,0,'2013-07-06 12:44:32',NULL,NULL),(6689,'06050','P','New Britain','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.673633,-72.778821,0,'2013-07-06 12:44:30',NULL,NULL),(3163,'01266','S','W Stockbridge','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.333061,-73.380396,0,'2013-07-06 12:44:30',NULL,NULL),(43154,'48255','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331409,-83.051738,0,'2013-07-06 12:44:32',NULL,NULL),(67525,'80248','P','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.748464,-104.999727,0,'2013-07-06 12:44:34',NULL,NULL),(65944,'78259','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.626494,-98.445839,0,'2013-07-06 12:44:34',NULL,NULL),(57232,'66512','S','Meriden','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.188271,-95.569174,0,'2013-07-06 12:44:33',NULL,NULL),(53906,'62366','S','Pleasant Hill','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.440122,-90.871294,0,'2013-07-06 12:44:33',NULL,NULL),(50200,'57570','P','Yankton Indian Reservation','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.268101,-100.736849,0,'2013-07-06 12:44:33',NULL,NULL),(44128,'49509','S','Grand Rapids','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.883860,-85.706160,0,'2013-07-06 12:44:32',NULL,NULL),(44088,'49458','P','Walhalla','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.943890,-86.099220,0,'2013-07-06 12:44:32',NULL,NULL),(12415,'12939','P','Gabriels','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.432868,-74.178382,0,'2013-07-06 12:44:30',NULL,NULL),(37399,'41773','S','Allock','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.157727,-83.095710,0,'2013-07-06 12:44:32',NULL,NULL),(35052,'39179','S','Vaughan','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.811569,-90.093514,0,'2013-07-06 12:44:32',NULL,NULL),(72342,'89016','P','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.093110,-114.943541,0,'2013-07-06 12:44:34',NULL,NULL),(74283,'92359','S','Mountain Home Village','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.073506,-117.106254,0,'2013-07-06 12:44:34',NULL,NULL),(78391,'98031','S','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.386336,-122.195858,0,'2013-07-06 12:44:34',NULL,NULL),(58492,'68760','S','Verdel','A','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.768480,-98.009880,0,'2013-07-06 12:44:33',NULL,NULL),(25227,'28090','S','Toluca','N','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.465460,-81.532440,0,'2013-07-06 12:44:31',NULL,NULL),(32148,'35463','S','Fosters','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.124953,-87.726199,0,'2013-07-06 12:44:32',NULL,NULL),(6868,'06137','P','Bishops Cor','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(8607,'08234','S','McKee City','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(1698,'00777','S','Urb Lirios Cala','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(20816,'21617','S','Centreville','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.043882,-76.065900,0,'2013-07-06 12:44:31',NULL,NULL),(10300,'10526','S','Goldens Bridge','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.295831,-73.666608,0,'2013-07-06 12:44:30',NULL,NULL),(49201,'56452','S','Hackensack','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.000063,-94.499213,0,'2013-07-06 12:44:33',NULL,NULL),(1759,'00780','S','Coto Laurel','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(76822,'95957','S','Sycamore','N','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.107422,-121.863955,0,'2013-07-06 12:44:34',NULL,NULL),(56244,'65050','S','Latham','D','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.547307,-92.647250,0,'2013-07-06 12:44:33',NULL,NULL),(59107,'70143','U','Belle Chasse Nas','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.822294,-90.011918,0,'2013-07-06 12:44:33',NULL,NULL),(44403,'49819','P','Cornell','A','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.049895,-87.492966,0,'2013-07-06 12:44:32',NULL,NULL),(9766,'10104','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(3153,'01260','P','South Lee','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.281234,-73.278924,0,'2013-07-06 12:44:30',NULL,NULL),(52691,'61102','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.253136,-89.131474,0,'2013-07-06 12:44:33',NULL,NULL),(48998,'56241','S','Granite Falls','D','Yellow Medicine','27173','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.808478,-95.548738,0,'2013-07-06 12:44:33',NULL,NULL),(74775,'93110','S','Goleta','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.438801,-119.766004,0,'2013-07-06 12:44:34',NULL,NULL),(62470,'74338','S','West Siloam Springs','A','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.248548,-94.673222,0,'2013-07-06 12:44:33',NULL,NULL),(128,'00612','S','Villas del Sol','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(43352,'48387','P','Union Lake','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.612315,-83.447838,0,'2013-07-06 12:44:32',NULL,NULL),(13413,'13754','S','McClure','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(12796,'13221','P','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048798,-76.149827,0,'2013-07-06 12:44:30',NULL,NULL),(4293,'02902','U','Providence Journal','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.824676,-71.410790,0,'2013-07-06 12:44:30',NULL,NULL),(47851,'55076','S','Inver Grove Heights','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.849779,-93.034529,0,'2013-07-06 12:44:33',NULL,NULL),(11133,'11706','S','W Bay Shore','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(31689,'34787','S','Winter Garden','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.532903,-81.590667,0,'2013-07-06 12:44:32',NULL,NULL),(43284,'48333','P','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.462218,-83.377754,0,'2013-07-06 12:44:32',NULL,NULL),(39592,'44866','S','Redhaw','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.921560,-82.202280,0,'2013-07-06 12:44:32',NULL,NULL),(32318,'35762','P','Normal','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.792912,-86.569000,0,'2013-07-06 12:44:32',NULL,NULL),(78951,'98368','S','Protection Is','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(6439,'05750','P','Hydeville','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606837,-73.228695,0,'2013-07-06 12:44:30',NULL,NULL),(8734,'08514','S','Upper Freehold Township','N','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.164531,-74.453412,0,'2013-07-06 12:44:30',NULL,NULL),(65869,'78216','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.533684,-98.489444,0,'2013-07-06 12:44:34',NULL,NULL),(8464,'08088','S','Southampton','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.820757,-74.694484,0,'2013-07-06 12:44:30',NULL,NULL),(40112,'45321','S','Eldorado','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.892254,-84.673553,0,'2013-07-06 12:44:32',NULL,NULL),(68451,'81227','P','Salida','A','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.532188,-105.998639,0,'2013-07-06 12:44:34',NULL,NULL),(127,'00612','S','Villas del Capitan','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(36296,'40359','S','Monterey','N','Owen','21187','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.478600,-84.814080,0,'2013-07-06 12:44:32',NULL,NULL),(53203,'61613','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.742374,-89.628187,0,'2013-07-06 12:44:33',NULL,NULL),(49322,'56549','S','Rollag','A','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.740000,-96.237778,0,'2013-07-06 12:44:33',NULL,NULL),(72006,'88040','P','Hachita','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.916860,-108.322590,0,'2013-07-06 12:44:34',NULL,NULL),(73512,'91341','P','San Fernando','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.282219,-118.442779,0,'2013-07-06 12:44:34',NULL,NULL),(74404,'92531','P','Lake Elsinore','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.605257,-117.393897,0,'2013-07-06 12:44:34',NULL,NULL),(68610,'81620','P','Avon','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.631320,-106.521600,0,'2013-07-06 12:44:34',NULL,NULL),(47280,'54539','S','Lake Tomahawk','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.807785,-89.581053,0,'2013-07-06 12:44:32',NULL,NULL),(40199,'45385','S','Sugarcreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.691445,-83.953106,0,'2013-07-06 12:44:32',NULL,NULL),(23993,'26337','S','Cairo','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.235969,-81.150146,0,'2013-07-06 12:44:31',NULL,NULL),(71007,'85721','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.228886,-110.952157,0,'2013-07-06 12:44:34',NULL,NULL),(73371,'91031','P','S Pasadena','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.117536,-118.151757,0,'2013-07-06 12:44:34',NULL,NULL),(76565,'95670','S','Gold River','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.603520,-121.248060,0,'2013-07-06 12:44:34',NULL,NULL),(56696,'65658','S','Golden','D','Barry','29009','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.542445,-93.630518,0,'2013-07-06 12:44:33',NULL,NULL),(62555,'74442','S','Indianola','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.098337,-95.798323,0,'2013-07-06 12:44:33',NULL,NULL),(8933,'08752','S','Seaside Park','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.922118,-74.080135,0,'2013-07-06 12:44:30',NULL,NULL),(6333,'05666','S','No Montpelier','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.256675,-72.485785,0,'2013-07-06 12:44:30',NULL,NULL),(67337,'80101','S','Agate','D','Elbert','08039','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.406711,-104.020756,0,'2013-07-06 12:44:34',NULL,NULL),(66329,'78599','S','Weslaco','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.158854,-97.992492,0,'2013-07-06 12:44:34',NULL,NULL),(62767,'74859','S','Mason','A','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.431460,-96.305173,0,'2013-07-06 12:44:33',NULL,NULL),(52496,'60706','S','Harwood Heights','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.962443,-87.817391,0,'2013-07-06 12:44:33',NULL,NULL),(8872,'08691','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(42662,'47954','S','Ladoga','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.918830,-86.797098,0,'2013-07-06 12:44:32',NULL,NULL),(41127,'46615','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.672646,-86.213631,0,'2013-07-06 12:44:32',NULL,NULL),(75292,'93725','S','Calwa','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.662145,-119.740783,0,'2013-07-06 12:44:34',NULL,NULL),(77790,'97132','S','Newberg','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.308916,-122.977461,0,'2013-07-06 12:44:34',NULL,NULL),(43885,'49229','S','Ridgeway','A','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.984165,-83.839522,0,'2013-07-06 12:44:32',NULL,NULL),(25538,'28403','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.204361,-77.883608,0,'2013-07-06 12:44:31',NULL,NULL),(14425,'15072','P','Pricedale','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.140460,-79.859271,0,'2013-07-06 12:44:31',NULL,NULL),(45099,'50542','S','Goldfield','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.733991,-93.921071,0,'2013-07-06 12:44:32',NULL,NULL),(718,'00687','S','Qtas de Morovis','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(27345,'30047','S','Lilburn','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.874851,-84.113781,0,'2013-07-06 12:44:31',NULL,NULL),(64743,'76906','P','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.460090,-100.436751,0,'2013-07-06 12:44:34',NULL,NULL),(5842,'05089','S','Sheddsville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.475040,-72.427380,0,'2013-07-06 12:44:30',NULL,NULL),(56234,'65046','S','Cedron','N','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.790635,-92.483677,0,'2013-07-06 12:44:33',NULL,NULL),(15714,'16865','S','Pa Furnace','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.725800,-77.945698,0,'2013-07-06 12:44:31',NULL,NULL),(56478,'65324','S','Climax Springs','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.125197,-92.961855,0,'2013-07-06 12:44:33',NULL,NULL),(1568,'00766','S','VISTA Bella','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(52280,'60527','S','Burr Ridge','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.841820,-87.951040,0,'2013-07-06 12:44:33',NULL,NULL),(73578,'91381','S','Newhall','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.381783,-118.573262,0,'2013-07-06 12:44:34',NULL,NULL),(17931,'18470','S','Union Dale','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.713270,-75.550480,0,'2013-07-06 12:44:31',NULL,NULL),(28433,'31402','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.095395,-81.334504,0,'2013-07-06 12:44:32',NULL,NULL),(495,'00674','S','Colina del Mar','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(8769,'08544','U','Princeton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.345441,-74.655866,0,'2013-07-06 12:44:30',NULL,NULL),(16893,'17579','S','Strasburg','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.967797,-76.177226,0,'2013-07-06 12:44:31',NULL,NULL),(32082,'35290','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.550093,-86.741320,0,'2013-07-06 12:44:32',NULL,NULL),(63897,'76020','S','Pelican Bay','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.910000,-97.557240,0,'2013-07-06 12:44:34',NULL,NULL),(17939,'18505','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.391055,-75.665550,0,'2013-07-06 12:44:31',NULL,NULL),(29493,'32746','S','Lake Mary','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.759920,-81.345840,0,'2013-07-06 12:44:32',NULL,NULL),(28349,'31196','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.807894,-84.474929,0,'2013-07-06 12:44:32',NULL,NULL),(45822,'52207','S','Baldwin','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.072359,-90.820412,0,'2013-07-06 12:44:32',NULL,NULL),(60113,'71366','S','Wilsona','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(1173,'00727','S','Urb Las Nubes','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(6933,'06161','U','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.701070,-72.667463,0,'2013-07-06 12:44:30',NULL,NULL),(16417,'17225','S','Mason Dixon','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(65979,'78330','S','Agua Dulce','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.782460,-97.909035,0,'2013-07-06 12:44:34',NULL,NULL),(62050,'73532','S','Duke','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.661943,-99.569012,0,'2013-07-06 12:44:33',NULL,NULL),(61714,'73010','S','Blanchard','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.136801,-97.648526,0,'2013-07-06 12:44:33',NULL,NULL),(1724,'00778','S','Parc Nuevas','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(5245,'04476','S','Penobscot','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.468623,-68.708320,0,'2013-07-06 12:44:30',NULL,NULL),(10975,'11530','S','Village Of Garden City','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719167,-73.688889,0,'2013-07-06 12:44:30',NULL,NULL),(24827,'27608','S','Five Points','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.810030,-78.645013,0,'2013-07-06 12:44:31',NULL,NULL),(45503,'51360','S','Orleans','A','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(30074,'33154','S','Indian Creek Village','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(32895,'36535','S','Vernant Park','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.398083,-87.704195,0,'2013-07-06 12:44:32',NULL,NULL),(8804,'08609','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.222505,-74.741462,0,'2013-07-06 12:44:30',NULL,NULL),(64660,'76801','S','Thrifty','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(59899,'71276','S','Roosevelt','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.571944,-91.182222,0,'2013-07-06 12:44:33',NULL,NULL),(69129,'83285','S','Soda Springs','A','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.951741,-111.173683,0,'2013-07-06 12:44:34',NULL,NULL),(15873,'16950','S','North Fork','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(18752,'19344','S','W Brandywine','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.084833,-75.898086,0,'2013-07-06 12:44:31',NULL,NULL),(9313,'09725','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38420,'43545','S','Okolona','A','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.386399,-84.133117,0,'2013-07-06 12:44:32',NULL,NULL),(49469,'56653','S','Lindford','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.362760,-93.507720,0,'2013-07-06 12:44:33',NULL,NULL),(59330,'70537','S','Evangeline','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.259924,-92.564263,0,'2013-07-06 12:44:33',NULL,NULL),(16108,'17055','S','Lisburn','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(34377,'38614','S','Roundaway','N','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.014190,-90.595120,0,'2013-07-06 12:44:32',NULL,NULL),(76342,'95470','S','Redwood Vly','A','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.280802,-123.212931,0,'2013-07-06 12:44:34',NULL,NULL),(13485,'13797','S','Centerlisle','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.334546,-76.047179,0,'2013-07-06 12:44:31',NULL,NULL),(44805,'50234','S','Rhodes','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.908955,-93.182342,0,'2013-07-06 12:44:32',NULL,NULL),(22596,'24184','S','Burnt Chimney','A','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.062960,-79.718160,0,'2013-07-06 12:44:31',NULL,NULL),(74515,'92648','S','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.677256,-118.005064,0,'2013-07-06 12:44:34',NULL,NULL),(76146,'95296','U','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.025975,-121.297271,0,'2013-07-06 12:44:34',NULL,NULL),(1868,'00791','S','Urb El Paraiso','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(42365,'47710','S','Darmstadt','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.011789,-87.579506,0,'2013-07-06 12:44:32',NULL,NULL),(65179,'77418','S','Bellville','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.989680,-96.254040,0,'2013-07-06 12:44:34',NULL,NULL),(4465,'03259','S','N Sandwich','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.862648,-71.379837,0,'2013-07-06 12:44:30',NULL,NULL),(10581,'11021','S','Saddle Rock Estates','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(9724,'10081','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(76099,'95223','S','Camp Connell','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.263800,-120.332640,0,'2013-07-06 12:44:34',NULL,NULL),(78031,'97430','S','Greenleaf','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.151420,-123.712080,0,'2013-07-06 12:44:34',NULL,NULL),(53793,'62284','S','Hookdale','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.876400,-89.323800,0,'2013-07-06 12:44:33',NULL,NULL),(25805,'28607','S','Hillcrest','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(13445,'13775','S','Franklin','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340614,-75.160930,0,'2013-07-06 12:44:31',NULL,NULL),(30962,'33737','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742638,-82.719858,0,'2013-07-06 12:44:32',NULL,NULL),(8360,'08050','S','Stafford Twp','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.698720,-74.257382,0,'2013-07-06 12:44:30',NULL,NULL),(44518,'49947','S','Marenisco','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.375800,-89.593980,0,'2013-07-06 12:44:32',NULL,NULL),(11340,'11793','S','Briar Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.685767,-73.514020,0,'2013-07-06 12:44:30',NULL,NULL),(48984,'56225','S','Clinton','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.458909,-96.435317,0,'2013-07-06 12:44:33',NULL,NULL),(23145,'24986','S','White Sulphur Springs','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.797867,-80.296195,0,'2013-07-06 12:44:31',NULL,NULL),(14854,'15455','P','Leisenring','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.999339,-79.640051,0,'2013-07-06 12:44:31',NULL,NULL),(13581,'13844','S','South Plymouth','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.608333,-75.701944,0,'2013-07-06 12:44:31',NULL,NULL),(66442,'78648','S','Luling','D','Caldwell','48055','Texas','TX','48','0640','830','Central',-6.0,'Y',29.678992,-97.646226,0,'2013-07-06 12:44:34',NULL,NULL),(31268,'34002','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(14613,'15227','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.426740,-79.969140,0,'2013-07-06 12:44:31',NULL,NULL),(44686,'50125','S','Spring Hill','A','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.315040,-93.572040,0,'2013-07-06 12:44:32',NULL,NULL),(42823,'48062','S','Richmond','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.843791,-82.798308,0,'2013-07-06 12:44:32',NULL,NULL),(15804,'16926','S','Windfall','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.666415,-76.720268,0,'2013-07-06 12:44:31',NULL,NULL),(71661,'87501','S','Sf','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(36222,'40283','U','Pleasure Rdge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(59592,'71008','S','Bryceland','A','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(5402,'04655','S','Machiasport','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.669643,-67.408725,0,'2013-07-06 12:44:30',NULL,NULL),(9335,'09749','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(10731,'11354','S','Linden Hill','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.770167,-73.825967,0,'2013-07-06 12:44:30',NULL,NULL),(50650,'58318','S','Metigoshe','N','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.905100,-100.424520,0,'2013-07-06 12:44:33',NULL,NULL),(19352,'20046','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.957666,-77.086672,0,'2013-07-06 12:44:31',NULL,NULL),(37787,'42366','S','Knottsville','A','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.738372,-86.943626,0,'2013-07-06 12:44:32',NULL,NULL),(32144,'35460','S','Sumterville','N','Sumter','01119','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.711667,-88.238889,0,'2013-07-06 12:44:32',NULL,NULL),(55316,'63539','S','Goldberry','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.930787,-92.773951,0,'2013-07-06 12:44:33',NULL,NULL),(11381,'11935','S','Nassau Point','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.015049,-72.472897,0,'2013-07-06 12:44:30',NULL,NULL),(66233,'78566','S','Los Fresnos','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.085000,-97.461600,0,'2013-07-06 12:44:34',NULL,NULL),(27258,'29932','S','Luray','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.864636,-81.228486,0,'2013-07-06 12:44:31',NULL,NULL),(47616,'54896','S','Loretta','A','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.842100,-90.907620,0,'2013-07-06 12:44:33',NULL,NULL),(67302,'80017','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.692691,-104.785113,0,'2013-07-06 12:44:34',NULL,NULL),(17345,'17870','S','Kantz','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(40241,'45424','S','Huber Hgts','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.845640,-84.111720,0,'2013-07-06 12:44:32',NULL,NULL),(37175,'41472','S','Yocum','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(32752,'36344','S','Hartford','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.101347,-85.700671,0,'2013-07-06 12:44:32',NULL,NULL),(17834,'18421','S','Browndale','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(22410,'23967','S','Saxe','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.903402,-78.619215,0,'2013-07-06 12:44:31',NULL,NULL),(18736,'19331','P','Concordville','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.880054,-75.519758,0,'2013-07-06 12:44:31',NULL,NULL),(10253,'10473','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.818719,-73.857180,0,'2013-07-06 12:44:30',NULL,NULL),(26855,'29526','S','Conway','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.832026,-79.043531,0,'2013-07-06 12:44:31',NULL,NULL),(37947,'42717','S','Bakerton','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(39682,'45015','S','Village Of Indian Springs','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.367572,-84.550446,0,'2013-07-06 12:44:32',NULL,NULL),(1015,'00718','S','Jard de Esperanza','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(1320,'00735','S','Roosevelt Rds','A','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(41371,'46795','S','Pretty Lake','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(80113,'99760','S','Nenana','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.549649,-149.104344,0,'2013-07-06 12:44:34',NULL,NULL),(14772,'15345','S','Marianna','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.024140,-80.101840,0,'2013-07-06 12:44:31',NULL,NULL),(53607,'62081','S','Lake Centralia','N','Greene','17061','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.285885,-90.270095,0,'2013-07-06 12:44:33',NULL,NULL),(34644,'38769','S','Niles','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.846420,-91.001880,0,'2013-07-06 12:44:32',NULL,NULL),(41667,'47160','S','New Middletown','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.138492,-86.054477,0,'2013-07-06 12:44:32',NULL,NULL),(76749,'95918','S','Browns Valley','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.283964,-121.361589,0,'2013-07-06 12:44:34',NULL,NULL),(3519,'01886','S','Nabnasset','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.589321,-71.437474,0,'2013-07-06 12:44:30',NULL,NULL),(19612,'20237','U','Broadcasting Bd of Governors','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895381,-77.036342,0,'2013-07-06 12:44:31',NULL,NULL),(35364,'39440','S','Tuckers Crossing','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(77986,'97392','S','Turner','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.810901,-122.944478,0,'2013-07-06 12:44:34',NULL,NULL),(78942,'98368','S','Adelma Beach','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.116667,-122.783333,0,'2013-07-06 12:44:34',NULL,NULL),(62851,'75022','S','Lewisville','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.014444,-97.096667,0,'2013-07-06 12:44:33',NULL,NULL),(8549,'08204','S','Erma','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.971580,-74.927691,0,'2013-07-06 12:44:30',NULL,NULL),(58271,'68401','S','Mc Cool Jct','A','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.744573,-97.595253,0,'2013-07-06 12:44:33',NULL,NULL),(41499,'46957','P','Matthews','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.388702,-85.495675,0,'2013-07-06 12:44:32',NULL,NULL),(28887,'32125','P','Holly Hill','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.234976,-81.055403,0,'2013-07-06 12:44:32',NULL,NULL),(26914,'29582','S','Crescent Beach','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(4404,'03222','S','Alexandria','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.606641,-71.739886,0,'2013-07-06 12:44:30',NULL,NULL),(6048,'05440','S','Alburg','A','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.957724,-73.279914,0,'2013-07-06 12:44:30',NULL,NULL),(65239,'77454','P','Lissie','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.554125,-96.226320,0,'2013-07-06 12:44:34',NULL,NULL),(9004,'08854','S','Piscataway','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.552711,-74.458211,0,'2013-07-06 12:44:30',NULL,NULL),(60071,'71354','S','Workinger Bayou Road','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.345723,-91.668555,0,'2013-07-06 12:44:33',NULL,NULL),(5563,'04859','S','Tenants Hbr','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.013030,-69.171205,0,'2013-07-06 12:44:30',NULL,NULL),(41510,'46971','S','Grissom A R B','N','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.673495,-86.158752,0,'2013-07-06 12:44:32',NULL,NULL),(39445,'44695','S','New Hagerstown','N','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.415653,-81.173846,0,'2013-07-06 12:44:32',NULL,NULL),(45371,'51011','S','Chatsworth','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.014778,-96.431632,0,'2013-07-06 12:44:32',NULL,NULL),(48470,'55720','S','Cloquet','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.729380,-92.459220,0,'2013-07-06 12:44:33',NULL,NULL),(68358,'81133','S','Sangre de Cristo Ranches','A','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.413562,-105.393706,0,'2013-07-06 12:44:34',NULL,NULL),(63413,'75653','P','Henderson','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.161816,-94.805683,0,'2013-07-06 12:44:33',NULL,NULL),(62490,'74358','P','North Miami','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.917496,-94.882505,0,'2013-07-06 12:44:33',NULL,NULL),(23890,'26178','S','Smithville','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.067760,-81.069659,0,'2013-07-06 12:44:31',NULL,NULL),(78594,'98185','U','Safeco Plaza','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.665276,-122.291979,0,'2013-07-06 12:44:34',NULL,NULL),(74687,'92882','S','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.862585,-117.598903,0,'2013-07-06 12:44:34',NULL,NULL),(7632,'07063','S','North Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.609259,-74.453927,0,'2013-07-06 12:44:30',NULL,NULL),(68079,'80938','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.797690,-104.837067,0,'2013-07-06 12:44:34',NULL,NULL),(13266,'13650','S','Henderson','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.849649,-76.228306,0,'2013-07-06 12:44:30',NULL,NULL),(24733,'27521','S','Coats','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.410283,-78.672574,0,'2013-07-06 12:44:31',NULL,NULL),(60374,'71485','S','Brookwood','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.160578,-92.499928,0,'2013-07-06 12:44:33',NULL,NULL),(39426,'44680','S','Strasburg','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.600632,-81.533260,0,'2013-07-06 12:44:32',NULL,NULL),(71508,'87114','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(4486,'03275','S','Allenstown','A','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.173240,-71.403720,0,'2013-07-06 12:44:30',NULL,NULL),(4230,'02857','S','Scituate','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.833680,-71.641620,0,'2013-07-06 12:44:30',NULL,NULL),(15802,'16926','S','Granville Smt','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.666415,-76.720268,0,'2013-07-06 12:44:31',NULL,NULL),(60541,'71701','S','Camden','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.581400,-92.819340,0,'2013-07-06 12:44:33',NULL,NULL),(60801,'72031','S','Botkinburg','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(25935,'28655','S','Enola','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(9946,'10156','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.746242,-73.980923,0,'2013-07-06 12:44:30',NULL,NULL),(78690,'98250','S','Roche Harbor','A','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.543044,-123.068308,0,'2013-07-06 12:44:34',NULL,NULL),(72633,'89420','S','Luning','D','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.417477,-118.190097,0,'2013-07-06 12:44:34',NULL,NULL),(9298,'09708','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19758,'20414','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.881612,-77.024982,0,'2013-07-06 12:44:31',NULL,NULL),(48951,'56172','S','Slayton','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.983778,-95.758806,0,'2013-07-06 12:44:33',NULL,NULL),(48018,'55175','P','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.966530,-93.087695,0,'2013-07-06 12:44:33',NULL,NULL),(44596,'50047','S','Carlisle','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.477985,-93.476846,0,'2013-07-06 12:44:32',NULL,NULL),(55631,'64002','U','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.104258,-93.546629,0,'2013-07-06 12:44:33',NULL,NULL),(74792,'93150','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.434711,-119.632112,0,'2013-07-06 12:44:34',NULL,NULL),(42470,'47834','S','Cloverland','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(12703,'13146','S','Savannah','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.103753,-76.760166,0,'2013-07-06 12:44:30',NULL,NULL),(11330,'11790','S','Head of the Harbor','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.905287,-73.125351,0,'2013-07-06 12:44:30',NULL,NULL),(76346,'95473','P','Sebastopol','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.400744,-122.824549,0,'2013-07-06 12:44:34',NULL,NULL),(7775,'07419','S','Hardyston','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.153970,-74.567322,0,'2013-07-06 12:44:30',NULL,NULL),(42709,'48001','S','Clay Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(54215,'62644','S','Havana','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.297332,-90.063176,0,'2013-07-06 12:44:33',NULL,NULL),(72104,'88230','S','Midway','N','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.226907,-104.407794,0,'2013-07-06 12:44:34',NULL,NULL),(65957,'78270','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588376,-98.473568,0,'2013-07-06 12:44:34',NULL,NULL),(10896,'11425','U','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674365,-73.771894,0,'2013-07-06 12:44:30',NULL,NULL),(74160,'92262','S','Palm Springs Municipal Airpo','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.856934,-116.563137,0,'2013-07-06 12:44:34',NULL,NULL),(29933,'33065','S','Margate','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.268785,-80.255243,0,'2013-07-06 12:44:32',NULL,NULL),(78810,'98331','S','Clearwater','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(31143,'33910','P','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.551448,-82.020111,0,'2013-07-06 12:44:32',NULL,NULL),(9058,'08902','S','North Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.446660,-74.488980,0,'2013-07-06 12:44:30',NULL,NULL),(50812,'58458','S','Lamoure','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.397400,-98.283240,0,'2013-07-06 12:44:33',NULL,NULL),(38599,'43836','P','Plainfield','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.208882,-81.719943,0,'2013-07-06 12:44:32',NULL,NULL),(53840,'62319','S','Camden','D','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.149043,-90.737657,0,'2013-07-06 12:44:33',NULL,NULL),(53227,'61637','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.699505,-89.590142,0,'2013-07-06 12:44:33',NULL,NULL),(73064,'90095','U','Uc Los Angeles','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.070199,-118.451020,0,'2013-07-06 12:44:34',NULL,NULL),(68698,'82054','S','Carpenter','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.060046,-104.366017,0,'2013-07-06 12:44:34',NULL,NULL),(13305,'13669','S','Red Mills','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.666280,-75.499440,0,'2013-07-06 12:44:30',NULL,NULL),(66883,'79235','S','Floydada','D','Floyd','48153','Texas','TX','48','0000','806','Central',-6.0,'Y',33.981778,-101.339054,0,'2013-07-06 12:44:34',NULL,NULL),(55244,'63446','S','Knox City','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.127713,-92.003683,0,'2013-07-06 12:44:33',NULL,NULL),(40416,'45687','P','Wakefield','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.968280,-83.021553,0,'2013-07-06 12:44:32',NULL,NULL),(42895,'48097','S','Brockway Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.116201,-82.794016,0,'2013-07-06 12:44:32',NULL,NULL),(48093,'55340','S','Hamel','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.072108,-93.576508,0,'2013-07-06 12:44:33',NULL,NULL),(3348,'01560','S','Saundersville','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.177849,-71.693325,0,'2013-07-06 12:44:30',NULL,NULL),(24960,'27836','P','Greenville','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.603283,-77.359478,0,'2013-07-06 12:44:31',NULL,NULL),(7933,'07650','S','Palisades Pk','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.848970,-73.998019,0,'2013-07-06 12:44:30',NULL,NULL),(16565,'17315','S','Bigmount','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.013820,-76.815840,0,'2013-07-06 12:44:31',NULL,NULL),(24740,'27527','S','Clayton','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.650556,-78.456667,0,'2013-07-06 12:44:31',NULL,NULL),(28723,'31904','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.520024,-84.981542,0,'2013-07-06 12:44:32',NULL,NULL),(46094,'52621','S','Crawfordsvlle','A','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.212644,-91.536955,0,'2013-07-06 12:44:32',NULL,NULL),(63442,'75670','S','Gill','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(34484,'38665','S','Strayhorn','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601919,-90.126392,0,'2013-07-06 12:44:32',NULL,NULL),(27516,'30189','S','Woodstock','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.126928,-84.563188,0,'2013-07-06 12:44:31',NULL,NULL),(45716,'52068','S','Peosta','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.431580,-90.799380,0,'2013-07-06 12:44:32',NULL,NULL),(42600,'47885','S','Sandford','A','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(51119,'58788','S','Towner','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.353802,-100.405480,0,'2013-07-06 12:44:33',NULL,NULL),(47257,'54524','S','Fifield','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.875946,-90.417070,0,'2013-07-06 12:44:32',NULL,NULL),(42276,'47584','P','Spurgeon','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.348983,-87.222007,0,'2013-07-06 12:44:32',NULL,NULL),(60450,'71652','S','Kingsland','D','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.877586,-92.306949,0,'2013-07-06 12:44:33',NULL,NULL),(13783,'14166','P','Van Buren Point','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.450113,-79.417318,0,'2013-07-06 12:44:31',NULL,NULL),(12100,'12574','P','Rhinecliff','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.910591,-73.951351,0,'2013-07-06 12:44:30',NULL,NULL),(78816,'98333','S','Fox Is','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250837,-122.623135,0,'2013-07-06 12:44:34',NULL,NULL),(20841,'21645','S','Kennedyville','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.303304,-75.961244,0,'2013-07-06 12:44:31',NULL,NULL),(39678,'45015','S','Hamilton','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.367572,-84.550446,0,'2013-07-06 12:44:32',NULL,NULL),(66704,'78946','S','Waldeck','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.231900,-96.775620,0,'2013-07-06 12:44:34',NULL,NULL),(29107,'32306','U','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.442453,-84.299083,0,'2013-07-06 12:44:32',NULL,NULL),(516,'00674','S','Urb Flamboyan','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(2564,'00959','S','Urb Riberas del Rio','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(41426,'46845','S','Hazelwood','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.201330,-85.112447,0,'2013-07-06 12:44:32',NULL,NULL),(26083,'28705','S','Bakersville','D','Mitchell','37121','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.977949,-82.121955,0,'2013-07-06 12:44:31',NULL,NULL),(22932,'24628','S','Harman','A','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.303473,-82.173372,0,'2013-07-06 12:44:31',NULL,NULL),(60236,'71431','P','Gardner','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.266691,-92.693747,0,'2013-07-06 12:44:33',NULL,NULL),(79413,'98816','S','Lucerne','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.850024,-120.044073,0,'2013-07-06 12:44:34',NULL,NULL),(16005,'17039','P','Kleinfeltersville','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.301020,-76.249244,0,'2013-07-06 12:44:31',NULL,NULL),(58218,'68338','S','Daykin','D','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.300330,-97.277589,0,'2013-07-06 12:44:33',NULL,NULL),(3629,'02066','S','Scituate Harbor','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.199513,-70.746169,0,'2013-07-06 12:44:30',NULL,NULL),(11102,'11697','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.556389,-73.926667,0,'2013-07-06 12:44:30',NULL,NULL),(77125,'96154','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.943645,-119.977876,0,'2013-07-06 12:44:34',NULL,NULL),(76450,'95608','S','Carmichael','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.628172,-121.327836,0,'2013-07-06 12:44:34',NULL,NULL),(65639,'77964','S','Vienna','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(44719,'50149','S','Lorimor','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.111128,-94.073065,0,'2013-07-06 12:44:32',NULL,NULL),(49204,'56455','S','Riverton','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.478503,-93.978413,0,'2013-07-06 12:44:33',NULL,NULL),(53489,'61957','S','Windsor','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.441537,-88.600965,0,'2013-07-06 12:44:33',NULL,NULL),(59244,'70437','S','Folsom','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.605587,-90.181639,0,'2013-07-06 12:44:33',NULL,NULL),(64378,'76528','S','Pidcoke','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(23921,'26224','S','Helvetia','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.896029,-79.848585,0,'2013-07-06 12:44:31',NULL,NULL),(26341,'29061','S','Horrel Hill','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.932888,-80.844488,0,'2013-07-06 12:44:31',NULL,NULL),(34323,'38558','S','Crossvle','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(5192,'04444','S','Newburgh','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.726340,-68.928540,0,'2013-07-06 12:44:30',NULL,NULL),(15621,'16693','S','Ganister','A','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.459604,-78.203477,0,'2013-07-06 12:44:31',NULL,NULL),(35610,'39601','S','Lucien','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(61661,'72908','S','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.299600,-94.409478,0,'2013-07-06 12:44:33',NULL,NULL),(38848,'44092','S','Willoughby Hills','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.603368,-81.464859,0,'2013-07-06 12:44:32',NULL,NULL),(2958,'01037','P','Hardwick','D','Worcester','25027','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.349404,-72.200810,0,'2013-07-06 12:44:30',NULL,NULL),(48148,'55368','S','Nya','A','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.752993,-93.920341,0,'2013-07-06 12:44:33',NULL,NULL),(40860,'46228','S','North Crows Nest','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.848173,-86.193351,0,'2013-07-06 12:44:32',NULL,NULL),(23861,'26146','S','Bens Run','A','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.492550,-81.013419,0,'2013-07-06 12:44:31',NULL,NULL),(21725,'23004','S','Arvonia','D','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.667219,-78.413499,0,'2013-07-06 12:44:31',NULL,NULL),(33657,'37715','S','Clairfield','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.541619,-83.874799,0,'2013-07-06 12:44:32',NULL,NULL),(70626,'85137','S','Kearny','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.089910,-110.939051,0,'2013-07-06 12:44:34',NULL,NULL),(37751,'42322','P','Beech Grove','D','McLean','21149','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.614047,-87.398347,0,'2013-07-06 12:44:32',NULL,NULL),(40141,'45342','S','Miamisburg','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.629485,-84.263441,0,'2013-07-06 12:44:32',NULL,NULL),(42369,'47711','S','Daylight','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(20352,'20862','S','Brinklow','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.179672,-77.020116,0,'2013-07-06 12:44:31',NULL,NULL),(18514,'19103','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.964218,-75.200972,0,'2013-07-06 12:44:31',NULL,NULL),(61983,'73196','U','Bank of Oklahoma','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460523,-97.398837,0,'2013-07-06 12:44:33',NULL,NULL),(348,'00656','S','Urb San Augusto','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(78897,'98360','S','Electron','N','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.087937,-122.185345,0,'2013-07-06 12:44:34',NULL,NULL),(56860,'66012','S','Basehor','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.073262,-94.884623,0,'2013-07-06 12:44:33',NULL,NULL),(43514,'48637','S','Merrill','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.397782,-84.322285,0,'2013-07-06 12:44:32',NULL,NULL),(32619,'36141','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386911,-86.148084,0,'2013-07-06 12:44:32',NULL,NULL),(12690,'13136','S','Pitcher','D','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.615400,-75.853885,0,'2013-07-06 12:44:30',NULL,NULL),(68223,'81050','S','La Junta','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.818220,-103.774050,0,'2013-07-06 12:44:34',NULL,NULL),(64871,'77063','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.732190,-95.521538,0,'2013-07-06 12:44:34',NULL,NULL),(58631,'68866','S','Cedar','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.971884,-99.085142,0,'2013-07-06 12:44:33',NULL,NULL),(56935,'66078','S','Princeton','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.490104,-95.276057,0,'2013-07-06 12:44:33',NULL,NULL),(38287,'43334','S','Marengo','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.385700,-82.829760,0,'2013-07-06 12:44:32',NULL,NULL),(57222,'66501','P','McFarland','N','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.052131,-96.237299,0,'2013-07-06 12:44:33',NULL,NULL),(24,'00603','S','Repto Juan Aguiar','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(71034,'85739','S','Saddlebrooke','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.221743,-110.926479,0,'2013-07-06 12:44:34',NULL,NULL),(2578,'00959','S','Vista Alegre','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(46234,'52778','S','Wilton','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.590341,-91.019280,0,'2013-07-06 12:44:32',NULL,NULL),(41368,'46794','S','Wawaka','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.491296,-85.420706,0,'2013-07-06 12:44:32',NULL,NULL),(18820,'19407','P','Norristown','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.118426,-75.446143,0,'2013-07-06 12:44:31',NULL,NULL),(36524,'40843','S','Holmes Mill','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.884524,-82.967825,0,'2013-07-06 12:44:32',NULL,NULL),(32380,'35905','S','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.954808,-85.903321,0,'2013-07-06 12:44:32',NULL,NULL),(56706,'65669','S','Highlandville','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.972165,-93.353272,0,'2013-07-06 12:44:33',NULL,NULL),(5122,'04401','S','Hermon','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.814135,-68.778574,0,'2013-07-06 12:44:30',NULL,NULL),(22261,'23691','S','Nav Wpns Sta','A','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.244023,-76.551905,0,'2013-07-06 12:44:31',NULL,NULL),(73498,'91330','U','Ca State Univ Northridge','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.245875,-118.501885,0,'2013-07-06 12:44:34',NULL,NULL),(48873,'56085','S','Sleepy Eye','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.296100,-94.723907,0,'2013-07-06 12:44:33',NULL,NULL),(14899,'15502','P','Hidden Valley','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.011575,-79.078207,0,'2013-07-06 12:44:31',NULL,NULL),(35572,'39568','P','Pascagoula','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.369518,-88.523942,0,'2013-07-06 12:44:32',NULL,NULL),(17882,'18444','S','Covington Township','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(1738,'00778','S','Urb Los Flamboyanes','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(15685,'16834','P','Drifting','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.022289,-78.107768,0,'2013-07-06 12:44:31',NULL,NULL),(55397,'63633','S','Corridon','N','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.440471,-90.995157,0,'2013-07-06 12:44:33',NULL,NULL),(65591,'77873','S','Richards','D','Grimes','48185','Texas','TX','48','0000','936','Central',-6.0,'Y',30.548688,-95.862840,0,'2013-07-06 12:44:34',NULL,NULL),(69526,'83728','U','Boise Cascade','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.618134,-116.202744,0,'2013-07-06 12:44:34',NULL,NULL),(51012,'58704','S','Minot AFB','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.232500,-101.295833,0,'2013-07-06 12:44:33',NULL,NULL),(29979,'33093','P','Coconut Creek','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.252723,-80.209522,0,'2013-07-06 12:44:32',NULL,NULL),(48118,'55356','S','Long Lake','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.987459,-93.581675,0,'2013-07-06 12:44:33',NULL,NULL),(69771,'84057','S','Clyde','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.315140,-111.695870,0,'2013-07-06 12:44:34',NULL,NULL),(61180,'72204','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.723843,-92.347871,0,'2013-07-06 12:44:33',NULL,NULL),(76761,'95926','S','Chico','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.791460,-121.847640,0,'2013-07-06 12:44:34',NULL,NULL),(1166,'00727','S','Urb Bonneville Manor','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(19967,'20590','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878849,-77.023618,0,'2013-07-06 12:44:31',NULL,NULL),(44154,'49528','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881100,-85.623900,0,'2013-07-06 12:44:32',NULL,NULL),(50581,'58231','S','Fordville','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.241082,-97.838469,0,'2013-07-06 12:44:33',NULL,NULL),(58906,'69217','S','Long Pine','D','Brown','31017','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.436196,-99.750801,0,'2013-07-06 12:44:33',NULL,NULL),(70820,'85382','S','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.649198,-112.247486,0,'2013-07-06 12:44:34',NULL,NULL),(30107,'33160','S','Golden Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(1720,'00778','S','Jard de Gurabo','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(40290,'45440','S','Beavercrk Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(3418,'01720','S','Acton','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.477355,-71.446686,0,'2013-07-06 12:44:30',NULL,NULL),(6997,'06251','P','Mansfield Dpt','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.815888,-72.285998,0,'2013-07-06 12:44:30',NULL,NULL),(75579,'94283','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.477355,-121.444157,0,'2013-07-06 12:44:34',NULL,NULL),(18594,'19137','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.997468,-75.099036,0,'2013-07-06 12:44:31',NULL,NULL),(14257,'14836','S','Dalton','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.543587,-77.919905,0,'2013-07-06 12:44:31',NULL,NULL),(70796,'85362','P','Yarnell','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.239701,-112.753201,0,'2013-07-06 12:44:34',NULL,NULL),(28526,'31548','S','Kingsland','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',30.790654,-81.711294,0,'2013-07-06 12:44:32',NULL,NULL),(24553,'27292','S','Yadkin','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(13857,'14227','S','S Cheek','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.876735,-78.744457,0,'2013-07-06 12:44:31',NULL,NULL),(65629,'77963','S','Sarco','N','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.757460,-97.420680,0,'2013-07-06 12:44:34',NULL,NULL),(29294,'32509','U','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.420085,-87.222152,0,'2013-07-06 12:44:32',NULL,NULL),(39283,'44484','S','Howland','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.231245,-80.762228,0,'2013-07-06 12:44:32',NULL,NULL),(55557,'63857','S','Kennett','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.239810,-90.047625,0,'2013-07-06 12:44:33',NULL,NULL),(18640,'19161','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.065457,-75.080697,0,'2013-07-06 12:44:31',NULL,NULL),(70369,'84653','S','Woodland Hls','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.032330,-111.658857,0,'2013-07-06 12:44:34',NULL,NULL),(8750,'08530','S','Lambertville','D','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.367930,-74.933508,0,'2013-07-06 12:44:30',NULL,NULL),(13699,'14058','S','Elba','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.085396,-78.156946,0,'2013-07-06 12:44:31',NULL,NULL),(43461,'48552','U','Chevrolet Canada','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.990914,-83.711409,0,'2013-07-06 12:44:32',NULL,NULL),(49062,'56309','S','Ashby','D','Grant','27051','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.092873,-95.819457,0,'2013-07-06 12:44:33',NULL,NULL),(53099,'61534','S','Green Valley','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.447032,-89.651245,0,'2013-07-06 12:44:33',NULL,NULL),(63127,'75336','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.674559,-96.619806,0,'2013-07-06 12:44:33',NULL,NULL),(32649,'36251','S','Gibsonville','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.274905,-85.832315,0,'2013-07-06 12:44:32',NULL,NULL),(75565,'94263','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585076,-121.491659,0,'2013-07-06 12:44:34',NULL,NULL),(58103,'68113','S','Offutt Air Force Base','N','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.124900,-95.916720,0,'2013-07-06 12:44:33',NULL,NULL),(4822,'03906','S','North Berwick','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.305842,-70.742523,0,'2013-07-06 12:44:30',NULL,NULL),(74153,'92258','P','No Palm Springs','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.922919,-116.549446,0,'2013-07-06 12:44:34',NULL,NULL),(7435,'06829','P','Georgetown','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.257587,-73.432452,0,'2013-07-06 12:44:30',NULL,NULL),(33856,'38001','S','Alamo','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.785570,-89.114394,0,'2013-07-06 12:44:32',NULL,NULL),(18275,'19010','S','Rosemont','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.026360,-75.334380,0,'2013-07-06 12:44:31',NULL,NULL),(51740,'60014','S','Vlg of Lakewd','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.230860,-88.326944,0,'2013-07-06 12:44:33',NULL,NULL),(11163,'11722','S','South Hauppauge','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.779120,-73.191420,0,'2013-07-06 12:44:30',NULL,NULL),(63195,'75429','P','Commerce','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.248968,-95.898144,0,'2013-07-06 12:44:33',NULL,NULL),(61495,'72644','S','Lead Hill','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.469449,-92.916329,0,'2013-07-06 12:44:33',NULL,NULL),(60322,'71458','P','Natch','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.757608,-93.086235,0,'2013-07-06 12:44:33',NULL,NULL),(79628,'99126','S','Evans','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.693900,-118.011300,0,'2013-07-06 12:44:34',NULL,NULL),(75128,'93553','S','Pearblossom','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.470395,-117.896351,0,'2013-07-06 12:44:34',NULL,NULL),(5082,'04330','S','Chelsea','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.353599,-69.731361,0,'2013-07-06 12:44:30',NULL,NULL),(18239,'18974','S','Warwick','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.208672,-75.079555,0,'2013-07-06 12:44:31',NULL,NULL),(16141,'17059','S','Jericho Mills','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(62589,'74470','S','Webbers Falls','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.508872,-95.126074,0,'2013-07-06 12:44:33',NULL,NULL),(24521,'27284','S','Union Cross','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.116290,-80.092145,0,'2013-07-06 12:44:31',NULL,NULL),(60114,'71367','S','Lonepine','N','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.850864,-92.412602,0,'2013-07-06 12:44:33',NULL,NULL),(66854,'79166','U','Amarillo Globe News','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.204349,-101.831265,0,'2013-07-06 12:44:34',NULL,NULL),(1862,'00791','S','Parq de Candelero','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(20127,'20720','S','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.965267,-76.773094,0,'2013-07-06 12:44:31',NULL,NULL),(11259,'11768','S','Asharoken','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(26201,'28775','S','Scaly Mountain','D','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.014232,-83.333640,0,'2013-07-06 12:44:31',NULL,NULL),(53359,'61764','S','Rowe','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(49158,'56387','S','Waite Park','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.552241,-94.216617,0,'2013-07-06 12:44:33',NULL,NULL),(48537,'55752','S','Cornish','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.941037,-93.313905,0,'2013-07-06 12:44:33',NULL,NULL),(25207,'28079','S','Indian Trail','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.098742,-80.631203,0,'2013-07-06 12:44:31',NULL,NULL),(265,'00641','S','Urb Cabrera','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(8489,'08094','S','Williamstown','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.642840,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(60292,'71454','S','Fletcher','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(67054,'79553','S','Tuxedo','N','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.948220,-99.769860,0,'2013-07-06 12:44:34',NULL,NULL),(3653,'02120','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.334141,-71.097433,0,'2013-07-06 12:44:30',NULL,NULL),(31220,'33957','S','Sanibel','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.446199,-82.086096,0,'2013-07-06 12:44:32',NULL,NULL),(26746,'29423','P','N Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.845603,-79.977751,0,'2013-07-06 12:44:31',NULL,NULL),(26438,'29129','S','Ridge Spring','D','Saluda','45081','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.737089,-81.657680,0,'2013-07-06 12:44:31',NULL,NULL),(39033,'44146','S','Bedford Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(52548,'60940','S','Grant Park','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.239371,-87.648677,0,'2013-07-06 12:44:33',NULL,NULL),(49800,'57193','U','Midland Life Ins Co','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.545553,-96.720773,0,'2013-07-06 12:44:33',NULL,NULL),(21160,'22135','U','FBI Academy','N','Stafford','51179','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.521184,-77.288054,0,'2013-07-06 12:44:31',NULL,NULL),(45741,'52132','S','Calmar','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.184136,-91.872048,0,'2013-07-06 12:44:32',NULL,NULL),(30166,'33172','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796061,-80.360119,0,'2013-07-06 12:44:32',NULL,NULL),(33684,'37745','S','Baileyton','N','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.186641,-82.815175,0,'2013-07-06 12:44:32',NULL,NULL),(66582,'78746','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.301080,-97.814880,0,'2013-07-06 12:44:34',NULL,NULL),(64631,'76705','S','Lacy Lakeview','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(17679,'18109','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.581201,-75.472059,0,'2013-07-06 12:44:31',NULL,NULL),(19065,'19548','P','Pine Forge','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.285607,-75.692533,0,'2013-07-06 12:44:31',NULL,NULL),(49342,'56567','S','New York Mills','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.688056,-95.352778,0,'2013-07-06 12:44:33',NULL,NULL),(47853,'55076','S','South St Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.849779,-93.034529,0,'2013-07-06 12:44:33',NULL,NULL),(66646,'78840','S','Del Rio','D','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.367308,-100.890893,0,'2013-07-06 12:44:34',NULL,NULL),(45840,'52220','P','Conroy','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.743848,-91.966250,0,'2013-07-06 12:44:32',NULL,NULL),(42206,'47552','S','Lincoln City','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.129410,-86.988319,0,'2013-07-06 12:44:32',NULL,NULL),(40785,'46164','S','Princes Lakes','A','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.341154,-86.103529,0,'2013-07-06 12:44:32',NULL,NULL),(26555,'29209','S','Bluff Estates','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(30611,'33429','P','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.349389,-80.082008,0,'2013-07-06 12:44:32',NULL,NULL),(57323,'66711','S','Cato','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.625557,-94.701799,0,'2013-07-06 12:44:33',NULL,NULL),(67967,'80914','P','Cmafb','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(33211,'37050','S','Cumberland City','D','Stewart','47161','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.375503,-87.563413,0,'2013-07-06 12:44:32',NULL,NULL),(38936,'44122','S','Woodmere','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(53620,'62089','P','Taylor Spgs','A','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.130995,-89.494582,0,'2013-07-06 12:44:33',NULL,NULL),(45363,'51005','S','Aurelia','D','Cherokee','19035','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.715939,-95.435448,0,'2013-07-06 12:44:32',NULL,NULL),(41357,'46792','S','Pleasant Plain','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(70455,'84751','S','Milford','D','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.351737,-112.986950,0,'2013-07-06 12:44:34',NULL,NULL),(1769,'00780','S','Urb Llanos del Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(16816,'17545','S','Mount Hope','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(47785,'55044','S','Antlers Park','N','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.652317,-93.247168,0,'2013-07-06 12:44:33',NULL,NULL),(57089,'66217','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.010010,-94.780199,0,'2013-07-06 12:44:33',NULL,NULL),(62061,'73542','S','Frederick','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.393428,-99.010477,0,'2013-07-06 12:44:33',NULL,NULL),(58232,'68349','S','Elmwood','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.841581,-96.295682,0,'2013-07-06 12:44:33',NULL,NULL),(36419,'40546','U','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.038753,-84.508993,0,'2013-07-06 12:44:32',NULL,NULL),(27872,'30445','S','Mount Vernon','D','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.179324,-82.595973,0,'2013-07-06 12:44:31',NULL,NULL),(29312,'32531','S','Baker','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.788131,-86.606115,0,'2013-07-06 12:44:32',NULL,NULL),(66988,'79490','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.576556,-101.982812,0,'2013-07-06 12:44:34',NULL,NULL),(70720,'85286','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.254994,-111.833255,0,'2013-07-06 12:44:34',NULL,NULL),(11930,'12428','S','Ellenville','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.698500,-74.505120,0,'2013-07-06 12:44:30',NULL,NULL),(23523,'25565','S','Spurlockville','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.077916,-81.994264,0,'2013-07-06 12:44:31',NULL,NULL),(77895,'97292','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.515433,-122.555436,0,'2013-07-06 12:44:34',NULL,NULL),(63696,'75880','U','Tenn Colony','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.835895,-95.839416,0,'2013-07-06 12:44:34',NULL,NULL),(40364,'45640','S','Jackson','D','Jackson','39079','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.032746,-82.649218,0,'2013-07-06 12:44:32',NULL,NULL),(55391,'63629','S','Bunker','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.510008,-91.186057,0,'2013-07-06 12:44:33',NULL,NULL),(66813,'79082','S','Springlake','D','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.249949,-102.315536,0,'2013-07-06 12:44:34',NULL,NULL),(32706,'36280','S','Hawk','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.357551,-85.348233,0,'2013-07-06 12:44:32',NULL,NULL),(32511,'36080','S','Titus','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.651394,-86.264772,0,'2013-07-06 12:44:32',NULL,NULL),(28648,'31768','S','Moultrie','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.171229,-83.782941,0,'2013-07-06 12:44:32',NULL,NULL),(59666,'71052','S','South Mansfield','A','De Soto','22031','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.034409,-93.700560,0,'2013-07-06 12:44:33',NULL,NULL),(54563,'62895','S','Crisp','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(9085,'09034','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(80041,'99702','S','Eielson AFB','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.653581,-147.085013,0,'2013-07-06 12:44:34',NULL,NULL),(13415,'13754','S','Oquaga Lake','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(30902,'33706','S','St Pete Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(75225,'93641','S','Pinehurst','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.693920,-119.035961,0,'2013-07-06 12:44:34',NULL,NULL),(10749,'11359','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.789436,-73.777382,0,'2013-07-06 12:44:30',NULL,NULL),(25129,'28007','P','Ansonville','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.021110,-80.081933,0,'2013-07-06 12:44:31',NULL,NULL),(79096,'98444','S','Parkland','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.150660,-122.447434,0,'2013-07-06 12:44:34',NULL,NULL),(30091,'33157','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(72838,'89833','S','Ruby Valley','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.306038,-115.284616,0,'2013-07-06 12:44:34',NULL,NULL),(50310,'57717','S','Belle Fourche','D','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.665219,-103.847783,0,'2013-07-06 12:44:33',NULL,NULL),(28637,'31756','S','Hartsfield','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.215276,-83.970568,0,'2013-07-06 12:44:32',NULL,NULL),(5527,'04779','S','Cross Lke Twp','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.170980,-68.304902,0,'2013-07-06 12:44:30',NULL,NULL),(58367,'68524','S','Air Park','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.857067,-96.786673,0,'2013-07-06 12:44:33',NULL,NULL),(11069,'11590','S','Westbury','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757311,-73.577498,0,'2013-07-06 12:44:30',NULL,NULL),(59910,'71282','S','Ashley','N','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(1797,'00783','S','Urb Monterey','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(58564,'68825','S','Delight','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.288611,-99.923023,0,'2013-07-06 12:44:33',NULL,NULL),(49177,'56425','S','Brainerd','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341560,-94.288961,0,'2013-07-06 12:44:33',NULL,NULL),(43153,'48255','U','Comerica','N','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331409,-83.051738,0,'2013-07-06 12:44:32',NULL,NULL),(269,'00641','S','Utuado','D','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(47212,'54493','S','Hendren','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.697478,-90.815604,0,'2013-07-06 12:44:32',NULL,NULL),(4298,'02904','S','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.832900,-71.437560,0,'2013-07-06 12:44:30',NULL,NULL),(63818,'75972','S','Denning','N','San Augustine','48405','Texas','TX','48','0000','936','Central',-6.0,'Y',31.548960,-94.095660,0,'2013-07-06 12:44:34',NULL,NULL),(66392,'78624','S','Spring Creek','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(11795,'12223','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651781,-73.757949,0,'2013-07-06 12:44:30',NULL,NULL),(33323,'37143','S','Pegram','D','Cheatham','47021','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.124381,-87.026548,0,'2013-07-06 12:44:32',NULL,NULL),(30721,'33521','P','Coleman','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.800169,-82.070244,0,'2013-07-06 12:44:32',NULL,NULL),(11580,'12072','S','Fultonville','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.944695,-74.376969,0,'2013-07-06 12:44:30',NULL,NULL),(4026,'02568','S','North Tisbury','N','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.453520,-70.589400,0,'2013-07-06 12:44:30',NULL,NULL),(12209,'12790','S','Wurtsboro','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.590168,-74.526249,0,'2013-07-06 12:44:30',NULL,NULL),(68640,'81637','S','Sweetwater','N','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.633376,-106.954148,0,'2013-07-06 12:44:34',NULL,NULL),(74533,'92656','S','Laguna Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.576120,-117.736380,0,'2013-07-06 12:44:34',NULL,NULL),(11714,'12172','P','Stottville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.287538,-73.742015,0,'2013-07-06 12:44:30',NULL,NULL),(74982,'93445','S','Oceano','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.102497,-120.611271,0,'2013-07-06 12:44:34',NULL,NULL),(4266,'02882','S','Point Judith','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.432140,-71.468662,0,'2013-07-06 12:44:30',NULL,NULL),(71057,'85752','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.351982,-111.048553,0,'2013-07-06 12:44:34',NULL,NULL),(64316,'76475','S','Strawn','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.556935,-98.497761,0,'2013-07-06 12:44:34',NULL,NULL),(59797,'71220','S','Upland','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(10948,'11439','U','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.722867,-73.788363,0,'2013-07-06 12:44:30',NULL,NULL),(12843,'13316','S','Empeyville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.354631,-75.746699,0,'2013-07-06 12:44:30',NULL,NULL),(22923,'24614','S','Grundy','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.277524,-82.094356,0,'2013-07-06 12:44:31',NULL,NULL),(61591,'72758','S','Rogers','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.329665,-94.127155,0,'2013-07-06 12:44:33',NULL,NULL),(28147,'30824','S','Thomson','D','McDuffie','13189','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.468374,-82.498017,0,'2013-07-06 12:44:31',NULL,NULL),(7865,'07503','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.897944,-74.156957,0,'2013-07-06 12:44:30',NULL,NULL),(75027,'93504','P','California City','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.147963,-118.010042,0,'2013-07-06 12:44:34',NULL,NULL),(74272,'92350','U','Loma Linda University','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.052083,-117.263767,0,'2013-07-06 12:44:34',NULL,NULL),(37031,'41256','S','Barnetts Creek','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.836517,-82.861342,0,'2013-07-06 12:44:32',NULL,NULL),(60187,'71417','S','Rock','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.519190,-92.705968,0,'2013-07-06 12:44:33',NULL,NULL),(64273,'76426','S','Runaway Bay','A','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.151387,-97.821373,0,'2013-07-06 12:44:34',NULL,NULL),(4790,'03872','S','Brookfield','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.551728,-71.015802,0,'2013-07-06 12:44:30',NULL,NULL),(2012,'00915','S','Barrio Obrero','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(56715,'65680','S','Kissee Mills','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.665728,-93.025250,0,'2013-07-06 12:44:33',NULL,NULL),(56596,'65559','S','Safe','N','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.998771,-91.613832,0,'2013-07-06 12:44:33',NULL,NULL),(66197,'78543','P','Elsa','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.297711,-97.993340,0,'2013-07-06 12:44:34',NULL,NULL),(69641,'84005','S','Lehi','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.352471,-111.983329,0,'2013-07-06 12:44:34',NULL,NULL),(10592,'11027','P','Great Neck','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.798205,-73.738285,0,'2013-07-06 12:44:30',NULL,NULL),(5691,'04975','P','Shawmut','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.622377,-69.589233,0,'2013-07-06 12:44:30',NULL,NULL),(66218,'78557','S','Hidalgo','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.100919,-98.244193,0,'2013-07-06 12:44:34',NULL,NULL),(18131,'18825','S','Jackson','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.867048,-75.609174,0,'2013-07-06 12:44:31',NULL,NULL),(42783,'48044','S','Macomb Township','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.651262,-82.925811,0,'2013-07-06 12:44:32',NULL,NULL),(40249,'45429','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.686892,-84.159357,0,'2013-07-06 12:44:32',NULL,NULL),(38433,'43556','S','Sherwood','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.299570,-84.562441,0,'2013-07-06 12:44:32',NULL,NULL),(32375,'35902','P','Gadsden','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.000276,-85.956435,0,'2013-07-06 12:44:32',NULL,NULL),(7908,'07620','P','Alpine','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.954487,-73.925395,0,'2013-07-06 12:44:30',NULL,NULL),(21368,'22451','P','Dogue','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.235220,-77.214022,0,'2013-07-06 12:44:31',NULL,NULL),(70253,'84415','P','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.222904,-111.971747,0,'2013-07-06 12:44:34',NULL,NULL),(28741,'31993','U','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.481702,-84.976028,0,'2013-07-06 12:44:32',NULL,NULL),(43857,'49112','S','Edwardsburg','D','Cass','26027','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.797374,-86.040698,0,'2013-07-06 12:44:32',NULL,NULL),(79137,'98499','S','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(68314,'81101','S','Waverly','N','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(46490,'53225','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.113789,-88.040760,0,'2013-07-06 12:44:32',NULL,NULL),(33025,'36722','S','Arlington','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.044710,-87.585820,0,'2013-07-06 12:44:32',NULL,NULL),(3945,'02472','S','E Watertown','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.371297,-71.180361,0,'2013-07-06 12:44:30',NULL,NULL),(71875,'87730','S','Mills','D','Harding','35021','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.130813,-104.278693,0,'2013-07-06 12:44:34',NULL,NULL),(28163,'30907','S','Augusta','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.525000,-82.101420,0,'2013-07-06 12:44:31',NULL,NULL),(60388,'71602','S','Pine Bluff','A','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.261382,-92.132192,0,'2013-07-06 12:44:33',NULL,NULL),(37494,'42025','S','Palma','N','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.877980,-88.333200,0,'2013-07-06 12:44:32',NULL,NULL),(44871,'50310','S','Beaverdale','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.626925,-93.672635,0,'2013-07-06 12:44:32',NULL,NULL),(56971,'66160','U','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.058215,-94.609992,0,'2013-07-06 12:44:33',NULL,NULL),(57824,'67525','S','Odin','A','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.524583,-98.534997,0,'2013-07-06 12:44:33',NULL,NULL),(48792,'56003','S','N Mankato','N','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.185763,-94.056217,0,'2013-07-06 12:44:33',NULL,NULL),(48586,'55779','S','Brevator','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(61872,'73128','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.451515,-97.620639,0,'2013-07-06 12:44:33',NULL,NULL),(68671,'81657','S','Vail','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.650220,-106.360740,0,'2013-07-06 12:44:34',NULL,NULL),(34541,'38703','S','Greenville','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.421500,-91.019400,0,'2013-07-06 12:44:32',NULL,NULL),(70042,'84134','U','Utah State Tax Commission','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.774204,-111.946340,0,'2013-07-06 12:44:34',NULL,NULL),(3950,'02474','S','East Arlington','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.420728,-71.158189,0,'2013-07-06 12:44:30',NULL,NULL),(77539,'96853','S','Jb Pearl Harbor Hickam','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.339051,-157.943329,0,'2013-07-06 12:44:34',NULL,NULL),(28708,'31829','S','Columbus','A','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.563740,-84.739320,0,'2013-07-06 12:44:32',NULL,NULL),(17404,'17901','S','Phoenix Park','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(75021,'93475','P','Oceano','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.101630,-120.611837,0,'2013-07-06 12:44:34',NULL,NULL),(12889,'13331','S','Eagle Bay','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.841882,-74.878424,0,'2013-07-06 12:44:30',NULL,NULL),(74454,'92587','S','Quail Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.695760,-117.239280,0,'2013-07-06 12:44:34',NULL,NULL),(41097,'46550','S','Nappanee','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.447798,-85.999846,0,'2013-07-06 12:44:32',NULL,NULL),(55412,'63651','P','Knob Lick','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.675439,-90.370288,0,'2013-07-06 12:44:33',NULL,NULL),(37171,'41472','S','Silverhill','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(11868,'12302','S','Stoodley Corners','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(20031,'20635','P','Helen','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.331965,-76.785037,0,'2013-07-06 12:44:31',NULL,NULL),(4417,'03227','S','CTR Sandwich','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.834383,-71.477065,0,'2013-07-06 12:44:30',NULL,NULL),(1095,'00725','S','Urb Jose Delgado','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(74500,'92627','S','Costa Mesa','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648280,-117.915538,0,'2013-07-06 12:44:34',NULL,NULL),(33286,'37121','P','Mount Juliet','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.205060,-86.520664,0,'2013-07-06 12:44:32',NULL,NULL),(71515,'87115','S','Manzano Base','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.982758,-106.517977,0,'2013-07-06 12:44:34',NULL,NULL),(60567,'71754','P','Magnolia','D','Columbia','05027','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.267422,-93.239230,0,'2013-07-06 12:44:33',NULL,NULL),(11888,'12309','S','Upper Union','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.795780,-73.867440,0,'2013-07-06 12:44:30',NULL,NULL),(35562,'39567','S','Bigpoint','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(79728,'99215','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.690874,-117.209831,0,'2013-07-06 12:44:34',NULL,NULL),(50483,'58048','S','Hunter','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.195870,-97.323836,0,'2013-07-06 12:44:33',NULL,NULL),(11684,'12153','S','Taborton','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.637100,-73.491691,0,'2013-07-06 12:44:30',NULL,NULL),(65324,'77515','S','Angleton','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(56865,'66013','S','Bucyrus','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.782596,-94.699097,0,'2013-07-06 12:44:33',NULL,NULL),(52793,'61273','S','Western','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.366880,-90.433140,0,'2013-07-06 12:44:33',NULL,NULL),(15444,'16401','S','Pageville','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(41224,'46733','S','Peterson','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(19060,'19547','S','Manatawny','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(20015,'20619','S','California','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.300880,-76.520266,0,'2013-07-06 12:44:31',NULL,NULL),(5450,'04730','S','Hodgdon','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.125041,-67.839044,0,'2013-07-06 12:44:30',NULL,NULL),(3965,'02492','S','Needham','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.276004,-71.243064,0,'2013-07-06 12:44:30',NULL,NULL),(73257,'90713','S','Lakewood','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.851668,-118.107286,0,'2013-07-06 12:44:34',NULL,NULL),(75088,'93535','S','Lake Los Angeles','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.715491,-117.902577,0,'2013-07-06 12:44:34',NULL,NULL),(2625,'00962','S','Urb Catano Pueblo','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(22789,'24460','S','Millboro Springs','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.020620,-79.650900,0,'2013-07-06 12:44:31',NULL,NULL),(7422,'06814','U','Shared Zip For Brm','N','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.377300,-73.488123,0,'2013-07-06 12:44:30',NULL,NULL),(67410,'80131','P','Louviers','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.475712,-105.006529,0,'2013-07-06 12:44:34',NULL,NULL),(43477,'48604','S','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.473230,-83.947983,0,'2013-07-06 12:44:32',NULL,NULL),(51776,'60040','S','Highwood','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.203499,-87.813543,0,'2013-07-06 12:44:33',NULL,NULL),(5493,'04751','U','Defense Finance Accounting','N','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.908611,-67.826389,0,'2013-07-06 12:44:30',NULL,NULL),(55050,'63145','P','Lambert Arprt','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.748850,-90.361025,0,'2013-07-06 12:44:33',NULL,NULL),(6637,'06006','U','Northeast Area','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.854244,-72.644045,0,'2013-07-06 12:44:30',NULL,NULL),(75758,'94617','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.757976,-122.147048,0,'2013-07-06 12:44:34',NULL,NULL),(539,'00676','S','Parc Sabana','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(21107,'22046','S','Falls Church','D','Falls Church City','51610','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.884560,-77.182978,0,'2013-07-06 12:44:31',NULL,NULL),(56769,'65740','S','Merriam Woods Village','A','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.701943,-93.161158,0,'2013-07-06 12:44:33',NULL,NULL),(29727,'32956','P','Rockledge','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.316875,-80.727762,0,'2013-07-06 12:44:32',NULL,NULL),(77058,'96120','S','Crystal Springs','N','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(68748,'82222','S','Lance Creek','D','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.179868,-104.600423,0,'2013-07-06 12:44:34',NULL,NULL),(63778,'75951','S','Holly Springs','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(51592,'59808','S','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.849245,-114.014432,0,'2013-07-06 12:44:33',NULL,NULL),(45322,'50851','S','Lenox','D','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.882080,-94.560958,0,'2013-07-06 12:44:32',NULL,NULL),(33663,'37723','S','Crab Orchard','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.895389,-84.848577,0,'2013-07-06 12:44:32',NULL,NULL),(47789,'55046','S','Lonsdale','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445600,-93.413280,0,'2013-07-06 12:44:33',NULL,NULL),(7010,'06259','S','Pomfret Center','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.876521,-72.011578,0,'2013-07-06 12:44:30',NULL,NULL),(33686,'37745','S','Tusculum','A','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.186641,-82.815175,0,'2013-07-06 12:44:32',NULL,NULL),(59379,'70601','S','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.228174,-93.194503,0,'2013-07-06 12:44:33',NULL,NULL),(65975,'78296','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.427516,-98.487585,0,'2013-07-06 12:44:34',NULL,NULL),(79063,'98430','U','Camp Murray','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255899,-122.440697,0,'2013-07-06 12:44:34',NULL,NULL),(17827,'18414','S','Scott Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.532124,-75.732122,0,'2013-07-06 12:44:31',NULL,NULL),(33801,'37892','S','Winfield','D','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.521860,-84.501975,0,'2013-07-06 12:44:32',NULL,NULL),(57926,'67672','S','Wakeeney','D','Trego','20195','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.987400,-99.880140,0,'2013-07-06 12:44:33',NULL,NULL),(54673,'62940','S','Gorham','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.745311,-89.441223,0,'2013-07-06 12:44:33',NULL,NULL),(26160,'28743','S','Hot Springs','D','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(2941,'01029','P','Big Pond','N','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.159812,-73.043385,0,'2013-07-06 12:44:30',NULL,NULL),(1780,'00782','S','Urb La Hacienda','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(56124,'64832','S','Waco','A','Barton','29011','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.272981,-94.609466,0,'2013-07-06 12:44:33',NULL,NULL),(17486,'17960','S','Dorset','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(35648,'39641','S','Sartinsville','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.410049,-90.187496,0,'2013-07-06 12:44:32',NULL,NULL),(52868,'61335','S','McNabb','N','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.177164,-89.208757,0,'2013-07-06 12:44:33',NULL,NULL),(18623,'19151','S','Overbrook Hills','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.977579,-75.254673,0,'2013-07-06 12:44:31',NULL,NULL),(70757,'85327','P','Cave Creek','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.826462,-111.963469,0,'2013-07-06 12:44:34',NULL,NULL),(17048,'17751','S','Mill Hall','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(32070,'35283','P','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.517488,-86.809476,0,'2013-07-06 12:44:32',NULL,NULL),(11350,'11797','S','Woodbury','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.813810,-73.468323,0,'2013-07-06 12:44:30',NULL,NULL),(31690,'34788','S','Haines Creek','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.853853,-81.778191,0,'2013-07-06 12:44:32',NULL,NULL),(75597,'94301','S','Palo Alto','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.439933,-122.151692,0,'2013-07-06 12:44:34',NULL,NULL),(62391,'74085','S','Yale','D','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.115757,-96.700338,0,'2013-07-06 12:44:33',NULL,NULL),(51560,'59748','P','Ramsay','D','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.107165,-112.642452,0,'2013-07-06 12:44:33',NULL,NULL),(43902,'49247','S','Rollin','A','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.853146,-84.330032,0,'2013-07-06 12:44:32',NULL,NULL),(79959,'99635','P','Nikishka','N','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.690180,-151.288800,0,'2013-07-06 12:44:34',NULL,NULL),(41290,'46761','S','Valentine','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(60713,'71953','S','Black Fork','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(74591,'92698','U','Aliso Viejo','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.668598,-117.838637,0,'2013-07-06 12:44:34',NULL,NULL),(47061,'54422','S','Curtiss','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953643,-90.433401,0,'2013-07-06 12:44:32',NULL,NULL),(60686,'71933','S','Mazarn','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.347207,-93.316503,0,'2013-07-06 12:44:33',NULL,NULL),(66786,'79045','S','Hereford','D','Deaf Smith','48117','Texas','TX','48','0000','806','Central',-6.0,'Y',34.821088,-102.402643,0,'2013-07-06 12:44:34',NULL,NULL),(65082,'77354','S','Decker Pr','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.221346,-95.676720,0,'2013-07-06 12:44:34',NULL,NULL),(71768,'87553','S','Picuris','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.172500,-105.745200,0,'2013-07-06 12:44:34',NULL,NULL),(45084,'50532','S','Brushy','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.470067,-93.993314,0,'2013-07-06 12:44:32',NULL,NULL),(77972,'97377','S','Shedd','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.465799,-123.110600,0,'2013-07-06 12:44:34',NULL,NULL),(61120,'72152','S','Haywood','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.356360,-91.987080,0,'2013-07-06 12:44:33',NULL,NULL),(17854,'18430','S','Herrick Center','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.761885,-75.507594,0,'2013-07-06 12:44:31',NULL,NULL),(45221,'50642','S','Holland','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.400663,-92.800257,0,'2013-07-06 12:44:32',NULL,NULL),(48443,'55705','S','Pineville','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.498700,-92.235780,0,'2013-07-06 12:44:33',NULL,NULL),(6392,'05730','S','Belmont','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.421527,-72.817203,0,'2013-07-06 12:44:30',NULL,NULL),(71087,'85931','P','Forest Lakes','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.626034,-111.111768,0,'2013-07-06 12:44:34',NULL,NULL),(16777,'17527','S','Gap','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.010580,-75.992040,0,'2013-07-06 12:44:31',NULL,NULL),(3748,'02171','S','N Quincy','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(65741,'78056','S','Castroville','A','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.579640,-98.874960,0,'2013-07-06 12:44:34',NULL,NULL),(17889,'18444','S','Roaring Bk Tp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(60379,'71486','S','Zwolle','D','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623819,-93.634378,0,'2013-07-06 12:44:33',NULL,NULL),(5704,'04985','S','E Moxie Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(79798,'99356','S','Roosevelt','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.806187,-120.309134,0,'2013-07-06 12:44:34',NULL,NULL),(78421,'98046','P','Lynnwood','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.830174,-122.304010,0,'2013-07-06 12:44:34',NULL,NULL),(36654,'41007','S','Carthage','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.894989,-84.294749,0,'2013-07-06 12:44:32',NULL,NULL),(59035,'70083','S','Potash','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(12870,'13324','S','Morehouseville','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(20803,'21555','S','Oldtown','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.595816,-78.560611,0,'2013-07-06 12:44:31',NULL,NULL),(68144,'80995','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.964661,-104.792493,0,'2013-07-06 12:44:34',NULL,NULL),(3290,'01504','S','Millerville','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.026266,-71.528483,0,'2013-07-06 12:44:30',NULL,NULL),(12967,'13367','S','Beaver River','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.787100,-75.476910,0,'2013-07-06 12:44:30',NULL,NULL),(53674,'62218','S','Bartelso','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.522043,-89.480239,0,'2013-07-06 12:44:33',NULL,NULL),(56634,'65607','P','Caplinger Mills','D','Cedar','29039','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.794964,-93.804523,0,'2013-07-06 12:44:33',NULL,NULL),(7252,'06514','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.372400,-72.939720,0,'2013-07-06 12:44:30',NULL,NULL),(43296,'48336','S','Farmington Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458873,-83.346843,0,'2013-07-06 12:44:32',NULL,NULL),(48666,'55917','S','Blooming Prairie','D','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917900,-93.055500,0,'2013-07-06 12:44:33',NULL,NULL),(3613,'02053','S','Medway','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.145235,-71.407864,0,'2013-07-06 12:44:30',NULL,NULL),(2465,'00956','S','Ciudad Interamericana','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(54225,'62650','S','South Jacksonville','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(40236,'45422','U','Montgomery Cnty Admnstrv','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.760595,-84.186625,0,'2013-07-06 12:44:32',NULL,NULL),(42168,'47527','S','Crystal','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(20703,'21263','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290550,-76.609596,0,'2013-07-06 12:44:31',NULL,NULL),(7409,'06795','S','Watertown','D','Litchfield','09005','Connecticut','CT','09','8880','860/959','Eastern',-5.0,'Y',41.605821,-73.125700,0,'2013-07-06 12:44:30',NULL,NULL),(7062,'06332','P','Central Village','D','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.724456,-71.908237,0,'2013-07-06 12:44:30',NULL,NULL),(49622,'56904','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(79065,'98430','U','Tacoma','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255899,-122.440697,0,'2013-07-06 12:44:34',NULL,NULL),(65034,'77327','S','North Cleveland','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(52085,'60404','S','Shorewood','D','Will','17197','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.514639,-88.198385,0,'2013-07-06 12:44:33',NULL,NULL),(49151,'56379','S','Sauk Rapids','D','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.616973,-94.118408,0,'2013-07-06 12:44:33',NULL,NULL),(42978,'48139','P','Hamburg','D','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.454041,-83.811311,0,'2013-07-06 12:44:32',NULL,NULL),(72246,'88523','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.813053,-106.417368,0,'2013-07-06 12:44:34',NULL,NULL),(74173,'92274','S','One Hundred Palms','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(79783,'99344','S','Royal Slope','N','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.819036,-119.168555,0,'2013-07-06 12:44:34',NULL,NULL),(12698,'13142','S','Port Ontario','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.557794,-76.128407,0,'2013-07-06 12:44:30',NULL,NULL),(56118,'64803','P','Joplin','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.034415,-94.509317,0,'2013-07-06 12:44:33',NULL,NULL),(5688,'04972','P','Sandy Point','D','Waldo','23027','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.512516,-68.811078,0,'2013-07-06 12:44:30',NULL,NULL),(59350,'70559','S','Morse','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.098183,-92.502091,0,'2013-07-06 12:44:33',NULL,NULL),(11952,'12448','S','Lake Hill','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.072851,-74.210051,0,'2013-07-06 12:44:30',NULL,NULL),(11979,'12469','S','Preston Hlow','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.456600,-74.220660,0,'2013-07-06 12:44:30',NULL,NULL),(60682,'71929','S','Lambert','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.336448,-93.193258,0,'2013-07-06 12:44:33',NULL,NULL),(8541,'08201','S','Galloway Township','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(49821,'57216','S','Big Stone Cty','A','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.292796,-96.462397,0,'2013-07-06 12:44:33',NULL,NULL),(38099,'43085','S','Linworth','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.098773,-83.017045,0,'2013-07-06 12:44:32',NULL,NULL),(48182,'55387','S','Minnetrista','N','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.847413,-93.788794,0,'2013-07-06 12:44:33',NULL,NULL),(24304,'27013','S','Mount Vernon','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.745026,-80.676769,0,'2013-07-06 12:44:31',NULL,NULL),(5738,'05034','S','West Bridgewater','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.572856,-72.617134,0,'2013-07-06 12:44:30',NULL,NULL),(72513,'89154','P','Univ Nv Las Vegas','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.086541,-115.146079,0,'2013-07-06 12:44:34',NULL,NULL),(69871,'84095','S','Riverton','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569297,-111.967229,0,'2013-07-06 12:44:34',NULL,NULL),(31482,'34430','P','Dunnellon','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.053058,-82.378464,0,'2013-07-06 12:44:32',NULL,NULL),(2362,'00949','S','Levittown','A','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(37771,'42345','S','Greenville','D','Muhlenberg','21177','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.207010,-87.181121,0,'2013-07-06 12:44:32',NULL,NULL),(34720,'38841','S','Ecru','D','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.347360,-88.989000,0,'2013-07-06 12:44:32',NULL,NULL),(10883,'11421','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.692189,-73.856141,0,'2013-07-06 12:44:30',NULL,NULL),(14799,'15377','S','West Finley','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.982714,-80.445036,0,'2013-07-06 12:44:31',NULL,NULL),(1739,'00778','S','Urb Los Robles','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(61925,'73152','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.518680,-97.505079,0,'2013-07-06 12:44:33',NULL,NULL),(26701,'29407','S','St Andrews','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.800052,-80.010928,0,'2013-07-06 12:44:31',NULL,NULL),(46414,'53181','S','Twin Lakes','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.519397,-88.254983,0,'2013-07-06 12:44:32',NULL,NULL),(8529,'08108','S','Haddon Township','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.913768,-75.065877,0,'2013-07-06 12:44:30',NULL,NULL),(33555,'37405','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.074768,-85.309383,0,'2013-07-06 12:44:32',NULL,NULL),(41270,'46750','S','Simpson','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(64764,'76945','S','Robert Lee','D','Coke','48081','Texas','TX','48','0000','325','Central',-6.0,'Y',31.896228,-100.482117,0,'2013-07-06 12:44:34',NULL,NULL),(62369,'74073','S','Sperry','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.291646,-95.967837,0,'2013-07-06 12:44:33',NULL,NULL),(60944,'72099','U','Lr AFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.891861,-92.158312,0,'2013-07-06 12:44:33',NULL,NULL),(50034,'57430','S','Britton','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.806700,-97.722180,0,'2013-07-06 12:44:33',NULL,NULL),(35506,'39531','S','BLX','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400773,-88.962563,0,'2013-07-06 12:44:32',NULL,NULL),(8383,'08057','S','Moorestown','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.962222,-74.982778,0,'2013-07-06 12:44:30',NULL,NULL),(54029,'62460','S','Denison','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.591789,-87.646603,0,'2013-07-06 12:44:33',NULL,NULL),(4566,'03467','S','Westmoreland','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.956812,-72.422762,0,'2013-07-06 12:44:30',NULL,NULL),(70305,'84542','S','East Wellington','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.551983,-110.731494,0,'2013-07-06 12:44:34',NULL,NULL),(38774,'44053','S','Lorain','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.428474,-82.204417,0,'2013-07-06 12:44:32',NULL,NULL),(24285,'27006','S','Bermuda Run','A','Davie','37059','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.010380,-80.447340,0,'2013-07-06 12:44:31',NULL,NULL),(52955,'61418','S','Biggsville','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.853434,-90.856874,0,'2013-07-06 12:44:33',NULL,NULL),(13890,'14269','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.865140,-78.869492,0,'2013-07-06 12:44:31',NULL,NULL),(66144,'78472','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693700,-97.398467,0,'2013-07-06 12:44:34',NULL,NULL),(14061,'14586','S','West Henrietta','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.043209,-77.679662,0,'2013-07-06 12:44:31',NULL,NULL),(50430,'57791','S','Wasta','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.094970,-102.335284,0,'2013-07-06 12:44:33',NULL,NULL),(46182,'52738','S','Cotter','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(73483,'91321','S','Newhall','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.379025,-118.520802,0,'2013-07-06 12:44:34',NULL,NULL),(19628,'20250','U','Dept Agriculture','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884663,-77.030371,0,'2013-07-06 12:44:31',NULL,NULL),(19576,'20215','U','Dept Labor Payroll Audit Div','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894207,-77.012508,0,'2013-07-06 12:44:31',NULL,NULL),(67203,'79910','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766131,-106.426133,0,'2013-07-06 12:44:34',NULL,NULL),(61236,'72335','S','Forrest City','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.012397,-90.782355,0,'2013-07-06 12:44:33',NULL,NULL),(61011,'72114','S','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(1728,'00778','S','Repto San Jose','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(7557,'07018','S','East Orange','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.754785,-74.218897,0,'2013-07-06 12:44:30',NULL,NULL),(77469,'96817','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.334849,-157.856702,0,'2013-07-06 12:44:34',NULL,NULL),(24420,'27150','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.103682,-80.207720,0,'2013-07-06 12:44:31',NULL,NULL),(38269,'43316','S','Adrian','A','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943398,-83.381939,0,'2013-07-06 12:44:32',NULL,NULL),(58089,'68102','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260653,-95.934340,0,'2013-07-06 12:44:33',NULL,NULL),(31536,'34489','P','Silver Springs','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.226877,-81.948070,0,'2013-07-06 12:44:32',NULL,NULL),(67452,'80214','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745789,-105.059616,0,'2013-07-06 12:44:34',NULL,NULL),(30655,'33462','S','Atlantis','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.581130,-80.079020,0,'2013-07-06 12:44:32',NULL,NULL),(13953,'14461','P','Gorham','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.801791,-77.130502,0,'2013-07-06 12:44:31',NULL,NULL),(72826,'89822','S','Carlin','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.716972,-116.105345,0,'2013-07-06 12:44:34',NULL,NULL),(69793,'84065','S','Herriman','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.535262,-111.962723,0,'2013-07-06 12:44:34',NULL,NULL),(47576,'54846','S','Highbridge','A','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.381203,-90.737197,0,'2013-07-06 12:44:33',NULL,NULL),(58341,'68465','S','Wilber','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.481162,-96.964186,0,'2013-07-06 12:44:33',NULL,NULL),(3419,'01720','S','W Acton','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.477355,-71.446686,0,'2013-07-06 12:44:30',NULL,NULL),(29064,'32246','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.305263,-81.511694,0,'2013-07-06 12:44:32',NULL,NULL),(66317,'78594','P','Sebastian','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.345568,-97.791107,0,'2013-07-06 12:44:34',NULL,NULL),(33086,'36793','S','Lawley','D','Bibb','01007','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.865756,-86.963491,0,'2013-07-06 12:44:32',NULL,NULL),(35409,'39465','S','Harvey','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.340040,-89.189100,0,'2013-07-06 12:44:32',NULL,NULL),(72296,'88577','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.759159,-106.487488,0,'2013-07-06 12:44:34',NULL,NULL),(1188,'00728','S','Bo Magueyes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(40727,'46124','S','Camp Attrbry','A','Johnson','18081','Indiana','IN','18','3480','812','Eastern',-5.0,'Y',39.353574,-85.964085,0,'2013-07-06 12:44:32',NULL,NULL),(76513,'95642','S','Jackson','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.360720,-120.742856,0,'2013-07-06 12:44:34',NULL,NULL),(49032,'56279','S','Pennock','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.215370,-95.169095,0,'2013-07-06 12:44:33',NULL,NULL),(33776,'37871','S','Straw Plains','A','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.018011,-83.706710,0,'2013-07-06 12:44:32',NULL,NULL),(31934,'35183','S','Weogufka','D','Coosa','01037','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.967826,-86.369735,0,'2013-07-06 12:44:32',NULL,NULL),(25452,'28326','S','Cameron','D','Harnett','37085','North Carolina','NC','37','0000','919/984','Eastern',-5.0,'Y',35.340855,-79.223822,0,'2013-07-06 12:44:31',NULL,NULL),(13002,'13411','S','South Edmeston','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(10039,'10173','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(63359,'75638','S','Jenkins','N','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.976111,-94.718333,0,'2013-07-06 12:44:33',NULL,NULL),(19286,'19970','S','Ocean View','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.555449,-75.108954,0,'2013-07-06 12:44:31',NULL,NULL),(42412,'47802','S','Keller','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(54167,'62612','S','Prentice','A','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.886126,-90.009613,0,'2013-07-06 12:44:33',NULL,NULL),(23160,'25015','S','Diamond','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(20598,'21204','S','Loch Raven','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404090,-76.608279,0,'2013-07-06 12:44:31',NULL,NULL),(47305,'54552','S','Park Falls','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(30952,'33732','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.756372,-82.643512,0,'2013-07-06 12:44:32',NULL,NULL),(24775,'27559','S','Moncure','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.671783,-79.170590,0,'2013-07-06 12:44:31',NULL,NULL),(7589,'07036','S','Tremley','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.635633,-74.256169,0,'2013-07-06 12:44:30',NULL,NULL),(77733,'97070','S','Charbonneau','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.301823,-122.762197,0,'2013-07-06 12:44:34',NULL,NULL),(43953,'49304','S','Baldwin','D','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.897103,-85.853664,0,'2013-07-06 12:44:32',NULL,NULL),(50968,'58631','S','Eagles Nest','N','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.818421,-101.839984,0,'2013-07-06 12:44:33',NULL,NULL),(7277,'06525','S','Woodbridge','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.360503,-73.012777,0,'2013-07-06 12:44:30',NULL,NULL),(69493,'83703','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.627724,-116.263707,0,'2013-07-06 12:44:34',NULL,NULL),(69366,'83555','S','Winchester','D','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.242252,-116.607936,0,'2013-07-06 12:44:34',NULL,NULL),(19274,'19962','S','Magnolia','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.071345,-75.526500,0,'2013-07-06 12:44:31',NULL,NULL),(12767,'13209','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.085400,-76.251720,0,'2013-07-06 12:44:30',NULL,NULL),(40003,'45244','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118320,-84.337680,0,'2013-07-06 12:44:32',NULL,NULL),(26007,'28675','S','Twin Oaks','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.506191,-81.117283,0,'2013-07-06 12:44:31',NULL,NULL),(78074,'97467','S','Reedsport','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.709940,-123.973740,0,'2013-07-06 12:44:34',NULL,NULL),(52025,'60179','U','Hoffman Estates','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.079712,-88.224255,0,'2013-07-06 12:44:33',NULL,NULL),(35090,'39205','P','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.304324,-90.182529,0,'2013-07-06 12:44:32',NULL,NULL),(52144,'60439','S','Lemont','D','Cook','17031','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.702649,-88.072694,0,'2013-07-06 12:44:33',NULL,NULL),(67999,'80920','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.958459,-104.757058,0,'2013-07-06 12:44:34',NULL,NULL),(35794,'39752','S','Clarkson','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.539394,-89.135634,0,'2013-07-06 12:44:32',NULL,NULL),(9228,'09543','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3719,'02145','S','Somerville','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.391409,-71.094721,0,'2013-07-06 12:44:30',NULL,NULL),(40264,'45432','S','Beavercreek','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.741263,-84.068879,0,'2013-07-06 12:44:32',NULL,NULL),(71126,'86022','S','Cane Beds','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.945813,-112.529509,0,'2013-07-06 12:44:34',NULL,NULL),(73565,'91367','S','Woodland Hls','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.178189,-118.623042,0,'2013-07-06 12:44:34',NULL,NULL),(1353,'00736','S','Mans Monte Verde','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(33438,'37305','S','Beersheba Springs','D','Grundy','47061','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.485212,-85.652867,0,'2013-07-06 12:44:32',NULL,NULL),(65104,'77365','S','Timberlane Acres','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.105908,-95.260353,0,'2013-07-06 12:44:34',NULL,NULL),(40919,'46274','U','Time Life Inc','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.895207,-86.257246,0,'2013-07-06 12:44:32',NULL,NULL),(78374,'98022','S','Krain','N','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.208720,-121.863420,0,'2013-07-06 12:44:34',NULL,NULL),(52220,'60487','S','Orland Hills','A','Cook','17031','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.567359,-87.791980,0,'2013-07-06 12:44:33',NULL,NULL),(29529,'32784','S','Dona Vista','A','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.927940,-81.664305,0,'2013-07-06 12:44:32',NULL,NULL),(9124,'09142','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19257,'19944','S','Fenwick Isle','A','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.459312,-75.052878,0,'2013-07-06 12:44:31',NULL,NULL),(22359,'23898','S','Zuni','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.831280,-76.840923,0,'2013-07-06 12:44:31',NULL,NULL),(9993,'10166','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(8940,'08755','S','Toms River','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.000470,-74.222076,0,'2013-07-06 12:44:30',NULL,NULL),(48088,'55336','S','Glencoe','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.771232,-94.149805,0,'2013-07-06 12:44:33',NULL,NULL),(26714,'29413','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.793627,-79.929515,0,'2013-07-06 12:44:31',NULL,NULL),(39784,'45130','S','Poetown','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.910678,-83.984564,0,'2013-07-06 12:44:32',NULL,NULL),(31500,'34447','P','Homosassa Springs','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.796554,-82.550226,0,'2013-07-06 12:44:32',NULL,NULL),(33391,'37220','S','Forest Hills','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.067492,-86.781198,0,'2013-07-06 12:44:32',NULL,NULL),(78191,'97730','S','Camp Sherman','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.445641,-121.658818,0,'2013-07-06 12:44:34',NULL,NULL),(62680,'74720','P','Achille','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.924563,-96.265123,0,'2013-07-06 12:44:33',NULL,NULL),(10717,'11245','U','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.693148,-73.985871,0,'2013-07-06 12:44:30',NULL,NULL),(78364,'98020','S','Edmonds','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.800941,-122.374292,0,'2013-07-06 12:44:34',NULL,NULL),(50387,'57764','S','Oglala','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.185802,-102.739517,0,'2013-07-06 12:44:33',NULL,NULL),(54009,'62448','S','Wakefield','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.988361,-88.163646,0,'2013-07-06 12:44:33',NULL,NULL),(28558,'31568','S','White Oak','D','Camden','13039','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.106278,-81.725750,0,'2013-07-06 12:44:32',NULL,NULL),(68797,'82421','S','Deaver','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.893147,-108.591631,0,'2013-07-06 12:44:34',NULL,NULL),(59306,'70513','P','Avery Island','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.044609,-91.880175,0,'2013-07-06 12:44:33',NULL,NULL),(50218,'57580','S','Mosher','N','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(72978,'90049','S','Barrington','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.078365,-118.486589,0,'2013-07-06 12:44:34',NULL,NULL),(74194,'92281','S','Westmorland','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.034322,-115.611218,0,'2013-07-06 12:44:34',NULL,NULL),(17966,'18610','S','Blakeslee','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.100466,-75.568798,0,'2013-07-06 12:44:31',NULL,NULL),(12746,'13203','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.060624,-76.139954,0,'2013-07-06 12:44:30',NULL,NULL),(28803,'32063','S','Macclenny','D','Baker','12003','Florida','FL','12','0000','904','Eastern',-5.0,'Y',30.284132,-82.127726,0,'2013-07-06 12:44:32',NULL,NULL),(32016,'35235','S','Grayson Valley','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(26484,'29162','S','Turbeville','D','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.881147,-80.006901,0,'2013-07-06 12:44:31',NULL,NULL),(28675,'31794','S','Abac','A','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.460118,-83.509086,0,'2013-07-06 12:44:32',NULL,NULL),(45087,'50533','S','Eagle Grove','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.663250,-93.902294,0,'2013-07-06 12:44:32',NULL,NULL),(35468,'39505','P','GPT','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.442559,-89.067759,0,'2013-07-06 12:44:32',NULL,NULL),(75672,'94547','S','Hercules','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',38.011358,-122.262961,0,'2013-07-06 12:44:34',NULL,NULL),(78419,'98045','S','Denny Creek','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.475162,-121.756532,0,'2013-07-06 12:44:34',NULL,NULL),(65795,'78125','P','Kenedy','A','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.550320,-97.903107,0,'2013-07-06 12:44:34',NULL,NULL),(62259,'74006','S','Bville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.738109,-95.933260,0,'2013-07-06 12:44:33',NULL,NULL),(49942,'57337','S','Fedora','D','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.980581,-97.790792,0,'2013-07-06 12:44:33',NULL,NULL),(46491,'53225','S','Wauwatosa','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.113789,-88.040760,0,'2013-07-06 12:44:32',NULL,NULL),(3543,'01915','S','Beverly Farms','N','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.566460,-70.853280,0,'2013-07-06 12:44:30',NULL,NULL),(16994,'17728','S','Perryville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(54205,'62639','S','Frederick','D','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.056023,-90.495285,0,'2013-07-06 12:44:33',NULL,NULL),(57189,'66416','S','Circleville','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.507485,-95.859636,0,'2013-07-06 12:44:33',NULL,NULL),(3086,'01201','S','Allendale','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.455451,-73.249993,0,'2013-07-06 12:44:30',NULL,NULL),(33881,'38024','S','Dyersburg','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.039737,-89.384816,0,'2013-07-06 12:44:32',NULL,NULL),(68063,'80934','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.844726,-104.860092,0,'2013-07-06 12:44:34',NULL,NULL),(5501,'04761','P','Houlton','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.128321,-67.971164,0,'2013-07-06 12:44:30',NULL,NULL),(53926,'62401','S','Green Creek','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(27166,'29838','S','Colliers','N','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.708528,-82.217647,0,'2013-07-06 12:44:31',NULL,NULL),(64729,'76883','S','Telegraph','D','Edwards','48137','Texas','TX','48','0000','325','Central',-6.0,'Y',30.336485,-99.983284,0,'2013-07-06 12:44:34',NULL,NULL),(51130,'58801','S','Bonetraill','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.416870,-103.823860,0,'2013-07-06 12:44:33',NULL,NULL),(73798,'91750','S','La Verne','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.117986,-117.768243,0,'2013-07-06 12:44:34',NULL,NULL),(76660,'95742','S','Rancho Cordova','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587081,-121.204382,0,'2013-07-06 12:44:34',NULL,NULL),(78867,'98349','S','Home','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.280780,-122.773440,0,'2013-07-06 12:44:34',NULL,NULL),(46351,'53097','S','Thiensville','A','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.236480,-87.984600,0,'2013-07-06 12:44:32',NULL,NULL),(9573,'10026','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803430,-73.952625,0,'2013-07-06 12:44:30',NULL,NULL),(20656,'21226','S','Chestnut Hill Cove','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(23328,'25235','S','Floe','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.677705,-81.093441,0,'2013-07-06 12:44:31',NULL,NULL),(5223,'04462','S','Long A Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.654650,-68.702349,0,'2013-07-06 12:44:30',NULL,NULL),(49711,'57035','S','Wellington','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.711272,-96.886802,0,'2013-07-06 12:44:33',NULL,NULL),(61480,'72635','S','Monkey Run','N','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.302640,-92.484480,0,'2013-07-06 12:44:33',NULL,NULL),(27864,'30441','S','Midville','D','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(62489,'74355','P','Miami','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.890711,-94.876486,0,'2013-07-06 12:44:33',NULL,NULL),(15673,'16823','S','Bellefonte','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.938060,-77.721720,0,'2013-07-06 12:44:31',NULL,NULL),(31083,'33862','P','Lake Placid','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.293438,-81.361851,0,'2013-07-06 12:44:32',NULL,NULL),(53846,'62321','S','Fountain Green','N','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(43095,'48213','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.393275,-82.995296,0,'2013-07-06 12:44:32',NULL,NULL),(70087,'84158','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.739667,-111.817677,0,'2013-07-06 12:44:34',NULL,NULL),(75829,'94912','P','San Rafael','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.977710,-122.506459,0,'2013-07-06 12:44:34',NULL,NULL),(79098,'98445','S','Parkland','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.137362,-122.409805,0,'2013-07-06 12:44:34',NULL,NULL),(1941,'00795','S','Villa El Encanto','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(14032,'14546','S','Wheatland','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.029866,-77.765882,0,'2013-07-06 12:44:31',NULL,NULL),(38822,'44077','S','Fairport Harbor','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.750000,-81.283333,0,'2013-07-06 12:44:32',NULL,NULL),(73878,'91942','S','La Mesa','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.784319,-117.017783,0,'2013-07-06 12:44:34',NULL,NULL),(75780,'94701','P','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.869905,-122.270672,0,'2013-07-06 12:44:34',NULL,NULL),(18956,'19512','S','District','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(17070,'17758','S','Beech Glen','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(44611,'50055','S','Collins','D','Story','19169','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.903253,-93.306942,0,'2013-07-06 12:44:32',NULL,NULL),(36113,'40222','S','Glenview Manor','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(57983,'67842','S','Kingsdown','A','Ford','20057','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.634089,-99.755515,0,'2013-07-06 12:44:33',NULL,NULL),(38858,'44095','S','Lakeline','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.654810,-81.440913,0,'2013-07-06 12:44:32',NULL,NULL),(31128,'33903','S','N Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.683534,-81.905577,0,'2013-07-06 12:44:32',NULL,NULL),(29805,'33023','S','West Hollywood','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(8236,'08002','S','Cherry Hill','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.933589,-75.018781,0,'2013-07-06 12:44:30',NULL,NULL),(15137,'15847','P','Knox Dale','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.162256,-79.081754,0,'2013-07-06 12:44:31',NULL,NULL),(15423,'16366','U','Blair Corp','N','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.843956,-79.141103,0,'2013-07-06 12:44:31',NULL,NULL),(11046,'11572','S','Rockville Center','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.658611,-73.641667,0,'2013-07-06 12:44:30',NULL,NULL),(10603,'11040','S','Manhasset Hil','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(13522,'13815','S','Chenango Lake','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.530787,-75.524876,0,'2013-07-06 12:44:31',NULL,NULL),(55334,'63549','S','South Gifford','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.023008,-92.494977,0,'2013-07-06 12:44:33',NULL,NULL),(29027,'32228','P','Mayport Naval Station','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(33931,'38061','S','Essary Springs','N','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.028862,-88.816731,0,'2013-07-06 12:44:32',NULL,NULL),(35548,'39564','S','Gulf Hills','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(36260,'40324','S','Georgetown','D','Scott','21209','Kentucky','KY','21','4280','502','Eastern',-5.0,'Y',38.220225,-84.565091,0,'2013-07-06 12:44:32',NULL,NULL),(70024,'84129','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696347,-112.017349,0,'2013-07-06 12:44:34',NULL,NULL),(23157,'25009','S','Ashford','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.190518,-81.712810,0,'2013-07-06 12:44:31',NULL,NULL),(9490,'10012','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724324,-73.996124,0,'2013-07-06 12:44:30',NULL,NULL),(29921,'33062','S','Hillsboro Beach','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.234821,-80.093841,0,'2013-07-06 12:44:32',NULL,NULL),(54315,'62721','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.794416,-89.648447,0,'2013-07-06 12:44:33',NULL,NULL),(52746,'61241','S','Green Rock','A','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.481385,-90.329909,0,'2013-07-06 12:44:33',NULL,NULL),(79159,'98507','P','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.031455,-122.870480,0,'2013-07-06 12:44:34',NULL,NULL),(5519,'04776','S','Silver Ridge','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.815245,-68.309550,0,'2013-07-06 12:44:30',NULL,NULL),(61863,'73123','P','Warr Acres','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.537598,-97.621042,0,'2013-07-06 12:44:33',NULL,NULL),(68159,'81004','S','Bessemer','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.226239,-104.660953,0,'2013-07-06 12:44:34',NULL,NULL),(3549,'01930','S','Gloucester','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.628500,-70.686240,0,'2013-07-06 12:44:30',NULL,NULL),(63134,'75357','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.824932,-96.678883,0,'2013-07-06 12:44:33',NULL,NULL),(58366,'68523','S','Rokeby','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.735318,-96.757947,0,'2013-07-06 12:44:33',NULL,NULL),(46385,'53144','S','Kenosha','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.649960,-87.869149,0,'2013-07-06 12:44:32',NULL,NULL),(57429,'66781','S','Weir','D','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.298040,-94.755000,0,'2013-07-06 12:44:33',NULL,NULL),(2493,'00956','S','Villas de Buena Vista','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(25330,'28207','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.198282,-80.830604,0,'2013-07-06 12:44:31',NULL,NULL),(49592,'56748','S','Plummer','D','Red Lake','27125','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.903815,-95.901783,0,'2013-07-06 12:44:33',NULL,NULL),(40033,'45249','S','Symmes Twp','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.290580,-84.334690,0,'2013-07-06 12:44:32',NULL,NULL),(53217,'61630','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.682843,-89.601814,0,'2013-07-06 12:44:33',NULL,NULL),(54299,'62707','S','Bissell','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(17099,'17767','P','Salona','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.088882,-77.468055,0,'2013-07-06 12:44:31',NULL,NULL),(23469,'25442','S','Shenandoah Junction','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.359284,-77.838178,0,'2013-07-06 12:44:31',NULL,NULL),(49681,'57016','S','Lake Brandt','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.894594,-97.007429,0,'2013-07-06 12:44:33',NULL,NULL),(29560,'32811','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.522969,-81.443050,0,'2013-07-06 12:44:32',NULL,NULL),(56630,'65604','S','Ash Grove','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.315620,-93.580809,0,'2013-07-06 12:44:33',NULL,NULL),(2272,'00926','S','Urb Sagrado Corazon','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(955,'00716','S','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(27475,'30147','S','Lindale','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.171707,-85.189331,0,'2013-07-06 12:44:31',NULL,NULL),(47416,'54656','S','Sparta','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.948001,-90.811171,0,'2013-07-06 12:44:32',NULL,NULL),(38741,'44030','S','East Conneaut','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(30273,'33247','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.852307,-80.239515,0,'2013-07-06 12:44:32',NULL,NULL),(73266,'90720','S','Rossmoor','A','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.795614,-118.064756,0,'2013-07-06 12:44:34',NULL,NULL),(76376,'95521','S','Mc Kinleyville','A','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.928760,-124.060080,0,'2013-07-06 12:44:34',NULL,NULL),(41376,'46795','S','Woodland Park','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(12109,'12583','S','Nevis','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.057300,-73.886760,0,'2013-07-06 12:44:30',NULL,NULL),(24232,'26743','S','New Creek','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.319934,-79.047286,0,'2013-07-06 12:44:31',NULL,NULL),(2711,'00969','S','Parq de Bucare','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(23246,'25114','S','Ramage','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.959900,-81.811980,0,'2013-07-06 12:44:31',NULL,NULL),(67046,'79548','S','Rule','D','Haskell','48207','Texas','TX','48','0000','940','Central',-6.0,'Y',33.184444,-99.893333,0,'2013-07-06 12:44:34',NULL,NULL),(372,'00660','S','Bo Lavadero','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(61074,'72126','S','Thornburg','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(21152,'22121','P','Mount Vernon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.716701,-77.108231,0,'2013-07-06 12:44:31',NULL,NULL),(78311,'97909','S','Jamieson','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.222643,-117.488983,0,'2013-07-06 12:44:34',NULL,NULL),(32973,'36610','S','Magazine','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.739731,-88.080296,0,'2013-07-06 12:44:32',NULL,NULL),(30372,'33317','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.093836,-80.239494,0,'2013-07-06 12:44:32',NULL,NULL),(29505,'32763','S','Orange City','D','Volusia','12127','Florida','FL','12','2020','407/321/689','Eastern',-5.0,'Y',28.943912,-81.301782,0,'2013-07-06 12:44:32',NULL,NULL),(53202,'61613','U','Northwoods Shop Ctr','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.742374,-89.628187,0,'2013-07-06 12:44:33',NULL,NULL),(24364,'27050','S','Tobaccoville','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.232639,-80.396424,0,'2013-07-06 12:44:31',NULL,NULL),(25137,'28017','P','Boiling Spgs','A','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.252902,-81.644801,0,'2013-07-06 12:44:31',NULL,NULL),(28036,'30646','S','Hull','D','Madison','13195','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.020092,-83.314243,0,'2013-07-06 12:44:31',NULL,NULL),(52919,'61368','S','Providence','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.293034,-89.507464,0,'2013-07-06 12:44:33',NULL,NULL),(36622,'40988','S','Stoney Fork','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.884347,-83.530783,0,'2013-07-06 12:44:32',NULL,NULL),(69288,'83443','S','Ririe','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.595448,-111.660076,0,'2013-07-06 12:44:34',NULL,NULL),(61587,'72753','S','Prairie Grove','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.976750,-94.319194,0,'2013-07-06 12:44:33',NULL,NULL),(56424,'65260','S','Jacksonville','D','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.579424,-92.419085,0,'2013-07-06 12:44:33',NULL,NULL),(9354,'09810','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(13562,'13839','S','Franklin Depot','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.220441,-75.323336,0,'2013-07-06 12:44:31',NULL,NULL),(59355,'70570','S','Opelousas','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.532550,-92.084616,0,'2013-07-06 12:44:33',NULL,NULL),(73234,'90651','P','Norwalk','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.906859,-118.076073,0,'2013-07-06 12:44:34',NULL,NULL),(75951,'95043','S','New Idria','N','San Benito','06069','California','CA','06','0000','831','Pacific',-8.0,'Y',36.548040,-121.016280,0,'2013-07-06 12:44:34',NULL,NULL),(14066,'14592','P','York','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.873962,-77.884221,0,'2013-07-06 12:44:31',NULL,NULL),(74596,'92703','S','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.748904,-117.907165,0,'2013-07-06 12:44:34',NULL,NULL),(31394,'34223','S','Englewood','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.013007,-82.380021,0,'2013-07-06 12:44:32',NULL,NULL),(64242,'76357','S','Byers','D','Clay','48077','Texas','TX','48','0000','940','Central',-6.0,'Y',34.063392,-98.192731,0,'2013-07-06 12:44:34',NULL,NULL),(62911,'75074','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.029555,-96.675345,0,'2013-07-06 12:44:33',NULL,NULL),(75452,'94066','S','San Bruno','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.625010,-122.432243,0,'2013-07-06 12:44:34',NULL,NULL),(77179,'96306','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(19950,'20578','U','Farm Credit Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897253,-77.010546,0,'2013-07-06 12:44:31',NULL,NULL),(30680,'33470','S','Lxhtchee Grvs','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(40186,'45377','S','Vandalia','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.889016,-84.205982,0,'2013-07-06 12:44:32',NULL,NULL),(40545,'45846','S','Ft Recovery','N','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.418548,-84.748829,0,'2013-07-06 12:44:32',NULL,NULL),(5228,'04463','S','Milo','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.248630,-68.986198,0,'2013-07-06 12:44:30',NULL,NULL),(10941,'11435','S','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699477,-73.808819,0,'2013-07-06 12:44:30',NULL,NULL),(60425,'71643','S','Gould','D','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.984603,-91.556472,0,'2013-07-06 12:44:33',NULL,NULL),(49112,'56350','S','Mc Grath','D','Aitkin','27001','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.289865,-93.239993,0,'2013-07-06 12:44:33',NULL,NULL),(1471,'00745','S','Urb Los Maestros','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(4957,'04105','S','Falmouth Foreside','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.743978,-70.281854,0,'2013-07-06 12:44:30',NULL,NULL),(76948,'96031','S','Frk of Salmon','A','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.218476,-123.245773,0,'2013-07-06 12:44:34',NULL,NULL),(11886,'12309','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.795780,-73.867440,0,'2013-07-06 12:44:30',NULL,NULL),(61664,'72916','S','Bonanza','A','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.326437,-94.423658,0,'2013-07-06 12:44:33',NULL,NULL),(55073,'63178','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.629922,-90.217361,0,'2013-07-06 12:44:33',NULL,NULL),(21331,'22408','S','Frederickbur','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(20591,'21163','S','Woodstock','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341160,-76.859940,0,'2013-07-06 12:44:31',NULL,NULL),(6964,'06234','S','Brooklyn','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.785357,-71.954821,0,'2013-07-06 12:44:30',NULL,NULL),(37204,'41522','S','Dunleary','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(14241,'14817','S','Brooktondale','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.370141,-76.365201,0,'2013-07-06 12:44:31',NULL,NULL),(19302,'20002','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905231,-76.992743,0,'2013-07-06 12:44:31',NULL,NULL),(25915,'28645','S','Warrior','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(4718,'03822','U','Liberty Mutual Insurance','N','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.218179,-70.841093,0,'2013-07-06 12:44:30',NULL,NULL),(75418,'94025','S','West Menlo Park','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.436934,-122.193602,0,'2013-07-06 12:44:34',NULL,NULL),(64151,'76202','P','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.176509,-97.183450,0,'2013-07-06 12:44:34',NULL,NULL),(64044,'76129','U','Texas Christian Univ','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.705900,-97.359380,0,'2013-07-06 12:44:34',NULL,NULL),(41995,'47424','S','Hashtown','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(36237,'40293','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258971,-85.758075,0,'2013-07-06 12:44:32',NULL,NULL),(75632,'94514','S','Byron','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.872000,-121.613640,0,'2013-07-06 12:44:34',NULL,NULL),(20780,'21536','S','Grantsville','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.676680,-79.153920,0,'2013-07-06 12:44:31',NULL,NULL),(43057,'48187','S','Canton Twp','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.331838,-83.477568,0,'2013-07-06 12:44:32',NULL,NULL),(13682,'14043','S','Depew','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.902602,-78.706762,0,'2013-07-06 12:44:31',NULL,NULL),(64405,'76544','S','Chaffee Village','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(2127,'00924','S','Parc Hill Brothers','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(2593,'00961','S','Urb Enramada','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(53266,'61720','S','Anchor','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.526876,-88.517491,0,'2013-07-06 12:44:33',NULL,NULL),(15438,'16388','U','Warren Industries','N','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.648956,-80.147265,0,'2013-07-06 12:44:31',NULL,NULL),(42744,'48023','S','Ira','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.688876,-82.669348,0,'2013-07-06 12:44:32',NULL,NULL),(18555,'19119','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.069561,-75.210372,0,'2013-07-06 12:44:31',NULL,NULL),(64127,'76191','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.808015,-97.354309,0,'2013-07-06 12:44:34',NULL,NULL),(51269,'59102','S','Hesper','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.785595,-108.576337,0,'2013-07-06 12:44:33',NULL,NULL),(22867,'24557','S','Gretna','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.952581,-79.364393,0,'2013-07-06 12:44:31',NULL,NULL),(60051,'71348','P','Libuse','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.263570,-92.424744,0,'2013-07-06 12:44:33',NULL,NULL),(7613,'07054','S','Parsippany','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.859388,-74.413425,0,'2013-07-06 12:44:30',NULL,NULL),(75931,'95019','S','Freedom','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.934894,-121.777258,0,'2013-07-06 12:44:34',NULL,NULL),(68543,'81420','P','Lazear','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.776803,-107.781887,0,'2013-07-06 12:44:34',NULL,NULL),(51957,'60137','S','Glendale Hts','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.871806,-88.065073,0,'2013-07-06 12:44:33',NULL,NULL),(46830,'54014','S','Hager City','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.602849,-92.538909,0,'2013-07-06 12:44:32',NULL,NULL),(50112,'57501','S','Canning','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(70338,'84631','S','Flowell','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.901194,-112.632166,0,'2013-07-06 12:44:34',NULL,NULL),(12852,'13317','S','Mapletown','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.893700,-74.574180,0,'2013-07-06 12:44:30',NULL,NULL),(30713,'33503','P','Balm','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.779577,-82.312495,0,'2013-07-06 12:44:32',NULL,NULL),(67605,'80429','P','Leadville','A','Lake','08065','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.326580,-106.234080,0,'2013-07-06 12:44:34',NULL,NULL),(46986,'54230','S','Cato','A','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.151390,-87.921245,0,'2013-07-06 12:44:32',NULL,NULL),(66139,'78467','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.748683,-97.420344,0,'2013-07-06 12:44:34',NULL,NULL),(8639,'08270','S','Petersburg','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(34513,'38676','S','Little Texas','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(75732,'94596','S','Walnut Creek','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.904944,-122.054411,0,'2013-07-06 12:44:34',NULL,NULL),(72439,'89086','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.281466,-115.134712,0,'2013-07-06 12:44:34',NULL,NULL),(56257,'65061','S','Hope','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.502518,-91.534868,0,'2013-07-06 12:44:33',NULL,NULL),(54320,'62726','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.805194,-89.652979,0,'2013-07-06 12:44:33',NULL,NULL),(18910,'19482','P','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.094429,-75.469240,0,'2013-07-06 12:44:31',NULL,NULL),(36534,'40863','S','Alva','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.745787,-83.455764,0,'2013-07-06 12:44:32',NULL,NULL),(28026,'30634','S','Dewy Rose','D','Elbert','13105','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.181291,-82.947378,0,'2013-07-06 12:44:31',NULL,NULL),(13432,'13760','S','Campville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(38870,'44104','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.484079,-81.629568,0,'2013-07-06 12:44:32',NULL,NULL),(14265,'14843','S','Hornell','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.328714,-77.656438,0,'2013-07-06 12:44:31',NULL,NULL),(4815,'03901','S','Berwick','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.289863,-70.853529,0,'2013-07-06 12:44:30',NULL,NULL),(26086,'28709','S','Barnardsville','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.761504,-82.433278,0,'2013-07-06 12:44:31',NULL,NULL),(4818,'03904','S','Kittery','D','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.097316,-70.743639,0,'2013-07-06 12:44:30',NULL,NULL),(21194,'22191','S','Wdbg','N','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.626232,-77.274322,0,'2013-07-06 12:44:31',NULL,NULL),(22076,'23356','S','Greenbackville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',38.001245,-75.413882,0,'2013-07-06 12:44:31',NULL,NULL),(62124,'73659','S','Putnam','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.845181,-98.942549,0,'2013-07-06 12:44:33',NULL,NULL),(49336,'56562','S','Moorhead','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.862982,-96.763781,0,'2013-07-06 12:44:33',NULL,NULL),(75638,'94519','S','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.980490,-122.006612,0,'2013-07-06 12:44:34',NULL,NULL),(66589,'78749','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.211620,-97.851840,0,'2013-07-06 12:44:34',NULL,NULL),(33942,'38075','S','Whiteville','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.324796,-89.149580,0,'2013-07-06 12:44:32',NULL,NULL),(5697,'04981','S','Stockton Spgs','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.533378,-68.860272,0,'2013-07-06 12:44:30',NULL,NULL),(21445,'22579','P','Wicomico Chur','A','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.788954,-76.360133,0,'2013-07-06 12:44:31',NULL,NULL),(69489,'83686','S','Nampa','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.533311,-116.574597,0,'2013-07-06 12:44:34',NULL,NULL),(71595,'87319','P','Mentmore','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.493375,-108.855190,0,'2013-07-06 12:44:34',NULL,NULL),(51262,'59087','S','Cat Creek','A','Petroleum','30069','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.065280,-108.005560,0,'2013-07-06 12:44:33',NULL,NULL),(52566,'60959','S','Piper City','D','Ford','17053','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.759016,-88.187314,0,'2013-07-06 12:44:33',NULL,NULL),(61524,'72662','S','Omaha','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.456548,-93.172793,0,'2013-07-06 12:44:33',NULL,NULL),(79177,'98520','S','Markham','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(9301,'09711','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(16568,'17315','S','Mount Royal','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.013820,-76.815840,0,'2013-07-06 12:44:31',NULL,NULL),(67445,'80208','U','University of Denver','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.680475,-104.962996,0,'2013-07-06 12:44:34',NULL,NULL),(30689,'33476','S','Pahokee','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.819344,-80.662225,0,'2013-07-06 12:44:32',NULL,NULL),(61397,'72542','S','Highland','A','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.256526,-91.538180,0,'2013-07-06 12:44:33',NULL,NULL),(22055,'23323','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.714360,-76.294260,0,'2013-07-06 12:44:31',NULL,NULL),(66797,'79061','S','Old Mobeetie','N','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.535764,-100.441825,0,'2013-07-06 12:44:34',NULL,NULL),(43780,'49038','S','Coloma','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.203099,-86.326828,0,'2013-07-06 12:44:32',NULL,NULL),(38831,'44084','S','Rock Creek','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.666663,-80.872296,0,'2013-07-06 12:44:32',NULL,NULL),(16370,'17201','S','New Franklin','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(1262,'00729','S','Villas del Este','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(27514,'30188','S','Holly Springs','A','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.115005,-84.455112,0,'2013-07-06 12:44:31',NULL,NULL),(33532,'37382','P','Summitville','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.557770,-85.993171,0,'2013-07-06 12:44:32',NULL,NULL),(64077,'76147','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.748100,-97.365374,0,'2013-07-06 12:44:34',NULL,NULL),(8299,'08022','S','Mansfield','N','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.077182,-74.691452,0,'2013-07-06 12:44:30',NULL,NULL),(5190,'04443','S','Willimantic','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.214034,-69.409404,0,'2013-07-06 12:44:30',NULL,NULL),(4551,'03452','S','Jaffrey','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.814093,-72.031745,0,'2013-07-06 12:44:30',NULL,NULL),(62347,'74058','S','Pawnee','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.331099,-96.777425,0,'2013-07-06 12:44:33',NULL,NULL),(59206,'70391','P','Paincourtvlle','A','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.990731,-91.055924,0,'2013-07-06 12:44:33',NULL,NULL),(56932,'66073','S','Perry','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.075627,-95.393017,0,'2013-07-06 12:44:33',NULL,NULL),(42894,'48097','S','Brockway','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.116201,-82.794016,0,'2013-07-06 12:44:32',NULL,NULL),(6254,'05544','U','Internal Revenue Service','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.649524,-71.184214,0,'2013-07-06 12:44:30',NULL,NULL),(64875,'77065','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.930003,-95.605601,0,'2013-07-06 12:44:34',NULL,NULL),(71215,'86315','S','Prescott Vly','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',34.537845,-112.469326,0,'2013-07-06 12:44:34',NULL,NULL),(960,'00716','S','Sect Salistral','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(1576,'00767','S','Urb Mendez','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(19409,'20078','U','Washington Brm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916403,-76.994507,0,'2013-07-06 12:44:31',NULL,NULL),(73708,'91610','P','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.155836,-118.379194,0,'2013-07-06 12:44:34',NULL,NULL),(43883,'49228','S','Blissfield','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.819406,-83.875842,0,'2013-07-06 12:44:32',NULL,NULL),(73779,'91744','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.028223,-117.937998,0,'2013-07-06 12:44:34',NULL,NULL),(63115,'75301','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.661511,-96.885392,0,'2013-07-06 12:44:33',NULL,NULL),(19429,'20103','U','Dulles','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.997377,-77.451478,0,'2013-07-06 12:44:31',NULL,NULL),(27769,'30366','P','Chamblee','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.887527,-84.287641,0,'2013-07-06 12:44:31',NULL,NULL),(49945,'57340','S','Fulton','D','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.726969,-97.822202,0,'2013-07-06 12:44:33',NULL,NULL),(63001,'75156','S','Gun Barrel City','A','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.295960,-96.118738,0,'2013-07-06 12:44:33',NULL,NULL),(76093,'95220','S','Acampo','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.196391,-121.231802,0,'2013-07-06 12:44:34',NULL,NULL),(79264,'98568','S','Gibson Creek','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.843134,-123.246221,0,'2013-07-06 12:44:34',NULL,NULL),(3291,'01505','S','Boylston','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.331643,-71.734141,0,'2013-07-06 12:44:30',NULL,NULL),(72394,'89041','P','Johnnie','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.259020,-116.018640,0,'2013-07-06 12:44:34',NULL,NULL),(61476,'72634','S','Flippin','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.279343,-92.593895,0,'2013-07-06 12:44:33',NULL,NULL),(54298,'62707','S','Archer','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(54190,'62628','S','Bethel','N','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.767526,-90.403632,0,'2013-07-06 12:44:33',NULL,NULL),(28507,'31532','S','Denton','D','Jeff Davis','13161','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.783139,-82.658447,0,'2013-07-06 12:44:32',NULL,NULL),(19877,'20530','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891194,-77.022162,0,'2013-07-06 12:44:31',NULL,NULL),(3068,'01128','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.094006,-72.494830,0,'2013-07-06 12:44:30',NULL,NULL),(40460,'45745','S','Warner','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.607800,-81.350400,0,'2013-07-06 12:44:32',NULL,NULL),(37576,'42083','S','Tiline','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.163084,-88.248816,0,'2013-07-06 12:44:32',NULL,NULL),(34837,'38921','S','Charleston','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.980940,-90.107520,0,'2013-07-06 12:44:32',NULL,NULL),(75689,'94559','S','Napa','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.292689,-122.287500,0,'2013-07-06 12:44:34',NULL,NULL),(23448,'25419','S','Falling Waters','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.575745,-77.891093,0,'2013-07-06 12:44:31',NULL,NULL),(62788,'74880','S','Weleetka','D','Okfuskee','40107','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.334178,-96.130338,0,'2013-07-06 12:44:33',NULL,NULL),(61949,'73165','S','Del City','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.334300,-97.345860,0,'2013-07-06 12:44:33',NULL,NULL),(58625,'68862','S','Noble','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.599708,-98.930085,0,'2013-07-06 12:44:33',NULL,NULL),(16238,'17078','S','Palmyra','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299264,-76.586642,0,'2013-07-06 12:44:31',NULL,NULL),(70865,'85603','S','Bisbee Jct','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(74952,'93420','S','Halcyon','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.120444,-120.564172,0,'2013-07-06 12:44:34',NULL,NULL),(77861,'97231','S','Burlington','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.633419,-122.856362,0,'2013-07-06 12:44:34',NULL,NULL),(6681,'06039','S','Hotchkiss School','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.952050,-73.433986,0,'2013-07-06 12:44:30',NULL,NULL),(32398,'35956','S','Boaz','D','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.203788,-86.154159,0,'2013-07-06 12:44:32',NULL,NULL),(31822,'35064','S','Fairfield','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.478682,-86.921329,0,'2013-07-06 12:44:32',NULL,NULL),(28002,'30604','P','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',34.006838,-83.493235,0,'2013-07-06 12:44:31',NULL,NULL),(27145,'29822','P','Clearwater','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.497709,-81.893574,0,'2013-07-06 12:44:31',NULL,NULL),(25833,'28618','S','Deep Gap','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.192222,-81.529594,0,'2013-07-06 12:44:31',NULL,NULL),(13587,'13848','P','Tunnel','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.216349,-75.728147,0,'2013-07-06 12:44:31',NULL,NULL),(60485,'71658','S','Thebes','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.306540,-91.515180,0,'2013-07-06 12:44:33',NULL,NULL),(59269,'70455','S','Robert','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.521644,-90.334674,0,'2013-07-06 12:44:33',NULL,NULL),(58728,'68942','S','Guide Rock','D','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.072859,-98.328721,0,'2013-07-06 12:44:33',NULL,NULL),(16023,'17042','S','Iona','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(2948,'01032','S','Lithia','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.466800,-72.830760,0,'2013-07-06 12:44:30',NULL,NULL),(11057,'11577','S','East Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.785766,-73.637013,0,'2013-07-06 12:44:30',NULL,NULL),(11876,'12306','S','Bellevue','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.792392,-73.984961,0,'2013-07-06 12:44:30',NULL,NULL),(1911,'00795','S','Ext Jacaguax','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(59716,'71107','S','Dixie','A','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.608620,-93.862080,0,'2013-07-06 12:44:33',NULL,NULL),(36204,'40269','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.164595,-85.515500,0,'2013-07-06 12:44:32',NULL,NULL),(25887,'28642','S','Jonesville','D','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.236940,-80.782320,0,'2013-07-06 12:44:31',NULL,NULL),(16894,'17580','P','Talmage','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.115482,-76.211364,0,'2013-07-06 12:44:31',NULL,NULL),(4322,'02916','S','Rumford','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.839800,-71.416200,0,'2013-07-06 12:44:30',NULL,NULL),(5662,'04961','S','Lexington Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(60391,'71611','P','Pine Bluff','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.200673,-91.939537,0,'2013-07-06 12:44:33',NULL,NULL),(46396,'53157','P','Pell Lake','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.541376,-88.354927,0,'2013-07-06 12:44:32',NULL,NULL),(74536,'92657','S','Newport Coast','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.588320,-117.808426,0,'2013-07-06 12:44:34',NULL,NULL),(28301,'31107','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.763577,-84.351567,0,'2013-07-06 12:44:31',NULL,NULL),(73560,'91364','S','Woodland Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.153026,-118.602986,0,'2013-07-06 12:44:34',NULL,NULL),(80104,'99755','P','Denali National Park','D','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.625861,-150.903059,0,'2013-07-06 12:44:34',NULL,NULL),(91,'00612','S','Sect El Cano','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(3676,'02127','S','South Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.338960,-71.025290,0,'2013-07-06 12:44:30',NULL,NULL),(69803,'84069','S','Rush Valley','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.346188,-112.454949,0,'2013-07-06 12:44:34',NULL,NULL),(19191,'19808','S','Marshallton','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.731712,-75.669224,0,'2013-07-06 12:44:31',NULL,NULL),(32792,'36426','S','Brewton','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(56227,'65041','S','McKittrick','A','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.697938,-91.437726,0,'2013-07-06 12:44:33',NULL,NULL),(78862,'98346','S','Eglon','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.805964,-122.524971,0,'2013-07-06 12:44:34',NULL,NULL),(49801,'57193','U','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.545553,-96.720773,0,'2013-07-06 12:44:33',NULL,NULL),(49319,'56548','S','Halstad','D','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.351884,-96.825530,0,'2013-07-06 12:44:33',NULL,NULL),(70775,'85342','S','Circle City','N','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.850320,-112.609320,0,'2013-07-06 12:44:34',NULL,NULL),(79844,'99545','P','Kongiganak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.940532,-164.621428,0,'2013-07-06 12:44:34',NULL,NULL),(47681,'54960','S','Neshkoro','D','Marquette','55077','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.936871,-89.256930,0,'2013-07-06 12:44:33',NULL,NULL),(39479,'44720','S','McDonaldsville','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.897320,-81.433440,0,'2013-07-06 12:44:32',NULL,NULL),(33814,'37920','S','Kimberlin Hgt','A','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.923862,-83.877198,0,'2013-07-06 12:44:32',NULL,NULL),(5965,'05301','S','W Brattleboro','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.843087,-72.688635,0,'2013-07-06 12:44:30',NULL,NULL),(28172,'30999','U','Augusta','D','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.456177,-81.991838,0,'2013-07-06 12:44:31',NULL,NULL),(73586,'91384','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.464820,-118.640594,0,'2013-07-06 12:44:34',NULL,NULL),(77247,'96542','M','FPO','A','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77622,'96970','P','Ebeye','D','Marshall Islands','68020','Marshall Islands','MH','68','0000','692','UTC+12',12.0,'N',7.121001,171.062651,0,'2013-07-06 12:44:34',NULL,NULL),(23739,'25921','P','McAlpin','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.706351,-81.256171,0,'2013-07-06 12:44:31',NULL,NULL),(21051,'21902','P','Perry Point','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.552425,-76.072526,0,'2013-07-06 12:44:31',NULL,NULL),(6652,'06020','S','Canton Center','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.849426,-72.922674,0,'2013-07-06 12:44:30',NULL,NULL),(21250,'22246','U','US Unmanned Aerial Vehicles','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.857622,-77.053083,0,'2013-07-06 12:44:31',NULL,NULL),(20984,'21811','S','Berlin','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.310240,-75.234480,0,'2013-07-06 12:44:31',NULL,NULL),(12700,'13143','S','Red Creek','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.235287,-76.731148,0,'2013-07-06 12:44:30',NULL,NULL),(51373,'59402','S','Malmstrom AFB','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.509367,-111.194562,0,'2013-07-06 12:44:33',NULL,NULL),(9327,'09739','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(37423,'41819','S','Gilly','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.992572,-83.069894,0,'2013-07-06 12:44:32',NULL,NULL),(36083,'40217','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.217903,-85.741113,0,'2013-07-06 12:44:32',NULL,NULL),(65134,'77384','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.230149,-95.490453,0,'2013-07-06 12:44:34',NULL,NULL),(29313,'32533','S','Cantonment','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.630694,-87.334171,0,'2013-07-06 12:44:32',NULL,NULL),(34564,'38731','S','Erwin','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.087531,-91.084410,0,'2013-07-06 12:44:32',NULL,NULL),(35953,'40061','P','St Catharine','A','Washington','21229','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.695114,-85.264452,0,'2013-07-06 12:44:32',NULL,NULL),(52695,'61104','S','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.255647,-89.081171,0,'2013-07-06 12:44:33',NULL,NULL),(41563,'47023','S','Holton','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.021348,-85.387979,0,'2013-07-06 12:44:32',NULL,NULL),(2156,'00925','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(75062,'93524','U','Edwards AFB','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.919545,-117.946773,0,'2013-07-06 12:44:34',NULL,NULL),(22304,'23832','S','Beach','N','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.409940,-77.610720,0,'2013-07-06 12:44:31',NULL,NULL),(69402,'83622','S','Crouch','N','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.055720,-115.624380,0,'2013-07-06 12:44:34',NULL,NULL),(69204,'83350','S','Jackson','A','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.620280,-113.767320,0,'2013-07-06 12:44:34',NULL,NULL),(4717,'03822','U','Dover','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.218179,-70.841093,0,'2013-07-06 12:44:30',NULL,NULL),(30805,'33612','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.056730,-82.451615,0,'2013-07-06 12:44:32',NULL,NULL),(40428,'45699','U','So Oh Correctional Facility','N','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.881627,-82.992138,0,'2013-07-06 12:44:32',NULL,NULL),(39078,'44215','S','Gloria Glens','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.068001,-81.904211,0,'2013-07-06 12:44:32',NULL,NULL),(4601,'03586','S','Sugar Hill','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.221351,-71.819069,0,'2013-07-06 12:44:30',NULL,NULL),(21317,'22406','S','Fredericksbrg','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(65694,'78006','S','Boerne','D','Kendall','48259','Texas','TX','48','7240','830','Central',-6.0,'Y',29.718030,-98.651343,0,'2013-07-06 12:44:34',NULL,NULL),(54182,'62624','S','Sheldons Grove','N','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.160050,-90.349720,0,'2013-07-06 12:44:33',NULL,NULL),(44355,'49781','S','Saint Ignace','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.879306,-84.731798,0,'2013-07-06 12:44:32',NULL,NULL),(47156,'54467','S','Buena Vista','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.439810,-89.544706,0,'2013-07-06 12:44:32',NULL,NULL),(46856,'54024','S','Eureka Center','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.412894,-92.633615,0,'2013-07-06 12:44:32',NULL,NULL),(79889,'99578','P','Eek','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.831463,-162.015890,0,'2013-07-06 12:44:34',NULL,NULL),(46569,'53521','S','Brooklyn','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.868490,-89.389756,0,'2013-07-06 12:44:32',NULL,NULL),(27833,'30415','S','Ivanhoe','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(48406,'55594','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816993,-93.918911,0,'2013-07-06 12:44:33',NULL,NULL),(67745,'80610','S','Ault','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.619513,-104.701943,0,'2013-07-06 12:44:34',NULL,NULL),(27451,'30123','P','Cassville','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.248055,-84.855986,0,'2013-07-06 12:44:31',NULL,NULL),(39876,'45208','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.132484,-84.435285,0,'2013-07-06 12:44:32',NULL,NULL),(7067,'06335','S','Gales Ferry','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.432117,-72.069858,0,'2013-07-06 12:44:30',NULL,NULL),(18176,'18922','P','Forest Grove','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.298834,-75.057172,0,'2013-07-06 12:44:31',NULL,NULL),(17602,'18040','S','Stockertown Township','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.719000,-75.220260,0,'2013-07-06 12:44:31',NULL,NULL),(65313,'77505','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.654184,-95.149733,0,'2013-07-06 12:44:34',NULL,NULL),(27397,'30087','S','Smoke Rise','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.801564,-84.138154,0,'2013-07-06 12:44:31',NULL,NULL),(25135,'28012','S','Catawba Heights','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.243718,-81.036410,0,'2013-07-06 12:44:31',NULL,NULL),(28087,'30736','S','Ringgold','D','Catoosa','13047','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.934373,-85.151128,0,'2013-07-06 12:44:31',NULL,NULL),(26507,'29171','P','West Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.970062,-81.078582,0,'2013-07-06 12:44:31',NULL,NULL),(13549,'13830','S','South Oxford','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.442500,-75.623280,0,'2013-07-06 12:44:31',NULL,NULL),(2398,'00949','S','VISTA del Lago','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(2508,'00957','S','Urb Bella Vista','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(34931,'39038','S','Belzoni','D','Humphreys','28053','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.181313,-90.485915,0,'2013-07-06 12:44:32',NULL,NULL),(12152,'12740','S','Grahamsville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.888409,-74.521026,0,'2013-07-06 12:44:30',NULL,NULL),(13650,'14010','P','Athol Springs','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.773247,-78.865948,0,'2013-07-06 12:44:31',NULL,NULL),(20201,'20755','S','Fort George G Meade','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.109680,-76.736935,0,'2013-07-06 12:44:31',NULL,NULL),(21810,'23093','S','Louisa','D','Louisa','51109','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.092162,-78.021999,0,'2013-07-06 12:44:31',NULL,NULL),(22128,'23440','P','Tangier','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.830029,-75.993029,0,'2013-07-06 12:44:31',NULL,NULL),(3808,'02266','U','Boston Financial Data Servic','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.349321,-71.059883,0,'2013-07-06 12:44:30',NULL,NULL),(75671,'94546','S','Hayward','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.726080,-122.080380,0,'2013-07-06 12:44:34',NULL,NULL),(17123,'17774','S','Unityville','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.242038,-76.522091,0,'2013-07-06 12:44:31',NULL,NULL),(53709,'62237','S','Coulterville','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.198220,-89.593740,0,'2013-07-06 12:44:33',NULL,NULL),(19874,'20529','U','US Citizenship Immigration','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895138,-77.036621,0,'2013-07-06 12:44:31',NULL,NULL),(58002,'67863','S','Modoc','A','Wichita','20203','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.485800,-101.036700,0,'2013-07-06 12:44:33',NULL,NULL),(71856,'87710','P','Angel Fire','D','Colfax','35007','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.393000,-105.284400,0,'2013-07-06 12:44:34',NULL,NULL),(27794,'30385','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.674395,-84.441613,0,'2013-07-06 12:44:31',NULL,NULL),(54308,'62715','U','Horace Mann Ins','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803359,-89.646811,0,'2013-07-06 12:44:33',NULL,NULL),(37540,'42055','S','Suwanee','N','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.058468,-88.128269,0,'2013-07-06 12:44:32',NULL,NULL),(10469,'10940','S','Scotchtown','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.474400,-74.410980,0,'2013-07-06 12:44:30',NULL,NULL),(18644,'19170','U','Citibank Delaware','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952013,-75.183323,0,'2013-07-06 12:44:31',NULL,NULL),(14357,'15019','S','Bulger','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.403803,-80.330763,0,'2013-07-06 12:44:31',NULL,NULL),(31097,'33880','S','JPV','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.996505,-81.752285,0,'2013-07-06 12:44:32',NULL,NULL),(31293,'34055','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(58275,'68404','S','Centerville','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.642620,-96.747120,0,'2013-07-06 12:44:33',NULL,NULL),(72345,'89017','S','Hiko','D','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.591348,-115.225947,0,'2013-07-06 12:44:34',NULL,NULL),(32407,'35963','S','Dawson','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.355993,-85.926785,0,'2013-07-06 12:44:32',NULL,NULL),(49888,'57268','S','Toronto','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.574557,-96.644841,0,'2013-07-06 12:44:33',NULL,NULL),(38838,'44086','S','Thompson','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.677794,-81.052903,0,'2013-07-06 12:44:32',NULL,NULL),(69224,'83401','S','Saint Leon','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(40013,'45246','S','Springdale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.279734,-84.471102,0,'2013-07-06 12:44:32',NULL,NULL),(33980,'38113','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.209681,-89.996175,0,'2013-07-06 12:44:32',NULL,NULL),(63835,'75973','S','Pauls Store','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(52189,'60469','S','Posen','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.626682,-87.686685,0,'2013-07-06 12:44:33',NULL,NULL),(42567,'47874','S','Rosedale','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(20253,'20782','S','University Park','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(40099,'45309','S','Brookville','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.837478,-84.420495,0,'2013-07-06 12:44:32',NULL,NULL),(34600,'38748','S','Estill','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.175353,-90.856370,0,'2013-07-06 12:44:32',NULL,NULL),(16709,'17403','S','Ore Valley','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.950251,-76.710456,0,'2013-07-06 12:44:31',NULL,NULL),(17115,'17771','S','White Pine','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(21259,'22304','S','Theological Seminary','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.817208,-77.122599,0,'2013-07-06 12:44:31',NULL,NULL),(44446,'49863','P','Nadeau','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.607239,-87.549156,0,'2013-07-06 12:44:32',NULL,NULL),(19176,'19735','S','Winterthur','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.802932,-75.612558,0,'2013-07-06 12:44:31',NULL,NULL),(35013,'39149','S','Shivers','N','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.824327,-90.022923,0,'2013-07-06 12:44:32',NULL,NULL),(39437,'44687','P','Walnut Creek','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.542033,-81.719256,0,'2013-07-06 12:44:32',NULL,NULL),(6821,'06112','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.794394,-72.696348,0,'2013-07-06 12:44:30',NULL,NULL),(40419,'45692','S','Wellston','D','Jackson','39079','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.122440,-82.546002,0,'2013-07-06 12:44:32',NULL,NULL),(15593,'16667','S','Saint Clairsville','A','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.160648,-78.508616,0,'2013-07-06 12:44:31',NULL,NULL),(14469,'15120','S','West Homestead','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.394809,-79.903215,0,'2013-07-06 12:44:31',NULL,NULL),(74662,'92850','U','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.844215,-117.955546,0,'2013-07-06 12:44:34',NULL,NULL),(33442,'37309','S','Calhoun','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.382097,-84.766636,0,'2013-07-06 12:44:32',NULL,NULL),(27735,'30353','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.753297,-84.391406,0,'2013-07-06 12:44:31',NULL,NULL),(12251,'12831','S','Fortsville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.198440,-73.678260,0,'2013-07-06 12:44:30',NULL,NULL),(54177,'62621','S','Exeter','A','Scott','17171','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.734110,-90.522678,0,'2013-07-06 12:44:33',NULL,NULL),(37605,'42129','S','Cork','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(36071,'40209','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.189812,-85.754157,0,'2013-07-06 12:44:32',NULL,NULL),(49105,'56344','P','Lastrup','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.038336,-94.063923,0,'2013-07-06 12:44:33',NULL,NULL),(36815,'41059','S','Ross','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.018300,-84.360480,0,'2013-07-06 12:44:32',NULL,NULL),(7762,'07405','S','High Crest','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.988669,-74.383743,0,'2013-07-06 12:44:30',NULL,NULL),(2143,'00924','S','Urb Sabana Llana','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(47231,'54501','S','Monico','A','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(9886,'10126','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760726,-73.970532,0,'2013-07-06 12:44:30',NULL,NULL),(72027,'88052','P','Organ','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.423691,-106.602291,0,'2013-07-06 12:44:34',NULL,NULL),(62840,'75011','P','Carrollton','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.954424,-96.889584,0,'2013-07-06 12:44:33',NULL,NULL),(61391,'72536','S','Horseshoe Bend','N','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.123302,-91.808456,0,'2013-07-06 12:44:33',NULL,NULL),(56944,'66088','S','Valley Falls','D','Jefferson','20087','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.344898,-95.460968,0,'2013-07-06 12:44:33',NULL,NULL),(43202,'48304','S','Bloomfield Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(47020,'54313','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.558732,-88.102722,0,'2013-07-06 12:44:32',NULL,NULL),(13202,'13624','S','Murray Isle','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.239325,-76.080450,0,'2013-07-06 12:44:30',NULL,NULL),(18715,'19255','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951255,-75.163103,0,'2013-07-06 12:44:31',NULL,NULL),(7651,'07078','S','Short Hills','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.737260,-74.329009,0,'2013-07-06 12:44:30',NULL,NULL),(22159,'23460','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.814484,-76.025796,0,'2013-07-06 12:44:31',NULL,NULL),(63849,'75976','P','Wells','D','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.509036,-94.986968,0,'2013-07-06 12:44:34',NULL,NULL),(67136,'79760','P','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.827713,-102.434573,0,'2013-07-06 12:44:34',NULL,NULL),(1531,'00754','S','Villas del hato','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(67656,'80477','P','Steamboat Spr','A','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.477411,-106.845470,0,'2013-07-06 12:44:34',NULL,NULL),(39268,'44452','S','North Lima','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.952505,-80.658498,0,'2013-07-06 12:44:32',NULL,NULL),(75905,'94999','S','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.323951,-122.642590,0,'2013-07-06 12:44:34',NULL,NULL),(53851,'62324','S','Clayton','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.030973,-90.957190,0,'2013-07-06 12:44:33',NULL,NULL),(23225,'25083','S','Mahan','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.137478,-81.383508,0,'2013-07-06 12:44:31',NULL,NULL),(61274,'72384','S','Turrell','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.339209,-90.255939,0,'2013-07-06 12:44:33',NULL,NULL),(8109,'07806','S','Picatinny Arsenal','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.939389,-74.558453,0,'2013-07-06 12:44:30',NULL,NULL),(63607,'75799','U','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.328487,-95.303780,0,'2013-07-06 12:44:34',NULL,NULL),(7629,'07062','S','North Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.632249,-74.399691,0,'2013-07-06 12:44:30',NULL,NULL),(41338,'46784','S','Rome City','D','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.494938,-85.366105,0,'2013-07-06 12:44:32',NULL,NULL),(49066,'56312','S','Regal','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.486795,-94.955270,0,'2013-07-06 12:44:33',NULL,NULL),(47697,'54976','P','Saxeville','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.175303,-89.114101,0,'2013-07-06 12:44:33',NULL,NULL),(16548,'17307','S','Biglerville','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.934161,-77.293238,0,'2013-07-06 12:44:31',NULL,NULL),(67951,'80912','S','Ent Air Force Base','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(78470,'98082','P','Bothell','A','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.855245,-122.221023,0,'2013-07-06 12:44:34',NULL,NULL),(28391,'31312','S','Marlow','N','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.319023,-81.394389,0,'2013-07-06 12:44:32',NULL,NULL),(5896,'05156','S','Maple Dell','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.289460,-72.474780,0,'2013-07-06 12:44:30',NULL,NULL),(17045,'17751','S','Bald Eagle','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106295,-77.488495,0,'2013-07-06 12:44:31',NULL,NULL),(78497,'98108','S','Tukwila','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.537090,-122.310216,0,'2013-07-06 12:44:34',NULL,NULL),(25928,'28653','P','Montezuma','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.065927,-81.904155,0,'2013-07-06 12:44:31',NULL,NULL),(35145,'39218','S','JXN','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.237700,-90.154800,0,'2013-07-06 12:44:32',NULL,NULL),(54655,'62930','S','Wasson','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(58335,'68460','S','Thayer','N','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.925505,-97.443237,0,'2013-07-06 12:44:33',NULL,NULL),(64481,'76597','U','Gatesville','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.434052,-97.746657,0,'2013-07-06 12:44:34',NULL,NULL),(64625,'76703','P','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.558118,-97.127509,0,'2013-07-06 12:44:34',NULL,NULL),(70355,'84645','S','Mona','D','Juab','49023','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.819573,-111.852966,0,'2013-07-06 12:44:34',NULL,NULL),(33840,'37934','S','Knox','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(6196,'05483','S','Fairgrounds','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(33399,'37224','P','Nashvl','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.151112,-86.795584,0,'2013-07-06 12:44:32',NULL,NULL),(32185,'35501','S','Jasper','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.842149,-87.274833,0,'2013-07-06 12:44:32',NULL,NULL),(32113,'35403','P','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.204105,-87.523651,0,'2013-07-06 12:44:32',NULL,NULL),(5347,'04607','S','South Gouldsboro','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.472300,-68.086980,0,'2013-07-06 12:44:30',NULL,NULL),(4987,'04122','U','Union Mutual Life Ins','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.653310,-70.331898,0,'2013-07-06 12:44:30',NULL,NULL),(57674,'67219','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.756398,-97.317064,0,'2013-07-06 12:44:33',NULL,NULL),(35233,'39320','S','Bailey','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.487494,-88.699810,0,'2013-07-06 12:44:32',NULL,NULL),(78290,'97877','S','Greenhorn','A','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.729195,-118.264168,0,'2013-07-06 12:44:34',NULL,NULL),(5918,'05250','S','West Arlington','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(4496,'03282','S','Wentworth','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.862876,-71.931934,0,'2013-07-06 12:44:30',NULL,NULL),(66151,'78502','P','McAllen','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.198279,-98.246967,0,'2013-07-06 12:44:34',NULL,NULL),(63505,'75710','P','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.364819,-95.317669,0,'2013-07-06 12:44:33',NULL,NULL),(62939,'75094','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.017760,-96.624420,0,'2013-07-06 12:44:33',NULL,NULL),(43972,'49321','S','Comstock Park','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.058199,-85.664935,0,'2013-07-06 12:44:32',NULL,NULL),(19079,'19560','S','Temple','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.396140,-75.889620,0,'2013-07-06 12:44:31',NULL,NULL),(70717,'85283','S','Tempe','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.365103,-111.928523,0,'2013-07-06 12:44:34',NULL,NULL),(70036,'84133','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.770852,-111.892118,0,'2013-07-06 12:44:34',NULL,NULL),(17395,'17901','S','Glen Dower','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(9897,'10129','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755624,-73.990453,0,'2013-07-06 12:44:30',NULL,NULL),(11918,'12416','S','Chichester','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.090912,-74.268664,0,'2013-07-06 12:44:30',NULL,NULL),(12230,'12815','S','Brant Lake','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.671550,-73.769240,0,'2013-07-06 12:44:30',NULL,NULL),(44813,'50240','S','Conger','N','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.300602,-93.744062,0,'2013-07-06 12:44:32',NULL,NULL),(68730,'82190','S','Mammoth Hot Springs','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.975150,-110.694710,0,'2013-07-06 12:44:34',NULL,NULL),(63076,'75243','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.911604,-96.732266,0,'2013-07-06 12:44:33',NULL,NULL),(79980,'99654','S','Wasilla','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.595441,-149.409008,0,'2013-07-06 12:44:34',NULL,NULL),(60676,'71923','S','Hollywood','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(69478,'83670','S','Sweet','D','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.996035,-116.323667,0,'2013-07-06 12:44:34',NULL,NULL),(21473,'22637','S','Gore','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.274602,-78.353036,0,'2013-07-06 12:44:31',NULL,NULL),(21763,'23060','S','Glen Allenw','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.659630,-77.529243,0,'2013-07-06 12:44:31',NULL,NULL),(10934,'11434','S','Addisleigh Pk','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(11184,'11733','S','Poquott','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(71714,'87530','S','El Rito','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.322492,-106.283634,0,'2013-07-06 12:44:34',NULL,NULL),(71960,'88003','P','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.279674,-106.759683,0,'2013-07-06 12:44:34',NULL,NULL),(70018,'84128','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.704442,-112.044520,0,'2013-07-06 12:44:34',NULL,NULL),(35744,'39730','S','East Aberdeen','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(26002,'28673','S','Sherrills Ford','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.589500,-81.002891,0,'2013-07-06 12:44:31',NULL,NULL),(32230,'35578','S','Saragossa','N','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.933720,-87.426540,0,'2013-07-06 12:44:32',NULL,NULL),(12942,'13350','S','Herkimer','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.030105,-74.984973,0,'2013-07-06 12:44:30',NULL,NULL),(8597,'08232','S','Egg Harbor Twp','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(6666,'06029','S','Ellington','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917142,-72.443805,0,'2013-07-06 12:44:30',NULL,NULL),(13446,'13775','S','Leonta','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340614,-75.160930,0,'2013-07-06 12:44:31',NULL,NULL),(38360,'43452','S','Port Clinton','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.536800,-82.908000,0,'2013-07-06 12:44:32',NULL,NULL),(47390,'54636','S','Holmen','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.964762,-91.258450,0,'2013-07-06 12:44:32',NULL,NULL),(48097,'55343','S','Eden Prairie','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(50085,'57465','S','Chelsea','A','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.166500,-98.688780,0,'2013-07-06 12:44:33',NULL,NULL),(61341,'72466','S','Smithville','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.097394,-91.274131,0,'2013-07-06 12:44:33',NULL,NULL),(67094,'79703','S','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',31.975158,-102.116534,0,'2013-07-06 12:44:34',NULL,NULL),(71636,'87413','S','Chaco Canyon National Monume','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.713295,-107.969839,0,'2013-07-06 12:44:34',NULL,NULL),(12574,'13065','P','Fayette','D','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.821298,-76.812129,0,'2013-07-06 12:44:30',NULL,NULL),(4830,'04001','S','Acton','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.566236,-70.916523,0,'2013-07-06 12:44:30',NULL,NULL),(31230,'33967','S','San Carlos Park','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637179,-81.872520,0,'2013-07-06 12:44:32',NULL,NULL),(3236,'01378','S','Warwick','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.677282,-72.343139,0,'2013-07-06 12:44:30',NULL,NULL),(23311,'25204','S','Twilight','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.940556,-81.640000,0,'2013-07-06 12:44:31',NULL,NULL),(41540,'47003','S','W College Cor','A','Union','18161','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.504861,-84.860620,0,'2013-07-06 12:44:32',NULL,NULL),(42378,'47716','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.961823,-87.492329,0,'2013-07-06 12:44:32',NULL,NULL),(67281,'80004','S','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.816646,-105.127381,0,'2013-07-06 12:44:34',NULL,NULL),(861,'00698','S','Urb El Rosario','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(76806,'95948','S','East Gridley','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.358225,-121.696103,0,'2013-07-06 12:44:34',NULL,NULL),(12225,'12811','P','Bakers Mills','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.612146,-74.025481,0,'2013-07-06 12:44:30',NULL,NULL),(13235,'13640','S','Fineview','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.317415,-76.008175,0,'2013-07-06 12:44:30',NULL,NULL),(28306,'31126','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.847924,-84.359054,0,'2013-07-06 12:44:31',NULL,NULL),(24791,'27583','S','Timberlake','D','Person','37145','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234630,-78.965713,0,'2013-07-06 12:44:31',NULL,NULL),(57264,'66542','S','Tecumseh','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.020394,-95.553498,0,'2013-07-06 12:44:33',NULL,NULL),(49076,'56319','S','Carlos','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.969695,-95.293448,0,'2013-07-06 12:44:33',NULL,NULL),(47248,'54519','S','Conover','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.044005,-89.268510,0,'2013-07-06 12:44:32',NULL,NULL),(44342,'49770','S','Bay Harbor','A','Emmet','26047','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.356561,-84.930304,0,'2013-07-06 12:44:32',NULL,NULL),(36854,'41076','S','Highland Hgts','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(24151,'26581','S','Knob Fork','A','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.665921,-80.575673,0,'2013-07-06 12:44:31',NULL,NULL),(10651,'11103','S','Astoria','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.762281,-73.910107,0,'2013-07-06 12:44:30',NULL,NULL),(293,'00646','S','Urb Costa de Oro','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(2698,'00969','S','Colinas de Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(35795,'39752','S','Mathiston','D','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.539394,-89.135634,0,'2013-07-06 12:44:32',NULL,NULL),(46734,'53827','S','Woodman','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.048813,-90.825159,0,'2013-07-06 12:44:32',NULL,NULL),(62152,'73726','S','Aline','N','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.577425,-98.459621,0,'2013-07-06 12:44:33',NULL,NULL),(64509,'76634','S','Hurst Springs','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.811700,-97.490820,0,'2013-07-06 12:44:34',NULL,NULL),(70930,'85635','S','Fry','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.528599,-110.259800,0,'2013-07-06 12:44:34',NULL,NULL),(26594,'29226','U','Wells Fargo','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.031953,-81.104915,0,'2013-07-06 12:44:31',NULL,NULL),(23779,'25979','S','Pipestem','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.516015,-80.920145,0,'2013-07-06 12:44:31',NULL,NULL),(48489,'55733','S','Esko','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.710215,-92.360371,0,'2013-07-06 12:44:33',NULL,NULL),(51512,'59648','S','Craig','A','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.044107,-112.063648,0,'2013-07-06 12:44:33',NULL,NULL),(55457,'63736','S','Haywood City','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.072200,-89.569800,0,'2013-07-06 12:44:33',NULL,NULL),(1006,'00717','S','Urb Perla del Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(77493,'96826','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.294061,-157.826123,0,'2013-07-06 12:44:34',NULL,NULL),(27728,'30349','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.614175,-84.497109,0,'2013-07-06 12:44:31',NULL,NULL),(25398,'28280','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.230706,-80.846213,0,'2013-07-06 12:44:31',NULL,NULL),(23465,'25437','S','Points','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.450587,-78.564934,0,'2013-07-06 12:44:31',NULL,NULL),(15686,'16835','P','Fleming','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.912329,-77.931374,0,'2013-07-06 12:44:31',NULL,NULL),(18287,'19014','S','Aston','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(16986,'17728','S','Balls Mills','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(16095,'17051','S','Ryde','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(43479,'48605','P','Saginaw','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.459077,-84.052167,0,'2013-07-06 12:44:32',NULL,NULL),(53759,'62263','S','New Minden','N','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441389,-89.370278,0,'2013-07-06 12:44:33',NULL,NULL),(57529,'67009','S','Attica','D','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.243090,-98.226796,0,'2013-07-06 12:44:33',NULL,NULL),(58676,'68901','S','Ingleside','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(65237,'77453','P','Haid','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.215350,-96.019905,0,'2013-07-06 12:44:34',NULL,NULL),(75628,'94510','S','Benicia','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.069204,-122.164378,0,'2013-07-06 12:44:34',NULL,NULL),(79139,'98501','S','Maytown','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(12914,'13339','S','Fort Plain','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(10202,'10312','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.542579,-74.178991,0,'2013-07-06 12:44:30',NULL,NULL),(10045,'10174','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(20361,'20876','S','Germantown','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.191056,-77.234312,0,'2013-07-06 12:44:31',NULL,NULL),(47818,'55060','S','Litomysl','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087587,-93.221024,0,'2013-07-06 12:44:33',NULL,NULL),(76142,'95269','P','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.018991,-121.322247,0,'2013-07-06 12:44:34',NULL,NULL),(58177,'68305','S','Howe','N','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.390284,-95.842607,0,'2013-07-06 12:44:33',NULL,NULL),(34573,'38736','S','Doddsville','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.659722,-90.616389,0,'2013-07-06 12:44:32',NULL,NULL),(8385,'08059','S','W Colls Hgts','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.879419,-75.092601,0,'2013-07-06 12:44:30',NULL,NULL),(21065,'21920','P','Elk Mills','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.656796,-75.827397,0,'2013-07-06 12:44:31',NULL,NULL),(36069,'40207','S','Woodlawn Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(46058,'52574','S','Brazil','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.796400,-92.928720,0,'2013-07-06 12:44:32',NULL,NULL),(70539,'85023','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.632395,-112.111758,0,'2013-07-06 12:44:34',NULL,NULL),(73973,'92079','P','San Marcos','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.142655,-117.165619,0,'2013-07-06 12:44:34',NULL,NULL),(77845,'97223','S','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.438890,-122.772276,0,'2013-07-06 12:44:34',NULL,NULL),(1004,'00717','S','Urb Mercedita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(60687,'71935','S','Caddo Gap','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.358611,-93.688611,0,'2013-07-06 12:44:33',NULL,NULL),(67801,'80735','S','Idalia','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.719760,-102.254640,0,'2013-07-06 12:44:34',NULL,NULL),(77164,'96224','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79111,'98466','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225803,-122.534108,0,'2013-07-06 12:44:34',NULL,NULL),(79495,'98903','S','South Broadway','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.561980,-120.667800,0,'2013-07-06 12:44:34',NULL,NULL),(53331,'61751','P','Lawndale','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.220019,-89.285105,0,'2013-07-06 12:44:33',NULL,NULL),(17156,'17812','S','Beaver Sprgs','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.770100,-77.247271,0,'2013-07-06 12:44:31',NULL,NULL),(7740,'07208','S','North Elizabeth','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.674420,-74.225148,0,'2013-07-06 12:44:30',NULL,NULL),(15869,'16950','S','Cowanesque','A','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(54208,'62640','S','Standard City','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.446714,-89.796627,0,'2013-07-06 12:44:33',NULL,NULL),(51475,'59538','S','Malta','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.343680,-107.839380,0,'2013-07-06 12:44:33',NULL,NULL),(50897,'58541','S','Golden Valley','D','Mercer','38057','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.299471,-102.067172,0,'2013-07-06 12:44:33',NULL,NULL),(48942,'56164','S','Verdi','A','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.994823,-96.317095,0,'2013-07-06 12:44:33',NULL,NULL),(31106,'33884','S','Cypress Gdns','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.999605,-81.679242,0,'2013-07-06 12:44:32',NULL,NULL),(21148,'22118','U','Bank of America','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.839359,-77.336627,0,'2013-07-06 12:44:31',NULL,NULL),(40101,'45311','S','Camden','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.633333,-84.650000,0,'2013-07-06 12:44:32',NULL,NULL),(39659,'45011','S','Fairfield','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(41682,'47175','S','Taswell','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.347872,-86.538762,0,'2013-07-06 12:44:32',NULL,NULL),(9026,'08873','S','Franklin Twp','N','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.499340,-74.521380,0,'2013-07-06 12:44:30',NULL,NULL),(44565,'50020','S','Berea','N','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.444100,-94.765161,0,'2013-07-06 12:44:32',NULL,NULL),(72026,'88051','P','Mule Creek','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.121820,-108.956410,0,'2013-07-06 12:44:34',NULL,NULL),(25620,'28461','S','Bling Spr Lks','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(67470,'80222','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.680076,-104.923754,0,'2013-07-06 12:44:34',NULL,NULL),(64980,'77268','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.007153,-95.486701,0,'2013-07-06 12:44:34',NULL,NULL),(56224,'65040','S','Hickory Hill','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.379720,-92.332906,0,'2013-07-06 12:44:33',NULL,NULL),(23851,'26141','S','Creston','D','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.961534,-81.257948,0,'2013-07-06 12:44:31',NULL,NULL),(15603,'16673','S','Roaring Spring','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.334211,-78.396280,0,'2013-07-06 12:44:31',NULL,NULL),(35571,'39567','S','Wade','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(52692,'61103','S','Machesney Park','A','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.299190,-89.103195,0,'2013-07-06 12:44:33',NULL,NULL),(45800,'52171','S','Jackson Junction','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.058499,-91.990554,0,'2013-07-06 12:44:32',NULL,NULL),(14704,'15262','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.473575,-79.988919,0,'2013-07-06 12:44:31',NULL,NULL),(6047,'05439','U','St Michaels College','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.551291,-73.179908,0,'2013-07-06 12:44:30',NULL,NULL),(987,'00716','S','Vistas del Mar','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(70331,'84629','S','Fairview','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(30423,'33327','S','Weston','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118498,-80.436434,0,'2013-07-06 12:44:32',NULL,NULL),(46984,'54229','S','Green Bay','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.559527,-87.833095,0,'2013-07-06 12:44:32',NULL,NULL),(72771,'89533','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.529229,-119.881028,0,'2013-07-06 12:44:34',NULL,NULL),(48845,'56060','S','Lewisville','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.923635,-94.433285,0,'2013-07-06 12:44:33',NULL,NULL),(19288,'19971','S','Dewey Bch','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.726540,-75.081250,0,'2013-07-06 12:44:31',NULL,NULL),(10008,'10168','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(10308,'10533','S','Irvington','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.041760,-73.855752,0,'2013-07-06 12:44:30',NULL,NULL),(20750,'21403','S','Highland Bch','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.949357,-76.488902,0,'2013-07-06 12:44:31',NULL,NULL),(35041,'39170','S','Terry','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.140911,-90.347940,0,'2013-07-06 12:44:32',NULL,NULL),(64013,'76117','S','North Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.802093,-97.265859,0,'2013-07-06 12:44:34',NULL,NULL),(57299,'66622','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.012994,-95.824145,0,'2013-07-06 12:44:33',NULL,NULL),(55653,'64024','S','Excelsior Est','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(47998,'55145','U','State Tax Dept','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.945326,-93.094113,0,'2013-07-06 12:44:33',NULL,NULL),(80078,'99732','P','Chicken','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.826658,-142.160943,0,'2013-07-06 12:44:34',NULL,NULL),(55934,'64473','S','NW Point','A','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.993891,-95.139533,0,'2013-07-06 12:44:33',NULL,NULL),(23122,'24962','S','Pence Springs','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.670191,-80.711159,0,'2013-07-06 12:44:31',NULL,NULL),(59869,'71263','S','Oak Grove','D','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.840160,-91.467780,0,'2013-07-06 12:44:33',NULL,NULL),(65888,'78231','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588400,-98.549910,0,'2013-07-06 12:44:34',NULL,NULL),(32968,'36605','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.627381,-88.085652,0,'2013-07-06 12:44:32',NULL,NULL),(33802,'37901','P','Knox','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.029281,-83.886332,0,'2013-07-06 12:44:32',NULL,NULL),(30864,'33663','U','Time Customer Service Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.961787,-82.527993,0,'2013-07-06 12:44:32',NULL,NULL),(19762,'20416','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882620,-77.017393,0,'2013-07-06 12:44:31',NULL,NULL),(36365,'40447','S','Parrot','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(39028,'44144','S','Brooklyn','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.437456,-81.744047,0,'2013-07-06 12:44:32',NULL,NULL),(55902,'64437','S','Craig','D','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.156812,-95.358379,0,'2013-07-06 12:44:33',NULL,NULL),(49628,'56920','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895216,-77.036514,0,'2013-07-06 12:44:33',NULL,NULL),(45451,'51238','S','Hospers','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.069984,-95.904488,0,'2013-07-06 12:44:32',NULL,NULL),(64777,'77004','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.728205,-95.366222,0,'2013-07-06 12:44:34',NULL,NULL),(69595,'83847','S','Naples','D','Boundary','16021','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.694387,-116.303452,0,'2013-07-06 12:44:34',NULL,NULL),(9917,'10150','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757563,-73.972925,0,'2013-07-06 12:44:30',NULL,NULL),(26308,'29037','S','Chappells','D','Newberry','45071','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.235316,-81.841403,0,'2013-07-06 12:44:31',NULL,NULL),(24620,'27349','S','Rock Creek','N','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.915033,-79.427355,0,'2013-07-06 12:44:31',NULL,NULL),(17549,'17980','S','Orwin','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.591905,-76.538022,0,'2013-07-06 12:44:31',NULL,NULL),(14457,'15108','S','Coraopolis','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.510530,-80.182409,0,'2013-07-06 12:44:31',NULL,NULL),(7927,'07646','S','New Milford','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.933644,-74.022176,0,'2013-07-06 12:44:30',NULL,NULL),(2532,'00959','S','Alt de Flamboyan','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(45895,'52308','P','Millersburg','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.573839,-92.159956,0,'2013-07-06 12:44:32',NULL,NULL),(16874,'17569','S','Blainsport','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.276083,-76.123914,0,'2013-07-06 12:44:31',NULL,NULL),(24582,'27317','S','Level Cross','N','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.841660,-79.816020,0,'2013-07-06 12:44:31',NULL,NULL),(73366,'91023','P','Mount Wilson','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.226166,-118.092289,0,'2013-07-06 12:44:34',NULL,NULL),(69313,'83464','S','Blue Dome','N','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.601224,-113.355918,0,'2013-07-06 12:44:34',NULL,NULL),(62531,'74427','S','Cookson','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.811810,-95.076551,0,'2013-07-06 12:44:33',NULL,NULL),(36505,'40823','S','Hiram','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.975189,-82.986975,0,'2013-07-06 12:44:32',NULL,NULL),(18197,'18940','S','George School','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245694,-74.942426,0,'2013-07-06 12:44:31',NULL,NULL),(60251,'71438','S','Lacamp','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.149021,-92.748532,0,'2013-07-06 12:44:33',NULL,NULL),(22881,'24576','P','Naruna','D','Campbell','51031','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.093469,-78.902190,0,'2013-07-06 12:44:31',NULL,NULL),(21798,'23083','S','Jetersville','D','Amelia','51007','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.317910,-78.118077,0,'2013-07-06 12:44:31',NULL,NULL),(71455,'87047','S','San Antonito','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.155441,-106.310313,0,'2013-07-06 12:44:34',NULL,NULL),(62301,'74026','P','Davenport','D','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.707460,-96.764061,0,'2013-07-06 12:44:33',NULL,NULL),(13849,'14225','S','Cheektowaga','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927300,-78.747480,0,'2013-07-06 12:44:31',NULL,NULL),(47291,'54545','S','Manitowish Waters','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.088375,-89.821821,0,'2013-07-06 12:44:32',NULL,NULL),(73853,'91899','P','City of Industry','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.080816,-118.135414,0,'2013-07-06 12:44:34',NULL,NULL),(37800,'42377','P','West Louisville','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.698211,-87.284712,0,'2013-07-06 12:44:32',NULL,NULL),(20799,'21550','S','Mountain Lake Park','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(33046,'36751','S','Low Peach Tre','A','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.848577,-87.569570,0,'2013-07-06 12:44:32',NULL,NULL),(1003,'00717','S','Urb Mariani','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(6672,'06032','S','Talcott Village','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.725812,-72.835995,0,'2013-07-06 12:44:30',NULL,NULL),(75679,'94552','S','Hayward','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.694127,-122.018877,0,'2013-07-06 12:44:34',NULL,NULL),(67897,'80901','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834608,-104.822550,0,'2013-07-06 12:44:34',NULL,NULL),(36836,'41073','S','Dayton','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.101923,-84.482010,0,'2013-07-06 12:44:32',NULL,NULL),(62777,'74871','S','Harden City','A','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.658077,-96.523130,0,'2013-07-06 12:44:33',NULL,NULL),(5952,'05262','S','Shaftsbury','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.133333,-73.066667,0,'2013-07-06 12:44:30',NULL,NULL),(25269,'28125','S','Mt Ulla','N','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.640595,-80.716219,0,'2013-07-06 12:44:31',NULL,NULL),(19508,'20170','S','Herndon','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.981236,-77.387257,0,'2013-07-06 12:44:31',NULL,NULL),(44984,'50428','S','Clear Lake','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.138257,-93.384461,0,'2013-07-06 12:44:32',NULL,NULL),(28639,'31757','S','Thomasville','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.865689,-83.906478,0,'2013-07-06 12:44:32',NULL,NULL),(28067,'30707','S','Chickamauga','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.845003,-85.330721,0,'2013-07-06 12:44:31',NULL,NULL),(74787,'93120','P','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.421042,-119.708474,0,'2013-07-06 12:44:34',NULL,NULL),(71570,'87301','S','Williams Acres','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(4464,'03258','S','North Chichester','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.279404,-71.410433,0,'2013-07-06 12:44:30',NULL,NULL),(51173,'59008','S','Belfry','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.065698,-109.164591,0,'2013-07-06 12:44:33',NULL,NULL),(46100,'52625','S','Mt Hamill','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.653180,-91.550700,0,'2013-07-06 12:44:32',NULL,NULL),(26814,'29477','S','Saint George','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.185354,-80.581025,0,'2013-07-06 12:44:31',NULL,NULL),(35092,'39205','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.304324,-90.182529,0,'2013-07-06 12:44:32',NULL,NULL),(9971,'10161','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.747012,-74.005347,0,'2013-07-06 12:44:30',NULL,NULL),(24437,'27207','S','Bear Creek','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.698455,-79.508612,0,'2013-07-06 12:44:31',NULL,NULL),(51,'00606','S','Maricao','D','Maricao','72093','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.185616,-66.977377,0,'2013-07-06 12:44:30',NULL,NULL),(57814,'67516','S','Bazine','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.478513,-99.697030,0,'2013-07-06 12:44:33',NULL,NULL),(48267,'55429','S','Brooklyn Center','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(4312,'02911','S','N Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(78267,'97856','S','Fox','A','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.715891,-119.102716,0,'2013-07-06 12:44:34',NULL,NULL),(68188,'81025','S','Boone','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.284292,-104.217474,0,'2013-07-06 12:44:34',NULL,NULL),(20181,'20746','S','Silver Hill','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(68171,'81009','U','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.279229,-104.489956,0,'2013-07-06 12:44:34',NULL,NULL),(79143,'98501','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(16531,'17268','S','Wayne Heights','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(51151,'58847','S','Johnsons Corner','N','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.959396,-102.865396,0,'2013-07-06 12:44:33',NULL,NULL),(45220,'50641','S','Hazleton','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.617154,-91.903815,0,'2013-07-06 12:44:32',NULL,NULL),(26817,'29479','S','Saint Stephen','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.348889,-79.816389,0,'2013-07-06 12:44:31',NULL,NULL),(16949,'17701','S','Towncrest Vlg','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(68323,'81120','S','Lobatos','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(53624,'62092','S','Belltown','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.440324,-90.402625,0,'2013-07-06 12:44:33',NULL,NULL),(48619,'55796','P','Winton','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.928032,-91.800164,0,'2013-07-06 12:44:33',NULL,NULL),(12679,'13126','S','Scriba Center','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(65044,'77332','P','Dallardsville','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.626197,-94.630939,0,'2013-07-06 12:44:34',NULL,NULL),(62505,'74368','S','Twin Oaks','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.196118,-94.866615,0,'2013-07-06 12:44:33',NULL,NULL),(56691,'65653','S','Forsyth','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.667383,-93.121570,0,'2013-07-06 12:44:33',NULL,NULL),(47320,'54559','S','Cedar','N','Iron','55051','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.522463,-90.556240,0,'2013-07-06 12:44:32',NULL,NULL),(64953,'77236','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.707243,-95.497967,0,'2013-07-06 12:44:34',NULL,NULL),(27045,'29669','S','Pelzer','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.651323,-82.494694,0,'2013-07-06 12:44:31',NULL,NULL),(4231,'02858','S','Burrillville','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.962823,-71.645043,0,'2013-07-06 12:44:30',NULL,NULL),(46335,'53086','S','Slinger','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.330414,-88.278981,0,'2013-07-06 12:44:32',NULL,NULL),(19556,'20203','U','Social Securtiy Admin','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904541,-77.045041,0,'2013-07-06 12:44:31',NULL,NULL),(57173,'66286','P','Shawnee','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.993781,-94.871495,0,'2013-07-06 12:44:33',NULL,NULL),(60409,'71639','S','Back Gate','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(10209,'10452','S','University Heights','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.841676,-73.921773,0,'2013-07-06 12:44:30',NULL,NULL),(63914,'76044','S','Godley','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.449349,-97.530941,0,'2013-07-06 12:44:34',NULL,NULL),(3997,'02541','P','Falmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.557159,-70.632387,0,'2013-07-06 12:44:30',NULL,NULL),(67519,'80244','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.749741,-104.991002,0,'2013-07-06 12:44:34',NULL,NULL),(64067,'76136','P','Lake Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.899378,-97.458124,0,'2013-07-06 12:44:34',NULL,NULL),(9867,'10121','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(60036,'71343','S','Parhams','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(58382,'68583','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.828399,-96.663016,0,'2013-07-06 12:44:33',NULL,NULL),(8751,'08530','S','West Amwell','N','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.367930,-74.933508,0,'2013-07-06 12:44:30',NULL,NULL),(54450,'62849','S','Omega','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.613375,-88.790283,0,'2013-07-06 12:44:33',NULL,NULL),(4188,'02818','S','East Greenwich','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.639217,-71.502017,0,'2013-07-06 12:44:30',NULL,NULL),(52171,'60458','S','Bedford Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745877,-87.836217,0,'2013-07-06 12:44:33',NULL,NULL),(64260,'76380','S','Seymour','D','Baylor','48023','Texas','TX','48','0000','940','Central',-6.0,'Y',33.591147,-99.263331,0,'2013-07-06 12:44:34',NULL,NULL),(27189,'29851','S','Warrenville','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.518108,-81.820849,0,'2013-07-06 12:44:31',NULL,NULL),(34434,'38646','S','Hinchcliff','N','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.250150,-90.274085,0,'2013-07-06 12:44:32',NULL,NULL),(7893,'07538','P','Prospect Park','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.936601,-74.189611,0,'2013-07-06 12:44:30',NULL,NULL),(5079,'04294','S','Perkins Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.596240,-70.226079,0,'2013-07-06 12:44:30',NULL,NULL),(39413,'44667','S','Burton City','N','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.833108,-81.768456,0,'2013-07-06 12:44:32',NULL,NULL),(43206,'48306','S','Goodison','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(47742,'55014','S','Lexington','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.179760,-93.132240,0,'2013-07-06 12:44:33',NULL,NULL),(53397,'61822','S','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.130816,-88.309971,0,'2013-07-06 12:44:33',NULL,NULL),(584,'00680','S','Bo Sabalos','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(44181,'49588','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963544,-85.656222,0,'2013-07-06 12:44:32',NULL,NULL),(27925,'30517','S','Braselton','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.132726,-83.758475,0,'2013-07-06 12:44:31',NULL,NULL),(50555,'58205','S','Grand Forks AFB','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.925264,-97.241434,0,'2013-07-06 12:44:33',NULL,NULL),(7564,'07024','S','Fort Lee','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.851376,-73.975825,0,'2013-07-06 12:44:30',NULL,NULL),(56565,'65473','S','Fort Leonard Wood','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.826765,-92.218586,0,'2013-07-06 12:44:33',NULL,NULL),(28811,'32067','P','Orange Pk','N','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.032559,-81.791988,0,'2013-07-06 12:44:32',NULL,NULL),(36894,'41102','S','Summitt','A','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.441408,-82.688442,0,'2013-07-06 12:44:32',NULL,NULL),(6548,'05842','S','Greensbro Bnd','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.556900,-72.251340,0,'2013-07-06 12:44:30',NULL,NULL),(55659,'64024','S','Mosby','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(62420,'74137','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.025399,-95.924266,0,'2013-07-06 12:44:33',NULL,NULL),(37584,'42087','S','Wickliffe','D','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.969136,-88.980962,0,'2013-07-06 12:44:32',NULL,NULL),(36950,'41168','S','Rush','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.308320,-82.746300,0,'2013-07-06 12:44:32',NULL,NULL),(6985,'06246','P','Grosvenor Dale','D','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',41.969557,-71.894299,0,'2013-07-06 12:44:30',NULL,NULL),(73330,'90844','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.776755,-118.191618,0,'2013-07-06 12:44:34',NULL,NULL),(24349,'27041','S','Pilot Mtn','A','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.450094,-80.489865,0,'2013-07-06 12:44:31',NULL,NULL),(70948,'85643','S','Chiricahua National Monument','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(17210,'17823','S','Dornsife','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.757282,-76.762227,0,'2013-07-06 12:44:31',NULL,NULL),(30410,'33325','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110796,-80.317912,0,'2013-07-06 12:44:32',NULL,NULL),(42376,'47714','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.957902,-87.524265,0,'2013-07-06 12:44:32',NULL,NULL),(65560,'77843','U','College Sta','A','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.611331,-96.348373,0,'2013-07-06 12:44:34',NULL,NULL),(26515,'29180','S','Greenbrier','N','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.372149,-81.086971,0,'2013-07-06 12:44:31',NULL,NULL),(75873,'94950','P','Olema','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.043331,-122.770535,0,'2013-07-06 12:44:34',NULL,NULL),(12615,'13088','S','Galeville','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.111538,-76.195307,0,'2013-07-06 12:44:30',NULL,NULL),(56992,'66203','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(43070,'48193','S','Brownstwn Twp','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(36912,'41141','S','Garrison','D','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.551771,-83.193288,0,'2013-07-06 12:44:32',NULL,NULL),(9147,'09301','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(77042,'96108','S','Willow Ranch','N','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.826704,-120.310770,0,'2013-07-06 12:44:34',NULL,NULL),(44358,'49783','S','Sault S Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.478524,-84.355204,0,'2013-07-06 12:44:32',NULL,NULL),(36474,'40755','P','Pittsburg','D','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.159579,-84.104100,0,'2013-07-06 12:44:32',NULL,NULL),(22378,'23934','S','Cullen','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.161006,-78.638349,0,'2013-07-06 12:44:31',NULL,NULL),(66358,'78614','S','Monthalia','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.420313,-97.554007,0,'2013-07-06 12:44:34',NULL,NULL),(24708,'27498','U','United States Postal Service','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.072005,-79.767906,0,'2013-07-06 12:44:31',NULL,NULL),(74625,'92804','S','Brookhurst Center','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.818606,-117.972857,0,'2013-07-06 12:44:34',NULL,NULL),(73015,'90067','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.058123,-118.416403,0,'2013-07-06 12:44:34',NULL,NULL),(67972,'80914','P','Peterson A F B','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(13259,'13648','S','Diana','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(60068,'71354','S','Island Road','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.345723,-91.668555,0,'2013-07-06 12:44:33',NULL,NULL),(65848,'78201','S','Balcones Heights','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.467240,-98.530042,0,'2013-07-06 12:44:34',NULL,NULL),(45691,'52048','S','Garber','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.748109,-91.248549,0,'2013-07-06 12:44:32',NULL,NULL),(22766,'24438','P','Glen Wilton','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.753384,-79.816617,0,'2013-07-06 12:44:31',NULL,NULL),(73666,'91522','U','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.146904,-118.337574,0,'2013-07-06 12:44:34',NULL,NULL),(33912,'38053','S','Dixonville','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(75035,'93514','S','Chalfant','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(49408,'56627','S','Grand Falls','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.157929,-93.863003,0,'2013-07-06 12:44:33',NULL,NULL),(28949,'32187','S','San Mateo','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.569734,-81.562275,0,'2013-07-06 12:44:32',NULL,NULL),(51602,'59824','S','Moiese','A','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.370556,-114.265000,0,'2013-07-06 12:44:33',NULL,NULL),(10158,'10278','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(10692,'11217','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.684381,-73.980437,0,'2013-07-06 12:44:30',NULL,NULL),(2523,'00957','S','Urb Santa Catalina','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(7607,'07047','S','Tyler Park','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.793459,-74.022545,0,'2013-07-06 12:44:30',NULL,NULL),(28076,'30725','S','Flintstone','D','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.937899,-85.331723,0,'2013-07-06 12:44:31',NULL,NULL),(72837,'89832','P','Owyhee','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.750437,-116.013069,0,'2013-07-06 12:44:34',NULL,NULL),(7966,'07701','S','Red Bank','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.353122,-74.074629,0,'2013-07-06 12:44:30',NULL,NULL),(58590,'68841','S','Giltner','D','Hamilton','31081','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.742673,-98.112964,0,'2013-07-06 12:44:33',NULL,NULL),(27717,'30344','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.668940,-84.458280,0,'2013-07-06 12:44:31',NULL,NULL),(3227,'01370','S','Shelburne','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.583380,-72.771540,0,'2013-07-06 12:44:30',NULL,NULL),(7235,'06508','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.307025,-72.923348,0,'2013-07-06 12:44:30',NULL,NULL),(2231,'00926','S','Urb El Vigia','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(14256,'14831','U','Corning Inc','N','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.147148,-77.056466,0,'2013-07-06 12:44:31',NULL,NULL),(31367,'34208','S','Samoset','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.484276,-82.535488,0,'2013-07-06 12:44:32',NULL,NULL),(78194,'97732','P','Crane','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.397005,-118.437308,0,'2013-07-06 12:44:34',NULL,NULL),(55720,'64077','S','Orrick','D','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.248992,-94.043368,0,'2013-07-06 12:44:33',NULL,NULL),(31306,'34103','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.187903,-81.804396,0,'2013-07-06 12:44:32',NULL,NULL),(51535,'59721','S','Cardwell','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.862721,-111.977005,0,'2013-07-06 12:44:33',NULL,NULL),(9340,'09759','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(32125,'35442','S','Old Memphis','A','Pickens','01107','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.124200,-88.159260,0,'2013-07-06 12:44:32',NULL,NULL),(62017,'73450','S','Milburn','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.175396,-96.528999,0,'2013-07-06 12:44:33',NULL,NULL),(5409,'04662','P','Northeast Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.293470,-68.284715,0,'2013-07-06 12:44:30',NULL,NULL),(37276,'41602','S','Auxier','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.736769,-82.762448,0,'2013-07-06 12:44:32',NULL,NULL),(15434,'16373','S','Emlenton','D','Venango','42121','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.178788,-79.709264,0,'2013-07-06 12:44:31',NULL,NULL),(27945,'30537','S','Dillard','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.981080,-83.381580,0,'2013-07-06 12:44:31',NULL,NULL),(29439,'32693','S','Fanning Springs','A','Gilchrist','12041','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.613522,-82.814668,0,'2013-07-06 12:44:32',NULL,NULL),(65067,'77345','S','Kingwood','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.055815,-95.169196,0,'2013-07-06 12:44:34',NULL,NULL),(52487,'60696','U','Bank of America','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.848295,-87.649618,0,'2013-07-06 12:44:33',NULL,NULL),(52193,'60473','S','South Holland','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.598979,-87.596242,0,'2013-07-06 12:44:33',NULL,NULL),(46068,'52580','S','Limby','N','Jefferson','19101','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.118406,-92.061888,0,'2013-07-06 12:44:32',NULL,NULL),(20090,'20697','U','Southern MD Facility','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.032920,-76.904253,0,'2013-07-06 12:44:31',NULL,NULL),(27256,'29929','S','Moselle','N','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.953565,-80.883542,0,'2013-07-06 12:44:31',NULL,NULL),(9130,'09180','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5447,'04694','S','Crawford','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.154958,-67.407874,0,'2013-07-06 12:44:30',NULL,NULL),(80025,'99686','S','Valdez','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.240531,-145.994063,0,'2013-07-06 12:44:34',NULL,NULL),(77209,'96376','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(64457,'76571','S','Salado','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.944482,-97.516912,0,'2013-07-06 12:44:34',NULL,NULL),(56568,'65483','S','Clara','N','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.323082,-91.964295,0,'2013-07-06 12:44:33',NULL,NULL),(53092,'61529','S','Rosefield','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.778521,-89.950179,0,'2013-07-06 12:44:33',NULL,NULL),(49694,'57026','S','Elkton','D','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.232906,-96.484595,0,'2013-07-06 12:44:33',NULL,NULL),(9387,'09845','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(36208,'40272','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.087506,-85.844480,0,'2013-07-06 12:44:32',NULL,NULL),(42540,'47866','S','Pimento','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.285986,-87.379085,0,'2013-07-06 12:44:32',NULL,NULL),(43434,'48501','P','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.966167,-83.777843,0,'2013-07-06 12:44:32',NULL,NULL),(47695,'54971','S','Ripon','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.848219,-88.841595,0,'2013-07-06 12:44:33',NULL,NULL),(21079,'22027','S','Vienna','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.894516,-77.223341,0,'2013-07-06 12:44:31',NULL,NULL),(80184,'99901','S','Edna Bay','A','Ketchikan Gateway','02130','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',55.373751,-131.692560,0,'2013-07-06 12:44:34',NULL,NULL),(79124,'98496','P','Lakewood','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.161770,-122.514397,0,'2013-07-06 12:44:34',NULL,NULL),(56429,'65263','S','Madison','D','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.473290,-92.214390,0,'2013-07-06 12:44:33',NULL,NULL),(43116,'48225','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.437669,-82.940907,0,'2013-07-06 12:44:32',NULL,NULL),(21102,'22043','S','Falls Church','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.900669,-77.193846,0,'2013-07-06 12:44:31',NULL,NULL),(21377,'22473','S','Heathsville','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.905166,-76.434436,0,'2013-07-06 12:44:31',NULL,NULL),(28936,'32174','S','Ormond Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.289955,-81.123815,0,'2013-07-06 12:44:32',NULL,NULL),(25375,'28254','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.221426,-80.928747,0,'2013-07-06 12:44:31',NULL,NULL),(39429,'44681','S','Sugarcreek','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.512840,-81.678300,0,'2013-07-06 12:44:32',NULL,NULL),(7254,'06515','S','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.327559,-72.966874,0,'2013-07-06 12:44:30',NULL,NULL),(68605,'81611','S','Aspen Gerbaz','N','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.194434,-106.826452,0,'2013-07-06 12:44:34',NULL,NULL),(39178,'44314','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.042156,-81.557464,0,'2013-07-06 12:44:32',NULL,NULL),(36480,'40769','S','Nevisdale','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.744037,-84.165125,0,'2013-07-06 12:44:32',NULL,NULL),(1905,'00795','S','Colinas Del Prado','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(16203,'17070','S','Newcmbrlnd','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(32470,'36036','S','Grady','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.002701,-86.115957,0,'2013-07-06 12:44:32',NULL,NULL),(25694,'28529','S','Grantsboro','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.140270,-76.819980,0,'2013-07-06 12:44:31',NULL,NULL),(20516,'21087','S','Bradshaw','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.448752,-76.419654,0,'2013-07-06 12:44:31',NULL,NULL),(77785,'97128','S','McMinnville','D','Yamhill','41071','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.209606,-123.217803,0,'2013-07-06 12:44:34',NULL,NULL),(69147,'83313','S','Broadford','N','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.414624,-114.198990,0,'2013-07-06 12:44:34',NULL,NULL),(56883,'66030','S','Gardner','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.815013,-94.933080,0,'2013-07-06 12:44:33',NULL,NULL),(54878,'63057','P','Liguori','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.338320,-90.398820,0,'2013-07-06 12:44:33',NULL,NULL),(52149,'60442','S','Wilton Center','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.434474,-87.984338,0,'2013-07-06 12:44:33',NULL,NULL),(46338,'53089','S','Sussex','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.153034,-88.234855,0,'2013-07-06 12:44:32',NULL,NULL),(10802,'11372','S','Jackson Hts','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.749542,-73.883319,0,'2013-07-06 12:44:30',NULL,NULL),(28745,'31995','P','Fort Benning','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.489923,-84.969539,0,'2013-07-06 12:44:32',NULL,NULL),(39853,'45171','S','Buford','A','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.969796,-83.793965,0,'2013-07-06 12:44:32',NULL,NULL),(40127,'45331','S','Greenville','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.092949,-84.632927,0,'2013-07-06 12:44:32',NULL,NULL),(40916,'46268','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.897141,-86.228019,0,'2013-07-06 12:44:32',NULL,NULL),(76197,'95352','P','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.663366,-120.994582,0,'2013-07-06 12:44:34',NULL,NULL),(64117,'76182','S','Fort Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.798211,-97.191792,0,'2013-07-06 12:44:34',NULL,NULL),(60034,'71343','S','Manifest','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(34954,'39061','P','Delta City','D','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.025276,-90.786213,0,'2013-07-06 12:44:32',NULL,NULL),(34101,'38174','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.132269,-90.002258,0,'2013-07-06 12:44:32',NULL,NULL),(30252,'33206','U','Coral Gables','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.795180,-80.325380,0,'2013-07-06 12:44:32',NULL,NULL),(16315,'17120','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.267283,-76.881635,0,'2013-07-06 12:44:31',NULL,NULL),(49243,'56473','S','Pillager','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.295738,-94.330254,0,'2013-07-06 12:44:33',NULL,NULL),(53662,'62207','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.610300,-90.156180,0,'2013-07-06 12:44:33',NULL,NULL),(54030,'62460','S','Saint Francisville','D','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.591789,-87.646603,0,'2013-07-06 12:44:33',NULL,NULL),(77859,'97230','S','Parkrose','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.541400,-122.498239,0,'2013-07-06 12:44:34',NULL,NULL),(55058,'63156','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.634618,-90.241991,0,'2013-07-06 12:44:33',NULL,NULL),(52236,'60504','S','Aurora','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.755826,-88.241597,0,'2013-07-06 12:44:33',NULL,NULL),(49789,'57106','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.517030,-96.789603,0,'2013-07-06 12:44:33',NULL,NULL),(43810,'49070','S','Martin','D','Allegan','26005','Michigan','MI','26','3000','269','Eastern',-5.0,'Y',42.541296,-85.634433,0,'2013-07-06 12:44:32',NULL,NULL),(8252,'08007','S','Barrington','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.866321,-75.054278,0,'2013-07-06 12:44:30',NULL,NULL),(31619,'34690','S','Tarpon Spgs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.191092,-82.728081,0,'2013-07-06 12:44:32',NULL,NULL),(3680,'02129','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.336180,-71.103660,0,'2013-07-06 12:44:30',NULL,NULL),(7782,'07422','S','Highland Lakes','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.187240,-74.453760,0,'2013-07-06 12:44:30',NULL,NULL),(69814,'84073','S','Talmage','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.174992,-110.393823,0,'2013-07-06 12:44:34',NULL,NULL),(59935,'71292','S','West Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(53659,'62206','S','Sauget','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.561749,-90.161656,0,'2013-07-06 12:44:33',NULL,NULL),(50710,'58366','S','Thorne','N','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.654300,-99.890100,0,'2013-07-06 12:44:33',NULL,NULL),(12135,'12724','P','Callicoon Center','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.839043,-74.946526,0,'2013-07-06 12:44:30',NULL,NULL),(27371,'30069','U','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.916908,-84.517971,0,'2013-07-06 12:44:31',NULL,NULL),(1185,'00727','S','Villa Hermosa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(70604,'85118','S','Gold Canyon','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359605,-111.440833,0,'2013-07-06 12:44:34',NULL,NULL),(65914,'78236','S','Wilford Hall USAF Hosp','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.404744,-98.612640,0,'2013-07-06 12:44:34',NULL,NULL),(51663,'59912','S','Columbia Falls','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.365309,-114.192688,0,'2013-07-06 12:44:33',NULL,NULL),(51206,'59038','S','Sanders','A','Treasure','30103','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.288514,-107.232251,0,'2013-07-06 12:44:33',NULL,NULL),(18379,'19046','S','Rydal','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(8821,'08619','S','Mercerville','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.238460,-74.717460,0,'2013-07-06 12:44:30',NULL,NULL),(31481,'34429','S','Crystal River','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.870559,-82.590328,0,'2013-07-06 12:44:32',NULL,NULL),(28240,'31052','S','Lizella','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.786526,-83.793445,0,'2013-07-06 12:44:31',NULL,NULL),(20293,'20810','U','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.979522,-77.100398,0,'2013-07-06 12:44:31',NULL,NULL),(14917,'15540','S','Fort Hill','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.863584,-79.247684,0,'2013-07-06 12:44:31',NULL,NULL),(73198,'90601','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',34.005998,-118.032175,0,'2013-07-06 12:44:34',NULL,NULL),(56892,'66041','S','Huron','A','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.603120,-95.325900,0,'2013-07-06 12:44:33',NULL,NULL),(50350,'57745','S','Hill City','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.124460,-103.719540,0,'2013-07-06 12:44:33',NULL,NULL),(41046,'46405','S','Gary','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.568530,-87.270213,0,'2013-07-06 12:44:32',NULL,NULL),(26620,'29316','S','Boiling Spgs','A','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.056379,-81.964009,0,'2013-07-06 12:44:31',NULL,NULL),(27431,'30111','P','Clarkdale','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.804574,-84.606511,0,'2013-07-06 12:44:31',NULL,NULL),(35556,'39565','S','Ocean Spgs','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.568555,-88.740289,0,'2013-07-06 12:44:32',NULL,NULL),(24996,'27867','P','Potecasi','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.361074,-77.238158,0,'2013-07-06 12:44:31',NULL,NULL),(75685,'94557','P','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.629876,-122.103025,0,'2013-07-06 12:44:34',NULL,NULL),(71910,'87801','S','Socorro','D','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.006320,-106.793820,0,'2013-07-06 12:44:34',NULL,NULL),(70784,'85350','S','Somerton','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.596969,-114.690827,0,'2013-07-06 12:44:34',NULL,NULL),(68974,'83110','S','Turnerville','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.720239,-110.943627,0,'2013-07-06 12:44:34',NULL,NULL),(46506,'53235','S','Saint Francis','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.969046,-87.871317,0,'2013-07-06 12:44:32',NULL,NULL),(33774,'37869','S','Sneedville','D','Hancock','47067','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.535976,-83.220036,0,'2013-07-06 12:44:32',NULL,NULL),(33176,'37030','S','Mc Clures Bend','N','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.262380,-85.994400,0,'2013-07-06 12:44:32',NULL,NULL),(5084,'04330','S','Togus','N','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.353599,-69.731361,0,'2013-07-06 12:44:30',NULL,NULL),(27195,'29899','U','Mc Cormick','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.908678,-82.290232,0,'2013-07-06 12:44:31',NULL,NULL),(26910,'29582','S','Atlantic Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(37949,'42717','S','Burkesville','D','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(45043,'50479','S','Thornton','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.943522,-93.380824,0,'2013-07-06 12:44:32',NULL,NULL),(13029,'13433','S','Collinsville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.588855,-75.279411,0,'2013-07-06 12:44:30',NULL,NULL),(74417,'92551','S','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.902690,-117.189128,0,'2013-07-06 12:44:34',NULL,NULL),(66998,'79504','S','Baird','D','Callahan','48059','Texas','TX','48','0000','325','Central',-6.0,'Y',32.395547,-99.397885,0,'2013-07-06 12:44:34',NULL,NULL),(45593,'51550','S','Magnolia','D','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.643056,-95.788611,0,'2013-07-06 12:44:32',NULL,NULL),(60398,'71631','S','Gravelridge','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.544300,-92.265430,0,'2013-07-06 12:44:33',NULL,NULL),(50023,'57402','P','Aberdeen','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.493924,-98.494540,0,'2013-07-06 12:44:33',NULL,NULL),(39475,'44718','S','Lake Cable','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.851462,-81.443104,0,'2013-07-06 12:44:32',NULL,NULL),(61633,'72839','S','Hagarville','D','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.526713,-93.339763,0,'2013-07-06 12:44:33',NULL,NULL),(77123,'96152','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.942280,-119.976119,0,'2013-07-06 12:44:34',NULL,NULL),(17829,'18415','S','Galilee','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.735665,-75.135097,0,'2013-07-06 12:44:31',NULL,NULL),(76785,'95943','S','Bayliss','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.593700,-122.052780,0,'2013-07-06 12:44:34',NULL,NULL),(75594,'94298','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584020,-121.494416,0,'2013-07-06 12:44:34',NULL,NULL),(18128,'18822','S','Hallstead','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.961084,-75.748092,0,'2013-07-06 12:44:31',NULL,NULL),(31776,'35019','S','Baileyton','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.267570,-86.845224,0,'2013-07-06 12:44:32',NULL,NULL),(76614,'95694','S','Winters','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.525534,-121.973650,0,'2013-07-06 12:44:34',NULL,NULL),(8858,'08648','S','Lawrenceville','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.265940,-74.695860,0,'2013-07-06 12:44:30',NULL,NULL),(26581,'29219','U','Blue Cross Blue Shield od SC','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.067593,-80.920837,0,'2013-07-06 12:44:31',NULL,NULL),(70033,'84132','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.765465,-111.840905,0,'2013-07-06 12:44:34',NULL,NULL),(67447,'80210','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.675422,-104.961630,0,'2013-07-06 12:44:34',NULL,NULL),(40110,'45319','P','Donnelsville','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.916803,-83.949240,0,'2013-07-06 12:44:32',NULL,NULL),(13421,'13755','S','Gregorytown','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.067456,-75.036591,0,'2013-07-06 12:44:31',NULL,NULL),(7680,'07099','U','Kearny','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.753847,-74.119960,0,'2013-07-06 12:44:30',NULL,NULL),(33946,'38076','S','Williston','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.167612,-89.377588,0,'2013-07-06 12:44:32',NULL,NULL),(31085,'33865','S','Ona','D','Hardee','12049','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.461174,-81.961885,0,'2013-07-06 12:44:32',NULL,NULL),(25029,'27892','S','Beargrass','A','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.731680,-77.114100,0,'2013-07-06 12:44:31',NULL,NULL),(35656,'39647','S','Quentin','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.510920,-90.772920,0,'2013-07-06 12:44:32',NULL,NULL),(35733,'39701','S','New Hope','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(75458,'94080','S','Ssf','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.652366,-122.430543,0,'2013-07-06 12:44:34',NULL,NULL),(12142,'12729','S','Cuddebackvlle','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.485047,-74.627581,0,'2013-07-06 12:44:30',NULL,NULL),(30377,'33318','P','Plantation','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.118323,-80.251273,0,'2013-07-06 12:44:32',NULL,NULL),(7429,'06820','S','Noroton Heights','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.079898,-73.480707,0,'2013-07-06 12:44:30',NULL,NULL),(4615,'03597','P','W Stewartstown','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.992788,-71.534456,0,'2013-07-06 12:44:30',NULL,NULL),(60805,'72031','S','Formosa','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(58887,'69165','S','Flats','N','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.162515,-101.123437,0,'2013-07-06 12:44:33',NULL,NULL),(45575,'51531','S','Elk Horn','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.595124,-95.060430,0,'2013-07-06 12:44:32',NULL,NULL),(41465,'46916','P','Burrows','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.674828,-86.506016,0,'2013-07-06 12:44:32',NULL,NULL),(60066,'71353','S','Woodside','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(75914,'95005','S','Ben Lomond','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',37.085118,-122.086704,0,'2013-07-06 12:44:34',NULL,NULL),(10666,'11106','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761688,-73.930747,0,'2013-07-06 12:44:30',NULL,NULL),(33672,'37730','P','Eagan','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.551016,-83.980097,0,'2013-07-06 12:44:32',NULL,NULL),(14264,'14842','S','Himrod','D','Yates','36123','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.592474,-76.947431,0,'2013-07-06 12:44:31',NULL,NULL),(53281,'61726','S','Yates','N','McLean','17113','Illinois','IL','17','1040','815/779','Central',-6.0,'Y',40.743720,-88.717320,0,'2013-07-06 12:44:33',NULL,NULL),(28370,'31220','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.880527,-83.836998,0,'2013-07-06 12:44:32',NULL,NULL),(49149,'56378','S','Sauk Centre','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.714514,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(56746,'65721','S','Ozark','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.014220,-93.204822,0,'2013-07-06 12:44:33',NULL,NULL),(68720,'82072','S','Laramie','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.061360,-106.014750,0,'2013-07-06 12:44:34',NULL,NULL),(2721,'00969','S','Urb Baldwin Mansions','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(9884,'10125','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.753195,-74.000885,0,'2013-07-06 12:44:30',NULL,NULL),(58637,'68869','S','Ravenna','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(49386,'56601','S','Port Hope','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(67280,'80003','S','Westminster','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.824737,-105.061827,0,'2013-07-06 12:44:34',NULL,NULL),(36201,'40268','P','Pleasure Rdge','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.146878,-85.870680,0,'2013-07-06 12:44:32',NULL,NULL),(35494,'39529','U','Bay Saint Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(35067,'39191','S','Wesson','D','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.701603,-90.395297,0,'2013-07-06 12:44:32',NULL,NULL),(43107,'48220','S','Ferndale','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.458803,-83.138618,0,'2013-07-06 12:44:32',NULL,NULL),(21222,'22213','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.894653,-77.163198,0,'2013-07-06 12:44:31',NULL,NULL),(57498,'66945','S','Hanover','D','Washington','20201','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.889590,-96.887758,0,'2013-07-06 12:44:33',NULL,NULL),(57427,'66780','S','Walnut','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.600473,-95.081169,0,'2013-07-06 12:44:33',NULL,NULL),(2130,'00924','S','Sect Los Penas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(10362,'10579','S','Tompkins Corners','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.390553,-73.846426,0,'2013-07-06 12:44:30',NULL,NULL),(63169,'75397','U','Jp Morgan Chase','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.767255,-96.829088,0,'2013-07-06 12:44:33',NULL,NULL),(23675,'25840','S','Beckwith','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(80177,'99836','P','Port Alexander','D','Sitka','02220','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.039187,-132.563950,0,'2013-07-06 12:44:34',NULL,NULL),(54742,'62972','S','Tunnel Hill','A','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.533890,-88.763201,0,'2013-07-06 12:44:33',NULL,NULL),(3317,'01523','S','North Lancaster','N','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.477605,-71.684044,0,'2013-07-06 12:44:30',NULL,NULL),(55840,'64161','S','Birmingham','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.161625,-94.466674,0,'2013-07-06 12:44:33',NULL,NULL),(27484,'30153','S','Rockmart','D','Polk','13233','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.987500,-85.055100,0,'2013-07-06 12:44:31',NULL,NULL),(25846,'28623','S','Ennice','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.529320,-80.969220,0,'2013-07-06 12:44:31',NULL,NULL),(54817,'63022','P','Ballwin','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.596552,-90.546397,0,'2013-07-06 12:44:33',NULL,NULL),(17301,'17851','S','Strong','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(34977,'39090','S','Kosciusko','D','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.056108,-89.589283,0,'2013-07-06 12:44:32',NULL,NULL),(3618,'02059','P','N Marshfield','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.142821,-70.772118,0,'2013-07-06 12:44:30',NULL,NULL),(77512,'96839','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.322589,-157.812705,0,'2013-07-06 12:44:34',NULL,NULL),(73752,'91724','S','Covina','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.090101,-117.858739,0,'2013-07-06 12:44:34',NULL,NULL),(70282,'84532','S','Castle Valley','A','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(58406,'68636','S','Elgin','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.959792,-98.065420,0,'2013-07-06 12:44:33',NULL,NULL),(27706,'30340','S','Doraville','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.891239,-84.250847,0,'2013-07-06 12:44:31',NULL,NULL),(12657,'13119','P','Mottville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.973215,-76.441929,0,'2013-07-06 12:44:30',NULL,NULL),(53376,'61778','S','Waynesville','D','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.242570,-89.126495,0,'2013-07-06 12:44:33',NULL,NULL),(75560,'94257','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587116,-121.493274,0,'2013-07-06 12:44:34',NULL,NULL),(54445,'62846','S','Ina','D','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.152390,-88.904498,0,'2013-07-06 12:44:33',NULL,NULL),(58981,'70044','P','Chalmette','D','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.951794,-89.959355,0,'2013-07-06 12:44:33',NULL,NULL),(70241,'84405','S','Washington Terrace','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(71751,'87544','S','White Rock','A','Los Alamos','35028','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.866912,-106.265556,0,'2013-07-06 12:44:34',NULL,NULL),(75058,'93523','S','Edwards Air Force Base','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.950022,-117.901246,0,'2013-07-06 12:44:34',NULL,NULL),(4176,'02809','S','Bristol','D','Bristol','44001','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.687450,-71.270122,0,'2013-07-06 12:44:30',NULL,NULL),(32243,'35601','S','Decatur','D','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.591880,-86.984191,0,'2013-07-06 12:44:32',NULL,NULL),(15364,'16256','S','Smicksburg','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.826103,-79.167610,0,'2013-07-06 12:44:31',NULL,NULL),(29293,'32509','U','Netpmdsa Saufley Field','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.420085,-87.222152,0,'2013-07-06 12:44:32',NULL,NULL),(28577,'31625','S','Barney','D','Brooks','13027','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.002216,-83.519240,0,'2013-07-06 12:44:32',NULL,NULL),(6895,'06145','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791818,-72.668284,0,'2013-07-06 12:44:30',NULL,NULL),(65960,'78279','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.533211,-98.491012,0,'2013-07-06 12:44:34',NULL,NULL),(20469,'21036','S','Dayton','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.240467,-76.996499,0,'2013-07-06 12:44:31',NULL,NULL),(29840,'33032','S','Redland','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.526149,-80.406867,0,'2013-07-06 12:44:32',NULL,NULL),(41323,'46774','S','Tanglewood','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.076957,-84.996923,0,'2013-07-06 12:44:32',NULL,NULL),(61718,'73013','S','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.622482,-97.470627,0,'2013-07-06 12:44:33',NULL,NULL),(77319,'96703','P','Anahola','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.129099,-159.345570,0,'2013-07-06 12:44:34',NULL,NULL),(1410,'00738','S','Urb Rafael Bermudez','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(13906,'14301','S','Niagara Falls','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.093678,-79.041792,0,'2013-07-06 12:44:31',NULL,NULL),(14485,'15134','P','McKeesport','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.341563,-79.843904,0,'2013-07-06 12:44:31',NULL,NULL),(61572,'72734','S','Springtown','A','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.268323,-94.486877,0,'2013-07-06 12:44:33',NULL,NULL),(60842,'72041','S','De Valls Blf','A','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.715356,-91.542833,0,'2013-07-06 12:44:33',NULL,NULL),(12278,'12839','S','Kingsbury','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.320840,-73.576800,0,'2013-07-06 12:44:30',NULL,NULL),(5877,'05149','S','Smithville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.392420,-72.697140,0,'2013-07-06 12:44:30',NULL,NULL),(64477,'76579','S','Troy','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.204456,-97.308221,0,'2013-07-06 12:44:34',NULL,NULL),(35702,'39666','S','Mars Hill','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(55411,'63650','S','Rosel','N','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.601823,-90.629002,0,'2013-07-06 12:44:33',NULL,NULL),(79824,'99509','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.175640,-149.878401,0,'2013-07-06 12:44:34',NULL,NULL),(16948,'17701','S','Proctor','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(21174,'22158','U','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.812261,-77.256414,0,'2013-07-06 12:44:31',NULL,NULL),(52949,'61414','S','Altona','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.114661,-90.162252,0,'2013-07-06 12:44:33',NULL,NULL),(77731,'97068','S','West Linn','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.366874,-122.650360,0,'2013-07-06 12:44:34',NULL,NULL),(10570,'11020','S','Grt Neck','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(65654,'77976','P','Nursery','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.951978,-96.983533,0,'2013-07-06 12:44:34',NULL,NULL),(33310,'37133','P','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.840269,-86.394053,0,'2013-07-06 12:44:32',NULL,NULL),(77374,'96752','P','Kekaha','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.967116,-159.709834,0,'2013-07-06 12:44:34',NULL,NULL),(2256,'00926','S','Urb Monte Apolo Est','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(724,'00687','S','Urb Cruz Rosario','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(22650,'24266','S','Barnett','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.890460,-82.084560,0,'2013-07-06 12:44:31',NULL,NULL),(9395,'09865','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(75279,'93711','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.820061,-119.843171,0,'2013-07-06 12:44:34',NULL,NULL),(73316,'90814','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.770764,-118.150873,0,'2013-07-06 12:44:34',NULL,NULL),(71659,'87501','S','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(68607,'81615','P','Snowmass Village','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.209019,-106.936130,0,'2013-07-06 12:44:34',NULL,NULL),(8689,'08344','S','Newfield','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.563197,-74.980592,0,'2013-07-06 12:44:30',NULL,NULL),(62325,'74044','S','Lawrence Crk','A','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.121473,-96.344224,0,'2013-07-06 12:44:33',NULL,NULL),(69042,'83221','S','Thomas','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.326240,-112.411320,0,'2013-07-06 12:44:34',NULL,NULL),(5785,'05054','P','North Thetford','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.842315,-72.183801,0,'2013-07-06 12:44:30',NULL,NULL),(17212,'17823','S','Red Cross','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.757282,-76.762227,0,'2013-07-06 12:44:31',NULL,NULL),(18399,'19053','S','Feasterville','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.149318,-74.981646,0,'2013-07-06 12:44:31',NULL,NULL),(43048,'48183','S','Brownstown Township','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(51960,'60139','S','Glendale Hts','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.918876,-88.076541,0,'2013-07-06 12:44:33',NULL,NULL),(20486,'21048','S','Patapsco','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.504233,-76.904395,0,'2013-07-06 12:44:31',NULL,NULL),(17974,'18614','S','Forkston Twp','A','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.522494,-76.401012,0,'2013-07-06 12:44:31',NULL,NULL),(75464,'94087','S','Sunnyvale','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.348182,-122.031788,0,'2013-07-06 12:44:34',NULL,NULL),(72913,'90025','S','West Los Angeles','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.044073,-118.451381,0,'2013-07-06 12:44:34',NULL,NULL),(62059,'73540','S','Faxon','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.464413,-98.545707,0,'2013-07-06 12:44:33',NULL,NULL),(15181,'15938','S','Lilly','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.423002,-78.628976,0,'2013-07-06 12:44:31',NULL,NULL),(19594,'20224','U','Internal Revenue Service','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.890942,-77.027831,0,'2013-07-06 12:44:31',NULL,NULL),(1220,'00728','S','Urb Las Margaritas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(65707,'78014','S','Los Angeles','N','La Salle','48283','Texas','TX','48','0000','830','Central',-6.0,'Y',28.424112,-99.237016,0,'2013-07-06 12:44:34',NULL,NULL),(27060,'29684','S','Starr','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.397696,-82.667729,0,'2013-07-06 12:44:31',NULL,NULL),(70423,'84728','S','Petra','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.935110,-114.034510,0,'2013-07-06 12:44:34',NULL,NULL),(12392,'12924','S','Keeseville','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.473734,-73.589677,0,'2013-07-06 12:44:30',NULL,NULL),(22037,'23298','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.540976,-77.425624,0,'2013-07-06 12:44:31',NULL,NULL),(54968,'63121','S','Pasadena Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(54705,'62952','S','Ware','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.452013,-89.269945,0,'2013-07-06 12:44:33',NULL,NULL),(66063,'78380','S','South San Pedro','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(49919,'57319','S','Bridgewater','D','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.529100,-97.446420,0,'2013-07-06 12:44:33',NULL,NULL),(51790,'60046','S','Chesney Shores','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.410921,-88.063011,0,'2013-07-06 12:44:33',NULL,NULL),(63939,'76070','S','Nemo','D','Somervell','48425','Texas','TX','48','0000','254','Central',-6.0,'Y',32.283795,-97.648649,0,'2013-07-06 12:44:34',NULL,NULL),(34509,'38675','S','Tula','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.364813,-89.526651,0,'2013-07-06 12:44:32',NULL,NULL),(78969,'98371','S','Maplewood','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(67798,'80733','S','Hillrose','D','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.333267,-103.510516,0,'2013-07-06 12:44:34',NULL,NULL),(25784,'28604','S','Beech Mountain','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(55804,'64136','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.006121,-94.399430,0,'2013-07-06 12:44:33',NULL,NULL),(18819,'19407','P','Audubon','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.118426,-75.446143,0,'2013-07-06 12:44:31',NULL,NULL),(59933,'71292','S','Olinkraft','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(44820,'50244','S','Slater','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.881450,-93.679502,0,'2013-07-06 12:44:32',NULL,NULL),(704,'00685','S','Valle Verde','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(8947,'08757','S','Toms River','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.971940,-74.219880,0,'2013-07-06 12:44:30',NULL,NULL),(35491,'39525','S','Bay Saint Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.384560,-89.375564,0,'2013-07-06 12:44:32',NULL,NULL),(49909,'57301','S','Loomis','A','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.727400,-98.046180,0,'2013-07-06 12:44:33',NULL,NULL),(63533,'75757','S','Old Larissa','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.150666,-95.372322,0,'2013-07-06 12:44:33',NULL,NULL),(31890,'35133','S','Remlap','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.821151,-86.623895,0,'2013-07-06 12:44:32',NULL,NULL),(70890,'85615','S','Palominas','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.402920,-110.207340,0,'2013-07-06 12:44:34',NULL,NULL),(34854,'38925','S','Duck Hill','D','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.633238,-89.715693,0,'2013-07-06 12:44:32',NULL,NULL),(11661,'12138','S','North Petersburg','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.737100,-73.362660,0,'2013-07-06 12:44:30',NULL,NULL),(65260,'77469','S','Crabb','N','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(27146,'29824','S','Cleora','N','Edgefield','45037','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.786960,-81.929623,0,'2013-07-06 12:44:31',NULL,NULL),(49638,'56945','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(18774,'19362','S','Nottingham','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.752457,-76.067397,0,'2013-07-06 12:44:31',NULL,NULL),(45528,'51443','S','Glidden','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.060616,-94.729301,0,'2013-07-06 12:44:32',NULL,NULL),(37608,'42129','S','Randolph','N','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(26991,'29624','S','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.478216,-82.681650,0,'2013-07-06 12:44:31',NULL,NULL),(31146,'33911','P','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.628255,-81.993931,0,'2013-07-06 12:44:32',NULL,NULL),(57377,'66746','S','Hepler','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.653504,-95.016741,0,'2013-07-06 12:44:33',NULL,NULL),(57143,'66250','U','Jc Penney Co','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.955067,-94.786621,0,'2013-07-06 12:44:33',NULL,NULL),(28230,'31041','S','Ideal','D','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.377455,-84.204243,0,'2013-07-06 12:44:31',NULL,NULL),(76152,'95304','S','Tracy','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.727820,-121.413900,0,'2013-07-06 12:44:34',NULL,NULL),(33234,'37069','S','Franklin','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.990255,-86.895944,0,'2013-07-06 12:44:32',NULL,NULL),(29687,'32927','S','Cocoa','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.470183,-80.797492,0,'2013-07-06 12:44:32',NULL,NULL),(22166,'23463','U','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.801576,-76.176454,0,'2013-07-06 12:44:31',NULL,NULL),(42350,'47648','S','Fort Branch','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.245368,-87.578368,0,'2013-07-06 12:44:32',NULL,NULL),(50520,'58079','S','Embden','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.877214,-97.409644,0,'2013-07-06 12:44:33',NULL,NULL),(6706,'06064','P','Poquonock','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.905959,-72.682676,0,'2013-07-06 12:44:30',NULL,NULL),(48230,'55420','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.835722,-93.275326,0,'2013-07-06 12:44:33',NULL,NULL),(62715,'74756','S','Sawyer','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.047128,-95.363473,0,'2013-07-06 12:44:33',NULL,NULL),(65020,'77306','S','Cut and Shoot','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.323320,-95.471373,0,'2013-07-06 12:44:34',NULL,NULL),(19970,'20593','U','Us Coast Guard','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.867378,-77.012246,0,'2013-07-06 12:44:31',NULL,NULL),(65041,'77331','S','Coldspring','D','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.598380,-95.114520,0,'2013-07-06 12:44:34',NULL,NULL),(48228,'55418','S','St Anthony Village','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.022134,-93.244686,0,'2013-07-06 12:44:33',NULL,NULL),(58653,'68874','S','Corner','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.639988,-99.371879,0,'2013-07-06 12:44:33',NULL,NULL),(48668,'55917','S','Summit','N','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917900,-93.055500,0,'2013-07-06 12:44:33',NULL,NULL),(50081,'57456','S','Leola','D','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.624679,-98.769904,0,'2013-07-06 12:44:33',NULL,NULL),(4063,'02646','S','Harwichport','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.673644,-70.071486,0,'2013-07-06 12:44:30',NULL,NULL),(4774,'03860','S','No Conway','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.041258,-71.131424,0,'2013-07-06 12:44:30',NULL,NULL),(7965,'07699','U','USPS','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.859722,-74.059722,0,'2013-07-06 12:44:30',NULL,NULL),(14645,'15235','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445040,-79.913760,0,'2013-07-06 12:44:31',NULL,NULL),(18018,'18641','S','Avoca','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.329128,-75.746729,0,'2013-07-06 12:44:31',NULL,NULL),(27024,'29648','P','Greenwood','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.189151,-82.156129,0,'2013-07-06 12:44:31',NULL,NULL),(27150,'29826','P','Elko','D','Barnwell','45011','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.379504,-81.377307,0,'2013-07-06 12:44:31',NULL,NULL),(11632,'12118','S','Malta','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.913913,-73.707978,0,'2013-07-06 12:44:30',NULL,NULL),(367,'00659','S','Urb Hatillo del Mar','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(66017,'78358','P','Fulton','D','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.079830,-97.032030,0,'2013-07-06 12:44:34',NULL,NULL),(57638,'67151','S','Walton','D','Harvey','20079','Kansas','KS','20','9040','620','Central',-6.0,'Y',38.117243,-97.255176,0,'2013-07-06 12:44:33',NULL,NULL),(47786,'55044','S','Argonne','N','Dakota','27037','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.652317,-93.247168,0,'2013-07-06 12:44:33',NULL,NULL),(5774,'05049','P','Hartland Cors','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.544740,-72.427723,0,'2013-07-06 12:44:30',NULL,NULL),(22760,'24430','S','Craigsville','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.107652,-79.334798,0,'2013-07-06 12:44:31',NULL,NULL),(80012,'99677','P','Cordova','A','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.105204,-147.109932,0,'2013-07-06 12:44:34',NULL,NULL),(68297,'81091','S','Monument Park','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(30641,'33448','P','West Delray Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.461111,-80.073056,0,'2013-07-06 12:44:32',NULL,NULL),(72053,'88103','P','Cannon Air Force Base','N','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.395300,-103.324380,0,'2013-07-06 12:44:34',NULL,NULL),(30852,'33647','S','Tampa Palms','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.114509,-82.363889,0,'2013-07-06 12:44:32',NULL,NULL),(77541,'96853','S','Joint Base Pearl Hbr Hickam','A','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.339051,-157.943329,0,'2013-07-06 12:44:34',NULL,NULL),(27655,'30322','U','Emory University','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.791247,-84.324900,0,'2013-07-06 12:44:31',NULL,NULL),(56117,'64802','P','Joplin','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.055577,-94.543038,0,'2013-07-06 12:44:33',NULL,NULL),(72596,'89409','P','Gabbs','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.861774,-117.925368,0,'2013-07-06 12:44:34',NULL,NULL),(73598,'91390','S','Canyon Cntry','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(16909,'17601','S','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(12111,'12584','P','Vails Gate','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.466225,-74.049239,0,'2013-07-06 12:44:30',NULL,NULL),(46689,'53783','U','American Family Ins Co','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.159291,-89.283709,0,'2013-07-06 12:44:32',NULL,NULL),(42496,'47842','S','Centenary','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(20881,'21679','S','Wye Mills','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.880954,-75.830894,0,'2013-07-06 12:44:31',NULL,NULL),(55175,'63369','S','Maryknoll','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.942597,-90.763542,0,'2013-07-06 12:44:33',NULL,NULL),(60606,'71852','S','Nashville','D','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.945803,-93.850288,0,'2013-07-06 12:44:33',NULL,NULL),(67359,'80111','S','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612706,-104.883398,0,'2013-07-06 12:44:34',NULL,NULL),(16950,'17701','S','Vallamont Hls','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(40900,'46254','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.840838,-86.265101,0,'2013-07-06 12:44:32',NULL,NULL),(39591,'44866','S','Polk','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.921560,-82.202280,0,'2013-07-06 12:44:32',NULL,NULL),(16493,'17257','S','Mowersville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(64528,'76642','S','Groesbeck','D','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.546200,-96.529080,0,'2013-07-06 12:44:34',NULL,NULL),(5072,'04287','S','West Bowdoin','N','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.985129,-70.094212,0,'2013-07-06 12:44:30',NULL,NULL),(49918,'57317','S','Bonesteel','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.058084,-99.032139,0,'2013-07-06 12:44:33',NULL,NULL),(56728,'65706','S','Marshfield','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.339115,-92.905687,0,'2013-07-06 12:44:33',NULL,NULL),(21933,'23229','S','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602592,-77.557517,0,'2013-07-06 12:44:31',NULL,NULL),(14563,'15215','S','Aspinwall','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.503780,-79.912020,0,'2013-07-06 12:44:31',NULL,NULL),(2824,'00979','S','Urb Cape Sea Vlg','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(51763,'60030','S','Third Lake','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(36162,'40242','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(41503,'46961','S','New Waverly','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.764026,-86.194231,0,'2013-07-06 12:44:32',NULL,NULL),(79014,'98390','S','Edgewood','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.179260,-122.192040,0,'2013-07-06 12:44:34',NULL,NULL),(62163,'73736','S','Fairmont','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.376230,-97.701868,0,'2013-07-06 12:44:33',NULL,NULL),(44588,'50040','P','Boxholm','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.166492,-94.106704,0,'2013-07-06 12:44:32',NULL,NULL),(55689,'64061','S','Kingsville','D','Johnson','29101','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',38.839976,-94.118479,0,'2013-07-06 12:44:33',NULL,NULL),(67398,'80126','S','Hghlnds Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.548022,-104.963984,0,'2013-07-06 12:44:34',NULL,NULL),(10684,'11209','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.623738,-74.033806,0,'2013-07-06 12:44:30',NULL,NULL),(65489,'77655','S','Sabine Pass','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.725616,-93.888258,0,'2013-07-06 12:44:34',NULL,NULL),(45159,'50590','S','Swea City','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.382381,-94.309212,0,'2013-07-06 12:44:32',NULL,NULL),(76621,'95701','P','Alta','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.213231,-120.801982,0,'2013-07-06 12:44:34',NULL,NULL),(21163,'22151','S','N Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801146,-77.207526,0,'2013-07-06 12:44:31',NULL,NULL),(61824,'73110','S','Midwest City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460687,-97.397356,0,'2013-07-06 12:44:33',NULL,NULL),(26241,'28815','P','Oteen Sta','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.575619,-82.545629,0,'2013-07-06 12:44:31',NULL,NULL),(8565,'08212','P','Cape May Point','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.939854,-74.963948,0,'2013-07-06 12:44:30',NULL,NULL),(68727,'82083','S','Rock River','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.782089,-105.885219,0,'2013-07-06 12:44:34',NULL,NULL),(8809,'08610','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.215600,-74.739600,0,'2013-07-06 12:44:30',NULL,NULL),(29257,'32452','P','Noma','D','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.980595,-85.615081,0,'2013-07-06 12:44:32',NULL,NULL),(22691,'24319','S','Chilhowie','D','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.802209,-81.682538,0,'2013-07-06 12:44:31',NULL,NULL),(2694,'00969','S','Alt de Torrimar Este','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(1228,'00728','S','Valle del Rey','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(51642,'59866','S','St Regis','N','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.298848,-115.094482,0,'2013-07-06 12:44:33',NULL,NULL),(49059,'56307','S','Albany','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.637483,-94.577068,0,'2013-07-06 12:44:33',NULL,NULL),(30514,'33404','S','Palm Beach Shores','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(53318,'61741','S','Wing','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.751704,-88.412200,0,'2013-07-06 12:44:33',NULL,NULL),(8865,'08690','S','Hamilton Sq','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(9165,'09340','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(60758,'72003','S','Almyra','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.297589,-91.345171,0,'2013-07-06 12:44:33',NULL,NULL),(28693,'31810','P','Geneva','D','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.586218,-84.619383,0,'2013-07-06 12:44:32',NULL,NULL),(22135,'23451','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.863730,-76.012395,0,'2013-07-06 12:44:31',NULL,NULL),(65837,'78155','S','New Berlin','A','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.566660,-97.965413,0,'2013-07-06 12:44:34',NULL,NULL),(365,'00659','S','Urb Corales de Hatillo','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(11960,'12453','P','Mldn on Hdsn','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.094637,-73.933788,0,'2013-07-06 12:44:30',NULL,NULL),(341,'00656','S','Bda Guaydia','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(71071,'85911','P','Cibecue','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.046700,-110.484957,0,'2013-07-06 12:44:34',NULL,NULL),(53752,'62261','S','Pr du Rocher','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.037120,-90.007380,0,'2013-07-06 12:44:33',NULL,NULL),(62647,'74576','S','Wardville','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.609432,-95.997575,0,'2013-07-06 12:44:33',NULL,NULL),(50131,'57531','S','Draper','D','Jones','46075','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.937546,-100.467728,0,'2013-07-06 12:44:33',NULL,NULL),(11464,'12010','S','Perth','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923640,-74.170860,0,'2013-07-06 12:44:30',NULL,NULL),(52732,'61235','S','Alba','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.417664,-90.016623,0,'2013-07-06 12:44:33',NULL,NULL),(71711,'87528','S','Lumberton','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.947461,-106.988234,0,'2013-07-06 12:44:34',NULL,NULL),(23108,'24943','S','Grassy Mdws','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.844161,-80.743448,0,'2013-07-06 12:44:31',NULL,NULL),(58975,'70040','S','Davant','N','Plaquemines','22075','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.827869,-89.963279,0,'2013-07-06 12:44:33',NULL,NULL),(16256,'17084','S','Shraders','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.677620,-77.606927,0,'2013-07-06 12:44:31',NULL,NULL),(28654,'31773','S','Ochlocknee','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.852812,-84.205045,0,'2013-07-06 12:44:32',NULL,NULL),(33018,'36701','S','Selma','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.413447,-87.027314,0,'2013-07-06 12:44:32',NULL,NULL),(42216,'47557','S','Monroe City','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.580666,-87.353511,0,'2013-07-06 12:44:32',NULL,NULL),(57709,'67346','S','Grenola','D','Elk','20049','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.346368,-96.449744,0,'2013-07-06 12:44:33',NULL,NULL),(21117,'22081','S','Northern Virginia Facility','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.873376,-77.235978,0,'2013-07-06 12:44:31',NULL,NULL),(43890,'49235','S','Clayton','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.866607,-84.211330,0,'2013-07-06 12:44:32',NULL,NULL),(58721,'68939','S','Macon','N','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.097909,-98.951170,0,'2013-07-06 12:44:33',NULL,NULL),(53304,'61736','S','Holder','A','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.364700,-88.868220,0,'2013-07-06 12:44:33',NULL,NULL),(76651,'95728','P','Cisco','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.320782,-120.408004,0,'2013-07-06 12:44:34',NULL,NULL),(77011,'96088','S','Viola','N','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.531920,-121.845240,0,'2013-07-06 12:44:34',NULL,NULL),(1121,'00725','S','Valle de San Luis','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(67400,'80126','S','Littleton','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.548022,-104.963984,0,'2013-07-06 12:44:34',NULL,NULL),(63814,'75969','S','Central','N','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.415556,-94.938889,0,'2013-07-06 12:44:34',NULL,NULL),(2138,'00924','S','Urb Highland Pk','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(55716,'64074','S','Napoleon','D','Lafayette','29107','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.107839,-94.066239,0,'2013-07-06 12:44:33',NULL,NULL),(51633,'59856','P','Paradise','D','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.389760,-114.798329,0,'2013-07-06 12:44:33',NULL,NULL),(29044,'32235','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.294054,-81.634778,0,'2013-07-06 12:44:32',NULL,NULL),(75114,'93546','S','Lake Mary','N','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',37.564380,-118.744510,0,'2013-07-06 12:44:34',NULL,NULL),(75471,'94105','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.786816,-122.395580,0,'2013-07-06 12:44:34',NULL,NULL),(35012,'39149','S','Pinola','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.824327,-90.022923,0,'2013-07-06 12:44:32',NULL,NULL),(33540,'37388','S','Tullahoma','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.371202,-86.213117,0,'2013-07-06 12:44:32',NULL,NULL),(9007,'08858','P','Oldwick','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.692810,-74.794463,0,'2013-07-06 12:44:30',NULL,NULL),(27437,'30115','S','Holly Springs','A','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.207461,-84.401820,0,'2013-07-06 12:44:31',NULL,NULL),(78409,'98038','S','Wilderness Village','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.398201,-122.032234,0,'2013-07-06 12:44:34',NULL,NULL),(12196,'12780','S','Sparrow Bush','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.432778,-74.720524,0,'2013-07-06 12:44:30',NULL,NULL),(63941,'76073','S','Paradise','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.099525,-97.777889,0,'2013-07-06 12:44:34',NULL,NULL),(60134,'71373','S','Fairview','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(21441,'22576','S','Weems','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.692170,-76.421703,0,'2013-07-06 12:44:31',NULL,NULL),(55700,'64064','S','LS','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.982769,-94.365575,0,'2013-07-06 12:44:33',NULL,NULL),(51440,'59467','S','Pendroy','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.080537,-112.278112,0,'2013-07-06 12:44:33',NULL,NULL),(29050,'32238','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.221453,-81.763006,0,'2013-07-06 12:44:32',NULL,NULL),(8653,'08313','P','Deerfield Street','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.530646,-75.231010,0,'2013-07-06 12:44:30',NULL,NULL),(6527,'05827','S','Mill Village','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.650000,-72.383333,0,'2013-07-06 12:44:30',NULL,NULL),(47499,'54760','P','Pigeon Falls','D','Trempealeau','55121','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.426866,-91.204480,0,'2013-07-06 12:44:32',NULL,NULL),(36828,'41071','S','S Newport','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(76684,'95815','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.612581,-121.445749,0,'2013-07-06 12:44:34',NULL,NULL),(45100,'50543','S','Gowrie','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.278285,-94.288979,0,'2013-07-06 12:44:32',NULL,NULL),(615,'00681','P','Mayaguez','D','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.204311,-67.144689,0,'2013-07-06 12:44:30',NULL,NULL),(53566,'62054','S','Kane','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.217022,-90.382913,0,'2013-07-06 12:44:33',NULL,NULL),(26968,'29611','S','Powdersville','A','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.854896,-82.448532,0,'2013-07-06 12:44:31',NULL,NULL),(28851,'32094','S','Wellborn','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.178260,-82.858788,0,'2013-07-06 12:44:32',NULL,NULL),(72707,'89448','P','Skyland','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(79574,'99021','S','Mead','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.794004,-117.294238,0,'2013-07-06 12:44:34',NULL,NULL),(70052,'84139','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.768936,-111.887445,0,'2013-07-06 12:44:34',NULL,NULL),(23325,'25234','S','Arnoldsburg','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.834580,-81.172662,0,'2013-07-06 12:44:31',NULL,NULL),(37288,'41615','S','Dana','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.554142,-82.676693,0,'2013-07-06 12:44:32',NULL,NULL),(43544,'48686','U','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.601347,-84.206759,0,'2013-07-06 12:44:32',NULL,NULL),(23911,'26209','P','Snowshoe','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.387939,-80.064576,0,'2013-07-06 12:44:31',NULL,NULL),(18773,'19360','P','New London','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.767028,-75.889908,0,'2013-07-06 12:44:31',NULL,NULL),(45979,'52409','P','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.989566,-91.714334,0,'2013-07-06 12:44:32',NULL,NULL),(43704,'48894','S','Westphalia','D','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',42.928630,-84.795666,0,'2013-07-06 12:44:32',NULL,NULL),(42438,'47805','S','Ehrmandale','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(10674,'11201','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.695472,-73.992723,0,'2013-07-06 12:44:30',NULL,NULL),(18254,'19002','S','Lower Gwynedd','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.190760,-75.206580,0,'2013-07-06 12:44:31',NULL,NULL),(15168,'15923','S','Bolivar','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.357223,-79.170216,0,'2013-07-06 12:44:31',NULL,NULL),(1013,'00718','S','Brisas de Naguabo','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(7129,'06387','P','Wauregan','D','Windham','09015','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.743607,-71.911848,0,'2013-07-06 12:44:30',NULL,NULL),(61473,'72632','S','Eureka Spgs','A','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.444978,-93.740676,0,'2013-07-06 12:44:33',NULL,NULL),(13601,'13856','S','Hawleys','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(12724,'13158','S','Cuyler','A','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.695444,-76.014250,0,'2013-07-06 12:44:30',NULL,NULL),(54412,'62830','S','Boyd','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.441733,-88.935689,0,'2013-07-06 12:44:33',NULL,NULL),(48459,'55712','S','Bruno','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.287947,-92.550048,0,'2013-07-06 12:44:33',NULL,NULL),(39256,'44443','S','New Springfld','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.928502,-80.596676,0,'2013-07-06 12:44:32',NULL,NULL),(73892,'91978','S','Spring Valley','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.705089,-116.938685,0,'2013-07-06 12:44:34',NULL,NULL),(63299,'75561','S','Smith Hill','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.469320,-94.315020,0,'2013-07-06 12:44:33',NULL,NULL),(41013,'46373','S','Saint John','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.451569,-87.476665,0,'2013-07-06 12:44:32',NULL,NULL),(71187,'86045','P','Moenkopi','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',36.133993,-111.242465,0,'2013-07-06 12:44:34',NULL,NULL),(80034,'99692','P','Unalaska','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',53.880000,-166.530000,0,'2013-07-06 12:44:34',NULL,NULL),(9380,'09838','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(62389,'74083','S','Wann','D','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.931887,-95.771943,0,'2013-07-06 12:44:33',NULL,NULL),(43935,'49281','P','Somerset','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.051931,-84.382907,0,'2013-07-06 12:44:32',NULL,NULL),(73440,'91225','P','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.124264,-118.254291,0,'2013-07-06 12:44:34',NULL,NULL),(79423,'98826','S','Merritt','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(41613,'47120','S','Fredericksbrg','A','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.433130,-86.189970,0,'2013-07-06 12:44:32',NULL,NULL),(14459,'15108','S','Moon Township','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.510530,-80.182409,0,'2013-07-06 12:44:31',NULL,NULL),(75065,'93526','S','Independence','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.832098,-118.233557,0,'2013-07-06 12:44:34',NULL,NULL),(32783,'36420','S','Heath','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(37019,'41238','S','Oil Springs','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.842864,-82.940341,0,'2013-07-06 12:44:32',NULL,NULL),(14068,'14603','P','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.160031,-77.605267,0,'2013-07-06 12:44:31',NULL,NULL),(70622,'85131','S','Eloy','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.741320,-111.585370,0,'2013-07-06 12:44:34',NULL,NULL),(9839,'10116','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(24403,'27107','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.062543,-80.183453,0,'2013-07-06 12:44:31',NULL,NULL),(21678,'22959','S','North Garden','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.954067,-78.691947,0,'2013-07-06 12:44:31',NULL,NULL),(1451,'00741','S','Villa Palmira','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.168687,-65.747221,0,'2013-07-06 12:44:30',NULL,NULL),(40481,'45775','S','Rutland','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.078654,-82.154842,0,'2013-07-06 12:44:32',NULL,NULL),(34331,'38563','S','New Middleton','N','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.172586,-85.931293,0,'2013-07-06 12:44:32',NULL,NULL),(72349,'89019','S','Goodsprings','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.804011,-115.635842,0,'2013-07-06 12:44:34',NULL,NULL),(15256,'16057','S','Slippery Rock','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.063241,-80.053604,0,'2013-07-06 12:44:31',NULL,NULL),(19133,'19609','S','West Wyomissing','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(32395,'35954','S','Reece City','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.083060,-86.060280,0,'2013-07-06 12:44:32',NULL,NULL),(31555,'34607','S','Weeki Wachee','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.505114,-82.636115,0,'2013-07-06 12:44:32',NULL,NULL),(70670,'85216','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.396902,-111.723184,0,'2013-07-06 12:44:34',NULL,NULL),(37454,'41847','S','Redfox','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.231111,-82.968056,0,'2013-07-06 12:44:32',NULL,NULL),(77566,'96910','S','Hagatna','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(23310,'25204','S','Bandytown','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.940556,-81.640000,0,'2013-07-06 12:44:31',NULL,NULL),(12071,'12546','S','Millerton','D','Dutchess','36027','New York','NY','36','2281','518','Eastern',-5.0,'Y',41.997293,-73.543272,0,'2013-07-06 12:44:30',NULL,NULL),(18292,'19014','S','Twin Oaks','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.862370,-75.434048,0,'2013-07-06 12:44:31',NULL,NULL),(47582,'54850','P','La Pointe','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.937248,-90.579819,0,'2013-07-06 12:44:33',NULL,NULL),(15400,'16335','S','Meadville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.640960,-80.169720,0,'2013-07-06 12:44:31',NULL,NULL),(11752,'12190','S','Wells','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.475882,-74.270426,0,'2013-07-06 12:44:30',NULL,NULL),(78024,'97424','S','Curtin','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.784169,-123.057967,0,'2013-07-06 12:44:34',NULL,NULL),(75697,'94565','S','Port Chicago','N','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.017076,-121.909650,0,'2013-07-06 12:44:34',NULL,NULL),(3856,'02349','U','Ocean Spray','N','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.870977,-70.908380,0,'2013-07-06 12:44:30',NULL,NULL),(17978,'18616','S','Forksville','D','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.515707,-76.596254,0,'2013-07-06 12:44:31',NULL,NULL),(17738,'18301','S','Lehman','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024022,-75.185712,0,'2013-07-06 12:44:31',NULL,NULL),(39450,'44703','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.807231,-81.369181,0,'2013-07-06 12:44:32',NULL,NULL),(30586,'33418','S','Palm Beach Gardens','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855526,-80.144330,0,'2013-07-06 12:44:32',NULL,NULL),(44925,'50336','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.568532,-93.714503,0,'2013-07-06 12:44:32',NULL,NULL),(18497,'19095','S','Wyncote','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.086592,-75.150296,0,'2013-07-06 12:44:31',NULL,NULL),(12390,'12923','S','Churubusco','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.952809,-73.933845,0,'2013-07-06 12:44:30',NULL,NULL),(70045,'84136','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.767474,-111.887633,0,'2013-07-06 12:44:34',NULL,NULL),(14209,'14779','S','Salamanca','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.210897,-78.746912,0,'2013-07-06 12:44:31',NULL,NULL),(2861,'00985','S','Bo Villa Justicia','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(66532,'78722','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.285321,-97.714963,0,'2013-07-06 12:44:34',NULL,NULL),(33358,'37186','S','Westmoreland','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.574864,-86.223555,0,'2013-07-06 12:44:32',NULL,NULL),(74809,'93208','P','Springville','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.137286,-118.611308,0,'2013-07-06 12:44:34',NULL,NULL),(35471,'39506','P','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.389458,-89.057201,0,'2013-07-06 12:44:32',NULL,NULL),(34308,'38549','S','Byrdstown','D','Pickett','47137','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.573617,-85.140037,0,'2013-07-06 12:44:32',NULL,NULL),(73778,'91744','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.028223,-117.937998,0,'2013-07-06 12:44:34',NULL,NULL),(64025,'76120','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.765356,-97.186397,0,'2013-07-06 12:44:34',NULL,NULL),(63754,'75939','S','Pluck','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(48164,'55375','S','Crown College','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.904785,-93.749054,0,'2013-07-06 12:44:33',NULL,NULL),(10205,'10451','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.820195,-73.920218,0,'2013-07-06 12:44:30',NULL,NULL),(10695,'11220','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.642875,-74.015564,0,'2013-07-06 12:44:30',NULL,NULL),(52536,'60928','S','Crescent City','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.770708,-87.856446,0,'2013-07-06 12:44:33',NULL,NULL),(79613,'99113','S','Colton','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.571523,-117.129163,0,'2013-07-06 12:44:34',NULL,NULL),(62906,'75070','S','Mc Kinney','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.169120,-96.691924,0,'2013-07-06 12:44:33',NULL,NULL),(836,'00698','S','Alts del Cafetal','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(30843,'33634','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.008709,-82.553744,0,'2013-07-06 12:44:32',NULL,NULL),(30997,'33769','U','Readers Digest','N','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.968846,-82.803211,0,'2013-07-06 12:44:32',NULL,NULL),(47952,'55118','S','W Saint Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(7308,'06611','S','Trumbull','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.255623,-73.208807,0,'2013-07-06 12:44:30',NULL,NULL),(18790,'19381','P','Gay Street','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.960448,-75.601924,0,'2013-07-06 12:44:31',NULL,NULL),(17464,'17948','S','Mahanoy City','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(16076,'17050','S','Hampden Township','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(72745,'89508','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.630232,-119.870037,0,'2013-07-06 12:44:34',NULL,NULL),(55008,'63131','S','Westwood','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(30432,'33330','S','Cooper City','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(2120,'00924','S','Ciudad Central I','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(69875,'84096','S','Riverton','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569038,-111.966550,0,'2013-07-06 12:44:34',NULL,NULL),(4985,'04116','P','South Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.659977,-70.267197,0,'2013-07-06 12:44:30',NULL,NULL),(7118,'06378','S','Shawondassee','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.344260,-71.911442,0,'2013-07-06 12:44:30',NULL,NULL),(66299,'78586','S','Landrum','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(60879,'72063','S','Robertsville','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.289780,-92.784000,0,'2013-07-06 12:44:33',NULL,NULL),(46556,'53505','S','Avalon','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.687981,-88.810568,0,'2013-07-06 12:44:32',NULL,NULL),(75803,'94801','S','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.942278,-122.355347,0,'2013-07-06 12:44:34',NULL,NULL),(76258,'95409','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.462708,-122.638647,0,'2013-07-06 12:44:34',NULL,NULL),(79227,'98548','S','Hoodsport','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.406850,-123.158638,0,'2013-07-06 12:44:34',NULL,NULL),(12459,'12973','P','Piercefield','D','Saint Lawrence','36089','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.227650,-74.568181,0,'2013-07-06 12:44:30',NULL,NULL),(10942,'11435','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699477,-73.808819,0,'2013-07-06 12:44:30',NULL,NULL),(44159,'49534','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.976900,-85.768900,0,'2013-07-06 12:44:32',NULL,NULL),(305,'00646','S','Urb Molinos Del Rio','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(28839,'32085','P','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.886854,-81.343718,0,'2013-07-06 12:44:32',NULL,NULL),(55250,'63451','S','Leonard','D','Shelby','29205','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.908313,-92.206345,0,'2013-07-06 12:44:33',NULL,NULL),(42218,'47558','S','Glendale','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.623171,-87.044863,0,'2013-07-06 12:44:32',NULL,NULL),(76378,'95524','S','Bayside','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.827899,-124.052999,0,'2013-07-06 12:44:34',NULL,NULL),(770,'00692','S','Urb Santa Ana','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(67596,'80422','S','Blackhawk','N','Gilpin','08047','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.821401,-105.500162,0,'2013-07-06 12:44:34',NULL,NULL),(36044,'40205','S','Seneca Gdns','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(7443,'06850','S','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.128164,-73.441537,0,'2013-07-06 12:44:30',NULL,NULL),(54687,'62943','S','Samoth','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(66712,'78948','S','Loebau','N','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.316524,-96.976370,0,'2013-07-06 12:44:34',NULL,NULL),(39646,'44906','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.764961,-82.565848,0,'2013-07-06 12:44:32',NULL,NULL),(37493,'42025','S','Fairdealing','N','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.877980,-88.333200,0,'2013-07-06 12:44:32',NULL,NULL),(30581,'33416','P','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.664190,-80.090666,0,'2013-07-06 12:44:32',NULL,NULL),(40579,'45872','S','N Baltimore','A','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.189235,-83.669819,0,'2013-07-06 12:44:32',NULL,NULL),(60751,'71973','S','Wickes','D','Polk','05113','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.312438,-94.346936,0,'2013-07-06 12:44:33',NULL,NULL),(44977,'50423','S','Duncan','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.095207,-93.799817,0,'2013-07-06 12:44:32',NULL,NULL),(47421,'54660','S','Wyeville','A','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.994100,-90.459720,0,'2013-07-06 12:44:32',NULL,NULL),(13472,'13787','S','Colesville','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.189300,-75.684780,0,'2013-07-06 12:44:31',NULL,NULL),(43576,'48740','S','Harrisville','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.658699,-83.358493,0,'2013-07-06 12:44:32',NULL,NULL),(33803,'37901','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.029281,-83.886332,0,'2013-07-06 12:44:32',NULL,NULL),(23576,'25661','S','Sprigg','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.673227,-82.277393,0,'2013-07-06 12:44:31',NULL,NULL),(65608,'77905','S','Raisin','A','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.884742,-97.170923,0,'2013-07-06 12:44:34',NULL,NULL),(68036,'80928','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.588656,-104.442148,0,'2013-07-06 12:44:34',NULL,NULL),(73994,'92103','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.749777,-117.168668,0,'2013-07-06 12:44:34',NULL,NULL),(12395,'12926','S','Westville Center','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.947620,-74.337300,0,'2013-07-06 12:44:30',NULL,NULL),(13467,'13784','P','Harford','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.419740,-76.231397,0,'2013-07-06 12:44:31',NULL,NULL),(1956,'00805','P','St Thomas','D','Saint Thomas','78030','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',18.350478,-64.935123,0,'2013-07-06 12:44:30',NULL,NULL),(20431,'20915','P','Wheaton','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.043731,-77.046791,0,'2013-07-06 12:44:31',NULL,NULL),(28843,'32086','S','St Augustine','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.759403,-81.303970,0,'2013-07-06 12:44:32',NULL,NULL),(46080,'52590','S','Seymour','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.681531,-93.120610,0,'2013-07-06 12:44:32',NULL,NULL),(50494,'58058','S','Mantador','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.164440,-96.976254,0,'2013-07-06 12:44:33',NULL,NULL),(70245,'84408','U','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.188154,-111.942473,0,'2013-07-06 12:44:34',NULL,NULL),(49072,'56315','S','Millerville','A','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.966274,-95.593817,0,'2013-07-06 12:44:33',NULL,NULL),(79404,'98812','S','Brewster','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.167400,-119.790720,0,'2013-07-06 12:44:34',NULL,NULL),(76436,'95603','S','Christian Valley','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.921820,-121.098120,0,'2013-07-06 12:44:34',NULL,NULL),(2860,'00985','S','Bo Villa Esperanza','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(21458,'22611','S','Mount Weather','A','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.150938,-77.976972,0,'2013-07-06 12:44:31',NULL,NULL),(41840,'47348','S','Lake Mohee','N','Blackford','18009','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.466400,-85.365120,0,'2013-07-06 12:44:32',NULL,NULL),(22989,'24747','S','Mc Comas','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.389223,-81.233084,0,'2013-07-06 12:44:31',NULL,NULL),(67634,'80452','S','Idaho Springs','D','Clear Creek','08019','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.736355,-105.522767,0,'2013-07-06 12:44:34',NULL,NULL),(66634,'78829','S','Batesville','D','Zavala','48507','Texas','TX','48','0000','830','Central',-6.0,'Y',28.935822,-99.619519,0,'2013-07-06 12:44:34',NULL,NULL),(22586,'24167','S','Staffordsvlle','A','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.245104,-80.766253,0,'2013-07-06 12:44:31',NULL,NULL),(8396,'08062','S','Mullica Hill','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722021,-75.221337,0,'2013-07-06 12:44:30',NULL,NULL),(14146,'14712','S','Bemus Point','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.152037,-79.357012,0,'2013-07-06 12:44:31',NULL,NULL),(25642,'28467','S','Ocean Isl Bch','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.898397,-78.578267,0,'2013-07-06 12:44:31',NULL,NULL),(73305,'90807','S','Bixby Knolls','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.827641,-118.179228,0,'2013-07-06 12:44:34',NULL,NULL),(36037,'40201','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.247047,-85.776597,0,'2013-07-06 12:44:32',NULL,NULL),(78549,'98146','S','Shorewood','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.500943,-122.357500,0,'2013-07-06 12:44:34',NULL,NULL),(78554,'98148','S','Seatac','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.425051,-122.332127,0,'2013-07-06 12:44:34',NULL,NULL),(2833,'00982','S','Alt de Villa Fontana','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(26894,'29572','S','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.762507,-78.798962,0,'2013-07-06 12:44:31',NULL,NULL),(32718,'36303','S','Rehobeth','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.254240,-85.398900,0,'2013-07-06 12:44:32',NULL,NULL),(65300,'77492','P','Katy','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.747025,-95.821656,0,'2013-07-06 12:44:34',NULL,NULL),(39709,'45044','S','Middletown','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.484738,-84.383452,0,'2013-07-06 12:44:32',NULL,NULL),(59245,'70437','S','Uneedus','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.605587,-90.181639,0,'2013-07-06 12:44:33',NULL,NULL),(2374,'00949','S','Toa Baja','D','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(18260,'19004','S','Belmont Hills','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.013801,-75.231706,0,'2013-07-06 12:44:31',NULL,NULL),(34761,'38860','S','Okolona','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.005968,-88.748637,0,'2013-07-06 12:44:32',NULL,NULL),(65464,'77625','S','Honey Island','N','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.313900,-94.284907,0,'2013-07-06 12:44:34',NULL,NULL),(58579,'68833','S','Dunning','D','Blaine','31009','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.787232,-100.060338,0,'2013-07-06 12:44:33',NULL,NULL),(51546,'59731','S','Garrison','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.521788,-112.859419,0,'2013-07-06 12:44:33',NULL,NULL),(71723,'87532','S','Espanola','D','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(77184,'96322','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(79060,'98422','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293639,-122.392048,0,'2013-07-06 12:44:34',NULL,NULL),(79671,'99163','S','Pullman','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.765515,-117.191900,0,'2013-07-06 12:44:34',NULL,NULL),(946,'00716','S','Ext Alhambra','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(65204,'77435','S','Chesterville','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.527948,-96.061715,0,'2013-07-06 12:44:34',NULL,NULL),(2601,'00961','S','Urb Rio Hondo 3','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(60164,'71405','S','Pollock','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.415594,-92.405924,0,'2013-07-06 12:44:33',NULL,NULL),(15042,'15705','U','Indiana','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.616606,-79.153926,0,'2013-07-06 12:44:31',NULL,NULL),(45999,'52531','S','Albia','D','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.086920,-92.728800,0,'2013-07-06 12:44:32',NULL,NULL),(38752,'44035','S','Sheffield Village','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(13482,'13795','S','Langdon','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.067223,-75.796242,0,'2013-07-06 12:44:31',NULL,NULL),(48748,'55971','S','Rushford Vlg','A','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.797936,-91.757171,0,'2013-07-06 12:44:33',NULL,NULL),(35853,'39823','S','Blakely','D','Early','13099','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.376097,-84.934063,0,'2013-07-06 12:44:32',NULL,NULL),(55356,'63560','S','Pollock','D','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.343020,-93.123704,0,'2013-07-06 12:44:33',NULL,NULL),(59679,'71066','P','Powhatan','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.844948,-93.168138,0,'2013-07-06 12:44:33',NULL,NULL),(58332,'68456','S','Utica','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.896389,-97.346355,0,'2013-07-06 12:44:33',NULL,NULL),(44787,'50220','S','Perry','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.840572,-94.098673,0,'2013-07-06 12:44:32',NULL,NULL),(44729,'50156','S','Zook Spur','N','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.875552,-93.819402,0,'2013-07-06 12:44:32',NULL,NULL),(75248,'93657','S','Minkler','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.784020,-119.468700,0,'2013-07-06 12:44:34',NULL,NULL),(74309,'92384','P','Shoshone','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.188188,-116.410849,0,'2013-07-06 12:44:34',NULL,NULL),(3342,'01545','S','Shrewsbury','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.286758,-71.721540,0,'2013-07-06 12:44:30',NULL,NULL),(49762,'57068','S','Ben Claire','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.582880,-96.464847,0,'2013-07-06 12:44:33',NULL,NULL),(26180,'28755','P','Micaville','D','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.906336,-82.215416,0,'2013-07-06 12:44:31',NULL,NULL),(68179,'81019','P','Colorado City','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',37.943546,-104.846617,0,'2013-07-06 12:44:34',NULL,NULL),(27699,'30339','S','Overlook Sru','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(38507,'43713','S','Barnesville','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.976140,-81.165000,0,'2013-07-06 12:44:32',NULL,NULL),(11892,'12345','U','General Electric','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.815656,-73.942324,0,'2013-07-06 12:44:30',NULL,NULL),(9543,'10021','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(58694,'68927','S','Westmark','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.526584,-99.632651,0,'2013-07-06 12:44:33',NULL,NULL),(50691,'58352','S','Munich','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.655800,-98.850720,0,'2013-07-06 12:44:33',NULL,NULL),(8202,'07933','S','Gillette','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.709787,-74.468550,0,'2013-07-06 12:44:30',NULL,NULL),(8993,'08840','S','Metuchen','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.542350,-74.356832,0,'2013-07-06 12:44:30',NULL,NULL),(16513,'17267','S','Amaranth','N','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.776683,-78.204091,0,'2013-07-06 12:44:31',NULL,NULL),(76113,'95233','P','Hathaway Pines','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.185926,-120.372735,0,'2013-07-06 12:44:34',NULL,NULL),(10083,'10199','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(64408,'76544','S','Killeen','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(24636,'27371','S','Moratock','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(35342,'39437','S','Pecan Grove','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(20357,'20872','S','Damascus','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.281394,-77.216305,0,'2013-07-06 12:44:31',NULL,NULL),(71142,'86029','P','Holbrook','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.980645,-110.057212,0,'2013-07-06 12:44:34',NULL,NULL),(74996,'93451','S','Parkfield','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.750880,-120.636780,0,'2013-07-06 12:44:34',NULL,NULL),(22788,'24460','S','Millboro','D','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.020620,-79.650900,0,'2013-07-06 12:44:31',NULL,NULL),(61310,'72433','S','Hoxie','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.047283,-90.973982,0,'2013-07-06 12:44:33',NULL,NULL),(74945,'93410','S','Cal Poly Student Dorms','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.276728,-120.737489,0,'2013-07-06 12:44:34',NULL,NULL),(67743,'80603','S','Brighton','D','Weld','08123','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.991590,-104.696847,0,'2013-07-06 12:44:34',NULL,NULL),(16080,'17050','S','Mechancsbrg','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(11761,'12196','S','West Sand Lake','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.627847,-73.632094,0,'2013-07-06 12:44:30',NULL,NULL),(12592,'13074','S','Hannibal','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.285920,-76.532580,0,'2013-07-06 12:44:30',NULL,NULL),(9769,'10104','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(7001,'06254','S','N Franklin','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.618872,-72.143072,0,'2013-07-06 12:44:30',NULL,NULL),(58399,'68631','S','Creston','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.656578,-97.367518,0,'2013-07-06 12:44:33',NULL,NULL),(58278,'68405','S','Grover','N','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.775066,-97.054666,0,'2013-07-06 12:44:33',NULL,NULL),(55169,'63368','S','Dardenne Pr','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.757000,-90.724700,0,'2013-07-06 12:44:33',NULL,NULL),(36563,'40930','P','Dewitt','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.870963,-83.729048,0,'2013-07-06 12:44:32',NULL,NULL),(20244,'20781','S','Rogers Heights','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.940840,-76.928280,0,'2013-07-06 12:44:31',NULL,NULL),(3066,'01119','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122853,-72.506417,0,'2013-07-06 12:44:30',NULL,NULL),(57166,'66283','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861823,-94.670864,0,'2013-07-06 12:44:33',NULL,NULL),(5760,'05041','S','East Randolph','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.973889,-72.556389,0,'2013-07-06 12:44:30',NULL,NULL),(58846,'69133','S','Dix','D','Kimball','31105','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.200815,-103.468834,0,'2013-07-06 12:44:33',NULL,NULL),(1782,'00782','S','Urb Pasarell','N','Comerio','72045','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.221934,-66.227220,0,'2013-07-06 12:44:30',NULL,NULL),(47883,'55092','S','East Bethel','A','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.329640,-93.074700,0,'2013-07-06 12:44:33',NULL,NULL),(27850,'30434','S','Rosier','N','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.000236,-82.407759,0,'2013-07-06 12:44:31',NULL,NULL),(28325,'31146','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.925442,-84.341206,0,'2013-07-06 12:44:31',NULL,NULL),(25305,'28150','S','Kingstown','A','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.304225,-81.551791,0,'2013-07-06 12:44:31',NULL,NULL),(69088,'83252','S','Malad City','D','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(77283,'96619','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(31406,'34233','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.281597,-82.473386,0,'2013-07-06 12:44:32',NULL,NULL),(59039,'70084','S','Reserve','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.069968,-90.557182,0,'2013-07-06 12:44:33',NULL,NULL),(76380,'95526','S','Bridgeville','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.467480,-123.693420,0,'2013-07-06 12:44:34',NULL,NULL),(1560,'00766','S','Portales del Alba','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(15122,'15822','S','Brandy Camp','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.318909,-78.687360,0,'2013-07-06 12:44:31',NULL,NULL),(42461,'47834','S','Alma Lake','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(50491,'58054','S','Lisbon','D','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.415340,-97.653120,0,'2013-07-06 12:44:33',NULL,NULL),(78247,'97830','S','Fossil','D','Wheeler','41069','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.998369,-120.212626,0,'2013-07-06 12:44:34',NULL,NULL),(30442,'33331','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(78147,'97601','S','Kfalls','N','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.221688,-121.796627,0,'2013-07-06 12:44:34',NULL,NULL),(2722,'00969','S','Urb Baldwin Park','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(21132,'22102','S','Tysons','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.955820,-77.234785,0,'2013-07-06 12:44:31',NULL,NULL),(2320,'00930','P','Rio Piedras','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405329,-66.062376,0,'2013-07-06 12:44:30',NULL,NULL),(49548,'56686','S','Williams','D','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.977222,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(37151,'41465','S','Marshallville','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(40842,'46219','S','Warren Park','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.780423,-86.044659,0,'2013-07-06 12:44:32',NULL,NULL),(79345,'98626','S','Kelso','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.144760,-122.880170,0,'2013-07-06 12:44:34',NULL,NULL),(18231,'18970','P','Trumbaursvlle','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.410255,-75.378287,0,'2013-07-06 12:44:31',NULL,NULL),(7449,'06854','S','South Norwalk','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.091966,-73.433011,0,'2013-07-06 12:44:30',NULL,NULL),(37069,'41314','S','Booneville','D','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(31333,'34136','P','Bonita Spgs','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.387994,-81.709518,0,'2013-07-06 12:44:32',NULL,NULL),(40526,'45830','S','Columbus Grove','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.872082,-84.028336,0,'2013-07-06 12:44:32',NULL,NULL),(11646,'12125','S','New Lebanon Center','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.483586,-73.377729,0,'2013-07-06 12:44:30',NULL,NULL),(6430,'05743','S','West Castleton','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(43925,'49269','S','Parma','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.279435,-84.584670,0,'2013-07-06 12:44:32',NULL,NULL),(16908,'17601','S','Fruitville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.061400,-76.322040,0,'2013-07-06 12:44:31',NULL,NULL),(21014,'21843','P','Ocean City','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.338025,-75.083974,0,'2013-07-06 12:44:31',NULL,NULL),(59059,'70092','S','Hi Land','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.915069,-89.862837,0,'2013-07-06 12:44:33',NULL,NULL),(55833,'64153','S','Weatherby Lake','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.273370,-94.691489,0,'2013-07-06 12:44:33',NULL,NULL),(51891,'60096','S','Winthrop Hbr','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.478195,-87.831505,0,'2013-07-06 12:44:33',NULL,NULL),(51764,'60030','S','Volo','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(48154,'55372','S','Prior Lake','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.683929,-93.399760,0,'2013-07-06 12:44:33',NULL,NULL),(44487,'49913','S','Calumet','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.241904,-88.450576,0,'2013-07-06 12:44:32',NULL,NULL),(32985,'36615','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.628884,-88.072632,0,'2013-07-06 12:44:32',NULL,NULL),(73409,'91129','U','Ambassador I C Foundation','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.141146,-118.156851,0,'2013-07-06 12:44:34',NULL,NULL),(37056,'41301','S','Mary','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(17934,'18473','P','White Mills','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.528258,-75.202276,0,'2013-07-06 12:44:31',NULL,NULL),(32009,'35231','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.565231,-86.892763,0,'2013-07-06 12:44:32',NULL,NULL),(70232,'84404','S','Pleasant View','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(78841,'98335','S','Wollochet','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(63109,'75283','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768227,-96.830324,0,'2013-07-06 12:44:33',NULL,NULL),(35348,'39440','S','Calhoun','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(18651,'19172','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.945336,-75.151079,0,'2013-07-06 12:44:31',NULL,NULL),(23674,'25839','S','Fairdale','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.788127,-81.389816,0,'2013-07-06 12:44:31',NULL,NULL),(59454,'70728','P','Duplessis','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.272768,-90.943938,0,'2013-07-06 12:44:33',NULL,NULL),(55133,'63349','S','Hawk Point','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.973280,-91.137883,0,'2013-07-06 12:44:33',NULL,NULL),(23584,'25670','S','Stirrat','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.726001,-82.126879,0,'2013-07-06 12:44:31',NULL,NULL),(52867,'61335','S','Mc Nabb','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.177164,-89.208757,0,'2013-07-06 12:44:33',NULL,NULL),(52674,'61075','S','Scalesmound','N','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.466454,-90.253838,0,'2013-07-06 12:44:33',NULL,NULL),(52474,'60687','U','Peoples Gas and Light','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.878579,-87.625823,0,'2013-07-06 12:44:33',NULL,NULL),(46948,'54169','S','Sherwood','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.174879,-88.258610,0,'2013-07-06 12:44:32',NULL,NULL),(46001,'52531','S','Georgetown','N','Monroe','19135','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.086920,-92.728800,0,'2013-07-06 12:44:32',NULL,NULL),(44781,'50216','S','Lake Panorama','N','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.692194,-94.362644,0,'2013-07-06 12:44:32',NULL,NULL),(20314,'20824','P','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.984119,-77.092723,0,'2013-07-06 12:44:31',NULL,NULL),(2823,'00979','S','Urb Biascochea','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(33704,'37765','S','Kyles Ford','D','Hancock','47067','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.564311,-83.048671,0,'2013-07-06 12:44:32',NULL,NULL),(3986,'02536','S','East Falmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(70435,'84738','S','Ivins','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.167800,-113.667546,0,'2013-07-06 12:44:34',NULL,NULL),(22758,'24426','S','Covington','D','Covington City','51580','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.751640,-80.045760,0,'2013-07-06 12:44:31',NULL,NULL),(9547,'10022','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756416,-73.970295,0,'2013-07-06 12:44:30',NULL,NULL),(27052,'29676','S','Salem','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.838477,-82.930726,0,'2013-07-06 12:44:31',NULL,NULL),(35345,'39439','S','Heidelberg','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.897396,-89.002726,0,'2013-07-06 12:44:32',NULL,NULL),(2672,'00966','S','Urb Victor Braeger','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(77032,'96103','S','Blrsdn-Greagl','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(21015,'21849','S','Parsonsburg','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.379302,-75.492423,0,'2013-07-06 12:44:31',NULL,NULL),(35140,'39217','U','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.288941,-90.186095,0,'2013-07-06 12:44:32',NULL,NULL),(49844,'57234','S','Dempster','A','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.622353,-96.958682,0,'2013-07-06 12:44:33',NULL,NULL),(43217,'48308','P','Rochester Hills','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.678404,-83.134101,0,'2013-07-06 12:44:32',NULL,NULL),(67173,'79842','P','Marathon','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',30.125699,-103.140048,0,'2013-07-06 12:44:34',NULL,NULL),(2836,'00982','S','Qtas de Country Club','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(79416,'98821','P','Dryden','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.542879,-120.558920,0,'2013-07-06 12:44:34',NULL,NULL),(58476,'68746','S','Lynch','D','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.859206,-98.439970,0,'2013-07-06 12:44:33',NULL,NULL),(59338,'70544','S','Jeanerette','D','Iberia','22045','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.916877,-91.674463,0,'2013-07-06 12:44:33',NULL,NULL),(49038,'56283','S','Redwood Falls','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.540219,-95.111345,0,'2013-07-06 12:44:33',NULL,NULL),(66685,'78941','S','Floy','N','Fayette','48149','Texas','TX','48','0000','361','Central',-6.0,'Y',29.687084,-97.108065,0,'2013-07-06 12:44:34',NULL,NULL),(61250,'72350','S','Joiner','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.513409,-90.145986,0,'2013-07-06 12:44:33',NULL,NULL),(60589,'71831','S','Columbus','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.751594,-93.821408,0,'2013-07-06 12:44:33',NULL,NULL),(1901,'00795','S','Brisas del Sur','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(5358,'04622','S','Cherryfield','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.601113,-67.926225,0,'2013-07-06 12:44:30',NULL,NULL),(50889,'58535','S','Flasher','D','Morton','38059','North Dakota','ND','38','1010','701','Mountain',-7.0,'Y',46.466520,-101.178960,0,'2013-07-06 12:44:33',NULL,NULL),(4413,'03226','S','Center Harbor','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715187,-71.492553,0,'2013-07-06 12:44:30',NULL,NULL),(58706,'68932','S','North Franklin','N','Franklin','31061','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.298761,-98.729244,0,'2013-07-06 12:44:33',NULL,NULL),(28075,'30724','P','Eton','D','Murray','13213','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.822161,-84.761831,0,'2013-07-06 12:44:31',NULL,NULL),(45137,'50577','S','Renwick','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.827927,-93.980188,0,'2013-07-06 12:44:32',NULL,NULL),(38030,'43023','S','Granville','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.069498,-82.526879,0,'2013-07-06 12:44:32',NULL,NULL),(70093,'84165','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.714872,-111.892415,0,'2013-07-06 12:44:34',NULL,NULL),(5821,'05075','S','Rices Mills','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.823651,-72.272568,0,'2013-07-06 12:44:30',NULL,NULL),(31015,'33782','S','Pinellas Park','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.855702,-82.706232,0,'2013-07-06 12:44:32',NULL,NULL),(41152,'46701','S','High Lake','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.395396,-85.422456,0,'2013-07-06 12:44:32',NULL,NULL),(79272,'98571','P','Pacific Beach','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.201111,-124.166667,0,'2013-07-06 12:44:34',NULL,NULL),(49972,'57355','S','Kimball','D','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.716989,-98.934980,0,'2013-07-06 12:44:33',NULL,NULL),(47473,'54742','S','Brackett','N','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.754625,-91.331294,0,'2013-07-06 12:44:32',NULL,NULL),(74291,'92365','S','Newberry Springs','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.873491,-116.656202,0,'2013-07-06 12:44:34',NULL,NULL),(79326,'98606','S','Brush Prairie','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.735779,-122.475516,0,'2013-07-06 12:44:34',NULL,NULL),(69054,'83230','S','Henry','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.732720,-111.533520,0,'2013-07-06 12:44:34',NULL,NULL),(21633,'22910','U','Embarq','N','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.021668,-78.598714,0,'2013-07-06 12:44:31',NULL,NULL),(53026,'61471','P','Raritan','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.678942,-90.847713,0,'2013-07-06 12:44:33',NULL,NULL),(72340,'89015','S','Calico Ridge','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.060266,-114.956815,0,'2013-07-06 12:44:34',NULL,NULL),(79735,'99217','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.659332,-117.424425,0,'2013-07-06 12:44:34',NULL,NULL),(69472,'83660','S','Apple Valley','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.774723,-116.935468,0,'2013-07-06 12:44:34',NULL,NULL),(46631,'53585','S','Sharon','D','Walworth','55127','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',42.506463,-88.727832,0,'2013-07-06 12:44:32',NULL,NULL),(14629,'15232','S','Shadyside','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.451373,-79.932761,0,'2013-07-06 12:44:31',NULL,NULL),(37786,'42364','P','Pellville','D','Hancock','21091','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.752441,-86.814795,0,'2013-07-06 12:44:32',NULL,NULL),(47466,'54736','S','Durand','D','Pepin','55091','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.628057,-91.961960,0,'2013-07-06 12:44:32',NULL,NULL),(14672,'15241','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.357620,-80.059980,0,'2013-07-06 12:44:31',NULL,NULL),(9771,'10105','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(30937,'33714','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.819947,-82.679529,0,'2013-07-06 12:44:32',NULL,NULL),(33162,'37019','S','Belfast','D','Marshall','47117','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.517599,-86.808808,0,'2013-07-06 12:44:32',NULL,NULL),(56216,'65036','P','Gasconade','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.672778,-91.636111,0,'2013-07-06 12:44:33',NULL,NULL),(61019,'72116','S','N Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(55141,'63359','S','New Hartford','A','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.093735,-91.367918,0,'2013-07-06 12:44:33',NULL,NULL),(25126,'28001','S','South Albemarle','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(13817,'14214','S','University Buffalo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.941449,-78.836451,0,'2013-07-06 12:44:31',NULL,NULL),(36918,'41144','S','Greenup','D','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.572275,-82.812737,0,'2013-07-06 12:44:32',NULL,NULL),(54104,'62540','P','Kincaid','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.586052,-89.414602,0,'2013-07-06 12:44:33',NULL,NULL),(14581,'15220','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.425951,-80.048689,0,'2013-07-06 12:44:31',NULL,NULL),(20318,'20827','P','W Bethesda','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.013715,-77.158738,0,'2013-07-06 12:44:31',NULL,NULL),(44100,'49501','P','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.964920,-85.658539,0,'2013-07-06 12:44:32',NULL,NULL),(55740,'64089','S','Smithville','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.398160,-94.539780,0,'2013-07-06 12:44:33',NULL,NULL),(73717,'91614','P','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.393815,0,'2013-07-06 12:44:34',NULL,NULL),(68584,'81521','S','Fruita','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.165497,-108.720895,0,'2013-07-06 12:44:34',NULL,NULL),(59278,'70461','S','Slidell','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.268846,-89.678399,0,'2013-07-06 12:44:33',NULL,NULL),(58881,'69162','S','Brownson','N','Cheyenne','31033','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.131320,-103.031580,0,'2013-07-06 12:44:33',NULL,NULL),(49363,'56583','S','Charlesville','N','Traverse','27155','Minnesota','MN','27','0000','218','Central',-6.0,'Y',45.986280,-96.405780,0,'2013-07-06 12:44:33',NULL,NULL),(42601,'47885','S','Shirkleville','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(38607,'43845','S','West Lafayette','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.269968,-81.735623,0,'2013-07-06 12:44:32',NULL,NULL),(20268,'20785','S','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(12634,'13101','S','McGraw','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.597772,-76.078518,0,'2013-07-06 12:44:30',NULL,NULL),(16350,'17177','U','Blue Cross','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.290362,-76.812588,0,'2013-07-06 12:44:31',NULL,NULL),(31104,'33883','P','Winter Hvn','N','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.023165,-81.726968,0,'2013-07-06 12:44:32',NULL,NULL),(23029,'24845','P','Ikes Fork','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.540509,-81.795247,0,'2013-07-06 12:44:31',NULL,NULL),(21603,'22851','S','Stanley','D','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.547769,-78.496558,0,'2013-07-06 12:44:31',NULL,NULL),(47194,'54486','S','Whitcomb','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.743866,-89.041687,0,'2013-07-06 12:44:32',NULL,NULL),(47102,'54443','S','Carson','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.604785,-89.748588,0,'2013-07-06 12:44:32',NULL,NULL),(43831,'49088','S','Scotts','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.186704,-85.421776,0,'2013-07-06 12:44:32',NULL,NULL),(16871,'17566','S','Quarryville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.879899,-76.148321,0,'2013-07-06 12:44:31',NULL,NULL),(21745,'23035','S','Cobbs Creek','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.505520,-76.397220,0,'2013-07-06 12:44:31',NULL,NULL),(30505,'33403','S','N Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(10563,'11004','S','Floral Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747846,-73.710498,0,'2013-07-06 12:44:30',NULL,NULL),(30842,'33633','U','Tampa Brm Unique','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.977884,-82.487078,0,'2013-07-06 12:44:32',NULL,NULL),(2082,'00921','S','Urb Las Americas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(77510,'96838','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.348058,-157.876862,0,'2013-07-06 12:44:34',NULL,NULL),(61447,'72613','P','Beaver','D','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.386420,-93.617629,0,'2013-07-06 12:44:33',NULL,NULL),(56569,'65483','S','Houston','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.323082,-91.964295,0,'2013-07-06 12:44:33',NULL,NULL),(47307,'54552','S','Springstead','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(33329,'37149','S','Readyville','D','Cannon','47015','Tennessee','TN','47','0000','615','Central',-6.0,'Y',35.824986,-86.217289,0,'2013-07-06 12:44:32',NULL,NULL),(10290,'10520','S','Croton Hudson','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.216760,-73.896720,0,'2013-07-06 12:44:30',NULL,NULL),(28226,'31038','S','Hillsboro','D','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.174782,-83.709904,0,'2013-07-06 12:44:31',NULL,NULL),(28045,'30660','S','Rayle','D','Wilkes','13317','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.724162,-82.762010,0,'2013-07-06 12:44:31',NULL,NULL),(18921,'19495','U','Valley Forge','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.054002,-75.557455,0,'2013-07-06 12:44:31',NULL,NULL),(36849,'41076','S','Cold Spring','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(40960,'46311','S','Dyer','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.487320,-87.508227,0,'2013-07-06 12:44:32',NULL,NULL),(47118,'54451','S','Esadore Lake','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(79950,'99629','P','Meadow Lake','N','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593474,-149.414543,0,'2013-07-06 12:44:34',NULL,NULL),(75280,'93712','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.610955,-119.773998,0,'2013-07-06 12:44:34',NULL,NULL),(74381,'92507','S','Box Springs','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.976325,-117.330414,0,'2013-07-06 12:44:34',NULL,NULL),(68439,'81225','P','Crested Butte','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(67372,'80117','S','Kiowa','D','Elbert','08039','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.328704,-104.451470,0,'2013-07-06 12:44:34',NULL,NULL),(52540,'60932','P','East Lynn','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.217614,-87.594217,0,'2013-07-06 12:44:33',NULL,NULL),(48782,'55991','S','Hammond','A','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.224920,-92.434140,0,'2013-07-06 12:44:33',NULL,NULL),(48533,'55751','S','Iron','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.403605,-92.653616,0,'2013-07-06 12:44:33',NULL,NULL),(29581,'32821','S','Bay Lake','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.379055,-81.467846,0,'2013-07-06 12:44:32',NULL,NULL),(7510,'06928','U','International Masters Pub','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.038894,-73.556427,0,'2013-07-06 12:44:30',NULL,NULL),(10442,'10914','P','S Bloomng Grv','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.382548,-74.179202,0,'2013-07-06 12:44:30',NULL,NULL),(70225,'84404','S','Marriott-Slaterville City','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(65533,'77801','S','Steep Hollow','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(58007,'67868','S','Garden City','A','Finney','20055','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.832760,-100.695287,0,'2013-07-06 12:44:33',NULL,NULL),(15613,'16683','S','Spruce Creek','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.615408,-78.138082,0,'2013-07-06 12:44:31',NULL,NULL),(4500,'03285','S','Thornton','D','Grafton','33009','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.877218,-71.676330,0,'2013-07-06 12:44:30',NULL,NULL),(28979,'32211','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.329252,-81.579613,0,'2013-07-06 12:44:32',NULL,NULL),(73048,'90086','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.066364,-118.239719,0,'2013-07-06 12:44:34',NULL,NULL),(55077,'63182','U','IBSSC Acs Asc','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.630539,-90.203178,0,'2013-07-06 12:44:33',NULL,NULL),(54217,'62650','S','Arcadia','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(78884,'98357','P','Tatoosh Is','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.369349,-124.626924,0,'2013-07-06 12:44:34',NULL,NULL),(44194,'49617','S','Beulah','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.644459,-86.055187,0,'2013-07-06 12:44:32',NULL,NULL),(35975,'40109','S','Brooks','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.056143,-85.733400,0,'2013-07-06 12:44:32',NULL,NULL),(18091,'18707','S','Nuangola','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.144606,-75.925343,0,'2013-07-06 12:44:31',NULL,NULL),(29645,'32902','P','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.994380,-80.646933,0,'2013-07-06 12:44:32',NULL,NULL),(37580,'42086','S','Heath','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.087107,-88.767014,0,'2013-07-06 12:44:32',NULL,NULL),(37891,'42602','S','Static','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(37965,'42724','S','Cecilia','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.671855,-86.025831,0,'2013-07-06 12:44:32',NULL,NULL),(38058,'43055','S','Marne','N','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.116667,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(42089,'47459','S','Newark','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.123646,-86.753712,0,'2013-07-06 12:44:32',NULL,NULL),(37356,'41722','S','Hardburly','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.300000,-83.166667,0,'2013-07-06 12:44:32',NULL,NULL),(37351,'41719','S','Butterfly','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.309817,-83.218287,0,'2013-07-06 12:44:32',NULL,NULL),(15503,'16508','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.097111,-80.094070,0,'2013-07-06 12:44:31',NULL,NULL),(24821,'27605','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.790341,-78.653956,0,'2013-07-06 12:44:31',NULL,NULL),(29178,'32360','P','Telogia','D','Liberty','12077','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.349304,-84.818526,0,'2013-07-06 12:44:32',NULL,NULL),(77959,'97366','S','Newport','A','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.553071,-124.041750,0,'2013-07-06 12:44:34',NULL,NULL),(76641,'95720','S','Kyburz','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.757517,-120.199076,0,'2013-07-06 12:44:34',NULL,NULL),(65169,'77412','P','Altair','D','Colorado','48089','Texas','TX','48','0000','979','Central',-6.0,'Y',29.640974,-96.510571,0,'2013-07-06 12:44:34',NULL,NULL),(62353,'74062','S','Ripley','D','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.984342,-96.889919,0,'2013-07-06 12:44:33',NULL,NULL),(59183,'70355','S','Gheens','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.707466,-90.487840,0,'2013-07-06 12:44:33',NULL,NULL),(33361,'37189','S','Whites Creek','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.272962,-86.831533,0,'2013-07-06 12:44:32',NULL,NULL),(25806,'28607','S','Hodges Gap','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(1571,'00767','S','Jard de Yabucoa','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(17443,'17935','S','Preston Hill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.790036,-76.280325,0,'2013-07-06 12:44:31',NULL,NULL),(45988,'52499','U','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.974943,-91.655103,0,'2013-07-06 12:44:32',NULL,NULL),(49081,'56325','P','Elrosa','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.562811,-94.945219,0,'2013-07-06 12:44:33',NULL,NULL),(50536,'58121','U','Blue Cross','N','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.865114,-96.861885,0,'2013-07-06 12:44:33',NULL,NULL),(8150,'07848','S','Lafayette','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.094554,-74.696522,0,'2013-07-06 12:44:30',NULL,NULL),(54803,'63017','S','Clarkson Valley','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.647818,-90.545814,0,'2013-07-06 12:44:33',NULL,NULL),(52483,'60694','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.877882,-87.629688,0,'2013-07-06 12:44:33',NULL,NULL),(50864,'58504','S','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.760820,-100.699380,0,'2013-07-06 12:44:33',NULL,NULL),(47737,'55012','S','Center City','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.396474,-92.816791,0,'2013-07-06 12:44:33',NULL,NULL),(16996,'17728','S','Quiggleville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(38907,'44118','S','East Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(39142,'44278','S','Tallmadge','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.095652,-81.429879,0,'2013-07-06 12:44:32',NULL,NULL),(5676,'04966','S','Avon','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.843444,-70.376629,0,'2013-07-06 12:44:30',NULL,NULL),(80021,'99683','P','Trapper Creek','D','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.367280,-150.616620,0,'2013-07-06 12:44:34',NULL,NULL),(72895,'90018','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.030481,-118.318046,0,'2013-07-06 12:44:34',NULL,NULL),(68072,'80936','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.906063,-104.753199,0,'2013-07-06 12:44:34',NULL,NULL),(27471,'30144','S','Kennesaw','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.034049,-84.584675,0,'2013-07-06 12:44:31',NULL,NULL),(19907,'20546','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.883971,-76.989253,0,'2013-07-06 12:44:31',NULL,NULL),(9394,'09859','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(49333,'56560','S','Moorhead','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.890120,-96.744720,0,'2013-07-06 12:44:33',NULL,NULL),(56250,'65055','P','Mc Girk','D','Moniteau','29135','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.627659,-92.566101,0,'2013-07-06 12:44:33',NULL,NULL),(65346,'77520','S','Old Rvr-Wnfre','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(6852,'06127','P','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766715,-72.682282,0,'2013-07-06 12:44:30',NULL,NULL),(78765,'98305','S','Sappho','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.063480,-124.296000,0,'2013-07-06 12:44:34',NULL,NULL),(71025,'85734','P','Mission','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.114902,-110.894300,0,'2013-07-06 12:44:34',NULL,NULL),(56311,'65101','S','Schubert','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(40352,'45629','S','Frankln Frnce','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.657779,-82.807843,0,'2013-07-06 12:44:32',NULL,NULL),(16037,'17044','S','Hawstone','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(34820,'38914','S','Big Creek','D','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.867342,-89.457753,0,'2013-07-06 12:44:32',NULL,NULL),(17198,'17821','S','Mahoning','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(18146,'18840','S','Sayre','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.983124,-76.530623,0,'2013-07-06 12:44:31',NULL,NULL),(19745,'20408','U','Natl Archives and Records','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.893730,-77.021451,0,'2013-07-06 12:44:31',NULL,NULL),(20614,'21209','S','Mt Washington','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.370500,-76.694460,0,'2013-07-06 12:44:31',NULL,NULL),(22725,'24361','S','Meadowview','D','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.766293,-81.855650,0,'2013-07-06 12:44:31',NULL,NULL),(41597,'47108','S','Campbellsburg','D','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.650000,-86.260000,0,'2013-07-06 12:44:32',NULL,NULL),(50045,'57434','S','Crandall','N','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.165262,-98.015514,0,'2013-07-06 12:44:33',NULL,NULL),(992,'00717','S','Bo Caracoles','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(76451,'95609','P','Carmichael','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.625313,-121.327420,0,'2013-07-06 12:44:34',NULL,NULL),(61497,'72645','S','Flag','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.826780,-92.575020,0,'2013-07-06 12:44:33',NULL,NULL),(10582,'11021','S','Thomaston','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(12033,'12520','S','Cornwall Hud','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.442299,-74.015486,0,'2013-07-06 12:44:30',NULL,NULL),(72982,'90051','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062744,-118.243140,0,'2013-07-06 12:44:34',NULL,NULL),(63487,'75693','S','White Oak','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.540043,-94.857003,0,'2013-07-06 12:44:33',NULL,NULL),(48997,'56240','S','Graceville','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.568603,-96.436884,0,'2013-07-06 12:44:33',NULL,NULL),(37586,'42101','S','Bowling Green','D','Warren','21227','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.018172,-86.458733,0,'2013-07-06 12:44:32',NULL,NULL),(21961,'23237','S','N Chesterfld','A','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.400976,-77.461897,0,'2013-07-06 12:44:31',NULL,NULL),(23977,'26302','P','Clarksburg','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.266363,-80.309665,0,'2013-07-06 12:44:31',NULL,NULL),(22563,'24149','S','Fairview','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.026300,-80.435280,0,'2013-07-06 12:44:31',NULL,NULL),(14134,'14692','P','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.084621,-77.598456,0,'2013-07-06 12:44:31',NULL,NULL),(350,'00656','S','Urb Santa Elena 2','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(67091,'79699','U','Abilene Christian Univ','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.470981,-99.707622,0,'2013-07-06 12:44:34',NULL,NULL),(54080,'62518','S','Chestnut','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.064221,-89.196549,0,'2013-07-06 12:44:33',NULL,NULL),(37782,'42354','S','McHenry','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.382786,-86.925555,0,'2013-07-06 12:44:32',NULL,NULL),(20982,'21804','S','Salisbury','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.355713,-75.537711,0,'2013-07-06 12:44:31',NULL,NULL),(25573,'28431','S','Chadbourn','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.323716,-78.823898,0,'2013-07-06 12:44:31',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (5916,'05250','S','Sunderland','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(24409,'27111','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098893,-80.243891,0,'2013-07-06 12:44:31',NULL,NULL),(5174,'04431','P','East Orland','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.586683,-68.663947,0,'2013-07-06 12:44:30',NULL,NULL),(71207,'86305','S','Iron Springs','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.542870,-112.468447,0,'2013-07-06 12:44:34',NULL,NULL),(66632,'78828','S','Barksdale','D','Edwards','48137','Texas','TX','48','0000','830','Central',-6.0,'Y',29.736480,-100.103400,0,'2013-07-06 12:44:34',NULL,NULL),(64205,'76258','S','Pilot Point','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.384159,-96.947915,0,'2013-07-06 12:44:34',NULL,NULL),(53080,'61523','S','Vets Row','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(45655,'52001','S','Sageville','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(18408,'19055','S','Levittown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.146863,-74.839128,0,'2013-07-06 12:44:31',NULL,NULL),(1436,'00739','S','Urb Campo Primavera','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(76334,'95465','S','Occidental','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.401354,-122.965484,0,'2013-07-06 12:44:34',NULL,NULL),(73526,'91350','S','Agua Dulce','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.485022,-118.428020,0,'2013-07-06 12:44:34',NULL,NULL),(64909,'77095','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.906371,-95.655232,0,'2013-07-06 12:44:34',NULL,NULL),(29125,'32316','P','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.445560,-84.327868,0,'2013-07-06 12:44:32',NULL,NULL),(2277,'00926','S','Urb Senderos En Montehiedra','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(26239,'28814','P','Grace Sta','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.623680,-82.554480,0,'2013-07-06 12:44:31',NULL,NULL),(21389,'22503','S','Millenbeck','N','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.763511,-76.498306,0,'2013-07-06 12:44:31',NULL,NULL),(54667,'62938','S','Golconda','D','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.357533,-88.488804,0,'2013-07-06 12:44:33',NULL,NULL),(57826,'67529','S','Garfield','D','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.076590,-99.244220,0,'2013-07-06 12:44:33',NULL,NULL),(58292,'68416','S','Ohiowa','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.410905,-97.452822,0,'2013-07-06 12:44:33',NULL,NULL),(480,'00667','S','Parq Real','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(74711,'93012','S','Santa Rosa Va','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.224457,-118.978052,0,'2013-07-06 12:44:34',NULL,NULL),(51980,'60152','S','Coral','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.233492,-88.630366,0,'2013-07-06 12:44:33',NULL,NULL),(50079,'57454','S','Langford','D','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.629492,-97.729855,0,'2013-07-06 12:44:33',NULL,NULL),(46993,'54235','S','Maplewood','A','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(587,'00680','S','Ext Belmonte','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(33091,'36830','S','Auburn','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.599446,-85.473449,0,'2013-07-06 12:44:32',NULL,NULL),(25088,'27954','S','Cape Hatteras National Seash','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.915917,-75.677254,0,'2013-07-06 12:44:31',NULL,NULL),(8328,'08037','S','Ancora','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(69375,'83605','S','Enrose','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(60255,'71440','P','Gorhamtown','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.940430,-92.599937,0,'2013-07-06 12:44:33',NULL,NULL),(58991,'70055','P','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.998968,-90.134242,0,'2013-07-06 12:44:33',NULL,NULL),(53572,'62059','P','Brooklyn','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.656184,-90.166082,0,'2013-07-06 12:44:33',NULL,NULL),(48388,'55576','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996437,-93.711308,0,'2013-07-06 12:44:33',NULL,NULL),(42397,'47734','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.972826,-87.571062,0,'2013-07-06 12:44:32',NULL,NULL),(6108,'05455','S','Fairfield','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.784985,-73.017552,0,'2013-07-06 12:44:30',NULL,NULL),(28015,'30621','S','North High Shoals','A','Oconee','13219','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.833825,-83.471768,0,'2013-07-06 12:44:31',NULL,NULL),(14181,'14745','P','Hume','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.470999,-78.137723,0,'2013-07-06 12:44:31',NULL,NULL),(79204,'98535','S','Copalis Beach','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.116999,-124.155077,0,'2013-07-06 12:44:34',NULL,NULL),(76984,'96064','S','Montague','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.735873,-122.439379,0,'2013-07-06 12:44:34',NULL,NULL),(50091,'57469','S','Redfield','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.874469,-98.514591,0,'2013-07-06 12:44:33',NULL,NULL),(44270,'49701','S','Mackinaw City','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.777537,-84.754096,0,'2013-07-06 12:44:32',NULL,NULL),(6676,'06034','P','Farmington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.708905,-72.873483,0,'2013-07-06 12:44:30',NULL,NULL),(3256,'01450','S','Groton','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.608416,-71.556651,0,'2013-07-06 12:44:30',NULL,NULL),(25100,'27964','S','Point Harbor','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.076731,-75.799265,0,'2013-07-06 12:44:31',NULL,NULL),(42066,'47452','S','Bromer','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.662839,-86.450428,0,'2013-07-06 12:44:32',NULL,NULL),(43706,'48896','P','Winn','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.527260,-84.901708,0,'2013-07-06 12:44:32',NULL,NULL),(2519,'00957','S','Urb Rexville','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(78424,'98050','P','Preston','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.532563,-121.925654,0,'2013-07-06 12:44:34',NULL,NULL),(74237,'92325','P','Crestline','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.241417,-117.277125,0,'2013-07-06 12:44:34',NULL,NULL),(69990,'84121','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(57986,'67844','S','Fowler','D','Meade','20119','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.382512,-100.194629,0,'2013-07-06 12:44:33',NULL,NULL),(50214,'57580','S','Carter','A','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(46323,'53076','S','Richfield','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.268248,-88.218877,0,'2013-07-06 12:44:32',NULL,NULL),(22915,'24608','P','Tazewell','A','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.116004,-81.525343,0,'2013-07-06 12:44:31',NULL,NULL),(29444,'32697','P','Worthngtn Spg','A','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.931333,-82.424654,0,'2013-07-06 12:44:32',NULL,NULL),(37228,'41538','P','Jonancy','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.317544,-82.581457,0,'2013-07-06 12:44:32',NULL,NULL),(40427,'45699','U','Lucasville','D','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.881627,-82.992138,0,'2013-07-06 12:44:32',NULL,NULL),(44846,'50266','S','WDM','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.586600,-93.765743,0,'2013-07-06 12:44:32',NULL,NULL),(27,'00603','S','Sect Las Villas','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(74148,'92256','S','Morongo Vly','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.080121,-116.552087,0,'2013-07-06 12:44:34',NULL,NULL),(49006,'56252','S','Kerkhoven','D','Swift','27151','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.238951,-95.311927,0,'2013-07-06 12:44:33',NULL,NULL),(46869,'54082','S','Houlton','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.074760,-92.754060,0,'2013-07-06 12:44:32',NULL,NULL),(39648,'44907','S','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.735427,-82.521533,0,'2013-07-06 12:44:32',NULL,NULL),(37970,'42726','S','Peonia','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.413206,-86.157634,0,'2013-07-06 12:44:32',NULL,NULL),(3803,'02238','P','Harvard Square','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.374067,-71.117136,0,'2013-07-06 12:44:30',NULL,NULL),(49671,'57007','U','South Dakota State Univ','N','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.306715,-96.786041,0,'2013-07-06 12:44:33',NULL,NULL),(52133,'60434','P','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.539292,-88.076927,0,'2013-07-06 12:44:33',NULL,NULL),(79588,'99030','S','Rockford','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.478073,-117.113089,0,'2013-07-06 12:44:34',NULL,NULL),(72003,'88039','S','Glenwood','D','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.327720,-108.813300,0,'2013-07-06 12:44:34',NULL,NULL),(51563,'59750','S','Silverbow','N','Silver Bow','30093','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.974422,-112.808021,0,'2013-07-06 12:44:33',NULL,NULL),(17444,'17936','P','Gordon','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.748751,-76.339174,0,'2013-07-06 12:44:31',NULL,NULL),(6154,'05470','P','Montgomery','D','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.901593,-72.640125,0,'2013-07-06 12:44:30',NULL,NULL),(6318,'05661','S','Morrisville','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(11602,'12086','S','Hagaman','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.974141,-74.154373,0,'2013-07-06 12:44:30',NULL,NULL),(13556,'13833','S','Sanitaria Springs','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.200520,-75.773460,0,'2013-07-06 12:44:31',NULL,NULL),(60326,'71459','S','Leesville','A','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.995820,-93.246900,0,'2013-07-06 12:44:33',NULL,NULL),(27537,'30228','S','Hampton','D','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.404127,-84.282000,0,'2013-07-06 12:44:31',NULL,NULL),(27829,'30415','S','Arcola','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(16609,'17331','S','Brushtown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(33031,'36728','S','Prairie','A','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.201926,-87.481239,0,'2013-07-06 12:44:32',NULL,NULL),(36689,'41016','S','Ludlow','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.084954,-84.549188,0,'2013-07-06 12:44:32',NULL,NULL),(13135,'13493','S','Williamstown','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.422128,-75.888230,0,'2013-07-06 12:44:30',NULL,NULL),(71376,'87002','S','Rio Communities','A','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.656448,-106.759548,0,'2013-07-06 12:44:34',NULL,NULL),(66073,'78384','S','San Diego','D','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.760852,-98.243736,0,'2013-07-06 12:44:34',NULL,NULL),(10899,'11426','S','Bellerose','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.733204,-73.722052,0,'2013-07-06 12:44:30',NULL,NULL),(34716,'38838','S','Dennis','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.561800,-88.204080,0,'2013-07-06 12:44:32',NULL,NULL),(61255,'72355','S','Lexa','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.677640,-90.767453,0,'2013-07-06 12:44:33',NULL,NULL),(55579,'63879','S','Wardell','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.352080,-89.820360,0,'2013-07-06 12:44:33',NULL,NULL),(26123,'28732','S','Fletcher','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.421548,-82.499968,0,'2013-07-06 12:44:31',NULL,NULL),(50452,'58018','S','Colfax','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.500867,-97.048646,0,'2013-07-06 12:44:33',NULL,NULL),(45192,'50614','U','University of Northern Iowa','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.509279,-92.460752,0,'2013-07-06 12:44:32',NULL,NULL),(38275,'43321','S','Fulton','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.463265,-82.829866,0,'2013-07-06 12:44:32',NULL,NULL),(45110,'50554','S','Laurens','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.849816,-94.849302,0,'2013-07-06 12:44:32',NULL,NULL),(16638,'17339','S','Fortney','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.126080,-76.876560,0,'2013-07-06 12:44:31',NULL,NULL),(27292,'30006','P','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.953731,-84.541162,0,'2013-07-06 12:44:31',NULL,NULL),(13687,'14051','S','E Amherst','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.033131,-78.693260,0,'2013-07-06 12:44:31',NULL,NULL),(11764,'12197','S','Worcester','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.517778,-74.750278,0,'2013-07-06 12:44:30',NULL,NULL),(2848,'00983','S','Urb Sabana Gdns','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(77468,'96817','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.334849,-157.856702,0,'2013-07-06 12:44:34',NULL,NULL),(34483,'38665','S','Savage','A','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601919,-90.126392,0,'2013-07-06 12:44:32',NULL,NULL),(64894,'77081','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.713931,-95.479494,0,'2013-07-06 12:44:34',NULL,NULL),(19032,'19538','P','Maxatawny','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.544055,-75.691496,0,'2013-07-06 12:44:31',NULL,NULL),(53276,'61724','S','Kumler','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.341562,-88.515542,0,'2013-07-06 12:44:33',NULL,NULL),(36165,'40242','S','Murray Hill','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(46876,'54106','S','Black Creek','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.480124,-88.446752,0,'2013-07-06 12:44:32',NULL,NULL),(57611,'67119','S','Sieboldt','N','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.276202,-97.170267,0,'2013-07-06 12:44:33',NULL,NULL),(59986,'71327','S','Crackville','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.988947,-92.052747,0,'2013-07-06 12:44:33',NULL,NULL),(63879,'76010','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.722794,-97.084692,0,'2013-07-06 12:44:34',NULL,NULL),(78914,'98364','P','Little Boston','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.836944,-122.594391,0,'2013-07-06 12:44:34',NULL,NULL),(69086,'83252','S','Gwenford','N','Oneida','16071','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.192381,-112.248421,0,'2013-07-06 12:44:34',NULL,NULL),(4695,'03812','S','Harts Location','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.088653,-71.280179,0,'2013-07-06 12:44:30',NULL,NULL),(17072,'17758','S','Hemlock Grove','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(53850,'62323','S','Chambersburg','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.778405,-90.749454,0,'2013-07-06 12:44:33',NULL,NULL),(16560,'17314','S','Bryansville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.730000,-76.313333,0,'2013-07-06 12:44:31',NULL,NULL),(36439,'40601','S','Hatton','A','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.199801,-84.947505,0,'2013-07-06 12:44:32',NULL,NULL),(8889,'08724','S','Bricktown','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.086348,-74.118215,0,'2013-07-06 12:44:30',NULL,NULL),(20169,'20743','S','Seat Pleasant','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.885663,-76.901034,0,'2013-07-06 12:44:31',NULL,NULL),(3001,'01072','S','Shutesbury','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.467788,-72.429890,0,'2013-07-06 12:44:30',NULL,NULL),(42975,'48137','S','Williamsville','N','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.468420,-84.065880,0,'2013-07-06 12:44:32',NULL,NULL),(8591,'08230','S','Ocean View','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.210240,-74.728080,0,'2013-07-06 12:44:30',NULL,NULL),(11367,'11901','S','Northampton','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.928084,-72.655830,0,'2013-07-06 12:44:30',NULL,NULL),(32549,'36110','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.418887,-86.273229,0,'2013-07-06 12:44:32',NULL,NULL),(2105,'00923','S','Urb Open Land','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(57726,'67402','P','Salina','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.838881,-97.608195,0,'2013-07-06 12:44:33',NULL,NULL),(55053,'63147','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.695585,-90.223216,0,'2013-07-06 12:44:33',NULL,NULL),(36099,'40220','S','Hurstbourne Acres','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(49470,'56653','S','Littlefork','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.362760,-93.507720,0,'2013-07-06 12:44:33',NULL,NULL),(32633,'36201','S','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.656650,-85.827251,0,'2013-07-06 12:44:32',NULL,NULL),(32451,'36023','P','E Tallassee','A','Tallapoosa','01123','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.609580,-85.810369,0,'2013-07-06 12:44:32',NULL,NULL),(73551,'91360','S','Thousand Oaks','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.208451,-118.874426,0,'2013-07-06 12:44:34',NULL,NULL),(60984,'72110','S','Riverview','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(56784,'65753','S','Sparta','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.964680,-93.127200,0,'2013-07-06 12:44:33',NULL,NULL),(45381,'51023','S','Hawarden','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.000660,-96.480582,0,'2013-07-06 12:44:32',NULL,NULL),(6529,'05828','S','Danville Center','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.438199,-72.114702,0,'2013-07-06 12:44:30',NULL,NULL),(41755,'47283','S','Westport','D','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.175635,-85.575619,0,'2013-07-06 12:44:32',NULL,NULL),(19570,'20212','U','Dept Labor Stats','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895371,-77.007528,0,'2013-07-06 12:44:31',NULL,NULL),(44498,'49921','S','Dodgeville','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.090392,-88.580984,0,'2013-07-06 12:44:32',NULL,NULL),(34393,'38620','S','Courtland','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.172202,-90.137417,0,'2013-07-06 12:44:32',NULL,NULL),(33512,'37370','S','Riceville','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.324129,-84.658559,0,'2013-07-06 12:44:32',NULL,NULL),(50530,'58104','S','Prairie Rose','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.819706,-96.808039,0,'2013-07-06 12:44:33',NULL,NULL),(11754,'12192','S','West Coxsackie','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.383280,-73.824300,0,'2013-07-06 12:44:30',NULL,NULL),(62367,'74072','S','S Coffeyville','D','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.975720,-95.587200,0,'2013-07-06 12:44:33',NULL,NULL),(53194,'61610','S','Peoria','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.660110,-89.578136,0,'2013-07-06 12:44:33',NULL,NULL),(9742,'10095','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748793,-73.989926,0,'2013-07-06 12:44:30',NULL,NULL),(41706,'47231','S','Dupont','D','Jefferson','18077','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.891468,-85.501730,0,'2013-07-06 12:44:32',NULL,NULL),(76046,'95170','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.311750,-122.009013,0,'2013-07-06 12:44:34',NULL,NULL),(5371,'04628','S','Marion Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.854149,-67.275517,0,'2013-07-06 12:44:30',NULL,NULL),(27541,'30234','S','Jenkinsburg','D','Butts','13035','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.320972,-84.033019,0,'2013-07-06 12:44:31',NULL,NULL),(29009,'32224','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.275858,-81.461221,0,'2013-07-06 12:44:32',NULL,NULL),(3821,'02305','P','Brockton','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.083180,-71.024619,0,'2013-07-06 12:44:30',NULL,NULL),(26403,'29111','S','Oakdale','N','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.780339,-80.018183,0,'2013-07-06 12:44:31',NULL,NULL),(57996,'67859','S','Kismet','D','Seward','20175','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.204966,-100.702144,0,'2013-07-06 12:44:33',NULL,NULL),(50997,'58653','S','Scranton','D','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.112711,-103.120110,0,'2013-07-06 12:44:33',NULL,NULL),(38251,'43272','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.960349,-83.005660,0,'2013-07-06 12:44:32',NULL,NULL),(33236,'37070','P','Goodlettsvl','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.323710,-86.715822,0,'2013-07-06 12:44:32',NULL,NULL),(1170,'00727','S','Urb Idamaris Gdns','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(9111,'09104','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(68594,'81601','S','Glenwood','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.528426,-107.338503,0,'2013-07-06 12:44:34',NULL,NULL),(49603,'56758','S','Florian','N','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.454725,-96.453374,0,'2013-07-06 12:44:33',NULL,NULL),(75388,'93953','S','Pebble Beach','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.578257,-121.948084,0,'2013-07-06 12:44:34',NULL,NULL),(78669,'98236','S','Maxwelton','N','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.959500,-122.402110,0,'2013-07-06 12:44:34',NULL,NULL),(5053,'04271','P','Paris Hill','N','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.220906,-70.478319,0,'2013-07-06 12:44:30',NULL,NULL),(39407,'44663','S','New Philadelphia','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.486040,-81.442532,0,'2013-07-06 12:44:32',NULL,NULL),(13118,'13488','S','Westford','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.676969,-74.769177,0,'2013-07-06 12:44:30',NULL,NULL),(29162,'32347','S','Perry','D','Taylor','12123','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.111591,-83.582335,0,'2013-07-06 12:44:32',NULL,NULL),(1307,'00733','P','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.020753,-66.620129,0,'2013-07-06 12:44:30',NULL,NULL),(79007,'98387','S','Loveland','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.077576,-122.396089,0,'2013-07-06 12:44:34',NULL,NULL),(67704,'80525','S','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.534158,-105.043374,0,'2013-07-06 12:44:34',NULL,NULL),(66617,'78773','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.331091,-97.706506,0,'2013-07-06 12:44:34',NULL,NULL),(61486,'72639','S','Harriet','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.045000,-92.501389,0,'2013-07-06 12:44:33',NULL,NULL),(52249,'60517','S','Woodridge','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.754240,-88.061040,0,'2013-07-06 12:44:33',NULL,NULL),(47600,'54872','S','Siren','D','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.776310,-92.384046,0,'2013-07-06 12:44:33',NULL,NULL),(46362,'53110','S','Cudahy','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.947125,-87.861954,0,'2013-07-06 12:44:32',NULL,NULL),(6625,'05905','S','Bloomfield','A','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.733720,-71.641500,0,'2013-07-06 12:44:30',NULL,NULL),(3585,'02018','P','Accord','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.175682,-70.886913,0,'2013-07-06 12:44:30',NULL,NULL),(34303,'38545','S','Blmngton Spgs','A','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.343846,-85.651469,0,'2013-07-06 12:44:32',NULL,NULL),(14129,'14651','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.160651,-77.619606,0,'2013-07-06 12:44:31',NULL,NULL),(36636,'41004','S','Powersville','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(37512,'42038','S','Lamasco','N','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.045200,-88.050120,0,'2013-07-06 12:44:32',NULL,NULL),(42580,'47879','S','Shelburn','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(71190,'86046','S','Williams','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.289747,-112.161649,0,'2013-07-06 12:44:34',NULL,NULL),(67058,'79560','S','Sylvester','D','Fisher','48151','Texas','TX','48','0000','325','Central',-6.0,'Y',32.715578,-100.226775,0,'2013-07-06 12:44:34',NULL,NULL),(65256,'77467','P','Pierce','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.236892,-96.198326,0,'2013-07-06 12:44:34',NULL,NULL),(65086,'77355','S','Decker Pr','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.151734,-95.743252,0,'2013-07-06 12:44:34',NULL,NULL),(60171,'71409','S','Gardner','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(35886,'39897','S','Whigham','D','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.936474,-84.314520,0,'2013-07-06 12:44:32',NULL,NULL),(19111,'19606','S','Reading Sta','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(20045,'20653','S','Lexington Park','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.273193,-76.464098,0,'2013-07-06 12:44:31',NULL,NULL),(20179,'20746','S','Marlow Heights','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(29234,'32431','S','Cottondale','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.798181,-85.373699,0,'2013-07-06 12:44:32',NULL,NULL),(1659,'00773','S','Hacienda Paloma','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(21366,'22448','S','Dahlgren','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.335861,-77.033198,0,'2013-07-06 12:44:31',NULL,NULL),(20288,'20797','U','Southern MD Facility','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.095953,-76.838956,0,'2013-07-06 12:44:31',NULL,NULL),(70983,'85707','P','DM AFB','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.182027,-110.868630,0,'2013-07-06 12:44:34',NULL,NULL),(64174,'76227','S','Providnce Vil','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(41182,'46714','S','North Oaks','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(17846,'18424','S','Thornhurst','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(48539,'55753','P','Keewatin','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.398873,-93.079649,0,'2013-07-06 12:44:33',NULL,NULL),(51237,'59068','S','Red Lodge','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.186715,-109.251476,0,'2013-07-06 12:44:33',NULL,NULL),(64588,'76671','S','Poesville','N','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.020833,-97.493611,0,'2013-07-06 12:44:34',NULL,NULL),(63867,'76002','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.629271,-97.077873,0,'2013-07-06 12:44:34',NULL,NULL),(73699,'91607','S','Valley Village','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(79382,'98673','P','Wishram','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.663424,-120.971965,0,'2013-07-06 12:44:34',NULL,NULL),(15823,'16933','S','Cherry Flats','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(12699,'13142','S','Pulaski','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.557794,-76.128407,0,'2013-07-06 12:44:30',NULL,NULL),(44879,'50313','S','Saylorville','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.641599,-93.617602,0,'2013-07-06 12:44:32',NULL,NULL),(76134,'95252','S','Valley Springs','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.147636,-120.857242,0,'2013-07-06 12:44:34',NULL,NULL),(51162,'58856','S','Marmon','N','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589053,-103.668530,0,'2013-07-06 12:44:33',NULL,NULL),(61133,'72158','P','Benton','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.569207,-92.578913,0,'2013-07-06 12:44:33',NULL,NULL),(67746,'80610','S','Severance','A','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.619513,-104.701943,0,'2013-07-06 12:44:34',NULL,NULL),(7565,'07024','S','Palisade','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.851376,-73.975825,0,'2013-07-06 12:44:30',NULL,NULL),(43641,'48834','S','Fenwick','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.146154,-85.048477,0,'2013-07-06 12:44:32',NULL,NULL),(35126,'39213','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.346826,-90.214369,0,'2013-07-06 12:44:32',NULL,NULL),(8724,'08510','S','Clarksburg','A','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.189800,-74.441400,0,'2013-07-06 12:44:30',NULL,NULL),(65994,'78339','P','Banquete','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.913915,-97.778587,0,'2013-07-06 12:44:34',NULL,NULL),(27353,'30058','S','Lithonia','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.727929,-84.123557,0,'2013-07-06 12:44:31',NULL,NULL),(35691,'39662','S','Ruth','D','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.381546,-90.292446,0,'2013-07-06 12:44:32',NULL,NULL),(61251,'72351','P','Keiser','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.694638,-90.102767,0,'2013-07-06 12:44:33',NULL,NULL),(17652,'18076','S','Red Hill','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.377723,-75.486191,0,'2013-07-06 12:44:31',NULL,NULL),(1324,'00735','S','Urb Santa Maria','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(1406,'00738','S','Urb Monte Vista','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(26568,'29211','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.024196,-81.293589,0,'2013-07-06 12:44:31',NULL,NULL),(46278,'53034','S','Hustisford','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.343769,-88.602485,0,'2013-07-06 12:44:32',NULL,NULL),(52560,'60954','S','Momence','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.163429,-87.662302,0,'2013-07-06 12:44:33',NULL,NULL),(79884,'99575','P','Crooked Creek','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.807587,-157.938213,0,'2013-07-06 12:44:34',NULL,NULL),(19391,'20068','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901054,-77.046743,0,'2013-07-06 12:44:31',NULL,NULL),(53437,'61870','S','Ridge Farm','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.895436,-87.651249,0,'2013-07-06 12:44:33',NULL,NULL),(26295,'29030','S','Cameron','D','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.550000,-80.710000,0,'2013-07-06 12:44:31',NULL,NULL),(43949,'49302','S','Alto','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.829750,-85.422188,0,'2013-07-06 12:44:32',NULL,NULL),(49752,'57062','S','Springfield','D','Bon Homme','46009','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.853777,-97.892321,0,'2013-07-06 12:44:33',NULL,NULL),(48086,'55335','S','Gibbon','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.528499,-94.527041,0,'2013-07-06 12:44:33',NULL,NULL),(60457,'71653','S','Lake Village','D','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(47431,'54701','S','Caryville','N','Eau Claire','55035','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.794997,-91.483260,0,'2013-07-06 12:44:32',NULL,NULL),(61227,'72327','S','Crawfordsvlle','A','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.207580,-90.343980,0,'2013-07-06 12:44:33',NULL,NULL),(62728,'74820','S','Bing','A','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.771920,-96.679980,0,'2013-07-06 12:44:33',NULL,NULL),(66758,'79013','S','Cactus','D','Moore','48341','Texas','TX','48','0000','806','Central',-6.0,'Y',36.052481,-101.997921,0,'2013-07-06 12:44:34',NULL,NULL),(27453,'30125','S','Cedartown','D','Polk','13233','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.010998,-85.256877,0,'2013-07-06 12:44:31',NULL,NULL),(34324,'38558','S','Fairfield','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(67172,'79839','S','Mc Nary','N','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.297510,-105.837570,0,'2013-07-06 12:44:34',NULL,NULL),(46289,'53047','P','Lebanon','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.191925,-88.719413,0,'2013-07-06 12:44:32',NULL,NULL),(53292,'61727','S','Texas Township','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(70995,'85713','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.191440,-111.062700,0,'2013-07-06 12:44:34',NULL,NULL),(17544,'17976','S','Turkey Run','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(16445,'17236','S','Markes','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(2545,'00959','S','Parc Juan Sanchez','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(29158,'32346','S','Alligator Pt','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.023822,-84.391553,0,'2013-07-06 12:44:32',NULL,NULL),(1152,'00727','S','Mans El Paraiso','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(19377,'20061','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918880,-76.993855,0,'2013-07-06 12:44:31',NULL,NULL),(46928,'54154','S','Ocontofalls','N','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.874146,-88.164099,0,'2013-07-06 12:44:32',NULL,NULL),(64299,'76457','S','Hico','D','Hamilton','48193','Texas','TX','48','0000','254','Central',-6.0,'Y',31.990782,-98.024841,0,'2013-07-06 12:44:34',NULL,NULL),(71394,'87009','S','Cedarvale','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.445675,-105.733776,0,'2013-07-06 12:44:34',NULL,NULL),(17188,'17820','S','Mill Grove','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(74494,'92624','S','Capistrano Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.459976,-117.663169,0,'2013-07-06 12:44:34',NULL,NULL),(29515,'32774','P','Orange City','D','Volusia','12127','Florida','FL','12','2020','407/321/689','Eastern',-5.0,'Y',28.951285,-81.299272,0,'2013-07-06 12:44:32',NULL,NULL),(16226,'17074','S','Newprt','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(42596,'47885','S','Libertyville','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(41599,'47110','S','Central','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.091924,-86.161324,0,'2013-07-06 12:44:32',NULL,NULL),(23981,'26320','S','Wilbur','A','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.424509,-80.827230,0,'2013-07-06 12:44:31',NULL,NULL),(11246,'11758','S','N Massapequa','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.686884,-73.469397,0,'2013-07-06 12:44:30',NULL,NULL),(61051,'72120','S','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.892804,-92.231859,0,'2013-07-06 12:44:33',NULL,NULL),(56527,'65401','S','Rolla','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.950864,-91.763227,0,'2013-07-06 12:44:33',NULL,NULL),(63554,'75766','S','Jacksonville','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:33',NULL,NULL),(59625,'71037','S','Adner','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.536800,-93.534900,0,'2013-07-06 12:44:33',NULL,NULL),(48429,'55614','S','Little Marais','A','Lake','27075','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.305260,-91.247460,0,'2013-07-06 12:44:33',NULL,NULL),(42353,'47660','S','Oakland City','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.336755,-87.352284,0,'2013-07-06 12:44:32',NULL,NULL),(22070,'23345','S','Davis Wharf','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.569999,-75.888446,0,'2013-07-06 12:44:31',NULL,NULL),(79454,'98848','S','Quincy','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.210850,-119.861652,0,'2013-07-06 12:44:34',NULL,NULL),(13799,'14205','P','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.892353,-78.868805,0,'2013-07-06 12:44:31',NULL,NULL),(76851,'95965','S','Pentz','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(73435,'91214','S','La Crescenta','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.232506,-118.245761,0,'2013-07-06 12:44:34',NULL,NULL),(76273,'95421','S','Cazadero','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.535522,-123.135789,0,'2013-07-06 12:44:34',NULL,NULL),(66762,'79016','U','Canyon','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',34.979592,-101.929451,0,'2013-07-06 12:44:34',NULL,NULL),(30968,'33740','P','Treasure Is','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.770012,-82.766347,0,'2013-07-06 12:44:32',NULL,NULL),(80153,'99789','P','Nuiqsut','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.235770,-151.126315,0,'2013-07-06 12:44:34',NULL,NULL),(49232,'56469','S','Workman','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(16559,'17313','S','Yoe','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.901404,-76.648789,0,'2013-07-06 12:44:31',NULL,NULL),(13823,'14217','S','Kenmore','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.972758,-78.876061,0,'2013-07-06 12:44:31',NULL,NULL),(444,'00662','S','Urb Lamela','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(47267,'54530','S','South Fork','N','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.510622,-90.712444,0,'2013-07-06 12:44:32',NULL,NULL),(49375,'56589','S','Waubun','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.194333,-95.870248,0,'2013-07-06 12:44:33',NULL,NULL),(51315,'59244','S','Larslan','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.546336,-106.225926,0,'2013-07-06 12:44:33',NULL,NULL),(54439,'62842','S','Geff','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.440349,-88.426303,0,'2013-07-06 12:44:33',NULL,NULL),(61239,'72338','S','Frenchmans Bayou','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.467529,-90.059363,0,'2013-07-06 12:44:33',NULL,NULL),(26091,'28713','S','Alarka','N','Swain','37173','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.401379,-83.467681,0,'2013-07-06 12:44:31',NULL,NULL),(5118,'04363','S','Windsor','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.306838,-69.572907,0,'2013-07-06 12:44:30',NULL,NULL),(48371,'55559','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.814039,-93.918937,0,'2013-07-06 12:44:33',NULL,NULL),(40161,'45360','P','Port Jefferson','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.332192,-84.090568,0,'2013-07-06 12:44:32',NULL,NULL),(39421,'44676','S','Craigton','N','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.697236,-82.034128,0,'2013-07-06 12:44:32',NULL,NULL),(62267,'74011','S','Broken Arrow','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.987755,-95.810740,0,'2013-07-06 12:44:33',NULL,NULL),(49678,'57015','S','Chancellor','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.369918,-96.983301,0,'2013-07-06 12:44:33',NULL,NULL),(48464,'55717','S','Lake Nichols','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.079441,-92.470331,0,'2013-07-06 12:44:33',NULL,NULL),(46515,'53267','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.043798,-87.909801,0,'2013-07-06 12:44:32',NULL,NULL),(39715,'45051','S','Mt St Joseph','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.095333,-84.639780,0,'2013-07-06 12:44:32',NULL,NULL),(54018,'62454','S','Duncanville','N','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(27013,'29642','S','Easley','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.805816,-82.562178,0,'2013-07-06 12:44:31',NULL,NULL),(66594,'78753','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371378,-97.671747,0,'2013-07-06 12:44:34',NULL,NULL),(72577,'89404','P','Highway 40','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.988160,-118.623640,0,'2013-07-06 12:44:34',NULL,NULL),(2553,'00959','S','Repto Flamingo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(8161,'07857','S','Netcong','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.898789,-74.705094,0,'2013-07-06 12:44:30',NULL,NULL),(58376,'68529','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.852903,-96.613110,0,'2013-07-06 12:44:33',NULL,NULL),(20478,'21043','S','Ellicott City','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.266016,-76.845513,0,'2013-07-06 12:44:31',NULL,NULL),(19572,'20213','U','Dept Labor Manpower Admn','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.890866,-77.013467,0,'2013-07-06 12:44:31',NULL,NULL),(48589,'55779','S','Harnell Park','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.908120,-92.439060,0,'2013-07-06 12:44:33',NULL,NULL),(8350,'08045','S','Lawnside','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.866011,-75.034254,0,'2013-07-06 12:44:30',NULL,NULL),(60337,'71465','S','Pleasant Ridge','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.907286,-92.223113,0,'2013-07-06 12:44:33',NULL,NULL),(62460,'74331','S','Bird Island','N','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(74677,'92868','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.787473,-117.877611,0,'2013-07-06 12:44:34',NULL,NULL),(50271,'57644','S','Athboy','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.291739,-102.295248,0,'2013-07-06 12:44:33',NULL,NULL),(55101,'63304','S','Saint Peters','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.733326,-90.622121,0,'2013-07-06 12:44:33',NULL,NULL),(47660,'54936','P','Fond du Lac','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.773509,-88.447801,0,'2013-07-06 12:44:33',NULL,NULL),(71675,'87508','S','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.618373,-105.963441,0,'2013-07-06 12:44:34',NULL,NULL),(73898,'92004','S','Borrego Spgs','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.236443,-116.349384,0,'2013-07-06 12:44:34',NULL,NULL),(78323,'97913','S','Owyhee Corners','N','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.838397,-117.061031,0,'2013-07-06 12:44:34',NULL,NULL),(25771,'28601','S','Lenoir Rhyne','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(58462,'68730','S','Crofton','D','Knox','31107','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.744114,-97.529215,0,'2013-07-06 12:44:33',NULL,NULL),(23126,'24966','S','Falling Sprg','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.065844,-80.376621,0,'2013-07-06 12:44:31',NULL,NULL),(28303,'31119','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.857043,-84.344412,0,'2013-07-06 12:44:31',NULL,NULL),(35889,'39901','U','IRS Service Center','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.890737,-84.287630,0,'2013-07-06 12:44:32',NULL,NULL),(46316,'53072','S','Brookfield','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.078937,-88.256368,0,'2013-07-06 12:44:32',NULL,NULL),(47630,'54913','S','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.263597,-88.413736,0,'2013-07-06 12:44:33',NULL,NULL),(73331,'90844','U','Press Telegram','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.776755,-118.191618,0,'2013-07-06 12:44:34',NULL,NULL),(7355,'06749','U','Uniroyal Inc','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.504981,-73.152430,0,'2013-07-06 12:44:30',NULL,NULL),(62144,'73717','S','Avard','A','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.796749,-98.668264,0,'2013-07-06 12:44:33',NULL,NULL),(10425,'10710','S','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.965847,-73.845926,0,'2013-07-06 12:44:30',NULL,NULL),(65421,'77575','S','Moss Hill','N','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.067839,-94.789652,0,'2013-07-06 12:44:34',NULL,NULL),(62269,'74012','S','Broken Arrow','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.045030,-95.808242,0,'2013-07-06 12:44:33',NULL,NULL),(980,'00716','S','Villa del Carmen','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(19925,'20557','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880368,-76.990661,0,'2013-07-06 12:44:31',NULL,NULL),(9276,'09623','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(58873,'69155','S','Paxton','D','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.211049,-101.375901,0,'2013-07-06 12:44:33',NULL,NULL),(71122,'86018','P','Parks Comm Po','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.260485,-111.947488,0,'2013-07-06 12:44:34',NULL,NULL),(13689,'14051','S','Swormville','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.033131,-78.693260,0,'2013-07-06 12:44:31',NULL,NULL),(6049,'05440','S','Alburgh','D','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.957724,-73.279914,0,'2013-07-06 12:44:30',NULL,NULL),(56673,'65631','S','Clever','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.022884,-93.472120,0,'2013-07-06 12:44:33',NULL,NULL),(46717,'53806','S','Cassville','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.738574,-90.942940,0,'2013-07-06 12:44:32',NULL,NULL),(16831,'17554','S','Mountville','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.043724,-76.425577,0,'2013-07-06 12:44:31',NULL,NULL),(59341,'70549','S','Lake Arthur','D','Jefferson Davis','22053','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.084531,-92.676676,0,'2013-07-06 12:44:33',NULL,NULL),(50325,'57730','S','Bluebell','N','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(45268,'50669','S','Reinbeck','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.316980,-92.571000,0,'2013-07-06 12:44:32',NULL,NULL),(258,'00641','S','Alts de Utuado','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(65727,'78040','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.512693,-99.488193,0,'2013-07-06 12:44:34',NULL,NULL),(61112,'72145','P','Searcy','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.252087,-91.742855,0,'2013-07-06 12:44:33',NULL,NULL),(9613,'10032','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(52779,'61265','S','Quad City Airport','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.491529,-90.495895,0,'2013-07-06 12:44:33',NULL,NULL),(15463,'16420','S','Grand Valley','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772126,-79.548546,0,'2013-07-06 12:44:31',NULL,NULL),(33717,'37779','S','Luttrell','D','Union','47173','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.157029,-83.751395,0,'2013-07-06 12:44:32',NULL,NULL),(70216,'84402','P','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.223691,-112.021721,0,'2013-07-06 12:44:34',NULL,NULL),(28650,'31768','S','Riverside','A','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.171229,-83.782941,0,'2013-07-06 12:44:32',NULL,NULL),(75613,'94497','U','Postal Data Center','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.562555,-122.324828,0,'2013-07-06 12:44:34',NULL,NULL),(54268,'62681','S','Rushville','D','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.121657,-90.560514,0,'2013-07-06 12:44:33',NULL,NULL),(59307,'70514','S','Baldwin','D','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.838927,-91.546126,0,'2013-07-06 12:44:33',NULL,NULL),(44255,'49680','S','S Boardman','A','Kalkaska','26079','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.633052,-85.243490,0,'2013-07-06 12:44:32',NULL,NULL),(43790,'49048','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.293679,-85.586333,0,'2013-07-06 12:44:32',NULL,NULL),(41649,'47137','S','Fredonia','A','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.209645,-86.365045,0,'2013-07-06 12:44:32',NULL,NULL),(12199,'12783','S','Swan Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.740653,-74.792651,0,'2013-07-06 12:44:30',NULL,NULL),(20391,'20894','U','National Library of Medicine','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.002607,-77.093732,0,'2013-07-06 12:44:31',NULL,NULL),(26985,'29621','S','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.523656,-82.644593,0,'2013-07-06 12:44:31',NULL,NULL),(65158,'77399','U','Escapees Rv Club','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.713086,-94.935409,0,'2013-07-06 12:44:34',NULL,NULL),(60363,'71473','S','Hickory Valley','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.067300,-92.422500,0,'2013-07-06 12:44:33',NULL,NULL),(60354,'71469','S','Shamrock','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(63585,'75783','S','Quitman','D','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.795818,-95.445299,0,'2013-07-06 12:44:34',NULL,NULL),(74162,'92263','P','Palm Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.875893,-116.566292,0,'2013-07-06 12:44:34',NULL,NULL),(66770,'79025','P','Dawn','D','Deaf Smith','48117','Texas','TX','48','0000','806','Central',-6.0,'Y',34.909880,-102.200720,0,'2013-07-06 12:44:34',NULL,NULL),(31793,'35036','P','Brookside','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.633971,-86.917920,0,'2013-07-06 12:44:32',NULL,NULL),(52686,'61087','S','Warren','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.489012,-89.991849,0,'2013-07-06 12:44:33',NULL,NULL),(57839,'67550','S','Radium','A','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.188320,-99.120720,0,'2013-07-06 12:44:33',NULL,NULL),(4130,'02745','S','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.695977,-70.938302,0,'2013-07-06 12:44:30',NULL,NULL),(20952,'21776','S','New Windsor','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.517882,-77.109276,0,'2013-07-06 12:44:31',NULL,NULL),(21752,'23050','S','Dutton','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.488110,-76.429213,0,'2013-07-06 12:44:31',NULL,NULL),(11090,'11693','S','Rockaway Beac','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.589797,-73.813567,0,'2013-07-06 12:44:30',NULL,NULL),(27445,'30120','S','Cartersville','D','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.177555,-84.854308,0,'2013-07-06 12:44:31',NULL,NULL),(34388,'38618','S','Poagville','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(48633,'55808','S','Morgan Park','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.676959,-92.231918,0,'2013-07-06 12:44:33',NULL,NULL),(44494,'49918','P','Calumet','A','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.470095,-87.887734,0,'2013-07-06 12:44:32',NULL,NULL),(41017,'46376','P','Schneider','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.183380,-87.462356,0,'2013-07-06 12:44:32',NULL,NULL),(63847,'75975','S','Stockman','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.890720,-94.390140,0,'2013-07-06 12:44:34',NULL,NULL),(62787,'74880','S','Pharoah','A','Okfuskee','40107','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.334178,-96.130338,0,'2013-07-06 12:44:33',NULL,NULL),(61752,'73047','S','Bridgeport','A','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.473849,-98.355464,0,'2013-07-06 12:44:33',NULL,NULL),(32518,'36087','P','Tuskegee Institute','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.412992,-85.681539,0,'2013-07-06 12:44:32',NULL,NULL),(32337,'35775','S','Valhermoso Springs','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.550490,-86.694970,0,'2013-07-06 12:44:32',NULL,NULL),(26734,'29419','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.936047,-80.100088,0,'2013-07-06 12:44:31',NULL,NULL),(66334,'78604','P','Belmont','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.523929,-97.681918,0,'2013-07-06 12:44:34',NULL,NULL),(14172,'14738','S','Frewsburg','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.053607,-79.134602,0,'2013-07-06 12:44:31',NULL,NULL),(57516,'66966','S','Scandia','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.795975,-97.784791,0,'2013-07-06 12:44:33',NULL,NULL),(39728,'45062','P','Seven Mile','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.483343,-84.553190,0,'2013-07-06 12:44:32',NULL,NULL),(5116,'04359','P','South Gardiner','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.202673,-69.781345,0,'2013-07-06 12:44:30',NULL,NULL),(7354,'06726','P','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.555029,-73.037976,0,'2013-07-06 12:44:30',NULL,NULL),(22138,'23452','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.839129,-76.090953,0,'2013-07-06 12:44:31',NULL,NULL),(51421,'59450','S','Highwood','D','Chouteau','30015','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.628889,-110.571944,0,'2013-07-06 12:44:33',NULL,NULL),(5630,'04945','S','Dennistown','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.673790,-70.266917,0,'2013-07-06 12:44:30',NULL,NULL),(4347,'03044','S','Fremont','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.973193,-71.112276,0,'2013-07-06 12:44:30',NULL,NULL),(49096,'56334','S','Terrace','N','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.651444,-95.386131,0,'2013-07-06 12:44:33',NULL,NULL),(38453,'43607','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.650995,-83.603793,0,'2013-07-06 12:44:32',NULL,NULL),(8510,'08101','P','Camden','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.940902,-75.126163,0,'2013-07-06 12:44:30',NULL,NULL),(19247,'19934','S','Camden-Wyoming','N','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(32037,'35244','S','Bluff Park','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.361710,-86.788783,0,'2013-07-06 12:44:32',NULL,NULL),(41329,'46777','S','Tocsin','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.870920,-85.156740,0,'2013-07-06 12:44:32',NULL,NULL),(35485,'39522','U','Bay St Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.335026,-89.509144,0,'2013-07-06 12:44:32',NULL,NULL),(35708,'39667','S','Knoxo','N','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(20838,'21641','P','Hillsboro','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.916650,-75.943316,0,'2013-07-06 12:44:31',NULL,NULL),(56350,'65202','S','Hinton','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(54477,'62859','S','McLeansboro','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(78366,'98021','S','Bothell','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.791648,-122.217445,0,'2013-07-06 12:44:34',NULL,NULL),(13319,'13676','S','Sissonville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(25302,'28146','S','Granite Quarry','A','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.630497,-80.432818,0,'2013-07-06 12:44:31',NULL,NULL),(60338,'71465','S','Rosefield','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.907286,-92.223113,0,'2013-07-06 12:44:33',NULL,NULL),(57612,'67120','S','Peck','D','Sumner','20191','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.500810,-97.385952,0,'2013-07-06 12:44:33',NULL,NULL),(18595,'19138','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.058584,-75.160929,0,'2013-07-06 12:44:31',NULL,NULL),(55365,'63565','S','Mendota','N','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497300,-93.005760,0,'2013-07-06 12:44:33',NULL,NULL),(29993,'33112','U','International Service Center','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796650,-80.341619,0,'2013-07-06 12:44:32',NULL,NULL),(53915,'62376','S','Marcelline','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.080169,-91.411941,0,'2013-07-06 12:44:33',NULL,NULL),(51842,'60069','S','Prairie View','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194460,-87.910740,0,'2013-07-06 12:44:33',NULL,NULL),(67473,'80225','S','Denver','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.724284,-105.110169,0,'2013-07-06 12:44:34',NULL,NULL),(66149,'78501','S','McAllen','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.213590,-98.235546,0,'2013-07-06 12:44:34',NULL,NULL),(73197,'90510','P','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.825599,-118.328416,0,'2013-07-06 12:44:34',NULL,NULL),(67851,'80820','S','Guffey','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.779970,-105.510388,0,'2013-07-06 12:44:34',NULL,NULL),(14153,'14718','S','Cassadaga','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.348088,-79.292917,0,'2013-07-06 12:44:31',NULL,NULL),(23034,'24850','S','Jolo','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.332245,-81.833824,0,'2013-07-06 12:44:31',NULL,NULL),(19430,'20103','U','Stamp Distribution Network','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.997377,-77.451478,0,'2013-07-06 12:44:31',NULL,NULL),(58596,'68847','S','Kearney','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.742085,-99.060441,0,'2013-07-06 12:44:33',NULL,NULL),(6240,'05491','S','Waltham','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.148540,-73.275360,0,'2013-07-06 12:44:30',NULL,NULL),(45022,'50461','S','New Haven','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.286734,-92.810092,0,'2013-07-06 12:44:32',NULL,NULL),(29628,'32885','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.539323,-81.379368,0,'2013-07-06 12:44:32',NULL,NULL),(59347,'70556','P','Mermentau','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.187929,-92.577927,0,'2013-07-06 12:44:33',NULL,NULL),(57976,'67837','S','Copeland','D','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.542791,-100.628155,0,'2013-07-06 12:44:33',NULL,NULL),(56505,'65345','S','Mora','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.531213,-93.218254,0,'2013-07-06 12:44:33',NULL,NULL),(51214,'59046','S','Lavina','D','Golden Valley','30037','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.227533,-108.713743,0,'2013-07-06 12:44:33',NULL,NULL),(24192,'26660','S','Calvin','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.324547,-80.707045,0,'2013-07-06 12:44:31',NULL,NULL),(21153,'22122','P','Newington','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.739023,-77.180316,0,'2013-07-06 12:44:31',NULL,NULL),(51322,'59255','S','Poplar','D','Roosevelt','30085','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.108682,-105.192014,0,'2013-07-06 12:44:33',NULL,NULL),(22548,'24132','P','Parrott','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.147992,-80.615851,0,'2013-07-06 12:44:31',NULL,NULL),(41826,'47340','S','Farmland','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.181057,-85.113281,0,'2013-07-06 12:44:32',NULL,NULL),(65904,'78235','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.341979,-98.442498,0,'2013-07-06 12:44:34',NULL,NULL),(43985,'49333','S','Middleville','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.684480,-85.452060,0,'2013-07-06 12:44:32',NULL,NULL),(73484,'91321','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.379025,-118.520802,0,'2013-07-06 12:44:34',NULL,NULL),(4484,'03273','P','South Sutton','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.321255,-71.936438,0,'2013-07-06 12:44:30',NULL,NULL),(5944,'05257','S','Wolumsak','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(73670,'91526','U','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.190452,-118.325901,0,'2013-07-06 12:44:34',NULL,NULL),(5711,'04985','S','West Forks','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(46789,'53963','S','Waupun','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.629805,-88.734679,0,'2013-07-06 12:44:32',NULL,NULL),(30489,'33359','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.179370,-80.226998,0,'2013-07-06 12:44:32',NULL,NULL),(797,'00693','S','Jard de Vega Baja','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(30136,'33165','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.729513,-80.360218,0,'2013-07-06 12:44:32',NULL,NULL),(58387,'68601','S','Richland','A','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.449200,-97.371960,0,'2013-07-06 12:44:33',NULL,NULL),(46589,'53543','S','Highland','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.042113,-90.363424,0,'2013-07-06 12:44:32',NULL,NULL),(46314,'53069','S','Okauchee','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.113593,-88.443741,0,'2013-07-06 12:44:32',NULL,NULL),(37067,'41311','S','Widecreek','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(73038,'90078','P','Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.099648,-118.328037,0,'2013-07-06 12:44:34',NULL,NULL),(43406,'48454','S','Melvin','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.199609,-82.822046,0,'2013-07-06 12:44:32',NULL,NULL),(25254,'28115','S','Doolie','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.575801,-80.819083,0,'2013-07-06 12:44:31',NULL,NULL),(50467,'58038','S','Grandin','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.195959,-97.068257,0,'2013-07-06 12:44:33',NULL,NULL),(18108,'18766','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.244606,-75.883149,0,'2013-07-06 12:44:31',NULL,NULL),(29832,'33030','S','Homestead','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.481403,-80.505418,0,'2013-07-06 12:44:32',NULL,NULL),(9879,'10123','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(26924,'29585','S','N Litchfield','A','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.453325,-79.135137,0,'2013-07-06 12:44:31',NULL,NULL),(71688,'87516','S','Canones','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188056,-106.438889,0,'2013-07-06 12:44:34',NULL,NULL),(23549,'25628','P','Kistler','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.713214,-81.788081,0,'2013-07-06 12:44:31',NULL,NULL),(49142,'56374','S','Saint Joseph','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.586745,-94.330030,0,'2013-07-06 12:44:33',NULL,NULL),(45133,'50574','S','Pocahontas','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.733325,-94.671319,0,'2013-07-06 12:44:32',NULL,NULL),(11914,'12412','S','Boiceville','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.004425,-74.261329,0,'2013-07-06 12:44:30',NULL,NULL),(8715,'08406','S','Ventnor City','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.342361,-74.481532,0,'2013-07-06 12:44:30',NULL,NULL),(18266,'19007','S','Edgely','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.111586,-74.861944,0,'2013-07-06 12:44:31',NULL,NULL),(15749,'16912','S','Blossburg','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.679554,-77.064192,0,'2013-07-06 12:44:31',NULL,NULL),(15679,'16827','S','Boalsburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.780424,-77.791762,0,'2013-07-06 12:44:31',NULL,NULL),(28942,'32179','S','Oklawaha','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.052240,-81.920160,0,'2013-07-06 12:44:32',NULL,NULL),(13671,'14034','S','Helmuth','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.502473,-78.860926,0,'2013-07-06 12:44:31',NULL,NULL),(21504,'22709','S','Aroda','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.322616,-78.261232,0,'2013-07-06 12:44:31',NULL,NULL),(73727,'91618','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.112736,-118.365832,0,'2013-07-06 12:44:34',NULL,NULL),(74615,'92735','P','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.718836,-117.854616,0,'2013-07-06 12:44:34',NULL,NULL),(77769,'97117','S','Gales Creek','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.597896,-123.268469,0,'2013-07-06 12:44:34',NULL,NULL),(56412,'65251','S','Carrington','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.852815,-91.946319,0,'2013-07-06 12:44:33',NULL,NULL),(17932,'18471','P','Waverly','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.524177,-75.702613,0,'2013-07-06 12:44:31',NULL,NULL),(63952,'76087','S','Weatherford','D','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699394,-97.772650,0,'2013-07-06 12:44:34',NULL,NULL),(17527,'17970','S','Saint Clair','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.746000,-76.208460,0,'2013-07-06 12:44:31',NULL,NULL),(35225,'39305','S','Meridian','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.402996,-88.706033,0,'2013-07-06 12:44:32',NULL,NULL),(74843,'93245','S','Lemoore','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.320100,-119.816820,0,'2013-07-06 12:44:34',NULL,NULL),(8693,'08346','S','Newtonville','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.565187,-74.857657,0,'2013-07-06 12:44:30',NULL,NULL),(24637,'27371','S','Okeewemee','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(70979,'85705','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.266080,-110.998980,0,'2013-07-06 12:44:34',NULL,NULL),(37583,'42087','S','Blandville','A','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.969136,-88.980962,0,'2013-07-06 12:44:32',NULL,NULL),(22623,'24228','S','Honeycamp','N','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.152022,-82.458909,0,'2013-07-06 12:44:31',NULL,NULL),(49052,'56301','S','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.531141,-94.209162,0,'2013-07-06 12:44:33',NULL,NULL),(33929,'38060','S','Oakland','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.212950,-89.542271,0,'2013-07-06 12:44:32',NULL,NULL),(13151,'13602','S','Watertown','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.054057,-75.750531,0,'2013-07-06 12:44:30',NULL,NULL),(20135,'20722','S','No Brentwood','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(60444,'71647','S','Rock Island Junction','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(29500,'32754','S','Mims','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.691588,-80.864509,0,'2013-07-06 12:44:32',NULL,NULL),(77624,'97001','S','Antelope','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.876700,-120.709320,0,'2013-07-06 12:44:34',NULL,NULL),(2172,'00926','S','Ciudad Senorial','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(5193,'04448','S','Edinburg','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.240115,-68.661207,0,'2013-07-06 12:44:30',NULL,NULL),(28090,'30740','S','Rocky Face','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.771128,-85.056235,0,'2013-07-06 12:44:31',NULL,NULL),(45631,'51637','P','College Sprgs','A','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.620338,-95.109800,0,'2013-07-06 12:44:32',NULL,NULL),(75616,'94501','S','Alameda Pt','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.760574,-122.260375,0,'2013-07-06 12:44:34',NULL,NULL),(80046,'99704','S','Nenana','A','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.491996,-148.678285,0,'2013-07-06 12:44:34',NULL,NULL),(622,'00682','S','Jard de Guanajibo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(68568,'81502','P','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.074393,-108.631686,0,'2013-07-06 12:44:34',NULL,NULL),(1424,'00739','S','Cidra','D','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(32781,'36420','S','Carolina','A','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(38723,'44022','S','Orange','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(44470,'49891','S','Traunik','A','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.202796,-86.866256,0,'2013-07-06 12:44:32',NULL,NULL),(41348,'46789','P','Stroh','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.580247,-85.199688,0,'2013-07-06 12:44:32',NULL,NULL),(71634,'87412','S','Turley','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.777110,-107.736433,0,'2013-07-06 12:44:34',NULL,NULL),(19445,'20113','P','Manassas','D','Manassas Park City','51685','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.786738,-77.455746,0,'2013-07-06 12:44:31',NULL,NULL),(70873,'85606','S','Cochise','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.006439,-109.880346,0,'2013-07-06 12:44:34',NULL,NULL),(65766,'78101','S','Adkins','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.349505,-98.223103,0,'2013-07-06 12:44:34',NULL,NULL),(19113,'19606','S','Reiffton','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.322494,-75.867810,0,'2013-07-06 12:44:31',NULL,NULL),(74540,'92661','S','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.604484,-117.902066,0,'2013-07-06 12:44:34',NULL,NULL),(16855,'17563','S','Furniss','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(67239,'79937','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.785770,-106.336864,0,'2013-07-06 12:44:34',NULL,NULL),(60101,'71360','S','Pineville','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(1463,'00745','S','Trump Founders Rsdncs','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(58005,'67865','S','Minneola','D','Clark','20025','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.421160,-99.917040,0,'2013-07-06 12:44:33',NULL,NULL),(27832,'30415','S','Hubert','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(13260,'13648','S','East Pitcairn','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(67697,'80522','P','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.594542,-105.127399,0,'2013-07-06 12:44:34',NULL,NULL),(10298,'10524','S','Manitou','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.369283,-73.919944,0,'2013-07-06 12:44:30',NULL,NULL),(65613,'77954','S','Cheapside','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(5828,'05077','S','North Tunbridge','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.915965,-72.473032,0,'2013-07-06 12:44:30',NULL,NULL),(25896,'28643','S','Lansing','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(58318,'68443','S','Sterling','D','Johnson','31097','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.462807,-96.379563,0,'2013-07-06 12:44:33',NULL,NULL),(52333,'60568','U','Aurora','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.773392,-88.247376,0,'2013-07-06 12:44:33',NULL,NULL),(40188,'45380','S','Versailles','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.238785,-84.511676,0,'2013-07-06 12:44:32',NULL,NULL),(39506,'44807','S','Carrothers','A','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(12751,'13205','S','Colvin Elmwood','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.006472,-76.148241,0,'2013-07-06 12:44:30',NULL,NULL),(62456,'74330','S','Adair','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.438562,-95.264386,0,'2013-07-06 12:44:33',NULL,NULL),(26950,'29604','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.830301,-82.394264,0,'2013-07-06 12:44:31',NULL,NULL),(32933,'36562','S','Perdido','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.009821,-87.658990,0,'2013-07-06 12:44:32',NULL,NULL),(44641,'50073','S','Elkhart','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.789463,-93.515162,0,'2013-07-06 12:44:32',NULL,NULL),(58737,'68949','S','Holdridge','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.440800,-99.370426,0,'2013-07-06 12:44:33',NULL,NULL),(5350,'04612','S','Bernard','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.240559,-68.362155,0,'2013-07-06 12:44:30',NULL,NULL),(74553,'92676','S','Silverado','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.745069,-117.615251,0,'2013-07-06 12:44:34',NULL,NULL),(12759,'13207','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.017354,-76.167626,0,'2013-07-06 12:44:30',NULL,NULL),(69513,'83717','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.610151,-116.203847,0,'2013-07-06 12:44:34',NULL,NULL),(55400,'63638','S','Ellington','D','Reynolds','29179','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.222438,-90.974306,0,'2013-07-06 12:44:33',NULL,NULL),(44165,'49544','S','Walker','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.001565,-85.743164,0,'2013-07-06 12:44:32',NULL,NULL),(52292,'60538','S','Montgmry','A','Kendall','17093','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.709552,-88.336361,0,'2013-07-06 12:44:33',NULL,NULL),(38958,'44127','S','Cuyahoga Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472030,-81.650481,0,'2013-07-06 12:44:32',NULL,NULL),(37651,'42201','P','Aberdeen','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.253618,-86.684733,0,'2013-07-06 12:44:32',NULL,NULL),(74907,'93313','S','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.254233,-119.060086,0,'2013-07-06 12:44:34',NULL,NULL),(10586,'11023','S','Harbor Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.798973,-73.733349,0,'2013-07-06 12:44:30',NULL,NULL),(26456,'29138','S','Saluda','D','Saluda','45081','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.007368,-81.769758,0,'2013-07-06 12:44:31',NULL,NULL),(37879,'42565','S','Windsor','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.179714,-84.915007,0,'2013-07-06 12:44:32',NULL,NULL),(285,'00646','S','Paseo del Sol','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(43113,'48224','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.411143,-82.943461,0,'2013-07-06 12:44:32',NULL,NULL),(53135,'61550','S','Morton','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613787,-89.463814,0,'2013-07-06 12:44:33',NULL,NULL),(38240,'43251','U','National City Bank','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.959725,-83.020801,0,'2013-07-06 12:44:32',NULL,NULL),(36307,'40371','S','Sudith','A','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.084878,-83.623075,0,'2013-07-06 12:44:32',NULL,NULL),(79499,'98904','P','Gleed','A','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.602180,-120.504720,0,'2013-07-06 12:44:34',NULL,NULL),(28053,'30668','S','Tignall','D','Wilkes','13317','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.782130,-82.816561,0,'2013-07-06 12:44:31',NULL,NULL),(77651,'97016','S','Mist','N','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.996389,-123.255278,0,'2013-07-06 12:44:34',NULL,NULL),(72044,'88065','P','Tyrone','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.669917,-108.292553,0,'2013-07-06 12:44:34',NULL,NULL),(39059,'44197','U','BRM Unique Firm ZIP','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.480998,-81.681696,0,'2013-07-06 12:44:32',NULL,NULL),(37057,'41301','S','Maytown','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.742837,-83.449664,0,'2013-07-06 12:44:32',NULL,NULL),(61290,'72410','S','Alicia','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.127822,-90.924239,0,'2013-07-06 12:44:33',NULL,NULL),(60514,'71667','S','Crigler','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(59633,'71038','S','Blackburn','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(40409,'45681','S','South Salem','D','Ross','39141','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.308066,-83.258473,0,'2013-07-06 12:44:32',NULL,NULL),(20358,'20874','S','Darnestown','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.167973,-77.268161,0,'2013-07-06 12:44:31',NULL,NULL),(77333,'96714','P','Hanalei','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.216648,-159.481698,0,'2013-07-06 12:44:34',NULL,NULL),(71893,'87743','S','Roy','D','Harding','35021','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.936248,-104.193889,0,'2013-07-06 12:44:34',NULL,NULL),(45452,'51238','S','Newkirk','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.069984,-95.904488,0,'2013-07-06 12:44:32',NULL,NULL),(7676,'07096','P','Plaza','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.781235,-74.064580,0,'2013-07-06 12:44:30',NULL,NULL),(42047,'47446','S','Georgia','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(63465,'75685','P','Panola','D','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.441546,-93.973308,0,'2013-07-06 12:44:33',NULL,NULL),(68169,'81008','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.327052,-104.625950,0,'2013-07-06 12:44:34',NULL,NULL),(71347,'86514','S','Red Mesa','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750658,-109.364054,0,'2013-07-06 12:44:34',NULL,NULL),(37546,'42063','P','Lynnville','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.559278,-88.568383,0,'2013-07-06 12:44:32',NULL,NULL),(30771,'33575','P','Sun City Center','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.714551,-82.419142,0,'2013-07-06 12:44:32',NULL,NULL),(26541,'29204','S','Edgewood','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.028919,-80.998590,0,'2013-07-06 12:44:31',NULL,NULL),(62643,'74570','S','Stuart','D','Hughes','40063','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.895073,-96.157838,0,'2013-07-06 12:44:33',NULL,NULL),(22201,'23511','S','Naval Base','A','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.942636,-76.307176,0,'2013-07-06 12:44:31',NULL,NULL),(16533,'17268','S','Weltys','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(63208,'75443','P','Gober','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.554307,-96.044109,0,'2013-07-06 12:44:33',NULL,NULL),(54401,'62823','S','Enterprise','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.515855,-88.366410,0,'2013-07-06 12:44:33',NULL,NULL),(75608,'94401','S','San Mateo','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.573151,-122.320510,0,'2013-07-06 12:44:34',NULL,NULL),(76312,'95450','S','Fort Ross','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.499360,-123.185160,0,'2013-07-06 12:44:34',NULL,NULL),(1793,'00783','S','Urb Cibuco','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(54017,'62452','S','Parkersburg','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.592078,-88.064006,0,'2013-07-06 12:44:33',NULL,NULL),(36827,'41071','S','Newport','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(4157,'02769','S','Rehoboth','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.847903,-71.252629,0,'2013-07-06 12:44:30',NULL,NULL),(57512,'66961','P','Norway','D','Republic','20157','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.698981,-97.829778,0,'2013-07-06 12:44:33',NULL,NULL),(15925,'17020','S','Duncannon','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(30216,'33185','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.716424,-80.437255,0,'2013-07-06 12:44:32',NULL,NULL),(38187,'43199','U','Groveport','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.859691,-82.894413,0,'2013-07-06 12:44:32',NULL,NULL),(29806,'33023','S','West Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(56888,'66036','P','Hillsdale','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.662298,-94.852003,0,'2013-07-06 12:44:33',NULL,NULL),(4609,'03590','S','North Stratford','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.719190,-71.465831,0,'2013-07-06 12:44:30',NULL,NULL),(61056,'72121','S','Dewey','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(10527,'10984','S','Thiells','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.206448,-74.015747,0,'2013-07-06 12:44:30',NULL,NULL),(37994,'42749','S','Park','A','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.185069,-85.878778,0,'2013-07-06 12:44:32',NULL,NULL),(37477,'42001','S','Massac','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(9156,'09312','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71438,'87034','P','Pblo of Acoma','A','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084674,-107.598482,0,'2013-07-06 12:44:34',NULL,NULL),(76983,'96063','P','Mineral','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.360478,-121.564354,0,'2013-07-06 12:44:34',NULL,NULL),(31597,'34667','S','Port Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.393847,-82.651438,0,'2013-07-06 12:44:32',NULL,NULL),(57973,'67835','S','Cimarron','D','Gray','20069','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.904580,-100.332780,0,'2013-07-06 12:44:33',NULL,NULL),(13739,'14109','P','Niagara Univ','A','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.134350,-79.035930,0,'2013-07-06 12:44:31',NULL,NULL),(27584,'30281','S','Stockbridge','D','Henry','13151','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.553217,-84.213596,0,'2013-07-06 12:44:31',NULL,NULL),(31259,'33991','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.629052,-82.002027,0,'2013-07-06 12:44:32',NULL,NULL),(64031,'76123','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.625915,-97.368031,0,'2013-07-06 12:44:34',NULL,NULL),(61308,'72431','P','Grubbs','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.655714,-91.076929,0,'2013-07-06 12:44:33',NULL,NULL),(60614,'71859','S','Okay','N','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.774332,-93.884417,0,'2013-07-06 12:44:33',NULL,NULL),(53480,'61943','S','Oakland','D','Coles','17029','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.655691,-88.026167,0,'2013-07-06 12:44:33',NULL,NULL),(52371,'60618','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.944335,-87.702859,0,'2013-07-06 12:44:33',NULL,NULL),(40934,'46290','S','Indianapolis','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.936276,-86.211203,0,'2013-07-06 12:44:32',NULL,NULL),(39385,'44653','P','Midvale','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.437941,-81.370867,0,'2013-07-06 12:44:32',NULL,NULL),(16364,'17201','S','Housum','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(29435,'32686','S','Reddick','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.358780,-82.252850,0,'2013-07-06 12:44:32',NULL,NULL),(73171,'90307','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.954677,-118.373609,0,'2013-07-06 12:44:34',NULL,NULL),(37561,'42071','S','College Campus','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(9439,'10005','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708119,-74.012238,0,'2013-07-06 12:44:30',NULL,NULL),(60592,'71834','S','Doddridge','D','Miller','05091','Arkansas','AR','05','8360','870','Central',-6.0,'Y',33.118192,-93.958398,0,'2013-07-06 12:44:33',NULL,NULL),(31730,'34983','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308284,-80.348414,0,'2013-07-06 12:44:32',NULL,NULL),(38555,'43759','P','Morristown','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.060403,-81.071245,0,'2013-07-06 12:44:32',NULL,NULL),(69459,'83650','S','Oreana','A','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.053611,-116.394167,0,'2013-07-06 12:44:34',NULL,NULL),(35304,'39401','S','Sunrise','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(64207,'76261','S','Ringgold','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.804982,-97.949011,0,'2013-07-06 12:44:34',NULL,NULL),(63388,'75644','S','Sand Hill','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(57304,'66625','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.047811,-95.683248,0,'2013-07-06 12:44:33',NULL,NULL),(5465,'04736','S','Woodland','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.847780,-68.010473,0,'2013-07-06 12:44:30',NULL,NULL),(64468,'76574','S','Waterloo','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(4618,'03598','S','Carroll','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.376161,-71.618637,0,'2013-07-06 12:44:30',NULL,NULL),(66362,'78616','S','Lytton Springs','N','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.029845,-97.571615,0,'2013-07-06 12:44:34',NULL,NULL),(23335,'25245','S','Rock Castle','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.680155,-81.685128,0,'2013-07-06 12:44:31',NULL,NULL),(19922,'20555','U','Nuclear Regulatory Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896447,-77.041074,0,'2013-07-06 12:44:31',NULL,NULL),(27467,'30142','P','Holly Springs','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.175472,-84.498039,0,'2013-07-06 12:44:31',NULL,NULL),(37312,'41647','S','E Mc Dowell','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.427384,-82.743993,0,'2013-07-06 12:44:32',NULL,NULL),(79113,'98466','S','University Place','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225803,-122.534108,0,'2013-07-06 12:44:34',NULL,NULL),(10836,'11385','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702860,-73.879740,0,'2013-07-06 12:44:30',NULL,NULL),(11451,'11978','S','W Hampton Beach','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.811711,-72.645053,0,'2013-07-06 12:44:30',NULL,NULL),(2030,'00917','S','Urb El Prado','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(45386,'51027','S','Ireton','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.975452,-96.317851,0,'2013-07-06 12:44:32',NULL,NULL),(25711,'28542','P','Cp Lejeune Mcb','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.697778,-77.352038,0,'2013-07-06 12:44:31',NULL,NULL),(76044,'95161','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.385740,-121.899338,0,'2013-07-06 12:44:34',NULL,NULL),(55282,'63471','S','Taylor','D','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.913920,-91.510680,0,'2013-07-06 12:44:33',NULL,NULL),(79934,'99615','S','Kodiak','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.804109,-152.453963,0,'2013-07-06 12:44:34',NULL,NULL),(34757,'38858','S','Nettleton','D','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.076707,-88.619807,0,'2013-07-06 12:44:32',NULL,NULL),(41247,'46742','S','Island Park','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(43827,'49085','S','Shoreham','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.068065,-86.475496,0,'2013-07-06 12:44:32',NULL,NULL),(11861,'12288','U','Us Postal Service','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.728717,-73.847757,0,'2013-07-06 12:44:30',NULL,NULL),(60609,'71855','S','Ozan','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.878935,-93.742793,0,'2013-07-06 12:44:33',NULL,NULL),(56804,'65769','S','Verona','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.961558,-93.795732,0,'2013-07-06 12:44:33',NULL,NULL),(26021,'28677','S','Sharon','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(43977,'49327','S','Grant','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.341807,-85.830102,0,'2013-07-06 12:44:32',NULL,NULL),(36440,'40602','P','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.213933,-84.816581,0,'2013-07-06 12:44:32',NULL,NULL),(39100,'44234','S','Hiram','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.313003,-81.156535,0,'2013-07-06 12:44:32',NULL,NULL),(9662,'10039','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(70079,'84151','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.787872,-111.938789,0,'2013-07-06 12:44:34',NULL,NULL),(75694,'94564','S','Pinole','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.998695,-122.286973,0,'2013-07-06 12:44:34',NULL,NULL),(19787,'20429','U','Federal Deposit Ins Corp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891450,-77.040790,0,'2013-07-06 12:44:31',NULL,NULL),(13873,'14241','U','USPS Buffalo AMF','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927923,-78.747650,0,'2013-07-06 12:44:31',NULL,NULL),(33798,'37890','S','Baneberry','A','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.061640,-83.260110,0,'2013-07-06 12:44:32',NULL,NULL),(10078,'10199','S','Gpo Official Mail','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.726252,-73.979012,0,'2013-07-06 12:44:30',NULL,NULL),(22708,'24343','S','Richardson','N','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.764206,-80.736826,0,'2013-07-06 12:44:31',NULL,NULL),(78117,'97503','S','Medford','A','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.418373,-122.814932,0,'2013-07-06 12:44:34',NULL,NULL),(64283,'76439','P','Dennis','D','Parker','48367','Texas','TX','48','2800','940','Central',-6.0,'Y',32.619991,-97.924460,0,'2013-07-06 12:44:34',NULL,NULL),(55036,'63138','S','North County','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.795220,-90.209040,0,'2013-07-06 12:44:33',NULL,NULL),(54726,'62964','S','Mounds','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.116221,-89.194753,0,'2013-07-06 12:44:33',NULL,NULL),(46148,'52657','S','Saint Paul','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.768772,-91.541663,0,'2013-07-06 12:44:32',NULL,NULL),(19729,'20398','S','Washington Na','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876127,-76.994243,0,'2013-07-06 12:44:31',NULL,NULL),(21019,'21852','P','Powellville','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.349503,-75.405489,0,'2013-07-06 12:44:31',NULL,NULL),(39455,'44706','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.771402,-81.413102,0,'2013-07-06 12:44:32',NULL,NULL),(43571,'48734','S','Frankenmuth','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.340608,-83.747615,0,'2013-07-06 12:44:32',NULL,NULL),(820,'00693','S','Urb Ocean Front','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(76913,'95993','S','Yuba City','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.126202,-121.664894,0,'2013-07-06 12:44:34',NULL,NULL),(75966,'95053','U','Santa Clara University','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.347920,-121.936525,0,'2013-07-06 12:44:34',NULL,NULL),(52897,'61356','S','Coal Hollow','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.371332,-89.463511,0,'2013-07-06 12:44:33',NULL,NULL),(49890,'57270','S','Hillhead','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.864739,-97.284259,0,'2013-07-06 12:44:33',NULL,NULL),(40759,'46148','S','Knightstown','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.794447,-85.525839,0,'2013-07-06 12:44:32',NULL,NULL),(17002,'17737','S','Glen Mawr','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257740,-76.713780,0,'2013-07-06 12:44:31',NULL,NULL),(1349,'00736','S','Hacienda Vistas Del Plata','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(7561,'07021','S','Essex Fells','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.830223,-74.280703,0,'2013-07-06 12:44:30',NULL,NULL),(32281,'35653','S','Littleville','A','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.508322,-87.740943,0,'2013-07-06 12:44:32',NULL,NULL),(7240,'06511','S','Hamden','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.327048,-72.940381,0,'2013-07-06 12:44:30',NULL,NULL),(74874,'93268','S','Taft','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.172101,-119.431600,0,'2013-07-06 12:44:34',NULL,NULL),(64683,'76834','S','Fisk','N','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.833600,-99.415500,0,'2013-07-06 12:44:34',NULL,NULL),(56508,'65349','S','Saline City','N','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.214173,-93.069492,0,'2013-07-06 12:44:33',NULL,NULL),(48571,'55769','S','Nashwauk','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379684,-93.166650,0,'2013-07-06 12:44:33',NULL,NULL),(44875,'50313','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.641599,-93.617602,0,'2013-07-06 12:44:32',NULL,NULL),(39193,'44325','U','Univ of Akron','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.076672,-81.510338,0,'2013-07-06 12:44:32',NULL,NULL),(21036,'21869','S','Elliott','N','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.432760,-75.893700,0,'2013-07-06 12:44:31',NULL,NULL),(26636,'29333','P','Drayton','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.004529,-81.874135,0,'2013-07-06 12:44:31',NULL,NULL),(13879,'14261','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.002450,-78.781965,0,'2013-07-06 12:44:31',NULL,NULL),(32776,'36401','S','Burnt Corn','A','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.430309,-86.956166,0,'2013-07-06 12:44:32',NULL,NULL),(101,'00612','S','Urb Garden View','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(73620,'91405','S','Valley Glen','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201681,-118.446452,0,'2013-07-06 12:44:34',NULL,NULL),(57803,'67504','P','Hutchinson','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.025338,-97.936497,0,'2013-07-06 12:44:33',NULL,NULL),(53068,'61520','S','Breeds','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.516944,-89.908333,0,'2013-07-06 12:44:33',NULL,NULL),(37552,'42064','S','New Salem','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(421,'00662','S','Repto Yomaira','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(33163,'37020','S','Bell Buckle','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.604064,-86.410407,0,'2013-07-06 12:44:32',NULL,NULL),(30862,'33662','U','Time Inc','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.971741,-82.348435,0,'2013-07-06 12:44:32',NULL,NULL),(7414,'06804','S','Brookfield Center','N','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.466931,-73.395508,0,'2013-07-06 12:44:30',NULL,NULL),(72424,'89067','S','Coyote Spgs','A','Clark','32003','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.675655,-114.620214,0,'2013-07-06 12:44:34',NULL,NULL),(70207,'84401','S','Mriott Sltrvl','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(65133,'77383','P','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.074289,-95.422790,0,'2013-07-06 12:44:34',NULL,NULL),(64649,'76797','U','Amer Income Life Ins','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.532449,-97.190218,0,'2013-07-06 12:44:34',NULL,NULL),(49946,'57340','S','Plano','N','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.726969,-97.822202,0,'2013-07-06 12:44:33',NULL,NULL),(41823,'47338','S','Shideler','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.342989,-85.353750,0,'2013-07-06 12:44:32',NULL,NULL),(36462,'40730','P','Emlyn','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.706420,-84.146051,0,'2013-07-06 12:44:32',NULL,NULL),(19459,'20129','S','Paeonian Springs','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.156021,-77.597753,0,'2013-07-06 12:44:31',NULL,NULL),(31288,'34039','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(39021,'44143','S','Highland Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(8326,'08036','S','Hainesport Township','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.984745,-74.830958,0,'2013-07-06 12:44:30',NULL,NULL),(77844,'97222','S','Portland','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.437695,-122.614273,0,'2013-07-06 12:44:34',NULL,NULL),(53352,'61764','S','Cayuga','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(47393,'54638','S','Kendall','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.811197,-90.403788,0,'2013-07-06 12:44:32',NULL,NULL),(46198,'52752','P','Grandview','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.279733,-91.188208,0,'2013-07-06 12:44:32',NULL,NULL),(14017,'14536','S','Portageville','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.550639,-78.081712,0,'2013-07-06 12:44:31',NULL,NULL),(5522,'04777','S','Hrsytown Twp','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.896021,-68.492070,0,'2013-07-06 12:44:30',NULL,NULL),(76763,'95928','S','Butte Creek','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.724307,-121.813534,0,'2013-07-06 12:44:34',NULL,NULL),(75130,'93554','P','Johannesburg','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.375287,-117.664370,0,'2013-07-06 12:44:34',NULL,NULL),(68606,'81612','P','Aspen','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.207734,-106.850820,0,'2013-07-06 12:44:34',NULL,NULL),(67216,'79920','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.823595,-106.463282,0,'2013-07-06 12:44:34',NULL,NULL),(49830,'57223','S','Castlewood','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.726786,-97.027942,0,'2013-07-06 12:44:33',NULL,NULL),(41180,'46714','S','Domestic','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(28937,'32175','P','Ormond Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.286677,-81.055778,0,'2013-07-06 12:44:32',NULL,NULL),(32661,'36258','S','Delta','D','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.454247,-85.684409,0,'2013-07-06 12:44:32',NULL,NULL),(6177,'05474','S','Knights Point','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(67056,'79556','S','Palava','N','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.465940,-100.386240,0,'2013-07-06 12:44:34',NULL,NULL),(65767,'78102','S','Beeville','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.403356,-97.749054,0,'2013-07-06 12:44:34',NULL,NULL),(38076,'43069','U','Reynoldsburg','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.963450,-82.782984,0,'2013-07-06 12:44:32',NULL,NULL),(13072,'13454','S','Salisbury Center','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.231609,-74.791568,0,'2013-07-06 12:44:30',NULL,NULL),(35498,'39529','U','National Space Technology La','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(33412,'37235','U','Vanderbilt University','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.148097,-86.805447,0,'2013-07-06 12:44:32',NULL,NULL),(29655,'32906','P','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.012469,-80.627582,0,'2013-07-06 12:44:32',NULL,NULL),(15096,'15764','S','Oliveburg','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.000222,-79.038536,0,'2013-07-06 12:44:31',NULL,NULL),(23092,'24924','S','Buckeye','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.190266,-80.142658,0,'2013-07-06 12:44:31',NULL,NULL),(24980,'27852','S','Old Sparta','N','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.778300,-77.587620,0,'2013-07-06 12:44:31',NULL,NULL),(37503,'42031','S','New Cypress','N','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(6244,'05492','S','Belvidere Junction','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.717268,-72.755250,0,'2013-07-06 12:44:30',NULL,NULL),(67541,'80260','S','Northglenn','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.866033,-105.004313,0,'2013-07-06 12:44:34',NULL,NULL),(67439,'80203','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.731434,-104.981595,0,'2013-07-06 12:44:34',NULL,NULL),(15022,'15681','S','Saltsburg','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.488961,-79.449454,0,'2013-07-06 12:44:31',NULL,NULL),(58537,'68813','S','Anselmo','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.641920,-99.771120,0,'2013-07-06 12:44:33',NULL,NULL),(62303,'74028','S','Depew','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.803536,-96.508453,0,'2013-07-06 12:44:33',NULL,NULL),(48113,'55353','S','Kimball','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.359002,-94.296954,0,'2013-07-06 12:44:33',NULL,NULL),(45330,'50858','S','Zion','N','Adair','19001','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204707,-94.422418,0,'2013-07-06 12:44:32',NULL,NULL),(25294,'28139','S','Ruth','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(25918,'28647','P','Linville Fls','A','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.956741,-81.944180,0,'2013-07-06 12:44:31',NULL,NULL),(2081,'00921','S','Urb La Riviera Ind Park','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(13537,'13827','S','Flemingville','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(67945,'80912','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(64289,'76446','S','Dublin','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.087767,-98.341739,0,'2013-07-06 12:44:34',NULL,NULL),(58512,'68774','S','South Yankton','N','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.821267,-97.340702,0,'2013-07-06 12:44:33',NULL,NULL),(53844,'62321','S','Carthage','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.344444,-91.111667,0,'2013-07-06 12:44:33',NULL,NULL),(47478,'54746','S','Humbird','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.544399,-90.870773,0,'2013-07-06 12:44:32',NULL,NULL),(9624,'10034','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(7026,'06265','P','S Willington','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.854519,-72.301887,0,'2013-07-06 12:44:30',NULL,NULL),(12188,'12775','S','Rock Hill','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.616893,-74.583219,0,'2013-07-06 12:44:30',NULL,NULL),(20094,'20703','P','Lanham','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.966944,-76.862222,0,'2013-07-06 12:44:31',NULL,NULL),(15582,'16660','P','Mc Conelstown','A','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.449212,-78.082861,0,'2013-07-06 12:44:31',NULL,NULL),(4800,'03883','S','S Tamworth','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.839632,-71.313989,0,'2013-07-06 12:44:30',NULL,NULL),(2060,'00920','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(71182,'86043','P','Toreva','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.805000,-110.491944,0,'2013-07-06 12:44:34',NULL,NULL),(58375,'68529','P','Havelock','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.852903,-96.613110,0,'2013-07-06 12:44:33',NULL,NULL),(57117,'66223','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(52926,'61371','P','Triumph','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.498164,-89.024348,0,'2013-07-06 12:44:33',NULL,NULL),(34775,'38863','S','Zion','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(34260,'38455','P','Elkton','D','Giles','47055','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.083297,-86.888381,0,'2013-07-06 12:44:32',NULL,NULL),(16442,'17236','S','Cove Gap','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(12672,'13126','S','Fruit Valley','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(48519,'55746','S','Leetonia','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(60780,'72021','S','Brinkley','D','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.891991,-91.193555,0,'2013-07-06 12:44:33',NULL,NULL),(6602,'05867','S','East Sutton Ridge','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663871,-72.037012,0,'2013-07-06 12:44:30',NULL,NULL),(39779,'45122','S','Goshen','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.222960,-84.120240,0,'2013-07-06 12:44:32',NULL,NULL),(40298,'45448','U','Metropolitan Life','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.647561,-84.169843,0,'2013-07-06 12:44:32',NULL,NULL),(46532,'53401','P','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.691955,-87.814781,0,'2013-07-06 12:44:32',NULL,NULL),(54836,'63033','S','Florissant','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.794669,-90.277021,0,'2013-07-06 12:44:33',NULL,NULL),(47773,'55041','S','Lake City','D','Wabasha','27157','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.444479,-92.269817,0,'2013-07-06 12:44:33',NULL,NULL),(79866,'99559','P','Newtok','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.940000,-164.620000,0,'2013-07-06 12:44:34',NULL,NULL),(7151,'06417','S','Deep River','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.373550,-72.495583,0,'2013-07-06 12:44:30',NULL,NULL),(17748,'18323','P','Buck Hill Fls','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.187496,-75.264475,0,'2013-07-06 12:44:31',NULL,NULL),(46275,'53031','P','Hingham','D','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.639932,-87.919809,0,'2013-07-06 12:44:32',NULL,NULL),(33535,'37384','P','Soddy Daisy','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.275049,-85.167714,0,'2013-07-06 12:44:32',NULL,NULL),(1305,'00731','S','Urb Terra Senorial','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014073,-66.617175,0,'2013-07-06 12:44:30',NULL,NULL),(14996,'15656','S','W Leechburg','A','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.629851,-79.604848,0,'2013-07-06 12:44:31',NULL,NULL),(74137,'92248','P','La Quinta','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.675895,-116.303058,0,'2013-07-06 12:44:34',NULL,NULL),(77527,'96847','U','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.301543,-157.845453,0,'2013-07-06 12:44:34',NULL,NULL),(29761,'33008','P','Hallandale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986952,-80.140539,0,'2013-07-06 12:44:32',NULL,NULL),(40790,'46168','S','Plainfield','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.709427,-86.395053,0,'2013-07-06 12:44:32',NULL,NULL),(49795,'57110','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.544300,-96.638702,0,'2013-07-06 12:44:33',NULL,NULL),(60029,'71343','S','Archie','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(65684,'77995','S','Hope','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(6550,'05842','S','Stannard','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.556900,-72.251340,0,'2013-07-06 12:44:30',NULL,NULL),(66749,'79007','S','Borger','D','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.677980,-101.416380,0,'2013-07-06 12:44:34',NULL,NULL),(59031,'70083','S','Home Place','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.446151,-89.764678,0,'2013-07-06 12:44:33',NULL,NULL),(72155,'88325','P','Mountain Park','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.076011,-106.025093,0,'2013-07-06 12:44:34',NULL,NULL),(73395,'91116','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.143178,-118.128197,0,'2013-07-06 12:44:34',NULL,NULL),(2683,'00968','S','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(175,'00623','S','Haciendas De Belvedere','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(32063,'35266','P','Vestavia Hills','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(11910,'12409','S','Shady','A','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.037380,-74.175180,0,'2013-07-06 12:44:30',NULL,NULL),(55732,'64085','S','Richmond','D','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.279528,-93.976207,0,'2013-07-06 12:44:33',NULL,NULL),(47347,'54603','S','La Crosse','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.848862,-91.249344,0,'2013-07-06 12:44:32',NULL,NULL),(46639,'53593','S','Verona','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.992600,-89.570110,0,'2013-07-06 12:44:32',NULL,NULL),(41991,'47424','S','Calvertville','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(24008,'26351','S','Glenville','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.938379,-80.837080,0,'2013-07-06 12:44:31',NULL,NULL),(30052,'33146','S','Coconut Grove','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.719595,-80.272159,0,'2013-07-06 12:44:32',NULL,NULL),(15914,'17018','S','Dauphin','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.370886,-76.931434,0,'2013-07-06 12:44:31',NULL,NULL),(64293,'76450','S','Graham','D','Young','48503','Texas','TX','48','0000','940','Central',-6.0,'Y',33.063225,-98.633058,0,'2013-07-06 12:44:34',NULL,NULL),(55481,'63755','S','Jackson','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.384771,-89.659833,0,'2013-07-06 12:44:33',NULL,NULL),(928,'00714','S','Urb Belinda','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(30906,'33706','S','Treasure Is','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(12805,'13250','U','Caller Firms Brm','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.122569,-76.132866,0,'2013-07-06 12:44:30',NULL,NULL),(68823,'82501','S','Midval','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(63786,'75956','S','Kirbyville','D','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(22113,'23430','S','Smithfield','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.984938,-76.619668,0,'2013-07-06 12:44:31',NULL,NULL),(49677,'57014','S','Dalesburg','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.140734,-96.992306,0,'2013-07-06 12:44:33',NULL,NULL),(44184,'49601','S','Cadillac','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.256670,-85.445220,0,'2013-07-06 12:44:32',NULL,NULL),(35447,'39480','S','Soso','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.763949,-89.320828,0,'2013-07-06 12:44:32',NULL,NULL),(72313,'88905','U','Citibank','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.143477,-115.279371,0,'2013-07-06 12:44:34',NULL,NULL),(38446,'43603','P','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.658070,-83.527385,0,'2013-07-06 12:44:32',NULL,NULL),(36136,'40228','S','Hollow Creek','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.139470,-85.630403,0,'2013-07-06 12:44:32',NULL,NULL),(9455,'10007','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(883,'00703','S','Urb San Antonio','N','Aguas Buenas','72007','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.261636,-66.103857,0,'2013-07-06 12:44:30',NULL,NULL),(56951,'66097','S','Winchester','D','Jefferson','20087','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.304737,-95.274703,0,'2013-07-06 12:44:33',NULL,NULL),(14493,'15140','S','Monroeville','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405817,-79.773696,0,'2013-07-06 12:44:31',NULL,NULL),(388,'00662','S','Brisas del Canal','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(72092,'88202','P','Roswell','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.348619,-104.490865,0,'2013-07-06 12:44:34',NULL,NULL),(40820,'46206','P','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.742836,-86.159777,0,'2013-07-06 12:44:32',NULL,NULL),(31372,'34211','S','Brad','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.469714,-82.411482,0,'2013-07-06 12:44:32',NULL,NULL),(55447,'63702','P','Cape Girardeau','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.310950,-89.625937,0,'2013-07-06 12:44:33',NULL,NULL),(20708,'21270','P','Reisterstown Rd Plaza','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.359071,-76.704770,0,'2013-07-06 12:44:31',NULL,NULL),(974,'00716','S','Urb Sagrado Corazon','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(39673,'45014','S','Fairfield','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.334440,-84.562260,0,'2013-07-06 12:44:32',NULL,NULL),(50320,'57724','S','Gustave','N','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.615420,-103.933080,0,'2013-07-06 12:44:33',NULL,NULL),(72548,'89191','P','Nellis AFB','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.244017,-115.040965,0,'2013-07-06 12:44:34',NULL,NULL),(77427,'96803','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308655,-157.858561,0,'2013-07-06 12:44:34',NULL,NULL),(53737,'62252','P','Huey','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.604272,-89.290238,0,'2013-07-06 12:44:33',NULL,NULL),(11991,'12480','S','Shandaken','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.129960,-74.384640,0,'2013-07-06 12:44:30',NULL,NULL),(46365,'53118','S','Dousman','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.976521,-88.480955,0,'2013-07-06 12:44:32',NULL,NULL),(71974,'88020','S','Cotton City','N','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',31.948375,-108.813066,0,'2013-07-06 12:44:34',NULL,NULL),(24156,'26586','P','Montana Mines','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.520447,-80.114901,0,'2013-07-06 12:44:31',NULL,NULL),(66478,'78663','S','Round Mountain','D','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.441858,-98.468024,0,'2013-07-06 12:44:34',NULL,NULL),(60596,'71838','S','Fulton','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.629501,-93.816318,0,'2013-07-06 12:44:33',NULL,NULL),(58594,'68845','S','Kearney','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.728578,-99.160032,0,'2013-07-06 12:44:33',NULL,NULL),(35894,'40008','S','Bloomfield','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.906036,-85.288243,0,'2013-07-06 12:44:32',NULL,NULL),(45351,'50981','U','HP-SC/YE','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582831,-93.639369,0,'2013-07-06 12:44:32',NULL,NULL),(18719,'19311','S','Avondale','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.822055,-75.777223,0,'2013-07-06 12:44:31',NULL,NULL),(16089,'17051','S','Atkinsons Mills','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(66919,'79331','S','La Mesa','A','Dawson','48115','Texas','TX','48','0000','806','Central',-6.0,'Y',32.734510,-101.955850,0,'2013-07-06 12:44:34',NULL,NULL),(71952,'87943','S','Chloride','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.338611,-107.677222,0,'2013-07-06 12:44:34',NULL,NULL),(2430,'00953','S','Urb La Providencia','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(3064,'01118','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.093934,-72.527899,0,'2013-07-06 12:44:30',NULL,NULL),(1567,'00766','S','Vista Alegre','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(69229,'83403','P','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.479402,-111.982911,0,'2013-07-06 12:44:34',NULL,NULL),(59047,'70085','S','St Bernard','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(71208,'86305','S','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.542870,-112.468447,0,'2013-07-06 12:44:34',NULL,NULL),(69805,'84070','S','Crescent','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.571551,-111.884711,0,'2013-07-06 12:44:34',NULL,NULL),(11544,'12051','S','Coxsackie','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.357823,-73.807318,0,'2013-07-06 12:44:30',NULL,NULL),(56155,'64857','P','Purcell','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.241722,-94.435865,0,'2013-07-06 12:44:33',NULL,NULL),(52509,'60804','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.843375,-87.763267,0,'2013-07-06 12:44:33',NULL,NULL),(10113,'10258','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713720,-74.007559,0,'2013-07-06 12:44:30',NULL,NULL),(45728,'52079','S','Otter Creek','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.309240,-90.722340,0,'2013-07-06 12:44:32',NULL,NULL),(19510,'20171','S','Oak Hill','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.925711,-77.403864,0,'2013-07-06 12:44:31',NULL,NULL),(26611,'29303','S','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.018040,-81.976140,0,'2013-07-06 12:44:31',NULL,NULL),(22390,'23943','P','Hampden Sydney','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.240559,-78.457075,0,'2013-07-06 12:44:31',NULL,NULL),(184,'00623','S','Parc Las Margaritas','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(66196,'78542','S','Edinburg','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.295473,-98.163736,0,'2013-07-06 12:44:34',NULL,NULL),(4273,'02888','S','Warwick','D','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.748700,-71.411872,0,'2013-07-06 12:44:30',NULL,NULL),(34360,'38603','S','Canaan','A','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.831184,-89.170922,0,'2013-07-06 12:44:32',NULL,NULL),(58206,'68328','S','Clatonia','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.465354,-96.849788,0,'2013-07-06 12:44:33',NULL,NULL),(71606,'87326','P','Chi Chll Tah','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.528056,-108.741944,0,'2013-07-06 12:44:34',NULL,NULL),(39892,'45214','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.120751,-84.543703,0,'2013-07-06 12:44:32',NULL,NULL),(42404,'47747','U','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.982273,-87.567901,0,'2013-07-06 12:44:32',NULL,NULL),(54703,'62952','S','Jonesboro','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.452013,-89.269945,0,'2013-07-06 12:44:33',NULL,NULL),(56016,'64658','S','Marceline','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.714416,-92.947320,0,'2013-07-06 12:44:33',NULL,NULL),(17772,'18340','P','Millrift','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.391718,-74.790682,0,'2013-07-06 12:44:31',NULL,NULL),(9801,'10110','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(25482,'28352','S','Laurinburg','D','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.767212,-79.468392,0,'2013-07-06 12:44:31',NULL,NULL),(41054,'46410','S','Merrillville','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.477940,-87.305820,0,'2013-07-06 12:44:32',NULL,NULL),(38236,'43235','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.120326,-83.033953,0,'2013-07-06 12:44:32',NULL,NULL),(7700,'07112','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.709508,-74.211572,0,'2013-07-06 12:44:30',NULL,NULL),(16010,'17041','P','Lawn','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.218150,-76.541899,0,'2013-07-06 12:44:31',NULL,NULL),(20677,'21234','S','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.391101,-76.535369,0,'2013-07-06 12:44:31',NULL,NULL),(6705,'06063','S','Winsted','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917156,-72.977392,0,'2013-07-06 12:44:30',NULL,NULL),(58575,'68831','S','Dannebrog','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.126147,-98.544364,0,'2013-07-06 12:44:33',NULL,NULL),(52948,'61413','S','Alpha','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.190339,-90.374656,0,'2013-07-06 12:44:33',NULL,NULL),(46501,'53228','S','New Berlin','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.966203,-88.043196,0,'2013-07-06 12:44:32',NULL,NULL),(25913,'28645','S','Upton','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(26769,'29438','S','Edisto Island','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.569486,-80.310046,0,'2013-07-06 12:44:31',NULL,NULL),(22637,'24250','S','Fort Blackmore','D','Scott','51169','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.754746,-82.625126,0,'2013-07-06 12:44:31',NULL,NULL),(11699,'12161','P','S Bethlehem','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.535245,-73.893390,0,'2013-07-06 12:44:30',NULL,NULL),(73145,'90275','S','Rllng Hls Est','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(66826,'79096','S','Wheeler','D','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.440865,-100.274083,0,'2013-07-06 12:44:34',NULL,NULL),(65918,'78239','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.511329,-98.367675,0,'2013-07-06 12:44:34',NULL,NULL),(62567,'74454','S','Porter','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.847041,-95.511485,0,'2013-07-06 12:44:33',NULL,NULL),(29554,'32809','S','Belle Isle','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.471095,-81.389356,0,'2013-07-06 12:44:32',NULL,NULL),(9810,'10111','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758985,-73.978625,0,'2013-07-06 12:44:30',NULL,NULL),(17419,'17921','S','Taylorville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779226,-76.336594,0,'2013-07-06 12:44:31',NULL,NULL),(2996,'01066','P','North Hatfield','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.410613,-72.625559,0,'2013-07-06 12:44:30',NULL,NULL),(8105,'07803','S','Dover','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.880184,-74.596365,0,'2013-07-06 12:44:30',NULL,NULL),(36035,'40177','S','West Point','D','Hardin','21093','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.993837,-85.950334,0,'2013-07-06 12:44:32',NULL,NULL),(46866,'54028','S','Slag Pile','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.955122,-92.285779,0,'2013-07-06 12:44:32',NULL,NULL),(49250,'56474','S','Ponto Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(49714,'57036','S','Turkey Ridge','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.287240,-97.160340,0,'2013-07-06 12:44:33',NULL,NULL),(51645,'59868','S','Seeley Lake','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',47.224412,-113.499488,0,'2013-07-06 12:44:33',NULL,NULL),(61679,'72935','P','Dyer','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.497374,-94.188404,0,'2013-07-06 12:44:33',NULL,NULL),(78795,'98321','S','Burnett','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.157444,-122.073282,0,'2013-07-06 12:44:34',NULL,NULL),(58016,'67879','S','Tribune','D','Greeley','20071','Kansas','KS','20','0000','620','Mountain',-7.0,'Y',38.475095,-101.748829,0,'2013-07-06 12:44:33',NULL,NULL),(54635,'62921','P','New Camp','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.804393,-89.081265,0,'2013-07-06 12:44:33',NULL,NULL),(53827,'62298','S','Waterloo','D','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(42359,'47702','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.954299,-87.558781,0,'2013-07-06 12:44:32',NULL,NULL),(31538,'34492','P','Summerfield','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.992642,-82.049538,0,'2013-07-06 12:44:32',NULL,NULL),(14407,'15063','S','Monongahela','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.195465,-79.933138,0,'2013-07-06 12:44:31',NULL,NULL),(17769,'18335','P','Marshalls Crk','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.080932,-75.167868,0,'2013-07-06 12:44:31',NULL,NULL),(36328,'40387','S','Pomeroyton','A','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.981269,-83.472057,0,'2013-07-06 12:44:32',NULL,NULL),(5368,'04627','S','Deer Isle','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.236473,-68.648686,0,'2013-07-06 12:44:30',NULL,NULL),(78636,'98221','S','Guemes','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.498900,-122.607300,0,'2013-07-06 12:44:34',NULL,NULL),(63870,'76005','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.749659,-97.057175,0,'2013-07-06 12:44:34',NULL,NULL),(23567,'25649','P','Verdunville','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.898738,-81.991915,0,'2013-07-06 12:44:31',NULL,NULL),(28459,'31414','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.049448,-81.050393,0,'2013-07-06 12:44:32',NULL,NULL),(14549,'15211','S','Mt Washington','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.432740,-79.945680,0,'2013-07-06 12:44:31',NULL,NULL),(3826,'02327','P','Bryantville','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.044742,-70.836344,0,'2013-07-06 12:44:30',NULL,NULL),(7338,'06712','S','Waterbury','A','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.495200,-72.974161,0,'2013-07-06 12:44:30',NULL,NULL),(76445,'95605','S','W Sacramento','A','Yolo','06113','California','CA','06','9270','916','Pacific',-8.0,'Y',38.594722,-121.540556,0,'2013-07-06 12:44:34',NULL,NULL),(71224,'86329','P','Humboldt','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.505187,-112.222610,0,'2013-07-06 12:44:34',NULL,NULL),(70213,'84401','S','West Haven','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(65439,'77586','S','Timber Cove','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(63555,'75766','S','Lake Jacksonville','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:33',NULL,NULL),(59225,'70422','S','Hillsdale','A','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.725646,-90.507562,0,'2013-07-06 12:44:33',NULL,NULL),(26763,'29434','S','Cordesville','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.131273,-79.901616,0,'2013-07-06 12:44:31',NULL,NULL),(23139,'24983','S','Sarton','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.562090,-80.514593,0,'2013-07-06 12:44:31',NULL,NULL),(5941,'05257','S','North Bennington','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.930035,-73.246250,0,'2013-07-06 12:44:30',NULL,NULL),(72651,'89430','S','Central Valley','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.764947,-119.324642,0,'2013-07-06 12:44:34',NULL,NULL),(51976,'60150','S','Malta','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.926212,-88.857968,0,'2013-07-06 12:44:33',NULL,NULL),(48722,'55954','S','Mabel','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.507778,-91.869444,0,'2013-07-06 12:44:33',NULL,NULL),(2901,'00987','S','Urb Metropolis','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(29617,'32860','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.624797,-81.429589,0,'2013-07-06 12:44:32',NULL,NULL),(9374,'09832','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(23900,'26201','S','Tennerton','A','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.983537,-80.225375,0,'2013-07-06 12:44:31',NULL,NULL),(19335,'20032','S','Washingtn','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(23365,'25271','S','Ripley','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.814793,-81.707302,0,'2013-07-06 12:44:31',NULL,NULL),(39291,'44490','S','Washingtonvle','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.899998,-80.761464,0,'2013-07-06 12:44:32',NULL,NULL),(45687,'52046','S','Farley','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.453542,-91.009472,0,'2013-07-06 12:44:32',NULL,NULL),(12421,'12944','S','Keeseville','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.493052,-73.480994,0,'2013-07-06 12:44:30',NULL,NULL),(76421,'95567','S','Smith River','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.927467,-124.164768,0,'2013-07-06 12:44:34',NULL,NULL),(75885,'94957','P','Ross','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.964848,-122.555077,0,'2013-07-06 12:44:34',NULL,NULL),(70274,'84526','S','Standardville','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(66354,'78612','S','Lost Pines','A','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.072856,-97.521573,0,'2013-07-06 12:44:34',NULL,NULL),(42705,'47996','P','West Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.443842,-86.911409,0,'2013-07-06 12:44:32',NULL,NULL),(37616,'42135','P','Franklin','D','Simpson','21213','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.716493,-86.577334,0,'2013-07-06 12:44:32',NULL,NULL),(34617,'38751','S','Saints Rest','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(35028,'39159','S','Rolling Fork','D','Sharkey','28125','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.897670,-90.882023,0,'2013-07-06 12:44:32',NULL,NULL),(13137,'13495','S','Yorkville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.114065,-75.274396,0,'2013-07-06 12:44:30',NULL,NULL),(78883,'98357','P','Neah Bay','D','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.369349,-124.626924,0,'2013-07-06 12:44:34',NULL,NULL),(50642,'58311','S','Alsen','D','Cavalier','38019','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.629815,-98.589847,0,'2013-07-06 12:44:33',NULL,NULL),(47122,'54451','S','Perkinstown','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(46944,'54165','S','Isaar','N','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.500193,-88.301344,0,'2013-07-06 12:44:32',NULL,NULL),(45908,'52320','S','Olin','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.004912,-91.137564,0,'2013-07-06 12:44:32',NULL,NULL),(45280,'50677','S','Horton','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.716220,-92.425620,0,'2013-07-06 12:44:32',NULL,NULL),(34585,'38740','S','Deeson','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.777156,-90.722884,0,'2013-07-06 12:44:32',NULL,NULL),(33835,'37933','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.866070,-84.124099,0,'2013-07-06 12:44:32',NULL,NULL),(12073,'12548','S','Modena','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.655818,-74.112788,0,'2013-07-06 12:44:30',NULL,NULL),(1664,'00773','S','Urb Los Paisajes','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(19682,'20370','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878761,-76.994199,0,'2013-07-06 12:44:31',NULL,NULL),(24277,'26852','S','Purgitsville','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.264244,-78.898607,0,'2013-07-06 12:44:31',NULL,NULL),(20755,'21409','S','Annapolis','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.022100,-76.450111,0,'2013-07-06 12:44:31',NULL,NULL),(36217,'40282','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254860,-85.766403,0,'2013-07-06 12:44:32',NULL,NULL),(4677,'03785','S','Benton','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.149423,-72.034577,0,'2013-07-06 12:44:30',NULL,NULL),(79281,'98577','S','Old Willapa','N','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.629720,-123.658440,0,'2013-07-06 12:44:34',NULL,NULL),(77336,'96716','P','Hanapepe','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.920872,-159.589670,0,'2013-07-06 12:44:34',NULL,NULL),(62796,'74901','S','Arkoma','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.353477,-94.437512,0,'2013-07-06 12:44:33',NULL,NULL),(50658,'58327','S','Southam','A','Ramsey','38071','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.013856,-98.604066,0,'2013-07-06 12:44:33',NULL,NULL),(16738,'17503','P','Bart','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.935972,-76.084154,0,'2013-07-06 12:44:31',NULL,NULL),(23366,'25271','S','Statts Mills','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.814793,-81.707302,0,'2013-07-06 12:44:31',NULL,NULL),(15101,'15770','S','Ringgold','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.993752,-79.150635,0,'2013-07-06 12:44:31',NULL,NULL),(3490,'01842','P','Lawrence','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.705479,-71.159968,0,'2013-07-06 12:44:30',NULL,NULL),(7203,'06483','S','Seymour','D','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.381477,-73.085777,0,'2013-07-06 12:44:30',NULL,NULL),(5859,'05143','S','Brockways Mills','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(27993,'30597','U','Dahlonega','D','Lumpkin','13187','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.528036,-83.987193,0,'2013-07-06 12:44:31',NULL,NULL),(76238,'95389','S','Tuolumne Meadows','A','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(74187,'92278','S','29 Palms','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.273320,-116.102460,0,'2013-07-06 12:44:34',NULL,NULL),(73211,'90610','P','Los Nietos','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.969836,-118.071934,0,'2013-07-06 12:44:34',NULL,NULL),(58510,'68773','S','Royal','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.309636,-98.125775,0,'2013-07-06 12:44:33',NULL,NULL),(41221,'46733','S','Bo Bo','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(28102,'30755','S','Tunnel Hill','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.843757,-85.043450,0,'2013-07-06 12:44:31',NULL,NULL),(73422,'91199','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.109919,-118.125578,0,'2013-07-06 12:44:34',NULL,NULL),(69534,'83735','U','ID State Dept Of Employ','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.610738,-116.199409,0,'2013-07-06 12:44:34',NULL,NULL),(68433,'81221','P','Coal Creek','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.361447,-105.148019,0,'2013-07-06 12:44:34',NULL,NULL),(67546,'80262','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.731445,-104.938641,0,'2013-07-06 12:44:34',NULL,NULL),(29864,'33040','S','E Rockland Ky','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(1813,'00784','S','Comunidad Miramar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(25290,'28137','S','Richfield','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.459658,-80.267160,0,'2013-07-06 12:44:31',NULL,NULL),(54472,'62859','S','Crook','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(47202,'54489','S','Seneca Corners','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.461390,-89.993344,0,'2013-07-06 12:44:32',NULL,NULL),(40808,'46184','S','Whiteland','D','Johnson','18081','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.555508,-86.091336,0,'2013-07-06 12:44:32',NULL,NULL),(39958,'45236','S','Deer Park','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(36658,'41008','S','Carrollton','D','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.677051,-85.169553,0,'2013-07-06 12:44:32',NULL,NULL),(9738,'10090','S','Santa Claus','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(21410,'22529','P','Oldhams','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.999333,-76.667766,0,'2013-07-06 12:44:31',NULL,NULL),(41173,'46706','S','Auburn Junction','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.370451,-85.045718,0,'2013-07-06 12:44:32',NULL,NULL),(23041,'24857','P','Lynco','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.676111,-81.663333,0,'2013-07-06 12:44:31',NULL,NULL),(25318,'28168','S','Vale','D','Lincoln','37109','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.494582,-81.415179,0,'2013-07-06 12:44:31',NULL,NULL),(14938,'15562','S','Springs','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.742433,-79.096794,0,'2013-07-06 12:44:31',NULL,NULL),(33239,'37071','P','Gladeville','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.193796,-86.279517,0,'2013-07-06 12:44:32',NULL,NULL),(36538,'40870','S','Totz','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.969150,-83.204775,0,'2013-07-06 12:44:32',NULL,NULL),(35479,'39520','S','Stennis Ctr','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(74428,'92562','S','Murrieta','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.543275,-117.287556,0,'2013-07-06 12:44:34',NULL,NULL),(67453,'80214','S','Edgewater','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.745789,-105.059616,0,'2013-07-06 12:44:34',NULL,NULL),(67040,'79545','S','Roscoe','D','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.440465,-100.529095,0,'2013-07-06 12:44:34',NULL,NULL),(54844,'63038','S','Wildwood','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.582772,-90.652220,0,'2013-07-06 12:44:33',NULL,NULL),(48309,'55443','S','Brooklyn Ctr','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.076111,-93.332500,0,'2013-07-06 12:44:33',NULL,NULL),(36644,'41005','S','Idlewild','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(8925,'08750','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.134492,-74.045049,0,'2013-07-06 12:44:30',NULL,NULL),(19785,'20428','U','Civil Aeronautics Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.913441,-77.043978,0,'2013-07-06 12:44:31',NULL,NULL),(22221,'23551','U','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.848151,-76.288565,0,'2013-07-06 12:44:31',NULL,NULL),(29037,'32233','S','Jacksonville','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355620,-81.518460,0,'2013-07-06 12:44:32',NULL,NULL),(40558,'45858','S','Mc Comb','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.105322,-83.806293,0,'2013-07-06 12:44:32',NULL,NULL),(21374,'22469','S','Hague','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.050417,-76.670603,0,'2013-07-06 12:44:31',NULL,NULL),(76391,'95536','S','Ferndale','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.565664,-124.243554,0,'2013-07-06 12:44:34',NULL,NULL),(71862,'87712','P','Golondrinas','N','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.891111,-105.185278,0,'2013-07-06 12:44:34',NULL,NULL),(58487,'68757','S','Newcastle','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.659384,-96.887990,0,'2013-07-06 12:44:33',NULL,NULL),(36346,'40422','S','Danville','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.640220,-84.782363,0,'2013-07-06 12:44:32',NULL,NULL),(35734,'39702','S','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.438653,-88.346866,0,'2013-07-06 12:44:32',NULL,NULL),(28247,'31061','S','Milledgeville','D','Baldwin','13009','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.085732,-83.245046,0,'2013-07-06 12:44:31',NULL,NULL),(41727,'47246','S','Hope','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.292612,-85.759781,0,'2013-07-06 12:44:32',NULL,NULL),(43922,'49266','S','Osseo','D','Hillsdale','26059','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.851341,-84.548348,0,'2013-07-06 12:44:32',NULL,NULL),(65887,'78230','S','Shavano Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.539652,-98.551914,0,'2013-07-06 12:44:34',NULL,NULL),(49552,'56701','S','Rosewood','N','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.115399,-96.174170,0,'2013-07-06 12:44:33',NULL,NULL),(46651,'53702','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.074862,-89.380795,0,'2013-07-06 12:44:32',NULL,NULL),(42797,'48048','S','New Haven','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.738060,-82.801020,0,'2013-07-06 12:44:32',NULL,NULL),(13773,'14141','S','Springville','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.521734,-78.704161,0,'2013-07-06 12:44:31',NULL,NULL),(31400,'34228','S','Long Boat Key','N','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.426057,-82.672355,0,'2013-07-06 12:44:32',NULL,NULL),(7953,'07676','S','Twp Washinton','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(3902,'02452','S','Waltham','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.398020,-71.220337,0,'2013-07-06 12:44:30',NULL,NULL),(19645,'20268','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901073,-77.028825,0,'2013-07-06 12:44:31',NULL,NULL),(40693,'46074','S','Carmel','A','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.037435,-86.153185,0,'2013-07-06 12:44:32',NULL,NULL),(71760,'87551','S','Rutheron','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.673323,-106.552060,0,'2013-07-06 12:44:34',NULL,NULL),(67409,'80130','S','Littleton','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.544318,-104.920225,0,'2013-07-06 12:44:34',NULL,NULL),(1842,'00784','S','Villa Rosa 1','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(36531,'40856','S','Miracle','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.701111,-83.521111,0,'2013-07-06 12:44:32',NULL,NULL),(28642,'31758','P','Tville','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.837608,-83.978538,0,'2013-07-06 12:44:32',NULL,NULL),(24252,'26802','S','Ft Seybert','N','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.640625,-79.198583,0,'2013-07-06 12:44:31',NULL,NULL),(42061,'47448','S','Gnaw Bone','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(48055,'55320','S','Clearwater','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.413142,-94.119490,0,'2013-07-06 12:44:33',NULL,NULL),(51019,'58707','U','Minot','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.235211,-101.294711,0,'2013-07-06 12:44:33',NULL,NULL),(55957,'64492','S','Trimble','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.494736,-94.563052,0,'2013-07-06 12:44:33',NULL,NULL),(56624,'65589','S','Yukon','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.209732,-91.814544,0,'2013-07-06 12:44:33',NULL,NULL),(60992,'72112','S','Bengall','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(79458,'98849','S','Synarep','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.480603,-119.617296,0,'2013-07-06 12:44:34',NULL,NULL),(59985,'71327','S','Cottonport','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.988947,-92.052747,0,'2013-07-06 12:44:33',NULL,NULL),(59857,'71256','S','Lillie','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.925196,-92.691728,0,'2013-07-06 12:44:33',NULL,NULL),(41684,'47190','S','Bureau of Census Decennial','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.279200,-85.722700,0,'2013-07-06 12:44:32',NULL,NULL),(38075,'43068','S','Reynoldsburg','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.962571,-82.783851,0,'2013-07-06 12:44:32',NULL,NULL),(33105,'36854','S','Shawmut','N','Chambers','01017','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.810093,-85.181624,0,'2013-07-06 12:44:32',NULL,NULL),(32598,'36132','U','AL Revenue Dept','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380100,-86.181883,0,'2013-07-06 12:44:32',NULL,NULL),(6723,'06071','S','Somers','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.994749,-72.451260,0,'2013-07-06 12:44:30',NULL,NULL),(30622,'33436','S','Village of Golf','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.524205,-80.107257,0,'2013-07-06 12:44:32',NULL,NULL),(28298,'31099','P','Warner Robins','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.643141,-83.634469,0,'2013-07-06 12:44:31',NULL,NULL),(6095,'05450','S','Woodpecker Village','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(6675,'06033','S','Glastonbury','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.707148,-72.563304,0,'2013-07-06 12:44:30',NULL,NULL),(15807,'16927','S','Harrison Valley','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.951385,-77.702976,0,'2013-07-06 12:44:31',NULL,NULL),(75056,'93523','S','Edward','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',34.950022,-117.901246,0,'2013-07-06 12:44:34',NULL,NULL),(69495,'83704','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.630174,-116.297422,0,'2013-07-06 12:44:34',NULL,NULL),(63063,'75231','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.876553,-96.751035,0,'2013-07-06 12:44:33',NULL,NULL),(58539,'68813','S','New Helena','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.641920,-99.771120,0,'2013-07-06 12:44:33',NULL,NULL),(43353,'48390','S','Commerce','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(28772,'32033','S','Elkton','D','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.780205,-81.438268,0,'2013-07-06 12:44:32',NULL,NULL),(27608,'30303','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.750591,-84.387699,0,'2013-07-06 12:44:31',NULL,NULL),(20140,'20724','S','Laurel','D','Anne Arundel','24003','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.090999,-76.818955,0,'2013-07-06 12:44:31',NULL,NULL),(16387,'17213','S','Lack','N','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(6867,'06134','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.766457,-72.682703,0,'2013-07-06 12:44:30',NULL,NULL),(77423,'96802','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304492,-157.859879,0,'2013-07-06 12:44:34',NULL,NULL),(67523,'80247','S','Aurora','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.675696,-104.885137,0,'2013-07-06 12:44:34',NULL,NULL),(46428,'53192','P','Wilmot','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.513487,-88.209516,0,'2013-07-06 12:44:32',NULL,NULL),(44593,'50046','S','Cambridge','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.901318,-93.532750,0,'2013-07-06 12:44:32',NULL,NULL),(41864,'47356','S','Middletown','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.056706,-85.543297,0,'2013-07-06 12:44:32',NULL,NULL),(20354,'20868','S','Spencerville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.119176,-76.971825,0,'2013-07-06 12:44:31',NULL,NULL),(3984,'02536','S','E Falmouth','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(18571,'19126','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.055969,-75.135303,0,'2013-07-06 12:44:31',NULL,NULL),(26789,'29455','S','Johns Island','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.691291,-80.091155,0,'2013-07-06 12:44:31',NULL,NULL),(62330,'74047','S','Mounds','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.873661,-96.059648,0,'2013-07-06 12:44:33',NULL,NULL),(61639,'72843','S','Hector','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.509314,-92.975107,0,'2013-07-06 12:44:33',NULL,NULL),(40126,'45330','P','Gratis','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.648938,-84.527080,0,'2013-07-06 12:44:32',NULL,NULL),(39153,'44287','S','Pleasant Home','N','Wayne','39169','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.925833,-82.053056,0,'2013-07-06 12:44:32',NULL,NULL),(5936,'05255','S','Manchestr CTR','A','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.194892,-73.065620,0,'2013-07-06 12:44:30',NULL,NULL),(2351,'00949','S','Alt Hacienda Dorada','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(18472,'19086','S','Garden City','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.889823,-75.370994,0,'2013-07-06 12:44:31',NULL,NULL),(11514,'12032','S','Pine Lake','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.161683,-74.493710,0,'2013-07-06 12:44:30',NULL,NULL),(18635,'19155','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.096358,-74.978989,0,'2013-07-06 12:44:31',NULL,NULL),(8705,'08361','S','Vineland','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.482485,-75.023974,0,'2013-07-06 12:44:30',NULL,NULL),(67304,'80019','S','Aurora','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.771487,-104.679038,0,'2013-07-06 12:44:34',NULL,NULL),(55713,'64071','S','Mayview','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.040903,-93.830524,0,'2013-07-06 12:44:33',NULL,NULL),(48271,'55429','S','Crystal','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(34153,'38242','S','Paris','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.302656,-88.314279,0,'2013-07-06 12:44:32',NULL,NULL),(33971,'38109','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.046864,-90.068205,0,'2013-07-06 12:44:32',NULL,NULL),(585,'00680','S','Bo Salud','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(28040,'30655','S','Between','A','Walton','13297','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.790908,-83.711688,0,'2013-07-06 12:44:31',NULL,NULL),(5259,'04487','S','Lakeville','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.393599,-68.101456,0,'2013-07-06 12:44:30',NULL,NULL),(42638,'47922','S','Brook','D','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',40.867564,-87.363700,0,'2013-07-06 12:44:32',NULL,NULL),(45923,'52329','S','Rowley','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.368583,-91.844393,0,'2013-07-06 12:44:32',NULL,NULL),(47065,'54424','S','Deerbrook','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.242450,-89.156160,0,'2013-07-06 12:44:32',NULL,NULL),(79795,'99353','S','Richland','A','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.285833,-119.283333,0,'2013-07-06 12:44:34',NULL,NULL),(78093,'97481','S','Tenmile','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.091401,-123.564457,0,'2013-07-06 12:44:34',NULL,NULL),(75204,'93628','S','Hume','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.692500,-119.051389,0,'2013-07-06 12:44:34',NULL,NULL),(69113,'83272','S','St Charles','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.077452,-111.314009,0,'2013-07-06 12:44:34',NULL,NULL),(60324,'71459','S','Dogwood Terrace','N','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.995820,-93.246900,0,'2013-07-06 12:44:33',NULL,NULL),(61275,'72386','S','Tyronza','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.485574,-90.371039,0,'2013-07-06 12:44:33',NULL,NULL),(1528,'00754','S','Urb Santa Clara','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(13424,'13756','S','East Branch','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.023889,-75.113056,0,'2013-07-06 12:44:31',NULL,NULL),(52380,'60625','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.968521,-87.703667,0,'2013-07-06 12:44:33',NULL,NULL),(54830,'63028','S','Festus','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.180295,-90.405608,0,'2013-07-06 12:44:33',NULL,NULL),(3046,'01105','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.101072,-72.579177,0,'2013-07-06 12:44:30',NULL,NULL),(22752,'24416','S','Buena Vista','D','Buena Vista City','51530','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.729973,-79.350879,0,'2013-07-06 12:44:31',NULL,NULL),(70280,'84532','S','Arches','N','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(79165,'98512','S','Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.951987,-123.014667,0,'2013-07-06 12:44:34',NULL,NULL),(44758,'50201','S','Nevada','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.018291,-93.450971,0,'2013-07-06 12:44:32',NULL,NULL),(5805,'05068','S','East Barnard','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.801620,-72.530880,0,'2013-07-06 12:44:30',NULL,NULL),(59002,'70062','S','Kenner','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.988618,-90.250441,0,'2013-07-06 12:44:33',NULL,NULL),(59788,'71217','P','Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.509651,-92.119049,0,'2013-07-06 12:44:33',NULL,NULL),(63186,'75418','S','Bonham','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.585686,-96.177204,0,'2013-07-06 12:44:33',NULL,NULL),(72047,'88081','S','Chaparral','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.010850,-106.570172,0,'2013-07-06 12:44:34',NULL,NULL),(25050,'27919','S','Belvidere','D','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.314810,-76.515448,0,'2013-07-06 12:44:31',NULL,NULL),(79637,'99135','S','Hartline','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.690318,-119.105256,0,'2013-07-06 12:44:34',NULL,NULL),(78233,'97814','S','Keating','N','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.779688,-117.834287,0,'2013-07-06 12:44:34',NULL,NULL),(76523,'95646','P','Kirkwood','D','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(21977,'23250','S','Henrico','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(62194,'73772','S','Watonga','D','Blaine','40011','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.855545,-98.410440,0,'2013-07-06 12:44:33',NULL,NULL),(15995,'17036','S','South Hanover','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.277580,-76.708800,0,'2013-07-06 12:44:31',NULL,NULL),(18411,'19056','S','Newportville','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.150296,-74.888025,0,'2013-07-06 12:44:31',NULL,NULL),(77617,'96951','P','Rota Mariana Islands','N','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',14.147930,145.245515,0,'2013-07-06 12:44:34',NULL,NULL),(9067,'08989','U','Merrill Lynch','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.519417,-74.414583,0,'2013-07-06 12:44:30',NULL,NULL),(62003,'73437','S','Graham','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.322331,-97.502472,0,'2013-07-06 12:44:33',NULL,NULL),(6957,'06226','S','Willimantic','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.714269,-72.211943,0,'2013-07-06 12:44:30',NULL,NULL),(76349,'95476','S','Sonoma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.293075,-122.470371,0,'2013-07-06 12:44:34',NULL,NULL),(65936,'78253','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.459263,-98.747046,0,'2013-07-06 12:44:34',NULL,NULL),(60850,'72044','S','Brewer','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.645789,-92.190482,0,'2013-07-06 12:44:33',NULL,NULL),(54099,'62535','S','Forsyth','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.929267,-88.949924,0,'2013-07-06 12:44:33',NULL,NULL),(53225,'61636','U','Methodist Hosp','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700195,-89.598587,0,'2013-07-06 12:44:33',NULL,NULL),(13019,'13424','S','Oriskany','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.154445,-75.332472,0,'2013-07-06 12:44:30',NULL,NULL),(1709,'00778','S','Alt de Montebrisas','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(19945,'20575','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899437,-77.041181,0,'2013-07-06 12:44:31',NULL,NULL),(24682,'27411','U','A&T State University','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.074246,-79.776390,0,'2013-07-06 12:44:31',NULL,NULL),(21525,'22727','S','Banco','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(42479,'47836','P','Bridgeton','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.649687,-87.183167,0,'2013-07-06 12:44:32',NULL,NULL),(44895,'50321','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543913,-93.676872,0,'2013-07-06 12:44:32',NULL,NULL),(45225,'50644','S','Doris','N','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.468967,-91.895783,0,'2013-07-06 12:44:32',NULL,NULL),(9523,'10018','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(79453,'98848','S','George','A','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.210850,-119.861652,0,'2013-07-06 12:44:34',NULL,NULL),(78140,'97538','S','Selma','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.270682,-123.584681,0,'2013-07-06 12:44:34',NULL,NULL),(57475,'66868','S','Reading','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.542055,-96.020909,0,'2013-07-06 12:44:33',NULL,NULL),(14921,'15545','S','Hyndman','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.815212,-78.728884,0,'2013-07-06 12:44:31',NULL,NULL),(35511,'39532','S','Boloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.461218,-88.949246,0,'2013-07-06 12:44:32',NULL,NULL),(34804,'38878','S','Hollis','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(29352,'32563','S','Gulf Breeze','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.405810,-86.987190,0,'2013-07-06 12:44:32',NULL,NULL),(29164,'32350','S','Pinetta','D','Madison','12079','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.605854,-83.338359,0,'2013-07-06 12:44:32',NULL,NULL),(26493,'29168','S','Wedgefield','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.901928,-80.497455,0,'2013-07-06 12:44:31',NULL,NULL),(26013,'28677','S','Bradfords Cross Roads','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(10766,'11364','S','Bayside','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(75656,'94534','S','Fairfield','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.286723,-122.011695,0,'2013-07-06 12:44:34',NULL,NULL),(73142,'90275','S','Pls Vrds Pnsl','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.766667,-118.366667,0,'2013-07-06 12:44:34',NULL,NULL),(70943,'85641','S','Corona de Tucson','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(69142,'83303','P','CSI','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.560847,-114.464815,0,'2013-07-06 12:44:34',NULL,NULL),(68134,'80962','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.954393,-104.733997,0,'2013-07-06 12:44:34',NULL,NULL),(60140,'71373','S','St Genevieve','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(50420,'57787','S','Chalk Butte','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.733611,-102.654167,0,'2013-07-06 12:44:33',NULL,NULL),(40260,'45431','S','Dayton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(17223,'17830','S','Herndon','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690745,-76.789710,0,'2013-07-06 12:44:31',NULL,NULL),(9997,'10166','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(22002,'23279','U','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.583347,-77.491807,0,'2013-07-06 12:44:31',NULL,NULL),(1328,'00736','S','Bda Buena Vista','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(7624,'07060','S','N Plainfield','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.631340,-74.437020,0,'2013-07-06 12:44:30',NULL,NULL),(70316,'84620','P','Aurora','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.927880,-111.919505,0,'2013-07-06 12:44:34',NULL,NULL),(66530,'78720','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.401849,-97.754127,0,'2013-07-06 12:44:34',NULL,NULL),(58096,'68108','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.235658,-95.928687,0,'2013-07-06 12:44:33',NULL,NULL),(48099,'55343','S','Minetonka Mls','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(28333,'31156','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.959963,-84.364913,0,'2013-07-06 12:44:32',NULL,NULL),(25277,'28128','S','Porter','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.237400,-80.166240,0,'2013-07-06 12:44:31',NULL,NULL),(34955,'39062','P','D Lo','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.984304,-89.898049,0,'2013-07-06 12:44:32',NULL,NULL),(34408,'38628','S','Falcon','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.395268,-90.254922,0,'2013-07-06 12:44:32',NULL,NULL),(33952,'38083','P','Millington','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.332201,-89.887885,0,'2013-07-06 12:44:32',NULL,NULL),(74498,'92625','S','Corona dl Mar','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.603589,-117.861931,0,'2013-07-06 12:44:34',NULL,NULL),(73810,'91758','S','Ontario','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.055007,-117.608926,0,'2013-07-06 12:44:34',NULL,NULL),(72098,'88213','S','Tatum','A','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.404833,-103.659049,0,'2013-07-06 12:44:34',NULL,NULL),(65938,'78254','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.536152,-98.724160,0,'2013-07-06 12:44:34',NULL,NULL),(60998,'72112','S','New Pr','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(30111,'33160','S','Sunny Isl Bch','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(17487,'17960','S','East Brunswick','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.681547,-75.998948,0,'2013-07-06 12:44:31',NULL,NULL),(39617,'44882','S','Plankton','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(57545,'67026','S','Clearwater','D','Sedgwick','20173','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.539314,-97.493326,0,'2013-07-06 12:44:33',NULL,NULL),(57856,'67570','S','Pretty Pr','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.786862,-97.941549,0,'2013-07-06 12:44:33',NULL,NULL),(1383,'00738','S','Bo Proyecto Veve Calzada 3','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(74511,'92646','S','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.665392,-117.968576,0,'2013-07-06 12:44:34',NULL,NULL),(65760,'78071','S','Three Rivers','D','Live Oak','48297','Texas','TX','48','0000','361','Central',-6.0,'Y',28.356491,-98.135804,0,'2013-07-06 12:44:34',NULL,NULL),(64202,'76252','S','Muenster','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.652773,-97.377391,0,'2013-07-06 12:44:34',NULL,NULL),(11463,'12010','S','Amsterdam','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923640,-74.170860,0,'2013-07-06 12:44:30',NULL,NULL),(15072,'15741','P','Gipsy','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.807761,-78.862651,0,'2013-07-06 12:44:31',NULL,NULL),(32089,'35292','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.512500,-86.805024,0,'2013-07-06 12:44:32',NULL,NULL),(25138,'28017','P','Boiling Springs','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.252902,-81.644801,0,'2013-07-06 12:44:31',NULL,NULL),(40936,'46291','U','B M G','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.782399,-86.047878,0,'2013-07-06 12:44:32',NULL,NULL),(42171,'47527','S','Dubois Xrds','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(52298,'60541','S','Lisbon','N','Kendall','17093','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.514251,-88.510263,0,'2013-07-06 12:44:33',NULL,NULL),(58088,'68101','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.262185,-95.931331,0,'2013-07-06 12:44:33',NULL,NULL),(10214,'10455','S','Hub','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.812989,-73.903711,0,'2013-07-06 12:44:30',NULL,NULL),(73588,'91385','P','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.389797,-118.558445,0,'2013-07-06 12:44:34',NULL,NULL),(71820,'87574','P','Tesuque','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.806152,-105.915266,0,'2013-07-06 12:44:34',NULL,NULL),(70436,'84738','S','Kayenta','N','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.167800,-113.667546,0,'2013-07-06 12:44:34',NULL,NULL),(60481,'71657','P','Monticello','D','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.625295,-91.789337,0,'2013-07-06 12:44:33',NULL,NULL),(59538,'70813','U','Southern University','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.426458,-91.109438,0,'2013-07-06 12:44:33',NULL,NULL),(53235,'61641','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.653063,-89.683748,0,'2013-07-06 12:44:33',NULL,NULL),(34495,'38668','S','Tyro','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(24125,'26554','S','Bellview','N','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(16648,'17344','S','Mc Sherrystown','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.804478,-77.019713,0,'2013-07-06 12:44:31',NULL,NULL),(7075,'06340','S','Groton','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(40535,'45838','P','Elgin','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.739828,-84.475071,0,'2013-07-06 12:44:32',NULL,NULL),(41808,'47331','S','Everton','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(50167,'57552','S','Nowlin','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(7181,'06467','P','Milldale','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.566761,-72.903921,0,'2013-07-06 12:44:30',NULL,NULL),(66223,'78561','P','Lasara','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.468286,-97.909697,0,'2013-07-06 12:44:34',NULL,NULL),(5,'00601','S','Adjuntas','D','Adjuntas','72001','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.165950,-66.723627,0,'2013-07-06 12:44:30',NULL,NULL),(1982,'00906','P','Puerta De Tierra','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.405503,-66.062657,0,'2013-07-06 12:44:30',NULL,NULL),(65402,'77563','S','Hitchcock','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.342457,-95.001043,0,'2013-07-06 12:44:34',NULL,NULL),(63318,'75569','S','Nash','D','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.439691,-94.124358,0,'2013-07-06 12:44:33',NULL,NULL),(6198,'05483','S','Sheldon','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(26803,'29465','P','Mt Pleasant','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.794330,-79.860810,0,'2013-07-06 12:44:31',NULL,NULL),(31427,'34264','P','Oneco','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.445348,-82.536877,0,'2013-07-06 12:44:32',NULL,NULL),(54325,'62739','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.798125,-89.646516,0,'2013-07-06 12:44:33',NULL,NULL),(23498,'25523','S','Sweetland','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.276689,-82.098761,0,'2013-07-06 12:44:31',NULL,NULL),(34435,'38646','S','Marks','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.250150,-90.274085,0,'2013-07-06 12:44:32',NULL,NULL),(14699,'15260','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441234,-79.945700,0,'2013-07-06 12:44:31',NULL,NULL),(25136,'28016','S','Bessemer City','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.285753,-81.282523,0,'2013-07-06 12:44:31',NULL,NULL),(62621,'74545','P','Gowen','D','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.881825,-95.479038,0,'2013-07-06 12:44:33',NULL,NULL),(58736,'68949','S','Holdrege','D','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.440800,-99.370426,0,'2013-07-06 12:44:33',NULL,NULL),(2702,'00969','S','Est Reales','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(80182,'99841','P','Tenakee Springs','D','Hoonah-Angoon','02105','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.779884,-135.188839,0,'2013-07-06 12:44:34',NULL,NULL),(50038,'57430','S','Sunset Colony','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.806700,-97.722180,0,'2013-07-06 12:44:33',NULL,NULL),(28896,'32129','S','Port Orange','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.148785,-81.025137,0,'2013-07-06 12:44:32',NULL,NULL),(34886,'38945','P','Money','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.520275,-90.180575,0,'2013-07-06 12:44:32',NULL,NULL),(73815,'91763','S','Montclair','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.077569,-117.697687,0,'2013-07-06 12:44:34',NULL,NULL),(76415,'95559','P','Phillipsville','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.211585,-123.782226,0,'2013-07-06 12:44:34',NULL,NULL),(65315,'77507','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.625223,-95.057353,0,'2013-07-06 12:44:34',NULL,NULL),(3168,'01267','S','Wmstown','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.699457,-73.210225,0,'2013-07-06 12:44:30',NULL,NULL),(77330,'96712','S','Haleiwa','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.592861,-158.103416,0,'2013-07-06 12:44:34',NULL,NULL),(27874,'30447','P','Norristown','D','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.503946,-82.494456,0,'2013-07-06 12:44:31',NULL,NULL),(56284,'65074','S','Enon','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.485140,-92.403960,0,'2013-07-06 12:44:33',NULL,NULL),(11848,'12250','U','NY Tele Co','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.673005,-73.735244,0,'2013-07-06 12:44:30',NULL,NULL),(66257,'78573','S','Palmhurst','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214239,-98.325921,0,'2013-07-06 12:44:34',NULL,NULL),(23340,'25248','S','Romance','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.655556,-81.590556,0,'2013-07-06 12:44:31',NULL,NULL),(39691,'45033','P','Hooven','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.176513,-84.759571,0,'2013-07-06 12:44:32',NULL,NULL),(1370,'00736','S','Urb Mirador Echevarri','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(16631,'17333','U','Hanover Direct','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.824208,-76.990704,0,'2013-07-06 12:44:31',NULL,NULL),(41506,'46965','P','Oakford','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.416518,-86.102449,0,'2013-07-06 12:44:32',NULL,NULL),(19565,'20208','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897725,-77.011119,0,'2013-07-06 12:44:31',NULL,NULL),(44557,'50011','U','Ames','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.022225,-93.639475,0,'2013-07-06 12:44:32',NULL,NULL),(58751,'68957','S','Mount Clare','N','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.261367,-98.214325,0,'2013-07-06 12:44:33',NULL,NULL),(22966,'24712','S','Athens','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.457773,-80.997359,0,'2013-07-06 12:44:31',NULL,NULL),(22769,'24441','S','Grottoes','D','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.268854,-78.826751,0,'2013-07-06 12:44:31',NULL,NULL),(27974,'30564','S','Murrayville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.428732,-83.910740,0,'2013-07-06 12:44:31',NULL,NULL),(55788,'64121','P','Kans City','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.100769,-94.578994,0,'2013-07-06 12:44:33',NULL,NULL),(22457,'24031','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.272186,-79.956056,0,'2013-07-06 12:44:31',NULL,NULL),(37705,'42261','S','Logansport','A','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.196340,-86.689320,0,'2013-07-06 12:44:32',NULL,NULL),(15827,'16933','S','Mansfield','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(15489,'16443','S','West Springfield','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.939334,-80.469219,0,'2013-07-06 12:44:31',NULL,NULL),(72086,'88136','S','Yeso','D','De Baca','35011','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.351148,-104.598484,0,'2013-07-06 12:44:34',NULL,NULL),(58778,'68972','S','Riverton','D','Franklin','31061','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.112990,-98.813748,0,'2013-07-06 12:44:33',NULL,NULL),(53500,'62012','S','Brighton','D','Macoupin','17117','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.036979,-90.137327,0,'2013-07-06 12:44:33',NULL,NULL),(39653,'45004','P','Collinsville','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.512750,-84.612152,0,'2013-07-06 12:44:32',NULL,NULL),(34581,'38737','S','Wade','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(78967,'98371','S','Firwood','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(2273,'00926','S','Urb San Agustin','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(17869,'18436','S','Mount Cobb','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.402430,-75.336574,0,'2013-07-06 12:44:31',NULL,NULL),(31492,'34441','P','Hernando','D','Citrus','12017','Florida','FL','12','0000','000','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(43816,'49076','S','Olivet','D','Eaton','26045','Michigan','MI','26','4040','269','Eastern',-5.0,'Y',42.455103,-84.907989,0,'2013-07-06 12:44:32',NULL,NULL),(68108,'80946','U','Colorado College','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.847888,-104.824771,0,'2013-07-06 12:44:34',NULL,NULL),(47360,'54615','S','Blk Riv Falls','N','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.290491,-90.846708,0,'2013-07-06 12:44:32',NULL,NULL),(42768,'48037','P','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.485960,-83.265438,0,'2013-07-06 12:44:32',NULL,NULL),(24471,'27239','S','Jacksons Creek','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(75363,'93924','S','Carmel Valley','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.393660,-121.675020,0,'2013-07-06 12:44:34',NULL,NULL),(12036,'12520','S','Cornwall on the Hudson','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.442299,-74.015486,0,'2013-07-06 12:44:30',NULL,NULL),(21435,'22567','S','Lahore','N','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.228135,-77.912975,0,'2013-07-06 12:44:31',NULL,NULL),(58927,'69341','S','Gering','D','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.804640,-103.716960,0,'2013-07-06 12:44:33',NULL,NULL),(19892,'20538','U','Immig and Naturalization Ser','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901597,-77.017489,0,'2013-07-06 12:44:31',NULL,NULL),(64950,'77233','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.655059,-95.358217,0,'2013-07-06 12:44:34',NULL,NULL),(59486,'70761','S','Norwood','D','East Feliciana','22037','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.930863,-91.032481,0,'2013-07-06 12:44:33',NULL,NULL),(36229,'40289','U','National City Bank','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258911,-85.756935,0,'2013-07-06 12:44:32',NULL,NULL),(4684,'03803','U','Air National Guard','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.067757,-70.800532,0,'2013-07-06 12:44:30',NULL,NULL),(3251,'01438','P','E Templeton','A','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.563733,-72.040368,0,'2013-07-06 12:44:30',NULL,NULL),(9877,'10123','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750161,-74.000838,0,'2013-07-06 12:44:30',NULL,NULL),(10736,'11356','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.786000,-73.844070,0,'2013-07-06 12:44:30',NULL,NULL),(23179,'25039','S','Cedar Grove','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.221119,-81.431623,0,'2013-07-06 12:44:31',NULL,NULL),(68455,'81230','S','Doyleville','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.453420,-106.609860,0,'2013-07-06 12:44:34',NULL,NULL),(3664,'02124','S','Boston','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.286139,-71.070555,0,'2013-07-06 12:44:30',NULL,NULL),(21241,'22242','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856291,-77.050893,0,'2013-07-06 12:44:31',NULL,NULL),(58813,'69029','S','Farnam','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.708789,-100.213088,0,'2013-07-06 12:44:33',NULL,NULL),(37502,'42031','S','Moscow','N','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(10294,'10521','P','Crugers','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.234521,-73.924343,0,'2013-07-06 12:44:30',NULL,NULL),(77880,'97267','S','Oak Lodge','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.407460,-122.610386,0,'2013-07-06 12:44:34',NULL,NULL),(12169,'12758','S','Lew Beach','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.912654,-74.754347,0,'2013-07-06 12:44:30',NULL,NULL),(5863,'05143','S','Peaseville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(16190,'17068','S','Perry Village','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.418905,-77.189502,0,'2013-07-06 12:44:31',NULL,NULL),(65530,'77801','S','Edge','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(2878,'00987','S','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(42385,'47722','U','University of Evansville','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974242,-87.535628,0,'2013-07-06 12:44:32',NULL,NULL),(62346,'74058','S','Blackburn','A','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.331099,-96.777425,0,'2013-07-06 12:44:33',NULL,NULL),(79647,'99143','S','Lacrosse','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.773540,-117.863160,0,'2013-07-06 12:44:34',NULL,NULL),(42490,'47840','S','Centerpoint','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.376944,-87.100716,0,'2013-07-06 12:44:32',NULL,NULL),(37208,'41522','S','Senterville','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(33664,'37724','S','Cumb Gap','A','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.542300,-83.689657,0,'2013-07-06 12:44:32',NULL,NULL),(71014,'85725','P','South Tucson','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.199047,-111.013265,0,'2013-07-06 12:44:34',NULL,NULL),(2817,'00978','P','Saint Just','D','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.369930,-65.996610,0,'2013-07-06 12:44:30',NULL,NULL),(25909,'28645','S','Kings Creek','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(65096,'77360','S','Onalaska','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.806106,-95.117992,0,'2013-07-06 12:44:34',NULL,NULL),(29604,'32836','S','Golden Oak','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.427503,-81.507039,0,'2013-07-06 12:44:32',NULL,NULL),(35950,'40059','S','River Bluff','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.338312,-85.613141,0,'2013-07-06 12:44:32',NULL,NULL),(78722,'98278','U','Nas Whidbey','A','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.281520,-122.625637,0,'2013-07-06 12:44:34',NULL,NULL),(13204,'13626','S','Barnes Corners','A','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.895883,-75.707121,0,'2013-07-06 12:44:30',NULL,NULL),(2865,'00985','S','Jard de Borinquen','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(29663,'32909','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.969161,-80.647489,0,'2013-07-06 12:44:32',NULL,NULL),(14220,'14801','S','Addison','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.107463,-77.230985,0,'2013-07-06 12:44:31',NULL,NULL),(3521,'01887','S','Wilmington','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.559770,-71.169957,0,'2013-07-06 12:44:30',NULL,NULL),(1508,'00754','S','Bosque Llano','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(30981,'33755','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.977549,-82.782998,0,'2013-07-06 12:44:32',NULL,NULL),(74107,'92223','S','Cherry Valley','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.952498,-116.973803,0,'2013-07-06 12:44:34',NULL,NULL),(74793,'93160','P','Goleta','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.434059,-119.802492,0,'2013-07-06 12:44:34',NULL,NULL),(12416,'12941','S','Jay','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.353596,-73.710530,0,'2013-07-06 12:44:30',NULL,NULL),(21664,'22947','S','Boyd Tavern','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(17359,'17872','S','Luke Fidler','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(27175,'29842','S','Clearwater','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.408592,-81.881677,0,'2013-07-06 12:44:31',NULL,NULL),(27786,'30378','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.757624,-84.550681,0,'2013-07-06 12:44:31',NULL,NULL),(32269,'35634','S','Florence','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.799674,-87.675698,0,'2013-07-06 12:44:32',NULL,NULL),(45028,'50467','S','Rock Falls','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.207888,-93.085486,0,'2013-07-06 12:44:32',NULL,NULL),(34797,'38874','P','Spring Hill','N','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.304862,-89.158498,0,'2013-07-06 12:44:32',NULL,NULL),(34000,'38119','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.085796,-89.848658,0,'2013-07-06 12:44:32',NULL,NULL),(12195,'12779','S','South Fallsburg','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.709537,-74.635185,0,'2013-07-06 12:44:30',NULL,NULL),(3641,'02110','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358190,-71.050678,0,'2013-07-06 12:44:30',NULL,NULL),(54336,'62764','U','Dept of Transportation','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.757628,-89.635423,0,'2013-07-06 12:44:33',NULL,NULL),(52619,'61036','S','Galena','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.408396,-90.371098,0,'2013-07-06 12:44:33',NULL,NULL),(79095,'98443','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.205924,-122.372561,0,'2013-07-06 12:44:34',NULL,NULL),(16105,'17055','S','Bowmansdale','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(55155,'63366','S','Dardenne','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(57101,'66220','S','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.968891,-94.817860,0,'2013-07-06 12:44:33',NULL,NULL),(64697,'76852','S','Lohn','D','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.340312,-99.380947,0,'2013-07-06 12:44:34',NULL,NULL),(14111,'14638','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.157140,-77.606676,0,'2013-07-06 12:44:31',NULL,NULL),(20311,'20817','S','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.997996,-77.146318,0,'2013-07-06 12:44:31',NULL,NULL),(66805,'79072','S','Plainview','D','Hale','48189','Texas','TX','48','0000','806','Central',-6.0,'Y',34.192932,-101.716093,0,'2013-07-06 12:44:34',NULL,NULL),(34974,'39086','S','Hermanville','D','Claiborne','28021','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.011080,-90.817800,0,'2013-07-06 12:44:32',NULL,NULL),(35686,'39661','S','Knoxville','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(42732,'48009','S','Birmingham','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.544619,-83.213883,0,'2013-07-06 12:44:32',NULL,NULL),(55459,'63736','S','New Hamburg','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.072200,-89.569800,0,'2013-07-06 12:44:33',NULL,NULL),(65428,'77582','P','Raywood','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',30.041095,-94.674384,0,'2013-07-06 12:44:34',NULL,NULL),(2456,'00953','S','Villa Matilde','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(54056,'62471','S','Vandalia','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.967418,-89.105783,0,'2013-07-06 12:44:33',NULL,NULL),(14943,'15601','S','GBG','N','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.296760,-79.542457,0,'2013-07-06 12:44:31',NULL,NULL),(12831,'13309','S','Talcottville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.453080,-75.336000,0,'2013-07-06 12:44:30',NULL,NULL),(60695,'71940','S','Pike','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(62603,'74525','S','Atoka','D','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.385284,-96.132110,0,'2013-07-06 12:44:33',NULL,NULL),(13375,'13737','P','Bible Sch Pk','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.078376,-76.096835,0,'2013-07-06 12:44:31',NULL,NULL),(9404,'09890','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3268,'01464','S','Shirley Ctr','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.577860,-71.643840,0,'2013-07-06 12:44:30',NULL,NULL),(11217,'11746','S','South Huntington','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(19102,'19605','S','River View Park','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(57265,'66543','S','Vassar','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.648951,-95.621088,0,'2013-07-06 12:44:33',NULL,NULL),(35883,'39877','S','Parrott','D','Terrell','13273','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.894364,-84.507084,0,'2013-07-06 12:44:32',NULL,NULL),(59122,'70154','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.920683,-90.097011,0,'2013-07-06 12:44:33',NULL,NULL),(38609,'43902','S','Alledonia','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.880712,-80.993107,0,'2013-07-06 12:44:32',NULL,NULL),(11070,'11596','S','E Williston','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757885,-73.644633,0,'2013-07-06 12:44:30',NULL,NULL),(2103,'00923','S','Urb Los Maestros','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(67257,'79958','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.755406,-106.489477,0,'2013-07-06 12:44:34',NULL,NULL),(23373,'25287','S','West Columbia','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.930914,-82.072593,0,'2013-07-06 12:44:31',NULL,NULL),(63983,'76108','S','White Settlement','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.781540,-97.503780,0,'2013-07-06 12:44:34',NULL,NULL),(11898,'12401','S','St Remy','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.932171,-74.019531,0,'2013-07-06 12:44:30',NULL,NULL),(1449,'00741','S','Punta Stgo','A','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.168687,-65.747221,0,'2013-07-06 12:44:30',NULL,NULL),(67701,'80524','S','Ft Collins','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.635510,-105.049839,0,'2013-07-06 12:44:34',NULL,NULL),(53163,'61567','S','Goofy Ridge','N','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.372662,-89.936217,0,'2013-07-06 12:44:33',NULL,NULL),(9864,'10121','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750095,-73.998867,0,'2013-07-06 12:44:30',NULL,NULL),(51874,'60084','S','Wauconda','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.262122,-88.139439,0,'2013-07-06 12:44:33',NULL,NULL),(49079,'56323','S','Cyrus','D','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.614317,-95.739191,0,'2013-07-06 12:44:33',NULL,NULL),(38690,'43984','P','New Rumley','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.399263,-81.033928,0,'2013-07-06 12:44:32',NULL,NULL),(41266,'46750','S','Huntington','D','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.883166,-85.495183,0,'2013-07-06 12:44:32',NULL,NULL),(7935,'07653','P','Paramus','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.947226,-74.071226,0,'2013-07-06 12:44:30',NULL,NULL),(13209,'13627','P','Deer River','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.929150,-75.590454,0,'2013-07-06 12:44:30',NULL,NULL),(58261,'68376','S','Humboldt','D','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.164101,-95.945902,0,'2013-07-06 12:44:33',NULL,NULL),(33426,'37244','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.166215,-86.785877,0,'2013-07-06 12:44:32',NULL,NULL),(45467,'51248','S','Sanborn','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.181515,-95.654995,0,'2013-07-06 12:44:32',NULL,NULL),(3756,'02184','S','Braintree','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.208818,-71.000729,0,'2013-07-06 12:44:30',NULL,NULL),(76536,'95658','S','Newcastle','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.874748,-121.146340,0,'2013-07-06 12:44:34',NULL,NULL),(6441,'05753','S','Bread Loaf','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.012313,-73.163211,0,'2013-07-06 12:44:30',NULL,NULL),(52681,'61081','S','Sterling','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.818523,-89.718838,0,'2013-07-06 12:44:33',NULL,NULL),(38432,'43555','P','Ridgeville Corners','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.438435,-84.257991,0,'2013-07-06 12:44:32',NULL,NULL),(39297,'44502','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.084949,-80.639100,0,'2013-07-06 12:44:32',NULL,NULL),(23591,'25678','S','Blackberry City','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649769,-82.126194,0,'2013-07-06 12:44:31',NULL,NULL),(70175,'84326','P','Millville','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.683925,-111.820524,0,'2013-07-06 12:44:34',NULL,NULL),(8455,'08087','S','Mystic Islands','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.589796,-74.356472,0,'2013-07-06 12:44:30',NULL,NULL),(33443,'37310','S','Charleston','D','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.258306,-84.868393,0,'2013-07-06 12:44:32',NULL,NULL),(75811,'94806','S','Hilltop Mall','A','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.972918,-122.333929,0,'2013-07-06 12:44:34',NULL,NULL),(5087,'04333','U','Me State Agencies','N','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.309517,-69.783518,0,'2013-07-06 12:44:30',NULL,NULL),(19410,'20080','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900032,-77.026546,0,'2013-07-06 12:44:31',NULL,NULL),(39448,'44701','P','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.729703,-81.450833,0,'2013-07-06 12:44:32',NULL,NULL),(47464,'54734','S','Downing','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.044489,-92.107248,0,'2013-07-06 12:44:32',NULL,NULL),(78714,'98272','S','Novelty','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.857085,-121.937678,0,'2013-07-06 12:44:34',NULL,NULL),(2269,'00926','S','Urb Romany Pk','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(66240,'78570','S','Mercedes','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160480,-97.919820,0,'2013-07-06 12:44:34',NULL,NULL),(45443,'51201','S','Ritter','N','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.184792,-95.847789,0,'2013-07-06 12:44:32',NULL,NULL),(1145,'00727','S','Est de Bairoa','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(47811,'55056','S','Branch','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.504480,-92.877900,0,'2013-07-06 12:44:33',NULL,NULL),(45833,'52214','S','Central City','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.181140,-91.491360,0,'2013-07-06 12:44:32',NULL,NULL),(35062,'39183','S','Vburg','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.390993,-90.829096,0,'2013-07-06 12:44:32',NULL,NULL),(71419,'87024','S','Jemez Pueblo','D','Sandoval','35043','New Mexico','NM','35','0200','575','Mountain',-7.0,'Y',35.608527,-106.741853,0,'2013-07-06 12:44:34',NULL,NULL),(24915,'27802','P','Rocky Mount','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.863709,-77.840190,0,'2013-07-06 12:44:31',NULL,NULL),(21209,'22203','S','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.875126,-77.119607,0,'2013-07-06 12:44:31',NULL,NULL),(49498,'56662','S','Rheiderland','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.846424,-93.901398,0,'2013-07-06 12:44:33',NULL,NULL),(38710,'44010','S','Austinburg','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.760517,-80.850566,0,'2013-07-06 12:44:32',NULL,NULL),(38216,'43219','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.005201,-82.931203,0,'2013-07-06 12:44:32',NULL,NULL),(75049,'93518','S','Caliente','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.318400,-118.462200,0,'2013-07-06 12:44:34',NULL,NULL),(1727,'00778','S','Praderas De Navarro','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(2618,'00962','S','Jard De Catano II','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(982,'00716','S','Villa Esperanza','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(67553,'80271','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.744563,-104.990066,0,'2013-07-06 12:44:34',NULL,NULL),(4155,'02768','P','Raynham Center','D','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.929116,-71.041703,0,'2013-07-06 12:44:30',NULL,NULL),(56608,'65565','S','Steelville','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.968536,-91.358000,0,'2013-07-06 12:44:33',NULL,NULL),(56470,'65305','S','Whiteman AFB','A','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.728246,-93.565357,0,'2013-07-06 12:44:33',NULL,NULL),(25814,'28608','U','Boone','D','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.211626,-81.668282,0,'2013-07-06 12:44:31',NULL,NULL),(41757,'47302','S','Breezewood Pk','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(74071,'92172','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.964590,-117.136931,0,'2013-07-06 12:44:34',NULL,NULL),(1877,'00791','S','Urb Miradero','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(35492,'39525','S','Bay St Louis','A','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.384560,-89.375564,0,'2013-07-06 12:44:32',NULL,NULL),(79088,'98439','S','JBLM','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(74060,'92161','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.879947,-117.228751,0,'2013-07-06 12:44:34',NULL,NULL),(30888,'33701','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.767645,-82.638123,0,'2013-07-06 12:44:32',NULL,NULL),(75316,'93761','U','United Faith Found','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.751664,-119.788568,0,'2013-07-06 12:44:34',NULL,NULL),(50620,'58265','S','Neche','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.946127,-97.483185,0,'2013-07-06 12:44:33',NULL,NULL),(36023,'40165','S','Pioneer Vlg','A','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.010762,-85.697038,0,'2013-07-06 12:44:32',NULL,NULL),(24136,'26559','P','Barrackville','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.500620,-80.172206,0,'2013-07-06 12:44:31',NULL,NULL),(44356,'49782','S','Beaver Island','D','Charlevoix','26029','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.666667,-85.550000,0,'2013-07-06 12:44:32',NULL,NULL),(41598,'47108','S','Livonia','A','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.650000,-86.260000,0,'2013-07-06 12:44:32',NULL,NULL),(34709,'38834','S','Biggersville','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(28288,'31093','S','Warner Robins','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.636119,-83.641763,0,'2013-07-06 12:44:31',NULL,NULL),(1673,'00773','S','Vistas De Luquillo II','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(5352,'04613','S','Birch Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.385517,-68.044934,0,'2013-07-06 12:44:30',NULL,NULL),(1931,'00795','S','Urb Las Marias','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(17203,'17821','S','Rushtown','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(9064,'08906','P','New Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.484296,-74.444675,0,'2013-07-06 12:44:30',NULL,NULL),(32013,'35235','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(23375,'25302','S','Big Chimney','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.386200,-81.617460,0,'2013-07-06 12:44:31',NULL,NULL),(38663,'43946','S','Sardis','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.639294,-80.949108,0,'2013-07-06 12:44:32',NULL,NULL),(45857,'52240','S','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.657959,-91.528060,0,'2013-07-06 12:44:32',NULL,NULL),(64006,'76116','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.714361,-97.464571,0,'2013-07-06 12:44:34',NULL,NULL),(51026,'58713','S','Bantry','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.500739,-100.784923,0,'2013-07-06 12:44:33',NULL,NULL),(48582,'55772','P','Nett Lake','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',48.053611,-92.830833,0,'2013-07-06 12:44:33',NULL,NULL),(21433,'22560','S','Tappahannock','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.923806,-76.864812,0,'2013-07-06 12:44:31',NULL,NULL),(16618,'17331','S','Hobart','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(27966,'30555','S','McCaysville','N','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.978674,-84.372632,0,'2013-07-06 12:44:31',NULL,NULL),(30754,'33565','S','Plant City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.086888,-82.154800,0,'2013-07-06 12:44:32',NULL,NULL),(78351,'98010','S','Black Diamond','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.311403,-121.997673,0,'2013-07-06 12:44:34',NULL,NULL),(74617,'92781','P','Tustin','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.736867,-117.818051,0,'2013-07-06 12:44:34',NULL,NULL),(72443,'89102','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.146544,-115.189684,0,'2013-07-06 12:44:34',NULL,NULL),(4704,'03816','S','Center Tuftonboro','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.656557,-71.251707,0,'2013-07-06 12:44:30',NULL,NULL),(16814,'17545','S','Manheim','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170819,-76.411581,0,'2013-07-06 12:44:31',NULL,NULL),(37302,'41635','S','Osborn','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(38852,'44094','S','Kirtland Hills','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(52580,'60970','S','Watseka','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.776658,-87.739943,0,'2013-07-06 12:44:33',NULL,NULL),(62992,'75152','S','Palmer','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.428210,-96.663681,0,'2013-07-06 12:44:33',NULL,NULL),(63231,'75462','S','Reno','A','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.667380,-95.500320,0,'2013-07-06 12:44:33',NULL,NULL),(66191,'78539','S','Red Gate','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(69730,'84043','S','Cedar Pass','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(64428,'76557','S','White Hall','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(60575,'71766','S','Thornton','D','Calhoun','05013','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.753543,-92.456546,0,'2013-07-06 12:44:33',NULL,NULL),(56009,'64652','S','Laredo','D','Grundy','29079','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.996154,-93.433679,0,'2013-07-06 12:44:33',NULL,NULL),(50951,'58602','P','Dickinson','D','Stark','38089','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.884926,-102.783730,0,'2013-07-06 12:44:33',NULL,NULL),(13005,'13415','S','New Lisbon','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.599137,-75.187460,0,'2013-07-06 12:44:30',NULL,NULL),(9961,'10159','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(9711,'10075','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.776185,-73.963945,0,'2013-07-06 12:44:30',NULL,NULL),(38408,'43534','S','Mc Clure','D','Henry','39069','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.373000,-83.939975,0,'2013-07-06 12:44:32',NULL,NULL),(44434,'49852','S','Vulcan','A','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.781469,-87.816698,0,'2013-07-06 12:44:32',NULL,NULL),(50841,'58481','S','Spiritwood','D','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.935970,-98.333360,0,'2013-07-06 12:44:33',NULL,NULL),(71822,'87575','S','Ensenada','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(68838,'82520','S','South Pass City','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(61203,'72255','U','Bba Solutions','N','Pulaski','05119','Arkansas','AR','05','4400','501','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:33',NULL,NULL),(47058,'54418','S','Polar','N','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.220320,-88.968660,0,'2013-07-06 12:44:32',NULL,NULL),(41666,'47151','P','New Albany','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287601,-85.825632,0,'2013-07-06 12:44:32',NULL,NULL),(32524,'36089','S','Union Springs','D','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.140539,-85.714718,0,'2013-07-06 12:44:32',NULL,NULL),(8441,'08085','S','Auburn','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(22214,'23520','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.845950,-76.285113,0,'2013-07-06 12:44:31',NULL,NULL),(10006,'10168','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750979,-73.977238,0,'2013-07-06 12:44:30',NULL,NULL),(59230,'70427','S','Mitch','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(50866,'58504','S','Livona','N','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.760820,-100.699380,0,'2013-07-06 12:44:33',NULL,NULL),(50575,'58225','S','Drayton','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.567554,-97.176905,0,'2013-07-06 12:44:33',NULL,NULL),(49307,'56537','S','Fergus Falls','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.291020,-96.074820,0,'2013-07-06 12:44:33',NULL,NULL),(48466,'55717','S','Shaw','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.079441,-92.470331,0,'2013-07-06 12:44:33',NULL,NULL),(15323,'16172','U','Westminster College','N','Lawrence','42073','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.122710,-80.336002,0,'2013-07-06 12:44:31',NULL,NULL),(32686,'36272','S','Brdn Sprngs','A','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.916629,-85.632561,0,'2013-07-06 12:44:32',NULL,NULL),(30753,'33564','P','Plant City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.019232,-82.097947,0,'2013-07-06 12:44:32',NULL,NULL),(28854,'32096','S','White Springs','D','Hamilton','12047','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.336677,-82.758442,0,'2013-07-06 12:44:32',NULL,NULL),(66178,'78526','S','Brownsville','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.931144,-97.496733,0,'2013-07-06 12:44:34',NULL,NULL),(38918,'44120','S','Shaker Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472129,-81.578028,0,'2013-07-06 12:44:32',NULL,NULL),(6840,'06119','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760843,-72.729064,0,'2013-07-06 12:44:30',NULL,NULL),(32467,'36033','S','Georgiana','D','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.640900,-86.734286,0,'2013-07-06 12:44:32',NULL,NULL),(30443,'33331','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(26648,'29353','S','Jonesville','D','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.815120,-81.694080,0,'2013-07-06 12:44:31',NULL,NULL),(21867,'23154','P','Schley','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.389953,-76.458186,0,'2013-07-06 12:44:31',NULL,NULL),(68944,'82936','S','Lonetree','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.028280,-110.137088,0,'2013-07-06 12:44:34',NULL,NULL),(58580,'68834','S','Eddyville','D','Dawson','31047','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.014295,-99.702870,0,'2013-07-06 12:44:33',NULL,NULL),(45418,'51054','S','Sergeant Blf','A','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.407067,-96.357402,0,'2013-07-06 12:44:32',NULL,NULL),(43618,'48811','S','Carson City','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.181337,-84.868066,0,'2013-07-06 12:44:32',NULL,NULL),(37917,'42633','S','Rockybranch','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(24101,'26508','S','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.589081,-79.896108,0,'2013-07-06 12:44:31',NULL,NULL),(14526,'15205','S','Crafton','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437059,-80.074137,0,'2013-07-06 12:44:31',NULL,NULL),(11530,'12043','S','Cobleskill','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.679057,-74.487086,0,'2013-07-06 12:44:30',NULL,NULL),(7124,'06384','S','Glasgo','A','New London','09011','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.574260,-71.884653,0,'2013-07-06 12:44:30',NULL,NULL),(78535,'98133','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.739660,-122.333340,0,'2013-07-06 12:44:34',NULL,NULL),(76458,'95614','S','Auburn Lake Trails','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.905494,-120.956183,0,'2013-07-06 12:44:34',NULL,NULL),(67597,'80423','S','Bond','D','Eagle','08037','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.906108,-106.632347,0,'2013-07-06 12:44:34',NULL,NULL),(65532,'77801','S','Reliance','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(36602,'40977','S','Cary','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(33470,'37331','S','Etowah','D','McMinn','47107','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.327364,-84.528516,0,'2013-07-06 12:44:32',NULL,NULL),(31235,'33972','S','Lehigh Acres','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.602691,-81.632837,0,'2013-07-06 12:44:32',NULL,NULL),(24931,'27814','S','Blounts Creek','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.369891,-76.922419,0,'2013-07-06 12:44:31',NULL,NULL),(47819,'55060','S','Owatonna','D','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.087587,-93.221024,0,'2013-07-06 12:44:33',NULL,NULL),(65173,'77414','S','Cedar Lake','N','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.963849,-95.948080,0,'2013-07-06 12:44:34',NULL,NULL),(60065,'71353','S','Melville','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(42667,'47960','S','Indiana Beach','N','White','18181','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.749635,-86.762622,0,'2013-07-06 12:44:32',NULL,NULL),(42366,'47710','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.011789,-87.579506,0,'2013-07-06 12:44:32',NULL,NULL),(17923,'18464','S','Tafton','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.412769,-75.169763,0,'2013-07-06 12:44:31',NULL,NULL),(10658,'11104','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.744648,-73.917792,0,'2013-07-06 12:44:30',NULL,NULL),(1063,'00725','S','Ext La Granja','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(73883,'91947','P','Lincoln Acres','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.668408,-117.069850,0,'2013-07-06 12:44:34',NULL,NULL),(62544,'74436','S','Haskell','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.820529,-95.670862,0,'2013-07-06 12:44:33',NULL,NULL),(55516,'63784','P','Vanduser','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.992092,-89.684917,0,'2013-07-06 12:44:33',NULL,NULL),(49706,'57033','S','Wall Lake','N','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.627967,-96.942970,0,'2013-07-06 12:44:33',NULL,NULL),(43274,'48331','S','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505080,-83.408580,0,'2013-07-06 12:44:32',NULL,NULL),(4891,'04047','S','Maplewood','N','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.802761,-70.891033,0,'2013-07-06 12:44:30',NULL,NULL),(13834,'14220','S','W Seneca','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.833786,-78.797770,0,'2013-07-06 12:44:31',NULL,NULL),(74469,'92599','U','Starcrest of Cal','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.830356,-117.198023,0,'2013-07-06 12:44:34',NULL,NULL),(55485,'63764','S','Lutesville','A','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.303440,-89.971980,0,'2013-07-06 12:44:33',NULL,NULL),(6597,'05862','S','Peacham','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.338056,-72.157778,0,'2013-07-06 12:44:30',NULL,NULL),(12472,'12983','S','Saranac Lake','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.316720,-74.133540,0,'2013-07-06 12:44:30',NULL,NULL),(27488,'30160','P','Kennesaw','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.025101,-84.615154,0,'2013-07-06 12:44:31',NULL,NULL),(26998,'29630','S','Central','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.743252,-82.799162,0,'2013-07-06 12:44:31',NULL,NULL),(2009,'00914','P','Loiza Street','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.448288,-66.016711,0,'2013-07-06 12:44:30',NULL,NULL),(1566,'00766','S','Villalba','D','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(41052,'46409','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.545122,-87.323773,0,'2013-07-06 12:44:32',NULL,NULL),(45727,'52078','S','Worthington','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.393176,-91.102562,0,'2013-07-06 12:44:32',NULL,NULL),(220,'00624','S','Urb Guayanes','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(78933,'98366','S','S Park Vil','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(71928,'87830','S','San Francisco Plaza','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652664,-108.764998,0,'2013-07-06 12:44:34',NULL,NULL),(62360,'74066','S','Supulpa','N','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.000197,-96.113994,0,'2013-07-06 12:44:33',NULL,NULL),(52239,'60507','P','Aurora','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.785320,-88.318452,0,'2013-07-06 12:44:33',NULL,NULL),(42862,'48081','S','Saint Clair Shores','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(39058,'44195','U','Cleveland Clinic Foundation','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.502183,-81.619647,0,'2013-07-06 12:44:32',NULL,NULL),(15775,'16921','S','Marshlands','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(11658,'12137','S','Mariaville','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.855720,-74.127900,0,'2013-07-06 12:44:30',NULL,NULL),(8987,'08833','S','Lebanon','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.644815,-74.826924,0,'2013-07-06 12:44:30',NULL,NULL),(12677,'13126','S','Oswego Center','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(70153,'84313','S','Etna','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.441690,-113.769269,0,'2013-07-06 12:44:34',NULL,NULL),(69186,'83338','S','Falls City','N','Jerome','16053','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.709237,-114.464322,0,'2013-07-06 12:44:34',NULL,NULL),(10476,'10950','S','Monroe','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.338274,-74.185886,0,'2013-07-06 12:44:30',NULL,NULL),(9100,'09075','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8152,'07849','S','Lk Hopatcong','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.954339,-74.614031,0,'2013-07-06 12:44:30',NULL,NULL),(41133,'46626','U','South Bend Tribune','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.657277,-86.295067,0,'2013-07-06 12:44:32',NULL,NULL),(45446,'51231','S','Archer','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.115395,-95.745834,0,'2013-07-06 12:44:32',NULL,NULL),(50309,'57716','S','Denby','A','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.104120,-102.197880,0,'2013-07-06 12:44:33',NULL,NULL),(60519,'71667','S','Relfs Bluff','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(63172,'75401','S','Greenville','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.147180,-96.103980,0,'2013-07-06 12:44:33',NULL,NULL),(63283,'75555','S','Wiggins','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.939700,-94.147800,0,'2013-07-06 12:44:33',NULL,NULL),(2726,'00969','S','Urb Cerro Real','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(78509,'98115','S','Seattle Naval Support Activi','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.683441,-122.291533,0,'2013-07-06 12:44:34',NULL,NULL),(64039,'76127','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.776500,-97.423380,0,'2013-07-06 12:44:34',NULL,NULL),(55209,'63389','S','Winfield','D','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.008098,-90.746290,0,'2013-07-06 12:44:33',NULL,NULL),(49732,'57049','S','Dakota Dunes','A','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.528060,-96.503280,0,'2013-07-06 12:44:33',NULL,NULL),(27900,'30474','S','Kibbee','N','Toombs','13279','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.210424,-82.411532,0,'2013-07-06 12:44:31',NULL,NULL),(4570,'03469','P','W Swanzey','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.864159,-72.328061,0,'2013-07-06 12:44:30',NULL,NULL),(18349,'19034','S','Upper Dublin','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.135875,-75.206603,0,'2013-07-06 12:44:31',NULL,NULL),(29284,'32501','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.419339,-87.219070,0,'2013-07-06 12:44:32',NULL,NULL),(22471,'24050','U','Hanover Direct','N','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.346218,-79.957184,0,'2013-07-06 12:44:31',NULL,NULL),(3681,'02129','S','Charlestown','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.336180,-71.103660,0,'2013-07-06 12:44:30',NULL,NULL),(74562,'92679','S','Robinson Rnch','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(73901,'92007','S','Cardiff by the Sea','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.020814,-117.267083,0,'2013-07-06 12:44:34',NULL,NULL),(33135,'36904','S','Lavaca','A','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.091455,-88.222286,0,'2013-07-06 12:44:32',NULL,NULL),(20626,'21215','S','Arlington','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.346278,-76.681280,0,'2013-07-06 12:44:31',NULL,NULL),(42281,'47586','S','Fenn Haven','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(42646,'47932','S','Covington','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.138435,-87.391625,0,'2013-07-06 12:44:32',NULL,NULL),(46086,'52595','P','University Park','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.285630,-92.620526,0,'2013-07-06 12:44:32',NULL,NULL),(52850,'61322','P','Howe','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.325484,-89.303078,0,'2013-07-06 12:44:33',NULL,NULL),(53645,'62203','S','E St Louis','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.598771,-90.076739,0,'2013-07-06 12:44:33',NULL,NULL),(60475,'71655','S','Montongo','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(66633,'78828','S','Vance','N','Edwards','48137','Texas','TX','48','0000','830','Central',-6.0,'Y',29.736480,-100.103400,0,'2013-07-06 12:44:34',NULL,NULL),(72245,'88521','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.814284,-106.418275,0,'2013-07-06 12:44:34',NULL,NULL),(11116,'11702','S','West Gilgo Beach','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(9449,'10006','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711230,-74.012908,0,'2013-07-06 12:44:30',NULL,NULL),(33501,'37359','S','Mulberry','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.182176,-86.417080,0,'2013-07-06 12:44:32',NULL,NULL),(3070,'01129','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.122932,-72.486989,0,'2013-07-06 12:44:30',NULL,NULL),(75890,'94965','S','Muir Beach','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.865100,-122.530980,0,'2013-07-06 12:44:34',NULL,NULL),(67962,'80914','P','Chey Mtn AFB','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(67813,'80746','P','Paoli','D','Phillips','08095','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.608040,-102.549851,0,'2013-07-06 12:44:34',NULL,NULL),(57806,'67505','S','So Hutchinson','N','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.019420,-97.973340,0,'2013-07-06 12:44:33',NULL,NULL),(53932,'62401','S','Saint Marys','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(25102,'27966','S','Powells Point','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.116292,-75.836750,0,'2013-07-06 12:44:31',NULL,NULL),(20864,'21664','P','Secretary','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.609098,-75.949023,0,'2013-07-06 12:44:31',NULL,NULL),(34647,'38769','S','Wright','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.846420,-91.001880,0,'2013-07-06 12:44:32',NULL,NULL),(35043,'39173','S','Tinsley','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.731312,-90.458132,0,'2013-07-06 12:44:32',NULL,NULL),(35172,'39271','U','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289835,-90.180840,0,'2013-07-06 12:44:32',NULL,NULL),(63931,'76064','S','Maypearl','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.308249,-97.028525,0,'2013-07-06 12:44:34',NULL,NULL),(62052,'73533','S','Empire City','A','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.513258,-97.960374,0,'2013-07-06 12:44:33',NULL,NULL),(58447,'68717','S','Belden','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.393887,-97.193244,0,'2013-07-06 12:44:33',NULL,NULL),(46249,'53006','S','Brownsville','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.615200,-88.516980,0,'2013-07-06 12:44:32',NULL,NULL),(45128,'50568','S','Newell','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.605095,-95.005059,0,'2013-07-06 12:44:32',NULL,NULL),(40774,'46158','S','Mooresville','D','Morgan','18109','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.592032,-86.375059,0,'2013-07-06 12:44:32',NULL,NULL),(39664,'45011','S','Saint Clair','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(15501,'16507','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.135100,-80.085131,0,'2013-07-06 12:44:31',NULL,NULL),(15404,'16343','P','Reno','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.410444,-79.747292,0,'2013-07-06 12:44:31',NULL,NULL),(11294,'11776','S','Prt Jefferson STation','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(33667,'37725','S','Dandridge','D','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.020059,-83.419087,0,'2013-07-06 12:44:32',NULL,NULL),(32829,'36467','S','Opp','D','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.285500,-86.264760,0,'2013-07-06 12:44:32',NULL,NULL),(28860,'32111','P','Candler','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.164842,-82.217478,0,'2013-07-06 12:44:32',NULL,NULL),(8587,'08223','S','Palermo','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.262920,-74.661780,0,'2013-07-06 12:44:30',NULL,NULL),(22686,'24315','S','Bland Correctional Farm','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.142078,-81.013829,0,'2013-07-06 12:44:31',NULL,NULL),(13207,'13626','S','S Rutland','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.895883,-75.707121,0,'2013-07-06 12:44:30',NULL,NULL),(74603,'92706','S','King','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.769052,-117.885536,0,'2013-07-06 12:44:34',NULL,NULL),(60973,'72105','P','Malvern','A','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.437500,-92.887500,0,'2013-07-06 12:44:33',NULL,NULL),(51799,'60047','S','Forest Lake','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(48292,'55436','S','St Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.901982,-93.372906,0,'2013-07-06 12:44:33',NULL,NULL),(36930,'41164','S','Clark Hill','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(35139,'39217','U','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.288941,-90.186095,0,'2013-07-06 12:44:32',NULL,NULL),(25525,'28393','S','Turkey','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.955656,-78.206696,0,'2013-07-06 12:44:31',NULL,NULL),(12569,'13060','S','Hart Lot','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.024371,-76.418761,0,'2013-07-06 12:44:30',NULL,NULL),(76498,'95635','S','Greenwood','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917442,-120.901475,0,'2013-07-06 12:44:34',NULL,NULL),(75996,'95103','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.341165,-121.888307,0,'2013-07-06 12:44:34',NULL,NULL),(70665,'85211','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.442359,-111.849093,0,'2013-07-06 12:44:34',NULL,NULL),(69196,'83344','S','Murtaugh','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.493358,-114.161857,0,'2013-07-06 12:44:34',NULL,NULL),(51702,'60006','P','Arlington Hts','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.130610,-88.092341,0,'2013-07-06 12:44:33',NULL,NULL),(31139,'33907','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.564829,-81.887080,0,'2013-07-06 12:44:32',NULL,NULL),(14962,'15623','S','Claridge','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.363355,-79.619134,0,'2013-07-06 12:44:31',NULL,NULL),(20517,'21087','S','Kingsville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.448752,-76.419654,0,'2013-07-06 12:44:31',NULL,NULL),(27352,'30056','S','Newborn','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.484500,-83.665156,0,'2013-07-06 12:44:31',NULL,NULL),(25477,'28349','S','Kenansville','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.962078,-77.960596,0,'2013-07-06 12:44:31',NULL,NULL),(22370,'23921','S','Buckingham','D','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.598418,-78.615702,0,'2013-07-06 12:44:31',NULL,NULL),(44618,'50060','S','Sewal','A','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.758022,-93.318743,0,'2013-07-06 12:44:32',NULL,NULL),(73534,'91351','S','Canyon Country','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.425819,-118.443437,0,'2013-07-06 12:44:34',NULL,NULL),(72126,'88264','S','Maljamar','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.825571,-103.734737,0,'2013-07-06 12:44:34',NULL,NULL),(66327,'78598','P','Prt Mansfield','A','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.560268,-97.431370,0,'2013-07-06 12:44:34',NULL,NULL),(58277,'68404','S','Princeton','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.642620,-96.747120,0,'2013-07-06 12:44:33',NULL,NULL),(53800,'62286','S','Sparta','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.151540,-89.723160,0,'2013-07-06 12:44:33',NULL,NULL),(41305,'46769','P','Linn Grove','D','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.644448,-85.031233,0,'2013-07-06 12:44:32',NULL,NULL),(40452,'45740','P','Jacksonville','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.477806,-82.079070,0,'2013-07-06 12:44:32',NULL,NULL),(21496,'22657','S','Strasburg','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.987689,-78.359876,0,'2013-07-06 12:44:31',NULL,NULL),(15915,'17018','S','Ellendale','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.370886,-76.931434,0,'2013-07-06 12:44:31',NULL,NULL),(4175,'02808','S','Bradford','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.405039,-71.750551,0,'2013-07-06 12:44:30',NULL,NULL),(34522,'38680','S','Lake View','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.961644,-90.119278,0,'2013-07-06 12:44:32',NULL,NULL),(79064,'98430','U','Camp Murray Natl Guard','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.255899,-122.440697,0,'2013-07-06 12:44:34',NULL,NULL),(65827,'78150','S','Randolph AFB','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(63693,'75862','S','Trinity','D','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(57850,'67564','S','Olmitz','D','Barton','20009','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.565580,-98.916485,0,'2013-07-06 12:44:33',NULL,NULL),(79897,'99586','S','Miers Lake','A','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.714253,-143.985789,0,'2013-07-06 12:44:34',NULL,NULL),(9561,'10024','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(14503,'15148','S','Wilmerding','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.388580,-79.796940,0,'2013-07-06 12:44:31',NULL,NULL),(15670,'16820','S','Aaronsburg','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.862757,-77.391287,0,'2013-07-06 12:44:31',NULL,NULL),(39507,'44807','S','Reed','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(41246,'46742','S','Hamilton','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(47124,'54452','S','Corning','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.182325,-89.694701,0,'2013-07-06 12:44:32',NULL,NULL),(74431,'92563','S','Murrieta Hot Springs','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.564738,-117.171595,0,'2013-07-06 12:44:34',NULL,NULL),(71871,'87724','S','La Loma','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.195854,-105.084813,0,'2013-07-06 12:44:34',NULL,NULL),(61231,'72330','S','Dyess','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.594515,-90.218765,0,'2013-07-06 12:44:33',NULL,NULL),(60558,'71745','P','Harrell','D','Calhoun','05013','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.502995,-92.392347,0,'2013-07-06 12:44:33',NULL,NULL),(8864,'08690','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.224987,-74.661288,0,'2013-07-06 12:44:30',NULL,NULL),(28316,'31141','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761509,-84.419799,0,'2013-07-06 12:44:31',NULL,NULL),(10370,'10589','S','Somers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.335949,-73.694100,0,'2013-07-06 12:44:30',NULL,NULL),(24806,'27597','S','Zebulon','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.845905,-78.338439,0,'2013-07-06 12:44:31',NULL,NULL),(14196,'14760','S','Olean','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.081747,-78.426015,0,'2013-07-06 12:44:31',NULL,NULL),(66054,'78379','S','Loyola Beach','N','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.319380,-97.862520,0,'2013-07-06 12:44:34',NULL,NULL),(59382,'70605','S','Sweet Lake','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.125640,-93.202680,0,'2013-07-06 12:44:33',NULL,NULL),(52443,'60664','P','State of Il','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.873171,-87.654296,0,'2013-07-06 12:44:33',NULL,NULL),(12302,'12852','S','Newcomb','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.017069,-74.127361,0,'2013-07-06 12:44:30',NULL,NULL),(12254,'12831','S','Kings Station','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.198440,-73.678260,0,'2013-07-06 12:44:30',NULL,NULL),(6703,'06063','S','Pleasant Valley','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917156,-72.977392,0,'2013-07-06 12:44:30',NULL,NULL),(21768,'23061','S','Naxera','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.435603,-76.547405,0,'2013-07-06 12:44:31',NULL,NULL),(8429,'08079','S','Mannington','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.548542,-75.452329,0,'2013-07-06 12:44:30',NULL,NULL),(2006,'00913','S','Isla Verde','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451003,-66.045064,0,'2013-07-06 12:44:30',NULL,NULL),(15035,'15692','S','Westmrlnd Cty','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.330504,-79.679891,0,'2013-07-06 12:44:31',NULL,NULL),(38707,'44004','S','Edgewood','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.850540,-80.777400,0,'2013-07-06 12:44:32',NULL,NULL),(80009,'99675','P','Mc Grath','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.980000,-156.060000,0,'2013-07-06 12:44:34',NULL,NULL),(77901,'97302','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.900455,-123.045639,0,'2013-07-06 12:44:34',NULL,NULL),(75392,'93960','S','Soledad','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.411765,-121.316768,0,'2013-07-06 12:44:34',NULL,NULL),(49368,'56584','S','Syre','N','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.284811,-96.264019,0,'2013-07-06 12:44:33',NULL,NULL),(48295,'55437','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.822599,-93.341540,0,'2013-07-06 12:44:33',NULL,NULL),(33127,'36875','S','Seale','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.336199,-85.019591,0,'2013-07-06 12:44:32',NULL,NULL),(7800,'07438','S','Cozy Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.033460,-74.499840,0,'2013-07-06 12:44:30',NULL,NULL),(10738,'11357','S','Beechhurst','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.783792,-73.812287,0,'2013-07-06 12:44:30',NULL,NULL),(10630,'11052','U','Prt Washingtn','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.844414,-73.701934,0,'2013-07-06 12:44:30',NULL,NULL),(1127,'00725','S','Villa de Castro','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(15778,'16922','S','Abbott','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.712840,-77.662020,0,'2013-07-06 12:44:31',NULL,NULL),(17200,'17821','S','Mooresburg','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(36722,'41031','S','Connersville','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(37079,'41332','S','Hazel Green','D','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.796026,-83.456314,0,'2013-07-06 12:44:32',NULL,NULL),(38816,'44074','S','Elyria','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.286311,-82.234157,0,'2013-07-06 12:44:32',NULL,NULL),(79439,'98837','S','Moses Lake','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.126359,-119.296146,0,'2013-07-06 12:44:34',NULL,NULL),(78002,'97409','P','Alvadore','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.128550,-123.267113,0,'2013-07-06 12:44:34',NULL,NULL),(71957,'88002','S','Las Cruces','A','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.263759,-106.471871,0,'2013-07-06 12:44:34',NULL,NULL),(67307,'80021','S','Broomfield','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.883964,-105.106613,0,'2013-07-06 12:44:34',NULL,NULL),(59715,'71106','S','Spring Lake','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.426395,-93.738506,0,'2013-07-06 12:44:33',NULL,NULL),(54404,'62827','S','Calvin','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.169678,-88.066046,0,'2013-07-06 12:44:33',NULL,NULL),(35847,'39817','S','Bdge','N','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.905055,-84.568611,0,'2013-07-06 12:44:32',NULL,NULL),(35629,'39633','S','Crosby','D','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(11887,'12309','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.795780,-73.867440,0,'2013-07-06 12:44:30',NULL,NULL),(20341,'20853','S','Rockville','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.096217,-77.095489,0,'2013-07-06 12:44:31',NULL,NULL),(20006,'20612','P','Benedict','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.508971,-76.679356,0,'2013-07-06 12:44:31',NULL,NULL),(795,'00693','S','Hacienda La Arboleda','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(39130,'44266','S','Ravenna','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.159227,-81.233714,0,'2013-07-06 12:44:32',NULL,NULL),(41617,'47124','S','Greenville','D','Floyd','18043','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.374078,-85.992416,0,'2013-07-06 12:44:32',NULL,NULL),(46897,'54124','S','Gillett','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.903377,-88.341021,0,'2013-07-06 12:44:32',NULL,NULL),(47054,'54415','P','Blenker','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.618384,-89.918069,0,'2013-07-06 12:44:32',NULL,NULL),(77951,'97357','S','Logsden','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.751580,-123.815364,0,'2013-07-06 12:44:34',NULL,NULL),(75329,'93779','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.747859,-119.791661,0,'2013-07-06 12:44:34',NULL,NULL),(63968,'76102','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.757178,-97.323972,0,'2013-07-06 12:44:34',NULL,NULL),(57430,'66782','P','Mineral','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.286058,-94.924505,0,'2013-07-06 12:44:33',NULL,NULL),(53391,'61815','P','Bondville','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.111439,-88.368949,0,'2013-07-06 12:44:33',NULL,NULL),(12878,'13326','S','Hartwick Seminary','A','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.716131,-74.906704,0,'2013-07-06 12:44:30',NULL,NULL),(36106,'40220','S','St Regis Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(31859,'35118','S','Sylvan Spgs','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.538080,-87.039240,0,'2013-07-06 12:44:32',NULL,NULL),(2744,'00969','S','Urb Palma Real','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(59220,'70404','P','Hammond','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.512272,-90.456313,0,'2013-07-06 12:44:33',NULL,NULL),(57345,'66725','S','Melrose','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.167381,-94.844493,0,'2013-07-06 12:44:33',NULL,NULL),(54425,'62837','S','Crestview Terrace','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(49493,'56661','S','Shooks','N','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.828166,-94.143470,0,'2013-07-06 12:44:33',NULL,NULL),(48098,'55343','S','Hopkins','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(7983,'07712','S','Interlaken','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(32859,'36509','S','Bayou Labatre','A','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.403859,-88.246081,0,'2013-07-06 12:44:32',NULL,NULL),(19145,'19703','S','Claymont','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.804953,-75.464429,0,'2013-07-06 12:44:31',NULL,NULL),(20557,'21128','S','Perry Hall','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.401633,-76.446100,0,'2013-07-06 12:44:31',NULL,NULL),(76213,'95365','S','Planada','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.291780,-120.317118,0,'2013-07-06 12:44:34',NULL,NULL),(65501,'77662','S','Rose City','N','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.145872,-94.010918,0,'2013-07-06 12:44:34',NULL,NULL),(57094,'66218','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.014399,-94.817167,0,'2013-07-06 12:44:33',NULL,NULL),(56841,'65814','P','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.216841,-93.300022,0,'2013-07-06 12:44:33',NULL,NULL),(38229,'43228','S','New Rome','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.951399,-83.128000,0,'2013-07-06 12:44:32',NULL,NULL),(16244,'17082','S','Beale','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(11190,'11735','S','S Farmingdale','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.725297,-73.444737,0,'2013-07-06 12:44:30',NULL,NULL),(32623,'36142','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.381048,-86.310445,0,'2013-07-06 12:44:32',NULL,NULL),(4499,'03284','S','West Springfield','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.486437,-72.056353,0,'2013-07-06 12:44:30',NULL,NULL),(22574,'24153','S','Kesslers Mill','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(20543,'21111','S','Monkton','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.569940,-76.592880,0,'2013-07-06 12:44:31',NULL,NULL),(20295,'20811','U','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.982042,-77.099807,0,'2013-07-06 12:44:31',NULL,NULL),(75629,'94511','P','Bethel Island','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.023001,-121.652091,0,'2013-07-06 12:44:34',NULL,NULL),(73327,'90840','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.781444,-118.118257,0,'2013-07-06 12:44:34',NULL,NULL),(68212,'81047','S','Bristol','A','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.982565,-102.140804,0,'2013-07-06 12:44:34',NULL,NULL),(11828,'12240','U','NY Labor Div Empl','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651487,-73.756900,0,'2013-07-06 12:44:30',NULL,NULL),(1506,'00754','S','Alt de San Lorenzo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(32537,'36105','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.323522,-86.313946,0,'2013-07-06 12:44:32',NULL,NULL),(29874,'33041','P','Ky Wst','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.558003,-81.808398,0,'2013-07-06 12:44:32',NULL,NULL),(15075,'15745','P','Heilwood','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.622231,-78.914064,0,'2013-07-06 12:44:31',NULL,NULL),(46575,'53528','S','Cross Plains','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.120810,-89.638208,0,'2013-07-06 12:44:32',NULL,NULL),(75899,'94976','P','Corte Madera','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.927431,-122.524551,0,'2013-07-06 12:44:34',NULL,NULL),(64898,'77084','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.821140,-95.640017,0,'2013-07-06 12:44:34',NULL,NULL),(43478,'48604','S','Zilwaukee','A','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.473230,-83.947983,0,'2013-07-06 12:44:32',NULL,NULL),(40469,'45767','S','Fly','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.603478,-81.082854,0,'2013-07-06 12:44:32',NULL,NULL),(10166,'10279','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(30306,'33302','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.036168,-80.196791,0,'2013-07-06 12:44:32',NULL,NULL),(2347,'00939','U','Unique Brm','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.408286,-66.064668,0,'2013-07-06 12:44:30',NULL,NULL),(64146,'76198','U','Jp Morgan Chase','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.755079,-97.332446,0,'2013-07-06 12:44:34',NULL,NULL),(59642,'71039','S','Heflin','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.441009,-93.295609,0,'2013-07-06 12:44:33',NULL,NULL),(56119,'64804','S','Joplin','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.064704,-94.509874,0,'2013-07-06 12:44:33',NULL,NULL),(53694,'62231','S','Carlyle','D','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(30995,'33767','S','Clearwater Beach','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.982798,-82.817763,0,'2013-07-06 12:44:32',NULL,NULL),(18682,'19185','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.891542,-75.169424,0,'2013-07-06 12:44:31',NULL,NULL),(4086,'02664','S','So Yarmouth','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.668281,-70.193806,0,'2013-07-06 12:44:30',NULL,NULL),(11323,'11786','S','Shoreham','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.949365,-72.891529,0,'2013-07-06 12:44:30',NULL,NULL),(12268,'12834','S','Greenwich','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.090326,-73.500080,0,'2013-07-06 12:44:30',NULL,NULL),(66552,'78734','S','Bee Cave','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371100,-97.869900,0,'2013-07-06 12:44:34',NULL,NULL),(62598,'74501','S','Scipio','N','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.935281,-95.767139,0,'2013-07-06 12:44:33',NULL,NULL),(29520,'32777','P','Tangerine','D','Orange','12095','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.760814,-81.625640,0,'2013-07-06 12:44:32',NULL,NULL),(1991,'00908','P','Santurce Station','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444163,-66.079468,0,'2013-07-06 12:44:30',NULL,NULL),(15187,'15945','S','Parkhill','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.326667,-78.922222,0,'2013-07-06 12:44:31',NULL,NULL),(16302,'17111','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.270440,-76.805460,0,'2013-07-06 12:44:31',NULL,NULL),(22626,'24237','S','Dante','D','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.040485,-82.275198,0,'2013-07-06 12:44:31',NULL,NULL),(22464,'24038','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.271690,-79.956295,0,'2013-07-06 12:44:31',NULL,NULL),(46130,'52646','S','Oakville','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.097250,-91.043310,0,'2013-07-06 12:44:32',NULL,NULL),(10152,'10276','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733951,-73.989188,0,'2013-07-06 12:44:30',NULL,NULL),(72283,'88563','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768358,-106.327597,0,'2013-07-06 12:44:34',NULL,NULL),(69069,'83241','S','Central','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(64191,'76244','S','Fort Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.934024,-97.250604,0,'2013-07-06 12:44:34',NULL,NULL),(48022,'55188','U','Target Direct','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.919109,-92.941297,0,'2013-07-06 12:44:33',NULL,NULL),(39160,'44302','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.092067,-81.539665,0,'2013-07-06 12:44:32',NULL,NULL),(57274,'66549','S','Blaine','A','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.474166,-96.415994,0,'2013-07-06 12:44:33',NULL,NULL),(42312,'47611','S','Chrisney','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.011983,-87.032495,0,'2013-07-06 12:44:32',NULL,NULL),(41547,'47011','S','Bennington','D','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.872783,-85.080787,0,'2013-07-06 12:44:32',NULL,NULL),(39990,'45241','S','Sharonville','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267662,-84.405863,0,'2013-07-06 12:44:32',NULL,NULL),(25060,'27928','S','Creswell','D','Washington','37187','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.810130,-76.456380,0,'2013-07-06 12:44:31',NULL,NULL),(34562,'38730','S','Skene','A','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.705356,-90.727661,0,'2013-07-06 12:44:32',NULL,NULL),(31770,'35011','P','Alex City','A','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.927018,-85.937364,0,'2013-07-06 12:44:32',NULL,NULL),(30143,'33166','S','Miami Springs','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.821954,-80.300074,0,'2013-07-06 12:44:32',NULL,NULL),(13176,'13616','S','Calcium','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.024370,-75.858123,0,'2013-07-06 12:44:30',NULL,NULL),(78115,'97502','S','Central Point','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.402193,-122.914829,0,'2013-07-06 12:44:34',NULL,NULL),(74467,'92596','S','Winchester','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.625979,-117.068531,0,'2013-07-06 12:44:34',NULL,NULL),(61211,'72312','P','Barton','D','Phillips','05107','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.493787,-90.713159,0,'2013-07-06 12:44:33',NULL,NULL),(56583,'65546','P','Montier','D','Shannon','29203','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.987875,-91.575003,0,'2013-07-06 12:44:33',NULL,NULL),(53417,'61846','S','Georgetown','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.982066,-87.633758,0,'2013-07-06 12:44:33',NULL,NULL),(36799,'41055','S','Mays Lick','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(36485,'40801','P','Ages Brookside','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.859167,-83.249444,0,'2013-07-06 12:44:32',NULL,NULL),(34226,'38368','S','Reagan','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.512768,-88.355669,0,'2013-07-06 12:44:32',NULL,NULL),(28960,'32202','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.328103,-81.654825,0,'2013-07-06 12:44:32',NULL,NULL),(26067,'28694','S','Smethport','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(16929,'17605','P','Lancaster','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.014997,-76.248254,0,'2013-07-06 12:44:31',NULL,NULL),(20443,'21009','S','Abingdon','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.473034,-76.297814,0,'2013-07-06 12:44:31',NULL,NULL),(17275,'17844','S','West Buffalo','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(52079,'60402','S','Berwyn','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.838828,-87.791023,0,'2013-07-06 12:44:33',NULL,NULL),(53342,'61756','S','Maroa','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',40.037374,-88.958544,0,'2013-07-06 12:44:33',NULL,NULL),(50044,'57434','S','Conde','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.165262,-98.015514,0,'2013-07-06 12:44:33',NULL,NULL),(44955,'50392','U','Principal Financial','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.590370,-93.629659,0,'2013-07-06 12:44:32',NULL,NULL),(44232,'49654','S','South Manitou','N','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.025065,-85.752371,0,'2013-07-06 12:44:32',NULL,NULL),(35103,'39208','S','JAX','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.271720,-90.104940,0,'2013-07-06 12:44:32',NULL,NULL),(13956,'14464','S','Hamlin','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.316716,-77.921667,0,'2013-07-06 12:44:31',NULL,NULL),(12211,'12792','S','Yulan','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.521354,-74.929301,0,'2013-07-06 12:44:30',NULL,NULL),(38770,'44048','S','Kingsville','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.861290,-80.654690,0,'2013-07-06 12:44:32',NULL,NULL),(40265,'45432','S','Dayton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.741263,-84.068879,0,'2013-07-06 12:44:32',NULL,NULL),(7276,'06525','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.360503,-73.012777,0,'2013-07-06 12:44:30',NULL,NULL),(77645,'97015','S','Carver','N','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.415610,-122.523750,0,'2013-07-06 12:44:34',NULL,NULL),(62499,'74363','S','Peoria','A','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.942000,-94.732920,0,'2013-07-06 12:44:33',NULL,NULL),(43005,'48161','S','Frenchtown','A','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.909061,-83.470098,0,'2013-07-06 12:44:32',NULL,NULL),(40729,'46125','P','Eminence','D','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.522149,-86.637917,0,'2013-07-06 12:44:32',NULL,NULL),(22448,'24022','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.272082,-79.939745,0,'2013-07-06 12:44:31',NULL,NULL),(27707,'30341','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.897852,-84.306585,0,'2013-07-06 12:44:31',NULL,NULL),(27881,'30453','S','Reidsville','D','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.081383,-82.118083,0,'2013-07-06 12:44:31',NULL,NULL),(16624,'17331','S','Pennville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(29153,'32341','P','Madison','D','Madison','12079','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.469730,-83.417479,0,'2013-07-06 12:44:32',NULL,NULL),(3377,'01590','S','Wilkinsonvile','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.138424,-71.752496,0,'2013-07-06 12:44:30',NULL,NULL),(79401,'98802','S','Wenatchee','A','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.438520,-120.234960,0,'2013-07-06 12:44:34',NULL,NULL),(74364,'92418','U','City Hall','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.104145,-117.290746,0,'2013-07-06 12:44:34',NULL,NULL),(56059,'64743','P','East Lynne','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.668198,-94.227681,0,'2013-07-06 12:44:33',NULL,NULL),(38492,'43667','U','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.650895,-83.535228,0,'2013-07-06 12:44:32',NULL,NULL),(27470,'30144','S','Barrett Parkway','N','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.034049,-84.584675,0,'2013-07-06 12:44:31',NULL,NULL),(25554,'28410','U','Willow Ridge','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.125636,-77.953828,0,'2013-07-06 12:44:31',NULL,NULL),(72431,'89077','P','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.035100,-114.976600,0,'2013-07-06 12:44:34',NULL,NULL),(66092,'78404','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.766532,-97.401972,0,'2013-07-06 12:44:34',NULL,NULL),(61238,'72338','S','Frenchman Byu','A','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.467529,-90.059363,0,'2013-07-06 12:44:33',NULL,NULL),(2713,'00969','S','Parq San Ramon','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(4635,'03608','S','Walpole','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.070183,-72.407165,0,'2013-07-06 12:44:30',NULL,NULL),(20678,'21234','S','Parkville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.391101,-76.535369,0,'2013-07-06 12:44:31',NULL,NULL),(35887,'39901','U','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.890737,-84.287630,0,'2013-07-06 12:44:32',NULL,NULL),(29958,'33074','P','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.238998,-80.124146,0,'2013-07-06 12:44:32',NULL,NULL),(40226,'45414','S','Northridge','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.827790,-84.203696,0,'2013-07-06 12:44:32',NULL,NULL),(50036,'57430','S','Newark','N','Marshall','46091','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.806700,-97.722180,0,'2013-07-06 12:44:33',NULL,NULL),(70347,'84636','P','Holden','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.104100,-112.269847,0,'2013-07-06 12:44:34',NULL,NULL),(55648,'64022','S','Dover','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.184485,-93.663696,0,'2013-07-06 12:44:33',NULL,NULL),(54566,'62895','S','Orel','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(53514,'62023','P','Eagarville','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.109720,-89.783720,0,'2013-07-06 12:44:33',NULL,NULL),(29900,'33050','S','Grassy Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(6497,'05777','S','Clarendon Springs','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.547778,-73.022778,0,'2013-07-06 12:44:30',NULL,NULL),(37514,'42039','S','Fancy Farm','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.758589,-88.795489,0,'2013-07-06 12:44:32',NULL,NULL),(14590,'15221','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(65107,'77368','P','Romayor','D','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.448695,-94.843557,0,'2013-07-06 12:44:34',NULL,NULL),(62631,'74556','P','Lehigh','D','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.473773,-96.221551,0,'2013-07-06 12:44:33',NULL,NULL),(61260,'72364','S','Marion','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.213006,-90.202685,0,'2013-07-06 12:44:33',NULL,NULL),(50533,'58107','P','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.825832,-96.848634,0,'2013-07-06 12:44:33',NULL,NULL),(10669,'11109','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742578,-73.949048,0,'2013-07-06 12:44:30',NULL,NULL),(28955,'32198','U','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.195511,-81.052236,0,'2013-07-06 12:44:32',NULL,NULL),(26283,'29020','S','Dusty Bend','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(26087,'28710','P','Bat Cave','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.430771,-82.544357,0,'2013-07-06 12:44:31',NULL,NULL),(23679,'25840','S','Tourison','N','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(19484,'20149','U','Ashburn','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.043616,-77.481607,0,'2013-07-06 12:44:31',NULL,NULL),(39132,'44270','S','Rittman','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.952500,-81.735556,0,'2013-07-06 12:44:32',NULL,NULL),(44648,'50078','P','Ferguson','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.940879,-92.867284,0,'2013-07-06 12:44:32',NULL,NULL),(77410,'96789','S','Mililani','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.447784,-158.023645,0,'2013-07-06 12:44:34',NULL,NULL),(74786,'93118','P','Santa Barbara','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.435471,-119.824927,0,'2013-07-06 12:44:34',NULL,NULL),(70264,'84520','S','East Carbon','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.543972,-110.414477,0,'2013-07-06 12:44:34',NULL,NULL),(59392,'70616','P','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.224615,-93.212779,0,'2013-07-06 12:44:33',NULL,NULL),(59043,'70085','S','Poydras','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(57847,'67560','S','Ness City','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.455286,-99.905530,0,'2013-07-06 12:44:33',NULL,NULL),(39196,'44328','U','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.087158,-81.506914,0,'2013-07-06 12:44:32',NULL,NULL),(35699,'39665','S','Sontag','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.614167,-90.238056,0,'2013-07-06 12:44:32',NULL,NULL),(35137,'39217','U','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.288941,-90.186095,0,'2013-07-06 12:44:32',NULL,NULL),(19363,'20053','U','Verizon','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884726,-77.012221,0,'2013-07-06 12:44:31',NULL,NULL),(29509,'32766','S','Oviedo','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.647707,-81.150362,0,'2013-07-06 12:44:32',NULL,NULL),(20991,'21821','S','Chance','A','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.167252,-75.905948,0,'2013-07-06 12:44:31',NULL,NULL),(22913,'24607','P','Breaks','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.301451,-82.307866,0,'2013-07-06 12:44:31',NULL,NULL),(74863,'93257','S','Woodville','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.069871,-119.021504,0,'2013-07-06 12:44:34',NULL,NULL),(73828,'91772','U','Rosemead','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065726,-118.085794,0,'2013-07-06 12:44:34',NULL,NULL),(67632,'80451','P','Hot Slphr Spr','A','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.074422,-106.104276,0,'2013-07-06 12:44:34',NULL,NULL),(63816,'75969','S','Redtown','N','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.415556,-94.938889,0,'2013-07-06 12:44:34',NULL,NULL),(63266,'75501','S','Red River Army Depot','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.424489,-94.102297,0,'2013-07-06 12:44:33',NULL,NULL),(61543,'72685','S','Western Grove','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.042357,-92.985835,0,'2013-07-06 12:44:33',NULL,NULL),(20438,'20997','U','Suburban MD BRM','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.994472,-77.025419,0,'2013-07-06 12:44:31',NULL,NULL),(24381,'27094','U','Rural Hall','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.236783,-80.297030,0,'2013-07-06 12:44:31',NULL,NULL),(30296,'33280','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.932022,-80.136421,0,'2013-07-06 12:44:32',NULL,NULL),(60244,'71433','S','McNary','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(71174,'86042','P','Hano','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.967439,-110.430862,0,'2013-07-06 12:44:34',NULL,NULL),(69858,'84092','S','Alta','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(67429,'80162','P','Littleton','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.599349,-105.106619,0,'2013-07-06 12:44:34',NULL,NULL),(44688,'50126','S','Iowa Falls','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.512225,-93.291365,0,'2013-07-06 12:44:32',NULL,NULL),(24713,'27503','S','Bahama','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.157869,-78.899222,0,'2013-07-06 12:44:31',NULL,NULL),(3921,'02460','S','Newtonville','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.351054,-71.207393,0,'2013-07-06 12:44:30',NULL,NULL),(35621,'39629','S','Arlington','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.485120,-90.452940,0,'2013-07-06 12:44:32',NULL,NULL),(1693,'00777','S','Urb Cerro Ceiba','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(73755,'91729','P','Rch Cucamonga','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.098356,-117.563036,0,'2013-07-06 12:44:34',NULL,NULL),(64520,'76638','S','Crawford','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.571640,-97.382220,0,'2013-07-06 12:44:34',NULL,NULL),(44452,'49870','S','Norway','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.785403,-87.901924,0,'2013-07-06 12:44:32',NULL,NULL),(32542,'36108','S','Dannelly','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.350670,-86.361835,0,'2013-07-06 12:44:32',NULL,NULL),(1403,'00738','S','Urb Monte Brisas 2','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(77841,'97221','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.492836,-122.730269,0,'2013-07-06 12:44:34',NULL,NULL),(18060,'18702','S','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(57732,'67417','S','Aurora','D','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.412093,-97.512050,0,'2013-07-06 12:44:33',NULL,NULL),(33243,'37073','S','Greenbrier','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.426973,-86.801739,0,'2013-07-06 12:44:32',NULL,NULL),(33332,'37151','S','Riddleton','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.350576,-86.030064,0,'2013-07-06 12:44:32',NULL,NULL),(1302,'00730','S','Villa Dos Rios','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(28876,'32119','S','South Daytona','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.139694,-81.012938,0,'2013-07-06 12:44:32',NULL,NULL),(58015,'67878','S','Syracuse','D','Hamilton','20075','Kansas','KS','20','0000','620','Mountain',-7.0,'Y',37.984523,-101.747922,0,'2013-07-06 12:44:33',NULL,NULL),(36324,'40385','S','Bybee','A','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.747999,-84.128552,0,'2013-07-06 12:44:32',NULL,NULL),(47938,'55115','S','Mahtomedi','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(41121,'46595','P','Wyatt','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.522298,-86.169288,0,'2013-07-06 12:44:32',NULL,NULL),(68691,'82050','S','Albin','D','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.419483,-104.356295,0,'2013-07-06 12:44:34',NULL,NULL),(74537,'92658','P','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.642217,-117.863051,0,'2013-07-06 12:44:34',NULL,NULL),(13458,'13780','S','Guilford Center','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.405278,-75.462500,0,'2013-07-06 12:44:31',NULL,NULL),(2979,'01057','S','Monson','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.094023,-72.323969,0,'2013-07-06 12:44:30',NULL,NULL),(35885,'39886','S','Shellman','D','Randolph','13243','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.761276,-84.606731,0,'2013-07-06 12:44:32',NULL,NULL),(55646,'64020','S','Ernestville','N','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',38.955230,-93.584522,0,'2013-07-06 12:44:33',NULL,NULL),(55489,'63767','P','Morley','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.043348,-89.610551,0,'2013-07-06 12:44:33',NULL,NULL),(43429,'48473','S','Rankin','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.942120,-83.828040,0,'2013-07-06 12:44:32',NULL,NULL),(51731,'60012','S','Crystal Lake','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.270000,-88.304220,0,'2013-07-06 12:44:33',NULL,NULL),(54035,'62462','S','Sigel','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.227201,-88.491182,0,'2013-07-06 12:44:33',NULL,NULL),(29748,'32971','P','Winter Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.714624,-80.422408,0,'2013-07-06 12:44:32',NULL,NULL),(29740,'32966','S','Citrus Ridge','A','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.637794,-80.475396,0,'2013-07-06 12:44:32',NULL,NULL),(59557,'70826','P','General Mail Facility','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.401161,-91.077146,0,'2013-07-06 12:44:33',NULL,NULL),(77545,'96857','S','Helemano Mltry Reservation','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.494722,-158.066346,0,'2013-07-06 12:44:34',NULL,NULL),(6397,'05733','S','Brandon','D','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.798620,-73.094520,0,'2013-07-06 12:44:30',NULL,NULL),(21452,'22603','S','Winchester','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.204657,-78.162238,0,'2013-07-06 12:44:31',NULL,NULL),(57910,'67657','S','Palco','D','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.252862,-99.560620,0,'2013-07-06 12:44:33',NULL,NULL),(32499,'36066','S','Prattville','D','Autauga','01001','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.469884,-86.436853,0,'2013-07-06 12:44:32',NULL,NULL),(75596,'94299','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.564429,-121.469141,0,'2013-07-06 12:44:34',NULL,NULL),(63245,'75479','S','Savoy','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.570716,-96.329163,0,'2013-07-06 12:44:33',NULL,NULL),(16602,'17327','S','Hametown','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.798447,-76.722134,0,'2013-07-06 12:44:31',NULL,NULL),(21650,'22936','S','Earlysville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.140751,-78.485072,0,'2013-07-06 12:44:31',NULL,NULL),(20685,'21239','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.358614,-76.590884,0,'2013-07-06 12:44:31',NULL,NULL),(45825,'52208','S','Koszta','N','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.898779,-92.274878,0,'2013-07-06 12:44:32',NULL,NULL),(22142,'23454','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.837731,-76.025953,0,'2013-07-06 12:44:31',NULL,NULL),(18524,'19106','S','Wm Penn Anx E','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951659,-75.144608,0,'2013-07-06 12:44:31',NULL,NULL),(19943,'20573','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899380,-77.008021,0,'2013-07-06 12:44:31',NULL,NULL),(28914,'32143','S','Palm Coast','D','Flagler','12035','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.481152,-81.133651,0,'2013-07-06 12:44:32',NULL,NULL),(53828,'62301','S','Burton','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.931262,-91.379720,0,'2013-07-06 12:44:33',NULL,NULL),(56352,'65202','S','Midway','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(47739,'55013','S','Chisago City','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.374138,-92.892680,0,'2013-07-06 12:44:33',NULL,NULL),(17032,'17747','S','Booneville','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(76741,'95914','S','Bangor','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.407542,-121.390436,0,'2013-07-06 12:44:34',NULL,NULL),(71808,'87567','S','Santo Nino','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.994133,-106.052197,0,'2013-07-06 12:44:34',NULL,NULL),(39173,'44310','S','North Hill','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.106498,-81.497681,0,'2013-07-06 12:44:32',NULL,NULL),(7851,'07470','S','Preakness','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(4938,'04088','S','South Waterford','N','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.216087,-70.474619,0,'2013-07-06 12:44:30',NULL,NULL),(16150,'17061','S','Killinger','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.567020,-76.917600,0,'2013-07-06 12:44:31',NULL,NULL),(28170,'30917','P','Augusta','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.516740,-82.057765,0,'2013-07-06 12:44:31',NULL,NULL),(41458,'46904','P','Kokomo','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.659213,-86.239543,0,'2013-07-06 12:44:32',NULL,NULL),(32903,'36542','S','Gulf Shores','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.274095,-87.715267,0,'2013-07-06 12:44:32',NULL,NULL),(66855,'79168','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.157736,-101.801454,0,'2013-07-06 12:44:34',NULL,NULL),(56457,'65284','S','Riggs','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.204824,-92.308046,0,'2013-07-06 12:44:33',NULL,NULL),(70219,'84403','S','South Weber','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.178180,-111.963540,0,'2013-07-06 12:44:34',NULL,NULL),(14404,'15060','P','Midway','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.367883,-80.295614,0,'2013-07-06 12:44:31',NULL,NULL),(30886,'33689','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.950388,-82.459663,0,'2013-07-06 12:44:32',NULL,NULL),(63747,'75938','S','Colmesneil','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.912780,-94.420200,0,'2013-07-06 12:44:34',NULL,NULL),(72535,'89169','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.254819,-115.526343,0,'2013-07-06 12:44:34',NULL,NULL),(1767,'00780','S','Urb Lago Horizonte','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(12362,'12903','S','Plattsburgh','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.707491,-73.475457,0,'2013-07-06 12:44:30',NULL,NULL),(78769,'98310','S','East Bremerton','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(63493,'75704','S','Swan','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.405184,-95.432727,0,'2013-07-06 12:44:33',NULL,NULL),(39411,'44666','S','N Lawrence','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.832808,-81.615396,0,'2013-07-06 12:44:32',NULL,NULL),(20686,'21239','S','Idlewylde','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.358614,-76.590884,0,'2013-07-06 12:44:31',NULL,NULL),(31725,'34979','P','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.445034,-80.339808,0,'2013-07-06 12:44:32',NULL,NULL),(33022,'36703','S','Valley Grande','A','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.420765,-87.007289,0,'2013-07-06 12:44:32',NULL,NULL),(47446,'54727','S','Cadott','D','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',44.939274,-91.171476,0,'2013-07-06 12:44:32',NULL,NULL),(56955,'66103','S','Rosedale','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.056699,-94.629221,0,'2013-07-06 12:44:33',NULL,NULL),(74166,'92267','S','Parker Dam','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.295930,-114.189406,0,'2013-07-06 12:44:34',NULL,NULL),(79859,'99557','P','Aniak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.787030,-156.614710,0,'2013-07-06 12:44:34',NULL,NULL),(1538,'00757','S','Ext Bda Monserrate','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(30791,'33602','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.955402,-82.459825,0,'2013-07-06 12:44:32',NULL,NULL),(52260,'60522','S','Oak Brook','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.832778,-87.928889,0,'2013-07-06 12:44:33',NULL,NULL),(7325,'06704','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.578898,-73.032746,0,'2013-07-06 12:44:30',NULL,NULL),(51136,'58830','S','Appam','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589714,-103.408726,0,'2013-07-06 12:44:33',NULL,NULL),(43272,'48330','P','Waterford','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.683616,-83.377192,0,'2013-07-06 12:44:32',NULL,NULL),(27483,'30153','S','Braswell','A','Polk','13233','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.987500,-85.055100,0,'2013-07-06 12:44:31',NULL,NULL),(11118,'11703','S','N Babylon','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732426,-73.324916,0,'2013-07-06 12:44:30',NULL,NULL),(4109,'02714','P','Dartmouth','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.571165,-71.002659,0,'2013-07-06 12:44:30',NULL,NULL),(11904,'12404','S','Whitfield','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.810460,-74.249820,0,'2013-07-06 12:44:30',NULL,NULL),(57587,'67070','S','Kiowa','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.013888,-98.483557,0,'2013-07-06 12:44:33',NULL,NULL),(8714,'08406','S','Ventnor','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.342361,-74.481532,0,'2013-07-06 12:44:30',NULL,NULL),(48798,'56007','S','Oakland','A','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.650835,-93.371347,0,'2013-07-06 12:44:33',NULL,NULL),(8757,'08535','S','Millstone','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.220714,-74.440497,0,'2013-07-06 12:44:30',NULL,NULL),(41020,'46379','P','Sumava Rsts','A','Newton','18111','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.166140,-87.438854,0,'2013-07-06 12:44:32',NULL,NULL),(43726,'48922','U','Mi Department of Revenue','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.735066,-84.558119,0,'2013-07-06 12:44:32',NULL,NULL),(64422,'76554','S','Little River Academy','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.988620,-97.365780,0,'2013-07-06 12:44:34',NULL,NULL),(41388,'46803','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.070631,-85.101842,0,'2013-07-06 12:44:32',NULL,NULL),(10077,'10185','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.757484,-73.991365,0,'2013-07-06 12:44:30',NULL,NULL),(69646,'84007','S','Bluebell','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.336272,-110.332410,0,'2013-07-06 12:44:34',NULL,NULL),(15452,'16407','S','Columbus Boro','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.923367,-79.657272,0,'2013-07-06 12:44:31',NULL,NULL),(31370,'34210','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.454714,-82.641506,0,'2013-07-06 12:44:32',NULL,NULL),(49785,'57103','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.535409,-96.685536,0,'2013-07-06 12:44:33',NULL,NULL),(73071,'90189','U','Citibank','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.051596,-118.239035,0,'2013-07-06 12:44:34',NULL,NULL),(25908,'28645','S','Joyceton','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(34638,'38764','P','Pace','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.791689,-90.857201,0,'2013-07-06 12:44:32',NULL,NULL),(1477,'00745','S','Villa Realidad','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(42586,'47882','S','Sullivan','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.098637,-87.402599,0,'2013-07-06 12:44:32',NULL,NULL),(15036,'15693','P','Whitney','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.253047,-79.405238,0,'2013-07-06 12:44:31',NULL,NULL),(55581,'63881','P','Wolf Island','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.737905,-89.211829,0,'2013-07-06 12:44:33',NULL,NULL),(46862,'54026','S','Star Prairie','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.197820,-92.530130,0,'2013-07-06 12:44:32',NULL,NULL),(42769,'48038','S','Clinton Township','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.599508,-82.953544,0,'2013-07-06 12:44:32',NULL,NULL),(14310,'14889','S','Van Etten','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.215462,-76.579551,0,'2013-07-06 12:44:31',NULL,NULL),(32967,'36604','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.683282,-88.069544,0,'2013-07-06 12:44:32',NULL,NULL),(29877,'33042','S','Cudjoe Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(10752,'11360','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.776438,-73.780380,0,'2013-07-06 12:44:30',NULL,NULL),(10259,'10501','S','Amawalk','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.294884,-73.762148,0,'2013-07-06 12:44:30',NULL,NULL),(72847,'89835','S','Shafter','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(76040,'95157','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.299956,-121.975922,0,'2013-07-06 12:44:34',NULL,NULL),(53309,'61738','S','Kappa','A','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.740699,-89.012596,0,'2013-07-06 12:44:33',NULL,NULL),(47757,'55027','S','Bellechester','A','Goodhue','27049','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.407008,-92.585148,0,'2013-07-06 12:44:33',NULL,NULL),(79479,'98860','P','Wilson Creek','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.425298,-119.117338,0,'2013-07-06 12:44:34',NULL,NULL),(45780,'52159','S','Rossville','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.049280,-91.388773,0,'2013-07-06 12:44:32',NULL,NULL),(8799,'08604','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.219598,-74.764373,0,'2013-07-06 12:44:30',NULL,NULL),(1716,'00778','S','Est Siervas De Maria','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(26723,'29417','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.786797,-80.032618,0,'2013-07-06 12:44:31',NULL,NULL),(14804,'15401','S','Oliphant Furnace','N','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.864960,-79.759380,0,'2013-07-06 12:44:31',NULL,NULL),(22688,'24317','S','Cana','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.597106,-80.672052,0,'2013-07-06 12:44:31',NULL,NULL),(15202,'15958','S','Summerhill','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.375776,-78.761417,0,'2013-07-06 12:44:31',NULL,NULL),(21541,'22737','S','Rixeyville','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.598789,-77.997650,0,'2013-07-06 12:44:31',NULL,NULL),(16483,'17252','S','St Thomas','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.915118,-77.808351,0,'2013-07-06 12:44:31',NULL,NULL),(74650,'92834','P','Fullerton','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.876777,-117.897002,0,'2013-07-06 12:44:34',NULL,NULL),(13287,'13660','S','Madrid Springs','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.749316,-75.132378,0,'2013-07-06 12:44:30',NULL,NULL),(60117,'71368','S','Leland','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.854570,-91.693483,0,'2013-07-06 12:44:33',NULL,NULL),(18505,'19101','P','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.003344,-75.136687,0,'2013-07-06 12:44:31',NULL,NULL),(79762,'99321','S','Beverly','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.863736,-119.865074,0,'2013-07-06 12:44:34',NULL,NULL),(66696,'78945','S','Mullins Prairie','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(66204,'78548','P','La Grulla','A','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.273939,-98.638445,0,'2013-07-06 12:44:34',NULL,NULL),(31814,'35056','P','Cullman','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.180143,-86.851112,0,'2013-07-06 12:44:32',NULL,NULL),(49573,'56726','S','Greenbush','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.722490,-96.209221,0,'2013-07-06 12:44:33',NULL,NULL),(73671,'91526','U','Walt Disney Co','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.190452,-118.325901,0,'2013-07-06 12:44:34',NULL,NULL),(23445,'25411','S','Unger','A','Morgan','54065','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.549780,-78.188160,0,'2013-07-06 12:44:31',NULL,NULL),(29827,'33029','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.006742,-80.428893,0,'2013-07-06 12:44:32',NULL,NULL),(63039,'75209','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.848647,-96.825080,0,'2013-07-06 12:44:33',NULL,NULL),(37118,'41408','S','Cannel City','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.790978,-83.274399,0,'2013-07-06 12:44:32',NULL,NULL),(52231,'60501','S','Bedford Pk','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782868,-87.813794,0,'2013-07-06 12:44:33',NULL,NULL),(39143,'44280','S','Valley City','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.238919,-81.917158,0,'2013-07-06 12:44:32',NULL,NULL),(2213,'00926','S','Urb Alamein','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(3398,'01653','U','Allmerica','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.292703,-71.779043,0,'2013-07-06 12:44:30',NULL,NULL),(54690,'62947','S','Herod','D','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.491775,-88.478187,0,'2013-07-06 12:44:33',NULL,NULL),(28802,'32062','S','McAlpin','N','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.297771,-82.987534,0,'2013-07-06 12:44:32',NULL,NULL),(31390,'34220','P','Palmetto','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.522214,-82.578741,0,'2013-07-06 12:44:32',NULL,NULL),(43039,'48175','P','Salem','D','Washtenaw','26161','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.408287,-83.577493,0,'2013-07-06 12:44:32',NULL,NULL),(49419,'56630','S','Cormant','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(45882,'52255','S','Lowden','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.860439,-90.928486,0,'2013-07-06 12:44:32',NULL,NULL),(48186,'55389','S','Watkins','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.357665,-94.432239,0,'2013-07-06 12:44:33',NULL,NULL),(89,'00612','S','Repto San Juan','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(64024,'76120','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.765356,-97.186397,0,'2013-07-06 12:44:34',NULL,NULL),(7239,'06510','S','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310571,-72.922891,0,'2013-07-06 12:44:30',NULL,NULL),(60155,'71401','S','Aimwell','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.754412,-91.996022,0,'2013-07-06 12:44:33',NULL,NULL),(67178,'79846','P','Redford','D','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',29.440000,-104.180000,0,'2013-07-06 12:44:34',NULL,NULL),(46407,'53172','S','South Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.909971,-87.866551,0,'2013-07-06 12:44:32',NULL,NULL),(32330,'35769','S','Scottsboro','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.650985,-86.045946,0,'2013-07-06 12:44:32',NULL,NULL),(68037,'80928','S','Security','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.588656,-104.442148,0,'2013-07-06 12:44:34',NULL,NULL),(19259,'19945','S','Frankford','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.524385,-75.205393,0,'2013-07-06 12:44:31',NULL,NULL),(42351,'47649','S','Francisco','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.334511,-87.445445,0,'2013-07-06 12:44:32',NULL,NULL),(65283,'77483','S','Wadsworth','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.578493,-96.044940,0,'2013-07-06 12:44:34',NULL,NULL),(64305,'76463','S','Mingus','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.651561,-98.433211,0,'2013-07-06 12:44:34',NULL,NULL),(54194,'62630','S','Hagaman','A','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.277225,-90.092676,0,'2013-07-06 12:44:33',NULL,NULL),(22522,'24091','S','Alum Ridge','A','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.914072,-80.316498,0,'2013-07-06 12:44:31',NULL,NULL),(40288,'45440','S','Beavercreek','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(15252,'16054','P','Saint Petersburg','D','Clarion','42031','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.158592,-79.655355,0,'2013-07-06 12:44:31',NULL,NULL),(2279,'00926','S','Urb Venus Gdns','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(23500,'25524','S','Harts','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.030940,-82.105380,0,'2013-07-06 12:44:31',NULL,NULL),(45751,'52140','S','Dorchester','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.435320,-91.513065,0,'2013-07-06 12:44:32',NULL,NULL),(26460,'29145','S','Silverstreet','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.212506,-81.743693,0,'2013-07-06 12:44:31',NULL,NULL),(70752,'85324','S','Black Canyon City','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.085943,-112.141600,0,'2013-07-06 12:44:34',NULL,NULL),(67300,'80016','S','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.584457,-104.758155,0,'2013-07-06 12:44:34',NULL,NULL),(5825,'05076','S','East Corinth','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.061849,-72.220363,0,'2013-07-06 12:44:30',NULL,NULL),(2451,'00953','S','Urb Town Hls','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(11045,'11572','S','Oceanside','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.658611,-73.641667,0,'2013-07-06 12:44:30',NULL,NULL),(17965,'18603','S','Berwick','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.056782,-76.245260,0,'2013-07-06 12:44:31',NULL,NULL),(61549,'72703','S','Fayetteville','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.099773,-94.153894,0,'2013-07-06 12:44:33',NULL,NULL),(19256,'19944','S','Fenwick Island','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.459312,-75.052878,0,'2013-07-06 12:44:31',NULL,NULL),(71353,'86520','P','Blue Gap','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.065671,-110.084930,0,'2013-07-06 12:44:34',NULL,NULL),(77314,'96683','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(66072,'78384','S','Rosita','N','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.760852,-98.243736,0,'2013-07-06 12:44:34',NULL,NULL),(63833,'75973','S','New Harmony','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(46330,'53083','S','Howards Grove','A','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.802340,-87.769800,0,'2013-07-06 12:44:32',NULL,NULL),(703,'00685','S','Urb Venturini','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(33588,'37604','S','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.309556,-82.381176,0,'2013-07-06 12:44:32',NULL,NULL),(25756,'28581','S','Stacy','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.857921,-76.423320,0,'2013-07-06 12:44:31',NULL,NULL),(12066,'12542','S','Marlboro','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.608715,-73.992141,0,'2013-07-06 12:44:30',NULL,NULL),(29763,'33008','P','Hallandle Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986952,-80.140539,0,'2013-07-06 12:44:32',NULL,NULL),(40139,'45341','S','Medway','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.880470,-84.027072,0,'2013-07-06 12:44:32',NULL,NULL),(39255,'44443','S','New Springfield','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.928502,-80.596676,0,'2013-07-06 12:44:32',NULL,NULL),(36050,'40207','S','Bellewood','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(70385,'84664','S','Mapleton','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.137545,-111.574793,0,'2013-07-06 12:44:34',NULL,NULL),(79256,'98563','S','Montesano','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(33207,'37047','S','Cornersville','D','Marshall','47117','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.360804,-86.840796,0,'2013-07-06 12:44:32',NULL,NULL),(72476,'89124','S','Mt Charleston','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(2880,'00987','S','Ciudad Centro','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(18307,'19018','S','Primos-Secane','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(40863,'46229','S','Cumberland','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.778740,-85.976640,0,'2013-07-06 12:44:32',NULL,NULL),(12299,'12850','S','Middle Grove','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.118700,-73.987500,0,'2013-07-06 12:44:30',NULL,NULL),(59504,'70776','S','Iberville','A','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.287400,-91.073340,0,'2013-07-06 12:44:33',NULL,NULL),(23210,'25075','S','Carbon','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(53623,'62091','S','Walshville','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.042917,-89.643014,0,'2013-07-06 12:44:33',NULL,NULL),(52664,'61070','S','Rock City','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.409790,-89.473497,0,'2013-07-06 12:44:33',NULL,NULL),(35146,'39218','S','Richland','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.237700,-90.154800,0,'2013-07-06 12:44:32',NULL,NULL),(36614,'40977','S','Pineville','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(65671,'77984','S','Glaze City','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.432036,-97.175420,0,'2013-07-06 12:44:34',NULL,NULL),(25163,'28035','S','Davidson College','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.499205,-80.846577,0,'2013-07-06 12:44:31',NULL,NULL),(23188,'25047','S','Clothier','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.790206,-81.991460,0,'2013-07-06 12:44:31',NULL,NULL),(41028,'46384','P','Valparaiso','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.493624,-87.054754,0,'2013-07-06 12:44:32',NULL,NULL),(78616,'98199','S','Fort Lawton','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.649774,-122.398314,0,'2013-07-06 12:44:34',NULL,NULL),(26237,'28813','P','Biltmor','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.554470,-82.510720,0,'2013-07-06 12:44:31',NULL,NULL),(73010,'90065','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105980,-118.229781,0,'2013-07-06 12:44:34',NULL,NULL),(8506,'08098','S','Pilesgrv Twp','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.651717,-75.330001,0,'2013-07-06 12:44:30',NULL,NULL),(4523,'03305','U','Nh Dept of Safety','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.206116,-71.539058,0,'2013-07-06 12:44:30',NULL,NULL),(31798,'35042','S','Eoline','N','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.953666,-87.138868,0,'2013-07-06 12:44:32',NULL,NULL),(63107,'75283','U','Bank of America','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.768227,-96.830324,0,'2013-07-06 12:44:33',NULL,NULL),(34314,'38554','S','Crawford','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.248188,-85.188903,0,'2013-07-06 12:44:32',NULL,NULL),(42398,'47735','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974147,-87.571111,0,'2013-07-06 12:44:32',NULL,NULL),(42131,'47512','S','Bicknell','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772909,-87.307853,0,'2013-07-06 12:44:32',NULL,NULL),(40763,'46150','S','Manilla','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.578950,-85.635677,0,'2013-07-06 12:44:32',NULL,NULL),(7630,'07062','S','Plainfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.632249,-74.399691,0,'2013-07-06 12:44:30',NULL,NULL),(2658,'00966','S','Urb Garden Hls Est','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(71119,'86017','P','Munds Park','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.946175,-111.638116,0,'2013-07-06 12:44:34',NULL,NULL),(65640,'77964','S','Wied','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(38154,'43146','S','Pleasant Cors','A','Pickaway','39129','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.771545,-83.148051,0,'2013-07-06 12:44:32',NULL,NULL),(64049,'76131','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.858146,-97.330601,0,'2013-07-06 12:44:34',NULL,NULL),(12431,'12953','S','Malone','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.845371,-74.269912,0,'2013-07-06 12:44:30',NULL,NULL),(17726,'18247','P','Saint Johns','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.030726,-76.007020,0,'2013-07-06 12:44:31',NULL,NULL),(38947,'44125','S','Cuyahoga Heights','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(59671,'71055','S','Pace','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.617484,-93.281086,0,'2013-07-06 12:44:33',NULL,NULL),(73942,'92054','S','Cmp Pendleton','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.205217,-117.352732,0,'2013-07-06 12:44:34',NULL,NULL),(73679,'91602','S','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(70026,'84130','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.700770,-111.947110,0,'2013-07-06 12:44:34',NULL,NULL),(66387,'78624','S','Fredericksbrg','A','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(63745,'75936','S','Chester','D','Tyler','48457','Texas','TX','48','0000','936','Central',-6.0,'Y',30.767579,-94.458240,0,'2013-07-06 12:44:34',NULL,NULL),(60492,'71661','S','Parkdale','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.112866,-91.528220,0,'2013-07-06 12:44:33',NULL,NULL),(54985,'63125','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.523552,-90.297410,0,'2013-07-06 12:44:33',NULL,NULL),(31181,'33928','S','Estero','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.399815,-81.860317,0,'2013-07-06 12:44:32',NULL,NULL),(792,'00693','S','Comunidad Bethel','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(36718,'41030','S','Flingsville','N','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.769713,-84.573036,0,'2013-07-06 12:44:32',NULL,NULL),(25343,'28220','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.177804,-80.851015,0,'2013-07-06 12:44:31',NULL,NULL),(20130,'20722','S','Brentwd','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.939104,-76.953103,0,'2013-07-06 12:44:31',NULL,NULL),(19901,'20542','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.940478,-77.029433,0,'2013-07-06 12:44:31',NULL,NULL),(18258,'19004','S','Bala','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.013801,-75.231706,0,'2013-07-06 12:44:31',NULL,NULL),(17539,'17976','S','Maple Hill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(10929,'11433','S','Addisleigh Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.697305,-73.789271,0,'2013-07-06 12:44:30',NULL,NULL),(15551,'16625','S','Claysburg','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.289416,-78.452288,0,'2013-07-06 12:44:31',NULL,NULL),(7650,'07077','S','Sewaren','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.554739,-74.266680,0,'2013-07-06 12:44:30',NULL,NULL),(79461,'98851','S','Adrian','N','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.395140,-119.452020,0,'2013-07-06 12:44:34',NULL,NULL),(6304,'05657','P','Lk Elmore','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544357,-72.528615,0,'2013-07-06 12:44:30',NULL,NULL),(26436,'29128','S','Rembert','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(22096,'23413','P','Nassawadox','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.474680,-75.858600,0,'2013-07-06 12:44:31',NULL,NULL),(21647,'22935','S','Dyke','D','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.264055,-78.574641,0,'2013-07-06 12:44:31',NULL,NULL),(17172,'17814','S','Waller','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(37910,'42633','S','Mount Pisgah','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(45722,'52074','S','Spragueville','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.075043,-90.490232,0,'2013-07-06 12:44:32',NULL,NULL),(58444,'68714','S','Rose','A','Rock','31149','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.580331,-99.530917,0,'2013-07-06 12:44:33',NULL,NULL),(63012,'75165','S','Waxahachie','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.378150,-96.789203,0,'2013-07-06 12:44:33',NULL,NULL),(71244,'86351','S','Sedona','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.786583,-111.761488,0,'2013-07-06 12:44:34',NULL,NULL),(77356,'96734','S','Kailua','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.397507,-157.744966,0,'2013-07-06 12:44:34',NULL,NULL),(74195,'92282','S','Cabazon','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.933154,-116.693211,0,'2013-07-06 12:44:34',NULL,NULL),(68095,'80943','U','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837361,-104.823078,0,'2013-07-06 12:44:34',NULL,NULL),(66242,'78570','S','Rio Rico','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160480,-97.919820,0,'2013-07-06 12:44:34',NULL,NULL),(45123,'50563','S','Wieston','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.530080,-94.537593,0,'2013-07-06 12:44:32',NULL,NULL),(23331,'25243','S','Gandeeville','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.706480,-81.426000,0,'2013-07-06 12:44:31',NULL,NULL),(31680,'34772','S','Saint Cloud','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.125336,-81.242167,0,'2013-07-06 12:44:32',NULL,NULL),(30499,'33394','S','One Financial Plaza','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.121148,-80.139899,0,'2013-07-06 12:44:32',NULL,NULL),(40999,'46360','S','Pines','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(1810,'00784','S','Brisas del Mar','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(64413,'76548','S','Harker Hts','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.116944,-97.727500,0,'2013-07-06 12:44:34',NULL,NULL),(60642,'71902','P','Hot Springs National Park','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.502350,-93.057544,0,'2013-07-06 12:44:33',NULL,NULL),(54812,'63021','S','Manchester','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(12787,'13218','P','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.047082,-76.148417,0,'2013-07-06 12:44:30',NULL,NULL),(1929,'00795','S','Urb La Esperanza','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(4952,'04101','S','Portland','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.662471,-70.261426,0,'2013-07-06 12:44:30',NULL,NULL),(43557,'48722','S','Bridgeport','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.350825,-83.851455,0,'2013-07-06 12:44:32',NULL,NULL),(508,'00674','S','Parc La Luisa','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(78411,'98040','S','Mercer Island','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.564004,-122.226476,0,'2013-07-06 12:44:34',NULL,NULL),(77393,'96771','S','Mountain View','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.537962,-155.089330,0,'2013-07-06 12:44:34',NULL,NULL),(11433,'11968','S','Southampton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.907565,-72.411077,0,'2013-07-06 12:44:30',NULL,NULL),(10712,'11238','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678989,-73.961819,0,'2013-07-06 12:44:30',NULL,NULL),(32295,'35739','S','Ardmore','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.960139,-86.755214,0,'2013-07-06 12:44:32',NULL,NULL),(31456,'34286','S','North Port','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.070796,-82.145952,0,'2013-07-06 12:44:32',NULL,NULL),(30824,'33620','U','University of South Florida','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060736,-82.410807,0,'2013-07-06 12:44:32',NULL,NULL),(30246,'33197','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.595047,-80.363125,0,'2013-07-06 12:44:32',NULL,NULL),(22342,'23876','S','Rawlings','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.953239,-77.833694,0,'2013-07-06 12:44:31',NULL,NULL),(38031,'43025','S','Hebron','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.974580,-82.505940,0,'2013-07-06 12:44:32',NULL,NULL),(38530,'43735','P','E Fultonham','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.853633,-82.122518,0,'2013-07-06 12:44:32',NULL,NULL),(61722,'73017','S','Cement','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.934206,-98.138908,0,'2013-07-06 12:44:33',NULL,NULL),(65474,'77640','S','Griffing','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(66015,'78357','S','Freer','D','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.861524,-98.563007,0,'2013-07-06 12:44:34',NULL,NULL),(4068,'02649','S','New Seabury','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.632800,-70.488720,0,'2013-07-06 12:44:30',NULL,NULL),(78589,'98178','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.492862,-122.249902,0,'2013-07-06 12:44:34',NULL,NULL),(77044,'96110','P','Eagleville','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.316969,-120.117312,0,'2013-07-06 12:44:34',NULL,NULL),(71773,'87556','S','Questa','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.718233,-105.599120,0,'2013-07-06 12:44:34',NULL,NULL),(61599,'72764','S','Springdale','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.179938,-94.145696,0,'2013-07-06 12:44:33',NULL,NULL),(57735,'67420','S','Scottsville','A','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.451140,-98.110080,0,'2013-07-06 12:44:33',NULL,NULL),(43520,'48649','S','Oakley','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.151296,-84.201887,0,'2013-07-06 12:44:32',NULL,NULL),(18188,'18933','S','Doylestown','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.399813,-75.042800,0,'2013-07-06 12:44:31',NULL,NULL),(8771,'08550','S','Princeton Jct','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.299355,-74.614868,0,'2013-07-06 12:44:30',NULL,NULL),(79077,'98433','S','JBLM','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(73764,'91733','S','S el Monte','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.051383,-118.044588,0,'2013-07-06 12:44:34',NULL,NULL),(72663,'89434','S','Sparks','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(67760,'80631','S','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.418082,-104.708389,0,'2013-07-06 12:44:34',NULL,NULL),(65751,'78063','S','Lakehills','A','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.656800,-98.907540,0,'2013-07-06 12:44:34',NULL,NULL),(54493,'62864','S','Dodds','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(40580,'45872','S','No Baltimore','N','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.189235,-83.669819,0,'2013-07-06 12:44:32',NULL,NULL),(36925,'41149','S','Isonville','D','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.062470,-83.038908,0,'2013-07-06 12:44:32',NULL,NULL),(33782,'37876','S','Pigeon Forge','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.839522,-83.480286,0,'2013-07-06 12:44:32',NULL,NULL),(5180,'04441','S','Frenchtwn Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(20775,'21529','P','Ellerslie','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.718506,-78.777773,0,'2013-07-06 12:44:31',NULL,NULL),(39057,'44195','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.502183,-81.619647,0,'2013-07-06 12:44:32',NULL,NULL),(79525,'98937','S','Rimrock','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(71821,'87575','S','El Vado','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(56261,'65062','S','Mount Sterling','D','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.531941,-91.612913,0,'2013-07-06 12:44:33',NULL,NULL),(50917,'58562','S','Bentley','A','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.405980,-101.895420,0,'2013-07-06 12:44:33',NULL,NULL),(3523,'01889','U','Massachusetts District','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.572012,-71.111231,0,'2013-07-06 12:44:30',NULL,NULL),(11243,'11758','S','E Massapequa','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.686884,-73.469397,0,'2013-07-06 12:44:30',NULL,NULL),(16036,'17044','S','Colonial Hill','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(17711,'18234','P','Lattimer Mines','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.994353,-75.961265,0,'2013-07-06 12:44:31',NULL,NULL),(39141,'44276','S','Sterling','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.940184,-81.834331,0,'2013-07-06 12:44:32',NULL,NULL),(7817,'07456','S','Cupsaw Lake','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.100840,-74.290260,0,'2013-07-06 12:44:30',NULL,NULL),(76592,'95684','S','Outingdale','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.602860,-120.630000,0,'2013-07-06 12:44:34',NULL,NULL),(52556,'60950','S','Manteno','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.224823,-87.837831,0,'2013-07-06 12:44:33',NULL,NULL),(49194,'56444','S','Cuyuna','N','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.473714,-93.904656,0,'2013-07-06 12:44:33',NULL,NULL),(38111,'43105','S','Baltimore','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.858878,-82.620111,0,'2013-07-06 12:44:32',NULL,NULL),(21013,'21842','S','West Ocean City','N','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.387820,-75.107280,0,'2013-07-06 12:44:31',NULL,NULL),(22555,'24139','S','Pittsville','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',37.010041,-79.482448,0,'2013-07-06 12:44:31',NULL,NULL),(9982,'10163','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755007,-73.967791,0,'2013-07-06 12:44:30',NULL,NULL),(29407,'32640','S','Cross Creek','A','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.591884,-82.112532,0,'2013-07-06 12:44:32',NULL,NULL),(2842,'00983','S','Jard de Country Club','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(23805,'26040','S','McMechen','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.987108,-80.731381,0,'2013-07-06 12:44:31',NULL,NULL),(78494,'98107','S','Ballard','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.669508,-122.383202,0,'2013-07-06 12:44:34',NULL,NULL),(68131,'80960','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.810217,-104.816961,0,'2013-07-06 12:44:34',NULL,NULL),(45860,'52241','S','Oakdale','A','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.680235,-91.577652,0,'2013-07-06 12:44:32',NULL,NULL),(38176,'43160','S','Washington CH','N','Fayette','39047','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.536064,-83.442724,0,'2013-07-06 12:44:32',NULL,NULL),(17181,'17815','S','Mordansville','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(45514,'51401','S','Mount Carmel','N','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.047220,-94.865160,0,'2013-07-06 12:44:32',NULL,NULL),(51040,'58727','S','Columbus','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.862800,-102.815100,0,'2013-07-06 12:44:33',NULL,NULL),(74426,'92561','S','Mountain Ctr','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.518312,-116.424551,0,'2013-07-06 12:44:34',NULL,NULL),(71894,'87745','S','Beulah','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.593889,-105.216667,0,'2013-07-06 12:44:34',NULL,NULL),(69813,'84072','S','Tabiona','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.374733,-110.677193,0,'2013-07-06 12:44:34',NULL,NULL),(69801,'84068','P','Park City','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.671636,-111.500120,0,'2013-07-06 12:44:34',NULL,NULL),(62655,'74604','S','Kildare','N','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.725760,-97.042075,0,'2013-07-06 12:44:33',NULL,NULL),(6664,'06028','P','E Windsor Hl','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.864145,-72.599902,0,'2013-07-06 12:44:30',NULL,NULL),(35324,'39426','S','Ozona','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.592349,-89.639175,0,'2013-07-06 12:44:32',NULL,NULL),(1551,'00765','S','Bo Coffi','N','Vieques','72147','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.123576,-65.438423,0,'2013-07-06 12:44:30',NULL,NULL),(24597,'27326','S','Powells Store','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.449100,-79.589460,0,'2013-07-06 12:44:31',NULL,NULL),(78396,'98033','S','Juanita','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.687703,-122.192053,0,'2013-07-06 12:44:34',NULL,NULL),(55190,'63379','S','Briscoe','N','Lincoln','29113','Missouri','MO','29','7040','636','Central',-6.0,'Y',39.005640,-90.962460,0,'2013-07-06 12:44:33',NULL,NULL),(47574,'54845','S','Hertel','D','Burnett','55013','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.805378,-92.133134,0,'2013-07-06 12:44:33',NULL,NULL),(39084,'44221','S','Cuyahoga Fls','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.142424,-81.472891,0,'2013-07-06 12:44:32',NULL,NULL),(17958,'18519','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.462308,-75.625366,0,'2013-07-06 12:44:31',NULL,NULL),(3905,'02454','P','Waltham','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.378002,-71.239881,0,'2013-07-06 12:44:30',NULL,NULL),(5871,'05148','S','Bromley Mtn','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.224333,-72.797903,0,'2013-07-06 12:44:30',NULL,NULL),(13245,'13642','S','Fullerville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(69491,'83701','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.622340,-116.322069,0,'2013-07-06 12:44:34',NULL,NULL),(51312,'59242','S','Homestead','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.439875,-104.597750,0,'2013-07-06 12:44:33',NULL,NULL),(16642,'17340','S','Kingsdale','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.763200,-77.117160,0,'2013-07-06 12:44:31',NULL,NULL),(18764,'19352','S','New London Township','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.769645,-75.890630,0,'2013-07-06 12:44:31',NULL,NULL),(15097,'15765','S','Penn Run','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.563004,-79.007721,0,'2013-07-06 12:44:31',NULL,NULL),(4093,'02669','P','West Chatham','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.675266,-69.998143,0,'2013-07-06 12:44:30',NULL,NULL),(36561,'40923','S','Cannon','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.964621,-83.806033,0,'2013-07-06 12:44:32',NULL,NULL),(12453,'12967','S','North Lawrence','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.761693,-74.654141,0,'2013-07-06 12:44:30',NULL,NULL),(30335,'33309','S','Lauderdale Lakes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(75224,'93641','S','Miramonte','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.693920,-119.035961,0,'2013-07-06 12:44:34',NULL,NULL),(62384,'74079','S','Stroud','D','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.760300,-96.702300,0,'2013-07-06 12:44:33',NULL,NULL),(53687,'62225','S','Scott AFB','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.539124,-89.851513,0,'2013-07-06 12:44:33',NULL,NULL),(21416,'22538','S','Rappnhanck','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.158313,-77.300230,0,'2013-07-06 12:44:31',NULL,NULL),(15148,'15860','S','Sigel','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.359757,-78.990878,0,'2013-07-06 12:44:31',NULL,NULL),(29268,'32459','S','Point Washington','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.359723,-86.237832,0,'2013-07-06 12:44:32',NULL,NULL),(1478,'00745','S','Villa Vizcay','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(53941,'62418','S','Brownstown','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.995023,-88.952593,0,'2013-07-06 12:44:33',NULL,NULL),(41204,'46725','S','Loon Lake','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(26089,'28711','S','Black Mtn','A','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.607610,-82.312275,0,'2013-07-06 12:44:31',NULL,NULL),(31993,'35223','S','English Village','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489469,-86.741202,0,'2013-07-06 12:44:32',NULL,NULL),(79364,'98648','S','Stevenson','D','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.834480,-121.840560,0,'2013-07-06 12:44:34',NULL,NULL),(63594,'75789','S','Mixon','N','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.131620,-95.154780,0,'2013-07-06 12:44:34',NULL,NULL),(62644,'74571','S','Talihina','D','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.752849,-95.033114,0,'2013-07-06 12:44:33',NULL,NULL),(55611,'63956','S','Patterson','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.210022,-90.571496,0,'2013-07-06 12:44:33',NULL,NULL),(33702,'37763','S','Kingston','D','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.876568,-84.507327,0,'2013-07-06 12:44:32',NULL,NULL),(15124,'15824','S','Brockway','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.247530,-78.762650,0,'2013-07-06 12:44:31',NULL,NULL),(44834,'50256','S','Tracy','D','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.283057,-92.871871,0,'2013-07-06 12:44:32',NULL,NULL),(68992,'83127','S','Star Valley Ranch','A','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.972890,-110.971354,0,'2013-07-06 12:44:34',NULL,NULL),(62457,'74331','S','Afton','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.692974,-94.960304,0,'2013-07-06 12:44:33',NULL,NULL),(54319,'62723','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.759431,-89.634086,0,'2013-07-06 12:44:33',NULL,NULL),(47845,'55074','S','Shafer','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.387412,-92.746332,0,'2013-07-06 12:44:33',NULL,NULL),(42449,'47805','S','Tera North','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(37424,'41819','S','Gordon','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.992572,-83.069894,0,'2013-07-06 12:44:32',NULL,NULL),(6641,'06011','P','Bristol','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.677462,-72.946279,0,'2013-07-06 12:44:30',NULL,NULL),(21069,'22003','S','Annandale','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.828264,-77.212338,0,'2013-07-06 12:44:31',NULL,NULL),(29054,'32240','P','Jacksonville','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.278240,-81.411680,0,'2013-07-06 12:44:32',NULL,NULL),(28624,'31722','P','Berlin','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.126702,-83.703010,0,'2013-07-06 12:44:32',NULL,NULL),(71289,'86441','S','Dolan Springs','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.571310,-114.311710,0,'2013-07-06 12:44:34',NULL,NULL),(68647,'81641','S','Axel','N','Rio Blanco','08103','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.045459,-107.946922,0,'2013-07-06 12:44:34',NULL,NULL),(67799,'80734','S','Holyoke','D','Phillips','08095','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.583683,-102.302044,0,'2013-07-06 12:44:34',NULL,NULL),(40824,'46209','U','Bus Reply','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.744999,-86.158607,0,'2013-07-06 12:44:32',NULL,NULL),(67143,'79768','P','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.845279,-102.364363,0,'2013-07-06 12:44:34',NULL,NULL),(58604,'68853','S','Loup City','D','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.279151,-98.969658,0,'2013-07-06 12:44:33',NULL,NULL),(53741,'62254','S','Lebanon','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.606738,-89.813433,0,'2013-07-06 12:44:33',NULL,NULL),(35019,'39153','S','Raleigh','D','Smith','28129','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.064420,-89.507100,0,'2013-07-06 12:44:32',NULL,NULL),(31572,'34638','S','Land O Lakes','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.262356,-82.518310,0,'2013-07-06 12:44:32',NULL,NULL),(28495,'31522','S','St Simons Is','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.165091,-81.384700,0,'2013-07-06 12:44:32',NULL,NULL),(14015,'14533','S','Wadsworth','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.829598,-77.897767,0,'2013-07-06 12:44:31',NULL,NULL),(526,'00674','S','Valle de Tierras Nuevas','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(9937,'10154','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.756535,-73.970600,0,'2013-07-06 12:44:30',NULL,NULL),(53313,'61739','S','Fairbury','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.747916,-88.513741,0,'2013-07-06 12:44:33',NULL,NULL),(5109,'04354','S','Palermo','D','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.382089,-69.430742,0,'2013-07-06 12:44:30',NULL,NULL),(53776,'62274','S','Pinckneyville','D','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.078533,-89.388584,0,'2013-07-06 12:44:33',NULL,NULL),(49631,'56933','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(48806,'56019','S','Comfrey','D','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.110660,-94.904546,0,'2013-07-06 12:44:33',NULL,NULL),(40741,'46133','S','Glenwood','D','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.611007,-85.273628,0,'2013-07-06 12:44:32',NULL,NULL),(39269,'44453','P','Orangeville','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.336016,-80.526283,0,'2013-07-06 12:44:32',NULL,NULL),(7813,'07446','S','Ramsey','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.059559,-74.146690,0,'2013-07-06 12:44:30',NULL,NULL),(13757,'14127','S','Orchard Park','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.764164,-78.742821,0,'2013-07-06 12:44:31',NULL,NULL),(29884,'33042','S','Ramrod Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(16782,'17532','S','Holtwood','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.856500,-76.300080,0,'2013-07-06 12:44:31',NULL,NULL),(1674,'00775','P','Culebra','D','Culebra','72049','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.311531,-65.305548,0,'2013-07-06 12:44:30',NULL,NULL),(77484,'96823','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.307300,-157.844392,0,'2013-07-06 12:44:34',NULL,NULL),(76512,'95642','S','Clinton','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.360720,-120.742856,0,'2013-07-06 12:44:34',NULL,NULL),(64881,'77069','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.985545,-95.522847,0,'2013-07-06 12:44:34',NULL,NULL),(60878,'72063','S','Old Hickory','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.289780,-92.784000,0,'2013-07-06 12:44:33',NULL,NULL),(48044,'55311','S','Hassan','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.118800,-93.486660,0,'2013-07-06 12:44:33',NULL,NULL),(46339,'53090','S','W Bend','N','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.449492,-88.171297,0,'2013-07-06 12:44:32',NULL,NULL),(12498,'13020','P','Apulia Station','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.818065,-76.073470,0,'2013-07-06 12:44:30',NULL,NULL),(11522,'12035','S','Central Bridge','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.716078,-74.361941,0,'2013-07-06 12:44:30',NULL,NULL),(30582,'33417','S','Haverhill','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.714953,-80.124964,0,'2013-07-06 12:44:32',NULL,NULL),(25033,'27895','P','Wilson','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.759935,-77.943394,0,'2013-07-06 12:44:31',NULL,NULL),(23803,'26038','S','Glen Dale','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.957196,-80.744214,0,'2013-07-06 12:44:31',NULL,NULL),(20165,'20743','S','Capitol Heights','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.885663,-76.901034,0,'2013-07-06 12:44:31',NULL,NULL),(65808,'78133','S','Sattler','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.880900,-98.215200,0,'2013-07-06 12:44:34',NULL,NULL),(65595,'77878','P','Snook','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.488286,-96.464530,0,'2013-07-06 12:44:34',NULL,NULL),(37236,'41548','S','Flanary','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.374131,-82.287581,0,'2013-07-06 12:44:32',NULL,NULL),(29986,'33102','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796138,-80.301056,0,'2013-07-06 12:44:32',NULL,NULL),(32335,'35775','S','Valhermoso Sp','A','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.550490,-86.694970,0,'2013-07-06 12:44:32',NULL,NULL),(17033,'17747','S','Eastville','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.029920,-77.317212,0,'2013-07-06 12:44:31',NULL,NULL),(15926,'17020','S','Perdix','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(14974,'15633','P','Forbes Road','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.358425,-79.524654,0,'2013-07-06 12:44:31',NULL,NULL),(7020,'06260','S','Rhodesville','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(78254,'97837','S','Hereford','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.593477,-117.989390,0,'2013-07-06 12:44:34',NULL,NULL),(76148,'95297','U','Stockton Brm Zip','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.970844,-121.307880,0,'2013-07-06 12:44:34',NULL,NULL),(71271,'86430','P','Bullhead City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.062871,-114.578938,0,'2013-07-06 12:44:34',NULL,NULL),(51094,'58772','S','Portal','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.948464,-102.546422,0,'2013-07-06 12:44:33',NULL,NULL),(50428,'57791','S','Elm Springs','A','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.094970,-102.335284,0,'2013-07-06 12:44:33',NULL,NULL),(40209,'45390','S','Union City','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.018500,-84.564240,0,'2013-07-06 12:44:32',NULL,NULL),(35022,'39154','S','Raymond','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.223960,-90.443040,0,'2013-07-06 12:44:32',NULL,NULL),(34501,'38670','S','Sledge','D','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.429607,-90.218388,0,'2013-07-06 12:44:32',NULL,NULL),(3992,'02538','S','E Wareham','A','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.781003,-70.649757,0,'2013-07-06 12:44:30',NULL,NULL),(30637,'33446','S','W Delray Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.451567,-80.173388,0,'2013-07-06 12:44:32',NULL,NULL),(26271,'29010','S','Stokes Bridge','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(38606,'43845','S','W Lafayette','A','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.269968,-81.735623,0,'2013-07-06 12:44:32',NULL,NULL),(11232,'11754','S','Kings Park','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.886446,-73.244857,0,'2013-07-06 12:44:30',NULL,NULL),(14093,'14619','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.133202,-77.644090,0,'2013-07-06 12:44:31',NULL,NULL),(74451,'92586','S','Sun City','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.702108,-117.201493,0,'2013-07-06 12:44:34',NULL,NULL),(72866,'90006','S','Pico Heights','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.045817,-118.290338,0,'2013-07-06 12:44:34',NULL,NULL),(69663,'84015','S','Sunset','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(23602,'25696','P','Varney','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.680935,-82.063057,0,'2013-07-06 12:44:31',NULL,NULL),(19149,'19709','S','Middletown','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.488886,-75.685331,0,'2013-07-06 12:44:31',NULL,NULL),(18672,'19182','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951857,-75.150106,0,'2013-07-06 12:44:31',NULL,NULL),(40624,'46012','S','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.141971,-85.628094,0,'2013-07-06 12:44:32',NULL,NULL),(41672,'47163','S','Otisco','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.543218,-85.662713,0,'2013-07-06 12:44:32',NULL,NULL),(44471,'49891','S','Trenary','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.202796,-86.866256,0,'2013-07-06 12:44:32',NULL,NULL),(49327,'56553','S','Kent','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.426018,-96.677907,0,'2013-07-06 12:44:33',NULL,NULL),(49831,'57223','S','Kones Corner','N','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.726786,-97.027942,0,'2013-07-06 12:44:33',NULL,NULL),(58068,'68055','S','Rosalie','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.058749,-96.471206,0,'2013-07-06 12:44:33',NULL,NULL),(59411,'70647','S','Iowa','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.236653,-93.014650,0,'2013-07-06 12:44:33',NULL,NULL),(59926,'71291','S','Wall Lake','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(59953,'71302','S','Alex','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.266926,-92.417063,0,'2013-07-06 12:44:33',NULL,NULL),(62078,'73558','P','Lawton','A','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.782945,-98.577817,0,'2013-07-06 12:44:33',NULL,NULL),(66756,'79011','S','Briscoe','D','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.547074,-100.144310,0,'2013-07-06 12:44:34',NULL,NULL),(68742,'82215','S','Hartville','D','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.326100,-104.682000,0,'2013-07-06 12:44:34',NULL,NULL),(68918,'82839','S','Ranchester','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.903574,-107.143746,0,'2013-07-06 12:44:34',NULL,NULL),(67349,'80110','S','Cherry Hills Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(56585,'65550','S','Big Piney','N','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.920180,-91.886100,0,'2013-07-06 12:44:33',NULL,NULL),(46326,'53080','S','Saukville','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.387123,-87.967557,0,'2013-07-06 12:44:32',NULL,NULL),(28212,'31030','S','Fort Valley','D','Peach','13225','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.550073,-83.882935,0,'2013-07-06 12:44:31',NULL,NULL),(9582,'10027','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.812070,-73.954377,0,'2013-07-06 12:44:30',NULL,NULL),(69732,'84043','S','Eagle Mtn','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.393610,-111.846309,0,'2013-07-06 12:44:34',NULL,NULL),(65998,'78342','P','Ben Bolt','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.751944,-98.069444,0,'2013-07-06 12:44:34',NULL,NULL),(57181,'66407','S','Belvue','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.243209,-96.174224,0,'2013-07-06 12:44:33',NULL,NULL),(51357,'59336','S','Ismay','D','Custer','30017','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.498305,-104.793911,0,'2013-07-06 12:44:33',NULL,NULL),(47795,'55047','S','New Scandia','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(44113,'49506','S','Cascade Twp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.941650,-85.594449,0,'2013-07-06 12:44:32',NULL,NULL),(15477,'16433','S','Saegertown','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.718121,-80.142619,0,'2013-07-06 12:44:31',NULL,NULL),(32773,'36374','S','Skipperville','D','Dale','01045','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.558713,-85.543523,0,'2013-07-06 12:44:32',NULL,NULL),(26686,'29405','S','Charleston','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(16924,'17603','S','Rohrerstown','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(39348,'44625','S','E Rochester','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.771834,-80.996741,0,'2013-07-06 12:44:32',NULL,NULL),(43681,'48873','S','Pewamo','D','Ionia','26067','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',42.979924,-84.855911,0,'2013-07-06 12:44:32',NULL,NULL),(15112,'15778','S','Timblin','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.964525,-79.198212,0,'2013-07-06 12:44:31',NULL,NULL),(73543,'91355','S','Santa Clarita','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.403591,-118.532784,0,'2013-07-06 12:44:34',NULL,NULL),(13663,'14028','S','Burt','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.319563,-78.724973,0,'2013-07-06 12:44:31',NULL,NULL),(38310,'43358','S','W Mansfld','N','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.416420,-83.486218,0,'2013-07-06 12:44:32',NULL,NULL),(41518,'46979','S','Russiaville','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.424335,-86.264710,0,'2013-07-06 12:44:32',NULL,NULL),(42450,'47805','S','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(45544,'51455','S','Manning','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.907350,-95.064387,0,'2013-07-06 12:44:32',NULL,NULL),(59521,'70802','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.447918,-91.167399,0,'2013-07-06 12:44:33',NULL,NULL),(66757,'79012','P','Bushland','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.116284,-102.052636,0,'2013-07-06 12:44:34',NULL,NULL),(492,'00674','S','Bda San Jose','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(75822,'94903','S','Marinwood','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.013354,-122.548797,0,'2013-07-06 12:44:34',NULL,NULL),(41970,'47421','S','Bedford Heights','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(40248,'45429','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.686892,-84.159357,0,'2013-07-06 12:44:32',NULL,NULL),(40160,'45359','S','Pleasant Hill','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.054057,-84.353770,0,'2013-07-06 12:44:32',NULL,NULL),(17287,'17847','S','Limestonevle','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.014839,-76.846934,0,'2013-07-06 12:44:31',NULL,NULL),(2710,'00969','S','Mans Reales','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(15331,'16218','S','Cowansville','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.929888,-79.590168,0,'2013-07-06 12:44:31',NULL,NULL),(70919,'85632','S','Portal','A','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.177580,-109.379880,0,'2013-07-06 12:44:34',NULL,NULL),(61870,'73127','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.484360,-97.631411,0,'2013-07-06 12:44:33',NULL,NULL),(56800,'65765','P','Turners','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.181516,-93.157205,0,'2013-07-06 12:44:33',NULL,NULL),(41553,'47018','S','Elrod','N','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',38.967420,-85.051860,0,'2013-07-06 12:44:32',NULL,NULL),(2739,'00969','S','Urb Mallorca','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(12434,'12956','S','Grover Hills','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.078155,-73.517787,0,'2013-07-06 12:44:30',NULL,NULL),(18106,'18765','U','Geisinger South','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.219464,-75.797080,0,'2013-07-06 12:44:31',NULL,NULL),(11182,'11733','S','East Setauket','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.932850,-73.108934,0,'2013-07-06 12:44:30',NULL,NULL),(39956,'45236','S','Blue Ash','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(41291,'46763','S','Ege','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.291971,-85.202440,0,'2013-07-06 12:44:32',NULL,NULL),(79394,'98801','S','Mission Square','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.427482,-120.333262,0,'2013-07-06 12:44:34',NULL,NULL),(77620,'96960','P','Majuro','D','Marshall Islands','68020','Marshall Islands','MH','68','0000','692','UTC+12',12.0,'N',7.364758,170.855049,0,'2013-07-06 12:44:34',NULL,NULL),(72250,'88527','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810669,-106.416154,0,'2013-07-06 12:44:34',NULL,NULL),(65317,'77510','S','Alta Loma','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.372127,-95.087892,0,'2013-07-06 12:44:34',NULL,NULL),(529,'00674','S','Villa Beatriz','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(9077,'09011','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(31431,'34266','S','Sidell','A','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.199150,-81.847982,0,'2013-07-06 12:44:32',NULL,NULL),(28517,'31543','S','Hortense','D','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.310697,-81.967185,0,'2013-07-06 12:44:32',NULL,NULL),(22935,'24630','S','North Tazewell','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.154700,-81.511320,0,'2013-07-06 12:44:31',NULL,NULL),(21293,'22401','S','Fred','N','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.296176,-77.485335,0,'2013-07-06 12:44:31',NULL,NULL),(19842,'20506','U','Exec Office Other Organ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899668,-77.039336,0,'2013-07-06 12:44:31',NULL,NULL),(4418,'03227','S','Sandwich','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.834383,-71.477065,0,'2013-07-06 12:44:30',NULL,NULL),(8037,'07732','S','Gateway National Recreation','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.399752,-73.997462,0,'2013-07-06 12:44:30',NULL,NULL),(38864,'44097','P','Willoughby','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.651449,-81.448780,0,'2013-07-06 12:44:32',NULL,NULL),(50861,'58501','S','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.819042,-100.780969,0,'2013-07-06 12:44:33',NULL,NULL),(60428,'71644','S','Shannon','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.089960,-91.734240,0,'2013-07-06 12:44:33',NULL,NULL),(74760,'93099','U','Farmers Insurance','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.262932,-118.750530,0,'2013-07-06 12:44:34',NULL,NULL),(70217,'84403','S','Ogden','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.178180,-111.963540,0,'2013-07-06 12:44:34',NULL,NULL),(64821,'77030','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.709260,-95.400851,0,'2013-07-06 12:44:34',NULL,NULL),(40866,'46231','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.722652,-86.308950,0,'2013-07-06 12:44:32',NULL,NULL),(18175,'18921','P','Ferndale','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.533461,-75.180481,0,'2013-07-06 12:44:31',NULL,NULL),(15371,'16262','S','Worthington','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.835880,-79.644420,0,'2013-07-06 12:44:31',NULL,NULL),(21446,'22579','P','Wicomico Church','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.788954,-76.360133,0,'2013-07-06 12:44:31',NULL,NULL),(11726,'12180','S','Raymertown','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(78677,'98244','S','Deming','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.824220,-121.958340,0,'2013-07-06 12:44:34',NULL,NULL),(68927,'82901','S','Rock Springs','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.597550,-109.234183,0,'2013-07-06 12:44:34',NULL,NULL),(66138,'78467','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.748683,-97.420344,0,'2013-07-06 12:44:34',NULL,NULL),(53228,'61637','U','St Francis Hosp','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.699505,-89.590142,0,'2013-07-06 12:44:33',NULL,NULL),(46711,'53801','S','Bagley','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.923562,-91.056053,0,'2013-07-06 12:44:32',NULL,NULL),(37564,'42071','S','Murray','D','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(28343,'31193','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761200,-84.385347,0,'2013-07-06 12:44:32',NULL,NULL),(26420,'29123','S','Thor','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.776254,-81.255322,0,'2013-07-06 12:44:31',NULL,NULL),(18050,'18702','S','Bear Creek Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(21297,'22402','P','Fredericksbrg','A','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.256114,-77.566794,0,'2013-07-06 12:44:31',NULL,NULL),(67425,'80155','P','Greenwood Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.591335,-104.876947,0,'2013-07-06 12:44:34',NULL,NULL),(62966,'75126','S','Forney','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.745419,-96.455203,0,'2013-07-06 12:44:33',NULL,NULL),(61820,'73108','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.447049,-97.564806,0,'2013-07-06 12:44:33',NULL,NULL),(47406,'54649','P','Oakdale','D','Monroe','55081','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.960617,-90.381272,0,'2013-07-06 12:44:32',NULL,NULL),(42729,'48006','S','Kenockee Township','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(40057,'45268','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.148449,-84.519895,0,'2013-07-06 12:44:32',NULL,NULL),(362,'00659','S','Hatillo','D','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(34492,'38668','S','Nw Jr College','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.653180,-89.869860,0,'2013-07-06 12:44:32',NULL,NULL),(74362,'92415','U','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.127706,-117.266443,0,'2013-07-06 12:44:34',NULL,NULL),(68412,'81201','S','Smeltertown','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(63038,'75208','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.754908,-96.839460,0,'2013-07-06 12:44:33',NULL,NULL),(62138,'73702','P','Enid','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.395323,-97.873628,0,'2013-07-06 12:44:33',NULL,NULL),(24080,'26452','S','Valley Chapel','A','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.041383,-80.464446,0,'2013-07-06 12:44:31',NULL,NULL),(28189,'31014','S','Cochran','D','Bleckley','13023','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.385663,-83.348675,0,'2013-07-06 12:44:31',NULL,NULL),(27130,'29808','U','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.248093,-81.649368,0,'2013-07-06 12:44:31',NULL,NULL),(78459,'98070','S','Vashon','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.418180,-122.451780,0,'2013-07-06 12:44:34',NULL,NULL),(72595,'89408','S','Hazen','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.597279,-119.231521,0,'2013-07-06 12:44:34',NULL,NULL),(70772,'85340','S','Litchfield Park','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.497954,-112.376641,0,'2013-07-06 12:44:34',NULL,NULL),(55743,'64093','S','Warrensburg','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.758746,-93.732134,0,'2013-07-06 12:44:33',NULL,NULL),(47519,'54805','S','Almena','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.414226,-92.029086,0,'2013-07-06 12:44:32',NULL,NULL),(44325,'49751','S','Johannesburg','D','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.976836,-84.449237,0,'2013-07-06 12:44:32',NULL,NULL),(24169,'26615','S','Copen','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.841723,-80.723809,0,'2013-07-06 12:44:31',NULL,NULL),(35178,'39272','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.216828,-90.269123,0,'2013-07-06 12:44:32',NULL,NULL),(34911,'38958','P','Charleston','A','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.949231,-90.174679,0,'2013-07-06 12:44:32',NULL,NULL),(12910,'13338','S','Kayuta Lake','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(71413,'87020','S','Grants','D','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.159241,-107.836997,0,'2013-07-06 12:44:34',NULL,NULL),(43145,'48239','S','Redford','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.376745,-83.285091,0,'2013-07-06 12:44:32',NULL,NULL),(24512,'27281','S','Jackson Springs','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.220300,-79.610820,0,'2013-07-06 12:44:31',NULL,NULL),(29306,'32522','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.422794,-87.223235,0,'2013-07-06 12:44:32',NULL,NULL),(5108,'04353','S','Whitefield','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.201980,-69.612352,0,'2013-07-06 12:44:30',NULL,NULL),(481,'00667','S','Urb El Valle','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(76685,'95816','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.574536,-121.466593,0,'2013-07-06 12:44:34',NULL,NULL),(9751,'10101','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(25465,'28337','S','White Lake','N','Bladen','37017','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.621800,-78.572100,0,'2013-07-06 12:44:31',NULL,NULL),(3627,'02066','S','Scituate','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.199513,-70.746169,0,'2013-07-06 12:44:30',NULL,NULL),(43306,'48348','S','Clarkston','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.767149,-83.400047,0,'2013-07-06 12:44:32',NULL,NULL),(59736,'71120','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.504406,-93.744686,0,'2013-07-06 12:44:33',NULL,NULL),(69056,'83232','S','Dayton','D','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.125313,-112.013069,0,'2013-07-06 12:44:34',NULL,NULL),(69486,'83677','S','Yellow Pine','D','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',45.043964,-115.369443,0,'2013-07-06 12:44:34',NULL,NULL),(63838,'75974','S','Meldrum','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.939621,-94.255138,0,'2013-07-06 12:44:34',NULL,NULL),(44843,'50265','S','WDM','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.583232,-93.756888,0,'2013-07-06 12:44:32',NULL,NULL),(40369,'45646','S','Latham','D','Pike','39131','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.090705,-83.292192,0,'2013-07-06 12:44:32',NULL,NULL),(16032,'17043','S','Washington Ht','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.254300,-76.898040,0,'2013-07-06 12:44:31',NULL,NULL),(20859,'21660','S','Ridgely','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.942711,-75.890372,0,'2013-07-06 12:44:31',NULL,NULL),(3055,'01109','S','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.118736,-72.548305,0,'2013-07-06 12:44:30',NULL,NULL),(12204,'12786','S','White Lake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.648614,-74.870751,0,'2013-07-06 12:44:30',NULL,NULL),(36753,'41040','S','Morgan','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(3057,'01111','U','Mass Mutual Life Ins Co','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.117977,-72.547899,0,'2013-07-06 12:44:30',NULL,NULL),(7645,'07073','S','East Rutherford','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.839748,-74.102949,0,'2013-07-06 12:44:30',NULL,NULL),(77513,'96839','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.322589,-157.812705,0,'2013-07-06 12:44:34',NULL,NULL),(70464,'84756','P','Newcastle','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.823414,-113.721440,0,'2013-07-06 12:44:34',NULL,NULL),(65311,'77503','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.691128,-95.162613,0,'2013-07-06 12:44:34',NULL,NULL),(4528,'03431','S','Roxbury','A','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.938975,-72.285756,0,'2013-07-06 12:44:30',NULL,NULL),(26586,'29222','S','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.984355,-81.029966,0,'2013-07-06 12:44:31',NULL,NULL),(50111,'57501','S','Ames','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(7484,'06904','P','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.051140,-73.540539,0,'2013-07-06 12:44:30',NULL,NULL),(76537,'95659','S','East Nicolaus','A','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.870336,-121.567175,0,'2013-07-06 12:44:34',NULL,NULL),(76389,'95534','P','Cutten','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.793242,-124.158139,0,'2013-07-06 12:44:34',NULL,NULL),(72276,'88556','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767180,-106.331086,0,'2013-07-06 12:44:34',NULL,NULL),(66858,'79172','U','Amarillo Hardware','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.202037,-101.833183,0,'2013-07-06 12:44:34',NULL,NULL),(36426,'40576','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.136625,-84.470075,0,'2013-07-06 12:44:32',NULL,NULL),(35318,'39423','S','Little Creek','N','Perry','28111','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.129500,-88.904640,0,'2013-07-06 12:44:32',NULL,NULL),(18677,'19183','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951604,-75.168997,0,'2013-07-06 12:44:31',NULL,NULL),(37292,'41622','S','Eastern','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.525559,-82.823760,0,'2013-07-06 12:44:32',NULL,NULL),(40179,'45371','S','Phoneton','A','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.955039,-84.178566,0,'2013-07-06 12:44:32',NULL,NULL),(40772,'46156','S','Milroy','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.502223,-85.467205,0,'2013-07-06 12:44:32',NULL,NULL),(50569,'58220','S','Cavalier AFS','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.782525,-97.607866,0,'2013-07-06 12:44:33',NULL,NULL),(54722,'62961','P','Millcreek','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.351655,-89.272492,0,'2013-07-06 12:44:33',NULL,NULL),(57631,'67143','S','Sun City','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.398571,-98.900639,0,'2013-07-06 12:44:33',NULL,NULL),(58699,'68929','S','Farmers','N','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.135092,-99.009196,0,'2013-07-06 12:44:33',NULL,NULL),(1022,'00718','S','Urb City Palace','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(78176,'97641','P','Christmas Valley','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.240268,-120.677507,0,'2013-07-06 12:44:34',NULL,NULL),(73691,'91606','S','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186265,-118.391357,0,'2013-07-06 12:44:34',NULL,NULL),(71607,'87326','P','Gallup','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.528056,-108.741944,0,'2013-07-06 12:44:34',NULL,NULL),(54339,'62765','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.801449,-89.645216,0,'2013-07-06 12:44:33',NULL,NULL),(46040,'52557','U','Maharishi University of Mgmt','N','Jefferson','19101','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.005913,-91.964200,0,'2013-07-06 12:44:32',NULL,NULL),(43957,'49309','S','Bitely','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.740936,-85.870792,0,'2013-07-06 12:44:32',NULL,NULL),(40685,'46065','S','Rossville','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.417917,-86.595717,0,'2013-07-06 12:44:32',NULL,NULL),(1206,'00728','S','Qtas del Sur','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(72518,'89158','S','City Center','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.171909,-115.139969,0,'2013-07-06 12:44:34',NULL,NULL),(62536,'74430','P','Crowder','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.125899,-95.670092,0,'2013-07-06 12:44:33',NULL,NULL),(59999,'71331','S','Effie','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.219560,-92.118600,0,'2013-07-06 12:44:33',NULL,NULL),(35066,'39191','S','Beauregard','N','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.701603,-90.395297,0,'2013-07-06 12:44:32',NULL,NULL),(28966,'32205','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.303160,-81.726849,0,'2013-07-06 12:44:32',NULL,NULL),(10348,'10567','S','Cortlandt Mnr','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.279156,-73.872830,0,'2013-07-06 12:44:30',NULL,NULL),(21232,'22226','U','FDIC','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.883884,-77.094284,0,'2013-07-06 12:44:31',NULL,NULL),(18958,'19512','S','Gabelsville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(59553,'70825','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.427794,-91.021838,0,'2013-07-06 12:44:33',NULL,NULL),(31,'00603','S','Urb Garcia','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(78527,'98126','S','Westwood Village','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.549039,-122.376348,0,'2013-07-06 12:44:34',NULL,NULL),(51906,'60103','S','Ontarioville','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.966534,-88.165433,0,'2013-07-06 12:44:33',NULL,NULL),(44864,'50303','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.603190,-93.631372,0,'2013-07-06 12:44:32',NULL,NULL),(39135,'44273','S','Blake','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.027572,-81.883128,0,'2013-07-06 12:44:32',NULL,NULL),(1735,'00778','S','Urb Heavenly Vw Est','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(1434,'00739','S','Urb Campo Bello','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(2784,'00976','S','Parq Montebello','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(15026,'15685','P','Southwest','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.149546,-79.541551,0,'2013-07-06 12:44:31',NULL,NULL),(21918,'23221','S','Stewart','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.558348,-77.488650,0,'2013-07-06 12:44:31',NULL,NULL),(448,'00662','S','Urb Llanos De Isabela','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(36109,'40222','S','Bellemeade','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(12667,'13122','S','Sheds','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.855055,-75.914421,0,'2013-07-06 12:44:30',NULL,NULL),(12112,'12585','S','Verbank','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.719922,-73.700860,0,'2013-07-06 12:44:30',NULL,NULL),(31567,'34613','S','Weeki Wachee','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.556846,-82.518576,0,'2013-07-06 12:44:32',NULL,NULL),(11418,'11963','S','N Haven','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.972440,-72.324540,0,'2013-07-06 12:44:30',NULL,NULL),(66049,'78375','S','Premont','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',27.355708,-98.129917,0,'2013-07-06 12:44:34',NULL,NULL),(61594,'72761','S','Siloam Springs','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.183359,-94.539153,0,'2013-07-06 12:44:33',NULL,NULL),(60080,'71357','S','Balmoral','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.076480,-91.243800,0,'2013-07-06 12:44:33',NULL,NULL),(59148,'70179','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.974498,-90.087150,0,'2013-07-06 12:44:33',NULL,NULL),(58802,'69020','S','Bartley','D','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.253074,-100.305798,0,'2013-07-06 12:44:33',NULL,NULL),(54653,'62930','S','Rector','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.813759,-88.441389,0,'2013-07-06 12:44:33',NULL,NULL),(15011,'15671','S','New Derry','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.350897,-79.315882,0,'2013-07-06 12:44:31',NULL,NULL),(30924,'33708','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(46291,'53048','S','Lomira','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.590376,-88.447118,0,'2013-07-06 12:44:32',NULL,NULL),(48618,'55796','P','Fall Lake','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.928032,-91.800164,0,'2013-07-06 12:44:33',NULL,NULL),(1867,'00791','S','Urb Buzo','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(77092,'96137','S','Clear Creek','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.349400,-121.071420,0,'2013-07-06 12:44:34',NULL,NULL),(70868,'85603','S','South Bisbee','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(46415,'53182','S','Union Grove','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.703188,-88.038888,0,'2013-07-06 12:44:32',NULL,NULL),(39489,'44750','U','Consumer Direct Inc','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.791005,-81.423621,0,'2013-07-06 12:44:32',NULL,NULL),(2633,'00965','S','Bda Vietnam','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(21309,'22405','S','Fredericksbrg','A','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.320601,-77.414651,0,'2013-07-06 12:44:31',NULL,NULL),(1934,'00795','S','Urb Monte Sol','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(34472,'38664','S','Bowdre','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.817778,-90.370833,0,'2013-07-06 12:44:32',NULL,NULL),(13489,'13802','S','Maine','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.202719,-76.056278,0,'2013-07-06 12:44:31',NULL,NULL),(57769,'67456','S','Smolan','A','McPherson','20113','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.573248,-97.674221,0,'2013-07-06 12:44:33',NULL,NULL),(60440,'71647','S','Hermitage','D','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.399420,-92.123700,0,'2013-07-06 12:44:33',NULL,NULL),(8624,'08251','S','Villas','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.023220,-74.931300,0,'2013-07-06 12:44:30',NULL,NULL),(62951,'75106','P','Cedar Hill','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.587715,-96.956151,0,'2013-07-06 12:44:33',NULL,NULL),(16759,'17518','S','Drumore','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.818303,-76.244889,0,'2013-07-06 12:44:31',NULL,NULL),(49701,'57030','S','Sherman','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.714740,-96.519420,0,'2013-07-06 12:44:33',NULL,NULL),(76313,'95450','S','Jenner','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.499360,-123.185160,0,'2013-07-06 12:44:34',NULL,NULL),(77132,'96156','P','Camp Richardson','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.947065,-119.970227,0,'2013-07-06 12:44:34',NULL,NULL),(46049,'52568','P','Martinsburg','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.203919,-92.160184,0,'2013-07-06 12:44:32',NULL,NULL),(43839,'49096','S','Vermontville','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.634787,-85.014625,0,'2013-07-06 12:44:32',NULL,NULL),(48012,'55170','U','Us Bank','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.944443,-93.092404,0,'2013-07-06 12:44:33',NULL,NULL),(25745,'28571','S','Oriental','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.031095,-76.695847,0,'2013-07-06 12:44:31',NULL,NULL),(45666,'52035','S','Colesburg','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.634992,-91.200496,0,'2013-07-06 12:44:32',NULL,NULL),(8356,'08050','S','Beach Haven West','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.698720,-74.257382,0,'2013-07-06 12:44:30',NULL,NULL),(17367,'17872','S','West Cameron','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(53702,'62232','S','Hollywood Heights','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.634957,-90.012889,0,'2013-07-06 12:44:33',NULL,NULL),(6461,'05761','S','East Rupert','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.361700,-73.134300,0,'2013-07-06 12:44:30',NULL,NULL),(48887,'56101','S','Wilder','A','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.873800,-95.153160,0,'2013-07-06 12:44:33',NULL,NULL),(35805,'39759','S','Bradley','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(67896,'80901','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834608,-104.822550,0,'2013-07-06 12:44:34',NULL,NULL),(4839,'04007','P','Biddeford','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.465925,-70.440735,0,'2013-07-06 12:44:30',NULL,NULL),(17703,'18222','S','Drums','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.035414,-75.952009,0,'2013-07-06 12:44:31',NULL,NULL),(9057,'08902','S','New Brunswick','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.446660,-74.488980,0,'2013-07-06 12:44:30',NULL,NULL),(40998,'46360','S','Michigan City','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.709441,-86.864786,0,'2013-07-06 12:44:32',NULL,NULL),(9469,'10009','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(10866,'11416','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.684494,-73.850427,0,'2013-07-06 12:44:30',NULL,NULL),(16306,'17112','S','Linglestown','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.338060,-76.803780,0,'2013-07-06 12:44:31',NULL,NULL),(10013,'10169','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.797792,-73.946351,0,'2013-07-06 12:44:30',NULL,NULL),(10809,'11374','S','Rego Park','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.727079,-73.861454,0,'2013-07-06 12:44:30',NULL,NULL),(44469,'49887','S','Stephenson','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.414673,-87.615414,0,'2013-07-06 12:44:32',NULL,NULL),(25934,'28655','S','Calvin','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(21662,'22945','P','Ivy','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.057250,-78.597718,0,'2013-07-06 12:44:31',NULL,NULL),(21027,'21862','S','Showell','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.396558,-75.213903,0,'2013-07-06 12:44:31',NULL,NULL),(50156,'57548','S','Lower Brule','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.060655,-99.695554,0,'2013-07-06 12:44:33',NULL,NULL),(25635,'28465','S','Sunny Point Mil Ocean','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.915678,-78.132541,0,'2013-07-06 12:44:31',NULL,NULL),(15430,'16369','U','Warren','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.847491,-79.145887,0,'2013-07-06 12:44:31',NULL,NULL),(77072,'96125','S','Sierra City','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.570300,-120.647805,0,'2013-07-06 12:44:34',NULL,NULL),(9297,'09707','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(70661,'85207','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.454568,-111.650423,0,'2013-07-06 12:44:34',NULL,NULL),(4018,'02562','S','Sagamore Beach','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.794946,-70.527022,0,'2013-07-06 12:44:30',NULL,NULL),(49484,'56660','S','Mizpah','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.987810,-94.214799,0,'2013-07-06 12:44:33',NULL,NULL),(8395,'08062','S','Harrison Township','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.722021,-75.221337,0,'2013-07-06 12:44:30',NULL,NULL),(40935,'46290','S','Nora','A','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.936276,-86.211203,0,'2013-07-06 12:44:32',NULL,NULL),(7687,'07103','S','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.737637,-74.196772,0,'2013-07-06 12:44:30',NULL,NULL),(79537,'98947','S','Tieton','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.703002,-120.740110,0,'2013-07-06 12:44:34',NULL,NULL),(79538,'98948','S','Toppenish','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.372419,-120.316397,0,'2013-07-06 12:44:34',NULL,NULL),(60675,'71923','S','Hearn','N','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.085898,-93.045684,0,'2013-07-06 12:44:33',NULL,NULL),(12927,'13341','P','Franklin Spgs','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.034678,-75.390751,0,'2013-07-06 12:44:30',NULL,NULL),(62960,'75119','S','Ennis','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.339376,-96.566955,0,'2013-07-06 12:44:33',NULL,NULL),(75038,'93514','S','Hammil Valley','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(22972,'24724','S','Freeman','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.363056,-81.334444,0,'2013-07-06 12:44:31',NULL,NULL),(42208,'47553','S','Bramble','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.822500,-86.886944,0,'2013-07-06 12:44:32',NULL,NULL),(54818,'63023','S','Dittmer','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.305762,-90.680759,0,'2013-07-06 12:44:33',NULL,NULL),(51945,'60131','S','Franklin Park','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',41.936119,-87.875866,0,'2013-07-06 12:44:33',NULL,NULL),(71362,'86544','P','Teec Nos Pos','A','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750097,-109.365708,0,'2013-07-06 12:44:34',NULL,NULL),(1655,'00773','S','Brisas de Luquillo','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(45561,'51503','S','Co Bluffs','N','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.263360,-95.819074,0,'2013-07-06 12:44:32',NULL,NULL),(47705,'54984','S','Wild Rose','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.168670,-89.214247,0,'2013-07-06 12:44:33',NULL,NULL),(49997,'57371','S','Ree Heights','D','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.594136,-99.247882,0,'2013-07-06 12:44:33',NULL,NULL),(26590,'29224','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.057985,-80.841611,0,'2013-07-06 12:44:31',NULL,NULL),(70970,'85662','P','Nogales','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.366528,-110.933260,0,'2013-07-06 12:44:34',NULL,NULL),(22056,'23324','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.799974,-76.267142,0,'2013-07-06 12:44:31',NULL,NULL),(61107,'72142','S','Kerr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.776533,-92.063990,0,'2013-07-06 12:44:33',NULL,NULL),(20797,'21550','S','Loch Lynn Heights','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(32428,'35983','S','Sandrock','A','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.160544,-85.779405,0,'2013-07-06 12:44:32',NULL,NULL),(51252,'59078','S','Shawmut','D','Wheatland','30107','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.377137,-109.592192,0,'2013-07-06 12:44:33',NULL,NULL),(75698,'94565','S','West Pittsburg','N','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.017076,-121.909650,0,'2013-07-06 12:44:34',NULL,NULL),(20188,'20748','S','Hillcrest Hts','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(19727,'20398','S','Military Sealift Command','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876127,-76.994243,0,'2013-07-06 12:44:31',NULL,NULL),(19485,'20149','U','Natl Assn Letter Carriers','N','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.043616,-77.481607,0,'2013-07-06 12:44:31',NULL,NULL),(57895,'67643','S','Jennings','D','Decatur','20039','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.677779,-100.293941,0,'2013-07-06 12:44:33',NULL,NULL),(31309,'34106','P','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.139274,-81.797939,0,'2013-07-06 12:44:32',NULL,NULL),(33723,'37807','S','Maynardville','D','Union','47173','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.166587,-83.911863,0,'2013-07-06 12:44:32',NULL,NULL),(54699,'62951','S','Ferges','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.819324,-88.924585,0,'2013-07-06 12:44:33',NULL,NULL),(18059,'18702','S','Plains Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(51385,'59417','S','Blackfoot','N','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.571299,-113.206612,0,'2013-07-06 12:44:33',NULL,NULL),(74731,'93041','S','Naval Base Ventura County','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.161105,-119.189825,0,'2013-07-06 12:44:34',NULL,NULL),(19040,'19539','S','Oreville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.490340,-75.692160,0,'2013-07-06 12:44:31',NULL,NULL),(64835,'77040','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(63743,'75935','S','Short','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(70422,'84728','S','Garrison','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.935110,-114.034510,0,'2013-07-06 12:44:34',NULL,NULL),(8064,'07748','S','Middletown','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.395074,-74.109292,0,'2013-07-06 12:44:30',NULL,NULL),(32589,'36125','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.313036,-86.318132,0,'2013-07-06 12:44:32',NULL,NULL),(42962,'48131','S','Duncan','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.965760,-83.668534,0,'2013-07-06 12:44:32',NULL,NULL),(45305,'50836','S','Maloy','A','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648229,-94.530783,0,'2013-07-06 12:44:32',NULL,NULL),(72112,'88244','U','Lea County Correctional Fac','N','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.630065,-103.334409,0,'2013-07-06 12:44:34',NULL,NULL),(59965,'71309','P','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.255733,-92.470566,0,'2013-07-06 12:44:33',NULL,NULL),(48846,'56062','S','Madelia','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.048762,-94.418055,0,'2013-07-06 12:44:33',NULL,NULL),(27741,'30355','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.835447,-84.366399,0,'2013-07-06 12:44:31',NULL,NULL),(36074,'40212','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.261980,-85.800266,0,'2013-07-06 12:44:32',NULL,NULL),(77203,'96368','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74779,'93116','P','Goleta','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.491171,-120.038827,0,'2013-07-06 12:44:34',NULL,NULL),(44832,'50254','S','Thayer','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.985232,-94.072081,0,'2013-07-06 12:44:32',NULL,NULL),(9816,'10112','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(71237,'86338','P','Skull Valley','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.554634,-112.710745,0,'2013-07-06 12:44:34',NULL,NULL),(66214,'78551','P','Harlingen','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.207392,-97.735067,0,'2013-07-06 12:44:34',NULL,NULL),(52084,'60404','S','Joliet','A','Will','17197','Illinois','IL','17','1600','708','Central',-6.0,'Y',41.514639,-88.198385,0,'2013-07-06 12:44:33',NULL,NULL),(8723,'08505','S','Fieldsboro','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.128420,-74.716860,0,'2013-07-06 12:44:30',NULL,NULL),(72057,'88113','S','Causey','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.858898,-103.139868,0,'2013-07-06 12:44:34',NULL,NULL),(71218,'86322','S','Camp Verde','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.557188,-111.834292,0,'2013-07-06 12:44:34',NULL,NULL),(69953,'84118','S','Kearns','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(1141,'00727','S','Bosque Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(65116,'77375','S','Rose Hill','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.081648,-95.615932,0,'2013-07-06 12:44:34',NULL,NULL),(55134,'63350','S','High Hill','D','Montgomery','29139','Missouri','MO','29','0000','636','Central',-6.0,'Y',38.900995,-91.372028,0,'2013-07-06 12:44:33',NULL,NULL),(54625,'62918','S','Blairsville','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.789020,-89.096520,0,'2013-07-06 12:44:33',NULL,NULL),(46340,'53090','S','West Bend','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.449492,-88.171297,0,'2013-07-06 12:44:32',NULL,NULL),(7480,'06897','S','Wilton','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.204177,-73.435815,0,'2013-07-06 12:44:30',NULL,NULL),(7022,'06262','S','Quinebaug','D','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',42.018708,-71.945107,0,'2013-07-06 12:44:30',NULL,NULL),(58084,'68070','S','Weston','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.178610,-96.794009,0,'2013-07-06 12:44:33',NULL,NULL),(34158,'38256','S','Springville','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.381413,-88.105873,0,'2013-07-06 12:44:32',NULL,NULL),(53267,'61721','S','Armington','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.341244,-89.310815,0,'2013-07-06 12:44:33',NULL,NULL),(62113,'73644','S','Elk City','D','Beckham','40009','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.410421,-99.413649,0,'2013-07-06 12:44:33',NULL,NULL),(4028,'02568','S','Vineyard Haven','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.453520,-70.589400,0,'2013-07-06 12:44:30',NULL,NULL),(27142,'29819','S','Callison','N','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.109752,-82.233224,0,'2013-07-06 12:44:31',NULL,NULL),(72879,'90011','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.006146,-118.257237,0,'2013-07-06 12:44:34',NULL,NULL),(52713,'61126','P','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.253632,-89.017952,0,'2013-07-06 12:44:33',NULL,NULL),(14798,'15376','S','West Alexander','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.112468,-80.489517,0,'2013-07-06 12:44:31',NULL,NULL),(44271,'49705','S','Afton','D','Cheboygan','26031','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.363111,-84.474201,0,'2013-07-06 12:44:32',NULL,NULL),(1640,'00771','S','Urb Olimpic Pk','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(11681,'12151','S','Round Lake','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923520,-73.782900,0,'2013-07-06 12:44:30',NULL,NULL),(38679,'43967','P','Warnock','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.021742,-80.940084,0,'2013-07-06 12:44:32',NULL,NULL),(30170,'33173','S','South Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.701363,-80.360874,0,'2013-07-06 12:44:32',NULL,NULL),(80102,'99753','P','Koyuk','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.149946,-160.778172,0,'2013-07-06 12:44:34',NULL,NULL),(13257,'13646','S','Ruby Corner','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.450100,-75.686400,0,'2013-07-06 12:44:30',NULL,NULL),(9359,'09816','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(65259,'77469','S','Clodine','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(50304,'57703','S','Rapid City','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.079971,-103.231979,0,'2013-07-06 12:44:33',NULL,NULL),(11216,'11746','S','So Huntington','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(44541,'50001','S','Ackworth','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.381400,-93.398760,0,'2013-07-06 12:44:32',NULL,NULL),(1548,'00757','S','Villa Camarero','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(37876,'42553','S','Science Hill','D','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.173000,-84.685920,0,'2013-07-06 12:44:32',NULL,NULL),(38042,'43036','P','Magnetic Spring','N','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.352146,-83.262257,0,'2013-07-06 12:44:32',NULL,NULL),(59267,'70453','S','Pine Grove','D','Saint Helena','22091','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.696601,-90.773856,0,'2013-07-06 12:44:33',NULL,NULL),(29139,'32328','S','East Point','N','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.746800,-84.923220,0,'2013-07-06 12:44:32',NULL,NULL),(3272,'01470','U','Groton','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.608252,-71.571890,0,'2013-07-06 12:44:30',NULL,NULL),(77866,'97236','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.488127,-122.507963,0,'2013-07-06 12:44:34',NULL,NULL),(79675,'99167','S','Rice','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.426364,-118.132218,0,'2013-07-06 12:44:34',NULL,NULL),(63244,'75478','S','Saltillo','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.196298,-95.346022,0,'2013-07-06 12:44:33',NULL,NULL),(65934,'78251','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.459501,-98.669147,0,'2013-07-06 12:44:34',NULL,NULL),(65270,'77474','S','Sealy','D','Austin','48015','Texas','TX','48','0000','979','Central',-6.0,'Y',29.783576,-96.158093,0,'2013-07-06 12:44:34',NULL,NULL),(8121,'07826','S','Branchville','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.191414,-74.750519,0,'2013-07-06 12:44:30',NULL,NULL),(25261,'28120','S','Mt Holly','A','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.307051,-81.030096,0,'2013-07-06 12:44:31',NULL,NULL),(49959,'57349','S','Howard','D','Miner','46097','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.014323,-97.529484,0,'2013-07-06 12:44:33',NULL,NULL),(73102,'90240','S','Downey','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.954610,-118.116688,0,'2013-07-06 12:44:34',NULL,NULL),(74427,'92561','S','Pinyon Pines','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.518312,-116.424551,0,'2013-07-06 12:44:34',NULL,NULL),(25789,'28604','S','Matney','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(31952,'35209','S','Vestavia','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.460200,-86.809200,0,'2013-07-06 12:44:32',NULL,NULL),(61520,'72659','S','Norfork','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.207031,-92.282934,0,'2013-07-06 12:44:33',NULL,NULL),(12414,'12937','S','Ft Covington','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.956408,-74.489215,0,'2013-07-06 12:44:30',NULL,NULL),(63883,'76013','S','Dalworthington Gardens','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.717191,-97.152038,0,'2013-07-06 12:44:34',NULL,NULL),(27499,'30172','P','Shannon','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.343073,-85.083756,0,'2013-07-06 12:44:31',NULL,NULL),(38508,'43713','S','Somerton','A','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.976140,-81.165000,0,'2013-07-06 12:44:32',NULL,NULL),(67255,'79954','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.757960,-106.488675,0,'2013-07-06 12:44:34',NULL,NULL),(46977,'54217','S','Dyckesville','N','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.594160,-87.715920,0,'2013-07-06 12:44:32',NULL,NULL),(74019,'92126','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.912763,-117.148011,0,'2013-07-06 12:44:34',NULL,NULL),(34251,'38402','P','Columbia','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.615211,-87.031789,0,'2013-07-06 12:44:32',NULL,NULL),(3750,'02171','S','Norfolk Downs','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(43289,'48335','S','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.466205,-83.401727,0,'2013-07-06 12:44:32',NULL,NULL),(68763,'82244','S','Yoder','D','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.958631,-104.462340,0,'2013-07-06 12:44:34',NULL,NULL),(50297,'57701','S','Rapid City','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.080920,-103.172940,0,'2013-07-06 12:44:33',NULL,NULL),(48384,'55572','P','Rockford','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996060,-93.708483,0,'2013-07-06 12:44:33',NULL,NULL),(30365,'33314','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.070011,-80.219723,0,'2013-07-06 12:44:32',NULL,NULL),(31240,'33974','S','Leehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.554897,-81.626174,0,'2013-07-06 12:44:32',NULL,NULL),(39760,'45114','P','Cuba','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.361894,-83.862435,0,'2013-07-06 12:44:32',NULL,NULL),(8698,'08349','S','Port Norris','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.258120,-75.059520,0,'2013-07-06 12:44:30',NULL,NULL),(32088,'35292','U','AL Power Co','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.512500,-86.805024,0,'2013-07-06 12:44:32',NULL,NULL),(10652,'11103','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.762281,-73.910107,0,'2013-07-06 12:44:30',NULL,NULL),(56833,'65803','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.244329,-93.294373,0,'2013-07-06 12:44:33',NULL,NULL),(46183,'52738','S','Fredonia','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(76470,'95620','S','Dixon','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.440059,-121.822861,0,'2013-07-06 12:44:34',NULL,NULL),(29733,'32962','S','Vero Beach','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.589213,-80.410201,0,'2013-07-06 12:44:32',NULL,NULL),(17398,'17901','S','Heckschersville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(19868,'20526','U','Peace Corps','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900668,-77.045582,0,'2013-07-06 12:44:31',NULL,NULL),(13009,'13417','S','New York Mls','A','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.100821,-75.290988,0,'2013-07-06 12:44:30',NULL,NULL),(513,'00674','S','Repto Rosello','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(48378,'55568','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816126,-93.919400,0,'2013-07-06 12:44:33',NULL,NULL),(38581,'43802','S','Adamsville','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.083252,-81.859062,0,'2013-07-06 12:44:32',NULL,NULL),(15037,'15695','P','Wyano','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.198702,-79.697361,0,'2013-07-06 12:44:31',NULL,NULL),(58446,'68716','S','Beemer','D','Cuming','31039','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.929617,-96.809699,0,'2013-07-06 12:44:33',NULL,NULL),(67939,'80911','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.738810,-104.707810,0,'2013-07-06 12:44:34',NULL,NULL),(60583,'71822','S','Ashdown','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.674109,-94.125689,0,'2013-07-06 12:44:33',NULL,NULL),(26157,'28741','S','Highlands','D','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.055868,-83.205699,0,'2013-07-06 12:44:31',NULL,NULL),(46850,'54022','S','Clifton','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.880780,-92.632260,0,'2013-07-06 12:44:32',NULL,NULL),(36185,'40253','P','Middletown','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.242117,-85.529319,0,'2013-07-06 12:44:32',NULL,NULL),(52565,'60958','S','Pembroke Twp','A','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.234742,-87.635744,0,'2013-07-06 12:44:33',NULL,NULL),(13789,'14170','S','West Falls','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.704094,-78.670831,0,'2013-07-06 12:44:31',NULL,NULL),(10125,'10260','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(71407,'87016','S','Tajique','A','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.775760,-106.171560,0,'2013-07-06 12:44:34',NULL,NULL),(48860,'56075','P','Fairmont','A','Martin','27091','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.720118,-94.442171,0,'2013-07-06 12:44:33',NULL,NULL),(60169,'71409','S','Boyce','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(60098,'71360','S','Kolin','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.348955,-92.392557,0,'2013-07-06 12:44:33',NULL,NULL),(79081,'98438','P','JB Lewis McChord','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.253000,-122.443020,0,'2013-07-06 12:44:34',NULL,NULL),(67809,'80743','S','Otis','D','Washington','08121','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.208232,-102.961898,0,'2013-07-06 12:44:34',NULL,NULL),(15588,'16664','S','New Entrprise','A','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.193674,-78.423234,0,'2013-07-06 12:44:31',NULL,NULL),(41534,'46995','P','W Middleton','A','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.439485,-86.217646,0,'2013-07-06 12:44:32',NULL,NULL),(72175,'88346','S','Ruidoso Downs','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.325236,-105.620219,0,'2013-07-06 12:44:34',NULL,NULL),(40274,'45434','S','Beavercreek','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.712421,-84.041488,0,'2013-07-06 12:44:32',NULL,NULL),(12513,'13027','S','Radison','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.166729,-76.339805,0,'2013-07-06 12:44:30',NULL,NULL),(2102,'00923','S','Urb Embalse San Jose','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(46223,'52772','S','Rochester','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.788260,-91.131240,0,'2013-07-06 12:44:32',NULL,NULL),(43032,'48173','S','Gibraltar','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.073111,-83.223109,0,'2013-07-06 12:44:32',NULL,NULL),(35876,'39854','S','Georgetown','D','Quitman','13239','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.874042,-85.104636,0,'2013-07-06 12:44:32',NULL,NULL),(16239,'17078','S','Upper Lawn','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299264,-76.586642,0,'2013-07-06 12:44:31',NULL,NULL),(17895,'18445','S','South Sterling','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.289870,-75.399598,0,'2013-07-06 12:44:31',NULL,NULL),(75702,'94568','S','Pleasanton','A','Alameda','06001','California','CA','06','5775','925','Pacific',-8.0,'Y',37.714234,-121.930817,0,'2013-07-06 12:44:34',NULL,NULL),(61320,'72442','S','Manila','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.883098,-90.168223,0,'2013-07-06 12:44:33',NULL,NULL),(23161,'25015','S','DuPont City','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(34056,'38139','S','Memphis','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.089280,-89.773074,0,'2013-07-06 12:44:32',NULL,NULL),(74435,'92567','S','Nuevo','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.834435,-117.107956,0,'2013-07-06 12:44:34',NULL,NULL),(8218,'07961','P','Convent Sta','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.796667,-74.481944,0,'2013-07-06 12:44:30',NULL,NULL),(10263,'10504','S','Armonk','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.139871,-73.700165,0,'2013-07-06 12:44:30',NULL,NULL),(36202,'40268','P','Pleasure Ridge Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.146878,-85.870680,0,'2013-07-06 12:44:32',NULL,NULL),(63032,'75205','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.836236,-96.794663,0,'2013-07-06 12:44:33',NULL,NULL),(76398,'95543','S','Gasquet','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.881896,-123.874458,0,'2013-07-06 12:44:34',NULL,NULL),(501,'00674','S','Hacienda Hermanas Mena','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(19082,'19565','S','Wernersville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323518,-76.086686,0,'2013-07-06 12:44:31',NULL,NULL),(61723,'73018','S','Chickasha','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.033843,-97.947357,0,'2013-07-06 12:44:33',NULL,NULL),(12807,'13251','U','Firms','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.123742,-76.135103,0,'2013-07-06 12:44:30',NULL,NULL),(27491,'30163','P','Rome','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.246140,-85.131730,0,'2013-07-06 12:44:31',NULL,NULL),(40435,'45715','S','Beverly','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.570240,-81.635520,0,'2013-07-06 12:44:32',NULL,NULL),(30583,'33417','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.714953,-80.124964,0,'2013-07-06 12:44:32',NULL,NULL),(31893,'35137','P','Saginaw','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.215942,-86.791875,0,'2013-07-06 12:44:32',NULL,NULL),(32057,'35261','P','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573309,-86.715321,0,'2013-07-06 12:44:32',NULL,NULL),(24495,'27260','S','High Pnt','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(77626,'97002','S','Aurora','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.232302,-122.807794,0,'2013-07-06 12:44:34',NULL,NULL),(46535,'53402','S','Wind Point','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.797800,-87.832227,0,'2013-07-06 12:44:32',NULL,NULL),(8561,'08210','S','Cape May Court House','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(65865,'78213','S','Castle Hills','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.512114,-98.523892,0,'2013-07-06 12:44:34',NULL,NULL),(36966,'41179','S','Camp Dix','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(3515,'01879','S','Tyngsborough','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.673414,-71.416749,0,'2013-07-06 12:44:30',NULL,NULL),(68509,'81325','S','Slick Rock','A','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.910000,-108.930000,0,'2013-07-06 12:44:34',NULL,NULL),(23877,'26160','S','Somervlle Frk','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.966426,-81.425664,0,'2013-07-06 12:44:31',NULL,NULL),(22163,'23462','S','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.839595,-76.151374,0,'2013-07-06 12:44:31',NULL,NULL),(47171,'54476','S','Weston','A','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.906068,-89.571594,0,'2013-07-06 12:44:32',NULL,NULL),(71481,'87068','S','Peralta','A','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.892400,-106.712640,0,'2013-07-06 12:44:34',NULL,NULL),(29333,'32548','S','Fort Walton Beach','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(64766,'76949','S','Silver','D','Coke','48081','Texas','TX','48','0000','325','Central',-6.0,'Y',32.041663,-100.681797,0,'2013-07-06 12:44:34',NULL,NULL),(54718,'62960','S','Bargerville','N','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.154433,-88.723675,0,'2013-07-06 12:44:33',NULL,NULL),(38398,'43526','S','Hicksville','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.312912,-84.734343,0,'2013-07-06 12:44:32',NULL,NULL),(44745,'50165','S','Millerton','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.856051,-93.271104,0,'2013-07-06 12:44:32',NULL,NULL),(20851,'21656','P','Church Hill','A','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.097500,-75.959167,0,'2013-07-06 12:44:31',NULL,NULL),(38948,'44125','S','Garfield','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(2980,'01059','P','Amherst','A','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.413287,-72.530513,0,'2013-07-06 12:44:30',NULL,NULL),(69436,'83641','S','Stoddard','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.380775,-116.549761,0,'2013-07-06 12:44:34',NULL,NULL),(71062,'85756','S','TSN','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.136236,-111.085365,0,'2013-07-06 12:44:34',NULL,NULL),(4556,'03457','S','Stoddard','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.002905,-72.144980,0,'2013-07-06 12:44:30',NULL,NULL),(69016,'83211','S','American Falls','D','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(60399,'71631','S','Lanark','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.544300,-92.265430,0,'2013-07-06 12:44:33',NULL,NULL),(18947,'19508','S','Robeson','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(44211,'49635','S','Frankfort','D','Benzie','26019','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.631996,-86.214690,0,'2013-07-06 12:44:32',NULL,NULL),(29215,'32413','S','Watersound','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(75572,'94274','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586449,-121.494078,0,'2013-07-06 12:44:34',NULL,NULL),(15782,'16922','S','West Pike','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.712840,-77.662020,0,'2013-07-06 12:44:31',NULL,NULL),(73829,'91772','U','So Cal Edison Co','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065726,-118.085794,0,'2013-07-06 12:44:34',NULL,NULL),(72920,'90027','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.123560,-118.287840,0,'2013-07-06 12:44:34',NULL,NULL),(34362,'38603','S','Snow Lake Shores','N','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.831184,-89.170922,0,'2013-07-06 12:44:32',NULL,NULL),(31387,'34218','P','Holmes Beach','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.501540,-82.709820,0,'2013-07-06 12:44:32',NULL,NULL),(71555,'87195','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.064655,-106.675409,0,'2013-07-06 12:44:34',NULL,NULL),(51004,'58701','S','Minot','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230821,-101.294119,0,'2013-07-06 12:44:33',NULL,NULL),(15066,'15733','P','De Lancey','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.983892,-78.973673,0,'2013-07-06 12:44:31',NULL,NULL),(13263,'13648','S','Lake Bonaparte','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(8003,'07719','S','Wall','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.165500,-74.072640,0,'2013-07-06 12:44:30',NULL,NULL),(51544,'59730','S','Gallatin Gateway','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.438705,-111.215519,0,'2013-07-06 12:44:33',NULL,NULL),(50316,'57719','S','Box Elder','D','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.116272,-103.078498,0,'2013-07-06 12:44:33',NULL,NULL),(11559,'12060','S','Red Rock','N','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.412620,-73.496040,0,'2013-07-06 12:44:30',NULL,NULL),(68751,'82224','S','Lost Springs','D','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.765510,-104.925100,0,'2013-07-06 12:44:34',NULL,NULL),(30897,'33705','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.742211,-82.643117,0,'2013-07-06 12:44:32',NULL,NULL),(27173,'29841','S','North Augusta','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.512008,-81.932644,0,'2013-07-06 12:44:31',NULL,NULL),(72,'00612','S','Est de Arecibo','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(57236,'66517','S','Ogden','D','Riley','20161','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.114104,-96.708239,0,'2013-07-06 12:44:33',NULL,NULL),(22884,'24577','S','Republican Grove','A','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.942263,-78.970967,0,'2013-07-06 12:44:31',NULL,NULL),(49392,'56621','S','Bagley','D','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(10115,'10259','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(33197,'37042','S','Sango','N','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.562140,-87.405720,0,'2013-07-06 12:44:32',NULL,NULL),(62676,'74653','S','Tonkawa','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.679522,-97.302551,0,'2013-07-06 12:44:33',NULL,NULL),(26401,'29111','S','New Zion','D','Clarendon','45027','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.780339,-80.018183,0,'2013-07-06 12:44:31',NULL,NULL),(48380,'55569','P','Osseo','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.115998,-93.397431,0,'2013-07-06 12:44:33',NULL,NULL),(964,'00716','S','Urb Anaida','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(10093,'10213','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.718440,-74.006344,0,'2013-07-06 12:44:30',NULL,NULL),(66097,'78407','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.805931,-97.436894,0,'2013-07-06 12:44:34',NULL,NULL),(26496,'29169','S','Kathwood','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(63242,'75476','S','Ravenna','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.669604,-96.240457,0,'2013-07-06 12:44:33',NULL,NULL),(62299,'74023','S','Norfolk','N','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.976349,-96.764819,0,'2013-07-06 12:44:33',NULL,NULL),(60557,'71744','S','Hampton','D','Calhoun','05013','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.513001,-92.562851,0,'2013-07-06 12:44:33',NULL,NULL),(48918,'56143','S','Jackson','D','Jackson','27063','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.622545,-94.991359,0,'2013-07-06 12:44:33',NULL,NULL),(21528,'22727','S','Graves Mill','A','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(71466,'87056','S','Stanley','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.134100,-105.941216,0,'2013-07-06 12:44:34',NULL,NULL),(18330,'19026','S','Pilgrim Gdns','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.955020,-75.327420,0,'2013-07-06 12:44:31',NULL,NULL),(46422,'53187','P','Waukesha','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.008880,-88.221398,0,'2013-07-06 12:44:32',NULL,NULL),(61474,'72632','S','Eureka Springs','D','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.444978,-93.740676,0,'2013-07-06 12:44:33',NULL,NULL),(59337,'70543','S','Iota','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.325152,-92.513107,0,'2013-07-06 12:44:33',NULL,NULL),(31769,'35010','S','Alexander City','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',32.913360,-85.938360,0,'2013-07-06 12:44:32',NULL,NULL),(64896,'77083','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.690885,-95.651136,0,'2013-07-06 12:44:34',NULL,NULL),(72448,'89107','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.173181,-115.209884,0,'2013-07-06 12:44:34',NULL,NULL),(15784,'16923','S','Ellisburg','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(70558,'85042','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.375254,-112.031642,0,'2013-07-06 12:44:34',NULL,NULL),(69383,'83611','S','Alpha','N','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.393460,-115.981260,0,'2013-07-06 12:44:34',NULL,NULL),(15432,'16371','S','Youngsville','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.854699,-79.318469,0,'2013-07-06 12:44:31',NULL,NULL),(31064,'33847','P','Homeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.818652,-81.827765,0,'2013-07-06 12:44:32',NULL,NULL),(77647,'97015','S','Damascus','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.415610,-122.523750,0,'2013-07-06 12:44:34',NULL,NULL),(39671,'45013','S','Rossville','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.408216,-84.617598,0,'2013-07-06 12:44:32',NULL,NULL),(75680,'94553','S','Briones','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.991280,-122.164320,0,'2013-07-06 12:44:34',NULL,NULL),(79935,'99619','P','Kodiak','D','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.794070,-152.404070,0,'2013-07-06 12:44:34',NULL,NULL),(68290,'81089','S','Pryor','N','Huerfano','08055','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.617160,-104.817267,0,'2013-07-06 12:44:34',NULL,NULL),(5890,'05155','S','Rawsonville','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(38729,'44023','S','Bainbridge Township','N','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.390948,-81.336689,0,'2013-07-06 12:44:32',NULL,NULL),(34609,'38751','S','Baird','A','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(10524,'10981','P','Sugar Loaf','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.323014,-74.285588,0,'2013-07-06 12:44:30',NULL,NULL),(50293,'57660','S','Watauga','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.924308,-101.512821,0,'2013-07-06 12:44:33',NULL,NULL),(48642,'55814','P','Duluth Federal Prison','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.841316,-92.216319,0,'2013-07-06 12:44:33',NULL,NULL),(39551,'44842','S','Loudonville','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.644167,-82.233247,0,'2013-07-06 12:44:32',NULL,NULL),(48695,'55935','S','Fountain','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.717012,-92.150989,0,'2013-07-06 12:44:33',NULL,NULL),(49220,'56467','S','Nebish','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.876449,-94.807054,0,'2013-07-06 12:44:33',NULL,NULL),(12290,'12846','S','Luzerne','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.326780,-73.820220,0,'2013-07-06 12:44:30',NULL,NULL),(70728,'85298','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.239786,-111.717632,0,'2013-07-06 12:44:34',NULL,NULL),(68099,'80944','U','Co Interstate Gas','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832646,-104.822595,0,'2013-07-06 12:44:34',NULL,NULL),(7725,'07201','S','Peterstown','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.664256,-74.179890,0,'2013-07-06 12:44:30',NULL,NULL),(30832,'33625','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.071279,-82.555434,0,'2013-07-06 12:44:32',NULL,NULL),(49271,'56484','S','Turtle Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(37378,'41740','S','Tina','A','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.324933,-83.068260,0,'2013-07-06 12:44:32',NULL,NULL),(78418,'98045','S','Cedar Falls','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.475162,-121.756532,0,'2013-07-06 12:44:34',NULL,NULL),(79172,'98520','S','Aberdeen Gardens','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(67205,'79912','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.842644,-106.540333,0,'2013-07-06 12:44:34',NULL,NULL),(53719,'62242','S','Evansville','D','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.096033,-89.906301,0,'2013-07-06 12:44:33',NULL,NULL),(32990,'36619','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.593684,-88.184484,0,'2013-07-06 12:44:32',NULL,NULL),(77516,'96841','U','Hawaiian Telcom','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.309296,-157.859620,0,'2013-07-06 12:44:34',NULL,NULL),(79025,'98391','S','Rhododendron Park','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(171,'00623','S','Ext Elizabeth','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(764,'00692','S','Urb La Esperanza','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(59520,'70801','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.446043,-91.185434,0,'2013-07-06 12:44:33',NULL,NULL),(52987,'61438','S','Good Hope','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.556390,-90.671360,0,'2013-07-06 12:44:33',NULL,NULL),(35946,'40057','S','Franklinton','A','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.369196,-85.063919,0,'2013-07-06 12:44:32',NULL,NULL),(77822,'97205','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.518251,-122.687935,0,'2013-07-06 12:44:34',NULL,NULL),(65900,'78234','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.457977,-98.493044,0,'2013-07-06 12:44:34',NULL,NULL),(24107,'26524','S','Reedsville','N','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.541498,-79.802342,0,'2013-07-06 12:44:31',NULL,NULL),(34857,'38927','S','Enid','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.123299,-90.037402,0,'2013-07-06 12:44:32',NULL,NULL),(72294,'88575','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766653,-106.330377,0,'2013-07-06 12:44:34',NULL,NULL),(78322,'97913','S','Nyssa','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',43.838397,-117.061031,0,'2013-07-06 12:44:34',NULL,NULL),(72529,'89163','U','The Lakes','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.174641,-115.138381,0,'2013-07-06 12:44:34',NULL,NULL),(3751,'02171','S','North Quincy','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(34297,'38506','S','Cookevl','N','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.146202,-85.527440,0,'2013-07-06 12:44:32',NULL,NULL),(64763,'76943','S','Ozona','D','Crockett','48105','Texas','TX','48','0000','325','Central',-6.0,'Y',30.710960,-101.211744,0,'2013-07-06 12:44:34',NULL,NULL),(59125,'70158','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.922943,-90.068665,0,'2013-07-06 12:44:33',NULL,NULL),(57219,'66451','S','Lyndon','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.611022,-95.685015,0,'2013-07-06 12:44:33',NULL,NULL),(55951,'64487','S','Quitman','A','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.290788,-95.073940,0,'2013-07-06 12:44:33',NULL,NULL),(55873,'64196','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.098923,-94.583366,0,'2013-07-06 12:44:33',NULL,NULL),(46254,'53010','S','Campbellsport','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.610388,-88.277922,0,'2013-07-06 12:44:32',NULL,NULL),(60259,'71446','S','Coopers','N','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.123769,-93.277892,0,'2013-07-06 12:44:33',NULL,NULL),(52984,'61436','S','Delong','A','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.875827,-90.156586,0,'2013-07-06 12:44:33',NULL,NULL),(48692,'55934','S','Eyota','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.022060,-92.276760,0,'2013-07-06 12:44:33',NULL,NULL),(69057,'83233','P','Dingle','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.229841,-111.280722,0,'2013-07-06 12:44:34',NULL,NULL),(43310,'48350','S','Davisburg','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.742927,-83.530899,0,'2013-07-06 12:44:32',NULL,NULL),(55930,'64469','S','Maysville','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.888652,-94.356601,0,'2013-07-06 12:44:33',NULL,NULL),(52959,'61421','S','Broadmoor','N','Stark','17175','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.177575,-89.653011,0,'2013-07-06 12:44:33',NULL,NULL),(37184,'41502','P','Pikeville','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.479655,-82.518774,0,'2013-07-06 12:44:32',NULL,NULL),(52378,'60623','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.846636,-87.717240,0,'2013-07-06 12:44:33',NULL,NULL),(50459,'58031','S','Alice','A','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.761371,-97.791535,0,'2013-07-06 12:44:33',NULL,NULL),(33853,'37997','U','Suntrust Bank','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.965412,-83.909511,0,'2013-07-06 12:44:32',NULL,NULL),(12713,'13152','S','Mandana','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.884340,-76.351260,0,'2013-07-06 12:44:30',NULL,NULL),(74983,'93446','S','Adelaide','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(45871,'52247','S','Williamstown','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.487300,-91.707929,0,'2013-07-06 12:44:32',NULL,NULL),(65243,'77457','P','Matagorda','D','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.696251,-95.970671,0,'2013-07-06 12:44:34',NULL,NULL),(58748,'68956','S','Kenesaw','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.625091,-98.657971,0,'2013-07-06 12:44:33',NULL,NULL),(19009,'19526','S','Windsor Castle','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(44409,'49826','P','Eben Junction','A','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.342560,-86.920968,0,'2013-07-06 12:44:32',NULL,NULL),(45303,'50836','S','Athlestan','N','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648229,-94.530783,0,'2013-07-06 12:44:32',NULL,NULL),(48607,'55787','S','Haugen','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.637586,-93.122746,0,'2013-07-06 12:44:33',NULL,NULL),(75328,'93778','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.747457,-119.790491,0,'2013-07-06 12:44:34',NULL,NULL),(25534,'28401','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.229055,-77.935953,0,'2013-07-06 12:44:31',NULL,NULL),(9090,'09053','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(41636,'47132','U','Bureau of the Census','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287784,-85.731015,0,'2013-07-06 12:44:32',NULL,NULL),(52851,'61323','P','Dover','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.363716,-89.398570,0,'2013-07-06 12:44:33',NULL,NULL),(71331,'86507','P','Greasewood Springs','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.432600,-109.238820,0,'2013-07-06 12:44:34',NULL,NULL),(65625,'77962','S','Ganado','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',29.038785,-96.513009,0,'2013-07-06 12:44:34',NULL,NULL),(22971,'24724','S','Coaldale','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.363056,-81.334444,0,'2013-07-06 12:44:31',NULL,NULL),(16264,'17089','U','Blue Shield','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.253878,-76.927333,0,'2013-07-06 12:44:31',NULL,NULL),(44861,'50278','S','Zearing','D','Story','19169','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.161300,-93.307580,0,'2013-07-06 12:44:32',NULL,NULL),(72551,'89195','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.205334,-115.223749,0,'2013-07-06 12:44:34',NULL,NULL),(76759,'95925','S','Challenge','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.467748,-121.207569,0,'2013-07-06 12:44:34',NULL,NULL),(14192,'14756','P','Maple Springs','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.196953,-79.424756,0,'2013-07-06 12:44:31',NULL,NULL),(67237,'79935','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.774787,-106.332818,0,'2013-07-06 12:44:34',NULL,NULL),(48752,'55972','S','St Charles','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.967246,-92.063039,0,'2013-07-06 12:44:33',NULL,NULL),(68160,'81004','S','Pueblo','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.226239,-104.660953,0,'2013-07-06 12:44:34',NULL,NULL),(38116,'43107','S','Hideaway Hls','A','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.696084,-82.422138,0,'2013-07-06 12:44:32',NULL,NULL),(69626,'83873','S','Wallace','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.396520,-115.949460,0,'2013-07-06 12:44:34',NULL,NULL),(68247,'81058','S','Manzanola','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.104620,-103.872321,0,'2013-07-06 12:44:34',NULL,NULL),(19047,'19540','S','Maple Grove Park','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(12625,'13090','S','Liverpool','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(64939,'77223','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.727156,-95.320928,0,'2013-07-06 12:44:34',NULL,NULL),(55683,'64056','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.118237,-94.347327,0,'2013-07-06 12:44:33',NULL,NULL),(52598,'61018','S','Dakota','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.405407,-89.549200,0,'2013-07-06 12:44:33',NULL,NULL),(34519,'38677','P','University of Mississippi','N','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.367390,-89.528956,0,'2013-07-06 12:44:32',NULL,NULL),(39345,'44622','S','Winfield','N','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.551120,-81.445800,0,'2013-07-06 12:44:32',NULL,NULL),(3262,'01462','S','Lunenburg','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.588874,-71.731381,0,'2013-07-06 12:44:30',NULL,NULL),(70057,'84141','U','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.668129,-111.861408,0,'2013-07-06 12:44:34',NULL,NULL),(69552,'83811','S','Cabinet','N','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.147478,-116.178280,0,'2013-07-06 12:44:34',NULL,NULL),(69439,'83643','S','Mesa','D','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.668855,-116.379583,0,'2013-07-06 12:44:34',NULL,NULL),(35551,'39564','S','Larue','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(70711,'85275','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.454213,-111.767337,0,'2013-07-06 12:44:34',NULL,NULL),(43495,'48621','S','Fairview','D','Oscoda','26135','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.723788,-84.037663,0,'2013-07-06 12:44:32',NULL,NULL),(71243,'86343','P','Crown King','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.219023,-112.305579,0,'2013-07-06 12:44:34',NULL,NULL),(15516,'16530','U','Erie Ins Exchange','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.132056,-80.083610,0,'2013-07-06 12:44:31',NULL,NULL),(31834,'35078','S','Harpersville','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.337983,-86.455431,0,'2013-07-06 12:44:32',NULL,NULL),(46406,'53172','S','S Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.909971,-87.866551,0,'2013-07-06 12:44:32',NULL,NULL),(2588,'00961','S','Qtas de Boulevar','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(65193,'77423','S','Pattison','A','Waller','48473','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.798940,-95.962284,0,'2013-07-06 12:44:34',NULL,NULL),(24718,'27508','S','Bunn','D','Franklin','37069','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.968540,-78.194646,0,'2013-07-06 12:44:31',NULL,NULL),(17914,'18456','S','Prompton','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.574877,-75.324430,0,'2013-07-06 12:44:31',NULL,NULL),(53156,'61562','P','Rome','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.880087,-89.503756,0,'2013-07-06 12:44:33',NULL,NULL),(27155,'29831','S','Dunbarton','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.343729,-81.807960,0,'2013-07-06 12:44:31',NULL,NULL),(14644,'15235','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445040,-79.913760,0,'2013-07-06 12:44:31',NULL,NULL),(23233,'25093','S','Gordon','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.993714,-81.681320,0,'2013-07-06 12:44:31',NULL,NULL),(21890,'23180','S','Water View','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.700809,-76.619083,0,'2013-07-06 12:44:31',NULL,NULL),(16676,'17362','S','Nashville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.874292,-76.864491,0,'2013-07-06 12:44:31',NULL,NULL),(52128,'60431','S','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.523431,-88.158761,0,'2013-07-06 12:44:33',NULL,NULL),(51801,'60047','S','Hawthorn Woods','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(42286,'47586','S','Scenic Heights','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(42232,'47567','S','Bowman','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(26246,'28903','P','Culberson','D','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',34.989954,-84.167688,0,'2013-07-06 12:44:31',NULL,NULL),(79010,'98388','S','Ketron Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.170637,-122.588055,0,'2013-07-06 12:44:34',NULL,NULL),(68415,'81201','S','Wellsville','N','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.533980,-106.038780,0,'2013-07-06 12:44:34',NULL,NULL),(68078,'80938','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.797690,-104.837067,0,'2013-07-06 12:44:34',NULL,NULL),(25069,'27939','S','Grandy','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.238287,-75.899405,0,'2013-07-06 12:44:31',NULL,NULL),(2827,'00979','S','Urb Palmar Norte','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(10179,'10282','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(19520,'20182','P','Nokesville','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.700206,-77.579071,0,'2013-07-06 12:44:31',NULL,NULL),(42430,'47802','S','Youngstown Acres','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(28754,'32003','S','Orange Park','A','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.106435,-81.711499,0,'2013-07-06 12:44:32',NULL,NULL),(73736,'91706','S','Irwindale','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.085581,-117.970122,0,'2013-07-06 12:44:34',NULL,NULL),(73787,'91746','S','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.049002,-117.979948,0,'2013-07-06 12:44:34',NULL,NULL),(77865,'97233','S','Rockwood','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.514315,-122.503676,0,'2013-07-06 12:44:34',NULL,NULL),(65987,'78336','S','Aransas Pass','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.904408,-97.160091,0,'2013-07-06 12:44:34',NULL,NULL),(19271,'19958','S','Lewes Beach','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.725800,-75.174180,0,'2013-07-06 12:44:31',NULL,NULL),(64561,'76656','S','Durango','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.076389,-97.109167,0,'2013-07-06 12:44:34',NULL,NULL),(60166,'71407','S','Bentley','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.483526,-92.497502,0,'2013-07-06 12:44:33',NULL,NULL),(76626,'95709','S','Eight Mile House','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.751360,-120.665040,0,'2013-07-06 12:44:34',NULL,NULL),(17458,'17946','P','Raven Run','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809304,-76.248260,0,'2013-07-06 12:44:31',NULL,NULL),(3722,'02149','S','Everett','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.411501,-71.052188,0,'2013-07-06 12:44:30',NULL,NULL),(18274,'19010','S','Bryn Mawr','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.026360,-75.334380,0,'2013-07-06 12:44:31',NULL,NULL),(1404,'00738','S','Urb Monte Brisas 3','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(30668,'33467','S','Green Acres','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.606929,-80.177700,0,'2013-07-06 12:44:32',NULL,NULL),(64987,'77275','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757451,-95.366785,0,'2013-07-06 12:44:34',NULL,NULL),(62260,'74006','S','Eastside','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.738109,-95.933260,0,'2013-07-06 12:44:33',NULL,NULL),(18792,'19381','P','West Chester','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.960448,-75.601924,0,'2013-07-06 12:44:31',NULL,NULL),(49604,'56758','S','Strandquist','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.454725,-96.453374,0,'2013-07-06 12:44:33',NULL,NULL),(35114,'39210','U','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.276055,-90.218261,0,'2013-07-06 12:44:32',NULL,NULL),(33746,'37843','S','Parrottsville','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.996437,-83.053565,0,'2013-07-06 12:44:32',NULL,NULL),(33331,'37150','S','Red Boiling Springs','D','Macon','47111','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.529731,-85.845293,0,'2013-07-06 12:44:32',NULL,NULL),(69976,'84120','S','W Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(11197,'11742','S','Holtsville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.810612,-73.043845,0,'2013-07-06 12:44:30',NULL,NULL),(12485,'12992','S','Sciota','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.780960,-73.505322,0,'2013-07-06 12:44:30',NULL,NULL),(71212,'86314','S','Prescott Valley','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.605746,-112.320979,0,'2013-07-06 12:44:34',NULL,NULL),(69082,'83251','S','Chilly','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.933380,-113.779500,0,'2013-07-06 12:44:34',NULL,NULL),(64370,'76528','S','Arnett','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(64195,'76246','P','Greenwood','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.378499,-97.474475,0,'2013-07-06 12:44:34',NULL,NULL),(59304,'70511','P','Abbeville','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.969682,-92.131840,0,'2013-07-06 12:44:33',NULL,NULL),(53451,'61910','S','Arcola','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.681798,-88.308311,0,'2013-07-06 12:44:33',NULL,NULL),(45129,'50569','S','Otho','D','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.430428,-94.162014,0,'2013-07-06 12:44:32',NULL,NULL),(23361,'25268','S','Minnora','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.709444,-81.098333,0,'2013-07-06 12:44:31',NULL,NULL),(27837,'30420','S','Aline','N','Tattnall','13267','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.256436,-82.124286,0,'2013-07-06 12:44:31',NULL,NULL),(32062,'35266','P','Vestavia','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.446847,-86.790162,0,'2013-07-06 12:44:32',NULL,NULL),(33865,'38011','S','Brighton','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.482116,-89.722391,0,'2013-07-06 12:44:32',NULL,NULL),(15171,'15926','S','Central City','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.102784,-78.812442,0,'2013-07-06 12:44:31',NULL,NULL),(79900,'99588','S','Glennallen','D','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.107707,-145.528461,0,'2013-07-06 12:44:34',NULL,NULL),(71531,'87125','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.093355,-106.642816,0,'2013-07-06 12:44:34',NULL,NULL),(70388,'84667','S','Wales','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.487834,-111.634109,0,'2013-07-06 12:44:34',NULL,NULL),(66841,'79116','P','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.213165,-101.885407,0,'2013-07-06 12:44:34',NULL,NULL),(49424,'56630','S','Quiring','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(37464,'41858','S','Oscaloosa','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.122402,-82.826576,0,'2013-07-06 12:44:32',NULL,NULL),(17184,'17820','S','Catawissa','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.944780,-76.447560,0,'2013-07-06 12:44:31',NULL,NULL),(17815,'18411','S','Clarks Green','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.484637,-75.709934,0,'2013-07-06 12:44:31',NULL,NULL),(41228,'46737','S','Fremont','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.721900,-84.920220,0,'2013-07-06 12:44:32',NULL,NULL),(42545,'47868','S','Poland','D','Owen','18119','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.450742,-86.974712,0,'2013-07-06 12:44:32',NULL,NULL),(45190,'50613','S','North Cedar','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(48612,'55791','P','Twig','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.895844,-92.356325,0,'2013-07-06 12:44:33',NULL,NULL),(73657,'91504','S','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203164,-118.327142,0,'2013-07-06 12:44:34',NULL,NULL),(64971,'77258','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.571123,-95.079244,0,'2013-07-06 12:44:34',NULL,NULL),(61985,'73196','U','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460523,-97.398837,0,'2013-07-06 12:44:33',NULL,NULL),(57113,'66222','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.023477,-94.648849,0,'2013-07-06 12:44:33',NULL,NULL),(46253,'53008','P','Brookfield','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.061990,-88.109637,0,'2013-07-06 12:44:32',NULL,NULL),(42618,'47904','S','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.428786,-86.875104,0,'2013-07-06 12:44:32',NULL,NULL),(17130,'17777','S','Goosetown','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.092752,-76.861603,0,'2013-07-06 12:44:31',NULL,NULL),(3110,'01230','S','New Marlborou','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(26062,'28693','S','Warrensville','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.461801,-81.554415,0,'2013-07-06 12:44:31',NULL,NULL),(15385,'16321','P','East Hickory','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.583889,-79.401944,0,'2013-07-06 12:44:31',NULL,NULL),(11701,'12164','S','Speculator','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.557902,-74.357613,0,'2013-07-06 12:44:30',NULL,NULL),(13756,'14126','P','Olcott','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.332652,-78.718556,0,'2013-07-06 12:44:31',NULL,NULL),(51242,'59071','S','Roscoe','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.377011,-109.424177,0,'2013-07-06 12:44:33',NULL,NULL),(42371,'47711','S','Evansville Dress Regional Ai','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(42051,'47446','S','Stonington','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(17654,'18078','S','Schnecksville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.678413,-75.609307,0,'2013-07-06 12:44:31',NULL,NULL),(18111,'18767','U','Social Security Admin Brm','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.249950,-75.875977,0,'2013-07-06 12:44:31',NULL,NULL),(19379,'20062','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901909,-77.036280,0,'2013-07-06 12:44:31',NULL,NULL),(19708,'20388','S','Washington Navy Yard','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878851,-76.991728,0,'2013-07-06 12:44:31',NULL,NULL),(31255,'33983','S','Port Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',27.003613,-82.013836,0,'2013-07-06 12:44:32',NULL,NULL),(12037,'12521','S','Craryville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.181320,-73.655640,0,'2013-07-06 12:44:30',NULL,NULL),(9329,'09742','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71750,'87544','S','Los Alamos','D','Los Alamos','35028','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.866912,-106.265556,0,'2013-07-06 12:44:34',NULL,NULL),(70010,'84125','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701548,-111.945910,0,'2013-07-06 12:44:34',NULL,NULL),(57161,'66282','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.953539,-94.688284,0,'2013-07-06 12:44:33',NULL,NULL),(55054,'63150','U','Bank of America','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.632631,-90.193043,0,'2013-07-06 12:44:33',NULL,NULL),(54144,'62565','S','Shelbyville','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.408284,-88.799436,0,'2013-07-06 12:44:33',NULL,NULL),(46509,'53259','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.036290,-87.912848,0,'2013-07-06 12:44:32',NULL,NULL),(40374,'45651','S','Mc Arthur','D','Vinton','39163','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.249907,-82.478264,0,'2013-07-06 12:44:32',NULL,NULL),(9133,'09211','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(11417,'11963','S','Bay Point','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.972440,-72.324540,0,'2013-07-06 12:44:30',NULL,NULL),(25397,'28278','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.101881,-81.024501,0,'2013-07-06 12:44:31',NULL,NULL),(17907,'18449','P','Orson','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.814594,-75.449971,0,'2013-07-06 12:44:31',NULL,NULL),(13090,'13470','S','Stratford','D','Fulton','36035','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.189457,-74.635488,0,'2013-07-06 12:44:30',NULL,NULL),(25513,'28384','S','Saint Pauls','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.802763,-78.975198,0,'2013-07-06 12:44:31',NULL,NULL),(43327,'48362','S','Orion','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.782837,-83.269237,0,'2013-07-06 12:44:32',NULL,NULL),(50605,'58254','S','Kloten','A','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.776680,-98.164800,0,'2013-07-06 12:44:33',NULL,NULL),(74835,'93239','S','Kettleman Cty','A','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.025098,-119.977456,0,'2013-07-06 12:44:34',NULL,NULL),(12546,'13040','S','Taylor','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.562547,-75.928525,0,'2013-07-06 12:44:30',NULL,NULL),(3410,'01705','P','Framingham','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.320250,-71.439495,0,'2013-07-06 12:44:30',NULL,NULL),(11927,'12424','S','East Jewett','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.235000,-74.145833,0,'2013-07-06 12:44:30',NULL,NULL),(24383,'27098','U','Rural Hall','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.229233,-80.304498,0,'2013-07-06 12:44:31',NULL,NULL),(11218,'11747','S','Dix Hills','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.803692,-73.402157,0,'2013-07-06 12:44:30',NULL,NULL),(23910,'26209','P','Slatyfork','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.387939,-80.064576,0,'2013-07-06 12:44:31',NULL,NULL),(48171,'55379','S','Prior Lake','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.791430,-93.516743,0,'2013-07-06 12:44:33',NULL,NULL),(49359,'56579','S','Rothsay','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.471961,-96.276350,0,'2013-07-06 12:44:33',NULL,NULL),(49660,'57003','S','Baltic','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.749361,-96.734130,0,'2013-07-06 12:44:33',NULL,NULL),(51708,'60009','P','Elk Grove Vlg','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.008382,-87.991526,0,'2013-07-06 12:44:33',NULL,NULL),(55809,'64141','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.085594,-94.585241,0,'2013-07-06 12:44:33',NULL,NULL),(9740,'10090','S','South Pole','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(60015,'71334','S','Spokane','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(55965,'64501','S','St Joseph','N','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.765162,-94.844255,0,'2013-07-06 12:44:33',NULL,NULL),(37912,'42633','S','Oil Valley','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(16690,'17371','P','York New Salem','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.901600,-76.791415,0,'2013-07-06 12:44:31',NULL,NULL),(33534,'37383','U','University of the South','N','Franklin','47051','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.201422,-85.923515,0,'2013-07-06 12:44:32',NULL,NULL),(27693,'30338','S','North Springs','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(27129,'29805','S','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.698508,-81.634909,0,'2013-07-06 12:44:31',NULL,NULL),(42626,'47906','S','West Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.495856,-86.967180,0,'2013-07-06 12:44:32',NULL,NULL),(69202,'83349','S','Richfield','D','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.054018,-114.149995,0,'2013-07-06 12:44:34',NULL,NULL),(72710,'89448','P','Zephyr Point','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(73606,'91393','P','North Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.230541,-118.466992,0,'2013-07-06 12:44:34',NULL,NULL),(36245,'40297','U','Pnc Bank','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254499,-85.761600,0,'2013-07-06 12:44:32',NULL,NULL),(9096,'09063','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(2141,'00924','S','Urb Luarca','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(4386,'03106','S','Hooksett','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.056574,-71.448553,0,'2013-07-06 12:44:30',NULL,NULL),(38621,'43913','S','Brilliant','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.263036,-80.629993,0,'2013-07-06 12:44:32',NULL,NULL),(57096,'66219','S','Lenexa','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.965992,-94.764646,0,'2013-07-06 12:44:33',NULL,NULL),(5278,'04497','S','Glenwood Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(9722,'10081','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710424,-74.006157,0,'2013-07-06 12:44:30',NULL,NULL),(37303,'41636','S','Buckingham','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.390254,-82.729050,0,'2013-07-06 12:44:32',NULL,NULL),(34422,'38637','S','Jago','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.950244,-90.037659,0,'2013-07-06 12:44:32',NULL,NULL),(2667,'00966','S','Urb Susan CT','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(31994,'35223','S','Mountain Brk','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489469,-86.741202,0,'2013-07-06 12:44:32',NULL,NULL),(48535,'55751','S','McDavitt','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.403605,-92.653616,0,'2013-07-06 12:44:33',NULL,NULL),(49719,'57039','S','Naomi','N','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.353196,-96.892740,0,'2013-07-06 12:44:33',NULL,NULL),(21989,'23269','U','Div Motor Veh','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557901,-77.467640,0,'2013-07-06 12:44:31',NULL,NULL),(17215,'17824','S','Fisherdale','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.864589,-76.553163,0,'2013-07-06 12:44:31',NULL,NULL),(54961,'63121','S','Bel Nor','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(28760,'32006','P','Orange Park','A','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.157247,-81.704123,0,'2013-07-06 12:44:32',NULL,NULL),(21969,'23241','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.585084,-77.420677,0,'2013-07-06 12:44:31',NULL,NULL),(8569,'08214','P','North Dennis','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.191334,-74.824104,0,'2013-07-06 12:44:30',NULL,NULL),(17402,'17901','S','North Manheim','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(47913,'55110','S','Lino Lakes','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(53399,'61825','P','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.108793,-88.243278,0,'2013-07-06 12:44:33',NULL,NULL),(62947,'75102','S','Barry','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.086692,-96.709496,0,'2013-07-06 12:44:33',NULL,NULL),(64791,'77013','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.795292,-95.239790,0,'2013-07-06 12:44:34',NULL,NULL),(37308,'41642','S','Ivel','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.599644,-82.661820,0,'2013-07-06 12:44:32',NULL,NULL),(2910,'01001','S','Agawam','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.071523,-72.624257,0,'2013-07-06 12:44:30',NULL,NULL),(73510,'91337','P','Reseda','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.202639,-118.534607,0,'2013-07-06 12:44:34',NULL,NULL),(71096,'85936','S','St Johns','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.506335,-109.378069,0,'2013-07-06 12:44:34',NULL,NULL),(71065,'85757','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.136300,-111.086100,0,'2013-07-06 12:44:34',NULL,NULL),(50088,'57467','S','Orient','D','Hand','46059','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.835346,-99.110013,0,'2013-07-06 12:44:33',NULL,NULL),(38308,'43357','S','West Liberty','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.265708,-83.737998,0,'2013-07-06 12:44:32',NULL,NULL),(25686,'28522','P','Comfort','D','Jones','37103','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.003386,-77.522269,0,'2013-07-06 12:44:31',NULL,NULL),(19944,'20575','U','Adv Comm Inter Govt Relation','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899437,-77.041181,0,'2013-07-06 12:44:31',NULL,NULL),(24732,'27520','S','Whitley Heights','N','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.636282,-78.444815,0,'2013-07-06 12:44:31',NULL,NULL),(70528,'85012','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.512706,-112.066178,0,'2013-07-06 12:44:34',NULL,NULL),(38547,'43754','S','Sycamore Valley','A','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.762764,-81.237672,0,'2013-07-06 12:44:32',NULL,NULL),(1341,'00736','S','Bo Vegas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(70683,'85251','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.493889,-111.922875,0,'2013-07-06 12:44:34',NULL,NULL),(68362,'81137','S','Allison','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(67570,'80301','S','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.045435,-105.213243,0,'2013-07-06 12:44:34',NULL,NULL),(8692,'08345','S','Newport','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.288657,-75.149130,0,'2013-07-06 12:44:30',NULL,NULL),(34994,'39111','S','Sanitorium','N','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.872919,-89.734963,0,'2013-07-06 12:44:32',NULL,NULL),(34718,'38838','S','Moores Mill','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.561800,-88.204080,0,'2013-07-06 12:44:32',NULL,NULL),(33267,'37095','S','Liberty','D','DeKalb','47041','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.006120,-85.970822,0,'2013-07-06 12:44:32',NULL,NULL),(32756,'36346','S','Jack','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.596944,-85.913611,0,'2013-07-06 12:44:32',NULL,NULL),(6663,'06027','S','East Hartland','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',42.004268,-72.936417,0,'2013-07-06 12:44:30',NULL,NULL),(43743,'49003','P','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.312389,-85.682295,0,'2013-07-06 12:44:32',NULL,NULL),(48534,'55751','S','Iron Junction','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.403605,-92.653616,0,'2013-07-06 12:44:33',NULL,NULL),(54947,'63116','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.582028,-90.264153,0,'2013-07-06 12:44:33',NULL,NULL),(66989,'79491','U','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.504419,-101.877558,0,'2013-07-06 12:44:34',NULL,NULL),(6786,'06106','S','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.746680,-72.696298,0,'2013-07-06 12:44:30',NULL,NULL),(75609,'94402','S','San Mateo','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.546272,-122.329933,0,'2013-07-06 12:44:34',NULL,NULL),(73610,'91396','P','Canoga Park','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.210263,-118.570594,0,'2013-07-06 12:44:34',NULL,NULL),(58789,'68978','S','Superior','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.020913,-98.064163,0,'2013-07-06 12:44:33',NULL,NULL),(52513,'60805','S','Evergreen Pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.722096,-87.702938,0,'2013-07-06 12:44:33',NULL,NULL),(34593,'38745','P','Grace','D','Issaquena','28055','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.823937,-91.044092,0,'2013-07-06 12:44:32',NULL,NULL),(33927,'38058','S','Munford','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.448981,-89.807405,0,'2013-07-06 12:44:32',NULL,NULL),(2574,'00959','S','Villa Rica','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(31323,'34120','S','Naples','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.312625,-81.596577,0,'2013-07-06 12:44:32',NULL,NULL),(10681,'11206','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.703008,-73.943208,0,'2013-07-06 12:44:30',NULL,NULL),(17274,'17844','S','Red Bank','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(40496,'45802','P','Lima','D','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.741048,-84.174464,0,'2013-07-06 12:44:32',NULL,NULL),(380,'00660','S','Urb Montebello','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(78310,'97908','S','Ironside','D','Malheur','41045','Oregon','OR','41','0000','541','Mountain',-7.0,'Y',44.359632,-117.832776,0,'2013-07-06 12:44:34',NULL,NULL),(77890,'97283','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.537884,-122.654515,0,'2013-07-06 12:44:34',NULL,NULL),(73176,'90312','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.960629,-118.350216,0,'2013-07-06 12:44:34',NULL,NULL),(69519,'83724','U','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.618309,-116.195538,0,'2013-07-06 12:44:34',NULL,NULL),(68450,'81227','P','Monarch','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.532188,-105.998639,0,'2013-07-06 12:44:34',NULL,NULL),(55389,'63628','S','Bonne Terre','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.915562,-90.589053,0,'2013-07-06 12:44:33',NULL,NULL),(13447,'13776','S','Butternuts','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.434400,-75.362580,0,'2013-07-06 12:44:31',NULL,NULL),(13025,'13428','S','Palatine Bridge','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.909641,-74.574370,0,'2013-07-06 12:44:30',NULL,NULL),(18034,'18654','P','Shawanese','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.353444,-76.051413,0,'2013-07-06 12:44:31',NULL,NULL),(41517,'46978','S','Royal Center','D','Cass','18017','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.857298,-86.491253,0,'2013-07-06 12:44:32',NULL,NULL),(52701,'61109','S','New Milford','N','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.194700,-89.062680,0,'2013-07-06 12:44:33',NULL,NULL),(9121,'09138','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(61208,'72303','P','West Memphis','D','Crittenden','05035','Arkansas','AR','05','4920','870','Central',-6.0,'Y',35.147010,-90.185924,0,'2013-07-06 12:44:33',NULL,NULL),(51848,'60072','S','Ringwood','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.408534,-88.298655,0,'2013-07-06 12:44:33',NULL,NULL),(35895,'40009','S','Bradfordsville','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.421874,-85.166763,0,'2013-07-06 12:44:32',NULL,NULL),(78513,'98117','S','Crown Hill','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.686273,-122.380393,0,'2013-07-06 12:44:34',NULL,NULL),(74520,'92650','P','Irvine','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.679458,-117.760857,0,'2013-07-06 12:44:34',NULL,NULL),(71925,'87830','S','Cruzville','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652664,-108.764998,0,'2013-07-06 12:44:34',NULL,NULL),(58788,'68978','S','Cadams','N','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.020913,-98.064163,0,'2013-07-06 12:44:33',NULL,NULL),(57233,'66514','S','Milford','D','Geary','20061','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.173318,-96.914453,0,'2013-07-06 12:44:33',NULL,NULL),(15637,'16728','S','De Young','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.574389,-78.912109,0,'2013-07-06 12:44:31',NULL,NULL),(26718,'29415','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.027502,-80.046168,0,'2013-07-06 12:44:31',NULL,NULL),(53469,'61930','S','Hindsboro','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.686989,-88.133993,0,'2013-07-06 12:44:33',NULL,NULL),(12361,'12901','S','South Plattsburgh','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.727960,-73.463100,0,'2013-07-06 12:44:30',NULL,NULL),(78846,'98337','S','Gorst','A','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.570043,-122.637038,0,'2013-07-06 12:44:34',NULL,NULL),(76201,'95356','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.700102,-121.032875,0,'2013-07-06 12:44:34',NULL,NULL),(75576,'94279','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585681,-121.494555,0,'2013-07-06 12:44:34',NULL,NULL),(69340,'83537','S','Kendrick','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.643793,-116.541608,0,'2013-07-06 12:44:34',NULL,NULL),(67417,'80136','S','Strasburg','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.751552,-104.331296,0,'2013-07-06 12:44:34',NULL,NULL),(63588,'75784','S','Reklaw','D','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.905784,-95.017688,0,'2013-07-06 12:44:34',NULL,NULL),(11635,'12121','S','Melrose','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.843234,-73.618514,0,'2013-07-06 12:44:30',NULL,NULL),(32321,'35763','S','Owens Cross Roads','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.610433,-86.463316,0,'2013-07-06 12:44:32',NULL,NULL),(28493,'31522','S','Saint Simons Is','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.165091,-81.384700,0,'2013-07-06 12:44:32',NULL,NULL),(24634,'27371','S','Flint Hill','N','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.367660,-79.858140,0,'2013-07-06 12:44:31',NULL,NULL),(6509,'05821','S','Barnet Center','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.314722,-72.166389,0,'2013-07-06 12:44:30',NULL,NULL),(2548,'00959','S','Parq San Miguel','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(19957,'20581','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.891213,-77.044910,0,'2013-07-06 12:44:31',NULL,NULL),(43370,'48415','S','Birch Run','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.266718,-83.792556,0,'2013-07-06 12:44:32',NULL,NULL),(49210,'56461','S','Laporte','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.227020,-94.766880,0,'2013-07-06 12:44:33',NULL,NULL),(51314,'59243','S','Lambert','D','Richland','30083','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.757632,-104.736737,0,'2013-07-06 12:44:33',NULL,NULL),(53181,'61604','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(55086,'63199','U','USPS Inspection Service','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.645844,-90.331287,0,'2013-07-06 12:44:33',NULL,NULL),(55211,'63390','S','Wright City','D','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.804920,-91.039421,0,'2013-07-06 12:44:33',NULL,NULL),(59237,'70433','S','Covington','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.457687,-90.114529,0,'2013-07-06 12:44:33',NULL,NULL),(74516,'92648','S','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.677256,-118.005064,0,'2013-07-06 12:44:34',NULL,NULL),(67381,'80121','S','Greenwood Vlg','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(61916,'73148','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.452945,-97.551956,0,'2013-07-06 12:44:33',NULL,NULL),(60847,'72042','S','De Witt','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.292792,-91.337922,0,'2013-07-06 12:44:33',NULL,NULL),(55837,'64156','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.277465,-94.525144,0,'2013-07-06 12:44:33',NULL,NULL),(39026,'44143','S','Richmond Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(15440,'16401','S','Cherry Hill','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(5700,'04983','S','Freeman TWP','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.868494,-70.234780,0,'2013-07-06 12:44:30',NULL,NULL),(78541,'98138','P','Tukwila','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.474167,-122.259722,0,'2013-07-06 12:44:34',NULL,NULL),(76508,'95641','S','Andrus Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.145589,-121.598217,0,'2013-07-06 12:44:34',NULL,NULL),(26277,'29014','S','Woodward','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.573234,-80.987145,0,'2013-07-06 12:44:31',NULL,NULL),(24223,'26719','S','Fort Ashby','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.480227,-78.773099,0,'2013-07-06 12:44:31',NULL,NULL),(23238,'25108','S','Hewett','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.960781,-81.852506,0,'2013-07-06 12:44:31',NULL,NULL),(43956,'49307','S','Big Rapids','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.697737,-85.468184,0,'2013-07-06 12:44:32',NULL,NULL),(14871,'15466','P','Newell','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.071342,-79.888310,0,'2013-07-06 12:44:31',NULL,NULL),(74746,'93044','P','Port Hueneme','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.154211,-119.187956,0,'2013-07-06 12:44:34',NULL,NULL),(71897,'87746','S','Solano','D','Harding','35021','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.841481,-104.162543,0,'2013-07-06 12:44:34',NULL,NULL),(14267,'14845','S','Horseheads','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.180601,-76.841295,0,'2013-07-06 12:44:31',NULL,NULL),(14235,'14810','S','Veterans Admn','A','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.342030,-77.318938,0,'2013-07-06 12:44:31',NULL,NULL),(23417,'25337','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.348918,-81.624515,0,'2013-07-06 12:44:31',NULL,NULL),(17009,'17740','S','Jersey Shore','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(18190,'18934','S','Mechanicsville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.346630,-75.072109,0,'2013-07-06 12:44:31',NULL,NULL),(44789,'50222','S','Peru','D','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.204218,-93.942498,0,'2013-07-06 12:44:32',NULL,NULL),(50630,'58273','S','Pisek','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.279886,-97.709129,0,'2013-07-06 12:44:33',NULL,NULL),(52357,'60610','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.898992,-87.636455,0,'2013-07-06 12:44:33',NULL,NULL),(52486,'60695','U','Jp Morgan Chase','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.878332,-87.633108,0,'2013-07-06 12:44:33',NULL,NULL),(14005,'14521','S','Ovid','D','Seneca','36099','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.672490,-76.808623,0,'2013-07-06 12:44:31',NULL,NULL),(71853,'87701','S','Las Vegas','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.590200,-105.198120,0,'2013-07-06 12:44:34',NULL,NULL),(68893,'82720','S','New Haven','A','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.694848,-104.748765,0,'2013-07-06 12:44:34',NULL,NULL),(10808,'11374','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.727079,-73.861454,0,'2013-07-06 12:44:30',NULL,NULL),(4162,'02780','S','Taunton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.904134,-71.105920,0,'2013-07-06 12:44:30',NULL,NULL),(21737,'23025','S','Cardinal','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.420768,-76.382292,0,'2013-07-06 12:44:31',NULL,NULL),(8981,'08830','S','Iselin','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.571397,-74.314012,0,'2013-07-06 12:44:30',NULL,NULL),(69800,'84067','S','Roy','D','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.169960,-112.046185,0,'2013-07-06 12:44:34',NULL,NULL),(36151,'40241','S','Green Spring','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(33610,'37645','S','Church Hill','A','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.522222,-82.713611,0,'2013-07-06 12:44:32',NULL,NULL),(31703,'34950','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.442882,-80.343377,0,'2013-07-06 12:44:32',NULL,NULL),(8044,'07734','S','Ideal Beach','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.439051,-74.125510,0,'2013-07-06 12:44:30',NULL,NULL),(42521,'47854','S','Alta','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.763883,-87.410160,0,'2013-07-06 12:44:32',NULL,NULL),(43136,'48236','S','Grosse Pointe','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(51507,'59643','S','Toston','D','Broadwater','30007','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.175683,-111.481307,0,'2013-07-06 12:44:33',NULL,NULL),(55152,'63363','S','Prices Branch','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.894700,-91.517100,0,'2013-07-06 12:44:33',NULL,NULL),(68230,'81052','S','Lamar','D','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(74084,'92187','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.724875,-117.166229,0,'2013-07-06 12:44:34',NULL,NULL),(55284,'63472','S','Wayland','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.397041,-91.582082,0,'2013-07-06 12:44:33',NULL,NULL),(44952,'50391','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585461,-93.622417,0,'2013-07-06 12:44:32',NULL,NULL),(44590,'50042','S','Brayton','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.553383,-94.983495,0,'2013-07-06 12:44:32',NULL,NULL),(43801,'49060','S','Hickory Crnrs','A','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.436160,-85.400652,0,'2013-07-06 12:44:32',NULL,NULL),(15054,'15720','P','Brush Valley','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.535496,-79.061267,0,'2013-07-06 12:44:31',NULL,NULL),(32904,'36543','P','Huxford','D','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.217030,-87.461165,0,'2013-07-06 12:44:32',NULL,NULL),(5709,'04985','S','Moxie Gore Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.428213,-69.978255,0,'2013-07-06 12:44:30',NULL,NULL),(14610,'15226','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.396692,-80.015390,0,'2013-07-06 12:44:31',NULL,NULL),(76781,'95940','P','Oroville','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.511620,-121.556520,0,'2013-07-06 12:44:34',NULL,NULL),(51139,'58831','S','Charbonneau','N','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.855481,-103.642519,0,'2013-07-06 12:44:33',NULL,NULL),(50849,'58490','S','Verona','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.368792,-98.100113,0,'2013-07-06 12:44:33',NULL,NULL),(49916,'57314','S','Forestburg','A','Sanborn','46111','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.040260,-97.958503,0,'2013-07-06 12:44:33',NULL,NULL),(41855,'47353','S','Treaty Ln Mus','N','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.631241,-84.928586,0,'2013-07-06 12:44:32',NULL,NULL),(1726,'00778','S','Paseo de Santa Barbara','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(11049,'11572','S','Rvc','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.658611,-73.641667,0,'2013-07-06 12:44:30',NULL,NULL),(29377,'32605','S','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.680283,-82.372095,0,'2013-07-06 12:44:32',NULL,NULL),(24382,'27098','U','Hanes Brands Inc','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.229233,-80.304498,0,'2013-07-06 12:44:31',NULL,NULL),(79936,'99619','P','Uscgs','N','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.794070,-152.404070,0,'2013-07-06 12:44:34',NULL,NULL),(78195,'97733','S','Crescent','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.509329,-121.741618,0,'2013-07-06 12:44:34',NULL,NULL),(75347,'93907','S','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.757320,-121.668120,0,'2013-07-06 12:44:34',NULL,NULL),(26929,'29587','P','Surfside Bch','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.617875,-78.987929,0,'2013-07-06 12:44:31',NULL,NULL),(25295,'28139','S','Rutherfordton','D','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.378220,-81.977880,0,'2013-07-06 12:44:31',NULL,NULL),(17339,'17866','S','Ranshaw','A','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.786065,-76.555465,0,'2013-07-06 12:44:31',NULL,NULL),(46403,'53168','S','Salem','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.578640,-88.136640,0,'2013-07-06 12:44:32',NULL,NULL),(53727,'62246','S','Greenville','D','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(54944,'63114','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703764,-90.367077,0,'2013-07-06 12:44:33',NULL,NULL),(73663,'91510','P','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.173285,-118.345911,0,'2013-07-06 12:44:34',NULL,NULL),(74572,'92688','S','RSM','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.651232,-117.593834,0,'2013-07-06 12:44:34',NULL,NULL),(66575,'78742','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.234425,-97.672765,0,'2013-07-06 12:44:34',NULL,NULL),(64135,'76195','U','Colonial Financial','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.726738,-97.317356,0,'2013-07-06 12:44:34',NULL,NULL),(63757,'75941','S','Burke','A','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.187357,-94.786365,0,'2013-07-06 12:44:34',NULL,NULL),(52821,'61299','U','Rock Island','D','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.517464,-90.531148,0,'2013-07-06 12:44:33',NULL,NULL),(38906,'44118','S','E Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(19073,'19555','S','Shoemakersvle','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.496804,-75.955057,0,'2013-07-06 12:44:31',NULL,NULL),(22778,'24448','P','Iron Gate','D','Alleghany','51005','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.795875,-79.794086,0,'2013-07-06 12:44:31',NULL,NULL),(29213,'32413','S','Seacrest','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(26391,'29104','S','Mayesville','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.983524,-80.208008,0,'2013-07-06 12:44:31',NULL,NULL),(65037,'77327','S','Security','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(63143,'75371','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.791615,-96.772623,0,'2013-07-06 12:44:33',NULL,NULL),(61892,'73137','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.481011,-97.633607,0,'2013-07-06 12:44:33',NULL,NULL),(56374,'65218','U','Shelter Insurance','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.952596,-92.366496,0,'2013-07-06 12:44:33',NULL,NULL),(8824,'08620','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.178809,-74.659973,0,'2013-07-06 12:44:30',NULL,NULL),(22661,'24273','S','Norton','D','Norton City','51720','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.936315,-82.622842,0,'2013-07-06 12:44:31',NULL,NULL),(28309,'31131','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.705697,-84.547200,0,'2013-07-06 12:44:31',NULL,NULL),(42333,'47633','S','Stewartsville','N','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.155388,-87.775202,0,'2013-07-06 12:44:32',NULL,NULL),(44450,'49866','S','Negaunee','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.513209,-87.590554,0,'2013-07-06 12:44:32',NULL,NULL),(56044,'64725','S','Archie','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.482614,-94.355052,0,'2013-07-06 12:44:33',NULL,NULL),(63421,'75658','P','Joinerville','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.181680,-94.907333,0,'2013-07-06 12:44:33',NULL,NULL),(62814,'74948','S','Muldrow','D','Sequoyah','40135','Oklahoma','OK','40','2720','918','Central',-6.0,'Y',35.406109,-94.595446,0,'2013-07-06 12:44:33',NULL,NULL),(56390,'65236','S','Indian Grove','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.430800,-93.123900,0,'2013-07-06 12:44:33',NULL,NULL),(38976,'44130','S','Middlebrg Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(38617,'43909','P','Blaine','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.070954,-80.816073,0,'2013-07-06 12:44:32',NULL,NULL),(12419,'12943','S','Keene Valley','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.190442,-73.785574,0,'2013-07-06 12:44:30',NULL,NULL),(7302,'06604','S','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.180721,-73.192975,0,'2013-07-06 12:44:30',NULL,NULL),(72671,'89440','P','Gold Hill','N','Storey','32029','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.345624,-119.648752,0,'2013-07-06 12:44:34',NULL,NULL),(65612,'77954','S','Arneckeville','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(62374,'74076','P','Stillwater','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.123420,-97.031945,0,'2013-07-06 12:44:33',NULL,NULL),(59182,'70354','S','Galliano','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.431366,-90.291973,0,'2013-07-06 12:44:33',NULL,NULL),(49811,'57201','S','Rauville','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(14769,'15341','S','Holbrook','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.843791,-80.344220,0,'2013-07-06 12:44:31',NULL,NULL),(36195,'40259','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.254480,-85.759321,0,'2013-07-06 12:44:32',NULL,NULL),(3293,'01506','S','Brookfield','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.203252,-72.100050,0,'2013-07-06 12:44:30',NULL,NULL),(31580,'34653','S','New Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.248579,-82.701991,0,'2013-07-06 12:44:32',NULL,NULL),(11662,'12138','S','Petersburg','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.737100,-73.362660,0,'2013-07-06 12:44:30',NULL,NULL),(11460,'12008','S','Schenectady','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.854388,-73.904169,0,'2013-07-06 12:44:30',NULL,NULL),(20821,'21624','P','Claiborne','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.785000,-76.224722,0,'2013-07-06 12:44:31',NULL,NULL),(79026,'98391','S','Snag Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.187400,-122.164500,0,'2013-07-06 12:44:34',NULL,NULL),(73759,'91731','S','El Monte','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.076656,-118.040904,0,'2013-07-06 12:44:34',NULL,NULL),(72199,'88415','S','Clapham','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(50441,'58007','S','Ayr','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.020062,-97.579977,0,'2013-07-06 12:44:33',NULL,NULL),(20477,'21043','S','Ellicott','N','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.266016,-76.845513,0,'2013-07-06 12:44:31',NULL,NULL),(33521,'37377','S','Signal Mtn','A','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.147329,-85.330097,0,'2013-07-06 12:44:32',NULL,NULL),(31997,'35224','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.521022,-86.934710,0,'2013-07-06 12:44:32',NULL,NULL),(26482,'29161','S','Sardis','N','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.119660,-79.973820,0,'2013-07-06 12:44:31',NULL,NULL),(961,'00716','S','Urb Alhambra','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(892,'00704','S','Urb Gonzalez','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.251151,-66.101442,0,'2013-07-06 12:44:30',NULL,NULL),(37699,'42256','S','Quality','A','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.008924,-86.979116,0,'2013-07-06 12:44:32',NULL,NULL),(5853,'05141','S','Cambridgeport','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.151815,-72.567588,0,'2013-07-06 12:44:30',NULL,NULL),(78615,'98198','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.405098,-122.310024,0,'2013-07-06 12:44:34',NULL,NULL),(66985,'79457','U','City of Lubbock','N','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.584608,-101.851658,0,'2013-07-06 12:44:34',NULL,NULL),(63222,'75456','P','Mt Pleasant','A','Titus','48449','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.158187,-94.968045,0,'2013-07-06 12:44:33',NULL,NULL),(52925,'61370','S','Vermilionville','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.228820,-89.110860,0,'2013-07-06 12:44:33',NULL,NULL),(44737,'50162','S','Melbourne','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.929203,-93.067787,0,'2013-07-06 12:44:32',NULL,NULL),(76852,'95965','S','Pulga','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(48361,'55488','U','Minneapolis Tribune','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.981963,-93.265510,0,'2013-07-06 12:44:33',NULL,NULL),(47249,'54520','S','Crandon','D','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.568279,-88.904809,0,'2013-07-06 12:44:32',NULL,NULL),(9494,'10013','S','Chinatown','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(4751,'03843','P','Hampton Beach','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.940988,-70.825066,0,'2013-07-06 12:44:30',NULL,NULL),(23680,'25840','S','Wriston','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(21247,'22245','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.852066,-77.051486,0,'2013-07-06 12:44:31',NULL,NULL),(19158,'19717','S','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.713625,-75.740186,0,'2013-07-06 12:44:31',NULL,NULL),(37918,'42633','S','Slat','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(64653,'76799','U','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.531269,-97.192230,0,'2013-07-06 12:44:34',NULL,NULL),(60934,'72086','S','Wattensaw','N','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.788120,-91.948860,0,'2013-07-06 12:44:33',NULL,NULL),(52026,'60179','U','Schaumburg','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.079712,-88.224255,0,'2013-07-06 12:44:33',NULL,NULL),(49545,'56686','S','Birch Beach','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.977222,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(7886,'07522','S','Paterson','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.924122,-74.183291,0,'2013-07-06 12:44:30',NULL,NULL),(34972,'39083','S','Hazlehurst','D','Copiah','28029','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.865846,-90.387830,0,'2013-07-06 12:44:32',NULL,NULL),(58062,'68044','S','Nickerson','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.521374,-96.498540,0,'2013-07-06 12:44:33',NULL,NULL),(36373,'40456','S','Mount Vernon','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.358415,-84.346235,0,'2013-07-06 12:44:32',NULL,NULL),(4388,'03107','U','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.003767,-71.467549,0,'2013-07-06 12:44:30',NULL,NULL),(35240,'39328','S','De Kalb','D','Kemper','28069','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.774588,-88.662108,0,'2013-07-06 12:44:32',NULL,NULL),(31518,'34472','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.091917,-81.989320,0,'2013-07-06 12:44:32',NULL,NULL),(12226,'12812','S','Blue Mountain Lake','D','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.835368,-74.426553,0,'2013-07-06 12:44:30',NULL,NULL),(10768,'11364','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.746500,-73.761707,0,'2013-07-06 12:44:30',NULL,NULL),(53560,'62052','S','Jersey','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.135780,-90.333000,0,'2013-07-06 12:44:33',NULL,NULL),(79563,'99016','S','Greenacres','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.643255,-117.151477,0,'2013-07-06 12:44:34',NULL,NULL),(75025,'93502','P','Mojave','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.055697,-118.175526,0,'2013-07-06 12:44:34',NULL,NULL),(62782,'74873','S','Tecumseh','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.259960,-96.974340,0,'2013-07-06 12:44:33',NULL,NULL),(60690,'71935','S','Manfred','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.358611,-93.688611,0,'2013-07-06 12:44:33',NULL,NULL),(45144,'50579','S','Rockwell City','D','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(13030,'13433','S','Fowlersville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.588855,-75.279411,0,'2013-07-06 12:44:30',NULL,NULL),(12529,'13035','S','Cazenovia','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968760,-75.820020,0,'2013-07-06 12:44:30',NULL,NULL),(30297,'33280','P','Nmb','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.932022,-80.136421,0,'2013-07-06 12:44:32',NULL,NULL),(27204,'29905','P','Parris Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.343880,-80.665757,0,'2013-07-06 12:44:31',NULL,NULL),(76336,'95467','S','Hidden Valley Lake','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.810967,-122.556198,0,'2013-07-06 12:44:34',NULL,NULL),(73267,'90721','P','Los Alamitos','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.802254,-118.068984,0,'2013-07-06 12:44:34',NULL,NULL),(57937,'67736','S','Gove','D','Gove','20063','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.856239,-100.502060,0,'2013-07-06 12:44:33',NULL,NULL),(55895,'64432','S','Clyde','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.271216,-94.639774,0,'2013-07-06 12:44:33',NULL,NULL),(55451,'63730','S','Advance','D','Stoddard','29207','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.094820,-89.910060,0,'2013-07-06 12:44:33',NULL,NULL),(53406,'61832','S','Tilton','A','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.136438,-87.632393,0,'2013-07-06 12:44:33',NULL,NULL),(33264,'37090','S','Lebanon','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.152343,-86.315832,0,'2013-07-06 12:44:32',NULL,NULL),(8642,'08302','S','Bridgeton','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.438881,-75.228175,0,'2013-07-06 12:44:30',NULL,NULL),(25403,'28287','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.130178,-80.853682,0,'2013-07-06 12:44:31',NULL,NULL),(18860,'19441','U','Harleysville Insurance Co','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.278302,-75.390438,0,'2013-07-06 12:44:31',NULL,NULL),(41009,'46371','S','Rolling Pr','A','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.686889,-86.609518,0,'2013-07-06 12:44:32',NULL,NULL),(46741,'53916','S','South Beaver Dam','N','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.462045,-88.839358,0,'2013-07-06 12:44:32',NULL,NULL),(49629,'56933','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(13946,'14449','P','E Williamson','A','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.232738,-77.150121,0,'2013-07-06 12:44:31',NULL,NULL),(47520,'54806','S','Ashland','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(19016,'19529','S','Steinsville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(6434,'05745','P','Forestdale','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.829518,-73.054531,0,'2013-07-06 12:44:30',NULL,NULL),(12668,'13123','P','North Bay','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.228347,-75.748595,0,'2013-07-06 12:44:30',NULL,NULL),(1064,'00725','S','Ext Villa Blanca','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(1446,'00740','S','Puerto Real','D','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332837,-65.634129,0,'2013-07-06 12:44:30',NULL,NULL),(73193,'90506','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.885708,-118.329022,0,'2013-07-06 12:44:34',NULL,NULL),(64379,'76528','S','South Mountain','A','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(58574,'68828','S','Geranium','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.536564,-99.308281,0,'2013-07-06 12:44:33',NULL,NULL),(46774,'53951','S','North Freedom','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.429199,-89.850103,0,'2013-07-06 12:44:32',NULL,NULL),(45581,'51537','S','Harlan','D','Shelby','19165','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.651801,-95.327571,0,'2013-07-06 12:44:32',NULL,NULL),(28352,'31201','S','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.833817,-83.633712,0,'2013-07-06 12:44:32',NULL,NULL),(14774,'15347','P','Meadow Lands','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.215751,-80.230219,0,'2013-07-06 12:44:31',NULL,NULL),(34397,'38623','P','Darling','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.436854,-90.175508,0,'2013-07-06 12:44:32',NULL,NULL),(69246,'83423','S','Argora','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(52003,'60168','P','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.045434,-88.126629,0,'2013-07-06 12:44:33',NULL,NULL),(39995,'45242','S','Montgomery','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.245232,-84.353209,0,'2013-07-06 12:44:32',NULL,NULL),(37648,'42167','S','Tompkinsville','D','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(6153,'05469','P','Monkton','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.253950,-73.120952,0,'2013-07-06 12:44:30',NULL,NULL),(4772,'03860','S','Hales Location','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.041258,-71.131424,0,'2013-07-06 12:44:30',NULL,NULL),(36716,'41030','S','Bracht','N','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.769713,-84.573036,0,'2013-07-06 12:44:32',NULL,NULL),(34958,'39063','S','Durant','D','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.073783,-89.857157,0,'2013-07-06 12:44:32',NULL,NULL),(16661,'17353','S','Orrtanna','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.880603,-77.384367,0,'2013-07-06 12:44:31',NULL,NULL),(17008,'17740','S','Crawford','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(53459,'61917','S','Brocton','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.693347,-87.671412,0,'2013-07-06 12:44:33',NULL,NULL),(58171,'68198','U','University of Nebraska Medic','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.265996,-96.010026,0,'2013-07-06 12:44:33',NULL,NULL),(77255,'96551','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(73564,'91367','S','Woodland Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.178189,-118.623042,0,'2013-07-06 12:44:34',NULL,NULL),(70096,'84170','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.701243,-112.010773,0,'2013-07-06 12:44:34',NULL,NULL),(66968,'79406','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.580255,-101.880255,0,'2013-07-06 12:44:34',NULL,NULL),(65800,'78131','P','New Braunfels','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.714980,-98.143724,0,'2013-07-06 12:44:34',NULL,NULL),(37781,'42354','S','Mc Henry','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.382786,-86.925555,0,'2013-07-06 12:44:32',NULL,NULL),(31904,'35147','S','Westover','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.425188,-86.506690,0,'2013-07-06 12:44:32',NULL,NULL),(5813,'05070','S','So Strafford','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.833285,-72.377667,0,'2013-07-06 12:44:30',NULL,NULL),(39362,'44633','S','Holmesville','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.619690,-81.920167,0,'2013-07-06 12:44:32',NULL,NULL),(46814,'54006','S','Laketown','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.573120,-92.648880,0,'2013-07-06 12:44:32',NULL,NULL),(66724,'78954','S','Walhalla','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.054884,-96.755586,0,'2013-07-06 12:44:34',NULL,NULL),(15797,'16925','S','Mosherville','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.951700,-76.770180,0,'2013-07-06 12:44:31',NULL,NULL),(35969,'40077','S','Westport','D','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.485186,-85.451519,0,'2013-07-06 12:44:32',NULL,NULL),(4114,'02720','S','Fall River','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.716352,-71.138140,0,'2013-07-06 12:44:30',NULL,NULL),(27894,'30470','S','Tarrytown','D','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.290664,-82.525613,0,'2013-07-06 12:44:31',NULL,NULL),(39859,'45176','S','Crosstown','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.072060,-84.043331,0,'2013-07-06 12:44:32',NULL,NULL),(45037,'50472','S','Saint Ansgar','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.377784,-92.915665,0,'2013-07-06 12:44:32',NULL,NULL),(50750,'58402','P','Jamestwn','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.905091,-98.732378,0,'2013-07-06 12:44:33',NULL,NULL),(55892,'64429','S','Cameron','D','Clinton','29049','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.735615,-94.243823,0,'2013-07-06 12:44:33',NULL,NULL),(57536,'67019','S','Burden','D','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.321597,-96.753042,0,'2013-07-06 12:44:33',NULL,NULL),(64566,'76657','S','Mc Gregor','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.438425,-97.399576,0,'2013-07-06 12:44:34',NULL,NULL),(72234,'88510','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.809866,-106.416814,0,'2013-07-06 12:44:34',NULL,NULL),(77910,'97308','P','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.899188,-122.928252,0,'2013-07-06 12:44:34',NULL,NULL),(36364,'40447','S','New Zion','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(29388,'32612','U','University of FL','N','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.652878,-82.351153,0,'2013-07-06 12:44:32',NULL,NULL),(7915,'07631','S','Englewood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.894215,-73.977781,0,'2013-07-06 12:44:30',NULL,NULL),(11809,'12231','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.656061,-73.760129,0,'2013-07-06 12:44:30',NULL,NULL),(5317,'04570','P','Boothbay Hbr','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.807043,-69.634374,0,'2013-07-06 12:44:30',NULL,NULL),(17997,'18629','S','Mehoopany','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.490456,-76.155214,0,'2013-07-06 12:44:31',NULL,NULL),(39127,'44266','S','Campbellsport','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.159227,-81.233714,0,'2013-07-06 12:44:32',NULL,NULL),(49442,'56636','S','Oteneagen','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(53112,'61541','P','Bell Plain','N','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.982691,-89.238779,0,'2013-07-06 12:44:33',NULL,NULL),(15748,'16912','S','Blakes','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.679554,-77.064192,0,'2013-07-06 12:44:31',NULL,NULL),(69115,'83274','S','Jamestown','N','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.379837,-112.124740,0,'2013-07-06 12:44:34',NULL,NULL),(57318,'66701','S','Fort Scott','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.822740,-94.701540,0,'2013-07-06 12:44:33',NULL,NULL),(9691,'10045','S','Federal Reserve','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.690858,-74.011905,0,'2013-07-06 12:44:30',NULL,NULL),(27746,'30357','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.799057,-84.387174,0,'2013-07-06 12:44:31',NULL,NULL),(26963,'29609','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.897521,-82.398093,0,'2013-07-06 12:44:31',NULL,NULL),(51581,'59802','S','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.894225,-114.012626,0,'2013-07-06 12:44:33',NULL,NULL),(53190,'61607','S','Orchard Mines','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(58832,'69103','P','North Platte','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.136419,-100.767544,0,'2013-07-06 12:44:33',NULL,NULL),(59606,'71019','S','Harmon','A','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(77843,'97222','S','Oak Grove','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.437695,-122.614273,0,'2013-07-06 12:44:34',NULL,NULL),(79261,'98565','P','Napavine','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.573390,-122.912653,0,'2013-07-06 12:44:34',NULL,NULL),(8352,'08048','S','Lumberton','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.956414,-74.804349,0,'2013-07-06 12:44:30',NULL,NULL),(27380,'30076','S','Roswell','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.026099,-84.311677,0,'2013-07-06 12:44:31',NULL,NULL),(23827,'26103','P','Parkersburg','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.248270,-81.557201,0,'2013-07-06 12:44:31',NULL,NULL),(40942,'46296','U','USPS Symbol Repair','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.770156,-86.161029,0,'2013-07-06 12:44:32',NULL,NULL),(46773,'53950','S','New Lisbon','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.886478,-90.153790,0,'2013-07-06 12:44:32',NULL,NULL),(50166,'57552','S','Moenville','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(54346,'62776','U','IL Dept Revenue','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.802184,-89.654242,0,'2013-07-06 12:44:33',NULL,NULL),(66618,'78773','U','Dept of Public Safety','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.331091,-97.706506,0,'2013-07-06 12:44:34',NULL,NULL),(62834,'75002','S','Lucas','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.087120,-96.616980,0,'2013-07-06 12:44:33',NULL,NULL),(59083,'70121','S','Jefferson','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.964212,-90.156847,0,'2013-07-06 12:44:33',NULL,NULL),(15641,'16731','S','Eldred','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.950881,-78.380230,0,'2013-07-06 12:44:31',NULL,NULL),(13394,'13747','P','Colliersville','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.492615,-74.982708,0,'2013-07-06 12:44:31',NULL,NULL),(44684,'50125','S','Indianola','D','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.315040,-93.572040,0,'2013-07-06 12:44:32',NULL,NULL),(42235,'47567','S','Logan','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(8376,'08054','S','Rancocas Woods','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.946438,-74.915955,0,'2013-07-06 12:44:30',NULL,NULL),(10217,'10457','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.846394,-73.902732,0,'2013-07-06 12:44:30',NULL,NULL),(9470,'10009','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724608,-73.980332,0,'2013-07-06 12:44:30',NULL,NULL),(19162,'19720','S','Minquadale','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.673263,-75.595423,0,'2013-07-06 12:44:31',NULL,NULL),(39571,'44851','S','Ruggles','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.101292,-82.421414,0,'2013-07-06 12:44:32',NULL,NULL),(12145,'12733','S','Fallsburg','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.735601,-74.613484,0,'2013-07-06 12:44:30',NULL,NULL),(24615,'27341','S','Seagrove','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.398446,-79.783082,0,'2013-07-06 12:44:31',NULL,NULL),(67958,'80913','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(6390,'05701','S','South Chittenden','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(63635,'75840','S','Grindstone','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.722324,-96.157345,0,'2013-07-06 12:44:34',NULL,NULL),(10369,'10588','S','Shrub Oak','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.330384,-73.834120,0,'2013-07-06 12:44:30',NULL,NULL),(62177,'73754','S','Lahoma','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.385915,-98.094738,0,'2013-07-06 12:44:33',NULL,NULL),(68070,'80936','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.906063,-104.753199,0,'2013-07-06 12:44:34',NULL,NULL),(42674,'47967','S','New Richmond','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.196107,-86.980031,0,'2013-07-06 12:44:32',NULL,NULL),(44250,'49674','P','Omena','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.063163,-85.621512,0,'2013-07-06 12:44:32',NULL,NULL),(12694,'13140','S','Conquest','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.052760,-76.655280,0,'2013-07-06 12:44:30',NULL,NULL),(67127,'79749','S','Lenorah','D','Martin','48317','Texas','TX','48','0000','432','Central',-6.0,'Y',32.409782,-101.784514,0,'2013-07-06 12:44:34',NULL,NULL),(18883,'19462','S','Plymouth Mtng','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.108511,-75.277184,0,'2013-07-06 12:44:31',NULL,NULL),(62742,'74833','S','Welty','A','Okfuskee','40107','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.481185,-96.369933,0,'2013-07-06 12:44:33',NULL,NULL),(50571,'58222','S','Crystal','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.586179,-97.666904,0,'2013-07-06 12:44:33',NULL,NULL),(69982,'84121','S','Cottonwood Heights','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(23367,'25275','S','Sandyville','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.903607,-81.639896,0,'2013-07-06 12:44:31',NULL,NULL),(23333,'25244','S','Gay','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.797281,-81.573705,0,'2013-07-06 12:44:31',NULL,NULL),(6949,'06183','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.764012,-72.685950,0,'2013-07-06 12:44:30',NULL,NULL),(4213,'02837','S','L Compton','A','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.511254,-71.170707,0,'2013-07-06 12:44:30',NULL,NULL),(25143,'28018','S','Sunshine','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(55548,'63849','S','Gobler','D','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.156209,-89.934704,0,'2013-07-06 12:44:33',NULL,NULL),(39379,'44646','S','Massillon','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.802818,-81.520846,0,'2013-07-06 12:44:32',NULL,NULL),(64752,'76932','S','Texon','A','Reagan','48383','Texas','TX','48','0000','325','Central',-6.0,'Y',31.212019,-101.463340,0,'2013-07-06 12:44:34',NULL,NULL),(50582,'58233','S','Conway','N','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.237188,-97.447403,0,'2013-07-06 12:44:33',NULL,NULL),(27820,'30401','S','Wesley','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(9757,'10102','U','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(25927,'28652','P','Minneapolis','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.099899,-81.987145,0,'2013-07-06 12:44:31',NULL,NULL),(2216,'00926','S','Urb Caldas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(64300,'76458','S','Jacksboro','D','Jack','48237','Texas','TX','48','0000','940','Central',-6.0,'Y',33.302798,-98.156777,0,'2013-07-06 12:44:34',NULL,NULL),(19387,'20066','U','Washington DC Post Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918215,-76.995482,0,'2013-07-06 12:44:31',NULL,NULL),(69321,'83468','P','Tendoy','D','Lemhi','16059','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.960904,-113.641348,0,'2013-07-06 12:44:34',NULL,NULL),(44074,'49445','S','North Muskegon','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.293180,-86.282880,0,'2013-07-06 12:44:32',NULL,NULL),(3539,'01910','U','General Elec Co','N','Essex','25009','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.473328,-70.961315,0,'2013-07-06 12:44:30',NULL,NULL),(75602,'94304','S','Palo Alto','D','Santa Clara','06085','California','CA','06','7400','650','Pacific',-8.0,'Y',37.408130,-122.158663,0,'2013-07-06 12:44:34',NULL,NULL),(60147,'71375','S','Helena','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(23030,'24846','S','Isaban','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.528355,-81.886920,0,'2013-07-06 12:44:31',NULL,NULL),(36490,'40807','P','Benham','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.967225,-82.956333,0,'2013-07-06 12:44:32',NULL,NULL),(68597,'81601','S','West Glenwood','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.528426,-107.338503,0,'2013-07-06 12:44:34',NULL,NULL),(64751,'76932','S','Big Lake','D','Reagan','48383','Texas','TX','48','0000','325','Central',-6.0,'Y',31.212019,-101.463340,0,'2013-07-06 12:44:34',NULL,NULL),(63246,'75480','S','Scroggins','D','Franklin','48159','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.066811,-95.203665,0,'2013-07-06 12:44:33',NULL,NULL),(49760,'57067','S','Janesville','N','Yankton','46135','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.962076,-97.507277,0,'2013-07-06 12:44:33',NULL,NULL),(68281,'81082','S','Sopris','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(39552,'44843','S','Lucas','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.691000,-82.404305,0,'2013-07-06 12:44:32',NULL,NULL),(35860,'39828','S','Cairo','D','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.874451,-84.209360,0,'2013-07-06 12:44:32',NULL,NULL),(70040,'84134','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.774204,-111.946340,0,'2013-07-06 12:44:34',NULL,NULL),(63981,'76108','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.781540,-97.503780,0,'2013-07-06 12:44:34',NULL,NULL),(49541,'56682','S','Swift','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.840032,-95.286441,0,'2013-07-06 12:44:33',NULL,NULL),(11504,'12025','S','North Broadalbin','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(12761,'13208','S','Lyncourt','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.072766,-76.147309,0,'2013-07-06 12:44:30',NULL,NULL),(36659,'41008','S','English','N','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.677051,-85.169553,0,'2013-07-06 12:44:32',NULL,NULL),(70492,'84772','P','Summit','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.797218,-112.942812,0,'2013-07-06 12:44:34',NULL,NULL),(70243,'84407','U','Defense Depot Ogden','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.243163,-111.967258,0,'2013-07-06 12:44:34',NULL,NULL),(10191,'10301','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.628781,-74.094599,0,'2013-07-06 12:44:30',NULL,NULL),(62697,'74735','S','Fort Towson','D','Choctaw','40023','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.049200,-95.260121,0,'2013-07-06 12:44:33',NULL,NULL),(46643,'53596','U','General Casualty Co','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.195587,-89.264013,0,'2013-07-06 12:44:32',NULL,NULL),(10834,'11385','S','Fresh Pond','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.702860,-73.879740,0,'2013-07-06 12:44:30',NULL,NULL),(72362,'89025','P','Moapa','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.691114,-114.592630,0,'2013-07-06 12:44:34',NULL,NULL),(17568,'18003','U','Business Reply Mail','N','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.644716,-75.434684,0,'2013-07-06 12:44:31',NULL,NULL),(2755,'00969','S','Urb Tierra Alta II','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(41260,'46747','S','Hudson','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.531111,-85.170278,0,'2013-07-06 12:44:32',NULL,NULL),(69149,'83313','S','Gannett','A','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.414624,-114.198990,0,'2013-07-06 12:44:34',NULL,NULL),(48440,'55704','S','Partridge','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.272907,-92.812752,0,'2013-07-06 12:44:33',NULL,NULL),(55994,'64639','S','De Witt','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.350890,-93.296628,0,'2013-07-06 12:44:33',NULL,NULL),(55070,'63171','U','Laclede Gas Co','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.597715,-90.326395,0,'2013-07-06 12:44:33',NULL,NULL),(65461,'77622','S','Hamshire','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.879658,-94.312970,0,'2013-07-06 12:44:34',NULL,NULL),(51198,'59032','S','Grass Range','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.991910,-108.902070,0,'2013-07-06 12:44:33',NULL,NULL),(267,'00641','S','Urb Perez Matos','N','Utuado','72141','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.268891,-66.704425,0,'2013-07-06 12:44:30',NULL,NULL),(76350,'95480','S','Stewarts Point','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.619693,-123.377331,0,'2013-07-06 12:44:34',NULL,NULL),(7253,'06515','S','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.327559,-72.966874,0,'2013-07-06 12:44:30',NULL,NULL),(33981,'38113','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.209681,-89.996175,0,'2013-07-06 12:44:32',NULL,NULL),(42986,'48151','P','Livonia','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.396016,-83.371538,0,'2013-07-06 12:44:32',NULL,NULL),(4929,'04082','P','South Windham','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.733601,-70.441554,0,'2013-07-06 12:44:30',NULL,NULL),(49962,'57350','S','Broadland','N','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.359540,-98.217645,0,'2013-07-06 12:44:33',NULL,NULL),(37567,'42071','S','Van Cleve','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.618300,-88.251060,0,'2013-07-06 12:44:32',NULL,NULL),(35724,'39669','S','Turnbull','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(4542,'03446','S','East Swanzey','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.854142,-72.260794,0,'2013-07-06 12:44:30',NULL,NULL),(71354,'86520','P','Pinon','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.065671,-110.084930,0,'2013-07-06 12:44:34',NULL,NULL),(63451,'75681','S','Mt Enterprise','A','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.909489,-94.613298,0,'2013-07-06 12:44:33',NULL,NULL),(26025,'28679','S','Amantha','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.273480,-81.876420,0,'2013-07-06 12:44:31',NULL,NULL),(958,'00716','S','Sect los Potes','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(18381,'19047','S','Langhorne','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.179301,-74.905397,0,'2013-07-06 12:44:31',NULL,NULL),(44880,'50314','S','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.604631,-93.634646,0,'2013-07-06 12:44:32',NULL,NULL),(78336,'98003','S','Federal Way','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.309940,-122.313900,0,'2013-07-06 12:44:34',NULL,NULL),(78926,'98366','S','Lake Holiday','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(64315,'76474','S','Sidney','D','Comanche','48093','Texas','TX','48','0000','254','Central',-6.0,'Y',31.930933,-98.773630,0,'2013-07-06 12:44:34',NULL,NULL),(13021,'13425','S','Oriskany Falls','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.939058,-75.459424,0,'2013-07-06 12:44:30',NULL,NULL),(4016,'02561','P','Sagamore','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.771196,-70.539161,0,'2013-07-06 12:44:30',NULL,NULL),(63788,'75956','S','Magnolia Springs','A','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(7263,'06518','S','Hamden','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.415836,-72.912377,0,'2013-07-06 12:44:30',NULL,NULL),(5999,'05356','S','Mount Snow','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.933333,-72.833333,0,'2013-07-06 12:44:30',NULL,NULL),(14542,'15209','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.496241,-79.979064,0,'2013-07-06 12:44:31',NULL,NULL),(24363,'27049','P','Toast','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.496244,-80.632927,0,'2013-07-06 12:44:31',NULL,NULL),(15639,'16730','P','E Smethport','A','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.809560,-78.417600,0,'2013-07-06 12:44:31',NULL,NULL),(80019,'99681','P','Tununak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.604290,-164.760278,0,'2013-07-06 12:44:34',NULL,NULL),(77001,'96079','P','Project City','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.691415,-122.344769,0,'2013-07-06 12:44:34',NULL,NULL),(20675,'21231','S','Patterson','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.290195,-76.593956,0,'2013-07-06 12:44:31',NULL,NULL),(38965,'44128','S','Garfield Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(39007,'44139','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.392321,-81.444888,0,'2013-07-06 12:44:32',NULL,NULL),(66650,'78843','S','Del Rio','A','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.361815,-100.894575,0,'2013-07-06 12:44:34',NULL,NULL),(47044,'54410','S','Bethel','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542991,-90.047517,0,'2013-07-06 12:44:32',NULL,NULL),(74275,'92354','S','Loma Linda','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.052344,-117.250346,0,'2013-07-06 12:44:34',NULL,NULL),(27208,'29907','S','Ladys Island','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.427269,-80.702200,0,'2013-07-06 12:44:31',NULL,NULL),(23623,'25719','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.423022,-82.440755,0,'2013-07-06 12:44:31',NULL,NULL),(61225,'72326','S','Colt','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.102623,-90.769590,0,'2013-07-06 12:44:33',NULL,NULL),(43733,'48937','U','Consumers Energy','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.783292,-84.571296,0,'2013-07-06 12:44:32',NULL,NULL),(31623,'34691','S','Tarpon Spgs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.192041,-82.754164,0,'2013-07-06 12:44:32',NULL,NULL),(24444,'27214','S','Brightwood','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.200700,-79.677720,0,'2013-07-06 12:44:31',NULL,NULL),(54971,'63122','S','Glendale','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.584479,-90.414020,0,'2013-07-06 12:44:33',NULL,NULL),(49137,'56369','P','Rockville','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.466387,-94.342233,0,'2013-07-06 12:44:33',NULL,NULL),(42244,'47573','S','Ragsdale','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.772302,-87.327969,0,'2013-07-06 12:44:32',NULL,NULL),(34877,'38941','S','Murdock Xing','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.497698,-90.325338,0,'2013-07-06 12:44:32',NULL,NULL),(14618,'15228','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.375682,-80.040038,0,'2013-07-06 12:44:31',NULL,NULL),(77400,'96779','S','Paia','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.916294,-156.380420,0,'2013-07-06 12:44:34',NULL,NULL),(37349,'41719','S','Blue Diamond','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.309817,-83.218287,0,'2013-07-06 12:44:32',NULL,NULL),(33908,'38052','S','Middleton','D','Hardeman','47069','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.062209,-88.895359,0,'2013-07-06 12:44:32',NULL,NULL),(29492,'32746','S','Heathrow','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.759920,-81.345840,0,'2013-07-06 12:44:32',NULL,NULL),(3552,'01936','P','Hamilton','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.637922,-70.859398,0,'2013-07-06 12:44:30',NULL,NULL),(49141,'56373','S','Royalton','D','Morrison','27097','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.832001,-94.289638,0,'2013-07-06 12:44:33',NULL,NULL),(18283,'19013','S','Upland','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(26784,'29451','S','Dewees Island','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.795877,-79.769665,0,'2013-07-06 12:44:31',NULL,NULL),(30849,'33637','S','Temple Terrace','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.032275,-82.365111,0,'2013-07-06 12:44:32',NULL,NULL),(67342,'80106','S','Black Forest','N','El Paso','08041','Colorado','CO','08','1720','303/720','Mountain',-7.0,'Y',39.056631,-104.593326,0,'2013-07-06 12:44:34',NULL,NULL),(9623,'10034','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.867888,-73.919847,0,'2013-07-06 12:44:30',NULL,NULL),(25774,'28601','S','Viewmont','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(60771,'72015','S','Haskell','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.566563,-92.583045,0,'2013-07-06 12:44:33',NULL,NULL),(22238,'23630','U','Family Fashions by Avon','N','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.999882,-76.410732,0,'2013-07-06 12:44:31',NULL,NULL),(49334,'56561','P','Moorhead','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.926751,-96.715269,0,'2013-07-06 12:44:33',NULL,NULL),(48982,'56223','S','Clarkfield','D','Yellow Medicine','27173','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.792882,-95.810742,0,'2013-07-06 12:44:33',NULL,NULL),(40353,'45629','S','Stream Side','N','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.657779,-82.807843,0,'2013-07-06 12:44:32',NULL,NULL),(20531,'21094','P','Timonium','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.421320,-76.623102,0,'2013-07-06 12:44:31',NULL,NULL),(74612,'92728','P','Fountain Valley','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.713991,-117.928354,0,'2013-07-06 12:44:34',NULL,NULL),(42501,'47842','S','Jonestown','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(51163,'58856','S','Zahl','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589053,-103.668530,0,'2013-07-06 12:44:33',NULL,NULL),(9435,'10004','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.704169,-74.012311,0,'2013-07-06 12:44:30',NULL,NULL),(65335,'77520','S','Baytown','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(57731,'67416','S','Mentor','A','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.669599,-97.583065,0,'2013-07-06 12:44:33',NULL,NULL),(38856,'44094','S','Wiloughby Hls','A','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.637224,-81.418352,0,'2013-07-06 12:44:32',NULL,NULL),(56121,'64830','P','Alba','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.235590,-94.416734,0,'2013-07-06 12:44:33',NULL,NULL),(48838,'56052','S','Kilkenny','D','Rice','27131','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.334649,-93.485933,0,'2013-07-06 12:44:33',NULL,NULL),(40304,'45458','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.612491,-84.161498,0,'2013-07-06 12:44:32',NULL,NULL),(11059,'11577','S','Roslyn Hts','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.785766,-73.637013,0,'2013-07-06 12:44:30',NULL,NULL),(3625,'02065','P','Marshfield','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.091667,-70.706111,0,'2013-07-06 12:44:30',NULL,NULL),(68285,'81084','S','Two Buttes','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.693548,-102.354655,0,'2013-07-06 12:44:34',NULL,NULL),(66025,'78361','S','Viboras','N','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',27.283639,-98.691312,0,'2013-07-06 12:44:34',NULL,NULL),(59437,'70710','S','Addis','D','West Baton Rouge','22121','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.352671,-91.266929,0,'2013-07-06 12:44:33',NULL,NULL),(20629,'21216','S','Walbrook','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.308329,-76.677180,0,'2013-07-06 12:44:31',NULL,NULL),(51615,'59835','P','Grantsdale','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.200933,-114.142552,0,'2013-07-06 12:44:33',NULL,NULL),(45729,'52079','S','Zwingle','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.309240,-90.722340,0,'2013-07-06 12:44:32',NULL,NULL),(41059,'46504','S','Bourbon','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.317525,-86.119695,0,'2013-07-06 12:44:32',NULL,NULL),(9153,'09309','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38846,'44090','S','Wellington','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.155380,-82.206840,0,'2013-07-06 12:44:32',NULL,NULL),(38274,'43320','S','Edison','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.577397,-82.883382,0,'2013-07-06 12:44:32',NULL,NULL),(34250,'38401','S','Columbia','D','Maury','47119','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.609931,-87.048941,0,'2013-07-06 12:44:32',NULL,NULL),(62521,'74403','S','Muskogee','D','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.740245,-95.348429,0,'2013-07-06 12:44:33',NULL,NULL),(79611,'99111','S','Colfax','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.878924,-117.356883,0,'2013-07-06 12:44:34',NULL,NULL),(21483,'22646','P','Millwood','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.066551,-78.038580,0,'2013-07-06 12:44:31',NULL,NULL),(56052,'64734','S','West Line','A','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.678619,-94.592674,0,'2013-07-06 12:44:33',NULL,NULL),(51199,'59033','S','Greycliff','D','Sweet Grass','30097','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.775614,-109.687545,0,'2013-07-06 12:44:33',NULL,NULL),(19061,'19547','S','Oley','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(38007,'42784','S','Upton','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.469104,-85.925903,0,'2013-07-06 12:44:32',NULL,NULL),(48944,'56166','S','Revere','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.218769,-95.362766,0,'2013-07-06 12:44:33',NULL,NULL),(68071,'80936','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.906063,-104.753199,0,'2013-07-06 12:44:34',NULL,NULL),(57936,'67735','S','Goodland','D','Sherman','20181','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',39.348821,-101.712088,0,'2013-07-06 12:44:33',NULL,NULL),(61717,'73012','S','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.645555,-97.519322,0,'2013-07-06 12:44:33',NULL,NULL),(70111,'84184','U','American Express Co','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.679483,-111.954813,0,'2013-07-06 12:44:34',NULL,NULL),(25030,'27892','S','Williamston','D','Martin','37117','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.731680,-77.114100,0,'2013-07-06 12:44:31',NULL,NULL),(64331,'76501','S','Seaton','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(16964,'17702','S','Williamsport','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(29941,'33068','S','N Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.216234,-80.216437,0,'2013-07-06 12:44:32',NULL,NULL),(22829,'24513','U','J Crew','N','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.403695,-79.189857,0,'2013-07-06 12:44:31',NULL,NULL),(58622,'68860','S','Oconto','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.130711,-99.664931,0,'2013-07-06 12:44:33',NULL,NULL),(5421,'04668','S','Indian Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.226109,-67.563119,0,'2013-07-06 12:44:30',NULL,NULL),(52132,'60433','S','Joliet','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.513131,-88.052737,0,'2013-07-06 12:44:33',NULL,NULL),(42177,'47531','S','Evanston','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.023906,-86.827683,0,'2013-07-06 12:44:32',NULL,NULL),(30726,'33525','S','Dade City','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.364430,-82.209827,0,'2013-07-06 12:44:32',NULL,NULL),(31987,'35220','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.441667,-86.905801,0,'2013-07-06 12:44:32',NULL,NULL),(33485,'37342','S','Hillsboro','D','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.387925,-85.997192,0,'2013-07-06 12:44:32',NULL,NULL),(34957,'39062','P','DLO','N','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.984304,-89.898049,0,'2013-07-06 12:44:32',NULL,NULL),(65095,'77359','S','Oakhurst','D','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.699015,-95.300239,0,'2013-07-06 12:44:34',NULL,NULL),(27251,'29928','S','Fairfield','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.161512,-80.752518,0,'2013-07-06 12:44:31',NULL,NULL),(44629,'50065','S','Davis City','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.639458,-93.812081,0,'2013-07-06 12:44:32',NULL,NULL),(75541,'94230','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.474474,-121.444005,0,'2013-07-06 12:44:34',NULL,NULL),(64453,'76570','S','Terrys Chapel','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(11319,'11782','S','Sayville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.746049,-73.080662,0,'2013-07-06 12:44:30',NULL,NULL),(57862,'67575','S','Rush Center','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.463652,-99.312553,0,'2013-07-06 12:44:33',NULL,NULL),(38584,'43804','S','Bucks','A','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.463509,-81.734242,0,'2013-07-06 12:44:32',NULL,NULL),(38043,'43036','P','Magnetic Springs','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.352146,-83.262257,0,'2013-07-06 12:44:32',NULL,NULL),(35269,'39362','S','State Line','D','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.436443,-88.468270,0,'2013-07-06 12:44:32',NULL,NULL),(33500,'37357','S','Morrison','D','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.587843,-85.935375,0,'2013-07-06 12:44:32',NULL,NULL),(32336,'35775','S','Valhermoso Spg','A','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.550490,-86.694970,0,'2013-07-06 12:44:32',NULL,NULL),(77269,'96603','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(13788,'14170','S','W Falls','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.704094,-78.670831,0,'2013-07-06 12:44:31',NULL,NULL),(71956,'88001','S','Tortugas','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.317522,-106.743509,0,'2013-07-06 12:44:34',NULL,NULL),(67193,'79904','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.857581,-106.438197,0,'2013-07-06 12:44:34',NULL,NULL),(41466,'46917','S','Camden','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.598280,-86.500680,0,'2013-07-06 12:44:32',NULL,NULL),(22720,'24354','S','Thomas Bridge','N','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(67649,'80470','S','Pine','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.462199,-105.367398,0,'2013-07-06 12:44:34',NULL,NULL),(75643,'94523','S','Concord','A','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.952057,-122.074333,0,'2013-07-06 12:44:34',NULL,NULL),(23701,'25870','S','Maben','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.659608,-81.396162,0,'2013-07-06 12:44:31',NULL,NULL),(22483,'24061','U','Blacksburg','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.255026,-80.431691,0,'2013-07-06 12:44:31',NULL,NULL),(18397,'19050','S','Yeadon','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936540,-75.263580,0,'2013-07-06 12:44:31',NULL,NULL),(76178,'95330','S','Lathrop','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.818495,-121.286548,0,'2013-07-06 12:44:34',NULL,NULL),(75361,'93923','S','Carmel','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.359760,-121.796280,0,'2013-07-06 12:44:34',NULL,NULL),(72779,'89599','U','Jc Penney Co','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.530106,-119.813810,0,'2013-07-06 12:44:34',NULL,NULL),(6247,'05494','S','Westford','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.630369,-73.005676,0,'2013-07-06 12:44:30',NULL,NULL),(21944,'23231','S','Varina','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(6832,'06117','S','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.777870,-72.756911,0,'2013-07-06 12:44:30',NULL,NULL),(20303,'20815','S','Chevy Chase Village','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(67230,'79928','S','Socorro','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.757176,-106.486005,0,'2013-07-06 12:44:34',NULL,NULL),(32376,'35903','S','East Gadsden','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',33.993300,-85.905900,0,'2013-07-06 12:44:32',NULL,NULL),(418,'00662','S','Repto Santa Maria','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(71614,'87327','P','Zuni Pueblo','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(35658,'39648','S','Barto','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(70221,'84404','S','Farr West','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(71463,'87052','S','St Dmng Pblo','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.533365,-106.392193,0,'2013-07-06 12:44:34',NULL,NULL),(56192,'65016','S','Frankenstein','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.562513,-91.919760,0,'2013-07-06 12:44:33',NULL,NULL),(47628,'54912','P','Appleton','D','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.266623,-88.434674,0,'2013-07-06 12:44:33',NULL,NULL),(16951,'17701','S','Warrensville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(18339,'19029','S','Tinicum Township','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868240,-75.294939,0,'2013-07-06 12:44:31',NULL,NULL),(14926,'15550','S','Manns Choice','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.971222,-78.655072,0,'2013-07-06 12:44:31',NULL,NULL),(54288,'62702','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.829980,-89.653080,0,'2013-07-06 12:44:33',NULL,NULL),(48831,'56044','S','Henderson','D','Sibley','27143','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.526232,-93.905740,0,'2013-07-06 12:44:33',NULL,NULL),(43800,'49060','S','Hickory Corners','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.436160,-85.400652,0,'2013-07-06 12:44:32',NULL,NULL),(20262,'20784','S','Landover Hls','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(74481,'92610','S','Foothill Ranch','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.681780,-117.631980,0,'2013-07-06 12:44:34',NULL,NULL),(38717,'44022','S','Chagrin Township','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(31444,'34278','P','Pinecraft','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.332107,-82.530323,0,'2013-07-06 12:44:32',NULL,NULL),(15365,'16257','S','Snydersburg','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.334198,-79.357913,0,'2013-07-06 12:44:31',NULL,NULL),(65549,'77834','P','Brenham','D','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.168111,-96.397823,0,'2013-07-06 12:44:34',NULL,NULL),(11019,'11560','S','Lattingtown','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.877100,-73.611420,0,'2013-07-06 12:44:30',NULL,NULL),(54023,'62454','S','Robinson','D','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.005760,-87.775140,0,'2013-07-06 12:44:33',NULL,NULL),(35426,'39474','S','Lucas','N','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.595381,-89.875941,0,'2013-07-06 12:44:32',NULL,NULL),(49089,'56331','S','Freeport','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.681666,-94.680948,0,'2013-07-06 12:44:33',NULL,NULL),(29935,'33066','S','Coconut Creek','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.247211,-80.174433,0,'2013-07-06 12:44:32',NULL,NULL),(58819,'69036','S','Lebanon','D','Red Willow','31145','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.086094,-100.246584,0,'2013-07-06 12:44:33',NULL,NULL),(25999,'28672','S','Peden','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.473151,-81.380417,0,'2013-07-06 12:44:31',NULL,NULL),(56831,'65801','P','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.131172,-93.294336,0,'2013-07-06 12:44:33',NULL,NULL),(19287,'19970','S','Oceanview','N','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.555449,-75.108954,0,'2013-07-06 12:44:31',NULL,NULL),(41306,'46769','P','Linn Grv','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.644448,-85.031233,0,'2013-07-06 12:44:32',NULL,NULL),(16649,'17344','S','McSherrystown','A','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.804478,-77.019713,0,'2013-07-06 12:44:31',NULL,NULL),(38787,'44057','S','Madison','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.770970,-81.058712,0,'2013-07-06 12:44:32',NULL,NULL),(38478,'43654','U','Toledo','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.605962,-83.537003,0,'2013-07-06 12:44:32',NULL,NULL),(67787,'80705','S','Log Lane Vlg','A','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.260900,-103.818540,0,'2013-07-06 12:44:34',NULL,NULL),(14941,'15565','S','W Salisbury','A','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.752803,-79.096393,0,'2013-07-06 12:44:31',NULL,NULL),(33728,'37814','S','Morristown','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.221466,-83.310936,0,'2013-07-06 12:44:32',NULL,NULL),(14947,'15606','U','Allegheny Power','N','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.301688,-79.538092,0,'2013-07-06 12:44:31',NULL,NULL),(76493,'95634','S','Buffalo Hill','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.917770,-120.790653,0,'2013-07-06 12:44:34',NULL,NULL),(21682,'22960','S','Nasons','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.245110,-78.108521,0,'2013-07-06 12:44:31',NULL,NULL),(21558,'22807','U','Harrisonburg','D','Harrisonburg City','51660','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.434377,-78.874712,0,'2013-07-06 12:44:31',NULL,NULL),(65277,'77479','S','Sugar Land','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.565407,-95.635280,0,'2013-07-06 12:44:34',NULL,NULL),(28763,'32009','S','Bryceville','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.410361,-81.950312,0,'2013-07-06 12:44:32',NULL,NULL),(32611,'36135','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.387934,-86.151025,0,'2013-07-06 12:44:32',NULL,NULL),(38687,'43977','S','Flushing','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.128055,-81.070756,0,'2013-07-06 12:44:32',NULL,NULL),(26042,'28684','S','Tamarack','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.311400,-81.579000,0,'2013-07-06 12:44:31',NULL,NULL),(15628,'16699','U','SCI Cresson','N','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.465506,-78.588583,0,'2013-07-06 12:44:31',NULL,NULL),(76438,'95603','S','Lake of the Pines','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',38.921820,-121.098120,0,'2013-07-06 12:44:34',NULL,NULL),(25473,'28344','S','Godwin','D','Sampson','37163','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.196241,-78.659945,0,'2013-07-06 12:44:31',NULL,NULL),(64796,'77016','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.856433,-95.303513,0,'2013-07-06 12:44:34',NULL,NULL),(48508,'55741','S','Gilbert','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.512565,-92.411206,0,'2013-07-06 12:44:33',NULL,NULL),(30772,'33575','P','Sun City Ctr','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.714551,-82.419142,0,'2013-07-06 12:44:32',NULL,NULL),(21292,'22401','S','Enon','N','Fredericksburg City','51630','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.296176,-77.485335,0,'2013-07-06 12:44:31',NULL,NULL),(28094,'30742','S','Rossville','A','Catoosa','13047','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.954118,-85.250532,0,'2013-07-06 12:44:31',NULL,NULL),(20172,'20745','S','Forest Heights','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.807841,-76.989145,0,'2013-07-06 12:44:31',NULL,NULL),(78772,'98310','S','Sheridan Park','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(66472,'78659','S','Manheim','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.198600,-97.105380,0,'2013-07-06 12:44:34',NULL,NULL),(62478,'74345','P','Grove City','N','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.595226,-94.787452,0,'2013-07-06 12:44:33',NULL,NULL),(2361,'00949','S','Hacienda del Norte 2','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(61619,'72823','S','Blackwell','A','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.244334,-92.936881,0,'2013-07-06 12:44:33',NULL,NULL),(13854,'14226','S','Snyder Square','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.969504,-78.798576,0,'2013-07-06 12:44:31',NULL,NULL),(68857,'82630','S','Arminto','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',43.121700,-107.371907,0,'2013-07-06 12:44:34',NULL,NULL),(41191,'46721','S','Moore','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.413936,-84.885428,0,'2013-07-06 12:44:32',NULL,NULL),(50549,'58204','S','Gfafb','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.960971,-97.370375,0,'2013-07-06 12:44:33',NULL,NULL),(45026,'50465','P','Rake','D','Winnebago','19189','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.467276,-93.910376,0,'2013-07-06 12:44:32',NULL,NULL),(46369,'53122','S','Elm Grove','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.048854,-88.086552,0,'2013-07-06 12:44:32',NULL,NULL),(26656,'29370','S','Mountville','D','Laurens','45059','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.341308,-81.957117,0,'2013-07-06 12:44:31',NULL,NULL),(8563,'08210','S','Mayville','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.119280,-74.825820,0,'2013-07-06 12:44:30',NULL,NULL),(35780,'39746','S','Old Hamilton','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.799577,-88.429985,0,'2013-07-06 12:44:32',NULL,NULL),(44046,'49428','S','Georgetown TWP','N','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.907457,-85.830308,0,'2013-07-06 12:44:32',NULL,NULL),(11743,'12186','S','Reidsville','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.624780,-73.969800,0,'2013-07-06 12:44:30',NULL,NULL),(29809,'33024','S','Pembroke Pines','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.018670,-80.258199,0,'2013-07-06 12:44:32',NULL,NULL),(31678,'34771','S','Magnolia Square','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.287024,-81.213434,0,'2013-07-06 12:44:32',NULL,NULL),(41783,'47306','U','Ball State University','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.200890,-85.407098,0,'2013-07-06 12:44:32',NULL,NULL),(77310,'96678','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(26128,'28734','S','Cullasaja','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(14547,'15210','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.404900,-79.972620,0,'2013-07-06 12:44:31',NULL,NULL),(78460,'98070','S','Vashon Island','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.418180,-122.451780,0,'2013-07-06 12:44:34',NULL,NULL),(70144,'84307','S','Promontory','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.406420,-112.293960,0,'2013-07-06 12:44:34',NULL,NULL),(34430,'38643','S','Lambert','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.202923,-90.281184,0,'2013-07-06 12:44:32',NULL,NULL),(28609,'31704','U','Marine Corps Logistics Base','N','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.553595,-84.051925,0,'2013-07-06 12:44:32',NULL,NULL),(45167,'50599','S','Woolstock','D','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.601398,-93.795443,0,'2013-07-06 12:44:32',NULL,NULL),(57811,'67513','S','Alexander','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.468846,-99.552228,0,'2013-07-06 12:44:33',NULL,NULL),(61129,'72156','S','Solgohachia','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.275653,-92.675788,0,'2013-07-06 12:44:33',NULL,NULL),(40992,'46356','S','Lowell','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.284559,-87.416071,0,'2013-07-06 12:44:32',NULL,NULL),(22567,'24150','S','Ripplemead','D','Giles','51071','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.378380,-80.656200,0,'2013-07-06 12:44:31',NULL,NULL),(2889,'00987','S','Mans de Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(70779,'85345','S','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.569542,-112.246397,0,'2013-07-06 12:44:34',NULL,NULL),(53605,'62080','S','Ramsey','D','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.144853,-89.109512,0,'2013-07-06 12:44:33',NULL,NULL),(46185,'52739','S','Conesville','D','Muscatine','19139','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.383565,-91.350458,0,'2013-07-06 12:44:32',NULL,NULL),(29937,'33067','S','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.309681,-80.220464,0,'2013-07-06 12:44:32',NULL,NULL),(54496,'62864','S','Miller Lake','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(5826,'05076','S','Topsham','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.061849,-72.220363,0,'2013-07-06 12:44:30',NULL,NULL),(4959,'04106','S','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.620751,-70.291117,0,'2013-07-06 12:44:30',NULL,NULL),(70535,'85019','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.512656,-112.141833,0,'2013-07-06 12:44:34',NULL,NULL),(66713,'78949','S','Flatonia','N','Fayette','48149','Texas','TX','48','0000','512/737','Central',-6.0,'Y',29.798228,-97.092113,0,'2013-07-06 12:44:34',NULL,NULL),(34538,'38701','S','Refuge','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.288780,-90.990720,0,'2013-07-06 12:44:32',NULL,NULL),(20054,'20661','P','Mount Victoria','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.359153,-76.896668,0,'2013-07-06 12:44:31',NULL,NULL),(25610,'28457','S','Rocky Point','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.410616,-77.912320,0,'2013-07-06 12:44:31',NULL,NULL),(1976,'00901','S','Viejo Sn Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.463862,-66.109811,0,'2013-07-06 12:44:30',NULL,NULL),(54109,'62545','S','Mechanicsburg','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.809097,-89.397015,0,'2013-07-06 12:44:33',NULL,NULL),(68900,'82727','S','Rozet','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.248100,-105.252650,0,'2013-07-06 12:44:34',NULL,NULL),(56981,'66202','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(51390,'59418','S','Straw','N','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.797946,-109.687162,0,'2013-07-06 12:44:33',NULL,NULL),(41904,'47373','S','Redkey','D','Jay','18075','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.339260,-85.155120,0,'2013-07-06 12:44:32',NULL,NULL),(18714,'19255','U','Internal Revenue Service','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951255,-75.163103,0,'2013-07-06 12:44:31',NULL,NULL),(76864,'95970','S','Princeton','D','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.424920,-122.096280,0,'2013-07-06 12:44:34',NULL,NULL),(70147,'84309','S','Beeton','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.707724,-112.092685,0,'2013-07-06 12:44:34',NULL,NULL),(64451,'76570','S','New Clarkson','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(22841,'24526','S','Big Island','D','Bedford','51019','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.533900,-79.385220,0,'2013-07-06 12:44:31',NULL,NULL),(31539,'34498','S','Yankeetown','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.020900,-82.731360,0,'2013-07-06 12:44:32',NULL,NULL),(10176,'10282','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.714419,-74.008255,0,'2013-07-06 12:44:30',NULL,NULL),(22422,'24006','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.273068,-79.943322,0,'2013-07-06 12:44:31',NULL,NULL),(67844,'80816','S','Twin Rock','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.891057,-105.264451,0,'2013-07-06 12:44:34',NULL,NULL),(28258,'31068','S','Oglethorpe','D','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.293577,-84.068988,0,'2013-07-06 12:44:31',NULL,NULL),(30346,'33311','S','Oakland Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.140547,-80.173789,0,'2013-07-06 12:44:32',NULL,NULL),(52585,'61007','S','Baileyville','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.190432,-89.593184,0,'2013-07-06 12:44:33',NULL,NULL),(31142,'33909','S','Cape Coral','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.672523,-81.972797,0,'2013-07-06 12:44:32',NULL,NULL),(34924,'38965','S','Springdale','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.153955,-89.632766,0,'2013-07-06 12:44:32',NULL,NULL),(67937,'80910','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.816626,-104.777849,0,'2013-07-06 12:44:34',NULL,NULL),(14846,'15445','S','Hopwood','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.872450,-79.659576,0,'2013-07-06 12:44:31',NULL,NULL),(71398,'87012','S','Coyote','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.178174,-106.654000,0,'2013-07-06 12:44:34',NULL,NULL),(453,'00662','S','Urb Santa Teresita','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(35338,'39437','S','Ellisville Junction','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(33396,'37221','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.055020,-86.961600,0,'2013-07-06 12:44:32',NULL,NULL),(37400,'41773','S','Amburgey','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.157727,-83.095710,0,'2013-07-06 12:44:32',NULL,NULL),(15200,'15956','S','South Fork','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.365677,-78.792021,0,'2013-07-06 12:44:31',NULL,NULL),(22191,'23503','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.945923,-76.253486,0,'2013-07-06 12:44:31',NULL,NULL),(16476,'17246','S','Pleasant Hall','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.057748,-77.675087,0,'2013-07-06 12:44:31',NULL,NULL),(10777,'11366','S','Flushing','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.729445,-73.797794,0,'2013-07-06 12:44:30',NULL,NULL),(43701,'48892','S','Webberville','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.648435,-84.173694,0,'2013-07-06 12:44:32',NULL,NULL),(77168,'96264','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(77406,'96785','P','Volcano','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.443033,-155.284434,0,'2013-07-06 12:44:34',NULL,NULL),(1884,'00791','S','Urb San Francisco','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(14145,'14711','S','Belfast','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.341095,-78.119974,0,'2013-07-06 12:44:31',NULL,NULL),(36647,'41005','S','Rabbit Hash','A','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(35859,'39827','S','Karo','N','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.876043,-84.206528,0,'2013-07-06 12:44:32',NULL,NULL),(6445,'05753','S','Weybridge Hill','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.012313,-73.163211,0,'2013-07-06 12:44:30',NULL,NULL),(31766,'35006','S','North Johns','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.443940,-87.202920,0,'2013-07-06 12:44:32',NULL,NULL),(12871,'13324','S','Noblesboro','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.320770,-74.963299,0,'2013-07-06 12:44:30',NULL,NULL),(5300,'04549','S','Is of Springs','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.897252,-69.629746,0,'2013-07-06 12:44:30',NULL,NULL),(16627,'17331','S','York Road','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(24675,'27409','S','Guilford College','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.093667,-79.927798,0,'2013-07-06 12:44:31',NULL,NULL),(41591,'47060','S','West Harrison','D','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',39.288941,-84.865533,0,'2013-07-06 12:44:32',NULL,NULL),(2024,'00917','S','Bda Israel','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(78164,'97630','S','Lakeview','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.187658,-120.352653,0,'2013-07-06 12:44:34',NULL,NULL),(76162,'95315','S','Delhi','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.428901,-120.771361,0,'2013-07-06 12:44:34',NULL,NULL),(71480,'87068','S','Bosque Farms','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.892400,-106.712640,0,'2013-07-06 12:44:34',NULL,NULL),(66606,'78761','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.342101,-97.681888,0,'2013-07-06 12:44:34',NULL,NULL),(43545,'48701','S','Akron','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.588530,-83.549241,0,'2013-07-06 12:44:32',NULL,NULL),(34261,'38456','S','Ethridge','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.323472,-87.305069,0,'2013-07-06 12:44:32',NULL,NULL),(14194,'14758','P','Niobe','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.011416,-79.450406,0,'2013-07-06 12:44:31',NULL,NULL),(16211,'17071','P','Toboyne','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.282231,-77.577883,0,'2013-07-06 12:44:31',NULL,NULL),(27152,'29827','S','Fairfax','D','Allendale','45005','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.923380,-81.285780,0,'2013-07-06 12:44:31',NULL,NULL),(17341,'17867','S','Rebuck','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.712710,-76.735861,0,'2013-07-06 12:44:31',NULL,NULL),(26445,'29135','S','Hammond Crossroads','N','Calhoun','45017','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.661870,-80.781778,0,'2013-07-06 12:44:31',NULL,NULL),(50469,'58040','S','Gwinner','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.224480,-97.760640,0,'2013-07-06 12:44:33',NULL,NULL),(2626,'00962','S','Urb El Coqui 2','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(33887,'38027','P','Piperton','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056954,-89.676442,0,'2013-07-06 12:44:32',NULL,NULL),(22126,'23438','S','Whaleyville','N','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.563256,-76.717225,0,'2013-07-06 12:44:31',NULL,NULL),(18912,'19486','P','West Point','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.209809,-75.303409,0,'2013-07-06 12:44:31',NULL,NULL),(14390,'15046','S','Crescent','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.548807,-80.217723,0,'2013-07-06 12:44:31',NULL,NULL),(6525,'05827','S','Craftsbury Cm','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.650000,-72.383333,0,'2013-07-06 12:44:30',NULL,NULL),(45525,'51440','S','Dedham','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.908376,-94.820201,0,'2013-07-06 12:44:32',NULL,NULL),(53346,'61760','S','Minonk','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.893180,-89.035680,0,'2013-07-06 12:44:33',NULL,NULL),(61361,'72503','P','Batesville','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.727389,-91.673733,0,'2013-07-06 12:44:33',NULL,NULL),(61814,'73105','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.512654,-97.504104,0,'2013-07-06 12:44:33',NULL,NULL),(66914,'79324','S','Enochs','D','Bailey','48017','Texas','TX','48','0000','806','Central',-6.0,'Y',33.846757,-102.766227,0,'2013-07-06 12:44:34',NULL,NULL),(74249,'92332','S','Goffs','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.822579,-115.069722,0,'2013-07-06 12:44:34',NULL,NULL),(12988,'13407','S','Mohawk','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.991140,-74.980560,0,'2013-07-06 12:44:30',NULL,NULL),(21049,'21901','S','North East','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.590075,-75.955936,0,'2013-07-06 12:44:31',NULL,NULL),(1060,'00725','S','Est El Verde','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(19992,'20601','S','Waldorf','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.627621,-76.874973,0,'2013-07-06 12:44:31',NULL,NULL),(1987,'00907','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.454321,-66.076621,0,'2013-07-06 12:44:30',NULL,NULL),(40617,'46001','S','Alexandria','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.251384,-85.660463,0,'2013-07-06 12:44:32',NULL,NULL),(42565,'47874','S','Northpine Estates','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(51501,'59638','P','Jefferson City','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.383852,-112.059319,0,'2013-07-06 12:44:33',NULL,NULL),(78797,'98323','S','Carbonado','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.069692,-122.046626,0,'2013-07-06 12:44:34',NULL,NULL),(76159,'95311','S','Coulterville','D','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.728888,-120.198361,0,'2013-07-06 12:44:34',NULL,NULL),(69566,'83822','S','Oldtown','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.182406,-117.033951,0,'2013-07-06 12:44:34',NULL,NULL),(62418,'74135','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.098476,-95.922076,0,'2013-07-06 12:44:33',NULL,NULL),(52070,'60304','S','Oak Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.874171,-87.789179,0,'2013-07-06 12:44:33',NULL,NULL),(15862,'16947','S','W Burlington','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.783653,-76.791605,0,'2013-07-06 12:44:31',NULL,NULL),(31134,'33905','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.670910,-81.802140,0,'2013-07-06 12:44:32',NULL,NULL),(26970,'29612','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.847835,-82.403959,0,'2013-07-06 12:44:31',NULL,NULL),(24618,'27344','S','Siler City','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.723460,-79.425420,0,'2013-07-06 12:44:31',NULL,NULL),(16589,'17324','S','Goodyear','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(47504,'54764','P','Rock Falls','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.718965,-91.691873,0,'2013-07-06 12:44:32',NULL,NULL),(54256,'62674','S','Scottville','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.439755,-89.925200,0,'2013-07-06 12:44:33',NULL,NULL),(59599,'71018','S','Cotton Valley','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.838968,-93.453323,0,'2013-07-06 12:44:33',NULL,NULL),(62073,'73554','S','Mangum','D','Greer','40055','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.876209,-99.504161,0,'2013-07-06 12:44:33',NULL,NULL),(71742,'87538','S','North San Ysidro','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.420980,-105.561446,0,'2013-07-06 12:44:34',NULL,NULL),(34985,'39107','P','Mc Adams','D','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.019495,-89.687084,0,'2013-07-06 12:44:32',NULL,NULL),(4836,'04005','S','Dayton','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.474441,-70.452039,0,'2013-07-06 12:44:30',NULL,NULL),(31237,'33973','S','Leehigh Acres','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.610303,-81.691774,0,'2013-07-06 12:44:32',NULL,NULL),(11056,'11577','S','E Hills','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.785766,-73.637013,0,'2013-07-06 12:44:30',NULL,NULL),(42726,'48006','S','Greenwood','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.064902,-82.688720,0,'2013-07-06 12:44:32',NULL,NULL),(50090,'57468','S','Pierpont','D','Day','46037','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.500668,-97.794951,0,'2013-07-06 12:44:33',NULL,NULL),(51342,'59315','S','Bloomfield','D','Dawson','30021','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.380907,-104.944266,0,'2013-07-06 12:44:33',NULL,NULL),(72801,'89711','U','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.163917,-119.765948,0,'2013-07-06 12:44:34',NULL,NULL),(8081,'07756','S','Ocean Grove','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.211956,-74.008515,0,'2013-07-06 12:44:30',NULL,NULL),(7560,'07020','S','Edgewater','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.832415,-73.972271,0,'2013-07-06 12:44:30',NULL,NULL),(32656,'36256','S','Daviston','D','Tallapoosa','01123','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.042132,-85.738562,0,'2013-07-06 12:44:32',NULL,NULL),(19938,'20571','U','Export Import Bank','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900450,-77.032812,0,'2013-07-06 12:44:31',NULL,NULL),(40478,'45771','S','Racine','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.967300,-81.915300,0,'2013-07-06 12:44:32',NULL,NULL),(51824,'60056','S','Mount Prospect','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.068179,-87.932697,0,'2013-07-06 12:44:33',NULL,NULL),(65559,'77842','P','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.629960,-96.333212,0,'2013-07-06 12:44:34',NULL,NULL),(8309,'08030','S','Gloucester City','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.887704,-75.115680,0,'2013-07-06 12:44:30',NULL,NULL),(72681,'89444','S','Topaz Ranch Estates','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.842200,-119.367900,0,'2013-07-06 12:44:34',NULL,NULL),(66636,'78832','S','Brackettville','D','Kinney','48271','Texas','TX','48','0000','830','Central',-6.0,'Y',29.310600,-100.418012,0,'2013-07-06 12:44:34',NULL,NULL),(65758,'78069','S','Somerset','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.197679,-98.675868,0,'2013-07-06 12:44:34',NULL,NULL),(20568,'21139','P','Riderwood','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.407324,-76.648486,0,'2013-07-06 12:44:31',NULL,NULL),(34217,'38358','S','Milan Army Ammunition Plant','N','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.923931,-88.765013,0,'2013-07-06 12:44:32',NULL,NULL),(34126,'38194','U','Federal Express','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.064129,-89.999493,0,'2013-07-06 12:44:32',NULL,NULL),(22504,'24076','S','Claudville','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.598118,-80.430923,0,'2013-07-06 12:44:31',NULL,NULL),(29186,'32401','S','P C Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.160005,-85.649607,0,'2013-07-06 12:44:32',NULL,NULL),(26514,'29178','S','Whitmire','D','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.501145,-81.616631,0,'2013-07-06 12:44:31',NULL,NULL),(52415,'60643','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.699379,-87.659992,0,'2013-07-06 12:44:33',NULL,NULL),(53182,'61604','S','West Peoria','A','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.700000,-89.683333,0,'2013-07-06 12:44:33',NULL,NULL),(53265,'61710','U','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.478286,-88.952728,0,'2013-07-06 12:44:33',NULL,NULL),(71539,'87154','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.145729,-106.491629,0,'2013-07-06 12:44:34',NULL,NULL),(59677,'71064','S','Plain Dealing','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.905021,-93.702244,0,'2013-07-06 12:44:33',NULL,NULL),(59473,'70749','S','Jarreau','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.630766,-91.431298,0,'2013-07-06 12:44:33',NULL,NULL),(69460,'83650','S','Reynolds','N','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.053611,-116.394167,0,'2013-07-06 12:44:34',NULL,NULL),(60950,'72101','S','Mc Crory','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(43381,'48428','S','Dryden','D','Lapeer','26087','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.936752,-83.143404,0,'2013-07-06 12:44:32',NULL,NULL),(42856,'48079','S','St Clair Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.853850,-82.547092,0,'2013-07-06 12:44:32',NULL,NULL),(17625,'18051','S','Fogelsville','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.594749,-75.651281,0,'2013-07-06 12:44:31',NULL,NULL),(17040,'17748','P','McElhattan','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.149722,-77.365556,0,'2013-07-06 12:44:31',NULL,NULL),(38300,'43347','S','Rushsylvania','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.470088,-83.666200,0,'2013-07-06 12:44:32',NULL,NULL),(4658,'03766','S','Lebanon','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.642879,-72.253714,0,'2013-07-06 12:44:30',NULL,NULL),(76333,'95464','S','Nice','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.119398,-122.845078,0,'2013-07-06 12:44:34',NULL,NULL),(75068,'93528','P','Johannesburg','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.368926,-117.634207,0,'2013-07-06 12:44:34',NULL,NULL),(57080,'66216','S','Lenexa','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.008231,-94.740275,0,'2013-07-06 12:44:33',NULL,NULL),(39634,'44901','P','Mansfield','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.685074,-82.586108,0,'2013-07-06 12:44:32',NULL,NULL),(18674,'19182','U','Pnc Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951857,-75.150106,0,'2013-07-06 12:44:31',NULL,NULL),(12730,'13160','S','Allens Point','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.842257,-76.688186,0,'2013-07-06 12:44:30',NULL,NULL),(35048,'39175','S','Utica Junior College','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.120866,-90.599332,0,'2013-07-06 12:44:32',NULL,NULL),(34583,'38738','P','Parchman','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.917778,-90.496389,0,'2013-07-06 12:44:32',NULL,NULL),(33809,'37916','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.954943,-83.930350,0,'2013-07-06 12:44:32',NULL,NULL),(32268,'35633','S','Florence','D','Lauderdale','01077','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.856704,-87.686979,0,'2013-07-06 12:44:32',NULL,NULL),(60763,'72007','S','Austin','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.997111,-91.970805,0,'2013-07-06 12:44:33',NULL,NULL),(59065,'70094','S','Fairfield','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(55388,'63627','S','Bloomsdale','D','Sainte Genevieve','29186','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.033035,-90.256122,0,'2013-07-06 12:44:33',NULL,NULL),(44299,'49730','S','Elmira','D','Otsego','26137','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.950099,-84.883435,0,'2013-07-06 12:44:32',NULL,NULL),(24376,'27055','S','Footsville','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.139920,-80.623620,0,'2013-07-06 12:44:31',NULL,NULL),(3936,'02466','S','Newton','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.345147,-71.247889,0,'2013-07-06 12:44:30',NULL,NULL),(33090,'36804','S','Opelika','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.657875,-85.377323,0,'2013-07-06 12:44:32',NULL,NULL),(79116,'98467','S','University Place','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.235833,-122.549167,0,'2013-07-06 12:44:34',NULL,NULL),(75345,'93906','S','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.709565,-121.639635,0,'2013-07-06 12:44:34',NULL,NULL),(62010,'73444','S','Hennepin','D','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.473917,-97.411006,0,'2013-07-06 12:44:33',NULL,NULL),(57672,'67218','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.670737,-97.280969,0,'2013-07-06 12:44:33',NULL,NULL),(52623,'61038','S','Garden Prairie','D','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.249088,-88.739224,0,'2013-07-06 12:44:33',NULL,NULL),(6412,'05738','S','Shrewsbury','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.531020,-72.864480,0,'2013-07-06 12:44:30',NULL,NULL),(29012,'32225','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.348896,-81.501070,0,'2013-07-06 12:44:32',NULL,NULL),(40699,'46085','U','Fishers','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.979634,-86.119609,0,'2013-07-06 12:44:32',NULL,NULL),(181,'00623','S','Parc Betances','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(62302,'74027','S','Delaware','D','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.778584,-95.640408,0,'2013-07-06 12:44:33',NULL,NULL),(40816,'46203','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.743419,-86.104228,0,'2013-07-06 12:44:32',NULL,NULL),(28113,'30807','P','Camak','D','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.458265,-82.646376,0,'2013-07-06 12:44:31',NULL,NULL),(33178,'37030','S','South Carthage','A','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.262380,-85.994400,0,'2013-07-06 12:44:32',NULL,NULL),(23359,'25267','S','Normantown','D','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.891624,-80.957193,0,'2013-07-06 12:44:31',NULL,NULL),(14853,'15454','P','Leckrone','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.860912,-79.869033,0,'2013-07-06 12:44:31',NULL,NULL),(56078,'64759','S','Irwin','A','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.493876,-94.271176,0,'2013-07-06 12:44:33',NULL,NULL),(43990,'49337','S','Croton','N','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.437720,-85.740420,0,'2013-07-06 12:44:32',NULL,NULL),(26182,'28757','P','Montreat','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.643925,-82.305516,0,'2013-07-06 12:44:31',NULL,NULL),(79761,'99320','S','Kiona','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.256964,-119.471504,0,'2013-07-06 12:44:34',NULL,NULL),(73439,'91224','P','La Crescenta','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.227961,-118.246396,0,'2013-07-06 12:44:34',NULL,NULL),(71486,'87083','S','Cochiti Lake','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.645558,-106.335325,0,'2013-07-06 12:44:34',NULL,NULL),(65971,'78292','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.425547,-98.485755,0,'2013-07-06 12:44:34',NULL,NULL),(54766,'62990','S','Fayville','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.189836,-89.393166,0,'2013-07-06 12:44:33',NULL,NULL),(3365,'01581','S','Westboro','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.266610,-71.617194,0,'2013-07-06 12:44:30',NULL,NULL),(20577,'21153','P','Stevenson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.419263,-76.712485,0,'2013-07-06 12:44:31',NULL,NULL),(6386,'05701','S','Mill Village','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(51778,'60041','S','Long Lake','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.357735,-88.163789,0,'2013-07-06 12:44:33',NULL,NULL),(53161,'61565','S','Hopewell Estates','N','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.995506,-89.451602,0,'2013-07-06 12:44:33',NULL,NULL),(53372,'61775','S','Strawn','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.651172,-88.395957,0,'2013-07-06 12:44:33',NULL,NULL),(54381,'62812','S','West City','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.003056,-88.938333,0,'2013-07-06 12:44:33',NULL,NULL),(2730,'00969','S','Urb El Jard de Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(66167,'78520','S','El Jardin','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(66111,'78414','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.671260,-97.368060,0,'2013-07-06 12:44:34',NULL,NULL),(60290,'71454','S','Campground','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(18046,'18661','S','White Haven','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.062005,-75.784080,0,'2013-07-06 12:44:31',NULL,NULL),(31602,'34674','P','Hudson','D','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.357719,-82.698689,0,'2013-07-06 12:44:32',NULL,NULL),(26365,'29072','S','Lexington','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.979860,-81.260520,0,'2013-07-06 12:44:31',NULL,NULL),(26338,'29059','S','Bowyer','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.322019,-80.412299,0,'2013-07-06 12:44:31',NULL,NULL),(41644,'47134','U','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285868,-85.732024,0,'2013-07-06 12:44:32',NULL,NULL),(57544,'67025','S','Cheney','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.628991,-97.778762,0,'2013-07-06 12:44:33',NULL,NULL),(11943,'12439','S','East Windham','A','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.258600,-74.224980,0,'2013-07-06 12:44:30',NULL,NULL),(73043,'90081','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.057006,-118.266560,0,'2013-07-06 12:44:34',NULL,NULL),(67534,'80257','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.751093,-104.999498,0,'2013-07-06 12:44:34',NULL,NULL),(66697,'78945','S','Oquinn','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(61603,'72768','S','Sulphur Springs','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.478438,-94.462102,0,'2013-07-06 12:44:33',NULL,NULL),(20594,'21202','S','East Case','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.295835,-76.609089,0,'2013-07-06 12:44:31',NULL,NULL),(28963,'32203','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.337271,-81.672748,0,'2013-07-06 12:44:32',NULL,NULL),(24974,'27849','S','Lewiston Woodville','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.088260,-77.229660,0,'2013-07-06 12:44:31',NULL,NULL),(38877,'44106','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.505132,-81.607134,0,'2013-07-06 12:44:32',NULL,NULL),(47095,'54439','P','Hannibal','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.242751,-90.740469,0,'2013-07-06 12:44:32',NULL,NULL),(47784,'55043','S','St Marys Pt','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(55754,'64111','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.058627,-94.592111,0,'2013-07-06 12:44:33',NULL,NULL),(61035,'72117','S','Rixey','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(8615,'08244','S','Somers Point','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.319760,-74.600482,0,'2013-07-06 12:44:30',NULL,NULL),(76499,'95636','S','Grizzly Flats','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.652667,-120.488469,0,'2013-07-06 12:44:34',NULL,NULL),(72969,'90046','S','W Hollywood','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105576,-118.366794,0,'2013-07-06 12:44:34',NULL,NULL),(72264,'88542','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770148,-106.429958,0,'2013-07-06 12:44:34',NULL,NULL),(60058,'71351','S','Fort de Russy','N','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.161480,-92.095020,0,'2013-07-06 12:44:33',NULL,NULL),(59911,'71282','S','Englewood','N','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(56665,'65624','S','Galena','A','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.675135,-93.528191,0,'2013-07-06 12:44:33',NULL,NULL),(53769,'62269','S','O Fallon','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.562834,-89.896654,0,'2013-07-06 12:44:33',NULL,NULL),(47564,'54838','S','Wascott','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.198672,-91.897453,0,'2013-07-06 12:44:32',NULL,NULL),(7226,'06504','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.291641,-72.964292,0,'2013-07-06 12:44:30',NULL,NULL),(29643,'32899','U','Orlando','D','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.611682,-80.677691,0,'2013-07-06 12:44:32',NULL,NULL),(29187,'32401','S','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.160005,-85.649607,0,'2013-07-06 12:44:32',NULL,NULL),(69440,'83644','S','Middleton','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.722252,-116.603590,0,'2013-07-06 12:44:34',NULL,NULL),(65252,'77463','P','Old Ocean','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.077390,-95.748242,0,'2013-07-06 12:44:34',NULL,NULL),(57889,'67635','S','Dresden','D','Decatur','20039','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.612630,-100.377412,0,'2013-07-06 12:44:33',NULL,NULL),(46439,'53207','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.980668,-87.892825,0,'2013-07-06 12:44:32',NULL,NULL),(38180,'43162','S','West Jefferson','D','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.943824,-83.293373,0,'2013-07-06 12:44:32',NULL,NULL),(25869,'28633','U','Broyhill Furniture','N','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.902482,-81.535317,0,'2013-07-06 12:44:31',NULL,NULL),(37360,'41723','S','Busy','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.269914,-83.271246,0,'2013-07-06 12:44:32',NULL,NULL),(12027,'12514','S','Clinton Crn','N','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.875980,-73.772400,0,'2013-07-06 12:44:30',NULL,NULL),(2312,'00927','S','Villas de Palma Real','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(78730,'98281','S','Point Roberts','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.991860,-123.057602,0,'2013-07-06 12:44:34',NULL,NULL),(74556,'92678','P','Trabuco Canyon','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.664297,-117.589602,0,'2013-07-06 12:44:34',NULL,NULL),(66521,'78713','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.283922,-97.741323,0,'2013-07-06 12:44:34',NULL,NULL),(45015,'50457','S','Meservey','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.931012,-93.466683,0,'2013-07-06 12:44:32',NULL,NULL),(27764,'30364','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.675999,-84.461995,0,'2013-07-06 12:44:31',NULL,NULL),(26917,'29582','S','North Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(25643,'28467','S','Ocean Isle Beach','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.898397,-78.578267,0,'2013-07-06 12:44:31',NULL,NULL),(77166,'96258','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(46287,'53045','S','Brookfield','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.061327,-88.155393,0,'2013-07-06 12:44:32',NULL,NULL),(42664,'47957','S','Medaryville','D','Pulaski','18131','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',41.079726,-86.887555,0,'2013-07-06 12:44:32',NULL,NULL),(30005,'33124','P','Univ of Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.726412,-80.238000,0,'2013-07-06 12:44:32',NULL,NULL),(40540,'45844','S','Fort Jennings','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.915999,-84.290490,0,'2013-07-06 12:44:32',NULL,NULL),(74864,'93258','P','Porterville','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.066445,-119.130717,0,'2013-07-06 12:44:34',NULL,NULL),(69239,'83420','S','Drummond','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.042760,-111.375420,0,'2013-07-06 12:44:34',NULL,NULL),(68209,'81044','S','John Martin Reservoir','N','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.061389,-102.926667,0,'2013-07-06 12:44:34',NULL,NULL),(65719,'78023','S','Helotes','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.592512,-98.715028,0,'2013-07-06 12:44:34',NULL,NULL),(58636,'68869','S','Poole','N','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.024580,-98.893020,0,'2013-07-06 12:44:33',NULL,NULL),(36807,'41056','S','Moranburg','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(29930,'33064','S','Lighthouse Pt','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.277900,-80.147820,0,'2013-07-06 12:44:32',NULL,NULL),(6838,'06118','S','East Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.748563,-72.609938,0,'2013-07-06 12:44:30',NULL,NULL),(6265,'05602','S','Montpelier Junction','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(5249,'04478','S','Rockwood','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(21177,'22159','U','Firm Zip','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801702,-77.182270,0,'2013-07-06 12:44:31',NULL,NULL),(31339,'34140','P','Goodland','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.924592,-81.649561,0,'2013-07-06 12:44:32',NULL,NULL),(7148,'06414','P','Cobalt','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.568275,-72.556386,0,'2013-07-06 12:44:30',NULL,NULL),(10150,'10276','P','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733951,-73.989188,0,'2013-07-06 12:44:30',NULL,NULL),(42805,'48051','S','Chesterfield','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.688473,-82.809772,0,'2013-07-06 12:44:32',NULL,NULL),(43662,'48854','S','Mason','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.584076,-84.437704,0,'2013-07-06 12:44:32',NULL,NULL),(72709,'89448','P','Zephyr Cove','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.002220,-119.955000,0,'2013-07-06 12:44:34',NULL,NULL),(64358,'76520','S','Pettibone','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.851242,-96.976377,0,'2013-07-06 12:44:34',NULL,NULL),(57021,'66206','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.950800,-94.626000,0,'2013-07-06 12:44:33',NULL,NULL),(56439,'65274','S','Estill','N','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.014736,-92.740471,0,'2013-07-06 12:44:33',NULL,NULL),(54362,'62801','S','Raccoon','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(42502,'47842','S','Sandytown','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(1094,'00725','S','Urb Grillo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(31823,'35068','S','Coalburg','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.612000,-86.826540,0,'2013-07-06 12:44:32',NULL,NULL),(22655,'24269','S','Mc Clure','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.080985,-82.383101,0,'2013-07-06 12:44:31',NULL,NULL),(21327,'22407','S','Fredericksburg','D','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.282279,-77.557232,0,'2013-07-06 12:44:31',NULL,NULL),(3941,'02467','S','Newton','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.318527,-71.157052,0,'2013-07-06 12:44:30',NULL,NULL),(78650,'98225','S','Marietta','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.746494,-122.493289,0,'2013-07-06 12:44:34',NULL,NULL),(77377,'96754','S','Kilauea','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.215931,-159.403979,0,'2013-07-06 12:44:34',NULL,NULL),(59914,'71282','S','Richmond','A','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(47701,'54980','P','Waukau','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.990733,-88.769713,0,'2013-07-06 12:44:33',NULL,NULL),(37923,'42633','S','Touristville','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(37403,'41774','S','Farler','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.138863,-83.165412,0,'2013-07-06 12:44:32',NULL,NULL),(36129,'40223','S','Moorland','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(31717,'34957','S','Ocean Brz Pk','A','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.234550,-80.232374,0,'2013-07-06 12:44:32',NULL,NULL),(26288,'29021','P','Antioch','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(45001,'50447','S','Denhart','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.935696,-93.790461,0,'2013-07-06 12:44:32',NULL,NULL),(45171,'50601','S','Macy','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.552024,-93.052562,0,'2013-07-06 12:44:32',NULL,NULL),(1041,'00723','S','Parq del Sol','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(78885,'98357','P','Tatoosh Island','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.369349,-124.626924,0,'2013-07-06 12:44:34',NULL,NULL),(70223,'84404','S','Marriott','N','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.276379,-111.987441,0,'2013-07-06 12:44:34',NULL,NULL),(64595,'76679','S','Purdon','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.949322,-96.573146,0,'2013-07-06 12:44:34',NULL,NULL),(53413,'61842','S','Farmer City','D','Dewitt','17039','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.243766,-88.640662,0,'2013-07-06 12:44:33',NULL,NULL),(47810,'55055','S','Newport','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.872086,-92.997031,0,'2013-07-06 12:44:33',NULL,NULL),(45423,'51058','S','Sutherland','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.970337,-95.498504,0,'2013-07-06 12:44:32',NULL,NULL),(12803,'13244','U','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.041575,-76.133784,0,'2013-07-06 12:44:30',NULL,NULL),(79031,'98394','S','Vaughn','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.329286,-122.769120,0,'2013-07-06 12:44:34',NULL,NULL),(77436,'96806','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304761,-157.857413,0,'2013-07-06 12:44:34',NULL,NULL),(75408,'94019','S','Princeton by the Sea','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.479960,-122.330880,0,'2013-07-06 12:44:34',NULL,NULL),(72781,'89701','S','Carson City','D','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(6361,'05675','S','Washington','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.028056,-72.413333,0,'2013-07-06 12:44:30',NULL,NULL),(10033,'10172','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(47603,'54873','S','Solon Springs','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.399140,-91.748040,0,'2013-07-06 12:44:33',NULL,NULL),(60983,'72110','S','Oppelo','A','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(64054,'76132','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.671991,-97.432311,0,'2013-07-06 12:44:34',NULL,NULL),(14200,'14770','S','Portville','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.037594,-78.334611,0,'2013-07-06 12:44:31',NULL,NULL),(78255,'97838','S','Hermiston','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.839542,-119.285752,0,'2013-07-06 12:44:34',NULL,NULL),(68963,'83011','S','Kelly','D','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.605445,-110.329035,0,'2013-07-06 12:44:34',NULL,NULL),(60728,'71958','S','Kimberley','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.060950,-93.689939,0,'2013-07-06 12:44:33',NULL,NULL),(2160,'00925','S','Urb Santa Rita','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(5579,'04911','S','Starks','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.796485,-69.894103,0,'2013-07-06 12:44:30',NULL,NULL),(57047,'66210','S','Overland Park','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.924700,-94.678320,0,'2013-07-06 12:44:33',NULL,NULL),(723,'00687','S','Sect Pabon','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(51054,'58740','S','Wolseth','A','Renville','38075','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.519799,-101.238037,0,'2013-07-06 12:44:33',NULL,NULL),(21004,'21837','S','Mardela Spgs','A','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.455644,-75.755948,0,'2013-07-06 12:44:31',NULL,NULL),(38069,'43065','S','Powell','D','Delaware','39041','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.172501,-83.093346,0,'2013-07-06 12:44:32',NULL,NULL),(32231,'35579','S','Oakman','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.667762,-87.368234,0,'2013-07-06 12:44:32',NULL,NULL),(30400,'33322','S','Sunrise','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.150168,-80.273686,0,'2013-07-06 12:44:32',NULL,NULL),(14675,'15241','S','Upper St Clair','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.357620,-80.059980,0,'2013-07-06 12:44:31',NULL,NULL),(29238,'32433','S','Defuniak Springs','D','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.723150,-86.120366,0,'2013-07-06 12:44:32',NULL,NULL),(26758,'29430','P','Bethera','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.201366,-79.789924,0,'2013-07-06 12:44:31',NULL,NULL),(6044,'05408','S','N Burlington','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446628,-73.175354,0,'2013-07-06 12:44:30',NULL,NULL),(10245,'10469','S','Baychester','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868747,-73.849303,0,'2013-07-06 12:44:30',NULL,NULL),(10922,'11430','S','John F Kennedy Airport','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.661453,-73.811830,0,'2013-07-06 12:44:30',NULL,NULL),(24366,'27052','S','Brook Cove','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.313380,-80.155080,0,'2013-07-06 12:44:31',NULL,NULL),(16601,'17327','S','Glen Rock','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.798447,-76.722134,0,'2013-07-06 12:44:31',NULL,NULL),(13217,'13634','S','Adams Cove','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(63590,'75785','S','Rusk','D','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.799220,-95.164860,0,'2013-07-06 12:44:34',NULL,NULL),(53842,'62320','S','Columbus','A','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.038481,-91.064920,0,'2013-07-06 12:44:33',NULL,NULL),(20323,'20833','S','Sunshine','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.206400,-77.050740,0,'2013-07-06 12:44:31',NULL,NULL),(33754,'37852','S','Glen Mary','N','Scott','47151','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.326828,-84.571266,0,'2013-07-06 12:44:32',NULL,NULL),(39461,'44707','S','Waco','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.780264,-81.361212,0,'2013-07-06 12:44:32',NULL,NULL),(45055,'50501','S','Palm Grove','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(47532,'54812','S','Poskin','A','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.401861,-91.872294,0,'2013-07-06 12:44:32',NULL,NULL),(15653,'16745','S','Rixford','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.925648,-78.497127,0,'2013-07-06 12:44:31',NULL,NULL),(78854,'98340','S','Hansville','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.905828,-122.573462,0,'2013-07-06 12:44:34',NULL,NULL),(64619,'76691','S','West','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.775460,-97.104060,0,'2013-07-06 12:44:34',NULL,NULL),(60089,'71358','S','Palmetto','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.699586,-91.915616,0,'2013-07-06 12:44:33',NULL,NULL),(15436,'16375','P','Lamartine','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.221081,-79.637892,0,'2013-07-06 12:44:31',NULL,NULL),(32947,'36575','S','Semmes','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.757651,-88.266909,0,'2013-07-06 12:44:32',NULL,NULL),(3567,'01952','S','Salisbury','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.843480,-70.820580,0,'2013-07-06 12:44:30',NULL,NULL),(43178,'48279','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.327887,-83.042036,0,'2013-07-06 12:44:32',NULL,NULL),(75333,'93791','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.790318,-119.829786,0,'2013-07-06 12:44:34',NULL,NULL),(68630,'81635','S','Battlement Mesa','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.460598,-108.009596,0,'2013-07-06 12:44:34',NULL,NULL),(62835,'75002','S','Parker','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.087120,-96.616980,0,'2013-07-06 12:44:33',NULL,NULL),(59754,'71153','U','Dowus','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.515347,-93.749932,0,'2013-07-06 12:44:33',NULL,NULL),(50743,'58401','S','Jamestwn','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(4904,'04062','S','Windham','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.808062,-70.420871,0,'2013-07-06 12:44:30',NULL,NULL),(38157,'43148','S','Pleasantville','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.814868,-82.502382,0,'2013-07-06 12:44:32',NULL,NULL),(35767,'39741','S','Griffith','N','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.613034,-88.845449,0,'2013-07-06 12:44:32',NULL,NULL),(35574,'39571','S','Cuevas','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.367611,-89.262586,0,'2013-07-06 12:44:32',NULL,NULL),(28968,'32206','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.351865,-81.643107,0,'2013-07-06 12:44:32',NULL,NULL),(9608,'10031','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.827379,-73.948071,0,'2013-07-06 12:44:30',NULL,NULL),(70322,'84624','S','Oasis','A','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(67884,'80860','P','Victor','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.739224,-105.125564,0,'2013-07-06 12:44:34',NULL,NULL),(65103,'77365','S','Sorters','N','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.105908,-95.260353,0,'2013-07-06 12:44:34',NULL,NULL),(59949,'71301','S','Martin Park','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(47727,'55009','S','Cannon Falls','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.507743,-92.905112,0,'2013-07-06 12:44:33',NULL,NULL),(38185,'43195','U','Groveport','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.854672,-82.883640,0,'2013-07-06 12:44:32',NULL,NULL),(33827,'37928','P','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.060090,-83.911345,0,'2013-07-06 12:44:32',NULL,NULL),(32659,'36258','S','Abel','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.454247,-85.684409,0,'2013-07-06 12:44:32',NULL,NULL),(2385,'00949','S','Urb La Rosaleda Ii','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(11489,'12020','S','Maltaville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(38307,'43356','S','Waldo','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.464334,-83.062303,0,'2013-07-06 12:44:32',NULL,NULL),(8157,'07853','S','Long Valley','D','Morris','34027','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.795321,-74.782913,0,'2013-07-06 12:44:30',NULL,NULL),(57906,'67651','S','Natoma','D','Osborne','20141','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.188526,-99.024213,0,'2013-07-06 12:44:33',NULL,NULL),(54924,'63102','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.636396,-90.185776,0,'2013-07-06 12:44:33',NULL,NULL),(52848,'61322','P','Depue','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.325484,-89.303078,0,'2013-07-06 12:44:33',NULL,NULL),(39934,'45226','S','East End','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.118178,-84.426641,0,'2013-07-06 12:44:32',NULL,NULL),(15989,'17034','S','Highspire','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.206340,-76.789304,0,'2013-07-06 12:44:31',NULL,NULL),(37841,'42459','S','Sturgis','D','Union','21225','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.550004,-87.985593,0,'2013-07-06 12:44:32',NULL,NULL),(1869,'00791','S','Urb El Recreo','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(24909,'27715','P','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.013683,-78.959137,0,'2013-07-06 12:44:31',NULL,NULL),(10716,'11243','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.679972,-73.981434,0,'2013-07-06 12:44:30',NULL,NULL),(27521,'30213','S','Fairburn','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.577678,-84.594233,0,'2013-07-06 12:44:31',NULL,NULL),(73549,'91359','P','Westlake Village','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.194443,-118.820014,0,'2013-07-06 12:44:34',NULL,NULL),(63305,'75563','S','New Colony','N','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.009734,-94.366056,0,'2013-07-06 12:44:33',NULL,NULL),(3094,'01223','S','Sherwood Forest','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.381306,-73.143709,0,'2013-07-06 12:44:30',NULL,NULL),(19077,'19560','S','Cherokee Ranch','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.396140,-75.889620,0,'2013-07-06 12:44:31',NULL,NULL),(44503,'49929','P','Greenland','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.782554,-89.095113,0,'2013-07-06 12:44:32',NULL,NULL),(45779,'52159','S','Monona','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.049280,-91.388773,0,'2013-07-06 12:44:32',NULL,NULL),(51711,'60010','S','Deer Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(55276,'63466','P','Saint Patrick','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.317858,-91.663974,0,'2013-07-06 12:44:33',NULL,NULL),(34881,'38943','S','McCarley','N','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.590842,-89.850324,0,'2013-07-06 12:44:32',NULL,NULL),(31935,'35184','S','West Blocton','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.205643,-87.071388,0,'2013-07-06 12:44:32',NULL,NULL),(39003,'44137','S','Maple Hts','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.409495,-81.558216,0,'2013-07-06 12:44:32',NULL,NULL),(24358,'27046','S','Sandy Ridge','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.492663,-80.089256,0,'2013-07-06 12:44:31',NULL,NULL),(44385,'49801','S','Iron Mtn','N','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.817870,-88.066576,0,'2013-07-06 12:44:32',NULL,NULL),(45216,'50635','S','Gladbrook','D','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.183970,-92.711709,0,'2013-07-06 12:44:32',NULL,NULL),(51513,'59648','S','Wolf Creek','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.044107,-112.063648,0,'2013-07-06 12:44:33',NULL,NULL),(57663,'67212','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.698135,-97.436018,0,'2013-07-06 12:44:33',NULL,NULL),(73502,'91331','S','Lakeview Terrace','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252512,-118.425349,0,'2013-07-06 12:44:34',NULL,NULL),(78818,'98333','S','Shorewood Beach','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250837,-122.623135,0,'2013-07-06 12:44:34',NULL,NULL),(14811,'15416','P','Brownfield','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.858474,-79.712651,0,'2013-07-06 12:44:31',NULL,NULL),(14627,'15232','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.451373,-79.932761,0,'2013-07-06 12:44:31',NULL,NULL),(38681,'43970','P','Wolf Run','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.465643,-80.885986,0,'2013-07-06 12:44:32',NULL,NULL),(14163,'14728','S','Dewittville','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.241482,-79.401184,0,'2013-07-06 12:44:31',NULL,NULL),(21742,'23031','P','Christchurch','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.597737,-76.450035,0,'2013-07-06 12:44:31',NULL,NULL),(25341,'28218','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.221989,-80.788267,0,'2013-07-06 12:44:31',NULL,NULL),(26815,'29477','S','St George','N','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.185354,-80.581025,0,'2013-07-06 12:44:31',NULL,NULL),(28734,'31908','P','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.531133,-84.938045,0,'2013-07-06 12:44:32',NULL,NULL),(27686,'30336','S','Industrial','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.749608,-84.551548,0,'2013-07-06 12:44:31',NULL,NULL),(26908,'29580','S','Nesmith','D','Williamsburg','45089','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.598052,-79.566749,0,'2013-07-06 12:44:31',NULL,NULL),(43464,'48553','U','Gm Truck and Bus','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.974333,-83.716168,0,'2013-07-06 12:44:32',NULL,NULL),(48258,'55427','S','Golden Valley','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.996340,-93.379980,0,'2013-07-06 12:44:33',NULL,NULL),(54448,'62849','S','Helm','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.613375,-88.790283,0,'2013-07-06 12:44:33',NULL,NULL),(56319,'65104','U','Div of Employment Sec','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.575066,-92.173635,0,'2013-07-06 12:44:33',NULL,NULL),(58144,'68155','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.242263,-95.965961,0,'2013-07-06 12:44:33',NULL,NULL),(66322,'78596','S','Weslaco','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160167,-97.986360,0,'2013-07-06 12:44:34',NULL,NULL),(14988,'15644','S','Jeannette','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.333621,-79.614905,0,'2013-07-06 12:44:31',NULL,NULL),(19923,'20555','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896447,-77.041074,0,'2013-07-06 12:44:31',NULL,NULL),(22496,'24070','S','Catawba','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.356587,-80.180426,0,'2013-07-06 12:44:31',NULL,NULL),(24722,'27512','P','Cary','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.767970,-78.798984,0,'2013-07-06 12:44:31',NULL,NULL),(28491,'31521','P','Brunswick','D','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.158959,-81.485895,0,'2013-07-06 12:44:32',NULL,NULL),(25580,'28436','S','Delco','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.341124,-78.187982,0,'2013-07-06 12:44:31',NULL,NULL),(26178,'28753','S','Marshall','D','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.837619,-82.710606,0,'2013-07-06 12:44:31',NULL,NULL),(39615,'44882','S','Deunquat','N','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943820,-83.138880,0,'2013-07-06 12:44:32',NULL,NULL),(43778,'49037','S','Battle Creek','D','Calhoun','26025','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.237105,-85.203233,0,'2013-07-06 12:44:32',NULL,NULL),(54387,'62817','S','Dale','A','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.960013,-88.453753,0,'2013-07-06 12:44:33',NULL,NULL),(79388,'98685','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.709089,-122.681254,0,'2013-07-06 12:44:34',NULL,NULL),(31228,'33967','S','Ft Myers','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637179,-81.872520,0,'2013-07-06 12:44:32',NULL,NULL),(2689,'00968','S','Urb Parkside','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(2939,'01028','S','E Longmeadow','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.068418,-72.504285,0,'2013-07-06 12:44:30',NULL,NULL),(40557,'45856','S','West Leipsic','N','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.097024,-83.996732,0,'2013-07-06 12:44:32',NULL,NULL),(48627,'55804','S','Duluth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.868596,-91.981305,0,'2013-07-06 12:44:33',NULL,NULL),(55151,'63363','S','New Florence','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.894700,-91.517100,0,'2013-07-06 12:44:33',NULL,NULL),(79842,'99540','S','Bird Creek','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.116878,-149.899764,0,'2013-07-06 12:44:34',NULL,NULL),(1110,'00725','S','Urb San Rafael','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(13461,'13783','S','Cadosia','A','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(29092,'32260','P','JAX','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.077501,-81.580838,0,'2013-07-06 12:44:32',NULL,NULL),(68532,'81413','S','Coalby','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.957100,-107.913960,0,'2013-07-06 12:44:34',NULL,NULL),(74353,'92410','S','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.105653,-117.294667,0,'2013-07-06 12:44:34',NULL,NULL),(77977,'97384','P','Mehama','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.790049,-122.598524,0,'2013-07-06 12:44:34',NULL,NULL),(78432,'98052','S','Redmond','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.683648,-122.121837,0,'2013-07-06 12:44:34',NULL,NULL),(2736,'00969','S','Urb La Lomita','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(38914,'44119','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.586699,-81.547659,0,'2013-07-06 12:44:32',NULL,NULL),(33837,'37934','S','Concord Farr','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.876100,-84.170300,0,'2013-07-06 12:44:32',NULL,NULL),(29889,'33042','S','Summerland Key','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(27753,'30360','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928090,-84.278530,0,'2013-07-06 12:44:31',NULL,NULL),(23853,'26143','S','Elizabeth','D','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(19599,'20227','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894569,-77.033661,0,'2013-07-06 12:44:31',NULL,NULL),(51725,'60010','S','S Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(44563,'50014','S','Ames','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.023745,-93.662894,0,'2013-07-06 12:44:32',NULL,NULL),(43490,'48616','S','Chesaning','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.191198,-84.118351,0,'2013-07-06 12:44:32',NULL,NULL),(43333,'48367','S','Addison Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.844709,-83.140674,0,'2013-07-06 12:44:32',NULL,NULL),(6696,'06057','S','New Hartford','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844360,-73.012800,0,'2013-07-06 12:44:30',NULL,NULL),(20273,'20787','P','Hyattsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.001883,-76.969387,0,'2013-07-06 12:44:31',NULL,NULL),(934,'00715','S','Bo Calzada','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014885,-66.586461,0,'2013-07-06 12:44:30',NULL,NULL),(53209,'61616','S','Peoria Heights','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.751710,-89.600183,0,'2013-07-06 12:44:33',NULL,NULL),(62156,'73728','S','Lambert','A','Alfalfa','40003','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.755620,-98.350679,0,'2013-07-06 12:44:33',NULL,NULL),(64336,'76504','S','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.093709,-97.369617,0,'2013-07-06 12:44:34',NULL,NULL),(70534,'85018','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.502501,-111.982899,0,'2013-07-06 12:44:34',NULL,NULL),(76824,'95958','P','Nelson','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.555497,-121.772180,0,'2013-07-06 12:44:34',NULL,NULL),(77148,'96161','S','Tahoe Donner','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.353299,-120.189535,0,'2013-07-06 12:44:34',NULL,NULL),(4460,'03256','S','New Hampton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.615072,-71.467519,0,'2013-07-06 12:44:30',NULL,NULL),(29794,'33019','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.021851,-80.123476,0,'2013-07-06 12:44:32',NULL,NULL),(27342,'30044','S','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.921718,-84.072670,0,'2013-07-06 12:44:31',NULL,NULL),(22690,'24318','S','Nebo','N','Bland','51021','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.010137,-81.362054,0,'2013-07-06 12:44:31',NULL,NULL),(2490,'00956','S','Urb Sunny Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(2019,'00916','P','Barrio Obrero','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.376517,-66.162719,0,'2013-07-06 12:44:30',NULL,NULL),(39761,'45115','P','Byrd','N','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.812180,-83.697339,0,'2013-07-06 12:44:32',NULL,NULL),(42905,'48103','S','Lodi Township','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.270780,-83.808660,0,'2013-07-06 12:44:32',NULL,NULL),(48283,'55433','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.167194,-93.324436,0,'2013-07-06 12:44:33',NULL,NULL),(78663,'98232','S','Samish Island','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.562380,-122.444940,0,'2013-07-06 12:44:34',NULL,NULL),(79808,'99402','S','Asotin','D','Asotin','53003','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.340395,-117.042596,0,'2013-07-06 12:44:34',NULL,NULL),(16861,'17563','S','Wrightsdale','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(15051,'15715','P','Big Run','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.970500,-78.879764,0,'2013-07-06 12:44:31',NULL,NULL),(29995,'33114','P','Coral Gables','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.752299,-80.270652,0,'2013-07-06 12:44:32',NULL,NULL),(28098,'30750','S','Lookout Mtn','A','Walker','13295','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.975006,-85.355133,0,'2013-07-06 12:44:31',NULL,NULL),(25668,'28510','S','Minnesott Beach','A','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.979257,-76.825851,0,'2013-07-06 12:44:31',NULL,NULL),(40840,'46219','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.780423,-86.044659,0,'2013-07-06 12:44:32',NULL,NULL),(47723,'55007','S','Quamba','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.946447,-92.864586,0,'2013-07-06 12:44:33',NULL,NULL),(63724,'75931','S','Browndell','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',31.098300,-93.999180,0,'2013-07-06 12:44:34',NULL,NULL),(69993,'84122','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.798588,-111.960684,0,'2013-07-06 12:44:34',NULL,NULL),(78190,'97722','S','Diamond','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.010406,-118.664099,0,'2013-07-06 12:44:34',NULL,NULL),(7176,'06457','S','Middletown','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.548962,-72.663524,0,'2013-07-06 12:44:30',NULL,NULL),(39156,'44288','S','Freedom','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.242226,-81.056024,0,'2013-07-06 12:44:32',NULL,NULL),(38638,'43932','S','Cream City','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.590849,-80.708824,0,'2013-07-06 12:44:32',NULL,NULL),(15884,'17003','S','Syner','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(25241,'28104','S','Weddington','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.116667,-80.723889,0,'2013-07-06 12:44:31',NULL,NULL),(24929,'27812','S','Bethel','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.806779,-77.378225,0,'2013-07-06 12:44:31',NULL,NULL),(23072,'24882','S','Simon','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.617947,-81.767737,0,'2013-07-06 12:44:31',NULL,NULL),(9732,'10090','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754817,-73.994447,0,'2013-07-06 12:44:30',NULL,NULL),(11564,'12063','S','East Schodack','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.569709,-73.614510,0,'2013-07-06 12:44:30',NULL,NULL),(78986,'98376','S','Quilcene','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.813700,-122.850480,0,'2013-07-06 12:44:34',NULL,NULL),(72880,'90012','S','Federal','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.063679,-118.238854,0,'2013-07-06 12:44:34',NULL,NULL),(8226,'07974','S','New Providnce','A','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.700446,-74.405937,0,'2013-07-06 12:44:30',NULL,NULL),(20407,'20903','S','Takoma Park','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.012780,-76.981200,0,'2013-07-06 12:44:31',NULL,NULL),(34127,'38194','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.064129,-89.999493,0,'2013-07-06 12:44:32',NULL,NULL),(44705,'50139','S','Lacona','D','Warren','19181','Iowa','IA','19','2120','641','Central',-6.0,'Y',41.196919,-93.394123,0,'2013-07-06 12:44:32',NULL,NULL),(51570,'59758','S','W Yellowstone','A','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',44.711443,-111.150995,0,'2013-07-06 12:44:33',NULL,NULL),(37957,'42719','P','Campbellsville','D','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.341936,-85.340234,0,'2013-07-06 12:44:32',NULL,NULL),(31900,'35144','P','Elliotsvle','N','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.200000,-86.783333,0,'2013-07-06 12:44:32',NULL,NULL),(73840,'91789','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.014965,-117.856127,0,'2013-07-06 12:44:34',NULL,NULL),(903,'00705','S','Ext San Luis','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(64545,'76650','P','Irene','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.989969,-96.871536,0,'2013-07-06 12:44:34',NULL,NULL),(4092,'02668','S','West Barnstable','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.706060,-70.366440,0,'2013-07-06 12:44:30',NULL,NULL),(41660,'47144','U','Jeffersonvlle','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.332730,-85.708400,0,'2013-07-06 12:44:32',NULL,NULL),(32454,'36024','S','Central','N','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.681580,-85.997880,0,'2013-07-06 12:44:32',NULL,NULL),(79707,'99211','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.665303,-117.310120,0,'2013-07-06 12:44:34',NULL,NULL),(27756,'30360','S','Dunwoody','A','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.928090,-84.278530,0,'2013-07-06 12:44:31',NULL,NULL),(53856,'62329','P','Colusa','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.598632,-91.137878,0,'2013-07-06 12:44:33',NULL,NULL),(60242,'71433','S','Calcasieu','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',30.984468,-92.639592,0,'2013-07-06 12:44:33',NULL,NULL),(67062,'79565','S','Iatan','N','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.359444,-101.013905,0,'2013-07-06 12:44:34',NULL,NULL),(33594,'37614','P','Johnson City','D','Washington','47179','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.330892,-82.365584,0,'2013-07-06 12:44:32',NULL,NULL),(47678,'54952','S','Menasha','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.217032,-88.430451,0,'2013-07-06 12:44:33',NULL,NULL),(40450,'45735','S','Guysville','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.259585,-81.927828,0,'2013-07-06 12:44:32',NULL,NULL),(36829,'41071','S','So Newport','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.082844,-84.482628,0,'2013-07-06 12:44:32',NULL,NULL),(74935,'93407','S','Cal Poly University','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.298873,-120.658799,0,'2013-07-06 12:44:34',NULL,NULL),(76964,'96048','S','Helena','A','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.780780,-123.050679,0,'2013-07-06 12:44:34',NULL,NULL),(2015,'00915','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(16441,'17236','S','Claylick','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(26412,'29115','S','Orangeburg','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.581944,-80.818056,0,'2013-07-06 12:44:31',NULL,NULL),(64634,'76706','S','Robinson','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.480320,-97.115880,0,'2013-07-06 12:44:34',NULL,NULL),(31578,'34652','S','NW Prt Rchy','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.238545,-82.730700,0,'2013-07-06 12:44:32',NULL,NULL),(53654,'62205','S','Washingtn Park','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.615813,-90.128903,0,'2013-07-06 12:44:33',NULL,NULL),(30603,'33422','P','Haverhill','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.750328,-80.128524,0,'2013-07-06 12:44:32',NULL,NULL),(68629,'81633','S','Elk Springs','A','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.314931,-108.350141,0,'2013-07-06 12:44:34',NULL,NULL),(48651,'55906','S','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.060636,-92.439257,0,'2013-07-06 12:44:33',NULL,NULL),(77347,'96727','S','Ahualoa','N','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.087407,-155.518923,0,'2013-07-06 12:44:34',NULL,NULL),(58079,'68065','S','Valparaiso','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.078461,-96.829772,0,'2013-07-06 12:44:33',NULL,NULL),(12433,'12955','S','Merrill','A','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.793668,-73.965388,0,'2013-07-06 12:44:30',NULL,NULL),(21895,'23184','P','Wicomico','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.292098,-76.509951,0,'2013-07-06 12:44:31',NULL,NULL),(12341,'12874','S','Sabbath Day Point','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.667500,-73.514444,0,'2013-07-06 12:44:30',NULL,NULL),(77062,'96120','S','Markleeville','D','Alpine','06003','California','CA','06','0000','530','Pacific',-8.0,'Y',38.632880,-119.825920,0,'2013-07-06 12:44:34',NULL,NULL),(13384,'13743','S','Candor','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.217072,-76.337592,0,'2013-07-06 12:44:31',NULL,NULL),(3246,'01432','S','Ft Devens','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.559756,-71.575320,0,'2013-07-06 12:44:30',NULL,NULL),(18127,'18821','S','Great Bend','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.973211,-75.746207,0,'2013-07-06 12:44:31',NULL,NULL),(56539,'65444','S','Bendavis','A','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.399403,-92.038861,0,'2013-07-06 12:44:33',NULL,NULL),(56480,'65325','S','Mount Hulda','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.449974,-93.217748,0,'2013-07-06 12:44:33',NULL,NULL),(56235,'65046','S','Jamestown','D','Moniteau','29135','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.790635,-92.483677,0,'2013-07-06 12:44:33',NULL,NULL),(10382,'10594','S','Thornwood','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.117322,-73.773933,0,'2013-07-06 12:44:30',NULL,NULL),(40108,'45317','S','Lena','N','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.188641,-83.992318,0,'2013-07-06 12:44:32',NULL,NULL),(43750,'49009','S','Kalamazoo','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.273649,-85.688557,0,'2013-07-06 12:44:32',NULL,NULL),(9221,'09517','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30222,'33187','S','Country Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.585600,-80.504660,0,'2013-07-06 12:44:32',NULL,NULL),(5025,'04243','P','Lewiston','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.092083,-70.175937,0,'2013-07-06 12:44:30',NULL,NULL),(18609,'19145','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.924229,-75.186845,0,'2013-07-06 12:44:31',NULL,NULL),(29534,'32791','P','Wekiva Spg','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.703312,-81.419952,0,'2013-07-06 12:44:32',NULL,NULL),(53385,'61803','P','Urbana','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.106393,-88.214050,0,'2013-07-06 12:44:33',NULL,NULL),(45241,'50653','S','Aureola','N','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.966180,-92.880960,0,'2013-07-06 12:44:32',NULL,NULL),(34306,'38548','S','Buffalo Valley','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.182066,-85.756226,0,'2013-07-06 12:44:32',NULL,NULL),(70174,'84325','S','Petersboro','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.749980,-111.981060,0,'2013-07-06 12:44:34',NULL,NULL),(4550,'03451','S','Hinsdale','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.799792,-72.501077,0,'2013-07-06 12:44:30',NULL,NULL),(38059,'43055','S','Newark','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.116667,-82.433333,0,'2013-07-06 12:44:32',NULL,NULL),(35725,'39669','S','Wilkinson','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(33599,'37617','S','Blountville','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.533107,-82.359186,0,'2013-07-06 12:44:32',NULL,NULL),(19952,'20579','U','Foreign Claims Settlement','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901432,-77.044897,0,'2013-07-06 12:44:31',NULL,NULL),(29830,'33029','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.006742,-80.428893,0,'2013-07-06 12:44:32',NULL,NULL),(4961,'04106','S','So Portland','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.620751,-70.291117,0,'2013-07-06 12:44:30',NULL,NULL),(20192,'20749','P','Fort Washington','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.733525,-77.003006,0,'2013-07-06 12:44:31',NULL,NULL),(38775,'44053','S','Sheffield Twp','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.428474,-82.204417,0,'2013-07-06 12:44:32',NULL,NULL),(54586,'62901','S','Briarwood Trace','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(44210,'49634','P','Filer City','D','Manistee','26101','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.214543,-86.288914,0,'2013-07-06 12:44:32',NULL,NULL),(43592,'48756','S','Roos','A','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.183333,-84.035278,0,'2013-07-06 12:44:32',NULL,NULL),(73345,'91001','S','Altadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.188413,-118.140109,0,'2013-07-06 12:44:34',NULL,NULL),(74618,'92782','S','Tustin','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.734584,-117.786935,0,'2013-07-06 12:44:34',NULL,NULL),(32137,'35453','S','Cottondale','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.200553,-87.401063,0,'2013-07-06 12:44:32',NULL,NULL),(70677,'85244','P','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.235097,-111.761257,0,'2013-07-06 12:44:34',NULL,NULL),(35021,'39154','S','Learned','A','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.223960,-90.443040,0,'2013-07-06 12:44:32',NULL,NULL),(44033,'49418','S','Wyoming','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.896187,-85.756061,0,'2013-07-06 12:44:32',NULL,NULL),(58330,'68454','S','Unadilla','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.683866,-96.272409,0,'2013-07-06 12:44:33',NULL,NULL),(31920,'35172','S','Trafford','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.813893,-86.747615,0,'2013-07-06 12:44:32',NULL,NULL),(10615,'11050','S','Baxter Estates','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.843056,-73.715278,0,'2013-07-06 12:44:30',NULL,NULL),(49000,'56243','S','Grove City','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.152697,-94.681564,0,'2013-07-06 12:44:33',NULL,NULL),(13842,'14223','S','Kenmore','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.974220,-78.856260,0,'2013-07-06 12:44:31',NULL,NULL),(46936,'54160','P','Potter','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.119133,-88.096915,0,'2013-07-06 12:44:32',NULL,NULL),(45677,'52042','S','Littleport','A','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.649161,-91.399965,0,'2013-07-06 12:44:32',NULL,NULL),(7623,'07060','S','Muhlenberg','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.631340,-74.437020,0,'2013-07-06 12:44:30',NULL,NULL),(17405,'17901','S','Pine Hill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.675560,-76.232640,0,'2013-07-06 12:44:31',NULL,NULL),(6710,'06066','S','Turnpike','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(76791,'95945','S','Bear River Pines','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(67154,'79783','S','Tarzan','D','Martin','48317','Texas','TX','48','0000','432','Central',-6.0,'Y',32.395431,-102.032317,0,'2013-07-06 12:44:34',NULL,NULL),(56820,'65784','S','Zanoni','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.683625,-92.304487,0,'2013-07-06 12:44:33',NULL,NULL),(9059,'08903','P','New Brunswick','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.509874,-74.445463,0,'2013-07-06 12:44:30',NULL,NULL),(78597,'98188','S','McMicken Heights','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(70937,'85640','S','Agua Linda','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.596899,-111.047790,0,'2013-07-06 12:44:34',NULL,NULL),(39799,'45135','S','Fayette County','A','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.334108,-83.547824,0,'2013-07-06 12:44:32',NULL,NULL),(20145,'20726','P','Laurel','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.089392,-76.852395,0,'2013-07-06 12:44:31',NULL,NULL),(58497,'68763','S','Shields','N','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.456401,-98.648879,0,'2013-07-06 12:44:33',NULL,NULL),(56931,'66072','S','Parker','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.327153,-94.990741,0,'2013-07-06 12:44:33',NULL,NULL),(5147,'04418','S','Costigan','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(39811,'45140','S','Symmes Twp','A','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(49557,'56711','P','Angle Inlet','D','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',49.309708,-95.090831,0,'2013-07-06 12:44:33',NULL,NULL),(49864,'57252','S','Milbank','D','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.218981,-96.632324,0,'2013-07-06 12:44:33',NULL,NULL),(26754,'29426','S','Adams Run','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.789760,-80.352960,0,'2013-07-06 12:44:31',NULL,NULL),(30270,'33243','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.701397,-80.299020,0,'2013-07-06 12:44:32',NULL,NULL),(28468,'31420','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.979375,-81.145823,0,'2013-07-06 12:44:32',NULL,NULL),(77036,'96104','S','Cedarville','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.519083,-120.167083,0,'2013-07-06 12:44:34',NULL,NULL),(43317,'48357','S','Highland Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.656319,-83.636330,0,'2013-07-06 12:44:32',NULL,NULL),(39628,'44890','S','Boughtonville','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(46591,'53545','S','Janesville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.689826,-89.050644,0,'2013-07-06 12:44:32',NULL,NULL),(58871,'69154','S','Penn','N','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408280,-102.349472,0,'2013-07-06 12:44:33',NULL,NULL),(51947,'60132','U','Carol Stream','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.919511,-88.100953,0,'2013-07-06 12:44:33',NULL,NULL),(51278,'59112','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.791631,-108.539787,0,'2013-07-06 12:44:33',NULL,NULL),(31378,'34212','S','Lakewood Ranch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.471865,-82.412165,0,'2013-07-06 12:44:32',NULL,NULL),(35763,'39740','S','Caledonia','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.688435,-88.329881,0,'2013-07-06 12:44:32',NULL,NULL),(71316,'86505','S','Hubbell Trading Post Nationa','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(28702,'31823','S','Pine Mountain Valley','D','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.784644,-84.823456,0,'2013-07-06 12:44:32',NULL,NULL),(6940,'06176','U','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768415,-72.669185,0,'2013-07-06 12:44:30',NULL,NULL),(22019,'23289','U','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542258,-77.434021,0,'2013-07-06 12:44:31',NULL,NULL),(65531,'77801','S','Law','N','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.889720,-96.294450,0,'2013-07-06 12:44:34',NULL,NULL),(61865,'73124','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.431919,-97.525309,0,'2013-07-06 12:44:33',NULL,NULL),(17851,'18428','S','Blooming Grv','A','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.473980,-75.205080,0,'2013-07-06 12:44:31',NULL,NULL),(53689,'62226','S','Belleville','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.544506,-90.000820,0,'2013-07-06 12:44:33',NULL,NULL),(33274,'37101','S','McEwen','N','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.138332,-87.657349,0,'2013-07-06 12:44:32',NULL,NULL),(22287,'23804','P','Petersburg','D','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.229058,-77.403672,0,'2013-07-06 12:44:31',NULL,NULL),(71100,'85938','S','Springville','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.132976,-109.279764,0,'2013-07-06 12:44:34',NULL,NULL),(28327,'31146','P','Perimeter Center Finance','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.925442,-84.341206,0,'2013-07-06 12:44:32',NULL,NULL),(73436,'91221','P','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165334,-118.289424,0,'2013-07-06 12:44:34',NULL,NULL),(71617,'87347','P','Continental Divide','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432459,-108.729828,0,'2013-07-06 12:44:34',NULL,NULL),(30934,'33712','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.730222,-82.667425,0,'2013-07-06 12:44:32',NULL,NULL),(69474,'83660','S','Roswell','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.774723,-116.935468,0,'2013-07-06 12:44:34',NULL,NULL),(69284,'83442','S','Labelle','N','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.686480,-111.879600,0,'2013-07-06 12:44:34',NULL,NULL),(75761,'94619','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.790966,-122.181455,0,'2013-07-06 12:44:34',NULL,NULL),(65805,'78132','S','Startzville','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.777220,-98.152980,0,'2013-07-06 12:44:34',NULL,NULL),(73799,'91752','S','Eastvale','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995007,-117.528742,0,'2013-07-06 12:44:34',NULL,NULL),(79678,'99170','S','Rosalia','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.303675,-117.357249,0,'2013-07-06 12:44:34',NULL,NULL),(62809,'74943','P','Lequire','D','Haskell','40061','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.103491,-95.110276,0,'2013-07-06 12:44:33',NULL,NULL),(2367,'00949','S','Parq Punta Salinas','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(75352,'93915','P','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.675734,-121.627987,0,'2013-07-06 12:44:34',NULL,NULL),(17781,'18347','S','Pocono Lake','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.153003,-75.559822,0,'2013-07-06 12:44:31',NULL,NULL),(65748,'78061','S','Pearsall','D','Frio','48163','Texas','TX','48','0000','830','Central',-6.0,'Y',28.891692,-99.095347,0,'2013-07-06 12:44:34',NULL,NULL),(52290,'60537','P','Millington','D','Kendall','17093','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.560782,-88.601057,0,'2013-07-06 12:44:33',NULL,NULL),(48248,'55424','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.902538,-93.339411,0,'2013-07-06 12:44:33',NULL,NULL),(6809,'06110','S','Corbins Corner','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.732870,-72.735989,0,'2013-07-06 12:44:30',NULL,NULL),(4696,'03813','S','Center Conway','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.163170,-71.012330,0,'2013-07-06 12:44:30',NULL,NULL),(78536,'98133','S','Shoreline','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.739660,-122.333340,0,'2013-07-06 12:44:34',NULL,NULL),(9161,'09328','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(72586,'89406','S','Fallon Colony','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(53032,'61474','S','St Augustine','A','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.734471,-90.357068,0,'2013-07-06 12:44:33',NULL,NULL),(46268,'53022','S','Rockfield','A','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.224428,-88.145134,0,'2013-07-06 12:44:32',NULL,NULL),(38336,'43436','P','Is St George','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.715585,-82.819135,0,'2013-07-06 12:44:32',NULL,NULL),(3678,'02128','S','E Boston','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.383079,-71.018049,0,'2013-07-06 12:44:30',NULL,NULL),(8351,'08046','S','Willingboro','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.030946,-74.880877,0,'2013-07-06 12:44:30',NULL,NULL),(40463,'45750','S','Marietta','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.473611,-81.479167,0,'2013-07-06 12:44:32',NULL,NULL),(30040,'33141','S','North Bay Vlg','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.849841,-80.166593,0,'2013-07-06 12:44:32',NULL,NULL),(55344,'63556','S','Sorrell','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.201394,-93.124920,0,'2013-07-06 12:44:33',NULL,NULL),(78235,'97814','S','Medical Springs','A','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.779688,-117.834287,0,'2013-07-06 12:44:34',NULL,NULL),(61326,'72450','S','Paragould','D','Greene','05055','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.057247,-90.502389,0,'2013-07-06 12:44:33',NULL,NULL),(16216,'17073','S','Sheridan','N','Lebanon','42075','Pennsylvania','PA','42','3240','610/484','Eastern',-5.0,'Y',40.308720,-76.252800,0,'2013-07-06 12:44:31',NULL,NULL),(72366,'89028','P','Laughlin','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.148523,-114.625993,0,'2013-07-06 12:44:34',NULL,NULL),(59934,'71292','S','Siegle','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(76978,'96059','S','Manton','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.445559,-121.844707,0,'2013-07-06 12:44:34',NULL,NULL),(2014,'00915','S','Bo Obrero','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.438019,-66.047360,0,'2013-07-06 12:44:30',NULL,NULL),(20659,'21226','S','Clearwatr Bch','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(6911,'06152','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757059,-72.688643,0,'2013-07-06 12:44:30',NULL,NULL),(7177,'06459','U','Middletown','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.551147,-72.651828,0,'2013-07-06 12:44:30',NULL,NULL),(38990,'44133','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.315718,-81.741271,0,'2013-07-06 12:44:32',NULL,NULL),(38364,'43457','S','Risingsun','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.272080,-83.435820,0,'2013-07-06 12:44:32',NULL,NULL),(476,'00667','S','Est Del Parra','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(19766,'20418','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.889776,-77.044451,0,'2013-07-06 12:44:31',NULL,NULL),(70620,'85128','S','Coolidge','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.983925,-111.524534,0,'2013-07-06 12:44:34',NULL,NULL),(30513,'33404','S','Palm Bch Shrs','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(57462,'66856','S','Olivet','A','Coffey','20031','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.389155,-95.844704,0,'2013-07-06 12:44:33',NULL,NULL),(51111,'58784','S','Lostwood','A','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.312403,-102.392847,0,'2013-07-06 12:44:33',NULL,NULL),(34392,'38619','S','Harmontown','N','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.510320,-89.901900,0,'2013-07-06 12:44:32',NULL,NULL),(73078,'90209','P','Beverly Hills','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.071996,-118.391420,0,'2013-07-06 12:44:34',NULL,NULL),(35706,'39666','S','Topisaw','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.309020,-90.421800,0,'2013-07-06 12:44:32',NULL,NULL),(78203,'97739','S','East Lake','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.704905,-121.531851,0,'2013-07-06 12:44:34',NULL,NULL),(25360,'28235','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.214514,-80.825694,0,'2013-07-06 12:44:31',NULL,NULL),(70343,'84634','P','Gunnison','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.143543,-111.841228,0,'2013-07-06 12:44:34',NULL,NULL),(52094,'60411','S','Chicago Hts','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(35105,'39208','S','JXN','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.271720,-90.104940,0,'2013-07-06 12:44:32',NULL,NULL),(75012,'93457','P','Santa Maria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.865278,-120.435000,0,'2013-07-06 12:44:34',NULL,NULL),(40757,'46146','S','Homer','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.577781,-85.579338,0,'2013-07-06 12:44:32',NULL,NULL),(43193,'48302','S','Bloomfld Twp','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(51504,'59640','P','Marysville','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.753933,-112.302114,0,'2013-07-06 12:44:33',NULL,NULL),(13450,'13778','S','Coventry','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(19196,'19810','S','Arden','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.820580,-75.508102,0,'2013-07-06 12:44:31',NULL,NULL),(53635,'62201','S','E St Louis','N','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(27161,'29835','S','Bordeaux','N','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.911159,-82.290467,0,'2013-07-06 12:44:31',NULL,NULL),(39312,'44514','S','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.008740,-80.624160,0,'2013-07-06 12:44:32',NULL,NULL),(14538,'15208','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.456388,-79.897619,0,'2013-07-06 12:44:31',NULL,NULL),(28139,'30819','P','Mesena','D','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.460559,-82.591621,0,'2013-07-06 12:44:31',NULL,NULL),(78427,'98051','S','Ravensdale','D','King','53033','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.362470,-121.896169,0,'2013-07-06 12:44:34',NULL,NULL),(60206,'71419','S','Houston Spur','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.723825,-93.637496,0,'2013-07-06 12:44:33',NULL,NULL),(65029,'77327','S','Clark','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(3749,'02171','S','No Quincy','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(36517,'40829','P','Grays Knob','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.841312,-83.318518,0,'2013-07-06 12:44:32',NULL,NULL),(23634,'25755','U','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.416466,-82.447210,0,'2013-07-06 12:44:31',NULL,NULL),(66216,'78552','S','Palm Valley','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.187337,-97.732062,0,'2013-07-06 12:44:34',NULL,NULL),(45259,'50665','S','Fern','N','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.579549,-92.788151,0,'2013-07-06 12:44:32',NULL,NULL),(29866,'33040','S','Fort Jefferson National Mon','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.562514,-81.761061,0,'2013-07-06 12:44:32',NULL,NULL),(40391,'45662','S','Sciotoville','A','Scioto','39145','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.783520,-82.941300,0,'2013-07-06 12:44:32',NULL,NULL),(56537,'65441','S','Bourbon','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.151641,-91.252655,0,'2013-07-06 12:44:33',NULL,NULL),(60253,'71439','S','Hornbeck','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.320895,-93.312646,0,'2013-07-06 12:44:33',NULL,NULL),(27992,'30582','S','Young Harris','D','Towns','13281','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.910667,-83.850085,0,'2013-07-06 12:44:31',NULL,NULL),(18553,'19118','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.086847,-75.197968,0,'2013-07-06 12:44:31',NULL,NULL),(53308,'61738','S','El Paso','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.740699,-89.012596,0,'2013-07-06 12:44:33',NULL,NULL),(66400,'78629','S','Dilworth','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(15483,'16440','S','Venango','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.945363,-79.974932,0,'2013-07-06 12:44:31',NULL,NULL),(23390,'25312','S','Sissonville','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.386908,-81.665551,0,'2013-07-06 12:44:31',NULL,NULL),(51389,'59418','S','Buffalo','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.797946,-109.687162,0,'2013-07-06 12:44:33',NULL,NULL),(47937,'55115','S','Grant Township','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(47237,'54501','S','Woodboro','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(21229,'22225','U','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856611,-77.059377,0,'2013-07-06 12:44:31',NULL,NULL),(39296,'44501','P','Youngstown','D','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.097395,-80.661703,0,'2013-07-06 12:44:32',NULL,NULL),(8502,'08097','S','Woodbury Hgts','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.831240,-75.151020,0,'2013-07-06 12:44:30',NULL,NULL),(46843,'54017','S','New Richmond','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(9456,'10007','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712808,-74.009507,0,'2013-07-06 12:44:30',NULL,NULL),(73905,'92010','S','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.106900,-117.287000,0,'2013-07-06 12:44:34',NULL,NULL),(70273,'84526','S','Spring Glen','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(10696,'11221','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.693561,-73.926509,0,'2013-07-06 12:44:30',NULL,NULL),(54992,'63128','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.502540,-90.381840,0,'2013-07-06 12:44:33',NULL,NULL),(40322,'45475','P','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.643805,-84.166326,0,'2013-07-06 12:44:32',NULL,NULL),(4920,'04076','S','N Shapleigh','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.517658,-70.853521,0,'2013-07-06 12:44:30',NULL,NULL),(70538,'85022','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.627465,-112.051962,0,'2013-07-06 12:44:34',NULL,NULL),(23585,'25671','S','Dingess','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.881209,-82.190460,0,'2013-07-06 12:44:31',NULL,NULL),(50609,'58257','S','Mayville','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.498380,-97.323749,0,'2013-07-06 12:44:33',NULL,NULL),(47195,'54487','S','Bay Mills','N','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.474520,-89.727183,0,'2013-07-06 12:44:32',NULL,NULL),(47143,'54459','S','Ogema','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.435960,-90.242894,0,'2013-07-06 12:44:32',NULL,NULL),(74853,'93249','S','Lost Hills','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.655395,-119.769040,0,'2013-07-06 12:44:34',NULL,NULL),(77629,'97005','S','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.488582,-122.804382,0,'2013-07-06 12:44:34',NULL,NULL),(71103,'85941','P','Whiteriver','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.804762,-109.995741,0,'2013-07-06 12:44:34',NULL,NULL),(11109,'11702','S','Babylon','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(68578,'81506','S','Grand Jct','A','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.105108,-108.548046,0,'2013-07-06 12:44:34',NULL,NULL),(8318,'08033','S','Tavistock','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.895208,-75.039366,0,'2013-07-06 12:44:30',NULL,NULL),(50606,'58254','S','McVille','D','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.776680,-98.164800,0,'2013-07-06 12:44:33',NULL,NULL),(8507,'08098','S','Sharptown','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.651717,-75.330001,0,'2013-07-06 12:44:30',NULL,NULL),(26920,'29582','S','Ocean Drive Beach','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(36321,'40383','S','Versailles','D','Woodford','21239','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.049052,-84.716968,0,'2013-07-06 12:44:32',NULL,NULL),(77353,'96731','S','Kahuku','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.678499,-157.957534,0,'2013-07-06 12:44:34',NULL,NULL),(41207,'46725','S','Peabody','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(30963,'33738','P','Madeira Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.801363,-82.801164,0,'2013-07-06 12:44:32',NULL,NULL),(57727,'67410','S','Abilene','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.921079,-97.220096,0,'2013-07-06 12:44:33',NULL,NULL),(61469,'72631','S','Holiday Island','A','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.400948,-93.736695,0,'2013-07-06 12:44:33',NULL,NULL),(53171,'61571','S','Beverly Manor','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.694863,-89.479364,0,'2013-07-06 12:44:33',NULL,NULL),(43073,'48195','S','Southgate','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.205329,-83.206980,0,'2013-07-06 12:44:32',NULL,NULL),(39875,'45207','S','Evanston','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.146978,-84.470797,0,'2013-07-06 12:44:32',NULL,NULL),(57198,'66426','P','Fostoria','D','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.427312,-96.491448,0,'2013-07-06 12:44:33',NULL,NULL),(18735,'19330','S','Cochranville','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.869928,-75.900225,0,'2013-07-06 12:44:31',NULL,NULL),(72798,'89705','S','Carson City','D','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.089040,-119.788777,0,'2013-07-06 12:44:34',NULL,NULL),(67530,'80252','U','Bank Of America','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.792550,-104.897260,0,'2013-07-06 12:44:34',NULL,NULL),(22223,'23601','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.057272,-76.460838,0,'2013-07-06 12:44:31',NULL,NULL),(21081,'22031','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853996,-77.259111,0,'2013-07-06 12:44:31',NULL,NULL),(53730,'62246','S','Woburn','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(46564,'53516','S','Blanchardville','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.784010,-89.902654,0,'2013-07-06 12:44:32',NULL,NULL),(40546,'45848','P','Glandorf','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.023690,-84.070127,0,'2013-07-06 12:44:32',NULL,NULL),(37179,'41501','S','McCombs','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.476931,-82.513726,0,'2013-07-06 12:44:32',NULL,NULL),(9827,'10114','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(74865,'93260','S','Balance Rock','N','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.802184,-118.629785,0,'2013-07-06 12:44:34',NULL,NULL),(33642,'37692','S','Unicoi','D','Unicoi','47171','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.187403,-82.342355,0,'2013-07-06 12:44:32',NULL,NULL),(40518,'45821','S','Cecil','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.219928,-84.603438,0,'2013-07-06 12:44:32',NULL,NULL),(41673,'47164','S','Palmyra','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.406478,-86.089859,0,'2013-07-06 12:44:32',NULL,NULL),(73998,'92107','S','Ocean Beach','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.740687,-117.238741,0,'2013-07-06 12:44:34',NULL,NULL),(53363,'61769','S','Eylar','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.893501,-88.404022,0,'2013-07-06 12:44:33',NULL,NULL),(46088,'52601','S','Burlington','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.806060,-91.120685,0,'2013-07-06 12:44:32',NULL,NULL),(69160,'83318','S','View','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.528311,-113.790822,0,'2013-07-06 12:44:34',NULL,NULL),(62234,'73949','S','Texhoma','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.508709,-101.775332,0,'2013-07-06 12:44:33',NULL,NULL),(62053,'73534','P','Duncan','D','Stephens','40137','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.508526,-97.965888,0,'2013-07-06 12:44:33',NULL,NULL),(55638,'64015','S','Blue Springs','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.017700,-94.310640,0,'2013-07-06 12:44:33',NULL,NULL),(16504,'17264','S','Cherry Grove','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.174380,-77.988180,0,'2013-07-06 12:44:31',NULL,NULL),(12382,'12918','S','Cadyville','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.672587,-73.664389,0,'2013-07-06 12:44:30',NULL,NULL),(3621,'02060','P','North Scituate','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.186869,-71.204063,0,'2013-07-06 12:44:30',NULL,NULL),(68346,'81130','S','Spar City','N','Mineral','08079','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.843042,-106.926914,0,'2013-07-06 12:44:34',NULL,NULL),(63488,'75694','P','Woodlawn','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.670639,-94.345255,0,'2013-07-06 12:44:33',NULL,NULL),(46119,'52639','S','Galland','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.528312,-91.412979,0,'2013-07-06 12:44:32',NULL,NULL),(40087,'45304','S','Gordon','A','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.989474,-84.534278,0,'2013-07-06 12:44:32',NULL,NULL),(67547,'80262','U','Univ of Colorado Med Ctr','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.731445,-104.938641,0,'2013-07-06 12:44:34',NULL,NULL),(34108,'38181','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.052297,-89.942237,0,'2013-07-06 12:44:32',NULL,NULL),(75691,'94561','S','Oakley','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.992866,-121.714643,0,'2013-07-06 12:44:34',NULL,NULL),(30616,'33434','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.383356,-80.163210,0,'2013-07-06 12:44:32',NULL,NULL),(41965,'47408','S','Bloomington','D','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.217645,-86.458495,0,'2013-07-06 12:44:32',NULL,NULL),(57852,'67565','S','Otis','D','Rush','20165','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.534948,-99.052096,0,'2013-07-06 12:44:33',NULL,NULL),(54638,'62922','S','Egyptian Hills','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.618809,-88.837781,0,'2013-07-06 12:44:33',NULL,NULL),(29630,'32886','U','Wells Fargo','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.541241,-81.380821,0,'2013-07-06 12:44:32',NULL,NULL),(35455,'39483','S','Jamestown','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(76100,'95223','S','Dorrington','N','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.263800,-120.332640,0,'2013-07-06 12:44:34',NULL,NULL),(438,'00662','S','Urb Cassandra','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(76860,'95967','P','Paradise','D','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.742569,-121.604533,0,'2013-07-06 12:44:34',NULL,NULL),(12024,'12513','S','Claverack','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.222240,-73.734878,0,'2013-07-06 12:44:30',NULL,NULL),(4571,'03469','P','West Swanzey','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.864159,-72.328061,0,'2013-07-06 12:44:30',NULL,NULL),(61209,'72310','P','Armorel','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.917680,-89.798860,0,'2013-07-06 12:44:33',NULL,NULL),(36492,'40810','S','Bledsoe','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.872980,-83.432960,0,'2013-07-06 12:44:32',NULL,NULL),(77057,'96119','P','Madeline','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.976847,-120.549695,0,'2013-07-06 12:44:34',NULL,NULL),(7463,'06875','P','Redding Center','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.324045,-73.370143,0,'2013-07-06 12:44:30',NULL,NULL),(30103,'33158','S','Richmond Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(48344,'55474','U','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.981774,-93.263916,0,'2013-07-06 12:44:33',NULL,NULL),(51104,'58781','S','Sawyer','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.066443,-101.078571,0,'2013-07-06 12:44:33',NULL,NULL),(69184,'83337','P','Hill City','D','Camas','16025','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.301826,-115.050884,0,'2013-07-06 12:44:34',NULL,NULL),(67242,'79941','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.758186,-106.483108,0,'2013-07-06 12:44:34',NULL,NULL),(11634,'12120','S','Medusa','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.435003,-74.147921,0,'2013-07-06 12:44:30',NULL,NULL),(38373,'43467','P','W Millgrove','A','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.240434,-83.490982,0,'2013-07-06 12:44:32',NULL,NULL),(1384,'00738','S','Bo Vega Baja','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(4631,'03605','S','Lempster','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.212734,-72.161103,0,'2013-07-06 12:44:30',NULL,NULL),(33416,'37240','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.143381,-86.803365,0,'2013-07-06 12:44:32',NULL,NULL),(75824,'94903','S','Santa Venetia','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.013354,-122.548797,0,'2013-07-06 12:44:34',NULL,NULL),(69010,'83209','U','Idaho State Univ','N','Bannock','16005','Idaho','ID','16','6340','208','Mountain',-7.0,'Y',42.875640,-112.470880,0,'2013-07-06 12:44:34',NULL,NULL),(66182,'78536','S','El Centro','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.643548,-98.403199,0,'2013-07-06 12:44:34',NULL,NULL),(40295,'45440','S','Sugarcrk Twp','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(36451,'40622','U','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.197856,-84.871610,0,'2013-07-06 12:44:32',NULL,NULL),(21024,'21857','P','Rehobeth','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.046474,-75.667256,0,'2013-07-06 12:44:31',NULL,NULL),(76290,'95432','S','Elk','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.143139,-123.713346,0,'2013-07-06 12:44:34',NULL,NULL),(6520,'05824','S','Ralston Corner','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.435400,-71.854320,0,'2013-07-06 12:44:30',NULL,NULL),(540,'00676','S','Res Edad Dorada','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(61246,'72347','S','Hickory Ridge','D','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.404017,-90.994778,0,'2013-07-06 12:44:33',NULL,NULL),(23885,'26167','S','Reader','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.578498,-80.746570,0,'2013-07-06 12:44:31',NULL,NULL),(43444,'48509','S','Burton','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.024922,-83.604329,0,'2013-07-06 12:44:32',NULL,NULL),(6894,'06145','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.791818,-72.668284,0,'2013-07-06 12:44:30',NULL,NULL),(34745,'38852','S','Eastport','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.827180,-88.216500,0,'2013-07-06 12:44:32',NULL,NULL),(7028,'06266','S','South Windham','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.673457,-72.173186,0,'2013-07-06 12:44:30',NULL,NULL),(31541,'34602','S','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.475302,-82.284057,0,'2013-07-06 12:44:32',NULL,NULL),(13860,'14228','S','Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.025880,-78.795360,0,'2013-07-06 12:44:31',NULL,NULL),(1747,'00778','S','Urb Veredas','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(15998,'17037','S','Ickesburg','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.432478,-77.353347,0,'2013-07-06 12:44:31',NULL,NULL),(68989,'83123','S','LaBarge','N','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.257113,-110.205952,0,'2013-07-06 12:44:34',NULL,NULL),(69247,'83423','S','Dubois','D','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(67177,'79846','P','Presidio','A','Presidio','48377','Texas','TX','48','0000','432','Central',-6.0,'Y',29.440000,-104.180000,0,'2013-07-06 12:44:34',NULL,NULL),(66122,'78419','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.693737,-97.264702,0,'2013-07-06 12:44:34',NULL,NULL),(30033,'33140','S','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.815316,-80.130710,0,'2013-07-06 12:44:32',NULL,NULL),(26993,'29625','S','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.536322,-82.732656,0,'2013-07-06 12:44:31',NULL,NULL),(55677,'64052','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.072429,-94.446384,0,'2013-07-06 12:44:33',NULL,NULL),(53354,'61764','S','McDowell','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(34138,'38229','S','Gleason','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.216363,-88.616472,0,'2013-07-06 12:44:32',NULL,NULL),(17381,'17886','S','W Milton','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.022009,-76.870147,0,'2013-07-06 12:44:31',NULL,NULL),(60352,'71469','S','Harmony','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.807619,-93.309894,0,'2013-07-06 12:44:33',NULL,NULL),(10908,'11427','S','Queens Vlg','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(45257,'50664','S','Jesup','N','Fayette','19065','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.710590,-91.877058,0,'2013-07-06 12:44:32',NULL,NULL),(17471,'17948','S','Shoemakers','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(16860,'17563','S','Penn Hill','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(78042,'97439','S','Florence','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.008860,-124.036260,0,'2013-07-06 12:44:34',NULL,NULL),(10026,'10171','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(68479,'81247','S','Windy Point','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.490794,-107.075470,0,'2013-07-06 12:44:34',NULL,NULL),(30441,'33331','S','Everglades Br','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(39248,'44437','S','Mc Donald','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.158569,-80.732639,0,'2013-07-06 12:44:32',NULL,NULL),(63258,'75491','S','Tom Bean','A','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.508961,-96.401740,0,'2013-07-06 12:44:33',NULL,NULL),(54614,'62914','S','Cairo','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.009840,-89.180112,0,'2013-07-06 12:44:33',NULL,NULL),(29080,'32257','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.193293,-81.601505,0,'2013-07-06 12:44:32',NULL,NULL),(33061,'36762','S','Thomasville','A','Clarke','01025','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.985556,-87.993333,0,'2013-07-06 12:44:32',NULL,NULL),(11420,'11963','S','Pine Neck','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.972440,-72.324540,0,'2013-07-06 12:44:30',NULL,NULL),(34059,'38141','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.026360,-89.847033,0,'2013-07-06 12:44:32',NULL,NULL),(4642,'03743','S','Claremont','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.368783,-72.345829,0,'2013-07-06 12:44:30',NULL,NULL),(67474,'80225','S','Denver Federal Center','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.724284,-105.110169,0,'2013-07-06 12:44:34',NULL,NULL),(17201,'17821','S','Ottawa','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(61597,'72764','S','Bethel Hts','A','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.179938,-94.145696,0,'2013-07-06 12:44:33',NULL,NULL),(54574,'62896','S','West Frankfort','D','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(26307,'29037','S','Bigcreek','N','Newberry','45071','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.235316,-81.841403,0,'2013-07-06 12:44:31',NULL,NULL),(54310,'62716','U','Hope School','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.748155,-89.611770,0,'2013-07-06 12:44:33',NULL,NULL),(61172,'72199','U','Camp Robinson','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.785804,-92.255214,0,'2013-07-06 12:44:33',NULL,NULL),(39743,'45070','P','West Elkton','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.588718,-84.556106,0,'2013-07-06 12:44:32',NULL,NULL),(40735,'46130','S','Fountaintown','D','Shelby','18145','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.694471,-85.782306,0,'2013-07-06 12:44:32',NULL,NULL),(46238,'52804','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.545202,-90.619714,0,'2013-07-06 12:44:32',NULL,NULL),(4259,'02879','S','South Kingstown','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(10022,'10171','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758429,-73.972144,0,'2013-07-06 12:44:30',NULL,NULL),(26987,'29622','P','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.499718,-82.660714,0,'2013-07-06 12:44:31',NULL,NULL),(32732,'36317','S','Clopton','D','Henry','01067','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.598085,-85.467166,0,'2013-07-06 12:44:32',NULL,NULL),(48925,'56150','S','Lakefield','D','Jackson','27063','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.672190,-95.168243,0,'2013-07-06 12:44:33',NULL,NULL),(36683,'41015','S','Ryland Heights','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(77915,'97311','U','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.943754,-123.028070,0,'2013-07-06 12:44:34',NULL,NULL),(5179,'04441','S','Frenchtown Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.501708,-69.466450,0,'2013-07-06 12:44:30',NULL,NULL),(60433,'71646','S','Bovine','N','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.186960,-91.853640,0,'2013-07-06 12:44:33',NULL,NULL),(11100,'11697','S','Breezy Point','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.556389,-73.926667,0,'2013-07-06 12:44:30',NULL,NULL),(10812,'11375','S','Forest Hills','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.721216,-73.850210,0,'2013-07-06 12:44:30',NULL,NULL),(60257,'71441','S','Kelly','D','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.001711,-92.149787,0,'2013-07-06 12:44:33',NULL,NULL),(64750,'76932','S','Best','A','Reagan','48383','Texas','TX','48','0000','325','Central',-6.0,'Y',31.212019,-101.463340,0,'2013-07-06 12:44:34',NULL,NULL),(9820,'10113','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742669,-73.999421,0,'2013-07-06 12:44:30',NULL,NULL),(62440,'74172','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.150461,-95.972719,0,'2013-07-06 12:44:33',NULL,NULL),(12491,'12996','S','Willsboro','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.374140,-73.417200,0,'2013-07-06 12:44:30',NULL,NULL),(37783,'42355','S','Maceo','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.861000,-86.984565,0,'2013-07-06 12:44:32',NULL,NULL),(76321,'95457','S','Lower Lake','D','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',38.901949,-122.613839,0,'2013-07-06 12:44:34',NULL,NULL),(76985,'96065','S','Montgomery Creek','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.971399,-122.000991,0,'2013-07-06 12:44:34',NULL,NULL),(21795,'23079','S','Jamaica','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.726585,-76.688739,0,'2013-07-06 12:44:31',NULL,NULL),(38465,'43616','S','Oregon','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.648315,-83.466213,0,'2013-07-06 12:44:32',NULL,NULL),(25627,'28462','S','Supply','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.972720,-78.289860,0,'2013-07-06 12:44:31',NULL,NULL),(6570,'05853','S','Morgan','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.909167,-71.979444,0,'2013-07-06 12:44:30',NULL,NULL),(32246,'35609','P','Decatur','D','Morgan','01103','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.612494,-87.022119,0,'2013-07-06 12:44:32',NULL,NULL),(33613,'37650','S','Erwin','D','Unicoi','47171','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.140916,-82.409298,0,'2013-07-06 12:44:32',NULL,NULL),(50758,'58415','S','Lamoure','A','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.442400,-98.483700,0,'2013-07-06 12:44:33',NULL,NULL),(20895,'21709','U','State Farm Ins Co','N','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.427762,-77.415493,0,'2013-07-06 12:44:31',NULL,NULL),(28354,'31203','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.867332,-83.693101,0,'2013-07-06 12:44:32',NULL,NULL),(42534,'47862','S','Armiesburg','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.789289,-87.373004,0,'2013-07-06 12:44:32',NULL,NULL),(25141,'28018','S','Corinth','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(59366,'70583','S','Scott','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.246725,-92.103925,0,'2013-07-06 12:44:33',NULL,NULL),(28806,'32064','S','Live Oak','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.295480,-82.987712,0,'2013-07-06 12:44:32',NULL,NULL),(31617,'34689','S','Tarpon Springs','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143816,-82.747935,0,'2013-07-06 12:44:32',NULL,NULL),(33278,'37111','P','Mc Minnville','A','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.687754,-85.775514,0,'2013-07-06 12:44:32',NULL,NULL),(70371,'84654','S','Salina','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.951768,-111.860719,0,'2013-07-06 12:44:34',NULL,NULL),(4288,'02896','S','North Smithfield','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.965954,-71.552269,0,'2013-07-06 12:44:30',NULL,NULL),(73282,'90746','S','Carson','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.860506,-118.255622,0,'2013-07-06 12:44:34',NULL,NULL),(64148,'76199','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.752429,-97.334282,0,'2013-07-06 12:44:34',NULL,NULL),(48375,'55565','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.277535,-93.809067,0,'2013-07-06 12:44:33',NULL,NULL),(41776,'47304','S','Cammack','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(16879,'17570','P','Rheems','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.128687,-76.569920,0,'2013-07-06 12:44:31',NULL,NULL),(4767,'03857','S','Newmarket','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.077386,-70.940347,0,'2013-07-06 12:44:30',NULL,NULL),(32397,'35954','S','Rockledge','N','Etowah','01055','Alabama','AL','01','2880','256','Central',-6.0,'Y',34.083060,-86.060280,0,'2013-07-06 12:44:32',NULL,NULL),(76790,'95945','S','Alta Sierra','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(643,'00682','S','Urb Mendoza','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(20829,'21632','S','Federalsburg','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.706568,-75.775985,0,'2013-07-06 12:44:31',NULL,NULL),(6213,'05488','S','Fonda','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(33792,'37881','S','Treadway','A','Grainger','47057','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.395156,-83.365973,0,'2013-07-06 12:44:32',NULL,NULL),(38779,'44054','S','Sheffield Twp','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.477010,-82.098416,0,'2013-07-06 12:44:32',NULL,NULL),(7984,'07712','S','Ocean','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235268,-74.035669,0,'2013-07-06 12:44:30',NULL,NULL),(2646,'00966','S','Ext Victor Braeger','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(75144,'93561','S','Bear Vly Spgs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(16877,'17569','S','Vere Cruz','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.276083,-76.123914,0,'2013-07-06 12:44:31',NULL,NULL),(22719,'24354','S','The Cedars','N','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.834499,-81.517149,0,'2013-07-06 12:44:31',NULL,NULL),(54426,'62837','S','Cumberland Heights','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(35723,'39669','S','Pinckneyville','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(29310,'32526','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.478102,-87.324059,0,'2013-07-06 12:44:32',NULL,NULL),(66140,'78468','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.706826,-97.355976,0,'2013-07-06 12:44:34',NULL,NULL),(58678,'68901','S','West Blue','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(38705,'44004','S','E Ashtabula','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.850540,-80.777400,0,'2013-07-06 12:44:32',NULL,NULL),(36857,'41080','S','Petersburg','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.042442,-84.841380,0,'2013-07-06 12:44:32',NULL,NULL),(46187,'52742','S','Dewitt','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.823540,-90.460200,0,'2013-07-06 12:44:32',NULL,NULL),(45285,'50682','S','Winthrop','D','Buchanan','19019','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.474575,-91.735596,0,'2013-07-06 12:44:32',NULL,NULL),(5909,'05201','S','Bennington College','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.879586,-73.197676,0,'2013-07-06 12:44:30',NULL,NULL),(15525,'16544','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.110099,-80.103108,0,'2013-07-06 12:44:31',NULL,NULL),(13206,'13626','S','Copenhagen','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.895883,-75.707121,0,'2013-07-06 12:44:30',NULL,NULL),(57756,'67448','S','Carlton','A','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.702809,-97.424184,0,'2013-07-06 12:44:33',NULL,NULL),(17028,'17745','S','Lock Haven','D','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(13154,'13603','S','Watertown','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.042160,-75.791520,0,'2013-07-06 12:44:30',NULL,NULL),(3120,'01237','S','Lanesboro','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.539340,-73.246200,0,'2013-07-06 12:44:30',NULL,NULL),(39397,'44657','S','Pattersonville','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(35682,'39661','S','Cranfield','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(17315,'17857','S','Oak Park','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.893520,-76.797765,0,'2013-07-06 12:44:31',NULL,NULL),(51827,'60060','S','Mundelein','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.268920,-88.060980,0,'2013-07-06 12:44:33',NULL,NULL),(21392,'22504','S','Laneview','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.770833,-76.688333,0,'2013-07-06 12:44:31',NULL,NULL),(74568,'92685','P','Westminster','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.752811,-117.995095,0,'2013-07-06 12:44:34',NULL,NULL),(77835,'97218','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.562445,-122.602923,0,'2013-07-06 12:44:34',NULL,NULL),(1657,'00773','S','Est Del Atlantico','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(11406,'11955','S','Moriches','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.804137,-72.820828,0,'2013-07-06 12:44:30',NULL,NULL),(14643,'15235','S','Penn Hills','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445040,-79.913760,0,'2013-07-06 12:44:31',NULL,NULL),(44722,'50151','S','Lucas','D','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.177296,-93.538427,0,'2013-07-06 12:44:32',NULL,NULL),(68954,'82943','P','Reliance','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.668898,-109.193833,0,'2013-07-06 12:44:34',NULL,NULL),(45045,'50480','S','Titonka','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.238426,-94.039265,0,'2013-07-06 12:44:32',NULL,NULL),(74929,'93403','P','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.280162,-120.656816,0,'2013-07-06 12:44:34',NULL,NULL),(24105,'26521','S','Blacksville','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.693698,-80.235660,0,'2013-07-06 12:44:31',NULL,NULL),(9535,'10020','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758933,-73.978818,0,'2013-07-06 12:44:30',NULL,NULL),(59149,'70181','P','New Orleans','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.963850,-90.067100,0,'2013-07-06 12:44:33',NULL,NULL),(77192,'96339','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(64627,'76704','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.582080,-97.125000,0,'2013-07-06 12:44:34',NULL,NULL),(50631,'58274','S','Portland','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.499181,-97.372975,0,'2013-07-06 12:44:33',NULL,NULL),(52469,'60685','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881488,-87.624120,0,'2013-07-06 12:44:33',NULL,NULL),(13602,'13856','S','Northfield','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.246944,-75.189167,0,'2013-07-06 12:44:31',NULL,NULL),(72514,'89155','U','Clark Co Courthouse','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.172209,-115.120274,0,'2013-07-06 12:44:34',NULL,NULL),(73792,'91748','S','City of Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(53349,'61761','S','College Hills Mall','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.510903,-88.987912,0,'2013-07-06 12:44:33',NULL,NULL),(4202,'02829','P','Harmony','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.882376,-71.594633,0,'2013-07-06 12:44:30',NULL,NULL),(77752,'97103','S','Tongue Point','N','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.181734,-123.826767,0,'2013-07-06 12:44:34',NULL,NULL),(72656,'89431','S','Sun Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.548066,-119.734394,0,'2013-07-06 12:44:34',NULL,NULL),(67840,'80814','S','Divide','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.942016,-105.180968,0,'2013-07-06 12:44:34',NULL,NULL),(60971,'72104','S','Social Hill','N','Hot Spring','05059','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.401540,-92.836320,0,'2013-07-06 12:44:33',NULL,NULL),(50221,'57580','S','Winner','D','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(50169,'57552','S','Stamford','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.247900,-101.320680,0,'2013-07-06 12:44:33',NULL,NULL),(20479,'21043','S','Ilchester','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.266016,-76.845513,0,'2013-07-06 12:44:31',NULL,NULL),(13917,'14411','S','Albion','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.239907,-78.202239,0,'2013-07-06 12:44:31',NULL,NULL),(28444,'31407','S','Port Wentworth','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.166660,-81.172740,0,'2013-07-06 12:44:32',NULL,NULL),(3204,'01354','S','Mt Hermon','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.711180,-72.448620,0,'2013-07-06 12:44:30',NULL,NULL),(19829,'20472','U','Fed Emer Mngt Agncy','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885928,-77.019442,0,'2013-07-06 12:44:31',NULL,NULL),(1573,'00767','S','Urb Calvario','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(66672,'78885','S','Vanderpool','D','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.782637,-99.552484,0,'2013-07-06 12:44:34',NULL,NULL),(65488,'77651','S','Port Neches','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.980985,-93.961475,0,'2013-07-06 12:44:34',NULL,NULL),(60323,'71458','P','Natchitoches','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.757608,-93.086235,0,'2013-07-06 12:44:33',NULL,NULL),(57410,'66769','S','Redfield','D','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.860520,-94.831824,0,'2013-07-06 12:44:33',NULL,NULL),(21135,'22103','P','Maclean','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.947768,-77.227954,0,'2013-07-06 12:44:31',NULL,NULL),(41763,'47302','S','New Burlington','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.171455,-85.379033,0,'2013-07-06 12:44:32',NULL,NULL),(45650,'52001','S','Eagle Point','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.557520,-90.690780,0,'2013-07-06 12:44:32',NULL,NULL),(74994,'93450','S','San Ardo','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.025296,-120.902933,0,'2013-07-06 12:44:34',NULL,NULL),(63177,'75409','S','Anna','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.345806,-96.577245,0,'2013-07-06 12:44:33',NULL,NULL),(62539,'74432','S','Eutaula','N','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.288414,-95.585124,0,'2013-07-06 12:44:33',NULL,NULL),(29638,'32897','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.538957,-81.379064,0,'2013-07-06 12:44:32',NULL,NULL),(1025,'00718','S','Urb Promised Land','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(24577,'27314','S','Prospect Hill','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.293460,-79.197593,0,'2013-07-06 12:44:31',NULL,NULL),(52007,'60171','S','River Grove','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.924233,-87.841100,0,'2013-07-06 12:44:33',NULL,NULL),(58770,'68969','P','Holdrege','A','Harlan','31083','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.310839,-99.254620,0,'2013-07-06 12:44:33',NULL,NULL),(281,'00646','S','Parc El Cotto','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(73334,'90847','U','AARP','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.834248,-118.189003,0,'2013-07-06 12:44:34',NULL,NULL),(69261,'83429','S','Last Chance Resort','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.459589,-111.345873,0,'2013-07-06 12:44:34',NULL,NULL),(7925,'07645','S','Montvale','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.046598,-74.038288,0,'2013-07-06 12:44:30',NULL,NULL),(13649,'14009','S','Arcade','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.569872,-78.406548,0,'2013-07-06 12:44:31',NULL,NULL),(34352,'38583','S','Sparta','D','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.931616,-85.469699,0,'2013-07-06 12:44:32',NULL,NULL),(30819,'33619','S','Clair Mel City','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.933359,-82.378210,0,'2013-07-06 12:44:32',NULL,NULL),(43051,'48183','S','Trenton','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.134388,-83.215861,0,'2013-07-06 12:44:32',NULL,NULL),(51345,'59317','S','Sonnette','A','Powder River','30075','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.413540,-105.829860,0,'2013-07-06 12:44:33',NULL,NULL),(55598,'63940','S','Fisk','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.783310,-90.209025,0,'2013-07-06 12:44:33',NULL,NULL),(58514,'68776','S','S Sioux City','A','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.471705,-96.414132,0,'2013-07-06 12:44:33',NULL,NULL),(65988,'78336','S','Aranspass','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.904408,-97.160091,0,'2013-07-06 12:44:34',NULL,NULL),(10733,'11355','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.754005,-73.821132,0,'2013-07-06 12:44:30',NULL,NULL),(42184,'47542','S','Bretzville','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.297169,-86.956690,0,'2013-07-06 12:44:32',NULL,NULL),(20125,'20719','P','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.959850,-76.737130,0,'2013-07-06 12:44:31',NULL,NULL),(36123,'40223','S','Anchorage','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(58538,'68813','S','Milburn','A','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.641920,-99.771120,0,'2013-07-06 12:44:33',NULL,NULL),(54813,'63021','S','Sherman','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576504,-90.528928,0,'2013-07-06 12:44:33',NULL,NULL),(54169,'62613','S','Athens','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.945060,-89.725020,0,'2013-07-06 12:44:33',NULL,NULL),(22360,'23899','P','Claremont','D','Surry','51181','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.227610,-76.965605,0,'2013-07-06 12:44:31',NULL,NULL),(8294,'08021','S','Laurel Springs','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(9171,'09354','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(10813,'11375','S','Forest Hls','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.721216,-73.850210,0,'2013-07-06 12:44:30',NULL,NULL),(1018,'00718','S','Mans Playa Hucares','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(71395,'87010','S','Cerrillos','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.413800,-106.124820,0,'2013-07-06 12:44:34',NULL,NULL),(38010,'43002','P','Amlin','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.078159,-83.169222,0,'2013-07-06 12:44:32',NULL,NULL),(30996,'33769','U','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.968846,-82.803211,0,'2013-07-06 12:44:32',NULL,NULL),(20590,'21163','S','Granite','A','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341160,-76.859940,0,'2013-07-06 12:44:31',NULL,NULL),(28268,'31079','S','Rochelle','D','Wilcox','13315','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.949715,-83.454065,0,'2013-07-06 12:44:31',NULL,NULL),(24021,'26372','S','Horner','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.957645,-80.360194,0,'2013-07-06 12:44:31',NULL,NULL),(26151,'28740','S','Greenmountain','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(48415,'55602','S','Brimson','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.309551,-91.835899,0,'2013-07-06 12:44:33',NULL,NULL),(61550,'72704','S','Fayetteville','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.080874,-94.201559,0,'2013-07-06 12:44:33',NULL,NULL),(79584,'99027','S','Otis Orchards','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.702089,-117.110984,0,'2013-07-06 12:44:34',NULL,NULL),(66560,'78736','S','Bee Cave','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250073,-97.926724,0,'2013-07-06 12:44:34',NULL,NULL),(56272,'65066','S','Old Woollam','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348543,-91.499030,0,'2013-07-06 12:44:33',NULL,NULL),(40668,'46055','S','Mc Cordsville','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.891661,-85.901929,0,'2013-07-06 12:44:32',NULL,NULL),(23663,'25825','S','Cool Ridge','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.646196,-81.121344,0,'2013-07-06 12:44:31',NULL,NULL),(34779,'38865','S','Hinkle','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.711840,-88.659681,0,'2013-07-06 12:44:32',NULL,NULL),(36380,'40473','P','Renfro Valley','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.388535,-84.330442,0,'2013-07-06 12:44:32',NULL,NULL),(38015,'43007','P','Broadway','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.337547,-83.411104,0,'2013-07-06 12:44:32',NULL,NULL),(4756,'03848','S','Kingston','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.919841,-71.064382,0,'2013-07-06 12:44:30',NULL,NULL),(74960,'93426','S','Nacimiento Lake','N','Monterey','06053','California','CA','06','7120','805','Pacific',-8.0,'Y',35.755566,-120.978715,0,'2013-07-06 12:44:34',NULL,NULL),(63314,'75568','S','Cornett','N','Morris','48343','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.192600,-94.693620,0,'2013-07-06 12:44:33',NULL,NULL),(44266,'49690','S','Williamsburg','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.789033,-85.429799,0,'2013-07-06 12:44:32',NULL,NULL),(34518,'38677','P','University','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.367390,-89.528956,0,'2013-07-06 12:44:32',NULL,NULL),(30984,'33757','P','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.980018,-82.780895,0,'2013-07-06 12:44:32',NULL,NULL),(65901,'78235','S','Brooks AFB Branch','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.341979,-98.442498,0,'2013-07-06 12:44:34',NULL,NULL),(63476,'75686','S','Pittsburg','D','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(63199,'75434','P','Cunningham','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.501422,-95.377887,0,'2013-07-06 12:44:33',NULL,NULL),(50326,'57730','S','Crazy Horse','A','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.767311,-103.595844,0,'2013-07-06 12:44:33',NULL,NULL),(13132,'13492','S','Whitesboro','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.118640,-75.329340,0,'2013-07-06 12:44:30',NULL,NULL),(22250,'23665','S','Langley Air Force Base','N','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.080265,-76.373645,0,'2013-07-06 12:44:31',NULL,NULL),(31234,'33972','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.602691,-81.632837,0,'2013-07-06 12:44:32',NULL,NULL),(29772,'33011','P','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.822221,-80.284112,0,'2013-07-06 12:44:32',NULL,NULL),(26141,'28737','P','Glenwood','D','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.683889,-82.009444,0,'2013-07-06 12:44:31',NULL,NULL),(47255,'54521','S','Eagle River','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.910500,-89.224500,0,'2013-07-06 12:44:32',NULL,NULL),(2020,'00916','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.376517,-66.162719,0,'2013-07-06 12:44:30',NULL,NULL),(79191,'98532','S','Boistfort','N','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.639080,-123.015720,0,'2013-07-06 12:44:34',NULL,NULL),(66071,'78383','S','Sandia','D','Jim Wells','48249','Texas','TX','48','0000','361','Central',-6.0,'Y',28.089420,-97.942200,0,'2013-07-06 12:44:34',NULL,NULL),(49465,'56652','S','Holst','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.638080,-95.383500,0,'2013-07-06 12:44:33',NULL,NULL),(23119,'24954','S','Minnehaha','N','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.211660,-80.055660,0,'2013-07-06 12:44:31',NULL,NULL),(8720,'08502','S','Montgomery','N','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.464764,-74.630308,0,'2013-07-06 12:44:30',NULL,NULL),(9081,'09020','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(379,'00660','S','Parc San Romualdo','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(77916,'97312','U','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.893155,-123.060071,0,'2013-07-06 12:44:34',NULL,NULL),(76253,'95405','S','Santa Rosa','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.444478,-122.655453,0,'2013-07-06 12:44:34',NULL,NULL),(12358,'12887','S','Whitehall','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.554480,-73.401960,0,'2013-07-06 12:44:30',NULL,NULL),(31478,'34421','P','Belleview','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.049241,-82.036417,0,'2013-07-06 12:44:32',NULL,NULL),(3781,'02203','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.365142,-71.070244,0,'2013-07-06 12:44:30',NULL,NULL),(28080,'30730','S','Lyerly','D','Chattooga','13055','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.402441,-85.397197,0,'2013-07-06 12:44:31',NULL,NULL),(10472,'10941','S','Scotchtown','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.463349,-74.421398,0,'2013-07-06 12:44:30',NULL,NULL),(7110,'06373','P','Oneco','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.692041,-71.811247,0,'2013-07-06 12:44:30',NULL,NULL),(44940,'50364','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.596699,-93.764908,0,'2013-07-06 12:44:32',NULL,NULL),(50544,'58126','U','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.874888,-96.784488,0,'2013-07-06 12:44:33',NULL,NULL),(51096,'58773','S','Powers Lake','D','Burke','38013','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.618780,-102.624000,0,'2013-07-06 12:44:33',NULL,NULL),(65665,'77979','S','Port Lavaca','D','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.617499,-96.633202,0,'2013-07-06 12:44:34',NULL,NULL),(71048,'85748','S','Rincon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.212606,-110.769648,0,'2013-07-06 12:44:34',NULL,NULL),(2162,'00926','S','Alts del Remanso','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(77257,'96553','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74830,'93235','S','Ivanhoe','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.366409,-119.210787,0,'2013-07-06 12:44:34',NULL,NULL),(73329,'90842','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.819348,-118.168139,0,'2013-07-06 12:44:34',NULL,NULL),(17641,'18067','S','Northampton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.700621,-75.486647,0,'2013-07-06 12:44:31',NULL,NULL),(41702,'47229','S','Crothersville','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.792996,-85.841879,0,'2013-07-06 12:44:32',NULL,NULL),(49774,'57070','S','Viborg','D','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.189920,-97.116960,0,'2013-07-06 12:44:33',NULL,NULL),(50451,'58017','S','Straubville','A','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.100640,-97.809420,0,'2013-07-06 12:44:33',NULL,NULL),(52649,'61062','S','Loran','N','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.259707,-89.829814,0,'2013-07-06 12:44:33',NULL,NULL),(52846,'61321','S','Dana','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.979794,-88.965342,0,'2013-07-06 12:44:33',NULL,NULL),(55221,'63430','S','Alexandria','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.357020,-91.457994,0,'2013-07-06 12:44:33',NULL,NULL),(77344,'96722','S','Princeville','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.226424,-159.482542,0,'2013-07-06 12:44:34',NULL,NULL),(65835,'78154','S','Schertz','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.587509,-98.288298,0,'2013-07-06 12:44:34',NULL,NULL),(65494,'77659','S','Grayburg','N','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.164700,-94.350960,0,'2013-07-06 12:44:34',NULL,NULL),(65468,'77629','P','Nome','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.045115,-94.374320,0,'2013-07-06 12:44:34',NULL,NULL),(61304,'72427','P','Egypt','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.863806,-90.951982,0,'2013-07-06 12:44:33',NULL,NULL),(14726,'15282','U','Duquesne Univ','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.436290,-79.991277,0,'2013-07-06 12:44:31',NULL,NULL),(19187,'19805','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.731640,-75.624240,0,'2013-07-06 12:44:31',NULL,NULL),(22343,'23878','S','Sedley','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.805778,-77.024354,0,'2013-07-06 12:44:31',NULL,NULL),(23055,'24868','S','Powhatan','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(79476,'98858','S','Withrow','N','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.677620,-119.909880,0,'2013-07-06 12:44:34',NULL,NULL),(74669,'92861','S','Villa Park','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.820489,-117.810430,0,'2013-07-06 12:44:34',NULL,NULL),(67107,'79720','S','Big Spring','D','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.514610,-101.575740,0,'2013-07-06 12:44:34',NULL,NULL),(61695,'72951','S','Ratcliff','D','Logan','05083','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.259950,-93.833359,0,'2013-07-06 12:44:33',NULL,NULL),(56436,'65265','S','Vandiver Village','N','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.167340,-91.870440,0,'2013-07-06 12:44:33',NULL,NULL),(14529,'15205','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437059,-80.074137,0,'2013-07-06 12:44:31',NULL,NULL),(7231,'06506','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309470,-72.925324,0,'2013-07-06 12:44:30',NULL,NULL),(34143,'38233','S','Masonhall','N','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.177966,-89.025271,0,'2013-07-06 12:44:32',NULL,NULL),(54111,'62546','S','Morrisonville','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.420129,-89.460129,0,'2013-07-06 12:44:33',NULL,NULL),(52348,'60604','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.875734,-87.625562,0,'2013-07-06 12:44:33',NULL,NULL),(49989,'57366','S','Parkston','D','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.394273,-97.988210,0,'2013-07-06 12:44:33',NULL,NULL),(48381,'55570','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.995228,-93.707683,0,'2013-07-06 12:44:33',NULL,NULL),(14637,'15234','S','Castl Shannon','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(27582,'30276','S','Senoia','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.286584,-84.590087,0,'2013-07-06 12:44:31',NULL,NULL),(27209,'29909','S','Bluffton','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.262421,-80.867479,0,'2013-07-06 12:44:31',NULL,NULL),(13395,'13748','S','Conklin','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.074345,-75.819022,0,'2013-07-06 12:44:31',NULL,NULL),(41637,'47132','U','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.287784,-85.731015,0,'2013-07-06 12:44:32',NULL,NULL),(42341,'47637','S','Folsomvle','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.128740,-87.148763,0,'2013-07-06 12:44:32',NULL,NULL),(43465,'48554','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.936862,-83.823819,0,'2013-07-06 12:44:32',NULL,NULL),(4069,'02649','S','South Mashpee','N','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.632800,-70.488720,0,'2013-07-06 12:44:30',NULL,NULL),(79353,'98638','S','Naselle','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.407326,-123.708491,0,'2013-07-06 12:44:34',NULL,NULL),(78168,'97635','S','New Pine Creek','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.052488,-120.234489,0,'2013-07-06 12:44:34',NULL,NULL),(78062,'97456','S','Monroe','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.324340,-123.319140,0,'2013-07-06 12:44:34',NULL,NULL),(74636,'92811','P','Atwood','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.867401,-117.830990,0,'2013-07-06 12:44:34',NULL,NULL),(71358,'86538','P','Many Farms','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.453233,-109.581542,0,'2013-07-06 12:44:34',NULL,NULL),(67868,'80829','S','Manitou Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855979,-104.906332,0,'2013-07-06 12:44:34',NULL,NULL),(37500,'42031','S','Croley','N','Hickman','21105','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.713580,-89.006820,0,'2013-07-06 12:44:32',NULL,NULL),(34868,'38935','P','Greenwood','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.522263,-90.178983,0,'2013-07-06 12:44:32',NULL,NULL),(11127,'11706','S','Fair Harbor','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(19811,'20447','U','Family Support Administratio','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885057,-77.027332,0,'2013-07-06 12:44:31',NULL,NULL),(39609,'44878','S','Shiloh','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.935120,-82.507980,0,'2013-07-06 12:44:32',NULL,NULL),(41495,'46951','S','Macy','D','Miami','18103','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.968780,-86.126400,0,'2013-07-06 12:44:32',NULL,NULL),(50033,'57429','P','Brentford','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.162829,-98.323250,0,'2013-07-06 12:44:33',NULL,NULL),(60459,'71653','S','Macon Lake','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(63101,'75267','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.753689,-96.842948,0,'2013-07-06 12:44:33',NULL,NULL),(63381,'75644','S','Kelsey','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(5608,'04935','P','E Vassalboro','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.449774,-69.608359,0,'2013-07-06 12:44:30',NULL,NULL),(70516,'84791','P','St George','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.087282,-113.556082,0,'2013-07-06 12:44:34',NULL,NULL),(66455,'78653','S','New Sweden','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(58325,'68448','S','Talmage','D','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.531822,-96.025289,0,'2013-07-06 12:44:33',NULL,NULL),(53729,'62246','S','Wisetown','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(37107,'41364','S','Ricetown','D','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.399975,-83.607980,0,'2013-07-06 12:44:32',NULL,NULL),(33490,'37348','S','Kelso','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.109489,-86.464752,0,'2013-07-06 12:44:32',NULL,NULL),(22809,'24479','S','Swoope','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.142486,-79.201796,0,'2013-07-06 12:44:31',NULL,NULL),(21182,'22161','U','Springfield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.787863,-77.187222,0,'2013-07-06 12:44:31',NULL,NULL),(21003,'21837','S','Mardela','A','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.455644,-75.755948,0,'2013-07-06 12:44:31',NULL,NULL),(13111,'13484','P','West Eaton','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.851757,-75.662247,0,'2013-07-06 12:44:30',NULL,NULL),(45027,'50466','S','Riceville','D','Howard','19089','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.365290,-92.551275,0,'2013-07-06 12:44:32',NULL,NULL),(47,'00603','S','Vista Verde','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(61535,'72679','S','Tilly','D','Pope','05115','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.699195,-92.863769,0,'2013-07-06 12:44:33',NULL,NULL),(36304,'40366','P','Preston','D','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.082578,-83.757136,0,'2013-07-06 12:44:32',NULL,NULL),(1321,'00735','S','Roosevelt Roads','A','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(10574,'11021','S','Allenwood','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(25985,'28665','S','Parsonville','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.221121,-81.387906,0,'2013-07-06 12:44:31',NULL,NULL),(39055,'44194','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.516028,-81.672288,0,'2013-07-06 12:44:32',NULL,NULL),(53996,'62443','S','Mason','D','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.961718,-88.635948,0,'2013-07-06 12:44:33',NULL,NULL),(59013,'70070','S','Luling','D','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.925870,-90.372616,0,'2013-07-06 12:44:33',NULL,NULL),(122,'00612','S','Valle Escondido','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(75468,'94102','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.780793,-122.417576,0,'2013-07-06 12:44:34',NULL,NULL),(73444,'91301','S','Calabasas','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(9628,'10035','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(29123,'32314','P','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.440348,-84.334698,0,'2013-07-06 12:44:32',NULL,NULL),(10053,'10176','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(6592,'05860','S','Orleans','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.807079,-72.201511,0,'2013-07-06 12:44:30',NULL,NULL),(16667,'17356','S','New Bridgeville','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.903715,-76.607910,0,'2013-07-06 12:44:31',NULL,NULL),(24402,'27107','S','Waughtown','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.062543,-80.183453,0,'2013-07-06 12:44:31',NULL,NULL),(18101,'18711','S','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.249408,-75.884003,0,'2013-07-06 12:44:31',NULL,NULL),(58682,'68922','S','Arapahoe','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.307147,-99.900593,0,'2013-07-06 12:44:33',NULL,NULL),(61790,'73080','S','Purcell','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.017904,-97.366998,0,'2013-07-06 12:44:33',NULL,NULL),(73123,'90265','S','Malibu','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.044755,-118.755380,0,'2013-07-06 12:44:34',NULL,NULL),(6953,'06199','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.926830,-72.654423,0,'2013-07-06 12:44:30',NULL,NULL),(75081,'93534','S','Fairmont','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(72274,'88554','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767660,-106.328617,0,'2013-07-06 12:44:34',NULL,NULL),(67019,'79530','S','Lawn','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.125523,-99.708958,0,'2013-07-06 12:44:34',NULL,NULL),(59782,'71209','U','Northeast Univ','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.528150,-92.072246,0,'2013-07-06 12:44:33',NULL,NULL),(38499,'43701','S','S Zanesville','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.954240,-81.984960,0,'2013-07-06 12:44:32',NULL,NULL),(41800,'47327','S','Jacksonburg','N','Wayne','18177','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.822189,-85.164134,0,'2013-07-06 12:44:32',NULL,NULL),(46062,'52576','S','Ollie','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.203732,-92.161382,0,'2013-07-06 12:44:32',NULL,NULL),(13226,'13635','S','South Edwards','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.308020,-75.256080,0,'2013-07-06 12:44:30',NULL,NULL),(75201,'93625','S','Fowler','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.623292,-119.667048,0,'2013-07-06 12:44:34',NULL,NULL),(70849,'85544','S','Strawberry','A','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.396467,-111.453745,0,'2013-07-06 12:44:34',NULL,NULL),(55687,'64058','S','Sugar Creek','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.141498,-94.353728,0,'2013-07-06 12:44:33',NULL,NULL),(38924,'44122','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(1688,'00777','S','Paseo de La Ceiba','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(27928,'30518','S','Sugar Hill','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.124264,-84.031055,0,'2013-07-06 12:44:31',NULL,NULL),(14489,'15136','S','McKees Rocks','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.472555,-80.088822,0,'2013-07-06 12:44:31',NULL,NULL),(77115,'96146','S','Olympic Vly','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.150000,-120.150000,0,'2013-07-06 12:44:34',NULL,NULL),(75158,'93581','P','Tehachapi','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.130447,-118.447638,0,'2013-07-06 12:44:34',NULL,NULL),(74959,'93426','S','Lake Nacimiento','N','Monterey','06053','California','CA','06','7120','805','Pacific',-8.0,'Y',35.755566,-120.978715,0,'2013-07-06 12:44:34',NULL,NULL),(47809,'55054','S','New Market','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.571168,-93.354431,0,'2013-07-06 12:44:33',NULL,NULL),(2032,'00917','S','Urb Perez Morris','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(28957,'32198','U','Fl Regional Library for Blin','N','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.195511,-81.052236,0,'2013-07-06 12:44:32',NULL,NULL),(4217,'02839','S','Burrillville','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.942142,-71.637583,0,'2013-07-06 12:44:30',NULL,NULL),(69748,'84047','S','Union','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.616513,-111.879899,0,'2013-07-06 12:44:34',NULL,NULL),(68135,'80970','P','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848525,-104.717700,0,'2013-07-06 12:44:34',NULL,NULL),(56204,'65026','S','Aurora Springs','N','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.348224,-92.579976,0,'2013-07-06 12:44:33',NULL,NULL),(18557,'19120','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.036043,-75.119434,0,'2013-07-06 12:44:31',NULL,NULL),(2482,'00956','S','Urb Golden Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(23205,'25067','S','Crown Hill','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.220630,-81.441267,0,'2013-07-06 12:44:31',NULL,NULL),(33034,'36738','S','Dayton','A','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.405885,-87.612440,0,'2013-07-06 12:44:32',NULL,NULL),(14944,'15601','S','Greensburg','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.296760,-79.542457,0,'2013-07-06 12:44:31',NULL,NULL),(5305,'04554','S','New Harbor','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.856798,-69.504529,0,'2013-07-06 12:44:30',NULL,NULL),(77165,'96257','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75645,'94524','P','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.973586,-122.057630,0,'2013-07-06 12:44:34',NULL,NULL),(69262,'83429','S','Ponds Resort','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.459589,-111.345873,0,'2013-07-06 12:44:34',NULL,NULL),(65431,'77583','S','Rosharon','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.408146,-95.441666,0,'2013-07-06 12:44:34',NULL,NULL),(60504,'71665','S','Rowell','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(50993,'58651','S','Rhame','D','Bowman','38011','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.186233,-103.396002,0,'2013-07-06 12:44:33',NULL,NULL),(38949,'44125','S','Garfield Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(26902,'29576','S','Murrells Inlet','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.586770,-79.009455,0,'2013-07-06 12:44:31',NULL,NULL),(16841,'17560','S','New Providence','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.252500,0,'2013-07-06 12:44:31',NULL,NULL),(38119,'43110','S','Canal Winchester','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.827570,-82.794186,0,'2013-07-06 12:44:32',NULL,NULL),(36715,'41022','P','Florence','D','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.989761,-84.642819,0,'2013-07-06 12:44:32',NULL,NULL),(30778,'33585','S','Sumterville','D','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.697187,-82.002798,0,'2013-07-06 12:44:32',NULL,NULL),(30019,'33133','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.733767,-80.241942,0,'2013-07-06 12:44:32',NULL,NULL),(73970,'92074','P','Poway','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.957495,-117.034928,0,'2013-07-06 12:44:34',NULL,NULL),(73707,'91610','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.155836,-118.379194,0,'2013-07-06 12:44:34',NULL,NULL),(35942,'40055','S','Sulphur','A','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.495040,-85.339571,0,'2013-07-06 12:44:32',NULL,NULL),(9318,'09730','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(39235,'44423','S','New Garden','N','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.765396,-80.906383,0,'2013-07-06 12:44:32',NULL,NULL),(49298,'56528','S','Dent','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.542914,-95.781515,0,'2013-07-06 12:44:33',NULL,NULL),(54763,'62987','S','Stonefort','D','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.637140,-88.740772,0,'2013-07-06 12:44:33',NULL,NULL),(54900,'63074','S','Saint Anne','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.727416,-90.387327,0,'2013-07-06 12:44:33',NULL,NULL),(59855,'71254','S','Shelburn','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.804753,-91.177769,0,'2013-07-06 12:44:33',NULL,NULL),(65847,'78164','S','Yorktown','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',28.980914,-97.505632,0,'2013-07-06 12:44:34',NULL,NULL),(69997,'84123','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(72145,'88318','S','Corona','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.245860,-105.595760,0,'2013-07-06 12:44:34',NULL,NULL),(77935,'97336','P','Crawfordsville','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.358322,-122.851361,0,'2013-07-06 12:44:34',NULL,NULL),(61852,'73120','S','The Village','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.584064,-97.574272,0,'2013-07-06 12:44:33',NULL,NULL),(55893,'64430','S','Clarksdale','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.813236,-94.522762,0,'2013-07-06 12:44:33',NULL,NULL),(185,'00623','S','Parc Puerto Real','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(36054,'40207','S','Indian Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(30820,'33619','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.933359,-82.378210,0,'2013-07-06 12:44:32',NULL,NULL),(3370,'01585','S','W Brookfield','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.235246,-72.146449,0,'2013-07-06 12:44:30',NULL,NULL),(38366,'43460','S','Rossford','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.603999,-83.568757,0,'2013-07-06 12:44:32',NULL,NULL),(9611,'10032','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(26467,'29150','S','Bon Air','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(25007,'27874','S','Scotland Neck','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.130304,-77.420567,0,'2013-07-06 12:44:31',NULL,NULL),(18205,'18946','P','Pineville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.292390,-75.013910,0,'2013-07-06 12:44:31',NULL,NULL),(44709,'50142','P','Le Grand','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.005152,-92.775704,0,'2013-07-06 12:44:32',NULL,NULL),(78005,'97412','S','Blachly','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.185860,-123.533340,0,'2013-07-06 12:44:34',NULL,NULL),(74616,'92780','S','Tustin','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.736361,-117.822888,0,'2013-07-06 12:44:34',NULL,NULL),(16073,'17050','S','Defense Depot','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(5596,'04923','S','Cambridge','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.051120,-69.426360,0,'2013-07-06 12:44:30',NULL,NULL),(18796,'19390','S','Chatham','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.821687,-75.841624,0,'2013-07-06 12:44:31',NULL,NULL),(10293,'10521','P','Croton on Hudson','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.234521,-73.924343,0,'2013-07-06 12:44:30',NULL,NULL),(8596,'08232','S','Egg Harbor Township','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(30154,'33169','S','Miami Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.935490,-80.214010,0,'2013-07-06 12:44:32',NULL,NULL),(1808,'00784','S','Bo Machete','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(33068,'36768','S','Pine Apple','D','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.936892,-87.008880,0,'2013-07-06 12:44:32',NULL,NULL),(7190,'06473','S','No Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.381539,-72.861606,0,'2013-07-06 12:44:30',NULL,NULL),(31074,'33855','P','Indian Lake Estates','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.873608,-81.477219,0,'2013-07-06 12:44:32',NULL,NULL),(30255,'33222','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.732873,-80.241591,0,'2013-07-06 12:44:32',NULL,NULL),(29018,'32227','S','JAX Bch','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.381910,-81.410410,0,'2013-07-06 12:44:32',NULL,NULL),(63405,'75652','S','Good Springs','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(65539,'77807','S','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.622933,-96.385176,0,'2013-07-06 12:44:34',NULL,NULL),(78456,'98068','P','Snoqualmie Pass','D','Kittitas','53037','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.412300,-121.418723,0,'2013-07-06 12:44:34',NULL,NULL),(55364,'63565','S','Martinstown','N','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497300,-93.005760,0,'2013-07-06 12:44:33',NULL,NULL),(54072,'62510','S','Assumption','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.518917,-89.050981,0,'2013-07-06 12:44:33',NULL,NULL),(50204,'57572','S','Spring Creek','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.142534,-100.967723,0,'2013-07-06 12:44:33',NULL,NULL),(45482,'51345','S','Harris','D','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.444748,-95.434345,0,'2013-07-06 12:44:32',NULL,NULL),(42881,'48092','S','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.512974,-83.059791,0,'2013-07-06 12:44:32',NULL,NULL),(40560,'45859','P','Mc Guffey','D','Hardin','39065','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.693751,-83.783763,0,'2013-07-06 12:44:32',NULL,NULL),(2089,'00922','P','Caparra Hills','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409982,-66.092553,0,'2013-07-06 12:44:30',NULL,NULL),(6661,'06025','P','East Glastonbury','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.690889,-72.534917,0,'2013-07-06 12:44:30',NULL,NULL),(18954,'19512','S','Boyertown','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.333043,-75.640609,0,'2013-07-06 12:44:31',NULL,NULL),(12383,'12919','S','Champlain','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.965140,-73.434300,0,'2013-07-06 12:44:30',NULL,NULL),(13856,'14227','S','Cheektowaga','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.876735,-78.744457,0,'2013-07-06 12:44:31',NULL,NULL),(2064,'00920','S','Urb Puerto Nuevo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410210,-66.087732,0,'2013-07-06 12:44:30',NULL,NULL),(42345,'47638','S','Wadesville','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.075839,-87.761568,0,'2013-07-06 12:44:32',NULL,NULL),(47994,'55144','U','3m Corp','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.925118,-93.048795,0,'2013-07-06 12:44:33',NULL,NULL),(53345,'61759','S','Minier','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.432110,-89.310172,0,'2013-07-06 12:44:33',NULL,NULL),(64657,'76801','S','Lake Brownwood','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(65196,'77428','P','Collegeport','D','Matagorda','48321','Texas','TX','48','0000','361','Central',-6.0,'Y',28.723708,-96.176127,0,'2013-07-06 12:44:34',NULL,NULL),(74886,'93282','P','Waukena','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.149403,-119.506075,0,'2013-07-06 12:44:34',NULL,NULL),(78471,'98082','P','Mill Creek','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.855245,-122.221023,0,'2013-07-06 12:44:34',NULL,NULL),(33402,'37227','P','Nashvl','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.132543,-86.669444,0,'2013-07-06 12:44:32',NULL,NULL),(26912,'29582','S','Cherry Grove','A','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(17655,'18079','P','Slatedale','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.742918,-75.653119,0,'2013-07-06 12:44:31',NULL,NULL),(25759,'28584','S','Cape Carteret','A','Onslow','37133','North Carolina','NC','37','3605','252','Eastern',-5.0,'Y',34.701094,-77.065759,0,'2013-07-06 12:44:31',NULL,NULL),(18552,'19118','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.086847,-75.197968,0,'2013-07-06 12:44:31',NULL,NULL),(21672,'22952','S','Lyndhurst','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.011380,-78.924480,0,'2013-07-06 12:44:31',NULL,NULL),(20794,'21550','S','Deer Park','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(55592,'63935','S','Doniphan','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.622500,-90.832800,0,'2013-07-06 12:44:33',NULL,NULL),(57273,'66548','S','Waterville','D','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.688984,-96.749155,0,'2013-07-06 12:44:33',NULL,NULL),(57677,'67221','S','McConnell AFB','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.632480,-97.250340,0,'2013-07-06 12:44:33',NULL,NULL),(11920,'12418','S','Cornwallville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.379172,-74.126219,0,'2013-07-06 12:44:30',NULL,NULL),(76242,'95389','S','Yosemite Ntpk','A','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(73291,'90755','S','Long Beach','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.779826,-118.150529,0,'2013-07-06 12:44:34',NULL,NULL),(33422,'37243','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162894,-86.785734,0,'2013-07-06 12:44:32',NULL,NULL),(28925,'32162','S','Lady Lake','A','Sumter','12119','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.915470,-81.922679,0,'2013-07-06 12:44:32',NULL,NULL),(15646,'16735','S','Kane','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.663640,-78.790860,0,'2013-07-06 12:44:31',NULL,NULL),(22403,'23958','S','Pamplin','D','Appomattox','51011','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.260126,-78.645051,0,'2013-07-06 12:44:31',NULL,NULL),(20097,'20704','P','Beltsville','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.039402,-76.906964,0,'2013-07-06 12:44:31',NULL,NULL),(17410,'17920','P','Aristes','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.819609,-76.340066,0,'2013-07-06 12:44:31',NULL,NULL),(7515,'07002','S','Pamrapo','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.664207,-74.122276,0,'2013-07-06 12:44:30',NULL,NULL),(72200,'88415','S','Clayton','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(65922,'78242','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.353568,-98.609845,0,'2013-07-06 12:44:34',NULL,NULL),(62058,'73539','S','Elmer','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.506248,-99.295805,0,'2013-07-06 12:44:33',NULL,NULL),(48034,'55304','S','Ham Lake','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.254700,-93.240480,0,'2013-07-06 12:44:33',NULL,NULL),(40227,'45415','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.824450,-84.276130,0,'2013-07-06 12:44:32',NULL,NULL),(14062,'14588','P','Willard','D','Seneca','36099','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.681759,-76.872085,0,'2013-07-06 12:44:31',NULL,NULL),(26204,'28777','S','Spruce Pine','D','Mitchell','37121','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.914346,-82.072490,0,'2013-07-06 12:44:31',NULL,NULL),(23926,'26236','S','Selbyville','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.714700,-80.311151,0,'2013-07-06 12:44:31',NULL,NULL),(6444,'05753','S','Weybridge','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.012313,-73.163211,0,'2013-07-06 12:44:30',NULL,NULL),(2919,'01008','S','Blandford','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.143189,-72.931858,0,'2013-07-06 12:44:30',NULL,NULL),(2708,'00969','S','Mans de Guaynabo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(7634,'07064','S','Port Reading','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.566503,-74.257398,0,'2013-07-06 12:44:30',NULL,NULL),(71519,'87117','U','Albuquerque','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.052085,-106.545052,0,'2013-07-06 12:44:34',NULL,NULL),(49695,'57026','S','Ward','A','Brookings','46011','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.232906,-96.484595,0,'2013-07-06 12:44:33',NULL,NULL),(56881,'66027','S','Ft Leavenworth','N','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.361430,-94.923664,0,'2013-07-06 12:44:33',NULL,NULL),(67370,'80113','S','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643479,-104.956040,0,'2013-07-06 12:44:34',NULL,NULL),(75984,'95071','P','Saratoga','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.252860,-122.029595,0,'2013-07-06 12:44:34',NULL,NULL),(79449,'98845','S','Palisades','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.460957,-119.762352,0,'2013-07-06 12:44:34',NULL,NULL),(9303,'09714','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(38025,'43018','P','Etna','D','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.960293,-82.682353,0,'2013-07-06 12:44:32',NULL,NULL),(15347,'16236','P','Mc Grann','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.781649,-79.522667,0,'2013-07-06 12:44:31',NULL,NULL),(74961,'93426','S','Oak Shores','N','Monterey','06053','California','CA','06','7120','805','Pacific',-8.0,'Y',35.755566,-120.978715,0,'2013-07-06 12:44:34',NULL,NULL),(70759,'85329','P','Cashion','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.427690,-112.305076,0,'2013-07-06 12:44:34',NULL,NULL),(64268,'76402','U','Stephenville','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.218530,-98.217122,0,'2013-07-06 12:44:34',NULL,NULL),(63805,'75962','U','S F Austin Univ','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(62417,'74134','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.112907,-95.820260,0,'2013-07-06 12:44:33',NULL,NULL),(58405,'68635','S','Dwight','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.089148,-96.962053,0,'2013-07-06 12:44:33',NULL,NULL),(54198,'62633','S','Poplar City','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.234297,-89.847735,0,'2013-07-06 12:44:33',NULL,NULL),(14539,'15209','S','Millvale','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.496241,-79.979064,0,'2013-07-06 12:44:31',NULL,NULL),(13948,'14450','S','Fairport','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.087492,-77.432058,0,'2013-07-06 12:44:31',NULL,NULL),(11501,'12025','S','Fish House','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(25505,'28376','S','Raeford','D','Hoke','37093','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.986107,-79.206141,0,'2013-07-06 12:44:31',NULL,NULL),(22580,'24157','U','Roanoke','D','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.292411,-80.063958,0,'2013-07-06 12:44:31',NULL,NULL),(44463,'49881','S','Sagola','D','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.068868,-88.064656,0,'2013-07-06 12:44:32',NULL,NULL),(45046,'50481','S','Toeterville','D','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.378333,-92.918611,0,'2013-07-06 12:44:32',NULL,NULL),(79032,'98395','P','Wauna','D','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.363283,-122.700059,0,'2013-07-06 12:44:34',NULL,NULL),(77295,'96662','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69023,'83213','S','Butte City','A','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.636568,-113.293312,0,'2013-07-06 12:44:34',NULL,NULL),(64427,'76557','S','Stampede','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.269780,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(55919,'64456','S','Grant City','D','Worth','29227','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.484416,-94.411236,0,'2013-07-06 12:44:33',NULL,NULL),(7590,'07036','S','Tremley Point','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.635633,-74.256169,0,'2013-07-06 12:44:30',NULL,NULL),(33205,'37046','S','Bethesda','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.772714,-86.714662,0,'2013-07-06 12:44:32',NULL,NULL),(9360,'09817','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(42746,'48023','S','Ira Twp','N','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.688876,-82.669348,0,'2013-07-06 12:44:32',NULL,NULL),(45590,'51548','S','Mc Clelland','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.303365,-95.672529,0,'2013-07-06 12:44:32',NULL,NULL),(46847,'54020','S','Osceola','D','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.320122,-92.699523,0,'2013-07-06 12:44:32',NULL,NULL),(6312,'05661','S','Cadys Falls','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.559826,-72.601659,0,'2013-07-06 12:44:30',NULL,NULL),(73938,'92049','P','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.194820,-117.379671,0,'2013-07-06 12:44:34',NULL,NULL),(68527,'81403','S','Montrose','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.487341,-107.838735,0,'2013-07-06 12:44:34',NULL,NULL),(44539,'49970','S','Watton','D','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.502349,-88.620275,0,'2013-07-06 12:44:32',NULL,NULL),(22711,'24348','S','Independence','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.619535,-81.144242,0,'2013-07-06 12:44:31',NULL,NULL),(9830,'10114','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743057,-74.000308,0,'2013-07-06 12:44:30',NULL,NULL),(18348,'19034','S','Ft Washington','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.135875,-75.206603,0,'2013-07-06 12:44:31',NULL,NULL),(26136,'28734','S','Riverside','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(15215,'16017','U','Office of Personnel Mgmt','N','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.091440,-79.907770,0,'2013-07-06 12:44:31',NULL,NULL),(77747,'97089','S','Damascus','D','Clackamas','41005','Oregon','OR','41','6440','503','Pacific',-8.0,'Y',45.422127,-122.449928,0,'2013-07-06 12:44:34',NULL,NULL),(77286,'96622','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74806,'93207','S','Calif Hot Spg','A','Tulare','06107','California','CA','06','8780','661','Pacific',-8.0,'Y',35.907677,-118.723924,0,'2013-07-06 12:44:34',NULL,NULL),(73158,'90294','P','Venice','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.986206,-118.468275,0,'2013-07-06 12:44:34',NULL,NULL),(62863,'75030','P','Rowlett','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.899918,-96.563730,0,'2013-07-06 12:44:33',NULL,NULL),(53063,'61516','S','Benson','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.851271,-89.119521,0,'2013-07-06 12:44:33',NULL,NULL),(52659,'61068','S','Flag Center','N','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',41.948220,-89.055360,0,'2013-07-06 12:44:33',NULL,NULL),(37893,'42629','S','Bryan','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.976422,-85.093378,0,'2013-07-06 12:44:32',NULL,NULL),(28889,'32127','S','Ponce Inlet','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.110341,-80.980002,0,'2013-07-06 12:44:32',NULL,NULL),(12586,'13072','S','Otselic','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.763862,-75.753162,0,'2013-07-06 12:44:30',NULL,NULL),(22597,'24184','S','Wirtz','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.062960,-79.718160,0,'2013-07-06 12:44:31',NULL,NULL),(45489,'51351','S','W Okoboji','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.323480,-95.169660,0,'2013-07-06 12:44:32',NULL,NULL),(47988,'55128','S','Saint Paul','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.007260,-92.964120,0,'2013-07-06 12:44:33',NULL,NULL),(4863,'04024','S','East Baldwin','D','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.800000,-70.666667,0,'2013-07-06 12:44:30',NULL,NULL),(74476,'92607','P','Laguna Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.526852,-117.711714,0,'2013-07-06 12:44:34',NULL,NULL),(69617,'83866','P','Santa','D','Benewah','16009','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.240469,-116.548417,0,'2013-07-06 12:44:34',NULL,NULL),(68015,'80924','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739417,-104.635170,0,'2013-07-06 12:44:34',NULL,NULL),(56544,'65452','S','Crocker','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.955148,-92.293130,0,'2013-07-06 12:44:33',NULL,NULL),(11824,'12238','U','Ny Park and Rec Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652025,-73.761447,0,'2013-07-06 12:44:30',NULL,NULL),(756,'00692','S','Hacienda El Molino','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(38989,'44132','S','Euclid','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.606668,-81.500850,0,'2013-07-06 12:44:32',NULL,NULL),(75100,'93541','P','Mono City','N','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.002080,-119.069580,0,'2013-07-06 12:44:34',NULL,NULL),(64060,'76134','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.642955,-97.327416,0,'2013-07-06 12:44:34',NULL,NULL),(18026,'18643','S','Pittston','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.328885,-75.815364,0,'2013-07-06 12:44:31',NULL,NULL),(20321,'20832','S','Olney','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.148558,-77.074173,0,'2013-07-06 12:44:31',NULL,NULL),(1280,'00730','S','Jard de Ponce','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(38035,'43029','S','Irwin','D','Union','39159','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.089788,-83.455458,0,'2013-07-06 12:44:32',NULL,NULL),(36076,'40213','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.184398,-85.716074,0,'2013-07-06 12:44:32',NULL,NULL),(14299,'14880','S','Scio','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.166475,-77.984285,0,'2013-07-06 12:44:31',NULL,NULL),(3912,'02458','S','Newton','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.352515,-71.190702,0,'2013-07-06 12:44:30',NULL,NULL),(1663,'00773','S','Urb Costa Azul','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(3841,'02341','S','Hanson','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.055954,-70.868035,0,'2013-07-06 12:44:30',NULL,NULL),(73489,'91325','S','Sherwood Forest','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.239807,-118.516396,0,'2013-07-06 12:44:34',NULL,NULL),(59448,'70726','S','Denham Spgs','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.495187,-90.921746,0,'2013-07-06 12:44:33',NULL,NULL),(54565,'62895','S','Four Mile','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.316600,-88.570680,0,'2013-07-06 12:44:33',NULL,NULL),(44645,'50074','S','Ellston','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.852201,-94.074806,0,'2013-07-06 12:44:32',NULL,NULL),(41370,'46795','S','Lakeside','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(40102,'45311','S','Morning Sun','N','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.633333,-84.650000,0,'2013-07-06 12:44:32',NULL,NULL),(22069,'23341','P','Craddockville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.576848,-75.796523,0,'2013-07-06 12:44:31',NULL,NULL),(12917,'13339','S','Hessville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.958740,-74.578260,0,'2013-07-06 12:44:30',NULL,NULL),(15292,'16133','S','Jackson Center','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.276916,-80.083724,0,'2013-07-06 12:44:31',NULL,NULL),(37901,'42633','S','Bethesda','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(37033,'41256','S','Staffordsville','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.836517,-82.861342,0,'2013-07-06 12:44:32',NULL,NULL),(36682,'41015','S','Ryland','N','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(74213,'92308','S','Jess Ranch','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.460602,-117.192247,0,'2013-07-06 12:44:34',NULL,NULL),(62371,'74074','S','STW','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.107960,-97.076194,0,'2013-07-06 12:44:33',NULL,NULL),(43853,'49106','S','Bridgman','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.942155,-86.551885,0,'2013-07-06 12:44:32',NULL,NULL),(6910,'06152','S','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757059,-72.688643,0,'2013-07-06 12:44:30',NULL,NULL),(9109,'09102','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(19857,'20520','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895588,-77.047964,0,'2013-07-06 12:44:31',NULL,NULL),(4174,'02807','P','New Shoreham','A','Washington','44009','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.180709,-71.573098,0,'2013-07-06 12:44:30',NULL,NULL),(32541,'36107','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.376358,-86.278031,0,'2013-07-06 12:44:32',NULL,NULL),(12364,'12910','S','Altona','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.882237,-73.662504,0,'2013-07-06 12:44:30',NULL,NULL),(38751,'44035','S','Ridgeville','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(1,'00501','U','Holtsville','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.813078,-73.046388,0,'2013-07-06 12:44:30',NULL,NULL),(75353,'93920','S','Big Sur','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.135880,-121.659477,0,'2013-07-06 12:44:34',NULL,NULL),(63751,'75939','S','Carmona','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(53802,'62288','S','Welge','N','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.005855,-89.658943,0,'2013-07-06 12:44:33',NULL,NULL),(37326,'41653','S','Hippo','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.665242,-82.767938,0,'2013-07-06 12:44:32',NULL,NULL),(5796,'05060','S','West Brookfield','A','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.931946,-72.644794,0,'2013-07-06 12:44:30',NULL,NULL),(34039,'38135','S','Bartlett','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229541,-89.853081,0,'2013-07-06 12:44:32',NULL,NULL),(21462,'22624','S','Clear Brook','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.247394,-78.092824,0,'2013-07-06 12:44:31',NULL,NULL),(3578,'01970','S','Salem','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.518116,-70.904469,0,'2013-07-06 12:44:30',NULL,NULL),(5066,'04282','S','Turner','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.261042,-70.189316,0,'2013-07-06 12:44:30',NULL,NULL),(40475,'45769','S','Minersville','N','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.088080,-82.031760,0,'2013-07-06 12:44:32',NULL,NULL),(46726,'53817','P','Patch Grove','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.942923,-90.974330,0,'2013-07-06 12:44:32',NULL,NULL),(48609,'55790','S','Breitung','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.795868,-92.353874,0,'2013-07-06 12:44:33',NULL,NULL),(6734,'06076','S','Union','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.985120,-72.255660,0,'2013-07-06 12:44:30',NULL,NULL),(71604,'87325','S','Tohatchi','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.862100,-108.762199,0,'2013-07-06 12:44:34',NULL,NULL),(69122,'83278','S','Redfish Lake','N','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.330002,-114.863022,0,'2013-07-06 12:44:34',NULL,NULL),(22398,'23952','S','Lunenburg','D','Lunenburg','51111','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.918227,-78.294635,0,'2013-07-06 12:44:31',NULL,NULL),(1057,'00725','S','Brisas Del Parque I','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(75104,'93543','S','Littlerock','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.520996,-117.951674,0,'2013-07-06 12:44:34',NULL,NULL),(76891,'95980','P','Oroville','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(79594,'99036','S','Valleyford','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.531367,-117.266381,0,'2013-07-06 12:44:34',NULL,NULL),(44953,'50391','U','Urbandale','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.585461,-93.622417,0,'2013-07-06 12:44:32',NULL,NULL),(24520,'27284','S','Talleys Crossing','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.116290,-80.092145,0,'2013-07-06 12:44:31',NULL,NULL),(20808,'21562','S','McCoole','A','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.446389,-78.972500,0,'2013-07-06 12:44:31',NULL,NULL),(70972,'85670','P','Sierra Vista','A','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.550000,-110.350000,0,'2013-07-06 12:44:34',NULL,NULL),(57546,'67028','S','Belvidere','A','Pratt','20151','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.514225,-98.902140,0,'2013-07-06 12:44:33',NULL,NULL),(8449,'08086','S','Thorofare','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.836371,-75.181675,0,'2013-07-06 12:44:30',NULL,NULL),(12523,'13032','S','Perryville','A','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083843,-75.768034,0,'2013-07-06 12:44:30',NULL,NULL),(31763,'35004','S','Moody','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.592120,-86.497541,0,'2013-07-06 12:44:32',NULL,NULL),(10122,'10260','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703143,-74.012787,0,'2013-07-06 12:44:30',NULL,NULL),(77982,'97389','S','Tangent','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.537782,-123.101943,0,'2013-07-06 12:44:34',NULL,NULL),(23886,'26169','S','Rockport','D','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.075465,-81.571097,0,'2013-07-06 12:44:31',NULL,NULL),(16215,'17073','S','Newmanstown','D','Lebanon','42075','Pennsylvania','PA','42','3240','610/484','Eastern',-5.0,'Y',40.308720,-76.252800,0,'2013-07-06 12:44:31',NULL,NULL),(24885,'27703','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.973771,-78.838515,0,'2013-07-06 12:44:31',NULL,NULL),(65622,'77957','S','Morales','N','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',28.974180,-96.649920,0,'2013-07-06 12:44:34',NULL,NULL),(43105,'48219','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.423328,-83.250921,0,'2013-07-06 12:44:32',NULL,NULL),(76317,'95454','S','Laytonville','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.731538,-123.505679,0,'2013-07-06 12:44:34',NULL,NULL),(78189,'97721','S','Princeton','D','Harney','41025','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.105420,-118.631740,0,'2013-07-06 12:44:34',NULL,NULL),(69368,'83602','S','Banks','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.172548,-116.028276,0,'2013-07-06 12:44:34',NULL,NULL),(51984,'60154','S','Westchester','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.853882,-87.882073,0,'2013-07-06 12:44:33',NULL,NULL),(8643,'08302','S','Deerfield Twp','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.438881,-75.228175,0,'2013-07-06 12:44:30',NULL,NULL),(79938,'99621','P','Kwethluk','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.772649,-161.387912,0,'2013-07-06 12:44:34',NULL,NULL),(19399,'20073','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896184,-77.022512,0,'2013-07-06 12:44:31',NULL,NULL),(13499,'13804','S','Whitman','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.222370,-75.371063,0,'2013-07-06 12:44:31',NULL,NULL),(10840,'11386','P','Ridgewood','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.700392,-73.894731,0,'2013-07-06 12:44:30',NULL,NULL),(50525,'58102','S','Reiles Acres','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.893312,-96.798609,0,'2013-07-06 12:44:33',NULL,NULL),(31864,'35121','S','Highland Lake','A','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.948154,-86.470543,0,'2013-07-06 12:44:32',NULL,NULL),(24949,'27830','S','Eureka','A','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.542860,-77.965020,0,'2013-07-06 12:44:31',NULL,NULL),(65949,'78264','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.192675,-98.517416,0,'2013-07-06 12:44:34',NULL,NULL),(60483,'71658','S','Montrose','D','Ashley','05003','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.306540,-91.515180,0,'2013-07-06 12:44:33',NULL,NULL),(57648,'67203','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.706617,-97.363073,0,'2013-07-06 12:44:33',NULL,NULL),(7871,'07508','S','Haledon','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.951433,-74.185795,0,'2013-07-06 12:44:30',NULL,NULL),(28880,'32122','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.145349,-81.029374,0,'2013-07-06 12:44:32',NULL,NULL),(37793,'42370','P','Rosine','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.667156,-86.828682,0,'2013-07-06 12:44:32',NULL,NULL),(43803,'49062','P','Kendall','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.360890,-85.815472,0,'2013-07-06 12:44:32',NULL,NULL),(68084,'80939','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798565,-104.836169,0,'2013-07-06 12:44:34',NULL,NULL),(1246,'00729','S','Qtas Jard de Parmarejo','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(5334,'04605','S','Amherst','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(5553,'04851','P','Matinicus','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.045854,-68.630969,0,'2013-07-06 12:44:30',NULL,NULL),(50786,'58436','S','Ellendale','D','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.002161,-98.521819,0,'2013-07-06 12:44:33',NULL,NULL),(24853,'27628','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.804185,-78.645560,0,'2013-07-06 12:44:31',NULL,NULL),(44227,'49651','S','Lake City','D','Missaukee','26113','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.386560,-85.145400,0,'2013-07-06 12:44:32',NULL,NULL),(3477,'01826','S','Dracut','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.676829,-71.314567,0,'2013-07-06 12:44:30',NULL,NULL),(30973,'33741','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.688063,-82.733847,0,'2013-07-06 12:44:32',NULL,NULL),(77650,'97016','S','Clatskanie','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.996389,-123.255278,0,'2013-07-06 12:44:34',NULL,NULL),(25065,'27935','S','Eure','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.421909,-76.857501,0,'2013-07-06 12:44:31',NULL,NULL),(53896,'62360','S','Fall Creek','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.818387,-91.239589,0,'2013-07-06 12:44:33',NULL,NULL),(22916,'24609','S','Belfast Mills','N','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083840,-81.768540,0,'2013-07-06 12:44:31',NULL,NULL),(45537,'51450','S','Carnarvon','A','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.304670,-95.045383,0,'2013-07-06 12:44:32',NULL,NULL),(36369,'40452','P','Mitchellsburg','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.598414,-84.964295,0,'2013-07-06 12:44:32',NULL,NULL),(33401,'37227','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.132543,-86.669444,0,'2013-07-06 12:44:32',NULL,NULL),(14812,'15417','S','Brownsville','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.031040,-79.929900,0,'2013-07-06 12:44:31',NULL,NULL),(12080,'12553','S','New Windsor','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.470200,-74.070060,0,'2013-07-06 12:44:30',NULL,NULL),(945,'00716','S','Est del Carmen','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(79599,'99039','P','Waverly','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.311882,-117.246753,0,'2013-07-06 12:44:34',NULL,NULL),(65117,'77375','S','The Woodlands','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.081648,-95.615932,0,'2013-07-06 12:44:34',NULL,NULL),(16978,'17724','S','Leroy','A','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(56983,'66202','S','Prairie Village','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(72684,'89445','S','Cosgrave','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(4842,'04010','S','Brownfield','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.184244,-70.743656,0,'2013-07-06 12:44:30',NULL,NULL),(13400,'13751','S','Davenport Center','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.456620,-74.900750,0,'2013-07-06 12:44:31',NULL,NULL),(37913,'42633','S','Parnell','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(15078,'15748','S','Graceton','A','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.525920,-79.162140,0,'2013-07-06 12:44:31',NULL,NULL),(14244,'14820','S','Cameron Mills','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.233846,-77.337118,0,'2013-07-06 12:44:31',NULL,NULL),(66966,'79404','S','Buffalo Springs','A','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.553575,-101.821365,0,'2013-07-06 12:44:34',NULL,NULL),(29996,'33114','P','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.752299,-80.270652,0,'2013-07-06 12:44:32',NULL,NULL),(44069,'49444','S','Muskegon Hts','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.168440,-86.184540,0,'2013-07-06 12:44:32',NULL,NULL),(42382,'47721','U','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.915026,-87.648785,0,'2013-07-06 12:44:32',NULL,NULL),(31872,'35124','S','Indian Springs Village','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.301860,-86.791800,0,'2013-07-06 12:44:32',NULL,NULL),(37390,'41759','S','Sassafras','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.239124,-83.035289,0,'2013-07-06 12:44:32',NULL,NULL),(77975,'97381','S','Silverton','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.895069,-122.564126,0,'2013-07-06 12:44:34',NULL,NULL),(68368,'81137','S','Southern Ute Indian Reservat','A','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(48564,'55766','P','Whiteface','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.236200,-92.412180,0,'2013-07-06 12:44:33',NULL,NULL),(25335,'28212','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.192219,-80.715194,0,'2013-07-06 12:44:31',NULL,NULL),(68560,'81434','S','Somerset','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.963810,-107.296606,0,'2013-07-06 12:44:34',NULL,NULL),(13173,'13614','S','Brier Hill','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.541243,-75.688955,0,'2013-07-06 12:44:30',NULL,NULL),(16297,'17108','P','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.281473,-76.846974,0,'2013-07-06 12:44:31',NULL,NULL),(78581,'98174','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.604103,-122.337504,0,'2013-07-06 12:44:34',NULL,NULL),(65091,'77357','S','New Caney','D','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.134460,-95.180700,0,'2013-07-06 12:44:34',NULL,NULL),(13778,'14145','S','Strykersville','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.738540,-78.424560,0,'2013-07-06 12:44:31',NULL,NULL),(4228,'02857','S','N Scituate','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.833680,-71.641620,0,'2013-07-06 12:44:30',NULL,NULL),(59233,'70427','S','Rio','N','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(53590,'62070','S','Mozier','D','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.291007,-90.722780,0,'2013-07-06 12:44:33',NULL,NULL),(53414,'61843','S','Fisher','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.319041,-88.348527,0,'2013-07-06 12:44:33',NULL,NULL),(46104,'52627','S','Sawyer','N','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.632072,-91.335554,0,'2013-07-06 12:44:32',NULL,NULL),(38988,'44132','S','Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.606668,-81.500850,0,'2013-07-06 12:44:32',NULL,NULL),(25666,'28510','S','Arapahoe','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.979257,-76.825851,0,'2013-07-06 12:44:31',NULL,NULL),(32599,'36132','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.380100,-86.181883,0,'2013-07-06 12:44:32',NULL,NULL),(52758,'61250','S','Erie','D','Whiteside','17195','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.670529,-90.096703,0,'2013-07-06 12:44:33',NULL,NULL),(43711,'48909','P','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.733354,-84.549580,0,'2013-07-06 12:44:32',NULL,NULL),(66768,'79022','S','Dalhart','D','Dallam','48111','Texas','TX','48','0000','806','Central',-6.0,'Y',36.063187,-102.519966,0,'2013-07-06 12:44:34',NULL,NULL),(52102,'60411','S','South Chicago Heights','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(50247,'57626','S','Edson','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(44904,'50324','S','Windsor Hts','A','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.543762,-93.586549,0,'2013-07-06 12:44:32',NULL,NULL),(71247,'86401','S','Lake Mead Rancheros','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.524020,-113.992680,0,'2013-07-06 12:44:34',NULL,NULL),(70074,'84150','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.772019,-111.889801,0,'2013-07-06 12:44:34',NULL,NULL),(26602,'29250','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.002817,-81.005802,0,'2013-07-06 12:44:31',NULL,NULL),(25243,'28105','S','Matthews','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.114340,-80.693940,0,'2013-07-06 12:44:31',NULL,NULL),(15879,'17003','S','Bellegrove','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(28578,'31626','S','Boston','D','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.791561,-83.786193,0,'2013-07-06 12:44:32',NULL,NULL),(47796,'55047','S','St Croix','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.202860,-92.825280,0,'2013-07-06 12:44:33',NULL,NULL),(38512,'43719','S','Bethesda','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',39.985860,-81.075720,0,'2013-07-06 12:44:32',NULL,NULL),(37130,'41465','S','Cisco','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(32228,'35577','P','Natural Bridge','D','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.088637,-87.604239,0,'2013-07-06 12:44:32',NULL,NULL),(57401,'66760','P','Opolis','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.347211,-94.619694,0,'2013-07-06 12:44:33',NULL,NULL),(16687,'17368','S','Wrightsville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015953,-76.528879,0,'2013-07-06 12:44:31',NULL,NULL),(18334,'19027','S','Melrose Park','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.017822,-75.135978,0,'2013-07-06 12:44:31',NULL,NULL),(75798,'94720','U','UC Berkeley','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.868252,-122.258486,0,'2013-07-06 12:44:34',NULL,NULL),(14183,'14748','S','Kill Buck','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.149646,-78.639987,0,'2013-07-06 12:44:31',NULL,NULL),(17813,'18407','S','Simpson','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.572651,-75.499232,0,'2013-07-06 12:44:31',NULL,NULL),(25195,'28072','P','Granite Quarry','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.607440,-80.444746,0,'2013-07-06 12:44:31',NULL,NULL),(23155,'25007','S','Arnett','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.840631,-81.438192,0,'2013-07-06 12:44:31',NULL,NULL),(6690,'06051','S','New Brit','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.662408,-72.770431,0,'2013-07-06 12:44:30',NULL,NULL),(47492,'54755','S','Rock Falls','A','Buffalo','55011','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.566394,-91.671809,0,'2013-07-06 12:44:32',NULL,NULL),(79949,'99628','P','Manokotak','D','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.863367,-159.127113,0,'2013-07-06 12:44:34',NULL,NULL),(26690,'29405','S','No Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.859430,-79.988157,0,'2013-07-06 12:44:31',NULL,NULL),(26429,'29127','S','Stockman','N','Newberry','45071','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.182431,-81.520940,0,'2013-07-06 12:44:31',NULL,NULL),(8586,'08223','S','Marmora','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.262920,-74.661780,0,'2013-07-06 12:44:30',NULL,NULL),(44689,'50126','S','Owasa','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.512225,-93.291365,0,'2013-07-06 12:44:32',NULL,NULL),(71504,'87111','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.134826,-106.518962,0,'2013-07-06 12:44:34',NULL,NULL),(10035,'10173','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754208,-73.980058,0,'2013-07-06 12:44:30',NULL,NULL),(44783,'50217','S','Paton','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.162387,-94.255165,0,'2013-07-06 12:44:32',NULL,NULL),(49374,'56588','S','Vining','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.240869,-95.583181,0,'2013-07-06 12:44:33',NULL,NULL),(65027,'77325','P','Kingwood','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.068280,-95.216280,0,'2013-07-06 12:44:34',NULL,NULL),(77907,'97306','S','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.864263,-123.050408,0,'2013-07-06 12:44:34',NULL,NULL),(41313,'46773','S','Monroeville','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.982510,-84.877333,0,'2013-07-06 12:44:32',NULL,NULL),(41645,'47135','S','Laconia','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.039760,-86.074463,0,'2013-07-06 12:44:32',NULL,NULL),(4295,'02904','S','N Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.832900,-71.437560,0,'2013-07-06 12:44:30',NULL,NULL),(69693,'84029','S','Grantsville','D','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.604525,-112.456180,0,'2013-07-06 12:44:34',NULL,NULL),(14632,'15233','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.457777,-80.026332,0,'2013-07-06 12:44:31',NULL,NULL),(13889,'14267','U','M and T Bank','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.916696,-78.877078,0,'2013-07-06 12:44:31',NULL,NULL),(10555,'11001','S','South Floral Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.719635,-73.706913,0,'2013-07-06 12:44:30',NULL,NULL),(9035,'08876','S','North Branch','A','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.543740,-74.660040,0,'2013-07-06 12:44:30',NULL,NULL),(30381,'33319','S','Lauder Hill','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(37938,'42653','S','Whitley City','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.720391,-84.465547,0,'2013-07-06 12:44:32',NULL,NULL),(77889,'97282','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.481652,-122.639279,0,'2013-07-06 12:44:34',NULL,NULL),(72549,'89191','P','Nellis Air Force Base','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.244017,-115.040965,0,'2013-07-06 12:44:34',NULL,NULL),(10059,'10177','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(2531,'00958','P','Bayamon','D','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.177224,-66.116169,0,'2013-07-06 12:44:30',NULL,NULL),(4237,'02861','S','Pawtucket','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.881170,-71.355799,0,'2013-07-06 12:44:30',NULL,NULL),(30401,'33323','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.162098,-80.306679,0,'2013-07-06 12:44:32',NULL,NULL),(245,'00637','S','Sabana Grande','D','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(42544,'47868','S','Jordan','N','Owen','18119','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.450742,-86.974712,0,'2013-07-06 12:44:32',NULL,NULL),(56540,'65444','S','Bucyrus','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.399403,-92.038861,0,'2013-07-06 12:44:33',NULL,NULL),(63962,'76097','P','Burleson','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.540910,-97.321069,0,'2013-07-06 12:44:34',NULL,NULL),(528,'00674','S','Valles De Manati','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(33889,'38029','P','Ellendale','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.202963,-89.820479,0,'2013-07-06 12:44:32',NULL,NULL),(66109,'78413','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.687141,-97.400470,0,'2013-07-06 12:44:34',NULL,NULL),(44791,'50225','S','Beech','N','Marion','19125','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.388347,-93.271889,0,'2013-07-06 12:44:32',NULL,NULL),(28112,'30806','P','Boneville','D','McDuffie','13189','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.526632,-82.513399,0,'2013-07-06 12:44:31',NULL,NULL),(28827,'32081','S','Tn of Nocatee','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173581,-81.395627,0,'2013-07-06 12:44:32',NULL,NULL),(27394,'30086','P','St Mountain','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.803359,-84.103425,0,'2013-07-06 12:44:31',NULL,NULL),(50870,'58520','S','Almont','D','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.695511,-101.540211,0,'2013-07-06 12:44:33',NULL,NULL),(45698,'52053','S','Holy Cross','D','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.591397,-90.963771,0,'2013-07-06 12:44:32',NULL,NULL),(13180,'13617','S','Eddy','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(77384,'96762','S','Laie','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.647614,-157.926602,0,'2013-07-06 12:44:34',NULL,NULL),(69540,'83801','S','Chilco','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.936824,-116.675482,0,'2013-07-06 12:44:34',NULL,NULL),(561,'00678','S','Parc Chivas','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(11733,'12182','S','Lansingburg','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.775992,-73.660085,0,'2013-07-06 12:44:30',NULL,NULL),(61930,'73154','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.521987,-97.527560,0,'2013-07-06 12:44:33',NULL,NULL),(46560,'53510','S','Belmont','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.729527,-90.330139,0,'2013-07-06 12:44:32',NULL,NULL),(43014,'48164','S','Huron Twp','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(74114,'92231','S','Calexico','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.691821,-115.504813,0,'2013-07-06 12:44:34',NULL,NULL),(33793,'37882','S','Townsend','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.627245,-83.783892,0,'2013-07-06 12:44:32',NULL,NULL),(17303,'17853','S','Meiserville','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(79336,'98617','P','Dallesport','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.619824,-121.178551,0,'2013-07-06 12:44:34',NULL,NULL),(26286,'29020','S','Red Hill','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(60530,'71674','S','Kurdo','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.798097,-91.302406,0,'2013-07-06 12:44:33',NULL,NULL),(55986,'64630','S','Browning','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.008468,-93.170966,0,'2013-07-06 12:44:33',NULL,NULL),(36938,'41164','S','Lawton','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(31341,'34141','S','Ochopee','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.906809,-81.303364,0,'2013-07-06 12:44:32',NULL,NULL),(18425,'19061','S','Upper Chichester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(79547,'99001','S','Airway Heights','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.650357,-117.616267,0,'2013-07-06 12:44:34',NULL,NULL),(61489,'72641','S','Low Gap','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.002568,-93.217954,0,'2013-07-06 12:44:33',NULL,NULL),(60317,'71457','S','Irma','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(39444,'44695','S','Conotton','N','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.415653,-81.173846,0,'2013-07-06 12:44:32',NULL,NULL),(14999,'15658','S','Wilpen','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.224180,-79.216740,0,'2013-07-06 12:44:31',NULL,NULL),(25432,'28306','S','Lakedale','N','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.010174,-78.930528,0,'2013-07-06 12:44:31',NULL,NULL),(68395,'81152','S','Mesita','A','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(64417,'76550','S','Lampasas','D','Lampasas','48281','Texas','TX','48','0000','512/737','Central',-6.0,'Y',31.066265,-98.180696,0,'2013-07-06 12:44:34',NULL,NULL),(29345,'32559','U','Educ Dev Ctr Corresp','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.465303,-87.338781,0,'2013-07-06 12:44:32',NULL,NULL),(57865,'67576','S','Seward','A','Stafford','20185','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.003667,-98.761543,0,'2013-07-06 12:44:33',NULL,NULL),(12285,'12844','S','Kattskill Bay','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.515833,-73.629722,0,'2013-07-06 12:44:30',NULL,NULL),(40337,'45601','S','Chillicothe','D','Ross','39141','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.328095,-82.982598,0,'2013-07-06 12:44:32',NULL,NULL),(34195,'38334','S','Finger','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.318925,-88.596816,0,'2013-07-06 12:44:32',NULL,NULL),(1773,'00780','S','Urb Santa Rita 3','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(1621,'00771','S','Est del Rocio','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(73474,'91313','P','Chatsworth','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.239477,-118.588495,0,'2013-07-06 12:44:34',NULL,NULL),(8909,'08736','S','Wall Township','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.122204,-74.063541,0,'2013-07-06 12:44:30',NULL,NULL),(17282,'17846','S','Millville','D','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.135280,-76.519320,0,'2013-07-06 12:44:31',NULL,NULL),(36882,'41101','S','Ashland','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.459835,-82.661314,0,'2013-07-06 12:44:32',NULL,NULL),(52607,'61024','S','Durand','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.441983,-89.312535,0,'2013-07-06 12:44:33',NULL,NULL),(42459,'47832','S','Sylvania','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.844258,-87.267425,0,'2013-07-06 12:44:32',NULL,NULL),(76535,'95656','P','Mount Aukum','D','El Dorado','06017','California','CA','06','6920','209','Pacific',-8.0,'Y',38.563380,-120.714932,0,'2013-07-06 12:44:34',NULL,NULL),(41286,'46761','S','Mount Pisgah','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(74940,'93408','U','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.222175,-120.637046,0,'2013-07-06 12:44:34',NULL,NULL),(58164,'68183','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.258306,-95.938217,0,'2013-07-06 12:44:33',NULL,NULL),(45095,'50540','S','Fonda','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.586237,-94.844066,0,'2013-07-06 12:44:32',NULL,NULL),(37681,'42219','S','Dunbar','D','Butler','21031','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.164221,-86.749492,0,'2013-07-06 12:44:32',NULL,NULL),(31082,'33860','S','Mulberry','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.898459,-81.996840,0,'2013-07-06 12:44:32',NULL,NULL),(23734,'25917','S','Scarbro','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.969510,-81.158866,0,'2013-07-06 12:44:31',NULL,NULL),(6688,'06045','P','Manchester','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.775734,-72.523200,0,'2013-07-06 12:44:30',NULL,NULL),(68875,'82642','S','Lysite','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.300855,-107.638296,0,'2013-07-06 12:44:34',NULL,NULL),(48020,'55187','U','Target Direct','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.947433,-92.911685,0,'2013-07-06 12:44:33',NULL,NULL),(47295,'54546','S','Mellen','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.324004,-90.656945,0,'2013-07-06 12:44:32',NULL,NULL),(31000,'33770','S','Largo','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.920852,-82.799669,0,'2013-07-06 12:44:32',NULL,NULL),(32841,'36481','S','Vredenburgh','D','Monroe','01099','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.823614,-87.310611,0,'2013-07-06 12:44:32',NULL,NULL),(7426,'06817','U','Union Carbide Corp','N','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.396437,-73.456032,0,'2013-07-06 12:44:30',NULL,NULL),(65159,'77399','U','Livingston','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.713086,-94.935409,0,'2013-07-06 12:44:34',NULL,NULL),(62558,'74446','P','Okay','D','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.848789,-95.315507,0,'2013-07-06 12:44:33',NULL,NULL),(59028,'70082','P','Davant','A','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.575598,-89.793242,0,'2013-07-06 12:44:33',NULL,NULL),(13174,'13615','P','Brownville','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006764,-75.986222,0,'2013-07-06 12:44:30',NULL,NULL),(9677,'10041','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(45008,'50452','S','Latimer','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.775174,-93.321219,0,'2013-07-06 12:44:32',NULL,NULL),(40167,'45367','U','Amos Press Inc','N','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.289153,-84.163256,0,'2013-07-06 12:44:32',NULL,NULL),(35793,'39751','S','Pinebluff','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.733333,-89.066667,0,'2013-07-06 12:44:32',NULL,NULL),(29669,'32912','P','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.078258,-80.603624,0,'2013-07-06 12:44:32',NULL,NULL),(78850,'98339','S','Hadlock','N','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.027885,-122.759844,0,'2013-07-06 12:44:34',NULL,NULL),(47650,'54930','S','Richford','N','Waushara','55137','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.024459,-89.636788,0,'2013-07-06 12:44:33',NULL,NULL),(33024,'36721','S','Annemanie','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.073132,-87.563594,0,'2013-07-06 12:44:32',NULL,NULL),(11491,'12020','S','Pioneer','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(71325,'86506','P','Allentown','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.389139,-109.283418,0,'2013-07-06 12:44:34',NULL,NULL),(67228,'79928','S','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.757176,-106.486005,0,'2013-07-06 12:44:34',NULL,NULL),(62660,'74633','S','Burbank','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.694260,-96.730275,0,'2013-07-06 12:44:33',NULL,NULL),(27883,'30455','S','Rocky Ford','D','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.658804,-81.744488,0,'2013-07-06 12:44:31',NULL,NULL),(27450,'30122','S','Lithia Springs','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.773697,-84.637899,0,'2013-07-06 12:44:31',NULL,NULL),(41062,'46508','S','Burket','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.153498,-85.967310,0,'2013-07-06 12:44:32',NULL,NULL),(49321,'56549','S','Hawley','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.740000,-96.237778,0,'2013-07-06 12:44:33',NULL,NULL),(71921,'87829','S','Omega','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.311420,-108.809880,0,'2013-07-06 12:44:34',NULL,NULL),(67879,'80840','S','USAF Academy','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.999759,-104.695596,0,'2013-07-06 12:44:34',NULL,NULL),(61822,'73109','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.433770,-97.518393,0,'2013-07-06 12:44:33',NULL,NULL),(60334,'71463','S','Oakdale','D','Allen','22003','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.817482,-92.658202,0,'2013-07-06 12:44:33',NULL,NULL),(27479,'30149','P','Rome','A','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.275000,-85.183320,0,'2013-07-06 12:44:31',NULL,NULL),(25566,'28424','P','Brunswick','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.289270,-78.705899,0,'2013-07-06 12:44:31',NULL,NULL),(14391,'15046','S','Glenwillard','A','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.548807,-80.217723,0,'2013-07-06 12:44:31',NULL,NULL),(13722,'14086','S','Lancaster','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.905877,-78.627625,0,'2013-07-06 12:44:31',NULL,NULL),(11974,'12464','S','Phoenicia','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.997088,-74.334644,0,'2013-07-06 12:44:30',NULL,NULL),(48913,'56138','S','Hills','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.525924,-96.360077,0,'2013-07-06 12:44:33',NULL,NULL),(56978,'66202','S','Countryside','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(76599,'95688','S','Vacaville','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.396760,-122.004180,0,'2013-07-06 12:44:34',NULL,NULL),(75743,'94607','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.805982,-122.285871,0,'2013-07-06 12:44:34',NULL,NULL),(58075,'68062','S','Thurston','D','Thurston','31173','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.196266,-96.682949,0,'2013-07-06 12:44:33',NULL,NULL),(23077,'24892','S','English','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.304104,-81.680662,0,'2013-07-06 12:44:31',NULL,NULL),(28598,'31648','S','Statenville','D','Echols','13101','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.707394,-82.849717,0,'2013-07-06 12:44:32',NULL,NULL),(29359,'32568','S','Walnut Hill','A','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.869340,-87.453840,0,'2013-07-06 12:44:32',NULL,NULL),(14029,'14545','S','Groveland','A','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.663666,-77.713631,0,'2013-07-06 12:44:31',NULL,NULL),(4777,'03862','S','N Hampton','N','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.976443,-70.820892,0,'2013-07-06 12:44:30',NULL,NULL),(35135,'39216','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.335115,-90.166439,0,'2013-07-06 12:44:32',NULL,NULL),(1791,'00783','S','Sect Cienagueta','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(42014,'47432','S','Lost River','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.545144,-86.619616,0,'2013-07-06 12:44:32',NULL,NULL),(66090,'78404','S','CC','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.766532,-97.401972,0,'2013-07-06 12:44:34',NULL,NULL),(27113,'29731','P','Rock Hill','D','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.963690,-81.051035,0,'2013-07-06 12:44:31',NULL,NULL),(26961,'29608','P','Park Place','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.901963,-82.409599,0,'2013-07-06 12:44:31',NULL,NULL),(14376,'15031','S','Cuddy','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.351382,-80.169707,0,'2013-07-06 12:44:31',NULL,NULL),(44214,'49638','S','Harrietta','D','Wexford','26165','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.291982,-85.727444,0,'2013-07-06 12:44:32',NULL,NULL),(53815,'62298','S','Burksville','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(54233,'62662','P','Lowder','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.553094,-89.846458,0,'2013-07-06 12:44:33',NULL,NULL),(61189,'72212','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.790223,-92.422264,0,'2013-07-06 12:44:33',NULL,NULL),(5531,'04780','S','Moro Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.166860,-68.269882,0,'2013-07-06 12:44:30',NULL,NULL),(10347,'10567','S','Cortlandt Manor','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.279156,-73.872830,0,'2013-07-06 12:44:30',NULL,NULL),(11571,'12065','S','Jonesville','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.851460,-73.798980,0,'2013-07-06 12:44:30',NULL,NULL),(34663,'38801','S','Bissell','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.233855,-88.738853,0,'2013-07-06 12:44:32',NULL,NULL),(14074,'14608','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.152750,-77.625651,0,'2013-07-06 12:44:31',NULL,NULL),(36782,'41046','S','Glencoe','D','Gallatin','21077','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.713339,-84.799484,0,'2013-07-06 12:44:32',NULL,NULL),(38579,'43793','S','Antioch','A','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.755116,-81.112949,0,'2013-07-06 12:44:32',NULL,NULL),(67631,'80449','S','Hartsel','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.861422,-105.804729,0,'2013-07-06 12:44:34',NULL,NULL),(41488,'46941','S','Lagro','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.838011,-85.728898,0,'2013-07-06 12:44:32',NULL,NULL),(18920,'19495','U','Providian Agon','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.054002,-75.557455,0,'2013-07-06 12:44:31',NULL,NULL),(22366,'23917','S','Palmer Springs','N','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.655688,-78.378914,0,'2013-07-06 12:44:31',NULL,NULL),(10160,'10278','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.711322,-74.008880,0,'2013-07-06 12:44:30',NULL,NULL),(37834,'42451','S','Reed','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.859401,-87.380990,0,'2013-07-06 12:44:32',NULL,NULL),(31363,'34206','P','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.491765,-82.572897,0,'2013-07-06 12:44:32',NULL,NULL),(21482,'22645','S','Middletown','D','Frederick','51069','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.025765,-78.278230,0,'2013-07-06 12:44:31',NULL,NULL),(43793,'49052','S','Fulton','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.107053,-85.339615,0,'2013-07-06 12:44:32',NULL,NULL),(51572,'59759','S','Whitehall','D','Jefferson','30043','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.870160,-112.140493,0,'2013-07-06 12:44:33',NULL,NULL),(76501,'95638','S','Clay','N','Sacramento','06067','California','CA','06','6920','209','Pacific',-8.0,'Y',38.347884,-121.109377,0,'2013-07-06 12:44:34',NULL,NULL),(39381,'44648','P','Massillon','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.754160,-81.513999,0,'2013-07-06 12:44:32',NULL,NULL),(26927,'29585','S','Pawleys Island','D','Georgetown','45043','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.453325,-79.135137,0,'2013-07-06 12:44:31',NULL,NULL),(11907,'12406','S','Arkville','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.108167,-74.530179,0,'2013-07-06 12:44:30',NULL,NULL),(20416,'20906','S','Norbeck','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.081407,-77.056897,0,'2013-07-06 12:44:31',NULL,NULL),(41256,'46746','S','Howe','D','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.716860,-85.413840,0,'2013-07-06 12:44:32',NULL,NULL),(46703,'53791','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077245,-89.454359,0,'2013-07-06 12:44:32',NULL,NULL),(39966,'45237','S','Bond Hill','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(37738,'42302','P','Owensboro','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.765092,-87.043646,0,'2013-07-06 12:44:32',NULL,NULL),(2530,'00957','S','VISTA Alta','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(12172,'12759','S','Loch Sheldrake','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.784360,-74.659800,0,'2013-07-06 12:44:30',NULL,NULL),(11134,'11706','S','West Bay Shore','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(74348,'92407','S','Verdemont','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(62950,'75105','S','Chatfield','D','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.290400,-96.368573,0,'2013-07-06 12:44:33',NULL,NULL),(53581,'62063','S','Kemper','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.205251,-90.162210,0,'2013-07-06 12:44:33',NULL,NULL),(7323,'06703','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.528912,-73.007869,0,'2013-07-06 12:44:30',NULL,NULL),(25508,'28379','S','Rockingham','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.936426,-79.763623,0,'2013-07-06 12:44:31',NULL,NULL),(32528,'36101','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.398863,-86.325648,0,'2013-07-06 12:44:32',NULL,NULL),(38273,'43319','S','East Liberty','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.306292,-83.580853,0,'2013-07-06 12:44:32',NULL,NULL),(3472,'01821','S','Billerica','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.549001,-71.247667,0,'2013-07-06 12:44:30',NULL,NULL),(19805,'20441','U','Inter Amer Defense Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.923260,-77.034800,0,'2013-07-06 12:44:31',NULL,NULL),(61694,'72950','S','Parks','D','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.792808,-93.875162,0,'2013-07-06 12:44:33',NULL,NULL),(55584,'63901','S','Rombauer','A','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.760411,-90.402714,0,'2013-07-06 12:44:33',NULL,NULL),(52059,'60203','S','Evanston','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.051639,-87.717787,0,'2013-07-06 12:44:33',NULL,NULL),(45550,'51463','S','Templeton','D','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.908678,-94.917539,0,'2013-07-06 12:44:32',NULL,NULL),(37251,'41559','S','Regina','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.359629,-82.372947,0,'2013-07-06 12:44:32',NULL,NULL),(20561,'21131','S','Phoenix','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.501074,-76.573561,0,'2013-07-06 12:44:31',NULL,NULL),(42489,'47840','S','Center Point','A','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.376944,-87.100716,0,'2013-07-06 12:44:32',NULL,NULL),(43584,'48748','S','National City','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.300286,-83.674914,0,'2013-07-06 12:44:32',NULL,NULL),(13367,'13733','S','New Berlin Junction','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.304440,-75.480180,0,'2013-07-06 12:44:31',NULL,NULL),(79089,'98439','S','Joint Base Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(76649,'95726','S','Pacific House','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.756220,-120.546600,0,'2013-07-06 12:44:34',NULL,NULL),(74284,'92363','S','Chemehuevi','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.833512,-114.602406,0,'2013-07-06 12:44:34',NULL,NULL),(63484,'75692','S','Waskom','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.476919,-94.063815,0,'2013-07-06 12:44:33',NULL,NULL),(30933,'33712','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.730222,-82.667425,0,'2013-07-06 12:44:32',NULL,NULL),(25202,'28078','S','Hicks Crossroads','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.414040,-80.852580,0,'2013-07-06 12:44:31',NULL,NULL),(46466,'53215','S','West Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.997687,-87.942662,0,'2013-07-06 12:44:32',NULL,NULL),(47116,'54450','P','Mattoon','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.005716,-89.042156,0,'2013-07-06 12:44:32',NULL,NULL),(74881,'93277','S','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.312162,-119.307419,0,'2013-07-06 12:44:34',NULL,NULL),(74543,'92662','S','Newport Beach','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.606234,-117.893145,0,'2013-07-06 12:44:34',NULL,NULL),(74502,'92629','S','Dana Point','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.474313,-117.696438,0,'2013-07-06 12:44:34',NULL,NULL),(70741,'85309','S','Luke AFB','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538316,-112.370171,0,'2013-07-06 12:44:34',NULL,NULL),(68655,'81645','P','Minturn','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.570257,-106.418899,0,'2013-07-06 12:44:34',NULL,NULL),(66489,'78671','S','Albert','A','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.209657,-98.657123,0,'2013-07-06 12:44:34',NULL,NULL),(37441,'41836','S','Mallie','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.301259,-82.915491,0,'2013-07-06 12:44:32',NULL,NULL),(11727,'12180','S','Snyders Corners','N','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.744000,-73.605120,0,'2013-07-06 12:44:30',NULL,NULL),(29988,'33106','U','Skyshop Logistics Inc','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796832,-80.301438,0,'2013-07-06 12:44:32',NULL,NULL),(18579,'19130','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.968491,-75.173091,0,'2013-07-06 12:44:31',NULL,NULL),(25020,'27886','S','Princeville','A','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.898660,-77.558220,0,'2013-07-06 12:44:31',NULL,NULL),(23863,'26147','S','Grantsville','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.921135,-81.093194,0,'2013-07-06 12:44:31',NULL,NULL),(39574,'44854','S','New Washingtn','A','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.951507,-82.851713,0,'2013-07-06 12:44:32',NULL,NULL),(41795,'47326','S','Jay City','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.536527,-84.963031,0,'2013-07-06 12:44:32',NULL,NULL),(44607,'50054','S','Goddard','N','Jasper','19099','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.681400,-93.267900,0,'2013-07-06 12:44:32',NULL,NULL),(45262,'50666','S','Plainfield','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.845914,-92.535460,0,'2013-07-06 12:44:32',NULL,NULL),(52283,'60527','S','Willowbrook','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.841820,-87.951040,0,'2013-07-06 12:44:33',NULL,NULL),(54277,'62689','P','Thayer','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.539231,-89.762271,0,'2013-07-06 12:44:33',NULL,NULL),(14535,'15208','S','Homewood','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.456388,-79.897619,0,'2013-07-06 12:44:31',NULL,NULL),(64816,'77027','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.738237,-95.446438,0,'2013-07-06 12:44:34',NULL,NULL),(63368,'75642','P','Elysian Fields','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.366441,-94.185982,0,'2013-07-06 12:44:33',NULL,NULL),(53159,'61564','P','South Pekin','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.493654,-89.656135,0,'2013-07-06 12:44:33',NULL,NULL),(49332,'56560','S','Kragnes','N','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.890120,-96.744720,0,'2013-07-06 12:44:33',NULL,NULL),(21459,'22620','S','Boyce','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.079260,-78.049642,0,'2013-07-06 12:44:31',NULL,NULL),(22253,'23667','U','Kecoughtan Veterans Hospital','N','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.009530,-76.385641,0,'2013-07-06 12:44:31',NULL,NULL),(5165,'04427','S','Corinth','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.983476,-69.013009,0,'2013-07-06 12:44:30',NULL,NULL),(8094,'07762','S','Wall','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(10251,'10471','S','Riverdale','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.903491,-73.903466,0,'2013-07-06 12:44:30',NULL,NULL),(6268,'05604','U','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.257063,-72.587791,0,'2013-07-06 12:44:30',NULL,NULL),(5099,'04347','S','Hallowell','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.281990,-69.790056,0,'2013-07-06 12:44:30',NULL,NULL),(69943,'84116','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.785043,-111.930074,0,'2013-07-06 12:44:34',NULL,NULL),(61058,'72121','S','Little Red','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.423264,-91.839892,0,'2013-07-06 12:44:33',NULL,NULL),(58053,'68034','S','Kennard','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.472000,-96.203364,0,'2013-07-06 12:44:33',NULL,NULL),(14286,'14865','S','Montour Falls','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.344960,-76.837674,0,'2013-07-06 12:44:31',NULL,NULL),(28750,'31999','U','American Family Life Ins','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.457882,-84.988344,0,'2013-07-06 12:44:32',NULL,NULL),(22803,'24473','S','Rockbridge Baths','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.899159,-79.396696,0,'2013-07-06 12:44:31',NULL,NULL),(806,'00693','S','Urb Brasilia','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(79115,'98467','S','University Pl','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.235833,-122.549167,0,'2013-07-06 12:44:34',NULL,NULL),(71083,'85928','S','Heber','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.428988,-110.543120,0,'2013-07-06 12:44:34',NULL,NULL),(66497,'78676','S','Woodcreek','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.039060,-98.139780,0,'2013-07-06 12:44:34',NULL,NULL),(50942,'58576','S','Underwood','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.451649,-101.137530,0,'2013-07-06 12:44:33',NULL,NULL),(48645,'55901','S','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.051928,-92.495114,0,'2013-07-06 12:44:33',NULL,NULL),(36798,'41055','S','Helena','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(8333,'08037','S','Folsom','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(3241,'01430','S','South Ashburnham','N','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.653600,-71.924255,0,'2013-07-06 12:44:30',NULL,NULL),(25303,'28146','S','Salisbury','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.630497,-80.432818,0,'2013-07-06 12:44:31',NULL,NULL),(29043,'32234','S','Maxville','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.219367,-81.997401,0,'2013-07-06 12:44:32',NULL,NULL),(40218,'45409','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.724144,-84.183354,0,'2013-07-06 12:44:32',NULL,NULL),(46348,'53095','S','West Bend','D','Washington','55131','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.390226,-88.167388,0,'2013-07-06 12:44:32',NULL,NULL),(10644,'11101','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.748470,-73.939180,0,'2013-07-06 12:44:30',NULL,NULL),(79788,'99349','S','Desert Aire','A','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.736559,-119.899537,0,'2013-07-06 12:44:34',NULL,NULL),(76527,'95650','S','Loomis','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.808860,-121.167325,0,'2013-07-06 12:44:34',NULL,NULL),(62182,'73759','S','Jefferson','A','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.807871,-97.741275,0,'2013-07-06 12:44:33',NULL,NULL),(59370,'70586','S','Ville Platte','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.690732,-92.281579,0,'2013-07-06 12:44:33',NULL,NULL),(54737,'62969','S','Olive Branch','D','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.167231,-89.355121,0,'2013-07-06 12:44:33',NULL,NULL),(39040,'44147','S','Broadview Heights','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.320684,-81.676508,0,'2013-07-06 12:44:32',NULL,NULL),(19780,'20425','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897093,-77.024167,0,'2013-07-06 12:44:31',NULL,NULL),(12745,'13202','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.050827,-76.148300,0,'2013-07-06 12:44:30',NULL,NULL),(8113,'07821','S','Byram Twp','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.967267,-74.766575,0,'2013-07-06 12:44:30',NULL,NULL),(29298,'32512','U','Pensacola Naval Hospital','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.502687,-87.173684,0,'2013-07-06 12:44:32',NULL,NULL),(28136,'30818','S','Matthews','D','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.215285,-82.287101,0,'2013-07-06 12:44:31',NULL,NULL),(80172,'99830','P','Kake','D','Petersburg Census Area','02195','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.973379,-133.949115,0,'2013-07-06 12:44:34',NULL,NULL),(68309,'81101','S','Great Sand Dunes National Mo','A','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(67670,'80497','P','Silverthorne','D','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.640551,-106.062121,0,'2013-07-06 12:44:34',NULL,NULL),(60827,'72036','S','Cotton Plant','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.003283,-91.250233,0,'2013-07-06 12:44:33',NULL,NULL),(36948,'41168','S','Coalton','N','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.308320,-82.746300,0,'2013-07-06 12:44:32',NULL,NULL),(36663,'41010','S','Owen','A','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.539046,-84.590182,0,'2013-07-06 12:44:32',NULL,NULL),(11099,'11695','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.558349,-73.911454,0,'2013-07-06 12:44:30',NULL,NULL),(23074,'24887','P','Switchback','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.367110,-81.302224,0,'2013-07-06 12:44:31',NULL,NULL),(8917,'08742','S','Point Pleasant','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.079185,-74.065870,0,'2013-07-06 12:44:30',NULL,NULL),(19098,'19605','S','Muhlenberg Township','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(41810,'47331','S','Jennings','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(46772,'53949','S','Montello','D','Marquette','55077','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.793929,-89.327626,0,'2013-07-06 12:44:32',NULL,NULL),(51620,'59842','P','Haugan','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.387646,-115.396885,0,'2013-07-06 12:44:33',NULL,NULL),(76961,'96046','P','Hyampom','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.617830,-123.451210,0,'2013-07-06 12:44:34',NULL,NULL),(76894,'95980','P','Rogers Flat','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.918474,-121.328711,0,'2013-07-06 12:44:34',NULL,NULL),(35545,'39563','S','Moss Pt','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.407564,-88.530167,0,'2013-07-06 12:44:32',NULL,NULL),(3093,'01223','S','Becket Corners','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.381306,-73.143709,0,'2013-07-06 12:44:30',NULL,NULL),(40251,'45430','S','Beavercreek','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(7271,'06521','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309985,-72.926398,0,'2013-07-06 12:44:30',NULL,NULL),(48678,'55923','S','Cummingsville','N','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.842309,-92.183188,0,'2013-07-06 12:44:33',NULL,NULL),(50047,'57435','S','Cresbard','D','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.173980,-98.939794,0,'2013-07-06 12:44:33',NULL,NULL),(50862,'58502','P','Bismarck','D','Burleigh','38015','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.851023,-100.717405,0,'2013-07-06 12:44:33',NULL,NULL),(334,'00653','S','Bda Esperanza','N','Guanica','72055','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.974015,-66.908699,0,'2013-07-06 12:44:30',NULL,NULL),(61124,'72153','S','Lexington','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.579400,-92.291580,0,'2013-07-06 12:44:33',NULL,NULL),(57495,'66942','S','Formoso','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.775298,-97.994109,0,'2013-07-06 12:44:33',NULL,NULL),(52046,'60195','S','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.076320,-88.110120,0,'2013-07-06 12:44:33',NULL,NULL),(30325,'33308','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.189201,-80.109298,0,'2013-07-06 12:44:32',NULL,NULL),(3688,'02132','S','West Roxbury','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.275160,-71.147280,0,'2013-07-06 12:44:30',NULL,NULL),(3792,'02212','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.355722,-71.055772,0,'2013-07-06 12:44:30',NULL,NULL),(5849,'05101','S','Bellows Falls','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185420,-72.488580,0,'2013-07-06 12:44:30',NULL,NULL),(24087,'26502','P','Morgantown','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.634444,-79.970000,0,'2013-07-06 12:44:31',NULL,NULL),(22797,'24469','P','New Hope','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.197386,-78.908518,0,'2013-07-06 12:44:31',NULL,NULL),(22530,'24105','S','Indian Valley','D','Floyd','51063','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.903240,-80.578322,0,'2013-07-06 12:44:31',NULL,NULL),(5045,'04265','S','North Monmouth','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.270876,-70.052031,0,'2013-07-06 12:44:30',NULL,NULL),(39858,'45174','S','Terrace Park','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159318,-84.311489,0,'2013-07-06 12:44:32',NULL,NULL),(105,'00612','S','Urb Los Llanos','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(76707,'95836','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.704056,-121.535546,0,'2013-07-06 12:44:34',NULL,NULL),(70545,'85029','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.597410,-112.118455,0,'2013-07-06 12:44:34',NULL,NULL),(54736,'62967','S','New Burnside','D','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.580076,-88.762140,0,'2013-07-06 12:44:33',NULL,NULL),(47155,'54466','S','Veedum','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.448100,-90.177921,0,'2013-07-06 12:44:32',NULL,NULL),(34624,'38756','S','Bourbon','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(26458,'29142','S','Santee','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.488318,-80.456440,0,'2013-07-06 12:44:31',NULL,NULL),(23973,'26301','S','Laurel Park','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.275559,-80.338918,0,'2013-07-06 12:44:31',NULL,NULL),(51549,'59735','P','Harrison','D','Madison','30057','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.732860,-111.801147,0,'2013-07-06 12:44:33',NULL,NULL),(9044,'08882','S','South River','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.444355,-74.383419,0,'2013-07-06 12:44:30',NULL,NULL),(73107,'90248','S','Gardena','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.879226,-118.283613,0,'2013-07-06 12:44:34',NULL,NULL),(67648,'80469','P','Phippsburg','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.217516,-106.962100,0,'2013-07-06 12:44:34',NULL,NULL),(64014,'76118','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(57740,'67428','S','Canton','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.385452,-97.428295,0,'2013-07-06 12:44:33',NULL,NULL),(54386,'62817','S','Broughton','D','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.960013,-88.453753,0,'2013-07-06 12:44:33',NULL,NULL),(36454,'40701','S','Keavy','A','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.937489,-84.114901,0,'2013-07-06 12:44:32',NULL,NULL),(33581,'37544','U','Internal Revenue','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.070320,-89.956560,0,'2013-07-06 12:44:32',NULL,NULL),(5829,'05077','S','Tunbridge','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.915965,-72.473032,0,'2013-07-06 12:44:30',NULL,NULL),(25661,'28502','P','Kinston','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.261679,-77.577928,0,'2013-07-06 12:44:31',NULL,NULL),(24503,'27264','P','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.980506,-79.995827,0,'2013-07-06 12:44:31',NULL,NULL),(16600,'17325','S','Hunterstown','N','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.851653,-77.260693,0,'2013-07-06 12:44:31',NULL,NULL),(41594,'47106','S','Borden','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.454142,-85.870973,0,'2013-07-06 12:44:32',NULL,NULL),(44495,'49918','P','Copper Harbor','D','Keweenaw','26083','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.470095,-87.887734,0,'2013-07-06 12:44:32',NULL,NULL),(44677,'50120','S','Haverhill','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.930905,-92.979024,0,'2013-07-06 12:44:32',NULL,NULL),(67198,'79907','S','Ysleta Del Sur Pueblo','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.711168,-106.331389,0,'2013-07-06 12:44:34',NULL,NULL),(66600,'78756','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.320939,-97.743082,0,'2013-07-06 12:44:34',NULL,NULL),(61920,'73150','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.403293,-97.341978,0,'2013-07-06 12:44:33',NULL,NULL),(60495,'71662','S','Tyro','N','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.812280,-91.403100,0,'2013-07-06 12:44:33',NULL,NULL),(59295,'70504','U','Univ of LA at Lafayette','N','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.190224,-92.037106,0,'2013-07-06 12:44:33',NULL,NULL),(3504,'01862','S','North Billerica','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.567360,-71.291220,0,'2013-07-06 12:44:30',NULL,NULL),(32101,'35296','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.414914,-86.809475,0,'2013-07-06 12:44:32',NULL,NULL),(22772,'24445','S','Bacova Junction','N','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(55685,'64057','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.072219,-94.346464,0,'2013-07-06 12:44:33',NULL,NULL),(62893,'75062','S','Irving','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.846175,-96.963386,0,'2013-07-06 12:44:33',NULL,NULL),(64452,'76570','S','Rosebud','D','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(66061,'78380','S','Robstown','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(77320,'96704','S','Captain Cook','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.415684,-155.876176,0,'2013-07-06 12:44:34',NULL,NULL),(77398,'96777','P','Pahala','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.200662,-155.525898,0,'2013-07-06 12:44:34',NULL,NULL),(805,'00693','S','Sect Miraflores','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(72806,'89713','U','Nevada Employment Security','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.160959,-119.765544,0,'2013-07-06 12:44:34',NULL,NULL),(179,'00623','S','Mans De Cabo Rojo','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(72627,'89419','S','Oreana','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(61472,'72632','S','Eureka','N','Carroll','05015','Arkansas','AR','05','0000','479','Central',-6.0,'Y',36.444978,-93.740676,0,'2013-07-06 12:44:33',NULL,NULL),(60201,'71418','S','Riverton','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(27375,'30072','P','Pine Lake','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.792860,-84.207364,0,'2013-07-06 12:44:31',NULL,NULL),(24780,'27568','P','Pine Level','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.505870,-78.243484,0,'2013-07-06 12:44:31',NULL,NULL),(18102,'18762','U','Altria','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.237393,-75.897191,0,'2013-07-06 12:44:31',NULL,NULL),(19687,'20373','U','Jbab','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(42546,'47869','P','Prairie Creek','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.358399,-87.407090,0,'2013-07-06 12:44:32',NULL,NULL),(53512,'62021','S','Dorsey','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.981048,-89.972493,0,'2013-07-06 12:44:33',NULL,NULL),(60102,'71361','P','Pineville','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.356431,-92.406647,0,'2013-07-06 12:44:33',NULL,NULL),(73505,'91334','P','Arleta','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.244284,-118.426018,0,'2013-07-06 12:44:34',NULL,NULL),(70826,'85388','S','Surprise','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.613400,-112.451200,0,'2013-07-06 12:44:34',NULL,NULL),(67004,'79511','S','Coahoma','D','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.296057,-101.313531,0,'2013-07-06 12:44:34',NULL,NULL),(63704,'75886','U','Tenn Colony','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.836617,-95.838882,0,'2013-07-06 12:44:34',NULL,NULL),(36808,'41056','S','Murphysville','N','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.596020,-83.781120,0,'2013-07-06 12:44:32',NULL,NULL),(27162,'29835','S','Britts','N','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.911159,-82.290467,0,'2013-07-06 12:44:31',NULL,NULL),(23534,'25601','S','Rossmore','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.868777,-81.988500,0,'2013-07-06 12:44:31',NULL,NULL),(12844,'13316','S','Florence','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.354631,-75.746699,0,'2013-07-06 12:44:30',NULL,NULL),(18075,'18705','S','Miners Mill','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.272156,-75.844934,0,'2013-07-06 12:44:31',NULL,NULL),(3778,'02199','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.345258,-71.078871,0,'2013-07-06 12:44:30',NULL,NULL),(42126,'47501','S','Maysville','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(44158,'49530','U','Zondervan Corp','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866782,-85.544254,0,'2013-07-06 12:44:32',NULL,NULL),(56323,'65105','U','Jefferson Cty','A','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.577411,-92.174184,0,'2013-07-06 12:44:33',NULL,NULL),(10487,'10956','S','New City','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.144539,-73.996493,0,'2013-07-06 12:44:30',NULL,NULL),(77111,'96145','P','Tahoe City','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.174073,-120.155846,0,'2013-07-06 12:44:34',NULL,NULL),(65605,'77902','P','Victoria','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.783592,-96.996184,0,'2013-07-06 12:44:34',NULL,NULL),(63639,'75844','S','Augusta','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(3790,'02211','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358069,-71.056709,0,'2013-07-06 12:44:30',NULL,NULL),(30588,'33418','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855526,-80.144330,0,'2013-07-06 12:44:32',NULL,NULL),(29335,'32548','S','Ft Walton Beach','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(27635,'30315','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.708343,-84.384090,0,'2013-07-06 12:44:31',NULL,NULL),(41711,'47236','S','Elizabethtown','A','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.135000,-85.813333,0,'2013-07-06 12:44:32',NULL,NULL),(47235,'54501','S','Stella','N','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691320,-89.349600,0,'2013-07-06 12:44:32',NULL,NULL),(76703,'95832','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.472573,-121.484924,0,'2013-07-06 12:44:34',NULL,NULL),(74665,'92857','P','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.831695,-117.849144,0,'2013-07-06 12:44:34',NULL,NULL),(68945,'82937','S','Lyman','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.317669,-110.299141,0,'2013-07-06 12:44:34',NULL,NULL),(66277,'78580','S','Willamar','N','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.481214,-97.783570,0,'2013-07-06 12:44:34',NULL,NULL),(64149,'76199','U','Jp Morgan Chase','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.752429,-97.334282,0,'2013-07-06 12:44:34',NULL,NULL),(49734,'57049','S','N Sioux City','A','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.528060,-96.503280,0,'2013-07-06 12:44:33',NULL,NULL),(4108,'02713','P','Cuttyhunk','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.421378,-70.933460,0,'2013-07-06 12:44:30',NULL,NULL),(35624,'39629','S','Norfield','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.485120,-90.452940,0,'2013-07-06 12:44:32',NULL,NULL),(16775,'17522','S','Voganville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.170960,-76.167300,0,'2013-07-06 12:44:31',NULL,NULL),(29351,'32562','P','Gulf Breeze','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.371535,-87.173931,0,'2013-07-06 12:44:32',NULL,NULL),(28736,'31909','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.534042,-84.924710,0,'2013-07-06 12:44:32',NULL,NULL),(27998,'30601','S','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.974834,-83.363891,0,'2013-07-06 12:44:31',NULL,NULL),(18586,'19133','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.992137,-75.143289,0,'2013-07-06 12:44:31',NULL,NULL),(21376,'22472','P','Haynesville','D','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.951692,-76.663853,0,'2013-07-06 12:44:31',NULL,NULL),(46492,'53226','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.047262,-88.044347,0,'2013-07-06 12:44:32',NULL,NULL),(12735,'13163','P','Wampsville','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.083090,-75.705865,0,'2013-07-06 12:44:30',NULL,NULL),(79834,'99520','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.216414,-149.867078,0,'2013-07-06 12:44:34',NULL,NULL),(65831,'78150','S','Universal Cty','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.527918,-98.274563,0,'2013-07-06 12:44:34',NULL,NULL),(56114,'64801','S','Prosperity','N','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.108500,-94.515060,0,'2013-07-06 12:44:33',NULL,NULL),(55871,'64191','P','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.087629,-94.584711,0,'2013-07-06 12:44:33',NULL,NULL),(54717,'62959','S','Spillertown','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.722939,-88.873368,0,'2013-07-06 12:44:33',NULL,NULL),(68463,'81235','S','Lake City','D','Hinsdale','08053','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.023092,-107.316944,0,'2013-07-06 12:44:34',NULL,NULL),(14100,'14623','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.081673,-77.633588,0,'2013-07-06 12:44:31',NULL,NULL),(32974,'36610','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.739731,-88.080296,0,'2013-07-06 12:44:32',NULL,NULL),(28084,'30733','S','Plainville','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.412119,-85.039417,0,'2013-07-06 12:44:31',NULL,NULL),(10801,'11372','S','Jackson Heights','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.749542,-73.883319,0,'2013-07-06 12:44:30',NULL,NULL),(18673,'19182','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951857,-75.150106,0,'2013-07-06 12:44:31',NULL,NULL),(19998,'20604','P','Waldorf','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.617973,-76.892084,0,'2013-07-06 12:44:31',NULL,NULL),(49027,'56273','S','New London','D','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.310623,-94.991718,0,'2013-07-06 12:44:33',NULL,NULL),(56945,'66090','S','Wathena','D','Doniphan','20043','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.762419,-94.948109,0,'2013-07-06 12:44:33',NULL,NULL),(59450,'70726','S','Dennis Mills','A','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.495187,-90.921746,0,'2013-07-06 12:44:33',NULL,NULL),(60956,'72102','S','Mc Rae','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.114602,-91.823524,0,'2013-07-06 12:44:33',NULL,NULL),(13988,'14507','S','Middlesex','D','Yates','36123','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.704465,-77.268077,0,'2013-07-06 12:44:31',NULL,NULL),(14132,'14653','U','Kodak Apparatus Division','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.152130,-77.623329,0,'2013-07-06 12:44:31',NULL,NULL),(39148,'44286','S','Richfield Heights','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.231451,-81.641199,0,'2013-07-06 12:44:32',NULL,NULL),(79831,'99517','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.190021,-149.935563,0,'2013-07-06 12:44:34',NULL,NULL),(68732,'82190','S','Yelwstn Nl Pk','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.975150,-110.694710,0,'2013-07-06 12:44:34',NULL,NULL),(7359,'06752','S','Bridgewater','D','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.528811,-73.361384,0,'2013-07-06 12:44:30',NULL,NULL),(9108,'09099','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30850,'33646','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.947016,-82.459229,0,'2013-07-06 12:44:32',NULL,NULL),(36092,'40219','S','Heritage Crk','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(78569,'98161','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.609554,-122.337614,0,'2013-07-06 12:44:34',NULL,NULL),(7015,'06260','S','Laurel Hill','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(26560,'29209','S','Galaxy','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(60478,'71655','S','UA Monticello','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(3062,'01116','P','East Longmeadow','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.064444,-72.513056,0,'2013-07-06 12:44:30',NULL,NULL),(27520,'30212','P','Experiment','D','Spalding','13255','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.267698,-84.282751,0,'2013-07-06 12:44:31',NULL,NULL),(18337,'19029','S','Lester','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.868240,-75.294939,0,'2013-07-06 12:44:31',NULL,NULL),(61344,'72467','P','State University','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.849336,-90.679349,0,'2013-07-06 12:44:33',NULL,NULL),(23166,'25019','S','Fola','A','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.357500,-81.103889,0,'2013-07-06 12:44:31',NULL,NULL),(57484,'66901','S','Rice','A','Cloud','20029','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.567727,-97.660244,0,'2013-07-06 12:44:33',NULL,NULL),(26421,'29125','S','Millford','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.742260,-80.481720,0,'2013-07-06 12:44:31',NULL,NULL),(19733,'20402','U','GPO Supt of Documents','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898247,-77.010957,0,'2013-07-06 12:44:31',NULL,NULL),(53230,'61638','U','Replacement Lens Inc','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.804240,-89.629708,0,'2013-07-06 12:44:33',NULL,NULL),(75815,'94807','P','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.927153,-122.353849,0,'2013-07-06 12:44:34',NULL,NULL),(68541,'81419','S','Hotchkiss','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.817069,-107.748719,0,'2013-07-06 12:44:34',NULL,NULL),(62033,'73502','P','Lawton','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.600793,-98.393741,0,'2013-07-06 12:44:33',NULL,NULL),(68790,'82336','P','Wamsutter','D','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.629570,-108.264820,0,'2013-07-06 12:44:34',NULL,NULL),(31446,'34280','P','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.498840,-82.636138,0,'2013-07-06 12:44:32',NULL,NULL),(49572,'56725','S','Goodridge','D','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.061717,-95.716096,0,'2013-07-06 12:44:33',NULL,NULL),(74109,'92225','S','Mesa Verde','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609354,-114.615439,0,'2013-07-06 12:44:34',NULL,NULL),(75473,'94108','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.789438,-122.406217,0,'2013-07-06 12:44:34',NULL,NULL),(78892,'98358','S','Nordland','D','Jefferson','53031','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.067708,-122.694175,0,'2013-07-06 12:44:34',NULL,NULL),(37205,'41522','S','Elkhorn City','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(29673,'32919','U','Harris Corporation','N','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.077407,-80.631614,0,'2013-07-06 12:44:32',NULL,NULL),(79481,'98901','S','East Selah','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606829,-120.465379,0,'2013-07-06 12:44:34',NULL,NULL),(73961,'92067','P','Rancho Santa Fe','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.011798,-117.201867,0,'2013-07-06 12:44:34',NULL,NULL),(5827,'05076','S','Topsham Four Corners','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.061849,-72.220363,0,'2013-07-06 12:44:30',NULL,NULL),(7121,'06380','S','Taftville','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.564008,-72.054926,0,'2013-07-06 12:44:30',NULL,NULL),(44289,'49723','P','Cross Village','D','Emmet','26047','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',45.629984,-85.023411,0,'2013-07-06 12:44:32',NULL,NULL),(20852,'21656','P','Price','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.097500,-75.959167,0,'2013-07-06 12:44:31',NULL,NULL),(43411,'48458','S','Mount Morris','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.113921,-83.689128,0,'2013-07-06 12:44:32',NULL,NULL),(32431,'35986','S','Rainsville','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.497002,-85.843760,0,'2013-07-06 12:44:32',NULL,NULL),(79399,'98802','S','E Wenatchee','A','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.438520,-120.234960,0,'2013-07-06 12:44:34',NULL,NULL),(11589,'12078','S','Bleecker','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.054502,-74.338330,0,'2013-07-06 12:44:30',NULL,NULL),(25693,'28528','S','Gloucester','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.684622,-76.526421,0,'2013-07-06 12:44:31',NULL,NULL),(67030,'79538','S','Novice','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',32.006901,-99.564507,0,'2013-07-06 12:44:34',NULL,NULL),(66289,'78582','S','Villareales','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(59403,'70637','S','Dry Creek','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.780646,-92.955128,0,'2013-07-06 12:44:33',NULL,NULL),(3450,'01772','S','Southboro','N','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.295044,-71.532273,0,'2013-07-06 12:44:30',NULL,NULL),(24858,'27635','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.817935,-78.572329,0,'2013-07-06 12:44:31',NULL,NULL),(11014,'11558','S','Harbor Island','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.600901,-73.654227,0,'2013-07-06 12:44:30',NULL,NULL),(29226,'32425','S','Caryville','A','Holmes','12059','Florida','FL','12','0000','850','Central',-6.0,'Y',30.795111,-85.677801,0,'2013-07-06 12:44:32',NULL,NULL),(67180,'79847','S','Salt Flat','D','Hudspeth','48229','Texas','TX','48','0000','915','Mountain',-7.0,'Y',31.808783,-105.277133,0,'2013-07-06 12:44:34',NULL,NULL),(45623,'51593','P','Harlan','D','Shelby','19165','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.658090,-95.318610,0,'2013-07-06 12:44:32',NULL,NULL),(54640,'62922','S','Lake Crest','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.618809,-88.837781,0,'2013-07-06 12:44:33',NULL,NULL),(24200,'26678','S','Mount Lookout','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.179342,-80.906842,0,'2013-07-06 12:44:31',NULL,NULL),(70935,'85638','S','Tombstone','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.709811,-110.063648,0,'2013-07-06 12:44:34',NULL,NULL),(65864,'78212','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.478611,-98.487222,0,'2013-07-06 12:44:34',NULL,NULL),(52172,'60458','S','Justice','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745877,-87.836217,0,'2013-07-06 12:44:33',NULL,NULL),(19749,'20410','U','Housing and Urban Dev','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885547,-77.021382,0,'2013-07-06 12:44:31',NULL,NULL),(29912,'33055','S','Carol City','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.943016,-80.276516,0,'2013-07-06 12:44:32',NULL,NULL),(7638,'07068','S','Roseland','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.819209,-74.298691,0,'2013-07-06 12:44:30',NULL,NULL),(1260,'00729','S','Urb Usubal','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(15824,'16933','S','E Charleston','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(55920,'64457','S','Guilford','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.172689,-94.676814,0,'2013-07-06 12:44:33',NULL,NULL),(19759,'20415','U','Office Personnel Mgmt','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896458,-77.040977,0,'2013-07-06 12:44:31',NULL,NULL),(49420,'56630','S','Funkley','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(36968,'41179','S','Charters','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(15696,'16847','P','Kylertown','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.993392,-78.168491,0,'2013-07-06 12:44:31',NULL,NULL),(30071,'33154','S','Bay Harbor Islands','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(58577,'68832','S','Doniphan','D','Hall','31079','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.772243,-98.370227,0,'2013-07-06 12:44:33',NULL,NULL),(55650,'64024','S','Ex Spgs','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(53891,'62356','S','New Canton','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.625007,-91.086931,0,'2013-07-06 12:44:33',NULL,NULL),(41397,'46806','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.046401,-85.105518,0,'2013-07-06 12:44:32',NULL,NULL),(33156,'37013','S','Cane Ridge','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.037491,-86.638596,0,'2013-07-06 12:44:32',NULL,NULL),(63443,'75670','S','Grange Hall','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(36469,'40741','S','Tuttle','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.110220,-84.078189,0,'2013-07-06 12:44:32',NULL,NULL),(33531,'37381','S','Watts Bar Dam','A','Rhea','47143','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.669020,-84.851318,0,'2013-07-06 12:44:32',NULL,NULL),(34211,'38351','S','Lexington','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.658539,-88.400806,0,'2013-07-06 12:44:32',NULL,NULL),(22531,'24111','P','Mc Coy','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.258890,-80.429778,0,'2013-07-06 12:44:31',NULL,NULL),(16312,'17113','S','Oberlin','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.247280,-76.842480,0,'2013-07-06 12:44:31',NULL,NULL),(50702,'58363','S','Perth','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.682409,-99.396186,0,'2013-07-06 12:44:33',NULL,NULL),(30008,'33126','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.774119,-80.290919,0,'2013-07-06 12:44:32',NULL,NULL),(34341,'38574','S','Monterey','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.138530,-85.265960,0,'2013-07-06 12:44:32',NULL,NULL),(21090,'22037','U','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853441,-77.300385,0,'2013-07-06 12:44:31',NULL,NULL),(69971,'84119','S','West Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(33369,'37204','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108754,-86.780579,0,'2013-07-06 12:44:32',NULL,NULL),(1690,'00777','S','Portales de Juncos','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(76039,'95156','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.359971,-121.840023,0,'2013-07-06 12:44:34',NULL,NULL),(42938,'48118','S','Chelsea','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(42866,'48081','S','St Clr Shores','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.498015,-82.899035,0,'2013-07-06 12:44:32',NULL,NULL),(69170,'83324','S','Dietrich','D','Lincoln','16063','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.921960,-114.273840,0,'2013-07-06 12:44:34',NULL,NULL),(30740,'33543','S','Zephyrhills','A','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.205100,-82.300020,0,'2013-07-06 12:44:32',NULL,NULL),(40056,'45267','U','University Hospital','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.127931,-84.514462,0,'2013-07-06 12:44:32',NULL,NULL),(52947,'61412','S','Shanghai City','N','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.064856,-90.557525,0,'2013-07-06 12:44:33',NULL,NULL),(32701,'36278','S','Corinth','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.325381,-85.506798,0,'2013-07-06 12:44:32',NULL,NULL),(6073,'05446','S','St Michaels College','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.548500,-73.215480,0,'2013-07-06 12:44:30',NULL,NULL),(10017,'10170','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(26664,'29378','P','Una','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.984132,-81.987347,0,'2013-07-06 12:44:31',NULL,NULL),(69930,'84113','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775548,-111.831028,0,'2013-07-06 12:44:34',NULL,NULL),(61931,'73155','P','Del City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.418558,-97.435219,0,'2013-07-06 12:44:33',NULL,NULL),(45830,'52212','S','Center Jct','A','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.078396,-91.073294,0,'2013-07-06 12:44:32',NULL,NULL),(43994,'49340','S','Remus','D','Mecosta','26107','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.617953,-85.138870,0,'2013-07-06 12:44:32',NULL,NULL),(21842,'23128','S','North','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.468590,-76.377198,0,'2013-07-06 12:44:31',NULL,NULL),(9173,'09356','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4207,'02832','S','Hope Valley','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.502720,-71.731380,0,'2013-07-06 12:44:30',NULL,NULL),(78451,'98063','P','Federal Way','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.305546,-122.320901,0,'2013-07-06 12:44:34',NULL,NULL),(26567,'29211','P','Capitol','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.024196,-81.293589,0,'2013-07-06 12:44:31',NULL,NULL),(29441,'32694','S','Waldo','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.782650,-82.173373,0,'2013-07-06 12:44:32',NULL,NULL),(28884,'32123','P','Pt Orange','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.149529,-81.031180,0,'2013-07-06 12:44:32',NULL,NULL),(59808,'71226','S','Chatham','D','Jackson','22049','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.249460,-92.416800,0,'2013-07-06 12:44:33',NULL,NULL),(7529,'07005','S','Rockaway Valley','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(51777,'60041','S','Ingleside','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.357735,-88.163789,0,'2013-07-06 12:44:33',NULL,NULL),(49245,'56474','S','Barclay','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.745939,-94.372764,0,'2013-07-06 12:44:33',NULL,NULL),(46383,'53142','S','Kenosha','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.573269,-87.880354,0,'2013-07-06 12:44:32',NULL,NULL),(44321,'49746','S','Hillman','D','Montmorency','26119','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.066069,-83.843782,0,'2013-07-06 12:44:32',NULL,NULL),(73677,'91601','S','Valley Vlg','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(62411,'74128','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.144415,-95.853927,0,'2013-07-06 12:44:33',NULL,NULL),(52195,'60474','P','S Wilmington','A','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.173333,-88.263889,0,'2013-07-06 12:44:33',NULL,NULL),(51460,'59521','S','Box Elder','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.320436,-109.832831,0,'2013-07-06 12:44:33',NULL,NULL),(24314,'27018','S','East Bend','D','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.201254,-80.530156,0,'2013-07-06 12:44:31',NULL,NULL),(45076,'50525','S','Cornelia','N','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.729586,-93.733773,0,'2013-07-06 12:44:32',NULL,NULL),(10003,'10167','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(71344,'86512','P','Sanders','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.206267,-109.332901,0,'2013-07-06 12:44:34',NULL,NULL),(58665,'68882','S','Brayton','N','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.468087,-98.385202,0,'2013-07-06 12:44:33',NULL,NULL),(6988,'06248','S','Hebron','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.685074,-72.406095,0,'2013-07-06 12:44:30',NULL,NULL),(19591,'20222','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898336,-77.032305,0,'2013-07-06 12:44:31',NULL,NULL),(12961,'13363','S','Lee Center','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.314420,-75.512100,0,'2013-07-06 12:44:30',NULL,NULL),(32526,'36092','S','Wetumpka','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.532040,-86.193776,0,'2013-07-06 12:44:32',NULL,NULL),(15306,'16148','S','Sharon','A','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.229960,-80.440500,0,'2013-07-06 12:44:31',NULL,NULL),(48115,'55354','S','Lester Pr','A','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.883546,-94.040436,0,'2013-07-06 12:44:33',NULL,NULL),(22467,'24042','U','Norfolk Southern','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.275867,-79.941592,0,'2013-07-06 12:44:31',NULL,NULL),(7730,'07202','S','Parkandbush','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.656153,-74.218524,0,'2013-07-06 12:44:30',NULL,NULL),(37320,'41651','S','Minnie','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.479601,-82.755894,0,'2013-07-06 12:44:32',NULL,NULL),(56900,'66045','U','Lawrence','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.959171,-95.264228,0,'2013-07-06 12:44:33',NULL,NULL),(56071,'64752','S','Hume','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.090159,-94.586446,0,'2013-07-06 12:44:33',NULL,NULL),(52337,'60572','U','AT & T','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.766060,-88.320017,0,'2013-07-06 12:44:33',NULL,NULL),(48886,'56101','S','Delft','N','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.873800,-95.153160,0,'2013-07-06 12:44:33',NULL,NULL),(32605,'36133','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.374861,-86.309891,0,'2013-07-06 12:44:32',NULL,NULL),(76539,'95659','S','Trowbridge','A','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.870336,-121.567175,0,'2013-07-06 12:44:34',NULL,NULL),(77677,'97033','P','Kent','D','Sherman','41055','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.081959,-120.664996,0,'2013-07-06 12:44:34',NULL,NULL),(16075,'17050','S','Hampden Station','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.216649,-77.008727,0,'2013-07-06 12:44:31',NULL,NULL),(26630,'29324','P','Clifton','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.983913,-81.824034,0,'2013-07-06 12:44:31',NULL,NULL),(70362,'84649','P','Oak City','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.376918,-112.335547,0,'2013-07-06 12:44:34',NULL,NULL),(65728,'78041','S','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.549459,-99.488974,0,'2013-07-06 12:44:34',NULL,NULL),(50670,'58341','S','Harvey','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.775600,-99.906420,0,'2013-07-06 12:44:33',NULL,NULL),(48201,'55399','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.815292,-93.920113,0,'2013-07-06 12:44:33',NULL,NULL),(66505,'78691','P','Pflugerville','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.440689,-97.621429,0,'2013-07-06 12:44:34',NULL,NULL),(24276,'26852','S','Junction','A','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.264244,-78.898607,0,'2013-07-06 12:44:31',NULL,NULL),(66366,'78617','S','Elroy','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.151020,-97.594440,0,'2013-07-06 12:44:34',NULL,NULL),(48492,'55734','S','Fayal','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.431510,-92.516556,0,'2013-07-06 12:44:33',NULL,NULL),(54599,'62906','S','Saratoga','N','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.463400,-89.229960,0,'2013-07-06 12:44:33',NULL,NULL),(289,'00646','S','Paseo Los Corales II','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(11248,'11760','P','Islandia','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.816034,-73.212013,0,'2013-07-06 12:44:30',NULL,NULL),(42185,'47542','S','Duff','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.297169,-86.956690,0,'2013-07-06 12:44:32',NULL,NULL),(56278,'65069','S','Americus','N','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757968,-91.534285,0,'2013-07-06 12:44:33',NULL,NULL),(65962,'78283','P','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.411113,-98.503666,0,'2013-07-06 12:44:34',NULL,NULL),(74991,'93448','P','Shell Beach','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.155278,-120.671389,0,'2013-07-06 12:44:34',NULL,NULL),(79444,'98841','S','Omak','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.360556,-119.236111,0,'2013-07-06 12:44:34',NULL,NULL),(79615,'99115','S','Coulee City','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.634433,-119.252549,0,'2013-07-06 12:44:34',NULL,NULL),(54254,'62674','S','Barr','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.439755,-89.925200,0,'2013-07-06 12:44:33',NULL,NULL),(22994,'24801','S','Havaco','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(44393,'49807','S','Schaffer','A','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.698400,-87.235980,0,'2013-07-06 12:44:32',NULL,NULL),(64705,'76856','S','Streeter','N','Mason','48319','Texas','TX','48','0000','325','Central',-6.0,'Y',30.737100,-99.227400,0,'2013-07-06 12:44:34',NULL,NULL),(42756,'48028','S','Harsens Island','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.577729,-82.602065,0,'2013-07-06 12:44:32',NULL,NULL),(77742,'97080','S','Gresham','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.483779,-122.416754,0,'2013-07-06 12:44:34',NULL,NULL),(1008,'00717','S','Urb San Jorge','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(6365,'05676','S','North Duxbury','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.345220,-72.785100,0,'2013-07-06 12:44:30',NULL,NULL),(68794,'82412','P','Byron','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.795553,-108.507741,0,'2013-07-06 12:44:34',NULL,NULL),(57029,'66207','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.956388,-94.640303,0,'2013-07-06 12:44:33',NULL,NULL),(55988,'64632','S','Cainsville','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.481913,-93.743319,0,'2013-07-06 12:44:33',NULL,NULL),(66480,'78664','S','Old Round Rock','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.512352,-97.670283,0,'2013-07-06 12:44:34',NULL,NULL),(61610,'72802','S','Russellville','D','Pope','05115','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.317580,-93.091084,0,'2013-07-06 12:44:33',NULL,NULL),(55013,'63133','S','Pagedale','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.678252,-90.305602,0,'2013-07-06 12:44:33',NULL,NULL),(46995,'54235','S','Sturgeon Bay','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.843160,-87.397260,0,'2013-07-06 12:44:32',NULL,NULL),(1684,'00777','S','Jard de Ceiba Norte','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(73803,'91754','S','Monterey Park','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.048466,-118.149740,0,'2013-07-06 12:44:34',NULL,NULL),(28179,'31006','S','Butler','D','Taylor','13269','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.556390,-84.242868,0,'2013-07-06 12:44:31',NULL,NULL),(1175,'00727','S','Urb Palmas del Turabo','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(61943,'73162','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.579721,-97.641491,0,'2013-07-06 12:44:33',NULL,NULL),(9243,'09574','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(14094,'14620','S','Brighton','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.132792,-77.600284,0,'2013-07-06 12:44:31',NULL,NULL),(48331,'55455','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.972981,-93.237826,0,'2013-07-06 12:44:33',NULL,NULL),(31460,'34287','S','Venice','A','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.078300,-82.181160,0,'2013-07-06 12:44:32',NULL,NULL),(27691,'30338','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.938634,-84.316813,0,'2013-07-06 12:44:31',NULL,NULL),(39967,'45237','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(4122,'02739','S','Mattapoisett','D','Plymouth','25023','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.662281,-70.805945,0,'2013-07-06 12:44:30',NULL,NULL),(15004,'15664','P','Mammoth','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.323784,-79.671735,0,'2013-07-06 12:44:31',NULL,NULL),(77581,'96915','S','Piti','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.388165,144.666553,0,'2013-07-06 12:44:34',NULL,NULL),(16439,'17236','S','Africa','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(55310,'63535','S','Coatsville','D','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.570519,-92.620601,0,'2013-07-06 12:44:33',NULL,NULL),(53698,'62231','S','Shattuc','A','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.609310,-89.376252,0,'2013-07-06 12:44:33',NULL,NULL),(10957,'11507','S','Albertson','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.772577,-73.652127,0,'2013-07-06 12:44:30',NULL,NULL),(4563,'03466','S','W Chesterfield','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871118,-72.516627,0,'2013-07-06 12:44:30',NULL,NULL),(63955,'76092','S','Grapevine','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.953968,-97.150453,0,'2013-07-06 12:44:34',NULL,NULL),(13978,'14485','S','Lima','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.891560,-77.614458,0,'2013-07-06 12:44:31',NULL,NULL),(51287,'59117','U','Wells Fargo Bank','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.783606,-108.505138,0,'2013-07-06 12:44:33',NULL,NULL),(3862,'02356','S','N Easton','N','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.057491,-71.115498,0,'2013-07-06 12:44:30',NULL,NULL),(6206,'05486','S','Keelers Bay','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.866206,-73.251370,0,'2013-07-06 12:44:30',NULL,NULL),(23826,'26103','P','Fort Neal','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.248270,-81.557201,0,'2013-07-06 12:44:31',NULL,NULL),(54823,'63025','S','Eureka','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(33115,'36863','S','La Nett','N','Chambers','01017','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.868458,-85.239722,0,'2013-07-06 12:44:32',NULL,NULL),(12676,'13126','S','Oswego','D','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(12534,'13037','S','Chitt','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.057290,-75.872483,0,'2013-07-06 12:44:30',NULL,NULL),(75834,'94915','P','San Rafael','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.959899,-122.504023,0,'2013-07-06 12:44:34',NULL,NULL),(18086,'18706','S','Warrior Run','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(67572,'80303','S','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.991717,-105.227400,0,'2013-07-06 12:44:34',NULL,NULL),(58243,'68355','S','Preston','N','Richardson','31147','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.063372,-95.601580,0,'2013-07-06 12:44:33',NULL,NULL),(53669,'62214','S','Venedy','A','Washington','17189','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.381708,-89.611975,0,'2013-07-06 12:44:33',NULL,NULL),(78735,'98283','S','Rockport','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.482400,-121.527120,0,'2013-07-06 12:44:34',NULL,NULL),(11371,'11930','P','Promised Land','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.976299,-72.133670,0,'2013-07-06 12:44:30',NULL,NULL),(29784,'33016','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890138,-80.341466,0,'2013-07-06 12:44:32',NULL,NULL),(40856,'46227','S','Southport','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.674837,-86.127705,0,'2013-07-06 12:44:32',NULL,NULL),(49399,'56623','S','Baudette','D','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(74499,'92626','S','Costa Mesa','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.680139,-117.908452,0,'2013-07-06 12:44:34',NULL,NULL),(23114,'24946','S','Mill Point','A','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.132820,-80.243820,0,'2013-07-06 12:44:31',NULL,NULL),(21902,'23187','P','Williamsburg','D','Williamsburg City','51830','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.268238,-76.710083,0,'2013-07-06 12:44:31',NULL,NULL),(18133,'18827','P','Lanesboro','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.956416,-75.587030,0,'2013-07-06 12:44:31',NULL,NULL),(17837,'18421','S','Forest City','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.651632,-75.469425,0,'2013-07-06 12:44:31',NULL,NULL),(7395,'06790','S','Torrington','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.812769,-73.120734,0,'2013-07-06 12:44:30',NULL,NULL),(71116,'86016','P','Cameron','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',35.746955,-111.474916,0,'2013-07-06 12:44:34',NULL,NULL),(7166,'06441','S','Higganum','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.462791,-72.574330,0,'2013-07-06 12:44:30',NULL,NULL),(15706,'16855','P','Mineral Springs','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.001571,-78.363433,0,'2013-07-06 12:44:31',NULL,NULL),(58440,'68710','S','Martinsburg','N','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.414736,-96.840752,0,'2013-07-06 12:44:33',NULL,NULL),(58365,'68523','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.735318,-96.757947,0,'2013-07-06 12:44:33',NULL,NULL),(65433,'77584','S','Pearland','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.544998,-95.329534,0,'2013-07-06 12:44:34',NULL,NULL),(74298,'92373','S','Redlands','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.050061,-117.169355,0,'2013-07-06 12:44:34',NULL,NULL),(56463,'65299','S','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.023561,-92.248218,0,'2013-07-06 12:44:33',NULL,NULL),(66152,'78503','S','Mc Allen','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.177511,-98.241408,0,'2013-07-06 12:44:34',NULL,NULL),(33902,'38045','P','Laconia','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.292164,-89.368803,0,'2013-07-06 12:44:32',NULL,NULL),(76257,'95409','S','Kenwood','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.462708,-122.638647,0,'2013-07-06 12:44:34',NULL,NULL),(63737,'75935','S','East Liberty','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(22322,'23846','S','Elberon','D','Surry','51181','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.059423,-76.822191,0,'2013-07-06 12:44:31',NULL,NULL),(11465,'12010','S','West Charlton','A','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923640,-74.170860,0,'2013-07-06 12:44:30',NULL,NULL),(49396,'56621','S','Nora','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.522156,-95.397890,0,'2013-07-06 12:44:33',NULL,NULL),(35378,'39452','S','Shipman','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(44987,'50432','P','Crystal Lake','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.225498,-93.791023,0,'2013-07-06 12:44:32',NULL,NULL),(43183,'48301','S','Bloomfield Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(79737,'99219','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.629754,-117.542356,0,'2013-07-06 12:44:34',NULL,NULL),(23221,'25082','S','Pliny','A','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.568197,-82.025774,0,'2013-07-06 12:44:31',NULL,NULL),(25671,'28512','S','Atlantic Beach','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.699394,-76.781687,0,'2013-07-06 12:44:31',NULL,NULL),(66648,'78841','P','Del Rio','D','Val Verde','48465','Texas','TX','48','0000','830','Central',-6.0,'Y',29.346565,-100.913120,0,'2013-07-06 12:44:34',NULL,NULL),(68813,'82435','S','Willwood','A','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.755778,-108.760087,0,'2013-07-06 12:44:34',NULL,NULL),(45538,'51450','S','Lake View','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.304670,-95.045383,0,'2013-07-06 12:44:32',NULL,NULL),(58619,'68859','S','Independent','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.466866,-98.705890,0,'2013-07-06 12:44:33',NULL,NULL),(6046,'05439','U','Colchester','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.551291,-73.179908,0,'2013-07-06 12:44:30',NULL,NULL),(49587,'56738','S','Newfolden','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.284400,-96.227280,0,'2013-07-06 12:44:33',NULL,NULL),(32,'00603','S','Urb Las Americas','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(16000,'17038','S','Green Point','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.410665,-76.486339,0,'2013-07-06 12:44:31',NULL,NULL),(32003,'35226','S','Vestavia Hls','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(41261,'46747','S','Salem Center','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.531111,-85.170278,0,'2013-07-06 12:44:32',NULL,NULL),(77632,'97006','S','Beaverton','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.516558,-122.858874,0,'2013-07-06 12:44:34',NULL,NULL),(70898,'85619','P','Mount Lemmon','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.427139,-110.799542,0,'2013-07-06 12:44:34',NULL,NULL),(18352,'19036','S','Darby Township','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.906381,-75.293696,0,'2013-07-06 12:44:31',NULL,NULL),(21593,'22845','S','Orkney Springs','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.788542,-78.822829,0,'2013-07-06 12:44:31',NULL,NULL),(61369,'72519','S','Jordan','A','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.152503,-92.016533,0,'2013-07-06 12:44:33',NULL,NULL),(72556,'89301','S','Ely','D','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(72158,'88336','S','Hondo','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.445569,-105.368703,0,'2013-07-06 12:44:34',NULL,NULL),(25981,'28662','P','Pineola','D','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.030658,-81.891045,0,'2013-07-06 12:44:31',NULL,NULL),(38205,'43212','S','Marble Cliff','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.987260,-83.043294,0,'2013-07-06 12:44:32',NULL,NULL),(57965,'67764','S','Russell Spg','A','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046384,-101.228293,0,'2013-07-06 12:44:33',NULL,NULL),(4264,'02882','S','Galilee','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.432140,-71.468662,0,'2013-07-06 12:44:30',NULL,NULL),(7296,'06538','U','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.432208,-72.909280,0,'2013-07-06 12:44:30',NULL,NULL),(12424,'12945','S','Upper St Reg','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.366560,-74.247330,0,'2013-07-06 12:44:30',NULL,NULL),(7005,'06255','S','North Grosvenordale','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.986809,-71.902586,0,'2013-07-06 12:44:30',NULL,NULL),(30481,'33351','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.177671,-80.275118,0,'2013-07-06 12:44:32',NULL,NULL),(76217,'95369','S','Snelling','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.513396,-120.469416,0,'2013-07-06 12:44:34',NULL,NULL),(76710,'95840','U','Franchise Tax Board','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583712,-121.490234,0,'2013-07-06 12:44:34',NULL,NULL),(70928,'85634','S','Sil Nakaya','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.910000,-111.880000,0,'2013-07-06 12:44:34',NULL,NULL),(67889,'80863','S','Westwood Lake','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.992976,-105.071027,0,'2013-07-06 12:44:34',NULL,NULL),(7225,'06503','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309366,-72.928189,0,'2013-07-06 12:44:30',NULL,NULL),(19940,'20572','U','National Mediation Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905845,-77.030192,0,'2013-07-06 12:44:31',NULL,NULL),(78837,'98335','S','Sunrise Beach','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(30073,'33154','S','Indian Creek','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.885829,-80.127959,0,'2013-07-06 12:44:32',NULL,NULL),(64537,'76645','S','Lovelace','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(51748,'60019','U','Des Plaines','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.024981,-87.899607,0,'2013-07-06 12:44:33',NULL,NULL),(78633,'98220','S','Saxon','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.687032,-122.194051,0,'2013-07-06 12:44:34',NULL,NULL),(78715,'98273','S','Mount Vernon','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.407114,-122.324434,0,'2013-07-06 12:44:34',NULL,NULL),(2338,'00936','P','Minillas','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(66029,'78363','S','Kingsville Naval Air Station','A','Kleberg','48273','Texas','TX','48','0000','361','Central',-6.0,'Y',27.514425,-97.860850,0,'2013-07-06 12:44:34',NULL,NULL),(30882,'33687','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.035966,-82.390978,0,'2013-07-06 12:44:32',NULL,NULL),(60211,'71422','S','Gaars Mill','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.066880,-92.645400,0,'2013-07-06 12:44:33',NULL,NULL),(56675,'65633','S','Crane','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.903431,-93.566967,0,'2013-07-06 12:44:33',NULL,NULL),(78622,'98203','S','Pinehurst','N','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.945956,-122.229877,0,'2013-07-06 12:44:34',NULL,NULL),(48175,'55381','S','Silver Lake','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.905043,-94.200088,0,'2013-07-06 12:44:33',NULL,NULL),(36599,'40972','S','Oneida','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.273420,-83.653289,0,'2013-07-06 12:44:32',NULL,NULL),(61146,'72167','S','Traskwood','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.450558,-92.654895,0,'2013-07-06 12:44:33',NULL,NULL),(48420,'55604','S','Croftville','N','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.800000,-90.300000,0,'2013-07-06 12:44:33',NULL,NULL),(66363,'78616','S','McMahan','A','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.029845,-97.571615,0,'2013-07-06 12:44:34',NULL,NULL),(25176,'28052','S','Boogertown','N','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(61749,'73043','S','Greenfield','D','Blaine','40011','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.746969,-98.387828,0,'2013-07-06 12:44:33',NULL,NULL),(20378,'20883','P','Gaithersburg','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.141926,-77.202510,0,'2013-07-06 12:44:31',NULL,NULL),(44319,'49744','S','Herron','D','Alpena','26007','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.992291,-83.664049,0,'2013-07-06 12:44:32',NULL,NULL),(16989,'17728','S','Haleeka','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.325480,-77.046900,0,'2013-07-06 12:44:31',NULL,NULL),(8055,'07739','S','Little Silver Point','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.334913,-74.044900,0,'2013-07-06 12:44:30',NULL,NULL),(29426,'32668','S','Morriston','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.273046,-82.364684,0,'2013-07-06 12:44:32',NULL,NULL),(75587,'94291','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.559052,-121.497218,0,'2013-07-06 12:44:34',NULL,NULL),(61025,'72117','S','Booker','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(49847,'57236','S','Garden City','D','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.936264,-97.557266,0,'2013-07-06 12:44:33',NULL,NULL),(13835,'14220','S','West Seneca','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.833786,-78.797770,0,'2013-07-06 12:44:31',NULL,NULL),(44257,'49682','S','Peshawbestown','A','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.967179,-85.639857,0,'2013-07-06 12:44:32',NULL,NULL),(37340,'41701','S','Browns Fork','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.253627,-83.184866,0,'2013-07-06 12:44:32',NULL,NULL),(76490,'95631','S','Todd Valley','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.009228,-120.852443,0,'2013-07-06 12:44:34',NULL,NULL),(26149,'28740','S','Green Mt','N','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(5618,'04938','S','Industry','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.670853,-70.146599,0,'2013-07-06 12:44:30',NULL,NULL),(57725,'67401','S','Salina','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.829855,-97.616195,0,'2013-07-06 12:44:33',NULL,NULL),(53885,'62353','S','Hersman','N','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985995,-90.767312,0,'2013-07-06 12:44:33',NULL,NULL),(52786,'61270','S','Union Grove','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.821788,-89.965907,0,'2013-07-06 12:44:33',NULL,NULL),(9502,'10014','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(19830,'20472','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885928,-77.019442,0,'2013-07-06 12:44:31',NULL,NULL),(30977,'33743','P','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.782429,-82.727623,0,'2013-07-06 12:44:32',NULL,NULL),(45222,'50643','S','Hudson','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.383057,-92.461301,0,'2013-07-06 12:44:32',NULL,NULL),(42427,'47802','S','Woodgate','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(28251,'31063','S','Dooling','A','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.299090,-84.021341,0,'2013-07-06 12:44:31',NULL,NULL),(60061,'71353','S','Bayou Current','N','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.655155,-91.789849,0,'2013-07-06 12:44:33',NULL,NULL),(53648,'62204','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.633044,-90.101683,0,'2013-07-06 12:44:33',NULL,NULL),(52875,'61341','S','Danway','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.330121,-88.708340,0,'2013-07-06 12:44:33',NULL,NULL),(5775,'05049','P','Hartland Four Corners','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.544740,-72.427723,0,'2013-07-06 12:44:30',NULL,NULL),(20506,'21076','S','Hanover','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.164940,-76.715640,0,'2013-07-06 12:44:31',NULL,NULL),(41977,'47421','S','Fayetteville','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(33003,'36652','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.695900,-88.043034,0,'2013-07-06 12:44:32',NULL,NULL),(17732,'18252','S','Tamaqua','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.798861,-75.971960,0,'2013-07-06 12:44:31',NULL,NULL),(14460,'15108','S','Moon Twp','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.510530,-80.182409,0,'2013-07-06 12:44:31',NULL,NULL),(78585,'98177','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.743958,-122.369875,0,'2013-07-06 12:44:34',NULL,NULL),(23556,'25635','S','Hunt','A','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.744662,-81.878847,0,'2013-07-06 12:44:31',NULL,NULL),(5507,'04765','S','Patten','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.997816,-68.444509,0,'2013-07-06 12:44:30',NULL,NULL),(19004,'19526','S','Jalappa','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(5395,'04653','S','Bass Harbor','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.156826,-68.439773,0,'2013-07-06 12:44:30',NULL,NULL),(39420,'44675','S','Sherrodsville','D','Carroll','39019','Ohio','OH','39','1320','740','Eastern',-5.0,'Y',40.520150,-81.233307,0,'2013-07-06 12:44:32',NULL,NULL),(39714,'45051','S','Mount Saint Joseph','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.095333,-84.639780,0,'2013-07-06 12:44:32',NULL,NULL),(1400,'00738','S','Urb La Costa Gdns Homes','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(6883,'06141','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.792221,-72.665323,0,'2013-07-06 12:44:30',NULL,NULL),(17022,'17745','S','Caldwell','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(78813,'98331','S','Queets','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(79400,'98802','S','East Wenatchee','D','Douglas','53017','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.438520,-120.234960,0,'2013-07-06 12:44:34',NULL,NULL),(3351,'01561','P','So Lancaster','N','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.441040,-71.689995,0,'2013-07-06 12:44:30',NULL,NULL),(54343,'62767','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.804644,-89.655319,0,'2013-07-06 12:44:33',NULL,NULL),(3405,'01701','S','Framingham So','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.315117,-71.434120,0,'2013-07-06 12:44:30',NULL,NULL),(25963,'28658','S','Newton','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(20813,'21610','S','Betterton','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.370080,-76.065963,0,'2013-07-06 12:44:31',NULL,NULL),(53420,'61849','S','Homer','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.037249,-87.963012,0,'2013-07-06 12:44:33',NULL,NULL),(41227,'46737','S','Clear Lake','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.721900,-84.920220,0,'2013-07-06 12:44:32',NULL,NULL),(39440,'44690','P','Winesburg','D','Holmes','39075','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.617698,-81.706191,0,'2013-07-06 12:44:32',NULL,NULL),(17149,'17801','S','Stonington','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(61313,'72435','S','Peach Orchard','A','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.315336,-90.586579,0,'2013-07-06 12:44:33',NULL,NULL),(16646,'17343','P','Mc Knightstown','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.864464,-77.336847,0,'2013-07-06 12:44:31',NULL,NULL),(23276,'25154','S','Peytona','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.121524,-81.705556,0,'2013-07-06 12:44:31',NULL,NULL),(29039,'32233','S','Mayport','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355620,-81.518460,0,'2013-07-06 12:44:32',NULL,NULL),(61700,'72958','S','Bates','A','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.899469,-94.094254,0,'2013-07-06 12:44:33',NULL,NULL),(76396,'95540','S','Fortuna','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.585216,-124.138734,0,'2013-07-06 12:44:34',NULL,NULL),(74456,'92589','P','Temecula','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.516968,-117.110213,0,'2013-07-06 12:44:34',NULL,NULL),(36243,'40296','U','Pnc Bank','N','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.257669,-85.757548,0,'2013-07-06 12:44:32',NULL,NULL),(20863,'21663','S','St Michaels','A','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.788100,-76.225239,0,'2013-07-06 12:44:31',NULL,NULL),(44083,'49455','S','Shelby','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.600338,-86.361909,0,'2013-07-06 12:44:32',NULL,NULL),(31691,'34788','S','Leesburg','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.853853,-81.778191,0,'2013-07-06 12:44:32',NULL,NULL),(78077,'97467','S','Winchestr Bay','A','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.709940,-123.973740,0,'2013-07-06 12:44:34',NULL,NULL),(58473,'68742','S','Inman','D','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.344111,-98.553943,0,'2013-07-06 12:44:33',NULL,NULL),(53272,'61722','S','West','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.449086,-88.632987,0,'2013-07-06 12:44:33',NULL,NULL),(51548,'59733','S','Gold Creek','D','Powell','30077','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.559875,-112.937996,0,'2013-07-06 12:44:33',NULL,NULL),(38912,'44118','S','University Ht','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(69256,'83427','S','Iona','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.457371,-111.868061,0,'2013-07-06 12:44:34',NULL,NULL),(8818,'08619','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.238460,-74.717460,0,'2013-07-06 12:44:30',NULL,NULL),(16040,'17044','S','Klondyke','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(26842,'29504','P','Florence','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',34.184235,-79.782543,0,'2013-07-06 12:44:31',NULL,NULL),(24265,'26833','S','Maysville','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.093016,-79.202715,0,'2013-07-06 12:44:31',NULL,NULL),(15135,'15845','S','Johnsonburg','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.493465,-78.682904,0,'2013-07-06 12:44:31',NULL,NULL),(6245,'05492','S','Waterville','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.717268,-72.755250,0,'2013-07-06 12:44:30',NULL,NULL),(28633,'31747','P','Ellenton','D','Colquitt','13071','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.186638,-83.746826,0,'2013-07-06 12:44:32',NULL,NULL),(68149,'80997','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.877688,-104.819099,0,'2013-07-06 12:44:34',NULL,NULL),(59316,'70521','P','Cecilia','D','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.336287,-91.847997,0,'2013-07-06 12:44:33',NULL,NULL),(8095,'07762','S','Wall Township','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(50488,'58053','S','Geneseo','A','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.077722,-97.150760,0,'2013-07-06 12:44:33',NULL,NULL),(24428,'27198','U','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.105109,-80.225702,0,'2013-07-06 12:44:31',NULL,NULL),(69658,'84014','S','Centerville','D','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.924885,-111.877285,0,'2013-07-06 12:44:34',NULL,NULL),(75076,'93532','S','Lake Hughes','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(79374,'98664','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.622483,-122.565862,0,'2013-07-06 12:44:34',NULL,NULL),(45295,'50707','S','Waterloo','A','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.482880,-92.277060,0,'2013-07-06 12:44:32',NULL,NULL),(16026,'17042','S','Mount Wilson','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(29216,'32413','S','West Panama City Beach','N','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(15627,'16699','U','Cresson','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.465506,-78.588583,0,'2013-07-06 12:44:31',NULL,NULL),(7745,'07305','S','Greenville','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.693860,-74.078820,0,'2013-07-06 12:44:30',NULL,NULL),(65992,'78338','P','Norias','N','Kenedy','48261','Texas','TX','48','0000','361','Central',-6.0,'Y',26.826414,-97.750931,0,'2013-07-06 12:44:34',NULL,NULL),(10596,'11040','S','Garden City Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(996,'00717','S','Ponce','D','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(30291,'33265','P','Olympia Hgts','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.737256,-80.411116,0,'2013-07-06 12:44:32',NULL,NULL),(29522,'32778','S','Tavares','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.801667,-81.736253,0,'2013-07-06 12:44:32',NULL,NULL),(16523,'17268','S','Fox Hill','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(12936,'13346','S','Hamilton','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827220,-75.529560,0,'2013-07-06 12:44:30',NULL,NULL),(2202,'00926','S','Repto de Diego','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(66862,'79178','U','Amarillo College','N','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.187943,-101.848673,0,'2013-07-06 12:44:34',NULL,NULL),(62034,'73503','S','Fort Sill','D','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.663560,-98.442960,0,'2013-07-06 12:44:33',NULL,NULL),(5749,'05036','S','Brookfield Center','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.033106,-72.595924,0,'2013-07-06 12:44:30',NULL,NULL),(18989,'19522','S','New Jerusalem','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(43596,'48760','S','Silverwood','D','Lapeer','26087','Michigan','MI','26','2160','989','Eastern',-5.0,'Y',43.321577,-83.247216,0,'2013-07-06 12:44:32',NULL,NULL),(49612,'56763','S','Swift','N','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.908263,-95.317658,0,'2013-07-06 12:44:33',NULL,NULL),(12399,'12928','S','Factoryville','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.966980,-73.461780,0,'2013-07-06 12:44:30',NULL,NULL),(17272,'17844','S','Foresthill','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.915260,-77.046496,0,'2013-07-06 12:44:31',NULL,NULL),(26625,'29319','U','Sptbg','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.947178,-81.926781,0,'2013-07-06 12:44:31',NULL,NULL),(13239,'13641','P','Fishers Lndg','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.278171,-76.008350,0,'2013-07-06 12:44:30',NULL,NULL),(25091,'27954','S','Manteo','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.915917,-75.677254,0,'2013-07-06 12:44:31',NULL,NULL),(12822,'13304','S','Barneveld','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.231560,-75.157560,0,'2013-07-06 12:44:30',NULL,NULL),(41998,'47424','S','Park','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(8417,'08075','S','Bridgeboro','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',40.021944,-74.932778,0,'2013-07-06 12:44:30',NULL,NULL),(61669,'72919','U','Golden Ventures','N','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.352237,-94.353023,0,'2013-07-06 12:44:33',NULL,NULL),(40166,'45365','S','Sidney','D','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.286524,-84.155059,0,'2013-07-06 12:44:32',NULL,NULL),(58548,'68815','S','Yale','N','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.524360,-99.039205,0,'2013-07-06 12:44:33',NULL,NULL),(70617,'85123','S','Arizona City','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.749965,-111.676936,0,'2013-07-06 12:44:34',NULL,NULL),(61835,'73114','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.566667,-97.522044,0,'2013-07-06 12:44:33',NULL,NULL),(40309,'45459','S','Bellbrook','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.638203,-84.167460,0,'2013-07-06 12:44:32',NULL,NULL),(44098,'49464','S','Zeeland','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866880,-85.968600,0,'2013-07-06 12:44:32',NULL,NULL),(43567,'48730','S','East Tawas','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.308832,-83.471081,0,'2013-07-06 12:44:32',NULL,NULL),(71565,'87301','S','Manuelito','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(49885,'57265','S','Troy','N','Grant','46051','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.017187,-96.820946,0,'2013-07-06 12:44:33',NULL,NULL),(76778,'95939','S','Elk Creek','D','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.600336,-122.565896,0,'2013-07-06 12:44:34',NULL,NULL),(46045,'52563','S','Hedrick','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.182320,-92.284680,0,'2013-07-06 12:44:32',NULL,NULL),(43785,'49042','S','Constantine','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.852452,-85.662670,0,'2013-07-06 12:44:32',NULL,NULL),(41932,'47386','S','Springport','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.046633,-85.394207,0,'2013-07-06 12:44:32',NULL,NULL),(8483,'08093','S','Verga','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.859740,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(67125,'79745','S','Kermit','D','Winkler','48495','Texas','TX','48','0000','432','Central',-6.0,'Y',31.853325,-103.090864,0,'2013-07-06 12:44:34',NULL,NULL),(27602,'30298','P','Forest Park','D','Clayton','13063','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.620191,-84.355795,0,'2013-07-06 12:44:31',NULL,NULL),(1150,'00727','S','La Cima I','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(39091,'44224','S','Hudson','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.173500,-81.449700,0,'2013-07-06 12:44:32',NULL,NULL),(79909,'99602','P','Holy Cross','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.229476,-160.433416,0,'2013-07-06 12:44:34',NULL,NULL),(44816,'50240','S','Wick','N','Madison','19121','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.300602,-93.744062,0,'2013-07-06 12:44:32',NULL,NULL),(33169,'37026','S','Bradyville','D','Cannon','47015','Tennessee','TN','47','0000','615','Central',-6.0,'Y',35.698888,-86.099540,0,'2013-07-06 12:44:32',NULL,NULL),(11018,'11559','S','Meadowmere Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.611795,-73.732344,0,'2013-07-06 12:44:30',NULL,NULL),(24114,'26531','P','Dellslow','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.606875,-79.890656,0,'2013-07-06 12:44:31',NULL,NULL),(15319,'16160','P','West Pittsburg','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.933740,-80.363091,0,'2013-07-06 12:44:31',NULL,NULL),(8406,'08066','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.825920,-75.212157,0,'2013-07-06 12:44:30',NULL,NULL),(4169,'02801','P','Adamsville','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.544002,-71.137777,0,'2013-07-06 12:44:30',NULL,NULL),(38105,'43093','U','State Farm Insurance','N','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.058168,-82.452320,0,'2013-07-06 12:44:32',NULL,NULL),(4846,'04011','S','Mere Point','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.905571,-69.964566,0,'2013-07-06 12:44:30',NULL,NULL),(66401,'78629','S','Gonzales','D','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(28715,'31901','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.474185,-84.977932,0,'2013-07-06 12:44:32',NULL,NULL),(36509,'40827','S','Essie','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.987935,-83.387657,0,'2013-07-06 12:44:32',NULL,NULL),(461,'00662','S','Vista Verde','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(4088,'02666','P','Truro','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.993876,-70.044935,0,'2013-07-06 12:44:30',NULL,NULL),(35739,'39710','U','Columbus AFB','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.636366,-88.455067,0,'2013-07-06 12:44:32',NULL,NULL),(41143,'46699','U','S Bend','N','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.671706,-86.252194,0,'2013-07-06 12:44:32',NULL,NULL),(51744,'60016','S','Des Plaines','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.047152,-87.891674,0,'2013-07-06 12:44:33',NULL,NULL),(50586,'58235','S','Gilby','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.104302,-97.450273,0,'2013-07-06 12:44:33',NULL,NULL),(50308,'57716','S','Batesland','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.104120,-102.197880,0,'2013-07-06 12:44:33',NULL,NULL),(42297,'47598','S','Arthur','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.362500,-87.217560,0,'2013-07-06 12:44:32',NULL,NULL),(14329,'15001','S','Mac Arthur','N','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(54053,'62471','S','Bear Grove','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.967418,-89.105783,0,'2013-07-06 12:44:33',NULL,NULL),(35111,'39209','S','Metrocenter','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.324026,-90.252348,0,'2013-07-06 12:44:32',NULL,NULL),(6260,'05602','S','Middlesex','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(17924,'18465','S','Thompson','D','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.829400,-75.537198,0,'2013-07-06 12:44:31',NULL,NULL),(69775,'84058','S','Bunker','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(66077,'78387','S','Sodville','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.033412,-97.505169,0,'2013-07-06 12:44:34',NULL,NULL),(47392,'54637','P','Hustler','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.876945,-90.275207,0,'2013-07-06 12:44:32',NULL,NULL),(59488,'70762','S','Torbert','A','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.615901,-91.463133,0,'2013-07-06 12:44:33',NULL,NULL),(63865,'75990','U','Woodville','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.773964,-94.423527,0,'2013-07-06 12:44:34',NULL,NULL),(78857,'98343','P','Crane','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.139728,-123.732852,0,'2013-07-06 12:44:34',NULL,NULL),(70824,'85387','S','Sun City West','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.678050,-112.468506,0,'2013-07-06 12:44:34',NULL,NULL),(43339,'48375','S','Novi','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.463733,-83.460384,0,'2013-07-06 12:44:32',NULL,NULL),(26017,'28677','S','Elmwood','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(10118,'10259','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(13370,'13736','S','Berkshire','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.313800,-76.190640,0,'2013-07-06 12:44:31',NULL,NULL),(67843,'80816','S','Florissant Fossil Beds Natio','N','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.891057,-105.264451,0,'2013-07-06 12:44:34',NULL,NULL),(54193,'62630','S','Chesterfield','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.277225,-90.092676,0,'2013-07-06 12:44:33',NULL,NULL),(48532,'55750','S','Hoyt Lakes','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.516024,-92.138667,0,'2013-07-06 12:44:33',NULL,NULL),(42883,'48094','S','Washingtn Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.734460,-82.998120,0,'2013-07-06 12:44:32',NULL,NULL),(22879,'24572','S','Wrights Shop','N','Amherst','51009','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.447984,-79.112687,0,'2013-07-06 12:44:31',NULL,NULL),(36444,'40618','U','Ky Dept of Revenue','N','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.179131,-84.898561,0,'2013-07-06 12:44:32',NULL,NULL),(37627,'42152','P','Hiseville','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.098707,-85.811844,0,'2013-07-06 12:44:32',NULL,NULL),(72631,'89419','S','Trinity','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(65703,'78011','S','Charlotte','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.818671,-98.711561,0,'2013-07-06 12:44:34',NULL,NULL),(44701,'50136','S','Keswick','D','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.469943,-92.244021,0,'2013-07-06 12:44:32',NULL,NULL),(12929,'13342','S','Garrattsville','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.640750,-75.226719,0,'2013-07-06 12:44:30',NULL,NULL),(1522,'00754','S','Urb Los Flamboyanes','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(6207,'05486','S','S Hero','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.866206,-73.251370,0,'2013-07-06 12:44:30',NULL,NULL),(16791,'17537','P','Lampeter','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.993237,-76.245313,0,'2013-07-06 12:44:31',NULL,NULL),(11630,'12116','S','Maryland','D','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.542837,-74.899432,0,'2013-07-06 12:44:30',NULL,NULL),(3155,'01263','U','Assoc of Marian Helpers','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.289010,-73.319529,0,'2013-07-06 12:44:30',NULL,NULL),(75871,'94949','S','Ignacio','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.060614,-122.540903,0,'2013-07-06 12:44:34',NULL,NULL),(63756,'75939','S','Wakefield','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',31.001922,-94.818309,0,'2013-07-06 12:44:34',NULL,NULL),(62491,'74359','S','Oaks','D','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.171831,-94.860683,0,'2013-07-06 12:44:33',NULL,NULL),(57793,'67484','S','Tescott','D','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.987400,-97.788540,0,'2013-07-06 12:44:33',NULL,NULL),(43008,'48161','S','Raisinvl Twp','A','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.909061,-83.470098,0,'2013-07-06 12:44:32',NULL,NULL),(40924,'46278','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.883333,-86.238611,0,'2013-07-06 12:44:32',NULL,NULL),(18036,'18655','S','Shickshinny','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.171280,-76.140000,0,'2013-07-06 12:44:31',NULL,NULL),(17180,'17815','S','Mainville','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(12451,'12966','S','West Bangor','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.818980,-74.415000,0,'2013-07-06 12:44:30',NULL,NULL),(27657,'30324','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.820340,-84.362232,0,'2013-07-06 12:44:31',NULL,NULL),(38905,'44118','S','Cleveland Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(38026,'43019','S','Fredericktown','D','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.491704,-82.533390,0,'2013-07-06 12:44:32',NULL,NULL),(16126,'17057','S','Mdt','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(35423,'39470','S','Poplarville','D','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.879720,-89.588460,0,'2013-07-06 12:44:32',NULL,NULL),(4603,'03588','S','Milan','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.639911,-71.148517,0,'2013-07-06 12:44:30',NULL,NULL),(57131,'66225','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.888339,-94.686133,0,'2013-07-06 12:44:33',NULL,NULL),(59694,'71073','S','Sibley','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.525220,-93.295020,0,'2013-07-06 12:44:33',NULL,NULL),(66543,'78731','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.345829,-97.765628,0,'2013-07-06 12:44:34',NULL,NULL),(67753,'80621','S','Fort Lupton','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.099919,-104.805331,0,'2013-07-06 12:44:34',NULL,NULL),(78157,'97622','P','Bly','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.424667,-121.179451,0,'2013-07-06 12:44:34',NULL,NULL),(8985,'08831','S','Monroe Twp','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.350085,-74.441445,0,'2013-07-06 12:44:30',NULL,NULL),(30566,'33413','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.678715,-80.141603,0,'2013-07-06 12:44:32',NULL,NULL),(29951,'33073','S','Coral Springs','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.305181,-80.187797,0,'2013-07-06 12:44:32',NULL,NULL),(1271,'00730','S','Bo Pueblito Nuevo','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(16868,'17565','S','Pequea','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.307222,0,'2013-07-06 12:44:31',NULL,NULL),(24109,'26525','S','Bruceton Mills','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.646175,-79.624337,0,'2013-07-06 12:44:31',NULL,NULL),(20898,'21711','S','Big Pool','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.670565,-78.004589,0,'2013-07-06 12:44:31',NULL,NULL),(45744,'52134','S','Chester','D','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.465662,-92.433456,0,'2013-07-06 12:44:32',NULL,NULL),(59007,'70067','S','Lafitte','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.721001,-90.123913,0,'2013-07-06 12:44:33',NULL,NULL),(69605,'83855','S','Onaway','A','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.011509,-116.928485,0,'2013-07-06 12:44:34',NULL,NULL),(4129,'02745','S','Acushnet','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.695977,-70.938302,0,'2013-07-06 12:44:30',NULL,NULL),(177,'00623','S','Haciendas De Miramar','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(11879,'12306','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.792392,-73.984961,0,'2013-07-06 12:44:30',NULL,NULL),(73827,'91771','U','So Cal Edison Co','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.065056,-118.083026,0,'2013-07-06 12:44:34',NULL,NULL),(47596,'54868','S','Canton','A','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.516544,-91.733836,0,'2013-07-06 12:44:33',NULL,NULL),(47228,'54499','S','Shepley','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.825108,-89.169054,0,'2013-07-06 12:44:32',NULL,NULL),(19027,'19533','S','Leesport','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.440626,-75.974641,0,'2013-07-06 12:44:31',NULL,NULL),(626,'00682','S','Parc Castillo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(6161,'05472','S','Brookville','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(3341,'01545','S','Edgemere','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.286758,-71.721540,0,'2013-07-06 12:44:30',NULL,NULL),(5499,'04758','S','Mars Hill','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.518157,-67.867517,0,'2013-07-06 12:44:30',NULL,NULL),(30083,'33156','S','Kendall','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(23559,'25637','P','Mount Gay','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.838894,-82.008765,0,'2013-07-06 12:44:31',NULL,NULL),(43285,'48334','S','Farmingtn Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505423,-83.351825,0,'2013-07-06 12:44:32',NULL,NULL),(43991,'49337','S','Newaygo','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.437720,-85.740420,0,'2013-07-06 12:44:32',NULL,NULL),(52320,'60556','S','Waterman','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.749083,-88.773261,0,'2013-07-06 12:44:33',NULL,NULL),(64342,'76513','S','Morgans Point','A','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.097391,-97.467293,0,'2013-07-06 12:44:34',NULL,NULL),(68367,'81137','S','So Ute Indian Res','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(68907,'82801','S','Sheridan','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.786539,-106.968080,0,'2013-07-06 12:44:34',NULL,NULL),(71252,'86404','S','Lake Havasu City','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',34.518339,-114.324094,0,'2013-07-06 12:44:34',NULL,NULL),(71863,'87713','S','Chacon','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.155830,-105.385328,0,'2013-07-06 12:44:34',NULL,NULL),(76128,'95248','P','Rail Rd Flat','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.315924,-120.516711,0,'2013-07-06 12:44:34',NULL,NULL),(30922,'33708','S','Redington Shores','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(2486,'00956','S','Urb Magnolia Gdns','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(5516,'04775','P','Sheridan','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.656893,-68.405304,0,'2013-07-06 12:44:30',NULL,NULL),(50029,'57426','P','Barnard','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.717662,-98.606716,0,'2013-07-06 12:44:33',NULL,NULL),(50342,'57738','S','Fairburn','D','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.651331,-103.221411,0,'2013-07-06 12:44:33',NULL,NULL),(398,'00662','S','Est De Isabela','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(37078,'41332','S','Buskirk','A','Wolfe','21237','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.796026,-83.456314,0,'2013-07-06 12:44:32',NULL,NULL),(3892,'02420','S','Lexington','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.455799,-71.215027,0,'2013-07-06 12:44:30',NULL,NULL),(32737,'36320','S','Cottonwood','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.075800,-85.302240,0,'2013-07-06 12:44:32',NULL,NULL),(2433,'00953','S','Urb Madelaine','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(17199,'17821','S','Mausdale','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(27326,'30032','S','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.735464,-84.266983,0,'2013-07-06 12:44:31',NULL,NULL),(54005,'62447','S','Neoga','D','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.321626,-88.454756,0,'2013-07-06 12:44:33',NULL,NULL),(65374,'77541','S','Jones Creek','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(76268,'95417','S','Laytonville','A','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.663318,-123.633905,0,'2013-07-06 12:44:34',NULL,NULL),(72612,'89415','S','Hawthorne','D','Mineral','32021','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.599680,-118.684500,0,'2013-07-06 12:44:34',NULL,NULL),(71542,'87174','P','Albuquerque','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.277379,-106.652579,0,'2013-07-06 12:44:34',NULL,NULL),(69584,'83839','S','Enaville','N','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.551860,-116.290620,0,'2013-07-06 12:44:34',NULL,NULL),(67676,'80503','S','Niwot','A','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.153029,-105.171300,0,'2013-07-06 12:44:34',NULL,NULL),(65672,'77984','S','Henkhaus','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.432036,-97.175420,0,'2013-07-06 12:44:34',NULL,NULL),(77335,'96715','P','Lihue','A','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.998592,-159.356441,0,'2013-07-06 12:44:34',NULL,NULL),(61899,'73141','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.510127,-97.394891,0,'2013-07-06 12:44:33',NULL,NULL),(50755,'58413','S','Nelvik','N','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.036030,-99.371223,0,'2013-07-06 12:44:33',NULL,NULL),(49203,'56455','S','Ironton','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.478503,-93.978413,0,'2013-07-06 12:44:33',NULL,NULL),(37936,'42649','S','Strunk','D','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.606503,-84.430804,0,'2013-07-06 12:44:32',NULL,NULL),(11567,'12065','S','Clifton Park','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.851460,-73.798980,0,'2013-07-06 12:44:30',NULL,NULL),(18709,'19197','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954696,-75.178777,0,'2013-07-06 12:44:31',NULL,NULL),(43753,'49012','S','Augusta','D','Kalamazoo','26077','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.356033,-85.347067,0,'2013-07-06 12:44:32',NULL,NULL),(14057,'14580','S','Webster','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.220645,-77.464013,0,'2013-07-06 12:44:31',NULL,NULL),(76744,'95915','P','Ganser Bar','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.006111,-121.248056,0,'2013-07-06 12:44:34',NULL,NULL),(59321,'70526','S','Crowley','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.213433,-92.373777,0,'2013-07-06 12:44:33',NULL,NULL),(42390,'47725','S','Evansville Dress Regional Ai','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974596,-87.555538,0,'2013-07-06 12:44:32',NULL,NULL),(36326,'40385','S','Dreyfus','A','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.747999,-84.128552,0,'2013-07-06 12:44:32',NULL,NULL),(78817,'98333','S','Fox Island','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250837,-122.623135,0,'2013-07-06 12:44:34',NULL,NULL),(72452,'89111','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.089397,-115.148121,0,'2013-07-06 12:44:34',NULL,NULL),(53134,'61550','S','Mayfair','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613787,-89.463814,0,'2013-07-06 12:44:33',NULL,NULL),(51247,'59074','S','Ryegate','D','Golden Valley','30037','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.279039,-109.286955,0,'2013-07-06 12:44:33',NULL,NULL),(29336,'32548','S','Okaloosa Is','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.411115,-86.614430,0,'2013-07-06 12:44:32',NULL,NULL),(12587,'13073','S','Groton','D','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.585725,-76.393025,0,'2013-07-06 12:44:30',NULL,NULL),(11822,'12237','U','NY Health Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.645888,-73.797658,0,'2013-07-06 12:44:30',NULL,NULL),(8237,'08002','S','Cherry Hill Township','N','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.933589,-75.018781,0,'2013-07-06 12:44:30',NULL,NULL),(33054,'36756','S','Sprott','A','Perry','01105','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.674170,-87.223090,0,'2013-07-06 12:44:32',NULL,NULL),(76943,'96028','S','Fall River Mills','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',41.059235,-121.497300,0,'2013-07-06 12:44:34',NULL,NULL),(68692,'82051','S','Bosler','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.576111,-105.694722,0,'2013-07-06 12:44:34',NULL,NULL),(57277,'66552','S','Whiting','D','Jackson','20085','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.612836,-95.621934,0,'2013-07-06 12:44:33',NULL,NULL),(39553,'44844','S','Mc Cutchenville','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.981166,-83.270538,0,'2013-07-06 12:44:32',NULL,NULL),(19237,'19930','S','Bethany Beach','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.530364,-75.062715,0,'2013-07-06 12:44:31',NULL,NULL),(36108,'40222','S','Bancroft','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(79873,'99567','S','Chugiak','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.403984,-149.460035,0,'2013-07-06 12:44:34',NULL,NULL),(78835,'98335','S','Shore Acres','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(64651,'76798','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.455490,-97.098132,0,'2013-07-06 12:44:34',NULL,NULL),(57282,'66605','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.014671,-95.635278,0,'2013-07-06 12:44:33',NULL,NULL),(53390,'61814','S','Bismarck','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.261951,-87.610694,0,'2013-07-06 12:44:33',NULL,NULL),(23439,'25404','S','Martinsburg','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.461628,-77.969503,0,'2013-07-06 12:44:31',NULL,NULL),(38288,'43335','P','Martel','D','Marion','39101','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.663648,-82.910449,0,'2013-07-06 12:44:32',NULL,NULL),(9507,'10016','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.745154,-73.980751,0,'2013-07-06 12:44:30',NULL,NULL),(34423,'38638','P','Independence','D','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.633091,-89.823776,0,'2013-07-06 12:44:32',NULL,NULL),(31712,'34953','S','St Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.256604,-80.384626,0,'2013-07-06 12:44:32',NULL,NULL),(29722,'32953','S','Merritt Island','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.400081,-80.705159,0,'2013-07-06 12:44:32',NULL,NULL),(25537,'28403','S','University of NC','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.204361,-77.883608,0,'2013-07-06 12:44:31',NULL,NULL),(16044,'17044','S','Longfellow','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(77713,'97057','P','Shaniko','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.058157,-120.808513,0,'2013-07-06 12:44:34',NULL,NULL),(74578,'92691','S','San Juan Capo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.612814,-117.662215,0,'2013-07-06 12:44:34',NULL,NULL),(63132,'75355','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.880114,-96.705112,0,'2013-07-06 12:44:33',NULL,NULL),(52369,'60616','S','Twenty Second Street','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.844775,-87.626719,0,'2013-07-06 12:44:33',NULL,NULL),(48680,'55924','S','Claremont','D','Dodge','27039','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.044098,-92.993163,0,'2013-07-06 12:44:33',NULL,NULL),(46566,'53517','S','Blue Mounds','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.005538,-89.821569,0,'2013-07-06 12:44:32',NULL,NULL),(42634,'47917','S','Ambia','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.465621,-87.464804,0,'2013-07-06 12:44:32',NULL,NULL),(1661,'00773','S','Luquillo','D','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(414,'00662','S','Repto Las Brisas','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(76639,'95717','P','Gold Run','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.164539,-120.859208,0,'2013-07-06 12:44:34',NULL,NULL),(64926,'77210','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757742,-95.363878,0,'2013-07-06 12:44:34',NULL,NULL),(61439,'72585','S','Forty Four','N','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.215052,-92.007034,0,'2013-07-06 12:44:33',NULL,NULL),(55381,'63622','S','Belgrade','D','Washington','29221','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.788108,-90.848823,0,'2013-07-06 12:44:33',NULL,NULL),(39083,'44221','S','Cuyahoga Falls','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.142424,-81.472891,0,'2013-07-06 12:44:32',NULL,NULL),(20141,'20724','S','Maryland City','A','Anne Arundel','24003','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.090999,-76.818955,0,'2013-07-06 12:44:31',NULL,NULL),(47533,'54813','S','Barronett','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.673321,-92.101259,0,'2013-07-06 12:44:32',NULL,NULL),(50481,'58047','S','Oxbow','A','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.717620,-96.856680,0,'2013-07-06 12:44:33',NULL,NULL),(14617,'15228','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.375682,-80.040038,0,'2013-07-06 12:44:31',NULL,NULL),(74680,'92871','P','Placentia','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.882928,-117.855690,0,'2013-07-06 12:44:34',NULL,NULL),(44029,'49415','S','Fruitport','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.144002,-86.134800,0,'2013-07-06 12:44:32',NULL,NULL),(3430,'01745','S','Fayville','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.292310,-71.504095,0,'2013-07-06 12:44:30',NULL,NULL),(38808,'44068','P','North Kingsville','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.905833,-80.690556,0,'2013-07-06 12:44:32',NULL,NULL),(19194,'19809','S','Edgemoor','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.771847,-75.496485,0,'2013-07-06 12:44:31',NULL,NULL),(74490,'92618','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.707390,-117.705377,0,'2013-07-06 12:44:34',NULL,NULL),(64620,'76692','S','Whitney','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.950379,-97.316515,0,'2013-07-06 12:44:34',NULL,NULL),(52511,'60805','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.722096,-87.702938,0,'2013-07-06 12:44:33',NULL,NULL),(49691,'57025','S','Junction City','N','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.785700,-96.696900,0,'2013-07-06 12:44:33',NULL,NULL),(23485,'25510','S','Culloden','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.420264,-82.071294,0,'2013-07-06 12:44:31',NULL,NULL),(1066,'00725','S','Jard Pla','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(2022,'00917','S','Bda Bitumul','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(766,'00692','S','Urb La Inmaculada Ct','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(74964,'93429','P','Casmalia','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.836982,-120.530949,0,'2013-07-06 12:44:34',NULL,NULL),(63005,'75158','S','Scurry','D','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.467435,-96.405307,0,'2013-07-06 12:44:33',NULL,NULL),(58022,'67951','S','Hugoton','D','Stevens','20189','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.175657,-101.346497,0,'2013-07-06 12:44:33',NULL,NULL),(54706,'62953','P','Joppa','D','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.208604,-88.846425,0,'2013-07-06 12:44:33',NULL,NULL),(50604,'58251','S','McCanna','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.898360,-97.669140,0,'2013-07-06 12:44:33',NULL,NULL),(33218,'37057','S','Dixon Springs','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.402435,-86.039251,0,'2013-07-06 12:44:32',NULL,NULL),(19421,'20097','U','Natl Repub Cong Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884700,-77.008117,0,'2013-07-06 12:44:31',NULL,NULL),(10357,'10578','S','Purdys','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.320695,-73.679913,0,'2013-07-06 12:44:30',NULL,NULL),(37034,'41256','S','Staffordsvlle','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.836517,-82.861342,0,'2013-07-06 12:44:32',NULL,NULL),(74416,'92549','S','Idyllwild','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.735886,-116.693711,0,'2013-07-06 12:44:34',NULL,NULL),(62624,'74549','S','Honobia','A','Le Flore','40079','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.539310,-94.938190,0,'2013-07-06 12:44:33',NULL,NULL),(61122,'72152','S','Sherrill','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.356360,-91.987080,0,'2013-07-06 12:44:33',NULL,NULL),(61078,'72128','S','Poyen','D','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.359293,-92.607618,0,'2013-07-06 12:44:33',NULL,NULL),(55553,'63852','S','Holcomb','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.403506,-90.025878,0,'2013-07-06 12:44:33',NULL,NULL),(53863,'62334','P','Elvaston','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.416211,-91.199203,0,'2013-07-06 12:44:33',NULL,NULL),(21533,'22729','S','Mitchells','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.383019,-78.011350,0,'2013-07-06 12:44:31',NULL,NULL),(49028,'56274','S','Norcross','D','Grant','27051','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.891030,-96.129385,0,'2013-07-06 12:44:33',NULL,NULL),(79903,'99591','P','Saint George Island','D','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',56.591517,-169.620701,0,'2013-07-06 12:44:34',NULL,NULL),(73217,'90623','S','La Palma','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.849063,-118.039814,0,'2013-07-06 12:44:34',NULL,NULL),(70790,'85356','S','Wellton','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.685851,-114.089045,0,'2013-07-06 12:44:34',NULL,NULL),(66012,'78353','S','Rachal','N','Brooks','48047','Texas','TX','48','0000','361','Central',-6.0,'Y',26.983969,-98.209608,0,'2013-07-06 12:44:34',NULL,NULL),(64297,'76455','S','Gustine','D','Comanche','48093','Texas','TX','48','0000','325','Central',-6.0,'Y',31.859419,-98.360506,0,'2013-07-06 12:44:34',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (52715,'61131','P','Loves Park','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.351915,-88.995909,0,'2013-07-06 12:44:33',NULL,NULL),(52257,'60521','S','Oak Brook','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.790281,-87.948130,0,'2013-07-06 12:44:33',NULL,NULL),(43379,'48426','S','Decker','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.504956,-83.065201,0,'2013-07-06 12:44:32',NULL,NULL),(37492,'42025','S','Draffenville','N','Marshall','21157','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.877980,-88.333200,0,'2013-07-06 12:44:32',NULL,NULL),(17630,'18055','S','Hellertown','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.579925,-75.333249,0,'2013-07-06 12:44:31',NULL,NULL),(43326,'48362','S','Lake Orion','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.782837,-83.269237,0,'2013-07-06 12:44:32',NULL,NULL),(72343,'89017','S','Ash Springs','N','Lincoln','32017','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',37.591348,-115.225947,0,'2013-07-06 12:44:34',NULL,NULL),(63632,'75839','S','Salmon','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.620240,-95.519820,0,'2013-07-06 12:44:34',NULL,NULL),(61951,'73165','S','okc','N','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.334300,-97.345860,0,'2013-07-06 12:44:33',NULL,NULL),(56490,'65334','S','Longwood','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.855775,-93.208469,0,'2013-07-06 12:44:33',NULL,NULL),(45007,'50451','S','Lakota','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.410394,-94.053463,0,'2013-07-06 12:44:32',NULL,NULL),(24320,'27020','S','Hamptonville','D','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(21198,'22192','S','Prince Wm','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.680010,-77.309022,0,'2013-07-06 12:44:31',NULL,NULL),(17998,'18630','S','Meshoppen','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.651464,-76.023654,0,'2013-07-06 12:44:31',NULL,NULL),(14838,'15437','S','Farmington','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.792451,-79.565992,0,'2013-07-06 12:44:31',NULL,NULL),(2179,'00926','S','Hacienda de Carraizo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(79868,'99563','P','Chevak','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.350500,-164.657918,0,'2013-07-06 12:44:34',NULL,NULL),(79745,'99224','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.692675,-117.626090,0,'2013-07-06 12:44:34',NULL,NULL),(73233,'90650','S','Norwalk','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.908151,-118.080822,0,'2013-07-06 12:44:34',NULL,NULL),(69227,'83402','S','Eagle Rock','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.496857,-112.113288,0,'2013-07-06 12:44:34',NULL,NULL),(64230,'76305','S','Pleasant Vly','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(61663,'72914','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.385872,-94.399733,0,'2013-07-06 12:44:33',NULL,NULL),(57473,'66865','S','Olpe','D','Lyon','20111','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.246277,-96.251350,0,'2013-07-06 12:44:33',NULL,NULL),(55186,'63377','S','Corso','N','Lincoln','29113','Missouri','MO','29','7040','573','Central',-6.0,'Y',39.140541,-91.061883,0,'2013-07-06 12:44:33',NULL,NULL),(43837,'49094','S','Union City','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',42.040123,-85.114805,0,'2013-07-06 12:44:32',NULL,NULL),(42523,'47854','S','Hillsdale','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.763883,-87.410160,0,'2013-07-06 12:44:32',NULL,NULL),(6580,'05857','S','Newport Center','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.950833,-72.306944,0,'2013-07-06 12:44:30',NULL,NULL),(38601,'43837','S','Prt Washingtn','A','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.320682,-81.502140,0,'2013-07-06 12:44:32',NULL,NULL),(37192,'41514','S','Burnwell','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.639594,-82.258022,0,'2013-07-06 12:44:32',NULL,NULL),(31162,'33917','S','N Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(7337,'06712','S','Prospect','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.495200,-72.974161,0,'2013-07-06 12:44:30',NULL,NULL),(9562,'10024','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(3091,'01222','S','Ashley Falls','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.056401,-73.318783,0,'2013-07-06 12:44:30',NULL,NULL),(26454,'29138','S','Fruit Hill','N','Saluda','45081','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.007368,-81.769758,0,'2013-07-06 12:44:31',NULL,NULL),(61191,'72215','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.753071,-92.347004,0,'2013-07-06 12:44:33',NULL,NULL),(2408,'00953','S','Ciudad Jardin II','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(54127,'62557','S','Dunkel','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.386310,-89.080983,0,'2013-07-06 12:44:33',NULL,NULL),(41233,'46738','S','Butler Center','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(74832,'93238','S','Kernville','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.752376,-118.424275,0,'2013-07-06 12:44:34',NULL,NULL),(27680,'30333','P','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.795743,-84.323393,0,'2013-07-06 12:44:31',NULL,NULL),(60782,'72022','S','Bryant','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.598058,-92.488227,0,'2013-07-06 12:44:33',NULL,NULL),(33155,'37013','S','Antioch','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.037491,-86.638596,0,'2013-07-06 12:44:32',NULL,NULL),(57128,'66224','S','Stanley','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(35661,'39648','S','McComb','D','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.162380,-90.384420,0,'2013-07-06 12:44:32',NULL,NULL),(76280,'95425','S','Asti','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.769480,-122.948340,0,'2013-07-06 12:44:34',NULL,NULL),(65505,'77664','S','Warren','D','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.636053,-94.381639,0,'2013-07-06 12:44:34',NULL,NULL),(21594,'22845','S','Orkney Sprngs','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.788542,-78.822829,0,'2013-07-06 12:44:31',NULL,NULL),(52730,'61233','P','Andover','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.294778,-90.288072,0,'2013-07-06 12:44:33',NULL,NULL),(8101,'07799','S','Eatontown','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.361410,-74.077982,0,'2013-07-06 12:44:30',NULL,NULL),(52168,'60456','S','Oak Lawn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.734578,-87.732449,0,'2013-07-06 12:44:33',NULL,NULL),(49463,'56652','S','Clover','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.638080,-95.383500,0,'2013-07-06 12:44:33',NULL,NULL),(7522,'07005','S','Boonton Township','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(63391,'75644','S','Soules Chapel','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(18985,'19522','S','Evansville','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(41554,'47018','S','Farmers Retreat','N','Dearborn','18029','Indiana','IN','18','1640','812','Eastern',-5.0,'Y',38.967420,-85.051860,0,'2013-07-06 12:44:32',NULL,NULL),(49766,'57069','S','Hub City','N','Clay','46027','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.781151,-96.924411,0,'2013-07-06 12:44:33',NULL,NULL),(41981,'47421','S','Judah','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(4112,'02718','S','East Taunton','D','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.872147,-71.018465,0,'2013-07-06 12:44:30',NULL,NULL),(24811,'27601','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772749,-78.635142,0,'2013-07-06 12:44:31',NULL,NULL),(30043,'33143','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.702034,-80.295591,0,'2013-07-06 12:44:32',NULL,NULL),(58432,'68666','S','Stromsburg','D','Polk','31143','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.114660,-97.592891,0,'2013-07-06 12:44:33',NULL,NULL),(69755,'84050','S','Peterson','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(42910,'48105','S','Ann Arbor Township','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.306761,-83.700406,0,'2013-07-06 12:44:32',NULL,NULL),(43548,'48706','S','Bay City','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.608032,-83.919043,0,'2013-07-06 12:44:32',NULL,NULL),(8063,'07747','S','Strathmore','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.412700,-74.252520,0,'2013-07-06 12:44:30',NULL,NULL),(52910,'61364','S','Kernan','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(71814,'87571','S','Ranchito','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.397440,-105.594480,0,'2013-07-06 12:44:34',NULL,NULL),(35335,'39436','P','Eastabuchie','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.472935,-89.326297,0,'2013-07-06 12:44:32',NULL,NULL),(1785,'00783','S','Bda Sostre','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(75500,'94134','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.722221,-122.411294,0,'2013-07-06 12:44:34',NULL,NULL),(12508,'13026','S','Aurora','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.743286,-76.652204,0,'2013-07-06 12:44:30',NULL,NULL),(4805,'03886','S','Tamworth','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.873645,-71.285814,0,'2013-07-06 12:44:30',NULL,NULL),(68743,'82215','S','Sunrise','A','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.326100,-104.682000,0,'2013-07-06 12:44:34',NULL,NULL),(16997,'17729','S','Cross Fork','D','Potter','42105','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',41.505883,-77.735689,0,'2013-07-06 12:44:31',NULL,NULL),(14290,'14871','S','Pine City','D','Chemung','36015','New York','NY','36','2335','607','Eastern',-5.0,'Y',42.050672,-76.866098,0,'2013-07-06 12:44:31',NULL,NULL),(29642,'32899','U','NASA','N','Brevard','12009','Florida','FL','12','5960','321','Eastern',-5.0,'Y',28.611682,-80.677691,0,'2013-07-06 12:44:32',NULL,NULL),(1050,'00723','S','Valle Alto','N','Patillas','72109','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010671,-66.015222,0,'2013-07-06 12:44:30',NULL,NULL),(39376,'44644','S','Malvern','D','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.685014,-81.195285,0,'2013-07-06 12:44:32',NULL,NULL),(74897,'93302','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.375349,-119.021889,0,'2013-07-06 12:44:34',NULL,NULL),(10529,'10985','S','Thompson Ridge','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.626920,-74.634300,0,'2013-07-06 12:44:30',NULL,NULL),(10848,'11412','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694225,-73.760504,0,'2013-07-06 12:44:30',NULL,NULL),(65756,'78066','S','Rio Medina','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.500765,-98.869143,0,'2013-07-06 12:44:34',NULL,NULL),(19059,'19547','S','Lobachsville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.383022,-75.787120,0,'2013-07-06 12:44:31',NULL,NULL),(49377,'56591','P','White Earth','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.096509,-95.842920,0,'2013-07-06 12:44:33',NULL,NULL),(29348,'32561','S','Gulf Breeze','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.383106,-87.090524,0,'2013-07-06 12:44:32',NULL,NULL),(36943,'41164','S','Stark','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(34998,'39116','S','Mize','D','Smith','28129','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.849432,-89.564337,0,'2013-07-06 12:44:32',NULL,NULL),(73702,'91608','S','North Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140376,-118.354334,0,'2013-07-06 12:44:34',NULL,NULL),(79651,'99147','S','Creston','A','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.822043,-118.474960,0,'2013-07-06 12:44:34',NULL,NULL),(14050,'14561','S','Stanley','D','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.823591,-77.098747,0,'2013-07-06 12:44:31',NULL,NULL),(74873,'93267','S','Strathmore','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.148701,-119.064161,0,'2013-07-06 12:44:34',NULL,NULL),(19706,'20388','S','Washington','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878851,-76.991728,0,'2013-07-06 12:44:31',NULL,NULL),(22246,'23664','S','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.056659,-76.293478,0,'2013-07-06 12:44:31',NULL,NULL),(65609,'77905','S','Victoria','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.884742,-97.170923,0,'2013-07-06 12:44:34',NULL,NULL),(61276,'72387','P','Vanndale','D','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.255454,-90.807725,0,'2013-07-06 12:44:33',NULL,NULL),(46233,'52778','S','Lime City','N','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.590341,-91.019280,0,'2013-07-06 12:44:32',NULL,NULL),(45238,'50651','S','La Porte City','D','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.333783,-92.194367,0,'2013-07-06 12:44:32',NULL,NULL),(38464,'43615','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651393,-83.674791,0,'2013-07-06 12:44:32',NULL,NULL),(19313,'20013','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894993,-77.044909,0,'2013-07-06 12:44:31',NULL,NULL),(35655,'39647','S','McCall Creek','N','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.510920,-90.772920,0,'2013-07-06 12:44:32',NULL,NULL),(78358,'98013','P','Burton','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.389080,-122.459400,0,'2013-07-06 12:44:34',NULL,NULL),(60507,'71665','S','Toledo','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(77338,'96718','P','Hawaii National Park','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.410522,-155.274653,0,'2013-07-06 12:44:34',NULL,NULL),(14651,'15236','S','Pleasant Hills','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.347180,-79.976950,0,'2013-07-06 12:44:31',NULL,NULL),(11814,'12233','U','NY Conservation Dept','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.649243,-73.755554,0,'2013-07-06 12:44:30',NULL,NULL),(11092,'11694','S','Belle Harbor','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.576767,-73.844160,0,'2013-07-06 12:44:30',NULL,NULL),(6022,'05401','S','Burlingtn','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487240,-73.227780,0,'2013-07-06 12:44:30',NULL,NULL),(48933,'56157','S','Lynd','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.415366,-95.958530,0,'2013-07-06 12:44:33',NULL,NULL),(6252,'05501','U','Internal Revenue Service','N','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.652272,-71.183498,0,'2013-07-06 12:44:30',NULL,NULL),(57328,'66713','S','Baxter Spgs','A','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.022713,-94.739150,0,'2013-07-06 12:44:33',NULL,NULL),(30506,'33403','S','North Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(24731,'27520','S','Clayton','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.636282,-78.444815,0,'2013-07-06 12:44:31',NULL,NULL),(19120,'19608','S','Fritztown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(10189,'10292','U','Bache Halsey Stuart Shields','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.708181,-74.003846,0,'2013-07-06 12:44:30',NULL,NULL),(71134,'86023','P','Grand Canyon National Park','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.054420,-112.138620,0,'2013-07-06 12:44:34',NULL,NULL),(9114,'09114','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5903,'05159','P','Grout','N','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.085978,-72.440728,0,'2013-07-06 12:44:30',NULL,NULL),(32548,'36110','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.418887,-86.273229,0,'2013-07-06 12:44:32',NULL,NULL),(76648,'95726','S','Fresh Pond','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.756220,-120.546600,0,'2013-07-06 12:44:34',NULL,NULL),(24332,'27027','S','Mayodan','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.411918,-79.976025,0,'2013-07-06 12:44:31',NULL,NULL),(63142,'75370','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.999788,-96.841700,0,'2013-07-06 12:44:33',NULL,NULL),(39981,'45239','S','North College Hill','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(75648,'94527','P','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.976622,-122.056397,0,'2013-07-06 12:44:34',NULL,NULL),(78574,'98166','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.447460,-122.356560,0,'2013-07-06 12:44:34',NULL,NULL),(16011,'17042','S','Avon','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(17055,'17754','S','Loyalsockvle','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(69293,'83445','S','Saint Anthony','D','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(17112,'17771','S','Pleasant Strm','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(61428,'72575','P','Salado','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.691013,-91.590512,0,'2013-07-06 12:44:33',NULL,NULL),(51503,'59639','S','Lincoln','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.946300,-112.914727,0,'2013-07-06 12:44:33',NULL,NULL),(33852,'37997','U','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.965412,-83.909511,0,'2013-07-06 12:44:32',NULL,NULL),(79933,'99615','S','Chiniak','A','Kodiak Island','02150','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',57.804109,-152.453963,0,'2013-07-06 12:44:34',NULL,NULL),(55955,'64490','S','Stewartsville','D','DeKalb','29063','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.753900,-94.502700,0,'2013-07-06 12:44:33',NULL,NULL),(47139,'54456','S','Neillsville','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.563991,-90.593555,0,'2013-07-06 12:44:32',NULL,NULL),(40628,'46016','S','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.097201,-85.681347,0,'2013-07-06 12:44:32',NULL,NULL),(20522,'21090','S','Linthicum Hts','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.205670,-76.657567,0,'2013-07-06 12:44:31',NULL,NULL),(10893,'11424','P','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.706550,-73.828147,0,'2013-07-06 12:44:30',NULL,NULL),(27272,'29940','S','Seabrook','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.522450,-80.745942,0,'2013-07-06 12:44:31',NULL,NULL),(55972,'64506','S','Country Club','A','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.788843,-94.802142,0,'2013-07-06 12:44:33',NULL,NULL),(11810,'12231','U','NY Secretary Of State','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.656061,-73.760129,0,'2013-07-06 12:44:30',NULL,NULL),(39203,'44372','P','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.150868,-81.608894,0,'2013-07-06 12:44:32',NULL,NULL),(25286,'28135','S','Polkton','D','Anson','37007','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.006202,-80.207436,0,'2013-07-06 12:44:31',NULL,NULL),(13332,'13684','S','Clare','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.375880,-75.069180,0,'2013-07-06 12:44:30',NULL,NULL),(22533,'24113','P','Martinsville','D','Martinsville City','51690','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.682672,-79.850377,0,'2013-07-06 12:44:31',NULL,NULL),(71471,'87060','P','Tome','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.740824,-106.731384,0,'2013-07-06 12:44:34',NULL,NULL),(55270,'63462','S','Salt River','N','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.429064,-91.669127,0,'2013-07-06 12:44:33',NULL,NULL),(55291,'63501','S','Sperry','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(55277,'63467','P','Saverton','D','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.531879,-91.437369,0,'2013-07-06 12:44:33',NULL,NULL),(28730,'31907','S','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.477304,-84.903608,0,'2013-07-06 12:44:32',NULL,NULL),(50602,'58250','S','Lankin','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.289211,-98.059895,0,'2013-07-06 12:44:33',NULL,NULL),(78232,'97814','S','Baker City','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.779688,-117.834287,0,'2013-07-06 12:44:34',NULL,NULL),(33430,'37250','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.161267,-86.783675,0,'2013-07-06 12:44:32',NULL,NULL),(10319,'10541','S','Lake Lincolndale','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.378032,-73.749712,0,'2013-07-06 12:44:30',NULL,NULL),(48078,'55331','S','Greenwood','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(16333,'17126','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265390,-76.880316,0,'2013-07-06 12:44:31',NULL,NULL),(15043,'15705','U','Indiana Univ of Pa','N','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.616606,-79.153926,0,'2013-07-06 12:44:31',NULL,NULL),(61933,'73155','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.418558,-97.435219,0,'2013-07-06 12:44:33',NULL,NULL),(8884,'08722','S','Beachwood','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.934006,-74.195669,0,'2013-07-06 12:44:30',NULL,NULL),(34727,'38847','S','Golden','D','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.468200,-88.181220,0,'2013-07-06 12:44:32',NULL,NULL),(16653,'17347','S','Saginaw','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.054598,-76.690743,0,'2013-07-06 12:44:31',NULL,NULL),(23229,'25085','S','Gauley Bridge','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.167246,-81.190813,0,'2013-07-06 12:44:31',NULL,NULL),(15243,'16046','S','Mars','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.697780,-80.065812,0,'2013-07-06 12:44:31',NULL,NULL),(29785,'33016','S','Hialeah Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890138,-80.341466,0,'2013-07-06 12:44:32',NULL,NULL),(39383,'44651','S','Mechanicstown','D','Carroll','39019','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.632802,-80.959765,0,'2013-07-06 12:44:32',NULL,NULL),(65469,'77630','S','Orange','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.081944,-93.758056,0,'2013-07-06 12:44:34',NULL,NULL),(68517,'81330','P','Mesa Verde','A','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.297111,-108.420076,0,'2013-07-06 12:44:34',NULL,NULL),(63785,'75956','S','Bon Ami','A','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.659279,-93.896201,0,'2013-07-06 12:44:34',NULL,NULL),(79887,'99576','P','Twin Hills','A','Dillingham','02070','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.070280,-160.266870,0,'2013-07-06 12:44:34',NULL,NULL),(6615,'05874','S','Westfield','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.875475,-72.465214,0,'2013-07-06 12:44:30',NULL,NULL),(10754,'11361','S','Bayside','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.764760,-73.777510,0,'2013-07-06 12:44:30',NULL,NULL),(63416,'75656','S','Hughes Springs','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.941001,-94.707975,0,'2013-07-06 12:44:33',NULL,NULL),(14997,'15656','S','West Leechburg','A','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.629851,-79.604848,0,'2013-07-06 12:44:31',NULL,NULL),(5098,'04346','S','Randolph','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.230440,-69.764460,0,'2013-07-06 12:44:30',NULL,NULL),(39447,'44699','S','Tippecanoe','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.281057,-81.268298,0,'2013-07-06 12:44:32',NULL,NULL),(76711,'95840','U','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583712,-121.490234,0,'2013-07-06 12:44:34',NULL,NULL),(39393,'44657','S','Bayard','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(63828,'75973','S','Goober Hill','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(48842,'56056','P','La Salle','D','Watonwan','27165','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.981769,-94.626721,0,'2013-07-06 12:44:33',NULL,NULL),(46446,'53209','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.125920,-87.946764,0,'2013-07-06 12:44:32',NULL,NULL),(72254,'88531','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.809229,-106.417472,0,'2013-07-06 12:44:34',NULL,NULL),(1854,'00791','S','Est de la Loma','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(34123,'38190','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.056208,-90.060145,0,'2013-07-06 12:44:32',NULL,NULL),(16313,'17113','S','Steelton','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.247280,-76.842480,0,'2013-07-06 12:44:31',NULL,NULL),(73156,'90293','S','Playa del Rey','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.990833,-118.459167,0,'2013-07-06 12:44:34',NULL,NULL),(14185,'14750','S','Lakewood','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.100720,-79.322878,0,'2013-07-06 12:44:31',NULL,NULL),(71793,'87562','P','Rencona','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.507793,-105.666812,0,'2013-07-06 12:44:34',NULL,NULL),(65328,'77515','S','McBeth','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(57256,'66536','S','St Marys','N','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.194394,-96.064840,0,'2013-07-06 12:44:33',NULL,NULL),(8680,'08330','S','Scullville','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.440760,-74.728980,0,'2013-07-06 12:44:30',NULL,NULL),(29820,'33027','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.978093,-80.330196,0,'2013-07-06 12:44:32',NULL,NULL),(13350,'13694','S','Waddington','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.863217,-75.200794,0,'2013-07-06 12:44:30',NULL,NULL),(866,'00698','S','Urb Luchetti','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(17125,'17776','S','Cummings','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.331890,-77.344196,0,'2013-07-06 12:44:31',NULL,NULL),(32074,'35285','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.541978,-86.803608,0,'2013-07-06 12:44:32',NULL,NULL),(64812,'77025','S','Astrodome','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.690087,-95.433831,0,'2013-07-06 12:44:34',NULL,NULL),(13994,'14513','S','East Palmyra','A','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.052762,-77.096188,0,'2013-07-06 12:44:31',NULL,NULL),(65569,'77852','P','Deanville','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.431374,-96.757176,0,'2013-07-06 12:44:34',NULL,NULL),(76432,'95595','S','Zenia','D','Trinity','06105','California','CA','06','0000','707','Pacific',-8.0,'Y',40.180955,-123.416183,0,'2013-07-06 12:44:34',NULL,NULL),(6866,'06133','P','West Hartfrd','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753216,-72.704041,0,'2013-07-06 12:44:30',NULL,NULL),(17234,'17836','S','Upper Mahanoy','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.711436,-76.629823,0,'2013-07-06 12:44:31',NULL,NULL),(35696,'39664','S','Eastfork','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.356300,-90.636060,0,'2013-07-06 12:44:32',NULL,NULL),(74017,'92123','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.800916,-117.137146,0,'2013-07-06 12:44:34',NULL,NULL),(57789,'67481','S','Sylvan Grove','D','Lincoln','20105','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.046332,-98.376685,0,'2013-07-06 12:44:33',NULL,NULL),(47221,'54495','S','Wisconsin Rapids','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.404404,-89.867303,0,'2013-07-06 12:44:32',NULL,NULL),(42961,'48130','S','Webster','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.353665,-83.897388,0,'2013-07-06 12:44:32',NULL,NULL),(20782,'21538','S','Kitzmiller','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.379444,-79.205000,0,'2013-07-06 12:44:31',NULL,NULL),(38459,'43613','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.704307,-83.604452,0,'2013-07-06 12:44:32',NULL,NULL),(11683,'12153','S','Sand Lake','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.637100,-73.491691,0,'2013-07-06 12:44:30',NULL,NULL),(34867,'38935','P','G Wood','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.522263,-90.178983,0,'2013-07-06 12:44:32',NULL,NULL),(34667,'38802','P','Tupelo','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.272739,-88.700478,0,'2013-07-06 12:44:32',NULL,NULL),(31527,'34480','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.105081,-82.098267,0,'2013-07-06 12:44:32',NULL,NULL),(31464,'34288','S','Northport','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.048529,-82.194897,0,'2013-07-06 12:44:32',NULL,NULL),(14332,'15001','S','West Aliquippa','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(10453,'10922','P','Fort Montgomery','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.338977,-73.987248,0,'2013-07-06 12:44:30',NULL,NULL),(12859,'13319','S','Willowvale','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.023165,-75.269856,0,'2013-07-06 12:44:30',NULL,NULL),(29198,'32407','S','Panama City Beach','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.202980,-85.797960,0,'2013-07-06 12:44:32',NULL,NULL),(27054,'29678','S','Seneca','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.693402,-82.941284,0,'2013-07-06 12:44:31',NULL,NULL),(57790,'67482','P','Talmage','D','Dickinson','20041','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.009162,-97.317100,0,'2013-07-06 12:44:33',NULL,NULL),(43270,'48330','P','Drayton Plains','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.683616,-83.377192,0,'2013-07-06 12:44:32',NULL,NULL),(71030,'85737','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.425216,-110.957657,0,'2013-07-06 12:44:34',NULL,NULL),(73971,'92075','S','Solana Beach','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.996744,-117.256492,0,'2013-07-06 12:44:34',NULL,NULL),(20891,'21704','S','Frederick','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.373967,-77.390459,0,'2013-07-06 12:44:31',NULL,NULL),(2073,'00921','S','Repto Metropolitano','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(43191,'48302','S','Bloomfield Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573777,-83.293724,0,'2013-07-06 12:44:32',NULL,NULL),(31616,'34689','S','Tarpon Spngs','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.143816,-82.747935,0,'2013-07-06 12:44:32',NULL,NULL),(76718,'95853','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.607305,-121.443172,0,'2013-07-06 12:44:34',NULL,NULL),(56425,'65261','S','Keytesville','D','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.432638,-92.935494,0,'2013-07-06 12:44:33',NULL,NULL),(27144,'29821','S','Clarks Hill','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.643723,-82.146272,0,'2013-07-06 12:44:31',NULL,NULL),(51180,'59015','S','Comanche','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',46.197479,-108.913459,0,'2013-07-06 12:44:33',NULL,NULL),(38890,'44111','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.459888,-81.784804,0,'2013-07-06 12:44:32',NULL,NULL),(13134,'13493','S','Williamstn','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.422128,-75.888230,0,'2013-07-06 12:44:30',NULL,NULL),(76068,'95204','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.973809,-121.317740,0,'2013-07-06 12:44:34',NULL,NULL),(67594,'80421','S','Bailey','D','Park','08093','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.458026,-105.484852,0,'2013-07-06 12:44:34',NULL,NULL),(9253,'09588','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(61507,'72650','S','Landis','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.940312,-92.656563,0,'2013-07-06 12:44:33',NULL,NULL),(3909,'02456','P','Newton','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.333573,-71.204106,0,'2013-07-06 12:44:30',NULL,NULL),(63625,'75835','S','Crockett','D','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(24962,'27839','S','Halifax','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.326599,-77.587407,0,'2013-07-06 12:44:31',NULL,NULL),(24802,'27593','P','Wilsons Mill','N','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.604395,-78.341248,0,'2013-07-06 12:44:31',NULL,NULL),(67603,'80428','S','Clark','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.738657,-106.914430,0,'2013-07-06 12:44:34',NULL,NULL),(3848,'02346','S','Middleborough','N','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.887265,-70.887189,0,'2013-07-06 12:44:30',NULL,NULL),(38414,'43541','S','Milton Center','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.302432,-83.830175,0,'2013-07-06 12:44:32',NULL,NULL),(16828,'17552','S','Florin','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.108548,-76.508883,0,'2013-07-06 12:44:31',NULL,NULL),(69705,'84032','S','Keetley','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(22959,'24701','S','Bluewell','A','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(55992,'64637','S','Cowgill','D','Caldwell','29025','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.569295,-93.927257,0,'2013-07-06 12:44:33',NULL,NULL),(2226,'00926','S','Urb El Mirador de Cupey','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(19270,'19958','S','Lewes','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.725800,-75.174180,0,'2013-07-06 12:44:31',NULL,NULL),(43061,'48189','S','Northfield Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.399875,-83.771630,0,'2013-07-06 12:44:32',NULL,NULL),(37559,'42070','P','Milburn','D','Carlisle','21039','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.797936,-88.897657,0,'2013-07-06 12:44:32',NULL,NULL),(32531,'36102','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.395238,-86.326456,0,'2013-07-06 12:44:32',NULL,NULL),(77070,'96124','S','Sattley','A','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.653100,-120.514620,0,'2013-07-06 12:44:34',NULL,NULL),(56032,'64680','P','Stet','D','Carroll','29033','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.424328,-93.757542,0,'2013-07-06 12:44:33',NULL,NULL),(64,'00612','S','Bda Duhamel','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(64267,'76401','S','Stephenville','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.220415,-98.216583,0,'2013-07-06 12:44:34',NULL,NULL),(24418,'27130','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.056965,-80.320718,0,'2013-07-06 12:44:31',NULL,NULL),(51551,'59739','S','Lima','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',44.643198,-112.601232,0,'2013-07-06 12:44:33',NULL,NULL),(78304,'97905','P','Durkee','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.582418,-117.462964,0,'2013-07-06 12:44:34',NULL,NULL),(73382,'91102','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.148314,-118.143097,0,'2013-07-06 12:44:34',NULL,NULL),(65436,'77586','S','Seabrook','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(59380,'70602','P','Lake Charles','D','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.225539,-93.216157,0,'2013-07-06 12:44:33',NULL,NULL),(39031,'44145','S','Westlake','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.450401,-81.925054,0,'2013-07-06 12:44:32',NULL,NULL),(35773,'39744','S','Europa','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(4333,'03031','S','Amherst','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.860306,-71.608545,0,'2013-07-06 12:44:30',NULL,NULL),(10449,'10918','S','Mediacom Park','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.352758,-74.266372,0,'2013-07-06 12:44:30',NULL,NULL),(23006,'24815','S','Berwind','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.269547,-81.665130,0,'2013-07-06 12:44:31',NULL,NULL),(39988,'45241','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267662,-84.405863,0,'2013-07-06 12:44:32',NULL,NULL),(48992,'56235','S','Donnelly','D','Stevens','27149','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.716501,-96.124586,0,'2013-07-06 12:44:33',NULL,NULL),(55886,'64424','S','Bethany','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.265514,-94.034115,0,'2013-07-06 12:44:33',NULL,NULL),(67295,'80014','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.659880,-104.836980,0,'2013-07-06 12:44:34',NULL,NULL),(27388,'30083','S','St Mountain','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.789125,-84.199181,0,'2013-07-06 12:44:31',NULL,NULL),(19596,'20226','U','Dept Treas Other Offices','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897787,-77.031979,0,'2013-07-06 12:44:31',NULL,NULL),(38767,'44047','S','Jefferson','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.650287,-80.769918,0,'2013-07-06 12:44:32',NULL,NULL),(7805,'07439','S','Ogdensburg','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.073022,-74.595302,0,'2013-07-06 12:44:30',NULL,NULL),(54855,'63043','S','Maryland Heights','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.724027,-90.439555,0,'2013-07-06 12:44:33',NULL,NULL),(59514,'70787','P','Weyanoke','D','West Feliciana','22125','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.967035,-91.467995,0,'2013-07-06 12:44:33',NULL,NULL),(60975,'72106','S','Mayflower','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.969289,-92.431561,0,'2013-07-06 12:44:33',NULL,NULL),(66048,'78374','S','Portland','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.881212,-97.318690,0,'2013-07-06 12:44:34',NULL,NULL),(15847,'16938','S','Nauvoo','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(27969,'30558','S','Maysville','D','Banks','13011','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.256794,-83.557304,0,'2013-07-06 12:44:31',NULL,NULL),(29683,'32925','S','Canaveral As','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.229987,-80.623528,0,'2013-07-06 12:44:32',NULL,NULL),(671,'00683','S','Urb La Nueva Salamanca','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(36607,'40977','S','Davisburg','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(6943,'06180','U','Bank of America','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757571,-72.764720,0,'2013-07-06 12:44:30',NULL,NULL),(23677,'25840','S','Fayetteville','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.054872,-81.100490,0,'2013-07-06 12:44:31',NULL,NULL),(77367,'96745','P','Kailua Kona','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.685677,-155.970966,0,'2013-07-06 12:44:34',NULL,NULL),(76776,'95937','P','Dunnigan','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.888464,-121.990452,0,'2013-07-06 12:44:34',NULL,NULL),(73231,'90639','U','La Mirada','D','Los Angeles','06037','California','CA','06','4480','714','Pacific',-8.0,'Y',33.907592,-118.020573,0,'2013-07-06 12:44:34',NULL,NULL),(69792,'84065','S','Camp Williams','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.535262,-111.962723,0,'2013-07-06 12:44:34',NULL,NULL),(60830,'72038','S','Crocketts Blf','A','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.421824,-91.227791,0,'2013-07-06 12:44:33',NULL,NULL),(50059,'57439','P','Ferney','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.329454,-98.096459,0,'2013-07-06 12:44:33',NULL,NULL),(47004,'54301','S','Allouez','A','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.477500,-88.016111,0,'2013-07-06 12:44:32',NULL,NULL),(2001,'00911','S','Loiza Street','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451416,-66.061581,0,'2013-07-06 12:44:30',NULL,NULL),(77337,'96717','S','Hauula','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.620407,-157.918600,0,'2013-07-06 12:44:34',NULL,NULL),(76107,'95228','S','Copperopolis','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',37.957753,-120.638434,0,'2013-07-06 12:44:34',NULL,NULL),(73655,'91502','S','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.174687,-118.306185,0,'2013-07-06 12:44:34',NULL,NULL),(72894,'90018','S','Dockweiler','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.030481,-118.318046,0,'2013-07-06 12:44:34',NULL,NULL),(71440,'87035','S','Moriarty','D','Torrance','35057','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.959132,-106.054681,0,'2013-07-06 12:44:34',NULL,NULL),(66445,'78650','S','McDade','A','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.306005,-97.219545,0,'2013-07-06 12:44:34',NULL,NULL),(64536,'76645','S','Hillsboro','D','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',32.014740,-97.108860,0,'2013-07-06 12:44:34',NULL,NULL),(63543,'75763','S','Fincastle','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(52894,'61350','S','Woodland Addition','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(52174,'60459','S','Bedford Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745512,-87.772445,0,'2013-07-06 12:44:33',NULL,NULL),(49580,'56733','S','Kennedy','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.634540,-96.978652,0,'2013-07-06 12:44:33',NULL,NULL),(48900,'56122','S','Chandler','D','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.930909,-95.947259,0,'2013-07-06 12:44:33',NULL,NULL),(40286,'45439','S','West Carrollton City','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(25698,'28531','S','Harkers Island','D','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.726336,-76.570940,0,'2013-07-06 12:44:31',NULL,NULL),(27364,'30065','P','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.047214,-84.442482,0,'2013-07-06 12:44:31',NULL,NULL),(20044,'20653','S','LEX Pk','N','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.273193,-76.464098,0,'2013-07-06 12:44:31',NULL,NULL),(30387,'33319','S','Tamarac','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.181839,-80.227592,0,'2013-07-06 12:44:32',NULL,NULL),(32257,'35618','S','North Courtland','A','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.652816,-87.299297,0,'2013-07-06 12:44:32',NULL,NULL),(19235,'19905','P','Dover','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.158991,-75.520428,0,'2013-07-06 12:44:31',NULL,NULL),(6059,'05443','S','Rocky Dale','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.157840,-73.062600,0,'2013-07-06 12:44:30',NULL,NULL),(734,'00688','S','Sabana Hoyos','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.430209,-66.612619,0,'2013-07-06 12:44:30',NULL,NULL),(15262,'16066','S','Cranberry Twp','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.707441,-80.107217,0,'2013-07-06 12:44:31',NULL,NULL),(4263,'02882','S','Bonnet Shores','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.432140,-71.468662,0,'2013-07-06 12:44:30',NULL,NULL),(7202,'06482','S','Sandy Hook','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.410179,-73.250634,0,'2013-07-06 12:44:30',NULL,NULL),(19443,'20111','S','Manassas Park','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.737900,-77.422197,0,'2013-07-06 12:44:31',NULL,NULL),(7219,'06498','S','Westbrook','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.288396,-72.455846,0,'2013-07-06 12:44:30',NULL,NULL),(59176,'70346','S','Donaldsonville','D','Ascension','22005','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.100345,-91.001444,0,'2013-07-06 12:44:33',NULL,NULL),(69412,'83629','S','Horseshoe Bend','D','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.928831,-116.292814,0,'2013-07-06 12:44:34',NULL,NULL),(79469,'98855','S','Nighthawk','N','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.704499,-119.439348,0,'2013-07-06 12:44:34',NULL,NULL),(39705,'45042','S','Middletown','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.545160,-84.439260,0,'2013-07-06 12:44:32',NULL,NULL),(4602,'03588','S','Dummer','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.639911,-71.148517,0,'2013-07-06 12:44:30',NULL,NULL),(15374,'16301','S','Oil Creek','N','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.433864,-79.705846,0,'2013-07-06 12:44:31',NULL,NULL),(20482,'21045','S','Columbia','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.204277,-76.834440,0,'2013-07-06 12:44:31',NULL,NULL),(9521,'10018','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(7008,'06258','P','Pomfret','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.905344,-71.959304,0,'2013-07-06 12:44:30',NULL,NULL),(75118,'93549','P','Olancha','D','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.320833,-118.025556,0,'2013-07-06 12:44:34',NULL,NULL),(74657,'92842','P','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.778341,-117.945580,0,'2013-07-06 12:44:34',NULL,NULL),(68715,'82071','P','University','N','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.422527,-105.607196,0,'2013-07-06 12:44:34',NULL,NULL),(58246,'68359','S','Friend','D','Saline','31151','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.640909,-97.269963,0,'2013-07-06 12:44:33',NULL,NULL),(56980,'66202','S','Mission','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(192,'00623','S','Urb Borinquen','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(38491,'43667','U','Dept of Public Utilities','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.650895,-83.535228,0,'2013-07-06 12:44:32',NULL,NULL),(12884,'13328','S','Deansboro','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.997626,-75.428706,0,'2013-07-06 12:44:30',NULL,NULL),(6127,'05459','S','Highgate Falls','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(24275,'26851','S','Wardensville','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.075211,-78.596294,0,'2013-07-06 12:44:31',NULL,NULL),(60986,'72110','S','Wesley Chapel','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(64204,'76255','S','Nocona','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.796166,-97.713828,0,'2013-07-06 12:44:34',NULL,NULL),(78333,'98001','S','Federal Way','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.306800,-122.260607,0,'2013-07-06 12:44:34',NULL,NULL),(9306,'09717','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(47428,'54667','S','Westby','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.653908,-90.859455,0,'2013-07-06 12:44:32',NULL,NULL),(49496,'56662','S','Crooked Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.846424,-93.901398,0,'2013-07-06 12:44:33',NULL,NULL),(51016,'58705','S','Minot A F B','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230700,-101.307900,0,'2013-07-06 12:44:33',NULL,NULL),(55095,'63303','S','Harvester','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.752200,-90.537720,0,'2013-07-06 12:44:33',NULL,NULL),(67854,'80821','S','Punkin Center','N','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.942890,-103.269910,0,'2013-07-06 12:44:34',NULL,NULL),(80125,'99767','P','Rampart','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.492007,-149.856480,0,'2013-07-06 12:44:34',NULL,NULL),(14408,'15064','S','Morgan','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.356794,-80.148263,0,'2013-07-06 12:44:31',NULL,NULL),(21592,'22845','S','Orkney Spgs','N','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.788542,-78.822829,0,'2013-07-06 12:44:31',NULL,NULL),(21697,'22967','S','Roseland','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(50800,'58448','S','Karnak','N','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.269722,-98.194167,0,'2013-07-06 12:44:33',NULL,NULL),(68699,'82055','P','Centennial','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.302928,-106.137752,0,'2013-07-06 12:44:34',NULL,NULL),(72353,'89020','S','Amargosa Valley','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.490016,-116.390342,0,'2013-07-06 12:44:34',NULL,NULL),(37250,'41558','S','Ransom','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.593680,-82.170026,0,'2013-07-06 12:44:32',NULL,NULL),(34073,'38150','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.147314,-90.048201,0,'2013-07-06 12:44:32',NULL,NULL),(23386,'25309','S','S Charleston','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.339160,-81.753480,0,'2013-07-06 12:44:31',NULL,NULL),(26603,'29260','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.026058,-80.967646,0,'2013-07-06 12:44:31',NULL,NULL),(25023,'27888','S','Walstonburg','D','Greene','37079','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.581146,-77.704479,0,'2013-07-06 12:44:31',NULL,NULL),(47158,'54467','S','Plover','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.439810,-89.544706,0,'2013-07-06 12:44:32',NULL,NULL),(61372,'72522','S','Charlotte','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.804100,-91.476480,0,'2013-07-06 12:44:33',NULL,NULL),(75336,'93794','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.787969,-119.829498,0,'2013-07-06 12:44:34',NULL,NULL),(73177,'90401','S','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.016630,-118.495341,0,'2013-07-06 12:44:34',NULL,NULL),(71149,'86032','P','Joseph City','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.964299,-110.330963,0,'2013-07-06 12:44:34',NULL,NULL),(69777,'84058','S','Lakeview','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(68021,'80925','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739647,-104.635922,0,'2013-07-06 12:44:34',NULL,NULL),(38018,'43010','P','Catawba','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.001052,-83.622964,0,'2013-07-06 12:44:32',NULL,NULL),(16220,'17074','S','Everhartville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(34932,'39039','S','Benton','D','Yazoo','28163','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.871673,-90.468877,0,'2013-07-06 12:44:32',NULL,NULL),(54248,'62670','S','Curran','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.734757,-89.908806,0,'2013-07-06 12:44:33',NULL,NULL),(53901,'62363','S','Pittsfield','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.609331,-90.807822,0,'2013-07-06 12:44:33',NULL,NULL),(34466,'38663','S','Gravestown','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.739520,-88.973100,0,'2013-07-06 12:44:32',NULL,NULL),(27163,'29835','S','Mc Cormick','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.911159,-82.290467,0,'2013-07-06 12:44:31',NULL,NULL),(27124,'29801','S','Aiken','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.564827,-81.709984,0,'2013-07-06 12:44:31',NULL,NULL),(21108,'22060','S','Fort Belvoir','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.712147,-77.158616,0,'2013-07-06 12:44:31',NULL,NULL),(22224,'23602','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.124608,-76.519972,0,'2013-07-06 12:44:31',NULL,NULL),(42048,'47446','S','Lawrenceport','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.735506,-86.473305,0,'2013-07-06 12:44:32',NULL,NULL),(42817,'48059','S','Lakeport','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(76057,'95194','U','California Water Service','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.343655,-121.881178,0,'2013-07-06 12:44:34',NULL,NULL),(48698,'55936','S','Grand Meadow','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.704937,-92.570979,0,'2013-07-06 12:44:33',NULL,NULL),(19462,'20132','S','Hillsboro','A','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.163955,-77.727182,0,'2013-07-06 12:44:31',NULL,NULL),(19179,'19802','S','Edgemoor','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.755190,-75.530870,0,'2013-07-06 12:44:31',NULL,NULL),(66859,'79174','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.203258,-101.834253,0,'2013-07-06 12:44:34',NULL,NULL),(63309,'75566','S','Marietta','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.196373,-94.536138,0,'2013-07-06 12:44:33',NULL,NULL),(51436,'59464','S','Moore','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.971054,-109.694698,0,'2013-07-06 12:44:33',NULL,NULL),(43768,'49027','P','Breedsville','D','Van Buren','26159','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.352513,-86.063283,0,'2013-07-06 12:44:32',NULL,NULL),(1795,'00783','S','Urb Las Brisas','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(4422,'03231','P','E Andover','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.480087,-71.768205,0,'2013-07-06 12:44:30',NULL,NULL),(4061,'02645','S','Harwich','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.703441,-70.062208,0,'2013-07-06 12:44:30',NULL,NULL),(63864,'75990','U','Gib Lewis Prison','N','Tyler','48457','Texas','TX','48','0000','409','Central',-6.0,'Y',30.773964,-94.423527,0,'2013-07-06 12:44:34',NULL,NULL),(59969,'71316','S','New Era','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.260852,-91.766700,0,'2013-07-06 12:44:33',NULL,NULL),(39370,'44639','P','Leesville','D','Carroll','39019','Ohio','OH','39','1320','740','Eastern',-5.0,'Y',40.444048,-81.219711,0,'2013-07-06 12:44:32',NULL,NULL),(3330,'01535','S','North Brookfield','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.267155,-72.075987,0,'2013-07-06 12:44:30',NULL,NULL),(9232,'09554','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(40666,'46052','S','Lebanon','D','Boone','18011','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.051603,-86.470531,0,'2013-07-06 12:44:32',NULL,NULL),(49326,'56552','S','Hitterdal','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',47.020788,-96.316650,0,'2013-07-06 12:44:33',NULL,NULL),(51721,'60010','S','N Barrington','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(8823,'08620','S','Groveville','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.178809,-74.659973,0,'2013-07-06 12:44:30',NULL,NULL),(75188,'93612','S','Clovis','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.828991,-119.666341,0,'2013-07-06 12:44:34',NULL,NULL),(64176,'76228','S','Bellevue','D','Clay','48077','Texas','TX','48','0000','940','Central',-6.0,'Y',33.593612,-98.166185,0,'2013-07-06 12:44:34',NULL,NULL),(59930,'71292','S','Cheniere','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(53450,'61884','S','White Heath','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.101302,-88.507950,0,'2013-07-06 12:44:33',NULL,NULL),(50884,'58531','S','Coleharbor','D','McLean','38055','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.516137,-100.918707,0,'2013-07-06 12:44:33',NULL,NULL),(38793,'44060','S','Mentor','D','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.722620,-81.356520,0,'2013-07-06 12:44:32',NULL,NULL),(8891,'08724','S','Wall Township','A','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.086348,-74.118215,0,'2013-07-06 12:44:30',NULL,NULL),(34109,'38182','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145303,-89.970637,0,'2013-07-06 12:44:32',NULL,NULL),(23723,'25907','P','Prince','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.858917,-81.051519,0,'2013-07-06 12:44:31',NULL,NULL),(12229,'12814','S','Bolton Lndg','A','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.589700,-73.668480,0,'2013-07-06 12:44:30',NULL,NULL),(46699,'53789','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077115,-89.384153,0,'2013-07-06 12:44:32',NULL,NULL),(208,'00623','S','Villa Luisa','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(79602,'99102','P','Albion','D','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.796284,-117.248966,0,'2013-07-06 12:44:34',NULL,NULL),(72691,'89445','S','Winnemucca Colony','N','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.125560,-117.786720,0,'2013-07-06 12:44:34',NULL,NULL),(72050,'88101','S','Clovis','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.405380,-103.248420,0,'2013-07-06 12:44:34',NULL,NULL),(71785,'87560','S','El Ancon','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(69240,'83420','S','Lamont','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.042760,-111.375420,0,'2013-07-06 12:44:34',NULL,NULL),(60648,'71909','S','Hot Springs National Park','A','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.610580,-93.014760,0,'2013-07-06 12:44:33',NULL,NULL),(52902,'61360','S','Seneca','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.329446,-88.610406,0,'2013-07-06 12:44:33',NULL,NULL),(33690,'37752','S','Harrogate','D','Claiborne','47025','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.594620,-83.662410,0,'2013-07-06 12:44:32',NULL,NULL),(12009,'12496','S','Windham','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.310080,-74.288880,0,'2013-07-06 12:44:30',NULL,NULL),(10062,'10177','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738338,-73.985633,0,'2013-07-06 12:44:30',NULL,NULL),(44782,'50216','S','Panora','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.692194,-94.362644,0,'2013-07-06 12:44:32',NULL,NULL),(50042,'57433','S','Sand Lake','N','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.679320,-98.308680,0,'2013-07-06 12:44:33',NULL,NULL),(79833,'99519','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.189183,-149.987503,0,'2013-07-06 12:44:34',NULL,NULL),(69962,'84119','S','S Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.692079,-111.947832,0,'2013-07-06 12:44:34',NULL,NULL),(68849,'82604','S','Moneta','A','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.826825,-106.381639,0,'2013-07-06 12:44:34',NULL,NULL),(67000,'79506','S','Blackwell','D','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.080538,-100.322878,0,'2013-07-06 12:44:34',NULL,NULL),(65393,'77554','S','Tiki Island','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.207422,-94.965163,0,'2013-07-06 12:44:34',NULL,NULL),(61545,'72686','S','Witts Springs','D','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.789648,-92.835353,0,'2013-07-06 12:44:33',NULL,NULL),(28625,'31727','P','Brookfield','D','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.440490,-83.502790,0,'2013-07-06 12:44:32',NULL,NULL),(27095,'29714','S','Fort Lawn','D','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.701218,-80.913514,0,'2013-07-06 12:44:31',NULL,NULL),(22247,'23665','S','Hampton','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.080265,-76.373645,0,'2013-07-06 12:44:31',NULL,NULL),(21149,'22118','U','Merrifield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.839359,-77.336627,0,'2013-07-06 12:44:31',NULL,NULL),(20624,'21214','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.354090,-76.560840,0,'2013-07-06 12:44:31',NULL,NULL),(41436,'46859','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.070893,-85.164844,0,'2013-07-06 12:44:32',NULL,NULL),(43671,'48860','S','Muir','D','Ionia','26067','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.031986,-84.922141,0,'2013-07-06 12:44:32',NULL,NULL),(47091,'54436','S','Lynn','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.569207,-90.452286,0,'2013-07-06 12:44:32',NULL,NULL),(53377,'61790','U','IL State University','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.517290,-88.999162,0,'2013-07-06 12:44:33',NULL,NULL),(72032,'88054','P','Radium Springs','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.641333,-107.073950,0,'2013-07-06 12:44:34',NULL,NULL),(50704,'58365','S','Crocus','N','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.857949,-99.129655,0,'2013-07-06 12:44:33',NULL,NULL),(44538,'49969','S','Watersmeet','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.268905,-89.174316,0,'2013-07-06 12:44:32',NULL,NULL),(26578,'29217','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.010724,-81.036122,0,'2013-07-06 12:44:31',NULL,NULL),(27921,'30513','S','Blue Ridge','D','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.843508,-84.336171,0,'2013-07-06 12:44:31',NULL,NULL),(30520,'33405','S','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.671543,-80.059678,0,'2013-07-06 12:44:32',NULL,NULL),(34463,'38661','S','Red Banks','D','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.955910,-89.516040,0,'2013-07-06 12:44:32',NULL,NULL),(34041,'38135','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.229541,-89.853081,0,'2013-07-06 12:44:32',NULL,NULL),(68612,'81621','S','Basalt','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.375819,-106.992926,0,'2013-07-06 12:44:34',NULL,NULL),(65487,'77650','P','Port Bolivar','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.449643,-94.635997,0,'2013-07-06 12:44:34',NULL,NULL),(61448,'72615','P','Bergman','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.264197,-93.103432,0,'2013-07-06 12:44:33',NULL,NULL),(28947,'32183','P','Ocklawaha','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.043234,-81.929375,0,'2013-07-06 12:44:32',NULL,NULL),(27300,'30012','S','Conyers','D','Rockdale','13247','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.706453,-84.005117,0,'2013-07-06 12:44:31',NULL,NULL),(23019,'24829','P','Eckman','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.442847,-81.595444,0,'2013-07-06 12:44:31',NULL,NULL),(18676,'19183','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951604,-75.168997,0,'2013-07-06 12:44:31',NULL,NULL),(6992,'06250','S','Mansfield Center','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780580,-72.210300,0,'2013-07-06 12:44:30',NULL,NULL),(55502,'63775','S','Longtown','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(54468,'62858','S','Hoosier','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.826300,-88.483680,0,'2013-07-06 12:44:33',NULL,NULL),(47148,'54463','S','Pelican Lake','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.502399,-89.159806,0,'2013-07-06 12:44:32',NULL,NULL),(41171,'46705','S','Steubenville','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.514265,-85.072002,0,'2013-07-06 12:44:32',NULL,NULL),(39228,'44417','S','Farmdale','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.425790,-80.661237,0,'2013-07-06 12:44:32',NULL,NULL),(4569,'03468','P','West Peterborough','D','Hillsborough','33011','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.871737,-71.969706,0,'2013-07-06 12:44:30',NULL,NULL),(74889,'93285','S','Wofford Hts','A','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.713219,-118.475236,0,'2013-07-06 12:44:34',NULL,NULL),(72463,'89120','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.084157,-115.099291,0,'2013-07-06 12:44:34',NULL,NULL),(61206,'72295','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.745708,-92.279780,0,'2013-07-06 12:44:33',NULL,NULL),(40594,'45882','S','Rockford','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.672372,-84.655712,0,'2013-07-06 12:44:32',NULL,NULL),(40171,'45368','S','South Charleston','D','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.847694,-83.658868,0,'2013-07-06 12:44:32',NULL,NULL),(24128,'26554','S','Monongah','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.476203,-80.152059,0,'2013-07-06 12:44:31',NULL,NULL),(19849,'20509','U','White House Ofc Staff','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892273,-77.037823,0,'2013-07-06 12:44:31',NULL,NULL),(2410,'00953','S','Colinas de Plata','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(76525,'95646','P','Pioneer','A','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(43776,'49035','P','Cloverdale','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.552666,-85.385214,0,'2013-07-06 12:44:32',NULL,NULL),(6261,'05602','S','Middlesex Center','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.270220,-72.576420,0,'2013-07-06 12:44:30',NULL,NULL),(15352,'16242','S','Climax','A','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.006608,-79.331190,0,'2013-07-06 12:44:31',NULL,NULL),(29545,'32802','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.543808,-81.377151,0,'2013-07-06 12:44:32',NULL,NULL),(29599,'32833','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.486350,-81.084730,0,'2013-07-06 12:44:32',NULL,NULL),(37849,'42501','S','Elihu','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(15902,'17012','U','Book of Month','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.181354,-76.990646,0,'2013-07-06 12:44:31',NULL,NULL),(76929,'96016','S','Cassel','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.905106,-121.498735,0,'2013-07-06 12:44:34',NULL,NULL),(66246,'78572','S','Citrus City','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(52296,'60540','S','Naperville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.774282,-88.147187,0,'2013-07-06 12:44:33',NULL,NULL),(45414,'51052','S','Luton','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.304178,-96.275313,0,'2013-07-06 12:44:32',NULL,NULL),(13577,'13843','S','Whites Store','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(15480,'16436','S','Spring Creek','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.844751,-79.565546,0,'2013-07-06 12:44:31',NULL,NULL),(17206,'17821','S','West Hemlock','N','Montour','42093','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.974300,-76.613400,0,'2013-07-06 12:44:31',NULL,NULL),(16053,'17046','S','Swatara Township','A','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.357882,-76.432449,0,'2013-07-06 12:44:31',NULL,NULL),(1587,'00769','S','Est de Coamo','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(12660,'13120','S','Onondaga Nation','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(79070,'98431','U','Madigan Army Medical Center','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(75709,'94575','P','Moraga','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.845244,-122.122691,0,'2013-07-06 12:44:34',NULL,NULL),(73304,'90806','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.805737,-118.181738,0,'2013-07-06 12:44:34',NULL,NULL),(67819,'80755','S','Vernon','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.927165,-102.357424,0,'2013-07-06 12:44:34',NULL,NULL),(65695,'78006','S','Fair Oaks','A','Kendall','48259','Texas','TX','48','7240','830','Central',-6.0,'Y',29.718030,-98.651343,0,'2013-07-06 12:44:34',NULL,NULL),(62035,'73503','S','Lawton','A','Comanche','40031','Oklahoma','OK','40','4200','580','Central',-6.0,'Y',34.663560,-98.442960,0,'2013-07-06 12:44:33',NULL,NULL),(54981,'63124','S','Ladue','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.642678,-90.378302,0,'2013-07-06 12:44:33',NULL,NULL),(52197,'60475','S','Chicago Heights','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466203,-87.638399,0,'2013-07-06 12:44:33',NULL,NULL),(50280,'57649','S','Glendo','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.603149,-102.825211,0,'2013-07-06 12:44:33',NULL,NULL),(49813,'57201','S','Waverly','A','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(17651,'18074','S','Perkiomenvlle','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.319879,-75.517672,0,'2013-07-06 12:44:31',NULL,NULL),(11667,'12140','S','Poestenkill','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.695254,-73.578996,0,'2013-07-06 12:44:30',NULL,NULL),(38602,'43840','S','Stone Creek','D','Tuscarawas','39157','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.407646,-81.595511,0,'2013-07-06 12:44:32',NULL,NULL),(37091,'41339','S','Jackson','D','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(35728,'39701','S','Columbus AFB','A','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(9568,'10025','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.799621,-73.970312,0,'2013-07-06 12:44:30',NULL,NULL),(77931,'97331','S','Corvallis','D','Benton','41003','Oregon','OR','41','1890','541','Pacific',-8.0,'Y',44.565718,-123.280906,0,'2013-07-06 12:44:34',NULL,NULL),(69022,'83213','S','Arco','D','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.636568,-113.293312,0,'2013-07-06 12:44:34',NULL,NULL),(51479,'59544','S','Whitewater','D','Phillips','30071','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.874101,-107.391343,0,'2013-07-06 12:44:33',NULL,NULL),(40938,'46291','U','Rca Mfg Co','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.782399,-86.047878,0,'2013-07-06 12:44:32',NULL,NULL),(22338,'23873','P','Meredithville','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.805341,-77.957105,0,'2013-07-06 12:44:31',NULL,NULL),(19340,'20037','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904693,-77.050778,0,'2013-07-06 12:44:31',NULL,NULL),(3887,'02379','S','W Bridgewater','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.018468,-71.013855,0,'2013-07-06 12:44:30',NULL,NULL),(8260,'08008','S','Long Beach Township','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(27289,'30004','S','Milton','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.122744,-84.296757,0,'2013-07-06 12:44:31',NULL,NULL),(9768,'10104','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(13974,'14480','S','Lakeville','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.834968,-77.704898,0,'2013-07-06 12:44:31',NULL,NULL),(73174,'90310','P','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.927761,-118.319917,0,'2013-07-06 12:44:34',NULL,NULL),(60256,'71440','P','Joyce','D','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.940430,-92.599937,0,'2013-07-06 12:44:33',NULL,NULL),(52427,'60654','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.887141,-87.636511,0,'2013-07-06 12:44:33',NULL,NULL),(43208,'48306','S','Oakland Township','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(41595,'47106','S','Starlight','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.454142,-85.870973,0,'2013-07-06 12:44:32',NULL,NULL),(8800,'08605','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.219274,-74.765178,0,'2013-07-06 12:44:30',NULL,NULL),(33435,'37304','S','Bakewell','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.382222,-85.108889,0,'2013-07-06 12:44:32',NULL,NULL),(30428,'33329','P','Cooper City','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111170,-80.274605,0,'2013-07-06 12:44:32',NULL,NULL),(30283,'33257','P','Quail Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.613248,-80.347422,0,'2013-07-06 12:44:32',NULL,NULL),(29697,'32936','P','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.137568,-80.650157,0,'2013-07-06 12:44:32',NULL,NULL),(46696,'53786','U','Wi Dept Revenue Box 34','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077126,-89.380448,0,'2013-07-06 12:44:32',NULL,NULL),(77081,'96130','S','Spaulding','N','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.417140,-120.641220,0,'2013-07-06 12:44:34',NULL,NULL),(75236,'93648','S','Parlier','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.616031,-119.530882,0,'2013-07-06 12:44:34',NULL,NULL),(74248,'92332','S','Essex','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.822579,-115.069722,0,'2013-07-06 12:44:34',NULL,NULL),(49583,'56735','S','Orleans','A','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.912614,-96.843421,0,'2013-07-06 12:44:33',NULL,NULL),(33556,'37406','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.060724,-85.245113,0,'2013-07-06 12:44:32',NULL,NULL),(21205,'22199','P','Lorton','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.701995,-77.230356,0,'2013-07-06 12:44:31',NULL,NULL),(27997,'30599','U','Commerce','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.205200,-83.460610,0,'2013-07-06 12:44:31',NULL,NULL),(62500,'74363','S','Quapaw','D','Ottawa','40115','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.942000,-94.732920,0,'2013-07-06 12:44:33',NULL,NULL),(56859,'66010','S','Blue Mound','D','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.095828,-95.004477,0,'2013-07-06 12:44:33',NULL,NULL),(51951,'60133','S','Hanover Park','D','Cook','17031','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.966626,-88.161383,0,'2013-07-06 12:44:33',NULL,NULL),(51771,'60037','S','Fort Sheridan','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.209412,-87.806565,0,'2013-07-06 12:44:33',NULL,NULL),(47137,'54455','S','Peplin','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(10569,'11020','S','Great Nk','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.786686,-73.725770,0,'2013-07-06 12:44:30',NULL,NULL),(14818,'15422','P','Chestnut Ridge','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.978300,-79.810140,0,'2013-07-06 12:44:31',NULL,NULL),(29237,'32433','S','Defuniak Spgs','A','Walton','12131','Florida','FL','12','0000','850','Central',-6.0,'Y',30.723150,-86.120366,0,'2013-07-06 12:44:32',NULL,NULL),(26350,'29067','S','White Bluff','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.498309,-80.520734,0,'2013-07-06 12:44:31',NULL,NULL),(64710,'76862','S','Millersview','D','Concho','48095','Texas','TX','48','0000','325','Central',-6.0,'Y',31.450210,-99.708549,0,'2013-07-06 12:44:34',NULL,NULL),(49065,'56312','S','Belgrade','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.486795,-94.955270,0,'2013-07-06 12:44:33',NULL,NULL),(44623,'50061','S','West Des Moines','A','Warren','19181','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.489268,-93.753860,0,'2013-07-06 12:44:32',NULL,NULL),(679,'00683','S','Urb Santa Maria','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(34304,'38545','S','Bloomington Springs','D','Putnam','47141','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.343846,-85.651469,0,'2013-07-06 12:44:32',NULL,NULL),(31411,'34238','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.247430,-82.489728,0,'2013-07-06 12:44:32',NULL,NULL),(30638,'33446','S','West Delray Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.451567,-80.173388,0,'2013-07-06 12:44:32',NULL,NULL),(23657,'25817','S','Bolt','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.780267,-81.413406,0,'2013-07-06 12:44:31',NULL,NULL),(23244,'25113','S','Ivydale','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.529600,-81.032880,0,'2013-07-06 12:44:31',NULL,NULL),(8606,'08234','S','Egg Hbr Twp','A','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.413230,-74.575699,0,'2013-07-06 12:44:30',NULL,NULL),(76246,'95397','U','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.660766,-120.993431,0,'2013-07-06 12:44:34',NULL,NULL),(70694,'85260','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.599601,-111.889956,0,'2013-07-06 12:44:34',NULL,NULL),(67427,'80161','P','Centennial','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.596945,-104.961633,0,'2013-07-06 12:44:34',NULL,NULL),(64738,'76901','S','San Angelo','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.465353,-100.493525,0,'2013-07-06 12:44:34',NULL,NULL),(63247,'75481','S','Sulphur Bluff','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.337441,-95.361881,0,'2013-07-06 12:44:33',NULL,NULL),(62170,'73743','P','Hillsdale','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.561817,-97.989483,0,'2013-07-06 12:44:33',NULL,NULL),(48379,'55569','P','Maple Grove','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.115998,-93.397431,0,'2013-07-06 12:44:33',NULL,NULL),(41372,'46795','S','Shady Nook','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(19349,'20044','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895999,-77.025808,0,'2013-07-06 12:44:31',NULL,NULL),(21687,'22963','S','Lake Montcelo','N','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(34237,'38379','S','Stantonville','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.184702,-88.443973,0,'2013-07-06 12:44:32',NULL,NULL),(27202,'29904','P','Beaufort','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.457864,-80.801400,0,'2013-07-06 12:44:31',NULL,NULL),(10307,'10533','S','East Irvington','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.041760,-73.855752,0,'2013-07-06 12:44:30',NULL,NULL),(5834,'05084','S','West Hartford','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.712159,-72.404948,0,'2013-07-06 12:44:30',NULL,NULL),(7870,'07507','P','Hawthorne','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.916667,-74.172222,0,'2013-07-06 12:44:30',NULL,NULL),(41344,'46787','S','South Whitley','D','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.085770,-85.618016,0,'2013-07-06 12:44:32',NULL,NULL),(45162,'50593','P','Varina','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.630778,-94.816716,0,'2013-07-06 12:44:32',NULL,NULL),(47936,'55115','S','Grant','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.070200,-92.952900,0,'2013-07-06 12:44:33',NULL,NULL),(77096,'96140','P','Agate Bay','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.227511,-120.081240,0,'2013-07-06 12:44:34',NULL,NULL),(73339,'90853','P','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.760400,-118.132702,0,'2013-07-06 12:44:34',NULL,NULL),(69514,'83719','P','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.546011,-116.286598,0,'2013-07-06 12:44:34',NULL,NULL),(68516,'81329','P','Marvel','D','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.113282,-108.124637,0,'2013-07-06 12:44:34',NULL,NULL),(67005,'79512','S','Buford','N','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.394374,-100.859048,0,'2013-07-06 12:44:34',NULL,NULL),(54518,'62875','S','Carrigan','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.753045,-89.096352,0,'2013-07-06 12:44:33',NULL,NULL),(52137,'60435','S','Shorewood','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.552040,-88.111620,0,'2013-07-06 12:44:33',NULL,NULL),(39899,'45215','S','Lincoln Heights','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(38234,'43232','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.917023,-82.875392,0,'2013-07-06 12:44:32',NULL,NULL),(12060,'12534','S','Hudson','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.248254,-73.774447,0,'2013-07-06 12:44:30',NULL,NULL),(645,'00682','S','Urb Miradero Hls','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(22750,'24413','S','Blue Grass','D','Highland','51091','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.530184,-79.600070,0,'2013-07-06 12:44:31',NULL,NULL),(50680,'58344','S','Mapes','A','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.042397,-98.341319,0,'2013-07-06 12:44:33',NULL,NULL),(76417,'95562','S','Rio Dell','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.504206,-124.107339,0,'2013-07-06 12:44:34',NULL,NULL),(68494,'81301','S','Hermosa','N','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.326840,-107.831460,0,'2013-07-06 12:44:34',NULL,NULL),(35852,'39819','S','Bdge','N','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.901653,-84.567519,0,'2013-07-06 12:44:32',NULL,NULL),(12718,'13153','P','Skan Falls','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.994912,-76.452863,0,'2013-07-06 12:44:30',NULL,NULL),(10897,'11425','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674365,-73.771894,0,'2013-07-06 12:44:30',NULL,NULL),(9803,'10110','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(57885,'67629','S','Clayton','D','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.678805,-100.296418,0,'2013-07-06 12:44:33',NULL,NULL),(60841,'72040','S','Sand Hill','N','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(72412,'89048','S','Crystal','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.254480,-116.018558,0,'2013-07-06 12:44:34',NULL,NULL),(65273,'77476','P','Valley Lodge','N','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.683333,-95.966667,0,'2013-07-06 12:44:34',NULL,NULL),(60895,'72069','S','Pine City','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(319,'00646','S','Villa Plata','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(16557,'17312','P','Craley','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.945887,-76.510486,0,'2013-07-06 12:44:31',NULL,NULL),(31300,'34093','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(63546,'75763','S','Kickapoo','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(52116,'60423','S','Frankfort','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.491927,-87.833795,0,'2013-07-06 12:44:33',NULL,NULL),(49976,'57358','P','Lane','D','Jerauld','46073','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.073104,-98.405479,0,'2013-07-06 12:44:33',NULL,NULL),(48460,'55713','P','Buhl','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.493443,-92.773072,0,'2013-07-06 12:44:33',NULL,NULL),(48333,'55459','P','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.986773,-93.271401,0,'2013-07-06 12:44:33',NULL,NULL),(20412,'20905','S','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.101870,-76.991042,0,'2013-07-06 12:44:31',NULL,NULL),(30150,'33168','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.875268,-80.201839,0,'2013-07-06 12:44:32',NULL,NULL),(13640,'13905','S','West Chenango','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.160620,-75.936480,0,'2013-07-06 12:44:31',NULL,NULL),(51156,'58852','S','Tioga','D','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.387360,-102.971460,0,'2013-07-06 12:44:33',NULL,NULL),(40636,'46031','S','Ekin','N','Hamilton','18057','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.162140,-85.935600,0,'2013-07-06 12:44:32',NULL,NULL),(8019,'07724','S','Vail Homes','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.299859,-74.070754,0,'2013-07-06 12:44:30',NULL,NULL),(52952,'61415','S','Greenbush','N','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.660240,-90.433285,0,'2013-07-06 12:44:33',NULL,NULL),(30548,'33410','S','West Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.843134,-80.087669,0,'2013-07-06 12:44:32',NULL,NULL),(67380,'80121','S','Greenwood Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.612173,-104.954964,0,'2013-07-06 12:44:34',NULL,NULL),(26275,'29014','S','Douglass','N','Chester','45023','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.573234,-80.987145,0,'2013-07-06 12:44:31',NULL,NULL),(5769,'05045','S','Fairlee','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.916667,-72.150000,0,'2013-07-06 12:44:30',NULL,NULL),(8375,'08054','S','Mount Laurel Township','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.946438,-74.915955,0,'2013-07-06 12:44:30',NULL,NULL),(77056,'96118','S','Loyalton','D','Sierra','06091','California','CA','06','0000','530','Pacific',-8.0,'Y',39.670023,-120.236806,0,'2013-07-06 12:44:34',NULL,NULL),(31632,'34712','P','Clermont','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.553199,-81.757548,0,'2013-07-06 12:44:32',NULL,NULL),(39018,'44143','S','Euclid','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(6536,'05833','S','E Charleston','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.823299,-71.986472,0,'2013-07-06 12:44:30',NULL,NULL),(66131,'78460','P','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.831211,-97.596211,0,'2013-07-06 12:44:34',NULL,NULL),(54928,'63105','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.643582,-90.328636,0,'2013-07-06 12:44:33',NULL,NULL),(38417,'43543','S','Montpelier','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.590070,-84.611596,0,'2013-07-06 12:44:32',NULL,NULL),(15758,'16915','S','Coudersport','D','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(14766,'15339','P','Hendersonville','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.298920,-80.154703,0,'2013-07-06 12:44:31',NULL,NULL),(36460,'40729','S','Symbol','A','Laurel','21125','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.204331,-84.118241,0,'2013-07-06 12:44:32',NULL,NULL),(7665,'07088','S','Vauxhall','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.717813,-74.284932,0,'2013-07-06 12:44:30',NULL,NULL),(11744,'12186','S','Voorheesville','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.624780,-73.969800,0,'2013-07-06 12:44:30',NULL,NULL),(21847,'23138','S','Peary','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.371944,-76.279722,0,'2013-07-06 12:44:31',NULL,NULL),(54037,'62463','S','Stewardson','D','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.266470,-88.628735,0,'2013-07-06 12:44:33',NULL,NULL),(37488,'42022','P','Bandana','D','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.147896,-88.943305,0,'2013-07-06 12:44:32',NULL,NULL),(61541,'72683','S','Vendor','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.941766,-93.109327,0,'2013-07-06 12:44:33',NULL,NULL),(31856,'35117','S','Mount Olive','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.668747,-86.868208,0,'2013-07-06 12:44:32',NULL,NULL),(47149,'54464','P','Phlox','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.049754,-89.016863,0,'2013-07-06 12:44:32',NULL,NULL),(41541,'47003','S','West College Corner','D','Union','18161','Indiana','IN','18','0000','317','Eastern',-5.0,'Y',39.504861,-84.860620,0,'2013-07-06 12:44:32',NULL,NULL),(14279,'14857','P','Lakemont','D','Yates','36123','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.518741,-76.928255,0,'2013-07-06 12:44:31',NULL,NULL),(70676,'85236','P','Higley','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.330307,-111.696802,0,'2013-07-06 12:44:34',NULL,NULL),(31764,'35005','S','Adamsville','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.592136,-86.961171,0,'2013-07-06 12:44:32',NULL,NULL),(57397,'66757','S','Neodesha','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.428154,-95.680875,0,'2013-07-06 12:44:33',NULL,NULL),(39036,'44146','S','Oakwood Village','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(75237,'93649','P','Piedra','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.823999,-119.355050,0,'2013-07-06 12:44:34',NULL,NULL),(58664,'68881','S','Westerville','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.414776,-99.392022,0,'2013-07-06 12:44:33',NULL,NULL),(57949,'67747','S','Winona','A','Logan','20109','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.960076,-101.064031,0,'2013-07-06 12:44:33',NULL,NULL),(25611,'28458','S','Greenevers','A','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.825637,-78.025004,0,'2013-07-06 12:44:31',NULL,NULL),(23358,'25267','S','Lockney','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.891624,-80.957193,0,'2013-07-06 12:44:31',NULL,NULL),(22981,'24737','P','Montcalm','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.355619,-81.254095,0,'2013-07-06 12:44:31',NULL,NULL),(21444,'22578','S','Whitestone','N','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.650000,-76.383333,0,'2013-07-06 12:44:31',NULL,NULL),(65165,'77407','S','Richmond','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.622726,-95.647873,0,'2013-07-06 12:44:34',NULL,NULL),(4926,'04079','S','Harpswell','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.825960,-69.953763,0,'2013-07-06 12:44:30',NULL,NULL),(1514,'00754','S','Hacienda Florida','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(71876,'87731','S','El Porvenir','N','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.696667,-105.382222,0,'2013-07-06 12:44:34',NULL,NULL),(5141,'04415','P','Brownville Junction','D','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.349887,-69.058546,0,'2013-07-06 12:44:30',NULL,NULL),(57751,'67443','S','Galva','D','McPherson','20113','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.386476,-97.550684,0,'2013-07-06 12:44:33',NULL,NULL),(42513,'47849','S','Dodds Bridge','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.214283,-87.524549,0,'2013-07-06 12:44:32',NULL,NULL),(67906,'80903','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.831839,-104.818927,0,'2013-07-06 12:44:34',NULL,NULL),(77649,'97016','S','Birkenfeld','A','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.996389,-123.255278,0,'2013-07-06 12:44:34',NULL,NULL),(78606,'98191','U','Qwest','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.613607,-122.335017,0,'2013-07-06 12:44:34',NULL,NULL),(4250,'02877','S','Slocum','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.536514,-71.527238,0,'2013-07-06 12:44:30',NULL,NULL),(19406,'20077','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.919481,-76.994663,0,'2013-07-06 12:44:31',NULL,NULL),(71826,'87575','S','Tira Amarilla','A','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.727222,-106.532778,0,'2013-07-06 12:44:34',NULL,NULL),(57190,'66417','S','Corning','D','Nemaha','20131','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.640946,-96.094728,0,'2013-07-06 12:44:33',NULL,NULL),(52583,'61001','S','Apple River','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.478132,-90.106068,0,'2013-07-06 12:44:33',NULL,NULL),(73634,'91416','P','Encino','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.178039,-118.517445,0,'2013-07-06 12:44:34',NULL,NULL),(78172,'97638','S','Silver Lake','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.132050,-121.043120,0,'2013-07-06 12:44:34',NULL,NULL),(29905,'33051','P','Key Colony Beach','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.721329,-81.021245,0,'2013-07-06 12:44:32',NULL,NULL),(77761,'97112','S','Cloverdale','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.219748,-123.926658,0,'2013-07-06 12:44:34',NULL,NULL),(11113,'11702','S','Oak Beach','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(18645,'19170','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952013,-75.183323,0,'2013-07-06 12:44:31',NULL,NULL),(56158,'64861','S','Rocky Comfort','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.701000,-94.121763,0,'2013-07-06 12:44:33',NULL,NULL),(34921,'38964','S','Vance','D','Quitman','28119','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.016683,-90.432367,0,'2013-07-06 12:44:32',NULL,NULL),(60803,'72031','S','Crabtree','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.613600,-92.505780,0,'2013-07-06 12:44:33',NULL,NULL),(21822,'23110','S','Mattaponi','D','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.608056,-76.778889,0,'2013-07-06 12:44:31',NULL,NULL),(59672,'71058','P','Minden','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.612262,-93.295173,0,'2013-07-06 12:44:33',NULL,NULL),(11785,'12210','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.654387,-73.757380,0,'2013-07-06 12:44:30',NULL,NULL),(76588,'95683','S','Rncho Murieta','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.496180,-121.127280,0,'2013-07-06 12:44:34',NULL,NULL),(42296,'47597','S','Wheatland','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.669385,-87.298788,0,'2013-07-06 12:44:32',NULL,NULL),(16098,'17052','S','Birdville','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(58670,'68883','S','Wood River','D','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.819408,-98.597850,0,'2013-07-06 12:44:33',NULL,NULL),(24939,'27820','S','Milwaukee','A','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.441291,-77.256965,0,'2013-07-06 12:44:31',NULL,NULL),(12464,'12978','S','Redford','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.609012,-73.805908,0,'2013-07-06 12:44:30',NULL,NULL),(41542,'47006','S','Batesville','D','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.328406,-85.199126,0,'2013-07-06 12:44:32',NULL,NULL),(80124,'99767','P','Fairbanks','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.492007,-149.856480,0,'2013-07-06 12:44:34',NULL,NULL),(26618,'29307','S','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.998752,-81.746450,0,'2013-07-06 12:44:31',NULL,NULL),(70819,'85381','S','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.613599,-112.237530,0,'2013-07-06 12:44:34',NULL,NULL),(13752,'14120','S','Pendleton','N','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.071240,-78.814140,0,'2013-07-06 12:44:31',NULL,NULL),(333,'00652','S','Urb los Jardines','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.466248,-66.569371,0,'2013-07-06 12:44:30',NULL,NULL),(3266,'01464','S','Shirley','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.577860,-71.643840,0,'2013-07-06 12:44:30',NULL,NULL),(29568,'32816','U','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.606119,-81.204801,0,'2013-07-06 12:44:32',NULL,NULL),(63871,'76006','S','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.778606,-97.081409,0,'2013-07-06 12:44:34',NULL,NULL),(63364,'75640','S','Diana','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.699271,-94.668973,0,'2013-07-06 12:44:33',NULL,NULL),(59271,'70456','S','Roseland','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.765787,-90.512420,0,'2013-07-06 12:44:33',NULL,NULL),(29644,'32901','S','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074083,-80.630823,0,'2013-07-06 12:44:32',NULL,NULL),(26144,'28739','S','Hendersonville','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.318666,-82.488402,0,'2013-07-06 12:44:31',NULL,NULL),(18062,'18702','S','Wlks Barr Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234843,-75.877313,0,'2013-07-06 12:44:31',NULL,NULL),(15789,'16923','S','Kinney','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.915978,-77.886047,0,'2013-07-06 12:44:31',NULL,NULL),(3479,'01830','S','Haverhill','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.781433,-71.084197,0,'2013-07-06 12:44:30',NULL,NULL),(76504,'95640','S','Camanche Lake','N','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.329832,-120.932789,0,'2013-07-06 12:44:34',NULL,NULL),(7606,'07047','S','North Bergen','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.793459,-74.022545,0,'2013-07-06 12:44:30',NULL,NULL),(15840,'16936','S','Jobs Corners','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.931667,-76.936111,0,'2013-07-06 12:44:31',NULL,NULL),(70614,'85122','S','Casa Grande','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',32.893933,-111.745030,0,'2013-07-06 12:44:34',NULL,NULL),(30367,'33315','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.097086,-80.154360,0,'2013-07-06 12:44:32',NULL,NULL),(34660,'38781','P','Winstonville','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897283,-90.718493,0,'2013-07-06 12:44:32',NULL,NULL),(57122,'66224','S','Leawood','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.866937,-94.629184,0,'2013-07-06 12:44:33',NULL,NULL),(56975,'66201','P','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.969026,-94.676138,0,'2013-07-06 12:44:33',NULL,NULL),(46293,'53050','S','Mayville','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.499689,-88.546329,0,'2013-07-06 12:44:32',NULL,NULL),(77506,'96837','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312064,-157.864195,0,'2013-07-06 12:44:34',NULL,NULL),(28122,'30814','S','Campania','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.414274,-82.313268,0,'2013-07-06 12:44:31',NULL,NULL),(42877,'48088','S','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.515810,-82.981163,0,'2013-07-06 12:44:32',NULL,NULL),(5512,'04772','S','Saint Agatha','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.235079,-68.338942,0,'2013-07-06 12:44:30',NULL,NULL),(607,'00680','S','Urb Sultana','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(10670,'11120','U','Citicorp','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747242,-73.949347,0,'2013-07-06 12:44:30',NULL,NULL),(7679,'07097','U','Nj International and Bmc','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.751433,-74.050904,0,'2013-07-06 12:44:30',NULL,NULL),(59186,'70357','S','Leeville','N','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.372100,-90.263340,0,'2013-07-06 12:44:33',NULL,NULL),(47018,'54311','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.493458,-87.928499,0,'2013-07-06 12:44:32',NULL,NULL),(38981,'44131','S','Brooklyn Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.384643,-81.657442,0,'2013-07-06 12:44:32',NULL,NULL),(6348,'05673','S','Irasville','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.187565,-72.843339,0,'2013-07-06 12:44:30',NULL,NULL),(57480,'66873','S','Council Grove','A','Morris','20127','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.654363,-96.693462,0,'2013-07-06 12:44:33',NULL,NULL),(1553,'00765','S','Urb Isabel Ii','N','Vieques','72147','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.123576,-65.438423,0,'2013-07-06 12:44:30',NULL,NULL),(66765,'79018','S','Masterson','N','Hartley','48205','Texas','TX','48','0000','806','Central',-6.0,'Y',35.774520,-102.413280,0,'2013-07-06 12:44:34',NULL,NULL),(60137,'71373','S','Lucerne','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(13053,'13440','S','Lee','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(37999,'42758','P','Mannsville','D','Taylor','21217','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.337992,-85.343706,0,'2013-07-06 12:44:32',NULL,NULL),(75836,'94920','S','Belvedere','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.893723,-122.471124,0,'2013-07-06 12:44:34',NULL,NULL),(5268,'04491','P','Vanceboro','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.556591,-67.445138,0,'2013-07-06 12:44:30',NULL,NULL),(14072,'14606','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.167126,-77.687832,0,'2013-07-06 12:44:31',NULL,NULL),(67658,'80478','P','Tabernash','D','Grand','08049','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.002845,-105.883499,0,'2013-07-06 12:44:34',NULL,NULL),(46302,'53059','S','Neosho','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.311909,-88.525006,0,'2013-07-06 12:44:32',NULL,NULL),(24134,'26555','P','Pleasant Valley','N','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.470255,-80.150258,0,'2013-07-06 12:44:31',NULL,NULL),(68617,'81623','S','Marble','A','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.416703,-107.189562,0,'2013-07-06 12:44:34',NULL,NULL),(49085,'56329','S','Foley','D','Benton','27009','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.689579,-93.912459,0,'2013-07-06 12:44:33',NULL,NULL),(3333,'01536','S','North Grafton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.229493,-71.703587,0,'2013-07-06 12:44:30',NULL,NULL),(65350,'77523','S','Baytown','D','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(34337,'38570','S','Livingston','D','Overton','47133','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.388366,-85.321465,0,'2013-07-06 12:44:32',NULL,NULL),(41282,'46761','S','Brushy Prairie','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.644620,-85.404600,0,'2013-07-06 12:44:32',NULL,NULL),(43587,'48750','S','Oscoda','D','Iosco','26069','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.448307,-83.380374,0,'2013-07-06 12:44:32',NULL,NULL),(69496,'83704','S','Ustick','N','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.630174,-116.297422,0,'2013-07-06 12:44:34',NULL,NULL),(69154,'83316','S','Clover','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.604315,-114.762452,0,'2013-07-06 12:44:34',NULL,NULL),(66937,'79357','S','Ralls','D','Crosby','48107','Texas','TX','48','0000','806','Central',-6.0,'Y',33.653760,-101.377380,0,'2013-07-06 12:44:34',NULL,NULL),(57413,'66771','S','St Paul','N','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.517288,-95.169242,0,'2013-07-06 12:44:33',NULL,NULL),(48536,'55752','S','Ball Bluff','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.941037,-93.313905,0,'2013-07-06 12:44:33',NULL,NULL),(14077,'14610','S','Brighton','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.140249,-77.545983,0,'2013-07-06 12:44:31',NULL,NULL),(48296,'55438','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.827962,-93.378236,0,'2013-07-06 12:44:33',NULL,NULL),(3460,'01784','P','Woodville','D','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.232334,-71.559628,0,'2013-07-06 12:44:30',NULL,NULL),(72557,'89301','S','Ely Colony','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.381960,-114.883440,0,'2013-07-06 12:44:34',NULL,NULL),(69197,'83346','S','Basin','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.303000,-113.996280,0,'2013-07-06 12:44:34',NULL,NULL),(28634,'31749','S','Enigma','D','Berrien','13019','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.365365,-83.346313,0,'2013-07-06 12:44:32',NULL,NULL),(67327,'80036','P','Westminster','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.859851,-105.037313,0,'2013-07-06 12:44:34',NULL,NULL),(33170,'37027','S','Brentwood','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.002450,-86.791159,0,'2013-07-06 12:44:32',NULL,NULL),(64730,'76884','S','Valera','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.772003,-99.543672,0,'2013-07-06 12:44:34',NULL,NULL),(40650,'46036','S','Rigdon','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(40917,'46268','S','New Augusta','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.897141,-86.228019,0,'2013-07-06 12:44:32',NULL,NULL),(42585,'47882','S','New Lebanon','A','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.098637,-87.402599,0,'2013-07-06 12:44:32',NULL,NULL),(4874,'04033','U','LL Bean Co','N','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.856471,-70.102326,0,'2013-07-06 12:44:30',NULL,NULL),(60386,'71601','S','Jefferson Square','N','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.201680,-91.929399,0,'2013-07-06 12:44:33',NULL,NULL),(18025,'18643','S','Harding','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.328885,-75.815364,0,'2013-07-06 12:44:31',NULL,NULL),(59828,'71237','S','Epps','D','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.602579,-91.481584,0,'2013-07-06 12:44:33',NULL,NULL),(44548,'50006','S','Alden','D','Hardin','19083','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.518788,-93.372170,0,'2013-07-06 12:44:32',NULL,NULL),(35038,'39169','S','Mileston','N','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.179923,-90.223094,0,'2013-07-06 12:44:32',NULL,NULL),(33351,'37179','S','Thompsons Station','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.799949,-86.904828,0,'2013-07-06 12:44:32',NULL,NULL),(64628,'76705','S','Bellmead','A','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.579380,-97.135680,0,'2013-07-06 12:44:34',NULL,NULL),(42666,'47959','S','Monon','D','White','18181','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.863882,-86.878604,0,'2013-07-06 12:44:32',NULL,NULL),(9204,'09469','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4245,'02873','P','Rockville','D','Washington','44009','Rhode Island','RI','44','5520','401','Eastern',-5.0,'Y',41.516994,-71.768409,0,'2013-07-06 12:44:30',NULL,NULL),(30272,'33245','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.747122,-80.288174,0,'2013-07-06 12:44:32',NULL,NULL),(10602,'11040','S','Lakeville Estates','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(62072,'73553','S','Loveland','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.366219,-98.737610,0,'2013-07-06 12:44:33',NULL,NULL),(56156,'64858','P','Racine','D','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.896329,-94.525820,0,'2013-07-06 12:44:33',NULL,NULL),(49875,'57260','S','White Rock','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.878034,-96.713253,0,'2013-07-06 12:44:33',NULL,NULL),(43781,'49039','P','Coloma','A','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.200000,-86.333333,0,'2013-07-06 12:44:32',NULL,NULL),(21092,'22038','P','Fairfax','D','Fairfax City','51600','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.830825,-77.362938,0,'2013-07-06 12:44:31',NULL,NULL),(18968,'19518','S','Douglassville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(78674,'98240','S','Custer','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.943935,-122.629607,0,'2013-07-06 12:44:34',NULL,NULL),(27117,'29733','U','Withrop College','N','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',34.890601,-81.024567,0,'2013-07-06 12:44:31',NULL,NULL),(22767,'24439','S','Goshen','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.969846,-79.483393,0,'2013-07-06 12:44:31',NULL,NULL),(23946,'26271','S','Hendricks','D','Tucker','54093','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.064458,-79.612063,0,'2013-07-06 12:44:31',NULL,NULL),(80138,'99777','P','Tanana','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.319847,-151.889671,0,'2013-07-06 12:44:34',NULL,NULL),(34511,'38676','S','Evansville','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.694400,-90.369420,0,'2013-07-06 12:44:32',NULL,NULL),(52941,'61401','S','Galesburg','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.949094,-90.369290,0,'2013-07-06 12:44:33',NULL,NULL),(65578,'77863','P','Lyons','D','Burleson','48051','Texas','TX','48','0000','979','Central',-6.0,'Y',30.387313,-96.561285,0,'2013-07-06 12:44:34',NULL,NULL),(29065,'32246','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.305263,-81.511694,0,'2013-07-06 12:44:32',NULL,NULL),(56660,'65620','S','Bruner','D','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.980390,-92.953868,0,'2013-07-06 12:44:33',NULL,NULL),(43844,'49101','S','Baroda','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.947675,-86.484704,0,'2013-07-06 12:44:32',NULL,NULL),(23265,'25139','S','Mount Carbon','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.151124,-81.326901,0,'2013-07-06 12:44:31',NULL,NULL),(63574,'75773','S','Hoard','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.646900,-95.516460,0,'2013-07-06 12:44:34',NULL,NULL),(29592,'32829','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.463802,-81.220717,0,'2013-07-06 12:44:32',NULL,NULL),(59591,'71008','S','Bienville','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.301720,-92.925316,0,'2013-07-06 12:44:33',NULL,NULL),(40634,'46031','S','Atlanta','D','Hamilton','18057','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.162140,-85.935600,0,'2013-07-06 12:44:32',NULL,NULL),(14814,'15419','S','California','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.063892,-79.894161,0,'2013-07-06 12:44:31',NULL,NULL),(6808,'06109','S','Wethersfld','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(38299,'43346','P','Roundhead','D','Hardin','39065','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.566781,-83.842051,0,'2013-07-06 12:44:32',NULL,NULL),(74690,'92886','S','Yorba Linda','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.905797,-117.786465,0,'2013-07-06 12:44:34',NULL,NULL),(75108,'93545','S','Alabama Hills','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.588000,-118.056263,0,'2013-07-06 12:44:34',NULL,NULL),(1281,'00730','S','Lomas de Country Club','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(45534,'51448','S','Boyer','N','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.188040,-95.317860,0,'2013-07-06 12:44:32',NULL,NULL),(15451,'16406','S','Conneautville','D','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.761210,-80.367720,0,'2013-07-06 12:44:31',NULL,NULL),(27722,'30346','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.927811,-84.344192,0,'2013-07-06 12:44:31',NULL,NULL),(14783,'15353','P','Nineveh','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.969209,-80.305861,0,'2013-07-06 12:44:31',NULL,NULL),(20544,'21113','S','Odenton','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.072800,-76.700643,0,'2013-07-06 12:44:31',NULL,NULL),(31502,'34448','S','Homosassa Spg','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.772147,-82.591385,0,'2013-07-06 12:44:32',NULL,NULL),(16628,'17332','U','Direct Brands','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.798105,-76.988197,0,'2013-07-06 12:44:31',NULL,NULL),(23295,'25180','S','Saxon','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.782912,-81.431537,0,'2013-07-06 12:44:31',NULL,NULL),(56957,'66105','S','Kansas City','D','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.079775,-94.632837,0,'2013-07-06 12:44:33',NULL,NULL),(26411,'29115','S','Jamison','N','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.581944,-80.818056,0,'2013-07-06 12:44:31',NULL,NULL),(16181,'17067','S','Greble','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(47042,'54409','S','Antigo','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.137836,-89.151432,0,'2013-07-06 12:44:32',NULL,NULL),(2753,'00969','S','Urb Terranova','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(72722,'89501','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.527740,-119.812619,0,'2013-07-06 12:44:34',NULL,NULL),(72233,'88439','S','Trementina','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.613718,-104.595110,0,'2013-07-06 12:44:34',NULL,NULL),(21691,'22963','S','Wilmington','A','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(52800,'61277','S','Brookhaven','N','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.657855,-89.920163,0,'2013-07-06 12:44:33',NULL,NULL),(5977,'05344','P','Marlboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.860125,-72.728912,0,'2013-07-06 12:44:30',NULL,NULL),(6857,'06129','P','Wethersfield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.708586,-72.659766,0,'2013-07-06 12:44:30',NULL,NULL),(29616,'32859','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.462121,-81.385294,0,'2013-07-06 12:44:32',NULL,NULL),(8450,'08086','S','West Deptford','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.836371,-75.181675,0,'2013-07-06 12:44:30',NULL,NULL),(62216,'73857','S','Sharon','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.262341,-99.394198,0,'2013-07-06 12:44:33',NULL,NULL),(62041,'73522','P','Altus','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.647815,-99.336331,0,'2013-07-06 12:44:33',NULL,NULL),(48076,'55331','S','Deephaven','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(3715,'02143','S','Somerville','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.381835,-71.103174,0,'2013-07-06 12:44:30',NULL,NULL),(10675,'11201','S','Brooklyn Heights','A','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.695472,-73.992723,0,'2013-07-06 12:44:30',NULL,NULL),(72625,'89419','S','Lovelock','D','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.177849,-118.479076,0,'2013-07-06 12:44:34',NULL,NULL),(25971,'28659','S','Hunting Creek','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(61268,'72373','S','Parkin','D','Cross','05037','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.271241,-90.558288,0,'2013-07-06 12:44:33',NULL,NULL),(77455,'96812','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304962,-157.861303,0,'2013-07-06 12:44:34',NULL,NULL),(79957,'99634','P','Napakiak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.674560,-161.738774,0,'2013-07-06 12:44:34',NULL,NULL),(45041,'50477','S','Swaledale','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.951782,-93.313856,0,'2013-07-06 12:44:32',NULL,NULL),(12373,'12913','S','Bloomingdale','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.398502,-74.070744,0,'2013-07-06 12:44:30',NULL,NULL),(40051,'45263','U','Fifth Third Bank','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.107980,-84.534184,0,'2013-07-06 12:44:32',NULL,NULL),(6481,'05767','S','Rochester','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.867841,-72.825813,0,'2013-07-06 12:44:30',NULL,NULL),(70071,'84148','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.755635,-111.835281,0,'2013-07-06 12:44:34',NULL,NULL),(30993,'33766','P','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.030055,-82.719910,0,'2013-07-06 12:44:32',NULL,NULL),(15383,'16317','S','Cooperstown','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.500971,-79.871006,0,'2013-07-06 12:44:31',NULL,NULL),(15092,'15760','S','Marsteller','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.644933,-78.812916,0,'2013-07-06 12:44:31',NULL,NULL),(64341,'76513','S','Belton','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.097391,-97.467293,0,'2013-07-06 12:44:34',NULL,NULL),(63517,'75752','S','Athens','D','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.276517,-95.808593,0,'2013-07-06 12:44:33',NULL,NULL),(24590,'27320','S','Reidsville','D','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(18484,'19088','U','Wayne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.048256,-75.355995,0,'2013-07-06 12:44:31',NULL,NULL),(79838,'99524','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.184959,-149.891783,0,'2013-07-06 12:44:34',NULL,NULL),(17520,'17967','S','Pattersonville','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.849233,-76.231076,0,'2013-07-06 12:44:31',NULL,NULL),(17432,'17931','S','Altamont','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.779310,-76.233926,0,'2013-07-06 12:44:31',NULL,NULL),(64007,'76116','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.714361,-97.464571,0,'2013-07-06 12:44:34',NULL,NULL),(61187,'72210','S','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.712586,-92.457803,0,'2013-07-06 12:44:33',NULL,NULL),(19652,'20299','U','Readasorus','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918368,-76.990783,0,'2013-07-06 12:44:31',NULL,NULL),(43995,'49341','S','Rockford','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.114707,-85.511792,0,'2013-07-06 12:44:32',NULL,NULL),(19316,'20016','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.940315,-77.088596,0,'2013-07-06 12:44:31',NULL,NULL),(37951,'42717','S','Kettle','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(10227,'10461','S','Pilgrim','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.844984,-73.843255,0,'2013-07-06 12:44:30',NULL,NULL),(16125,'17057','S','Lower Swatara','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(9260,'09599','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(168,'00623','S','Cabo Rojo','D','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(57014,'66205','S','Westwood Hls','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(39396,'44657','S','Moultrie','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.738980,-81.099600,0,'2013-07-06 12:44:32',NULL,NULL),(76658,'95741','P','Rancho Cordova','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.588819,-121.300677,0,'2013-07-06 12:44:34',NULL,NULL),(76661,'95742','S','Rncho Cordova','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587081,-121.204382,0,'2013-07-06 12:44:34',NULL,NULL),(63542,'75763','S','Coffee City','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.053680,-95.496540,0,'2013-07-06 12:44:33',NULL,NULL),(3018,'01085','S','Westfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.156360,-72.778740,0,'2013-07-06 12:44:30',NULL,NULL),(53947,'62420','S','Casey','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.300331,-87.989447,0,'2013-07-06 12:44:33',NULL,NULL),(22014,'23288','U','Henrico','D','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.601923,-77.546947,0,'2013-07-06 12:44:31',NULL,NULL),(42237,'47567','S','Petersburg','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(28807,'32065','S','Orange Park','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.134405,-81.774717,0,'2013-07-06 12:44:32',NULL,NULL),(60416,'71640','S','Chicot','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(7458,'06859','U','Perkin Elmer Corp','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.138485,-73.405893,0,'2013-07-06 12:44:30',NULL,NULL),(75956,'95044','P','Holy City','N','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.158418,-121.984871,0,'2013-07-06 12:44:34',NULL,NULL),(15002,'15662','P','Luxor','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.335324,-79.479293,0,'2013-07-06 12:44:31',NULL,NULL),(26268,'29010','S','Manville','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(53890,'62355','S','Nebo','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.398619,-90.771723,0,'2013-07-06 12:44:33',NULL,NULL),(46485,'53222','S','Wauwatosa','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084153,-88.036961,0,'2013-07-06 12:44:32',NULL,NULL),(42282,'47586','S','Franklin Hills','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(1569,'00767','S','Alts De Terralinda','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(17612,'18043','P','Easton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.688694,-75.219639,0,'2013-07-06 12:44:31',NULL,NULL),(60024,'71342','S','Good Pine','N','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.642920,-92.097900,0,'2013-07-06 12:44:33',NULL,NULL),(33864,'38010','P','Braden','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.201706,-89.395141,0,'2013-07-06 12:44:32',NULL,NULL),(13702,'14060','S','Farmersville Station','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.436740,-78.302220,0,'2013-07-06 12:44:31',NULL,NULL),(24353,'27043','S','Perch','N','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.255873,-80.442780,0,'2013-07-06 12:44:31',NULL,NULL),(74236,'92324','S','Grand Terrace','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.032420,-117.282300,0,'2013-07-06 12:44:34',NULL,NULL),(54491,'62864','S','Bakerville','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(54341,'62766','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.774254,-89.607845,0,'2013-07-06 12:44:33',NULL,NULL),(20897,'21710','S','Doubs','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.291540,-77.458140,0,'2013-07-06 12:44:31',NULL,NULL),(42639,'47923','S','Brookston','D','White','18181','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.601295,-86.864871,0,'2013-07-06 12:44:32',NULL,NULL),(10939,'11434','S','Rochdale Village','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(73314,'90810','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.817980,-118.223280,0,'2013-07-06 12:44:34',NULL,NULL),(3102,'01230','S','Alford','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(4865,'04028','P','E Parsonfield','A','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.765270,-70.917943,0,'2013-07-06 12:44:30',NULL,NULL),(18426,'19061','S','Uppr Chichstr','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.835136,-75.448632,0,'2013-07-06 12:44:31',NULL,NULL),(71081,'85926','P','Fort Apache','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.789489,-109.989521,0,'2013-07-06 12:44:34',NULL,NULL),(47585,'54855','S','Marengo','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.356214,-90.846867,0,'2013-07-06 12:44:33',NULL,NULL),(1256,'00729','S','Urb River Plantation','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(77000,'96079','P','Central Vly','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.691415,-122.344769,0,'2013-07-06 12:44:34',NULL,NULL),(49925,'57322','S','Bloomfield','N','Clark','46025','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.674688,-97.914803,0,'2013-07-06 12:44:33',NULL,NULL),(27799,'30392','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755406,-84.392641,0,'2013-07-06 12:44:31',NULL,NULL),(39914,'45218','S','Parkdale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.269057,-84.521832,0,'2013-07-06 12:44:32',NULL,NULL),(70159,'84315','S','Kanesville','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.175095,-112.082261,0,'2013-07-06 12:44:34',NULL,NULL),(27939,'30530','S','Commerce','D','Banks','13011','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.207252,-83.412131,0,'2013-07-06 12:44:31',NULL,NULL),(44320,'49745','S','Hessel','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.025812,-84.327501,0,'2013-07-06 12:44:32',NULL,NULL),(7431,'06824','S','Fairfield','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.168961,-73.265130,0,'2013-07-06 12:44:30',NULL,NULL),(15692,'16841','S','Howard','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',41.017669,-77.658874,0,'2013-07-06 12:44:31',NULL,NULL),(10432,'10805','S','New Rochelle','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.902888,-73.777829,0,'2013-07-06 12:44:30',NULL,NULL),(67001,'79508','S','Buffalo Gap','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.338793,-99.753848,0,'2013-07-06 12:44:34',NULL,NULL),(43921,'49265','S','Onsted','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.014230,-84.172982,0,'2013-07-06 12:44:32',NULL,NULL),(49165,'56395','U','Saint Cloud','D','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.561027,-94.161673,0,'2013-07-06 12:44:33',NULL,NULL),(51453,'59484','S','Sweet Grass','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.964779,-112.030107,0,'2013-07-06 12:44:33',NULL,NULL),(49554,'56701','S','Thief Rvr Fls','A','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.115399,-96.174170,0,'2013-07-06 12:44:33',NULL,NULL),(78464,'98073','P','Redmond','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.676555,-122.114869,0,'2013-07-06 12:44:34',NULL,NULL),(28534,'31553','S','Nahunta','D','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.216716,-81.956732,0,'2013-07-06 12:44:32',NULL,NULL),(4620,'03598','S','Whitefield','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.376161,-71.618637,0,'2013-07-06 12:44:30',NULL,NULL),(23518,'25559','S','Salt Rock','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.336856,-82.230402,0,'2013-07-06 12:44:31',NULL,NULL),(16013,'17042','S','Beverly Hts','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(37235,'41547','S','Majestic','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.542213,-82.094738,0,'2013-07-06 12:44:32',NULL,NULL),(15944,'17023','S','Elizabethville','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.555025,-76.826794,0,'2013-07-06 12:44:31',NULL,NULL),(51808,'60050','S','Bull Valley','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.347392,-88.259759,0,'2013-07-06 12:44:33',NULL,NULL),(38461,'43615','S','Ottawa Hills','A','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.651393,-83.674791,0,'2013-07-06 12:44:32',NULL,NULL),(20777,'21531','S','Friendsville','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.660306,-79.405427,0,'2013-07-06 12:44:31',NULL,NULL),(9406,'09892','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(35695,'39664','S','Auburn','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.356300,-90.636060,0,'2013-07-06 12:44:32',NULL,NULL),(66306,'78586','S','Yescas','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(8598,'08232','S','Egg Hbr Twp','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(36835,'41073','S','Bellevue','D','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.101923,-84.482010,0,'2013-07-06 12:44:32',NULL,NULL),(68228,'81052','S','Carlton','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(10299,'10526','S','Goldens Brg','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.295831,-73.666608,0,'2013-07-06 12:44:30',NULL,NULL),(13103,'13479','P','Washington Mills','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.056604,-75.273986,0,'2013-07-06 12:44:30',NULL,NULL),(60453,'71653','S','Chanticleer','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(35729,'39701','S','Fairlane','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(56232,'65043','S','Lake Mykee Town','N','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.639139,-92.116345,0,'2013-07-06 12:44:33',NULL,NULL),(33305,'37132','U','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.850303,-86.361672,0,'2013-07-06 12:44:32',NULL,NULL),(73928,'92029','S','Elfin Forest','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.090581,-117.108862,0,'2013-07-06 12:44:34',NULL,NULL),(20812,'21609','P','Bethlehem','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.740325,-75.952024,0,'2013-07-06 12:44:31',NULL,NULL),(24139,'26562','S','Burton','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.665640,-80.419500,0,'2013-07-06 12:44:31',NULL,NULL),(65014,'77303','S','Cut and Shoot','A','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.360510,-95.414641,0,'2013-07-06 12:44:34',NULL,NULL),(39657,'45005','S','Middletown','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.528960,-84.297420,0,'2013-07-06 12:44:32',NULL,NULL),(57795,'67487','S','Wakefield','D','Clay','20027','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.217739,-97.017957,0,'2013-07-06 12:44:33',NULL,NULL),(78357,'98012','S','Mill Creek','A','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.841300,-122.205819,0,'2013-07-06 12:44:34',NULL,NULL),(13811,'14211','S','Cheektowaga','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.909859,-78.822940,0,'2013-07-06 12:44:31',NULL,NULL),(1200,'00728','S','Parc El Tuque','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(30741,'33544','S','Wesley Chapel','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.269457,-82.319078,0,'2013-07-06 12:44:32',NULL,NULL),(27465,'30140','P','Felton','D','Haralson','13143','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.884836,-85.219859,0,'2013-07-06 12:44:31',NULL,NULL),(58530,'68792','S','Wynot','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.741296,-97.141101,0,'2013-07-06 12:44:33',NULL,NULL),(23778,'25979','S','Lovern','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.516015,-80.920145,0,'2013-07-06 12:44:31',NULL,NULL),(35923,'40033','S','Calvary','A','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.568206,-85.250680,0,'2013-07-06 12:44:32',NULL,NULL),(11512,'12032','S','Caroga','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.161683,-74.493710,0,'2013-07-06 12:44:30',NULL,NULL),(23408,'25328','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.350365,-81.629816,0,'2013-07-06 12:44:31',NULL,NULL),(11487,'12020','S','Malta','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(21775,'23063','S','Fife','A','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.680935,-77.886050,0,'2013-07-06 12:44:31',NULL,NULL),(500,'00674','S','Ext San Salvador','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(75420,'94026','P','West Menlo Park','N','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.481131,-122.180141,0,'2013-07-06 12:44:34',NULL,NULL),(63490,'75701','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.326456,-95.294488,0,'2013-07-06 12:44:33',NULL,NULL),(11759,'12195','P','West Lebanon','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.490534,-73.448183,0,'2013-07-06 12:44:30',NULL,NULL),(11854,'12256','U','NY Lottery','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651907,-73.758318,0,'2013-07-06 12:44:30',NULL,NULL),(23357,'25267','S','Letter Gap','A','Gilmer','54021','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.891624,-80.957193,0,'2013-07-06 12:44:31',NULL,NULL),(12007,'12494','S','West Shokan','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.945647,-74.291909,0,'2013-07-06 12:44:30',NULL,NULL),(51523,'59711','S','Fairmont','N','Deer Lodge','30023','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.139820,-113.045940,0,'2013-07-06 12:44:33',NULL,NULL),(44430,'49847','S','Hermansville','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.752060,-87.642290,0,'2013-07-06 12:44:32',NULL,NULL),(74631,'92807','S','Anaheim Hills','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.854371,-117.785773,0,'2013-07-06 12:44:34',NULL,NULL),(17242,'17837','S','Kelly X Rds','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(70376,'84660','S','Benjamin','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(57802,'67502','S','Medora','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.102658,-97.919629,0,'2013-07-06 12:44:33',NULL,NULL),(16857,'17563','S','New Texas','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(21157,'22134','S','MCB Quantico','N','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.520589,-77.321006,0,'2013-07-06 12:44:31',NULL,NULL),(44647,'50076','S','Exira','D','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.590777,-94.874949,0,'2013-07-06 12:44:32',NULL,NULL),(20987,'21813','S','Bishop','N','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.417940,-75.191460,0,'2013-07-06 12:44:31',NULL,NULL),(29652,'32904','S','West Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074548,-80.694237,0,'2013-07-06 12:44:32',NULL,NULL),(75041,'93514','S','Rovana','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(27461,'30135','S','Douglasville','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.696171,-84.742497,0,'2013-07-06 12:44:31',NULL,NULL),(59218,'70402','U','Southeastern Louisiana Univ','N','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.510346,-90.459565,0,'2013-07-06 12:44:33',NULL,NULL),(14889,'15483','P','Stockdale','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.082257,-79.847836,0,'2013-07-06 12:44:31',NULL,NULL),(54935,'63112','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.661545,-90.285509,0,'2013-07-06 12:44:33',NULL,NULL),(48824,'56036','S','London','A','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.571784,-93.274151,0,'2013-07-06 12:44:33',NULL,NULL),(76402,'95546','S','Resighini Rancheria','N','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',41.168795,-123.727286,0,'2013-07-06 12:44:34',NULL,NULL),(24206,'26684','S','Pool','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.145767,-80.884027,0,'2013-07-06 12:44:31',NULL,NULL),(10463,'10930','S','Highland Mills','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.353753,-74.130068,0,'2013-07-06 12:44:30',NULL,NULL),(71840,'87581','S','Vallecitos','D','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.698574,-106.136233,0,'2013-07-06 12:44:34',NULL,NULL),(39688,'45030','S','New Baltimore','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.251160,-84.739620,0,'2013-07-06 12:44:32',NULL,NULL),(47923,'55111','S','Saint Paul','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.880467,-93.196044,0,'2013-07-06 12:44:33',NULL,NULL),(8130,'07830','S','Tewksbury Township','A','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.715880,-74.817513,0,'2013-07-06 12:44:30',NULL,NULL),(42635,'47918','S','Attica','D','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.291256,-87.249487,0,'2013-07-06 12:44:32',NULL,NULL),(78503,'98111','P','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.610241,-122.334698,0,'2013-07-06 12:44:34',NULL,NULL),(64951,'77234','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.618205,-95.191130,0,'2013-07-06 12:44:34',NULL,NULL),(59057,'70091','S','South Pass','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.209341,-89.231358,0,'2013-07-06 12:44:33',NULL,NULL),(36378,'40468','S','Perryville','D','Boyle','21021','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.648350,-84.968959,0,'2013-07-06 12:44:32',NULL,NULL),(34960,'39067','S','Ethel','D','Attala','28007','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.081483,-89.542860,0,'2013-07-06 12:44:32',NULL,NULL),(70155,'84314','S','Crystal Springs','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.641228,-112.090819,0,'2013-07-06 12:44:34',NULL,NULL),(30006,'33124','P','University of Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.726412,-80.238000,0,'2013-07-06 12:44:32',NULL,NULL),(33631,'37682','P','Milligan','N','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.302307,-82.296008,0,'2013-07-06 12:44:32',NULL,NULL),(44697,'50133','S','Kellerton','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648980,-94.070796,0,'2013-07-06 12:44:32',NULL,NULL),(75920,'95010','S','Capitola','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.978256,-121.952464,0,'2013-07-06 12:44:34',NULL,NULL),(26797,'29458','S','McClellanville','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.103751,-79.470346,0,'2013-07-06 12:44:31',NULL,NULL),(67653,'80475','P','Shawnee','D','Park','08093','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.434466,-105.587075,0,'2013-07-06 12:44:34',NULL,NULL),(8220,'07961','P','Morristown','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.796667,-74.481944,0,'2013-07-06 12:44:30',NULL,NULL),(26098,'28716','S','Canton','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.530030,-82.839417,0,'2013-07-06 12:44:31',NULL,NULL),(61502,'72648','S','Erbie','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.084759,-93.146930,0,'2013-07-06 12:44:33',NULL,NULL),(2609,'00961','S','Valle Verde 1','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(34184,'38320','S','Camden','D','Benton','47005','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.058480,-88.102425,0,'2013-07-06 12:44:32',NULL,NULL),(74852,'93247','S','Tonyville','N','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.209983,-119.086125,0,'2013-07-06 12:44:34',NULL,NULL),(62287,'74018','P','Claremore','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.319001,-95.586801,0,'2013-07-06 12:44:33',NULL,NULL),(35765,'39740','S','White Sand','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.688435,-88.329881,0,'2013-07-06 12:44:32',NULL,NULL),(59995,'71328','S','Holloway','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(69045,'83223','P','Bloomington','D','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.187392,-111.401138,0,'2013-07-06 12:44:34',NULL,NULL),(18918,'19494','U','Providian Agon','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.054579,-75.556882,0,'2013-07-06 12:44:31',NULL,NULL),(29810,'33024','S','Pembroke Pnes','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.018670,-80.258199,0,'2013-07-06 12:44:32',NULL,NULL),(60003,'71334','S','Concordia Lake','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(81,'00612','S','Parc Mattey','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(7660,'07083','S','Union Center','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.691867,-74.269598,0,'2013-07-06 12:44:30',NULL,NULL),(68890,'82717','P','Gillette','D','Campbell','56005','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.257303,-105.385939,0,'2013-07-06 12:44:34',NULL,NULL),(67740,'80601','S','Thornton','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.964059,-104.817375,0,'2013-07-06 12:44:34',NULL,NULL),(66404,'78629','S','Nickel','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.510053,-97.452034,0,'2013-07-06 12:44:34',NULL,NULL),(63900,'76022','S','Bedford','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.828966,-97.147631,0,'2013-07-06 12:44:34',NULL,NULL),(53196,'61611','S','Bayview Gardens','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(77674,'97030','S','Gresham','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.499394,-122.420435,0,'2013-07-06 12:44:34',NULL,NULL),(3980,'02534','P','Cataumet','D','Barnstable','25001','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.666022,-70.613720,0,'2013-07-06 12:44:30',NULL,NULL),(70025,'84129','S','Taylorsville','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696347,-112.017349,0,'2013-07-06 12:44:34',NULL,NULL),(32520,'36088','S','Tuskegee Institute','D','Macon','01087','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.413395,-85.721531,0,'2013-07-06 12:44:32',NULL,NULL),(66723,'78954','S','Round Top','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',30.054884,-96.755586,0,'2013-07-06 12:44:34',NULL,NULL),(62926,'75085','P','Richardson','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.952906,-96.703839,0,'2013-07-06 12:44:33',NULL,NULL),(60136,'71373','S','Hammet','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.590120,-91.487040,0,'2013-07-06 12:44:33',NULL,NULL),(34019,'38127','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.240147,-90.020802,0,'2013-07-06 12:44:32',NULL,NULL),(23,'00603','S','Repto Jimenez','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(25773,'28601','S','View Mont','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(21076,'22026','S','Dumfries','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.583120,-77.333820,0,'2013-07-06 12:44:31',NULL,NULL),(33330,'37150','S','Red Blng Spgs','A','Macon','47111','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.529731,-85.845293,0,'2013-07-06 12:44:32',NULL,NULL),(68048,'80931','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.752720,-104.731586,0,'2013-07-06 12:44:34',NULL,NULL),(33987,'38115','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.045523,-89.849029,0,'2013-07-06 12:44:32',NULL,NULL),(49300,'56531','S','Elbow Lake','D','Grant','27051','Minnesota','MN','27','0000','218','Central',-6.0,'Y',45.994893,-95.969068,0,'2013-07-06 12:44:33',NULL,NULL),(29339,'32549','P','Fort Walton Beach','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.410303,-86.614571,0,'2013-07-06 12:44:32',NULL,NULL),(54335,'62763','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.786222,-89.656263,0,'2013-07-06 12:44:33',NULL,NULL),(75211,'93633','P','Kings Canyon National Pk','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(39916,'45219','S','Corryville','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.126100,-84.517318,0,'2013-07-06 12:44:32',NULL,NULL),(35924,'40033','S','Lebanon','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.568206,-85.250680,0,'2013-07-06 12:44:32',NULL,NULL),(34443,'38650','S','Myrtle','D','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.543592,-89.128594,0,'2013-07-06 12:44:32',NULL,NULL),(52971,'61427','S','Cuba','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.493831,-90.196232,0,'2013-07-06 12:44:33',NULL,NULL),(15964,'17027','P','Messiah College','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.152071,-77.002719,0,'2013-07-06 12:44:31',NULL,NULL),(5664,'04961','S','N New Portlnd','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(4530,'03435','U','Keene','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.925672,-72.276350,0,'2013-07-06 12:44:30',NULL,NULL),(11606,'12090','S','Hoosick Falls','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.880260,-73.359060,0,'2013-07-06 12:44:30',NULL,NULL),(60158,'71404','S','Gum Springs Road','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.832832,-92.788989,0,'2013-07-06 12:44:33',NULL,NULL),(31789,'35033','S','Arkadelphia','N','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.953478,-87.004753,0,'2013-07-06 12:44:32',NULL,NULL),(48915,'56140','P','Ihlen','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.908457,-96.366548,0,'2013-07-06 12:44:33',NULL,NULL),(43129,'48230','S','Grosse Pointe Woods','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(30808,'33615','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.009516,-82.585627,0,'2013-07-06 12:44:32',NULL,NULL),(15038,'15696','P','Youngstown','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.277657,-79.368507,0,'2013-07-06 12:44:31',NULL,NULL),(75310,'93750','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.838720,-119.788009,0,'2013-07-06 12:44:34',NULL,NULL),(31186,'33931','S','Ft Myers Beach','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.447226,-81.931788,0,'2013-07-06 12:44:32',NULL,NULL),(62633,'74558','S','Nashoba','D','Pushmataha','40127','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.529936,-95.182144,0,'2013-07-06 12:44:33',NULL,NULL),(45661,'52030','P','Andrew','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.165035,-90.606013,0,'2013-07-06 12:44:32',NULL,NULL),(25496,'28367','P','Norman','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.169689,-79.722074,0,'2013-07-06 12:44:31',NULL,NULL),(15307,'16150','S','Sharpsville','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.268681,-80.455152,0,'2013-07-06 12:44:31',NULL,NULL),(6598,'05863','P','Saint Johnsbury Center','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.452899,-72.012143,0,'2013-07-06 12:44:30',NULL,NULL),(43415,'48462','S','Ortonville','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.838413,-83.428185,0,'2013-07-06 12:44:32',NULL,NULL),(71052,'85749','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.270941,-110.767721,0,'2013-07-06 12:44:34',NULL,NULL),(17467,'17948','S','Morea','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(8937,'08753','S','Dover Twp','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.988680,-74.179560,0,'2013-07-06 12:44:30',NULL,NULL),(75866,'94945','S','San Marin','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.124448,-122.550509,0,'2013-07-06 12:44:34',NULL,NULL),(64136,'76195','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.726738,-97.317356,0,'2013-07-06 12:44:34',NULL,NULL),(43114,'48224','S','Grosse Pointe','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.411143,-82.943461,0,'2013-07-06 12:44:32',NULL,NULL),(8258,'08008','S','Long Bch Twp','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(29614,'32857','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.560540,-81.296712,0,'2013-07-06 12:44:32',NULL,NULL),(11170,'11729','S','Deer Park','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.759058,-73.325501,0,'2013-07-06 12:44:30',NULL,NULL),(1999,'00910','P','Fernandez Juncos','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.442966,-66.071521,0,'2013-07-06 12:44:30',NULL,NULL),(51413,'59441','S','Forest Grove','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.867250,-109.053316,0,'2013-07-06 12:44:33',NULL,NULL),(49518,'56672','S','Slater','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(33957,'38104','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.133557,-89.998776,0,'2013-07-06 12:44:32',NULL,NULL),(76285,'95427','S','Keene Summit','N','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.261694,-123.582922,0,'2013-07-06 12:44:34',NULL,NULL),(75339,'93888','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.753596,-119.678137,0,'2013-07-06 12:44:34',NULL,NULL),(69923,'84111','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.753460,-111.879217,0,'2013-07-06 12:44:34',NULL,NULL),(13793,'14173','P','Yorkshire','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.527409,-78.473350,0,'2013-07-06 12:44:31',NULL,NULL),(38164,'43152','S','S Bloomingvil','A','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.407940,-82.611540,0,'2013-07-06 12:44:32',NULL,NULL),(9328,'09741','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(69,'00612','S','Bo Obrero','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(230,'00627','S','Camuy','D','Camuy','72027','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485866,-66.844057,0,'2013-07-06 12:44:30',NULL,NULL),(37634,'42163','S','Rocky Hill','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.068506,-86.098123,0,'2013-07-06 12:44:32',NULL,NULL),(29208,'32413','S','Inlet Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(28234,'31045','S','Jewell','D','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.336256,-82.734618,0,'2013-07-06 12:44:31',NULL,NULL),(24164,'26601','S','Newville','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.672330,-80.687532,0,'2013-07-06 12:44:31',NULL,NULL),(6955,'06226','S','Conantville','N','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.714269,-72.211943,0,'2013-07-06 12:44:30',NULL,NULL),(68136,'80970','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848525,-104.717700,0,'2013-07-06 12:44:34',NULL,NULL),(65454,'77614','P','Deweyville','D','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',30.493512,-93.745014,0,'2013-07-06 12:44:34',NULL,NULL),(48512,'55745','U','Arrowhead Promotion Fulfillm','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.230302,-93.524079,0,'2013-07-06 12:44:33',NULL,NULL),(6965,'06235','S','Chaplin','D','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.808838,-72.115007,0,'2013-07-06 12:44:30',NULL,NULL),(1123,'00725','S','Valley View Park','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(3135,'01247','S','North Adams','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.687120,-73.074360,0,'2013-07-06 12:44:30',NULL,NULL),(31290,'34042','M','APO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(20834,'21636','S','Goldsboro','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.033140,-75.787880,0,'2013-07-06 12:44:31',NULL,NULL),(54303,'62707','S','Riddle Hill','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.777482,-89.650787,0,'2013-07-06 12:44:33',NULL,NULL),(39060,'44197','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.480998,-81.681696,0,'2013-07-06 12:44:32',NULL,NULL),(31947,'35207','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.560963,-86.818624,0,'2013-07-06 12:44:32',NULL,NULL),(6655,'06021','S','Colebrook','D','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.999755,-73.098758,0,'2013-07-06 12:44:30',NULL,NULL),(25316,'28166','S','Troutman','D','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.699084,-80.889947,0,'2013-07-06 12:44:31',NULL,NULL),(50149,'57540','S','Holabird','D','Hyde','46069','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.515664,-99.587927,0,'2013-07-06 12:44:33',NULL,NULL),(68544,'81422','S','Naturita','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.230861,-108.586113,0,'2013-07-06 12:44:34',NULL,NULL),(73035,'90076','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.062531,-118.308835,0,'2013-07-06 12:44:34',NULL,NULL),(73355,'91011','S','Flintridge','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.206651,-118.201628,0,'2013-07-06 12:44:34',NULL,NULL),(17029,'17745','S','Sagamore Hill','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(13543,'13827','S','Straits Corners','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(14442,'15091','P','Wildwood','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.596238,-79.964462,0,'2013-07-06 12:44:31',NULL,NULL),(21211,'22204','S','South','N','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.859707,-77.095607,0,'2013-07-06 12:44:31',NULL,NULL),(42364,'47708','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.971882,-87.575060,0,'2013-07-06 12:44:32',NULL,NULL),(76186,'95340','S','Merced','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.299167,-120.474945,0,'2013-07-06 12:44:34',NULL,NULL),(48366,'55554','P','Norwood','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.771087,-93.927780,0,'2013-07-06 12:44:33',NULL,NULL),(44516,'49946','S','L\' Anse','N','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.759740,-88.409340,0,'2013-07-06 12:44:32',NULL,NULL),(5722,'05001','S','White River Junction','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.662310,-72.359191,0,'2013-07-06 12:44:30',NULL,NULL),(5063,'04280','S','Sabattus','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.112074,-70.100318,0,'2013-07-06 12:44:30',NULL,NULL),(36729,'41031','S','Oddville','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(2242,'00926','S','Urb La Campina','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(31396,'34223','S','Inglewood','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.013007,-82.380021,0,'2013-07-06 12:44:32',NULL,NULL),(22283,'23803','S','North Dinwiddie','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.213860,-77.455680,0,'2013-07-06 12:44:31',NULL,NULL),(71797,'87565','S','Soham','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.415556,-105.493611,0,'2013-07-06 12:44:34',NULL,NULL),(68713,'82070','S','Laramie','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.297825,-105.635487,0,'2013-07-06 12:44:34',NULL,NULL),(831,'00693','S','Villa Rosa 2','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(38502,'43701','S','Zanesville','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.954240,-81.984960,0,'2013-07-06 12:44:32',NULL,NULL),(19327,'20026','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880334,-77.019327,0,'2013-07-06 12:44:31',NULL,NULL),(20536,'21104','S','Marriottsville','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.343680,-76.907220,0,'2013-07-06 12:44:31',NULL,NULL),(65996,'78341','P','Benavides','D','Duval','48131','Texas','TX','48','0000','361','Central',-6.0,'Y',27.526925,-98.381021,0,'2013-07-06 12:44:34',NULL,NULL),(22572,'24153','S','Glenvar','N','Salem City','51775','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.288165,-80.081369,0,'2013-07-06 12:44:31',NULL,NULL),(21624,'22908','U','Charlottesville','D','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.035452,-78.514913,0,'2013-07-06 12:44:31',NULL,NULL),(20970,'21791','S','Linwood','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.544988,-77.194309,0,'2013-07-06 12:44:31',NULL,NULL),(14685,'15252','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.440966,-79.998271,0,'2013-07-06 12:44:31',NULL,NULL),(38756,'44039','S','N Ridgeville','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.391979,-82.019396,0,'2013-07-06 12:44:32',NULL,NULL),(6164,'05472','S','New Haven Junction','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(32758,'36349','P','Malvern','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.103492,-85.602975,0,'2013-07-06 12:44:32',NULL,NULL),(30125,'33162','S','N Miami Beach','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(4598,'03585','S','Landaff','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.210565,-71.903972,0,'2013-07-06 12:44:30',NULL,NULL),(60784,'72024','S','Carlisle','D','Lonoke','05085','Arkansas','AR','05','4400','870','Central',-6.0,'Y',34.788454,-91.746133,0,'2013-07-06 12:44:33',NULL,NULL),(59222,'70421','S','Akers','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.397042,-90.368525,0,'2013-07-06 12:44:33',NULL,NULL),(55757,'64114','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.963244,-94.597784,0,'2013-07-06 12:44:33',NULL,NULL),(54222,'62650','S','Merritt','A','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.730959,-90.238625,0,'2013-07-06 12:44:33',NULL,NULL),(43585,'48749','S','Omer','D','Arenac','26011','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.056004,-83.895744,0,'2013-07-06 12:44:32',NULL,NULL),(20990,'21817','S','Crisfield','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',37.989315,-75.844496,0,'2013-07-06 12:44:31',NULL,NULL),(22588,'24171','S','Stuart','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.631672,-80.247549,0,'2013-07-06 12:44:31',NULL,NULL),(7706,'07184','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.725585,-74.218488,0,'2013-07-06 12:44:30',NULL,NULL),(27632,'30313','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.764232,-84.395287,0,'2013-07-06 12:44:31',NULL,NULL),(157,'00617','S','Urb Sol Naciente','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(37211,'41524','S','Biggs','A','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.368780,-82.262100,0,'2013-07-06 12:44:32',NULL,NULL),(666,'00683','S','San German','D','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(24871,'27676','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772367,-78.634536,0,'2013-07-06 12:44:31',NULL,NULL),(45488,'51351','S','Old Town','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.323480,-95.169660,0,'2013-07-06 12:44:32',NULL,NULL),(45975,'52405','S','Cedar Rapids','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.979370,-91.718932,0,'2013-07-06 12:44:32',NULL,NULL),(49887,'57268','S','Johnsonville','N','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.574557,-96.644841,0,'2013-07-06 12:44:33',NULL,NULL),(56979,'66202','S','Merriam','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(56295,'65082','S','Equality','N','Miller','29131','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.238110,-92.482845,0,'2013-07-06 12:44:33',NULL,NULL),(53460,'61919','S','Camargo','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.804516,-88.124820,0,'2013-07-06 12:44:33',NULL,NULL),(11509,'12028','S','Buskirk','D','Washington','36115','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.962677,-73.447303,0,'2013-07-06 12:44:30',NULL,NULL),(39498,'44805','S','Ashland','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.853220,-82.315020,0,'2013-07-06 12:44:32',NULL,NULL),(2687,'00968','S','Urb Caparra Hls','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(31963,'35212','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.543843,-86.747944,0,'2013-07-06 12:44:32',NULL,NULL),(28620,'31716','S','Baconton','D','Mitchell','13205','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.374218,-84.161186,0,'2013-07-06 12:44:32',NULL,NULL),(28386,'31308','S','Black Creek','A','Bryan','13029','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.175889,-81.482070,0,'2013-07-06 12:44:32',NULL,NULL),(24945,'27826','S','Fairfield','D','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.573676,-76.242516,0,'2013-07-06 12:44:31',NULL,NULL),(51152,'58847','S','Keene','D','McKenzie','38053','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.959396,-102.865396,0,'2013-07-06 12:44:33',NULL,NULL),(58346,'68502','S','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.786507,-96.714244,0,'2013-07-06 12:44:33',NULL,NULL),(62820,'74956','S','Shady Point','D','Le Flore','40079','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.124932,-94.673619,0,'2013-07-06 12:44:33',NULL,NULL),(72666,'89436','S','Spanish Spgs','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.645257,-119.698716,0,'2013-07-06 12:44:34',NULL,NULL),(7452,'06856','P','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.111028,-73.422612,0,'2013-07-06 12:44:30',NULL,NULL),(8444,'08085','S','Logan Twp','A','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.753559,-75.321630,0,'2013-07-06 12:44:30',NULL,NULL),(36424,'40574','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.137144,-84.473423,0,'2013-07-06 12:44:32',NULL,NULL),(21515,'22719','S','Etlan','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.556608,-78.307639,0,'2013-07-06 12:44:31',NULL,NULL),(22236,'23628','U','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.146056,-76.578123,0,'2013-07-06 12:44:31',NULL,NULL),(30007,'33125','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.781311,-80.236441,0,'2013-07-06 12:44:32',NULL,NULL),(25649,'28469','S','Ocean Isle Beach','D','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.923901,-78.459091,0,'2013-07-06 12:44:31',NULL,NULL),(70198,'84339','S','Wellsville','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.645040,-111.918060,0,'2013-07-06 12:44:34',NULL,NULL),(80057,'99712','S','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.891588,-147.414606,0,'2013-07-06 12:44:34',NULL,NULL),(79484,'98901','S','Yakima','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.606829,-120.465379,0,'2013-07-06 12:44:34',NULL,NULL),(73421,'91199','U','City National Bank','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.109919,-118.125578,0,'2013-07-06 12:44:34',NULL,NULL),(72449,'89108','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.205858,-115.225094,0,'2013-07-06 12:44:34',NULL,NULL),(20304,'20815','S','Chevy Chs Vlg','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(18581,'19131','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.978878,-75.220604,0,'2013-07-06 12:44:31',NULL,NULL),(612,'00680','S','Villas de Felisa','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(4225,'02852','S','North Kingstown','D','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.584340,-71.463799,0,'2013-07-06 12:44:30',NULL,NULL),(12334,'12871','S','Bacon Hill','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.088460,-73.622760,0,'2013-07-06 12:44:30',NULL,NULL),(53198,'61611','S','Peoria','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(54429,'62837','S','Jasper','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(72209,'88421','S','Garita','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.357574,-104.489215,0,'2013-07-06 12:44:34',NULL,NULL),(56880,'66027','S','Fort Leavenworth','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.361430,-94.923664,0,'2013-07-06 12:44:33',NULL,NULL),(4713,'03819','S','So Danville','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.919072,-71.116979,0,'2013-07-06 12:44:30',NULL,NULL),(17024,'17745','S','Dunnstown','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.134686,-77.449701,0,'2013-07-06 12:44:31',NULL,NULL),(29681,'32924','P','Cocoa','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.262067,-80.705413,0,'2013-07-06 12:44:32',NULL,NULL),(75377,'93940','S','Del Rey Oaks','A','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.587700,-121.849200,0,'2013-07-06 12:44:34',NULL,NULL),(70470,'84760','P','Paragonah','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.886218,-112.775555,0,'2013-07-06 12:44:34',NULL,NULL),(69934,'84114','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775628,-111.891834,0,'2013-07-06 12:44:34',NULL,NULL),(68991,'83126','S','Smoot','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.609653,-110.908814,0,'2013-07-06 12:44:34',NULL,NULL),(59928,'71292','S','Bawcomville','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(21837,'23124','S','New Kent','D','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.536551,-77.027884,0,'2013-07-06 12:44:31',NULL,NULL),(23117,'24954','S','Marlinton','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.211660,-80.055660,0,'2013-07-06 12:44:31',NULL,NULL),(26976,'29614','U','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.910320,-82.409036,0,'2013-07-06 12:44:31',NULL,NULL),(29609,'32839','S','Pine Castle','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.487458,-81.403507,0,'2013-07-06 12:44:32',NULL,NULL),(28974,'32209','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355851,-81.694137,0,'2013-07-06 12:44:32',NULL,NULL),(42801,'48049','S','Ruby','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.036320,-82.574580,0,'2013-07-06 12:44:32',NULL,NULL),(45613,'51570','S','Shelby','D','Shelby','19165','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.519002,-95.452367,0,'2013-07-06 12:44:32',NULL,NULL),(50093,'57470','S','Rockham','D','Faulk','46049','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.025175,-98.778074,0,'2013-07-06 12:44:33',NULL,NULL),(78558,'98155','S','Lake Forest Park','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(74186,'92277','S','Twentynine Palms','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.161757,-116.045717,0,'2013-07-06 12:44:34',NULL,NULL),(67420,'80150','P','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.643214,-104.985443,0,'2013-07-06 12:44:34',NULL,NULL),(64574,'76664','S','Mart','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.548099,-96.837534,0,'2013-07-06 12:44:34',NULL,NULL),(62314,'74036','S','Inola','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147671,-95.509727,0,'2013-07-06 12:44:33',NULL,NULL),(15536,'16601','S','Altoona','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.515900,-78.403203,0,'2013-07-06 12:44:31',NULL,NULL),(8266,'08008','S','Surf City Boro','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(5838,'05086','S','West Topsham','D','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.094722,-72.341944,0,'2013-07-06 12:44:30',NULL,NULL),(28221,'31036','S','Hawkinsville','D','Pulaski','13235','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.281988,-83.473610,0,'2013-07-06 12:44:31',NULL,NULL),(25518,'28387','S','Southern Pnes','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.174091,-79.390844,0,'2013-07-06 12:44:31',NULL,NULL),(42651,'47942','S','Earl Park','D','Benton','18007','Indiana','IN','18','0000','219','Eastern',-5.0,'Y',40.682835,-87.411617,0,'2013-07-06 12:44:32',NULL,NULL),(48553,'55760','S','Spalding','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(49402,'56623','S','Clementson','N','Lake of the Woods','27077','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.690833,-94.436111,0,'2013-07-06 12:44:33',NULL,NULL),(39492,'44799','U','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.811856,-81.373368,0,'2013-07-06 12:44:32',NULL,NULL),(9309,'09720','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(30666,'33465','P','Lantana','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.576320,-80.087218,0,'2013-07-06 12:44:32',NULL,NULL),(54585,'62901','S','Boskydell','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(69900,'84106','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(70468,'84759','S','Panguitch','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.774394,-112.590019,0,'2013-07-06 12:44:34',NULL,NULL),(30034,'33140','S','Sunset Island','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.815316,-80.130710,0,'2013-07-06 12:44:32',NULL,NULL),(28857,'32102','S','Astor','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',29.154918,-81.548357,0,'2013-07-06 12:44:32',NULL,NULL),(42319,'47617','P','Hatfield','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.910925,-87.203235,0,'2013-07-06 12:44:32',NULL,NULL),(48690,'55932','S','Potsdam','N','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.121402,-92.250206,0,'2013-07-06 12:44:33',NULL,NULL),(48810,'56023','S','Delavan','D','Faribault','27043','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.768968,-94.003264,0,'2013-07-06 12:44:33',NULL,NULL),(73763,'91733','S','El Monte','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.051383,-118.044588,0,'2013-07-06 12:44:34',NULL,NULL),(69798,'84066','S','Monarch','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.298824,-109.998125,0,'2013-07-06 12:44:34',NULL,NULL),(67331,'80041','P','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.700882,-104.836569,0,'2013-07-06 12:44:34',NULL,NULL),(61215,'72316','P','Blytheville','D','Mississippi','05093','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.929930,-89.916897,0,'2013-07-06 12:44:33',NULL,NULL),(1679,'00777','S','Est de Juncos','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(36737,'41033','S','Demossville','A','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.749457,-84.473187,0,'2013-07-06 12:44:32',NULL,NULL),(17290,'17850','P','Montandon','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972467,-76.850729,0,'2013-07-06 12:44:31',NULL,NULL),(20251,'20782','S','Prince Georges Metro Ctr','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964978,-76.965246,0,'2013-07-06 12:44:31',NULL,NULL),(73009,'90065','S','Glassell Park','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.105980,-118.229781,0,'2013-07-06 12:44:34',NULL,NULL),(64483,'76598','U','Hilltop Unit Tdc','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.445596,-97.743272,0,'2013-07-06 12:44:34',NULL,NULL),(58027,'68002','S','Arlington','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.457952,-96.352472,0,'2013-07-06 12:44:33',NULL,NULL),(52184,'60466','S','Park Forest','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.464740,-87.699000,0,'2013-07-06 12:44:33',NULL,NULL),(43497,'48623','S','Freeland','D','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.501760,-84.128179,0,'2013-07-06 12:44:32',NULL,NULL),(22092,'23408','P','Marionville','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.438885,-75.895385,0,'2013-07-06 12:44:31',NULL,NULL),(3316,'01523','S','Lancaster','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.477605,-71.684044,0,'2013-07-06 12:44:30',NULL,NULL),(8132,'07831','P','Changewater','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.732525,-74.941540,0,'2013-07-06 12:44:30',NULL,NULL),(11245,'11758','S','Massapequa','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.686884,-73.469397,0,'2013-07-06 12:44:30',NULL,NULL),(28120,'30813','S','Grovetown','D','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.463492,-82.208269,0,'2013-07-06 12:44:31',NULL,NULL),(25583,'28439','S','Fair Bluff','D','Columbus','37047','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.308288,-79.003050,0,'2013-07-06 12:44:31',NULL,NULL),(18509,'19102','S','Penn Ctr','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952547,-75.163950,0,'2013-07-06 12:44:31',NULL,NULL),(22340,'23874','S','Newsoms','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.614061,-77.096376,0,'2013-07-06 12:44:31',NULL,NULL),(47768,'55038','S','Centerville','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.163580,-92.956430,0,'2013-07-06 12:44:33',NULL,NULL),(61343,'72467','P','State Univ','A','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.849336,-90.679349,0,'2013-07-06 12:44:33',NULL,NULL),(73719,'91615','P','N Hollywood','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.200891,-118.394821,0,'2013-07-06 12:44:34',NULL,NULL),(40593,'45881','S','Rawson','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.955966,-83.776777,0,'2013-07-06 12:44:32',NULL,NULL),(2727,'00969','S','Urb Colimar','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(23431,'25389','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.368284,-81.673323,0,'2013-07-06 12:44:31',NULL,NULL),(21920,'23223','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.558121,-77.374277,0,'2013-07-06 12:44:31',NULL,NULL),(61348,'72471','S','Swifton','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.836973,-91.118711,0,'2013-07-06 12:44:33',NULL,NULL),(47783,'55043','S','St Marys Point','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(70812,'85375','S','Sun City West','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.661749,-112.345339,0,'2013-07-06 12:44:34',NULL,NULL),(43825,'49085','S','Saint Joe','N','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.068065,-86.475496,0,'2013-07-06 12:44:32',NULL,NULL),(57394,'66756','S','Mulberry','D','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.549625,-94.679242,0,'2013-07-06 12:44:33',NULL,NULL),(57882,'67626','S','Bunker Hill','D','Russell','20167','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.839703,-98.671233,0,'2013-07-06 12:44:33',NULL,NULL),(63984,'76108','S','Wht Settlemt','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.781540,-97.503780,0,'2013-07-06 12:44:34',NULL,NULL),(69408,'83627','S','Hammett','D','Elmore','16039','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.977016,-115.564362,0,'2013-07-06 12:44:34',NULL,NULL),(80105,'99755','P','Denali Park','A','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.625861,-150.903059,0,'2013-07-06 12:44:34',NULL,NULL),(78445,'98059','S','Renton','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.483100,-122.129820,0,'2013-07-06 12:44:34',NULL,NULL),(71153,'86033','P','Kayenta','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.630720,-110.277720,0,'2013-07-06 12:44:34',NULL,NULL),(32087,'35291','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513087,-86.806429,0,'2013-07-06 12:44:32',NULL,NULL),(47640,'54922','S','Bear Creek','D','Outagamie','55087','Wisconsin','WI','55','0460','715','Central',-6.0,'Y',44.530280,-88.724483,0,'2013-07-06 12:44:33',NULL,NULL),(50369,'57755','S','Olson','N','Harding','46063','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.848971,-103.364264,0,'2013-07-06 12:44:33',NULL,NULL),(59697,'71079','S','Summerfield','D','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.935341,-92.805364,0,'2013-07-06 12:44:33',NULL,NULL),(2039,'00918','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(38286,'43333','S','Lewistown','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.439457,-83.916891,0,'2013-07-06 12:44:32',NULL,NULL),(35381,'39455','S','Carnes','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(15283,'16121','S','Farrell','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.211841,-80.490520,0,'2013-07-06 12:44:31',NULL,NULL),(32652,'36253','P','Bynum','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.602494,-85.962626,0,'2013-07-06 12:44:32',NULL,NULL),(23858,'26143','S','Spring Valley','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(56310,'65101','S','Osage City','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(76573,'95674','S','Rio Oso','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.961496,-121.495208,0,'2013-07-06 12:44:34',NULL,NULL),(63422,'75659','P','Jonesville','D','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.497692,-94.112507,0,'2013-07-06 12:44:33',NULL,NULL),(63183,'75415','S','Ben Franklin','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.379930,-95.859660,0,'2013-07-06 12:44:33',NULL,NULL),(41403,'46809','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.026644,-85.189643,0,'2013-07-06 12:44:32',NULL,NULL),(46599,'53554','S','Livingston','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.898732,-90.456658,0,'2013-07-06 12:44:32',NULL,NULL),(54093,'62531','S','Edenburg','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.661648,-89.392376,0,'2013-07-06 12:44:33',NULL,NULL),(64332,'76501','S','Temple','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.085400,-97.309680,0,'2013-07-06 12:44:34',NULL,NULL),(68645,'81640','S','Greystone','N','Moffat','08081','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.530669,-108.143210,0,'2013-07-06 12:44:34',NULL,NULL),(77134,'96156','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.947065,-119.970227,0,'2013-07-06 12:44:34',NULL,NULL),(6270,'05609','U','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.287423,-72.600062,0,'2013-07-06 12:44:30',NULL,NULL),(1071,'00725','S','Qtas de San Luis 1','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(15393,'16329','S','Irvine','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.844630,-79.274369,0,'2013-07-06 12:44:31',NULL,NULL),(22131,'23442','S','Temperancevle','A','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.895258,-75.559531,0,'2013-07-06 12:44:31',NULL,NULL),(48908,'56131','S','Kinbrae','A','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.871151,-95.602641,0,'2013-07-06 12:44:33',NULL,NULL),(59639,'71038','S','Mount Sinai','N','Claiborne','22027','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.946900,-93.122940,0,'2013-07-06 12:44:33',NULL,NULL),(63334,'75599','U','Texarkana Community College','N','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.447126,-94.077525,0,'2013-07-06 12:44:33',NULL,NULL),(68141,'80977','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.772039,-104.665048,0,'2013-07-06 12:44:34',NULL,NULL),(2423,'00953','S','Qtas De Plaza Aquarium','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(7155,'06420','S','Colchester','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.487578,-72.271646,0,'2013-07-06 12:44:30',NULL,NULL),(21546,'22741','S','Stevensburg','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.442676,-77.866475,0,'2013-07-06 12:44:31',NULL,NULL),(43954,'49305','S','Barryton','D','Mecosta','26107','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.749421,-85.169379,0,'2013-07-06 12:44:32',NULL,NULL),(57306,'66626','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.047246,-95.682820,0,'2013-07-06 12:44:33',NULL,NULL),(76796,'95945','S','La Barr Meadows','N','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.202715,-121.029155,0,'2013-07-06 12:44:34',NULL,NULL),(50263,'57638','S','White Butte','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.937575,-102.160093,0,'2013-07-06 12:44:33',NULL,NULL),(46405,'53171','P','Somers','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.636099,-87.909790,0,'2013-07-06 12:44:32',NULL,NULL),(1414,'00738','S','Urb Santa Isidra 3','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(78120,'97520','S','Ashland','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.158340,-122.633820,0,'2013-07-06 12:44:34',NULL,NULL),(3273,'01470','U','New England Business Brm','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.608252,-71.571890,0,'2013-07-06 12:44:30',NULL,NULL),(3859,'02351','S','North Abington','N','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.117783,-70.954203,0,'2013-07-06 12:44:30',NULL,NULL),(37637,'42164','S','Halifax','N','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.782160,-86.190120,0,'2013-07-06 12:44:32',NULL,NULL),(22996,'24801','S','Maitland','N','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.430754,-81.577391,0,'2013-07-06 12:44:31',NULL,NULL),(47647,'54929','S','Clintonville','D','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.624076,-88.755627,0,'2013-07-06 12:44:33',NULL,NULL),(77289,'96629','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(78146,'97544','S','Williams','D','Josephine','41033','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.227790,-123.280356,0,'2013-07-06 12:44:34',NULL,NULL),(16358,'17201','S','Clay Hill','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(58150,'68172','U','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.260689,-95.940590,0,'2013-07-06 12:44:33',NULL,NULL),(2266,'00926','S','Urb Rio Piedras Hts','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(54622,'62917','S','Carriers Mills','N','Saline','17165','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.690197,-88.627956,0,'2013-07-06 12:44:33',NULL,NULL),(75314,'93760','U','Pacific Gas and Electric','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.735811,-119.778758,0,'2013-07-06 12:44:34',NULL,NULL),(46344,'53092','S','Thiensville','A','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.221480,-87.950520,0,'2013-07-06 12:44:32',NULL,NULL),(30402,'33323','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.162098,-80.306679,0,'2013-07-06 12:44:32',NULL,NULL),(18395,'19050','S','Fernwood','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936540,-75.263580,0,'2013-07-06 12:44:31',NULL,NULL),(28819,'32080','S','Anastasia Island','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(73308,'90808','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.819908,-118.105424,0,'2013-07-06 12:44:34',NULL,NULL),(67202,'79908','S','Fort Bliss','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.838148,-106.375434,0,'2013-07-06 12:44:34',NULL,NULL),(58586,'68838','S','Farwell','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.227083,-98.673138,0,'2013-07-06 12:44:33',NULL,NULL),(3857,'02350','P','Monponsett','D','Plymouth','25023','Massachusetts','MA','25','1200','781/339','Eastern',-5.0,'Y',42.016870,-70.848897,0,'2013-07-06 12:44:30',NULL,NULL),(13084,'13464','S','Upperville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.691125,-75.632663,0,'2013-07-06 12:44:30',NULL,NULL),(53593,'62071','P','Natl Stock Yd','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.646662,-90.157901,0,'2013-07-06 12:44:33',NULL,NULL),(9968,'10161','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.747012,-74.005347,0,'2013-07-06 12:44:30',NULL,NULL),(43723,'48919','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.730681,-84.552898,0,'2013-07-06 12:44:32',NULL,NULL),(18162,'18901','S','Doylestown','D','Bucks','42017','Pennsylvania','PA','42','6160','215','Eastern',-5.0,'Y',40.332324,-75.116759,0,'2013-07-06 12:44:31',NULL,NULL),(20917,'21733','S','St James','A','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.548142,-77.762386,0,'2013-07-06 12:44:31',NULL,NULL),(10708,'11234','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.619061,-73.923116,0,'2013-07-06 12:44:30',NULL,NULL),(41201,'46725','S','Etna','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(41352,'46792','S','Dillman','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(79136,'98499','S','McChord AFB','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.162503,-122.510156,0,'2013-07-06 12:44:34',NULL,NULL),(29105,'32306','U','Florida State Univ Admin','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.442453,-84.299083,0,'2013-07-06 12:44:32',NULL,NULL),(14405,'15061','S','Monaca','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.671386,-80.292590,0,'2013-07-06 12:44:31',NULL,NULL),(4398,'03216','S','Andover','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.434421,-71.773453,0,'2013-07-06 12:44:30',NULL,NULL),(1517,'00754','S','Mans De Monte Sereno','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(63337,'75601','S','Tenneryville','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.522353,-94.733035,0,'2013-07-06 12:44:33',NULL,NULL),(79710,'99212','S','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.660806,-117.314906,0,'2013-07-06 12:44:34',NULL,NULL),(49384,'56601','S','Northern','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(36741,'41035','S','Dry Ridge','D','Grant','21081','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.707527,-84.655201,0,'2013-07-06 12:44:32',NULL,NULL),(73676,'91601','S','Valley Village','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.169504,-118.370011,0,'2013-07-06 12:44:34',NULL,NULL),(24473,'27239','S','Newsom','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(13563,'13839','S','Ivanhoe','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.220441,-75.323336,0,'2013-07-06 12:44:31',NULL,NULL),(31442,'34276','P','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.336762,-82.546895,0,'2013-07-06 12:44:32',NULL,NULL),(28845,'32087','S','Sanderson','D','Baker','12003','Florida','FL','12','0000','904','Eastern',-5.0,'Y',30.204150,-82.427506,0,'2013-07-06 12:44:32',NULL,NULL),(25090,'27954','S','Fort Raleigh National Histor','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.915917,-75.677254,0,'2013-07-06 12:44:31',NULL,NULL),(16593,'17324','S','Starners Station','N','Adams','42001','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.011966,-77.195076,0,'2013-07-06 12:44:31',NULL,NULL),(62510,'74401','S','Keefeton','N','Muskogee','40101','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.739900,-95.384940,0,'2013-07-06 12:44:33',NULL,NULL),(72988,'90056','S','Crenshaw','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.984248,-118.364182,0,'2013-07-06 12:44:34',NULL,NULL),(32527,'36093','S','Wetumpka','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.545362,-86.203327,0,'2013-07-06 12:44:32',NULL,NULL),(44490,'49913','S','Laurium','A','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.241904,-88.450576,0,'2013-07-06 12:44:32',NULL,NULL),(52089,'60407','S','Godley','A','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.240640,-88.260120,0,'2013-07-06 12:44:33',NULL,NULL),(58121,'68128','S','Ralston','A','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.183889,-96.030833,0,'2013-07-06 12:44:33',NULL,NULL),(9499,'10013','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(9080,'09014','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(79727,'99215','P','Cty Spok Val','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.690874,-117.209831,0,'2013-07-06 12:44:34',NULL,NULL),(75649,'94528','P','Diablo','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.838423,-121.954252,0,'2013-07-06 12:44:34',NULL,NULL),(69894,'84105','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.734214,-111.856179,0,'2013-07-06 12:44:34',NULL,NULL),(50438,'58004','S','Amenia','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.022377,-97.249357,0,'2013-07-06 12:44:33',NULL,NULL),(48040,'55308','S','Becker','D','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.411381,-93.841945,0,'2013-07-06 12:44:33',NULL,NULL),(38186,'43199','U','Dist Fulfillment Svc','N','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.859691,-82.894413,0,'2013-07-06 12:44:32',NULL,NULL),(31039,'33809','S','Lakeland','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.121806,-81.983669,0,'2013-07-06 12:44:32',NULL,NULL),(31054,'33836','P','Davenport','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.160466,-81.605950,0,'2013-07-06 12:44:32',NULL,NULL),(69827,'84078','S','Naples','A','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.474320,-109.570104,0,'2013-07-06 12:44:34',NULL,NULL),(23980,'26320','S','Alma','D','Tyler','54095','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.424509,-80.827230,0,'2013-07-06 12:44:31',NULL,NULL),(60381,'71497','U','Natch','N','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.755063,-93.101240,0,'2013-07-06 12:44:33',NULL,NULL),(74380,'92506','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.940143,-117.361737,0,'2013-07-06 12:44:34',NULL,NULL),(19753,'20412','U','FHA Comptroller','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.892284,-77.020518,0,'2013-07-06 12:44:31',NULL,NULL),(10065,'10178','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(12360,'12901','S','Plattsburgh','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.727960,-73.463100,0,'2013-07-06 12:44:30',NULL,NULL),(22327,'23857','S','Gasburg','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.542588,-77.877073,0,'2013-07-06 12:44:31',NULL,NULL),(32522,'36089','S','Armstrong','N','Bullock','01011','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.140539,-85.714718,0,'2013-07-06 12:44:32',NULL,NULL),(4360,'03057','S','Mount Vernon','N','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.898128,-71.677913,0,'2013-07-06 12:44:30',NULL,NULL),(27299,'30011','S','Auburn','D','Barrow','13013','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.023740,-83.826404,0,'2013-07-06 12:44:31',NULL,NULL),(46179,'52738','S','Cairo','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.282580,-91.382220,0,'2013-07-06 12:44:32',NULL,NULL),(13343,'13690','S','Star Lake','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.153984,-75.029510,0,'2013-07-06 12:44:30',NULL,NULL),(27033,'29655','S','Iva','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.312100,-82.669680,0,'2013-07-06 12:44:31',NULL,NULL),(10153,'10277','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.718432,-74.015507,0,'2013-07-06 12:44:30',NULL,NULL),(40677,'46060','S','Noblesville','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',40.040132,-86.005910,0,'2013-07-06 12:44:32',NULL,NULL),(57918,'67663','S','Zurich','A','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.232902,-99.303102,0,'2013-07-06 12:44:33',NULL,NULL),(53205,'61614','S','Pottstown','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.746805,-89.575662,0,'2013-07-06 12:44:33',NULL,NULL),(64214,'76264','S','Sadler','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.737011,-96.831865,0,'2013-07-06 12:44:34',NULL,NULL),(17093,'17765','S','Eastpoint','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.555628,-76.892895,0,'2013-07-06 12:44:31',NULL,NULL),(18984,'19522','S','Breezy Corner','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(10536,'10990','S','Warwick','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.263712,-74.367060,0,'2013-07-06 12:44:30',NULL,NULL),(58093,'68105','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.239537,-95.962523,0,'2013-07-06 12:44:33',NULL,NULL),(62219,'73860','S','Waynoka','D','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.587353,-98.880471,0,'2013-07-06 12:44:33',NULL,NULL),(3639,'02108','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.358664,-71.071293,0,'2013-07-06 12:44:30',NULL,NULL),(27305,'30015','P','Covington','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.600466,-83.853776,0,'2013-07-06 12:44:31',NULL,NULL),(15528,'16546','U','Mercyhurst Univ','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.109206,-80.048241,0,'2013-07-06 12:44:31',NULL,NULL),(66326,'78598','P','Port Mansfield','D','Willacy','48489','Texas','TX','48','0000','956','Central',-6.0,'Y',26.560268,-97.431370,0,'2013-07-06 12:44:34',NULL,NULL),(56710,'65675','P','Hurley','D','Stone','29209','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.924539,-93.475964,0,'2013-07-06 12:44:33',NULL,NULL),(73940,'92052','P','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.196976,-117.367059,0,'2013-07-06 12:44:34',NULL,NULL),(25879,'28638','S','Hudson','D','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.845122,-81.491631,0,'2013-07-06 12:44:31',NULL,NULL),(6958,'06230','P','Abington','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.846519,-72.013672,0,'2013-07-06 12:44:30',NULL,NULL),(3759,'02184','S','E Braintree','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.208818,-71.000729,0,'2013-07-06 12:44:30',NULL,NULL),(59661,'71051','S','McDade','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.362958,-93.497801,0,'2013-07-06 12:44:33',NULL,NULL),(51438,'59466','S','Ferdig','A','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.754167,-111.774167,0,'2013-07-06 12:44:33',NULL,NULL),(38264,'43311','S','Bellefontaine','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.359628,-83.757376,0,'2013-07-06 12:44:32',NULL,NULL),(75073,'93532','S','Elizabeth Lake','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(26406,'29112','S','North','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.689919,-81.124565,0,'2013-07-06 12:44:31',NULL,NULL),(25116,'27983','S','Askewville','A','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.997565,-76.943880,0,'2013-07-06 12:44:31',NULL,NULL),(12823,'13304','S','South Trenton','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.231560,-75.157560,0,'2013-07-06 12:44:30',NULL,NULL),(47253,'54521','S','Clearwater Lk','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.910500,-89.224500,0,'2013-07-06 12:44:32',NULL,NULL),(35742,'39730','S','Centralgrove','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(15095,'15763','S','Northpoint','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.901792,-79.121320,0,'2013-07-06 12:44:31',NULL,NULL),(11403,'11953','S','Middle Island','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.877720,-72.955011,0,'2013-07-06 12:44:30',NULL,NULL),(69332,'83526','S','Ferdinand','D','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.127853,-116.420041,0,'2013-07-06 12:44:34',NULL,NULL),(64735,'76888','S','Voss','D','Coleman','48083','Texas','TX','48','0000','325','Central',-6.0,'Y',31.567778,-99.672778,0,'2013-07-06 12:44:34',NULL,NULL),(56684,'65645','P','Morrisville','D','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.481243,-93.537123,0,'2013-07-06 12:44:33',NULL,NULL),(29329,'32544','S','Hurlburt Fld','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.421136,-86.695646,0,'2013-07-06 12:44:32',NULL,NULL),(27295,'30009','S','Alpharetta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.096195,-84.261245,0,'2013-07-06 12:44:31',NULL,NULL),(20345,'20855','S','Rockville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.145020,-77.137560,0,'2013-07-06 12:44:31',NULL,NULL),(40586,'45875','S','Gilboa','A','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.029812,-84.054975,0,'2013-07-06 12:44:32',NULL,NULL),(59983,'71326','S','Junks','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.746480,-91.495320,0,'2013-07-06 12:44:33',NULL,NULL),(67624,'80443','P','Copper Mtn','N','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.574380,-106.096920,0,'2013-07-06 12:44:34',NULL,NULL),(8125,'07827','S','Sandyston','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.306160,-74.748900,0,'2013-07-06 12:44:30',NULL,NULL),(52160,'60451','S','New Lenox','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.510578,-87.963544,0,'2013-07-06 12:44:33',NULL,NULL),(32941,'36569','S','Saint Stephens','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.542499,-88.050964,0,'2013-07-06 12:44:32',NULL,NULL),(20854,'21658','S','Queenstown','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.964400,-76.123558,0,'2013-07-06 12:44:31',NULL,NULL),(1187,'00728','S','Bda Baldorioty','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(11965,'12457','S','Mount Tremper','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.042160,-74.258837,0,'2013-07-06 12:44:30',NULL,NULL),(55593,'63935','S','Poynor','A','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.622500,-90.832800,0,'2013-07-06 12:44:33',NULL,NULL),(51044,'58733','S','Des Lacs','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.239635,-101.595213,0,'2013-07-06 12:44:33',NULL,NULL),(26574,'29215','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.026843,-81.001189,0,'2013-07-06 12:44:31',NULL,NULL),(12216,'12803','S','S Glens Falls','A','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.280520,-73.630020,0,'2013-07-06 12:44:30',NULL,NULL),(55943,'64481','S','Ridgeway','D','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.418120,-93.986501,0,'2013-07-06 12:44:33',NULL,NULL),(40895,'46250','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.903249,-86.068818,0,'2013-07-06 12:44:32',NULL,NULL),(66026,'78362','S','Ingleside','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.869269,-97.204245,0,'2013-07-06 12:44:34',NULL,NULL),(16727,'17408','S','New Salem Bro','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015315,-76.597579,0,'2013-07-06 12:44:31',NULL,NULL),(20668,'21227','S','Lansdowne','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252540,-76.696380,0,'2013-07-06 12:44:31',NULL,NULL),(15244,'16046','S','Seven Fields','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.697780,-80.065812,0,'2013-07-06 12:44:31',NULL,NULL),(9689,'10044','S','Roosevelt Isl','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(38140,'43135','S','Laurelville','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.476647,-82.682155,0,'2013-07-06 12:44:32',NULL,NULL),(39563,'44848','P','Nankin','D','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.920824,-82.281860,0,'2013-07-06 12:44:32',NULL,NULL),(53136,'61550','S','Ossami Lake','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613787,-89.463814,0,'2013-07-06 12:44:33',NULL,NULL),(73335,'90847','U','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.834248,-118.189003,0,'2013-07-06 12:44:34',NULL,NULL),(70325,'84624','S','Woodrow','N','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.362915,-112.574399,0,'2013-07-06 12:44:34',NULL,NULL),(32325,'35765','S','Pisgah','D','Jackson','01071','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.699257,-85.813193,0,'2013-07-06 12:44:32',NULL,NULL),(17535,'17976','S','Kehley Run Junction','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(22351,'23888','S','Wakefield','D','Sussex','51183','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.973535,-76.987737,0,'2013-07-06 12:44:31',NULL,NULL),(66069,'78382','S','Rockport','D','Aransas','48007','Texas','TX','48','0000','361','Central',-6.0,'Y',28.022280,-97.099080,0,'2013-07-06 12:44:34',NULL,NULL),(21659,'22942','S','Zion Crossrds','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.134847,-78.186346,0,'2013-07-06 12:44:31',NULL,NULL),(44946,'50369','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.595940,-93.746203,0,'2013-07-06 12:44:32',NULL,NULL),(79220,'98541','S','Whites','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.010231,-123.411051,0,'2013-07-06 12:44:34',NULL,NULL),(4345,'03042','S','Epping','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.047850,-71.076667,0,'2013-07-06 12:44:30',NULL,NULL),(68752,'82225','S','Kirtley','A','Niobrara','56027','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.803734,-104.337239,0,'2013-07-06 12:44:34',NULL,NULL),(50887,'58533','S','Heil','A','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.409640,-101.831280,0,'2013-07-06 12:44:33',NULL,NULL),(38053,'43047','P','Mingo','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.205526,-83.644226,0,'2013-07-06 12:44:32',NULL,NULL),(33611,'37645','S','Mount Carmel','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.522222,-82.713611,0,'2013-07-06 12:44:32',NULL,NULL),(665,'00683','S','Repto Universidad','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(70542,'85026','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.456034,-111.979230,0,'2013-07-06 12:44:34',NULL,NULL),(24317,'27020','S','Buck Shoals','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.095640,-80.795700,0,'2013-07-06 12:44:31',NULL,NULL),(31069,'33851','P','Lake Hamilton','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.044293,-81.623281,0,'2013-07-06 12:44:32',NULL,NULL),(46507,'53235','S','St Francis','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.969046,-87.871317,0,'2013-07-06 12:44:32',NULL,NULL),(79365,'98649','S','Toutle','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.317705,-122.692327,0,'2013-07-06 12:44:34',NULL,NULL),(2561,'00959','S','Urb Hnas Davila','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(39244,'44431','S','Leetonia','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.860443,-80.754830,0,'2013-07-06 12:44:32',NULL,NULL),(41625,'47129','S','Jeffersonville','A','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.316146,-85.769135,0,'2013-07-06 12:44:32',NULL,NULL),(1359,'00736','S','Urb Aponte','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(33977,'38112','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.145279,-89.979378,0,'2013-07-06 12:44:32',NULL,NULL),(65855,'78206','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.416807,-98.498525,0,'2013-07-06 12:44:34',NULL,NULL),(40697,'46077','S','Zionsville','D','Boone','18011','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.956095,-86.273792,0,'2013-07-06 12:44:32',NULL,NULL),(23213,'25075','S','Kayford','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(50417,'57785','S','Marcus','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.408276,-103.511437,0,'2013-07-06 12:44:33',NULL,NULL),(47323,'54560','S','Plum Lake','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.993836,-89.520140,0,'2013-07-06 12:44:32',NULL,NULL),(19486,'20151','S','Chantilly','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.888306,-77.453725,0,'2013-07-06 12:44:31',NULL,NULL),(78165,'97632','S','Malin','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.019082,-121.428116,0,'2013-07-06 12:44:34',NULL,NULL),(72824,'89821','S','Dunphy','N','Eureka','32011','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.580000,-116.480000,0,'2013-07-06 12:44:34',NULL,NULL),(22957,'24701','S','Ada','N','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.281000,-81.197280,0,'2013-07-06 12:44:31',NULL,NULL),(8789,'08559','S','Stockton','D','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.432795,-74.954631,0,'2013-07-06 12:44:30',NULL,NULL),(59530,'70808','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.409457,-91.139053,0,'2013-07-06 12:44:33',NULL,NULL),(21805,'23089','S','Lanexa','D','New Kent','51127','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.473120,-76.905831,0,'2013-07-06 12:44:31',NULL,NULL),(18570,'19126','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.055969,-75.135303,0,'2013-07-06 12:44:31',NULL,NULL),(18838,'19426','S','Collegeville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.188960,-75.426360,0,'2013-07-06 12:44:31',NULL,NULL),(18600,'19140','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.013413,-75.144023,0,'2013-07-06 12:44:31',NULL,NULL),(6211,'05487','S','South Starksboro','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.229720,-73.013400,0,'2013-07-06 12:44:30',NULL,NULL),(59189,'70360','S','Allemand','N','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.607360,-90.782400,0,'2013-07-06 12:44:33',NULL,NULL),(38692,'43986','S','Jewett','D','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.371767,-80.989071,0,'2013-07-06 12:44:32',NULL,NULL),(56174,'64999','U','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.953479,-94.549666,0,'2013-07-06 12:44:33',NULL,NULL),(15825,'16933','S','Kellytown','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.773056,-77.200833,0,'2013-07-06 12:44:31',NULL,NULL),(58532,'68801','S','Hall County Regional Airport','N','Hall','31079','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.923320,-98.336430,0,'2013-07-06 12:44:33',NULL,NULL),(28707,'31827','S','Talbotton','D','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.701566,-84.487321,0,'2013-07-06 12:44:32',NULL,NULL),(62979,'75143','S','Kemp','D','Kaufman','48257','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.366040,-96.286680,0,'2013-07-06 12:44:33',NULL,NULL),(53139,'61554','S','Marquette Heights','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(26331,'29054','S','Gilbert','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.948355,-81.383815,0,'2013-07-06 12:44:31',NULL,NULL),(68530,'81411','S','Bedrock','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.334387,-108.885548,0,'2013-07-06 12:44:34',NULL,NULL),(13286,'13660','S','Madrid','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.749316,-75.132378,0,'2013-07-06 12:44:30',NULL,NULL),(11331,'11790','S','Stony Brook','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.905287,-73.125351,0,'2013-07-06 12:44:30',NULL,NULL),(63738,'75935','S','Good Hope','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(19701,'20376','S','Washington Na','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916809,-76.993655,0,'2013-07-06 12:44:31',NULL,NULL),(298,'00646','S','Urb Gables Breeze','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(56369,'65216','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.961050,-92.325791,0,'2013-07-06 12:44:33',NULL,NULL),(55610,'63955','S','Oxly','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.583578,-90.688128,0,'2013-07-06 12:44:33',NULL,NULL),(38179,'43162','S','W Jefferson','A','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.943824,-83.293373,0,'2013-07-06 12:44:32',NULL,NULL),(35042,'39171','P','Thomastown','D','Leake','28079','Mississippi','MS','28','0000','662','Central',-6.0,'Y',32.863506,-89.670941,0,'2013-07-06 12:44:32',NULL,NULL),(9023,'08871','P','Sayreville','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.465874,-74.323603,0,'2013-07-06 12:44:30',NULL,NULL),(15930,'17021','S','East Waterford','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.360534,-77.674744,0,'2013-07-06 12:44:31',NULL,NULL),(54006,'62447','S','Trowbridge','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.321626,-88.454756,0,'2013-07-06 12:44:33',NULL,NULL),(7910,'07624','S','Closter','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.971961,-73.961859,0,'2013-07-06 12:44:30',NULL,NULL),(39944,'45230','S','Mount Washington','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.078715,-84.377216,0,'2013-07-06 12:44:32',NULL,NULL),(7117,'06378','S','Lords Point','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.344260,-71.911442,0,'2013-07-06 12:44:30',NULL,NULL),(70060,'84143','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.779354,-111.880031,0,'2013-07-06 12:44:34',NULL,NULL),(53149,'61558','U','Pekin','D','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.567474,-89.638253,0,'2013-07-06 12:44:33',NULL,NULL),(8819,'08619','S','Hamilton Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.238460,-74.717460,0,'2013-07-06 12:44:30',NULL,NULL),(11665,'12139','S','Arietta','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.390766,-74.606599,0,'2013-07-06 12:44:30',NULL,NULL),(19891,'20537','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897231,-77.025361,0,'2013-07-06 12:44:31',NULL,NULL),(69350,'83543','S','Nezperce','D','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.219251,-116.248211,0,'2013-07-06 12:44:34',NULL,NULL),(59522,'70803','U','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.408018,-91.188669,0,'2013-07-06 12:44:33',NULL,NULL),(55374,'63601','S','Leadington','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.855031,-90.518894,0,'2013-07-06 12:44:33',NULL,NULL),(15812,'16928','S','Knoxville','D','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.954882,-77.440143,0,'2013-07-06 12:44:31',NULL,NULL),(44810,'50238','S','New York','N','Lucas','19117','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.983991,-93.199488,0,'2013-07-06 12:44:32',NULL,NULL),(35089,'39204','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.285241,-90.230923,0,'2013-07-06 12:44:32',NULL,NULL),(78169,'97635','S','New Pine Crk','A','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.052488,-120.234489,0,'2013-07-06 12:44:34',NULL,NULL),(25500,'28371','S','Parkton','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.900876,-79.005897,0,'2013-07-06 12:44:31',NULL,NULL),(40720,'46121','S','Coatesville','D','Putnam','18133','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.673090,-86.664333,0,'2013-07-06 12:44:32',NULL,NULL),(16130,'17057','S','Royalton','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.204159,-76.734268,0,'2013-07-06 12:44:31',NULL,NULL),(52771,'61261','S','Lyndon','D','Whiteside','17195','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.725560,-89.915984,0,'2013-07-06 12:44:33',NULL,NULL),(43010,'48164','S','Brownstown','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(58090,'68103','P','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.257105,-95.944998,0,'2013-07-06 12:44:33',NULL,NULL),(57445,'66840','S','Burns','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.086035,-96.884066,0,'2013-07-06 12:44:33',NULL,NULL),(25811,'28607','S','Sands','N','Watauga','37189','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.218640,-81.654600,0,'2013-07-06 12:44:31',NULL,NULL),(23985,'26325','S','Auburn','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.088910,-80.897635,0,'2013-07-06 12:44:31',NULL,NULL),(46788,'53962','P','Union Center','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.682465,-90.267028,0,'2013-07-06 12:44:32',NULL,NULL),(48294,'55437','S','Bloomington','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.822599,-93.341540,0,'2013-07-06 12:44:33',NULL,NULL),(45756,'52142','S','Fayette','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.857326,-91.809593,0,'2013-07-06 12:44:32',NULL,NULL),(64798,'77018','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.827979,-95.426715,0,'2013-07-06 12:44:34',NULL,NULL),(44263,'49686','S','Traverse City','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.754969,-85.596072,0,'2013-07-06 12:44:32',NULL,NULL),(34152,'38241','S','Palmersville','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.284486,-88.699663,0,'2013-07-06 12:44:32',NULL,NULL),(1265,'00730','S','Bda Borinquen','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(57978,'67839','S','Dighton','D','Lane','20101','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.462460,-100.435140,0,'2013-07-06 12:44:33',NULL,NULL),(56730,'65707','S','Grays Point','N','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.231449,-93.849869,0,'2013-07-06 12:44:33',NULL,NULL),(55330,'63547','S','Kenwood','N','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.145709,-92.302124,0,'2013-07-06 12:44:33',NULL,NULL),(68620,'81624','S','Plateau City','N','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.237222,-107.981111,0,'2013-07-06 12:44:34',NULL,NULL),(10901,'11426','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.733204,-73.722052,0,'2013-07-06 12:44:30',NULL,NULL),(36046,'40205','S','Strathmoor Village','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(46106,'52631','P','Houghton','D','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.770855,-91.661151,0,'2013-07-06 12:44:32',NULL,NULL),(44012,'49357','U','Ada','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.950385,-85.487478,0,'2013-07-06 12:44:32',NULL,NULL),(42498,'47842','S','Crompton Hill','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(2570,'00959','S','Urb Victoria Hts','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(64177,'76230','S','Bowie','D','Montague','48337','Texas','TX','48','0000','940','Central',-6.0,'Y',33.561402,-97.838818,0,'2013-07-06 12:44:34',NULL,NULL),(26243,'28816','P','W Asheville','N','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.581775,-82.601410,0,'2013-07-06 12:44:31',NULL,NULL),(62556,'74444','P','Moodys','D','Cherokee','40021','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.028524,-94.955765,0,'2013-07-06 12:44:33',NULL,NULL),(31221,'33960','S','Venus','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.094549,-81.397416,0,'2013-07-06 12:44:32',NULL,NULL),(3106,'01230','S','Gt Barrington','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(31535,'34489','P','Silver Spgs','A','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.226877,-81.948070,0,'2013-07-06 12:44:32',NULL,NULL),(47082,'54433','S','Polley','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.214708,-90.818461,0,'2013-07-06 12:44:32',NULL,NULL),(41252,'46742','S','Russels Point','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(7159,'06424','S','East Hampton','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.560080,-72.501360,0,'2013-07-06 12:44:30',NULL,NULL),(10091,'10212','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713127,-74.010130,0,'2013-07-06 12:44:30',NULL,NULL),(69697,'84031','S','Hanna','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.436388,-110.826187,0,'2013-07-06 12:44:34',NULL,NULL),(61510,'72653','S','Mountain Home','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.352620,-92.366700,0,'2013-07-06 12:44:33',NULL,NULL),(40092,'45305','S','Beavercrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.636147,-84.082389,0,'2013-07-06 12:44:32',NULL,NULL),(51659,'59904','P','Kalispell','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.194518,-114.312264,0,'2013-07-06 12:44:33',NULL,NULL),(47858,'55077','S','Sunfish Lake','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.839723,-93.076930,0,'2013-07-06 12:44:33',NULL,NULL),(76821,'95957','S','Meridian','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',39.107422,-121.863955,0,'2013-07-06 12:44:34',NULL,NULL),(26379,'29081','S','Ehrhardt','D','Bamberg','45009','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.107954,-81.022941,0,'2013-07-06 12:44:31',NULL,NULL),(1691,'00777','S','Repto Valenciano','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(73433,'91210','S','Glendale Galleria','N','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.141910,-118.260565,0,'2013-07-06 12:44:34',NULL,NULL),(79099,'98445','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.137362,-122.409805,0,'2013-07-06 12:44:34',NULL,NULL),(13784,'14166','P','Van Buren Pt','A','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.450113,-79.417318,0,'2013-07-06 12:44:31',NULL,NULL),(67535,'80257','U','Us Court of Appeals 10th Cir','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.751093,-104.999498,0,'2013-07-06 12:44:34',NULL,NULL),(10162,'10279','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(28897,'32129','S','Pt Orange','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.148785,-81.025137,0,'2013-07-06 12:44:32',NULL,NULL),(45584,'51541','S','Henderson','D','Mills','19129','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.141456,-95.431242,0,'2013-07-06 12:44:32',NULL,NULL),(9817,'10112','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760660,-73.981818,0,'2013-07-06 12:44:30',NULL,NULL),(72620,'89418','S','Mill City','A','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(59970,'71320','P','Bordelonville','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.108017,-91.906707,0,'2013-07-06 12:44:33',NULL,NULL),(62732,'74824','S','Agra','D','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.896999,-96.873429,0,'2013-07-06 12:44:33',NULL,NULL),(35158,'39236','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364207,-90.145180,0,'2013-07-06 12:44:32',NULL,NULL),(76877,'95975','S','Rough and Ready','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.223350,-121.143204,0,'2013-07-06 12:44:34',NULL,NULL),(4735,'03832','P','Eaton Ctr','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.911744,-71.083715,0,'2013-07-06 12:44:30',NULL,NULL),(25235,'28101','S','Mc Adenville','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.258051,-81.079408,0,'2013-07-06 12:44:31',NULL,NULL),(30210,'33183','S','Kendall','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.700327,-80.408398,0,'2013-07-06 12:44:32',NULL,NULL),(36331,'40390','S','Wilmore','D','Jessamine','21113','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.862373,-84.648746,0,'2013-07-06 12:44:32',NULL,NULL),(76484,'95630','S','Mormon Island','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.683096,-121.160535,0,'2013-07-06 12:44:34',NULL,NULL),(59994,'71328','S','Hickory Grove','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(31227,'33967','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637179,-81.872520,0,'2013-07-06 12:44:32',NULL,NULL),(6051,'05442','S','Belvidere','N','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.772686,-72.663680,0,'2013-07-06 12:44:30',NULL,NULL),(26766,'29437','S','Dorchester','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.143072,-80.378909,0,'2013-07-06 12:44:31',NULL,NULL),(2925,'01013','S','Chicopee','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.162301,-72.604454,0,'2013-07-06 12:44:30',NULL,NULL),(3367,'01583','S','Oakdale','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.360502,-71.787608,0,'2013-07-06 12:44:30',NULL,NULL),(26995,'29626','S','Anderson','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.444494,-82.754302,0,'2013-07-06 12:44:31',NULL,NULL),(71931,'87832','S','Bingham','A','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.910833,-106.348889,0,'2013-07-06 12:44:34',NULL,NULL),(4552,'03455','S','Marlborough','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.896040,-72.189420,0,'2013-07-06 12:44:30',NULL,NULL),(57234,'66515','S','Morrill','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.950909,-95.727527,0,'2013-07-06 12:44:33',NULL,NULL),(54290,'62703','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.772322,-89.632328,0,'2013-07-06 12:44:33',NULL,NULL),(10785,'11368','S','Corona','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.752572,-73.854759,0,'2013-07-06 12:44:30',NULL,NULL),(26796,'29458','S','Mc Clellanville','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.103751,-79.470346,0,'2013-07-06 12:44:31',NULL,NULL),(47764,'55033','S','Hastings','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.732642,-92.850259,0,'2013-07-06 12:44:33',NULL,NULL),(15701,'16851','P','Lemont','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.811791,-77.814403,0,'2013-07-06 12:44:31',NULL,NULL),(63909,'76036','S','Crowley','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.584696,-97.371992,0,'2013-07-06 12:44:34',NULL,NULL),(23989,'26330','S','Lake Ridge','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.289276,-80.254283,0,'2013-07-06 12:44:31',NULL,NULL),(34662,'38801','S','Ballardsville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.233855,-88.738853,0,'2013-07-06 12:44:32',NULL,NULL),(34828,'38917','S','Carrollton','D','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.632500,-89.895000,0,'2013-07-06 12:44:32',NULL,NULL),(19893,'20538','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901597,-77.017489,0,'2013-07-06 12:44:31',NULL,NULL),(10531,'10987','S','Tuxedo','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.200012,-74.216239,0,'2013-07-06 12:44:30',NULL,NULL),(5843,'05089','S','West Windsor','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.475040,-72.427380,0,'2013-07-06 12:44:30',NULL,NULL),(70587,'85080','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.633614,-112.111004,0,'2013-07-06 12:44:34',NULL,NULL),(59407,'70643','S','Grand Chenier','D','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.795445,-92.783145,0,'2013-07-06 12:44:33',NULL,NULL),(59314,'70519','P','Cade','D','Saint Martin','22099','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.105088,-91.913628,0,'2013-07-06 12:44:33',NULL,NULL),(10229,'10462','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.840999,-73.857210,0,'2013-07-06 12:44:30',NULL,NULL),(28253,'31064','S','Monticello','D','Jasper','13159','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.332348,-83.758157,0,'2013-07-06 12:44:31',NULL,NULL),(44921,'50334','U','American Republic','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.627111,-93.710893,0,'2013-07-06 12:44:32',NULL,NULL),(43688,'48880','S','Saint Louis','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.409427,-84.599079,0,'2013-07-06 12:44:32',NULL,NULL),(22012,'23286','U','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557404,-77.447536,0,'2013-07-06 12:44:31',NULL,NULL),(12886,'13329','S','Manheim','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.103700,-74.740980,0,'2013-07-06 12:44:30',NULL,NULL),(42243,'47568','S','Plainville','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.777115,-87.180839,0,'2013-07-06 12:44:32',NULL,NULL),(33142,'36913','S','Melvin','D','Choctaw','01023','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.928964,-88.457923,0,'2013-07-06 12:44:32',NULL,NULL),(10852,'11413','S','Laurelton','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(27254,'29929','S','Ashton','N','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.953565,-80.883542,0,'2013-07-06 12:44:31',NULL,NULL),(32855,'36507','S','Bay Minette','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.874562,-87.775538,0,'2013-07-06 12:44:32',NULL,NULL),(58921,'69337','S','Chadron','D','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.831016,-103.001366,0,'2013-07-06 12:44:33',NULL,NULL),(20901,'21714','P','Braddock Hts','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.415134,-77.505881,0,'2013-07-06 12:44:31',NULL,NULL),(15230,'16029','P','East Butler','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.880385,-79.845270,0,'2013-07-06 12:44:31',NULL,NULL),(71373,'87002','S','Los Chavez','N','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.656448,-106.759548,0,'2013-07-06 12:44:34',NULL,NULL),(62024,'73460','S','Tishomingo','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.232285,-96.673345,0,'2013-07-06 12:44:33',NULL,NULL),(41406,'46815','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.113302,-85.061006,0,'2013-07-06 12:44:32',NULL,NULL),(57470,'66862','S','Matfield Grn','A','Chase','20017','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.143372,-96.497559,0,'2013-07-06 12:44:33',NULL,NULL),(52119,'60426','S','Dixmoor','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.604606,-87.669030,0,'2013-07-06 12:44:33',NULL,NULL),(8045,'07734','S','Keansburg','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.439051,-74.125510,0,'2013-07-06 12:44:30',NULL,NULL),(42942,'48118','S','Luce Twp','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.317447,-84.030349,0,'2013-07-06 12:44:32',NULL,NULL),(29601,'32834','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.563579,-81.206956,0,'2013-07-06 12:44:32',NULL,NULL),(28556,'31566','S','Waynesville','D','Brantley','13025','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.249057,-81.820471,0,'2013-07-06 12:44:32',NULL,NULL),(21285,'22333','U','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.815071,-77.113643,0,'2013-07-06 12:44:31',NULL,NULL),(19661,'20307','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.972480,-77.029182,0,'2013-07-06 12:44:31',NULL,NULL),(42831,'48065','S','Bruce TWP','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.840846,-83.032465,0,'2013-07-06 12:44:32',NULL,NULL),(32217,'35571','S','Atwood','N','Franklin','01059','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.344894,-87.968525,0,'2013-07-06 12:44:32',NULL,NULL),(14761,'15333','S','Fredericktown','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.028384,-80.018794,0,'2013-07-06 12:44:31',NULL,NULL),(9053,'08890','P','Zarephath','D','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.538485,-74.577082,0,'2013-07-06 12:44:30',NULL,NULL),(76106,'95227','P','Clements','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.201788,-121.069202,0,'2013-07-06 12:44:34',NULL,NULL),(769,'00692','S','Urb Puesta Del Sol','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(6449,'05758','S','Hortonville','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.450800,-72.791580,0,'2013-07-06 12:44:30',NULL,NULL),(19586,'20220','U','Dept Treasury','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899749,-77.031261,0,'2013-07-06 12:44:31',NULL,NULL),(80152,'99789','P','Barrow','A','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.235770,-151.126315,0,'2013-07-06 12:44:34',NULL,NULL),(27733,'30350','S','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975825,-84.325274,0,'2013-07-06 12:44:31',NULL,NULL),(99,'00612','S','Urb Factor','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(47427,'54667','S','Bloomingdale','N','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.653908,-90.859455,0,'2013-07-06 12:44:32',NULL,NULL),(59843,'71249','P','Jigger','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.034328,-91.746559,0,'2013-07-06 12:44:33',NULL,NULL),(44134,'49512','S','GR','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.881460,-85.535400,0,'2013-07-06 12:44:32',NULL,NULL),(32050,'35254','U','Birmingham Southern College','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513945,-86.853654,0,'2013-07-06 12:44:32',NULL,NULL),(16970,'17723','S','Cammal','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.391600,-77.471280,0,'2013-07-06 12:44:31',NULL,NULL),(67,'00612','S','Bo Islote Ii','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(66791,'79054','P','Lefors','D','Gray','48179','Texas','TX','48','0000','806','Central',-6.0,'Y',35.436648,-100.806171,0,'2013-07-06 12:44:34',NULL,NULL),(59560,'70831','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.448890,-91.185962,0,'2013-07-06 12:44:33',NULL,NULL),(16195,'17070','S','Marsh Run','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(36504,'40823','S','Cumberland','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.975189,-82.986975,0,'2013-07-06 12:44:32',NULL,NULL),(26291,'29021','P','Kirkland','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313874,-80.605934,0,'2013-07-06 12:44:31',NULL,NULL),(3183,'01339','S','Hawley','A','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.645420,-72.880260,0,'2013-07-06 12:44:30',NULL,NULL),(58836,'69122','S','Big Springs','D','Deuel','31049','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.109609,-102.144422,0,'2013-07-06 12:44:33',NULL,NULL),(34225,'38367','S','Ramer','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.052884,-88.638071,0,'2013-07-06 12:44:32',NULL,NULL),(22312,'23836','S','Chester','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.349033,-77.323940,0,'2013-07-06 12:44:31',NULL,NULL),(68422,'81211','S','Buena Vista','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.849213,-106.155646,0,'2013-07-06 12:44:34',NULL,NULL),(59950,'71301','S','Moreland','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(34903,'38955','P','Calhoun City','A','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(41535,'46995','P','West Middleton','D','Howard','18067','Indiana','IN','18','3850','765','Eastern',-5.0,'Y',40.439485,-86.217646,0,'2013-07-06 12:44:32',NULL,NULL),(80062,'99720','P','Allakaket','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.543114,-152.737183,0,'2013-07-06 12:44:34',NULL,NULL),(30110,'33160','S','North Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.940364,-80.139706,0,'2013-07-06 12:44:32',NULL,NULL),(43644,'48837','S','Grand Ledge','D','Eaton','26045','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.741897,-84.743758,0,'2013-07-06 12:44:32',NULL,NULL),(51733,'60012','S','Ridgefield','N','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.270000,-88.304220,0,'2013-07-06 12:44:33',NULL,NULL),(32613,'36135','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.387934,-86.151025,0,'2013-07-06 12:44:32',NULL,NULL),(49068,'56313','P','Bock','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.785033,-93.551708,0,'2013-07-06 12:44:33',NULL,NULL),(46568,'53520','S','Brodhead','D','Green','55045','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.621933,-89.373581,0,'2013-07-06 12:44:32',NULL,NULL),(40835,'46216','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861466,-86.014172,0,'2013-07-06 12:44:32',NULL,NULL),(30576,'33415','S','Greenacres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.663672,-80.126382,0,'2013-07-06 12:44:32',NULL,NULL),(14484,'15133','S','Port Vue','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.332947,-79.865183,0,'2013-07-06 12:44:31',NULL,NULL),(74226,'92316','S','Crestmore','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.069928,-117.397247,0,'2013-07-06 12:44:34',NULL,NULL),(76544,'95661','S','Roseville','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.732237,-121.225981,0,'2013-07-06 12:44:34',NULL,NULL),(79409,'98815','S','Cashmere','D','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.529334,-120.479427,0,'2013-07-06 12:44:34',NULL,NULL),(56186,'65014','S','Canaan','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(75294,'93725','S','Malaga','N','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.662145,-119.740783,0,'2013-07-06 12:44:34',NULL,NULL),(3107,'01230','S','Hartsville','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(64963,'77249','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.804629,-95.375621,0,'2013-07-06 12:44:34',NULL,NULL),(56823,'65786','S','Macks Creek','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.976586,-92.968476,0,'2013-07-06 12:44:33',NULL,NULL),(15439,'16401','S','Albion','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.884381,-80.379163,0,'2013-07-06 12:44:31',NULL,NULL),(24585,'27320','S','Camp Springs','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(14961,'15622','S','Champion','D','Westmoreland','42129','Pennsylvania','PA','42','6280','814','Eastern',-5.0,'Y',40.040231,-79.323715,0,'2013-07-06 12:44:31',NULL,NULL),(21925,'23225','S','N Chesterfld','A','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.517420,-77.501037,0,'2013-07-06 12:44:31',NULL,NULL),(13219,'13634','S','Guffin Bay','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(31200,'33946','S','Placida','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.851772,-82.287635,0,'2013-07-06 12:44:32',NULL,NULL),(14449,'15104','S','Braddock','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.406423,-79.863859,0,'2013-07-06 12:44:31',NULL,NULL),(11840,'12246','U','S U N Y 99 Wash','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.689007,-73.821157,0,'2013-07-06 12:44:30',NULL,NULL),(54453,'62850','S','Orchardville','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.526480,-88.590120,0,'2013-07-06 12:44:33',NULL,NULL),(42971,'48135','S','Garden City','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.324302,-83.338607,0,'2013-07-06 12:44:32',NULL,NULL),(26024,'28678','S','Stony Point','D','Alexander','37003','North Carolina','NC','37','3290','704/980','Eastern',-5.0,'Y',35.851332,-81.043467,0,'2013-07-06 12:44:31',NULL,NULL),(71870,'87724','S','Dilia','N','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.195854,-105.084813,0,'2013-07-06 12:44:34',NULL,NULL),(66949,'79371','S','Goodland','N','Lamb','48279','Texas','TX','48','0000','806','Central',-6.0,'Y',34.062057,-102.523858,0,'2013-07-06 12:44:34',NULL,NULL),(11415,'11961','S','Ridge','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.896900,-72.884340,0,'2013-07-06 12:44:30',NULL,NULL),(30184,'33177','S','Country Lakes','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.592736,-80.405844,0,'2013-07-06 12:44:32',NULL,NULL),(22182,'23479','U','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.846156,-76.092025,0,'2013-07-06 12:44:31',NULL,NULL),(45799,'52171','S','Jackson Jct','A','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.058499,-91.990554,0,'2013-07-06 12:44:32',NULL,NULL),(80068,'99724','P','Beaver','D','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.660573,-147.574438,0,'2013-07-06 12:44:34',NULL,NULL),(72873,'90009','P','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.946348,-118.379884,0,'2013-07-06 12:44:34',NULL,NULL),(58372,'68527','S','Prairie Home','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.842546,-96.535412,0,'2013-07-06 12:44:33',NULL,NULL),(13095,'13473','S','Houseville','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.655600,-75.428792,0,'2013-07-06 12:44:30',NULL,NULL),(10830,'11381','U','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715918,-73.875773,0,'2013-07-06 12:44:30',NULL,NULL),(1230,'00728','S','Villa Paraiso','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(45460,'51244','S','Matlock','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.215655,-95.978975,0,'2013-07-06 12:44:32',NULL,NULL),(46239,'52805','P','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.572625,-90.602314,0,'2013-07-06 12:44:32',NULL,NULL),(6885,'06142','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.775997,-72.697466,0,'2013-07-06 12:44:30',NULL,NULL),(19408,'20078','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.916403,-76.994507,0,'2013-07-06 12:44:31',NULL,NULL),(42933,'48116','S','Crooked Lake','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.532103,-83.773187,0,'2013-07-06 12:44:32',NULL,NULL),(57994,'67855','S','Johnson','D','Stanton','20187','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.571880,-101.714760,0,'2013-07-06 12:44:33',NULL,NULL),(47699,'54978','S','Tilleda','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.782821,-88.897067,0,'2013-07-06 12:44:33',NULL,NULL),(46617,'53575','S','Fitchburg','A','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',42.931421,-89.389758,0,'2013-07-06 12:44:32',NULL,NULL),(72507,'89151','U','Nevada Power','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.145667,-115.227731,0,'2013-07-06 12:44:34',NULL,NULL),(55693,'64063','S','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(24274,'26847','S','Petersburg','D','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.996532,-79.123849,0,'2013-07-06 12:44:31',NULL,NULL),(38402,'43530','P','Jewell','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.327153,-84.284934,0,'2013-07-06 12:44:32',NULL,NULL),(775,'00692','S','Vega Alta','D','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(13741,'14110','P','N Boston','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.684526,-78.774487,0,'2013-07-06 12:44:31',NULL,NULL),(22786,'24459','S','Middlebrook','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.025912,-79.283055,0,'2013-07-06 12:44:31',NULL,NULL),(45139,'50579','S','Lanedale','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(43606,'48768','S','Vassar','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.368767,-83.574866,0,'2013-07-06 12:44:32',NULL,NULL),(46395,'53156','S','Palmyra','D','Jefferson','55055','Wisconsin','WI','55','0000','414','Central',-6.0,'Y',42.875121,-88.585220,0,'2013-07-06 12:44:32',NULL,NULL),(24877,'27697','U','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.778849,-78.623747,0,'2013-07-06 12:44:31',NULL,NULL),(35449,'39482','S','Higgins','N','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.362960,-89.589180,0,'2013-07-06 12:44:32',NULL,NULL),(40184,'45374','U','Hobart Corp','N','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.044093,-84.217683,0,'2013-07-06 12:44:32',NULL,NULL),(66590,'78749','S','Oak Hill','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.211620,-97.851840,0,'2013-07-06 12:44:34',NULL,NULL),(21378,'22476','S','Hustle','D','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.022747,-77.047665,0,'2013-07-06 12:44:31',NULL,NULL),(25852,'28624','S','Hendrix','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.156660,-81.393840,0,'2013-07-06 12:44:31',NULL,NULL),(44728,'50156','S','Madrid','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.875552,-93.819402,0,'2013-07-06 12:44:32',NULL,NULL),(61906,'73144','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.411174,-97.556980,0,'2013-07-06 12:44:33',NULL,NULL),(4044,'02631','S','Brewster','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.749983,-70.074588,0,'2013-07-06 12:44:30',NULL,NULL),(13850,'14226','S','Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.969504,-78.798576,0,'2013-07-06 12:44:31',NULL,NULL),(32845,'36483','S','Bradley','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.123075,-86.584525,0,'2013-07-06 12:44:32',NULL,NULL),(70336,'84630','S','Fayette','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.220217,-111.869307,0,'2013-07-06 12:44:34',NULL,NULL),(64137,'76195','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.726738,-97.317356,0,'2013-07-06 12:44:34',NULL,NULL),(16091,'17051','S','Little Kansas','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(53829,'62301','S','Marblehead','N','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.931262,-91.379720,0,'2013-07-06 12:44:33',NULL,NULL),(49855,'57243','S','Henry','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.888142,-97.432744,0,'2013-07-06 12:44:33',NULL,NULL),(36128,'40223','S','Meadowbrook Farm','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.255940,-85.514040,0,'2013-07-06 12:44:32',NULL,NULL),(31603,'34674','P','Port Richey','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.357719,-82.698689,0,'2013-07-06 12:44:32',NULL,NULL),(29843,'33033','S','Naranja','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.494244,-80.432291,0,'2013-07-06 12:44:32',NULL,NULL),(5869,'05144','P','Spoonerville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.286631,-72.634544,0,'2013-07-06 12:44:30',NULL,NULL),(53869,'62341','S','Hamilton','D','Hancock','17067','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.394115,-91.335644,0,'2013-07-06 12:44:33',NULL,NULL),(10041,'10174','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(78660,'98232','S','Allen','N','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.562380,-122.444940,0,'2013-07-06 12:44:34',NULL,NULL),(22292,'23806','U','Petersburg','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.226377,-77.403086,0,'2013-07-06 12:44:31',NULL,NULL),(12598,'13078','S','Jamesville','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.967440,-76.060740,0,'2013-07-06 12:44:30',NULL,NULL),(45883,'52255','S','Massillon','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.860439,-90.928486,0,'2013-07-06 12:44:32',NULL,NULL),(74941,'93409','U','California Mens Colony SLO','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.220710,-120.636882,0,'2013-07-06 12:44:34',NULL,NULL),(27780,'30375','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.775206,-84.389428,0,'2013-07-06 12:44:31',NULL,NULL),(55308,'63534','S','Kaseyville','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.739621,-92.645570,0,'2013-07-06 12:44:33',NULL,NULL),(23711,'25880','S','Kilsyth','N','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.893074,-81.167686,0,'2013-07-06 12:44:31',NULL,NULL),(52332,'60567','P','Naperville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.783823,-88.146897,0,'2013-07-06 12:44:33',NULL,NULL),(79995,'99662','P','Scammon Bay','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.792836,-165.071630,0,'2013-07-06 12:44:34',NULL,NULL),(52245,'60514','S','Clarendon Hls','A','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.772480,-87.957180,0,'2013-07-06 12:44:33',NULL,NULL),(27458,'30132','S','Dallas','D','Paulding','13223','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.994458,-84.859977,0,'2013-07-06 12:44:31',NULL,NULL),(74140,'92250','S','Holtville','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.808254,-115.375136,0,'2013-07-06 12:44:34',NULL,NULL),(17148,'17801','S','Sevenpoints','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(62446,'74187','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.147918,-95.994333,0,'2013-07-06 12:44:33',NULL,NULL),(75098,'93539','P','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.691705,-118.132025,0,'2013-07-06 12:44:34',NULL,NULL),(30165,'33172','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796061,-80.360119,0,'2013-07-06 12:44:32',NULL,NULL),(46625,'53581','S','Boaz','N','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.351140,-90.389940,0,'2013-07-06 12:44:32',NULL,NULL),(77614,'96950','P','Saipan','D','Northern Mariana Islands','69010','Northern Mariana Islands','MP','69','0000','670','UTC+10',10.0,'N',15.181897,145.756677,0,'2013-07-06 12:44:34',NULL,NULL),(79066,'98431','U','JB Lewis McChord','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(74005,'92112','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.725903,-117.164620,0,'2013-07-06 12:44:34',NULL,NULL),(27464,'30139','S','Fairmount','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.460296,-84.740922,0,'2013-07-06 12:44:31',NULL,NULL),(73336,'90848','U','AARP','N','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.830348,-118.184925,0,'2013-07-06 12:44:34',NULL,NULL),(53529,'62031','S','Nutwood','N','Jersey','17083','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',39.101331,-90.556238,0,'2013-07-06 12:44:33',NULL,NULL),(42696,'47991','S','West Lebanon','D','Warren','18171','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.270611,-87.385722,0,'2013-07-06 12:44:32',NULL,NULL),(65240,'77455','S','Louise','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.164080,-96.406800,0,'2013-07-06 12:44:34',NULL,NULL),(64931,'77216','U','Chase Bank','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.615732,-95.216522,0,'2013-07-06 12:44:34',NULL,NULL),(62908,'75071','S','Mc Kinney','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.167006,-96.597465,0,'2013-07-06 12:44:33',NULL,NULL),(41332,'46779','S','Pleasant Lake','D','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.593680,-85.012980,0,'2013-07-06 12:44:32',NULL,NULL),(76846,'95965','S','Jarbo','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(24481,'27247','P','Ether','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.430675,-79.787081,0,'2013-07-06 12:44:31',NULL,NULL),(65473,'77639','P','Orangefield','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.053212,-93.856171,0,'2013-07-06 12:44:34',NULL,NULL),(10606,'11040','S','N New Hyde Pk','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(14488,'15136','S','Mc Kees Rocks','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.472555,-80.088822,0,'2013-07-06 12:44:31',NULL,NULL),(55708,'64068','S','Liberty','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.276480,-94.423260,0,'2013-07-06 12:44:33',NULL,NULL),(40020,'45247','S','Dunlap','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(18184,'18930','S','Kintnersville','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.508214,-75.235473,0,'2013-07-06 12:44:31',NULL,NULL),(5948,'05261','S','Pownal','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.797700,-73.216680,0,'2013-07-06 12:44:30',NULL,NULL),(65786,'78118','S','Karnes City','D','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.891304,-97.900158,0,'2013-07-06 12:44:34',NULL,NULL),(8475,'08091','S','Berlin Township','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.815979,-74.940718,0,'2013-07-06 12:44:30',NULL,NULL),(34801,'38876','S','Tremont','D','Itawamba','28057','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.215232,-88.208583,0,'2013-07-06 12:44:32',NULL,NULL),(69380,'83607','S','Caldwell','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.662016,-116.685127,0,'2013-07-06 12:44:34',NULL,NULL),(19930,'20560','U','Smithsonian Institute','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885489,-77.026296,0,'2013-07-06 12:44:31',NULL,NULL),(74261,'92341','P','Green Valley Lake','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.241861,-117.075564,0,'2013-07-06 12:44:34',NULL,NULL),(53400,'61826','P','Champaign','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.137064,-88.278526,0,'2013-07-06 12:44:33',NULL,NULL),(31882,'35127','S','Pleasant Grove','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489447,-86.973348,0,'2013-07-06 12:44:32',NULL,NULL),(75733,'94597','S','Walnut Creek','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.900911,-122.059246,0,'2013-07-06 12:44:34',NULL,NULL),(18429,'19063','S','Glen Riddle','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.919440,-75.420480,0,'2013-07-06 12:44:31',NULL,NULL),(65691,'78003','S','Bandera','D','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.735076,-99.040070,0,'2013-07-06 12:44:34',NULL,NULL),(51003,'58701','S','Logan','N','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230821,-101.294119,0,'2013-07-06 12:44:33',NULL,NULL),(44361,'49784','U','Kincheloe','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.258915,-84.381415,0,'2013-07-06 12:44:32',NULL,NULL),(46160,'52727','S','Bryant','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.973508,-90.342726,0,'2013-07-06 12:44:32',NULL,NULL),(35807,'39759','S','Hickory Grove','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(26537,'29203','S','Ridgewood','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(19296,'19975','S','Selbyville','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.466300,-75.149820,0,'2013-07-06 12:44:31',NULL,NULL),(68389,'81151','S','Lasauses','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.265658,-105.848320,0,'2013-07-06 12:44:34',NULL,NULL),(10000,'10167','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755560,-73.974469,0,'2013-07-06 12:44:30',NULL,NULL),(65258,'77469','S','Booth','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.590019,-95.752785,0,'2013-07-06 12:44:34',NULL,NULL),(13052,'13440','S','Lake Delta','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(49145,'56375','S','St Stephen','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.700959,-94.266485,0,'2013-07-06 12:44:33',NULL,NULL),(33413,'37236','U','Baptist Hospital','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.150275,-86.802472,0,'2013-07-06 12:44:32',NULL,NULL),(21409,'22528','P','Nuttsville','D','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.790076,-76.551822,0,'2013-07-06 12:44:31',NULL,NULL),(52887,'61350','S','Brickton','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.333611,-88.878056,0,'2013-07-06 12:44:33',NULL,NULL),(35966,'40075','S','Turners Sta','A','Henry','21103','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.556216,-85.126679,0,'2013-07-06 12:44:32',NULL,NULL),(78466,'98074','S','Sammamish','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.624151,-122.048612,0,'2013-07-06 12:44:34',NULL,NULL),(16899,'17582','S','Washington Boro','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.996531,-76.452756,0,'2013-07-06 12:44:31',NULL,NULL),(24742,'27529','S','Garner','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.684813,-78.608260,0,'2013-07-06 12:44:31',NULL,NULL),(61621,'72824','S','Corinth','N','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.106480,-93.451980,0,'2013-07-06 12:44:33',NULL,NULL),(58953,'69366','S','Whitman','D','Grant','31075','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.918254,-101.535684,0,'2013-07-06 12:44:33',NULL,NULL),(56891,'66040','S','Linn Valley','A','Linn','20107','Kansas','KS','20','0000','913','Central',-6.0,'Y',38.356638,-94.741025,0,'2013-07-06 12:44:33',NULL,NULL),(22077,'23357','S','Greenbush','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.760282,-75.675288,0,'2013-07-06 12:44:31',NULL,NULL),(40063,'45271','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.136175,-84.536864,0,'2013-07-06 12:44:32',NULL,NULL),(46390,'53150','S','Muskego','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.891978,-88.124961,0,'2013-07-06 12:44:32',NULL,NULL),(42099,'47460','S','Romona','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(78505,'98112','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.633515,-122.292981,0,'2013-07-06 12:44:34',NULL,NULL),(67002,'79510','S','Clyde','D','Callahan','48059','Texas','TX','48','0000','325','Central',-6.0,'Y',32.407474,-99.501877,0,'2013-07-06 12:44:34',NULL,NULL),(23170,'25025','S','Blount','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.302878,-81.384071,0,'2013-07-06 12:44:31',NULL,NULL),(68276,'81082','S','Cokedale','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(46963,'54204','S','Brussels','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.749355,-87.634647,0,'2013-07-06 12:44:32',NULL,NULL),(48370,'55558','U','Young America Corp','N','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.816260,-93.919928,0,'2013-07-06 12:44:33',NULL,NULL),(49723,'57042','S','Lake Herman','N','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.008120,-97.113629,0,'2013-07-06 12:44:33',NULL,NULL),(54868,'63051','S','La Barque Crk','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.412034,-90.558900,0,'2013-07-06 12:44:33',NULL,NULL),(34916,'38961','S','Murphreesboro','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.990153,-89.878680,0,'2013-07-06 12:44:32',NULL,NULL),(1830,'00784','S','Urb Dorado','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(74947,'93410','S','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.276728,-120.737489,0,'2013-07-06 12:44:34',NULL,NULL),(21193,'22185','U','Vienna','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.899292,-77.260327,0,'2013-07-06 12:44:31',NULL,NULL),(30684,'33471','S','Moore Haven','D','Glades','12043','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.834040,-81.104050,0,'2013-07-06 12:44:32',NULL,NULL),(65928,'78247','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588133,-98.402025,0,'2013-07-06 12:44:34',NULL,NULL),(60170,'71409','S','Cotile','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(53721,'62244','S','Chaflin Bridge','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.163740,-90.201178,0,'2013-07-06 12:44:33',NULL,NULL),(39311,'44514','S','Poland','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.008740,-80.624160,0,'2013-07-06 12:44:32',NULL,NULL),(67219,'79923','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.780293,-106.459121,0,'2013-07-06 12:44:34',NULL,NULL),(53103,'61535','S','Towne Oaks','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.593891,-89.535053,0,'2013-07-06 12:44:33',NULL,NULL),(23433,'25392','U','United Bank','N','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.351984,-81.628434,0,'2013-07-06 12:44:31',NULL,NULL),(35104,'39208','S','Jksn','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.271720,-90.104940,0,'2013-07-06 12:44:32',NULL,NULL),(6978,'06242','S','Eastford','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.893298,-72.091566,0,'2013-07-06 12:44:30',NULL,NULL),(71977,'88021','S','La Union','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',31.935600,-106.505520,0,'2013-07-06 12:44:34',NULL,NULL),(6221,'05488','S','W Swanton','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.929800,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(11718,'12174','P','Stuyvesant Fl','A','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.351815,-73.733223,0,'2013-07-06 12:44:30',NULL,NULL),(22710,'24347','S','Hiwassee','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.016100,-80.606340,0,'2013-07-06 12:44:31',NULL,NULL),(45176,'50605','S','Aredale','D','Butler','19023','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.836963,-93.003512,0,'2013-07-06 12:44:32',NULL,NULL),(78610,'98195','U','Univ of Washington','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.651377,-122.298431,0,'2013-07-06 12:44:34',NULL,NULL),(45692,'52049','S','Clayton','A','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.872700,-91.229160,0,'2013-07-06 12:44:32',NULL,NULL),(29728,'32957','P','Roseland','D','Indian River','12061','Florida','FL','12','0000','772','Eastern',-5.0,'Y',27.831962,-80.492354,0,'2013-07-06 12:44:32',NULL,NULL),(1561,'00766','S','Urb La Vega','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(15681,'16829','S','Clarence','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',41.088694,-77.874660,0,'2013-07-06 12:44:31',NULL,NULL),(11771,'12203','S','Pine','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.691560,-73.827840,0,'2013-07-06 12:44:30',NULL,NULL),(32679,'36266','S','Shinebone','N','Clay','01027','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.337020,-85.729080,0,'2013-07-06 12:44:32',NULL,NULL),(34859,'38928','S','Glendora','D','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.946772,-90.174703,0,'2013-07-06 12:44:32',NULL,NULL),(30298,'33283','P','Kendall','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.699280,-80.381577,0,'2013-07-06 12:44:32',NULL,NULL),(3363,'01570','S','Webster','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.052997,-71.879710,0,'2013-07-06 12:44:30',NULL,NULL),(28072,'30720','S','Dalton','D','Whitfield','13313','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.759673,-84.975973,0,'2013-07-06 12:44:31',NULL,NULL),(68113,'80947','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.832634,-104.819249,0,'2013-07-06 12:44:34',NULL,NULL),(39754,'45106','S','Mount Olive','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.948415,-84.096965,0,'2013-07-06 12:44:32',NULL,NULL),(25891,'28643','S','Brandon','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(7961,'07677','S','Woodcliff Lake','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.024537,-74.060304,0,'2013-07-06 12:44:30',NULL,NULL),(58738,'68949','S','Prairie','N','Phelps','31137','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.440800,-99.370426,0,'2013-07-06 12:44:33',NULL,NULL),(51324,'59257','S','Redstone','D','Sheridan','30091','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.833150,-104.922222,0,'2013-07-06 12:44:33',NULL,NULL),(49665,'57005','S','Corson','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.587111,-96.580716,0,'2013-07-06 12:44:33',NULL,NULL),(43573,'48737','S','Glennie','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.549664,-83.705696,0,'2013-07-06 12:44:32',NULL,NULL),(4661,'03770','S','Meriden','D','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.517012,-72.278909,0,'2013-07-06 12:44:30',NULL,NULL),(10664,'11106','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.761688,-73.930747,0,'2013-07-06 12:44:30',NULL,NULL),(40407,'45680','S','Southpoint','N','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.420040,-82.572900,0,'2013-07-06 12:44:32',NULL,NULL),(42174,'47528','S','Edwardsport','D','Knox','18083','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.813066,-87.243531,0,'2013-07-06 12:44:32',NULL,NULL),(29556,'32809','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.471095,-81.389356,0,'2013-07-06 12:44:32',NULL,NULL),(46488,'53223','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.158245,-87.989707,0,'2013-07-06 12:44:32',NULL,NULL),(3598,'02038','S','Franklin','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.093298,-71.404394,0,'2013-07-06 12:44:30',NULL,NULL),(67956,'80913','S','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(67643,'80463','S','Mc Coy','D','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.876018,-106.758054,0,'2013-07-06 12:44:34',NULL,NULL),(52551,'60944','P','Hopkins Park','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.071609,-87.617340,0,'2013-07-06 12:44:33',NULL,NULL),(6079,'05449','P','Colchester','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.545050,-73.145961,0,'2013-07-06 12:44:30',NULL,NULL),(559,'00678','S','Brisas Tropical','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(10413,'10706','S','Hastings Hdsn','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.970520,-73.875300,0,'2013-07-06 12:44:30',NULL,NULL),(10611,'11042','S','Lake Success','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757711,-73.697796,0,'2013-07-06 12:44:30',NULL,NULL),(34272,'38471','S','Lutts','D','Wayne','47181','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.120142,-87.905568,0,'2013-07-06 12:44:32',NULL,NULL),(62600,'74521','P','Albion','D','Pushmataha','40127','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.661736,-95.098277,0,'2013-07-06 12:44:33',NULL,NULL),(51426,'59453','S','Judith Gap','D','Wheatland','30107','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.605514,-109.599361,0,'2013-07-06 12:44:33',NULL,NULL),(58710,'68934','S','Deweese','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.355030,-98.138110,0,'2013-07-06 12:44:33',NULL,NULL),(70781,'85347','S','Roll','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.749589,-113.912286,0,'2013-07-06 12:44:34',NULL,NULL),(10,'00602','S','Alts de Aguada','N','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(7978,'07711','S','Allenhurst','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235381,-74.005003,0,'2013-07-06 12:44:30',NULL,NULL),(37543,'42058','S','Ledbetter','D','Livingston','21139','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.047851,-88.492729,0,'2013-07-06 12:44:32',NULL,NULL),(79275,'98575','S','Quinault','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.414224,-123.743166,0,'2013-07-06 12:44:34',NULL,NULL),(61400,'72544','S','Henderson','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.349196,-92.231716,0,'2013-07-06 12:44:33',NULL,NULL),(53314,'61740','S','Flanagan','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.876326,-88.861363,0,'2013-07-06 12:44:33',NULL,NULL),(48822,'56035','P','Geneva','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.828762,-93.269864,0,'2013-07-06 12:44:33',NULL,NULL),(50782,'58430','S','Denhoff','D','Sheridan','38083','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.564837,-100.256442,0,'2013-07-06 12:44:33',NULL,NULL),(78974,'98372','S','Edgewood','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.205996,-122.271245,0,'2013-07-06 12:44:34',NULL,NULL),(16406,'17224','S','Bricker Dev','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(71624,'87375','P','Gallup','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.525520,-108.740820,0,'2013-07-06 12:44:34',NULL,NULL),(10475,'10950','S','Kiryas Joel','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.338274,-74.185886,0,'2013-07-06 12:44:30',NULL,NULL),(35568,'39567','S','Pasgoula','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.447660,-88.520880,0,'2013-07-06 12:44:32',NULL,NULL),(56896,'66043','S','Leavenworth','A','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.253586,-94.901087,0,'2013-07-06 12:44:33',NULL,NULL),(77872,'97256','U','Pacificorp','N','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.515988,-122.680938,0,'2013-07-06 12:44:34',NULL,NULL),(19625,'20244','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914896,-76.996272,0,'2013-07-06 12:44:31',NULL,NULL),(65803,'78132','S','New Braunfels','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.777220,-98.152980,0,'2013-07-06 12:44:34',NULL,NULL),(6932,'06161','U','Ct Dept of Motor Vehicles','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.701070,-72.667463,0,'2013-07-06 12:44:30',NULL,NULL),(60981,'72110','S','Lewisburg','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(52753,'61244','S','Meersman','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.510378,-90.418471,0,'2013-07-06 12:44:33',NULL,NULL),(3156,'01263','U','Marian Helpers','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.289010,-73.319529,0,'2013-07-06 12:44:30',NULL,NULL),(50618,'58261','S','Warsaw','N','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.291130,-97.372047,0,'2013-07-06 12:44:33',NULL,NULL),(74670,'92862','S','Orange','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.791502,-117.714005,0,'2013-07-06 12:44:34',NULL,NULL),(70858,'85554','P','Young','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.089269,-111.169619,0,'2013-07-06 12:44:34',NULL,NULL),(20844,'21649','S','Marydel','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.109101,-75.767492,0,'2013-07-06 12:44:31',NULL,NULL),(15412,'16351','S','Tidioute','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.684188,-79.403836,0,'2013-07-06 12:44:31',NULL,NULL),(63249,'75482','S','Sulphur Springs','D','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.128095,-95.598595,0,'2013-07-06 12:44:33',NULL,NULL),(74691,'92887','S','Yorba Linda','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.884072,-117.730356,0,'2013-07-06 12:44:34',NULL,NULL),(42377,'47715','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.969963,-87.484049,0,'2013-07-06 12:44:32',NULL,NULL),(63087,'75252','S','Dallas','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.995735,-96.784576,0,'2013-07-06 12:44:33',NULL,NULL),(4503,'03287','S','Wilmot Flat','N','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.443972,-71.912264,0,'2013-07-06 12:44:30',NULL,NULL),(40015,'45247','S','Bevis','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.228599,-84.625748,0,'2013-07-06 12:44:32',NULL,NULL),(51091,'58770','S','Parshall','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.944630,-102.128265,0,'2013-07-06 12:44:33',NULL,NULL),(66654,'78850','S','D Hanis','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.349952,-99.311444,0,'2013-07-06 12:44:34',NULL,NULL),(61540,'72682','S','Valley Springs','D','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.143149,-92.983087,0,'2013-07-06 12:44:33',NULL,NULL),(41750,'47281','S','Vallonia','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.800788,-86.059127,0,'2013-07-06 12:44:32',NULL,NULL),(34367,'38610','S','Blue Mountain','D','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.670141,-89.019896,0,'2013-07-06 12:44:32',NULL,NULL),(32086,'35291','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.513087,-86.806429,0,'2013-07-06 12:44:32',NULL,NULL),(46202,'52754','S','Letts','D','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.328289,-91.235037,0,'2013-07-06 12:44:32',NULL,NULL),(7981,'07711','S','West Allenhurst','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235381,-74.005003,0,'2013-07-06 12:44:30',NULL,NULL),(23135,'24977','S','Smoot','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.866405,-80.665267,0,'2013-07-06 12:44:31',NULL,NULL),(17058,'17754','S','Upper Fairfld','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(64017,'76118','S','N Richlnd Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.806620,-97.210260,0,'2013-07-06 12:44:34',NULL,NULL),(54485,'62863','S','Friendsville','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(31886,'35130','S','Quinton','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.570865,-87.165507,0,'2013-07-06 12:44:32',NULL,NULL),(17503,'17963','S','Brookside','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(29077,'32256','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.191339,-81.494560,0,'2013-07-06 12:44:32',NULL,NULL),(39548,'44840','S','Lake Fork','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.810987,-82.189201,0,'2013-07-06 12:44:32',NULL,NULL),(38931,'44122','S','University Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(32015,'35235','S','Centerpoint','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.605039,-86.656101,0,'2013-07-06 12:44:32',NULL,NULL),(10577,'11021','S','Great Neck Estates','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(60798,'72030','S','Beverage Town','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.366302,-92.705971,0,'2013-07-06 12:44:33',NULL,NULL),(61960,'73172','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.419424,-97.569451,0,'2013-07-06 12:44:33',NULL,NULL),(22299,'23827','S','Boykins','D','Southampton','51175','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',36.582710,-77.196811,0,'2013-07-06 12:44:31',NULL,NULL),(12233,'12816','S','Center Cambridge','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.040880,-73.380600,0,'2013-07-06 12:44:30',NULL,NULL),(4512,'03298','U','Tilton','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.634856,-71.531507,0,'2013-07-06 12:44:30',NULL,NULL),(61727,'73020','S','Choctaw','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.461457,-97.263145,0,'2013-07-06 12:44:33',NULL,NULL),(56468,'65301','S','Springfork','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.695080,-93.242160,0,'2013-07-06 12:44:33',NULL,NULL),(43239,'48316','S','Shelby Township','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.680668,-83.052212,0,'2013-07-06 12:44:32',NULL,NULL),(46554,'53503','S','Arena','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.141048,-89.946926,0,'2013-07-06 12:44:32',NULL,NULL),(42613,'47901','S','Lafayette','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.415409,-86.892088,0,'2013-07-06 12:44:32',NULL,NULL),(7457,'06859','U','Norwalk','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.138485,-73.405893,0,'2013-07-06 12:44:30',NULL,NULL),(73445,'91301','S','Calabasas Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(26119,'28729','S','Etowah','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.318754,-82.604976,0,'2013-07-06 12:44:31',NULL,NULL),(46796,'54001','S','Deronda','A','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.306512,-92.356007,0,'2013-07-06 12:44:32',NULL,NULL),(44073,'49445','S','N Muskegon','A','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.293180,-86.282880,0,'2013-07-06 12:44:32',NULL,NULL),(15776,'16921','S','Rexford','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.671380,-77.552580,0,'2013-07-06 12:44:31',NULL,NULL),(19174,'19734','S','Blackbird','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.382560,-75.665280,0,'2013-07-06 12:44:31',NULL,NULL),(58666,'68882','S','Wolbach','D','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.468087,-98.385202,0,'2013-07-06 12:44:33',NULL,NULL),(20860,'21661','S','Rock Hall','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.137898,-76.231798,0,'2013-07-06 12:44:31',NULL,NULL),(23670,'25832','S','Glade Springs','A','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.737399,-81.134572,0,'2013-07-06 12:44:31',NULL,NULL),(10945,'11436','S','S Ozone Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678055,-73.797848,0,'2013-07-06 12:44:30',NULL,NULL),(66486,'78669','S','Briarcliff','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.418049,-98.052665,0,'2013-07-06 12:44:34',NULL,NULL),(63307,'75565','P','Mc Leod','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.951167,-94.079416,0,'2013-07-06 12:44:33',NULL,NULL),(59894,'71272','U','Ruston','D','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.529801,-92.650160,0,'2013-07-06 12:44:33',NULL,NULL),(58516,'68777','S','Spencer','D','Boyd','31015','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.899532,-98.718650,0,'2013-07-06 12:44:33',NULL,NULL),(37224,'41537','S','Jenkins','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(27154,'29829','S','Graniteville','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.560576,-81.828149,0,'2013-07-06 12:44:31',NULL,NULL),(6185,'05478','S','Saint Albans','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.802840,-73.089660,0,'2013-07-06 12:44:30',NULL,NULL),(64754,'76934','S','Carlsbad','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.591803,-100.711528,0,'2013-07-06 12:44:34',NULL,NULL),(62665,'74641','S','Kaw City','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.764350,-96.861771,0,'2013-07-06 12:44:33',NULL,NULL),(59893,'71272','U','Louisiana Tech Univ','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.529801,-92.650160,0,'2013-07-06 12:44:33',NULL,NULL),(11089,'11693','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.589797,-73.813567,0,'2013-07-06 12:44:30',NULL,NULL),(74998,'93452','S','Ragged Point','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.549785,-120.950261,0,'2013-07-06 12:44:34',NULL,NULL),(60722,'71953','S','Rocky','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(59834,'71241','S','Rocky Branch','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.771520,-92.332620,0,'2013-07-06 12:44:33',NULL,NULL),(59829,'71238','S','Cadeville','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.364300,-92.361480,0,'2013-07-06 12:44:33',NULL,NULL),(59418,'70654','S','Mittie','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.678133,-92.932056,0,'2013-07-06 12:44:33',NULL,NULL),(42337,'47635','S','Reo','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.895520,-87.060780,0,'2013-07-06 12:44:32',NULL,NULL),(64078,'76148','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.862745,-97.248844,0,'2013-07-06 12:44:34',NULL,NULL),(37686,'42232','S','Gracey','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.868364,-87.651698,0,'2013-07-06 12:44:32',NULL,NULL),(28752,'32003','S','Fleming Island','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.106435,-81.711499,0,'2013-07-06 12:44:32',NULL,NULL),(26684,'29404','S','N Charleston','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.893419,-80.069777,0,'2013-07-06 12:44:31',NULL,NULL),(73824,'91769','P','Pomona','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.061362,-117.756820,0,'2013-07-06 12:44:34',NULL,NULL),(66367,'78617','S','Garfield','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.151020,-97.594440,0,'2013-07-06 12:44:34',NULL,NULL),(65218,'77441','S','Weston Lakes','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.680355,-95.926739,0,'2013-07-06 12:44:34',NULL,NULL),(24398,'27106','S','Oldtown','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.149640,-80.322600,0,'2013-07-06 12:44:31',NULL,NULL),(41710,'47235','S','Freetown','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.010573,-86.122781,0,'2013-07-06 12:44:32',NULL,NULL),(42380,'47720','S','Darmstadt','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.032487,-87.631363,0,'2013-07-06 12:44:32',NULL,NULL),(3628,'02066','S','Scituate Center','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.199513,-70.746169,0,'2013-07-06 12:44:30',NULL,NULL),(72207,'88418','S','Des Moines','D','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.637805,-103.885290,0,'2013-07-06 12:44:34',NULL,NULL),(49228,'56469','S','Morrison','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.726598,-93.612719,0,'2013-07-06 12:44:33',NULL,NULL),(51829,'60061','S','Vernon Hills','D','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.234248,-87.970272,0,'2013-07-06 12:44:33',NULL,NULL),(19888,'20536','U','Immig and Naturalization Ser','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.901010,-77.015942,0,'2013-07-06 12:44:31',NULL,NULL),(20845,'21650','S','Massey','D','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.310905,-75.820082,0,'2013-07-06 12:44:31',NULL,NULL),(59946,'71301','S','Chandler Park','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(11586,'12076','S','Gilboa','D','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.410715,-74.390183,0,'2013-07-06 12:44:30',NULL,NULL),(75149,'93561','S','Stallion Spgs','A','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(69986,'84121','S','Holladay Ctwd','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(38324,'43413','S','Cygnet','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.238209,-83.652763,0,'2013-07-06 12:44:32',NULL,NULL),(38969,'44128','S','Orange Village','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(53649,'62204','S','Washington Pk','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.633044,-90.101683,0,'2013-07-06 12:44:33',NULL,NULL),(52011,'60173','S','Hoffman Estates','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.042778,-88.079722,0,'2013-07-06 12:44:33',NULL,NULL),(42914,'48106','P','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.227952,-83.738851,0,'2013-07-06 12:44:32',NULL,NULL),(51089,'58768','S','Norwich','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.239520,-100.951920,0,'2013-07-06 12:44:33',NULL,NULL),(48445,'55706','S','Babbitt','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.720713,-91.960638,0,'2013-07-06 12:44:33',NULL,NULL),(30004,'33124','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.726412,-80.238000,0,'2013-07-06 12:44:32',NULL,NULL),(23005,'24813','P','Bartley','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.340033,-81.736141,0,'2013-07-06 12:44:31',NULL,NULL),(63779,'75951','S','Jasper','D','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(48396,'55584','P','Monticello','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.279734,-93.811197,0,'2013-07-06 12:44:33',NULL,NULL),(43165,'48268','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.331348,-83.048397,0,'2013-07-06 12:44:32',NULL,NULL),(58475,'68745','S','Laurel','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.439551,-97.104567,0,'2013-07-06 12:44:33',NULL,NULL),(11071,'11596','S','East Williston','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.757885,-73.644633,0,'2013-07-06 12:44:30',NULL,NULL),(11205,'11743','S','Huntington Bay','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.869083,-73.409300,0,'2013-07-06 12:44:30',NULL,NULL),(16500,'17261','P','S Mountain','A','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.834092,-77.474209,0,'2013-07-06 12:44:31',NULL,NULL),(1297,'00730','S','Urb Morell Campos','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(4712,'03819','S','S Danville','N','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.919072,-71.116979,0,'2013-07-06 12:44:30',NULL,NULL),(29471,'32721','P','Deland','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.027194,-81.295606,0,'2013-07-06 12:44:32',NULL,NULL),(67968,'80914','P','Co Spgs','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.786821,-104.714138,0,'2013-07-06 12:44:34',NULL,NULL),(26465,'29148','S','St Paul','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.589744,-80.341999,0,'2013-07-06 12:44:31',NULL,NULL),(2569,'00959','S','Urb Versalles','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(26036,'28681','S','Paynes Store','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(31940,'35201','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.518556,-86.808416,0,'2013-07-06 12:44:32',NULL,NULL),(55401,'63640','S','Farmington','D','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.780722,-90.421005,0,'2013-07-06 12:44:33',NULL,NULL),(54915,'63088','S','Valley Park','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.550608,-90.490282,0,'2013-07-06 12:44:33',NULL,NULL),(67423,'80155','P','Englewood','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.591335,-104.876947,0,'2013-07-06 12:44:34',NULL,NULL),(21350,'22435','S','Callao','D','Northumberland','51133','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.941111,-76.535556,0,'2013-07-06 12:44:31',NULL,NULL),(12125,'12603','S','Arlington','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.697060,-73.862400,0,'2013-07-06 12:44:30',NULL,NULL),(38615,'43907','S','Short Creek','N','Harrison','39067','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.258860,-81.031320,0,'2013-07-06 12:44:32',NULL,NULL),(55296,'63530','S','Economy','N','Macon','29121','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.928400,-92.451724,0,'2013-07-06 12:44:33',NULL,NULL),(59778,'71203','S','Lakeshore','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.547557,-92.044046,0,'2013-07-06 12:44:33',NULL,NULL),(42115,'47469','S','Prospect','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.578380,-86.610000,0,'2013-07-06 12:44:32',NULL,NULL),(40278,'45435','U','Dayton','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.766782,-84.085913,0,'2013-07-06 12:44:32',NULL,NULL),(3215,'01364','S','New Salem','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.589080,-72.319440,0,'2013-07-06 12:44:30',NULL,NULL),(73704,'91608','S','Universal Cty','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140376,-118.354334,0,'2013-07-06 12:44:34',NULL,NULL),(73157,'90293','S','Venice','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.990833,-118.459167,0,'2013-07-06 12:44:34',NULL,NULL),(21339,'22412','U','Geico Insurance','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.299924,-77.488208,0,'2013-07-06 12:44:31',NULL,NULL),(13656,'14020','S','Batavia','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.994565,-78.190625,0,'2013-07-06 12:44:31',NULL,NULL),(13644,'14004','S','Alden','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.901992,-78.524759,0,'2013-07-06 12:44:31',NULL,NULL),(31667,'34756','S','Montverde','D','Lake','12069','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.596545,-81.680818,0,'2013-07-06 12:44:32',NULL,NULL),(12413,'12937','S','Fort Covington','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.956408,-74.489215,0,'2013-07-06 12:44:30',NULL,NULL),(73506,'91334','P','Pacoima','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.244284,-118.426018,0,'2013-07-06 12:44:34',NULL,NULL),(10331,'10549','S','Bedford Cors','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.207160,-73.717320,0,'2013-07-06 12:44:30',NULL,NULL),(68449,'81226','S','Williamsburg','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.370060,-105.119760,0,'2013-07-06 12:44:34',NULL,NULL),(66893,'79248','S','Chalk','N','Cottle','48101','Texas','TX','48','0000','806','Central',-6.0,'Y',34.010623,-100.302278,0,'2013-07-06 12:44:34',NULL,NULL),(35651,'39643','S','Kokomo','D','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.173021,-89.986969,0,'2013-07-06 12:44:32',NULL,NULL),(45646,'51654','S','Thurman','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.821039,-95.750570,0,'2013-07-06 12:44:32',NULL,NULL),(16875,'17569','S','Reinholds','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.276083,-76.123914,0,'2013-07-06 12:44:31',NULL,NULL),(19155,'19714','P','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.714157,-75.741454,0,'2013-07-06 12:44:31',NULL,NULL),(24046,'26415','S','Toll Gate','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.285557,-80.967156,0,'2013-07-06 12:44:31',NULL,NULL),(61705,'73003','S','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.704729,-97.568619,0,'2013-07-06 12:44:33',NULL,NULL),(52267,'60525','S','Indian Head Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(45336,'50863','S','Tingley','D','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.851137,-94.190589,0,'2013-07-06 12:44:32',NULL,NULL),(58450,'68720','S','Brunswick','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.352542,-97.952099,0,'2013-07-06 12:44:33',NULL,NULL),(68937,'82932','S','Eden','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.110000,-109.440000,0,'2013-07-06 12:44:34',NULL,NULL),(59216,'70402','U','Hammond','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.510346,-90.459565,0,'2013-07-06 12:44:33',NULL,NULL),(22363,'23909','U','Longwood University','N','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.295563,-78.398027,0,'2013-07-06 12:44:31',NULL,NULL),(43627,'48820','S','Dewitt','D','Clinton','26037','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.846571,-84.590334,0,'2013-07-06 12:44:32',NULL,NULL),(22256,'23669','S','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.041146,-76.337539,0,'2013-07-06 12:44:31',NULL,NULL),(12115,'12589','S','Wallkill','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.617824,-74.149503,0,'2013-07-06 12:44:30',NULL,NULL),(28124,'30814','S','Pumpkin Center','N','Columbia','13073','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.414274,-82.313268,0,'2013-07-06 12:44:31',NULL,NULL),(11153,'11718','S','Brightwaters','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.719074,-73.267235,0,'2013-07-06 12:44:30',NULL,NULL),(68821,'82501','S','Gas Hills','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.999319,-108.386674,0,'2013-07-06 12:44:34',NULL,NULL),(51330,'59263','S','Four Buttes','A','Daniels','30019','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.790791,-105.423135,0,'2013-07-06 12:44:33',NULL,NULL),(44776,'50212','S','Ogden','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.040772,-94.027489,0,'2013-07-06 12:44:32',NULL,NULL),(11256,'11766','S','Mount Sinai','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.931723,-73.012963,0,'2013-07-06 12:44:30',NULL,NULL),(72598,'89410','S','Dresslerville','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(4338,'03037','S','Deerfield','D','Rockingham','33015','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.140914,-71.247252,0,'2013-07-06 12:44:30',NULL,NULL),(66019,'78359','P','Gregory','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.921211,-97.289753,0,'2013-07-06 12:44:34',NULL,NULL),(52020,'60175','S','St Charles','A','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.952674,-88.346033,0,'2013-07-06 12:44:33',NULL,NULL),(27203,'29905','P','Beaufort','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.343880,-80.665757,0,'2013-07-06 12:44:31',NULL,NULL),(13347,'13692','P','Thousnd Is Pk','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.284887,-76.029920,0,'2013-07-06 12:44:30',NULL,NULL),(61454,'72617','S','Big Flat','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.031701,-92.357454,0,'2013-07-06 12:44:33',NULL,NULL),(38593,'43824','S','Fresno','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.347220,-81.738511,0,'2013-07-06 12:44:32',NULL,NULL),(20428,'20914','P','Colesville','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.074133,-77.003460,0,'2013-07-06 12:44:31',NULL,NULL),(4885,'04041','S','Hiram','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.891094,-70.841258,0,'2013-07-06 12:44:30',NULL,NULL),(12527,'13034','S','Cayuga','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.927604,-76.720691,0,'2013-07-06 12:44:30',NULL,NULL),(45962,'52358','S','Oasis','N','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.675413,-91.346693,0,'2013-07-06 12:44:32',NULL,NULL),(10433,'10901','S','Airmont','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.127671,-74.111934,0,'2013-07-06 12:44:30',NULL,NULL),(34845,'38922','S','Gums','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(8369,'08053','S','Marlton','D','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(7869,'07506','S','Hawthorne','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.956380,-74.159033,0,'2013-07-06 12:44:30',NULL,NULL),(5868,'05144','P','Gassetts','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.286631,-72.634544,0,'2013-07-06 12:44:30',NULL,NULL),(40927,'46280','S','Indianapolis','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.937574,-86.138329,0,'2013-07-06 12:44:32',NULL,NULL),(71024,'85733','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.085766,-111.071379,0,'2013-07-06 12:44:34',NULL,NULL),(60988,'72111','S','Hammonsville','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.185421,-92.073842,0,'2013-07-06 12:44:33',NULL,NULL),(46768,'53946','S','Manchester','A','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.705413,-88.990142,0,'2013-07-06 12:44:32',NULL,NULL),(76172,'95324','S','Hilmar','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.397801,-120.871764,0,'2013-07-06 12:44:34',NULL,NULL),(40046,'45255','S','Anderson','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.051766,-84.347377,0,'2013-07-06 12:44:32',NULL,NULL),(46443,'53208','S','Wauwatosa','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.048166,-87.964638,0,'2013-07-06 12:44:32',NULL,NULL),(44366,'49785','U','Sault S Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.264580,-84.449270,0,'2013-07-06 12:44:32',NULL,NULL),(4491,'03278','S','Sutton','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.278960,-71.803980,0,'2013-07-06 12:44:30',NULL,NULL),(39431,'44683','S','Feed Springs','N','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.392715,-81.347949,0,'2013-07-06 12:44:32',NULL,NULL),(75950,'95042','P','New Almaden','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.177537,-121.818513,0,'2013-07-06 12:44:34',NULL,NULL),(72963,'90044','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.956268,-118.290701,0,'2013-07-06 12:44:34',NULL,NULL),(18445,'19070','S','Morton','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.908428,-75.323818,0,'2013-07-06 12:44:31',NULL,NULL),(36822,'41064','S','Kentontown','N','Robertson','21201','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.532132,-84.039003,0,'2013-07-06 12:44:32',NULL,NULL),(9305,'09716','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(68569,'81502','P','Grand Junction','D','Mesa','08077','Colorado','CO','08','2995','970','Mountain',-7.0,'Y',39.074393,-108.631686,0,'2013-07-06 12:44:34',NULL,NULL),(34824,'38915','S','Lantrip','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.004880,-89.360460,0,'2013-07-06 12:44:32',NULL,NULL),(58289,'68414','S','Nemaha','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.338842,-95.675420,0,'2013-07-06 12:44:33',NULL,NULL),(53900,'62363','S','Detroit','A','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.609331,-90.807822,0,'2013-07-06 12:44:33',NULL,NULL),(14088,'14617','S','Irondequoit','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.206420,-77.635320,0,'2013-07-06 12:44:31',NULL,NULL),(76926,'96013','S','Johnson Park','N','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.934280,-121.667100,0,'2013-07-06 12:44:34',NULL,NULL),(75219,'93637','S','Berenda','A','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',36.958261,-120.070035,0,'2013-07-06 12:44:34',NULL,NULL),(49259,'56478','S','Nimrod','D','Wadena','27159','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.636977,-94.880849,0,'2013-07-06 12:44:33',NULL,NULL),(50435,'57799','U','Spearfish','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.485188,-103.859540,0,'2013-07-06 12:44:33',NULL,NULL),(34844,'38922','S','Gatewood','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(64672,'76824','P','Bend','D','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',31.083168,-98.500007,0,'2013-07-06 12:44:34',NULL,NULL),(35208,'39296','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.345145,-90.165957,0,'2013-07-06 12:44:32',NULL,NULL),(58059,'68041','S','Mead','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.213989,-96.519748,0,'2013-07-06 12:44:33',NULL,NULL),(26583,'29220','U','Baptist Medical Center','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.004320,-81.032526,0,'2013-07-06 12:44:31',NULL,NULL),(21011,'21842','S','North Ocean City','N','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.387820,-75.107280,0,'2013-07-06 12:44:31',NULL,NULL),(17833,'18420','P','Fleetville','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.598421,-75.706863,0,'2013-07-06 12:44:31',NULL,NULL),(58001,'67863','S','Marienthal','D','Wichita','20203','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.485800,-101.036700,0,'2013-07-06 12:44:33',NULL,NULL),(62614,'74538','S','Coalgate','D','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.534003,-96.219571,0,'2013-07-06 12:44:33',NULL,NULL),(31066,'33848','P','Intrcsion Cty','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.263539,-81.506217,0,'2013-07-06 12:44:32',NULL,NULL),(64960,'77244','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.777550,-95.603263,0,'2013-07-06 12:44:34',NULL,NULL),(61355,'72476','S','Williams Baptist College','A','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.090720,-90.959580,0,'2013-07-06 12:44:33',NULL,NULL),(60906,'72076','S','Jacksonville','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(68234,'81052','S','West Farm','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(11651,'12131','S','North Blenheim','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.487846,-74.429697,0,'2013-07-06 12:44:30',NULL,NULL),(40026,'45248','S','Green Township','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159624,-84.661853,0,'2013-07-06 12:44:32',NULL,NULL),(37377,'41740','S','Emmalena','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.324933,-83.068260,0,'2013-07-06 12:44:32',NULL,NULL),(29774,'33013','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.862177,-80.270734,0,'2013-07-06 12:44:32',NULL,NULL),(71009,'85722','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.235135,-110.939552,0,'2013-07-06 12:44:34',NULL,NULL),(27214,'29910','S','Bluffton','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.259699,-80.872324,0,'2013-07-06 12:44:31',NULL,NULL),(12006,'12494','S','W Shokan','N','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.945647,-74.291909,0,'2013-07-06 12:44:30',NULL,NULL),(22052,'23320','S','Chesapeake','D','Chesapeake City','51550','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.743400,-76.225740,0,'2013-07-06 12:44:31',NULL,NULL),(19181,'19803','S','Talleyville','A','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.794276,-75.534321,0,'2013-07-06 12:44:31',NULL,NULL),(18365,'19040','S','Hatboro','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.178137,-75.108926,0,'2013-07-06 12:44:31',NULL,NULL),(45720,'52072','S','Saint Olaf','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.951110,-91.426746,0,'2013-07-06 12:44:32',NULL,NULL),(38577,'43788','S','Summerfield','D','Noble','39121','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.792959,-81.345816,0,'2013-07-06 12:44:32',NULL,NULL),(7096,'06359','S','N Stonington','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.462417,-71.870272,0,'2013-07-06 12:44:30',NULL,NULL),(2470,'00956','S','Ext Vista Bella','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(61070,'72126','S','Cherry Hill','N','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(55981,'64624','S','Braymer','D','Caldwell','29025','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.593217,-93.788696,0,'2013-07-06 12:44:33',NULL,NULL),(7827,'07460','S','Cliffwood Lake','N','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.088300,-74.514420,0,'2013-07-06 12:44:30',NULL,NULL),(31503,'34448','S','Homosassa Springs','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.772147,-82.591385,0,'2013-07-06 12:44:32',NULL,NULL),(40556,'45856','S','W Leipsic','N','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.097024,-83.996732,0,'2013-07-06 12:44:32',NULL,NULL),(46377,'53132','S','Franklin','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.887280,-88.009560,0,'2013-07-06 12:44:32',NULL,NULL),(41139,'46637','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.726797,-86.242770,0,'2013-07-06 12:44:32',NULL,NULL),(228,'00624','S','Vista Bahia','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(71033,'85739','S','Catalina','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.221743,-110.926479,0,'2013-07-06 12:44:34',NULL,NULL),(5129,'04410','S','Bradford','D','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.090445,-68.907992,0,'2013-07-06 12:44:30',NULL,NULL),(63698,'75880','U','Tennessee Colony','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.835895,-95.839416,0,'2013-07-06 12:44:34',NULL,NULL),(61940,'73160','S','Moore','A','Cleveland','40027','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.381160,-97.475880,0,'2013-07-06 12:44:33',NULL,NULL),(61331,'72456','S','Pollard','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.443108,-90.270438,0,'2013-07-06 12:44:33',NULL,NULL),(7433,'06828','U','Fairfield','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.218272,-73.252765,0,'2013-07-06 12:44:30',NULL,NULL),(58922,'69339','S','Crawford','D','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.658320,-103.409940,0,'2013-07-06 12:44:33',NULL,NULL),(55503,'63775','S','Parker Lake','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(47074,'54428','S','Elcho','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.458760,-89.110140,0,'2013-07-06 12:44:32',NULL,NULL),(4671,'03780','S','Benton','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.999870,-72.000233,0,'2013-07-06 12:44:30',NULL,NULL),(76042,'95159','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.316790,-121.932386,0,'2013-07-06 12:44:34',NULL,NULL),(79984,'99657','P','Russian Msn','A','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.768371,-160.975984,0,'2013-07-06 12:44:34',NULL,NULL),(15245,'16048','P','N Washington','A','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.046265,-79.815559,0,'2013-07-06 12:44:31',NULL,NULL),(55950,'64486','S','Sheridan','D','Worth','29227','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.487896,-94.545144,0,'2013-07-06 12:44:33',NULL,NULL),(58731,'68945','S','Eaton','N','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.569121,-98.779825,0,'2013-07-06 12:44:33',NULL,NULL),(5586,'04918','S','Belgrade Lakes','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.512980,-69.860580,0,'2013-07-06 12:44:30',NULL,NULL),(42091,'47460','S','Adel','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(24586,'27320','S','Cherrygrove','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352800,-79.618200,0,'2013-07-06 12:44:31',NULL,NULL),(26090,'28712','S','Brevard','D','Transylvania','37175','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.200259,-82.738354,0,'2013-07-06 12:44:31',NULL,NULL),(5893,'05155','S','Stratton Mnt','A','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.185300,-72.798900,0,'2013-07-06 12:44:30',NULL,NULL),(27279,'29945','S','Pocataligo','N','Hampton','45049','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.654220,-80.826720,0,'2013-07-06 12:44:31',NULL,NULL),(62166,'73738','S','Garber','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.436312,-97.581717,0,'2013-07-06 12:44:33',NULL,NULL),(4880,'04037','S','Stow','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.014772,-70.967645,0,'2013-07-06 12:44:30',NULL,NULL),(32023,'35238','P','Birmingham','D','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.518088,-86.802297,0,'2013-07-06 12:44:32',NULL,NULL),(37555,'42064','S','Tribune','N','Crittenden','21055','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.294380,-88.088460,0,'2013-07-06 12:44:32',NULL,NULL),(16119,'17055','S','Williams Grv','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(5126,'04406','S','Blanchard Twp','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.306850,-69.558284,0,'2013-07-06 12:44:30',NULL,NULL),(73860,'91909','P','Chula Vista','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.607717,-117.070647,0,'2013-07-06 12:44:34',NULL,NULL),(19085,'19567','S','Stouchsburg','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386594,-76.216795,0,'2013-07-06 12:44:31',NULL,NULL),(50465,'58036','S','Gardner','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.108096,-97.007998,0,'2013-07-06 12:44:33',NULL,NULL),(2540,'00959','S','Ext Hnas Davila','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(64984,'77272','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.699844,-95.582693,0,'2013-07-06 12:44:34',NULL,NULL),(56450,'65281','S','Bynumville','N','Chariton','29041','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.420951,-92.803243,0,'2013-07-06 12:44:33',NULL,NULL),(26150,'28740','S','Green Mtn','A','Yancey','37199','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.994300,-82.274400,0,'2013-07-06 12:44:31',NULL,NULL),(20074,'20684','S','Beachville','N','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.152561,-76.413819,0,'2013-07-06 12:44:31',NULL,NULL),(67140,'79764','S','Odessa','D','Ector','48135','Texas','TX','48','5800','432','Central',-6.0,'Y',31.879344,-102.436780,0,'2013-07-06 12:44:34',NULL,NULL),(31473,'34292','S','Venice','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.104244,-82.409144,0,'2013-07-06 12:44:32',NULL,NULL),(34505,'38673','S','Taylor','D','Lafayette','28071','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.275541,-89.637463,0,'2013-07-06 12:44:32',NULL,NULL),(14,'00602','S','Urb Isabel la Catolica','N','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(44223,'49646','S','Kalkaska','D','Kalkaska','26079','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.737703,-85.081328,0,'2013-07-06 12:44:32',NULL,NULL),(74095,'92201','S','Chiriaco Smt','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.707812,-116.231849,0,'2013-07-06 12:44:34',NULL,NULL),(36370,'40456','S','Climax','A','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.358415,-84.346235,0,'2013-07-06 12:44:32',NULL,NULL),(58215,'68335','S','Davenport','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.278417,-97.793557,0,'2013-07-06 12:44:33',NULL,NULL),(73855,'91902','S','Bonita','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.670318,-117.005554,0,'2013-07-06 12:44:34',NULL,NULL),(75872,'94949','S','Novato','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.060614,-122.540903,0,'2013-07-06 12:44:34',NULL,NULL),(34817,'38901','S','Sunnycrest','N','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.783216,-89.806975,0,'2013-07-06 12:44:32',NULL,NULL),(38172,'43156','P','Tarlton','D','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.555824,-82.775783,0,'2013-07-06 12:44:32',NULL,NULL),(69687,'84026','S','Ouray','A','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.294221,-109.839602,0,'2013-07-06 12:44:34',NULL,NULL),(8030,'07728','S','Jerseyville','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.243519,-74.277392,0,'2013-07-06 12:44:30',NULL,NULL),(41425,'46845','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.201330,-85.112447,0,'2013-07-06 12:44:32',NULL,NULL),(79350,'98632','S','Longview','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.157629,-122.985831,0,'2013-07-06 12:44:34',NULL,NULL),(21474,'22639','S','Hume','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.818969,-77.990868,0,'2013-07-06 12:44:31',NULL,NULL),(76974,'96056','S','McArthur','D','Lassen','06035','California','CA','06','6690','530','Pacific',-8.0,'Y',41.167186,-121.356668,0,'2013-07-06 12:44:34',NULL,NULL),(78819,'98333','S','Sylvan','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.250837,-122.623135,0,'2013-07-06 12:44:34',NULL,NULL),(1164,'00727','S','Urb Bairoa Park','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(58613,'68856','S','Merna','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.395529,-99.846927,0,'2013-07-06 12:44:33',NULL,NULL),(57121,'66223','S','Stanley','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.854674,-94.667175,0,'2013-07-06 12:44:33',NULL,NULL),(9255,'09590','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(17042,'17749','P','Mc Ewensville','D','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.073697,-76.821257,0,'2013-07-06 12:44:31',NULL,NULL),(29699,'32937','S','Indian Harbour Beach','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.172827,-80.598673,0,'2013-07-06 12:44:32',NULL,NULL),(45160,'50591','S','Thor','D','Humboldt','19091','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.686415,-94.047874,0,'2013-07-06 12:44:32',NULL,NULL),(52842,'61318','S','The Burg','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.699592,-89.081857,0,'2013-07-06 12:44:33',NULL,NULL),(2831,'00981','P','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.406458,-65.978643,0,'2013-07-06 12:44:30',NULL,NULL),(71682,'87511','P','Los Luceros','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.103333,-106.047500,0,'2013-07-06 12:44:34',NULL,NULL),(45072,'50522','S','Burt','D','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.197762,-94.222103,0,'2013-07-06 12:44:32',NULL,NULL),(56466,'65301','S','Longwood','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.695080,-93.242160,0,'2013-07-06 12:44:33',NULL,NULL),(55657,'64024','S','Exclsor Sprgs','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.341594,-94.236203,0,'2013-07-06 12:44:33',NULL,NULL),(29141,'32328','S','Saint George Island','A','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.746800,-84.923220,0,'2013-07-06 12:44:32',NULL,NULL),(6986,'06246','P','Grosvenor Dl','A','Windham','09015','Connecticut','CT','09','9240','860/959','Eastern',-5.0,'Y',41.969557,-71.894299,0,'2013-07-06 12:44:30',NULL,NULL),(9008,'08859','S','Parlin','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.461255,-74.310279,0,'2013-07-06 12:44:30',NULL,NULL),(34991,'39111','S','Magee','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.872919,-89.734963,0,'2013-07-06 12:44:32',NULL,NULL),(32639,'36205','S','Anniston','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.659722,-85.831667,0,'2013-07-06 12:44:32',NULL,NULL),(66398,'78628','S','Georgetown','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.665203,-97.707564,0,'2013-07-06 12:44:34',NULL,NULL),(25377,'28255','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.211192,-80.865108,0,'2013-07-06 12:44:31',NULL,NULL),(14733,'15289','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.438309,-79.997452,0,'2013-07-06 12:44:31',NULL,NULL),(23091,'24920','S','Bartow','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.581829,-79.717497,0,'2013-07-06 12:44:31',NULL,NULL),(52796,'61275','S','Coe','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.598088,-90.317110,0,'2013-07-06 12:44:33',NULL,NULL),(52024,'60179','U','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.079712,-88.224255,0,'2013-07-06 12:44:33',NULL,NULL),(79250,'98561','P','Menlo','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.622306,-123.647856,0,'2013-07-06 12:44:34',NULL,NULL),(79569,'99017','S','Sprague','A','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.193321,-117.800269,0,'2013-07-06 12:44:34',NULL,NULL),(79598,'99037','S','Veradale','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.644452,-117.195238,0,'2013-07-06 12:44:34',NULL,NULL),(58815,'69030','S','Sanborn','N','Dundy','31057','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.160205,-101.945280,0,'2013-07-06 12:44:33',NULL,NULL),(52522,'60913','S','Bonfield','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.148125,-88.056609,0,'2013-07-06 12:44:33',NULL,NULL),(61294,'72414','S','Black Oak','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.836370,-90.366266,0,'2013-07-06 12:44:33',NULL,NULL),(19919,'20553','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887704,-77.024043,0,'2013-07-06 12:44:31',NULL,NULL),(38412,'43537','S','Maumee','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.576929,-83.664917,0,'2013-07-06 12:44:32',NULL,NULL),(48060,'55323','P','Orono','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.954569,-93.576380,0,'2013-07-06 12:44:33',NULL,NULL),(18703,'19194','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954940,-75.183065,0,'2013-07-06 12:44:31',NULL,NULL),(64818,'77028','S','Sheldon','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.826296,-95.287438,0,'2013-07-06 12:44:34',NULL,NULL),(64197,'76247','S','Northlake','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.070947,-97.302229,0,'2013-07-06 12:44:34',NULL,NULL),(2382,'00949','S','Urb El Plantio','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(26345,'29065','S','Monticello','A','Fairfield','45039','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.244829,-81.264483,0,'2013-07-06 12:44:31',NULL,NULL),(5149,'04418','S','Greenfield Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.079164,-68.592463,0,'2013-07-06 12:44:30',NULL,NULL),(43842,'49099','S','Mottville','A','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.793351,-85.661168,0,'2013-07-06 12:44:32',NULL,NULL),(10607,'11040','S','New Hyde Park','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(68717,'82072','S','Bosler','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.061360,-106.014750,0,'2013-07-06 12:44:34',NULL,NULL),(65681,'77993','P','Weesatche','D','Goliad','48175','Texas','TX','48','0000','361','Central',-6.0,'Y',28.654748,-97.426186,0,'2013-07-06 12:44:34',NULL,NULL),(12110,'12583','S','Tivoli','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',42.057300,-73.886760,0,'2013-07-06 12:44:30',NULL,NULL),(32593,'36130','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.373160,-86.311027,0,'2013-07-06 12:44:32',NULL,NULL),(61141,'72164','P','Sweet Home','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.675748,-92.237351,0,'2013-07-06 12:44:33',NULL,NULL),(16925,'17603','S','West Lancaster','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(12528,'13035','S','Caz','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968760,-75.820020,0,'2013-07-06 12:44:30',NULL,NULL),(34035,'38134','S','Bartlett','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.191860,-89.925360,0,'2013-07-06 12:44:32',NULL,NULL),(40551,'45854','P','La Fayette','N','Allen','39003','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.758842,-83.945650,0,'2013-07-06 12:44:32',NULL,NULL),(10483,'10953','P','Mountainville','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.401699,-74.079126,0,'2013-07-06 12:44:30',NULL,NULL),(67160,'79821','S','Vinton','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.970939,-106.597447,0,'2013-07-06 12:44:34',NULL,NULL),(35215,'39301','S','Meeham','N','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.372903,-88.696221,0,'2013-07-06 12:44:32',NULL,NULL),(49953,'57345','S','Howell','N','Hyde','46069','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.520425,-99.443461,0,'2013-07-06 12:44:33',NULL,NULL),(49343,'56567','S','New York Mls','A','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.688056,-95.352778,0,'2013-07-06 12:44:33',NULL,NULL),(49236,'56470','S','Lake Emma','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(43362,'48397','U','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.503868,-83.045668,0,'2013-07-06 12:44:32',NULL,NULL),(63095,'75261','P','DFW Airport','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.873864,-96.965862,0,'2013-07-06 12:44:33',NULL,NULL),(50904,'58549','S','Kintyre','D','Emmons','38029','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.589346,-99.981332,0,'2013-07-06 12:44:33',NULL,NULL),(50260,'57638','S','Lemmon','D','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.937575,-102.160093,0,'2013-07-06 12:44:33',NULL,NULL),(3962,'02481','S','Wellesley Hills','D','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.316214,-71.265402,0,'2013-07-06 12:44:30',NULL,NULL),(11875,'12305','S','Schenectady','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.814529,-73.943411,0,'2013-07-06 12:44:30',NULL,NULL),(38921,'44121','S','Cleveland Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.520000,-81.556389,0,'2013-07-06 12:44:32',NULL,NULL),(43087,'48207','S','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.350631,-83.023593,0,'2013-07-06 12:44:32',NULL,NULL),(40830,'46213','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(69464,'83653','P','Nampa','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.634730,-116.498083,0,'2013-07-06 12:44:34',NULL,NULL),(33007,'36670','P','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.700055,-88.108118,0,'2013-07-06 12:44:32',NULL,NULL),(42927,'48114','S','Brighton Twp','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.529992,-83.782845,0,'2013-07-06 12:44:32',NULL,NULL),(76692,'95822','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.511675,-121.493259,0,'2013-07-06 12:44:34',NULL,NULL),(60954,'72101','S','Riverside','N','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.262221,-91.203001,0,'2013-07-06 12:44:33',NULL,NULL),(56106,'64790','S','Walker','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.888483,-94.232012,0,'2013-07-06 12:44:33',NULL,NULL),(61373,'72523','S','Concord','D','Cleburne','05023','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.623195,-91.782919,0,'2013-07-06 12:44:33',NULL,NULL),(17088,'17764','S','Noyes','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(9671,'10040','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(32626,'36177','U','Montg','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.378975,-86.303722,0,'2013-07-06 12:44:32',NULL,NULL),(57704,'67340','P','Dearing','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.058653,-95.714024,0,'2013-07-06 12:44:33',NULL,NULL),(66871,'79221','P','Aiken','D','Floyd','48153','Texas','TX','48','0000','806','Central',-6.0,'Y',34.119881,-101.446013,0,'2013-07-06 12:44:34',NULL,NULL),(56435,'65265','S','Vandiver','N','Audrain','29007','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.167340,-91.870440,0,'2013-07-06 12:44:33',NULL,NULL),(25951,'28657','S','Ingalls','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(8058,'07740','S','West End','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.295596,-73.994230,0,'2013-07-06 12:44:30',NULL,NULL),(59526,'70805','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.488060,-91.150049,0,'2013-07-06 12:44:33',NULL,NULL),(15542,'16616','S','Beccaria','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.759126,-78.507769,0,'2013-07-06 12:44:31',NULL,NULL),(15302,'16143','S','Pulaski','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.089529,-80.441994,0,'2013-07-06 12:44:31',NULL,NULL),(42039,'47441','S','West Linton','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.073200,-87.170460,0,'2013-07-06 12:44:32',NULL,NULL),(10230,'10463','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.881512,-73.907521,0,'2013-07-06 12:44:30',NULL,NULL),(78567,'98160','P','Richmond Beach','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.771124,-122.382371,0,'2013-07-06 12:44:34',NULL,NULL),(29304,'32521','U','City of Pensacola','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.375769,-87.276144,0,'2013-07-06 12:44:32',NULL,NULL),(62827,'74963','S','Watson','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.315507,-94.568242,0,'2013-07-06 12:44:33',NULL,NULL),(30974,'33742','P','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.844686,-82.643445,0,'2013-07-06 12:44:32',NULL,NULL),(22714,'24352','S','Laurel Fork','D','Carroll','51035','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.709127,-80.518355,0,'2013-07-06 12:44:31',NULL,NULL),(75997,'95106','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.338540,-121.891619,0,'2013-07-06 12:44:34',NULL,NULL),(31183,'33930','P','Felda','D','Hendry','12051','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.710106,-81.529356,0,'2013-07-06 12:44:32',NULL,NULL),(14527,'15205','S','Ingram','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437059,-80.074137,0,'2013-07-06 12:44:31',NULL,NULL),(63089,'75253','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.687055,-96.602168,0,'2013-07-06 12:44:33',NULL,NULL),(48876,'56089','S','Twin Lakes','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.560978,-93.423372,0,'2013-07-06 12:44:33',NULL,NULL),(50526,'58103','S','Fargo','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.852000,-96.814801,0,'2013-07-06 12:44:33',NULL,NULL),(6796,'06108','S','East Htfd','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.776681,-72.622928,0,'2013-07-06 12:44:30',NULL,NULL),(79424,'98826','S','Plain','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(16448,'17236','S','Shimpstown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(20822,'21625','S','Cordova','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.864311,-75.998898,0,'2013-07-06 12:44:31',NULL,NULL),(59515,'70788','S','Bayou Goula','A','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.167164,-91.148219,0,'2013-07-06 12:44:33',NULL,NULL),(3888,'02379','S','West Bridgewater','D','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',42.018468,-71.013855,0,'2013-07-06 12:44:30',NULL,NULL),(25976,'28659','S','Spurgeon','N','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.234234,-81.113377,0,'2013-07-06 12:44:31',NULL,NULL),(33638,'37687','S','Roan Mountain','D','Carter','47019','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.171244,-82.096567,0,'2013-07-06 12:44:32',NULL,NULL),(72661,'89434','S','Mustang','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.552532,-119.716592,0,'2013-07-06 12:44:34',NULL,NULL),(65802,'78132','S','Hunter','N','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.777220,-98.152980,0,'2013-07-06 12:44:34',NULL,NULL),(62620,'74543','S','Finley','D','Pushmataha','40127','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.347092,-95.550322,0,'2013-07-06 12:44:33',NULL,NULL),(36101,'40220','S','Lincolnshire','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.213254,-85.621574,0,'2013-07-06 12:44:32',NULL,NULL),(55482,'63758','P','Kelso','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.190960,-89.550208,0,'2013-07-06 12:44:33',NULL,NULL),(39129,'44266','S','Proctor','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.159227,-81.233714,0,'2013-07-06 12:44:32',NULL,NULL),(29675,'32920','S','Cape Canaveral','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.391416,-80.605396,0,'2013-07-06 12:44:32',NULL,NULL),(70292,'84533','S','Lake Powell','D','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(58309,'68434','S','Tamora','N','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.911360,-97.152300,0,'2013-07-06 12:44:33',NULL,NULL),(52764,'61254','S','Geneseo','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.457579,-90.163141,0,'2013-07-06 12:44:33',NULL,NULL),(45078,'50526','U','HP','N','Wright','19197','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.732885,-93.732537,0,'2013-07-06 12:44:32',NULL,NULL),(40470,'45767','S','Matamoras','A','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.603478,-81.082854,0,'2013-07-06 12:44:32',NULL,NULL),(39701,'45040','S','Mason','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.345374,-84.313966,0,'2013-07-06 12:44:32',NULL,NULL),(78654,'98227','P','Bellingham','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.800066,-122.407858,0,'2013-07-06 12:44:34',NULL,NULL),(72667,'89436','S','Spanish Springs','A','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.645257,-119.698716,0,'2013-07-06 12:44:34',NULL,NULL),(70818,'85380','P','Peoria','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.688644,-112.244481,0,'2013-07-06 12:44:34',NULL,NULL),(2149,'00924','S','Villa Navarra','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(70365,'84651','S','Spring Lake','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.026844,-111.705036,0,'2013-07-06 12:44:34',NULL,NULL),(10728,'11352','P','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.753276,-73.820637,0,'2013-07-06 12:44:30',NULL,NULL),(38170,'43155','S','Sugar Grove','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.630339,-82.535734,0,'2013-07-06 12:44:32',NULL,NULL),(77246,'96542','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(68016,'80924','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.739417,-104.635170,0,'2013-07-06 12:44:34',NULL,NULL),(25681,'28516','S','Cape Lookout National Seasho','N','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.731559,-76.655049,0,'2013-07-06 12:44:31',NULL,NULL),(59408,'70644','P','Grant','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.678321,-92.934850,0,'2013-07-06 12:44:33',NULL,NULL),(15626,'16698','U','SCI Houtzdale','N','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.828332,-78.352347,0,'2013-07-06 12:44:31',NULL,NULL),(79451,'98846','S','Pateros','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.233413,-119.814273,0,'2013-07-06 12:44:34',NULL,NULL),(8699,'08350','S','Richland','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.490764,-74.881538,0,'2013-07-06 12:44:30',NULL,NULL),(67554,'80271','U','Wells Fargo Bank','N','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.744563,-104.990066,0,'2013-07-06 12:44:34',NULL,NULL),(76982,'96063','P','Lassen Volcanic National Par','N','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',40.360478,-121.564354,0,'2013-07-06 12:44:34',NULL,NULL),(6757,'06089','S','Weatogue','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.841162,-72.823567,0,'2013-07-06 12:44:30',NULL,NULL),(40258,'45431','S','Beavercreek Township','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.765802,-84.120940,0,'2013-07-06 12:44:32',NULL,NULL),(68853,'82609','S','Casper','D','Natrona','56025','Wyoming','WY','56','1350','307','Mountain',-7.0,'Y',42.846450,-106.274603,0,'2013-07-06 12:44:34',NULL,NULL),(41356,'46792','S','Mount Zion','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(72550,'89193','P','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.083862,-115.145672,0,'2013-07-06 12:44:34',NULL,NULL),(67008,'79516','P','Dunn','D','Scurry','48415','Texas','TX','48','0000','325','Central',-6.0,'Y',32.566900,-100.885554,0,'2013-07-06 12:44:34',NULL,NULL),(64658,'76801','S','Lake Shore','N','Brown','48049','Texas','TX','48','0000','325','Central',-6.0,'Y',31.688700,-98.967720,0,'2013-07-06 12:44:34',NULL,NULL),(53904,'62365','S','Plainville','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.828285,-91.193150,0,'2013-07-06 12:44:33',NULL,NULL),(36638,'41004','S','Willow','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.651705,-84.095395,0,'2013-07-06 12:44:32',NULL,NULL),(45368,'51009','P','Calumet','D','Obrien','19141','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.945207,-95.550225,0,'2013-07-06 12:44:32',NULL,NULL),(18643,'19162','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955702,-75.181007,0,'2013-07-06 12:44:31',NULL,NULL),(4511,'03298','U','J Jill Brm','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.634856,-71.531507,0,'2013-07-06 12:44:30',NULL,NULL),(67688,'80515','S','Loveland','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.441457,-105.369149,0,'2013-07-06 12:44:34',NULL,NULL),(35380,'39455','S','Baxterville','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(36533,'40862','S','Partridge','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.011481,-82.875359,0,'2013-07-06 12:44:32',NULL,NULL),(7233,'06507','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.305516,-72.922831,0,'2013-07-06 12:44:30',NULL,NULL),(74384,'92508','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.887600,-117.313369,0,'2013-07-06 12:44:34',NULL,NULL),(31562,'34610','S','Spring Hill','D','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.397951,-82.537892,0,'2013-07-06 12:44:32',NULL,NULL),(25472,'28343','S','Gibson','D','Scotland','37165','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.788592,-79.554281,0,'2013-07-06 12:44:31',NULL,NULL),(32128,'35444','S','Brookwood','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.338834,-87.122617,0,'2013-07-06 12:44:32',NULL,NULL),(16227,'17074','S','Nwprt','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(65440,'77586','S','Tod','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(50041,'57433','S','Columbia','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.679320,-98.308680,0,'2013-07-06 12:44:33',NULL,NULL),(45565,'51520','S','Arion','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.949169,-95.463302,0,'2013-07-06 12:44:32',NULL,NULL),(14370,'15025','S','Jefferson Hls','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.295525,-79.916350,0,'2013-07-06 12:44:31',NULL,NULL),(33185,'37033','S','Coble','N','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.668470,-87.699030,0,'2013-07-06 12:44:32',NULL,NULL),(22922,'24613','S','Falls Mills','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.265833,-81.331458,0,'2013-07-06 12:44:31',NULL,NULL),(31354,'34202','S','Lakewood Rch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.475504,-82.392128,0,'2013-07-06 12:44:32',NULL,NULL),(79355,'98639','P','North Bonneville','D','Skamania','53059','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.643202,-121.968412,0,'2013-07-06 12:44:34',NULL,NULL),(39542,'44839','S','Ceylon','N','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388818,-82.561774,0,'2013-07-06 12:44:32',NULL,NULL),(48710,'55946','S','Kenyon','D','Goodhue','27049','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.271167,-92.988924,0,'2013-07-06 12:44:33',NULL,NULL),(2896,'00987','S','Urb Carolina Alta','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(4247,'02875','S','Richmond','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.457393,-71.639083,0,'2013-07-06 12:44:30',NULL,NULL),(28014,'30621','S','N High Shoals','A','Oconee','13219','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.833825,-83.471768,0,'2013-07-06 12:44:31',NULL,NULL),(72437,'89085','S','North Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.300030,-115.141810,0,'2013-07-06 12:44:34',NULL,NULL),(9969,'10161','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.747012,-74.005347,0,'2013-07-06 12:44:30',NULL,NULL),(51506,'59642','P','Ringling','D','Meagher','30059','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.301734,-110.872484,0,'2013-07-06 12:44:33',NULL,NULL),(6882,'06141','P','HFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.792221,-72.665323,0,'2013-07-06 12:44:30',NULL,NULL),(25200,'28077','P','High Shoals','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.401297,-81.204549,0,'2013-07-06 12:44:31',NULL,NULL),(39218,'44410','S','Cortland','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.331036,-80.729796,0,'2013-07-06 12:44:32',NULL,NULL),(42001,'47424','S','Tulip','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(48786,'56001','S','Skyline','A','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.160927,-93.995246,0,'2013-07-06 12:44:33',NULL,NULL),(3428,'01742','S','W Concord','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.456444,-71.370954,0,'2013-07-06 12:44:30',NULL,NULL),(1301,'00730','S','Valle Alto','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(23697,'25864','S','Terry','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.871329,-80.996894,0,'2013-07-06 12:44:31',NULL,NULL),(21883,'23173','U','University Of Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.577785,-77.534555,0,'2013-07-06 12:44:31',NULL,NULL),(30333,'33309','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(50134,'57532','S','Laroche','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(29956,'33074','P','Lighthouse Point','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.238998,-80.124146,0,'2013-07-06 12:44:32',NULL,NULL),(27207,'29907','S','Ladies Island','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.427269,-80.702200,0,'2013-07-06 12:44:31',NULL,NULL),(23341,'25251','S','Left Hand','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.611825,-81.246538,0,'2013-07-06 12:44:31',NULL,NULL),(71262,'86412','P','Hualapai','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.503062,-113.881715,0,'2013-07-06 12:44:34',NULL,NULL),(66602,'78758','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.378845,-97.711093,0,'2013-07-06 12:44:34',NULL,NULL),(55890,'64428','S','Burlingtn Jct','N','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.436052,-95.019402,0,'2013-07-06 12:44:33',NULL,NULL),(53724,'62246','S','Ayers','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.888242,-89.407911,0,'2013-07-06 12:44:33',NULL,NULL),(45153,'50588','S','Casino Beach','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(21549,'22746','S','Viewtown','D','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.636708,-78.013297,0,'2013-07-06 12:44:31',NULL,NULL),(40059,'45269','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.106237,-84.534866,0,'2013-07-06 12:44:32',NULL,NULL),(44780,'50214','S','Park Hills','N','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.459212,-93.038568,0,'2013-07-06 12:44:32',NULL,NULL),(49551,'56688','S','Wirt','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.718698,-93.962032,0,'2013-07-06 12:44:33',NULL,NULL),(74179,'92275','P','Salton City','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.640389,-116.141879,0,'2013-07-06 12:44:34',NULL,NULL),(73036,'90077','S','Barrington','N','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.101509,-118.452396,0,'2013-07-06 12:44:34',NULL,NULL),(2427,'00953','S','Toa Alta','D','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(63874,'76008','S','Annetta','A','Parker','48367','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.699617,-97.628794,0,'2013-07-06 12:44:34',NULL,NULL),(16449,'17236','S','Sylvan','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(18993,'19522','S','RuscoMBManor Twp','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(976,'00716','S','Urb Santa Clara','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(65818,'78146','P','Pettus','D','Bee','48025','Texas','TX','48','0000','361','Central',-6.0,'Y',28.614976,-97.803040,0,'2013-07-06 12:44:34',NULL,NULL),(65338,'77520','S','Cedar Point','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(3169,'01270','S','East Windsor','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.336404,-73.254387,0,'2013-07-06 12:44:30',NULL,NULL),(46584,'53537','P','Footville','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.670296,-89.213228,0,'2013-07-06 12:44:32',NULL,NULL),(29127,'32317','S','Tallahassee','D','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.567200,-84.111895,0,'2013-07-06 12:44:32',NULL,NULL),(39881,'45211','S','Bridgetown','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.158460,-84.594600,0,'2013-07-06 12:44:32',NULL,NULL),(69553,'83811','S','Clark Fork','D','Bonner','16017','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',48.147478,-116.178280,0,'2013-07-06 12:44:34',NULL,NULL),(16495,'17257','S','Shippensburg','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(6138,'05462','S','Huntington Lower Village','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.310720,-73.003500,0,'2013-07-06 12:44:30',NULL,NULL),(696,'00685','S','Urb El Culebrina','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(27806,'30398','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.650336,-84.389036,0,'2013-07-06 12:44:31',NULL,NULL),(22616,'24220','S','Birchleaf','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.152395,-82.237486,0,'2013-07-06 12:44:31',NULL,NULL),(57416,'66773','S','Roseland','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.267281,-94.853706,0,'2013-07-06 12:44:33',NULL,NULL),(7007,'06256','S','South Chaplin','N','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.751840,-72.142800,0,'2013-07-06 12:44:30',NULL,NULL),(1703,'00777','S','Urb Senderos De Juncos','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(3420,'01720','S','West Acton','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.477355,-71.446686,0,'2013-07-06 12:44:30',NULL,NULL),(68910,'82832','S','Story','A','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.645411,-106.798869,0,'2013-07-06 12:44:34',NULL,NULL),(6427,'05743','S','Benson Landing','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.594271,-73.266808,0,'2013-07-06 12:44:30',NULL,NULL),(77126,'96154','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.943645,-119.977876,0,'2013-07-06 12:44:34',NULL,NULL),(18846,'19429','U','Conshohocken','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.080514,-75.300080,0,'2013-07-06 12:44:31',NULL,NULL),(67354,'80110','S','Sheridan','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(64124,'76190','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','0000','000','Eastern',-5.0,'Y',21.266700,-99.316700,0,'2013-07-06 12:44:34',NULL,NULL),(14039,'14551','S','Sodus','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.200120,-77.038500,0,'2013-07-06 12:44:31',NULL,NULL),(44662,'50109','S','Granger','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.761899,-93.774509,0,'2013-07-06 12:44:32',NULL,NULL),(27782,'30375','U','ATT Bellsouth','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.775206,-84.389428,0,'2013-07-06 12:44:31',NULL,NULL),(17113,'17771','S','Trout Run','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(69628,'83874','P','Wallace','A','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.623381,-115.857511,0,'2013-07-06 12:44:34',NULL,NULL),(53950,'62422','S','Bowling Green','N','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.216769,-88.903850,0,'2013-07-06 12:44:33',NULL,NULL),(1163,'00727','S','Urb Bairoa Golden Gates','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(12186,'12771','S','Port Jervis','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.373715,-74.665744,0,'2013-07-06 12:44:30',NULL,NULL),(42668,'47960','S','Monticello','D','White','18181','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.749635,-86.762622,0,'2013-07-06 12:44:32',NULL,NULL),(57566,'67051','S','Geuda Springs','D','Sumner','20191','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.061520,-97.169220,0,'2013-07-06 12:44:33',NULL,NULL),(44334,'49760','S','Moran','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.043353,-84.973791,0,'2013-07-06 12:44:32',NULL,NULL),(47612,'54890','P','Wascott','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.175902,-91.798524,0,'2013-07-06 12:44:33',NULL,NULL),(54441,'62842','S','Lamard','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.440349,-88.426303,0,'2013-07-06 12:44:33',NULL,NULL),(66889,'79243','S','McAdoo','D','Dickens','48125','Texas','TX','48','0000','806','Central',-6.0,'Y',33.776371,-100.963219,0,'2013-07-06 12:44:34',NULL,NULL),(38939,'44124','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(5381,'04637','P','Grand Lk Strm','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.223333,-67.572778,0,'2013-07-06 12:44:30',NULL,NULL),(10774,'11365','S','Fresh Meadows','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.738549,-73.790001,0,'2013-07-06 12:44:30',NULL,NULL),(52712,'61125','P','Rockford','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.237359,-89.012382,0,'2013-07-06 12:44:33',NULL,NULL),(925,'00714','S','Qtas de Guasima','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(21312,'22406','S','Fred','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(21043,'21872','S','Whaleyville','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.399628,-75.299816,0,'2013-07-06 12:44:31',NULL,NULL),(15574,'16651','S','SCI Houtzdale','N','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.823943,-78.349798,0,'2013-07-06 12:44:31',NULL,NULL),(904,'00705','S','Ext Villa Rosales','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(1007,'00717','S','Urb San Antonio','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(32202,'35552','S','Detroit','D','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.993530,-88.158358,0,'2013-07-06 12:44:32',NULL,NULL),(68482,'81251','S','Twin Lakes','D','Lake','08065','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.071220,-106.448520,0,'2013-07-06 12:44:34',NULL,NULL),(66700,'78945','S','Winchester','A','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(18834,'19424','U','Blue Bell','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.148617,-75.266159,0,'2013-07-06 12:44:31',NULL,NULL),(17086,'17764','S','Hammersley Fk','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(54603,'62908','S','Mermet','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.328034,-88.950830,0,'2013-07-06 12:44:33',NULL,NULL),(32529,'36101','P','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.398863,-86.325648,0,'2013-07-06 12:44:32',NULL,NULL),(9670,'10040','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.858370,-73.927473,0,'2013-07-06 12:44:30',NULL,NULL),(62940,'75097','P','Weston','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.348780,-96.669120,0,'2013-07-06 12:44:33',NULL,NULL),(50398,'57770','S','Pine Ridge Reservation','N','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.232220,-102.696720,0,'2013-07-06 12:44:33',NULL,NULL),(77921,'97321','S','Albany','D','Linn','41043','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.625600,-123.066420,0,'2013-07-06 12:44:34',NULL,NULL),(65274,'77477','S','Meadows Place','A','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.621316,-95.562225,0,'2013-07-06 12:44:34',NULL,NULL),(54013,'62450','S','Olney','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.730805,-88.084555,0,'2013-07-06 12:44:33',NULL,NULL),(19962,'20588','U','Cheltenham','A','Howard','24027','Maryland','MD','24','8840','202','Eastern',-5.0,'Y',38.916044,-77.056499,0,'2013-07-06 12:44:31',NULL,NULL),(36898,'41114','U','Ashland','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.461423,-82.647651,0,'2013-07-06 12:44:32',NULL,NULL),(12309,'12856','P','North River','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.740463,-74.050649,0,'2013-07-06 12:44:30',NULL,NULL),(58661,'68879','S','Almeria','A','Loup','31115','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.853120,-99.440580,0,'2013-07-06 12:44:33',NULL,NULL),(46961,'54202','S','Baileys Harbor','D','Door','55029','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.067316,-87.143147,0,'2013-07-06 12:44:32',NULL,NULL),(38750,'44035','S','North Ridgeville','A','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.370813,-82.114096,0,'2013-07-06 12:44:32',NULL,NULL),(4581,'03576','S','Dixville Notch','N','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.892390,-71.498526,0,'2013-07-06 12:44:30',NULL,NULL),(23958,'26288','S','Parcoal','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.497260,-80.369280,0,'2013-07-06 12:44:31',NULL,NULL),(5778,'05050','P','McIndoe Falls','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262531,-72.058292,0,'2013-07-06 12:44:30',NULL,NULL),(49340,'56566','S','Naytahwaush','D','Mahnomen','27087','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.236957,-95.615631,0,'2013-07-06 12:44:33',NULL,NULL),(79233,'98550','S','Newton','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(75000,'93453','S','Pozo','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.365892,-120.392105,0,'2013-07-06 12:44:34',NULL,NULL),(24239,'26755','S','Rio','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.177526,-78.691989,0,'2013-07-06 12:44:31',NULL,NULL),(30701,'33484','S','West Delray Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.457619,-80.135160,0,'2013-07-06 12:44:32',NULL,NULL),(68651,'81642','S','Nast','N','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.343479,-106.678875,0,'2013-07-06 12:44:34',NULL,NULL),(49641,'56950','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(38108,'43103','S','Ashville','D','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.726780,-82.952940,0,'2013-07-06 12:44:32',NULL,NULL),(67867,'80829','S','Manitou Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.855979,-104.906332,0,'2013-07-06 12:44:34',NULL,NULL),(221,'00624','S','Urb Llanos De Sabana Palma','N','Penuelas','72111','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.063481,-66.723612,0,'2013-07-06 12:44:30',NULL,NULL),(66190,'78539','S','Lull','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.332020,-98.163840,0,'2013-07-06 12:44:34',NULL,NULL),(59556,'70826','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.401161,-91.077146,0,'2013-07-06 12:44:33',NULL,NULL),(14161,'14726','S','Conewango Vly','A','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.238377,-79.060848,0,'2013-07-06 12:44:31',NULL,NULL),(31409,'34236','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.332306,-82.551206,0,'2013-07-06 12:44:32',NULL,NULL),(55797,'64129','S','Raytown','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.021792,-94.489653,0,'2013-07-06 12:44:33',NULL,NULL),(46480,'53220','S','Greenfield','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.961389,-88.012500,0,'2013-07-06 12:44:32',NULL,NULL),(73083,'90220','S','Compton','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.890694,-118.239135,0,'2013-07-06 12:44:34',NULL,NULL),(46114,'52637','S','Kossuth','N','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.007600,-91.097940,0,'2013-07-06 12:44:32',NULL,NULL),(75,'00612','S','Ext Tanama','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(8166,'07863','S','Oxford','D','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.814320,-74.968670,0,'2013-07-06 12:44:30',NULL,NULL),(21146,'22109','U','Wachovia Bank','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.933680,-77.184391,0,'2013-07-06 12:44:31',NULL,NULL),(13825,'14217','S','Tonawanda','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.972758,-78.876061,0,'2013-07-06 12:44:31',NULL,NULL),(28531,'31552','S','Millwood','D','Ware','13299','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.270467,-82.638049,0,'2013-07-06 12:44:32',NULL,NULL),(28434,'31403','P','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.043785,-81.111925,0,'2013-07-06 12:44:32',NULL,NULL),(60608,'71854','S','Texarkana','D','Miller','05091','Arkansas','AR','05','8360','870','Central',-6.0,'Y',33.436576,-94.019848,0,'2013-07-06 12:44:33',NULL,NULL),(57165,'66283','P','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861823,-94.670864,0,'2013-07-06 12:44:33',NULL,NULL),(75036,'93514','S','Chalfant Valley','A','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',37.357496,-118.416618,0,'2013-07-06 12:44:34',NULL,NULL),(27336,'30038','S','Lithonia','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.681893,-84.161895,0,'2013-07-06 12:44:31',NULL,NULL),(47488,'54754','S','Hatfield','N','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.446740,-90.818160,0,'2013-07-06 12:44:32',NULL,NULL),(8028,'07728','S','Freehold','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.243519,-74.277392,0,'2013-07-06 12:44:30',NULL,NULL),(9304,'09715','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(18112,'18767','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.249950,-75.875977,0,'2013-07-06 12:44:31',NULL,NULL),(45409,'51047','S','Peterson','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.919009,-95.339599,0,'2013-07-06 12:44:32',NULL,NULL),(48688,'55931','S','Eitzen','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.602779,-91.444998,0,'2013-07-06 12:44:33',NULL,NULL),(13818,'14215','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.933454,-78.811840,0,'2013-07-06 12:44:31',NULL,NULL),(57079,'66215','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(29717,'32951','S','Melbourne Bch','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.024675,-80.539219,0,'2013-07-06 12:44:32',NULL,NULL),(20967,'21788','S','Graceham','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.600540,-77.429160,0,'2013-07-06 12:44:31',NULL,NULL),(13870,'14241','U','Bflo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.927923,-78.747650,0,'2013-07-06 12:44:31',NULL,NULL),(10128,'10261','U','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(14341,'15009','S','W Bridgewater','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.702800,-80.355660,0,'2013-07-06 12:44:31',NULL,NULL),(32711,'36301','S','Hodgesville','N','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.199820,-85.417680,0,'2013-07-06 12:44:32',NULL,NULL),(49208,'56461','S','Guthrie','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.227020,-94.766880,0,'2013-07-06 12:44:33',NULL,NULL),(48652,'55909','S','Adams','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.567108,-92.718696,0,'2013-07-06 12:44:33',NULL,NULL),(36476,'40759','S','Rockholds','D','Whitley','21235','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.827380,-84.091590,0,'2013-07-06 12:44:32',NULL,NULL),(72090,'88201','S','Roswell','D','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.393099,-104.522917,0,'2013-07-06 12:44:34',NULL,NULL),(11292,'11776','S','Port Jefferson Station','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(63967,'76102','S','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.757178,-97.323972,0,'2013-07-06 12:44:34',NULL,NULL),(58283,'68409','S','Murray','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',40.915033,-95.928545,0,'2013-07-06 12:44:33',NULL,NULL),(1648,'00771','S','Villas De San Cristobal','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(44421,'49836','S','Germfask','D','Schoolcraft','26153','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.243692,-85.928722,0,'2013-07-06 12:44:32',NULL,NULL),(63485,'75693','S','Clarksville City','A','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.540043,-94.857003,0,'2013-07-06 12:44:33',NULL,NULL),(26652,'29364','P','Lockhart','D','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.785521,-81.464419,0,'2013-07-06 12:44:31',NULL,NULL),(17263,'17842','S','Meiser','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.794122,-77.026747,0,'2013-07-06 12:44:31',NULL,NULL),(11679,'12150','S','Rotterdam Junction','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.876680,-74.043438,0,'2013-07-06 12:44:30',NULL,NULL),(58048,'68028','S','Gretna','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.127216,-96.250421,0,'2013-07-06 12:44:33',NULL,NULL),(36929,'41164','S','Brinegar','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(48261,'55428','S','Brooklyn Center','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064712,-93.381245,0,'2013-07-06 12:44:33',NULL,NULL),(77420,'96801','P','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.325480,-157.831334,0,'2013-07-06 12:44:34',NULL,NULL),(474,'00667','S','Bda Tomei','N','Lajas','72079','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.045169,-67.057853,0,'2013-07-06 12:44:30',NULL,NULL),(68165,'81006','S','Vineland','N','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.244574,-104.524364,0,'2013-07-06 12:44:34',NULL,NULL),(58414,'68643','S','Leigh','D','Colfax','31037','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.704228,-97.231539,0,'2013-07-06 12:44:33',NULL,NULL),(16012,'17042','S','Avon Heights','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(9796,'10109','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(36584,'40962','S','Bright Shade','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(42937,'48117','S','Carleton','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.052359,-83.410724,0,'2013-07-06 12:44:32',NULL,NULL),(45930,'52335','S','Kinross','A','Keokuk','19107','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.469607,-92.116288,0,'2013-07-06 12:44:32',NULL,NULL),(28499,'31524','U','Fed Law Enforcement Trng Ctr','N','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.144010,-81.469037,0,'2013-07-06 12:44:32',NULL,NULL),(28200,'31022','S','Dudley','D','Laurens','13175','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.509216,-83.088850,0,'2013-07-06 12:44:31',NULL,NULL),(4148,'02763','S','Attleboro Fls','A','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.970895,-71.304600,0,'2013-07-06 12:44:30',NULL,NULL),(11293,'11776','S','Prt Jeff Sta','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.909840,-73.046164,0,'2013-07-06 12:44:30',NULL,NULL),(2007,'00913','S','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451003,-66.045064,0,'2013-07-06 12:44:30',NULL,NULL),(23899,'26201','S','Hodgesville','N','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.983537,-80.225375,0,'2013-07-06 12:44:31',NULL,NULL),(56122,'64831','S','Anderson','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.648293,-94.447841,0,'2013-07-06 12:44:33',NULL,NULL),(78912,'98363','S','Prt Angeles','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.118410,-123.480610,0,'2013-07-06 12:44:34',NULL,NULL),(70170,'84322','U','Utah State University','N','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.746323,-111.810684,0,'2013-07-06 12:44:34',NULL,NULL),(282,'00646','S','Parc Mameyal','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(78400,'98034','S','Kingsgate','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.718053,-122.198946,0,'2013-07-06 12:44:34',NULL,NULL),(58044,'68023','S','Fort Calhoun','D','Washington','31177','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.456200,-96.024852,0,'2013-07-06 12:44:33',NULL,NULL),(71175,'86042','P','Polacca','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.967439,-110.430862,0,'2013-07-06 12:44:34',NULL,NULL),(61190,'72214','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.775891,-92.277155,0,'2013-07-06 12:44:33',NULL,NULL),(14524,'15204','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.452082,-80.056352,0,'2013-07-06 12:44:31',NULL,NULL),(8979,'08828','S','Helmetta','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.377937,-74.419215,0,'2013-07-06 12:44:30',NULL,NULL),(44218,'49643','S','Interlochen','D','Grand Traverse','26055','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.651160,-85.838640,0,'2013-07-06 12:44:32',NULL,NULL),(10631,'11052','U','Publishers Clear House','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.844414,-73.701934,0,'2013-07-06 12:44:30',NULL,NULL),(41087,'46537','P','La Paz','A','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.457406,-86.305414,0,'2013-07-06 12:44:32',NULL,NULL),(37691,'42236','S','Herndon','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.710577,-87.603781,0,'2013-07-06 12:44:32',NULL,NULL),(78026,'97424','S','Walden','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.784169,-123.057967,0,'2013-07-06 12:44:34',NULL,NULL),(16254,'17084','S','Gardenview','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.677620,-77.606927,0,'2013-07-06 12:44:31',NULL,NULL),(14714,'15272','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441848,-80.005017,0,'2013-07-06 12:44:31',NULL,NULL),(67309,'80022','S','Commerce City','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.831897,-104.894182,0,'2013-07-06 12:44:34',NULL,NULL),(53636,'62201','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(50774,'58424','S','Windsor','A','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.894080,-99.095940,0,'2013-07-06 12:44:33',NULL,NULL),(47608,'54880','S','Oliver','A','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.705941,-92.074691,0,'2013-07-06 12:44:33',NULL,NULL),(27009,'29638','S','Shoals Junction','A','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.374350,-82.272156,0,'2013-07-06 12:44:31',NULL,NULL),(20484,'21047','S','Fallston','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.525849,-76.430070,0,'2013-07-06 12:44:31',NULL,NULL),(61721,'73016','S','Cashion','D','Kingfisher','40073','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.799856,-97.676823,0,'2013-07-06 12:44:33',NULL,NULL),(25498,'28369','S','Orrum','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.427354,-79.021071,0,'2013-07-06 12:44:31',NULL,NULL),(59771,'71201','S','Fondale','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.522484,-92.103332,0,'2013-07-06 12:44:33',NULL,NULL),(78259,'97842','S','Imnaha','D','Wallowa','41063','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.750882,-116.862928,0,'2013-07-06 12:44:34',NULL,NULL),(3546,'01922','S','Newbury','A','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.755852,-70.931083,0,'2013-07-06 12:44:30',NULL,NULL),(69890,'84104','S','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.749850,-111.934638,0,'2013-07-06 12:44:34',NULL,NULL),(26877,'29551','P','Hartsville','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.368964,-80.086322,0,'2013-07-06 12:44:31',NULL,NULL),(21498,'22663','S','White Post','D','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.054892,-78.097567,0,'2013-07-06 12:44:31',NULL,NULL),(33950,'38080','S','Ridgely','D','Lake','47095','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.263847,-89.484004,0,'2013-07-06 12:44:32',NULL,NULL),(46685,'53779','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.095268,-89.326410,0,'2013-07-06 12:44:32',NULL,NULL),(46650,'53701','P','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.072838,-89.379278,0,'2013-07-06 12:44:32',NULL,NULL),(43758,'49016','P','Battle Creek','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.305870,-85.172099,0,'2013-07-06 12:44:32',NULL,NULL),(39632,'44890','S','Havana','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(26477,'29153','S','Sumter','D','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.941345,-80.324377,0,'2013-07-06 12:44:31',NULL,NULL),(52335,'60568','U','Northern Il Gas','N','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.773392,-88.247376,0,'2013-07-06 12:44:33',NULL,NULL),(36953,'41171','S','Bruin','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(12127,'12604','U','Poughkeepsie','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.685996,-73.896069,0,'2013-07-06 12:44:30',NULL,NULL),(77243,'96538','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(67772,'80644','S','Kersey','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.341639,-104.529139,0,'2013-07-06 12:44:34',NULL,NULL),(22399,'23954','S','Meherrin','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.096043,-78.382492,0,'2013-07-06 12:44:31',NULL,NULL),(49287,'56520','S','Breckenridge','D','Wilkin','27167','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.268423,-96.587538,0,'2013-07-06 12:44:33',NULL,NULL),(18634,'19155','P','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.096358,-74.978989,0,'2013-07-06 12:44:31',NULL,NULL),(42703,'47996','P','Lafayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.443842,-86.911409,0,'2013-07-06 12:44:32',NULL,NULL),(2462,'00956','S','Bosque de Las Flores','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(75714,'94579','S','San Leandro','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.688081,-122.149396,0,'2013-07-06 12:44:34',NULL,NULL),(12441,'12960','S','Moriah Corners','N','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.037103,-73.516791,0,'2013-07-06 12:44:30',NULL,NULL),(38718,'44022','S','Hunting Valley','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(7968,'07701','S','Westboro','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.353122,-74.074629,0,'2013-07-06 12:44:30',NULL,NULL),(35698,'39664','S','Thompson','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.356300,-90.636060,0,'2013-07-06 12:44:32',NULL,NULL),(4654,'03755','S','Hanover','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.711386,-72.270611,0,'2013-07-06 12:44:30',NULL,NULL),(70454,'84751','S','Burbank','N','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.351737,-112.986950,0,'2013-07-06 12:44:34',NULL,NULL),(42137,'47513','S','Riceville','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.283320,-86.714517,0,'2013-07-06 12:44:32',NULL,NULL),(45497,'51358','S','Lost Island Lake','N','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.131401,-94.899857,0,'2013-07-06 12:44:32',NULL,NULL),(6941,'06176','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768415,-72.669185,0,'2013-07-06 12:44:30',NULL,NULL),(71926,'87830','S','Lower San Francisco Plaza','N','Catron','35003','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.652664,-108.764998,0,'2013-07-06 12:44:34',NULL,NULL),(50798,'58445','S','Grace Cty','N','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.541934,-98.816327,0,'2013-07-06 12:44:33',NULL,NULL),(69389,'83612','S','Cuprum','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(53523,'62027','S','Woodville','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.286541,-90.553196,0,'2013-07-06 12:44:33',NULL,NULL),(51672,'59920','S','Kila','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.065157,-114.502262,0,'2013-07-06 12:44:33',NULL,NULL),(24647,'27377','S','Stoney Creek','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.035608,-79.602646,0,'2013-07-06 12:44:31',NULL,NULL),(57590,'67073','S','Lehigh','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.375851,-97.304362,0,'2013-07-06 12:44:33',NULL,NULL),(43172,'48275','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.332231,-83.050280,0,'2013-07-06 12:44:32',NULL,NULL),(4779,'03862','S','North Hampton','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',42.976443,-70.820892,0,'2013-07-06 12:44:30',NULL,NULL),(35159,'39236','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364207,-90.145180,0,'2013-07-06 12:44:32',NULL,NULL),(69911,'84108','S','Emigration Canyon','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.738359,-111.812479,0,'2013-07-06 12:44:34',NULL,NULL),(26368,'29073','S','Lexington','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.927355,-81.216327,0,'2013-07-06 12:44:31',NULL,NULL),(20085,'20690','S','Tall Timbers','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.166031,-76.542912,0,'2013-07-06 12:44:31',NULL,NULL),(55212,'63401','S','Clay','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(49598,'56751','S','Ross','A','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.846666,-95.757088,0,'2013-07-06 12:44:33',NULL,NULL),(77394,'96772','S','Naalehu','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.085968,-155.708899,0,'2013-07-06 12:44:34',NULL,NULL),(78500,'98110','S','Bainbridge Is','A','Kitsap','53035','Washington','WA','53','1150','206/564','Pacific',-8.0,'Y',47.648322,-122.533526,0,'2013-07-06 12:44:34',NULL,NULL),(69068,'83241','S','Bench','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.526431,-111.759461,0,'2013-07-06 12:44:34',NULL,NULL),(7167,'06442','S','Ivoryton','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.345098,-72.444625,0,'2013-07-06 12:44:30',NULL,NULL),(46710,'53794','U','Swiss Colony','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.098373,-89.324921,0,'2013-07-06 12:44:32',NULL,NULL),(16102,'17053','S','Marysville','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.337522,-76.983731,0,'2013-07-06 12:44:31',NULL,NULL),(70886,'85614','S','Madera Canyon','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.859137,-111.000231,0,'2013-07-06 12:44:34',NULL,NULL),(24258,'26812','S','Mathias','D','Hardy','54031','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.877412,-78.892481,0,'2013-07-06 12:44:31',NULL,NULL),(59861,'71260','S','Linville','A','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.909183,-92.241002,0,'2013-07-06 12:44:33',NULL,NULL),(57221,'66501','P','Mc Farland','D','Wabaunsee','20197','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.052131,-96.237299,0,'2013-07-06 12:44:33',NULL,NULL),(68539,'81418','S','Eckert','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.852404,-107.967183,0,'2013-07-06 12:44:34',NULL,NULL),(61022,'72116','S','No Little Rock','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(58794,'68980','S','Trumbull','D','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.627431,-98.095825,0,'2013-07-06 12:44:33',NULL,NULL),(4931,'04083','S','Springvale','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.464074,-70.795813,0,'2013-07-06 12:44:30',NULL,NULL),(39430,'44682','P','Tuscarawas','D','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.400835,-81.405712,0,'2013-07-06 12:44:32',NULL,NULL),(18889,'19468','S','Limerick','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.196820,-75.539280,0,'2013-07-06 12:44:31',NULL,NULL),(27489,'30161','S','Rome','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.245490,-85.109805,0,'2013-07-06 12:44:31',NULL,NULL),(64100,'76166','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.783918,-97.347748,0,'2013-07-06 12:44:34',NULL,NULL),(25045,'27910','S','Ahoskie','D','Hertford','37091','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.288186,-76.984827,0,'2013-07-06 12:44:31',NULL,NULL),(17648,'18073','S','Pennsburg','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.392600,-75.482400,0,'2013-07-06 12:44:31',NULL,NULL),(59867,'71263','S','Concord','N','West Carroll','22123','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.840160,-91.467780,0,'2013-07-06 12:44:33',NULL,NULL),(59435,'70706','S','Denham Springs','D','Livingston','22063','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.606884,-90.920617,0,'2013-07-06 12:44:33',NULL,NULL),(59026,'70081','P','Pilottown','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.179853,-89.256974,0,'2013-07-06 12:44:33',NULL,NULL),(3423,'01731','S','Bedford','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.453933,-71.278811,0,'2013-07-06 12:44:30',NULL,NULL),(56387,'65233','S','Speed','N','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.964646,-92.743139,0,'2013-07-06 12:44:33',NULL,NULL),(55600,'63942','S','Gatewood','D','Ripley','29181','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.560987,-91.074230,0,'2013-07-06 12:44:33',NULL,NULL),(35555,'39564','S','Windsor Park','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(45715,'52068','S','Centralia','N','Dubuque','19061','Iowa','IA','19','2200','563','Central',-6.0,'Y',42.431580,-90.799380,0,'2013-07-06 12:44:32',NULL,NULL),(20745,'21401','S','Cpe St Claire','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.002488,-76.510357,0,'2013-07-06 12:44:31',NULL,NULL),(4189,'02822','S','Escoheag','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.555618,-71.626724,0,'2013-07-06 12:44:30',NULL,NULL),(74474,'92605','P','Huntington Beach','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.715124,-118.007674,0,'2013-07-06 12:44:34',NULL,NULL),(60908,'72076','S','Little Rock AFB','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.874693,-92.122352,0,'2013-07-06 12:44:33',NULL,NULL),(4524,'03307','S','Loudon','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.286511,-71.467441,0,'2013-07-06 12:44:30',NULL,NULL),(8276,'08012','S','Blackwood','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.747480,-75.022320,0,'2013-07-06 12:44:30',NULL,NULL),(11482,'12020','S','Ballston Center','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.005586,-73.860404,0,'2013-07-06 12:44:30',NULL,NULL),(1786,'00783','S','Bo Pueblo','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(68613,'81621','S','Ruedi','N','Eagle','08037','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.375819,-106.992926,0,'2013-07-06 12:44:34',NULL,NULL),(40382,'45658','S','Northup','N','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',38.775857,-82.438825,0,'2013-07-06 12:44:32',NULL,NULL),(43946,'49301','S','Ada','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.955202,-85.471385,0,'2013-07-06 12:44:32',NULL,NULL),(59260,'70448','S','Hootenville','N','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.366783,-90.034817,0,'2013-07-06 12:44:33',NULL,NULL),(36257,'40322','S','Frenchburg','D','Menifee','21165','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.957240,-83.618623,0,'2013-07-06 12:44:32',NULL,NULL),(65161,'77402','P','Bellaire','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.706618,-95.475338,0,'2013-07-06 12:44:34',NULL,NULL),(26169,'28745','S','Lk Junaluska','A','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.524801,-82.972902,0,'2013-07-06 12:44:31',NULL,NULL),(65013,'77303','S','Conroe','D','Montgomery','48339','Texas','TX','48','3360','936','Central',-6.0,'Y',30.360510,-95.414641,0,'2013-07-06 12:44:34',NULL,NULL),(31050,'33830','S','Bartow','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.899601,-81.819661,0,'2013-07-06 12:44:32',NULL,NULL),(70675,'85234','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.359611,-111.750767,0,'2013-07-06 12:44:34',NULL,NULL),(55841,'64161','S','Kansas City','D','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.161625,-94.466674,0,'2013-07-06 12:44:33',NULL,NULL),(52052,'60196','U','Schaumburg','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.071476,-88.049239,0,'2013-07-06 12:44:33',NULL,NULL),(37979,'42729','S','Cub Run','D','Hart','21099','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.295386,-86.063461,0,'2013-07-06 12:44:32',NULL,NULL),(7200,'06480','S','Portland','D','Middlesex','09007','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.581923,-72.618579,0,'2013-07-06 12:44:30',NULL,NULL),(7033,'06268','S','Storrs','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(14543,'15210','S','Mount Oliver','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.404900,-79.972620,0,'2013-07-06 12:44:31',NULL,NULL),(6946,'06180','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.757571,-72.764720,0,'2013-07-06 12:44:30',NULL,NULL),(4799,'03882','S','South Effingham','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715503,-71.004712,0,'2013-07-06 12:44:30',NULL,NULL),(30477,'33348','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.187318,-80.108851,0,'2013-07-06 12:44:32',NULL,NULL),(71004,'85719','S','Sun','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.241787,-110.946837,0,'2013-07-06 12:44:34',NULL,NULL),(14746,'15317','S','Canonsburg','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.269407,-80.150995,0,'2013-07-06 12:44:31',NULL,NULL),(37115,'41386','S','Vincent','D','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450115,-83.803868,0,'2013-07-06 12:44:32',NULL,NULL),(44910,'50328','U','Wells Fargo Mortgage','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582091,-93.637951,0,'2013-07-06 12:44:32',NULL,NULL),(41717,'47240','S','Kingston','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(2092,'00922','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409982,-66.092553,0,'2013-07-06 12:44:30',NULL,NULL),(41790,'47325','S','Brownsville','D','Union','18161','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.717506,-84.963353,0,'2013-07-06 12:44:32',NULL,NULL),(75161,'93586','P','Quartz Hill','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.648854,-118.219319,0,'2013-07-06 12:44:34',NULL,NULL),(11314,'11780','S','Saint James','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.891440,-73.169280,0,'2013-07-06 12:44:30',NULL,NULL),(69999,'84123','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.659098,-111.923072,0,'2013-07-06 12:44:34',NULL,NULL),(57285,'66608','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.074827,-95.666827,0,'2013-07-06 12:44:33',NULL,NULL),(40618,'46011','S','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.131179,-85.761842,0,'2013-07-06 12:44:32',NULL,NULL),(29562,'32812','S','Belle Isle','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.488781,-81.324101,0,'2013-07-06 12:44:32',NULL,NULL),(69951,'84117','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.665128,-111.835513,0,'2013-07-06 12:44:34',NULL,NULL),(16299,'17109','S','Lower Paxton','A','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.301280,-76.799940,0,'2013-07-06 12:44:31',NULL,NULL),(2114,'00923','S','VISTA del Cano','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(44661,'50108','S','Westerville','N','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.809211,-93.958622,0,'2013-07-06 12:44:32',NULL,NULL),(75970,'95060','S','Bonny Doon','A','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.989018,-122.057824,0,'2013-07-06 12:44:34',NULL,NULL),(26788,'29453','S','Shulerville','A','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.197783,-79.691205,0,'2013-07-06 12:44:31',NULL,NULL),(20925,'21746','U','Hagerstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.564137,-77.718312,0,'2013-07-06 12:44:31',NULL,NULL),(31960,'35210','S','Ruffner','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(39292,'44491','S','W Farmington','A','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.368536,-80.963139,0,'2013-07-06 12:44:32',NULL,NULL),(77532,'96849','U','Bancorp','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333358,-157.916104,0,'2013-07-06 12:44:34',NULL,NULL),(67432,'80163','P','Littleton','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.545881,-104.974412,0,'2013-07-06 12:44:34',NULL,NULL),(5987,'05350','S','Readsboro','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.829722,-72.988056,0,'2013-07-06 12:44:30',NULL,NULL),(56678,'65636','P','Diggins','D','Webster','29225','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.172542,-92.853143,0,'2013-07-06 12:44:33',NULL,NULL),(74686,'92881','S','Corona','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.843208,-117.513113,0,'2013-07-06 12:44:34',NULL,NULL),(41422,'46835','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.138225,-85.061298,0,'2013-07-06 12:44:32',NULL,NULL),(35037,'39169','S','Beelake','N','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.179923,-90.223094,0,'2013-07-06 12:44:32',NULL,NULL),(78679,'98244','S','Kendall','N','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.824220,-121.958340,0,'2013-07-06 12:44:34',NULL,NULL),(1539,'00757','S','Hacienda Concordia','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(27029,'29651','S','Greer','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.968571,-82.255432,0,'2013-07-06 12:44:31',NULL,NULL),(59462,'70736','S','Glynn','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.639270,-91.337346,0,'2013-07-06 12:44:33',NULL,NULL),(4889,'04046','S','Kennebunkport','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.393701,-70.452320,0,'2013-07-06 12:44:30',NULL,NULL),(8170,'07869','S','Randolph','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.844283,-74.574152,0,'2013-07-06 12:44:30',NULL,NULL),(78096,'97487','S','Vaughn','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.046249,-123.349478,0,'2013-07-06 12:44:34',NULL,NULL),(36039,'40203','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.247961,-85.764632,0,'2013-07-06 12:44:32',NULL,NULL),(56274,'65067','S','Portland','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.797987,-91.700471,0,'2013-07-06 12:44:33',NULL,NULL),(41862,'47355','S','Lynn','D','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(5240,'04471','S','Orient','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.890612,-67.847255,0,'2013-07-06 12:44:30',NULL,NULL),(15047,'15713','S','Aultman','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.567920,-79.264547,0,'2013-07-06 12:44:31',NULL,NULL),(37277,'41603','S','Banner','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.579884,-82.700311,0,'2013-07-06 12:44:32',NULL,NULL),(38369,'43464','S','Vickery','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.388217,-82.942973,0,'2013-07-06 12:44:32',NULL,NULL),(45777,'52157','S','Mc Gregor','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.021470,-91.179382,0,'2013-07-06 12:44:32',NULL,NULL),(50050,'57437','S','Eureka','D','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.802620,-99.618600,0,'2013-07-06 12:44:33',NULL,NULL),(78938,'98366','S','Waterman','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(66320,'78596','S','Progreso Lks','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.160167,-97.986360,0,'2013-07-06 12:44:34',NULL,NULL),(21644,'22932','S','Crozet','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.066684,-78.702915,0,'2013-07-06 12:44:31',NULL,NULL),(49590,'56742','S','Oklee','D','Red Lake','27125','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.835019,-95.852182,0,'2013-07-06 12:44:33',NULL,NULL),(66427,'78641','S','Leander','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.527880,-97.880340,0,'2013-07-06 12:44:34',NULL,NULL),(23182,'25043','S','Clay','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.455543,-81.045457,0,'2013-07-06 12:44:31',NULL,NULL),(62337,'74053','S','Oologah','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.444855,-95.708823,0,'2013-07-06 12:44:33',NULL,NULL),(34860,'38928','S','Whitehead','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.946772,-90.174703,0,'2013-07-06 12:44:32',NULL,NULL),(54946,'63115','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.673685,-90.238923,0,'2013-07-06 12:44:33',NULL,NULL),(52442,'60664','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.873171,-87.654296,0,'2013-07-06 12:44:33',NULL,NULL),(47190,'54486','S','Hunting','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.743866,-89.041687,0,'2013-07-06 12:44:32',NULL,NULL),(31197,'33944','P','Palmdale','D','Glades','12043','Florida','FL','12','0000','863','Eastern',-5.0,'Y',26.943751,-81.315508,0,'2013-07-06 12:44:32',NULL,NULL),(56391,'65237','S','Bunceton','D','Cooper','29053','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.787039,-92.799726,0,'2013-07-06 12:44:33',NULL,NULL),(24070,'26436','P','Smithburg','D','Doddridge','54017','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.241547,-80.809776,0,'2013-07-06 12:44:31',NULL,NULL),(22517,'24088','S','Charity','A','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.928893,-80.016884,0,'2013-07-06 12:44:31',NULL,NULL),(40343,'45618','P','Cherry Fork','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.853058,-83.585381,0,'2013-07-06 12:44:32',NULL,NULL),(19863,'20523','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896710,-77.047010,0,'2013-07-06 12:44:31',NULL,NULL),(48959,'56180','S','Walnut Grove','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.239402,-95.510201,0,'2013-07-06 12:44:33',NULL,NULL),(3075,'01139','P','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.116316,-72.546932,0,'2013-07-06 12:44:30',NULL,NULL),(29189,'32402','P','Panama City','D','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.190549,-85.673480,0,'2013-07-06 12:44:32',NULL,NULL),(17928,'18469','S','Tyler Hill','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.667122,-75.152624,0,'2013-07-06 12:44:31',NULL,NULL),(71781,'87557','S','Talpa','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(64158,'76208','S','Corinth','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.194850,-97.056584,0,'2013-07-06 12:44:34',NULL,NULL),(58865,'69151','S','Maxwell','D','Lincoln','31111','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.081286,-100.523552,0,'2013-07-06 12:44:33',NULL,NULL),(39462,'44708','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.812034,-81.424133,0,'2013-07-06 12:44:32',NULL,NULL),(72907,'90023','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.025925,-118.200657,0,'2013-07-06 12:44:34',NULL,NULL),(76344,'95472','S','Freestone','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.401860,-122.851680,0,'2013-07-06 12:44:34',NULL,NULL),(20721,'21282','P','Pikesville','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.387100,-76.722830,0,'2013-07-06 12:44:31',NULL,NULL),(20167,'20743','S','Fairmount Heights','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.885663,-76.901034,0,'2013-07-06 12:44:31',NULL,NULL),(16920,'17603','S','Leaf Park','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.045868,-76.354179,0,'2013-07-06 12:44:31',NULL,NULL),(13449,'13777','S','Glen Aubrey','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.239707,-76.010116,0,'2013-07-06 12:44:31',NULL,NULL),(64455,'76570','S','Zipperlenville','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.073808,-96.972971,0,'2013-07-06 12:44:34',NULL,NULL),(38533,'43736','P','Quaker City','A','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.994015,-81.285558,0,'2013-07-06 12:44:32',NULL,NULL),(50360,'57748','S','Red Scaffold','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.541189,-102.211846,0,'2013-07-06 12:44:33',NULL,NULL),(69610,'83858','S','Rathdrum','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.840040,-116.903100,0,'2013-07-06 12:44:34',NULL,NULL),(38226,'43226','P','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.978571,-83.163374,0,'2013-07-06 12:44:32',NULL,NULL),(53150,'61558','U','Pekin Ins Co','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.567474,-89.638253,0,'2013-07-06 12:44:33',NULL,NULL),(42880,'48091','S','Warren','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.466705,-83.055818,0,'2013-07-06 12:44:32',NULL,NULL),(57308,'66629','U','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.048063,-95.682616,0,'2013-07-06 12:44:33',NULL,NULL),(54120,'62550','S','Radford','A','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.624412,-89.016482,0,'2013-07-06 12:44:33',NULL,NULL),(49606,'56760','S','Viking','D','Marshall','27089','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.241794,-96.498626,0,'2013-07-06 12:44:33',NULL,NULL),(43207,'48306','S','Oakland','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.724767,-83.149761,0,'2013-07-06 12:44:32',NULL,NULL),(67232,'79929','P','Socorro','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.691648,-106.159445,0,'2013-07-06 12:44:34',NULL,NULL),(26347,'29067','S','Kershaw','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.498309,-80.520734,0,'2013-07-06 12:44:31',NULL,NULL),(61748,'73042','S','Gracemont','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.187323,-98.258540,0,'2013-07-06 12:44:33',NULL,NULL),(57199,'66426','P','Westmoreland','A','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.427312,-96.491448,0,'2013-07-06 12:44:33',NULL,NULL),(23466,'25438','S','Ranson','D','Jefferson','54037','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.301798,-77.859006,0,'2013-07-06 12:44:31',NULL,NULL),(41404,'46809','S','Waynedale','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.026644,-85.189643,0,'2013-07-06 12:44:32',NULL,NULL),(18312,'19020','S','Bensalem','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.102797,-74.929344,0,'2013-07-06 12:44:31',NULL,NULL),(24097,'26507','P','Cheat Lake','N','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.614238,-79.915841,0,'2013-07-06 12:44:31',NULL,NULL),(32129,'35446','S','Buhl','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.272100,-87.734160,0,'2013-07-06 12:44:32',NULL,NULL),(57952,'67751','S','Park','D','Gove','20063','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.063984,-100.233233,0,'2013-07-06 12:44:33',NULL,NULL),(70301,'84539','P','Sunnyside','D','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.549386,-110.388166,0,'2013-07-06 12:44:34',NULL,NULL),(8119,'07825','S','Hardwick','A','Warren','34041','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.982604,-74.950757,0,'2013-07-06 12:44:30',NULL,NULL),(7298,'06540','U','Conn Bank & Trust Co','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.310015,-72.921458,0,'2013-07-06 12:44:30',NULL,NULL),(36061,'40207','S','Norbourne Estates','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.262780,-85.660980,0,'2013-07-06 12:44:32',NULL,NULL),(3334,'01537','S','North Oxford','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.167512,-71.888900,0,'2013-07-06 12:44:30',NULL,NULL),(30814,'33617','S','Temple Terr','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.036676,-82.396230,0,'2013-07-06 12:44:32',NULL,NULL),(45151,'50586','S','Somers','D','Calhoun','19025','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.377536,-94.429628,0,'2013-07-06 12:44:32',NULL,NULL),(9378,'09836','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(4896,'04051','S','Lovell','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.192343,-70.951093,0,'2013-07-06 12:44:30',NULL,NULL),(12541,'13039','S','Clay','A','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.172160,-76.071720,0,'2013-07-06 12:44:30',NULL,NULL),(50476,'58045','S','Kelso','A','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.400171,-97.060426,0,'2013-07-06 12:44:33',NULL,NULL),(65486,'77650','P','Crystal Beach','A','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.449643,-94.635997,0,'2013-07-06 12:44:34',NULL,NULL),(36317,'40380','S','Bowen','A','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.851590,-83.854413,0,'2013-07-06 12:44:32',NULL,NULL),(76568,'95670','S','Rncho Cordova','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.603520,-121.248060,0,'2013-07-06 12:44:34',NULL,NULL),(78045,'97442','S','Glendale','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.754694,-123.382926,0,'2013-07-06 12:44:34',NULL,NULL),(72780,'89599','U','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.530106,-119.813810,0,'2013-07-06 12:44:34',NULL,NULL),(27570,'30268','S','Palmetto','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.533450,-84.690866,0,'2013-07-06 12:44:31',NULL,NULL),(24900,'27711','U','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916201,-78.867468,0,'2013-07-06 12:44:31',NULL,NULL),(58459,'68728','S','Concord','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.374325,-96.965134,0,'2013-07-06 12:44:33',NULL,NULL),(47201,'54489','S','Hansen','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.461390,-89.993344,0,'2013-07-06 12:44:32',NULL,NULL),(42338,'47635','S','Rockport','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.895520,-87.060780,0,'2013-07-06 12:44:32',NULL,NULL),(37068,'41311','S','Yellow Rock','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(76963,'96047','S','Ono','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.458121,-122.588612,0,'2013-07-06 12:44:34',NULL,NULL),(78408,'98038','S','Maple Valley','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.398201,-122.032234,0,'2013-07-06 12:44:34',NULL,NULL),(46470,'53217','S','Glendale','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.150112,-87.911181,0,'2013-07-06 12:44:32',NULL,NULL),(14676,'15241','S','Uppr St Clair','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.357620,-80.059980,0,'2013-07-06 12:44:31',NULL,NULL),(39726,'45056','S','Reily','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.494309,-84.744070,0,'2013-07-06 12:44:32',NULL,NULL),(7283,'06532','P','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.319206,-72.926573,0,'2013-07-06 12:44:30',NULL,NULL),(42384,'47722','U','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974242,-87.535628,0,'2013-07-06 12:44:32',NULL,NULL),(27034,'29656','P','La France','D','Anderson','45007','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.612072,-82.761338,0,'2013-07-06 12:44:31',NULL,NULL),(22818,'24487','S','Williamsville','D','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.177778,-79.647778,0,'2013-07-06 12:44:31',NULL,NULL),(5162,'04426','S','Dovr Foxcroft','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.184450,-69.227020,0,'2013-07-06 12:44:30',NULL,NULL),(55238,'63441','S','Frankford','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.490026,-91.278196,0,'2013-07-06 12:44:33',NULL,NULL),(71522,'87120','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.141221,-106.704928,0,'2013-07-06 12:44:34',NULL,NULL),(25089,'27954','S','Fort Raleigh City','N','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.915917,-75.677254,0,'2013-07-06 12:44:31',NULL,NULL),(10105,'10256','U','Deutsche Bank','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706232,-74.010903,0,'2013-07-06 12:44:30',NULL,NULL),(61053,'72120','S','North Little Rock','A','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.892804,-92.231859,0,'2013-07-06 12:44:33',NULL,NULL),(51662,'59911','S','Swan Lake','A','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.881860,-113.965080,0,'2013-07-06 12:44:33',NULL,NULL),(67692,'80517','S','Rocky Mountain National Park','N','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.365932,-105.515995,0,'2013-07-06 12:44:34',NULL,NULL),(66611,'78766','P','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.352149,-97.729720,0,'2013-07-06 12:44:34',NULL,NULL),(46155,'52721','S','Bennett','D','Cedar','19031','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.743424,-90.971603,0,'2013-07-06 12:44:32',NULL,NULL),(30257,'33231','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.773930,-80.194434,0,'2013-07-06 12:44:32',NULL,NULL),(34345,'38579','S','Quebeck','D','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.834444,-85.548236,0,'2013-07-06 12:44:32',NULL,NULL),(57520,'66970','S','Webber','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.914805,-97.986799,0,'2013-07-06 12:44:33',NULL,NULL),(57422,'66777','S','Toronto','D','Woodson','20207','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.800799,-95.947736,0,'2013-07-06 12:44:33',NULL,NULL),(35270,'39362','S','Stateline','N','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.436443,-88.468270,0,'2013-07-06 12:44:32',NULL,NULL),(62190,'73766','S','Pond Creek','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.667062,-97.798587,0,'2013-07-06 12:44:33',NULL,NULL),(45341,'50936','U','HP-Proactive','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.582040,-93.638893,0,'2013-07-06 12:44:32',NULL,NULL),(42920,'48111','S','Belleville','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.174217,-83.489647,0,'2013-07-06 12:44:32',NULL,NULL),(13289,'13662','S','Massena','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.918160,-74.935980,0,'2013-07-06 12:44:30',NULL,NULL),(63078,'75244','S','Farmers Branch','A','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.939490,-96.838730,0,'2013-07-06 12:44:33',NULL,NULL),(46700,'53789','U','Wi Dept Ind Labor Human Rel','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.077115,-89.384153,0,'2013-07-06 12:44:32',NULL,NULL),(36009,'40153','P','Mc Quady','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.707933,-86.521171,0,'2013-07-06 12:44:32',NULL,NULL),(71150,'86033','P','Baby Rock','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.630720,-110.277720,0,'2013-07-06 12:44:34',NULL,NULL),(67274,'79997','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766474,-106.425750,0,'2013-07-06 12:44:34',NULL,NULL),(62016,'73449','S','Mead','D','Bryan','40013','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.943247,-96.404271,0,'2013-07-06 12:44:33',NULL,NULL),(48249,'55424','S','Saint Louis Park','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.902538,-93.339411,0,'2013-07-06 12:44:33',NULL,NULL),(13939,'14435','S','Conesus','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.724523,-77.677278,0,'2013-07-06 12:44:31',NULL,NULL),(36594,'40962','S','Urban','A','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.152002,-83.764393,0,'2013-07-06 12:44:32',NULL,NULL),(77095,'96137','S','Westwood','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.349400,-121.071420,0,'2013-07-06 12:44:34',NULL,NULL),(18942,'19508','S','Baumstown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(74573,'92690','P','Mission Viejo','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.611708,-117.642970,0,'2013-07-06 12:44:34',NULL,NULL),(69680,'84023','S','Red Canyon','A','Daggett','49009','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.932867,-109.392096,0,'2013-07-06 12:44:34',NULL,NULL),(33067,'36767','S','Orrville','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.319938,-87.100160,0,'2013-07-06 12:44:32',NULL,NULL),(54898,'63074','S','Nw Plaza','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.727416,-90.387327,0,'2013-07-06 12:44:33',NULL,NULL),(54512,'62871','S','Asbury','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.886303,-88.267731,0,'2013-07-06 12:44:33',NULL,NULL),(9397,'09866','M','FPO','A','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33786,'37877','S','Talbott','D','Hamblen','47063','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.174831,-83.418381,0,'2013-07-06 12:44:32',NULL,NULL),(33104,'36854','S','Langdale','N','Chambers','01017','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.810093,-85.181624,0,'2013-07-06 12:44:32',NULL,NULL),(908,'00705','S','Urb Golden Vlg Iv','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(27459,'30133','P','Douglasville','D','Douglas','13097','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.735023,-84.702085,0,'2013-07-06 12:44:31',NULL,NULL),(63211,'75447','S','Ivanhoe','D','Fannin','48147','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.678755,-96.172238,0,'2013-07-06 12:44:33',NULL,NULL),(14656,'15237','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.549733,-80.039957,0,'2013-07-06 12:44:31',NULL,NULL),(14089,'14617','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.206420,-77.635320,0,'2013-07-06 12:44:31',NULL,NULL),(52315,'60553','S','Scarboro','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.812414,-89.021117,0,'2013-07-06 12:44:33',NULL,NULL),(42316,'47615','S','Grandview','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.974900,-86.947020,0,'2013-07-06 12:44:32',NULL,NULL),(66885,'79237','S','Hedley','D','Donley','48129','Texas','TX','48','0000','806','Central',-6.0,'Y',34.861710,-100.678751,0,'2013-07-06 12:44:34',NULL,NULL),(45984,'52497','U','Nordstrom','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.005872,-91.641725,0,'2013-07-06 12:44:32',NULL,NULL),(3388,'01607','S','Worcester','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.227250,-71.793758,0,'2013-07-06 12:44:30',NULL,NULL),(3699,'02137','P','Readville','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.235076,-71.134469,0,'2013-07-06 12:44:30',NULL,NULL),(72680,'89444','S','Sweetwater','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.842200,-119.367900,0,'2013-07-06 12:44:34',NULL,NULL),(69378,'83605','S','Weitz','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(27892,'30467','S','Hiltonia','A','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.748470,-81.638522,0,'2013-07-06 12:44:31',NULL,NULL),(59417,'70653','S','Merryville','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.709468,-93.552030,0,'2013-07-06 12:44:33',NULL,NULL),(47765,'55036','S','Grasston','A','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.839035,-92.958857,0,'2013-07-06 12:44:33',NULL,NULL),(72055,'88112','S','Bellview','A','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.821111,-103.107222,0,'2013-07-06 12:44:34',NULL,NULL),(32843,'36482','S','Suggsville','N','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.651737,-87.627073,0,'2013-07-06 12:44:32',NULL,NULL),(72916,'90026','S','Edendale','N','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.079313,-118.262692,0,'2013-07-06 12:44:34',NULL,NULL),(10066,'10178','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(53977,'62439','S','Billet','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(44828,'50250','S','Stuart','D','Guthrie','19077','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.502010,-94.316481,0,'2013-07-06 12:44:32',NULL,NULL),(73545,'91356','S','Tarzana','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.162999,-118.549334,0,'2013-07-06 12:44:34',NULL,NULL),(30844,'33634','S','Time Cs Brm Unique','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.008709,-82.553744,0,'2013-07-06 12:44:32',NULL,NULL),(34786,'38868','S','Old Union','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.120111,-88.714124,0,'2013-07-06 12:44:32',NULL,NULL),(53246,'61701','S','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(43651,'48844','P','Howell','D','Livingston','26093','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.606977,-83.931981,0,'2013-07-06 12:44:32',NULL,NULL),(76289,'95431','P','Eldridge','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.329558,-122.525306,0,'2013-07-06 12:44:34',NULL,NULL),(16677,'17362','S','Sinsheim','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.874292,-76.864491,0,'2013-07-06 12:44:31',NULL,NULL),(2612,'00961','S','Villa Espana','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(4151,'02764','S','N Dighton','A','Bristol','25005','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.856622,-71.148635,0,'2013-07-06 12:44:30',NULL,NULL),(65647,'77973','P','Mc Faddin','N','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.720049,-97.048372,0,'2013-07-06 12:44:34',NULL,NULL),(60743,'71968','S','Bear','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.523895,-93.299582,0,'2013-07-06 12:44:33',NULL,NULL),(27347,'30049','P','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.950240,-83.984410,0,'2013-07-06 12:44:31',NULL,NULL),(71778,'87557','S','Ranchos de Taos','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(38094,'43081','S','Westerville','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.110098,-82.907426,0,'2013-07-06 12:44:32',NULL,NULL),(7746,'07305','S','Jersey City','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.693860,-74.078820,0,'2013-07-06 12:44:30',NULL,NULL),(16336,'17127','U','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263282,-76.876977,0,'2013-07-06 12:44:31',NULL,NULL),(25112,'27979','S','Sunbury','D','Gates','37073','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.417311,-76.565101,0,'2013-07-06 12:44:31',NULL,NULL),(62445,'74186','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.152163,-95.995000,0,'2013-07-06 12:44:33',NULL,NULL),(62081,'73560','S','Olustee','D','Jackson','40065','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.547089,-99.423379,0,'2013-07-06 12:44:33',NULL,NULL),(39893,'45214','S','Fairmount','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.120751,-84.543703,0,'2013-07-06 12:44:32',NULL,NULL),(23344,'25252','S','Liverpool','A','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.957697,-81.571231,0,'2013-07-06 12:44:31',NULL,NULL),(15990,'17035','S','Honey Grove','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.434041,-77.587129,0,'2013-07-06 12:44:31',NULL,NULL),(22499,'24073','S','Cambria','N','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.136439,-80.404000,0,'2013-07-06 12:44:31',NULL,NULL),(3165,'01266','S','West Stockbridge Center','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.333061,-73.380396,0,'2013-07-06 12:44:30',NULL,NULL),(38943,'44124','S','Mayfield Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(10746,'11359','S','Bayside','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.789436,-73.777382,0,'2013-07-06 12:44:30',NULL,NULL),(77978,'97385','S','Sublimity','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.861115,-122.762241,0,'2013-07-06 12:44:34',NULL,NULL),(78773,'98311','S','Bremerton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.625445,-122.638533,0,'2013-07-06 12:44:34',NULL,NULL),(4924,'04078','P','S Freeport','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.821360,-70.111614,0,'2013-07-06 12:44:30',NULL,NULL),(59199,'70375','S','Mathews','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.688017,-90.554771,0,'2013-07-06 12:44:33',NULL,NULL),(66670,'78883','S','Tarpley','D','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.645218,-99.224408,0,'2013-07-06 12:44:34',NULL,NULL),(65710,'78015','S','Fair Oaks Ranch','A','Kendall','48259','Texas','TX','48','7240','210','Central',-6.0,'Y',29.801349,-98.741246,0,'2013-07-06 12:44:34',NULL,NULL),(46194,'52749','S','Fruitland','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.356809,-91.123980,0,'2013-07-06 12:44:32',NULL,NULL),(34834,'38920','S','Paul','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.896850,-90.036929,0,'2013-07-06 12:44:32',NULL,NULL),(40564,'45862','S','Mendon','D','Mercer','39107','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.671884,-84.523424,0,'2013-07-06 12:44:32',NULL,NULL),(29111,'32308','S','Centerville','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.503754,-84.212359,0,'2013-07-06 12:44:32',NULL,NULL),(23979,'26306','U','FBI','N','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281890,-80.332998,0,'2013-07-06 12:44:31',NULL,NULL),(11097,'11695','P','Far Rockaway','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.558349,-73.911454,0,'2013-07-06 12:44:30',NULL,NULL),(36976,'41179','S','Trace','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(38783,'44055','S','Sheffield','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.434380,-82.137420,0,'2013-07-06 12:44:32',NULL,NULL),(73770,'91737','S','Rancho Cucamonga','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.146529,-117.573112,0,'2013-07-06 12:44:34',NULL,NULL),(29816,'33026','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.028424,-80.296813,0,'2013-07-06 12:44:32',NULL,NULL),(27731,'30350','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975825,-84.325274,0,'2013-07-06 12:44:31',NULL,NULL),(27716,'30343','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.753835,-84.392167,0,'2013-07-06 12:44:31',NULL,NULL),(3706,'02140','S','North Cambridge','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.392350,-71.131259,0,'2013-07-06 12:44:30',NULL,NULL),(43007,'48161','S','Raisinville Twp','A','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.909061,-83.470098,0,'2013-07-06 12:44:32',NULL,NULL),(10140,'10270','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703355,-74.007485,0,'2013-07-06 12:44:30',NULL,NULL),(642,'00682','S','Urb Mayaguez Terrace','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203830,-67.143514,0,'2013-07-06 12:44:30',NULL,NULL),(17179,'17815','S','Lime Ridge','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.007884,-76.445829,0,'2013-07-06 12:44:31',NULL,NULL),(31832,'35074','P','Green Pond','D','Bibb','01007','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.223262,-87.124392,0,'2013-07-06 12:44:32',NULL,NULL),(4578,'03576','S','Colebrook','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.892390,-71.498526,0,'2013-07-06 12:44:30',NULL,NULL),(71164,'86039','P','Kykotsmovi','A','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.652776,-110.494156,0,'2013-07-06 12:44:34',NULL,NULL),(27653,'30322','U','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.791247,-84.324900,0,'2013-07-06 12:44:31',NULL,NULL),(25553,'28410','U','Bedford Fair Industries','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.125636,-77.953828,0,'2013-07-06 12:44:31',NULL,NULL),(40042,'45253','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.269123,-84.599293,0,'2013-07-06 12:44:32',NULL,NULL),(63384,'75644','S','Mings Chapel','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(67750,'80615','S','Eaton','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.524123,-104.687892,0,'2013-07-06 12:44:34',NULL,NULL),(71902,'87750','S','Watrous','A','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.810499,-104.924862,0,'2013-07-06 12:44:34',NULL,NULL),(43551,'48710','U','Bay City','A','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.561826,-83.987515,0,'2013-07-06 12:44:32',NULL,NULL),(66417,'78635','S','Hye','D','Blanco','48031','Texas','TX','48','0000','830','Central',-6.0,'Y',30.221566,-98.532558,0,'2013-07-06 12:44:34',NULL,NULL),(13929,'14425','S','Canandaigua','A','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.958380,-77.310240,0,'2013-07-06 12:44:31',NULL,NULL),(31818,'35060','P','Docena','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.559893,-86.929588,0,'2013-07-06 12:44:32',NULL,NULL),(57289,'66612','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.039267,-95.677633,0,'2013-07-06 12:44:33',NULL,NULL),(29535,'32791','P','Wekiva Springs','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.703312,-81.419952,0,'2013-07-06 12:44:32',NULL,NULL),(74203,'92285','S','Yucca Valley','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.313640,-116.448000,0,'2013-07-06 12:44:34',NULL,NULL),(38468,'43617','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.664110,-83.717316,0,'2013-07-06 12:44:32',NULL,NULL),(65166,'77410','P','Cypress','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.972663,-95.696811,0,'2013-07-06 12:44:34',NULL,NULL),(67724,'80542','S','Mead','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.239028,-104.998324,0,'2013-07-06 12:44:34',NULL,NULL),(29854,'33036','S','Venetian Shores','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(64981,'77269','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.978817,-95.568207,0,'2013-07-06 12:44:34',NULL,NULL),(40082,'45301','P','Alpha','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.708108,-84.020217,0,'2013-07-06 12:44:32',NULL,NULL),(50210,'57577','S','Wanblee','D','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.551517,-101.805742,0,'2013-07-06 12:44:33',NULL,NULL),(58572,'68828','S','Comstock','D','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.536564,-99.308281,0,'2013-07-06 12:44:33',NULL,NULL),(59929,'71292','S','Brownsville','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(18969,'19518','S','Earlville','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(74804,'93205','S','Bodfish','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.580528,-118.482763,0,'2013-07-06 12:44:34',NULL,NULL),(7932,'07650','S','Palisades Park','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.848970,-73.998019,0,'2013-07-06 12:44:30',NULL,NULL),(50051,'57437','S','Greenway','N','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.802620,-99.618600,0,'2013-07-06 12:44:33',NULL,NULL),(47863,'55080','S','Stanchfield','D','Isanti','27059','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.663805,-93.233436,0,'2013-07-06 12:44:33',NULL,NULL),(30508,'33403','S','Palm Beach Gardens','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(11885,'12309','S','Niskayuna','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.795780,-73.867440,0,'2013-07-06 12:44:30',NULL,NULL),(39010,'44140','S','Bay Village','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.489820,-81.921480,0,'2013-07-06 12:44:32',NULL,NULL),(3596,'02035','S','Foxboro','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.062193,-71.243476,0,'2013-07-06 12:44:30',NULL,NULL),(65882,'78226','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.396389,-98.546677,0,'2013-07-06 12:44:34',NULL,NULL),(35282,'39401','S','Camp Shelby','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(78106,'97494','P','Wilbur','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.317756,-123.342676,0,'2013-07-06 12:44:34',NULL,NULL),(58408,'68638','S','Fullerton','D','Nance','31125','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.361320,-97.974859,0,'2013-07-06 12:44:33',NULL,NULL),(57783,'67473','S','Osborne','D','Osborne','20141','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.443497,-98.699927,0,'2013-07-06 12:44:33',NULL,NULL),(53819,'62298','S','Madonnaville','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(48216,'55414','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.978546,-93.226011,0,'2013-07-06 12:44:33',NULL,NULL),(14288,'14869','S','Odessa','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.350105,-76.776852,0,'2013-07-06 12:44:31',NULL,NULL),(13269,'13650','S','Woodville','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.849649,-76.228306,0,'2013-07-06 12:44:30',NULL,NULL),(35764,'39740','S','Kolola Springs','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.688435,-88.329881,0,'2013-07-06 12:44:32',NULL,NULL),(73746,'91715','P','City of Industry','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.015728,-117.969965,0,'2013-07-06 12:44:34',NULL,NULL),(18637,'19160','P','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.011141,-75.147333,0,'2013-07-06 12:44:31',NULL,NULL),(27926,'30518','S','Buford','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.124264,-84.031055,0,'2013-07-06 12:44:31',NULL,NULL),(26597,'29228','P','Columbia','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.920816,-81.090297,0,'2013-07-06 12:44:31',NULL,NULL),(24236,'26753','S','Patterson Crk','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.600960,-78.784140,0,'2013-07-06 12:44:31',NULL,NULL),(38945,'44124','S','Pepper Pike','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(62731,'74821','P','Ada','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.777081,-96.679427,0,'2013-07-06 12:44:33',NULL,NULL),(23871,'26155','S','New Martinsville','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.659451,-80.861572,0,'2013-07-06 12:44:31',NULL,NULL),(65109,'77371','S','Shepherd','D','San Jacinto','48407','Texas','TX','48','0000','936','Central',-6.0,'Y',30.479972,-94.991246,0,'2013-07-06 12:44:34',NULL,NULL),(31098,'33880','S','Wahneta','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.996505,-81.752285,0,'2013-07-06 12:44:32',NULL,NULL),(30126,'33162','S','North Miami','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(11306,'11779','S','Lake Ronkonkoma Heights','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.818120,-73.120800,0,'2013-07-06 12:44:30',NULL,NULL),(21263,'22306','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.760953,-77.095861,0,'2013-07-06 12:44:31',NULL,NULL),(70242,'84405','S','Washington Tr','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(50150,'57541','S','Ideal','D','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.587976,-99.964462,0,'2013-07-06 12:44:33',NULL,NULL),(45725,'52076','S','Strawberry Pt','A','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.704281,-91.512431,0,'2013-07-06 12:44:32',NULL,NULL),(77909,'97307','P','Salem','A','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.006936,-123.019795,0,'2013-07-06 12:44:34',NULL,NULL),(5343,'04605','S','Waltham','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(25964,'28658','S','Olivers Crossroads','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(67078,'79603','S','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.470693,-99.765045,0,'2013-07-06 12:44:34',NULL,NULL),(39752,'45105','P','Bentonville','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.752554,-83.609424,0,'2013-07-06 12:44:32',NULL,NULL),(49017,'56264','S','Minneota','D','Lyon','27083','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.563139,-95.985774,0,'2013-07-06 12:44:33',NULL,NULL),(31556,'34608','S','Brooksville','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.480569,-82.554386,0,'2013-07-06 12:44:32',NULL,NULL),(42972,'48136','P','Garden City','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.325324,-83.343608,0,'2013-07-06 12:44:32',NULL,NULL),(38087,'43074','S','Sunbury','D','Delaware','39041','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.269436,-82.843951,0,'2013-07-06 12:44:32',NULL,NULL),(79892,'99581','P','Emmonak','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.904955,-164.336695,0,'2013-07-06 12:44:34',NULL,NULL),(19784,'20427','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899040,-77.037241,0,'2013-07-06 12:44:31',NULL,NULL),(19368,'20057','U','Georgetown Univ','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905206,-77.075470,0,'2013-07-06 12:44:31',NULL,NULL),(77048,'96112','S','Ft Bidwell','N','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.873979,-120.117673,0,'2013-07-06 12:44:34',NULL,NULL),(5559,'04858','S','S Thomaston','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.040168,-69.146550,0,'2013-07-06 12:44:30',NULL,NULL),(23755,'25958','S','Charmco','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.989769,-80.689842,0,'2013-07-06 12:44:31',NULL,NULL),(17913,'18455','S','Preston Park','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.866964,-75.381978,0,'2013-07-06 12:44:31',NULL,NULL),(34406,'38627','S','Etta','D','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.434041,-89.185271,0,'2013-07-06 12:44:32',NULL,NULL),(9104,'09090','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(15024,'15683','S','Scottdale','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.104074,-79.592703,0,'2013-07-06 12:44:31',NULL,NULL),(25457,'28329','P','Clinton','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.998310,-78.330057,0,'2013-07-06 12:44:31',NULL,NULL),(6829,'06115','P','Main Office','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760560,-72.674050,0,'2013-07-06 12:44:30',NULL,NULL),(75048,'93517','S','Bridgeport','D','Mono','06051','California','CA','06','0000','760','Pacific',-8.0,'Y',38.232590,-119.276186,0,'2013-07-06 12:44:34',NULL,NULL),(9860,'10120','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748958,-73.997849,0,'2013-07-06 12:44:30',NULL,NULL),(5654,'04957','S','Norridgewock','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.672400,-69.856231,0,'2013-07-06 12:44:30',NULL,NULL),(70827,'85390','S','Wickenburg','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.966580,-112.741801,0,'2013-07-06 12:44:34',NULL,NULL),(33385,'37216','S','Jere Baxter','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.214733,-86.724860,0,'2013-07-06 12:44:32',NULL,NULL),(35552,'39564','S','Latimer','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.624670,-88.847890,0,'2013-07-06 12:44:32',NULL,NULL),(63189,'75422','S','Campbell','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.135561,-95.944998,0,'2013-07-06 12:44:33',NULL,NULL),(57129,'66225','P','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.888339,-94.686133,0,'2013-07-06 12:44:33',NULL,NULL),(54734,'62966','S','Murphysboro','D','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(75152,'93562','S','Argus','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.754736,-117.385894,0,'2013-07-06 12:44:34',NULL,NULL),(20277,'20788','P','W Hyattsville','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.964901,-76.966704,0,'2013-07-06 12:44:31',NULL,NULL),(6823,'06114','S','Barry Square','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.741050,-72.669085,0,'2013-07-06 12:44:30',NULL,NULL),(45359,'51002','S','Hanover','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.672649,-95.304541,0,'2013-07-06 12:44:32',NULL,NULL),(48548,'55760','S','Minnewana','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(7494,'06913','U','Shared Zip For Brm','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.050068,-73.538971,0,'2013-07-06 12:44:30',NULL,NULL),(18372,'19046','S','Foxcroft','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(4424,'03233','S','Elkins','D','Merrimack','33013','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.420320,-71.938730,0,'2013-07-06 12:44:30',NULL,NULL),(65762,'78073','S','Von Ormy','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.254866,-98.613495,0,'2013-07-06 12:44:34',NULL,NULL),(32165,'35475','S','North Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.245390,-87.594372,0,'2013-07-06 12:44:32',NULL,NULL),(36045,'40205','S','Strathmoor Manor','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(53638,'62201','S','Fairmont City','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(67617,'80436','P','Dumont','D','Clear Creek','08019','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.790428,-105.642576,0,'2013-07-06 12:44:34',NULL,NULL),(67364,'80112','S','Greenwood Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.575499,-104.861971,0,'2013-07-06 12:44:34',NULL,NULL),(53868,'62340','S','Valley City','N','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.710725,-90.727921,0,'2013-07-06 12:44:33',NULL,NULL),(50795,'58443','S','Juanita','A','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448180,-98.680680,0,'2013-07-06 12:44:33',NULL,NULL),(46851,'54022','S','Kinnickinnic','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.880780,-92.632260,0,'2013-07-06 12:44:32',NULL,NULL),(42259,'47579','S','Xmas Lake Vlg','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.104943,-86.928717,0,'2013-07-06 12:44:32',NULL,NULL),(37100,'41348','S','Hardshell','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480000,-83.320000,0,'2013-07-06 12:44:32',NULL,NULL),(30199,'33180','S','Ojus','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.961901,-80.140608,0,'2013-07-06 12:44:32',NULL,NULL),(79448,'98844','S','Oroville','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.946111,-119.050278,0,'2013-07-06 12:44:34',NULL,NULL),(17690,'18202','S','West Hazleton','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.960185,-75.976455,0,'2013-07-06 12:44:31',NULL,NULL),(28837,'32084','S','St Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.885160,-81.313980,0,'2013-07-06 12:44:32',NULL,NULL),(76277,'95423','S','Sulphur Bank Rancheria','N','Lake','06033','California','CA','06','0000','707','Pacific',-8.0,'Y',39.025340,-122.667855,0,'2013-07-06 12:44:34',NULL,NULL),(64229,'76305','S','Pleasant Valley','A','Wichita','48485','Texas','TX','48','9080','940','Central',-6.0,'Y',33.934579,-98.538803,0,'2013-07-06 12:44:34',NULL,NULL),(2641,'00966','S','Bda San Miguel','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(57153,'66276','U','Jc Penney Co','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.002659,-94.669998,0,'2013-07-06 12:44:33',NULL,NULL),(21251,'22301','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.819280,-77.064236,0,'2013-07-06 12:44:31',NULL,NULL),(15853,'16941','S','North Bingham','A','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.981572,-77.769980,0,'2013-07-06 12:44:31',NULL,NULL),(15502,'16507','S','Perry Square','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.135100,-80.085131,0,'2013-07-06 12:44:31',NULL,NULL),(58750,'68957','S','Lawrence','D','Nuckolls','31129','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.261367,-98.214325,0,'2013-07-06 12:44:33',NULL,NULL),(4585,'03579','S','Wntwrths Lctn','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.775308,-71.175804,0,'2013-07-06 12:44:30',NULL,NULL),(28086,'30735','S','Resaca','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.593674,-84.928381,0,'2013-07-06 12:44:31',NULL,NULL),(18136,'18829','S','Le Raysville','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.845364,-76.179080,0,'2013-07-06 12:44:31',NULL,NULL),(21882,'23173','U','Univ of Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.577785,-77.534555,0,'2013-07-06 12:44:31',NULL,NULL),(45047,'50482','S','Ventura','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.127040,-93.474427,0,'2013-07-06 12:44:32',NULL,NULL),(45360,'51003','S','Alton','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.987828,-96.011384,0,'2013-07-06 12:44:32',NULL,NULL),(79624,'99122','S','Seven Bays','A','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.655779,-118.147962,0,'2013-07-06 12:44:34',NULL,NULL),(71796,'87565','S','San Jose','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.415556,-105.493611,0,'2013-07-06 12:44:34',NULL,NULL),(50974,'58636','S','Twin Buttes','N','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.342310,-102.334132,0,'2013-07-06 12:44:33',NULL,NULL),(56202,'65024','S','Mint Hill','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.664240,-91.769160,0,'2013-07-06 12:44:33',NULL,NULL),(24259,'26814','S','Riverton','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.699442,-79.497969,0,'2013-07-06 12:44:31',NULL,NULL),(46729,'53821','S','Pr du Chien','A','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.047250,-91.135493,0,'2013-07-06 12:44:32',NULL,NULL),(79162,'98509','P','Olympia','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.036241,-122.810690,0,'2013-07-06 12:44:34',NULL,NULL),(65538,'77806','P','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.675908,-96.368282,0,'2013-07-06 12:44:34',NULL,NULL),(20833,'21635','S','Golts','A','Kent','24029','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.335931,-75.867837,0,'2013-07-06 12:44:31',NULL,NULL),(2922,'01010','S','East Brimfield','N','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.115140,-72.201420,0,'2013-07-06 12:44:30',NULL,NULL),(45572,'51528','S','Dow City','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.925696,-95.476441,0,'2013-07-06 12:44:32',NULL,NULL),(16753,'17516','S','Conestoga','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.925500,-76.366080,0,'2013-07-06 12:44:31',NULL,NULL),(28417,'31324','S','Richmond Hill','D','Bryan','13029','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.875724,-81.284127,0,'2013-07-06 12:44:32',NULL,NULL),(17346,'17870','S','Kratzerville','N','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.831680,-76.903620,0,'2013-07-06 12:44:31',NULL,NULL),(65521,'77709','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.174154,-94.197448,0,'2013-07-06 12:44:34',NULL,NULL),(61087,'72132','S','Kearney','N','Jefferson','05069','Arkansas','AR','05','6240','501','Central',-6.0,'Y',34.460182,-92.177190,0,'2013-07-06 12:44:33',NULL,NULL),(3875,'02361','P','Plymouth','D','Plymouth','25023','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',41.923344,-70.655618,0,'2013-07-06 12:44:30',NULL,NULL),(12716,'13152','S','Skaneateles','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.884340,-76.351260,0,'2013-07-06 12:44:30',NULL,NULL),(32795,'36426','S','East Brewton','A','Escambia','01053','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.209444,-87.218333,0,'2013-07-06 12:44:32',NULL,NULL),(63773,'75949','S','Huntington','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.286661,-94.578663,0,'2013-07-06 12:44:34',NULL,NULL),(61123,'72153','S','Eglantine','N','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.579400,-92.291580,0,'2013-07-06 12:44:33',NULL,NULL),(22071,'23347','P','Eastville','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.278564,-75.960252,0,'2013-07-06 12:44:31',NULL,NULL),(42753,'48027','S','Wales','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.981737,-82.660493,0,'2013-07-06 12:44:32',NULL,NULL),(23528,'25572','S','Alkol','A','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.160737,-81.893383,0,'2013-07-06 12:44:31',NULL,NULL),(10516,'10977','S','New Hempstead','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.120211,-74.046736,0,'2013-07-06 12:44:30',NULL,NULL),(40892,'46249','U','Army Finance Ctr','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861999,-86.002044,0,'2013-07-06 12:44:32',NULL,NULL),(52555,'60949','S','Ludlow','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.387738,-88.125579,0,'2013-07-06 12:44:33',NULL,NULL),(16357,'17201','S','Cheesetown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(66302,'78586','S','Los Cuates','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.185620,-97.664640,0,'2013-07-06 12:44:34',NULL,NULL),(62476,'74344','S','Grove City','N','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.589899,-94.772190,0,'2013-07-06 12:44:33',NULL,NULL),(77611,'96944','P','Kosae','N','Federated States of Micro','64003','Federated States of Micronesia','FM','64','0000','691','UTC+11',11.0,'N',5.310246,162.962756,0,'2013-07-06 12:44:34',NULL,NULL),(47610,'54888','S','Trego','D','Washburn','55129','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.988585,-91.893391,0,'2013-07-06 12:44:33',NULL,NULL),(47301,'54552','S','Eisenstein','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.931380,-90.397140,0,'2013-07-06 12:44:32',NULL,NULL),(75535,'94206','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.494822,-121.449573,0,'2013-07-06 12:44:34',NULL,NULL),(1970,'00841','P','Frederiksted','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.715086,-64.883394,0,'2013-07-06 12:44:30',NULL,NULL),(40970,'46323','S','Hessville','N','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.584786,-87.451351,0,'2013-07-06 12:44:32',NULL,NULL),(68864,'82637','S','Glenrock','D','Converse','56009','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.831726,-105.843281,0,'2013-07-06 12:44:34',NULL,NULL),(66390,'78624','S','Luckenback','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(61623,'72827','S','Bluffton','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.895706,-93.595583,0,'2013-07-06 12:44:33',NULL,NULL),(69877,'84098','S','Kimball Junction','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.657510,-111.495033,0,'2013-07-06 12:44:34',NULL,NULL),(46125,'52644','S','Mount Union','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.032332,-91.426886,0,'2013-07-06 12:44:32',NULL,NULL),(39970,'45237','S','Roselawn','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.190923,-84.455964,0,'2013-07-06 12:44:32',NULL,NULL),(31659,'34746','S','Kissimmee','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.258683,-81.459499,0,'2013-07-06 12:44:32',NULL,NULL),(57337,'66717','S','Buffalo','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.689303,-95.723736,0,'2013-07-06 12:44:33',NULL,NULL),(125,'00612','S','Villa Serena','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(28765,'32013','P','Day','D','Lafayette','12067','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.186927,-83.292081,0,'2013-07-06 12:44:32',NULL,NULL),(66146,'78480','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.797353,-97.396512,0,'2013-07-06 12:44:34',NULL,NULL),(8959,'08805','S','Bound Brook','D','Somerset','34035','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.569275,-74.539176,0,'2013-07-06 12:44:30',NULL,NULL),(36651,'41006','S','Peachgrove','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.791002,-84.321560,0,'2013-07-06 12:44:32',NULL,NULL),(56499,'65339','S','Grand Pass','A','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.197280,-93.380280,0,'2013-07-06 12:44:33',NULL,NULL),(47664,'54940','S','Fremont','D','Waupaca','55135','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.211350,-88.827485,0,'2013-07-06 12:44:33',NULL,NULL),(72881,'90012','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.063679,-118.238854,0,'2013-07-06 12:44:34',NULL,NULL),(6151,'05468','S','Milton','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.639211,-73.136914,0,'2013-07-06 12:44:30',NULL,NULL),(17615,'18045','S','Easton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.698000,-75.273420,0,'2013-07-06 12:44:31',NULL,NULL),(48152,'55370','S','Plato','D','McLeod','27085','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.774436,-94.038969,0,'2013-07-06 12:44:33',NULL,NULL),(45968,'52362','S','Wyoming','D','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.062000,-91.004313,0,'2013-07-06 12:44:32',NULL,NULL),(78565,'98158','S','Seatac Airport','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445664,-122.311881,0,'2013-07-06 12:44:34',NULL,NULL),(31780,'35022','S','Bess','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.342582,-86.962361,0,'2013-07-06 12:44:32',NULL,NULL),(7217,'06495','U','International Masters Pub','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.458768,-72.826674,0,'2013-07-06 12:44:30',NULL,NULL),(25486,'28357','S','Lumber Bridge','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.891920,-79.078190,0,'2013-07-06 12:44:31',NULL,NULL),(16030,'17042','S','South Lebanon Twp','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(70064,'84145','P','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.754454,-111.897732,0,'2013-07-06 12:44:34',NULL,NULL),(68436,'81223','S','Texas Creek','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.362980,-105.495600,0,'2013-07-06 12:44:34',NULL,NULL),(14247,'14823','S','Canisteo','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.259750,-77.584644,0,'2013-07-06 12:44:31',NULL,NULL),(61971,'73185','U','Jp Morgan Chase','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.469690,-97.518506,0,'2013-07-06 12:44:33',NULL,NULL),(61937,'73157','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.423290,-97.569614,0,'2013-07-06 12:44:33',NULL,NULL),(17659,'18083','P','Stockertown','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.757945,-75.261381,0,'2013-07-06 12:44:31',NULL,NULL),(13188,'13619','S','Champion','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.980552,-75.620903,0,'2013-07-06 12:44:30',NULL,NULL),(3329,'01535','S','N Brookfield','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.267155,-72.075987,0,'2013-07-06 12:44:30',NULL,NULL),(45513,'51401','S','Maple River','N','Carroll','19027','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.047220,-94.865160,0,'2013-07-06 12:44:32',NULL,NULL),(37773,'42347','S','Narrows','A','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.492020,-86.926080,0,'2013-07-06 12:44:32',NULL,NULL),(14340,'15009','S','Vanport','A','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.702800,-80.355660,0,'2013-07-06 12:44:31',NULL,NULL),(28676,'31794','S','Abraham Baldwin College','A','Tift','13277','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.460118,-83.509086,0,'2013-07-06 12:44:32',NULL,NULL),(26953,'29605','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.799312,-82.391757,0,'2013-07-06 12:44:31',NULL,NULL),(3060,'01115','P','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.104032,-72.591791,0,'2013-07-06 12:44:30',NULL,NULL),(63946,'76084','S','Venus','D','Johnson','48251','Texas','TX','48','2800','214/469/972','Central',-6.0,'Y',32.445612,-97.100962,0,'2013-07-06 12:44:34',NULL,NULL),(21047,'21890','U','Easton Correctional Inst','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.149316,-75.690351,0,'2013-07-06 12:44:31',NULL,NULL),(16957,'17702','S','Nisbet','A','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.228880,-77.013929,0,'2013-07-06 12:44:31',NULL,NULL),(8538,'08201','S','Absecon Heights','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(58957,'70003','S','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.995600,-90.214291,0,'2013-07-06 12:44:33',NULL,NULL),(30275,'33255','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.776930,-80.190934,0,'2013-07-06 12:44:32',NULL,NULL),(32069,'35282','U','Business Reply Mail','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.495620,-86.794338,0,'2013-07-06 12:44:32',NULL,NULL),(78778,'98312','S','Chico','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(1347,'00736','S','Est De Las Brumas','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(76024,'95135','S','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.297932,-121.756973,0,'2013-07-06 12:44:34',NULL,NULL),(60498,'71665','S','Dialion','N','Cleveland','05025','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.008660,-92.141100,0,'2013-07-06 12:44:33',NULL,NULL),(50453,'58021','S','Davenport','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.715969,-97.069115,0,'2013-07-06 12:44:33',NULL,NULL),(43917,'49261','P','Napoleon','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.246000,-84.404617,0,'2013-07-06 12:44:32',NULL,NULL),(42387,'47725','S','Darmstadt','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974596,-87.555538,0,'2013-07-06 12:44:32',NULL,NULL),(47567,'54841','S','Haugen','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.611851,-91.781700,0,'2013-07-06 12:44:33',NULL,NULL),(41168,'46704','P','Arcola','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.104668,-85.291919,0,'2013-07-06 12:44:32',NULL,NULL),(34964,'39073','S','Florence','D','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.148436,-90.134308,0,'2013-07-06 12:44:32',NULL,NULL),(11032,'11568','S','Old Westbury','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.782780,-73.590240,0,'2013-07-06 12:44:30',NULL,NULL),(19199,'19850','P','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.728944,-75.537337,0,'2013-07-06 12:44:31',NULL,NULL),(70762,'85333','S','Dateland','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.877172,-113.426851,0,'2013-07-06 12:44:34',NULL,NULL),(70712,'85277','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.457507,-111.722491,0,'2013-07-06 12:44:34',NULL,NULL),(48497,'55735','S','Giese','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.217584,-92.953356,0,'2013-07-06 12:44:33',NULL,NULL),(8096,'07762','S','Wall Twp','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.153489,-74.039280,0,'2013-07-06 12:44:30',NULL,NULL),(25123,'28001','S','Palestine','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.343780,-80.226300,0,'2013-07-06 12:44:31',NULL,NULL),(3124,'01238','S','W Becket','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.301320,-73.231980,0,'2013-07-06 12:44:30',NULL,NULL),(76351,'95480','S','Stewarts Point Rancheria','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.619693,-123.377331,0,'2013-07-06 12:44:34',NULL,NULL),(5092,'04342','S','Dresden','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.079573,-69.736354,0,'2013-07-06 12:44:30',NULL,NULL),(42064,'47449','S','Newberry','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.926065,-87.009605,0,'2013-07-06 12:44:32',NULL,NULL),(15549,'16623','S','Cassville','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.293418,-78.028929,0,'2013-07-06 12:44:31',NULL,NULL),(21698,'22967','S','Wintergreen Resort','A','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.916232,-78.951373,0,'2013-07-06 12:44:31',NULL,NULL),(76171,'95323','S','Hickman','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.622821,-120.734378,0,'2013-07-06 12:44:34',NULL,NULL),(21526,'22727','S','Criglersville','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(52837,'61315','P','Bureau','D','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.286868,-89.369862,0,'2013-07-06 12:44:33',NULL,NULL),(48077,'55331','S','Excelsior','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.903880,-93.573146,0,'2013-07-06 12:44:33',NULL,NULL),(65312,'77504','S','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.649003,-95.182296,0,'2013-07-06 12:44:34',NULL,NULL),(79871,'99565','P','Chignik Lagoon','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',56.187976,-158.445675,0,'2013-07-06 12:44:34',NULL,NULL),(28871,'32118','S','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.207209,-80.999801,0,'2013-07-06 12:44:32',NULL,NULL),(25883,'28640','S','Theta','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.409140,-81.410460,0,'2013-07-06 12:44:31',NULL,NULL),(72827,'89823','S','Deeth','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.080320,-115.271460,0,'2013-07-06 12:44:34',NULL,NULL),(70125,'84199','U','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725101,-111.939531,0,'2013-07-06 12:44:34',NULL,NULL),(34170,'38302','P','Jackson','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.590220,-88.860766,0,'2013-07-06 12:44:32',NULL,NULL),(40173,'45369','S','So Vienna','N','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.956268,-83.612904,0,'2013-07-06 12:44:32',NULL,NULL),(30391,'33321','S','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(69477,'83669','S','Star','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.703271,-116.488941,0,'2013-07-06 12:44:34',NULL,NULL),(8437,'08081','S','Sicklerville','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.773333,-75.006667,0,'2013-07-06 12:44:30',NULL,NULL),(17069,'17758','S','Beaver Lake','N','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.371851,-76.496126,0,'2013-07-06 12:44:31',NULL,NULL),(40442,'45723','S','Coolville','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.226792,-81.801929,0,'2013-07-06 12:44:32',NULL,NULL),(34058,'38141','S','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.026360,-89.847033,0,'2013-07-06 12:44:32',NULL,NULL),(17700,'18219','P','Conyngham','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.989156,-76.061544,0,'2013-07-06 12:44:31',NULL,NULL),(3305,'01517','P','E Princeton','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.470175,-71.840195,0,'2013-07-06 12:44:30',NULL,NULL),(56857,'66007','S','Basehor','D','Leavenworth','20103','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.136390,-94.931980,0,'2013-07-06 12:44:33',NULL,NULL),(52334,'60568','U','Nicor Gas','N','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.773392,-88.247376,0,'2013-07-06 12:44:33',NULL,NULL),(41383,'46798','S','Yoder','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.940475,-85.218540,0,'2013-07-06 12:44:32',NULL,NULL),(21635,'22911','S','Charlottesvle','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.071652,-78.432215,0,'2013-07-06 12:44:31',NULL,NULL),(12329,'12865','S','West Hebron','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.152744,-73.342735,0,'2013-07-06 12:44:30',NULL,NULL),(15195,'15954','S','Boltz','N','Westmoreland','42129','Pennsylvania','PA','42','6280','814','Eastern',-5.0,'Y',40.403760,-79.025220,0,'2013-07-06 12:44:31',NULL,NULL),(56645,'65613','S','Cherokee Homestead Village','A','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.613564,-93.414989,0,'2013-07-06 12:44:33',NULL,NULL),(36205,'40270','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.253553,-85.757909,0,'2013-07-06 12:44:32',NULL,NULL),(10481,'10952','S','Monsey','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.114522,-74.077510,0,'2013-07-06 12:44:30',NULL,NULL),(79989,'99660','P','Saint Paul','A','Aleutians West','02016','Alaska','AK','02','0000','907','Hawaii',-10.0,'Y',57.184029,-170.273301,0,'2013-07-06 12:44:34',NULL,NULL),(75585,'94289','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.587077,-121.490815,0,'2013-07-06 12:44:34',NULL,NULL),(80040,'99701','S','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.836296,-147.715406,0,'2013-07-06 12:44:34',NULL,NULL),(8249,'08006','P','Barnegat Lgt','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.757500,-74.106667,0,'2013-07-06 12:44:30',NULL,NULL),(14371,'15025','S','Large','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.295525,-79.916350,0,'2013-07-06 12:44:31',NULL,NULL),(67936,'80910','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.816626,-104.777849,0,'2013-07-06 12:44:34',NULL,NULL),(2636,'00965','S','Guaynabo','D','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386260,-66.117485,0,'2013-07-06 12:44:30',NULL,NULL),(32157,'35473','S','N Port','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.228904,-87.577424,0,'2013-07-06 12:44:32',NULL,NULL),(16117,'17055','S','Shepherdstown','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(74278,'92356','S','Lucerne Vly','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.453374,-116.918928,0,'2013-07-06 12:44:34',NULL,NULL),(72510,'89153','U','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.162290,-115.203507,0,'2013-07-06 12:44:34',NULL,NULL),(67053,'79553','S','Stamford','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.948220,-99.769860,0,'2013-07-06 12:44:34',NULL,NULL),(33503,'37361','S','Ocoee','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.107372,-84.705948,0,'2013-07-06 12:44:32',NULL,NULL),(34351,'38583','S','Riverwatch','N','White','47185','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.931616,-85.469699,0,'2013-07-06 12:44:32',NULL,NULL),(56985,'66202','S','Roeland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(45447,'51232','S','Ashton','D','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.312140,-95.784660,0,'2013-07-06 12:44:32',NULL,NULL),(6342,'05669','S','West Braintree','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.073568,-72.727483,0,'2013-07-06 12:44:30',NULL,NULL),(24836,'27613','S','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.902051,-78.707118,0,'2013-07-06 12:44:31',NULL,NULL),(22628,'24239','S','Davenport','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.056587,-82.123206,0,'2013-07-06 12:44:31',NULL,NULL),(68137,'80970','P','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.848525,-104.717700,0,'2013-07-06 12:44:34',NULL,NULL),(28786,'32043','S','Green Cove Springs','D','Clay','12019','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.958919,-81.736288,0,'2013-07-06 12:44:32',NULL,NULL),(28027,'30635','S','Elberton','D','Elbert','13105','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.109753,-82.861460,0,'2013-07-06 12:44:31',NULL,NULL),(45953,'52353','S','Grace Hill','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.299109,-91.688587,0,'2013-07-06 12:44:32',NULL,NULL),(41203,'46725','S','Laud','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(16249,'17082','S','Seven Pines','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.520880,-77.414400,0,'2013-07-06 12:44:31',NULL,NULL),(75642,'94522','P','Concord','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',38.015350,-122.023314,0,'2013-07-06 12:44:34',NULL,NULL),(75015,'93461','S','Cholame','N','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.535600,-120.203280,0,'2013-07-06 12:44:34',NULL,NULL),(27593,'30292','S','Williamson','D','Pike','13231','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.206861,-84.359144,0,'2013-07-06 12:44:31',NULL,NULL),(25743,'28570','S','Bogue','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.770637,-76.870770,0,'2013-07-06 12:44:31',NULL,NULL),(43204,'48304','S','Bloomfld Hls','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.589560,-83.265360,0,'2013-07-06 12:44:32',NULL,NULL),(34941,'39046','S','Way','N','Madison','28089','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.639280,-90.007500,0,'2013-07-06 12:44:32',NULL,NULL),(3239,'01420','S','Fitchburg','D','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.576269,-71.802089,0,'2013-07-06 12:44:30',NULL,NULL),(1665,'00773','S','Urb Luquillo Lomas','N','Luquillo','72089','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.375722,-65.720579,0,'2013-07-06 12:44:30',NULL,NULL),(70051,'84139','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.768936,-111.887445,0,'2013-07-06 12:44:34',NULL,NULL),(11612,'12093','S','Jefferson','D','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.493692,-74.604434,0,'2013-07-06 12:44:30',NULL,NULL),(44408,'49825','P','Eben Junction','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.353420,-87.033521,0,'2013-07-06 12:44:32',NULL,NULL),(27701,'30339','S','Sandy Springs','A','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862244,-84.470385,0,'2013-07-06 12:44:31',NULL,NULL),(39630,'44890','S','Centerton','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.074326,-82.724338,0,'2013-07-06 12:44:32',NULL,NULL),(61986,'73301','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.220228,-97.749942,0,'2013-07-06 12:44:33',NULL,NULL),(59908,'71280','S','Sterlington','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.616000,-92.157420,0,'2013-07-06 12:44:33',NULL,NULL),(56028,'64674','S','Purdin','D','Linn','29115','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.957574,-93.176712,0,'2013-07-06 12:44:33',NULL,NULL),(26120,'28730','S','Fairview','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.524195,-82.410772,0,'2013-07-06 12:44:31',NULL,NULL),(46563,'53515','S','Black Earth','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.127067,-89.742349,0,'2013-07-06 12:44:32',NULL,NULL),(52338,'60572','U','Aurora','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.766060,-88.320017,0,'2013-07-06 12:44:33',NULL,NULL),(660,'00683','S','Mans de San German','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(4981,'04110','S','Portland','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.759193,-70.202112,0,'2013-07-06 12:44:30',NULL,NULL),(29321,'32541','S','Destin','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.397703,-86.479754,0,'2013-07-06 12:44:32',NULL,NULL),(76375,'95521','S','Manila','N','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.928760,-124.060080,0,'2013-07-06 12:44:34',NULL,NULL),(64884,'77072','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.697439,-95.587015,0,'2013-07-06 12:44:34',NULL,NULL),(57115,'66222','P','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.023477,-94.648849,0,'2013-07-06 12:44:33',NULL,NULL),(12034,'12520','S','Cornwall Hudson','N','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.442299,-74.015486,0,'2013-07-06 12:44:30',NULL,NULL),(44481,'49908','S','Baraga','D','Baraga','26013','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.784280,-88.493640,0,'2013-07-06 12:44:32',NULL,NULL),(27869,'30442','S','Perkins','A','Jenkins','13165','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.806080,-81.941063,0,'2013-07-06 12:44:31',NULL,NULL),(73897,'92003','S','Bonsall','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.284720,-117.191750,0,'2013-07-06 12:44:34',NULL,NULL),(10330,'10549','S','Bedford Corners','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.207160,-73.717320,0,'2013-07-06 12:44:30',NULL,NULL),(40107,'45317','S','Conover','D','Miami','39109','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',40.188641,-83.992318,0,'2013-07-06 12:44:32',NULL,NULL),(28670,'31792','S','Gateway','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.836835,-83.972588,0,'2013-07-06 12:44:32',NULL,NULL),(37274,'41601','S','New Allen','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.657284,-82.701808,0,'2013-07-06 12:44:32',NULL,NULL),(18114,'18769','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.253872,-75.871166,0,'2013-07-06 12:44:31',NULL,NULL),(74529,'92654','P','Laguna Hills','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.604203,-117.715359,0,'2013-07-06 12:44:34',NULL,NULL),(35100,'39207','P','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.306196,-90.198595,0,'2013-07-06 12:44:32',NULL,NULL),(66361,'78616','S','Dale','D','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.029845,-97.571615,0,'2013-07-06 12:44:34',NULL,NULL),(46354,'53101','P','Bassett','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.538597,-88.227841,0,'2013-07-06 12:44:32',NULL,NULL),(49736,'57050','S','Nunda','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.155058,-97.010748,0,'2013-07-06 12:44:33',NULL,NULL),(77623,'96970','P','Ebeye Marshall Islands','N','Marshall Islands','68020','Marshall Islands','MH','68','0000','692','UTC+12',12.0,'N',7.121001,171.062651,0,'2013-07-06 12:44:34',NULL,NULL),(72436,'89085','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.300030,-115.141810,0,'2013-07-06 12:44:34',NULL,NULL),(72038,'88061','S','Gila Cliff Dwellings Nationa','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.775733,-108.264777,0,'2013-07-06 12:44:34',NULL,NULL),(64680,'76832','S','Cherokee','D','San Saba','48411','Texas','TX','48','0000','325','Central',-6.0,'Y',30.976993,-98.713025,0,'2013-07-06 12:44:34',NULL,NULL),(25991,'28668','S','Roaring Gap','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.404449,-81.005156,0,'2013-07-06 12:44:31',NULL,NULL),(74056,'92158','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.563682,-116.972887,0,'2013-07-06 12:44:34',NULL,NULL),(68446,'81226','S','Brewster','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.370060,-105.119760,0,'2013-07-06 12:44:34',NULL,NULL),(29217,'32417','P','P C Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.184300,-85.811156,0,'2013-07-06 12:44:32',NULL,NULL),(75867,'94946','S','Nicasio','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.061912,-122.677452,0,'2013-07-06 12:44:34',NULL,NULL),(61741,'73033','P','Eakly','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.305581,-98.557549,0,'2013-07-06 12:44:33',NULL,NULL),(56506,'65347','S','Nelson','D','Saline','29195','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.996587,-93.031634,0,'2013-07-06 12:44:33',NULL,NULL),(25695,'28529','S','Kennells Beach','N','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.140270,-76.819980,0,'2013-07-06 12:44:31',NULL,NULL),(50362,'57750','S','Interior','D','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.739520,-101.933280,0,'2013-07-06 12:44:33',NULL,NULL),(36906,'41129','S','Catlettsburg','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.373377,-82.628036,0,'2013-07-06 12:44:32',NULL,NULL),(13503,'13808','S','Filer Corners','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.547176,-75.243080,0,'2013-07-06 12:44:31',NULL,NULL),(74253,'92336','S','Fontana','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.132487,-117.459265,0,'2013-07-06 12:44:34',NULL,NULL),(7343,'06721','P','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.559848,-73.059033,0,'2013-07-06 12:44:30',NULL,NULL),(58054,'68036','S','Linwood','D','Butler','31023','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.412710,-96.932180,0,'2013-07-06 12:44:33',NULL,NULL),(56810,'65774','S','Weaubleau','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.889769,-93.539293,0,'2013-07-06 12:44:33',NULL,NULL),(56159,'64862','S','Sarcoxie','D','Jasper','29097','Missouri','MO','29','3710','417','Central',-6.0,'Y',37.067820,-94.126452,0,'2013-07-06 12:44:33',NULL,NULL),(308,'00646','S','Urb Monte Mayor','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(44161,'49534','S','Standale','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.976900,-85.768900,0,'2013-07-06 12:44:32',NULL,NULL),(78726,'98278','U','Whidbey Nas','N','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.281520,-122.625637,0,'2013-07-06 12:44:34',NULL,NULL),(72182,'88351','S','Arabela','A','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.274217,-105.137756,0,'2013-07-06 12:44:34',NULL,NULL),(69865,'84093','S','Cottonwd Hgts','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.590896,-111.828061,0,'2013-07-06 12:44:34',NULL,NULL),(11620,'12107','P','Knox','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.669807,-74.119886,0,'2013-07-06 12:44:30',NULL,NULL),(53604,'62080','S','Bayle','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.144853,-89.109512,0,'2013-07-06 12:44:33',NULL,NULL),(30829,'33624','S','Northdale','A','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.076141,-82.523628,0,'2013-07-06 12:44:32',NULL,NULL),(18629,'19153','S','Eastwick','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.887687,-75.233918,0,'2013-07-06 12:44:31',NULL,NULL),(77054,'96116','P','Likely','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.232112,-120.503123,0,'2013-07-06 12:44:34',NULL,NULL),(76994,'96074','P','Paskenta','D','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',39.930965,-122.532728,0,'2013-07-06 12:44:34',NULL,NULL),(76634,'95713','S','Yankee Jims','N','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(67835,'80810','S','Cheyenne Wells','D','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.850458,-102.381819,0,'2013-07-06 12:44:34',NULL,NULL),(67636,'80454','P','Indian Hills','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.631893,-105.251516,0,'2013-07-06 12:44:34',NULL,NULL),(52885,'61349','S','Limerick','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.602605,-89.452512,0,'2013-07-06 12:44:33',NULL,NULL),(50462,'58033','S','Englevale','A','Ransom','38073','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.433700,-97.862400,0,'2013-07-06 12:44:33',NULL,NULL),(27809,'30401','S','Blun','N','Emanuel','13107','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.597493,-82.336281,0,'2013-07-06 12:44:31',NULL,NULL),(18512,'19103','S','Mid City West','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.964218,-75.200972,0,'2013-07-06 12:44:31',NULL,NULL),(22869,'24562','S','Howardsville','D','Buckingham','51029','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.767311,-78.589328,0,'2013-07-06 12:44:31',NULL,NULL),(17289,'17850','P','Chillisquaque','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972467,-76.850729,0,'2013-07-06 12:44:31',NULL,NULL),(21675,'22957','P','Montpelier Station','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.199667,-78.116529,0,'2013-07-06 12:44:31',NULL,NULL),(74064,'92165','P','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.751960,-117.102240,0,'2013-07-06 12:44:34',NULL,NULL),(72724,'89502','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.500666,-119.765124,0,'2013-07-06 12:44:34',NULL,NULL),(65114,'77373','S','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.054630,-95.382975,0,'2013-07-06 12:44:34',NULL,NULL),(61784,'73073','S','Orlando','D','Logan','40083','Oklahoma','OK','40','5880','580','Central',-6.0,'Y',36.132163,-97.439865,0,'2013-07-06 12:44:33',NULL,NULL),(74926,'93402','S','San Luis Obispo','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.301420,-120.825000,0,'2013-07-06 12:44:34',NULL,NULL),(61707,'73005','S','Anadarko','D','Caddo','40015','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.072673,-98.245206,0,'2013-07-06 12:44:33',NULL,NULL),(13232,'13638','S','Felts Mills','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.019385,-75.745627,0,'2013-07-06 12:44:30',NULL,NULL),(9357,'09813','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21820,'23109','S','Beaverlett','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.442814,-76.356370,0,'2013-07-06 12:44:31',NULL,NULL),(58989,'70053','S','Gretna','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.911883,-90.052716,0,'2013-07-06 12:44:33',NULL,NULL),(55735,'64086','S','Lone Jack','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.919180,-94.320840,0,'2013-07-06 12:44:33',NULL,NULL),(46517,'53268','U','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.040756,-87.911157,0,'2013-07-06 12:44:32',NULL,NULL),(12291,'12847','S','Brandreth','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.968517,-74.418773,0,'2013-07-06 12:44:30',NULL,NULL),(4315,'02911','S','Providence','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(443,'00662','S','Urb Islazul','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(8893,'08730','S','Brielle','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.104098,-74.067637,0,'2013-07-06 12:44:30',NULL,NULL),(12583,'13071','S','Genoa','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.673961,-76.541497,0,'2013-07-06 12:44:30',NULL,NULL),(53833,'62306','P','Quincy','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.932961,-91.305950,0,'2013-07-06 12:44:33',NULL,NULL),(10659,'11104','S','Sunnyside','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.744648,-73.917792,0,'2013-07-06 12:44:30',NULL,NULL),(7572,'07029','S','East Newark','A','Hudson','34017','New Jersey','NJ','34','3640','973/862','Eastern',-5.0,'Y',40.744953,-74.152306,0,'2013-07-06 12:44:30',NULL,NULL),(78309,'97907','S','Rye Valley','N','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.347926,-117.262318,0,'2013-07-06 12:44:34',NULL,NULL),(54713,'62957','S','McClure','N','Alexander','17003','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.295028,-89.495807,0,'2013-07-06 12:44:33',NULL,NULL),(9062,'08906','P','Edison','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.484296,-74.444675,0,'2013-07-06 12:44:30',NULL,NULL),(78180,'97707','S','Bend','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.843213,-121.509344,0,'2013-07-06 12:44:34',NULL,NULL),(50998,'58654','S','Sentinel','N','Golden Valley','38033','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.801990,-103.732852,0,'2013-07-06 12:44:33',NULL,NULL),(5235,'04469','U','Orono','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.901113,-68.672733,0,'2013-07-06 12:44:30',NULL,NULL),(51326,'59259','S','Richey','D','Dawson','30021','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.640640,-104.980628,0,'2013-07-06 12:44:33',NULL,NULL),(14075,'14609','S','Irondequoit','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.174537,-77.559782,0,'2013-07-06 12:44:31',NULL,NULL),(68955,'82944','P','Robertson','D','Uinta','56041','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.088076,-110.560957,0,'2013-07-06 12:44:34',NULL,NULL),(18140,'18831','S','Milan','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.899052,-76.535770,0,'2013-07-06 12:44:31',NULL,NULL),(6469,'05763','S','N Chittenden','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.767228,-72.969037,0,'2013-07-06 12:44:30',NULL,NULL),(7906,'07607','S','Maywood','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.903987,-74.063587,0,'2013-07-06 12:44:30',NULL,NULL),(6902,'06150','U','Hartford Natl Bank','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765671,-72.675155,0,'2013-07-06 12:44:30',NULL,NULL),(3254,'01441','U','Tyco','N','Worcester','25027','Massachusetts','MA','25','2600','978/351','Eastern',-5.0,'Y',42.573616,-71.994641,0,'2013-07-06 12:44:30',NULL,NULL),(31845,'35094','S','Leeds','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540397,-86.557890,0,'2013-07-06 12:44:32',NULL,NULL),(50612,'58259','S','Whitman','A','Nelson','38063','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.062400,-98.125380,0,'2013-07-06 12:44:33',NULL,NULL),(6271,'05609','U','State of Vermont','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.287423,-72.600062,0,'2013-07-06 12:44:30',NULL,NULL),(22490,'24066','S','Lithia','A','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.531800,-79.683720,0,'2013-07-06 12:44:31',NULL,NULL),(7526,'07005','S','Lyonsville','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.918020,-74.425860,0,'2013-07-06 12:44:30',NULL,NULL),(28382,'31303','S','Clyo','D','Effingham','13103','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.516854,-81.318805,0,'2013-07-06 12:44:32',NULL,NULL),(77768,'97116','S','Verboort','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.522072,-123.107074,0,'2013-07-06 12:44:34',NULL,NULL),(79187,'98531','S','Centralia','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.723564,-122.958491,0,'2013-07-06 12:44:34',NULL,NULL),(67153,'79782','S','Stanton','D','Martin','48317','Texas','TX','48','0000','432','Central',-6.0,'Y',32.131726,-101.792877,0,'2013-07-06 12:44:34',NULL,NULL),(63366,'75641','P','Easton','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.373227,-94.588435,0,'2013-07-06 12:44:33',NULL,NULL),(3925,'02462','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.331200,-71.258208,0,'2013-07-06 12:44:30',NULL,NULL),(28372,'31294','U','Business Reply Mail','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.837487,-83.632352,0,'2013-07-06 12:44:32',NULL,NULL),(34712,'38834','S','Kendrick','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(22598,'24185','S','Woolwine','D','Patrick','51141','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.807816,-80.278377,0,'2013-07-06 12:44:31',NULL,NULL),(70431,'84735','P','Hatch','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.651760,-112.432889,0,'2013-07-06 12:44:34',NULL,NULL),(30277,'33256','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.661865,-80.326386,0,'2013-07-06 12:44:32',NULL,NULL),(58094,'68106','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.237222,-96.001713,0,'2013-07-06 12:44:33',NULL,NULL),(27670,'30328','S','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.933854,-84.386944,0,'2013-07-06 12:44:31',NULL,NULL),(42614,'47902','P','La Fayette','A','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.416378,-86.851288,0,'2013-07-06 12:44:32',NULL,NULL),(41055,'46411','P','Gary','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.471370,-87.376351,0,'2013-07-06 12:44:32',NULL,NULL),(63248,'75482','S','Sulphur Spgs','A','Hopkins','48223','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.128095,-95.598595,0,'2013-07-06 12:44:33',NULL,NULL),(21253,'22302','S','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.829310,-77.085205,0,'2013-07-06 12:44:31',NULL,NULL),(26006,'28675','S','Stratford','N','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.506191,-81.117283,0,'2013-07-06 12:44:31',NULL,NULL),(17545,'17976','S','Weston Place','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(65061,'77342','P','Huntsville','D','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.722392,-95.531478,0,'2013-07-06 12:44:34',NULL,NULL),(79840,'99530','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.151483,-149.944356,0,'2013-07-06 12:44:34',NULL,NULL),(72249,'88526','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811387,-106.417414,0,'2013-07-06 12:44:34',NULL,NULL),(78570,'98164','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.607818,-122.333703,0,'2013-07-06 12:44:34',NULL,NULL),(71836,'87579','S','Vadito','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.188374,-105.684228,0,'2013-07-06 12:44:34',NULL,NULL),(52270,'60525','S','Indianhead Pk','N','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.795251,-87.875697,0,'2013-07-06 12:44:33',NULL,NULL),(21518,'22722','S','Haywood','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.469435,-78.179818,0,'2013-07-06 12:44:31',NULL,NULL),(74266,'92344','S','Oak Hills','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.397300,-117.399400,0,'2013-07-06 12:44:34',NULL,NULL),(73312,'90810','S','Carson','A','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.817980,-118.223280,0,'2013-07-06 12:44:34',NULL,NULL),(37836,'42453','S','Saint Charles','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.163997,-87.584022,0,'2013-07-06 12:44:32',NULL,NULL),(43122,'48229','S','Ecorse','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.252273,-83.144669,0,'2013-07-06 12:44:32',NULL,NULL),(49103,'56342','S','Isle','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.199853,-93.490646,0,'2013-07-06 12:44:33',NULL,NULL),(59905,'71277','S','Spearsville','D','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.897756,-92.609210,0,'2013-07-06 12:44:33',NULL,NULL),(47384,'54632','S','Genoa','D','Vernon','55123','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.563766,-91.228395,0,'2013-07-06 12:44:32',NULL,NULL),(78972,'98371','S','Puyallup','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.189343,-122.305994,0,'2013-07-06 12:44:34',NULL,NULL),(67263,'79968','U','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.773335,-106.504435,0,'2013-07-06 12:44:34',NULL,NULL),(10279,'10512','S','Lake Carmel','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.449121,-73.679279,0,'2013-07-06 12:44:30',NULL,NULL),(5986,'05350','S','Heartwellville','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.829722,-72.988056,0,'2013-07-06 12:44:30',NULL,NULL),(6588,'05859','S','Jay Peak','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.000000,-72.400000,0,'2013-07-06 12:44:30',NULL,NULL),(21045,'21875','S','Delmar','D','Wicomico','24045','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.448681,-75.580949,0,'2013-07-06 12:44:31',NULL,NULL),(76679,'95811','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.575345,-121.507277,0,'2013-07-06 12:44:34',NULL,NULL),(74297,'92373','S','Marigold','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.050061,-117.169355,0,'2013-07-06 12:44:34',NULL,NULL),(23174,'25031','P','Boomer','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.151292,-81.286034,0,'2013-07-06 12:44:31',NULL,NULL),(31184,'33931','S','Fort Myers Beach','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.447226,-81.931788,0,'2013-07-06 12:44:32',NULL,NULL),(66434,'78644','S','Mendoza','N','Caldwell','48055','Texas','TX','48','0640','512/737','Central',-6.0,'Y',29.879640,-97.666740,0,'2013-07-06 12:44:34',NULL,NULL),(16260,'17086','S','West Perry','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.698624,-77.126607,0,'2013-07-06 12:44:31',NULL,NULL),(56915,'66053','S','Louisburg','D','Miami','20121','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.622878,-94.675240,0,'2013-07-06 12:44:33',NULL,NULL),(11264,'11768','S','Sunken Meadow','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.913820,-73.333500,0,'2013-07-06 12:44:30',NULL,NULL),(19050,'19542','P','Monocacy Sta','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.262469,-75.767703,0,'2013-07-06 12:44:31',NULL,NULL),(74803,'93204','S','Avenal','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.008653,-120.132647,0,'2013-07-06 12:44:34',NULL,NULL),(17708,'18230','P','Junedale','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.925984,-75.938095,0,'2013-07-06 12:44:31',NULL,NULL),(71425,'87026','S','Old Laguna','A','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.876024,-107.285992,0,'2013-07-06 12:44:34',NULL,NULL),(4700,'03814','S','Center Ossipee','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.749840,-71.105236,0,'2013-07-06 12:44:30',NULL,NULL),(43254,'48323','S','W Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.573180,-83.380200,0,'2013-07-06 12:44:32',NULL,NULL),(35615,'39601','S','West Lincoln','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(57366,'66740','S','Galesburg','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.467613,-95.309733,0,'2013-07-06 12:44:33',NULL,NULL),(53774,'62273','P','Pierron','D','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.782644,-89.565101,0,'2013-07-06 12:44:33',NULL,NULL),(6072,'05446','S','Smc','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.548500,-73.215480,0,'2013-07-06 12:44:30',NULL,NULL),(55870,'64190','P','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.188576,-94.682108,0,'2013-07-06 12:44:33',NULL,NULL),(55170,'63368','S','Dardenne Prairie','A','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.757000,-90.724700,0,'2013-07-06 12:44:33',NULL,NULL),(54752,'62982','S','Rosiclare','D','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.421501,-88.356850,0,'2013-07-06 12:44:33',NULL,NULL),(37223,'41537','S','Gaskill','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(35978,'40115','S','Custer','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.753035,-86.249373,0,'2013-07-06 12:44:32',NULL,NULL),(51750,'60019','U','Rosemont','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.024981,-87.899607,0,'2013-07-06 12:44:33',NULL,NULL),(42198,'47550','S','Buffaloville','A','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.052420,-86.966520,0,'2013-07-06 12:44:32',NULL,NULL),(18662,'19177','U','Wachovia Bank','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951003,-75.149750,0,'2013-07-06 12:44:31',NULL,NULL),(57157,'66276','U','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.002659,-94.669998,0,'2013-07-06 12:44:33',NULL,NULL),(53661,'62207','S','Centreville','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.610300,-90.156180,0,'2013-07-06 12:44:33',NULL,NULL),(37952,'42717','S','Peytonsburg','A','Cumberland','21057','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.805860,-85.409340,0,'2013-07-06 12:44:32',NULL,NULL),(76774,'95935','S','Dobbins','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.375661,-121.216067,0,'2013-07-06 12:44:34',NULL,NULL),(9422,'10002','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.715523,-73.988379,0,'2013-07-06 12:44:30',NULL,NULL),(23242,'25112','P','Institute','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.377795,-81.762433,0,'2013-07-06 12:44:31',NULL,NULL),(12709,'13147','S','Venice Center','A','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(48521,'55746','S','Lynwood','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(73443,'91301','S','Agoura Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.144523,-118.760382,0,'2013-07-06 12:44:34',NULL,NULL),(19007,'19526','S','Tilden','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.550000,-76.016667,0,'2013-07-06 12:44:31',NULL,NULL),(62630,'74555','S','Lane','D','Atoka','40005','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.389315,-96.124352,0,'2013-07-06 12:44:33',NULL,NULL),(22434,'24015','S','Grandin Road','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.254944,-79.980629,0,'2013-07-06 12:44:31',NULL,NULL),(5097,'04345','S','West Gardiner','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.231489,-69.779004,0,'2013-07-06 12:44:30',NULL,NULL),(39414,'44667','S','Orrville','D','Wayne','39169','Ohio','OH','39','0000','330/234','Eastern',-5.0,'Y',40.833108,-81.768456,0,'2013-07-06 12:44:32',NULL,NULL),(50363,'57750','S','Potato Creek','N','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.739520,-101.933280,0,'2013-07-06 12:44:33',NULL,NULL),(35497,'39529','U','N S T L','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(9727,'10087','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755837,-73.973221,0,'2013-07-06 12:44:30',NULL,NULL),(43329,'48362','S','Orion Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.782837,-83.269237,0,'2013-07-06 12:44:32',NULL,NULL),(61258,'72359','P','Madison','D','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.013056,-90.722500,0,'2013-07-06 12:44:33',NULL,NULL),(55122,'63341','S','Matson','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.664113,-90.817080,0,'2013-07-06 12:44:33',NULL,NULL),(13839,'14222','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.919299,-78.876334,0,'2013-07-06 12:44:31',NULL,NULL),(49938,'57332','S','Clayton','N','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.605292,-97.622528,0,'2013-07-06 12:44:33',NULL,NULL),(19048,'19540','S','Mohnton','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(24950,'27830','S','Fremont','D','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.542860,-77.965020,0,'2013-07-06 12:44:31',NULL,NULL),(63524,'75755','S','Holly Lake Ranch','A','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.583260,-95.112002,0,'2013-07-06 12:44:33',NULL,NULL),(15674,'16823','S','Hublersburg','A','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.938060,-77.721720,0,'2013-07-06 12:44:31',NULL,NULL),(48868,'56082','S','St Peter','N','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.330953,-93.959962,0,'2013-07-06 12:44:33',NULL,NULL),(33227,'37064','S','Kingfield','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.923225,-86.887821,0,'2013-07-06 12:44:32',NULL,NULL),(69578,'83835','S','Hayden','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.790660,-116.764380,0,'2013-07-06 12:44:34',NULL,NULL),(67552,'80266','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.750435,-104.999154,0,'2013-07-06 12:44:34',NULL,NULL),(54480,'62859','S','Thackeray','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(47041,'54408','S','Hogarty','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',45.045303,-89.291462,0,'2013-07-06 12:44:32',NULL,NULL),(52199,'60475','S','Steger','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466203,-87.638399,0,'2013-07-06 12:44:33',NULL,NULL),(21029,'21864','S','Stockton','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.043738,-75.414833,0,'2013-07-06 12:44:31',NULL,NULL),(32066,'35270','U','North American Mg','N','Jefferson','01073','Alabama','AL','01','1000','205','Central',-6.0,'Y',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(72496,'89142','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.156108,-115.032164,0,'2013-07-06 12:44:34',NULL,NULL),(35298,'39401','S','Meyers','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(76459,'95614','S','Cool','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.905494,-120.956183,0,'2013-07-06 12:44:34',NULL,NULL),(21183,'22172','S','Triangle','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.551270,-77.324765,0,'2013-07-06 12:44:31',NULL,NULL),(76455,'95611','P','Citrus Hts','A','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.707001,-121.277971,0,'2013-07-06 12:44:34',NULL,NULL),(69131,'83286','S','Linrose','N','Franklin','16041','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.033727,-112.014264,0,'2013-07-06 12:44:34',NULL,NULL),(40983,'46348','S','La Crosse','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.313420,-86.887041,0,'2013-07-06 12:44:32',NULL,NULL),(44414,'49831','S','Iron Mountain','A','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.998379,-87.826892,0,'2013-07-06 12:44:32',NULL,NULL),(46228,'52774','P','Welton','D','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.905202,-90.609367,0,'2013-07-06 12:44:32',NULL,NULL),(66043,'78369','S','Ojuelas','N','Webb','48479','Texas','TX','48','4080','361','Central',-6.0,'Y',27.441138,-99.024210,0,'2013-07-06 12:44:34',NULL,NULL),(29811,'33025','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.992876,-80.274221,0,'2013-07-06 12:44:32',NULL,NULL),(29265,'32456','S','Port St Joe','A','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.819214,-85.299275,0,'2013-07-06 12:44:32',NULL,NULL),(22495,'24069','S','Leakesville Junction','N','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.586350,-79.660137,0,'2013-07-06 12:44:31',NULL,NULL),(34616,'38751','S','Pollock','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(70678,'85246','P','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.292302,-111.867612,0,'2013-07-06 12:44:34',NULL,NULL),(49513,'56670','P','Redby','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.859549,-94.921538,0,'2013-07-06 12:44:33',NULL,NULL),(45604,'51559','S','Neola','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.455145,-95.617157,0,'2013-07-06 12:44:32',NULL,NULL),(43056,'48187','S','Canton','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.331838,-83.477568,0,'2013-07-06 12:44:32',NULL,NULL),(37719,'42275','S','Big Ready','N','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.199181,-86.454521,0,'2013-07-06 12:44:32',NULL,NULL),(37162,'41472','S','Cottle','A','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.970737,-83.278690,0,'2013-07-06 12:44:32',NULL,NULL),(72360,'89023','P','Mercury','D','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.661428,-115.999727,0,'2013-07-06 12:44:34',NULL,NULL),(69066,'83238','S','Raymond','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.319818,-111.061024,0,'2013-07-06 12:44:34',NULL,NULL),(63622,'75833','S','Middleton','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.249797,-95.973492,0,'2013-07-06 12:44:34',NULL,NULL),(59482,'70757','S','Ramah','A','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.491099,-91.515729,0,'2013-07-06 12:44:33',NULL,NULL),(49283,'56516','S','Bejou','D','Mahnomen','27087','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.453105,-95.935493,0,'2013-07-06 12:44:33',NULL,NULL),(11909,'12409','S','Bearsville','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.037380,-74.175180,0,'2013-07-06 12:44:30',NULL,NULL),(15259,'16061','S','West Sunbury','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.015217,-79.876934,0,'2013-07-06 12:44:31',NULL,NULL),(55363,'63565','S','Lemons','N','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497300,-93.005760,0,'2013-07-06 12:44:33',NULL,NULL),(52410,'60639','S','Cragin','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.918417,-87.755959,0,'2013-07-06 12:44:33',NULL,NULL),(13963,'14469','S','Holcomb','N','Ontario','36069','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.877952,-77.456375,0,'2013-07-06 12:44:31',NULL,NULL),(27302,'30014','S','Covington','D','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.587144,-83.832307,0,'2013-07-06 12:44:31',NULL,NULL),(7733,'07205','S','Hillside','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.693929,-74.228806,0,'2013-07-06 12:44:30',NULL,NULL),(35957,'40063','P','St Mary','A','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.579147,-85.342897,0,'2013-07-06 12:44:32',NULL,NULL),(38268,'43315','S','Cardington','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.482130,-82.860172,0,'2013-07-06 12:44:32',NULL,NULL),(77108,'96143','P','Kings Beach','D','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.258133,-120.036587,0,'2013-07-06 12:44:34',NULL,NULL),(72938,'90036','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.067699,-118.350907,0,'2013-07-06 12:44:34',NULL,NULL),(61908,'73145','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.415801,-97.392307,0,'2013-07-06 12:44:33',NULL,NULL),(53384,'61802','S','Urbana','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.126026,-88.171678,0,'2013-07-06 12:44:33',NULL,NULL),(40061,'45270','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.100915,-84.535879,0,'2013-07-06 12:44:32',NULL,NULL),(37513,'42038','S','Overlook','N','Lyon','21143','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.045200,-88.050120,0,'2013-07-06 12:44:32',NULL,NULL),(74156,'92260','S','Palm Desert','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.727749,-116.371851,0,'2013-07-06 12:44:34',NULL,NULL),(66496,'78676','S','Wimberley','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.039060,-98.139780,0,'2013-07-06 12:44:34',NULL,NULL),(58229,'68346','S','Lorton','A','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.655568,-96.007618,0,'2013-07-06 12:44:33',NULL,NULL),(77990,'97401','S','Eugene','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.080533,-123.073047,0,'2013-07-06 12:44:34',NULL,NULL),(52165,'60455','S','Bridgeview','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.737459,-87.803915,0,'2013-07-06 12:44:33',NULL,NULL),(7105,'06370','S','Oakdale','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.468520,-72.176760,0,'2013-07-06 12:44:30',NULL,NULL),(29873,'33041','P','Key West','D','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.558003,-81.808398,0,'2013-07-06 12:44:32',NULL,NULL),(9657,'10038','S','Peck Slip','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.706088,-74.004447,0,'2013-07-06 12:44:30',NULL,NULL),(22828,'24506','P','Lynchburg','D','Lynchburg City','51680','Virginia','VA','51','4640','434','Eastern',-5.0,'Y',37.355911,-79.166735,0,'2013-07-06 12:44:31',NULL,NULL),(10680,'11205','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694985,-73.965575,0,'2013-07-06 12:44:30',NULL,NULL),(49882,'57263','S','South Shore','D','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.108550,-97.022712,0,'2013-07-06 12:44:33',NULL,NULL),(28954,'32195','S','Weirsdale','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.981820,-81.917908,0,'2013-07-06 12:44:32',NULL,NULL),(63589,'75785','S','Dialville','A','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.799220,-95.164860,0,'2013-07-06 12:44:34',NULL,NULL),(57813,'67515','S','Arnold','D','Ness','20135','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.608938,-100.006515,0,'2013-07-06 12:44:33',NULL,NULL),(54908,'63080','S','Strain','N','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.261280,-91.141560,0,'2013-07-06 12:44:33',NULL,NULL),(65077,'77350','P','Seven Oaks','N','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.817983,-94.870287,0,'2013-07-06 12:44:34',NULL,NULL),(62954,'75110','S','Navarro','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.060160,-96.431160,0,'2013-07-06 12:44:33',NULL,NULL),(31303,'34099','M','FPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(38543,'43750','P','Cambridge','A','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.994618,-81.506178,0,'2013-07-06 12:44:32',NULL,NULL),(59761,'71161','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.497981,-93.751988,0,'2013-07-06 12:44:33',NULL,NULL),(48119,'55356','S','Orono','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.987459,-93.581675,0,'2013-07-06 12:44:33',NULL,NULL),(76945,'96029','S','Corning','A','Tehama','06103','California','CA','06','0000','530','Pacific',-8.0,'Y',39.913416,-122.467956,0,'2013-07-06 12:44:34',NULL,NULL),(22358,'23897','S','Yale','D','Sussex','51183','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.832124,-77.279258,0,'2013-07-06 12:44:31',NULL,NULL),(55228,'63436','S','Center','D','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.506337,-91.532429,0,'2013-07-06 12:44:33',NULL,NULL),(76189,'95344','P','Merced','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.377754,-120.613757,0,'2013-07-06 12:44:34',NULL,NULL),(78639,'98222','S','Anacortes','A','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.609071,-122.921563,0,'2013-07-06 12:44:34',NULL,NULL),(66771,'79027','S','Dimmitt','D','Castro','48069','Texas','TX','48','0000','806','Central',-6.0,'Y',34.546258,-102.316894,0,'2013-07-06 12:44:34',NULL,NULL),(65172,'77414','S','Buckeye','N','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.963849,-95.948080,0,'2013-07-06 12:44:34',NULL,NULL),(32580,'36120','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.312846,-86.234558,0,'2013-07-06 12:44:32',NULL,NULL),(39975,'45239','S','Brookwood','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.221695,-84.580861,0,'2013-07-06 12:44:32',NULL,NULL),(43437,'48504','S','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.035862,-83.742760,0,'2013-07-06 12:44:32',NULL,NULL),(16892,'17579','S','Hessdale','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.967797,-76.177226,0,'2013-07-06 12:44:31',NULL,NULL),(59702,'71101','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.504787,-93.746306,0,'2013-07-06 12:44:33',NULL,NULL),(18724,'19318','P','Chatham','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.855966,-75.822922,0,'2013-07-06 12:44:31',NULL,NULL),(42400,'47737','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.973127,-87.573374,0,'2013-07-06 12:44:32',NULL,NULL),(17598,'18039','P','Durham','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.584196,-75.227453,0,'2013-07-06 12:44:31',NULL,NULL),(75764,'94621','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.755868,-122.188468,0,'2013-07-06 12:44:34',NULL,NULL),(66153,'78503','S','McAllen','D','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.177511,-98.241408,0,'2013-07-06 12:44:34',NULL,NULL),(8194,'07924','S','Bernardsville','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.723076,-74.588522,0,'2013-07-06 12:44:30',NULL,NULL),(53081,'61523','S','Vonachen Knolls','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(14506,'15201','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.470679,-79.954348,0,'2013-07-06 12:44:31',NULL,NULL),(13365,'13733','S','Bennettsville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.304440,-75.480180,0,'2013-07-06 12:44:31',NULL,NULL),(69695,'84029','S','Skull Valley','A','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.604525,-112.456180,0,'2013-07-06 12:44:34',NULL,NULL),(69655,'84013','S','Cedar Fort','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.247580,-112.062060,0,'2013-07-06 12:44:34',NULL,NULL),(72765,'89521','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.379920,-119.753303,0,'2013-07-06 12:44:34',NULL,NULL),(42440,'47805','S','Marquette Farm','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(46279,'53035','S','Iron Ridge','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.394704,-88.534239,0,'2013-07-06 12:44:32',NULL,NULL),(77207,'96374','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(2976,'01054','S','Leverett','D','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.474743,-72.482496,0,'2013-07-06 12:44:30',NULL,NULL),(25520,'28388','P','Southern Pnes','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.181810,-79.401905,0,'2013-07-06 12:44:31',NULL,NULL),(69758,'84050','S','Stoddard','N','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(38802,'44067','S','Northfield','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(68548,'81426','P','Ophir','D','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.862652,-107.874103,0,'2013-07-06 12:44:34',NULL,NULL),(53244,'61656','P','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.683509,-89.606531,0,'2013-07-06 12:44:33',NULL,NULL),(77156,'96204','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(52452,'60673','U','Chase Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.887505,-87.628813,0,'2013-07-06 12:44:33',NULL,NULL),(46320,'53074','S','Port Washington','D','Ozaukee','55089','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.421132,-87.876731,0,'2013-07-06 12:44:32',NULL,NULL),(54484,'62863','S','Cowling','N','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.416747,-87.765751,0,'2013-07-06 12:44:33',NULL,NULL),(67475,'80225','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.724284,-105.110169,0,'2013-07-06 12:44:34',NULL,NULL),(21856,'23146','S','Rockville','D','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.700079,-77.706409,0,'2013-07-06 12:44:31',NULL,NULL),(34628,'38756','S','Helm','N','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(54443,'62843','S','Goldengate','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.361539,-88.203910,0,'2013-07-06 12:44:33',NULL,NULL),(40233,'45420','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.704905,-84.126463,0,'2013-07-06 12:44:32',NULL,NULL),(74848,'93246','U','NAS Lemoore','N','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.290241,-119.847834,0,'2013-07-06 12:44:34',NULL,NULL),(9462,'10008','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.712215,-74.006968,0,'2013-07-06 12:44:30',NULL,NULL),(21477,'22641','S','Lebanon Church','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.062322,-78.362403,0,'2013-07-06 12:44:31',NULL,NULL),(27481,'30151','P','Nelson','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.382400,-84.369300,0,'2013-07-06 12:44:31',NULL,NULL),(58418,'68649','S','North Bend','D','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.462461,-96.783977,0,'2013-07-06 12:44:33',NULL,NULL),(52281,'60527','S','Burridge','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.841820,-87.951040,0,'2013-07-06 12:44:33',NULL,NULL),(49274,'56501','S','Detroit Lakes','D','Becker','27005','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.815249,-95.846334,0,'2013-07-06 12:44:33',NULL,NULL),(79623,'99122','S','Deer Meadows','A','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.655779,-118.147962,0,'2013-07-06 12:44:34',NULL,NULL),(19253,'19941','S','Ellendale','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.777869,-75.366822,0,'2013-07-06 12:44:31',NULL,NULL),(68270,'81073','S','Maxey','N','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.397087,-102.621835,0,'2013-07-06 12:44:34',NULL,NULL),(64878,'77066','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.958349,-95.500210,0,'2013-07-06 12:44:34',NULL,NULL),(15163,'15909','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.357965,-78.876651,0,'2013-07-06 12:44:31',NULL,NULL),(47722,'55007','S','Brook Park','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.946447,-92.864586,0,'2013-07-06 12:44:33',NULL,NULL),(15367,'16259','S','Templeton','D','Armstrong','42005','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.948599,-79.452462,0,'2013-07-06 12:44:31',NULL,NULL),(15039,'15697','S','Youngwood','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.236948,-79.577624,0,'2013-07-06 12:44:31',NULL,NULL),(65920,'78240','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.498580,-98.605740,0,'2013-07-06 12:44:34',NULL,NULL),(62230,'73945','S','Hooker','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.827280,-101.182200,0,'2013-07-06 12:44:33',NULL,NULL),(57705,'67341','S','Dennis','D','Labette','20099','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.318870,-95.414151,0,'2013-07-06 12:44:33',NULL,NULL),(68528,'81410','S','Austin','D','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.792114,-107.972510,0,'2013-07-06 12:44:34',NULL,NULL),(49155,'56385','S','Villard','D','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.688264,-95.116517,0,'2013-07-06 12:44:33',NULL,NULL),(16045,'17044','S','Maitland','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.602729,-77.569859,0,'2013-07-06 12:44:31',NULL,NULL),(69876,'84097','S','Orem','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.306409,-111.675292,0,'2013-07-06 12:44:34',NULL,NULL),(28356,'31204','S','Payne','A','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.842317,-83.677163,0,'2013-07-06 12:44:32',NULL,NULL),(3089,'01203','P','Pittsfield','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.453189,-73.262785,0,'2013-07-06 12:44:30',NULL,NULL),(68404,'81154','S','Wagon Wheel Gap','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.672402,-106.630824,0,'2013-07-06 12:44:34',NULL,NULL),(62928,'75087','S','Rockwall','D','Rockwall','48397','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.899320,-96.412080,0,'2013-07-06 12:44:33',NULL,NULL),(26061,'28693','S','Clifton','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.461801,-81.554415,0,'2013-07-06 12:44:31',NULL,NULL),(17976,'18614','S','Wilmot Twp','A','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.522494,-76.401012,0,'2013-07-06 12:44:31',NULL,NULL),(2921,'01010','S','Brimfield','D','Hampden','25013','Massachusetts','MA','25','9240','413','Eastern',-5.0,'Y',42.115140,-72.201420,0,'2013-07-06 12:44:30',NULL,NULL),(18309,'19018','S','Westbrook Park','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.922624,-75.302964,0,'2013-07-06 12:44:31',NULL,NULL),(64907,'77093','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.862610,-95.339011,0,'2013-07-06 12:44:34',NULL,NULL),(10020,'10170','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(56889,'66039','S','Kincaid','D','Anderson','20003','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.103006,-95.128986,0,'2013-07-06 12:44:33',NULL,NULL),(46611,'53569','S','Montfort','D','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.991221,-90.475978,0,'2013-07-06 12:44:32',NULL,NULL),(33918,'38053','S','Quito','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.331660,-89.894580,0,'2013-07-06 12:44:32',NULL,NULL),(77045,'96111','P','Floriston','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.391046,-120.023279,0,'2013-07-06 12:44:34',NULL,NULL),(26812,'29475','S','Ruffin','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',33.010716,-80.823021,0,'2013-07-06 12:44:31',NULL,NULL),(13354,'13697','S','Winthrop','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.745875,-74.805347,0,'2013-07-06 12:44:30',NULL,NULL),(54899,'63074','S','Saint Ann','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.727416,-90.387327,0,'2013-07-06 12:44:33',NULL,NULL),(35411,'39466','S','Caesar','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(18661,'19177','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951003,-75.149750,0,'2013-07-06 12:44:31',NULL,NULL),(51673,'59921','P','Lake Mc Donald','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.621891,-113.873901,0,'2013-07-06 12:44:33',NULL,NULL),(17143,'17801','S','Lower Augusta','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.846980,-76.771500,0,'2013-07-06 12:44:31',NULL,NULL),(20400,'20899','U','Natl Inst Stds & Tech Md','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.144286,-77.215257,0,'2013-07-06 12:44:31',NULL,NULL),(32803,'36436','S','Scyrene','N','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.730014,-87.651049,0,'2013-07-06 12:44:32',NULL,NULL),(33289,'37127','S','Mboro','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.775581,-86.328633,0,'2013-07-06 12:44:32',NULL,NULL),(40662,'46048','S','Ingalls','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.954093,-85.795621,0,'2013-07-06 12:44:32',NULL,NULL),(1908,'00795','S','Est del Rio','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(32090,'35292','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.512500,-86.805024,0,'2013-07-06 12:44:32',NULL,NULL),(77345,'96725','S','Holualoa','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.619027,-155.953335,0,'2013-07-06 12:44:34',NULL,NULL),(29340,'32549','P','Ft Walton Bch','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.410303,-86.614571,0,'2013-07-06 12:44:32',NULL,NULL),(48073,'55330','S','Nowthen','A','Sherburne','27141','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.319200,-93.545280,0,'2013-07-06 12:44:33',NULL,NULL),(49277,'56510','S','Lockhart','A','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.298022,-96.510903,0,'2013-07-06 12:44:33',NULL,NULL),(49269,'56484','S','Onigum','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(44157,'49530','U','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866782,-85.544254,0,'2013-07-06 12:44:32',NULL,NULL),(20513,'21085','S','Joppa','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.431754,-76.355815,0,'2013-07-06 12:44:31',NULL,NULL),(31379,'34212','S','Lakewood Rch','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.471865,-82.412165,0,'2013-07-06 12:44:32',NULL,NULL),(24479,'27244','S','Ossipee','N','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.135017,-79.505282,0,'2013-07-06 12:44:31',NULL,NULL),(38080,'43071','S','Saint Louisvl','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.177388,-82.375739,0,'2013-07-06 12:44:32',NULL,NULL),(43402,'48449','S','Lennon','D','Genesee','26049','Michigan','MI','26','2640','989','Eastern',-5.0,'Y',42.996449,-83.949610,0,'2013-07-06 12:44:32',NULL,NULL),(28195,'31018','S','Riddleville','A','Washington','13303','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.983468,-82.599047,0,'2013-07-06 12:44:31',NULL,NULL),(36645,'41005','S','Limaburg','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.024812,-84.747372,0,'2013-07-06 12:44:32',NULL,NULL),(16230,'17074','S','Wila','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(32203,'35553','S','Double Spgs','A','Winston','01133','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.132870,-87.387518,0,'2013-07-06 12:44:32',NULL,NULL),(6579,'05855','S','West Derby','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.941733,-72.203234,0,'2013-07-06 12:44:30',NULL,NULL),(13611,'13862','S','Itaska','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.357840,-75.938160,0,'2013-07-06 12:44:31',NULL,NULL),(687,'00685','S','Bda Pueblo Nuevo','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(72407,'89045','S','Round Mtn','A','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.808300,-117.156300,0,'2013-07-06 12:44:34',NULL,NULL),(60195,'71418','S','Copenhagen','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(39195,'44326','U','Akron Public Lib','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.083101,-81.517487,0,'2013-07-06 12:44:32',NULL,NULL),(2602,'00961','S','Urb Rio Hondo 4','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.180752,-66.112215,0,'2013-07-06 12:44:30',NULL,NULL),(72347,'89018','P','Indian Spgs','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.570550,-115.669994,0,'2013-07-06 12:44:34',NULL,NULL),(21083,'22033','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.879674,-77.388079,0,'2013-07-06 12:44:31',NULL,NULL),(13092,'13471','S','Point Rock','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.395357,-75.611063,0,'2013-07-06 12:44:30',NULL,NULL),(9841,'10116','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(42909,'48105','S','Ann Arbor','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.306761,-83.700406,0,'2013-07-06 12:44:32',NULL,NULL),(78671,'98237','S','Concrete','D','Skagit','53057','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.522300,-121.753350,0,'2013-07-06 12:44:34',NULL,NULL),(19131,'19609','S','Springmont','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.324875,-75.998193,0,'2013-07-06 12:44:31',NULL,NULL),(57962,'67761','S','Wallace','D','Wallace','20199','Kansas','KS','20','0000','785','Mountain',-7.0,'Y',38.917299,-101.565301,0,'2013-07-06 12:44:33',NULL,NULL),(61034,'72117','S','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(43943,'49287','S','Tipton','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.029334,-84.086644,0,'2013-07-06 12:44:32',NULL,NULL),(32505,'36069','S','Ramer','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.094900,-86.282220,0,'2013-07-06 12:44:32',NULL,NULL),(19267,'19954','S','Houston','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',38.919187,-75.504777,0,'2013-07-06 12:44:31',NULL,NULL),(17985,'18621','S','Hunlock Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.226559,-76.014039,0,'2013-07-06 12:44:31',NULL,NULL),(59202,'70380','S','Morgan City','D','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.699185,-91.211040,0,'2013-07-06 12:44:33',NULL,NULL),(16404,'17223','S','Fort Littleton','D','Fulton','42057','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.060812,-77.970494,0,'2013-07-06 12:44:31',NULL,NULL),(34148,'38237','S','Martin','D','Weakley','47183','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.338425,-88.853587,0,'2013-07-06 12:44:32',NULL,NULL),(60856,'72047','S','Enola','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.217403,-92.213012,0,'2013-07-06 12:44:33',NULL,NULL),(27687,'30337','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.644256,-84.467351,0,'2013-07-06 12:44:31',NULL,NULL),(12630,'13092','S','Locke','D','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.658980,-76.424040,0,'2013-07-06 12:44:30',NULL,NULL),(70753,'85324','S','Black Cyn Cty','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.085943,-112.141600,0,'2013-07-06 12:44:34',NULL,NULL),(15813,'16929','S','E Lawrencevle','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.993999,-77.123186,0,'2013-07-06 12:44:31',NULL,NULL),(1637,'00771','S','Urb las Campinas II','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(42781,'48043','S','Mount Clemens','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.597080,-82.881654,0,'2013-07-06 12:44:32',NULL,NULL),(22662,'24277','S','Penningtn Gap','A','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.755012,-83.033078,0,'2013-07-06 12:44:31',NULL,NULL),(68250,'81059','S','Thatcher','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.498583,-104.151083,0,'2013-07-06 12:44:34',NULL,NULL),(55967,'64503','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.738976,-94.817292,0,'2013-07-06 12:44:33',NULL,NULL),(39780,'45123','S','Greenfield','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.333281,-83.413658,0,'2013-07-06 12:44:32',NULL,NULL),(78298,'97885','S','Wallowa','D','Wallowa','41063','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.568597,-117.528014,0,'2013-07-06 12:44:34',NULL,NULL),(71102,'85940','P','Vernon','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.255946,-109.692861,0,'2013-07-06 12:44:34',NULL,NULL),(39104,'44237','U','Hudson','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.254965,-81.481388,0,'2013-07-06 12:44:32',NULL,NULL),(2853,'00983','S','Villa Fontana','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(53925,'62401','S','Funkhouser','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(12628,'13090','S','Lvrpool','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(76783,'95942','S','Butte Meadows','A','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',40.089969,-121.531089,0,'2013-07-06 12:44:34',NULL,NULL),(34183,'38318','S','Buena Vista','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.937514,-88.270198,0,'2013-07-06 12:44:32',NULL,NULL),(64935,'77219','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.757160,-95.411957,0,'2013-07-06 12:44:34',NULL,NULL),(62638,'74563','S','Red Oak','D','Latimer','40077','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.942490,-95.080667,0,'2013-07-06 12:44:33',NULL,NULL),(18299,'19016','P','Chester','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.845630,-75.370818,0,'2013-07-06 12:44:31',NULL,NULL),(56483,'65326','S','Sagrada','N','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.167610,-93.149233,0,'2013-07-06 12:44:33',NULL,NULL),(55602,'63944','S','Greenville','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.092403,-90.451140,0,'2013-07-06 12:44:33',NULL,NULL),(54391,'62818','S','Browns','D','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.370994,-87.996316,0,'2013-07-06 12:44:33',NULL,NULL),(43124,'48230','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.394584,-82.918482,0,'2013-07-06 12:44:32',NULL,NULL),(77592,'96929','S','Barrigada','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.539783,144.899632,0,'2013-07-06 12:44:34',NULL,NULL),(2133,'00924','S','Urb Country Club','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(34099,'38173','P','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.143248,-90.054456,0,'2013-07-06 12:44:32',NULL,NULL),(68229,'81052','S','Kornman','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.958640,-102.578700,0,'2013-07-06 12:44:34',NULL,NULL),(35524,'39535','P','Boloxi','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.415255,-88.930352,0,'2013-07-06 12:44:32',NULL,NULL),(63018,'75173','S','Nevada','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.057445,-96.379449,0,'2013-07-06 12:44:33',NULL,NULL),(32120,'35441','S','Akron','D','Hale','01065','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.874480,-87.696780,0,'2013-07-06 12:44:32',NULL,NULL),(71172,'86040','P','Page','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.913751,-111.467162,0,'2013-07-06 12:44:34',NULL,NULL),(34176,'38313','S','Beech Bluff','D','Madison','47113','Tennessee','TN','47','3580','731','Central',-6.0,'Y',35.603980,-88.645457,0,'2013-07-06 12:44:32',NULL,NULL),(46486,'53222','S','Wawatosa','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084153,-88.036961,0,'2013-07-06 12:44:32',NULL,NULL),(15321,'16172','U','New Wilmington','D','Lawrence','42073','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.122710,-80.336002,0,'2013-07-06 12:44:31',NULL,NULL),(69100,'83254','S','Pegram','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(77043,'96109','S','Doyle','D','Lassen','06035','California','CA','06','0000','530','Pacific',-8.0,'Y',40.041563,-120.116174,0,'2013-07-06 12:44:34',NULL,NULL),(28635,'31750','S','Fitzgerald','D','Ben Hill','13017','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.714990,-83.253233,0,'2013-07-06 12:44:32',NULL,NULL),(47369,'54622','S','Cochrane','D','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.271780,-91.873200,0,'2013-07-06 12:44:32',NULL,NULL),(19726,'20395','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.859014,-76.975556,0,'2013-07-06 12:44:31',NULL,NULL),(61697,'72955','S','Uniontown','D','Crawford','05033','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.585182,-94.433559,0,'2013-07-06 12:44:33',NULL,NULL),(35713,'39668','S','Union Church','D','Jefferson','28063','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.709377,-90.826145,0,'2013-07-06 12:44:32',NULL,NULL),(57140,'66227','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.980518,-94.869055,0,'2013-07-06 12:44:33',NULL,NULL),(39716,'45052','S','Elizabethtown','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.141720,-84.756600,0,'2013-07-06 12:44:32',NULL,NULL),(41487,'46940','S','La Fontaine','D','Wabash','18169','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.674047,-85.721014,0,'2013-07-06 12:44:32',NULL,NULL),(44616,'50060','S','Cambria','N','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.758022,-93.318743,0,'2013-07-06 12:44:32',NULL,NULL),(16096,'17052','S','Bankstown','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.378094,-77.971536,0,'2013-07-06 12:44:31',NULL,NULL),(76693,'95823','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.481025,-121.444142,0,'2013-07-06 12:44:34',NULL,NULL),(23001,'24808','S','Anawalt','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.333193,-81.438739,0,'2013-07-06 12:44:31',NULL,NULL),(38225,'43224','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.040081,-82.966132,0,'2013-07-06 12:44:32',NULL,NULL),(31013,'33780','P','Pinellas Park','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.840000,-82.720795,0,'2013-07-06 12:44:32',NULL,NULL),(46231,'52777','S','Toronto','A','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.832932,-90.840574,0,'2013-07-06 12:44:32',NULL,NULL),(37646,'42167','S','Mud Lick','N','Monroe','21171','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.718537,-85.700436,0,'2013-07-06 12:44:32',NULL,NULL),(75681,'94553','S','Martinez','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.991280,-122.164320,0,'2013-07-06 12:44:34',NULL,NULL),(54974,'63122','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.584479,-90.414020,0,'2013-07-06 12:44:33',NULL,NULL),(14102,'14624','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.120619,-77.729488,0,'2013-07-06 12:44:31',NULL,NULL),(33368,'37204','S','Melrose','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108754,-86.780579,0,'2013-07-06 12:44:32',NULL,NULL),(23933,'26254','S','Wymer','A','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.893333,-79.618889,0,'2013-07-06 12:44:31',NULL,NULL),(77667,'97027','S','Gladstone','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.389810,-122.588846,0,'2013-07-06 12:44:34',NULL,NULL),(1336,'00736','S','Bo Farallon','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(19310,'20010','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.930413,-77.028189,0,'2013-07-06 12:44:31',NULL,NULL),(57320,'66710','S','Altoona','D','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.520445,-95.658609,0,'2013-07-06 12:44:33',NULL,NULL),(44795,'50227','S','Popejoy','D','Franklin','19069','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.599402,-93.437458,0,'2013-07-06 12:44:32',NULL,NULL),(79267,'98569','S','Ocean Shores','D','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.970702,-124.150812,0,'2013-07-06 12:44:34',NULL,NULL),(73629,'91411','S','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.179000,-118.447380,0,'2013-07-06 12:44:34',NULL,NULL),(32459,'36027','S','Bakerhill','A','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.884947,-85.153904,0,'2013-07-06 12:44:32',NULL,NULL),(66969,'79407','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.569595,-101.948489,0,'2013-07-06 12:44:34',NULL,NULL),(25310,'28159','S','Spencer','D','Rowan','37159','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.694549,-80.433281,0,'2013-07-06 12:44:31',NULL,NULL),(1979,'00902','P','Viejo San Juan','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.446284,-66.098281,0,'2013-07-06 12:44:30',NULL,NULL),(5014,'04228','S','East Livermore','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.400255,-70.128240,0,'2013-07-06 12:44:30',NULL,NULL),(13418,'13754','S','Tompkins','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(53959,'62427','S','Birds','A','Crawford','17033','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.900944,-87.672357,0,'2013-07-06 12:44:33',NULL,NULL),(32597,'36131','U','State Dept Industrial Relat','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.379353,-86.298504,0,'2013-07-06 12:44:32',NULL,NULL),(33936,'38068','S','Mason','A','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.241585,-89.359208,0,'2013-07-06 12:44:32',NULL,NULL),(3794,'02215','S','Boston University','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344927,-71.101619,0,'2013-07-06 12:44:30',NULL,NULL),(27765,'30364','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.675999,-84.461995,0,'2013-07-06 12:44:31',NULL,NULL),(71556,'87196','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.082837,-106.619087,0,'2013-07-06 12:44:34',NULL,NULL),(71035,'85739','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.221743,-110.926479,0,'2013-07-06 12:44:34',NULL,NULL),(66920,'79331','S','Lamesa','D','Dawson','48115','Texas','TX','48','0000','806','Central',-6.0,'Y',32.734510,-101.955850,0,'2013-07-06 12:44:34',NULL,NULL),(35080,'39202','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.310057,-90.176007,0,'2013-07-06 12:44:32',NULL,NULL),(42787,'48045','S','Sang','N','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(42356,'47670','S','Princeton','D','Gibson','18051','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.353193,-87.567259,0,'2013-07-06 12:44:32',NULL,NULL),(677,'00683','S','Urb Retiro','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(3157,'01263','U','Marion Fathers','N','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.289010,-73.319529,0,'2013-07-06 12:44:30',NULL,NULL),(76597,'95687','S','Vacaville','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.346229,-121.954425,0,'2013-07-06 12:44:34',NULL,NULL),(41899,'47371','S','New Mt Pleasant','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(40987,'46352','P','La Porte','D','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.621980,-86.695386,0,'2013-07-06 12:44:32',NULL,NULL),(42776,'48041','S','Memphis','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.924364,-82.781340,0,'2013-07-06 12:44:32',NULL,NULL),(28056,'30669','S','Union Point','D','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.644580,-83.085879,0,'2013-07-06 12:44:31',NULL,NULL),(57933,'67732','S','Brewster','D','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.361269,-101.375215,0,'2013-07-06 12:44:33',NULL,NULL),(35620,'39603','P','Brookhaven','D','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.577695,-90.477599,0,'2013-07-06 12:44:32',NULL,NULL),(38458,'43612','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.702832,-83.539208,0,'2013-07-06 12:44:32',NULL,NULL),(50190,'57567','S','Plum Creek','N','Haakon','46055','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.039632,-101.663435,0,'2013-07-06 12:44:33',NULL,NULL),(13804,'14207','S','Town of Tonawanda','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.945566,-78.896412,0,'2013-07-06 12:44:31',NULL,NULL),(30657,'33462','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.581130,-80.079020,0,'2013-07-06 12:44:32',NULL,NULL),(70408,'84719','P','Brian Head','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.698178,-112.849139,0,'2013-07-06 12:44:34',NULL,NULL),(23260,'25130','S','Madison','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.061200,-81.820332,0,'2013-07-06 12:44:31',NULL,NULL),(25379,'28256','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.283183,-80.730649,0,'2013-07-06 12:44:31',NULL,NULL),(53496,'62009','S','Benld','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.091339,-89.805938,0,'2013-07-06 12:44:33',NULL,NULL),(36392,'40492','P','Wildie','D','Rockcastle','21203','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.420572,-84.299702,0,'2013-07-06 12:44:32',NULL,NULL),(26810,'29472','S','Ridgeville','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.092825,-80.316503,0,'2013-07-06 12:44:31',NULL,NULL),(57800,'67501','S','Willowbrook','A','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.056168,-97.912213,0,'2013-07-06 12:44:33',NULL,NULL),(1533,'00757','S','Alt de Santa Isabel','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(76150,'95303','S','Ballico','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.447804,-120.686746,0,'2013-07-06 12:44:34',NULL,NULL),(41703,'47229','S','Retreat','N','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.792996,-85.841879,0,'2013-07-06 12:44:32',NULL,NULL),(17814,'18410','P','Chinchilla','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.477461,-75.685159,0,'2013-07-06 12:44:31',NULL,NULL),(30742,'33544','S','Zephyrhills','A','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.269457,-82.319078,0,'2013-07-06 12:44:32',NULL,NULL),(22866,'24556','S','Goode','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.366667,-79.391704,0,'2013-07-06 12:44:31',NULL,NULL),(14516,'15202','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.501271,-80.066474,0,'2013-07-06 12:44:31',NULL,NULL),(47049,'54412','S','Auburndale','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.636525,-90.004530,0,'2013-07-06 12:44:32',NULL,NULL),(74245,'92328','S','Stove Pipe Wells','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.425648,-117.090213,0,'2013-07-06 12:44:34',NULL,NULL),(11624,'12110','S','Newtonville','A','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.747077,-73.767886,0,'2013-07-06 12:44:30',NULL,NULL),(48894,'56116','S','Beaver Creek','D','Rock','27133','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.629992,-96.373627,0,'2013-07-06 12:44:33',NULL,NULL),(42478,'47834','S','Wey Lake','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(19649,'20277','U','Washington Dc Brm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.882540,-77.017002,0,'2013-07-06 12:44:31',NULL,NULL),(58997,'70059','P','Harvey','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.904042,-90.079366,0,'2013-07-06 12:44:33',NULL,NULL),(18044,'18657','S','Tunkhannock','D','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(11686,'12154','S','Schaghticoke','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.897909,-73.589565,0,'2013-07-06 12:44:30',NULL,NULL),(58046,'68025','S','Inglewood','A','Dodge','31053','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.441269,-96.494304,0,'2013-07-06 12:44:33',NULL,NULL),(55016,'63134','S','Berkeley','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.738992,-90.342092,0,'2013-07-06 12:44:33',NULL,NULL),(21066,'21921','S','Elkton','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.626375,-75.849604,0,'2013-07-06 12:44:31',NULL,NULL),(42476,'47834','S','Stearleyville','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(3073,'01138','P','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.088597,-72.561028,0,'2013-07-06 12:44:30',NULL,NULL),(70649,'85190','P','Tortilla Flat','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.414513,-111.581113,0,'2013-07-06 12:44:34',NULL,NULL),(69716,'84036','S','Tuhaye','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(25239,'28104','S','Matthews','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.116667,-80.723889,0,'2013-07-06 12:44:31',NULL,NULL),(21796,'23081','P','Jamestown','D','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.224814,-76.781576,0,'2013-07-06 12:44:31',NULL,NULL),(18699,'19193','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955683,-75.184056,0,'2013-07-06 12:44:31',NULL,NULL),(26470,'29150','S','Highway Four Forty One','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',33.877080,-80.257500,0,'2013-07-06 12:44:31',NULL,NULL),(25733,'28554','P','Maury','D','Greene','37079','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.482968,-77.586178,0,'2013-07-06 12:44:31',NULL,NULL),(32416,'35971','S','Lakeview','A','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.506569,-85.904300,0,'2013-07-06 12:44:32',NULL,NULL),(62257,'74006','S','Bartlesville','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.738109,-95.933260,0,'2013-07-06 12:44:33',NULL,NULL),(16409,'17224','S','Fort Loudon','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(8147,'07845','P','Ironia','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.830131,-74.626833,0,'2013-07-06 12:44:30',NULL,NULL),(2088,'00922','P','Caparra','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409982,-66.092553,0,'2013-07-06 12:44:30',NULL,NULL),(68551,'81428','S','Bowie','N','Delta','08029','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.895300,-107.587980,0,'2013-07-06 12:44:34',NULL,NULL),(36838,'41073','S','Newport','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.101923,-84.482010,0,'2013-07-06 12:44:32',NULL,NULL),(60573,'71764','S','Stephens','D','Ouachita','05103','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.418904,-93.030723,0,'2013-07-06 12:44:33',NULL,NULL),(57423,'66778','S','Melrose','N','Cherokee','20021','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.003569,-94.844982,0,'2013-07-06 12:44:33',NULL,NULL),(55213,'63401','S','Hannibal','D','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(29047,'32236','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.306054,-81.729965,0,'2013-07-06 12:44:32',NULL,NULL),(27010,'29639','S','Due West','D','Abbeville','45001','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.334985,-82.382073,0,'2013-07-06 12:44:31',NULL,NULL),(19895,'20539','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898392,-77.028592,0,'2013-07-06 12:44:31',NULL,NULL),(49810,'57201','S','Pelican','N','Codington','46029','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.902615,-97.121324,0,'2013-07-06 12:44:33',NULL,NULL),(70874,'85607','S','Bay Acres','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.351622,-109.543515,0,'2013-07-06 12:44:34',NULL,NULL),(30129,'33163','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.964602,-80.142184,0,'2013-07-06 12:44:32',NULL,NULL),(28792,'32053','S','Jennings','D','Hamilton','12047','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.562359,-83.247328,0,'2013-07-06 12:44:32',NULL,NULL),(19606,'20232','U','Resolutn Trust Oversight Brd','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.919252,-77.036045,0,'2013-07-06 12:44:31',NULL,NULL),(50556,'58206','P','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.899294,-97.067616,0,'2013-07-06 12:44:33',NULL,NULL),(347,'00656','S','Urb Monte Claro','N','Guayanilla','72059','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.025970,-66.787588,0,'2013-07-06 12:44:30',NULL,NULL),(51923,'60117','U','Great Lakes Area Office','N','DuPage','17043','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.945790,-88.084824,0,'2013-07-06 12:44:33',NULL,NULL),(654,'00683','S','Ext Mans San German','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(17294,'17851','S','Diamondtown','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(61577,'72739','S','Hiwasse','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.478701,-94.328444,0,'2013-07-06 12:44:33',NULL,NULL),(56291,'65078','S','Stover','D','Morgan','29141','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.444823,-92.992709,0,'2013-07-06 12:44:33',NULL,NULL),(35315,'39422','S','Bay Springs','D','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.945464,-89.199718,0,'2013-07-06 12:44:32',NULL,NULL),(56087,'64769','S','Mindenmines','D','Barton','29011','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.421285,-94.557183,0,'2013-07-06 12:44:33',NULL,NULL),(35803,'39759','S','Bells School','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(20935,'21757','S','Keymar','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.601199,-77.254452,0,'2013-07-06 12:44:31',NULL,NULL),(63374,'75644','S','East Mountain','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(59373,'70592','S','Youngsville','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.099803,-92.000885,0,'2013-07-06 12:44:33',NULL,NULL),(47912,'55110','S','Grant Township','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(11921,'12419','S','Cottekill','D','Ulster','36111','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.850267,-74.115043,0,'2013-07-06 12:44:30',NULL,NULL),(14294,'14876','P','Reading Center','D','Schuyler','36097','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.433722,-76.950153,0,'2013-07-06 12:44:31',NULL,NULL),(45845,'52224','S','Dysart','D','Tama','19171','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.168794,-92.307308,0,'2013-07-06 12:44:32',NULL,NULL),(35198,'39288','P','Jksn','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.300020,-90.145549,0,'2013-07-06 12:44:32',NULL,NULL),(40326,'45481','U','Dayton Courtesy Reply Mail','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.757610,-84.178798,0,'2013-07-06 12:44:32',NULL,NULL),(75190,'93614','S','Coarsegold','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.212480,-119.732948,0,'2013-07-06 12:44:34',NULL,NULL),(63019,'75180','S','Balch Springs','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.717417,-96.619426,0,'2013-07-06 12:44:33',NULL,NULL),(53199,'61611','S','Robein','N','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.661495,-89.554256,0,'2013-07-06 12:44:33',NULL,NULL),(61793,'73084','S','Spencer','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.515551,-97.346404,0,'2013-07-06 12:44:33',NULL,NULL),(19099,'19605','S','Muhlenburg Park','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.386040,-75.932598,0,'2013-07-06 12:44:31',NULL,NULL),(47761,'55031','S','Hampton','D','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.606486,-93.000228,0,'2013-07-06 12:44:33',NULL,NULL),(68388,'81149','S','Saguache','D','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.081430,-106.131788,0,'2013-07-06 12:44:34',NULL,NULL),(1395,'00738','S','Urb Altamira','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(30492,'33388','S','Broward Mall','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.117073,-80.254184,0,'2013-07-06 12:44:32',NULL,NULL),(22652,'24266','S','Carterton','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.890460,-82.084560,0,'2013-07-06 12:44:31',NULL,NULL),(50412,'57783','S','Spearfish','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.494780,-103.867617,0,'2013-07-06 12:44:33',NULL,NULL),(12572,'13063','S','Fabius','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.855288,-75.987549,0,'2013-07-06 12:44:30',NULL,NULL),(41692,'47203','S','Columbus','D','Bartholomew','18005','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.233901,-85.876002,0,'2013-07-06 12:44:32',NULL,NULL),(14001,'14519','S','Ontario','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.235743,-77.302362,0,'2013-07-06 12:44:31',NULL,NULL),(994,'00717','S','Bo San Anton','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(15377,'16312','P','Chandlrs Vly','A','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.932606,-79.304327,0,'2013-07-06 12:44:31',NULL,NULL),(16571,'17317','P','East Prospect','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.968240,-76.521232,0,'2013-07-06 12:44:31',NULL,NULL),(78073,'97466','S','Powers','D','Coos','41011','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.882288,-124.073274,0,'2013-07-06 12:44:34',NULL,NULL),(25917,'28647','P','Linville Falls','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.956741,-81.944180,0,'2013-07-06 12:44:31',NULL,NULL),(75330,'93786','U','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.638642,-119.903110,0,'2013-07-06 12:44:34',NULL,NULL),(74974,'93437','S','Vandenberg Air Force Base','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.738800,-120.525060,0,'2013-07-06 12:44:34',NULL,NULL),(11791,'12214','U','Albany Brm','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.686317,-73.846929,0,'2013-07-06 12:44:30',NULL,NULL),(23708,'25878','P','Midway','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.717778,-81.219167,0,'2013-07-06 12:44:31',NULL,NULL),(33032,'36732','S','Demopolis','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.508129,-87.836342,0,'2013-07-06 12:44:32',NULL,NULL),(33410,'37234','U','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.150333,-86.790926,0,'2013-07-06 12:44:32',NULL,NULL),(75599,'94303','S','E Palo Alto','A','Santa Clara','06085','California','CA','06','7360','650','Pacific',-8.0,'Y',37.449360,-122.125260,0,'2013-07-06 12:44:34',NULL,NULL),(58160,'68180','U','Blue Cross Blue Shield','N','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.233224,-96.053004,0,'2013-07-06 12:44:33',NULL,NULL),(53290,'61727','S','Ospur','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(52077,'60401','S','Goodenow','N','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.355724,-87.607332,0,'2013-07-06 12:44:33',NULL,NULL),(50699,'58357','S','Oberon','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.961515,-99.163469,0,'2013-07-06 12:44:33',NULL,NULL),(51145,'58843','S','Spring Brook','A','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.242437,-103.343766,0,'2013-07-06 12:44:33',NULL,NULL),(25800,'28606','S','Boomer','D','Wilkes','37193','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.226493,-81.099183,0,'2013-07-06 12:44:31',NULL,NULL),(66268,'78578','S','Laguna Heights','A','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.084744,-97.241580,0,'2013-07-06 12:44:34',NULL,NULL),(44732,'50158','S','Marshalltown','D','Marshall','19127','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.055920,-92.940600,0,'2013-07-06 12:44:32',NULL,NULL),(51897,'60099','S','Beach Park','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.450382,-87.859034,0,'2013-07-06 12:44:33',NULL,NULL),(48357,'55486','U','Us Bank','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.974141,-93.267706,0,'2013-07-06 12:44:33',NULL,NULL),(31107,'33884','S','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.999605,-81.679242,0,'2013-07-06 12:44:32',NULL,NULL),(15143,'15853','S','Ridgway','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.457360,-78.726660,0,'2013-07-06 12:44:31',NULL,NULL),(61918,'73149','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.392069,-97.490844,0,'2013-07-06 12:44:33',NULL,NULL),(59134,'70164','U','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.003600,-90.002730,0,'2013-07-06 12:44:33',NULL,NULL),(33982,'38113','P','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.209681,-89.996175,0,'2013-07-06 12:44:32',NULL,NULL),(47867,'55082','S','Oak Park Hgts','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(15899,'17011','S','Camp Hill','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.240066,-76.930386,0,'2013-07-06 12:44:31',NULL,NULL),(30756,'33567','S','Plant City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.935820,-82.126812,0,'2013-07-06 12:44:32',NULL,NULL),(63293,'75560','S','Douglassville','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.190651,-94.354656,0,'2013-07-06 12:44:33',NULL,NULL),(23351,'25261','S','Millstone','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.854513,-81.077711,0,'2013-07-06 12:44:31',NULL,NULL),(49364,'56583','S','Tenney','A','Traverse','27155','Minnesota','MN','27','0000','218','Central',-6.0,'Y',45.986280,-96.405780,0,'2013-07-06 12:44:33',NULL,NULL),(30407,'33324','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.110295,-80.270027,0,'2013-07-06 12:44:32',NULL,NULL),(67311,'80022','S','Irondale','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.831897,-104.894182,0,'2013-07-06 12:44:34',NULL,NULL),(59214,'70397','S','Theriot','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.416105,-90.779879,0,'2013-07-06 12:44:33',NULL,NULL),(23510,'25541','S','Milton','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.438748,-82.142932,0,'2013-07-06 12:44:31',NULL,NULL),(73470,'91309','P','Canoga Park','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.218100,-118.595483,0,'2013-07-06 12:44:34',NULL,NULL),(27704,'30340','S','ATL','N','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.891239,-84.250847,0,'2013-07-06 12:44:31',NULL,NULL),(71819,'87573','S','Tererro','D','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.775048,-105.625041,0,'2013-07-06 12:44:34',NULL,NULL),(14210,'14781','S','Sherman','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.158808,-79.597595,0,'2013-07-06 12:44:31',NULL,NULL),(25858,'28628','P','Glen Alpine','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.721926,-81.782025,0,'2013-07-06 12:44:31',NULL,NULL),(8623,'08251','S','Miami Beach','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.023220,-74.931300,0,'2013-07-06 12:44:30',NULL,NULL),(50238,'57623','S','Dupree','D','Ziebach','46137','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.990004,-101.647447,0,'2013-07-06 12:44:33',NULL,NULL),(6746,'06082','S','Scitico','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986942,-72.565275,0,'2013-07-06 12:44:30',NULL,NULL),(32729,'36314','S','Black','D','Geneva','01061','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.008169,-85.746883,0,'2013-07-06 12:44:32',NULL,NULL),(4414,'03226','S','Centre Harbor','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715187,-71.492553,0,'2013-07-06 12:44:30',NULL,NULL),(30085,'33156','S','Pinecrest','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.665235,-80.301146,0,'2013-07-06 12:44:32',NULL,NULL),(51603,'59825','S','Clinton','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.761060,-113.677380,0,'2013-07-06 12:44:33',NULL,NULL),(47185,'54481','S','Whiting','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(67023,'79535','S','Maryneal','D','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.164395,-100.550022,0,'2013-07-06 12:44:34',NULL,NULL),(67472,'80224','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.687700,-104.909814,0,'2013-07-06 12:44:34',NULL,NULL),(8414,'08072','P','Quinton','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.556788,-75.404719,0,'2013-07-06 12:44:30',NULL,NULL),(69796,'84066','S','Ioka','N','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.298824,-109.998125,0,'2013-07-06 12:44:34',NULL,NULL),(62748,'74842','P','Fittstown','D','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.623212,-96.673660,0,'2013-07-06 12:44:33',NULL,NULL),(59810,'71227','S','Cartwright','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.496780,-92.473320,0,'2013-07-06 12:44:33',NULL,NULL),(78231,'97814','S','Baker','N','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.779688,-117.834287,0,'2013-07-06 12:44:34',NULL,NULL),(72869,'90008','S','Baldwin Hills','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006715,-118.339229,0,'2013-07-06 12:44:34',NULL,NULL),(27730,'30350','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.975825,-84.325274,0,'2013-07-06 12:44:31',NULL,NULL),(67615,'80435','S','Keystone','A','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.618708,-106.041714,0,'2013-07-06 12:44:34',NULL,NULL),(61608,'72776','S','Witter','D','Madison','05087','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.939190,-93.603214,0,'2013-07-06 12:44:33',NULL,NULL),(57042,'66209','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(74667,'92860','S','Norco','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.925624,-117.552211,0,'2013-07-06 12:44:34',NULL,NULL),(59297,'70506','S','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.209397,-92.065502,0,'2013-07-06 12:44:33',NULL,NULL),(59615,'71029','S','Gilliam','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.805224,-93.830904,0,'2013-07-06 12:44:33',NULL,NULL),(19980,'20598','U','DHS','D','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(5623,'04941','S','Montville','A','Waldo','23027','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.466565,-69.309221,0,'2013-07-06 12:44:30',NULL,NULL),(74493,'92623','P','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.694249,-117.812612,0,'2013-07-06 12:44:34',NULL,NULL),(10737,'11356','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.786000,-73.844070,0,'2013-07-06 12:44:30',NULL,NULL),(38998,'44135','S','Riveredge','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.434425,-81.801820,0,'2013-07-06 12:44:32',NULL,NULL),(2109,'00923','S','Urb Valencia','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(54367,'62806','S','Albion','D','Edwards','17047','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.377481,-88.056083,0,'2013-07-06 12:44:33',NULL,NULL),(16170,'17065','S','Mount Holly Spgs','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.117148,-77.192329,0,'2013-07-06 12:44:31',NULL,NULL),(39158,'44301','S','Akron','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.043261,-81.521198,0,'2013-07-06 12:44:32',NULL,NULL),(79553,'99004','S','Tyler','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.439420,-117.627360,0,'2013-07-06 12:44:34',NULL,NULL),(16619,'17331','S','Jacobs Mills','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(60222,'71427','S','Flatwoods','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.389387,-92.875928,0,'2013-07-06 12:44:33',NULL,NULL),(25526,'28394','S','Vass','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.242723,-79.227747,0,'2013-07-06 12:44:31',NULL,NULL),(21197,'22192','S','Prince William','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.680010,-77.309022,0,'2013-07-06 12:44:31',NULL,NULL),(6150,'05468','S','Georgia','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.639211,-73.136914,0,'2013-07-06 12:44:30',NULL,NULL),(30122,'33162','S','Mia Shrs','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(4244,'02872','P','Prudence Island','D','Bristol','44001','Rhode Island','RI','44','0000','401','Eastern',-5.0,'Y',41.614191,-71.315427,0,'2013-07-06 12:44:30',NULL,NULL),(10938,'11434','S','Rochdale Vill','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.677047,-73.778208,0,'2013-07-06 12:44:30',NULL,NULL),(42572,'47876','P','St Mary of the Woods','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.511739,-87.474237,0,'2013-07-06 12:44:32',NULL,NULL),(75716,'94581','P','Napa','D','Napa','06055','California','CA','06','8720','707','Pacific',-8.0,'Y',38.297277,-122.287663,0,'2013-07-06 12:44:34',NULL,NULL),(72363,'89026','U','Jean','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.778436,-115.325816,0,'2013-07-06 12:44:34',NULL,NULL),(73224,'90632','P','La Habra','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.914328,-117.954717,0,'2013-07-06 12:44:34',NULL,NULL),(19053,'19544','P','Mount Aetna','D','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.418727,-76.295812,0,'2013-07-06 12:44:31',NULL,NULL),(44406,'49822','S','Deerton','D','Alger','26003','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.449225,-87.006293,0,'2013-07-06 12:44:32',NULL,NULL),(46698,'53788','U','Madison Gas and Electric','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.075177,-89.378400,0,'2013-07-06 12:44:32',NULL,NULL),(77445,'96809','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.305003,-157.859366,0,'2013-07-06 12:44:34',NULL,NULL),(73002,'90062','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.006750,-118.307195,0,'2013-07-06 12:44:34',NULL,NULL),(24768,'27552','P','Mamers','D','Harnett','37085','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.420060,-78.934329,0,'2013-07-06 12:44:31',NULL,NULL),(76751,'95920','S','Afton','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.463470,-121.943844,0,'2013-07-06 12:44:34',NULL,NULL),(13337,'13685','S','Boultons Beach','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.943471,-76.111664,0,'2013-07-06 12:44:30',NULL,NULL),(70432,'84736','P','Henrieville','D','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.561268,-111.995387,0,'2013-07-06 12:44:34',NULL,NULL),(27446,'30120','S','Euharlee','A','Bartow','13015','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.177555,-84.854308,0,'2013-07-06 12:44:31',NULL,NULL),(66356,'78614','S','Bebe','A','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.420313,-97.554007,0,'2013-07-06 12:44:34',NULL,NULL),(57702,'67337','S','Angola','N','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.039645,-95.630692,0,'2013-07-06 12:44:33',NULL,NULL),(42605,'47885','S','Toad Hop','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(20235,'20777','S','Highland','D','Howard','24027','Maryland','MD','24','0720','301/240/227','Eastern',-5.0,'Y',39.183211,-76.968505,0,'2013-07-06 12:44:31',NULL,NULL),(59714,'71106','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.426395,-93.738506,0,'2013-07-06 12:44:33',NULL,NULL),(37212,'41524','S','Fedscreek','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.368780,-82.262100,0,'2013-07-06 12:44:32',NULL,NULL),(49620,'56904','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(67268,'79978','U','El Paso Natural Gas','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.760770,-106.488302,0,'2013-07-06 12:44:34',NULL,NULL),(73841,'91789','S','Diamond Bar','A','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.014965,-117.856127,0,'2013-07-06 12:44:34',NULL,NULL),(67796,'80731','S','Haxtun','D','Phillips','08095','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.640627,-102.627341,0,'2013-07-06 12:44:34',NULL,NULL),(50765,'58421','S','Bordulac','A','Foster','38031','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.448882,-99.124405,0,'2013-07-06 12:44:33',NULL,NULL),(77413,'96792','S','Nanakuli','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.440282,-158.186378,0,'2013-07-06 12:44:34',NULL,NULL),(10220,'10459','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.827628,-73.896045,0,'2013-07-06 12:44:30',NULL,NULL),(76760,'95925','S','Woodleaf','N','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.467748,-121.207569,0,'2013-07-06 12:44:34',NULL,NULL),(8846,'08641','S','Trenton','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',40.027821,-74.570679,0,'2013-07-06 12:44:30',NULL,NULL),(21567,'22821','S','Montezuma','A','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.417387,-78.954792,0,'2013-07-06 12:44:31',NULL,NULL),(12687,'13135','S','Hinmansville','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.261500,-76.325220,0,'2013-07-06 12:44:30',NULL,NULL),(35850,'39818','P','Bdge','N','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.908890,-84.578618,0,'2013-07-06 12:44:32',NULL,NULL),(20971,'21791','S','Union Bridge','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.544988,-77.194309,0,'2013-07-06 12:44:31',NULL,NULL),(74344,'92407','S','Devore Hghts','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.183703,-117.342519,0,'2013-07-06 12:44:34',NULL,NULL),(20964,'21784','S','Gaither','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.338199,-76.972300,0,'2013-07-06 12:44:31',NULL,NULL),(19666,'20317','U','Soldiers Airmens Home','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.942652,-77.012337,0,'2013-07-06 12:44:31',NULL,NULL),(55831,'64152','S','Wthrby Lake','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.218160,-94.730700,0,'2013-07-06 12:44:33',NULL,NULL),(2043,'00918','S','Urb Jb Huyke','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.417375,-66.061221,0,'2013-07-06 12:44:30',NULL,NULL),(10958,'11509','S','Atlantic Bch','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.592092,-73.728017,0,'2013-07-06 12:44:30',NULL,NULL),(5730,'05032','S','Lillieville','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.810080,-72.656700,0,'2013-07-06 12:44:30',NULL,NULL),(40836,'46216','S','Oaklandon','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861466,-86.014172,0,'2013-07-06 12:44:32',NULL,NULL),(33065,'36766','P','Oak Hill','D','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.921413,-87.086669,0,'2013-07-06 12:44:32',NULL,NULL),(23943,'26268','S','Glady','D','Randolph','54083','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.822152,-79.706701,0,'2013-07-06 12:44:31',NULL,NULL),(62293,'74020','S','Westport','N','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.273480,-96.430080,0,'2013-07-06 12:44:33',NULL,NULL),(39279,'44481','S','Warren','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.241420,-80.857080,0,'2013-07-06 12:44:32',NULL,NULL),(80141,'99780','S','Tok','D','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.330000,-142.980000,0,'2013-07-06 12:44:34',NULL,NULL),(18276,'19012','S','Cheltenham','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.058426,-75.105976,0,'2013-07-06 12:44:31',NULL,NULL),(32356,'35815','P','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.640498,-86.564791,0,'2013-07-06 12:44:32',NULL,NULL),(71954,'87943','S','Winston','D','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.338611,-107.677222,0,'2013-07-06 12:44:34',NULL,NULL),(6398,'05733','S','Goshen','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.798620,-73.094520,0,'2013-07-06 12:44:30',NULL,NULL),(57657,'67208','S','Eastborough','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.703821,-97.277212,0,'2013-07-06 12:44:33',NULL,NULL),(48999,'56241','S','Hazel Run','A','Yellow Medicine','27173','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.808478,-95.548738,0,'2013-07-06 12:44:33',NULL,NULL),(45496,'51357','S','Royal','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.038840,-95.236980,0,'2013-07-06 12:44:32',NULL,NULL),(42239,'47567','S','Willisville','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.465400,-87.320700,0,'2013-07-06 12:44:32',NULL,NULL),(38786,'44056','S','Northfield','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.313720,-81.496140,0,'2013-07-06 12:44:32',NULL,NULL),(33337,'37161','U','National Pen Company','N','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.484443,-86.461170,0,'2013-07-06 12:44:32',NULL,NULL),(30185,'33177','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.592736,-80.405844,0,'2013-07-06 12:44:32',NULL,NULL),(3208,'01360','S','N Field','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.700499,-72.450887,0,'2013-07-06 12:44:30',NULL,NULL),(69902,'84106','S','South Salt Lake','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.702966,-111.856027,0,'2013-07-06 12:44:34',NULL,NULL),(61281,'72394','S','Round Pond','A','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.022701,-90.686118,0,'2013-07-06 12:44:33',NULL,NULL),(59017,'70075','S','Cypress Gardens','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948870,-89.898600,0,'2013-07-06 12:44:33',NULL,NULL),(41130,'46619','S','South Bend','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.665548,-86.322304,0,'2013-07-06 12:44:32',NULL,NULL),(57034,'66208','S','Prairie Village','D','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(39831,'45155','P','Mowrystown','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.039634,-83.749616,0,'2013-07-06 12:44:32',NULL,NULL),(3755,'02180','S','Stoneham','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.482637,-71.096392,0,'2013-07-06 12:44:30',NULL,NULL),(18500,'19096','S','Wynnewood','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002510,-75.273155,0,'2013-07-06 12:44:31',NULL,NULL),(61817,'73106','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483548,-97.534998,0,'2013-07-06 12:44:33',NULL,NULL),(34792,'38871','S','Hurricane','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.310044,-89.158801,0,'2013-07-06 12:44:32',NULL,NULL),(59095,'70126','S','Chef Menteur','N','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.017111,-90.019351,0,'2013-07-06 12:44:33',NULL,NULL),(41529,'46990','S','Urbana','D','Wabash','18169','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.901903,-85.719800,0,'2013-07-06 12:44:32',NULL,NULL),(77894,'97291','P','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.547380,-122.726171,0,'2013-07-06 12:44:34',NULL,NULL),(71489,'87103','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.209758,-106.629701,0,'2013-07-06 12:44:34',NULL,NULL),(24916,'27803','S','Rocky Mount','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.930266,-77.833897,0,'2013-07-06 12:44:31',NULL,NULL),(53903,'62363','S','Time','N','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.609331,-90.807822,0,'2013-07-06 12:44:33',NULL,NULL),(53610,'62082','S','Barrow','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.479516,-90.373279,0,'2013-07-06 12:44:33',NULL,NULL),(67164,'79832','U','Sul Ross State Univ','N','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',30.362350,-103.672744,0,'2013-07-06 12:44:34',NULL,NULL),(74030,'92135','S','Nas N Island','A','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.699246,-117.185174,0,'2013-07-06 12:44:34',NULL,NULL),(46748,'53925','S','Columbus','D','Columbia','55021','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.337270,-89.028562,0,'2013-07-06 12:44:32',NULL,NULL),(80140,'99780','S','Mentasta Lake','A','Southeast Fairbanks','02240','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.330000,-142.980000,0,'2013-07-06 12:44:34',NULL,NULL),(63685,'75861','S','Tennessee Colony','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.885591,-95.920349,0,'2013-07-06 12:44:34',NULL,NULL),(61458,'72624','S','Compton','D','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.084866,-93.306736,0,'2013-07-06 12:44:33',NULL,NULL),(49268,'56484','S','Leech Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.124271,-94.607274,0,'2013-07-06 12:44:33',NULL,NULL),(21843,'23129','S','Oilville','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.707016,-77.779889,0,'2013-07-06 12:44:31',NULL,NULL),(4012,'02557','S','Oak Bluffs','D','Dukes','25007','Massachusetts','MA','25','0000','508/774','Eastern',-5.0,'Y',41.453677,-70.563360,0,'2013-07-06 12:44:30',NULL,NULL),(39433,'44683','S','Roanoke','N','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.392715,-81.347949,0,'2013-07-06 12:44:32',NULL,NULL),(21771,'23062','S','Glou Point','A','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.256502,-76.493791,0,'2013-07-06 12:44:31',NULL,NULL),(27340,'30042','P','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.923544,-84.073020,0,'2013-07-06 12:44:31',NULL,NULL),(56705,'65668','S','Hermitage','D','Hickory','29085','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.937897,-93.318670,0,'2013-07-06 12:44:33',NULL,NULL),(53826,'62298','S','Wartburg','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.339290,-90.151530,0,'2013-07-06 12:44:33',NULL,NULL),(22041,'23303','S','Atlantic','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.901730,-75.509132,0,'2013-07-06 12:44:31',NULL,NULL),(39790,'45133','S','East Danville','N','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.165420,-83.571180,0,'2013-07-06 12:44:32',NULL,NULL),(32887,'36530','S','Miflin','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.405780,-87.586380,0,'2013-07-06 12:44:32',NULL,NULL),(78297,'97884','S','Unity','D','Baker','41001','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.435130,-118.191101,0,'2013-07-06 12:44:34',NULL,NULL),(10119,'10259','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754165,-73.973439,0,'2013-07-06 12:44:30',NULL,NULL),(54882,'63066','P','Morse Mill','D','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.278052,-90.653066,0,'2013-07-06 12:44:33',NULL,NULL),(27947,'30538','S','Eastanollee','D','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.498181,-83.256207,0,'2013-07-06 12:44:31',NULL,NULL),(69754,'84050','S','Mtn Green','A','Morgan','49029','Utah','UT','49','0000','801/385','Mountain',-7.0,'Y',41.029860,-111.731880,0,'2013-07-06 12:44:34',NULL,NULL),(32715,'36302','P','Dothan','D','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.227185,-85.395884,0,'2013-07-06 12:44:32',NULL,NULL),(63190,'75423','S','Celeste','D','Hunt','48231','Texas','TX','48','1920','903/430','Central',-6.0,'Y',33.294316,-96.198477,0,'2013-07-06 12:44:33',NULL,NULL),(17284,'17846','S','Sereno','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.135280,-76.519320,0,'2013-07-06 12:44:31',NULL,NULL),(46676,'53725','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.050369,-89.397499,0,'2013-07-06 12:44:32',NULL,NULL),(10753,'11360','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.776438,-73.780380,0,'2013-07-06 12:44:30',NULL,NULL),(8496,'08096','S','Jericho','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(35095,'39206','S','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.364777,-90.171740,0,'2013-07-06 12:44:32',NULL,NULL),(42503,'47842','S','Summit Grove','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(16798,'17540','S','Oregon','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.095709,-76.185401,0,'2013-07-06 12:44:31',NULL,NULL),(78478,'98093','P','Federal Way','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.301949,-122.358826,0,'2013-07-06 12:44:34',NULL,NULL),(76566,'95670','S','Nimbus','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.603520,-121.248060,0,'2013-07-06 12:44:34',NULL,NULL),(69808,'84070','S','White City','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.571551,-111.884711,0,'2013-07-06 12:44:34',NULL,NULL),(30660,'33463','S','Green Acres','N','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.593980,-80.127720,0,'2013-07-06 12:44:32',NULL,NULL),(10817,'11377','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.743107,-73.906134,0,'2013-07-06 12:44:30',NULL,NULL),(43181,'48301','S','Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.541806,-83.281957,0,'2013-07-06 12:44:32',NULL,NULL),(75184,'93610','S','Chowchilla','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',37.110099,-120.262938,0,'2013-07-06 12:44:34',NULL,NULL),(63770,'75948','S','Fairdale','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.308720,-93.771600,0,'2013-07-06 12:44:34',NULL,NULL),(43759,'49017','S','Battle Creek','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.325907,-85.181060,0,'2013-07-06 12:44:32',NULL,NULL),(7791,'07428','P','Mc Afee','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.185381,-74.551549,0,'2013-07-06 12:44:30',NULL,NULL),(71239,'86340','P','Sedona','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.864350,-111.798180,0,'2013-07-06 12:44:34',NULL,NULL),(64247,'76366','S','Dundee','N','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.620220,-98.689800,0,'2013-07-06 12:44:34',NULL,NULL),(26408,'29114','S','McKenzie Crossroads','N','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.927712,-79.905262,0,'2013-07-06 12:44:31',NULL,NULL),(8164,'07860','S','Fredon Twp','A','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.036057,-74.764550,0,'2013-07-06 12:44:30',NULL,NULL),(51239,'59070','S','Fox','A','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.395254,-109.169029,0,'2013-07-06 12:44:33',NULL,NULL),(42393,'47730','P','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.973685,-87.574227,0,'2013-07-06 12:44:32',NULL,NULL),(35446,'39479','S','Seminary','D','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.532820,-89.486580,0,'2013-07-06 12:44:32',NULL,NULL),(35395,'39459','S','Moselle','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.482740,-89.327507,0,'2013-07-06 12:44:32',NULL,NULL),(13967,'14472','S','Honeoye Falls','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.970369,-77.596338,0,'2013-07-06 12:44:31',NULL,NULL),(55120,'63339','S','Curryville','D','Pike','29163','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.345193,-91.340748,0,'2013-07-06 12:44:33',NULL,NULL),(21668,'22947','S','Keswick','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(35714,'39669','S','Ashwood','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(37656,'42206','S','Richelieu','N','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.885141,-86.723180,0,'2013-07-06 12:44:32',NULL,NULL),(71022,'85732','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.215610,-110.881959,0,'2013-07-06 12:44:34',NULL,NULL),(20553,'21122','S','Riviera Beach','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.127599,-76.512544,0,'2013-07-06 12:44:31',NULL,NULL),(62434,'74158','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.167813,-95.918382,0,'2013-07-06 12:44:33',NULL,NULL),(3705,'02140','S','N Cambridge','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.392350,-71.131259,0,'2013-07-06 12:44:30',NULL,NULL),(37128,'41465','S','Burning Fork','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(78997,'98382','S','Dungeness','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.068580,-123.058560,0,'2013-07-06 12:44:34',NULL,NULL),(73396,'91117','P','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.147020,-118.092722,0,'2013-07-06 12:44:34',NULL,NULL),(14400,'15056','S','Leetsdale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.567417,-80.206685,0,'2013-07-06 12:44:31',NULL,NULL),(36565,'40935','S','Flat Lick','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834317,-83.759584,0,'2013-07-06 12:44:32',NULL,NULL),(20230,'20774','S','UPR Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.883657,-76.766349,0,'2013-07-06 12:44:31',NULL,NULL),(52765,'61254','S','Hanna','N','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.457579,-90.163141,0,'2013-07-06 12:44:33',NULL,NULL),(69467,'83655','S','Hamilton Corner','N','Payette','16075','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.958901,-116.807565,0,'2013-07-06 12:44:34',NULL,NULL),(4226,'02852','S','Wickford','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.584340,-71.463799,0,'2013-07-06 12:44:30',NULL,NULL),(18567,'19125','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.979114,-75.123882,0,'2013-07-06 12:44:31',NULL,NULL),(66080,'78390','S','Taft','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.975862,-97.394258,0,'2013-07-06 12:44:34',NULL,NULL),(73464,'91306','S','Winnetka','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.207991,-118.575470,0,'2013-07-06 12:44:34',NULL,NULL),(6608,'05871','S','West Burke','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.616667,-71.933333,0,'2013-07-06 12:44:30',NULL,NULL),(1017,'00718','S','Jard del Este','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(45640,'51649','S','Randolph','D','Fremont','19071','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.870781,-95.567028,0,'2013-07-06 12:44:32',NULL,NULL),(68253,'81063','S','Numa','N','Crowley','08025','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.237711,-103.784046,0,'2013-07-06 12:44:34',NULL,NULL),(21082,'22032','S','Fairfax','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.820862,-77.290981,0,'2013-07-06 12:44:31',NULL,NULL),(8747,'08527','S','Jackson Township','N','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.106820,-74.341020,0,'2013-07-06 12:44:30',NULL,NULL),(60188,'71418','S','Banks Springs','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(51972,'60146','S','Kirkland','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.119640,-88.891020,0,'2013-07-06 12:44:33',NULL,NULL),(55224,'63432','S','Arbela','D','Scotland','29199','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.503569,-91.998959,0,'2013-07-06 12:44:33',NULL,NULL),(36993,'41214','S','Debord','D','Martin','21159','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.798056,-82.581944,0,'2013-07-06 12:44:32',NULL,NULL),(20385,'20889','U','National Naval Medical Ctr','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.009294,-77.097732,0,'2013-07-06 12:44:31',NULL,NULL),(61200,'72231','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.746261,-92.276659,0,'2013-07-06 12:44:33',NULL,NULL),(34706,'38833','S','Doskie','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.890120,-88.309221,0,'2013-07-06 12:44:32',NULL,NULL),(64347,'76518','S','Val Verde','N','Milam','48331','Texas','TX','48','0000','254','Central',-6.0,'Y',30.894745,-97.123059,0,'2013-07-06 12:44:34',NULL,NULL),(2270,'00926','S','Urb Romany Pk Ii','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(20519,'21088','P','Manchester','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.717480,-76.830000,0,'2013-07-06 12:44:31',NULL,NULL),(39919,'45220','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.146959,-84.518750,0,'2013-07-06 12:44:32',NULL,NULL),(34102,'38174','P','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.132269,-90.002258,0,'2013-07-06 12:44:32',NULL,NULL),(74980,'93443','P','Morro Bay','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.367194,-120.851678,0,'2013-07-06 12:44:34',NULL,NULL),(74175,'92274','S','Thermal','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.609040,-116.162060,0,'2013-07-06 12:44:34',NULL,NULL),(14055,'14571','S','Waterport','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.347169,-78.247079,0,'2013-07-06 12:44:31',NULL,NULL),(55511,'63780','S','Scott City','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.218328,-89.518577,0,'2013-07-06 12:44:33',NULL,NULL),(46423,'53188','S','Vernon','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.016203,-88.267858,0,'2013-07-06 12:44:32',NULL,NULL),(18775,'19363','S','Oxford','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.787748,-75.960554,0,'2013-07-06 12:44:31',NULL,NULL),(78268,'97856','S','Long Creek','D','Grant','41023','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.715891,-119.102716,0,'2013-07-06 12:44:34',NULL,NULL),(53140,'61554','S','Marquette Hts','A','Tazewell','17179','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.560420,-89.609100,0,'2013-07-06 12:44:33',NULL,NULL),(52716,'61132','P','Loves Park','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.352184,-88.996195,0,'2013-07-06 12:44:33',NULL,NULL),(50206,'57576','S','McClure','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.021919,-100.306929,0,'2013-07-06 12:44:33',NULL,NULL),(77228,'96507','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(30447,'33331','S','Weston','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(30101,'33158','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.637750,-80.317090,0,'2013-07-06 12:44:32',NULL,NULL),(24774,'27557','S','Middlesex','D','Nash','37127','North Carolina','NC','37','6640','252','Eastern',-5.0,'Y',35.791243,-78.189798,0,'2013-07-06 12:44:31',NULL,NULL),(25013,'27880','S','Sims','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.734926,-78.100591,0,'2013-07-06 12:44:31',NULL,NULL),(58733,'68946','S','Hendley','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.089534,-99.970161,0,'2013-07-06 12:44:33',NULL,NULL),(17765,'18332','S','Henryville','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.081878,-75.283385,0,'2013-07-06 12:44:31',NULL,NULL),(76207,'95361','S','Valley Home','A','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.781218,-120.835377,0,'2013-07-06 12:44:34',NULL,NULL),(75252,'93661','P','Santa Rita Park','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.108668,-120.597447,0,'2013-07-06 12:44:34',NULL,NULL),(66933,'79353','S','Pep','D','Hockley','48219','Texas','TX','48','0000','806','Central',-6.0,'Y',33.793592,-102.578907,0,'2013-07-06 12:44:34',NULL,NULL),(15247,'16049','S','Parker','D','Armstrong','42005','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.109388,-79.694213,0,'2013-07-06 12:44:31',NULL,NULL),(54846,'63040','S','Grover','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.576576,-90.628174,0,'2013-07-06 12:44:33',NULL,NULL),(20144,'20725','P','Laurel','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.102525,-76.844376,0,'2013-07-06 12:44:31',NULL,NULL),(51254,'59081','S','Cooke City','A','Park','30067','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.104688,-110.221461,0,'2013-07-06 12:44:33',NULL,NULL),(6094,'05450','S','West Enosburg','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(76077,'95209','S','Stkn','N','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.025675,-121.348721,0,'2013-07-06 12:44:34',NULL,NULL),(74192,'92280','S','Vidal','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.191918,-114.553587,0,'2013-07-06 12:44:34',NULL,NULL),(35694,'39663','S','Silver Creek','D','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.577100,-90.022800,0,'2013-07-06 12:44:32',NULL,NULL),(31447,'34280','P','Palma Sola','A','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.498840,-82.636138,0,'2013-07-06 12:44:32',NULL,NULL),(68740,'82213','S','Glendo','D','Platte','56031','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.498239,-104.895783,0,'2013-07-06 12:44:34',NULL,NULL),(62901,'75068','S','Little Elm','D','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.168674,-96.961589,0,'2013-07-06 12:44:33',NULL,NULL),(30596,'33420','P','West Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855333,-80.083047,0,'2013-07-06 12:44:32',NULL,NULL),(51989,'60156','S','Lk In The Hills','N','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.180245,-88.331470,0,'2013-07-06 12:44:33',NULL,NULL),(37064,'41311','S','Primrose','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(36960,'41171','S','Stephens','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(31958,'35210','S','Overton','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.540720,-86.685180,0,'2013-07-06 12:44:32',NULL,NULL),(25741,'28563','P','New Bern','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.138210,-77.006350,0,'2013-07-06 12:44:31',NULL,NULL),(21636,'22920','S','Afton','D','Nelson','51125','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.952009,-78.844068,0,'2013-07-06 12:44:31',NULL,NULL),(63450,'75681','S','Mount Enterprise','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.909489,-94.613298,0,'2013-07-06 12:44:33',NULL,NULL),(3646,'02115','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.341535,-71.094458,0,'2013-07-06 12:44:30',NULL,NULL),(31344,'34143','P','Ave Maria','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.429476,-81.433479,0,'2013-07-06 12:44:32',NULL,NULL),(38120,'43110','S','Canal Wnchstr','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.827570,-82.794186,0,'2013-07-06 12:44:32',NULL,NULL),(42203,'47552','S','Lake Lincoln','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.129410,-86.988319,0,'2013-07-06 12:44:32',NULL,NULL),(42786,'48045','S','Harrison Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.609410,-82.835672,0,'2013-07-06 12:44:32',NULL,NULL),(44005,'49349','S','White Cloud','D','Newaygo','26123','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.561678,-85.752158,0,'2013-07-06 12:44:32',NULL,NULL),(3131,'01247','S','Clarksburg','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.687120,-73.074360,0,'2013-07-06 12:44:30',NULL,NULL),(70378,'84660','S','Covered Bridge','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.113000,-111.673500,0,'2013-07-06 12:44:34',NULL,NULL),(27183,'29848','S','Troy','D','Greenwood','45047','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.965222,-82.287072,0,'2013-07-06 12:44:31',NULL,NULL),(66010,'78353','S','Encino','D','Brooks','48047','Texas','TX','48','0000','361','Central',-6.0,'Y',26.983969,-98.209608,0,'2013-07-06 12:44:34',NULL,NULL),(21018,'21851','S','Pocomoke City','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.066608,-75.540891,0,'2013-07-06 12:44:31',NULL,NULL),(63653,'75845','S','Nogalus','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',31.060260,-95.091840,0,'2013-07-06 12:44:34',NULL,NULL),(56597,'65559','S','Saint James','D','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.998771,-91.613832,0,'2013-07-06 12:44:33',NULL,NULL),(60762,'72006','S','Augusta','D','Woodruff','05147','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.284958,-91.362504,0,'2013-07-06 12:44:33',NULL,NULL),(78586,'98177','S','Shoreline','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.743958,-122.369875,0,'2013-07-06 12:44:34',NULL,NULL),(75260,'93667','S','Tollhouse','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.987815,-119.393501,0,'2013-07-06 12:44:34',NULL,NULL),(16662,'17354','S','Porters Sideling','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.849844,-76.879266,0,'2013-07-06 12:44:31',NULL,NULL),(38589,'43812','S','Coshocton','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.266552,-81.852642,0,'2013-07-06 12:44:32',NULL,NULL),(34328,'38560','S','Elmwood','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.241881,-85.883125,0,'2013-07-06 12:44:32',NULL,NULL),(12046,'12526','S','Germantown','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.134040,-73.850340,0,'2013-07-06 12:44:30',NULL,NULL),(23329,'25239','S','Cottageville','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.856119,-81.815753,0,'2013-07-06 12:44:31',NULL,NULL),(52913,'61364','S','South Streator','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.173260,-88.822560,0,'2013-07-06 12:44:33',NULL,NULL),(33140,'36912','S','Lisman','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.222880,-88.326180,0,'2013-07-06 12:44:32',NULL,NULL),(39720,'45055','P','Overpeck','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.450623,-84.514312,0,'2013-07-06 12:44:32',NULL,NULL),(78742,'98290','S','Clearview','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.939532,-122.016706,0,'2013-07-06 12:44:34',NULL,NULL),(3579,'01971','P','Salem','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.527567,-70.868387,0,'2013-07-06 12:44:30',NULL,NULL),(12134,'12723','S','Callicoon','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.781826,-74.983676,0,'2013-07-06 12:44:30',NULL,NULL),(6694,'06057','S','Bakersville','N','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844360,-73.012800,0,'2013-07-06 12:44:30',NULL,NULL),(75879,'94952','S','Two Rock Ranch STa','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.244916,-122.659988,0,'2013-07-06 12:44:34',NULL,NULL),(70825,'85387','S','Surprise','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.678050,-112.468506,0,'2013-07-06 12:44:34',NULL,NULL),(67557,'80274','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.742322,-104.989512,0,'2013-07-06 12:44:34',NULL,NULL),(29605,'32836','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.427503,-81.507039,0,'2013-07-06 12:44:32',NULL,NULL),(38841,'44089','S','Beulah Beach','N','Erie','39043','Ohio','OH','39','0000','440','Eastern',-5.0,'Y',41.406313,-82.382678,0,'2013-07-06 12:44:32',NULL,NULL),(9146,'09267','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(71305,'86503','S','Low Mountain','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(63452,'75682','P','New London','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.242434,-94.946652,0,'2013-07-06 12:44:33',NULL,NULL),(47319,'54558','S','St Germain','N','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.926415,-89.481221,0,'2013-07-06 12:44:32',NULL,NULL),(60668,'71922','P','Antoine','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.027118,-93.450160,0,'2013-07-06 12:44:33',NULL,NULL),(60612,'71857','S','Reader','N','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.802675,-93.377033,0,'2013-07-06 12:44:33',NULL,NULL),(10161,'10279','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.713759,-74.009621,0,'2013-07-06 12:44:30',NULL,NULL),(54094,'62531','S','Edinburg','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.661648,-89.392376,0,'2013-07-06 12:44:33',NULL,NULL),(27381,'30077','P','Roswell','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.040334,-84.354585,0,'2013-07-06 12:44:31',NULL,NULL),(56308,'65101','S','Osage Bend','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.501640,-92.155560,0,'2013-07-06 12:44:33',NULL,NULL),(48935,'56159','S','Mountain Lake','D','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.939928,-94.928701,0,'2013-07-06 12:44:33',NULL,NULL),(73776,'91741','S','Glendora','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.145314,-117.853357,0,'2013-07-06 12:44:34',NULL,NULL),(13249,'13642','S','Pierces Corner','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(3148,'01258','S','Mt Washington','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.107580,-73.465080,0,'2013-07-06 12:44:30',NULL,NULL),(29231,'32428','S','Chipley','D','Washington','12133','Florida','FL','12','0000','850','Central',-6.0,'Y',30.671940,-85.571469,0,'2013-07-06 12:44:32',NULL,NULL),(16760,'17518','S','Liberty Square','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.818303,-76.244889,0,'2013-07-06 12:44:31',NULL,NULL),(55726,'64081','S','LS','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.912082,-94.406100,0,'2013-07-06 12:44:33',NULL,NULL),(30510,'33403','S','W Plm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.784940,-80.071224,0,'2013-07-06 12:44:32',NULL,NULL),(29455,'32709','S','Christmas','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.516066,-80.984322,0,'2013-07-06 12:44:32',NULL,NULL),(29276,'32461','P','Rosemary Beach','D','Walton','12131','Florida','FL','12','6015','850','Central',-6.0,'Y',30.251077,-85.950567,0,'2013-07-06 12:44:32',NULL,NULL),(38149,'43144','P','Murray City','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.513016,-82.165595,0,'2013-07-06 12:44:32',NULL,NULL),(24242,'26757','S','Three Churches','A','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.344134,-78.758405,0,'2013-07-06 12:44:31',NULL,NULL),(73357,'91011','S','La Canada Flintridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.206651,-118.201628,0,'2013-07-06 12:44:34',NULL,NULL),(23747,'25938','S','Ramsey','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.144624,-81.034034,0,'2013-07-06 12:44:31',NULL,NULL),(10149,'10275','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.701876,-74.013967,0,'2013-07-06 12:44:30',NULL,NULL),(4269,'02883','P','South Kingstown','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.451648,-71.501278,0,'2013-07-06 12:44:30',NULL,NULL),(61291,'72411','S','Bay','D','Craighead','05031','Arkansas','AR','05','3700','870','Central',-6.0,'Y',35.741926,-90.560407,0,'2013-07-06 12:44:33',NULL,NULL),(52117,'60424','S','Gardner','D','Grundy','17063','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.169508,-88.320503,0,'2013-07-06 12:44:33',NULL,NULL),(49649,'56967','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(39476,'44720','S','Akron Canton Region Airport','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.897320,-81.433440,0,'2013-07-06 12:44:32',NULL,NULL),(36697,'41017','S','Crestview Hls','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(4947,'04095','S','West Newfield','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.674167,-70.911389,0,'2013-07-06 12:44:30',NULL,NULL),(52282,'60527','S','Willow Brook','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.841820,-87.951040,0,'2013-07-06 12:44:33',NULL,NULL),(7798,'07435','S','Newfoundland','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.056980,-74.428920,0,'2013-07-06 12:44:30',NULL,NULL),(18378,'19046','S','Rockledge','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(24897,'27709','P','Rtp','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.913800,-78.848911,0,'2013-07-06 12:44:31',NULL,NULL),(7592,'07039','S','Livingston','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.787368,-74.319046,0,'2013-07-06 12:44:30',NULL,NULL),(780,'00693','S','Bda Sandin','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(74420,'92554','P','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.914803,-117.251101,0,'2013-07-06 12:44:34',NULL,NULL),(44567,'50022','S','Atlantic','D','Cass','19029','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.400014,-95.009466,0,'2013-07-06 12:44:32',NULL,NULL),(17538,'17976','S','Mahanoy','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(2169,'00926','S','BO Tortugo','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(29300,'32514','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.524613,-87.236038,0,'2013-07-06 12:44:32',NULL,NULL),(28155,'30833','S','Wrens','D','Jefferson','13163','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.206767,-82.389017,0,'2013-07-06 12:44:31',NULL,NULL),(77686,'97037','S','Maupin','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.076963,-121.376099,0,'2013-07-06 12:44:34',NULL,NULL),(59029,'70082','P','Pointe A la Hache','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.575598,-89.793242,0,'2013-07-06 12:44:33',NULL,NULL),(24993,'27864','S','Pinetops','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.790476,-77.641917,0,'2013-07-06 12:44:31',NULL,NULL),(2758,'00969','S','Urb Torrimar Est','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(15136,'15846','S','Kersey','D','Elk','42047','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.353722,-78.614239,0,'2013-07-06 12:44:31',NULL,NULL),(65607,'77904','S','Victoria','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.855498,-97.003146,0,'2013-07-06 12:44:34',NULL,NULL),(25157,'28027','S','Concord','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.411756,-80.646757,0,'2013-07-06 12:44:31',NULL,NULL),(32604,'36133','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.374861,-86.309891,0,'2013-07-06 12:44:32',NULL,NULL),(77740,'97077','U','Tektronix','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.493610,-122.800298,0,'2013-07-06 12:44:34',NULL,NULL),(79758,'99302','P','Pasco','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.256423,-119.079477,0,'2013-07-06 12:44:34',NULL,NULL),(8265,'08008','S','Surf City','A','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(29804,'33023','S','W Hollywood','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(43632,'48825','S','East Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.723616,-84.467477,0,'2013-07-06 12:44:32',NULL,NULL),(2814,'00976','S','Villa de Caney','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(18068,'18704','S','Larksville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(75895,'94972','S','Valley Ford','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.297258,-122.941962,0,'2013-07-06 12:44:34',NULL,NULL),(50053,'57437','S','Hillsview','N','McPherson','46089','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.802620,-99.618600,0,'2013-07-06 12:44:33',NULL,NULL),(45945,'52345','S','Urbana','D','Benton','19011','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.223644,-91.875135,0,'2013-07-06 12:44:32',NULL,NULL),(25051,'27920','P','Buxton','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.265883,-75.528710,0,'2013-07-06 12:44:31',NULL,NULL),(17306,'17853','S','Mt Pleasant Mills','A','Snyder','42109','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.696004,-77.008001,0,'2013-07-06 12:44:31',NULL,NULL),(10923,'11430','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.661453,-73.811830,0,'2013-07-06 12:44:30',NULL,NULL),(22381,'23936','S','Sprouses Corn','A','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.520399,-78.476570,0,'2013-07-06 12:44:31',NULL,NULL),(3335,'01538','P','N Uxbridge','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.090256,-71.639891,0,'2013-07-06 12:44:30',NULL,NULL),(24016,'26362','S','Hazelgreen','A','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.211147,-81.050312,0,'2013-07-06 12:44:31',NULL,NULL),(59053,'70087','S','St Rose','N','Saint Charles','22089','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.982463,-90.313325,0,'2013-07-06 12:44:33',NULL,NULL),(48023,'55301','S','Albertville','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.239613,-93.654947,0,'2013-07-06 12:44:33',NULL,NULL),(23412,'25332','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.353789,-81.628091,0,'2013-07-06 12:44:31',NULL,NULL),(4679,'03785','S','Landaff','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.149423,-72.034577,0,'2013-07-06 12:44:30',NULL,NULL),(531,'00674','S','Villa Forestal','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(44932,'50360','U','Citigroup','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.594905,-93.764562,0,'2013-07-06 12:44:32',NULL,NULL),(10416,'10706','S','Yonkers','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.970520,-73.875300,0,'2013-07-06 12:44:30',NULL,NULL),(44478,'49902','P','Alpha','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.017070,-88.304990,0,'2013-07-06 12:44:32',NULL,NULL),(70939,'85640','S','Kinsley Ranch','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.596899,-111.047790,0,'2013-07-06 12:44:34',NULL,NULL),(60816,'72032','S','Gold Creek','N','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.067300,-92.380800,0,'2013-07-06 12:44:33',NULL,NULL),(55931,'64470','S','Mound City','D','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.133489,-95.230985,0,'2013-07-06 12:44:33',NULL,NULL),(46752,'53929','S','Elroy','D','Juneau','55057','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.746595,-90.267539,0,'2013-07-06 12:44:32',NULL,NULL),(44558,'50011','U','Iowa State University','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.022225,-93.639475,0,'2013-07-06 12:44:32',NULL,NULL),(36168,'40242','S','Plantation','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(71662,'87501','S','Tesuque Pueblo','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(3063,'01116','P','Longmeadow','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.064444,-72.513056,0,'2013-07-06 12:44:30',NULL,NULL),(55012,'63133','S','Hanley Hills','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.678252,-90.305602,0,'2013-07-06 12:44:33',NULL,NULL),(26377,'29080','S','Shiloh','N','Lee','45061','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.038853,-80.110297,0,'2013-07-06 12:44:31',NULL,NULL),(59064,'70094','S','Bridge City','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(2083,'00921','S','Urb Las Lomas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(5611,'04936','S','Chain of Ponds Twp','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182634,-70.491461,0,'2013-07-06 12:44:30',NULL,NULL),(60146,'71375','S','Goldman','N','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.822058,-91.382756,0,'2013-07-06 12:44:33',NULL,NULL),(11802,'12227','U','NYS Dept of Tax & Finance','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.689555,-73.845984,0,'2013-07-06 12:44:30',NULL,NULL),(19617,'20239','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.879588,-77.032458,0,'2013-07-06 12:44:31',NULL,NULL),(58373,'68528','S','Emerald','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.819560,-96.813060,0,'2013-07-06 12:44:33',NULL,NULL),(56054,'64738','S','Collins','D','Saint Clair','29185','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.869606,-93.678666,0,'2013-07-06 12:44:33',NULL,NULL),(45774,'52156','S','Hardin','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.056418,-91.392347,0,'2013-07-06 12:44:32',NULL,NULL),(11138,'11709','S','Bayville','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.907634,-73.560621,0,'2013-07-06 12:44:30',NULL,NULL),(29212,'32413','S','Rosemary Bch','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(28726,'31905','S','Columbus','A','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.430120,-84.918180,0,'2013-07-06 12:44:32',NULL,NULL),(26777,'29447','P','Grover','D','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.107714,-80.592916,0,'2013-07-06 12:44:31',NULL,NULL),(78776,'98312','S','Bremerton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.574600,-122.810580,0,'2013-07-06 12:44:34',NULL,NULL),(4127,'02743','S','New Bedford','A','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.711280,-70.909680,0,'2013-07-06 12:44:30',NULL,NULL),(49912,'57311','S','Farmer','A','Hanson','46061','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.645920,-97.761300,0,'2013-07-06 12:44:33',NULL,NULL),(34317,'38555','S','Fairfield Glade','A','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951220,-85.029780,0,'2013-07-06 12:44:32',NULL,NULL),(9563,'10024','S','Planetarium','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.786538,-73.978644,0,'2013-07-06 12:44:30',NULL,NULL),(31669,'34758','S','Poinciana','A','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.203472,-81.500447,0,'2013-07-06 12:44:32',NULL,NULL),(73618,'91403','S','Van Nuys','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.148353,-118.461005,0,'2013-07-06 12:44:34',NULL,NULL),(67593,'80420','P','Alma','D','Park','08093','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.296764,-106.066278,0,'2013-07-06 12:44:34',NULL,NULL),(3017,'01085','S','Montgomery','A','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.156360,-72.778740,0,'2013-07-06 12:44:30',NULL,NULL),(64172,'76227','S','Krugerville','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.292349,-96.986964,0,'2013-07-06 12:44:34',NULL,NULL),(45811,'52203','S','Amana','D','Iowa','19095','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.804159,-91.867902,0,'2013-07-06 12:44:32',NULL,NULL),(55574,'63875','P','Rives','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.095992,-90.014795,0,'2013-07-06 12:44:33',NULL,NULL),(33214,'37051','S','Cumberland Furnace','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.298358,-87.412642,0,'2013-07-06 12:44:32',NULL,NULL),(19972,'20594','U','Natl Trans Safety Board','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.886830,-77.022138,0,'2013-07-06 12:44:31',NULL,NULL),(22554,'24138','S','Pilot','D','Montgomery','51121','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.058466,-80.318946,0,'2013-07-06 12:44:31',NULL,NULL),(7972,'07703','S','Red Bank','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.315026,-74.037045,0,'2013-07-06 12:44:30',NULL,NULL),(75588,'94293','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.554780,-121.495621,0,'2013-07-06 12:44:34',NULL,NULL),(70119,'84190','U','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725005,-111.886915,0,'2013-07-06 12:44:34',NULL,NULL),(30631,'33442','S','Deerfield Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.308884,-80.140867,0,'2013-07-06 12:44:32',NULL,NULL),(3797,'02217','U','John Hancock P O Box 505','N','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.348526,-71.072994,0,'2013-07-06 12:44:30',NULL,NULL),(53781,'62275','S','Pocahontas','D','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770822,-89.501779,0,'2013-07-06 12:44:33',NULL,NULL),(43216,'48308','P','Rochester','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.678404,-83.134101,0,'2013-07-06 12:44:32',NULL,NULL),(40743,'46135','S','Limedale','N','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.647580,-86.867220,0,'2013-07-06 12:44:32',NULL,NULL),(27384,'30080','S','Smyrna','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.872023,-84.507595,0,'2013-07-06 12:44:31',NULL,NULL),(58714,'68936','S','Edison','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.262436,-99.799141,0,'2013-07-06 12:44:33',NULL,NULL),(4317,'02912','U','Brown University','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.824987,-71.400763,0,'2013-07-06 12:44:30',NULL,NULL),(40764,'46151','S','Bethany','A','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.410700,-86.463180,0,'2013-07-06 12:44:32',NULL,NULL),(33168,'37025','S','Bon Aqua','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.930256,-87.246161,0,'2013-07-06 12:44:32',NULL,NULL),(15928,'17020','S','Wheatfield','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.391761,-77.045102,0,'2013-07-06 12:44:31',NULL,NULL),(31488,'34434','S','Citrus Spgs','A','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',28.998415,-82.431555,0,'2013-07-06 12:44:32',NULL,NULL),(71895,'87745','S','Las Vegas','A','San Miguel','35047','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.593889,-105.216667,0,'2013-07-06 12:44:34',NULL,NULL),(10857,'11413','S','Sprngfld Gdns','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.671820,-73.751834,0,'2013-07-06 12:44:30',NULL,NULL),(58139,'68147','S','Bellevue','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.177581,-95.955671,0,'2013-07-06 12:44:33',NULL,NULL),(31020,'33785','S','Indian Rk Bch','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.894398,-82.844386,0,'2013-07-06 12:44:32',NULL,NULL),(65028,'77326','P','Ace','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.520029,-94.810503,0,'2013-07-06 12:44:34',NULL,NULL),(43412,'48460','S','New Lothrop','D','Shiawassee','26155','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.108607,-83.996083,0,'2013-07-06 12:44:32',NULL,NULL),(78828,'98335','S','Picnic Point','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(78592,'98181','U','Macys','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.610729,-122.341403,0,'2013-07-06 12:44:34',NULL,NULL),(2333,'00936','P','Barrio Obrero','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(21990,'23269','U','Rich','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.557901,-77.467640,0,'2013-07-06 12:44:31',NULL,NULL),(78632,'98220','S','Acme','D','Whatcom','53073','Washington','WA','53','0860','360/564','Pacific',-8.0,'Y',48.687032,-122.194051,0,'2013-07-06 12:44:34',NULL,NULL),(10434,'10901','S','Montebello','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.127671,-74.111934,0,'2013-07-06 12:44:30',NULL,NULL),(41985,'47421','S','Peerless','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(27476,'30148','S','Marble Hill','D','Pickens','13227','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.455391,-84.270318,0,'2013-07-06 12:44:31',NULL,NULL),(25307,'28150','S','Shelby','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.304225,-81.551791,0,'2013-07-06 12:44:31',NULL,NULL),(37041,'41264','S','Ulysses','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.000051,-82.714700,0,'2013-07-06 12:44:32',NULL,NULL),(10610,'11040','S','North New Hyde Park','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(75472,'94107','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.770830,-122.395463,0,'2013-07-06 12:44:34',NULL,NULL),(28104,'30757','S','Wildwood','D','Dade','13083','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.977192,-85.436272,0,'2013-07-06 12:44:31',NULL,NULL),(67785,'80705','S','Fort Morgan','A','Morgan','08087','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.260900,-103.818540,0,'2013-07-06 12:44:34',NULL,NULL),(50919,'58563','S','Blue Grass','N','Morton','38059','North Dakota','ND','38','1010','701','Central',-6.0,'Y',46.853700,-101.435580,0,'2013-07-06 12:44:33',NULL,NULL),(41244,'46742','S','Cold Springs','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(7436,'06830','S','Belle Haven','N','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.035494,-73.628183,0,'2013-07-06 12:44:30',NULL,NULL),(32498,'36065','P','Pine Level','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.070031,-86.057006,0,'2013-07-06 12:44:32',NULL,NULL),(26161,'28743','S','Joe','N','Madison','37115','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.845800,-82.870620,0,'2013-07-06 12:44:31',NULL,NULL),(8160,'07856','S','Mt Arlington','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.928208,-74.636027,0,'2013-07-06 12:44:30',NULL,NULL),(49037,'56283','S','North Redwood','A','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.540219,-95.111345,0,'2013-07-06 12:44:33',NULL,NULL),(35320,'39425','S','Maxie','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.031160,-89.172000,0,'2013-07-06 12:44:32',NULL,NULL),(70481,'84767','P','Springdale','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.185515,-112.998069,0,'2013-07-06 12:44:34',NULL,NULL),(48936,'56159','S','Mt Lake','N','Cottonwood','27033','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.939928,-94.928701,0,'2013-07-06 12:44:33',NULL,NULL),(27729,'30349','S','College Park','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.614175,-84.497109,0,'2013-07-06 12:44:31',NULL,NULL),(61856,'73121','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.509891,-97.446247,0,'2013-07-06 12:44:33',NULL,NULL),(8047,'07734','S','West Keansburg','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.439051,-74.125510,0,'2013-07-06 12:44:30',NULL,NULL),(57341,'66720','S','Petrolia','A','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.640820,-95.464980,0,'2013-07-06 12:44:33',NULL,NULL),(47766,'55036','S','Henriette','D','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.839035,-92.958857,0,'2013-07-06 12:44:33',NULL,NULL),(31933,'35182','P','Wattsville','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.660556,-86.263333,0,'2013-07-06 12:44:32',NULL,NULL),(58064,'68046','S','Papillion','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.154802,-96.037961,0,'2013-07-06 12:44:33',NULL,NULL),(15506,'16509','S','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.072512,-80.063237,0,'2013-07-06 12:44:31',NULL,NULL),(58056,'68038','S','Lyons','D','Burt','31021','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.935485,-96.473601,0,'2013-07-06 12:44:33',NULL,NULL),(1261,'00729','S','Villas de Loiza','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(55596,'63938','P','Fagus','D','Butler','29023','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.512536,-90.269868,0,'2013-07-06 12:44:33',NULL,NULL),(55911,'64445','S','Elmo','D','Nodaway','29147','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.515953,-95.127844,0,'2013-07-06 12:44:33',NULL,NULL),(48405,'55593','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.991976,-93.711101,0,'2013-07-06 12:44:33',NULL,NULL),(79090,'98439','S','Lakewood','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(65940,'78256','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.623424,-98.624731,0,'2013-07-06 12:44:34',NULL,NULL),(9844,'10117','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752294,-73.995082,0,'2013-07-06 12:44:30',NULL,NULL),(14339,'15009','S','Beaver','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.702800,-80.355660,0,'2013-07-06 12:44:31',NULL,NULL),(26526,'29203','S','Crafts Farrow','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(13065,'13452','S','Crum Creek','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.037760,-74.636400,0,'2013-07-06 12:44:30',NULL,NULL),(14642,'15234','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.367019,-80.019091,0,'2013-07-06 12:44:31',NULL,NULL),(30292,'33266','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.827127,-80.313971,0,'2013-07-06 12:44:32',NULL,NULL),(29146,'32332','S','Gretna','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.615685,-84.664824,0,'2013-07-06 12:44:32',NULL,NULL),(62968,'75126','S','Heath','A','Kaufman','48257','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.745419,-96.455203,0,'2013-07-06 12:44:33',NULL,NULL),(10579,'11021','S','Kensington','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.788775,-73.728665,0,'2013-07-06 12:44:30',NULL,NULL),(26219,'28791','S','Hendersonville','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.350441,-82.494453,0,'2013-07-06 12:44:31',NULL,NULL),(38538,'43747','S','Jerusalem','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.837154,-81.116078,0,'2013-07-06 12:44:32',NULL,NULL),(30692,'33480','S','Palm Beach','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.717031,-80.047448,0,'2013-07-06 12:44:32',NULL,NULL),(9405,'09890','M','DPO','A','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(13662,'14027','P','Brant','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.580316,-79.012869,0,'2013-07-06 12:44:31',NULL,NULL),(34557,'38725','S','Longshot','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(75670,'94546','S','Castro Valley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.726080,-122.080380,0,'2013-07-06 12:44:34',NULL,NULL),(17361,'17872','S','Ralpho','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(76671,'95763','P','Folsom','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.678182,-121.174368,0,'2013-07-06 12:44:34',NULL,NULL),(27328,'30033','S','Decatur','D','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.817078,-84.281903,0,'2013-07-06 12:44:31',NULL,NULL),(8362,'08051','S','Mantua Heights','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.787980,-75.181295,0,'2013-07-06 12:44:30',NULL,NULL),(23436,'25401','S','Martinsburg','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.461266,-77.965102,0,'2013-07-06 12:44:31',NULL,NULL),(5907,'05161','S','Weston Priory','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.284563,-72.793543,0,'2013-07-06 12:44:30',NULL,NULL),(75221,'93638','S','Madera','D','Madera','06039','California','CA','06','2840','559','Pacific',-8.0,'Y',36.974268,-120.002242,0,'2013-07-06 12:44:34',NULL,NULL),(20965,'21784','S','Sykesville','D','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.338199,-76.972300,0,'2013-07-06 12:44:31',NULL,NULL),(3662,'02122','S','Dorchester','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.297038,-71.054735,0,'2013-07-06 12:44:30',NULL,NULL),(4864,'04027','S','Lebanon','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.429620,-70.906500,0,'2013-07-06 12:44:30',NULL,NULL),(35774,'39744','S','Fame','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.555840,-89.294340,0,'2013-07-06 12:44:32',NULL,NULL),(40626,'46014','P','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.087030,-85.676330,0,'2013-07-06 12:44:32',NULL,NULL),(43159,'48265','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.441129,-82.930987,0,'2013-07-06 12:44:32',NULL,NULL),(70976,'85703','P','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.272599,-110.990622,0,'2013-07-06 12:44:34',NULL,NULL),(56526,'65401','S','Lecoma','A','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.950864,-91.763227,0,'2013-07-06 12:44:33',NULL,NULL),(51539,'59725','S','Dillon','D','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.211890,-112.649262,0,'2013-07-06 12:44:33',NULL,NULL),(78704,'98261','S','Port Stanley','N','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.447828,-122.842452,0,'2013-07-06 12:44:34',NULL,NULL),(75281,'93714','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.735181,-119.785635,0,'2013-07-06 12:44:34',NULL,NULL),(50203,'57572','S','Saint Francis','D','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.142534,-100.967723,0,'2013-07-06 12:44:33',NULL,NULL),(5491,'04750','S','Limestone','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.912547,-67.826893,0,'2013-07-06 12:44:30',NULL,NULL),(22307,'23833','S','Church Road','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.217846,-77.675533,0,'2013-07-06 12:44:31',NULL,NULL),(35827,'39767','S','Stewart','D','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.532113,-89.496533,0,'2013-07-06 12:44:32',NULL,NULL),(31496,'34446','S','Homosassa','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.747053,-82.526574,0,'2013-07-06 12:44:32',NULL,NULL),(39463,'44708','S','Country Fair','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.812034,-81.424133,0,'2013-07-06 12:44:32',NULL,NULL),(35753,'39735','S','Fentress','N','Choctaw','28019','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.336060,-89.186940,0,'2013-07-06 12:44:32',NULL,NULL),(35427,'39474','S','Mount Carmel','N','Jefferson Davis','28065','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.595381,-89.875941,0,'2013-07-06 12:44:32',NULL,NULL),(16608,'17331','S','Bowman Addition','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.796620,-77.001420,0,'2013-07-06 12:44:31',NULL,NULL),(21629,'22909','U','Charlottesvle','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.043210,-78.474036,0,'2013-07-06 12:44:31',NULL,NULL),(55744,'64096','S','Waverly','D','Lafayette','29107','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.202923,-93.523427,0,'2013-07-06 12:44:33',NULL,NULL),(35993,'40142','S','Guston','D','Meade','21163','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.895924,-86.163022,0,'2013-07-06 12:44:32',NULL,NULL),(54434,'62839','S','Flora','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.669142,-88.485148,0,'2013-07-06 12:44:33',NULL,NULL),(18837,'19425','S','Chester Springs','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.089503,-75.637922,0,'2013-07-06 12:44:31',NULL,NULL),(61162,'72181','S','Wooster','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.193472,-92.465202,0,'2013-07-06 12:44:33',NULL,NULL),(24176,'26623','S','Frametown','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.630653,-80.876931,0,'2013-07-06 12:44:31',NULL,NULL),(11042,'11571','P','Rockville Centre','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.657461,-73.648593,0,'2013-07-06 12:44:30',NULL,NULL),(11997,'12485','S','Tannersville','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.194261,-74.134684,0,'2013-07-06 12:44:30',NULL,NULL),(20299,'20813','P','Chevy Chase','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.984105,-77.080215,0,'2013-07-06 12:44:31',NULL,NULL),(64836,'77040','S','Jersey Village','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(66857,'79172','U','Amarillo','D','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.202037,-101.833183,0,'2013-07-06 12:44:34',NULL,NULL),(48715,'55949','S','Lanesboro','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.716900,-92.006580,0,'2013-07-06 12:44:33',NULL,NULL),(79899,'99587','P','Girdwood','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',60.960239,-149.126190,0,'2013-07-06 12:44:34',NULL,NULL),(75083,'93534','S','Lancaster','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.692638,-118.144902,0,'2013-07-06 12:44:34',NULL,NULL),(72727,'89504','P','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.681276,-119.841848,0,'2013-07-06 12:44:34',NULL,NULL),(55470,'63744','P','Delta','D','Cape Girardeau','29031','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.192154,-89.749348,0,'2013-07-06 12:44:33',NULL,NULL),(11811,'12232','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.652603,-73.754055,0,'2013-07-06 12:44:30',NULL,NULL),(74884,'93280','S','Wasco','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.615820,-119.391660,0,'2013-07-06 12:44:34',NULL,NULL),(9756,'10102','U','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(9638,'10036','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.759011,-73.989876,0,'2013-07-06 12:44:30',NULL,NULL),(67199,'79907','S','Ysleta Sur','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.711168,-106.331389,0,'2013-07-06 12:44:34',NULL,NULL),(66384,'78624','S','Blumenthal','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(62871,'75040','S','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.925157,-96.622452,0,'2013-07-06 12:44:33',NULL,NULL),(56007,'64650','S','Kingston','D','Caldwell','29025','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',39.654749,-94.093356,0,'2013-07-06 12:44:33',NULL,NULL),(49123,'56358','S','Ogilvie','D','Kanabec','27065','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.830614,-93.425896,0,'2013-07-06 12:44:33',NULL,NULL),(49118,'56355','S','Nelson','D','Douglas','27041','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.933714,-95.218886,0,'2013-07-06 12:44:33',NULL,NULL),(2984,'01061','P','North Hampton','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.323341,-72.690352,0,'2013-07-06 12:44:30',NULL,NULL),(19334,'20032','S','Washing','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.833027,-76.997902,0,'2013-07-06 12:44:31',NULL,NULL),(71245,'86401','S','Grasshopper Junction','N','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.524020,-113.992680,0,'2013-07-06 12:44:34',NULL,NULL),(64863,'77058','S','Clear Lake City','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.553866,-95.095044,0,'2013-07-06 12:44:34',NULL,NULL),(54573,'62896','S','W Frankfort','A','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.898902,-88.922036,0,'2013-07-06 12:44:33',NULL,NULL),(30060,'33149','S','Key Biscayne','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.694059,-80.166798,0,'2013-07-06 12:44:32',NULL,NULL),(28771,'32033','S','Armstrong','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.780205,-81.438268,0,'2013-07-06 12:44:32',NULL,NULL),(66721,'78953','S','Rosanky','D','Bastrop','48021','Texas','TX','48','0640','830','Central',-6.0,'Y',29.881875,-97.323178,0,'2013-07-06 12:44:34',NULL,NULL),(27519,'30206','S','Concord','D','Pike','13231','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.096075,-84.464790,0,'2013-07-06 12:44:31',NULL,NULL),(50422,'57787','S','Stoneville','A','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.733611,-102.654167,0,'2013-07-06 12:44:33',NULL,NULL),(43451,'48529','S','Flint','A','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.974171,-83.664604,0,'2013-07-06 12:44:32',NULL,NULL),(29355,'32566','S','Gulf Breeze','A','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.500880,-86.896620,0,'2013-07-06 12:44:32',NULL,NULL),(9967,'10160','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.739111,-73.983857,0,'2013-07-06 12:44:30',NULL,NULL),(22624,'24230','S','Coeburn','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.942598,-82.468058,0,'2013-07-06 12:44:31',NULL,NULL),(56603,'65560','S','Sligo','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(32808,'36442','S','Hacoda','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.002261,-86.325796,0,'2013-07-06 12:44:32',NULL,NULL),(40415,'45686','S','Vinton','D','Gallia','39053','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.003900,-82.369140,0,'2013-07-06 12:44:32',NULL,NULL),(40953,'46307','S','Crown Point','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.419705,-87.354291,0,'2013-07-06 12:44:32',NULL,NULL),(74558,'92679','S','Coto de Caza','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.641543,-117.589400,0,'2013-07-06 12:44:34',NULL,NULL),(73290,'90749','P','Long Beach','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.819146,-118.263108,0,'2013-07-06 12:44:34',NULL,NULL),(69285,'83442','S','Lorenzo','N','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.686480,-111.879600,0,'2013-07-06 12:44:34',NULL,NULL),(63764,'75946','S','Brileytown','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.799280,-94.485300,0,'2013-07-06 12:44:34',NULL,NULL),(69195,'83343','P','Rupert','A','Minidoka','16067','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.753889,-113.489444,0,'2013-07-06 12:44:34',NULL,NULL),(9407,'09898','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5289,'04538','S','Capitol Is','A','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.851438,-69.626454,0,'2013-07-06 12:44:30',NULL,NULL),(34906,'38955','P','Dentontown','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.740556,-89.371111,0,'2013-07-06 12:44:32',NULL,NULL),(67098,'79707','S','Midland','D','Midland','48329','Texas','TX','48','5800','432','Central',-6.0,'Y',32.022609,-102.141467,0,'2013-07-06 12:44:34',NULL,NULL),(65678,'77989','P','Thomaston','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.096799,-97.190375,0,'2013-07-06 12:44:34',NULL,NULL),(35346,'39439','S','Stafford Springs','N','Jasper','28061','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.897396,-89.002726,0,'2013-07-06 12:44:32',NULL,NULL),(77723,'97064','S','Vernonia','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.860625,-123.201591,0,'2013-07-06 12:44:34',NULL,NULL),(78898,'98360','S','Ohop','N','Pierce','53053','Washington','WA','53','8200','360/564','Pacific',-8.0,'Y',47.087937,-122.185345,0,'2013-07-06 12:44:34',NULL,NULL),(61054,'72120','S','Sherwood','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.892804,-92.231859,0,'2013-07-06 12:44:33',NULL,NULL),(21218,'22211','S','Fort Myer','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.886949,-77.078211,0,'2013-07-06 12:44:31',NULL,NULL),(68249,'81059','S','Model','D','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.498583,-104.151083,0,'2013-07-06 12:44:34',NULL,NULL),(17804,'18403','S','Archbald','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.496372,-75.569205,0,'2013-07-06 12:44:31',NULL,NULL),(9690,'10044','S','Roosevelt Island','A','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760799,-73.945729,0,'2013-07-06 12:44:30',NULL,NULL),(57032,'66208','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.997171,-94.632694,0,'2013-07-06 12:44:33',NULL,NULL),(71849,'87594','P','Santa Fe','D','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.793134,-105.993637,0,'2013-07-06 12:44:34',NULL,NULL),(66183,'78536','S','La Reforma','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.643548,-98.403199,0,'2013-07-06 12:44:34',NULL,NULL),(26287,'29020','S','Shamokin','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.313040,-80.605560,0,'2013-07-06 12:44:31',NULL,NULL),(23235,'25103','S','Hansford','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.113553,-81.377213,0,'2013-07-06 12:44:31',NULL,NULL),(2856,'00984','P','Carolina','D','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.408896,-65.981861,0,'2013-07-06 12:44:30',NULL,NULL),(37858,'42516','S','Bethelridge','D','Casey','21045','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.146786,-84.717801,0,'2013-07-06 12:44:32',NULL,NULL),(76812,'95951','P','Mills Orchard','N','Glenn','06021','California','CA','06','0000','530','Pacific',-8.0,'Y',39.743650,-122.010960,0,'2013-07-06 12:44:34',NULL,NULL),(73362,'91016','S','Monrovia','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.143769,-117.999476,0,'2013-07-06 12:44:34',NULL,NULL),(17607,'18042','S','Easton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.685899,-75.240754,0,'2013-07-06 12:44:31',NULL,NULL),(7519,'07003','S','North Center','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.805311,-74.187412,0,'2013-07-06 12:44:30',NULL,NULL),(61581,'72744','S','Lincoln','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',35.950316,-94.413006,0,'2013-07-06 12:44:33',NULL,NULL),(59573,'70884','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.377259,-91.096010,0,'2013-07-06 12:44:33',NULL,NULL),(12402,'12930','S','Dickinson Center','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.779444,-74.498056,0,'2013-07-06 12:44:30',NULL,NULL),(39702,'45041','P','Miamitown','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.212981,-84.703406,0,'2013-07-06 12:44:32',NULL,NULL),(16287,'17104','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.260352,-76.855909,0,'2013-07-06 12:44:31',NULL,NULL),(12560,'13052','S','Lincklaen','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.760200,-75.892320,0,'2013-07-06 12:44:30',NULL,NULL),(57603,'67111','S','Murdock','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.603749,-97.973333,0,'2013-07-06 12:44:33',NULL,NULL),(50291,'57658','S','Wakpala','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.786177,-100.514830,0,'2013-07-06 12:44:33',NULL,NULL),(8201,'07932','S','Florham Park','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.775255,-74.393299,0,'2013-07-06 12:44:30',NULL,NULL),(29356,'32566','S','Navarre','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.500880,-86.896620,0,'2013-07-06 12:44:32',NULL,NULL),(75753,'94612','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.812882,-122.269830,0,'2013-07-06 12:44:34',NULL,NULL),(74003,'92110','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.763916,-117.201402,0,'2013-07-06 12:44:34',NULL,NULL),(1646,'00771','S','Valle Piedras','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(70804,'85367','S','Yuma','D','Yuma','04027','Arizona','AZ','04','9360','928','Mountain',-7.0,'N',32.655369,-114.383585,0,'2013-07-06 12:44:34',NULL,NULL),(50787,'58436','S','Monango','A','Dickey','38021','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.002161,-98.521819,0,'2013-07-06 12:44:33',NULL,NULL),(47524,'54806','S','Moquah','A','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.590566,-90.878699,0,'2013-07-06 12:44:32',NULL,NULL),(2868,'00985','S','Urb Rosa Maria','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(47775,'55042','S','Oakdale','N','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.993774,-92.907951,0,'2013-07-06 12:44:33',NULL,NULL),(38353,'43446','P','Middle Bass','D','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.648155,-82.817376,0,'2013-07-06 12:44:32',NULL,NULL),(21,'00603','S','Ext Marbella','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(79640,'99137','S','Hunters','D','Stevens','53065','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.152402,-118.128791,0,'2013-07-06 12:44:34',NULL,NULL),(34389,'38618','S','Wakefield','N','Tate','28137','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.689243,-89.979180,0,'2013-07-06 12:44:32',NULL,NULL),(11956,'12452','P','Lexington','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.240210,-74.364377,0,'2013-07-06 12:44:30',NULL,NULL),(1644,'00771','S','Urb Palma Royale','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(18014,'18640','S','Pittston Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.321046,-75.792617,0,'2013-07-06 12:44:31',NULL,NULL),(47873,'55084','S','Palmdale','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.411517,-92.664152,0,'2013-07-06 12:44:33',NULL,NULL),(9754,'10102','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(9706,'10060','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748746,-73.997962,0,'2013-07-06 12:44:30',NULL,NULL),(38889,'44110','S','East Cleveland','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.565195,-81.567100,0,'2013-07-06 12:44:32',NULL,NULL),(31700,'34949','S','Fort Pierce','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.475372,-80.302774,0,'2013-07-06 12:44:32',NULL,NULL),(33392,'37220','S','Melrose','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.067492,-86.781198,0,'2013-07-06 12:44:32',NULL,NULL),(32425,'35981','S','Ider','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.728552,-85.636151,0,'2013-07-06 12:44:32',NULL,NULL),(46241,'52807','S','Davenport','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.563174,-90.538577,0,'2013-07-06 12:44:32',NULL,NULL),(12898,'13334','S','Eaton','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827651,-75.654124,0,'2013-07-06 12:44:30',NULL,NULL),(27705,'30340','S','Atlanta','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.891239,-84.250847,0,'2013-07-06 12:44:31',NULL,NULL),(73925,'92027','S','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.138222,-117.045024,0,'2013-07-06 12:44:34',NULL,NULL),(57853,'67566','S','Partridge','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.964189,-98.090631,0,'2013-07-06 12:44:33',NULL,NULL),(67266,'79976','U','Southern Union Gas Co','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.817144,-106.442286,0,'2013-07-06 12:44:34',NULL,NULL),(72488,'89134','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.211320,-115.293840,0,'2013-07-06 12:44:34',NULL,NULL),(69180,'83334','S','Hansen','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.515005,-114.303296,0,'2013-07-06 12:44:34',NULL,NULL),(5339,'04605','S','Mariaville','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.828710,-68.365160,0,'2013-07-06 12:44:30',NULL,NULL),(4622,'03602','S','Alstead','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.154442,-72.304628,0,'2013-07-06 12:44:30',NULL,NULL),(65525,'77720','P','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.035549,-94.159229,0,'2013-07-06 12:44:34',NULL,NULL),(33339,'37162','P','Shelbyville','D','Bedford','47003','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.491536,-86.445995,0,'2013-07-06 12:44:32',NULL,NULL),(66118,'78417','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.728238,-97.443545,0,'2013-07-06 12:44:34',NULL,NULL),(16107,'17055','S','Defense Depot','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(14159,'14724','S','Clymer','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.052487,-79.669917,0,'2013-07-06 12:44:31',NULL,NULL),(34887,'38946','P','Morgan City','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.378180,-90.349864,0,'2013-07-06 12:44:32',NULL,NULL),(51106,'58783','S','Carbury','A','Bottineau','38009','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.920760,-100.825620,0,'2013-07-06 12:44:33',NULL,NULL),(13215,'13633','S','De Peyster','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.541079,-75.418940,0,'2013-07-06 12:44:30',NULL,NULL),(72997,'90059','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.926115,-118.242201,0,'2013-07-06 12:44:34',NULL,NULL),(48509,'55741','S','McKinley','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.512565,-92.411206,0,'2013-07-06 12:44:33',NULL,NULL),(36002,'40146','S','Irvington','D','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.874100,-86.295540,0,'2013-07-06 12:44:32',NULL,NULL),(31731,'34983','S','Saint Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.308284,-80.348414,0,'2013-07-06 12:44:32',NULL,NULL),(65150,'77389','S','Spring','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.047500,-95.532222,0,'2013-07-06 12:44:34',NULL,NULL),(64033,'76124','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.758223,-97.205267,0,'2013-07-06 12:44:34',NULL,NULL),(28460,'31415','S','Garden City','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.075555,-81.129128,0,'2013-07-06 12:44:32',NULL,NULL),(23017,'24828','S','Davy','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.470561,-81.659490,0,'2013-07-06 12:44:31',NULL,NULL),(39408,'44665','P','N Georgetown','A','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.839273,-80.986030,0,'2013-07-06 12:44:32',NULL,NULL),(79236,'98550','S','Woodlawn','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(14692,'15255','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.455892,-80.021962,0,'2013-07-06 12:44:31',NULL,NULL),(63154,'75389','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.770456,-96.687485,0,'2013-07-06 12:44:33',NULL,NULL),(54074,'62513','S','Blue Mound','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.699970,-89.118469,0,'2013-07-06 12:44:33',NULL,NULL),(49189,'56442','S','Cross Lake','N','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.677300,-94.112100,0,'2013-07-06 12:44:33',NULL,NULL),(43724,'48919','U','Lansing State Journal','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.730681,-84.552898,0,'2013-07-06 12:44:32',NULL,NULL),(22433,'24014','S','South Roanoke','N','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.234614,-79.934731,0,'2013-07-06 12:44:31',NULL,NULL),(22217,'23529','U','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.884721,-76.311064,0,'2013-07-06 12:44:31',NULL,NULL),(43707,'48897','S','Woodland','D','Barry','26015','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',42.707619,-85.129563,0,'2013-07-06 12:44:32',NULL,NULL),(13616,'13864','S','South Danby','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.276942,-76.378237,0,'2013-07-06 12:44:31',NULL,NULL),(79488,'98902','S','Harwood','N','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.595168,-120.537142,0,'2013-07-06 12:44:34',NULL,NULL),(44176,'49548','S','Wyoming','A','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.866570,-85.660484,0,'2013-07-06 12:44:32',NULL,NULL),(18949,'19508','S','Stonersville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(25904,'28645','S','Cajahs Mtn','A','Caldwell','37027','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.949000,-81.529800,0,'2013-07-06 12:44:31',NULL,NULL),(41677,'47170','S','Little York','A','Scott','18143','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.685010,-85.777663,0,'2013-07-06 12:44:32',NULL,NULL),(9155,'09311','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(64650,'76797','U','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.532449,-97.190218,0,'2013-07-06 12:44:34',NULL,NULL),(10183,'10285','U','Shearson American Express','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.710807,-74.015235,0,'2013-07-06 12:44:30',NULL,NULL),(30128,'33162','S','Uleta','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(77066,'96122','S','Delleker','N','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.842100,-120.468060,0,'2013-07-06 12:44:34',NULL,NULL),(24470,'27239','S','High Rock','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(39601,'44875','S','Bethlehem','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.888800,-82.662540,0,'2013-07-06 12:44:32',NULL,NULL),(40025,'45248','S','Dent','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.159624,-84.661853,0,'2013-07-06 12:44:32',NULL,NULL),(52581,'60973','S','Wellington','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.539251,-87.676600,0,'2013-07-06 12:44:33',NULL,NULL),(23704,'25873','P','Mac Arthur','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.759129,-81.208224,0,'2013-07-06 12:44:31',NULL,NULL),(17111,'17771','S','Marsh Hill','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(76047,'95172','P','San Jose','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.333829,-121.885149,0,'2013-07-06 12:44:34',NULL,NULL),(61329,'72454','S','Piggott','D','Clay','05021','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.383400,-90.195043,0,'2013-07-06 12:44:33',NULL,NULL),(14623,'15230','P','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.512020,-80.078900,0,'2013-07-06 12:44:31',NULL,NULL),(43240,'48316','S','Shelby Twp','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.680668,-83.052212,0,'2013-07-06 12:44:32',NULL,NULL),(16034,'17043','S','Wormleysburg','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.254300,-76.898040,0,'2013-07-06 12:44:31',NULL,NULL),(56906,'66047','S','Lawrence','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.946781,-95.281917,0,'2013-07-06 12:44:33',NULL,NULL),(46078,'52588','S','Selma','D','Van Buren','19177','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.857546,-92.123347,0,'2013-07-06 12:44:32',NULL,NULL),(7206,'06487','P','South Britain','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.469673,-73.251733,0,'2013-07-06 12:44:30',NULL,NULL),(41405,'46814','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.128755,-85.128368,0,'2013-07-06 12:44:32',NULL,NULL),(25638,'28466','S','Wallace','D','Duplin','37061','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.736924,-77.993819,0,'2013-07-06 12:44:31',NULL,NULL),(31253,'33981','S','Pt Charlotte','A','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.936512,-82.232968,0,'2013-07-06 12:44:32',NULL,NULL),(26739,'29420','S','Chas','N','Dorchester','45035','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.923689,-80.099458,0,'2013-07-06 12:44:31',NULL,NULL),(39237,'44425','S','Hubbard','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.163813,-80.581187,0,'2013-07-06 12:44:32',NULL,NULL),(32047,'35253','P','Mountain Brook','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.486215,-86.740394,0,'2013-07-06 12:44:32',NULL,NULL),(40646,'46036','S','Meadowood Est','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.272959,-85.843758,0,'2013-07-06 12:44:32',NULL,NULL),(79826,'99511','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.114540,-149.859371,0,'2013-07-06 12:44:34',NULL,NULL),(26495,'29169','S','Dixiana','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.988980,-81.100080,0,'2013-07-06 12:44:31',NULL,NULL),(29041,'32234','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.219367,-81.997401,0,'2013-07-06 12:44:32',NULL,NULL),(466,'00664','S','Jayuya','D','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(72113,'88250','S','Hope','D','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.754037,-104.744343,0,'2013-07-06 12:44:34',NULL,NULL),(15911,'17016','P','Cornwall','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.276374,-76.408476,0,'2013-07-06 12:44:31',NULL,NULL),(14411,'15066','S','New Brighton','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.734660,-80.289254,0,'2013-07-06 12:44:31',NULL,NULL),(41053,'46410','S','Gary','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.477940,-87.305820,0,'2013-07-06 12:44:32',NULL,NULL),(6128,'05459','S','Rixford','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(4600,'03585','S','Lyman','A','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.210565,-71.903972,0,'2013-07-06 12:44:30',NULL,NULL),(19245,'19934','S','Camden-Wy','N','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(67571,'80302','S','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.035467,-105.306748,0,'2013-07-06 12:44:34',NULL,NULL),(65238,'77453','P','Lane City','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.215350,-96.019905,0,'2013-07-06 12:44:34',NULL,NULL),(61756,'73050','P','Langston','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.942310,-97.252196,0,'2013-07-06 12:44:33',NULL,NULL),(53418,'61847','S','Gifford','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.307841,-88.020156,0,'2013-07-06 12:44:33',NULL,NULL),(15126,'15825','S','Hazen','A','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.174100,-79.067400,0,'2013-07-06 12:44:31',NULL,NULL),(5055,'04274','S','Poland Spring','A','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.018700,-70.371000,0,'2013-07-06 12:44:30',NULL,NULL),(61248,'72348','S','Horseshoe Lk','A','Saint Francis','05123','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.920523,-90.311029,0,'2013-07-06 12:44:33',NULL,NULL),(49686,'57020','S','Renner','A','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.661406,-96.808287,0,'2013-07-06 12:44:33',NULL,NULL),(97,'00612','S','Urb Costas del Atlantico','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(3738,'02163','S','Cambridge','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.369472,-71.124373,0,'2013-07-06 12:44:30',NULL,NULL),(72143,'88316','S','Capitan','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.545370,-105.578780,0,'2013-07-06 12:44:34',NULL,NULL),(5789,'05056','S','Plymouth Union','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.512000,-72.720000,0,'2013-07-06 12:44:30',NULL,NULL),(58626,'68862','S','Ord','D','Valley','31175','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.599708,-98.930085,0,'2013-07-06 12:44:33',NULL,NULL),(51754,'60021','S','Fox River Grove','D','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.192301,-88.222307,0,'2013-07-06 12:44:33',NULL,NULL),(43611,'48804','P','Mount Pleasant','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.606089,-84.688548,0,'2013-07-06 12:44:32',NULL,NULL),(64807,'77024','S','Hunters Creek Village','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(9778,'10106','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(58741,'68950','S','Holstein','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.434655,-98.666771,0,'2013-07-06 12:44:33',NULL,NULL),(56984,'66202','S','Prairie Vlg','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(53350,'61761','S','Merna','A','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.510903,-88.987912,0,'2013-07-06 12:44:33',NULL,NULL),(19834,'20502','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896958,-77.034624,0,'2013-07-06 12:44:31',NULL,NULL),(31161,'33917','S','N Fort Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.704114,-81.853949,0,'2013-07-06 12:44:32',NULL,NULL),(70564,'85050','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.693798,-111.999557,0,'2013-07-06 12:44:34',NULL,NULL),(24487,'27253','S','Graham','D','Alamance','37001','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.023611,-79.366835,0,'2013-07-06 12:44:31',NULL,NULL),(64162,'76210','S','Corinth','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.145623,-97.090468,0,'2013-07-06 12:44:34',NULL,NULL),(17529,'17972','S','Bohrmans Mill','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.632720,-76.155120,0,'2013-07-06 12:44:31',NULL,NULL),(58286,'68410','S','Paul','N','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.674994,-95.861844,0,'2013-07-06 12:44:33',NULL,NULL),(46082,'52591','S','Sigourney','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.332082,-92.206101,0,'2013-07-06 12:44:32',NULL,NULL),(25367,'28243','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.221435,-80.837627,0,'2013-07-06 12:44:31',NULL,NULL),(29350,'32561','S','Pensacola Beach','A','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.383106,-87.090524,0,'2013-07-06 12:44:32',NULL,NULL),(59889,'71270','S','Vienna','N','Lincoln','22061','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.484180,-92.668200,0,'2013-07-06 12:44:33',NULL,NULL),(36502,'40820','S','Cranks','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.757243,-83.199118,0,'2013-07-06 12:44:32',NULL,NULL),(17517,'17965','S','Schoentown','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.699019,-76.165915,0,'2013-07-06 12:44:31',NULL,NULL),(68300,'81091','S','Torres Canon','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(22909,'24604','P','Bishop','D','Tazewell','51185','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.210094,-81.555976,0,'2013-07-06 12:44:31',NULL,NULL),(56373,'65218','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.952596,-92.366496,0,'2013-07-06 12:44:33',NULL,NULL),(37531,'42051','S','Folsomdale','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(29173,'32358','S','Saint Teresa','A','Wakulla','12129','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.122839,-84.522762,0,'2013-07-06 12:44:32',NULL,NULL),(60547,'71724','P','Calion','D','Union','05139','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.323766,-92.548566,0,'2013-07-06 12:44:33',NULL,NULL),(20084,'20689','S','Sunderland','D','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.657098,-76.586489,0,'2013-07-06 12:44:31',NULL,NULL),(55293,'63501','S','Yarrow','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.193771,-92.583295,0,'2013-07-06 12:44:33',NULL,NULL),(12158,'12746','S','Huguenot','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.412347,-74.641586,0,'2013-07-06 12:44:30',NULL,NULL),(9776,'10106','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766517,-73.983784,0,'2013-07-06 12:44:30',NULL,NULL),(23714,'25888','U','Boy Scouts Of America','N','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.893074,-81.167686,0,'2013-07-06 12:44:31',NULL,NULL),(61192,'72216','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.825890,-92.216914,0,'2013-07-06 12:44:33',NULL,NULL),(8840,'08638','S','Ewing Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.266540,-74.712840,0,'2013-07-06 12:44:30',NULL,NULL),(79342,'98623','P','Husum','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.809185,-121.467884,0,'2013-07-06 12:44:34',NULL,NULL),(23752,'25951','S','Hinton','D','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.667392,-80.883909,0,'2013-07-06 12:44:31',NULL,NULL),(7310,'06614','S','Stratford','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.228282,-73.130796,0,'2013-07-06 12:44:30',NULL,NULL),(64161,'76209','S','Denton','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.232875,-97.107192,0,'2013-07-06 12:44:34',NULL,NULL),(1074,'00725','S','Repto Caguax','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(30988,'33761','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.029446,-82.724016,0,'2013-07-06 12:44:32',NULL,NULL),(25880,'28640','S','Jefferson','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.409140,-81.410460,0,'2013-07-06 12:44:31',NULL,NULL),(11947,'12442','S','Hunter','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.231420,-74.199420,0,'2013-07-06 12:44:30',NULL,NULL),(40476,'45769','S','Pomeroy','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.088080,-82.031760,0,'2013-07-06 12:44:32',NULL,NULL),(34914,'38959','P','Swiftown','D','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.407616,-90.374719,0,'2013-07-06 12:44:32',NULL,NULL),(5492,'04750','S','Loring Cm Ctr','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.912547,-67.826893,0,'2013-07-06 12:44:30',NULL,NULL),(10021,'10170','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749247,-73.976527,0,'2013-07-06 12:44:30',NULL,NULL),(19810,'20444','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896916,-77.008805,0,'2013-07-06 12:44:31',NULL,NULL),(7292,'06537','U','Advertising Distr Co','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.431433,-72.910481,0,'2013-07-06 12:44:30',NULL,NULL),(61509,'72651','S','Midway','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.287590,-92.438972,0,'2013-07-06 12:44:33',NULL,NULL),(21804,'23086','S','King William','D','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.680460,-77.068899,0,'2013-07-06 12:44:31',NULL,NULL),(5777,'05050','P','Mc Indoe Fls','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262531,-72.058292,0,'2013-07-06 12:44:30',NULL,NULL),(44605,'50052','S','Clio','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.680080,-93.498964,0,'2013-07-06 12:44:32',NULL,NULL),(29898,'33050','S','Conch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.723614,-81.046878,0,'2013-07-06 12:44:32',NULL,NULL),(78824,'98335','S','Elgin','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(29677,'32920','S','Port Canaveral','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.391416,-80.605396,0,'2013-07-06 12:44:32',NULL,NULL),(78902,'98362','S','Fairholm','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.043860,-123.505200,0,'2013-07-06 12:44:34',NULL,NULL),(10842,'11405','U','Motor Vehicle Bureau','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.699453,-73.788562,0,'2013-07-06 12:44:30',NULL,NULL),(47549,'54828','S','New Post','A','Sawyer','55113','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.796363,-91.343774,0,'2013-07-06 12:44:32',NULL,NULL),(18019,'18641','S','Dupont','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.329128,-75.746729,0,'2013-07-06 12:44:31',NULL,NULL),(56290,'65077','S','Steedman','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.757061,-91.782634,0,'2013-07-06 12:44:33',NULL,NULL),(23577,'25661','S','Williamson','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.673227,-82.277393,0,'2013-07-06 12:44:31',NULL,NULL),(63185,'75417','S','Bogata','D','Red River','48387','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.470271,-95.211469,0,'2013-07-06 12:44:33',NULL,NULL),(46375,'53129','S','Greendale','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.938162,-87.995124,0,'2013-07-06 12:44:32',NULL,NULL),(51540,'59725','S','Grant','N','Beaverhead','30001','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.211890,-112.649262,0,'2013-07-06 12:44:33',NULL,NULL),(28202,'31023','S','Plainfield','A','Dodge','13091','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.196771,-83.180079,0,'2013-07-06 12:44:31',NULL,NULL),(51427,'59454','S','Kevin','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.746263,-112.014265,0,'2013-07-06 12:44:33',NULL,NULL),(12396,'12927','P','Cranberry Lake','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.220251,-74.832828,0,'2013-07-06 12:44:30',NULL,NULL),(72987,'90056','S','Baldwin Hills','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.984248,-118.364182,0,'2013-07-06 12:44:34',NULL,NULL),(40169,'45368','S','S Charleston','A','Clark','39023','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.847694,-83.658868,0,'2013-07-06 12:44:32',NULL,NULL),(36164,'40242','S','Meadow Vale','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(45273,'50673','P','Stout','D','Grundy','19075','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.580592,-92.758845,0,'2013-07-06 12:44:32',NULL,NULL),(47151,'54466','S','City Point','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.448100,-90.177921,0,'2013-07-06 12:44:32',NULL,NULL),(51285,'59116','U','First Interstate Bank','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.767072,-108.581669,0,'2013-07-06 12:44:33',NULL,NULL),(17162,'17814','S','Central','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.234700,-76.347420,0,'2013-07-06 12:44:31',NULL,NULL),(77984,'97391','S','Toledo','D','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.627249,-123.932217,0,'2013-07-06 12:44:34',NULL,NULL),(27972,'30562','P','Mountain City','D','Rabun','13241','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.916566,-83.384658,0,'2013-07-06 12:44:31',NULL,NULL),(68643,'81639','S','Hayden','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.485154,-107.270273,0,'2013-07-06 12:44:34',NULL,NULL),(66964,'79403','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.603447,-101.814744,0,'2013-07-06 12:44:34',NULL,NULL),(12736,'13164','S','Warners','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.090879,-76.311279,0,'2013-07-06 12:44:30',NULL,NULL),(48859,'56074','S','Nicollet','D','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.277125,-94.189225,0,'2013-07-06 12:44:33',NULL,NULL),(15598,'16670','S','Queen','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.256461,-78.509722,0,'2013-07-06 12:44:31',NULL,NULL),(21099,'22041','S','Falls Church','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.846929,-77.142525,0,'2013-07-06 12:44:31',NULL,NULL),(21062,'21917','S','Colora','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.655213,-76.073020,0,'2013-07-06 12:44:31',NULL,NULL),(63013,'75166','S','Lavon','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.019982,-96.428233,0,'2013-07-06 12:44:33',NULL,NULL),(58071,'68058','P','South Bend','D','Cass','31025','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.000221,-96.246892,0,'2013-07-06 12:44:33',NULL,NULL),(70038,'84133','S','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.770852,-111.892118,0,'2013-07-06 12:44:34',NULL,NULL),(21630,'22909','U','State Farm Insurance','N','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.043210,-78.474036,0,'2013-07-06 12:44:31',NULL,NULL),(63989,'76110','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.704715,-97.334989,0,'2013-07-06 12:44:34',NULL,NULL),(47034,'54404','U','Marshfield','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.667961,-90.168447,0,'2013-07-06 12:44:32',NULL,NULL),(30468,'33339','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.163838,-80.113870,0,'2013-07-06 12:44:32',NULL,NULL),(37926,'42634','S','Honeybee','A','McCreary','21147','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.845915,-84.451334,0,'2013-07-06 12:44:32',NULL,NULL),(4229,'02857','S','North Scituate','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.833680,-71.641620,0,'2013-07-06 12:44:30',NULL,NULL),(7027,'06265','P','South Willington','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.854519,-72.301887,0,'2013-07-06 12:44:30',NULL,NULL),(70348,'84637','P','Kanosh','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.804613,-112.437798,0,'2013-07-06 12:44:34',NULL,NULL),(24653,'27404','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.084834,-79.832770,0,'2013-07-06 12:44:31',NULL,NULL),(47749,'55020','S','Elko','A','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.567439,-93.328186,0,'2013-07-06 12:44:33',NULL,NULL),(78381,'98024','S','Spring Glen','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.561848,-121.901429,0,'2013-07-06 12:44:34',NULL,NULL),(18868,'19450','P','Lederach','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.262252,-75.418734,0,'2013-07-06 12:44:31',NULL,NULL),(18789,'19380','S','West Chester','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.982089,-75.603385,0,'2013-07-06 12:44:31',NULL,NULL),(70681,'85249','S','Chandler','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.243258,-111.790921,0,'2013-07-06 12:44:34',NULL,NULL),(52419,'60646','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.007469,-87.741972,0,'2013-07-06 12:44:33',NULL,NULL),(49082,'56326','S','Evansville','D','Douglas','27041','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.006155,-95.687882,0,'2013-07-06 12:44:33',NULL,NULL),(69781,'84060','S','Deer Valley','A','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.697533,-111.526589,0,'2013-07-06 12:44:34',NULL,NULL),(77807,'97141','S','Cape Meares','N','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.466380,-123.716940,0,'2013-07-06 12:44:34',NULL,NULL),(29730,'32959','P','Sharpes','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.460307,-80.827428,0,'2013-07-06 12:44:32',NULL,NULL),(65470,'77630','S','West Orange','A','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.081944,-93.758056,0,'2013-07-06 12:44:34',NULL,NULL),(62317,'74038','S','Jennings','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.190677,-96.587636,0,'2013-07-06 12:44:33',NULL,NULL),(59660,'71051','S','Loggy Bayou','N','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.362958,-93.497801,0,'2013-07-06 12:44:33',NULL,NULL),(53883,'62352','P','Milton','D','Pike','17149','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.564157,-90.648463,0,'2013-07-06 12:44:33',NULL,NULL),(55422,'63656','S','Middle Brook','D','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.697252,-90.683551,0,'2013-07-06 12:44:33',NULL,NULL),(54027,'62459','P','Sainte Marie','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.934009,-88.021589,0,'2013-07-06 12:44:33',NULL,NULL),(50124,'57522','S','Degray','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.513605,-99.988191,0,'2013-07-06 12:44:33',NULL,NULL),(50070,'57446','S','Hecla','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.880108,-98.147006,0,'2013-07-06 12:44:33',NULL,NULL),(48732,'55962','S','Peterson','D','Fillmore','27045','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.774230,-91.848858,0,'2013-07-06 12:44:33',NULL,NULL),(6892,'06144','P','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790732,-72.669992,0,'2013-07-06 12:44:30',NULL,NULL),(28029,'30639','P','Franklin Spgs','A','Franklin','13119','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.274158,-83.172001,0,'2013-07-06 12:44:31',NULL,NULL),(61405,'72553','P','Magness','D','Independence','05063','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.706177,-91.482775,0,'2013-07-06 12:44:33',NULL,NULL),(72654,'89431','S','Happy Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.548066,-119.734394,0,'2013-07-06 12:44:34',NULL,NULL),(7954,'07676','S','Washington Tnshp','N','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.006449,-74.020718,0,'2013-07-06 12:44:30',NULL,NULL),(68814,'82440','P','Ralston','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.716065,-108.866082,0,'2013-07-06 12:44:34',NULL,NULL),(62646,'74574','S','Tuskahoma','D','Pushmataha','40127','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.739958,-95.264133,0,'2013-07-06 12:44:33',NULL,NULL),(19882,'20533','U','Bureau Narc and Dngr Drugs','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904566,-77.031907,0,'2013-07-06 12:44:31',NULL,NULL),(4473,'03264','S','Bridgewater','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.753373,-71.693831,0,'2013-07-06 12:44:30',NULL,NULL),(59737,'71129','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.424689,-93.897547,0,'2013-07-06 12:44:33',NULL,NULL),(79618,'99117','S','Creston','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.754972,-118.518513,0,'2013-07-06 12:44:34',NULL,NULL),(70740,'85309','S','Glendale','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.538316,-112.370171,0,'2013-07-06 12:44:34',NULL,NULL),(46607,'53562','S','Middleton','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.115280,-89.524920,0,'2013-07-06 12:44:32',NULL,NULL),(52642,'61054','S','Mount Morris','D','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.052377,-89.432066,0,'2013-07-06 12:44:33',NULL,NULL),(12183,'12768','S','Parksville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.868458,-74.721907,0,'2013-07-06 12:44:30',NULL,NULL),(54776,'62996','S','Villa Ridge','D','Pulaski','17153','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.157145,-89.175913,0,'2013-07-06 12:44:33',NULL,NULL),(24889,'27706','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.996830,-78.937993,0,'2013-07-06 12:44:31',NULL,NULL),(24325,'27022','S','Lawsonville','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.513484,-80.219058,0,'2013-07-06 12:44:31',NULL,NULL),(22562,'24148','S','Ridgeway','D','Henry','51089','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.614394,-79.864963,0,'2013-07-06 12:44:31',NULL,NULL),(67391,'80123','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(62792,'74883','S','Wetumka','D','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.237743,-96.239432,0,'2013-07-06 12:44:33',NULL,NULL),(12273,'12836','S','Graphite','N','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.788709,-73.497895,0,'2013-07-06 12:44:30',NULL,NULL),(44108,'49504','S','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.986465,-85.721042,0,'2013-07-06 12:44:32',NULL,NULL),(39119,'44258','P','Medina','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.101605,-82.124280,0,'2013-07-06 12:44:32',NULL,NULL),(48063,'55325','S','Kingston','A','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.092940,-94.315860,0,'2013-07-06 12:44:33',NULL,NULL),(18974,'19518','S','Yellow House','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(20472,'21041','P','Ellicott','N','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.273952,-76.836061,0,'2013-07-06 12:44:31',NULL,NULL),(3923,'02461','S','Newton Highlands','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.314739,-71.208012,0,'2013-07-06 12:44:30',NULL,NULL),(26300,'29031','S','Tuckertown','N','Union','45087','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.683284,-81.636507,0,'2013-07-06 12:44:31',NULL,NULL),(26409,'29114','S','Olanta','D','Florence','45041','South Carolina','SC','45','2655','843','Eastern',-5.0,'Y',33.927712,-79.905262,0,'2013-07-06 12:44:31',NULL,NULL),(28510,'31534','P','Douglas','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.506040,-82.849856,0,'2013-07-06 12:44:32',NULL,NULL),(77271,'96605','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(71488,'87102','S','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.077349,-106.653549,0,'2013-07-06 12:44:34',NULL,NULL),(59540,'70815','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.454915,-91.063684,0,'2013-07-06 12:44:33',NULL,NULL),(48365,'55553','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.813274,-93.920395,0,'2013-07-06 12:44:33',NULL,NULL),(21113,'22079','S','Lorton','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.690100,-77.206500,0,'2013-07-06 12:44:31',NULL,NULL),(61126,'72153','S','Shirley','D','Van Buren','05141','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.579400,-92.291580,0,'2013-07-06 12:44:33',NULL,NULL),(25592,'28447','S','Ivanhoe','D','Sampson','37163','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.693305,-78.162602,0,'2013-07-06 12:44:31',NULL,NULL),(3987,'02536','S','Hatchville','A','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.583018,-70.565899,0,'2013-07-06 12:44:30',NULL,NULL),(30317,'33305','S','Wilton Manors','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.156150,-80.122239,0,'2013-07-06 12:44:32',NULL,NULL),(25117,'27983','S','Windsor','D','Bertie','37015','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.997565,-76.943880,0,'2013-07-06 12:44:31',NULL,NULL),(70971,'85670','P','Fort Huachuca','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.550000,-110.350000,0,'2013-07-06 12:44:34',NULL,NULL),(21903,'23187','P','Wlmg','N','Williamsburg City','51830','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.268238,-76.710083,0,'2013-07-06 12:44:31',NULL,NULL),(40965,'46321','S','Hammond','A','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.555530,-87.497888,0,'2013-07-06 12:44:32',NULL,NULL),(11865,'12302','S','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(50567,'58220','S','Backoo','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.782525,-97.607866,0,'2013-07-06 12:44:33',NULL,NULL),(64372,'76528','S','Fort Gates','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(66483,'78665','S','Round Rock','D','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.530921,-97.651317,0,'2013-07-06 12:44:34',NULL,NULL),(72091,'88201','S','Roswell Industrial Air Cente','N','Chaves','35005','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.393099,-104.522917,0,'2013-07-06 12:44:34',NULL,NULL),(78552,'98148','S','Des Moines','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.425051,-122.332127,0,'2013-07-06 12:44:34',NULL,NULL),(69248,'83423','S','Idman','N','Clark','16033','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.179107,-112.228646,0,'2013-07-06 12:44:34',NULL,NULL),(68499,'81320','S','Cahone','D','Dolores','08033','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.692194,-108.757665,0,'2013-07-06 12:44:34',NULL,NULL),(56314,'65102','P','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.579476,-92.170918,0,'2013-07-06 12:44:33',NULL,NULL),(9773,'10105','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(72351,'89019','S','Primm','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.804011,-115.635842,0,'2013-07-06 12:44:34',NULL,NULL),(71206,'86304','P','Prescott','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.577357,-112.451141,0,'2013-07-06 12:44:34',NULL,NULL),(2211,'00926','S','Sect La Marina','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(75705,'94571','S','Rio Vista','D','Solano','06095','California','CA','06','8720','707','Pacific',-8.0,'Y',38.170067,-121.718396,0,'2013-07-06 12:44:34',NULL,NULL),(39948,'45231','S','N College Hl','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.244265,-84.540628,0,'2013-07-06 12:44:32',NULL,NULL),(25326,'28203','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.206514,-80.857866,0,'2013-07-06 12:44:31',NULL,NULL),(26523,'29202','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.972106,-80.975437,0,'2013-07-06 12:44:31',NULL,NULL),(5420,'04668','S','Grand Lake Stream','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.226109,-67.563119,0,'2013-07-06 12:44:30',NULL,NULL),(67735,'80551','U','Windsor','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.477500,-104.900833,0,'2013-07-06 12:44:34',NULL,NULL),(31187,'33932','P','Fort Myers Beach','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.449073,-81.932449,0,'2013-07-06 12:44:32',NULL,NULL),(71779,'87557','S','Ranchos Taos','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.307380,-105.613620,0,'2013-07-06 12:44:34',NULL,NULL),(5214,'04459','S','Molunkus Twp','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.544499,-68.310790,0,'2013-07-06 12:44:30',NULL,NULL),(5729,'05032','S','East Bethel','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.810080,-72.656700,0,'2013-07-06 12:44:30',NULL,NULL),(60959,'72103','S','Royal Oak','N','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.590766,-92.379460,0,'2013-07-06 12:44:33',NULL,NULL),(27559,'30260','S','Morrow','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.583733,-84.328154,0,'2013-07-06 12:44:31',NULL,NULL),(24390,'27103','S','Muddy Creek','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.069214,-80.316170,0,'2013-07-06 12:44:31',NULL,NULL),(8567,'08213','P','Cologne','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.499211,-74.608247,0,'2013-07-06 12:44:30',NULL,NULL),(76187,'95341','S','Merced','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.341483,-120.487724,0,'2013-07-06 12:44:34',NULL,NULL),(74050,'92152','U','Spawars System Center','N','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.691593,-117.247143,0,'2013-07-06 12:44:34',NULL,NULL),(55953,'64489','S','Stanberry','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.218266,-94.538896,0,'2013-07-06 12:44:33',NULL,NULL),(9553,'10023','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(840,'00698','S','Bo Alto de Cuba','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(25038,'27906','P','Elizabeth Cty','A','Pasquotank','37139','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.286618,-76.216871,0,'2013-07-06 12:44:31',NULL,NULL),(63646,'75844','S','Weches','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.492420,-95.483017,0,'2013-07-06 12:44:34',NULL,NULL),(29367,'32578','S','Niceville','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.505216,-86.454252,0,'2013-07-06 12:44:32',NULL,NULL),(41605,'47116','S','Eckerty','D','Crawford','18025','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.319039,-86.618917,0,'2013-07-06 12:44:32',NULL,NULL),(71590,'87316','P','Perea','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.432945,-108.725842,0,'2013-07-06 12:44:34',NULL,NULL),(63096,'75262','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.749718,-96.841253,0,'2013-07-06 12:44:33',NULL,NULL),(29362,'32571','S','Milton','D','Santa Rosa','12113','Florida','FL','12','6080','850','Central',-6.0,'Y',30.669600,-87.154920,0,'2013-07-06 12:44:32',NULL,NULL),(42815,'48059','S','Fort Gratiot','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.075603,-82.480044,0,'2013-07-06 12:44:32',NULL,NULL),(18510,'19102','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952547,-75.163950,0,'2013-07-06 12:44:31',NULL,NULL),(73459,'91304','S','Box Canyon','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.218348,-118.625847,0,'2013-07-06 12:44:34',NULL,NULL),(67855,'80822','S','Joes','D','Yuma','08125','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.745819,-102.623120,0,'2013-07-06 12:44:34',NULL,NULL),(44693,'50130','S','Jewell','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.304755,-93.640015,0,'2013-07-06 12:44:32',NULL,NULL),(53087,'61526','S','West Hallock','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.958700,-89.588220,0,'2013-07-06 12:44:33',NULL,NULL),(42800,'48049','S','North Street','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.036320,-82.574580,0,'2013-07-06 12:44:32',NULL,NULL),(6267,'05603','U','Montpelier','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.262128,-72.584362,0,'2013-07-06 12:44:30',NULL,NULL),(66995,'79502','S','Aspermont','D','Stonewall','48433','Texas','TX','48','0000','940','Central',-6.0,'Y',33.109200,-100.270800,0,'2013-07-06 12:44:34',NULL,NULL),(1232,'00729','S','Brisas de Canovanas','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(31999,'35226','S','Bluff Park','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.405053,-86.828320,0,'2013-07-06 12:44:32',NULL,NULL),(8366,'08053','S','Evesham','A','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(47776,'55043','S','Lake Saint Croix Beach','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(40010,'45246','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.279734,-84.471102,0,'2013-07-06 12:44:32',NULL,NULL),(19946,'20576','U','Natl Capitol Planning','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.898384,-77.032462,0,'2013-07-06 12:44:31',NULL,NULL),(1897,'00794','S','Urb Campo Alegre','N','Barranquitas','72019','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.187596,-66.307408,0,'2013-07-06 12:44:30',NULL,NULL),(49555,'56701','S','Tr Falls','N','Pennington','27113','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.115399,-96.174170,0,'2013-07-06 12:44:33',NULL,NULL),(35,'00603','S','Urb Marbella','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.433236,-67.151954,0,'2013-07-06 12:44:30',NULL,NULL),(18279,'19013','S','Chester Twp','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(17570,'18010','P','Ackermanville','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.864800,-75.207300,0,'2013-07-06 12:44:31',NULL,NULL),(40973,'46325','P','Hammond','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.614095,-87.514713,0,'2013-07-06 12:44:32',NULL,NULL),(59922,'71291','S','Forest Park','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(19364,'20053','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884726,-77.012221,0,'2013-07-06 12:44:31',NULL,NULL),(37010,'41226','S','Keaton','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.971849,-82.950663,0,'2013-07-06 12:44:32',NULL,NULL),(20423,'20911','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.994570,-77.032258,0,'2013-07-06 12:44:31',NULL,NULL),(77957,'97365','S','Agate Beach','N','Lincoln','41041','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.687599,-124.007012,0,'2013-07-06 12:44:34',NULL,NULL),(28746,'31997','U','AT&T Universal Card Service','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.485272,-84.830872,0,'2013-07-06 12:44:32',NULL,NULL),(70476,'84764','P','Bryce Canyon','A','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.677100,-112.155661,0,'2013-07-06 12:44:34',NULL,NULL),(65438,'77586','S','Taylor Lk Vlg','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.577120,-95.021220,0,'2013-07-06 12:44:34',NULL,NULL),(52186,'60466','S','University Pk','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.464740,-87.699000,0,'2013-07-06 12:44:33',NULL,NULL),(46540,'53404','S','Mt Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.740654,-87.809611,0,'2013-07-06 12:44:32',NULL,NULL),(78240,'97823','S','Condon','D','Gilliam','41021','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.234719,-120.192094,0,'2013-07-06 12:44:34',NULL,NULL),(76593,'95684','S','Somerset','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.602860,-120.630000,0,'2013-07-06 12:44:34',NULL,NULL),(19910,'20548','U','General Accounting Office','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900712,-77.019624,0,'2013-07-06 12:44:31',NULL,NULL),(17057,'17754','S','Montoursville','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(69975,'84120','S','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.696560,-112.017480,0,'2013-07-06 12:44:34',NULL,NULL),(17225,'17830','S','Urban','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.690745,-76.789710,0,'2013-07-06 12:44:31',NULL,NULL),(5382,'04640','S','Hancock','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.504622,-68.244777,0,'2013-07-06 12:44:30',NULL,NULL),(33784,'37876','S','Pittman Ctr','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.839522,-83.480286,0,'2013-07-06 12:44:32',NULL,NULL),(34325,'38558','S','Fairfield Glade','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(45924,'52330','S','Robinson','N','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.350073,-91.482006,0,'2013-07-06 12:44:32',NULL,NULL),(46042,'52561','S','Fremont','D','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.212479,-92.435459,0,'2013-07-06 12:44:32',NULL,NULL),(54107,'62544','S','Macon','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.716477,-88.998481,0,'2013-07-06 12:44:33',NULL,NULL),(20934,'21757','S','Detour','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.601199,-77.254452,0,'2013-07-06 12:44:31',NULL,NULL),(71541,'87158','U','Public Service Co','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.084393,-106.647676,0,'2013-07-06 12:44:34',NULL,NULL),(13196,'13622','S','Chaumont','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.064254,-76.129074,0,'2013-07-06 12:44:30',NULL,NULL),(2079,'00921','S','Urb Coop V Borinquen','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.391717,-66.090591,0,'2013-07-06 12:44:30',NULL,NULL),(5663,'04961','S','N New Portland','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.013248,-70.081728,0,'2013-07-06 12:44:30',NULL,NULL),(19201,'19884','U','Bank of America','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743248,-75.545385,0,'2013-07-06 12:44:31',NULL,NULL),(45339,'50864','S','Villisca','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.926401,-94.974732,0,'2013-07-06 12:44:32',NULL,NULL),(47997,'55145','U','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.945326,-93.094113,0,'2013-07-06 12:44:33',NULL,NULL),(2301,'00927','S','Urb Antonsanti','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(36846,'41076','S','Cold Sprgs Hi','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(7483,'06903','S','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.136379,-73.566393,0,'2013-07-06 12:44:30',NULL,NULL),(19142,'19701','S','Bear','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.609577,-75.690962,0,'2013-07-06 12:44:31',NULL,NULL),(22040,'23302','S','Assawoman','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.856541,-75.515792,0,'2013-07-06 12:44:31',NULL,NULL),(20308,'20815','S','North Chevy Chase','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.980206,-77.079720,0,'2013-07-06 12:44:31',NULL,NULL),(76538,'95659','S','Nicolaus','D','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.870336,-121.567175,0,'2013-07-06 12:44:34',NULL,NULL),(73497,'91329','U','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.246037,-118.531914,0,'2013-07-06 12:44:34',NULL,NULL),(27862,'30441','S','Greenway','N','Burke','13033','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.895717,-82.197463,0,'2013-07-06 12:44:31',NULL,NULL),(43456,'48550','U','Buick City','N','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.065739,-83.688105,0,'2013-07-06 12:44:32',NULL,NULL),(20082,'20687','S','Scotland','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.078266,-76.346702,0,'2013-07-06 12:44:31',NULL,NULL),(11130,'11706','S','North Bay Shore','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.636111,-73.197222,0,'2013-07-06 12:44:30',NULL,NULL),(17004,'17737','S','Tivoli','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257740,-76.713780,0,'2013-07-06 12:44:31',NULL,NULL),(10814,'11375','S','Parkside','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.721216,-73.850210,0,'2013-07-06 12:44:30',NULL,NULL),(31252,'33981','S','Port Charlotte','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.936512,-82.232968,0,'2013-07-06 12:44:32',NULL,NULL),(2298,'00927','S','Parq de Santa Maria','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388812,-66.073302,0,'2013-07-06 12:44:30',NULL,NULL),(67283,'80005','S','Westminster','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.841453,-105.117853,0,'2013-07-06 12:44:34',NULL,NULL),(44865,'50304','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.606979,-93.632601,0,'2013-07-06 12:44:32',NULL,NULL),(657,'00683','S','Ext Villa Interamericana','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(77485,'96823','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.307300,-157.844392,0,'2013-07-06 12:44:34',NULL,NULL),(67959,'80913','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.609596,-104.809735,0,'2013-07-06 12:44:34',NULL,NULL),(61828,'73111','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.508822,-97.472580,0,'2013-07-06 12:44:33',NULL,NULL),(59087,'70122','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.005955,-90.065104,0,'2013-07-06 12:44:33',NULL,NULL),(29434,'32686','S','Irvine','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.358780,-82.252850,0,'2013-07-06 12:44:32',NULL,NULL),(8174,'07874','S','Stanhope','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.920415,-74.699194,0,'2013-07-06 12:44:30',NULL,NULL),(39234,'44423','S','Hanoverton','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.765396,-80.906383,0,'2013-07-06 12:44:32',NULL,NULL),(73793,'91748','S','La Puente','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.979568,-117.898437,0,'2013-07-06 12:44:34',NULL,NULL),(17505,'17963','S','Irving','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.549020,-76.404120,0,'2013-07-06 12:44:31',NULL,NULL),(76082,'95211','U','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.982119,-121.309791,0,'2013-07-06 12:44:34',NULL,NULL),(79425,'98826','S','Telma','N','Chelan','53007','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.596320,-120.660180,0,'2013-07-06 12:44:34',NULL,NULL),(31448,'34281','P','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.489556,-82.579608,0,'2013-07-06 12:44:32',NULL,NULL),(42771,'48039','S','Cottrellville','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.719047,-82.521691,0,'2013-07-06 12:44:32',NULL,NULL),(20872,'21671','S','Tilghman','D','Talbot','24041','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.694278,-76.335784,0,'2013-07-06 12:44:31',NULL,NULL),(15301,'16142','S','New Wilmngtn','A','Lawrence','42073','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.118893,-80.336897,0,'2013-07-06 12:44:31',NULL,NULL),(60298,'71454','S','Mount Zion','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(59421,'70656','S','Pitkin','D','Vernon','22115','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.939362,-92.772121,0,'2013-07-06 12:44:33',NULL,NULL),(28537,'31554','S','Bickley','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(56103,'64784','S','Sheldon','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.658454,-94.297359,0,'2013-07-06 12:44:33',NULL,NULL),(59900,'71276','S','Sanbeimer','N','East Carroll','22035','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.571944,-91.182222,0,'2013-07-06 12:44:33',NULL,NULL),(28900,'32131','S','East Palatka','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.664677,-81.563252,0,'2013-07-06 12:44:32',NULL,NULL),(48542,'55757','S','Kettle River','D','Carlton','27017','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.513559,-92.920583,0,'2013-07-06 12:44:33',NULL,NULL),(44726,'50154','S','Mc Callsburg','D','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.165609,-93.389645,0,'2013-07-06 12:44:32',NULL,NULL),(22266,'23692','S','Grafton','A','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.177139,-76.459291,0,'2013-07-06 12:44:31',NULL,NULL),(15156,'15901','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.325297,-78.910953,0,'2013-07-06 12:44:31',NULL,NULL),(70908,'85625','S','Sunizona','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.935591,-109.803528,0,'2013-07-06 12:44:34',NULL,NULL),(62781,'74873','S','Pink','N','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.259960,-96.974340,0,'2013-07-06 12:44:33',NULL,NULL),(26016,'28677','S','East Monbo','N','Iredell','37097','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.845260,-80.899200,0,'2013-07-06 12:44:31',NULL,NULL),(35878,'39861','S','Jakin','D','Early','13099','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.184086,-85.006655,0,'2013-07-06 12:44:32',NULL,NULL),(38393,'43522','S','Grand Rapids','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.402142,-83.849564,0,'2013-07-06 12:44:32',NULL,NULL),(62282,'74017','S','Claremore','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.343020,-95.596680,0,'2013-07-06 12:44:33',NULL,NULL),(57930,'67701','S','Colby','D','Thomas','20193','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.394672,-101.047317,0,'2013-07-06 12:44:33',NULL,NULL),(52225,'60499','P','Bedford Park','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.782323,-87.767936,0,'2013-07-06 12:44:33',NULL,NULL),(39866,'45203','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.101841,-84.529638,0,'2013-07-06 12:44:32',NULL,NULL),(48279,'55432','S','Minneapolis','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.098640,-93.254963,0,'2013-07-06 12:44:33',NULL,NULL),(23214,'25075','S','Leewood','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(73552,'91361','S','Hidden Valley','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.152136,-118.846704,0,'2013-07-06 12:44:34',NULL,NULL),(66515,'78710','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.353420,-97.656761,0,'2013-07-06 12:44:34',NULL,NULL),(65451,'77611','S','Bridge City','D','Orange','48361','Texas','TX','48','0840','409','Central',-6.0,'Y',30.029508,-93.839065,0,'2013-07-06 12:44:34',NULL,NULL),(62297,'74023','S','Avery','N','Payne','40119','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.976349,-96.764819,0,'2013-07-06 12:44:33',NULL,NULL),(36197,'40261','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192741,-85.650714,0,'2013-07-06 12:44:32',NULL,NULL),(62093,'73570','S','Tipton','D','Tillman','40141','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.500360,-99.142663,0,'2013-07-06 12:44:33',NULL,NULL),(45556,'51501','S','Council Bluffs','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.254887,-95.852753,0,'2013-07-06 12:44:32',NULL,NULL),(50776,'58425','S','Cooperstwn','N','Griggs','38039','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.445786,-98.118678,0,'2013-07-06 12:44:33',NULL,NULL),(70599,'85098','U','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.448261,-112.075768,0,'2013-07-06 12:44:34',NULL,NULL),(41583,'47041','S','Lawrenceville','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(18946,'19508','S','Ridgewood','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(40629,'46017','S','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.084260,-85.604700,0,'2013-07-06 12:44:32',NULL,NULL),(12266,'12834','S','Battenville','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.090326,-73.500080,0,'2013-07-06 12:44:30',NULL,NULL),(15991,'17035','S','McCullochs Ml','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.434041,-77.587129,0,'2013-07-06 12:44:31',NULL,NULL),(29927,'33063','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.248973,-80.206871,0,'2013-07-06 12:44:32',NULL,NULL),(69688,'84027','P','Fruitland','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.210774,-110.839417,0,'2013-07-06 12:44:34',NULL,NULL),(9006,'08857','S','Old Bridge','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.400392,-74.324601,0,'2013-07-06 12:44:30',NULL,NULL),(74933,'93406','P','SN Luis Obisp','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.246254,-120.639327,0,'2013-07-06 12:44:34',NULL,NULL),(14934,'15558','S','Salisbury','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.751569,-79.088316,0,'2013-07-06 12:44:31',NULL,NULL),(38376,'43469','S','Woodville','D','Sandusky','39143','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.448066,-83.371641,0,'2013-07-06 12:44:32',NULL,NULL),(40616,'45999','U','Internal Revenue Service','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.085561,-84.513589,0,'2013-07-06 12:44:32',NULL,NULL),(4196,'02826','P','Glendale','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.983366,-71.627803,0,'2013-07-06 12:44:30',NULL,NULL),(66040,'78368','S','Swinney Swtch','A','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(41213,'46730','S','Fairfield Center','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.438215,-85.154373,0,'2013-07-06 12:44:32',NULL,NULL),(46926,'54153','S','Pensaukee','N','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.893296,-87.900009,0,'2013-07-06 12:44:32',NULL,NULL),(841,'00698','S','Bo Palomas','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(24493,'27260','S','Glenola','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(3897,'02447','P','Brookline Village','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.333546,-71.118745,0,'2013-07-06 12:44:30',NULL,NULL),(74800,'93202','S','Armona','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.310673,-119.707822,0,'2013-07-06 12:44:34',NULL,NULL),(16188,'17068','S','New Bloomfld','A','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.418905,-77.189502,0,'2013-07-06 12:44:31',NULL,NULL),(56994,'66203','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.017760,-94.696860,0,'2013-07-06 12:44:33',NULL,NULL),(53093,'61530','S','Eureka','D','Woodford','17203','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.716571,-89.276742,0,'2013-07-06 12:44:33',NULL,NULL),(39524,'44822','S','Butler','D','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.583729,-82.415811,0,'2013-07-06 12:44:32',NULL,NULL),(60864,'72055','S','Arkansas Post National Memor','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.120469,-91.378469,0,'2013-07-06 12:44:33',NULL,NULL),(39466,'44709','S','North Canton','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.839184,-81.389308,0,'2013-07-06 12:44:32',NULL,NULL),(32357,'35816','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.737489,-86.624911,0,'2013-07-06 12:44:32',NULL,NULL),(74735,'93042','U','Naval Air Warfare Ctr','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.122182,-119.092865,0,'2013-07-06 12:44:34',NULL,NULL),(79709,'99211','P','Spokane Vly','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.665303,-117.310120,0,'2013-07-06 12:44:34',NULL,NULL),(75466,'94088','P','Sunnyvale','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.390976,-122.037328,0,'2013-07-06 12:44:34',NULL,NULL),(13339,'13685','S','Sackets Harbor','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.943471,-76.111664,0,'2013-07-06 12:44:30',NULL,NULL),(12926,'13340','S','Schuyler','A','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.040165,-75.082322,0,'2013-07-06 12:44:30',NULL,NULL),(11357,'11804','S','Old Bethpage','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.768333,-73.525556,0,'2013-07-06 12:44:30',NULL,NULL),(32747,'36331','P','Eprise','N','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.326065,-85.854309,0,'2013-07-06 12:44:32',NULL,NULL),(64221,'76272','S','Valley View','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.476767,-97.104797,0,'2013-07-06 12:44:34',NULL,NULL),(63703,'75884','U','Tennessee Colony','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.834403,-95.840540,0,'2013-07-06 12:44:34',NULL,NULL),(28779,'32035','P','Fernandina Beach','D','Nassau','12089','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.670498,-81.462032,0,'2013-07-06 12:44:32',NULL,NULL),(1348,'00736','S','Est de Monte Rio','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(34971,'39082','S','Harrisville','D','Simpson','28127','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.957765,-90.093264,0,'2013-07-06 12:44:32',NULL,NULL),(43663,'48855','S','Howell','D','Livingston','26093','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',42.620163,-83.917238,0,'2013-07-06 12:44:32',NULL,NULL),(9539,'10021','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.768479,-73.960718,0,'2013-07-06 12:44:30',NULL,NULL),(1853,'00791','S','Colinas del Este','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(75749,'94610','S','Piedmontxxx','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.815060,-122.239672,0,'2013-07-06 12:44:34',NULL,NULL),(28892,'32127','S','Wilbur By Sea','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.110341,-80.980002,0,'2013-07-06 12:44:32',NULL,NULL),(3656,'02120','S','Roxbury Crossing','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.334141,-71.097433,0,'2013-07-06 12:44:30',NULL,NULL),(21394,'22508','S','Lake of the Woods','A','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.333379,-77.762530,0,'2013-07-06 12:44:31',NULL,NULL),(47132,'54455','S','Halder','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(11846,'12249','U','NY Labor Unemp Ins','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.697178,-73.994306,0,'2013-07-06 12:44:30',NULL,NULL),(30061,'33149','S','Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.694059,-80.166798,0,'2013-07-06 12:44:32',NULL,NULL),(3576,'01966','S','Rockport','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.658742,-70.618711,0,'2013-07-06 12:44:30',NULL,NULL),(64614,'76689','S','Valley Mills','D','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',31.674120,-97.509300,0,'2013-07-06 12:44:34',NULL,NULL),(21813,'23103','S','Manakin','N','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.653832,-77.725631,0,'2013-07-06 12:44:31',NULL,NULL),(61144,'72166','S','Tichnor','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057122,-91.234851,0,'2013-07-06 12:44:33',NULL,NULL),(53810,'62295','S','Fountain','N','Monroe','17133','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.280452,-90.340506,0,'2013-07-06 12:44:33',NULL,NULL),(53124,'61546','S','Talbott','N','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.421867,-89.779680,0,'2013-07-06 12:44:33',NULL,NULL),(41278,'46755','S','Wayne Center','N','Noble','18113','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.448737,-85.263287,0,'2013-07-06 12:44:32',NULL,NULL),(39565,'44849','S','Little York','N','Wyandot','39175','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.826400,-83.130900,0,'2013-07-06 12:44:32',NULL,NULL),(64845,'77044','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.899678,-95.180002,0,'2013-07-06 12:44:34',NULL,NULL),(60766,'72012','S','Beebe','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.073551,-91.896331,0,'2013-07-06 12:44:33',NULL,NULL),(6378,'05682','S','N Middlesex','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.408965,-72.573124,0,'2013-07-06 12:44:30',NULL,NULL),(2457,'00953','S','Vistas Del Rio Iii','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(79029,'98392','S','Suquamish','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.736954,-122.560402,0,'2013-07-06 12:44:34',NULL,NULL),(78766,'98310','S','Bremerton','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.610346,-122.631677,0,'2013-07-06 12:44:34',NULL,NULL),(52872,'61337','S','Zearing','N','Bureau','17011','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.425406,-89.368028,0,'2013-07-06 12:44:33',NULL,NULL),(8656,'08315','P','Dividing Crk','A','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.269693,-75.104860,0,'2013-07-06 12:44:30',NULL,NULL),(35466,'39503','S','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.473100,-89.153820,0,'2013-07-06 12:44:32',NULL,NULL),(55935,'64473','S','Oregon','D','Holt','29087','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.993891,-95.139533,0,'2013-07-06 12:44:33',NULL,NULL),(48479,'55723','S','Togo','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.867400,-92.779260,0,'2013-07-06 12:44:33',NULL,NULL),(29507,'32765','S','Oviedo','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.648105,-81.210071,0,'2013-07-06 12:44:32',NULL,NULL),(45713,'52066','S','N Buena Vista','A','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.672057,-90.967071,0,'2013-07-06 12:44:32',NULL,NULL),(20214,'20768','P','Greenbelt','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.000621,-76.877752,0,'2013-07-06 12:44:31',NULL,NULL),(25022,'27887','P','Tillery','D','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.254271,-77.487612,0,'2013-07-06 12:44:31',NULL,NULL),(54959,'63120','S','Pine Lawn','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.690003,-90.261886,0,'2013-07-06 12:44:33',NULL,NULL),(31786,'35023','S','Hueytown','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.411900,-87.046140,0,'2013-07-06 12:44:32',NULL,NULL),(65833,'78152','S','Saint Hedwig','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.436023,-98.201979,0,'2013-07-06 12:44:34',NULL,NULL),(13770,'14139','S','South Wales','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.718999,-78.536856,0,'2013-07-06 12:44:31',NULL,NULL),(73413,'91184','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.141599,-118.157559,0,'2013-07-06 12:44:34',NULL,NULL),(1915,'00795','S','Hacienda Las Vegas','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(46687,'53782','U','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.063213,-89.315194,0,'2013-07-06 12:44:32',NULL,NULL),(4861,'04021','S','Cumberlnd Ctr','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.811530,-70.263280,0,'2013-07-06 12:44:30',NULL,NULL),(73213,'90620','S','Buena Park','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.843903,-118.007993,0,'2013-07-06 12:44:34',NULL,NULL),(66512,'78705','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.291487,-97.733878,0,'2013-07-06 12:44:34',NULL,NULL),(13754,'14125','S','East Oakfield','N','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.078642,-78.272493,0,'2013-07-06 12:44:31',NULL,NULL),(35530,'39555','P','Hurley','D','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.674763,-88.485871,0,'2013-07-06 12:44:32',NULL,NULL),(5535,'04783','S','Stockholm','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.055284,-68.256011,0,'2013-07-06 12:44:30',NULL,NULL),(64598,'76680','S','Eloise','N','Falls','48145','Texas','TX','48','0000','254','Central',-6.0,'Y',31.238487,-96.754011,0,'2013-07-06 12:44:34',NULL,NULL),(26745,'29423','P','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.845603,-79.977751,0,'2013-07-06 12:44:31',NULL,NULL),(46534,'53402','S','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.797800,-87.832227,0,'2013-07-06 12:44:32',NULL,NULL),(40432,'45712','P','Barlow','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.394944,-81.667760,0,'2013-07-06 12:44:32',NULL,NULL),(21200,'22193','S','Dale City','A','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.646162,-77.349693,0,'2013-07-06 12:44:31',NULL,NULL),(43351,'48386','S','White Lake','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.642161,-83.471924,0,'2013-07-06 12:44:32',NULL,NULL),(8635,'08260','S','Wildwood Crst','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(62451,'74193','U','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.061650,-95.923301,0,'2013-07-06 12:44:33',NULL,NULL),(62005,'73439','S','Kingston','D','Marshall','40095','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.988351,-96.707799,0,'2013-07-06 12:44:33',NULL,NULL),(52976,'61430','S','E Galesburg','A','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.948243,-90.312728,0,'2013-07-06 12:44:33',NULL,NULL),(46263,'53019','S','Eden','D','Fond du Lac','55039','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.695123,-88.338784,0,'2013-07-06 12:44:32',NULL,NULL),(43521,'48650','S','Pinconning','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.847680,-83.990744,0,'2013-07-06 12:44:32',NULL,NULL),(40703,'46104','S','Arlington','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.656163,-85.574678,0,'2013-07-06 12:44:32',NULL,NULL),(34128,'38197','U','International Paper Co','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099040,-89.848207,0,'2013-07-06 12:44:32',NULL,NULL),(63207,'75442','S','Farmersville','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.169385,-96.368070,0,'2013-07-06 12:44:33',NULL,NULL),(60238,'71432','S','Mudville','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.738200,-92.391755,0,'2013-07-06 12:44:33',NULL,NULL),(6437,'05747','S','Lower Granville','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.006169,-72.841833,0,'2013-07-06 12:44:30',NULL,NULL),(35349,'39440','S','Cleo','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(74836,'93240','S','Lake Isabella','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.628560,-118.440370,0,'2013-07-06 12:44:34',NULL,NULL),(63898,'76020','S','Sanctuary','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.910000,-97.557240,0,'2013-07-06 12:44:34',NULL,NULL),(63552,'75766','S','Cove Spring','N','Cherokee','48073','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.950060,-95.257500,0,'2013-07-06 12:44:33',NULL,NULL),(11804,'12228','U','NY Dept Of Motor Vehicles','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.645681,-73.756663,0,'2013-07-06 12:44:30',NULL,NULL),(32912,'36548','S','Leroy','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.516479,-87.896552,0,'2013-07-06 12:44:32',NULL,NULL),(32927,'36558','S','Millry','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(80100,'99751','P','Kobuk','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.977609,-155.882969,0,'2013-07-06 12:44:34',NULL,NULL),(27738,'30354','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.658320,-84.384600,0,'2013-07-06 12:44:31',NULL,NULL),(27047,'29671','S','Pickens','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.889416,-82.727390,0,'2013-07-06 12:44:31',NULL,NULL),(6816,'06111','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688552,-72.729085,0,'2013-07-06 12:44:30',NULL,NULL),(32835,'36475','S','Repton','D','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.431480,-87.189300,0,'2013-07-06 12:44:32',NULL,NULL),(55582,'63882','P','Wyatt','D','Mississippi','29133','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.917072,-89.223405,0,'2013-07-06 12:44:33',NULL,NULL),(47874,'55084','S','Taylors Falls','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.411517,-92.664152,0,'2013-07-06 12:44:33',NULL,NULL),(42583,'47881','P','Staunton','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.516140,-87.124206,0,'2013-07-06 12:44:32',NULL,NULL),(44449,'49865','P','National Mine','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.457683,-87.681834,0,'2013-07-06 12:44:32',NULL,NULL),(71987,'88027','P','Chamberino','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.032495,-106.662104,0,'2013-07-06 12:44:34',NULL,NULL),(10924,'11431','P','Jamaica','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.717893,-73.793487,0,'2013-07-06 12:44:30',NULL,NULL),(59070,'70097','P','Kenner','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.989880,-90.242058,0,'2013-07-06 12:44:33',NULL,NULL),(34913,'38959','P','Itta Bena','N','Leflore','28083','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.407616,-90.374719,0,'2013-07-06 12:44:32',NULL,NULL),(58923,'69339','S','Fort Robinson','N','Dawes','31045','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.658320,-103.409940,0,'2013-07-06 12:44:33',NULL,NULL),(39686,'45030','S','Fort Scott Camps','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.251160,-84.739620,0,'2013-07-06 12:44:32',NULL,NULL),(44519,'49947','S','Merriweather','A','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.375800,-89.593980,0,'2013-07-06 12:44:32',NULL,NULL),(25793,'28604','S','Sugar Mountain','A','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.172200,-81.825180,0,'2013-07-06 12:44:31',NULL,NULL),(33356,'37184','S','Watertown','D','Wilson','47189','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108708,-86.136719,0,'2013-07-06 12:44:32',NULL,NULL),(10257,'10499','U','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.827159,-73.824345,0,'2013-07-06 12:44:30',NULL,NULL),(62483,'74349','P','Ketchum','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.522655,-95.024834,0,'2013-07-06 12:44:33',NULL,NULL),(65492,'77657','S','Rose Hill Acres','A','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.249112,-94.191872,0,'2013-07-06 12:44:34',NULL,NULL),(38604,'43843','S','Walhonding','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.311486,-82.219602,0,'2013-07-06 12:44:32',NULL,NULL),(28299,'31106','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.787616,-84.355516,0,'2013-07-06 12:44:31',NULL,NULL),(22095,'23412','P','Modest Town','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.833363,-75.568987,0,'2013-07-06 12:44:31',NULL,NULL),(33134,'36904','S','Butler','D','Choctaw','01023','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',32.091455,-88.222286,0,'2013-07-06 12:44:32',NULL,NULL),(39149,'44286','S','West Richfield','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.231451,-81.641199,0,'2013-07-06 12:44:32',NULL,NULL),(16728,'17408','S','W Manchester','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015315,-76.597579,0,'2013-07-06 12:44:31',NULL,NULL),(23300,'25185','U','Mount Olive','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.240034,-81.233861,0,'2013-07-06 12:44:31',NULL,NULL),(44920,'50333','P','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.678246,-93.610113,0,'2013-07-06 12:44:32',NULL,NULL),(18070,'18704','S','Swoyersville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.264580,-75.888180,0,'2013-07-06 12:44:31',NULL,NULL),(7754,'07395','U','USPS','N','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.727933,-74.077952,0,'2013-07-06 12:44:30',NULL,NULL),(56344,'65201','S','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.896440,-92.246280,0,'2013-07-06 12:44:33',NULL,NULL),(63769,'75948','S','East Mayfield','N','Sabine','48403','Texas','TX','48','0000','409','Central',-6.0,'Y',31.308720,-93.771600,0,'2013-07-06 12:44:34',NULL,NULL),(53082,'61524','P','Dunfermline','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.487157,-90.020667,0,'2013-07-06 12:44:33',NULL,NULL),(15276,'16113','P','Clark','D','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.279695,-80.423889,0,'2013-07-06 12:44:31',NULL,NULL),(19250,'19938','S','Clayton','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.300955,-75.708637,0,'2013-07-06 12:44:31',NULL,NULL),(68719,'82072','S','Jelm','A','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.061360,-106.014750,0,'2013-07-06 12:44:34',NULL,NULL),(66563,'78736','S','Oak Hill','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250073,-97.926724,0,'2013-07-06 12:44:34',NULL,NULL),(25710,'28542','P','Camp Lejeune','D','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.697778,-77.352038,0,'2013-07-06 12:44:31',NULL,NULL),(61836,'73115','S','Del City','A','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.438660,-97.439577,0,'2013-07-06 12:44:33',NULL,NULL),(17975,'18614','S','Wilmot Township','A','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.522494,-76.401012,0,'2013-07-06 12:44:31',NULL,NULL),(34841,'38922','S','Benwood','N','Yalobusha','28161','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.976963,-89.676645,0,'2013-07-06 12:44:32',NULL,NULL),(4757,'03849','S','Madison','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.890397,-71.116993,0,'2013-07-06 12:44:30',NULL,NULL),(12082,'12555','P','Mid Hudson','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.508604,-74.013373,0,'2013-07-06 12:44:30',NULL,NULL),(62872,'75041','S','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.883060,-96.642717,0,'2013-07-06 12:44:33',NULL,NULL),(57307,'66629','U','Blue Cross','N','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.048063,-95.682616,0,'2013-07-06 12:44:33',NULL,NULL),(48546,'55760','S','Lawler','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.707780,-93.296880,0,'2013-07-06 12:44:33',NULL,NULL),(43886,'49230','S','Brooklyn','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.103506,-84.245512,0,'2013-07-06 12:44:32',NULL,NULL),(35710,'39667','S','Mesa','N','Walthall','28147','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.163040,-90.133620,0,'2013-07-06 12:44:32',NULL,NULL),(76567,'95670','S','Rancho Cordova','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.603520,-121.248060,0,'2013-07-06 12:44:34',NULL,NULL),(3352,'01561','P','South Lancaster','D','Worcester','25027','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.441040,-71.689995,0,'2013-07-06 12:44:30',NULL,NULL),(70482,'84767','P','Zion National Park','A','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.185515,-112.998069,0,'2013-07-06 12:44:34',NULL,NULL),(33051,'36753','P','Mc Williams','D','Wilcox','01131','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.830584,-87.095985,0,'2013-07-06 12:44:32',NULL,NULL),(46581,'53534','S','Edgerton','D','Rock','55105','Wisconsin','WI','55','3620','608','Central',-6.0,'Y',42.822805,-89.063685,0,'2013-07-06 12:44:32',NULL,NULL),(70987,'85709','U','Pima Community College','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.231493,-111.013919,0,'2013-07-06 12:44:34',NULL,NULL),(77025,'96099','P','Redding','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.641465,-122.506104,0,'2013-07-06 12:44:34',NULL,NULL),(18358,'19038','S','Ardsley','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.107900,-75.157080,0,'2013-07-06 12:44:31',NULL,NULL),(14541,'15209','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.496241,-79.979064,0,'2013-07-06 12:44:31',NULL,NULL),(4416,'03227','S','Center Sandwich','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.834383,-71.477065,0,'2013-07-06 12:44:30',NULL,NULL),(20617,'21211','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.330421,-76.637183,0,'2013-07-06 12:44:31',NULL,NULL),(9850,'10118','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748827,-73.996353,0,'2013-07-06 12:44:30',NULL,NULL),(71613,'87327','P','Zuni','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(9755,'10102','U','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.764955,-73.982933,0,'2013-07-06 12:44:30',NULL,NULL),(59359,'70577','S','Port Barre','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.541871,-91.963950,0,'2013-07-06 12:44:33',NULL,NULL),(57584,'67067','S','Kechi','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.770844,-97.293167,0,'2013-07-06 12:44:33',NULL,NULL),(33878,'38021','P','Crockett Mills','D','Crockett','47033','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.911875,-89.190532,0,'2013-07-06 12:44:32',NULL,NULL),(41070,'46516','S','Elkhart','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.677793,-85.960517,0,'2013-07-06 12:44:32',NULL,NULL),(35290,'39401','S','Indian Springs','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(67894,'80866','P','Woodland Park','D','Teller','08119','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.994835,-105.060746,0,'2013-07-06 12:44:34',NULL,NULL),(65378,'77541','S','Surfside Beach','A','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',28.951980,-95.366280,0,'2013-07-06 12:44:34',NULL,NULL),(44129,'49509','S','Wyoming','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.883860,-85.706160,0,'2013-07-06 12:44:32',NULL,NULL),(43012,'48164','S','Brownstown TWP','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.129384,-83.390387,0,'2013-07-06 12:44:32',NULL,NULL),(37791,'42368','S','Reynolds Station','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.698386,-86.772446,0,'2013-07-06 12:44:32',NULL,NULL),(31035,'33805','S','Gibsonia','N','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.085598,-81.975530,0,'2013-07-06 12:44:32',NULL,NULL),(26947,'29602','P','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.855034,-82.408153,0,'2013-07-06 12:44:31',NULL,NULL),(67659,'80479','S','Toponas','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.050052,-106.834689,0,'2013-07-06 12:44:34',NULL,NULL),(65842,'78160','S','Stockdale','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.232249,-97.963196,0,'2013-07-06 12:44:34',NULL,NULL),(2887,'00987','S','Loma Alta','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(51161,'58856','S','Hanks','N','Williams','38105','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.589053,-103.668530,0,'2013-07-06 12:44:33',NULL,NULL),(46712,'53801','S','Wyalusing','N','Grant','55043','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.923562,-91.056053,0,'2013-07-06 12:44:32',NULL,NULL),(31679,'34771','S','Saint Cloud','D','Osceola','12097','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.287024,-81.213434,0,'2013-07-06 12:44:32',NULL,NULL),(75793,'94709','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.879509,-122.262241,0,'2013-07-06 12:44:34',NULL,NULL),(66136,'78466','P','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.744040,-97.381702,0,'2013-07-06 12:44:34',NULL,NULL),(15859,'16945','P','Sylvania','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.805044,-76.854875,0,'2013-07-06 12:44:31',NULL,NULL),(59717,'71107','S','Industrial','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.608620,-93.862080,0,'2013-07-06 12:44:33',NULL,NULL),(44084,'49456','S','Norton Shores','A','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.086511,-86.189307,0,'2013-07-06 12:44:32',NULL,NULL),(17783,'18348','P','Pocono Lake Preserve','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.106882,-75.479231,0,'2013-07-06 12:44:31',NULL,NULL),(7472,'06883','S','Weston','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.216732,-73.366948,0,'2013-07-06 12:44:30',NULL,NULL),(45177,'50606','S','Arlington','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.768576,-91.693918,0,'2013-07-06 12:44:32',NULL,NULL),(37021,'41240','S','Offutt','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(21225,'22216','P','Arlington','D','Arlington','51013','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.891625,-77.085322,0,'2013-07-06 12:44:31',NULL,NULL),(65325,'77515','S','Baileys Prairie','N','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.168122,-95.425065,0,'2013-07-06 12:44:34',NULL,NULL),(56538,'65443','S','Brinktown','D','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.090350,-92.117392,0,'2013-07-06 12:44:33',NULL,NULL),(8018,'07724','S','Tinton Falls','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.299859,-74.070754,0,'2013-07-06 12:44:30',NULL,NULL),(25954,'28657','S','Roaring Creek','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(33472,'37333','S','Farner','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.135821,-84.325911,0,'2013-07-06 12:44:32',NULL,NULL),(33121,'36869','S','Phenix City','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.443587,-85.024696,0,'2013-07-06 12:44:32',NULL,NULL),(29210,'32413','S','Panama City','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.243545,-85.907737,0,'2013-07-06 12:44:32',NULL,NULL),(41251,'46742','S','Penn Park','N','Steuben','18151','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.538720,-84.898920,0,'2013-07-06 12:44:32',NULL,NULL),(918,'00707','S','Villas de Maunabo','N','Maunabo','72095','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.010343,-65.896868,0,'2013-07-06 12:44:30',NULL,NULL),(7923,'07643','S','Little Ferry','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.847729,-74.043006,0,'2013-07-06 12:44:30',NULL,NULL),(52519,'60910','P','Aroma Park','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.083343,-87.805365,0,'2013-07-06 12:44:33',NULL,NULL),(44362,'49784','U','Sault S Marie','A','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.258915,-84.381415,0,'2013-07-06 12:44:32',NULL,NULL),(57573,'67058','S','Duquoin','N','Harper','20077','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.285895,-98.026088,0,'2013-07-06 12:44:33',NULL,NULL),(56048,'64730','S','Butler','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.256683,-94.337631,0,'2013-07-06 12:44:33',NULL,NULL),(38891,'44112','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.534374,-81.574679,0,'2013-07-06 12:44:32',NULL,NULL),(6915,'06153','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688148,-72.728859,0,'2013-07-06 12:44:30',NULL,NULL),(19018,'19529','S','Trexler','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(20187,'20748','S','Hillcrest Heights','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.816051,-76.939606,0,'2013-07-06 12:44:31',NULL,NULL),(61565,'72728','P','Elm Springs','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.205388,-94.231692,0,'2013-07-06 12:44:33',NULL,NULL),(10042,'10174','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(40771,'46155','P','Mays','D','Rush','18139','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.742938,-85.429654,0,'2013-07-06 12:44:32',NULL,NULL),(2630,'00962','S','Villa Aurora','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(2718,'00969','S','Urb Alto Apolo','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(2742,'00969','S','Urb Munoz Rivera','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(42057,'47448','S','Cloud Crst Hls','N','Brown','18013','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.192600,-86.220600,0,'2013-07-06 12:44:32',NULL,NULL),(54427,'62837','S','Fairfield','D','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(808,'00693','S','Urb Camino del Sol','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(45618,'51576','S','Underwood','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.317278,-95.708118,0,'2013-07-06 12:44:32',NULL,NULL),(48033,'55304','S','County Market','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.254700,-93.240480,0,'2013-07-06 12:44:33',NULL,NULL),(58379,'68542','P','Lincoln','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.787298,-96.700531,0,'2013-07-06 12:44:33',NULL,NULL),(64596,'76679','S','Pursley','N','Navarro','48349','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.949322,-96.573146,0,'2013-07-06 12:44:34',NULL,NULL),(63383,'75644','S','Lone Mountain','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(61947,'73164','P','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.472000,-97.520348,0,'2013-07-06 12:44:33',NULL,NULL),(74882,'93278','P','Visalia','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.306081,-119.312092,0,'2013-07-06 12:44:34',NULL,NULL),(45974,'52404','S','Shueyville','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',41.947254,-91.690122,0,'2013-07-06 12:44:32',NULL,NULL),(47176,'54481','S','Arnott','N','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542980,-89.564460,0,'2013-07-06 12:44:32',NULL,NULL),(36327,'40385','S','Waco','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.747999,-84.128552,0,'2013-07-06 12:44:32',NULL,NULL),(56349,'65202','S','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.995035,-92.315503,0,'2013-07-06 12:44:33',NULL,NULL),(21055,'21911','S','Rising Sun','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.690212,-76.050886,0,'2013-07-06 12:44:31',NULL,NULL),(71137,'86024','S','Happy Jack','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.662907,-111.479346,0,'2013-07-06 12:44:34',NULL,NULL),(1972,'00851','P','Kingshill','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.733540,-64.798875,0,'2013-07-06 12:44:30',NULL,NULL),(62467,'74337','S','Mazie','A','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.189386,-95.333812,0,'2013-07-06 12:44:33',NULL,NULL),(62172,'73746','P','Hopeton','D','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.685412,-98.664762,0,'2013-07-06 12:44:33',NULL,NULL),(7499,'06920','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.055342,-73.538541,0,'2013-07-06 12:44:30',NULL,NULL),(56063,'64745','S','Foster','D','Bates','29013','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.173144,-94.553762,0,'2013-07-06 12:44:33',NULL,NULL),(51686,'59933','P','Stryker','D','Lincoln','30053','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.673900,-114.769336,0,'2013-07-06 12:44:33',NULL,NULL),(79559,'99011','S','Fairchild Air Force Base','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.636732,-117.652435,0,'2013-07-06 12:44:34',NULL,NULL),(4824,'03908','S','S Berwick','N','York','23031','Maine','ME','23','6450','207','Eastern',-5.0,'Y',43.230935,-70.783559,0,'2013-07-06 12:44:30',NULL,NULL),(19613,'20237','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.895381,-77.036342,0,'2013-07-06 12:44:31',NULL,NULL),(31855,'35116','S','Morris','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.745120,-86.771340,0,'2013-07-06 12:44:32',NULL,NULL),(62836,'75006','S','Carrollton','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.961351,-96.891307,0,'2013-07-06 12:44:33',NULL,NULL),(46989,'54232','P','St Nazianz','N','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.004420,-87.924250,0,'2013-07-06 12:44:32',NULL,NULL),(77454,'96812','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.304962,-157.861303,0,'2013-07-06 12:44:34',NULL,NULL),(15620,'16692','S','Westover','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.775807,-78.746208,0,'2013-07-06 12:44:31',NULL,NULL),(12902,'13337','S','Cattown','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.734651,-74.991943,0,'2013-07-06 12:44:30',NULL,NULL),(42313,'47612','S','Cynthiana','D','Posey','18129','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.171264,-87.692616,0,'2013-07-06 12:44:32',NULL,NULL),(71580,'87312','S','Contnental Dv','A','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.468748,-108.455845,0,'2013-07-06 12:44:34',NULL,NULL),(75841,'94923','S','Salmon Creek','N','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.349015,-123.047387,0,'2013-07-06 12:44:34',NULL,NULL),(6872,'06137','P','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.584485,-72.865338,0,'2013-07-06 12:44:30',NULL,NULL),(56613,'65571','S','Summersville','D','Texas','29215','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.130857,-91.705703,0,'2013-07-06 12:44:33',NULL,NULL),(52418,'60645','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',42.008098,-87.706039,0,'2013-07-06 12:44:33',NULL,NULL),(20483,'21046','S','Columbia','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.171649,-76.852986,0,'2013-07-06 12:44:31',NULL,NULL),(34293,'38504','S','Allardt','D','Fentress','47049','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.368347,-84.811613,0,'2013-07-06 12:44:32',NULL,NULL),(24229,'26726','S','Short Gap','A','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.437003,-78.981107,0,'2013-07-06 12:44:31',NULL,NULL),(811,'00693','S','Urb El Verde','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(76667,'95759','P','Elk Grove','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.404350,-121.375312,0,'2013-07-06 12:44:34',NULL,NULL),(56753,'65727','S','Bolivar','A','Polk','29167','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.754824,-93.292646,0,'2013-07-06 12:44:33',NULL,NULL),(54656,'62931','S','Elizabethtown','D','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.487388,-88.268499,0,'2013-07-06 12:44:33',NULL,NULL),(24655,'27405','S','Hamtown','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110580,-79.740600,0,'2013-07-06 12:44:31',NULL,NULL),(17355,'17872','S','Doutyville','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(14202,'14774','P','Richburg','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.089324,-78.155021,0,'2013-07-06 12:44:31',NULL,NULL),(42740,'48021','S','Eastpointe','D','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.463894,-82.946167,0,'2013-07-06 12:44:32',NULL,NULL),(50288,'57656','S','Timber Lake','D','Dewey','46041','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.427700,-101.074481,0,'2013-07-06 12:44:33',NULL,NULL),(78071,'97464','P','Ophir','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.502068,-124.412467,0,'2013-07-06 12:44:34',NULL,NULL),(29710,'32949','S','Grant Valkaria','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.925540,-80.531790,0,'2013-07-06 12:44:32',NULL,NULL),(27176,'29843','S','Olar','D','Bamberg','45009','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.174153,-81.153464,0,'2013-07-06 12:44:31',NULL,NULL),(6991,'06250','S','Mansfield','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780580,-72.210300,0,'2013-07-06 12:44:30',NULL,NULL),(53327,'61748','S','Hudson','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.601797,-88.991264,0,'2013-07-06 12:44:33',NULL,NULL),(17633,'18059','S','Laurys Sta','A','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.727455,-75.535044,0,'2013-07-06 12:44:31',NULL,NULL),(24961,'27837','S','Grimesland','D','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.576700,-77.235090,0,'2013-07-06 12:44:31',NULL,NULL),(73216,'90623','S','Buena Park','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.849063,-118.039814,0,'2013-07-06 12:44:34',NULL,NULL),(52037,'60187','S','Wheaton','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.857559,-88.112465,0,'2013-07-06 12:44:33',NULL,NULL),(51637,'59863','S','Ravalli','D','Lake','30047','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.276988,-114.180225,0,'2013-07-06 12:44:33',NULL,NULL),(45213,'50632','S','Green Mtn','A','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.095421,-92.674244,0,'2013-07-06 12:44:32',NULL,NULL),(1354,'00736','S','Parc El Polvorin','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(39692,'45034','S','Kings Island','A','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.355219,-84.244219,0,'2013-07-06 12:44:32',NULL,NULL),(35843,'39776','S','Woodland','D','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.794434,-89.053443,0,'2013-07-06 12:44:32',NULL,NULL),(44509,'49935','S','Iron River','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.106840,-88.657064,0,'2013-07-06 12:44:32',NULL,NULL),(77755,'97108','S','Beaver','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.283796,-123.753015,0,'2013-07-06 12:44:34',NULL,NULL),(30117,'33161','S','Miami Shores','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.890934,-80.178037,0,'2013-07-06 12:44:32',NULL,NULL),(32905,'36544','S','Irvington','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.482569,-88.230815,0,'2013-07-06 12:44:32',NULL,NULL),(70638,'85142','S','San Tan Vly','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.228018,-111.637649,0,'2013-07-06 12:44:34',NULL,NULL),(56771,'65740','S','Rockaway Beach','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.701943,-93.161158,0,'2013-07-06 12:44:33',NULL,NULL),(21927,'23225','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.517420,-77.501037,0,'2013-07-06 12:44:31',NULL,NULL),(14328,'15001','S','Aliquippa','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.603720,-80.285814,0,'2013-07-06 12:44:31',NULL,NULL),(44526,'49955','P','Painesdale','D','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.043157,-88.671488,0,'2013-07-06 12:44:32',NULL,NULL),(48321,'55446','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.043463,-93.491662,0,'2013-07-06 12:44:33',NULL,NULL),(12258,'12832','S','North Hebron','N','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.386180,-73.280580,0,'2013-07-06 12:44:30',NULL,NULL),(5032,'04255','S','Greenwood','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.320167,-70.633081,0,'2013-07-06 12:44:30',NULL,NULL),(56683,'65644','S','Elkland','D','Dallas','29059','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.438921,-93.017937,0,'2013-07-06 12:44:33',NULL,NULL),(34082,'38152','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.120123,-89.939705,0,'2013-07-06 12:44:32',NULL,NULL),(33655,'37713','S','Bybee','D','Cocke','47029','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.079345,-83.157540,0,'2013-07-06 12:44:32',NULL,NULL),(14681,'15244','P','Montour','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.445184,-80.143578,0,'2013-07-06 12:44:31',NULL,NULL),(46849,'54021','S','Prescott','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.749536,-92.794364,0,'2013-07-06 12:44:32',NULL,NULL),(7879,'07511','P','Totowa','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.902429,-74.221090,0,'2013-07-06 12:44:30',NULL,NULL),(35054,'39180','S','Letourneau','N','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.323121,-90.860809,0,'2013-07-06 12:44:32',NULL,NULL),(4809,'03890','S','West Ossipee','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.838457,-71.201602,0,'2013-07-06 12:44:30',NULL,NULL),(16720,'17406','S','Highmount','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.015200,-76.597440,0,'2013-07-06 12:44:31',NULL,NULL),(61073,'72126','S','Perryville','D','Perry','05105','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.972920,-92.871720,0,'2013-07-06 12:44:33',NULL,NULL),(27171,'29841','S','Belvedere','A','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.512008,-81.932644,0,'2013-07-06 12:44:31',NULL,NULL),(78645,'98223','S','Smokey Point','N','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.181800,-121.979640,0,'2013-07-06 12:44:34',NULL,NULL),(42730,'48007','P','Troy','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.581000,-83.145735,0,'2013-07-06 12:44:32',NULL,NULL),(5095,'04345','S','Gardiner','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.231489,-69.779004,0,'2013-07-06 12:44:30',NULL,NULL),(62356,'74063','S','Sandsprings','N','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.122622,-96.150607,0,'2013-07-06 12:44:33',NULL,NULL),(7066,'06334','P','Fitchville','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.539470,-72.176914,0,'2013-07-06 12:44:30',NULL,NULL),(32389,'35952','S','Altoona','D','Etowah','01055','Alabama','AL','01','2880','205/659','Central',-6.0,'Y',34.026000,-86.299260,0,'2013-07-06 12:44:32',NULL,NULL),(65170,'77413','P','Barker','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770634,-95.702302,0,'2013-07-06 12:44:34',NULL,NULL),(39662,'45011','S','Liberty Twp','A','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(58893,'69168','S','Venango','D','Perkins','31135','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',40.849784,-101.936080,0,'2013-07-06 12:44:33',NULL,NULL),(57778,'67467','S','Ada','A','Ottawa','20143','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.125123,-97.703693,0,'2013-07-06 12:44:33',NULL,NULL),(43656,'48849','S','Lake Odessa','D','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',42.804386,-85.139514,0,'2013-07-06 12:44:32',NULL,NULL),(69286,'83442','S','Rigby','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.686480,-111.879600,0,'2013-07-06 12:44:34',NULL,NULL),(54918,'63090','S','Clover Bottom','N','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.546118,-91.015131,0,'2013-07-06 12:44:33',NULL,NULL),(37013,'41230','S','Louisa','D','Lawrence','21127','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.109540,-82.626840,0,'2013-07-06 12:44:32',NULL,NULL),(12122,'12594','S','Wingdale','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.669591,-73.558676,0,'2013-07-06 12:44:30',NULL,NULL),(57636,'67149','S','Viola','D','Sedgwick','20173','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.554253,-97.605505,0,'2013-07-06 12:44:33',NULL,NULL),(74277,'92356','S','Lucerne Valley','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.453374,-116.918928,0,'2013-07-06 12:44:34',NULL,NULL),(28509,'31533','S','Douglas','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.508915,-82.849891,0,'2013-07-06 12:44:32',NULL,NULL),(60160,'71404','S','Mars Hill','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.832832,-92.788989,0,'2013-07-06 12:44:33',NULL,NULL),(15067,'15734','P','Dixonville','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.714085,-79.005137,0,'2013-07-06 12:44:31',NULL,NULL),(37438,'41834','S','Littcarr','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.259621,-82.967852,0,'2013-07-06 12:44:32',NULL,NULL),(44627,'50063','S','Dallas Center','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.690242,-93.967705,0,'2013-07-06 12:44:32',NULL,NULL),(26698,'29407','S','Charleston','D','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.800052,-80.010928,0,'2013-07-06 12:44:31',NULL,NULL),(30720,'33514','S','Centerhill','N','Sumter','12119','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.699610,-82.004424,0,'2013-07-06 12:44:32',NULL,NULL),(60172,'71409','S','Hotwells','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(58369,'68526','S','Cheney','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.730880,-96.551460,0,'2013-07-06 12:44:33',NULL,NULL),(28520,'31545','S','Gardi','N','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.612517,-81.885560,0,'2013-07-06 12:44:32',NULL,NULL),(50266,'57641','S','Mc Intosh','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.921810,-101.350490,0,'2013-07-06 12:44:33',NULL,NULL),(63,'00612','S','Arecibo','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(46041,'52560','S','Floris','D','Davis','19051','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.855010,-92.294921,0,'2013-07-06 12:44:32',NULL,NULL),(18930,'19504','S','Niantic','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.388460,-75.578220,0,'2013-07-06 12:44:31',NULL,NULL),(18576,'19128','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.042066,-75.225337,0,'2013-07-06 12:44:31',NULL,NULL),(12375,'12915','P','Brainardsville','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.857117,-74.034613,0,'2013-07-06 12:44:30',NULL,NULL),(60296,'71454','S','Kadesh','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(69393,'83612','S','Pine Ridge','N','Adams','16003','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.695761,-116.461989,0,'2013-07-06 12:44:34',NULL,NULL),(1287,'00730','S','Sect Playita','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.023150,-66.625250,0,'2013-07-06 12:44:30',NULL,NULL),(2640,'00966','S','Bda Buen Samaritano','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(74394,'92518','S','March Arb','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.896243,-117.267131,0,'2013-07-06 12:44:34',NULL,NULL),(68279,'81082','S','Ludlow','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.173925,-104.512742,0,'2013-07-06 12:44:34',NULL,NULL),(60179,'71415','P','Clarks','D','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.029604,-92.139750,0,'2013-07-06 12:44:33',NULL,NULL),(55421,'63655','S','Marquand','D','Madison','29123','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.403467,-90.197360,0,'2013-07-06 12:44:33',NULL,NULL),(37967,'42724','S','Vertrees','A','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.671855,-86.025831,0,'2013-07-06 12:44:32',NULL,NULL),(39941,'45230','S','Anderson Twp','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.078715,-84.377216,0,'2013-07-06 12:44:32',NULL,NULL),(40341,'45616','S','Blue Creek','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.793184,-83.340218,0,'2013-07-06 12:44:32',NULL,NULL),(46229,'52776','S','Centerdale','N','Muscatine','19139','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.575495,-91.261347,0,'2013-07-06 12:44:32',NULL,NULL),(10512,'10976','S','Sparkill','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.031057,-73.927325,0,'2013-07-06 12:44:30',NULL,NULL),(12739,'13166','S','Brutus','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.055291,-76.559355,0,'2013-07-06 12:44:30',NULL,NULL),(59927,'71291','S','West Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.503812,-92.191028,0,'2013-07-06 12:44:33',NULL,NULL),(1856,'00791','S','Ext Roig','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(30610,'33428','S','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.355630,-80.195232,0,'2013-07-06 12:44:32',NULL,NULL),(78804,'98327','S','Dupont','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.094572,-122.642466,0,'2013-07-06 12:44:34',NULL,NULL),(9900,'10130','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754891,-74.003971,0,'2013-07-06 12:44:30',NULL,NULL),(4451,'03249','S','Guilford','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.546583,-71.404039,0,'2013-07-06 12:44:30',NULL,NULL),(8977,'08826','S','Glen Gardner','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.701442,-74.928017,0,'2013-07-06 12:44:30',NULL,NULL),(53066,'61519','P','Bryant','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.478281,-90.069774,0,'2013-07-06 12:44:33',NULL,NULL),(18730,'19320','S','Valley Township','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.984475,-75.810978,0,'2013-07-06 12:44:31',NULL,NULL),(36923,'41146','S','Fairview Hill','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.236656,-82.919076,0,'2013-07-06 12:44:32',NULL,NULL),(52460,'60677','U','Pnc Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881607,-87.639724,0,'2013-07-06 12:44:33',NULL,NULL),(70623,'85131','S','Toltec','A','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.741320,-111.585370,0,'2013-07-06 12:44:34',NULL,NULL),(53435,'61865','S','Potomac','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.307563,-87.802402,0,'2013-07-06 12:44:33',NULL,NULL),(3320,'01526','P','Manchaug','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.089553,-71.746666,0,'2013-07-06 12:44:30',NULL,NULL),(35474,'39520','S','Bay Saint Louis','D','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.316210,-89.483285,0,'2013-07-06 12:44:32',NULL,NULL),(74429,'92562','S','Murrieta Hot Springs','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.543275,-117.287556,0,'2013-07-06 12:44:34',NULL,NULL),(9497,'10013','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(66531,'78721','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.272454,-97.686158,0,'2013-07-06 12:44:34',NULL,NULL),(56824,'65787','S','Roach','D','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.010123,-92.807334,0,'2013-07-06 12:44:33',NULL,NULL),(36692,'41017','S','Crescent Park','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(45932,'52336','S','Springville','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.094680,-91.462620,0,'2013-07-06 12:44:32',NULL,NULL),(64487,'76621','S','Menlow','N','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.900080,-97.074180,0,'2013-07-06 12:44:34',NULL,NULL),(27167,'29838','S','Modoc','D','McCormick','45065','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',33.708528,-82.217647,0,'2013-07-06 12:44:31',NULL,NULL),(11510,'12029','S','Canaan','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.391057,-73.400428,0,'2013-07-06 12:44:30',NULL,NULL),(73063,'90095','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.070199,-118.451020,0,'2013-07-06 12:44:34',NULL,NULL),(8719,'08502','S','Belle Mead','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.464764,-74.630308,0,'2013-07-06 12:44:30',NULL,NULL),(67492,'80233','S','North Glenn','N','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903291,-104.948178,0,'2013-07-06 12:44:34',NULL,NULL),(35899,'40012','S','Chaplin','D','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.899244,-85.208252,0,'2013-07-06 12:44:32',NULL,NULL),(61845,'73118','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.515114,-97.526477,0,'2013-07-06 12:44:33',NULL,NULL),(54228,'62656','S','Lincoln','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153604,-89.369109,0,'2013-07-06 12:44:33',NULL,NULL),(53780,'62275','S','Old Ripley','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770822,-89.501779,0,'2013-07-06 12:44:33',NULL,NULL),(49977,'57359','S','Letcher','D','Sanborn','46111','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.896104,-98.208027,0,'2013-07-06 12:44:33',NULL,NULL),(46702,'53790','U','Wi Dept Revenue Box 268','N','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.073534,-89.382948,0,'2013-07-06 12:44:32',NULL,NULL),(8873,'08691','S','Robbinsville','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.223905,-74.620394,0,'2013-07-06 12:44:30',NULL,NULL),(3940,'02467','S','Chestnut Hill','D','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.318527,-71.157052,0,'2013-07-06 12:44:30',NULL,NULL),(13143,'13504','P','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.085213,-75.188377,0,'2013-07-06 12:44:30',NULL,NULL),(16558,'17313','S','Dallastown','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.901404,-76.648789,0,'2013-07-06 12:44:31',NULL,NULL),(39850,'45169','S','Clinton County','A','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.491952,-83.654601,0,'2013-07-06 12:44:32',NULL,NULL),(79894,'99585','P','Marshall','D','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.846500,-161.986500,0,'2013-07-06 12:44:34',NULL,NULL),(41416,'46819','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.996887,-85.132630,0,'2013-07-06 12:44:32',NULL,NULL),(55357,'63561','S','Queen City','D','Schuyler','29197','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.420358,-92.567187,0,'2013-07-06 12:44:33',NULL,NULL),(62286,'74018','P','Clairemore','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.319001,-95.586801,0,'2013-07-06 12:44:33',NULL,NULL),(10321,'10541','S','Lake Secor','N','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.378032,-73.749712,0,'2013-07-06 12:44:30',NULL,NULL),(40318,'45469','U','Univ Dayton','N','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.721166,-84.190652,0,'2013-07-06 12:44:32',NULL,NULL),(22726,'24363','S','Mouth of Wilson','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.612187,-81.384826,0,'2013-07-06 12:44:31',NULL,NULL),(17309,'17856','S','New Columbia','D','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.043720,-76.884900,0,'2013-07-06 12:44:31',NULL,NULL),(62393,'74102','P','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.244111,-95.828066,0,'2013-07-06 12:44:33',NULL,NULL),(67167,'79835','S','Canutillo','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.929899,-106.591690,0,'2013-07-06 12:44:34',NULL,NULL),(73904,'92009','S','La Costa','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.099272,-117.270924,0,'2013-07-06 12:44:34',NULL,NULL),(46769,'53946','S','Markesan','D','Green Lake','55047','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.705413,-88.990142,0,'2013-07-06 12:44:32',NULL,NULL),(39205,'44396','U','Target','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.065643,-81.520817,0,'2013-07-06 12:44:32',NULL,NULL),(67812,'80746','P','Haxtun','N','Phillips','08095','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.608040,-102.549851,0,'2013-07-06 12:44:34',NULL,NULL),(70668,'85214','P','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.399958,-111.788572,0,'2013-07-06 12:44:34',NULL,NULL),(71789,'87560','S','Lagunita','N','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(22226,'23603','S','Newport News','D','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.190578,-76.562567,0,'2013-07-06 12:44:31',NULL,NULL),(40148,'45348','S','Rossburg','A','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.321680,-84.627120,0,'2013-07-06 12:44:32',NULL,NULL),(29659,'32908','S','Melbourne','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',27.980227,-80.688532,0,'2013-07-06 12:44:32',NULL,NULL),(73191,'90504','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.871409,-118.325688,0,'2013-07-06 12:44:34',NULL,NULL),(16116,'17055','S','Navy Sup Dpt','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(34404,'38626','S','Jeffries','N','Tunica','28143','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.534380,-90.396000,0,'2013-07-06 12:44:32',NULL,NULL),(37992,'42748','S','White City','A','Larue','21123','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.576860,-85.708920,0,'2013-07-06 12:44:32',NULL,NULL),(29025,'32228','P','Mayport Nav Sta','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.388853,-81.433191,0,'2013-07-06 12:44:32',NULL,NULL),(48103,'55344','S','Eden Prairie','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.861720,-93.448107,0,'2013-07-06 12:44:33',NULL,NULL),(50588,'58235','S','Johnstown','A','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',48.104302,-97.450273,0,'2013-07-06 12:44:33',NULL,NULL),(73608,'91394','P','Granada Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.263508,-118.526054,0,'2013-07-06 12:44:34',NULL,NULL),(71725,'87532','S','La Mesilla','N','Rio Arriba','35039','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.976840,-106.150560,0,'2013-07-06 12:44:34',NULL,NULL),(69300,'83449','S','Swan Valley','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.435853,-111.293388,0,'2013-07-06 12:44:34',NULL,NULL),(67278,'80002','S','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.794577,-105.095896,0,'2013-07-06 12:44:34',NULL,NULL),(48671,'55919','S','Brownsville','D','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.688294,-91.294422,0,'2013-07-06 12:44:33',NULL,NULL),(47358,'54614','S','Newburg Corners','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.890535,-90.983181,0,'2013-07-06 12:44:32',NULL,NULL),(45809,'52201','S','Haskins','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.291753,-91.552100,0,'2013-07-06 12:44:32',NULL,NULL),(22310,'23834','S','S Chesterfld','A','Colonial Heights City','51570','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.287361,-77.391074,0,'2013-07-06 12:44:31',NULL,NULL),(65729,'78042','P','Laredo','D','Webb','48479','Texas','TX','48','4080','956','Central',-6.0,'Y',27.505646,-99.507523,0,'2013-07-06 12:44:34',NULL,NULL),(41057,'46501','S','Argos','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.236625,-86.248195,0,'2013-07-06 12:44:32',NULL,NULL),(45690,'52047','S','National','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.947298,-91.311574,0,'2013-07-06 12:44:32',NULL,NULL),(12310,'12857','S','Olmstedville','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.827352,-73.937295,0,'2013-07-06 12:44:30',NULL,NULL),(13559,'13835','S','Richford','D','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.409488,-76.227768,0,'2013-07-06 12:44:31',NULL,NULL),(65319,'77511','S','Alvin','D','Brazoria','48039','Texas','TX','48','1145','713/281/832','Central',-6.0,'Y',29.400000,-95.239440,0,'2013-07-06 12:44:34',NULL,NULL),(53909,'62367','S','Plymouth','D','Hancock','17067','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.290180,-90.893760,0,'2013-07-06 12:44:33',NULL,NULL),(22245,'23663','S','Hampton','D','Hampton City','51650','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.035132,-76.315821,0,'2013-07-06 12:44:31',NULL,NULL),(22089,'23404','S','Locustville','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.644101,-75.669243,0,'2013-07-06 12:44:31',NULL,NULL),(19489,'20152','S','Fairfax','A','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.907611,-77.518015,0,'2013-07-06 12:44:31',NULL,NULL),(61479,'72635','S','Gassville','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.302640,-92.484480,0,'2013-07-06 12:44:33',NULL,NULL),(64797,'77017','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.681768,-95.258078,0,'2013-07-06 12:44:34',NULL,NULL),(68256,'81064','S','Pritchett','D','Baca','08009','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.237984,-103.164023,0,'2013-07-06 12:44:34',NULL,NULL),(47471,'54740','S','Elmwood','D','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.782104,-92.151312,0,'2013-07-06 12:44:32',NULL,NULL),(46336,'53088','P','Stockbridge','D','Calumet','55015','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.075694,-88.303086,0,'2013-07-06 12:44:32',NULL,NULL),(41700,'47227','S','Commiskey','D','Jennings','18079','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.856452,-85.638507,0,'2013-07-06 12:44:32',NULL,NULL),(15965,'17028','S','Grantville','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.374960,-76.694820,0,'2013-07-06 12:44:31',NULL,NULL),(57239,'66521','S','Duluth','A','Pottawatomie','20149','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.491343,-96.171545,0,'2013-07-06 12:44:33',NULL,NULL),(60267,'71447','S','Chopin','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.417620,-92.777658,0,'2013-07-06 12:44:33',NULL,NULL),(72768,'89523','S','Mogul','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.525676,-119.890959,0,'2013-07-06 12:44:34',NULL,NULL),(40045,'45254','P','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.105465,-84.501838,0,'2013-07-06 12:44:32',NULL,NULL),(39032,'44146','S','Bedford','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.386690,-81.527124,0,'2013-07-06 12:44:32',NULL,NULL),(35166,'39269','S','Jackson','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.299021,-90.185387,0,'2013-07-06 12:44:32',NULL,NULL),(40587,'45875','S','Ottawa','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.029812,-84.054975,0,'2013-07-06 12:44:32',NULL,NULL),(59164,'70339','S','Pierre Part','D','Assumption','22007','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.962452,-91.201838,0,'2013-07-06 12:44:33',NULL,NULL),(31359,'34204','P','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.442625,-82.507552,0,'2013-07-06 12:44:32',NULL,NULL),(33928,'38059','S','Newbern','D','Dyer','47045','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.114240,-89.267273,0,'2013-07-06 12:44:32',NULL,NULL),(29895,'33043','S','Summerland Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.678501,-81.368387,0,'2013-07-06 12:44:32',NULL,NULL),(42429,'47802','S','Youngstown','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(3109,'01230','S','New Marlboro','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(5445,'04694','S','Baileyville','D','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.154958,-67.407874,0,'2013-07-06 12:44:30',NULL,NULL),(56672,'65630','S','Saddlebrooke','A','Christian','29043','Missouri','MO','29','7920','417','Central',-6.0,'Y',36.859987,-93.124983,0,'2013-07-06 12:44:33',NULL,NULL),(9484,'10011','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741790,-73.999332,0,'2013-07-06 12:44:30',NULL,NULL),(18853,'19437','P','Gwynedd Valley','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.182564,-75.258744,0,'2013-07-06 12:44:31',NULL,NULL),(54605,'62910','S','Brookport','D','Massac','17127','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.125868,-88.629383,0,'2013-07-06 12:44:33',NULL,NULL),(42428,'47802','S','Woodgate East','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(31331,'34135','S','Bonita Spgs','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.387185,-81.735987,0,'2013-07-06 12:44:32',NULL,NULL),(33872,'38017','S','Collierville','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.054102,-89.679063,0,'2013-07-06 12:44:32',NULL,NULL),(70510,'84784','P','Hildale','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.010071,-112.966011,0,'2013-07-06 12:44:34',NULL,NULL),(32075,'35285','U','S S Payment Ctr','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.541978,-86.803608,0,'2013-07-06 12:44:32',NULL,NULL),(74208,'92304','P','Cadiz','A','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.634003,-115.751436,0,'2013-07-06 12:44:34',NULL,NULL),(73425,'91203','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.151572,-118.267799,0,'2013-07-06 12:44:34',NULL,NULL),(73461,'91304','S','West Hills','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.218348,-118.625847,0,'2013-07-06 12:44:34',NULL,NULL),(71827,'87576','S','Trampas','D','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.153207,-105.622991,0,'2013-07-06 12:44:34',NULL,NULL),(71284,'86437','S','Kingman','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.384257,-113.657991,0,'2013-07-06 12:44:34',NULL,NULL),(6303,'05657','P','Lake Elmore','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544357,-72.528615,0,'2013-07-06 12:44:30',NULL,NULL),(8205,'07936','S','East Hanover','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.818071,-74.363870,0,'2013-07-06 12:44:30',NULL,NULL),(8631,'08260','S','West Wildwood','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(7511,'06928','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.038894,-73.556427,0,'2013-07-06 12:44:30',NULL,NULL),(67387,'80123','S','Columbine Valley','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(66248,'78572','S','Havana','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(59414,'70651','P','Leblanc','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.507078,-92.941459,0,'2013-07-06 12:44:33',NULL,NULL),(49517,'56672','S','Remer','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.087607,-93.899234,0,'2013-07-06 12:44:33',NULL,NULL),(44562,'50013','U','Iowa State University','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.019665,-93.645568,0,'2013-07-06 12:44:32',NULL,NULL),(22737,'24378','S','Troutdale','D','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.692024,-81.438104,0,'2013-07-06 12:44:31',NULL,NULL),(27927,'30518','S','Rest Haven','A','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.124264,-84.031055,0,'2013-07-06 12:44:31',NULL,NULL),(17840,'18424','S','Clifton','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.248130,-75.569885,0,'2013-07-06 12:44:31',NULL,NULL),(11143,'11713','S','N Bellport','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.769052,-72.942600,0,'2013-07-06 12:44:30',NULL,NULL),(68828,'82512','S','Burris','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.379445,-109.188086,0,'2013-07-06 12:44:34',NULL,NULL),(68428,'81212','S','Parkdale','N','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(68005,'80922','S','Cimarron Hills','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.898824,-104.700007,0,'2013-07-06 12:44:34',NULL,NULL),(58944,'69357','S','Haig','N','Scotts Bluff','31157','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.940372,-103.808440,0,'2013-07-06 12:44:33',NULL,NULL),(16381,'17211','S','Artemas','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.767488,-78.406126,0,'2013-07-06 12:44:31',NULL,NULL),(19756,'20413','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894978,-77.021775,0,'2013-07-06 12:44:31',NULL,NULL),(35211,'39298','P','JAX','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.321984,-90.206032,0,'2013-07-06 12:44:32',NULL,NULL),(38228,'43228','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.951399,-83.128000,0,'2013-07-06 12:44:32',NULL,NULL),(46604,'53559','S','Marshall','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.175384,-89.075712,0,'2013-07-06 12:44:32',NULL,NULL),(3502,'01860','S','Merrimac','D','Essex','25009','Massachusetts','MA','25','4160','978/351','Eastern',-5.0,'Y',42.836632,-71.006424,0,'2013-07-06 12:44:30',NULL,NULL),(79571,'99019','S','Liberty Lake','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.650703,-117.078957,0,'2013-07-06 12:44:34',NULL,NULL),(75651,'94529','U','Chevron USA Inc','N','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.874619,-122.047244,0,'2013-07-06 12:44:34',NULL,NULL),(71791,'87560','S','Ribera','D','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(65797,'78130','S','Canyon Lake','A','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.719620,-98.080800,0,'2013-07-06 12:44:34',NULL,NULL),(57812,'67514','S','Arlington','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.884729,-98.185498,0,'2013-07-06 12:44:33',NULL,NULL),(53966,'62428','S','Timothy','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(52206,'60478','S','Tinley Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.559523,-87.722149,0,'2013-07-06 12:44:33',NULL,NULL),(7419,'06812','S','New Fairfield','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.485140,-73.487520,0,'2013-07-06 12:44:30',NULL,NULL),(27122,'29744','P','Van Wyck','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.858501,-80.846028,0,'2013-07-06 12:44:31',NULL,NULL),(20753,'21405','S','Sherwood Forest','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.978333,-76.492500,0,'2013-07-06 12:44:31',NULL,NULL),(4393,'03111','U','Manchester','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',42.937825,-71.453825,0,'2013-07-06 12:44:30',NULL,NULL),(40302,'45449','S','West Carrollton City','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.668355,-84.246864,0,'2013-07-06 12:44:32',NULL,NULL),(51127,'58794','S','White Earth','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.457091,-102.820249,0,'2013-07-06 12:44:33',NULL,NULL),(72571,'89318','P','Steptoe','N','White Pine','32033','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.391389,-114.786899,0,'2013-07-06 12:44:34',NULL,NULL),(69006,'83203','P','Pocatello','A','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.990305,-112.424758,0,'2013-07-06 12:44:34',NULL,NULL),(68382,'81146','S','Mosca','D','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.648702,-105.700616,0,'2013-07-06 12:44:34',NULL,NULL),(48616,'55795','S','Rutledge','A','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.311725,-92.860123,0,'2013-07-06 12:44:33',NULL,NULL),(48390,'55578','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.995780,-93.709167,0,'2013-07-06 12:44:33',NULL,NULL),(39222,'44411','S','Yale','N','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.021628,-81.042585,0,'2013-07-06 12:44:32',NULL,NULL),(38473,'43623','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.707048,-83.649692,0,'2013-07-06 12:44:32',NULL,NULL),(5546,'04847','S','Camden','A','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.256919,-69.143873,0,'2013-07-06 12:44:30',NULL,NULL),(489,'00670','S','Urb El Coqui','N','Las Marias','72083','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.296381,-67.146608,0,'2013-07-06 12:44:30',NULL,NULL),(32099,'35295','U','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.511347,-86.804838,0,'2013-07-06 12:44:32',NULL,NULL),(27248,'29927','S','Hardeeville','D','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.281300,-81.071015,0,'2013-07-06 12:44:31',NULL,NULL),(25541,'28404','P','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.927021,-78.069326,0,'2013-07-06 12:44:31',NULL,NULL),(15604,'16674','S','Robertsdale','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.180671,-78.115002,0,'2013-07-06 12:44:31',NULL,NULL),(11339,'11792','S','Willwood','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.945440,-72.835020,0,'2013-07-06 12:44:30',NULL,NULL),(73889,'91963','S','Potrero','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.641102,-116.607580,0,'2013-07-06 12:44:34',NULL,NULL),(71088,'85931','P','Heber','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.626034,-111.111768,0,'2013-07-06 12:44:34',NULL,NULL),(37065,'41311','S','Tallega','A','Lee','21129','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.578443,-83.708123,0,'2013-07-06 12:44:32',NULL,NULL),(16700,'17402','S','Mount Zion','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(36150,'40241','S','Goose Creek','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(20514,'21085','S','Joppatown','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.431754,-76.355815,0,'2013-07-06 12:44:31',NULL,NULL),(58483,'68752','S','Meadow Grove','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.027426,-97.733894,0,'2013-07-06 12:44:33',NULL,NULL),(16020,'17042','S','Flintville','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(54411,'62829','P','Twigg','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.995516,-88.532996,0,'2013-07-06 12:44:33',NULL,NULL),(33388,'37218','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.219335,-86.856532,0,'2013-07-06 12:44:32',NULL,NULL),(30417,'33326','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(9363,'09821','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(28683,'31799','P','Tville','N','Thomas','13275','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.837613,-83.978012,0,'2013-07-06 12:44:32',NULL,NULL),(5247,'04478','S','Pittston Academy Grant Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.769880,-69.883299,0,'2013-07-06 12:44:30',NULL,NULL),(18824,'19409','P','Fairview Vlg','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.121389,-75.340278,0,'2013-07-06 12:44:31',NULL,NULL),(41460,'46911','S','Amboy','D','Miami','18103','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.615509,-85.942896,0,'2013-07-06 12:44:32',NULL,NULL),(76849,'95965','S','Oregon City','N','Butte','06007','California','CA','06','1620','530','Pacific',-8.0,'Y',39.562606,-121.557974,0,'2013-07-06 12:44:34',NULL,NULL),(73582,'91381','S','Valencia','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.381783,-118.573262,0,'2013-07-06 12:44:34',NULL,NULL),(3760,'02184','S','East Braintree','N','Norfolk','25021','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.208818,-71.000729,0,'2013-07-06 12:44:30',NULL,NULL),(39140,'44275','S','Spencer','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.101074,-82.102809,0,'2013-07-06 12:44:32',NULL,NULL),(78395,'98033','S','Houghton','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.687703,-122.192053,0,'2013-07-06 12:44:34',NULL,NULL),(77206,'96373','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(7485,'06905','S','Ridgeway','A','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.085715,-73.541654,0,'2013-07-06 12:44:30',NULL,NULL),(62143,'73717','S','Alva','D','Woods','40151','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.796749,-98.668264,0,'2013-07-06 12:44:33',NULL,NULL),(13743,'14111','S','N Collins','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.583510,-78.908047,0,'2013-07-06 12:44:31',NULL,NULL),(23925,'26234','S','Rock Cave','D','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.769558,-80.304443,0,'2013-07-06 12:44:31',NULL,NULL),(29301,'32516','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.424453,-87.294897,0,'2013-07-06 12:44:32',NULL,NULL),(68074,'80937','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.798001,-104.836875,0,'2013-07-06 12:44:34',NULL,NULL),(67582,'80314','U','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.087784,-105.199407,0,'2013-07-06 12:44:34',NULL,NULL),(57682,'67226','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.742159,-97.242969,0,'2013-07-06 12:44:33',NULL,NULL),(26667,'29385','S','Wellford','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.953723,-82.095835,0,'2013-07-06 12:44:31',NULL,NULL),(25353,'28228','U','United States Postal Service','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.099604,-80.771417,0,'2013-07-06 12:44:31',NULL,NULL),(19455,'20122','P','Centreville','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.855942,-77.478615,0,'2013-07-06 12:44:31',NULL,NULL),(78423,'98047','S','Pacific','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.307500,-122.227222,0,'2013-07-06 12:44:34',NULL,NULL),(7704,'07175','U','USPS','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.735659,-74.171397,0,'2013-07-06 12:44:30',NULL,NULL),(20869,'21669','P','Taylors Is','A','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.472517,-76.276180,0,'2013-07-06 12:44:31',NULL,NULL),(35594,'39574','S','Wortham','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.600720,-89.112240,0,'2013-07-06 12:44:32',NULL,NULL),(42215,'47556','P','Mariah Hill','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.136060,-86.849362,0,'2013-07-06 12:44:32',NULL,NULL),(2235,'00926','S','Urb Hill Mansions','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(31517,'34472','S','Maricamp','N','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.091917,-81.989320,0,'2013-07-06 12:44:32',NULL,NULL),(72037,'88061','S','Arenas Valley','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.775733,-108.264777,0,'2013-07-06 12:44:34',NULL,NULL),(70400,'84713','S','Manderfield','N','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.298252,-112.716345,0,'2013-07-06 12:44:34',NULL,NULL),(24741,'27528','S','Clayton','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.636854,-78.447613,0,'2013-07-06 12:44:31',NULL,NULL),(17718,'18239','P','Milnesville','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.991136,-75.984084,0,'2013-07-06 12:44:31',NULL,NULL),(6505,'05819','S','Waterford','A','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.434670,-72.038170,0,'2013-07-06 12:44:30',NULL,NULL),(70688,'85254','S','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.616346,-111.954949,0,'2013-07-06 12:44:34',NULL,NULL),(63373,'75644','S','Delrose','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(56398,'65243','S','Clark','D','Randolph','29175','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.211871,-92.388655,0,'2013-07-06 12:44:33',NULL,NULL),(42240,'47568','S','Bogard','N','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.777115,-87.180839,0,'2013-07-06 12:44:32',NULL,NULL),(44852,'50271','S','Williams','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.488487,-93.542349,0,'2013-07-06 12:44:32',NULL,NULL),(27965,'30555','S','Mc Caysville','D','Fannin','13111','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.978674,-84.372632,0,'2013-07-06 12:44:31',NULL,NULL),(26967,'29611','S','Gville','N','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.854896,-82.448532,0,'2013-07-06 12:44:31',NULL,NULL),(25053,'27921','S','Camden','D','Camden','37029','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.294916,-76.149146,0,'2013-07-06 12:44:31',NULL,NULL),(9793,'10108','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.758763,-73.992621,0,'2013-07-06 12:44:30',NULL,NULL),(59425,'70660','S','Singer','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.539937,-93.516576,0,'2013-07-06 12:44:33',NULL,NULL),(57710,'67347','S','Havana','D','Montgomery','20125','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.094260,-95.941335,0,'2013-07-06 12:44:33',NULL,NULL),(52463,'60680','P','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.866893,-87.648013,0,'2013-07-06 12:44:33',NULL,NULL),(50662,'58331','S','Egeland','D','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.631110,-99.099433,0,'2013-07-06 12:44:33',NULL,NULL),(24292,'27009','S','Belew Creek','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.237061,-80.082222,0,'2013-07-06 12:44:31',NULL,NULL),(39888,'45213','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.179149,-84.417894,0,'2013-07-06 12:44:32',NULL,NULL),(50361,'57750','S','Headlee Ranch','N','Jackson','46071','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.739520,-101.933280,0,'2013-07-06 12:44:33',NULL,NULL),(40011,'45246','S','Glendale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.279734,-84.471102,0,'2013-07-06 12:44:32',NULL,NULL),(30022,'33134','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.753678,-80.272023,0,'2013-07-06 12:44:32',NULL,NULL),(72202,'88415','S','Stead','A','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.451664,-103.180222,0,'2013-07-06 12:44:34',NULL,NULL),(24392,'27104','S','Peace Haven Estates','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.096281,-80.322652,0,'2013-07-06 12:44:31',NULL,NULL),(46019,'52544','S','Centerville','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.727537,-92.865109,0,'2013-07-06 12:44:32',NULL,NULL),(15041,'15701','S','Indiana','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.619062,-79.160083,0,'2013-07-06 12:44:31',NULL,NULL),(14280,'14858','S','Lindley','D','Steuben','36101','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.059605,-77.146474,0,'2013-07-06 12:44:31',NULL,NULL),(74359,'92413','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.150103,-117.256720,0,'2013-07-06 12:44:34',NULL,NULL),(9473,'10010','S','Madison Square','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(9226,'09532','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21663,'22946','S','Keene','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.924605,-78.559962,0,'2013-07-06 12:44:31',NULL,NULL),(47750,'55020','S','Elko New Market','D','Scott','27139','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.567439,-93.328186,0,'2013-07-06 12:44:33',NULL,NULL),(16916,'17602','S','Meadia Heights','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.029250,-76.265633,0,'2013-07-06 12:44:31',NULL,NULL),(44802,'50233','S','Redfield','D','Dallas','19049','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.551425,-94.182514,0,'2013-07-06 12:44:32',NULL,NULL),(38623,'43914','P','Cameron','D','Monroe','39111','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.769151,-80.946797,0,'2013-07-06 12:44:32',NULL,NULL),(8641,'08270','S','Woodbine','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(19786,'20428','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.913441,-77.043978,0,'2013-07-06 12:44:31',NULL,NULL),(8370,'08053','S','Marlton Lakes','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(72792,'89701','S','Washoe Valley','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.196620,-119.761920,0,'2013-07-06 12:44:34',NULL,NULL),(67087,'79697','U','Mcmurry Univ','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.432945,-99.747844,0,'2013-07-06 12:44:34',NULL,NULL),(45873,'52248','S','Keota','D','Keokuk','19107','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.363498,-91.954172,0,'2013-07-06 12:44:32',NULL,NULL),(78809,'98331','S','Bogachiel','N','Clallam','53009','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.925780,-124.454400,0,'2013-07-06 12:44:34',NULL,NULL),(79091,'98439','S','Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(18799,'19397','P','Southeastern','D','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.982240,-75.508869,0,'2013-07-06 12:44:31',NULL,NULL),(13801,'14206','S','Cheektowaga','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.869763,-78.796792,0,'2013-07-06 12:44:31',NULL,NULL),(33679,'37742','S','Greenback','D','Loudon','47105','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.658505,-84.172683,0,'2013-07-06 12:44:32',NULL,NULL),(62668,'74646','S','Nardin','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.806061,-97.449659,0,'2013-07-06 12:44:33',NULL,NULL),(36800,'41055','S','Mayslick','D','Mason','21161','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.530049,-83.881279,0,'2013-07-06 12:44:32',NULL,NULL),(40512,'45815','P','Leipsic','A','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.153280,-83.938620,0,'2013-07-06 12:44:32',NULL,NULL),(45670,'52037','S','North Welton','N','Clinton','19045','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.001059,-90.609493,0,'2013-07-06 12:44:32',NULL,NULL),(67893,'80864','S','Yoder','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.751983,-104.200640,0,'2013-07-06 12:44:34',NULL,NULL),(66890,'79244','S','Matador','D','Motley','48345','Texas','TX','48','0000','806','Central',-6.0,'Y',34.012122,-100.820634,0,'2013-07-06 12:44:34',NULL,NULL),(63894,'76019','U','Univ of Texas at Arlington','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.728201,-97.112604,0,'2013-07-06 12:44:34',NULL,NULL),(39561,'44847','S','Ridgefield','N','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.214505,-82.714432,0,'2013-07-06 12:44:32',NULL,NULL),(36977,'41179','S','Trinity','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(36566,'40935','S','Mills','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834317,-83.759584,0,'2013-07-06 12:44:32',NULL,NULL),(26556,'29209','S','Capitol View','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.966947,-80.934317,0,'2013-07-06 12:44:31',NULL,NULL),(49985,'57365','S','Oacoma','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.798230,-99.397818,0,'2013-07-06 12:44:33',NULL,NULL),(50627,'58271','S','Joliette','A','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.818056,-97.227222,0,'2013-07-06 12:44:33',NULL,NULL),(78843,'98336','S','Glenoma','D','Lewis','53041','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.526804,-122.119918,0,'2013-07-06 12:44:34',NULL,NULL),(27840,'30423','P','Daisy','D','Evans','13109','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.150267,-81.839238,0,'2013-07-06 12:44:31',NULL,NULL),(23915,'26217','S','Diana','D','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.581441,-80.419160,0,'2013-07-06 12:44:31',NULL,NULL),(43565,'48728','S','Curran','D','Alcona','26001','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.728327,-83.809576,0,'2013-07-06 12:44:32',NULL,NULL),(40605,'45890','S','Vanlue','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.967308,-83.489889,0,'2013-07-06 12:44:32',NULL,NULL),(43420,'48466','S','Peck','D','Sanilac','26151','Michigan','MI','26','0000','810','Eastern',-5.0,'Y',43.274958,-82.811823,0,'2013-07-06 12:44:32',NULL,NULL),(10322,'10541','S','Mahopac','D','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.378032,-73.749712,0,'2013-07-06 12:44:30',NULL,NULL),(58302,'68428','S','Raymond','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.970750,-96.786660,0,'2013-07-06 12:44:33',NULL,NULL),(69159,'83318','S','Starrhs Ferry','N','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.528311,-113.790822,0,'2013-07-06 12:44:34',NULL,NULL),(75164,'93591','S','Lake Los Angeles','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.604861,-117.832601,0,'2013-07-06 12:44:34',NULL,NULL),(68477,'81247','S','Gunnison','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.490794,-107.075470,0,'2013-07-06 12:44:34',NULL,NULL),(39863,'45177','S','Wilmington','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.453237,-83.843068,0,'2013-07-06 12:44:32',NULL,NULL),(53712,'62238','S','Cutler','D','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.980409,-89.362381,0,'2013-07-06 12:44:33',NULL,NULL),(41447,'46885','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.135863,-85.033678,0,'2013-07-06 12:44:32',NULL,NULL),(35692,'39662','S','Sauls','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.381546,-90.292446,0,'2013-07-06 12:44:32',NULL,NULL),(14836,'15435','P','Fairbank','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.942726,-79.849407,0,'2013-07-06 12:44:31',NULL,NULL),(26792,'29455','S','Seabrook Island','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.691291,-80.091155,0,'2013-07-06 12:44:31',NULL,NULL),(76303,'95442','S','Glen Ellen','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.372891,-122.528168,0,'2013-07-06 12:44:34',NULL,NULL),(48605,'55787','S','Balsam','N','Aitkin','27001','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.637586,-93.122746,0,'2013-07-06 12:44:33',NULL,NULL),(73397,'91118','P','Pasadena','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.125011,-118.092416,0,'2013-07-06 12:44:34',NULL,NULL),(2670,'00966','S','Urb Tintillo Hls','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(23239,'25109','P','Hometown','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.533170,-81.862742,0,'2013-07-06 12:44:31',NULL,NULL),(51177,'59013','P','Boyd','D','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.455285,-109.063818,0,'2013-07-06 12:44:33',NULL,NULL),(10324,'10543','S','Mamaroneck','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.955281,-73.737657,0,'2013-07-06 12:44:30',NULL,NULL),(47882,'55092','S','Columbus','N','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.329640,-93.074700,0,'2013-07-06 12:44:33',NULL,NULL),(35289,'39401','S','Hattiesburg South','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(15250,'16052','S','Prospect','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.906532,-80.072945,0,'2013-07-06 12:44:31',NULL,NULL),(60328,'71461','S','New Llano','D','Vernon','22115','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.115114,-93.283142,0,'2013-07-06 12:44:33',NULL,NULL),(65491,'77657','S','Lumberton','D','Hardin','48199','Texas','TX','48','0840','409','Central',-6.0,'Y',30.249112,-94.191872,0,'2013-07-06 12:44:34',NULL,NULL),(30755,'33566','S','Plant City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.003601,-82.097562,0,'2013-07-06 12:44:32',NULL,NULL),(60300,'71454','S','New Hope','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.626100,-92.818663,0,'2013-07-06 12:44:33',NULL,NULL),(57292,'66616','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.065147,-95.638885,0,'2013-07-06 12:44:33',NULL,NULL),(22193,'23505','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.911339,-76.284855,0,'2013-07-06 12:44:31',NULL,NULL),(38658,'43943','S','Connorsville','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.179877,-80.707940,0,'2013-07-06 12:44:32',NULL,NULL),(14912,'15536','S','Crystal Spring','D','Fulton','42057','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',39.929488,-78.212411,0,'2013-07-06 12:44:31',NULL,NULL),(2008,'00913','S','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.451003,-66.045064,0,'2013-07-06 12:44:30',NULL,NULL),(32284,'35660','S','Sheffield','D','Colbert','01033','Alabama','AL','01','2650','256','Central',-6.0,'Y',34.754898,-87.681822,0,'2013-07-06 12:44:32',NULL,NULL),(67754,'80621','S','Ft Lupton','N','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.099919,-104.805331,0,'2013-07-06 12:44:34',NULL,NULL),(64004,'76115','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.682825,-97.332300,0,'2013-07-06 12:44:34',NULL,NULL),(17930,'18470','S','Clifford Twp','A','Susquehanna','42115','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.713270,-75.550480,0,'2013-07-06 12:44:31',NULL,NULL),(56736,'65711','S','Mountain Grove','D','Wright','29229','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.378970,-92.367020,0,'2013-07-06 12:44:33',NULL,NULL),(39517,'44815','P','Bettsville','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.242804,-83.232241,0,'2013-07-06 12:44:32',NULL,NULL),(74630,'92807','S','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.854371,-117.785773,0,'2013-07-06 12:44:34',NULL,NULL),(69630,'83877','P','Post Falls','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.714861,-116.945541,0,'2013-07-06 12:44:34',NULL,NULL),(28485,'31519','S','Broxton','D','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.627081,-82.891582,0,'2013-07-06 12:44:32',NULL,NULL),(27827,'30414','P','Bellville','D','Evans','13109','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.150960,-81.973742,0,'2013-07-06 12:44:31',NULL,NULL),(61135,'72160','S','Brummitt','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(60154,'71378','S','Wisner','D','Franklin','22041','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.971417,-91.657424,0,'2013-07-06 12:44:33',NULL,NULL),(56656,'65618','S','Brixey','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.753995,-92.392466,0,'2013-07-06 12:44:33',NULL,NULL),(35758,'39739','S','Brooksville','D','Noxubee','28103','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.234567,-88.580798,0,'2013-07-06 12:44:32',NULL,NULL),(11934,'12430','S','Halcott Ctr','A','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.195000,-74.550556,0,'2013-07-06 12:44:30',NULL,NULL),(6134,'05461','S','Mechanicsburg','N','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.304622,-73.118170,0,'2013-07-06 12:44:30',NULL,NULL),(31340,'34141','S','Jerome','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.906809,-81.303364,0,'2013-07-06 12:44:32',NULL,NULL),(74183,'92276','S','Thousand Plms','A','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.810639,-116.376227,0,'2013-07-06 12:44:34',NULL,NULL),(56902,'66045','U','University of Kansas','N','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.959171,-95.264228,0,'2013-07-06 12:44:33',NULL,NULL),(26305,'29036','S','Chapin','D','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.141080,-81.344100,0,'2013-07-06 12:44:31',NULL,NULL),(34207,'38345','S','Huron','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.586780,-88.508713,0,'2013-07-06 12:44:32',NULL,NULL),(4998,'04217','S','Gilead','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.447236,-70.693616,0,'2013-07-06 12:44:30',NULL,NULL),(44038,'49423','S','Holland','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.779463,-86.110617,0,'2013-07-06 12:44:32',NULL,NULL),(8930,'08751','S','Seaside Heights','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.937620,-74.080080,0,'2013-07-06 12:44:30',NULL,NULL),(29788,'33017','P','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.943386,-80.318215,0,'2013-07-06 12:44:32',NULL,NULL),(13527,'13820','S','Emmons','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.481020,-75.070440,0,'2013-07-06 12:44:31',NULL,NULL),(78927,'98366','S','Long Lake','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(25201,'28078','S','Caldwell','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.414040,-80.852580,0,'2013-07-06 12:44:31',NULL,NULL),(23751,'25951','S','Brooks','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.667392,-80.883909,0,'2013-07-06 12:44:31',NULL,NULL),(48815,'56028','S','Elysian','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.233426,-93.704695,0,'2013-07-06 12:44:33',NULL,NULL),(63162,'75393','U','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.801369,-96.790487,0,'2013-07-06 12:44:33',NULL,NULL),(59932,'71292','S','Luna','N','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.444493,-92.203495,0,'2013-07-06 12:44:33',NULL,NULL),(16510,'17265','S','Upperstrasburg','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.052056,-77.753164,0,'2013-07-06 12:44:31',NULL,NULL),(67330,'80040','P','Aurora','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.723696,-104.767316,0,'2013-07-06 12:44:34',NULL,NULL),(53740,'62253','S','Tamalco','N','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.739872,-89.312992,0,'2013-07-06 12:44:33',NULL,NULL),(58197,'68319','S','Bradshaw','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.884339,-97.745935,0,'2013-07-06 12:44:33',NULL,NULL),(64279,'76433','S','Bluff Dale','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.352313,-98.021842,0,'2013-07-06 12:44:34',NULL,NULL),(69818,'84074','S','Pine Canyon','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(52807,'61279','S','Marston','N','Rock Island','17161','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.342093,-90.705564,0,'2013-07-06 12:44:33',NULL,NULL),(68840,'82520','S','Sweetwatr Sta','A','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(16842,'17560','S','New Providnce','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.926389,-76.252500,0,'2013-07-06 12:44:31',NULL,NULL),(69374,'83605','S','Doles','N','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.658798,-116.716481,0,'2013-07-06 12:44:34',NULL,NULL),(19322,'20023','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.881607,-76.995593,0,'2013-07-06 12:44:31',NULL,NULL),(57739,'67427','S','Bushton','D','Rice','20159','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.513006,-98.395487,0,'2013-07-06 12:44:33',NULL,NULL),(77998,'97406','S','Agness','D','Curry','41015','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.608430,-124.074122,0,'2013-07-06 12:44:34',NULL,NULL),(53991,'62442','S','Cleone','N','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.330353,-87.886995,0,'2013-07-06 12:44:33',NULL,NULL),(78170,'97636','S','Paisley','D','Lake','41037','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.710132,-120.513961,0,'2013-07-06 12:44:34',NULL,NULL),(75509,'94143','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.763790,-122.457389,0,'2013-07-06 12:44:34',NULL,NULL),(16413,'17224','S','Tuscarora Hts','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(28191,'31015','S','Cordele','D','Crisp','13081','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.946591,-83.765287,0,'2013-07-06 12:44:31',NULL,NULL),(52478,'60689','U','Fifth Third Bank','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.850211,-87.652468,0,'2013-07-06 12:44:33',NULL,NULL),(38259,'43301','P','Marion','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.565693,-83.124872,0,'2013-07-06 12:44:32',NULL,NULL),(25560,'28412','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.142287,-77.915225,0,'2013-07-06 12:44:31',NULL,NULL),(25898,'28643','S','Sturgills','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.490000,-81.510000,0,'2013-07-06 12:44:31',NULL,NULL),(25198,'28075','S','Harrisburg','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.333819,-80.663496,0,'2013-07-06 12:44:31',NULL,NULL),(22742,'24401','S','Staunton','D','Staunton City','51790','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.153156,-79.078684,0,'2013-07-06 12:44:31',NULL,NULL),(72100,'88220','S','Carlsbad Caverns National Pa','N','Eddy','35015','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.397966,-104.241065,0,'2013-07-06 12:44:34',NULL,NULL),(66658,'78860','P','El Indio','D','Maverick','48323','Texas','TX','48','0000','830','Central',-6.0,'Y',28.516711,-100.312589,0,'2013-07-06 12:44:34',NULL,NULL),(51760,'60030','S','Gages Lake','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.341153,-88.024884,0,'2013-07-06 12:44:33',NULL,NULL),(41701,'47228','P','Cortland','D','Jackson','18071','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.985937,-86.003945,0,'2013-07-06 12:44:32',NULL,NULL),(71572,'87302','U','Sw Indian Foundation','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.431205,-108.728509,0,'2013-07-06 12:44:34',NULL,NULL),(26070,'28694','S','West Jefferson','D','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(62616,'74538','S','Cottonwood','N','Coal','40029','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.534003,-96.219571,0,'2013-07-06 12:44:33',NULL,NULL),(57002,'66204','S','Shawnee Mission','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(54627,'62918','S','Crainville','N','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.789020,-89.096520,0,'2013-07-06 12:44:33',NULL,NULL),(76941,'96027','S','Etna','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.427300,-122.916600,0,'2013-07-06 12:44:34',NULL,NULL),(53105,'61536','S','Hanna City','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.687089,-89.792578,0,'2013-07-06 12:44:33',NULL,NULL),(46373,'53127','P','Genesee Depot','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.971014,-88.371705,0,'2013-07-06 12:44:32',NULL,NULL),(1032,'00720','S','Alt de Orocovis','N','Orocovis','72107','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.229109,-66.391520,0,'2013-07-06 12:44:30',NULL,NULL),(33293,'37128','S','Murfreesboro','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.815518,-86.451250,0,'2013-07-06 12:44:32',NULL,NULL),(34629,'38756','S','Leland','D','Washington','28151','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.406160,-90.897726,0,'2013-07-06 12:44:32',NULL,NULL),(35675,'39654','S','Rosella','N','Lawrence','28077','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.506000,-90.118080,0,'2013-07-06 12:44:32',NULL,NULL),(28596,'31645','S','Ray City','D','Berrien','13019','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.073974,-83.195973,0,'2013-07-06 12:44:32',NULL,NULL),(38270,'43316','S','Carey','D','Wyandot','39175','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.943398,-83.381939,0,'2013-07-06 12:44:32',NULL,NULL),(37621,'42141','S','Dry Fork','N','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.974371,-85.907023,0,'2013-07-06 12:44:32',NULL,NULL),(77315,'96686','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(71999,'88036','P','Ft Bayard','N','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.768885,-108.143971,0,'2013-07-06 12:44:34',NULL,NULL),(61358,'72479','S','Weiner','D','Poinsett','05111','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.643977,-90.929712,0,'2013-07-06 12:44:33',NULL,NULL),(21733,'23021','S','Bohannon','D','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.393121,-76.372982,0,'2013-07-06 12:44:31',NULL,NULL),(57572,'67057','S','Hardtner','D','Barber','20007','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.016334,-98.648322,0,'2013-07-06 12:44:33',NULL,NULL),(51443,'59471','S','Roy','D','Fergus','30027','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.406535,-108.739056,0,'2013-07-06 12:44:33',NULL,NULL),(50806,'58454','S','Jud','D','Lamoure','38045','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.488265,-98.813122,0,'2013-07-06 12:44:33',NULL,NULL),(32114,'35404','S','Tuscaloosa','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.212241,-87.492537,0,'2013-07-06 12:44:32',NULL,NULL),(72597,'89410','S','Centerville','N','Douglas','32005','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.829540,-119.714580,0,'2013-07-06 12:44:34',NULL,NULL),(9132,'09201','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(13836,'14221','S','Amherst','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980183,-78.734894,0,'2013-07-06 12:44:31',NULL,NULL),(2452,'00953','S','Urb Veredas Del Rio II','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(21906,'23190','P','Woods Cr Rds','N','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.483538,-76.620692,0,'2013-07-06 12:44:31',NULL,NULL),(42254,'47577','S','St Meinrad','N','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.186231,-86.847745,0,'2013-07-06 12:44:32',NULL,NULL),(50754,'58413','S','Danzig','N','McIntosh','38051','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.036030,-99.371223,0,'2013-07-06 12:44:33',NULL,NULL),(8295,'08021','S','Lindenwold','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.809815,-75.001119,0,'2013-07-06 12:44:30',NULL,NULL),(74551,'92676','S','Modjeska','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.745069,-117.615251,0,'2013-07-06 12:44:34',NULL,NULL),(71240,'86341','P','Sedona','D','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.774138,-111.762821,0,'2013-07-06 12:44:34',NULL,NULL),(66851,'79124','S','Bishop Hills','A','Potter','48375','Texas','TX','48','0320','806','Central',-6.0,'Y',35.248182,-101.907512,0,'2013-07-06 12:44:34',NULL,NULL),(9337,'09751','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(46959,'54201','S','Algoma','D','Kewaunee','55061','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.607804,-87.447524,0,'2013-07-06 12:44:32',NULL,NULL),(39809,'45140','S','Springvale','N','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.267042,-84.292122,0,'2013-07-06 12:44:32',NULL,NULL),(28547,'31561','P','Brunswick','A','Glynn','13127','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.205555,-81.329738,0,'2013-07-06 12:44:32',NULL,NULL),(33659,'37717','P','Clinton','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.091034,-84.132090,0,'2013-07-06 12:44:32',NULL,NULL),(3452,'01773','S','Lincoln','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.423884,-71.314205,0,'2013-07-06 12:44:30',NULL,NULL),(63441,'75670','S','Darco','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.516700,-94.361580,0,'2013-07-06 12:44:33',NULL,NULL),(64112,'76180','S','Northrichland Hills','N','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(71550,'87190','P','Albuquerque','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.108134,-106.596139,0,'2013-07-06 12:44:34',NULL,NULL),(73583,'91382','S','Santa Clarita','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.412894,-118.510726,0,'2013-07-06 12:44:34',NULL,NULL),(77222,'96427','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(31328,'34134','S','Bonita Beach','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.362812,-81.822980,0,'2013-07-06 12:44:32',NULL,NULL),(20088,'20695','S','White Plains','D','Charles','24017','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.592595,-76.957017,0,'2013-07-06 12:44:31',NULL,NULL),(11043,'11571','P','Rockville Ctr','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.657461,-73.648593,0,'2013-07-06 12:44:30',NULL,NULL),(48800,'56010','S','Amboy','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.887255,-94.158648,0,'2013-07-06 12:44:33',NULL,NULL),(63402,'75652','S','Church Hill','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(33216,'37055','S','Dickson','D','Dickson','47043','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.083188,-87.428235,0,'2013-07-06 12:44:32',NULL,NULL),(79641,'99138','S','Inchelium','D','Ferry','53019','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.288105,-118.525606,0,'2013-07-06 12:44:34',NULL,NULL),(48816,'56029','S','Emmons','D','Freeborn','27047','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.503746,-93.491262,0,'2013-07-06 12:44:33',NULL,NULL),(48494,'55734','S','Leonidas','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.431510,-92.516556,0,'2013-07-06 12:44:33',NULL,NULL),(44744,'50164','S','Menlo','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.558007,-94.416659,0,'2013-07-06 12:44:32',NULL,NULL),(14935,'15559','S','Schellsburg','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.044408,-78.668155,0,'2013-07-06 12:44:31',NULL,NULL),(19909,'20547','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885247,-77.014601,0,'2013-07-06 12:44:31',NULL,NULL),(68401,'81154','S','Alpine','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.672402,-106.630824,0,'2013-07-06 12:44:34',NULL,NULL),(23252,'25123','S','Grimms Landing','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.746520,-81.955930,0,'2013-07-06 12:44:31',NULL,NULL),(71416,'87022','P','Isleta','D','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.922050,-106.699627,0,'2013-07-06 12:44:34',NULL,NULL),(28407,'31319','P','Meridian','D','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421746,-81.423676,0,'2013-07-06 12:44:32',NULL,NULL),(48226,'55418','S','St Anthny Vlg','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',45.022134,-93.244686,0,'2013-07-06 12:44:33',NULL,NULL),(8784,'08556','S','Rosemont','D','Hunterdon','34019','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.420974,-74.995102,0,'2013-07-06 12:44:30',NULL,NULL),(20729,'21286','S','Towson','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.406546,-76.581702,0,'2013-07-06 12:44:31',NULL,NULL),(64589,'76673','S','Birome','A','Hill','48217','Texas','TX','48','0000','254','Central',-6.0,'Y',31.762263,-96.911319,0,'2013-07-06 12:44:34',NULL,NULL),(5866,'05144','P','Chester','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.286631,-72.634544,0,'2013-07-06 12:44:30',NULL,NULL),(17587,'18025','U','Bethlehem','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.625072,-75.371201,0,'2013-07-06 12:44:31',NULL,NULL),(42434,'47805','S','Apache Acres','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(21282,'22320','P','George Mason','N','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.805356,-77.056422,0,'2013-07-06 12:44:31',NULL,NULL),(68156,'81001','S','Pueblo Depot Activity','A','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.285226,-104.577144,0,'2013-07-06 12:44:34',NULL,NULL),(2927,'01014','P','Chicopee','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.174812,-72.572286,0,'2013-07-06 12:44:30',NULL,NULL),(66688,'78942','S','Giddings','D','Lee','48287','Texas','TX','48','0000','979','Central',-6.0,'Y',30.186180,-96.934577,0,'2013-07-06 12:44:34',NULL,NULL),(23379,'25303','S','South Charleston','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.352660,-81.658500,0,'2013-07-06 12:44:31',NULL,NULL),(10963,'11510','S','North Baldwin','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.655358,-73.607376,0,'2013-07-06 12:44:30',NULL,NULL),(14858,'15456','S','Lemont Furnace','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.922596,-79.787657,0,'2013-07-06 12:44:31',NULL,NULL),(42663,'47955','S','Linden','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.190561,-86.900602,0,'2013-07-06 12:44:32',NULL,NULL),(43695,'48887','P','Belding','A','Ionia','26067','Michigan','MI','26','0000','616','Eastern',-5.0,'Y',43.062420,-85.262729,0,'2013-07-06 12:44:32',NULL,NULL),(55842,'64161','S','Randolph','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.161625,-94.466674,0,'2013-07-06 12:44:33',NULL,NULL),(332,'00652','S','Hacienda De Garrochales','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.466248,-66.569371,0,'2013-07-06 12:44:30',NULL,NULL),(10067,'10178','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752881,-73.978560,0,'2013-07-06 12:44:30',NULL,NULL),(33233,'37068','P','Franklin','D','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.927805,-86.843648,0,'2013-07-06 12:44:32',NULL,NULL),(71043,'85744','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.047559,-110.673722,0,'2013-07-06 12:44:34',NULL,NULL),(49991,'57368','S','Plankinton','D','Aurora','46003','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.713793,-98.481568,0,'2013-07-06 12:44:33',NULL,NULL),(61750,'73044','S','Guthrie','D','Logan','40083','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.864031,-97.424514,0,'2013-07-06 12:44:33',NULL,NULL),(44860,'50277','S','Yale','D','Guthrie','19077','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.773978,-94.359197,0,'2013-07-06 12:44:32',NULL,NULL),(65210,'77437','S','Jones Creek','N','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(35319,'39425','S','Brooklyn','D','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.031160,-89.172000,0,'2013-07-06 12:44:32',NULL,NULL),(66429,'78641','S','Whitestone','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.527880,-97.880340,0,'2013-07-06 12:44:34',NULL,NULL),(69675,'84021','S','Duchesne','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.169700,-110.398451,0,'2013-07-06 12:44:34',NULL,NULL),(24144,'26570','S','Fairview','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.624974,-80.259968,0,'2013-07-06 12:44:31',NULL,NULL),(5885,'05151','S','Weathersfield Center','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.416944,-72.518333,0,'2013-07-06 12:44:30',NULL,NULL),(9996,'10166','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.754811,-73.977146,0,'2013-07-06 12:44:30',NULL,NULL),(60585,'71825','S','Blevins','D','Hempstead','05057','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888971,-93.519746,0,'2013-07-06 12:44:33',NULL,NULL),(2869,'00985','S','Villa Carolina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(25780,'28603','P','Hickory','D','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.757664,-81.327333,0,'2013-07-06 12:44:31',NULL,NULL),(19844,'20507','U','Equal Emp Opportunity Comm','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903711,-77.042144,0,'2013-07-06 12:44:31',NULL,NULL),(35905,'40014','S','Ballardsville','A','Oldham','21185','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.337990,-85.443424,0,'2013-07-06 12:44:32',NULL,NULL),(28881,'32123','P','Allandale','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.149529,-81.031180,0,'2013-07-06 12:44:32',NULL,NULL),(18851,'19436','S','North Wales','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.206010,-75.247779,0,'2013-07-06 12:44:31',NULL,NULL),(20475,'21042','S','Ellicott City','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.277416,-76.866712,0,'2013-07-06 12:44:31',NULL,NULL),(18982,'19520','S','Pine Swamp','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(6544,'05840','P','Granby','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.572522,-71.760456,0,'2013-07-06 12:44:30',NULL,NULL),(19593,'20223','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894341,-77.036991,0,'2013-07-06 12:44:31',NULL,NULL),(31475,'34295','P','Englewood','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',26.930149,-82.283757,0,'2013-07-06 12:44:32',NULL,NULL),(32492,'36054','S','Millbrook','D','Elmore','01051','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.489491,-86.368080,0,'2013-07-06 12:44:32',NULL,NULL),(49854,'57242','S','Hazel','D','Hamlin','46057','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.756769,-97.384225,0,'2013-07-06 12:44:33',NULL,NULL),(53085,'61526','S','Edelstein','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.958700,-89.588220,0,'2013-07-06 12:44:33',NULL,NULL),(69772,'84057','S','Orem','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.315140,-111.695870,0,'2013-07-06 12:44:34',NULL,NULL),(72000,'88036','P','Silver City','A','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.768885,-108.143971,0,'2013-07-06 12:44:34',NULL,NULL),(23531,'25601','S','Logan','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.868777,-81.988500,0,'2013-07-06 12:44:31',NULL,NULL),(2539,'00959','S','Ext Forest Hls','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(7633,'07063','S','Plainfield','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.609259,-74.453927,0,'2013-07-06 12:44:30',NULL,NULL),(33120,'36868','P','Phenix City','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.450321,-85.008861,0,'2013-07-06 12:44:32',NULL,NULL),(6704,'06063','S','Pleasant Vly','A','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.917156,-72.977392,0,'2013-07-06 12:44:30',NULL,NULL),(48856,'56073','S','Klossner','A','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.312771,-94.465735,0,'2013-07-06 12:44:33',NULL,NULL),(6172,'05473','S','No Ferrisburgh','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.254680,-73.210800,0,'2013-07-06 12:44:30',NULL,NULL),(30944,'33729','U','Home Shopping','N','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878378,-82.669082,0,'2013-07-06 12:44:32',NULL,NULL),(67412,'80132','S','Woodmoor','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.100182,-104.849748,0,'2013-07-06 12:44:34',NULL,NULL),(32936,'36567','S','Elsanor','N','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.569400,-87.630720,0,'2013-07-06 12:44:32',NULL,NULL),(76835,'95961','S','Olivehurst','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.088781,-121.550818,0,'2013-07-06 12:44:34',NULL,NULL),(6500,'05778','S','West Cornwall','A','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.885116,-73.211804,0,'2013-07-06 12:44:30',NULL,NULL),(44882,'50315','S','South Des Moines','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.544895,-93.615845,0,'2013-07-06 12:44:32',NULL,NULL),(41889,'47371','S','Blaine','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(47353,'54613','S','Arkdale','D','Adams','55001','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.064139,-89.898982,0,'2013-07-06 12:44:32',NULL,NULL),(16781,'17532','S','Bethesda','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.856500,-76.300080,0,'2013-07-06 12:44:31',NULL,NULL),(62482,'74349','P','Grnd Lke Town','A','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.522655,-95.024834,0,'2013-07-06 12:44:33',NULL,NULL),(20837,'21640','S','Henderson','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',39.068537,-75.814675,0,'2013-07-06 12:44:31',NULL,NULL),(77561,'96898','P','Wake Island','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.310541,-157.863115,0,'2013-07-06 12:44:34',NULL,NULL),(66751,'79008','P','Borger','D','Hutchinson','48233','Texas','TX','48','0000','806','Central',-6.0,'Y',35.669658,-101.388130,0,'2013-07-06 12:44:34',NULL,NULL),(66163,'78520','S','Acacia Lake','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(63233,'75469','S','Pecan Gap','D','Delta','48119','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.406499,-95.804842,0,'2013-07-06 12:44:33',NULL,NULL),(55569,'63873','S','Conran','A','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.430781,-89.697849,0,'2013-07-06 12:44:33',NULL,NULL),(17915,'18457','P','Rowland','D','Pike','42103','Pennsylvania','PA','42','5660','570','Eastern',-5.0,'Y',41.468132,-75.043999,0,'2013-07-06 12:44:31',NULL,NULL),(23664,'25826','P','Corinne','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.572389,-81.361365,0,'2013-07-06 12:44:31',NULL,NULL),(16678,'17362','S','Spring Grove','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.874292,-76.864491,0,'2013-07-06 12:44:31',NULL,NULL),(44332,'49759','S','Millersburg','D','Presque Isle','26141','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',45.436961,-84.100677,0,'2013-07-06 12:44:32',NULL,NULL),(12359,'12901','S','Beekmantown','N','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.727960,-73.463100,0,'2013-07-06 12:44:30',NULL,NULL),(75573,'94277','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585210,-121.489578,0,'2013-07-06 12:44:34',NULL,NULL),(62014,'73447','S','Mannsville','D','Johnston','40069','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.198181,-96.790680,0,'2013-07-06 12:44:33',NULL,NULL),(57998,'67861','S','Leoti','D','Wichita','20203','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.483861,-101.356671,0,'2013-07-06 12:44:33',NULL,NULL),(57922,'67667','P','Schoenchen','D','Ellis','20051','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.713957,-99.331020,0,'2013-07-06 12:44:33',NULL,NULL),(55880,'64402','S','Albany','D','Gentry','29075','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.248635,-94.331441,0,'2013-07-06 12:44:33',NULL,NULL),(37137,'41465','S','Ever','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(36608,'40977','S','Dorton Branch','A','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(25624,'28461','S','Saint James','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(14983,'15642','S','Irwin','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.328956,-79.721348,0,'2013-07-06 12:44:31',NULL,NULL),(10378,'10591','S','Pocantico Hills','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(72802,'89711','U','Nevada Motor Vehicle','N','Carson City','32510','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.163917,-119.765948,0,'2013-07-06 12:44:34',NULL,NULL),(5947,'05260','S','North Pownal','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.821495,-73.250086,0,'2013-07-06 12:44:30',NULL,NULL),(20886,'21701','S','Lewistown','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.418320,-77.336160,0,'2013-07-06 12:44:31',NULL,NULL),(11645,'12125','S','New Lebanon','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.483586,-73.377729,0,'2013-07-06 12:44:30',NULL,NULL),(78246,'97828','S','Enterprise','D','Wallowa','41063','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.417100,-117.270806,0,'2013-07-06 12:44:34',NULL,NULL),(77399,'96778','S','Pahoa','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.527960,-154.909098,0,'2013-07-06 12:44:34',NULL,NULL),(23592,'25678','S','Blckberry Cty','A','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649769,-82.126194,0,'2013-07-06 12:44:31',NULL,NULL),(65083,'77354','S','Decker Prairie','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.221346,-95.676720,0,'2013-07-06 12:44:34',NULL,NULL),(47869,'55082','S','Stillwater','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.052620,-92.846400,0,'2013-07-06 12:44:33',NULL,NULL),(9102,'09081','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(32427,'35983','S','Sand Rock','A','Cherokee','01019','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.160544,-85.779405,0,'2013-07-06 12:44:32',NULL,NULL),(7864,'07502','S','Totowa','A','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.918903,-74.194887,0,'2013-07-06 12:44:30',NULL,NULL),(21643,'22931','S','Covesville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.906385,-78.722678,0,'2013-07-06 12:44:31',NULL,NULL),(11008,'11556','S','Uniondale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.701858,-73.620203,0,'2013-07-06 12:44:30',NULL,NULL),(50175,'57555','S','Olsonville','N','Todd','46121','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.194176,-100.477794,0,'2013-07-06 12:44:33',NULL,NULL),(37830,'42442','S','Nortonville','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.179410,-87.471198,0,'2013-07-06 12:44:32',NULL,NULL),(42934,'48116','S','Genoa Twp','N','Livingston','26093','Michigan','MI','26','0440','810','Eastern',-5.0,'Y',42.532103,-83.773187,0,'2013-07-06 12:44:32',NULL,NULL),(32690,'36274','S','Roanoke','D','Randolph','01111','Alabama','AL','01','0000','334','Central',-6.0,'Y',33.152242,-85.372945,0,'2013-07-06 12:44:32',NULL,NULL),(77810,'97143','P','Netarts','D','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.436071,-123.942514,0,'2013-07-06 12:44:34',NULL,NULL),(7847,'07470','S','Mountain View','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(14140,'14706','S','Allegany','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.103002,-78.493761,0,'2013-07-06 12:44:31',NULL,NULL),(4867,'04029','S','E Sebago','N','Cumberland','23005','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.888056,-70.632500,0,'2013-07-06 12:44:30',NULL,NULL),(32028,'35242','S','Vestavia Hills','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.403565,-86.711683,0,'2013-07-06 12:44:32',NULL,NULL),(28077,'30726','P','Graysville','D','Catoosa','13047','Georgia','GA','13','1560','706/762','Eastern',-5.0,'Y',34.974190,-85.142346,0,'2013-07-06 12:44:31',NULL,NULL),(25332,'28209','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.174505,-80.853465,0,'2013-07-06 12:44:31',NULL,NULL),(20107,'20709','P','Laurel','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.064161,-76.837097,0,'2013-07-06 12:44:31',NULL,NULL),(36615,'40977','S','Straight Creek','N','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.751701,-83.699321,0,'2013-07-06 12:44:32',NULL,NULL),(45647,'51656','P','Yorktown','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.732025,-95.154746,0,'2013-07-06 12:44:32',NULL,NULL),(17011,'17740','S','Larryville','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(10947,'11436','S','South Ozone Park','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.678055,-73.797848,0,'2013-07-06 12:44:30',NULL,NULL),(76413,'95556','P','Orleans','D','Humboldt','06023','California','CA','06','0000','530','Pacific',-8.0,'Y',41.289963,-123.551367,0,'2013-07-06 12:44:34',NULL,NULL),(50580,'58230','S','Finley','D','Steele','38091','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.537087,-97.710357,0,'2013-07-06 12:44:33',NULL,NULL),(39827,'45153','S','Moscow','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.852640,-84.179460,0,'2013-07-06 12:44:32',NULL,NULL),(14301,'14881','S','Slatervle Spg','A','Tompkins','36109','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.401520,-76.322280,0,'2013-07-06 12:44:31',NULL,NULL),(4274,'02889','S','Conimicut','N','Kent','44003','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.709084,-71.386673,0,'2013-07-06 12:44:30',NULL,NULL),(67700,'80524','S','Fort Collins','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.635510,-105.049839,0,'2013-07-06 12:44:34',NULL,NULL),(58968,'70036','S','Barataria','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.693729,-90.104339,0,'2013-07-06 12:44:33',NULL,NULL),(37828,'42440','P','Mortons Gap','D','Hopkins','21107','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.238024,-87.469456,0,'2013-07-06 12:44:32',NULL,NULL),(78642,'98223','S','Arlington','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.181800,-121.979640,0,'2013-07-06 12:44:34',NULL,NULL),(68507,'81324','S','Squaw Point','N','Dolores','08033','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.765803,-108.904715,0,'2013-07-06 12:44:34',NULL,NULL),(24240,'26757','S','Romney','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.344134,-78.758405,0,'2013-07-06 12:44:31',NULL,NULL),(55905,'64439','S','Dearborn','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.527161,-94.767966,0,'2013-07-06 12:44:33',NULL,NULL),(70496,'84775','S','Caineville','N','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.302647,-111.367243,0,'2013-07-06 12:44:34',NULL,NULL),(45752,'52141','S','Brainard','N','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.958838,-91.636493,0,'2013-07-06 12:44:32',NULL,NULL),(4806,'03887','S','Middleton','A','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.462117,-71.075110,0,'2013-07-06 12:44:30',NULL,NULL),(77456,'96813','S','HON','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.314718,-157.853702,0,'2013-07-06 12:44:34',NULL,NULL),(33828,'37929','S','Knoxville','D','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.962625,-83.921292,0,'2013-07-06 12:44:32',NULL,NULL),(73190,'90503','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.842791,-118.357275,0,'2013-07-06 12:44:34',NULL,NULL),(30251,'33206','U','Aeropost','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.795180,-80.325380,0,'2013-07-06 12:44:32',NULL,NULL),(65221,'77444','S','Guy','D','Fort Bend','48157','Texas','TX','48','3360','979','Central',-6.0,'Y',29.312180,-95.787708,0,'2013-07-06 12:44:34',NULL,NULL),(35261,'39355','S','Quitman','D','Clarke','28023','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.045394,-88.723680,0,'2013-07-06 12:44:32',NULL,NULL),(23766,'25966','P','Meadow Bridge','A','Summers','54089','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.796066,-80.830326,0,'2013-07-06 12:44:31',NULL,NULL),(39999,'45243','S','Columbia Twp','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.185697,-84.352352,0,'2013-07-06 12:44:32',NULL,NULL),(32098,'35295','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.511347,-86.804838,0,'2013-07-06 12:44:32',NULL,NULL),(65885,'78229','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.501242,-98.573979,0,'2013-07-06 12:44:34',NULL,NULL),(27669,'30328','S','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.933854,-84.386944,0,'2013-07-06 12:44:31',NULL,NULL),(63354,'75631','S','Grand Bluff','N','Panola','48365','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.252312,-94.452675,0,'2013-07-06 12:44:33',NULL,NULL),(56801,'65766','S','Udall','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.526066,-92.233750,0,'2013-07-06 12:44:33',NULL,NULL),(27243,'29925','P','Hilton Head Island','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.164766,-80.754408,0,'2013-07-06 12:44:31',NULL,NULL),(5870,'05146','S','Grafton','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.147412,-72.623850,0,'2013-07-06 12:44:30',NULL,NULL),(38698,'44001','S','So Amherst','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.369097,-82.253517,0,'2013-07-06 12:44:32',NULL,NULL),(1198,'00728','S','Jard del Caribe','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(19449,'20117','S','Middleburg','D','Loudoun','51107','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.006815,-77.748359,0,'2013-07-06 12:44:31',NULL,NULL),(55796,'64129','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.021792,-94.489653,0,'2013-07-06 12:44:33',NULL,NULL),(57938,'67737','S','Grainfield','D','Gove','20063','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.110945,-100.464358,0,'2013-07-06 12:44:33',NULL,NULL),(24115,'26534','P','Granville','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.639722,-79.987121,0,'2013-07-06 12:44:31',NULL,NULL),(65915,'78237','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.422667,-98.565747,0,'2013-07-06 12:44:34',NULL,NULL),(21832,'23116','S','Mechanicsvlle','A','Hanover','51085','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.628332,-77.353236,0,'2013-07-06 12:44:31',NULL,NULL),(13246,'13642','S','Gouverneur','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.302440,-75.415680,0,'2013-07-06 12:44:30',NULL,NULL),(5508,'04766','S','Perham','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.846520,-68.200237,0,'2013-07-06 12:44:30',NULL,NULL),(10234,'10465','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.823241,-73.826218,0,'2013-07-06 12:44:30',NULL,NULL),(70335,'84629','S','Thistle','A','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.854820,-111.445320,0,'2013-07-06 12:44:34',NULL,NULL),(27967,'30557','S','Avalon','A','Stephens','13257','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.530869,-83.144053,0,'2013-07-06 12:44:31',NULL,NULL),(6718,'06069','S','Sharon Valley','N','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.865139,-73.455872,0,'2013-07-06 12:44:30',NULL,NULL),(20285,'20792','P','Uppr Marlboro','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.815289,-76.749621,0,'2013-07-06 12:44:31',NULL,NULL),(43287,'48334','S','Farmington Hills','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.505423,-83.351825,0,'2013-07-06 12:44:32',NULL,NULL),(3132,'01247','S','Florida','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.687120,-73.074360,0,'2013-07-06 12:44:30',NULL,NULL),(34355,'38588','S','Whitleyville','D','Jackson','47087','Tennessee','TN','47','0000','931','Central',-6.0,'Y',36.483570,-85.707587,0,'2013-07-06 12:44:32',NULL,NULL),(28716,'31901','S','Columbus','D','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.474185,-84.977932,0,'2013-07-06 12:44:32',NULL,NULL),(74928,'93403','P','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.280162,-120.656816,0,'2013-07-06 12:44:34',NULL,NULL),(20296,'20811','U','Geico','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.982042,-77.099807,0,'2013-07-06 12:44:31',NULL,NULL),(13094,'13472','P','Thendara','D','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.839312,-74.998485,0,'2013-07-06 12:44:30',NULL,NULL),(33756,'37853','S','Rockford','D','Blount','47009','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.828507,-83.944804,0,'2013-07-06 12:44:32',NULL,NULL),(56631,'65605','S','Aurora','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.956100,-93.720540,0,'2013-07-06 12:44:33',NULL,NULL),(47092,'54436','S','York','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.569207,-90.452286,0,'2013-07-06 12:44:32',NULL,NULL),(68788,'82336','P','Red Desert','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.629570,-108.264820,0,'2013-07-06 12:44:34',NULL,NULL),(48127,'55359','S','Independence','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.997812,-93.687245,0,'2013-07-06 12:44:33',NULL,NULL),(44644,'50074','S','Beaconsfield','A','Ringgold','19159','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.852201,-94.074806,0,'2013-07-06 12:44:32',NULL,NULL),(5881,'05150','S','North Springfield','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.335916,-72.524997,0,'2013-07-06 12:44:30',NULL,NULL),(6567,'05851','S','Red Village','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.544120,-72.021300,0,'2013-07-06 12:44:30',NULL,NULL),(79301,'98588','S','Tahuya','D','Mason','53045','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.403801,-123.038252,0,'2013-07-06 12:44:34',NULL,NULL),(13706,'14063','S','Fredonia','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.425716,-79.340280,0,'2013-07-06 12:44:31',NULL,NULL),(70669,'85215','S','Mesa','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.468094,-111.706926,0,'2013-07-06 12:44:34',NULL,NULL),(67158,'79789','P','Wink','D','Winkler','48495','Texas','TX','48','0000','432','Central',-6.0,'Y',31.750379,-103.157737,0,'2013-07-06 12:44:34',NULL,NULL),(32627,'36177','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.378975,-86.303722,0,'2013-07-06 12:44:32',NULL,NULL),(65709,'78015','S','Fair Oaks','A','Kendall','48259','Texas','TX','48','7240','210','Central',-6.0,'Y',29.801349,-98.741246,0,'2013-07-06 12:44:34',NULL,NULL),(56245,'65051','S','Linn','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.478325,-91.844999,0,'2013-07-06 12:44:33',NULL,NULL),(24273,'26847','S','Landes Station','A','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.996532,-79.123849,0,'2013-07-06 12:44:31',NULL,NULL),(75522,'94160','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.718015,-122.404390,0,'2013-07-06 12:44:34',NULL,NULL),(70828,'85392','S','Avondale','D','Maricopa','04013','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',33.471893,-112.276769,0,'2013-07-06 12:44:34',NULL,NULL),(63033,'75205','S','Highland Park','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.836236,-96.794663,0,'2013-07-06 12:44:33',NULL,NULL),(3302,'01515','S','East Brookfield','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.222612,-72.053004,0,'2013-07-06 12:44:30',NULL,NULL),(33461,'37323','S','Clevelnd','N','Bradley','47011','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.125348,-84.866606,0,'2013-07-06 12:44:32',NULL,NULL),(15805,'16927','S','Harrison','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.951385,-77.702976,0,'2013-07-06 12:44:31',NULL,NULL),(54191,'62628','S','Chapin','D','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.767526,-90.403632,0,'2013-07-06 12:44:33',NULL,NULL),(47779,'55043','S','Lakeland Shrs','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.952548,-92.771548,0,'2013-07-06 12:44:33',NULL,NULL),(31483,'34431','S','Dunnellon','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.141649,-82.515504,0,'2013-07-06 12:44:32',NULL,NULL),(66053,'78377','S','Refugio','D','Refugio','48391','Texas','TX','48','0000','361','Central',-6.0,'Y',28.298118,-97.281607,0,'2013-07-06 12:44:34',NULL,NULL),(17862,'18434','S','Jessup','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.473584,-75.570479,0,'2013-07-06 12:44:31',NULL,NULL),(16415,'17225','S','Cosytown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.789267,-77.752975,0,'2013-07-06 12:44:31',NULL,NULL),(248,'00637','S','Urb San Miguel','N','Sabana Grande','72121','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.081674,-66.968022,0,'2013-07-06 12:44:30',NULL,NULL),(19157,'19716','S','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.714507,-75.738715,0,'2013-07-06 12:44:31',NULL,NULL),(27725,'30348','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.835327,-84.392667,0,'2013-07-06 12:44:31',NULL,NULL),(31842,'35087','S','Joppa','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.274397,-86.550323,0,'2013-07-06 12:44:32',NULL,NULL),(31992,'35223','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.489469,-86.741202,0,'2013-07-06 12:44:32',NULL,NULL),(31876,'35125','S','Glen City','N','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.573051,-86.276572,0,'2013-07-06 12:44:32',NULL,NULL),(78550,'98146','S','White Center','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.500943,-122.357500,0,'2013-07-06 12:44:34',NULL,NULL),(78280,'97867','S','N Powder','N','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.035797,-117.937934,0,'2013-07-06 12:44:34',NULL,NULL),(77027,'96101','S','Alturas Rancheria','N','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.512612,-120.551753,0,'2013-07-06 12:44:34',NULL,NULL),(75589,'94294','U','Ca Dept Motor Vehicle','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.556446,-121.494212,0,'2013-07-06 12:44:34',NULL,NULL),(29040,'32234','S','Baldwin','A','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.219367,-81.997401,0,'2013-07-06 12:44:32',NULL,NULL),(12911,'13338','S','McKeever','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(35999,'40144','S','Locust Hill','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.750620,-86.371080,0,'2013-07-06 12:44:32',NULL,NULL),(41770,'47303','S','Hamilton Park','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.218641,-85.377520,0,'2013-07-06 12:44:32',NULL,NULL),(47949,'55118','S','Mendota Hts','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.893500,-93.108360,0,'2013-07-06 12:44:33',NULL,NULL),(70697,'85263','S','Rio Verde','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.722520,-111.675000,0,'2013-07-06 12:44:34',NULL,NULL),(59544,'70819','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.469095,-91.012658,0,'2013-07-06 12:44:33',NULL,NULL),(52631,'61047','S','Egan','A','Ogle','17141','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.165240,-89.401260,0,'2013-07-06 12:44:33',NULL,NULL),(48904,'56128','S','Edgerton','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.872956,-96.129560,0,'2013-07-06 12:44:33',NULL,NULL),(37739,'42303','S','Owensboro','D','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.757138,-87.092555,0,'2013-07-06 12:44:32',NULL,NULL),(22018,'23289','U','Internal Revenue Service','N','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.542258,-77.434021,0,'2013-07-06 12:44:31',NULL,NULL),(25769,'28601','S','Bethlehem','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.753580,-81.324900,0,'2013-07-06 12:44:31',NULL,NULL),(14722,'15279','U','Duquesne Light Co','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.465513,-80.038303,0,'2013-07-06 12:44:31',NULL,NULL),(4763,'03854','P','New Castle','D','Rockingham','33015','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.068790,-70.719895,0,'2013-07-06 12:44:30',NULL,NULL),(2113,'00923','S','Villa Granada','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.412398,-66.039106,0,'2013-07-06 12:44:30',NULL,NULL),(79661,'99154','S','Harrington','A','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.402809,-118.329726,0,'2013-07-06 12:44:34',NULL,NULL),(76691,'95821','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.621789,-121.381978,0,'2013-07-06 12:44:34',NULL,NULL),(32392,'35953','S','Ashville','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.837955,-86.250092,0,'2013-07-06 12:44:32',NULL,NULL),(2521,'00957','S','Urb San Fernando','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(9978,'10162','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766659,-73.958508,0,'2013-07-06 12:44:30',NULL,NULL),(16570,'17316','S','East Berlin','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.960645,-77.023324,0,'2013-07-06 12:44:31',NULL,NULL),(18179,'18925','S','Furlong','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.280453,-75.066114,0,'2013-07-06 12:44:31',NULL,NULL),(44253,'49677','S','Reed City','D','Osceola','26133','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.899809,-85.511425,0,'2013-07-06 12:44:32',NULL,NULL),(46297,'53052','P','Menomonee Fls','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.178003,-88.119438,0,'2013-07-06 12:44:32',NULL,NULL),(54039,'62465','S','Herborn','N','Shelby','17173','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.385371,-88.644050,0,'2013-07-06 12:44:33',NULL,NULL),(56497,'65338','S','Lincoln','D','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.436452,-93.404512,0,'2013-07-06 12:44:33',NULL,NULL),(67527,'80250','P','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.679099,-104.944689,0,'2013-07-06 12:44:34',NULL,NULL),(73872,'91932','S','Imperial Beach','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.574700,-117.116328,0,'2013-07-06 12:44:34',NULL,NULL),(10246,'10469','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.868747,-73.849303,0,'2013-07-06 12:44:30',NULL,NULL),(62011,'73446','S','Madill','D','Marshall','40095','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.085514,-96.773997,0,'2013-07-06 12:44:33',NULL,NULL),(58892,'69167','S','Tryon','D','McPherson','31117','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.568840,-101.061231,0,'2013-07-06 12:44:33',NULL,NULL),(58499,'68764','S','Orchard','D','Antelope','31003','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.337337,-98.240400,0,'2013-07-06 12:44:33',NULL,NULL),(52154,'60446','S','Lockport','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.591798,-88.060557,0,'2013-07-06 12:44:33',NULL,NULL),(47688,'54965','S','Pine River','D','Waushara','55137','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.174648,-89.085052,0,'2013-07-06 12:44:33',NULL,NULL),(31605,'34679','P','Aripeka','D','Pasco','12101','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.427697,-82.663889,0,'2013-07-06 12:44:32',NULL,NULL),(13055,'13440','S','Rome','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.213860,-75.459540,0,'2013-07-06 12:44:30',NULL,NULL),(15486,'16442','S','Phillipsville','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.025336,-79.824940,0,'2013-07-06 12:44:31',NULL,NULL),(434,'00662','S','Sect San Antonio De La Tuna','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(77908,'97307','P','Keizer','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.006936,-123.019795,0,'2013-07-06 12:44:34',NULL,NULL),(74270,'92347','S','Lockhart','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.938977,-117.196307,0,'2013-07-06 12:44:34',NULL,NULL),(58039,'68017','S','Ceresco','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.061704,-96.647630,0,'2013-07-06 12:44:33',NULL,NULL),(49745,'57058','S','Center','N','McCook','46087','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.737240,-97.384440,0,'2013-07-06 12:44:33',NULL,NULL),(42287,'47586','S','Scenic Hts','N','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',37.953864,-86.762258,0,'2013-07-06 12:44:32',NULL,NULL),(35689,'39661','S','Roxie','D','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.428960,-91.116360,0,'2013-07-06 12:44:32',NULL,NULL),(29590,'32828','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.545909,-81.181177,0,'2013-07-06 12:44:32',NULL,NULL),(26538,'29203','S','Stark Terrace','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.098180,-81.036180,0,'2013-07-06 12:44:31',NULL,NULL),(8243,'08004','S','Atco','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.776340,-74.870640,0,'2013-07-06 12:44:30',NULL,NULL),(1322,'00735','S','Urb Celina','N','Ceiba','72037','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.260550,-65.640326,0,'2013-07-06 12:44:30',NULL,NULL),(13759,'14130','P','Pike','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.554652,-78.144859,0,'2013-07-06 12:44:31',NULL,NULL),(11543,'12050','P','Columbiaville','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.315037,-73.748815,0,'2013-07-06 12:44:30',NULL,NULL),(67575,'80306','P','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.040316,-105.308452,0,'2013-07-06 12:44:34',NULL,NULL),(61116,'72150','S','Center Grove','N','Grant','05053','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.305789,-92.400260,0,'2013-07-06 12:44:33',NULL,NULL),(18840,'19426','S','Rahns','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.188960,-75.426360,0,'2013-07-06 12:44:31',NULL,NULL),(2010,'00914','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.448288,-66.016711,0,'2013-07-06 12:44:30',NULL,NULL),(25036,'27897','S','Woodland','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.324900,-77.199060,0,'2013-07-06 12:44:31',NULL,NULL),(26301,'29032','S','Cassatt','D','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.337084,-80.489212,0,'2013-07-06 12:44:31',NULL,NULL),(31521,'34475','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.226341,-82.159076,0,'2013-07-06 12:44:32',NULL,NULL),(9261,'09602','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(2782,'00976','S','Parq del Monte','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(72393,'89041','P','Crystal','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',36.259020,-116.018640,0,'2013-07-06 12:44:34',NULL,NULL),(45608,'51562','S','Panama','D','Shelby','19165','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.727122,-95.474308,0,'2013-07-06 12:44:32',NULL,NULL),(43260,'48325','P','West Bloomfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595072,-83.389939,0,'2013-07-06 12:44:32',NULL,NULL),(41414,'46818','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.147538,-85.224765,0,'2013-07-06 12:44:32',NULL,NULL),(4113,'02719','S','Fairhaven','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.636765,-70.891199,0,'2013-07-06 12:44:30',NULL,NULL),(31242,'33974','S','Lehigh','N','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.554897,-81.626174,0,'2013-07-06 12:44:32',NULL,NULL),(5286,'04537','S','Boothbay','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.890375,-69.621719,0,'2013-07-06 12:44:30',NULL,NULL),(66789,'79052','S','Kress','D','Swisher','48437','Texas','TX','48','0000','806','Central',-6.0,'Y',34.364723,-101.748118,0,'2013-07-06 12:44:34',NULL,NULL),(55791,'64124','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.109884,-94.541043,0,'2013-07-06 12:44:33',NULL,NULL),(48166,'55375','S','Saint Bonifacius','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.904785,-93.749054,0,'2013-07-06 12:44:33',NULL,NULL),(44183,'49599','P','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.963384,-85.652746,0,'2013-07-06 12:44:32',NULL,NULL),(116,'00612','S','Urb Tanama','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(11890,'12325','P','Schdy','N','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.814167,-73.940000,0,'2013-07-06 12:44:30',NULL,NULL),(18022,'18642','S','Pittston','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.325833,-75.789722,0,'2013-07-06 12:44:31',NULL,NULL),(13979,'14486','S','Linwood','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.892704,-77.920284,0,'2013-07-06 12:44:31',NULL,NULL),(10888,'11422','S','Rosedale','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.663176,-73.733191,0,'2013-07-06 12:44:30',NULL,NULL),(36985,'41189','S','Poplar Flat','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.586965,-83.548106,0,'2013-07-06 12:44:32',NULL,NULL),(43315,'48356','S','Highland Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.650009,-83.582556,0,'2013-07-06 12:44:32',NULL,NULL),(75592,'94296','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.570922,-121.502908,0,'2013-07-06 12:44:34',NULL,NULL),(61139,'72160','S','Slovac','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(43009,'48162','S','Monroe','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.940000,-83.313333,0,'2013-07-06 12:44:32',NULL,NULL),(34711,'38834','S','Farmington','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.936175,-88.512642,0,'2013-07-06 12:44:32',NULL,NULL),(2498,'00957','S','Alt de Sans Souci','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(24262,'26817','S','Bloomery','D','Hampshire','54027','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.375279,-78.387899,0,'2013-07-06 12:44:31',NULL,NULL),(1643,'00771','S','Urb Oriente','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(13585,'13846','S','Treadwell','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340556,-75.165556,0,'2013-07-06 12:44:31',NULL,NULL),(40787,'46166','S','Paragon','D','Morgan','18109','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.399504,-86.586345,0,'2013-07-06 12:44:32',NULL,NULL),(41881,'47368','S','Windsor','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.192356,-85.191566,0,'2013-07-06 12:44:32',NULL,NULL),(3501,'01854','S','Lowell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.647505,-71.336201,0,'2013-07-06 12:44:30',NULL,NULL),(70959,'85644','P','Willcox','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.253921,-109.835996,0,'2013-07-06 12:44:34',NULL,NULL),(14532,'15206','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.466864,-79.915908,0,'2013-07-06 12:44:31',NULL,NULL),(38920,'44121','S','Cleveland Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.520000,-81.556389,0,'2013-07-06 12:44:32',NULL,NULL),(40162,'45360','P','Prt Jefferson','A','Shelby','39149','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.332192,-84.090568,0,'2013-07-06 12:44:32',NULL,NULL),(53282,'61727','S','Barnett Township','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.153108,-88.956925,0,'2013-07-06 12:44:33',NULL,NULL),(59209,'70392','S','Patterson','D','Saint Mary','22101','Louisiana','LA','22','0000','985','Central',-6.0,'Y',29.698890,-91.305847,0,'2013-07-06 12:44:33',NULL,NULL),(1563,'00766','S','Urb Tierra Santa','N','Villalba','72149','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.129578,-66.490474,0,'2013-07-06 12:44:30',NULL,NULL),(78919,'98366','S','Colby','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(63620,'75833','S','Davisville','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.249797,-95.973492,0,'2013-07-06 12:44:34',NULL,NULL),(61979,'73194','U','Ok Tax Comm','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.517415,-97.503803,0,'2013-07-06 12:44:33',NULL,NULL),(57012,'66205','S','Westwood','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(56104,'64788','S','Hartwell','N','Henry','29083','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.458971,-93.995235,0,'2013-07-06 12:44:33',NULL,NULL),(52624,'61039','S','German Valley','D','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.218936,-89.465538,0,'2013-07-06 12:44:33',NULL,NULL),(38785,'44056','S','Macedonia','D','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.313720,-81.496140,0,'2013-07-06 12:44:32',NULL,NULL),(21431,'22556','S','Stafford','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.461964,-77.435878,0,'2013-07-06 12:44:31',NULL,NULL),(8938,'08753','S','Toms River','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.988680,-74.179560,0,'2013-07-06 12:44:30',NULL,NULL),(3753,'02171','S','Squantum','A','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.285206,-71.025251,0,'2013-07-06 12:44:30',NULL,NULL),(60480,'71656','P','University of Arkansas','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.630719,-91.791081,0,'2013-07-06 12:44:33',NULL,NULL),(26383,'29101','S','McBee','N','Chesterfield','45025','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.489200,-80.248200,0,'2013-07-06 12:44:31',NULL,NULL),(53123,'61546','S','Spring Lake','N','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.421867,-89.779680,0,'2013-07-06 12:44:33',NULL,NULL),(73503,'91331','S','Pacoima','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.252512,-118.425349,0,'2013-07-06 12:44:34',NULL,NULL),(57186,'66413','S','Burlingame','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.752959,-95.823846,0,'2013-07-06 12:44:33',NULL,NULL),(36703,'41017','S','Ft Wright','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(22314,'23838','S','Chesterfield','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.326774,-77.607350,0,'2013-07-06 12:44:31',NULL,NULL),(35353,'39440','S','Laurel','D','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(76236,'95388','S','Winton','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.399943,-120.612748,0,'2013-07-06 12:44:34',NULL,NULL),(5624,'04942','S','Harmony','D','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.011460,-69.569760,0,'2013-07-06 12:44:30',NULL,NULL),(52634,'61048','S','Waddams Grove','N','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.383724,-89.822437,0,'2013-07-06 12:44:33',NULL,NULL),(56243,'65049','S','Vlg of 4 Ssns','A','Camden','29029','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.200554,-92.711201,0,'2013-07-06 12:44:33',NULL,NULL),(72815,'89803','P','Elko','D','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.859443,-115.715009,0,'2013-07-06 12:44:34',NULL,NULL),(24075,'26444','S','Tunnelton','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.333665,-79.761039,0,'2013-07-06 12:44:31',NULL,NULL),(40406,'45680','S','South Point','D','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.420040,-82.572900,0,'2013-07-06 12:44:32',NULL,NULL),(72932,'90033','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.049807,-118.209245,0,'2013-07-06 12:44:34',NULL,NULL),(65964,'78285','S','Firm Cases','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.422258,-98.525584,0,'2013-07-06 12:44:34',NULL,NULL),(60769,'72015','S','Benton','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.566563,-92.583045,0,'2013-07-06 12:44:33',NULL,NULL),(27929,'30518','S','Sugarhill','N','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.124264,-84.031055,0,'2013-07-06 12:44:31',NULL,NULL),(38470,'43620','S','Toledo','D','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.664084,-83.550387,0,'2013-07-06 12:44:32',NULL,NULL),(16537,'17302','S','Airville','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(15248,'16050','S','Petrolia','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.043097,-79.765048,0,'2013-07-06 12:44:31',NULL,NULL),(66731,'78956','S','Schulenburg','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.680967,-96.906472,0,'2013-07-06 12:44:34',NULL,NULL),(24729,'27519','S','Cary','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.785409,-78.779645,0,'2013-07-06 12:44:31',NULL,NULL),(46295,'53051','S','Menomonee Fls','A','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.145602,-88.115779,0,'2013-07-06 12:44:32',NULL,NULL),(27441,'30118','U','Carrollton','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.571798,-85.106910,0,'2013-07-06 12:44:31',NULL,NULL),(6179,'05474','S','No Hero','N','Grand Isle','50013','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.852461,-73.278914,0,'2013-07-06 12:44:30',NULL,NULL),(65872,'78218','S','Windcrest','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.501300,-98.397733,0,'2013-07-06 12:44:34',NULL,NULL),(33744,'37840','S','Oliver Springs','D','Roane','47145','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.032719,-84.324441,0,'2013-07-06 12:44:32',NULL,NULL),(29944,'33069','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.233635,-80.156758,0,'2013-07-06 12:44:32',NULL,NULL),(48158,'55373','S','Rockford','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.089673,-93.734933,0,'2013-07-06 12:44:33',NULL,NULL),(38745,'44030','S','Monroe Twp','N','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.931936,-80.581103,0,'2013-07-06 12:44:32',NULL,NULL),(79589,'99031','S','Spangle','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.431932,-117.370610,0,'2013-07-06 12:44:34',NULL,NULL),(33247,'37076','S','Hermitage','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.186946,-86.600463,0,'2013-07-06 12:44:32',NULL,NULL),(71543,'87174','P','Rio Rancho','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.277379,-106.652579,0,'2013-07-06 12:44:34',NULL,NULL),(29042,'32234','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.219367,-81.997401,0,'2013-07-06 12:44:32',NULL,NULL),(22435,'24015','S','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.254944,-79.980629,0,'2013-07-06 12:44:31',NULL,NULL),(2527,'00957','S','Urb Sierra Linda','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(52514,'60827','S','Calumet Park','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.647040,-87.620670,0,'2013-07-06 12:44:33',NULL,NULL),(63509,'75750','S','Arp','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.254343,-95.069941,0,'2013-07-06 12:44:33',NULL,NULL),(46142,'52654','S','Wayland','D','Henry','19087','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.145353,-91.664079,0,'2013-07-06 12:44:32',NULL,NULL),(59308,'70515','S','Basile','D','Evangeline','22039','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.486370,-92.596043,0,'2013-07-06 12:44:33',NULL,NULL),(31811,'35055','S','Cullman','D','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.174036,-86.843648,0,'2013-07-06 12:44:32',NULL,NULL),(71434,'87031','S','Los Lunas','D','Valencia','35061','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',34.784421,-106.692838,0,'2013-07-06 12:44:34',NULL,NULL),(25559,'28412','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.142287,-77.915225,0,'2013-07-06 12:44:31',NULL,NULL),(34140,'38231','S','Henry','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.206881,-88.464225,0,'2013-07-06 12:44:32',NULL,NULL),(22423,'24007','P','Roanoke','D','Roanoke City','51770','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.270595,-79.941504,0,'2013-07-06 12:44:31',NULL,NULL),(31454,'34286','S','N Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.070796,-82.145952,0,'2013-07-06 12:44:32',NULL,NULL),(64643,'76711','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.512973,-97.163580,0,'2013-07-06 12:44:34',NULL,NULL),(17599,'18040','S','Easton','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.719000,-75.220260,0,'2013-07-06 12:44:31',NULL,NULL),(62007,'73441','S','Leon','D','Love','40085','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',33.950511,-97.461153,0,'2013-07-06 12:44:33',NULL,NULL),(36676,'41015','S','Covington','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.950920,-84.484380,0,'2013-07-06 12:44:32',NULL,NULL),(54831,'63030','S','Fletcher','D','Jefferson','29099','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.143599,-90.751450,0,'2013-07-06 12:44:33',NULL,NULL),(53231,'61639','U','Komatsu Dresser','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.709663,-89.566400,0,'2013-07-06 12:44:33',NULL,NULL),(3497,'01850','S','Lowell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.654952,-71.306891,0,'2013-07-06 12:44:30',NULL,NULL),(17051,'17752','S','Brady','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.173173,-76.873541,0,'2013-07-06 12:44:31',NULL,NULL),(16289,'17105','P','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.299869,-76.799562,0,'2013-07-06 12:44:31',NULL,NULL),(1802,'00783','S','Valle de Aramana','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(4884,'04040','S','Sweden','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',44.104958,-70.668459,0,'2013-07-06 12:44:30',NULL,NULL),(26386,'29102','S','Foreston','N','Clarendon','45027','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.637920,-80.257380,0,'2013-07-06 12:44:31',NULL,NULL),(74150,'92257','S','Niland','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',33.328560,-115.594200,0,'2013-07-06 12:44:34',NULL,NULL),(71046,'85747','S','Rincon','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.043928,-110.735754,0,'2013-07-06 12:44:34',NULL,NULL),(57212,'66439','S','Horton','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.663723,-95.526639,0,'2013-07-06 12:44:33',NULL,NULL),(28057,'30669','S','Woodville','A','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.644580,-83.085879,0,'2013-07-06 12:44:31',NULL,NULL),(31465,'34289','S','N Port','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.052555,-82.197321,0,'2013-07-06 12:44:32',NULL,NULL),(54528,'62880','S','Saint Paul','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.868041,-88.865839,0,'2013-07-06 12:44:33',NULL,NULL),(93,'00612','S','Sect Muelle','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(538,'00676','S','Parc Lomas Verdes','N','Moca','72099','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.399405,-67.113279,0,'2013-07-06 12:44:30',NULL,NULL),(70102,'84171','P','Cottonwood','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.620584,-111.806052,0,'2013-07-06 12:44:34',NULL,NULL),(6023,'05401','S','Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.487240,-73.227780,0,'2013-07-06 12:44:30',NULL,NULL),(21334,'22408','S','Fredericksbur','N','Spotsylvania','51177','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.207246,-77.458369,0,'2013-07-06 12:44:31',NULL,NULL),(38385,'43515','S','Delta','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.577589,-84.007260,0,'2013-07-06 12:44:32',NULL,NULL),(34742,'38851','S','Pyland','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.897840,-88.990980,0,'2013-07-06 12:44:32',NULL,NULL),(8508,'08098','S','Woodstown','D','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.651717,-75.330001,0,'2013-07-06 12:44:30',NULL,NULL),(5888,'05153','S','South Reading','A','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.474167,-72.589722,0,'2013-07-06 12:44:30',NULL,NULL),(19467,'20135','S','Mount Weather','A','Clarke','51043','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',39.091285,-77.841619,0,'2013-07-06 12:44:31',NULL,NULL),(595,'00680','S','Urb Alemany','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(19610,'20235','U','Dept Commerce Outside Hq','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.911897,-77.045863,0,'2013-07-06 12:44:31',NULL,NULL),(33429,'37250','U','American General','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.161267,-86.783675,0,'2013-07-06 12:44:32',NULL,NULL),(56863,'66012','S','Lake of the Forest','A','Wyandotte','20209','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.073262,-94.884623,0,'2013-07-06 12:44:33',NULL,NULL),(47573,'54844','S','Herbster','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.776022,-91.228420,0,'2013-07-06 12:44:33',NULL,NULL),(39857,'45172','P','Sinking Spring','D','Highland','39071','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.055787,-83.352014,0,'2013-07-06 12:44:32',NULL,NULL),(35412,'39466','S','Cybur','N','Pearl River','28109','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.583680,-89.675940,0,'2013-07-06 12:44:32',NULL,NULL),(14071,'14606','S','Gates','A','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.167126,-77.687832,0,'2013-07-06 12:44:31',NULL,NULL),(59562,'70833','U','La Lottery','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.407464,-91.142909,0,'2013-07-06 12:44:33',NULL,NULL),(8636,'08270','S','Belleplain','N','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.255540,-74.807040,0,'2013-07-06 12:44:30',NULL,NULL),(75782,'94703','S','Berkeley','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.866890,-122.272342,0,'2013-07-06 12:44:34',NULL,NULL),(7230,'06506','P','N Haven','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.309470,-72.925324,0,'2013-07-06 12:44:30',NULL,NULL),(34174,'38310','S','Adamsville','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.231782,-88.387691,0,'2013-07-06 12:44:32',NULL,NULL),(54402,'62824','S','Clay City','D','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.688177,-88.360321,0,'2013-07-06 12:44:33',NULL,NULL),(38676,'43962','P','Summitville','D','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.677674,-80.886924,0,'2013-07-06 12:44:32',NULL,NULL),(43725,'48922','U','Lansing','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.735066,-84.558119,0,'2013-07-06 12:44:32',NULL,NULL),(42435,'47805','S','Bartley','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(43194,'48303','P','Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.582303,-83.245248,0,'2013-07-06 12:44:32',NULL,NULL),(38182,'43194','U','Lockbourne','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.808925,-82.977053,0,'2013-07-06 12:44:32',NULL,NULL),(45682,'52043','S','Mederville','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.856180,-91.404581,0,'2013-07-06 12:44:32',NULL,NULL),(49116,'56353','S','Milaca','D','Mille Lacs','27095','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.752989,-93.650614,0,'2013-07-06 12:44:33',NULL,NULL),(51184,'59019','S','Columbus','D','Stillwater','30095','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.634341,-109.255058,0,'2013-07-06 12:44:33',NULL,NULL),(31913,'35151','S','Sylacauga','D','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.176529,-86.262153,0,'2013-07-06 12:44:32',NULL,NULL),(7032,'06268','S','Mansfield','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(11923,'12421','S','Denver','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.270333,-74.531212,0,'2013-07-06 12:44:30',NULL,NULL),(44854,'50273','S','Winterset','D','Madison','19121','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.332721,-94.013335,0,'2013-07-06 12:44:32',NULL,NULL),(38677,'43963','S','Tiltonsville','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.174164,-80.697370,0,'2013-07-06 12:44:32',NULL,NULL),(2399,'00950','P','Toa Baja','D','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.448748,-66.172539,0,'2013-07-06 12:44:30',NULL,NULL),(16833,'17555','S','Churchtown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.133056,-75.965000,0,'2013-07-06 12:44:31',NULL,NULL),(48833,'56046','P','Hope','D','Steele','27147','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.979980,-93.343192,0,'2013-07-06 12:44:33',NULL,NULL),(50027,'57424','S','Ashton','D','Spink','46115','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.021900,-98.494500,0,'2013-07-06 12:44:33',NULL,NULL),(56872,'66019','P','Clearview Cty','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.945400,-95.002701,0,'2013-07-06 12:44:33',NULL,NULL),(30336,'33309','S','North Lauderdale','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.182764,-80.175692,0,'2013-07-06 12:44:32',NULL,NULL),(25002,'27870','S','Ronok Rpd Afs','A','Halifax','37083','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.451430,-77.655125,0,'2013-07-06 12:44:31',NULL,NULL),(24908,'27713','S','Durham','D','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.916567,-78.917612,0,'2013-07-06 12:44:31',NULL,NULL),(18979,'19520','S','Joanna','N','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.158113,-75.786780,0,'2013-07-06 12:44:31',NULL,NULL),(18695,'19192','U','Cigna Corporation','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.955297,-75.184537,0,'2013-07-06 12:44:31',NULL,NULL),(35588,'39573','S','Silver Run','N','Stone','28131','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.764527,-89.081583,0,'2013-07-06 12:44:32',NULL,NULL),(63906,'76033','S','Cleburne','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.345415,-97.387647,0,'2013-07-06 12:44:34',NULL,NULL),(52934,'61377','S','East Wenona','N','Marshall','17123','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.051074,-89.052018,0,'2013-07-06 12:44:33',NULL,NULL),(45208,'50630','S','Fredericksbrg','A','Chickasaw','19037','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.968397,-92.197281,0,'2013-07-06 12:44:32',NULL,NULL),(44455,'49873','S','Perronville','D','Menominee','26109','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.873016,-87.498701,0,'2013-07-06 12:44:32',NULL,NULL),(27229,'29920','S','Dataw Island','N','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.369940,-80.550300,0,'2013-07-06 12:44:31',NULL,NULL),(32249,'35612','P','Athens','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.795322,-87.008608,0,'2013-07-06 12:44:32',NULL,NULL),(25527,'28395','S','Wade','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.160288,-78.735146,0,'2013-07-06 12:44:31',NULL,NULL),(20700,'21252','U','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.394959,-76.612936,0,'2013-07-06 12:44:31',NULL,NULL),(1422,'00738','S','Vistas del Mar','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(68347,'81131','P','Crestone','D','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.992916,-105.700693,0,'2013-07-06 12:44:34',NULL,NULL),(59173,'70344','S','Cocodrie','N','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.250580,-90.662180,0,'2013-07-06 12:44:33',NULL,NULL),(57901,'67646','S','Logan','D','Phillips','20147','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.666242,-99.568823,0,'2013-07-06 12:44:33',NULL,NULL),(37775,'42348','S','Hawesville','D','Hancock','21091','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.794496,-86.850476,0,'2013-07-06 12:44:32',NULL,NULL),(31532,'34487','P','Homosassa','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.780574,-82.615556,0,'2013-07-06 12:44:32',NULL,NULL),(8524,'08107','S','Oaklyn','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.908406,-75.085817,0,'2013-07-06 12:44:30',NULL,NULL),(27825,'30412','P','Alston','D','Montgomery','13209','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.080636,-82.479694,0,'2013-07-06 12:44:31',NULL,NULL),(35881,'39867','S','Morris','D','Quitman','13239','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.818931,-85.035602,0,'2013-07-06 12:44:32',NULL,NULL),(3695,'02136','S','Hyde Park','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.252810,-71.129122,0,'2013-07-06 12:44:30',NULL,NULL),(74845,'93246','U','Lemoore','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.290241,-119.847834,0,'2013-07-06 12:44:34',NULL,NULL),(79955,'99632','P','Mountain Vlg','A','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.087996,-163.717879,0,'2013-07-06 12:44:34',NULL,NULL),(44220,'49644','S','Irons','D','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.165877,-85.958375,0,'2013-07-06 12:44:32',NULL,NULL),(37388,'41754','S','Napfor','A','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.313333,-83.312222,0,'2013-07-06 12:44:32',NULL,NULL),(15300,'16142','S','New Wilmington','D','Lawrence','42073','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.118893,-80.336897,0,'2013-07-06 12:44:31',NULL,NULL),(34765,'38863','S','Chiwapa','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.225680,-88.974540,0,'2013-07-06 12:44:32',NULL,NULL),(25644,'28468','S','Shallotte','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.884891,-78.508720,0,'2013-07-06 12:44:31',NULL,NULL),(23758,'25962','S','Bellwood','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(20936,'21757','S','Middleburg','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.601199,-77.254452,0,'2013-07-06 12:44:31',NULL,NULL),(14689,'15254','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.441088,-79.998276,0,'2013-07-06 12:44:31',NULL,NULL),(17682,'18201','S','Hazle Township','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',40.961962,-75.978971,0,'2013-07-06 12:44:31',NULL,NULL),(6617,'05875','S','W Glover','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.696433,-72.268832,0,'2013-07-06 12:44:30',NULL,NULL),(64183,'76234','S','Decatur','D','Wise','48497','Texas','TX','48','0000','940','Central',-6.0,'Y',33.231308,-97.588741,0,'2013-07-06 12:44:34',NULL,NULL),(55570,'63873','S','Hayward','N','New Madrid','29143','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.430781,-89.697849,0,'2013-07-06 12:44:33',NULL,NULL),(45397,'51036','S','Maurice','D','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.964551,-96.180988,0,'2013-07-06 12:44:32',NULL,NULL),(27346,'30048','P','Lilburn','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.900250,-84.125496,0,'2013-07-06 12:44:31',NULL,NULL),(17481,'17959','S','Kaska','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.738984,-76.109152,0,'2013-07-06 12:44:31',NULL,NULL),(4227,'02857','S','Glocester','N','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.833680,-71.641620,0,'2013-07-06 12:44:30',NULL,NULL),(9962,'10159','P','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.738556,-73.984332,0,'2013-07-06 12:44:30',NULL,NULL),(66557,'78735','S','Oak Hill','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.264300,-97.865340,0,'2013-07-06 12:44:34',NULL,NULL),(65536,'77803','S','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.681235,-96.376593,0,'2013-07-06 12:44:34',NULL,NULL),(63270,'75501','S','Wake Village','A','Bowie','48037','Texas','TX','48','8360','903/430','Central',-6.0,'Y',33.424489,-94.102297,0,'2013-07-06 12:44:33',NULL,NULL),(61193,'72217','P','Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.775922,-92.357628,0,'2013-07-06 12:44:33',NULL,NULL),(6040,'05407','P','South Burlington','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.446346,-73.175684,0,'2013-07-06 12:44:30',NULL,NULL),(31209,'33951','P','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.935314,-81.986584,0,'2013-07-06 12:44:32',NULL,NULL),(44200,'49623','S','Chase','D','Lake','26085','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.895693,-85.636290,0,'2013-07-06 12:44:32',NULL,NULL),(44520,'49948','S','Mass City','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.725602,-89.032124,0,'2013-07-06 12:44:32',NULL,NULL),(45210,'50631','P','Frederika','D','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.801815,-92.268512,0,'2013-07-06 12:44:32',NULL,NULL),(80080,'99734','P','Prudhoe Bay','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.015200,-148.884265,0,'2013-07-06 12:44:34',NULL,NULL),(53750,'62260','S','Millstadt','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.463742,-90.092279,0,'2013-07-06 12:44:33',NULL,NULL),(56799,'65764','S','Tunas','D','Dallas','29059','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.835835,-92.962045,0,'2013-07-06 12:44:33',NULL,NULL),(57040,'66209','S','Overland','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(60079,'71356','S','Morrow','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.824220,-92.041680,0,'2013-07-06 12:44:33',NULL,NULL),(6843,'06119','S','West Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760843,-72.729064,0,'2013-07-06 12:44:30',NULL,NULL),(66972,'79410','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.568027,-101.894650,0,'2013-07-06 12:44:34',NULL,NULL),(64116,'76181','P','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.813066,-97.228230,0,'2013-07-06 12:44:34',NULL,NULL),(62887,'75056','S','Lewisville','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.097680,-96.883920,0,'2013-07-06 12:44:33',NULL,NULL),(46946,'54166','S','Shawano','D','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.780208,-88.590326,0,'2013-07-06 12:44:32',NULL,NULL),(29266,'32457','P','Port Saint Joe','D','Gulf','12045','Florida','FL','12','0000','850','Central',-6.0,'Y',29.811847,-85.303541,0,'2013-07-06 12:44:32',NULL,NULL),(66076,'78387','S','Sinton','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.033412,-97.505169,0,'2013-07-06 12:44:34',NULL,NULL),(62938,'75094','S','Parker','A','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.017760,-96.624420,0,'2013-07-06 12:44:33',NULL,NULL),(57105,'66220','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.968891,-94.817860,0,'2013-07-06 12:44:33',NULL,NULL),(49473,'56655','S','Boy Lake','N','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.067212,-94.161631,0,'2013-07-06 12:44:33',NULL,NULL),(35540,'39562','S','Moss Pt','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.425733,-88.529215,0,'2013-07-06 12:44:32',NULL,NULL),(33892,'38036','P','Gallaway','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.324079,-89.619045,0,'2013-07-06 12:44:32',NULL,NULL),(28445,'31407','S','Port Wentwrth','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.166660,-81.172740,0,'2013-07-06 12:44:32',NULL,NULL),(21945,'23232','S','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.560246,-77.447422,0,'2013-07-06 12:44:31',NULL,NULL),(68426,'81212','S','Canon City','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.448695,-105.232790,0,'2013-07-06 12:44:34',NULL,NULL),(66601,'78757','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.350518,-97.732097,0,'2013-07-06 12:44:34',NULL,NULL),(59021,'70076','S','Mount Airy','D','St John the Baptist','22095','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.060295,-90.636603,0,'2013-07-06 12:44:33',NULL,NULL),(57835,'67547','S','Kinsley','D','Edwards','20047','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.925257,-99.408329,0,'2013-07-06 12:44:33',NULL,NULL),(54105,'62541','P','Lake Fork','D','Logan','17107','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.969958,-89.351644,0,'2013-07-06 12:44:33',NULL,NULL),(52209,'60480','S','Willow Springs','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.725603,-87.874259,0,'2013-07-06 12:44:33',NULL,NULL),(49385,'56601','S','Nymore','N','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.504512,-94.857600,0,'2013-07-06 12:44:33',NULL,NULL),(1009,'00717','S','Urb Santa Maria','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(4219,'02840','S','Newport','D','Newport','44005','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.475501,-71.309471,0,'2013-07-06 12:44:30',NULL,NULL),(17629,'18054','S','Green Lane','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.342495,-75.438474,0,'2013-07-06 12:44:31',NULL,NULL),(15893,'17007','S','Boiling Spgs','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.147806,-77.116428,0,'2013-07-06 12:44:31',NULL,NULL),(42924,'48112','P','Belleville','D','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.204508,-83.482683,0,'2013-07-06 12:44:32',NULL,NULL),(44692,'50129','S','Jefferson','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.012434,-94.378248,0,'2013-07-06 12:44:32',NULL,NULL),(3947,'02472','S','Watertown','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.371297,-71.180361,0,'2013-07-06 12:44:30',NULL,NULL),(66377,'78621','S','Lund','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(47579,'54848','S','Ladysmith','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.465609,-91.094582,0,'2013-07-06 12:44:33',NULL,NULL),(47269,'54532','P','Heafford Jct','A','Lincoln','55069','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.547200,-89.715180,0,'2013-07-06 12:44:32',NULL,NULL),(46054,'52572','S','Dean','N','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.689450,-92.684164,0,'2013-07-06 12:44:32',NULL,NULL),(3441,'01757','S','Milford','D','Worcester','25027','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.149786,-71.522396,0,'2013-07-06 12:44:30',NULL,NULL),(6993,'06250','S','Mansfield Ctr','A','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.780580,-72.210300,0,'2013-07-06 12:44:30',NULL,NULL),(25240,'28104','S','Stallings','A','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.116667,-80.723889,0,'2013-07-06 12:44:31',NULL,NULL),(6096,'05451','P','Essex','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.507500,-73.069481,0,'2013-07-06 12:44:30',NULL,NULL),(74921,'93390','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.356413,-119.002285,0,'2013-07-06 12:44:34',NULL,NULL),(72693,'89447','S','Mason','N','Lyon','32019','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',38.921460,-119.117640,0,'2013-07-06 12:44:34',NULL,NULL),(66177,'78523','P','Brownsville','D','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.002329,-97.572730,0,'2013-07-06 12:44:34',NULL,NULL),(58280,'68406','S','Milligan','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.501769,-97.387605,0,'2013-07-06 12:44:33',NULL,NULL),(41298,'46765','S','Leo','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.228281,-85.030944,0,'2013-07-06 12:44:32',NULL,NULL),(38675,'43961','P','Stratton','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.518617,-80.627696,0,'2013-07-06 12:44:32',NULL,NULL),(16394,'17214','S','Charmian','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.730375,-77.470658,0,'2013-07-06 12:44:31',NULL,NULL),(29608,'32839','S','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.487458,-81.403507,0,'2013-07-06 12:44:32',NULL,NULL),(28864,'32115','P','Daytona Beach','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.213213,-81.023770,0,'2013-07-06 12:44:32',NULL,NULL),(25011,'27878','P','Sharpsburg','D','Nash','37127','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.866422,-77.837357,0,'2013-07-06 12:44:31',NULL,NULL),(23582,'25670','S','Delbarton','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.726001,-82.126879,0,'2013-07-06 12:44:31',NULL,NULL),(37317,'41649','S','Martin','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.545706,-82.758667,0,'2013-07-06 12:44:32',NULL,NULL),(37483,'42002','P','Paducah','D','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.068551,-88.624938,0,'2013-07-06 12:44:32',NULL,NULL),(5487,'04747','S','Crystal','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.011654,-68.271262,0,'2013-07-06 12:44:30',NULL,NULL),(76323,'95459','S','Manchester','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',38.989307,-123.664351,0,'2013-07-06 12:44:34',NULL,NULL),(66075,'78387','S','Papalote','N','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.033412,-97.505169,0,'2013-07-06 12:44:34',NULL,NULL),(55973,'64506','S','Saint Joseph','D','Buchanan','29021','Missouri','MO','29','7000','816/975','Central',-6.0,'Y',39.788843,-94.802142,0,'2013-07-06 12:44:33',NULL,NULL),(36723,'41031','S','Cynthiana','D','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(14981,'15640','P','Hutchinson','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.227397,-79.732599,0,'2013-07-06 12:44:31',NULL,NULL),(79149,'98501','S','Union Mills','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(74370,'92427','P','Sn Bernrdno','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.199862,-117.345353,0,'2013-07-06 12:44:34',NULL,NULL),(68712,'82070','S','Jelm','N','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.297825,-105.635487,0,'2013-07-06 12:44:34',NULL,NULL),(68366,'81137','S','S Ute Indian','A','La Plata','08067','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.105788,-107.597693,0,'2013-07-06 12:44:34',NULL,NULL),(59728,'71110','S','Barksdale AFB','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.506680,-93.640260,0,'2013-07-06 12:44:33',NULL,NULL),(54787,'63011','S','Ballwin','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.598725,-90.547046,0,'2013-07-06 12:44:33',NULL,NULL),(29526,'32780','S','Titusville','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.572256,-80.820946,0,'2013-07-06 12:44:32',NULL,NULL),(10264,'10504','S','North Castle','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.139871,-73.700165,0,'2013-07-06 12:44:30',NULL,NULL),(40834,'46216','S','Ft Benjamin Harrison','N','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.861466,-86.014172,0,'2013-07-06 12:44:32',NULL,NULL),(60846,'72042','S','De Luce','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.292792,-91.337922,0,'2013-07-06 12:44:33',NULL,NULL),(45269,'50670','S','Shell Rock','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.710147,-92.581298,0,'2013-07-06 12:44:32',NULL,NULL),(15170,'15925','P','Cassandra','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.409397,-78.641724,0,'2013-07-06 12:44:31',NULL,NULL),(11648,'12128','P','Newtonville','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.724446,-73.750908,0,'2013-07-06 12:44:30',NULL,NULL),(28330,'31150','P','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.982371,-84.333684,0,'2013-07-06 12:44:32',NULL,NULL),(30496,'33394','S','Financial Plaza','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.121148,-80.139899,0,'2013-07-06 12:44:32',NULL,NULL),(29249,'32443','S','Greenwood','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.867175,-85.171707,0,'2013-07-06 12:44:32',NULL,NULL),(15116,'15783','P','West Lebanon','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.602258,-79.354004,0,'2013-07-06 12:44:31',NULL,NULL),(17856,'18431','S','Bethany','A','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.569284,-75.257159,0,'2013-07-06 12:44:31',NULL,NULL),(62183,'73759','S','Medford','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.807871,-97.741275,0,'2013-07-06 12:44:33',NULL,NULL),(60694,'71940','S','Delight','D','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(26981,'29617','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.921125,-82.476529,0,'2013-07-06 12:44:31',NULL,NULL),(76574,'95675','P','Mount Aukum','A','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.545897,-120.741250,0,'2013-07-06 12:44:34',NULL,NULL),(488,'00670','S','Urb El Bosque','N','Las Marias','72083','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.296381,-67.146608,0,'2013-07-06 12:44:30',NULL,NULL),(4445,'03246','S','Weirs Beach','N','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.551000,-71.427600,0,'2013-07-06 12:44:30',NULL,NULL),(69929,'84113','S','Fort Douglas','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.775548,-111.831028,0,'2013-07-06 12:44:34',NULL,NULL),(43161,'48266','U','Detroit','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.344450,-83.009180,0,'2013-07-06 12:44:32',NULL,NULL),(43777,'49036','S','Coldwater','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.908150,-85.014826,0,'2013-07-06 12:44:32',NULL,NULL),(72498,'89144','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.179908,-115.327153,0,'2013-07-06 12:44:34',NULL,NULL),(48972,'56212','S','Bellingham','D','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.172093,-96.326214,0,'2013-07-06 12:44:33',NULL,NULL),(72280,'88560','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.768994,-106.328556,0,'2013-07-06 12:44:34',NULL,NULL),(61379,'72528','S','Dolph','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.228212,-92.107943,0,'2013-07-06 12:44:33',NULL,NULL),(37663,'42211','S','Blue Spring','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(59618,'71031','S','Goldonna','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.990819,-92.978850,0,'2013-07-06 12:44:33',NULL,NULL),(71277,'86434','S','Peach Springs','D','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.574300,-113.492100,0,'2013-07-06 12:44:34',NULL,NULL),(29063,'32245','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.247865,-81.549311,0,'2013-07-06 12:44:32',NULL,NULL),(70552,'85036','P','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.631873,-112.152600,0,'2013-07-06 12:44:34',NULL,NULL),(24979,'27852','S','Macclesfield','D','Edgecombe','37065','North Carolina','NC','37','6895','252','Eastern',-5.0,'Y',35.778300,-77.587620,0,'2013-07-06 12:44:31',NULL,NULL),(61978,'73190','U','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.458463,-97.516594,0,'2013-07-06 12:44:33',NULL,NULL),(697,'00685','S','Urb El Guayabal','N','San Sebastian','72131','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.341548,-66.996280,0,'2013-07-06 12:44:30',NULL,NULL),(45933,'52336','S','Viola','A','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.094680,-91.462620,0,'2013-07-06 12:44:32',NULL,NULL),(23121,'24957','S','Maxwelton','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.908011,-80.425002,0,'2013-07-06 12:44:31',NULL,NULL),(33322,'37142','S','Palmyra','D','Montgomery','47125','Tennessee','TN','47','1660','931','Central',-6.0,'Y',36.408773,-87.504544,0,'2013-07-06 12:44:32',NULL,NULL),(16148,'17060','S','Mill Crk','N','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.445595,-77.904057,0,'2013-07-06 12:44:31',NULL,NULL),(64389,'76534','S','Vilas','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.877288,-97.404648,0,'2013-07-06 12:44:34',NULL,NULL),(35766,'39741','S','Cedarbluff','D','Clay','28025','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.613034,-88.845449,0,'2013-07-06 12:44:32',NULL,NULL),(49839,'57227','S','Shady Beach','N','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.362558,-96.668241,0,'2013-07-06 12:44:33',NULL,NULL),(49281,'56515','S','Amor','N','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.287269,-95.713207,0,'2013-07-06 12:44:33',NULL,NULL),(24272,'26847','S','Landes Sta','A','Grant','54023','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.996532,-79.123849,0,'2013-07-06 12:44:31',NULL,NULL),(59088,'70123','S','Elmwood','A','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.956536,-90.207527,0,'2013-07-06 12:44:33',NULL,NULL),(33484,'37341','S','Harrison','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',35.174574,-85.093484,0,'2013-07-06 12:44:32',NULL,NULL),(35340,'39437','S','Maybell','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.597860,-89.208600,0,'2013-07-06 12:44:32',NULL,NULL),(8584,'08221','S','Linwood','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.342937,-74.580402,0,'2013-07-06 12:44:30',NULL,NULL),(77378,'96755','P','Kapaau','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.167014,-155.802192,0,'2013-07-06 12:44:34',NULL,NULL),(76086,'95212','S','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',38.039880,-121.237899,0,'2013-07-06 12:44:34',NULL,NULL),(33320,'37140','S','Only','D','Hickman','47081','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.870014,-87.653403,0,'2013-07-06 12:44:32',NULL,NULL),(52388,'60630','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.971136,-87.757805,0,'2013-07-06 12:44:33',NULL,NULL),(54659,'62932','S','Hallidayboro','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.911722,-89.233161,0,'2013-07-06 12:44:33',NULL,NULL),(14478,'15129','S','Library','A','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.296259,-79.999358,0,'2013-07-06 12:44:31',NULL,NULL),(8830,'08628','S','Ewing Township','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.273620,-74.817480,0,'2013-07-06 12:44:30',NULL,NULL),(3207,'01355','S','New Salem','D','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.485715,-72.341275,0,'2013-07-06 12:44:30',NULL,NULL),(48268,'55429','S','Brooklyn Ctr','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.064504,-93.341046,0,'2013-07-06 12:44:33',NULL,NULL),(47206,'54491','S','Hollister','N','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.187800,-88.731300,0,'2013-07-06 12:44:32',NULL,NULL),(33906,'38049','S','Mason','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.394464,-89.537243,0,'2013-07-06 12:44:32',NULL,NULL),(79550,'99003','S','Milan','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.914506,-117.304131,0,'2013-07-06 12:44:34',NULL,NULL),(76506,'95640','S','Ione','D','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.329832,-120.932789,0,'2013-07-06 12:44:34',NULL,NULL),(17460,'17948','S','Bowmans','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(66370,'78620','S','Dripping Spgs','A','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250260,-98.120160,0,'2013-07-06 12:44:34',NULL,NULL),(8387,'08060','S','Eastamptn Twp','A','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.991815,-74.807251,0,'2013-07-06 12:44:30',NULL,NULL),(70293,'84533','S','Natural Bridges','N','San Juan','49037','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.668670,-110.698851,0,'2013-07-06 12:44:34',NULL,NULL),(1214,'00728','S','Urb Baramaya','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(1758,'00780','S','Brisas del Laurel','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.046755,-66.550220,0,'2013-07-06 12:44:30',NULL,NULL),(68960,'83001','S','Jackson Hole','A','Teton','56039','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.472028,-110.766160,0,'2013-07-06 12:44:34',NULL,NULL),(46541,'53404','S','Racine','D','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.740654,-87.809611,0,'2013-07-06 12:44:32',NULL,NULL),(22732,'24370','S','Saltville','D','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.876897,-81.761345,0,'2013-07-06 12:44:31',NULL,NULL),(11962,'12455','S','Margaretville','D','Delaware','36025','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.151087,-74.653789,0,'2013-07-06 12:44:30',NULL,NULL),(11987,'12474','S','Roxbury','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.287672,-74.561318,0,'2013-07-06 12:44:30',NULL,NULL),(52342,'60598','P','Aurora','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.774780,-88.250675,0,'2013-07-06 12:44:33',NULL,NULL),(35719,'39669','S','Highway Village','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(15578,'16655','S','Imler','D','Bedford','42009','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.248513,-78.539222,0,'2013-07-06 12:44:31',NULL,NULL),(975,'00716','S','Urb San Tomas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.014620,-66.614749,0,'2013-07-06 12:44:30',NULL,NULL),(59440,'70714','S','Baker','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.583252,-91.139787,0,'2013-07-06 12:44:33',NULL,NULL),(70284,'84532','S','Moab','D','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.554444,-109.524340,0,'2013-07-06 12:44:34',NULL,NULL),(9148,'09302','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(32365,'35896','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.663817,-86.751466,0,'2013-07-06 12:44:32',NULL,NULL),(17338,'17866','S','Excelsior','A','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.786065,-76.555465,0,'2013-07-06 12:44:31',NULL,NULL),(63146,'75373','U','Jp Morgan Chase','N','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.783840,-96.829120,0,'2013-07-06 12:44:33',NULL,NULL),(503,'00674','S','Jard de Monaco 1','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(53366,'61770','S','Saybrook','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.425378,-88.527308,0,'2013-07-06 12:44:33',NULL,NULL),(43931,'49276','S','Riga','D','Lenawee','26091','Michigan','MI','26','0440','517','Eastern',-5.0,'Y',41.792208,-83.808952,0,'2013-07-06 12:44:32',NULL,NULL),(38159,'43150','S','Rushville','D','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.777131,-82.425291,0,'2013-07-06 12:44:32',NULL,NULL),(34054,'38139','S','Germantown','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.089280,-89.773074,0,'2013-07-06 12:44:32',NULL,NULL),(6693,'06053','S','New Britain','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.684610,-72.790399,0,'2013-07-06 12:44:30',NULL,NULL),(54186,'62626','S','Enos','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.282298,-89.878029,0,'2013-07-06 12:44:33',NULL,NULL),(75765,'94622','U','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.749508,-122.194169,0,'2013-07-06 12:44:34',NULL,NULL),(31178,'33922','S','Bokeelia','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.659618,-82.132968,0,'2013-07-06 12:44:32',NULL,NULL),(3877,'02364','S','Kingston','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',41.979540,-70.745100,0,'2013-07-06 12:44:30',NULL,NULL),(72563,'89310','S','Reese River','N','Lander','32015','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.738476,-117.193253,0,'2013-07-06 12:44:34',NULL,NULL),(60219,'71424','S','Elmer','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.151862,-92.708766,0,'2013-07-06 12:44:33',NULL,NULL),(59984,'71326','S','Red Gum','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.746480,-91.495320,0,'2013-07-06 12:44:33',NULL,NULL),(4632,'03607','S','S Acworth','N','Sullivan','33019','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.176228,-72.332333,0,'2013-07-06 12:44:30',NULL,NULL),(30287,'33261','P','North Miami','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.891214,-80.181179,0,'2013-07-06 12:44:32',NULL,NULL),(75479,'94115','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.782569,-122.436359,0,'2013-07-06 12:44:34',NULL,NULL),(23600,'25691','P','Rawl','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.647535,-82.218312,0,'2013-07-06 12:44:31',NULL,NULL),(35863,'39829','P','Calvary','D','Grady','13131','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.749193,-84.310922,0,'2013-07-06 12:44:32',NULL,NULL),(68328,'81120','S','San Antonio','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(28462,'31415','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.075555,-81.129128,0,'2013-07-06 12:44:32',NULL,NULL),(7017,'06260','S','Putnam','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.906760,-71.866980,0,'2013-07-06 12:44:30',NULL,NULL),(7712,'07191','U','Wachovia Bank','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.702983,-74.168748,0,'2013-07-06 12:44:30',NULL,NULL),(21204,'22195','P','Woodbridge','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.658441,-77.249580,0,'2013-07-06 12:44:31',NULL,NULL),(62896,'75065','S','Lake Dallas','D','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.122050,-97.027006,0,'2013-07-06 12:44:33',NULL,NULL),(19812,'20447','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.885057,-77.027332,0,'2013-07-06 12:44:31',NULL,NULL),(14628,'15232','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.451373,-79.932761,0,'2013-07-06 12:44:31',NULL,NULL),(37154,'41465','S','Seitz','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(19600,'20228','U','Bureau Engav and Printing','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887710,-77.031420,0,'2013-07-06 12:44:31',NULL,NULL),(14035,'14549','P','Silver Lake','D','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.699111,-78.024080,0,'2013-07-06 12:44:31',NULL,NULL),(3393,'01612','S','Paxton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.301580,-71.909525,0,'2013-07-06 12:44:30',NULL,NULL),(10832,'11381','U','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.715918,-73.875773,0,'2013-07-06 12:44:30',NULL,NULL),(19867,'20525','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.900624,-77.030204,0,'2013-07-06 12:44:31',NULL,NULL),(75179,'93607','P','Burrel','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.488333,-119.984167,0,'2013-07-06 12:44:34',NULL,NULL),(73162,'90296','P','Playa del Rey','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.956096,-118.449853,0,'2013-07-06 12:44:34',NULL,NULL),(69638,'84004','S','Alpine','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.456346,-111.769730,0,'2013-07-06 12:44:34',NULL,NULL),(63921,'76051','S','Grapevine','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.933618,-97.097514,0,'2013-07-06 12:44:34',NULL,NULL),(58643,'68870','S','Riverdale','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.784307,-99.160939,0,'2013-07-06 12:44:33',NULL,NULL),(10850,'11412','S','St Albans','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.694225,-73.760504,0,'2013-07-06 12:44:30',NULL,NULL),(7080,'06349','P','Groton','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.401943,-72.089280,0,'2013-07-06 12:44:30',NULL,NULL),(1233,'00729','S','Brisas de Loiza','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(12957,'13357','S','Spinnerville','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.012843,-75.045183,0,'2013-07-06 12:44:30',NULL,NULL),(16873,'17568','P','Refton','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.944930,-76.232889,0,'2013-07-06 12:44:31',NULL,NULL),(36852,'41076','S','Ft Thomas','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(40111,'45320','S','Eaton','D','Preble','39135','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.733814,-84.671102,0,'2013-07-06 12:44:32',NULL,NULL),(51931,'60120','S','Hoffman Est','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.039135,-88.281994,0,'2013-07-06 12:44:33',NULL,NULL),(55702,'64065','U','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.949632,-94.405068,0,'2013-07-06 12:44:33',NULL,NULL),(56650,'65616','S','Bull Creek Village','N','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.643271,-93.232983,0,'2013-07-06 12:44:33',NULL,NULL),(71308,'86503','S','Smoke Signal','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(66378,'78621','S','Structure','N','Bastrop','48021','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.323520,-97.379520,0,'2013-07-06 12:44:34',NULL,NULL),(55690,'64062','S','Elmira','A','Ray','29177','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.438047,-94.203353,0,'2013-07-06 12:44:33',NULL,NULL),(47245,'54514','S','Butternut','D','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.086253,-90.251505,0,'2013-07-06 12:44:32',NULL,NULL),(43964,'49315','S','Byron Center','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.805357,-85.703821,0,'2013-07-06 12:44:32',NULL,NULL),(41396,'46806','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.046401,-85.105518,0,'2013-07-06 12:44:32',NULL,NULL),(22282,'23803','S','Matoaca','N','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.213860,-77.455680,0,'2013-07-06 12:44:31',NULL,NULL),(1259,'00729','S','Urb Town Pk','N','Canovanas','72029','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379881,-65.908969,0,'2013-07-06 12:44:30',NULL,NULL),(10410,'10703','S','Yonkers','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.953777,-73.881010,0,'2013-07-06 12:44:30',NULL,NULL),(7640,'07069','S','Watchung','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.636817,-74.452093,0,'2013-07-06 12:44:30',NULL,NULL),(79854,'99553','P','Akutan','D','Aleutians East','02013','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',54.127864,-165.916603,0,'2013-07-06 12:44:34',NULL,NULL),(74911,'93380','P','Bakersfield','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.550483,-118.921018,0,'2013-07-06 12:44:34',NULL,NULL),(59079,'70117','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.969240,-90.029607,0,'2013-07-06 12:44:33',NULL,NULL),(55863,'64184','U','Commerce Bank','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.107300,-94.592461,0,'2013-07-06 12:44:33',NULL,NULL),(37379,'41743','P','Fisty','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.354985,-83.104501,0,'2013-07-06 12:44:32',NULL,NULL),(24750,'27531','S','Sjafb','A','Wayne','37191','North Carolina','NC','37','2980','919/984','Eastern',-5.0,'Y',35.380000,-77.990000,0,'2013-07-06 12:44:31',NULL,NULL),(29308,'32524','P','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.485413,-87.190253,0,'2013-07-06 12:44:32',NULL,NULL),(19182,'19803','S','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.794276,-75.534321,0,'2013-07-06 12:44:31',NULL,NULL),(13200,'13624','S','Grenell','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.239325,-76.080450,0,'2013-07-06 12:44:30',NULL,NULL),(6802,'06109','S','Hartford','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(70063,'84145','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.754454,-111.897732,0,'2013-07-06 12:44:34',NULL,NULL),(62366,'74071','P','Slick','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.776835,-96.264564,0,'2013-07-06 12:44:33',NULL,NULL),(62222,'73932','S','Beaver','D','Beaver','40007','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.738180,-100.548300,0,'2013-07-06 12:44:33',NULL,NULL),(3013,'01082','S','Ware','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.262671,-72.265357,0,'2013-07-06 12:44:30',NULL,NULL),(8658,'08317','S','Dorothy','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.409419,-74.820629,0,'2013-07-06 12:44:30',NULL,NULL),(23998,'26346','S','Ellenboro','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.288720,-81.058680,0,'2013-07-06 12:44:31',NULL,NULL),(12192,'12777','S','Monticello','A','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.565300,-74.605980,0,'2013-07-06 12:44:30',NULL,NULL),(72928,'90031','S','Lincoln Hts','A','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.078396,-118.211918,0,'2013-07-06 12:44:34',NULL,NULL),(66894,'79248','S','Dumont','A','Cottle','48101','Texas','TX','48','0000','806','Central',-6.0,'Y',34.010623,-100.302278,0,'2013-07-06 12:44:34',NULL,NULL),(42993,'48158','S','Sharon','N','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.162540,-84.020040,0,'2013-07-06 12:44:32',NULL,NULL),(38946,'44125','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.435278,-81.657500,0,'2013-07-06 12:44:32',NULL,NULL),(37384,'41749','S','Hyden','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164468,-83.437621,0,'2013-07-06 12:44:32',NULL,NULL),(17671,'18099','U','Rodale Press Brm','N','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.533963,-75.497936,0,'2013-07-06 12:44:31',NULL,NULL),(26799,'29461','S','Moncks Corner','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.149449,-80.028022,0,'2013-07-06 12:44:31',NULL,NULL),(24702,'27495','S','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.108616,-79.737907,0,'2013-07-06 12:44:31',NULL,NULL),(63077,'75244','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.939490,-96.838730,0,'2013-07-06 12:44:33',NULL,NULL),(28645,'31764','S','Leslie','D','Sumter','13261','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.954310,-84.083715,0,'2013-07-06 12:44:32',NULL,NULL),(20384,'20889','U','Bethesda','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.009294,-77.097732,0,'2013-07-06 12:44:31',NULL,NULL),(9659,'10039','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(32277,'35650','S','Moulton','D','Lawrence','01079','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.491418,-87.290515,0,'2013-07-06 12:44:32',NULL,NULL),(11841,'12247','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.682270,-73.727879,0,'2013-07-06 12:44:30',NULL,NULL),(33108,'36856','S','Fort Mitchell','D','Russell','01113','Alabama','AL','01','1800','334','Central',-6.0,'Y',32.339501,-85.020268,0,'2013-07-06 12:44:32',NULL,NULL),(12074,'12549','S','Montgomery','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.525576,-74.236316,0,'2013-07-06 12:44:30',NULL,NULL),(79304,'98590','S','Tokeland','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.733820,-124.016700,0,'2013-07-06 12:44:34',NULL,NULL),(67115,'79734','S','Mcdonald Observatory','A','Jeff Davis','48243','Texas','TX','48','0000','432','Central',-6.0,'Y',30.709108,-103.914129,0,'2013-07-06 12:44:34',NULL,NULL),(55362,'63565','S','Graysville','N','Putnam','29171','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.497300,-93.005760,0,'2013-07-06 12:44:33',NULL,NULL),(49029,'56276','S','Odessa','D','Big Stone','27011','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.327256,-96.301095,0,'2013-07-06 12:44:33',NULL,NULL),(44993,'50438','S','Hayfield','N','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.114320,-93.553740,0,'2013-07-06 12:44:32',NULL,NULL),(13140,'13502','S','Schuyler','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.127460,-75.214260,0,'2013-07-06 12:44:30',NULL,NULL),(16223,'17074','S','Markelsville','N','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.476000,-77.155500,0,'2013-07-06 12:44:31',NULL,NULL),(33740,'37829','S','Oakdale','D','Morgan','47129','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.013101,-84.636364,0,'2013-07-06 12:44:32',NULL,NULL),(4284,'02894','S','Wood River Jt','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.450100,-71.691600,0,'2013-07-06 12:44:30',NULL,NULL),(77912,'97310','U','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.910500,-123.009129,0,'2013-07-06 12:44:34',NULL,NULL),(75569,'94269','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.555479,-121.496541,0,'2013-07-06 12:44:34',NULL,NULL),(65680,'77991','P','Vanderbilt','D','Jackson','48239','Texas','TX','48','0000','361','Central',-6.0,'Y',29.009568,-96.684356,0,'2013-07-06 12:44:34',NULL,NULL),(63022,'75181','S','Mesquite','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.722807,-96.552108,0,'2013-07-06 12:44:33',NULL,NULL),(57869,'67581','S','Sylvia','D','Reno','20155','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.960585,-98.405441,0,'2013-07-06 12:44:33',NULL,NULL),(50875,'58528','S','Cannonball','N','Sioux','38085','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.378635,-100.614493,0,'2013-07-06 12:44:33',NULL,NULL),(49787,'57105','S','Sioux Falls','D','Minnehaha','46099','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.521706,-96.730370,0,'2013-07-06 12:44:33',NULL,NULL),(3509,'01865','P','Nutting Lake','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.534713,-71.269156,0,'2013-07-06 12:44:30',NULL,NULL),(32205,'35554','S','Eldridge','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.921941,-87.622032,0,'2013-07-06 12:44:32',NULL,NULL),(32034,'35243','S','Mtn Brook','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(10237,'10466','S','Wakefield','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.889675,-73.845608,0,'2013-07-06 12:44:30',NULL,NULL),(79915,'99603','S','Nanwalek','A','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.672642,-151.481184,0,'2013-07-06 12:44:34',NULL,NULL);
INSERT INTO `ZipCodeMultiCity` VALUES (61792,'73083','P','Edmond','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.736726,-97.480951,0,'2013-07-06 12:44:33',NULL,NULL),(55828,'64152','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.218160,-94.730700,0,'2013-07-06 12:44:33',NULL,NULL),(43849,'49103','S','Berrien Springs','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',41.940154,-86.349801,0,'2013-07-06 12:44:32',NULL,NULL),(42606,'47885','S','Vermillion Acres','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.464223,-87.445806,0,'2013-07-06 12:44:32',NULL,NULL),(37365,'41729','S','Combs','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.295690,-83.200168,0,'2013-07-06 12:44:32',NULL,NULL),(33013,'36688','U','University of South Alabama','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.688966,-88.189832,0,'2013-07-06 12:44:32',NULL,NULL),(28003,'30605','S','Athens','D','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.926072,-83.340748,0,'2013-07-06 12:44:31',NULL,NULL),(27308,'30017','S','Grayson','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.891156,-83.963999,0,'2013-07-06 12:44:31',NULL,NULL),(36699,'41017','S','Edgewood','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.034253,-84.574476,0,'2013-07-06 12:44:32',NULL,NULL),(3457,'01776','S','Sudbury','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.382955,-71.427696,0,'2013-07-06 12:44:30',NULL,NULL),(73996,'92105','S','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.740294,-117.091575,0,'2013-07-06 12:44:34',NULL,NULL),(66698,'78945','S','Rabbs Prairie','N','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.913724,-96.871432,0,'2013-07-06 12:44:34',NULL,NULL),(59419,'70655','S','Oberlin','D','Allen','22003','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.620192,-92.760690,0,'2013-07-06 12:44:33',NULL,NULL),(34072,'38148','U','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.146943,-90.046493,0,'2013-07-06 12:44:32',NULL,NULL),(33622,'37663','S','Colonial Hgts','A','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.460654,-82.484579,0,'2013-07-06 12:44:32',NULL,NULL),(24102,'26508','S','Sabraton','N','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.589081,-79.896108,0,'2013-07-06 12:44:31',NULL,NULL),(37962,'42721','S','Spring Lick','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.426977,-86.486700,0,'2013-07-06 12:44:32',NULL,NULL),(45486,'51350','S','Melvin','D','Osceola','19143','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.278016,-95.565094,0,'2013-07-06 12:44:32',NULL,NULL),(54240,'62665','S','Sweetwater','N','Morgan','17137','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.829660,-90.559448,0,'2013-07-06 12:44:33',NULL,NULL),(15880,'17003','S','East Hanover','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(80130,'99772','P','Shishmaref','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.039597,-165.509025,0,'2013-07-06 12:44:34',NULL,NULL),(75777,'94662','P','Oakland','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.840484,-122.293762,0,'2013-07-06 12:44:34',NULL,NULL),(72268,'88546','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.765714,-106.327732,0,'2013-07-06 12:44:34',NULL,NULL),(64460,'76574','S','Hare','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(59582,'70898','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.418422,-91.139518,0,'2013-07-06 12:44:33',NULL,NULL),(18282,'19013','S','Parkside','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(37701,'42259','S','Mammoth Cave National Park','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.284708,-86.189466,0,'2013-07-06 12:44:32',NULL,NULL),(46300,'53058','S','Chenequa','N','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.112049,-88.405116,0,'2013-07-06 12:44:32',NULL,NULL),(58439,'68710','S','Allen','D','Dixon','31051','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.414736,-96.840752,0,'2013-07-06 12:44:33',NULL,NULL),(3595,'02032','S','East Walpole','D','Norfolk','25021','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.154795,-71.216436,0,'2013-07-06 12:44:30',NULL,NULL),(77562,'96910','S','Agana','N','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(71991,'88030','S','Denning','N','Luna','35029','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.263005,-107.754054,0,'2013-07-06 12:44:34',NULL,NULL),(31941,'35202','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.516349,-86.805810,0,'2013-07-06 12:44:32',NULL,NULL),(31052,'33834','S','Bowling Green','D','Hardee','12049','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.627339,-81.834273,0,'2013-07-06 12:44:32',NULL,NULL),(10667,'11109','S','Long Is City','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742578,-73.949048,0,'2013-07-06 12:44:30',NULL,NULL),(24632,'27361','P','Thomasville','D','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.876008,-80.099679,0,'2013-07-06 12:44:31',NULL,NULL),(10375,'10591','S','N Tarrytown','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(4139,'02748','S','South Dartmouth','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.598019,-70.954047,0,'2013-07-06 12:44:30',NULL,NULL),(45818,'52205','S','Amber','N','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.113520,-91.295220,0,'2013-07-06 12:44:32',NULL,NULL),(57387,'66754','S','Harding','N','Bourbon','20011','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.017399,-94.876798,0,'2013-07-06 12:44:33',NULL,NULL),(65878,'78223','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.321261,-98.409516,0,'2013-07-06 12:44:34',NULL,NULL),(73406,'91125','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.138929,-118.123728,0,'2013-07-06 12:44:34',NULL,NULL),(69294,'83445','S','Twin Groves','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.157240,-111.645060,0,'2013-07-06 12:44:34',NULL,NULL),(69244,'83422','S','Bates','N','Teton','16081','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.734162,-111.221574,0,'2013-07-06 12:44:34',NULL,NULL),(61522,'72661','S','Oakland','D','Marion','05089','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.449464,-92.574135,0,'2013-07-06 12:44:33',NULL,NULL),(54545,'62886','S','Arrington','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.411879,-88.528805,0,'2013-07-06 12:44:33',NULL,NULL),(52311,'60550','S','Shabbona','D','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.768314,-88.869678,0,'2013-07-06 12:44:33',NULL,NULL),(51384,'59416','S','Brady','D','Pondera','30073','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.028026,-111.657445,0,'2013-07-06 12:44:33',NULL,NULL),(42023,'47436','S','Heltonville','D','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.003996,-86.436004,0,'2013-07-06 12:44:32',NULL,NULL),(21669,'22947','S','Shadwell','A','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.995730,-78.375095,0,'2013-07-06 12:44:31',NULL,NULL),(21618,'22905','P','Charlottesvle','A','Charlottesville City','51540','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.023188,-78.489866,0,'2013-07-06 12:44:31',NULL,NULL),(10389,'10598','S','Yorktown Hgts','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.294911,-73.797703,0,'2013-07-06 12:44:30',NULL,NULL),(7146,'06412','S','Chester','D','Middlesex','09007','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.406509,-72.465351,0,'2013-07-06 12:44:30',NULL,NULL),(33579,'37501','U','Internal Revenue','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.068065,-89.957585,0,'2013-07-06 12:44:32',NULL,NULL),(13934,'14429','P','Clarendon','D','Orleans','36073','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.192479,-78.063625,0,'2013-07-06 12:44:31',NULL,NULL),(29384,'32611','U','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.643443,-82.349637,0,'2013-07-06 12:44:32',NULL,NULL),(28604,'31699','U','Moody Air Force Base','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.971019,-83.202986,0,'2013-07-06 12:44:32',NULL,NULL),(74942,'93409','U','San Luis Obispo','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.220710,-120.636882,0,'2013-07-06 12:44:34',NULL,NULL),(66718,'78952','P','Plum','D','Fayette','48149','Texas','TX','48','0000','979','Central',-6.0,'Y',29.936363,-96.968195,0,'2013-07-06 12:44:34',NULL,NULL),(63387,'75644','S','Rosewood','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(62628,'74553','S','Kiowa','D','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.724208,-95.904396,0,'2013-07-06 12:44:33',NULL,NULL),(59384,'70607','S','Drew','N','Calcasieu','22019','Louisiana','LA','22','3960','337','Central',-6.0,'Y',30.088912,-93.176486,0,'2013-07-06 12:44:33',NULL,NULL),(31706,'34952','S','Port Saint Lucie','D','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.298140,-80.296740,0,'2013-07-06 12:44:32',NULL,NULL),(5296,'04548','S','Five Islands','N','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.806783,-69.763606,0,'2013-07-06 12:44:30',NULL,NULL),(38388,'43518','S','Edon','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.573093,-84.769884,0,'2013-07-06 12:44:32',NULL,NULL),(52130,'60432','S','Downtown Joliet','N','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.535383,-88.053442,0,'2013-07-06 12:44:33',NULL,NULL),(57527,'67005','S','Silverdale','N','Cowley','20035','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.071000,-97.059720,0,'2013-07-06 12:44:33',NULL,NULL),(7187,'06471','S','N Branford','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.341138,-72.776339,0,'2013-07-06 12:44:30',NULL,NULL),(77857,'97229','S','Portland','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.540884,-122.829980,0,'2013-07-06 12:44:34',NULL,NULL),(66752,'79009','S','Bovina','D','Parmer','48369','Texas','TX','48','0000','806','Central',-6.0,'Y',34.516381,-102.885183,0,'2013-07-06 12:44:34',NULL,NULL),(49739,'57052','S','Wittenberg','N','Hutchinson','46067','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.282169,-97.732289,0,'2013-07-06 12:44:33',NULL,NULL),(38541,'43749','S','Guernsey','A','Guernsey','39059','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.181667,-81.592500,0,'2013-07-06 12:44:32',NULL,NULL),(1958,'00820','S','St Croix','A','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.745943,-64.707272,0,'2013-07-06 12:44:30',NULL,NULL),(27658,'30325','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.791989,-84.447285,0,'2013-07-06 12:44:31',NULL,NULL),(11214,'11746','S','Huntington Station','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(23594,'25678','S','Matewan','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649769,-82.126194,0,'2013-07-06 12:44:31',NULL,NULL),(15698,'16849','P','Lanse','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.972668,-78.129891,0,'2013-07-06 12:44:31',NULL,NULL),(7727,'07202','S','Bayway','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.656153,-74.218524,0,'2013-07-06 12:44:30',NULL,NULL),(78547,'98146','S','Burien','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.500943,-122.357500,0,'2013-07-06 12:44:34',NULL,NULL),(73711,'91611','U','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.186474,-118.395745,0,'2013-07-06 12:44:34',NULL,NULL),(63098,'75264','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.754729,-96.842395,0,'2013-07-06 12:44:33',NULL,NULL),(45304,'50836','S','Blockton','D','Taylor','19173','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.648229,-94.530783,0,'2013-07-06 12:44:32',NULL,NULL),(35451,'39482','S','Oloh','N','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.362960,-89.589180,0,'2013-07-06 12:44:32',NULL,NULL),(20565,'21133','S','Randallstown','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.369846,-76.802416,0,'2013-07-06 12:44:31',NULL,NULL),(19639,'20262','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918995,-76.994920,0,'2013-07-06 12:44:31',NULL,NULL),(29939,'33067','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.309681,-80.220464,0,'2013-07-06 12:44:32',NULL,NULL),(27377,'30074','P','Redan','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.744614,-84.135993,0,'2013-07-06 12:44:31',NULL,NULL),(6695,'06057','S','Nepaug','N','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844360,-73.012800,0,'2013-07-06 12:44:30',NULL,NULL),(49824,'57218','S','Brandt','D','Deuel','46039','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.672958,-96.671048,0,'2013-07-06 12:44:33',NULL,NULL),(37221,'41537','S','Dunham','N','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.176180,-82.641780,0,'2013-07-06 12:44:32',NULL,NULL),(35599,'39595','U','Navy Homeport','N','Jackson','28059','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.368782,-88.549063,0,'2013-07-06 12:44:32',NULL,NULL),(4972,'04109','S','Diamond Is','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.678510,-70.201680,0,'2013-07-06 12:44:30',NULL,NULL),(31915,'35160','S','Waldo','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.439294,-86.102326,0,'2013-07-06 12:44:32',NULL,NULL),(18226,'18966','S','Southampton','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.186800,-75.009660,0,'2013-07-06 12:44:31',NULL,NULL),(17905,'18448','U','Cinram','N','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.451993,-75.580207,0,'2013-07-06 12:44:31',NULL,NULL),(17805,'18403','S','Eynon','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.496372,-75.569205,0,'2013-07-06 12:44:31',NULL,NULL),(76169,'95322','S','Gustine','D','Merced','06047','California','CA','06','4940','209','Pacific',-8.0,'Y',37.188900,-120.986100,0,'2013-07-06 12:44:34',NULL,NULL),(76166,'95319','P','Empire','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.647502,-120.904123,0,'2013-07-06 12:44:34',NULL,NULL),(75909,'95003','S','Aptos','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.992640,-121.876740,0,'2013-07-06 12:44:34',NULL,NULL),(75661,'94537','P','Fremont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.555694,-122.017336,0,'2013-07-06 12:44:34',NULL,NULL),(22553,'24137','S','Penhook','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.033302,-79.592130,0,'2013-07-06 12:44:31',NULL,NULL),(19072,'19555','S','Shoemakersville','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.496804,-75.955057,0,'2013-07-06 12:44:31',NULL,NULL),(15406,'16345','S','Russell','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.948820,-79.104480,0,'2013-07-06 12:44:31',NULL,NULL),(39499,'44805','S','Bailey Lakes','N','Ashland','39005','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.853220,-82.315020,0,'2013-07-06 12:44:32',NULL,NULL),(41279,'46759','S','Keystone','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.610058,-85.190031,0,'2013-07-06 12:44:32',NULL,NULL),(44584,'50037','P','Boone','D','Boone','19015','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.056176,-93.880757,0,'2013-07-06 12:44:32',NULL,NULL),(58835,'69121','S','Arthur','D','Arthur','31005','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.570396,-101.694174,0,'2013-07-06 12:44:33',NULL,NULL),(62682,'74722','P','Battiest','D','McCurtain','40089','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.392641,-94.924286,0,'2013-07-06 12:44:33',NULL,NULL),(63423,'75660','P','Judson','D','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.585634,-94.756181,0,'2013-07-06 12:44:33',NULL,NULL),(13018,'13421','S','Scribner Corners','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.064220,-75.648180,0,'2013-07-06 12:44:30',NULL,NULL),(77297,'96664','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74732,'93041','S','Point Mugu NAWC','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.161105,-119.189825,0,'2013-07-06 12:44:34',NULL,NULL),(60748,'71971','S','Athens','N','Howard','05061','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.290480,-94.094820,0,'2013-07-06 12:44:33',NULL,NULL),(54708,'62955','P','Karbers Ridge','D','Hardin','17069','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.475345,-88.363192,0,'2013-07-06 12:44:33',NULL,NULL),(52465,'60682','U','Bank of America','N','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.835903,-87.686615,0,'2013-07-06 12:44:33',NULL,NULL),(27975,'30565','S','Nicholson','D','Jackson','13157','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.074688,-83.417461,0,'2013-07-06 12:44:31',NULL,NULL),(6744,'06082','S','Hazardville','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986942,-72.565275,0,'2013-07-06 12:44:30',NULL,NULL),(17971,'18612','S','Monroe Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.332973,-75.961823,0,'2013-07-06 12:44:31',NULL,NULL),(1106,'00725','S','Urb San Alfonso','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(14821,'15424','S','Listonburg','A','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',39.821640,-79.358280,0,'2013-07-06 12:44:31',NULL,NULL),(42530,'47860','P','Mecca','D','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.771195,-87.168232,0,'2013-07-06 12:44:32',NULL,NULL),(43356,'48390','S','Walled Lake','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(48635,'55810','S','Hermantown','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.764120,-92.254200,0,'2013-07-06 12:44:33',NULL,NULL),(51869,'60083','S','Old Mill Creek','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.429918,-87.932049,0,'2013-07-06 12:44:33',NULL,NULL),(6163,'05472','S','New Haven Jct','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.115215,-73.176252,0,'2013-07-06 12:44:30',NULL,NULL),(72327,'89007','P','Riverside','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.771438,-114.126860,0,'2013-07-06 12:44:34',NULL,NULL),(68784,'82331','S','Saratoga','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.321340,-106.502710,0,'2013-07-06 12:44:34',NULL,NULL),(47135,'54455','S','Moon','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(36544,'40906','S','Bailey Switch','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(16940,'17701','S','Faxon','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.267400,-77.035080,0,'2013-07-06 12:44:31',NULL,NULL),(29923,'33062','S','Lauderdale by the Sea','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.234821,-80.093841,0,'2013-07-06 12:44:32',NULL,NULL),(13324,'13678','P','Raymondville','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.842211,-74.981315,0,'2013-07-06 12:44:30',NULL,NULL),(6366,'05676','S','Waterbury','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.345220,-72.785100,0,'2013-07-06 12:44:30',NULL,NULL),(74471,'92603','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.624530,-117.793967,0,'2013-07-06 12:44:34',NULL,NULL),(73007,'90064','S','Rancho Park','A','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.035989,-118.422620,0,'2013-07-06 12:44:34',NULL,NULL),(70211,'84401','S','Roy','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.219800,-112.016418,0,'2013-07-06 12:44:34',NULL,NULL),(45131,'50571','S','Palmer','D','Pocahontas','19151','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.633721,-94.597766,0,'2013-07-06 12:44:32',NULL,NULL),(3084,'01199','U','Spfld','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.119147,-72.603412,0,'2013-07-06 12:44:30',NULL,NULL),(8992,'08837','S','Menlo Park','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.505704,-74.354187,0,'2013-07-06 12:44:30',NULL,NULL),(33096,'36849','U','Auburn University','D','Lee','01081','Alabama','AL','01','0580','334','Central',-6.0,'Y',32.602139,-85.508496,0,'2013-07-06 12:44:32',NULL,NULL),(31851,'35112','P','Margaret','D','Saint Clair','01115','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.688062,-86.475825,0,'2013-07-06 12:44:32',NULL,NULL),(659,'00683','S','Haciendas De San German','N','San German','72125','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.084045,-67.046282,0,'2013-07-06 12:44:30',NULL,NULL),(28310,'31131','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.705697,-84.547200,0,'2013-07-06 12:44:31',NULL,NULL),(28133,'30817','S','Maxim','N','Lincoln','13181','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.824462,-82.493112,0,'2013-07-06 12:44:31',NULL,NULL),(70442,'84741','S','Kanab','D','Kane','49025','Utah','UT','49','2620','435','Mountain',-7.0,'Y',37.051804,-112.533746,0,'2013-07-06 12:44:34',NULL,NULL),(38143,'43138','S','Logan','D','Hocking','39073','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.523862,-82.415172,0,'2013-07-06 12:44:32',NULL,NULL),(26005,'28675','S','Sparta','D','Alleghany','37005','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.506191,-81.117283,0,'2013-07-06 12:44:31',NULL,NULL),(33250,'37078','S','Hurricane Mills','D','Humphreys','47085','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.949864,-87.761509,0,'2013-07-06 12:44:32',NULL,NULL),(9225,'09524','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(33773,'37868','P','Sevierville','A','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.775608,-83.537836,0,'2013-07-06 12:44:32',NULL,NULL),(30927,'33709','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.817643,-82.732339,0,'2013-07-06 12:44:32',NULL,NULL),(15221,'16021','S','Branchton','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.070185,-79.986051,0,'2013-07-06 12:44:31',NULL,NULL),(39862,'45176','S','Williamsburg','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.072060,-84.043331,0,'2013-07-06 12:44:32',NULL,NULL),(23087,'24915','S','Arbovale','D','Pocahontas','54075','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.456002,-79.753687,0,'2013-07-06 12:44:31',NULL,NULL),(31735,'34984','S','Port St Lucie','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.275367,-80.347242,0,'2013-07-06 12:44:32',NULL,NULL),(55432,'63670','S','Clearwater','N','Sainte Genevieve','29186','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.977891,-90.049578,0,'2013-07-06 12:44:33',NULL,NULL),(56825,'65788','S','Peace Valley','D','Howell','29091','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.838442,-91.760467,0,'2013-07-06 12:44:33',NULL,NULL),(64120,'76182','S','N Richlnd Hls','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.798211,-97.191792,0,'2013-07-06 12:44:34',NULL,NULL),(63551,'75765','S','Jarvis College','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.655720,-95.197003,0,'2013-07-06 12:44:33',NULL,NULL),(13673,'14035','P','Collins Ctr','A','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.493611,-78.851667,0,'2013-07-06 12:44:31',NULL,NULL),(27849,'30434','S','Louisville','D','Jefferson','13163','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',33.000236,-82.407759,0,'2013-07-06 12:44:31',NULL,NULL),(17624,'18050','P','Flicksville','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.864578,-75.207134,0,'2013-07-06 12:44:31',NULL,NULL),(45281,'50677','S','Murphy','N','Bremer','19017','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.716220,-92.425620,0,'2013-07-06 12:44:32',NULL,NULL),(43920,'49264','S','Onondaga','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.453693,-84.553294,0,'2013-07-06 12:44:32',NULL,NULL),(8405,'08066','S','Paulsboro','D','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.825920,-75.212157,0,'2013-07-06 12:44:30',NULL,NULL),(71371,'87001','S','San Felipe Pb','A','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.382532,-106.479515,0,'2013-07-06 12:44:34',NULL,NULL),(78109,'97496','S','Winston','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',43.100381,-123.454748,0,'2013-07-06 12:44:34',NULL,NULL),(53467,'61929','S','Pierson Sta','A','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.801837,-88.565868,0,'2013-07-06 12:44:33',NULL,NULL),(32366,'35896','U','Oakwood College','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.663817,-86.751466,0,'2013-07-06 12:44:32',NULL,NULL),(23480,'25506','S','Palermo','A','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.232678,-82.211046,0,'2013-07-06 12:44:31',NULL,NULL),(34620,'38753','S','Waco','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.352720,-90.592066,0,'2013-07-06 12:44:32',NULL,NULL),(47400,'54644','S','Mindoro','D','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',44.027989,-91.050927,0,'2013-07-06 12:44:32',NULL,NULL),(51588,'59806','P','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.916293,-114.152007,0,'2013-07-06 12:44:33',NULL,NULL),(54227,'62655','S','Kilbourne','D','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.151058,-90.009308,0,'2013-07-06 12:44:33',NULL,NULL),(56408,'65250','S','Boonesboro','N','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.062310,-92.839917,0,'2013-07-06 12:44:33',NULL,NULL),(59759,'71156','U','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.511335,-93.748082,0,'2013-07-06 12:44:33',NULL,NULL),(65779,'78113','S','McCoy','A','Karnes','48255','Texas','TX','48','0000','830','Central',-6.0,'Y',28.931521,-98.063035,0,'2013-07-06 12:44:34',NULL,NULL),(36285,'40351','S','Lakeview Hgts','A','Rowan','21205','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.194098,-83.439956,0,'2013-07-06 12:44:32',NULL,NULL),(1800,'00783','S','Urb Sobrino','N','Corozal','72047','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.342583,-66.311101,0,'2013-07-06 12:44:30',NULL,NULL),(76203,'95358','S','Modesto','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.627387,-121.051694,0,'2013-07-06 12:44:34',NULL,NULL),(61552,'72711','P','Avoca','D','Benton','05007','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.355400,-94.044946,0,'2013-07-06 12:44:33',NULL,NULL),(50383,'57761','S','Viewfield','N','Pennington','46103','South Dakota','SD','46','6660','605','Mountain',-7.0,'Y',44.095452,-102.832789,0,'2013-07-06 12:44:33',NULL,NULL),(50229,'57620','S','Ada','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.522518,-102.472513,0,'2013-07-06 12:44:33',NULL,NULL),(5392,'04650','S','Ltl Deer Is','A','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.290418,-68.711631,0,'2013-07-06 12:44:30',NULL,NULL),(62540,'74432','S','Lake Eufaula','N','McIntosh','40091','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.288414,-95.585124,0,'2013-07-06 12:44:33',NULL,NULL),(65004,'77299','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.770633,-95.414819,0,'2013-07-06 12:44:34',NULL,NULL),(66555,'78734','S','Lakeway','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.371100,-97.869900,0,'2013-07-06 12:44:34',NULL,NULL),(69839,'84081','S','WJRD','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.618845,-111.967345,0,'2013-07-06 12:44:34',NULL,NULL),(22613,'24217','S','Bee','D','Dickenson','51051','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.083006,-82.193556,0,'2013-07-06 12:44:31',NULL,NULL),(78041,'97439','S','Dunes City','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.008860,-124.036260,0,'2013-07-06 12:44:34',NULL,NULL),(75157,'93563','S','Valyermo','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.429622,-117.797685,0,'2013-07-06 12:44:34',NULL,NULL),(8765,'08541','U','Educational Testing Service','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.348381,-74.659016,0,'2013-07-06 12:44:30',NULL,NULL),(15329,'16214','S','Clarion','D','Clarion','42031','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.211652,-79.382697,0,'2013-07-06 12:44:31',NULL,NULL),(2653,'00966','S','Repto Santana','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.388179,-66.114391,0,'2013-07-06 12:44:30',NULL,NULL),(50975,'58636','S','Werner','A','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.342310,-102.334132,0,'2013-07-06 12:44:33',NULL,NULL),(9162,'09330','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(54282,'62693','S','Williamsville','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.953762,-89.544240,0,'2013-07-06 12:44:33',NULL,NULL),(44023,'49409','P','Ferrysburg','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',43.082979,-86.213705,0,'2013-07-06 12:44:32',NULL,NULL),(43144,'48239','S','Detroit','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.376745,-83.285091,0,'2013-07-06 12:44:32',NULL,NULL),(74727,'93034','P','Oxnard','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.172552,-119.177361,0,'2013-07-06 12:44:34',NULL,NULL),(18023,'18643','S','Exeter','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.328885,-75.815364,0,'2013-07-06 12:44:31',NULL,NULL),(47265,'54529','S','Harshaw','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.673020,-89.671560,0,'2013-07-06 12:44:32',NULL,NULL),(68377,'81143','S','Moffat','D','Saguache','08109','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.079015,-105.894520,0,'2013-07-06 12:44:34',NULL,NULL),(3894,'02445','S','Brookline','D','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.332533,-71.129865,0,'2013-07-06 12:44:30',NULL,NULL),(77174,'96276','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(69413,'83629','S','Horseshoe Bnd','A','Boise','16015','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.928831,-116.292814,0,'2013-07-06 12:44:34',NULL,NULL),(62663,'74640','S','Hunter','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.569161,-97.599711,0,'2013-07-06 12:44:33',NULL,NULL),(62120,'73654','S','Leedey','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.869321,-99.343665,0,'2013-07-06 12:44:33',NULL,NULL),(54895,'63072','S','Robertsville','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.397409,-90.828096,0,'2013-07-06 12:44:33',NULL,NULL),(45773,'52155','S','Saratoga','A','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.453080,-92.282246,0,'2013-07-06 12:44:32',NULL,NULL),(45318,'50848','S','Gravity','D','Taylor','19173','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.754997,-94.742542,0,'2013-07-06 12:44:32',NULL,NULL),(42673,'47966','P','Newport','D','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.881774,-87.405059,0,'2013-07-06 12:44:32',NULL,NULL),(18517,'19104','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.963766,-75.198203,0,'2013-07-06 12:44:31',NULL,NULL),(35453,'39483','S','Cheraw','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.254960,-89.933820,0,'2013-07-06 12:44:32',NULL,NULL),(42136,'47513','S','Mentor','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.283320,-86.714517,0,'2013-07-06 12:44:32',NULL,NULL),(80101,'99752','P','Kotzebue','D','Northwest Arctic','02188','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.923181,-162.036011,0,'2013-07-06 12:44:34',NULL,NULL),(78980,'98375','S','Puyallup','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118810,-122.306430,0,'2013-07-06 12:44:34',NULL,NULL),(59673,'71060','S','Mooringsport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.658065,-93.977436,0,'2013-07-06 12:44:33',NULL,NULL),(41226,'46733','S','Yost Woods','N','Adams','18001','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.829878,-84.928591,0,'2013-07-06 12:44:32',NULL,NULL),(36013,'40159','P','Radcliff','D','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.825258,-85.941249,0,'2013-07-06 12:44:32',NULL,NULL),(20394,'20896','P','Garrett Park','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.033201,-77.092769,0,'2013-07-06 12:44:31',NULL,NULL),(71315,'86505','S','Greasewood','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.606072,-109.455542,0,'2013-07-06 12:44:34',NULL,NULL),(68489,'81253','S','Wetmore','D','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.178706,-105.106327,0,'2013-07-06 12:44:34',NULL,NULL),(67212,'79918','S','Biggs Field','A','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.847479,-106.378199,0,'2013-07-06 12:44:34',NULL,NULL),(51410,'59436','S','Fairfield','D','Teton','30099','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.614592,-112.099185,0,'2013-07-06 12:44:33',NULL,NULL),(47687,'54964','S','Pickett','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',43.929257,-88.713331,0,'2013-07-06 12:44:33',NULL,NULL),(43773,'49032','S','Centreville','D','Saint Joseph','26149','Michigan','MI','26','0000','269','Eastern',-5.0,'Y',41.919412,-85.500581,0,'2013-07-06 12:44:32',NULL,NULL),(11352,'11798','S','Wheatley Hts','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.756804,-73.364139,0,'2013-07-06 12:44:30',NULL,NULL),(30182,'33176','S','Snapper Creek','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.656256,-80.360854,0,'2013-07-06 12:44:32',NULL,NULL),(15505,'16509','S','Belle Valley','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.072512,-80.063237,0,'2013-07-06 12:44:31',NULL,NULL),(22388,'23942','S','Greenbay','N','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.132330,-78.307103,0,'2013-07-06 12:44:31',NULL,NULL),(15764,'16915','S','Odin','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(77416,'96795','S','Waimanalo','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.342885,-157.716302,0,'2013-07-06 12:44:34',NULL,NULL),(75011,'93457','P','Orcutt','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.865278,-120.435000,0,'2013-07-06 12:44:34',NULL,NULL),(62197,'73802','P','Woodward','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.422068,-99.388358,0,'2013-07-06 12:44:33',NULL,NULL),(53983,'62439','S','Westport','N','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.720880,-87.707940,0,'2013-07-06 12:44:33',NULL,NULL),(44761,'50206','S','New Providence','D','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.198187,-93.188548,0,'2013-07-06 12:44:32',NULL,NULL),(4156,'02768','P','Raynham Ctr','A','Bristol','25005','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.929116,-71.041703,0,'2013-07-06 12:44:30',NULL,NULL),(4479,'03268','S','Salisbury','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.335317,-71.459130,0,'2013-07-06 12:44:30',NULL,NULL),(16371,'17201','S','Nyesville','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(24518,'27284','S','Kernersville','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.116290,-80.092145,0,'2013-07-06 12:44:31',NULL,NULL),(26650,'29356','S','Landrum','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',35.173475,-82.182252,0,'2013-07-06 12:44:31',NULL,NULL),(5933,'05254','P','Manchester Village','N','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.162851,-73.070330,0,'2013-07-06 12:44:30',NULL,NULL),(6159,'05471','S','Montgomry Ctr','A','Franklin','50011','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.860467,-72.593608,0,'2013-07-06 12:44:30',NULL,NULL),(79074,'98433','S','Fort Lewis','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(20213,'20765','P','Galesville','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.844354,-76.554174,0,'2013-07-06 12:44:31',NULL,NULL),(17678,'18106','S','Wescosville','A','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.581600,-75.527580,0,'2013-07-06 12:44:31',NULL,NULL),(17663,'18087','S','Trexlertown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.550503,-75.597132,0,'2013-07-06 12:44:31',NULL,NULL),(15431,'16370','P','West Hickory','D','Forest','42053','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.559158,-79.529382,0,'2013-07-06 12:44:31',NULL,NULL),(7382,'06777','S','Washington Depot','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.686902,-73.346373,0,'2013-07-06 12:44:30',NULL,NULL),(40750,'46140','S','Greenfield','D','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.794852,-85.791522,0,'2013-07-06 12:44:32',NULL,NULL),(49373,'56587','S','Vergas','D','Otter Tail','27111','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.671193,-95.793552,0,'2013-07-06 12:44:33',NULL,NULL),(51717,'60010','S','Kildeer','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(53378,'61790','U','Normal','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.517290,-88.999162,0,'2013-07-06 12:44:33',NULL,NULL),(58540,'68813','S','Victoria','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.641920,-99.771120,0,'2013-07-06 12:44:33',NULL,NULL),(69336,'83533','S','Cottonwood','A','Idaho','16049','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.048611,-116.348611,0,'2013-07-06 12:44:34',NULL,NULL),(72715,'89451','S','Incline Village','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.252736,-119.954554,0,'2013-07-06 12:44:34',NULL,NULL),(70418,'84725','P','Enterprise','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.573577,-113.716080,0,'2013-07-06 12:44:34',NULL,NULL),(68987,'83122','S','Grover','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.800116,-110.939832,0,'2013-07-06 12:44:34',NULL,NULL),(61706,'73004','S','Amber','D','Grady','40051','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.130401,-97.790120,0,'2013-07-06 12:44:33',NULL,NULL),(13443,'13775','S','Bartlett Hollow','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340614,-75.160930,0,'2013-07-06 12:44:31',NULL,NULL),(24425,'27157','U','Bowman Gray School of Med','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.059402,-80.321981,0,'2013-07-06 12:44:31',NULL,NULL),(20793,'21550','S','Crellin','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(53775,'62274','S','Conant','N','Perry','17145','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.078533,-89.388584,0,'2013-07-06 12:44:33',NULL,NULL),(76939,'96024','S','Douglas City','D','Trinity','06105','California','CA','06','0000','530','Pacific',-8.0,'Y',40.671801,-122.900308,0,'2013-07-06 12:44:34',NULL,NULL),(75828,'94904','S','Kentfield','A','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.951140,-122.539560,0,'2013-07-06 12:44:34',NULL,NULL),(70856,'85552','S','Thatcher','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.830751,-109.760629,0,'2013-07-06 12:44:34',NULL,NULL),(70735,'85306','S','Glendale','D','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.620994,-112.181517,0,'2013-07-06 12:44:34',NULL,NULL),(70641,'85143','S','San Tan Vly','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.161780,-111.550939,0,'2013-07-06 12:44:34',NULL,NULL),(68236,'81054','S','Fort Lyon','A','Bent','08011','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.047431,-103.208858,0,'2013-07-06 12:44:34',NULL,NULL),(30482,'33351','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.177671,-80.275118,0,'2013-07-06 12:44:32',NULL,NULL),(25272,'28127','S','New London','D','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.400410,-80.204216,0,'2013-07-06 12:44:31',NULL,NULL),(13105,'13480','S','Daytonville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',42.930337,-75.378181,0,'2013-07-06 12:44:30',NULL,NULL),(18593,'19137','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.997468,-75.099036,0,'2013-07-06 12:44:31',NULL,NULL),(45600,'51555','S','Mo Valley','A','Harrison','19085','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.562303,-95.890364,0,'2013-07-06 12:44:32',NULL,NULL),(58349,'68504','S','University Place','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.837188,-96.659433,0,'2013-07-06 12:44:33',NULL,NULL),(65725,'78029','P','Kerrville','D','Kerr','48265','Texas','TX','48','0000','830','Central',-6.0,'Y',30.061153,-99.156092,0,'2013-07-06 12:44:34',NULL,NULL),(66371,'78620','S','Dripping Springs','D','Hays','48209','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.250260,-98.120160,0,'2013-07-06 12:44:34',NULL,NULL),(49934,'57328','S','Corsica','D','Douglas','46043','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.426269,-98.407020,0,'2013-07-06 12:44:33',NULL,NULL),(48805,'56017','S','Cleveland','D','Le Sueur','27079','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.324172,-93.834005,0,'2013-07-06 12:44:33',NULL,NULL),(48562,'55766','P','Ellsburg','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.236200,-92.412180,0,'2013-07-06 12:44:33',NULL,NULL),(4459,'03255','S','Newbury','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.320148,-72.027840,0,'2013-07-06 12:44:30',NULL,NULL),(70613,'85121','S','Bapchule','D','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.135274,-111.872419,0,'2013-07-06 12:44:34',NULL,NULL),(69784,'84061','S','Rockport','N','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.714412,-111.334069,0,'2013-07-06 12:44:34',NULL,NULL),(69233,'83406','S','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.451050,-111.965181,0,'2013-07-06 12:44:34',NULL,NULL),(68806,'82433','S','Meeteetse','D','Park','56029','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.214800,-108.828859,0,'2013-07-06 12:44:34',NULL,NULL),(67264,'79968','U','Univ Of TX El Paso','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.773335,-106.504435,0,'2013-07-06 12:44:34',NULL,NULL),(50632,'58275','S','Reynolds','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.671123,-97.104503,0,'2013-07-06 12:44:33',NULL,NULL),(29030,'32229','P','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.408371,-81.579521,0,'2013-07-06 12:44:32',NULL,NULL),(26414,'29116','P','Orangeburg','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.481450,-80.810907,0,'2013-07-06 12:44:31',NULL,NULL),(46334,'53085','S','Sheboygan Fls','A','Sheboygan','55117','Wisconsin','WI','55','7620','920','Central',-6.0,'Y',43.731424,-87.816063,0,'2013-07-06 12:44:32',NULL,NULL),(7320,'06701','U','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.558763,-73.052179,0,'2013-07-06 12:44:30',NULL,NULL),(55725,'64081','S','Lees Summit','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.912082,-94.406100,0,'2013-07-06 12:44:33',NULL,NULL),(48168,'55376','S','Saint Michael','D','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.201094,-93.672766,0,'2013-07-06 12:44:33',NULL,NULL),(46192,'52748','S','Eldridge','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.663915,-90.556726,0,'2013-07-06 12:44:32',NULL,NULL),(33620,'37662','P','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.546449,-82.563833,0,'2013-07-06 12:44:32',NULL,NULL),(35068,'39192','S','Possumneck','N','Holmes','28051','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.204672,-89.782274,0,'2013-07-06 12:44:32',NULL,NULL),(31291,'34044','M','APO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(11470,'12017','S','Austerlitz','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.316394,-73.458542,0,'2013-07-06 12:44:30',NULL,NULL),(15032,'15690','S','Vandergrift','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.598718,-79.570417,0,'2013-07-06 12:44:31',NULL,NULL),(17801,'18372','S','Tannersville','D','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.042009,-75.319259,0,'2013-07-06 12:44:31',NULL,NULL),(18944,'19508','S','Gibraltar','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(38975,'44130','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.380101,-81.785719,0,'2013-07-06 12:44:32',NULL,NULL),(46027,'52551','S','Leando','N','Van Buren','19177','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.803340,-92.046595,0,'2013-07-06 12:44:32',NULL,NULL),(4401,'03220','S','Belmont','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.472125,-71.474141,0,'2013-07-06 12:44:30',NULL,NULL),(78023,'97424','S','Cottage Grove','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.784169,-123.057967,0,'2013-07-06 12:44:34',NULL,NULL),(76925,'96013','S','Burney','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.934280,-121.667100,0,'2013-07-06 12:44:34',NULL,NULL),(70178,'84328','S','Paradise','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.556660,-111.818340,0,'2013-07-06 12:44:34',NULL,NULL),(61595,'72762','S','Springdale','D','Washington','05143','Arkansas','AR','05','2580','479','Central',-6.0,'Y',36.180785,-94.167717,0,'2013-07-06 12:44:33',NULL,NULL),(57929,'67675','S','Woodston','D','Rooks','20163','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.437794,-99.100339,0,'2013-07-06 12:44:33',NULL,NULL),(34359,'38603','S','Ashland','D','Benton','28009','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.831184,-89.170922,0,'2013-07-06 12:44:32',NULL,NULL),(32308,'35754','S','Laceys Spring','D','Morgan','01103','Alabama','AL','01','2030','256','Central',-6.0,'Y',34.523132,-86.599091,0,'2013-07-06 12:44:32',NULL,NULL),(30911,'33707','S','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.758748,-82.721353,0,'2013-07-06 12:44:32',NULL,NULL),(10511,'10975','S','Southfields','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.259946,-74.175595,0,'2013-07-06 12:44:30',NULL,NULL),(25469,'28340','S','Raynham','N','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.484940,-79.085880,0,'2013-07-06 12:44:31',NULL,NULL),(1840,'00784','S','Valles De Guayama','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(16704,'17402','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.976830,-76.685313,0,'2013-07-06 12:44:31',NULL,NULL),(79338,'98620','S','Goldendale','D','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.836346,-120.823149,0,'2013-07-06 12:44:34',NULL,NULL),(60031,'71343','S','Jonesville','D','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(58525,'68787','S','Wayne','D','Wayne','31179','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.238544,-97.015602,0,'2013-07-06 12:44:33',NULL,NULL),(56407,'65248','S','Fayette','D','Howard','29089','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.146465,-92.685942,0,'2013-07-06 12:44:33',NULL,NULL),(44055,'49437','S','Montague','D','Muskegon','26121','Michigan','MI','26','3000','231','Eastern',-5.0,'Y',43.421496,-86.360385,0,'2013-07-06 12:44:32',NULL,NULL),(17681,'18195','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.582121,-75.471549,0,'2013-07-06 12:44:31',NULL,NULL),(29086,'32259','S','Julington Creek','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.091233,-81.625682,0,'2013-07-06 12:44:32',NULL,NULL),(28867,'32116','P','Daytona Beach Shores','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.212508,-81.008741,0,'2013-07-06 12:44:32',NULL,NULL),(2154,'00925','S','Bda Blondet','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(47555,'54832','S','Drummond','D','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.334190,-91.335820,0,'2013-07-06 12:44:32',NULL,NULL),(41481,'46935','P','Grass Creek','D','Fulton','18049','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.018611,-86.413333,0,'2013-07-06 12:44:32',NULL,NULL),(40153,'45351','P','Osgood','D','Darke','39037','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.340439,-84.495845,0,'2013-07-06 12:44:32',NULL,NULL),(29417,'32656','S','Keystone Heights','D','Clay','12019','Florida','FL','12','3600','352','Eastern',-5.0,'Y',29.798149,-81.989223,0,'2013-07-06 12:44:32',NULL,NULL),(32344,'35805','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.712977,-86.612847,0,'2013-07-06 12:44:32',NULL,NULL),(33241,'37072','S','Goodlettsvlle','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.325144,-86.737474,0,'2013-07-06 12:44:32',NULL,NULL),(13302,'13668','S','Yaleville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.762820,-74.991240,0,'2013-07-06 12:44:30',NULL,NULL),(78241,'97823','S','Lonerock','A','Gilliam','41021','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.234719,-120.192094,0,'2013-07-06 12:44:34',NULL,NULL),(34050,'38138','S','Germantown','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.072700,-89.902500,0,'2013-07-06 12:44:32',NULL,NULL),(30266,'33239','P','Carl Fisher','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.790887,-80.141386,0,'2013-07-06 12:44:32',NULL,NULL),(11574,'12067','S','Feura Bush','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.565899,-73.913257,0,'2013-07-06 12:44:30',NULL,NULL),(29550,'32807','S','Azalea Park','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.559275,-81.302867,0,'2013-07-06 12:44:32',NULL,NULL),(23829,'26104','S','North Hills','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.286068,-81.526137,0,'2013-07-06 12:44:31',NULL,NULL),(23212,'25075','S','Eskdale','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.128378,-81.458564,0,'2013-07-06 12:44:31',NULL,NULL),(18896,'19473','S','Collegeville','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.237680,-75.481440,0,'2013-07-06 12:44:31',NULL,NULL),(48855,'56073','S','Essig','A','Brown','27015','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.312771,-94.465735,0,'2013-07-06 12:44:33',NULL,NULL),(56144,'64847','S','Lanagan','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.598418,-94.457108,0,'2013-07-06 12:44:33',NULL,NULL),(60200,'71418','S','Longlake','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(71513,'87114','S','Village Of Los Ranchos','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.189199,-106.784765,0,'2013-07-06 12:44:34',NULL,NULL),(74491,'92619','P','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.669900,-117.764580,0,'2013-07-06 12:44:34',NULL,NULL),(10539,'10993','S','W Haverstraw','A','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.205428,-73.983291,0,'2013-07-06 12:44:30',NULL,NULL),(51896,'60098','S','Woodstock','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.320586,-88.447623,0,'2013-07-06 12:44:33',NULL,NULL),(45642,'51651','P','Shambaugh','D','Page','19145','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.680842,-95.063935,0,'2013-07-06 12:44:32',NULL,NULL),(43637,'48831','S','Carland','A','Clinton','26037','Michigan','MI','26','4040','989','Eastern',-5.0,'Y',43.089874,-84.427686,0,'2013-07-06 12:44:32',NULL,NULL),(42829,'48065','S','Bruce','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.840846,-83.032465,0,'2013-07-06 12:44:32',NULL,NULL),(20122,'20717','P','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.008960,-76.781954,0,'2013-07-06 12:44:31',NULL,NULL),(25618,'28461','S','Bald Head Isl','A','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',33.983280,-78.048480,0,'2013-07-06 12:44:31',NULL,NULL),(31337,'34139','P','Everglades','A','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.860870,-81.381711,0,'2013-07-06 12:44:32',NULL,NULL),(2679,'00968','S','Alt de San Patricio','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386834,-66.115793,0,'2013-07-06 12:44:30',NULL,NULL),(27606,'30302','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.755454,-84.387605,0,'2013-07-06 12:44:31',NULL,NULL),(8980,'08829','S','High Bridge','D','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.670912,-74.893718,0,'2013-07-06 12:44:30',NULL,NULL),(73152,'90291','S','Venice','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.993348,-118.465075,0,'2013-07-06 12:44:34',NULL,NULL),(71084,'85929','S','Lakeside','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.122542,-109.947213,0,'2013-07-06 12:44:34',NULL,NULL),(69624,'83872','S','Viola','D','Latah','16057','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.861727,-116.975585,0,'2013-07-06 12:44:34',NULL,NULL),(65174,'77414','S','Clemville','A','Matagorda','48321','Texas','TX','48','0000','979','Central',-6.0,'Y',28.963849,-95.948080,0,'2013-07-06 12:44:34',NULL,NULL),(49152,'56381','S','Starbuck','D','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.613548,-95.530926,0,'2013-07-06 12:44:33',NULL,NULL),(8325,'08036','S','Hainesport','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.984745,-74.830958,0,'2013-07-06 12:44:30',NULL,NULL),(8250,'08006','P','Barnegat Light','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.757500,-74.106667,0,'2013-07-06 12:44:30',NULL,NULL),(26918,'29582','S','Ocean Dr Beach','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.827420,-78.682495,0,'2013-07-06 12:44:31',NULL,NULL),(23773,'25976','S','Elton','A','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.866798,-80.852381,0,'2013-07-06 12:44:31',NULL,NULL),(7208,'06489','S','Southington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.607535,-72.870394,0,'2013-07-06 12:44:30',NULL,NULL),(16071,'17049','S','McAlistervle','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(38430,'43554','S','Pioneer','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.667305,-84.552070,0,'2013-07-06 12:44:32',NULL,NULL),(29585,'32825','S','Alafaya','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.522353,-81.227289,0,'2013-07-06 12:44:32',NULL,NULL),(46413,'53179','S','Trevor','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.517117,-88.134016,0,'2013-07-06 12:44:32',NULL,NULL),(37149,'41465','S','Logville','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(11853,'12256','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.651907,-73.758318,0,'2013-07-06 12:44:30',NULL,NULL),(8982,'08831','S','Jamesburg','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.350085,-74.441445,0,'2013-07-06 12:44:30',NULL,NULL),(79979,'99653','P','Port Alsworth','D','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.362061,-154.540609,0,'2013-07-06 12:44:34',NULL,NULL),(18650,'19172','U','Penn Mutual Ins Co','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.945336,-75.151079,0,'2013-07-06 12:44:31',NULL,NULL),(70515,'84791','P','Saint George','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.087282,-113.556082,0,'2013-07-06 12:44:34',NULL,NULL),(69357,'83548','S','Culdesac','A','Lewis','16061','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.344720,-116.541900,0,'2013-07-06 12:44:34',NULL,NULL),(43040,'48176','S','Saline','D','Washtenaw','26161','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.165249,-83.786854,0,'2013-07-06 12:44:32',NULL,NULL),(20319,'20827','P','Westlake','A','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.013715,-77.158738,0,'2013-07-06 12:44:31',NULL,NULL),(10600,'11040','S','Hillside Mnr','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(45244,'50654','S','Masonville','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.510957,-91.548967,0,'2013-07-06 12:44:32',NULL,NULL),(69872,'84095','S','S Jordan','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.569297,-111.967229,0,'2013-07-06 12:44:34',NULL,NULL),(23850,'26141','S','Annamoriah','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.961534,-81.257948,0,'2013-07-06 12:44:31',NULL,NULL),(37697,'42254','S','La Fayette','D','Christian','21047','Kentucky','KY','21','1660','270','Central',-6.0,'Y',36.658712,-87.647685,0,'2013-07-06 12:44:32',NULL,NULL),(1385,'00738','S','Ext Melendez','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(29850,'33036','S','Lower Matecumbe Key','N','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.921276,-80.630142,0,'2013-07-06 12:44:32',NULL,NULL),(24896,'27709','P','Research Triangle Park','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.913800,-78.848911,0,'2013-07-06 12:44:31',NULL,NULL),(1438,'00739','S','Urb Domingo Rodriguez','N','Cidra','72041','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.177401,-66.156056,0,'2013-07-06 12:44:30',NULL,NULL),(47246,'54515','S','Catawba','D','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.538877,-90.527494,0,'2013-07-06 12:44:32',NULL,NULL),(6280,'05641','S','Barre Junction','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(56413,'65251','S','Fulton','D','Callaway','29027','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.852815,-91.946319,0,'2013-07-06 12:44:33',NULL,NULL),(1689,'00777','S','Paseo Palma Real','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(6931,'06160','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.771494,-72.707813,0,'2013-07-06 12:44:30',NULL,NULL),(67106,'79719','P','Barstow','D','Ward','48475','Texas','TX','48','0000','432','Central',-6.0,'Y',31.480361,-103.329587,0,'2013-07-06 12:44:34',NULL,NULL),(68089,'80941','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.866594,-104.755324,0,'2013-07-06 12:44:34',NULL,NULL),(74984,'93446','S','Heritage Ranch','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(25146,'28020','S','Casar','D','Cleveland','37045','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.526116,-81.597449,0,'2013-07-06 12:44:31',NULL,NULL),(6585,'05858','S','North Concord','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.575000,-71.784722,0,'2013-07-06 12:44:30',NULL,NULL),(66283,'78582','S','Rincon','N','Starr','48427','Texas','TX','48','0000','956','Central',-6.0,'Y',26.491920,-98.739300,0,'2013-07-06 12:44:34',NULL,NULL),(4359,'03057','S','Mont Vernon','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.898128,-71.677913,0,'2013-07-06 12:44:30',NULL,NULL),(79953,'99631','S','Moose Pass','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.608320,-149.249213,0,'2013-07-06 12:44:34',NULL,NULL),(67626,'80444','P','Georgetown','D','Clear Creek','08019','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',39.708322,-105.694429,0,'2013-07-06 12:44:34',NULL,NULL),(52042,'60192','S','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.073812,-88.106821,0,'2013-07-06 12:44:33',NULL,NULL),(254,'00638','S','Qtas De Ciales','N','Ciales','72039','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.338774,-66.466418,0,'2013-07-06 12:44:30',NULL,NULL),(71349,'86514','S','Tolacon','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.750658,-109.364054,0,'2013-07-06 12:44:34',NULL,NULL),(70386,'84664','S','Springville','A','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.137545,-111.574793,0,'2013-07-06 12:44:34',NULL,NULL),(3871,'02359','S','East Pembroke','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.063591,-70.805297,0,'2013-07-06 12:44:30',NULL,NULL),(47470,'54739','S','Elk Mound','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.874354,-91.690543,0,'2013-07-06 12:44:32',NULL,NULL),(48766,'55982','S','Waltham','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.803937,-92.868615,0,'2013-07-06 12:44:33',NULL,NULL),(21767,'23061','S','Gloucester','D','Gloucester','51073','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.435603,-76.547405,0,'2013-07-06 12:44:31',NULL,NULL),(25493,'28364','S','Maxton','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.738081,-79.341399,0,'2013-07-06 12:44:31',NULL,NULL),(58935,'69348','S','Hemingford','D','Box Butte','31013','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.316869,-103.075882,0,'2013-07-06 12:44:33',NULL,NULL),(30526,'33406','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.656737,-80.090777,0,'2013-07-06 12:44:32',NULL,NULL),(30876,'33680','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.002750,-82.400927,0,'2013-07-06 12:44:32',NULL,NULL),(6535,'05832','S','East Burke','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.604179,-71.918969,0,'2013-07-06 12:44:30',NULL,NULL),(5771,'05046','S','Groton','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.234984,-72.263574,0,'2013-07-06 12:44:30',NULL,NULL),(19236,'19906','S','Dover','D','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.158893,-75.526594,0,'2013-07-06 12:44:31',NULL,NULL),(43419,'48465','S','Palms','D','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.629223,-82.631547,0,'2013-07-06 12:44:32',NULL,NULL),(18521,'19106','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951659,-75.144608,0,'2013-07-06 12:44:31',NULL,NULL),(50779,'58428','S','Dawson','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.807596,-99.764035,0,'2013-07-06 12:44:33',NULL,NULL),(54007,'62448','S','Bogota','N','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.988361,-88.163646,0,'2013-07-06 12:44:33',NULL,NULL),(72008,'88041','S','Hanover','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.746667,-107.885833,0,'2013-07-06 12:44:34',NULL,NULL),(54179,'62624','S','Bader','A','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.160050,-90.349720,0,'2013-07-06 12:44:33',NULL,NULL),(16285,'17103','S','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259580,-76.860180,0,'2013-07-06 12:44:31',NULL,NULL),(25509,'28380','P','Rockingham','D','Richmond','37153','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.943054,-79.760844,0,'2013-07-06 12:44:31',NULL,NULL),(24177,'26623','S','Glendon','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.630653,-80.876931,0,'2013-07-06 12:44:31',NULL,NULL),(46260,'53016','P','Clyman','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.313962,-88.722855,0,'2013-07-06 12:44:32',NULL,NULL),(62181,'73758','S','Manchester','D','Grant','40053','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.954762,-98.011661,0,'2013-07-06 12:44:33',NULL,NULL),(50568,'58220','S','Cavalier','D','Pembina','38067','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.782525,-97.607866,0,'2013-07-06 12:44:33',NULL,NULL),(48788,'56002','P','N Mankato','N','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.161464,-94.005528,0,'2013-07-06 12:44:33',NULL,NULL),(29405,'32635','P','Gainesville','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.650401,-82.325247,0,'2013-07-06 12:44:32',NULL,NULL),(26550,'29207','P','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.061667,-80.966102,0,'2013-07-06 12:44:31',NULL,NULL),(772,'00692','S','Urb Sierra Maestra','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(60775,'72017','S','Biscoe','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.836954,-91.538165,0,'2013-07-06 12:44:33',NULL,NULL),(22890,'24580','S','Nelson','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.555409,-78.672411,0,'2013-07-06 12:44:31',NULL,NULL),(15868,'16950','S','Brookfield','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.919720,-77.517120,0,'2013-07-06 12:44:31',NULL,NULL),(35110,'39209','S','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.324026,-90.252348,0,'2013-07-06 12:44:32',NULL,NULL),(37534,'42051','S','Pottsville','N','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.853500,-88.695180,0,'2013-07-06 12:44:32',NULL,NULL),(51231,'59064','S','Pompeys Pillar','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.949977,-107.981373,0,'2013-07-06 12:44:33',NULL,NULL),(29679,'32922','S','Cocoa','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.363967,-80.747039,0,'2013-07-06 12:44:32',NULL,NULL),(58889,'69166','S','Brownlee','A','Thomas','31171','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.978979,-100.570282,0,'2013-07-06 12:44:33',NULL,NULL),(58388,'68602','P','Columbus','D','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.446287,-97.307733,0,'2013-07-06 12:44:33',NULL,NULL),(43582,'48746','S','Millington','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.278288,-83.538168,0,'2013-07-06 12:44:32',NULL,NULL),(15005,'15665','S','Manor','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.334924,-79.664623,0,'2013-07-06 12:44:31',NULL,NULL),(551,'00677','S','Rincon','D','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(49205,'56456','P','Jenkins','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.649886,-94.335802,0,'2013-07-06 12:44:33',NULL,NULL),(23847,'26137','S','Nobe','A','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.002820,-81.073980,0,'2013-07-06 12:44:31',NULL,NULL),(11215,'11746','S','S Huntington','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.817398,-73.369148,0,'2013-07-06 12:44:30',NULL,NULL),(72851,'89883','P','W Wendover','A','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',40.691330,-114.143019,0,'2013-07-06 12:44:34',NULL,NULL),(61973,'73185','U','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.469690,-97.518506,0,'2013-07-06 12:44:33',NULL,NULL),(38351,'43445','S','Bono','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.591940,-83.311500,0,'2013-07-06 12:44:32',NULL,NULL),(70349,'84638','P','Leamington','D','Millard','49027','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.525274,-112.286779,0,'2013-07-06 12:44:34',NULL,NULL),(53079,'61523','S','South Rome','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.907358,-89.516204,0,'2013-07-06 12:44:33',NULL,NULL),(19117,'19607','S','Kenhorst','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.311120,-75.923820,0,'2013-07-06 12:44:31',NULL,NULL),(68109,'80946','U','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.847888,-104.824771,0,'2013-07-06 12:44:34',NULL,NULL),(25391,'28272','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.229711,-80.844761,0,'2013-07-06 12:44:31',NULL,NULL),(42228,'47564','S','Iva','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.478071,-87.099267,0,'2013-07-06 12:44:32',NULL,NULL),(52330,'60565','S','Naperville','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.738696,-88.124239,0,'2013-07-06 12:44:33',NULL,NULL),(46435,'53205','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.053463,-87.933809,0,'2013-07-06 12:44:32',NULL,NULL),(31971,'35215','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.639053,-86.691875,0,'2013-07-06 12:44:32',NULL,NULL),(8914,'08740','P','Ocean Gate','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.923912,-74.136557,0,'2013-07-06 12:44:30',NULL,NULL),(23842,'26134','S','Eureka','A','Pleasants','54073','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.379129,-81.264578,0,'2013-07-06 12:44:31',NULL,NULL),(23394,'25315','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.235874,-81.555983,0,'2013-07-06 12:44:31',NULL,NULL),(60738,'71964','S','Pearcy','D','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.450158,-93.197251,0,'2013-07-06 12:44:33',NULL,NULL),(13436,'13760','S','Union Center','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.141000,-76.075260,0,'2013-07-06 12:44:31',NULL,NULL),(79700,'99207','S','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.692694,-117.386717,0,'2013-07-06 12:44:34',NULL,NULL),(79827,'99513','S','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.215754,-149.867867,0,'2013-07-06 12:44:34',NULL,NULL),(42951,'48125','S','Dearborn Hts','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.275895,-83.263587,0,'2013-07-06 12:44:32',NULL,NULL),(58799,'68982','S','Wilcox','D','Kearney','31099','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.392938,-99.121319,0,'2013-07-06 12:44:33',NULL,NULL),(59683,'71068','S','Woodardville','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.316980,-93.299756,0,'2013-07-06 12:44:33',NULL,NULL),(75706,'94572','S','Rodeo','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',38.030560,-122.261841,0,'2013-07-06 12:44:34',NULL,NULL),(33041,'36745','P','Jefferson','D','Marengo','01091','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.387543,-87.902054,0,'2013-07-06 12:44:32',NULL,NULL),(64704,'76856','S','Mason','D','Mason','48319','Texas','TX','48','0000','325','Central',-6.0,'Y',30.737100,-99.227400,0,'2013-07-06 12:44:34',NULL,NULL),(26712,'29412','S','James Island','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.719260,-79.951080,0,'2013-07-06 12:44:31',NULL,NULL),(60546,'71722','S','Bluff City','D','Nevada','05099','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.698184,-93.198955,0,'2013-07-06 12:44:33',NULL,NULL),(610,'00680','S','Villa India','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(54077,'62515','S','Buffalo Hart','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.847849,-89.406204,0,'2013-07-06 12:44:33',NULL,NULL),(9426,'10003','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(52173,'60458','S','Oak Lawn','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.745877,-87.836217,0,'2013-07-06 12:44:33',NULL,NULL),(72379,'89036','P','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.369599,-114.884210,0,'2013-07-06 12:44:34',NULL,NULL),(27313,'30022','S','Johns Creek','A','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.029562,-84.240658,0,'2013-07-06 12:44:31',NULL,NULL),(23440,'25405','S','Martinsburg','D','Berkeley','54003','West Virginia','WV','54','8840','304/681','Eastern',-5.0,'Y',39.461940,-77.969187,0,'2013-07-06 12:44:31',NULL,NULL),(23106,'24941','S','Gap Mills','D','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.521353,-80.372282,0,'2013-07-06 12:44:31',NULL,NULL),(47743,'55014','S','Lino Lakes','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.179760,-93.132240,0,'2013-07-06 12:44:33',NULL,NULL),(46816,'54007','S','Deer Park','D','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.169996,-92.361717,0,'2013-07-06 12:44:32',NULL,NULL),(45060,'50511','S','Hobarton','N','Kossuth','19109','Iowa','IA','19','0000','515','Central',-6.0,'Y',43.072355,-94.229492,0,'2013-07-06 12:44:32',NULL,NULL),(39183,'44316','U','Goodyear Tire','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.079334,-81.472767,0,'2013-07-06 12:44:32',NULL,NULL),(27917,'30507','S','Gainesville','D','Hall','13139','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',34.254602,-83.775548,0,'2013-07-06 12:44:31',NULL,NULL),(35231,'39309','U','Naval Air Sta Meridian','A','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.537503,-88.567935,0,'2013-07-06 12:44:32',NULL,NULL),(30094,'33157','S','South Miami Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.606686,-80.344992,0,'2013-07-06 12:44:32',NULL,NULL),(16138,'17059','S','Denholm','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(45867,'52246','S','University Heights','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.654177,-91.560065,0,'2013-07-06 12:44:32',NULL,NULL),(37606,'42129','S','Edmonton','D','Metcalfe','21169','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.988715,-85.611504,0,'2013-07-06 12:44:32',NULL,NULL),(21486,'22650','S','Rileyville','D','Page','51139','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.765027,-78.377011,0,'2013-07-06 12:44:31',NULL,NULL),(33749,'37847','S','Pioneer','D','Campbell','47013','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.459083,-84.302660,0,'2013-07-06 12:44:32',NULL,NULL),(29201,'32408','S','Panama City Beach','A','Bay','12005','Florida','FL','12','6015','850','Central',-6.0,'Y',30.158417,-85.763888,0,'2013-07-06 12:44:32',NULL,NULL),(25057,'27925','S','Columbia','D','Tyrrell','37177','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.921365,-76.252726,0,'2013-07-06 12:44:31',NULL,NULL),(12293,'12847','S','Sabattis','N','Hamilton','36041','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.968517,-74.418773,0,'2013-07-06 12:44:30',NULL,NULL),(67805,'80741','S','Merino','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.531920,-103.413240,0,'2013-07-06 12:44:34',NULL,NULL),(67462,'80219','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.698319,-105.032695,0,'2013-07-06 12:44:34',NULL,NULL),(66383,'78624','S','Bankersmith','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(61946,'73163','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.472000,-97.520348,0,'2013-07-06 12:44:33',NULL,NULL),(57356,'66736','S','Coyville','A','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.535127,-95.823027,0,'2013-07-06 12:44:33',NULL,NULL),(55478,'63751','S','Glenallen','D','Bollinger','29017','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.327212,-90.061063,0,'2013-07-06 12:44:33',NULL,NULL),(2904,'00987','S','Urb Remanzo Taino','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(9193,'09397','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(24862,'27650','P','Raleigh','D','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.787729,-78.662621,0,'2013-07-06 12:44:31',NULL,NULL),(24088,'26502','P','Westover','A','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.634444,-79.970000,0,'2013-07-06 12:44:31',NULL,NULL),(36530,'40855','P','Lynch','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.963272,-82.910360,0,'2013-07-06 12:44:32',NULL,NULL),(14224,'14804','S','Almond','D','Allegany','36003','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.327793,-77.824559,0,'2013-07-06 12:44:31',NULL,NULL),(75855,'94937','S','Inverness','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',38.096305,-122.859417,0,'2013-07-06 12:44:34',NULL,NULL),(70597,'85097','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.448261,-112.075768,0,'2013-07-06 12:44:34',NULL,NULL),(59018,'70075','S','Francis Place','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.948870,-89.898600,0,'2013-07-06 12:44:33',NULL,NULL),(46479,'53219','S','West Milwaukee','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.994394,-87.991356,0,'2013-07-06 12:44:32',NULL,NULL),(33964,'38106','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.107211,-90.042832,0,'2013-07-06 12:44:32',NULL,NULL),(17431,'17930','P','Cumbola','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.709559,-76.138383,0,'2013-07-06 12:44:31',NULL,NULL),(21422,'22546','S','Rutherglen','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.007807,-77.545616,0,'2013-07-06 12:44:31',NULL,NULL),(27679,'30333','P','ATL','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.795743,-84.323393,0,'2013-07-06 12:44:31',NULL,NULL),(23683,'25844','S','Glen Daniel','D','Raleigh','54081','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.744768,-81.393226,0,'2013-07-06 12:44:31',NULL,NULL),(69701,'84032','S','Hailstone','N','Wasatch','49051','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.401780,-111.246300,0,'2013-07-06 12:44:34',NULL,NULL),(44573,'50025','S','Sharon','N','Audubon','19009','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.726100,-94.918560,0,'2013-07-06 12:44:32',NULL,NULL),(39061,'44198','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.493668,-81.676246,0,'2013-07-06 12:44:32',NULL,NULL),(9390,'09852','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(8729,'08512','S','Cranbury','D','Middlesex','34023','New Jersey','NJ','34','5015','609','Eastern',-5.0,'Y',40.311180,-74.525160,0,'2013-07-06 12:44:30',NULL,NULL),(28703,'31823','S','Pine Mtn Valy','A','Harris','13145','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.784644,-84.823456,0,'2013-07-06 12:44:32',NULL,NULL),(6404,'05735','S','East Hubbardton','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627980,-73.170780,0,'2013-07-06 12:44:30',NULL,NULL),(11547,'12053','S','Delanson','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.722580,-74.171580,0,'2013-07-06 12:44:30',NULL,NULL),(12976,'13368','S','Lyons Falls','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.630920,-75.348480,0,'2013-07-06 12:44:30',NULL,NULL),(78420,'98045','S','North Bend','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.475162,-121.756532,0,'2013-07-06 12:44:34',NULL,NULL),(73573,'91376','P','Agoura Hills','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.140438,-118.751567,0,'2013-07-06 12:44:34',NULL,NULL),(69075,'83244','S','Clyde','N','Butte','16023','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.797498,-113.093060,0,'2013-07-06 12:44:34',NULL,NULL),(58463,'68731','S','Dakota City','D','Dakota','31043','Nebraska','NE','31','7720','402','Central',-6.0,'Y',42.411172,-96.418220,0,'2013-07-06 12:44:33',NULL,NULL),(48687,'55929','S','Dover','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',43.970538,-92.136636,0,'2013-07-06 12:44:33',NULL,NULL),(39191,'44321','S','Copley','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.104382,-81.650553,0,'2013-07-06 12:44:32',NULL,NULL),(18281,'19013','S','Feltonville','N','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.847709,-75.376375,0,'2013-07-06 12:44:31',NULL,NULL),(15373,'16301','S','Oil City','D','Venango','42121','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.433864,-79.705846,0,'2013-07-06 12:44:31',NULL,NULL),(20526,'21093','S','Luthvle Timon','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.434940,-76.654860,0,'2013-07-06 12:44:31',NULL,NULL),(5626,'04942','S','Mayfield Twp','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.011460,-69.569760,0,'2013-07-06 12:44:30',NULL,NULL),(6382,'05701','S','East Pittsford','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(80067,'99723','P','Barrow','D','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',70.669760,-155.143030,0,'2013-07-06 12:44:34',NULL,NULL),(78119,'97504','S','Medford','D','Jackson','41029','Oregon','OR','41','4890','541','Pacific',-8.0,'Y',42.335443,-122.837108,0,'2013-07-06 12:44:34',NULL,NULL),(77133,'96156','P','S Lake Tahoe','A','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.947065,-119.970227,0,'2013-07-06 12:44:34',NULL,NULL),(69363,'83553','S','Weippe','D','Clearwater','16035','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',46.380448,-115.947701,0,'2013-07-06 12:44:34',NULL,NULL),(35197,'39288','P','JAX','N','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.300020,-90.145549,0,'2013-07-06 12:44:32',NULL,NULL),(34821,'38914','S','Coles Creek','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.867342,-89.457753,0,'2013-07-06 12:44:32',NULL,NULL),(28570,'31605','S','Bemiss','N','Lowndes','13185','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.934844,-83.221011,0,'2013-07-06 12:44:32',NULL,NULL),(24014,'26361','P','Gypsy','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.370303,-80.319346,0,'2013-07-06 12:44:31',NULL,NULL),(22198,'23510','S','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.851128,-76.291171,0,'2013-07-06 12:44:31',NULL,NULL),(21269,'22309','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.727866,-77.109317,0,'2013-07-06 12:44:31',NULL,NULL),(55526,'63824','P','Blodgett','D','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.002542,-89.525191,0,'2013-07-06 12:44:33',NULL,NULL),(61318,'72440','S','Lynn','D','Lawrence','05075','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.997577,-91.247233,0,'2013-07-06 12:44:33',NULL,NULL),(7672,'07093','S','West New York','D','Hudson','34017','New Jersey','NJ','34','3640','201/551','Eastern',-5.0,'Y',40.788201,-74.013854,0,'2013-07-06 12:44:30',NULL,NULL),(79507,'98922','S','Liberty','N','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.163120,-120.849600,0,'2013-07-06 12:44:34',NULL,NULL),(77457,'96813','S','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.314718,-157.853702,0,'2013-07-06 12:44:34',NULL,NULL),(68523,'81335','S','Yellow Jacket','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.497977,-108.773677,0,'2013-07-06 12:44:34',NULL,NULL),(8812,'08611','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.209791,-74.754696,0,'2013-07-06 12:44:30',NULL,NULL),(24295,'27011','S','Booneville','N','Yadkin','37197','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.240300,-80.637420,0,'2013-07-06 12:44:31',NULL,NULL),(23597,'25686','P','Newtown','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.649022,-82.128388,0,'2013-07-06 12:44:31',NULL,NULL),(21145,'22109','U','Mc Lean','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.933680,-77.184391,0,'2013-07-06 12:44:31',NULL,NULL),(18633,'19154','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.085444,-74.983544,0,'2013-07-06 12:44:31',NULL,NULL),(15226,'16025','S','Chicora','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.948847,-79.764350,0,'2013-07-06 12:44:31',NULL,NULL),(38537,'43746','S','Hopewell','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.963000,-82.170248,0,'2013-07-06 12:44:32',NULL,NULL),(39263,'44450','S','Lockwood','N','Trumbull','39155','Ohio','OH','39','9320','440','Eastern',-5.0,'Y',41.460780,-80.830440,0,'2013-07-06 12:44:32',NULL,NULL),(50831,'58475','S','Pettibone','D','Kidder','38043','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.109310,-99.546142,0,'2013-07-06 12:44:33',NULL,NULL),(57956,'67756','S','Saint Francis','D','Cheyenne','20023','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.774780,-101.810400,0,'2013-07-06 12:44:33',NULL,NULL),(58805,'69022','S','Cambridge','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.285841,-100.171518,0,'2013-07-06 12:44:33',NULL,NULL),(63418,'75657','S','Gray','N','Marion','48315','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.787670,-94.073130,0,'2013-07-06 12:44:33',NULL,NULL),(144,'00617','S','Parc Imbery','N','Barceloneta','72017','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.458792,-66.537234,0,'2013-07-06 12:44:30',NULL,NULL),(67431,'80163','P','Highlands Ranch','A','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.545881,-104.974412,0,'2013-07-06 12:44:34',NULL,NULL),(64838,'77040','S','Kohrville','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(53457,'61913','S','Garrett','N','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.814320,-88.436880,0,'2013-07-06 12:44:33',NULL,NULL),(50496,'58059','S','Mapleton','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',46.867140,-97.069320,0,'2013-07-06 12:44:33',NULL,NULL),(45013,'50455','S','Meyer','N','Mitchell','19131','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.465027,-92.612882,0,'2013-07-06 12:44:32',NULL,NULL),(24857,'27635','U','NC Library','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.817935,-78.572329,0,'2013-07-06 12:44:31',NULL,NULL),(17013,'17740','S','Piatt','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(5534,'04781','S','Wallagrass','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.145899,-68.632982,0,'2013-07-06 12:44:30',NULL,NULL),(15131,'15832','S','Driftwood','D','Cameron','42023','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.366719,-78.167946,0,'2013-07-06 12:44:31',NULL,NULL),(1894,'00792','P','Humacao','D','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.151300,-65.821929,0,'2013-07-06 12:44:30',NULL,NULL),(79708,'99211','P','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.665303,-117.310120,0,'2013-07-06 12:44:34',NULL,NULL),(63432,'75667','S','Anadarko','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.945127,-94.853612,0,'2013-07-06 12:44:33',NULL,NULL),(62140,'73705','S','Enid','D','Garfield','40047','Oklahoma','OK','40','2340','580','Central',-6.0,'Y',36.395520,-97.878000,0,'2013-07-06 12:44:33',NULL,NULL),(35746,'39730','S','Lackey','N','Monroe','28095','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.840000,-88.530120,0,'2013-07-06 12:44:32',NULL,NULL),(34074,'38150','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.147314,-90.048201,0,'2013-07-06 12:44:32',NULL,NULL),(27413,'30097','S','Duluth','D','Fulton','13121','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.025741,-84.141816,0,'2013-07-06 12:44:31',NULL,NULL),(24183,'26629','S','Tesla','A','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.565848,-80.708460,0,'2013-07-06 12:44:31',NULL,NULL),(14786,'15359','S','Rogersville','D','Greene','42059','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',39.906384,-80.287245,0,'2013-07-06 12:44:31',NULL,NULL),(16584,'17322','S','Cross Roads','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.860272,-76.566178,0,'2013-07-06 12:44:31',NULL,NULL),(21530,'22727','S','Shelby','N','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(47925,'55112','S','Mounds View','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.079380,-93.187200,0,'2013-07-06 12:44:33',NULL,NULL),(54672,'62939','S','Pulleys Mill','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.554162,-88.969995,0,'2013-07-06 12:44:33',NULL,NULL),(79078,'98433','S','Joint Base Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(70680,'85248','S','Sun Lakes','A','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.247500,-111.879180,0,'2013-07-06 12:44:34',NULL,NULL),(75790,'94707','S','Kensington','A','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.899300,-122.276520,0,'2013-07-06 12:44:34',NULL,NULL),(5684,'04970','S','Rangeley','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.983435,-70.658693,0,'2013-07-06 12:44:30',NULL,NULL),(78413,'98042','S','Covington','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.376480,-122.099400,0,'2013-07-06 12:44:34',NULL,NULL),(10638,'11055','U','Port Washington','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.840893,-73.704913,0,'2013-07-06 12:44:30',NULL,NULL),(32666,'36263','S','Graham','D','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.462293,-85.338064,0,'2013-07-06 12:44:32',NULL,NULL),(4235,'02860','S','Pawtucket','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.872972,-71.392740,0,'2013-07-06 12:44:30',NULL,NULL),(12318,'12861','S','Putnam Station','D','Washington','36115','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.749622,-73.417889,0,'2013-07-06 12:44:30',NULL,NULL),(23219,'25082','S','Fraziers Bottom','D','Putnam','54079','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.568197,-82.025774,0,'2013-07-06 12:44:31',NULL,NULL),(20680,'21235','U','Social Security Administrat','N','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.309564,-76.728397,0,'2013-07-06 12:44:31',NULL,NULL),(14440,'15089','S','West Newton','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.200567,-79.720301,0,'2013-07-06 12:44:31',NULL,NULL),(14070,'14605','S','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.165247,-77.600096,0,'2013-07-06 12:44:31',NULL,NULL),(39230,'44417','S','Mayburn Corners','N','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.425790,-80.661237,0,'2013-07-06 12:44:32',NULL,NULL),(39663,'45011','S','New Miami','N','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.406984,-84.509883,0,'2013-07-06 12:44:32',NULL,NULL),(40084,'45303','S','Ansonia','D','Darke','39037','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.216786,-84.641269,0,'2013-07-06 12:44:32',NULL,NULL),(40982,'46347','S','Kouts','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.314916,-87.034521,0,'2013-07-06 12:44:32',NULL,NULL),(43290,'48335','S','Farmington','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.466205,-83.401727,0,'2013-07-06 12:44:32',NULL,NULL),(53125,'61547','S','Lake Camelot','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.613781,-89.743465,0,'2013-07-06 12:44:33',NULL,NULL),(66021,'78361','S','Agua Nueva','N','Jim Hogg','48247','Texas','TX','48','0000','361','Central',-6.0,'Y',27.283639,-98.691312,0,'2013-07-06 12:44:34',NULL,NULL),(7993,'07717','S','Avon','N','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.192871,-74.017170,0,'2013-07-06 12:44:30',NULL,NULL),(75963,'95051','S','Santa Clara','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.347073,-121.983350,0,'2013-07-06 12:44:34',NULL,NULL),(71010,'85723','U','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.194430,-111.005542,0,'2013-07-06 12:44:34',NULL,NULL),(68419,'81210','S','Spring Creek','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(64904,'77090','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.011863,-95.446521,0,'2013-07-06 12:44:34',NULL,NULL),(59608,'71021','P','Cullen','D','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.968959,-93.445228,0,'2013-07-06 12:44:33',NULL,NULL),(53375,'61778','S','Tabor','N','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.242570,-89.126495,0,'2013-07-06 12:44:33',NULL,NULL),(8717,'08501','S','Allentown','D','Monmouth','34025','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',40.134060,-74.597340,0,'2013-07-06 12:44:30',NULL,NULL),(18115,'18773','P','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.245679,-75.883795,0,'2013-07-06 12:44:31',NULL,NULL),(37209,'41522','S','Venters','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(48928,'56151','S','Slayton','A','Murray','27101','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.008260,-95.906340,0,'2013-07-06 12:44:33',NULL,NULL),(52362,'60612','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881072,-87.687130,0,'2013-07-06 12:44:33',NULL,NULL),(3328,'01534','S','Rockdale','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.143607,-71.654859,0,'2013-07-06 12:44:30',NULL,NULL),(72418,'89052','S','Henderson','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.992568,-115.119585,0,'2013-07-06 12:44:34',NULL,NULL),(53409,'61834','S','Danville','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.130702,-87.629223,0,'2013-07-06 12:44:33',NULL,NULL),(49510,'56668','P','Ranier','D','Koochiching','27071','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.613378,-93.349817,0,'2013-07-06 12:44:33',NULL,NULL),(16579,'17320','S','Fairfield','D','Adams','42001','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.755100,-77.376290,0,'2013-07-06 12:44:31',NULL,NULL),(27665,'30327','S','Sandy Spgs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.865889,-84.425245,0,'2013-07-06 12:44:31',NULL,NULL),(8495,'08096','S','Deptford Township','N','Gloucester','34015','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.827998,-75.134513,0,'2013-07-06 12:44:30',NULL,NULL),(61874,'73129','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.429134,-97.486641,0,'2013-07-06 12:44:33',NULL,NULL),(52285,'60531','S','Baker','N','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.601884,-88.780679,0,'2013-07-06 12:44:33',NULL,NULL),(50964,'58626','S','Dunn Ctr','N','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.349834,-102.564317,0,'2013-07-06 12:44:33',NULL,NULL),(33366,'37203','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.155873,-86.789280,0,'2013-07-06 12:44:32',NULL,NULL),(11640,'12122','S','Middleburgh','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.540360,-74.270820,0,'2013-07-06 12:44:30',NULL,NULL),(63634,'75840','S','Fairfield','D','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.722324,-96.157345,0,'2013-07-06 12:44:34',NULL,NULL),(62368,'74072','S','South Coffeyville','N','Nowata','40105','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.975720,-95.587200,0,'2013-07-06 12:44:33',NULL,NULL),(59409,'70645','S','Hackberry','D','Cameron','22023','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.982600,-93.396360,0,'2013-07-06 12:44:33',NULL,NULL),(58701,'68930','S','Blue Hill','D','Webster','31181','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.329281,-98.450890,0,'2013-07-06 12:44:33',NULL,NULL),(55210,'63390','S','Innsbrook','A','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.804920,-91.039421,0,'2013-07-06 12:44:33',NULL,NULL),(21509,'22714','S','Brandy','N','Culpeper','51047','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.523104,-77.898372,0,'2013-07-06 12:44:31',NULL,NULL),(27102,'29721','P','Lancaster','D','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.747105,-80.718422,0,'2013-07-06 12:44:31',NULL,NULL),(850,'00698','S','Jard M Blanco','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(79663,'99155','P','Nespelem','D','Okanogan','53047','Washington','WA','53','0000','509','Pacific',-8.0,'Y',48.255119,-119.239591,0,'2013-07-06 12:44:34',NULL,NULL),(79255,'98563','S','Melbourne','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.999232,-123.601956,0,'2013-07-06 12:44:34',NULL,NULL),(63863,'75980','S','Zavalla','D','Angelina','48005','Texas','TX','48','0000','936','Central',-6.0,'Y',31.160640,-94.402200,0,'2013-07-06 12:44:34',NULL,NULL),(59157,'70190','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.940241,-90.069378,0,'2013-07-06 12:44:33',NULL,NULL),(39328,'44614','S','Canal Fulton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.880580,-81.589680,0,'2013-07-06 12:44:32',NULL,NULL),(39024,'44143','S','Mayfield Village','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(32216,'35570','S','Hamilton','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',34.167932,-87.979150,0,'2013-07-06 12:44:32',NULL,NULL),(29808,'33024','S','Hollywood','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.018670,-80.258199,0,'2013-07-06 12:44:32',NULL,NULL),(5301,'04549','S','Isle of Springs','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.897252,-69.629746,0,'2013-07-06 12:44:30',NULL,NULL),(9236,'09565','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(36366,'40447','S','Peoples','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.450161,-84.012456,0,'2013-07-06 12:44:32',NULL,NULL),(77474,'96819','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.345402,-157.880907,0,'2013-07-06 12:44:34',NULL,NULL),(75112,'93545','S','Swansea','N','Inyo','06027','California','CA','06','0000','760','Pacific',-8.0,'Y',36.588000,-118.056263,0,'2013-07-06 12:44:34',NULL,NULL),(55159,'63366','S','Ofallon','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.835060,-90.742320,0,'2013-07-06 12:44:33',NULL,NULL),(48760,'55976','S','Stewartville','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',43.859369,-92.487834,0,'2013-07-06 12:44:33',NULL,NULL),(48317,'55444','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.088050,-93.296289,0,'2013-07-06 12:44:33',NULL,NULL),(37090,'41339','S','Haddix','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(18907,'19480','P','Eagle','A','Chester','42029','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.081499,-75.694821,0,'2013-07-06 12:44:31',NULL,NULL),(4302,'02907','S','Cranston','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.821440,-71.433900,0,'2013-07-06 12:44:30',NULL,NULL),(8322,'08035','S','Haddon Heights','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.877788,-75.066565,0,'2013-07-06 12:44:30',NULL,NULL),(6640,'06010','S','Forestville','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.679705,-72.931387,0,'2013-07-06 12:44:30',NULL,NULL),(77587,'96917','P','Inarajan','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.278936,144.737867,0,'2013-07-06 12:44:34',NULL,NULL),(75538,'94209','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.583540,-121.493379,0,'2013-07-06 12:44:34',NULL,NULL),(65353,'77523','S','Mont Belvieu','A','Chambers','48071','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.756417,-94.968734,0,'2013-07-06 12:44:34',NULL,NULL),(54778,'62998','S','Wolf Lake','D','Union','17181','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.532673,-89.443850,0,'2013-07-06 12:44:33',NULL,NULL),(52321,'60557','P','Wedron','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.435185,-88.769788,0,'2013-07-06 12:44:33',NULL,NULL),(47437,'54721','S','Arkansaw','D','Pepin','55091','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.619614,-92.069589,0,'2013-07-06 12:44:32',NULL,NULL),(45766,'52151','S','Lansing','D','Allamakee','19005','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.359099,-91.221890,0,'2013-07-06 12:44:32',NULL,NULL),(37972,'42726','S','Wax','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.413206,-86.157634,0,'2013-07-06 12:44:32',NULL,NULL),(1740,'00778','S','Urb Los Suenos','N','Gurabo','72063','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.257108,-65.975738,0,'2013-07-06 12:44:30',NULL,NULL),(12768,'13210','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.034249,-76.126286,0,'2013-07-06 12:44:30',NULL,NULL),(14096,'14621','S','Irondequoit','N','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.182834,-77.602085,0,'2013-07-06 12:44:31',NULL,NULL),(14741,'15312','S','Rea','A','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.272892,-80.451010,0,'2013-07-06 12:44:31',NULL,NULL),(75937,'95026','P','Redwood Est','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.155014,-121.982515,0,'2013-07-06 12:44:34',NULL,NULL),(72019,'88045','S','Road Forks','A','Hidalgo','35023','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.347258,-108.708739,0,'2013-07-06 12:44:34',NULL,NULL),(71609,'87327','P','Black Rock','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(48301,'55440','P','Minn','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.987435,-93.271271,0,'2013-07-06 12:44:33',NULL,NULL),(47189,'54485','S','Summit Lake','D','Langlade','55067','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.364927,-89.187376,0,'2013-07-06 12:44:32',NULL,NULL),(18906,'19478','P','Spring Mount','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.274069,-75.460750,0,'2013-07-06 12:44:31',NULL,NULL),(15841,'16936','S','Millerton','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.931667,-76.936111,0,'2013-07-06 12:44:31',NULL,NULL),(6345,'05671','U','Waterbury','D','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.341294,-72.758536,0,'2013-07-06 12:44:30',NULL,NULL),(8759,'08535','S','Millstone Twp','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.220714,-74.440497,0,'2013-07-06 12:44:30',NULL,NULL),(41523,'46986','S','Sims','A','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.508776,-85.820070,0,'2013-07-06 12:44:32',NULL,NULL),(43421,'48467','S','Grindstone City','N','Huron','26063','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.008740,-82.980780,0,'2013-07-06 12:44:32',NULL,NULL),(5585,'04917','S','Belgrade','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.450800,-69.857364,0,'2013-07-06 12:44:30',NULL,NULL),(77804,'97138','S','Jewell','N','Clatsop','41007','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',46.001224,-123.921677,0,'2013-07-06 12:44:34',NULL,NULL),(76526,'95648','S','Lincoln','D','Placer','06061','California','CA','06','6920','916','Pacific',-8.0,'Y',38.913763,-121.293916,0,'2013-07-06 12:44:34',NULL,NULL),(72505,'89150','U','Sw Gas Co','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.127385,-115.216214,0,'2013-07-06 12:44:34',NULL,NULL),(56614,'65580','S','Vichy','D','Maries','29125','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.103854,-91.797318,0,'2013-07-06 12:44:33',NULL,NULL),(55552,'63851','S','Pascola','A','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.235589,-89.749057,0,'2013-07-06 12:44:33',NULL,NULL),(51978,'60151','S','Maple Park','D','Kane','17089','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.903604,-88.594699,0,'2013-07-06 12:44:33',NULL,NULL),(46839,'54017','S','Erin','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(36342,'40405','P','Bighill','D','Madison','21151','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.557751,-84.208093,0,'2013-07-06 12:44:32',NULL,NULL),(15003,'15663','P','Madison','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.248142,-79.687152,0,'2013-07-06 12:44:31',NULL,NULL),(5327,'04575','P','West Boothbay Harbor','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.848039,-69.651327,0,'2013-07-06 12:44:30',NULL,NULL),(1130,'00725','S','Villa Guadalupe','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(4256,'02879','S','Narragansett','A','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.419674,-71.530513,0,'2013-07-06 12:44:30',NULL,NULL),(30123,'33162','S','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.924770,-80.178200,0,'2013-07-06 12:44:32',NULL,NULL),(26749,'29424','U','Chas','N','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.783715,-79.939185,0,'2013-07-06 12:44:31',NULL,NULL),(14712,'15270','U','Columbia Gas of Pa','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.403948,-80.034848,0,'2013-07-06 12:44:31',NULL,NULL),(20420,'20908','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.104732,-77.076794,0,'2013-07-06 12:44:31',NULL,NULL),(18843,'19428','S','Gulph Mills','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.077938,-75.303000,0,'2013-07-06 12:44:31',NULL,NULL),(63028,'75201','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.787220,-96.798491,0,'2013-07-06 12:44:33',NULL,NULL),(10904,'11427','S','Hollis Hills','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728919,-73.748586,0,'2013-07-06 12:44:30',NULL,NULL),(59710,'71105','S','Southfield','N','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.454589,-93.712715,0,'2013-07-06 12:44:33',NULL,NULL),(39022,'44143','S','Mayfield','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(37871,'42544','S','Jabez','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(26228,'28803','S','Biltmore Forest','A','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.548613,-82.522312,0,'2013-07-06 12:44:31',NULL,NULL),(73817,'91765','S','Diamond Bar','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.001426,-117.815685,0,'2013-07-06 12:44:34',NULL,NULL),(59613,'71028','S','Mount Lebanon','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.518320,-93.070980,0,'2013-07-06 12:44:33',NULL,NULL),(59481,'70757','S','Maringouin','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.491099,-91.515729,0,'2013-07-06 12:44:33',NULL,NULL),(79879,'99572','S','Cooper Landing','D','Kenai Peninsula','02122','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.448658,-149.916942,0,'2013-07-06 12:44:34',NULL,NULL),(1374,'00736','S','Valle Alto','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(22899,'24594','S','Sutherlin','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.627560,-79.189326,0,'2013-07-06 12:44:31',NULL,NULL),(49651,'56972','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(44589,'50041','P','Bradford','D','Franklin','19069','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.601229,-93.204334,0,'2013-07-06 12:44:32',NULL,NULL),(43938,'49283','S','Spring Arbor','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.209557,-84.547787,0,'2013-07-06 12:44:32',NULL,NULL),(41820,'47338','S','Eaton','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.342989,-85.353750,0,'2013-07-06 12:44:32',NULL,NULL),(41058,'46502','P','Atwood','D','Kosciusko','18085','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.263913,-85.974073,0,'2013-07-06 12:44:32',NULL,NULL),(49910,'57301','S','Mitchell','D','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.727400,-98.046180,0,'2013-07-06 12:44:33',NULL,NULL),(2503,'00957','S','Est de Cerro Gordo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178309,-66.111070,0,'2013-07-06 12:44:30',NULL,NULL),(48717,'55950','P','Lansing','D','Mower','27099','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.716970,-92.986286,0,'2013-07-06 12:44:33',NULL,NULL),(47558,'54836','S','Foxboro','D','Douglas','55031','Wisconsin','WI','55','2240','715','Central',-6.0,'Y',46.484657,-92.187393,0,'2013-07-06 12:44:32',NULL,NULL),(19392,'20069','U','Wash Intell Bureau Inc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.880445,-77.230119,0,'2013-07-06 12:44:31',NULL,NULL),(37131,'41465','S','Conley','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(39590,'44865','S','Plymouth','D','Huron','39077','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.995780,-82.670280,0,'2013-07-06 12:44:32',NULL,NULL),(74721,'93023','S','Ojai','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.448123,-119.252560,0,'2013-07-06 12:44:34',NULL,NULL),(31118,'33898','S','Lake Wales','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.900343,-81.535123,0,'2013-07-06 12:44:32',NULL,NULL),(68025,'80926','S','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.663492,-104.909353,0,'2013-07-06 12:44:34',NULL,NULL),(45251,'50659','S','New Hampton','D','Chickasaw','19037','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.062151,-92.314419,0,'2013-07-06 12:44:32',NULL,NULL),(34554,'38725','S','Dahomey','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(1409,'00738','S','Urb Puertas del Sol','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(47849,'55075','S','South St Paul','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.892636,-93.040178,0,'2013-07-06 12:44:33',NULL,NULL),(41675,'47166','S','Ramsey','D','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.338520,-86.136754,0,'2013-07-06 12:44:32',NULL,NULL),(39924,'45223','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.162801,-84.548827,0,'2013-07-06 12:44:32',NULL,NULL),(68132,'80962','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.954393,-104.733997,0,'2013-07-06 12:44:34',NULL,NULL),(62934,'75092','S','Knollwood','A','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.645158,-96.633453,0,'2013-07-06 12:44:33',NULL,NULL),(71738,'87537','S','Chili','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.070638,-106.160258,0,'2013-07-06 12:44:34',NULL,NULL),(58808,'69024','S','Culbertson','D','Hitchcock','31087','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.228479,-100.838653,0,'2013-07-06 12:44:33',NULL,NULL),(32703,'36278','S','Malone','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.325381,-85.506798,0,'2013-07-06 12:44:32',NULL,NULL),(40483,'45777','P','Sharpsburg','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.445418,-81.921198,0,'2013-07-06 12:44:32',NULL,NULL),(18048,'18690','U','Frontier Communicationa','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.335765,-75.970464,0,'2013-07-06 12:44:31',NULL,NULL),(64585,'76670','S','Milford','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.142009,-96.958075,0,'2013-07-06 12:44:34',NULL,NULL),(69470,'83657','S','Gross','N','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.250761,-116.298415,0,'2013-07-06 12:44:34',NULL,NULL),(71582,'87313','P','Crownpoint','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.798788,-107.923273,0,'2013-07-06 12:44:34',NULL,NULL),(79555,'99006','S','Deer Park','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.953330,-117.456570,0,'2013-07-06 12:44:34',NULL,NULL),(39293,'44491','S','West Farmington','D','Trumbull','39155','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.368536,-80.963139,0,'2013-07-06 12:44:32',NULL,NULL),(59156,'70189','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.073336,-89.817298,0,'2013-07-06 12:44:33',NULL,NULL),(27263,'29936','S','Gillisonville','N','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.481598,-80.984342,0,'2013-07-06 12:44:31',NULL,NULL),(62738,'74831','S','Byars','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.873693,-97.047649,0,'2013-07-06 12:44:33',NULL,NULL),(65836,'78154','S','Selma','A','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.587509,-98.288298,0,'2013-07-06 12:44:34',NULL,NULL),(9805,'10110','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(63807,'75962','U','Sfa','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(53533,'62032','S','Fillmore','D','Montgomery','17135','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.103643,-89.305669,0,'2013-07-06 12:44:33',NULL,NULL),(48657,'55910','S','Minneiska','A','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.131260,-91.920660,0,'2013-07-06 12:44:33',NULL,NULL),(62098,'73601','S','Clinton','D','Custer','40039','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.515594,-98.971140,0,'2013-07-06 12:44:33',NULL,NULL),(25564,'28422','S','Sunset Harbor','N','Brunswick','37019','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.034100,-78.167160,0,'2013-07-06 12:44:31',NULL,NULL),(1082,'00725','S','Urb Bonneville Terr','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(9952,'10157','U','Business Reply','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.743962,-73.977191,0,'2013-07-06 12:44:30',NULL,NULL),(55261,'63459','S','New London','D','Ralls','29173','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.586253,-91.398191,0,'2013-07-06 12:44:33',NULL,NULL),(49560,'56714','S','Badger','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.857405,-96.209079,0,'2013-07-06 12:44:33',NULL,NULL),(46577,'53530','S','Darlington','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.690879,-90.105208,0,'2013-07-06 12:44:32',NULL,NULL),(43309,'48348','S','Independence Twp','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.767149,-83.400047,0,'2013-07-06 12:44:32',NULL,NULL),(26158,'28742','S','Horse Shoe','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.361150,-82.574013,0,'2013-07-06 12:44:31',NULL,NULL),(73821,'91766','S','Pomona','D','Los Angeles','06037','California','CA','06','4480','909','Pacific',-8.0,'Y',34.041268,-117.761339,0,'2013-07-06 12:44:34',NULL,NULL),(1700,'00777','S','Urb Loma Alta','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(15611,'16681','P','Smokerun','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.800320,-78.427661,0,'2013-07-06 12:44:31',NULL,NULL),(33282,'37115','S','Madison','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.264356,-86.711888,0,'2013-07-06 12:44:32',NULL,NULL),(45743,'52133','S','Castalia','D','Winneshiek','19191','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.166865,-91.662442,0,'2013-07-06 12:44:32',NULL,NULL),(9159,'09315','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(3237,'01379','S','Wendell','D','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.561643,-72.385557,0,'2013-07-06 12:44:30',NULL,NULL),(5558,'04856','S','Rockport','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.174901,-69.087104,0,'2013-07-06 12:44:30',NULL,NULL),(23371,'25286','S','Walton','D','Roane','54087','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.577042,-81.419744,0,'2013-07-06 12:44:31',NULL,NULL),(41103,'46556','P','Notre Dame','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.693901,-86.239284,0,'2013-07-06 12:44:32',NULL,NULL),(45463,'51246','S','Edna','N','Lyon','19119','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.422060,-96.248040,0,'2013-07-06 12:44:32',NULL,NULL),(33328,'37148','S','Portland','D','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.568357,-86.490640,0,'2013-07-06 12:44:32',NULL,NULL),(69981,'84121','S','Cottonwood','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(17108,'17771','S','Fields Sta','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.422800,-77.030700,0,'2013-07-06 12:44:31',NULL,NULL),(45936,'52338','S','Cou Falls','N','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.848730,-91.697035,0,'2013-07-06 12:44:32',NULL,NULL),(57352,'66733','S','Erie','D','Neosho','20133','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.567699,-95.244417,0,'2013-07-06 12:44:33',NULL,NULL),(57651,'67204','S','Wichita','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.752075,-97.357444,0,'2013-07-06 12:44:33',NULL,NULL),(60995,'72112','S','Ingleside','N','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.553960,-91.192500,0,'2013-07-06 12:44:33',NULL,NULL),(32636,'36203','S','Oxford','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.602111,-85.835924,0,'2013-07-06 12:44:32',NULL,NULL),(68416,'81210','S','Almont','D','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.814540,-106.659960,0,'2013-07-06 12:44:34',NULL,NULL),(34129,'38197','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.099040,-89.848207,0,'2013-07-06 12:44:32',NULL,NULL),(16262,'17088','P','Schaefferstown','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.298697,-76.299045,0,'2013-07-06 12:44:31',NULL,NULL),(31739,'34986','S','Fort Pierce','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.321528,-80.418405,0,'2013-07-06 12:44:32',NULL,NULL),(62977,'75141','S','Hutchins','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.645353,-96.707711,0,'2013-07-06 12:44:33',NULL,NULL),(65316,'77508','P','Pasadena','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.663810,-95.148185,0,'2013-07-06 12:44:34',NULL,NULL),(12313,'12858','S','Ticonderoga','A','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.894090,-73.638656,0,'2013-07-06 12:44:30',NULL,NULL),(69279,'83440','S','Sunnydell','N','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.831739,-111.783266,0,'2013-07-06 12:44:34',NULL,NULL),(44675,'50119','S','Durham','N','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.317591,-92.930643,0,'2013-07-06 12:44:32',NULL,NULL),(39838,'45159','S','New Vienna','D','Clinton','39027','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',39.342854,-83.695157,0,'2013-07-06 12:44:32',NULL,NULL),(30470,'33340','P','Fort Lauderdale','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.143611,-80.173524,0,'2013-07-06 12:44:32',NULL,NULL),(41992,'47424','S','Cincinnati','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.024720,-86.913060,0,'2013-07-06 12:44:32',NULL,NULL),(48441,'55705','S','Aurora','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.498700,-92.235780,0,'2013-07-06 12:44:33',NULL,NULL),(16802,'17543','S','Halfville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.162966,-76.293604,0,'2013-07-06 12:44:31',NULL,NULL),(76405,'95548','S','Klamath','D','Del Norte','06015','California','CA','06','0000','707','Pacific',-8.0,'Y',41.537759,-124.033969,0,'2013-07-06 12:44:34',NULL,NULL),(28801,'32062','S','Mc Alpin','D','Suwannee','12121','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.297771,-82.987534,0,'2013-07-06 12:44:32',NULL,NULL),(76631,'95713','S','Eden Valley','A','Placer','06061','California','CA','06','6920','530','Pacific',-8.0,'Y',39.088440,-120.956520,0,'2013-07-06 12:44:34',NULL,NULL),(71628,'87401','S','Farmington Municipal Airport','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.741697,-108.191411,0,'2013-07-06 12:44:34',NULL,NULL),(69598,'83850','S','Pinehurst','D','Shoshone','16079','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.538336,-116.235291,0,'2013-07-06 12:44:34',NULL,NULL),(42031,'47438','S','Jasonville','D','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.163489,-87.199212,0,'2013-07-06 12:44:32',NULL,NULL),(16025,'17042','S','Lebanon','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(24496,'27260','S','High Point','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.968678,-80.000592,0,'2013-07-06 12:44:31',NULL,NULL),(30948,'33730','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.822536,-82.827888,0,'2013-07-06 12:44:32',NULL,NULL),(10873,'11418','S','Richmond Hill','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.698520,-73.835575,0,'2013-07-06 12:44:30',NULL,NULL),(38133,'43123','S','Urbancrest','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.881816,-83.091047,0,'2013-07-06 12:44:32',NULL,NULL),(37301,'41635','S','Laynesville','N','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.492800,-82.617099,0,'2013-07-06 12:44:32',NULL,NULL),(70636,'85142','S','Queen Creek','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.228018,-111.637649,0,'2013-07-06 12:44:34',NULL,NULL),(67352,'80110','S','Greenwood Village','A','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.648960,-104.980860,0,'2013-07-06 12:44:34',NULL,NULL),(21105,'22044','S','Falls Church','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.856209,-77.157020,0,'2013-07-06 12:44:31',NULL,NULL),(55778,'64118','S','Gladstone','A','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.215793,-94.572799,0,'2013-07-06 12:44:33',NULL,NULL),(57571,'67056','S','Halstead','D','Harvey','20079','Kansas','KS','20','9040','316','Central',-6.0,'Y',38.000707,-97.509005,0,'2013-07-06 12:44:33',NULL,NULL),(13185,'13617','S','West Pierrepont','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.583780,-75.143820,0,'2013-07-06 12:44:30',NULL,NULL),(78474,'98089','P','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.393200,-122.257900,0,'2013-07-06 12:44:34',NULL,NULL),(76104,'95226','P','Valley Spgs','A','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.224462,-120.859612,0,'2013-07-06 12:44:34',NULL,NULL),(73419,'91189','U','J P Morgan','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.124070,-118.164542,0,'2013-07-06 12:44:34',NULL,NULL),(65333,'77518','S','Bacliff','D','Galveston','48167','Texas','TX','48','2920','713/281/832','Central',-6.0,'Y',29.503662,-94.988266,0,'2013-07-06 12:44:34',NULL,NULL),(52143,'60438','S','Lansing','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.567222,-87.550503,0,'2013-07-06 12:44:33',NULL,NULL),(45585,'51542','S','Honey Creek','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.476990,-95.920407,0,'2013-07-06 12:44:32',NULL,NULL),(10278,'10512','S','Kent Lakes','A','Putnam','36079','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.449121,-73.679279,0,'2013-07-06 12:44:30',NULL,NULL),(4706,'03816','S','CTR Tuftonboro','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.656557,-71.251707,0,'2013-07-06 12:44:30',NULL,NULL),(67275,'79998','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.769830,-106.428395,0,'2013-07-06 12:44:34',NULL,NULL),(43539,'48670','U','Midland','D','Midland','26111','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.636969,-84.256060,0,'2013-07-06 12:44:32',NULL,NULL),(19166,'19725','U','Newark','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.685667,-75.737283,0,'2013-07-06 12:44:31',NULL,NULL),(26668,'29386','P','White Stone','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.883365,-81.806934,0,'2013-07-06 12:44:31',NULL,NULL),(1068,'00725','S','Lomas De La Serrania','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(11833,'12243','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.653793,-73.746424,0,'2013-07-06 12:44:30',NULL,NULL),(35737,'39705','S','Columbus','D','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.505932,-88.403620,0,'2013-07-06 12:44:32',NULL,NULL),(75612,'94404','S','San Mateo','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.547930,-122.269310,0,'2013-07-06 12:44:34',NULL,NULL),(58143,'68154','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.261363,-96.115709,0,'2013-07-06 12:44:33',NULL,NULL),(57530,'67010','S','Augusta','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.691488,-96.976061,0,'2013-07-06 12:44:33',NULL,NULL),(49057,'56303','S','Sartell','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.583801,-94.203700,0,'2013-07-06 12:44:33',NULL,NULL),(17425,'17923','P','New Mines','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.674527,-76.324675,0,'2013-07-06 12:44:31',NULL,NULL),(25096,'27959','S','Nags Head','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.888575,-75.603554,0,'2013-07-06 12:44:31',NULL,NULL),(27477,'30148','S','Marblehill','N','Pickens','13227','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.455391,-84.270318,0,'2013-07-06 12:44:31',NULL,NULL),(17053,'17754','S','Bella Vista','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.257765,-76.927599,0,'2013-07-06 12:44:31',NULL,NULL),(34596,'38746','S','Perthshire','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.977222,-90.912222,0,'2013-07-06 12:44:32',NULL,NULL),(36003,'40146','S','Lodiburg','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.874100,-86.295540,0,'2013-07-06 12:44:32',NULL,NULL),(206,'00623','S','Villa Aida','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(75256,'93664','S','Shaver Lake','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.092778,-119.300445,0,'2013-07-06 12:44:34',NULL,NULL),(63791,'75958','P','Martinsville','D','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.641707,-94.413269,0,'2013-07-06 12:44:34',NULL,NULL),(24475,'27243','S','Buckhorn','N','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.069418,-79.204420,0,'2013-07-06 12:44:31',NULL,NULL),(18145,'18840','S','Athens Township','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.983124,-76.530623,0,'2013-07-06 12:44:31',NULL,NULL),(75574,'94278','U','Ca Franchise Tx Brd Brm','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.574262,-121.468927,0,'2013-07-06 12:44:34',NULL,NULL),(70427,'84731','S','Greenville','D','Beaver','49001','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.265985,-112.729199,0,'2013-07-06 12:44:34',NULL,NULL),(67469,'80221','S','Westminster','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.834420,-105.009540,0,'2013-07-06 12:44:34',NULL,NULL),(61504,'72648','S','Pruitt','N','Newton','05101','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.084759,-93.146930,0,'2013-07-06 12:44:33',NULL,NULL),(61338,'72462','P','Reyno','D','Randolph','05121','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.358163,-90.758478,0,'2013-07-06 12:44:33',NULL,NULL),(40826,'46209','U','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.744999,-86.158607,0,'2013-07-06 12:44:32',NULL,NULL),(36041,'40205','S','Kingsley','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.224111,-85.683771,0,'2013-07-06 12:44:32',NULL,NULL),(28824,'32080','S','St Augustine Beach','A','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',29.832017,-81.272761,0,'2013-07-06 12:44:32',NULL,NULL),(24201,'26679','S','Mount Nebo','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.205180,-80.821920,0,'2013-07-06 12:44:31',NULL,NULL),(22145,'23456','S','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.775899,-76.075614,0,'2013-07-06 12:44:31',NULL,NULL),(18667,'19179','U','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.032062,-75.177546,0,'2013-07-06 12:44:31',NULL,NULL),(36726,'41031','S','Lees Lick','N','Harrison','21097','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',38.391151,-84.294101,0,'2013-07-06 12:44:32',NULL,NULL),(39525,'44822','S','North Liberty','N','Richland','39139','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.583729,-82.415811,0,'2013-07-06 12:44:32',NULL,NULL),(1169,'00727','S','Urb El Valle','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(75957,'95044','P','Redwood Est','A','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.158418,-121.984871,0,'2013-07-06 12:44:34',NULL,NULL),(68564,'81435','S','Sawpit','N','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.979875,-107.941486,0,'2013-07-06 12:44:34',NULL,NULL),(65565,'77844','P','College Station','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.610719,-96.354731,0,'2013-07-06 12:44:34',NULL,NULL),(60202,'71418','S','Vixen','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(40846,'46222','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.791182,-86.212094,0,'2013-07-06 12:44:32',NULL,NULL),(28055,'30669','S','Penfld','N','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.644580,-83.085879,0,'2013-07-06 12:44:31',NULL,NULL),(1628,'00771','S','Paseo de los Artesanos','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(64050,'76131','S','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.858146,-97.330601,0,'2013-07-06 12:44:34',NULL,NULL),(59746,'71149','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.508077,-93.741235,0,'2013-07-06 12:44:33',NULL,NULL),(54185,'62626','S','Comer','A','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.282298,-89.878029,0,'2013-07-06 12:44:33',NULL,NULL),(23860,'26143','S','Stndg Stone','A','Wirt','54105','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.061962,-81.399985,0,'2013-07-06 12:44:31',NULL,NULL),(18603,'19142','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.923516,-75.233199,0,'2013-07-06 12:44:31',NULL,NULL),(29861,'33039','U','Homestead AFB','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.507761,-80.409021,0,'2013-07-06 12:44:32',NULL,NULL),(26623,'29319','U','Dennys Corporation','N','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.947178,-81.926781,0,'2013-07-06 12:44:31',NULL,NULL),(7195,'06475','S','Old Saybrook','D','Middlesex','09007','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.299740,-72.390360,0,'2013-07-06 12:44:30',NULL,NULL),(76731,'95901','S','Linda','A','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.215400,-121.463340,0,'2013-07-06 12:44:34',NULL,NULL),(61684,'72941','S','Central City','A','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.336949,-94.170533,0,'2013-07-06 12:44:33',NULL,NULL),(58313,'68439','S','Staplehurst','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.973735,-97.175172,0,'2013-07-06 12:44:33',NULL,NULL),(56708,'65673','P','Hollister','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.619201,-93.217698,0,'2013-07-06 12:44:33',NULL,NULL),(54173,'62617','S','Lynchburg','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.136329,-90.169770,0,'2013-07-06 12:44:33',NULL,NULL),(16485,'17254','P','Scotland','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.967955,-77.584588,0,'2013-07-06 12:44:31',NULL,NULL),(13444,'13775','S','East Sidney','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.340614,-75.160930,0,'2013-07-06 12:44:31',NULL,NULL),(32901,'36540','S','Gainestown','D','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.424852,-87.673723,0,'2013-07-06 12:44:32',NULL,NULL),(7385,'06778','S','Thomaston','A','Litchfield','09005','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.703300,-73.118700,0,'2013-07-06 12:44:30',NULL,NULL),(77797,'97136','S','Rockaway Bch','A','Tillamook','41057','Oregon','OR','41','0000','503/971','Pacific',-8.0,'Y',45.631500,-123.891420,0,'2013-07-06 12:44:34',NULL,NULL),(3640,'02109','S','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.367960,-71.054780,0,'2013-07-06 12:44:30',NULL,NULL),(30779,'33586','P','Sun City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.675657,-82.479102,0,'2013-07-06 12:44:32',NULL,NULL),(29331,'32547','S','Ft Walton Bch','A','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.446373,-86.626191,0,'2013-07-06 12:44:32',NULL,NULL),(11864,'12302','S','Glenville','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.856481,-73.956093,0,'2013-07-06 12:44:30',NULL,NULL),(19328,'20027','P','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.912207,-77.074325,0,'2013-07-06 12:44:31',NULL,NULL),(50478,'58046','S','Hope','D','Steele','38091','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.200020,-97.783920,0,'2013-07-06 12:44:33',NULL,NULL),(56511,'65350','S','Bahner','N','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.680224,-93.092795,0,'2013-07-06 12:44:33',NULL,NULL),(59821,'71234','S','Frost Town','N','Union','22111','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.581980,-92.345100,0,'2013-07-06 12:44:33',NULL,NULL),(63587,'75783','S','Stormville','N','Wood','48499','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.795818,-95.445299,0,'2013-07-06 12:44:34',NULL,NULL),(66541,'78729','S','Jollyville','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.456180,-97.765080,0,'2013-07-06 12:44:34',NULL,NULL),(76706,'95835','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.672191,-121.527492,0,'2013-07-06 12:44:34',NULL,NULL),(5224,'04462','S','Millinocket','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.654650,-68.702349,0,'2013-07-06 12:44:30',NULL,NULL),(67471,'80223','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.698343,-105.002952,0,'2013-07-06 12:44:34',NULL,NULL),(4471,'03262','S','North Woodstock','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.033209,-71.687240,0,'2013-07-06 12:44:30',NULL,NULL),(5100,'04348','S','Jefferson','D','Lincoln','23015','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.197758,-69.471419,0,'2013-07-06 12:44:30',NULL,NULL),(21455,'22610','S','Browntown','A','Warren','51187','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.818140,-78.258120,0,'2013-07-06 12:44:31',NULL,NULL),(33780,'37873','S','Surgoinsville','D','Hawkins','47073','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.464970,-82.824611,0,'2013-07-06 12:44:32',NULL,NULL),(368,'00659','S','Urb Las Palmas','N','Hatillo','72065','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.485446,-66.824880,0,'2013-07-06 12:44:30',NULL,NULL),(69992,'84122','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.798588,-111.960684,0,'2013-07-06 12:44:34',NULL,NULL),(60658,'71914','P','Hot Springs National','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.529159,-93.051519,0,'2013-07-06 12:44:33',NULL,NULL),(45490,'51351','S','West Okoboji','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.323480,-95.169660,0,'2013-07-06 12:44:32',NULL,NULL),(42451,'47807','S','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.473138,-87.396567,0,'2013-07-06 12:44:32',NULL,NULL),(39774,'45121','S','Georgetown','D','Brown','39015','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.876731,-83.895335,0,'2013-07-06 12:44:32',NULL,NULL),(3029,'01093','P','Whately','D','Franklin','25011','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.435682,-72.648379,0,'2013-07-06 12:44:30',NULL,NULL),(33047,'36751','S','Lower Peach Tree','D','Wilcox','01131','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.848577,-87.569570,0,'2013-07-06 12:44:32',NULL,NULL),(32223,'35574','S','Kingville','N','Lamar','01075','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.633424,-87.932980,0,'2013-07-06 12:44:32',NULL,NULL),(31511,'34464','P','Beverly Hills','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.912992,-82.463184,0,'2013-07-06 12:44:32',NULL,NULL),(8372,'08053','S','Pine Grove','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.888912,-74.911599,0,'2013-07-06 12:44:30',NULL,NULL),(16120,'17055','S','Winding Hill','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.219237,-77.001047,0,'2013-07-06 12:44:31',NULL,NULL),(79888,'99577','S','Eagle River','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.317886,-149.534978,0,'2013-07-06 12:44:34',NULL,NULL),(79339,'98620','S','Maryhill','N','Klickitat','53039','Washington','WA','53','0000','509','Pacific',-8.0,'Y',45.836346,-120.823149,0,'2013-07-06 12:44:34',NULL,NULL),(45186,'50613','S','Cedar City','N','Black Hawk','19013','Iowa','IA','19','8920','319','Central',-6.0,'Y',42.529347,-92.451306,0,'2013-07-06 12:44:32',NULL,NULL),(19354,'20047','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:31',NULL,NULL),(23387,'25309','S','South Charleston','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.339160,-81.753480,0,'2013-07-06 12:44:31',NULL,NULL),(18583,'19132','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.992702,-75.166366,0,'2013-07-06 12:44:31',NULL,NULL),(34462,'38659','S','Winborn','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.601820,-89.320920,0,'2013-07-06 12:44:32',NULL,NULL),(15612,'16682','S','Sproul','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.273208,-78.455958,0,'2013-07-06 12:44:31',NULL,NULL),(7257,'06516','S','W Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.269511,-72.964339,0,'2013-07-06 12:44:30',NULL,NULL),(77191,'96338','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(59478,'70755','S','Livonia','D','Pointe Coupee','22077','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.568384,-91.545355,0,'2013-07-06 12:44:33',NULL,NULL),(55222,'63430','S','Saint Francisville','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.357020,-91.457994,0,'2013-07-06 12:44:33',NULL,NULL),(74955,'93422','S','Atascadero','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.481363,-120.669911,0,'2013-07-06 12:44:34',NULL,NULL),(74396,'92519','P','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995480,-117.413440,0,'2013-07-06 12:44:34',NULL,NULL),(53658,'62206','S','East Saint Louis','D','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.561749,-90.161656,0,'2013-07-06 12:44:33',NULL,NULL),(53504,'62014','S','Bunker Hill','D','Macoupin','17117','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.044260,-89.951789,0,'2013-07-06 12:44:33',NULL,NULL),(52670,'61073','S','Roscoe','D','Winnebago','17201','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.423292,-88.992945,0,'2013-07-06 12:44:33',NULL,NULL),(50225,'57601','S','Foster','N','Walworth','46129','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.538190,-100.429946,0,'2013-07-06 12:44:33',NULL,NULL),(40176,'45370','S','Spring Valley','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.599468,-84.138005,0,'2013-07-06 12:44:32',NULL,NULL),(36443,'40618','U','Frankfort','D','Franklin','21073','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.179131,-84.898561,0,'2013-07-06 12:44:32',NULL,NULL),(33333,'37152','P','Ridgetop','D','Robertson','47147','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.401821,-86.771287,0,'2013-07-06 12:44:32',NULL,NULL),(31760,'34996','S','Stuart','D','Martin','12085','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.194129,-80.206393,0,'2013-07-06 12:44:32',NULL,NULL),(10373,'10590','S','Lewisboro','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.251239,-73.543589,0,'2013-07-06 12:44:30',NULL,NULL),(2488,'00956','S','Urb Royal Town','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(12893,'13332','S','Poolville','A','Chenango','36017','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.742625,-75.566682,0,'2013-07-06 12:44:30',NULL,NULL),(16725,'17407','S','York','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.938040,-76.666080,0,'2013-07-06 12:44:31',NULL,NULL),(13707,'14065','S','Freedom','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.476640,-78.316440,0,'2013-07-06 12:44:31',NULL,NULL),(75145,'93561','S','California Correctional Inst','N','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.135575,-118.527991,0,'2013-07-06 12:44:34',NULL,NULL),(74440,'92581','P','San Jacinto','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.784708,-116.959911,0,'2013-07-06 12:44:34',NULL,NULL),(69033,'83217','S','Pebble','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.742325,-111.887397,0,'2013-07-06 12:44:34',NULL,NULL),(20999,'21829','S','Girdletree','D','Worcester','24047','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.096777,-75.397397,0,'2013-07-06 12:44:31',NULL,NULL),(29179,'32361','P','Wacissa','D','Jefferson','12065','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.357349,-83.985919,0,'2013-07-06 12:44:32',NULL,NULL),(32882,'36529','S','Deer Park','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.321111,-88.188611,0,'2013-07-06 12:44:32',NULL,NULL),(2770,'00975','U','Bureau of Census','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410442,-66.065594,0,'2013-07-06 12:44:30',NULL,NULL),(75192,'93616','S','Del Rey','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.659348,-119.587883,0,'2013-07-06 12:44:34',NULL,NULL),(72618,'89418','S','Humboldt','N','Pershing','32027','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.660000,-118.140000,0,'2013-07-06 12:44:34',NULL,NULL),(66837,'79109','S','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.164304,-101.888752,0,'2013-07-06 12:44:34',NULL,NULL),(58826,'69042','S','Stockville','D','Frontier','31063','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.482959,-100.381585,0,'2013-07-06 12:44:33',NULL,NULL),(6250,'05495','S','Williston','D','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.427660,-73.087980,0,'2013-07-06 12:44:30',NULL,NULL),(28447,'31407','S','Savannah','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.166660,-81.172740,0,'2013-07-06 12:44:32',NULL,NULL),(5469,'04739','S','Quimby','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.040052,-68.589901,0,'2013-07-06 12:44:30',NULL,NULL),(41713,'47240','S','Adams','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(41753,'47283','S','Quailtown','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.175635,-85.575619,0,'2013-07-06 12:44:32',NULL,NULL),(46015,'52540','S','Germanville','N','Washington','19183','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.173994,-91.823207,0,'2013-07-06 12:44:32',NULL,NULL),(49178,'56430','P','Ah Gwah Ching','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.383439,-94.362558,0,'2013-07-06 12:44:33',NULL,NULL),(373,'00660','S','Colinas del Oeste','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(63410,'75652','S','Pinehill','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.939310,-94.961030,0,'2013-07-06 12:44:33',NULL,NULL),(57897,'67645','S','Densmore','A','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610537,-100.001449,0,'2013-07-06 12:44:33',NULL,NULL),(22728,'24363','S','Volney','A','Grayson','51077','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.612187,-81.384826,0,'2013-07-06 12:44:31',NULL,NULL),(2920,'01009','P','Bondsville','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.207963,-72.344959,0,'2013-07-06 12:44:30',NULL,NULL),(9495,'10013','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.720024,-74.003648,0,'2013-07-06 12:44:30',NULL,NULL),(25690,'28526','S','Dover','D','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.267460,-77.374020,0,'2013-07-06 12:44:31',NULL,NULL),(19356,'20049','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.894428,-77.020323,0,'2013-07-06 12:44:31',NULL,NULL),(75491,'94127','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.735401,-122.459035,0,'2013-07-06 12:44:34',NULL,NULL),(69220,'83401','S','Idaho Falls','D','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(60624,'71901','S','Euclid Heights','N','Garland','05051','Arkansas','AR','05','0000','501','Central',-6.0,'Y',34.496486,-93.032712,0,'2013-07-06 12:44:33',NULL,NULL),(60476,'71655','S','Mount Tabor','N','Drew','05043','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.624900,-91.800900,0,'2013-07-06 12:44:33',NULL,NULL),(19743,'20407','U','GSA Region 3','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884305,-77.023130,0,'2013-07-06 12:44:31',NULL,NULL),(22843,'24527','S','Blairs','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.709193,-79.377666,0,'2013-07-06 12:44:31',NULL,NULL),(39372,'44641','S','Fairhope','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.845335,-81.258482,0,'2013-07-06 12:44:32',NULL,NULL),(44617,'50060','S','Corydon','D','Wayne','19185','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.758022,-93.318743,0,'2013-07-06 12:44:32',NULL,NULL),(49240,'56472','S','Breezy Point','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.615920,-94.281420,0,'2013-07-06 12:44:33',NULL,NULL),(59692,'71073','S','Calloway Corners','N','Webster','22119','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.525220,-93.295020,0,'2013-07-06 12:44:33',NULL,NULL),(79038,'98402','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.246812,-122.440740,0,'2013-07-06 12:44:34',NULL,NULL),(75554,'94248','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.586457,-121.493033,0,'2013-07-06 12:44:34',NULL,NULL),(72723,'89502','S','Hidden Valley','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.500666,-119.765124,0,'2013-07-06 12:44:34',NULL,NULL),(70261,'84515','S','Cisco','D','Grand','49019','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.973058,-109.317915,0,'2013-07-06 12:44:34',NULL,NULL),(43223,'48310','S','Sterling Hts','A','Macomb','26099','Michigan','MI','26','2160','586','Eastern',-5.0,'Y',42.566407,-83.068010,0,'2013-07-06 12:44:32',NULL,NULL),(35831,'39771','S','Monte Vista','N','Webster','28155','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.613941,-89.366226,0,'2013-07-06 12:44:32',NULL,NULL),(30538,'33408','S','West Palm Beach','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.837511,-80.060444,0,'2013-07-06 12:44:32',NULL,NULL),(5768,'05045','S','Ely','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.916667,-72.150000,0,'2013-07-06 12:44:30',NULL,NULL),(25660,'28501','S','Kinston','D','Lenoir','37107','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.273461,-77.597639,0,'2013-07-06 12:44:31',NULL,NULL),(3362,'01570','S','Dudley Hill','A','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.052997,-71.879710,0,'2013-07-06 12:44:30',NULL,NULL),(22488,'24065','S','Boones Mill','D','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.171728,-79.962694,0,'2013-07-06 12:44:31',NULL,NULL),(21749,'23043','S','Deltaville','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.554145,-76.352965,0,'2013-07-06 12:44:31',NULL,NULL),(16068,'17049','S','Mc Alisterville','D','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.646820,-77.264520,0,'2013-07-06 12:44:31',NULL,NULL),(7140,'06408','U','Cheshire','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.498889,-72.901111,0,'2013-07-06 12:44:30',NULL,NULL),(2343,'00936','P','Santurce','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(75510,'94143','U','Uc San Francisco','N','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.763790,-122.457389,0,'2013-07-06 12:44:34',NULL,NULL),(70902,'85622','S','Green Valley','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.844512,-111.009938,0,'2013-07-06 12:44:34',NULL,NULL),(54253,'62673','S','Oakford','D','Menard','17129','Illinois','IL','17','7880','217','Central',-6.0,'Y',40.102440,-89.965555,0,'2013-07-06 12:44:33',NULL,NULL),(47310,'54555','S','Hackett','N','Price','55099','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.691966,-90.401212,0,'2013-07-06 12:44:32',NULL,NULL),(3112,'01230','S','North Egremont','A','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.183660,-73.363980,0,'2013-07-06 12:44:30',NULL,NULL),(2116,'00924','S','Alt de Berwind','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404427,-66.012462,0,'2013-07-06 12:44:30',NULL,NULL),(22734,'24375','S','Sugar Grove','D','Smyth','51173','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.771845,-81.394418,0,'2013-07-06 12:44:31',NULL,NULL),(45056,'50501','S','Tara','N','Webster','19187','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.506592,-94.176990,0,'2013-07-06 12:44:32',NULL,NULL),(46805,'54003','S','El Paso','N','Pierce','55093','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.787574,-92.441735,0,'2013-07-06 12:44:32',NULL,NULL),(1910,'00795','S','Ext del Carmen','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(79092,'98439','S','Mc Chord AFB','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.126912,-122.522573,0,'2013-07-06 12:44:34',NULL,NULL),(69774,'84058','S','Bonnie','N','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.281391,-111.698420,0,'2013-07-06 12:44:34',NULL,NULL),(68098,'80943','U','US Bank Exchange','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.837361,-104.823078,0,'2013-07-06 12:44:34',NULL,NULL),(66162,'78516','S','El Gato','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.184742,-98.117053,0,'2013-07-06 12:44:34',NULL,NULL),(61459,'72626','S','Cotter','D','Baxter','05005','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.319081,-92.534547,0,'2013-07-06 12:44:33',NULL,NULL),(59190,'70360','S','Bayou Blue','N','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.607360,-90.782400,0,'2013-07-06 12:44:33',NULL,NULL),(50723,'58379','P','Tokio','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.921485,-98.817673,0,'2013-07-06 12:44:33',NULL,NULL),(20554,'21123','P','Lake Shore','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.111974,-76.553563,0,'2013-07-06 12:44:31',NULL,NULL),(20650,'21225','S','Baltimore','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.230400,-76.617360,0,'2013-07-06 12:44:31',NULL,NULL),(24182,'26629','S','Little Birch','D','Braxton','54007','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.565848,-80.708460,0,'2013-07-06 12:44:31',NULL,NULL),(38487,'43661','U','Champion Spark Plug','N','Lucas','39095','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.652881,-83.604687,0,'2013-07-06 12:44:32',NULL,NULL),(53452,'61911','S','Arthur','D','Douglas','17041','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.703333,-88.391111,0,'2013-07-06 12:44:33',NULL,NULL),(53192,'61607','S','Tuscarora','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(35808,'39759','S','Longview','N','Oktibbeha','28105','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.434520,-88.835340,0,'2013-07-06 12:44:32',NULL,NULL),(27933,'30522','S','Cherry Log','D','Gilmer','13123','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.612755,-84.531737,0,'2013-07-06 12:44:31',NULL,NULL),(32405,'35961','S','Collinsville','D','DeKalb','01049','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.307986,-85.834569,0,'2013-07-06 12:44:32',NULL,NULL),(10694,'11219','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.631209,-73.998416,0,'2013-07-06 12:44:30',NULL,NULL),(79147,'98501','S','Thompson Place','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.990860,-122.873880,0,'2013-07-06 12:44:34',NULL,NULL),(77852,'97225','S','West Slope','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.501041,-122.761269,0,'2013-07-06 12:44:34',NULL,NULL),(73946,'92055','S','Marine Corp Base','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.291239,-117.301241,0,'2013-07-06 12:44:34',NULL,NULL),(73680,'91602','S','Studio City','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(61624,'72828','S','Briggsville','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.946389,-93.405278,0,'2013-07-06 12:44:33',NULL,NULL),(56371,'65217','U','Columbia','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.897983,-92.333640,0,'2013-07-06 12:44:33',NULL,NULL),(55960,'64496','S','Watson','D','Atchison','29005','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.481889,-95.627340,0,'2013-07-06 12:44:33',NULL,NULL),(49770,'57070','S','Center Point','N','Turner','46125','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.189920,-97.116960,0,'2013-07-06 12:44:33',NULL,NULL),(27793,'30385','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.674395,-84.441613,0,'2013-07-06 12:44:31',NULL,NULL),(30206,'33182','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.778250,-80.414948,0,'2013-07-06 12:44:32',NULL,NULL),(28210,'31028','S','Centerville','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.629036,-83.677182,0,'2013-07-06 12:44:31',NULL,NULL),(36550,'40906','S','Jarvis','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(41330,'46778','P','Petroleum','D','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.612239,-85.148995,0,'2013-07-06 12:44:32',NULL,NULL),(46512,'53263','U','JC Penney','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.084119,-88.035945,0,'2013-07-06 12:44:32',NULL,NULL),(65110,'77372','S','Patton Village','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.220286,-95.158358,0,'2013-07-06 12:44:34',NULL,NULL),(60463,'71653','S','Shives','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.330484,-91.284186,0,'2013-07-06 12:44:33',NULL,NULL),(37215,'41528','S','Board Tree','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.543483,-82.135640,0,'2013-07-06 12:44:32',NULL,NULL),(5110,'04355','S','Readfield','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.406716,-69.939412,0,'2013-07-06 12:44:30',NULL,NULL),(5363,'04623','S','Columbia Fls','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.707438,-67.773645,0,'2013-07-06 12:44:30',NULL,NULL),(68064,'80934','P','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.844726,-104.860092,0,'2013-07-06 12:44:34',NULL,NULL),(38330,'43432','S','Elliston','A','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.557515,-83.242620,0,'2013-07-06 12:44:32',NULL,NULL),(17831,'18417','S','Equinunk','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.796512,-75.208840,0,'2013-07-06 12:44:31',NULL,NULL),(18903,'19477','S','North Wales','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.210833,-75.278611,0,'2013-07-06 12:44:31',NULL,NULL),(20515,'21085','S','Joppatowne','N','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.431754,-76.355815,0,'2013-07-06 12:44:31',NULL,NULL),(20892,'21704','S','Urbana','A','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.373967,-77.390459,0,'2013-07-06 12:44:31',NULL,NULL),(30203,'33181','S','Nmb','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.902791,-80.151290,0,'2013-07-06 12:44:32',NULL,NULL),(32695,'36276','S','Goldville','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(70,'00612','S','Bo Santana','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(77368,'96746','S','Kapaa','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',22.078817,-159.350070,0,'2013-07-06 12:44:34',NULL,NULL),(60336,'71465','S','Olla','D','La Salle','22059','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.907286,-92.223113,0,'2013-07-06 12:44:33',NULL,NULL),(45334,'50861','S','Shannon City','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.939500,-94.239358,0,'2013-07-06 12:44:32',NULL,NULL),(24781,'27569','S','Princeton','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.464515,-78.162907,0,'2013-07-06 12:44:31',NULL,NULL),(13298,'13668','S','Hewittville','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.762820,-74.991240,0,'2013-07-06 12:44:30',NULL,NULL),(3740,'02169','S','Houghs Neck','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.240464,-71.014144,0,'2013-07-06 12:44:30',NULL,NULL),(65370,'77538','S','Devers','D','Liberty','48291','Texas','TX','48','3360','936','Central',-6.0,'Y',29.992347,-94.529977,0,'2013-07-06 12:44:34',NULL,NULL),(63099,'75265','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.743228,-97.001090,0,'2013-07-06 12:44:33',NULL,NULL),(60198,'71418','S','Hearn Island','N','Caldwell','22021','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.128860,-92.153760,0,'2013-07-06 12:44:33',NULL,NULL),(55274,'63465','S','Peaksville','N','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.495020,-91.677480,0,'2013-07-06 12:44:33',NULL,NULL),(53671,'62215','S','Damiansville','A','Clinton','17027','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.510000,-89.619444,0,'2013-07-06 12:44:33',NULL,NULL),(41095,'46545','S','Mishawaka','D','St Joseph','18141','Indiana','IN','18','7800','574','Eastern',-5.0,'Y',41.680563,-86.160151,0,'2013-07-06 12:44:32',NULL,NULL),(24686,'27413','U','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.068728,-79.810276,0,'2013-07-06 12:44:31',NULL,NULL),(28425,'31331','S','Cox','N','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(3167,'01267','S','Williamstown','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.699457,-73.210225,0,'2013-07-06 12:44:30',NULL,NULL),(30899,'33706','S','Pass A Grille Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(73893,'91979','P','Spring Valley','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.733520,-116.973098,0,'2013-07-06 12:44:34',NULL,NULL),(59466,'70739','S','Greenwell Springs','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.539595,-91.000712,0,'2013-07-06 12:44:33',NULL,NULL),(56893,'66041','S','Lancaster','D','Atchison','20005','Kansas','KS','20','0000','913','Central',-6.0,'Y',39.603120,-95.325900,0,'2013-07-06 12:44:33',NULL,NULL),(53311,'61739','S','Avoca','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.747916,-88.513741,0,'2013-07-06 12:44:33',NULL,NULL),(51524,'59711','S','Georgetown','N','Deer Lodge','30023','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.139820,-113.045940,0,'2013-07-06 12:44:33',NULL,NULL),(36528,'40849','P','Lejunior','D','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.918266,-83.181917,0,'2013-07-06 12:44:32',NULL,NULL),(17281,'17846','S','Iola','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.135280,-76.519320,0,'2013-07-06 12:44:31',NULL,NULL),(35023,'39156','S','Redwood','D','Warren','28149','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.422033,-90.816785,0,'2013-07-06 12:44:32',NULL,NULL),(27562,'30263','S','Newnan','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.393182,-84.823447,0,'2013-07-06 12:44:31',NULL,NULL),(65195,'77426','S','Chappell Hill','D','Washington','48477','Texas','TX','48','0000','979','Central',-6.0,'Y',30.052487,-96.206760,0,'2013-07-06 12:44:34',NULL,NULL),(55066,'63166','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.630444,-90.217497,0,'2013-07-06 12:44:33',NULL,NULL),(45913,'52323','S','Oxford Jct','A','Jones','19105','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.989991,-90.978487,0,'2013-07-06 12:44:32',NULL,NULL),(42548,'47871','P','Riley','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.387755,-87.301153,0,'2013-07-06 12:44:32',NULL,NULL),(69399,'83617','S','Emmett','D','Gem','16045','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.896900,-116.502780,0,'2013-07-06 12:44:34',NULL,NULL),(69047,'83227','S','Clayton','D','Custer','16037','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.298351,-114.409180,0,'2013-07-06 12:44:34',NULL,NULL),(64732,'76886','P','Veribest','D','Tom Green','48451','Texas','TX','48','7200','325','Central',-6.0,'Y',31.352852,-100.495041,0,'2013-07-06 12:44:34',NULL,NULL),(16029,'17042','S','Rocherty','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(17474,'17948','S','Wiggans','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.809592,-76.138532,0,'2013-07-06 12:44:31',NULL,NULL),(25093,'27956','S','Maple','D','Currituck','37053','North Carolina','NC','37','5720','252','Eastern',-5.0,'Y',36.391755,-76.003521,0,'2013-07-06 12:44:31',NULL,NULL),(8127,'07828','S','Mount Olive','N','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.886645,-74.751763,0,'2013-07-06 12:44:30',NULL,NULL),(55746,'64098','S','Weston','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.461895,-94.911413,0,'2013-07-06 12:44:33',NULL,NULL),(50615,'58261','S','Ardoch','A','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.291130,-97.372047,0,'2013-07-06 12:44:33',NULL,NULL),(3247,'01434','S','Ayer','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.560949,-71.576624,0,'2013-07-06 12:44:30',NULL,NULL),(6818,'06111','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.688552,-72.729085,0,'2013-07-06 12:44:30',NULL,NULL),(1850,'00791','S','Bda Obrera','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(552,'00677','S','Urb Cerro Los Pobres','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(32097,'35295','U','AL Gas Corp','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.511347,-86.804838,0,'2013-07-06 12:44:32',NULL,NULL),(1197,'00728','S','Hacienda Las Lomas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(6764,'06094','P','Winchester Center','D','Litchfield','09005','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.901881,-73.142301,0,'2013-07-06 12:44:30',NULL,NULL),(76803,'95946','S','Penn Valley','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.216172,-121.194087,0,'2013-07-06 12:44:34',NULL,NULL),(75982,'95067','P','Scotts Valley','D','Santa Cruz','06087','California','CA','06','7485','831','Pacific',-8.0,'Y',36.974167,-122.029722,0,'2013-07-06 12:44:34',NULL,NULL),(70986,'85708','S','Tucson','D','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.184649,-110.865478,0,'2013-07-06 12:44:34',NULL,NULL),(11935,'12431','S','Freehold','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.377411,-74.056683,0,'2013-07-06 12:44:30',NULL,NULL),(32930,'36560','S','Chastang','N','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',31.069380,-88.053120,0,'2013-07-06 12:44:32',NULL,NULL),(12753,'13205','S','Syracuse','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.006472,-76.148241,0,'2013-07-06 12:44:30',NULL,NULL),(24233,'26750','S','Piedmont','D','Mineral','54057','West Virginia','WV','54','1900','304/681','Eastern',-5.0,'Y',39.508294,-78.995394,0,'2013-07-06 12:44:31',NULL,NULL),(41072,'46517','S','Dunlap','N','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.622360,-85.983780,0,'2013-07-06 12:44:32',NULL,NULL),(42636,'47920','S','Battle Ground','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.524602,-86.827766,0,'2013-07-06 12:44:32',NULL,NULL),(48237,'55421','S','Saint Anthony','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.051120,-93.244380,0,'2013-07-06 12:44:33',NULL,NULL),(49411,'56628','S','Stokes','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.766250,-93.707164,0,'2013-07-06 12:44:33',NULL,NULL),(50559,'58208','P','Grand Forks','D','Grand Forks','38035','North Dakota','ND','38','2985','701','Central',-6.0,'Y',47.880381,-97.062167,0,'2013-07-06 12:44:33',NULL,NULL),(57041,'66209','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.900603,-94.632767,0,'2013-07-06 12:44:33',NULL,NULL),(65481,'77640','S','West Port Arthur','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(7944,'07666','S','Teaneck','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.891901,-74.008379,0,'2013-07-06 12:44:30',NULL,NULL),(70237,'84405','S','Riverdale','A','Weber','49057','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.180942,-111.970409,0,'2013-07-06 12:44:34',NULL,NULL),(68682,'82006','U','WY State Game And Fish','N','Laramie','56021','Wyoming','WY','56','1580','307','Mountain',-7.0,'Y',41.404407,-104.857277,0,'2013-07-06 12:44:34',NULL,NULL),(68381,'81144','S','Sargents School','N','Rio Grande','08105','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.566562,-106.148089,0,'2013-07-06 12:44:34',NULL,NULL),(1595,'00769','S','Parc Niagara','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(4553,'03456','S','Marlow','D','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.130345,-72.215803,0,'2013-07-06 12:44:30',NULL,NULL),(5043,'04263','S','Leeds','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.296106,-70.129879,0,'2013-07-06 12:44:30',NULL,NULL),(11459,'12008','S','Alplaus','D','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.854388,-73.904169,0,'2013-07-06 12:44:30',NULL,NULL),(42423,'47802','S','Spring Hill Estates','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(47462,'54733','S','Dallas','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.262056,-91.842404,0,'2013-07-06 12:44:32',NULL,NULL),(6141,'05464','S','Jeffersonvlle','A','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663827,-72.783702,0,'2013-07-06 12:44:30',NULL,NULL),(73273,'90732','S','San Pedro','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.764107,-118.303038,0,'2013-07-06 12:44:34',NULL,NULL),(63624,'75835','S','Belott','N','Houston','48225','Texas','TX','48','0000','936','Central',-6.0,'Y',31.270556,-95.608889,0,'2013-07-06 12:44:34',NULL,NULL),(57231,'66510','S','Melvern','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.506646,-95.635334,0,'2013-07-06 12:44:33',NULL,NULL),(49605,'56759','S','Strathcona','D','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.623727,-96.114734,0,'2013-07-06 12:44:33',NULL,NULL),(32696,'36276','S','Levelroad','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.152100,-85.561800,0,'2013-07-06 12:44:32',NULL,NULL),(27876,'30449','P','Oliver','D','Screven','13251','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.521207,-81.531318,0,'2013-07-06 12:44:31',NULL,NULL),(29442,'32696','S','Williston','D','Levy','12075','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.388078,-82.453512,0,'2013-07-06 12:44:32',NULL,NULL),(28543,'31556','P','Offerman','D','Pierce','13229','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.406251,-82.112871,0,'2013-07-06 12:44:32',NULL,NULL),(40285,'45439','S','West Carrollton','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.699058,-84.219886,0,'2013-07-06 12:44:32',NULL,NULL),(79164,'98511','P','Tumwater','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.039781,-122.900904,0,'2013-07-06 12:44:34',NULL,NULL),(77379,'96756','S','Koloa','D','Kauai','15007','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',21.907994,-159.489037,0,'2013-07-06 12:44:34',NULL,NULL),(60110,'71366','S','Saint Joseph','D','Tensas','22107','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.915830,-91.239809,0,'2013-07-06 12:44:33',NULL,NULL),(53777,'62275','S','Baden Baden','N','Bond','17005','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.770822,-89.501779,0,'2013-07-06 12:44:33',NULL,NULL),(41530,'46991','S','Landess','N','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.626360,-85.495440,0,'2013-07-06 12:44:32',NULL,NULL),(6841,'06119','S','W Hartford','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.760843,-72.729064,0,'2013-07-06 12:44:30',NULL,NULL),(16761,'17519','S','Cedar Lane','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.127373,-76.024073,0,'2013-07-06 12:44:31',NULL,NULL),(14703,'15262','U','Mellon Bank','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.473575,-79.988919,0,'2013-07-06 12:44:31',NULL,NULL),(2787,'00976','S','Terr de Cupey','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(78029,'97429','S','Days Creek','D','Douglas','41019','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.980125,-123.101768,0,'2013-07-06 12:44:34',NULL,NULL),(77735,'97071','S','Monitor','N','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',45.147450,-122.855971,0,'2013-07-06 12:44:34',NULL,NULL),(73349,'91008','S','Bradbury','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.152274,-117.968170,0,'2013-07-06 12:44:34',NULL,NULL),(62128,'73663','S','Seiling','D','Dewey','40043','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.141917,-98.927264,0,'2013-07-06 12:44:33',NULL,NULL),(34965,'39074','S','Forest','D','Scott','28123','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.363909,-89.473080,0,'2013-07-06 12:44:32',NULL,NULL),(20061,'20670','S','Patuxent River Naval Air Sta','N','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.281107,-76.420424,0,'2013-07-06 12:44:31',NULL,NULL),(37431,'41826','S','Jeremiah','D','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.163934,-82.933262,0,'2013-07-06 12:44:32',NULL,NULL),(40050,'45263','U','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.107980,-84.534184,0,'2013-07-06 12:44:32',NULL,NULL),(41902,'47371','S','Powers','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.429380,-84.998580,0,'2013-07-06 12:44:32',NULL,NULL),(50334,'57732','S','Roubaix','N','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.275833,-103.665833,0,'2013-07-06 12:44:33',NULL,NULL),(56058,'64742','S','Drexel','D','Bates','29013','Missouri','MO','29','0000','816/975','Central',-6.0,'Y',38.479745,-94.607715,0,'2013-07-06 12:44:33',NULL,NULL),(56852,'65899','U','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.150347,-93.248417,0,'2013-07-06 12:44:33',NULL,NULL),(1202,'00728','S','Parc Nueva Vida','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(72754,'89510','S','Sutcliffe','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.770408,-119.617338,0,'2013-07-06 12:44:34',NULL,NULL),(72025,'88049','S','Mimbres','D','Grant','35017','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.867754,-107.966597,0,'2013-07-06 12:44:34',NULL,NULL),(59375,'70596','P','Lafayette','D','Lafayette','22055','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.220320,-92.017052,0,'2013-07-06 12:44:33',NULL,NULL),(64307,'76465','P','Morgan Mill','D','Erath','48143','Texas','TX','48','0000','254','Central',-6.0,'Y',32.387195,-98.165449,0,'2013-07-06 12:44:34',NULL,NULL),(78397,'98033','S','Kirkland','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.687703,-122.192053,0,'2013-07-06 12:44:34',NULL,NULL),(42520,'47853','P','Harmony','D','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.576142,-87.056265,0,'2013-07-06 12:44:32',NULL,NULL),(10595,'11040','S','Garden City P','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(22538,'24121','S','Moneta','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.100237,-79.662578,0,'2013-07-06 12:44:31',NULL,NULL),(10646,'11101','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.748470,-73.939180,0,'2013-07-06 12:44:30',NULL,NULL),(1464,'00745','S','Urb Cambalache I','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(53379,'61791','U','3 State Farm Plaza','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.474272,-88.955768,0,'2013-07-06 12:44:33',NULL,NULL),(21199,'22192','S','Woodbridge','D','Prince William','51153','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.680010,-77.309022,0,'2013-07-06 12:44:31',NULL,NULL),(27327,'30032','S','Dunaire','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.735464,-84.266983,0,'2013-07-06 12:44:31',NULL,NULL),(860,'00698','S','Urb El Rocio','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(11195,'11740','S','Greenlawn','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.859896,-73.362616,0,'2013-07-06 12:44:30',NULL,NULL),(3996,'02540','S','Falmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.563155,-70.626053,0,'2013-07-06 12:44:30',NULL,NULL),(77273,'96607','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(75881,'94954','S','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.253709,-122.613700,0,'2013-07-06 12:44:34',NULL,NULL),(68709,'82063','S','Woods Landing','N','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',40.912373,-105.868056,0,'2013-07-06 12:44:34',NULL,NULL),(50659,'58329','S','Dunseith','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.815206,-100.062160,0,'2013-07-06 12:44:33',NULL,NULL),(20344,'20855','S','Derwood','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.145020,-77.137560,0,'2013-07-06 12:44:31',NULL,NULL),(1056,'00725','S','Bosques De La Sierra','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(30483,'33351','S','Lauderhill','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.177671,-80.275118,0,'2013-07-06 12:44:32',NULL,NULL),(80056,'99711','P','Fairbanks','D','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.818214,-147.567698,0,'2013-07-06 12:44:34',NULL,NULL),(74645,'92823','S','Brea','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.922954,-117.797999,0,'2013-07-06 12:44:34',NULL,NULL),(67556,'80273','U','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.727577,-104.988288,0,'2013-07-06 12:44:34',NULL,NULL),(64699,'76852','S','Waldrip','N','McCulloch','48307','Texas','TX','48','0000','325','Central',-6.0,'Y',31.340312,-99.380947,0,'2013-07-06 12:44:34',NULL,NULL),(3404,'01701','S','Framingham Center','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.315117,-71.434120,0,'2013-07-06 12:44:30',NULL,NULL),(30066,'33152','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.797522,-80.313487,0,'2013-07-06 12:44:32',NULL,NULL),(37896,'42629','S','Rowena','A','Russell','21207','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.976422,-85.093378,0,'2013-07-06 12:44:32',NULL,NULL),(44845,'50266','S','W Des Moines','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.586600,-93.765743,0,'2013-07-06 12:44:32',NULL,NULL),(45296,'50801','S','Creston','D','Union','19175','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.057460,-94.403400,0,'2013-07-06 12:44:32',NULL,NULL),(48491,'55734','S','Eveleth','D','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.431510,-92.516556,0,'2013-07-06 12:44:33',NULL,NULL),(58350,'68505','S','Bethany','N','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.839250,-96.624615,0,'2013-07-06 12:44:33',NULL,NULL),(187,'00623','S','Qtas de Cabo Rojo','N','Cabo Rojo','72023','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.086721,-67.151780,0,'2013-07-06 12:44:30',NULL,NULL),(44660,'50108','S','Grand River','D','Decatur','19053','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.809211,-93.958622,0,'2013-07-06 12:44:32',NULL,NULL),(43947,'49301','S','Cascade','N','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.955202,-85.471385,0,'2013-07-06 12:44:32',NULL,NULL),(25950,'28657','S','Hughes','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(18507,'19102','S','Mid City East','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.952547,-75.163950,0,'2013-07-06 12:44:31',NULL,NULL),(4064,'02647','P','Hyannis Port','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.636204,-70.309762,0,'2013-07-06 12:44:30',NULL,NULL),(6862,'06133','P','Elmwood','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.753216,-72.704041,0,'2013-07-06 12:44:30',NULL,NULL),(73220,'90631','S','La Habra','D','Orange','06059','California','CA','06','5945','562','Pacific',-8.0,'Y',33.941040,-117.954420,0,'2013-07-06 12:44:34',NULL,NULL),(62372,'74075','S','Stillwater','D','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.140565,-97.061624,0,'2013-07-06 12:44:33',NULL,NULL),(58768,'68967','S','Reuben','N','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.251107,-99.635999,0,'2013-07-06 12:44:33',NULL,NULL),(54059,'62474','S','Westfield','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.454400,-87.997271,0,'2013-07-06 12:44:33',NULL,NULL),(52931,'61375','S','Varna','D','Marshall','17123','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.064923,-89.260460,0,'2013-07-06 12:44:33',NULL,NULL),(50340,'57735','S','Provo','A','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.296010,-103.829609,0,'2013-07-06 12:44:33',NULL,NULL),(34690,'38828','S','Cherrycreek','N','Union','28145','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.426680,-88.868700,0,'2013-07-06 12:44:32',NULL,NULL),(34336,'38569','S','Lancaster','D','Smith','47159','Tennessee','TN','47','0000','615','Central',-6.0,'Y',36.098310,-85.847416,0,'2013-07-06 12:44:32',NULL,NULL),(11268,'11770','P','Ocean Bay Park','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.647098,-73.151777,0,'2013-07-06 12:44:30',NULL,NULL),(10493,'10960','S','Grandview on Hudson','N','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.093680,-73.932130,0,'2013-07-06 12:44:30',NULL,NULL),(28586,'31635','S','Lakeland','D','Lanier','13173','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.039688,-83.071992,0,'2013-07-06 12:44:32',NULL,NULL),(21313,'22406','S','Fredbg','N','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.380437,-77.534307,0,'2013-07-06 12:44:31',NULL,NULL),(3623,'02061','S','Norwell','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.156831,-70.821267,0,'2013-07-06 12:44:30',NULL,NULL),(40589,'45877','S','Pandora','D','Putnam','39137','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.948816,-83.953667,0,'2013-07-06 12:44:32',NULL,NULL),(41181,'46714','S','Murray','N','Wells','18179','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.718760,-85.194840,0,'2013-07-06 12:44:32',NULL,NULL),(41972,'47421','S','Brook Knoll','N','Lawrence','18093','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.863336,-86.490428,0,'2013-07-06 12:44:32',NULL,NULL),(67771,'80643','S','Keenesburg','D','Weld','08123','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.096167,-104.505829,0,'2013-07-06 12:44:34',NULL,NULL),(61012,'72114','S','Veterans Admin Fac','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(51878,'60086','U','Selective Service','N','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.320270,-87.859647,0,'2013-07-06 12:44:33',NULL,NULL),(49301,'56531','S','Erdahl','N','Grant','27051','Minnesota','MN','27','0000','218','Central',-6.0,'Y',45.994893,-95.969068,0,'2013-07-06 12:44:33',NULL,NULL),(48206,'55405','S','Minneapolis','D','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.974363,-93.305344,0,'2013-07-06 12:44:33',NULL,NULL),(39902,'45215','S','Woodlawn','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.191220,-84.461520,0,'2013-07-06 12:44:32',NULL,NULL),(37219,'41534','S','Hellier','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.286063,-82.473270,0,'2013-07-06 12:44:32',NULL,NULL),(33888,'38028','S','Eads','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.156132,-89.682958,0,'2013-07-06 12:44:32',NULL,NULL),(11305,'11779','S','Lake Ronkonkoma','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.818120,-73.120800,0,'2013-07-06 12:44:30',NULL,NULL),(9364,'09822','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(20679,'21235','U','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.309564,-76.728397,0,'2013-07-06 12:44:31',NULL,NULL),(20481,'21044','S','Columbia','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.212981,-76.882253,0,'2013-07-06 12:44:31',NULL,NULL),(35892,'40006','S','Bedford','D','Trimble','21223','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.582109,-85.314240,0,'2013-07-06 12:44:32',NULL,NULL),(79516,'98933','S','Harrah','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.389211,-120.510324,0,'2013-07-06 12:44:34',NULL,NULL),(76642,'95720','S','Silver Fork','N','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.757517,-120.199076,0,'2013-07-06 12:44:34',NULL,NULL),(67006,'79512','S','Colorado City','D','Mitchell','48335','Texas','TX','48','0000','325','Central',-6.0,'Y',32.394374,-100.859048,0,'2013-07-06 12:44:34',NULL,NULL),(62245,'74003','S','Brtlsville','N','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.737880,-96.005400,0,'2013-07-06 12:44:33',NULL,NULL),(49682,'57017','S','Colman','D','Moody','46101','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.984490,-96.813250,0,'2013-07-06 12:44:33',NULL,NULL),(36194,'40258','S','Pleasure Ridge Park','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.142310,-85.861886,0,'2013-07-06 12:44:32',NULL,NULL),(20920,'21738','S','Glenwood','D','Howard','24027','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.278191,-77.016131,0,'2013-07-06 12:44:31',NULL,NULL),(28297,'31098','S','Warner Robins','D','Houston','13153','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.611973,-83.596726,0,'2013-07-06 12:44:31',NULL,NULL),(59288,'70469','P','Slidell','D','Saint Tammany','22103','Louisiana','LA','22','5560','985','Central',-6.0,'Y',30.280259,-89.776565,0,'2013-07-06 12:44:33',NULL,NULL),(54043,'62466','S','Sumner','D','Lawrence','17101','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.730600,-87.772380,0,'2013-07-06 12:44:33',NULL,NULL),(25701,'28533','S','Cherry Point Marine Corps AI','N','Craven','37049','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.878889,-76.901667,0,'2013-07-06 12:44:31',NULL,NULL),(29574,'32818','S','Hiawassee','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.577550,-81.496134,0,'2013-07-06 12:44:32',NULL,NULL),(14444,'15095','P','Warrendale','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.643305,-80.109507,0,'2013-07-06 12:44:31',NULL,NULL),(34708,'38833','S','Leedy','N','Tishomingo','28141','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.890120,-88.309221,0,'2013-07-06 12:44:32',NULL,NULL),(121,'00612','S','Urb Zeno Gandia','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(78414,'98042','S','Kent','D','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.376480,-122.099400,0,'2013-07-06 12:44:34',NULL,NULL),(73847,'91801','S','Alhambra','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.089881,-118.129539,0,'2013-07-06 12:44:34',NULL,NULL),(71068,'85901','S','Show Low','D','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.241520,-110.077320,0,'2013-07-06 12:44:34',NULL,NULL),(66571,'78738','S','Vlg O the Hls','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.319171,-97.937460,0,'2013-07-06 12:44:34',NULL,NULL),(54530,'62880','S','St Paul','N','Fayette','17051','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.868041,-88.865839,0,'2013-07-06 12:44:33',NULL,NULL),(51146,'58844','S','Colgan','A','Divide','38023','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.948333,-103.627778,0,'2013-07-06 12:44:33',NULL,NULL),(50506,'58069','S','Stirum','D','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.245831,-97.645578,0,'2013-07-06 12:44:33',NULL,NULL),(47399,'54643','P','Millston','D','Jackson','55053','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.192529,-90.649360,0,'2013-07-06 12:44:32',NULL,NULL),(42389,'47725','S','Evansville','D','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',37.974596,-87.555538,0,'2013-07-06 12:44:32',NULL,NULL),(38646,'43937','P','Blainesville','N','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.130903,-80.879039,0,'2013-07-06 12:44:32',NULL,NULL),(6743,'06082','S','Enfield','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.986942,-72.565275,0,'2013-07-06 12:44:30',NULL,NULL),(1332,'00736','S','Bda Vieques','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(4587,'03580','S','Franconia','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.228548,-71.749886,0,'2013-07-06 12:44:30',NULL,NULL),(33193,'37037','S','Christiana','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.712477,-86.364445,0,'2013-07-06 12:44:32',NULL,NULL),(30986,'33759','S','Clearwater','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.979517,-82.718245,0,'2013-07-06 12:44:32',NULL,NULL),(20796,'21550','S','Loch Lyn Hght','A','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.337920,-79.402320,0,'2013-07-06 12:44:31',NULL,NULL),(29770,'33010','S','Hialeah','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.828980,-80.285640,0,'2013-07-06 12:44:32',NULL,NULL),(27392,'30084','S','Tucker','D','DeKalb','13089','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.848103,-84.226117,0,'2013-07-06 12:44:31',NULL,NULL),(51852,'60073','S','Round Lake Heights','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.351780,-88.092480,0,'2013-07-06 12:44:33',NULL,NULL),(55003,'63131','S','Crystal Lake Park','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(56200,'65024','S','Chamois','D','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.664240,-91.769160,0,'2013-07-06 12:44:33',NULL,NULL),(60867,'72058','S','Greenbrier','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.219280,-92.324100,0,'2013-07-06 12:44:33',NULL,NULL),(62899,'75068','S','Lakewood Village','A','Denton','48121','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.168674,-96.961589,0,'2013-07-06 12:44:33',NULL,NULL),(70494,'84773','S','Teasdale','D','Wayne','49055','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.283757,-111.472299,0,'2013-07-06 12:44:34',NULL,NULL),(72305,'88586','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.766467,-106.332762,0,'2013-07-06 12:44:34',NULL,NULL),(73903,'92009','S','Carlsbad','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.099272,-117.270924,0,'2013-07-06 12:44:34',NULL,NULL),(12430,'12953','S','Duane','N','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.845371,-74.269912,0,'2013-07-06 12:44:30',NULL,NULL),(78584,'98177','S','Richmond Beach','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.743958,-122.369875,0,'2013-07-06 12:44:34',NULL,NULL),(73430,'91208','S','Glendale','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.191213,-118.231522,0,'2013-07-06 12:44:34',NULL,NULL),(19220,'19895','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743840,-75.549474,0,'2013-07-06 12:44:31',NULL,NULL),(35328,'39428','S','Hot Coffee','N','Covington','28031','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.652280,-89.557320,0,'2013-07-06 12:44:32',NULL,NULL),(12776,'13212','S','Syr','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.110960,-76.139280,0,'2013-07-06 12:44:30',NULL,NULL),(31765,'35006','S','Adger','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.443940,-87.202920,0,'2013-07-06 12:44:32',NULL,NULL),(27611,'30304','S','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.651549,-84.394247,0,'2013-07-06 12:44:31',NULL,NULL),(1855,'00791','S','Ext Cotto Mabu','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(80093,'99744','P','Nenana','A','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.293059,-149.128347,0,'2013-07-06 12:44:34',NULL,NULL),(79169,'98516','S','Lacey','A','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.065090,-122.793039,0,'2013-07-06 12:44:34',NULL,NULL),(73589,'91385','P','Valencia','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.389797,-118.558445,0,'2013-07-06 12:44:34',NULL,NULL),(66763,'79016','U','West Texas A&M University','N','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',34.979592,-101.929451,0,'2013-07-06 12:44:34',NULL,NULL),(64932,'77216','U','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.615732,-95.216522,0,'2013-07-06 12:44:34',NULL,NULL),(61371,'72521','S','Cave City','D','Sharp','05135','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.894197,-91.503465,0,'2013-07-06 12:44:33',NULL,NULL),(17041,'17748','P','Youngdale','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.149722,-77.365556,0,'2013-07-06 12:44:31',NULL,NULL),(31990,'35221','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.454994,-86.895854,0,'2013-07-06 12:44:32',NULL,NULL),(31433,'34267','P','Ft Ogden','N','DeSoto','12027','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.087121,-81.954404,0,'2013-07-06 12:44:32',NULL,NULL),(20154,'20737','S','Riverdale Park','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.959262,-76.920047,0,'2013-07-06 12:44:31',NULL,NULL),(36095,'40219','S','South Park View','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.143260,-85.695780,0,'2013-07-06 12:44:32',NULL,NULL),(29536,'32792','S','Aloma','A','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.595103,-81.304723,0,'2013-07-06 12:44:32',NULL,NULL),(48368,'55557','P','Young America','D','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.813910,-93.920574,0,'2013-07-06 12:44:33',NULL,NULL),(56839,'65809','S','Springfield','D','Greene','29077','Missouri','MO','29','7920','417','Central',-6.0,'Y',37.176716,-93.207149,0,'2013-07-06 12:44:33',NULL,NULL),(77053,'96115','S','Lake City','D','Modoc','06049','California','CA','06','0000','530','Pacific',-8.0,'Y',41.718144,-120.190248,0,'2013-07-06 12:44:34',NULL,NULL),(65819,'78147','P','Poth','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.035954,-98.100932,0,'2013-07-06 12:44:34',NULL,NULL),(56988,'66202','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(55325,'63545','S','Pennville','N','Sullivan','29211','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.266332,-92.952465,0,'2013-07-06 12:44:33',NULL,NULL),(38959,'44127','S','Newburgh Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472030,-81.650481,0,'2013-07-06 12:44:32',NULL,NULL),(38084,'43073','P','Pataskala','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.001966,-82.751027,0,'2013-07-06 12:44:32',NULL,NULL),(14352,'15012','S','North Belle Vernon','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.122188,-79.844637,0,'2013-07-06 12:44:31',NULL,NULL),(9661,'10039','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.826414,-73.936319,0,'2013-07-06 12:44:30',NULL,NULL),(36353,'40444','S','Lancaster','D','Garrard','21079','Kentucky','KY','21','0000','859','Eastern',-5.0,'Y',37.663640,-84.593177,0,'2013-07-06 12:44:32',NULL,NULL),(4134,'02747','S','North Dartmouth','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.645940,-70.997460,0,'2013-07-06 12:44:30',NULL,NULL),(20953,'21777','S','Point of Rocks','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.279637,-77.532881,0,'2013-07-06 12:44:31',NULL,NULL),(5277,'04497','S','Drew Plt','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(78404,'98036','S','Brier','A','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.802780,-122.284860,0,'2013-07-06 12:44:34',NULL,NULL),(70396,'84712','S','Angle','N','Garfield','49017','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.939733,-112.138116,0,'2013-07-06 12:44:34',NULL,NULL),(34284,'38483','S','Summertown','D','Lawrence','47099','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.433010,-87.336384,0,'2013-07-06 12:44:32',NULL,NULL),(31543,'34603','P','Brooksville','D','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.552210,-82.391059,0,'2013-07-06 12:44:32',NULL,NULL),(13223,'13634','S','Sherwin Bay','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(26455,'29138','S','Richland Springs','N','Saluda','45081','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.007368,-81.769758,0,'2013-07-06 12:44:31',NULL,NULL),(1527,'00754','S','Urb San Lorenzo Valley','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(15544,'16617','S','Bellwood','D','Blair','42013','Pennsylvania','PA','42','0280','814','Eastern',-5.0,'Y',40.603182,-78.332859,0,'2013-07-06 12:44:31',NULL,NULL),(10144,'10272','P','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760631,-74.005451,0,'2013-07-06 12:44:30',NULL,NULL),(37854,'42501','S','Stab','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(51371,'59401','S','Great Falls','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.509333,-111.288029,0,'2013-07-06 12:44:33',NULL,NULL),(60852,'72044','S','Parma','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.645789,-92.190482,0,'2013-07-06 12:44:33',NULL,NULL),(61655,'72902','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.319700,-94.353180,0,'2013-07-06 12:44:33',NULL,NULL),(70674,'85233','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.355672,-111.803866,0,'2013-07-06 12:44:34',NULL,NULL),(68393,'81152','S','Garcia','A','Costilla','08023','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.081380,-105.622500,0,'2013-07-06 12:44:34',NULL,NULL),(65535,'77802','S','Bryan','D','Brazos','48041','Texas','TX','48','1260','979','Central',-6.0,'Y',30.660096,-96.332343,0,'2013-07-06 12:44:34',NULL,NULL),(54833,'63031','S','Florissant','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.806089,-90.343437,0,'2013-07-06 12:44:33',NULL,NULL),(24506,'27278','S','Hillsborough','D','Orange','37135','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',36.074580,-79.077660,0,'2013-07-06 12:44:31',NULL,NULL),(25390,'28271','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.067814,-80.806736,0,'2013-07-06 12:44:31',NULL,NULL),(19359,'20051','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.897965,-77.025424,0,'2013-07-06 12:44:31',NULL,NULL),(71631,'87410','S','Cedar Hill','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.839533,-107.992684,0,'2013-07-06 12:44:34',NULL,NULL),(69098,'83254','S','Nounan','N','Bear Lake','16007','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.315860,-111.295308,0,'2013-07-06 12:44:34',NULL,NULL),(45003,'50448','S','Bolan','N','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.356377,-93.227126,0,'2013-07-06 12:44:32',NULL,NULL),(43044,'48179','S','South Rockwood','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.051676,-83.258881,0,'2013-07-06 12:44:32',NULL,NULL),(1543,'00757','S','Santa Isabel','D','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(10710,'11236','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.640108,-73.904411,0,'2013-07-06 12:44:30',NULL,NULL),(31978,'35216','S','Vestavia Hls','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.421551,-86.794582,0,'2013-07-06 12:44:32',NULL,NULL),(65342,'77520','S','Lynchburg','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(46464,'53215','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',42.997687,-87.942662,0,'2013-07-06 12:44:32',NULL,NULL),(45706,'52060','S','Hurstville','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.071208,-90.660765,0,'2013-07-06 12:44:32',NULL,NULL),(11122,'11704','S','West Babylon','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.709193,-73.371464,0,'2013-07-06 12:44:30',NULL,NULL),(10129,'10261','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.750339,-73.975338,0,'2013-07-06 12:44:30',NULL,NULL),(64286,'76443','S','Cross Plains','D','Callahan','48059','Texas','TX','48','0000','254','Central',-6.0,'Y',32.127979,-99.167220,0,'2013-07-06 12:44:34',NULL,NULL),(43505,'48630','P','Houghton Lake Heights','D','Roscommon','26143','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.325418,-84.774328,0,'2013-07-06 12:44:32',NULL,NULL),(22383,'23937','S','Drakes Branch','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.954547,-78.543684,0,'2013-07-06 12:44:31',NULL,NULL),(21707,'22973','S','Stanardsville','D','Greene','51079','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.296962,-78.439538,0,'2013-07-06 12:44:31',NULL,NULL),(8986,'08832','S','Keasbey','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.514300,-74.302150,0,'2013-07-06 12:44:30',NULL,NULL),(3088,'01202','P','Pittsfield','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.457889,-73.322048,0,'2013-07-06 12:44:30',NULL,NULL),(78492,'98106','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.536346,-122.352802,0,'2013-07-06 12:44:34',NULL,NULL),(74575,'92690','P','San Juan Capo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.611708,-117.642970,0,'2013-07-06 12:44:34',NULL,NULL),(72184,'88352','S','Three Rivers','N','Otero','35035','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.074578,-106.015424,0,'2013-07-06 12:44:34',NULL,NULL),(45031,'50469','S','Cartersville','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.012320,-93.314520,0,'2013-07-06 12:44:32',NULL,NULL),(36198,'40266','U','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.226101,-85.742616,0,'2013-07-06 12:44:32',NULL,NULL),(3726,'02151','S','Revere Beach','N','Suffolk','25025','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.415223,-71.005325,0,'2013-07-06 12:44:30',NULL,NULL),(29487,'32736','S','Eustis','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.889900,-81.514750,0,'2013-07-06 12:44:32',NULL,NULL),(29483,'32730','S','Fern Park','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.651184,-81.345343,0,'2013-07-06 12:44:32',NULL,NULL),(40436,'45716','P','Buchtel','D','Athens','39009','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.462330,-82.185638,0,'2013-07-06 12:44:32',NULL,NULL),(75169,'93599','U','Palmdale','D','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.577152,-118.116071,0,'2013-07-06 12:44:34',NULL,NULL),(72065,'88120','S','Cameron','N','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.821627,-103.313553,0,'2013-07-06 12:44:34',NULL,NULL),(71772,'87556','S','Lama','N','Taos','35055','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.718233,-105.599120,0,'2013-07-06 12:44:34',NULL,NULL),(67600,'80425','P','Buffalo Creek','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.367290,-105.268466,0,'2013-07-06 12:44:34',NULL,NULL),(60980,'72110','S','Lanty','N','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.238660,-92.671080,0,'2013-07-06 12:44:33',NULL,NULL),(52372,'60619','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.745767,-87.607643,0,'2013-07-06 12:44:33',NULL,NULL),(11062,'11580','S','North Valley Stream','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.674214,-73.709056,0,'2013-07-06 12:44:30',NULL,NULL),(30647,'33454','P','Lake Worth','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.594768,-80.200705,0,'2013-07-06 12:44:32',NULL,NULL),(25562,'28421','S','Atkinson','D','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.527759,-78.173939,0,'2013-07-06 12:44:31',NULL,NULL),(21716,'22989','P','Woodberry Forest','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.213226,-78.052185,0,'2013-07-06 12:44:31',NULL,NULL),(43072,'48193','S','Wyandotte','A','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.176900,-83.193200,0,'2013-07-06 12:44:32',NULL,NULL),(46740,'53916','S','Beaver Dam','D','Dodge','55027','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',43.462045,-88.839358,0,'2013-07-06 12:44:32',NULL,NULL),(47144,'54460','S','Atwood','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.947848,-90.563733,0,'2013-07-06 12:44:32',NULL,NULL),(49616,'56901','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(51700,'60005','S','Arlington Hts','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.065315,-87.983562,0,'2013-07-06 12:44:33',NULL,NULL),(409,'00662','S','Qtas Del Atlantico','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(78670,'98236','S','Possession','N','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.959500,-122.402110,0,'2013-07-06 12:44:34',NULL,NULL),(70960,'85645','S','Amado','D','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.568611,-111.051667,0,'2013-07-06 12:44:34',NULL,NULL),(65813,'78141','S','Nordheim','D','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',28.898681,-97.563751,0,'2013-07-06 12:44:34',NULL,NULL),(65208,'77437','S','El Campo','D','Wharton','48481','Texas','TX','48','0000','979','Central',-6.0,'Y',29.198562,-96.272851,0,'2013-07-06 12:44:34',NULL,NULL),(50583,'58233','S','Forest River','D','Walsh','38099','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.237188,-97.447403,0,'2013-07-06 12:44:33',NULL,NULL),(48498,'55735','S','Pine Lake','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.217584,-92.953356,0,'2013-07-06 12:44:33',NULL,NULL),(43993,'49339','S','Pierson','D','Montcalm','26117','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.331082,-85.481474,0,'2013-07-06 12:44:32',NULL,NULL),(8214,'07950','S','Greystone Park','A','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.844846,-74.476815,0,'2013-07-06 12:44:30',NULL,NULL),(24299,'27012','S','Clemmons','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.033742,-80.396011,0,'2013-07-06 12:44:31',NULL,NULL),(9619,'10033','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(41385,'46801','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.067891,-85.167675,0,'2013-07-06 12:44:32',NULL,NULL),(43740,'48980','U','Vehicle License Plates','N','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.671821,-84.675469,0,'2013-07-06 12:44:32',NULL,NULL),(8808,'08610','S','Hamilton Twp','N','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.215600,-74.739600,0,'2013-07-06 12:44:30',NULL,NULL),(79820,'99506','S','Elmendorf AFB','A','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.232052,-149.789210,0,'2013-07-06 12:44:34',NULL,NULL),(74397,'92519','P','Rubidoux','N','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.995480,-117.413440,0,'2013-07-06 12:44:34',NULL,NULL),(72073,'88126','S','Pep','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.783671,-103.358447,0,'2013-07-06 12:44:34',NULL,NULL),(54781,'63005','S','Chesterfield','D','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.634884,-90.619343,0,'2013-07-06 12:44:33',NULL,NULL),(26407,'29113','S','Norway','D','Orangeburg','45075','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',33.446370,-81.116514,0,'2013-07-06 12:44:31',NULL,NULL),(6182,'05477','S','Bolton Valley','A','Chittenden','50007','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.383440,-72.973560,0,'2013-07-06 12:44:30',NULL,NULL),(6657,'06023','S','East Berlin','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.615890,-72.717823,0,'2013-07-06 12:44:30',NULL,NULL),(79986,'99658','P','St Marys','N','Wade Hampton','02270','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.268431,-163.344319,0,'2013-07-06 12:44:34',NULL,NULL),(77591,'96928','P','Agat','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.382214,144.657570,0,'2013-07-06 12:44:34',NULL,NULL),(64208,'76262','S','Keller','A','Denton','48121','Texas','TX','48','1920','817','Central',-6.0,'Y',33.007049,-97.194352,0,'2013-07-06 12:44:34',NULL,NULL),(57630,'67142','S','Spivey','D','Kingman','20095','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.426412,-98.190505,0,'2013-07-06 12:44:33',NULL,NULL),(55266,'63461','S','Withers Mill','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.797789,-91.526300,0,'2013-07-06 12:44:33',NULL,NULL),(49717,'57038','S','Jefferson','D','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',42.573514,-96.539367,0,'2013-07-06 12:44:33',NULL,NULL),(15565,'16641','S','Gallitzin','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.480478,-78.552746,0,'2013-07-06 12:44:31',NULL,NULL),(28428,'31331','S','Shellman Blf','A','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.380744,-81.423097,0,'2013-07-06 12:44:32',NULL,NULL),(38721,'44022','S','Munson Twp','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.438462,-81.418674,0,'2013-07-06 12:44:32',NULL,NULL),(39438,'44688','S','Waynesburg','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.685305,-81.267135,0,'2013-07-06 12:44:32',NULL,NULL),(77824,'97207','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.522892,-122.684519,0,'2013-07-06 12:44:34',NULL,NULL),(17583,'18017','S','Butztown','A','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.653231,-75.336849,0,'2013-07-06 12:44:31',NULL,NULL),(26608,'29302','S','Spartanburg','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.957122,-81.863011,0,'2013-07-06 12:44:31',NULL,NULL),(43099,'48215','S','Grosse Pointe Park','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.387720,-82.950600,0,'2013-07-06 12:44:32',NULL,NULL),(74548,'92675','S','Mission Viejo','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.508513,-117.656472,0,'2013-07-06 12:44:34',NULL,NULL),(76379,'95525','S','Blue Lake','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.906634,-123.938458,0,'2013-07-06 12:44:34',NULL,NULL),(77031,'96103','S','Blairsden-Graeagle','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.791040,-120.672420,0,'2013-07-06 12:44:34',NULL,NULL),(54842,'63038','S','Glencoe','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.582772,-90.652220,0,'2013-07-06 12:44:33',NULL,NULL),(23407,'25327','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.353108,-81.632439,0,'2013-07-06 12:44:31',NULL,NULL),(25960,'28658','S','Blackburn','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(35464,'39502','P','Gulfport','D','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.389224,-89.099424,0,'2013-07-06 12:44:32',NULL,NULL),(6124,'05459','S','Highgate','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.949000,-73.012020,0,'2013-07-06 12:44:30',NULL,NULL),(8966,'08812','S','Green Brook','A','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.601341,-74.478647,0,'2013-07-06 12:44:30',NULL,NULL),(28541,'31554','S','Wilsonville','N','Coffee','13069','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.421121,-82.595050,0,'2013-07-06 12:44:32',NULL,NULL),(8430,'08079','S','Mannington Township','N','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.548542,-75.452329,0,'2013-07-06 12:44:30',NULL,NULL),(70269,'84526','S','Castle Gate','N','Carbon','49007','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.679255,-110.852494,0,'2013-07-06 12:44:34',NULL,NULL),(60418,'71640','S','Eudora','D','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.105480,-91.259880,0,'2013-07-06 12:44:33',NULL,NULL),(32924,'36558','S','Copeland','N','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.627372,-88.352891,0,'2013-07-06 12:44:32',NULL,NULL),(26548,'29206','S','Ravenwood','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.029540,-80.951880,0,'2013-07-06 12:44:31',NULL,NULL),(13762,'14132','S','Sanborn','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.147891,-78.872724,0,'2013-07-06 12:44:31',NULL,NULL),(36338,'40402','S','Moores Creek','A','Jackson','21109','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.303317,-84.007453,0,'2013-07-06 12:44:32',NULL,NULL),(45209,'50630','S','Fredericksburg','D','Chickasaw','19037','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.968397,-92.197281,0,'2013-07-06 12:44:32',NULL,NULL),(51300,'59223','S','Fort Peck','D','Valley','30105','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.004486,-106.444604,0,'2013-07-06 12:44:33',NULL,NULL),(56190,'65014','S','Red Bird','N','Gasconade','29073','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.302146,-91.634880,0,'2013-07-06 12:44:33',NULL,NULL),(4590,'03582','S','Groveton','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.600195,-71.510658,0,'2013-07-06 12:44:30',NULL,NULL),(74635,'92809','S','Anaheim Hills','N','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.842578,-117.938803,0,'2013-07-06 12:44:34',NULL,NULL),(68546,'81424','S','Nucla','D','Montrose','08085','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.265437,-108.553494,0,'2013-07-06 12:44:34',NULL,NULL),(66660,'78861','S','Hondo','D','Medina','48325','Texas','TX','48','0000','830','Central',-6.0,'Y',29.356920,-99.101580,0,'2013-07-06 12:44:34',NULL,NULL),(66255,'78573','S','Alton','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214239,-98.325921,0,'2013-07-06 12:44:34',NULL,NULL),(62281,'74017','S','Clairemore','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.343020,-95.596680,0,'2013-07-06 12:44:33',NULL,NULL),(39985,'45240','S','Parkdale','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.285863,-84.524542,0,'2013-07-06 12:44:32',NULL,NULL),(4476,'03266','S','Ellsworth','N','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.787467,-71.855141,0,'2013-07-06 12:44:30',NULL,NULL),(33475,'37336','S','Georgetown','D','Meigs','47121','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.271974,-84.986898,0,'2013-07-06 12:44:32',NULL,NULL),(72773,'89555','U','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.529646,-119.812392,0,'2013-07-06 12:44:34',NULL,NULL),(69822,'84074','S','Tooele Army Depot','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(60376,'71485','S','Indian Creek','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.160578,-92.499928,0,'2013-07-06 12:44:33',NULL,NULL),(47136,'54455','S','Mosinee','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.788648,-89.687985,0,'2013-07-06 12:44:32',NULL,NULL),(33544,'37391','S','Turtletown','D','Polk','47139','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',35.143958,-84.370385,0,'2013-07-06 12:44:32',NULL,NULL),(2285,'00926','S','Villa Dagmarita','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(26352,'29069','S','Lamar','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.181109,-80.057782,0,'2013-07-06 12:44:31',NULL,NULL),(14881,'15475','P','Republic','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',39.966207,-79.876501,0,'2013-07-06 12:44:31',NULL,NULL),(19544,'20195','P','Herndon','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.948887,-77.326781,0,'2013-07-06 12:44:31',NULL,NULL),(17299,'17851','S','Mt Carmel Township','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.801680,-76.430700,0,'2013-07-06 12:44:31',NULL,NULL),(17252,'17841','S','Belltown','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(16180,'17067','S','Frystown','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.377563,-76.318740,0,'2013-07-06 12:44:31',NULL,NULL),(38933,'44122','S','Warrensville Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.468177,-81.514037,0,'2013-07-06 12:44:32',NULL,NULL),(45465,'51247','S','Carmel','N','Sioux','19167','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.205229,-96.291066,0,'2013-07-06 12:44:32',NULL,NULL),(72587,'89406','S','Frenchman','N','Churchill','32001','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',39.480660,-118.768130,0,'2013-07-06 12:44:34',NULL,NULL),(54353,'62786','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.803138,-89.658075,0,'2013-07-06 12:44:33',NULL,NULL),(3364,'01571','S','Dudley','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.057246,-71.912522,0,'2013-07-06 12:44:30',NULL,NULL),(7116,'06377','S','Sterling','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.719140,-71.818560,0,'2013-07-06 12:44:30',NULL,NULL),(80157,'99801','S','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.356473,-134.526685,0,'2013-07-06 12:44:34',NULL,NULL),(78489,'98104','S','Seattle','D','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.604727,-122.325941,0,'2013-07-06 12:44:34',NULL,NULL),(73167,'90304','S','Inglewood','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.935693,-118.355284,0,'2013-07-06 12:44:34',NULL,NULL),(12101,'12575','S','Rock Tavern','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.473305,-74.146634,0,'2013-07-06 12:44:30',NULL,NULL),(31368,'34209','S','Bradenton','D','Manatee','12081','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.508354,-82.646654,0,'2013-07-06 12:44:32',NULL,NULL),(14217,'14787','S','Westfield','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.324371,-79.570661,0,'2013-07-06 12:44:31',NULL,NULL),(19223,'19897','U','Astrazeneca','N','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.798051,-75.545651,0,'2013-07-06 12:44:31',NULL,NULL),(38868,'44102','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.470294,-81.737685,0,'2013-07-06 12:44:32',NULL,NULL),(54424,'62837','S','Boyleston','N','Wayne','17191','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.382854,-88.364987,0,'2013-07-06 12:44:33',NULL,NULL),(6457,'05760','S','Lake Hortonia','N','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.785111,-73.276135,0,'2013-07-06 12:44:30',NULL,NULL),(72108,'88240','S','Oil Center','A','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.725126,-103.140536,0,'2013-07-06 12:44:34',NULL,NULL),(70709,'85271','P','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.466987,-111.914908,0,'2013-07-06 12:44:34',NULL,NULL),(52829,'61310','S','Maytown','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.704186,-89.342017,0,'2013-07-06 12:44:33',NULL,NULL),(49531,'56678','S','Solway','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.555400,-95.132820,0,'2013-07-06 12:44:33',NULL,NULL),(3376,'01590','S','Sutton','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.138424,-71.752496,0,'2013-07-06 12:44:30',NULL,NULL),(10031,'10172','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.741194,-73.987354,0,'2013-07-06 12:44:30',NULL,NULL),(1878,'00791','S','Urb Palmanova','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(26627,'29321','S','Buffalo','D','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.725233,-81.683994,0,'2013-07-06 12:44:31',NULL,NULL),(43340,'48375','S','Novi Township','N','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.463733,-83.460384,0,'2013-07-06 12:44:32',NULL,NULL),(7249,'06513','S','New Haven','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.321735,-72.859214,0,'2013-07-06 12:44:30',NULL,NULL),(66915,'79325','S','Farwell','D','Parmer','48369','Texas','TX','48','0000','806','Central',-6.0,'Y',34.387530,-103.042230,0,'2013-07-06 12:44:34',NULL,NULL),(63732,'75934','P','Camden','D','Polk','48373','Texas','TX','48','0000','936','Central',-6.0,'Y',30.917797,-94.735098,0,'2013-07-06 12:44:34',NULL,NULL),(44615,'50059','S','Cooper','D','Greene','19073','Iowa','IA','19','0000','515','Central',-6.0,'Y',41.899565,-94.339514,0,'2013-07-06 12:44:32',NULL,NULL),(34553,'38725','S','Bolivar','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.652860,-91.031700,0,'2013-07-06 12:44:32',NULL,NULL),(15724,'16875','S','Spring Mills','D','Centre','42027','Pennsylvania','PA','42','8050','814','Eastern',-5.0,'Y',40.864802,-77.571544,0,'2013-07-06 12:44:31',NULL,NULL),(29948,'33071','S','Pompano Beach','D','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.243112,-80.261973,0,'2013-07-06 12:44:32',NULL,NULL),(28685,'31801','S','Juniper','A','Talbot','13263','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',32.570820,-84.621720,0,'2013-07-06 12:44:32',NULL,NULL),(20725,'21285','P','Baltimore','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.407938,-76.597911,0,'2013-07-06 12:44:31',NULL,NULL),(68988,'83123','S','La Barge','D','Lincoln','56023','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.257113,-110.205952,0,'2013-07-06 12:44:34',NULL,NULL),(59056,'70091','S','Port Eads','N','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.209341,-89.231358,0,'2013-07-06 12:44:33',NULL,NULL),(56430,'65263','S','Middle Grove','N','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.473290,-92.214390,0,'2013-07-06 12:44:33',NULL,NULL),(53930,'62401','S','Northmore Heights','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(35171,'39271','U','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289835,-90.180840,0,'2013-07-06 12:44:32',NULL,NULL),(6651,'06019','S','Collinsville','A','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.835820,-72.896405,0,'2013-07-06 12:44:30',NULL,NULL),(24457,'27228','P','Bynum','D','Chatham','37037','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.772618,-79.137819,0,'2013-07-06 12:44:31',NULL,NULL),(23624,'25720','P','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.398656,-82.448258,0,'2013-07-06 12:44:31',NULL,NULL),(23428,'25365','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.234272,-81.573751,0,'2013-07-06 12:44:31',NULL,NULL),(1876,'00791','S','Urb Mabu','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(13680,'14041','S','Dayton','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.423665,-78.980320,0,'2013-07-06 12:44:31',NULL,NULL),(3380,'01602','S','West Side','N','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.270180,-71.845149,0,'2013-07-06 12:44:30',NULL,NULL),(49630,'56933','U','Parcel Return Svc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(67762,'80633','P','Greeley','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.423830,-104.695380,0,'2013-07-06 12:44:34',NULL,NULL),(64820,'77029','S','Jacinto City','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.767222,-95.233611,0,'2013-07-06 12:44:34',NULL,NULL),(34569,'38733','S','Cleveland','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.749492,-90.831182,0,'2013-07-06 12:44:32',NULL,NULL),(31821,'35063','S','Empire','D','Walker','01127','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.802419,-86.941597,0,'2013-07-06 12:44:32',NULL,NULL),(31642,'34731','S','Fruitland Park','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.864889,-81.898909,0,'2013-07-06 12:44:32',NULL,NULL),(14879,'15473','S','Whitsett','A','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.087523,-79.750761,0,'2013-07-06 12:44:31',NULL,NULL),(41778,'47304','S','West Acres','N','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(56338,'65109','S','Saint Martins','N','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.555400,-92.280540,0,'2013-07-06 12:44:33',NULL,NULL),(35989,'40122','S','Fort Knox','D','Hardin','21093','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',37.881100,-85.962689,0,'2013-07-06 12:44:32',NULL,NULL),(8544,'08202','S','Avalon','D','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.092790,-74.732870,0,'2013-07-06 12:44:30',NULL,NULL),(22740,'24382','S','Stones Mill','N','Wythe','51197','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.945260,-81.089071,0,'2013-07-06 12:44:31',NULL,NULL),(46836,'54016','S','North Hudson','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',44.981880,-92.690820,0,'2013-07-06 12:44:32',NULL,NULL),(56489,'65334','S','Hughesville','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.855775,-93.208469,0,'2013-07-06 12:44:33',NULL,NULL),(45169,'50601','S','Cleves','N','Hardin','19083','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.552024,-93.052562,0,'2013-07-06 12:44:32',NULL,NULL),(42453,'47809','U','Indiana State University','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.470391,-87.409294,0,'2013-07-06 12:44:32',NULL,NULL),(17258,'17841','S','Soradoville','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(12841,'13315','S','Exeter','N','Otsego','36077','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.753480,-75.169620,0,'2013-07-06 12:44:30',NULL,NULL),(1061,'00725','S','Ext Caguax','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(79577,'99023','S','Mica','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.544258,-117.213397,0,'2013-07-06 12:44:34',NULL,NULL),(68268,'81071','S','Towner','A','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.446999,-102.218718,0,'2013-07-06 12:44:34',NULL,NULL),(67862,'80826','U','Limon Crrctnl','N','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.263889,-103.692415,0,'2013-07-06 12:44:34',NULL,NULL),(10668,'11109','S','Long Island City','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.742578,-73.949048,0,'2013-07-06 12:44:30',NULL,NULL),(15942,'17022','S','Etown','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.148743,-76.597557,0,'2013-07-06 12:44:31',NULL,NULL),(39953,'45233','S','Sayler Park','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.119196,-84.669399,0,'2013-07-06 12:44:32',NULL,NULL),(51884,'60090','S','Wheeling','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.133221,-87.934315,0,'2013-07-06 12:44:33',NULL,NULL),(63147,'75374','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.912949,-96.734628,0,'2013-07-06 12:44:33',NULL,NULL),(63768,'75946','S','Hidden Valley','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.799280,-94.485300,0,'2013-07-06 12:44:34',NULL,NULL),(378,'00660','S','Mans La Monserrate','N','Hormigueros','72067','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.140855,-67.128154,0,'2013-07-06 12:44:30',NULL,NULL),(76406,'95549','S','Kneeland','D','Humboldt','06023','California','CA','06','0000','707','Pacific',-8.0,'Y',40.729684,-123.958230,0,'2013-07-06 12:44:34',NULL,NULL),(69863,'84092','S','Sherwood Park','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.566960,-111.814560,0,'2013-07-06 12:44:34',NULL,NULL),(57386,'66753','S','Strauss','N','Crawford','20037','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.352484,-95.021069,0,'2013-07-06 12:44:33',NULL,NULL),(53627,'62092','S','White Hall','D','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.440324,-90.402625,0,'2013-07-06 12:44:33',NULL,NULL),(15159,'15905','S','Johnstown','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.308022,-78.940967,0,'2013-07-06 12:44:31',NULL,NULL),(24211,'26705','S','Amboy','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.302220,-79.577580,0,'2013-07-06 12:44:31',NULL,NULL),(9063,'08906','P','Kilmer Gmf','N','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.484296,-74.444675,0,'2013-07-06 12:44:30',NULL,NULL),(26267,'29010','S','Lucknow','N','Lee','45061','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.219080,-80.270820,0,'2013-07-06 12:44:31',NULL,NULL),(6508,'05821','S','Barnet','D','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.314722,-72.166389,0,'2013-07-06 12:44:30',NULL,NULL),(72210,'88422','S','Farley','N','Union','35059','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.321192,-103.864445,0,'2013-07-06 12:44:34',NULL,NULL),(67109,'79721','P','Big Spring','D','Howard','48227','Texas','TX','48','0000','432','Central',-6.0,'Y',32.250099,-101.457516,0,'2013-07-06 12:44:34',NULL,NULL),(67059,'79561','S','Trent','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.489551,-100.120390,0,'2013-07-06 12:44:34',NULL,NULL),(65637,'77964','S','Rabbs','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.248610,-96.703340,0,'2013-07-06 12:44:34',NULL,NULL),(54062,'62477','S','West Union','D','Clark','17023','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.247800,-87.644700,0,'2013-07-06 12:44:33',NULL,NULL),(5995,'05354','S','Vernon','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.760563,-72.526116,0,'2013-07-06 12:44:30',NULL,NULL),(33625,'37665','S','Kingsport','D','Sullivan','47163','Tennessee','TN','47','3660','423','Eastern',-5.0,'Y',36.582057,-82.564868,0,'2013-07-06 12:44:32',NULL,NULL),(33375,'37209','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.150761,-86.864100,0,'2013-07-06 12:44:32',NULL,NULL),(15763,'16915','S','Mina','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(46460,'53214','S','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.020816,-88.017337,0,'2013-07-06 12:44:32',NULL,NULL),(50468,'58040','S','Crete','A','Sargent','38081','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.224480,-97.760640,0,'2013-07-06 12:44:33',NULL,NULL),(37486,'42020','S','Almo Heights','N','Calloway','21035','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.668399,-88.368865,0,'2013-07-06 12:44:32',NULL,NULL),(24526,'27288','S','Leaksville','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(27211,'29909','S','Okatie','D','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.262421,-80.867479,0,'2013-07-06 12:44:31',NULL,NULL),(20563,'21133','S','Foxridge','N','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.369846,-76.802416,0,'2013-07-06 12:44:31',NULL,NULL),(22269,'23693','S','Yorktown','D','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.122300,-76.448400,0,'2013-07-06 12:44:31',NULL,NULL),(71159,'86038','S','Flagstaff','A','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.944121,-111.427745,0,'2013-07-06 12:44:34',NULL,NULL),(49756,'57064','S','Tea','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.447764,-96.835749,0,'2013-07-06 12:44:33',NULL,NULL),(43686,'48878','S','Rosebush','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.713070,-84.771596,0,'2013-07-06 12:44:32',NULL,NULL),(11817,'12235','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.649742,-73.756061,0,'2013-07-06 12:44:30',NULL,NULL),(16196,'17070','S','N Cumberld','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.210140,-76.869360,0,'2013-07-06 12:44:31',NULL,NULL),(11441,'11973','P','Upton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.849836,-72.889667,0,'2013-07-06 12:44:30',NULL,NULL),(78759,'98303','S','Anderson Island','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164386,-122.695768,0,'2013-07-06 12:44:34',NULL,NULL),(74576,'92691','S','Mission Viejo','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.612814,-117.662215,0,'2013-07-06 12:44:34',NULL,NULL),(69538,'83801','S','Athol','D','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.936824,-116.675482,0,'2013-07-06 12:44:34',NULL,NULL),(53626,'62092','S','Walkerville','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.440324,-90.402625,0,'2013-07-06 12:44:33',NULL,NULL),(18948,'19508','S','Seyfert','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284167,-75.872222,0,'2013-07-06 12:44:31',NULL,NULL),(3338,'01541','S','Princeton','D','Worcester','25027','Massachusetts','MA','25','9240','978/351','Eastern',-5.0,'Y',42.450061,-71.884655,0,'2013-07-06 12:44:30',NULL,NULL),(72385,'89039','S','Palm Gardens','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.316311,-114.885400,0,'2013-07-06 12:44:34',NULL,NULL),(59597,'71016','S','Castor','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.187420,-93.133374,0,'2013-07-06 12:44:33',NULL,NULL),(47838,'55072','S','Markville','A','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.126511,-92.866999,0,'2013-07-06 12:44:33',NULL,NULL),(44499,'49921','S','Houghton','A','Houghton','26061','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',47.090392,-88.580984,0,'2013-07-06 12:44:32',NULL,NULL),(30691,'33478','S','Jupiter','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.921814,-80.215886,0,'2013-07-06 12:44:32',NULL,NULL),(3319,'01525','P','Linwood','D','Worcester','25027','Massachusetts','MA','25','9240','508/774','Eastern',-5.0,'Y',42.098419,-71.643912,0,'2013-07-06 12:44:30',NULL,NULL),(23809,'26047','S','New Cumbrlnd','N','Hancock','54029','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.493050,-80.597570,0,'2013-07-06 12:44:31',NULL,NULL),(9764,'10104','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.761151,-73.977549,0,'2013-07-06 12:44:30',NULL,NULL),(2871,'00985','S','Villas del Sol','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(43491,'48617','S','Clare','D','Clare','26035','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.862429,-84.734662,0,'2013-07-06 12:44:32',NULL,NULL),(927,'00714','S','Urb Arroyo del Mar','N','Arroyo','72015','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.970131,-66.064155,0,'2013-07-06 12:44:30',NULL,NULL),(78751,'98292','S','Stanwood','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.179280,-122.371440,0,'2013-07-06 12:44:34',NULL,NULL),(58598,'68849','U','Kearney','D','Buffalo','31019','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.702013,-99.099483,0,'2013-07-06 12:44:33',NULL,NULL),(57111,'66221','S','Stanley','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.861820,-94.712640,0,'2013-07-06 12:44:33',NULL,NULL),(10691,'11216','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.679695,-73.950292,0,'2013-07-06 12:44:30',NULL,NULL),(2459,'00955','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409298,-66.064653,0,'2013-07-06 12:44:30',NULL,NULL),(5672,'04963','S','Rome','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.544935,-69.721959,0,'2013-07-06 12:44:30',NULL,NULL),(20773,'21524','P','Corriganville','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.692576,-78.793467,0,'2013-07-06 12:44:31',NULL,NULL),(17551,'17980','S','Reinerton','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.591905,-76.538022,0,'2013-07-06 12:44:31',NULL,NULL),(15212,'16016','U','Boyers','D','Butler','42019','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',41.106482,-79.897055,0,'2013-07-06 12:44:31',NULL,NULL),(53338,'61754','S','Mc Lean','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.314947,-89.170467,0,'2013-07-06 12:44:33',NULL,NULL),(53969,'62432','S','Hidalgo','D','Jasper','17079','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',39.117001,-88.129813,0,'2013-07-06 12:44:33',NULL,NULL),(77829,'97212','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.547387,-122.637999,0,'2013-07-06 12:44:34',NULL,NULL),(73743,'91714','P','City Industry','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.019446,-117.957126,0,'2013-07-06 12:44:34',NULL,NULL),(68908,'82831','S','Arvada','D','Sheridan','56033','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.705531,-106.101313,0,'2013-07-06 12:44:34',NULL,NULL),(67441,'80205','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.762697,-104.973357,0,'2013-07-06 12:44:34',NULL,NULL),(59243,'70436','S','Fluker','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.826849,-90.538479,0,'2013-07-06 12:44:33',NULL,NULL),(35730,'39701','S','G T Airport','N','Lowndes','28087','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.537660,-88.462380,0,'2013-07-06 12:44:32',NULL,NULL),(43390,'48437','P','Genesee','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.104282,-83.638707,0,'2013-07-06 12:44:32',NULL,NULL),(45004,'50448','S','Kensett','D','Worth','19195','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.356377,-93.227126,0,'2013-07-06 12:44:32',NULL,NULL),(45326,'50857','S','Guss','N','Adams','19003','Iowa','IA','19','0000','712','Central',-6.0,'Y',40.943672,-94.874173,0,'2013-07-06 12:44:32',NULL,NULL),(46893,'54120','S','Fence','D','Florence','55037','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.763549,-88.446898,0,'2013-07-06 12:44:32',NULL,NULL),(52577,'60967','P','Stockland','D','Iroquois','17075','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.613720,-87.595200,0,'2013-07-06 12:44:33',NULL,NULL),(54949,'63117','S','Richmond Heights','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.628611,-90.319444,0,'2013-07-06 12:44:33',NULL,NULL),(75739,'94603','S','Oakland','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.740185,-122.174990,0,'2013-07-06 12:44:34',NULL,NULL),(53995,'62443','S','Gilmore','N','Effingham','17049','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.961718,-88.635948,0,'2013-07-06 12:44:33',NULL,NULL),(42974,'48137','S','Unadilla','N','Livingston','26093','Michigan','MI','26','0440','734','Eastern',-5.0,'Y',42.468420,-84.065880,0,'2013-07-06 12:44:32',NULL,NULL),(34575,'38737','S','Blue Lake','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(33549,'37397','S','Whitwell','D','Sequatchie','47153','Tennessee','TN','47','1560','423','Central',-6.0,'Y',35.198597,-85.514246,0,'2013-07-06 12:44:32',NULL,NULL),(32777,'36401','S','Egreen','N','Conecuh','01035','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.430309,-86.956166,0,'2013-07-06 12:44:32',NULL,NULL),(19837,'20503','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.902115,-77.036165,0,'2013-07-06 12:44:31',NULL,NULL),(7917,'07632','S','Englewood','A','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',40.883283,-73.954892,0,'2013-07-06 12:44:30',NULL,NULL),(64603,'76682','S','Riesel','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.473889,-96.920114,0,'2013-07-06 12:44:34',NULL,NULL),(64045,'76130','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.706926,-97.362225,0,'2013-07-06 12:44:34',NULL,NULL),(23916,'26218','S','Alexander','A','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.846220,-80.269980,0,'2013-07-06 12:44:31',NULL,NULL),(21529,'22727','S','Madison','D','Madison','51113','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.374012,-78.321934,0,'2013-07-06 12:44:31',NULL,NULL),(17319,'17859','S','Orange','N','Columbia','42037','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.076734,-76.413424,0,'2013-07-06 12:44:31',NULL,NULL),(15634,'16726','S','Cyclone','D','McKean','42083','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.821800,-78.561120,0,'2013-07-06 12:44:31',NULL,NULL),(15298,'16140','P','New Bedford','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',41.095717,-80.505156,0,'2013-07-06 12:44:31',NULL,NULL),(10526,'10983','S','Tappan','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.029100,-73.952176,0,'2013-07-06 12:44:30',NULL,NULL),(61517,'72657','S','Timbo','D','Stone','05137','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.894800,-92.246904,0,'2013-07-06 12:44:33',NULL,NULL),(58917,'69335','S','Bingham','D','Sheridan','31161','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',42.266896,-102.155767,0,'2013-07-06 12:44:33',NULL,NULL),(51629,'59851','P','Milltown','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.873703,-113.879040,0,'2013-07-06 12:44:33',NULL,NULL),(50377,'57760','S','Castle Rock','N','Butte','46019','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.718125,-103.420575,0,'2013-07-06 12:44:33',NULL,NULL),(39963,'45236','S','Sycamore Twp','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.204746,-84.400718,0,'2013-07-06 12:44:32',NULL,NULL),(51121,'58790','S','Velva','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.058466,-100.930511,0,'2013-07-06 12:44:33',NULL,NULL),(7720,'07198','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.735880,-74.143855,0,'2013-07-06 12:44:30',NULL,NULL),(30516,'33404','S','Singer Island','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.779152,-80.073595,0,'2013-07-06 12:44:32',NULL,NULL),(15470,'16426','S','McKean','A','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',41.990841,-80.144052,0,'2013-07-06 12:44:31',NULL,NULL),(78955,'98370','S','Breidablick','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(52198,'60475','S','Chicago Hts','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.466203,-87.638399,0,'2013-07-06 12:44:33',NULL,NULL),(31640,'34729','P','Ferndale','D','Lake','12069','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.620539,-81.711500,0,'2013-07-06 12:44:32',NULL,NULL),(30825,'33620','U','USF','N','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.060736,-82.410807,0,'2013-07-06 12:44:32',NULL,NULL),(3879,'02364','S','Silver Lake','N','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',41.979540,-70.745100,0,'2013-07-06 12:44:30',NULL,NULL),(2998,'01069','S','Palmer','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.165487,-72.314400,0,'2013-07-06 12:44:30',NULL,NULL),(23406,'25326','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.333129,-81.598412,0,'2013-07-06 12:44:31',NULL,NULL),(22511,'24084','S','Dublin','D','Pulaski','51155','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.106884,-80.684639,0,'2013-07-06 12:44:31',NULL,NULL),(1515,'00754','S','Jard de Cerro Gordo','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(13989,'14508','P','Morton','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.327041,-77.999192,0,'2013-07-06 12:44:31',NULL,NULL),(50128,'57529','S','Dallas','D','Gregory','46053','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.234545,-99.511640,0,'2013-07-06 12:44:33',NULL,NULL),(283,'00646','S','Parc San Antonio','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(79716,'99213','P','City of Spokane Valley','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.656583,-117.291099,0,'2013-07-06 12:44:34',NULL,NULL),(74034,'92136','U','San Diego','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.678744,-117.119958,0,'2013-07-06 12:44:34',NULL,NULL),(71962,'88004','P','Las Cruces','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.333848,-106.719414,0,'2013-07-06 12:44:34',NULL,NULL),(62084,'73562','S','Randlett','D','Cotton','40033','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.177916,-98.434828,0,'2013-07-06 12:44:33',NULL,NULL),(61970,'73184','U','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.620834,-97.571442,0,'2013-07-06 12:44:33',NULL,NULL),(33770,'37866','S','Sharps Chapel','D','Union','47173','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.356798,-83.863314,0,'2013-07-06 12:44:32',NULL,NULL),(5529,'04780','S','Hersey','A','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',46.166860,-68.269882,0,'2013-07-06 12:44:30',NULL,NULL),(18041,'18657','S','Mehoopany Twp','A','Wyoming','42131','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.537400,-75.974520,0,'2013-07-06 12:44:31',NULL,NULL),(24578,'27315','S','Providence','D','Caswell','37033','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.516305,-79.428083,0,'2013-07-06 12:44:31',NULL,NULL),(41032,'46390','S','Haskells','N','La Porte','18091','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.435469,-86.892131,0,'2013-07-06 12:44:32',NULL,NULL),(44075,'49446','S','New Era','D','Oceana','26127','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.561615,-86.357296,0,'2013-07-06 12:44:32',NULL,NULL),(58610,'68855','S','Algernon','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.162665,-99.310489,0,'2013-07-06 12:44:33',NULL,NULL),(78442,'98058','S','Fairwood','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.444411,-122.142843,0,'2013-07-06 12:44:34',NULL,NULL),(75983,'95070','S','Saratoga','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.274954,-122.021747,0,'2013-07-06 12:44:34',NULL,NULL),(73600,'91390','S','Green Valley','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(72187,'88353','P','Vaughn','D','Guadalupe','35019','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.686068,-105.133654,0,'2013-07-06 12:44:34',NULL,NULL),(64998,'77291','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.872287,-95.415915,0,'2013-07-06 12:44:34',NULL,NULL),(48066,'55327','S','Otsego','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.202456,-93.468790,0,'2013-07-06 12:44:33',NULL,NULL),(3267,'01464','S','Shirley Center','A','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.577860,-71.643840,0,'2013-07-06 12:44:30',NULL,NULL),(6436,'05747','S','Granville','D','Addison','50001','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.006169,-72.841833,0,'2013-07-06 12:44:30',NULL,NULL),(20924,'21742','S','Northern','N','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.657087,-77.709741,0,'2013-07-06 12:44:31',NULL,NULL),(14593,'15222','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.448765,-79.991418,0,'2013-07-06 12:44:31',NULL,NULL),(37337,'41666','S','Wayland','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.456944,-82.818889,0,'2013-07-06 12:44:32',NULL,NULL),(43405,'48453','S','Marlette','D','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.339316,-83.037832,0,'2013-07-06 12:44:32',NULL,NULL),(44336,'49762','S','Naubinway','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.147284,-85.403210,0,'2013-07-06 12:44:32',NULL,NULL),(7532,'07006','S','N Caldwell','A','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.855020,-74.277840,0,'2013-07-06 12:44:30',NULL,NULL),(68932,'82929','P','Litl America','A','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.542836,-109.857942,0,'2013-07-06 12:44:34',NULL,NULL),(65616,'77954','S','Edgar','N','De Witt','48123','Texas','TX','48','0000','361','Central',-6.0,'Y',29.103420,-97.281300,0,'2013-07-06 12:44:34',NULL,NULL),(55680,'64054','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.111863,-94.441141,0,'2013-07-06 12:44:33',NULL,NULL),(4011,'02556','S','North Falmouth','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.649960,-70.624919,0,'2013-07-06 12:44:30',NULL,NULL),(19714,'20390','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.884615,-76.993490,0,'2013-07-06 12:44:31',NULL,NULL),(2617,'00962','S','Jard De Catano I','N','Catano','72033','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444331,-66.138606,0,'2013-07-06 12:44:30',NULL,NULL),(5734,'05033','S','South Corinth','N','Orange','50017','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.999980,-72.137700,0,'2013-07-06 12:44:30',NULL,NULL),(40232,'45419','S','Kettering','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.714561,-84.165115,0,'2013-07-06 12:44:32',NULL,NULL),(50790,'58440','S','Fredonia','D','Logan','38047','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.365495,-99.289657,0,'2013-07-06 12:44:33',NULL,NULL),(58528,'68790','S','Winside','D','Wayne','31179','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.155093,-97.193363,0,'2013-07-06 12:44:33',NULL,NULL),(54891,'63069','S','Wildwood','A','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.491435,-90.765094,0,'2013-07-06 12:44:33',NULL,NULL),(41600,'47110','S','New Amsterdam','A','Harrison','18061','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.091924,-86.161324,0,'2013-07-06 12:44:32',NULL,NULL),(38771,'44049','P','Kipton','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.269183,-82.305608,0,'2013-07-06 12:44:32',NULL,NULL),(13625,'13901','S','Port Dickinson','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.156660,-75.890520,0,'2013-07-06 12:44:31',NULL,NULL),(27294,'30008','S','Marietta','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.903740,-84.582593,0,'2013-07-06 12:44:31',NULL,NULL),(11286,'11773','U','Syosset','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.828208,-73.503625,0,'2013-07-06 12:44:30',NULL,NULL),(10262,'10503','P','Ardsley on Hudson','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.025309,-73.868081,0,'2013-07-06 12:44:30',NULL,NULL),(68094,'80942','U','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834659,-104.822936,0,'2013-07-06 12:44:34',NULL,NULL),(65924,'78243','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.381316,-98.579896,0,'2013-07-06 12:44:34',NULL,NULL),(60174,'71409','S','Rapides','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.309860,-92.707080,0,'2013-07-06 12:44:33',NULL,NULL),(44424,'49838','S','Gould City','D','Mackinac','26097','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.069365,-85.732722,0,'2013-07-06 12:44:32',NULL,NULL),(36564,'40932','P','Fall Rock','D','Clay','21051','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.219911,-83.789070,0,'2013-07-06 12:44:32',NULL,NULL),(34970,'39081','P','Harriston','D','Jefferson','28063','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.718062,-91.038486,0,'2013-07-06 12:44:32',NULL,NULL),(18711,'19197','U','USPS Eastern Region Hdqtrs','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.954696,-75.178777,0,'2013-07-06 12:44:31',NULL,NULL),(36551,'40906','S','Kayjay','A','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.865780,-83.892076,0,'2013-07-06 12:44:32',NULL,NULL),(71942,'87935','P','Engle','N','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.195236,-107.218449,0,'2013-07-06 12:44:34',NULL,NULL),(70189,'84335','S','Smithfield','D','Cache','49005','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.835840,-111.870960,0,'2013-07-06 12:44:34',NULL,NULL),(69431,'83638','S','McCall','D','Valley','16085','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.914318,-116.098389,0,'2013-07-06 12:44:34',NULL,NULL),(48495,'55735','S','Bremen','N','Pine','27115','Minnesota','MN','27','0000','320','Central',-6.0,'Y',46.217584,-92.953356,0,'2013-07-06 12:44:33',NULL,NULL),(590,'00680','S','Repto Antillano','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(31836,'35079','S','Hayden','D','Blount','01009','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.884716,-86.806982,0,'2013-07-06 12:44:32',NULL,NULL),(29689,'32927','S','Port St John','A','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.470183,-80.797492,0,'2013-07-06 12:44:32',NULL,NULL),(23052,'24868','S','Keystone','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.381371,-81.410642,0,'2013-07-06 12:44:31',NULL,NULL),(18247,'18991','U','W Atlee Burpee Co','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.218695,-75.075680,0,'2013-07-06 12:44:31',NULL,NULL),(38130,'43119','S','Galloway','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.936720,-83.194440,0,'2013-07-06 12:44:32',NULL,NULL),(47629,'54912','P','Grand Chute','A','Outagamie','55087','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.266623,-88.434674,0,'2013-07-06 12:44:33',NULL,NULL),(570,'00678','S','Urb Santa Marina','N','Quebradillas','72115','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.474927,-66.937286,0,'2013-07-06 12:44:30',NULL,NULL),(61499,'72645','S','Oxley','N','Searcy','05129','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.826780,-92.575020,0,'2013-07-06 12:44:33',NULL,NULL),(59322,'70527','P','Crowley','D','Acadia','22001','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.231737,-92.378907,0,'2013-07-06 12:44:33',NULL,NULL),(56604,'65560','S','Timber','N','Dent','29065','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.608360,-91.524300,0,'2013-07-06 12:44:33',NULL,NULL),(54685,'62943','S','New Columbia','N','Johnson','17087','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.379602,-88.764190,0,'2013-07-06 12:44:33',NULL,NULL),(38118,'43110','S','Canal Whchstr','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.827570,-82.794186,0,'2013-07-06 12:44:32',NULL,NULL),(37904,'42633','S','Delta','A','Wayne','21231','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.834130,-84.845607,0,'2013-07-06 12:44:32',NULL,NULL),(13658,'14021','P','Batavia','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.018919,-78.163893,0,'2013-07-06 12:44:31',NULL,NULL),(26212,'28785','S','Waynesville','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.574687,-83.010377,0,'2013-07-06 12:44:31',NULL,NULL),(36306,'40371','S','Salt Lick','D','Bath','21011','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.084878,-83.623075,0,'2013-07-06 12:44:32',NULL,NULL),(70080,'84152','P','Salt Lake City','D','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725327,-111.859692,0,'2013-07-06 12:44:34',NULL,NULL),(65606,'77903','P','Victoria','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.794880,-97.004106,0,'2013-07-06 12:44:34',NULL,NULL),(53921,'62401','S','Blue Point','N','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.122640,-88.587960,0,'2013-07-06 12:44:33',NULL,NULL),(53279,'61726','S','Meadows','N','McLean','17113','Illinois','IL','17','1040','815/779','Central',-6.0,'Y',40.743720,-88.717320,0,'2013-07-06 12:44:33',NULL,NULL),(40203,'45387','S','Yellow Springs','D','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.798844,-83.897655,0,'2013-07-06 12:44:32',NULL,NULL),(32909,'36545','S','Walker Springs','A','Clarke','01025','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.527175,-87.891357,0,'2013-07-06 12:44:32',NULL,NULL),(26105,'28721','S','Clyde','D','Haywood','37087','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.538721,-82.915332,0,'2013-07-06 12:44:31',NULL,NULL),(25118,'27985','P','Winfall','D','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.209308,-76.453104,0,'2013-07-06 12:44:31',NULL,NULL),(22117,'23433','S','Crittenden','N','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.906300,-76.492560,0,'2013-07-06 12:44:31',NULL,NULL),(37889,'42602','S','Seventy Six','A','Clinton','21053','Kentucky','KY','21','0000','606','Central',-6.0,'Y',36.691259,-85.133802,0,'2013-07-06 12:44:32',NULL,NULL),(77397,'96776','P','Paauilo','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.925429,-155.435559,0,'2013-07-06 12:44:34',NULL,NULL),(58237,'68352','S','Powell','N','Jefferson','31095','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.156080,-97.171800,0,'2013-07-06 12:44:33',NULL,NULL),(49221,'56467','S','Nevis','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.876449,-94.807054,0,'2013-07-06 12:44:33',NULL,NULL),(15527,'16546','U','Erie','D','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.109206,-80.048241,0,'2013-07-06 12:44:31',NULL,NULL),(32554,'36112','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.366580,-86.299980,0,'2013-07-06 12:44:32',NULL,NULL),(31873,'35124','S','Indn Spgs Vlg','A','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.301860,-86.791800,0,'2013-07-06 12:44:32',NULL,NULL),(30806,'33613','S','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.075939,-82.450560,0,'2013-07-06 12:44:32',NULL,NULL),(25265,'28124','S','Mount Pleasant','D','Cabarrus','37025','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.411081,-80.419470,0,'2013-07-06 12:44:31',NULL,NULL),(15295,'16134','S','Westford','A','Mercer','42085','Pennsylvania','PA','42','7610','724/878','Eastern',-5.0,'Y',41.497920,-80.449020,0,'2013-07-06 12:44:31',NULL,NULL),(79636,'99134','S','Harrington','D','Lincoln','53043','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.418159,-118.325713,0,'2013-07-06 12:44:34',NULL,NULL),(76168,'95321','S','Groveland','D','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',37.885110,-119.854250,0,'2013-07-06 12:44:34',NULL,NULL),(74379,'92505','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.919916,-117.486689,0,'2013-07-06 12:44:34',NULL,NULL),(68045,'80930','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.830904,-104.513630,0,'2013-07-06 12:44:34',NULL,NULL),(59817,'71232','S','Waverly','A','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.453833,-91.489746,0,'2013-07-06 12:44:33',NULL,NULL),(53502,'62013','S','Deer Plain','N','Calhoun','17013','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.966280,-90.600120,0,'2013-07-06 12:44:33',NULL,NULL),(10687,'11212','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.663426,-73.912354,0,'2013-07-06 12:44:30',NULL,NULL),(2233,'00926','S','Urb Fairview','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(30682,'33470','S','Vlg Wellingtn','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.722172,-80.306749,0,'2013-07-06 12:44:32',NULL,NULL),(12022,'12511','P','Castle Point','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.528219,-73.963443,0,'2013-07-06 12:44:30',NULL,NULL),(9505,'10014','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.733960,-74.005276,0,'2013-07-06 12:44:30',NULL,NULL),(74798,'93199','U','Santa Barbara P & D Ctr','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.489743,-120.039532,0,'2013-07-06 12:44:34',NULL,NULL),(5605,'04930','S','Ripley','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.025984,-69.285426,0,'2013-07-06 12:44:30',NULL,NULL),(34856,'38926','P','Elliott','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.780085,-89.827085,0,'2013-07-06 12:44:32',NULL,NULL),(33397,'37222','P','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.068877,-86.726246,0,'2013-07-06 12:44:32',NULL,NULL),(20030,'20634','S','Great Mills','D','Saint Marys','24037','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',38.257775,-76.494134,0,'2013-07-06 12:44:31',NULL,NULL),(43654,'48847','S','Ithaca','D','Gratiot','26057','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.271092,-84.592337,0,'2013-07-06 12:44:32',NULL,NULL),(55814,'64147','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.852262,-94.547801,0,'2013-07-06 12:44:33',NULL,NULL),(14121,'14646','U','Rochester','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.151509,-77.605675,0,'2013-07-06 12:44:31',NULL,NULL),(75731,'94595','S','Walnut Creek','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.870524,-122.072952,0,'2013-07-06 12:44:34',NULL,NULL),(53962,'62428','S','Diona','N','Cumberland','17035','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.202222,-88.041111,0,'2013-07-06 12:44:33',NULL,NULL),(51780,'60041','S','Volo','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.357735,-88.163789,0,'2013-07-06 12:44:33',NULL,NULL),(19595,'20224','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.890942,-77.027831,0,'2013-07-06 12:44:31',NULL,NULL),(36542,'40902','S','Arjay','D','Bell','21013','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.842039,-83.640103,0,'2013-07-06 12:44:32',NULL,NULL),(33294,'37128','S','Murfreesbr','N','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.815518,-86.451250,0,'2013-07-06 12:44:32',NULL,NULL),(25522,'28390','S','Spring Lake','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.175116,-78.976743,0,'2013-07-06 12:44:31',NULL,NULL),(78058,'97455','S','Eugene','A','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',43.970221,-122.916439,0,'2013-07-06 12:44:34',NULL,NULL),(75487,'94123','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.801619,-122.435242,0,'2013-07-06 12:44:34',NULL,NULL),(63774,'75951','S','Beech Grove','N','Jasper','48241','Texas','TX','48','0000','409','Central',-6.0,'Y',30.935280,-94.016580,0,'2013-07-06 12:44:34',NULL,NULL),(5135,'04413','S','Frst City Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.579310,-67.727269,0,'2013-07-06 12:44:30',NULL,NULL),(28161,'30905','S','Ft Gordon','N','Richmond','13245','Georgia','GA','13','0600','706/762','Eastern',-5.0,'Y',33.403925,-82.120051,0,'2013-07-06 12:44:31',NULL,NULL),(21937,'23229','S','Westbury','N','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.602592,-77.557517,0,'2013-07-06 12:44:31',NULL,NULL),(21710,'22976','S','Tyro','D','Nelson','51125','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.921586,-78.945010,0,'2013-07-06 12:44:31',NULL,NULL),(49623,'56915','U','Parcel Return Service','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.896263,-77.036490,0,'2013-07-06 12:44:33',NULL,NULL),(62277,'74015','S','Port of Catoo','N','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.186268,-95.744614,0,'2013-07-06 12:44:33',NULL,NULL),(310,'00646','S','Urb Montelindo','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(73024,'90071','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.053598,-118.255851,0,'2013-07-06 12:44:34',NULL,NULL),(71363,'86545','P','Rock Point','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.718409,-109.622723,0,'2013-07-06 12:44:34',NULL,NULL),(48957,'56177','P','Trosky','D','Pipestone','27117','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.885969,-96.255583,0,'2013-07-06 12:44:33',NULL,NULL),(31217,'33955','S','Punta Gorda','D','Charlotte','12015','Florida','FL','12','6580','941','Eastern',-5.0,'Y',26.839940,-81.997611,0,'2013-07-06 12:44:32',NULL,NULL),(28174,'31001','S','Abbeville','D','Wilcox','13315','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.991336,-83.313050,0,'2013-07-06 12:44:31',NULL,NULL),(26108,'28723','S','East Laport','N','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.284272,-83.179192,0,'2013-07-06 12:44:31',NULL,NULL),(19269,'19956','S','Laurel','D','Sussex','10005','Delaware','DE','10','0000','302','Eastern',-5.0,'Y',38.552450,-75.569735,0,'2013-07-06 12:44:31',NULL,NULL),(3518,'01886','S','Forge Village','N','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.589321,-71.437474,0,'2013-07-06 12:44:30',NULL,NULL),(61739,'73031','P','Dibble','D','McClain','40087','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.031916,-97.626840,0,'2013-07-06 12:44:33',NULL,NULL),(52573,'60964','S','St Anne','N','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.023177,-87.716807,0,'2013-07-06 12:44:33',NULL,NULL),(51205,'59038','S','Hysham','D','Treasure','30103','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.288514,-107.232251,0,'2013-07-06 12:44:33',NULL,NULL),(39062,'44198','U','Ohio Motorists','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.493668,-81.676246,0,'2013-07-06 12:44:32',NULL,NULL),(8054,'07739','S','Little Silver','D','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.334913,-74.044900,0,'2013-07-06 12:44:30',NULL,NULL),(79373,'98663','S','Vancouver','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.652447,-122.656498,0,'2013-07-06 12:44:34',NULL,NULL),(55466,'63740','S','Randles','N','Scott','29201','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.185720,-89.647920,0,'2013-07-06 12:44:33',NULL,NULL),(54436,'62840','P','Frankfort Hts','A','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.900295,-88.840796,0,'2013-07-06 12:44:33',NULL,NULL),(53916,'62376','S','Ursa','D','Adams','17001','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.080169,-91.411941,0,'2013-07-06 12:44:33',NULL,NULL),(51901,'60102','S','Barrington Hills','N','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.170820,-88.318740,0,'2013-07-06 12:44:33',NULL,NULL),(26830,'29487','S','Wadmalaw Is','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.653461,-80.187416,0,'2013-07-06 12:44:31',NULL,NULL),(79963,'99637','P','Toksook Bay','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.605545,-164.759764,0,'2013-07-06 12:44:34',NULL,NULL),(60760,'72005','S','Amagon','D','Jackson','05067','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.554257,-91.080965,0,'2013-07-06 12:44:33',NULL,NULL),(60696,'71940','S','Piney Grove','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(53187,'61607','S','High Meadows','N','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.652745,-89.668522,0,'2013-07-06 12:44:33',NULL,NULL),(11025,'11561','S','Lido Beach','A','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.585753,-73.657497,0,'2013-07-06 12:44:30',NULL,NULL),(34558,'38726','S','Beulah','D','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.786816,-90.981417,0,'2013-07-06 12:44:32',NULL,NULL),(25168,'28040','S','Dobbinsville','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.400480,-81.757380,0,'2013-07-06 12:44:31',NULL,NULL),(12059,'12533','S','Wiccopee','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.573590,-73.796075,0,'2013-07-06 12:44:30',NULL,NULL),(16876,'17569','S','Swartzville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.276083,-76.123914,0,'2013-07-06 12:44:31',NULL,NULL),(18083,'18706','S','Hanover Twp','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.207017,-75.923776,0,'2013-07-06 12:44:31',NULL,NULL),(76209,'95363','S','Grayson','N','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.486062,-121.129906,0,'2013-07-06 12:44:34',NULL,NULL),(34244,'38388','S','Wildersville','D','Henderson','47077','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.721022,-88.390326,0,'2013-07-06 12:44:32',NULL,NULL),(19046,'19540','S','Knauers','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.284584,-75.988345,0,'2013-07-06 12:44:31',NULL,NULL),(26185,'28759','S','Mills River','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.301536,-82.581486,0,'2013-07-06 12:44:31',NULL,NULL),(21825,'23112','S','Midlothian','D','Chesterfield','51041','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.433683,-77.647870,0,'2013-07-06 12:44:31',NULL,NULL),(40252,'45430','S','Beavercreek Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.706775,-84.084303,0,'2013-07-06 12:44:32',NULL,NULL),(46152,'52660','S','Yarmouth','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.032221,-91.314680,0,'2013-07-06 12:44:32',NULL,NULL),(62088,'73566','S','Snyder','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.657358,-98.952847,0,'2013-07-06 12:44:33',NULL,NULL),(62672,'74651','S','Red Rock','D','Noble','40103','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.476998,-97.170438,0,'2013-07-06 12:44:33',NULL,NULL),(64919,'77205','P','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.955096,-95.335741,0,'2013-07-06 12:44:34',NULL,NULL),(67217,'79920','P','Wbamc','N','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.823595,-106.463282,0,'2013-07-06 12:44:34',NULL,NULL),(67668,'80488','P','Steamboat Spr','A','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.476275,-106.850394,0,'2013-07-06 12:44:34',NULL,NULL),(69116,'83274','S','Shelley','D','Bingham','16011','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.379837,-112.124740,0,'2013-07-06 12:44:34',NULL,NULL),(73939,'92051','P','Oceanside','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.201512,-117.370224,0,'2013-07-06 12:44:34',NULL,NULL),(1116,'00725','S','Urb Santa Juana 3','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(76615,'95695','S','Woodland','D','Yolo','06113','California','CA','06','9270','530','Pacific',-8.0,'Y',38.675457,-121.776397,0,'2013-07-06 12:44:34',NULL,NULL),(74484,'92612','S','Irvine','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.648309,-117.821853,0,'2013-07-06 12:44:34',NULL,NULL),(72052,'88103','P','Cannon AFB','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.395300,-103.324380,0,'2013-07-06 12:44:34',NULL,NULL),(68473,'81242','P','Poncha Spgs','A','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.514511,-106.074083,0,'2013-07-06 12:44:34',NULL,NULL),(54389,'62817','S','South Twigg','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.960013,-88.453753,0,'2013-07-06 12:44:33',NULL,NULL),(37383,'41749','S','Dryhill','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.164468,-83.437621,0,'2013-07-06 12:44:32',NULL,NULL),(12104,'12578','S','Salt Point','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.796696,-73.794052,0,'2013-07-06 12:44:30',NULL,NULL),(10356,'10578','S','Purdy Station','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.320695,-73.679913,0,'2013-07-06 12:44:30',NULL,NULL),(20330,'20842','S','Dickerson','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.204180,-77.421720,0,'2013-07-06 12:44:31',NULL,NULL),(38095,'43082','S','Westerville','D','Delaware','39041','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.121049,-82.929557,0,'2013-07-06 12:44:32',NULL,NULL),(54095,'62532','P','Elwin','D','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.777219,-88.981540,0,'2013-07-06 12:44:33',NULL,NULL),(64465,'76574','S','Rices Crossing','N','Williamson','48491','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.575729,-97.415968,0,'2013-07-06 12:44:34',NULL,NULL),(58011,'67871','S','Friend','A','Scott','20171','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.479020,-100.891440,0,'2013-07-06 12:44:33',NULL,NULL),(53917,'62378','S','Versailles','D','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.889092,-90.657738,0,'2013-07-06 12:44:33',NULL,NULL),(42647,'47933','S','Crawfordsville','D','Montgomery','18107','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.034074,-86.907942,0,'2013-07-06 12:44:32',NULL,NULL),(42015,'47432','S','Norton','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.545144,-86.619616,0,'2013-07-06 12:44:32',NULL,NULL),(20096,'20703','P','Seabrook','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.966944,-76.862222,0,'2013-07-06 12:44:31',NULL,NULL),(13653,'14012','S','Barker','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.338643,-78.531618,0,'2013-07-06 12:44:31',NULL,NULL),(23353,'25264','S','Mount Alto','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.865477,-81.880550,0,'2013-07-06 12:44:31',NULL,NULL),(4241,'02865','S','Lincoln','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.910259,-71.438038,0,'2013-07-06 12:44:30',NULL,NULL),(4544,'03446','S','Swanzey Center','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.854142,-72.260794,0,'2013-07-06 12:44:30',NULL,NULL),(65945,'78260','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.707290,-98.483007,0,'2013-07-06 12:44:34',NULL,NULL),(57881,'67625','S','Bogue','D','Graham','20065','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.418191,-99.677529,0,'2013-07-06 12:44:33',NULL,NULL),(54344,'62769','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.805964,-89.643223,0,'2013-07-06 12:44:33',NULL,NULL),(53254,'61701','S','Oldtown','N','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.475580,-89.004720,0,'2013-07-06 12:44:33',NULL,NULL),(42339,'47637','S','Folsomville','A','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.128740,-87.148763,0,'2013-07-06 12:44:32',NULL,NULL),(40870,'46235','S','Oaklandon','A','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.768333,-86.158056,0,'2013-07-06 12:44:32',NULL,NULL),(20202,'20755','S','Fort George Meade','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.109680,-76.736935,0,'2013-07-06 12:44:31',NULL,NULL),(32614,'36140','U','AL Revenue Dept','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382875,-86.146711,0,'2013-07-06 12:44:32',NULL,NULL),(15618,'16689','S','Waterfall','D','Fulton','42057','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.079150,-78.055028,0,'2013-07-06 12:44:31',NULL,NULL),(27828,'30415','S','Akin','N','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.371613,-81.670188,0,'2013-07-06 12:44:31',NULL,NULL),(69490,'83687','S','Nampa','D','Canyon','16027','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.595223,-116.536483,0,'2013-07-06 12:44:34',NULL,NULL),(68873,'82640','P','Linch','D','Johnson','56019','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',43.603763,-106.191855,0,'2013-07-06 12:44:34',NULL,NULL),(49581,'56734','S','Lake Bronson','D','Kittson','27069','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.845443,-96.562653,0,'2013-07-06 12:44:33',NULL,NULL),(48559,'55764','P','Marble','D','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.322198,-93.302759,0,'2013-07-06 12:44:33',NULL,NULL),(28606,'31702','P','Albany','D','Dougherty','13095','Georgia','GA','13','0120','229','Eastern',-5.0,'Y',31.598251,-84.199958,0,'2013-07-06 12:44:32',NULL,NULL),(23988,'26330','S','Brushy Fork','A','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.289276,-80.254283,0,'2013-07-06 12:44:31',NULL,NULL),(52744,'61241','S','Cleveland','A','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.481385,-90.329909,0,'2013-07-06 12:44:33',NULL,NULL),(55005,'63131','S','Frontenac','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(61649,'72857','S','Plainview','D','Yell','05149','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.990157,-93.299478,0,'2013-07-06 12:44:33',NULL,NULL),(77657,'97021','S','Dufur','D','Wasco','41065','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.421839,-121.162820,0,'2013-07-06 12:44:34',NULL,NULL),(73546,'91357','P','Tarzana','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.172643,-118.540408,0,'2013-07-06 12:44:34',NULL,NULL),(71880,'87732','S','Mora','D','Mora','35033','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.059286,-105.288077,0,'2013-07-06 12:44:34',NULL,NULL),(60277,'71448','P','Longleaf','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.008725,-92.553968,0,'2013-07-06 12:44:33',NULL,NULL),(59334,'70540','P','Garden City','D','Saint Mary','22101','Louisiana','LA','22','0000','337','Central',-6.0,'Y',29.765709,-91.467397,0,'2013-07-06 12:44:33',NULL,NULL),(18201,'18940','S','Wrightstown','N','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.245694,-74.942426,0,'2013-07-06 12:44:31',NULL,NULL),(21109,'22060','S','Ft Belvoir','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.712147,-77.158616,0,'2013-07-06 12:44:31',NULL,NULL),(22527,'24101','S','Hardy','D','Franklin','51067','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.170582,-79.740775,0,'2013-07-06 12:44:31',NULL,NULL),(1578,'00767','S','Urb Santa Maria','N','Yabucoa','72151','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.051521,-65.880880,0,'2013-07-06 12:44:30',NULL,NULL),(8671,'08324','S','Heislerville','D','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.249636,-74.994012,0,'2013-07-06 12:44:30',NULL,NULL),(60837,'72040','S','Des Arc','D','Prairie','05117','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.958367,-91.509222,0,'2013-07-06 12:44:33',NULL,NULL),(60831,'72038','S','Crocketts Bluff','D','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.421824,-91.227791,0,'2013-07-06 12:44:33',NULL,NULL),(59734,'71118','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.395437,-93.803021,0,'2013-07-06 12:44:33',NULL,NULL),(31486,'34433','S','Citrus Springs','A','Citrus','12017','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.004097,-82.522871,0,'2013-07-06 12:44:32',NULL,NULL),(30593,'33420','P','Palm Bch Gdns','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.855333,-80.083047,0,'2013-07-06 12:44:32',NULL,NULL),(17647,'18072','S','Pen Argyl','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.860324,-75.257256,0,'2013-07-06 12:44:31',NULL,NULL),(17933,'18472','S','Waymart','D','Wayne','42127','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.583823,-75.409378,0,'2013-07-06 12:44:31',NULL,NULL),(51225,'59059','S','Musselshell','D','Musselshell','30065','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.514989,-108.090082,0,'2013-07-06 12:44:33',NULL,NULL),(55201,'63383','S','Warrenton','D','Warren','29219','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.771220,-91.224360,0,'2013-07-06 12:44:33',NULL,NULL),(76211,'95364','S','Dardanelle','A','Tuolumne','06109','California','CA','06','0000','209','Pacific',-8.0,'Y',38.320730,-119.823875,0,'2013-07-06 12:44:34',NULL,NULL),(74703,'93005','P','Ventura','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.250131,-119.202985,0,'2013-07-06 12:44:34',NULL,NULL),(68773,'82322','P','Lamont','N','Sweetwater','56037','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.238410,-107.560162,0,'2013-07-06 12:44:34',NULL,NULL),(15994,'17036','S','Hummelstown','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.277580,-76.708800,0,'2013-07-06 12:44:31',NULL,NULL),(17354,'17872','S','Coal','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.820340,-76.555680,0,'2013-07-06 12:44:31',NULL,NULL),(21001,'21835','S','Linkwood','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.535786,-75.953036,0,'2013-07-06 12:44:31',NULL,NULL),(20422,'20910','S','Takoma Pk','N','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.998735,-77.036543,0,'2013-07-06 12:44:31',NULL,NULL),(45420,'51054','S','Sgt Bluff','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.407067,-96.357402,0,'2013-07-06 12:44:32',NULL,NULL),(45684,'52044','S','Elkport','D','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.738977,-91.278923,0,'2013-07-06 12:44:32',NULL,NULL),(13737,'14107','P','Model City','D','Niagara','36063','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.193133,-78.983270,0,'2013-07-06 12:44:31',NULL,NULL),(78183,'97709','P','Bend','D','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.069081,-121.311942,0,'2013-07-06 12:44:34',NULL,NULL),(71715,'87530','S','Las Placitas','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.322492,-106.283634,0,'2013-07-06 12:44:34',NULL,NULL),(14937,'15561','P','Sipesville','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.101376,-79.094471,0,'2013-07-06 12:44:31',NULL,NULL),(74161,'92262','S','Smoke Tree','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.856934,-116.563137,0,'2013-07-06 12:44:34',NULL,NULL),(71492,'87105','S','Los Padillas','N','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.043217,-106.694148,0,'2013-07-06 12:44:34',NULL,NULL),(54459,'62853','S','Haines','N','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.541111,-88.912222,0,'2013-07-06 12:44:33',NULL,NULL),(43003,'48160','S','Stony Creek','N','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.110465,-83.684175,0,'2013-07-06 12:44:32',NULL,NULL),(37757,'42328','S','Centertown','D','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.419834,-86.994628,0,'2013-07-06 12:44:32',NULL,NULL),(467,'00664','S','Urb Hayuya','N','Jayuya','72073','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.219830,-66.591354,0,'2013-07-06 12:44:30',NULL,NULL),(68486,'81252','S','Tanglewood Acres','N','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.114881,-105.429189,0,'2013-07-06 12:44:34',NULL,NULL),(66439,'78645','S','Point Venture','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.447624,-97.980615,0,'2013-07-06 12:44:34',NULL,NULL),(56495,'65337','S','La Monte','D','Pettis','29159','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.772698,-93.426159,0,'2013-07-06 12:44:33',NULL,NULL),(47220,'54495','S','Wisc Rapids','A','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.404404,-89.867303,0,'2013-07-06 12:44:32',NULL,NULL),(38314,'43402','S','Bowling Green','D','Wood','39173','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.387758,-83.653281,0,'2013-07-06 12:44:32',NULL,NULL),(19929,'20559','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887950,-77.005785,0,'2013-07-06 12:44:31',NULL,NULL),(1028,'00718','S','Villa del Rosario','N','Naguabo','72103','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.214923,-65.732399,0,'2013-07-06 12:44:30',NULL,NULL),(16455,'17240','S','Newburg','D','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.116059,-77.602385,0,'2013-07-06 12:44:31',NULL,NULL),(72066,'88120','S','Grady','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.821627,-103.313553,0,'2013-07-06 12:44:34',NULL,NULL),(48650,'55905','U','Rochester','D','Olmsted','27109','Minnesota','MN','27','6820','507','Central',-6.0,'Y',44.037368,-92.490118,0,'2013-07-06 12:44:33',NULL,NULL),(37668,'42211','S','Golden Pond','A','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(8505,'08098','S','Pilesgrove Township','A','Salem','34033','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.651717,-75.330001,0,'2013-07-06 12:44:30',NULL,NULL),(10720,'11249','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.750696,-74.000690,0,'2013-07-06 12:44:30',NULL,NULL),(76955,'96039','S','Happy Camp','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.724456,-123.418504,0,'2013-07-06 12:44:34',NULL,NULL),(55096,'63303','S','Saint Charles','D','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.752200,-90.537720,0,'2013-07-06 12:44:33',NULL,NULL),(51716,'60010','S','Inverness','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(51209,'59041','S','Silesia','A','Carbon','30009','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.499020,-108.989580,0,'2013-07-06 12:44:33',NULL,NULL),(42078,'47454','S','Stampers Creek','N','Orange','18117','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.555193,-86.468358,0,'2013-07-06 12:44:32',NULL,NULL),(36858,'41081','P','Plummers Landing','D','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.304959,-83.569924,0,'2013-07-06 12:44:32',NULL,NULL),(24135,'26555','P','Whitehall','A','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.470255,-80.150258,0,'2013-07-06 12:44:31',NULL,NULL),(24246,'26764','S','Hopemont','A','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.444161,-79.544620,0,'2013-07-06 12:44:31',NULL,NULL),(16534,'17271','S','Willow Hill','D','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.110786,-77.793814,0,'2013-07-06 12:44:31',NULL,NULL),(28345,'31195','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.806070,-84.477521,0,'2013-07-06 12:44:32',NULL,NULL),(26263,'29009','S','Bethune','D','Kershaw','45055','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.433803,-80.368950,0,'2013-07-06 12:44:31',NULL,NULL),(21447,'22580','S','Woodford','D','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.098990,-77.534121,0,'2013-07-06 12:44:31',NULL,NULL),(68186,'81023','S','Beulah','D','Pueblo','08101','Colorado','CO','08','6560','719','Mountain',-7.0,'Y',38.073947,-104.953614,0,'2013-07-06 12:44:34',NULL,NULL),(67479,'80227','S','Lakewood','A','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.666540,-105.096180,0,'2013-07-06 12:44:34',NULL,NULL),(65600,'77901','S','Cologne','N','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.706750,-97.181430,0,'2013-07-06 12:44:34',NULL,NULL),(62642,'74570','S','Ashland','A','Hughes','40063','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.895073,-96.157838,0,'2013-07-06 12:44:33',NULL,NULL),(46947,'54166','S','Thornton','N','Shawano','55115','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.780208,-88.590326,0,'2013-07-06 12:44:32',NULL,NULL),(502,'00674','S','Hacienda La Monserrate','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(22391,'23943','P','Hmpden Sydney','A','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.240559,-78.457075,0,'2013-07-06 12:44:31',NULL,NULL),(23548,'25625','S','Holden','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.829550,-82.040681,0,'2013-07-06 12:44:31',NULL,NULL),(24468,'27239','S','Handy','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.617560,-80.110920,0,'2013-07-06 12:44:31',NULL,NULL),(4803,'03884','S','Strafford','D','Strafford','33017','New Hampshire','NH','33','6450','603','Eastern',-5.0,'Y',43.232808,-71.131735,0,'2013-07-06 12:44:30',NULL,NULL),(36033,'40176','S','Raymond','A','Breckinridge','21027','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.929066,-86.394425,0,'2013-07-06 12:44:32',NULL,NULL),(5281,'04497','S','Wytopitlock','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.698333,-68.101094,0,'2013-07-06 12:44:30',NULL,NULL),(67438,'80202','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.749412,-104.993661,0,'2013-07-06 12:44:34',NULL,NULL),(66180,'78535','P','Comby','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.250563,-97.729406,0,'2013-07-06 12:44:34',NULL,NULL),(60227,'71429','S','Mount Carmel','N','Sabine','22085','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.562771,-93.478790,0,'2013-07-06 12:44:33',NULL,NULL),(32717,'36303','S','Kinsey','A','Houston','01069','Alabama','AL','01','2180','334','Central',-6.0,'Y',31.254240,-85.398900,0,'2013-07-06 12:44:32',NULL,NULL),(7056,'06320','S','United States Coast Guard','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.351139,-72.108165,0,'2013-07-06 12:44:30',NULL,NULL),(16691,'17371','P','York Nw Salem','A','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.901600,-76.791415,0,'2013-07-06 12:44:31',NULL,NULL),(37005,'41222','S','Leander','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.795350,-82.819772,0,'2013-07-06 12:44:32',NULL,NULL),(37731,'42285','S','Sweeden','D','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.262476,-86.279063,0,'2013-07-06 12:44:32',NULL,NULL),(48771,'55987','S','Goodview','A','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.037660,-91.674900,0,'2013-07-06 12:44:33',NULL,NULL),(57787,'67478','P','Simpson','D','Mitchell','20123','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.382800,-97.933251,0,'2013-07-06 12:44:33',NULL,NULL),(63327,'75572','S','Queen City','D','Cass','48067','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.175260,-94.152300,0,'2013-07-06 12:44:33',NULL,NULL),(42652,'47943','S','Fair Oaks','D','Jasper','18073','Indiana','IN','18','0000','219','Central',-6.0,'Y',41.070599,-87.210287,0,'2013-07-06 12:44:32',NULL,NULL),(6938,'06167','U','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.768325,-72.682921,0,'2013-07-06 12:44:30',NULL,NULL),(18099,'18709','S','Wilkes Barre','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.281505,-75.894483,0,'2013-07-06 12:44:31',NULL,NULL),(512,'00674','S','Repto Marista','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(29155,'32344','S','Monticello','D','Jefferson','12065','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.545766,-83.865130,0,'2013-07-06 12:44:32',NULL,NULL),(77919,'97314','U','Salem','D','Marion','41047','Oregon','OR','41','7080','503/971','Pacific',-8.0,'Y',44.966960,-123.004587,0,'2013-07-06 12:44:34',NULL,NULL),(75515,'94146','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.760148,-122.433279,0,'2013-07-06 12:44:34',NULL,NULL),(72364,'89026','U','So Nev Correctional Ctr','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.778436,-115.325816,0,'2013-07-06 12:44:34',NULL,NULL),(71089,'85932','P','Nutrioso','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.954516,-109.209744,0,'2013-07-06 12:44:34',NULL,NULL),(68805,'82432','S','Manderson','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.273330,-107.946537,0,'2013-07-06 12:44:34',NULL,NULL),(56417,'65256','S','Harrisburg','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.126631,-92.438081,0,'2013-07-06 12:44:33',NULL,NULL),(28793,'32054','S','Lake Butler','D','Union','12125','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.022895,-82.341708,0,'2013-07-06 12:44:32',NULL,NULL),(23389,'25312','S','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.386908,-81.665551,0,'2013-07-06 12:44:31',NULL,NULL),(17949,'18512','S','Dunmore','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.420505,-75.625001,0,'2013-07-06 12:44:31',NULL,NULL),(21287,'22334','U','Alexandria','D','Alexandria City','51510','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.803177,-77.058685,0,'2013-07-06 12:44:31',NULL,NULL),(1989,'00908','P','San Juan','D','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.444163,-66.079468,0,'2013-07-06 12:44:30',NULL,NULL),(58570,'68827','S','Chapman','D','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.999123,-98.204492,0,'2013-07-06 12:44:33',NULL,NULL),(41584,'47041','S','Penntown','N','Ripley','18137','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.254220,-85.067460,0,'2013-07-06 12:44:32',NULL,NULL),(14570,'15216','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(34081,'38152','U','Mem','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.120123,-89.939705,0,'2013-07-06 12:44:32',NULL,NULL),(24575,'27313','S','Pleasant Gdn','A','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.952898,-79.757191,0,'2013-07-06 12:44:31',NULL,NULL),(21171,'22156','U','Firm Zip','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.776500,-77.186403,0,'2013-07-06 12:44:31',NULL,NULL),(40654,'46039','S','Forest','D','Clinton','18023','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.377511,-86.313689,0,'2013-07-06 12:44:32',NULL,NULL),(38704,'44004','S','Ashtabula','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.850540,-80.777400,0,'2013-07-06 12:44:32',NULL,NULL),(34245,'38389','P','Yorkville','D','Gibson','47053','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.077305,-89.060592,0,'2013-07-06 12:44:32',NULL,NULL),(66549,'78733','S','Bee Cave','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.321780,-97.895100,0,'2013-07-06 12:44:34',NULL,NULL),(58074,'68061','S','Tekamah','D','Burt','31021','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.775728,-96.223201,0,'2013-07-06 12:44:33',NULL,NULL),(52076,'60401','S','Eagle Lake','N','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.355724,-87.607332,0,'2013-07-06 12:44:33',NULL,NULL),(47002,'54247','S','Branch','A','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.183956,-87.792516,0,'2013-07-06 12:44:32',NULL,NULL),(45152,'50588','S','Bel Air Beach','N','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.641049,-95.202540,0,'2013-07-06 12:44:32',NULL,NULL),(43563,'48726','S','Cass City','D','Tuscola','26157','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.592764,-83.199936,0,'2013-07-06 12:44:32',NULL,NULL),(5024,'04241','P','Lewiston','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.085850,-70.170085,0,'2013-07-06 12:44:30',NULL,NULL),(17973,'18614','S','Forkston Township','A','Sullivan','42113','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.522494,-76.401012,0,'2013-07-06 12:44:31',NULL,NULL),(26346,'29067','S','Abney','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.498309,-80.520734,0,'2013-07-06 12:44:31',NULL,NULL),(27649,'30320','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.635644,-84.433286,0,'2013-07-06 12:44:31',NULL,NULL),(36910,'41135','S','Head of Grassy','A','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.380556,-83.260136,0,'2013-07-06 12:44:32',NULL,NULL),(3445,'01760','S','North Natick','N','Middlesex','25017','Massachusetts','MA','25','1120','508/774','Eastern',-5.0,'Y',42.287156,-71.352308,0,'2013-07-06 12:44:30',NULL,NULL),(35045,'39175','S','Cayuga','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.120866,-90.599332,0,'2013-07-06 12:44:32',NULL,NULL),(13165,'13607','S','St Lawrence Park','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.331922,-75.917693,0,'2013-07-06 12:44:30',NULL,NULL),(31510,'34461','S','Lecanto','D','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.815855,-82.481143,0,'2013-07-06 12:44:32',NULL,NULL),(30628,'33441','S','Deerfield Bch','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.312859,-80.104367,0,'2013-07-06 12:44:32',NULL,NULL),(66,'00612','S','Bo Islote','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(65384,'77550','S','Galveston','D','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.301240,-94.788420,0,'2013-07-06 12:44:34',NULL,NULL),(59992,'71328','S','Buckeye','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.359785,-92.203943,0,'2013-07-06 12:44:33',NULL,NULL),(59371,'70589','S','Washington','D','Saint Landry','22097','Louisiana','LA','22','3880','337','Central',-6.0,'Y',30.611138,-92.058035,0,'2013-07-06 12:44:33',NULL,NULL),(40457,'45743','S','Long Bottom','D','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.078125,-81.856643,0,'2013-07-06 12:44:32',NULL,NULL),(38521,'43727','S','Chandlersvlle','A','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.877305,-81.810514,0,'2013-07-06 12:44:32',NULL,NULL),(7115,'06377','S','North Sterling','N','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.719140,-71.818560,0,'2013-07-06 12:44:30',NULL,NULL),(525,'00674','S','Urb Santa Teresa','N','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(16965,'17703','P','Williamsport','D','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.237840,-77.001639,0,'2013-07-06 12:44:31',NULL,NULL),(14418,'15068','S','New Kensington','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(29648,'32904','S','Melbourne','D','Brevard','12009','Florida','FL','12','4900','321','Eastern',-5.0,'Y',28.074548,-80.694237,0,'2013-07-06 12:44:32',NULL,NULL),(29255,'32449','S','Kinard','A','Calhoun','12013','Florida','FL','12','0000','850','Central',-6.0,'Y',30.270733,-85.198121,0,'2013-07-06 12:44:32',NULL,NULL),(29176,'32359','S','Jena','N','Taylor','12123','Florida','FL','12','0000','352','Eastern',-5.0,'Y',29.676861,-83.378046,0,'2013-07-06 12:44:32',NULL,NULL),(10192,'10302','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.629815,-74.138408,0,'2013-07-06 12:44:30',NULL,NULL),(9615,'10033','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.847553,-73.936012,0,'2013-07-06 12:44:30',NULL,NULL),(2421,'00953','S','Mans del Toa','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(79921,'99606','P','Kokhonak','N','Lake and Peninsula','02164','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.613300,-155.276220,0,'2013-07-06 12:44:34',NULL,NULL),(77006,'96084','P','Round Mtn','A','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.774706,-121.988586,0,'2013-07-06 12:44:34',NULL,NULL),(60890,'72068','S','Higgson','N','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.181008,-91.715439,0,'2013-07-06 12:44:33',NULL,NULL),(56479,'65325','S','Cole Camp','D','Benton','29015','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.449974,-93.217748,0,'2013-07-06 12:44:33',NULL,NULL),(55329,'63547','S','Hurdland','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.145709,-92.302124,0,'2013-07-06 12:44:33',NULL,NULL),(13224,'13635','S','Edwards','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.308020,-75.256080,0,'2013-07-06 12:44:30',NULL,NULL),(41777,'47304','S','Muncie','D','Delaware','18035','Indiana','IN','18','5280','765','Eastern',-5.0,'Y',40.226820,-85.445940,0,'2013-07-06 12:44:32',NULL,NULL),(44346,'49775','S','Bois Blanc Is','A','Mackinac','26097','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.764363,-84.467304,0,'2013-07-06 12:44:32',NULL,NULL),(48877,'56090','S','Vernon Center','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.960899,-94.165264,0,'2013-07-06 12:44:33',NULL,NULL),(77875,'97266','S','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.484850,-122.557005,0,'2013-07-06 12:44:34',NULL,NULL),(73643,'91470','U','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.177794,-118.614680,0,'2013-07-06 12:44:34',NULL,NULL),(68046,'80930','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.830904,-104.513630,0,'2013-07-06 12:44:34',NULL,NULL),(62383,'74079','S','Kendrick','A','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.760300,-96.702300,0,'2013-07-06 12:44:33',NULL,NULL),(59048,'70085','S','Toca','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(34263,'38459','S','Frankewing','D','Lincoln','47103','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.172609,-86.775948,0,'2013-07-06 12:44:32',NULL,NULL),(19880,'20532','U','Bureau Narc Dngr Drugs Lab','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.903020,-77.016199,0,'2013-07-06 12:44:31',NULL,NULL),(24152,'26581','S','Littleton','D','Wetzel','54103','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.665921,-80.575673,0,'2013-07-06 12:44:31',NULL,NULL),(37657,'42206','S','South Union','A','Logan','21141','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.885141,-86.723180,0,'2013-07-06 12:44:32',NULL,NULL),(40653,'46038','S','Fishers','D','Hamilton','18057','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.960000,-85.983660,0,'2013-07-06 12:44:32',NULL,NULL),(44386,'49801','S','Kingsford','N','Dickinson','26043','Michigan','MI','26','0000','906','Central',-6.0,'Y',45.817870,-88.066576,0,'2013-07-06 12:44:32',NULL,NULL),(44988,'50433','S','Dougherty','D','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.922058,-93.041859,0,'2013-07-06 12:44:32',NULL,NULL),(48125,'55358','S','Maple Lake','D','Wright','27171','Minnesota','MN','27','5120','320','Central',-6.0,'Y',45.233674,-94.004626,0,'2013-07-06 12:44:33',NULL,NULL),(2897,'00987','S','Urb Colinitas De Cacao','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(53393,'61817','S','Catlin','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.068082,-87.710463,0,'2013-07-06 12:44:33',NULL,NULL),(45823,'52207','S','Emeline','N','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.072359,-90.820412,0,'2013-07-06 12:44:32',NULL,NULL),(41793,'47326','S','Bryant','D','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.536527,-84.963031,0,'2013-07-06 12:44:32',NULL,NULL),(12663,'13120','S','South Onondaga','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.948000,-76.176840,0,'2013-07-06 12:44:30',NULL,NULL),(74159,'92262','S','Palm Springs','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.856934,-116.563137,0,'2013-07-06 12:44:34',NULL,NULL),(67610,'80433','S','Aspen Park','N','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.515866,-105.311973,0,'2013-07-06 12:44:34',NULL,NULL),(64715,'76870','S','Priddy','D','Mills','48333','Texas','TX','48','0000','325','Central',-6.0,'Y',31.691993,-98.504331,0,'2013-07-06 12:44:34',NULL,NULL),(60932,'72086','S','Lonoke','D','Lonoke','05085','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.788120,-91.948860,0,'2013-07-06 12:44:33',NULL,NULL),(56772,'65741','P','Rockbridge','D','Ozark','29153','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.788867,-92.409967,0,'2013-07-06 12:44:33',NULL,NULL),(10371,'10589','S','Somers Town','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.335949,-73.694100,0,'2013-07-06 12:44:30',NULL,NULL),(7503,'06922','U','Stamford','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.056955,-73.514770,0,'2013-07-06 12:44:30',NULL,NULL),(2825,'00979','S','Urb La Marina','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.404820,-65.978882,0,'2013-07-06 12:44:30',NULL,NULL),(24440,'27209','S','Biscoe','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.356370,-79.790361,0,'2013-07-06 12:44:31',NULL,NULL),(22636,'24248','S','Willow Tree','N','Lee','51105','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.625839,-83.515719,0,'2013-07-06 12:44:31',NULL,NULL),(40606,'45891','S','Van Wert','D','Van Wert','39161','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.861959,-84.587966,0,'2013-07-06 12:44:32',NULL,NULL),(51593,'59812','U','Missoula','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.858954,-113.986470,0,'2013-07-06 12:44:33',NULL,NULL),(14591,'15221','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.437960,-79.955700,0,'2013-07-06 12:44:31',NULL,NULL),(46812,'54005','S','New Haven','N','Polk','55095','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.249537,-92.272632,0,'2013-07-06 12:44:32',NULL,NULL),(45770,'52154','S','Saude','N','Chickasaw','19037','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.101911,-92.138892,0,'2013-07-06 12:44:32',NULL,NULL),(4796,'03882','S','Effingham','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.715503,-71.004712,0,'2013-07-06 12:44:30',NULL,NULL),(20939,'21759','P','Ladiesburg','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.575011,-77.263916,0,'2013-07-06 12:44:31',NULL,NULL),(31514,'34470','S','Ocala','D','Marion','12083','Florida','FL','12','5790','352','Eastern',-5.0,'Y',29.203104,-82.091918,0,'2013-07-06 12:44:32',NULL,NULL),(29291,'32507','S','Perdido Key','N','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.367319,-87.330899,0,'2013-07-06 12:44:32',NULL,NULL),(13997,'14515','P','North Greece','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',43.255445,-77.729910,0,'2013-07-06 12:44:31',NULL,NULL),(79497,'98903','S','Union Gap','A','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.561980,-120.667800,0,'2013-07-06 12:44:34',NULL,NULL),(73181,'90405','S','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.007914,-118.470161,0,'2013-07-06 12:44:34',NULL,NULL),(72511,'89153','U','Lv Valley Water Co','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.162290,-115.203507,0,'2013-07-06 12:44:34',NULL,NULL),(65698,'78008','S','Campbellton','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.792111,-98.245657,0,'2013-07-06 12:44:34',NULL,NULL),(57614,'67123','S','Potwin','D','Butler','20015','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.937501,-97.016481,0,'2013-07-06 12:44:33',NULL,NULL),(44291,'49725','S','De Tour Village','D','Chippewa','26033','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.984999,-83.903840,0,'2013-07-06 12:44:32',NULL,NULL),(38027,'43019','S','Fredricktwn','N','Knox','39083','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.491704,-82.533390,0,'2013-07-06 12:44:32',NULL,NULL),(10876,'11419','S','S Richmond Hill','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.688921,-73.823304,0,'2013-07-06 12:44:30',NULL,NULL),(807,'00693','S','Urb Cabo Caribe','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(33423,'37243','U','Nashvl','N','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.162894,-86.785734,0,'2013-07-06 12:44:32',NULL,NULL),(32241,'35593','S','Vina','D','Franklin','01059','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.366192,-88.081170,0,'2013-07-06 12:44:32',NULL,NULL),(21840,'23127','P','Norge','D','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.364207,-76.771807,0,'2013-07-06 12:44:31',NULL,NULL),(6184,'05478','S','Georgia','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.802840,-73.089660,0,'2013-07-06 12:44:30',NULL,NULL),(65753,'78063','S','Pipe Creek','D','Bandera','48019','Texas','TX','48','0000','830','Central',-6.0,'Y',29.656800,-98.907540,0,'2013-07-06 12:44:34',NULL,NULL),(58956,'70002','S','Metairie','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.009645,-90.160453,0,'2013-07-06 12:44:33',NULL,NULL),(52978,'61431','S','Ellisville','D','Fulton','17057','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.601583,-90.281616,0,'2013-07-06 12:44:33',NULL,NULL),(50072,'57449','S','Houghton','D','Brown','46013','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.805233,-98.103312,0,'2013-07-06 12:44:33',NULL,NULL),(45675,'52041','S','Earlville','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.480661,-91.271389,0,'2013-07-06 12:44:32',NULL,NULL),(44740,'50163','P','Melcher Dal','A','Marion','19125','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.225249,-93.238708,0,'2013-07-06 12:44:32',NULL,NULL),(16410,'17224','S','Ft Loudon','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.980520,-77.898720,0,'2013-07-06 12:44:31',NULL,NULL),(19203,'19884','U','Wilmington','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.743248,-75.545385,0,'2013-07-06 12:44:31',NULL,NULL),(31112,'33888','U','Winter Haven','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.044236,-81.722199,0,'2013-07-06 12:44:32',NULL,NULL),(20978,'21798','S','Woodsboro','D','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.531691,-77.304607,0,'2013-07-06 12:44:31',NULL,NULL),(40714,'46117','S','Charlottesvle','A','Hancock','18059','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.817766,-85.617132,0,'2013-07-06 12:44:32',NULL,NULL),(75293,'93725','S','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.662145,-119.740783,0,'2013-07-06 12:44:34',NULL,NULL),(66059,'78380','S','Petronila','N','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.762480,-97.742580,0,'2013-07-06 12:44:34',NULL,NULL),(60740,'71965','S','Y City','N','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.652412,-93.747235,0,'2013-07-06 12:44:33',NULL,NULL),(36917,'41143','S','Johns Run','A','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.329825,-82.936538,0,'2013-07-06 12:44:32',NULL,NULL),(4314,'02911','S','North Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.852404,-71.469476,0,'2013-07-06 12:44:30',NULL,NULL),(31072,'33854','P','Lake Wales','A','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',27.857939,-81.412475,0,'2013-07-06 12:44:32',NULL,NULL),(3526,'01890','S','Winchester','D','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.452923,-71.146003,0,'2013-07-06 12:44:30',NULL,NULL),(57747,'67438','S','Durham','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.485024,-97.223571,0,'2013-07-06 12:44:33',NULL,NULL),(15399,'16335','S','Kerrtown','N','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.640960,-80.169720,0,'2013-07-06 12:44:31',NULL,NULL),(34499,'38669','P','Sherard','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.189654,-90.626670,0,'2013-07-06 12:44:32',NULL,NULL),(34144,'38235','P','Mc Lemoresville','D','Carroll','47017','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.985579,-88.581792,0,'2013-07-06 12:44:32',NULL,NULL),(29326,'32542','S','Elgin','N','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.464353,-86.534988,0,'2013-07-06 12:44:32',NULL,NULL),(42560,'47874','S','Coxville','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.603060,-87.257340,0,'2013-07-06 12:44:32',NULL,NULL),(7051,'06281','S','Woodstock','D','Windham','09015','Connecticut','CT','09','0000','860/959','Eastern',-5.0,'Y',41.946708,-71.986604,0,'2013-07-06 12:44:30',NULL,NULL),(52376,'60621','S','Englewood','N','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.778204,-87.641571,0,'2013-07-06 12:44:33',NULL,NULL),(50464,'58035','S','Galesburg','D','Traill','38097','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.281586,-97.326614,0,'2013-07-06 12:44:33',NULL,NULL),(49427,'56633','S','Cass Lake','D','Cass','27021','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379804,-94.604123,0,'2013-07-06 12:44:33',NULL,NULL),(45510,'51365','S','Wallingford','D','Emmet','19063','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.296934,-94.854337,0,'2013-07-06 12:44:32',NULL,NULL),(40573,'45868','S','Mount Cory','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.968598,-83.837304,0,'2013-07-06 12:44:32',NULL,NULL),(19023,'19530','S','New Smithville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.533780,-75.789540,0,'2013-07-06 12:44:31',NULL,NULL),(18967,'19516','P','Centerport','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.484168,-76.008507,0,'2013-07-06 12:44:31',NULL,NULL),(22724,'24361','S','Clinchburg','A','Washington','51191','Virginia','VA','51','3660','276','Eastern',-5.0,'Y',36.766293,-81.855650,0,'2013-07-06 12:44:31',NULL,NULL),(10564,'11004','S','Glen Oaks','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.747846,-73.710498,0,'2013-07-06 12:44:30',NULL,NULL),(73741,'91710','S','Ontario','A','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.016105,-117.686207,0,'2013-07-06 12:44:34',NULL,NULL),(60405,'71638','S','Dermott','D','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(59117,'70150','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.944559,-90.084953,0,'2013-07-06 12:44:33',NULL,NULL),(57577,'67060','S','Haysville','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.565138,-97.350958,0,'2013-07-06 12:44:33',NULL,NULL),(56937,'66080','S','Richmond','D','Franklin','20059','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.402738,-95.253134,0,'2013-07-06 12:44:33',NULL,NULL),(45560,'51502','P','Council Bluffs','D','Pottawattamie','19155','Iowa','IA','19','5920','712','Central',-6.0,'Y',41.261393,-95.849876,0,'2013-07-06 12:44:32',NULL,NULL),(43911,'49255','S','Montgomery','D','Branch','26023','Michigan','MI','26','0000','517','Eastern',-5.0,'Y',41.782742,-84.883132,0,'2013-07-06 12:44:32',NULL,NULL),(17892,'18444','S','Sprng Brk Twp','A','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.350221,-75.547811,0,'2013-07-06 12:44:31',NULL,NULL),(12900,'13334','S','Pierceville','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.827651,-75.654124,0,'2013-07-06 12:44:30',NULL,NULL),(30395,'33321','S','Ldhl','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.205804,-80.266294,0,'2013-07-06 12:44:32',NULL,NULL),(1919,'00795','S','Paseo del Parque','N','Juana Diaz','72075','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.053902,-66.505295,0,'2013-07-06 12:44:30',NULL,NULL),(69166,'83322','S','Fairfield','A','Camas','16025','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.322434,-114.998760,0,'2013-07-06 12:44:34',NULL,NULL),(65192,'77423','S','Brookshire','D','Waller','48473','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.798940,-95.962284,0,'2013-07-06 12:44:34',NULL,NULL),(38212,'43216','P','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.974192,-82.898226,0,'2013-07-06 12:44:32',NULL,NULL),(21418,'22542','S','Rhoadesville','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.284569,-77.907317,0,'2013-07-06 12:44:31',NULL,NULL),(23815,'26058','P','Short Creek','D','Brooke','54009','West Virginia','WV','54','8080','304/681','Eastern',-5.0,'Y',40.184992,-80.675308,0,'2013-07-06 12:44:31',NULL,NULL),(9095,'09060','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(5544,'04843','S','Camden','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.210169,-69.071581,0,'2013-07-06 12:44:30',NULL,NULL),(3667,'02124','S','Dorchestr Ctr','A','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.286139,-71.070555,0,'2013-07-06 12:44:30',NULL,NULL),(16869,'17566','S','Buck','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.879899,-76.148321,0,'2013-07-06 12:44:31',NULL,NULL),(26504,'29170','S','Cayce','N','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.950402,-81.141165,0,'2013-07-06 12:44:31',NULL,NULL),(24645,'27376','S','Seven Lakes','A','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.249640,-79.529160,0,'2013-07-06 12:44:31',NULL,NULL),(4223,'02852','S','Davisville','N','Washington','44009','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.584340,-71.463799,0,'2013-07-06 12:44:30',NULL,NULL),(17585,'18018','S','Bethlehem','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.624548,-75.405334,0,'2013-07-06 12:44:31',NULL,NULL),(21499,'22664','S','Woodstock','D','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.875497,-78.510530,0,'2013-07-06 12:44:31',NULL,NULL),(13131,'13492','S','Walesville','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.118640,-75.329340,0,'2013-07-06 12:44:30',NULL,NULL),(13555,'13833','S','Sanitaria Spg','A','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.200520,-75.773460,0,'2013-07-06 12:44:31',NULL,NULL),(77507,'96837','P','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.312064,-157.864195,0,'2013-07-06 12:44:34',NULL,NULL),(66308,'78589','S','Lopezville','N','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.196480,-98.153340,0,'2013-07-06 12:44:34',NULL,NULL),(59738,'71130','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.491049,-93.769298,0,'2013-07-06 12:44:33',NULL,NULL),(58269,'68382','S','Dunbar','A','Otoe','31131','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.595600,-96.024200,0,'2013-07-06 12:44:33',NULL,NULL),(54214,'62644','S','Enion','A','Mason','17125','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.297332,-90.063176,0,'2013-07-06 12:44:33',NULL,NULL),(10743,'11358','S','Flushing','D','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.760434,-73.799188,0,'2013-07-06 12:44:30',NULL,NULL),(7862,'07502','S','Hillcrest','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.918903,-74.194887,0,'2013-07-06 12:44:30',NULL,NULL),(23270,'25141','S','Nebo','D','Clay','54015','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.626014,-81.026996,0,'2013-07-06 12:44:31',NULL,NULL),(7852,'07470','S','Wayne','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.947255,-74.245839,0,'2013-07-06 12:44:30',NULL,NULL),(38085,'43073','P','Summit Sta','A','Licking','39089','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',40.001966,-82.751027,0,'2013-07-06 12:44:32',NULL,NULL),(39199,'44333','S','Fairlawn','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.156040,-81.637740,0,'2013-07-06 12:44:32',NULL,NULL),(39504,'44807','S','Buckeye Village','N','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.072571,-82.891165,0,'2013-07-06 12:44:32',NULL,NULL),(49093,'56334','S','Glenwood','D','Pope','27121','Minnesota','MN','27','0000','320','Central',-6.0,'Y',45.651444,-95.386131,0,'2013-07-06 12:44:33',NULL,NULL),(69193,'83342','S','Malta','D','Cassia','16031','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.305271,-113.370505,0,'2013-07-06 12:44:34',NULL,NULL),(65655,'77977','P','Placedo','D','Victoria','48469','Texas','TX','48','8750','361','Central',-6.0,'Y',28.695758,-96.826746,0,'2013-07-06 12:44:34',NULL,NULL),(51626,'59847','S','Lolo','D','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.755902,-114.104293,0,'2013-07-06 12:44:33',NULL,NULL),(49451,'56644','S','Pine Lake','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.849231,-95.480640,0,'2013-07-06 12:44:33',NULL,NULL),(20205,'20755','S','Ft Meade','N','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.109680,-76.736935,0,'2013-07-06 12:44:31',NULL,NULL),(23987,'26330','S','Bridgeport','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.289276,-80.254283,0,'2013-07-06 12:44:31',NULL,NULL),(14150,'14715','S','South Bolivar','N','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.075166,-78.157392,0,'2013-07-06 12:44:31',NULL,NULL),(31497,'34446','S','Homosassa Spg','A','Citrus','12017','Florida','FL','12','0000','352','Eastern',-5.0,'Y',28.747053,-82.526574,0,'2013-07-06 12:44:32',NULL,NULL),(3541,'01913','S','Amesbury','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.855920,-70.936450,0,'2013-07-06 12:44:30',NULL,NULL),(79001,'98383','S','Silverdale','D','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.663935,-122.707438,0,'2013-07-06 12:44:34',NULL,NULL),(75334,'93792','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.781298,-119.827169,0,'2013-07-06 12:44:34',NULL,NULL),(64892,'77079','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.781784,-95.602535,0,'2013-07-06 12:44:34',NULL,NULL),(62306,'74031','P','Foyil','D','Rogers','40131','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.436238,-95.518349,0,'2013-07-06 12:44:33',NULL,NULL),(53644,'62203','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.598771,-90.076739,0,'2013-07-06 12:44:33',NULL,NULL),(16028,'17042','S','North Lebanon','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.333597,-76.423855,0,'2013-07-06 12:44:31',NULL,NULL),(23036,'24853','P','Kimball','D','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.424159,-81.509900,0,'2013-07-06 12:44:31',NULL,NULL),(33848,'37995','U','First Tenn National Bank','N','Knox','47093','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.963474,-83.915580,0,'2013-07-06 12:44:32',NULL,NULL),(1603,'00769','S','Urb Las Aguilas','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(1154,'00727','S','Parq del Monte 2','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.233993,-66.036446,0,'2013-07-06 12:44:30',NULL,NULL),(80023,'99684','P','Unalakleet','D','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',63.724978,-160.542339,0,'2013-07-06 12:44:34',NULL,NULL),(75006,'93454','S','Santa Maria','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.877520,-120.331800,0,'2013-07-06 12:44:34',NULL,NULL),(66845,'79118','S','Timbercreek Canyon','A','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.065430,-101.852052,0,'2013-07-06 12:44:34',NULL,NULL),(58105,'68114','S','Omaha','D','Douglas','31055','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.264936,-96.051169,0,'2013-07-06 12:44:33',NULL,NULL),(49051,'56301','S','Saint Augusta','A','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.531141,-94.209162,0,'2013-07-06 12:44:33',NULL,NULL),(16349,'17140','U','Pa Blue Shield','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.259652,-76.807717,0,'2013-07-06 12:44:31',NULL,NULL),(36079,'40214','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.158525,-85.786573,0,'2013-07-06 12:44:32',NULL,NULL),(32303,'35748','S','Gurley','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.718445,-86.393989,0,'2013-07-06 12:44:32',NULL,NULL),(5506,'04765','S','Mount Chase','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.997816,-68.444509,0,'2013-07-06 12:44:30',NULL,NULL),(7554,'07017','S','Ampere','N','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.772043,-74.209455,0,'2013-07-06 12:44:30',NULL,NULL),(20487,'21050','S','Forest Hill','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.574458,-76.397623,0,'2013-07-06 12:44:31',NULL,NULL),(72440,'89087','S','N Las Vegas','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.283100,-115.135100,0,'2013-07-06 12:44:34',NULL,NULL),(70326,'84626','P','Elberta','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.162382,-112.031361,0,'2013-07-06 12:44:34',NULL,NULL),(64314,'76472','S','Santo','D','Palo Pinto','48363','Texas','TX','48','0000','940','Central',-6.0,'Y',32.588111,-98.183089,0,'2013-07-06 12:44:34',NULL,NULL),(58240,'68354','S','Fairmont','D','Fillmore','31059','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.632986,-97.584084,0,'2013-07-06 12:44:33',NULL,NULL),(42291,'47590','S','Velpen','D','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.376792,-87.100893,0,'2013-07-06 12:44:32',NULL,NULL),(12410,'12935','S','Ellenburg Depot','D','Clinton','36019','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.926800,-73.800120,0,'2013-07-06 12:44:30',NULL,NULL),(31813,'35055','S','Good Hope','A','Cullman','01043','Alabama','AL','01','0000','256','Central',-6.0,'Y',34.174036,-86.843648,0,'2013-07-06 12:44:32',NULL,NULL),(2849,'00983','S','Urb Vistamar','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(17482,'17959','S','New Phila','A','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.738984,-76.109152,0,'2013-07-06 12:44:31',NULL,NULL),(26432,'29128','S','Boykin','N','Sumter','45085','South Carolina','SC','45','8140','803','Eastern',-5.0,'Y',34.092080,-80.504800,0,'2013-07-06 12:44:31',NULL,NULL),(16765,'17520','S','East Petersburg','D','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.101393,-76.349047,0,'2013-07-06 12:44:31',NULL,NULL),(80029,'99690','P','Bethel','A','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.470000,-164.720000,0,'2013-07-06 12:44:34',NULL,NULL),(76528,'95651','S','Lotus','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.838560,-120.929258,0,'2013-07-06 12:44:34',NULL,NULL),(71564,'87301','S','Gallup','D','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(67396,'80125','S','Littleton','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.482672,-105.055501,0,'2013-07-06 12:44:34',NULL,NULL),(62373,'74075','S','STW','N','Payne','40119','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',36.140565,-97.061624,0,'2013-07-06 12:44:33',NULL,NULL),(34735,'38849','S','Corrona','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.441370,-88.663295,0,'2013-07-06 12:44:32',NULL,NULL),(47709,'54990','U','Krause Publ Co','N','Waupaca','55135','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.507553,-89.128307,0,'2013-07-06 12:44:33',NULL,NULL),(55499,'63775','S','Crosstown','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(55506,'63775','S','Silver Lake','N','Perry','29157','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.719480,-89.810160,0,'2013-07-06 12:44:33',NULL,NULL),(59188,'70359','S','Gray','D','Terrebonne','22109','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.690321,-90.777830,0,'2013-07-06 12:44:33',NULL,NULL),(7131,'06388','P','Mystic','A','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.350556,-71.982500,0,'2013-07-06 12:44:30',NULL,NULL),(75227,'93642','P','Mono Hot Springs','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',37.326667,-119.016667,0,'2013-07-06 12:44:34',NULL,NULL),(67858,'80825','S','Kit Carson','D','Cheyenne','08017','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.802746,-102.772985,0,'2013-07-06 12:44:34',NULL,NULL),(66173,'78520','S','Villa Cavazos','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(33724,'37809','S','Midway','D','Greene','47059','Tennessee','TN','47','0000','423','Eastern',-5.0,'Y',36.149148,-83.030331,0,'2013-07-06 12:44:32',NULL,NULL),(14608,'15226','S','Pgh','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.396692,-80.015390,0,'2013-07-06 12:44:31',NULL,NULL),(48976,'56216','S','Svea','A','Kandiyohi','27067','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.968860,-95.056440,0,'2013-07-06 12:44:33',NULL,NULL),(47006,'54301','S','Scott','N','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.477500,-88.016111,0,'2013-07-06 12:44:32',NULL,NULL),(38817,'44074','S','New Russia Township','N','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.286311,-82.234157,0,'2013-07-06 12:44:32',NULL,NULL),(5809,'05069','S','Newbury Center','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.219220,-72.129600,0,'2013-07-06 12:44:30',NULL,NULL),(14970,'15631','P','Everson','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.092692,-79.585609,0,'2013-07-06 12:44:31',NULL,NULL),(34666,'38801','S','Tupelo','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.233855,-88.738853,0,'2013-07-06 12:44:32',NULL,NULL),(31561,'34610','S','Shady Hills','A','Pasco','12101','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.397951,-82.537892,0,'2013-07-06 12:44:32',NULL,NULL),(28739,'31917','P','COLS','N','Muscogee','13215','Georgia','GA','13','1800','706/762','Eastern',-5.0,'Y',32.484084,-84.828966,0,'2013-07-06 12:44:32',NULL,NULL),(27303,'30014','S','Porterdale','A','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.587144,-83.832307,0,'2013-07-06 12:44:31',NULL,NULL),(9741,'10095','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748793,-73.989926,0,'2013-07-06 12:44:30',NULL,NULL),(7808,'07442','S','Pompton Falls','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',41.000492,-74.286910,0,'2013-07-06 12:44:30',NULL,NULL),(10895,'11424','P','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.706550,-73.828147,0,'2013-07-06 12:44:30',NULL,NULL),(75615,'94501','S','Alameda','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.760574,-122.260375,0,'2013-07-06 12:44:34',NULL,NULL),(73651,'91499','U','Van Nuys','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.201899,-118.454395,0,'2013-07-06 12:44:34',NULL,NULL),(73001,'90061','S','South','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.922433,-118.275162,0,'2013-07-06 12:44:34',NULL,NULL),(72127,'88265','S','Monument','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',32.638017,-103.126757,0,'2013-07-06 12:44:34',NULL,NULL),(66898,'79252','S','Quanah','D','Hardeman','48197','Texas','TX','48','0000','254','Central',-6.0,'Y',34.293199,-99.745234,0,'2013-07-06 12:44:34',NULL,NULL),(4299,'02905','S','Cranston','A','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.789822,-71.404779,0,'2013-07-06 12:44:30',NULL,NULL),(36776,'41043','S','Johnsville','N','Bracken','21023','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.749906,-84.151904,0,'2013-07-06 12:44:32',NULL,NULL),(74887,'93283','S','Weldon','D','Kern','06029','California','CA','06','0680','760','Pacific',-8.0,'Y',35.633847,-118.286072,0,'2013-07-06 12:44:34',NULL,NULL),(74780,'93116','P','Santa Barbara','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.491171,-120.038827,0,'2013-07-06 12:44:34',NULL,NULL),(70340,'84632','P','Fountain Grn','A','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.536945,-111.680191,0,'2013-07-06 12:44:34',NULL,NULL),(67769,'80640','S','Henderson','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.871048,-104.883399,0,'2013-07-06 12:44:34',NULL,NULL),(64531,'76642','S','Thelma','N','Limestone','48293','Texas','TX','48','0000','254','Central',-6.0,'Y',31.546200,-96.529080,0,'2013-07-06 12:44:34',NULL,NULL),(55722,'64079','S','Platte City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.354840,-94.796100,0,'2013-07-06 12:44:33',NULL,NULL),(54057,'62473','S','Watson','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.035209,-88.573240,0,'2013-07-06 12:44:33',NULL,NULL),(43534,'48663','U','AT&T','N','Saginaw','26145','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.419367,-83.947813,0,'2013-07-06 12:44:32',NULL,NULL),(1379,'00738','S','Bda Obrera','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(17542,'17976','S','Shenandoah Heights','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.816695,-76.202555,0,'2013-07-06 12:44:31',NULL,NULL),(26954,'29606','P','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.858052,-82.321696,0,'2013-07-06 12:44:31',NULL,NULL),(42322,'47619','S','Lynnville','D','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.191700,-87.292118,0,'2013-07-06 12:44:32',NULL,NULL),(1330,'00736','S','Bda Nueva','N','Cayey','72035','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.118281,-66.161033,0,'2013-07-06 12:44:30',NULL,NULL),(73981,'92088','P','Fallbrook','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.365635,-117.248377,0,'2013-07-06 12:44:34',NULL,NULL),(65838,'78155','S','Seguin','D','Guadalupe','48187','Texas','TX','48','7240','830','Central',-6.0,'Y',29.566660,-97.965413,0,'2013-07-06 12:44:34',NULL,NULL),(53613,'62084','S','Roxana','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.847419,-90.078484,0,'2013-07-06 12:44:33',NULL,NULL),(42706,'47997','S','Yeoman','D','Carroll','18015','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',40.664464,-86.720368,0,'2013-07-06 12:44:32',NULL,NULL),(21488,'22652','S','Saint Davids Church','A','Shenandoah','51171','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.842058,-78.419588,0,'2013-07-06 12:44:31',NULL,NULL),(6777,'06102','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.765945,-72.670056,0,'2013-07-06 12:44:30',NULL,NULL),(17438,'17933','P','Friedensburg','D','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.600739,-76.239609,0,'2013-07-06 12:44:31',NULL,NULL),(14198,'14767','S','Panama','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.063643,-79.499075,0,'2013-07-06 12:44:31',NULL,NULL),(70549,'85033','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.490937,-112.213503,0,'2013-07-06 12:44:34',NULL,NULL),(52140,'60436','S','Rockdale','A','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.489640,-88.145340,0,'2013-07-06 12:44:33',NULL,NULL),(43666,'48858','S','Mount Pleasant','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.601402,-84.787107,0,'2013-07-06 12:44:32',NULL,NULL),(38746,'44032','S','Dorset','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.664055,-80.674035,0,'2013-07-06 12:44:32',NULL,NULL),(27533,'30222','S','Greenville','D','Meriwether','13199','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.025339,-84.720335,0,'2013-07-06 12:44:31',NULL,NULL),(548,'00677','S','Comunidad Stella','N','Rincon','72117','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.343319,-67.255905,0,'2013-07-06 12:44:30',NULL,NULL),(32341,'35802','S','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.668541,-86.560249,0,'2013-07-06 12:44:32',NULL,NULL),(68519,'81331','S','Pleasant View','D','Montezuma','08083','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.551903,-108.804936,0,'2013-07-06 12:44:34',NULL,NULL),(64491,'76624','S','Billington','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.673100,-96.981780,0,'2013-07-06 12:44:34',NULL,NULL),(60746,'71969','S','Sims','D','Montgomery','05097','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.668050,-93.666032,0,'2013-07-06 12:44:33',NULL,NULL),(31055,'33837','S','Davenport','D','Polk','12105','Florida','FL','12','3980','863','Eastern',-5.0,'Y',28.199839,-81.620177,0,'2013-07-06 12:44:32',NULL,NULL),(1844,'00784','S','Villa Rosa 3','N','Guayama','72057','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.979829,-66.111453,0,'2013-07-06 12:44:30',NULL,NULL),(44935,'50361','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.597268,-93.764352,0,'2013-07-06 12:44:32',NULL,NULL),(47901,'55109','S','Little Canada','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(56647,'65614','S','Bradleyville','D','Taney','29213','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.727158,-92.878070,0,'2013-07-06 12:44:33',NULL,NULL),(78601,'98188','S','Tukwila','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.445834,-122.268993,0,'2013-07-06 12:44:34',NULL,NULL),(76521,'95646','P','Hams Station','N','Alpine','06003','California','CA','06','0000','209','Pacific',-8.0,'Y',38.689860,-120.080103,0,'2013-07-06 12:44:34',NULL,NULL),(71585,'87313','P','Standing Rock','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.798788,-107.923273,0,'2013-07-06 12:44:34',NULL,NULL),(64846,'77045','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.632758,-95.424060,0,'2013-07-06 12:44:34',NULL,NULL),(60347,'71468','S','Bellwood','N','Natchitoches','22069','Louisiana','LA','22','0000','337','Central',-6.0,'Y',31.538100,-93.115260,0,'2013-07-06 12:44:33',NULL,NULL),(10377,'10591','S','Philipse Manor','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.077148,-73.857479,0,'2013-07-06 12:44:30',NULL,NULL),(36280,'40347','S','Midway','D','Woodford','21239','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.143797,-84.695175,0,'2013-07-06 12:44:32',NULL,NULL),(34091,'38163','U','Univ of Tn','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.141451,-90.035289,0,'2013-07-06 12:44:32',NULL,NULL),(32624,'36142','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.381048,-86.310445,0,'2013-07-06 12:44:32',NULL,NULL),(30916,'33708','S','Madeira Beach','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.814056,-82.796577,0,'2013-07-06 12:44:32',NULL,NULL),(8323,'08035','S','Haddon Hgts','A','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.877788,-75.066565,0,'2013-07-06 12:44:30',NULL,NULL),(25402,'28285','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.228864,-80.846734,0,'2013-07-06 12:44:31',NULL,NULL),(16751,'17512','S','Ironville','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',40.036944,-76.480322,0,'2013-07-06 12:44:31',NULL,NULL),(39767,'45120','S','Felicity','D','Clermont','39025','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',38.823814,-84.104901,0,'2013-07-06 12:44:32',NULL,NULL),(9398,'09868','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(79080,'98433','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.118540,-122.578980,0,'2013-07-06 12:44:34',NULL,NULL),(78436,'98056','S','Highlands','N','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.512620,-122.193420,0,'2013-07-06 12:44:34',NULL,NULL),(35990,'40129','P','Hillview','D','Bullitt','21029','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.073955,-85.665026,0,'2013-07-06 12:44:32',NULL,NULL),(13295,'13666','P','Newton Falls','D','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.196954,-74.978374,0,'2013-07-06 12:44:30',NULL,NULL),(28585,'31634','S','Homerville','D','Clinch','13065','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.037475,-82.752207,0,'2013-07-06 12:44:32',NULL,NULL),(12708,'13147','S','Venice','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.784440,-76.566840,0,'2013-07-06 12:44:30',NULL,NULL),(22518,'24088','S','Endicott','N','Franklin','51067','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',36.928893,-80.016884,0,'2013-07-06 12:44:31',NULL,NULL),(22286,'23803','S','South Chesterfield','A','Petersburg City','51730','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.213860,-77.455680,0,'2013-07-06 12:44:31',NULL,NULL),(18194,'18936','S','Montgomeryville','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.244471,-75.243572,0,'2013-07-06 12:44:31',NULL,NULL),(17778,'18343','S','Mount Bethel','D','Northampton','42095','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.892453,-75.113563,0,'2013-07-06 12:44:31',NULL,NULL),(16136,'17059','S','Arch Rock','N','Juniata','42067','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.573604,-77.387497,0,'2013-07-06 12:44:31',NULL,NULL),(12013,'12503','S','Ancramdale','D','Columbia','36021','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.037624,-73.627890,0,'2013-07-06 12:44:30',NULL,NULL),(862,'00698','S','Urb Hill View','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(40225,'45414','S','Dayton','D','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.827790,-84.203696,0,'2013-07-06 12:44:32',NULL,NULL),(43984,'49332','S','Mecosta','D','Mecosta','26107','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.638325,-85.248310,0,'2013-07-06 12:44:32',NULL,NULL),(1216,'00728','S','Urb Canas','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013070,-66.614009,0,'2013-07-06 12:44:30',NULL,NULL),(51496,'59633','S','Canyon Creek','D','Lewis and Clark','30049','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.839213,-112.306088,0,'2013-07-06 12:44:33',NULL,NULL),(23651,'25810','P','Allen Junction','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.591606,-81.349909,0,'2013-07-06 12:44:31',NULL,NULL),(6063,'05444','S','Cambridge','D','Chittenden','50007','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.648100,-72.863880,0,'2013-07-06 12:44:30',NULL,NULL),(9675,'10041','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.707642,-74.013523,0,'2013-07-06 12:44:30',NULL,NULL),(60410,'71639','S','Dumas','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.888705,-91.490885,0,'2013-07-06 12:44:33',NULL,NULL),(56421,'65258','S','Holliday','D','Monroe','29137','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.483806,-92.138585,0,'2013-07-06 12:44:33',NULL,NULL),(55781,'64118','S','Oakview','N','Clay','29047','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.215793,-94.572799,0,'2013-07-06 12:44:33',NULL,NULL),(55001,'63130','S','University Cy','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.664368,-90.323797,0,'2013-07-06 12:44:33',NULL,NULL),(22634,'24246','P','East Stone Gap','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.847723,-82.759128,0,'2013-07-06 12:44:31',NULL,NULL),(4348,'03045','S','Goffstown','D','Hillsborough','33011','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.059240,-71.579400,0,'2013-07-06 12:44:30',NULL,NULL),(12213,'12801','S','Queensbury','A','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.308900,-73.644600,0,'2013-07-06 12:44:30',NULL,NULL),(34135,'38224','S','Cottage Grove','D','Henry','47079','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.379988,-88.480605,0,'2013-07-06 12:44:32',NULL,NULL),(7031,'06268','S','Gurleyville','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.793600,-72.251400,0,'2013-07-06 12:44:30',NULL,NULL),(15878,'17003','S','Annville','D','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.331280,-76.548060,0,'2013-07-06 12:44:31',NULL,NULL),(14980,'15639','S','Hunker','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.205661,-79.585770,0,'2013-07-06 12:44:31',NULL,NULL),(66474,'78660','S','Pflugerville','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.441950,-97.627258,0,'2013-07-06 12:44:34',NULL,NULL),(62146,'73718','S','Ames','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.230770,-98.180193,0,'2013-07-06 12:44:33',NULL,NULL),(56609,'65566','S','Steelville','A','Iron','29093','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.717920,-91.129200,0,'2013-07-06 12:44:33',NULL,NULL),(7708,'07188','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.730949,-74.175440,0,'2013-07-06 12:44:30',NULL,NULL),(20636,'21219','S','Edgemere','A','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.250556,-76.520833,0,'2013-07-06 12:44:31',NULL,NULL),(10241,'10467','S','Van Cott','N','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.873256,-73.870576,0,'2013-07-06 12:44:30',NULL,NULL),(34577,'38737','S','Drew','D','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(14414,'15068','S','Arnold','A','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.576451,-79.723980,0,'2013-07-06 12:44:31',NULL,NULL),(13322,'13676','S','West Potsdam','N','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.654820,-74.955540,0,'2013-07-06 12:44:30',NULL,NULL),(27255,'29929','S','Islandton','D','Colleton','45029','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.953565,-80.883542,0,'2013-07-06 12:44:31',NULL,NULL),(23868,'26151','S','Mount Zion','D','Calhoun','54013','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.892132,-81.127507,0,'2013-07-06 12:44:31',NULL,NULL),(63700,'75882','U','Powledge Prison','N','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.757811,-95.644004,0,'2013-07-06 12:44:34',NULL,NULL),(62674,'74652','S','Shidler','D','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.872222,-96.565278,0,'2013-07-06 12:44:33',NULL,NULL),(59816,'71232','S','Warden','A','Richland','22083','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.453833,-91.489746,0,'2013-07-06 12:44:33',NULL,NULL),(56923,'66062','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.840421,-94.781910,0,'2013-07-06 12:44:33',NULL,NULL),(29791,'33018','S','Hialeah Gardens','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.942320,-80.390400,0,'2013-07-06 12:44:32',NULL,NULL),(76753,'95922','S','Camptonville','D','Yuba','06115','California','CA','06','9340','530','Pacific',-8.0,'Y',39.440166,-121.074440,0,'2013-07-06 12:44:34',NULL,NULL),(75752,'94611','S','Piedmontxxx','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.835580,-122.223360,0,'2013-07-06 12:44:34',NULL,NULL),(61538,'72682','S','Bruno','A','Boone','05009','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.143149,-92.983087,0,'2013-07-06 12:44:33',NULL,NULL),(61390,'72536','S','Franklin','D','Izard','05065','Arkansas','AR','05','0000','870','Central',-6.0,'Y',36.123302,-91.808456,0,'2013-07-06 12:44:33',NULL,NULL),(29465,'32716','P','Altamonte Springs','D','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.663807,-81.403206,0,'2013-07-06 12:44:32',NULL,NULL),(42093,'47460','S','Cataract','N','Owen','18119','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.289620,-86.748660,0,'2013-07-06 12:44:32',NULL,NULL),(44898,'50322','S','Urbandale','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.629345,-93.732012,0,'2013-07-06 12:44:32',NULL,NULL),(48958,'56178','S','Tyler','D','Lincoln','27081','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.274416,-96.136308,0,'2013-07-06 12:44:33',NULL,NULL),(51347,'59319','S','Capitol','D','Carter','30011','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.467901,-104.184538,0,'2013-07-06 12:44:33',NULL,NULL),(4419,'03229','S','Contoocook','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.203240,-71.673060,0,'2013-07-06 12:44:30',NULL,NULL),(80045,'99704','S','Clear','D','Denali','02068','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.491996,-148.678285,0,'2013-07-06 12:44:34',NULL,NULL),(77421,'96801','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.325480,-157.831334,0,'2013-07-06 12:44:34',NULL,NULL),(71563,'87301','S','Fort Wingate Army Depot','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.522559,-108.725800,0,'2013-07-06 12:44:34',NULL,NULL),(68714,'82071','P','Laramie','D','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.422527,-105.607196,0,'2013-07-06 12:44:34',NULL,NULL),(61672,'72926','S','Boles','D','Scott','05127','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.713356,-94.028142,0,'2013-07-06 12:44:33',NULL,NULL),(58656,'68875','S','Horace','N','Greeley','31077','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.469255,-98.702666,0,'2013-07-06 12:44:33',NULL,NULL),(52413,'60642','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.944713,-87.745937,0,'2013-07-06 12:44:33',NULL,NULL),(37745,'42320','S','Nineteen','N','Ohio','21183','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.332060,-86.878140,0,'2013-07-06 12:44:32',NULL,NULL),(76469,'95619','S','Diamond Springs','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.665863,-120.822937,0,'2013-07-06 12:44:34',NULL,NULL),(75154,'93562','S','Pioneer Point','N','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',35.754736,-117.385894,0,'2013-07-06 12:44:34',NULL,NULL),(73700,'91607','S','Valley Vlg','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.165372,-118.398273,0,'2013-07-06 12:44:34',NULL,NULL),(71611,'87327','P','Pescado','N','McKinley','35031','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',35.087346,-108.790886,0,'2013-07-06 12:44:34',NULL,NULL),(63808,'75962','U','Stephen F Austin Univ','N','Nacogdoches','48347','Texas','TX','48','0000','936','Central',-6.0,'Y',31.615701,-94.651749,0,'2013-07-06 12:44:34',NULL,NULL),(56248,'65053','S','Lohman','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.541668,-92.334860,0,'2013-07-06 12:44:33',NULL,NULL),(27676,'30332','U','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.777293,-84.396568,0,'2013-07-06 12:44:31',NULL,NULL),(18313,'19020','S','Cornwells Heights','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.102797,-74.929344,0,'2013-07-06 12:44:31',NULL,NULL),(3151,'01258','S','South Egremont','D','Berkshire','25003','Massachusetts','MA','25','6320','413','Eastern',-5.0,'Y',42.107580,-73.465080,0,'2013-07-06 12:44:30',NULL,NULL),(11680,'12151','S','Malta','N','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.923520,-73.782900,0,'2013-07-06 12:44:30',NULL,NULL),(36971,'41179','S','Fearisville','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(38358,'43452','S','Catawba Island','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.536800,-82.908000,0,'2013-07-06 12:44:32',NULL,NULL),(47341,'54601','S','Campbell','N','La Crosse','55063','Wisconsin','WI','55','3870','608','Central',-6.0,'Y',43.795836,-91.221089,0,'2013-07-06 12:44:32',NULL,NULL),(54758,'62984','S','Shawneetown','D','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.715092,-88.188836,0,'2013-07-06 12:44:33',NULL,NULL),(2746,'00969','S','Urb Pineiro','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(79069,'98431','U','Lewis McChord','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.055515,-122.552079,0,'2013-07-06 12:44:34',NULL,NULL),(74141,'92251','S','Imperial','D','Imperial','06025','California','CA','06','0000','760','Pacific',-8.0,'Y',32.849051,-115.586227,0,'2013-07-06 12:44:34',NULL,NULL),(72744,'89508','S','Cold Springs','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.630232,-119.870037,0,'2013-07-06 12:44:34',NULL,NULL),(72553,'89199','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.151206,-115.108207,0,'2013-07-06 12:44:34',NULL,NULL),(57581,'67063','S','Hillsboro','D','Marion','20115','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.351820,-97.202504,0,'2013-07-06 12:44:33',NULL,NULL),(51377,'59406','P','Great Falls','D','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.481052,-111.253398,0,'2013-07-06 12:44:33',NULL,NULL),(17733,'18254','P','Tresckow','D','Carbon','42025','Pennsylvania','PA','42','0240','570','Eastern',-5.0,'Y',40.913131,-75.963752,0,'2013-07-06 12:44:31',NULL,NULL),(18105,'18764','U','Wilkes Barre General Hsptl','N','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.218277,-75.794595,0,'2013-07-06 12:44:31',NULL,NULL),(27386,'30082','S','Smyrna','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.862636,-84.539199,0,'2013-07-06 12:44:31',NULL,NULL),(20835,'21638','S','Grasonville','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',38.940370,-76.189363,0,'2013-07-06 12:44:31',NULL,NULL),(42499,'47842','S','Fairview Park','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.649440,-87.423720,0,'2013-07-06 12:44:32',NULL,NULL),(44051,'49434','P','Macatawa','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.766497,-86.207979,0,'2013-07-06 12:44:32',NULL,NULL),(10867,'11417','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.674260,-73.843796,0,'2013-07-06 12:44:30',NULL,NULL),(80054,'99710','P','Steese','A','Fairbanks North Star','02090','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',64.916817,-147.567476,0,'2013-07-06 12:44:34',NULL,NULL),(76723,'95867','U','Franchise Tax Brd Refunds','N','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.584856,-121.493723,0,'2013-07-06 12:44:34',NULL,NULL),(65288,'77486','S','West Columbia','D','Brazoria','48039','Texas','TX','48','1145','979','Central',-6.0,'Y',29.142060,-95.665560,0,'2013-07-06 12:44:34',NULL,NULL),(52065,'60290','U','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.881027,-87.624730,0,'2013-07-06 12:44:33',NULL,NULL),(43430,'48473','S','Swartz Creek','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',42.942120,-83.828040,0,'2013-07-06 12:44:32',NULL,NULL),(42044,'47443','S','Marco','N','Greene','18055','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.989429,-87.083684,0,'2013-07-06 12:44:32',NULL,NULL),(17227,'17832','P','Marion Height','A','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.806027,-76.461774,0,'2013-07-06 12:44:31',NULL,NULL),(9705,'10060','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.748746,-73.997962,0,'2013-07-06 12:44:30',NULL,NULL),(28012,'30620','S','Bethlehem','D','Barrow','13013','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.924569,-83.747066,0,'2013-07-06 12:44:31',NULL,NULL),(9635,'10035','S','Triborough','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.803001,-73.940497,0,'2013-07-06 12:44:30',NULL,NULL),(2839,'00982','S','Villa Flores','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.407765,-65.979421,0,'2013-07-06 12:44:30',NULL,NULL),(78296,'97883','S','Union','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.191810,-117.835694,0,'2013-07-06 12:44:34',NULL,NULL),(68440,'81225','P','Crested Butte So','N','Gunnison','08051','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',38.900406,-106.965249,0,'2013-07-06 12:44:34',NULL,NULL),(62214,'73853','S','Mutual','D','Woodward','40153','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.145542,-99.298390,0,'2013-07-06 12:44:33',NULL,NULL),(49002,'56245','S','Hanley Falls','D','Yellow Medicine','27173','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.695514,-95.620333,0,'2013-07-06 12:44:33',NULL,NULL),(46288,'53046','S','Lannon','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',43.152352,-88.167487,0,'2013-07-06 12:44:32',NULL,NULL),(40276,'45434','S','Beavercrk Twp','A','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.712421,-84.041488,0,'2013-07-06 12:44:32',NULL,NULL),(24771,'27555','P','Micro','D','Johnston','37101','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.563044,-78.205283,0,'2013-07-06 12:44:31',NULL,NULL),(10363,'10580','S','Rye','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.982377,-73.689314,0,'2013-07-06 12:44:30',NULL,NULL),(36155,'40241','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.302202,-85.581132,0,'2013-07-06 12:44:32',NULL,NULL),(79778,'99341','S','Lind','D','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.966393,-118.640330,0,'2013-07-06 12:44:34',NULL,NULL),(73292,'90755','S','Signal Hill','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.779826,-118.150529,0,'2013-07-06 12:44:34',NULL,NULL),(69723,'84038','S','Round Valley','N','Rich','49033','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.847331,-111.346321,0,'2013-07-06 12:44:34',NULL,NULL),(67416,'80135','S','Sedalia','D','Douglas','08035','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.257643,-105.225649,0,'2013-07-06 12:44:34',NULL,NULL),(59346,'70555','S','Maurice','D','Vermilion','22113','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.104494,-92.125962,0,'2013-07-06 12:44:33',NULL,NULL),(54338,'62765','U','DHS Dept of Mental Health','N','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.801449,-89.645216,0,'2013-07-06 12:44:33',NULL,NULL),(4936,'04086','S','Topsham','D','Sagadahoc','23023','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.955940,-69.986340,0,'2013-07-06 12:44:30',NULL,NULL),(3605,'02045','S','Hull','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.230785,-70.839051,0,'2013-07-06 12:44:30',NULL,NULL),(17948,'18510','S','Scranton','D','Lackawanna','42069','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.413287,-75.639206,0,'2013-07-06 12:44:31',NULL,NULL),(18998,'19525','S','Gilbertsville','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.311960,-75.589380,0,'2013-07-06 12:44:31',NULL,NULL),(38605,'43844','S','Warsaw','D','Coshocton','39031','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.311603,-82.047764,0,'2013-07-06 12:44:32',NULL,NULL),(39019,'44143','S','Highland Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.555719,-81.479949,0,'2013-07-06 12:44:32',NULL,NULL),(45527,'51442','S','Denison','D','Crawford','19047','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.021358,-95.346531,0,'2013-07-06 12:44:32',NULL,NULL),(46139,'52653','S','Toolesboro','N','Louisa','19115','Iowa','IA','19','0000','319','Central',-6.0,'Y',41.179547,-91.188068,0,'2013-07-06 12:44:32',NULL,NULL),(71194,'86047','S','Tolani Lakes','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.275380,-110.315820,0,'2013-07-06 12:44:34',NULL,NULL),(67815,'80749','S','Sedgwick','D','Sedgwick','08115','Colorado','CO','08','0000','303/720','Mountain',-7.0,'Y',40.915405,-102.533321,0,'2013-07-06 12:44:34',NULL,NULL),(62250,'74004','U','Bartlesville','D','Washington','40147','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.739762,-95.948625,0,'2013-07-06 12:44:33',NULL,NULL),(48191,'55391','S','Woodland','N','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.966040,-93.541800,0,'2013-07-06 12:44:33',NULL,NULL),(42445,'47805','S','Sandcut','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.529334,-87.367163,0,'2013-07-06 12:44:32',NULL,NULL),(41557,'47020','S','Florence','D','Switzerland','18155','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.820823,-84.935010,0,'2013-07-06 12:44:32',NULL,NULL),(39534,'44830','S','Fostoria','D','Seneca','39147','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.185277,-83.406022,0,'2013-07-06 12:44:32',NULL,NULL),(25938,'28655','S','Oak Hill','N','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.744040,-81.713160,0,'2013-07-06 12:44:31',NULL,NULL),(26870,'29545','S','Green Sea','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',34.213666,-79.060992,0,'2013-07-06 12:44:31',NULL,NULL),(24436,'27205','S','Asheboro','D','Randolph','37151','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.712988,-79.814274,0,'2013-07-06 12:44:31',NULL,NULL),(21802,'23085','S','King Queen Ch','A','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.728500,-76.845215,0,'2013-07-06 12:44:31',NULL,NULL),(2223,'00926','S','Urb El Dorado','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(50279,'57649','S','Date','N','Perkins','46105','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.603149,-102.825211,0,'2013-07-06 12:44:33',NULL,NULL),(45507,'51360','S','Wahpeton','N','Dickinson','19059','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.419420,-95.132880,0,'2013-07-06 12:44:32',NULL,NULL),(44010,'49356','U','Ada','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.956876,-85.481400,0,'2013-07-06 12:44:32',NULL,NULL),(41209,'46725','S','Thorncreek','N','Whitley','18183','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.149620,-85.465020,0,'2013-07-06 12:44:32',NULL,NULL),(40627,'46015','P','Anderson','D','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.108596,-85.675180,0,'2013-07-06 12:44:32',NULL,NULL),(40207,'45389','P','Christiansburg','D','Champaign','39021','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.054168,-84.024219,0,'2013-07-06 12:44:32',NULL,NULL),(38761,'44041','S','Geneva','D','Ashtabula','39007','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.786888,-80.957349,0,'2013-07-06 12:44:32',NULL,NULL),(20826,'21629','S','Denton','D','Caroline','24011','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.876750,-75.831327,0,'2013-07-06 12:44:31',NULL,NULL),(11707,'12166','S','Sprakers','D','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.849600,-74.476380,0,'2013-07-06 12:44:30',NULL,NULL),(74317,'92393','P','Victorville','D','San Bernardino','06071','California','CA','06','6780','760','Pacific',-8.0,'Y',34.483066,-117.312486,0,'2013-07-06 12:44:34',NULL,NULL),(68485,'81252','S','Silver Cliff','A','Custer','08027','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.114881,-105.429189,0,'2013-07-06 12:44:34',NULL,NULL),(67789,'80721','S','Amherst','D','Phillips','08095','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.680501,-102.168012,0,'2013-07-06 12:44:34',NULL,NULL),(63917,'76049','S','Acton','A','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.449949,-97.737417,0,'2013-07-06 12:44:34',NULL,NULL),(61097,'72135','S','Pinnacle','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.869776,-92.522556,0,'2013-07-06 12:44:33',NULL,NULL),(61014,'72114','S','Veterans Administration Faci','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.767166,-92.254875,0,'2013-07-06 12:44:33',NULL,NULL),(12120,'12590','S','West Fishkill','A','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.595832,-73.887450,0,'2013-07-06 12:44:30',NULL,NULL),(16656,'17349','S','Tolna','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.737783,-76.683516,0,'2013-07-06 12:44:31',NULL,NULL),(49299,'56529','S','Dilworth','D','Clay','27027','Minnesota','MN','27','2520','218','Central',-6.0,'Y',46.879898,-96.702553,0,'2013-07-06 12:44:33',NULL,NULL),(57837,'67550','S','Fort Larned National History','N','Pawnee','20145','Kansas','KS','20','0000','620','Central',-6.0,'Y',38.188320,-99.120720,0,'2013-07-06 12:44:33',NULL,NULL),(71802,'87566','S','Guique','N','Rio Arriba','35039','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',36.052980,-106.086000,0,'2013-07-06 12:44:34',NULL,NULL),(70471,'84761','P','Parowan','D','Iron','49021','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.844667,-112.827740,0,'2013-07-06 12:44:34',NULL,NULL),(65344,'77520','S','Mont Belvieu','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.772540,-94.944840,0,'2013-07-06 12:44:34',NULL,NULL),(12979,'13401','P','Mc Connellsville','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.291320,-75.668520,0,'2013-07-06 12:44:30',NULL,NULL),(9551,'10023','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.777277,-73.982489,0,'2013-07-06 12:44:30',NULL,NULL),(2439,'00953','S','Urb Palacio Imperial','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(30444,'33331','S','Pembroke Pines','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(767,'00692','S','Urb Las Colinas','N','Vega Alta','72143','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.413692,-66.318970,0,'2013-07-06 12:44:30',NULL,NULL),(17085,'17764','S','Farwell','N','Clinton','42035','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.335860,-77.737920,0,'2013-07-06 12:44:31',NULL,NULL),(23537,'25606','P','Crown','N','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.766019,-81.835111,0,'2013-07-06 12:44:31',NULL,NULL),(19394,'20070','U','Wash Intell Bureau Inc','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.878561,-77.230131,0,'2013-07-06 12:44:31',NULL,NULL),(43875,'49202','S','Jackson','D','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.264371,-84.410995,0,'2013-07-06 12:44:32',NULL,NULL),(61915,'73147','P','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.483574,-97.582013,0,'2013-07-06 12:44:33',NULL,NULL),(72302,'88583','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.771010,-106.330129,0,'2013-07-06 12:44:34',NULL,NULL),(49441,'56636','S','Morse','N','Itasca','27061','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.379960,-93.861360,0,'2013-07-06 12:44:33',NULL,NULL),(44667,'50112','S','Newburg','N','Poweshiek','19157','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.767320,-92.765040,0,'2013-07-06 12:44:32',NULL,NULL),(27512,'30185','S','Whitesburg','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.516993,-84.919009,0,'2013-07-06 12:44:31',NULL,NULL),(22229,'23605','S','Hampton','A','Newport News City','51700','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.019385,-76.437883,0,'2013-07-06 12:44:31',NULL,NULL),(17658,'18081','P','Springtown','D','Bucks','42017','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.554746,-75.289503,0,'2013-07-06 12:44:31',NULL,NULL),(32645,'36250','S','Alexandria','D','Calhoun','01015','Alabama','AL','01','0450','256','Central',-6.0,'Y',33.767433,-85.893282,0,'2013-07-06 12:44:32',NULL,NULL),(5166,'04427','S','East Corinth','N','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.983476,-69.013009,0,'2013-07-06 12:44:30',NULL,NULL),(69924,'84111','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.753460,-111.879217,0,'2013-07-06 12:44:34',NULL,NULL),(52908,'61363','P','Standard','D','Putnam','17155','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.257659,-89.177782,0,'2013-07-06 12:44:33',NULL,NULL),(48273,'55430','S','Brooklyn Center','A','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.056240,-93.301390,0,'2013-07-06 12:44:33',NULL,NULL),(291,'00646','S','Qtas de Dorado','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(73072,'90189','U','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','213','Pacific',-8.0,'Y',34.051596,-118.239035,0,'2013-07-06 12:44:34',NULL,NULL),(62271,'74013','P','Broken Arrow','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.045952,-95.789603,0,'2013-07-06 12:44:33',NULL,NULL),(20997,'21824','S','Rhodes Point','N','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',37.982465,-76.042178,0,'2013-07-06 12:44:31',NULL,NULL),(5862,'05143','S','North Windham','N','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(30889,'33701','S','St Petersburg','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.767645,-82.638123,0,'2013-07-06 12:44:32',NULL,NULL),(14674,'15241','S','Upper Saint Clair','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.357620,-80.059980,0,'2013-07-06 12:44:31',NULL,NULL),(45260,'50665','S','Parkersburg','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.579549,-92.788151,0,'2013-07-06 12:44:32',NULL,NULL),(39221,'44411','S','Deerfield','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.021628,-81.042585,0,'2013-07-06 12:44:32',NULL,NULL),(30264,'33234','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.750799,-80.274412,0,'2013-07-06 12:44:32',NULL,NULL),(35084,'39203','S','Jksn','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.309387,-90.196952,0,'2013-07-06 12:44:32',NULL,NULL),(9265,'09606','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(73681,'91602','S','Toluca Lake','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.152564,-118.367089,0,'2013-07-06 12:44:34',NULL,NULL),(72961,'90044','S','August F Haw','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.956268,-118.290701,0,'2013-07-06 12:44:34',NULL,NULL),(67599,'80424','S','Breckenridge','D','Summit','08117','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.472151,-106.040778,0,'2013-07-06 12:44:34',NULL,NULL),(40575,'45869','S','New Bremen','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.444556,-84.381645,0,'2013-07-06 12:44:32',NULL,NULL),(19742,'20406','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.855860,-77.050730,0,'2013-07-06 12:44:31',NULL,NULL),(22155,'23459','S','Naval Amphibious Base','N','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.881640,-76.001520,0,'2013-07-06 12:44:31',NULL,NULL),(35432,'39475','S','Rock Hill','N','Lamar','28073','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.065616,-89.289840,0,'2013-07-06 12:44:32',NULL,NULL),(28009,'30609','U','University of Georgia','N','Clarke','13059','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.936780,-83.431570,0,'2013-07-06 12:44:31',NULL,NULL),(23167,'25021','S','Bim','D','Boone','54005','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.877938,-81.709598,0,'2013-07-06 12:44:31',NULL,NULL),(72124,'88262','P','McDonald','D','Lea','35025','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.142688,-103.319739,0,'2013-07-06 12:44:34',NULL,NULL),(70942,'85641','S','Corona de Tuc','A','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',31.983984,-110.689294,0,'2013-07-06 12:44:34',NULL,NULL),(58583,'68835','S','Elba','D','Howard','31093','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.285075,-98.591395,0,'2013-07-06 12:44:33',NULL,NULL),(54580,'62899','S','Garden Hill','N','Clay','17025','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.697541,-88.638859,0,'2013-07-06 12:44:33',NULL,NULL),(35234,'39322','S','Buckatunna','D','Wayne','28153','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.490348,-88.561931,0,'2013-07-06 12:44:32',NULL,NULL),(22847,'24530','S','Callands','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.780419,-79.636872,0,'2013-07-06 12:44:31',NULL,NULL),(41420,'46825','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.160774,-85.115233,0,'2013-07-06 12:44:32',NULL,NULL),(43358,'48390','S','Wolverine Lk','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.551225,-83.477353,0,'2013-07-06 12:44:32',NULL,NULL),(51087,'58763','S','Sanish','A','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.972700,-102.481620,0,'2013-07-06 12:44:33',NULL,NULL),(71183,'86044','S','Red Lake','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',35.966411,-110.876600,0,'2013-07-06 12:44:34',NULL,NULL),(62944,'75099','U','Coppell','D','Dallas','48113','Texas','TX','48','1920','940','Central',-6.0,'Y',32.954431,-97.015214,0,'2013-07-06 12:44:33',NULL,NULL),(60011,'71334','S','Levens Addition','N','Concordia','22029','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.623080,-91.551226,0,'2013-07-06 12:44:33',NULL,NULL),(47368,'54622','S','Buffalo City','A','Buffalo','55011','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',44.271780,-91.873200,0,'2013-07-06 12:44:32',NULL,NULL),(13864,'14231','P','Bflo','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.980390,-78.737853,0,'2013-07-06 12:44:31',NULL,NULL),(9105,'09094','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(6329,'05664','P','Northfld Fls','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.171996,-72.651009,0,'2013-07-06 12:44:30',NULL,NULL),(38648,'43938','S','Georges Run','N','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.315500,-80.626200,0,'2013-07-06 12:44:32',NULL,NULL),(72850,'89835','S','Wilkins','N','Elko','32007','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',41.108927,-114.965942,0,'2013-07-06 12:44:34',NULL,NULL),(70947,'85643','S','Bonita','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(63638,'75840','S','Young','N','Freestone','48161','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.722324,-96.157345,0,'2013-07-06 12:44:34',NULL,NULL),(62187,'73762','S','Okarche','D','Kingfisher','40073','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.729377,-97.975980,0,'2013-07-06 12:44:33',NULL,NULL),(55556,'63857','S','Caruth','N','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.239810,-90.047625,0,'2013-07-06 12:44:33',NULL,NULL),(47859,'55078','P','Stacy','D','Chisago','27025','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.397510,-92.989336,0,'2013-07-06 12:44:33',NULL,NULL),(41687,'47199','U','Bureau of Census Decennial','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.285992,-85.732879,0,'2013-07-06 12:44:32',NULL,NULL),(11376,'11933','S','Baiting Hollow','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.934460,-72.769140,0,'2013-07-06 12:44:30',NULL,NULL),(1456,'00745','S','Alt Rio Grande','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(7418,'06811','S','Danbury','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.422764,-73.473148,0,'2013-07-06 12:44:30',NULL,NULL),(79606,'99105','S','Benge','D','Adams','53001','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.884728,-117.999072,0,'2013-07-06 12:44:34',NULL,NULL),(65843,'78161','S','Sutherland Springs','D','Wilson','48493','Texas','TX','48','7240','830','Central',-6.0,'Y',29.263031,-98.067520,0,'2013-07-06 12:44:34',NULL,NULL),(65749,'78062','P','Peggy','D','Atascosa','48013','Texas','TX','48','0000','830','Central',-6.0,'Y',28.741105,-98.177857,0,'2013-07-06 12:44:34',NULL,NULL),(36404,'40512','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.137113,-84.467519,0,'2013-07-06 12:44:32',NULL,NULL),(13010,'13417','S','NY Mills','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.100821,-75.290988,0,'2013-07-06 12:44:30',NULL,NULL),(34683,'38826','S','Belden','D','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.291060,-88.780847,0,'2013-07-06 12:44:32',NULL,NULL),(25178,'28052','S','Gastonia','D','Gaston','37071','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.227500,-81.242040,0,'2013-07-06 12:44:31',NULL,NULL),(28259,'31068','S','Olgethorpe','N','Macon','13193','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.293577,-84.068988,0,'2013-07-06 12:44:31',NULL,NULL),(52852,'61324','P','Eldena','D','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.771678,-89.413115,0,'2013-07-06 12:44:33',NULL,NULL),(57247,'66528','S','Quenemo','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.582564,-95.529845,0,'2013-07-06 12:44:33',NULL,NULL),(72338,'89014','S','Green Valley','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.063431,-115.054663,0,'2013-07-06 12:44:34',NULL,NULL),(72271,'88549','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.770045,-106.331480,0,'2013-07-06 12:44:34',NULL,NULL),(46226,'52773','S','Plain View','N','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.636460,-90.758940,0,'2013-07-06 12:44:32',NULL,NULL),(43619,'48812','P','Cedar Lake','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.404686,-84.976435,0,'2013-07-06 12:44:32',NULL,NULL),(4462,'03257','S','Sutton','N','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.419016,-71.993387,0,'2013-07-06 12:44:30',NULL,NULL),(35504,'39530','S','BLX','N','Harrison','28047','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.400015,-88.897393,0,'2013-07-06 12:44:32',NULL,NULL),(29148,'32334','S','Hosford','D','Liberty','12077','Florida','FL','12','0000','850','Eastern',-5.0,'Y',30.209904,-84.805533,0,'2013-07-06 12:44:32',NULL,NULL),(38160,'43150','S','W Rushville','A','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.777131,-82.425291,0,'2013-07-06 12:44:32',NULL,NULL),(71266,'86426','S','Bullhead City','A','Mohave','04015','Arizona','AZ','04','4120','928','Mountain',-7.0,'N',35.001660,-114.563060,0,'2013-07-06 12:44:34',NULL,NULL),(68305,'81101','S','Alamosa','D','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.472954,-105.866537,0,'2013-07-06 12:44:34',NULL,NULL),(66412,'78632','S','Sandy Fork','N','Gonzales','48177','Texas','TX','48','0000','830','Central',-6.0,'Y',29.660518,-97.479686,0,'2013-07-06 12:44:34',NULL,NULL),(59516,'70788','S','White Castle','D','Iberville','22047','Louisiana','LA','22','0000','225','Central',-6.0,'Y',30.167164,-91.148219,0,'2013-07-06 12:44:33',NULL,NULL),(55730,'64083','S','Raymore','D','Cass','29037','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.803006,-94.446895,0,'2013-07-06 12:44:33',NULL,NULL),(37558,'42069','S','Melber','D','Graves','21083','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.948877,-88.753453,0,'2013-07-06 12:44:32',NULL,NULL),(31702,'34949','S','Hutchinson Island','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.475372,-80.302774,0,'2013-07-06 12:44:32',NULL,NULL),(31170,'33918','P','N Ft Myers','A','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.676957,-81.892701,0,'2013-07-06 12:44:32',NULL,NULL),(26638,'29335','S','Enoree','D','Spartanburg','45083','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.669468,-81.904979,0,'2013-07-06 12:44:31',NULL,NULL),(20819,'21622','S','Church Creek','D','Dorchester','24019','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',38.446534,-76.163544,0,'2013-07-06 12:44:31',NULL,NULL),(17118,'17772','S','Schuyler','N','Northumberland','42097','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.100974,-76.773819,0,'2013-07-06 12:44:31',NULL,NULL),(46227,'52773','S','Walcott','D','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.636460,-90.758940,0,'2013-07-06 12:44:32',NULL,NULL),(46558,'53507','S','Barneveld','D','Iowa','55049','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.008512,-89.897707,0,'2013-07-06 12:44:32',NULL,NULL),(53498,'62010','S','Fort Russell','N','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.907799,-90.044400,0,'2013-07-06 12:44:33',NULL,NULL),(70089,'84158','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.739667,-111.817677,0,'2013-07-06 12:44:34',NULL,NULL),(63621,'75833','S','Guys Store','N','Leon','48289','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.249797,-95.973492,0,'2013-07-06 12:44:34',NULL,NULL),(62776,'74869','S','Sparks','D','Lincoln','40081','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',35.623229,-96.813151,0,'2013-07-06 12:44:33',NULL,NULL),(33947,'38077','P','Wynnburg','D','Lake','47095','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.261189,-89.523178,0,'2013-07-06 12:44:32',NULL,NULL),(37198,'41519','S','Canada','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.598218,-82.323703,0,'2013-07-06 12:44:32',NULL,NULL),(2165,'00926','S','Bo Canejas','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(18523,'19106','S','William Penn Annex East','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.951659,-75.144608,0,'2013-07-06 12:44:31',NULL,NULL),(32815,'36453','S','Kinston','D','Coffee','01031','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.227293,-86.153052,0,'2013-07-06 12:44:32',NULL,NULL),(29882,'33042','S','Mid Torch Key','A','Monroe','12087','Florida','FL','12','0000','305/786','Eastern',-5.0,'Y',24.657645,-81.454218,0,'2013-07-06 12:44:32',NULL,NULL),(18707,'19196','U','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.957442,-75.184264,0,'2013-07-06 12:44:31',NULL,NULL),(25579,'28435','S','Moores Creek National Battle','N','Pender','37141','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.410005,-78.101347,0,'2013-07-06 12:44:31',NULL,NULL),(45866,'52246','S','Iowa City','D','Johnson','19103','Iowa','IA','19','3500','319','Central',-6.0,'Y',41.654177,-91.560065,0,'2013-07-06 12:44:32',NULL,NULL),(12198,'12781','P','Summitville','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.619280,-74.448438,0,'2013-07-06 12:44:30',NULL,NULL),(70855,'85551','P','Solomon','D','Graham','04009','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',32.816863,-109.625659,0,'2013-07-06 12:44:34',NULL,NULL),(69664,'84015','S','West Point','A','Davis','49011','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',41.119274,-112.028647,0,'2013-07-06 12:44:34',NULL,NULL),(60163,'71405','S','Pineville','A','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.415594,-92.405924,0,'2013-07-06 12:44:33',NULL,NULL),(53432,'61862','S','Penfield','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.273045,-88.042103,0,'2013-07-06 12:44:33',NULL,NULL),(48453,'55710','S','Sandy','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.648089,-92.655516,0,'2013-07-06 12:44:33',NULL,NULL),(37004,'41222','S','Hagerhill','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.795350,-82.819772,0,'2013-07-06 12:44:32',NULL,NULL),(15677,'16825','P','Bigler','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.983390,-78.308698,0,'2013-07-06 12:44:31',NULL,NULL),(14471,'15122','S','W Mifflin/Pleasant Hills','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.377383,-79.892562,0,'2013-07-06 12:44:31',NULL,NULL),(42763,'48034','S','Southfield','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.472818,-83.293772,0,'2013-07-06 12:44:32',NULL,NULL),(47081,'54433','S','Gilman','D','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.214708,-90.818461,0,'2013-07-06 12:44:32',NULL,NULL),(47914,'55110','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.087946,-93.005825,0,'2013-07-06 12:44:33',NULL,NULL),(55168,'63368','S','Dardenne','N','Saint Charles','29183','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.757000,-90.724700,0,'2013-07-06 12:44:33',NULL,NULL),(58700,'68929','S','Oak Grove','N','Franklin','31061','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.135092,-99.009196,0,'2013-07-06 12:44:33',NULL,NULL),(64567,'76657','S','McGregor','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.438425,-97.399576,0,'2013-07-06 12:44:34',NULL,NULL),(64901,'77087','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.682888,-95.304840,0,'2013-07-06 12:44:34',NULL,NULL),(70841,'85539','S','Miami','D','Gila','04007','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',33.408420,-110.868176,0,'2013-07-06 12:44:34',NULL,NULL),(75583,'94287','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585797,-121.493535,0,'2013-07-06 12:44:34',NULL,NULL),(9377,'09835','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(2855,'00983','S','Villa Venecia','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409130,-65.981100,0,'2013-07-06 12:44:30',NULL,NULL),(34803,'38878','S','Elsie','N','Calhoun','28013','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.937451,-89.211711,0,'2013-07-06 12:44:32',NULL,NULL),(37271,'41572','S','Virgie','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.341120,-82.650600,0,'2013-07-06 12:44:32',NULL,NULL),(45438,'51108','S','James','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.550920,-96.390240,0,'2013-07-06 12:44:32',NULL,NULL),(48987,'56228','S','Cosmos','D','Meeker','27093','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.939095,-94.696931,0,'2013-07-06 12:44:33',NULL,NULL),(51893,'60097','S','Wonder Lake','D','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.394351,-88.354139,0,'2013-07-06 12:44:33',NULL,NULL),(54508,'62869','S','Herald','A','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.977903,-88.328317,0,'2013-07-06 12:44:33',NULL,NULL),(58443,'68714','S','Bassett','D','Rock','31149','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.580331,-99.530917,0,'2013-07-06 12:44:33',NULL,NULL),(61136,'72160','S','Farelly Lake','N','Arkansas','05001','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.223610,-91.521110,0,'2013-07-06 12:44:33',NULL,NULL),(324,'00650','S','Alt de Florida','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(2918,'01007','S','Belchertown','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.281915,-72.409531,0,'2013-07-06 12:44:30',NULL,NULL),(36560,'40921','S','Bryants Store','D','Knox','21121','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.766617,-83.918708,0,'2013-07-06 12:44:32',NULL,NULL),(34090,'38163','U','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.141451,-90.035289,0,'2013-07-06 12:44:32',NULL,NULL),(33991,'38116','S','Memphis','D','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.036558,-90.009010,0,'2013-07-06 12:44:32',NULL,NULL),(32890,'36532','S','Fairhope','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.500250,-87.868968,0,'2013-07-06 12:44:32',NULL,NULL),(8379,'08055','S','Medford Lakes Boro','N','Burlington','34005','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.862774,-74.815854,0,'2013-07-06 12:44:30',NULL,NULL),(53388,'61812','S','Armstrong','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.218225,-87.895541,0,'2013-07-06 12:44:33',NULL,NULL),(14474,'15123','S','West Mifflin','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.342320,-79.954680,0,'2013-07-06 12:44:31',NULL,NULL),(73658,'91505','S','Burbank','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.170910,-118.342586,0,'2013-07-06 12:44:34',NULL,NULL),(72469,'89124','S','Cold Creek','A','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.944610,-115.222810,0,'2013-07-06 12:44:34',NULL,NULL),(53580,'62062','S','Maryville','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.723650,-89.954460,0,'2013-07-06 12:44:33',NULL,NULL),(54263,'62677','S','Pleasant Plns','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.875106,-89.916317,0,'2013-07-06 12:44:33',NULL,NULL),(71652,'87501','S','Chupadero','N','Santa Fe','35049','New Mexico','NM','35','7490','505','Mountain',-7.0,'Y',35.699700,-105.967200,0,'2013-07-06 12:44:34',NULL,NULL),(15751,'16914','S','Big Pond','N','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.848609,-76.790408,0,'2013-07-06 12:44:31',NULL,NULL),(34582,'38737','S','Whitney','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.836400,-90.532800,0,'2013-07-06 12:44:32',NULL,NULL),(17969,'18612','S','Dallas','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.332973,-75.961823,0,'2013-07-06 12:44:31',NULL,NULL),(18315,'19020','S','Eddington','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.102797,-74.929344,0,'2013-07-06 12:44:31',NULL,NULL),(24697,'27427','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.068902,-79.766618,0,'2013-07-06 12:44:31',NULL,NULL),(20439,'21001','S','Aberdeen','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.508989,-76.182450,0,'2013-07-06 12:44:31',NULL,NULL),(38654,'43940','P','Neffs','D','Belmont','39013','Ohio','OH','39','9000','740','Eastern',-5.0,'Y',40.026323,-80.818501,0,'2013-07-06 12:44:32',NULL,NULL),(43486,'48612','S','Beaverton','D','Gladwin','26051','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.875973,-84.419697,0,'2013-07-06 12:44:32',NULL,NULL),(47741,'55014','S','Columbus','N','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.179760,-93.132240,0,'2013-07-06 12:44:33',NULL,NULL),(48681,'55925','S','Dakota','D','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917120,-91.394520,0,'2013-07-06 12:44:33',NULL,NULL),(55578,'63879','S','Homestown','A','Pemiscot','29155','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.352080,-89.820360,0,'2013-07-06 12:44:33',NULL,NULL),(613,'00680','S','Villas del Rio','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(74452,'92587','S','Canyon Lake','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.695760,-117.239280,0,'2013-07-06 12:44:34',NULL,NULL),(58671,'68901','S','Good Samaritan Village','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.592760,-98.415960,0,'2013-07-06 12:44:33',NULL,NULL),(32917,'36553','S','Mc Intosh','D','Washington','01129','Alabama','AL','01','0000','251','Central',-6.0,'Y',31.232711,-88.065729,0,'2013-07-06 12:44:32',NULL,NULL),(31723,'34973','P','Okeechobee','D','Okeechobee','12093','Florida','FL','12','5960','863','Eastern',-5.0,'Y',27.244715,-80.831008,0,'2013-07-06 12:44:32',NULL,NULL),(8673,'08326','S','Landisville','D','Atlantic','34001','New Jersey','NJ','34','0560','856','Eastern',-5.0,'Y',39.524575,-74.936643,0,'2013-07-06 12:44:30',NULL,NULL),(24863,'27656','U','Nationwide Ins Co','N','Wake','37183','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.848805,-78.692264,0,'2013-07-06 12:44:31',NULL,NULL),(38443,'43570','S','West Unity','D','Williams','39171','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.584133,-84.438762,0,'2013-07-06 12:44:32',NULL,NULL),(6285,'05641','S','Orange','A','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.191020,-72.488520,0,'2013-07-06 12:44:30',NULL,NULL),(12666,'13122','S','New Woodstock','D','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.855055,-75.914421,0,'2013-07-06 12:44:30',NULL,NULL),(18871,'19453','S','Mont Clare','D','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.138403,-75.502430,0,'2013-07-06 12:44:31',NULL,NULL),(42151,'47520','S','Mt Pleasant','A','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.096510,-86.463270,0,'2013-07-06 12:44:32',NULL,NULL),(45212,'50632','S','Green Mountain','A','Tama','19171','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.095421,-92.674244,0,'2013-07-06 12:44:32',NULL,NULL),(58247,'68360','S','Garland','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.943834,-96.983258,0,'2013-07-06 12:44:33',NULL,NULL),(74303,'92377','S','Rialto','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.150712,-117.407159,0,'2013-07-06 12:44:34',NULL,NULL),(64834,'77040','S','Bammel','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.894160,-95.579340,0,'2013-07-06 12:44:34',NULL,NULL),(59623,'71033','S','Greenwood','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.437841,-93.988179,0,'2013-07-06 12:44:33',NULL,NULL),(59602,'71019','S','East Point','A','Red River','22081','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.986240,-93.270240,0,'2013-07-06 12:44:33',NULL,NULL),(8817,'08618','S','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.221900,-74.733600,0,'2013-07-06 12:44:30',NULL,NULL),(5678,'04966','S','Phillips','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.843444,-70.376629,0,'2013-07-06 12:44:30',NULL,NULL),(27545,'30238','S','Jonesboro','D','Clayton','13063','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.493166,-84.384485,0,'2013-07-06 12:44:31',NULL,NULL),(22406,'23962','S','Randolph','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.970277,-78.709836,0,'2013-07-06 12:44:31',NULL,NULL),(21356,'22438','S','Chance','A','Essex','51057','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.029503,-76.962492,0,'2013-07-06 12:44:31',NULL,NULL),(16276,'17098','S','Williamstown','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.578618,-76.628591,0,'2013-07-06 12:44:31',NULL,NULL),(39954,'45234','S','Cincinnati','D','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.273417,-84.399795,0,'2013-07-06 12:44:32',NULL,NULL),(3920,'02460','S','Newton','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.351054,-71.207393,0,'2013-07-06 12:44:30',NULL,NULL),(78242,'97824','S','Cove','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.332750,-117.855360,0,'2013-07-06 12:44:34',NULL,NULL),(70985,'85708','S','Davis Monthan AFB','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.184649,-110.865478,0,'2013-07-06 12:44:34',NULL,NULL),(67794,'80728','S','Fleming','D','Logan','08075','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.618591,-102.853003,0,'2013-07-06 12:44:34',NULL,NULL),(63426,'75661','S','Leigh','N','Harrison','48203','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.628300,-94.175280,0,'2013-07-06 12:44:33',NULL,NULL),(62597,'74501','S','Richville','N','Pittsburg','40121','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',34.935281,-95.767139,0,'2013-07-06 12:44:33',NULL,NULL),(59742,'71136','P','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.418732,-93.760904,0,'2013-07-06 12:44:33',NULL,NULL),(58199,'68321','S','Brownville','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.397517,-95.715698,0,'2013-07-06 12:44:33',NULL,NULL),(45029,'50468','S','Rockford','D','Floyd','19067','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.055849,-92.944925,0,'2013-07-06 12:44:32',NULL,NULL),(21390,'22503','S','Regina','A','Lancaster','51103','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.763511,-76.498306,0,'2013-07-06 12:44:31',NULL,NULL),(41449,'46896','P','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.007720,-85.069323,0,'2013-07-06 12:44:32',NULL,NULL),(51025,'58712','S','Balfour','D','McHenry','38049','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.978400,-100.519271,0,'2013-07-06 12:44:33',NULL,NULL),(56253,'65058','S','Vancleve','N','Osage','29151','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.270435,-92.133364,0,'2013-07-06 12:44:33',NULL,NULL),(61084,'72131','S','Fairbanks','N','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.378007,-92.210229,0,'2013-07-06 12:44:33',NULL,NULL),(8207,'07938','P','Liberty Corner','D','Somerset','34035','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.664700,-74.577720,0,'2013-07-06 12:44:30',NULL,NULL),(34215,'38357','S','Michie','D','McNairy','47109','Tennessee','TN','47','0000','731','Central',-6.0,'Y',35.069645,-88.444749,0,'2013-07-06 12:44:32',NULL,NULL),(31014,'33781','S','Pinellas Park','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.838073,-82.715875,0,'2013-07-06 12:44:32',NULL,NULL),(25966,'28658','S','South Newton','N','Catawba','37035','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.658361,-81.233412,0,'2013-07-06 12:44:31',NULL,NULL),(2858,'00985','S','Bo Buena Vista','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.409189,-65.981382,0,'2013-07-06 12:44:30',NULL,NULL),(4614,'03595','P','Twin Mountain','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.271065,-71.541509,0,'2013-07-06 12:44:30',NULL,NULL),(7881,'07512','S','Totowa','D','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.902106,-74.218941,0,'2013-07-06 12:44:30',NULL,NULL),(10044,'10174','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.749366,-73.976646,0,'2013-07-06 12:44:30',NULL,NULL),(80161,'99812','U','Juneau','D','Juneau','02110','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',58.475528,-134.149850,0,'2013-07-06 12:44:34',NULL,NULL),(80028,'99689','P','Yakutat','D','Yakutat','02282','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',59.808020,-139.555518,0,'2013-07-06 12:44:34',NULL,NULL),(79118,'98471','U','World Vision Brm','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.252509,-122.476476,0,'2013-07-06 12:44:34',NULL,NULL),(76357,'95487','P','Vineburg','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.251972,-122.453982,0,'2013-07-06 12:44:34',NULL,NULL),(36675,'41014','S','Rouse','A','Kenton','21117','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.063763,-84.506679,0,'2013-07-06 12:44:32',NULL,NULL),(27785,'30378','P','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.757624,-84.550681,0,'2013-07-06 12:44:31',NULL,NULL),(28861,'32112','S','Crescent City','D','Putnam','12107','Florida','FL','12','0000','386','Eastern',-5.0,'Y',29.430988,-81.513718,0,'2013-07-06 12:44:32',NULL,NULL),(3044,'01104','S','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.128134,-72.571488,0,'2013-07-06 12:44:30',NULL,NULL),(73367,'91024','S','Sierra Madre','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.164984,-118.051648,0,'2013-07-06 12:44:34',NULL,NULL),(62080,'73559','S','Mountain Park','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.699521,-98.947540,0,'2013-07-06 12:44:33',NULL,NULL),(52819,'61285','S','Thompson','N','Carroll','17015','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.962948,-90.103044,0,'2013-07-06 12:44:33',NULL,NULL),(12671,'13126','S','Demster','N','Oswego','36075','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.451477,-76.501703,0,'2013-07-06 12:44:30',NULL,NULL),(12090,'12567','S','Mount Ross','N','Dutchess','36027','New York','NY','36','2281','518','Eastern',-5.0,'Y',41.993160,-73.666740,0,'2013-07-06 12:44:30',NULL,NULL),(26321,'29045','S','Pontiac','N','Kershaw','45055','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.180379,-80.797725,0,'2013-07-06 12:44:31',NULL,NULL),(21982,'23250','S','Richmond Int Airport','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.503730,-77.337500,0,'2013-07-06 12:44:31',NULL,NULL),(3152,'01259','S','Southfield','D','Berkshire','25003','Massachusetts','MA','25','0000','413','Eastern',-5.0,'Y',42.068111,-73.287921,0,'2013-07-06 12:44:30',NULL,NULL),(37313,'41647','S','East Mc Dowell','A','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.427384,-82.743993,0,'2013-07-06 12:44:32',NULL,NULL),(46412,'53178','S','Sullivan','D','Jefferson','55055','Wisconsin','WI','55','0000','262','Central',-6.0,'Y',43.010733,-88.599899,0,'2013-07-06 12:44:32',NULL,NULL),(80148,'99785','P','Brevig Msn','A','Nome','02180','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',65.459441,-166.825450,0,'2013-07-06 12:44:34',NULL,NULL),(76515,'95644','P','Pioneer','A','Amador','06005','California','CA','06','0000','209','Pacific',-8.0,'Y',38.457312,-120.530419,0,'2013-07-06 12:44:34',NULL,NULL),(74707,'93009','U','Ventura County Gov','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.266232,-119.209181,0,'2013-07-06 12:44:34',NULL,NULL),(66930,'79347','S','Muleshoe','D','Bailey','48017','Texas','TX','48','0000','806','Central',-6.0,'Y',34.224482,-102.731179,0,'2013-07-06 12:44:34',NULL,NULL),(55694,'64063','S','Lk Lotawana','N','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.917563,-94.362282,0,'2013-07-06 12:44:33',NULL,NULL),(45253,'50660','S','New Hartford','D','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.585000,-92.649072,0,'2013-07-06 12:44:32',NULL,NULL),(34888,'38947','P','N Carrollton','A','Carroll','28015','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.519480,-89.919278,0,'2013-07-06 12:44:32',NULL,NULL),(21267,'22308','S','Alexandria','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.727682,-77.058124,0,'2013-07-06 12:44:31',NULL,NULL),(20772,'21523','S','Bloomington','D','Garrett','24023','Maryland','MD','24','0000','301/240/227','Eastern',-5.0,'Y',39.504793,-79.115289,0,'2013-07-06 12:44:31',NULL,NULL),(56102,'64783','S','Schell City','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',38.000678,-94.183690,0,'2013-07-06 12:44:33',NULL,NULL),(55064,'63164','U','Nestle','N','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.636218,-90.185817,0,'2013-07-06 12:44:33',NULL,NULL),(41234,'46738','S','Cedar Creek','N','DeKalb','18033','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.348005,-85.133630,0,'2013-07-06 12:44:32',NULL,NULL),(16325,'17123','U','Traffic Safety','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265958,-76.880448,0,'2013-07-06 12:44:31',NULL,NULL),(13614,'13863','S','Willet','D','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.450705,-75.904204,0,'2013-07-06 12:44:31',NULL,NULL),(32972,'36609','S','Mobile','D','Mobile','01097','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.646418,-88.171305,0,'2013-07-06 12:44:32',NULL,NULL),(32323,'35763','S','Owens X Roads','N','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.610433,-86.463316,0,'2013-07-06 12:44:32',NULL,NULL),(14337,'15006','P','Bairdford','D','Allegheny','42003','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.633087,-79.885255,0,'2013-07-06 12:44:31',NULL,NULL),(15063,'15730','S','Coolspring','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.964684,-78.925325,0,'2013-07-06 12:44:31',NULL,NULL),(20902,'21715','P','Brownsville','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.383845,-77.659515,0,'2013-07-06 12:44:31',NULL,NULL),(79175,'98520','S','Central Park','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',47.043360,-123.762540,0,'2013-07-06 12:44:34',NULL,NULL),(76533,'95655','S','Mather','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.550396,-121.280814,0,'2013-07-06 12:44:34',NULL,NULL),(75125,'93551','S','Quartz Hill','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.600777,-118.190371,0,'2013-07-06 12:44:34',NULL,NULL),(27405,'30092','S','Norcross','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.973773,-84.238127,0,'2013-07-06 12:44:31',NULL,NULL),(21943,'23231','S','Richmond','A','Henrico','51087','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.459440,-77.314440,0,'2013-07-06 12:44:31',NULL,NULL),(7616,'07055','S','Dundee','N','Passaic','34031','New Jersey','NJ','34','0875','973/862','Eastern',-5.0,'Y',40.859415,-74.130577,0,'2013-07-06 12:44:30',NULL,NULL),(11119,'11703','S','North Babylon','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732426,-73.324916,0,'2013-07-06 12:44:30',NULL,NULL),(44302,'49735','S','Gaylord','D','Otsego','26137','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.987952,-84.675724,0,'2013-07-06 12:44:32',NULL,NULL),(45897,'52309','S','Monmouth','D','Jackson','19097','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.082257,-90.870603,0,'2013-07-06 12:44:32',NULL,NULL),(51617,'59840','S','Hamilton','D','Ravalli','30081','Montana','MT','30','0000','406','Mountain',-7.0,'Y',46.229862,-114.164719,0,'2013-07-06 12:44:33',NULL,NULL),(53320,'61743','S','Graymont','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.909715,-88.756025,0,'2013-07-06 12:44:33',NULL,NULL),(74594,'92702','P','Santa Ana','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.736548,-117.871389,0,'2013-07-06 12:44:34',NULL,NULL),(75163,'93591','S','Lake La','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.604861,-117.832601,0,'2013-07-06 12:44:34',NULL,NULL),(70932,'85636','P','Sierra Vista','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.470032,-110.187121,0,'2013-07-06 12:44:34',NULL,NULL),(68565,'81435','S','Telluride','D','San Miguel','08113','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',37.979875,-107.941486,0,'2013-07-06 12:44:34',NULL,NULL),(35374,'39452','S','Latonia','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(14677,'15242','P','Greentree','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.417412,-80.045004,0,'2013-07-06 12:44:31',NULL,NULL),(28618,'31712','S','Arabi','D','Crisp','13081','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.839748,-83.725125,0,'2013-07-06 12:44:32',NULL,NULL),(52010,'60173','S','Hoffman Est','N','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.042778,-88.079722,0,'2013-07-06 12:44:33',NULL,NULL),(7088,'06351','S','Jewett City','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.601907,-71.977075,0,'2013-07-06 12:44:30',NULL,NULL),(79940,'99623','S','Big Lake','A','Matanuska Susitna','02170','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',61.593459,-149.414728,0,'2013-07-06 12:44:34',NULL,NULL),(74953,'93421','P','Arroyo Grande','D','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.120678,-120.574422,0,'2013-07-06 12:44:34',NULL,NULL),(64829,'77036','S','Sharpstown','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.701008,-95.536659,0,'2013-07-06 12:44:34',NULL,NULL),(33777,'37871','S','Strawberry Plains','D','Jefferson','47089','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',36.018011,-83.706710,0,'2013-07-06 12:44:32',NULL,NULL),(30777,'33584','S','Seffner','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.990282,-82.285514,0,'2013-07-06 12:44:32',NULL,NULL),(59044,'70085','S','Reggio','N','Saint Bernard','22087','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.864280,-89.789580,0,'2013-07-06 12:44:33',NULL,NULL),(75520,'94159','P','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.784023,-122.453299,0,'2013-07-06 12:44:34',NULL,NULL),(63928,'76060','S','Kennedale','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.642683,-97.211734,0,'2013-07-06 12:44:34',NULL,NULL),(58017,'67880','S','Ulysses','D','Grant','20067','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.583530,-101.358939,0,'2013-07-06 12:44:33',NULL,NULL),(12143,'12729','S','Godeffroy','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.485047,-74.627581,0,'2013-07-06 12:44:30',NULL,NULL),(19147,'19707','S','Hockessin','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.778270,-75.687486,0,'2013-07-06 12:44:31',NULL,NULL),(38436,'43558','S','Swanton','D','Fulton','39051','Ohio','OH','39','8400','419/567','Eastern',-5.0,'Y',41.580263,-83.912406,0,'2013-07-06 12:44:32',NULL,NULL),(42452,'47808','P','Terre Haute','D','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.512735,-87.351994,0,'2013-07-06 12:44:32',NULL,NULL),(44913,'50330','U','Des Moines','D','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.587059,-93.637291,0,'2013-07-06 12:44:32',NULL,NULL),(70773,'85340','S','Litchfield Pk','A','Maricopa','04013','Arizona','AZ','04','6200','623','Mountain',-7.0,'N',33.497954,-112.376641,0,'2013-07-06 12:44:34',NULL,NULL),(66869,'79201','S','Northfield','A','Childress','48075','Texas','TX','48','0000','940','Central',-6.0,'Y',34.432500,-100.145820,0,'2013-07-06 12:44:34',NULL,NULL),(64822,'77030','S','VA Hospital','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.709260,-95.400851,0,'2013-07-06 12:44:34',NULL,NULL),(51113,'58784','S','Stanley','D','Mountrail','38061','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.312403,-102.392847,0,'2013-07-06 12:44:33',NULL,NULL),(26055,'28690','S','Valdese','D','Burke','37023','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.743328,-81.563588,0,'2013-07-06 12:44:31',NULL,NULL),(22124,'23437','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.627139,-76.791066,0,'2013-07-06 12:44:31',NULL,NULL),(12585,'13072','S','Geotown','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.763862,-75.753162,0,'2013-07-06 12:44:30',NULL,NULL),(7213,'06493','U','Publishers Clearing House','N','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.486804,-72.822757,0,'2013-07-06 12:44:30',NULL,NULL),(41075,'46526','S','Foraker','A','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.586985,-85.835835,0,'2013-07-06 12:44:32',NULL,NULL),(46445,'53209','S','Glendale','A','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.125920,-87.946764,0,'2013-07-06 12:44:32',NULL,NULL),(5197,'04450','S','Kenduskeag','D','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',44.919584,-68.929924,0,'2013-07-06 12:44:30',NULL,NULL),(57196,'66424','S','Everest','D','Brown','20013','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.707519,-95.396757,0,'2013-07-06 12:44:33',NULL,NULL),(54892,'63070','S','Horine','N','Jefferson','29099','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.283780,-90.440460,0,'2013-07-06 12:44:33',NULL,NULL),(37362,'41725','P','Carrie','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.308153,-83.027485,0,'2013-07-06 12:44:32',NULL,NULL),(30609,'33427','P','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.346052,-80.082015,0,'2013-07-06 12:44:32',NULL,NULL),(23016,'24828','S','Asco','A','McDowell','54047','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.470561,-81.659490,0,'2013-07-06 12:44:31',NULL,NULL),(77136,'96157','P','South Lake Tahoe','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.940824,-119.980263,0,'2013-07-06 12:44:34',NULL,NULL),(72079,'88133','S','St Vrain','N','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.485021,-103.456802,0,'2013-07-06 12:44:34',NULL,NULL),(59730,'71112','S','Bossier City','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.486057,-93.671643,0,'2013-07-06 12:44:33',NULL,NULL),(57395,'66757','S','Buffville','N','Wilson','20205','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.428154,-95.680875,0,'2013-07-06 12:44:33',NULL,NULL),(57004,'66204','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.992504,-94.682925,0,'2013-07-06 12:44:33',NULL,NULL),(15485,'16442','S','Lowville','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.025336,-79.824940,0,'2013-07-06 12:44:31',NULL,NULL),(36750,'41040','S','Lenoxburg','N','Pendleton','21191','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.678730,-84.333508,0,'2013-07-06 12:44:32',NULL,NULL),(73920,'92024','S','Leucadia','N','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.055326,-117.263733,0,'2013-07-06 12:44:34',NULL,NULL),(73728,'91618','P','North Hollywood','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.112736,-118.365832,0,'2013-07-06 12:44:34',NULL,NULL),(71788,'87560','S','Gonzales Rnch','A','San Miguel','35047','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.234975,-105.523122,0,'2013-07-06 12:44:34',NULL,NULL),(71123,'86020','P','Cameron','D','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'Y',35.848183,-111.431257,0,'2013-07-06 12:44:34',NULL,NULL),(25551,'28409','S','Wilm','N','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.164792,-77.873138,0,'2013-07-06 12:44:31',NULL,NULL),(20661,'21226','S','Greenland Bch','A','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.200554,-76.554316,0,'2013-07-06 12:44:31',NULL,NULL),(54587,'62901','S','Brush Hill','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.728408,-89.222946,0,'2013-07-06 12:44:33',NULL,NULL),(63516,'75751','S','Walton','N','Henderson','48213','Texas','TX','48','1920','903/430','Central',-6.0,'Y',32.162700,-95.822280,0,'2013-07-06 12:44:33',NULL,NULL),(65386,'77550','S','Jamaica Beach','N','Galveston','48167','Texas','TX','48','2920','409','Central',-6.0,'Y',29.301240,-94.788420,0,'2013-07-06 12:44:34',NULL,NULL),(56168,'64868','P','Tiff City','D','McDonald','29119','Missouri','MO','29','0000','417','Central',-6.0,'Y',36.667280,-94.598784,0,'2013-07-06 12:44:33',NULL,NULL),(54732,'62966','S','Mboro','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(44050,'49431','S','Ludington','D','Mason','26105','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',43.967114,-86.419549,0,'2013-07-06 12:44:32',NULL,NULL),(29223,'32423','S','Bascom','D','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.957522,-85.079542,0,'2013-07-06 12:44:32',NULL,NULL),(4128,'02744','S','New Bedford','D','Bristol','25005','Massachusetts','MA','25','5400','508/774','Eastern',-5.0,'Y',41.612432,-70.914928,0,'2013-07-06 12:44:30',NULL,NULL),(78258,'97841','S','Imbler','D','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.471602,-117.962094,0,'2013-07-06 12:44:34',NULL,NULL),(74720,'93023','S','Meiners Oaks','N','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.448123,-119.252560,0,'2013-07-06 12:44:34',NULL,NULL),(73597,'91390','S','Agua Dulce','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.482978,-118.428774,0,'2013-07-06 12:44:34',NULL,NULL),(69241,'83420','S','Marysville','N','Fremont','16043','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',44.042760,-111.375420,0,'2013-07-06 12:44:34',NULL,NULL),(59415,'70652','S','Longville','D','Beauregard','22011','Louisiana','LA','22','0000','337','Central',-6.0,'Y',30.594402,-93.269500,0,'2013-07-06 12:44:33',NULL,NULL),(53412,'61841','S','Fairmount','D','Vermilion','17183','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.046166,-87.832084,0,'2013-07-06 12:44:33',NULL,NULL),(47733,'55011','S','Cedar E Bethl','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.348975,-93.246677,0,'2013-07-06 12:44:33',NULL,NULL),(9323,'09735','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(11505,'12025','S','Stevers Mills','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(33868,'38015','S','Burlison','D','Tipton','47167','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.560536,-89.838101,0,'2013-07-06 12:44:32',NULL,NULL),(2950,'01034','S','Granville','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.081960,-72.950580,0,'2013-07-06 12:44:30',NULL,NULL),(26113,'28725','P','Dillsboro','D','Jackson','37099','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.369907,-83.251691,0,'2013-07-06 12:44:31',NULL,NULL),(9750,'10101','P','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(6086,'05450','S','Enosburg Falls','D','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.900880,-72.793260,0,'2013-07-06 12:44:30',NULL,NULL),(40683,'46064','S','Huntsville','N','Madison','18095','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',39.992520,-85.772940,0,'2013-07-06 12:44:32',NULL,NULL),(70532,'85016','S','Phoenix','D','Maricopa','04013','Arizona','AZ','04','6200','602','Mountain',-7.0,'N',33.504248,-112.029405,0,'2013-07-06 12:44:34',NULL,NULL),(66619,'78774','U','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.279861,-97.739184,0,'2013-07-06 12:44:34',NULL,NULL),(65217,'77441','S','Fulshear','D','Fort Bend','48157','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.680355,-95.926739,0,'2013-07-06 12:44:34',NULL,NULL),(64903,'77089','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.586462,-95.220419,0,'2013-07-06 12:44:34',NULL,NULL),(58711,'68934','S','Spring Ranch','N','Clay','31035','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.355030,-98.138110,0,'2013-07-06 12:44:33',NULL,NULL),(49367,'56584','S','Fossum','N','Norman','27107','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.284811,-96.264019,0,'2013-07-06 12:44:33',NULL,NULL),(37076,'41314','S','Turkey','A','Owsley','21189','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.480497,-83.664385,0,'2013-07-06 12:44:32',NULL,NULL),(3059,'01115','P','Bay State W Tower','N','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.104032,-72.591791,0,'2013-07-06 12:44:30',NULL,NULL),(19522,'20185','P','Upperville','D','Fauquier','51061','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.994497,-77.881808,0,'2013-07-06 12:44:31',NULL,NULL),(18104,'18764','U','Wilkes Barre','D','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.218277,-75.794595,0,'2013-07-06 12:44:31',NULL,NULL),(47375,'54626','S','Eastman','D','Crawford','55023','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.193536,-91.014896,0,'2013-07-06 12:44:32',NULL,NULL),(47854,'55077','S','Inver Grove','A','Dakota','27037','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.839723,-93.076930,0,'2013-07-06 12:44:33',NULL,NULL),(48351,'55483','U','Qwest','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.935113,-93.283739,0,'2013-07-06 12:44:33',NULL,NULL),(50886,'58533','S','Elgin','D','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.409640,-101.831280,0,'2013-07-06 12:44:33',NULL,NULL),(21724,'23004','S','Akunia','N','Buckingham','51029','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.667219,-78.413499,0,'2013-07-06 12:44:31',NULL,NULL),(19719,'20392','U','Navy Observatory','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.933497,-77.060031,0,'2013-07-06 12:44:31',NULL,NULL),(14606,'15225','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.515120,-80.087760,0,'2013-07-06 12:44:31',NULL,NULL),(27886,'30458','S','Statesboro','D','Bulloch','13031','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',32.445090,-81.780358,0,'2013-07-06 12:44:31',NULL,NULL),(30349,'33312','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.088164,-80.184514,0,'2013-07-06 12:44:32',NULL,NULL),(78185,'97711','S','Ashwood','D','Jefferson','41031','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.692443,-120.653263,0,'2013-07-06 12:44:34',NULL,NULL),(76720,'95864','S','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.585978,-121.376409,0,'2013-07-06 12:44:34',NULL,NULL),(60891,'72069','S','Blackton','N','Monroe','05095','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.602963,-91.165029,0,'2013-07-06 12:44:33',NULL,NULL),(52646,'61060','S','Oneco','N','Stephenson','17177','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.473749,-89.636004,0,'2013-07-06 12:44:33',NULL,NULL),(36322,'40384','U','Quadgraphics','N','Woodford','21239','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',38.051980,-84.725980,0,'2013-07-06 12:44:32',NULL,NULL),(30670,'33467','S','Lake Worth','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.606929,-80.177700,0,'2013-07-06 12:44:32',NULL,NULL),(30460,'33336','U','American Express','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.142550,-80.139499,0,'2013-07-06 12:44:32',NULL,NULL),(24147,'26574','P','Grant Town','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.555996,-80.178507,0,'2013-07-06 12:44:31',NULL,NULL),(37447,'41840','S','Hall','A','Letcher','21133','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.212627,-82.707115,0,'2013-07-06 12:44:32',NULL,NULL),(38218,'43220','S','Upper Arlington','A','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.000000,-83.066667,0,'2013-07-06 12:44:32',NULL,NULL),(47892,'55107','S','Saint Paul','D','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.932638,-93.077152,0,'2013-07-06 12:44:33',NULL,NULL),(14180,'14744','S','Houghton','D','Allegany','36003','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.416695,-78.167853,0,'2013-07-06 12:44:31',NULL,NULL),(70194,'84337','S','Thatcher','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.676420,-112.267800,0,'2013-07-06 12:44:34',NULL,NULL),(50365,'57752','S','Kyle','D','Shannon','46113','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.535696,-102.320814,0,'2013-07-06 12:44:33',NULL,NULL),(42950,'48125','S','Dearborn Heights','D','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.275895,-83.263587,0,'2013-07-06 12:44:32',NULL,NULL),(24054,'26425','S','Rowlesburg','D','Preston','54077','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.224494,-79.662638,0,'2013-07-06 12:44:31',NULL,NULL),(21095,'22039','S','Fx Station','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.763405,-77.314652,0,'2013-07-06 12:44:31',NULL,NULL),(9991,'10165','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755416,-73.980319,0,'2013-07-06 12:44:30',NULL,NULL),(77171,'96269','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(67561,'80290','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.752640,-104.991856,0,'2013-07-06 12:44:34',NULL,NULL),(60916,'72080','S','Jerusalem','D','Conway','05029','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.395533,-92.806007,0,'2013-07-06 12:44:33',NULL,NULL),(57899,'67645','S','Lenora','D','Norton','20137','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610537,-100.001449,0,'2013-07-06 12:44:33',NULL,NULL),(52167,'60456','S','Hometown','D','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.734578,-87.732449,0,'2013-07-06 12:44:33',NULL,NULL),(4537,'03445','S','E Sullivan','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.995925,-72.191513,0,'2013-07-06 12:44:30',NULL,NULL),(25753,'28579','S','Williston','A','Carteret','37031','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',34.800896,-76.512781,0,'2013-07-06 12:44:31',NULL,NULL),(1631,'00771','S','Urb April Gdns','N','Las Piedras','72085','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.182105,-65.869167,0,'2013-07-06 12:44:30',NULL,NULL),(6618,'05875','S','West Glover','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.696433,-72.268832,0,'2013-07-06 12:44:30',NULL,NULL),(19747,'20409','U','Fed Records Center','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.861490,-76.950140,0,'2013-07-06 12:44:31',NULL,NULL),(62990,'75150','S','Mesquite','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.814395,-96.625303,0,'2013-07-06 12:44:33',NULL,NULL),(51902,'60102','S','Lake in the Hills','A','McHenry','17111','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.170820,-88.318740,0,'2013-07-06 12:44:33',NULL,NULL),(42310,'47601','S','Pelzer','N','Warrick','18173','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.057280,-87.262440,0,'2013-07-06 12:44:32',NULL,NULL),(41929,'47384','S','Shirley','D','Henry','18065','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.888672,-85.580079,0,'2013-07-06 12:44:32',NULL,NULL),(27218,'29912','S','Coosawhatchie','D','Jasper','45053','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.488115,-80.987419,0,'2013-07-06 12:44:31',NULL,NULL),(3811,'02284','P','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.351144,-71.057065,0,'2013-07-06 12:44:30',NULL,NULL),(7585,'07034','S','Lake Hiawatha','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.879225,-74.384333,0,'2013-07-06 12:44:30',NULL,NULL),(576,'00680','S','Bo Cantera','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(79061,'98424','S','Fife','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.238360,-122.362020,0,'2013-07-06 12:44:34',NULL,NULL),(63138,'75360','P','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.939795,-96.792819,0,'2013-07-06 12:44:33',NULL,NULL),(13441,'13763','P','Endicott','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094477,-76.065139,0,'2013-07-06 12:44:31',NULL,NULL),(12738,'13165','S','Waterloo','D','Seneca','36099','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.907458,-76.877046,0,'2013-07-06 12:44:30',NULL,NULL),(1377,'00738','S','Alts de Monte Brisas','N','Fajardo','72053','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.332258,-65.659254,0,'2013-07-06 12:44:30',NULL,NULL),(23898,'26201','S','Century','A','Upshur','54097','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.983537,-80.225375,0,'2013-07-06 12:44:31',NULL,NULL),(28203,'31024','S','Eatonton','D','Putnam','13237','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.326891,-83.345511,0,'2013-07-06 12:44:31',NULL,NULL),(38766,'44046','S','Huntsburg','D','Geauga','39055','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.536534,-81.062161,0,'2013-07-06 12:44:32',NULL,NULL),(39053,'44193','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.502884,-81.695421,0,'2013-07-06 12:44:32',NULL,NULL),(56548,'65459','S','Dixon','D','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.999415,-92.102681,0,'2013-07-06 12:44:33',NULL,NULL),(63015,'75168','P','Waxahachie','D','Ellis','48139','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.305345,-96.769099,0,'2013-07-06 12:44:33',NULL,NULL),(8225,'07974','S','New Providence','D','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.700446,-74.405937,0,'2013-07-06 12:44:30',NULL,NULL),(75664,'94540','P','Hayward','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.658815,-122.095048,0,'2013-07-06 12:44:34',NULL,NULL),(73148,'90278','S','Redondo Beach','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.871269,-118.371584,0,'2013-07-06 12:44:34',NULL,NULL),(72541,'89179','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',35.996955,-115.251532,0,'2013-07-06 12:44:34',NULL,NULL),(68771,'82321','S','Baggs','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.032392,-107.608311,0,'2013-07-06 12:44:34',NULL,NULL),(34696,'38829','S','Altitude','N','Prentiss','28117','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.654538,-88.559614,0,'2013-07-06 12:44:32',NULL,NULL),(29131,'32322','S','Carrabelle','D','Franklin','12037','Florida','FL','12','0000','850','Eastern',-5.0,'Y',29.940707,-84.632787,0,'2013-07-06 12:44:32',NULL,NULL),(27726,'30348','P','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.835327,-84.392667,0,'2013-07-06 12:44:31',NULL,NULL),(9931,'10153','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.763133,-73.972541,0,'2013-07-06 12:44:30',NULL,NULL),(39737,'45068','S','Waynesville','D','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.520020,-84.073920,0,'2013-07-06 12:44:32',NULL,NULL),(45838,'52218','S','Coggon','D','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.278588,-91.540055,0,'2013-07-06 12:44:32',NULL,NULL),(55002,'63131','S','Country Life Acres','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.616726,-90.446097,0,'2013-07-06 12:44:33',NULL,NULL),(55795,'64128','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.067188,-94.536792,0,'2013-07-06 12:44:33',NULL,NULL),(60234,'71430','S','Forest Hill','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.051000,-92.507059,0,'2013-07-06 12:44:33',NULL,NULL),(58872,'69155','S','Bucktail','N','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.211049,-101.375901,0,'2013-07-06 12:44:33',NULL,NULL),(27320,'30028','S','Cumming','D','Forsyth','13117','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.205991,-84.136243,0,'2013-07-06 12:44:31',NULL,NULL),(20180,'20746','S','Morningside','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.837308,-76.918744,0,'2013-07-06 12:44:31',NULL,NULL),(35628,'39633','S','Coles','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(22321,'23845','S','Ebony','D','Brunswick','51025','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.541036,-77.981982,0,'2013-07-06 12:44:31',NULL,NULL),(24313,'27017','S','Stony Knoll','N','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.364620,-80.712840,0,'2013-07-06 12:44:31',NULL,NULL),(24995,'27866','S','Pleasant Hill','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.525713,-77.514848,0,'2013-07-06 12:44:31',NULL,NULL),(26671,'29395','U','Jonesville','D','Union','45087','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.855365,-81.738114,0,'2013-07-06 12:44:31',NULL,NULL),(3611,'02051','P','Marshfld Hls','A','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.145186,-70.723880,0,'2013-07-06 12:44:30',NULL,NULL),(58744,'68955','S','Assumption','N','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.587480,-98.516760,0,'2013-07-06 12:44:33',NULL,NULL),(53013,'61460','S','Media','D','Henderson','17071','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.770156,-90.851521,0,'2013-07-06 12:44:33',NULL,NULL),(48741,'55968','S','Reads Landing','D','Wabasha','27157','Minnesota','MN','27','0000','651','Central',-6.0,'Y',44.401512,-92.073119,0,'2013-07-06 12:44:33',NULL,NULL),(45982,'52411','S','Robins','N','Linn','19113','Iowa','IA','19','1360','319','Central',-6.0,'Y',42.040798,-91.723138,0,'2013-07-06 12:44:32',NULL,NULL),(42277,'47585','S','Lockhart','N','Pike','18125','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.277754,-87.128319,0,'2013-07-06 12:44:32',NULL,NULL),(39172,'44310','S','Chapel Hill Mall','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.106498,-81.497681,0,'2013-07-06 12:44:32',NULL,NULL),(16305,'17112','S','Harrisburg','D','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.338060,-76.803780,0,'2013-07-06 12:44:31',NULL,NULL),(15447,'16403','S','Cambridg Spgs','A','Crawford','42039','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.800913,-80.061183,0,'2013-07-06 12:44:31',NULL,NULL),(36893,'41102','S','Ashland','D','Boyd','21019','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.441408,-82.688442,0,'2013-07-06 12:44:32',NULL,NULL),(12627,'13090','S','Lvpl','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.149327,-76.223372,0,'2013-07-06 12:44:30',NULL,NULL),(32620,'36141','U','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.386911,-86.148084,0,'2013-07-06 12:44:32',NULL,NULL),(31345,'34143','P','Immokalee','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',26.429476,-81.433479,0,'2013-07-06 12:44:32',NULL,NULL),(9609,'10032','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.836680,-73.939944,0,'2013-07-06 12:44:30',NULL,NULL),(2332,'00936','P','65th Infantry','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(68836,'82520','S','Lander','D','Fremont','56013','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.841536,-108.726957,0,'2013-07-06 12:44:34',NULL,NULL),(52506,'60803','S','Chicago','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.667210,-87.740131,0,'2013-07-06 12:44:33',NULL,NULL),(49234,'56470','S','Dorset','N','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(3058,'01111','U','Springfield','D','Hampden','25013','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.117977,-72.547899,0,'2013-07-06 12:44:30',NULL,NULL),(1537,'00757','S','Est de Santa Isabel','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(26068,'28694','S','Treetop','N','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.352140,-81.472380,0,'2013-07-06 12:44:31',NULL,NULL),(21119,'22082','U','Merrifield','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.872667,-77.237303,0,'2013-07-06 12:44:31',NULL,NULL),(24891,'27707','S','Shannon Plaza','A','Durham','37063','North Carolina','NC','37','6640','919/984','Eastern',-5.0,'Y',35.964557,-78.940527,0,'2013-07-06 12:44:31',NULL,NULL),(22546,'24130','S','Oriskany','D','Botetourt','51023','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.661877,-79.834957,0,'2013-07-06 12:44:31',NULL,NULL),(39208,'44398','U','Fairlawn','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081679,-81.507276,0,'2013-07-06 12:44:32',NULL,NULL),(47316,'54557','S','Presque Isle','D','Vilas','55125','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.223820,-89.758920,0,'2013-07-06 12:44:32',NULL,NULL),(49679,'57016','S','Chester','D','Lake','46079','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.894594,-97.007429,0,'2013-07-06 12:44:33',NULL,NULL),(55413,'63653','S','Flat River','A','Saint Francois','29187','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.863336,-90.592582,0,'2013-07-06 12:44:33',NULL,NULL),(55667,'64034','S','Lk Winnebago','A','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',38.849040,-94.287060,0,'2013-07-06 12:44:33',NULL,NULL),(15769,'16917','S','Covington','D','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.757299,-77.067597,0,'2013-07-06 12:44:31',NULL,NULL),(72853,'89883','P','West Wendover','D','Elko','32007','Nevada','NV','32','0000','775','Mountain',-7.0,'Y',40.691330,-114.143019,0,'2013-07-06 12:44:34',NULL,NULL),(69878,'84098','S','Park City','D','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.657510,-111.495033,0,'2013-07-06 12:44:34',NULL,NULL),(63179,'75411','S','Arthur City','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.849066,-95.459112,0,'2013-07-06 12:44:33',NULL,NULL),(62852,'75023','S','Plano','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.057653,-96.737455,0,'2013-07-06 12:44:33',NULL,NULL),(13045,'13439','S','Warren','N','Otsego','36077','New York','NY','36','0000','315','Eastern',-5.0,'Y',42.851410,-74.988541,0,'2013-07-06 12:44:30',NULL,NULL),(30945,'33729','U','Saint Petersburg','D','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.878378,-82.669082,0,'2013-07-06 12:44:32',NULL,NULL),(6335,'05667','S','Pekin','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.243569,-72.409078,0,'2013-07-06 12:44:30',NULL,NULL),(11234,'11755','S','Lake Grove','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.858261,-73.117533,0,'2013-07-06 12:44:30',NULL,NULL),(26142,'28737','P','Marion','A','McDowell','37111','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.683889,-82.009444,0,'2013-07-06 12:44:31',NULL,NULL),(60545,'71721','P','Beirne','D','Clark','05019','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.890766,-93.202851,0,'2013-07-06 12:44:33',NULL,NULL),(61666,'72917','P','Fort Smith','D','Sebastian','05131','Arkansas','AR','05','2720','479','Central',-6.0,'Y',35.331225,-94.376810,0,'2013-07-06 12:44:33',NULL,NULL),(8283,'08015','S','Browns Mills','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.963656,-74.567804,0,'2013-07-06 12:44:30',NULL,NULL),(78468,'98075','S','Sammamish','D','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.586461,-122.030567,0,'2013-07-06 12:44:34',NULL,NULL),(77654,'97018','S','Columbia City','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.894545,-122.815837,0,'2013-07-06 12:44:34',NULL,NULL),(73784,'91745','S','Hacienda Hts','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',33.998974,-117.965163,0,'2013-07-06 12:44:34',NULL,NULL),(66101,'78409','S','Corp Christi','A','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.811342,-97.516007,0,'2013-07-06 12:44:34',NULL,NULL),(50216,'57580','S','Keyapaha','A','Tripp','46123','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.367573,-99.865593,0,'2013-07-06 12:44:33',NULL,NULL),(18596,'19138','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.058584,-75.160929,0,'2013-07-06 12:44:31',NULL,NULL),(12997,'13411','S','Columbus','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(36934,'41164','S','Garvin Ridge','N','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.305124,-83.169523,0,'2013-07-06 12:44:32',NULL,NULL),(33873,'38017','S','Fisherville','A','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.054102,-89.679063,0,'2013-07-06 12:44:32',NULL,NULL),(33228,'37064','S','Peytonsville','N','Williamson','47187','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.923225,-86.887821,0,'2013-07-06 12:44:32',NULL,NULL),(29478,'32725','S','Enterprise','A','Volusia','12127','Florida','FL','12','2020','407/321','Eastern',-5.0,'Y',28.898339,-81.241296,0,'2013-07-06 12:44:32',NULL,NULL),(24404,'27108','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.090834,-80.247942,0,'2013-07-06 12:44:31',NULL,NULL),(10608,'11040','S','No New Hyde Park','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.742887,-73.676015,0,'2013-07-06 12:44:30',NULL,NULL),(78265,'97850','S','Island City','A','Union','41061','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.331036,-118.078078,0,'2013-07-06 12:44:34',NULL,NULL),(56164,'64865','S','Hornet','N','Newton','29145','Missouri','MO','29','3710','417','Central',-6.0,'Y',36.839888,-94.609979,0,'2013-07-06 12:44:33',NULL,NULL),(21776,'23063','S','Goochland','D','Goochland','51075','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.680935,-77.886050,0,'2013-07-06 12:44:31',NULL,NULL),(37398,'41772','S','Vest','D','Knott','21119','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.431548,-83.071184,0,'2013-07-06 12:44:32',NULL,NULL),(31271,'34008','M','DPO','D','none','00000','Armed Forces - Americas','AA','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:32',NULL,NULL),(29235,'32431','S','Jacob','A','Jackson','12063','Florida','FL','12','0000','850','Central',-6.0,'Y',30.798181,-85.373699,0,'2013-07-06 12:44:32',NULL,NULL),(1550,'00757','S','Villa Serena','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(27508,'30182','S','Waco','D','Haralson','13143','Georgia','GA','13','0000','770/678/470','Eastern',-5.0,'Y',33.642788,-85.234357,0,'2013-07-06 12:44:31',NULL,NULL),(20820,'21623','S','Church Hill','D','Queen Annes','24035','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.107562,-75.970112,0,'2013-07-06 12:44:31',NULL,NULL),(67166,'79834','P','Big Bend National Park','D','Brewster','48043','Texas','TX','48','0000','432','Central',-6.0,'Y',29.290990,-103.182413,0,'2013-07-06 12:44:34',NULL,NULL),(60532,'71674','S','Watson','D','Desha','05041','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.798097,-91.302406,0,'2013-07-06 12:44:33',NULL,NULL),(48848,'56065','S','Mapleton','D','Blue Earth','27013','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.926749,-93.955128,0,'2013-07-06 12:44:33',NULL,NULL),(44985,'50430','S','Corwith','D','Hancock','19081','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.993070,-93.953142,0,'2013-07-06 12:44:32',NULL,NULL),(42834,'48067','S','Royal Oak','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.491862,-83.140721,0,'2013-07-06 12:44:32',NULL,NULL),(3937,'02467','S','Boston Clg','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.318527,-71.157052,0,'2013-07-06 12:44:30',NULL,NULL),(27083,'29707','S','Fort Mill','D','Lancaster','45057','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006139,-80.947219,0,'2013-07-06 12:44:31',NULL,NULL),(23261,'25132','S','Mammoth','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.255724,-81.374280,0,'2013-07-06 12:44:31',NULL,NULL),(20918,'21734','P','Funkstown','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.606917,-77.708414,0,'2013-07-06 12:44:31',NULL,NULL),(66817,'79086','S','Sunray','D','Moore','48341','Texas','TX','48','0000','806','Central',-6.0,'Y',36.017388,-101.827006,0,'2013-07-06 12:44:34',NULL,NULL),(64703,'76855','P','Lowake','D','Concho','48095','Texas','TX','48','0000','325','Central',-6.0,'Y',31.449890,-100.059135,0,'2013-07-06 12:44:34',NULL,NULL),(63378,'75644','S','Graceton','N','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.730600,-94.958940,0,'2013-07-06 12:44:33',NULL,NULL),(61029,'72117','S','N L R','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.780920,-92.152080,0,'2013-07-06 12:44:33',NULL,NULL),(40635,'46031','S','East Union','N','Hamilton','18057','Indiana','IN','18','3480','765','Eastern',-5.0,'Y',40.162140,-85.935600,0,'2013-07-06 12:44:32',NULL,NULL),(40591,'45879','S','Paulding','D','Paulding','39125','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.137337,-84.586462,0,'2013-07-06 12:44:32',NULL,NULL),(22393,'23947','S','Keysville','D','Charlotte','51037','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.989834,-78.223003,0,'2013-07-06 12:44:31',NULL,NULL),(32667,'36263','S','Hightower','N','Randolph','01111','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.462293,-85.338064,0,'2013-07-06 12:44:32',NULL,NULL),(11825,'12239','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.650821,-73.758546,0,'2013-07-06 12:44:30',NULL,NULL),(25114,'27981','S','Wanchese','D','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.835210,-75.642417,0,'2013-07-06 12:44:31',NULL,NULL),(1702,'00777','S','Urb Madrid','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(16386,'17213','S','Blairs Mills','D','Huntingdon','42061','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.254967,-77.776007,0,'2013-07-06 12:44:31',NULL,NULL),(3896,'02447','P','Brookline','N','Norfolk','25021','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.333546,-71.118745,0,'2013-07-06 12:44:30',NULL,NULL),(50447,'58015','S','Christine','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.532610,-96.782930,0,'2013-07-06 12:44:33',NULL,NULL),(50432,'57793','S','Whitewood','D','Lawrence','46081','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',44.464081,-103.637351,0,'2013-07-06 12:44:33',NULL,NULL),(47494,'54757','S','Island Lake','N','Chippewa','55017','Wisconsin','WI','55','2290','715','Central',-6.0,'Y',45.245040,-91.470240,0,'2013-07-06 12:44:32',NULL,NULL),(21343,'22427','S','Ft Ap Hill','N','Caroline','51033','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.049038,-77.350933,0,'2013-07-06 12:44:31',NULL,NULL),(32784,'36420','S','Libertyville','N','Covington','01039','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.237080,-86.575800,0,'2013-07-06 12:44:32',NULL,NULL),(573,'00680','S','Bo Barcelona','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(74985,'93446','S','Heritage Rnch','A','San Luis Obispo','06079','California','CA','06','7460','805','Pacific',-8.0,'Y',35.637137,-120.691676,0,'2013-07-06 12:44:34',NULL,NULL),(72074,'88130','S','Arch','N','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.154940,-103.335720,0,'2013-07-06 12:44:34',NULL,NULL),(67041,'79545','S','Wastella','N','Nolan','48353','Texas','TX','48','0000','325','Central',-6.0,'Y',32.440465,-100.529095,0,'2013-07-06 12:44:34',NULL,NULL),(58173,'68303','S','Alexandria','D','Thayer','31169','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.250787,-97.389823,0,'2013-07-06 12:44:33',NULL,NULL),(33225,'37063','P','Fosterville','D','Rutherford','47149','Tennessee','TN','47','5360','615','Central',-6.0,'Y',35.745445,-86.388115,0,'2013-07-06 12:44:32',NULL,NULL),(5860,'05143','S','Chester','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.279682,-72.575582,0,'2013-07-06 12:44:30',NULL,NULL),(28013,'30621','S','Bishop','D','Oconee','13219','Georgia','GA','13','0500','706/762','Eastern',-5.0,'Y',33.833825,-83.471768,0,'2013-07-06 12:44:31',NULL,NULL),(25731,'28552','S','Lowland','D','Pamlico','37137','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.306995,-76.569858,0,'2013-07-06 12:44:31',NULL,NULL),(38189,'43202','S','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.020415,-83.011890,0,'2013-07-06 12:44:32',NULL,NULL),(22610,'24216','S','Appalachia','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.906361,-82.782620,0,'2013-07-06 12:44:31',NULL,NULL),(46218,'52769','S','Stockton','D','Muscatine','19139','Iowa','IA','19','0000','563','Central',-6.0,'Y',41.654523,-90.835711,0,'2013-07-06 12:44:32',NULL,NULL),(10135,'10265','U','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.703113,-74.013325,0,'2013-07-06 12:44:30',NULL,NULL),(79108,'98464','P','University Place','A','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.225450,-122.537309,0,'2013-07-06 12:44:34',NULL,NULL),(65683,'77995','S','Fordtran','N','Lavaca','48285','Texas','TX','48','0000','361','Central',-6.0,'Y',29.320800,-97.125360,0,'2013-07-06 12:44:34',NULL,NULL),(14896,'15490','S','White','D','Fayette','42051','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.071746,-79.421919,0,'2013-07-06 12:44:31',NULL,NULL),(15082,'15752','P','Kent','D','Indiana','42063','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.541631,-79.283176,0,'2013-07-06 12:44:31',NULL,NULL),(35951,'40060','S','Raywick','D','Marion','21155','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.529118,-85.439647,0,'2013-07-06 12:44:32',NULL,NULL),(24387,'27102','P','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.110895,-80.202875,0,'2013-07-06 12:44:31',NULL,NULL),(24154,'26582','S','Mannington','D','Marion','54049','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.527980,-80.344068,0,'2013-07-06 12:44:31',NULL,NULL),(24019,'26366','P','Haywood','D','Harrison','54033','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.281630,-80.342878,0,'2013-07-06 12:44:31',NULL,NULL),(23883,'26164','S','Ravenswood','D','Jackson','54035','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.952720,-81.756120,0,'2013-07-06 12:44:31',NULL,NULL),(62342,'74056','S','Herd','N','Osage','40113','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.823412,-96.367170,0,'2013-07-06 12:44:33',NULL,NULL),(41863,'47355','S','Spartanburg','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.049570,-84.940519,0,'2013-07-06 12:44:32',NULL,NULL),(39456,'44706','S','Dueber','N','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.771402,-81.413102,0,'2013-07-06 12:44:32',NULL,NULL),(7274,'06524','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.412767,-72.992792,0,'2013-07-06 12:44:30',NULL,NULL),(9843,'10116','P','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.814261,-73.952564,0,'2013-07-06 12:44:30',NULL,NULL),(4770,'03859','P','Newton Junction','D','Rockingham','33015','New Hampshire','NH','33','4160','603','Eastern',-5.0,'Y',42.867214,-71.065993,0,'2013-07-06 12:44:30',NULL,NULL),(78287,'97875','S','Stanfield','D','Umatilla','41059','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',45.780672,-119.217409,0,'2013-07-06 12:44:34',NULL,NULL),(68779,'82327','S','Hanna','D','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.878504,-106.556303,0,'2013-07-06 12:44:34',NULL,NULL),(3002,'01073','S','Southampton','D','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.225636,-72.721743,0,'2013-07-06 12:44:30',NULL,NULL),(20447,'21010','S','Gunpowder','D','Harford','24025','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.404700,-76.288320,0,'2013-07-06 12:44:31',NULL,NULL),(40385,'45660','S','Peebles','D','Adams','39001','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',38.957037,-83.402685,0,'2013-07-06 12:44:32',NULL,NULL),(59581,'70896','P','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.367670,-91.036680,0,'2013-07-06 12:44:33',NULL,NULL),(64803,'77023','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.722464,-95.322941,0,'2013-07-06 12:44:34',NULL,NULL),(66382,'78623','S','Fischer','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.998616,-98.295262,0,'2013-07-06 12:44:34',NULL,NULL),(72898,'90020','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.068259,-118.310430,0,'2013-07-06 12:44:34',NULL,NULL),(72552,'89195','U','Las Vegas Brm','N','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.205334,-115.223749,0,'2013-07-06 12:44:34',NULL,NULL),(55829,'64152','S','Parkville','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.218160,-94.730700,0,'2013-07-06 12:44:33',NULL,NULL),(13992,'14511','P','Mumford','D','Monroe','36055','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.991585,-77.860852,0,'2013-07-06 12:44:31',NULL,NULL),(13538,'13827','S','Foster','N','Tioga','36107','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.094560,-76.249860,0,'2013-07-06 12:44:31',NULL,NULL),(13229,'13637','S','Le Ray','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.090947,-75.804665,0,'2013-07-06 12:44:30',NULL,NULL),(12403,'12930','S','Dickinson Ctr','A','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.779444,-74.498056,0,'2013-07-06 12:44:30',NULL,NULL),(8969,'08817','S','Edison','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.514670,-74.395296,0,'2013-07-06 12:44:30',NULL,NULL),(2914,'01002','S','South Amherst','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.376860,-72.469140,0,'2013-07-06 12:44:30',NULL,NULL),(48101,'55343','S','Minnetonka','A','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.923136,-93.438889,0,'2013-07-06 12:44:33',NULL,NULL),(51010,'58704','S','Minot','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.232500,-101.295833,0,'2013-07-06 12:44:33',NULL,NULL),(69825,'84078','S','Dry Fork','N','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.474320,-109.570104,0,'2013-07-06 12:44:34',NULL,NULL),(74145,'92254','S','North Shore','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.553183,-116.050757,0,'2013-07-06 12:44:34',NULL,NULL),(50746,'58401','S','Spiritwood Lake','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.910219,-98.706119,0,'2013-07-06 12:44:33',NULL,NULL),(20809,'21562','S','Westernport','D','Allegany','24001','Maryland','MD','24','1900','301/240/227','Eastern',-5.0,'Y',39.446389,-78.972500,0,'2013-07-06 12:44:31',NULL,NULL),(22975,'24731','S','Kegley','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.413077,-81.140557,0,'2013-07-06 12:44:31',NULL,NULL),(71170,'86040','P','Greenehaven','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.913751,-111.467162,0,'2013-07-06 12:44:34',NULL,NULL),(22125,'23438','S','Suffolk','D','Suffolk City','51800','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.563256,-76.717225,0,'2013-07-06 12:44:31',NULL,NULL),(23763,'25962','S','Rainelle','D','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.968083,-80.768018,0,'2013-07-06 12:44:31',NULL,NULL),(16499,'17260','S','Shirleysburg','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.321076,-77.848669,0,'2013-07-06 12:44:31',NULL,NULL),(12354,'12885','S','Warrensburg','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.500656,-73.787701,0,'2013-07-06 12:44:30',NULL,NULL),(38592,'43822','S','Frazeysburg','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.120570,-82.127628,0,'2013-07-06 12:44:32',NULL,NULL),(37086,'41339','S','Elkatawa','A','Breathitt','21025','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.537944,-83.388665,0,'2013-07-06 12:44:32',NULL,NULL),(37048,'41274','S','Wittensville','D','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.874106,-82.813925,0,'2013-07-06 12:44:32',NULL,NULL),(35101,'39207','P','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.306196,-90.198595,0,'2013-07-06 12:44:32',NULL,NULL),(10193,'10303','S','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.629027,-74.162595,0,'2013-07-06 12:44:30',NULL,NULL),(49931,'57325','S','Ola','N','Brule','46015','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.806473,-99.327811,0,'2013-07-06 12:44:33',NULL,NULL),(40294,'45440','S','Sugarcreek Township','A','Montgomery','39113','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.670431,-84.122239,0,'2013-07-06 12:44:32',NULL,NULL),(18970,'19518','S','Kulptown','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.323056,-75.755000,0,'2013-07-06 12:44:31',NULL,NULL),(20070,'20678','S','Prnc Frederck','A','Calvert','24009','Maryland','MD','24','8840','410/443/667','Eastern',-5.0,'Y',38.531530,-76.586745,0,'2013-07-06 12:44:31',NULL,NULL),(27270,'29939','P','Scotia','D','Hampton','45049','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',32.681996,-81.245041,0,'2013-07-06 12:44:31',NULL,NULL),(29991,'33109','S','Miami Beach','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.796586,-80.286950,0,'2013-07-06 12:44:32',NULL,NULL),(35609,'39601','S','Heucks','N','Lincoln','28085','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.584180,-90.406620,0,'2013-07-06 12:44:32',NULL,NULL),(34615,'38751','S','Marie','N','Sunflower','28133','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.452442,-90.645728,0,'2013-07-06 12:44:32',NULL,NULL),(9890,'10128','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.779563,-73.949559,0,'2013-07-06 12:44:30',NULL,NULL),(30752,'33563','S','Plant City','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',28.014481,-82.136482,0,'2013-07-06 12:44:32',NULL,NULL),(72417,'89049','S','Warm Springs','N','Nye','32023','Nevada','NV','32','4120','775','Pacific',-8.0,'Y',38.064715,-117.227674,0,'2013-07-06 12:44:34',NULL,NULL),(60041,'71343','S','Walters','N','Catahoula','22025','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.651441,-91.826706,0,'2013-07-06 12:44:33',NULL,NULL),(59727,'71109','S','Shreveport','D','Caddo','22017','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.465400,-93.814020,0,'2013-07-06 12:44:33',NULL,NULL),(54879,'63060','S','Lonedell','D','Franklin','29071','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.300532,-90.830331,0,'2013-07-06 12:44:33',NULL,NULL),(18528,'19107','S','Wm Penn Anx W','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.948927,-75.158663,0,'2013-07-06 12:44:31',NULL,NULL),(16334,'17126','U','State Dept of Education','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.265390,-76.880316,0,'2013-07-06 12:44:31',NULL,NULL),(25275,'28128','S','Cottonville','N','Stanly','37167','North Carolina','NC','37','0000','704/980','Eastern',-5.0,'Y',35.237400,-80.166240,0,'2013-07-06 12:44:31',NULL,NULL),(9479,'10010','S','Nyc','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.742272,-73.987907,0,'2013-07-06 12:44:30',NULL,NULL),(78422,'98047','S','Auburn','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.307500,-122.227222,0,'2013-07-06 12:44:34',NULL,NULL),(77231,'96515','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(63690,'75862','S','Kittrell','N','Trinity','48455','Texas','TX','48','0000','936','Central',-6.0,'Y',30.945900,-95.355420,0,'2013-07-06 12:44:34',NULL,NULL),(63017,'75172','S','Wilmer','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.596587,-96.681089,0,'2013-07-06 12:44:33',NULL,NULL),(59228,'70427','S','Bogalusa','D','Washington','22117','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.772216,-89.862599,0,'2013-07-06 12:44:33',NULL,NULL),(45552,'51466','S','Wall Lake','D','Sac','19161','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.271327,-95.090519,0,'2013-07-06 12:44:32',NULL,NULL),(37674,'42211','S','Roaring Spring','N','Trigg','21221','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.798060,-87.834840,0,'2013-07-06 12:44:32',NULL,NULL),(3919,'02459','S','Newton Ctr','N','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.308823,-71.191835,0,'2013-07-06 12:44:30',NULL,NULL),(9075,'09009','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(11611,'12093','S','East Jefferson','N','Schoharie','36095','New York','NY','36','0160','607','Eastern',-5.0,'Y',42.493692,-74.604434,0,'2013-07-06 12:44:30',NULL,NULL),(17736,'18301','S','E Stroudsburg','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.024022,-75.185712,0,'2013-07-06 12:44:31',NULL,NULL),(27617,'30307','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.769788,-84.328046,0,'2013-07-06 12:44:31',NULL,NULL),(42522,'47854','S','Highland','N','Vermillion','18165','Indiana','IN','18','8320','765','Eastern',-5.0,'Y',39.763883,-87.410160,0,'2013-07-06 12:44:32',NULL,NULL),(42659,'47952','S','Cates','A','Fountain','18045','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.017300,-87.285120,0,'2013-07-06 12:44:32',NULL,NULL),(43470,'48556','U','Flint','D','Genesee','26049','Michigan','MI','26','2640','810','Eastern',-5.0,'Y',43.064861,-83.626394,0,'2013-07-06 12:44:32',NULL,NULL),(460,'00662','S','Villa Pesquera','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(67860,'80826','U','Limon Correctional Fac','N','Lincoln','08073','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.263889,-103.692415,0,'2013-07-06 12:44:34',NULL,NULL),(54660,'62933','S','Energy','D','Williamson','17199','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.774589,-89.022459,0,'2013-07-06 12:44:33',NULL,NULL),(53232,'61639','U','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.709663,-89.566400,0,'2013-07-06 12:44:33',NULL,NULL),(25395,'28275','P','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.226870,-80.842931,0,'2013-07-06 12:44:31',NULL,NULL),(35842,'39776','S','Sparta','N','Chickasaw','28017','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.794434,-89.053443,0,'2013-07-06 12:44:32',NULL,NULL),(23217,'25079','S','Falling Rock','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.475124,-81.388946,0,'2013-07-06 12:44:31',NULL,NULL),(79792,'99352','S','Hanford Works','N','Benton','53005','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.280602,-119.291215,0,'2013-07-06 12:44:34',NULL,NULL),(67284,'80006','P','Arvada','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.844402,-105.078510,0,'2013-07-06 12:44:34',NULL,NULL),(66102,'78409','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.811342,-97.516007,0,'2013-07-06 12:44:34',NULL,NULL),(61967,'73179','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.425455,-97.641765,0,'2013-07-06 12:44:33',NULL,NULL),(30907,'33706','S','Treasure Island','A','Pinellas','12103','Florida','FL','12','8280','727','Eastern',-5.0,'Y',27.741340,-82.748341,0,'2013-07-06 12:44:32',NULL,NULL),(3730,'02153','P','Tufts University','A','Middlesex','25017','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.419023,-71.109862,0,'2013-07-06 12:44:30',NULL,NULL),(27689,'30337','S','College Park','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.644256,-84.467351,0,'2013-07-06 12:44:31',NULL,NULL),(23337,'25247','P','Hartford City','A','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.000627,-81.978560,0,'2013-07-06 12:44:31',NULL,NULL),(41358,'46792','S','Plum Tree','N','Huntington','18069','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',40.685126,-85.422972,0,'2013-07-06 12:44:32',NULL,NULL),(47550,'54829','S','Cumberland','D','Barron','55005','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.535961,-92.018076,0,'2013-07-06 12:44:32',NULL,NULL),(48945,'56167','S','Round Lake','D','Nobles','27105','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.538215,-95.465928,0,'2013-07-06 12:44:33',NULL,NULL),(18504,'19099','U','Philadelphia NDC','N','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953075,-75.161034,0,'2013-07-06 12:44:31',NULL,NULL),(78038,'97437','S','Elmira','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.093311,-123.382288,0,'2013-07-06 12:44:34',NULL,NULL),(77270,'96604','M','FPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(74741,'93043','U','Port Hueneme','A','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.162390,-119.201182,0,'2013-07-06 12:44:34',NULL,NULL),(62229,'73944','S','Hardesty','D','Texas','40139','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.588448,-101.163603,0,'2013-07-06 12:44:33',NULL,NULL),(19025,'19533','S','Dauberville','A','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.440626,-75.974641,0,'2013-07-06 12:44:31',NULL,NULL),(29144,'32330','P','Greensboro','D','Gadsden','12039','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.571884,-84.743962,0,'2013-07-06 12:44:32',NULL,NULL),(22609,'24215','P','Andover','D','Wise','51195','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',36.993827,-82.535934,0,'2013-07-06 12:44:31',NULL,NULL),(42172,'47527','S','Harbison','N','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(53482,'61949','P','Redmon','D','Edgar','17045','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.641755,-87.862916,0,'2013-07-06 12:44:33',NULL,NULL),(53538,'62033','S','Gillespie','D','Macoupin','17117','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.107340,-89.842080,0,'2013-07-06 12:44:33',NULL,NULL),(55606,'63951','S','Lowndes','D','Wayne','29223','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.134500,-90.251288,0,'2013-07-06 12:44:33',NULL,NULL),(26576,'29216','U','SC Dept Of Motor Vehicles','N','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.997822,-81.036511,0,'2013-07-06 12:44:31',NULL,NULL),(77992,'97403','S','Emu U of Or','N','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.037363,-123.052143,0,'2013-07-06 12:44:34',NULL,NULL),(64765,'76945','S','Silver','A','Coke','48081','Texas','TX','48','0000','325','Central',-6.0,'Y',31.896228,-100.482117,0,'2013-07-06 12:44:34',NULL,NULL),(32051,'35255','P','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.493514,-86.810296,0,'2013-07-06 12:44:32',NULL,NULL),(75534,'94205','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.476582,-121.442713,0,'2013-07-06 12:44:34',NULL,NULL),(70310,'84603','P','Provo','D','Utah','49049','Utah','UT','49','6520','801/385','Mountain',-7.0,'Y',40.225947,-111.699351,0,'2013-07-06 12:44:34',NULL,NULL),(58692,'68926','S','Beaver City','D','Furnas','31065','Nebraska','NE','31','0000','308','Central',-6.0,'Y',40.138817,-99.826440,0,'2013-07-06 12:44:33',NULL,NULL),(55272,'63464','S','Plevna','D','Knox','29103','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.998754,-92.118935,0,'2013-07-06 12:44:33',NULL,NULL),(50840,'58481','S','Eckelson','A','Barnes','38003','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.935970,-98.333360,0,'2013-07-06 12:44:33',NULL,NULL),(49990,'57367','P','Pickstown','D','Charles Mix','46023','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.067064,-98.533498,0,'2013-07-06 12:44:33',NULL,NULL),(736,'00690','S','Hacienda Asturias','N','Aguadilla','72005','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.493160,-67.096972,0,'2013-07-06 12:44:30',NULL,NULL),(26999,'29631','S','Clemson','D','Pickens','45077','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.685349,-82.816921,0,'2013-07-06 12:44:31',NULL,NULL),(9749,'10101','P','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.766708,-73.990523,0,'2013-07-06 12:44:30',NULL,NULL),(17010,'17740','S','Larrys Creek','N','Lycoming','42081','Pennsylvania','PA','42','9140','570','Eastern',-5.0,'Y',41.200306,-77.271326,0,'2013-07-06 12:44:31',NULL,NULL),(2547,'00959','S','Parq Flamingo','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(3265,'01463','S','Pepperell','D','Middlesex','25017','Massachusetts','MA','25','4560','978/351','Eastern',-5.0,'Y',42.667500,-71.599440,0,'2013-07-06 12:44:30',NULL,NULL),(65033,'77327','S','Midline','N','Liberty','48291','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.338040,-95.023620,0,'2013-07-06 12:44:34',NULL,NULL),(50978,'58639','S','Haynes','A','Adams','38001','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.035840,-102.570120,0,'2013-07-06 12:44:33',NULL,NULL),(47685,'54963','S','Eureka','A','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.044243,-88.759053,0,'2013-07-06 12:44:33',NULL,NULL),(13001,'13411','S','S Edmeston','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.624636,-75.330038,0,'2013-07-06 12:44:30',NULL,NULL),(28875,'32119','S','S Daytona Bch','A','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.139694,-81.012938,0,'2013-07-06 12:44:32',NULL,NULL),(28794,'32055','S','Lake City','D','Columbia','12023','Florida','FL','12','0000','386','Eastern',-5.0,'Y',30.184011,-82.634774,0,'2013-07-06 12:44:32',NULL,NULL),(20904,'21716','S','Knoxville','N','Frederick','24021','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.314478,-77.622428,0,'2013-07-06 12:44:31',NULL,NULL),(24393,'27104','S','Winston Salem','D','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.096281,-80.322652,0,'2013-07-06 12:44:31',NULL,NULL),(59084,'70121','S','New Orleans','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.964212,-90.156847,0,'2013-07-06 12:44:33',NULL,NULL),(28239,'31051','P','Lilly','D','Dooly','13093','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.148599,-83.877382,0,'2013-07-06 12:44:31',NULL,NULL),(25516,'28386','S','Shannon','D','Robeson','37155','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',34.904009,-79.166196,0,'2013-07-06 12:44:31',NULL,NULL),(23905,'26206','S','Boggs','A','Webster','54101','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.442060,-80.530200,0,'2013-07-06 12:44:31',NULL,NULL),(23491,'25515','S','Gallipolis Ferry','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.699313,-82.120471,0,'2013-07-06 12:44:31',NULL,NULL),(45898,'52310','S','Monticello','D','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.239992,-91.189303,0,'2013-07-06 12:44:32',NULL,NULL),(8355,'08049','S','Magnolia','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.852844,-75.038730,0,'2013-07-06 12:44:30',NULL,NULL),(20534,'21102','S','Millers','A','Carroll','24013','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.643550,-76.696400,0,'2013-07-06 12:44:31',NULL,NULL),(21600,'22848','P','Pleasant Vly','A','Rockingham','51165','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.384318,-78.900024,0,'2013-07-06 12:44:31',NULL,NULL),(24351,'27042','S','Pine Hall','D','Stokes','37169','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.348959,-80.058870,0,'2013-07-06 12:44:31',NULL,NULL),(25006,'27873','P','Saratoga','D','Wilson','37195','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.655080,-77.770318,0,'2013-07-06 12:44:31',NULL,NULL),(11188,'11735','S','East Farmingdale','N','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.725297,-73.444737,0,'2013-07-06 12:44:30',NULL,NULL),(35630,'39633','S','Darrington','N','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.312918,-90.982432,0,'2013-07-06 12:44:32',NULL,NULL),(14569,'15216','S','Dormont','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(6140,'05464','S','Jeffersonville','D','Lamoille','50015','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.663827,-72.783702,0,'2013-07-06 12:44:30',NULL,NULL),(15426,'16367','U','Warren','D','Warren','42123','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.846440,-79.146417,0,'2013-07-06 12:44:31',NULL,NULL),(76240,'95389','S','Yosemite','N','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.581703,-119.658918,0,'2013-07-06 12:44:34',NULL,NULL),(54756,'62984','S','Old Shawneetown','N','Gallatin','17059','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.715092,-88.188836,0,'2013-07-06 12:44:33',NULL,NULL),(43302,'48346','S','Clarkston','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.722381,-83.418152,0,'2013-07-06 12:44:32',NULL,NULL),(38125,'43113','S','Thatcher','N','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.594775,-82.936458,0,'2013-07-06 12:44:32',NULL,NULL),(28655,'31774','S','Ocilla','D','Irwin','13155','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',31.595052,-83.252522,0,'2013-07-06 12:44:32',NULL,NULL),(24519,'27284','S','Matthewstown','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.116290,-80.092145,0,'2013-07-06 12:44:31',NULL,NULL),(36848,'41076','S','Cold Sprgs-Highland Hts','A','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.020220,-84.440160,0,'2013-07-06 12:44:32',NULL,NULL),(78215,'97759','S','Black Butte Ranch','N','Deschutes','41017','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',44.323931,-121.575944,0,'2013-07-06 12:44:34',NULL,NULL),(74658,'92843','S','Garden Grove','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.767061,-117.929000,0,'2013-07-06 12:44:34',NULL,NULL),(71055,'85751','P','Fort Lowell','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.248543,-110.834322,0,'2013-07-06 12:44:34',NULL,NULL),(34395,'38621','S','Crenshaw','D','Panola','28107','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.504355,-90.192058,0,'2013-07-06 12:44:32',NULL,NULL),(28383,'31304','P','Crescent','D','McIntosh','13191','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.499626,-81.373103,0,'2013-07-06 12:44:32',NULL,NULL),(6890,'06144','P','Hartford','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.790732,-72.669992,0,'2013-07-06 12:44:30',NULL,NULL),(22439,'24018','S','Cave Spring','A','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.226453,-80.026824,0,'2013-07-06 12:44:31',NULL,NULL),(5206,'04457','S','Chester','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.363403,-68.503490,0,'2013-07-06 12:44:30',NULL,NULL),(41804,'47331','S','Alpine','N','Fayette','18041','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.644820,-85.157520,0,'2013-07-06 12:44:32',NULL,NULL),(47007,'54302','S','Green Bay','D','Brown','55009','Wisconsin','WI','55','3080','920','Central',-6.0,'Y',44.505133,-87.971774,0,'2013-07-06 12:44:32',NULL,NULL),(47329,'54562','S','Three Lakes','D','Oneida','55085','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.805375,-89.123651,0,'2013-07-06 12:44:32',NULL,NULL),(48352,'55484','U','Excel Energy','N','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.970317,-93.280682,0,'2013-07-06 12:44:33',NULL,NULL),(54001,'62445','S','Montrose','D','Effingham','17049','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.148880,-88.320381,0,'2013-07-06 12:44:33',NULL,NULL),(54397,'62821','S','Epworth','N','White','17193','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.066220,-88.138320,0,'2013-07-06 12:44:33',NULL,NULL),(59936,'71294','P','West Monroe','D','Ouachita','22073','Louisiana','LA','22','5200','318','Central',-6.0,'Y',32.511082,-92.182026,0,'2013-07-06 12:44:33',NULL,NULL),(66536,'78725','S','Hornsby Bend','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.234974,-97.597560,0,'2013-07-06 12:44:34',NULL,NULL),(68453,'81228','S','Twin Lakes','A','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.045472,-106.262136,0,'2013-07-06 12:44:34',NULL,NULL),(69216,'83401','S','Bone','N','Bonneville','16019','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.526640,-111.806460,0,'2013-07-06 12:44:34',NULL,NULL),(67312,'80023','S','Broomfield','D','Broomfield','08014','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.953501,-105.036717,0,'2013-07-06 12:44:34',NULL,NULL),(65119,'77376','P','Votaw','D','Hardin','48199','Texas','TX','48','0840','936','Central',-6.0,'Y',30.436867,-94.675073,0,'2013-07-06 12:44:34',NULL,NULL),(59681,'71068','S','Lawhon','N','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.316980,-93.299756,0,'2013-07-06 12:44:33',NULL,NULL),(52529,'60920','P','Campus','D','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.024026,-88.306610,0,'2013-07-06 12:44:33',NULL,NULL),(51838,'60067','S','Palatine','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.112431,-88.051211,0,'2013-07-06 12:44:33',NULL,NULL),(49940,'57334','S','Ethan','D','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.546469,-97.982906,0,'2013-07-06 12:44:33',NULL,NULL),(8702,'08360','S','East Vineland','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.480900,-75.010192,0,'2013-07-06 12:44:30',NULL,NULL),(30172,'33174','S','Olympia Heights','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.762543,-80.353593,0,'2013-07-06 12:44:32',NULL,NULL),(28117,'30810','S','Gibson','D','Glascock','13125','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.235312,-82.597815,0,'2013-07-06 12:44:31',NULL,NULL),(5119,'04364','S','Winthrop','D','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.307060,-69.972922,0,'2013-07-06 12:44:30',NULL,NULL),(15044,'15710','P','Alverda','D','Indiana','42063','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.629375,-78.858260,0,'2013-07-06 12:44:31',NULL,NULL),(46844,'54017','S','Stanton','N','Saint Croix','55109','Wisconsin','WI','55','5120','715','Central',-6.0,'Y',45.130920,-92.521560,0,'2013-07-06 12:44:32',NULL,NULL),(49562,'56716','S','Crookston','D','Polk','27119','Minnesota','MN','27','2985','218','Central',-6.0,'Y',47.774782,-96.608300,0,'2013-07-06 12:44:33',NULL,NULL),(13221,'13634','S','Perch River','N','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.006160,-76.071070,0,'2013-07-06 12:44:30',NULL,NULL),(68316,'81102','U','Alamosa','D','Alamosa','08003','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.471930,-105.861118,0,'2013-07-06 12:44:34',NULL,NULL),(67661,'80481','S','Ward','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',40.095849,-105.475897,0,'2013-07-06 12:44:34',NULL,NULL),(51665,'59913','P','Coram','D','Flathead','30029','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.436737,-114.050697,0,'2013-07-06 12:44:33',NULL,NULL),(12343,'12878','S','Stony Creek','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.426602,-73.962388,0,'2013-07-06 12:44:30',NULL,NULL),(16267,'17090','S','Shermans Dale','D','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.341440,-77.177825,0,'2013-07-06 12:44:31',NULL,NULL),(42708,'48001','S','Clay','A','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',42.638460,-82.582740,0,'2013-07-06 12:44:32',NULL,NULL),(50135,'57532','S','Lindsey','N','Stanley','46117','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.388787,-100.468252,0,'2013-07-06 12:44:33',NULL,NULL),(51281,'59114','U','K O A','N','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.641786,-108.398787,0,'2013-07-06 12:44:33',NULL,NULL),(12809,'13252','U','National Grid','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.048582,-76.156564,0,'2013-07-06 12:44:30',NULL,NULL),(75282,'93715','P','Fresno','D','Fresno','06019','California','CA','06','2840','559','Pacific',-8.0,'Y',36.733038,-119.784751,0,'2013-07-06 12:44:34',NULL,NULL),(74304,'92378','P','Rimforest','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.210300,-117.241852,0,'2013-07-06 12:44:34',NULL,NULL),(67086,'79697','U','Abilene','D','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.432945,-99.747844,0,'2013-07-06 12:44:34',NULL,NULL),(61635,'72840','S','Hunt','A','Johnson','05071','Arkansas','AR','05','0000','479','Central',-6.0,'Y',35.440758,-93.662707,0,'2013-07-06 12:44:33',NULL,NULL),(36412,'40524','P','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.990125,-84.533081,0,'2013-07-06 12:44:32',NULL,NULL),(5495,'04756','S','Madawaska','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',47.341339,-68.333061,0,'2013-07-06 12:44:30',NULL,NULL),(19021,'19530','S','Grimville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.533780,-75.789540,0,'2013-07-06 12:44:31',NULL,NULL),(30554,'33411','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.715568,-80.217416,0,'2013-07-06 12:44:32',NULL,NULL),(23781,'25981','S','Marfrance','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.055556,-80.691389,0,'2013-07-06 12:44:31',NULL,NULL),(38340,'43438','P','Kelleys Is','A','Erie','39043','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.603835,-82.686144,0,'2013-07-06 12:44:32',NULL,NULL),(48640,'55814','P','Dlth Fed Pris','A','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',46.841316,-92.216319,0,'2013-07-06 12:44:33',NULL,NULL),(80088,'99740','P','Ft Yukon','N','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.435007,-145.825007,0,'2013-07-06 12:44:34',NULL,NULL),(60105,'71362','S','Plaucheville','D','Avoyelles','22009','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.920973,-91.990157,0,'2013-07-06 12:44:33',NULL,NULL),(55794,'64127','S','Kansas City','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.092263,-94.537745,0,'2013-07-06 12:44:33',NULL,NULL),(50772,'58423','S','Chaseley','D','Wells','38103','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.458186,-99.839456,0,'2013-07-06 12:44:33',NULL,NULL),(15726,'16877','S','Warriors Mark','D','Huntingdon','42061','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.735071,-78.085504,0,'2013-07-06 12:44:31',NULL,NULL),(39735,'45068','S','Lytle','N','Warren','39165','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.520020,-84.073920,0,'2013-07-06 12:44:32',NULL,NULL),(40362,'45638','S','Hanging Rock','A','Lawrence','39087','Ohio','OH','39','3400','740','Eastern',-5.0,'Y',38.524095,-82.664084,0,'2013-07-06 12:44:32',NULL,NULL),(847,'00698','S','Haciendas Florida','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(78752,'98293','P','Startup','D','Snohomish','53061','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',47.871806,-121.746553,0,'2013-07-06 12:44:34',NULL,NULL),(66207,'78550','S','Arroyo','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',26.194287,-97.686999,0,'2013-07-06 12:44:34',NULL,NULL),(61984,'73196','U','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.460523,-97.398837,0,'2013-07-06 12:44:33',NULL,NULL),(60515,'71667','S','Glendale','N','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.939645,-91.844739,0,'2013-07-06 12:44:33',NULL,NULL),(11003,'11553','S','Uniondale','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.703352,-73.590714,0,'2013-07-06 12:44:30',NULL,NULL),(10741,'11357','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.783792,-73.812287,0,'2013-07-06 12:44:30',NULL,NULL),(9190,'09383','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(21803,'23085','S','Kingqueen Court House','N','King and Queen','51097','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.728500,-76.845215,0,'2013-07-06 12:44:31',NULL,NULL),(25729,'28547','S','Naval Hospital','N','Onslow','37133','North Carolina','NC','37','3605','910','Eastern',-5.0,'Y',34.704321,-77.349467,0,'2013-07-06 12:44:31',NULL,NULL),(41627,'47130','S','Cementville','N','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.300223,-85.733457,0,'2013-07-06 12:44:32',NULL,NULL),(54071,'62501','S','Oakley','A','Macon','17115','Illinois','IL','17','2040','217','Central',-6.0,'Y',39.984413,-88.818350,0,'2013-07-06 12:44:33',NULL,NULL),(7979,'07711','S','Loch Arbour','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.235381,-74.005003,0,'2013-07-06 12:44:30',NULL,NULL),(54837,'63034','S','Florissant','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.835444,-90.289954,0,'2013-07-06 12:44:33',NULL,NULL),(51643,'59867','S','Saltese','D','Mineral','30061','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.409754,-115.507715,0,'2013-07-06 12:44:33',NULL,NULL),(50857,'58496','S','Goldwin','N','Stutsman','38093','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.141743,-99.300422,0,'2013-07-06 12:44:33',NULL,NULL),(34762,'38862','S','Padenville','N','Lee','28081','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.197376,-88.663986,0,'2013-07-06 12:44:32',NULL,NULL),(27436,'30115','S','Canton','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.207461,-84.401820,0,'2013-07-06 12:44:31',NULL,NULL),(12983,'13406','S','Fairfield','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.139808,-74.969563,0,'2013-07-06 12:44:30',NULL,NULL),(22173,'23465','U','Virginia Beach','D','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.797995,-76.176483,0,'2013-07-06 12:44:31',NULL,NULL),(827,'00693','S','Villa del Rosario','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(6804,'06109','S','HTFD','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.702514,-72.667027,0,'2013-07-06 12:44:30',NULL,NULL),(38558,'43762','S','New Concord','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.019934,-81.751659,0,'2013-07-06 12:44:32',NULL,NULL),(44528,'49959','P','Ramsay','D','Gogebic','26053','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.478413,-89.991743,0,'2013-07-06 12:44:32',NULL,NULL),(48675,'55921','S','Freeburg','N','Houston','27055','Minnesota','MN','27','3870','507','Central',-6.0,'Y',43.632279,-91.501791,0,'2013-07-06 12:44:33',NULL,NULL),(50703,'58365','S','Armourdale','N','Towner','38095','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.857949,-99.129655,0,'2013-07-06 12:44:33',NULL,NULL),(11968,'12460','S','Oak Hill','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.411793,-74.148999,0,'2013-07-06 12:44:30',NULL,NULL),(22860,'24549','S','Dry Fork','D','Pittsylvania','51143','Virginia','VA','51','1950','434','Eastern',-5.0,'Y',36.743265,-79.462510,0,'2013-07-06 12:44:31',NULL,NULL),(37981,'42732','S','E View','N','Hardin','21093','Kentucky','KY','21','0000','270','Eastern',-5.0,'Y',37.606912,-86.114062,0,'2013-07-06 12:44:32',NULL,NULL),(39472,'44718','S','Canton','D','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.851462,-81.443104,0,'2013-07-06 12:44:32',NULL,NULL),(48386,'55574','P','Maple Plain','D','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.994478,-93.710794,0,'2013-07-06 12:44:33',NULL,NULL),(65070,'77346','S','Kingwood','A','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.033333,-95.250000,0,'2013-07-06 12:44:34',NULL,NULL),(46654,'53704','S','Madison','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.117217,-89.335082,0,'2013-07-06 12:44:32',NULL,NULL),(18031,'18651','S','Larksville','A','Luzerne','42079','Pennsylvania','PA','42','7560','570','Eastern',-5.0,'Y',41.245620,-75.961740,0,'2013-07-06 12:44:31',NULL,NULL),(17746,'18322','S','Brodheadsvlle','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.954238,-75.359905,0,'2013-07-06 12:44:31',NULL,NULL),(4539,'03445','S','Nelson','N','Cheshire','33005','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',42.995925,-72.191513,0,'2013-07-06 12:44:30',NULL,NULL),(34001,'38119','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.085796,-89.848658,0,'2013-07-06 12:44:32',NULL,NULL),(32020,'35236','P','Hoover','A','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.356611,-86.817395,0,'2013-07-06 12:44:32',NULL,NULL),(29474,'32723','U','Deland','D','Volusia','12127','Florida','FL','12','2020','386','Eastern',-5.0,'Y',29.009964,-81.308768,0,'2013-07-06 12:44:32',NULL,NULL),(17253,'17841','S','Crossgrove','N','Mifflin','42087','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.708320,-77.363700,0,'2013-07-06 12:44:31',NULL,NULL),(18398,'19052','P','Lenni','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.894353,-75.444607,0,'2013-07-06 12:44:31',NULL,NULL),(75212,'93633','P','Kings Canyon Natl Park','A','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.918180,-119.033820,0,'2013-07-06 12:44:34',NULL,NULL),(74771,'93107','P','UCSB Student Dorm Boxes','N','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.421154,-119.858056,0,'2013-07-06 12:44:34',NULL,NULL),(59649,'71045','S','Jamestown','D','Bienville','22013','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.378476,-93.183299,0,'2013-07-06 12:44:33',NULL,NULL),(57244,'66524','S','Overbrook','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.773836,-95.558779,0,'2013-07-06 12:44:33',NULL,NULL),(38788,'44057','S','Madison-on-the-Lake','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.770970,-81.058712,0,'2013-07-06 12:44:32',NULL,NULL),(38345,'43440','S','Lakeside-Marblehead','N','Ottawa','39123','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.531235,-82.759429,0,'2013-07-06 12:44:32',NULL,NULL),(24698,'27429','P','Greensboro','D','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.093454,-79.812745,0,'2013-07-06 12:44:31',NULL,NULL),(1685,'00777','S','Jard del Valenciano','N','Juncos','72077','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.229082,-65.918423,0,'2013-07-06 12:44:30',NULL,NULL),(69907,'84107','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.658460,-111.881914,0,'2013-07-06 12:44:34',NULL,NULL),(68129,'80960','P','Colo Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.810217,-104.816961,0,'2013-07-06 12:44:34',NULL,NULL),(63668,'75853','S','Montalba','D','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.941780,-95.763120,0,'2013-07-06 12:44:34',NULL,NULL),(51478,'59542','S','Turner','D','Blaine','30005','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.876686,-108.374004,0,'2013-07-06 12:44:33',NULL,NULL),(45064,'50515','S','Ayrshire','D','Palo Alto','19147','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.037511,-94.835824,0,'2013-07-06 12:44:32',NULL,NULL),(44228,'49651','S','Moorestown','A','Missaukee','26113','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.386560,-85.145400,0,'2013-07-06 12:44:32',NULL,NULL),(13492,'13803','S','Galatia','N','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.465051,-76.017549,0,'2013-07-06 12:44:31',NULL,NULL),(30438,'33330','S','Southwest Ranches','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.059626,-80.322613,0,'2013-07-06 12:44:32',NULL,NULL),(11938,'12434','S','Grand Gorge','D','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.343615,-74.476158,0,'2013-07-06 12:44:30',NULL,NULL),(38311,'43358','S','West Mansfield','D','Logan','39091','Ohio','OH','39','0000','937','Eastern',-5.0,'Y',40.416420,-83.486218,0,'2013-07-06 12:44:32',NULL,NULL),(75351,'93912','P','Salinas','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.738648,-121.681590,0,'2013-07-06 12:44:34',NULL,NULL),(74566,'92683','S','Westminster','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.750865,-117.989463,0,'2013-07-06 12:44:34',NULL,NULL),(71587,'87315','S','Trechado','N','Cibola','35006','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',34.763663,-108.783817,0,'2013-07-06 12:44:34',NULL,NULL),(54668,'62938','S','Rosebud','N','Pope','17151','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.357533,-88.488804,0,'2013-07-06 12:44:33',NULL,NULL),(6532,'05830','S','Holland','N','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',45.001164,-72.103249,0,'2013-07-06 12:44:30',NULL,NULL),(2240,'00926','S','Urb La Alameda','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(27242,'29925','P','Hilton Head','A','Beaufort','45013','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',32.164766,-80.754408,0,'2013-07-06 12:44:31',NULL,NULL),(22048,'23314','S','Carrollton','D','Isle of Wight','51093','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.940479,-76.526487,0,'2013-07-06 12:44:31',NULL,NULL),(25441,'28311','S','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.128576,-78.897217,0,'2013-07-06 12:44:31',NULL,NULL),(39045,'44188','U','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.400504,-81.826781,0,'2013-07-06 12:44:32',NULL,NULL),(39313,'44515','S','Austintown','A','Mahoning','39099','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',41.099874,-80.751233,0,'2013-07-06 12:44:32',NULL,NULL),(41391,'46804','S','Ft Wayne','N','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.055452,-85.243032,0,'2013-07-06 12:44:32',NULL,NULL),(53436,'61866','S','Rantoul','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.309571,-88.149445,0,'2013-07-06 12:44:33',NULL,NULL),(13732,'14102','S','Marilla','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.836658,-78.553177,0,'2013-07-06 12:44:31',NULL,NULL),(76863,'95970','S','Codora','N','Colusa','06011','California','CA','06','0000','530','Pacific',-8.0,'Y',39.424920,-122.096280,0,'2013-07-06 12:44:34',NULL,NULL),(50931,'58569','S','Porcupine','N','Grant','38037','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',46.200991,-101.235194,0,'2013-07-06 12:44:33',NULL,NULL),(47538,'54816','P','Mason','A','Bayfield','55007','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.503624,-91.077200,0,'2013-07-06 12:44:32',NULL,NULL),(45415,'51052','S','Owego','N','Woodbury','19193','Iowa','IA','19','7720','712','Central',-6.0,'Y',42.304178,-96.275313,0,'2013-07-06 12:44:32',NULL,NULL),(23163,'25015','S','Shrewsbury','A','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.233939,-81.528074,0,'2013-07-06 12:44:31',NULL,NULL),(10056,'10176','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752612,-73.981704,0,'2013-07-06 12:44:30',NULL,NULL),(36352,'40442','S','Kings Mtn','A','Lincoln','21137','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.366098,-84.701152,0,'2013-07-06 12:44:32',NULL,NULL),(36087,'40218','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.192865,-85.653204,0,'2013-07-06 12:44:32',NULL,NULL),(28350,'31196','U','Atlanta NDC','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.807894,-84.474929,0,'2013-07-06 12:44:32',NULL,NULL),(77389,'96767','P','Lahaina','D','Maui','15009','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',20.911065,-156.684798,0,'2013-07-06 12:44:34',NULL,NULL),(59531,'70809','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.408590,-91.086924,0,'2013-07-06 12:44:33',NULL,NULL),(51446,'59474','S','Shelby','D','Toole','30101','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.509590,-111.830333,0,'2013-07-06 12:44:33',NULL,NULL),(7113,'06376','P','Point O Woods','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.294573,-72.259086,0,'2013-07-06 12:44:30',NULL,NULL),(5627,'04942','S','Wellington','A','Somerset','23025','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.011460,-69.569760,0,'2013-07-06 12:44:30',NULL,NULL),(37121,'41425','S','Ezel','D','Morgan','21175','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.913003,-83.392966,0,'2013-07-06 12:44:32',NULL,NULL),(7260,'06517','S','New Haven','A','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.349805,-72.913991,0,'2013-07-06 12:44:30',NULL,NULL),(32577,'36118','U','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.406982,-86.247828,0,'2013-07-06 12:44:32',NULL,NULL),(32319,'35763','S','Big Cove','A','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.610433,-86.463316,0,'2013-07-06 12:44:32',NULL,NULL),(66456,'78653','S','Webberville','A','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.318960,-97.536960,0,'2013-07-06 12:44:34',NULL,NULL),(65953,'78266','S','San Antonio','D','Comal','48091','Texas','TX','48','7240','830','Central',-6.0,'Y',29.630375,-98.305497,0,'2013-07-06 12:44:34',NULL,NULL),(65310,'77503','S','Golden Acres','N','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.691128,-95.162613,0,'2013-07-06 12:44:34',NULL,NULL),(62734,'74826','S','Asher','D','Pottawatomie','40125','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',34.966755,-96.860038,0,'2013-07-06 12:44:33',NULL,NULL),(60216,'71423','S','Dry Prong','D','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.618500,-92.570400,0,'2013-07-06 12:44:33',NULL,NULL),(59175,'70345','S','Cut Off','D','Lafourche','22057','Louisiana','LA','22','3350','985','Central',-6.0,'Y',29.514897,-90.335946,0,'2013-07-06 12:44:33',NULL,NULL),(36973,'41179','S','Heselton','N','Lewis','21135','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.594885,-83.318316,0,'2013-07-06 12:44:32',NULL,NULL),(13378,'13738','P','Blodgett Mls','A','Cortland','36023','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.565864,-76.125222,0,'2013-07-06 12:44:31',NULL,NULL),(9269,'09610','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(7321,'06702','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.555258,-73.039627,0,'2013-07-06 12:44:30',NULL,NULL),(65889,'78231','S','Shavano Park','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588400,-98.549910,0,'2013-07-06 12:44:34',NULL,NULL),(51210,'59043','P','Lame Deer','D','Rosebud','30087','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.577559,-106.530746,0,'2013-07-06 12:44:33',NULL,NULL),(43932,'49277','S','Rives Jct','A','Jackson','26075','Michigan','MI','26','3520','517','Eastern',-5.0,'Y',42.388466,-84.466414,0,'2013-07-06 12:44:32',NULL,NULL),(42528,'47859','S','Howard','N','Parke','18121','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.910754,-87.172148,0,'2013-07-06 12:44:32',NULL,NULL),(4923,'04077','P','South Casco','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.871729,-70.514006,0,'2013-07-06 12:44:30',NULL,NULL),(12547,'13041','S','Clay','D','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.171563,-76.131940,0,'2013-07-06 12:44:30',NULL,NULL),(32530,'36102','P','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.395238,-86.326456,0,'2013-07-06 12:44:32',NULL,NULL),(11538,'12046','S','Coeymans Hollow','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.498420,-73.912260,0,'2013-07-06 12:44:30',NULL,NULL),(11506,'12025','S','Union Mills','N','Fulton','36035','New York','NY','36','0000','518','Eastern',-5.0,'Y',43.057254,-74.198122,0,'2013-07-06 12:44:30',NULL,NULL),(20676,'21233','S','Baltimore','D','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.293438,-76.605554,0,'2013-07-06 12:44:31',NULL,NULL),(8797,'08602','P','Trenton','D','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.218043,-74.576246,0,'2013-07-06 12:44:30',NULL,NULL),(76773,'95934','S','Crescent Mls','A','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',40.088345,-120.891835,0,'2013-07-06 12:44:34',NULL,NULL),(74276,'92354','S','North Loma Linda','N','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.052344,-117.250346,0,'2013-07-06 12:44:34',NULL,NULL),(37817,'42419','P','Henderson','D','Henderson','21101','Kentucky','KY','21','2440','270','Central',-6.0,'Y',37.837363,-87.591550,0,'2013-07-06 12:44:32',NULL,NULL),(37287,'41612','S','Bypro','D','Floyd','21071','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.305683,-82.701844,0,'2013-07-06 12:44:32',NULL,NULL),(23606,'25703','S','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.424158,-82.422731,0,'2013-07-06 12:44:31',NULL,NULL),(23598,'25688','P','North Matewan','D','Mingo','54059','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.625847,-82.149628,0,'2013-07-06 12:44:31',NULL,NULL),(16490,'17257','S','Mainsville','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(38171,'43156','P','Laurelville','A','Pickaway','39129','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.555824,-82.775783,0,'2013-07-06 12:44:32',NULL,NULL),(38772,'44050','S','Lagrange','D','Lorain','39093','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.245712,-82.130046,0,'2013-07-06 12:44:32',NULL,NULL),(38826,'44081','S','North Perry','N','Lake','39085','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.765861,-81.146611,0,'2013-07-06 12:44:32',NULL,NULL),(53634,'62201','S','E Saint Louis','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.628113,-90.138442,0,'2013-07-06 12:44:33',NULL,NULL),(62535,'74429','S','New Tulsa','N','Wagoner','40145','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.956129,-95.658301,0,'2013-07-06 12:44:33',NULL,NULL),(67757,'80623','P','Gilcrest','D','Weld','08123','Colorado','CO','08','3060','970','Mountain',-7.0,'Y',40.284835,-104.776641,0,'2013-07-06 12:44:34',NULL,NULL),(68764,'82301','S','Creston','A','Carbon','56007','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.788870,-107.199009,0,'2013-07-06 12:44:34',NULL,NULL),(2977,'01054','S','North Leverett','N','Franklin','25011','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.474743,-72.482496,0,'2013-07-06 12:44:30',NULL,NULL),(8716,'08406','S','Ventnor Heights','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.342361,-74.481532,0,'2013-07-06 12:44:30',NULL,NULL),(26244,'28901','S','Andrews','D','Cherokee','37039','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.189476,-83.804291,0,'2013-07-06 12:44:31',NULL,NULL),(14574,'15217','S','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.428877,-79.923209,0,'2013-07-06 12:44:31',NULL,NULL),(13821,'14216','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.947283,-78.859475,0,'2013-07-06 12:44:31',NULL,NULL),(71051,'85749','S','Ft Lowell','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.270941,-110.767721,0,'2013-07-06 12:44:34',NULL,NULL),(58494,'68763','S','Grattan','N','Holt','31089','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.456401,-98.648879,0,'2013-07-06 12:44:33',NULL,NULL),(54375,'62811','P','Bellmont','D','Wabash','17185','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.383961,-87.911522,0,'2013-07-06 12:44:33',NULL,NULL),(21553,'22749','S','Woodville','D','Rappahannock','51157','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.646126,-78.171784,0,'2013-07-06 12:44:31',NULL,NULL),(40263,'45432','S','Beaver Creek','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.741263,-84.068879,0,'2013-07-06 12:44:32',NULL,NULL),(49241,'56472','S','Jenkins','A','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.615920,-94.281420,0,'2013-07-06 12:44:33',NULL,NULL),(54306,'62711','S','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.763320,-89.725579,0,'2013-07-06 12:44:33',NULL,NULL),(79045,'98408','S','Tacoma','D','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.210649,-122.452887,0,'2013-07-06 12:44:34',NULL,NULL),(74545,'92672','S','San Clemente','D','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.436148,-117.623087,0,'2013-07-06 12:44:34',NULL,NULL),(69032,'83217','S','Lund','N','Caribou','16029','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.742325,-111.887397,0,'2013-07-06 12:44:34',NULL,NULL),(66849,'79121','S','Amarillo','D','Randall','48381','Texas','TX','48','0320','806','Central',-6.0,'Y',35.175263,-101.931175,0,'2013-07-06 12:44:34',NULL,NULL),(65881,'78226','S','Kelly USA','N','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.396389,-98.546677,0,'2013-07-06 12:44:34',NULL,NULL),(35014,'39150','S','Grand Gulf','N','Claiborne','28021','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.957545,-90.981874,0,'2013-07-06 12:44:32',NULL,NULL),(20916,'21733','S','Fairplay','D','Washington','24043','Maryland','MD','24','3180','301/240/227','Eastern',-5.0,'Y',39.548142,-77.762386,0,'2013-07-06 12:44:31',NULL,NULL),(52621,'61038','S','Bonus','N','Boone','17007','Illinois','IL','17','6880','815/779','Central',-6.0,'Y',42.249088,-88.739224,0,'2013-07-06 12:44:33',NULL,NULL),(47736,'55011','S','Oak Grove','A','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.348975,-93.246677,0,'2013-07-06 12:44:33',NULL,NULL),(46988,'54232','P','Saint Nazianz','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.004420,-87.924250,0,'2013-07-06 12:44:32',NULL,NULL),(32073,'35285','U','Bham','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.541978,-86.803608,0,'2013-07-06 12:44:32',NULL,NULL),(26977,'29615','S','Greenville','D','Greenville','45045','South Carolina','SC','45','3160','864','Eastern',-5.0,'Y',34.868789,-82.312139,0,'2013-07-06 12:44:31',NULL,NULL),(68324,'81120','S','Los Pinas','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(67568,'80299','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.746870,-104.993120,0,'2013-07-06 12:44:34',NULL,NULL),(61772,'73062','S','Mountain View','D','Kiowa','40075','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',35.101135,-98.753299,0,'2013-07-06 12:44:33',NULL,NULL),(59223,'70422','S','Amite','D','Tangipahoa','22105','Louisiana','LA','22','0000','985','Central',-6.0,'Y',30.725646,-90.507562,0,'2013-07-06 12:44:33',NULL,NULL),(54294,'62705','P','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.799861,-89.647762,0,'2013-07-06 12:44:33',NULL,NULL),(49011,'56257','S','Marietta','D','Lac Qui Parle','27073','Minnesota','MN','27','0000','320','Central',-6.0,'Y',44.931601,-96.397949,0,'2013-07-06 12:44:33',NULL,NULL),(44525,'49953','S','Ontonagon','D','Ontonagon','26131','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.855606,-89.315817,0,'2013-07-06 12:44:32',NULL,NULL),(1098,'00725','S','Urb La Meseta','N','Caguas','72025','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.236227,-66.041340,0,'2013-07-06 12:44:30',NULL,NULL),(26035,'28681','S','Little River','N','Alexander','37003','North Carolina','NC','37','3290','828','Eastern',-5.0,'Y',35.872440,-81.213360,0,'2013-07-06 12:44:31',NULL,NULL),(26794,'29456','S','Ladson','D','Berkeley','45015','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',33.016638,-80.105646,0,'2013-07-06 12:44:31',NULL,NULL),(9774,'10105','S','Ny City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.762235,-73.975175,0,'2013-07-06 12:44:30',NULL,NULL),(76910,'95991','S','Tierra Buena','N','Sutter','06101','California','CA','06','9340','530','Pacific',-8.0,'Y',38.995493,-121.621973,0,'2013-07-06 12:44:34',NULL,NULL),(74479,'92609','P','Lake Forest','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.624010,-117.690845,0,'2013-07-06 12:44:34',NULL,NULL),(23544,'25617','S','Davin','D','Logan','54045','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.716804,-81.785101,0,'2013-07-06 12:44:31',NULL,NULL),(46542,'53405','S','Elmwood Park','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.716356,-87.823291,0,'2013-07-06 12:44:32',NULL,NULL),(49436,'56634','S','Leon','N','Clearwater','27029','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.831879,-95.319135,0,'2013-07-06 12:44:33',NULL,NULL),(60333,'71463','S','Bond','N','Allen','22003','Louisiana','LA','22','0000','318','Central',-6.0,'Y',30.817482,-92.658202,0,'2013-07-06 12:44:33',NULL,NULL),(60777,'72019','S','Benton','D','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.563690,-92.586207,0,'2013-07-06 12:44:33',NULL,NULL),(14571,'15216','S','Pitt','N','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.402514,-80.038122,0,'2013-07-06 12:44:31',NULL,NULL),(75378,'93940','S','Monterey','D','Monterey','06053','California','CA','06','7120','831','Pacific',-8.0,'Y',36.587700,-121.849200,0,'2013-07-06 12:44:34',NULL,NULL),(64094,'76163','P','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.664187,-97.374241,0,'2013-07-06 12:44:34',NULL,NULL),(58746,'68955','S','Juniata','D','Adams','31001','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.587480,-98.516760,0,'2013-07-06 12:44:33',NULL,NULL),(48839,'56054','S','La Fayette','N','Nicollet','27103','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.445577,-94.394643,0,'2013-07-06 12:44:33',NULL,NULL),(38940,'44124','S','Lyn May','N','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.511136,-81.463234,0,'2013-07-06 12:44:32',NULL,NULL),(18373,'19046','S','Foxcroft Sq','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.101066,-75.111030,0,'2013-07-06 12:44:31',NULL,NULL),(5112,'04358','S','China','A','Kennebec','23011','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.398705,-69.582961,0,'2013-07-06 12:44:30',NULL,NULL),(29570,'32816','U','UCF','N','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.606119,-81.204801,0,'2013-07-06 12:44:32',NULL,NULL),(28038,'30648','S','Lexington','D','Oglethorpe','13221','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.872180,-83.078293,0,'2013-07-06 12:44:31',NULL,NULL),(24671,'27408','S','Guilford Courthouse National','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.106359,-79.817365,0,'2013-07-06 12:44:31',NULL,NULL),(65476,'77640','S','Pear Ridge','N','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',29.895365,-93.955602,0,'2013-07-06 12:44:34',NULL,NULL),(62775,'74868','S','Seminole','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',35.234976,-96.675123,0,'2013-07-06 12:44:33',NULL,NULL),(55040,'63140','S','Berkeley','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.737643,-90.323138,0,'2013-07-06 12:44:33',NULL,NULL),(33903,'38046','P','La Grange','D','Fayette','47047','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.065576,-89.329117,0,'2013-07-06 12:44:32',NULL,NULL),(78590,'98178','S','Skyway','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.492862,-122.249902,0,'2013-07-06 12:44:34',NULL,NULL),(75684,'94556','S','Moraga','D','Contra Costa','06013','California','CA','06','5775','925','Pacific',-8.0,'Y',37.843041,-122.125739,0,'2013-07-06 12:44:34',NULL,NULL),(62771,'74865','S','Hickory','A','Pontotoc','40123','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.632966,-96.841801,0,'2013-07-06 12:44:33',NULL,NULL),(54266,'62681','S','Pleasant View','A','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.121657,-90.560514,0,'2013-07-06 12:44:33',NULL,NULL),(54279,'62691','S','Little Indian','A','Cass','17017','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.948431,-90.202632,0,'2013-07-06 12:44:33',NULL,NULL),(56987,'66202','S','Shawnee MSN','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.022936,-94.668789,0,'2013-07-06 12:44:33',NULL,NULL),(10334,'10550','S','Mt Vernon','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.907698,-73.838538,0,'2013-07-06 12:44:30',NULL,NULL),(74827,'93230','S','Hanford','D','Kings','06031','California','CA','06','0000','559','Pacific',-8.0,'Y',36.329023,-119.641214,0,'2013-07-06 12:44:34',NULL,NULL),(74415,'92548','S','Homeland','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.759282,-117.102312,0,'2013-07-06 12:44:34',NULL,NULL),(67287,'80011','S','Aurora','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.741650,-104.791421,0,'2013-07-06 12:44:34',NULL,NULL),(66997,'79503','S','Avoca','D','Jones','48253','Texas','TX','48','0000','325','Central',-6.0,'Y',32.892087,-99.694537,0,'2013-07-06 12:44:34',NULL,NULL),(58520,'68781','S','Tilden','D','Madison','31119','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.043913,-97.828926,0,'2013-07-06 12:44:33',NULL,NULL),(58411,'68642','S','Cornlea','A','Platte','31141','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.688712,-97.489112,0,'2013-07-06 12:44:33',NULL,NULL),(10261,'10503','P','Ardsley Hdsn','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.025309,-73.868081,0,'2013-07-06 12:44:30',NULL,NULL),(13199,'13624','S','Frontenac','A','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.239325,-76.080450,0,'2013-07-06 12:44:30',NULL,NULL),(1012,'00717','S','Vista Alegre','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(27139,'29816','P','Bath','D','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.500799,-81.867579,0,'2013-07-06 12:44:31',NULL,NULL),(22777,'24445','S','Hot Springs','D','Bath','51017','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.971900,-79.871580,0,'2013-07-06 12:44:31',NULL,NULL),(22411,'23968','S','Skipwith','D','Mecklenburg','51117','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.730287,-78.528256,0,'2013-07-06 12:44:31',NULL,NULL),(21743,'23032','S','Church View','D','Middlesex','51119','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.670809,-76.678860,0,'2013-07-06 12:44:31',NULL,NULL),(72653,'89431','S','Greenbrae','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.548066,-119.734394,0,'2013-07-06 12:44:34',NULL,NULL),(72183,'88351','S','Tinnie','D','Lincoln','35027','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.274217,-105.137756,0,'2013-07-06 12:44:34',NULL,NULL),(66110,'78413','S','Corpus Christi','D','Nueces','48355','Texas','TX','48','1880','361','Central',-6.0,'Y',27.687141,-97.400470,0,'2013-07-06 12:44:34',NULL,NULL),(37600,'42127','S','Cave City','D','Barren','21009','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.121088,-85.916475,0,'2013-07-06 12:44:32',NULL,NULL),(37202,'41522','S','Cedarville','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.299540,-82.355160,0,'2013-07-06 12:44:32',NULL,NULL),(36118,'40222','S','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.258163,-85.606834,0,'2013-07-06 12:44:32',NULL,NULL),(35173,'39271','U','JXN','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289835,-90.180840,0,'2013-07-06 12:44:32',NULL,NULL),(5848,'05091','S','Woodstock','D','Windsor','50027','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.627860,-72.537180,0,'2013-07-06 12:44:30',NULL,NULL),(15848,'16938','S','Oregon Hill','N','Tioga','42117','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.544444,-77.285833,0,'2013-07-06 12:44:31',NULL,NULL),(32361,'35894','U','Huntsville','D','Madison','01089','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.646701,-86.754498,0,'2013-07-06 12:44:32',NULL,NULL),(28438,'31405','S','Garden City','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.043073,-81.132144,0,'2013-07-06 12:44:32',NULL,NULL),(12197,'12780','S','Sparrowbush','A','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.432778,-74.720524,0,'2013-07-06 12:44:30',NULL,NULL),(12520,'13031','S','Howlett Hill','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',43.044375,-76.289134,0,'2013-07-06 12:44:30',NULL,NULL),(24549,'27292','S','Reedy Creek','N','Davidson','37057','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',35.825700,-80.277660,0,'2013-07-06 12:44:31',NULL,NULL),(23301,'25185','U','Mt Olive Crrctnl Complex','N','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.240034,-81.233861,0,'2013-07-06 12:44:31',NULL,NULL),(47120,'54451','S','Little Black','N','Taylor','55119','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.170280,-90.370740,0,'2013-07-06 12:44:32',NULL,NULL),(54960,'63120','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.690003,-90.261886,0,'2013-07-06 12:44:33',NULL,NULL),(55845,'64163','S','Ferrelview','A','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.336740,-94.744720,0,'2013-07-06 12:44:33',NULL,NULL),(61,'00612','S','Alt de Juncos','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(59153,'70185','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.952425,-90.104368,0,'2013-07-06 12:44:33',NULL,NULL),(54494,'62864','S','Idlewood','N','Jefferson','17081','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.317640,-88.909298,0,'2013-07-06 12:44:33',NULL,NULL),(49656,'57001','S','Alcester','D','Union','46127','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.021930,-96.622613,0,'2013-07-06 12:44:33',NULL,NULL),(46764,'53942','P','Lime Ridge','D','Sauk','55111','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.468808,-90.161213,0,'2013-07-06 12:44:32',NULL,NULL),(41043,'46402','S','Gary','D','Lake','18089','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.601011,-87.336284,0,'2013-07-06 12:44:32',NULL,NULL),(16444,'17236','S','Kasiesville','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.813420,-77.957460,0,'2013-07-06 12:44:31',NULL,NULL),(3786,'02206','U','Boston','D','Suffolk','25025','Massachusetts','MA','25','1120','617/857','Eastern',-5.0,'Y',42.344450,-71.042166,0,'2013-07-06 12:44:30',NULL,NULL),(34347,'38581','S','Bone Cave','A','Warren','47177','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.730840,-85.650180,0,'2013-07-06 12:44:32',NULL,NULL),(19971,'20593','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.867378,-77.012246,0,'2013-07-06 12:44:31',NULL,NULL),(29046,'32236','P','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.306054,-81.729965,0,'2013-07-06 12:44:32',NULL,NULL),(25438,'28309','P','Fayetteville','D','Cumberland','37051','North Carolina','NC','37','2560','910','Eastern',-5.0,'Y',35.071877,-78.899070,0,'2013-07-06 12:44:31',NULL,NULL),(38956,'44127','S','Cleveland','D','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.472030,-81.650481,0,'2013-07-06 12:44:32',NULL,NULL),(71935,'87901','S','Truth Consq','A','Sierra','35051','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',33.129932,-107.251636,0,'2013-07-06 12:44:34',NULL,NULL),(66913,'79323','S','Denver City','D','Yoakum','48501','Texas','TX','48','0000','806','Central',-6.0,'Y',32.967963,-102.828509,0,'2013-07-06 12:44:34',NULL,NULL),(64213,'76263','S','Rosston','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.479695,-97.457070,0,'2013-07-06 12:44:34',NULL,NULL),(54926,'63104','S','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.613662,-90.214255,0,'2013-07-06 12:44:33',NULL,NULL),(15713,'16864','S','Orviston','D','Centre','42027','Pennsylvania','PA','42','8050','570','Eastern',-5.0,'Y',41.085359,-77.656066,0,'2013-07-06 12:44:31',NULL,NULL),(13568,'13841','S','Smithvle Flts','A','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.397440,-75.836580,0,'2013-07-06 12:44:31',NULL,NULL),(30418,'33326','S','P E Chevron Cs','N','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.111456,-80.372148,0,'2013-07-06 12:44:32',NULL,NULL),(17676,'18105','P','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.568941,-75.536719,0,'2013-07-06 12:44:31',NULL,NULL),(28366,'31213','U','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.821378,-83.647007,0,'2013-07-06 12:44:32',NULL,NULL),(79228,'98550','S','Chenois Creek','N','Grays Harbor','53027','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.982662,-123.892233,0,'2013-07-06 12:44:34',NULL,NULL),(75847,'94927','P','Cotati','A','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.347442,-122.698375,0,'2013-07-06 12:44:34',NULL,NULL),(75771,'94659','U','Blue Cross','N','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.809982,-122.269201,0,'2013-07-06 12:44:34',NULL,NULL),(64113,'76180','S','Richland Hills','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.861011,-97.216130,0,'2013-07-06 12:44:34',NULL,NULL),(25955,'28657','S','Senia','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(29612,'32855','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.509349,-81.390108,0,'2013-07-06 12:44:32',NULL,NULL),(36660,'41008','S','Prestonville','N','Carroll','21041','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.677051,-85.169553,0,'2013-07-06 12:44:32',NULL,NULL),(35387,'39455','S','Wells Town','N','Lamar','28073','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.059960,-89.502180,0,'2013-07-06 12:44:32',NULL,NULL),(34929,'38967','S','Eskridge','N','Montgomery','28097','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.483835,-89.732137,0,'2013-07-06 12:44:32',NULL,NULL),(7722,'07199','U','Newark','D','Essex','34013','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.727070,-74.172065,0,'2013-07-06 12:44:30',NULL,NULL),(78923,'98366','S','Forest City','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.498978,-122.620101,0,'2013-07-06 12:44:34',NULL,NULL),(75425,'94028','S','Portola Valley','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.379860,-122.208569,0,'2013-07-06 12:44:34',NULL,NULL),(72242,'88518','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.811002,-106.421428,0,'2013-07-06 12:44:34',NULL,NULL),(70685,'85253','S','Paradise Valley','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.546000,-111.968280,0,'2013-07-06 12:44:34',NULL,NULL),(53484,'61951','S','Kirksville','A','Moultrie','17139','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.597396,-88.609239,0,'2013-07-06 12:44:33',NULL,NULL),(51802,'60047','S','Kildeer','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.195624,-88.058166,0,'2013-07-06 12:44:33',NULL,NULL),(26900,'29576','S','Garden City','N','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.586770,-79.009455,0,'2013-07-06 12:44:31',NULL,NULL),(21436,'22567','S','Unionville','D','Orange','51137','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.228135,-77.912975,0,'2013-07-06 12:44:31',NULL,NULL),(2416,'00953','S','Jard de la Fuente','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(27344,'30046','S','Lawrenceville','D','Gwinnett','13135','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.940690,-83.960938,0,'2013-07-06 12:44:31',NULL,NULL),(75530,'94177','U','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.791933,-122.398410,0,'2013-07-06 12:44:34',NULL,NULL),(71176,'86042','P','Sichomovi','N','Navajo','04017','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',35.967439,-110.430862,0,'2013-07-06 12:44:34',NULL,NULL),(61850,'73120','S','okc','N','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.584064,-97.574272,0,'2013-07-06 12:44:33',NULL,NULL),(59094,'70125','S','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.952064,-90.105984,0,'2013-07-06 12:44:33',NULL,NULL),(18904,'19477','S','Spring House','D','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.210833,-75.278611,0,'2013-07-06 12:44:31',NULL,NULL),(19121,'19608','S','Gouglersville','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.312265,-76.023139,0,'2013-07-06 12:44:31',NULL,NULL),(19242,'19934','S','Camden','A','Kent','10001','Delaware','DE','10','2190','302','Eastern',-5.0,'Y',39.095340,-75.570300,0,'2013-07-06 12:44:31',NULL,NULL),(13986,'14505','S','Marion','D','Wayne','36117','New York','NY','36','6840','315','Eastern',-5.0,'Y',43.152501,-77.172245,0,'2013-07-06 12:44:31',NULL,NULL),(11816,'12234','U','State Office Bldg','N','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.671814,-73.736501,0,'2013-07-06 12:44:30',NULL,NULL),(40722,'46122','S','Danville','D','Hendricks','18063','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.771018,-86.540474,0,'2013-07-06 12:44:32',NULL,NULL),(54820,'63025','S','Allenton','A','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(55832,'64153','S','Kansas City','D','Platte','29165','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.273370,-94.691489,0,'2013-07-06 12:44:33',NULL,NULL),(79214,'98540','P','East Olympia','D','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',46.963393,-122.823764,0,'2013-07-06 12:44:34',NULL,NULL),(69268,'83435','S','Monteview','D','Jefferson','16051','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.872249,-112.543616,0,'2013-07-06 12:44:34',NULL,NULL),(8261,'08008','S','Loveladies','N','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.646800,-74.185860,0,'2013-07-06 12:44:30',NULL,NULL),(11698,'12160','S','Sloansville','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.762660,-74.372274,0,'2013-07-06 12:44:30',NULL,NULL),(5016,'04231','S','E Stoneham','A','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.252980,-70.886744,0,'2013-07-06 12:44:30',NULL,NULL),(13855,'14227','S','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.876735,-78.744457,0,'2013-07-06 12:44:31',NULL,NULL),(21893,'23181','S','West Point','D','King William','51101','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.556161,-76.810679,0,'2013-07-06 12:44:31',NULL,NULL),(21653,'22939','S','Fishersville','D','Augusta','51015','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.087881,-78.966521,0,'2013-07-06 12:44:31',NULL,NULL),(17674,'18103','S','Allentown','D','Lehigh','42077','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.592173,-75.475434,0,'2013-07-06 12:44:31',NULL,NULL),(52719,'61230','S','Albany','D','Whiteside','17195','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.766402,-90.214367,0,'2013-07-06 12:44:33',NULL,NULL),(50709,'58366','S','Rolette','D','Rolette','38079','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.654300,-99.890100,0,'2013-07-06 12:44:33',NULL,NULL),(42757,'48030','S','Hazel Park','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.460506,-83.096906,0,'2013-07-06 12:44:32',NULL,NULL),(68461,'81232','P','Hillside','D','Fremont','08043','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.271880,-105.607460,0,'2013-07-06 12:44:34',NULL,NULL),(66385,'78624','S','Cherry Spring','N','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(53609,'62082','S','Athensville','N','Greene','17061','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.479516,-90.373279,0,'2013-07-06 12:44:33',NULL,NULL),(47424,'54664','S','Viola','D','Richland','55103','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',43.443473,-90.676698,0,'2013-07-06 12:44:32',NULL,NULL),(25350,'28227','S','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.184960,-80.654820,0,'2013-07-06 12:44:31',NULL,NULL),(28971,'32207','S','JAX','N','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.292512,-81.629247,0,'2013-07-06 12:44:32',NULL,NULL),(3837,'02339','S','Hanover','D','Plymouth','25023','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.130281,-70.846944,0,'2013-07-06 12:44:30',NULL,NULL),(68667,'81654','S','Snowmass','D','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.286141,-106.979196,0,'2013-07-06 12:44:34',NULL,NULL),(67996,'80919','S','Rockrimmon','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.928018,-104.848484,0,'2013-07-06 12:44:34',NULL,NULL),(56447,'65279','S','Rocheport','D','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',39.000717,-92.518405,0,'2013-07-06 12:44:33',NULL,NULL),(53854,'62326','S','Colchester','D','McDonough','17109','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.423848,-90.792932,0,'2013-07-06 12:44:33',NULL,NULL),(53183,'61605','S','Peoria','D','Peoria','17143','Illinois','IL','17','6120','309','Central',-6.0,'Y',40.680845,-89.627061,0,'2013-07-06 12:44:33',NULL,NULL),(52370,'60617','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.716207,-87.554349,0,'2013-07-06 12:44:33',NULL,NULL),(13571,'13843','S','Ambierville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.537177,-75.347849,0,'2013-07-06 12:44:31',NULL,NULL),(17597,'18038','S','Danielsville','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.792991,-75.486968,0,'2013-07-06 12:44:31',NULL,NULL),(48031,'55304','S','Andover','D','Anoka','27003','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.254700,-93.240480,0,'2013-07-06 12:44:33',NULL,NULL),(50688,'58351','S','Minnewaukan','D','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.068926,-99.258727,0,'2013-07-06 12:44:33',NULL,NULL),(103,'00612','S','Urb Las Brisas','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(79573,'99021','S','Green Bluff','N','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.794004,-117.294238,0,'2013-07-06 12:44:34',NULL,NULL),(71530,'87124','S','Rio Rancho','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.256600,-106.696560,0,'2013-07-06 12:44:34',NULL,NULL),(70193,'84337','S','Penrose','A','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.676420,-112.267800,0,'2013-07-06 12:44:34',NULL,NULL),(70035,'84132','U','University Medical Ctr','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.765465,-111.840905,0,'2013-07-06 12:44:34',NULL,NULL),(66903,'79258','P','South Plains','D','Floyd','48153','Texas','TX','48','0000','806','Central',-6.0,'Y',34.178649,-101.303770,0,'2013-07-06 12:44:34',NULL,NULL),(3845,'02344','U','Middleborough','A','Plymouth','25023','Massachusetts','MA','25','1200','508/774','Eastern',-5.0,'Y',41.894218,-70.920815,0,'2013-07-06 12:44:30',NULL,NULL),(31962,'35211','S','Wenonah','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.473968,-86.862639,0,'2013-07-06 12:44:32',NULL,NULL),(31621,'34690','S','Tarpon Springs','A','Pasco','12101','Florida','FL','12','8280','727','Eastern',-5.0,'Y',28.191092,-82.728081,0,'2013-07-06 12:44:32',NULL,NULL),(5435,'04681','S','Stonington','D','Hancock','23009','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.182327,-68.672119,0,'2013-07-06 12:44:30',NULL,NULL),(26354,'29070','S','Batesburg-Leesville','A','Lexington','45063','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',33.908554,-81.449991,0,'2013-07-06 12:44:31',NULL,NULL),(50292,'57659','S','Walker','D','Corson','46031','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.907025,-101.090746,0,'2013-07-06 12:44:33',NULL,NULL),(61383,'72530','S','Drasco','D','Cleburne','05023','Arkansas','AR','05','0000','870','Central',-6.0,'Y',35.512977,-92.031354,0,'2013-07-06 12:44:33',NULL,NULL),(46143,'52655','S','Prairie Grove','N','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.826742,-91.165656,0,'2013-07-06 12:44:32',NULL,NULL),(32507,'36072','P','Eufaula','D','Barbour','01005','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.889093,-85.143727,0,'2013-07-06 12:44:32',NULL,NULL),(32665,'36262','S','Fruithurst','D','Cleburne','01029','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.729919,-85.430370,0,'2013-07-06 12:44:32',NULL,NULL),(21407,'22524','P','Mount Holly','D','Westmoreland','51193','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',38.135745,-76.661658,0,'2013-07-06 12:44:31',NULL,NULL),(711,'00687','S','Jard de Montellano','N','Morovis','72101','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.329095,-66.404240,0,'2013-07-06 12:44:30',NULL,NULL),(67334,'80045','S','Aurora','D','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.748262,-104.839178,0,'2013-07-06 12:44:34',NULL,NULL),(55143,'63361','S','Danville','A','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.978952,-91.505241,0,'2013-07-06 12:44:33',NULL,NULL),(5912,'05250','S','Arlington','D','Bennington','50003','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.098780,-73.157580,0,'2013-07-06 12:44:30',NULL,NULL),(18632,'19154','S','Phila','A','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.085444,-74.983544,0,'2013-07-06 12:44:31',NULL,NULL),(19686,'20373','U','Anacostia Anx','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.905980,-76.986540,0,'2013-07-06 12:44:31',NULL,NULL),(20118,'20716','S','Bowie','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.925300,-76.715460,0,'2013-07-06 12:44:31',NULL,NULL),(70684,'85252','P','Scottsdale','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.489653,-111.924556,0,'2013-07-06 12:44:34',NULL,NULL),(69174,'83328','S','Curry','N','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.559620,-114.622560,0,'2013-07-06 12:44:34',NULL,NULL),(67286,'80010','S','Aurora','D','Arapahoe','08005','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.735849,-104.865186,0,'2013-07-06 12:44:34',NULL,NULL),(66796,'79061','S','Mobeetie','D','Wheeler','48483','Texas','TX','48','0000','806','Central',-6.0,'Y',35.535764,-100.441825,0,'2013-07-06 12:44:34',NULL,NULL),(33376,'37210','S','Nashville','D','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.138854,-86.736367,0,'2013-07-06 12:44:32',NULL,NULL),(29403,'32633','P','Evinston','D','Alachua','12001','Florida','FL','12','2900','352','Eastern',-5.0,'Y',29.483793,-82.222855,0,'2013-07-06 12:44:32',NULL,NULL),(27610,'30304','S','ATL','N','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.651549,-84.394247,0,'2013-07-06 12:44:31',NULL,NULL),(25098,'27960','P','Portsmouth','N','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.112320,-75.976220,0,'2013-07-06 12:44:31',NULL,NULL),(23836,'26120','U','Coldwater Creek','A','Wood','54107','West Virginia','WV','54','6020','304/681','Eastern',-5.0,'Y',39.168661,-81.490206,0,'2013-07-06 12:44:31',NULL,NULL),(41402,'46809','S','Fort Wayne','D','Allen','18003','Indiana','IN','18','2760','260','Eastern',-5.0,'Y',41.026644,-85.189643,0,'2013-07-06 12:44:32',NULL,NULL),(42130,'47501','S','Washington','D','Daviess','18027','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.658010,-87.171087,0,'2013-07-06 12:44:32',NULL,NULL),(52836,'61314','S','Buda','D','Bureau','17011','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.325459,-89.680873,0,'2013-07-06 12:44:33',NULL,NULL),(54359,'62801','S','Centralia','D','Marion','17121','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.532120,-89.137020,0,'2013-07-06 12:44:33',NULL,NULL),(62410,'74127','S','Tulsa','D','Tulsa','40143','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',36.153390,-96.026756,0,'2013-07-06 12:44:33',NULL,NULL),(583,'00680','S','Bo Rio Hondo','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(77781,'97124','S','West Union','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.535156,-122.956260,0,'2013-07-06 12:44:34',NULL,NULL),(75898,'94975','P','Petaluma','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.322344,-122.646575,0,'2013-07-06 12:44:34',NULL,NULL),(16337,'17127','U','HBG','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.263282,-76.876977,0,'2013-07-06 12:44:31',NULL,NULL),(36487,'40803','P','Asher','D','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.989628,-83.392726,0,'2013-07-06 12:44:32',NULL,NULL),(34053,'38138','S','MPHS','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.072700,-89.902500,0,'2013-07-06 12:44:32',NULL,NULL),(30440,'33331','S','Davie','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.057117,-80.368319,0,'2013-07-06 12:44:32',NULL,NULL),(28998,'32219','S','Jacksonville','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.410491,-81.807977,0,'2013-07-06 12:44:32',NULL,NULL),(23416,'25336','P','Charleston','D','Kanawha','54039','West Virginia','WV','54','1480','304/681','Eastern',-5.0,'Y',38.350534,-81.628213,0,'2013-07-06 12:44:31',NULL,NULL),(19477,'20146','P','Ashburn','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',39.019050,-77.460991,0,'2013-07-06 12:44:31',NULL,NULL),(18460,'19080','U','Wayne','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.041159,-75.388173,0,'2013-07-06 12:44:31',NULL,NULL),(11253,'11763','S','Medford','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.825920,-72.986100,0,'2013-07-06 12:44:30',NULL,NULL),(46386,'53146','S','New Berlin','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.971531,-88.157905,0,'2013-07-06 12:44:32',NULL,NULL),(1971,'00850','S','Kingshill','D','Saint Croix','78010','Virgin Islands','VI','78','0000','340','Atlantic',-4.0,'N',17.776580,-64.824060,0,'2013-07-06 12:44:30',NULL,NULL),(55561,'63863','S','Malden','D','Dunklin','29069','Missouri','MO','29','0000','573','Central',-6.0,'Y',36.558432,-89.974113,0,'2013-07-06 12:44:33',NULL,NULL),(51927,'60118','S','West Dundee','A','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.110280,-88.296540,0,'2013-07-06 12:44:33',NULL,NULL),(37229,'41539','S','Kimper','D','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.498827,-82.312244,0,'2013-07-06 12:44:32',NULL,NULL),(13765,'14135','P','Sheridan','D','Chautauqua','36013','New York','NY','36','3610','716','Eastern',-5.0,'Y',42.487157,-79.240878,0,'2013-07-06 12:44:31',NULL,NULL),(32578,'36119','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.398077,-86.328482,0,'2013-07-06 12:44:32',NULL,NULL),(22947,'24647','P','Shortt Gap','D','Buchanan','51027','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.158485,-81.873769,0,'2013-07-06 12:44:31',NULL,NULL),(6416,'05739','S','Mount Tabor','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.356120,-73.017600,0,'2013-07-06 12:44:30',NULL,NULL),(24408,'27111','U','Wachovia Bldg Vim','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.098893,-80.243891,0,'2013-07-06 12:44:31',NULL,NULL),(29633,'32887','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.384748,-81.467936,0,'2013-07-06 12:44:32',NULL,NULL),(30500,'33401','S','West Palm Bch','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.705811,-80.064783,0,'2013-07-06 12:44:32',NULL,NULL),(38145,'43140','S','Summerford','A','Madison','39097','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.891060,-83.405340,0,'2013-07-06 12:44:32',NULL,NULL),(58858,'69146','S','Lemoyne','D','Keith','31101','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.337848,-101.877466,0,'2013-07-06 12:44:33',NULL,NULL),(57076,'66215','S','Overland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',38.949180,-94.742460,0,'2013-07-06 12:44:33',NULL,NULL),(10864,'11416','S','Jamaica','A','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.684494,-73.850427,0,'2013-07-06 12:44:30',NULL,NULL),(18393,'19050','S','E Lansdowne','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936540,-75.263580,0,'2013-07-06 12:44:31',NULL,NULL),(44766,'50207','S','Union Mills','N','Mahaska','19123','Iowa','IA','19','0000','641','Central',-6.0,'Y',41.467705,-92.649644,0,'2013-07-06 12:44:32',NULL,NULL),(79799,'99357','S','Royal City','D','Grant','53025','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.912047,-119.569706,0,'2013-07-06 12:44:34',NULL,NULL),(1475,'00745','S','Urb Rio Grande Hls','N','Rio Grande','72119','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.383385,-65.838061,0,'2013-07-06 12:44:30',NULL,NULL),(8672,'08324','S','Thompson Beach','N','Cumberland','34011','New Jersey','NJ','34','8760','856','Eastern',-5.0,'Y',39.249636,-74.994012,0,'2013-07-06 12:44:30',NULL,NULL),(5068,'04285','S','Weld','D','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.707678,-70.453410,0,'2013-07-06 12:44:30',NULL,NULL),(7316,'06699','U','Bridgeport','D','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.191157,-73.138012,0,'2013-07-06 12:44:30',NULL,NULL),(20429,'20914','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.074133,-77.003460,0,'2013-07-06 12:44:31',NULL,NULL),(60888,'72067','S','Higden','D','Cleburne','05023','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.570040,-92.174640,0,'2013-07-06 12:44:33',NULL,NULL),(63740,'75935','S','James','N','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.795080,-94.164180,0,'2013-07-06 12:44:34',NULL,NULL),(79746,'99228','P','Spokane','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.799759,-117.384682,0,'2013-07-06 12:44:34',NULL,NULL),(8334,'08037','S','Hammonton','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.631485,-74.771034,0,'2013-07-06 12:44:30',NULL,NULL),(10723,'11252','S','Brooklyn','D','Kings','36047','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.624546,-74.031281,0,'2013-07-06 12:44:30',NULL,NULL),(33759,'37854','S','Westel','N','Roane','47145','Tennessee','TN','47','0000','865','Eastern',-5.0,'Y',35.862451,-84.679796,0,'2013-07-06 12:44:32',NULL,NULL),(10225,'10461','S','Bronx','D','Bronx','36005','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.844984,-73.843255,0,'2013-07-06 12:44:30',NULL,NULL),(30827,'33622','P','Tampa','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.954520,-82.457101,0,'2013-07-06 12:44:32',NULL,NULL),(5200,'04451','S','Macwahoc Plt','A','Penobscot','23019','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.604763,-68.227102,0,'2013-07-06 12:44:30',NULL,NULL),(24045,'26415','S','Pennsboro','D','Ritchie','54085','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.285557,-80.967156,0,'2013-07-06 12:44:31',NULL,NULL),(16090,'17051','S','Atkinsons Mls','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.497914,-77.743817,0,'2013-07-06 12:44:31',NULL,NULL),(46355,'53102','P','Benet Lake','D','Kenosha','55059','Wisconsin','WI','55','3800','262','Central',-6.0,'Y',42.504370,-88.077260,0,'2013-07-06 12:44:32',NULL,NULL),(48682,'55925','S','New Hartford','N','Winona','27169','Minnesota','MN','27','0000','507','Central',-6.0,'Y',43.917120,-91.394520,0,'2013-07-06 12:44:33',NULL,NULL),(57505,'66952','S','Lebanon','D','Smith','20183','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.813397,-98.555445,0,'2013-07-06 12:44:33',NULL,NULL),(73249,'90704','P','Avalon','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.342834,-118.327634,0,'2013-07-06 12:44:34',NULL,NULL),(76295,'95437','S','Fort Bragg','D','Mendocino','06045','California','CA','06','0000','707','Pacific',-8.0,'Y',39.441739,-123.784270,0,'2013-07-06 12:44:34',NULL,NULL),(78964,'98370','S','Virginia','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.742377,-122.634666,0,'2013-07-06 12:44:34',NULL,NULL),(18261,'19004','S','Cynwyd','N','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.013801,-75.231706,0,'2013-07-06 12:44:31',NULL,NULL),(21628,'22909','U','Charlottesville','D','Albemarle','51003','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',38.043210,-78.474036,0,'2013-07-06 12:44:31',NULL,NULL),(43959,'49310','S','Blanchard','D','Isabella','26073','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.519182,-85.010651,0,'2013-07-06 12:44:32',NULL,NULL),(53383,'61801','S','Urbana','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',40.111668,-88.198416,0,'2013-07-06 12:44:33',NULL,NULL),(62654,'74602','P','Ponca City','D','Kay','40071','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.720461,-97.080194,0,'2013-07-06 12:44:33',NULL,NULL),(13454,'13778','S','Smithville','N','Chenango','36017','New York','NY','36','0000','607','Eastern',-5.0,'Y',42.331969,-75.768267,0,'2013-07-06 12:44:31',NULL,NULL),(11377,'11933','S','Calverton','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.934460,-72.769140,0,'2013-07-06 12:44:30',NULL,NULL),(26079,'28704','S','Arden','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.473046,-82.519301,0,'2013-07-06 12:44:31',NULL,NULL),(6344,'05671','U','State of Vermont','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.341294,-72.758536,0,'2013-07-06 12:44:30',NULL,NULL),(10427,'10802','P','New Rochelle','D','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.913140,-73.779734,0,'2013-07-06 12:44:30',NULL,NULL),(21063,'21918','S','Conowingo','D','Cecil','24015','Maryland','MD','24','9160','410/443/667','Eastern',-5.0,'Y',39.676234,-76.153303,0,'2013-07-06 12:44:31',NULL,NULL),(18444,'19067','S','Yardley','A','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.202400,-74.830980,0,'2013-07-06 12:44:31',NULL,NULL),(9797,'10109','U','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.760712,-73.989366,0,'2013-07-06 12:44:30',NULL,NULL),(4583,'03579','S','Errol','D','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.775308,-71.175804,0,'2013-07-06 12:44:30',NULL,NULL),(60346,'71467','S','Simms','N','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.498140,-92.421420,0,'2013-07-06 12:44:33',NULL,NULL),(78560,'98155','S','Lk Forest Pk','A','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.763130,-122.290150,0,'2013-07-06 12:44:34',NULL,NULL),(73438,'91224','P','Glendale','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.227961,-118.246396,0,'2013-07-06 12:44:34',NULL,NULL),(70117,'84189','U','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.764906,-111.886965,0,'2013-07-06 12:44:34',NULL,NULL),(68694,'82051','S','Lookout','N','Albany','56001','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',41.576111,-105.694722,0,'2013-07-06 12:44:34',NULL,NULL),(33165,'37022','S','Rock Bridge','A','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.514694,-86.324530,0,'2013-07-06 12:44:32',NULL,NULL),(24567,'27306','S','Mount Gilead','D','Montgomery','37123','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.269440,-79.974000,0,'2013-07-06 12:44:31',NULL,NULL),(2334,'00936','P','Caparra','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.385207,-66.063120,0,'2013-07-06 12:44:30',NULL,NULL),(48736,'55964','S','Plainview','D','Wabasha','27157','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.168343,-92.168273,0,'2013-07-06 12:44:33',NULL,NULL),(66777,'79035','S','Black','A','Parmer','48369','Texas','TX','48','0000','806','Central',-6.0,'Y',34.637034,-102.723022,0,'2013-07-06 12:44:34',NULL,NULL),(67485,'80230','S','Denver','D','Denver','08031','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.730904,-104.903794,0,'2013-07-06 12:44:34',NULL,NULL),(68660,'81650','S','Antlers','N','Garfield','08045','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.540153,-107.790633,0,'2013-07-06 12:44:34',NULL,NULL),(73263,'90717','S','Lomita','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.794899,-118.316450,0,'2013-07-06 12:44:34',NULL,NULL),(37490,'42024','S','Barlow','D','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.058897,-89.075654,0,'2013-07-06 12:44:32',NULL,NULL),(2425,'00953','S','Sect Los Rodriguez','N','Toa Alta','72135','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.389298,-66.248096,0,'2013-07-06 12:44:30',NULL,NULL),(5524,'04777','S','Sherman Station','A','Penobscot','23019','Maine','ME','23','0730','207','Eastern',-5.0,'Y',45.896021,-68.492070,0,'2013-07-06 12:44:30',NULL,NULL),(20001,'20608','S','Aquasco','D','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.582892,-76.715193,0,'2013-07-06 12:44:31',NULL,NULL),(21091,'22037','U','Mobil Oil Corp','N','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.853441,-77.300385,0,'2013-07-06 12:44:31',NULL,NULL),(26394,'29105','S','Hibernia','N','Aiken','45003','South Carolina','SC','45','0600','803','Eastern',-5.0,'Y',33.759336,-81.558390,0,'2013-07-06 12:44:31',NULL,NULL),(21453,'22604','P','Winchester','D','Winchester City','51840','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.187153,-78.154627,0,'2013-07-06 12:44:31',NULL,NULL),(45843,'52223','S','Delhi','D','Delaware','19055','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.429786,-91.330245,0,'2013-07-06 12:44:32',NULL,NULL),(69826,'84078','S','Maeser','N','Uintah','49047','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.474320,-109.570104,0,'2013-07-06 12:44:34',NULL,NULL),(75077,'93532','S','Leona Valley','N','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(79328,'98609','S','Carrolls','D','Cowlitz','53015','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.073646,-122.861996,0,'2013-07-06 12:44:34',NULL,NULL),(2485,'00956','S','Urb Los Faroles','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.179246,-66.113423,0,'2013-07-06 12:44:30',NULL,NULL),(22903,'24598','S','Virgilina','D','Halifax','51083','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.604233,-78.765860,0,'2013-07-06 12:44:31',NULL,NULL),(21744,'23035','S','Blakes','A','Mathews','51115','Virginia','VA','51','5720','804','Eastern',-5.0,'Y',37.505520,-76.397220,0,'2013-07-06 12:44:31',NULL,NULL),(39889,'45213','S','Kennedy Heights','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.179149,-84.417894,0,'2013-07-06 12:44:32',NULL,NULL),(43408,'48456','S','Minden','N','Sanilac','26151','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.666281,-82.738842,0,'2013-07-06 12:44:32',NULL,NULL),(53301,'61735','S','De Witt','A','Dewitt','17039','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.185739,-88.787860,0,'2013-07-06 12:44:33',NULL,NULL),(71558,'87196','P','Univ of Nm','A','Bernalillo','35001','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.082837,-106.619087,0,'2013-07-06 12:44:34',NULL,NULL),(74512,'92647','S','Huntingtn Bch','A','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.721030,-118.003329,0,'2013-07-06 12:44:34',NULL,NULL),(7723,'07201','S','Betsytown','N','Union','34039','New Jersey','NJ','34','5640','908','Eastern',-5.0,'Y',40.664256,-74.179890,0,'2013-07-06 12:44:30',NULL,NULL),(13261,'13648','S','Geers Corners','N','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.202180,-75.297060,0,'2013-07-06 12:44:30',NULL,NULL),(50916,'58561','S','Napoleon','D','Logan','38047','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.502292,-99.768821,0,'2013-07-06 12:44:33',NULL,NULL),(52946,'61412','S','Alexis','D','Mercer','17131','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.064856,-90.557525,0,'2013-07-06 12:44:33',NULL,NULL),(53888,'62353','S','Ripley','N','Brown','17009','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.985995,-90.767312,0,'2013-07-06 12:44:33',NULL,NULL),(64615,'76690','S','Walnut Spgs','A','Bosque','48035','Texas','TX','48','0000','254','Central',-6.0,'Y',32.064900,-97.763580,0,'2013-07-06 12:44:34',NULL,NULL),(70358,'84646','P','Moroni','D','Sanpete','49039','Utah','UT','49','0000','435','Mountain',-7.0,'Y',39.526809,-111.585420,0,'2013-07-06 12:44:34',NULL,NULL),(74443,'92583','S','Glmn Hot Spgs','A','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.791618,-116.918647,0,'2013-07-06 12:44:34',NULL,NULL),(76831,'95960','S','North San Juan','D','Nevada','06057','California','CA','06','0000','530','Pacific',-8.0,'Y',39.339635,-121.132146,0,'2013-07-06 12:44:34',NULL,NULL),(14936,'15560','P','Shanksville','D','Somerset','42111','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.018870,-78.904616,0,'2013-07-06 12:44:31',NULL,NULL),(14386,'15042','S','Freedom','D','Beaver','42007','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.678979,-80.223616,0,'2013-07-06 12:44:31',NULL,NULL),(33543,'37389','S','Tullahoma','A','Coffee','47031','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.320179,-86.067451,0,'2013-07-06 12:44:32',NULL,NULL),(11736,'12182','S','Troy','D','Rensselaer','36083','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.775992,-73.660085,0,'2013-07-06 12:44:30',NULL,NULL),(19173,'19733','P','Saint Georges','D','New Castle','10003','Delaware','DE','10','9160','302','Eastern',-5.0,'Y',39.554866,-75.653688,0,'2013-07-06 12:44:31',NULL,NULL),(26593,'29226','U','Columbia','D','Richland','45079','South Carolina','SC','45','1760','803','Eastern',-5.0,'Y',34.031953,-81.104915,0,'2013-07-06 12:44:31',NULL,NULL),(69410,'83628','S','Homedale','D','Owyhee','16073','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.604314,-116.911816,0,'2013-07-06 12:44:34',NULL,NULL),(8090,'07760','S','Sea Bright','A','Monmouth','34025','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',40.368572,-74.000172,0,'2013-07-06 12:44:30',NULL,NULL),(75819,'94850','S','Richmond','D','Contra Costa','06013','California','CA','06','5775','510','Pacific',-8.0,'Y',37.947097,-122.381529,0,'2013-07-06 12:44:34',NULL,NULL),(386,'00662','S','Alt del Mar','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(73768,'91735','U','Wells Fargo Bank','N','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.074913,-118.028045,0,'2013-07-06 12:44:34',NULL,NULL),(69175,'83328','S','Filer','D','Twin Falls','16083','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.559620,-114.622560,0,'2013-07-06 12:44:34',NULL,NULL),(66588,'78748','S','San Leanna','N','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.168174,-97.822906,0,'2013-07-06 12:44:34',NULL,NULL),(51380,'59412','S','Armington','N','Cascade','30013','Montana','MT','30','3040','406','Mountain',-7.0,'Y',47.371142,-110.903119,0,'2013-07-06 12:44:33',NULL,NULL),(35152,'39232','S','Jackson','A','Rankin','28121','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.289828,-90.181404,0,'2013-07-06 12:44:32',NULL,NULL),(34427,'38642','S','Earlygrove','N','Marshall','28093','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.988460,-89.374740,0,'2013-07-06 12:44:32',NULL,NULL),(33948,'38079','S','Tiptonville','D','Lake','47095','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.377752,-89.478666,0,'2013-07-06 12:44:32',NULL,NULL),(13460,'13783','S','Apex','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(23475,'25502','S','Apple Grove','D','Mason','54053','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.663298,-82.129837,0,'2013-07-06 12:44:31',NULL,NULL),(45412,'51050','S','Remsen','D','Plymouth','19149','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.813861,-95.971320,0,'2013-07-06 12:44:32',NULL,NULL),(75427,'94030','S','Millbrae','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.599952,-122.400126,0,'2013-07-06 12:44:34',NULL,NULL),(65958,'78270','P','Wetmore','A','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.588376,-98.473568,0,'2013-07-06 12:44:34',NULL,NULL),(63463,'75684','S','Wright City','N','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.266620,-94.954980,0,'2013-07-06 12:44:33',NULL,NULL),(58334,'68458','S','Virginia','D','Gage','31067','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.231200,-96.520680,0,'2013-07-06 12:44:33',NULL,NULL),(57201,'66427','S','Lillis','N','Marshall','20117','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.705297,-96.415675,0,'2013-07-06 12:44:33',NULL,NULL),(51652,'59873','S','Thompson Fls','A','Sanders','30089','Montana','MT','30','0000','406','Mountain',-7.0,'Y',47.621869,-115.341150,0,'2013-07-06 12:44:33',NULL,NULL),(49173,'56401','S','Brainerd','D','Crow Wing','27035','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.341720,-94.142280,0,'2013-07-06 12:44:33',NULL,NULL),(10203,'10313','P','Staten Island','D','Richmond','36085','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.614826,-74.124364,0,'2013-07-06 12:44:30',NULL,NULL),(36760,'41041','S','Dalesburg','N','Fleming','21069','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.418540,-83.688120,0,'2013-07-06 12:44:32',NULL,NULL),(9599,'10030','S','Ny','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.818115,-73.944054,0,'2013-07-06 12:44:30',NULL,NULL),(56070,'64750','S','Harwood','D','Vernon','29217','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.949580,-94.115700,0,'2013-07-06 12:44:33',NULL,NULL),(54826,'63025','S','Times Beach','N','Saint Louis','29189','Missouri','MO','29','7040','636','Central',-6.0,'Y',38.510003,-90.642759,0,'2013-07-06 12:44:33',NULL,NULL),(21688,'22963','S','Lake Monticello','N','Fluvanna','51065','Virginia','VA','51','1540','434','Eastern',-5.0,'Y',37.915257,-78.322769,0,'2013-07-06 12:44:31',NULL,NULL),(39144,'44281','S','Wadsworth','D','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.029624,-81.733414,0,'2013-07-06 12:44:32',NULL,NULL),(49877,'57262','S','Agency Village','A','Roberts','46109','South Dakota','SD','46','0000','605','Central',-6.0,'Y',45.664922,-97.048055,0,'2013-07-06 12:44:33',NULL,NULL),(58407,'68637','S','Ericson','D','Wheeler','31183','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.799293,-98.662453,0,'2013-07-06 12:44:33',NULL,NULL),(25859,'28629','S','Glendale Spgs','A','Ashe','37009','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.347119,-81.382714,0,'2013-07-06 12:44:31',NULL,NULL),(8996,'08846','S','Middlesex','D','Middlesex','34023','New Jersey','NJ','34','5015','732/848','Eastern',-5.0,'Y',40.574785,-74.498817,0,'2013-07-06 12:44:30',NULL,NULL),(20265,'20784','S','New Carrollton','A','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.953980,-76.896780,0,'2013-07-06 12:44:31',NULL,NULL),(9852,'10119','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.751108,-73.998842,0,'2013-07-06 12:44:30',NULL,NULL),(18991,'19522','S','Rockland','N','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.475833,-75.895000,0,'2013-07-06 12:44:31',NULL,NULL),(18691,'19190','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.953099,-75.166343,0,'2013-07-06 12:44:31',NULL,NULL),(7198,'06478','S','Seymour','A','New Haven','09009','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.426687,-73.133697,0,'2013-07-06 12:44:30',NULL,NULL),(41922,'47381','S','Salomonia','N','Jay','18075','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',40.350997,-84.851952,0,'2013-07-06 12:44:32',NULL,NULL),(42169,'47527','S','Dubois','D','Dubois','18037','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.472743,-86.782697,0,'2013-07-06 12:44:32',NULL,NULL),(42576,'47879','S','Curry','N','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.181484,-87.394063,0,'2013-07-06 12:44:32',NULL,NULL),(44241,'49664','S','Maple City','D','Leelanau','26089','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',44.878854,-85.889433,0,'2013-07-06 12:44:32',NULL,NULL),(47689,'54966','S','Plainfield','D','Waushara','55137','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.214264,-89.498003,0,'2013-07-06 12:44:33',NULL,NULL),(33563,'37412','S','Chattanooga','D','Hamilton','47065','Tennessee','TN','47','1560','423','Eastern',-5.0,'Y',34.997779,-85.233796,0,'2013-07-06 12:44:32',NULL,NULL),(27590,'30289','P','Turin','D','Coweta','13077','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.325102,-84.635050,0,'2013-07-06 12:44:31',NULL,NULL),(19653,'20299','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.918368,-76.990783,0,'2013-07-06 12:44:31',NULL,NULL),(43321,'48360','S','Lake Orion','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.766320,-83.278020,0,'2013-07-06 12:44:32',NULL,NULL),(50251,'57626','S','Usta','N','Meade','46093','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',45.027132,-102.038778,0,'2013-07-06 12:44:33',NULL,NULL),(57589,'67072','S','Latham','D','Butler','20015','Kansas','KS','20','9040','620','Central',-6.0,'Y',37.535765,-96.642723,0,'2013-07-06 12:44:33',NULL,NULL),(64099,'76166','U','Fort Worth','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.783918,-97.347748,0,'2013-07-06 12:44:34',NULL,NULL),(65120,'77377','S','Tomball','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.098706,-95.614258,0,'2013-07-06 12:44:34',NULL,NULL),(71929,'87831','S','Alamillo','N','Socorro','35053','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.233049,-106.913944,0,'2013-07-06 12:44:34',NULL,NULL),(78539,'98136','S','Westwood','N','King','53033','Washington','WA','53','7600','206/564','Pacific',-8.0,'Y',47.535393,-122.386977,0,'2013-07-06 12:44:34',NULL,NULL),(15688,'16837','S','Glen Richey','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.935362,-78.478297,0,'2013-07-06 12:44:31',NULL,NULL),(28443,'31406','S','Vernonburg','A','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.993240,-81.095484,0,'2013-07-06 12:44:32',NULL,NULL),(37799,'42377','P','W Louisville','A','Daviess','21059','Kentucky','KY','21','5990','270','Central',-6.0,'Y',37.698211,-87.284712,0,'2013-07-06 12:44:32',NULL,NULL),(8810,'08611','S','Hamilton','A','Mercer','34021','New Jersey','NJ','34','8480','609','Eastern',-5.0,'Y',40.209791,-74.754696,0,'2013-07-06 12:44:30',NULL,NULL),(6698,'06059','S','North Canton','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.898217,-72.892627,0,'2013-07-06 12:44:30',NULL,NULL),(15983,'17033','S','Palmdale','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.278840,-76.630680,0,'2013-07-06 12:44:31',NULL,NULL),(68609,'81615','P','West Village','N','Pitkin','08097','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',39.209019,-106.936130,0,'2013-07-06 12:44:34',NULL,NULL),(62455,'74301','S','White Oak','A','Craig','40035','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.642087,-95.156105,0,'2013-07-06 12:44:33',NULL,NULL),(59659,'71051','S','Elm Grove','D','Bossier','22015','Louisiana','LA','22','7680','318','Central',-6.0,'Y',32.362958,-93.497801,0,'2013-07-06 12:44:33',NULL,NULL),(49418,'56630','S','Blackduck','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.814758,-94.539269,0,'2013-07-06 12:44:33',NULL,NULL),(43868,'49127','S','Stevensville','D','Berrien','26021','Michigan','MI','26','0870','269','Eastern',-5.0,'Y',42.016823,-86.516037,0,'2013-07-06 12:44:32',NULL,NULL),(17582,'18017','S','Bethlehem','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.653231,-75.336849,0,'2013-07-06 12:44:31',NULL,NULL),(19309,'20009','S','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.917847,-77.035346,0,'2013-07-06 12:44:31',NULL,NULL),(36872,'41094','S','Richwood','N','Boone','21015','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',38.884714,-84.634472,0,'2013-07-06 12:44:32',NULL,NULL),(30067,'33153','P','Miami','D','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.863568,-80.192551,0,'2013-07-06 12:44:32',NULL,NULL),(40030,'45249','S','Montgomery','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.290580,-84.334690,0,'2013-07-06 12:44:32',NULL,NULL),(51582,'59802','S','MSLA','N','Missoula','30063','Montana','MT','30','5140','406','Mountain',-7.0,'Y',46.894225,-114.012626,0,'2013-07-06 12:44:33',NULL,NULL),(52391,'60630','S','Jefferson Pk','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.971136,-87.757805,0,'2013-07-06 12:44:33',NULL,NULL),(54333,'62762','U','Springfield','D','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.787857,-89.652226,0,'2013-07-06 12:44:33',NULL,NULL),(57564,'67050','S','Garden Plain','D','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.671690,-97.675091,0,'2013-07-06 12:44:33',NULL,NULL),(64377,'76528','S','Mountain','N','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(62671,'74650','S','Ralston','D','Pawnee','40117','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.494627,-96.782266,0,'2013-07-06 12:44:33',NULL,NULL),(11807,'12230','U','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.654700,-73.757766,0,'2013-07-06 12:44:30',NULL,NULL),(37661,'42210','S','Lindseyville','A','Edmonson','21061','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.198402,-86.277888,0,'2013-07-06 12:44:32',NULL,NULL),(29371,'32588','P','Niceville','D','Okaloosa','12091','Florida','FL','12','2750','850','Central',-6.0,'Y',30.524498,-86.474906,0,'2013-07-06 12:44:32',NULL,NULL),(4849,'04013','S','Bustins Island','D','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.798612,-70.074648,0,'2013-07-06 12:44:30',NULL,NULL),(15894,'17007','S','Boiling Sprgs','A','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.147806,-77.116428,0,'2013-07-06 12:44:31',NULL,NULL),(18407,'19054','S','Levittown','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.168340,-74.822181,0,'2013-07-06 12:44:31',NULL,NULL),(44646,'50075','S','Ellsworth','D','Hamilton','19079','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.313370,-93.580699,0,'2013-07-06 12:44:32',NULL,NULL),(49907,'57301','S','Betts','N','Davison','46035','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.727400,-98.046180,0,'2013-07-06 12:44:33',NULL,NULL),(56898,'66044','S','Lawrence','D','Douglas','20045','Kansas','KS','20','4150','785','Central',-6.0,'Y',38.962471,-95.254516,0,'2013-07-06 12:44:33',NULL,NULL),(62329,'74046','P','Milfay','D','Creek','40037','Oklahoma','OK','40','8560','918','Central',-6.0,'Y',35.755493,-96.565776,0,'2013-07-06 12:44:33',NULL,NULL),(64143,'76197','U','Ft Worth','A','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.777097,-97.299046,0,'2013-07-06 12:44:34',NULL,NULL),(67663,'80483','P','Yampa','D','Routt','08107','Colorado','CO','08','0000','970','Mountain',-7.0,'Y',40.148581,-106.924602,0,'2013-07-06 12:44:34',NULL,NULL),(73322,'90833','S','Long Beach','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.766363,-118.203087,0,'2013-07-06 12:44:34',NULL,NULL),(77537,'96850','S','Honolulu','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.308944,-157.861150,0,'2013-07-06 12:44:34',NULL,NULL),(36252,'40312','S','Westbend','A','Powell','21197','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.839660,-83.936520,0,'2013-07-06 12:44:32',NULL,NULL),(8634,'08260','S','Wildwood Crest','A','Cape May','34009','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',38.986861,-74.823351,0,'2013-07-06 12:44:30',NULL,NULL),(11579,'12071','S','Fultonham','D','Schoharie','36095','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.591388,-74.393816,0,'2013-07-06 12:44:30',NULL,NULL),(28397,'31314','S','Ft Stewart','N','Liberty','13179','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.866667,-81.583333,0,'2013-07-06 12:44:32',NULL,NULL),(28317,'31141','P','Embry Hls','N','DeKalb','13089','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.761509,-84.419799,0,'2013-07-06 12:44:31',NULL,NULL),(48518,'55746','S','Lavinia','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.416877,-92.930377,0,'2013-07-06 12:44:33',NULL,NULL),(56619,'65584','S','Saint Roberts','N','Pulaski','29169','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.828919,-92.200348,0,'2013-07-06 12:44:33',NULL,NULL),(58986,'70050','P','Empire','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.370658,-89.570686,0,'2013-07-06 12:44:33',NULL,NULL),(72077,'88132','S','Rogers','D','Roosevelt','35041','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.034530,-103.139803,0,'2013-07-06 12:44:34',NULL,NULL),(1546,'00757','S','Urb Santiago Apostol','N','Santa Isabel','72133','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.968229,-66.402656,0,'2013-07-06 12:44:30',NULL,NULL),(27506,'30179','S','Temple','D','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.808273,-85.018501,0,'2013-07-06 12:44:31',NULL,NULL),(21165,'22151','S','North Springfield','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.801146,-77.207526,0,'2013-07-06 12:44:31',NULL,NULL),(19013,'19529','S','Kempton','D','Berks','42011','Pennsylvania','PA','42','6680','610/484','Eastern',-5.0,'Y',40.635556,-75.853611,0,'2013-07-06 12:44:31',NULL,NULL),(44560,'50012','U','Iowa State University','N','Story','19169','Iowa','IA','19','0000','515','Central',-6.0,'Y',42.023294,-93.647478,0,'2013-07-06 12:44:32',NULL,NULL),(52604,'61021','S','Nelson','A','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.838841,-89.492572,0,'2013-07-06 12:44:33',NULL,NULL),(60770,'72015','S','Bryant','A','Saline','05125','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.566563,-92.583045,0,'2013-07-06 12:44:33',NULL,NULL),(63714,'75925','S','Linwood','N','Cherokee','48073','Texas','TX','48','0000','936','Central',-6.0,'Y',31.642080,-95.087100,0,'2013-07-06 12:44:34',NULL,NULL),(72465,'89122','S','Las Vegas','D','Clark','32003','Nevada','NV','32','4120','702','Pacific',-8.0,'Y',36.119073,-115.048202,0,'2013-07-06 12:44:34',NULL,NULL),(80151,'99788','P','Fort Yukon','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',66.564722,-145.273889,0,'2013-07-06 12:44:34',NULL,NULL),(507,'00674','S','Manati','D','Manati','72091','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.430555,-66.484708,0,'2013-07-06 12:44:30',NULL,NULL),(13697,'14056','P','East Pembroke','D','Genesee','36037','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.997572,-78.317822,0,'2013-07-06 12:44:31',NULL,NULL),(35697,'39664','S','Smithdale','D','Amite','28005','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.356300,-90.636060,0,'2013-07-06 12:44:32',NULL,NULL),(28335,'31156','P','Sandy Springs','A','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.959963,-84.364913,0,'2013-07-06 12:44:32',NULL,NULL),(24938,'27820','S','Conway','D','Northampton','37131','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.441291,-77.256965,0,'2013-07-06 12:44:31',NULL,NULL),(16542,'17302','S','Woodbine','N','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',39.768902,-76.372021,0,'2013-07-06 12:44:31',NULL,NULL),(39473,'44718','S','Jacksn Belden','A','Stark','39151','Ohio','OH','39','1320','330/234','Eastern',-5.0,'Y',40.851462,-81.443104,0,'2013-07-06 12:44:32',NULL,NULL),(53643,'62203','S','Centreville','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.598771,-90.076739,0,'2013-07-06 12:44:33',NULL,NULL),(53948,'62421','S','Claremont','D','Richland','17159','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.755773,-87.965113,0,'2013-07-06 12:44:33',NULL,NULL),(63836,'75973','S','Shelbyville','D','Shelby','48419','Texas','TX','48','0000','936','Central',-6.0,'Y',31.721520,-93.932580,0,'2013-07-06 12:44:34',NULL,NULL),(17754,'18326','S','Paradise Valley','A','Monroe','42089','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.160326,-75.252633,0,'2013-07-06 12:44:31',NULL,NULL),(45748,'52136','S','Kendallville','N','Howard','19089','Iowa','IA','19','0000','563','Central',-6.0,'Y',43.376062,-92.114632,0,'2013-07-06 12:44:32',NULL,NULL),(57187,'66414','S','Carbondale','D','Osage','20139','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.819916,-95.691821,0,'2013-07-06 12:44:33',NULL,NULL),(59793,'71220','S','Dewdrop','N','Morehouse','22067','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.776951,-91.913001,0,'2013-07-06 12:44:33',NULL,NULL),(60697,'71940','S','Pisgah','N','Pike','05109','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.057278,-93.530098,0,'2013-07-06 12:44:33',NULL,NULL),(62466,'74337','S','Chouteau','D','Mayes','40097','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.189386,-95.333812,0,'2013-07-06 12:44:33',NULL,NULL),(38423,'43549','S','Ney','D','Defiance','39039','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.374875,-84.524779,0,'2013-07-06 12:44:32',NULL,NULL),(67983,'80916','S','Colorado Springs','D','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.803293,-104.707538,0,'2013-07-06 12:44:34',NULL,NULL),(72669,'89438','P','Valmy','D','Humboldt','32013','Nevada','NV','32','0000','775','Pacific',-8.0,'Y',40.791997,-117.123163,0,'2013-07-06 12:44:34',NULL,NULL),(76155,'95306','S','Catheys Vly','A','Mariposa','06043','California','CA','06','0000','209','Pacific',-8.0,'Y',37.437371,-120.090278,0,'2013-07-06 12:44:34',NULL,NULL),(79343,'98624','S','Ilwaco','D','Pacific','53049','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',46.317024,-124.035598,0,'2013-07-06 12:44:34',NULL,NULL),(68248,'81059','S','Delhi','A','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.498583,-104.151083,0,'2013-07-06 12:44:34',NULL,NULL),(16491,'17257','S','Middle Spring','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.038795,-77.553738,0,'2013-07-06 12:44:31',NULL,NULL),(43762,'49020','P','Bedford','D','Calhoun','26025','Michigan','MI','26','3720','269','Eastern',-5.0,'Y',42.395449,-85.233075,0,'2013-07-06 12:44:32',NULL,NULL),(44090,'49460','S','Port Sheldon','N','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928020,-86.108640,0,'2013-07-06 12:44:32',NULL,NULL),(48540,'55756','S','Duquette','A','Pine','27115','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.298113,-92.721724,0,'2013-07-06 12:44:33',NULL,NULL),(51707,'60009','P','Elk Grove Village','D','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.008382,-87.991526,0,'2013-07-06 12:44:33',NULL,NULL),(55942,'64481','S','Mount Moriah','A','Harrison','29081','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.418120,-93.986501,0,'2013-07-06 12:44:33',NULL,NULL),(59061,'70093','S','Belle Chasse','D','Plaquemines','22075','Louisiana','LA','22','5560','985','Central',-6.0,'Y',29.850130,-89.988599,0,'2013-07-06 12:44:33',NULL,NULL),(62469,'74338','S','W Siloam Spgs','A','Delaware','40041','Oklahoma','OK','40','0000','918','Central',-6.0,'Y',36.248548,-94.673222,0,'2013-07-06 12:44:33',NULL,NULL),(62895,'75065','S','Hickory Creek','A','Denton','48121','Texas','TX','48','1920','940','Central',-6.0,'Y',33.122050,-97.027006,0,'2013-07-06 12:44:33',NULL,NULL),(60723,'71953','S','Yocana','N','Polk','05113','Arkansas','AR','05','0000','479','Central',-6.0,'Y',34.607640,-94.213500,0,'2013-07-06 12:44:33',NULL,NULL),(50355,'57747','S','Maverick','N','Fall River','46047','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.433844,-103.476204,0,'2013-07-06 12:44:33',NULL,NULL),(47442,'54725','S','Boyceville','D','Dunn','55033','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.042696,-92.037334,0,'2013-07-06 12:44:32',NULL,NULL),(25251,'28111','P','Monroe','D','Union','37179','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',34.983675,-80.549186,0,'2013-07-06 12:44:31',NULL,NULL),(24943,'27824','S','Engelhard','D','Hyde','37095','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.533320,-76.037700,0,'2013-07-06 12:44:31',NULL,NULL),(14976,'15635','P','Hannastown','D','Westmoreland','42129','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.348969,-79.497991,0,'2013-07-06 12:44:31',NULL,NULL),(10437,'10911','S','Bear Mountain','D','Rockland','36087','New York','NY','36','5600','845','Eastern',-5.0,'Y',41.306188,-73.992180,0,'2013-07-06 12:44:30',NULL,NULL),(36879,'41099','U','Highland Heights','N','Campbell','21037','Kentucky','KY','21','1640','859','Eastern',-5.0,'Y',39.032312,-84.463361,0,'2013-07-06 12:44:32',NULL,NULL),(34780,'38865','S','Jacinto','N','Alcorn','28003','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.711840,-88.659681,0,'2013-07-06 12:44:32',NULL,NULL),(34413,'38632','S','Hernando','D','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.808376,-90.028477,0,'2013-07-06 12:44:32',NULL,NULL),(17448,'17938','S','Weishample','N','Schuylkill','42107','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.655278,-76.446944,0,'2013-07-06 12:44:31',NULL,NULL),(78729,'98280','P','Orcas','D','San Juan','53055','Washington','WA','53','0000','360/564','Pacific',-8.0,'Y',48.605392,-122.881094,0,'2013-07-06 12:44:34',NULL,NULL),(56080,'64761','S','Leeton','D','Johnson','29101','Missouri','MO','29','0000','660','Central',-6.0,'Y',38.583887,-93.691195,0,'2013-07-06 12:44:33',NULL,NULL),(55216,'63401','S','Monkey Run','N','Marion','29127','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.708581,-91.380823,0,'2013-07-06 12:44:33',NULL,NULL),(51970,'60145','S','Valley View','N','DeKalb','17037','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.111420,-88.800360,0,'2013-07-06 12:44:33',NULL,NULL),(48442,'55705','S','Palo','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.498700,-92.235780,0,'2013-07-06 12:44:33',NULL,NULL),(22324,'23850','S','Ford','D','Dinwiddie','51053','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.153169,-77.741192,0,'2013-07-06 12:44:31',NULL,NULL),(38161,'43150','S','West Rushville','A','Fairfield','39045','Ohio','OH','39','1840','740','Eastern',-5.0,'Y',39.777131,-82.425291,0,'2013-07-06 12:44:32',NULL,NULL),(14036,'14550','S','Rock Glen','A','Wyoming','36121','New York','NY','36','0000','585','Eastern',-5.0,'Y',42.672990,-78.094390,0,'2013-07-06 12:44:31',NULL,NULL),(9141,'09250','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(26223,'28793','P','Hendersonville','D','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.327979,-82.478182,0,'2013-07-06 12:44:31',NULL,NULL),(16974,'17724','S','Canton','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.654450,-76.852356,0,'2013-07-06 12:44:31',NULL,NULL),(13033,'13433','S','Port Leyden','D','Lewis','36049','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.588855,-75.279411,0,'2013-07-06 12:44:30',NULL,NULL),(79155,'98505','U','Evergreen State College','N','Thurston','53067','Washington','WA','53','5910','360/564','Pacific',-8.0,'Y',47.068915,-122.979513,0,'2013-07-06 12:44:34',NULL,NULL),(76422,'95568','S','Somes Bar','D','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.435199,-123.488452,0,'2013-07-06 12:44:34',NULL,NULL),(71306,'86503','S','Rough Rock','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',36.159541,-109.581995,0,'2013-07-06 12:44:34',NULL,NULL),(64402,'76542','S','Maxdale','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.046520,-97.723800,0,'2013-07-06 12:44:34',NULL,NULL),(46645,'53597','S','Waunakee','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.181072,-89.450204,0,'2013-07-06 12:44:32',NULL,NULL),(41480,'46933','S','Gas City','D','Grant','18053','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.487084,-85.603074,0,'2013-07-06 12:44:32',NULL,NULL),(41373,'46795','S','Timberhurst','N','Lagrange','18087','Indiana','IN','18','0000','260','Eastern',-5.0,'Y',41.552040,-85.284900,0,'2013-07-06 12:44:32',NULL,NULL),(32030,'35243','S','Birmingham','D','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.429420,-86.725200,0,'2013-07-06 12:44:32',NULL,NULL),(31743,'34986','S','St Lucie West','A','Saint Lucie','12111','Florida','FL','12','2710','772','Eastern',-5.0,'Y',27.321528,-80.418405,0,'2013-07-06 12:44:32',NULL,NULL),(6584,'05858','S','Miles Pond','N','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.575000,-71.784722,0,'2013-07-06 12:44:30',NULL,NULL),(4357,'03054','S','Merrimack','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.863038,-71.516973,0,'2013-07-06 12:44:30',NULL,NULL),(14363,'15022','S','Charleroi','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.134660,-79.916040,0,'2013-07-06 12:44:31',NULL,NULL),(48137,'55362','S','Otsego','A','Wright','27171','Minnesota','MN','27','5120','763','Central',-6.0,'Y',45.303033,-93.798977,0,'2013-07-06 12:44:33',NULL,NULL),(23195,'25059','S','Dixie','D','Nicholas','54067','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.263961,-81.183718,0,'2013-07-06 12:44:31',NULL,NULL),(21464,'22625','S','Cross Junction','D','Frederick','51069','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',39.370440,-78.303060,0,'2013-07-06 12:44:31',NULL,NULL),(29569,'32816','U','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.606119,-81.204801,0,'2013-07-06 12:44:32',NULL,NULL),(37472,'42001','S','Barkley Regional Airport','N','McCracken','21145','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.037580,-88.710180,0,'2013-07-06 12:44:32',NULL,NULL),(17245,'17837','S','Lochiel','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.972740,-76.918440,0,'2013-07-06 12:44:31',NULL,NULL),(7471,'06881','P','Westport','D','Fairfield','09001','Connecticut','CT','09','8040','203/475','Eastern',-5.0,'Y',41.137760,-73.365029,0,'2013-07-06 12:44:30',NULL,NULL),(77343,'96721','P','Hilo','D','Hawaii','15001','Hawaii','HI','15','0000','808','Hawaii',-10.0,'N',19.532167,-154.955477,0,'2013-07-06 12:44:34',NULL,NULL),(74640,'92816','P','Anaheim','D','Orange','06059','California','CA','06','5945','714','Pacific',-8.0,'Y',33.840115,-117.886690,0,'2013-07-06 12:44:34',NULL,NULL),(70903,'85623','S','Oracle','D','Pinal','04021','Arizona','AZ','04','6200','520','Mountain',-7.0,'N',32.616554,-110.794397,0,'2013-07-06 12:44:34',NULL,NULL),(68210,'81045','S','Haswell','D','Kiowa','08061','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.437686,-103.124591,0,'2013-07-06 12:44:34',NULL,NULL),(65656,'77978','P','Point Comfort','D','Calhoun','48057','Texas','TX','48','0000','361','Central',-6.0,'Y',28.678919,-96.556383,0,'2013-07-06 12:44:34',NULL,NULL),(12397,'12927','P','Cranberry Lk','A','Saint Lawrence','36089','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.220251,-74.832828,0,'2013-07-06 12:44:30',NULL,NULL),(18325,'19025','S','Jarrettown','N','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.139401,-75.223398,0,'2013-07-06 12:44:31',NULL,NULL),(46503,'53234','P','Milwaukee','D','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.001743,-87.970753,0,'2013-07-06 12:44:32',NULL,NULL),(51752,'60020','S','Volo','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.394881,-88.176816,0,'2013-07-06 12:44:33',NULL,NULL),(61101,'72137','S','Rose Bud','D','White','05145','Arkansas','AR','05','0000','501','Central',-6.0,'Y',35.312759,-91.980405,0,'2013-07-06 12:44:33',NULL,NULL),(4963,'04107','S','Cape Eliz','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.610918,-70.232964,0,'2013-07-06 12:44:30',NULL,NULL),(74782,'93117','S','Goleta','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.437147,-119.866076,0,'2013-07-06 12:44:34',NULL,NULL),(53872,'62344','S','Huntsville','D','Schuyler','17169','Illinois','IL','17','0000','217','Central',-6.0,'Y',40.150965,-90.852473,0,'2013-07-06 12:44:33',NULL,NULL),(52606,'61021','S','Walton','N','Lee','17103','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.838841,-89.492572,0,'2013-07-06 12:44:33',NULL,NULL),(44199,'49622','S','Central Lake','D','Antrim','26009','Michigan','MI','26','0000','231','Eastern',-5.0,'Y',45.075561,-85.260237,0,'2013-07-06 12:44:32',NULL,NULL),(42416,'47802','S','Lakewood','N','Vigo','18167','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.427150,-87.391878,0,'2013-07-06 12:44:32',NULL,NULL),(2541,'00959','S','Ext La Milagrosa','N','Bayamon','72021','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.178084,-66.116735,0,'2013-07-06 12:44:30',NULL,NULL),(7331,'06706','S','Waterbury','D','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.535363,-73.027806,0,'2013-07-06 12:44:30',NULL,NULL),(14800,'15378','P','Westland','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.275938,-80.270353,0,'2013-07-06 12:44:31',NULL,NULL),(77565,'96910','S','Chalan Pago','A','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.476932,144.749308,0,'2013-07-06 12:44:34',NULL,NULL),(70957,'85643','S','Turkey Creek','N','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',32.361720,-109.886760,0,'2013-07-06 12:44:34',NULL,NULL),(69161,'83320','S','Carey','D','Blaine','16013','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.287180,-113.924700,0,'2013-07-06 12:44:34',NULL,NULL),(37874,'42544','S','Pointer','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.052740,-84.758850,0,'2013-07-06 12:44:32',NULL,NULL),(36169,'40242','S','Rolling Hills','A','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.256667,-85.601667,0,'2013-07-06 12:44:32',NULL,NULL),(35668,'39653','S','Meadville','D','Franklin','28037','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.455600,-90.879660,0,'2013-07-06 12:44:32',NULL,NULL),(34322,'38558','S','Crossvl','N','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.951652,-85.022011,0,'2013-07-06 12:44:32',NULL,NULL),(27304,'30014','S','Walnut Grove','N','Newton','13217','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.587144,-83.832307,0,'2013-07-06 12:44:31',NULL,NULL),(21346,'22430','P','Brooke','D','Stafford','51179','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.378786,-77.362519,0,'2013-07-06 12:44:31',NULL,NULL),(39350,'44625','S','New Alexander','N','Columbiana','39029','Ohio','OH','39','9320','330/234','Eastern',-5.0,'Y',40.771834,-80.996741,0,'2013-07-06 12:44:32',NULL,NULL),(48431,'55615','S','Tofte','D','Cook','27031','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.739914,-90.829716,0,'2013-07-06 12:44:33',NULL,NULL),(52390,'60630','S','Jefferson Park','A','Cook','17031','Illinois','IL','17','1600','773','Central',-6.0,'Y',41.971136,-87.757805,0,'2013-07-06 12:44:33',NULL,NULL),(63091,'75254','S','Dallas','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.934482,-96.789320,0,'2013-07-06 12:44:33',NULL,NULL),(67577,'80308','P','Boulder','D','Boulder','08013','Colorado','CO','08','1125','303/720','Mountain',-7.0,'Y',39.959537,-105.509752,0,'2013-07-06 12:44:34',NULL,NULL),(1857,'00791','S','Ext San Antonio','N','Humacao','72069','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.154496,-65.820757,0,'2013-07-06 12:44:30',NULL,NULL),(77201,'96365','M','APO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(76571,'95672','S','Rescue','D','El Dorado','06017','California','CA','06','6920','530','Pacific',-8.0,'Y',38.719155,-120.988178,0,'2013-07-06 12:44:34',NULL,NULL),(68026,'80926','S','Colorado Spgs','A','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.663492,-104.909353,0,'2013-07-06 12:44:34',NULL,NULL),(49021,'56266','S','Morgan','D','Redwood','27127','Minnesota','MN','27','0000','507','Central',-6.0,'Y',44.415886,-94.924541,0,'2013-07-06 12:44:33',NULL,NULL),(38962,'44128','S','Bedford Hts','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(2262,'00926','S','Urb Park Gdns Townhouses','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(26132,'28734','S','Hickory Knoll','N','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.201460,-83.381460,0,'2013-07-06 12:44:31',NULL,NULL),(25082,'27949','S','Southern Shores','A','Dare','37055','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.133440,-75.725400,0,'2013-07-06 12:44:31',NULL,NULL),(23717,'25901','S','Oak Hill','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.986637,-81.142428,0,'2013-07-06 12:44:31',NULL,NULL),(23107,'24941','S','Sweet Springs','A','Monroe','54063','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.521353,-80.372282,0,'2013-07-06 12:44:31',NULL,NULL),(47266,'54530','S','Hawkins','D','Rusk','55107','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.510622,-90.712444,0,'2013-07-06 12:44:32',NULL,NULL),(73856,'91903','P','Alpine','D','San Diego','06073','California','CA','06','7320','619','Pacific',-8.0,'Y',32.832775,-116.762806,0,'2013-07-06 12:44:34',NULL,NULL),(73189,'90502','S','Torrance','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',33.837971,-118.293025,0,'2013-07-06 12:44:34',NULL,NULL),(72856,'90001','S','Los Angeles','D','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',33.973310,-118.243612,0,'2013-07-06 12:44:34',NULL,NULL),(51280,'59114','U','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.641786,-108.398787,0,'2013-07-06 12:44:33',NULL,NULL),(50513,'58075','S','Wahpeton','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.273495,-96.609475,0,'2013-07-06 12:44:33',NULL,NULL),(48140,'55364','S','Mound','D','Hennepin','27053','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.935114,-93.662910,0,'2013-07-06 12:44:33',NULL,NULL),(46999,'54245','S','Valders','D','Manitowoc','55071','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',44.034289,-87.883227,0,'2013-07-06 12:44:32',NULL,NULL),(18499,'19096','S','Penn Wynne','A','Montgomery','42091','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',40.002510,-75.273155,0,'2013-07-06 12:44:31',NULL,NULL),(18394,'19050','S','East Lansdowne','A','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.936540,-75.263580,0,'2013-07-06 12:44:31',NULL,NULL),(74761,'93099','U','Simi Valley','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.262932,-118.750530,0,'2013-07-06 12:44:34',NULL,NULL),(56594,'65559','S','High Gate','N','Phelps','29161','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.998771,-91.613832,0,'2013-07-06 12:44:33',NULL,NULL),(52041,'60191','S','Wood Dale','D','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.959472,-87.980528,0,'2013-07-06 12:44:33',NULL,NULL),(51913,'60109','P','Burlington','D','Kane','17089','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.063706,-88.514428,0,'2013-07-06 12:44:33',NULL,NULL),(46136,'52651','S','Stockport','D','Van Buren','19177','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.859744,-91.834252,0,'2013-07-06 12:44:32',NULL,NULL),(20996,'21824','S','Ewell','D','Somerset','24039','Maryland','MD','24','0000','410/443/667','Eastern',-5.0,'Y',37.982465,-76.042178,0,'2013-07-06 12:44:31',NULL,NULL),(37541,'42056','S','Gage','N','Ballard','21007','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.101200,-88.969174,0,'2013-07-06 12:44:32',NULL,NULL),(36516,'40828','S','Yocum Creek','A','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.847695,-83.163724,0,'2013-07-06 12:44:32',NULL,NULL),(30001,'33122','S','Doral','A','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.799007,-80.300688,0,'2013-07-06 12:44:32',NULL,NULL),(100,'00612','S','Urb Garcia','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(28143,'30821','S','Cadley','N','Warren','13301','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.462193,-82.706161,0,'2013-07-06 12:44:31',NULL,NULL),(29486,'32735','S','Grand Island','D','Lake','12069','Florida','FL','12','5960','352','Eastern',-5.0,'Y',28.888050,-81.735747,0,'2013-07-06 12:44:32',NULL,NULL),(11110,'11702','S','Captree Is','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.694282,-73.327359,0,'2013-07-06 12:44:30',NULL,NULL),(4166,'02790','S','Westport','D','Bristol','25005','Massachusetts','MA','25','6480','508/774','Eastern',-5.0,'Y',41.607558,-71.083877,0,'2013-07-06 12:44:30',NULL,NULL),(55686,'64058','S','Independence','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.141498,-94.353728,0,'2013-07-06 12:44:33',NULL,NULL),(58508,'68771','S','Randolph','D','Cedar','31027','Nebraska','NE','31','0000','402','Central',-6.0,'Y',42.376438,-97.356521,0,'2013-07-06 12:44:33',NULL,NULL),(41100,'46553','S','New Paris','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.501908,-85.827126,0,'2013-07-06 12:44:32',NULL,NULL),(11982,'12470','S','Purling','D','Greene','36039','New York','NY','36','0000','518','Eastern',-5.0,'Y',42.270473,-74.008879,0,'2013-07-06 12:44:30',NULL,NULL),(12094,'12569','S','Pleasant Valley','D','Dutchess','36027','New York','NY','36','2281','845','Eastern',-5.0,'Y',41.746335,-73.817266,0,'2013-07-06 12:44:30',NULL,NULL),(6712,'06066','S','Vernon Rockville','D','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.844674,-72.463586,0,'2013-07-06 12:44:30',NULL,NULL),(51714,'60010','S','Hoffman Est','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.194268,-88.135521,0,'2013-07-06 12:44:33',NULL,NULL),(32819,'36456','S','McKenzie','A','Butler','01013','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.545720,-86.743920,0,'2013-07-06 12:44:32',NULL,NULL),(2794,'00976','S','Urb Golden Hls','N','Trujillo Alto','72139','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.363332,-66.017348,0,'2013-07-06 12:44:30',NULL,NULL),(28361,'31207','U','Mercer University','N','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.832198,-83.656205,0,'2013-07-06 12:44:32',NULL,NULL),(7078,'06340','S','Noank','N','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.352142,-72.044199,0,'2013-07-06 12:44:30',NULL,NULL),(71329,'86506','P','Querino','N','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'Y',35.389139,-109.283418,0,'2013-07-06 12:44:34',NULL,NULL),(61169,'72190','P','Nlr','N','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.798097,-92.256024,0,'2013-07-06 12:44:33',NULL,NULL),(59962,'71306','P','Alexandria','D','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.194386,-92.671547,0,'2013-07-06 12:44:33',NULL,NULL),(58569,'68826','S','Riverside Park','N','Merrick','31121','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.111822,-98.002519,0,'2013-07-06 12:44:33',NULL,NULL),(11777,'12205','S','Albany','D','Albany','36001','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.714746,-73.821155,0,'2013-07-06 12:44:30',NULL,NULL),(2902,'00987','S','Urb Mountain Vw','N','Carolina','72031','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.410228,-65.979410,0,'2013-07-06 12:44:30',NULL,NULL),(8111,'07821','S','Andover','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.967267,-74.766575,0,'2013-07-06 12:44:30',NULL,NULL),(5612,'04936','S','Coburn Gore','A','Franklin','23007','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.182634,-70.491461,0,'2013-07-06 12:44:30',NULL,NULL),(25552,'28409','S','Wilmington','D','New Hanover','37129','North Carolina','NC','37','9200','910','Eastern',-5.0,'Y',34.164792,-77.873138,0,'2013-07-06 12:44:31',NULL,NULL),(24121,'26543','P','Osage','D','Monongalia','54061','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',39.697322,-80.066232,0,'2013-07-06 12:44:31',NULL,NULL),(23748,'25938','S','Victor','D','Fayette','54019','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.144624,-81.034034,0,'2013-07-06 12:44:31',NULL,NULL),(21896,'23185','S','Williamsburg','D','James City','51095','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.266334,-76.709764,0,'2013-07-06 12:44:31',NULL,NULL),(21711,'22980','S','Park','N','Waynesboro City','51820','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',38.073472,-78.902930,0,'2013-07-06 12:44:31',NULL,NULL),(51835,'60067','S','Hoffman Est','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.112431,-88.051211,0,'2013-07-06 12:44:33',NULL,NULL),(55731,'64084','S','Rayville','D','Ray','29177','Missouri','MO','29','3760','660','Central',-6.0,'Y',39.394887,-94.039494,0,'2013-07-06 12:44:33',NULL,NULL),(56359,'65203','S','Huntsdale','N','Boone','29019','Missouri','MO','29','1740','573','Central',-6.0,'Y',38.929931,-92.372948,0,'2013-07-06 12:44:33',NULL,NULL),(12350,'12884','P','Victory Mills','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.088703,-73.594357,0,'2013-07-06 12:44:30',NULL,NULL),(75763,'94620','P','Piedmont','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.777570,-122.214747,0,'2013-07-06 12:44:34',NULL,NULL),(59532,'70810','S','Baton Rouge','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.366525,-91.092542,0,'2013-07-06 12:44:33',NULL,NULL),(58573,'68828','S','Douglas Grove','N','Custer','31041','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.536564,-99.308281,0,'2013-07-06 12:44:33',NULL,NULL),(52572,'60964','S','Saint Anne','D','Kankakee','17091','Illinois','IL','17','3740','815/779','Central',-6.0,'Y',41.023177,-87.716807,0,'2013-07-06 12:44:33',NULL,NULL),(50347,'57744','S','Hermosa','D','Custer','46033','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.838417,-103.190898,0,'2013-07-06 12:44:33',NULL,NULL),(45150,'50585','S','Sioux Rapids','D','Buena Vista','19021','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.905400,-95.145300,0,'2013-07-06 12:44:32',NULL,NULL),(39187,'44319','S','New Franklin','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',40.987174,-81.531004,0,'2013-07-06 12:44:32',NULL,NULL),(12374,'12914','S','Bombay','D','Franklin','36033','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.953343,-74.599279,0,'2013-07-06 12:44:30',NULL,NULL),(13026,'13431','S','Gravesville','N','Herkimer','36043','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.205100,-75.072600,0,'2013-07-06 12:44:30',NULL,NULL),(15900,'17011','S','Camp Hill Brm','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.240066,-76.930386,0,'2013-07-06 12:44:31',NULL,NULL),(31336,'34138','P','Chokoloskee','D','Collier','12021','Florida','FL','12','5345','239','Eastern',-5.0,'Y',25.814179,-81.357783,0,'2013-07-06 12:44:32',NULL,NULL),(30758,'33569','S','Riverview','D','Hillsborough','12057','Florida','FL','12','8280','813','Eastern',-5.0,'Y',27.850104,-82.313905,0,'2013-07-06 12:44:32',NULL,NULL),(29508,'32766','S','Chuluota','A','Seminole','12117','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.647707,-81.150362,0,'2013-07-06 12:44:32',NULL,NULL),(28829,'32082','S','Pnte Vdra Bch','N','Saint Johns','12109','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.173444,-81.395785,0,'2013-07-06 12:44:32',NULL,NULL),(22112,'23429','P','Seaview','D','Northampton','51131','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.276190,-75.957353,0,'2013-07-06 12:44:31',NULL,NULL),(9339,'09757','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(74336,'92405','S','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.141998,-117.299722,0,'2013-07-06 12:44:34',NULL,NULL),(72658,'89433','S','Sun Valley','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.596122,-119.775235,0,'2013-07-06 12:44:34',NULL,NULL),(72022,'88046','P','Mesilla','D','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.247119,-106.761443,0,'2013-07-06 12:44:34',NULL,NULL),(9235,'09564','M','FPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(27492,'30164','P','Rome','D','Floyd','13115','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.276431,-85.231078,0,'2013-07-06 12:44:31',NULL,NULL),(38994,'44134','S','Parma','A','Cuyahoga','39035','Ohio','OH','39','1680','440','Eastern',-5.0,'Y',41.387185,-81.702198,0,'2013-07-06 12:44:32',NULL,NULL),(48246,'55423','S','Richfield','A','Hennepin','27053','Minnesota','MN','27','5120','612','Central',-6.0,'Y',44.876412,-93.286850,0,'2013-07-06 12:44:33',NULL,NULL),(54500,'62865','S','Cleburne','N','Franklin','17055','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.989180,-89.109184,0,'2013-07-06 12:44:33',NULL,NULL),(63726,'75932','S','Shankleville','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.028220,-93.643080,0,'2013-07-06 12:44:34',NULL,NULL),(132,'00614','P','Arecibo','D','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.456904,-66.735892,0,'2013-07-06 12:44:30',NULL,NULL),(8542,'08201','S','Pinehurst','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.441925,-74.512041,0,'2013-07-06 12:44:30',NULL,NULL),(28475,'31510','S','Guysie','N','Bacon','13005','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.539831,-82.464187,0,'2013-07-06 12:44:32',NULL,NULL),(7774,'07419','S','Hamburg','D','Sussex','34037','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',41.153970,-74.567322,0,'2013-07-06 12:44:30',NULL,NULL),(3570,'01960','S','Peabody','D','Essex','25009','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.533241,-70.972639,0,'2013-07-06 12:44:30',NULL,NULL),(42473,'47834','S','Lena','N','Clay','18021','Indiana','IN','18','8320','812','Eastern',-5.0,'Y',39.525120,-87.169200,0,'2013-07-06 12:44:32',NULL,NULL),(52113,'60421','S','Elwood','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.424204,-88.086530,0,'2013-07-06 12:44:33',NULL,NULL),(57653,'67206','S','Eastborough','A','Sedgwick','20173','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.703526,-97.234538,0,'2013-07-06 12:44:33',NULL,NULL),(62774,'74867','S','Sasakwa','D','Seminole','40133','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.954799,-96.546147,0,'2013-07-06 12:44:33',NULL,NULL),(63344,'75605','S','Greggton','N','Gregg','48183','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.556050,-94.782395,0,'2013-07-06 12:44:33',NULL,NULL),(68203,'81041','S','Barton','N','Prowers','08099','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.913104,-102.348905,0,'2013-07-06 12:44:34',NULL,NULL),(72729,'89506','S','Anderson Acres','N','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.663392,-119.884208,0,'2013-07-06 12:44:34',NULL,NULL),(73186,'90410','P','Santa Monica','D','Los Angeles','06037','California','CA','06','4480','310/424','Pacific',-8.0,'Y',34.014649,-118.467400,0,'2013-07-06 12:44:34',NULL,NULL),(77670,'97028','S','Timberline Lodge','A','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.306268,-121.746016,0,'2013-07-06 12:44:34',NULL,NULL),(4101,'02675','S','Yarmouth Port','D','Barnstable','25001','Massachusetts','MA','25','0740','508/774','Eastern',-5.0,'Y',41.704063,-70.221541,0,'2013-07-06 12:44:30',NULL,NULL),(79673,'99164','U','Washington State University','N','Whitman','53075','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.728892,-117.155742,0,'2013-07-06 12:44:34',NULL,NULL),(62164,'73737','S','Fairview','D','Major','40093','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',36.268920,-98.513880,0,'2013-07-06 12:44:33',NULL,NULL),(28522,'31545','S','Madray Springs','N','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.612517,-81.885560,0,'2013-07-06 12:44:32',NULL,NULL),(32135,'35452','S','Coker','D','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.286474,-87.649998,0,'2013-07-06 12:44:32',NULL,NULL),(12217,'12803','S','South Glens Falls','D','Saratoga','36091','New York','NY','36','0160','518','Eastern',-5.0,'Y',43.280520,-73.630020,0,'2013-07-06 12:44:30',NULL,NULL),(1488,'00751','S','BO Santa Ana III','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(77572,'96912','P','Dededo','D','Guam','66010','Guam','GU','66','0000','671','UTC+10',10.0,'N',13.515455,144.835826,0,'2013-07-06 12:44:34',NULL,NULL),(73931,'92033','P','Escondido','D','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.121068,-117.086889,0,'2013-07-06 12:44:34',NULL,NULL),(69991,'84121','S','Solitude','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.622101,-111.824240,0,'2013-07-06 12:44:34',NULL,NULL),(63684,'75861','S','Tenn Colony','A','Anderson','48001','Texas','TX','48','0000','903/430','Central',-6.0,'Y',31.885591,-95.920349,0,'2013-07-06 12:44:34',NULL,NULL),(56702,'65664','P','Halltown','D','Lawrence','29109','Missouri','MO','29','0000','417','Central',-6.0,'Y',37.193643,-93.629207,0,'2013-07-06 12:44:33',NULL,NULL),(53466,'61929','S','Hammond','D','Piatt','17147','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.801837,-88.565868,0,'2013-07-06 12:44:33',NULL,NULL),(6384,'05701','S','Heartwell','N','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(34721,'38841','S','Friendship','N','Pontotoc','28115','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.347360,-88.989000,0,'2013-07-06 12:44:32',NULL,NULL),(33748,'37846','S','Philadelphia','D','Loudon','47105','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.678552,-84.406508,0,'2013-07-06 12:44:32',NULL,NULL),(33021,'36703','S','Selma','D','Dallas','01047','Alabama','AL','01','0000','334','Central',-6.0,'Y',32.420765,-87.007289,0,'2013-07-06 12:44:32',NULL,NULL),(39528,'44826','S','Collins','D','Huron','39077','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.236226,-82.484275,0,'2013-07-06 12:44:32',NULL,NULL),(40060,'45269','U','Provident Bank','N','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.106237,-84.534866,0,'2013-07-06 12:44:32',NULL,NULL),(814,'00693','S','Urb Las Delicias','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(74158,'92262','S','Barona Rancheria','N','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.856934,-116.563137,0,'2013-07-06 12:44:34',NULL,NULL),(67689,'80516','S','Erie','D','Boulder','08013','Colorado','CO','08','3060','303/720','Mountain',-7.0,'Y',40.055613,-105.026348,0,'2013-07-06 12:44:34',NULL,NULL),(66983,'79452','P','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.548871,-101.847573,0,'2013-07-06 12:44:34',NULL,NULL),(51555,'59741','S','Manhattan','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.764880,-111.338940,0,'2013-07-06 12:44:33',NULL,NULL),(50207,'57576','S','Vivian','D','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.021919,-100.306929,0,'2013-07-06 12:44:33',NULL,NULL),(35391,'39456','S','Mc Lain','D','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.073880,-88.816080,0,'2013-07-06 12:44:32',NULL,NULL),(31412,'34239','S','Sarasota','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.310402,-82.517837,0,'2013-07-06 12:44:32',NULL,NULL),(25946,'28657','S','Beech Bottom','N','Avery','37011','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',36.032760,-81.954360,0,'2013-07-06 12:44:31',NULL,NULL),(3193,'01344','S','Farley','N','Franklin','25011','Massachusetts','MA','25','8000','978/351','Eastern',-5.0,'Y',42.605957,-72.410738,0,'2013-07-06 12:44:30',NULL,NULL),(11117,'11703','S','Babylon','A','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.732426,-73.324916,0,'2013-07-06 12:44:30',NULL,NULL),(43941,'49285','S','Stockbridge','D','Ingham','26065','Michigan','MI','26','4040','517','Eastern',-5.0,'Y',42.466619,-84.213190,0,'2013-07-06 12:44:32',NULL,NULL),(13887,'14265','U','Ind Order of Foresters','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.978557,-78.750032,0,'2013-07-06 12:44:31',NULL,NULL),(73388,'91108','S','Pasadena','A','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.122334,-118.114252,0,'2013-07-06 12:44:34',NULL,NULL),(69959,'84118','S','West Valley City','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(37847,'42501','S','Acorn','A','Pulaski','21199','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.092398,-84.571846,0,'2013-07-06 12:44:32',NULL,NULL),(31908,'35150','S','Oak Grove','A','Talladega','01121','Alabama','AL','01','0000','256','Central',-6.0,'Y',33.175189,-86.255713,0,'2013-07-06 12:44:32',NULL,NULL),(47989,'55129','S','Saint Paul','D','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.889630,-92.918840,0,'2013-07-06 12:44:33',NULL,NULL),(55641,'64016','S','Buckner','D','Jackson','29095','Missouri','MO','29','3760','816/975','Central',-6.0,'Y',39.123058,-94.198901,0,'2013-07-06 12:44:33',NULL,NULL),(64407,'76544','S','Fort Hood','D','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',31.167180,-97.772700,0,'2013-07-06 12:44:34',NULL,NULL),(77239,'96532','M','DPO','D','none','00000','Armed Forces - Pacific','AP','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:34',NULL,NULL),(63414,'75654','S','Henderson','D','Rusk','48401','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.156130,-94.797864,0,'2013-07-06 12:44:33',NULL,NULL),(53747,'62258','S','Fayetteville','A','Saint Clair','17163','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.451780,-89.761020,0,'2013-07-06 12:44:33',NULL,NULL),(53546,'62040','S','Granite City','D','Madison','17119','Illinois','IL','17','7040','618/730','Central',-6.0,'Y',38.761356,-90.096335,0,'2013-07-06 12:44:33',NULL,NULL),(51530,'59717','P','Bozeman','D','Gallatin','30031','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.661963,-111.059937,0,'2013-07-06 12:44:33',NULL,NULL),(50115,'57501','S','Francis','N','Hughes','46065','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.446920,-100.187520,0,'2013-07-06 12:44:33',NULL,NULL),(6954,'06226','S','Chestnut Hill','N','Windham','09015','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.714269,-72.211943,0,'2013-07-06 12:44:30',NULL,NULL),(16526,'17268','S','Pen Mar','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.761199,-77.570415,0,'2013-07-06 12:44:31',NULL,NULL),(26172,'28748','S','Leicester','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.628226,-82.709526,0,'2013-07-06 12:44:31',NULL,NULL),(23497,'25523','S','Hamlin','D','Lincoln','54043','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.276689,-82.098761,0,'2013-07-06 12:44:31',NULL,NULL),(22079,'23358','S','Hacksneck','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.581160,-75.796356,0,'2013-07-06 12:44:31',NULL,NULL),(38304,'43350','P','Sparta','D','Morrow','39117','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.354745,-82.711177,0,'2013-07-06 12:44:32',NULL,NULL),(59571,'70874','P','Scotlandville','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.443359,-91.186981,0,'2013-07-06 12:44:33',NULL,NULL),(60524,'71671','S','Bradley Quarters','N','Bradley','05011','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.609178,-92.070158,0,'2013-07-06 12:44:33',NULL,NULL),(66967,'79404','S','Lubbock','D','Lubbock','48303','Texas','TX','48','4600','806','Central',-6.0,'Y',33.553575,-101.821365,0,'2013-07-06 12:44:34',NULL,NULL),(911,'00705','S','Villa Rosales','N','Aibonito','72009','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.142125,-66.267614,0,'2013-07-06 12:44:30',NULL,NULL),(38591,'43821','S','Dresden','D','Muskingum','39119','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.122240,-81.986160,0,'2013-07-06 12:44:32',NULL,NULL),(8601,'08232','S','Pleasantville','D','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.407640,-74.570700,0,'2013-07-06 12:44:30',NULL,NULL),(11384,'11939','S','E Marion','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',41.128421,-72.341905,0,'2013-07-06 12:44:30',NULL,NULL),(12344,'12879','S','Newcomb','D','Essex','36031','New York','NY','36','0000','518','Eastern',-5.0,'Y',44.018002,-74.128990,0,'2013-07-06 12:44:30',NULL,NULL),(19054,'19544','P','Mt Aetna','N','Berks','42011','Pennsylvania','PA','42','6680','717','Eastern',-5.0,'Y',40.418727,-76.295812,0,'2013-07-06 12:44:31',NULL,NULL),(22006,'23284','P','Richmond','D','Richmond City','51760','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.553021,-77.457951,0,'2013-07-06 12:44:31',NULL,NULL),(77381,'96759','P','Kunia','D','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.459024,-158.064195,0,'2013-07-06 12:44:34',NULL,NULL),(63727,'75932','S','Sycamore','N','Newton','48351','Texas','TX','48','0000','409','Central',-6.0,'Y',31.028220,-93.643080,0,'2013-07-06 12:44:34',NULL,NULL),(59912,'71282','S','Mound','A','Madison','22065','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.374680,-91.065480,0,'2013-07-06 12:44:33',NULL,NULL),(27440,'30117','S','University of West Georgia','N','Carroll','13045','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.589927,-85.120833,0,'2013-07-06 12:44:31',NULL,NULL),(28399,'31315','S','Ft Stewart','N','Liberty','13179','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.887737,-81.600923,0,'2013-07-06 12:44:32',NULL,NULL),(40537,'45840','S','Findlay','D','Hancock','39063','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',41.043063,-83.643019,0,'2013-07-06 12:44:32',NULL,NULL),(42835,'48068','P','Royal Oak','D','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.485230,-83.146542,0,'2013-07-06 12:44:32',NULL,NULL),(43257,'48324','S','W Bloomfield','A','Oakland','26125','Michigan','MI','26','2160','248/947','Eastern',-5.0,'Y',42.595440,-83.383020,0,'2013-07-06 12:44:32',NULL,NULL),(44968,'50401','S','Freeman','N','Cerro Gordo','19033','Iowa','IA','19','0000','641','Central',-6.0,'Y',43.149424,-93.198045,0,'2013-07-06 12:44:32',NULL,NULL),(78833,'98335','S','Raft Island','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.293860,-122.621820,0,'2013-07-06 12:44:34',NULL,NULL),(76216,'95368','S','Salida','D','Stanislaus','06099','California','CA','06','5170','209','Pacific',-8.0,'Y',37.708295,-121.092091,0,'2013-07-06 12:44:34',NULL,NULL),(75690,'94560','S','Newark','D','Alameda','06001','California','CA','06','5775','510','Pacific',-8.0,'Y',37.535958,-122.031512,0,'2013-07-06 12:44:34',NULL,NULL),(73360,'91012','P','La Canada Flintridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.203774,-118.191187,0,'2013-07-06 12:44:34',NULL,NULL),(68330,'81120','S','San Rafeal','N','Conejos','08021','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.073100,-106.246800,0,'2013-07-06 12:44:34',NULL,NULL),(58216,'68336','S','Davey','D','Lancaster','31109','Nebraska','NE','31','4360','402','Central',-6.0,'Y',40.973815,-96.692550,0,'2013-07-06 12:44:33',NULL,NULL),(52099,'60411','S','S Chicago Heights','A','Cook','17031','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.505061,-87.606173,0,'2013-07-06 12:44:33',NULL,NULL),(15532,'16553','U','Pnc Bank','N','Erie','42049','Pennsylvania','PA','42','2360','814','Eastern',-5.0,'Y',42.126405,-80.082939,0,'2013-07-06 12:44:31',NULL,NULL),(39536,'44833','S','Galion','D','Crawford','39033','Ohio','OH','39','4800','419/567','Eastern',-5.0,'Y',40.735262,-82.797835,0,'2013-07-06 12:44:32',NULL,NULL),(6610,'05872','S','W Charleston','A','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.898889,-72.060000,0,'2013-07-06 12:44:30',NULL,NULL),(22447,'24020','P','Roanoke','D','Roanoke','51161','Virginia','VA','51','6800','540','Eastern',-5.0,'Y',37.245254,-80.030639,0,'2013-07-06 12:44:31',NULL,NULL),(52731,'61234','S','Annawan','D','Henry','17073','Illinois','IL','17','1960','309','Central',-6.0,'Y',41.397338,-89.909448,0,'2013-07-06 12:44:33',NULL,NULL),(62881,'75049','P','Garland','D','Dallas','48113','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',32.858943,-96.602960,0,'2013-07-06 12:44:33',NULL,NULL),(69712,'84036','S','Francis','A','Summit','49043','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.645602,-111.284311,0,'2013-07-06 12:44:34',NULL,NULL),(76076,'95208','P','Stockton','D','San Joaquin','06077','California','CA','06','8120','209','Pacific',-8.0,'Y',37.955950,-121.441672,0,'2013-07-06 12:44:34',NULL,NULL),(79743,'99223','S','Spokane Valley','A','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.611523,-117.358133,0,'2013-07-06 12:44:34',NULL,NULL),(853,'00698','S','Res Barinas','N','Yauco','72153','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.035256,-66.863322,0,'2013-07-06 12:44:30',NULL,NULL),(28190,'31014','S','Empire','A','Bleckley','13023','Georgia','GA','13','0000','478','Eastern',-5.0,'Y',32.385663,-83.348675,0,'2013-07-06 12:44:31',NULL,NULL),(25517,'28387','S','Southern Pines','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.174091,-79.390844,0,'2013-07-06 12:44:31',NULL,NULL),(25062,'27930','P','Durants Neck','D','Perquimans','37143','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',36.153029,-76.313021,0,'2013-07-06 12:44:31',NULL,NULL),(21155,'22124','S','Vienna','A','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.889170,-77.322192,0,'2013-07-06 12:44:31',NULL,NULL),(77698,'97042','S','Mulino','D','Clackamas','41005','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.210348,-122.542178,0,'2013-07-06 12:44:34',NULL,NULL),(66037,'78368','S','Mathis','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',28.091531,-97.831561,0,'2013-07-06 12:44:34',NULL,NULL),(62608,'74531','S','Calvin','D','Hughes','40063','Oklahoma','OK','40','0000','405','Central',-6.0,'Y',34.835012,-96.293203,0,'2013-07-06 12:44:33',NULL,NULL),(61023,'72116','S','North Little Rock','D','Pulaski','05119','Arkansas','AR','05','4400','501','Central',-6.0,'Y',34.802035,-92.235768,0,'2013-07-06 12:44:33',NULL,NULL),(2754,'00969','S','Urb Tierra Alta I','N','Guaynabo','72061','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.386609,-66.113455,0,'2013-07-06 12:44:30',NULL,NULL),(15810,'16928','S','Austinburg','N','Tioga','42117','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.954882,-77.440143,0,'2013-07-06 12:44:31',NULL,NULL),(15050,'15714','S','Northern Cambria','D','Cambria','42021','Pennsylvania','PA','42','3680','814','Eastern',-5.0,'Y',40.663026,-78.778938,0,'2013-07-06 12:44:31',NULL,NULL),(7407,'06794','S','Washington Dt','A','Litchfield','09005','Connecticut','CT','09','1930','860/959','Eastern',-5.0,'Y',41.649297,-73.322807,0,'2013-07-06 12:44:30',NULL,NULL),(45576,'51532','S','Elliott','D','Montgomery','19137','Iowa','IA','19','0000','712','Central',-6.0,'Y',41.152713,-95.162777,0,'2013-07-06 12:44:32',NULL,NULL),(51035,'58722','S','Burlington','D','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.261494,-101.439227,0,'2013-07-06 12:44:33',NULL,NULL),(59574,'70884','P','Commerce Park','N','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.377259,-91.096010,0,'2013-07-06 12:44:33',NULL,NULL),(64245,'76364','S','Harrold','D','Wilbarger','48487','Texas','TX','48','0000','940','Central',-6.0,'Y',33.973560,-99.025800,0,'2013-07-06 12:44:34',NULL,NULL),(71645,'87420','S','Shiprock','D','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.574461,-108.590087,0,'2013-07-06 12:44:34',NULL,NULL),(65986,'78335','P','Aransas Pass','D','San Patricio','48409','Texas','TX','48','1880','361','Central',-6.0,'Y',27.909394,-97.150015,0,'2013-07-06 12:44:34',NULL,NULL),(37961,'42721','S','Neafus','A','Grayson','21085','Kentucky','KY','21','0000','270','Central',-6.0,'Y',37.426977,-86.486700,0,'2013-07-06 12:44:32',NULL,NULL),(37345,'41702','P','Hazard','D','Perry','21193','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.249396,-83.191370,0,'2013-07-06 12:44:32',NULL,NULL),(36409,'40517','S','Lexington','D','Fayette','21067','Kentucky','KY','21','4280','859','Eastern',-5.0,'Y',37.979479,-84.484850,0,'2013-07-06 12:44:32',NULL,NULL),(79898,'99586','S','Slana','A','Valdez Cordova','02261','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.714253,-143.985789,0,'2013-07-06 12:44:34',NULL,NULL),(67717,'80536','S','Livermore','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.858860,-105.373320,0,'2013-07-06 12:44:34',NULL,NULL),(63599,'75791','S','Whitehouse','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.228348,-95.224044,0,'2013-07-06 12:44:34',NULL,NULL),(60375,'71485','S','Castor Plunge','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.160578,-92.499928,0,'2013-07-06 12:44:33',NULL,NULL),(57008,'66205','S','Roeland Park','A','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.032921,-94.634324,0,'2013-07-06 12:44:33',NULL,NULL),(42251,'47576','S','Saint Croix','D','Perry','18123','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.227647,-86.609796,0,'2013-07-06 12:44:32',NULL,NULL),(40792,'46171','S','Reelsville','D','Putnam','18133','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',39.540941,-86.959946,0,'2013-07-06 12:44:32',NULL,NULL),(25158,'28031','S','Cornelius','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.478218,-80.864412,0,'2013-07-06 12:44:31',NULL,NULL),(4442,'03245','S','Holderness','D','Grafton','33009','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.698865,-71.551069,0,'2013-07-06 12:44:30',NULL,NULL),(16898,'17582','S','Wash Boro','A','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.996531,-76.452756,0,'2013-07-06 12:44:31',NULL,NULL),(36920,'41144','S','Load','A','Greenup','21089','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.572275,-82.812737,0,'2013-07-06 12:44:32',NULL,NULL),(15083,'15753','S','La Jose','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.816290,-78.625144,0,'2013-07-06 12:44:31',NULL,NULL),(45678,'52042','S','Wood','N','Clayton','19043','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.649161,-91.399965,0,'2013-07-06 12:44:32',NULL,NULL),(63228,'75460','S','Paris','D','Lamar','48277','Texas','TX','48','0000','903/430','Central',-6.0,'Y',33.665531,-95.543795,0,'2013-07-06 12:44:33',NULL,NULL),(63903,'76028','S','Burleson','D','Johnson','48251','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.529531,-97.311978,0,'2013-07-06 12:44:34',NULL,NULL),(63907,'76034','S','Colleyville','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.889382,-97.145416,0,'2013-07-06 12:44:34',NULL,NULL),(64184,'76238','S','Era','D','Cooke','48097','Texas','TX','48','0000','940','Central',-6.0,'Y',33.496281,-97.300529,0,'2013-07-06 12:44:34',NULL,NULL),(77708,'97051','S','St Helens','N','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.871834,-122.872699,0,'2013-07-06 12:44:34',NULL,NULL),(35902,'40013','S','Highgrove','A','Nelson','21179','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',37.917352,-85.501392,0,'2013-07-06 12:44:32',NULL,NULL),(31047,'33825','S','Avon Park','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.604536,-81.509633,0,'2013-07-06 12:44:32',NULL,NULL),(46523,'53288','U','M and I Bank','N','Milwaukee','55079','Wisconsin','WI','55','5080','414','Central',-6.0,'Y',43.043453,-87.912413,0,'2013-07-06 12:44:32',NULL,NULL),(50982,'58642','S','Manning','D','Dunn','38025','North Dakota','ND','38','0000','701','Mountain',-7.0,'Y',47.115146,-102.641338,0,'2013-07-06 12:44:33',NULL,NULL),(51166,'59002','S','Molt','A','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.924789,-108.695498,0,'2013-07-06 12:44:33',NULL,NULL),(54474,'62859','S','Delafield','N','Hamilton','17065','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.120000,-88.453056,0,'2013-07-06 12:44:33',NULL,NULL),(6199,'05483','S','Sheldon Creek','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.884878,-72.929823,0,'2013-07-06 12:44:30',NULL,NULL),(34141,'38232','S','Hornbeak','D','Obion','47131','Tennessee','TN','47','0000','731','Central',-6.0,'Y',36.331585,-89.311065,0,'2013-07-06 12:44:32',NULL,NULL),(44177,'49555','U','Grand Rapids','D','Kent','26081','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.969643,-85.665859,0,'2013-07-06 12:44:32',NULL,NULL),(46216,'52767','S','Pleasant Vly','A','Scott','19163','Iowa','IA','19','1960','563','Central',-6.0,'Y',41.569175,-90.423855,0,'2013-07-06 12:44:32',NULL,NULL),(46934,'54159','S','Loomis','N','Marinette','55075','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.205080,-87.795180,0,'2013-07-06 12:44:32',NULL,NULL),(55305,'63533','S','Adair','N','Adair','29001','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.220112,-92.432085,0,'2013-07-06 12:44:33',NULL,NULL),(75921,'95011','P','Campbell','D','Santa Clara','06085','California','CA','06','7400','408','Pacific',-8.0,'Y',37.295020,-121.960662,0,'2013-07-06 12:44:34',NULL,NULL),(106,'00612','S','Urb Los Pinos','N','Arecibo','72013','Puerto Rico','PR','72','0470','787/939','Atlantic',-4.0,'N',18.471326,-66.728149,0,'2013-07-06 12:44:30',NULL,NULL),(75402,'94015','S','Broadmoor Vlg','A','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.679341,-122.483788,0,'2013-07-06 12:44:34',NULL,NULL),(68452,'81228','S','Granite','D','Chaffee','08015','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',39.045472,-106.262136,0,'2013-07-06 12:44:34',NULL,NULL),(66927,'79344','S','Maple','D','Bailey','48017','Texas','TX','48','0000','806','Central',-6.0,'Y',33.859618,-102.948109,0,'2013-07-06 12:44:34',NULL,NULL),(51268,'59102','S','Billings','D','Yellowstone','30111','Montana','MT','30','0880','406','Mountain',-7.0,'Y',45.785595,-108.576337,0,'2013-07-06 12:44:33',NULL,NULL),(43137,'48236','S','Grosse Pointe Farms','A','Wayne','26163','Michigan','MI','26','2160','313/679','Eastern',-5.0,'Y',42.424935,-82.900732,0,'2013-07-06 12:44:32',NULL,NULL),(5571,'04864','S','Warren','D','Knox','23013','Maine','ME','23','0000','207','Eastern',-5.0,'Y',44.120142,-69.245163,0,'2013-07-06 12:44:30',NULL,NULL),(10394,'10603','S','N White Plns','A','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',41.050315,-73.777527,0,'2013-07-06 12:44:30',NULL,NULL),(8779,'08551','S','East Amwell Twp','N','Hunterdon','34019','New Jersey','NJ','34','5015','908','Eastern',-5.0,'Y',40.441298,-74.836215,0,'2013-07-06 12:44:30',NULL,NULL),(999,'00717','S','Urb Constancia','N','Ponce','72113','Puerto Rico','PR','72','6360','787/939','Atlantic',-4.0,'N',18.013291,-66.614490,0,'2013-07-06 12:44:30',NULL,NULL),(35718,'39669','S','Ft Adams','N','Wilkinson','28157','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.175760,-91.297740,0,'2013-07-06 12:44:32',NULL,NULL),(9520,'10018','S','Manhattan','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.755284,-73.992008,0,'2013-07-06 12:44:30',NULL,NULL),(14013,'14532','S','West Junius','N','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.967137,-77.044133,0,'2013-07-06 12:44:31',NULL,NULL),(52611,'61028','S','Elizabeth','D','Jo Daviess','17085','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',42.309202,-90.187779,0,'2013-07-06 12:44:33',NULL,NULL),(51882,'60088','S','North Chicago','A','Lake','17097','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',42.308646,-87.854501,0,'2013-07-06 12:44:33',NULL,NULL),(49238,'56470','S','Park Rapids','D','Hubbard','27057','Minnesota','MN','27','0000','218','Central',-6.0,'Y',46.921086,-95.056585,0,'2013-07-06 12:44:33',NULL,NULL),(13622,'13901','S','Glen Castle','N','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.156660,-75.890520,0,'2013-07-06 12:44:31',NULL,NULL),(59496,'70770','S','Pride','D','East Baton Rouge','22033','Louisiana','LA','22','0760','225','Central',-6.0,'Y',30.619832,-90.999546,0,'2013-07-06 12:44:33',NULL,NULL),(53786,'62278','S','Redbud','A','Randolph','17157','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',38.179200,-89.979600,0,'2013-07-06 12:44:33',NULL,NULL),(15971,'17032','S','Enders','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.463333,-76.842778,0,'2013-07-06 12:44:31',NULL,NULL),(34915,'38960','P','Tie Plant','D','Grenada','28043','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.738816,-89.789409,0,'2013-07-06 12:44:32',NULL,NULL),(4791,'03872','S','Sanbornville','D','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.551728,-71.015802,0,'2013-07-06 12:44:30',NULL,NULL),(28546,'31560','S','Screven','D','Wayne','13305','Georgia','GA','13','0000','912','Eastern',-5.0,'Y',31.486142,-82.018463,0,'2013-07-06 12:44:32',NULL,NULL),(28442,'31406','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',31.993240,-81.095484,0,'2013-07-06 12:44:32',NULL,NULL),(18867,'19446','S','Upper Gwynedd','A','Montgomery','42091','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.235193,-75.289081,0,'2013-07-06 12:44:31',NULL,NULL),(7204,'06484','S','Huntington','A','Fairfield','09001','Connecticut','CT','09','1160','203/475','Eastern',-5.0,'Y',41.313540,-73.137300,0,'2013-07-06 12:44:30',NULL,NULL),(6186,'05478','S','St Albans','N','Franklin','50011','Vermont','VT','50','1305','802','Eastern',-5.0,'Y',44.802840,-73.089660,0,'2013-07-06 12:44:30',NULL,NULL),(42685,'47981','S','Romney','D','Tippecanoe','18157','Indiana','IN','18','3920','765','Eastern',-5.0,'Y',40.257477,-86.899324,0,'2013-07-06 12:44:32',NULL,NULL),(42760,'48032','S','Jeddo','D','Saint Clair','26147','Michigan','MI','26','2160','810','Eastern',-5.0,'Y',43.173246,-82.593346,0,'2013-07-06 12:44:32',NULL,NULL),(51015,'58705','S','Minot','A','Ward','38101','North Dakota','ND','38','0000','701','Central',-6.0,'Y',48.230700,-101.307900,0,'2013-07-06 12:44:33',NULL,NULL),(9802,'10110','S','New York','D','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.724052,-73.980266,0,'2013-07-06 12:44:30',NULL,NULL),(74878,'93274','S','Tulare','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.208357,-119.341083,0,'2013-07-06 12:44:34',NULL,NULL),(54271,'62684','S','Barclay','A','Sangamon','17167','Illinois','IL','17','7880','217','Central',-6.0,'Y',39.894681,-89.600868,0,'2013-07-06 12:44:33',NULL,NULL),(40489,'45783','P','Tuppers Plns','A','Meigs','39105','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',39.166430,-81.835292,0,'2013-07-06 12:44:32',NULL,NULL),(38904,'44118','S','Cleveland Heights','A','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.498766,-81.554594,0,'2013-07-06 12:44:32',NULL,NULL),(20605,'21206','S','Raspeburg','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.341591,-76.530778,0,'2013-07-06 12:44:31',NULL,NULL),(27781,'30375','U','Atlanta','D','Fulton','13121','Georgia','GA','13','0520','404/678/470','Eastern',-5.0,'Y',33.775206,-84.389428,0,'2013-07-06 12:44:31',NULL,NULL),(4862,'04022','S','Denmark','D','Oxford','23017','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.976456,-70.798917,0,'2013-07-06 12:44:30',NULL,NULL),(6731,'06076','S','Stafford Sp','N','Tolland','09013','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.985120,-72.255660,0,'2013-07-06 12:44:30',NULL,NULL),(35440,'39477','P','Rogerslacy','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.787509,-89.038271,0,'2013-07-06 12:44:32',NULL,NULL),(8204,'07935','S','Green Village','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.740504,-74.448250,0,'2013-07-06 12:44:30',NULL,NULL),(71061,'85756','S','Mission','N','Pima','04019','Arizona','AZ','04','8520','520','Mountain',-7.0,'N',32.136236,-111.085365,0,'2013-07-06 12:44:34',NULL,NULL),(56543,'65449','S','Cook Sta','D','Crawford','29055','Missouri','MO','29','0000','573','Central',-6.0,'Y',37.847287,-91.464367,0,'2013-07-06 12:44:33',NULL,NULL),(52158,'60449','S','Monee','D','Will','17197','Illinois','IL','17','1600','708/464','Central',-6.0,'Y',41.419345,-87.774708,0,'2013-07-06 12:44:33',NULL,NULL),(41720,'47240','S','Williamstown','N','Decatur','18031','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.336960,-85.453920,0,'2013-07-06 12:44:32',NULL,NULL),(28432,'31401','S','Savannah','D','Chatham','13051','Georgia','GA','13','7520','912','Eastern',-5.0,'Y',32.070920,-81.105661,0,'2013-07-06 12:44:32',NULL,NULL),(12224,'12810','S','Athol','D','Warren','36113','New York','NY','36','2975','518','Eastern',-5.0,'Y',43.491212,-73.896855,0,'2013-07-06 12:44:30',NULL,NULL),(77533,'96849','U','Bancorp Hawaii','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.333358,-157.916104,0,'2013-07-06 12:44:34',NULL,NULL),(76127,'95247','S','Murphys','D','Calaveras','06009','California','CA','06','0000','209','Pacific',-8.0,'Y',38.141938,-120.445081,0,'2013-07-06 12:44:34',NULL,NULL),(70910,'85626','P','Pirtleville','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.359283,-109.573433,0,'2013-07-06 12:44:34',NULL,NULL),(68298,'81091','S','Stonewall','N','Las Animas','08071','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',37.174560,-104.895540,0,'2013-07-06 12:44:34',NULL,NULL),(58264,'68378','S','Johnson','D','Nemaha','31127','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.401480,-95.983800,0,'2013-07-06 12:44:33',NULL,NULL),(58194,'68316','S','Benedict','D','York','31185','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.005076,-97.603338,0,'2013-07-06 12:44:33',NULL,NULL),(38285,'43332','S','La Rue','D','Marion','39101','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.574908,-83.364808,0,'2013-07-06 12:44:32',NULL,NULL),(35372,'39452','S','Basin','N','George','28039','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',30.713260,-88.524635,0,'2013-07-06 12:44:32',NULL,NULL),(32544,'36108','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.350670,-86.361835,0,'2013-07-06 12:44:32',NULL,NULL),(32465,'36032','S','Fort Deposit','D','Lowndes','01085','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.982388,-86.578741,0,'2013-07-06 12:44:32',NULL,NULL),(6611,'05872','S','West Charleston','D','Orleans','50019','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.898889,-72.060000,0,'2013-07-06 12:44:30',NULL,NULL),(22335,'23870','U','Jarratt','D','Greensville','51081','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',36.813701,-77.469979,0,'2013-07-06 12:44:31',NULL,NULL),(29121,'32313','U','Florida State University','N','Leon','12073','Florida','FL','12','8240','850','Eastern',-5.0,'Y',30.430000,-84.280000,0,'2013-07-06 12:44:32',NULL,NULL),(28083,'30732','P','Oakman','D','Gordon','13129','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',34.564396,-84.704346,0,'2013-07-06 12:44:31',NULL,NULL),(41879,'47368','S','Parker','A','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.192356,-85.191566,0,'2013-07-06 12:44:32',NULL,NULL),(42990,'48157','S','Luna Pier','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.816305,-83.440293,0,'2013-07-06 12:44:32',NULL,NULL),(14706,'15265','U','Pittsburgh','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.442380,-79.999942,0,'2013-07-06 12:44:31',NULL,NULL),(80031,'99691','P','Mc Grath','A','Yukon Koyukuk','02290','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',62.998454,-154.389565,0,'2013-07-06 12:44:34',NULL,NULL),(79554,'99005','S','Colbert','D','Spokane','53063','Washington','WA','53','7840','509','Pacific',-8.0,'Y',47.841251,-117.365314,0,'2013-07-06 12:44:34',NULL,NULL),(58126,'68133','S','Papillion','D','Sarpy','31153','Nebraska','NE','31','5920','402','Central',-6.0,'Y',41.134020,-96.001800,0,'2013-07-06 12:44:33',NULL,NULL),(22362,'23909','U','Farmville','D','Prince Edward','51147','Virginia','VA','51','0000','434','Eastern',-5.0,'Y',37.295563,-78.398027,0,'2013-07-06 12:44:31',NULL,NULL),(46409,'53177','S','Mount Pleasant','A','Racine','55101','Wisconsin','WI','55','6600','262','Central',-6.0,'Y',42.697861,-87.917460,0,'2013-07-06 12:44:32',NULL,NULL),(55069,'63169','P','Saint Louis','D','Saint Louis City','29510','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.629081,-90.190015,0,'2013-07-06 12:44:33',NULL,NULL),(55247,'63447','S','Steffenville','A','Lewis','29111','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.105774,-91.914071,0,'2013-07-06 12:44:33',NULL,NULL),(78774,'98311','S','Sheridan Park','N','Kitsap','53035','Washington','WA','53','1150','360/564','Pacific',-8.0,'Y',47.625445,-122.638533,0,'2013-07-06 12:44:34',NULL,NULL),(73495,'91328','P','Northridge','D','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.217856,-118.531174,0,'2013-07-06 12:44:34',NULL,NULL),(72190,'88401','S','Tucumcari','D','Quay','35037','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',35.169863,-103.720274,0,'2013-07-06 12:44:34',NULL,NULL),(69955,'84118','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.654603,-111.984034,0,'2013-07-06 12:44:34',NULL,NULL),(20622,'21213','S','Clifton','A','Baltimore City','24510','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.312520,-76.583450,0,'2013-07-06 12:44:31',NULL,NULL),(40576,'45870','P','New Hampshire','D','Auglaize','39011','Ohio','OH','39','4320','419/567','Eastern',-5.0,'Y',40.558346,-83.954092,0,'2013-07-06 12:44:32',NULL,NULL),(43660,'48852','P','McBrides','D','Montcalm','26117','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',43.350739,-85.050680,0,'2013-07-06 12:44:32',NULL,NULL),(58556,'68821','S','Brewster','D','Blaine','31009','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.929163,-99.809807,0,'2013-07-06 12:44:33',NULL,NULL),(69759,'84051','S','Mountain Home','D','Duchesne','49013','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.208550,-110.741030,0,'2013-07-06 12:44:34',NULL,NULL),(79514,'98930','S','Grandview','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.254858,-119.918175,0,'2013-07-06 12:44:34',NULL,NULL),(74879,'93275','P','Tulare','D','Tulare','06107','California','CA','06','8780','559','Pacific',-8.0,'Y',36.207530,-119.343710,0,'2013-07-06 12:44:34',NULL,NULL),(60319,'71457','S','Natchitoches','D','Natchitoches','22069','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.787220,-93.128160,0,'2013-07-06 12:44:33',NULL,NULL),(60213,'71422','S','Hudson','N','Winn','22127','Louisiana','LA','22','0000','318','Central',-6.0,'Y',32.066880,-92.645400,0,'2013-07-06 12:44:33',NULL,NULL),(54794,'63014','S','Berger','D','Franklin','29071','Missouri','MO','29','7040','573','Central',-6.0,'Y',38.652660,-91.319280,0,'2013-07-06 12:44:33',NULL,NULL),(34063,'38145','U','Memphis Light Gas and Water','N','Shelby','47157','Tennessee','TN','47','4920','901','Central',-6.0,'Y',35.142373,-90.050604,0,'2013-07-06 12:44:32',NULL,NULL),(30539,'33409','S','Haverhill','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.708576,-80.096654,0,'2013-07-06 12:44:32',NULL,NULL),(16367,'17201','S','Kerrstown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',39.933480,-77.674560,0,'2013-07-06 12:44:31',NULL,NULL),(70082,'84152','P','Slc','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.725327,-111.859692,0,'2013-07-06 12:44:34',NULL,NULL),(14567,'15215','S','Sharpsburg','A','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.503780,-79.912020,0,'2013-07-06 12:44:31',NULL,NULL),(19704,'20380','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.876916,-76.994080,0,'2013-07-06 12:44:31',NULL,NULL),(13060,'13441','S','Rome','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.212972,-75.410170,0,'2013-07-06 12:44:30',NULL,NULL),(29036,'32233','S','Atlantic Beach','D','Duval','12031','Florida','FL','12','3600','904','Eastern',-5.0,'Y',30.355620,-81.518460,0,'2013-07-06 12:44:32',NULL,NULL),(29285,'32502','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.423197,-87.226657,0,'2013-07-06 12:44:32',NULL,NULL),(39120,'44260','S','Mogadore','D','Portage','39133','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.036803,-81.348875,0,'2013-07-06 12:44:32',NULL,NULL),(36486,'40801','P','Brookside','N','Harlan','21095','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',36.859167,-83.249444,0,'2013-07-06 12:44:32',NULL,NULL),(35392,'39456','S','McLain','N','Greene','28041','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.073880,-88.816080,0,'2013-07-06 12:44:32',NULL,NULL),(16274,'17098','S','Green Fields','N','Dauphin','42043','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.578618,-76.628591,0,'2013-07-06 12:44:31',NULL,NULL),(13892,'14270','U','Buffalo','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.870000,-78.832208,0,'2013-07-06 12:44:31',NULL,NULL),(71280,'86435','P','Havasupai Indian Reservation','N','Coconino','04005','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',36.114214,-112.523252,0,'2013-07-06 12:44:34',NULL,NULL),(47112,'54449','S','Bakerville','N','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.612100,-90.187920,0,'2013-07-06 12:44:32',NULL,NULL),(26166,'28744','P','Franklin','D','Macon','37113','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.180743,-83.381664,0,'2013-07-06 12:44:31',NULL,NULL),(34641,'38767','P','Rena Lara','D','Coahoma','28027','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.147347,-90.780987,0,'2013-07-06 12:44:32',NULL,NULL),(14494,'15140','S','Pitcairn','D','Allegheny','42003','Pennsylvania','PA','42','6280','412/878','Eastern',-5.0,'Y',40.405817,-79.773696,0,'2013-07-06 12:44:31',NULL,NULL),(17574,'18013','S','Bangor','D','Northampton','42095','Pennsylvania','PA','42','0240','610/484','Eastern',-5.0,'Y',40.873341,-75.187858,0,'2013-07-06 12:44:31',NULL,NULL),(9366,'09824','M','APO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(75074,'93532','S','Elizabeth Lk','A','Los Angeles','06037','California','CA','06','4480','661','Pacific',-8.0,'Y',34.673056,-118.423925,0,'2013-07-06 12:44:34',NULL,NULL),(74719,'93022','S','Oak View','D','Ventura','06111','California','CA','06','8735','805','Pacific',-8.0,'Y',34.405173,-119.297691,0,'2013-07-06 12:44:34',NULL,NULL),(73979,'92086','S','Warner Spgs','A','San Diego','06073','California','CA','06','7320','760','Pacific',-8.0,'Y',33.301094,-116.673009,0,'2013-07-06 12:44:34',NULL,NULL),(67498,'80234','S','North Glenn','A','Adams','08001','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.903133,-105.004743,0,'2013-07-06 12:44:34',NULL,NULL),(53296,'61731','S','Cropsey','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.595594,-88.513792,0,'2013-07-06 12:44:33',NULL,NULL),(50457,'58029','S','Erie','D','Cass','38017','North Dakota','ND','38','2520','701','Central',-6.0,'Y',47.110593,-97.387357,0,'2013-07-06 12:44:33',NULL,NULL),(38971,'44128','S','Warrensville Hts','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.441144,-81.545858,0,'2013-07-06 12:44:32',NULL,NULL),(41964,'47408','S','Blmgtn','N','Monroe','18105','Indiana','IN','18','1020','812','Eastern',-5.0,'Y',39.217645,-86.458495,0,'2013-07-06 12:44:32',NULL,NULL),(43525,'48654','S','Rose City','D','Ogemaw','26129','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.433039,-84.122243,0,'2013-07-06 12:44:32',NULL,NULL),(45142,'50579','S','Rands','N','Calhoun','19025','Iowa','IA','19','0000','712','Central',-6.0,'Y',42.394028,-94.630743,0,'2013-07-06 12:44:32',NULL,NULL),(46714,'53803','S','Benton','D','Lafayette','55065','Wisconsin','WI','55','0000','608','Central',-6.0,'Y',42.559118,-90.367335,0,'2013-07-06 12:44:32',NULL,NULL),(78162,'97626','P','Fort Klamath','D','Klamath','41035','Oregon','OR','41','0000','541','Pacific',-8.0,'Y',42.703520,-121.994710,0,'2013-07-06 12:44:34',NULL,NULL),(74813,'93216','P','Delano','D','Kern','06029','California','CA','06','0680','661','Pacific',-8.0,'Y',35.755150,-119.276056,0,'2013-07-06 12:44:34',NULL,NULL),(56341,'65111','U','Jefferson City','D','Cole','29051','Missouri','MO','29','0000','573','Central',-6.0,'Y',38.551103,-92.118815,0,'2013-07-06 12:44:33',NULL,NULL),(50883,'58530','S','Sanger','N','Oliver','38065','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.086010,-100.941390,0,'2013-07-06 12:44:33',NULL,NULL),(22987,'24740','S','Princeton','D','Mercer','54055','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.411080,-81.027240,0,'2013-07-06 12:44:31',NULL,NULL),(13980,'14487','S','Livonia','D','Livingston','36051','New York','NY','36','6840','585','Eastern',-5.0,'Y',42.811143,-77.668155,0,'2013-07-06 12:44:31',NULL,NULL),(4773,'03860','S','N Conway','N','Carroll','33003','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.041258,-71.131424,0,'2013-07-06 12:44:30',NULL,NULL),(75843,'94925','S','Corte Madera','D','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.925771,-122.518453,0,'2013-07-06 12:44:34',NULL,NULL),(64559,'76655','S','Rosenthal','N','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.422120,-97.237920,0,'2013-07-06 12:44:34',NULL,NULL),(47032,'54403','S','Wausau','D','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.960699,-89.599298,0,'2013-07-06 12:44:32',NULL,NULL),(46953,'54174','S','Suring','D','Oconto','55083','Wisconsin','WI','55','0000','920','Central',-6.0,'Y',45.035299,-88.377230,0,'2013-07-06 12:44:32',NULL,NULL),(42524,'47855','P','Hymera','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.182538,-87.299357,0,'2013-07-06 12:44:32',NULL,NULL),(594,'00680','S','Repto San Miguel','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(33765,'37863','S','Pigeon Forge','D','Sevier','47155','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',35.793902,-83.562814,0,'2013-07-06 12:44:32',NULL,NULL),(13036,'13436','S','Raquette Lake','D','Hamilton','36041','New York','NY','36','0000','315','Eastern',-5.0,'Y',43.780901,-74.669391,0,'2013-07-06 12:44:30',NULL,NULL),(12040,'12523','S','Elizaville','D','Columbia','36021','New York','NY','36','0000','845','Eastern',-5.0,'Y',42.072600,-73.792544,0,'2013-07-06 12:44:30',NULL,NULL),(32910,'36547','P','Gulf Shores','D','Baldwin','01003','Alabama','AL','01','5160','251','Central',-6.0,'Y',30.246140,-87.699911,0,'2013-07-06 12:44:32',NULL,NULL),(26937,'29593','S','Society Hill','D','Darlington','45031','South Carolina','SC','45','0000','843','Eastern',-5.0,'Y',34.444613,-79.837730,0,'2013-07-06 12:44:31',NULL,NULL),(20667,'21227','S','Halethorpe','D','Baltimore','24005','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.252540,-76.696380,0,'2013-07-06 12:44:31',NULL,NULL),(5460,'04733','S','Benedicta','D','Aroostook','23003','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.802342,-68.397685,0,'2013-07-06 12:44:30',NULL,NULL),(40818,'46205','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.827486,-86.133117,0,'2013-07-06 12:44:32',NULL,NULL),(48129,'55359','S','Medina','N','Hennepin','27053','Minnesota','MN','27','5120','763','Central',-6.0,'Y',44.997812,-93.687245,0,'2013-07-06 12:44:33',NULL,NULL),(9,'00602','S','Aguada','D','Aguada','72003','Puerto Rico','PR','72','0060','787/939','Atlantic',-4.0,'N',18.383005,-67.186553,0,'2013-07-06 12:44:30',NULL,NULL),(78872,'98352','U','Recreational Equipment Inc','N','Pierce','53053','Washington','WA','53','8200','253/564','Pacific',-8.0,'Y',47.164325,-122.242368,0,'2013-07-06 12:44:34',NULL,NULL),(76281,'95425','S','Cloverdale','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.769480,-122.948340,0,'2013-07-06 12:44:34',NULL,NULL),(70053,'84139','U','Slc','N','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.768936,-111.887445,0,'2013-07-06 12:44:34',NULL,NULL),(36143,'40233','P','Louisville','D','Jefferson','21111','Kentucky','KY','21','4520','502','Eastern',-5.0,'Y',38.272002,-85.529061,0,'2013-07-06 12:44:32',NULL,NULL),(30305,'33301','S','Ft Lauderdale','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',26.120250,-80.129547,0,'2013-07-06 12:44:32',NULL,NULL),(4858,'04020','S','Cornish','D','York','23031','Maine','ME','23','0000','207','Eastern',-5.0,'Y',43.802916,-70.810084,0,'2013-07-06 12:44:30',NULL,NULL),(21408,'22526','P','Ninde','D','King George','51099','Virginia','VA','51','8840','540','Eastern',-5.0,'Y',38.270141,-77.054318,0,'2013-07-06 12:44:31',NULL,NULL),(45196,'50619','S','Packard','N','Butler','19023','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.778981,-92.665398,0,'2013-07-06 12:44:32',NULL,NULL),(47985,'55128','S','Landfall Vlg','A','Washington','27163','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.007260,-92.964120,0,'2013-07-06 12:44:33',NULL,NULL),(52223,'60491','S','Homer Glen','D','Will','17197','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',41.607647,-88.014981,0,'2013-07-06 12:44:33',NULL,NULL),(62094,'73571','S','Vinson','D','Harmon','40057','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.886963,-99.813852,0,'2013-07-06 12:44:33',NULL,NULL),(66388,'78624','S','Fredericksburg','D','Gillespie','48171','Texas','TX','48','0000','830','Central',-6.0,'Y',30.249850,-99.099820,0,'2013-07-06 12:44:34',NULL,NULL),(78342,'98004','S','Yarrow Point','A','King','53033','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.617177,-122.208579,0,'2013-07-06 12:44:34',NULL,NULL),(64577,'76666','S','Mertens','D','Hill','48217','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.024409,-96.897306,0,'2013-07-06 12:44:34',NULL,NULL),(38239,'43251','U','Columbus','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',39.959725,-83.020801,0,'2013-07-06 12:44:32',NULL,NULL),(39923,'45222','P','Roselawn','A','Hamilton','39061','Ohio','OH','39','1640','513/283','Eastern',-5.0,'Y',39.193649,-84.446420,0,'2013-07-06 12:44:32',NULL,NULL),(47142,'54458','P','Nelsonville','D','Portage','55097','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.493237,-89.311107,0,'2013-07-06 12:44:32',NULL,NULL),(51949,'60132','U','North Suburban','N','DuPage','17043','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.919511,-88.100953,0,'2013-07-06 12:44:33',NULL,NULL),(74424,'92557','S','Moreno Valley','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.964589,-117.263935,0,'2013-07-06 12:44:34',NULL,NULL),(74386,'92509','S','Riverside','D','Riverside','06065','California','CA','06','6780','951','Pacific',-8.0,'Y',33.996714,-117.445775,0,'2013-07-06 12:44:34',NULL,NULL),(64282,'76437','S','Cisco','D','Eastland','48133','Texas','TX','48','0000','254','Central',-6.0,'Y',32.387328,-98.981735,0,'2013-07-06 12:44:34',NULL,NULL),(19932,'20565','U','National Gallery of Art','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.904899,-76.984842,0,'2013-07-06 12:44:31',NULL,NULL),(12189,'12776','S','Roscoe','D','Sullivan','36105','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.966965,-74.930453,0,'2013-07-06 12:44:30',NULL,NULL),(30711,'33499','U','Boca Raton','D','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.409609,-80.106315,0,'2013-07-06 12:44:32',NULL,NULL),(35665,'39652','S','Jennings','N','Pike','28113','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.144640,-90.458735,0,'2013-07-06 12:44:32',NULL,NULL),(34320,'38557','P','Crossville','D','Cumberland','47035','Tennessee','TN','47','0000','931','Central',-6.0,'Y',35.978972,-84.970658,0,'2013-07-06 12:44:32',NULL,NULL),(32008,'35229','U','Samford University','N','Jefferson','01073','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.464351,-86.795405,0,'2013-07-06 12:44:32',NULL,NULL),(63011,'75164','P','Josephine','D','Collin','48085','Texas','TX','48','1920','214/469/972','Central',-6.0,'Y',33.058595,-96.382568,0,'2013-07-06 12:44:33',NULL,NULL),(56420,'65257','S','Yates','N','Randolph','29175','Missouri','MO','29','0000','660','Central',-6.0,'Y',39.307992,-92.520101,0,'2013-07-06 12:44:33',NULL,NULL),(23798,'26033','S','Cameron','D','Marshall','54051','West Virginia','WV','54','9000','304/681','Eastern',-5.0,'Y',39.827348,-80.567821,0,'2013-07-06 12:44:31',NULL,NULL),(24474,'27242','S','Eagle Springs','D','Moore','37125','North Carolina','NC','37','0000','910','Eastern',-5.0,'Y',35.331358,-79.629491,0,'2013-07-06 12:44:31',NULL,NULL),(4332,'02940','P','Providence','D','Providence','44007','Rhode Island','RI','44','6480','401','Eastern',-5.0,'Y',41.822715,-71.420640,0,'2013-07-06 12:44:30',NULL,NULL),(15949,'17024','S','Green Park','A','Perry','42099','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.361616,-77.268375,0,'2013-07-06 12:44:31',NULL,NULL),(15999,'17038','S','Bordnersville','N','Lebanon','42075','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.410665,-76.486339,0,'2013-07-06 12:44:31',NULL,NULL),(809,'00693','S','Urb Ciara del Sol','N','Vega Baja','72145','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.441940,-66.398866,0,'2013-07-06 12:44:30',NULL,NULL),(42161,'47523','S','Dale','D','Spencer','18147','Indiana','IN','18','0000','812','Central',-6.0,'Y',38.173260,-86.999460,0,'2013-07-06 12:44:32',NULL,NULL),(5226,'04463','S','Lake View Plt','A','Piscataquis','23021','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.248630,-68.986198,0,'2013-07-06 12:44:30',NULL,NULL),(2026,'00917','S','Hato Rey','A','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.420562,-66.053869,0,'2013-07-06 12:44:30',NULL,NULL),(19676,'20340','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.849617,-77.016636,0,'2013-07-06 12:44:31',NULL,NULL),(6671,'06032','S','Farmington','D','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.725812,-72.835995,0,'2013-07-06 12:44:30',NULL,NULL),(36278,'40342','S','Lawrenceburg','D','Anderson','21005','Kentucky','KY','21','0000','502','Eastern',-5.0,'Y',38.011899,-84.949818,0,'2013-07-06 12:44:32',NULL,NULL),(33181,'37031','S','Castalin Spgs','A','Sumner','47165','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.382400,-86.318015,0,'2013-07-06 12:44:32',NULL,NULL),(14808,'15412','P','Allenport','D','Washington','42125','Pennsylvania','PA','42','6280','724/878','Eastern',-5.0,'Y',40.079070,-79.854384,0,'2013-07-06 12:44:31',NULL,NULL),(25144,'28018','S','Washburn Store','N','Rutherford','37161','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.457120,-81.803460,0,'2013-07-06 12:44:31',NULL,NULL),(70907,'85625','S','Pearce','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.935591,-109.803528,0,'2013-07-06 12:44:34',NULL,NULL),(52863,'61332','P','Leonore','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.191149,-88.982226,0,'2013-07-06 12:44:33',NULL,NULL),(49782,'57077','S','Worthing','D','Lincoln','46083','South Dakota','SD','46','7760','605','Central',-6.0,'Y',43.329353,-96.767294,0,'2013-07-06 12:44:33',NULL,NULL),(44394,'49808','P','Big Bay','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.815765,-87.728475,0,'2013-07-06 12:44:32',NULL,NULL),(22355,'23891','U','Waverly','D','Sussex','51183','Virginia','VA','51','0000','804','Eastern',-5.0,'Y',37.036209,-77.096824,0,'2013-07-06 12:44:31',NULL,NULL),(25378,'28255','U','NC Natl Bank','N','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.211192,-80.865108,0,'2013-07-06 12:44:31',NULL,NULL),(34840,'38921','S','Sharkey','N','Tallahatchie','28135','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.980940,-90.107520,0,'2013-07-06 12:44:32',NULL,NULL),(29611,'32854','P','Orlando','D','Orange','12095','Florida','FL','12','5960','407/321/689','Eastern',-5.0,'Y',28.568324,-81.386260,0,'2013-07-06 12:44:32',NULL,NULL),(27510,'30183','S','Waleska','D','Cherokee','13057','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',34.335140,-84.590564,0,'2013-07-06 12:44:31',NULL,NULL),(26928,'29587','P','Myrtle Beach','D','Horry','45051','South Carolina','SC','45','5330','843','Eastern',-5.0,'Y',33.617875,-78.987929,0,'2013-07-06 12:44:31',NULL,NULL),(7413,'06804','S','Brookfield','D','Fairfield','09001','Connecticut','CT','09','1930','203/475','Eastern',-5.0,'Y',41.466931,-73.395508,0,'2013-07-06 12:44:30',NULL,NULL),(76868,'95971','S','Quincy','D','Plumas','06063','California','CA','06','0000','530','Pacific',-8.0,'Y',39.935033,-120.905059,0,'2013-07-06 12:44:34',NULL,NULL),(70417,'84724','S','Elsinore','D','Sevier','49041','Utah','UT','49','0000','435','Mountain',-7.0,'Y',38.674418,-112.146821,0,'2013-07-06 12:44:34',NULL,NULL),(48414,'55602','S','Bassett','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.309551,-91.835899,0,'2013-07-06 12:44:33',NULL,NULL),(47904,'55109','S','North Saint Paul','A','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',45.013271,-93.029187,0,'2013-07-06 12:44:33',NULL,NULL),(46366,'53119','S','Eagle','D','Waukesha','55133','Wisconsin','WI','55','5080','262','Central',-6.0,'Y',42.877120,-88.468233,0,'2013-07-06 12:44:32',NULL,NULL),(37020,'41240','S','Nippa','A','Johnson','21115','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.809028,-82.802236,0,'2013-07-06 12:44:32',NULL,NULL),(7194,'06475','S','Fenwick','N','Middlesex','09007','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.299740,-72.390360,0,'2013-07-06 12:44:30',NULL,NULL),(18323,'19023','S','Darby','D','Delaware','42045','Pennsylvania','PA','42','6160','610/484','Eastern',-5.0,'Y',39.917217,-75.266969,0,'2013-07-06 12:44:31',NULL,NULL),(23609,'25705','S','Huntington','D','Cabell','54011','West Virginia','WV','54','3400','304/681','Eastern',-5.0,'Y',38.408574,-82.369744,0,'2013-07-06 12:44:31',NULL,NULL),(26348,'29067','S','Spring Mills','N','Lancaster','45057','South Carolina','SC','45','0000','803','Eastern',-5.0,'Y',34.498309,-80.520734,0,'2013-07-06 12:44:31',NULL,NULL),(28049,'30665','P','Siloam','D','Greene','13133','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.531500,-83.082441,0,'2013-07-06 12:44:31',NULL,NULL),(6389,'05701','S','S Chittenden','A','Rutland','50021','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',43.606253,-72.974023,0,'2013-07-06 12:44:30',NULL,NULL),(76310,'95448','S','Healdsburg','D','Sonoma','06097','California','CA','06','7500','707','Pacific',-8.0,'Y',38.619385,-122.860367,0,'2013-07-06 12:44:34',NULL,NULL),(70135,'84302','S','Bushnell','N','Box Elder','49003','Utah','UT','49','0000','435','Mountain',-7.0,'Y',41.536080,-112.048800,0,'2013-07-06 12:44:34',NULL,NULL),(57757,'67448','S','Gypsum','D','Saline','20169','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.702809,-97.424184,0,'2013-07-06 12:44:33',NULL,NULL),(57095,'66218','S','Sm','N','Johnson','20091','Kansas','KS','20','3760','913','Central',-6.0,'Y',39.014399,-94.817167,0,'2013-07-06 12:44:33',NULL,NULL),(54126,'62556','S','Palmer','D','Christian','17021','Illinois','IL','17','0000','217','Central',-6.0,'Y',39.479520,-89.432400,0,'2013-07-06 12:44:33',NULL,NULL),(18560,'19121','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',39.980775,-75.172170,0,'2013-07-06 12:44:31',NULL,NULL),(39729,'45063','P','Shandon','D','Butler','39017','Ohio','OH','39','3200','513/283','Eastern',-5.0,'Y',39.324928,-84.713192,0,'2013-07-06 12:44:32',NULL,NULL),(48490,'55734','S','Central Lakes','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.431510,-92.516556,0,'2013-07-06 12:44:33',NULL,NULL),(76722,'95866','P','Sacramento','D','Sacramento','06067','California','CA','06','6920','916','Pacific',-8.0,'Y',38.589449,-121.407836,0,'2013-07-06 12:44:34',NULL,NULL),(74554,'92677','S','Laguna Beach','A','Orange','06059','California','CA','06','5945','949','Pacific',-8.0,'Y',33.525540,-117.714360,0,'2013-07-06 12:44:34',NULL,NULL),(60540,'71678','P','Yorktown','D','Lincoln','05079','Arkansas','AR','05','0000','870','Central',-6.0,'Y',34.032116,-91.788646,0,'2013-07-06 12:44:33',NULL,NULL),(53262,'61709','U','Bloomington','D','McLean','17113','Illinois','IL','17','1040','309','Central',-6.0,'Y',40.458619,-88.961117,0,'2013-07-06 12:44:33',NULL,NULL),(50195,'57569','S','Grass Rope','N','Lyman','46085','South Dakota','SD','46','0000','605','Central',-6.0,'Y',43.832195,-99.527936,0,'2013-07-06 12:44:33',NULL,NULL),(47679,'54956','S','Neenah','D','Winnebago','55139','Wisconsin','WI','55','0460','920','Central',-6.0,'Y',44.183094,-88.487397,0,'2013-07-06 12:44:33',NULL,NULL),(42368,'47711','S','Darmstadt','N','Vanderburgh','18163','Indiana','IN','18','2440','812','Central',-6.0,'Y',38.029596,-87.532390,0,'2013-07-06 12:44:32',NULL,NULL),(16255,'17084','S','Reedsville','D','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.677620,-77.606927,0,'2013-07-06 12:44:31',NULL,NULL),(15150,'15863','P','Stump Creek','D','Jefferson','42065','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.012719,-78.835273,0,'2013-07-06 12:44:31',NULL,NULL),(586,'00680','S','Bo Santurce','N','Mayaguez','72097','Puerto Rico','PR','72','4840','787/939','Atlantic',-4.0,'N',18.203793,-67.145253,0,'2013-07-06 12:44:30',NULL,NULL),(8939,'08754','P','Toms River','D','Ocean','34029','New Jersey','NJ','34','5190','732/848','Eastern',-5.0,'Y',39.981977,-74.158872,0,'2013-07-06 12:44:30',NULL,NULL),(4592,'03582','S','Northumberlnd','A','Coos','33007','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',44.600195,-71.510658,0,'2013-07-06 12:44:30',NULL,NULL),(11308,'11779','S','Ronkonkoma','D','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.818120,-73.120800,0,'2013-07-06 12:44:30',NULL,NULL),(18549,'19115','S','Philadelphia','D','Philadelphia','42101','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.092863,-75.041136,0,'2013-07-06 12:44:31',NULL,NULL),(77892,'97290','P','Portland','D','Multnomah','41051','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.574143,-122.643315,0,'2013-07-06 12:44:34',NULL,NULL),(77488,'96824','P','Hono','N','Honolulu','15003','Hawaii','HI','15','3320','808','Hawaii',-10.0,'N',21.280032,-157.758076,0,'2013-07-06 12:44:34',NULL,NULL),(75860,'94941','S','Muir Woods','N','Marin','06041','California','CA','06','7360','415','Pacific',-8.0,'Y',37.890300,-122.567640,0,'2013-07-06 12:44:34',NULL,NULL),(38619,'43910','S','Unionport','A','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.340971,-80.806712,0,'2013-07-06 12:44:32',NULL,NULL),(17377,'17885','P','Cherry Run','N','Union','42119','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',40.859144,-77.298172,0,'2013-07-06 12:44:31',NULL,NULL),(26145,'28739','S','Hendersonvlle','A','Henderson','37089','North Carolina','NC','37','0000','828','Eastern',-5.0,'Y',35.318666,-82.488402,0,'2013-07-06 12:44:31',NULL,NULL),(22210,'23515','U','Norfolk','D','Norfolk City','51710','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.915605,-76.304000,0,'2013-07-06 12:44:31',NULL,NULL),(40443,'45724','S','Cutler','D','Washington','39167','Ohio','OH','39','6020','740','Eastern',-5.0,'Y',39.404374,-81.770012,0,'2013-07-06 12:44:32',NULL,NULL),(42691,'47986','P','Templeton','D','Benton','18007','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.516336,-87.207620,0,'2013-07-06 12:44:32',NULL,NULL),(46149,'52657','S','West Point','A','Lee','19111','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.768772,-91.541663,0,'2013-07-06 12:44:32',NULL,NULL),(51946,'60131','S','Schiller Park','A','Cook','17031','Illinois','IL','17','1600','847/224','Central',-6.0,'Y',41.936119,-87.875866,0,'2013-07-06 12:44:33',NULL,NULL),(74294,'92369','P','Patton','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.133473,-117.221198,0,'2013-07-06 12:44:34',NULL,NULL),(12656,'13118','S','Sempronius','N','Cayuga','36011','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.730440,-76.380600,0,'2013-07-06 12:44:30',NULL,NULL),(60215,'71423','S','Creola','A','Grant','22043','Louisiana','LA','22','0000','318','Central',-6.0,'Y',31.618500,-92.570400,0,'2013-07-06 12:44:33',NULL,NULL),(58080,'68066','S','Wahoo','D','Saunders','31155','Nebraska','NE','31','0000','402','Central',-6.0,'Y',41.209769,-96.622850,0,'2013-07-06 12:44:33',NULL,NULL),(57284,'66607','S','Topeka','D','Shawnee','20177','Kansas','KS','20','8440','785','Central',-6.0,'Y',39.041009,-95.642616,0,'2013-07-06 12:44:33',NULL,NULL),(47062,'54422','S','Hoard','N','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.953643,-90.433401,0,'2013-07-06 12:44:32',NULL,NULL),(44995,'50439','S','Goodell','D','Hancock','19081','Iowa','IA','19','0000','641','Central',-6.0,'Y',42.922102,-93.617078,0,'2013-07-06 12:44:32',NULL,NULL),(19535,'20190','S','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.958168,-77.341846,0,'2013-07-06 12:44:31',NULL,NULL),(41676,'47167','S','Salem','D','Washington','18175','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.605089,-86.098301,0,'2013-07-06 12:44:32',NULL,NULL),(43146,'48239','S','Redford Twp','N','Wayne','26163','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',42.376745,-83.285091,0,'2013-07-06 12:44:32',NULL,NULL),(5969,'05304','P','Brattleboro','D','Windham','50025','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',42.885232,-72.558728,0,'2013-07-06 12:44:30',NULL,NULL),(79801,'99360','S','Lowden','A','Walla Walla','53071','Washington','WA','53','0000','509','Pacific',-8.0,'Y',46.069500,-118.716300,0,'2013-07-06 12:44:34',NULL,NULL),(69503,'83712','S','Boise','D','Ada','16001','Idaho','ID','16','1080','208','Mountain',-7.0,'Y',43.599070,-116.162434,0,'2013-07-06 12:44:34',NULL,NULL),(60594,'71836','S','Foreman','D','Little River','05081','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.697375,-94.402260,0,'2013-07-06 12:44:33',NULL,NULL),(51816,'60051','S','Holiday Hills','A','McHenry','17111','Illinois','IL','17','1600','815/779','Central',-6.0,'Y',42.342172,-88.289042,0,'2013-07-06 12:44:33',NULL,NULL),(51248,'59075','S','Saint Xavier','D','Big Horn','30003','Montana','MT','30','0000','406','Mountain',-7.0,'Y',45.478490,-107.877691,0,'2013-07-06 12:44:33',NULL,NULL),(48146,'55368','S','Norwood','A','Carver','27019','Minnesota','MN','27','5120','952','Central',-6.0,'Y',44.752993,-93.920341,0,'2013-07-06 12:44:33',NULL,NULL),(37409,'41776','S','Frew','A','Leslie','21131','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.201089,-83.298307,0,'2013-07-06 12:44:32',NULL,NULL),(24958,'27834','S','Pactolus','N','Pitt','37147','North Carolina','NC','37','3150','252','Eastern',-5.0,'Y',35.626380,-77.438580,0,'2013-07-06 12:44:31',NULL,NULL),(35650,'39643','S','Darbun','N','Marion','28091','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.173021,-89.986969,0,'2013-07-06 12:44:32',NULL,NULL),(45789,'52164','S','Randalia','D','Fayette','19065','Iowa','IA','19','0000','563','Central',-6.0,'Y',42.862408,-91.886149,0,'2013-07-06 12:44:32',NULL,NULL),(71229,'86333','S','Bensch Ranch','A','Yavapai','04025','Arizona','AZ','04','2620','928','Mountain',-7.0,'N',34.316282,-112.121385,0,'2013-07-06 12:44:34',NULL,NULL),(66548,'78733','S','Austin','D','Travis','48453','Texas','TX','48','0640','512/737','Central',-6.0,'Y',30.321780,-97.895100,0,'2013-07-06 12:44:34',NULL,NULL),(63492,'75703','S','Tyler','D','Smith','48423','Texas','TX','48','8640','903/430','Central',-6.0,'Y',32.278780,-95.303581,0,'2013-07-06 12:44:33',NULL,NULL),(49646,'56965','U','Prs','A','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.899101,-77.028999,0,'2013-07-06 12:44:33',NULL,NULL),(35865,'39834','S','Climax','D','Decatur','13087','Georgia','GA','13','0000','229','Eastern',-5.0,'Y',30.876579,-84.441863,0,'2013-07-06 12:44:32',NULL,NULL),(29288,'32505','S','Pensacola','D','Escambia','12033','Florida','FL','12','6080','850','Central',-6.0,'Y',30.442180,-87.255850,0,'2013-07-06 12:44:32',NULL,NULL),(11576,'12068','S','Sammonsville','N','Montgomery','36057','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.942360,-74.430300,0,'2013-07-06 12:44:30',NULL,NULL),(19918,'20553','U','Federal Aviation Agency','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.887704,-77.024043,0,'2013-07-06 12:44:31',NULL,NULL),(47072,'54426','S','Rib Falls','N','Marathon','55073','Wisconsin','WI','55','8940','715','Central',-6.0,'Y',44.892081,-89.992307,0,'2013-07-06 12:44:32',NULL,NULL),(8519,'08106','S','Audubon','D','Camden','34007','New Jersey','NJ','34','6160','856','Eastern',-5.0,'Y',39.892401,-75.074652,0,'2013-07-06 12:44:30',NULL,NULL),(68750,'82223','S','Rockeagle','A','Goshen','56015','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',42.002320,-104.576230,0,'2013-07-06 12:44:34',NULL,NULL),(66251,'78572','S','Palmhurst','A','Hidalgo','48215','Texas','TX','48','4880','956','Central',-6.0,'Y',26.214660,-98.351640,0,'2013-07-06 12:44:34',NULL,NULL),(59947,'71301','S','Charles Park','N','Rapides','22079','Louisiana','LA','22','0220','318','Central',-6.0,'Y',31.284960,-92.465460,0,'2013-07-06 12:44:33',NULL,NULL),(59068,'70094','S','Westwego','D','Jefferson','22051','Louisiana','LA','22','5560','504','Central',-6.0,'Y',29.926980,-90.204120,0,'2013-07-06 12:44:33',NULL,NULL),(15584,'16661','S','Madera','D','Clearfield','42033','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',40.829157,-78.441940,0,'2013-07-06 12:44:31',NULL,NULL),(78732,'98282','S','Stanwood','A','Island','53029','Washington','WA','53','7600','360/564','Pacific',-8.0,'Y',48.174882,-122.521693,0,'2013-07-06 12:44:34',NULL,NULL),(77703,'97048','S','Rainier','D','Columbia','41009','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',46.058179,-122.963608,0,'2013-07-06 12:44:34',NULL,NULL),(72301,'88582','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.767649,-106.329558,0,'2013-07-06 12:44:34',NULL,NULL),(69018,'83211','S','Heglar','N','Power','16077','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',42.752040,-112.964640,0,'2013-07-06 12:44:34',NULL,NULL),(63961,'76096','P','Arlington','D','Tarrant','48439','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.672124,-97.091014,0,'2013-07-06 12:44:34',NULL,NULL),(45899,'52310','S','Scotch Grove','A','Jones','19105','Iowa','IA','19','0000','319','Central',-6.0,'Y',42.239992,-91.189303,0,'2013-07-06 12:44:32',NULL,NULL),(26780,'29449','S','Meggett','A','Charleston','45019','South Carolina','SC','45','1440','843','Eastern',-5.0,'Y',32.711040,-80.276820,0,'2013-07-06 12:44:31',NULL,NULL),(3903,'02453','S','South Waltham','A','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.369917,-71.236818,0,'2013-07-06 12:44:30',NULL,NULL),(30575,'33415','S','Green Acres','A','Palm Beach','12099','Florida','FL','12','8960','561','Eastern',-5.0,'Y',26.663672,-80.126382,0,'2013-07-06 12:44:32',NULL,NULL),(22133,'23450','P','Virginia Bch','A','Virginia Beach City','51810','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',36.844030,-76.093079,0,'2013-07-06 12:44:31',NULL,NULL),(290,'00646','S','Paseo Real','N','Dorado','72051','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.466563,-66.270521,0,'2013-07-06 12:44:30',NULL,NULL),(73205,'90605','S','Whittier','D','Los Angeles','06037','California','CA','06','4480','562','Pacific',-8.0,'Y',33.955629,-118.026647,0,'2013-07-06 12:44:34',NULL,NULL),(20272,'20785','S','Palmer Park','N','Prince Georges','24033','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',38.915920,-76.886146,0,'2013-07-06 12:44:31',NULL,NULL),(31438,'34272','P','Laurel','D','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.135805,-82.447292,0,'2013-07-06 12:44:32',NULL,NULL),(7103,'06365','S','Preston','D','New London','09011','Connecticut','CT','09','5520','860/959','Eastern',-5.0,'Y',41.513587,-71.999442,0,'2013-07-06 12:44:30',NULL,NULL),(38661,'43944','S','Richmond','D','Jefferson','39081','Ohio','OH','39','8080','740','Eastern',-5.0,'Y',40.431203,-80.756208,0,'2013-07-06 12:44:32',NULL,NULL),(16466,'17241','S','McCrea','N','Cumberland','42041','Pennsylvania','PA','42','3240','717','Eastern',-5.0,'Y',40.168351,-77.382711,0,'2013-07-06 12:44:31',NULL,NULL),(78477,'98093','P','Auburn','A','King','53033','Washington','WA','53','7600','253/564','Pacific',-8.0,'Y',47.301949,-122.358826,0,'2013-07-06 12:44:34',NULL,NULL),(76973,'96056','S','Little Valley','A','Lassen','06035','California','CA','06','6690','530','Pacific',-8.0,'Y',41.167186,-121.356668,0,'2013-07-06 12:44:34',NULL,NULL),(74136,'92247','P','La Quinta','D','Riverside','06065','California','CA','06','6780','760','Pacific',-8.0,'Y',33.673645,-116.295092,0,'2013-07-06 12:44:34',NULL,NULL),(69817,'84074','S','Lincoln','N','Tooele','49045','Utah','UT','49','0000','435','Mountain',-7.0,'Y',40.571280,-112.318620,0,'2013-07-06 12:44:34',NULL,NULL),(63908,'76035','S','Cresson','D','Hood','48221','Texas','TX','48','2800','817/682','Central',-6.0,'Y',32.567743,-97.681973,0,'2013-07-06 12:44:34',NULL,NULL),(22764,'24435','S','Fairfield','D','Rockbridge','51163','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.878805,-79.305142,0,'2013-07-06 12:44:31',NULL,NULL),(13150,'13602','S','Fort Drum','D','Jefferson','36045','New York','NY','36','0000','315','Eastern',-5.0,'Y',44.054057,-75.750531,0,'2013-07-06 12:44:30',NULL,NULL),(31457,'34286','S','Northport','N','Sarasota','12115','Florida','FL','12','7510','941','Eastern',-5.0,'Y',27.070796,-82.145952,0,'2013-07-06 12:44:32',NULL,NULL),(7620,'07058','S','Pine Brook','D','Morris','34027','New Jersey','NJ','34','5640','973/862','Eastern',-5.0,'Y',40.871765,-74.347469,0,'2013-07-06 12:44:30',NULL,NULL),(38801,'44067','S','Macedonia','A','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.316627,-81.548365,0,'2013-07-06 12:44:32',NULL,NULL),(35193,'39286','P','JAX','N','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.350653,-90.176499,0,'2013-07-06 12:44:32',NULL,NULL),(1614,'00769','S','Villa Cristina','N','Coamo','72043','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.082113,-66.359958,0,'2013-07-06 12:44:30',NULL,NULL),(16587,'17323','P','Franklintown','D','York','42133','Pennsylvania','PA','42','9280','717','Eastern',-5.0,'Y',40.074158,-77.031429,0,'2013-07-06 12:44:31',NULL,NULL),(64806,'77024','S','Houston','D','Harris','48201','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',29.764440,-95.509620,0,'2013-07-06 12:44:34',NULL,NULL),(61991,'73401','S','Milo','A','Carter','40019','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.332490,-97.335320,0,'2013-07-06 12:44:33',NULL,NULL),(57479,'66872','S','White City','D','Morris','20127','Kansas','KS','20','0000','785','Central',-6.0,'Y',38.797402,-96.733987,0,'2013-07-06 12:44:33',NULL,NULL),(55109,'63333','S','Bellflower','D','Montgomery','29139','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.001005,-91.334577,0,'2013-07-06 12:44:33',NULL,NULL),(35287,'39401','S','Glendale','N','Forrest','28035','Mississippi','MS','28','3285','601/769','Central',-6.0,'Y',31.250640,-89.276460,0,'2013-07-06 12:44:32',NULL,NULL),(10567,'11010','S','Franklin Square','D','Nassau','36059','New York','NY','36','5380','516','Eastern',-5.0,'Y',40.705094,-73.674202,0,'2013-07-06 12:44:30',NULL,NULL),(32764,'36353','S','Echo','N','Henry','01067','Alabama','AL','01','0000','334','Central',-6.0,'Y',31.431420,-85.331160,0,'2013-07-06 12:44:32',NULL,NULL),(31225,'33966','S','Fort Myers','D','Lee','12071','Florida','FL','12','2700','239','Eastern',-5.0,'Y',26.637141,-81.871604,0,'2013-07-06 12:44:32',NULL,NULL),(31070,'33852','S','Lake Placid','D','Highlands','12055','Florida','FL','12','0000','863','Eastern',-5.0,'Y',27.288620,-81.368570,0,'2013-07-06 12:44:32',NULL,NULL),(24344,'27040','S','Seward','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.167058,-80.376170,0,'2013-07-06 12:44:31',NULL,NULL),(44889,'50317','S','Risingsun','N','Polk','19153','Iowa','IA','19','2120','515','Central',-6.0,'Y',41.602770,-93.543515,0,'2013-07-06 12:44:32',NULL,NULL),(54984,'63125','S','Lemay','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.523552,-90.297410,0,'2013-07-06 12:44:33',NULL,NULL),(431,'00662','S','Sect Los Toledo','N','Isabela','72071','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',18.501226,-67.022790,0,'2013-07-06 12:44:30',NULL,NULL),(78406,'98037','S','Lynnwood','D','Snohomish','53061','Washington','WA','53','7600','425/564','Pacific',-8.0,'Y',47.851103,-122.281511,0,'2013-07-06 12:44:34',NULL,NULL),(68091,'80942','U','Affliated National Bank','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',38.834659,-104.822936,0,'2013-07-06 12:44:34',NULL,NULL),(65058,'77340','S','Phelps','N','Walker','48471','Texas','TX','48','0000','936','Central',-6.0,'Y',30.688500,-95.572380,0,'2013-07-06 12:44:34',NULL,NULL),(58601,'68852','S','Clay','N','Sherman','31163','Nebraska','NE','31','0000','308','Central',-6.0,'Y',41.199056,-99.120955,0,'2013-07-06 12:44:33',NULL,NULL),(4912,'04070','P','W Scarborough','A','Cumberland','23005','Maine','ME','23','6400','207','Eastern',-5.0,'Y',43.570278,-70.388333,0,'2013-07-06 12:44:30',NULL,NULL),(15264,'16101','S','New Castle','D','Lawrence','42073','Pennsylvania','PA','42','0000','724/878','Eastern',-5.0,'Y',40.989418,-80.336151,0,'2013-07-06 12:44:31',NULL,NULL),(22594,'24178','P','Villamont','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.425266,-79.708545,0,'2013-07-06 12:44:31',NULL,NULL),(22526,'24095','S','Goodview','D','Bedford','51019','Virginia','VA','51','4640','540','Eastern',-5.0,'Y',37.222194,-79.758294,0,'2013-07-06 12:44:31',NULL,NULL),(20433,'20916','P','Silver Spring','D','Montgomery','24031','Maryland','MD','24','8840','301/240/227','Eastern',-5.0,'Y',39.084115,-77.079333,0,'2013-07-06 12:44:31',NULL,NULL),(43549,'48707','P','Bay City','D','Bay','26017','Michigan','MI','26','6960','989','Eastern',-5.0,'Y',43.529416,-83.841192,0,'2013-07-06 12:44:32',NULL,NULL),(45481,'51343','S','Greenville','D','Clay','19041','Iowa','IA','19','0000','712','Central',-6.0,'Y',43.041318,-95.032585,0,'2013-07-06 12:44:32',NULL,NULL),(46060,'52574','S','Mystic','D','Appanoose','19007','Iowa','IA','19','0000','641','Central',-6.0,'Y',40.796400,-92.928720,0,'2013-07-06 12:44:32',NULL,NULL),(47293,'54546','S','Cayuga','N','Ashland','55003','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',46.324004,-90.656945,0,'2013-07-06 12:44:32',NULL,NULL),(48468,'55719','S','Balkan','N','Saint Louis','27137','Minnesota','MN','27','2240','218','Central',-6.0,'Y',47.519753,-92.880286,0,'2013-07-06 12:44:33',NULL,NULL),(53361,'61764','S','Swygert','N','Livingston','17105','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',40.881129,-88.634278,0,'2013-07-06 12:44:33',NULL,NULL),(58019,'67901','S','Liberal','D','Seward','20175','Kansas','KS','20','0000','620','Central',-6.0,'Y',37.041883,-100.928884,0,'2013-07-06 12:44:33',NULL,NULL),(79531,'98941','P','Roslyn','D','Kittitas','53037','Washington','WA','53','0000','509','Pacific',-8.0,'Y',47.221722,-120.993619,0,'2013-07-06 12:44:34',NULL,NULL),(70006,'84124','S','Salt Lake Cty','A','Salt Lake','49035','Utah','UT','49','7160','801/385','Mountain',-7.0,'Y',40.685813,-111.829118,0,'2013-07-06 12:44:34',NULL,NULL),(41657,'47143','S','Memphis','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.471919,-85.766289,0,'2013-07-06 12:44:32',NULL,NULL),(39077,'44215','S','Chippewa on the Lake','N','Medina','39103','Ohio','OH','39','1680','330/234','Eastern',-5.0,'Y',41.068001,-81.904211,0,'2013-07-06 12:44:32',NULL,NULL),(11257,'11766','S','Mt Sinai','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.931723,-73.012963,0,'2013-07-06 12:44:30',NULL,NULL),(18172,'18917','S','Dublin','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.373703,-75.200962,0,'2013-07-06 12:44:31',NULL,NULL),(35358,'39440','S','Pine Belt Reg','N','Jones','28067','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',31.710480,-89.102340,0,'2013-07-06 12:44:32',NULL,NULL),(22949,'24649','S','Lynn Spring','N','Russell','51167','Virginia','VA','51','0000','276','Eastern',-5.0,'Y',37.081098,-81.917929,0,'2013-07-06 12:44:31',NULL,NULL),(24921,'27806','S','Aurora','D','Beaufort','37013','North Carolina','NC','37','0000','252','Eastern',-5.0,'Y',35.301628,-76.789234,0,'2013-07-06 12:44:31',NULL,NULL),(28362,'31208','P','Macon','D','Bibb','13021','Georgia','GA','13','4680','478','Eastern',-5.0,'Y',32.831183,-83.639930,0,'2013-07-06 12:44:32',NULL,NULL),(73391,'91110','U','Pasadena','D','Los Angeles','06037','California','CA','06','4480','626','Pacific',-8.0,'Y',34.155939,-118.154292,0,'2013-07-06 12:44:34',NULL,NULL),(70466,'84757','S','New Harmony','D','Washington','49053','Utah','UT','49','0000','435','Mountain',-7.0,'Y',37.487664,-113.312512,0,'2013-07-06 12:44:34',NULL,NULL),(57514,'66963','S','Randall','D','Jewell','20089','Kansas','KS','20','0000','785','Central',-6.0,'Y',39.610152,-98.100119,0,'2013-07-06 12:44:33',NULL,NULL),(51458,'59501','S','Havre','D','Hill','30041','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.544915,-109.682429,0,'2013-07-06 12:44:33',NULL,NULL),(44091,'49460','S','West Olive','D','Ottawa','26139','Michigan','MI','26','3000','616','Eastern',-5.0,'Y',42.928020,-86.108640,0,'2013-07-06 12:44:32',NULL,NULL),(3248,'01434','S','Devens','D','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.560949,-71.576624,0,'2013-07-06 12:44:30',NULL,NULL),(16853,'17563','S','Eldora','N','Lancaster','42071','Pennsylvania','PA','42','4000','717','Eastern',-5.0,'Y',39.766461,-76.182262,0,'2013-07-06 12:44:31',NULL,NULL),(25407,'28289','U','Charlotte','D','Mecklenburg','37119','North Carolina','NC','37','1520','704/980','Eastern',-5.0,'Y',35.225894,-80.841681,0,'2013-07-06 12:44:31',NULL,NULL),(16400,'17221','S','Boggstown','N','Franklin','42055','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.064497,-77.824260,0,'2013-07-06 12:44:31',NULL,NULL),(34368,'38610','S','Bluff','N','Tippah','28139','Mississippi','MS','28','0000','662','Central',-6.0,'Y',34.670141,-89.019896,0,'2013-07-06 12:44:32',NULL,NULL),(9300,'09710','M','DPO','D','none','00000','Armed Forces - Europe/Africa/Canada','AE','00','0000','000','None',0.0,'N',0.000000,0.000000,0,'2013-07-06 12:44:30',NULL,NULL),(77086,'96134','S','Medicine Lake Lodge','N','Siskiyou','06093','California','CA','06','0000','530','Pacific',-8.0,'Y',41.949725,-121.472495,0,'2013-07-06 12:44:34',NULL,NULL),(71457,'87048','S','Corrales','D','Sandoval','35043','New Mexico','NM','35','0200','505','Mountain',-7.0,'Y',35.235304,-106.619422,0,'2013-07-06 12:44:34',NULL,NULL),(70632,'85140','S','San Tan Vly','A','Pinal','04021','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.236620,-111.543690,0,'2013-07-06 12:44:34',NULL,NULL),(64446,'76569','S','Red Ranger','N','Bell','48027','Texas','TX','48','3810','254','Central',-6.0,'Y',30.926330,-97.230983,0,'2013-07-06 12:44:34',NULL,NULL),(35496,'39529','U','Mississippi Test Facility','N','Hancock','28045','Mississippi','MS','28','0920','228','Central',-6.0,'Y',30.337636,-89.504580,0,'2013-07-06 12:44:32',NULL,NULL),(33652,'37710','S','Briceville','D','Anderson','47001','Tennessee','TN','47','3840','865','Eastern',-5.0,'Y',36.172200,-84.231480,0,'2013-07-06 12:44:32',NULL,NULL),(33367,'37204','S','Berry Hill','A','Davidson','47037','Tennessee','TN','47','5360','615','Central',-6.0,'Y',36.108754,-86.780579,0,'2013-07-06 12:44:32',NULL,NULL),(32160,'35473','S','Nport','N','Tuscaloosa','01125','Alabama','AL','01','8600','205/659','Central',-6.0,'Y',33.228904,-87.577424,0,'2013-07-06 12:44:32',NULL,NULL),(32022,'35238','P','Bham','N','Shelby','01117','Alabama','AL','01','1000','205/659','Central',-6.0,'Y',33.518088,-86.802297,0,'2013-07-06 12:44:32',NULL,NULL),(39189,'44320','S','Maple Valley','N','Summit','39153','Ohio','OH','39','0080','330/234','Eastern',-5.0,'Y',41.081335,-81.573558,0,'2013-07-06 12:44:32',NULL,NULL),(27494,'30168','S','Austell','D','Cobb','13067','Georgia','GA','13','0520','770/678/470','Eastern',-5.0,'Y',33.779077,-84.570132,0,'2013-07-06 12:44:31',NULL,NULL),(19545,'20195','P','Reston','D','Fairfax','51059','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.948887,-77.326781,0,'2013-07-06 12:44:31',NULL,NULL),(3244,'01432','S','Devens','N','Middlesex','25017','Massachusetts','MA','25','1120','978/351','Eastern',-5.0,'Y',42.559756,-71.575320,0,'2013-07-06 12:44:30',NULL,NULL),(1493,'00751','S','Jard de Salinas','N','Salinas','72123','Puerto Rico','PR','72','0000','787/939','Atlantic',-4.0,'N',17.988778,-66.287538,0,'2013-07-06 12:44:30',NULL,NULL),(9428,'10003','S','New York City','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.732373,-73.989477,0,'2013-07-06 12:44:30',NULL,NULL),(75497,'94131','S','San Francisco','D','San Francisco','06075','California','CA','06','7360','415','Pacific',-8.0,'Y',37.740516,-122.439028,0,'2013-07-06 12:44:34',NULL,NULL),(69310,'83460','U','Rexburg','D','Madison','16065','Idaho','ID','16','0000','208','Mountain',-7.0,'Y',43.818343,-111.782192,0,'2013-07-06 12:44:34',NULL,NULL),(13138,'13501','S','Utica','D','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.084370,-75.234461,0,'2013-07-06 12:44:30',NULL,NULL),(10414,'10706','S','Hastings Hudson','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.970520,-73.875300,0,'2013-07-06 12:44:30',NULL,NULL),(79347,'98629','S','La Center','D','Clark','53011','Washington','WA','53','6440','360/564','Pacific',-8.0,'Y',45.863687,-122.667532,0,'2013-07-06 12:44:34',NULL,NULL),(67719,'80537','S','Loveland','D','Larimer','08069','Colorado','CO','08','2670','970','Mountain',-7.0,'Y',40.388634,-105.105597,0,'2013-07-06 12:44:34',NULL,NULL),(62847,'75020','S','Denison','D','Grayson','48181','Texas','TX','48','7640','903/430','Central',-6.0,'Y',33.750177,-96.559463,0,'2013-07-06 12:44:33',NULL,NULL),(5133,'04413','S','Forest City Twp','A','Washington','23029','Maine','ME','23','0000','207','Eastern',-5.0,'Y',45.579310,-67.727269,0,'2013-07-06 12:44:30',NULL,NULL),(30047,'33144','S','Sweetwater','N','Miami-Dade','12086','Florida','FL','12','5000','305/786','Eastern',-5.0,'Y',25.763251,-80.313357,0,'2013-07-06 12:44:32',NULL,NULL),(5028,'04252','S','Lisbon Falls','D','Androscoggin','23001','Maine','ME','23','4240','207','Eastern',-5.0,'Y',44.007098,-70.061746,0,'2013-07-06 12:44:30',NULL,NULL),(27527,'30217','S','Centralhatchee','A','Heard','13149','Georgia','GA','13','0000','706/762','Eastern',-5.0,'Y',33.308377,-85.109975,0,'2013-07-06 12:44:31',NULL,NULL),(3005,'01075','S','So Hadley','N','Hampshire','25015','Massachusetts','MA','25','8000','413','Eastern',-5.0,'Y',42.253320,-72.579900,0,'2013-07-06 12:44:30',NULL,NULL),(49514,'56671','P','Redlake','D','Beltrami','27007','Minnesota','MN','27','0000','218','Central',-6.0,'Y',47.850830,-95.060653,0,'2013-07-06 12:44:33',NULL,NULL),(79836,'99522','P','Anchorage','D','Anchorage','02020','Alaska','AK','02','0380','907','Alaska',-9.0,'Y',61.153899,-149.919928,0,'2013-07-06 12:44:34',NULL,NULL),(67392,'80123','S','Littleton','D','Jefferson','08059','Colorado','CO','08','2080','303/720','Mountain',-7.0,'Y',39.595296,-105.087860,0,'2013-07-06 12:44:34',NULL,NULL),(61944,'73162','S','Oklahoma City','D','Oklahoma','40109','Oklahoma','OK','40','5880','405','Central',-6.0,'Y',35.579721,-97.641491,0,'2013-07-06 12:44:33',NULL,NULL),(47043,'54410','S','Arpin','D','Wood','55141','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.542991,-90.047517,0,'2013-07-06 12:44:32',NULL,NULL),(23686,'25848','S','Glen Rogers','D','Wyoming','54109','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',37.732688,-81.441177,0,'2013-07-06 12:44:31',NULL,NULL),(24419,'27150','U','Wachovia Bank','N','Forsyth','37067','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.103682,-80.207720,0,'2013-07-06 12:44:31',NULL,NULL),(40950,'46304','S','Chesterton','D','Porter','18127','Indiana','IN','18','2960','219','Central',-6.0,'Y',41.617037,-87.028793,0,'2013-07-06 12:44:32',NULL,NULL),(79767,'99326','S','Connell','D','Franklin','53021','Washington','WA','53','6740','509','Pacific',-8.0,'Y',46.663073,-118.916642,0,'2013-07-06 12:44:34',NULL,NULL),(63473,'75686','S','Matinburg','N','Camp','48063','Texas','TX','48','0000','903/430','Central',-6.0,'Y',32.997204,-94.967696,0,'2013-07-06 12:44:33',NULL,NULL),(55241,'63445','S','Kahoka','D','Clark','29045','Missouri','MO','29','0000','660','Central',-6.0,'Y',40.434444,-91.775833,0,'2013-07-06 12:44:33',NULL,NULL),(36915,'41143','S','Grayson','D','Carter','21043','Kentucky','KY','21','3400','606','Eastern',-5.0,'Y',38.329825,-82.936538,0,'2013-07-06 12:44:32',NULL,NULL),(12686,'13134','P','Smithfield','N','Madison','36053','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.968836,-75.687569,0,'2013-07-06 12:44:30',NULL,NULL),(27015,'29643','S','Fair Play','D','Oconee','45073','South Carolina','SC','45','0000','864','Eastern',-5.0,'Y',34.524647,-83.042855,0,'2013-07-06 12:44:31',NULL,NULL),(7860,'07495','S','Mahwah','D','Bergen','34003','New Jersey','NJ','34','0875','201/551','Eastern',-5.0,'Y',41.081134,-74.186657,0,'2013-07-06 12:44:30',NULL,NULL),(43513,'48636','S','Luzerne','D','Oscoda','26135','Michigan','MI','26','0000','989','Eastern',-5.0,'Y',44.637482,-84.252637,0,'2013-07-06 12:44:32',NULL,NULL),(47060,'54421','S','Colby','D','Clark','55019','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',44.912425,-90.319914,0,'2013-07-06 12:44:32',NULL,NULL),(52441,'60661','S','Chicago','D','Cook','17031','Illinois','IL','17','1600','312/872','Central',-6.0,'Y',41.883434,-87.640507,0,'2013-07-06 12:44:33',NULL,NULL),(52977,'61430','S','East Galesburg','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',40.948243,-90.312728,0,'2013-07-06 12:44:33',NULL,NULL),(54996,'63129','S','Saint Louis','D','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.464400,-90.332031,0,'2013-07-06 12:44:33',NULL,NULL),(325,'00650','S','Est de Arroyo','N','Florida','72054','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.362641,-66.565388,0,'2013-07-06 12:44:30',NULL,NULL),(74781,'93117','S','Gaviota','A','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.437147,-119.866076,0,'2013-07-06 12:44:34',NULL,NULL),(67079,'79603','S','Impact','N','Taylor','48441','Texas','TX','48','0040','325','Central',-6.0,'Y',32.470693,-99.765045,0,'2013-07-06 12:44:34',NULL,NULL),(40151,'45350','P','N Star','N','Darke','39037','Ohio','OH','39','0000','419/567','Eastern',-5.0,'Y',40.326656,-84.567991,0,'2013-07-06 12:44:32',NULL,NULL),(32543,'36108','S','Montgomery','D','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.350670,-86.361835,0,'2013-07-06 12:44:32',NULL,NULL),(35243,'39335','S','Lauderdale','D','Lauderdale','28075','Mississippi','MS','28','0000','601/769','Central',-6.0,'Y',32.529660,-88.478520,0,'2013-07-06 12:44:32',NULL,NULL),(4377,'03084','S','Temple','D','Hillsborough','33011','New Hampshire','NH','33','5350','603','Eastern',-5.0,'Y',42.823542,-71.845359,0,'2013-07-06 12:44:30',NULL,NULL),(77855,'97229','S','Cedar Mill','N','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.540884,-122.829980,0,'2013-07-06 12:44:34',NULL,NULL),(53446,'61880','S','Tolono','D','Champaign','17019','Illinois','IL','17','1400','217','Central',-6.0,'Y',39.986321,-88.263536,0,'2013-07-06 12:44:33',NULL,NULL),(44454,'49872','P','Perkins','D','Delta','26041','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',45.997357,-87.092569,0,'2013-07-06 12:44:32',NULL,NULL),(4518,'03303','S','Concord','D','Merrimack','33013','New Hampshire','NH','33','4760','603','Eastern',-5.0,'Y',43.303680,-71.638500,0,'2013-07-06 12:44:30',NULL,NULL),(4450,'03249','S','Gilford','D','Belknap','33001','New Hampshire','NH','33','0000','603','Eastern',-5.0,'Y',43.546583,-71.404039,0,'2013-07-06 12:44:30',NULL,NULL),(32557,'36113','S','Mtgy','N','Montgomery','01101','Alabama','AL','01','5240','334','Central',-6.0,'Y',32.382900,-86.304300,0,'2013-07-06 12:44:32',NULL,NULL),(1521,'00754','S','Urb Los Caminos','N','San Lorenzo','72129','Puerto Rico','PR','72','1310','787/939','Atlantic',-4.0,'N',18.188518,-65.958889,0,'2013-07-06 12:44:30',NULL,NULL),(12912,'13338','S','Otter Lake','N','Oneida','36065','New York','NY','36','8680','315','Eastern',-5.0,'Y',43.442960,-75.207302,0,'2013-07-06 12:44:30',NULL,NULL),(23125,'24966','S','Auto','A','Greenbrier','54025','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.065844,-80.376621,0,'2013-07-06 12:44:31',NULL,NULL),(6605,'05871','S','Burke','N','Caledonia','50005','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.616667,-71.933333,0,'2013-07-06 12:44:30',NULL,NULL),(41088,'46537','P','Lapaz','D','Marshall','18099','Indiana','IN','18','0000','574','Eastern',-5.0,'Y',41.457406,-86.305414,0,'2013-07-06 12:44:32',NULL,NULL),(41634,'47131','P','Jeffersonville','D','Clark','18019','Indiana','IN','18','4520','812','Eastern',-5.0,'Y',38.338659,-85.705189,0,'2013-07-06 12:44:32',NULL,NULL),(41918,'47380','S','Deerfield','N','Randolph','18135','Indiana','IN','18','0000','765','Eastern',-5.0,'Y',40.292380,-85.028052,0,'2013-07-06 12:44:32',NULL,NULL),(43041,'48177','P','Samaria','D','Monroe','26115','Michigan','MI','26','2160','734','Eastern',-5.0,'Y',41.811359,-83.576606,0,'2013-07-06 12:44:32',NULL,NULL),(14012,'14532','S','Phelps','D','Ontario','36069','New York','NY','36','6840','315','Eastern',-5.0,'Y',42.967137,-77.044133,0,'2013-07-06 12:44:31',NULL,NULL),(70864,'85603','S','Bisbee','D','Cochise','04003','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.458840,-109.945800,0,'2013-07-06 12:44:34',NULL,NULL),(63630,'75838','S','Donie','D','Freestone','48161','Texas','TX','48','0000','254','Central',-6.0,'Y',31.479552,-96.251191,0,'2013-07-06 12:44:34',NULL,NULL),(13896,'14272','U','Silhouette Books','N','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',42.872268,-78.870254,0,'2013-07-06 12:44:31',NULL,NULL),(32310,'35756','S','Madison','D','Limestone','01083','Alabama','AL','01','3440','256','Central',-6.0,'Y',34.581973,-86.822646,0,'2013-07-06 12:44:32',NULL,NULL),(3970,'02493','S','Silver Hill','N','Middlesex','25017','Massachusetts','MA','25','1120','781/339','Eastern',-5.0,'Y',42.365885,-71.301028,0,'2013-07-06 12:44:30',NULL,NULL),(21437,'22570','P','Village','D','Richmond','51159','Virginia','VA','51','6760','804','Eastern',-5.0,'Y',37.948402,-76.604617,0,'2013-07-06 12:44:31',NULL,NULL),(22081,'23389','P','Harborton','D','Accomack','51001','Virginia','VA','51','0000','757','Eastern',-5.0,'Y',37.637659,-75.746119,0,'2013-07-06 12:44:31',NULL,NULL),(46135,'52650','S','Sperry','D','Des Moines','19057','Iowa','IA','19','0000','319','Central',-6.0,'Y',40.943056,-91.180556,0,'2013-07-06 12:44:32',NULL,NULL),(65523,'77713','S','Beaumont','D','Jefferson','48245','Texas','TX','48','0840','409','Central',-6.0,'Y',30.146443,-94.222869,0,'2013-07-06 12:44:34',NULL,NULL),(64635,'76706','S','Waco','D','McLennan','48309','Texas','TX','48','8800','254','Central',-6.0,'Y',31.480320,-97.115880,0,'2013-07-06 12:44:34',NULL,NULL),(60402,'71638','S','Baxter','N','Chicot','05017','Arkansas','AR','05','0000','870','Central',-6.0,'Y',33.525724,-91.435385,0,'2013-07-06 12:44:33',NULL,NULL),(58870,'69154','S','Oshkosh','D','Garden','31069','Nebraska','NE','31','0000','308','Mountain',-7.0,'Y',41.408280,-102.349472,0,'2013-07-06 12:44:33',NULL,NULL),(57522,'67002','S','Andover','D','Butler','20015','Kansas','KS','20','9040','316','Central',-6.0,'Y',37.700039,-97.138310,0,'2013-07-06 12:44:33',NULL,NULL),(47251,'54520','S','Nashville','N','Forest','55041','Wisconsin','WI','55','0000','715','Central',-6.0,'Y',45.568279,-88.904809,0,'2013-07-06 12:44:32',NULL,NULL),(49521,'56673','S','Arnesen','N','Roseau','27135','Minnesota','MN','27','0000','218','Central',-6.0,'Y',48.779677,-95.251697,0,'2013-07-06 12:44:33',NULL,NULL),(52237,'60505','S','Aurora','D','Kane','17089','Illinois','IL','17','1600','630/331','Central',-6.0,'Y',41.758169,-88.297124,0,'2013-07-06 12:44:33',NULL,NULL),(10784,'11367','S','Queens','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.728160,-73.818582,0,'2013-07-06 12:44:30',NULL,NULL),(19804,'20440','U','Washington','D','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.914558,-77.044465,0,'2013-07-06 12:44:31',NULL,NULL),(19983,'20598','U','Herndon','A','Loudoun','51107','Virginia','VA','51','8840','202','Eastern',-5.0,'Y',38.916815,-77.056474,0,'2013-07-06 12:44:31',NULL,NULL),(7273,'06524','S','Bethany','D','New Haven','09009','Connecticut','CT','09','5480','203/475','Eastern',-5.0,'Y',41.412767,-72.992792,0,'2013-07-06 12:44:30',NULL,NULL),(7170,'06447','S','Marlboro','N','Hartford','09003','Connecticut','CT','09','3280','860/959','Eastern',-5.0,'Y',41.641101,-72.458069,0,'2013-07-06 12:44:30',NULL,NULL),(14164,'14729','S','East Otto','D','Cattaraugus','36009','New York','NY','36','0000','716','Eastern',-5.0,'Y',42.409324,-78.725794,0,'2013-07-06 12:44:31',NULL,NULL),(79867,'99561','P','Chefornak','D','Bethel','02050','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',60.155325,-164.196627,0,'2013-07-06 12:44:34',NULL,NULL),(74765,'93105','S','Santa Barbara','D','Santa Barbara','06083','California','CA','06','7480','805','Pacific',-8.0,'Y',34.446863,-119.741263,0,'2013-07-06 12:44:34',NULL,NULL),(64373,'76528','S','Gatesville','D','Coryell','48099','Texas','TX','48','3810','254','Central',-6.0,'Y',31.432575,-97.740289,0,'2013-07-06 12:44:34',NULL,NULL),(59150,'70182','P','New Orleans','D','Orleans','22071','Louisiana','LA','22','5560','504','Central',-6.0,'Y',30.011522,-90.062783,0,'2013-07-06 12:44:33',NULL,NULL),(50515,'58076','U','Wahpeton','D','Richland','38077','North Dakota','ND','38','0000','701','Central',-6.0,'Y',46.268399,-96.607702,0,'2013-07-06 12:44:33',NULL,NULL),(2366,'00949','S','Mans del Sur','N','Toa Baja','72137','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.452196,-66.178341,0,'2013-07-06 12:44:30',NULL,NULL),(6632,'05906','S','Lunenburg','D','Essex','50009','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.429167,-71.679722,0,'2013-07-06 12:44:30',NULL,NULL),(10336,'10551','P','Mt Vernon','N','Westchester','36119','New York','NY','36','5600','914','Eastern',-5.0,'Y',40.901727,-73.823937,0,'2013-07-06 12:44:30',NULL,NULL),(39054,'44193','U','National City Bank','N','Cuyahoga','39035','Ohio','OH','39','1680','216','Eastern',-5.0,'Y',41.502884,-81.695421,0,'2013-07-06 12:44:32',NULL,NULL),(12088,'12566','S','Pine Bush','D','Orange','36071','New York','NY','36','5660','845','Eastern',-5.0,'Y',41.605775,-74.305189,0,'2013-07-06 12:44:30',NULL,NULL),(10950,'11439','U','Saint John University','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.722867,-73.788363,0,'2013-07-06 12:44:30',NULL,NULL),(74004,'92111','S','San Diego','D','San Diego','06073','California','CA','06','7320','858','Pacific',-8.0,'Y',32.800458,-117.171574,0,'2013-07-06 12:44:34',NULL,NULL),(72078,'88133','S','Saint Vrain','D','Curry','35009','New Mexico','NM','35','0000','575','Mountain',-7.0,'Y',34.485021,-103.456802,0,'2013-07-06 12:44:34',NULL,NULL),(65862,'78211','S','San Antonio','D','Bexar','48029','Texas','TX','48','7240','210','Central',-6.0,'Y',29.357305,-98.559866,0,'2013-07-06 12:44:34',NULL,NULL),(44479,'49903','P','Amasa','D','Iron','26071','Michigan','MI','26','0000','906','Central',-6.0,'Y',46.237996,-88.441150,0,'2013-07-06 12:44:32',NULL,NULL),(39758,'45112','P','Chilo','D','Clermont','39025','Ohio','OH','39','1640','937','Eastern',-5.0,'Y',38.793094,-84.139751,0,'2013-07-06 12:44:32',NULL,NULL),(37155,'41465','S','Stella','A','Magoffin','21153','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.755467,-83.046508,0,'2013-07-06 12:44:32',NULL,NULL),(8894,'08731','S','Forked River','D','Ocean','34029','New Jersey','NJ','34','5190','609','Eastern',-5.0,'Y',39.871860,-74.237760,0,'2013-07-06 12:44:30',NULL,NULL),(71633,'87412','S','Gobernador','N','San Juan','35045','New Mexico','NM','35','0000','505','Mountain',-7.0,'Y',36.777110,-107.736433,0,'2013-07-06 12:44:34',NULL,NULL),(71099,'85938','S','Springerville','D','Apache','04001','Arizona','AZ','04','0000','928','Mountain',-7.0,'N',34.132976,-109.279764,0,'2013-07-06 12:44:34',NULL,NULL),(54966,'63121','S','Northwoods','N','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.703607,-90.298850,0,'2013-07-06 12:44:33',NULL,NULL),(50213,'57579','S','White River','D','Mellette','46095','South Dakota','SD','46','0000','605','Mountain',-7.0,'Y',43.564463,-100.748538,0,'2013-07-06 12:44:33',NULL,NULL),(42265,'47581','S','Halbert','N','Martin','18101','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',38.750000,-86.766667,0,'2013-07-06 12:44:32',NULL,NULL),(40815,'46202','S','Indianapolis','D','Marion','18097','Indiana','IN','18','3480','317','Eastern',-5.0,'Y',39.789789,-86.159462,0,'2013-07-06 12:44:32',NULL,NULL),(13462,'13783','S','French Woods','N','Delaware','36025','New York','NY','36','0000','607','Eastern',-5.0,'Y',41.945880,-75.238860,0,'2013-07-06 12:44:31',NULL,NULL),(34533,'38686','U','Sacred Heart League','N','DeSoto','28033','Mississippi','MS','28','4920','662','Central',-6.0,'Y',34.956644,-90.152037,0,'2013-07-06 12:44:32',NULL,NULL),(12177,'12763','S','Mountain Dale','D','Sullivan','36105','New York','NY','36','0000','845','Eastern',-5.0,'Y',41.691362,-74.525101,0,'2013-07-06 12:44:30',NULL,NULL),(77009,'96087','P','Shasta','D','Shasta','06089','California','CA','06','6690','530','Pacific',-8.0,'Y',40.598045,-122.489673,0,'2013-07-06 12:44:34',NULL,NULL),(66164,'78520','S','Boca Chica','N','Cameron','48061','Texas','TX','48','1240','956','Central',-6.0,'Y',25.981740,-97.535340,0,'2013-07-06 12:44:34',NULL,NULL),(56399,'65243','S','Rucker','N','Randolph','29175','Missouri','MO','29','0000','573','Central',-6.0,'Y',39.211871,-92.388655,0,'2013-07-06 12:44:33',NULL,NULL),(13411,'13754','S','Deposit','D','Broome','36007','New York','NY','36','0960','607','Eastern',-5.0,'Y',42.063900,-75.449220,0,'2013-07-06 12:44:31',NULL,NULL),(32242,'35594','S','Winfield','D','Marion','01093','Alabama','AL','01','0000','205/659','Central',-6.0,'Y',33.923348,-87.814573,0,'2013-07-06 12:44:32',NULL,NULL),(24077,'26447','S','Walkersville','D','Lewis','54041','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.848407,-80.503889,0,'2013-07-06 12:44:31',NULL,NULL),(22759,'24426','S','Jordan Mines','A','Covington City','51580','Virginia','VA','51','0000','540','Eastern',-5.0,'Y',37.751640,-80.045760,0,'2013-07-06 12:44:31',NULL,NULL),(22249,'23665','S','Langley AFB','A','York','51199','Virginia','VA','51','5720','757','Eastern',-5.0,'Y',37.080265,-76.373645,0,'2013-07-06 12:44:31',NULL,NULL),(11660,'12137','S','Pattersonvle','A','Schenectady','36093','New York','NY','36','0160','518','Eastern',-5.0,'Y',42.855720,-74.127900,0,'2013-07-06 12:44:30',NULL,NULL),(11150,'11717','S','Pine Air','N','Suffolk','36103','New York','NY','36','5380','631','Eastern',-5.0,'Y',40.780920,-73.254540,0,'2013-07-06 12:44:30',NULL,NULL),(7336,'06710','S','Wtby','N','New Haven','09009','Connecticut','CT','09','8880','203/475','Eastern',-5.0,'Y',41.568003,-73.045373,0,'2013-07-06 12:44:30',NULL,NULL),(10750,'11360','S','Bay Terrace','N','Queens','36081','New York','NY','36','5600','718/347','Eastern',-5.0,'Y',40.776438,-73.780380,0,'2013-07-06 12:44:30',NULL,NULL),(64258,'76379','S','Scotland','D','Archer','48009','Texas','TX','48','9080','940','Central',-6.0,'Y',33.654963,-98.467222,0,'2013-07-06 12:44:34',NULL,NULL),(62602,'74523','S','Antlers','D','Pushmataha','40127','Oklahoma','OK','40','0000','580','Central',-6.0,'Y',34.232845,-95.618454,0,'2013-07-06 12:44:33',NULL,NULL),(16278,'17099','S','Yeagertwn','N','Mifflin','42087','Pennsylvania','PA','42','0000','717','Eastern',-5.0,'Y',40.640569,-77.579797,0,'2013-07-06 12:44:31',NULL,NULL),(13667,'14032','S','Clarence Center','D','Erie','36029','New York','NY','36','1280','716','Eastern',-5.0,'Y',43.045445,-78.631521,0,'2013-07-06 12:44:31',NULL,NULL),(19344,'20041','P','Dulles International Airp','N','District of Columbia','11001','District of Columbia','DC','11','8840','202','Eastern',-5.0,'Y',38.834503,-77.210807,0,'2013-07-06 12:44:31',NULL,NULL),(53020,'61467','S','Oneida','D','Knox','17095','Illinois','IL','17','0000','309','Central',-6.0,'Y',41.074033,-90.227297,0,'2013-07-06 12:44:33',NULL,NULL),(60821,'72033','P','Conway','D','Faulkner','05045','Arkansas','AR','05','4400','501','Central',-6.0,'Y',35.082476,-92.375090,0,'2013-07-06 12:44:33',NULL,NULL),(74367,'92423','P','San Bernardino','D','San Bernardino','06071','California','CA','06','6780','909','Pacific',-8.0,'Y',34.107116,-117.292358,0,'2013-07-06 12:44:34',NULL,NULL),(18124,'18817','S','East Smithfield','D','Bradford','42015','Pennsylvania','PA','42','0000','570','Eastern',-5.0,'Y',41.861211,-76.614065,0,'2013-07-06 12:44:31',NULL,NULL),(41091,'46540','S','Middlebury','D','Elkhart','18039','Indiana','IN','18','2330','574','Eastern',-5.0,'Y',41.676613,-85.704764,0,'2013-07-06 12:44:32',NULL,NULL),(44432,'49849','S','Ishpeming','D','Marquette','26103','Michigan','MI','26','0000','906','Eastern',-5.0,'Y',46.495200,-87.725580,0,'2013-07-06 12:44:32',NULL,NULL),(77812,'97144','S','Timber','D','Washington','41067','Oregon','OR','41','6440','503/971','Pacific',-8.0,'Y',45.729286,-123.322577,0,'2013-07-06 12:44:34',NULL,NULL),(70933,'85637','S','Greaterville','N','Santa Cruz','04023','Arizona','AZ','04','0000','520','Mountain',-7.0,'N',31.622239,-110.706222,0,'2013-07-06 12:44:34',NULL,NULL),(70726,'85296','S','Gilbert','D','Maricopa','04013','Arizona','AZ','04','6200','480','Mountain',-7.0,'N',33.313543,-111.772549,0,'2013-07-06 12:44:34',NULL,NULL),(49928,'57324','S','Cavour','D','Beadle','46005','South Dakota','SD','46','0000','605','Central',-6.0,'Y',44.367668,-98.036362,0,'2013-07-06 12:44:33',NULL,NULL),(47890,'55106','S','Maplewood','N','Ramsey','27123','Minnesota','MN','27','5120','651','Central',-6.0,'Y',44.957208,-93.052916,0,'2013-07-06 12:44:33',NULL,NULL),(37256,'41562','S','Greasy Creek','N','Pike','21195','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',37.393260,-82.471200,0,'2013-07-06 12:44:32',NULL,NULL),(58190,'68313','S','Beaver Crossing','D','Seward','31159','Nebraska','NE','31','0000','402','Central',-6.0,'Y',40.780014,-97.268905,0,'2013-07-06 12:44:33',NULL,NULL),(68793,'82411','S','Burlington','D','Big Horn','56003','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.433274,-108.429369,0,'2013-07-06 12:44:34',NULL,NULL),(79523,'98937','S','Naches','D','Yakima','53077','Washington','WA','53','9260','509','Pacific',-8.0,'Y',46.770010,-120.784651,0,'2013-07-06 12:44:34',NULL,NULL),(72908,'90023','S','Lugo','N','Los Angeles','06037','California','CA','06','4480','323','Pacific',-8.0,'Y',34.025925,-118.200657,0,'2013-07-06 12:44:34',NULL,NULL),(72747,'89509','S','Reno','D','Washoe','32031','Nevada','NV','32','6720','775','Pacific',-8.0,'Y',39.477902,-119.897581,0,'2013-07-06 12:44:34',NULL,NULL),(71961,'88003','P','University Park','N','Dona Ana','35013','New Mexico','NM','35','4100','575','Mountain',-7.0,'Y',32.279674,-106.759683,0,'2013-07-06 12:44:34',NULL,NULL),(68886,'82714','S','Devils Tower','D','Crook','56011','Wyoming','WY','56','0000','307','Mountain',-7.0,'Y',44.642126,-104.845991,0,'2013-07-06 12:44:34',NULL,NULL),(2199,'00926','S','Paseo San Juan','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.379249,-66.060219,0,'2013-07-06 12:44:30',NULL,NULL),(60394,'71613','P','Pine Bluff','D','Jefferson','05069','Arkansas','AR','05','6240','870','Central',-6.0,'Y',34.140197,-92.107180,0,'2013-07-06 12:44:33',NULL,NULL),(24529,'27288','S','Spray','N','Rockingham','37157','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.483720,-79.791360,0,'2013-07-06 12:44:31',NULL,NULL),(24563,'27301','S','McLeansville','N','Guilford','37081','North Carolina','NC','37','3120','336','Eastern',-5.0,'Y',36.113388,-79.673916,0,'2013-07-06 12:44:31',NULL,NULL),(26088,'28711','S','Black Mountain','D','Buncombe','37021','North Carolina','NC','37','0480','828','Eastern',-5.0,'Y',35.607610,-82.312275,0,'2013-07-06 12:44:31',NULL,NULL),(27087,'29708','S','Ft Mill','N','York','45091','South Carolina','SC','45','1520','803','Eastern',-5.0,'Y',35.006322,-80.942526,0,'2013-07-06 12:44:31',NULL,NULL),(34934,'39041','S','Bolton','D','Hinds','28049','Mississippi','MS','28','3560','601/769','Central',-6.0,'Y',32.369187,-90.454684,0,'2013-07-06 12:44:32',NULL,NULL),(39432,'44683','S','Riverside Park','N','Tuscarawas','39157','Ohio','OH','39','0000','740','Eastern',-5.0,'Y',40.392715,-81.347949,0,'2013-07-06 12:44:32',NULL,NULL),(38032,'43026','S','Hilliard','D','Franklin','39049','Ohio','OH','39','1840','614/380','Eastern',-5.0,'Y',40.032483,-83.135808,0,'2013-07-06 12:44:32',NULL,NULL),(8577,'08215','S','Lower Bank','N','Atlantic','34001','New Jersey','NJ','34','0560','609','Eastern',-5.0,'Y',39.527280,-74.606700,0,'2013-07-06 12:44:30',NULL,NULL),(9410,'10001','S','Greeley Square','N','New York','36061','New York','NY','36','5600','212/646/917','Eastern',-5.0,'Y',40.752050,-73.994517,0,'2013-07-06 12:44:30',NULL,NULL),(24371,'27053','S','Westfield','D','Surry','37171','North Carolina','NC','37','0000','336','Eastern',-5.0,'Y',36.434671,-80.321082,0,'2013-07-06 12:44:31',NULL,NULL),(68200,'81039','S','Fowler','D','Otero','08089','Colorado','CO','08','0000','719','Mountain',-7.0,'Y',38.123114,-104.018939,0,'2013-07-06 12:44:34',NULL,NULL),(65572,'77856','S','Franklin','D','Robertson','48395','Texas','TX','48','0000','979','Central',-6.0,'Y',31.029518,-96.485340,0,'2013-07-06 12:44:34',NULL,NULL),(51397,'59427','S','Cut Bank','D','Glacier','30035','Montana','MT','30','0000','406','Mountain',-7.0,'Y',48.647289,-112.350965,0,'2013-07-06 12:44:33',NULL,NULL),(50685,'58348','S','Hesper','N','Benson','38005','North Dakota','ND','38','0000','701','Central',-6.0,'Y',47.932284,-99.553226,0,'2013-07-06 12:44:33',NULL,NULL),(2158,'00925','S','Urb Cabrera','N','San Juan','72127','Puerto Rico','PR','72','7440','787/939','Atlantic',-4.0,'N',18.398869,-66.050333,0,'2013-07-06 12:44:30',NULL,NULL),(8290,'08019','S','Chatsworth','D','Burlington','34005','New Jersey','NJ','34','6160','609','Eastern',-5.0,'Y',39.769693,-74.448835,0,'2013-07-06 12:44:30',NULL,NULL),(31553,'34607','S','Hernando Beach','A','Hernando','12053','Florida','FL','12','8280','352','Eastern',-5.0,'Y',28.505114,-82.636115,0,'2013-07-06 12:44:32',NULL,NULL),(19433,'20105','S','Aldie','D','Loudoun','51107','Virginia','VA','51','8840','703/571','Eastern',-5.0,'Y',38.954967,-77.598321,0,'2013-07-06 12:44:31',NULL,NULL),(29801,'33023','S','Pembroke Park','A','Broward','12011','Florida','FL','12','2680','954/754','Eastern',-5.0,'Y',25.986968,-80.206560,0,'2013-07-06 12:44:32',NULL,NULL),(24282,'26884','S','Seneca Rocks','D','Pendleton','54071','West Virginia','WV','54','0000','304/681','Eastern',-5.0,'Y',38.845264,-79.383961,0,'2013-07-06 12:44:31',NULL,NULL),(42510,'47848','S','Dugger','D','Sullivan','18153','Indiana','IN','18','0000','812','Eastern',-5.0,'Y',39.064996,-87.253689,0,'2013-07-06 12:44:32',NULL,NULL),(80111,'99759','P','Barrow','A','North Slope','02185','Alaska','AK','02','0000','907','Alaska',-9.0,'Y',69.538747,-163.247629,0,'2013-07-06 12:44:34',NULL,NULL),(52927,'61372','P','Troy Grove','D','La Salle','17099','Illinois','IL','17','0000','815/779','Central',-6.0,'Y',41.467466,-89.082529,0,'2013-07-06 12:44:33',NULL,NULL),(49150,'56378','S','Westport','N','Stearns','27145','Minnesota','MN','27','6980','320','Central',-6.0,'Y',45.714514,-94.959722,0,'2013-07-06 12:44:33',NULL,NULL),(46603,'53558','S','Mc Farland','D','Dane','55025','Wisconsin','WI','55','4720','608','Central',-6.0,'Y',43.007217,-89.296558,0,'2013-07-06 12:44:32',NULL,NULL),(6324,'05663','S','Norwich University','N','Washington','50023','Vermont','VT','50','0000','802','Eastern',-5.0,'Y',44.149825,-72.660946,0,'2013-07-06 12:44:30',NULL,NULL),(37628,'42153','S','Holland','D','Allen','21003','Kentucky','KY','21','0000','270','Central',-6.0,'Y',36.669520,-86.047299,0,'2013-07-06 12:44:32',NULL,NULL),(36958,'41171','S','Newfoundland','A','Elliott','21063','Kentucky','KY','21','0000','606','Eastern',-5.0,'Y',38.067411,-83.220393,0,'2013-07-06 12:44:32',NULL,NULL),(34653,'38774','S','Hushpuckena','N','Bolivar','28011','Mississippi','MS','28','0000','662','Central',-6.0,'Y',33.948680,-90.765417,0,'2013-07-06 12:44:32',NULL,NULL),(15757,'16915','S','Colesburg','N','Potter','42105','Pennsylvania','PA','42','0000','814','Eastern',-5.0,'Y',41.772095,-78.018822,0,'2013-07-06 12:44:31',NULL,NULL),(18206,'18947','S','Pipersville','D','Bucks','42017','Pennsylvania','PA','42','6160','215/267','Eastern',-5.0,'Y',40.416807,-75.118504,0,'2013-07-06 12:44:31',NULL,NULL),(20545,'21114','S','Crofton','D','Anne Arundel','24003','Maryland','MD','24','0720','410/443/667','Eastern',-5.0,'Y',39.010382,-76.681142,0,'2013-07-06 12:44:31',NULL,NULL),(40279,'45435','U','Wright State University','N','Greene','39057','Ohio','OH','39','2000','937','Eastern',-5.0,'Y',39.766782,-84.085913,0,'2013-07-06 12:44:32',NULL,NULL),(54733,'62966','S','Mount Carbon','N','Jackson','17077','Illinois','IL','17','0000','618/730','Central',-6.0,'Y',37.765150,-89.342282,0,'2013-07-06 12:44:33',NULL,NULL),(78008,'97413','S','Blue River','D','Lane','41039','Oregon','OR','41','2400','541','Pacific',-8.0,'Y',44.179665,-122.120204,0,'2013-07-06 12:44:34',NULL,NULL),(75419,'94026','P','Menlo Park','D','San Mateo','06081','California','CA','06','7360','650','Pacific',-8.0,'Y',37.481131,-122.180141,0,'2013-07-06 12:44:34',NULL,NULL),(73463,'91306','S','Canoga Park','A','Los Angeles','06037','California','CA','06','4480','818','Pacific',-8.0,'Y',34.207991,-118.575470,0,'2013-07-06 12:44:34',NULL,NULL),(72248,'88525','P','El Paso','D','El Paso','48141','Texas','TX','48','2320','915','Mountain',-7.0,'Y',31.810070,-106.417365,0,'2013-07-06 12:44:34',NULL,NULL),(67955,'80912','S','Schriever Air Sta','N','El Paso','08041','Colorado','CO','08','1720','719','Mountain',-7.0,'Y',39.047451,-104.696155,0,'2013-07-06 12:44:34',NULL,NULL),(12646,'13110','S','Otisco Valley','N','Onondaga','36067','New York','NY','36','8160','315','Eastern',-5.0,'Y',42.888966,-76.283957,0,'2013-07-06 12:44:30',NULL,NULL),(55009,'63132','S','Olivette','A','Saint Louis','29189','Missouri','MO','29','7040','314/557','Central',-6.0,'Y',38.671787,-90.377495,0,'2013-07-06 12:44:33',NULL,NULL),(63523,'75755','S','Big Sandy','D','Upshur','48459','Texas','TX','48','4420','903/430','Central',-6.0,'Y',32.583260,-95.112002,0,'2013-07-06 12:44:33',NULL,NULL),(65124,'77380','S','Shenandoah','A','Montgomery','48339','Texas','TX','48','3360','713/281/832','Central',-6.0,'Y',30.140487,-95.471451,0,'2013-07-06 12:44:34',NULL,NULL),(69577,'83835','S','Garwood','N','Kootenai','16055','Idaho','ID','16','0000','208','Pacific',-8.0,'Y',47.790660,-116.764380,0,'2013-07-06 12:44:34',NULL,NULL);
/*!40000 ALTER TABLE `ZipCodeMultiCity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ZipCodeMultiCounty`
--

DROP TABLE IF EXISTS `ZipCodeMultiCounty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ZipCodeMultiCounty` (
  `ZipCodeId` bigint(64) NOT NULL AUTO_INCREMENT,
  `ZipCode` char(5) NOT NULL,
  `County` varchar(100) NOT NULL,
  `CountyFIPS` char(5) NOT NULL,
  `StateAbbreviation` char(2) NOT NULL,
  `State` varchar(100) DEFAULT NULL,
  `CreatedByUserId` bigint(64) NOT NULL,
  `CreatedTimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `LastUpdatedByUserId` bigint(64) DEFAULT NULL,
  `LastUpdatedTimestamp` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`ZipCodeId`),
  KEY `ZipCodeMultiCounty_StateAbbreviationCounty_idx` (`StateAbbreviation`,`County`),
  KEY `ZipCodeMultiCounty_StateAbbreviationZipCode_idx` (`ZipCode`)
) ENGINE=innodb AUTO_INCREMENT=55171 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ZipCodeMultiCounty`
--

LOCK TABLES `ZipCodeMultiCounty` WRITE;
/*!40000 ALTER TABLE `ZipCodeMultiCounty` DISABLE KEYS */;
INSERT INTO `ZipCodeMultiCounty` VALUES (33252,'58049','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31843,'56153','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5990,'14724','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22660,'43015','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51566,'93032','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16,'00622','Cabo Rojo','72023','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(21362,'40118','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1798,'05034','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12352,'26377','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22967,'43360','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14752,'29918','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42406,'72579','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51696,'93308','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10549,'23139','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51432,'92650','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6301,'15206','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33222,'58030','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28365,'50456','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18252,'35466','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23401,'44053','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17762,'34251','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51591,'93107','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5509,'13804','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3200,'08560','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20064,'38259','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14513,'29605','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25819,'47392','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23482,'44134','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2267,'06254','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10450,'23027','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40837,'70142','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29195,'52154','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44143,'75424','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42825,'73097','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35130,'61064','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26992,'48871','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16469,'32209','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37461,'64150','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22234,'42045','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(628,'02114','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9273,'20586','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33143,'57744','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49737,'87116','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54372,'98366','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46,'00682','Mayaguez','72097','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(8802,'19706','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(32491,'56920','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(29999,'53572','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25677,'47246','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49477,'85730','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6717,'15783','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40937,'70431','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6476,'15454','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22189,'41844','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42887,'73155','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(773,'02467','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12691,'27237','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31424,'55603','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18697,'36141','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24034,'45067','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34665,'60407','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32982,'57523','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30780,'54770','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9707,'21288','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27351,'49323','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45892,'77964','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20116,'38341','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41047,'70550','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37724,'64738','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4243,'11702','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35582,'61728','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1981,'05654','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(29591,'52749','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31799,'56120','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32687,'57238','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33791,'58735','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45610,'77448','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18409,'35677','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43376,'74108','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3677,'09868','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20047,'38236','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19367,'37186','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41267,'71003','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50202,'89008','Lincoln','32017','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(30327,'54208','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53208,'96203','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54226,'98190','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54621,'98830','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20206,'38463','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24180,'45263','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15164,'30296','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2383,'06482','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40571,'69039','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31254,'55371','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38727,'66524','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10791,'23602','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1593,'04609','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38504,'66024','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13248,'28006','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1994,'05669','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24955,'46227','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41158,'70726','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13116,'27851','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6813,'15954','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49507,'85902','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10082,'22307','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39770,'68062','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4878,'12811','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23362,'43988','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45461,'77284','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55063,'99709','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(18784,'36322','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2719,'07444','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31267,'55382','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28188,'50239','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50013,'88124','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(16998,'33008','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42372,'72543','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13122,'27855','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46694,'79040','Hansford','48195','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16985,'32964','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42238,'72401','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25982,'47591','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44456,'75846','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38250,'65629','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13615,'28411','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13396,'28167','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51889,'93651','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9205,'20469','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(25119,'46528','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44428,'75789','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13560,'28365','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33771,'58718','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40736,'69356','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48289,'82836','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(53098,'96047','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46126,'78242','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28729,'50982','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27995,'50073','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31754,'56081','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53575,'97038','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50923,'91611','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30640,'54641','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10545,'23129','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43256,'74010','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44080,'75312','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36211,'62473','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11969,'25639','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32139,'56378','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(55091,'99744','Denali','2068','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30286,'54154','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45448,'77267','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20583,'38920','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22571,'42716','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52226,'94555','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48874,'84130','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30281,'54151','Florence','55037','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17839,'34484','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17937,'34788','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42713,'73018','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6225,'15057','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5906,'14558','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41794,'71841','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8850,'19899','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(26468,'48215','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53801,'97368','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54414,'98412','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27807,'49878','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41096,'70615','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43609,'74604','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(226,'01029','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31557,'55917','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23554,'44243','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23870,'44804','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53055,'95988','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36196,'62462','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39994,'68420','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5020,'13021','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30144,'53941','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53102,'96051','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29395,'52403','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28882,'51331','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43422,'74182','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26524,'48313','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1917,'05446','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40187,'68714','Loup','31115','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9536,'21018','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39099,'67106','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49952,'88021','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(19703,'37764','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33290,'58074','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9984,'22038','Fairfax City','51600','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39101,'67107','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3886,'10509','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4002,'10941','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16088,'31634','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46007,'78070','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54989,'99629','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(8834,'19809','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(37105,'63623','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36072,'62351','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49014,'84647','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54283,'98263','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6864,'16048','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50550,'90094','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45163,'76823','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38572,'66088','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7611,'17317','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47418,'80210','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49921,'87829','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(17847,'34601','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(493,'01770','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35810,'62015','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32830,'57359','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5309,'13459','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44873,'76439','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13061,'27808','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28101,'50157','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45299,'77013','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52683,'95444','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43819,'75001','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50005,'88118','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(42941,'73444','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21576,'40405','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17970,'34987','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32393,'56666','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28079,'50148','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15409,'30534','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37601,'64506','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36390,'62685','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46430,'78657','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46895,'79312','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53865,'97441','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4975,'12945','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14904,'30092','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40734,'69354','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51404,'92603','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(494,'01772','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6896,'16110','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7133,'16505','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7475,'17069','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17590,'33917','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10534,'23120','Powhatan','51145','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26103,'47850','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21780,'40939','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14751,'29916','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16685,'32535','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27293,'49271','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14455,'29550','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1212,'03779','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(43249,'74004','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7848,'17843','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14978,'30139','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53441,'96781','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(44209,'75476','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48865,'84121','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(17894,'34712','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40119,'68633','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38374,'65728','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35756,'61920','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37814,'64856','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24906,'46167','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18168,'35217','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3141,'08360','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9333,'20662','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28042,'50124','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21320,'40058','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(55163,'99923','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(22640,'43003','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24286,'45363','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25707,'47282','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4509,'12157','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7222,'16673','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36630,'62924','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34312,'59746','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30985,'54983','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29737,'53076','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7899,'17931','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31916,'56220','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4120,'11242','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25329,'46815','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52185,'94515','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22302,'42133','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37440,'64126','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30027,'53589','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13390,'28160','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41857,'71943','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23914,'44837','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45784,'77640','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53976,'97709','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(17694,'34116','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24864,'46142','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34270,'59642','Meagher','30059','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28781,'51029','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44247,'75504','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28377,'50461','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7345,'16901','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25958,'47564','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47008,'79499','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3624,'09777','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27534,'49621','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54555,'98623','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4065,'11042','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27861,'49946','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53785,'97352','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37902,'65062','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10514,'23106','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17741,'34228','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26806,'48701','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14084,'29039','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48663,'83726','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(3194,'08555','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12452,'26575','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13883,'28666','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45057,'76629','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17577,'33905','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16326,'32038','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17326,'33543','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26254,'47987','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43123,'73719','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4943,'12911','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39996,'68421','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41066,'70578','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15607,'30734','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30312,'54174','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46632,'78959','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47300,'80011','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52709,'95471','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22237,'42048','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19320,'37145','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28775,'51026','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49619,'86434','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46614,'78947','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17716,'34146','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1846,'05091','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1115,'03285','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(29218,'52170','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25253,'46750','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29035,'51557','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37430,'64116','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36580,'62892','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23771,'44637','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(124,'00822','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(9745,'21545','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34542,'60115','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30032,'53594','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18877,'36483','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46408,'78643','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50259,'89104','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(19022,'36756','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19150,'37022','Trousdale','47169','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44582,'76023','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38096,'65360','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4489,'12138','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32911,'57439','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14325,'29395','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7327,'16865','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31450,'55717','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22106,'41643','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16017,'31544','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25467,'46978','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30685,'54703','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11180,'24217','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45002,'76543','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5799,'14454','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49944,'88007','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53760,'97326','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10019,'22134','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14897,'30085','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21873,'41063','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53238,'96323','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(33314,'58204','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21207,'39836','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24865,'46143','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1487,'04401','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8023,'18085','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55161,'99921','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(29890,'53288','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49486,'85739','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2773,'07630','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7350,'16914','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47907,'81089','Huerfano','8055','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31767,'56088','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43607,'74601','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31881,'56180','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39635,'67849','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27983,'50068','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19601,'37641','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46237,'78393','Refugio','48391','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3108,'08316','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33263,'58054','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10926,'23901','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49802,'87418','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(15707,'31004','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30294,'54160','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48016,'81334','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44316,'75647','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16672,'32514','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41445,'71253','West Carroll','22123','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25298,'46787','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31670,'56013','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46879,'79255','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2329,'06401','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11601,'24938','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37808,'64850','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36900,'63303','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24465,'45681','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23610,'44313','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22984,'43420','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11523,'24751','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40001,'68424','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15668,'30820','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40909,'70373','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28263,'50310','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53757,'97324','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(910,'02804','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(36779,'63050','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9999,'22079','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50792,'91206','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50956,'91744','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21598,'40444','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24788,'46064','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38528,'66045','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2196,'06106','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43745,'74864','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32823,'57354','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1825,'05062','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21120,'39703','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50863,'91377','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43930,'75109','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10999,'24011','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30833,'54843','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16714,'32569','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25420,'46942','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53241,'96330','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(3231,'08650','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3427,'09265','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11424,'24562','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29831,'53179','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28990,'51529','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5340,'13490','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38184,'65565','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16049,'31565','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54993,'99633','Bristol Bay','2060','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(11423,'24558','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45205,'76857','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19692,'37753','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17824,'34470','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36258,'62538','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51863,'93627','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27882,'49968','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22455,'42374','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13740,'28547','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51691,'93303','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9180,'20423','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12632,'27055','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50656,'90630','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43245,'74001','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38335,'65692','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37116,'63628','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33687,'58620','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27976,'50063','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17591,'33918','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18945,'36582','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42533,'72740','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38057,'65332','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26433,'48178','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46299,'78559','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41751,'71759','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33494,'58386','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34772,'60499','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43889,'75070','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20196,'38455','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46346,'78608','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43807,'74959','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29775,'53115','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51098,'92082','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28725,'50947','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4873,'12803','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40708,'69336','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26531,'48321','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3890,'10512','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49993,'88101','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54695,'99006','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24670,'45868','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35751,'61914','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43439,'74335','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45519,'77357','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13867,'28653','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45040,'76579','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31948,'56241','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8755,'19530','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14144,'29105','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30896,'54915','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27269,'49252','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50028,'88202','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(7145,'16531','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3907,'10533','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34488,'60061','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37941,'65102','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19995,'38137','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44322,'75652','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6589,'15639','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22146,'41746','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45070,'76638','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35532,'61606','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14124,'29073','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42832,'73104','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1519,'04444','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47848,'81024','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29055,'51570','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42020,'72103','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44863,'76433','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34969,'60913','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19955,'38075','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20178,'38390','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1680,'04764','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19770,'37846','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17543,'33859','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16290,'31903','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26549,'48342','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(900,'02770','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9590,'21102','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50189,'88588','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(27227,'49201','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10891,'23868','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5454,'13733','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38338,'65702','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3014,'08069','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27823,'49892','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12762,'27313','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48718,'83850','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48843,'84097','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54964,'99602','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(20611,'38944','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21652,'40515','Clark','21049','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38396,'65742','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5060,'13054','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37376,'64062','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8942,'20046','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(15830,'31069','Peach','13225','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52723,'95493','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54149,'98064','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54570,'98642','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50686,'90714','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36478,'62830','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19685,'37744','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37837,'65001','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22254,'42064','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25171,'46572','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25421,'46943','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51238,'92274','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35373,'61433','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37839,'65011','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38445,'65779','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16692,'32541','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51351,'92508','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12955,'27584','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9644,'21209','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43782,'74932','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7437,'17040','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53315,'96595','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(28764,'51020','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20566,'38877','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44036,'75230','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9818,'21677','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25878,'47456','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42497,'72687','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13676,'28466','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19381,'37204','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39562,'67739','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48027,'81415','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54969,'99607','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(14495,'29585','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15543,'30650','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22926,'43332','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38232,'65616','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45775,'77625','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2190,'06098','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40005,'68429','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25923,'47528','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25252,'46750','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6272,'15123','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43496,'74428','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6564,'15615','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32359,'56630','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20039,'38229','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49425,'85636','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50381,'89438','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(18755,'36301','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14680,'29816','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46827,'79201','Cottle','48101','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53449,'96790','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(10269,'22716','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43037,'73562','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27219,'49120','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3969,'10710','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35244,'61281','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48015,'81332','Dolores','8033','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44894,'76452','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1768,'04964','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9254,'20555','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(55015,'99657','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(7255,'16726','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3698,'10013','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43069,'73644','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28899,'51347','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35959,'62249','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33387,'58273','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3216,'08611','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8,'00606','Maricao','72093','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(5019,'13021','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29160,'52073','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15941,'31318','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13532,'28342','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6473,'15449','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8286,'18656','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23042,'43511','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23956,'44865','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46906,'79324','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50838,'91343','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54498,'98560','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3949,'10596','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17334,'33549','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12442,'26561','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7442,'17044','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23047,'43512','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38966,'66944','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37316,'63957','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30146,'53941','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27016,'48884','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11797,'25266','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45270,'76940','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13872,'28656','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33383,'58269','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48322,'83012','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(34111,'59341','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25849,'47434','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31656,'56001','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12308,'26298','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42395,'72568','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32560,'57039','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15504,'30622','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34310,'59743','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16487,'32228','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24485,'45693','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5103,'13104','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36417,'62715','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41559,'71405','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35653,'61810','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46974,'79378','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54380,'98375','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9056,'20177','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14602,'29671','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14519,'29611','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6130,'14872','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14907,'30094','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49226,'85212','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(20389,'38652','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(603,'02051','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15741,'31021','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51943,'93745','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9214,'20506','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17623,'33960','Glades','12043','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6742,'15834','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30403,'54421','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30285,'54153','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22801,'43138','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45436,'77253','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46315,'78574','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54572,'98644','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4119,'11241','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45846,'77855','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34065,'59263','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(50775,'91121','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7990,'18055','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37487,'64190','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25270,'46769','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48212,'82435','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(29802,'53144','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16737,'32612','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14394,'29468','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1871,'05255','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(52637,'95385','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17677,'34095','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(6062,'14813','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39457,'67623','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27249,'49237','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3353,'09004','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(42620,'72857','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20784,'39174','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32995,'57533','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27159,'49071','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22440,'42356','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14412,'29483','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19106,'36872','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5453,'13733','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43821,'75006','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42964,'73461','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42042,'72119','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51024,'91941','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17270,'33461','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36672,'62952','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41816,'71860','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44844,'76389','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38823,'66734','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21680,'40598','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2669,'07192','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42358,'72531','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26261,'47991','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37603,'64508','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4260,'11722','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31081,'55077','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43756,'74871','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39210,'67336','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12655,'27127','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53528,'96951','Northern Mariana Islands','69010','MP','Northern Mariana Islands',0,'2013-07-03 15:17:54',NULL,NULL),(337,'01267','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39690,'67901','Stevens','20189','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36491,'62836','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7071,'16367','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48725,'83856','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:53',NULL,NULL),(42671,'72950','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48647,'83709','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53220,'96260','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(43542,'74467','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3111,'08319','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15310,'30448','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28659,'50674','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11706,'25121','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5887,'14537','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44167,'75442','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21978,'41254','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40990,'70506','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16395,'32119','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29841,'53188','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13508,'28323','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21295,'40040','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19848,'37919','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17343,'33563','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44848,'76402','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38147,'65529','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34536,'60108','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22066,'41553','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:52',NULL,NULL),(29926,'53517','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10682,'23327','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44065,'75264','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19243,'37079','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34565,'60133','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37062,'63543','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34891,'60620','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47334,'80041','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54680,'98944','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1776,'04973','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7919,'17960','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23589,'44282','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27996,'50074','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53565,'97032','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53647,'97131','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(38564,'66080','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10744,'23455','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21337,'40070','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19504,'37360','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37484,'64187','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28516,'50578','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22405,'42324','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17107,'33156','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15700,'30999','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13657,'28452','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5763,'14414','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7801,'17774','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(979,'02903','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(20804,'39192','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27262,'49247','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48199,'82420','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48298,'82902','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49669,'87016','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(22332,'42171','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20138,'38358','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3785,'10163','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3069,'08215','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3118,'08327','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26621,'48433','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23873,'44807','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13329,'28101','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(812,'02562','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16688,'32538','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29401,'52406','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22718,'43064','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54828,'99212','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13853,'28644','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45324,'77038','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15010,'30164','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17702,'34135','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3954,'10603','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39452,'67621','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34428,'59937','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(48071,'81620','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48259,'82712','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(31499,'55767','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33297,'58081','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7668,'17501','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1725,'04917','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6069,'14817','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4427,'12060','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15129,'30271','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23859,'44720','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50357,'89413','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40414,'68876','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36736,'63015','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18905,'36533','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29924,'53516','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28044,'50126','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50836,'91341','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44665,'76106','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26077,'47832','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34805,'60521','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28284,'50328','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18007,'35031','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32354,'56627','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20874,'39335','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41766,'71772','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5306,'13456','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3458,'09363','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(50228,'89034','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51554,'93013','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4897,'12835','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18248,'35463','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18170,'35219','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6264,'15106','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16643,'32456','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5325,'13477','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48319,'83001','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(4319,'11793','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50174,'88573','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(50984,'91776','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12888,'27526','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40086,'68529','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17528,'33845','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2174,'06081','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36595,'62902','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6619,'15677','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48561,'83602','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52880,'95691','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52242,'94571','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37466,'64155','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34946,'60689','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14110,'29059','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13497,'28311','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7467,'17063','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39677,'67876','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43152,'73744','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(113,'00791','Humacao','72069','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(41104,'70633','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2506,'06824','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27841,'49915','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20405,'38666','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54324,'98314','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51865,'93630','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1605,'04625','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42197,'72358','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43198,'73840','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9540,'21027','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7593,'17272','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26057,'47734','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3099,'08270','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12712,'27260','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2155,'06063','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50649,'90610','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13420,'28215','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53739,'97303','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(24813,'46082','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22717,'43062','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19648,'37710','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6387,'15324','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43855,'75039','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31568,'55924','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48111,'81655','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37497,'64421','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39305,'67456','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13089,'27829','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5168,'13166','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16968,'32948','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3087,'08243','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20742,'39120','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11198,'24237','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9029,'20143','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52703,'95466','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50186,'88585','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(15666,'30819','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15194,'30321','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24084,'45142','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19109,'36875','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37916,'65072','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18663,'36091','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40072,'68510','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40547,'69025','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45243,'76890','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10920,'23897','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53615,'97089','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54201,'98139','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54720,'99029','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49183,'85119','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32853,'57371','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13619,'28422','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31283,'55390','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20670,'39057','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7527,'17126','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26050,'47725','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13234,'27973','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4966,'12935','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12146,'26003','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15167,'30298','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13270,'28033','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15102,'30248','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17455,'33736','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36385,'62682','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37329,'63967','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45408,'77220','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7459,'17058','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21400,'40177','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8416,'18979','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7126,'16443','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43710,'74839','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35087,'61031','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28799,'51041','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53773,'97342','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35757,'61924','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25177,'46574','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7509,'17102','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45599,'77440','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49222,'85208','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(24303,'45378','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38233,'65616','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37557,'64473','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30384,'54409','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26557,'48356','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53407,'96745','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(3990,'10924','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19506,'37361','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10157,'22508','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10283,'22730','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46193,'78352','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40608,'69134','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36627,'62923','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32025,'56301','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30626,'54631','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51577,'93061','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19361,'37183','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11430,'24566','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3650,'09827','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19622,'37669','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31505,'55772','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19524,'37371','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12228,'26180','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27667,'49730','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(907,'02791','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1408,'04221','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11147,'24153','Salem City','51775','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20665,'39051','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9814,'21672','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(44550,'75977','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1779,'04976','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39278,'67439','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26248,'47981','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38952,'66937','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4940,'12901','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50980,'91771','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51979,'93923','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47468,'80248','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24368,'45459','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11644,'25030','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36649,'62938','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15401,'30533','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41236,'70816','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4041,'10992','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43176,'73762','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35603,'61742','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23550,'44240','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52182,'94514','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52778,'95589','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48743,'83874','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48483,'83429','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10292,'22735','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36734,'63014','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34445,'60013','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13484,'28301','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13275,'28036','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31917,'56220','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52101,'94209','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48890,'84157','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37476,'64166','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40134,'68640','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12068,'25845','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44352,'75682','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42155,'72320','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14797,'30011','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31405,'55584','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50126,'88520','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(38865,'66772','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18414,'35741','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22463,'42404','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10816,'23681','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3665,'09842','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(24959,'46230','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49690,'87037','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(35262,'61317','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29390,'52359','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52397,'95019','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7040,'16341','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16214,'31787','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35264,'61319','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42802,'73075','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41764,'71770','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41211,'70783','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38246,'65625','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28805,'51047','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51346,'92503','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25147,'46550','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8415,'18977','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7514,'17107','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8427,'19007','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9676,'21231','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23420,'44072','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15025,'30175','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10969,'23958','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25744,'47337','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26863,'48756','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31727,'56060','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39945,'68365','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26337,'48080','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12292,'26280','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47479,'80262','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49798,'87413','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(4406,'12037','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23476,'44128','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6066,'14815','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8885,'19962','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(3180,'08535','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10291,'22735','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45707,'77535','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52499,'95194','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47349,'80105','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31629,'55971','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31643,'55977','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12603,'27027','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(10663,'23302','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5875,'14529','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9045,'20164','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28181,'50236','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54901,'99507','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48850,'84106','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(26199,'47948','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25799,'47373','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14482,'29575','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44727,'76205','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36382,'62677','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24157,'45241','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19519,'37367','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7695,'17536','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8313,'18813','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2096,'05867','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(35113,'61052','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3615,'09748','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(74,'00728','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(35928,'62222','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28089,'50152','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51677,'93277','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9763,'21622','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14697,'29831','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26731,'48615','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9051,'20170','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2386,'06487','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36403,'62694','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38843,'66754','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5549,'13847','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44492,'75925','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2962,'08012','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20454,'38748','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52761,'95555','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50153,'88549','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47918,'81120','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2559,'07001','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26316,'48054','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(897,'02767','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20741,'39120','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41161,'70729','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37749,'64756','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46882,'79255','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38380,'65733','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9848,'21740','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45803,'77701','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44614,'76052','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34814,'60530','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53562,'97029','Sherman','41055','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(39814,'68128','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29174,'52132','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3426,'09264','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9480,'20868','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47444,'80229','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54554,'98622','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23661,'44437','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32473,'56756','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34379,'59858','Granite','30039','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44317,'75650','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42658,'72941','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15464,'30573','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52784,'95603','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39491,'67645','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41015,'70525','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41442,'71250','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9414,'20765','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10598,'23192','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34125,'59353','Fallon','30025','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27621,'49688','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33496,'58402','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12163,'26055','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(55147,'99827','Haines','2100','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(4769,'12569','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26174,'47928','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17411,'33655','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36137,'62425','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47945,'81144','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35750,'61914','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4498,'12148','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44530,'75961','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45630,'77465','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25370,'46904','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40869,'70182','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11028,'24032','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19390,'37212','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37857,'65026','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33224,'58030','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26015,'47639','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49172,'85080','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6914,'16127','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30464,'54462','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21179,'39773','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38002,'65262','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1151,'03465','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21578,'40409','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(424,'01534','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29299,'52252','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50729,'90846','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4329,'11815','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40074,'68514','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20242,'38501','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42556,'72762','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4989,'12964','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8801,'19703','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(462,'01612','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46743,'79070','Roberts','48393','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50300,'89145','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(24505,'45715','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29618,'52771','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45427,'77241','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22059,'41540','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41241,'70821','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38415,'65757','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44343,'75668','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29625,'52777','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3076,'08223','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5344,'13494','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21739,'40826','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(152,'00923','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14387,'29457','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41165,'70733','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28533,'50594','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51862,'93626','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54131,'98042','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50873,'91392','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46889,'79259','Childress','48075','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32863,'57379','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6762,'15863','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11334,'24460','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21371,'40140','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39547,'67732','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13679,'28467','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9322,'20645','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27758,'49819','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34171,'59444','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30380,'54407','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29693,'53038','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17927,'34770','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12378,'26422','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53153,'96106','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18698,'36142','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34677,'60417','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21732,'40816','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8570,'19153','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22132,'41722','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21701,'40730','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18693,'36133','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33039,'57574','Bennett','46007','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2049,'05772','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28492,'50563','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23146,'43661','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51188,'92199','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30881,'54901','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18207,'35288','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6025,'14758','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22547,'42603','Clinton','21053','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20899,'39354','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12640,'27104','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14939,'30108','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50518,'90060','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36019,'62293','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5824,'14477','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2973,'08026','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9302,'20620','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19517,'37366','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4753,'12549','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37630,'64636','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52082,'94145','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32846,'57369','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43722,'74851','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39220,'67345','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34737,'60464','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9391,'20740','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12244,'26210','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43622,'74641','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27449,'49431','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36952,'63379','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36159,'62440','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8230,'18519','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1011,'03046','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(42114,'72181','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19911,'38039','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25929,'47532','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35229,'61265','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47210,'79845','Presidio','48377','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48655,'83716','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(9787,'21649','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42722,'73025','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15585,'30705','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26186,'47940','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48872,'84128','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30228,'54103','Florence','55037','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23932,'44847','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9491,'20882','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40477,'68948','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24357,'45437','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1119,'03291','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6489,'15468','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23535,'44230','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28482,'50558','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36609,'62910','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39964,'68377','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17759,'34243','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10927,'23909','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27105,'49030','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27042,'48908','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50492,'90034','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9576,'21076','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24569,'45787','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9975,'22031','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7691,'17532','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30841,'54850','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40395,'68864','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2552,'06920','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5046,'13042','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23496,'44147','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51082,'92060','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31912,'56219','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(42149,'72311','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44141,'75423','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16240,'31801','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54465,'98526','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53683,'97211','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33481,'58380','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7885,'17886','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36955,'63381','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3119,'08328','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4482,'12132','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37109,'63624','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5385,'13633','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14010,'28778','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51115,'92108','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50209,'89015','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48307,'82933','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(6555,'15601','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34425,'59934','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29769,'53105','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42024,'72104','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23881,'44813','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25841,'47429','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27805,'49876','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20960,'39455','Lamar','28073','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38680,'66432','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37852,'65023','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23949,'44859','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37124,'63631','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6697,'15763','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9694,'21264','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5710,'14201','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42436,'72630','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3475,'09397','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38625,'66220','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9373,'20717','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49532,'86001','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47530,'80439','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10266,'22713','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19928,'38050','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41696,'71663','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22666,'43017','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12141,'25985','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8431,'19010','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5407,'13656','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39683,'67879','Wichita','20203','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38128,'65459','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52928,'95819','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51212,'92243','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34062,'59262','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30271,'54137','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42414,'72601','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37045,'63531','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54548,'98616','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25122,'46531','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9118,'20254','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(37350,'64024','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4918,'12857','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52960,'95866','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36954,'63381','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6491,'15470','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8120,'18346','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45279,'76950','Sutton','48435','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24992,'46262','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6803,'15944','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4281,'11749','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52656,'95415','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50856,'91362','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49861,'87562','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(9280,'20598','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39928,'68351','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18163,'35213','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43739,'74859','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24800,'46070','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54064,'97877','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49995,'88102','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48738,'83869','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29518,'52630','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15354,'30506','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33882,'58843','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50646,'90607','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50693,'90731','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46932,'79347','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36901,'63304','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40136,'68641','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8241,'18612','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10722,'23427','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23056,'43517','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41801,'71851','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19752,'37825','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34047,'59253','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31095,'55088','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50878,'91401','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45422,'77235','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(437,'01561','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10874,'23847','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4527,'12176','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4549,'12203','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25549,'47104','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22830,'43153','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37331,'64001','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(670,'02170','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10327,'22833','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6016,'14748','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32112,'56358','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40461,'68940','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2376,'06474','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33285,'58069','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8704,'19460','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31404,'55583','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2661,'07111','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41789,'71838','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26790,'48654','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33400,'58310','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49639,'86510','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44246,'75503','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30543,'54531','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26838,'48737','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23183,'43733','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51685,'93287','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52982,'95923','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16813,'32716','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13558,'28364','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35031,'60958','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44817,'76363','Throckmorton','48447','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7293,'16830','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28410,'50483','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4559,'12214','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14347,'29420','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54612,'98819','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28874,'51247','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31282,'55389','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52093,'94177','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32588,'57053','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23388,'44040','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30065,'53785','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52435,'95070','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49879,'87592','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(31257,'55373','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41620,'71458','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42985,'73523','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7415,'17022','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19226,'37067','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37780,'64788','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50265,'89110','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(39355,'67511','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7211,'16664','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3868,'10470','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11171,'24203','Bristol City','51520','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3000,'08054','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39750,'68044','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36096,'62373','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51402,'92599','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28904,'51354','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24734,'46017','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11929,'25540','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42200,'72364','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37985,'65247','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31953,'56245','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46473,'78708','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22551,'42633','Clinton','21053','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46230,'78385','Kenedy','48261','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14898,'30086','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37942,'65103','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20449,'38740','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4902,'12841','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16077,'31626','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35085,'61028','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14834,'30033','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40887,'70342','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21284,'40026','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41178,'70748','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50692,'90723','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53043,'95977','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(880,'02739','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7663,'17405','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8108,'18331','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43822,'75007','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10715,'23419','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36775,'63047','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21442,'40250','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21910,'41114','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(912,'02807','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(6713,'15778','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32168,'56433','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26909,'48813','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23194,'43748','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47394,'80136','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15737,'31018','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36541,'62869','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22278,'42088','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5776,'14424','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28180,'50235','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24167,'45247','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14119,'29069','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48092,'81638','Rio Blanco','8103','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53508,'96910','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(1276,'03866','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22744,'43078','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8773,'19548','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41111,'70640','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27930,'50036','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52436,'95071','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54559,'98628','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52428,'95061','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18078,'35111','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18999,'36727','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2954,'08005','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44082,'75315','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30940,'54950','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25389,'46920','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9129,'20301','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14664,'29742','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44540,'75972','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11926,'25534','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(422,'01531','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34907,'60638','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47909,'81090','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52398,'95020','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52652,'95407','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49197,'85139','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14483,'29576','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22164,'41778','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17572,'33898','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5949,'14621','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1205,'03768','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(41543,'71365','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47856,'81038','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33150,'57750','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24159,'45241','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37371,'64057','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5157,'13158','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32342,'56592','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8816,'19721','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(15265,'30413','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4983,'12957','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29567,'52726','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5093,'13088','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18847,'36454','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20457,'38753','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40330,'68820','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17144,'33197','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54121,'98032','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47052,'79532','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2798,'07676','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16867,'32783','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16862,'32777','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38669,'66424','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16422,'32145','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3787,'10165','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16779,'32667','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22346,'42214','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21730,'40813','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18608,'36041','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45662,'77489','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43933,'75115','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9145,'20374','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(46374,'78623','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25657,'47230','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25987,'47601','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26800,'48662','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15369,'30516','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3464,'09369','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(10649,'23284','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11002,'24012','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21142,'39745','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15523,'30633','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40819,'70115','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37161,'63673','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28785,'51033','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50290,'89135','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51938,'93730','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27317,'49303','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2220,'06140','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5355,'13601','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48392,'83253','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49166,'85073','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53548,'97016','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54963,'99599','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(19513,'37365','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29708,'53049','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29440,'52552','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39093,'67101','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40135,'68640','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12734,'27288','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23931,'44847','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15765,'31032','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18536,'35976','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42615,'72854','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44395,'75756','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3697,'10012','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53072,'96016','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53357,'96673','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52809,'95626','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49640,'86511','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46281,'78536','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23735,'44612','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6537,'15548','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7224,'16674','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20871,'39330','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37077,'63552','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45665,'77492','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12320,'26330','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10678,'23323','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26946,'48837','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50054,'88264','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(25863,'47448','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37132,'63638','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8321,'18822','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6854,'16038','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45114,'76678','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3481,'09459','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26270,'47997','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1697,'04787','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50644,'90605','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1552,'04491','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34827,'60541','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26085,'47837','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49231,'85216','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47046,'79529','King','48269','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30950,'54960','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11260,'24328','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18256,'35470','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16963,'32935','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47754,'80832','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49805,'87421','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(10280,'22728','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33880,'58838','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(692,'02215','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25544,'47043','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13177,'27907','Pasquotank','37139','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52393,'95014','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17918,'34755','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11404,'24540','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42897,'73167','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46544,'78778','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46875,'79250','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8185,'18446','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10015,'22121','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11815,'25304','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16585,'32401','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21231,'39859','Miller','13201','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17900,'34731','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10688,'23347','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40925,'70402','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15745,'31022','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31589,'55944','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54170,'98102','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45347,'77059','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44981,'76528','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42803,'73077','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41825,'71902','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30379,'54406','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32908,'57437','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11142,'24150','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23838,'44693','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5366,'13615','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48049,'81435','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54524,'98589','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7212,'16665','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51919,'93710','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40738,'69357','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30303,'54166','Menominee','55078','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17782,'34281','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8474,'19056','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18827,'36426','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52266,'94596','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50706,'90755','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8667,'19405','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11091,'24101','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45689,'77515','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10360,'22909','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3354,'09005','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(23749,'44621','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20404,'38665','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54873,'99348','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51143,'92138','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34951,'60695','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35144,'61074','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54061,'97874','Wheeler','41069','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34900,'60630','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9835,'21717','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22143,'41740','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6367,'15283','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20282,'38563','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24410,'45631','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53765,'97331','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48835,'84089','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27454,'49437','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1437,'04262','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48280,'82801','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(796,'02538','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41980,'72067','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14016,'28784','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22671,'43019','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19451,'37326','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50737,'91006','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54114,'98025','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46817,'79159','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24051,'45111','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6966,'16223','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43516,'74442','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11392,'24529','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18110,'35142','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26869,'48759','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7279,'16803','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2219,'06138','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(53578,'97041','Hood River','41027','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11211,'24258','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33455,'58356','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9143,'20372','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1194,'03748','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19984,'38125','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25104,'46510','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23223,'43773','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36637,'62930','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44173,'75448','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18659,'36088','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5275,'13413','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24186,'45271','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24171,'45250','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43830,'75015','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40513,'68975','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25978,'47588','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38121,'65456','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51208,'92239','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27062,'48956','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18103,'35131','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17887,'34691','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4209,'11555','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13280,'28038','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42269,'72432','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34599,'60156','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27748,'49807','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35465,'61520','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25588,'47132','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32092,'56343','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45300,'77014','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20397,'38659','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18224,'35440','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2512,'06836','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44127,'75413','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28487,'50561','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48593,'83634','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12907,'27541','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17439,'33707','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46980,'79383','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25598,'47138','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11054,'24064','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8761,'19539','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47503,'80310','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11020,'24024','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5001,'12978','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10380,'22939','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25281,'46777','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16699,'32550','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18492,'35905','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29757,'53095','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30366,'54307','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21002,'39502','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20541,'38860','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39555,'67735','Sherman','20181','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49969,'88040','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53009,'95948','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53726,'97281','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42202,'72366','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31860,'56164','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53550,'97017','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33456,'58357','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41109,'70638','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46252,'78415','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46620,'78950','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9966,'21930','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43235,'73944','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16673,'32516','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7677,'17509','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38447,'65781','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9518,'20912','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1829,'05069','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28931,'51440','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10270,'22716','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20335,'38610','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42798,'73073','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47649,'80632','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53866,'97442','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2542,'06903','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18760,'36304','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12484,'26629','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11114,'24128','Craig','51045','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44532,'75963','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30861,'54870','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19646,'37709','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29716,'53060','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26858,'48749','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23169,'43724','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15155,'30292','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30749,'54755','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47169,'79759','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27090,'49018','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4576,'12237','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(730,'02347','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44373,'75702','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3331,'08876','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11267,'24347','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12784,'27340','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22787,'43126','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37971,'65239','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25287,'46782','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8675,'19422','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28225,'50259','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5258,'13367','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21248,'39886','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24397,'45619','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39424,'67567','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32629,'57101','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31649,'55985','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48704,'83835','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48903,'84302','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54840,'99251','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33875,'58830','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1713,'04860','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3359,'09011','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20830,'39236','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54886,'99361','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53088,'96033','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3289,'08825','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13977,'28750','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1745,'04938','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54589,'98671','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51774,'93514','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50514,'90056','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27438,'49423','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18885,'36505','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43314,'74048','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7014,'16312','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53219,'96258','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(28471,'50546','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36025,'62297','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16294,'31906','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20055,'38251','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36294,'62560','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15870,'31096','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47069,'79544','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34342,'59820','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35367,'61426','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21900,'41096','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44039,'75233','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42916,'73401','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35834,'62036','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40449,'68934','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9166,'20409','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12848,'27501','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30558,'54543','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1023,'03062','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(20966,'39456','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53184,'96136','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47484,'80271','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17174,'33307','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31429,'55609','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39478,'67638','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44489,'75904','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29580,'52738','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25274,'46772','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26848,'48743','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18778,'36319','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21325,'40062','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42135,'72217','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13406,'28202','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44513,'75941','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9487,'20877','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33370,'58259','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52594,'95338','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16710,'32566','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46871,'79248','King','48269','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46438,'78663','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28646,'50667','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26425,'48169','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25348,'46860','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47899,'81076','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50825,'91326','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28784,'51031','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18225,'35441','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41399,'71212','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20524,'38849','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23524,'44215','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25776,'47357','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54594,'98675','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53821,'97386','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35906,'62094','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7278,'16802','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44216,'75481','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42347,'72523','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26617,'48430','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26165,'47922','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8271,'18635','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52760,'95554','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25907,'47513','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11633,'25008','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35170,'61105','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49219,'85205','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(22141,'41736','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26778,'48647','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36746,'63023','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31816,'56132','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36184,'62452','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19414,'37241','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39833,'68152','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22407,'42326','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23897,'44825','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41969,'72060','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38223,'65610','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6340,'15244','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35108,'61049','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33338,'58227','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51912,'93703','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15819,'31065','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38886,'66830','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39088,'67071','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9925,'21840','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20767,'39159','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7210,'16663','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2294,'06335','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12170,'26062','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52754,'95549','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9964,'21921','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14208,'29163','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42507,'72715','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13572,'28374','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54475,'98536','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48036,'81424','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42632,'72913','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43746,'74864','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37677,'64667','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13338,'28107','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5364,'13613','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12570,'26855','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54204,'98145','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51926,'93718','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50330,'89185','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(25942,'47547','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20452,'38746','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5889,'14539','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42444,'72635','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23818,'44677','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32369,'56639','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(18396,'35654','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52279,'94610','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47948,'81148','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26491,'48237','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1502,'04421','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5331,'13483','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24289,'45365','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9587,'21092','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7575,'17251','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43383,'74116','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18464,'35803','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54197,'98133','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54696,'99008','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40068,'68506','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20789,'39176','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17390,'33616','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53340,'96629','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(16799,'32702','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42737,'73034','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35007,'60942','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13539,'28347','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26063,'47750','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37298,'63941','Carter','29035','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49933,'87939','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(42577,'72823','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(456,'01606','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54393,'98387','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49246,'85253','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33564,'58463','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43279,'74023','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45161,'76820','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43939,'75120','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23540,'44231','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48447,'83342','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47451,'80234','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27433,'49420','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25965,'47576','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1642,'04676','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5934,'14606','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44025,'75219','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6424,'15366','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40525,'68980','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38798,'66636','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14557,'29642','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46704,'79043','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44187,'75455','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31507,'55777','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28282,'50325','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52106,'94234','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10341,'22849','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1874,'05261','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24917,'46175','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22593,'42729','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39636,'67849','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17502,'33809','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39233,'67354','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38155,'65541','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22707,'43056','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46794,'79105','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52930,'95821','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46831,'79221','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46462,'78677','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22833,'43155','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19473,'37338','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18094,'35124','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29844,'53190','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37703,'64689','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39493,'67646','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6726,'15823','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15375,'30518','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47812,'80939','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54244,'98223','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38812,'66717','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23841,'44697','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50102,'88418','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47084,'79553','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3600,'09731','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49135,'85034','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2990,'08042','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25027,'46323','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11175,'24211','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4535,'12186','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32684,'57236','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37176,'63738','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10030,'22172','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31528,'55801','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(515,'01833','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12114,'25927','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13393,'28164','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10312,'22807','Harrisonburg City','51660','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52018,'94030','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27071,'49008','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4894,'12832','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23164,'43720','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42970,'73487','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12264,'26238','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40520,'68979','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1135,'03444','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52883,'95693','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52801,'95618','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52667,'95425','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5328,'13480','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7824,'17821','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28394,'50472','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34896,'60625','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41340,'71075','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16769,'32656','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43484,'74401','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27561,'49640','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29929,'53518','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53075,'96020','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48311,'82937','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(29368,'52342','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14873,'30064','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2445,'06702','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29790,'53129','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16398,'32122','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15907,'31211','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7969,'18037','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34999,'60936','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11012,'24018','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23934,'44849','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28584,'50626','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20271,'38553','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53742,'97305','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26813,'48720','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14226,'29204','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21421,'40218','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5073,'13069','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37832,'64873','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7974,'18041','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52589,'95333','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54136,'98047','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35051,'60968','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36612,'62914','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20738,'39119','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(401,'01504','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11572,'24874','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27857,'49938','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48911,'84311','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(3762,'10124','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24130,'45213','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36527,'62860','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44659,'76099','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43766,'74880','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22703,'43050','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12880,'27522','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12882,'27523','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27633,'49706','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43328,'74059','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37336,'64013','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49816,'87508','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(35408,'61460','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27888,'50002','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(163,'00935','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(44024,'75218','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35284,'61334','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44965,'76519','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37359,'64037','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36156,'62438','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11582,'24894','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15297,'30439','Candler','13043','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13952,'28729','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35891,'62084','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32374,'56646','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31027,'55030','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20204,'38462','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20261,'38545','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25983,'47596','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41089,'70606','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43806,'74957','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28790,'51035','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6117,'14863','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30544,'54532','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16596,'32412','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1339,'04039','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47440,'80226','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37429,'64114','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50928,'91617','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20802,'39191','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43403,'74137','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22377,'42262','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21984,'41263','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32942,'57461','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30998,'55006','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16467,'32207','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54807,'99170','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32446,'56732','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10921,'23898','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33084,'57644','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32983,'57523','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50847,'91355','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52188,'94517','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8238,'18610','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40574,'69041','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26685,'48476','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38781,'66614','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53876,'97451','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44521,'75951','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5708,'14173','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9450,'20817','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40355,'68835','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50336,'89310','Lander','32015','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54988,'99628','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51120,'92113','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32232,'56482','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43779,'74931','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3177,'08533','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24673,'45869','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47924,'81125','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6004,'14737','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23176,'43730','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16941,'32902','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11675,'25070','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2104,'05902','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20032,'38221','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9920,'21830','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54681,'98946','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30717,'54737','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32592,'57055','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11731,'25156','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4834,'12758','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53632,'97117','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(18939,'36576','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16241,'31803','Marion','13197','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27094,'49021','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40567,'69038','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22827,'43153','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43924,'75102','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21772,'40915','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20368,'38635','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15087,'30233','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43755,'74869','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28710,'50858','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13356,'28124','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51519,'92860','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53438,'96778','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(29165,'52076','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31246,'55367','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43910,'75089','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22776,'43113','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(71,'00725','Caguas','72025','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(11029,'24033','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1828,'05068','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2864,'07828','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47159,'79748','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51646,'93244','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54330,'98324','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7244,'16694','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19116,'36904','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19739,'37813','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48699,'83832','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(547,'01902','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51880,'93643','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25245,'46746','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34374,'59851','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42650,'72933','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18781,'36322','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44951,'76490','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32382,'56654','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37470,'64161','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21583,'40419','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1142,'03451','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(40351,'68833','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3095,'08252','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36133,'62423','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43265,'74016','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16359,'32073','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14582,'29655','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36093,'62367','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47556,'80468','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53642,'97125','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37940,'65101','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25586,'47130','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42657,'72940','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8411,'18971','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(920,'02817','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(38040,'65321','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14098,'29051','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15445,'30559','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28134,'50210','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18627,'36053','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26332,'48073','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18718,'36257','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44031,'75225','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5946,'14618','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12685,'27229','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18708,'36206','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51148,'92145','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29822,'53168','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10443,'23021','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23112,'43566','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12185,'26134','Pleasants','54073','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6566,'15617','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41019,'70527','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12133,'25976','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4536,'12187','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37467,'64156','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29600,'52755','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45018,'76559','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20559,'38871','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8527,'19112','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1387,'04102','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34524,'60097','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10647,'23279','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(320,'01243','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45058,'76630','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41159,'70727','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53042,'95976','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18668,'36103','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45096,'76660','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2987,'08038','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15684,'30830','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27801,'49872','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50161,'88559','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(27843,'49917','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40204,'68727','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43667,'74748','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44571,'76015','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27678,'49739','Crawford','26039','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42717,'73021','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31512,'55783','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54650,'98862','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40639,'69154','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26051,'47725','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43467,'74360','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44131,'75416','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25855,'47438','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17097,'33145','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48446,'83341','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(21941,'41168','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10379,'22938','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31742,'56071','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3322,'08865','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38818,'66724','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46201,'78360','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11313,'24432','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21335,'40069','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46652,'79011','Hemphill','48211','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2701,'07419','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29738,'53078','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14245,'29222','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17695,'34117','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40746,'69365','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12468,'26591','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32749,'57276','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34909,'60640','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19814,'37876','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15008,'30162','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6463,'15438','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25162,'46563','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31029,'55031','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54354,'98349','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19802,'37870','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19643,'37707','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17312,'33523','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25688,'47264','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31362,'55472','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48481,'83427','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54751,'99117','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50817,'91313','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17987,'35010','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45065,'76634','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46682,'79033','Ochiltree','48357','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24290,'45367','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1592,'04607','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8748,'19523','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29084,'51640','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(34851,'60557','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47633,'80601','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46661,'79016','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27591,'49665','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8224,'18509','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49452,'85703','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50701,'90745','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9544,'21031','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38200,'65589','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12159,'26040','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17321,'33539','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15580,'30683','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6353,'15264','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28287,'50331','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38175,'65559','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20587,'38922','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10376,'22936','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2355,'06440','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25451,'46967','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44835,'76379','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41000,'70515','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45653,'77484','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32654,'57214','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18096,'35126','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53481,'96824','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(55071,'99722','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(34114,'59344','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14004,'28773','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10023,'22152','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15080,'30228','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28415,'50501','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33493,'58386','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50595,'90274','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33665,'58566','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46164,'78289','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10624,'23233','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36856,'63132','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8191,'18453','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14579,'29654','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21870,'41059','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29970,'53548','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26520,'48309','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39359,'67513','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10358,'22907','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4368,'11969','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49461,'85712','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47482,'80265','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39481,'67640','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45117,'76681','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28477,'50554','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12504,'26680','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50269,'89114','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53322,'96605','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(3390,'09099','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(41315,'71061','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12934,'27565','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11603,'24943','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34426,'59935','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28753,'51016','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31738,'56068','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48884,'84145','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54616,'98824','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31233,'55355','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23186,'43736','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45709,'77535','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27858,'49942','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36696,'62969','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41299,'71044','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22296,'42129','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2413,'06518','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23385,'44035','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54540,'98606','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31007,'55011','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24751,'46039','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9195,'20441','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(27310,'49286','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37389,'64072','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21104,'39665','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48974,'84533','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53814,'97378','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11844,'25338','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42695,'73009','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24386,'45601','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10043,'22202','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34537,'60109','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41771,'71822','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20076,'38308','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18412,'35739','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52515,'95219','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16805,'32707','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33862,'58790','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33907,'59011','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47073,'79545','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22011,'41351','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47993,'81253','Custer','8027','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8853,'19903','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(874,'02722','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9041,'20158','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39585,'67753','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40235,'68747','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52247,'94575','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28690,'50841','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28048,'50128','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36293,'62560','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35027,'60957','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53799,'97366','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29547,'52653','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33990,'59086','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44365,'75689','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6942,'16155','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14736,'29902','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19824,'37881','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30938,'54948','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27742,'49801','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50946,'91731','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32443,'56728','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5262,'13402','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18845,'36453','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30734,'54746','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32582,'57051','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9772,'21632','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34848,'60554','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13097,'27835','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24538,'45745','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50988,'91785','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42535,'72741','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30119,'53924','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22856,'43212','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3858,'10460','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8688,'19440','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7311,'16849','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(751,'02382','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53875,'97450','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48804,'84060','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(28096,'50155','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40797,'70076','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27789,'49855','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45509,'77349','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32067,'56330','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29424,'52537','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4833,'12758','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40822,'70118','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13999,'28768','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4097,'11217','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22263,'42071','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6420,'15362','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22494,'42450','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13725,'28531','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24611,'45832','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51963,'93792','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36755,'63028','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4198,'11531','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39855,'68303','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50607,'90301','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51968,'93901','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33871,'58801','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11428,'24565','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53611,'97080','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33256,'58052','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42458,'72645','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24323,'45402','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48205,'82428','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(27157,'49070','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1993,'05667','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(44897,'76454','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33891,'58853','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16529,'32311','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12030,'25726','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40766,'70039','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1671,'04750','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18314,'35564','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20954,'39443','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53723,'97268','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2328,'06390','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29586,'52746','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32290,'56553','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40657,'69163','Thomas','31171','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50368,'89425','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(8780,'19555','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14715,'29845','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4374,'11976','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5665,'14105','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15550,'30660','Wilkes','13317','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47031,'79519','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19914,'38040','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33262,'58053','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53010,'95949','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52368,'94971','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1645,'04680','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1462,'04332','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54639,'98850','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7891,'17920','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5996,'14729','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4335,'11931','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33164,'57761','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42399,'72572','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19635,'37692','Unicoi','47171','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11928,'25537','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49812,'87504','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37325,'63965','Carter','29035','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34649,'60209','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48052,'81503','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42175,'72338','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:53',NULL,NULL),(43635,'74653','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34193,'59463','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47627,'80549','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3368,'09038','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49594,'86337','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41417,'71229','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40445,'68932','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47734,'80817','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54415,'98413','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31292,'55396','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31612,'55959','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37932,'65081','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18301,'35554','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27037,'48897','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25889,'47462','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36583,'62894','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19543,'37385','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29915,'53508','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5378,'13625','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21336,'40069','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2637,'07082','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22438,'42354','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15413,'30537','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47669,'80654','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48187,'82331','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(8272,'18635','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7913,'17951','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16041,'31557','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29489,'52585','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3467,'09373','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(22099,'41631','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20535,'38857','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19177,'37037','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19119,'36910','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21913,'41128','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38665,'66420','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46680,'79031','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17473,'33764','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1634,'04667','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(53787,'97355','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(1948,'05478','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42069,'72134','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5733,'14224','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11507,'24715','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31056,'55053','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36464,'62818','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33064,'57631','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47085,'79553','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9211,'20503','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5976,'14710','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(223,'01026','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18950,'36590','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10213,'22601','Winchester City','51840','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(479,'01731','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28483,'50558','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29203,'52159','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30086,'53810','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45201,'76856','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41908,'72018','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34175,'59448','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(9703,'21284','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26225,'47966','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1209,'03773','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(14011,'28779','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29701,'53044','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22741,'43076','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45983,'78052','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18137,'35179','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20558,'38871','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33795,'58737','None','38999','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41022,'70529','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25628,'47170','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48383,'83241','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(26137,'47881','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26579,'48387','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40638,'69153','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42097,'72164','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(399,'01501','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7804,'17777','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36673,'62952','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2562,'07004','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21025,'39560','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14540,'29628','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15667,'30820','Glascock','13125','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14734,'29899','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42272,'72434','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2471,'06759','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47057,'79535','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53046,'95979','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50254,'89086','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(41920,'72024','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33561,'58461','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37401,'64080','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36286,'62556','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43100,'73666','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26100,'47848','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10436,'23011','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49506,'85901','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(38573,'66090','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33608,'58497','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20684,'39071','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14031,'28804','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53718,'97256','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48983,'84602','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6571,'15622','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8246,'18615','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46444,'78665','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32193,'56452','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29278,'52232','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47805,'80932','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16810,'32713','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(286,'01108','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16785,'32680','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53744,'97307','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(27268,'49252','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12231,'26184','Pleasants','54073','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19674,'37731','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13403,'28173','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30947,'54957','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31794,'56118','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39764,'68056','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28513,'50577','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52507,'95207','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35302,'61348','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1618,'04644','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(43936,'75118','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8146,'18414','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47409,'80201','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29928,'53518','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40019,'68442','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17687,'34108','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22104,'41640','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16612,'32428','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17864,'34652','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31042,'55042','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10841,'23806','Petersburg City','51730','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24302,'45377','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33967,'59067','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52302,'94704','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20625,'38954','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40357,'68836','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47553,'80466','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43897,'75080','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52373,'94976','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50560,'90211','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10171,'22529','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43081,'73654','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7072,'16368','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21949,'41179','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19249,'37082','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6465,'15440','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2278,'06267','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44152,'75433','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20113,'38341','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38758,'66547','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32466,'56750','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12714,'27261','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33539,'58443','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26808,'48705','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19538,'37381','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21777,'40932','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32862,'57376','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33446,'58348','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44670,'76110','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41011,'70521','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33103,'57659','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15856,'31087','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21271,'40013','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7724,'17573','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22713,'43061','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24435,'45656','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24642,'45850','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(712,'02324','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45972,'78040','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10590,'23185','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28427,'50519','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3926,'10560','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12336,'26349','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44078,'75301','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(899,'02769','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29828,'53177','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22140,'41735','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7424,'17028','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45380,'77089','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54352,'98346','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1062,'03225','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(41169,'70737','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43863,'75046','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(85,'00739','Cidra','72041','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(52433,'95066','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48785,'84041','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30788,'54805','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22123,'41701','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11850,'25360','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13168,'27892','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51319,'92391','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19434,'37313','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31937,'56232','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22727,'43067','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29068,'51593','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19234,'37073','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8005,'18069','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26080,'47834','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51251,'92304','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50767,'91108','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29003,'51535','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51296,'92357','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2494,'06798','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28293,'50339','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20877,'39336','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41429,'71237','East Carroll','22035','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4082,'11202','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17755,'34240','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50811,'91307','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15455,'30565','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5383,'13631','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35399,'61452','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11241,'24314','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10400,'22959','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4110,'11231','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15251,'30378','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25015,'46304','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25068,'46381','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30323,'54205','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48910,'84310','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49524,'85935','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49262,'85271','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(18090,'35121','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(468,'01655','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45922,'77994','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39938,'68359','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2403,'06509','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10215,'22603','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10304,'22747','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34517,'60090','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14464,'29560','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15511,'30627','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26194,'47944','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19273,'37098','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45226,'76873','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34315,'59749','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(8342,'18844','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20424,'38685','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22047,'41522','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16163,'31743','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2978,'08031','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11387,'24526','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11902,'25506','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10751,'23461','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2313,'06374','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17888,'34692','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50570,'90232','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53365,'96683','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1995,'05670','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14633,'29702','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35189,'61132','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35649,'61801','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44497,'75930','San Augustine','48405','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10409,'22967','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21721,'40771','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42778,'73059','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50404,'89505','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48304,'82930','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(27859,'49945','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20194,'38453','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36841,'63120','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22206,'42023','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25291,'46783','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45854,'77864','Madison','48313','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6000,'14733','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52999,'95940','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26584,'48401','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23414,'44064','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46954,'79363','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46555,'78832','Kinney','48271','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16104,'31642','Atkinson','13003','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18058,'35079','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41539,'71361','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27932,'50037','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9721,'21502','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1120,'03293','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28718,'50864','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2404,'06510','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54547,'98614','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54079,'97907','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(15722,'31013','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42846,'73118','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39392,'67547','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27496,'49512','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19855,'37924','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45906,'77978','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52658,'95417','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39897,'68335','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8088,'18255','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41375,'71138','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16242,'31803','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12519,'26714','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20584,'38920','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46807,'79118','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4621,'12410','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25066,'46379','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54407,'98404','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53090,'96035','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48274,'82729','Weston','56045','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48032,'81419','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18875,'36482','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3604,'09735','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(24195,'45301','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13465,'28271','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33633,'58533','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33390,'58275','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38416,'65759','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46759,'79082','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48421,'83314','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54073,'97902','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32192,'56450','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28059,'50136','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45369,'77081','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22053,'41534','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27909,'50022','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47565,'80477','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51221,'92254','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55085,'99738','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50220,'89026','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(17584,'33912','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27420,'49411','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12368,'26412','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18455,'35773','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38348,'65711','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36972,'63401','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9191,'20436','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(29262,'52222','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19578,'37424','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47824,'80962','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40550,'69027','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52521,'95225','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21827,'41016','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35813,'62017','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21303,'40047','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10783,'23519','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42670,'72949','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37108,'63624','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39638,'67850','Lane','20101','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27802,'49873','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8244,'18614','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39693,'67951','Stevens','20189','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17616,'33952','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54464,'98524','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53934,'97530','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35356,'61419','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45206,'76858','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48978,'84537','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(4841,'12764','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13119,'27852','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30235,'54106','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8859,'19933','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(43547,'74472','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8270,'18634','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46845,'79233','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49501,'85754','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7236,'16686','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(329,'01257','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9955,'21912','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42747,'73043','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15695,'30912','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13807,'28608','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51470,'92706','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15912,'31217','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8766,'19542','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4595,'12261','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27114,'49037','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51179,'92187','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11481,'24622','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2097,'05868','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(37864,'65036','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20580,'38916','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47828,'80997','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15418,'30540','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2357,'06442','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32746,'57273','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34576,'60140','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22704,'43050','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40680,'69212','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21760,'40870','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8078,'18245','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36908,'63336','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42617,'72856','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3935,'10577','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52246,'94574','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29498,'52591','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7420,'17025','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16235,'31798','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40793,'70071','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28789,'51034','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24752,'46039','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48841,'84095','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(4352,'11952','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42754,'73047','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17328,'33544','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8924,'20026','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17919,'34756','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47241,'79922','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24605,'45828','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48751,'84005','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(2152,'06060','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22779,'43115','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4976,'12946','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7958,'18020','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20710,'39092','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3883,'10506','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38316,'65674','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24318,'45388','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29095,'51649','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54864,'99344','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53317,'96599','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(26939,'48834','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27625,'49689','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5172,'13203','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42698,'73011','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20567,'38878','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11609,'24957','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23586,'44281','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24032,'45065','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(739,'02359','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20463,'38759','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15518,'30631','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28244,'50273','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9140,'20350','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(50470,'90012','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50735,'91001','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48373,'83230','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(5636,'14062','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31955,'56248','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35869,'62074','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21761,'40873','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1649,'04685','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39982,'68410','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32434,'56723','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32810,'57344','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22093,'41616','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21383,'40155','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9834,'21716','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32056,'56324','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3360,'09012','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28868,'51243','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51261,'92315','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3301,'08835','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19112,'36879','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25372,'46910','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14702,'29835','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30132,'53930','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35836,'62040','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12725,'27281','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46745,'79072','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24848,'46126','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53491,'96841','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(28965,'51463','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8281,'18651','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8701,'19456','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4289,'11758','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10047,'22206','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22091,'41612','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10408,'22967','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(634,'02120','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53864,'97440','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19337,'37160','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5191,'13235','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(789,'02495','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38072,'65344','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24983,'46254','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21440,'40245','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53860,'97436','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48419,'83312','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44797,'76305','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45401,'77212','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45266,'76936','Schleicher','48413','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31376,'55552','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2359,'06444','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28932,'51441','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10089,'22312','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54032,'97836','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10288,'22733','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46835,'79226','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18652,'36080','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13037,'27709','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9580,'21082','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51890,'93652','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7495,'17086','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24822,'46107','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9346,'20686','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(44924,'76468','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36418,'62716','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44933,'76474','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10301,'22742','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4693,'12484','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42158,'72324','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7049,'16347','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5466,'13746','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15838,'31076','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27652,'49720','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20673,'39059','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46860,'79243','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7330,'16868','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26876,'48761','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24838,'46120','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50600,'90290','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3279,'08812','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42824,'73096','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1596,'04613','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18439,'35760','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50442,'89802','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5755,'14302','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17369,'33596','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2805,'07709','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14302,'29356','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11484,'24628','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31664,'56010','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24997,'46274','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41589,'71429','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37927,'65079','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15571,'30677','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20783,'39174','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6218,'15051','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46307,'78566','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8554,'19138','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10968,'23958','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40210,'68730','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42050,'72124','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6298,'15203','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15842,'31079','Ben Hill','13017','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29032,'51555','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2663,'07114','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41431,'71237','West Carroll','22123','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14810,'30016','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28156,'50222','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30012,'53579','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30818,'54830','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24593,'45817','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18154,'35204','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9263,'20572','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2307,'06360','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26131,'47874','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6898,'16111','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38426,'65767','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31558,'55917','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3503,'09517','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8742,'19516','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39309,'67459','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13496,'28310','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3652,'09829','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53049,'95981','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40037,'68453','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42873,'73143','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5257,'13365','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23280,'43901','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9943,'21867','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40963,'70451','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11796,'25265','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33860,'58789','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12544,'26802','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47769,'80863','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42373,'72544','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43843,'75027','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54510,'98572','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(18362,'35613','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28218,'50256','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39299,'67451','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11561,'24860','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18585,'36029','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19658,'37719','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10411,'22968','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35148,'61078','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50339,'89315','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(27889,'50002','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51439,'92657','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5458,'13736','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39856,'68304','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47343,'80102','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17356,'33575','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46966,'79371','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49569,'86301','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(913,'02808','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(33266,'58056','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42164,'72328','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21485,'40317','Rowan','21205','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43676,'74759','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7792,'17765','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24894,'46161','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28046,'50127','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5719,'14210','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33287,'58071','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41187,'70757','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15806,'31058','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23085,'43540','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13128,'27862','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10130,'22446','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25903,'47512','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3415,'09211','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2476,'06777','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28855,'51234','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18975,'36644','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40200,'68725','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2434,'06607','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16890,'32810','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23296,'43915','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1611,'04631','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(49058,'84738','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10714,'23418','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1554,'04493','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13668,'28458','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31747,'56073','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(209,'01005','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12545,'26804','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44400,'75759','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31196,'55333','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22529,'42539','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25569,'47118','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46751,'79079','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53323,'96606','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(8014,'18076','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46002,'78067','Zapata','48505','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43488,'74421','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34768,'60487','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(255,'01072','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12191,'26138','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28915,'51366','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47636,'80603','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42702,'73013','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34383,'59864','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15053,'30205','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12284,'26269','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16319,'32025','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41813,'71859','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47983,'81240','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(25460,'46975','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26251,'47983','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52653,'95409','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39544,'67730','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40899,'70358','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53094,'96040','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18038,'35060','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29511,'52624','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22100,'41632','Magoffin','21153','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54535,'98602','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51868,'93631','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38203,'65601','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2461,'06749','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25732,'47327','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53797,'97364','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32653,'57213','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13782,'28584','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7284,'16821','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20037,'38225','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6123,'14867','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46641,'79001','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17594,'33921','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37778,'64784','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33764,'58710','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41931,'72030','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27880,'49967','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14228,'29206','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48428,'83323','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31523,'55793','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15209,'30336','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41527,'71351','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40198,'68724','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45439,'77256','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47980,'81236','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23578,'44274','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54628,'98837','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37570,'64483','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23313,'43937','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25757,'47346','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40847,'70154','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40620,'69144','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10090,'22313','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48339,'83120','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(16547,'32329','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5561,'13863','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6089,'14837','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24068,'45123','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6222,'15055','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24117,'45176','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17342,'33559','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33219,'58027','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10978,'23963','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10584,'23181','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36339,'62635','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38716,'66518','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40665,'69167','McPherson','31117','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12029,'25725','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17349,'33568','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25257,'46760','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49634,'86504','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(38742,'66536','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39704,'68003','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1743,'04937','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28313,'50401','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8347,'18847','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46810,'79118','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16521,'32304','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4719,'12515','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30337,'54216','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38753,'66544','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47987,'81244','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19931,'38053','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42930,'73438','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25037,'46342','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53160,'96113','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5897,'14546','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31294,'55397','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42280,'72440','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5470,'13750','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39800,'68112','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44339,'75666','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19941,'38061','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39829,'68144','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5424,'13673','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18641,'36069','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33498,'58413','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39731,'68028','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18344,'35585','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1099,'03264','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24035,'45068','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2623,'07068','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25415,'46939','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4163,'11414','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2909,'07885','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3717,'10033','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39380,'67526','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37922,'65076','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42129,'72210','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47449,'80232','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48503,'83446','Clark','16033','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(9693,'21263','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4392,'12022','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52103,'94229','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51451,'92677','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1562,'04538','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4876,'12809','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7137,'16509','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13007,'27627','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26655,'48455','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45442,'77259','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26693,'48507','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37452,'64139','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21189,'39818','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52958,'95864','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27513,'49560','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34592,'60151','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12103,'25911','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46621,'78951','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(150,'00921','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(45526,'77362','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49697,'87045','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(5917,'14571','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16019,'31546','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30421,'54433','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52350,'94946','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3933,'10576','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6774,'15905','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35071,'61015','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41494,'71320','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37974,'65240','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1647,'04683','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44086,'75339','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8082,'18249','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22328,'42167','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49699,'87046','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50413,'89513','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(3061,'08202','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2692,'07399','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29504,'52619','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33526,'58433','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26717,'48609','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47961,'81212','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20063,'38259','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17081,'33129','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4310,'11783','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22911,'43319','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39389,'67546','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(700,'02283','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14604,'29673','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25306,'46793','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3889,'10512','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24439,'45657','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22550,'42631','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19314,'37144','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52304,'94706','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13271,'28033','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45997,'78063','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48232,'82605','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(20353,'38626','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21770,'40913','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32723,'57262','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42388,'72561','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49020,'84654','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(652,'02138','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(909,'02802','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(6822,'15961','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47013,'79504','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42960,'73458','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(397,'01475','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25809,'47384','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15529,'30639','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15378,'30520','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28536,'50595','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32681,'57234','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50211,'89017','Lincoln','32017','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(23032,'43501','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21150,'39751','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3459,'09364','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21038,'39572','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37877,'65043','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33675,'58575','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48530,'83526','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47366,'80117','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35330,'61373','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27911,'50022','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15738,'31019','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6692,'15758','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(300,'01199','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32893,'57428','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31003,'55008','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54281,'98261','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42125,'72206','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43482,'74370','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9725,'21520','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45248,'76902','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41094,'70611','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31865,'56167','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38618,'66214','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35584,'61729','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42426,'72617','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43809,'74960','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17426,'33684','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18028,'35049','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5502,'13795','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3608,'09739','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(15359,'30511','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(55150,'99832','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54103,'98013','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7011,'16301','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20610,'38943','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5747,'14267','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3092,'08248','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27549,'49633','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32251,'56520','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10946,'23934','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3788,'10166','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11657,'25047','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(681,'02191','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7814,'17814','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3259,'08753','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1523,'04451','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31698,'56037','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50920,'91608','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55034,'99676','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47808,'80935','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30474,'54469','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46468,'78701','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32226,'56479','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12357,'26384','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30009,'53577','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47064,'79539','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50458,'89883','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(25247,'46747','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25916,'47523','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3771,'10138','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(638,'02124','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23588,'44281','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21215,'39841','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42460,'72648','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41140,'70668','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14928,'30104','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18762,'36305','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21443,'40251','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48755,'84010','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53226,'96275','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(22731,'43069','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12353,'26378','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14809,'30016','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5056,'13052','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15644,'30807','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54965,'99603','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49042,'84721','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(16789,'32692','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20362,'38632','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51817,'93561','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48106,'81650','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12939,'27569','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17261,'33446','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45428,'77242','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6810,'15951','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6266,'15108','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48724,'83856','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(30127,'53927','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41478,'71282','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24093,'45153','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26459,'48206','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24343,'45426','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13690,'28501','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16078,'31627','Cook','13075','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2830,'07737','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10767,'23501','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6193,'15024','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38071,'65340','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47359,'80111','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35546,'61634','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34198,'59467','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7083,'16401','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44410,'75770','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10892,'23870','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27061,'48951','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30866,'54873','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43734,'74857','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43483,'74370','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52313,'94720','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52940,'95831','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45491,'77332','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33244,'58046','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15729,'31015','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20786,'39175','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29062,'51577','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35006,'60941','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33607,'58496','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21037,'39571','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53767,'97333','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19218,'37062','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23991,'44906','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27690,'49751','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32024,'56297','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6155,'14889','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42677,'72957','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27940,'50043','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48377,'83235','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51681,'93282','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54469,'98530','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54384,'98380','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53035,'95970','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40955,'70444','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14475,'29569','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41829,'71910','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35370,'61430','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37736,'64745','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41363,'71115','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43696,'74826','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32786,'57328','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52782,'95602','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32774,'57322','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27188,'49090','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38672,'66427','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45753,'77584','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19470,'37336','Meigs','47121','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45231,'76877','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29665,'53017','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17991,'35013','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14566,'29646','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47667,'80652','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50548,'90091','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5667,'14105','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20133,'38356','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31009,'55013','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21008,'39521','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21638,'40507','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23441,'44093','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17871,'34667','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51144,'92139','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51678,'93278','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7386,'17001','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10061,'22217','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19447,'37324','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46713,'79052','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39496,'67647','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3455,'09356','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2447,'06704','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32921,'57446','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46681,'79032','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54604,'98811','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41861,'71949','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35026,'60956','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33600,'58492','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29470,'52570','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35360,'61421','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28991,'51529','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42628,'72904','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44888,'76448','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13711,'28523','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44947,'76487','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44841,'76385','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26490,'48236','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41958,'72046','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28220,'50257','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36330,'62628','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34411,'59921','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33677,'58577','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40282,'68777','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1826,'05065','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(26710,'48603','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47188,'79781','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39577,'67748','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23288,'43908','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6562,'15613','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28272,'50319','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28141,'50213','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34852,'60558','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6064,'14814','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17620,'33955','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43015,'73546','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18065,'35087','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36433,'62766','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10734,'23440','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48163,'82221','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49566,'86052','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51908,'93673','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7107,'16424','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36633,'62926','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22842,'43164','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10689,'23350','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6575,'15624','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42055,'72127','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40577,'69044','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32452,'56735','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27032,'48894','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5791,'14441','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33979,'59077','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34875,'60604','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8486,'19073','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43174,'73761','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9210,'20502','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(34901,'60631','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13123,'27856','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7779,'17752','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13144,'27875','Hyde','37095','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44807,'76311','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23187,'43738','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41239,'70819','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38743,'66537','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35421,'61470','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31781,'56098','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1806,'05042','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14782,'29945','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19312,'37143','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12417,'26519','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18376,'35630','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1148,'03461','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16193,'31773','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42755,'73048','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54623,'98832','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44685,'76126','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8344,'18845','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34549,'60120','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46956,'79364','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54312,'98294','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27790,'49858','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20182,'38393','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37595,'64502','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45671,'77494','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42837,'73109','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15780,'31038','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15581,'30683','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28178,'50235','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30301,'54165','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18219,'35403','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12259,'26236','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11780,'25245','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17662,'34037','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(24059,'45118','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1081,'03247','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27824,'49892','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30163,'53953','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39650,'67857','Kearny','20093','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21788,'40951','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(436,'01560','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28816,'51053','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7351,'16915','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13300,'28076','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29771,'53109','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30874,'54889','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7849,'17844','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9365,'20709','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45595,'77435','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28628,'50655','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24610,'45831','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33398,'58301','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6990,'16242','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5832,'14482','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7905,'17938','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35217,'61257','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28224,'50258','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16588,'32404','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19419,'37250','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17725,'34209','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34335,'59803','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(43578,'74553','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46463,'78680','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12952,'27582','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(556,'01915','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20174,'38387','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19680,'37742','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8059,'18223','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31744,'56071','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50753,'91040','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41090,'70607','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28731,'51001','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31236,'55358','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16891,'32811','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37712,'64725','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34380,'59859','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(10776,'23510','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48122,'82009','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(50814,'91310','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53478,'96821','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(15105,'30251','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24779,'46058','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11358,'24485','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4716,'12512','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6038,'14781','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(781,'02477','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14173,'29129','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22065,'41549','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25094,'46501','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29053,'51570','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18801,'36351','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24951,'46222','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40238,'68748','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32702,'57249','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15917,'31221','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46972,'79377','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34702,'60438','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40358,'68836','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18612,'36043','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20461,'38756','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16936,'32891','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26177,'47930','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(55111,'99764','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25653,'47228','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8256,'18622','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35907,'62095','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15228,'30350','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7614,'17320','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21868,'41056','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17293,'33483','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15201,'30328','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2728,'07460','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33038,'57572','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45344,'77056','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16418,'32140','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11461,'24599','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9762,'21620','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41871,'71960','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46066,'78148','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25400,'46929','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22064,'41548','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23882,'44813','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7649,'17364','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35389,'61447','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7570,'17244','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14020,'28787','Madison','37115','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30578,'54559','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26821,'48726','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9853,'21749','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3998,'10932','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48515,'83463','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50810,'91307','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11520,'24739','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39610,'67835','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6431,'15377','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17231,'33416','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5124,'13126','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10306,'22749','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51564,'93030','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22557,'42642','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51183,'92193','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23636,'44410','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26930,'48829','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8491,'19078','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43602,'74574','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31980,'56266','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1445,'04274','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18740,'36272','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45483,'77326','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44690,'76131','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15774,'31036','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5884,'14534','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9673,'21229','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2354,'06439','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52824,'95637','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21627,'40486','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51996,'93955','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9904,'21801','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18996,'36722','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50017,'88130','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52387,'95008','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53763,'97329','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51651,'93249','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1284,'03874','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12642,'27106','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27950,'50049','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34287,'59716','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42723,'73025','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39644,'67853','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48685,'83813','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10988,'23976','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20926,'39402','Lamar','28073','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24595,'45817','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47915,'81101','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22859,'43215','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27803,'49873','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51722,'93421','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51795,'93535','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49674,'87021','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(34415,'59925','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14669,'29801','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18456,'35773','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42917,'73401','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15811,'31061','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14205,'29161','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53360,'96677','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(364,'01370','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7545,'17219','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24000,'45012','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30795,'54813','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1388,'04103','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13620,'28423','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13136,'27869','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5184,'13217','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26059,'47736','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39260,'67425','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38255,'65632','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5091,'13084','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43017,'73548','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48143,'82082','Kimball','31105','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49859,'87558','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49288,'85310','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2806,'07710','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5353,'13599','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23678,'44450','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41451,'71256','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29220,'52171','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39334,'67483','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38927,'66863','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38455,'65787','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54456,'98508','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26427,'48170','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31762,'56085','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48456,'83348','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42163,'72327','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30615,'54623','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5201,'13304','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5117,'13120','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39530,'67667','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17795,'34420','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22633,'42784','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11515,'24733','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30515,'54499','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5406,'13655','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26187,'47941','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1134,'03443','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9905,'21802','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11778,'25244','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45207,'76858','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44013,'75206','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17513,'33826','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50924,'91612','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5631,'14058','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26822,'48727','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4692,'12483','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6653,'15716','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46623,'78953','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37426,'64111','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17357,'33576','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40770,'70044','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13915,'28692','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5515,'13810','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1833,'05073','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34243,'59542','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49906,'87745','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53263,'96377','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53929,'97526','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51383,'92564','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39732,'68028','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44265,'75564','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8644,'19365','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2890,'07855','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31831,'56144','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46203,'78361','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17559,'33880','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46448,'78666','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52651,'95406','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38439,'65774','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45230,'76875','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24898,'46163','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23522,'44214','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5699,'14150','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37269,'63870','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11756,'25204','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40619,'69143','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36459,'62814','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34096,'59327','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(8098,'18323','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14151,'29112','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49889,'87718','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(13819,'28618','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21272,'40013','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7242,'16693','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7265,'16735','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12076,'25857','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11407,'24543','Danville City','51590','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7313,'16851','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49230,'85215','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47745,'80827','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19468,'37336','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34146,'59418','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13637,'28438','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17076,'33124','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11500,'24656','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1054,'03217','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2875,'07839','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35136,'61068','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23647,'44423','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41287,'71031','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(905,'02783','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40823,'70119','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48940,'84339','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47605,'80527','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32083,'56339','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35660,'61816','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31827,'56141','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29102,'51654','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47642,'80615','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32683,'57235','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4234,'11599','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43934,'75116','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45760,'77592','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46494,'78728','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(504,'01812','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53571,'97035','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52957,'95860','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49542,'86020','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33597,'58490','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49653,'87002','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54196,'98132','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39550,'67732','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4688,'12480','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44383,'75712','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54015,'97814','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53367,'96687','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(29119,'52037','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3746,'10108','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43391,'74127','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7264,'16735','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26309,'48045','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20760,'39152','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12860,'27508','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13750,'28557','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41497,'71322','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7158,'16611','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10393,'22948','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25530,'47033','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19647,'37709','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44983,'76528','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33925,'59029','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28844,'51111','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54278,'98258','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29239,'52208','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22799,'43137','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28430,'50520','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(55108,'99761','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(31757,'56082','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5604,'14032','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30183,'53965','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5144,'13146','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49252,'85259','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17863,'34639','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30900,'54921','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23940,'44851','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19618,'37663','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40907,'70371','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38887,'66833','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40969,'70456','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(950,'02864','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(13015,'27656','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18508,'35957','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30020,'53585','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(55092,'99745','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(24442,'45660','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35398,'61451','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53132,'96084','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49857,'87556','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49462,'85713','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42068,'72134','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5486,'13774','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4913,'12852','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11073,'24079','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1381,'04094','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45173,'76831','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36587,'62896','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50941,'91722','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20446,'38737','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6362,'15277','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25115,'46524','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25697,'47272','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15474,'30582','Towns','13281','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11052,'24062','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9979,'22033','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28838,'51105','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53371,'96704','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(38400,'65746','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35693,'61848','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17406,'33635','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18649,'36078','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35024,'60955','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33554,'58456','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20075,'38305','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13340,'28107','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7866,'17864','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28030,'50117','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8562,'19146','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23684,'44455','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45831,'77834','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52745,'95538','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53224,'96269','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(47223,'79902','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15772,'31036','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44445,'75835','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46582,'78879','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13526,'28337','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54593,'98674','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38047,'65324','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27473,'49455','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27429,'49417','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54890,'99371','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9336,'20670','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24146,'45230','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22225,'42039','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30196,'54004','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35992,'62269','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4606,'12306','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45795,'77660','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9681,'21236','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8978,'20097','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35200,'61238','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23284,'43905','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31057,'55054','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49130,'85029','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(16169,'31749','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11156,'24174','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35667,'61822','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9977,'22032','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3498,'09508','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35164,'61091','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31469,'55735','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18134,'35176','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27761,'49822','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31215,'55342','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18498,'35951','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45990,'78058','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12470,'26610','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14790,'30005','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10391,'22947','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11225,'24277','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50237,'89045','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50217,'89023','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(8002,'18066','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6752,'15851','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22904,'43316','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39443,'67583','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19338,'37161','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39378,'67526','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34300,'59729','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38,'00670','Camuy','72027','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(52538,'95241','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35791,'61951','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19869,'37940','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4900,'12838','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4816,'12736','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9279,'20597','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(23171,'43725','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17947,'34951','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47117,'79701','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30353,'54235','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31051,'55051','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23069,'43526','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39991,'68418','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5372,'13619','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14138,'29101','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25197,'46680','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4058,'11023','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20455,'38749','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4304,'11776','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26711,'48604','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11297,'24411','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13051,'27803','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23644,'44418','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39409,'67557','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48961,'84516','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5957,'14639','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6485,'15464','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6644,'15701','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53517,'96928','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(53970,'97640','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26562,'48362','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10993,'24005','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44969,'76522','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11498,'24649','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5713,'14204','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49087,'84770','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49109,'85008','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(16832,'32739','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4887,'12822','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43331,'74061','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34691,'60430','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24888,'46158','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19202,'37052','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51253,'92307','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5541,'13841','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10660,'23297','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4081,'11201','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1419,'04236','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38636,'66282','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41112,'70643','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45828,'77831','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16074,'31624','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5503,'13796','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39818,'68133','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49325,'85353','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51704,'93384','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50807,'91304','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41962,'72052','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37032,'63468','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7150,'16546','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30669,'54662','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52131,'94271','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39188,'67226','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42590,'72834','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46619,'78950','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8315,'18815','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25515,'47017','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54311,'98293','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48277,'82731','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(29881,'53234','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15398,'30531','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45674,'77498','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29588,'52747','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6374,'15311','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11327,'24450','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42958,'73456','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26326,'48067','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39241,'67361','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48967,'84525','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30705,'54729','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28400,'50477','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13284,'28042','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47420,'80212','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5034,'13033','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4969,'12939','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49880,'87594','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51168,'92171','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50094,'88355','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(10359,'22908','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44155,'75435','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16427,'32157','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14572,'29650','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42809,'73080','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40468,'68943','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39589,'67756','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27964,'50057','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52414,'95041','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36991,'63440','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25086,'46404','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40029,'68448','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11422,'24557','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4980,'12953','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23285,'43906','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42411,'72585','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53806,'97371','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43770,'74883','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13891,'28673','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18039,'35061','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41833,'71920','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38065,'65336','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43224,'73860','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14179,'29133','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50655,'90624','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11065,'24072','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16697,'32549','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5652,'14082','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50152,'88548','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(49313,'85341','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(16228,'31794','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8268,'18631','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4001,'10940','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2738,'07495','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37283,'63902','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40287,'68781','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53686,'97214','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(27775,'49838','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40386,'68859','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37944,'65105','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16373,'32091','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28952,'51454','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42187,'72348','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45602,'77443','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8066,'18234','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51905,'93668','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38828,'66736','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13474,'28282','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2664,'07175','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16463,'32203','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42160,'72325','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51424,'92628','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31024,'55027','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39843,'68178','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14250,'29227','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23889,'44818','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35123,'61062','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17926,'34769','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19017,'36751','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5928,'14591','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39190,'67228','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15312,'30450','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51415,'92617','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50859,'91367','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15475,'30582','Union','13291','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6846,'16030','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8560,'19144','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34981,'60921','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33630,'58531','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5401,'13649','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47570,'80482','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9477,'20861','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9402,'20751','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4794,'12601','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24483,'45692','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52835,'95648','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19631,'37687','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19650,'37711','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25131,'46539','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3339,'08887','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50832,'91334','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1149,'03462','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19840,'37902','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29100,'51653','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48254,'82701','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33632,'58532','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4910,'12849','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4651,'12441','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54897,'99503','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51851,'93620','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50663,'90638','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11565,'24867','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5872,'14525','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29667,'53018','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53984,'97731','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53485,'96830','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(19388,'37210','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19697,'37756','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22285,'42104','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44237,'75494','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27501,'49519','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23960,'44867','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16145,'31719','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11322,'24441','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22472,'42411','Caldwell','21033','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32987,'57531','Jones','46075','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47791,'80919','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12388,'26435','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46168,'78294','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22385,'42275','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2862,'07826','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1252,'03841','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52632,'95380','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52480,'95151','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17075,'33122','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14708,'29840','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24656,'45860','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15411,'30536','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1947,'05477','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8192,'18454','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5984,'14719','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14045,'28906','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39480,'67639','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38359,'65720','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5533,'13835','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27314,'49301','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37101,'63620','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18243,'35459','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36763,'63036','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22028,'41425','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26962,'48845','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24374,'45481','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21277,'40019','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32108,'56356','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14505,'29594','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48416,'83302','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40121,'68634','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(569,'01949','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40604,'69131','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33883,'58844','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31342,'55440','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50077,'88339','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(31201,'55335','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16389,'32113','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39894,'68332','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27546,'49631','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52795,'95614','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50011,'88123','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(34206,'59477','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22543,'42567','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27116,'49038','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(581,'01983','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32553,'57035','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50158,'88556','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(46072,'78154','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20241,'38488','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2997,'08051','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28255,'50302','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24557,'45776','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21550,'40379','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8828,'19803','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(50052,'88262','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(20546,'38863','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15610,'30735','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37872,'65041','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43128,'73726','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43332,'74062','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49578,'86320','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1183,'03604','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39670,'67870','Haskell','20081','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3245,'08731','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21357,'40110','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33123,'57718','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54163,'98083','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31278,'55388','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45834,'77836','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31844,'56155','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29982,'53558','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48244,'82638','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(6889,'16066','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44720,'76197','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39531,'67669','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8652,'19375','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13965,'28739','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11427,'24563','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31590,'55944','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32447,'56732','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23294,'43913','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13916,'28693','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51586,'93101','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12797,'27351','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5267,'13407','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11913,'25517','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21041,'39573','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8555,'19139','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42038,'72115','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41319,'71065','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37860,'65032','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23951,'44860','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11642,'25026','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28589,'50628','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20148,'38366','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31036,'55037','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13488,'28304','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38713,'66516','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39873,'68319','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41712,'71675','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41896,'72007','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7372,'16938','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21514,'40347','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35488,'61537','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30104,'53901','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9667,'21226','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12121,'25951','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47837,'81008','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33011,'57551','Bennett','46007','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30054,'53719','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16622,'32438','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36777,'63049','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39917,'68345','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10981,'23966','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14342,'29416','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2709,'07430','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35858,'62061','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30416,'54428','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30247,'54114','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24709,'45894','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31049,'55049','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4962,'12930','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40049,'68461','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15299,'30441','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28696,'50846','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27944,'50046','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27568,'49645','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33682,'58581','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37796,'64836','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44961,'76511','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3025,'08080','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10869,'23843','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2652,'07102','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39067,'67056','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19533,'37378','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1472,'04347','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42304,'72461','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15815,'31062','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9076,'20197','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23103,'43556','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20719,'39097','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31349,'55447','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8847,'19896','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(3649,'09826','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(47833,'81005','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12015,'25711','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13228,'27967','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33101,'57657','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33575,'58474','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33014,'57552','Jones','46075','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(271,'01090','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16368,'32084','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41297,'71040','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20768,'39160','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39955,'68370','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45989,'78058','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49122,'85021','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37572,'64484','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11370,'24504','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37396,'64077','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27981,'50066','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1706,'04852','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18116,'35147','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20894,'39350','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13276,'28036','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47708,'80749','Sedgwick','8115','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6183,'15012','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21381,'40152','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7945,'18010','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(222,'01022','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41650,'71497','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22373,'42256','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15084,'30230','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46874,'79250','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29528,'52640','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37499,'64423','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51751,'93451','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46421,'78654','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32314,'56572','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6299,'15204','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26868,'48758','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1907,'05407','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(52459,'95122','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21535,'40362','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44714,'76190','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7417,'17022','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21384,'40157','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33125,'57719','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8963,'20069','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(49286,'85308','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14388,'29458','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11821,'25312','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33658,'58562','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3590,'09720','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8890,'19967','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(24646,'45853','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18621,'36051','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51271,'92325','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38315,'65674','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5416,'13665','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3956,'10605','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46212,'78371','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3015,'08070','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38987,'66960','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6825,'15963','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43731,'74855','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14982,'30142','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9488,'20878','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28944,'51449','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23867,'44802','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25301,'46788','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15836,'31075','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33861,'58789','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34079,'59311','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(14201,'29160','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47487,'80281','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49535,'86004','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1293,'03887','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15453,'30564','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2400,'06506','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41528,'71353','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18624,'36052','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11836,'25330','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40083,'68527','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50296,'89141','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33833,'58769','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12495,'26660','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19771,'37846','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17071,'33112','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32061,'56327','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2496,'06804','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45378,'77087','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53824,'97390','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36359,'62661','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17351,'33570','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24078,'45135','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43784,'74936','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40688,'69217','Rock','31149','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34092,'59322','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52785,'95604','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51197,'92225','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11453,'24592','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24537,'45745','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45088,'76653','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46107,'78223','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46389,'78632','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18213,'35295','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15672,'30821','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31576,'55932','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50973,'91765','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36812,'63088','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39608,'67834','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15484,'30604','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25499,'46996','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7188,'16641','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36809,'63084','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35528,'61602','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36552,'62877','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51508,'92840','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45817,'77801','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9684,'21237','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49988,'88063','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50299,'89144','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(27057,'48929','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29361,'52337','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32371,'56641','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36239,'62518','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6624,'15681','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2608,'07055','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13429,'28223','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32539,'57026','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33279,'58064','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36329,'62627','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36875,'63147','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48303,'82930','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(23783,'44645','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38112,'65441','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44282,'75602','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23536,'44230','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45164,'76823','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38109,'65440','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12924,'27557','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16197,'31775','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10438,'23015','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15909,'31211','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1815,'05051','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(195,'00979','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14621,'29689','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49455,'85706','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31863,'56166','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19461,'37331','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20245,'38502','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30931,'54944','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3277,'08810','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44284,'75603','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4405,'12036','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30487,'54479','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34699,'60436','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36769,'63041','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45479,'77318','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34682,'60422','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39717,'68016','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32866,'57381','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18770,'36316','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(937,'02838','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(21892,'41092','Gallatin','21077','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32436,'56724','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27334,'49314','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23395,'44046','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36042,'62320','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18588,'36030','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44827,'76372','Throckmorton','48447','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10073,'22246','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15897,'31202','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51779,'93517','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50634,'90505','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34403,'59914','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42584,'72829','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9870,'21771','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36678,'62956','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9761,'21620','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15482,'30602','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(145,'00916','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(40197,'68723','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10965,'23954','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33409,'58321','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33886,'58845','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28828,'51060','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29576,'52734','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30859,'54868','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22169,'41815','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35401,'61453','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31343,'55441','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17511,'33825','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17298,'33493','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53749,'97312','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49852,'87549','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37898,'65059','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26216,'47959','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39583,'67752','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28436,'50524','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50591,'90266','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4481,'12131','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22227,'42039','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13211,'27946','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46025,'78109','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16991,'32970','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37207,'63779','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24705,'45889','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26582,'48393','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41093,'70611','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28171,'50230','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3511,'09549','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19217,'37061','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1969,'05609','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18940,'36577','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51157,'92159','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29069,'51601','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32370,'56639','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35985,'62264','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25121,'46530','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8459,'19040','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50664,'90638','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52002,'94011','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6289,'15143','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11746,'25181','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32274,'56541','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40765,'70038','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45449,'77268','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8892,'19969','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(23906,'44833','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40383,'68858','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9574,'21075','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39666,'67868','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22090,'41607','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51706,'93386','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37092,'63565','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38407,'65753','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5525,'13825','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42488,'72680','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48030,'81416','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45826,'77830','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41411,'71225','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51298,'92359','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52409,'95035','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50954,'91741','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32877,'57385','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30930,'54943','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8613,'19319','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48136,'82063','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7470,'17066','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33275,'58062','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18988,'36701','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22730,'43068','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4313,'11787','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55021,'99663','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(22177,'41828','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5159,'13159','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19148,'37022','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48600,'83639','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6631,'15686','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51698,'93311','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(800,'02542','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47666,'80651','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16979,'32958','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46627,'78956','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11221,'24271','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5069,'13064','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2789,'07656','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54483,'98542','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28236,'50266','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6314,'15219','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48528,'83524','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(17446,'33714','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48100,'81643','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10387,'22943','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7931,'17976','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47527,'80436','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24254,'45338','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28099,'50156','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16670,'32512','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33152,'57752','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53456,'96799','American Samoa','60050','AS','American Samoa',0,'2013-07-03 15:17:54',NULL,NULL),(14333,'29407','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21639,'40508','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49264,'85275','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45724,'77552','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41788,'71837','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31726,'56058','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50593,'90270','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43334,'74063','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29443,'52553','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51585,'93099','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13408,'28204','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1564,'04541','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50654,'90623','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19380,'37203','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10781,'23517','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16352,'32065','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32199,'56459','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45361,'77073','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39537,'67673','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21493,'40328','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52153,'94298','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23046,'43512','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41707,'71671','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10188,'22552','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41498,'71323','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50348,'89405','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51149,'92147','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49842,'87535','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(39335,'67484','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38044,'65323','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11466,'24603','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11685,'25083','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5029,'13030','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26634,'48440','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22157,'41772','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41036,'70541','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38835,'66743','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2258,'06244','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7907,'17943','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13110,'27846','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13694,'28504','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28712,'50859','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30425,'54435','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47694,'80737','Deuel','31049','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52155,'94301','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47977,'81232','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40429,'68920','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38023,'65281','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9037,'20152','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8611,'19318','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21310,'40051','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21979,'41255','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27106,'49030','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36899,'63302','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46829,'79201','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42504,'72711','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48610,'83647','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31441,'55706','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2177,'06084','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7970,'18038','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7582,'17257','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41590,'71430','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21238,'39866','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2707,'07424','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54272,'98251','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10317,'22815','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44401,'75760','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15950,'31326','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53705,'97229','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(18021,'35042','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28431,'50521','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35814,'62018','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53018,'95957','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44741,'76230','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43487,'74403','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44182,'75452','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37168,'63730','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26772,'48638','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26148,'47905','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5252,'13360','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5856,'14512','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6157,'14892','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6856,'16038','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1832,'05072','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(38452,'65785','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50392,'89447','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(13907,'28685','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9492,'20883','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33023,'57560','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47111,'79606','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14135,'29081','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40344,'68828','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1928,'05456','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16824,'32727','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28511,'50576','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34798,'60516','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34864,'60568','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38674,'66428','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41946,'72040','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9648,'21212','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(48126,'82052','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45191,'76849','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26757,'48628','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46046,'78125','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29282,'52236','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52068,'94128','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27412,'49403','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31699,'56039','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19279,'37110','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52996,'95938','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6727,'15824','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24872,'46148','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22258,'42066','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14568,'29648','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46343,'78606','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26125,'47870','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1107,'03276','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5926,'14590','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12840,'27435','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43214,'73852','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16348,'32061','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18251,'35466','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35195,'61233','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54246,'98225','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23079,'43533','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16884,'32804','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37887,'65051','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15920,'31296','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33491,'58385','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27579,'49656','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15293,'30436','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16594,'32410','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8089,'18255','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30875,'54889','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49994,'88101','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50972,'91764','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(316,'01237','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39223,'67347','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11957,'25614','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28921,'51431','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31364,'55474','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31889,'56186','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36449,'62807','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52895,'95713','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52062,'94122','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44123,'75410','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41609,'71449','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46744,'79072','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14082,'29037','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2228,'06150','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24936,'46204','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24178,'45258','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17857,'34611','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29354,'52333','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30236,'54107','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30969,'54971','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31462,'55730','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40223,'68739','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16054,'31567','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(433,'01545','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36203,'62466','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7042,'16341','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8222,'18507','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22982,'43416','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24328,'45409','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45184,'76842','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36787,'63060','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1441,'04267','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7914,'17952','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19709,'37769','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2290,'06331','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4956,'12923','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52562,'95307','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51937,'93729','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50165,'88563','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(45872,'77879','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43749,'74865','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7094,'16410','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12629,'27053','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24324,'45403','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42138,'72222','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37143,'63650','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3486,'09469','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28605,'50638','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53473,'96816','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(48343,'83124','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46140,'78254','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23381,'44028','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2634,'07079','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27627,'49690','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1314,'04006','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9566,'21057','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22027,'41421','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21479,'40311','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40849,'70157','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31526,'55797','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13083,'27825','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10070,'22243','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32167,'56433','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3292,'08827','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34917,'60649','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11282,'24368','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(577,'01969','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12728,'27283','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44353,'75683','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45935,'78006','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47174,'79764','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54192,'98126','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11362,'24487','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9400,'20749','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45425,'77238','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5600,'14030','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12635,'27098','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25795,'47369','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16399,'32123','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32503,'57002','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31165,'55314','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52609,'95356','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22936,'43338','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39357,'67512','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47098,'79566','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47396,'80137','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49843,'87535','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(5107,'13111','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14686,'29821','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42907,'73184','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36178,'62449','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28274,'50320','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7258,'16729','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48145,'82082','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30599,'54612','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34088,'59316','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28856,'51234','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21591,'40437','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21116,'39701','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15395,'30530','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3536,'09590','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7262,'16733','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15663,'30817','Wilkes','13317','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6080,'14826','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29302,'52253','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46138,'78253','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24859,'46135','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27035,'48896','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38810,'66716','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7674,'17506','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1777,'04974','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9128,'20299','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24679,'45873','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4895,'12833','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27662,'49728','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5707,'14172','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5786,'14433','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48896,'84184','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41938,'72034','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47198,'79830','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31653,'55991','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50020,'88134','De Baca','35011','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47439,'80226','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44324,'75654','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40447,'68932','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39044,'67037','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34291,'59720','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(53121,'96070','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28972,'51467','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43190,'73802','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4029,'10980','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8694,'19446','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13660,'28454','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33831,'58768','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23604,'44308','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25454,'46970','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26027,'47670','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8528,'19113','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22452,'42371','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35912,'62202','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42189,'72350','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10697,'23396','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42721,'73024','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17408,'33646','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27671,'49735','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2159,'06067','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24701,'45887','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17197,'33330','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52781,'95601','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2888,'07852','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30887,'54909','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22802,'43138','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17902,'34734','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36410,'62704','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50619,'90401','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44309,'75643','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45454,'77273','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14860,'30055','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34366,'59844','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54578,'98651','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28574,'50619','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2697,'07410','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45477,'77315','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50333,'89195','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36821,'63104','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38934,'66868','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54556,'98624','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35044,'60963','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7960,'18030','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3230,'08648','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51473,'92711','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6639,'15693','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9891,'21787','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15821,'31065','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2935,'07950','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11955,'25611','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30320,'54201','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29606,'52760','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52816,'95630','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53914,'97495','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25639,'47199','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25713,'47303','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32010,'56289','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34200,'59468','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37838,'65010','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40384,'68858','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44867,'76436','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43616,'74632','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28091,'50153','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43398,'74132','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51514,'92846','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46180,'78336','Aransas','48007','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15222,'30345','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7625,'17332','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30567,'54552','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23930,'44846','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40745,'69363','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11213,'24260','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4441,'12071','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20941,'39428','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6414,'15353','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26003,'47630','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27019,'48886','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7768,'17740','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15589,'30710','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5478,'13756','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46892,'79261','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3166,'08518','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21673,'40579','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51589,'93105','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54983,'99623','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(477,'01721','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38967,'66945','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35025,'60955','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34548,'60120','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24221,'45317','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42207,'72368','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7734,'17585','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21323,'40060','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29468,'52569','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21670,'40576','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47787,'80915','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15185,'30315','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43060,'73626','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42995,'73532','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18420,'35748','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17808,'34441','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38271,'65640','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8709,'19465','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47337,'80045','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31878,'56177','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29796,'53139','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1607,'04627','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52798,'95616','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3846,'10312','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19722,'37779','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23257,'43822','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9348,'20688','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52265,'94595','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15076,'30224','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10486,'23069','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36999,'63446','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49915,'87821','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(32800,'57335','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30618,'54625','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9909,'21811','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15490,'30607','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23605,'44309','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6391,'15329','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22665,'43017','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17038,'33055','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21255,'40006','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15052,'30204','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30031,'53594','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32616,'57071','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51883,'93646','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32751,'57279','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20619,'38950','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6008,'14740','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11670,'25063','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20988,'39478','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46210,'78369','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39215,'67341','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7297,'16835','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47289,'80001','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47113,'79608','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38641,'66402','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34378,'59856','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29110,'52031','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24695,'45885','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46333,'78594','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5540,'13841','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18064,'35087','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53710,'97231','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31101,'55092','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45218,'76869','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23154,'43702','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23514,'44202','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27399,'49348','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4221,'11570','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14169,'29128','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53067,'96010','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53157,'96110','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48247,'82640','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45059,'76630','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43076,'73648','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39554,'67735','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9948,'21875','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42133,'72215','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41865,'71953','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24017,'45042','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25474,'46982','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31714,'56050','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33415,'58324','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50731,'90848','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49575,'86313','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43524,'74452','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36871,'63143','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30815,'54829','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20233,'38483','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21622,'40484','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2615,'07062','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26184,'47933','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(295,'01138','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46332,'78593','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43474,'74364','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20346,'38621','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33505,'58418','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1638,'04672','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50087,'88348','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40767,'70040','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38437,'65773','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1881,'05341','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21746,'40840','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41533,'71357','Tensas','22107','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12563,'26851','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3931,'10573','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(21599,'40445','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24235,'45326','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50502,'90044','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46553,'78829','Zavala','48507','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47146,'79733','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48702,'83833','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48516,'83464','Clark','16033','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(23638,'44412','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30232,'54104','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45053,'76626','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12338,'26351','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50700,'90744','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21510,'40346','Menifee','21165','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17906,'34740','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54854,'99328','Columbia','53013','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53696,'97221','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29323,'52313','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6175,'15005','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49102,'85001','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45889,'77961','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44552,'75979','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27916,'50026','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40588,'69120','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6238,'15069','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25442,'46960','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45044,'76598','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35418,'61468','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52714,'95480','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53421,'96760','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(17147,'33222','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49625,'86440','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25484,'46988','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16140,'31714','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(55006,'99648','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(40501,'68966','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38738,'66535','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54514,'98579','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6042,'14785','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32939,'57460','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1159,'03574','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4808,'12725','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41916,'72022','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22679,'43029','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(748,'02375','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54492,'98555','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45540,'77374','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41997,'72080','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20779,'39169','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13327,'28097','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16266,'31822','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34578,'60142','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36140,'62426','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44079,'75303','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47712,'80755','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46071,'78152','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39020,'67021','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20458,'38753','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10747,'23458','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51561,'93022','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50401,'89502','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(16372,'32091','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11219,'24270','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15029,'30178','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36290,'62558','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14281,'29331','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20730,'39114','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33094,'57649','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1112,'03281','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39289,'67448','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45816,'77726','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14635,'29704','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15064,'30217','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25948,'47553','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14863,'30056','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2558,'06928','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47140,'79720','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24930,'46186','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8073,'18240','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30738,'54749','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40142,'68643','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46825,'79201','Childress','48075','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45316,'77030','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36640,'62931','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30434,'54443','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2514,'06840','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45333,'77047','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24207,'45309','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13285,'28043','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32879,'57399','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36231,'62510','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3384,'09081','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(1298,'03901','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37098,'63620','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34441,'60010','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19623,'37680','Johnson','47091','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8432,'19012','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45459,'77280','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33700,'58626','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29867,'53217','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47802,'80929','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19549,'37388','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16042,'31558','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16512,'32257','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27991,'50071','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18587,'36030','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31204,'55336','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36719,'62992','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47561,'80473','Jackson','8057','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46916,'79336','Cochran','48079','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46859,'79241','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42953,'73453','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34510,'60084','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32550,'57034','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10613,'23227','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12315,'26321','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18015,'35035','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13696,'28509','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27798,'49868','Luce','26095','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25232,'46737','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7269,'16743','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38908,'66849','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37524,'64444','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6174,'15004','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53259,'96373','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1913,'05443','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3034,'08087','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54189,'98122','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48328,'83110','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(854,'02666','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(869,'02717','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10824,'23702','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4118,'11239','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45903,'77975','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22672,'43021','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39301,'67452','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54977,'99614','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46917,'79336','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43363,'74083','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42683,'73001','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41686,'71656','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40885,'70340','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39056,'67049','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34104,'59336','Fallon','30025','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31262,'55377','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28559,'50607','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19465,'37334','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10316,'22812','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26979,'48858','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41549,'71371','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17418,'33673','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52749,'95543','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51788,'93527','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46670,'79022','Oldham','48359','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39526,'67664','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8165,'18430','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49310,'85338','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39382,'67529','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35958,'62249','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35228,'61264','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51009,'91909','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46952,'79363','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33074,'57638','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32415,'56685','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29913,'53507','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11659,'25048','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3494,'09504','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(13483,'28299','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12974,'27597','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39384,'67530','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54321,'98311','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41317,'71063','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17515,'33830','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27897,'50009','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15923,'31301','Long','13183','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17657,'34032','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(34216,'59489','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32952,'57469','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29533,'52644','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18604,'36038','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50707,'90801','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39674,'67871','Scott','20171','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46017,'78101','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41933,'72031','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38519,'66039','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34749,'60470','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9985,'22039','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15111,'30256','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27544,'49630','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5520,'13813','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27664,'49729','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12184,'26133','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8397,'18955','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25354,'46866','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37989,'65254','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49331,'85359','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47397,'80138','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39013,'67017','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24279,'45356','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50031,'88211','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53640,'97124','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46820,'79172','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42090,'72157','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40786,'70064','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54914,'99521','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(28412,'50484','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27018,'48886','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31189,'55330','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40549,'69026','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46513,'78744','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14067,'29020','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28999,'51533','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11878,'25428','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49371,'85536','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49146,'85045','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45006,'76548','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34632,'60188','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34271,'59643','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12580,'27010','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(15664,'30818','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25842,'47431','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7657,'17372','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46003,'78069','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24497,'45710','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35633,'61769','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34157,'59430','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32540,'57027','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19664,'37724','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15622,'30742','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18966,'36617','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4149,'11373','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7653,'17370','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18468,'35807','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53180,'96134','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42141,'72227','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21184,'39813','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40193,'68719','Boyd','31015','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14461,'29555','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41092,'70609','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38556,'66072','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54866,'99344','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46380,'78626','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42733,'73031','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34194,'59464','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29961,'53542','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12331,'26346','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15217,'30340','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47780,'80908','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41150,'70715','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7710,'17555','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15794,'31046','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39011,'67016','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34862,'60566','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52001,'94010','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48813,'84066','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6751,'15849','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44281,'75602','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19987,'38128','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26153,'47909','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54334,'98328','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53448,'96789','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50349,'89406','Churchill','32001','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(21176,'39769','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11546,'24844','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5706,'14171','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(832,'02639','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24453,'45672','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31596,'55947','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26329,'48070','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7715,'17564','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35493,'61543','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51297,'92358','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2684,'07304','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3484,'09464','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9530,'21012','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53100,'96049','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52183,'94514','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50388,'89444','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(38207,'65604','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37645,'64644','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22425,'42345','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11386,'24523','Bedford City','51515','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31583,'55940','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46159,'78280','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17178,'33311','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9604,'21122','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15833,'31071','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3774,'10152','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13166,'27890','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17050,'33070','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32041,'56313','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14925,'30103','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6385,'15322','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2751,'07513','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24880,'46151','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13951,'28728','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23123,'43605','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42148,'72310','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30096,'53820','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31494,'55760','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33130,'57724','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(41031,'70535','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39689,'67901','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2484,'06785','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23724,'44601','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17979,'34996','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36394,'62690','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50918,'91606','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49772,'87310','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(18293,'35548','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28951,'51454','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43269,'74017','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35214,'61252','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30786,'54801','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28421,'50515','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12257,'26230','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3276,'08809','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26563,'48363','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27224,'49128','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27223,'49127','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22519,'42503','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10918,'23894','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42242,'72404','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35053,'60970','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3669,'09848','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29725,'53066','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12577,'27006','Davie','37059','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(55027,'99669','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51492,'92814','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48591,'83633','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36414,'62708','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35424,'61472','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2337,'06412','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24215,'45314','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4555,'12209','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40553,'69028','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48202,'82422','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(9700,'21280','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11711,'25124','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19498,'37357','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30792,'54812','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38871,'66776','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1325,'04019','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11124,'24136','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10740,'23452','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(233,'01036','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41056,'70560','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27472,'49454','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29205,'52161','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11021,'24025','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33813,'58756','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25882,'47459','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18055,'35077','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26738,'48618','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10509,'23102','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(929,'02829','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(10986,'23970','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25083,'46402','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13434,'28228','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37123,'63631','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46608,'78944','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24414,'45638','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18152,'35202','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26989,'48866','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14612,'29681','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31308,'55410','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(986,'02910','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(15531,'30641','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36014,'62286','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32771,'57321','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32602,'57062','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(430,'01541','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26499,'48260','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9747,'21555','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8844,'19893','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(49323,'85351','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37689,'64673','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9555,'21044','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22667,'43017','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40988,'70504','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18902,'36529','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24987,'46259','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17003,'33013','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23151,'43697','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31190,'55330','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31607,'55955','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32320,'56577','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(46129,'78245','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51007,'91906','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53453,'96795','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(49193,'85132','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2134,'06035','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50076,'88339','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(4765,'12566','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27063,'48980','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22834,'43155','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31981,'56266','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33618,'58520','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37220,'63801','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41570,'71418','Caldwell','22021','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4004,'10950','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50315,'89160','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47160,'79749','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40333,'68823','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39787,'68073','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9418,'20771','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11247,'24317','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21242,'39867','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1245,'03833','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16407,'32131','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22414,'42333','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50252,'89084','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(18862,'36471','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38561,'66078','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22397,'42302','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41658,'71603','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39179,'67214','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38983,'66956','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31782,'56101','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44404,'75763','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35388,'61443','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4275,'11740','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29316,'52307','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47996,'81290','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4759,'12561','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23952,'44861','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5345,'13495','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6330,'15235','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50164,'88562','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(45403,'77215','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7785,'17758','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19051,'36785','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52600,'95346','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49655,'87005','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41432,'71238','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39604,'67801','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28831,'51061','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28201,'50247','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9730,'21524','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23249,'43811','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10771,'23505','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3636,'09811','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53034,'95970','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35333,'61376','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33670,'58570','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5320,'13472','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23832,'44688','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54806,'99170','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47015,'79505','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1744,'04937','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48991,'84622','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39436,'67575','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37200,'63770','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25067,'46380','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24199,'45304','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8696,'19451','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4744,'12542','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32076,'56335','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36058,'62340','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39404,'67556','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5310,'13460','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27557,'49638','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11676,'25071','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12409,'26463','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47972,'81227','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52530,'95231','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47617,'80539','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44694,'76135','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32278,'56544','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29548,'52653','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2882,'07846','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25754,'47344','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36432,'62765','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32457,'56740','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53109,'96057','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35608,'61744','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48938,'84337','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(55165,'99926','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48990,'84621','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40613,'69138','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27865,'49950','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16310,'32008','Gilchrist','12041','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44939,'76481','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42227,'72391','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41124,'70654','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52586,'95329','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33896,'59001','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(50275,'89120','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(17329,'33545','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53501,'96857','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52882,'95692','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52726,'95501','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44907,'76460','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38321,'65680','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30831,'54841','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29726,'53066','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12428,'26541','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7816,'17815','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20041,'38230','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24241,'45330','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24050,'45107','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29598,'52755','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27365,'49330','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1020,'03057','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4584,'12245','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35870,'62074','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32305,'56567','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9938,'21862','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6143,'14882','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18470,'35809','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32360,'56631','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53175,'96128','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45573,'77414','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42745,'73041','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37239,'63834','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26605,'48421','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30414,'54427','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50114,'88436','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48007,'81325','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8603,'19310','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11696,'25108','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24860,'46135','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10547,'23131','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5681,'14130','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51134,'92128','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50563,'90220','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39477,'67638','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7631,'17340','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23181,'43732','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4203,'11549','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2065,'05828','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1376,'04088','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27943,'50044','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28311,'50396','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34204,'59472','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34241,'59540','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31380,'55557','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42759,'73050','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5293,'13437','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54721,'99029','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52547,'95253','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52537,'95240','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47078,'79547','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34301,'59730','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1549,'04488','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(25311,'46795','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19561,'37404','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12839,'27429','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13336,'28105','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17078,'33126','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33436,'58341','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43531,'74457','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26546,'48336','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29549,'52654','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32239,'56511','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33112,'57706','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24739,'46032','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44052,'75248','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29264,'52223','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9726,'21521','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7481,'17073','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17845,'34498','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20754,'39146','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26527,'48316','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5673,'14112','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27963,'50056','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28451,'50535','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18716,'36256','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41272,'71009','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9237,'20536','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(54619,'98828','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36724,'62997','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46520,'78750','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(875,'02723','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54943,'99569','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53573,'97036','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51071,'92040','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50498,'90040','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12077,'25860','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20900,'39354','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23297,'43916','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40047,'68460','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35722,'61871','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51887,'93649','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54065,'97877','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4645,'12435','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1035,'03087','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(40681,'69212','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31787,'56113','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21816,'41006','Pendleton','21191','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49556,'86036','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(27565,'49644','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6273,'15126','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34885,'60614','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14054,'29009','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47846,'81022','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52439,'95076','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47910,'81090','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1974,'05647','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(30248,'54115','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39558,'67737','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13578,'28379','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45475,'77305','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(96,'00765','Vieques','72147','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(12626,'27051','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49607,'86406','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25184,'46613','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38131,'65462','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13345,'28111','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9919,'21829','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13346,'28112','None','45999','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52064,'94124','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32100,'56349','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(719,'02334','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11167,'24201','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37846,'65016','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23470,'44122','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22973,'43407','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(771,'02466','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20020,'38186','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10430,'23002','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34424,'59933','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32828,'57358','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21397,'40175','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39257,'67423','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8359,'18913','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50626,'90408','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29357,'52334','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8545,'19129','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7381,'16947','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19453,'37327','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40874,'70187','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7884,'17885','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13708,'28521','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12014,'25710','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35828,'62031','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34758,'60477','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30241,'54111','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53234,'96310','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51666,'93263','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30099,'53824','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4567,'12228','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30563,'54548','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24133,'45216','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40642,'69155','McPherson','31117','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3480,'09454','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(45480,'77320','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43024,'73552','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50733,'90895','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32733,'57266','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33318,'58208','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36383,'62681','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18678,'36113','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(491,'01757','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25352,'46864','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6292,'15145','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2955,'08006','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9438,'20792','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15601,'30731','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45626,'77461','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5038,'13035','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13701,'28513','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28390,'50470','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8608,'19316','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7453,'17053','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44439,'75803','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42966,'73463','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2449,'06706','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14234,'29211','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14923,'30102','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29464,'52567','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28863,'51239','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24307,'45381','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6708,'15774','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1196,'03750','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5336,'13486','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20450,'38744','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30454,'54456','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26469,'48216','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8911,'20010','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11894,'25501','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8503,'19087','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39287,'67447','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44419,'75780','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10703,'23405','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41401,'71217','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4502,'12151','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10676,'23321','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52570,'95316','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39303,'67455','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53588,'97055','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2353,'06438','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35687,'61844','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20931,'39421','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33996,'59101','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29017,'51545','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25436,'46952','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52437,'95073','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42516,'72727','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29754,'53092','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3028,'08083','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23048,'43512','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27127,'49046','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17186,'33319','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36833,'63115','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46666,'79021','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49687,'87034','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(8950,'20056','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5298,'13442','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9550,'21040','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7793,'17765','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54242,'98221','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52453,'95116','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12779,'27330','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23317,'43941','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41456,'71264','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1286,'03878','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22805,'43140','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7854,'17850','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43730,'74855','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43001,'73534','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7286,'16822','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26381,'48125','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4372,'11973','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10773,'23507','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23939,'44851','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23129,'43611','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34547,'60119','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25856,'47438','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22313,'42152','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48427,'83322','Camas','16025','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12537,'26757','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14631,'29697','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36522,'62858','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24013,'45039','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48084,'81631','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33560,'58460','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32179,'56441','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52227,'94556','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35312,'61358','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37422,'64106','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28469,'50545','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30411,'54425','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33304,'58108','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44054,'75249','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46762,'79083','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9287,'20606','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13713,'28525','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33349,'58235','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32536,'57026','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34551,'60121','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41454,'71261','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26982,'48860','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(599,'02045','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23033,'43502','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21084,'39653','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30238,'54110','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38178,'65560','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9271,'20581','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5054,'13052','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33548,'58452','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25264,'46765','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8428,'19008','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41968,'72059','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40325,'68816','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39288,'67447','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31135,'55130','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28228,'50262','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1421,'04238','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13471,'28278','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6278,'15131','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46382,'78628','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28684,'50837','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50364,'89421','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(55099,'99752','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(16079,'31629','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11408,'24549','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17850,'34604','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48871,'84127','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(28686,'50839','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42128,'72210','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43450,'74345','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43605,'74577','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15074,'30224','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23923,'44842','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13190,'27923','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35607,'61744','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31949,'56243','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19978,'38117','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22382,'42273','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26255,'47988','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17499,'33806','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36182,'62450','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32646,'57201','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31175,'55321','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48010,'81328','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51429,'92647','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6471,'15447','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19539,'37381','Rhea','47143','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28761,'51019','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14945,'30113','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18382,'35643','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26139,'47884','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15885,'31141','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8609,'19317','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30706,'54730','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45267,'76937','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15608,'30735','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39037,'67031','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29467,'52569','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4715,'12511','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14587,'29658','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49244,'85251','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35057,'61006','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36216,'62476','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22882,'43260','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13940,'28718','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16189,'31771','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11652,'25043','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7596,'17302','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18542,'35980','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(521,'01843','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29852,'53203','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20950,'39441','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30455,'54457','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29837,'53185','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10900,'23879','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14331,'29406','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49932,'87937','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(36065,'62346','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50839,'91344','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29072,'51603','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44014,'75207','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18079,'35111','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50008,'88120','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40324,'68815','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22400,'42320','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18852,'36457','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35222,'61260','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35331,'61374','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2575,'07017','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18757,'36303','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38481,'66002','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48739,'83870','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(9714,'21403','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28677,'50830','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53386,'96720','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(3967,'10708','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30531,'54520','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2444,'06701','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(42989,'73528','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(455,'01605','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41959,'72047','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7186,'16639','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24271,'45348','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45859,'77868','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28810,'51049','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(335,'01264','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54624,'98832','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48524,'83520','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(18004,'35023','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9683,'21237','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7655,'17372','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21817,'41007','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44188,'75455','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22796,'43136','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15526,'30635','Elbert','13105','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6876,'16055','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39508,'67651','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14060,'29014','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46539,'78768','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33807,'58750','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36892,'63180','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30344,'54226','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30718,'54737','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29959,'53540','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3818,'10269','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53919,'97499','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13790,'28590','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44967,'76519','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16881,'32801','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19820,'37879','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5143,'13146','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27518,'49601','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48128,'82053','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46732,'79064','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8303,'18762','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53999,'97752','Crook','41013','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53440,'96780','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(38524,'66043','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43075,'73647','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41986,'72072','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41832,'71914','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17387,'33613','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37017,'63458','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24564,'45782','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13148,'27878','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14909,'30094','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12662,'27198','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14186,'29138','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38883,'66783','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37495,'64402','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18082,'35115','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26328,'48069','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38790,'66619','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29957,'53538','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36742,'63020','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14848,'30044','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49416,'85627','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17140,'33190','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7901,'17933','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9445,'20812','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28535,'50595','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31875,'56175','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40156,'68655','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41164,'70732','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36733,'63013','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44140,'75423','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52838,'95652','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53974,'97707','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52737,'95526','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41792,'71839','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31771,'56093','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30313,'54175','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45247,'76901','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45896,'77968','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27891,'50005','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5472,'13751','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11940,'25560','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28833,'51063','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(887,'02746','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41101,'70631','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33317,'58207','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29899,'53405','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5010,'12987','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52603,'95350','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44676,'76116','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5628,'14056','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38566,'66083','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39265,'67428','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39533,'67669','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14327,'29402','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7778,'17751','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25575,'47122','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15569,'30673','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31806,'56127','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17803,'34432','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27856,'49935','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29344,'52325','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33343,'58229','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2981,'08034','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15759,'31030','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14916,'30099','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6919,'16130','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3981,'10915','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51051,'92014','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27078,'49011','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28457,'50540','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4034,'10984','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6543,'15554','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32923,'57448','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24743,'46035','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25366,'46901','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35255,'61311','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38977,'66952','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51982,'93926','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8670,'19408','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(383,'01452','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14839,'30038','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33441,'58345','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35637,'61773','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21068,'39641','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20110,'38339','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21861,'41051','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10994,'24006','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12150,'26032','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(995,'02920','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(45074,'76642','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3900,'10523','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40058,'68465','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18936,'36572','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11051,'24061','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10739,'23451','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2119,'06020','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1967,'05603','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(26509,'48278','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30804,'54819','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48091,'81638','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53789,'97358','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32053,'56323','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(42874,'73144','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24795,'46069','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22905,'43316','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39839,'68164','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39123,'67119','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13181,'27915','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31618,'55963','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2284,'06280','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52525,'95229','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29577,'52736','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13035,'27707','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4860,'12781','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41558,'71404','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5081,'13077','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48172,'82242','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(14491,'29581','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(196,'00981','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13149,'27879','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26727,'48613','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1460,'04294','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14157,'29115','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18296,'35550','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10233,'22640','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47028,'79517','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24140,'45223','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6111,'14857','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52533,'95234','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48684,'83812','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(15587,'30707','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3732,'10069','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35544,'61630','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34802,'60518','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29990,'53563','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18756,'36302','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23088,'43543','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47638,'80611','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(625,'02111','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16291,'31904','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39647,'67855','Morton','20129','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50032,'88213','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(30570,'54555','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16355,'32068','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9594,'21104','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11697,'25109','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20283,'38564','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33196,'57793','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51692,'93304','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2051,'05774','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(41269,'71006','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28548,'50601','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29842,'53189','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33447,'58351','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35438,'61478','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25480,'46985','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28364,'50456','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45793,'77657','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36668,'62948','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27931,'50036','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2148,'06053','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(51875,'93639','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53111,'96059','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53110,'96058','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44747,'76234','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19933,'38055','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44436,'75801','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27425,'49413','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29420,'52535','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43631,'74651','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15955,'31333','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34240,'59540','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47908,'81089','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19268,'37096','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33838,'58771','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10076,'22302','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48262,'82716','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(18033,'35054','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36989,'63440','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11590,'24915','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4283,'11752','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13208,'27943','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5120,'13122','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42305,'72461','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3449,'09347','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38077,'65347','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14756,'29922','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7421,'17026','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7627,'17334','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23452,'44104','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36877,'63151','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14905,'30092','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46436,'78662','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27372,'49333','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54238,'98208','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49071,'84752','Beaver','49001','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(32484,'56762','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16430,'32159','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17868,'34656','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15093,'30236','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27587,'49663','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32991,'57533','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20143,'38361','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44559,'76004','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22743,'43077','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41537,'71360','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42477,'72668','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49735,'87114','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37392,'64075','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39253,'67420','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42472,'72661','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17943,'34948','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47880,'81057','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43967,'75148','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49092,'84775','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(16103,'31641','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21035,'39569','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14948,'30115','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(55126,'99780','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(31327,'55426','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7165,'16620','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7707,'17554','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5660,'14098','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26847,'48743','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46660,'79015','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3172,'08526','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15465,'30575','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36889,'63177','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48320,'83002','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49069,'84750','Piute','49031','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49434,'85644','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43130,'73727','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14501,'29592','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16248,'31806','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6539,'15550','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23044,'43512','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41747,'71753','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8480,'19064','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(891,'02761','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44001,'75182','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2264,'06250','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10402,'22960','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41507,'71328','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49426,'85637','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42113,'72180','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4928,'12870','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41670,'71640','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29229,'52203','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38803,'66699','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32928,'57451','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52998,'95939','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6836,'16022','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32812,'57345','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18056,'35078','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38046,'65324','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54229,'98195','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52900,'95721','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6458,'15433','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33843,'58776','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50551,'90095','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7367,'16935','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3700,'10016','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17310,'33521','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36795,'63069','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1158,'03570','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(49613,'86427','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5164,'13164','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8880,'19955','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(1263,'03852','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(38869,'66776','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43624,'74643','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41186,'70756','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(825,'02631','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12639,'27103','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11619,'24981','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16022,'31549','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25817,'47390','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12345,'26372','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45135,'76693','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14607,'29676','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7114,'16434','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51635,'93235','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45791,'77656','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23474,'44126','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(445,'01581','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36084,'62360','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(575,'01965','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41987,'72073','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11747,'25183','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12826,'27408','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1545,'04479','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47792,'80920','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27630,'49701','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54972,'99610','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54257,'98236','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51820,'93581','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51772,'93512','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5919,'14572','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52495,'95190','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7963,'18032','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9229,'20528','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53127,'96076','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53699,'97223','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13355,'28123','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15555,'30663','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5712,'14203','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35018,'60950','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1600,'04619','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4872,'12801','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13742,'28551','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47525,'80434','Jackson','8057','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44708,'76177','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11678,'25075','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33048,'57584','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44556,'76001','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35433,'61476','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26179,'47932','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20974,'39464','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43742,'74859','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49658,'87007','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(30511,'54495','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(225,'01028','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35454,'61489','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(990,'02915','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(26748,'48624','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3496,'09506','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(17175,'33308','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5094,'13089','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18368,'35619','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32601,'57061','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46039,'78119','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49957,'88026','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40024,'68445','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38955,'66938','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17691,'34112','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47591,'80513','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24061,'45120','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21907,'41102','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48185,'82329','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(16980,'32959','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26854,'48746','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28568,'50613','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45066,'76635','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12017,'25713','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30293,'54159','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44954,'76501','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47902,'81081','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2239,'06180','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20228,'38477','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36090,'62366','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16481,'32223','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19197,'37050','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37174,'63736','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36213,'62474','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30458,'54458','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53862,'97438','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10976,'23963','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24247,'45334','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26532,'48322','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34759,'60478','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24925,'46181','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(967,'02887','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(51362,'92530','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52688,'95450','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21881,'41074','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9286,'20604','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17904,'34737','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44378,'75707','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12119,'25942','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9583,'21087','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21524,'40356','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21355,'40109','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21461,'40283','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35442,'61482','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54853,'99326','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30326,'54208','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28369,'50457','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10566,'23156','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37816,'64858','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37986,'65248','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41483,'71292','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18573,'36022','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7352,'16917','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12138,'25981','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23066,'43524','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3434,'09308','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11291,'24380','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39513,'67656','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28651,'50670','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28770,'51024','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29688,'53035','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13911,'28689','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27406,'49401','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52803,'95619','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10859,'23836','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13570,'28372','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21569,'40402','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38503,'66023','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(889,'02748','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13352,'28117','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37193,'63764','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22956,'43349','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11235,'24293','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(166,'00939','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(12579,'27009','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(14233,'29210','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46596,'78935','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14466,'29560','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33017,'57553','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25384,'46919','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53619,'97102','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5963,'14649','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5920,'14580','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19427,'37308','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35671,'61830','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36690,'62963','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2072,'05838','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(47229,'79908','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35363,'61422','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14118,'29069','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44000,'75181','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41189,'70759','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6952,'16201','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36056,'62338','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47211,'79846','Presidio','48377','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26367,'48111','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29057,'51571','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41564,'71410','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19791,'37864','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21912,'41124','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24994,'46268','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36244,'62523','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33533,'58440','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16606,'32425','Holmes','12059','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18366,'35617','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49561,'86043','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(662,'02150','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15711,'31008','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27348,'49322','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9403,'20752','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37293,'63937','Carter','29035','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44329,'75657','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3766,'10129','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36060,'62343','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14707,'29839','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27553,'49635','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37709,'64724','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9552,'21042','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43378,'74110','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5285,'13425','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3036,'08088','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42082,'72149','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23909,'44833','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40458,'68938','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16539,'32321','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13437,'28231','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41218,'70791','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22395,'42301','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27812,'49880','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46111,'78227','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13685,'28478','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38620,'66216','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9944,'21869','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6438,'15412','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15860,'31090','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12930,'27562','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8691,'19442','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28064,'50139','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52733,'95521','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39139,'67135','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41041,'70544','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50414,'89515','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(7179,'16634','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10096,'22333','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47528,'80437','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41726,'71724','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38639,'66286','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29932,'53521','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18300,'35553','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30767,'54766','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28870,'51244','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26837,'48737','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24413,'45636','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21877,'41071','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(244,'01057','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50039,'88240','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46758,'79082','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43510,'74437','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41730,'71726','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33063,'57630','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30602,'54615','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19124,'36919','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7502,'17090','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1390,'04105','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4146,'11370','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27323,'49306','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49609,'86411','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43876,'75054','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15547,'30656','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37134,'63640','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18295,'35549','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21830,'41019','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14906,'30093','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22520,'42516','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49941,'88004','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(18303,'35554','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20875,'39335','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31358,'55459','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26864,'48756','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43795,'74945','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20150,'38367','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5211,'13316','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2315,'06376','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16783,'32669','Gilchrist','12041','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25297,'46787','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18527,'35971','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16746,'32622','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31692,'56031','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23460,'44112','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23461,'44113','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18304,'35555','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18071,'35094','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9368,'20712','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9012,'20130','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11044,'24055','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13777,'28581','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24598,'45821','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39470,'67634','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33811,'58755','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36335,'62630','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27288,'49267','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10698,'23397','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52382,'95004','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37959,'65215','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41612,'71452','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53479,'96822','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52192,'94521','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24085,'45142','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4430,'12062','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19906,'38034','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25545,'47060','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8181,'18445','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(470,'01702','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29495,'52588','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37652,'64648','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38349,'65711','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51232,'92266','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48017,'81335','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7119,'16436','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32643,'57193','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1529,'04459','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35598,'61739','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13592,'28390','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19689,'37748','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40921,'70394','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44466,'75852','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43817,'74966','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6643,'15698','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3307,'08848','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27772,'49836','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1096,'03261','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(36,'00669','Lares','72081','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(22852,'43207','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6561,'15612','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10825,'23703','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38413,'65756','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31563,'55921','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50197,'89003','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54558,'98626','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37087,'63560','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12249,'26219','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14655,'29727','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21026,'39561','Stone','28131','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45116,'76680','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19529,'37376','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14097,'29051','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29762,'53099','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44899,'76455','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26983,'48861','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12894,'27530','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22542,'42567','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33249,'58048','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54550,'98617','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46600,'78940','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44853,'76426','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30634,'54638','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8186,'18447','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15662,'30817','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3972,'10803','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10374,'22935','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34016,'59214','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(5580,'14009','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15339,'30471','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24672,'45869','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49713,'87061','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51260,'92314','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38757,'66547','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37011,'63454','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36874,'63146','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34298,'59727','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32960,'57472','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6413,'15352','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2577,'07019','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6769,'15870','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37774,'64783','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30284,'54153','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1682,'04766','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14219,'29178','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2360,'06447','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16431,'32160','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38853,'66759','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29346,'52326','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24793,'46068','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20410,'38670','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28621,'50650','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2393,'06495','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36601,'62905','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28023,'50110','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5629,'14057','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2642,'07090','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54843,'99258','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37718,'64733','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36176,'62448','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3798,'10176','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21073,'39645','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22331,'42170','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24155,'45239','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48243,'82638','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(768,'02462','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10556,'23147','Charles City','51036','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21289,'40033','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11552,'24848','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48693,'83824','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48451,'83344','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43294,'74034','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41167,'70736','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11112,'24126','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36650,'62938','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52858,'95672','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16519,'32302','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50172,'88571','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(49900,'87735','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(47297,'80007','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40559,'69030','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38829,'66738','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37569,'64482','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21641,'40509','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10415,'22971','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1285,'03875','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(43916,'75094','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42599,'72841','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31241,'55363','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1729,'04922','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32989,'57532','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49503,'85756','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46598,'78940','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41678,'71646','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13159,'27886','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14701,'29835','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7361,'16928','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25730,'47327','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49749,'87151','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46790,'79102','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36145,'62428','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3197,'08558','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22024,'41397','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22627,'42764','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10495,'23083','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43237,'73946','Cimarron','40025','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1132,'03441','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(53520,'96932','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(49806,'87455','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44145,'75426','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41555,'71403','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35901,'62090','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17171,'33304','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6629,'15684','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3474,'09394','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49035,'84714','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(33295,'58079','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23271,'43840','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18807,'36360','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19985,'38126','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17646,'34007','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(27774,'49837','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51284,'92339','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23645,'44420','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37025,'63463','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53813,'97378','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52790,'95609','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47967,'81223','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45444,'77262','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39614,'67837','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34890,'60619','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32565,'57042','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13600,'28396','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11767,'25234','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30675,'54666','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32463,'56744','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26121,'47868','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42714,'73019','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42036,'72113','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12833,'27416','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19058,'36792','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7063,'16362','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11516,'24736','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14730,'29856','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50281,'89126','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48439,'83336','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(16296,'31908','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15476,'30597','Lumpkin','13187','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10110,'22408','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21947,'41175','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23743,'44618','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26666,'48462','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7248,'16701','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54997,'99637','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46115,'78231','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38849,'66758','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31361,'55470','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8035,'18103','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11380,'24521','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14024,'28790','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1125,'03303','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21655,'40516','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7018,'16314','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32579,'57048','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4519,'12168','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20569,'38879','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34892,'60621','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29275,'52229','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28626,'50654','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15206,'30332','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27417,'49408','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1423,'04240','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18791,'36343','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31338,'55436','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44048,'75243','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43485,'74402','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54152,'98068','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24256,'45338','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50063,'88314','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54646,'98857','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48240,'82636','Converse','56009','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44056,'75251','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40914,'70380','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29472,'52571','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16147,'31721','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24432,'45654','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13888,'28671','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11758,'25206','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8091,'18256','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6407,'15346','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22016,'41365','Wolfe','21237','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19055,'36786','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45742,'77575','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9510,'20904','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39641,'67851','Kearny','20093','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17891,'34698','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48783,'84039','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44337,'75662','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26474,'48221','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15417,'30540','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12601,'27025','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(10972,'23960','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38016,'65276','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40283,'68778','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50000,'88114','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46265,'78469','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45404,'77216','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39004,'67008','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31854,'56160','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24681,'45874','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52243,'94571','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35741,'61910','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46361,'78616','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52682,'95443','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47404,'80161','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31720,'56054','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30878,'54893','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11496,'24646','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5195,'13252','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28338,'50434','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25594,'47137','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(931,'02831','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(13705,'28518','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40214,'68733','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41312,'71055','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34097,'59330','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30358,'54246','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19532,'37377','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15327,'30457','Treutlen','13283','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41550,'71373','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48608,'83646','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48290,'82837','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(43698,'74829','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38129,'65461','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3943,'10589','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19372,'37188','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18545,'35983','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14949,'30116','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32340,'56591','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(38045,'65323','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15979,'31503','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15554,'30662','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2822,'07728','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29661,'53014','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19730,'37806','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24928,'46183','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25487,'46989','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37099,'63620','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29280,'52235','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7904,'17936','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7092,'16407','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1494,'04413','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22659,'43014','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9932,'21851','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10395,'22952','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4516,'12166','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46032,'78114','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54011,'97801','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(55146,'99826','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52855,'95669','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33478,'58377','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11317,'24438','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54075,'97904','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31858,'56164','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23767,'44633','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7392,'17006','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24926,'46182','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25431,'46951','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13064,'27810','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5266,'13406','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50118,'88512','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(19959,'38080','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29082,'51638','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25470,'46979','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9375,'20719','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3684,'09892','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(51580,'93064','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33806,'58748','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24227,'45322','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18706,'36204','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3852,'10454','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3214,'08610','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26542,'48332','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28891,'51342','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10819,'23692','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8389,'18946','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28011,'50105','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14122,'29071','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33083,'57642','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16118,'31650','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51812,'93555','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45246,'76901','Irion','48235','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40756,'70010','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51202,'92231','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52986,'95926','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10909,'23887','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36780,'63051','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23821,'44680','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43992,'75167','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43693,'74825','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32045,'56316','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8216,'18501','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24818,'46104','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27373,'49335','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7064,'16362','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7823,'17821','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41811,'71858','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6478,'15456','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39482,'67640','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40961,'70450','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:53',NULL,NULL),(42334,'72512','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38328,'65685','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37178,'63740','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35039,'60961','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26023,'47660','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2524,'06859','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45294,'77008','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26313,'48049','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38612,'66208','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19818,'37879','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52251,'94579','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51449,'92675','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35933,'62231','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32961,'57473','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26298,'48035','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26395,'48140','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7656,'17372','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9781,'21641','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47259,'79938','Hudspeth','48229','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21964,'41219','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18630,'36057','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17683,'34104','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7489,'17080','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13278,'28037','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44105,'75380','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5609,'14036','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16637,'32448','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18088,'35119','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42557,'72762','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47489,'80291','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3149,'08405','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47852,'81030','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42804,'73078','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41952,'72044','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41661,'71613','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5203,'13308','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26697,'48531','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6496,'15476','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33354,'58239','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34356,'59832','Granite','30039','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38488,'66012','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(915,'02812','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(14817,'30021','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43335,'74063','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35256,'61312','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9767,'21626','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1851,'05144','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19285,'37116','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46325,'78585','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43092,'73660','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8452,'19033','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11172,'24205','Bristol City','51520','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14665,'29743','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33788,'58734','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24064,'45122','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9522,'20916','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14827,'30028','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7920,'17961','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43241,'73950','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53168,'96121','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40548,'69026','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35300,'61345','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12488,'26636','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27252,'49240','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25714,'47303','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2415,'06520','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6283,'15136','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12953,'27583','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22297,'42129','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4580,'12241','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40908,'70372','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40798,'70078','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34679,'60420','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34004,'59111','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32302,'56565','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32130,'56372','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17714,'34143','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41860,'71949','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38263,'65635','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35984,'62264','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45149,'76714','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16496,'32235','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49509,'85912','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49190,'85128','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43969,'75150','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29404,'52409','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4944,'12912','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14780,'29945','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6081,'14827','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(141,'00912','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(8831,'19806','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(40529,'68982','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52043,'94089','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40801,'70081','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1372,'04084','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7130,'16502','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53539,'97008','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48979,'84539','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41729,'71726','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35908,'62097','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31516,'55785','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5578,'14006','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25193,'46634','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14130,'29078','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16715,'32570','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27971,'50061','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27001,'48876','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26500,'48264','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6269,'15116','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4785,'12586','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53257,'96370','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(39605,'67831','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42780,'73059','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32133,'56374','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20156,'38371','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20367,'38635','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6373,'15310','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12377,'26421','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(210,'01007','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26974,'48853','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4371,'11972','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12925,'27557','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51109,'92102','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55087,'99740','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(4789,'12589','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53288,'96521','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53946,'97543','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43058,'73625','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29247,'52213','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4908,'12847','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27554,'49636','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27376,'49337','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49534,'86003','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33836,'58771','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23895,'44824','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29006,'51537','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11713,'25126','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8466,'19047','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54567,'98639','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23332,'43952','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17988,'35010','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36698,'62971','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49943,'88006','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(43682,'74766','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39587,'67753','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38974,'66951','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18965,'36616','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27065,'49002','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13861,'28647','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8273,'18636','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4257,'11719','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47379,'80127','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36144,'62428','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38754,'66544','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31207,'55338','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3436,'09310','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43119,'73717','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54904,'99510','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47415,'80207','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40172,'68666','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32400,'56672','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8223,'18508','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28223,'50258','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(92,'00745','Rio Grande','72119','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(21967,'41226','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42579,'72824','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34396,'59903','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40781,'70058','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13677,'28466','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40768,'70041','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9927,'21842','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5542,'13841','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30242,'54111','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35481,'61533','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54390,'98384','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1964,'05544','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7038,'16341','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51899,'93661','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51092,'92072','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37973,'65240','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37894,'65058','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30807,'54821','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30702,'54728','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8155,'18421','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1399,'04123','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1109,'03278','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(47119,'79703','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3187,'08542','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26028,'47683','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21844,'41035','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5726,'14217','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41515,'71336','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35242,'61279','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51736,'93436','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13479,'28289','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22820,'43148','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53255,'96367','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52510,'95210','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32900,'57434','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17241,'33427','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8703,'19460','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24348,'45431','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1574,'04556','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(454,'01604','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2448,'06705','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28919,'51430','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25308,'46794','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(261,'01079','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20643,'38965','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15166,'30297','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28291,'50335','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51325,'92398','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47781,'80909','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15747,'31023','Pulaski','13235','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7303,'16841','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32477,'56759','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33309,'58125','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13321,'28091','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21812,'41003','Harrison','21097','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46174,'78330','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54130,'98041','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16933,'32885','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52818,'95632','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43199,'73841','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33514,'58423','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29378,'52352','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1058,'03221','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(10706,'23409','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9760,'21619','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9607,'21130','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15274,'30420','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46949,'79359','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38919,'66857','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34262,'59635','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40806,'70086','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19788,'37861','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21330,'40067','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22242,'42053','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22515,'42501','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23511,'44201','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13481,'28296','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27778,'49841','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28582,'50625','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40554,'69028','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(674,'02184','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50176,'88575','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(40220,'68735','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24833,'46117','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27246,'49235','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52684,'95445','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2581,'07023','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3825,'10276','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27066,'49003','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37716,'64730','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43871,'75051','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24714,'45895','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8620,'19340','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(884,'02743','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15161,'30294','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9411,'20762','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28601,'50635','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5158,'13158','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47292,'80003','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19192,'37048','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25278,'46776','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7378,'16943','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4690,'12481','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50564,'90221','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49624,'86439','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34145,'59418','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3321,'08865','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21619,'40475','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29973,'53551','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32946,'57466','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46606,'78942','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38467,'65805','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30240,'54110','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25010,'46296','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19629,'37686','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14379,'29450','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28351,'50446','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38903,'66846','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33242,'58043','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33151,'57751','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7319,'16858','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27877,'49965','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26683,'48475','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54880,'99354','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(17412,'33660','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42844,'73116','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50437,'89712','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(27660,'49727','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53796,'97362','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53510,'96913','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(52876,'95689','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52355,'94951','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45796,'77661','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34214,'59487','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30519,'54501','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1204,'03766','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11925,'25530','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51005,'91903','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30932,'54944','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47942,'81141','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31274,'55385','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41996,'72079','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52951,'95841','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45242,'76888','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45121,'76685','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43004,'73537','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41407,'71221','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12748,'27301','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18901,'36528','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24991,'46260','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27011,'48882','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10911,'23888','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7501,'17090','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3195,'08556','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46145,'78259','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40254,'68759','Rock','31149','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3690,'10005','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26330,'48071','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5027,'13029','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13921,'28699','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16341,'32055','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4495,'12144','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52718,'95486','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16110,'31645','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36052,'62330','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54945,'99572','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49546,'86024','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48284,'82832','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45971,'78039','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28777,'51027','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19066,'36804','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46634,'78959','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36951,'63378','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34952,'60696','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33915,'59018','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3844,'10310','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14115,'29065','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7868,'17866','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18671,'36106','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16069,'31622','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20542,'38860','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24542,'45760','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51204,'92233','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34507,'60081','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11189,'24225','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22751,'43083','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54041,'97843','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50773,'91117','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46781,'79095','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45338,'77051','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30338,'54216','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26890,'48770','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11082,'24088','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53351,'96667','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49715,'87063','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46725,'79061','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40502,'68967','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35873,'62075','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29450,'52555','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6369,'15289','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2316,'06377','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24892,'46161','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35995,'62272','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50669,'90652','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53335,'96620','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(3801,'10179','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32424,'56711','Lake of the Woods','27077','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27008,'48880','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28796,'51039','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40332,'68822','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(882,'02741','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20124,'38346','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9250,'20551','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(18616,'36047','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22326,'42166','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32892,'57428','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40890,'70344','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9055,'20176','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41849,'71937','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4199,'11542','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16954,'32922','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7398,'17012','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14933,'30106','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37354,'64034','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7241,'16692','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1490,'04408','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31206,'55338','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17780,'34278','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6654,'15717','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43018,'73548','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43919,'75098','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12307,'26296','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35666,'61821','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42861,'73131','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42391,'72565','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19764,'37840','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32322,'56579','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43349,'74075','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17849,'34603','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38932,'66866','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1955,'05487','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12116,'25932','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37055,'63536','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31579,'55935','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46020,'78104','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7810,'17812','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4487,'12136','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47821,'80950','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46668,'79022','Hartley','48205','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19996,'38138','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24020,'45050','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24826,'46112','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8267,'18630','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36381,'62677','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45937,'78006','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2834,'07746','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33895,'58856','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47962,'81215','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34893,'60622','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30621,'54627','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20198,'38456','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3577,'09706','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27359,'49327','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1225,'03811','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11432,'24569','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1677,'04761','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18952,'36602','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23710,'44505','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18617,'36047','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46618,'78950','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28667,'50681','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5753,'14280','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23268,'43837','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52702,'95465','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20307,'38580','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17608,'33944','Glades','12043','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3492,'09502','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7859,'17856','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17388,'33614','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47374,'80123','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8304,'18764','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39766,'68057','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45494,'77335','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48404,'83276','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(33961,'59062','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54150,'98065','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42063,'72131','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5408,'13657','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41347,'71102','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32799,'57334','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4410,'12043','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47288,'79999','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25025,'46321','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52201,'94530','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29014,'51544','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13529,'28340','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8481,'19065','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43276,'74021','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30053,'53718','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40674,'69190','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28439,'50527','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37996,'65258','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12636,'27099','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28593,'50629','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49796,'87410','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(27187,'49090','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20218,'38473','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4591,'12255','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47173,'79763','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12820,'27402','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53515,'96921','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(6699,'15765','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5128,'13135','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54575,'98648','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14479,'29572','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7739,'17605','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46199,'78359','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37963,'65230','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31707,'56044','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23021,'43462','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38630,'66225','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28906,'51357','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54086,'97913','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29902,'53408','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39773,'68064','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41927,'72027','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46943,'79356','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48723,'83855','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(18700,'36191','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18696,'36140','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27599,'49675','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37711,'64725','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43452,'74346','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29108,'52030','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(331,'01259','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43589,'74562','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21815,'41005','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21611,'40461','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14995,'30150','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54975,'99613','Bristol Bay','2060','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(39145,'67140','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43861,'75044','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47842,'81019','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48054,'81505','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49544,'86022','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17392,'33618','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25003,'46280','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14423,'29501','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12794,'27349','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11591,'24916','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11250,'24319','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54630,'98841','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38389,'65738','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39652,'67860','Kearny','20093','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3067,'08213','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23027,'43467','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44982,'76528','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48038,'81425','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33058,'57625','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4032,'10983','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47663,'80649','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2813,'07719','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40702,'69334','Box Butte','31013','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17035,'33051','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29488,'52585','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53285,'96516','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(2428,'06540','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43735,'74857','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49541,'86018','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46643,'79002','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36659,'62942','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10834,'23803','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11504,'24701','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37642,'64643','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40730,'69351','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10191,'22555','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12761,'27313','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25844,'47432','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3213,'08609','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37784,'64801','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34497,'60072','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10558,'23148','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44840,'76384','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49133,'85032','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31286,'55393','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14929,'30104','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54132,'98043','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55070,'99721','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48440,'83336','Minidoka','16067','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41260,'70895','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17568,'33896','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2755,'07533','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46677,'79029','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36883,'63163','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3804,'10203','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29232,'52205','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50744,'91016','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51198,'92225','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42986,'73526','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43117,'73716','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25172,'46573','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47372,'80123','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19042,'36773','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28886,'51334','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40215,'68733','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23558,'44253','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10894,'23873','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24787,'46064','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35413,'61465','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45611,'77449','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44703,'76162','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17082,'33130','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39323,'67474','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13170,'27893','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36957,'63382','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28610,'50644','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9789,'21650','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42270,'72433','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5389,'13637','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49776,'87315','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2611,'07059','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26230,'47968','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13796,'28602','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1182,'03603','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2495,'06801','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38244,'65624','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38734,'66533','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27697,'49756','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4463,'12106','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41665,'71638','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5701,'14166','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5619,'14043','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8962,'20068','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(41551,'71375','Tensas','22107','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19305,'37136','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18166,'35216','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32079,'56338','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(19401,'37221','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54980,'99620','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53530,'96960','Marshall Islands','68020','MH','Marshall Islands',0,'2013-07-03 15:17:54',NULL,NULL),(25490,'46991','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31815,'56131','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40143,'68643','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40829,'70126','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3139,'08353','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53028,'95965','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10709,'23413','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4577,'12238','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31243,'55364','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(155,'00926','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19293,'37122','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46735,'79065','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4150,'11374','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30231,'54104','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18963,'36613','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39607,'67834','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3507,'09532','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(44613,'76052','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49350,'85380','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6772,'15902','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37040,'63474','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17383,'33609','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23222,'43773','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25829,'47404','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36132,'62423','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42292,'72451','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6456,'15431','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12731,'27284','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3734,'10080','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(924,'02824','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(54942,'99568','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52006,'94017','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23519,'44210','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19303,'37135','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32621,'57073','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(830,'02637','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3495,'09505','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(46983,'79403','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6754,'15853','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21258,'40007','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54008,'97760','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(8547,'19131','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10272,'22719','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5913,'14564','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1565,'04543','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27291,'49269','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23396,'44047','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23655,'44429','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36914,'63343','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37566,'64479','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47575,'80498','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32468,'56750','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27240,'49230','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21031,'39565','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22907,'43317','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14902,'30090','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37088,'63560','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9413,'20764','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28927,'51436','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8668,'19406','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15355,'30507','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24677,'45872','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20056,'38253','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42864,'73135','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37679,'64668','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6814,'15954','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36264,'62543','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18203,'35282','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3003,'08057','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8329,'18829','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30259,'54125','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44388,'75752','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(159,'00930','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(16535,'32317','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14458,'29554','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26653,'48454','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16414,'32137','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37640,'64642','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22251,'42061','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18117,'35148','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21968,'41230','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39819,'68134','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42298,'72457','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12742,'27295','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13566,'28369','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18227,'35442','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4073,'11101','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37166,'63703','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27776,'49839','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33382,'58267','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33157,'57758','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36532,'62864','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44369,'75692','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12855,'27505','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7829,'17824','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28631,'50658','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25766,'47353','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27107,'49031','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8903,'20002','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22084,'41602','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36115,'62413','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38169,'65552','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41027,'70532','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46215,'78374','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43502,'74434','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22889,'43287','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42731,'73030','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45181,'76841','Schleicher','48413','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26030,'47702','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25437,'46953','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35915,'62205','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1323,'04016','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24662,'45864','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37590,'64497','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1352,'04056','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48674,'83803','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32171,'56435','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2084,'05850','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(29194,'52151','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20602,'38929','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53429,'96768','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12462,'26586','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15976,'31501','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(268,'01086','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30535,'54524','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19265,'37095','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16236,'31798','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13824,'28622','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14270,'29320','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13523,'28334','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48851,'84107','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(26676,'48468','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46110,'78226','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40852,'70160','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7811,'17813','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13272,'28034','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46044,'78124','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48231,'82604','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(40669,'69169','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40305,'68790','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20500,'38828','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12631,'27055','Davie','37059','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36646,'62935','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11568,'24870','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8129,'18355','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54815,'99181','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46384,'78629','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13296,'28073','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29949,'53533','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5037,'13035','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48484,'83431','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12702,'27249','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26990,'48867','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26360,'48104','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52967,'95903','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53490,'96840','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(17154,'33243','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21042,'39573','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45329,'77043','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35477,'61530','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34529,'60102','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15703,'31002','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49464,'85715','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1088,'03255','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3123,'08340','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32285,'56549','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32472,'56755','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23738,'44614','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18130,'35173','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52147,'94291','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5443,'13693','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52114,'94246','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50853,'91361','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50724,'90834','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16099,'31638','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29332,'52320','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8504,'19088','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5836,'14486','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1501,'04420','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1046,'03106','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24510,'45720','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31295,'55397','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35280,'61331','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26424,'48169','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22800,'43138','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22921,'43326','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18562,'36010','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16380,'32096','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12295,'26283','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13865,'28651','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36012,'62284','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17209,'33348','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(326,'01254','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40931,'70422','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20325,'38601','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5718,'14209','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45547,'77379','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52873,'95686','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25996,'47616','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19233,'37072','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51176,'92179','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16551,'32331','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2487,'06790','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36895,'63195','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33678,'58579','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19001,'36732','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24142,'45225','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12675,'27212','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45819,'77803','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(215,'01011','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41462,'71269','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36189,'62458','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34139,'59414','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49871,'87576','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(14544,'29631','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14338,'29413','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48238,'82633','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(24170,'45249','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3040,'08092','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5649,'14081','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41668,'71639','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45651,'77482','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1756,'04951','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15558,'30665','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50375,'89432','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52626,'95375','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13691,'28502','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40637,'69153','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40431,'68922','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2716,'07439','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11273,'24351','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29494,'52588','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14946,'30113','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51341,'92418','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16209,'31783','Ben Hill','13017','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9516,'20911','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54145,'98059','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50780,'91129','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12503,'26680','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19547,'37388','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44886,'76446','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43630,'74650','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16488,'32229','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5018,'13020','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46371,'78621','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52886,'95695','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50566,'90223','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15791,'31045','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27600,'49676','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30600,'54613','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13814,'28613','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34172,'59446','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16658,'32466','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52217,'94547','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52877,'95690','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14979,'30140','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14356,'29430','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52300,'94702','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50416,'89520','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36770,'63041','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14099,'29052','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34385,'59866','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(53518,'96929','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(21262,'40009','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21322,'40059','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24612,'45832','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33454,'58356','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9068,'20188','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9876,'21775','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7898,'17930','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53818,'97383','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10086,'22311','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11891,'25443','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32490,'56915','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(54117,'98028','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43794,'74944','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1010,'03045','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(44103,'75378','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9795,'21655','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53968,'97638','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46965,'79371','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11179,'24217','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15078,'30228','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44069,'75270','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21924,'41142','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14855,'30052','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16031,'31553','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4842,'12765','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14244,'29221','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13400,'28168','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29996,'53569','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31872,'56172','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37390,'64073','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37913,'65069','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11834,'25328','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47755,'80832','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31608,'55956','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47147,'79734','Jeff Davis','48243','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42382,'72554','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27143,'49058','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29250,'52215','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29707,'53049','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32761,'57313','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53738,'97302','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(23483,'44135','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35711,'61858','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25335,'46825','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13173,'27896','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16297,'31909','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48564,'83606','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6320,'15225','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42100,'72167','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36832,'63114','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10170,'22528','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7594,'17301','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21557,'40385','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26765,'48633','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4228,'11580','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13778,'28582','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53590,'97056','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53414,'96752','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(46104,'78221','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38988,'66961','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50192,'88595','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(39146,'67142','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52758,'95552','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52102,'94211','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50247,'89067','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44904,'76458','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43711,'74840','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32599,'57059','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46079,'78161','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43869,'75050','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25666,'47236','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11034,'24038','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18598,'36035','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18392,'35652','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(55068,'99716','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46031,'78113','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14740,'29906','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6125,'14870','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36146,'62431','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17279,'33469','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32077,'56336','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51977,'93921','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21094,'39661','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15288,'30428','Wheeler','13309','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8807,'19711','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(18029,'35051','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31914,'56220','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(13000,'27620','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47477,'80260','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43728,'74854','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34773,'60501','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11303,'24421','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8919,'20019','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(4358,'11958','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21779,'40939','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52058,'94118','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45034,'76574','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41525,'71350','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15376,'30519','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6494,'15474','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23502,'44191','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36758,'63031','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17267,'33458','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25514,'47016','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5574,'14004','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5830,'14482','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5048,'13043','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46010,'78073','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23258,'43822','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12123,'25962','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2571,'07013','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16234,'31798','Ben Hill','13017','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43944,'75125','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11773,'25241','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46571,'78851','Terrell','48443','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20604,'38930','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23938,'44851','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25943,'47549','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24322,'45401','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27085,'49015','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49727,'87106','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(19550,'37389','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20225,'38476','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15333,'30464','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17137,'33187','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29559,'52659','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49559,'86040','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33000,'57536','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1027,'03071','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(53178,'96132','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14212,'29169','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38632,'66227','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21604,'40447','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4560,'12220','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19757,'37829','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27168,'49078','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14784,'30002','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53283,'96511','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(36866,'63138','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24635,'45845','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44771,'76259','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25995,'47615','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9514,'20908','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13478,'28288','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11588,'24910','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45850,'77859','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10420,'22974','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30828,'54839','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20505,'38833','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32475,'56757','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22632,'42782','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23509,'44199','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47405,'80162','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37856,'65025','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53542,'97010','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11837,'25331','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27951,'50049','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22441,'42361','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24250,'45335','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36759,'63032','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54768,'99133','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3366,'09033','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6648,'15712','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36094,'62367','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52081,'94144','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20709,'39092','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52438,'95075','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35441,'61480','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37577,'64487','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42999,'73533','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26247,'47980','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30980,'54981','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12543,'26801','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11653,'25044','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17340,'33558','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8377,'18931','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(563,'01936','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44672,'76112','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21807,'40995','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9546,'21034','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34358,'59833','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14585,'29657','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53618,'97101','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54435,'98448','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37435,'64120','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35317,'61361','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23733,'44611','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29170,'52079','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39611,'67835','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40437,'68927','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14932,'30106','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5426,'13675','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22861,'43217','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38371,'65727','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6226,'15059','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29715,'53059','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47496,'80303','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49790,'87357','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(1357,'04064','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22620,'42757','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37806,'64848','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40393,'68863','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16192,'31773','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12778,'27330','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48759,'84015','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48204,'82426','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(17331,'33547','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46673,'79025','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36301,'62570','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12785,'27341','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48173,'82242','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(32567,'57042','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6474,'15450','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18338,'35580','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39095,'67103','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52163,'94401','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24533,'45744','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38064,'65336','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21133,'39741','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33132,'57725','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48124,'82050','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(31542,'55816','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51599,'93120','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6989,'16242','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23315,'43939','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47101,'79567','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11860,'25401','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19740,'37814','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15648,'30810','Glascock','13125','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22544,'42602','Clinton','21053','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22415,'42334','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15591,'30719','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45987,'78057','Frio','48163','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18620,'36049','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18636,'36066','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40656,'69163','Logan','31113','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36122,'62419','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13262,'28023','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11178,'24216','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18222,'35406','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27153,'49067','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41044,'70548','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1968,'05604','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(37885,'65049','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40269,'68769','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34962,'60805','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24450,'45671','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33260,'58053','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2793,'07662','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23352,'43977','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12070,'25848','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36834,'63116','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45639,'77474','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15573,'30678','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27403,'49355','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9139,'20340','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53083,'96027','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40424,'68883','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3813,'10259','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46250,'78413','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11164,'24184','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7562,'17237','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(400,'01503','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12644,'27107','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52528,'95230','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43574,'74549','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48581,'83626','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48787,'84043','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(115,'00794','Barranquitas','72019','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42693,'73007','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25276,'46773','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18363,'35614','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40661,'69165','McPherson','31117','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6982,'16236','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14747,'29913','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6740,'15832','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28538,'50597','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44372,'75701','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20945,'39439','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6950,'16161','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27480,'49460','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47027,'79517','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44197,'75468','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43527,'74455','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25024,'46320','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4954,'12921','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44748,'76238','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3223,'08629','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10461,'23040','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15165,'30296','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44621,'76061','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32710,'57256','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16362,'32080','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47930,'81131','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45942,'78010','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42252,'72417','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19416,'37243','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28100,'50156','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21478,'40311','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29635,'52807','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39576,'67748','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49409,'85620','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14694,'29827','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23165,'43721','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34069,'59273','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28216,'50255','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53442,'96782','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(51395,'92589','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50647,'90608','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33341,'58229','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18483,'35897','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9557,'21046','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49950,'88020','Hidalgo','35023','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(39400,'67552','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1555,'04495','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8616,'19331','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53695,'97221','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32245,'56516','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(39192,'67230','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4689,'12480','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4045,'10997','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4868,'12789','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5910,'14561','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29436,'52550','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(358,'01360','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20108,'38337','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7108,'16426','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35368,'61427','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31016,'55019','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40509,'68972','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12045,'25801','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39238,'67357','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32596,'57058','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30478,'54471','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20810,'39202','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24385,'45601','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28318,'50423','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47531,'80439','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12689,'27233','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54564,'98635','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1953,'05485','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4075,'11103','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19573,'37416','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51497,'92822','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49547,'86025','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43950,'75134','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14791,'30005','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11668,'25061','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29145,'52060','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23010,'43449','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(86,'00740','Fajardo','72053','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(40854,'70162','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40631,'69149','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8465,'19046','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2595,'07040','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13498,'28312','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13256,'28019','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16288,'31901','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27169,'49078','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54629,'98840','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54588,'98671','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53651,'97132','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(1512,'04434','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23142,'43656','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11262,'24333','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29686,'53033','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43804,'74956','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44415,'75773','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8291,'18690','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54264,'98243','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51030,'91947','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35314,'61359','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13727,'28532','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34318,'59752','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13304,'28079','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23969,'44880','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15831,'31070','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18488,'35902','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35683,'61842','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1235,'03820','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(51382,'92563','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18404,'35672','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5242,'13343','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41068,'70580','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39434,'67574','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34992,'60931','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53557,'97023','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10849,'23829','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1420,'04237','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(442,'01569','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6668,'15731','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14456,'29550','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16718,'32577','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22589,'42728','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16514,'32259','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8332,'18830','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13442,'28236','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33863,'58790','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50261,'89106','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(41990,'72075','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43182,'73766','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13768,'28574','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54418,'98417','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53401,'96739','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53017,'95957','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52962,'95887','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51483,'92803','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49689,'87036','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(24153,'45237','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24038,'45070','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23830,'44687','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22706,'43055','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7581,'17257','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45180,'76841','Menard','48327','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14377,'29449','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35032,'60959','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42884,'73152','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50633,'90504','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24415,'45638','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18511,'35958','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24622,'45840','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24515,'45724','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17235,'33420','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19006,'36742','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7270,'16744','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21926,'41143','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8855,'19905','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(5044,'13040','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43677,'74760','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(487,'01749','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19311,'37142','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6728,'15824','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43251,'74006','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23937,'44850','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16194,'31774','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17065,'33097','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49935,'87941','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(27239,'49229','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39254,'67420','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(536,'01876','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1996,'05671','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(32000,'56282','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14605,'29673','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8477,'19060','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14511,'29603','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23962,'44871','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27757,'49818','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16640,'32455','Holmes','12059','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3791,'10169','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36319,'62618','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44851,'76424','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44212,'75478','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29750,'53090','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11486,'24631','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14998,'30153','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7678,'17512','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34481,'60050','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54235,'98205','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55137,'99801','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50250,'89077','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43054,'73601','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37382,'64066','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33520,'58428','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3270,'08803','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31485,'55750','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13724,'28530','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21318,'40057','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(279,'01101','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39315,'67466','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20467,'38762','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12055,'25825','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9227,'20526','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(49090,'84773','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21481,'40311','Robertson','21201','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5823,'14476','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12723,'27278','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50717,'90813','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40831,'70128','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39344,'67490','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21086,'39654','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11166,'24201','Bristol City','51520','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17775,'34272','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52021,'94038','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31030,'55032','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53755,'97322','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51724,'93423','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47133,'79713','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42653,'72935','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42092,'72160','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3469,'09378','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19405,'37228','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13146,'27876','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15788,'31042','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50151,'88547','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(38290,'65653','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34846,'60553','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51291,'92347','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53809,'97375','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34912,'60643','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17161,'33265','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6977,'16232','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50666,'90640','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46222,'78380','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34744,'60468','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4548,'12202','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17571,'33898','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20915,'39365','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23893,'44822','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16913,'32835','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17611,'33947','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41380,'71152','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39064,'67054','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36860,'63135','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13583,'28383','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16788,'32686','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52889,'95698','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54234,'98204','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9875,'21774','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27500,'49518','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5496,'13786','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39936,'68358','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30134,'53932','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18332,'35577','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16850,'32764','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17459,'33741','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5650,'14081','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15546,'30656','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8487,'19073','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9515,'20910','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41421,'71232','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15466,'30575','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(126,'00824','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(20284,'38564','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46456,'78672','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53922,'97503','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11826,'25320','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20229,'38478','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20770,'39161','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48981,'84542','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42471,'72660','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5950,'14622','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27385,'49341','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23398,'44049','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10051,'22207','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31848,'56158','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36581,'62893','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36902,'63330','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2705,'07422','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50461,'90003','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15258,'30396','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54479,'98539','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53493,'96844','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(20663,'39051','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1924,'05453','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(48726,'83857','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41276,'71019','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6815,'15955','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8050,'18212','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5951,'14623','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13557,'28364','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33937,'59038','Treasure','30103','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36811,'63087','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53998,'97751','Crook','41013','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53380,'96714','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50490,'90032','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50025,'88136','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49964,'88033','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46657,'79014','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38231,'65615','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35520,'61569','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35553,'61643','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6006,'14738','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27813,'49881','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5781,'14429','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2346,'06420','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19252,'37085','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34882,'60611','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27989,'50070','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(728,'02345','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27696,'49756','Crawford','26039','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19807,'37872','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21758,'40865','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7936,'17980','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44174,'75449','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40723,'69347','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35138,'61071','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30234,'54106','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28429,'50520','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54592,'98674','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2815,'07721','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18618,'36048','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6870,'16051','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44767,'76258','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37266,'63868','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52593,'95337','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49097,'84782','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42774,'73056','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36873,'63145','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22262,'42070','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22815,'43146','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23583,'44278','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41526,'71351','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21729,'40810','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24792,'46068','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10886,'23860','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10879,'23851','Franklin City','51620','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20043,'38232','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21351,'40104','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34880,'60609','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38878,'66780','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39908,'68341','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46841,'79229','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9460,'20838','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7834,'17830','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7154,'16565','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6071,'14819','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14465,'29560','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16887,'32807','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27747,'49807','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25535,'47037','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15557,'30664','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19291,'37122','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46400,'78640','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11931,'25541','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50730,'90847','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53873,'97448','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52864,'95678','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13636,'28436','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7193,'16646','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39629,'67844','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34402,'59913','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(48565,'83607','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6058,'14810','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22419,'42339','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2191,'06101','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(343,'01337','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5638,'14065','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15934,'31312','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21935,'41164','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21874,'41064','Robertson','21201','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4575,'12236','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24737,'46031','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18212,'35294','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25455,'46970','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51640,'93240','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49961,'88030','Luna','35029','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44264,'75563','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34731,'60459','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31182,'55327','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10795,'23605','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(921,'02818','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(23002,'43443','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31264,'55379','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3202,'08561','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30345,'54227','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(55123,'99776','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(40412,'68875','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13744,'28552','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5488,'13776','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3573,'09702','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(42073,'72137','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3724,'10040','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18997,'36723','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5145,'13147','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15768,'31034','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27615,'49684','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40348,'68832','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32460,'56742','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51661,'93257','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49290,'85312','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31571,'55926','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30895,'54915','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2550,'06913','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25233,'46738','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5155,'13157','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3030,'08085','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5970,'14701','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42424,'72616','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52331,'94920','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51192,'92210','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50759,'91077','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39321,'67473','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14727,'29851','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5632,'14059','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20171,'38382','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20193,'38452','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42464,'72653','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36191,'62460','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2629,'07074','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25016,'46307','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16762,'32643','Gilchrist','12041','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43923,'75102','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29364,'52339','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9658,'21220','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14528,'29620','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27181,'49085','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28192,'50241','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53494,'96846','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(37182,'63745','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24237,'45327','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25108,'46511','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47931,'81132','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46150,'78264','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34302,'59731','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(8447,'19028','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22891,'43301','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22962,'43357','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23172,'43727','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9880,'21778','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13187,'27920','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13360,'28126','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13440,'28234','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48700,'83832','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6082,'14830','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10878,'23850','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12921,'27555','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5545,'13843','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33495,'58401','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(246,'01060','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54267,'98247','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51053,'92019','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45011,'76554','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37596,'64503','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8076,'18242','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24517,'45729','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14048,'29001','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24581,'45808','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1392,'04107','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(43560,'74531','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1630,'04660','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(243,'01056','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(55139,'99803','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(18772,'36317','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25503,'47003','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40946,'70438','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10063,'22225','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50436,'89711','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(15888,'31146','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32918,'57445','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32149,'56385','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31901,'56211','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26726,'48613','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17434,'33702','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8115,'18340','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40889,'70343','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40454,'68936','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31037,'55038','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21123,'39710','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47515,'80423','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53348,'96664','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(20351,'38625','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3285,'08821','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43898,'75080','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38379,'65732','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37267,'63869','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(616,'02070','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24005,'45018','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45188,'76845','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20697,'39082','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(88,'00742','Ceiba','72037','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(12253,'26228','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50689,'90717','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46883,'79256','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40725,'69348','Box Butte','31013','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21999,'41311','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24204,'45307','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12102,'25909','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17554,'33872','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17596,'33924','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44229,'75491','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14139,'29101','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29240,'52209','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42719,'73022','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44044,'75238','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49872,'87577','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48035,'81423','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40544,'69024','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39259,'67425','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37315,'63956','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25576,'47123','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21256,'40006','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33999,'59104','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34031,'59226','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1957,'05489','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(37528,'64446','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2252,'06238','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5225,'13328','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18316,'35565','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43034,'73559','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39817,'68132','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6519,'15532','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19348,'37174','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43872,'75052','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40630,'69148','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32012,'56291','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26741,'48620','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(55019,'99661','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(15291,'30434','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37919,'65074','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45880,'77905','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2422,'06533','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16675,'32521','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22587,'42724','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27257,'49245','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7612,'17318','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47033,'79520','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32275,'56542','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40570,'69039','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52345,'94939','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48345,'83127','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44261,'75560','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41842,'71929','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32279,'56544','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14362,'29434','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11249,'24318','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18449,'35768','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15946,'31322','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(490,'01756','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18277,'35503','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22858,'43214','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32349,'56621','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(38560,'66076','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29475,'52572','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47318,'80023','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42854,'73126','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37589,'64497','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8338,'18837','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23527,'44216','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8910,'20009','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22635,'42784','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41008,'70519','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6171,'15001','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30280,'54150','Menominee','55078','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23096,'43549','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(782,'02478','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38536,'66052','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18934,'36569','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23660,'44436','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6513,'15510','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48354,'83206','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45292,'77006','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39721,'68019','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1296,'03896','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5467,'13747','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15361,'30511','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21057,'39629','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4047,'10998','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8421,'19002','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11115,'24128','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39171,'67206','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9554,'21043','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7686,'17522','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48341,'83122','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49304,'85333','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37626,'64635','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25021,'46311','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5637,'14063','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4991,'12966','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39778,'68065','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28562,'50609','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45402,'77213','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26168,'47923','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23872,'44805','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51528,'92869','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41806,'71854','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40069,'68507','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34421,'59931','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32748,'57274','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14515,'29607','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(110,'00785','Guayama','72057','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(48157,'82214','Platte','56031','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(38588,'66102','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31633,'55973','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15115,'30258','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54486,'98547','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46545,'78779','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36674,'62953','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35120,'61059','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30604,'54616','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34861,'60565','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34209,'59482','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33572,'58467','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18928,'36561','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28376,'50460','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28060,'50136','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12757,'27311','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23137,'43620','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29593,'52751','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8913,'20012','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1909,'05439','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21017,'39534','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31850,'56159','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45765,'77613','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1945,'05474','Grand Isle','50013','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(46016,'78101','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6002,'14736','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52706,'95469','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38431,'65770','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9213,'20505','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(47244,'79925','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30834,'54843','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1775,'04972','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24452,'45671','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23023,'43464','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22739,'43074','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22721,'43064','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13607,'28404','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12863,'27511','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22696,'43045','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49278,'85299','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52040,'94086','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25429,'46951','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45641,'77475','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44814,'76360','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43355,'74079','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37925,'65078','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35573,'61723','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34438,'60010','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32372,'56644','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2469,'06757','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10249,'22655','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27424,'49412','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17451,'33731','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20572,'38901','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6971,'16228','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26430,'48175','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41469,'71276','East Carroll','22035','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50267,'89112','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52627,'95376','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45910,'77983','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43045,'73569','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26673,'48465','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27121,'49042','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36309,'62611','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26205,'47951','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32123,'56364','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21614,'40468','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26816,'48723','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51622,'93218','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19748,'37821','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36687,'62960','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53253,'96362','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(46543,'78774','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52591,'95335','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46775,'79092','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39098,'67106','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30181,'53964','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26841,'48739','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29021,'51549','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41210,'70782','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31275,'55386','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29692,'53037','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(292,'01119','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3593,'09724','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29120,'52037','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39286,'67446','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37412,'64089','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33327,'58219','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33273,'58060','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30371,'54324','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4755,'12551','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48893,'84170','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43948,'75127','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39490,'67645','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39236,'67356','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35329,'61372','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31985,'56271','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15208,'30334','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30796,'54814','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23945,'44855','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(876,'02724','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6980,'16234','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2453,'06716','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24572,'45789','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29845,'53190','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53910,'97491','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46097,'78214','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45546,'77378','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39785,'68071','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38580,'66093','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37410,'64088','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37338,'64015','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35844,'62050','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31797,'56119','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8400,'18958','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19321,'37145','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9988,'22042','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5583,'14010','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52275,'94606','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28290,'50334','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51839,'93610','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43905,'75087','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36102,'62376','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51925,'93717','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12846,'27499','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8245,'18615','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11532,'24822','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1804,'05040','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13909,'28688','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4890,'12827','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18374,'35622','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34024,'59219','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(50504,'90046','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13075,'27819','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48897,'84189','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(38731,'66531','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38055,'65329','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8666,'19404','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26694,'48509','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47959,'81210','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39783,'68069','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34269,'59641','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45909,'77982','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46930,'79347','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31841,'56152','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18530,'35973','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6228,'15061','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7731,'17582','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12126,'25969','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44633,'76070','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13309,'28081','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12804,'27358','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39623,'67841','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18825,'36421','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54933,'99557','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42551,'72757','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30014,'53581','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23983,'44901','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5049,'13044','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28054,'50132','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18453,'35771','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17807,'34436','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35936,'62233','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1180,'03601','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6235,'15067','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53972,'97701','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45197,'76853','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42191,'72352','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31141,'55155','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3355,'09006','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2580,'07022','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34264,'59636','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20497,'38826','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34657,'60401','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44062,'75261','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43157,'73750','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39950,'68367','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7376,'16942','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29410,'52501','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19672,'37730','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3261,'08755','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49868,'87573','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(18167,'35216','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52730,'95514','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52168,'94501','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49766,'87197','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49463,'85714','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41981,'72068','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41554,'71401','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18985,'36691','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8101,'18325','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21594,'40442','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7522,'17121','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10491,'23076','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52910,'95747','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43548,'74477','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42910,'73190','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8063,'18230','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4112,'11233','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24811,'46077','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30043,'53705','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4771,'12571','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8156,'18424','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53048,'95981','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18466,'35805','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41410,'71223','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41259,'70894','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35335,'61377','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52044,'94102','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29642,'53004','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1785,'04984','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1050,'03110','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(14290,'29338','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16997,'33004','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4805,'12723','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12508,'26690','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42830,'73102','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6357,'15270','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5639,'14065','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8772,'19547','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25458,'46974','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49377,'85543','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39376,'67525','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36943,'63366','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10529,'23117','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10848,'23829','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19059,'36793','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29348,'52327','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34998,'60936','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(733,'02350','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32935,'57456','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5812,'14469','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30608,'54619','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19706,'37765','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14050,'29003','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5332,'13483','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42885,'73153','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54166,'98092','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22246,'42054','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19313,'37143','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35655,'61811','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38464,'65802','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13425,'28219','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48602,'83641','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46233,'78389','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45238,'76884','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45323,'77037','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44944,'76486','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23961,'44870','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39612,'67835','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32105,'56353','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(48094,'81639','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19592,'37616','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5269,'13409','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48933,'84332','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6252,'15086','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6022,'14755','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11092,'24101','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11814,'25303','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14651,'29721','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21088,'39656','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49247,'85254','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41654,'71602','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53358,'96674','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(26680,'48471','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30013,'53580','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13439,'28233','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25941,'47546','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16544,'32326','Wakulla','12129','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36708,'62982','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20510,'38839','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1636,'04669','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54745,'99113','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53468,'96811','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(32548,'57032','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30506,'54492','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19120,'36912','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24731,'46015','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5903,'14555','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9114,'20244','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10189,'22553','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50764,'91105','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5679,'14127','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54637,'98848','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51503,'92834','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39981,'68409','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33852,'58783','None','38999','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16011,'31539','Bacon','13005','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24332,'45414','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17055,'33075','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21006,'39507','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17112,'33161','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10863,'23839','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(947,'02861','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(46449,'78667','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47139,'79720','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40628,'69147','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39203,'67330','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20522,'38849','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11810,'25286','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27272,'49253','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10893,'23872','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24031,'45064','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16743,'32618','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8579,'19173','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7266,'16738','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23648,'44424','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12113,'25922','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44170,'75446','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18478,'35824','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47018,'79508','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38981,'66955','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7679,'17516','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22533,'42544','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25286,'46781','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13332,'28103','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14498,'29589','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24801,'46071','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30894,'54914','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20024,'38193','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27099,'49024','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13845,'28638','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20401,'38664','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31031,'55032','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1553,'04492','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6348,'15258','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7373,'16939','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48266,'82721','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46124,'78240','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46302,'78562','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37999,'65260','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13053,'27803','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14072,'29031','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5268,'13408','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15740,'31020','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24823,'46110','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22240,'42050','Fulton','21075','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10028,'22160','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49085,'84766','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43587,'74561','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41282,'71024','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24134,'45217','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3333,'08879','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34337,'59806','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(26913,'48816','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8233,'18601','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38081,'65348','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36990,'63440','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45776,'77626','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4906,'12845','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48536,'83536','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48296,'82845','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42585,'72830','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40917,'70390','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50389,'89445','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(14077,'29036','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3460,'09365','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28634,'50659','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33170,'57767','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40650,'69157','Thomas','31171','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5215,'13320','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21430,'40229','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7256,'16727','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20947,'39439','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1822,'05059','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(48757,'84013','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(16821,'32724','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24127,'45209','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44548,'75975','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35038,'60960','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33351,'58237','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(267,'01085','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7253,'16724','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33981,'59078','Wheatland','30107','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27023,'48889','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41185,'70755','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1542,'04476','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27569,'49646','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14436,'29518','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53374,'96707','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(22271,'42082','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14773,'29938','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21894,'41093','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19450,'37325','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2988,'08039','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49962,'88031','Luna','35029','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44880,'76443','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37567,'64480','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35724,'61872','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15059,'30214','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52364,'94964','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18381,'35640','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4929,'12871','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(958,'02877','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(26025,'47665','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4542,'12194','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9845,'21734','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5483,'13761','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31564,'55922','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54091,'98001','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46008,'78071','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4051,'11003','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4035,'10985','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4016,'10964','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13021,'27690','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5999,'14732','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7263,'16734','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50113,'88435','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(13487,'28304','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36992,'63441','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35593,'61735','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47044,'79528','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39007,'67009','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38965,'66944','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20675,'39060','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24363,'45449','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14542,'29630','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15639,'30803','Glascock','13125','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24531,'45742','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29672,'53021','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1580,'04568','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4731,'12528','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49114,'85013','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4369,'11970','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35293,'61341','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4251,'11713','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17268,'33459','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28702,'50851','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17851,'34605','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22019,'41367','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23623,'44333','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27208,'49104','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6940,'16153','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22287,'42120','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28327,'50430','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33274,'58061','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53689,'97217','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6035,'14777','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19458,'37329','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8781,'19559','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48697,'83830','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45352,'77064','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21778,'40935','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12499,'26675','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5302,'13452','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25475,'46982','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15638,'30802','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53506,'96863','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(30934,'54945','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48425,'83320','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46219,'78377','Refugio','48391','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35712,'61859','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27228,'49202','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13328,'28098','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3548,'09608','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28404,'50480','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(309,'01225','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52290,'94622','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48248,'82642','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(4696,'12487','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6809,'15949','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2367,'06460','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17781,'34280','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10721,'23426','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20387,'38651','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53032,'95968','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46268,'78501','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40463,'68941','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38336,'65692','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30040,'53702','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9161,'20404','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3678,'09870','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8351,'18851','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27692,'49752','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33898,'59002','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30635,'54638','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50584,'90260','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16216,'31788','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19883,'38007','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12056,'25826','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27934,'50039','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47204,'79836','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38188,'65567','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51814,'93558','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40612,'69135','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28852,'51232','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10788,'23541','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51111,'92104','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38990,'66962','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38364,'65722','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35706,'61854','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(476,'01720','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32873,'57383','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5902,'14551','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4663,'12455','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2014,'05733','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20659,'39044','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19766,'37843','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6911,'16124','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7177,'16631','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30513,'54498','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34392,'59873','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2286,'06282','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28583,'50626','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53635,'97119','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52094,'94188','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25360,'46896','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13450,'28250','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19196,'37050','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35105,'61047','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40757,'70011','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43193,'73834','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51504,'92835','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13368,'28130','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42017,'72101','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41217,'70789','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10585,'23183','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42052,'72125','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24707,'45891','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16416,'32139','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7542,'17215','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26599,'48418','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39312,'67464','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36517,'62854','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28139,'50212','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23634,'44408','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14538,'29627','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3749,'10111','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26747,'48623','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27161,'49073','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47943,'81143','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16664,'32505','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28561,'50608','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1589,'04579','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1615,'04640','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2650,'07099','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48213,'82440','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5314,'13465','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48114,'81658','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(55138,'99802','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(8695,'19450','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45259,'76932','Crockett','48105','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40391,'68862','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29866,'53217','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8221,'18507','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(410,'01517','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50248,'89070','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43961,'75146','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38622,'66217','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38254,'65631','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49438,'85648','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36408,'62702','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35583,'61729','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32136,'56377','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53308,'96553','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51389,'92582','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47937,'81137','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47237,'79917','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39296,'67450','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27992,'50071','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18553,'36003','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15483,'30603','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23390,'44041','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21229,'39854','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34238,'59537','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38194,'65582','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51317,'92386','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34777,'60503','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17867,'34655','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33542,'58445','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11356,'24484','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31434,'55616','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3129,'08344','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50715,'90809','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2361,'06450','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41191,'70761','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45026,'76567','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46369,'78621','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13854,'28644','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50549,'90093','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25798,'47371','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(564,'01937','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41505,'71326','Tensas','22107','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25005,'46283','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21089,'39657','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12439,'26555','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47700,'80742','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4640,'12431','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32158,'56398','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26656,'48456','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8563,'19147','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29809,'53149','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31678,'56021','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35780,'61941','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41783,'71834','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44046,'75241','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11743,'25177','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9718,'21411','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11871,'25421','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16912,'32834','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26128,'47872','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28609,'50643','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34430,'60002','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45167,'76825','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14547,'29633','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5341,'13491','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8274,'18636','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42838,'73110','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9980,'22034','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28923,'51433','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48916,'84315','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(2889,'07853','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22567,'42713','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29937,'53523','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53605,'97070','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46185,'78341','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40992,'70508','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26317,'48059','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6401,'15339','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30794,'54813','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54496,'98558','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6620,'15678','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48161,'82219','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47799,'80926','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43360,'74081','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43337,'74066','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24350,'45432','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1920,'05449','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4959,'12927','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5826,'14479','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20054,'38242','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34538,'60110','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1238,'03823','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(40814,'70096','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25392,'46923','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10137,'22469','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3308,'08848','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6819,'15958','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25610,'47147','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1976,'05649','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(41904,'72015','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51390,'92583','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54109,'98021','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14959,'30124','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5658,'14094','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36916,'63344','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34370,'59846','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23501,'44190','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30164,'53954','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48779,'84036','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6316,'15221','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34738,'60464','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42466,'72654','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44071,'75277','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27038,'48901','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22841,'43164','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18714,'36255','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31539,'55812','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15849,'31082','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13517,'28331','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31803,'56122','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52344,'94938','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23478,'44130','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28474,'50551','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10176,'22539','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22422,'42343','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28258,'50305','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30346,'54227','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14846,'30042','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52585,'95329','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40387,'68859','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39248,'67410','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34924,'60657','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31142,'55164','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30441,'54449','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27374,'49336','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33489,'58384','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21319,'40057','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16722,'32580','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4642,'12433','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17201,'33335','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29080,'51637','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33061,'57626','Ziebach','46137','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34059,'59260','Daniels','30019','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54614,'98822','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11420,'24556','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22030,'41451','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1654,'04730','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45355,'77067','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41464,'71270','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32111,'56358','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29759,'53097','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26987,'48865','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26307,'48043','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4259,'11721','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19101,'36868','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47696,'80740','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18723,'36260','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10022,'22151','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54574,'98647','Wahkiakum','53069','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54310,'98292','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48925,'84324','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46238,'78401','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40735,'69355','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39743,'68037','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36683,'62958','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32732,'57266','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2947,'07981','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30644,'54644','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50888,'91411','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27478,'49459','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51860,'93625','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31907,'56215','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31869,'56170','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12573,'26866','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46557,'78833','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49483,'85736','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3142,'08360','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5179,'13210','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9820,'21679','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12491,'26651','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11100,'24112','Martinsville City','51690','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10812,'23667','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37783,'64801','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4153,'11378','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6595,'15646','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21257,'40006','Trimble','21223','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30396,'54414','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52262,'94590','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35209,'61244','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15739,'31020','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35206,'61243','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25627,'47167','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21795,'40965','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6570,'15621','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32246,'56517','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33613,'58504','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38465,'65803','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25428,'46950','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35047,'60966','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11793,'25262','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43022,'73551','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39320,'67470','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25141,'46544','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20895,'39350','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28354,'50448','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28806,'51047','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31617,'55963','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33278,'58064','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42534,'72740','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50758,'91066','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17273,'33464','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41536,'71360','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53697,'97222','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4288,'11757','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16879,'32798','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41776,'71827','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48375,'83233','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47796,'80924','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38512,'66032','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37130,'63637','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32228,'56481','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28578,'50622','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15879,'31107','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25243,'46745','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26602,'48420','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19947,'38068','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31973,'56263','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50757,'91046','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51825,'93592','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3405,'09140','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(25963,'47575','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20813,'39205','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53420,'96759','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41227,'70807','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39440,'67579','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17149,'33233','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18334,'35578','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16687,'32537','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16646,'32459','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23276,'43844','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20863,'39326','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29039,'51559','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31691,'56030','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36243,'62522','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44083,'75320','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38854,'66760','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19357,'37180','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52544,'95249','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17490,'33782','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16819,'32722','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47551,'80463','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41694,'71662','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26842,'48739','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24265,'45344','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8818,'19726','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(15135,'30276','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6245,'15078','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28695,'50845','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28633,'50659','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38912,'66852','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16040,'31557','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53272,'96388','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51548,'93006','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41845,'71933','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32311,'56572','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51843,'93613','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30785,'54774','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30198,'54005','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(849,'02660','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52395,'95017','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24428,'45652','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8095,'18320','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50488,'90030','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11151,'24162','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42789,'73066','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41587,'71428','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32439,'56725','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14168,'29127','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26572,'48377','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22985,'43430','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21684,'40601','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28800,'51044','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33507,'58420','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16026,'31551','Bacon','13005','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(996,'02921','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(15627,'30750','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2202,'06112','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12936,'27565','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16523,'32306','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7745,'17699','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29216,'52169','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29522,'52635','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30291,'54157','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45295,'77009','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10596,'23190','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37746,'64755','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30202,'54007','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42604,'72846','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8340,'18842','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28757,'51018','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26625,'48435','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13239,'27980','Chowan','37041','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25091,'46409','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12822,'27404','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5749,'14270','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18989,'36701','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17272,'33463','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49612,'86426','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43596,'74570','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41998,'72080','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12399,'26447','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48194,'82410','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44945,'76486','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31801,'56121','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13605,'28402','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30299,'54162','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13456,'28260','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44098,'75371','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43567,'74540','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40309,'68792','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39920,'68347','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37835,'64999','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9636,'21205','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8417,'18980','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40166,'68663','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44959,'76508','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34654,'60304','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49885,'87712','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(15877,'31106','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5803,'14461','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27602,'49677','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1150,'03464','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39091,'67073','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41932,'72030','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43785,'74937','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8483,'19067','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24603,'45827','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25760,'47348','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46045,'78124','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26099,'47848','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25778,'47357','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40812,'70093','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24208,'45309','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8406,'18966','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4169,'11420','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11018,'24023','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24114,'45172','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33169,'57767','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15319,'30454','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44816,'76363','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38105,'65438','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46671,'79022','Sherman','48421','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39117,'67117','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21077,'39648','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52870,'95683','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49383,'85550','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5814,'14470','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32190,'56449','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25492,'46991','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4846,'12769','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4088,'11208','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28715,'50861','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35739,'61884','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36509,'62849','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(461,'01611','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51744,'93445','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50586,'90262','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50308,'89153','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(42297,'72456','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41143,'70706','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26441,'48185','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43361,'74082','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32418,'56688','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9256,'20558','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35640,'61775','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38355,'65714','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23319,'43942','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14329,'29404','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17924,'34761','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20412,'38672','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30150,'53944','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15273,'30420','Candler','13043','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35111,'61051','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48333,'83114','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48460,'83353','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49976,'88047','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52116,'94248','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6260,'15096','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54053,'97864','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45249,'76903','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19999,'38145','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40864,'70176','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(30667,'54660','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24730,'46014','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11063,'24070','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20827,'39218','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3222,'08628','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12710,'27259','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13640,'28441','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8019,'18080','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30548,'54538','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40636,'69152','Hooker','31091','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51156,'92158','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52952,'95842','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30723,'54739','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11309,'24426','Craig','51045','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26275,'48004','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6536,'15547','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5769,'14418','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8375,'18929','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11312,'24432','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4326,'11802','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29651,'53010','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4478,'12125','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13550,'28357','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51203,'92232','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31548,'55906','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46329,'78590','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36624,'62921','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53006,'95946','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49637,'86507','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44759,'76249','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8669,'19407','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15315,'30452','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22888,'43279','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24777,'46056','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51310,'92375','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25081,'46394','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6052,'14806','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18895,'36522','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54219,'98177','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46487,'78722','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36603,'62907','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32827,'57356','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31476,'55744','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17600,'33930','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13524,'28334','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5449,'13730','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5299,'13449','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7549,'17222','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19290,'37121','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31582,'55940','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3080,'08230','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52917,'95776','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34381,'59860','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(5022,'13024','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19559,'37402','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20445,'38737','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23292,'43910','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4701,'12493','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45654,'77484','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17182,'33315','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8008,'18071','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7637,'17349','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16115,'31649','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9597,'21108','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52234,'94563','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37620,'64630','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10962,'23950','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5972,'14706','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25608,'47145','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6714,'15779','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43342,'74070','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18269,'35482','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26272,'48002','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3444,'09330','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(17566,'33890','Hardee','12049','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27156,'49068','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26519,'48308','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(394,'01472','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19326,'37149','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50742,'91011','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48917,'84316','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42509,'72716','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32191,'56450','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52033,'94065','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49055,'84735','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(23423,'44076','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45555,'77385','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44631,'76067','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30352,'54234','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4397,'12027','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27760,'49821','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7387,'17002','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16972,'32951','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5854,'14512','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2838,'07750','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19871,'37995','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19681,'37742','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7982,'18046','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15114,'30257','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32618,'57072','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39458,'67625','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42641,'72927','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25665,'47235','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5743,'14261','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15773,'31036','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42314,'72470','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32044,'56315','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40031,'68450','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33641,'58545','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(55079,'99731','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50545,'90088','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44678,'76118','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38292,'65654','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5975,'14709','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12701,'27249','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24509,'45719','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18516,'35961','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44610,'76051','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15340,'30473','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4939,'12887','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21616,'40468','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22122,'41701','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35792,'61953','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53861,'97437','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12792,'27344','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44030,'75224','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35379,'61437','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33510,'58421','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33100,'57657','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20137,'38357','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47648,'80631','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(21848,'41040','Pendleton','21191','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2583,'07026','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13292,'28071','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27482,'49463','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43396,'74131','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25648,'47224','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50902,'91503','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48802,'84058','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39575,'67748','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12237,'26202','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5417,'13666','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29075,'51631','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13227,'27966','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39637,'67850','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42940,'73444','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27710,'49768','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40569,'69038','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15458,'30567','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23451,'44103','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10196,'22560','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46638,'78962','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37715,'64728','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36355,'62655','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22946,'43344','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27787,'49854','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2420,'06531','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35002,'60940','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13926,'28705','Mitchell','37121','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49595,'86338','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5199,'13302','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11592,'24918','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22429,'42348','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2844,'07756','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18387,'35649','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11185,'24221','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23595,'44288','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49740,'87120','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46505,'78736','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42183,'72347','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39284,'67445','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54762,'99128','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(21921,'41141','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15566,'30669','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1837,'05077','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(22231,'42041','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44280,'75601','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20287,'38567','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34973,'60917','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31733,'56063','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31180,'55324','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43466,'74359','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40459,'68938','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30475,'54470','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29994,'53566','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(94,'00754','San Lorenzo','72129','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(32085,'56340','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4941,'12903','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21995,'41301','Powell','21197','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47407,'80165','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8317,'18817','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53756,'97324','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19347,'37174','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49937,'87943','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45399,'77209','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36604,'62907','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12376,'26419','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9431,'20783','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34329,'59762','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46441,'78663','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40116,'68631','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37368,'64054','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10498,'23084','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9701,'21281','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3065,'08210','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16057,'31598','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14910,'30095','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14403,'29474','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40748,'69367','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13382,'28145','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13868,'28654','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27290,'49268','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23823,'44681','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3562,'09630','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2832,'07739','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14381,'29452','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17838,'34484','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17313,'33524','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2093,'05862','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(31755,'56081','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21460,'40282','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32807,'57341','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38631,'66226','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52878,'95690','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38332,'65689','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45370,'77082','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7061,'16360','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25422,'46945','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24530,'45742','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14779,'29944','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6596,'15647','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9352,'20693','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11457,'24597','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16369,'32085','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34750,'60471','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36149,'62432','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18286,'35542','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26209,'47954','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49346,'85376','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39841,'68175','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23503,'44192','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(993,'02918','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(5523,'13820','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12602,'27025','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(48465,'83402','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29005,'51536','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28406,'50480','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36962,'63384','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52643,'95391','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40080,'68523','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33315,'58205','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32787,'57329','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22151,'41759','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24650,'45856','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47126,'79708','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14306,'29368','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10865,'23841','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9444,'20811','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19128,'36925','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22814,'43146','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3530,'09581','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32438,'56725','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31351,'55449','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8752,'19529','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7102,'16420','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29879,'53228','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33276,'58062','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45261,'76933','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47093,'79561','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26724,'48612','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25413,'46938','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12913,'27544','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2627,'07072','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31299,'55401','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33145,'57745','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22305,'42135','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42896,'73165','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36310,'62611','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32821,'57353','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31045,'55044','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48770,'84026','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(2986,'08037','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41362,'71113','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24312,'45384','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32259,'56527','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2761,'07603','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9785,'21647','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9079,'20202','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(43757,'74871','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29922,'53516','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44974,'76525','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27681,'49744','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33215,'58017','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27186,'49089','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9529,'21010','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3824,'10275','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28877,'51248','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6968,'16224','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2995,'08049','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51511,'92843','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54447,'98499','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16556,'32336','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47965,'81221','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9959,'21916','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6507,'15489','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33469,'58369','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22469,'42408','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38685,'66439','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33605,'58495','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48087,'81635','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1513,'04435','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42644,'72928','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24639,'45849','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34996,'60935','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43102,'73667','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44713,'76185','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42536,'72742','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34771,'60491','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32478,'56759','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31117,'55114','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12990,'27611','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15590,'30711','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15828,'31069','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40543,'69023','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47344,'80102','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38708,'66512','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52921,'95812','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19244,'37079','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10905,'23883','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22887,'43272','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9589,'21094','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3712,'10028','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18890,'36513','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6517,'15530','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(277,'01097','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27103,'49028','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39258,'67425','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23489,'44141','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32479,'56760','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40804,'70084','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43389,'74126','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25839,'47427','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17614,'33950','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30324,'54205','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19878,'38004','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31304,'55406','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3728,'10045','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6551,'15562','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25204,'46705','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16477,'32219','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30630,'54634','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47717,'80802','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42788,'73065','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31058,'55055','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29396,'52404','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28913,'51364','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29834,'53182','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23089,'43545','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44972,'76524','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2898,'07870','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7539,'17213','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17497,'33804','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22502,'42457','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49312,'85340','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50771,'91115','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50012,'88124','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(42527,'72737','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34655,'60305','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8239,'18611','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46715,'79054','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26874,'48761','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25187,'46616','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23995,'45003','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14626,'29692','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3867,'10469','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9178,'20421','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17872,'34668','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32169,'56434','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23641,'44415','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16567,'32346','Wakulla','12129','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34259,'59633','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(39453,'67622','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39712,'68009','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48305,'82931','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(52527,'95230','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47395,'80137','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43966,'75148','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37899,'65061','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35997,'62272','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35179,'61111','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44327,'75656','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16680,'32530','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13726,'28532','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11383,'24522','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21532,'40361','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29008,'51541','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14434,'29516','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2659,'07109','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37030,'63467','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45174,'76832','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3008,'08063','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9663,'21224','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22993,'43435','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26692,'48506','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20696,'39081','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38587,'66101','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10108,'22407','Fredericksburg City','51630','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44943,'76485','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52008,'94019','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33739,'58649','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19501,'37359','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17407,'33637','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22687,'43035','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22295,'42129','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19482,'37345','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37186,'63750','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47313,'80020','Broomfield','8014','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48472,'83406','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37950,'65111','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19927,'38049','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9048,'20167','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24451,'45671','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1843,'05086','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28396,'50473','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16644,'32456','Gulf','12045','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27000,'48875','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37615,'64625','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4185,'11436','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49645,'86535','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47840,'81011','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11613,'24970','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20977,'39465','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3379,'09067','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(5640,'14066','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53389,'96725','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(51276,'92331','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38337,'65702','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1733,'04925','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12896,'27532','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12607,'27030','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(2777,'07641','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17060,'33083','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35124,'61062','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24311,'45383','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33629,'58530','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26370,'48114','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2021,'05740','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(49825,'87517','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(31374,'55550','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9602,'21117','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12053,'25820','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14034,'28810','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21497,'40330','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3733,'10075','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4652,'12442','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18040,'35062','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54295,'98278','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20581,'38916','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14308,'29370','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22614,'42753','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(682,'02196','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20781,'39171','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4330,'11819','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47216,'79851','Hudspeth','48229','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12661,'27157','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19673,'37731','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50306,'89151','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54779,'99141','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49841,'87533','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48889,'84152','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46014,'78075','McMullen','48311','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40474,'68947','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35824,'62027','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30728,'54741','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6884,'16059','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14284,'29333','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20761,'39153','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17784,'34284','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24225,'45320','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49792,'87365','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46905,'79324','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43410,'74150','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38021,'65281','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37203,'63774','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35732,'61878','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54148,'98063','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52086,'94158','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45973,'78041','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35249,'61283','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19809,'37874','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40183,'68713','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22316,'42154','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14385,'29456','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27409,'49402','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23793,'44654','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24148,'45232','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2911,'07901','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36465,'62819','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48892,'84165','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40607,'69134','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43639,'74721','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22631,'42782','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28500,'50568','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22951,'43345','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40231,'68745','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35386,'61442','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36302,'62571','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42808,'73079','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33371,'58259','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41552,'71377','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35499,'61547','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1626,'04654','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15324,'30457','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15318,'30453','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15705,'31002','Treutlen','13283','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24789,'46065','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37833,'64873','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45214,'76864','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30591,'54568','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3048,'08098','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26516,'48306','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25834,'47408','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8754,'19530','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35564,'61705','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20683,'39071','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53038,'95973','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37158,'63666','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36573,'62889','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34588,'60147','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23031,'43469','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13500,'28314','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22794,'43135','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34732,'60460','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9448,'20815','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(549,'01904','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29392,'52362','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22995,'43437','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15127,'30269','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49199,'85140','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(22622,'42758','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51741,'93442','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54292,'98275','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52628,'95377','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22747,'43080','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49905,'87743','Harding','35021','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(1608,'04628','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40926,'70403','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(349,'01343','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27324,'49307','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24852,'46129','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49644,'86520','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48387,'83246','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32504,'57002','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17100,'33149','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45431,'77245','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8074,'18241','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24988,'46259','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1237,'03822','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3465,'09370','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(44222,'75486','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1535,'04468','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1781,'04979','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48636,'83687','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43628,'74647','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52826,'95639','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45879,'77904','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41137,'70663','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39980,'68407','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36518,'62854','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34410,'59920','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30108,'53911','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17530,'33847','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38152,'65536','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28346,'50441','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24532,'45743','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9458,'20833','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52865,'95678','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55093,'99746','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42077,'72142','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54920,'99540','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51067,'92036','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48632,'83676','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48165,'82223','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(9534,'21015','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8242,'18614','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3173,'08527','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2132,'06033','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11129,'24139','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25385,'46919','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12857,'27506','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28455,'50539','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20363,'38633','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1899,'05362','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20309,'38581','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7044,'16342','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16790,'32693','Gilchrist','12041','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14500,'29591','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14739,'29905','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20644,'38965','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28632,'50658','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40085,'68528','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36986,'63438','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17822,'34464','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23105,'43557','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37437,'64123','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47277,'79960','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21071,'39643','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47917,'81102','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41128,'70656','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37047,'63532','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34688,'60426','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11839,'25333','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10222,'22623','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12752,'27305','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11533,'24823','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4821,'12741','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17959,'34974','Glades','12043','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28743,'51006','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37214,'63783','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18109,'35139','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53630,'97115','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46662,'79018','Hartley','48205','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46113,'78229','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39247,'67410','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39206,'67334','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24424,'45648','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48560,'83601','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(7281,'16804','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32486,'56763','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3647,'09824','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27639,'49711','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24543,'45761','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2906,'07880','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14673,'29805','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36878,'63155','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41250,'70836','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18451,'35769','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53004,'95944','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49128,'85027','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34876,'60605','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34525,'60098','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14296,'29349','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9981,'22035','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35743,'61911','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43255,'74010','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1872,'05257','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17132,'33182','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11637,'25019','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11852,'25362','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33255,'58051','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48742,'83873','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31550,'55909','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23494,'44145','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47777,'80905','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40904,'70363','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34486,'60056','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10815,'23670','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6583,'15633','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4797,'12604','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25848,'47433','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4373,'11975','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16033,'31554','Bacon','13005','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23327,'43947','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45276,'76945','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40705,'69334','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33619,'58520','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2025,'05744','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23345,'43973','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54437,'98465','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49589,'86333','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54973,'99611','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50995,'91792','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14523,'29613','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1326,'04020','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24824,'46110','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36706,'62977','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51964,'93793','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23446,'44097','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49553,'86033','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3491,'09501','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48795,'84052','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54275,'98255','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45130,'76690','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37527,'64446','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2603,'07047','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11539,'24829','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53492,'96843','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54788,'99152','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23928,'44845','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23299,'43917','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22176,'41826','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18960,'36610','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18622,'36051','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49108,'85007','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14869,'30060','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45566,'77404','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31684,'56026','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48808,'84063','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(38497,'66018','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31988,'56274','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1143,'03452','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26046,'47721','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19527,'37375','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48424,'83318','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6454,'15429','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46924,'79344','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42,'00677','Rincon','72117','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(25602,'47141','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25434,'46952','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(963,'02882','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(13669,'28459','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12637,'27101','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1612,'04634','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1136,'03445','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(31533,'55806','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29960,'53541','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32345,'56594','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28939,'51447','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8057,'18221','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13947,'28724','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15715,'31009','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41107,'70637','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44461,'75850','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45357,'77069','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48056,'81507','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15316,'30452','Candler','13043','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8512,'19096','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45430,'77244','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28270,'50317','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14452,'29546','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50256,'89101','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47806,'80933','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35566,'61710','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14252,'29229','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42421,'72613','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8758,'19535','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(180,'00961','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(6996,'16250','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21417,'40214','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19190,'37047','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9924,'21838','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9739,'21539','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30426,'54435','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31407,'55586','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35359,'61420','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26190,'47943','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33794,'58737','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25418,'46940','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52738,'95527','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41188,'70757','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38020,'65280','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31520,'55790','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31065,'55063','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35276,'61328','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14287,'29335','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(568,'01945','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7365,'16932','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3827,'10278','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21606,'40452','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9699,'21279','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11497,'24647','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3735,'10081','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50947,'91732','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47611,'80534','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4076,'11104','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21085,'39654','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48615,'83653','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37772,'64780','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37038,'63473','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46245,'78408','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43974,'75154','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(818,'02573','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4193,'11514','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12252,'26224','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31167,'55315','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34048,'59254','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36605,'62908','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1962,'05495','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15107,'30252','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8708,'19464','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35275,'61327','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44804,'76310','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39937,'68359','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36425,'62739','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34833,'60544','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32791,'57331','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27986,'50069','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3566,'09642','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48514,'83462','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46005,'78070','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17389,'33615','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1416,'04230','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1037,'03102','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9645,'21210','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5597,'14028','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11536,'24827','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54992,'99632','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46843,'79230','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40322,'68815','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9456,'20832','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10466,'23050','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4917,'12856','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8502,'19087','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10696,'23395','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6169,'14905','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26767,'48635','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12164,'26055','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7586,'17263','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50609,'90303','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47492,'80295','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6690,'15757','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17813,'34448','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23155,'43711','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23585,'44280','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25195,'46637','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4920,'12859','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14183,'29137','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33146,'57747','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3780,'10158','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45512,'77353','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5182,'13214','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7987,'18053','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49374,'85540','Greenlee','4011','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44783,'76268','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44689,'76130','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41645,'71480','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41313,'71058','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37938,'65101','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30381,'54408','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4295,'11766','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9035,'20151','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14632,'29702','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26690,'48504','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26429,'48174','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13889,'28672','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10555,'23146','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10035,'22185','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8586,'19182','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39046,'67039','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13958,'28734','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36389,'62684','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17541,'33857','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44791,'76273','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42544,'72752','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4437,'12068','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17578,'33906','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52115,'94247','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33889,'58852','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30401,'54420','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4237,'11692','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2531,'06879','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10059,'22215','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(528,'01854','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(245,'01059','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9189,'20434','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(21300,'40046','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50870,'91386','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45698,'77522','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15345,'30474','Treutlen','13283','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28827,'51060','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27394,'49346','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28112,'50164','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42515,'72727','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40113,'68629','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29603,'52757','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27994,'50072','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26202,'47949','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11584,'24898','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5922,'14585','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2396,'06502','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(46525,'78755','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35644,'61778','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46560,'78837','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43014,'73546','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11733,'25160','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13180,'27910','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(561,'01930','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22539,'42565','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38534,'66050','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8739,'19511','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29180,'52135','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17493,'33786','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21354,'40108','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31880,'56178','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36938,'63361','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33793,'58736','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31341,'55439','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17303,'33503','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26286,'48021','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18425,'35751','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5530,'13832','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11131,'24141','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10199,'22567','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15918,'31294','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54883,'99359','Columbia','53013','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53784,'97351','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(22839,'43160','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39444,'67583','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29345,'52325','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25432,'46952','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14999,'30153','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26439,'48183','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14303,'29360','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32632,'57105','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7643,'17356','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52534,'95236','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52607,'95354','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42459,'72645','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40337,'68823','Loup','31115','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36882,'63160','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34195,'59464','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1773,'04970','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12285,'26270','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8909,'20008','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17282,'33472','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1621,'04648','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26033,'47705','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4950,'12917','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29908,'53504','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25411,'46936','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1001,'03034','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9379,'20723','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20695,'39080','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3528,'09578','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(50006,'88119','De Baca','35011','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45095,'76657','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41286,'71030','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37681,'64670','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31082,'55078','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23734,'44611','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15338,'30471','Candler','13043','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47885,'81062','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42865,'73135','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45140,'76704','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19031,'36761','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48020,'81402','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47295,'80005','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45008,'76549','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40167,'68663','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35793,'61955','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6688,'15754','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7426,'17029','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13174,'27896','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9677,'21233','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29669,'53020','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31000,'55006','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32841,'57366','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23787,'44647','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23775,'44638','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6350,'15260','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17251,'33437','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47650,'80633','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33024,'57560','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11491,'24639','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20645,'38965','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1427,'04252','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18326,'35574','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8774,'19549','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14415,'29484','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38463,'65801','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13006,'27626','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39519,'67658','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49396,'85608','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44987,'76531','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43183,'73768','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35378,'61436','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33902,'59006','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11465,'24602','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22322,'42163','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31296,'55398','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17843,'34491','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8957,'20063','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7548,'17222','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15803,'31055','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45538,'77372','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25671,'47240','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23221,'43772','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1816,'05052','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(22998,'43440','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27814,'49883','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2582,'07024','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39212,'67337','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37505,'64429','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49587,'86331','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(18025,'35046','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4874,'12804','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23208,'43760','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1705,'04851','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35205,'61242','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32958,'57471','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54280,'98260','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32448,'56732','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53706,'97229','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51675,'93275','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49875,'87580','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43781,'74931','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4245,'11704','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10602,'23221','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9204,'20468','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(21092,'39661','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18968,'36619','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30272,'54137','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42666,'72947','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3297,'08831','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21286,'40031','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48287,'82834','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44279,'75601','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55119,'99772','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52941,'95832','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43844,'75028','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27117,'49039','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6191,'15021','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43232,'73938','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42000,'72081','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31452,'55719','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29519,'52630','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22767,'43107','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23946,'44856','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29065,'51578','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34511,'60085','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(135,'00906','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(24843,'46123','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45264,'76935','Schleicher','48413','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40634,'69150','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38299,'65658','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29592,'52750','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23265,'43832','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6808,'15948','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14814,'30019','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2857,'07820','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6490,'15469','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(234,'01037','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34710,'60443','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44958,'76505','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50123,'88517','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(25662,'47234','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45534,'77369','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20544,'38862','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14783,'29945','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15451,'30564','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27722,'49777','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1281,'03871','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24486,'45694','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15289,'30429','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43359,'74081','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52105,'94232','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33933,'59037','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28958,'51458','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28782,'51030','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11141,'24149','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23093,'43548','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10500,'23086','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31502,'55769','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23295,'43914','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16628,'32440','Holmes','12059','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32049,'56319','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(13504,'28318','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36139,'62426','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20929,'39406','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1291,'03886','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52800,'95617','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47042,'79527','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29616,'52769','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6857,'16039','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5977,'14711','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21691,'40619','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16181,'31764','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26411,'48160','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2753,'07522','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42592,'72837','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51435,'92653','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48076,'81623','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(25971,'47579','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10675,'23320','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8450,'19031','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3715,'10031','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15973,'31419','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50554,'90101','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41556,'71403','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14820,'30024','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19035,'36765','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54957,'99586','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54543,'98610','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37314,'63955','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47704,'80744','Sedgwick','8115','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14216,'29175','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48826,'84080','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48294,'82842','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46788,'79098','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45756,'77587','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44263,'75562','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34152,'59424','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23985,'44903','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25811,'47385','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1265,'03854','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11281,'24368','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22350,'42216','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6684,'15748','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52938,'95829','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46106,'78223','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44012,'75205','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42498,'72701','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36046,'62324','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10901,'23881','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12404,'26451','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51409,'92609','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54247,'98226','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33992,'59087','Petroleum','30069','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17812,'34447','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28661,'50675','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47500,'80307','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46653,'79011','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51659,'93255','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47858,'81039','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47082,'79549','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41252,'70873','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40092,'68588','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31535,'55808','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31221,'55346','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26243,'47977','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10091,'22314','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3106,'08314','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2570,'07012','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7159,'16611','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16342,'32056','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27985,'50069','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48747,'84001','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9903,'21798','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25076,'46390','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26197,'47946','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7006,'16260','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24660,'45862','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45584,'77426','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28897,'51346','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10162,'22514','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9817,'21676','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1691,'04779','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26379,'48123','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13784,'28585','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49823,'87515','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52854,'95668','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8364,'18917','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11302,'24416','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3525,'09575','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(34221,'59521','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36331,'62628','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35158,'61087','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30210,'54016','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4735,'12531','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25235,'46740','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27362,'49329','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46527,'78757','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19997,'38139','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45548,'77380','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31227,'55350','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16365,'32082','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12801,'27356','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19037,'36766','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21773,'40921','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39049,'67041','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44156,'75435','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54290,'98273','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10785,'23521','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4552,'12206','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2925,'07933','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26766,'48634','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26995,'48872','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6051,'14805','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3367,'09034','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27762,'49822','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22272,'42082','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44269,'75568','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10252,'22657','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54243,'98222','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35613,'61748','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4055,'11020','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32364,'56634','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15507,'30624','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25228,'46732','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9686,'21239','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36847,'63125','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16201,'31778','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47286,'79997','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4767,'12567','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20829,'39232','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6213,'15045','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(643,'02129','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38779,'66611','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33792,'58736','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32397,'56669','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12643,'27107','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25772,'47355','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37428,'64113','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38033,'65287','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19597,'37625','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16877,'32795','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22719,'43064','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7984,'18050','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2646,'07094','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29310,'52301','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35723,'61872','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54426,'98431','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12448,'26570','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45256,'76909','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11673,'25064','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9440,'20794','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53805,'97370','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(22709,'43058','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36857,'63133','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38705,'66508','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45285,'76957','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46187,'78343','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4922,'12861','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13683,'28472','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36804,'63077','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6994,'16248','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17368,'33595','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22960,'43356','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45236,'76883','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5909,'14560','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15525,'30634','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13206,'27941','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3120,'08329','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39397,'67550','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35682,'61842','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17315,'33526','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17028,'33039','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13154,'27883','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24861,'46140','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23996,'45003','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9647,'21211','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43064,'73632','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38126,'65459','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34151,'59422','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32538,'57026','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54232,'98201','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24123,'45205','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54307,'98290','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5973,'14707','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41851,'71940','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31732,'56063','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1657,'04734','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21392,'40166','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11406,'24541','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51827,'93599','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23339,'43968','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46733,'79064','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37591,'64498','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9668,'21226','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9107,'20235','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(51489,'92809','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15381,'30521','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37903,'65062','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5448,'13699','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14643,'29714','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44722,'76199','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45045,'76599','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15793,'31046','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13812,'28612','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30039,'53701','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13102,'27840','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41334,'71072','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24105,'45164','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9535,'21017','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50631,'90502','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52469,'95132','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13602,'28399','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50914,'91602','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50637,'90508','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22348,'42215','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50768,'91109','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15027,'30177','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24314,'45385','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10003,'22096','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44321,'75652','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45076,'76643','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46383,'78629','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49245,'85252','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51460,'92692','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52195,'94524','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51777,'93516','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24905,'46166','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49960,'88029','Luna','35029','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(26366,'48110','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22467,'42408','Caldwell','21033','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6988,'16240','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19591,'37615','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7730,'17581','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12961,'27589','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32526,'57017','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15306,'30445','Treutlen','13283','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48115,'82001','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37320,'63960','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18424,'35750','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(136,'00907','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(4342,'11940','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38272,'65641','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23837,'44691','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26630,'48438','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32605,'57064','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48201,'82421','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48886,'84148','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50670,'90660','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52337,'94927','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16075,'31625','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46757,'79081','Roberts','48393','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52698,'95461','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53434,'96773','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54523,'98588','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53179,'96133','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22080,'41568','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41643,'71479','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11248,'24318','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24276,'45352','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42185,'72347','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48492,'83438','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54599,'98686','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(289,'01115','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12548,'26810','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36805,'63079','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31835,'56146','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17276,'33467','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22994,'43436','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44393,'75755','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54254,'98232','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39993,'68420','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12815,'27375','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13047,'27722','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51336,'92410','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24606,'45830','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24160,'45242','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25924,'47529','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47830,'81002','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29256,'52218','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6365,'15281','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42756,'73048','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1008,'03043','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27783,'49852','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38628,'66223','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8994,'20111','Manassas Park City','51685','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45,'00681','Mayaguez','72097','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(9503,'20898','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24456,'45673','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50676,'90701','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28179,'50235','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1175,'03592','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9243,'20542','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14094,'29047','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31460,'55725','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46995,'79415','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48331,'83113','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(1684,'04769','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(55013,'99655','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(23338,'43967','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21766,'40906','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14640,'29709','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18522,'35966','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31584,'55940','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38289,'65652','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46765,'79085','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4204,'11550','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16351,'32064','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27691,'49751','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4122,'11245','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10957,'23943','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15004,'30157','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4563,'12224','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39967,'68379','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53698,'97222','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(16439,'32173','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31632,'55972','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38417,'65760','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39018,'67020','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54928,'99552','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(16059,'31601','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9631,'21163','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17770,'34267','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17466,'33757','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21847,'41039','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15758,'31030','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14766,'29932','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7665,'17407','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41322,'71067','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11744,'25177','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36460,'62815','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37488,'64191','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54037,'97840','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2003,'05677','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34619,'60177','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17660,'34035','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(12500,'26676','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38784,'66615','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6560,'15611','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24090,'45148','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31764,'56087','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31856,'56162','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39036,'67030','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41541,'71362','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47149,'79738','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14279,'29330','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50056,'88267','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48511,'83454','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47150,'79739','Glasscock','48173','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33190,'57790','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25973,'47581','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14450,'29544','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14232,'29210','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51292,'92350','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10418,'22973','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5141,'13144','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25611,'47147','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4926,'12865','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23358,'43985','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22981,'43414','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21444,'40252','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1514,'04438','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42513,'72721','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16335,'32050','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(914,'02809','Bristol','44001','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(28081,'50149','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53825,'97390','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41199,'70772','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28414,'50484','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19406,'37229','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52583,'95327','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4250,'11710','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34116,'59345','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(50415,'89519','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53324,'96607','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(18645,'36072','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29905,'53502','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34921,'60654','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11113,'24127','Craig','51045','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40202,'68726','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51444,'92662','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52399,'95021','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53298,'96541','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(6835,'16021','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40455,'68936','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24939,'46207','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21822,'41010','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11785,'25252','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12464,'26588','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16098,'31637','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41542,'71363','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42296,'72455','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24029,'45062','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47935,'81136','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7878,'17878','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43386,'74120','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41953,'72044','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30351,'54232','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53047,'95980','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46173,'78299','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51632,'93230','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26618,'48430','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13752,'28560','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3266,'08759','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29568,'52727','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29644,'53005','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(333,'01262','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23944,'44854','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37022,'63462','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9907,'21804','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2473,'06763','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33377,'58262','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36235,'62513','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43211,'73848','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26144,'47903','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15840,'31077','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18062,'35085','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15789,'31044','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3479,'09447','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(46293,'78550','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34660,'60403','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30367,'54308','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7606,'17313','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8632,'19351','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34812,'60527','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33161,'57760','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30102,'53827','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27860,'49945','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18675,'36110','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3831,'10282','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27721,'49777','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50484,'90026','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23919,'44841','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19608,'37656','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28122,'50171','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(607,'02055','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5512,'13808','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10670,'23310','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42877,'73147','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19586,'37604','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48638,'83701','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47872,'81047','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38860,'66769','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35268,'61321','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1425,'04243','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27733,'49791','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(99,'00769','Coamo','72043','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(16970,'32949','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32050,'56319','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(44134,'75418','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47427,'80216','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(67,'00719','Naranjito','72105','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13192,'27924','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30389,'54411','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29963,'53543','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22417,'42338','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19136,'37014','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16195,'31775','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41535,'71359','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36504,'62844','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34903,'60633','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34225,'59524','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22312,'42151','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3183,'08540','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26291,'48027','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6934,'16145','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31122,'55118','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54675,'98940','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13621,'28423','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30110,'53913','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32613,'57070','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43644,'74727','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49068,'84749','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51733,'93433','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23063,'43522','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1201,'03755','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(33203,'58005','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15439,'30557','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24585,'45810','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14961,'30125','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21925,'41143','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13219,'27957','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3107,'08315','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46568,'78843','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36947,'63370','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40835,'70139','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31200,'55334','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30576,'54558','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14484,'29576','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15537,'30646','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51769,'93504','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41663,'71631','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12444,'26562','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49949,'88013','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(14449,'29543','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26024,'47660','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11840,'25334','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11415,'24553','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30184,'53965','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42971,'73488','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54453,'98505','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33099,'57656','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36313,'62612','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48438,'83335','Jerome','16053','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41611,'71450','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54549,'98616','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5457,'13736','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13095,'27834','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10830,'23709','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46239,'78402','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46692,'79039','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48,'00685','San Sebastian','72131','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51062,'92028','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45050,'76623','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44331,'75658','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44885,'76445','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(227,'01030','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29909,'53505','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28612,'50645','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9549,'21037','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5080,'13076','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2792,'07661','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40911,'70375','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51532,'92878','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43519,'74446','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35986,'62265','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35537,'61612','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8746,'19520','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13828,'28626','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46056,'78140','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52112,'94244','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2965,'08016','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6421,'15363','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47928,'81129','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53216,'96218','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(35529,'61603','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14509,'29601','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20464,'38760','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22646,'43006','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18821,'36420','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26709,'48602','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26437,'48180','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37592,'64499','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21934,'41164','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32198,'56458','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45158,'76802','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7287,'16823','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28909,'51360','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49400,'85611','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41674,'71643','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41496,'71322','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39176,'67211','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8837,'19880','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(6792,'15930','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33419,'58327','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50163,'88561','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(28129,'50206','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17742,'34228','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8262,'18626','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46431,'78658','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53499,'96853','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(39849,'68198','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43049,'73572','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30957,'54964','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23237,'43787','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18141,'35181','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(863,'02702','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32591,'57054','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(273,'01093','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27368,'49331','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2074,'05840','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(6794,'15934','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54460,'98513','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42762,'73052','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34630,'60186','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32874,'57384','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32568,'57043','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32060,'56326','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31127,'55123','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11285,'24374','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33008,'57544','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29142,'52054','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13216,'27953','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35005,'60941','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2248,'06233','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11690,'25093','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30703,'54728','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43295,'74035','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32988,'57531','Stanley','46117','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19295,'37128','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50893,'91426','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45232,'76878','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21783,'40941','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22465,'42406','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30751,'54757','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18802,'36352','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37082,'63557','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24469,'45683','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20495,'38824','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10169,'22526','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25279,'46776','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18704,'36203','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2395,'06501','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30318,'54182','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52177,'94509','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31130,'55126','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25595,'47137','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17705,'34137','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52523,'95227','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50353,'89409','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(37002,'63447','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35909,'62097','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35835,'62037','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13078,'27822','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34460,'60029','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6098,'14845','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54723,'99030','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41258,'70893','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32253,'56522','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31109,'55108','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21291,'40036','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10890,'23867','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48691,'83823','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(15795,'31047','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14895,'30084','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3103,'08311','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40062,'68467','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37924,'65078','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35259,'61314','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36240,'62519','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51630,'93226','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50945,'91730','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33116,'57716','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20247,'38504','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11251,'24319','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8690,'19441','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23080,'43534','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3764,'10126','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16993,'32976','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12795,'27349','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20079,'38311','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30552,'54539','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17176,'33309','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42111,'72178','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27661,'49727','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21936,'41164','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22200,'42002','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22902,'43315','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53720,'97266','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25755,'47345','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50178,'88577','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(10407,'22967','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6178,'15007','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15595,'30724','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29115,'52033','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19495,'37356','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11066,'24073','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49487,'85739','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31212,'55341','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20717,'39096','Claiborne','28021','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16361,'32080','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6917,'16127','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52727,'95502','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53830,'97396','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33546,'58451','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13933,'28711','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52608,'95355','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52518,'95222','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3235,'08691','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21034,'39568','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51727,'93426','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50071,'88325','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49433,'85643','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10208,'22579','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1749,'04942','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21849,'41041','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18729,'36265','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4318,'11792','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38039,'65320','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47876,'81052','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35783,'61943','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18777,'36319','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6778,'15909','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(942,'02852','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(53751,'97317','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(24476,'45686','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42342,'72519','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36582,'62893','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23695,'44484','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14743,'29909','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29760,'53098','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16553,'32333','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25998,'47617','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14984,'30143','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4467,'12115','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5051,'13045','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49663,'87012','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(45844,'77852','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30176,'53962','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13991,'28760','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21948,'41179','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17320,'33538','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47770,'80863','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30314,'54175','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4300,'11771','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23593,'44287','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29379,'52353','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27875,'49963','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17025,'33035','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37539,'64457','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5196,'13261','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8438,'19018','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52939,'95830','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45616,'77453','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37618,'64628','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37516,'64438','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34384,'59865','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20540,'38860','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10838,'23805','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46806,'79117','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3451,'09352','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27714,'49770','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36395,'62690','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16292,'31905','Chattahoochee','13053','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1448,'04280','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7175,'16629','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26919,'48821','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24690,'45882','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28473,'50548','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19474,'37338','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43798,'74948','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24922,'46180','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24224,'45319','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48875,'84131','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44770,'76259','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42166,'72330','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8760,'19538','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8314,'18814','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9425,'20777','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13238,'27979','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30620,'54627','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25271,'46770','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49684,'87029','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(20042,'38231','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3610,'09742','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3336,'08884','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41428,'71235','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48664,'83728','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52503,'95203','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13610,'28407','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9388,'20736','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45258,'76930','Irion','48235','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34464,'60033','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53608,'97075','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35075,'61019','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8013,'18074','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2170,'06077','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31088,'55080','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21904,'41099','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22607,'42746','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50485,'90027','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14380,'29451','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32806,'57341','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35604,'61742','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39746,'68039','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37281,'63901','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11201,'24244','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49223,'85209','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42594,'72838','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33839,'58772','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20297,'38573','Pickett','47137','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20512,'38841','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30253,'54120','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50507,'90049','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43522,'74450','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40012,'68437','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41175,'70744','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42321,'72475','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21428,'40225','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28617,'50648','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(239,'01050','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(323,'01247','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37562,'64475','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49289,'85311','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44508,'75937','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1380,'04093','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16433,'32162','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30049,'53714','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45348,'77060','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44028,'75222','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28911,'51364','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33673,'58572','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20415,'38675','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33825,'58761','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32391,'56662','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2251,'06237','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6133,'14874','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28619,'50650','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(201,'00985','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(44564,'76008','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35299,'61345','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13124,'27857','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31414,'55593','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54350,'98344','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44213,'75479','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36174,'62448','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21587,'40422','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19838,'37892','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26612,'48427','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19440,'37320','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29751,'53090','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39640,'67851','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38482,'66006','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23099,'43552','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7874,'17876','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52954,'95851','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48058,'81521','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53051,'95983','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49672,'87020','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36961,'63384','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(270,'01089','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29907,'53504','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10383,'22942','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36704,'62975','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51536,'92881','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49657,'87006','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(26677,'48469','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54050,'97859','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46357,'78614','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46147,'78261','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41691,'71660','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40310,'68792','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38469,'65807','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5396,'13645','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27210,'49107','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2597,'07042','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11136,'24143','Radford City','51750','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11595,'24925','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8184,'18446','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13971,'28744','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10870,'23844','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44756,'76247','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35077,'61020','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7335,'16873','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4761,'12564','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26466,'48213','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30239,'54110','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50181,'88580','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(15394,'30530','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15277,'30423','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49330,'85358','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10803,'23630','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53790,'97358','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50803,'91301','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43717,'74848','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34694,'60432','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33229,'58033','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31877,'56176','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15184,'30315','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5434,'13682','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19655,'37715','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22063,'41547','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8171,'18436','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20608,'38940','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24999,'46277','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13502,'28315','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14237,'29214','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30958,'54965','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46447,'78666','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42751,'73045','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1338,'04038','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27059,'48933','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3429,'09301','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54403,'98398','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53804,'97369','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42738,'73036','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38283,'65649','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34080,'59312','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29149,'52065','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3666,'09844','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8912,'20011','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(38197,'65586','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4477,'12124','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3090,'08246','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30233,'54104','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16330,'32043','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47389,'80134','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40893,'70352','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49527,'85938','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43393,'74129','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40844,'70151','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(517,'01835','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45954,'78021','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39460,'67627','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4452,'12084','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2002,'05676','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27021,'48888','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8852,'19902','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(52250,'94578','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50958,'91746','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41281,'71024','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35510,'61560','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17588,'33916','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8367,'18921','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18482,'35896','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23454,'44106','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22944,'43343','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20720,'39098','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16794,'32696','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16155,'31730','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10641,'23269','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36053,'62330','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53589,'97055','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(40691,'69220','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34373,'59848','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19577,'37422','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24913,'46173','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29925,'53517','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6817,'15957','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45586,'77428','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20263,'38548','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44683,'76123','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34461,'60030','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31311,'55413','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41014,'70524','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26949,'48838','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1865,'05201','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(30105,'53901','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9512,'20906','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52871,'95684','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48734,'83866','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47217,'79852','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30918,'54933','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12522,'26717','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21382,'40153','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50891,'91416','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11936,'25555','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6120,'14865','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30000,'53572','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25862,'47446','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22088,'41605','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2903,'07877','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27050,'48916','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4641,'12432','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52341,'94931','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49110,'85009','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33035,'57569','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23248,'43805','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1719,'04901','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34648,'60208','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32317,'56574','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15232,'30355','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3226,'08641','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36982,'63437','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26232,'47970','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12992,'27613','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31087,'55080','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11919,'25524','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12367,'26411','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(123,'00821','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(55046,'99688','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51135,'92129','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50386,'89442','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40562,'69033','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40839,'70145','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5218,'13322','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17698,'34120','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29128,'52043','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13511,'28326','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23150,'43682','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40224,'68739','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28378,'50461','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15699,'30919','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14649,'29718','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54522,'98587','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52735,'95525','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51807,'93551','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50120,'88514','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(42362,'72534','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12973,'27596','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42561,'72766','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50487,'90029','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10048,'22206','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49316,'85344','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49755,'87181','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(16237,'31799','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26633,'48439','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3802,'10185','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53552,'97019','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(24551,'45769','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54022,'97824','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51992,'93944','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30909,'54928','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3361,'09013','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38320,'65679','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17470,'33761','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20702,'39087','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11223,'24273','Norton City','51720','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14158,'29116','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33476,'58377','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8521,'19106','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53992,'97739','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36068,'62348','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39326,'67476','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23346,'43973','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28135,'50210','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1789,'04988','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17061,'33084','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50372,'89429','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44486,'75901','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21708,'40742','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37059,'63540','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31513,'55783','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34429,'60001','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44462,'75851','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52358,'94954','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48323,'83013','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37058,'63539','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36974,'63431','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5062,'13057','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28363,'50455','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36091,'62366','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17218,'33403','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7543,'17215','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12754,'27306','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16784,'32669','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40884,'70339','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2185,'06092','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4474,'12122','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53585,'97051','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52942,'95833','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44749,'76239','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17756,'34241','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18973,'36640','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9371,'20715','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13117,'27852','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30923,'54940','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(98,'00767','Yabucoa','72151','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(45453,'77272','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18990,'36702','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11654,'25045','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11359,'24486','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54694,'99006','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53549,'97016','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44297,'75633','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42932,'73439','Marshall','40095','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39807,'68120','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23227,'43777','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50969,'91761','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48596,'83637','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(7024,'16321','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29968,'53546','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21717,'40763','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6749,'15847','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11183,'24219','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38739,'66536','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50287,'89132','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53680,'97209','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53193,'96148','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52061,'94121','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23633,'44406','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26451,'48195','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19129,'37010','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51006,'91905','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47607,'80530','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10421,'22974','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15624,'30746','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49661,'87010','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41592,'71432','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40041,'68455','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9089,'20214','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19374,'37190','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30681,'54670','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28938,'51446','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39298,'67451','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29309,'52301','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25489,'46990','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48677,'83805','Boundary','16021','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48184,'82327','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47560,'80471','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47534,'80443','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45350,'77062','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37550,'64467','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21264,'40009','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51749,'93450','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37742,'64748','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34046,'59253','Daniels','30019','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19228,'37069','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6284,'15137','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1241,'03826','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15678,'30824','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20474,'38772','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53455,'96797','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12599,'27023','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(2894,'07863','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9457,'20833','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25704,'47280','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33662,'58563','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10799,'23608','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31043,'55043','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29525,'52638','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25775,'47356','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13034,'27707','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49378,'85544','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5670,'14109','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24758,'46041','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46962,'79370','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45785,'77641','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42795,'73072','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40817,'70113','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26945,'48836','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17373,'33598','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17378,'33604','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7207,'16661','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24488,'45696','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12301,'26289','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49196,'85138','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6428,'15370','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20007,'38161','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13175,'27897','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52194,'94523','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54260,'98239','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42405,'72578','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35595,'61737','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21971,'41232','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30230,'54103','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16683,'32533','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26155,'47917','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12984,'27605','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12447,'26568','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52159,'94304','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49650,'86547','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43515,'74441','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34849,'60555','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1848,'05141','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(51794,'93534','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47045,'79529','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26293,'48030','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(952,'02871','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(240,'01053','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27072,'49009','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15510,'30625','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10029,'22161','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11040,'24053','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11688,'25088','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31581,'55939','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28385,'50466','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25529,'47032','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53237,'96322','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(14481,'29574','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53016,'95956','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47547,'80459','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43427,'74301','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32662,'57221','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15513,'30628','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49837,'87530','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36308,'62610','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1190,'03743','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21754,'40856','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21230,'39854','Quitman','13239','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51340,'92415','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4737,'12533','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31708,'56045','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34077,'59301','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(9788,'21649','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45395,'77205','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43590,'74563','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39043,'67037','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34635,'60191','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27609,'49680','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33602,'58494','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48314,'82941','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(21379,'40150','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23562,'44256','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33372,'58260','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29739,'53079','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39394,'67547','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49593,'86336','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46754,'79081','Hansford','48195','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40404,'68871','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35797,'61957','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32838,'57363','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17098,'33146','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18502,'35953','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7587,'17264','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25426,'46947','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(117,'00801','Saint Thomas','78030','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(48359,'83212','Power','16077','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50665,'90639','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49460,'85711','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9901,'21797','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17884,'34688','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46767,'79086','Hansford','48195','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46214,'78373','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43127,'73724','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39201,'67278','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52802,'95618','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37588,'64496','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21649,'40513','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29156,'52070','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51021,'91933','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46823,'79185','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5930,'14602','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48504,'83448','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48968,'84526','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51299,'92363','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26669,'48463','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1524,'04453','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37826,'64865','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39267,'67430','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54913,'99520','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(55014,'99656','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(15424,'30545','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15609,'30735','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20509,'38838','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15845,'31081','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7742,'17608','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19460,'37330','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35991,'62269','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11737,'25164','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37607,'64620','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48862,'84118','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47130,'79713','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19949,'38069','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34089,'59317','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15380,'30521','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34038,'59242','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54856,'99330','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51256,'92310','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42839,'73111','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32176,'56437','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5714,'14205','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6139,'14879','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47377,'80125','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7796,'17769','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4233,'11598','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2466,'06754','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30512,'54498','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23162,'43719','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31839,'56150','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40018,'68441','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21007,'39520','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29752,'53091','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2655,'07105','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20058,'38255','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2247,'06232','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16221,'31790','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6448,'15423','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5273,'13411','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27151,'49065','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18597,'36035','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12518,'26711','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27745,'49805','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15433,'30553','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45549,'77381','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47365,'80116','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27031,'48894','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11353,'24483','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11521,'24740','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29571,'52730','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24644,'45850','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52968,'95910','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49632,'86502','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47465,'80247','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45364,'77076','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8685,'19436','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26775,'48642','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15896,'31201','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1938,'05466','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(205,'01001','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16052,'31566','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47951,'81151','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41106,'70634','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(375,'01434','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49803,'87419','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46642,'79001','Oldham','48359','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35677,'61839','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12269,'26254','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24982,'46253','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32576,'57047','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51907,'93670','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50989,'91786','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49361,'85396','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33045,'57580','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47764,'80840','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34662,'60404','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23989,'44904','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26796,'48659','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15701,'31001','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47625,'80546','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44444,'75834','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22015,'41364','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28024,'50111','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41722,'71720','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34828,'60541','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10531,'23117','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10229,'22630','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19893,'38017','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5843,'14502','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7889,'17889','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49635,'86505','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47752,'80831','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31416,'55595','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4253,'11715','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34083,'59313','Fallon','30025','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44921,'76465','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43688,'74820','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42243,'72410','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33142,'57744','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32855,'57374','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10852,'23830','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12886,'27525','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28253,'50278','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27254,'49241','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22012,'41352','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22054,'41535','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17886,'34690','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14816,'30019','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42220,'72384','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12719,'27264','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48761,'84017','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(8434,'19014','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41406,'71220','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20901,'39355','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15230,'30354','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28970,'51466','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41136,'70662','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31168,'55316','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3574,'09703','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(13844,'28637','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10960,'23947','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47274,'79954','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52119,'94252','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42942,'73444','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42831,'73103','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32217,'56472','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29601,'52756','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19661,'37722','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8045,'18202','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21285,'40027','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28556,'50605','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27415,'49405','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41025,'70531','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10645,'23276','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53056,'95991','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34842,'60551','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12245,'26215','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40407,'68873','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10664,'23303','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4661,'12453','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9053,'20172','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14761,'29927','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6449,'15424','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(769,'02464','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25742,'47336','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24886,'46157','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39446,'67584','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41689,'71659','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14463,'29556','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52551,'95258','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46488,'78723','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42174,'72338','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29556,'52658','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10611,'23226','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10413,'22969','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(559,'01923','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3598,'09729','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6079,'14825','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33389,'58274','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33325,'58216','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24367,'45459','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41003,'70517','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44020,'75214','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46610,'78945','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51426,'92630','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37543,'64461','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34272,'59644','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7978,'18042','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10,'00611','Utuado','72141','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(6229,'15062','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14470,'29565','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53957,'97625','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30961,'54966','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2257,'06243','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(53314,'96578','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(50782,'91184','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48822,'84075','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(35568,'61720','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10475,'23061','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16406,'32130','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43503,'74434','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21412,'40209','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42143,'72255','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52753,'95548','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50618,'90312','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6932,'16143','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3156,'08505','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19625,'37681','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5083,'13077','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46034,'78116','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44384,'75713','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43416,'74158','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55024,'99666','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51091,'92071','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42377,'72550','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40015,'68439','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4503,'12153','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15412,'30536','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20844,'39301','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2407,'06513','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5413,'13661','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(617,'02071','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44022,'75216','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7002,'16257','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49293,'85321','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46202,'78361','Jim Hogg','48247','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41750,'71758','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34367,'59845','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32086,'56340','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21799,'40979','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9498,'20892','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51668,'93266','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2826,'07733','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1155,'03469','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(1101,'03268','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21185,'39813','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54485,'98546','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31886,'56183','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17058,'33081','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23135,'43617','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7981,'18045','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17503,'33810','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38222,'65610','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51457,'92688','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17637,'33981','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4752,'12548','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50944,'91729','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49357,'85390','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26290,'48026','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33823,'58760','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32521,'57015','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44146,'75428','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1750,'04943','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(43239,'73949','Cimarron','40025','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39548,'67732','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38931,'66866','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32015,'56292','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46967,'79372','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29077,'51632','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22299,'42131','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12233,'26187','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4512,'12160','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10577,'23176','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21731,'40815','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52060,'94120','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38893,'66835','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52504,'95204','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53666,'97146','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29469,'52569','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36172,'62447','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29940,'53525','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20409,'38670','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45951,'78016','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46796,'79106','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46554,'78830','Dimmit','48127','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44073,'75284','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42613,'72853','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26119,'47866','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7457,'17056','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39080,'67065','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54172,'98104','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34454,'60020','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18223,'35407','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37224,'63820','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19174,'37035','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20860,'39325','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14913,'30097','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1051,'03111','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4881,'12815','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52906,'95736','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13978,'28751','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23826,'44683','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3862,'10464','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12534,'26753','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12676,'27213','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6206,'15037','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54823,'99207','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51287,'92342','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33115,'57714','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(637,'02123','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25018,'46308','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2505,'06820','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2441,'06650','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22068,'41554','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11371,'24504','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18086,'35117','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29784,'53122','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40856,'70164','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49399,'85611','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53669,'97149','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50925,'91614','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44472,'75856','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12222,'26169','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15062,'30216','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4190,'11507','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34707,'60440','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11709,'25124','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11436,'24571','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28504,'50570','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4898,'12836','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15908,'31211','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15706,'31003','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23114,'43567','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21902,'41098','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18133,'35175','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17837,'34483','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7395,'17010','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7166,'16621','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33762,'58710','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(237,'01040','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43233,'73939','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29383,'52356','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27816,'49884','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28730,'50983','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15043,'30185','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10319,'22820','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16333,'32044','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50602,'90292','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48078,'81624','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34727,'60455','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33430,'58338','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8884,'19961','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(34485,'60055','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37180,'63743','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42258,'72421','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10419,'22973','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18929,'36562','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30928,'54942','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39316,'67467','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43685,'74804','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27619,'49685','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16653,'32463','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23229,'43778','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15243,'30366','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29785,'53125','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39383,'67530','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24098,'45157','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45746,'77580','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20849,'39307','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34703,'60439','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12969,'27593','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18052,'35072','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14997,'30152','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6615,'15673','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5098,'13093','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10754,'23464','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39447,'67584','Lane','20101','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48711,'83843','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12647,'27110','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50367,'89424','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(23234,'43782','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31734,'56065','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39393,'67547','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46446,'78666','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48842,'84096','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(12726,'27281','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44398,'75758','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37521,'64441','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12085,'25871','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30949,'54960','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9464,'20842','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14185,'29138','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1854,'05149','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8680,'19428','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29820,'53159','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34123,'59351','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16313,'32009','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50157,'88555','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(28613,'50645','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20199,'38457','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14211,'29168','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18232,'35446','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36372,'62670','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32294,'56557','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(13350,'28115','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(866,'02713','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13994,'28762','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17125,'33175','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32074,'56334','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(41784,'71835','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54363,'98357','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25843,'47432','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10704,'23407','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5991,'14726','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41284,'71028','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24676,'45871','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6866,'16049','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17234,'33419','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32842,'57366','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30229,'54103','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20782,'39173','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11683,'25082','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12859,'27507','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10453,'23031','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14332,'29406','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31464,'55731','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47221,'79855','Culberson','48109','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42961,'73459','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38459,'65790','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35696,'61850','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34867,'60585','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34667,'60408','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31527,'55798','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25404,'46931','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40667,'69168','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30130,'53929','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29198,'52156','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27054,'48919','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20891,'39348','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2073,'05839','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(31616,'55962','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43191,'73832','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43270,'74018','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28749,'51012','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35760,'61928','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14561,'29644','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25702,'47274','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21166,'39759','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8517,'19102','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27144,'49060','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13134,'27867','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38890,'66834','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51180,'92190','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(112,'00786','Aibonito','72009','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(27363,'49330','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36357,'62659','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4017,'10964','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28063,'50139','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9253,'20554','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24962,'46234','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3909,'10536','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47388,'80134','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12089,'25878','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33373,'58260','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4000,'10940','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50657,'90630','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14920,'30101','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38414,'65757','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24802,'46071','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16828,'32733','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19270,'37096','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2226,'06146','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3848,'10314','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22959,'43356','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16508,'32250','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3378,'09063','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(31519,'55787','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42761,'73051','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6951,'16172','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39174,'67209','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51551,'93010','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45041,'76579','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43061,'73627','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40051,'68461','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37559,'64474','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(64,'00716','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(32531,'57021','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12373,'26415','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24418,'45643','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41261,'70896','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32003,'56284','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6046,'14801','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16000,'31525','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32,'00660','Hormigueros','72067','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51065,'92030','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1026,'03070','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11161,'24178','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35190,'61201','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34414,'59923','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32296,'56557','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28095,'50155','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26571,'48376','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21859,'41048','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51619,'93215','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54620,'98829','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49599,'86342','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6241,'15074','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38205,'65601','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21593,'40440','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25981,'47590','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18352,'35594','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38520,'66040','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23207,'43759','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46675,'79027','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18437,'35759','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31005,'55009','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40120,'68633','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41685,'71655','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50667,'90650','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30481,'54473','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4264,'11727','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12424,'26531','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7296,'16834','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7005,'16260','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44825,'76371','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50055,'88265','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(14911,'30096','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(816,'02568','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9401,'20750','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51748,'93449','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30882,'54902','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30073,'53794','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19940,'38061','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2338,'06413','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7225,'16675','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32685,'57237','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42568,'72774','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48656,'83716','Jerome','16053','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(55037,'99679','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30469,'54465','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48420,'83313','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48175,'82244','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(36599,'62903','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36529,'62862','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23637,'44411','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51095,'92078','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55149,'99830','Petersburg Census Area','2195','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9524,'20993','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8822,'19733','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(40316,'68810','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44319,'75651','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29426,'52537','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(25176,'46574','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16989,'32968','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20378,'38644','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8055,'18219','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48410,'83285','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(20937,'39425','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18739,'36272','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7023,'16319','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23512,'44202','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21110,'39667','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53885,'97459','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52786,'95605','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49847,'87540','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44257,'75558','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37340,'64017','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26149,'47906','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5618,'14042','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13835,'28631','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9502,'20897','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19830,'37886','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30977,'54979','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3532,'09586','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(24725,'46001','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29499,'52593','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52027,'94044','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49998,'88112','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45250,'76904','Irion','48235','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5694,'14141','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17841,'34488','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53648,'97131','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52875,'95688','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45222,'76871','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42427,'72617','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28251,'50277','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5775,'14423','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20506,'38834','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17732,'34218','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14460,'29554','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33003,'57538','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41977,'72065','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(62,'00714','Arroyo','72015','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(12149,'26031','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44004,'75187','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39137,'67134','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(55156,'99850','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38782,'66614','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16756,'32639','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39714,'68014','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39420,'67565','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL);
INSERT INTO `ZipCodeMultiCounty` VALUES (6883,'16059','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5395,'13643','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19004,'36740','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5507,'13803','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23556,'44251','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17022,'33032','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1400,'04124','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(25596,'47137','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42945,'73446','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18389,'35651','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50116,'88510','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(28720,'50864','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54343,'98336','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35923,'62217','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12007,'25704','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11487,'24634','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21775,'40927','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23357,'43984','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23408,'44060','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11512,'24729','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11854,'25365','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11759,'25208','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3351,'09002','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(500,'01801','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13147,'27877','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14330,'29405','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51523,'92864','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44647,'76087','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44430,'75790','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29652,'53010','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20987,'39477','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21157,'39753','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16857,'32773','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17242,'33428','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21061,'39631','Wilkinson','28157','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42893,'73162','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51505,'92836','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25430,'46951','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48214,'82441','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(11148,'24155','Salem City','51775','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40609,'69134','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53877,'97452','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54935,'99559','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48824,'84078','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47923,'81125','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39688,'67882','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10463,'23045','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24206,'45308','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14889,'30078','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27461,'49445','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8745,'19520','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42635,'72917','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36378,'62674','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34960,'60803','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8130,'18356','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31675,'56019','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40800,'70080','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36153,'62435','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3147,'08403','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50064,'88316','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44697,'76140','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33631,'58532','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30006,'53574','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17074,'33119','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12194,'26142','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4200,'11545','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33411,'58321','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35765,'61930','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34184,'59456','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(26098,'47847','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8220,'18505','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26797,'48659','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2609,'07057','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17796,'34421','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47047,'79529','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49366,'85532','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30573,'54557','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41944,'72039','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53196,'96152','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29810,'53150','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18918,'36549','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45799,'77664','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45460,'77282','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1230,'03815','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22182,'41835','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6018,'14751','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42178,'72341','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23571,'44265','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52981,'95922','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45125,'76689','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26176,'47930','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6885,'16061','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19408,'37232','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47699,'80741','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26226,'47967','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14127,'29075','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42081,'72145','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46617,'78949','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42933,'73440','Marshall','40095','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34201,'59468','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4968,'12937','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18454,'35772','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13741,'28551','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24274,'45350','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22786,'43125','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38402,'65746','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43606,'74578','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45139,'76703','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(775,'02468','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27235,'49228','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48402,'83274','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43424,'74187','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42325,'72476','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13755,'28562','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4848,'12771','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31611,'55957','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12550,'26814','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13125,'27858','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(55030,'99671','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25373,'46910','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21378,'40146','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24877,'46150','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25852,'47436','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35449,'61484','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40184,'68714','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44728,'76206','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46395,'78636','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27846,'49920','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12591,'27019','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(13373,'28135','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29098,'51651','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40122,'68635','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30623,'54628','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6759,'15860','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16091,'31635','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4044,'10996','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13850,'28642','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53829,'97396','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49855,'87553','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36128,'62421','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32845,'57368','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31603,'55953','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25615,'47151','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18631,'36061','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40052,'68462','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1616,'04642','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4039,'10989','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22292,'42127','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12598,'27022','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(5869,'14522','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53869,'97446','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29843,'53190','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10041,'22199','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50243,'89053','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(42525,'72735','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27780,'49847','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23711,'44505','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18445,'35765','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36822,'63105','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45883,'77950','Refugio','48391','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41491,'71309','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(30830,'54840','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43865,'75048','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6591,'15641','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18798,'36350','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7106,'16423','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9305,'20622','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34824,'60539','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34844,'60552','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35208,'61243','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49259,'85267','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50435,'89706','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53900,'97478','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14088,'29042','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15799,'31051','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5810,'14467','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31120,'55117','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1748,'04941','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35156,'61084','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33604,'58495','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1394,'04109','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26583,'48397','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21011,'39529','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17833,'34479','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31066,'55065','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38110,'65440','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37358,'64036','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52860,'95674','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32938,'57460','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4921,'12860','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11954,'25608','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27214,'49113','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12006,'25703','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22052,'41531','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19181,'37042','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18365,'35616','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7096,'16412','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2470,'06758','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11651,'25043','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50789,'91203','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26923,'48823','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45720,'77547','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40026,'68447','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38577,'66092','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11128,'24138','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37377,'64062','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29774,'53114','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(189,'00975','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(53458,'96801','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(13798,'28603','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46636,'78960','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5129,'13135','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7433,'17036','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7827,'17823','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31503,'55771','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40556,'69029','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(228,'01031','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46377,'78624','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41139,'70665','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21448,'40257','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46244,'78407','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7309,'16847','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7887,'17888','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25676,'47245','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5592,'14024','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23393,'44045','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4671,'12461','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47074,'79546','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15245,'30369','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23259,'43824','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14709,'29841','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18976,'36652','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52038,'94083','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52312,'94712','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22697,'43045','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26596,'48417','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22651,'43011','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27279,'49259','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5586,'14012','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26090,'47840','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24586,'45812','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4880,'12814','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5893,'14544','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42091,'72158','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37555,'64471','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32023,'56297','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14231,'29209','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44654,'76094','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39152,'67147','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38151,'65535','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53274,'96401','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49914,'87820','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(18045,'35064','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15403,'30533','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23131,'43613','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43736,'74857','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2540,'06901','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16119,'31698','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5126,'13132','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19085,'36855','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50465,'90007','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26832,'48733','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50949,'91734','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40843,'70150','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33885,'58845','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7622,'17329','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8876,'19952','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(1532,'04462','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50474,'90016','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55065,'99711','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54748,'99116','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2380,'06479','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26150,'47906','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20074,'38305','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31473,'55738','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41083,'70593','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37812,'64855','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6850,'16036','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42422,'72615','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40957,'70446','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25219,'46725','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26319,'48061','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54569,'98641','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52673,'95431','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33057,'57623','Ziebach','46137','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11838,'25332','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17753,'34239','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2790,'07657','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30079,'53805','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(985,'02909','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(38973,'66949','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39794,'68107','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46635,'78959','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11310,'24430','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49617,'86432','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(18494,'35907','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2330,'06403','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(51521,'92862','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24477,'45686','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19446,'37323','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(630,'02116','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24640,'45849','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5410,'13659','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18436,'35758','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9082,'20206','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22216,'42032','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52839,'95653','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47434,'80222','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34810,'60525','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14973,'30135','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24484,'45692','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15927,'31304','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(133,'00901','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(26932,'48830','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19493,'37354','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30761,'54762','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30518,'54501','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30159,'53950','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(142,'00913','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(5114,'13117','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24664,'45865','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6194,'15025','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2238,'06176','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1318,'04010','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21922,'41141','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47875,'81050','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44826,'76371','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33757,'58702','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32650,'57212','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11984,'25669','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23378,'44024','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27708,'49765','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30683,'54701','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1936,'05464','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27663,'49729','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15322,'30456','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30759,'54760','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52392,'95013','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26644,'48449','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9277,'20593','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22585,'42721','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54020,'97820','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34013,'59212','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31229,'55353','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19010,'36745','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40201,'68725','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3985,'10919','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20185,'38402','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(709,'02305','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5958,'14642','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49267,'85281','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51690,'93302','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49511,'85922','Greenlee','4011','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46033,'78115','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36767,'63039','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1510,'04430','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21188,'39817','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21511,'40346','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30300,'54165','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2529,'06877','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50471,'90013','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4407,'12040','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36500,'62840','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46303,'78563','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54364,'98358','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51211,'92242','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49516,'85927','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46521,'78751','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44929,'76471','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39509,'67653','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37247,'63847','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1156,'03470','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32742,'57272','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1890,'05353','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19816,'37877','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29248,'52214','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42101,'72167','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52799,'95616','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45992,'78058','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45721,'77549','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31922,'56223','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7272,'16746','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14662,'29734','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25786,'47360','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11915,'25520','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33434,'58341','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53990,'97737','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34631,'60187','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31804,'56123','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14366,'29437','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19850,'37920','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27179,'49083','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2804,'07704','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29583,'52739','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8141,'18407','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43896,'75078','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17379,'33605','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39821,'68136','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6078,'14824','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2695,'07405','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52725,'95497','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4408,'12041','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21699,'40724','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13954,'28731','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13984,'28755','Yancey','37199','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31073,'55071','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18783,'36322','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(541,'01887','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38995,'66968','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26054,'47731','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47826,'80977','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(25604,'47142','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46813,'79121','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50,'00688','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(49369,'85534','Hidalgo','35023','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46669,'79022','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46011,'78073','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44171,'75446','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16423,'32145','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16655,'32464','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2913,'07920','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17291,'33481','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50903,'91504','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20382,'38647','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4951,'12918','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12016,'25712','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3397,'09123','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49043,'84722','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(34872,'60601','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4296,'11767','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7949,'18013','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15410,'30535','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45701,'77530','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19480,'37342','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13927,'28707','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3934,'10576','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3823,'10274','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14755,'29922','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32237,'56502','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(46018,'78102','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13703,'28516','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12652,'27116','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14845,'30041','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20373,'38642','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36448,'62806','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43580,'74555','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8678,'19425','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21226,'39851','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10401,'22960','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15437,'30555','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49454,'85705','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42878,'73148','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13827,'28625','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9847,'21738','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20511,'38841','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1803,'05039','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16930,'32872','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8398,'18956','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30898,'54919','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1160,'03574','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26511,'48288','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16447,'32180','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9257,'20559','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3234,'08691','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30693,'54723','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25355,'46867','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12219,'26164','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16412,'32135','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28657,'50673','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30605,'54616','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17940,'34945','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6662,'15724','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36220,'62477','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35224,'61262','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47029,'79518','Kent','48263','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38819,'66725','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53700,'97224','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41681,'71652','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25249,'46748','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6061,'14812','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41614,'71454','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35939,'62236','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34229,'59527','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7156,'16602','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39014,'67018','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7318,'16856','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12681,'27216','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54885,'99361','Columbia','53013','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31663,'56010','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23831,'44688','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25637,'47177','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18647,'36078','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36963,'63384','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49225,'85211','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(15286,'30427','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39516,'67657','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6559,'15610','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41688,'71658','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22036,'41477','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35283,'61333','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38611,'66207','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35910,'62098','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34504,'60078','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1518,'04443','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5380,'13627','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7401,'17015','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(284,'01106','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44396,'75757','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34487,'60060','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37797,'64840','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32054,'56323','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53091,'96037','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51388,'92581','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50098,'88414','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(32517,'57013','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9040,'20156','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31137,'55144','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11203,'24245','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44347,'75671','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12706,'27252','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12825,'27407','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52326,'94904','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2455,'06721','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10735,'23441','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10614,'23227','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10760,'23479','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9933,'21852','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20049,'38238','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52512,'95212','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10423,'22976','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14215,'29172','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4561,'12222','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4691,'12482','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7362,'16929','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29387,'52356','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8278,'18642','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52263,'94591','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27659,'49726','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26807,'48703','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24726,'46011','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22475,'42413','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45198,'76854','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53411,'96749','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(9806,'21664','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16900,'32821','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8339,'18840','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6288,'15142','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41762,'71766','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1942,'05471','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23753,'44624','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25,'00646','Dorado','72051','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28472,'50548','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41576,'71419','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33800,'58741','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22136,'41727','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2893,'07860','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54867,'99345','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36446,'62801','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35281,'61332','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11081,'24087','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17946,'34951','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27585,'49660','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19886,'38011','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2283,'06279','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28484,'50559','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49191,'85130','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3425,'09263','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(37690,'64674','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37139,'63648','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34789,'60510','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10212,'22601','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23430,'44085','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6363,'15278','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19213,'37060','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10235,'22642','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38107,'65439','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35191,'61204','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20473,'38771','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22795,'43135','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29370,'52345','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50026,'88201','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45714,'77541','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9941,'21865','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34010,'59201','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45337,'77050','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44964,'76518','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51811,'93555','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47597,'80520','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45327,'77041','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42230,'72392','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16152,'31727','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10973,'23960','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12659,'27152','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15006,'30161','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42727,'73027','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2356,'06441','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9531,'21013','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23918,'44840','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2253,'06239','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24360,'45440','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10431,'23003','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29341,'52323','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11656,'25045','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13957,'28733','Graham','37075','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24666,'45866','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19180,'37041','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28022,'50109','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1629,'04658','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(238,'01041','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8087,'18254','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7716,'17565','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19885,'38010','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26643,'48446','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20631,'38959','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7671,'17503','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52980,'95922','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49233,'85225','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40021,'68443','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35868,'62074','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17873,'34669','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41848,'71935','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13534,'28344','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19511,'37365','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10786,'23523','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2397,'06503','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9182,'20425','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14272,'29322','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31910,'56218','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40078,'68521','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39094,'67102','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37395,'64076','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32514,'57010','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54686,'98952','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49971,'88042','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52831,'95645','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52004,'94015','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4705,'12498','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5161,'13160','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28021,'50109','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3228,'08646','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49179,'85098','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(510,'01826','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26076,'47831','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46665,'79019','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13530,'28341','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1849,'05142','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16135,'31711','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28662,'50676','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30722,'54739','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50766,'91107','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54133,'98045','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16826,'32730','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12427,'26541','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26755,'48627','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8718,'19480','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18888,'36511','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27914,'50025','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35703,'61853','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15786,'31041','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32122,'56364','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5210,'13315','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19336,'37160','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27634,'49706','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51431,'92649','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45313,'77027','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12207,'26152','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10069,'22242','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51117,'92110','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50276,'89121','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(55135,'99790','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(8677,'19424','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5009,'12986','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16113,'31648','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23061,'43521','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34267,'59639','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(21175,'39769','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52417,'95044','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49126,'85025','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36105,'62379','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32519,'57014','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5260,'13368','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11311,'24431','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24870,'46147','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27160,'49072','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6455,'15430','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40858,'70166','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2678,'07205','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37613,'64624','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3085,'08241','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46208,'78368','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39883,'68325','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30865,'54872','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9840,'21721','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22320,'42160','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24525,'45735','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7555,'17229','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46221,'78380','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37433,'64118','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53505,'96861','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(30760,'54761','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51172,'92175','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46951,'79360','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20649,'39038','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29466,'52569','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12471,'26610','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15736,'31017','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29227,'52202','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25047,'46355','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32508,'57004','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32896,'57430','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53942,'97538','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(699,'02269','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50543,'90086','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44226,'75489','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4870,'12791','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53853,'97426','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52476,'95140','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9973,'22030','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24954,'46226','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5845,'14504','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25593,'47136','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12517,'26710','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41311,'71055','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40466,'68943','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37230,'63823','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10620,'23231','Charles City','51036','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41608,'71448','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32891,'57428','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32209,'56466','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30990,'54986','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25613,'47150','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21224,'39846','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16453,'32187','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35020,'60952','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15631,'30753','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35861,'62063','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3691,'10006','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18922,'36555','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20051,'38240','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4557,'12211','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2845,'07757','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46207,'78364','Kleberg','48273','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27668,'49733','Crawford','26039','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14085,'29040','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33722,'58640','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9284,'20602','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20209,'38464','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38613,'66209','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14160,'29118','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7147,'16538','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17400,'33626','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12287,'26273','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47903,'81082','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(554,'01910','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53905,'97486','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43418,'74169','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38875,'66777','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37352,'64029','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21726,'40808','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33626,'58528','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6197,'15026','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8320,'18821','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27589,'49665','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25650,'47226','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29561,'52701','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41514,'71334','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7845,'17841','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27273,'49254','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4827,'12748','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47055,'79533','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55028,'99669','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46970,'79376','Yoakum','48501','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39166,'67201','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13544,'28352','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4261,'11724','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5590,'14020','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7250,'16720','Cameron','42023','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20359,'38630','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19845,'37916','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1105,'03274','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22058,'41539','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33676,'58576','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42309,'72466','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4403,'12033','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52230,'94559','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51433,'92651','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50528,'90070','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48543,'83541','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48412,'83286','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40377,'68853','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35237,'61275','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32691,'57241','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5622,'14051','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7902,'17934','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23573,'44270','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19479,'37341','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22416,'42337','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48450,'83344','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12613,'27043','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(53059,'96001','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53200,'96157','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48637,'83687','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36823,'63105','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35250,'61284','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13698,'28511','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4925,'12864','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7400,'17014','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19774,'37848','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2227,'06147','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23067,'43525','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5354,'13601','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11224,'24273','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54113,'98024','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48069,'81612','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46579,'78873','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45518,'77357','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32367,'56636','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27086,'49016','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10560,'23149','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18489,'35903','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47086,'79556','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2657,'07107','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1413,'04226','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29251,'52216','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54369,'98363','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49539,'86016','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26325,'48066','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27817,'49884','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24447,'45662','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4095,'11215','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16983,'32962','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52005,'94016','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32420,'56701','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27538,'49625','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26997,'48873','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28946,'51451','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3309,'08850','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10930,'23919','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13764,'28573','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51594,'93110','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39343,'67490','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39207,'67335','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21570,'40403','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52677,'95436','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43267,'74016','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42273,'72435','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36725,'62998','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31614,'55961','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29920,'53515','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52208,'94538','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(153,'00924','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51493,'92815','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41961,'72051','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5250,'13355','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38768,'66554','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35475,'61529','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27237,'49229','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29408,'52498','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12250,'26222','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32600,'57059','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7112,'16432','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31919,'56221','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11992,'25678','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28204,'50248','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23277,'43845','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35354,'61418','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12916,'27549','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14120,'29070','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28321,'50424','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3443,'09328','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(895,'02764','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12201,'26147','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27444,'49426','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18000,'35020','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30077,'53804','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28804,'51047','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41029,'70534','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(23312,'43935','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12047,'25810','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31297,'55398','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33943,'59044','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31151,'55188','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48225,'82516','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(9702,'21282','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2752,'07514','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22912,'43320','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28480,'50556','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13435,'28229','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29836,'53184','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45705,'77533','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44267,'75566','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24948,'46219','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49181,'85118','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47981,'81237','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2175,'06082','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45051,'76624','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35639,'61774','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35547,'61635','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26860,'48750','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27247,'49236','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27398,'49348','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1966,'05602','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28262,'50309','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28389,'50469','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34285,'59714','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54829,'99213','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43368,'74101','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35000,'60938','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11725,'25143','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30419,'54430','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34826,'60541','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5303,'13454','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8285,'18655','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24828,'46113','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7772,'17745','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32103,'56353','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32413,'56684','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(47281,'79978','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12947,'27574','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53509,'96912','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(49647,'86540','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48399,'83263','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46902,'79322','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12000,'25699','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36981,'63436','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26001,'47620','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40979,'70465','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32043,'56315','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10303,'22746','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1873,'05260','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(29425,'52537','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(51624,'93220','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48487,'83434','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42469,'72658','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41079,'70591','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34823,'60538','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32769,'57319','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42591,'72835','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11274,'24352','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4421,'12055','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28481,'50557','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12554,'26823','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42931,'73438','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4859,'12780','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40190,'68716','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8927,'20030','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7030,'16328','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52498,'95193','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51921,'93712','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21784,'40943','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38796,'66626','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47239,'79920','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41296,'71039','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(785,'02482','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54293,'98276','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37353,'64030','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13351,'28115','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11145,'24153','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2648,'07096','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51129,'92122','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16982,'32961','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40600,'69129','Deuel','31049','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6160,'14894','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16462,'32202','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1963,'05501','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24231,'45324','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24866,'46143','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28058,'50135','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53892,'97467','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47178,'79766','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9248,'20548','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19045,'36776','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12783,'27332','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30175,'53961','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4728,'12525','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1351,'04055','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52777,'95587','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31809,'56128','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53902,'97480','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54146,'98061','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27796,'49865','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54433,'98446','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46578,'78872','Zavala','48507','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42946,'73446','Marshall','40095','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35635,'61771','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13540,'28348','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31828,'56142','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4579,'12240','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22568,'42715','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44164,'75440','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17832,'34478','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24194,'45299','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13961,'28736','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23115,'43569','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51985,'93930','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48195,'82411','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(8920,'20020','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(55025,'99667','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(32940,'57460','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39836,'68155','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10633,'23238','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6253,'15087','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25273,'46771','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29942,'53527','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46108,'78224','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44849,'76424','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(182,'00963','Catano','72033','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(45010,'76550','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43278,'74022','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15462,'30572','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29503,'52601','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24251,'45336','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51086,'92066','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43088,'73658','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45349,'77061','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47083,'79550','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43952,'75137','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40583,'69046','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15179,'30310','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43621,'74640','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33180,'57780','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15085,'30230','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(203,'00987','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(1317,'04009','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22075,'41562','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19426,'37307','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5270,'13409','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12897,'27533','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5404,'13652','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38395,'65742','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35663,'61818','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11186,'24221','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15271,'30417','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25873,'47453','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17806,'34434','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17089,'33137','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24198,'45304','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4558,'12212','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37752,'64761','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11519,'24738','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10247,'22654','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26675,'48467','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50745,'91017','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45877,'77902','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12971,'27596','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40700,'69333','Grant','31075','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54715,'99025','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(19231,'37072','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47005,'79490','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6486,'15465','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8566,'19150','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18803,'36352','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15421,'30543','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36270,'62546','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11068,'24077','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3326,'08870','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10350,'22902','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30901,'54921','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29674,'53021','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28778,'51028','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23241,'43791','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52666,'95425','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50933,'91708','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48595,'83636','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47871,'81047','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41205,'70776','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39622,'67840','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36376,'62673','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35341,'61410','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10964,'23952','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20294,'38571','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4893,'12831','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38714,'66516','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37622,'64631','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35323,'61367','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33414,'58324','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6028,'14767','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3800,'10178','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47798,'80926','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42956,'73456','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38780,'66612','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33028,'57564','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2036,'05760','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15756,'31029','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35949,'62241','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3614,'09747','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(36247,'62526','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2567,'07009','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2699,'07417','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29936,'53522','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28636,'50660','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27201,'49098','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27027,'48891','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25994,'47613','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24245,'45334','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44772,'76261','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10910,'23888','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33972,'59071','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23018,'43457','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42180,'72346','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37865,'65037','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2263,'06249','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27818,'49885','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27908,'50021','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3723,'10039','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6483,'15462','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50603,'90293','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44602,'76048','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42694,'73008','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41936,'72032','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7183,'16637','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26236,'47971','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19358,'37181','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15943,'31320','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23731,'44609','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54642,'98853','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51182,'92192','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40328,'68818','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13004,'27624','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16176,'31758','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3499,'09509','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8310,'18801','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18150,'35188','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6484,'15463','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29389,'52358','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26362,'48106','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2598,'07043','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2004,'05678','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18607,'36041','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45680,'77505','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2246,'06231','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9002,'20118','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50463,'90005','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37044,'63530','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33357,'58240','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25374,'46911','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25468,'46979','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31591,'55945','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15837,'31076','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26831,'48732','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43155,'73747','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49550,'86030','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9478,'20862','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53054,'95987','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18826,'36425','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37117,'63628','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7464,'17062','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55127,'99781','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(40140,'68642','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43055,'73620','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41063,'70576','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3810,'10256','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20186,'38425','Perry','47135','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40349,'68832','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28869,'51243','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19644,'37708','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45265,'76935','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43716,'74845','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27695,'49755','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37246,'63846','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21136,'39743','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26336,'48079','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39931,'68354','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37093,'63565','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27319,'49303','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30093,'53818','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32218,'56472','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(49835,'87528','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37035,'63471','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3456,'09357','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38241,'65622','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51110,'92103','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38477,'65898','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37478,'64168','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34956,'60706','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17945,'34950','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54557,'98625','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29640,'53002','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29432,'52543','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23619,'44325','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14890,'30079','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32444,'56729','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32955,'57470','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33288,'58071','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45132,'76691','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42996,'73532','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32657,'57217','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23334,'43961','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33855,'58785','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52402,'95024','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51841,'93611','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49119,'85018','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49094,'84779','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(36131,'62422','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32631,'57104','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21750,'40847','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52087,'94159','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48080,'81625','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8915,'20015','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(31983,'56270','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15094,'30236','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25687,'47263','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12492,'26656','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53033,'95969','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26744,'48622','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47196,'79789','Winkler','48495','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(198,'00982','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(47793,'80921','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41351,'71105','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40622,'69145','Kimball','31105','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36048,'62325','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33355,'58240','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17019,'33029','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8513,'19096','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3294,'08828','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26849,'48744','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35133,'61067','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34042,'59247','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25823,'47396','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17556,'33875','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26094,'47842','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45009,'76550','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48949,'84407','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(8162,'18427','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3042,'08094','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13972,'28745','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7074,'16370','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1988,'05662','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(38885,'66801','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20785,'39175','Claiborne','28021','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45224,'76872','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12306,'26294','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17463,'33747','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47968,'81224','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45311,'77025','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41915,'72021','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6691,'15757','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17370,'33597','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9873,'21771','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42146,'72301','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8501,'19087','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10496,'23084','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46398,'78639','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46308,'78567','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33983,'59081','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12650,'27114','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25502,'47003','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11703,'25115','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8954,'20060','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(29876,'53225','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8553,'19137','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26446,'48189','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45429,'77243','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43679,'74761','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38303,'65662','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14406,'29477','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49186,'85121','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46724,'79059','Roberts','48393','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37829,'64867','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6921,'16132','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38411,'65755','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2424,'06535','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5683,'14132','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27674,'49738','Crawford','26039','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25376,'46912','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2799,'07677','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46901,'79316','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11610,'24962','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24441,'45659','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12943,'27572','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16137,'31712','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31651,'55988','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35175,'61108','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26097,'47846','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41116,'70647','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17791,'34291','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45891,'77963','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45772,'77622','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30545,'54534','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24336,'45419','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35109,'61050','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43188,'73801','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34106,'59337','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13512,'28326','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30625,'54630','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43163,'73755','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30058,'53774','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8000,'18064','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7636,'17347','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7601,'17307','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44330,'75657','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16324,'32034','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21560,'40387','Wolfe','21237','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24596,'45819','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47463,'80246','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54568,'98640','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44739,'76230','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33071,'57634','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25953,'47561','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14033,'28806','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15770,'31035','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31808,'56128','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53071,'96015','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9332,'20661','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37823,'64862','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5634,'14060','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52665,'95424','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55080,'99732','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(43097,'73663','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41640,'71474','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21254,'40004','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30840,'54849','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8556,'19140','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30550,'54538','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51639,'93239','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51833,'93604','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12154,'26035','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53243,'96337','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(4052,'11004','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27830,'49896','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21399,'40176','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31639,'55975','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45767,'77615','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32740,'57271','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21686,'40601','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2963,'08014','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26282,'48014','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51155,'92155','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39854,'68303','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22508,'42461','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11978,'25653','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47639,'80612','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37753,'64761','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48922,'84321','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46161,'78284','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44236,'75494','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18341,'35582','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14023,'28789','Swain','37173','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17510,'33823','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3745,'10107','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8024,'18086','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20792,'39179','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8488,'19074','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49904,'87742','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(38068,'65338','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45104,'76667','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42749,'73045','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40130,'68638','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8815,'19720','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(47263,'79943','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37790,'64831','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36263,'62541','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32442,'56727','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22754,'43085','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25179,'46581','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33159,'57759','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24030,'45063','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32569,'57043','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45478,'77316','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32832,'57359','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17650,'34021','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(21195,'39824','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27525,'49614','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27648,'49718','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9634,'21203','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(253,'01070','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10702,'23404','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44169,'75444','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36888,'63171','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2840,'07752','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19587,'37604','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54505,'98568','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53167,'96120','Alpine','6003','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52450,'95112','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49829,'87521','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44225,'75488','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43307,'74044','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38897,'66840','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37990,'65254','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34405,'59915','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23059,'43520','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(396,'01474','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11787,'25252','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20408,'38670','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51755,'93454','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10426,'22987','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46533,'78762','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21704,'40737','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41118,'70648','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(949,'02863','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(22361,'42232','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51574,'93043','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46594,'78933','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41512,'71331','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38896,'66840','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35003,'60940','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22279,'42088','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6839,'16024','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20334,'38610','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1195,'03749','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19266,'37095','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3117,'08326','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1444,'04271','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26183,'47933','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25700,'47274','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24602,'45826','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27959,'50054','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39198,'67275','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32755,'57311','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17034,'33050','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10346,'22853','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11692,'25103','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11774,'25241','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48769,'84025','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42790,'73067','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42587,'72833','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40360,'68837','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38644,'66403','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34120,'59349','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(18580,'36027','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47497,'80304','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15680,'30824','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38797,'66629','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10499,'23085','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22668,'43018','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32140,'56379','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34561,'60130','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14037,'28815','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50434,'89706','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49895,'87730','Harding','35021','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(38999,'67003','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6918,'16130','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10088,'22312','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18360,'35611','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3809,'10249','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42898,'73169','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41910,'72020','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28714,'50861','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7559,'17235','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23825,'44682','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(865,'02712','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52273,'94604','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48057,'81520','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40721,'69345','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39998,'68423','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6137,'14878','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8169,'18435','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29807,'53149','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7595,'17301','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46697,'79041','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18186,'35238','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12909,'27542','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11125,'24137','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53294,'96535','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53240,'96328','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(42074,'72139','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6552,'15563','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4349,'11949','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37506,'64429','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51008,'91908','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17064,'33093','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25268,'46767','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41939,'72035','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26260,'47990','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45417,'77229','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16047,'31563','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40422,'68882','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39515,'67657','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(620,'02090','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45769,'77617','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44150,'75431','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39852,'68301','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34613,'60172','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22983,'43416','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3946,'10591','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19132,'37012','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20870,'39330','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15855,'31087','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8998,'20115','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19793,'37865','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4206,'11552','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45048,'76622','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51200,'92227','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42672,'72951','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7976,'18041','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2418,'06525','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27866,'49952','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47352,'80106','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54140,'98053','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(15012,'30165','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7909,'17945','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42589,'72834','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36206,'62467','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16942,'32903','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11622,'24985','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2215,'06132','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19656,'37716','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8327,'18828','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19778,'37851','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51959,'93779','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27120,'49041','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50429,'89703','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46411,'78646','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45365,'77077','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39667,'67869','Meade','20119','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3612,'09744','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21626,'40486','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28614,'50647','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2681,'07208','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30390,'54411','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2953,'08004','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25077,'46391','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14214,'29171','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17816,'34450','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23148,'43667','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47141,'79720','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40034,'68453','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32644,'57197','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6460,'15435','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9885,'21782','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50495,'90037','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15280,'30425','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17317,'33530','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18267,'35481','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1144,'03455','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8805,'19709','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(20908,'39361','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36709,'62983','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22928,'43332','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31389,'55568','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2429,'06601','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45405,'77217','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40149,'68651','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30362,'54303','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52278,'94609','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50957,'91745','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12594,'27020','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(3205,'08601','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24600,'45822','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29803,'53144','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16757,'32640','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14599,'29669','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1670,'04747','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8412,'18972','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36484,'62832','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34532,'60104','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9500,'20895','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7951,'18015','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14292,'29341','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32289,'56552','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(49700,'87046','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(39582,'67751','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38425,'65767','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35478,'61531','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32141,'56379','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27563,'49643','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8118,'18343','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6920,'16131','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28830,'51061','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50099,'88415','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(27744,'49802','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53197,'96154','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40578,'69044','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2537,'06890','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34398,'59910','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25328,'46814','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2336,'06411','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45570,'77411','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43727,'74852','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41883,'71972','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39578,'67748','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38312,'65672','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34278,'59703','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12920,'27553','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8997,'20113','Manassas Park City','51685','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1309,'04001','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15180,'30311','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27259,'49246','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12575,'26884','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7642,'17355','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54180,'98112','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50682,'90710','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43744,'74860','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16471,'32211','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31693,'56032','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8976,'20090','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(52630,'95378','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(803,'02553','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26956,'48842','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32705,'57252','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22612,'42749','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41354,'71107','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39580,'67749','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33975,'59074','Golden Valley','30037','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(21786,'40946','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54916,'99523','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(44102,'75376','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35154,'61081','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14793,'30007','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21237,'39866','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31021,'55025','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45061,'76632','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36677,'62956','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15785,'31041','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18638,'36067','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17785,'34285','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5130,'13136','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43566,'74538','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3767,'10130','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54634,'98846','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54323,'98312','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52574,'95320','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46808,'79118','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41230,'70810','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37253,'63851','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4007,'10953','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9560,'21050','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16250,'31807','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28125,'50174','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19898,'38023','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17079,'33127','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(940,'02841','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(6406,'15345','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13914,'28691','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50716,'90810','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13805,'28606','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46240,'78403','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6546,'15558','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46063,'78145','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21162,'39756','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20065,'38259','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24547,'45766','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25712,'47302','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26049,'47725','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7084,'16401','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30559,'54545','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26743,'48622','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(77,'00731','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(22606,'42746','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24579,'45807','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25813,'47386','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16962,'32934','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41040,'70544','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10959,'23947','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15754,'31028','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18377,'35631','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29976,'53554','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14238,'29215','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21213,'39840','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7664,'17406','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32849,'57370','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7939,'17983','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18559,'36008','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29698,'53042','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10099,'22401','Fredericksburg City','51630','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48198,'82414','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(41289,'71032','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8841,'19890','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(14650,'29720','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31078,'55074','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16740,'32616','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17021,'33031','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16803,'32704','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31001,'55007','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42192,'72353','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24720,'45898','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27751,'49814','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30568,'54552','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5315,'13468','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33941,'59043','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(39697,'67954','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51216,'92249','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50898,'91496','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49584,'86326','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42700,'73012','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33519,'58426','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34879,'60608','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38100,'65402','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(714,'02327','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3126,'08343','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22484,'42441','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29786,'53126','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44248,'75505','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14028,'28801','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33191,'57790','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29152,'52068','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32102,'56352','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16555,'32335','Liberty','12077','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54123,'98034','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42869,'73139','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38937,'66869','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35616,'61749','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53928,'97525','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(8906,'20005','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53191,'96145','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43940,'75121','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6606,'15664','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26344,'48088','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2297,'06339','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43446,'74342','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41945,'72039','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41838,'71923','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38850,'66758','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36730,'63010','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25826,'47402','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18754,'36301','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36632,'62926','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29052,'51566','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32196,'56455','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5615,'14040','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22402,'42321','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47412,'80204','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47261,'79941','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45517,'77356','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36421,'62722','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32682,'57235','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4510,'12158','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42058,'72129','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25647,'47224','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1683,'04768','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13409,'28205','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34233,'59530','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33616,'58506','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49447,'85662','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45708,'77535','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2340,'06415','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34107,'59338','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12717,'27263','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29602,'52756','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3485,'09468','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9201,'20456','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(40075,'68516','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50408,'89509','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47762,'80835','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2691,'07395','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2045,'05767','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7897,'17929','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13876,'28659','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4667,'12458','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47441,'80227','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4048,'11001','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24657,'45860','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28540,'50597','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27044,'48910','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25338,'46850','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16845,'32757','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53870,'97446','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48973,'84532','Grand','49019','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39906,'68339','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48207,'82431','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(41390,'71171','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39340,'67487','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6233,'15065','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2098,'05871','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1300,'03903','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29199,'52156','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(829,'02635','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31048,'55047','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8312,'18812','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48768,'84024','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47668,'80653','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34724,'60452','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25000,'46278','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6721,'15801','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43293,'74033','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46176,'78332','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34189,'59460','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(53165,'96118','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39467,'67631','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47934,'81135','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41309,'71052','Red River','22081','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40945,'70438','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:53',NULL,NULL),(39108,'67110','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25633,'47174','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25988,'47610','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14762,'29928','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39997,'68422','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30991,'54990','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13044,'27713','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2557,'06927','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(21122,'39705','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29011,'51542','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36585,'62895','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5326,'13478','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32207,'56465','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2621,'07066','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27988,'50070','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34014,'59213','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6296,'15201','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24507,'45716','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25692,'47265','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25936,'47541','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2189,'06096','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19580,'37501','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50037,'88232','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48318,'82945','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5955,'14627','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6227,'15060','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39459,'67626','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32720,'57261','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22072,'41559','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12363,'26405','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2942,'07976','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53211,'96206','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(16112,'31647','Cook','13075','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42032,'72112','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41162,'70729','West Baton Rouge','22121','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36543,'62869','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36126,'62420','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9372,'20716','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11556,'24853','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13881,'28664','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39271,'67432','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40174,'68667','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2975,'08028','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19563,'37405','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(837,'02645','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23629,'44402','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7660,'17402','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(81,'00735','Ceiba','72037','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(20377,'38643','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30133,'53931','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51595,'93111','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12351,'26377','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43346,'74073','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16344,'32058','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49300,'85328','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34019,'59215','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33987,'59085','Wheatland','30107','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33330,'58222','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32520,'57014','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3980,'10914','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23,'00638','Ciales','72039','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(25773,'47356','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21076,'39647','Wilkinson','28157','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(190,'00976','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(30848,'54857','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30572,'54557','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25683,'47250','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12502,'26679','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49045,'84724','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41392,'71201','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26072,'47807','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54335,'98329','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52971,'95913','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48915,'84315','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43129,'73726','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15964,'31408','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29339,'52323','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5664,'14103','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4530,'12181','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11606,'24946','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31789,'56114','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34443,'60012','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35924,'62218','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39916,'68345','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7093,'16407','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34607,'60165','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(242,'01054','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45661,'77488','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31186,'55329','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30808,'54821','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15038,'30182','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6578,'15627','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50736,'91003','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29685,'53032','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17248,'33434','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53284,'96515','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49198,'85139','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52482,'95153','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30035,'53596','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35460,'61501','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1065,'03229','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(43415,'74157','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8937,'20041','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6598,'15655','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15307,'30446','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25496,'46995','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17467,'33758','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20207,'38464','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12850,'27502','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46109,'78225','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12381,'26425','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43392,'74128','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55136,'99791','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(26118,'47865','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52160,'94305','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40586,'69103','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32941,'57460','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20345,'38620','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8125,'18351','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29329,'52317','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27295,'49274','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23601,'44305','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35840,'62046','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39185,'67220','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37304,'63944','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52561,'95306','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52929,'95820','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42443,'72634','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36791,'63066','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27205,'49102','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37710,'64724','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6189,'15019','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51044,'92004','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20854,'39322','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11965,'25634','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1187,'03609','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(29167,'52078','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48791,'84047','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(4844,'12767','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15213,'30338','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23846,'44702','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37988,'65251','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9319,'20639','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53136,'96088','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40895,'70354','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39563,'67740','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38140,'65473','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9689,'21244','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12216,'26161','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16727,'32602','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26574,'48380','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20668,'39056','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15244,'30368','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(786,'02492','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36926,'63351','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33743,'58650','Hettinger','38041','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35061,'61008','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44946,'76486','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32325,'56581','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21659,'40523','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22351,'42217','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17535,'33851','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16218,'31789','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13841,'28636','Alexander','37003','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33649,'58558','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2373,'06471','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37275,'63877','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50887,'91410','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46507,'78737','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38053,'65326','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33611,'58502','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31069,'55068','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24317,'45388','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4345,'11944','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(665,'02153','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49709,'87053','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42578,'72823','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19139,'37015','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18575,'36024','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18539,'35979','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2056,'05819','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16859,'32775','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41625,'71463','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40697,'69331','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39244,'67401','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33977,'59075','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1359,'04068','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2561,'07003','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40088,'68532','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47076,'79546','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7029,'16327','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50417,'89521','Storey','32029','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47323,'80027','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18600,'36036','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18838,'36442','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19486,'37350','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18570,'36017','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21805,'40988','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8789,'19603','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22957,'43350','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23213,'43762','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49773,'87311','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49633,'86503','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36686,'62960','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30304,'54166','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52772,'95569','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35979,'62262','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38692,'66442','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6211,'15044','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15825,'31067','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14133,'29080','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31111,'55110','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24820,'46106','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11395,'24531','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24462,'45679','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36789,'63061','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37907,'65065','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39387,'67545','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1304,'03907','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22807,'43143','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24025,'45054','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53139,'96091','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19701,'37762','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11331,'24458','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13286,'28052','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28707,'50857','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26331,'48072','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34252,'59620','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36437,'62777','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33179,'57779','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7552,'17225','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26802,'48667','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17142,'33194','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27955,'50050','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50446,'89821','Eureka','32011','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54006,'97759','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(39944,'68365','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38179,'65560','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35042,'60962','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34505,'60079','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36370,'62668','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14,'00616','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(44223,'75487','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13466,'28272','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51826,'93596','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37737,'64746','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49783,'87322','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42899,'73169','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53794,'97361','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28780,'51029','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43203,'73842','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48269,'82725','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(14964,'30127','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34817,'60531','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38172,'65556','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10178,'22544','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50285,'89130','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(24145,'45229','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36752,'63026','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43856,'75040','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32106,'56354','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15408,'30534','Lumpkin','13187','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34432,'60005','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8030,'18092','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21474,'40298','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9255,'20557','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(41425,'71234','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1164,'03579','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17208,'33346','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20255,'38542','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9358,'20704','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10372,'22931','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17042,'33062','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14524,'29614','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8979,'20098','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2831,'07738','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52842,'95656','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48654,'83716','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32897,'57432','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20630,'38958','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13806,'28607','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45160,'76804','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44218,'75482','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41087,'70602','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29699,'53042','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10631,'23237','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41586,'71427','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3793,'10171','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41105,'70634','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(23013,'43451','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14714,'29844','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27009,'48880','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20484,'38801','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37691,'64676','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47608,'80532','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50774,'91118','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53636,'97121','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(16254,'31811','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11799,'25267','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29512,'52625','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25590,'47134','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(872,'02720','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33910,'59014','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28257,'50304','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46685,'79035','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3546,'09606','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26877,'48762','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21498,'40334','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25498,'46996','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33950,'59053','Meagher','30059','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(39632,'67846','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43758,'74871','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46650,'79010','Oldham','48359','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15779,'31037','Wheeler','13309','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39314,'67466','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42019,'72102','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14063,'29016','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36728,'63005','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33725,'58642','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53146,'96097','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8188,'18449','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44872,'76437','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20532,'38855','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52335,'94925','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49287,'85309','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36953,'63381','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26477,'48224','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22399,'42304','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18634,'36065','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12127,'25969','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21575,'40404','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43772,'74884','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30450,'54454','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4320,'11794','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15240,'30362','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18419,'35747','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8292,'18701','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42703,'73014','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38718,'66520','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35698,'61851','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12441,'26560','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2462,'06750','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7968,'18036','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23671,'44444','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2720,'07446','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37892,'65054','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53849,'97420','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37284,'63931','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53523,'96941','Federated States of Micro','64003','FM','Federated States of Micronesia',0,'2013-07-03 15:17:54',NULL,NULL),(51672,'93271','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50798,'91221','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45497,'77338','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42137,'72221','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4654,'12444','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6941,'16154','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18092,'35121','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33963,'59063','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52505,'95205','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2115,'06013','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(49598,'86341','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43172,'73760','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35159,'61087','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4779,'12582','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26368,'48112','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24647,'45854','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20085,'38315','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9601,'21114','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9034,'20149','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18795,'36345','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34067,'59270','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28711,'50859','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9283,'20601','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33945,'59046','Golden Valley','30037','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46710,'79051','Dallam','48111','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24258,'45340','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16102,'31641','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7167,'16622','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3812,'10258','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22158,'41773','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2533,'06881','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35199,'61237','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39430,'67570','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35555,'61651','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4931,'12873','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3423,'09250','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(18889,'36512','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27489,'49504','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25045,'46350','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17648,'34011','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(9367,'20711','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8060,'18224','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34095,'59326','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7994,'18058','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49975,'88046','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(20884,'39341','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47592,'80514','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18788,'36330','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45715,'77542','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20745,'39130','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4189,'11501','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4524,'12173','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41546,'71368','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19640,'37701','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47886,'81062','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44147,'75428','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11628,'25002','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43946,'75126','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40382,'68856','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36257,'62538','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1786,'04985','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11482,'24624','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8276,'18641','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19630,'37686','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50547,'90090','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53477,'96820','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(28466,'50543','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48548,'83544','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45359,'77071','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31050,'55049','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7494,'17085','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26169,'47924','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40394,'68864','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39828,'68142','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32255,'56522','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14993,'30148','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5057,'13052','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41758,'71764','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25383,'46917','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53868,'97444','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53638,'97123','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50795,'91209','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46851,'79235','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23670,'44443','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10945,'23934','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15776,'31037','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49360,'85395','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47436,'80223','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45516,'77356','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31191,'55331','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53061,'96003','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18720,'36258','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19375,'37190','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42337,'72513','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11089,'24095','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6185,'15015','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27154,'49067','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21341,'40075','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38693,'66449','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31195,'55333','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53540,'97009','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41190,'70760','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53260,'96374','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(38939,'66871','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37686,'64671','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31927,'56226','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28752,'51015','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26684,'48475','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5381,'13628','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10774,'23508','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50517,'90059','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41937,'72033','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28820,'51055','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29888,'53274','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12385,'26431','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11354,'24483','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17526,'33843','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23791,'44652','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24162,'45244','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52712,'95476','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32202,'56464','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15574,'30678','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21043,'39573','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21312,'40052','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1007,'03042','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(925,'02825','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(904,'02780','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28478,'50554','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52241,'94570','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40473,'68946','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52676,'95435','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43118,'73717','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9921,'21835','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(917,'02814','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(36579,'62892','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54603,'98807','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50398,'89460','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(32529,'57020','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18834,'36436','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9670,'21227','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17086,'33134','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28088,'50151','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48024,'81411','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27318,'49303','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41438,'71243','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37385,'64069','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9752,'21562','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21858,'41046','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7744,'17622','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22920,'43326','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54013,'97812','Gilliam','41021','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46961,'79370','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38750,'66542','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12309,'26301','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19962,'38083','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36898,'63301','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20016,'38181','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49077,'84758','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48529,'83525','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2241,'06199','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32922,'57448','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28138,'50211','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14663,'29741','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49340,'85369','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30701,'54728','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5778,'14427','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23958,'44865','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24239,'45327','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4581,'12242','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(752,'02420','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46440,'78663','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41745,'71752','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5194,'13251','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49641,'86512','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46480,'78715','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38108,'65440','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31409,'55588','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(221,'01021','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14161,'29118','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43760,'74872','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28996,'51532','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9639,'21207','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21543,'40372','Mercer','21167','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47200,'79832','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47488,'80290','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46114,'78230','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8166,'18431','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9304,'20622','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8028,'18092','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(75,'00729','Canovanas','72029','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28531,'50592','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28434,'50524','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27336,'49315','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13825,'28623','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21146,'39750','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(202,'00986','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14165,'29125','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20151,'38368','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8042,'18201','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45315,'77029','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48688,'83816','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45409,'77221','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32711,'57256','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14341,'29415','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18112,'35144','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29717,'53061','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20967,'39457','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27220,'49120','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31063,'55057','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13870,'28655','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13818,'28617','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10128,'22443','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38291,'65653','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51258,'92312','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(972,'02893','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(49208,'85178','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48652,'83715','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44421,'75783','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36476,'62828','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1648,'04684','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11292,'24381','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2884,'07848','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36411,'62705','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31830,'56144','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(4107,'11228','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1279,'03869','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(14696,'29829','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44018,'75211','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48261,'82715','Weston','56045','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45930,'78003','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42937,'73442','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36929,'63352','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36584,'62895','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9796,'21656','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16012,'31539','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(474,'01718','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26652,'48454','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17263,'33449','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11679,'25076','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39891,'68330','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14744,'29910','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14862,'30055','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23899,'44826','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2007,'05681','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11293,'24382','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28200,'50247','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28499,'50568','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4148,'11372','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48193,'82401','Washakie','56043','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(21932,'41159','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19696,'37755','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16182,'31764','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26688,'48502','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5361,'13608','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4572,'12233','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10765,'23487','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50476,'90018','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12541,'26764','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4896,'12834','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(282,'01104','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29743,'53081','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47302,'80012','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46167,'78293','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6258,'15091','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26631,'48438','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51867,'93631','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47201,'79834','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42338,'72515','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37068,'63546','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36317,'62615','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24900,'46164','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27570,'49648','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52806,'95623','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41631,'71465','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46470,'78703','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42384,'72555','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32809,'57342','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34479,'60048','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2186,'06093','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34678,'60419','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22364,'42236','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4657,'12449','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5102,'13104','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30993,'55002','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15092,'30234','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15383,'30522','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6481,'15460','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37764,'64772','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2972,'08025','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27048,'48913','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50714,'90808','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43995,'75169','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37951,'65201','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16125,'31704','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9260,'20566','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10227,'22630','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18484,'35898','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19316,'37144','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19652,'37713','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24590,'45814','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17520,'33836','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17432,'33694','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(509,'01824','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37766,'64776','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32885,'57422','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2291,'06332','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37369,'64055','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40809,'70090','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14832,'30031','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8730,'19503','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31964,'56257','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(53947,'97544','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42237,'72396','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39396,'67548','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22014,'41360','Wolfe','21237','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3018,'08073','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(168,'00949','Toa Baja','72137','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(45956,'78021','McMullen','48311','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43316,'74048','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29058,'51572','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21637,'40506','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5205,'13309','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19422,'37303','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53890,'97465','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46485,'78720','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42282,'72442','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7458,'17057','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17612,'33948','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1569,'04549','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26268,'47995','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28807,'51047','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15002,'30156','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40590,'69122','Deuel','31049','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37085,'63559','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11455,'24594','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54905,'99511','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47703,'80743','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54491,'98554','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54341,'98333','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42639,'72923','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33864,'58792','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10939,'23923','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20897,'39354','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24353,'45433','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13702,'28515','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(593,'02035','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22791,'43130','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20865,'39328','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3820,'10271','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44799,'76306','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36111,'62410','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32118,'56362','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(54785,'99149','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51903,'93666','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32426,'56714','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(49925,'87901','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47585,'80510','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39914,'68343','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18426,'35752','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4865,'12787','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3102,'08310','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27799,'49870','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1256,'03845','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3721,'10037','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7324,'16863','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11782,'25248','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37185,'63748','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52788,'95607','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38339,'65704','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41129,'70657','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26235,'47970','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40602,'69130','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51453,'92679','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49554,'86034','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7431,'17034','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15692,'30907','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27939,'50042','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10432,'23004','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43921,'75099','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44320,'75652','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49165,'85072','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(16698,'32550','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8092,'18301','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30987,'54984','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19732,'37807','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46127,'78243','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(322,'01245','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27548,'49633','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37530,'64449','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32826,'57355','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37235,'63828','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15944,'31321','Bryan','13029','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16013,'31542','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23518,'44203','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4620,'12409','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28534,'50595','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5693,'14141','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18221,'35405','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11038,'24050','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10724,'23430','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33504,'58416','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48566,'83607','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10525,'23113','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51808,'93552','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38461,'65791','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36835,'63117','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35695,'61849','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9406,'20754','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20777,'39168','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8598,'19196','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7000,'16256','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48493,'83440','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2038,'05762','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1774,'04971','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26115,'47861','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6114,'14859','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46664,'79019','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12255,'26229','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7759,'17728','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55020,'99662','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(12944,'27572','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26164,'47921','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52675,'95433','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35729,'61876','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33305,'58109','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13103,'27841','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10299,'22740','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28196,'50244','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41839,'71923','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26095,'47845','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23726,'44606','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13405,'28201','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44258,'75558','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29903,'53501','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13323,'28092','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26805,'48686','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39657,'67862','Stanton','20187','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30741,'54751','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24139,'45222','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20812,'39204','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1200,'03754','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(13811,'28611','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44595,'76039','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9476,'20860','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26444,'48188','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30530,'54520','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53559,'97026','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2515,'06850','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18417,'35745','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6627,'15683','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50263,'89108','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47647,'80624','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46405,'78642','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37637,'64641','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3859,'10461','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3273,'08805','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22996,'43438','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23778,'44641','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1414,'04227','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27465,'49449','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1431,'04256','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23525,'44216','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34085,'59314','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14972,'30134','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53430,'96769','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12171,'26062','Hancock','54029','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54622,'98831','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46344,'78606','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30402,'54420','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8871,'19947','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(8836,'19850','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(17962,'34974','Okeechobee','12093','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37713,'64726','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39216,'67342','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1036,'03101','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26534,'48324','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31666,'56011','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46739,'79068','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46548,'78801','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41999,'72080','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41562,'71407','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13629,'28433','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28814,'51051','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4102,'11222','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18878,'36483','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(423,'01532','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45820,'77805','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37756,'64763','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11290,'24380','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5539,'13840','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20023,'38190','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33988,'59086','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(43976,'75155','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39502,'67649','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6379,'15316','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31210,'55339','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28398,'50475','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49913,'87801','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44235,'75494','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21388,'40161','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8564,'19148','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49265,'85277','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40480,'68949','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32432,'56721','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52475,'95139','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42901,'73172','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42409,'72583','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33955,'59058','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20862,'39326','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3274,'08807','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51576,'93060','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13255,'28018','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3971,'10802','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30696,'54725','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21709,'40743','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1788,'04987','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47947,'81147','Archuleta','8007','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45080,'76648','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42375,'72545','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13684,'28478','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1736,'04928','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26552,'48347','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26730,'48615','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35405,'61458','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12510,'26691','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5566,'13901','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10228,'22630','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22137,'41729','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10417,'22972','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20215,'38472','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31773,'56093','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28967,'51465','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50868,'91384','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31256,'55373','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52385,'95006','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38204,'65601','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23324,'43945','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28926,'51436','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13178,'27909','Camden','37029','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44457,'75847','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48109,'81653','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46927,'79346','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39346,'67491','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35431,'61475','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4766,'12567','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52445,'95106','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45627,'77463','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2479,'06781','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5243,'13345','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3863,'10465','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14951,'30118','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25601,'47140','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28454,'50538','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29711,'53052','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40440,'68928','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25229,'46733','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13862,'28649','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14051,'29006','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14840,'30039','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47973,'81228','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47315,'80021','Broomfield','8014','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42361,'72533','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37708,'64723','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34078,'59311','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29307,'52257','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10665,'23304','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16888,'32808','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47177,'79766','Crane','48103','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38666,'66422','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24095,'45154','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4220,'11569','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53924,'97520','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51545,'93003','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49211,'85192','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48473,'83414','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42056,'72128','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38219,'65609','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53475,'96818','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(28229,'50263','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54084,'97911','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(20499,'38827','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29724,'53065','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15088,'30233','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13501,'28315','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23493,'44144','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32868,'57382','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4290,'11760','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7821,'17820','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25840,'47427','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21202,'39828','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54209,'98158','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40752,'70004','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33184,'57783','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16844,'32756','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32353,'56626','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9928,'21843','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16437,'32169','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24911,'46172','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39052,'67045','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35400,'61452','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(469,'01701','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49248,'85255','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49049,'84729','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(28563,'50609','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31149,'55175','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46312,'78570','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30427,'54436','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43344,'74072','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29573,'52731','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24674,'45870','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29795,'53138','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22906,'43316','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32433,'56722','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8442,'19022','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50303,'89148','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(14504,'29593','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21468,'40292','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45440,'77257','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23768,'44634','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53971,'97641','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48857,'84113','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44104,'75379','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24953,'46225','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41748,'71753','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1157,'03561','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(29134,'52049','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30095,'53818','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16327,'32040','Baker','12003','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2274,'06263','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27863,'49947','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14878,'30068','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23997,'45004','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8650,'19373','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11476,'24614','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6067,'14816','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36905,'63333','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52773,'95570','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34131,'59404','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29980,'53556','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50763,'91104','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11535,'24827','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3170,'08525','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30261,'54126','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20774,'39165','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20092,'38321','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53857,'97432','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4167,'11418','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10367,'22922','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19738,'37813','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45023,'76566','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41740,'71747','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25678,'47246','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11647,'25035','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23565,'44258','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28448,'50533','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49884,'87711','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44186,'75454','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40498,'68961','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26921,'48822','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22924,'43331','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30088,'53811','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30707,'54730','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2047,'05769','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36029,'62305','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27366,'49330','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2620,'07065','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(250,'01066','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25607,'47145','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5696,'14144','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20691,'39078','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23040,'43506','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18164,'35214','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50677,'90702','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46973,'79377','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37153,'63660','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32872,'57383','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14517,'29609','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24071,'45131','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26404,'48153','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1334,'04032','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39418,'67563','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19799,'37869','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28666,'50680','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30967,'54970','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19642,'37705','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35731,'61877','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25242,'46743','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54869,'99347','Asotin','53003','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53843,'97413','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48183,'82325','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48123,'82010','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44905,'76459','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39338,'67485','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39360,'67513','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41699,'71665','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9247,'20547','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8960,'20066','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24384,'45601','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7812,'17814','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33344,'58230','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8552,'19136','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35174,'61108','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23812,'44671','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53195,'96151','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53129,'96078','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49958,'88027','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6440,'15415','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14266,'29307','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26299,'48036','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27180,'49084','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17766,'34266','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34149,'59421','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47815,'80943','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(21344,'40076','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20628,'38955','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25777,'47357','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48620,'83660','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42060,'72131','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39759,'68047','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38972,'66948','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36016,'62288','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34339,'59808','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(8433,'19013','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4324,'11798','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17954,'34958','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44034,'75228','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20256,'38543','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31222,'55347','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1547,'04485','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22431,'42349','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49382,'85548','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(20211,'38468','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18753,'36301','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33187,'57787','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22046,'41520','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49329,'85357','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47193,'79785','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11095,'24104','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53792,'97360','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25339,'46851','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25236,'46740','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11792,'25261','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28848,'51201','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25521,'47021','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7626,'17333','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24641,'45849','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5607,'14035','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52699,'95462','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50531,'90073','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36475,'62828','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35864,'62069','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16581,'32361','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19184,'37044','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8897,'19975','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(43035,'73560','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21386,'40159','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42876,'73146','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39514,'67656','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33751,'58654','Golden Valley','38033','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2635,'07080','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33614,'58504','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50906,'91507','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1269,'03858','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32607,'57065','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3391,'09102','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(18042,'35063','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25283,'46778','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25155,'46561','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5954,'14626','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28643,'50665','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34173,'59447','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31121,'55118','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53707,'97230','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(40744,'69361','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37465,'64154','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5800,'14456','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11526,'24811','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12616,'27043','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(1792,'05001','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15113,'30257','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45314,'77028','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53708,'97231','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(20716,'39095','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26729,'48614','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4443,'12073','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46191,'78350','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54252,'98230','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52571,'95317','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28638,'50661','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32183,'56444','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33085,'57644','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50057,'88268','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(41628,'71465','Caldwell','22021','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29532,'52642','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5621,'14048','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49996,'88103','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6352,'15262','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25386,'46919','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50930,'91701','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47843,'81020','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45615,'77452','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10917,'23893','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23231,'43779','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7683,'17519','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13893,'28675','None','51999','VA','Virginia',0,'2013-07-03 15:17:52',NULL,NULL),(2068,'05832','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21192,'39823','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23377,'44024','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33453,'58356','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35452,'61488','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54216,'98170','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49078,'84759','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44311,'75644','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42553,'72760','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41571,'71418','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36066,'62346','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15287,'30428','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7605,'17312','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43219,'73857','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17023,'33033','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34705,'60439','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14565,'29646','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50760,'91101','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43963,'75147','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43526,'74454','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20383,'38649','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52233,'94562','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2899,'07871','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26598,'48418','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19325,'37148','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9682,'21236','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53445,'96785','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(2212,'06128','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43171,'73760','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10605,'23223','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25715,'47304','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41132,'70659','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33460,'58363','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7152,'16553','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52421,'95051','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13197,'27928','Washington','37187','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(107,'00782','Comerio','72045','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(9292,'20610','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27354,'49325','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11605,'24945','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2780,'07644','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53306,'96551','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(19819,'37879','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8122,'18348','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43187,'73773','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37574,'64486','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22105,'41642','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11244,'24315','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12720,'27265','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28242,'50271','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7673,'17505','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53519,'96931','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(47214,'79848','Terrell','48443','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45644,'77477','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14887,'30076','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28266,'50313','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8492,'19079','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50171,'88570','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(15796,'31049','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(317,'01238','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4184,'11435','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40941,'70435','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42912,'73195','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48749,'84003','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41042,'70546','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48906,'84306','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10821,'23694','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39330,'67480','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9188,'20433','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(48488,'83435','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31508,'55779','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29799,'53141','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9972,'22027','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4077,'11105','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3929,'10567','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49253,'85260','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47314,'80020','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44696,'76137','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33220,'58027','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6249,'15084','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6168,'14904','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7289,'16826','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3280,'08812','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21425,'40222','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35747,'61913','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4121,'11243','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29459,'52563','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(689,'02210','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22219,'42035','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49767,'87198','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(39487,'67644','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38245,'65624','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17586,'33914','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15948,'31323','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20593,'38925','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20722,'39108','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3531,'09582','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(23917,'44840','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16452,'32185','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28918,'51401','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31892,'56201','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19283,'37111','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18364,'35615','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25584,'47126','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(663,'02151','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1021,'03060','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(42004,'72084','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7837,'17832','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6077,'14824','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54432,'98445','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39030,'67026','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53443,'96783','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(46331,'78592','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45388,'77098','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36937,'63361','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35685,'61843','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34940,'60682','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42059,'72130','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43987,'75161','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19589,'37614','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30171,'53958','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17550,'33867','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20943,'39436','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23966,'44878','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34218,'59501','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(24316,'45387','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11751,'25193','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6170,'14925','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42257,'72421','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35082,'61025','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(859,'02671','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41973,'72063','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41632,'71466','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38642,'66402','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35267,'61321','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10847,'23828','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19634,'37691','Johnson','47091','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8737,'19508','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4768,'12568','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2363,'06455','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32096,'56345','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(24693,'45883','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26351,'48095','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43078,'73650','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38163,'65548','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36007,'62279','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12200,'26146','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20948,'39439','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14428,'29506','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39624,'67841','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39368,'67520','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(710,'02322','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19660,'37721','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2303,'06354','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43473,'74364','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11067,'24076','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35223,'61261','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37732,'64743','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36181,'62450','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22505,'42459','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25895,'47468','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27898,'50010','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28758,'51019','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42456,'72645','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25749,'47341','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54678,'98943','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28893,'51343','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51627,'93223','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51078,'92056','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50501,'90043','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37217,'63785','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5397,'13646','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41435,'71241','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13553,'28360','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32293,'56556','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30992,'55001','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2167,'06075','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25571,'47119','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1892,'05355','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12144,'25989','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19167,'37032','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17068,'33106','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38830,'66738','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32419,'56701','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(18406,'35673','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18721,'36258','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43689,'74820','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53022,'95960','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49856,'87554','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(45939,'78008','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44442,'75832','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43583,'74557','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39290,'67448','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10544,'23129','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54847,'99320','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16527,'32309','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21981,'41257','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15049,'30189','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20747,'39144','Claiborne','28021','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4037,'10987','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18318,'35565','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20831,'39250','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52152,'94297','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12904,'27540','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12966,'27592','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22108,'41645','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24458,'45675','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16419,'32141','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44626,'76065','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20727,'39111','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15007,'30161','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9872,'21771','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49098,'84783','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(33934,'59037','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3729,'10055','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25211,'46713','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8991,'20110','Manassas City','51683','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4087,'11207','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20120,'38343','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30011,'53578','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11945,'25567','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24010,'45034','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1771,'04967','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32637,'57108','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54392,'98386','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50674,'90671','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7697,'17538','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16778,'32667','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11866,'25411','Morgan','54065','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16106,'31642','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21022,'39555','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7068,'16364','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16795,'32696','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50078,'88340','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52135,'94278','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53911,'97492','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53570,'97035','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47721,'80807','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43694,'74825','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21857,'41046','Gallatin','21077','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11827,'25321','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34163,'59436','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35678,'61839','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37685,'64671','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9861,'21758','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49022,'84656','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45985,'78055','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7423,'17027','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12349,'26376','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8898,'19977','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(3517,'09565','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(34502,'60076','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18932,'36567','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1708,'04854','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45669,'77494','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53936,'97532','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42112,'72179','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41308,'71052','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19346,'37172','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52654,'95410','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43480,'74368','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40430,'68922','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10488,'23071','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13308,'28081','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22873,'43230','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23694,'44483','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51674,'93274','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44242,'75497','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17360,'33583','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14824,'30025','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17649,'34020','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(17255,'33440','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44142,'75424','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22647,'43007','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12042,'25777','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53343,'96657','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(36669,'62949','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12512,'26704','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26659,'48457','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26725,'48613','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20959,'39455','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30186,'53965','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30267,'54130','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28989,'51529','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48705,'83836','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46310,'78569','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36766,'63038','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33070,'57633','Ziebach','46137','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52856,'95670','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52175,'94507','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51601,'93130','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42743,'73040','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42248,'72414','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(475,'01719','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13981,'28753','Madison','37115','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43212,'73851','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1337,'04037','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9779,'21640','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(48149,'82190','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(24492,'45698','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24902,'46165','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18259,'35474','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28994,'51531','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24489,'45697','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6999,'16255','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1242,'03827','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21579,'40409','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16517,'32277','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51756,'93455','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48623,'83661','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(17169,'33302','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17462,'33744','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27193,'49093','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16421,'32143','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7048,'16346','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28528,'50590','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28025,'50111','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(370,'01380','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20105,'38334','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46686,'79035','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45824,'77808','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34947,'60690','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10756,'23465','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34338,'59807','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28883,'51333','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44699,'76148','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46821,'79174','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3556,'09622','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53162,'96115','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7873,'17872','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6144,'14883','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47461,'80243','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44651,'76092','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53425,'96764','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(55018,'99660','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54661,'98922','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51836,'93607','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22010,'41348','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46519,'78750','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38210,'65605','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8443,'19023','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2302,'06353','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1364,'04073','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29564,'52721','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9355,'20701','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50740,'91009','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45749,'77582','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14253,'29230','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49106,'85005','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39332,'67481','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19301,'37134','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3252,'08739','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4643,'12434','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7408,'17019','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36000,'62275','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30562,'54547','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3310,'08852','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21298,'40045','Trimble','21223','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43540,'74464','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42888,'73156','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40486,'68956','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3209,'08605','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2969,'08021','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28367,'50457','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(763,'02457','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47866,'81045','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48801,'84057','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(18157,'35207','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13993,'28761','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13191,'27924','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26372,'48116','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49308,'85336','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(23857,'44718','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3229,'08647','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8787,'19601','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46264,'78468','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42570,'72801','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4187,'11451','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12995,'27615','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12919,'27553','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14788,'30004','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25561,'47114','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(419,'01526','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50286,'89131','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(311,'01227','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31223,'55348','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9822,'21690','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6131,'14873','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2585,'07028','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34799,'60517','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50143,'88539','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47900,'81076','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46434,'78660','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43901,'75082','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26250,'47982','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25952,'47561','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1483,'04359','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11123,'24134','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39391,'67546','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22478,'42431','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47836,'81008','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3814,'10260','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37375,'64061','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34258,'59632','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33258,'58052','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3386,'09090','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9564,'21054','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31736,'56065','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18548,'35986','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14030,'28803','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15233,'30356','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22644,'43006','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44942,'76484','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42176,'72339','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54501,'98563','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52769,'95565','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6771,'15901','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53951,'97604','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47887,'81063','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39798,'68111','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12238,'26203','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13205,'27939','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53036,'95971','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35872,'62075','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38643,'66403','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4682,'12471','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8056,'18220','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50223,'89029','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(12003,'25701','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35196,'61234','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44081,'75313','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41441,'71249','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(23273,'43843','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49224,'85210','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43775,'74902','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13695,'28508','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23453,'44105','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23770,'44636','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9483,'20872','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53808,'97374','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(3857,'10459','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2266,'06251','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16358,'32073','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18395,'35653','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28819,'51054','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23840,'44695','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30388,'54411','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45679,'77504','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44136,'75420','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9183,'20426','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3233,'08690','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5227,'13329','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38012,'65270','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53961,'97632','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53593,'97057','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43723,'74851','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41352,'71105','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41201,'70774','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9968,'22009','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10708,'23412','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20917,'39365','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18162,'35212','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13084,'27826','Hyde','37095','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25822,'47394','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6801,'15943','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47620,'80541','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20582,'38917','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36011,'62282','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35093,'61038','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11741,'25173','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(235,'01038','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49384,'85551','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36741,'63020','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31442,'55707','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13563,'28366','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1517,'04442','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4398,'12027','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24473,'45685','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14405,'29476','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29105,'52002','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39511,'67653','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46000,'78065','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44300,'75638','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1622,'04649','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52089,'94161','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44490,'75904','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32527,'57018','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9080,'20203','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(9499,'20894','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16593,'32409','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25090,'46408','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28845,'51201','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(382,'01451','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50851,'91359','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13894,'28676','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34540,'60112','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34527,'60101','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31554,'55912','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4140,'11364','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36515,'62853','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25600,'47140','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2673,'07199','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41384,'71161','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50438,'89713','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48040,'81427','Ouray','8091','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38186,'65565','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31054,'55052','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31039,'55040','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24174,'45253','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12305,'26294','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49338,'85366','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34070,'59274','McCone','30055','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42684,'73002','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36241,'62520','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10286,'22733','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32522,'57015','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19753,'37825','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12360,'26386','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23980,'44889','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22327,'42167','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10065,'22227','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18572,'36022','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50522,'90064','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5468,'13748','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28392,'50471','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35030,'60958','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9504,'20899','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14658,'29730','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53205,'96162','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46179,'78335','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40677,'69210','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10153,'22503','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13343,'28109','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4360,'11960','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27299,'49279','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27033,'48894','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7043,'16342','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25720,'47320','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45955,'78021','La Salle','48283','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22897,'43310','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32287,'56551','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32026,'56302','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53987,'97734','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29422,'52536','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39087,'67070','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23039,'43506','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43218,'73855','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4612,'12325','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22700,'43047','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10536,'23123','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15528,'30638','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27305,'49284','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17093,'33141','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3639,'09814','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21217,'39842','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18984,'36689','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29557,'52658','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39887,'68328','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36428,'62761','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7578,'17254','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35749,'61913','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19637,'37694','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51438,'92656','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38264,'65636','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3759,'10121','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6958,'16217','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25879,'47457','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52550,'95257','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40901,'70359','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21884,'41080','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52502,'95202','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28682,'50836','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10456,'23038','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47253,'79934','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(35742,'61911','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11403,'24540','Danville City','51590','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12823,'27405','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15095,'30237','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26406,'48157','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25116,'46526','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27297,'49276','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53113,'96061','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23471,'44123','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6360,'15275','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12892,'27529','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22621,'42757','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52210,'94540','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13734,'28541','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31627,'55970','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42380,'72553','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41710,'71674','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24398,'45620','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8097,'18322','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12593,'27020','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(49091,'84774','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42505,'72712','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11553,'24849','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24609,'45831','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1024,'03063','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28497,'50566','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49610,'86412','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53649,'97132','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52011,'94022','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51829,'93601','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51089,'92069','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49228,'85213','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48445,'83340','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42914,'73301','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38969,'66946','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38324,'65682','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19888,'38012','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11586,'24902','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3628,'09802','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20845,'39302','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(413,'01520','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10984,'23968','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36008,'62280','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32664,'57221','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54746,'99114','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43026,'73554','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48396,'83256','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43165,'73756','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11205,'24246','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4712,'12507','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11071,'24079','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36163,'62442','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3373,'09054','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2555,'06925','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48188,'82332','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(30004,'53573','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23005,'43445','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16500,'32239','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1297,'03897','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(18372,'35621','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4424,'12057','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30199,'54005','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32165,'56431','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36045,'62323','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37100,'63620','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42259,'72422','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47731,'80816','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11419,'24555','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39197,'67260','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32163,'56425','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31498,'55766','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28837,'51104','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21251,'39901','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17690,'34110','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2641,'07088','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4111,'11232','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22051,'41528','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7579,'17255','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30537,'54526','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18422,'35749','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50761,'91102','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45360,'77072','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45047,'76621','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21882,'41075','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18136,'35178','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15502,'30622','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28086,'50151','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15853,'31086','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4585,'12246','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(256,'01073','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35004,'60941','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22119,'41666','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23084,'43537','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23199,'43752','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36282,'62553','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18390,'35651','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11724,'25142','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43065,'73638','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18809,'36362','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50974,'91766','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46729,'79062','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24259,'45341','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27170,'49078','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50168,'88567','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47706,'80746','Phillips','8095','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52031,'94063','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41300,'71044','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45572,'77413','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32795,'57332','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16753,'32633','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12716,'27262','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2922,'07931','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20833,'39271','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3875,'10501','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17346,'33566','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28417,'50510','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26138,'47882','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44876,'76442','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42431,'72624','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9617,'21150','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33923,'59027','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31810,'56129','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43835,'75020','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50843,'91351','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17627,'33967','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52555,'95297','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42753,'73047','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40892,'70346','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10516,'23108','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22071,'41558','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23528,'44217','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47692,'80735','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24359,'45440','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14079,'29036','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52622,'95370','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36559,'62882','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47610,'80534','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47301,'80011','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40970,'70457','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1970,'05620','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16357,'32072','Baker','12003','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42558,'72764','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32116,'56361','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27612,'49683','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34787,'60506','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49344,'85374','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47664,'80649','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46125,'78241','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39970,'68381','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36651,'62938','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31659,'56003','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8959,'20065','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(125,'00823','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(28765,'51022','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3130,'08344','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42080,'72143','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9637,'21206','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36397,'62692','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51118,'92111','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51339,'92413','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5728,'14219','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48152,'82201','Platte','56031','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45968,'78028','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45513,'77354','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37773,'64781','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7217,'16669','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25486,'46989','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6151,'14886','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16030,'31552','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14247,'29224','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17615,'33951','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17659,'34034','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(13188,'27921','Camden','37029','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3329,'08873','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31780,'56098','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4287,'11756','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16522,'32305','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42026,'72106','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50725,'90835','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8234,'18602','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23450,'44102','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33893,'58854','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40061,'68466','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37513,'64434','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21047,'39576','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3060,'08201','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26953,'48840','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28676,'50801','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14340,'29414','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8827,'19802','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(19803,'37871','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18961,'36611','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43713,'74842','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23202,'43756','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52165,'94403','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49882,'87701','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(10680,'23325','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22828,'43153','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9657,'21219','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29873,'53223','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7105,'16422','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18342,'35582','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35898,'62088','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11001,'24012','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54383,'98378','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30016,'53583','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36548,'62874','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51510,'92842','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34668,'60408','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54908,'99515','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48119,'82006','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(38543,'66058','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31303,'55405','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28954,'51455','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24011,'45036','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25836,'47421','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34899,'60629','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43437,'74333','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39975,'68403','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32580,'57049','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22358,'42223','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18142,'35182','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42616,'72855','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14525,'29615','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33477,'58377','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34829,'60542','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54230,'98198','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28571,'50616','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50010,'88122','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(20890,'39347','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3440,'09314','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(10354,'22904','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53081,'96025','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42400,'72573','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14506,'29596','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17598,'33928','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16892,'32812','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8194,'18456','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18724,'36261','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21139,'39744','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2682,'07302','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47154,'79742','Ward','48475','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34636,'60192','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32138,'56378','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53244,'96338','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(46279,'78535','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42440,'72633','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38802,'66683','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13365,'28127','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2976,'08029','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25520,'47020','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48639,'83702','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39757,'68047','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39726,'68022','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14676,'29810','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7283,'16820','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(183,'00965','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(21406,'40203','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35664,'61818','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46064,'78146','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53169,'96122','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31046,'55045','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24544,'45764','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51662,'93258','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22818,'43147','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5162,'13162','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10105,'22406','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25089,'46407','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27034,'48895','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2176,'06083','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47651,'80634','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24935,'46203','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5873,'14526','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46155,'78269','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35270,'61322','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34345,'59821','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30257,'54124','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1176,'03593','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(7836,'17831','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31089,'55082','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12890,'27527','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36059,'62341','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17626,'33966','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22689,'43037','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22638,'43002','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46700,'79042','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45341,'77053','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42920,'73425','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36009,'62280','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13289,'28055','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13399,'28168','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23959,'44866','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24754,'46040','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50425,'89599','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48249,'82643','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(36594,'62901','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33067,'57632','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13939,'28717','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18942,'36579','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1466,'04341','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16931,'32877','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8349,'18848','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53965,'97635','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16158,'31733','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26742,'48621','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54898,'99504','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54512,'98576','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52315,'94802','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42316,'72471','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33786,'58734','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33104,'57660','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9397,'20746','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14089,'29044','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(908,'02801','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(27459,'49443','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14656,'29728','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45141,'76705','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42484,'72679','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54735,'99103','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25547,'47102','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47765,'80841','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45984,'78054','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3388,'09095','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3699,'10014','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49939,'88002','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48821,'84074','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27892,'50006','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10260,'22701','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33845,'58778','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50534,'90076','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53977,'97710','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44828,'76372','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32843,'57366','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10066,'22230','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17977,'34994','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52766,'95562','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13157,'27884','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47355,'80108','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32474,'56757','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6450,'15424','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2811,'07717','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18189,'35243','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2066,'05829','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2731,'07462','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53246,'96343','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(43651,'74731','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34786,'60506','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30844,'54854','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4151,'11375','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16677,'32523','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2612,'07060','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51001,'91896','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17936,'34787','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3009,'08064','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5921,'14580','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28337,'50434','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29484,'52581','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4745,'12543','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47767,'80861','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39893,'68332','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38094,'65360','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3165,'08515','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7746,'17701','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16336,'32052','Hamilton','12047','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27347,'49321','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25112,'46516','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23344,'43973','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15990,'31518','Bacon','13005','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22499,'42455','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23479,'44131','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21301,'40046','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9911,'21814','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43986,'75160','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36956,'63382','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51034,'91962','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46531,'78760','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38943,'66873','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10746,'23457','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16957,'32925','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4924,'12863','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25972,'47580','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14213,'29170','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16186,'31768','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27091,'49019','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5724,'14215','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42957,'73456','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28825,'51058','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50453,'89831','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43917,'75097','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42387,'72560','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32069,'56331','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30275,'54139','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1347,'04049','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8538,'19123','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25764,'47352','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43518,'74445','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52564,'95310','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51730,'93429','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47213,'79847','Hudspeth','48229','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3476,'09399','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48497,'83442','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47567,'80479','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41168,'70736','West Baton Rouge','22121','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34964,'60901','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3124,'08341','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11032,'24036','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25123,'46531','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8096,'18321','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19199,'37051','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26238,'47974','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22898,'43311','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49528,'85939','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(12411,'26502','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31866,'56168','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37977,'65243','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17014,'33024','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42679,'72959','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52689,'95451','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8551,'19135','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36265,'62543','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52837,'95651','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48077,'81623','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42064,'72132','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5092,'13087','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15549,'30660','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21698,'40702','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21526,'40358','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18093,'35123','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49626,'86441','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4793,'12594','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50987,'91784','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47598,'80521','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3834,'10292','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20003,'38151','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51735,'93435','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43797,'74947','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40173,'68666','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34170,'59444','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25883,'47459','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28871,'51245','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6807,'15946','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10190,'22554','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15198,'30325','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17645,'34004','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(3408,'09154','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32713,'57257','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36778,'63049','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9023,'20137','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7910,'17946','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15930,'31308','Bryan','13029','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(298,'01151','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36298,'62565','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20048,'38237','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51417,'92619','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44070,'75275','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37723,'64738','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53149,'96103','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44810,'76354','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35089,'61032','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15812,'31061','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50895,'91470','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8819,'19730','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(7117,'16435','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19891,'38016','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11665,'25059','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31108,'55107','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44178,'75451','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39613,'67836','Hamilton','20075','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32840,'57365','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9674,'21229','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39972,'68382','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14002,'28772','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52771,'95568','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43010,'73542','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40720,'69343','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16130,'31707','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25500,'46998','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28062,'50138','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44777,'76264','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8010,'18072','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6716,'15781','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52332,'94922','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52245,'94573','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46625,'78954','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24561,'45778','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6293,'15146','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7682,'17518','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37049,'63533','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27458,'49442','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17148,'33231','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30165,'53954','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24918,'46175','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27558,'49639','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9198,'20447','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53529,'96952','Northern Mariana Islands','69010','MP','Northern Mariana Islands',0,'2013-07-03 15:17:54',NULL,NULL),(42696,'73010','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41332,'71071','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27464,'49448','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16820,'32723','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10541,'23127','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47345,'80103','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4415,'12050','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41086,'70601','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38954,'66938','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40020,'68442','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34801,'60518','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14488,'29580','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18184,'35236','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24481,'45690','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5948,'14620','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10606,'23223','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8475,'19057','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11450,'24590','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8470,'19052','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54378,'98373','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14683,'29819','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1052,'03215','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52891,'95701','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22941,'43342','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35776,'61938','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41734,'71740','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44413,'75773','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53400,'96738','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(31882,'56180','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19930,'38053','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27411,'49403','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39366,'67519','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51720,'93412','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51486,'92806','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51003,'91901','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49145,'85044','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46160,'78283','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44361,'75686','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35807,'62012','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33413,'58323','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13052,'27803','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26537,'48327','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18429,'35755','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19296,'37129','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10000,'22081','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13678,'28466','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37402,'64080','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36844,'63123','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42622,'72860','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32811,'57345','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3296,'08830','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52887,'95696','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46390,'78632','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42099,'72166','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40063,'68501','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35966,'62254','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22077,'41564','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21409,'40206','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24742,'46035','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16899,'32820','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43205,'73843','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7221,'16673','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16497,'32236','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24086,'45144','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9117,'20251','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(48326,'83101','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(842,'02650','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54868,'99346','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53721,'97266','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49723,'87102','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(13645,'28444','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48370,'83227','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(23128,'43610','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39557,'67737','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42649,'72933','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27135,'49052','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1830,'05070','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21193,'39823','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23170,'43724','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30684,'54702','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34916,'60647','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39311,'67464','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46963,'79370','Garza','48169','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13604,'28401','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34935,'60675','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22347,'42214','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53653,'97133','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12051,'25817','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30921,'54936','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34365,'59843','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44812,'76360','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53089,'96034','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5625,'14054','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9649,'21212','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53103,'96052','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45176,'76834','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35104,'61047','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22710,'43060','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23433,'44086','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11718,'25136','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6221,'15054','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6978,'16232','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20817,'39209','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30654,'54652','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13542,'28350','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47311,'80020','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45101,'76665','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27301,'49282','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29112,'52032','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39310,'67460','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13344,'28110','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46028,'78112','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42701,'73012','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45692,'77518','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34859,'60564','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32679,'57234','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11771,'25239','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15681,'30828','Glascock','13125','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1561,'04537','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29728,'53066','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1961,'05494','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34770,'60490','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29833,'53182','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40381,'68856','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51324,'92397','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49665,'87014','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(39754,'68045','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7961,'18031','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25891,'47464','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27147,'49062','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14175,'29130','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39983,'68413','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30298,'54162','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3363,'09020','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28072,'50143','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45856,'77866','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43573,'74547','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38170,'65555','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15626,'30747','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25681,'47250','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25393,'46923','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32093,'56343','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(41356,'71108','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40258,'68764','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8699,'19454','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37242,'63839','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39885,'68327','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37831,'64870','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34685,'60424','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34340,'59812','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2041,'05764','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15586,'30707','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11462,'24599','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13438,'28232','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25462,'46975','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3323,'08867','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15921,'31297','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23130,'43612','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17523,'33839','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4258,'11720','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49903,'87742','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48538,'83537','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39722,'68019','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39595,'67761','Sherman','20181','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47577,'80501','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19582,'37601','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30955,'54963','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23426,'44080','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44773,'76261','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22670,'43019','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14107,'29058','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2802,'07702','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31807,'56128','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17423,'33680','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23111,'43565','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46306,'78565','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44060,'75254','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24100,'45159','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27014,'48883','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15211,'30337','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32189,'56449','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15886,'31144','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17416,'33664','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(754,'02445','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32458,'56741','Lake of the Woods','27077','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(42121,'72203','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11304,'24422','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30439,'54448','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31871,'56171','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9240,'20539','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(32441,'56727','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43297,'74036','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37364,'64050','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13142,'27873','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16269,'31824','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6338,'15242','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32907,'57437','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(951,'02865','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(9646,'21210','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5750,'14272','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48730,'83861','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45413,'77225','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40724,'69347','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39698,'67954','Morton','20129','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21914,'41129','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21280,'40023','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21367,'40121','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47601,'80524','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46718,'79057','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14368,'29438','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27739,'49796','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9119,'20260','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17435,'33703','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39905,'68339','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17054,'33074','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5429,'13678','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6110,'14856','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30462,'54460','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7751,'17720','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21333,'40068','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49582,'86324','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50096,'88410','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49515,'85926','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47325,'80031','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37928,'65079','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35700,'61851','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20216,'38472','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20530,'38852','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16528,'32310','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6425,'15367','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40716,'69341','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43133,'73729','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42767,'73054','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52660,'95419','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45553,'77383','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38192,'65571','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22413,'42333','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27839,'49913','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39371,'67522','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38762,'66549','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23569,'44262','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23654,'44428','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10831,'23801','Petersburg City','51730','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28463,'50542','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20706,'39090','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9878,'21776','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29742,'53080','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2504,'06817','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38913,'66853','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54021,'97823','Gilliam','41021','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53704,'97228','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37636,'64640','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24629,'45844','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26252,'47984','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16959,'32927','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32963,'57474','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23575,'44272','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30879,'54895','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54014,'97813','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50985,'91778','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39164,'67159','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28554,'50604','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14218,'29178','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16329,'32042','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37170,'63732','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38049,'65325','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44459,'75848','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45521,'77358','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1986,'05660','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17557,'33876','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5822,'14476','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12182,'26121','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14781,'29945','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20004,'38152','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49016,'84649','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46267,'78480','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40972,'70459','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12243,'26209','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13609,'28406','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19579,'37450','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29292,'52246','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19583,'37601','Unicoi','47171','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49046,'84725','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47219,'79854','Jeff Davis','48243','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33634,'58535','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12279,'26266','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1274,'03864','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6480,'15459','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8382,'18935','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30757,'54758','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9294,'20612','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47562,'80474','Gilpin','8047','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43047,'73571','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8085,'18251','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17472,'33763','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52924,'95815','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38735,'66533','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6871,'16052','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21342,'40075','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16151,'31722','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19188,'37047','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19062,'36801','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32858,'57375','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50385,'89441','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(35930,'62225','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32401,'56673','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20083,'38314','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8478,'19061','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25043,'46348','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35122,'61061','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54719,'99027','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19659,'37721','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11769,'25235','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18053,'35073','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37995,'65257','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3505,'09522','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(40859,'70167','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46497,'78729','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12958,'27587','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19575,'37419','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44957,'76504','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11734,'25161','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34177,'59451','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45958,'78022','McMullen','48311','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10114,'22428','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39600,'67762','Wallace','20199','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44515,'75943','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50311,'89156','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(29446,'52554','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12945,'27572','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43661,'74743','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54348,'98342','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10018,'22125','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6343,'15252','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5312,'13461','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(482,'01742','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(846,'02655','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17665,'34041','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(9001,'20117','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17524,'33840','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39295,'67449','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27848,'49921','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24278,'45354','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53783,'97350','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51671,'93270','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46277,'78523','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12323,'26335','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8439,'19019','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28588,'50628','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15133,'30274','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42357,'72530','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43884,'75065','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29621,'52773','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49292,'85320','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45091,'76655','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29815,'53154','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32186,'56446','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8700,'19455','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8559,'19143','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27845,'49919','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11126,'24137','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26026,'47666','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39465,'67631','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35557,'61653','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6860,'16041','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19808,'37873','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21572,'40403','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2475,'06776','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(15098,'30240','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2967,'08019','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51791,'93530','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45126,'76689','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21423,'40220','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4639,'12430','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49018,'84652','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44192,'75458','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35015,'60949','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2660,'07110','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25125,'46532','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36077,'62354','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15468,'30577','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18336,'35579','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8580,'19175','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20606,'38940','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39824,'68138','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46998,'79423','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48469,'83404','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46116,'78232','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53920,'97501','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45500,'77340','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15497,'30620','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6307,'15212','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17898,'34715','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2327,'06389','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29190,'52144','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24513,'45723','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23653,'44428','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23290,'43909','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38991,'66963','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6149,'14886','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4099,'11219','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12908,'27542','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27339,'49316','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49654,'87004','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(18268,'35481','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44507,'75936','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53212,'96207','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(8895,'19973','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2282,'06278','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6845,'16029','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43674,'74755','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43104,'73669','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37265,'63867','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36057,'62339','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22205,'42022','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25728,'47326','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2203,'06114','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8104,'18326','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34134,'59405','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32513,'57007','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28296,'50360','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6783,'15923','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12032,'25728','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43980,'75157','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31852,'56160','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1430,'04255','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3006,'08061','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7455,'17055','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35614,'61749','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52056,'94116','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45455,'77274','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15356,'30510','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1340,'04040','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31347,'55445','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3283,'08818','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22894,'43302','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11694,'25107','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38986,'66960','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54055,'97867','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52467,'95130','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52430,'95063','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49828,'87520','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(28980,'51521','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20128,'38352','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52881,'95692','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43226,'73901','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36315,'62613','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34469,'60039','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14713,'29843','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20657,'39043','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13837,'28633','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13353,'28119','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30429,'54439','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1505,'04426','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12394,'26440','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54322,'98312','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51509,'92841','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40860,'70170','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39276,'67438','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35078,'61020','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23520,'44211','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4593,'12257','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49908,'87747','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(25423,'46946','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30649,'54649','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29537,'52646','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8888,'19964','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(19616,'37660','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6286,'15139','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6215,'15047','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51781,'93519','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42369,'72540','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40141,'68643','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37751,'64759','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33657,'58562','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23861,'44730','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21725,'40807','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48776,'84033','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47209,'79843','Presidio','48377','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44794,'76302','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41475,'71280','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17964,'34981','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23291,'43910','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43514,'74440','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18514,'35960','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20352,'38625','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12690,'27235','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32619,'57072','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(348,'01342','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41926,'72027','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40275,'68771','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16304,'31999','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13457,'28262','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21064,'39633','Wilkinson','28157','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11975,'25650','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43988,'75163','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46234,'78390','Aransas','48007','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41368,'71129','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38287,'65652','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36524,'62859','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32380,'56652','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(18820,'36401','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2578,'07020','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24,'00641','Utuado','72141','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(50366,'89423','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(26259,'47990','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(55104,'99757','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(23011,'43450','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48873,'84129','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(35572,'61722','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17882,'34684','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5122,'13124','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14899,'30087','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22261,'42069','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8254,'18619','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20688,'39074','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2668,'07191','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50854,'91361','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48102,'81646','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44427,'75789','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37789,'64830','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2293,'06334','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9251,'20552','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35480,'61532','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34788,'60507','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4644,'12434','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7246,'16698','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50983,'91775','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51012,'91912','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48118,'82005','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(15685,'30833','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16615,'32431','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16563,'32344','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1181,'03602','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5473,'13752','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16070,'31622','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4820,'12740','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24919,'46175','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45804,'77702','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46791,'79103','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5239,'13340','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22427,'42345','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(943,'02857','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(452,'01602','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17724,'34208','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29914,'53508','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35029,'60957','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42987,'73526','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27835,'49908','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50751,'91030','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50719,'90815','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40511,'68974','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37146,'63654','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35236,'61274','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34515,'60089','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34436,'60008','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8862,'19938','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(18886,'36507','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20217,'38472','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13878,'28661','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51723,'93422','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2237,'06167','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29385,'52356','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20588,'38923','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37148,'63655','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52768,'95564','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52705,'95468','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49781,'87321','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(23819,'44678','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23370,'44017','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3545,'09605','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(4596,'12288','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30590,'54566','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3483,'09463','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(36567,'62885','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27535,'49622','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50255,'89087','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(9565,'21056','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8875,'19952','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18204,'35283','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30704,'54729','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30800,'54817','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26846,'48742','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29066,'51579','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46274,'78520','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46051,'78132','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22581,'42719','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12799,'27355','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16882,'32802','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32200,'56461','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9899,'21795','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27977,'50064','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1778,'04975','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11819,'25311','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6673,'15736','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27081,'49013','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33738,'58649','Bowman','38011','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3098,'08270','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25151,'46554','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20504,'38833','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20748,'39144','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4321,'11795','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45617,'77454','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6528,'15539','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20842,'39298','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28353,'50447','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45571,'77412','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42012,'72088','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34309,'59741','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51491,'92812','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32951,'57468','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23687,'44470','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28977,'51510','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24028,'45061','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16224,'31791','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18935,'36571','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14545,'29631','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47932,'81132','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4343,'11941','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3383,'09079','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(51713,'93403','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26851,'48745','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52943,'95834','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48778,'84035','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46797,'79107','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37741,'64748','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34756,'60476','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7528,'17127','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23444,'44095','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13054,'27804','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9501,'20896','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5938,'14610','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35253,'61301','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31265,'55380','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20744,'39122','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10174,'22535','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25409,'46933','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9511,'20905','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41895,'72006','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21703,'40734','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4138,'11362','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52063,'94123','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50307,'89152','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48134,'82061','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45797,'77662','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39133,'67131','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33617,'58507','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26825,'48728','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3711,'10027','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17561,'33882','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43417,'74159','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13904,'28683','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28732,'51001','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(44175,'75449','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50576,'90245','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43754,'74868','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15257,'30394','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36200,'62465','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33212,'58015','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27543,'49630','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28908,'51358','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30221,'54026','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6302,'15207','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19382,'37205','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31422,'55602','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2070,'05836','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4845,'12768','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5677,'14125','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17897,'34714','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13104,'27842','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16109,'31645','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37129,'63636','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30729,'54742','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47066,'79541','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5459,'13737','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7393,'17007','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10009,'22107','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10151,'22501','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25684,'47260','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45633,'77467','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44901,'76457','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39300,'67452','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37611,'64624','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34552,'60122','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33954,'59057','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16383,'32102','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46280,'78536','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47720,'80807','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46225,'78383','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44700,'76150','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38114,'65444','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22365,'42240','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12012,'25708','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43879,'75058','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35812,'62017','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5036,'13034','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28165,'50228','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8009,'18071','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31110,'55109','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16353,'32066','Lafayette','12067','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12286,'26271','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32860,'57376','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33308,'58124','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26895,'48801','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27025,'48890','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6715,'15780','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13803,'28605','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32888,'57424','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28278,'50323','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54158,'98074','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44971,'76523','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43268,'74016','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25212,'46714','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45474,'77304','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50146,'88542','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(45788,'77650','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38050,'65325','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28215,'50254','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29252,'52216','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30507,'54493','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1883,'05343','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20200,'38459','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6083,'14830','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6948,'16159','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5748,'14269','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30435,'54443','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28461,'50541','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39625,'67842','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1594,'04611','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13564,'28367','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40338,'68823','Rock','31149','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45664,'77491','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11843,'25337','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10618,'23230','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21582,'40419','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44870,'76437','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12235,'26201','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26154,'47916','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13936,'28714','Yancey','37199','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38515,'66033','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20825,'39216','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53979,'97712','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52822,'95635','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(757,'02451','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23054,'43516','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18037,'35058','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32170,'56434','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34052,'59256','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37126,'63633','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22576,'42717','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3957,'10606','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18808,'36361','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8316,'18816','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47631,'80551','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7428,'17032','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47456,'80236','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6053,'14806','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5792,'14443','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17288,'33478','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53937,'97533','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9115,'20245','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(46801,'79109','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18908,'36538','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51323,'92395','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50821,'91321','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54413,'98411','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12391,'26437','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17133,'33183','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17480,'33772','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13675,'28465','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8866,'19941','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(5394,'13642','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21023,'39556','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30716,'54736','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26721,'48611','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22461,'42378','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(953,'02872','Bristol','44001','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(1812,'05049','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40259,'68764','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35855,'62059','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17131,'33181','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12641,'27105','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24379,'45502','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19843,'37914','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38867,'66775','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39274,'67437','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19990,'38132','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42784,'73063','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2892,'07857','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12454,'26576','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28595,'50630','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27804,'49874','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18253,'35468','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31991,'56276','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54670,'98935','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54442,'98490','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39015,'67018','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38624,'66219','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11060,'24068','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25969,'47578','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29482,'52580','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8657,'19382','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32147,'56385','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15229,'30353','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8764,'19540','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37244,'63841','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47283,'79990','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3054,'08105','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49574,'86312','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31487,'55752','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42255,'72419','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16058,'31599','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23806,'44665','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20313,'38583','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53641,'97124','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49039,'84719','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5846,'14505','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3016,'08071','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25605,'47143','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8404,'18964','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5283,'13424','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46376,'78624','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13212,'27947','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54654,'98903','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49876,'87581','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44295,'75630','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1199,'03753','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(48485,'83433','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40795,'70073','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40565,'69036','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36422,'62723','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35484,'61534','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22774,'43112','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49826,'87518','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2843,'07755','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8638,'19358','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10148,'22485','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32332,'56585','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26012,'47638','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24565,'45783','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(555,'01913','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47517,'80425','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42433,'72628','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12449,'26571','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2992,'08045','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54396,'98391','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34767,'60484','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34612,'60172','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11995,'25688','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10599,'23218','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5338,'13489','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7896,'17925','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20337,'38611','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1760,'04955','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23062,'43522','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51060,'92026','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49873,'87578','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42261,'72425','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6277,'15131','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19777,'37849','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21908,'41102','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26192,'47944','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27560,'49640','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30966,'54969','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21210,'39837','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34231,'59529','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(43604,'74576','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44417,'75778','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3687,'10002','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4574,'12235','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54795,'99158','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41374,'71137','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40597,'69127','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15704,'31002','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21785,'40944','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23720,'44515','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8974,'20082','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(48644,'83706','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(1407,'04220','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12312,'26320','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39747,'68040','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28961,'51461','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51606,'93199','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44224,'75487','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41295,'71039','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35820,'62023','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1520,'04448','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17150,'33234','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28375,'50460','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19219,'37062','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44496,'75930','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4182,'11433','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48008,'81326','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50130,'88525','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(13830,'28628','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18240,'35456','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25314,'46797','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21595,'40442','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29182,'52136','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54473,'98533','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49764,'87195','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48626,'83669','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54793,'99156','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38882,'66782','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18556,'36005','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6375,'15312','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27915,'50025','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8923,'20024','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42963,'73461','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44735,'76226','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53754,'97321','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52950,'95840','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33850,'58782','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33473,'58374','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13348,'28114','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17952,'34957','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6776,'15906','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17116,'33165','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7446,'17047','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44290,'75606','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(262,'01080','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29479,'52576','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12294,'26283','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54915,'99522','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38615,'66211','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31940,'56236','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12125,'25966','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21350,'40078','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26036,'47710','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2569,'07011','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26465,'48212','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29471,'52570','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10328,'22834','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26682,'48473','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26217,'47959','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4036,'10986','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11566,'24868','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47131,'79713','Dawson','48115','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42115,'72182','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40278,'68774','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31667,'56011','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12413,'26505','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13644,'28443','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13656,'28451','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21339,'40071','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3215,'08610','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23732,'44610','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47927,'81128','Archuleta','8007','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17640,'33990','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41809,'71857','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35673,'61831','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18353,'35601','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34910,'60641','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48577,'83619','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29858,'53209','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27838,'49912','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23630,'44403','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52267,'94597','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45646,'77478','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16875,'32793','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10331,'22841','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19155,'37025','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24046,'45106','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35651,'61803','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45336,'77049','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1275,'03865','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3555,'09621','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27564,'49643','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42271,'72434','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15285,'30427','Long','13183','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2917,'07924','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43627,'74646','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12115,'25928','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22256,'42064','Lyon','21143','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22363,'42236','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44231,'75492','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35972,'62257','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2610,'07058','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(314,'01235','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33567,'58464','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44800,'76307','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3553,'09618','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52020,'94037','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51330,'92403','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44776,'76263','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11153,'24167','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28124,'50173','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18971,'36630','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11256,'24325','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4338,'11934','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18737,'36272','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51604,'93160','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48660,'83722','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(30650,'54650','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6393,'15331','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17858,'34613','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22211,'42027','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3637,'09812','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11788,'25253','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40531,'68982','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45962,'78024','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38593,'66109','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34845,'60553','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10433,'23005','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20428,'38703','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12527,'26726','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13347,'28112','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27203,'49099','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4885,'12820','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6842,'16027','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28273,'50320','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32403,'56676','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3100,'08302','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17855,'34609','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20073,'38303','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28515,'50578','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46768,'79086','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40927,'70403','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5868,'14522','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7869,'17867','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8369,'18923','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26828,'48730','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41709,'71671','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22280,'42101','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37008,'63451','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35559,'61655','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44746,'76234','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37859,'65032','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16907,'32829','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(965,'02885','Bristol','44001','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(4179,'11430','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46443,'78664','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45072,'76640','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44366,'75691','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40046,'68458','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39431,'67572','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4491,'12140','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19114,'36879','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15498,'30620','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32250,'56519','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(24340,'45424','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13031,'27705','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27333,'49312','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54917,'99524','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(24498,'45711','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18291,'35546','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28755,'51016','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40879,'70301','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52796,'95615','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52024,'94041','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34991,'60930','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32639,'57110','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29141,'52054','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6986,'16240','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9008,'20122','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25377,'46913','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14733,'29861','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23091,'43545','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43802,'74954','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40993,'70509','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33586,'58481','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22883,'43266','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4787,'12588','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13536,'28345','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42336,'72513','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52522,'95226','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48060,'81523','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43842,'75026','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38412,'65755','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19919,'38044','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10607,'23224','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5149,'13152','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18703,'36203','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2382,'06481','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26345,'48089','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7647,'17362','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42003,'72083','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31080,'55076','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23901,'44827','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20751,'39145','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1597,'04614','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2458,'06724','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34035,'59240','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32593,'57057','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12110,'25920','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12528,'26726','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16925,'32861','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14754,'29921','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47514,'80422','Gilpin','8047','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46177,'78332','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21114,'39668','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37765,'64776','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18423,'35749','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39501,'67649','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12118,'25938','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25546,'47060','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40551,'69027','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35215,'61254','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10483,'23068','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3128,'08344','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4242,'11701','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31355,'55454','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39280,'67442','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32004,'56284','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48617,'83655','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(11023,'24027','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14666,'29743','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50904,'91505','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50260,'89105','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49953,'88022','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(3962,'10703','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11875,'25425','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22654,'43011','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51031,'91948','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54484,'98544','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52452,'95115','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46320,'78579','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7504,'17094','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38098,'65401','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23201,'43755','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54443,'98493','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40233,'68746','Boyd','31015','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34628,'60185','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21477,'40310','Mercer','21167','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21856,'41045','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9462,'20841','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51961,'93790','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50499,'90041','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46050,'78131','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40284,'68779','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38051,'65326','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20111,'38340','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22749,'43081','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2150,'06058','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48823,'84076','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42299,'72458','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52281,'94612','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49274,'85295','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47722,'80808','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15163,'30295','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27481,'49461','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19253,'37086','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54932,'99556','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52200,'94529','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49155,'85062','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3089,'08245','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15039,'30183','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28356,'50449','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15367,'30515','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16045,'31561','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18073,'35096','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28041,'50124','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51304,'92369','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54487,'98547','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20432,'38721','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11009,'24016','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8530,'19115','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18738,'36272','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26737,'48618','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29783,'53121','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46611,'78946','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33918,'59022','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17976,'34994','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10020,'22135','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26061,'47740','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18309,'35559','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2921,'07930','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35592,'61734','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33433,'58341','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54899,'99505','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51673,'93272','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35411,'61462','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18661,'36091','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26812,'48710','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13354,'28120','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17143,'33196','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20400,'38663','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32803,'57339','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33289,'58072','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26428,'48173','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1944,'05473','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(50589,'90265','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36441,'62794','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15910,'31213','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45640,'77474','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40662,'69166','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1908,'05408','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1017,'03053','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6608,'15666','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17852,'34606','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26696,'48529','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22277,'42087','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12549,'26812','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20951,'39442','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40682,'69214','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1412,'04225','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51972,'93907','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36993,'63441','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34706,'60440','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20385,'38650','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8747,'19522','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21082,'39653','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50673,'90670','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37279,'63881','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17375,'33601','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5795,'14450','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31635,'55973','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24617,'45836','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16122,'31701','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10320,'22821','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39919,'68347','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34102,'59336','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20519,'38847','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2270,'06258','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47413,'80205','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42853,'73125','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4730,'12527','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14770,'29935','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38103,'65436','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53140,'96091','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52716,'95482','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50206,'89012','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46423,'78654','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14055,'29009','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18775,'36318','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47014,'79504','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45211,'76861','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38381,'65733','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40494,'68958','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25013,'46302','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24774,'46055','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30101,'53826','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30447,'54452','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17765,'34265','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49867,'87571','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(29380,'52354','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7251,'16720','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36032,'62311','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44485,'75886','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53874,'97449','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(23801,'44660','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9220,'20515','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20885,'39341','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34498,'60073','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34975,'60918','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38500,'66021','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54846,'99302','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51254,'92308','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20144,'38362','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15247,'30371','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6094,'14841','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29089,'51645','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48004,'81324','Dolores','8033','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7794,'17767','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40888,'70343','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6327,'15232','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18418,'35746','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25536,'47037','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9043,'20160','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10274,'22722','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10763,'23483','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28264,'50311','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53064,'96007','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16153,'31730','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5666,'14105','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51989,'93940','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37064,'63544','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36960,'63383','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35694,'61849','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31958,'56252','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30596,'54610','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31447,'55712','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53439,'96779','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(24817,'46104','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14204,'29161','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32058,'56326','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30853,'54862','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41490,'71307','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3829,'10280','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8651,'19374','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44724,'76202','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41656,'71603','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6443,'15417','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44005,'75189','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42786,'73064','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42203,'72366','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38120,'65453','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31344,'55442','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3646,'09823','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27183,'49087','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25741,'47336','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21636,'40505','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21018,'39535','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3131,'08344','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40788,'70067','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24524,'45735','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51809,'93553','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52913,'95759','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39720,'68018','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38589,'66103','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34328,'59761','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16662,'32503','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12046,'25802','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23329,'43950','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33140,'57738','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52334,'94924','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41383,'71156','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40442,'68930','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30391,'54412','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21635,'40504','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17700,'34134','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12329,'26343','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17069,'33109','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8437,'19017','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15195,'30322','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3305,'08844','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34058,'59259','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22404,'42323','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6975,'16229','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37880,'65047','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43523,'74451','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27277,'49257','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36205,'62467','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32157,'56397','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2636,'07081','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10481,'23066','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14371,'29440','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8249,'18616','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28420,'50514','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52141,'94285','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47208,'79842','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8829,'19804','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(55051,'99693','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48234,'82615','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(12600,'27024','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(10366,'22922','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11288,'24378','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34376,'59854','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45447,'77266','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34351,'59827','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33503,'58416','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22628,'42765','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24836,'46118','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6342,'15251','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16117,'31650','Atkinson','13003','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22755,'43086','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51349,'92506','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18479,'35893','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1382,'04095','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52532,'95233','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18467,'35806','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37306,'63945','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45953,'78019','La Salle','48283','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43204,'73842','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41203,'70775','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34941,'60684','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3239,'08721','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16249,'31806','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1665,'04742','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(25743,'47336','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27593,'49667','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35558,'61654','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28786,'51033','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28027,'50112','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2592,'07035','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51924,'93716','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2781,'07645','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33136,'57735','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39005,'67008','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41222,'70802','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49282,'85304','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44408,'75765','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39630,'67844','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11612,'24966','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27701,'49759','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44458,'75847','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32006,'56285','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52420,'95050','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12011,'25707','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37725,'64739','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50963,'91752','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52338,'94928','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46563,'78839','Zavala','48507','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44481,'75865','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12034,'25755','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(660,'02148','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4981,'12955','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29321,'52310','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26120,'47866','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3591,'09722','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9626,'21160','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13642,'28442','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39417,'67563','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37939,'65101','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25827,'47403','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40107,'68627','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33410,'58321','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33032,'57567','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23708,'44504','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10330,'22840','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11791,'25260','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16571,'32351','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27869,'49958','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25917,'47523','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10925,'23901','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23336,'43963','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33804,'58746','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53290,'96530','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52077,'94140','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51897,'93657','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51145,'92140','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50699,'90743','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48357,'83211','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(25800,'47373','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44732,'76210','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27651,'49720','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46190,'78349','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30282,'54151','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40749,'70001','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49364,'85530','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47867,'81045','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33982,'59079','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23351,'43977','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15143,'30284','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30756,'54758','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31107,'55106','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15899,'31204','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29330,'52318','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21966,'41224','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40336,'68823','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36227,'62481','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47677,'80722','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34003,'59108','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33001,'57537','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5732,'14223','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9087,'20212','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(50238,'89046','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(32729,'57265','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4414,'12047','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6746,'15841','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8623,'19342','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23510,'44201','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25858,'47441','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14210,'29166','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27704,'49762','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30407,'54423','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26585,'48410','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38657,'66414','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43608,'74602','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48526,'83523','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(13079,'27822','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28905,'51355','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51603,'93150','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47185,'79777','Ward','48475','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8414,'18976','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30085,'53809','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17063,'33092','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41427,'71235','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1031,'03079','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52693,'95456','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29678,'53024','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27100,'49026','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45284,'76955','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38998,'67002','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27730,'49785','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19980,'38119','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5623,'14052','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10737,'23443','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3,'00601','Adjuntas','72001','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(30809,'54822','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46101,'78218','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7069,'16365','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4656,'12448','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25572,'47120','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28787,'51034','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4096,'11216','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41911,'72020','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54367,'98361','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39158,'67152','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6150,'14886','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16619,'32435','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2109,'05907','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25526,'47030','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16170,'31750','Ben Hill','13017','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21197,'39825','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20136,'38357','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35631,'61761','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9687,'21240','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(46698,'79042','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44406,'75764','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42572,'72811','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10938,'23923','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19053,'36786','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30122,'53925','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4244,'11703','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19905,'38030','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27041,'48906','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41511,'71331','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20880,'39337','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35994,'62271','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39527,'67664','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1303,'03906','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8471,'19053','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7771,'17744','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15152,'30289','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17800,'34430','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47335,'80042','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2690,'07311','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46868,'79248','Cottle','48101','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41257,'70892','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34182,'59453','Wheatland','30107','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6630,'15685','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14047,'29001','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27043,'48909','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28976,'51503','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3592,'09723','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7882,'17883','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17165,'33283','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11336,'24464','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53210,'96205','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(40632,'69149','Deuel','31049','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15154,'30291','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9429,'20782','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29919,'53515','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4508,'12156','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23159,'43716','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20310,'38581','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20033,'38222','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7058,'16354','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36347,'62643','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41869,'71959','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44887,'76446','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9127,'20289','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14432,'29511','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7661,'17403','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39738,'68031','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54922,'99546','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(40433,'68924','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47671,'80654','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10937,'23922','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1904,'05404','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23875,'44809','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21793,'40962','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19110,'36877','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17779,'34277','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7427,'17030','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14108,'29058','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13242,'27983','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12611,'27041','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(12438,'26554','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35690,'61845','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43374,'74106','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22116,'41659','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1590,'04605','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40530,'68982','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52787,'95606','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9447,'20814','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24007,'45030','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13307,'28080','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27654,'49721','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2923,'07931','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30999,'55006','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26606,'48421','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21138,'39744','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15214,'30339','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11425,'24562','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51430,'92648','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29476,'52573','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(26861,'48754','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5216,'13321','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33381,'58267','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41216,'70788','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41349,'71104','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50668,'90651','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52134,'94277','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32235,'56501','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4999,'12976','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27369,'49332','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15246,'30370','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25888,'47462','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20868,'39330','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50359,'89415','Mineral','32021','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46852,'79235','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5839,'14488','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15647,'30809','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25899,'47470','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38352,'65713','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3121,'08330','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30115,'53920','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53933,'97528','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2999,'08053','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23542,'44233','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18537,'35978','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18515,'35961','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28616,'50648','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27899,'50011','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27414,'49404','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23253,'43821','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45335,'77048','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8961,'20067','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(28437,'50525','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38091,'65355','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26641,'48444','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45411,'77223','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25288,'46783','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19553,'37396','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29274,'52228','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40753,'70005','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11283,'24370','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49652,'87001','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44132,'75417','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39202,'67301','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25875,'47455','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29365,'52339','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7122,'16440','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52108,'94236','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2928,'07935','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2876,'07840','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31790,'56115','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10085,'22310','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12750,'27302','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28738,'51004','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14397,'29470','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22396,'42301','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20121,'38344','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18401,'35662','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35748,'61913','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52205,'94535','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33183,'57783','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24694,'45884','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12800,'27356','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(342,'01331','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36714,'62987','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47495,'80302','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48579,'83623','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41077,'70589','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8493,'19080','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23180,'43732','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22896,'43310','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34923,'60656','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41476,'71280','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41913,'72021','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45620,'77455','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50822,'91322','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11379,'24520','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48048,'81434','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54195,'98131','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11,'00612','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(38198,'65588','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12684,'27228','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1754,'04949','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9217,'20509','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(31467,'55733','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47180,'79768','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40928,'70404','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38804,'66701','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10037,'22192','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10482,'23067','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9855,'21754','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7125,'16442','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12005,'25702','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44643,'76084','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16191,'31773','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8180,'18445','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(932,'02832','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(12861,'27509','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47599,'80522','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54125,'98036','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10818,'23691','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22997,'43439','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15169,'30302','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2048,'05770','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(35073,'61016','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30686,'54703','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6793,'15931','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22525,'42528','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19792,'37865','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3898,'10521','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1319,'04011','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19516,'37366','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11803,'25271','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13230,'27969','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13451,'28253','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22038,'41502','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29415,'52531','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27952,'50049','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22120,'41667','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5074,'13069','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3911,'10538','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51474,'92712','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32048,'56318','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29851,'53202','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42008,'72086','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37380,'64064','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11772,'25239','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31849,'56159','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16852,'32766','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54199,'98136','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54601,'98801','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53000,'95941','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40811,'70092','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38282,'65648','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53831,'97401','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52817,'95631','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37339,'64016','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6939,'16153','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8167,'18433','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27504,'49528','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13982,'28754','Madison','37115','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33405,'58317','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36337,'62633','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9072,'20192','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18855,'36460','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25597,'47138','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36038,'62314','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29848,'53194','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54884,'99360','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53982,'97722','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50405,'89506','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44725,'76203','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15000,'30153','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7855,'17851','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18526,'35968','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6091,'14839','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49474,'85725','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44296,'75631','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1361,'04070','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29613,'52766','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21340,'40071','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44191,'75457','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36512,'62851','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10726,'23432','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8015,'18077','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11374,'24506','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18915,'36545','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31325,'55424','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8048,'18211','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23761,'44628','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33524,'58431','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38277,'65646','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1794,'05030','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(55166,'99927','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(41155,'70722','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40472,'68945','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31716,'56051','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28678,'50831','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9233,'20532','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5757,'14304','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32775,'57322','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24589,'45813','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13758,'28570','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46552,'78828','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47626,'80547','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50681,'90707','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55010,'99652','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(55056,'99702','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(3074,'08220','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14027,'28793','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41125,'70655','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40093,'68601','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5804,'14462','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20888,'39346','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22103,'41640','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22645,'43006','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27607,'49679','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21274,'40014','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25519,'47019','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1482,'04358','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21610,'40461','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45108,'76670','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55060,'99706','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46309,'78568','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42446,'72638','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36596,'62902','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13100,'27837','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16973,'32952','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6192,'15022','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4265,'11729','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40614,'69138','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37405,'64082','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9275,'20590','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(13112,'27849','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26903,'48809','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28374,'50459','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53678,'97207','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53303,'96548','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49571,'86303','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(15970,'31415','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36830,'63112','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34448,'60015','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8231,'18540','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1588,'04578','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12058,'25831','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39415,'67561','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14188,'29143','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2349,'06423','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3524,'09574','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20009,'38166','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50234,'89042','Lincoln','32017','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43937,'75119','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38079,'65348','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21121,'39704','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2168,'06076','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3643,'09820','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21836,'41031','Harrison','21097','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15731,'31016','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15481,'30601','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42283,'72443','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53567,'97033','Sherman','41055','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54245,'98224','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6707,'15773','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33173,'57772','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35011,'60946','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10779,'23514','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4795,'12602','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19216,'37061','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16286,'31833','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24689,'45881','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48068,'81611','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1704,'04850','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33302,'58106','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10172,'22530','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21424,'40221','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37318,'63960','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47954,'81154','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(778,'02474','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25726,'47325','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13588,'28386','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24482,'45690','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15103,'30248','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15284,'30427','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36289,'62557','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41123,'70653','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49585,'86327','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32247,'56517','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35709,'61856','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17685,'34106','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16872,'32791','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16717,'32572','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26804,'48674','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26478,'48225','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13709,'28521','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22681,'43029','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44514,'75942','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47370,'80121','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5377,'13624','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(604,'02052','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9569,'21062','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9485,'20875','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27092,'49020','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47587,'80511','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8956,'20062','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7120,'16438','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22127,'41714','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37946,'65107','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42011,'72087','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46055,'78140','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31817,'56134','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22964,'43358','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16468,'32208','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34190,'59461','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37225,'63821','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40076,'68517','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42782,'73062','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55114,'99767','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9312,'20629','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19229,'37070','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31437,'55702','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38880,'66780','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17366,'33593','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13590,'28387','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14467,'29563','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2435,'06608','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24287,'45365','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21052,'39595','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3880,'10505','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34822,'60538','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54615,'98823','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54633,'98845','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28988,'51528','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28815,'51052','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18487,'35901','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38056,'65330','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38928,'66864','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14575,'29652','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39868,'68316','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48573,'83616','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51412,'92614','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32461,'56742','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33226,'58031','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19160,'37028','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47860,'81039','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44706,'76166','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6452,'15427','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1432,'04257','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15479,'30601','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32104,'56353','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30152,'53946','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7662,'17404','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9468,'20850','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37052,'63535','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35410,'61462','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18066,'35089','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16616,'32432','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5175,'13206','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53463,'96806','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(46730,'79063','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42779,'73059','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8842,'19891','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(34930,'60668','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36904,'63333','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43455,'74347','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54399,'98394','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32642,'57186','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21965,'41222','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10102,'22403','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3964,'10705','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32166,'56431','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52324,'94901','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51178,'92186','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46587,'78884','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45847,'77856','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42263,'72427','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52269,'94599','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13545,'28353','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50535,'90077','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33584,'58480','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15441,'30558','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1454,'04287','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17809,'34442','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28416,'50510','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21252,'40003','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(169,'00950','Toa Baja','72137','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(32091,'56343','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8049,'18211','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38350,'65711','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39976,'68404','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28688,'50840','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51768,'93502','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49291,'85318','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42302,'72459','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53673,'97203','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(55145,'99825','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25071,'46383','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25405,'46932','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15220,'30343','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25752,'47342','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45468,'77293','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55026,'99668','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(10518,'23110','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40762,'70033','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40420,'68882','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52780,'95595','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35769,'61933','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17713,'34142','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21824,'41012','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9710,'21297','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35707,'61855','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(164,'00936','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(41884,'71973','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40707,'69335','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35183,'61114','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12933,'27563','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1940,'05469','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23808,'44666','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8725,'19493','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24570,'45788','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32449,'56733','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7556,'17231','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17701,'34134','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7473,'17067','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36868,'63140','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49614,'86429','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31114,'55111','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28895,'51345','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7738,'17604','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43213,'73851','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15278,'30424','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7477,'17070','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8381,'18934','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27112,'49036','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50313,'89158','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49157,'85064','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37623,'64632','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22865,'43221','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7451,'17052','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30956,'54964','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23462,'44114','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25962,'47574','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11518,'24737','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10974,'23962','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42335,'72513','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46968,'79373','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28167,'50229','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17295,'33486','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26569,'48374','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5878,'14532','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35952,'62244','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40007,'68431','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1308,'03911','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31432,'55614','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(55035,'99677','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48141,'82081','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(1604,'04624','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6224,'15057','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3417,'09214','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(31099,'55090','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8282,'18653','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21958,'41203','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18911,'36541','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21466,'40291','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28997,'51532','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16654,'32464','Holmes','12059','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45952,'78017','Frio','48163','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21050,'39577','Stone','28131','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21571,'40403','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50770,'91114','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50232,'89040','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44679,'76119','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37706,'64720','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12340,'26361','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11798,'25267','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7144,'16530','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46996,'79416','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10889,'23867','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32864,'57379','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4506,'12155','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12877,'27520','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6745,'15840','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38279,'65648','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52792,'95611','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25609,'47146','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11608,'24954','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1695,'04785','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39103,'67108','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42979,'73506','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51189,'92201','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52457,'95120','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2915,'07921','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14109,'29059','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1990,'05664','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(10339,'22847','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17191,'33324','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10797,'23606','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20396,'38659','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53250,'96349','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(32121,'56363','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(48606,'83644','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2198,'06108','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16121,'31701','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9459,'20837','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33713,'58638','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31435,'55616','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11830,'25324','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37268,'63870','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53074,'96019','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52640,'95387','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44973,'76524','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40180,'68702','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22943,'43343','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28000,'50076','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8901,'19980','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(9382,'20726','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31198,'55334','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53693,'97219','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30360,'54301','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6737,'15829','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24305,'45380','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39341,'67487','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35581,'61728','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24049,'45107','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23058,'43519','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32173,'56435','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(47966,'81222','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44274,'75571','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43489,'74422','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40706,'69335','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29979,'53556','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1738,'04930','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8297,'18706','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14534,'29624','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50581,'90251','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44154,'75434','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19967,'38105','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1166,'03581','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30107,'53911','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40043,'68457','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52036,'94074','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17324,'33541','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38008,'65264','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13665,'28456','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4336,'11932','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29067,'51591','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15079,'30228','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48147,'82083','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(40290,'68781','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13857,'28645','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6997,'16253','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3418,'09226','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(1720,'04903','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24553,'45771','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28526,'50586','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14257,'29290','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18594,'36033','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46547,'78799','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41172,'70740','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(23168,'43724','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8869,'19945','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(53099,'96048','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49062,'84742','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43461,'74354','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39283,'67444','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13699,'28512','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8750,'19525','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8951,'20057','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42041,'72118','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46562,'78839','Dimmit','48127','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18640,'36069','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29294,'52247','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51740,'93441','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21931,'41159','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18275,'35501','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33856,'58787','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32649,'57212','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7435,'17038','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4822,'12742','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47350,'80105','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49053,'84733','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(32851,'57371','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24521,'45732','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29501,'52594','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16141,'31714','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18239,'35456','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11163,'24179','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9898,'21794','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24445,'45660','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6521,'15533','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4282,'11751','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39232,'67353','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39901,'68337','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49080,'84761','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5082,'13077','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53359,'96675','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49158,'85065','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26201,'47949','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1862,'05158','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11259,'24328','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54927,'99551','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50865,'91381','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46981,'79401','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32164,'56430','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30606,'54618','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4457,'12090','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12993,'27613','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20127,'38351','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48537,'83536','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(8489,'19075','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2398,'06504','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50541,'90083','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41443,'71251','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1632,'04664','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19694,'37754','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(265,'01083','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28087,'50151','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26507,'48275','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25207,'46706','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25135,'46540','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13549,'28357','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5433,'13681','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42463,'72651','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43299,'74037','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51356,'92516','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31979,'56265','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2508,'06828','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3808,'10242','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22128,'41719','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21810,'41002','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20201,'38459','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17123,'33173','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13650,'28447','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12152,'26034','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34931,'60669','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53709,'97231','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25992,'47613','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24185,'45270','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22144,'41743','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26925,'48825','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52633,'95380','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52679,'95439','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27794,'49863','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19874,'37998','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37540,'64458','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54308,'98291','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(855,'02667','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1474,'04349','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4670,'12460','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12802,'27357','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13617,'28420','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26486,'48233','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16284,'31832','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15241,'30363','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27749,'49808','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10469,'23056','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32407,'56679','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31293,'55396','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31097,'55089','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14357,'29431','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18644,'36071','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38838,'66748','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49888,'87715','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(8197,'18459','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17364,'33587','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39834,'68152','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40971,'70458','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44893,'76450','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4623,'12412','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47063,'79538','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33980,'59078','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16709,'32565','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17115,'33164','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21259,'40008','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20253,'38541','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19176,'37036','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34600,'60157','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35013,'60948','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39437,'67576','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40013,'68437','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40099,'68621','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42567,'72774','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44446,'75838','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52189,'94518','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9893,'21790','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53058,'95993','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26361,'48105','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52446,'95108','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40568,'69038','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16645,'32457','Gulf','12045','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6821,'15960','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33442,'58346','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27735,'49793','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12251,'26224','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14469,'29565','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15593,'30721','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36071,'62351','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37605,'64601','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40419,'68882','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54177,'98109','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23795,'44656','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12515,'26710','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52535,'95236','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54909,'99516','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(2143,'06043','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7762,'17730','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36815,'63091','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47231,'79911','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49105,'85004','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2576,'07018','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34669,'60409','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36341,'62638','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42386,'72560','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43823,'75007','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44374,'75703','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4540,'12192','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24124,'45206','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13455,'28258','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12999,'27619','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8068,'18235','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31544,'55902','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9886,'21783','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(46731,'79064','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39870,'68317','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37096,'63567','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6757,'15857','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33340,'58228','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9936,'21857','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30200,'54005','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4619,'12407','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14274,'29323','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53904,'97484','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45368,'77080','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36638,'62930','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36533,'62865','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35380,'61438','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4511,'12159','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18643,'36071','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22493,'42450','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35659,'61815','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13533,'28343','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51320,'92392','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22540,'42565','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50041,'88242','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45565,'77402','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32128,'56369','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31562,'55920','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14370,'29440','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7233,'16683','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25472,'46980','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16227,'31793','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41318,'71064','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44760,'76249','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19258,'37088','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24478,'45687','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21275,'40018','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48710,'83842','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39542,'67701','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33185,'57785','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31354,'55450','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22922,'43330','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4247,'11706','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2896,'07866','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18061,'35083','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54649,'98860','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35505,'61555','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51295,'92356','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25063,'46375','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39765,'68057','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51506,'92837','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48786,'84042','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42001,'72081','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39218,'67344','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9969,'22015','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25200,'46702','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28014,'50106','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6882,'16058','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11607,'24951','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21723,'40803','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40366,'68843','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35064,'61011','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38979,'66955','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35334,'61376','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53714,'97238','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(8581,'19176','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50134,'88529','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(3428,'09267','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(1301,'03904','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21883,'41076','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23697,'44486','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27207,'49103','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29956,'53537','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30333,'54213','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2350,'06424','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41446,'71254','East Carroll','22035','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6907,'16120','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32315,'56573','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53724,'97269','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49551,'86031','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45153,'76798','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44780,'76266','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40059,'68465','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21549,'40379','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23341,'43971','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25189,'46619','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4125,'11251','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29337,'52322','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36819,'63102','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7602,'17309','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46584,'78880','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16449,'32181','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3169,'08525','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18993,'36703','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(976,'02898','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(2427,'06538','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5606,'14034','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32689,'57238','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49001,'84633','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48662,'83725','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45869,'77875','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13392,'28164','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39881,'68324','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1703,'04849','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3420,'09229','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16495,'32234','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6138,'14878','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7007,'16261','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22616,'42754','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(696,'02238','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29127,'52042','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27806,'49877','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21167,'39759','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3563,'09631','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(41195,'70765','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37259,'63860','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31711,'56048','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14319,'29379','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27718,'49775','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35125,'61062','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44662,'76103','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14039,'28901','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6427,'15370','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18846,'36453','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48203,'82423','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44544,'75974','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18234,'35447','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37073,'63549','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9052,'20171','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21363,'40119','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53950,'97603','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47612,'80535','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44334,'75661','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42668,'72948','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1163,'03579','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27782,'49849','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17113,'33162','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12186,'26136','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36578,'62891','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19469,'37336','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19698,'37756','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(57,'00703','Aguas Buenas','72007','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3253,'08740','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54441,'98481','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52052,'94111','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37979,'65243','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4799,'12719','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6946,'16157','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7200,'16655','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7033,'16332','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14543,'29630','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30274,'54139','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34838,'60548','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2308,'06365','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40296,'68785','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13241,'27982','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18864,'36474','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46574,'78860','Maverick','48323','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44910,'76462','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41790,'71838','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41717,'71678','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40618,'69142','Thomas','31171','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37115,'63627','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11314,'24433','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14746,'29912','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30477,'54470','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2092,'05861','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24158,'45241','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17017,'33027','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20711,'39094','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44021,'75215','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54881,'99356','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2414,'06519','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5685,'14134','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24280,'45356','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47958,'81201','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19976,'38115','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45495,'77336','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11036,'24042','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44661,'76102','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39292,'67448','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31960,'56253','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20925,'39402','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26788,'48653','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16299,'31917','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29562,'52720','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2114,'06011','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16880,'32799','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28145,'50216','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23197,'43749','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15081,'30229','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41752,'71762','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21033,'39567','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20291,'38569','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7003,'16258','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23709,'44504','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41422,'71232','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21693,'40621','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28733,'51002','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19126,'36922','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42605,'72846','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24768,'46050','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27446,'49428','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13337,'28106','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5011,'12989','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50765,'91106','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49620,'86435','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37212,'63781','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20235,'38483','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52365,'94965','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42919,'73403','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37473,'64164','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34043,'59248','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52898,'95717','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32678,'57233','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45079,'76648','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23022,'43463','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52117,'94249','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49649,'86545','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39476,'67637','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36697,'62970','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35850,'62054','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4947,'12914','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4269,'11733','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12687,'27231','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10220,'22620','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24242,'45331','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23747,'44621','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8846,'19895','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(10149,'22485','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21567,'40392','Clark','21049','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44547,'75975','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37777,'64784','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47115,'79698','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41948,'72041','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20882,'39338','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34400,'59911','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52282,'94613','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44567,'76011','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7798,'17772','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7592,'17271','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17538,'33854','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18378,'35632','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24897,'46163','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(780,'02476','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44529,'75960','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33082,'57642','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14365,'29436','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32604,'57063','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24993,'46266','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25157,'46562','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15136,'30276','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2758,'07544','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28155,'50222','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29300,'52253','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2169,'06076','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27456,'49440','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35058,'61006','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32712,'57256','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50053,'88263','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45945,'78013','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43632,'74651','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18068,'35091','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17306,'33510','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2814,'07720','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8265,'18629','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29804,'53146','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25051,'46361','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22381,'42266','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10923,'23899','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23639,'44412','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54178,'98110','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52663,'95422','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47218,'79853','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37152,'63656','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32119,'56362','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31477,'55745','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48023,'81410','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23412,'44062','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4679,'12469','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24016,'45042','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3335,'08882','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(531,'01863','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23621,'44328','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22083,'41601','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50082,'88344','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(11768,'25235','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30278,'54143','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4100,'11220','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18391,'35652','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33541,'58444','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46752,'79080','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44932,'76474','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44558,'76003','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44478,'75862','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36168,'62445','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10416,'22972','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48777,'84034','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50532,'90074','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43195,'73838','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2275,'06264','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54068,'97883','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(39016,'67019','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32694,'57242','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(55012,'99654','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(5611,'14037','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2083,'05849','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3063,'08204','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26377,'48121','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48050,'81501','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18416,'35744','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16550,'32331','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4435,'12066','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20164,'38376','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39564,'67740','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38608,'66204','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17250,'33436','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24528,'45741','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45067,'76636','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12418,'26520','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45774,'77624','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11138,'24147','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11802,'25270','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30237,'54107','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35846,'62052','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37222,'63801','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19617,'37662','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29212,'52164','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28726,'50950','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26777,'48647','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27694,'49755','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51282,'92337','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48694,'83825','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39707,'68004','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21797,'40972','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25706,'47281','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24522,'45734','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54250,'98229','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49912,'87753','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45811,'77709','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34317,'59751','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4127,'11256','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3017,'08072','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31669,'56013','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9563,'21053','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7566,'17240','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38678,'66432','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30569,'54554','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31408,'55587','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34457,'60022','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33467,'58368','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37272,'63874','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3773,'10151','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27938,'50042','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52546,'95252','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53781,'97348','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43216,'73852','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19972,'38111','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7972,'18040','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30631,'54635','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3797,'10175','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27384,'49340','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22554,'42635','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33214,'58016','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40743,'69361','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33790,'58735','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36067,'62347','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5759,'14410','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35416,'61466','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2117,'06018','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29849,'53195','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40764,'70037','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33168,'57766','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9773,'21632','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4317,'11791','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10857,'23834','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31488,'55752','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15928,'31305','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20961,'39455','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19255,'37087','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31226,'55350','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27953,'50050','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43000,'73533','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27098,'49023','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39948,'68366','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25326,'46809','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5729,'14220','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26523,'48312','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5420,'13669','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5214,'13319','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2211,'06127','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38921,'66859','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40830,'70127','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43087,'73655','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43362,'74083','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49236,'85234','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49343,'85373','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7574,'17250','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44778,'76265','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14693,'29827','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39588,'67756','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36188,'62458','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22067,'41553','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19670,'37727','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42927,'73435','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33007,'57543','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32626,'57077','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9671,'21228','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17088,'33136','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19879,'38004','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39971,'68381','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13627,'28431','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6451,'15425','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42542,'72751','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35632,'61764','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42039,'72116','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10230,'22630','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15302,'30442','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15542,'30650','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25951,'47558','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8058,'18222','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30560,'54545','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46205,'78362','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42643,'72927','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19717,'37774','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47039,'79526','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44144,'75425','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15623,'30746','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52722,'95492','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22714,'43061','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29304,'52254','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30974,'54977','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8907,'20006','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7858,'17855','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54521,'98586','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12181,'26120','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45092,'76655','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31183,'55328','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14527,'29617','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18842,'36449','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45400,'77210','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11858,'25392','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1428,'04253','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17475,'33766','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50526,'90068','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48876,'84132','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(20822,'39213','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16448,'32180','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6796,'15936','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7618,'17324','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46798,'79108','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44119,'75403','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33829,'58763','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26279,'48007','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28658,'50674','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10345,'22853','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36101,'62375','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33638,'58541','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25976,'47585','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3888,'10511','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31211,'55340','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5974,'14708','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31630,'55971','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8067,'18235','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23849,'44705','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16282,'31831','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52764,'95559','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45078,'76645','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40470,'68944','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39701,'68002','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39129,'67124','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29675,'53022','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37960,'65216','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3012,'08067','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21221,'39845','Miller','13201','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22857,'43213','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46194,'78353','Brooks','48047','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40564,'69034','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38783,'66615','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36976,'63433','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34834,'60544','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11097,'24111','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23979,'44889','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10728,'23434','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2149,'06057','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29111,'52032','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51037,'91977','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12970,'27594','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11337,'24465','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25585,'47129','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24552,'45770','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16866,'32781','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2851,'07765','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10494,'23083','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43007,'73540','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31832,'56144','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3706,'10022','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17179,'33312','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10140,'22473','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27716,'49774','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(642,'02128','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29816,'53156','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27731,'49786','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12339,'26354','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40802,'70082','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40845,'70152','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42629,'72905','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12621,'27047','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11390,'24528','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43551,'74521','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40042,'68456','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25553,'47107','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27653,'49721','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4578,'12239','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38993,'66966','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36015,'62286','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34249,'59601','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(10465,'23047','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8626,'19344','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7698,'17540','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38468,'65806','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31818,'56136','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(13929,'28709','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29535,'52645','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12868,'27516','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33431,'58338','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50210,'89016','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50051,'88260','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40082,'68526','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29854,'53205','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7932,'17978','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18969,'36625','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21853,'41043','Pendleton','21191','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46960,'79369','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46760,'79083','Hansford','48195','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20301,'38574','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47863,'81041','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39010,'67013','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35282,'61333','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11885,'25437','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30508,'54494','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3596,'09727','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12422,'26525','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12722,'27265','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41004,'70517','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53819,'97384','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48216,'82443','Hot Springs','56017','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(38945,'66901','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35764,'61929','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13269,'28032','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14288,'29335','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24236,'45327','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26597,'48417','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27926,'50033','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18637,'36067','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29859,'53210','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17697,'34119','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9633,'21202','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54888,'99362','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23871,'44805','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11306,'24422','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30126,'53926','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31098,'55089','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17445,'33713','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7041,'16341','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(137,'00908','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(43453,'74347','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1367,'04077','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32870,'57382','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50150,'88546','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(49017,'84651','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45725,'77553','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39752,'68045','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25964,'47576','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21263,'40009','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5343,'13493','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11949,'25572','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16706,'32563','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(636,'02122','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29132,'52047','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52471,'95134','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35652,'61810','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34809,'60523','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28557,'50606','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43101,'73666','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54355,'98350','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35119,'61057','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38726,'66524','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41886,'71998','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42669,'72949','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17830,'34476','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44801,'76308','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38841,'66753','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12134,'25977','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3579,'09708','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29605,'52759','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6694,'15760','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1624,'04652','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51348,'92505','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48501,'83445','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(23330,'43950','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34622,'60179','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40368,'68844','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36499,'62839','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46991,'79411','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14738,'29904','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5255,'13363','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9176,'20419','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(13718,'28527','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54094,'98004','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47319,'80023','Broomfield','8014','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10161,'22513','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9146,'20375','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7943,'18002','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19345,'37171','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27058,'48930','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25860,'47445','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4594,'12260','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55105,'99758','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(18534,'35976','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48935,'84334','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(13249,'28007','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16760,'32643','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27381,'49338','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29231,'52204','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3148,'08404','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47523,'80432','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47236,'79916','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43668,'74750','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40245,'68753','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38209,'65604','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13264,'28025','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33153,'57752','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9790,'21651','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43301,'74038','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20275,'38557','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18917,'36548','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20692,'39079','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8936,'20041','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(54573,'98645','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38149,'65534','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2984,'08037','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29276,'52231','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29455,'52561','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30510,'54494','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19334,'37153','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19936,'38058','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8361,'18915','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14647,'29717','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38372,'65727','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52389,'95010','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50422,'89557','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43451,'74346','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40953,'70444','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40415,'68878','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32808,'57342','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22624,'42762','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27519,'49610','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16160,'31738','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25765,'47353','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30060,'53778','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29355,'52333','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28771,'51025','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9967,'22003','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27766,'49829','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(567,'01944','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31509,'55780','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23281,'43902','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43425,'74192','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35346,'61413','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34906,'60637','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5289,'13431','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9407,'20755','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37935,'65084','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35516,'61565','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5820,'14475','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14507,'29597','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34589,'60148','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21218,'39842','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9690,'21250','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17804,'34433','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10805,'23661','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28380,'50464','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2638,'07083','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1139,'03448','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28381,'50464','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13975,'28748','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39702,'68003','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37858,'65026','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12402,'26448','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23235,'43783','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7519,'17112','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26287,'48022','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17607,'33938','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2856,'07806','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19028,'36759','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11033,'24037','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22864,'43220','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2680,'07207','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54376,'98371','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23364,'44003','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38434,'65772','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12928,'27560','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15488,'30606','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50787,'91201','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50291,'89136','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47524,'80433','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12560,'26847','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1646,'04681','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29356,'52333','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16287,'31836','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8201,'18462','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30546,'54536','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28608,'50643','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35874,'62075','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13158,'27885','Hyde','37095','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30656,'54654','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44397,'75757','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46026,'78111','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10686,'23341','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47873,'81049','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47775,'80903','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38889,'66834','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38354,'65714','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31719,'56054','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44883,'76445','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21,'00636','San German','72125','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(2868,'07831','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18014,'35035','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9754,'21607','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9706,'21287','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11956,'25612','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1644,'04679','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31700,'56041','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33392,'58276','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34389,'59870','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38353,'65713','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27260,'49246','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44341,'75668','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42118,'72199','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18477,'35816','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46241,'78404','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32425,'56713','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27705,'49764','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12898,'27534','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28551,'50603','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45884,'77951','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45815,'77725','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45624,'77459','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33737,'58649','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26274,'48003','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34898,'60628','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53691,'97219','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52595,'95340','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9223,'20522','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(15362,'30512','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51106,'92093','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34887,'60616','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33339,'58227','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14159,'29117','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4622,'12411','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16107,'31643','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5339,'13489','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17747,'34233','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36621,'62919','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51398,'92592','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53994,'97739','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32915,'57442','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48509,'83451','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36002,'62275','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31731,'56063','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13215,'27950','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31008,'55012','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5960,'14644','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49530,'85941','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6686,'15752','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14724,'29848','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1831,'05071','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13362,'28127','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17164,'33280','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54085,'97911','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37578,'64489','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51027,'91944','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1935,'05463','Grand Isle','50013','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(38490,'66013','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44138,'75422','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30892,'54913','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11429,'24565','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10464,'23047','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28331,'50433','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23035,'43502','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35587,'61731','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41786,'71835','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49115,'85014','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2688,'07308','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9970,'22025','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12160,'26041','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35578,'61726','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43089,'73658','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44203,'75472','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44443,'75833','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51112,'92105','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5134,'13139','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1610,'04630','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44792,'76301','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30155,'53947','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5744,'14263','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21100,'39664','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20648,'38967','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18263,'35477','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17982,'35005','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17764,'34264','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38429,'65769','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42954,'73453','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47891,'81067','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18216,'35298','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8102,'18326','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11977,'25652','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33537,'58442','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53454,'96796','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50955,'91743','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36199,'62464','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34563,'60132','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3529,'09579','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(483,'01745','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23908,'44833','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12131,'25976','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16733,'32608','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15158,'30294','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13459,'28263','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42154,'72319','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44639,'76078','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11881,'25431','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25762,'47352','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5153,'13156','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51600,'93121','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53884,'97458','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(527,'01853','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32612,'57069','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42992,'73529','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46067,'78150','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25324,'46807','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10072,'22245','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20962,'39455','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19483,'37347','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33736,'58647','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34839,'60548','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(954,'02873','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(11341,'24471','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19091,'36860','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53676,'97206','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30549,'54538','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30070,'53791','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29347,'52327','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34650,'60290','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41434,'71240','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48043,'81430','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(28008,'50104','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42676,'72956','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46833,'79225','Hardeman','48197','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17292,'33482','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23463,'44115','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36886,'63167','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52983,'95924','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2280,'06269','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10445,'23023','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7632,'17342','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13266,'28027','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24733,'46017','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23890,'44820','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39426,'67567','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39445,'67583','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41510,'71330','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45371,'77082','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48470,'83404','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(11643,'25028','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32622,'57075','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28858,'51235','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9125,'20270','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8467,'19048','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8112,'18335','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36183,'62451','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2863,'07827','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51789,'93528','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46526,'78756','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9946,'21872','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9298,'20616','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25935,'47541','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19758,'37830','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15802,'31054','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4230,'11582','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4486,'12134','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44596,'76040','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48018,'81401','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48951,'84409','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(22604,'42743','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9344,'20684','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12793,'27344','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31819,'56136','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49966,'88036','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46137,'78253','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11330,'24457','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7775,'17748','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12703,'27249','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42470,'72659','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42709,'73016','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54215,'98168','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34883,'60612','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44839,'76384','Foard','48155','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45941,'78009','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50278,'89123','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52148,'94293','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52825,'95638','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10896,'23875','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31143,'55165','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29933,'53521','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9058,'20180','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38599,'66113','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50812,'91308','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(856,'02668','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24264,'45344','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21864,'41053','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52111,'94240','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45736,'77568','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14682,'29817','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3348,'08906','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24960,'46231','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7933,'17978','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13305,'28079','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16565,'32345','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40416,'68878','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42895,'73164','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48093,'81638','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53227,'96276','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53840,'97410','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(16809,'32712','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35182,'61114','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41335,'71073','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40192,'68718','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39063,'67053','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34484,'60053','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28723,'50936','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27516,'49601','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24740,'46033','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42600,'72842','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45716,'77545','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46094,'78211','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20441,'38732','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(473,'01705','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20038,'38226','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4505,'12155','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26665,'48462','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47926,'81126','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12100,'25907','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20841,'39296','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13783,'28584','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39678,'67877','Haskell','20081','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42276,'72436','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47257,'79937','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51119,'92112','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19225,'37066','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16840,'32752','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31116,'55113','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53595,'97060','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(39796,'68109','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36361,'62663','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(516,'01834','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2564,'07006','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29107,'52004','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26083,'47834','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22932,'43335','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10055,'22212','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52258,'94587','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(744,'02366','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1606,'04626','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19304,'37135','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6665,'15728','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53834,'97404','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49480,'85733','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47502,'80309','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14584,'29656','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16134,'31711','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24809,'46076','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19585,'37602','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20642,'38964','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54533,'98601','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47542,'80453','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42495,'72686','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7247,'16699','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8380,'18933','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31753,'56080','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31281,'55389','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24696,'45885','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22929,'43333','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5115,'13118','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55098,'99751','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25266,'46766','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11705,'25119','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22301,'42133','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36386,'62682','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52050,'94109','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47643,'80620','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41395,'71207','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39882,'68325','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1415,'04228','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32906,'57436','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32262,'56531','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28237,'50268','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10953,'23939','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6844,'16028','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35296,'61342','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33049,'57585','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43718,'74849','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51456,'92685','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53233,'96309','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52549,'95255','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10406,'22965','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26897,'48805','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41114,'70645','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42086,'72153','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13652,'28447','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16598,'32413','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24190,'45277','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22450,'42369','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19294,'37127','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45878,'77903','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46919,'79339','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30943,'54952','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3232,'08666','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26207,'47952','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53189,'96142','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4492,'12141','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30430,'54440','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25574,'47122','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51020,'91932','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7563,'17238','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26898,'48806','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23000,'43442','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50971,'91763','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52812,'95627','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32224,'56477','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9889,'21784','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22618,'42755','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36018,'62292','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31998,'56281','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28342,'50438','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1710,'04856','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44420,'75782','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49358,'85390','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(514,'01832','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35383,'61440','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20442,'38733','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22329,'42167','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2067,'05830','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12704,'27249','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43906,'75087','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55112,'99765','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(11682,'25082','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1714,'04861','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(49435,'85645','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44377,'75706','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29429,'52540','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15337,'30471','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22684,'43031','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43536,'74462','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9032,'20147','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26791,'48655','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42948,'73447','Marshall','40095','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31600,'55951','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9896,'21792','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36488,'62835','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5004,'12981','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29658,'53013','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23804,'44662','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7888,'17889','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45917,'77989','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47817,'80945','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51888,'93650','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2951,'08003','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9326,'20656','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28890,'51341','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18257,'35471','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17372,'33597','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40178,'68701','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49892,'87724','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53768,'97335','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6173,'15003','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49134,'85033','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10242,'22646','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8522,'19107','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27517,'49601','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6156,'14891','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3258,'08752','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20237,'38485','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4605,'12306','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41814,'71860','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48107,'81650','Rio Blanco','8103','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6041,'14784','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6346,'15255','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13598,'28394','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19831,'37887','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54953,'99580','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(10856,'23833','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3843,'10309','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31439,'55704','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50270,'89115','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(34652,'60302','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20976,'39465','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22582,'42720','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28305,'50381','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2161,'06069','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(13320,'28090','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14326,'29401','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29116,'52035','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18218,'35402','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20595,'38926','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41607,'71447','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41893,'72004','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44774,'76262','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54118,'98029','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11238,'24312','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(55162,'99922','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(27108,'49032','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50697,'90740','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37533,'64454','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35034,'60959','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19323,'37146','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21957,'41201','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10197,'22560','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22578,'42718','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23269,'43837','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36641,'62932','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37625,'64633','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44076,'75287','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49500,'85752','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49512,'85923','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10256,'22663','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33200,'58001','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2217,'06134','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5964,'14650','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49662,'87011','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41844,'71933','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18518,'35962','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16154,'31730','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2778,'07642','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29303,'52253','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4974,'12944','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15708,'31005','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39353,'67505','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43313,'74047','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53097,'96046','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10755,'23464','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(55097,'99750','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54551,'98619','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49349,'85379','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34674,'60415','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15694,'30909','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3694,'10009','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13046,'27717','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12475,'26617','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(146,'00917','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(34603,'60161','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8499,'19085','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35362,'61421','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43202,'73842','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10887,'23866','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22746,'43080','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1258,'03847','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21326,'40063','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5643,'14069','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11882,'25432','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34446,'60014','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35806,'62012','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1531,'04461','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22159,'41773','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7651,'17366','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18715,'36255','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13202,'27936','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39268,'67431','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47020,'79510','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31397,'55576','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24196,'45302','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20765,'39157','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(411,'01518','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5170,'13201','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36279,'62551','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43252,'74006','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47012,'79503','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8109,'18332','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23225,'43773','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7629,'17337','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41338,'71075','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49066,'84746','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53851,'97424','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7930,'17974','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41724,'71721','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50749,'91024','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20212,'38468','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13551,'28358','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14409,'29481','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34815,'60530','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35434,'61476','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28391,'50470','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5896,'14546','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17045,'33065','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16548,'32330','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47697,'80741','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9965,'21922','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31239,'55361','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9103,'20229','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(47398,'80138','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48131,'82058','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(55048,'99690','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(2209,'06123','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20236,'38485','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27542,'49629','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9074,'20195','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31177,'55321','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29671,'53020','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6196,'15026','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33840,'58773','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33399,'58301','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32185,'56446','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32113,'56359','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5347,'13501','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4987,'12961','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25928,'47532','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35145,'61075','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45593,'77434','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54655,'98904','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28326,'50430','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13923,'28702','Swain','37173','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14182,'29137','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17788,'34288','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1949,'05479','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17829,'34475','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39475,'67637','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50023,'88136','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(440,'01566','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4666,'12457','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27885,'49971','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24799,'46070','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43669,'74752','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37861,'65034','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24099,'45158','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21506,'40342','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8858,'19931','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(31776,'56096','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18128,'35172','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26581,'48391','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26449,'48192','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45686,'77511','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54798,'99160','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34412,'59922','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44215,'75480','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41898,'72011','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18027,'35048','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13342,'28108','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38344,'65707','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33946,'59047','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31085,'55079','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7680,'17517','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25029,'46325','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13421,'28215','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35656,'61812','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40110,'68628','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7087,'16403','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26674,'48466','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16901,'32822','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17540,'33856','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19735,'37810','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20376,'38643','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24315,'45387','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25259,'46761','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12142,'25986','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30377,'54405','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7429,'17033','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4615,'12402','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35733,'61880','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41465,'71272','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45575,'77417','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10080,'22305','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28173,'50232','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53650,'97132','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(27937,'50041','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37714,'64728','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50828,'91329','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46537,'78766','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41225,'70805','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10666,'23306','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33672,'58571','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14264,'29305','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28370,'50458','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53281,'96507','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(4046,'10998','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23640,'44413','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22319,'42159','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13833,'28630','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16065,'31605','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21642,'40510','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46976,'79380','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47472,'80251','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34281,'59711','Deer Lodge','30023','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2721,'07450','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9884,'21781','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49149,'85050','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49386,'85553','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(11076,'24084','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14729,'29853','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27315,'49302','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24623,'45841','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41638,'71472','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2130,'06031','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10362,'22911','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21222,'39845','Seminole','13253','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23675,'44446','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35067,'61012','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35494,'61544','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36201,'62466','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43107,'73673','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10770,'23504','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33359,'58243','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3618,'09751','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3317,'08859','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27706,'49765','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27484,'49464','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25846,'47433','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12657,'27130','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17301,'33498','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34977,'60919','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53376,'96709','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54742,'99110','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54817,'99201','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7299,'16837','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6545,'15557','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30226,'54101','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29863,'53214','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16459,'32195','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18880,'36502','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54,'00694','Vega Alta','72143','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(41867,'71957','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4176,'11427','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32243,'56515','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15364,'30513','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29293,'52247','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28577,'50621','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54445,'98497','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10143,'22476','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26536,'48326','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43791,'74942','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45287,'77001','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55038,'99680','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(4529,'12180','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54337,'98330','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49054,'84734','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6895,'16108','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20469,'38765','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29000,'51533','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44581,'76023','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45036,'76577','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47557,'80469','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5351,'13504','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32878,'57386','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30124,'53926','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3659,'09836','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26824,'48728','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1479,'04354','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(41906,'72016','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10092,'22315','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2841,'07753','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6833,'16018','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13779,'28582','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(357,'01355','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14429,'29506','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18727,'36264','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16652,'32462','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40090,'68544','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27956,'50051','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14514,'29606','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37647,'64645','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46170,'78296','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50613,'90307','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54212,'98164','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21365,'40119','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37730,'64742','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38553,'66070','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39302,'67454','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47271,'79951','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3403,'09138','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27643,'49713','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2809,'07715','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35337,'61378','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39864,'68314','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40732,'69352','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48444,'83340','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52069,'94129','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53070,'96014','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10364,'22920','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32820,'57353','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15659,'30816','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32986,'57529','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17984,'35006','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45907,'77979','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49276,'85297','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10087,'22311','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7757,'17726','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30322,'54204','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11874,'25423','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28323,'50427','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27852,'49929','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27298,'49277','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21988,'41267','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25347,'46859','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39428,'67568','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49967,'88038','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52138,'94282','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30190,'53968','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5735,'14226','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20634,'38961','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5691,'14139','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4840,'12763','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29953,'53535','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18131,'35173','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24341,'45424','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36662,'62943','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40249,'68757','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42783,'73062','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5915,'14568','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29624,'52776','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19095,'36865','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53621,'97106','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51305,'92371','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35437,'61478','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7908,'17944','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32375,'56647','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21368,'40122','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28741,'51006','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38433,'65771','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43857,'75041','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6909,'16123','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20528,'38851','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23999,'45011','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46200,'78360','Jim Hogg','48247','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46457,'78673','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52451,'95113','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54265,'98244','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32283,'56548','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3945,'10590','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33025,'57562','Jones','46075','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28163,'50227','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37494,'64401','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44871,'76437','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46490,'78725','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34037,'59241','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12332,'26346','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25876,'47456','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4837,'12760','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52286,'94618','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50794,'91208','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34544,'60117','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47378,'80126','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3950,'10597','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12889,'27526','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28708,'50857','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17404,'33633','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34541,'60113','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41097,'70616','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48586,'83629','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48792,'84049','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(395,'01473','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11870,'25420','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35963,'62253','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36884,'63164','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5238,'13339','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48507,'83450','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37240,'63834','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33286,'58069','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1095,'03261','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4417,'12052','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20031,'38220','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11868,'25414','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11888,'25441','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35562,'61702','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37171,'63732','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5548,'13846','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33348,'58233','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5494,'13783','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9098,'20223','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5058,'13053','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24504,'45715','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22468,'42408','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11700,'25112','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15635,'30756','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21727,'40808','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11684,'25083','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15444,'30559','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20015,'38177','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19060,'36793','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41224,'70804','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50483,'90025','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52793,'95612','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24587,'45812','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14562,'29644','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2375,'06473','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26066,'47802','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(55102,'99755','Denali','2068','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46573,'78853','Maverick','48323','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2027,'05746','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5450,'13730','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2625,'07070','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22789,'43128','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7422,'17026','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3965,'10706','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43477,'74366','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51776,'93515','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1083,'03251','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(47157,'79745','Winkler','48495','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3198,'08558','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53731,'97291','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49999,'88113','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(13591,'28388','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19404,'37227','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40289,'68781','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5493,'13782','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6637,'15691','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29727,'53066','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(539,'01885','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21107,'39666','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51592,'93108','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55050,'99692','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(31547,'55905','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49799,'87415','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(16132,'31708','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(211,'01008','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46120,'78236','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35862,'62065','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24790,'46065','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17330,'33547','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19862,'37932','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7010,'16263','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33686,'58620','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33663,'58564','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45322,'77036','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47789,'80917','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11786,'25252','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42843,'73115','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37554,'64470','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1268,'03857','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(7109,'16427','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31187,'55329','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27605,'49677','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19215,'37061','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41126,'70656','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16937,'32896','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6649,'15713','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25478,'46985','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6479,'15458','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6119,'14864','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17376,'33602','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10081,'22306','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(840,'02648','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9553,'21043','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24390,'45613','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27559,'49639','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8567,'19151','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48047,'81434','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52920,'95811','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48215,'82442','Washakie','56043','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54849,'99322','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36619,'62918','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36288,'62557','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17084,'33132','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41605,'71446','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25038,'46342','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29367,'52341','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38476,'65897','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13294,'28071','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24342,'45424','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2401,'06507','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44601,'76044','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53637,'97122','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30097,'53821','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44693,'76134','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42815,'73086','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29362,'52338','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18510,'35958','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25165,'46567','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48308,'82934','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48971,'84530','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(17968,'34985','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6674,'15737','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17507,'33813','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34265,'59638','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47747,'80828','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43457,'74350','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32743,'57272','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14229,'29207','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23203,'43756','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53087,'96032','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47776,'80904','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42800,'73074','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1232,'03817','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(31999,'56282','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8366,'18920','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6267,'15110','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40010,'68436','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28849,'51230','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49218,'85204','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(13088,'27829','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2936,'07960','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3240,'08722','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9866,'21767','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49555,'86035','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40973,'70460','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17570,'33897','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1897,'05360','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18279,'35504','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19946,'38068','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35,'00667','Lajas','72079','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(20632,'38960','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46410,'78645','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32919,'57445','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25788,'47362','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28183,'50237','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52186,'94515','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46540,'78769','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37010,'63453','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19364,'37184','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28746,'51009','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20423,'38685','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25485,'46988','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10011,'22109','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16072,'31624','Atkinson','13003','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20139,'38359','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54107,'98019','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47997,'81301','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46042,'78122','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45924,'77995','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45339,'77052','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34325,'59759','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33784,'58731','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5382,'13630','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17225,'33410','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19201,'37052','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20934,'39422','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2079,'05846','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19910,'38037','Lauderdale','47097','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17057,'33077','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13196,'27928','Tyrrell','37177','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5663,'14102','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54632,'98844','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53879,'97454','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44333,'75660','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43288,'74031','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24643,'45850','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19071,'36830','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7988,'18054','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43156,'73749','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43456,'74349','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36846,'63124','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7483,'17074','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19142,'37016','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10814,'23669','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17004,'33014','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11130,'24139','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22040,'41512','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20308,'38581','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2301,'06351','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27862,'49947','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20082,'38313','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53949,'97602','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28082,'50149','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4545,'12197','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19847,'37918','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19731,'37806','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12455,'26578','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12620,'27046','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44865,'76433','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2298,'06340','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31252,'55371','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(657,'02143','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44097,'75370','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45470,'77299','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45033,'76573','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50043,'88250','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40181,'68710','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32697,'57245','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7820,'17820','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24716,'45896','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39234,'67355','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1915,'05444','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8174,'18439','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29434,'52548','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17505,'33811','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29192,'52147','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13990,'28759','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1858,'05153','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5790,'14437','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32201,'56461','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29989,'53562','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46687,'79036','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35530,'61604','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4861,'12783','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5535,'13835','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13754,'28562','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(478,'01730','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29755,'53093','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32422,'56710','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52976,'95917','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46534,'78763','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46263,'78467','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43521,'74447','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21200,'39827','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26745,'48623','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8635,'19354','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34128,'59401','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40432,'68923','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40703,'69334','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43351,'74076','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2254,'06241','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54135,'98047','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49808,'87499','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(47026,'79516','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18731,'36266','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34766,'60484','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35349,'61415','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32927,'57451','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32912,'57440','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6437,'15411','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11804,'25275','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2031,'05751','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5295,'13439','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11600,'24935','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40014,'68438','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47874,'81050','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44519,'75948','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44449,'75839','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42583,'72828','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39686,'67880','Hamilton','20075','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34913,'60644','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32835,'57362','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10924,'23901','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6816,'15956','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35037,'60960','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5987,'14722','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45969,'78029','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23800,'44659','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32796,'57332','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4305,'11777','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(315,'01236','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50050,'88256','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45777,'77627','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41862,'71950','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38369,'65725','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37277,'63879','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36039,'62316','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4889,'12824','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8170,'18436','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1539,'04473','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27029,'48892','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5240,'13341','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15047,'30188','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45612,'77450','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41249,'70835','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13493,'28307','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16572,'32352','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(55131,'99785','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42236,'72396','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54088,'97917','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30258,'54124','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7857,'17853','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54946,'99573','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52442,'95077','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49590,'86334','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21644,'40511','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23182,'43732','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34860,'60565','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47190,'79782','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51332,'92405','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46232,'78387','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39736,'68031','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52687,'95449','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39749,'68042','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48959,'84513','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40343,'68827','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22517,'42503','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24070,'45130','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31197,'55333','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19863,'37933','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34437,'60009','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32814,'57346','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32970,'57479','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10368,'22923','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50360,'89418','Pershing','32027','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(39462,'67629','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38533,'66050','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13449,'28247','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16920,'32856','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20167,'38379','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20721,'39107','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17928,'34771','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29189,'52144','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3075,'08221','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29287,'52241','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19827,'37882','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41575,'71419','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5513,'13809','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16200,'31778','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30585,'54564','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36881,'63158','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53150,'96104','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42880,'73149','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38226,'65612','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18748,'36276','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27020,'48887','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21831,'41022','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54120,'98031','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49606,'86405','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43207,'73844','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41404,'71220','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23466,'44118','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26347,'48091','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1244,'03832','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6294,'15147','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13252,'28012','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14128,'29075','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3727,'10044','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(852,'02663','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46417,'78652','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34473,'60042','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23515,'44202','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32129,'56371','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(24097,'45156','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18312,'35563','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23546,'44235','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12432,'26544','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27982,'50067','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11438,'24574','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26779,'48649','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9015,'20131','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51894,'93654','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45151,'76716','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36061,'62343','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9378,'20722','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7298,'16836','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8119,'18344','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30814,'54828','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3334,'08880','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53078,'96022','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28826,'51058','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37665,'64657','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51999,'94002','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45851,'77861','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52361,'94957','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17995,'35016','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33857,'58787','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49736,'87115','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46354,'78612','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37274,'63876','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35100,'61044','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18114,'35146','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28670,'50702','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21954,'41181','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6328,'15233','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50516,'90058','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37142,'63650','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42552,'72758','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9202,'20460','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(21395,'40175','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23676,'44449','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25991,'47612','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28762,'51020','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2236,'06161','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47878,'81054','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34093,'59323','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15535,'30645','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52554,'95296','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17217,'33402','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21434,'40233','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50362,'89420','Mineral','32021','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36906,'63334','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13503,'28318','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25695,'47272','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29217,'52169','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7946,'18011','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43569,'74543','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44204,'75472','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34574,'60140','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12533,'26750','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11449,'24590','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14249,'29226','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25359,'46895','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40484,'68955','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53604,'97070','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44161,'75439','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11620,'24983','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7343,'16881','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(308,'01224','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29666,'53017','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31594,'55946','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32757,'57312','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44574,'76018','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18125,'35160','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52885,'95694','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50462,'90004','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18512,'35959','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17289,'33478','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21675,'40581','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22869,'43226','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18629,'36054','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30829,'54840','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27809,'49879','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10397,'22952','Waynesboro City','51820','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6359,'15274','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39503,'67650','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38902,'66845','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35266,'61321','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(740,'02360','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18815,'36375','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21820,'41010','Harrison','21097','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9357,'20703','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13232,'27972','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16693,'32542','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52095,'94203','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21305,'40048','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10002,'22095','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10862,'23838','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4810,'12727','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37582,'64490','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53833,'97403','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46517,'78748','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4315,'11789','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7572,'17247','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10659,'23295','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(443,'01570','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37602,'64507','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17522,'33838','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54074,'97903','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49189,'85127','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43724,'74851','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39408,'67557','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23017,'43457','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28460,'50540','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14692,'29826','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30781,'54771','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47100,'79567','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8803,'19707','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(8448,'19029','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21735,'40820','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34545,'60118','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9650,'21213','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51920,'93711','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38135,'65464','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40400,'68866','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41461,'71269','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42771,'73055','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20872,'39332','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28537,'50597','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15301,'30441','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31448,'55713','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54089,'97918','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(21808,'40997','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7839,'17834','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38922,'66859','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38363,'65722','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47417,'80209','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48542,'83540','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44726,'76204','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38393,'65740','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35878,'62079','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22266,'42078','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26016,'47640','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28900,'51347','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40850,'70158','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36897,'63199','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24327,'45406','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21075,'39647','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15156,'30292','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3633,'09807','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43308,'74044','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24765,'46049','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53681,'97210','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52225,'94553','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50776,'91123','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48279,'82732','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45556,'77386','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39866,'68315','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36197,'62462','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23214,'43764','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48156,'82213','Platte','56031','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(30555,'54541','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22186,'41839','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42330,'72482','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39488,'67644','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29878,'53227','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41583,'71425','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40629,'69148','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12266,'26250','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15991,'31518','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18946,'36583','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9316,'20635','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24149,'45233','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29927,'53518','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9006,'20120','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29060,'51575','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37501,'64426','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35035,'60960','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29259,'52220','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46926,'79345','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41213,'70785','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40616,'69140','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38376,'65730','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4196,'11520','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36876,'63150','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24499,'45711','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1978,'05651','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36268,'62545','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12651,'27115','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14934,'30107','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26764,'48632','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53031,'95967','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7696,'17537','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49318,'85346','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45621,'77456','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33015,'57552','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35469,'61525','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26632,'48439','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53093,'96039','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39524,'67663','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16188,'31769','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24493,'45699','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(841,'02649','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3897,'10520','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34904,'60634','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9169,'20412','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(52668,'95426','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22369,'42254','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22260,'42069','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24335,'45417','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39466,'67631','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32747,'57274','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32357,'56630','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11357,'24485','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12926,'27557','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44970,'76522','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52307,'94707','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24175,'45254','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15832,'31071','Pulaski','13235','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4252,'11714','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13339,'28107','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7339,'16877','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52336,'94926','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6540,'15551','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52092,'94172','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49444,'85655','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3382,'09075','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49026,'84663','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11177,'24215','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41647,'71485','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47132,'79713','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43663,'74745','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34971,'60915','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1348,'04050','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21394,'40171','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3656,'09833','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28779,'51028','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28892,'51342','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1853,'05148','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9539,'21023','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19371,'37188','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17628,'33970','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31687,'56027','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32236,'56501','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53810,'97375','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53124,'96074','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41278,'71021','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39565,'67741','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17920,'34758','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3576,'09705','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11846,'25350','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30061,'53779','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21813,'41003','Pendleton','21191','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48648,'83711','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44881,'76444','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24963,'46234','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54544,'98611','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31565,'55923','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45781,'77632','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52872,'95685','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48479,'83424','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(35466,'61523','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2457,'06723','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6378,'15315','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8656,'19382','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18288,'35544','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(108,'00783','Corozal','72047','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51892,'93653','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30880,'54896','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29880,'53233','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36251,'62533','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16665,'32506','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8390,'18947','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18143,'35183','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29523,'52635','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54959,'99588','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(45713,'77539','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2616,'07062','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20214,'38471','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29507,'52621','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25022,'46312','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4683,'12472','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16382,'32099','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33726,'58643','Bowman','38011','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33299,'58103','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(798,'02540','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28878,'51249','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54411,'98408','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36150,'62433','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33388,'58274','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16020,'31547','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13770,'28577','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31786,'56111','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42892,'73160','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20514,'38844','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7171,'16625','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29720,'53062','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41460,'71268','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39140,'67135','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18824,'36421','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23929,'44846','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8790,'19604','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42972,'73488','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38087,'65351','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34406,'59916','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17913,'34747','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23755,'44625','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5559,'13862','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35404,'61455','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21869,'41056','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19784,'37854','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31556,'55917','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19368,'37186','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37415,'64093','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24165,'45246','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11917,'25523','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13829,'28627','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35036,'60960','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54734,'99102','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49103,'85002','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43122,'73718','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37836,'65001','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49822,'87514','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36275,'62548','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7368,'16936','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20277,'38559','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9104,'20230','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(15024,'30175','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25457,'46974','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6829,'16002','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6823,'15961','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21518,'40351','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9860,'21758','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5654,'14085','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33385,'58271','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35552,'61641','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7404,'17017','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22062,'41544','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6622,'15680','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47384,'80130','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6588,'15638','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21045,'39574','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5986,'14721','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35965,'62253','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3542,'09602','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(22845,'43199','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6722,'15821','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23174,'43728','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10279,'22727','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8232,'18577','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43254,'74008','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35615,'61749','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11264,'24333','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4700,'12492','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16260,'31816','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17708,'34140','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31184,'55328','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49260,'85268','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40266,'68768','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37507,'64429','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19050,'36784','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49009,'84642','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47995,'81253','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26879,'48763','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54752,'99118','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53774,'97343','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6072,'14820','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9175,'20418','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(80,'00734','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3658,'09835','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(51750,'93451','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42198,'72359','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37223,'63801','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35978,'62261','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27819,'49885','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41723,'71720','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49275,'85296','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30290,'54156','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18565,'36013','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50066,'88318','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(13179,'27909','Pasquotank','37139','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21360,'40117','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35789,'61951','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24903,'46165','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54416,'98415','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43634,'74652','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53661,'97140','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48521,'83468','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37952,'65201','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12709,'27258','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23242,'43793','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18662,'36091','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11368,'24503','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8248,'18616','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16849,'32763','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9422,'20775','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47361,'80112','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46529,'78759','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2509,'06829','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38659,'66416','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50363,'89421','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43329,'74059','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39414,'67561','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35497,'61546','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5097,'13092','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22434,'42351','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19007,'36742','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9727,'21521','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36467,'62820','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6033,'14774','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30854,'54864','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6043,'14786','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55122,'99775','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49938,'88001','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48868,'84124','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(33227,'58032','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15674,'30823','Glascock','13125','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13839,'28634','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24950,'46221','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19048,'36784','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15061,'30215','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43162,'73755','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14639,'29708','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54480,'98540','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52199,'94528','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47041,'79527','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35298,'61344','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32066,'56329','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25967,'47577','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11557,'24854','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23517,'44203','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21029,'39564','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17314,'33525','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49513,'85924','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46228,'78384','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44414,'75773','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40983,'70470','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34616,'60174','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22495,'42451','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1633,'04666','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22500,'42456','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13422,'28216','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36802,'63073','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40947,'70441','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49668,'87015','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54870,'99347','Columbia','53013','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29811,'53150','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29265,'52224','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21183,'39776','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(765,'02459','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49283,'85305','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45604,'77444','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43056,'73622','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37719,'64733','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37162,'63674','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15259,'30398','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11909,'25511','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47680,'80726','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48585,'83629','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52410,'95036','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38268,'65638','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35957,'62248','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7733,'17584','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27302,'49283','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13963,'28738','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48452,'83346','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6103,'14847','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21495,'40330','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16083,'31631','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6831,'16016','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35526,'61572','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42563,'72769','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47348,'80105','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47682,'80728','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53384,'96718','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(42787,'73064','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42356,'72530','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35080,'61021','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33936,'59038','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32597,'57058','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27765,'49827','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3794,'10172','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43697,'74827','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5857,'14513','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18331,'35576','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19633,'37690','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4501,'12150','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3747,'10109','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24807,'46075','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9408,'20757','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39066,'67055','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43200,'73841','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55160,'99919','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(41426,'71234','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28885,'51334','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7383,'16948','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25085,'46403','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43481,'74369','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44918,'76464','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2304,'06355','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25292,'46784','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5705,'14170','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11102,'24114','Martinsville City','51690','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3629,'09803','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16005,'31534','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44719,'76196','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32881,'57402','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11551,'24847','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4090,'11210','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9584,'21087','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4056,'11021','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50215,'89021','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50409,'89510','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(42593,'72838','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20981,'39474','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3832,'10285','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12623,'27049','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34323,'59756','Deer Lodge','30023','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(5192,'13244','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26341,'48084','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15621,'30741','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23921,'44842','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35610,'61745','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38848,'66757','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49204,'85145','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53489,'96839','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(23563,'44256','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4573,'12234','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13184,'27919','Chowan','37041','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51471,'92707','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4957,'12924','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11886,'25438','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1471,'04346','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21331,'40068','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20591,'38924','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2958,'08009','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6964,'16222','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37204,'63775','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48148,'82084','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49112,'85011','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(55073,'99724','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(6309,'15214','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22745,'43078','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18525,'35967','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49708,'87052','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(40751,'70003','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4718,'12514','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25915,'47523','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19302,'37135','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14241,'29218','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36237,'62515','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41995,'72079','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3849,'10451','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32184,'56444','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31802,'56122','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27389,'49343','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13851,'28643','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23994,'45002','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50322,'89169','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(45778,'77629','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36471,'62824','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2127,'06028','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2593,'07036','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13682,'28470','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15438,'30555','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20780,'39170','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18555,'36005','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42744,'73041','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43057,'73624','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53266,'96380','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(8479,'19063','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44110,'75391','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51935,'93727','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7613,'17319','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22867,'43223','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46830,'79220','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51269,'92324','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51957,'93777','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33598,'58490','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23090,'43545','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40712,'69339','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4232,'11596','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24884,'46156','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12852,'27503','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30713,'54735','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46986,'79407','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50112,'88434','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(7201,'16655','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10515,'23107','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10159,'22509','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42983,'73521','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50572,'90239','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27198,'49097','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34513,'60087','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8639,'19360','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18910,'36540','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54320,'98310','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28319,'50423','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5477,'13755','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39867,'68316','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38019,'65279','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20106,'38334','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28026,'50112','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4815,'12734','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26086,'47837','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4818,'12738','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13432,'28227','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14265,'29306','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36534,'62866','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38870,'66776','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2544,'06905','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17563,'33884','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20876,'39336','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27644,'49715','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21279,'40022','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24665,'45865','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3433,'09307','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48393,'83254','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45894,'77964','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21194,'39823','Miller','13201','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22076,'41563','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49336,'85364','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7718,'17567','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14439,'29525','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53764,'97330','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50106,'88424','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(14971,'30134','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53221,'96264','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(5697,'14145','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33942,'59044','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(21445,'40253','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10589,'23185','Williamsburg City','51830','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10335,'22844','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28177,'50234','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18085,'35116','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2665,'07184','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32410,'56682','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(50815,'91311','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19993,'38135','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9301,'20619','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16568,'32347','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30689,'54721','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22055,'41537','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51262,'92316','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52566,'95311','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8409,'18969','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32780,'57324','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(978,'02902','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(24680,'45873','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18380,'35634','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43552,'74522','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15086,'30233','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51695,'93307','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52203,'94533','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53015,'95955','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43472,'74364','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39762,'68055','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8299,'18708','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5190,'13225','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33532,'58439','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4551,'12205','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27514,'49588','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1262,'03851','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16370,'32086','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38831,'66739','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42894,'73163','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43780,'74931','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25949,'47556','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11766,'25234','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44857,'76429','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47782,'80910','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29546,'52652','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53563,'97030','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6254,'15088','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(960,'02879','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(1576,'04562','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19409,'37234','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43883,'75063','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10568,'23160','Powhatan','51145','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29480,'52576','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13023,'27697','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21851,'41042','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50235,'89043','Lincoln','32017','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(45536,'77371','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18520,'35963','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17605,'33936','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16531,'32313','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29840,'53187','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41323,'71067','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9804,'21662','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38859,'66767','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46990,'79410','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47163,'79755','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5877,'14530','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12278,'26264','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14485,'29577','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13906,'28684','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1410,'04223','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35702,'61852','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32833,'57361','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25113,'46517','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14271,'29321','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19318,'37144','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36242,'62521','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41061,'70571','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51495,'92817','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28479,'50554','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33310,'58126','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10570,'23162','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10899,'23878','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34716,'60447','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26123,'47868','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16948,'32909','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21174,'39769','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45192,'76849','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50452,'89830','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52949,'95838','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32313,'56572','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29423,'52536','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15370,'30517','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36842,'63121','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38575,'66091','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38876,'66778','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45864,'77872','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46793,'79104','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54596,'98683','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47308,'80017','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2848,'07762','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34483,'60051','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11764,'25214','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13687,'28479','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27292,'49270','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19032,'36762','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16638,'32449','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36165,'62443','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38275,'65645','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45110,'76673','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53276,'96444','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(17318,'33534','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13032,'27705','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38820,'66728','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38857,'66762','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43201,'73841','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51864,'93628','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34982,'60921','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4695,'12486','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17072,'33114','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16560,'32340','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8889,'19966','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(36439,'62786','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46876,'79251','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53850,'97423','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31154,'55303','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(813,'02563','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3622,'09762','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(263,'01081','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35579,'61726','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1476,'04351','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28680,'50835','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32549,'57033','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11367,'24502','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8591,'19188','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2105,'05903','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3001,'08055','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20169,'38380','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36099,'62374','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42975,'73501','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55053,'99695','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9010,'20128','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39351,'67502','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39669,'67870','Grant','20067','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42120,'72202','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45802,'77670','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32633,'57106','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32451,'56735','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45381,'77090','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49470,'85721','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(27215,'49115','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22990,'43432','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4059,'11024','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21467,'40291','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44570,'76014','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3114,'08322','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48622,'83660','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46590,'78931','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6529,'15540','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11754,'25202','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34393,'59874','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33512,'58422','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9742,'21541','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19570,'37412','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41706,'71670','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41755,'71763','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44498,'75931','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50530,'90072','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53194,'96150','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27743,'49801','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40379,'68855','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44510,'75939','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47105,'79601','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50177,'88576','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(52992,'95934','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54552,'98620','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28699,'50849','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16538,'32320','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14521,'29611','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20132,'38355','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37869,'65039','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17823,'34465','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24724,'46001','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3821,'10272','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29009,'51541','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27541,'49628','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26403,'48152','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5371,'13619','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50997,'91801','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28007,'50103','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17912,'34746','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11208,'24251','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52697,'95460','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54462,'98520','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1170,'03585','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(33236,'58040','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9111,'20240','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(38251,'65629','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49603,'86402','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(11531,'24818','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53310,'96555','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(47624,'80545','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22492,'42450','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5053,'13051','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29162,'52075','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13118,'27852','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39407,'67557','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35161,'61088','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34933,'60673','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32750,'57278','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26761,'48632','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51647,'93245','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44966,'76519','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38794,'66624','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38652,'66409','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17335,'33549','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1307,'03910','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6625,'15681','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3585,'09715','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(34303,'59732','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14129,'29078','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36636,'62928','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37512,'64433','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42580,'72826','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46362,'78617','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47600,'80523','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52249,'94577','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32693,'57242','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9588,'21093','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8995,'20111','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10446,'23024','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52545,'95251','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35830,'62033','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4504,'12154','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29234,'52207','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1659,'04736','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21366,'40121','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20288,'38568','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20179,'38391','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20045,'38233','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19111,'36877','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35886,'62082','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32210,'56466','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(50907,'91508','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43555,'74525','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28629,'50657','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29713,'53057','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7700,'17545','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16010,'31539','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20677,'39062','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41182,'70752','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31269,'55382','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30748,'54755','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24421,'45645','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50382,'89439','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54340,'98332','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27604,'49677','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27474,'49456','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18177,'35228','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19546,'37388','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36867,'63139','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49015,'84648','Juab','49023','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(3401,'09136','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(51467,'92703','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30972,'54976','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25139,'46543','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34795,'60513','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46780,'79095','Childress','48075','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34594,'60152','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22161,'41775','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26473,'48220','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46151,'78265','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51363,'92531','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54617,'98826','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(627,'02113','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34166,'59441','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31673,'56017','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27571,'49649','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11011,'24018','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9174,'20417','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14657,'29729','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20989,'39478','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40144,'68644','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48235,'82620','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51167,'92170','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55088,'99741','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1044,'03105','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(33890,'58852','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9216,'20508','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35500,'61548','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50180,'88579','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(41433,'71238','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40758,'70030','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3653,'09830','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(31220,'55345','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26746,'48623','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26438,'48182','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25074,'46385','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8740,'19512','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39033,'67028','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49800,'87416','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52548,'95254','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11823,'25314','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31932,'56229','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24684,'45877','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34442,'60011','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23278,'43901','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23975,'44882','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22213,'42028','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38740,'66536','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33684,'58601','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17679,'34099','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(30166,'53955','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19065,'36803','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21160,'39755','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45741,'77575','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47853,'81033','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49342,'85372','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10833,'23803','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22008,'41347','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1129,'03431','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21589,'40434','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16666,'32507','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39837,'68157','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33211,'58015','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30611,'54620','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26555,'48353','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38936,'66869','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40785,'70063','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42206,'72368','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45840,'77843','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15420,'30542','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16084,'31631','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27158,'49071','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35826,'62030','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35922,'62216','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40853,'70161','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51684,'93286','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1069,'03234','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30330,'54210','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16004,'31533','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1769,'04965','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16816,'32720','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41357,'71109','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45363,'77075','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47785,'80913','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53620,'97103','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34068,'59270','Wibaux','30109','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33439,'58344','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36391,'62688','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41453,'71260','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46128,'78244','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46196,'78355','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50505,'90047','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52218,'94548','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36075,'62353','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31164,'55313','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19872,'37996','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17581,'33909','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17283,'33473','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15182,'30313','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7524,'17123','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11930,'25541','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23523,'44214','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29312,'52305','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27872,'49960','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36419,'62719','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52647,'95402','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54799,'99161','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22392,'42286','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32706,'57252','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32511,'57006','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28648,'50669','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40364,'68841','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54563,'98632','Wahkiakum','53069','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29261,'52221','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24263,'45344','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23769,'44634','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18159,'35209','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3038,'08090','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38892,'66835','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19564,'37406','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9085,'20210','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30902,'54922','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30091,'53816','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10749,'23459','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25129,'46537','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13415,'28211','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5879,'14532','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32516,'57012','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42699,'73011','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42595,'72839','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41664,'71635','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13786,'28586','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16554,'32334','Liberty','12077','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28985,'51527','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32027,'56303','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11069,'24078','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1797,'05033','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5527,'13826','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28637,'50660','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43153,'73744','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49177,'85087','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50310,'89155','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(3416,'09213','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28964,'51462','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22257,'42066','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42182,'72346','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51680,'93280','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(269,'01088','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11795,'25264','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33323,'58212','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30721,'54738','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11580,'24888','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4298,'11769','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4026,'10976','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47212,'79847','Culberson','48109','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33192,'57791','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30750,'54756','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(776,'02471','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28774,'51026','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8410,'18970','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52710,'95472','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48245,'82639','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42028,'72108','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15069,'30222','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16938,'32897','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22770,'43110','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7536,'17210','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12209,'26155','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11714,'25130','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4266,'11730','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23083,'43536','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7690,'17529','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39039,'67035','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54385,'98380','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4599,'12302','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10948,'23936','Cumberland','51049','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28147,'50217','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7865,'17862','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22923,'43331','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12843,'27495','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37031,'63468','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35033,'60959','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9496,'20889','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16713,'32568','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18540,'35979','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2941,'07974','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33801,'58744','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1780,'04978','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26160,'47920','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17827,'34473','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17486,'33778','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54673,'98938','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28334,'50433','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37419,'64101','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(762,'02456','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(48661,'83724','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(9832,'21714','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8200,'18462','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32070,'56331','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31690,'56029','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11350,'24482','Staunton City','51790','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17048,'33068','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18623,'36051','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35648,'61799','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43902,'75083','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51560,'93021','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52868,'95681','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22552,'42633','Wayne','21231','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31106,'55105','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7740,'17606','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21148,'39750','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17156,'33247','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15869,'31096','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48942,'84341','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50897,'91495','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51475,'92728','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54208,'98155','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21159,'39755','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35355,'61418','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35514,'61563','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37905,'65064','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5154,'13156','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9026,'20140','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25620,'47164','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23851,'44707','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15603,'30732','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35571,'61721','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39659,'67863','Scott','20171','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40101,'68623','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41682,'71653','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44565,'76009','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21476,'40299','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20601,'38929','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15867,'31094','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40055,'68464','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51800,'93542','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30423,'54434','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(987,'02911','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(6047,'14802','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14704,'29836','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45800,'77665','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46984,'79404','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52692,'95454','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8153,'18421','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29623,'52776','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27148,'49063','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4147,'11371','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10308,'22801','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10008,'22106','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19288,'37118','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20750,'39145','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35041,'60961','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47998,'81301','San Juan','8111','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48845,'84101','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30343,'54221','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48347,'83201','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36813,'63089','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19713,'37772','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23702,'44491','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25539,'47040','Ohio','18115','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8179,'18444','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41843,'71932','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40686,'69216','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33802,'58746','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32968,'57476','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30864,'54872','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19762,'37840','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23122,'43605','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36365,'62666','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39028,'67025','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49628,'86443','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(15325,'30457','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6305,'15210','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8509,'19093','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6858,'16040','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41891,'72002','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46352,'78611','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9917,'21824','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26308,'48044','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24620,'45838','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17549,'33865','Hardee','12049','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14457,'29551','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7927,'17968','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45451,'77270','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11775,'25243','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29838,'53185','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40715,'69340','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54379,'98374','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53816,'97381','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41616,'71455','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47053,'79533','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48895,'84180','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50170,'88569','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(2532,'06880','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24582,'45809','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16874,'32792','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45895,'77967','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(838,'02646','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29709,'53050','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6200,'15030','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50407,'89508','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50335,'89301','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49902,'87740','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47656,'80642','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5241,'13342','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22881,'43251','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21798,'40977','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18197,'35255','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13849,'28642','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36505,'62844','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47291,'80002','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6015,'14747','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22265,'42076','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22233,'42044','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44546,'75975','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48395,'83255','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32937,'57457','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33046,'57580','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1003,'03037','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6672,'15734','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20799,'39190','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36836,'63117','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37800,'64842','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33810,'58755','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5952,'14624','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4464,'12107','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28639,'50662','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28067,'50140','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26814,'48721','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25269,'46767','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24437,'45657','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19508,'37362','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9971,'22026','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35092,'61038','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44984,'76528','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46100,'78217','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51173,'92176','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16702,'32561','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7803,'17777','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14123,'29072','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39134,'67132','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42814,'73085','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45810,'77708','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51,'00690','Aguadilla','72005','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(22650,'43010','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9395,'20744','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20181,'38392','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8689,'19440','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2256,'06242','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(724,'02340','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4312,'11786','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48267,'82721','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(20460,'38754','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6019,'14752','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10989,'24001','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14076,'29033','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46217,'78375','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35798,'62001','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5785,'14433','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17212,'33355','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18399,'35660','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29778,'53119','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4597,'12301','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40698,'69333','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3299,'08833','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39695,'67952','Stevens','20189','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15181,'30312','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17974,'34991','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20486,'38803','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19594,'37618','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43048,'73571','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51960,'93786','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1602,'04622','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24222,'45318','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8964,'20070','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17635,'33976','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32959,'57472','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48720,'83852','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(27769,'49833','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26817,'48724','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16949,'32910','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19429,'37309','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45220,'76870','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49945,'88008','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51151,'92150','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34439,'60010','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45373,'77083','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30823,'54836','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43400,'74134','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40009,'68434','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39521,'67660','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12679,'27215','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27045,'48911','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47320,'80024','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48619,'83657','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53624,'97109','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28930,'51440','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23240,'43788','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49167,'85074','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39946,'68366','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38554,'66071','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1575,'04558','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4231,'11590','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3997,'10931','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10209,'22580','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9867,'21769','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19556,'37398','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8751,'19526','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46335,'78596','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54450,'98502','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44115,'75397','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42173,'72336','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21404,'40201','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22863,'43219','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3692,'10007','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11873,'25422','Morgan','54065','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4188,'11499','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7893,'17921','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34434,'60007','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27189,'49091','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5079,'13074','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39413,'67560','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43206,'73843','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47742,'80824','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52171,'94503','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53397,'96733','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(27232,'49221','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1086,'03254','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(23904,'44830','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7564,'17239','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28811,'51050','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27925,'50032','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(584,'02018','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36894,'63188','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44181,'75452','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50555,'90189','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12218,'26164','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5988,'14723','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31004,'55009','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53462,'96805','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50473,'90015','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41993,'72076','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26604,'48420','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8593,'19191','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6548,'15559','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6985,'16239','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30410,'54425','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26515,'48304','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24349,'45431','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17210,'33349','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36950,'63377','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37584,'64492','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42376,'72546','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34224,'59523','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19737,'37811','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27847,'49920','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50455,'89833','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5140,'13143','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41135,'70662','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22810,'43144','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36130,'62422','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12615,'27043','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(9147,'20376','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36912,'63342','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43070,'73645','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27134,'49052','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1373,'04085','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42285,'72444','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46038,'78119','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51265,'92320','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13259,'28021','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33912,'59015','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(24708,'45893','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22766,'43107','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22378,'42265','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36474,'62827','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44358,'75685','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45691,'77517','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34117,'59345','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35799,'62002','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54141,'98055','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31028,'55030','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4084,'11204','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29353,'52332','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14053,'29006','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43454,'74347','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39616,'67837','Meade','20119','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7607,'17314','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2523,'06858','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10692,'23357','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10158,'22508','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7966,'18035','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28949,'51453','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28076,'50146','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49408,'85619','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51602,'93140','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9720,'21501','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8407,'18968','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30463,'54460','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52274,'94605','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6765,'15865','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14261,'29302','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5039,'13036','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13949,'28726','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7235,'16685','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31367,'55480','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27717,'49774','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2231,'06153','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3227,'08645','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14256,'29260','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51660,'93256','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43231,'73937','Cimarron','40025','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21020,'39552','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22528,'42539','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7540,'17213','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13258,'28020','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33147,'57747','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5409,'13658','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32125,'56367','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31306,'55408','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9340,'20677','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13817,'28616','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36918,'63346','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51535,'92880','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5307,'13457','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13518,'28332','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51218,'92251','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17484,'33776','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14269,'29319','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42159,'72324','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15328,'30458','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20318,'38585','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14581,'29654','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44100,'75373','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54104,'98014','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12173,'26074','Ohio','54069','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11964,'25632','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7998,'18062','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35132,'61065','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18914,'36544','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36629,'62923','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52576,'95321','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12634,'27094','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16350,'32063','Baker','12003','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31104,'55103','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23029,'43469','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21603,'40447','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20268,'38551','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38607,'66203','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42601,'72842','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49363,'85502','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(22220,'42036','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17043,'33063','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41769,'71802','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44407,'75765','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31166,'55314','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54481,'98541','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48914,'84314','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47411,'80203','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10563,'23153','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30842,'54853','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30505,'54491','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21745,'40840','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16871,'32790','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43831,'75016','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47102,'79601','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47194,'79786','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8679,'19426','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2907,'07881','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14586,'29657','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43248,'74003','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39989,'68417','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33900,'59003','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6705,'15772','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22637,'43001','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26769,'48637','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25913,'47521','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46501,'78733','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52948,'95837','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19395,'37216','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11699,'25111','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29554,'52656','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9810,'21668','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17419,'33674','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2996,'08050','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8105,'18327','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36035,'62312','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46866,'79245','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49250,'85257','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49714,'87062','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51645,'93243','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30109,'53913','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6020,'14753','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21621,'40481','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43568,'74540','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50943,'91724','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6767,'15866','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31538,'55811','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14407,'29477','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17769,'34266','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36328,'62627','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42359,'72531','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53827,'97392','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54635,'98847','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20246,'38503','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38377,'65731','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42969,'73481','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47946,'81146','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50007,'88120','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(3835,'10301','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5368,'13617','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3826,'10277','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14549,'29635','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28459,'50540','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23567,'44260','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33944,'59044','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30141,'53937','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2129,'06030','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5461,'13739','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47435,'80222','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48110,'81654','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49927,'87930','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(55029,'99670','Bristol Bay','2060','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(35106,'61048','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7338,'16876','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26763,'48632','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23139,'43635','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5941,'14613','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23713,'44507','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20728,'39113','Issaquena','28055','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41905,'72016','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2901,'07875','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29617,'52769','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9374,'20718','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23900,'44827','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19335,'37160','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23365,'44004','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39291,'67448','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45687,'77512','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48722,'83854','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51976,'93920','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35247,'61283','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14942,'30110','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53944,'97540','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26736,'48618','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12421,'26525','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35028,'60957','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34617,'60175','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37616,'64625','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42705,'73015','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12494,'26656','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6291,'15144','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32534,'57024','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30584,'54563','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38394,'65741','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50295,'89140','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(37573,'64485','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26971,'48850','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11508,'24716','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40695,'69301','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13137,'27870','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34585,'60146','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33835,'58770','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12073,'25853','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1664,'04741','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19682,'37742','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24277,'45353','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20755,'39148','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36217,'62476','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45280,'76951','Glasscock','48173','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45908,'77979','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46944,'79357','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47122,'79706','Glasscock','48173','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50642,'90603','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(821,'02576','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10997,'24009','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37792,'64832','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41531,'71356','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42991,'73528','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47328,'80034','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37191,'63760','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18898,'36525','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32640,'57117','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25667,'47240','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4677,'12468','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3490,'09498','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7203,'16657','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5859,'14514','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27993,'50072','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15101,'30248','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23366,'44005','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16738,'32614','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50658,'90631','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1402,'04211','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(46419,'78653','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39390,'67546','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2341,'06415','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8363,'18916','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32352,'56623','Lake of the Woods','27077','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30357,'54245','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36911,'63341','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28102,'50158','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41221,'70801','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6014,'14747','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1077,'03244','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16754,'32634','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22409,'42327','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29864,'53215','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1813,'05050','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25290,'46783','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10476,'23062','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9100,'20226','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8152,'18420','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41133,'70660','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45446,'77265','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50309,'89154','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33585,'58481','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30361,'54302','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29048,'51565','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19172,'37034','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5430,'13679','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54562,'98632','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43443,'74338','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35854,'62058','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23950,'44859','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22334,'42171','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2726,'07458','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4570,'12231','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18349,'35593','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29284,'52237','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22471,'42410','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27900,'50012','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49732,'87111','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(6371,'15295','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(672,'02176','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15874,'31097','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16927,'32867','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52964,'95899','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3681,'09875','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(33135,'57732','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20626,'38954','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42281,'72441','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42646,'72930','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46086,'78203','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52850,'95665','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53645,'97128','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11621,'24984','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43588,'74561','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47847,'81023','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42921,'73430','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10932,'23920','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32002,'56283','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41768,'71801','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40234,'68746','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37456,'64146','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24356,'45435','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8741,'19512','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9011,'20129','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9060,'20181','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11116,'24128','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3070,'08215','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33501,'58415','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9449,'20816','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34701,'60437','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28312,'50398','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4790,'12590','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2012,'05731','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2221,'06141','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7777,'17750','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52240,'94569','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46197,'78357','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16377,'32095','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27118,'49040','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35233,'61272','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10592,'23187','Williamsburg City','51830','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5918,'14572','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4496,'12147','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19079,'36852','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43972,'75153','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18486,'35901','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51866,'93631','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49311,'85339','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2693,'07401','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1997,'05672','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36001,'62275','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44649,'76088','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12230,'26181','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11918,'25523','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9897,'21793','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17395,'33621','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44813,'76360','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40517,'68978','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29093,'51647','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11184,'24220','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10934,'23920','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21763,'40874','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21473,'40297','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10057,'22213','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29253,'52217','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19528,'37375','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36620,'62918','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(983,'02907','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(51676,'93276','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53497,'96849','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12942,'27572','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32230,'56481','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26002,'47629','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35744,'61911','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3072,'08218','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10390,'22947','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8867,'19943','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(3784,'10162','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35893,'62086','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21556,'40385','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28916,'51366','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22232,'42041','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7482,'17073','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12574,'26884','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8597,'19195','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6666,'15729','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13446,'28243','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38360,'65720','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47390,'80135','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48097,'81641','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50085,'88346','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(30467,'54464','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50489,'90031','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54797,'99159','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(755,'02446','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(861,'02673','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4830,'12751','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31230,'55353','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3236,'08695','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23311,'43934','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41540,'71362','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42378,'72550','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11414,'24553','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14359,'29432','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12225,'26170','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13235,'27974','Camden','37029','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28306,'50391','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24791,'46067','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36854,'63130','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44342,'75668','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47248,'79929','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49076,'84757','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21632,'40492','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11534,'24826','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1243,'03830','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4919,'12858','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37136,'63645','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37755,'64762','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6995,'16249','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53955,'97623','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45366,'77078','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24151,'45235','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10651,'23286','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(293,'01128','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2698,'07416','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35795,'61956','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46734,'79065','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24238,'45327','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16111,'31645','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47790,'80918','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1006,'03041','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26594,'48416','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23779,'44643','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48489,'83436','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51512,'92844','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7493,'17084','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7721,'17569','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4971,'12942','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1227,'03813','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30340,'54217','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50892,'91423','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38409,'65754','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16731,'32606','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28769,'51023','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(2276,'06265','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27728,'49783','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25398,'46928','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23465,'44117','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15686,'30901','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18287,'35543','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16986,'32965','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16095,'31637','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43479,'74367','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53759,'97325','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(18679,'36114','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18591,'36032','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8126,'18352','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42049,'72123','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12914,'27545','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10202,'22572','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10045,'22204','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20361,'38632','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47818,'80946','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33930,'59034','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(10718,'23422','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34295,'59722','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(41835,'71921','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38542,'66058','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10038,'22193','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26233,'47970','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18742,'36274','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1004,'03038','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(34573,'60139','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8385,'18940','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21065,'39635','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36069,'62349','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46058,'78141','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8103,'18326','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41621,'71459','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4355,'11955','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48754,'84008','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50826,'91327','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38695,'66501','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38123,'65457','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21762,'40874','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29439,'52551','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27945,'50046','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15434,'30553','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37276,'63878','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53331,'96615','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(33362,'58249','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34,'00664','Jayuya','72073','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(47403,'80160','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35929,'62223','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11227,'24280','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29391,'52361','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5447,'13697','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9130,'20303','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(27256,'49245','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20090,'38318','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46068,'78151','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52193,'94522','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52487,'95158','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33511,'58421','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3345,'08902','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1658,'04735','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35785,'61943','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34521,'60094','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52029,'94061','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47290,'80002','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18568,'36016','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9387,'20736','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36208,'62469','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42540,'72747','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43434,'74332','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47695,'80737','Sedgwick','8115','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49694,'87042','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53092,'96038','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27141,'49056','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47835,'81007','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48965,'84522','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5247,'13352','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28683,'50837','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3760,'10122','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9363,'20707','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30417,'54428','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50601,'90291','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19690,'37752','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2748,'07510','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38418,'65761','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37975,'65240','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13087,'27828','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7498,'17087','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25641,'47201','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29224,'52172','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10206,'22578','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13743,'28551','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23925,'44843','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29301,'52253','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7485,'17076','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8436,'19016','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15210,'30337','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1818,'05054','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14152,'29112','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22793,'43135','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47326,'80031','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42215,'72376','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35594,'61736','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7704,'17550','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6505,'15486','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17718,'34202','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33335,'58225','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21016,'39533','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36438,'62781','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45387,'77096','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19455,'37328','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31517,'55786','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26667,'48462','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25353,'46865','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24741,'46034','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20869,'39330','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2235,'06160','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20847,'39304','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42240,'72402','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(707,'02303','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10168,'22524','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11289,'24378','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7577,'17253','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21415,'40212','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32902,'57434','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35476,'61530','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41900,'72013','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19724,'37801','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44852,'76426','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9793,'21653','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25053,'46366','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26967,'48849','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3703,'10019','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17642,'33993','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11740,'25169','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51655,'93252','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27965,'50058','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21283,'40025','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52463,'95126','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50662,'90637','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50361,'89419','Pershing','32027','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40011,'68436','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22444,'42366','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26880,'48763','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1870,'05254','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(30392,'54412','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30676,'54666','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34236,'59532','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40036,'68453','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44338,'75663','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49127,'85026','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(24292,'45368','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39888,'68329','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4607,'12307','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47750,'80830','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46019,'78102','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44802,'76308','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38623,'66218','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8641,'19362','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19786,'37857','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10146,'22482','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24748,'46037','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3654,'09831','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20655,'39042','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30022,'53586','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9473,'20855','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9226,'20525','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24392,'45614','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21663,'40536','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15041,'30184','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14280,'29330','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16916,'32839','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18402,'35670','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45873,'77880','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45670,'77494','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40512,'68974','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36800,'63072','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33679,'58579','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13801,'28605','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8370,'18924','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16605,'32424','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32482,'56761','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22152,'41760','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48888,'84151','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44371,'75694','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42475,'72663','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18799,'36350','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27637,'49709','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50627,'90409','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49985,'88058','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(39561,'67739','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36977,'63434','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36566,'62885','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26556,'48353','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51484,'92804','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22311,'42151','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21054,'39601','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8149,'18417','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7497,'17087','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12097,'25902','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51726,'93426','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53712,'97233','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43565,'74536','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43420,'74171','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41447,'71256','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16981,'32960','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7182,'16636','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6005,'14738','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6587,'15637','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10322,'22827','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27840,'49913','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23915,'44838','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39863,'68313','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40605,'69132','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8683,'19432','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35692,'61847','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11645,'25031','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5947,'14619','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10378,'22938','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19333,'37153','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26672,'48464','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33124,'57719','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50696,'90734','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50698,'90742','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51761,'93461','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20886,'39342','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14836,'30035','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26792,'48656','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52770,'95567','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50175,'88574','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47869,'81046','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42934,'73441','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37830,'64868','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11008,'24015','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51803,'93545','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32298,'56560','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7658,'17375','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20112,'38340','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4272,'11737','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35396,'61450','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40769,'70043','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49862,'87564','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(9102,'20228','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(32427,'56715','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7864,'17861','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23592,'44287','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21643,'40511','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21414,'40211','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14140,'29102','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20107,'38336','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25332,'46818','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7847,'17842','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28077,'50147','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16591,'32407','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2450,'06708','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4212,'11558','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27954,'50050','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25325,'46808','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5086,'13080','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24166,'45246','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6216,'15049','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23974,'44882','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4867,'12788','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32690,'57239','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32028,'56304','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17220,'33405','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50580,'90250','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40401,'68869','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43895,'75078','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23369,'44012','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27738,'49795','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27047,'48912','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20805,'39192','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39149,'67146','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38604,'66160','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33356,'58240','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33134,'57730','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25793,'47368','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22095,'41621','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28299,'50363','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22950,'43345','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24138,'45221','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26242,'47977','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13832,'28630','Alexander','37003','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7784,'17756','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3190,'08550','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15141,'30281','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9792,'21652','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39111,'67112','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10257,'22663','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32300,'56562','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(44920,'76464','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23300,'43920','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7754,'17724','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16728,'32603','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18070,'35094','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26078,'47833','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21106,'39666','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4653,'12443','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55125,'99778','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53082,'96025','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34841,'60550','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4757,'12553','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12082,'25866','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15276,'30421','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17975,'34992','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25710,'47283','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19250,'37083','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25606,'47144','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37120,'63629','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11748,'25185','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23133,'43615','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23564,'44256','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2095,'05866','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(48546,'83543','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46581,'78877','Maverick','48323','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43886,'75067','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35710,'61857','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33051,'57601','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3352,'09003','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(37930,'65081','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36399,'62692','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35600,'61740','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7684,'17520','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6748,'15846','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12497,'26667','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27064,'49001','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52244,'94572','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41070,'70582','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35290,'61337','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33878,'58833','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14541,'29628','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18358,'35610','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9755,'21609','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9850,'21742','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20617,'38949','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4416,'12051','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36978,'63434','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44656,'76096','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44757,'76247','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5337,'13488','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45609,'77447','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13641,'28441','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27702,'49760','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51161,'92164','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46712,'79052','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44129,'75415','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43012,'73543','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37791,'64832','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2887,'07851','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54710,'99019','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52305,'94706','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44254,'75555','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3010,'08065','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11399,'24536','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9120,'20261','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(31035,'55037','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26947,'48837','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31588,'55943','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51177,'92182','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48605,'83643','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10324,'22830','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23239,'43788','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2670,'07193','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31679,'56022','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17110,'33159','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30029,'53590','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30217,'54022','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8900,'19979','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(13109,'27845','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5655,'14086','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21631,'40489','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47882,'81058','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38658,'66415','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35289,'61336','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52219,'94549','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45658,'77485','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50990,'91788','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30755,'54758','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22193,'41849','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15250,'30377','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14912,'30097','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2008,'05682','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(416,'01523','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39517,'67657','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17930,'34773','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27827,'49895','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28485,'50560','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32284,'56549','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11050,'24060','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4191,'11509','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39535,'67672','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37982,'65244','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34279,'59707','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32007,'56287','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46081,'78163','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35758,'61925','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34207,'59479','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11934,'25547','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26305,'48041','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36761,'63034','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36112,'62410','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35508,'61559','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11614,'24970','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19378,'37201','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6134,'14876','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31340,'55438','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2244,'06230','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44038,'75232','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13527,'28338','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4998,'12975','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29788,'53128','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8930,'20035','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20932,'39421','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44819,'76365','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28110,'50163','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8775,'19550','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32850,'57370','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16625,'32438','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41935,'72031','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53740,'97304','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48815,'84068','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(23751,'44624','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22773,'43111','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23718,'44513','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(606,'02054','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17385,'33611','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16510,'32255','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25201,'46702','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23746,'44620','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52807,'95624','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16842,'32754','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43960,'75144','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43445,'74340','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3078,'08225','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49104,'85003','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51885,'93647','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52797,'95615','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35815,'62019','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53991,'97738','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52478,'95148','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38259,'65633','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25560,'47112','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25898,'47470','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25198,'46699','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26031,'47703','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26356,'48098','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31147,'55171','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29732,'53073','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28581,'50625','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19322,'37146','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16413,'32136','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28191,'50240','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51141,'92136','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51760,'93460','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41701,'71667','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22742,'43076','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31788,'56113','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29496,'52590','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5993,'14727','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8893,'19970','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(12583,'27012','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(12291,'26278','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13013,'27640','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3311,'08853','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37762,'64770','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5287,'13428','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36477,'62829','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43441,'74337','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46472,'78705','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48701,'83833','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54713,'99022','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51326,'92399','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9062,'20184','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14075,'29032','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22004,'41332','Wolfe','21237','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18400,'35661','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32731,'57266','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46656,'79014','Hemphill','48211','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5235,'13338','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18140,'35180','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6469,'15445','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50998,'91802','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35823,'62026','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38313,'65673','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36466,'62820','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11210,'24256','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38248,'65626','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11972,'25647','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53503,'96859','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(17576,'33904','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50262,'89107','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50612,'90306','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6271,'15122','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22490,'42445','Lyon','21143','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6902,'16115','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7526,'17125','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28382,'50464','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7906,'17941','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31845,'56156','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3254,'08741','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29817,'53156','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52728,'95503','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11454,'24593','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49004,'84636','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(16604,'32423','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35227,'61264','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54313,'98295','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11996,'25690','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30964,'54968','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23175,'43730','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29985,'53560','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42614,'72854','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41055,'70559','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34712,'60445','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22598,'42733','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27670,'49734','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28372,'50458','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3925,'10553','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30277,'54141','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17428,'33686','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54345,'98338','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5939,'14611','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45272,'76943','Crockett','48105','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39245,'67401','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3952,'10601','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22595,'42732','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26006,'47633','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17545,'33860','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21253,'40003','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19003,'36738','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5271,'13410','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50690,'90720','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25336,'46835','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52270,'94601','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48073,'81621','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32090,'56342','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29340,'52323','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18196,'35254','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20437,'38726','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42529,'72738','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49277,'85298','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49269,'85283','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44157,'75436','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43402,'74136','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38080,'65348','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24479,'45688','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31379,'55556','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20513,'38843','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48053,'81504','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27434,'49421','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34130,'59403','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23745,'44619','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25990,'47612','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27910,'50022','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13871,'28655','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18962,'36612','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39195,'67232','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36645,'62934','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32203,'56464','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2602,'07046','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6579,'15628','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28195,'50243','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(687,'02205','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16230,'31795','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13611,'28408','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3714,'10030','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43572,'74547','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27990,'50070','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17468,'33759','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8183,'18446','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41642,'71477','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38013,'65270','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36824,'63106','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16425,'32148','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16586,'32402','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16967,'32941','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42909,'73189','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9841,'21722','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13092,'27831','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21083,'39653','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19131,'37011','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28157,'50223','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18149,'35188','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40611,'69135','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35971,'62257','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19366,'37185','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43943,'75124','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34148,'59420','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32505,'57003','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16404,'32128','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19267,'37095','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17985,'35006','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10914,'23890','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24990,'46260','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53405,'96743','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(42781,'73061','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12630,'27054','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22662,'43016','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1637,'04671','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15813,'31061','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27687,'49747','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36653,'62939','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34692,'60431','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7654,'17371','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24516,'45727','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48852,'84108','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(35257,'61313','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33590,'58483','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4988,'12962','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18273,'35490','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11276,'24354','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8762,'19539','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39780,'68067','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39104,'67108','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44180,'75452','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15057,'30213','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15311,'30449','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12937,'27568','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19141,'37016','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27200,'49098','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54391,'98385','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53925,'97522','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43124,'73720','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34183,'59454','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12628,'27052','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18299,'35552','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2853,'07801','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8621,'19341','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54871,'99347','Garfield','53023','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53289,'96522','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51245,'92282','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11941,'25562','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2243,'06226','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22421,'42343','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12437,'26554','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35524,'61571','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34176,'59450','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34099,'59332','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2133,'06034','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32120,'56362','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31668,'56011','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49100,'84790','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47369,'80120','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46486,'78721','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15321,'30455','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28635,'50660','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30479,'54472','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54002,'97756','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44824,'76370','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32825,'57355','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22771,'43110','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1811,'05048','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2137,'06040','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(53496,'96848','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50190,'88589','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(42776,'73057','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41899,'72012','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40987,'70503','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38458,'65789','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51956,'93776','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47614,'80537','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46269,'78502','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24270,'45347','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5616,'14041','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8357,'18911','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9033,'20148','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19574,'37419','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53143,'96094','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13804,'28606','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(677,'02187','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30657,'54655','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3157,'08510','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28056,'50134','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23260,'43824','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25379,'46915','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35620,'61752','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36392,'62689','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29847,'53192','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41703,'71667','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17814,'34449','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26810,'48707','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1533,'04463','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50529,'90071','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32724,'57263','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19934,'38057','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26224,'47965','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48894,'84171','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47049,'79530','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42478,'72669','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14516,'29608','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22866,'43222','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11624,'24986','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30742,'54754','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49033,'84712','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(55016,'99658','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42476,'72666','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11686,'25085','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18044,'35063','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21796,'40965','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19649,'37711','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25239,'46742','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4123,'11247','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7702,'17547','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21736,'40823','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11121,'24133','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33661,'58563','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34570,'60136','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48989,'84620','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21066,'39638','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3073,'08219','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29462,'52566','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36838,'63119','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2088,'05857','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16409,'32132','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8147,'18415','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10961,'23947','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18574,'36023','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11437,'24572','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(236,'01039','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52394,'95015','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48898,'84190','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6775,'15905','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1355,'04062','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12506,'26681','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17960,'34974','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18699,'36177','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26470,'48217','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25733,'47330','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32416,'56686','Lake of the Woods','27077','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(102,'00773','Luquillo','72089','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(49810,'87502','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(27010,'48881','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29047,'51564','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19895,'38019','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26037,'47711','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47922,'81124','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33248,'58047','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8600,'19244','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31891,'56187','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8136,'18373','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28016,'50107','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11851,'25361','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(147,'00918','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51923,'93715','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50556,'90201','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35315,'61360','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(654,'02140','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17294,'33484','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(347,'01341','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19606,'37650','Unicoi','47171','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28792,'51035','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53795,'97362','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(38063,'65335','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33528,'58436','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5008,'12986','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14417,'29485','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15986,'31513','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28506,'50571','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17026,'33036','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30129,'53929','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47498,'80305','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47912,'81092','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35803,'62010','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11921,'25524','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34222,'59522','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(18810,'36370','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19398,'37219','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3795,'10173','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22371,'42256','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20935,'39423','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47707,'80747','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53199,'96156','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45845,'77853','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40326,'68817','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35198,'61236','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14294,'29346','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22061,'41543','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41928,'72027','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9782,'21643','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50412,'89512','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47761,'80835','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41692,'71661','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14001,'28771','Graham','37075','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1395,'04110','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(994,'02919','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(12572,'26866','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22652,'43011','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19099,'36867','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30492,'54482','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23095,'43548','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54458,'98511','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3876,'10502','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3217,'08618','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(784,'02481','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43612,'74630','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53597,'97062','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53839,'97409','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52997,'95939','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43412,'74153','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21990,'41271','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2333,'06408','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31020,'55025','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15377,'30519','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36127,'62421','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35996,'62272','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33660,'58563','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26357,'48099','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25739,'47334','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22513,'42464','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16807,'32709','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50919,'91607','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41985,'72072','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41244,'70825','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37041,'63474','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7436,'17039','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25307,'46793','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14006,'28774','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1492,'04411','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13427,'28221','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30577,'54559','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10610,'23225','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10434,'23009','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28104,'50160','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27476,'49457','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52229,'94558','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49037,'84716','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48936,'84335','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47766,'80860','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35320,'61363','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8047,'18210','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49406,'85617','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47364,'80113','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35811,'62016','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35720,'61870','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3838,'10304','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35670,'61826','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18171,'35220','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15901,'31206','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5765,'14416','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32498,'56967','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(27729,'49784','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26161,'47920','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8160,'18425','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27968,'50058','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48405,'83276','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(18501,'35952','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1220,'03803','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12392,'26438','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27060,'48937','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22037,'41501','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54705,'99014','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54968,'99606','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(18192,'35244','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8348,'18847','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55116,'99769','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(26464,'48211','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34509,'60083','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25784,'47360','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18819,'36401','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49919,'87827','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51790,'93529','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35149,'61078','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41509,'71329','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51608,'93202','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53531,'96970','Marshall Islands','68020','MH','Marshall Islands',0,'2013-07-03 15:17:54',NULL,NULL),(31783,'56101','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(704,'02298','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8947,'20052','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35491,'61541','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44820,'76365','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16806,'32708','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38733,'66532','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44314,'75647','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52291,'94623','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53392,'96728','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(5633,'14060','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34854,'60559','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11661,'25051','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31890,'56187','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27146,'49061','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18774,'36317','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49638,'86508','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49909,'87749','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50728,'90844','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52989,'95929','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29454,'52561','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33234,'58038','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31146,'55170','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29687,'53034','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22166,'41810','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28230,'50264','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26991,'48870','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37608,'64622','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42350,'72525','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45528,'77363','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50520,'90062','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34618,'60176','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5427,'13676','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1926,'05454','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18941,'36578','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30607,'54618','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47481,'80264','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49124,'85023','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49324,'85352','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47050,'79532','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42603,'72845','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40138,'68641','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6706,'15772','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19970,'38108','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48228,'82524','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48230,'82602','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(25048,'46356','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11181,'24218','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7964,'18032','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17525,'33841','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9154,'20393','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(23736,'44612','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42611,'72852','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15218,'30341','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8582,'19177','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4063,'11040','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4774,'12575','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7965,'18034','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14645,'29715','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48668,'83735','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50081,'88343','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(1912,'05442','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(26626,'48436','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9926,'21841','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15189,'30317','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33172,'57770','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(367,'01376','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11632,'25007','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5774,'14423','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27150,'49065','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27024,'48890','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22760,'43102','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18018,'35040','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47786,'80914','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12674,'27209','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9989,'22042','Falls Church City','51610','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20189,'38449','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26423,'48168','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4708,'12502','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53431,'96770','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50283,'89128','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36732,'63012','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30852,'54861','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30641,'54642','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27655,'49722','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31079,'55075','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1114,'03284','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19034,'36764','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37084,'63558','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53128,'96076','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(374,'01432','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16909,'32831','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12556,'26836','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32969,'57477','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13397,'28168','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15762,'31031','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30030,'53593','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18666,'36101','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4589,'12250','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24829,'46113','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24592,'45816','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45888,'77960','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45925,'77995','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46296,'78553','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4390,'12019','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12111,'25920','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17846,'34601','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20881,'39338','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42496,'72686','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46689,'79036','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5471,'13750','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(197,'00981','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51656,'93252','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13085,'27827','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34178,'59452','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(48539,'83537','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51237,'92274','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23762,'44628','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51465,'92701','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8726,'19494','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13203,'27937','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12699,'27247','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15823,'31066','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44879,'76443','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51162,'92165','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1453,'04286','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31936,'56231','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25724,'47325','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46644,'79003','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49947,'88011','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6027,'14766','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51488,'92808','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51301,'92365','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7565,'17240','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35126,'61063','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8724,'19492','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27353,'49325','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35691,'61846','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43641,'74723','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10185,'22548','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1000,'03033','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(13941,'28719','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15951,'31327','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35351,'61415','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24455,'45672','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28261,'50308','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1324,'04017','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1406,'04219','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17652,'34023','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(26568,'48371','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46278,'78526','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52560,'95305','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19555,'37397','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16320,'32026','Union','12125','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3407,'09143','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16298,'31914','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36351,'62649','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35219,'61259','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43222,'73859','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42977,'73503','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40541,'69022','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26295,'48032','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19391,'37213','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43949,'75132','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48086,'81633','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49752,'87158','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53437,'96777','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(6886,'16063','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35841,'62047','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34456,'60021','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27453,'49436','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34324,'59758','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46289,'78545','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2082,'05848','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(33329,'58220','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10290,'22734','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28226,'50261','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28045,'50126','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18921,'36553','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36849,'63126','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40960,'70449','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47118,'79702','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47307,'80016','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11583,'24895','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(361,'01366','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35684,'61842','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33257,'58052','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5156,'13158','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53337,'96622','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(50813,'91309','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50521,'90063','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13704,'28518','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29718,'53061','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40189,'68715','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7510,'17103','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29581,'52738','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48533,'83533','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48782,'84038','Rich','49033','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52540,'95245','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23038,'43505','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4309,'11782','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19204,'37055','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17348,'33567','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43079,'73651','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10442,'23018','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4500,'12149','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28979,'51521','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15613,'30736','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14522,'29612','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31203,'55336','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37504,'64428','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38115,'65446','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5788,'14437','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35975,'62258','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18091,'35121','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29645,'53006','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37580,'64490','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37891,'65053','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37965,'65231','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38058,'65332','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42089,'72156','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44194,'75460','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54217,'98174','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55077,'99729','Denali','2068','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13130,'27863','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10952,'23938','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16595,'32411','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2960,'08011','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15260,'30401','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5316,'13469','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51274,'92328','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1257,'03846','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(29178,'52134','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24821,'46106','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15503,'30622','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37351,'64028','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37356,'64035','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33775,'58722','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11933,'25545','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18584,'36029','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15320,'30455','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37102,'63621','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38866,'66773','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41940,'72036','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34327,'59760','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33361,'58244','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25806,'47381','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1571,'04553','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17443,'33711','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45988,'78057','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49081,'84762','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50536,'90078','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2331,'06404','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31592,'55946','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30954,'54963','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30225,'54082','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27871,'49959','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20911,'39363','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47548,'80459','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(417,'01524','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8150,'18419','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16996,'33002','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38907,'66849','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39142,'67137','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47737,'80819','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50864,'91380','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52483,'95154','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54803,'99166','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11988,'25672','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44126,'75412','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45921,'77993','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50565,'90222','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5676,'14125','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27471,'49453','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19907,'38034','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9394,'20743','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49333,'85361','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10131,'22448','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37114,'63627','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45656,'77485','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34675,'60416','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6852,'16037','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13873,'28657','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33798,'58740','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10078,'22304','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22708,'43056','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19787,'37860','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16037,'31555','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40352,'68833','Logan','31113','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8026,'18088','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23064,'43522','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39880,'68324','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19729,'37804','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21019,'39540','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39455,'67622','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43571,'74546','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46148,'78263','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54726,'99033','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55036,'99678','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25206,'46706','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1093,'03259','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15671,'30821','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50611,'90305','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53592,'97056','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(820,'02575','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7561,'17236','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32281,'56546','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(1349,'04051','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17002,'33012','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40759,'70030','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49890,'87722','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52897,'95715','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20142,'38361','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18289,'35545','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15600,'30731','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38516,'66035','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40838,'70143','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43282,'74026','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45786,'77642','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33787,'58734','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7240,'16691','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13879,'28662','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32776,'57322','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26636,'48441','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21036,'39571','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39193,'67230','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44875,'76442','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48571,'83612','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(28068,'50141','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21963,'41219','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13069,'27814','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(969,'02889','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(18255,'35469','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34621,'60178','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(101,'00772','Loiza','72087','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(33163,'57761','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30862,'54871','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(421,'01529','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37552,'64469','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53068,'96011','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22026,'41413','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24416,'45640','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27522,'49612','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42035,'72113','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6590,'15640','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44382,'75711','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45293,'77007','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47371,'80122','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7414,'17021','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36462,'62817','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19459,'37330','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31288,'55395','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39021,'67021','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41823,'71901','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49946,'88009','Hidalgo','35023','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(31752,'56078','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1730,'04923','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(35226,'61263','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53599,'97064','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50929,'91618','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50621,'90403','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48227,'82523','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47179,'79766','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38195,'65583','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26943,'48836','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20159,'38374','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8886,'19963','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(10004,'22101','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25708,'47283','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49479,'85732','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50625,'90407','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10236,'22642','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13942,'28719','Swain','37173','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29477,'52573','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50636,'90507','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54210,'98160','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31480,'55747','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25322,'46805','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35172,'61107','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35043,'60962','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34647,'60204','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20864,'39327','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25102,'46507','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53932,'97527','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(1984,'05657','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(32655,'57216','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11279,'24363','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53270,'96386','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(34878,'60607','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24067,'45123','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18771,'36316','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14313,'29374','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38011,'65265','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37695,'64681','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18615,'36046','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14537,'29627','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11294,'24401','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33667,'58568','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32829,'57359','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28860,'51238','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8587,'19183','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22686,'43033','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15404,'30534','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15501,'30622','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39664,'67867','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40774,'70051','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45128,'76690','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46249,'78412','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34604,'60162','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7312,'16850','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4071,'11055','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26315,'48051','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15368,'30516','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6231,'15063','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13207,'27942','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35139,'61071','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25525,'47025','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36930,'63353','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48292,'82839','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51799,'93541','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12875,'27519','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30724,'54739','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7831,'17824','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14847,'30043','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15261,'30410','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23581,'44276','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5111,'13114','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53419,'96757','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41012,'70522','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12569,'26855','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31139,'55146','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14962,'30125','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20517,'38847','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27352,'49325','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25477,'46984','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22370,'42256','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44618,'76058','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51702,'93380','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8159,'18424','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13129,'27863','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31138,'55145','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14398,'29471','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51277,'92332','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51567,'93033','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51758,'93457','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54421,'98421','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50230,'89037','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(28166,'50228','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25884,'47460','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23437,'44089','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37227,'63822','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36589,'62898','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34522,'60095','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4175,'11426','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15915,'31220','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21496,'40330','Mercer','21167','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40452,'68935','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41305,'71049','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53800,'97367','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13749,'28556','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53954,'97622','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51123,'92116','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47957,'81201','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33866,'58793','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30195,'54004','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37074,'63549','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9561,'21051','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14503,'29593','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15670,'30820','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39507,'67651','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41246,'70827','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47124,'79706','Upton','48461','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(523,'01845','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22107,'41643','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37043,'63501','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39512,'67654','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3904,'10528','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8864,'19939','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(28316,'50420','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10370,'22923','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24806,'46074','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14196,'29151','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45514,'77355','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51040,'91980','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13014,'27650','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25192,'46628','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20570,'38880','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33360,'58243','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47438,'80225','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48522,'83469','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(55067,'99714','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(35324,'61368','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1551,'04490','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24597,'45820','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6664,'15727','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31573,'55929','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14725,'29849','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28295,'50359','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23658,'44431','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24066,'45123','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27074,'49010','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27164,'49075','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45485,'77327','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53908,'97489','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7822,'17821','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19140,'37015','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27316,'49302','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5871,'14525','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3905,'10530','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17958,'34973','Okeechobee','12093','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39084,'67067','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47574,'80497','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3742,'10104','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27935,'50039','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17016,'33026','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43140,'73735','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33699,'58625','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28647,'50668','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(55047,'99689','Yakutat','2282','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13245,'28001','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36561,'62883','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12453,'26575','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30335,'54214','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4093,'11213','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15097,'30238','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18764,'36311','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16642,'32456','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51312,'92377','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31102,'55101','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5463,'13743','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29081,'51638','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35180,'61111','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54236,'98206','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43833,'75019','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17478,'33770','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15073,'30223','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1478,'04353','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29268,'52225','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15148,'30286','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21416,'40213','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53687,'97215','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28983,'51525','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4262,'11725','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22560,'42647','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49917,'87824','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48338,'83120','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31993,'56278','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26089,'47840','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41204,'70775','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53941,'97537','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12347,'26374','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10248,'22654','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42538,'72744','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47803,'80930','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49788,'87328','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(55042,'99684','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13419,'28214','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29983,'53559','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33702,'58630','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54046,'97848','Wheeler','41069','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54116,'98027','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21079,'39649','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21102,'39664','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21377,'40146','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28936,'51444','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25375,'46911','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39429,'67570','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43116,'73716','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12864,'27512','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9151,'20390','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2974,'08027','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37536,'64455','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54203,'98144','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27197,'49096','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7254,'16725','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32470,'56754','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25694,'47270','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20516,'38846','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16203,'31779','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1905,'05405','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36480,'62831','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39178,'67213','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30480,'54473','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26434,'48178','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37845,'65014','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25084,'46403','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10802,'23628','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28745,'51008','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39853,'68301','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40127,'68637','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40916,'70381','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46338,'78599','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52149,'94294','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54878,'99352','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37664,'64656','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30069,'53790','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34954,'60699','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34101,'59333','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30252,'54120','Florence','55037','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16315,'32011','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49243,'85250','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53662,'97141','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54030,'97834','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(406,'01509','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1312,'04004','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34476,'60045','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52617,'95365','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6013,'14745','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45533,'77368','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29735,'53075','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35735,'61882','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8252,'18618','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31619,'55963','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3680,'09874','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43810,'74962','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49789,'87347','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52236,'94565','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55058,'99704','Denali','2068','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30063,'53783','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13976,'28749','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20607,'38940','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21118,'39701','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29463,'52567','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27493,'49508','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50332,'89193','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(7782,'17756','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12135,'25978','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27371,'49333','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50710,'90804','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53659,'97140','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12521,'26716','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17518,'33834','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47646,'80623','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15940,'31316','Long','13183','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1185,'03607','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8821,'19732','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(31481,'55748','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28240,'50271','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20293,'38570','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14917,'30101','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18379,'35633','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51206,'92235','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51663,'93260','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3500,'09510','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48435,'83332','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(35556,'61652','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24996,'46268','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27431,'49418','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26620,'48432','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41046,'70549','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50350,'89407','Churchill','32001','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33167,'57764','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50783,'91185','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38062,'65335','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30598,'54612','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10343,'22850','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(280,'01102','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33774,'58721','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33176,'57775','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5084,'13078','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27195,'49094','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26910,'48813','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37949,'65110','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45043,'76597','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46506,'78737','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32272,'56540','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30768,'54766','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28175,'50233','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37342,'64019','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38024,'65282','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(176,'00957','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(41615,'71455','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40643,'69155','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38422,'65764','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13029,'27703','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34820,'60536','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17198,'33331','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18146,'35185','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19745,'37819','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20614,'38947','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22725,'43066','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41597,'71438','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50045,'88252','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(11275,'24352','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32195,'56453','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40044,'68458','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41635,'71469','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45504,'77344','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7806,'17779','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27192,'49093','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27428,'49416','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2151,'06059','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43468,'74361','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(992,'02917','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(10582,'23181','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1530,'04460','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1787,'04986','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33350,'58236','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25410,'46935','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12033,'25729','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23977,'44887','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22563,'42701','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14134,'29081','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21961,'41216','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37586,'64493','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48997,'84629','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11277,'24360','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3597,'09728','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16356,'32071','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40206,'68729','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41378,'71150','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48854,'84110','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(350,'01344','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25573,'47120','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5916,'14569','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24409,'45630','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20982,'39474','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37782,'64790','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54080,'97908','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13391,'28163','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32573,'57045','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29317,'52308','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28300,'50364','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21645,'40511','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51447,'92673','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48729,'83861','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44135,'75420','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5174,'13205','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1436,'04261','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18408,'35674','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45655,'77484','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53080,'96024','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2543,'06904','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(46945,'79358','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47748,'80828','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30319,'54201','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10064,'22226','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9656,'21218','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7360,'16927','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29125,'52041','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2277,'06266','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26239,'47975','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21389,'40161','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54667,'98932','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12095,'25901','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36764,'63037','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40205,'68728','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49693,'87041','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44259,'75559','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(480,'01740','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(587,'02021','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33091,'57648','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47431,'80220','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53292,'96532','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(11980,'25661','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24396,'45618','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16846,'32757','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20005,'38157','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5642,'14068','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43955,'75140','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29158,'52072','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1152,'03466','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2545,'06906','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16445,'32178','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19377,'37191','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17544,'33860','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30244,'54112','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49294,'85322','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41134,'70661','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39706,'68004','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27401,'49349','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13565,'28368','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13631,'28434','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11246,'24316','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29515,'52626','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16226,'31792','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17188,'33321','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23981,'44889','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41599,'71439','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42596,'72839','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46928,'79346','Cochran','48079','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32739,'57270','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12075,'25855','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9744,'21543','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50950,'91735','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50799,'91222','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45940,'78009','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43649,'74729','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41521,'71343','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41080,'70592','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21306,'40049','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18067,'35089','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29631,'52803','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43741,'74859','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13799,'28604','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30968,'54971','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22070,'41557','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42353,'72528','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48429,'83324','Lincoln','16063','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(35457,'61490','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12227,'26178','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7294,'16832','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8307,'18767','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3154,'08502','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37654,'64649','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22317,'42156','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23350,'43976','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(444,'01571','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5118,'13121','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26091,'47841','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13823,'28622','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16559,'32337','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47267,'79947','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49232,'85224','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49375,'85541','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51315,'92384','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54439,'98467','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29668,'53019','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16007,'31537','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51000,'91804','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48977,'84536','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42360,'72532','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20331,'38606','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27013,'48883','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39421,'67565','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39715,'68014','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40161,'68660','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46515,'78746','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48371,'83228','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48464,'83401','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49678,'87025','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54018,'97818','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9625,'21158','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32680,'57234','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21551,'40380','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4378,'12007','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43011,'73543','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20492,'38824','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8350,'18850','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8161,'18426','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2553,'06921','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20478,'38776','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19572,'37415','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48589,'83632','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32404,'56678','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(18107,'35136','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4400,'12029','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52118,'94250','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15719,'31012','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36120,'62417','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42167,'72331','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38093,'65360','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13424,'28218','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1528,'04457','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22752,'43084','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3046,'08097','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44758,'76248','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50271,'89116','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52380,'95002','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54830,'99214','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55101,'99754','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(6678,'15742','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7081,'16375','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1669,'04746','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20086,'38316','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20621,'38952','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5805,'14463','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25050,'46360','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21977,'41254','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9067,'20187','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18411,'35739','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15995,'31520','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34256,'59626','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3974,'10805','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32996,'57534','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32409,'56681','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(54048,'97856','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53176,'96129','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52353,'94949','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38041,'65321','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25087,'46405','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6957,'16214','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13019,'27675','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1709,'04855','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19945,'38067','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24682,'45875','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21525,'40357','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42479,'72670','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44895,'76453','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45225,'76872','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53225,'96271','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54099,'98009','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23852,'44708','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17120,'33169','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9523,'20918','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35511,'61560','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34804,'60520','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29352,'52330','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29164,'52076','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26493,'48239','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26013,'47639','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10766,'23488','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14921,'30102','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32309,'56570','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10758,'23467','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30028,'53589','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17881,'34683','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51542,'92899','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52303,'94705','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1500,'04419','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17401,'33629','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13962,'28737','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5324,'13476','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53823,'97389','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53945,'97541','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9997,'22066','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22002,'41317','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1328,'04022','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17223,'33408','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40260,'68764','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50420,'89533','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(7850,'17845','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2549,'06912','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18592,'36033','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20571,'38901','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51815,'93560','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51153,'92153','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48731,'83861','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42891,'73159','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42822,'73096','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41693,'71661','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36810,'63087','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7624,'17331','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34955,'60701','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34408,'59918','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33952,'59055','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25277,'46774','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28333,'50433','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48099,'81642','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29917,'53511','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2819,'07726','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49804,'87420','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42150,'72312','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38760,'66548','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8041,'18195','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30111,'53916','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1261,'03850','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15506,'30624','Elbert','13105','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31933,'56229','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18121,'35150','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5961,'14646','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5806,'14464','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35507,'61559','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44201,'75471','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31093,'55087','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38538,'66054','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13065,'27811','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26219,'47960','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26526,'48315','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14339,'29414','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48683,'83811','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45996,'78062','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22885,'43270','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23250,'43811','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28197,'50244','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28832,'51062','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14642,'29712','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30292,'54157','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29146,'52060','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10579,'23177','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9844,'21733','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19044,'36775','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34557,'60126','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5907,'14559','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13662,'28455','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9405,'20754','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23436,'44089','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8362,'18915','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27328,'49309','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30692,'54722','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52743,'95536','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50080,'88342','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(23424,'44076','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4160,'11411','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3586,'09716','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(44260,'75559','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46012,'78074','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17361,'33584','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25897,'47469','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51539,'92885','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43159,'73754','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40626,'69147','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35774,'61937','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4864,'12786','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3662,'09839','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20965,'39456','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45083,'76649','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39001,'67004','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36447,'62803','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4681,'12470','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3587,'09717','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52034,'94066','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50203,'89009','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(39463,'67629','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35827,'62031','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39242,'67363','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36865,'63138','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5682,'14131','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8988,'20108','Manassas City','51683','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13071,'27816','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10223,'22624','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10762,'23482','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5491,'13778','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31496,'55764','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16608,'32426','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22307,'42141','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35427,'61474','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35753,'61917','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48082,'81630','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54434,'98447','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35993,'62271','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24176,'45255','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18837,'36442','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21629,'40488','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16610,'32428','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22748,'43081','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29414,'52531','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9158,'20401','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2204,'06115','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44890,'76449','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14240,'29217','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38356,'65715','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48715,'83847','Boundary','16021','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(11997,'25691','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11042,'24054','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20299,'38574','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15922,'31301','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22462,'42402','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26126,'47871','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49123,'85022','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49118,'85017','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9638,'21206','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11811,'25287','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9756,'21610','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19953,'38075','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47362,'80112','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11137,'24146','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1128,'03307','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(51540,'92886','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47549,'80461','Lake','8065','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46375,'78624','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12773,'27325','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19603,'37643','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10842,'23821','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29677,'53023','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23577,'44273','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18019,'35040','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20087,'38317','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51427,'92637','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51285,'92340','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48859,'84115','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47151,'79739','Reagan','48383','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54374,'98368','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51399,'92593','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48735,'83867','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37254,'63852','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14619,'29687','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25524,'47024','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19499,'37357','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1559,'04530','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34168,'59443','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34684,'60423','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17162,'33266','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28202,'50248','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27972,'50061','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12736,'27291','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12396,'26443','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15598,'30728','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36164,'62443','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40169,'68664','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45273,'76943','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27261,'49247','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47034,'79520','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21062,'39632','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21099,'39663','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21630,'40489','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36367,'62667','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33458,'58362','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45384,'77093','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39318,'67468','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9571,'21071','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42278,'72438','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47749,'80829','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37926,'65078','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7027,'16326','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18789,'36331','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18868,'36475','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4229,'11581','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24653,'45858','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30468,'54465','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7243,'16693','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20682,'39069','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8984,'20105','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12605,'27028','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(16168,'31749','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52783,'95602','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(303,'01203','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42806,'73078','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42022,'72104','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39727,'68023','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34326,'59759','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14698,'29832','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29730,'53070','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49082,'84763','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52419,'95046','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53883,'97457','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54027,'97828','Wallowa','41063','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10679,'23324','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30393,'54413','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28737,'51003','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22823,'43150','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31772,'56093','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38522,'66041','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35307,'61353','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14453,'29547','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6797,'15937','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6800,'15942','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7954,'18017','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28029,'50116','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6892,'16103','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19882,'38006','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4473,'12121','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48732,'83864','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50070,'88324','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50124,'88518','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(304,'01220','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20162,'38375','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51393,'92586','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24889,'46160','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24325,'45404','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44616,'76054','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41487,'71302','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39716,'68015','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38225,'65611','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35713,'61859','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18563,'36010','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11779,'25245','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27623,'49688','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6152,'14887','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19726,'37802','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16096,'31637','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23001,'43442','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3547,'09607','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53544,'97013','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51850,'93620','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50953,'91740','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49012,'84645','Juab','49023','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37455,'64145','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36913,'63343','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23692,'44481','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54974,'99612','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46231,'78387','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37646,'64645','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31013,'55018','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5798,'14453','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4608,'12308','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46761,'79083','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38863,'66772','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19969,'38107','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3306,'08846','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44795,'76302','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33368,'58257','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23933,'44848','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14102,'29054','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36664,'62946','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4915,'12854','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5335,'13485','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28673,'50707','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16945,'32906','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1336,'04034','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19310,'37141','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53396,'96732','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52707,'95469','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42794,'73071','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41524,'71348','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53959,'97627','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(40836,'70141','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33065,'57631','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13418,'28213','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5730,'14221','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5014,'12995','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10958,'23944','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21983,'41262','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32670,'57226','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(675,'02185','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37024,'63463','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20971,'39462','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32459,'56742','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20964,'39456','George','28039','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19666,'37725','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25310,'46795','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1979,'05652','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2043,'05766','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(49845,'87538','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(47037,'79525','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44731,'76209','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10940,'23924','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22192,'41848','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48999,'84631','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45496,'77337','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42239,'72401','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39279,'67441','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38786,'66617','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33337,'58227','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6398,'15336','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18276,'35502','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32356,'56629','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23943,'44854','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54542,'98609','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41529,'71354','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41130,'70657','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39831,'68147','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34792,'60511','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18500,'35952','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3208,'08604','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30185,'53965','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13039,'27711','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46907,'79325','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3755,'10117','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39165,'67159','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53903,'97481','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53610,'97077','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46748,'79077','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24916,'46173','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37233,'63826','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14091,'29045','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3975,'10901','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53416,'96754','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53826,'97391','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49268,'85282','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39790,'68103','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39433,'67573','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21771,'40914','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21843,'41035','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39602,'67764','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6912,'16125','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6219,'15052','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27547,'49632','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45836,'77838','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53398,'96734','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(4012,'10960','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27340,'49316','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22041,'41513','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26853,'48746','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54882,'99357','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46676,'79027','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10753,'23463','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17284,'33474','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10119,'22435','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8637,'19357','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1138,'03447','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2835,'07747','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5931,'14603','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37624,'64632','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47059,'79536','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27947,'50047','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32887,'57424','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32715,'57258','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52531,'95232','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43181,'73764','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42503,'72704','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35095,'61039','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10817,'23690','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8496,'19083','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31909,'56218','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9209,'20501','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(9028,'20142','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43852,'75034','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45637,'77471','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16798,'32701','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30660,'54656','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29705,'53048','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51239,'92275','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43759,'74872','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42393,'72567','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35446,'61483','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35395,'61450','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7791,'17765','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8164,'18428','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41593,'71433','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16971,'32950','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6936,'16148','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27572,'49649','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19456,'37328','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29513,'52626','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(14882,'30072','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8196,'18458','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26408,'48159','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48549,'83545','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(55120,'99773','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37656,'64651','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37128,'63636','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35714,'61862','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3705,'10021','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21668,'40574','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47448,'80232','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16864,'32779','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22183,'41836','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(826,'02632','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20553,'38868','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13967,'28741','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3533,'09587','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52765,'95560','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43707,'74837','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36565,'62884','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13616,'28412','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22217,'42033','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24764,'46049','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9142,'20370','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20230,'38481','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4226,'11577','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18567,'36015','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14400,'29472','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22433,'42350','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49302,'85331','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44176,'75450','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41677,'71646','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25904,'47513','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18949,'36587','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22156,'41766','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(989,'02914','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(7356,'16922','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54044,'97846','Wallowa','41063','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45647,'77479','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39827,'68142','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36615,'62916','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10947,'23936','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54529,'98595','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41779,'71831','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36642,'62932','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12756,'27310','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30408,'54423','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24001,'45013','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17011,'33021','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51986,'93930','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37828,'64866','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14301,'29356','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4274,'11739','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41520,'71343','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20694,'39079','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19821,'37880','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6634,'15689','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32704,'57251','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45752,'77584','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42575,'72821','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38471,'65809','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27335,'49315','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23014,'43452','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22270,'42082','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12303,'26292','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6530,'15541','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6887,'16063','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4806,'12724','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24240,'45328','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33828,'58763','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48523,'83501','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39999,'68423','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38698,'66502','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35261,'61316','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5870,'14525','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23766,'44632','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27243,'49233','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27669,'49733','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30251,'54119','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37145,'63653','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33899,'59003','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32098,'56347','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(886,'02745','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19449,'37325','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10234,'22641','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5508,'13803','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13246,'28002','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31791,'56115','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25166,'46567','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39325,'67475','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48643,'83705','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(21832,'41030','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1198,'03752','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24115,'45174','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50125,'88519','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47092,'79561','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43287,'74030','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34355,'59831','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33756,'58701','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20285,'38565','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16339,'32054','Union','12125','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9595,'21105','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15953,'31329','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2044,'05767','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(6753,'15851','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3132,'08345','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28716,'50862','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20296,'38573','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27967,'50058','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6718,'15784','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13094,'27833','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44148,'75429','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48127,'82052','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44644,'76084','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13706,'28519','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6567,'15618','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5881,'14533','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24209,'45309','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2725,'07457','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32627,'57078','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24273,'45349','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51962,'93791','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54191,'98125','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47779,'80907','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(33461,'58365','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15805,'31058','Marion','13197','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3302,'08836','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1534,'04464','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23526,'44216','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49676,'87023','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44892,'76450','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35822,'62025','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36117,'62414','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54787,'99151','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45269,'76939','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40834,'70131','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16415,'32138','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5405,'13654','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24330,'45412','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24523,'45734','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(248,'01062','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31483,'55749','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29526,'52639','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10264,'22712','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17862,'34638','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19263,'37091','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28330,'50432','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11648,'25036','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17856,'34610','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15116,'30258','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15170,'30303','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50939,'91715','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37878,'65046','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35155,'61084','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9570,'21065','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6593,'15642','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26065,'47802','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30496,'54486','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29249,'52215','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30321,'54202','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43777,'74930','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43161,'73754','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26981,'48859','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4445,'12075','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(488,'01752','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38368,'65725','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27949,'50048','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51334,'92407','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40479,'68949','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9578,'21078','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31090,'55083','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48972,'84531','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37663,'64655','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23580,'44275','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19948,'38069','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16701,'32560','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38146,'65501','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38910,'66851','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48673,'83802','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49839,'87532','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49281,'85303','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45933,'78005','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35766,'61930','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33322,'58212','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23121,'43604','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24979,'46250','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29063,'51577','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46588,'78885','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46363,'78617','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9242,'20541','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(31284,'55391','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3510,'09545','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(23622,'44333','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3473,'09387','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(24706,'45890','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(697,'02241','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16148,'31721','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53,'00693','Vega Baja','72145','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(52388,'95009','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35340,'61402','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33484,'58381','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33320,'58212','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8584,'19179','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24272,'45348','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13050,'27803','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7142,'16515','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19423,'37304','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9472,'20854','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12457,'26582','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39898,'68335','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42354,'72529','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11970,'25644','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54659,'98920','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48268,'82723','Weston','56045','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47206,'79838','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3207,'08603','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14478,'29571','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8830,'19805','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(48840,'84094','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(33906,'59010','Treasure','30103','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17460,'33742','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4270,'11735','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22819,'43148','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11677,'25071','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5264,'13403','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46541,'78772','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11962,'25628','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11987,'25671','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33492,'58385','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27080,'49012','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23422,'44074','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45542,'77376','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43878,'75057','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36103,'62378','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34418,'59928','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31426,'55605','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54627,'98836','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53105,'96055','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46373,'78623','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35675,'61833','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34629,'60185','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33293,'58077','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54955,'99583','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53252,'96351','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(46166,'78292','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45911,'77984','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28271,'50318','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18183,'35235','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6863,'16046','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12398,'26444','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34698,'60435','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38532,'66049','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38505,'66025','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1032,'03082','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26070,'47805','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42549,'72756','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51443,'92661','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50806,'91304','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38270,'65640','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37621,'64631','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28596,'50631','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21733,'40818','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9049,'20168','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL);
INSERT INTO `ZipCodeMultiCounty` VALUES (33043,'57579','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30024,'53588','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29975,'53554','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42181,'72346','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(566,'01940','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50754,'91041','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42254,'72419','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8295,'18704','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21906,'41101','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2452,'06712','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(46616,'78948','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41327,'71069','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29399,'52405','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23326,'43946','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18185,'35237','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38862,'66771','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21747,'40843','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15746,'31023','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32114,'56360','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9132,'20307','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(13836,'28631','None','51999','VA','Virginia',0,'2013-07-03 15:17:52',NULL,NULL),(8938,'20042','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53316,'96598','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53123,'96073','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36703,'62974','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26383,'48127','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3753,'10115','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17421,'33677','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47331,'80037','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48817,'84070','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52136,'94279','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35353,'61417','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5624,'14052','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22314,'42153','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(60,'00705','Aibonito','72009','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(20539,'38859','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19881,'38006','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1306,'03909','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(30595,'54603','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26463,'48210','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31458,'55723','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52634,'95381','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40406,'68872','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24075,'45133','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1620,'04646','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10211,'22581','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31019,'55024','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1672,'04751','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7701,'17545','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26152,'47907','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53628,'97113','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49337,'85365','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46674,'79027','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5485,'13763','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50411,'89511','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46295,'78552','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38470,'65808','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24729,'46013','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27929,'50035','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15248,'30374','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47763,'80836','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17899,'34729','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31984,'56270','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31006,'55010','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9288,'20607','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12423,'26527','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16537,'32318','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42827,'73098','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48158,'82215','Platte','56031','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(38745,'66539','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6179,'15009','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27441,'49425','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29944,'53529','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33744,'58651','Bowman','38011','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8727,'19495','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30802,'54817','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35162,'61089','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15341,'30473','Toombs','13279','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52514,'95215','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46142,'78256','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2527,'06875','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22435,'42351','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29042,'51561','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19605,'37645','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13476,'28285','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10643,'23273','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33247,'58047','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31811,'56129','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5348,'13502','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54831,'99215','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36676,'62955','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34140,'59416','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25559,'47112','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52558,'95304','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47674,'80705','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43597,'74571','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18726,'36263','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27614,'49683','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28106,'50161','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21315,'40055','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32390,'56661','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27515,'49599','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15939,'31315','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43277,'74022','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22423,'42343','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31454,'55720','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17599,'33929','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21782,'40940','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53231,'96303','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1802,'05038','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16289,'31902','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17051,'33071','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3497,'09507','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26386,'48131','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4884,'12819','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3918,'10546','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22244,'42054','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3201,'08560','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9215,'20507','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(45841,'77844','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33909,'59013','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40967,'70454','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25871,'47452','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33363,'58250','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(93,'00751','Salinas','72123','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(538,'01880','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6023,'14756','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31465,'55732','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28057,'50134','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21334,'40069','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54528,'98593','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10392,'22947','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31219,'55344','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41468,'71275','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40803,'70083','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39723,'68019','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33429,'58335','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(595,'02040','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19610,'37656','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19467,'37335','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5888,'14538','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8508,'19092','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34742,'60467','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38385,'65735','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47573,'80488','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5794,'14449','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13081,'27823','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35311,'61356','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40196,'68722','Boyd','31015','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3718,'10034','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8636,'19355','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7230,'16680','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14071,'29031','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34174,'59447','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35412,'61465','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38676,'66431','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39857,'68305','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43725,'74851','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54402,'98397','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28728,'50981','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12372,'26415','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18383,'35645','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8326,'18827','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14017,'28785','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5522,'13815','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46198,'78358','Aransas','48007','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47393,'80136','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53352,'96668','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(2796,'07670','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39151,'67146','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38456,'65788','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24253,'45337','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15992,'31518','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15539,'30647','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4444,'12074','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32661,'57220','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28937,'51445','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41180,'70749','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49830,'87522','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(14125,'29074','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3609,'09741','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(25450,'46965','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22288,'42122','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24103,'45162','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40832,'70129','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36652,'62939','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6177,'15006','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13072,'27816','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35498,'61546','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33412,'58323','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29655,'53012','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15096,'30238','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23092,'43547','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24980,'46250','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37503,'64427','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38076,'65347','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7168,'16623','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6766,'15865','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22933,'43336','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50107,'88426','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(8007,'18070','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6244,'15077','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15022,'30173','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(779,'02475','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34268,'59640','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(24053,'45113','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9386,'20735','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52734,'95524','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2081,'05847','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25918,'47524','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25294,'46785','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45330,'77044','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48113,'81657','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36793,'63068','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13024,'27698','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30925,'54940','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25659,'47231','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10837,'23804','Petersburg City','51730','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(680,'02190','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44163,'75440','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43860,'75044','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38454,'65786','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13537,'28345','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12188,'26137','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20094,'38326','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15582,'30701','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4800,'12719','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2060,'05823','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7026,'16323','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9624,'21157','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47478,'80261','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53844,'97414','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(32440,'56726','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(24591,'45815','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(686,'02204','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41651,'71601','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34775,'60502','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34260,'59634','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16442,'32175','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32013,'56291','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23375,'44023','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38663,'66419','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45857,'77867','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52926,'95817','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13715,'28526','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15750,'31025','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15752,'31027','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17422,'33679','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22187,'41840','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53084,'96028','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40592,'69122','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40002,'68424','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18983,'36688','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30754,'54757','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27966,'50058','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16618,'32434','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21433,'40232','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48582,'83627','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51026,'91943','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23555,'44250','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38595,'66110','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40733,'69353','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38702,'66505','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4704,'12496','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16814,'32718','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37302,'63943','Carter','29035','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38852,'66758','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52580,'95324','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26811,'48708','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36831,'63113','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38649,'66407','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3468,'09374','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11378,'24517','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13005,'27625','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9961,'21918','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9711,'21298','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38408,'65753','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44434,'75798','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50841,'91346','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50951,'91737','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12899,'27536','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12267,'26250','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8454,'19035','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43397,'74132','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41903,'72015','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40891,'70345','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31459,'55724','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25751,'47342','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7709,'17555','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38127,'65459','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38626,'66221','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32524,'57016','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8441,'19021','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22214,'42029','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41666,'71638','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47058,'79536','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33552,'58455','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15130,'30272','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26020,'47649','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8134,'18371','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42018,'72101','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10006,'22102','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15323,'30456','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32686,'57238','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30753,'54757','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28854,'51232','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48466,'83402','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49307,'85335','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50575,'90242','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50866,'91382','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44268,'75567','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36600,'62905','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32467,'56750','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30443,'54450','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26648,'48451','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21867,'41055','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6840,'16025','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38918,'66856','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23184,'43734','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12664,'27201','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15617,'30739','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24083,'45142','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52097,'94205','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42859,'73129','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24101,'45159','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14526,'29616','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11530,'24817','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37917,'65074','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43618,'74636','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45418,'77230','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4875,'12808','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18547,'35984','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41459,'71268','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54360,'98354','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48075,'81623','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41746,'71752','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7124,'16441','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36602,'62906','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33470,'58370','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31235,'55357','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24931,'46186','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47819,'80947','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14421,'29493','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4254,'11716','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44716,'76192','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45240,'76886','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46399,'78639','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52150,'94295','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10658,'23294','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17923,'34760','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42366,'72538','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42667,'72948','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7926,'17967','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11435,'24571','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15124,'30266','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44834,'76377','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31123,'55119','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23927,'44844','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47262,'79942','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49061,'84741','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5555,'13856','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5387,'13635','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18767,'36312','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6641,'15696','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21069,'39641','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29054,'51570','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28624,'50652','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37424,'64109','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42449,'72639','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47845,'81021','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54319,'98305','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16825,'32728','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14958,'30124','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15443,'30559','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38230,'65614','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42054,'72126','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51195,'92222','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53119,'96068','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35019,'60951','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31572,'55927','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28495,'50565','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14015,'28783','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(526,'01852','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9937,'21861','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40824,'70121','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53313,'96577','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53741,'97304','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28348,'50444','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27017,'48885','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26009,'47635','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38475,'65890','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51355,'92515','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30106,'53910','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28668,'50682','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5109,'13112','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7813,'17814','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13757,'28564','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29884,'53259','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16782,'32669','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39269,'67432','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40741,'69358','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48806,'84061','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49631,'86446','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53776,'97345','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5593,'14024','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32725,'57263','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10639,'23260','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20197,'38456','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39541,'67675','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54507,'98569','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52847,'95662','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49254,'85261','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42245,'72412','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1674,'04757','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12498,'26671','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11522,'24747','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30582,'54562','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25033,'46341','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23803,'44662','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20165,'38377','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46339,'78602','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48044,'81431','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8253,'18619','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4702,'12494','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2324,'06385','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43908,'75088','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33506,'58418','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25169,'46571','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25039,'46345','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40426,'68901','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41923,'72025','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14974,'30137','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15926,'31303','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17033,'33045','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32335,'56588','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29986,'53560','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37236,'63829','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11364,'24501','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30776,'54768','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17073,'33116','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16684,'32534','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44855,'76427','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52120,'94254','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8080,'18247','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7020,'16317','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35022,'60953','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34501,'60075','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3992,'10925','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30637,'54639','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26271,'48001','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37308,'63951','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40209,'68730','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50428,'89702','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51094,'92075','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33789,'58734','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2378,'06477','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52526,'95230','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24989,'46259','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25156,'46561','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22426,'42345','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20787,'39175','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29634,'52806','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29943,'53528','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2910,'07890','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19944,'38066','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24732,'46016','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25686,'47261','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38308,'65667','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50088,'88349','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6399,'15337','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17956,'34972','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19741,'37815','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33688,'58621','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23942,'44854','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3634,'09809','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54664,'98926','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47258,'79938','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38547,'66062','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3395,'09112','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(30201,'54006','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36771,'63042','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54744,'99111','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5041,'13037','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24837,'46120','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9892,'21788','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11363,'24501','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1341,'04041','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8692,'19443','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34994,'60933','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34718,'60448','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33267,'58057','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32756,'57311','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6663,'15725','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43743,'74860','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48534,'83535','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54947,'99574','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(12858,'27507','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31868,'56170','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25453,'46970','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36932,'63357','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37310,'63953','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24110,'45169','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20998,'39482','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19571,'37414','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6786,'15925','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34593,'60152','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33927,'59031','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2574,'07016','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31323,'55422','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10681,'23326','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17274,'33465','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40496,'68960','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52513,'95213','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8138,'18405','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5329,'13480','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54859,'99336','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51699,'93312','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45758,'77590','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41655,'71603','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16633,'32444','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(380,'01441','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13447,'28244','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13025,'27699','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18034,'35055','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41517,'71340','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52701,'95464','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34330,'59762','Deer Lodge','30023','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31779,'56097','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50212,'89018','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49883,'87710','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41037,'70542','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25471,'46979','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31059,'55056','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24778,'46057','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9121,'20262','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35895,'62086','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51848,'93618','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12379,'26424','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33639,'58542','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18024,'35045','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2846,'07758','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54643,'98855','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38844,'66755','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38773,'66606','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15637,'30802','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26718,'48610','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53469,'96812','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(25088,'46406','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46993,'79413','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50079,'88341','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51980,'93924','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35913,'62203','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50040,'88241','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47243,'79924','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42608,'72851','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37432,'64118','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9353,'20695','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8172,'18437','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8328,'18828','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6108,'14854','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28015,'50106','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42397,'72571','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48388,'83250','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53572,'97035','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45081,'76648','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45090,'76654','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42147,'72303','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41951,'72043','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28797,'51040','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32497,'56965','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(50136,'88531','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(4439,'12069','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14181,'29135','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6676,'15739','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3256,'08750','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25100,'46506','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42066,'72133','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43706,'74836','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44270,'75568','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50091,'88352','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(5797,'14452','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31279,'55388','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18340,'35581','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18813,'36374','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21233,'39861','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50018,'88132','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54287,'98270','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10255,'22663','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34995,'60934','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2519,'06854','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22915,'43323','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29444,'52553','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37228,'63822','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40427,'68901','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44846,'76389','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46323,'78583','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50214,'89020','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48834,'84088','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49922,'87830','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(23698,'44488','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45813,'77713','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17737,'34223','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10855,'23833','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20347,'38621','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23625,'44372','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27,'00650','Florida','72054','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3803,'10199','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37970,'65237','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39648,'67855','Stanton','20187','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46869,'79248','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49006,'84638','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49671,'87018','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52133,'94274','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11444,'24580','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2163,'06071','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25640,'47201','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18302,'35554','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41984,'72070','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29491,'52586','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30037,'53598','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13556,'28363','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11602,'24941','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6318,'15223','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6154,'14889','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17444,'33712','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51563,'93024','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6512,'15502','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13546,'28355','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30664,'54658','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18158,'35208','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18465,'35804','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35839,'62045','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48325,'83025','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(36689,'62962','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33031,'57567','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16609,'32427','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27829,'49895','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27537,'49625','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35527,'61601','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34781,'60504','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45577,'77419','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17347,'33566','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30817,'54830','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32798,'57334','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3708,'10024','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13135,'27868','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36658,'62942','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9738,'21538','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21410,'40207','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39958,'68371','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40808,'70090','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47202,'79835','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54472,'98532','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13880,'28663','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33698,'58625','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54366,'98360','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46647,'79007','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36538,'62868','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35479,'61531','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33239,'58041','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14938,'30108','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25318,'46801','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23041,'43510','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41173,'70743','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(794,'02536','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28521,'50583','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42506,'72714','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38134,'65463','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42697,'73010','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35641,'61775','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54626,'98834','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48927,'84326','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46426,'78656','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36644,'62934','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8925,'20027','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19785,'37854','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22221,'42036','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29037,'51558','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40558,'69030','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48309,'82935','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54844,'99260','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14251,'29228','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6616,'15674','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17692,'34113','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53053,'95986','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18805,'36353','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21374,'40143','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36346,'62642','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35734,'61882','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28247,'50275','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41727,'71725','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43922,'75101','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31838,'56149','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28185,'50237','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10180,'22546','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26349,'48093','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16990,'32969','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18957,'36607','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(55055,'99701','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13773,'28578','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31400,'55579','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7953,'18016','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3902,'10526','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19645,'37709','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40693,'69301','Box Butte','31013','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42797,'73073','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46651,'79010','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49552,'86032','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(12618,'27045','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(39096,'67104','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26129,'47874','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4543,'12195','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28565,'50611','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1842,'05085','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36531,'62863','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28642,'50665','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24252,'45337','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42061,'72131','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48055,'81506','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51019,'91931','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31870,'56170','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13312,'28083','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31805,'56125','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25358,'46885','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11149,'24157','Salem City','51775','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9384,'20732','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36031,'62311','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48781,'84037','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43121,'73718','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42485,'72679','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17302,'33499','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33105,'57660','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32598,'57059','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6723,'15822','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30622,'54628','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28298,'50362','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6095,'14842','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6675,'15738','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15807,'31058','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38075,'65345','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11416,'24553','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46504,'78736','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24407,'45629','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24901,'46164','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10297,'22740','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1063,'03226','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4891,'12828','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43274,'74021','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49706,'87049','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37404,'64082','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31365,'55478','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(708,'02304','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4362,'11962','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8061,'18225','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13834,'28631','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6597,'15650','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12472,'26611','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27488,'49503','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26998,'48874','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2009,'05701','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1566,'04544','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(41052,'70555','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45727,'77555','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30826,'54838','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10642,'23273','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54112,'98023','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51573,'93042','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45849,'77859','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40219,'68735','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7004,'16259','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38847,'66757','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(220,'01020','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8987,'20106','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11658,'25047','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15775,'31036','Pulaski','13235','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39058,'67050','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42862,'73132','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52239,'94568','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23866,'44799','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(553,'01908','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(801,'02543','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8498,'19085','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4828,'12749','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12677,'27214','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12431,'26543','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17726,'34210','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38947,'66932','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14576,'29653','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37639,'64642','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22590,'42728','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36225,'62480','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40293,'68784','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40247,'68756','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15854,'31087','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31181,'55325','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(792,'02534','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36718,'62992','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25343,'46855','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20130,'38355','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19901,'38027','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18258,'35473','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17539,'33855','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10929,'23917','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15551,'30662','Elbert','13105','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54985,'99625','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(28176,'50234','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7397,'17011','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6534,'15545','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12319,'26330','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49869,'87574','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2867,'07830','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24072,'45132','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5318,'13470','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7650,'17365','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6304,'15209','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26436,'48179','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22096,'41622','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21647,'40513','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17172,'33305','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37910,'65066','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45722,'77550','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14446,'29536','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5752,'14276','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49793,'87375','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(45582,'77423','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37875,'65041','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44233,'75494','Camp','48063','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19851,'37920','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18410,'35699','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3115,'08323','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4249,'11709','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23331,'43951','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31680,'56023','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30499,'54488','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40999,'70514','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45123,'76687','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29338,'52323','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26595,'48416','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6680,'15744','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36246,'62525','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1810,'05047','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12787,'27341','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1929,'05457','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4952,'12919','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43557,'74529','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54812,'99179','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37014,'63456','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33750,'58653','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42223,'72386','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(508,'01822','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11433,'24569','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10712,'23416','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32295,'56557','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31456,'55722','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30824,'54837','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30246,'54114','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22342,'42206','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38031,'65286','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38530,'66047','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32334,'56587','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5388,'13636','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2193,'06103','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4748,'12545','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31258,'55374','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35203,'61240','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45469,'77297','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19614,'37659','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18118,'35148','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4068,'11052','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8771,'19545','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18188,'35242','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43520,'74447','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5584,'14011','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4040,'10990','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28103,'50158','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43652,'74733','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36925,'63350','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33782,'58730','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5180,'13211','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20775,'39166','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39057,'67049','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40580,'69045','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54493,'98556','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30431,'54441','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23363,'44001','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42221,'72386','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21753,'40855','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15850,'31083','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3523,'09573','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11243,'24315','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16036,'31555','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17711,'34142','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39141,'67137','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50917,'91605','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33174,'57773','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12493,'26656','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30627,'54632','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25587,'47131','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(213,'01010','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18403,'35671','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16429,'32159','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16046,'31562','Charlton','13049','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22255,'42064','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7817,'17815','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9982,'22036','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29407,'52497','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2842,'07754','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23805,'44663','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22555,'42638','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21013,'39531','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38111,'65441','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49194,'85135','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52556,'95301','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37873,'65041','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29207,'52162','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6849,'16035','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41978,'72066','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16657,'32466','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2535,'06888','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23816,'44676','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12485,'26631','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11197,'24237','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17181,'33314','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38176,'65559','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45860,'77868','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29812,'53151','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7756,'17724','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26472,'48219','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13593,'28390','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5554,'13851','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33877,'58831','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54790,'99154','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54607,'98813','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41684,'71655','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14154,'29114','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2599,'07043','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41761,'71765','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44784,'76270','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48121,'82008','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(7275,'16749','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54948,'99575','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49121,'85020','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(27509,'49544','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16387,'32111','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20140,'38359','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27608,'49679','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28772,'51025','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43353,'74078','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36064,'62346','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13730,'28538','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28187,'50238','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26043,'47716','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51088,'92068','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50482,'90024','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50068,'88321','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45471,'77301','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6867,'16049','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3984,'10918','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18571,'36020','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26789,'48654','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20354,'38626','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41864,'71953','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44593,'76036','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46428,'78657','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7290,'16827','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14003,'28773','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47991,'81251','Lake','8065','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44796,'76305','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41982,'72069','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23626,'44396','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13516,'28330','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33701,'58627','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11514,'24732','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18635,'36066','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18472,'35811','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2351,'06426','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5936,'14608','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39153,'67147','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40126,'68637','Garfield','31071','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22835,'43156','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18763,'36310','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40690,'69219','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48531,'83530','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47121,'79705','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42410,'72584','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8705,'19462','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34153,'59424','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33971,'59070','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(585,'02019','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28040,'50123','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5259,'13367','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42638,'72921','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45923,'77994','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47065,'79540','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48271,'82727','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(14297,'29351','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14106,'29056','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23028,'43468','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17117,'33166','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21134,'39743','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54164,'98087','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39374,'67523','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34562,'60131','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31770,'56091','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30143,'53940','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13176,'27906','Pasquotank','37139','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25060,'46374','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39990,'68418','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41547,'71368','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42312,'72469','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23764,'44630','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22693,'43044','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1609,'04629','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10024,'22153','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18768,'36313','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36799,'63071','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36485,'62833','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34226,'59524','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28960,'51460','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26067,'47803','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16929,'32869','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20443,'38736','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17275,'33466','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52079,'94142','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53417,'96755','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(4308,'11780','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23935,'44849','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12645,'27108','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23693,'44482','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46929,'79347','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51621,'93216','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51552,'93011','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35103,'61047','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13956,'28732','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12211,'26159','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38770,'66603','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40265,'68768','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44232,'75493','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44955,'76502','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50044,'88250','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53342,'96650','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(29945,'53530','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15820,'31065','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(354,'01350','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44101,'75374','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43110,'73702','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26096,'47846','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7276,'16750','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16624,'32438','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29153,'52069','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27881,'49967','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27707,'49765','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22448,'42368','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40729,'69350','Grant','31075','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43005,'73538','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34465,'60034','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10881,'23851','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1111,'03280','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(790,'02532','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54444,'98496','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41345,'71082','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47683,'80729','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3377,'09060','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(25554,'47108','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27470,'49452','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38492,'66014','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37027,'63464','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43338,'74067','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17604,'33935','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2713,'07436','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4635,'12427','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20678,'39063','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35887,'62082','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29958,'53538','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40226,'68740','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50036,'88231','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(36152,'62434','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14056,'29009','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10796,'23605','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16212,'31784','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44568,'76012','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53461,'96804','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(9320,'20640','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27486,'49501','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37514,'64436','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6497,'15477','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29900,'53406','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53514,'96919','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(54566,'98638','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34186,'59456','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17005,'33015','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47094,'79562','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14590,'29661','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10669,'23308','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28955,'51455','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26283,'48014','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26087,'47838','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23679,'44451','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19484,'37348','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39132,'67131','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44648,'76087','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50533,'90075','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10745,'23456','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31620,'55964','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27957,'50052','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39401,'67553','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46822,'79178','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54440,'98471','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35699,'61851','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35137,'61070','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19363,'37184','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29509,'52623','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20991,'39479','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22913,'43321','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39196,'67235','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2675,'07202','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6060,'14812','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16219,'31789','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36354,'62651','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16943,'32904','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20438,'38730','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24381,'45504','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30296,'54161','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14136,'29082','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12763,'27314','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9014,'20130','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47735,'80818','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17487,'33779','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39617,'67838','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35967,'62254','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42268,'72431','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18421,'35748','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18605,'36039','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35871,'62074','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1383,'04096','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11463,'24601','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15072,'30223','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32089,'56342','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25138,'46543','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40936,'70429','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42171,'72335','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52298,'94666','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10936,'23922','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7818,'17815','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41738,'71744','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42119,'72201','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47017,'79506','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50608,'90302','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10214,'22602','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34495,'60070','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24125,'45207','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16648,'32461','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7075,'16371','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40535,'69001','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41808,'71857','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50167,'88566','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(53235,'96319','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(30708,'54731','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21491,'40328','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7181,'16636','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12302,'26291','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12254,'26228','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6703,'15770','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21768,'40906','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8429,'19009','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2006,'05680','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15035,'30180','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38707,'66510','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52443,'95101','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30413,'54426','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7760,'17729','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3839,'10305','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49279,'85301','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33127,'57722','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7800,'17774','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10738,'23450','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10630,'23236','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1127,'03305','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15778,'31037','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17200,'33334','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36722,'62995','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37079,'63556','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38816,'66720','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48295,'82844','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49368,'85534','Greenlee','4011','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(18713,'36254','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37980,'65243','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43989,'75164','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49504,'85757','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54539,'98605','Skamania','53059','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22516,'42502','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35847,'62052','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35629,'61760','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11887,'25440','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20341,'38618','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20006,'38159','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(795,'02537','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39130,'67127','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41617,'71456','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46897,'79313','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47054,'79533','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54404,'98401','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29768,'53105','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26642,'48445','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4173,'11424','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41268,'71004','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36106,'62380','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31859,'56164','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(12878,'27520','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53391,'96727','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(31385,'55564','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6572,'15622','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9990,'22043','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9393,'20742','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27056,'48924','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45097,'76661','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47096,'79565','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48132,'82059','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51729,'93428','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52254,'94582','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34791,'60511','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2744,'07506','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7983,'18049','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32859,'57375','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19145,'37019','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20557,'38870','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48098,'81641','Rio Blanco','8103','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49493,'85745','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54425,'98430','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34147,'59419','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2649,'07097','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22698,'43046','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52363,'94963','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54301,'98283','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35754,'61919','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11190,'24226','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32623,'57075','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4499,'12149','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22574,'42717','Clinton','21053','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20543,'38860','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20295,'38572','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16244,'31804','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38229,'65614','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33483,'58380','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33421,'58329','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10243,'22649','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11828,'25322','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1506,'04427','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32537,'57026','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29874,'53224','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15075,'30224','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46575,'78861','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9383,'20731','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11398,'24535','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11271,'24350','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21956,'41189','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21296,'40041','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38387,'65737','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39740,'68034','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47282,'79980','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2347,'06420','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30306,'54170','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10166,'22520','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40469,'68944','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43478,'74366','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35759,'61925','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31216,'55342','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29702,'53045','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41394,'71203','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48471,'83405','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10429,'23002','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34928,'60664','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15188,'30317','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16780,'32668','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17981,'35004','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32965,'57475','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35248,'61283','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35790,'61951','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12268,'26253','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11323,'24442','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4086,'11206','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18682,'36117','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30995,'55005','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53694,'97220','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29409,'52499','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50466,'90008','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18208,'35290','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27184,'49087','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29520,'52631','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1991,'05665','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15187,'30316','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16302,'31997','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22626,'42764','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22464,'42404','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46130,'78246','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12891,'27528','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12729,'27283','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26883,'48765','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17555,'33873','Hardee','12049','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19075,'36850','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24873,'46148','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10152,'22503','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28189,'50239','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27130,'49047','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24080,'45140','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39160,'67154','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48022,'81403','Ouray','8091','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31105,'55104','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26385,'48130','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51073,'92049','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50395,'89450','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47429,'80218','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44717,'76193','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43019,'73548','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15448,'30562','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11784,'25251','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35178,'61110','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34911,'60642','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12910,'27542','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24169,'45249','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33587,'58482','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22109,'41647','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8418,'18981','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51784,'93524','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38090,'65354','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5861,'14516','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4532,'12183','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15389,'30527','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16992,'32971','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12361,'26404','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11635,'25011','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32321,'56578','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28493,'50563','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24634,'45845','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6509,'15492','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2548,'06911','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19957,'38077','Lake','47095','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43370,'74103','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49210,'85191','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51314,'92382','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53181,'96134','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55086,'99739','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(29792,'53132','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20850,'39307','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20689,'39077','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16830,'32736','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15766,'31033','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20887,'39345','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5231,'13333','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26281,'48012','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15440,'30557','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39026,'67025','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26512,'48301','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9310,'20627','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14874,'30065','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16960,'32931','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41716,'71677','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3189,'08544','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5700,'14151','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26277,'48005','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24223,'45318','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23238,'43787','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43956,'75141','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25812,'47386','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15881,'31126','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5517,'13811','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53779,'97347','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14871,'30062','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14267,'29307','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14235,'29212','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23417,'44067','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17009,'33019','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18190,'35243','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44789,'76272','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50630,'90501','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52357,'94953','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52486,'95157','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33270,'58059','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28924,'51433','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8905,'20004','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(45827,'77831','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43915,'75093','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43428,'74301','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12128,'25971','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15760,'31030','Peach','13225','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20338,'38614','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19870,'37950','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38378,'65732','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14005,'28774','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35048,'60967','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34583,'60145','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33809,'58752','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32268,'56536','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12730,'27284','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18674,'36109','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39634,'67846','Haskell','20081','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34535,'60107','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12212,'26159','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52178,'94510','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3936,'10578','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33090,'57646','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24376,'45490','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44299,'75637','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29780,'53119','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10460,'23040','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4812,'12729','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53040,'95974','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50092,'88353','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49448,'85670','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4291,'11762','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17091,'33139','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39154,'67149','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39869,'68317','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44109,'75390','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6412,'15351','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29012,'51543','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40699,'69333','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52623,'95372','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7692,'17533','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37083,'63558','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27503,'49525','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35804,'62011','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35982,'62263','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(619,'02081','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(181,'00962','Catano','72033','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(23359,'43986','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33178,'57776','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28113,'50165','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40816,'70112','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31961,'56255','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17787,'34287','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49143,'85042','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14853,'30049','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26182,'47933','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43990,'75165','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14687,'29821','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7138,'16510','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32856,'57374','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3482,'09461','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(55052,'99694','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51468,'92704','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3365,'09028','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20577,'38913','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6386,'15323','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51778,'93516','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53161,'96114','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53372,'96705','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54381,'98376','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54766,'99131','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10655,'23291','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5556,'13859','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17514,'33827','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3685,'09898','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52815,'95629','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51002,'91899','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31096,'55088','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2730,'07461','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18046,'35068','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31602,'55952','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26365,'48109','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26338,'48081','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41644,'71479','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36503,'62843','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34026,'59221','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(8139,'18405','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54259,'98238','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23570,'44264','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11943,'25565','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20594,'38925','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28963,'51462','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24974,'46241','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38877,'66779','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47095,'79563','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47784,'80912','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24753,'46040','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54697,'99008','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41382,'71154','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38472,'65810','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21273,'40014','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22792,'43135','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8615,'19330','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7226,'16677','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29643,'53004','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29187,'52142','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47564,'80476','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53769,'97336','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4758,'12555','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34950,'60694','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34319,'59752','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32532,'57022','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2431,'06604','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28719,'50864','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8154,'18421','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37360,'64037','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12027,'25723','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2312,'06373','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25869,'47451','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38180,'65560','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46439,'78663','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14690,'29824','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17534,'33850','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27764,'49826','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26917,'48819','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45015,'76557','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21266,'40011','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21268,'40011','Trimble','21223','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24904,'46166','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10858,'23834','Colonial Heights City','51570','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54760,'99126','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53639,'97123','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25643,'47203','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30005,'53574','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40540,'69022','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40025,'68446','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39601,'67764','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24470,'45684','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30128,'53928','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9155,'20394','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10183,'22546','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35305,'61349','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37075,'63549','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17865,'34653','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48614,'83652','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44433,'75797','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41604,'71443','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38647,'66406','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6547,'15559','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18327,'35574','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25740,'47335','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6904,'16117','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4521,'12169','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52581,'95325','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43240,'73949','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14623,'29690','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17111,'33160','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23704,'44493','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23402,'44054','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23553,'44242','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51847,'93618','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46078,'78160','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41405,'71220','Morehouse','22067','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39237,'67356','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25638,'47190','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26719,'48610','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7476,'17070','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25289,'46783','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5176,'13207','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14448,'29541','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40958,'70447','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44067,'75266','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48026,'81414','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16034,'31554','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31253,'55371','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26739,'48619','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7206,'16660','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21332,'40068','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40646,'69156','Kimball','31105','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26495,'48242','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32047,'56317','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23298,'43917','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47715,'80759','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53558,'97024','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6419,'15361','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14411,'29482','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15911,'31216','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(466,'01653','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29041,'51561','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52979,'95920','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35596,'61738','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21276,'40019','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53418,'96756','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41053,'70556','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6128,'14871','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15126,'30268','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19245,'37080','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54741,'99109','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53690,'97218','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51822,'93586','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41192,'70762','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1757,'04952','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27452,'49435','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4600,'12303','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33042,'57577','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51754,'93454','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49686,'87032','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43611,'74630','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5789,'14437','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3738,'10095','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5055,'13052','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(97,'00766','Villalba','72149','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(21601,'40447','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4490,'12139','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47296,'80006','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46324,'78584','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12980,'27602','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18656,'36082','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23429,'44084','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42777,'73058','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53350,'96666','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(17529,'33846','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24487,'45695','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9778,'21639','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31161,'55310','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19834,'37890','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37998,'65260','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35303,'61349','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15657,'30815','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13895,'28676','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21097,'39662','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46082,'78164','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37531,'64451','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36502,'62842','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47357,'80110','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38410,'65754','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18776,'36318','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5436,'13683','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37520,'64441','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22955,'43348','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18582,'36028','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17517,'33834','Hardee','12049','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22909,'43318','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25367,'46902','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29350,'52328','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36473,'62825','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8840,'19886','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(12158,'26039','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23714,'44509','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29173,'52101','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9776,'21636','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20084,'38315','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33269,'58058','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40476,'68948','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34914,'60645','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5492,'13780','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10021,'22150','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7310,'16848','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11947,'25570','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45912,'77984','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7019,'16316','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8633,'19352','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15640,'30803','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1074,'03241','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30988,'54985','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25880,'47458','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23752,'44624','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32408,'56680','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(44605,'76049','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44084,'75326','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53062,'96006','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52966,'95901','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47455,'80236','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24205,'45308','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42967,'73463','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12365,'26410','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13473,'28281','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21804,'40983','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19810,'37874','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7292,'16829','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29898,'53404','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15859,'31089','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5777,'14425','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25315,'46798','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45177,'76836','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37021,'63461','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25954,'47562','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7472,'17067','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8018,'18079','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17783,'34282','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21225,'39846','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8825,'19736','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(27826,'49894','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12589,'27017','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(1723,'04912','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23913,'44837','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32964,'57474','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52519,'95223','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44362,'75686','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41251,'70837','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29210,'52162','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7923,'17964','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33121,'57717','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33472,'58372','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(918,'02815','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(7646,'17361','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52403,'95026','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43832,'75017','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41026,'70532','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37794,'64834','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17593,'33920','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1391,'04106','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40771,'70047','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38891,'66834','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6915,'16127','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2630,'07075','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19018,'36751','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10042,'22201','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20187,'38425','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27732,'49788','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1835,'05075','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20052,'38241','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2440,'06615','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48241,'82636','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(12132,'25976','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54427,'98433','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48033,'81420','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45618,'77455','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35585,'61730','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48753,'84007','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51955,'93775','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34793,'60511','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31913,'56219','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7032,'16331','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11923,'25526','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38182,'65560','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38677,'66431','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42435,'72629','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43194,'73835','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44854,'76427','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45682,'77507','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49116,'85015','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51184,'92195','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29019,'51548','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22454,'42372','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16014,'31543','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38305,'65663','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46211,'78370','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49526,'85937','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48011,'81328','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2399,'06505','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30336,'54215','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25002,'46278','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24908,'46168','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16833,'32744','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48833,'84087','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50027,'88201','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(8870,'19946','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(7770,'17742','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15454,'30565','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53050,'95982','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37199,'63770','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19068,'36804','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9225,'20524','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33773,'58721','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33250,'58048','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30927,'54941','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26005,'47633','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15221,'30344','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38143,'65483','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8228,'18517','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34060,'59260','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22738,'43074','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48458,'83350','Minidoka','16067','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(19123,'36916','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13673,'28463','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31735,'56065','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27849,'49922','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23087,'43542','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17624,'33960','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39862,'68313','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43920,'75098','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45281,'76951','Sterling','48431','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12473,'26611','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13575,'28377','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26358,'48101','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43052,'73573','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50641,'90602','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30674,'54666','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8405,'18964','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32366,'56636','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23480,'44132','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34620,'60178','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47400,'80150','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51588,'93103','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53467,'96810','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54227,'98191','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4801,'12720','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13074,'27818','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13746,'28554','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51049,'92011','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51534,'92880','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30051,'53716','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17429,'33687','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20434,'38722','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28379,'50461','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1800,'05036','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36285,'62555','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50383,'89439','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5962,'14647','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17730,'34216','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(732,'02349','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35565,'61709','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35838,'62044','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32767,'57319','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39422,'67565','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22613,'42749','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8765,'19541','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15329,'30458','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2653,'07103','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5392,'13640','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50229,'89036','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50975,'91766','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12275,'26261','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30712,'54734','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20365,'38634','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43748,'74865','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(420,'01527','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(48939,'84338','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9162,'20405','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(18023,'35044','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43144,'73738','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44023,'75217','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47265,'79945','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54282,'98262','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29258,'52219','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28701,'50851','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13043,'27713','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16307,'32006','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18173,'35222','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(935,'02836','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(3894,'10517','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18517,'35961','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35453,'61489','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42136,'72219','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42673,'72951','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45318,'77032','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45773,'77623','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54895,'99501','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(7403,'17017','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29825,'53172','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13899,'28679','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17059,'33082','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35291,'61338','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44272,'75570','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49174,'85083','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6565,'15616','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20394,'38658','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36013,'62285','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41226,'70806','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28488,'50561','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20025,'38194','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34664,'60407','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46458,'78674','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32512,'57006','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11352,'24483','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30182,'53964','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15505,'30623','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22388,'42276','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15764,'31031','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43773,'74884','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47687,'80732','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51410,'92610','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27550,'49633','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8863,'19938','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(39510,'67653','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39978,'68405','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40728,'69350','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42381,'72554','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46891,'79261','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31662,'56009','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46923,'79343','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5933,'14605','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26650,'48453','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24518,'45732','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16371,'32087','Baker','12003','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4479,'12128','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4156,'11381','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44761,'76250','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53983,'97730','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7334,'16872','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38800,'66667','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40346,'68831','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42072,'72137','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44594,'76036','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37653,'64649','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6159,'14893','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20213,'38469','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17678,'34098','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(17663,'34038','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(15431,'30549','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7382,'16947','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40750,'70002','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49373,'85539','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51717,'93408','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53378,'96712','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(24534,'45744','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5684,'14133','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10638,'23255','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32666,'57223','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4235,'11690','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12318,'26327','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23219,'43771','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20680,'39067','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14440,'29525','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14070,'29030','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39230,'67352','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39663,'67865','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40084,'68528','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40982,'70469','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43290,'74032','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19939,'38060','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15149,'30287','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16261,'31820','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33986,'59084','Petroleum','30069','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35339,'61401','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41847,'71935','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1214,'03781','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(1758,'04953','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8387,'18943','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22732,'43070','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5479,'13757','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6129,'14871','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(588,'02025','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11578,'24884','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44351,'75681','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7688,'17527','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16723,'32583','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9717,'21409','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43699,'74830','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16167,'31749','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12062,'25837','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9148,'20380','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(32365,'56634','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17338,'33556','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(975,'02896','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(15578,'30680','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35719,'61866','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52342,'94933','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14609,'29678','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12187,'26137','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44202,'75471','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52047,'94105','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(503,'01810','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4632,'12422','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31178,'55322','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3877,'10503','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30287,'54154','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23600,'44304','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6693,'15759','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34054,'59258','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38159,'65543','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43931,'75110','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53366,'96686','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54186,'98118','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6647,'15711','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12044,'25779','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36988,'63439','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37381,'64065','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50341,'89317','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(134,'00902','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(25931,'47536','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38526,'66044','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7017,'16314','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28462,'50541','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7712,'17560','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21204,'39832','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19812,'37874','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14628,'29693','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35863,'62067','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37154,'63662','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6780,'15920','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33779,'58725','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35207,'61243','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40159,'68659','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22352,'42217','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52213,'94543','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40524,'68980','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3393,'09104','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29585,'52745','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19600,'37641','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14035,'28813','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11853,'25364','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37149,'63655','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46413,'78648','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2146,'06051','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(743,'02364','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20170,'38381','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50129,'88524','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(42645,'72928','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38645,'66404','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19261,'37090','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11749,'25186','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44858,'76430','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8982,'20103','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20319,'38587','White','47185','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18650,'36079','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43040,'73565','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8163,'18428','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7101,'16417','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23845,'44701','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5017,'12998','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10600,'23219','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1385,'04098','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29850,'53201','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24896,'46162','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23850,'44706','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1438,'04263','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37697,'64682','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45244,'76890','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10550,'23139','Powhatan','51145','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10399,'22958','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24628,'45843','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4402,'12032','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40194,'68719','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38276,'65646','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25146,'46550','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6931,'16142','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6585,'15635','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1689,'04776','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4359,'11959','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6280,'15133','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47246,'79927','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10329,'22835','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26396,'48141','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25723,'47324','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49489,'85741','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35017,'60950','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(254,'01071','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3871,'10473','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47470,'80249','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52042,'94088','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30612,'54621','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8749,'19525','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3584,'09714','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(46437,'78662','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7890,'17901','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24443,'45660','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43815,'74964','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42323,'72476','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33973,'59072','Musselshell','30065','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12695,'27243','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6535,'15546','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30876,'54890','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30526,'54515','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25493,'46992','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21767,'40906','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48766,'84022','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10506,'23093','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6201,'15031','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15605,'30733','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26075,'47830','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53152,'96105','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21140,'39745','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48994,'84626','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(34627,'60184','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19464,'37333','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5771,'14420','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16285,'31833','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18521,'35964','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25509,'47011','Ohio','18115','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24177,'45255','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19236,'37074','Trousdale','47169','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43419,'74170','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50779,'91126','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54007,'97760','Crook','41013','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54179,'98111','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9245,'20544','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(32084,'56339','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(38809,'66714','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32635,'57107','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23652,'44427','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22673,'43022','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29405,'52410','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26550,'48343','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(772,'02467','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22890,'43291','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46260,'78463','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48788,'84044','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50568,'90230','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25905,'47513','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24881,'46151','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21814,'41004','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12482,'26624','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12811,'27371','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16159,'31735','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35202,'61240','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38201,'65590','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4851,'12775','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47099,'79566','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44681,'76121','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29679,'53026','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15005,'30160','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15868,'31095','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35110,'61051','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37534,'64454','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43582,'74556','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51231,'92264','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31906,'56215','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9559,'21048','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(684,'02201','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38951,'66936','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53011,'95950','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50762,'91103','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22562,'42653','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12183,'26133','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12273,'26260','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39119,'67118','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44108,'75389','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46607,'78943','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52642,'95389','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54776,'99140','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4899,'12837','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43997,'75172','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47888,'81063','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50497,'90039','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28510,'50575','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26409,'48160','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26300,'48037','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3923,'10551','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20472,'38769','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18974,'36641','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48063,'81526','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48365,'83220','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(27624,'49689','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7506,'17098','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5101,'13103','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34659,'60402','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12576,'26886','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17382,'33608','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34640,'60195','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30317,'54180','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3987,'10921','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25592,'47136','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25117,'46527','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21903,'41098','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21113,'39668','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11865,'25410','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40965,'70453','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32151,'56387','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(582,'01984','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23742,'44617','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45089,'76653','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47978,'81233','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49213,'85193','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42929,'73437','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15120,'30263','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21494,'40328','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52049,'94108','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14681,'29817','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46849,'79235','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50567,'90224','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10084,'22309','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1932,'05460','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18685,'36120','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(819,'02574','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11845,'25339','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40882,'70310','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41956,'72046','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7879,'17880','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27171,'49079','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16720,'32578','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4809,'12726','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35054,'60973','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29814,'53153','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(275,'01095','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24310,'45383','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22175,'41825','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5953,'14625','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41038,'70542','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41901,'72013','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32389,'56661','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7066,'16364','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5095,'13090','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39662,'67865','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42730,'73029','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43656,'74736','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1952,'05483','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21401,'40177','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49370,'85535','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51846,'93616','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12122,'25958','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28509,'50575','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15067,'30220','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37013,'63456','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37438,'64124','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54918,'99529','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1570,'04551','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10010,'22108','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8117,'18342','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25970,'47578','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45638,'77473','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48552,'83547','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39718,'68017','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38278,'65647','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30720,'54738','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28520,'50582','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26698,'48532','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44627,'76065','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50266,'89111','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(10435,'23011','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25717,'47306','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12342,'26366','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21597,'40444','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46848,'79235','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48005,'81324','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43132,'73729','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38361,'65721','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(63,'00715','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(2640,'07087','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1287,'03882','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12375,'26416','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18576,'36025','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18930,'36562','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37967,'65232','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39941,'68361','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40341,'68825','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46041,'78121','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46229,'78384','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28544,'50599','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1752,'04945','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20355,'38627','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17883,'34685','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10512,'23103','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30610,'54619','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9900,'21797','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1856,'05151','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4451,'12083','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8977,'20091','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12739,'27292','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18730,'36266','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53066,'96009','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21517,'40351','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1965,'05601','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(31957,'56251','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47540,'80451','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35934,'62231','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42775,'73057','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9497,'20891','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3320,'08863','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35474,'61529','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36692,'62965','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36923,'63349','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45932,'78004','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52460,'95123','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53435,'96774','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(32312,'56572','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(817,'02571','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23659,'44432','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12105,'25915','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12727,'27282','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1893,'05356','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16660,'32501','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48931,'84330','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11510,'24724','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8719,'19481','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27167,'49077','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35899,'62089','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31479,'55746','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3249,'08735','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23404,'44056','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13494,'28308','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45275,'76945','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6332,'15237','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49352,'85382','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3940,'10583','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8873,'19950','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(13143,'27874','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16558,'32336','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39850,'68301','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46702,'79043','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49977,'88048','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53780,'97347','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54228,'98194','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11391,'24529','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26215,'47959','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26127,'47872','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6311,'15216','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4067,'11051','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26840,'48738','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10321,'22824','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17309,'33514','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22726,'43067','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40318,'68813','Blaine','31009','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41416,'71227','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33334,'58225','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14305,'29365','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26622,'48433','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26480,'48227','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46915,'79331','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53986,'97733','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54931,'99555','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9337,'20674','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22226,'42039','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29659,'53014','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39205,'67333','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40148,'68649','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25727,'47326','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15171,'30304','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33865,'58792','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32062,'56327','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27837,'49911','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23361,'43988','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45129,'76690','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53451,'96792','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(4201,'11547','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37037,'63472','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10219,'22611','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1741,'04935','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52264,'94592','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42021,'72103','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38598,'66112','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37006,'63451','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22736,'43074','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29793,'53132','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29997,'53570','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37464,'64153','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17184,'33317','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17815,'34449','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41228,'70808','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42545,'72752','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45190,'76848','Menard','48327','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48612,'83650','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49424,'85635','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37688,'64672','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33851,'58783','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27278,'49258','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(459,'01609','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49117,'85016','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49726,'87105','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53543,'97011','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7941,'17985','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18442,'35762','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19523,'37370','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23957,'44865','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15385,'30523','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11701,'25113','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26062,'47747','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3110,'08318','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17130,'33180','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42618,'72856','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46253,'78416','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14930,'30105','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13349,'28114','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17239,'33425','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11096,'24105','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12564,'26851','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12553,'26818','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13756,'28563','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12037,'25772','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9329,'20659','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31255,'55372','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19708,'37769','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19379,'37202','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18111,'35143','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17654,'34025','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(42051,'72125','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42371,'72542','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51242,'92278','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36138,'62425','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27737,'49795','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22485,'42442','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47756,'80833','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43783,'74935','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40521,'68979','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17632,'33973','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9133,'20310','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11417,'24553','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25397,'46928','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17907,'34741','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40374,'68849','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46509,'78738','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54144,'98058','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55054,'99697','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13606,'28403','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52235,'94564','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5745,'14264','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23425,'44077','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13090,'27830','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25513,'47016','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43327,'74059','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50605,'90295','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36416,'62712','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9278,'20594','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5142,'13145','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4825,'12746','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27715,'49770','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24217,'45315','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29183,'52140','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9740,'21539','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12546,'26807','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3410,'09173','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11927,'25535','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24383,'45506','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11218,'24269','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23910,'44836','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48171,'82240','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49359,'85392','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49660,'87009','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51708,'93388','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9881,'21779','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13973,'28746','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46243,'78406','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44619,'76059','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28111,'50164','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28948,'51453','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11716,'25133','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10428,'23001','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37912,'65068','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16690,'32539','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33534,'58440','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27693,'49753','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27129,'49047','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42626,'72902','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21952,'41180','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9091,'20216','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7196,'16650','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3772,'10150','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(212,'01009','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5278,'13417','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36245,'62524','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9096,'20221','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2141,'06042','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4386,'12016','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38621,'66216','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7694,'17535','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4141,'11365','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28975,'51503','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19924,'38047','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41479,'71282','Tensas','22107','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46367,'78620','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36863,'63137','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54631,'98843','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50208,'89014','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52477,'95141','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9722,'21503','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37303,'63943','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34422,'59931','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2667,'07189','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31994,'56278','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21989,'41268','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17215,'33394','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48535,'83535','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49719,'87070','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54961,'99590','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30976,'54979','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21489,'40324','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54106,'98019','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4909,'12848','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17229,'33414','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20298,'38574','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12853,'27504','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(453,'01603','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28760,'51019','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21969,'41230','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8569,'19153','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17402,'33630','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47913,'81092','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53399,'96737','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(13326,'28097','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26760,'48631','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25801,'47374','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12035,'25770','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15553,'30662','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2078,'05845','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16446,'32179','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39739,'68033','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41163,'70730','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1884,'05344','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(35338,'61379','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33396,'58282','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37400,'64080','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15200,'30327','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22191,'41847','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16476,'32218','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10777,'23511','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43701,'74831','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32368,'56637','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(19679,'37738','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21923,'41141','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38664,'66419','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45916,'77988','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42625,'72901','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42500,'72703','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2024,'05743','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14145,'29105','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36647,'62935','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35859,'62062','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6445,'15420','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47619,'80540','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42872,'73142','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22498,'42453','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8851,'19901','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(37411,'64089','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10634,'23241','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17817,'34451','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35621,'61753','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3921,'10549','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24713,'45895','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44688,'76129','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14043,'28904','Clay','37043','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34475,'60044','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20306,'38579','White','47185','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26843,'48740','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42482,'72675','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45278,'76950','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50860,'91371','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48926,'84325','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(1693,'04781','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11232,'24283','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38606,'66202','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44452,'75844','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14114,'29063','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11905,'25508','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40796,'70075','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41983,'72069','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43298,'74036','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49136,'85035','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50912,'91526','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10457,'23038','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14093,'29046','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23602,'44306','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19149,'37022','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18672,'36107','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40624,'69146','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41672,'71642','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44471,'75856','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49327,'85355','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49831,'87523','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(15065,'30218','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19683,'37743','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22900,'43314','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40340,'68824','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53258,'96372','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(28212,'50252','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46326,'78586','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13082,'27824','Hyde','37095','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16674,'32520','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38549,'66064','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38827,'66736','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39410,'67559','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41767,'71801','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36539,'62868','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46663,'79018','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54159,'98075','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9582,'21085','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15477,'30598','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32773,'57321','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26686,'48480','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16924,'32860','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39348,'67492','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43681,'74764','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44113,'75394','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47795,'80923','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51357,'92517','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18857,'36467','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29911,'53506','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49164,'85071','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29894,'53401','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15112,'30256','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13663,'28456','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38310,'65669','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41518,'71341','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42450,'72640','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45544,'77378','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36303,'62572','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13937,'28715','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4903,'12842','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24839,'46120','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46209,'78368','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36765,'63037','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(492,'01760','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2710,'07432','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17287,'33477','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40160,'68660','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40248,'68757','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41970,'72060','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2961,'08012','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26691,'48505','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21991,'41274','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19036,'36765','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39812,'68127','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5263,'13402','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15331,'30460','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2739,'07501','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12434,'26547','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18106,'35135','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11182,'24219','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39956,'68370','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41291,'71034','Red River','22081','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41553,'71378','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31530,'55803','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47233,'79913','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16245,'31804','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8133,'18370','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(529,'01860','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9077,'20198','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31431,'55613','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28517,'50579','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22935,'43337','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21293,'40037','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19842,'37912','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4418,'12053','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8037,'18105','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38864,'66772','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50861,'91372','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18710,'36250','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18297,'35551','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9112,'20241','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(53164,'96117','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54108,'98020','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54168,'98093','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(15371,'30517','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21446,'40255','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11726,'25143','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18175,'35224','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40866,'70178','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(312,'01229','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26616,'48429','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21891,'41092','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48828,'84082','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29538,'52646','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37564,'64477','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28343,'50439','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26420,'48167','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18050,'35072','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21297,'40045','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46711,'79052','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53228,'96278','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(32552,'57034','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26996,'48873','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52911,'95757','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20771,'39162','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20494,'38824','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20910,'39362','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22294,'42128','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25810,'47384','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34492,'60067','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(362,'01367','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40057,'68465','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42729,'73028','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47406,'80163','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10626,'23234','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43721,'74850','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44874,'76442','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51858,'93623','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48222,'82513','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(36373,'62671','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4388,'12018','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35240,'61277','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31518,'55787','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12226,'26175','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10768,'23502','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53560,'97027','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6368,'15286','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11220,'24271','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20036,'38224','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20010,'38167','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38585,'66097','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9653,'21215','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13030,'27704','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12529,'26731','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30297,'54162','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27204,'49101','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45144,'76707','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5758,'14305','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16379,'32096','Hamilton','12047','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20723,'39108','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42531,'72739','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53743,'97306','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53381,'96715','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52379,'95001','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33264,'58056','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8642,'19363','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25403,'46930','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18860,'36470','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41009,'70520','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46741,'79070','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49629,'86444','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53406,'96744','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(35903,'62091','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35382,'61439','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33462,'58366','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44325,'75654','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47519,'80427','Gilpin','8047','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34605,'60163','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14652,'29722','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44185,'75453','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43234,'73942','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42455,'72644','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14760,'29926','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5108,'13111','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29306,'52255','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24512,'45723','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43145,'73739','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20963,'39455','Stone','28131','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11080,'24087','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15175,'30307','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52708,'95470','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35221,'61260','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(481,'01741','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9751,'21561','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25465,'46978','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3627,'09801','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43306,'74043','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30601,'54614','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8916,'20016','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(49356,'85388','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10576,'23175','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12204,'26149','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36753,'63028','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3057,'08108','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3055,'08106','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20859,'39325','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16032,'31553','Charlton','13049','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40369,'68845','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44843,'76389','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34869,'60586','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52956,'95853','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44998,'76539','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7645,'17360','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4528,'12177','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26586,'48411','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50111,'88433','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(1900,'05363','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4080,'11120','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15296,'30439','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48567,'83607','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(38405,'65752','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21438,'40243','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7484,'17075','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36426,'62756','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35318,'61361','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18677,'36112','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37292,'63937','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40179,'68701','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40772,'70049','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50569,'90231','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54722,'99030','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(14496,'29587','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13968,'28741','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31645,'55981','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2055,'05778','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25164,'46565','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5905,'14557','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52429,'95062','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17207,'33345','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1022,'03061','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(40685,'69216','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43957,'75142','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46040,'78121','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54339,'98331','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12001,'25699','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20243,'38501','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54729,'99036','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44363,'75687','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43230,'73933','Cimarron','40025','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1206,'03769','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35066,'61012','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28966,'51463','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10348,'22901','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21232,'39859','Seminole','13253','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18958,'36608','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35617,'61750','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32572,'57045','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36606,'62908','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46141,'78255','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39943,'68364','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6599,'15656','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9192,'20437','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10403,'22960','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10484,'23069','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12156,'26037','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31,'00659','Hatillo','72065','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(448,'01586','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36109,'62401','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12667,'27204','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12112,'25921','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31567,'55923','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11418,'24554','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21918,'41132','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15026,'30176','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2784,'07648','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1434,'04259','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1735,'04927','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39135,'67133','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44864,'76433','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51906,'93669','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10725,'23431','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33080,'57641','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16402,'32126','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22851,'43206','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24024,'45053','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40585,'69101','McPherson','31117','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15011,'30165','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30924,'54940','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46291,'78548','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48618,'83656','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54653,'98902','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30658,'54655','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13700,'28513','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29297,'52249','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10951,'23938','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26887,'48767','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54857,'99333','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52091,'94164','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43556,'74528','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1867,'05251','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1934,'05462','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34472,'60042','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13489,'28305','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10808,'23664','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4162,'11413','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21737,'40823','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21309,'40051','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2633,'07078','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39489,'67644','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46415,'78650','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14323,'29388','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20381,'38646','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49858,'87557','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(8981,'20102','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36151,'62434','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33610,'58501','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31703,'56042','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8044,'18202','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42521,'72732','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43136,'73731','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51507,'92838','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55152,'99835','Sitka','2220','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(36340,'62635','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2309,'06370','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6963,'16222','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31939,'56235','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25299,'46787','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(956,'02875','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(54827,'99211','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51709,'93389','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45887,'77957','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22952,'43346','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23403,'44055','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5709,'14174','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32904,'57435','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15054,'30205','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43801,'74953','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44590,'76035','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44952,'76491','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37144,'63651','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31759,'56083','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24952,'46224','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3400,'09131','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53582,'97048','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46978,'79382','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15390,'30528','Lumpkin','13187','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14610,'29679','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1726,'04918','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11049,'24059','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29377,'52352','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24382,'45505','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41855,'71943','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49916,'87823','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50849,'91357','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51139,'92134','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11794,'25264','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(299,'01152','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37683,'64670','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15895,'31196','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4458,'12092','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34113,'59343','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(26929,'48827','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25295,'46786','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17339,'33558','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46403,'78641','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53727,'97282','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54944,'99571','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42664,'72946','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46287,'78542','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27137,'49053','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13688,'28480','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25073,'46385','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23432,'44086','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51614,'93208','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47381,'80128','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(21800,'40979','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36807,'63080','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29930,'53520','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6838,'16023','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6265,'15108','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5249,'13354','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21177,'39771','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17641,'33991','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41702,'71667','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49774,'87312','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50451,'89828','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52649,'95404','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52846,'95661','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35576,'61725','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34512,'60086','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31646,'55982','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3346,'08903','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48360,'83213','Butte','16023','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41303,'71047','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24556,'45775','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24540,'45746','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30002,'53573','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19029,'36761','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17610,'33946','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14726,'29850','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19187,'37046','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22343,'42207','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23055,'43517','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7366,'16933','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26257,'47989','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11369,'24503','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45900,'77973','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44040,'75234','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21562,'40390','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21128,'39736','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2268,'06255','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26114,'47860','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25095,'46501','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20769,'39160','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14529,'29620','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7231,'16681','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34143,'59416','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29506,'52621','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17909,'34743','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17613,'33949','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16632,'32443','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49362,'85501','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(14637,'29706','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27582,'49659','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27209,'49106','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13395,'28167','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41637,'71471','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42341,'72519','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43465,'74359','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48381,'83239','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49989,'88065','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52348,'94942','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54111,'98022','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26867,'48757','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19104,'36870','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18011,'35034','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32124,'56367','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53106,'96056','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17653,'34024','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(4069,'11053','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37500,'64424','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34868,'60586','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11127,'24138','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19811,'37874','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39609,'67835','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41495,'71322','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50033,'88220','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(10452,'23030','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40532,'68982','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54665,'98930','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29510,'52623','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5608,'14036','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37107,'63624','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33490,'58384','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22809,'43143','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21182,'39776','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21003,'39503','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13111,'27847','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45027,'76569','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53729,'97286','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14850,'30046','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48167,'82224','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(39229,'67352','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6300,'15205','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12408,'26456','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23306,'43930','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47,'00683','San German','72125','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(36304,'62572','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1321,'04014','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10574,'23170','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25985,'47598','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39055,'67047','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53996,'97741','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7469,'17065','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25127,'46536','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17243,'33429','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34637,'60192','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53207,'96202','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(48403,'83274','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42067,'72134','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(122,'00820','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(9628,'21161','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29123,'52040','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10053,'22210','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6592,'15642','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16667,'32508','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24402,'45622','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18101,'35130','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30243,'54112','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4697,'12489','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24172,'45251','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35646,'61790','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51288,'92344','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11324,'24445','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39929,'68352','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46516,'78747','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6953,'16210','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38499,'66020','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41800,'71847','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46062,'78144','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35612,'61748','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13167,'27891','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30484,'54475','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21720,'40771','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53716,'97240','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45052,'76624','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11937,'25557','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4720,'12516','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19569,'37411','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13226,'27965','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27928,'50034','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1688,'04775','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38924,'66860','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32818,'57350','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28116,'50168','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27596,'49670','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4466,'12110','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50196,'89002','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(19602,'37642','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19424,'37305','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21196,'39824','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10546,'23130','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5772,'14422','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14489,'29581','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4217,'11565','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28957,'51458','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2032,'05753','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(47809,'80936','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3847,'10313','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12918,'27552','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48669,'83756','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(18712,'36253','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20800,'39191','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4610,'12309','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33715,'58638','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11355,'24484','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37738,'64747','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2530,'06878','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12172,'26070','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11134,'24141','Radford City','51750','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39966,'68378','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46703,'79043','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15414,'30538','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18270,'35485','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7285,'16822','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12096,'25902','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10554,'23146','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42949,'73448','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55103,'99756','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38273,'65644','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3472,'09383','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32528,'57018','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25508,'47010','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7323,'16861','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53581,'97045','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7379,'16945','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2442,'06673','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30730,'54743','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45200,'76855','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44172,'75447','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28611,'50645','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(551,'01906','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11215,'24263','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23847,'44703','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38351,'65712','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49205,'85147','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10384,'22942','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49948,'88012','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52975,'95916','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9172,'20415','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(37260,'63862','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39483,'67642','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49720,'87072','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53837,'97407','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25391,'46922','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19117,'36907','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42228,'72392','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46435,'78661','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52330,'94915','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53079,'96023','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20724,'39108','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3917,'10545','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20160,'38374','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13333,'28104','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31971,'56262','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8914,'20013','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(23842,'44699','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23394,'44046','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13436,'28230','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42951,'73449','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10258,'22664','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9241,'20540','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(38060,'65333','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35313,'61358','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19916,'38041','Lauderdale','47097','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20280,'38562','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(610,'02060','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33041,'57576','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26712,'48604','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9426,'20778','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52173,'94505','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54077,'97906','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33036,'57570','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8025,'18087','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31022,'55025','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24624,'45841','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37012,'63454','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44788,'76272','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6351,'15261','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51844,'93614','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10904,'23882','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26228,'47968','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37871,'65040','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39022,'67022','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22222,'42037','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17296,'33487','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35517,'61565','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35569,'61721','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47644,'80621','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2503,'06816','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1374,'04086','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22899,'43314','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19392,'37214','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37131,'63638','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41058,'70563','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41820,'71864','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43938,'75119','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44589,'76034','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47558,'80470','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48717,'83849','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49651,'86556','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49910,'87750','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(5121,'13123','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34029,'59223','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7245,'16695','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7009,'16262','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26487,'48234','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1504,'04424','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52015,'94026','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46987,'79407','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35147,'61078','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31118,'55115','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34554,'60123','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39590,'67757','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45251,'76904','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3973,'10804','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38460,'65790','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45667,'77493','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1409,'04222','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39924,'68348','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41675,'71644','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47849,'81025','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12108,'25918','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43658,'74738','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45319,'77033','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28549,'50602','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32703,'57251','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18048,'35071','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40483,'68954','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23912,'44837','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(167,'00940','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(6905,'16117','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21829,'41018','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(822,'02584','Nantucket','25019','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21126,'39735','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35322,'61364','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40799,'70079','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42852,'73124','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47718,'80804','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49266,'85280','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1861,'05156','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27263,'49248','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9805,'21663','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39293,'67449','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31415,'55594','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2924,'07932','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7364,'16930','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37680,'64668','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49401,'85611','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30653,'54652','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9952,'21903','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1082,'03249','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26158,'47918','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25564,'47116','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43309,'74045','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46577,'78871','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48657,'83717','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49560,'86042','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53533,'97002','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28542,'50598','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5437,'13684','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26587,'48412','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24688,'45880','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13651,'28447','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3237,'08701','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9159,'20402','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33328,'58220','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33282,'58067','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1700,'04846','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5558,'13861','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15611,'30736','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23371,'44021','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41103,'70633','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45463,'77288','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45743,'77577','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30055,'53725','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9567,'21060','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(571,'01951','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3394,'09107','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27196,'49095','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14278,'29329','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19400,'37221','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38343,'65706','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41016,'70525','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42294,'72453','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51230,'92263','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25026,'46322','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34129,'59402','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32636,'57108','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12313,'26321','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31739,'56068','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16262,'31820','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17108,'33157','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44675,'76115','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45936,'78006','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55044,'99686','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30470,'54466','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28801,'51045','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16802,'32703','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39838,'68157','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41992,'72076','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48441,'83337','Camas','16025','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6650,'15714','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10386,'22942','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38148,'65532','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41588,'71429','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45643,'77477','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53895,'97471','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51105,'92092','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30948,'54960','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24496,'45710','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16025,'31550','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42031,'72111','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34023,'59218','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6947,'16159','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41113,'70644','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19890,'38015','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10873,'23847','Emporia City','51595','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37301,'63942','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38133,'65463','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29931,'53520','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14413,'29483','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31245,'55366','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21105,'39666','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46769,'79086','Sherman','48421','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46959,'79367','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26188,'47942','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43469,'74361','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51705,'93385','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33050,'57601','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39962,'68376','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36349,'62644','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8796,'19610','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3452,'09353','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(33659,'58562','Hettinger','38041','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31328,'55427','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28547,'50601','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20088,'38317','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39809,'68122','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6581,'15631','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29712,'53056','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34853,'60559','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38346,'65708','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39225,'67349','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44043,'75237','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49242,'85249','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53069,'96013','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3551,'09613','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26303,'48040','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12765,'27316','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11043,'24055','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33216,'58018','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48800,'84056','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48816,'84069','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(34855,'60560','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37571,'64484','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45619,'77455','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16520,'32303','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28407,'50481','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23252,'43812','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20729,'39114','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19909,'38037','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8784,'19564','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14935,'30107','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44744,'76234','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48226,'82520','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48494,'83440','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51405,'92604','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5866,'14520','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2927,'07934','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21282,'40023','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17587,'33915','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42434,'72629','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11708,'25123','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11295,'24401','Staunton City','51790','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4604,'12305','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15193,'30320','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17950,'34954','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27244,'49233','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31298,'55399','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11058,'24066','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54096,'98006','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38980,'66955','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36420,'62721','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10963,'23950','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33233,'58036','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10067,'22240','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(332,'01260','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23379,'44026','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14858,'30054','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42663,'72945','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43695,'74825','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33651,'58559','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28910,'51363','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37273,'63875','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44798,'76305','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49911,'87752','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49926,'87901','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(143,'00914','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(47529,'80438','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48966,'84523','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5885,'14536','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9996,'22066','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24144,'45227','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35319,'61362','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44860,'76431','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49991,'88081','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(29020,'51549','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25984,'47597','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25285,'46780','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18818,'36401','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20050,'38240','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34455,'60021','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32492,'56933','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(31475,'55742','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6544,'15555','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28881,'51301','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2869,'07832','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25780,'47358','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18851,'36456','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20475,'38773','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18982,'36685','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19844,'37915','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19593,'37617','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35905,'62093','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49854,'87552','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53085,'96029','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30042,'53704','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29974,'53553','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3989,'10923','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41797,'71845','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54872,'99347','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32297,'56560','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6704,'15771','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33120,'57717','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32936,'57457','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30944,'54956','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6172,'15003','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7633,'17343','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2539,'06897','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23531,'44222','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48856,'84112','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(3052,'08103','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9244,'20543','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17102,'33151','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40081,'68524','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26702,'48553','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53186,'96137','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45622,'77457','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42734,'73032','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6500,'15480','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16678,'32524','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23664,'44439','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20837,'39284','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17915,'34748','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16781,'32668','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41889,'72001','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44332,'75659','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44882,'76444','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47353,'80106','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(21953,'41180','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14668,'29745','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39097,'67105','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51463,'92697','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3478,'09421','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12359,'26385','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25624,'47165','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14983,'30143','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18979,'36670','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18695,'36135','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35588,'61731','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36608,'62910','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37137,'63645','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(447,'01585','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3101,'08302','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4727,'12524','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15691,'30907','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32252,'56521','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32206,'56464','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34943,'60686','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38600,'66115','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41582,'71425','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6763,'15864','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20700,'39086','Claiborne','28021','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25527,'47031','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32249,'56519','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27229,'49203','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44455,'75846','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45208,'76859','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52934,'95825','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28286,'50330','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43847,'75030','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1422,'04239','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31532,'55805','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8524,'19109','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27825,'49893','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35881,'62080','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37775,'64783','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7149,'16544','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8175,'18440','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12526,'26722','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53746,'97309','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34136,'59410','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3695,'10010','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34765,'60482','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25644,'47220','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23758,'44626','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20936,'39423','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14689,'29824','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17682,'34103','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15300,'30441','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37388,'64071','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44220,'75485','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32273,'56540','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27920,'50028','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27698,'49756','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8472,'19054','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13243,'27985','Perquimans','37143','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42057,'72128','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2742,'07504','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2718,'07442','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(808,'02558','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19937,'38059','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5985,'14720','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6423,'15365','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14564,'29645','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51097,'92081','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51686,'93290','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47176,'79765','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45974,'78042','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36327,'62626','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7499,'17088','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1972,'05640','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39681,'67878','Stanton','20187','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21055,'39602','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54428,'98438','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46989,'79409','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19613,'37659','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4824,'12745','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54223,'98185','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34500,'60074','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7034,'16333','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9046,'20165','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29448,'52554','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26878,'48762','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10996,'24008','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31855,'56161','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33280,'58064','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32570,'57043','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1933,'05461','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25703,'47274','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36984,'63437','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42682,'72959','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(55164,'99925','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(6872,'16053','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12902,'27537','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15620,'30741','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20483,'38801','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24229,'45323','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34293,'59721','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42313,'72469','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52418,'95045','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(669,'02169','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51045,'92007','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51159,'92161','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(811,'02562','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29710,'53051','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27176,'49082','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24655,'45859','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17355,'33574','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14202,'29160','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42740,'73039','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50288,'89133','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54656,'98907','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8046,'18210','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14092,'29045','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38833,'66741','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39816,'68131','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42122,'72204','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45204,'76856','Menard','48327','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51522,'92863','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51719,'93410','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26957,'48843','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25019,'46310','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19284,'37115','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13846,'28640','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15727,'31015','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53471,'96814','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(6991,'16244','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24961,'46231','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17633,'33974','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45213,'76862','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51637,'93238','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52037,'94080','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53327,'96610','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(38814,'66720','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29382,'52355','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1354,'04061','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32905,'57435','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30117,'53923','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21927,'41143','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35843,'62049','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39692,'67950','Morton','20129','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44509,'75938','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11158,'24175','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8622,'19342','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51650,'93247','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32212,'56468','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51485,'92805','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43603,'74576','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42581,'72827','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38689,'66440','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41815,'71860','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34082,'59313','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33655,'58561','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5032,'13032','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12258,'26234','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14328,'29403','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16116,'31649','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34404,'59914','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44526,'75958','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48321,'83011','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(8537,'19122','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10285,'22732','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24395,'45617','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23782,'44644','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15317,'30452','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18899,'36526','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37867,'65038','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43965,'75147','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21387,'40160','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36345,'62640','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(111,'00785','Guayanilla','72059','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(44273,'75571','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29025,'51551','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22310,'42142','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37992,'65256','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45809,'77707','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47358,'80110','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48103,'81647','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48671,'83801','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50588,'90264','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11689,'25090','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34110,'59339','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15732,'31016','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22044,'41517','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42439,'72632','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2464,'06752','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43636,'74701','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44505,'75935','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47870,'81047','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12310,'26302','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13559,'28365','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22245,'42054','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22089,'41606','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19489,'37352','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41057,'70562','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45690,'77516','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53909,'97490','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9005,'20120','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12311,'26306','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28388,'50468','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45711,'77538','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19163,'37030','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29729,'53069','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15965,'31409','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41700,'71666','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46336,'78597','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47471,'80250','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23839,'44695','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34350,'59826','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36375,'62672','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45170,'76827','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46971,'79377','Dawson','48115','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48256,'82701','Weston','56045','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(43999,'75180','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49565,'86047','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33928,'59032','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31359,'55460','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29895,'53402','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35166,'61102','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39032,'67028','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40045,'68458','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40587,'69120','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42429,'72623','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(464,'01614','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37670,'64658','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39586,'67753','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3109,'08317','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9484,'20874','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18853,'36458','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5445,'13695','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54605,'98812','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32182,'56443','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45166,'76824','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49894,'87729','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(33872,'58801','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32075,'56334','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31331,'55430','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42428,'72619','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24607,'45830','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19525,'37373','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16347,'32060','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43550,'74502','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6303,'15208','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8205,'18465','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8631,'19350','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39896,'68333','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41890,'72002','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42307,'72464','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6576,'15625','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53125,'96075','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11061,'24069','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10990,'24002','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50694,'90732','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46342,'78606','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36119,'62414','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38137,'65468','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42537,'72742','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43096,'73662','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7993,'18058','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8717,'19478','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18115,'35146','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37209,'63780','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48928,'84327','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52362,'94960','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53375,'96708','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12950,'27577','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38202,'65591','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38701,'66503','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54258,'98237','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49951,'88021','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47458,'80238','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3328,'08872','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8495,'19082','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27665,'49730','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16579,'32359','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49510,'85920','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53409,'96747','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(23427,'44081','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13169,'27892','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23410,'44061','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11640,'25024','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33366,'58255','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50964,'91754','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52285,'94617','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34165,'59440','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(26047,'47722','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36207,'62468','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5850,'14508','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5620,'14047','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12176,'26102','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14759,'29925','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18828,'36426','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(850,'02661','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27102,'49027','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21509,'40346','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26733,'48616','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5096,'13092','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25937,'47541','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29222,'52171','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1433,'04258','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40129,'68637','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32216,'56470','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29808,'53149','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5301,'13452','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9236,'20535','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36366,'62666','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39024,'67024','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39328,'67480','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32001,'56283','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23323,'43945','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22954,'43347','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14276,'29324','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13898,'28678','Alexander','37003','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42939,'73443','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(484,'01746','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4302,'11773','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8322,'18823','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6640,'15695','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18907,'36536','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37090,'63563','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48317,'82944','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48760,'84016','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(55159,'99918','Prince Wales Hyder','2198','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(10844,'23824','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31140,'55150','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30485,'54476','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19512,'37365','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20026,'38197','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31785,'56111','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20576,'38913','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3988,'10922','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1740,'04933','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12768,'27320','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14096,'29048','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14741,'29907','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37972,'65240','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45766,'77614','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47437,'80224','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52321,'94808','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54778,'99141','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26053,'47730','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6779,'15915','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18906,'36535','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15841,'31078','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6345,'15254','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8759,'19536','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41523,'71346','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43421,'74172','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47189,'79782','Glasscock','48173','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48301,'82925','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(34122,'59351','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33448,'58351','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31598,'55949','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30098,'53821','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23614,'44317','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23211,'43761','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54894,'99403','Garfield','53023','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13930,'28710','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17039,'33056','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41294,'71038','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5585,'14011','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5327,'13479','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1130,'03435','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4256,'11718','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30123,'53925','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26749,'48624','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14712,'29843','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20420,'38683','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18843,'36451','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15003,'30157','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36342,'62638','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46839,'79227','Foard','48155','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51978,'93922','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11475,'24613','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37237,'63830','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37529,'64448','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40229,'68743','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23065,'43523','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(328,'01256','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5026,'13028','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2912,'07902','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16273,'31826','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13664,'28456','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27601,'49676','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45077,'76644','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47827,'80995','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49899,'87734','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54693,'99006','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33333,'58224','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31760,'56083','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10373,'22932','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2488,'06791','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12893,'27529','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16725,'32591','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13707,'28520','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36443,'62801','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40176,'68669','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50225,'89031','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52670,'95428','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53504,'96860','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53658,'97138','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(518,'01840','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19966,'38104','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24092,'45152','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44057,'75252','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53213,'96209','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(34164,'59440','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1045,'03106','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12559,'26845','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32882,'57420','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29179,'52135','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20999,'39483','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10912,'23888','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53248,'96347','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(38684,'66438','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38262,'65634','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12819,'27401','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8142,'18410','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54730,'99037','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33027,'57564','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31461,'55726','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2770,'07626','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6250,'15085','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28447,'50532','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5469,'13749','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41713,'71675','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41753,'71762','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46015,'78076','Zapata','48505','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49178,'85097','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31529,'55802','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31322,'55421','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23499,'44181','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8945,'20050','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20008,'38163','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50739,'91008','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41749,'71754','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(373,'01431','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2920,'07928','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9495,'20886','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25690,'47264','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19356,'37180','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31766,'56088','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12871,'27517','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5300,'13450','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16627,'32439','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24675,'45871','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41591,'71431','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43545,'74470','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27274,'49255','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26978,'48857','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49659,'87008','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(33668,'58569','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34261,'59635','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14194,'29150','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16211,'31783','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27152,'49066','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17341,'33559','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26445,'48189','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50469,'90011','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28162,'50226','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18448,'35767','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14573,'29651','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3668,'09846','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43085,'73655','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51743,'93444','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43623,'74643','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2626,'07071','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33887,'58847','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22126,'41713','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18912,'36542','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14390,'29464','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6525,'15536','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45525,'77360','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53346,'96662','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(640,'02126','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14239,'29216','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14195,'29150','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18884,'36504','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38942,'66872','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54956,'99585','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(12988,'27609','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21049,'39577','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1060,'03223','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19992,'38134','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1987,'05661','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40617,'69141','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42565,'72773','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51501,'92832','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52070,'94130','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24812,'46077','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16834,'32745','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43264,'74015','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34160,'59433','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15862,'31091','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31134,'55129','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26970,'48850','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24618,'45836','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16589,'32405','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47504,'80314','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54256,'98235','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19817,'37878','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6922,'16133','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10685,'23337','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17508,'33815','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40022,'68443','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33471,'58372','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54503,'98565','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52615,'95363','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52054,'94114','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51904,'93667','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46770,'79087','Dallam','48111','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34985,'60924','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4836,'12759','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31237,'55359','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11056,'24065','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42726,'73027','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50090,'88351','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51342,'92423','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36526,'62860','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36300,'62568','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23101,'43554','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54134,'98046','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8309,'18773','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8081,'18248','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7560,'17236','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32656,'57216','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19938,'38059','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40478,'68948','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51824,'93591','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4746,'12543','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14105,'29056','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18335,'35579','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30715,'54736','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35837,'62044','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20568,'38878','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34217,'59501','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34126,'59353','Wibaux','30109','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22504,'42459','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29186,'52141','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26514,'48303','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52415,'95042','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53182,'96134','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53265,'96379','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(5360,'13607','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11366,'24502','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24283,'45360','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22300,'42133','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39167,'67202','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52953,'95843','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38300,'65660','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17040,'33060','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17625,'33965','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42856,'73127','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43381,'74115','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37734,'64744','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20592,'38925','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17168,'33301','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2808,'07712','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1426,'04250','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48578,'83622','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50183,'88582','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(10005,'22101','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53848,'97419','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52508,'95208','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4658,'12450','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4202,'11548','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53349,'96665','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1766,'04962','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16174,'31756','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27631,'49701','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3607,'09738','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11835,'25329','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26280,'48009','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35461,'61501','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54936,'99561','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47030,'79519','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17740,'34224','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18057,'35079','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38397,'65742','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21294,'40037','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23104,'43556','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42836,'73108','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44133,'75417','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13917,'28694','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28444,'50531','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3204,'08562','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19829,'37885','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20479,'38778','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50169,'88568','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(50221,'89027','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(14985,'30143','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31969,'56260','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9252,'20553','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3716,'10032','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24825,'46111','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43655,'74735','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1481,'04357','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1573,'04555','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21135,'39743','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41763,'71766','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45650,'77481','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54938,'99564','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47921,'81123','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23007,'43447','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17509,'33820','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11026,'24030','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33508,'58421','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29638,'53001','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1025,'03064','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24577,'45806','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52007,'94018','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47182,'79770','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46282,'78537','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30214,'54020','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19960,'38080','Lake','47095','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46022,'78108','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35143,'61074','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13244,'27986','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19384,'37207','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19413,'37240','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(281,'01103','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7925,'17966','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13649,'28445','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34352,'59828','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30819,'54832','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43051,'73573','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51345,'92502','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9443,'20810','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23368,'44011','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2305,'06357','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10733,'23439','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36123,'62420','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20125,'38347','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42184,'72347','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13586,'28384','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18493,'35906','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4181,'11432','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16988,'32967','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53060,'96002','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29213,'52165','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26391,'48137','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22778,'43115','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19073,'36832','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38906,'66846','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52821,'95634','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33259,'58053','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28339,'50435','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28314,'50402','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35246,'61282','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54772,'99136','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52739,'95528','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37700,'64686','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8824,'19735','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(22661,'43015','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28309,'50394','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42333,'72503','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44450,'75839','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(505,'01813','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24719,'45897','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5349,'13502','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49973,'88044','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(3454,'09355','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12419,'26521','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38617,'66213','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38976,'66952','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34289,'59718','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25603,'47141','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10097,'22334','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11755,'25203','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54865,'99344','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53052,'95984','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41208,'70778','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49348,'85378','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7302,'16840','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14769,'29934','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36195,'62462','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3293,'08827','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31580,'55936','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11662,'25053','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11460,'24598','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20821,'39212','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49811,'87503','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(12780,'27331','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21096,'39662','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20560,'38871','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8038,'18106','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17980,'34997','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33521,'58429','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31997,'56280','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26482,'48229','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(961,'02880','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(892,'02762','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37699,'64683','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20477,'38774','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50441,'89801','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(2391,'06493','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(39847,'68183','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31094,'55088','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25284,'46779','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49763,'87194','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36212,'62474','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5853,'14512','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44737,'76228','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52925,'95816','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26834,'48734','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24965,'46235','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40133,'68640','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45702,'77531','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42226,'72390','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9494,'20885','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4751,'12547','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23680,'44452','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21247,'39886','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19158,'37027','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37918,'65074','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47249,'79930','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48361,'83214','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14785,'30003','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(458,'01608','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53594,'97058','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47725,'80810','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8676,'19423','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32671,'57226','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19056,'36790','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7886,'17887','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34972,'60917','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31339,'55437','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7148,'16541','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10150,'22488','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42805,'73078','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43662,'74743','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49545,'86023','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52026,'94043','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9016,'20132','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1030,'03077','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11674,'25067','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2436,'06610','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52500,'95196','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15689,'30905','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1094,'03260','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(31823,'56138','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22655,'43013','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21327,'40065','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42502,'72704','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54362,'98356','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44277,'75574','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41275,'71018','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38633,'66250','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24399,'45620','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20239,'38486','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18702,'36202','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16202,'31779','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5212,'13317','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30412,'54425','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3941,'10587','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37923,'65077','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37403,'64081','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36129,'62421','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31717,'56052','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26288,'48023','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45001,'76542','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45171,'76828','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47701,'80742','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30495,'54486','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14648,'29718','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3224,'08638','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33010,'57548','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54368,'98362','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44730,'76208','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39495,'67646','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20364,'38633','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2879,'07843','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9212,'20504','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1951,'05482','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2124,'06025','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1041,'03104','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12803,'27357','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45423,'77236','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47810,'80937','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53413,'96751','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(34468,'60038','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6205,'15035','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11702,'25114','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43367,'74085','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3939,'10580','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6361,'15276','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10033,'22182','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47603,'80525','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10846,'23827','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20248,'38505','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45964,'78025','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16928,'32868','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14200,'29154','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2160,'06068','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5579,'14008','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14492,'29582','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25910,'47516','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24301,'45374','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40195,'68720','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48714,'83846','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(723,'02339','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38069,'65339','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32231,'56482','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30400,'54418','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14675,'29809','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29238,'52208','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26758,'48629','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6044,'14787','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10245,'22652','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10922,'23898','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24366,'45458','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16601,'32420','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21004,'39505','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51054,'92020','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8707,'19464','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49777,'87316','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(33111,'57703','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27912,'50023','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34399,'59911','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35900,'62090','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11896,'25503','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13217,'27954','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20323,'38589','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33754,'58656','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39461,'67628','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45055,'76628','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25831,'47405','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(138,'00909','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51664,'93261','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50188,'88587','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(43244,'73960','Sherman','48421','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22822,'43150','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13946,'28723','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12668,'27205','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1064,'03227','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6434,'15380','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19016,'36751','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47520,'80428','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32152,'56388','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15056,'30212','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24467,'45682','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4992,'12967','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13589,'28386','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17533,'33849','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17880,'34682','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48037,'81425','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51527,'92868','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32954,'57469','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6176,'15005','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1446,'04275','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34397,'59904','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14774,'29939','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28352,'50447','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45581,'77422','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46774,'79091','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9704,'21285','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14184,'29138','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13731,'28538','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6967,'16224','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32869,'57382','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23275,'43844','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26609,'48423','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26722,'48612','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50874,'91393','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2259,'06245','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37648,'64646','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39995,'68421','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52003,'94014','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15514,'30628','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8526,'19111','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12221,'26169','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43271,'74019','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18577,'36026','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31071,'55070','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6153,'14889','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4772,'12572','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36716,'62988','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34958,'60712','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16661,'32502','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17008,'33018','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53459,'96802','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(13423,'28217','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12879,'27521','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12064,'25840','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28357,'50450','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23922,'44842','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3588,'09718','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54262,'98241','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52559,'95304','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49525,'85936','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40240,'68749','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39317,'67467','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15797,'31049','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37781,'64788','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31904,'56214','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5813,'14470','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39362,'67515','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46814,'79121','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37097,'63601','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31713,'56050','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30457,'54457','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15665,'30818','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15560,'30666','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24069,'45130','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6811,'15952','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23834,'44689','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(307,'01223','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51066,'92033','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35969,'62255','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4114,'11235','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27894,'50006','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39859,'68307','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45037,'76578','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50750,'91025','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37687,'64672','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25134,'46540','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24957,'46229','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21755,'40858','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2859,'07822','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15748,'31024','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36364,'62665','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29388,'52358','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7915,'17953','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11809,'25285','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5317,'13470','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17997,'35016','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39127,'67122','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49442,'85653','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53112,'96059','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35974,'62258','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3221,'08625','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7128,'16475','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20824,'39215','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20846,'39303','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38686,'66439','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9691,'21251','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27746,'49806','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26963,'48846','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51581,'93065','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53190,'96143','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25440,'46958','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23307,'43931','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45255,'76908','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52096,'94204','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8352,'18853','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27380,'49338','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23827,'44683','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40942,'70436','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46773,'79088','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50166,'88565','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(54346,'98339','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25150,'46553','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17617,'33953','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18076,'35098','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23050,'43515','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9281,'20599','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(15641,'30805','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13394,'28166','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27521,'49612','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3094,'08251','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19077,'36850','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44503,'75934','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45779,'77630','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51711,'93401','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31775,'56096','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4426,'12059','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7681,'17517','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48746,'83877','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47676,'80721','Phillips','8095','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26489,'48236','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14811,'30016','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34881,'60610','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31935,'56230','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39003,'67005','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24358,'45439','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44385,'75750','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45216,'76866','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51513,'92845','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38699,'66502','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38318,'65675','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14556,'29641','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6877,'16056','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13067,'27812','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21156,'39752','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34625,'60183','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53247,'96346','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51571,'93040','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25947,'47553','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48547,'83544','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14988,'30145','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14627,'29692','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38681,'66434','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14163,'29123','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21742,'40829','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25341,'46853','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26815,'48722','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28734,'51002','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27686,'49747','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26908,'48812','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43464,'74358','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48258,'82711','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54448,'98501','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11502,'24657','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16694,'32544','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31566,'55923','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25210,'46711','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48221,'82512','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48019,'81401','Ouray','8091','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43354,'74079','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19923,'38046','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22496,'42452','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24722,'45899','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28491,'50563','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25580,'47125','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26178,'47930','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39615,'67837','Haskell','20081','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43778,'74930','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54387,'98382','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1313,'04005','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13491,'28306','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19805,'37871','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37251,'63849','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20561,'38873','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42489,'72682','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43584,'74558','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45550,'77381','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52059,'94119','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1617,'04643','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38501,'66021','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38102,'65436','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1153,'03467','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(48592,'83634','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48941,'84340','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51477,'92780','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13367,'28129','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30933,'54945','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25202,'46703','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46466,'78683','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47116,'79699','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6677,'15741','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37241,'63837','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25476,'46982','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52669,'95427','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22603,'42743','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37441,'64127','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11727,'25148','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29988,'53561','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18579,'36027','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25020,'46310','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23863,'44735','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39574,'67747','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41795,'71841','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44607,'76050','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45262,'76933','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52283,'94614','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54277,'98257','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24150,'45234','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20537,'38858','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17794,'34295','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45993,'78059','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54499,'98561','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50073,'88336','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47250,'79931','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14535,'29625','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8094,'18302','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10251,'22656','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6268,'15112','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5099,'13101','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5165,'13165','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22253,'42064','Caldwell','21033','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21459,'40281','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49332,'85360','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53159,'96112','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26759,'48630','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21985,'41264','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19081,'36853','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14286,'29335','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28750,'51014','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22803,'43140','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32730,'57265','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10931,'23919','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30193,'54002','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19276,'37101','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24652,'45858','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42110,'72176','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45506,'77346','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45693,'77519','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48923,'84322','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52180,'94512','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(806,'02556','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36798,'63071','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8333,'18831','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3241,'08723','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25303,'46791','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29043,'51562','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40218,'68735','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46348,'78610','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48645,'83707','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50942,'91723','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35736,'61882','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1635,'04668','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33122,'57718','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40784,'70062','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44990,'76534','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1266,'03855','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(48772,'84028','Rich','49033','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10644,'23274','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8113,'18336','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29298,'52251','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28136,'50210','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12745,'27298','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19780,'37852','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39040,'67035','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54737,'99104','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16451,'32183','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31076,'55073','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24319,'45388','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10187,'22551','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48477,'83422','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44859,'76431','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(457,'01607','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36948,'63373','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36663,'62946','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11099,'24112','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23074,'43530','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8917,'20017','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19098,'36866','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41810,'71857','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46772,'79088','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51620,'93215','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21244,'39877','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42849,'73121','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44092,'75358','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8084,'18250','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35545,'61633','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3093,'08250','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40251,'68758','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47392,'80135','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15396,'30530','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8128,'18354','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37417,'64097','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6659,'15723','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2046,'05768','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(51057,'92023','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40464,'68942','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30399,'54417','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32355,'56628','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35961,'62250','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10118,'22435','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26017,'47640','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43339,'74068','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10528,'23116','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13528,'28339','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38444,'65778','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4165,'11416','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35277,'61329','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29981,'53557','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39181,'67216','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49748,'87144','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(10778,'23513','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27855,'49934','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13370,'28133','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37627,'64635','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36444,'62801','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22879,'43236','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42883,'73151','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48532,'83531','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54193,'98127','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16494,'32234','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7802,'17776','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43845,'75028','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47584,'80504','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6207,'15038','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16791,'32693','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11630,'25003','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3155,'08504','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1522,'04450','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12929,'27560','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44701,'76155','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37966,'65231','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36496,'62838','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27404,'49356','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24188,'45274','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18182,'35234','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40789,'70068','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9812,'21670','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12451,'26574','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27657,'49724','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17180,'33313','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18036,'35057','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40924,'70401','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43008,'73540','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19965,'38103','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9828,'21709','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(44475,'75859','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46364,'78618','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48208,'82432','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48300,'82923','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37080,'63557','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8985,'20106','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38905,'66846','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38026,'65284','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16126,'31705','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35423,'61472','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4603,'12304','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27867,'49953','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27391,'49344','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20547,'38864','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41610,'71450','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51625,'93221','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30566,'54552','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29951,'53534','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1271,'03860','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16868,'32784','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12798,'27355','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13738,'28545','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17420,'33675','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35618,'61751','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43498,'74430','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46165,'78291','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7511,'17104','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17840,'34487','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27927,'50034','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22737,'43074','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44562,'76007','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49517,'85928','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(22209,'42025','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41805,'71853','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47801,'80928','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11143,'24151','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16381,'32097','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19756,'37828','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35211,'61250','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38228,'65613','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46604,'78941','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12477,'26619','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12281,'26267','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12426,'26537','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35821,'62024','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43858,'75042','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13281,'28039','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14592,'29664','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15968,'31412','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1544,'04478','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10323,'22827','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11625,'24986','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37112,'63626','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3502,'09513','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7419,'17024','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27122,'49042','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20753,'39146','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4393,'12023','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40302,'68788','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51127,'92120','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52206,'94536','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53966,'97636','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5901,'14550','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51445,'92663','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51657,'93252','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52377,'94998','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53141,'96092','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53667,'97147','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13220,'27958','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32099,'56349','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27248,'49236','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25541,'47041','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15604,'30733','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11339,'24468','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(489,'01754','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5546,'13844','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38473,'65814','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39222,'67346','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48390,'83252','Oneida','16071','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48616,'83654','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29524,'52637','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53148,'96101','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34057,'59259','McCone','30055','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12881,'27522','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7699,'17543','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31992,'56277','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31876,'56175','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31842,'56152','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27725,'49780','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19157,'37026','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16700,'32559','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37065,'63544','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9264,'20573','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(37347,'64022','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28121,'50170','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29040,'51560','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12911,'27543','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35999,'62274','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41770,'71820','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47949,'81149','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34433,'60006','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28623,'50651','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26607,'48422','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8071,'18239','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5577,'14005','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54576,'98649','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38327,'65685','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25977,'47586','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4763,'12566','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14722,'29848','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25769,'47354','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22018,'41367','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37739,'64747','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48904,'84304','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52631,'95379','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30382,'54408','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25346,'46858','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14630,'29696','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16536,'32317','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51108,'92101','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42630,'72906','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34273,'59645','Meagher','30059','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2113,'06010','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32392,'56663','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2521,'06856','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9978,'22032','Fairfax City','51600','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16570,'32350','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18179,'35231','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44253,'75554','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46297,'78557','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54039,'97842','Wallowa','41063','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(877,'02725','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25691,'47265','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49696,'87044','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53142,'96093','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10246,'22652','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31605,'55954','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13055,'27804','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15486,'30605','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47688,'80733','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52154,'94299','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11041,'24054','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9160,'20403','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24658,'45861','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40539,'69022','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24108,'45168','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50846,'91354','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46153,'78266','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43684,'74802','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(434,'01546','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29590,'52748','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26538,'48328','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8243,'18614','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1322,'04015','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13759,'28571','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35689,'61845','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42287,'72447','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49745,'87124','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(4655,'12446','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10032,'22181','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27752,'49815','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39675,'67871','Wichita','20203','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40678,'69210','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20985,'39476','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38984,'66958','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11543,'24836','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31521,'55791','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9261,'20570','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(26301,'48038','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25036,'46342','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2010,'05702','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18840,'36445','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6031,'14770','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43166,'73757','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44426,'75789','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46294,'78551','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47807,'80934','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2387,'06488','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28315,'50420','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48476,'83421','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(21039,'39573','George','28039','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2782,'07646','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31242,'55363','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4113,'11234','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41414,'71227','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43260,'74014','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45608,'77447','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5736,'14227','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37768,'64778','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26994,'48872','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49563,'86045','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5286,'13426','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(116,'00795','Juana Diaz','72075','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(11890,'25443','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18022,'35043','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13979,'28752','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10888,'23866','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36985,'63438','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43315,'74048','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44183,'75453','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48166,'82224','Converse','56009','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(6487,'15466','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55039,'99681','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54982,'99622','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(17336,'33550','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2389,'06491','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23003,'43443','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34711,'60444','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2498,'06810','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24262,'45343','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1643,'04677','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13585,'28384','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22561,'42649','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20258,'38544','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43594,'74570','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7363,'16930','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19138,'37015','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1464,'04336','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10646,'23278','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22538,'42564','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10595,'23188','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42520,'72730','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31954,'56248','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53379,'96713','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(21199,'39826','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27327,'49309','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(860,'02672','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11195,'24230','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2757,'07543','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34595,'60152','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39294,'67449','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36187,'62454','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18441,'35761','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14837,'30036','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6974,'16229','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50659,'90631','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20344,'38619','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1056,'03220','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30483,'54475','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3996,'10930','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21191,'39819','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4522,'12170','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17983,'35006','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42153,'72316','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47016,'79506','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2171,'06078','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48491,'83436','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45296,'77010','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44845,'76389','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37896,'65058','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30066,'53786','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3404,'09139','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3255,'08742','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43134,'73729','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52501,'95201','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8500,'19086','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44660,'76101','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43947,'75126','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25950,'47557','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18507,'35957','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4064,'11040','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(187,'00970','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(12938,'27569','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13964,'28739','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31768,'56089','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49807,'87461','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2756,'07538','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54059,'97870','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52931,'95822','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50340,'89316','Eureka','32011','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(41972,'72063','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41181,'70750','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40589,'69121','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3623,'09769','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21313,'40052','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28586,'50627','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10493,'23081','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11268,'24347','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34336,'59804','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34690,'60429','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6862,'16046','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33029,'57566','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19568,'37410','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2745,'07507','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38028,'65284','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41887,'71999','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44956,'76503','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22147,'41749','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51878,'93641','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49301,'85329','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48206,'82430','Hot Springs','56017','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(39902,'68338','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37219,'63787','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35892,'62085','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20481,'38781','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20679,'39066','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9364,'20708','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11305,'24422','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33888,'58849','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54739,'99107','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46749,'79078','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45134,'76693','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44579,'76021','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43554,'74523','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41652,'71601','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5160,'13159','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41174,'70744','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3463,'09368','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2905,'07879','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30857,'54868','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49682,'87027','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36194,'62461','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20920,'39367','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28297,'50361','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23986,'44903','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6879,'16057','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47402,'80155','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41950,'72042','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5236,'13339','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54043,'97845','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25701,'47274','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29574,'52732','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14444,'29530','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34708,'60441','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29670,'53020','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46667,'79022','Dallam','48111','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46048,'78130','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23953,'44862','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28214,'50254','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28846,'51201','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14113,'29063','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11528,'24815','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54530,'98596','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51146,'92142','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50506,'90048','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47399,'80138','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42389,'72562','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38646,'66404','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1332,'04029','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6743,'15834','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(121,'00805','Saint Thomas','78030','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(24375,'45482','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23458,'44110','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13003,'27623','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(565,'01938','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3284,'08820','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1992,'05666','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42764,'73052','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43436,'74332','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45755,'77586','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41184,'70754','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36801,'63072','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36666,'62947','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34288,'59717','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(55003,'99644','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51852,'93620','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27392,'49345','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29770,'53108','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20796,'39183','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30986,'54984','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33193,'57791','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4587,'12248','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30838,'54847','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2769,'07624','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30089,'53812','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25957,'47564','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25282,'46777','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32219,'56473','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51121,'92114','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15470,'30577','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30516,'54499','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7720,'17569','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12430,'26542','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29349,'52327','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6702,'15767','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42562,'72768','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41183,'70753','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38496,'66017','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15616,'30739','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21617,'40472','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52198,'94527','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50128,'88523','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(13989,'28759','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1515,'04441','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22511,'42463','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23406,'44057','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2998,'08052','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3879,'10504','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30825,'54837','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31640,'55976','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9106,'20233','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30534,'54521','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28051,'50129','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44075,'75287','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41032,'70535','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24578,'45806','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18041,'35062','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5529,'13830','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33770,'58718','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(283,'01105','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24104,'45162','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21144,'39747','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20440,'38732','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25619,'47163','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1283,'03873','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22728,'43068','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2412,'06517','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33636,'58538','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30648,'54648','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13816,'28615','None','47999','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54519,'98584','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44219,'75483','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42340,'72519','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15594,'30722','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35848,'62053','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19743,'37818','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22843,'43194','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39372,'67522','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44617,'76055','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49240,'85248','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36670,'62950','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40487,'68956','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45398,'77208','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54495,'98557','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29416,'52533','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30538,'54527','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5768,'14418','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25660,'47232','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3362,'09014','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(22488,'42445','Caldwell','21033','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21749,'40845','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16068,'31620','Cook','13075','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7140,'16512','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35831,'62034','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43223,'73859','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31075,'55072','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25737,'47331','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(264,'01082','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40040,'68455','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40017,'68441','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24494,'45701','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2343,'06417','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3112,'08320','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2116,'06016','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22734,'43072','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45056,'76629','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46805,'79116','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47310,'80019','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54253,'98231','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31044,'55044','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27531,'49619','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32949,'57467','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46098,'78215','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36100,'62375','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25510,'47011','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27382,'49339','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1910,'05440','Grand Isle','50013','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20554,'38868','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20650,'39038','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24182,'45267','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38487,'66012','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50723,'90833','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32765,'57315','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10823,'23701','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36508,'62848','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49833,'87525','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51487,'92807','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1980,'05653','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3765,'10128','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10694,'23359','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32405,'56678','Clearwater','27029','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27933,'50038','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35808,'62013','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53192,'96146','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53452,'96793','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(12535,'26755','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32566,'57042','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10782,'23518','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8368,'18922','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44934,'76475','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45657,'77485','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42840,'73112','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30179,'53963','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25280,'46777','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27793,'49862','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30206,'54011','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28210,'50251','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36550,'62875','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41330,'71070','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46512,'78742','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49770,'87302','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(6660,'15724','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(68,'00720','Orocovis','72107','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(54296,'98279','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50139,'88534','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(31158,'55307','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8208,'18466','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46846,'79234','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36121,'62418','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18210,'35292','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5573,'14001','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6657,'15721','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6182,'15012','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26407,'48158','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5363,'13612','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5110,'13113','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37215,'63784','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34124,'59351','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15576,'30680','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17758,'34243','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21756,'40862','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35771,'61933','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15565,'30669','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28428,'50519','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38721,'66522','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39438,'67576','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49717,'87068','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(18447,'35766','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51068,'92037','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19832,'37888','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40692,'69221','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42686,'73003','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49270,'85284','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17583,'33911','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26608,'48423','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43099,'73664','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7573,'17249','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22025,'41408','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37039,'63473','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38260,'65634','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35464,'61519','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6124,'14869','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8966,'20073','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(28541,'50598','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25960,'47568','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23407,'44057','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54842,'99256','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8881,'19956','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(52896,'95714','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8430,'19010','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32924,'57449','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26548,'48341','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13762,'28572','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36338,'62634','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45209,'76859','Menard','48327','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51300,'92364','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10075,'22302','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51886,'93648','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48818,'84071','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39363,'67516','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30871,'54876','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30629,'54634','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8682,'19430','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7639,'17352','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3269,'08802','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23936,'44849','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4590,'12252','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33475,'58374','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4476,'12123','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39985,'68414','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31053,'55052','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16489,'32231','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43670,'74753','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50732,'90853','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52456,'95119','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33544,'58448','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2285,'06281','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26352,'48096','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14881,'30071','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19544,'37387','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17299,'33496','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17252,'33438','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16180,'31763','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38933,'66868','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45465,'77290','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47136,'79719','Ward','48475','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23631,'44404','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3514,'09556','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28644,'50666','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50384,'89440','Storey','32029','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(37945,'65106','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22215,'42031','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14548,'29634','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7116,'16434','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3364,'09021','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54353,'98348','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26497,'48244','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1925,'05454','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4531,'12182','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49239,'85246','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49050,'84730','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44976,'76525','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42889,'73157','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41255,'70884','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20503,'38833','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40508,'68972','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12101,'25908','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31368,'55483','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14217,'29177','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54092,'98002','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54727,'99033','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55142,'99820','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46738,'79068','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35301,'61346','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18386,'35648','Lauderdale','1077','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17910,'34744','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17151,'33238','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6617,'15675','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9962,'21919','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4227,'11579','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17481,'33773','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27346,'49320','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45397,'77207','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3951,'10598','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27213,'49112','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39804,'68117','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43892,'75075','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34580,'60143','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6040,'14783','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31209,'55339','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44200,'75470','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44520,'75949','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45210,'76861','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53750,'97314','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2619,'07064','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2883,'07847','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28052,'50130','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9321,'20643','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31897,'56209','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14801,'30012','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15596,'30725','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26203,'47950','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40828,'70125','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41618,'71457','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41914,'72021','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46154,'78268','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46799,'79108','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6843,'16028','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29266,'52224','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46946,'79358','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26704,'48555','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1581,'04570','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16375,'32094','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39416,'67563','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40615,'69138','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51217,'92250','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52742,'95534','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33892,'58854','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28445,'50532','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21945,'41174','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35540,'61615','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49473,'85724','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29649,'53010','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24554,'45772','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37929,'65080','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48190,'82335','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51283,'92338','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1009,'03044','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4219,'11568','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17629,'33971','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15893,'31193','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42924,'73433','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44692,'76133','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49385,'85552','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52209,'94539','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54105,'98015','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25912,'47520','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7568,'17243','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16092,'31635','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35779,'61940','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36233,'62512','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40857,'70165','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28879,'51249','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52295,'94660','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44938,'76476','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3947,'10594','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25240,'46742','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6993,'16246','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3441,'09315','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(46054,'78135','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47269,'79949','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47579,'80502','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11389,'24528','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36141,'62426','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51936,'93728','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6096,'14843','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16394,'32118','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29608,'52761','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28864,'51240','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25011,'46298','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23582,'44278','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37317,'63957','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37483,'64184','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38675,'66429','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41298,'71043','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(635,'02121','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52588,'95330','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45487,'77328','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43891,'75074','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54939,'99565','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(11385,'24523','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9916,'21822','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13795,'28601','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42098,'72165','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5487,'13775','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14981,'30141','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36723,'62996','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27703,'49761','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45818,'77802','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4139,'11363','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10375,'22935','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24632,'45845','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10667,'23307','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31052,'55051','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31941,'56236','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12542,'26767','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23384,'44033','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7474,'17068','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3873,'10475','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48948,'84405','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45934,'78005','Frio','48163','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40388,'68860','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10474,'23060','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54545,'98612','Wahkiakum','53069','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52311,'94710','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51384,'92567','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42023,'72104','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21669,'40575','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21618,'40473','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28604,'50636','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29384,'52356','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13934,'28712','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33579,'58475','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7146,'16534','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10389,'22946','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20585,'38921','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28576,'50621','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36234,'62513','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39631,'67844','Meade','20119','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34523,'60096','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24783,'46061','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35366,'61425','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8151,'18419','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52130,'94269','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38388,'65738','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5296,'13440','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31706,'56044','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26732,'48616','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22931,'43334','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12941,'27571','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49739,'87119','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(38541,'66056','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1958,'05490','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7727,'17578','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15698,'30917','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23594,'44287','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11214,'24260','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27658,'49725','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7187,'16640','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1103,'03272','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28907,'51358','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25523,'47023','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37042,'63474','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39933,'68357','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26916,'48818','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45304,'77018','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35451,'61486','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20565,'38876','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19639,'37699','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27377,'49337','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29939,'53525','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25312,'46795','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31018,'55021','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51718,'93409','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51302,'92366','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50936,'91710','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48239,'82635','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49730,'87109','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37261,'63862','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49824,'87516','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37221,'63801','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35599,'61739','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4972,'12943','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17805,'34433','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17905,'34739','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18226,'35442','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31915,'56220','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6695,'15761','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49073,'84754','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(14546,'29632','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44584,'76028','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41279,'71023','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39499,'67648','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54970,'99608','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(39469,'67632','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47593,'80515','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46356,'78613','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24723,'45999','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38749,'66541','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14059,'29014','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12813,'27373','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37523,'64443','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10578,'23177','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18476,'35815','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6830,'16003','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(557,'01921','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10813,'23668','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9171,'20414','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8294,'18703','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22360,'42232','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54169,'98101','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54813,'99180','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27233,'49224','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17516,'33831','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5998,'14731','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33603,'58494','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8573,'19160','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1018,'03054','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(38010,'65265','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30996,'55005','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20590,'38924','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28268,'50315','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24021,'45050','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26151,'47906','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48415,'83301','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6007,'14739','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4776,'12578','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4973,'12944','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38015,'65275','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36380,'62677','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34779,'60503','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23663,'44438','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40668,'69168','Sedgwick','8115','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39162,'67155','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49393,'85605','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45019,'76561','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16787,'32683','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3672,'09855','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3332,'08876','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8814,'19718','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(28809,'51048','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24614,'45833','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24291,'45368','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4756,'12552','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34518,'60090','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30984,'54983','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44266,'75565','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39006,'67009','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53307,'96552','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(40380,'68855','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34386,'59866','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2818,'07724','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15597,'30726','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35473,'61528','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36535,'62867','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13132,'27865','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22250,'42060','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31234,'55356','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29772,'53110','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26141,'47885','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47255,'79935','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50326,'89178','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52367,'94970','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49794,'87401','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46057,'78140','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29823,'53170','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19488,'37352','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19307,'37138','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7173,'16627','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2020,'05739','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9081,'20204','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8720,'19482','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23119,'43601','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49465,'85716','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3983,'10917','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51096,'92079','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50544,'90087','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44940,'76481','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7110,'16428','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10472,'23059','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28080,'50148','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3781,'10159','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31478,'55746','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12358,'26385','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(379,'01440','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22453,'42372','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13253,'28016','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15028,'30178','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38935,'66868','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49321,'85349','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41062,'70575','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52221,'94550','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14222,'29180','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27450,'49434','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27883,'49969','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2162,'06070','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(4778,'12581','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6195,'15026','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28594,'50630','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27400,'49348','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41196,'70767','West Baton Rouge','22121','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46133,'78249','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47580,'80503','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48913,'84313','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11974,'25650','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13722,'28530','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14391,'29465','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25566,'47117','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27479,'49459','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42346,'72522','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9669,'21227','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15491,'30608','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18513,'35959','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32782,'57325','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23077,'43532','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28598,'50632','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29359,'52335','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1791,'04992','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22942,'43342','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7054,'16352','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40552,'69028','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35135,'61068','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4777,'12580','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14029,'28802','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41626,'71463','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42005,'72084','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48557,'83553','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51378,'92556','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54153,'98070','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53330,'96614','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54233,'98203','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44368,'75692','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42935,'73441','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41023,'70529','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24173,'45252','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15234,'30357','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12837,'27425','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10530,'23117','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53815,'97380','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44214,'75480','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42014,'72089','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27113,'49037','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26961,'48845','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14376,'29448','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27469,'49451','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11911,'25514','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36493,'62837','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41488,'71303','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18920,'36551','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22366,'42240','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10160,'22511','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10347,'22901','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11571,'24873','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34663,'60406','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14074,'29032','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36782,'63053','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38579,'66093','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32824,'57355','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30209,'54015','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13096,'27834','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5531,'13833','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2245,'06231','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25867,'47449','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24370,'45470','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9775,'21635','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18229,'35443','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4497,'12148','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51572,'93041','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43793,'74944','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21482,'40312','Powell','21197','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31363,'55473','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37834,'64874','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27443,'49426','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19415,'37242','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29124,'52040','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35495,'61544','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13931,'28711','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15144,'30285','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4050,'11002','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53312,'96562','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(41256,'70891','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20416,'38676','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11907,'25510','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26927,'48827','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39381,'67529','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7875,'17876','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42588,'72833','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47071,'79545','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37289,'63935','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1110,'03279','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(31228,'55352','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2689,'07310','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2939,'07963','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40557,'69029','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48627,'83669','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(55151,'99833','Petersburg Census Area','2195','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(24501,'45712','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18610,'36042','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20752,'39146','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48762,'84018','Morgan','49029','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48827,'84081','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49156,'85063','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2736,'07480','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13461,'28266','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29092,'51647','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27390,'49344','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8413,'18974','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38914,'66854','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33837,'58771','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29889,'53278','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27753,'49816','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23853,'44709','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20273,'38555','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6696,'15762','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19599,'37640','Johnson','47091','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43333,'74063','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43490,'74422','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44563,'76008','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51725,'93424','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16679,'32526','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35273,'61325','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1168,'03583','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5075,'13071','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41683,'71654','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41263,'71001','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19041,'36773','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17767,'34266','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17211,'33351','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4460,'12093','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(934,'02835','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(53209,'96204','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(16378,'32096','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32417,'56687','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31302,'55404','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29502,'52595','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24797,'46069','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7669,'17502','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53997,'97750','Wheeler','41069','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9871,'21771','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50793,'91207','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50661,'90633','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8497,'19083','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29794,'53137','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27342,'49318','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22690,'43040','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2490,'06793','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2019,'05738','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39761,'68050','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42905,'73179','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48283,'82831','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(35486,'61536','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20257,'38543','Pickett','47137','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18199,'35260','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47238,'79918','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38404,'65747','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7176,'16630','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16861,'32776','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15051,'30204','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29995,'53569','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28098,'50156','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25668,'47240','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40840,'70146','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47723,'80808','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18228,'35442','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3314,'08855','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47023,'79512','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54004,'97759','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49704,'87048','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48659,'83720','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39156,'67151','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38638,'66285','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15884,'31139','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25241,'46743','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24929,'46184','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23072,'43528','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9732,'21529','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11564,'24866','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4468,'12116','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14367,'29438','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2820,'07727','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3958,'10607','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30719,'54738','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17230,'33415','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41151,'70718','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9303,'20621','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38025,'65283','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49695,'87043','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(37803,'64844','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33312,'58202','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29875,'53225','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21180,'39773','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40679,'69211','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42690,'73006','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48003,'81323','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5376,'13623','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15347,'30477','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14539,'29627','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13948,'28725','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11501,'24656','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25505,'47006','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22580,'42718','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44463,'75851','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45046,'76621','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54198,'98134','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21046,'39574','Stone','28131','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46576,'78870','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17825,'34471','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7100,'16416','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52936,'95827','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55094,'99747','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9630,'21163','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11494,'24641','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7590,'17267','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33205,'58007','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9360,'20705','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42746,'73042','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45590,'77431','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46847,'79234','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4734,'12531','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53832,'97402','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51575,'93044','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45493,'77334','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35046,'60964','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25532,'47035','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20699,'39083','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21998,'41311','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40408,'68874','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6312,'15217','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9830,'21711','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18348,'35593','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26136,'47880','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22711,'43060','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44539,'75969','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3554,'09620','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52752,'95547','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41492,'71315','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20320,'38588','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6034,'14775','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15559,'30666','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25925,'47529','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15215,'30339','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37893,'65055','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28889,'51340','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12586,'27013','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(22597,'42733','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45489,'77328','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47988,'81247','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52659,'95418','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53063,'96006','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34783,'60505','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52090,'94163','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22281,'42101','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21347,'40077','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18506,'35956','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24308,'45382','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39569,'67743','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8713,'19473','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1126,'03304','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(34103,'59336','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2489,'06792','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3671,'09853','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(4863,'12785','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38989,'66962','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(756,'02447','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11824,'25315','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11169,'24202','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34401,'59912','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15268,'30414','Evans','13109','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35325,'61369','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27349,'49323','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6282,'15135','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26390,'48136','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25543,'47043','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45807,'77705','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44606,'76049','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38035,'65301','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36076,'62353','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14299,'29355','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3912,'10540','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47532,'80440','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53842,'97412','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19551,'37391','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48430,'83325','Jerome','16053','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51738,'93438','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53422,'96761','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(15653,'30813','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15436,'30554','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32947,'57466','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3567,'09643','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43178,'73763','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37270,'63873','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9680,'21235','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(48807,'84062','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45317,'77031','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3561,'09627','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8648,'19371','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10637,'23250','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32608,'57066','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38157,'65542','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35767,'61931','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35574,'61723','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28968,'51466','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4904,'12843','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50743,'91012','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31263,'55378','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26818,'48725','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38938,'66870','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1687,'04774','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(50678,'90703','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39932,'68355','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9608,'21131','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38185,'65565','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33827,'58762','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32659,'57219','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2385,'06484','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11489,'24637','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38307,'65666','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47727,'80813','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26645,'48449','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41035,'70540','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46378,'78624','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48072,'81621','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50110,'88431','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51414,'92616','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35153,'61081','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8157,'18424','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37841,'65013','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1869,'05253','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24909,'46170','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10716,'23420','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18557,'36006','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15989,'31518','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39934,'68357','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52848,'95663','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54924,'99548','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(12010,'25706','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49003,'84635','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53261,'96375','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(37070,'63547','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14944,'30112','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33034,'57568','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23205,'43758','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2482,'06784','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3186,'08541','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37245,'63845','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20369,'38637','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39661,'67864','Meade','20119','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41415,'71227','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8660,'19395','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50443,'89803','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48363,'83217','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47508,'80403','Gilpin','8047','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44903,'76458','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46013,'78075','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5305,'13456','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38119,'65452','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36715,'62987','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30778,'54769','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30019,'53584','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16841,'32753','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26902,'48808','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38949,'66933','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50993,'91791','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50818,'91316','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52030,'94062','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35942,'62237','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9318,'20637','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39235,'67355','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49298,'85326','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54763,'99128','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54900,'99506','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(14646,'29716','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13681,'28469','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32802,'57337','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9437,'20791','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30790,'54806','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(55011,'99653','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42678,'72958','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39979,'68406','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(185,'00968','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(36054,'62334','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30820,'54834','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3370,'09046','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38366,'65723','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9611,'21136','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26467,'48214','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25007,'46290','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18205,'35285','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44709,'76179','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12760,'27312','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37028,'63465','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49466,'85717','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41573,'71418','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3337,'08885','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10293,'22736','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8596,'19194','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30154,'53946','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1808,'05045','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18796,'36346','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5596,'14027','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16073,'31624','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31928,'56226','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41971,'72061','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46648,'79008','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49,'00687','Morovis','72101','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(33068,'57633','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7190,'16644','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31074,'55072','Kanabec','27065','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30255,'54123','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29018,'51546','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12383,'26426','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18954,'36604','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6661,'15724','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2089,'05858','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40560,'69032','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42881,'73150','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45482,'77325','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50204,'89010','Esmeralda','32009','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54072,'97901','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34292,'59721','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30727,'54741','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27924,'50031','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26311,'48047','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49522,'85933','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49391,'85602','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44599,'76043','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42457,'72645','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23963,'44874','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16473,'32214','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25258,'46761','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13856,'28644','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2064,'05827','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42345,'72521','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47994,'81253','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53345,'96661','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(26678,'48470','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23004,'43445','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39105,'67109','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40177,'68701','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43006,'73539','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54165,'98089','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50410,'89511','Storey','32029','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(11920,'25524','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33402,'58311','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26912,'48815','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17655,'34030','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(25759,'47348','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18552,'35990','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21672,'40578','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20794,'39181','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6998,'16254','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42152,'72315','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44586,'76033','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37811,'64854','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7515,'17108','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33422,'58329','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28925,'51433','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15646,'30808','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22403,'42322','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20097,'38328','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17410,'33650','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40227,'68741','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48034,'81422','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8619,'19339','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24281,'45358','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20637,'38963','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18870,'36477','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48733,'83865','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54689,'99003','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38523,'66042','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(334,'01263','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14062,'29016','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26204,'47950','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24109,'45169','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20898,'39354','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45744,'77578','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14721,'29848','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11879,'25430','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4129,'11352','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(177,'00958','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(6161,'14895','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(626,'02112','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19027,'36759','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47228,'79907','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47596,'80517','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32042,'56314','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30782,'54771','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6403,'15341','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11641,'25025','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17643,'33994','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49414,'85625','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(3341,'08889','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5499,'13788','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30083,'53807','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23559,'44254','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43285,'74028','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43991,'75166','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52320,'94807','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20014,'38175','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3674,'09859','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28158,'50225','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52645,'95397','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2604,'07050','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12400,'26447','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(398,'01477','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30922,'54937','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2486,'06787','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5516,'13811','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50029,'88203','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50342,'89318','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5865,'14519','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31371,'55486','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24850,'46127','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49209,'85190','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34036,'59241','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37078,'63555','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3892,'10516','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32737,'57270','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2433,'06606','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17199,'33332','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27326,'49309','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54005,'97759','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30863,'54871','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25103,'46508','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23136,'43619','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20758,'39151','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45189,'76848','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37936,'65084','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11567,'24869','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18709,'36207','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43753,'74867','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49203,'85143','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50755,'91042','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44217,'75482','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50121,'88515','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(55132,'99786','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(10538,'23124','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24042,'45102','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21987,'41265','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17353,'33572','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26143,'47902','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2062,'05825','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34232,'59530','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3663,'09840','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3175,'08530','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28591,'50629','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14057,'29010','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36326,'62625','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42390,'72564','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49724,'87103','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(22892,'43302','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8240,'18612','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6929,'16141','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37147,'63654','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34466,'60035','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27163,'49074','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27124,'49045','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21108,'39667','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22224,'42038','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42048,'72122','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42817,'73090','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53901,'97479','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54248,'98227','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42260,'72424','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42123,'72205','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41623,'71461','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19179,'37040','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19462,'37332','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48698,'83830','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46957,'79364','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50475,'90017','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16707,'32564','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15978,'31503','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31357,'55458','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2180,'06087','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8838,'19884','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(4422,'12056','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1795,'05031','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(43768,'74881','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51436,'92654','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48763,'84020','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44323,'75653','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43642,'74724','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4788,'12589','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33654,'58561','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15702,'31002','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4061,'11027','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39370,'67521','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3330,'08875','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9232,'20531','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(40666,'69168','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49326,'85354','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51721,'93420','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46102,'78219','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21748,'40844','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23681,'44453','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9958,'21915','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25363,'46899','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9629,'21162','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8823,'19734','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(38793,'66622','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8891,'19968','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(34109,'59339','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23723,'44601','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12229,'26180','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46699,'79042','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50884,'91407','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53450,'96791','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(36110,'62401','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54702,'99012','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22436,'42352','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13313,'28086','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33177,'57775','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31593,'55946','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(208,'01004','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33690,'58621','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12009,'25705','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10062,'22219','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44782,'76267','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50042,'88244','Lea','35025','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52902,'95724','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52166,'94404','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48391,'83253','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2852,'07799','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12,'00613','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(4554,'12208','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15735,'31017','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14073,'29031','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5504,'13797','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28625,'50653','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27095,'49021','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22247,'42055','Lyon','21143','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21149,'39750','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20624,'38953','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41436,'71241','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43671,'74754','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47091,'79561','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53377,'96710','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53722,'97267','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52721,'95490','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46481,'78716','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18242,'35458','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10504,'23091','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8659,'19390','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24756,'46041','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34463,'60033','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34041,'59244','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30520,'54511','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27921,'50028','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26578,'48386','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44538,'75969','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50704,'90748','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5514,'13809','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16411,'32134','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24536,'45745','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22958,'43351','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3720,'10036','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28947,'51452','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27300,'49281','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23019,'43458','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18676,'36111','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53039,'95973','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50426,'89701','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48265,'82720','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46655,'79013','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18750,'36278','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40787,'70065','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41881,'71971','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43009,'73541','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17350,'33569','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3501,'09511','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(14532,'29622','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38920,'66858','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40162,'68661','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53282,'96510','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(33451,'58353','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49488,'85740','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26170,'47925','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20302,'38575','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35519,'61568','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1563,'04539','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10832,'23801','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19867,'37938','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21431,'40229','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38785,'66616','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52624,'95373','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31778,'56097','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9187,'20431','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24214,'45312','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50574,'90241','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35376,'61434','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22290,'42123','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23617,'44321','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23756,'44625','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2292,'06333','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10850,'23830','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7080,'16374','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1233,'03818','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12957,'27587','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16873,'32792','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36852,'63129','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40111,'68628','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51931,'93723','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33644,'58549','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1239,'03824','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(25974,'47581','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17793,'34293','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23459,'44111','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3642,'09818','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(46053,'78133','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22965,'43358','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43705,'74834','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10410,'22968','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1259,'03848','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22282,'42101','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41396,'71209','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43964,'75147','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47245,'79926','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14307,'29369','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15755,'31029','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17427,'33685','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1536,'04469','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51107,'92096','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20814,'39206','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30177,'53963','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7640,'17353','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13200,'27932','Chowan','37041','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19182,'37043','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29308,'52257','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24750,'46039','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37379,'64063','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26048,'47724','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23620,'44326','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19973,'38112','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43050,'73572','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43082,'73654','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8473,'19055','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9610,'21133','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6802,'15944','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12192,'26141','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23998,'45005','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8658,'19383','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3013,'08068','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(804,'02554','Nantucket','25019','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11372,'24504','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8568,'19152','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23699,'44490','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33978,'59076','Treasure','30103','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7729,'17580','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33956,'59058','Petroleum','30069','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17671,'34060','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(26799,'48662','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24702,'45887','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37384,'64068','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38946,'66930','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42993,'73530','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8072,'18240','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42841,'73113','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39128,'67123','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36142,'62427','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21962,'41216','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21774,'40923','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26371,'48115','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14849,'30045','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11382,'24522','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32233,'56482','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33108,'57701','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11841,'25335','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32277,'56543','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9659,'21221','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20384,'38650','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28645,'50666','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12446,'26566','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43067,'73641','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51093,'92074','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12074,'25854','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33740,'58649','Hettinger','38041','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16223,'31791','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13140,'27871','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44993,'76538','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49029,'84667','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27221,'49125','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30015,'53582','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37458,'64147','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40880,'70301','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52454,'95117','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33296,'58081','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4284,'11753','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3509,'09543','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32205,'56464','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32034,'56309','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49787,'87327','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50875,'91394','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11397,'24534','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10254,'22660','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29267,'52224','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26266,'47995','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5064,'13060','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49791,'87364','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(40491,'68957','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17249,'33435','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10237,'22643','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33013,'57552','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28003,'50099','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27308,'49285','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36699,'62972','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37365,'64051','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42606,'72847','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43849,'75033','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26229,'47968','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4152,'11377','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17109,'33158','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23612,'44315','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35904,'62092','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3457,'09360','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(34072,'59276','Daniels','30019','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33622,'58523','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24102,'45160','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37962,'65218','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45486,'77327','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54240,'98220','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27395,'49346','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20102,'38332','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19134,'37012','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27487,'49502','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36549,'62875','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41452,'71259','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45389,'77099','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51762,'93463','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15880,'31119','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18282,'35540','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37701,'64688','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46300,'78560','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30276,'54140','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48988,'84606','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(722,'02339','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12440,'26559','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28748,'51011','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26039,'47712','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6251,'15085','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3595,'09726','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(13443,'28237','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24425,'45648','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20793,'39180','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53775,'97344','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11458,'24597','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8788,'19602','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22039,'41503','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48975,'84534','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47088,'79560','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45782,'77632','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18311,'35563','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15435,'30554','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20240,'38487','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19067,'36804','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30482,'54474','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25272,'46770','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13105,'27842','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18593,'36033','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45600,'77441','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19223,'37064','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38868,'66775','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54424,'98424','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11222,'24272','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6106,'14852','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27191,'49092','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26375,'48118','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40871,'70184','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31996,'56280','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6457,'15432','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3376,'09059','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(10031,'22180','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1878,'05303','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(26627,'48436','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43340,'74070','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49531,'85942','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52829,'95642','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18434,'35757','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22682,'43030','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44674,'76114','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32453,'56736','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7249,'16701','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34553,'60122','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15724,'31014','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29948,'53532','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28685,'50837','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20725,'39109','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44615,'76053','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30158,'53949','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28402,'50479','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23303,'43927','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5294,'13438','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48784,'84040','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52232,'94561','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4091,'11211','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35171,'61106','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6651,'15714','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24457,'45674','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23624,'44334','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23428,'44082','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1876,'05301','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13680,'28468','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3380,'09068','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49630,'86445','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53930,'97526','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30057,'53744','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9528,'21009','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24378,'45502','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15947,'31323','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18435,'35758','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18611,'36043','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24213,'45312','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38193,'65580','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34569,'60135','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31821,'56137','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31642,'55976','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14879,'30069','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41778,'71831','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52744,'95537','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55005,'99647','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(7405,'17018','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8999,'20116','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32606,'57064','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39277,'67439','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41532,'71356','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37169,'63730','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6851,'16037','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3840,'10306','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3994,'10927','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2306,'06359','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35761,'61928','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8671,'19409','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1578,'04564','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22527,'42533','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21109,'39667','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18201,'35266','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1405,'04217','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23266,'43832','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43091,'73659','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45071,'76639','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31486,'55751','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30593,'54601','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17647,'34008','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(17933,'34785','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51225,'92258','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7295,'16833','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9577,'21077','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22401,'42320','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16955,'32923','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36853,'63130','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15994,'31519','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17354,'33573','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21001,'39501','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20422,'38683','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45420,'77233','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45684,'77510','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11783,'25248','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14778,'29944','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24091,'45150','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50552,'90096','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13737,'28544','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14937,'30108','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17087,'33135','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54459,'98512','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43003,'73537','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37757,'64765','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21811,'41003','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28518,'50581','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38634,'66251','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39949,'68367','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35168,'61103','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43348,'74074','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41179,'70748','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22838,'43160','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47220,'79854','Presidio','48377','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38314,'65674','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19929,'38052','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16455,'32190','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1028,'03073','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(467,'01654','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6468,'15444','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4396,'12025','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15237,'30360','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43805,'74957','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46779,'79094','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19353,'37178','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20078,'38310','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34012,'59211','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(48650,'83713','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(37668,'64658','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10720,'23424','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8505,'19089','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20818,'39209','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22506,'42460','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19,'00627','Camuy','72027','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(47385,'80131','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35586,'61731','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(55096,'99749','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51716,'93407','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51209,'92240','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42078,'72142','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36858,'63133','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24135,'45218','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24246,'45334','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21447,'40256','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26263,'47993','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28345,'50440','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16534,'32316','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19260,'37090','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25396,'46926','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53275,'96427','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(44429,'75790','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36519,'62854','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37163,'63675','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11230,'24283','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46947,'79358','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(502,'01805','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22391,'42286','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23548,'44236','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24468,'45682','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4803,'12721','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5281,'13421','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36033,'62311','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19541,'37383','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3260,'08754','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1824,'05061','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(53778,'97346','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44249,'75507','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40272,'68770','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39559,'67738','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17311,'33523','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19212,'37060','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26479,'48226','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48771,'84027','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37731,'64742','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37005,'63450','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16691,'32540','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7056,'16353','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32717,'57259','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2850,'07764','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12478,'26621','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36945,'63368','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43438,'74333','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32797,'57334','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45944,'78012','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43962,'75146','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(170,'00951','Toa Baja','72137','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42652,'72934','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6938,'16151','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18099,'35128','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(512,'01830','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29155,'52070','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43864,'75047','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20930,'39407','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21862,'41051','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48066,'81602','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44336,'75662','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43405,'74145','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37337,'64014','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14593,'29665','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20924,'39402','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6436,'15410','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3267,'08801','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13900,'28680','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5927,'14591','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38384,'65735','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51266,'92321','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24433,'45656','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49838,'87531','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41099,'70630','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50790,'91204','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40232,'68745','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5734,'14225','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2617,'07063','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19714,'37773','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4011,'10959','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7532,'17140','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52455,'95118','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18284,'35541','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54891,'99401','Asotin','53003','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41600,'71439','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38771,'66604','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13625,'28429','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10262,'22709','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11286,'24375','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27294,'49272','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38832,'66740','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39846,'68182','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30978,'54980','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44424,'75785','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36564,'62883','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36551,'62876','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18711,'36251','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34970,'60914','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5742,'14260','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26984,'48861','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36523,'62858','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40372,'68847','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7157,'16603','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45764,'77612','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11742,'25174','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48495,'83441','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47629,'80550','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38130,'65461','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18247,'35463','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23052,'43516','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29689,'53036','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31836,'56147','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(590,'02027','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9538,'21022','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50844,'91352','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48891,'84158','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40462,'68941','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31647,'55982','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9362,'20707','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12824,'27406','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54685,'98951','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38118,'65452','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37904,'65063','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36306,'62601','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26212,'47957','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13658,'28453','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(570,'01950','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10995,'24007','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1386,'04101','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31918,'56221','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45016,'76557','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47425,'80215','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48544,'83541','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52605,'95352','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7191,'16645','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38755,'66546','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16388,'32112','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13932,'28711','McDowell','37111','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5123,'13126','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40910,'70374','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53921,'97502','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53279,'96502','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(40203,'68726','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37889,'65052','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22117,'41660','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25118,'46528','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26105,'47852','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32909,'57437','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54775,'99139','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12157,'26038','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12596,'27021','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(49221,'85207','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(15527,'30635','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15295,'30438','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25265,'46766','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30806,'54820','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31873,'56173','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32554,'57035','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1277,'03867','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(43907,'75088','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52107,'94235','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51452,'92678','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5375,'13622','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42560,'72765','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29326,'52315','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34144,'59417','Glacier','30035','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34499,'60074','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15399,'30531','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31126,'55122','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29521,'52632','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49851,'87548','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(12845,'27498','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27834,'49905','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43867,'75049','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15712,'31008','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41084,'70596','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7051,'16350','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10564,'23154','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22724,'43066','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18967,'36618','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19023,'36756','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40573,'69040','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45510,'77350','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49427,'85637','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50464,'90006','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52376,'94979','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35866,'62070','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12208,'26152','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11801,'25270','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44207,'75474','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9808,'21666','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37181,'63744','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12900,'27537','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30395,'54414','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1919,'05448','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17892,'34705','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43911,'75090','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45560,'77391','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13402,'28170','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53820,'97385','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7973,'18041','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2812,'07718','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48780,'84036','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51638,'93238','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9095,'20220','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5544,'13843','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3667,'09845','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16869,'32784','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26504,'48268','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24645,'45851','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23815,'44675','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21418,'40215','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38212,'65605','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24805,'46072','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37593,'64499','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43025,'73553','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4990,'12965','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16021,'31548','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37257,'63857','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13555,'28363','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13131,'27864','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21499,'40334','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17585,'33913','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4223,'11572','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38901,'66843','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39935,'68358','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41280,'71023','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54805,'99169','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46009,'78072','McMullen','48311','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10743,'23455','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7862,'17859','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23270,'43840','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7852,'17847','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38085,'65350','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39199,'67276','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39504,'67650','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49093,'84776','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54214,'98166','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24143,'45226','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17786,'34286','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37827,'64865','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6669,'15732','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31497,'55765','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14150,'29112','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23987,'44903','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20205,'38463','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49451,'85702','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51626,'93222','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32789,'57330','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18432,'35756','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16397,'32121','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15406,'30534','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19072,'36831','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22553,'42634','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2590,'07033','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54610,'98816','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23955,'44864','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26836,'48735','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54708,'99017','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52465,'95128','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51869,'93633','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48635,'83686','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43356,'74079','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42530,'72738','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14821,'30024','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1106,'03275','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(17971,'34988','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6744,'15840','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27975,'50062','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13018,'27668','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34447,'60015','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11154,'24168','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2317,'06378','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40185,'68714','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8778,'19551','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7986,'18052','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17693,'34114','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10916,'23891','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10478,'23064','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47135,'79718','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36544,'62870','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16940,'32901','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29923,'53516','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13324,'28092','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9084,'20208','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5441,'13691','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17567,'33896','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36998,'63445','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39131,'67127','Comanche','20033','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50145,'88541','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(52424,'95054','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6163,'14897','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34550,'60120','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45131,'76691','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3084,'08240','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23106,'43557','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23440,'44092','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27313,'49289','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28133,'50208','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28310,'50395','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(659,'02145','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31851,'56159','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33096,'57651','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8992,'20110','Manassas Park City','51685','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13826,'28624','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6366,'15282','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39973,'68401','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34832,'60543','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11664,'25057','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47743,'80825','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46816,'79124','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45060,'76631','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39183,'67218','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27917,'50026','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30094,'53818','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35231,'61270','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16910,'32832','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16630,'32442','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23178,'43731','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45867,'77873','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37606,'64601','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21486,'40319','Rowan','21205','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25057,'46371','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29201,'52158','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33749,'58653','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16138,'31712','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36250,'62532','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38280,'65648','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33846,'58779','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36530,'62862','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24088,'45146','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24862,'46140','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9193,'20439','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2904,'07878','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12293,'26282','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11554,'24850','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32953,'57469','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23434,'44087','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(926,'02826','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(16969,'32948','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36334,'62630','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42936,'73442','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6732,'15827','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1834,'05074','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23683,'44454','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27679,'49740','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21422,'40219','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17431,'33689','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33964,'59064','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14224,'29202','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7095,'16411','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53218,'96257','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49863,'87565','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49107,'85006','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35177,'61109','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46479,'78714','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29151,'52066','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11174,'24210','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26628,'48437','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22130,'41721','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30619,'54626','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53295,'96537','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51568,'93034','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50788,'91202','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38066,'65337','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20316,'38583','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17860,'34636','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6404,'15342','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11547,'24844','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28703,'50851','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8729,'19501','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9390,'20738','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39061,'67051','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44573,'76017','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29938,'53523','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4049,'11001','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5942,'14614','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27350,'49323','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20060,'38257','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3673,'09858','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49738,'87117','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(6601,'15658','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48603,'83641','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45926,'77995','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45737,'77571','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16208,'31782','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18955,'36605','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3976,'10910','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12976,'27597','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5626,'14054','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20526,'38850','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15373,'30517','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18281,'35540','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39191,'67228','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48687,'83815','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(34953,'60697','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30142,'53939','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26614,'48428','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9823,'21701','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30873,'54888','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6382,'15320','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35197,'61235','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34821,'60537','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28570,'50614','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24014,'45040','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22198,'41862','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21269,'40012','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25427,'46950','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12566,'26852','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4946,'12913','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4711,'12506','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16396,'32120','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37248,'63848','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31388,'55567','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53554,'97020','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46802,'79110','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42053,'72126','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7672,'17504','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8812,'19716','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(24295,'45369','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23597,'44301','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21145,'39747','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18633,'36064','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15226,'30349','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38537,'66053','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39263,'67427','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50831,'91333','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27435,'49421','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8523,'19108','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16518,'32301','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4301,'11772','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49255,'85262','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52316,'94803','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54102,'98012','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34895,'60624','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45874,'77881','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41630,'71465','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39711,'68008','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14919,'30101','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(144,'00915','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(24857,'46133','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17013,'33023','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5534,'13835','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15131,'30273','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52575,'95321','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45568,'77407','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44808,'76351','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43149,'73742','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6499,'15479','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14805,'30014','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8948,'20053','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(4066,'11050','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24082,'45140','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26116,'47862','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30433,'54443','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31749,'56074','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32326,'56583','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4456,'12089','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35818,'62021','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2877,'07840','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43305,'74042','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11895,'25502','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13885,'28668','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35099,'61043','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21876,'41071','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2153,'06061','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8255,'18621','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51541,'92887','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53027,'95963','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41569,'71417','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25761,'47351','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28340,'50436','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22344,'42210','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20873,'39332','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12538,'26761','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32187,'56447','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3696,'10011','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14283,'29332','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46766,'79085','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44501,'75933','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26443,'48187','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29083,'51639','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34064,'59263','Daniels','30019','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3901,'10524','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16524,'32307','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48236,'82630','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(21348,'40078','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17986,'35007','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6586,'15636','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(402,'01505','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54090,'97920','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54031,'97835','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51697,'93309','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45886,'77954','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45801,'77665','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25850,'47435','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26273,'48002','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11396,'24533','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1443,'04270','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52542,'95247','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52473,'95136','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16309,'32008','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6738,'15831','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14560,'29643','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50274,'89119','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47284,'79995','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43796,'74946','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41048,'70551','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32564,'57041','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12806,'27359','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13996,'28765','Mitchell','37121','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35896,'62087','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49499,'85751','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49328,'85356','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44866,'76435','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24249,'45335','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30917,'54932','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31644,'55979','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35016,'60949','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5131,'13136','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38158,'65542','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3872,'10474','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43877,'75056','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23855,'44711','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19554,'37397','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14142,'29104','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13377,'28138','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18689,'36125','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52072,'94132','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50509,'90051','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47916,'81101','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8300,'18709','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19454,'37327','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22878,'43235','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3922,'10550','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38879,'66780','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39913,'68343','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(415,'01522','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51029,'91946','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41141,'70669','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34034,'59231','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13183,'27917','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34590,'60150','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34283,'59711','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1495,'04414','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51368,'92544','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49284,'85306','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47036,'79521','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23810,'44669','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26577,'48383','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28387,'50468','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18894,'36522','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14477,'29571','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32772,'57321','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4673,'12464','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49786,'87326','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42882,'73150','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25194,'46635','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15954,'31331','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31176,'55321','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30223,'54027','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10355,'22904','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18836,'36441','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27583,'49659','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5221,'13324','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49008,'84640','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42826,'73098','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15183,'30314','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15822,'31066','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45441,'77258','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29015,'51544','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39402,'67554','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8302,'18711','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31879,'56178','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38911,'66852','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4582,'12243','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51870,'93634','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47485,'80273','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42204,'72366','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40467,'68943','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24161,'45243','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37818,'64861','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25401,'46929','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51810,'93554','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51387,'92572','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45396,'77206','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9960,'21917','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25456,'46971','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51609,'93203','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45410,'77222','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31205,'55337','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20485,'38802','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39921,'68347','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19641,'37705','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47940,'81140','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47513,'80422','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6057,'14809','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9913,'21821','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9486,'20876','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37659,'64652','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40783,'70060','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43016,'73547','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39471,'67634','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46597,'78938','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44830,'76374','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44124,'75410','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43909,'75089','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22512,'42464','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22501,'42456','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19720,'37779','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12483,'26627','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36739,'63017','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14886,'30075','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39763,'68055','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48709,'83841','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44768,'76258','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24333,'45415','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29595,'52753','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11627,'24993','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32052,'56321','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34825,'60540','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39594,'67761','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53166,'96119','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19776,'37849','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1864,'05161','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21970,'41231','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25382,'46917','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5815,'14471','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2943,'07977','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17536,'33852','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35738,'61884','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17752,'34238','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52901,'95722','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47726,'80812','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46459,'78675','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22575,'42717','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31929,'56227','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23926,'44844','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6444,'15419','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2919,'07927','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2708,'07428','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7634,'17344','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7271,'16745','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48678,'83806','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50047,'88253','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50862,'91376','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52046,'94104','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24942,'46211','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24876,'46149','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46615,'78947','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(105,'00778','Gurabo','72063','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(30325,'54207','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3688,'10003','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3792,'10170','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5849,'14508','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24087,'45144','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22797,'43136','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22530,'42541','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5045,'13041','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39858,'68307','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47155,'79743','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54736,'99103','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11287,'24377','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41733,'71731','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9044,'20163','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34624,'60181','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26458,'48205','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23973,'44882','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51549,'93007','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54386,'98381','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1335,'04033','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(25940,'47545','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39261,'67427','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40253,'68759','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9024,'20138','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36454,'62810','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33581,'58477','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5829,'14481','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25661,'47232','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24503,'45714','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16600,'32420','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41594,'71433','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44495,'75929','San Augustine','48405','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44677,'76117','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35081,'61024','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10532,'23119','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8051,'18214','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8022,'18084','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21243,'39870','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25342,'46854','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23790,'44651','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54999,'99639','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54300,'98282','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(805,'02554','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3504,'09520','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32101,'56350','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22772,'43110','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(272,'01092','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6503,'15484','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16133,'31709','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37720,'64734','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46181,'78336','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21471,'40295','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33188,'57788','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(179,'00960','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(27375,'49336','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24780,'46058','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18102,'35130','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19687,'37745','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42546,'72753','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53512,'96916','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(15402,'30533','Lumpkin','13187','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14950,'30117','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1137,'03446','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16641,'32455','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39957,'68371','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47658,'80643','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48139,'82072','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(36808,'63080','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27162,'49073','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23534,'44224','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12844,'27497','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18075,'35098','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3778,'10156','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42126,'72207','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44158,'75436','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41603,'71441','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24560,'45778','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5369,'13618','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29703,'53046','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15656,'30814','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10487,'23070','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3790,'10168','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30588,'54565','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29335,'52322','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27635,'49707','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41711,'71675','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47235,'79915','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54128,'98039','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50981,'91772','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36744,'63021','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7838,'17833','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5835,'14486','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45943,'78011','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4108,'11229','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35624,'61755','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16775,'32666','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29351,'52329','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28736,'51003','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27998,'50075','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18586,'36029','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21376,'40145','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46492,'78727','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49734,'87113','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(119,'00803','Saint Thomas','78030','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(52690,'95452','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5291,'13435','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15931,'31308','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50882,'91405','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48790,'84046','Daggett','49009','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(19385,'37208','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17494,'33801','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27907,'50020','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7769,'17740','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29516,'52627','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34813,'60527','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38898,'66840','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12735,'27289','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12587,'27014','Davie','37059','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(11822,'25313','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8237,'18610','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33054,'57621','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29336,'52322','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51247,'92284','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53134,'96086','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54717,'99026','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38265,'65637','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49490,'85742','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30694,'54724','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27462,'49446','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30769,'54766','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4965,'12934','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11393,'24530','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33509,'58421','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19130,'37010','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36108,'62401','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19237,'37075','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39553,'67734','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48367,'83223','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44980,'76527','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21375,'40144','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26651,'48453','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36825,'63107','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38288,'65652','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9507,'20903','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34423,'59932','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31712,'56048','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29722,'53064','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25537,'47038','Switzerland','18155','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23439,'44090','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53390,'96726','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(207,'01003','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25417,'46940','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54941,'99567','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(44389,'75752','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42076,'72141','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31440,'55705','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13925,'28704','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11729,'25152','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38563,'66079','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35509,'61560','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9308,'20625','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33571,'58467','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32871,'57382','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21508,'40342','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16044,'31560','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(414,'01521','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1661,'04738','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42634,'72916','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46566,'78841','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48680,'83809','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52369,'94972','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(160,'00931','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42555,'72761','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42084,'72150','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41975,'72065','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22600,'42741','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28842,'51109','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17104,'33153','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4672,'12463','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1663,'04740','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3841,'10307','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1280,'03870','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(20321,'38588','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18026,'35046','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35619,'61752','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34746,'60469','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12496,'26662','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51196,'92223','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53264,'96378','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53536,'97005','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37901,'65062','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37033,'63469','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36682,'62958','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15292,'30436','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12917,'27551','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22069,'41555','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40102,'68623','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41370,'71133','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44645,'76085','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54565,'98637','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44315,'75647','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43535,'74461','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6001,'14735','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4646,'12435','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38751,'66542','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12364,'26408','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32541,'57028','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4174,'11425','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19857,'37928','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9109,'20238','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(6910,'16123','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43853,'75035','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8630,'19348','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45367,'77079','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45543,'77377','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52813,'95628','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54076,'97905','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35884,'62081','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1,'00501','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37326,'63965','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5796,'14450','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34039,'59242','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(21462,'40285','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3578,'09707','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(5066,'13062','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40475,'68947','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46726,'79061','Hemphill','48211','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48609,'83647','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53802,'97368','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(1100,'03266','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9285,'20603','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37937,'65085','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25244,'46745','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6734,'15828','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14100,'29053','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32974,'57501','Hughes','46065','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28084,'50150','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10801,'23612','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18673,'36108','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19998,'38141','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49027,'84664','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49853,'87551','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49467,'85718','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6396,'15333','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9887,'21783','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3435,'09309','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(58,'00704','Guayama','72057','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(34188,'59457','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31129,'55125','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27677,'49738','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25449,'46962','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14187,'29142','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9716,'21405','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1039,'03103','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8697,'19453','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51966,'93844','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30260,'54126','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18680,'36115','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15984,'31512','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33407,'58317','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35083,'61027','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37776,'64784','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53524,'96942','Federated States of Micro','64003','FM','Federated States of Micronesia',0,'2013-07-03 15:17:54',NULL,NULL),(51728,'93427','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45588,'77430','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54577,'98650','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24627,'45843','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22862,'43218','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29419,'52535','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31853,'56160','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32385,'56658','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20393,'38655','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34296,'59724','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44195,'75461','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42624,'72865','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33615,'58505','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5052,'13045','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10573,'23169','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36928,'63352','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41197,'70769','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22428,'42347','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5997,'14730','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53980,'97720','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31103,'55102','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16597,'32413','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23737,'44613','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7317,'16855','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19170,'37033','Perry','47135','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51547,'93005','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34348,'59825','Granite','30039','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(50159,'88557','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(20340,'38617','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13761,'28572','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2940,'07970','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49924,'87832','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47230,'79910','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22948,'43344','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1751,'04944','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(13303,'28078','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25319,'46802','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31756,'56082','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48260,'82714','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(26801,'48663','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31688,'56028','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33627,'58529','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14019,'28787','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38078,'65347','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14828,'30028','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6926,'16137','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27594,'49668','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16506,'32246','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37906,'65064','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52425,'95055','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29966,'53544','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33464,'58367','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13548,'28356','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36124,'62420','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31695,'56034','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18602,'36037','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48417,'83303','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54143,'98057','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39065,'67054','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53845,'97415','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48703,'83834','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41455,'71263','West Carroll','22123','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40522,'68979','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22837,'43158','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2094,'05863','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34282,'59711','Granite','30039','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36274,'62548','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45792,'77656','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17304,'33508','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14826,'30026','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12986,'27607','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24043,'45103','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4871,'12792','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32214,'56469','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(38297,'65657','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46387,'78631','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7737,'17603','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9575,'21076','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12078,'25862','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47287,'79998','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20855,'39323','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14530,'29621','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2224,'06144','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2916,'07922','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8610,'19317','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25185,'46614','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36710,'62984','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12562,'26847','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1470,'04345','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1133,'03442','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(33697,'58623','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40737,'69356','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26133,'47876','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21850,'41042','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3878,'10504','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1310,'04002','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2325,'06387','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9167,'20410','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17916,'34749','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29289,'52243','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21863,'41052','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22812,'43145','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47109,'79604','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44387,'75751','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51569,'93035','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46792,'79103','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45354,'77066','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43840,'75024','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13282,'28040','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52890,'95699','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7719,'17568','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4294,'11765','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21373,'40142','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29862,'53213','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10405,'22964','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37643,'64643','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38915,'66854','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13040,'27712','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15100,'30241','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23706,'44502','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40985,'70501','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41601,'71440','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49667,'87015','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51394,'92587','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17173,'33306','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53426,'96765','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52794,'95613','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48672,'83801','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47744,'80826','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43275,'74021','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19500,'37357','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27358,'49327','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9951,'21902','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31034,'55036','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5761,'14413','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15104,'30250','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16454,'32189','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15801,'31052','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14378,'29450','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8935,'20040','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(5173,'13204','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18126,'35161','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2885,'07849','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34643,'60199','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52110,'94239','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7160,'16613','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29977,'53555','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34676,'60416','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4431,'12063','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3387,'09094','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26776,'48642','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26533,'48323','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21072,'39643','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36588,'62897','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8990,'20109','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53329,'96613','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(44822,'76367','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42229,'72392','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3558,'09624','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(13380,'28139','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4461,'12094','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(977,'02901','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(1356,'04063','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(36593,'62901','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13515,'28329','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45745,'77578','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(232,'01035','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31549,'55906','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42293,'72453','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10497,'23084','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21690,'40618','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16450,'32182','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36457,'62812','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4354,'11954','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40039,'68454','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38834,'66742','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37468,'64157','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53001,'95941','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49430,'85640','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(24978,'46249','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21405,'40202','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8264,'18628','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14955,'30121','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33671,'58571','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15346,'30475','Toombs','13279','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16509,'32254','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31174,'55320','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28615,'50647','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7995,'18059','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21888,'41086','Gallatin','21077','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30,'00656','Guayanilla','72059','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(33847,'58779','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53960,'97630','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28276,'50322','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20507,'38835','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9452,'20824','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38457,'65788','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15494,'30619','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14336,'29410','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8612,'19319','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29211,'52163','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24981,'46251','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52248,'94576','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55004,'99645','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37744,'64752','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47623,'80544','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43471,'74363','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41486,'71301','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19651,'37711','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7340,'16877','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33072,'57636','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1866,'05250','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36089,'62365','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16917,'32853','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6685,'15750','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35550,'61638','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27330,'49310','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7046,'16344','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2677,'07204','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42046,'72121','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51933,'93725','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5219,'13323','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47382,'80129','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5497,'13787','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50979,'91770','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2230,'06152','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8423,'19003','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15545,'30655','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16161,'31738','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16934,'32886','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(55000,'99640','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(27999,'50075','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20114,'38341','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30747,'54755','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18328,'35574','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34591,'60151','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12960,'27588','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31484,'55749','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28694,'50845','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20071,'38301','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22275,'42085','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43543,'74468','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47844,'81021','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5431,'13679','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46826,'79201','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45579,'77420','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44068,'75267','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41732,'71730','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8534,'19119','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30939,'54949','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11106,'24120','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13582,'28382','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40053,'68462','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40105,'68626','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40117,'68632','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17961,'34974','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14625,'29692','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38257,'65632','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36862,'63136','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8123,'18349','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36082,'62358','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32363,'56633','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10444,'23022','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9519,'20913','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21700,'40729','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22765,'43106','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51047,'92009','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6824,'15962','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50472,'90014','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49256,'85263','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48362,'83215','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43894,'75077','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4586,'12247','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23391,'44041','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18503,'35954','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41377,'71149','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50718,'90814','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24426,'45650','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28452,'50536','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6859,'16041','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37722,'64735','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51623,'93219','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28894,'51345','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29038,'51559','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14311,'29372','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15023,'30173','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2468,'06756','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36931,'63357','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31319,'55420','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31017,'55020','Scott','27139','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42352,'72527','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48996,'84628','Juab','49023','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(26551,'48346','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28150,'50219','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7070,'16366','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53362,'96679','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(4710,'12504','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35096,'61041','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38765,'66550','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36219,'62476','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30587,'54564','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39083,'67066','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20141,'38359','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47533,'80442','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50481,'90023','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2260,'06246','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(51876,'93640','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43633,'74652','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1178,'03597','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4611,'12309','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11820,'25312','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1652,'04693','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14617,'29685','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38808,'66713','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19194,'37049','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3430,'09302','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(44029,'75223','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49187,'85122','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46204,'78361','Zapata','48505','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46047,'78130','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41785,'71835','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26483,'48230','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31425,'55604','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19420,'37301','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35538,'61613','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1174,'03590','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(7877,'17878','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14671,'29803','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37442,'64128','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2022,'05741','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1066,'03230','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(23485,'44137','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49691,'87038','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52511,'95211','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54606,'98812','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46678,'79031','Bailey','48017','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25674,'47244','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27555,'49637','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18305,'35555','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17799,'34429','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11005,'24014','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(766,'02460','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10357,'22906','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37034,'63469','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19421,'37302','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33218,'58027','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50604,'90294','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54706,'99016','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39180,'67215','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54889,'99363','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50273,'89118','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(13291,'28070','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4009,'10956','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41669,'71639','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39810,'68123','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35347,'61414','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35430,'61475','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21533,'40361','Nicholas','21181','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49028,'84665','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53863,'97439','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34343,'59821','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(55045,'99687','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54819,'99203','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49929,'87933','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(15567,'30669','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31324,'55423','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6383,'15321','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46131,'78247','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48954,'84415','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37492,'64198','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17630,'33972','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43326,'74058','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43379,'74112','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52257,'94586','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52715,'95481','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54537,'98604','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48869,'84125','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(25634,'47175','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24984,'46255','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29445,'52554','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10492,'23079','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37883,'65049','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14838,'30037','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17998,'35019','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21198,'39825','Seminole','13253','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24320,'45389','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45007,'76549','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38700,'66503','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46640,'78963','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45852,'77862','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41039,'70543','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40696,'69301','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18322,'35571','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8583,'19178','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21212,'39840','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23814,'44675','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2179,'06085','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6580,'15629','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38601,'66117','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37192,'63763','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31162,'55311','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7337,'16875','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9562,'21052','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42523,'72734','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43837,'75022','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39687,'67880','Kearny','20093','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52828,'95641','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31951,'56244','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17126,'33176','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34021,'59217','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36839,'63119','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3091,'08247','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39031,'67028','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35773,'61937','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4333,'11901','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10449,'23025','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23006,'43446','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39988,'68416','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48992,'84623','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(664,'02152','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45298,'77012','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25174,'46574','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20647,'38967','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39529,'67665','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18751,'36279','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12812,'27371','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32471,'56754','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37007,'63451','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15847,'31082','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7805,'17778','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38767,'66552','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19596,'37621','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27388,'49343','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54855,'99329','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(345,'01339','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50059,'88301','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47004,'79464','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23677,'44449','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6943,'16156','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27969,'50059','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29683,'53029','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(671,'02171','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36607,'62909','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47474,'80256','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19632,'37688','Johnson','47091','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20115,'38341','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24040,'45101','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42902,'73173','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52894,'95712','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52174,'94506','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49580,'86322','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48900,'84201','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40286,'68780','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25698,'47273','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27364,'49330','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20044,'38233','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30387,'54410','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32257,'56524','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(19235,'37074','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6059,'14812','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2001,'05676','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39543,'67701','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16515,'32260','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7219,'16671','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19443,'37322','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7202,'16656','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4798,'12701','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15730,'31016','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22466,'42406','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4263,'11726','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15262,'30411','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(734,'02351','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21997,'41310','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4062,'11030','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21396,'40175','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46257,'78426','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50108,'88427','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54326,'98320','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25861,'47446','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38923,'66860','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7008,'16262','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9521,'20915','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20482,'38782','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15374,'30518','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4602,'12304','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39705,'68004','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1218,'03801','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27980,'50065','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(9307,'20624','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36147,'62431','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35201,'61239','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32035,'56309','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30636,'54638','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12474,'26615','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38926,'66862','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4807,'12725','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47252,'79932','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46036,'78118','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43647,'74728','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32254,'56522','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14735,'29901','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33404,'58316','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52022,'94039','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54115,'98026','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53245,'96339','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(50144,'88540','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(47716,'80801','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36768,'63040','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38036,'65301','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13766,'28574','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45391,'77201','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19239,'37076','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38656,'66413','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30803,'54818','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18924,'36558','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6237,'15068','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50371,'89428','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49987,'88062','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(49347,'85377','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43319,'74052','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25623,'47165','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26866,'48757','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31040,'55041','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7399,'17013','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53147,'96099','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50095,'88401','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(32351,'56623','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11789,'25259','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5313,'13464','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14831,'30030','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4341,'11939','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38637,'66283','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3462,'09367','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48189,'82334','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48095,'81640','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41921,'72024','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41457,'71264','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8712,'19472','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1666,'04743','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14221,'29180','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37459,'64148','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40347,'68831','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51689,'93301','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9088,'20213','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(9399,'20748','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25031,'46340','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37282,'63901','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36870,'63143','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(204,'00988','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(30557,'54542','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50996,'91793','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51333,'92406','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49019,'84653','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47430,'80219','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42441,'72633','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22615,'42754','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(815,'02565','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3288,'08824','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5610,'14037','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48797,'84053','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46550,'78827','Dimmit','48127','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24012,'45039','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22446,'42366','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17166,'33296','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5614,'14040','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12466,'26590','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21074,'39647','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18749,'36277','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25828,'47403','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2895,'07865','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30979,'54981','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17917,'34753','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8345,'18846','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37072,'63548','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(439,'01564','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17386,'33612','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3516,'09564','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35832,'62035','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7077,'16373','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18657,'36083','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19566,'37408','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38190,'65570','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53603,'97068','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26679,'48470','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14636,'29706','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39047,'67039','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(601,'02048','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53912,'97493','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36975,'63432','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34508,'60082','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52724,'95494','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24429,'45653','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10284,'22731','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10314,'22811','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11842,'25336','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41166,'70734','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52859,'95673','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47546,'80457','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16003,'31532','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35436,'61477','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37956,'65205','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39984,'68413','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16128,'31705','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4996,'12973','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12019,'25715','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8578,'19172','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24057,'45118','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31352,'55449','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40497,'68960','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2771,'07627','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38296,'65656','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48930,'84329','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42518,'72728','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25349,'46861','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38982,'66955','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4434,'12066','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47719,'80805','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32213,'56468','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26826,'48729','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17391,'33617','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26835,'48735','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53668,'97148','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47693,'80736','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45358,'77070','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32117,'56361','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21235,'39862','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13273,'28035','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12653,'27117','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18701,'36201','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22676,'43026','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1217,'03785','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(51013,'91913','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48563,'83605','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42379,'72550','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15349,'30501','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32132,'56373','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36388,'62683','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5070,'13065','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16837,'32750','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52694,'95457','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45734,'77565','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41846,'71933','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13655,'28450','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49797,'87412','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51459,'92691','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51450,'92676','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8777,'19551','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27620,'49686','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14273,'29322','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4218,'11566','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36276,'62549','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16246,'31805','Chattahoochee','13053','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48070,'81615','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42483,'72677','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41633,'71467','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22349,'42215','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32555,'57036','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15865,'31092','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4804,'12722','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4485,'12134','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45771,'77622','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51437,'92655','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30564,'54548','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34187,'59457','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(2322,'06384','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26510,'48279','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33272,'58060','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15314,'30451','Candler','13043','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39182,'67217','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51987,'93932','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47839,'81010','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22491,'42445','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26740,'48619','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16829,'32735','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48624,'83661','Washington','16087','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6056,'14808','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7060,'16354','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54410,'98407','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50842,'91350','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42075,'72140','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9874,'21773','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38302,'65662','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12002,'25699','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2181,'06088','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38367,'65724','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48250,'82644','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(25567,'47118','Crawford','18025','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12223,'26170','Pleasants','54073','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10793,'23603','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13274,'28036','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23102,'43555','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15645,'30808','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7675,'17507','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15425,'30546','Towns','13281','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6992,'16245','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39228,'67352','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41171,'70739','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47148,'79735','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54468,'98528','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5322,'13475','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38483,'66006','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9526,'21001','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18357,'35609','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29245,'52212','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22840,'43162','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48830,'84084','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45124,'76687','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29097,'51650','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4569,'12230','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19849,'37920','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24128,'45211','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40171,'68665','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40594,'69123','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52071,'94131','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44205,'75473','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41485,'71295','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7861,'17858','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19432,'37311','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26944,'48836','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(833,'02641','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2410,'06515','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37849,'65018','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15902,'31207','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29599,'52755','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29545,'52651','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15352,'30504','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6261,'15101','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43776,'74902','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22790,'43130','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23152,'43699','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10124,'22437','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8296,'18705','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16771,'32662','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2139,'06041','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30461,'54459','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3899,'10522','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14309,'29372','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25853,'47437','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17206,'33340','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15480,'30601','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13577,'28378','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45414,'77226','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52296,'94661','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39249,'67416','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16162,'31739','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34121,'59349','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31315,'55417','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24298,'45371','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49881,'87654','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(7,'00605','Aguadilla','72005','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(50268,'89113','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(8258,'18623','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29614,'52767','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11170,'24202','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43114,'73706','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9493,'20884','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4178,'11429','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1755,'04950','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1999,'05674','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13793,'28601','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38164,'65548','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9328,'20658','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33957,'59059','Musselshell','30065','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49518,'85929','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51413,'92615','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46455,'78671','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34687,'60425','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(69,'00721','Rio Grande','72119','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(37634,'64638','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(230,'01033','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29208,'52162','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28234,'50265','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24164,'45245','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6955,'16212','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6965,'16222','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48512,'83455','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(18744,'36275','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23060,'43521','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8143,'18411','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36253,'62534','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13057,'27805','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12028,'25724','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2628,'07073','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1123,'03301','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3135,'08348','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31290,'55395','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20834,'39272','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54303,'98284','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50319,'89164','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(32727,'57264','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31277,'55387','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29437,'52550','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48079,'81625','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46886,'79257','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46559,'78836','Dimmit','48127','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41568,'71416','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41223,'70803','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25046,'46352','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24309,'45382','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9078,'20201','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(13120,'27853','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39060,'67051','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31947,'56241','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6655,'15717','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25316,'46798','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50149,'88545','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(38442,'65775','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20995,'39482','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17994,'35016','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37089,'63561','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38386,'65737','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17029,'33040','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13543,'28351','Scotland','37165','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14442,'29527','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21211,'39837','Miller','13201','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42364,'72536','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44516,'75944','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48366,'83221','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40243,'68752','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44718,'76195','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4010,'10958','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31470,'55735','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29221,'52171','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41739,'71745','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5722,'14213','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5063,'13060','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36729,'63006','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2242,'06226','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31396,'55575','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22283,'42102','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50233,'89041','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(23727,'44607','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27343,'49318','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31926,'56225','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19438,'37317','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38341,'65705','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11585,'24901','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(831,'02638','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38502,'66021','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19327,'37149','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20536,'38858','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20970,'39461','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21624,'40484','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22572,'42716','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52416,'95043','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54222,'98181','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43585,'74559','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20990,'39479','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22588,'42726','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7706,'17552','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27632,'49705','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4598,'12302','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30125,'53926','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32758,'57312','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6164,'14898','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38756,'66546','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14685,'29819','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47572,'80487','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20906,'39360','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1255,'03844','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11880,'25430','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29835,'53183','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27002,'48877','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39304,'67456','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53460,'96803','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(49887,'87714','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(45975,'78043','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46483,'78718','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45488,'77328','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24871,'46147','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(666,'02155','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37211,'63781','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(157,'00928','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(22556,'42642','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29056,'51571','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17437,'33705','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17325,'33542','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8617,'19333','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3915,'10542','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41653,'71602','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42660,'72943','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45102,'76666','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51124,'92117','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52146,'94290','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4453,'12085','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3541,'09599','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(33848,'58781','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1603,'04623','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1154,'03468','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(23036,'43504','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16028,'31552','Atkinson','13003','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53644,'97128','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30632,'54636','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35212,'61251','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40881,'70302','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36336,'62631','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(426,'01536','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17371,'33597','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5005,'12983','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36079,'62355','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32303,'56565','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5506,'13802','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7554,'17229','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20487,'38804','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16349,'32062','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49051,'84731','Beaver','49001','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(13011,'27635','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15636,'30757','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37172,'63735','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39518,'67658','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48956,'84510','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(33692,'58622','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12410,'26501','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31813,'56131','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2849,'07763','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17482,'33774','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26432,'48177','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42291,'72450','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24986,'46256','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17723,'34207','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21657,'40517','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48480,'83425','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51032,'91950','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16765,'32653','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34735,'60463','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47709,'80750','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1906,'05406','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12072,'25851','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33997,'59102','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29168,'52078','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29579,'52737','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53415,'96753','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(34493,'60068','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17972,'34990','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46756,'79081','Ochiltree','48357','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7131,'16503','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14608,'29677','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27785,'49853','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28861,'51238','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33724,'58642','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26935,'48831','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16006,'31535','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9748,'21556','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3906,'10532','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3044,'08095','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12671,'27208','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12090,'25879','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26321,'48062','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21982,'41260','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3152,'08501','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37313,'63954','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46412,'78648','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52819,'95632','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13647,'28444','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6646,'15710','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38535,'66051','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42633,'72914','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52434,'95067','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34888,'60617','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21267,'40011','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20772,'39162','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45253,'76905','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33841,'58773','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28108,'50162','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12297,'26285','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21976,'41250','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38284,'65649','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36017,'62289','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13614,'28411','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32972,'57481','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32323,'56579','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14337,'29412','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15063,'30217','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20902,'39356','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16325,'32035','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41234,'70814','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(55064,'99710','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(14065,'29018','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29664,'53016','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3402,'09137','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(259,'01075','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27405,'49357','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21943,'41171','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7616,'17322','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11119,'24131','Craig','51045','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44302,'75639','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45897,'77969','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51617,'93212','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53320,'96603','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(24576,'45805','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24796,'46069','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34572,'60138','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35374,'61434','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14677,'29812','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28618,'50649','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52010,'94021','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12370,'26412','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16752,'32631','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46467,'78691','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7088,'16404','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33777,'58723','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30777,'54769','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25154,'46556','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10907,'23885','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2644,'07092','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4780,'12582','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12143,'25989','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19147,'37020','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38436,'65773','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42452,'72642','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44913,'76462','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15139,'30277','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4680,'12469','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1248,'03837','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(41812,'71859','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32204,'56464','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26055,'47732','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22124,'41702','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12585,'27013','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(7213,'16666','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41075,'70585','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46445,'78666','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51113,'92106','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10490,'23075','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17990,'35011','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46349,'78610','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48953,'84414','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54825,'99209','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5197,'13290','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30609,'54619','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23016,'43457','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37362,'64048','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54892,'99402','Asotin','53003','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14350,'29423','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27903,'50014','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19137,'37014','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37449,'64136','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15485,'30605','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36750,'63025','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1131,'03440','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3145,'08401','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24129,'45212','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17192,'33325','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45343,'77055','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53516,'96923','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(25551,'47106','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20661,'39046','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54587,'98670','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12151,'26033','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3603,'09734','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(10562,'23150','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29413,'52530','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47166,'79756','Ward','48475','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49422,'85633','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34208,'59480','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29223,'52172','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44050,'75246','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54732,'99040','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7050,'16347','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31428,'55607','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9224,'20523','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(29694,'53039','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18849,'36456','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24956,'46228','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47475,'80257','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(82,'00736','Cayey','72035','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(4128,'11351','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9323,'20646','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11505,'24712','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28239,'50269','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25516,'47018','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23905,'44830','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30145,'53941','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21287,'40031','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17949,'34953','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23389,'44040','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28793,'51036','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10601,'23220','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26029,'47701','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22974,'43408','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16793,'32694','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21563,'40391','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20012,'38173','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34740,'60466','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39672,'67871','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1365,'04074','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(41584,'71426','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40654,'69162','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21171,'39767','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24575,'45804','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34081,'59312','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14570,'29649','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1989,'05663','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9986,'22040','Falls Church City','51610','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8131,'18357','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34730,'60458','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47975,'81230','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49305,'85333','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52472,'95135','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32976,'57520','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29791,'53130','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6212,'15044','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17204,'33338','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17457,'33738','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25106,'46511','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37138,'63645','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47056,'79534','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9370,'20714','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51347,'92504','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48958,'84512','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44898,'76454','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42093,'72160','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29465,'52568','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18927,'36560','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32156,'56396','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29787,'53127','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19496,'37356','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52413,'95039','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37745,'64752','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4419,'12053','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8604,'19310','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17096,'33144','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14789,'30005','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16663,'32504','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52756,'95551','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22049,'41526','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27036,'48897','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54758,'99124','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47341,'80101','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38358,'65717','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36971,'63401','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11680,'25079','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3151,'08501','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18313,'35563','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27676,'49738','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26342,'48085','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14742,'29909','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9784,'21645','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52916,'95765','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53185,'96137','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12558,'26845','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51377,'92555','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44051,'75247','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42499,'72702','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20835,'39282','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27386,'49342','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18105,'35133','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17733,'34219','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2746,'07508','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3999,'10933','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15956,'31401','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26891,'48770','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18728,'36264','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23992,'44907','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37743,'64750','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38138,'65470','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6628,'15683','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52065,'94125','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43430,'74330','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42044,'72120','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17227,'33412','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9635,'21204','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28012,'50106','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9705,'21286','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10867,'23842','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11159,'24176','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36712,'62985','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27736,'49795','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25260,'46763','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1898,'05361','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(22442,'42361','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(296,'01139','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54082,'97910','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52190,'94519','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31884,'56181','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49002,'84634','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46288,'78543','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40276,'68773','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24771,'46052','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10363,'22920','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36155,'62436','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2839,'07751','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21738,'40824','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20533,'38856','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5599,'14030','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39872,'68319','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50622,'90404','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52789,'95608','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(188,'00971','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13661,'28454','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54338,'98330','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46139,'78254','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45527,'77363','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39019,'67020','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38605,'66201','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18998,'36726','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17948,'34952','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3605,'09736','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(4936,'12884','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13634,'28435','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(759,'02453','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34220,'59520','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15809,'31060','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18165,'35215','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21190,'39819','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26781,'48650','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37669,'64658','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5844,'14502','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48191,'82336','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42445,'72636','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41557,'71404','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39534,'67671','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25938,'47542','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26870,'48759','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24436,'45656','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21802,'40982','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4625,'12414','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30491,'54481','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11944,'25565','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1923,'05452','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16744,'32619','Gilchrist','12041','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21201,'39828','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21502,'40336','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22032,'41464','Magoffin','21153','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38640,'66401','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34087,'59316','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54504,'98566','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46093,'78210','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33674,'58573','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50279,'89124','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(45507,'77347','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44010,'75203','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41209,'70780','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40627,'69147','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40207,'68729','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38761,'66548','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20826,'39217','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11707,'25123','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2223,'06143','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31728,'56060','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23668,'44442','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22846,'43201','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49820,'87512','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(7780,'17754','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52905,'95735','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49979,'88051','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(28232,'50265','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40683,'69214','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6086,'14836','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9750,'21560','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26113,'47859','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2950,'08002','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33868,'58794','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8826,'19801','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(18329,'35575','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42370,'72542','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54365,'98359','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31966,'56258','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7466,'17063','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49367,'85533','Greenlee','4011','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2201,'06111','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(39579,'67749','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41343,'71079','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54976,'99613','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37076,'63551','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3059,'08110','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11228,'24281','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31665,'56011','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53115,'96063','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45049,'76622','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43499,'74431','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28283,'50327','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25820,'47393','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25196,'46660','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31377,'55553','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16621,'32437','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23322,'43944','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48562,'83604','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48805,'84060','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49934,'87940','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(2717,'07440','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21823,'41011','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39048,'67039','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40359,'68836','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47342,'80102','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5680,'14129','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4459,'12093','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29030,'51554','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26414,'48164','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46334,'78595','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50632,'90503','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24815,'46102','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9709,'21290','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47268,'79948','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22235,'42047','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38603,'66119','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45435,'77252','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7320,'16859','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33620,'58521','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35068,'61013','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31291,'55396','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11470,'24607','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15032,'30179','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17801,'34431','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18944,'36581','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38975,'66951','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46027,'78112','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46192,'78351','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48168,'82225','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(33319,'58210','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54156,'98072','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47184,'79776','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1264,'03853','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(25012,'46301','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45740,'77574','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45963,'78024','Real','48385','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4401,'12031','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34359,'59834','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32308,'56569','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30911,'54929','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10511,'23102','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25469,'46979','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1840,'05083','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16704,'32562','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28498,'50567','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27822,'49891','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18655,'36081','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52032,'94064','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47001,'79452','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40851,'70159','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42976,'73502','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29086,'51645','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28867,'51242','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2154,'06062','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17681,'34102','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44055,'75250','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9910,'21813','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(46123,'78239','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43020,'73549','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40303,'68788','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39538,'67673','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15450,'30563','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27497,'49514','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36545,'62871','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33241,'58043','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32344,'56593','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29417,'52533','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40153,'68654','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41481,'71286','East Carroll','22035','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47555,'80467','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36377,'62673','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39025,'67024','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46630,'78957','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53633,'97118','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13302,'28078','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34050,'59255','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30266,'54130','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11574,'24879','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29550,'52654','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23829,'44685','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23212,'43762','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18896,'36523','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48855,'84111','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11165,'24185','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29653,'53011','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8189,'18451','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46327,'78588','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49439,'85650','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4493,'12143','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10539,'23125','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31337,'55435','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2679,'07206','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27606,'49679','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25618,'47162','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20122,'38345','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42829,'73101','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43637,'74702','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45642,'77476','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51896,'93656','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34333,'59801','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29193,'52149','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17792,'34292','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43167,'73757','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4831,'12752','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51147,'92143','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8980,'20101','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8325,'18826','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8250,'18617','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26918,'48820','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23773,'44638','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7208,'16662','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16071,'31623','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38430,'65769','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49152,'85054','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29782,'53120','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52143,'94287','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45585,'77426','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10278,'22726','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13185,'27919','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27194,'49094','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9423,'20776','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4665,'12456','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47581,'80503','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36751,'63026','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32266,'56535','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4706,'12501','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33921,'59025','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52843,'95658','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20969,'39460','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16843,'32754','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15118,'30260','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8259,'18623','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24380,'45503','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(608,'02056','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43539,'74464','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19166,'37032','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26668,'48463','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1068,'03233','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11833,'25327','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35737,'61883','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30971,'54974','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49057,'84737','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29910,'53505','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16184,'31765','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17094,'33142','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36003,'62277','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34596,'60153','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6607,'15665','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47110,'79605','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46242,'78405','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41579,'71423','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39231,'67353','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38347,'65710','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17425,'33682','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25096,'46502','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27477,'49458','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17053,'33073','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2358,'06443','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24475,'45686','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18145,'35184','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(206,'01002','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8922,'20023','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30332,'54212','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39168,'67203','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53526,'96944','Federated States of Micro','64003','FM','Federated States of Micronesia',0,'2013-07-03 15:17:54',NULL,NULL),(54181,'98113','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4811,'12729','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40826,'70123','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39525,'67663','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1124,'03302','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(48382,'83241','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36041,'62319','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28824,'51058','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24201,'45305','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32875,'57385','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49023,'84657','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(22145,'41745','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18667,'36102','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36726,'62999','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1288,'03883','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(45013,'76556','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50496,'90038','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53457,'96799','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(2589,'07032','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51175,'92178','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15153,'30290','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23765,'44632','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24334,'45416','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2460,'06726','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1894,'05357','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(35746,'61912','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34074,'59301','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27413,'49404','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24183,'45268','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14786,'30004','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16584,'32399','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21530,'40361','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47925,'81125','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54672,'98937','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(387,'01463','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6321,'15226','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8849,'19898','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(596,'02041','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21702,'40734','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38326,'65682','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44658,'76098','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52988,'95928','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31746,'56072','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32695,'57243','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30203,'54007','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20892,'39350','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20515,'38846','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18903,'36530','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17831,'34477','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38330,'65688','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24535,'45744','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54613,'98821','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54049,'97857','Wallowa','41063','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54012,'97810','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(70,'00723','Patillas','72109','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13298,'28074','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24781,'46060','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45334,'77047','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33030,'57566','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7174,'16629','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31741,'56069','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2594,'07039','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49387,'85554','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39951,'68367','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19161,'37029','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30363,'54304','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20035,'38224','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3740,'10102','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3167,'08520','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30899,'54921','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28425,'50517','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24686,'45877','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41095,'70612','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53671,'97202','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13847,'28640','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(403,'01506','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14112,'29062','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3833,'10286','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44999,'76540','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40004,'68428','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39118,'67118','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25238,'46741','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35023,'60954','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27562,'49642','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17281,'33471','Glades','12043','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36528,'62861','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51524,'92865','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53311,'96557','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(9942,'21866','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45634,'77468','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33718,'58639','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49751,'87154','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54824,'99208','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34571,'60137','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42548,'72756','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45913,'77984','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55066,'99712','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13632,'28434','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1937,'05465','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14956,'30122','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45855,'77865','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32018,'56293','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25093,'46411','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17474,'33765','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16029,'31552','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34349,'59825','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14472,'29566','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11074,'24082','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44114,'75395','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36167,'62445','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54704,'99013','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8127,'18353','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1850,'05143','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(552,'01907','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32097,'56347','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(1197,'03751','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6818,'15957','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3247,'08733','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50615,'90309','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24009,'45033','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14101,'29053','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20019,'38184','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48551,'83547','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52493,'95172','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6764,'15864','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11935,'25550','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32930,'57452','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12753,'27305','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24233,'45325','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41072,'70583','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42636,'72918','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48237,'82633','Converse','56009','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49411,'85622','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50559,'90210','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13267,'28027','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51122,'92115','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7944,'18003','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1595,'04612','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4553,'12207','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5043,'13039','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11459,'24598','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42423,'72616','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47462,'80244','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11999,'25696','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31704,'56043','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19478,'37340','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45681,'77506','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28575,'50620','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6141,'14881','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32696,'57243','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27876,'49964','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29442,'52553','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28543,'50599','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40285,'68779','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49605,'86404','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25926,'47531','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52053,'94112','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7571,'17246','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6841,'16025','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16761,'32643','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14703,'29836','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41530,'71355','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53777,'97346','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9906,'21803','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16904,'32826','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43638,'74720','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45419,'77231','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52288,'94620','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36495,'62838','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2787,'07652','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34965,'60910','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20061,'38257','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37431,'64117','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40050,'68461','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41902,'72014','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50334,'89199','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40740,'69358','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40833,'70130','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50829,'91330','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1202,'03756','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35989,'62268','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8544,'19128','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22740,'43076','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46836,'79226','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28449,'50533','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5943,'14615','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13240,'27981','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27109,'49033','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51224,'92257','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3816,'10265','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12841,'27438','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17258,'33443','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42453,'72644','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45169,'76827','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36671,'62951','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18271,'35486','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42301,'72459','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(511,'01827','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1061,'03224','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(10668,'23307','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15942,'31319','McIntosh','13191','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39953,'68368','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51884,'93646','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13659,'28453','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12915,'27546','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12638,'27102','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22477,'42420','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21130,'39739','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2872,'07836','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30308,'54170','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22534,'42544','Wayne','21231','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48257,'82710','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(24275,'45351','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6127,'14871','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12884,'27524','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38491,'66014','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(192,'00977','Trujillo Alto','72139','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(53023,'95960','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54731,'99039','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32801,'57337','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(55095,'99748','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51016,'91916','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49496,'85748','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47428,'80217','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9306,'20623','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12106,'25916','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26264,'47994','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40434,'68924','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45407,'77219','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48286,'82833','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48409,'83283','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(34230,'59528','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35717,'61864','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50800,'91224','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21697,'40701','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21592,'40440','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14408,'29479','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51859,'93624','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34061,'59261','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20836,'39283','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42432,'72626','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50721,'90831','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51605,'93190','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46499,'78731','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47158,'79748','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25023,'46319','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26603,'48420','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23386,'44036','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34073,'59301','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37250,'63849','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45472,'77302','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44831,'76374','Baylor','48023','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26339,'48082','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5575,'14004','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30118,'53923','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22259,'42069','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37556,'64471','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54981,'99621','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52197,'94526','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50280,'89125','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49813,'87505','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(17651,'34022','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(11667,'25060','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12660,'27155','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1587,'04576','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16053,'31567','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34932,'60670','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16220,'31790','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38018,'65279','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49063,'84743','Piute','49031','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10625,'23233','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11405,'24541','Danville City','51590','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18741,'36273','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14193,'29148','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32399,'56671','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33195,'57793','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13357,'28124','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1717,'04864','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51479,'92782','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40938,'70433','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22338,'42204','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19340,'37165','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9568,'21061','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35728,'61875','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37091,'63563','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38602,'66118','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51090,'92070','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49494,'85746','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29091,'51646','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47829,'81001','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(28978,'51520','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52427,'95060','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43208,'73844','Harper','40059','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41595,'71434','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13974,'28747','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9768,'21627','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27289,'49267','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8260,'18624','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3887,'10510','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23964,'44875','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8456,'19037','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12774,'27326','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43364,'74084','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45118,'76682','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52601,'95347','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6869,'16051','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49583,'86325','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46696,'79041','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29697,'53040','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30283,'54152','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30428,'54437','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33435,'58341','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8800,'19702','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(46818,'79166','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41522,'71345','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21596,'40444','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19418,'37246','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27338,'49316','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7841,'17836','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6326,'15231','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51951,'93771','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51771,'93510','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47137,'79720','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27997,'50074','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21205,'39834','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33556,'58456','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51737,'93437','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30494,'54485','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31826,'56141','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1369,'04079','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2101,'05874','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28502,'50569','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49065,'84745','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44623,'76063','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26350,'48094','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29237,'52208','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14818,'30022','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10569,'23161','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12130,'25972','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54986,'99626','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48379,'83237','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41372,'71135','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19349,'37174','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21687,'40602','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8606,'19312','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23244,'43803','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23657,'44430','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30638,'54639','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31411,'55590','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34304,'59733','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49685,'87031','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48482,'83428','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47537,'80447','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46052,'78132','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43066,'73639','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26547,'48340','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(679,'02189','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2622,'07067','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21794,'40964','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26475,'48222','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17553,'33871','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54518,'98583','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52137,'94280','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47936,'81136','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45162,'76821','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41344,'71080','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7870,'17868','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5834,'14485','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10307,'22801','Harrisonburg City','51660','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27202,'49099','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34237,'59535','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16573,'32353','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15818,'31064','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39085,'67068','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32647,'57201','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47278,'79961','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52126,'94262','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2952,'08004','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37511,'64432','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50680,'90706','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22750,'43082','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(645,'02131','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12060,'25833','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38234,'65617','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39899,'68335','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36994,'63442','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33897,'59001','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12633,'27055','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29530,'52641','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24074,'45133','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4933,'12878','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20232,'38483','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(55157,'99901','Ketchikan Gateway','2130','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(6087,'14837','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9803,'21661','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10897,'23876','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12718,'27263','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35852,'62056','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34364,'59842','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(24480,'45688','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17963,'34979','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19090,'36860','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12873,'27518','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33221,'58029','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8965,'20071','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1686,'04773','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17020,'33030','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3159,'08511','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36700,'62972','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8457,'19038','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13477,'28287','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25655,'47229','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24539,'45746','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20374,'38642','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49817,'87509','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(17951,'34956','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49702,'87047','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46258,'78427','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42328,'72479','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19537,'37380','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27580,'49657','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12322,'26335','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1675,'04758','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28791,'51035','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26417,'48166','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47507,'80403','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2944,'07978','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54546,'98613','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22683,'43031','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26393,'48138','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39102,'67107','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40170,'68665','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18538,'35978','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12764,'27315','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50231,'89039','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(2205,'06117','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38518,'66039','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54845,'99301','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48969,'84528','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48721,'83853','Boundary','16021','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46360,'78616','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15223,'30346','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13042,'27713','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12683,'27217','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30522,'54513','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17037,'33054','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(988,'02912','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(17083,'33131','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16063,'31604','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(381,'01450','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17476,'33767','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29650,'53010','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34275,'59648','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20312,'38582','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19772,'37847','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17848,'34602','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9616,'21146','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14358,'29432','Bamberg','45009','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18765,'36311','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36431,'62764','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21605,'40448','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33696,'58623','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51165,'92168','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49170,'85078','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46184,'78340','Refugio','48391','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42906,'73179','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29918,'53512','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32506,'57004','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16338,'32054','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(55083,'99736','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47165,'79755','Upton','48461','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41827,'71909','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12834,'27417','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23566,'44260','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25262,'46764','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14601,'29670','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26109,'47857','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30858,'54868','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33144,'57744','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15279,'30425','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21880,'41073','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18823,'36421','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1485,'04363','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8203,'18463','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45574,'77415','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42820,'73093','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42610,'72852','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41316,'71063','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(23495,'44146','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21324,'40061','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31862,'56166','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18822,'36420','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13554,'28362','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39406,'67557','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15326,'30457','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36826,'63108','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34253,'59623','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(48568,'83610','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48555,'83549','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46495,'78728','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23293,'43912','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16156,'31733','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4180,'11431','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17409,'33647','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33824,'58761','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30137,'53934','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11762,'25211','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10104,'22405','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(363,'01368','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26647,'48451','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14723,'29848','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(959,'02878','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(34713,'60446','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9537,'21020','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51017,'91917','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47048,'79530','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41578,'71422','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9152,'20391','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7053,'16351','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15524,'30634','Elbert','13105','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17141,'33193','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29891,'53290','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18564,'36010','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34884,'60613','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37111,'63625','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(749,'02379','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1973,'05641','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42868,'73139','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50486,'90028','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50752,'91031','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33230,'58035','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9794,'21654','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25989,'47611','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16682,'32531','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17686,'34107','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7894,'17922','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24685,'45877','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54692,'99005','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(15397,'30530','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(55129,'99783','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53513,'96917','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(51641,'93241','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50324,'89173','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44576,'76020','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27212,'49111','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26859,'48750','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8403,'18963','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2764,'07606','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13623,'28425','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31420,'55599','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28973,'51501','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41803,'71852','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48634,'83680','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(7090,'16406','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34482,'60051','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9295,'20613','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33268,'58057','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33920,'59024','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14178,'29132','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38596,'66111','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14577,'29653','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33186,'57785','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28664,'50677','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13301,'28077','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54765,'99130','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50835,'91340','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46804,'79114','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44585,'76031','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43280,'74023','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29765,'53103','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30847,'54856','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19581,'37544','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13233,'27973','Camden','37029','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40775,'70052','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47419,'80211','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(55154,'99840','Skagway','2230','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1918,'05447','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27217,'49117','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54506,'98568','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41807,'71855','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31305,'55407','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41448,'71256','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26850,'48744','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35459,'61491','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47363,'80112','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(774,'02467','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32260,'56528','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(48432,'83328','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47272,'79952','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44989,'76533','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23149,'43681','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32059,'56326','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20476,'38773','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41735,'71742','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44803,'76309','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45739,'77573','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48411,'83285','Caribou','16029','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(3630,'09804','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(50380,'89436','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33449,'58352','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24773,'46055','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22642,'43004','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28735,'51002','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2406,'06512','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34391,'59872','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7104,'16421','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2741,'07503','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44312,'75645','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47566,'80478','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53685,'97213','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(38048,'65325','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39423,'67566','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44578,'76020','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42201,'72365','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26986,'48864','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17878,'34680','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17717,'34201','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15718,'31011','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15090,'30233','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33815,'58756','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22785,'43125','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2077,'05843','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40598,'69128','Kimball','31105','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34671,'60410','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18006,'35031','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(336,'01266','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53107,'96056','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48397,'83261','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43851,'75034','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42915,'73344','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24065,'45122','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35377,'61435','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54636,'98848','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46935,'79351','Dawson','48115','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4784,'12585','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29133,'52048','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18236,'35449','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18054,'35074','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4783,'12584','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16695,'32547','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43238,'73947','Cimarron','40025','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6533,'15545','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9723,'21504','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54875,'99350','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51793,'93532','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47226,'79905','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39009,'67012','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25832,'47406','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10877,'23850','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12272,'26259','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39211,'67336','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39092,'67074','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20370,'38638','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26640,'48444','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30714,'54736','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33199,'57799','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43792,'74943','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18639,'36068','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25582,'47126','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38529,'66046','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38873,'66777','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8279,'18643','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34689,'60428','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13086,'27828','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26111,'47858','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13182,'27916','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18977,'36660','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43918,'75098','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7767,'17739','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50823,'91324','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42997,'73532','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26388,'48134','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39086,'67068','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12985,'27606','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7518,'17111','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9664,'21224','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12707,'27253','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13510,'28326','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54174,'98106','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28019,'50108','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40825,'70122','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14877,'30067','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44669,'76109','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37307,'63950','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15461,'30571','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36557,'62880','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47197,'79821','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4168,'11419','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22202,'42020','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54318,'98304','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33482,'58380','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15572,'30677','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6729,'15824','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50062,'88312','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(33993,'59088','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46979,'79382','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45039,'76578','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12288,'26275','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13388,'28152','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15034,'30180','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37394,'64076','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15196,'30324','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13594,'28391','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2271,'06259','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2729,'07460','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5587,'14012','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45383,'77092','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47134,'79714','Andrews','48003','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49866,'87569','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(4588,'12249','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2054,'05777','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(51476,'92735','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46898,'79313','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7790,'17764','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36574,'62890','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14026,'28792','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21311,'40052','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45165,'76824','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48920,'84319','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(17512,'33825','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50394,'89449','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(25111,'46515','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9824,'21702','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32378,'56651','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16808,'32710','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29147,'52064','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15872,'31097','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28866,'51241','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28817,'51053','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19711,'37771','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43197,'73840','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45030,'76570','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33175,'57775','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16848,'32762','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20759,'39152','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3146,'08402','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3275,'08808','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27913,'50025','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28006,'50103','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16363,'32081','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39500,'67648','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30646,'54645','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25267,'46767','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19789,'37862','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42959,'73456','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49491,'85743','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(717,'02332','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50961,'91749','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18972,'36633','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52553,'95269','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26476,'48223','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24776,'46056','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33056,'57623','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16243,'31803','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34115,'59344','Fallon','30025','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6760,'15860','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32406,'56678','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15134,'30275','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12450,'26572','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25368,'46902','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42105,'72170','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44275,'75572','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1418,'04234','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51770,'93505','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49827,'87519','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(20260,'38545','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33781,'58727','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36720,'62993','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41198,'70770','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34555,'60124','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2437,'06611','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32734,'57268','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29103,'51656','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24296,'45370','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(55100,'99753','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(216,'01011','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54476,'98537','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51941,'93741','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41979,'72067','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29544,'52651','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37953,'65202','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7268,'16743','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6234,'15066','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12215,'26161','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5891,'14542','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(624,'02110','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23120,'43603','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47077,'79547','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34949,'60693','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13509,'28325','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4877,'12810','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51152,'92152','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24945,'46216','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28386,'50467','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28620,'50650','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31963,'56257','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:52',NULL,NULL),(2687,'07307','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39498,'67648','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11509,'24719','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44243,'75497','Rains','48379','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22274,'42085','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21623,'40484','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19801,'37870','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26343,'48086','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9746,'21550','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(369,'01379','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1073,'03240','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3389,'09096','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(36702,'62973','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40297,'68786','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54541,'98607','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25649,'47225','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30007,'53575','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22236,'42048','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21515,'40348','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36424,'62736','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8444,'19025','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7452,'17053','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33763,'58710','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21040,'39573','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9347,'20687','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36283,'62554','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9230,'20529','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11575,'24880','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(156,'00927','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(43825,'75009','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54911,'99518','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(45594,'77435','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23691,'44481','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19074,'36849','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12595,'27020','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(17901,'34731','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17187,'33320','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10789,'23551','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46175,'78332','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50369,'89426','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47640,'80612','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(32087,'56341','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(44750,'76239','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35988,'62266','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34017,'59214','McCone','30055','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23858,'44720','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32652,'57213','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15283,'30426','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35381,'61438','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38286,'65650','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2039,'05762','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(49180,'85117','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42233,'72395','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(29143,'52056','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14986,'30144','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33694,'58622','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44045,'75240','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54093,'98003','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46599,'78940','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41403,'71219','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25986,'47601','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7261,'16732','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26958,'48844','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27427,'49415','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36625,'62922','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39619,'67839','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25170,'46571','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48908,'84308','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(22131,'41722','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15393,'30529','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1071,'03237','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6270,'15120','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10729,'23435','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5793,'14445','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16734,'32609','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36461,'62816','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25792,'47368','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26829,'48731','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31965,'56257','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32248,'56518','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36218,'62476','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43954,'75140','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21546,'40374','Nicholas','21181','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7155,'16601','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2423,'06534','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35076,'61019','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36026,'62298','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54860,'99337','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54791,'99155','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52381,'95003','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19084,'36855','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21349,'40078','Mercer','21167','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25933,'47537','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2379,'06478','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18430,'35755','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7123,'16441','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26398,'48144','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39209,'67335','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50122,'88516','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(44543,'75973','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35502,'61552','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19982,'38122','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16391,'32115','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46832,'79223','Cottle','48101','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32174,'56436','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32483,'56761','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33395,'58281','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39725,'68020','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45732,'77564','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42481,'72675','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23419,'44070','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11636,'25015','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28959,'51459','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51993,'93950','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51533,'92879','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33669,'58570','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7980,'18044','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5356,'13602','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46037,'78119','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10094,'22331','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28149,'50218','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30503,'54490','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35074,'61018','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36070,'62349','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35919,'62214','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51116,'92109','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48264,'82718','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46337,'78598','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45648,'77480','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24937,'46205','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19169,'37033','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10915,'23890','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9036,'20151','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4268,'11732','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15119,'30261','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1796,'05032','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34602,'60160','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24228,'45322','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37813,'64855','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35523,'61570','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48285,'82832','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(20726,'39110','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22675,'43025','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29013,'51543','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32848,'57369','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15957,'31402','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9009,'20124','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11948,'25571','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14149,'29111','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45372,'77083','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46894,'79311','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53798,'97365','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54220,'98177','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37066,'63545','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47181,'79769','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15330,'30459','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31745,'56072','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32485,'56762','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30149,'53944','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7521,'17120','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28993,'51530','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15178,'30309','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42437,'72631','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39599,'67762','Greeley','20071','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41624,'71462','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26405,'48154','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23262,'43830','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40905,'70364','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6855,'16038','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5819,'14472','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11031,'24035','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11790,'25259','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38715,'66517','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24337,'45420','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31898,'56209','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47879,'81055','Huerfano','8055','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40687,'69217','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4892,'12828','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44292,'75608','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21634,'40503','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12147,'26003','Ohio','54069','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24932,'46197','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25612,'47147','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31531,'55804','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39947,'68366','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2733,'07465','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23491,'44142','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45898,'77970','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47733,'80817','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53412,'96750','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(28943,'51449','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26374,'48118','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9541,'21028','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11693,'25106','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35049,'60968','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46629,'78956','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46322,'78582','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39442,'67581','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8355,'18902','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35630,'61760','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14569,'29649','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6140,'14880','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11188,'24225','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25006,'46285','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24351,'45432','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21600,'40446','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20534,'38856','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10479,'23065','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19860,'37931','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23903,'44830','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46359,'78615','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47894,'81069','Huerfano','8055','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53907,'97488','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(15426,'30547','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36848,'63125','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24519,'45732','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28655,'50672','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38125,'65459','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43302,'74038','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54756,'99122','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37614,'64625','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53803,'97368','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29704,'53047','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34395,'59901','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28383,'50465','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6890,'16101','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22439,'42355','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5206,'13310','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41804,'71852','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47007,'79493','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47329,'80035','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48352,'83204','Power','16077','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54001,'97754','Crook','41013','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54397,'98392','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31545,'55903','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8193,'18455','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20123,'38345','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6039,'14782','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8702,'19457','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30172,'53959','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28117,'50168','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5119,'13122','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15044,'30185','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46844,'79231','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49562,'86044','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49940,'88003','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51838,'93609','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52529,'95230','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25433,'46952','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16689,'32539','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44517,'75946','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50805,'91303','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(721,'02338','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13221,'27959','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12343,'26369','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16267,'31823','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42708,'73016','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50135,'88530','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(51281,'92336','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51665,'93262','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10565,'23155','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33859,'58788','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15654,'30813','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7218,'16670','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12809,'27361','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36412,'62706','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5495,'13784','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19021,'36754','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30554,'54540','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23781,'44643','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38340,'65704','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48640,'83702','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14551,'29636','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33703,'58630','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28368,'50457','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24018,'45044','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36611,'62912','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15726,'31014','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39735,'68030','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40362,'68840','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50772,'91116','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14320,'29384','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36969,'63390','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4942,'12910','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40307,'68791','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43767,'74880','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37135,'63640','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(847,'02657','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11003,'24013','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10741,'23453','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9190,'20435','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(21803,'40983','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25729,'47326','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41627,'71463','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54071,'97886','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34205,'59474','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(10106,'22406','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16919,'32855','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38136,'65466','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7979,'18043','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34762,'60481','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27436,'49422','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12983,'27604','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22173,'41822','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(827,'02633','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6804,'15945','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38558,'66073','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44528,'75960','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48675,'83803','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50703,'90747','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50857,'91364','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51643,'93242','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54837,'99223','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27283,'49264','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7597,'17303','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21974,'41238','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44448,'75838','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33968,'59068','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11968,'25638','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22860,'43216','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37981,'65244','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39472,'67635','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48386,'83245','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(7815,'17814','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30220,'54025','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26453,'48198','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9894,'21791','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4186,'11439','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15123,'30265','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19428,'37308','Meigs','47121','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48364,'83218','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53953,'97621','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(35788,'61949','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1475,'04350','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10864,'23840','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18393,'35653','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44766,'76255','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14353,'29426','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9194,'20440','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(485,'01747','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8967,'20074','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12203,'26148','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9930,'21850','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33251,'58049','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18832,'36432','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37297,'63940','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40423,'68883','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23147,'43666','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25563,'47115','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8334,'18832','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8672,'19415','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5068,'13064','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7316,'16854','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20429,'38704','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37324,'63964','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34586,'60146','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10880,'23851','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28545,'50601','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23116,'43570','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21860,'41049','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46429,'78657','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8251,'18618','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10723,'23429','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33759,'58704','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10225,'22626','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30827,'54838','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5200,'13303','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24045,'45106','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16090,'31635','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46355,'78613','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48682,'83810','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54377,'98372','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9572,'21074','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25961,'47573','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21980,'41256','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5104,'13107','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4375,'11977','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43546,'74471','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51358,'92518','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1169,'03584','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28055,'50133','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40846,'70153','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28456,'50539','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25629,'47170','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17417,'33672','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17721,'34205','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19968,'38106','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22850,'43205','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23081,'43534','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23530,'44221','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40152,'68653','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54651,'98901','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6054,'14807','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54185,'98117','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23860,'44721','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26623,'48434','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29861,'53212','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18603,'36037','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1628,'04657','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3371,'09049','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(31974,'56264','Lincoln','27081','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25881,'47459','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20072,'38302','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20613,'38946','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38156,'65542','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2188,'06095','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54173,'98105','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16485,'32226','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13444,'28241','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32901,'57434','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7195,'16648','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27844,'49918','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22035,'41472','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10007,'22103','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8931,'20036','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(43517,'74444','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52539,'95242','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33486,'58382','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24721,'45898','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50478,'90020','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19328,'37150','Clay','47027','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11864,'25405','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29331,'52318','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30779,'54770','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3640,'09816','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7385,'16950','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24406,'45628','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40048,'68460','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43404,'74141','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(472,'01704','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4471,'12118','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5100,'13102','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21455,'40270','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33780,'58725','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5224,'13327','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1221,'03804','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(41802,'71852','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43281,'74023','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43325,'74058','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25222,'46725','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54560,'98629','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48584,'83628','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47373,'80123','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1627,'04655','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45490,'77331','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42451,'72641','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39774,'68064','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16120,'31699','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8372,'18926','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31511,'55782','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32223,'56477','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33047,'57580','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3029,'08084','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(368,'01378','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3822,'10273','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15146,'30285','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37226,'63822','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37717,'64733','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1585,'04574','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45186,'76844','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19354,'37179','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23387,'44039','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18583,'36028','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34462,'60031','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15612,'30736','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9092,'20217','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36228,'62481','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46478,'78713','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46546,'78783','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(600,'02047','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46305,'78564','Zapata','48505','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41482,'71291','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20259,'38544','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27004,'48877','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27455,'49437','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19220,'37062','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27611,'49683','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31765,'56087','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12776,'27330','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35328,'61371','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7257,'16728','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12193,'26141','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4703,'12495','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51861,'93626','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26018,'47647','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18371,'35620','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26269,'47996','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19734,'37809','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48368,'83226','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29536,'52645','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36095,'62370','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20154,'38370','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31433,'55615','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31990,'56276','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17041,'33061','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1855,'05150','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(35343,'61411','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34528,'60102','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38569,'66086','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46720,'79057','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47070,'79545','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54979,'99619','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54010,'97761','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50480,'90022','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49212,'85192','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(10943,'23927','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38959,'66940','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38084,'65350','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14352,'29425','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9661,'21222','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20953,'39443','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4134,'11358','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12242,'26208','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8735,'19506','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36353,'62650','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16732,'32607','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14583,'29655','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15697,'30916','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40376,'68852','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10980,'23964','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51371,'92548','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37854,'65024','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10144,'22480','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15544,'30650','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1527,'04456','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26455,'48202','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13223,'27962','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31543,'55901','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34284,'59713','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(5277,'13416','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44411,'75771','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50820,'91320','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7232,'16682','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3758,'10120','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54833,'99217','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24506,'45715','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25390,'46921','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19359,'37181','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12872,'27517','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7135,'16507','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29615,'52768','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36098,'62374','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38527,'66044','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22658,'43014','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21490,'40324','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20666,'39051','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25781,'47359','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32763,'57314','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45003,'76544','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43044,'73568','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1543,'04478','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31978,'56265','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10710,'23414','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10559,'23149','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26200,'47948','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6429,'15376','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48169,'82227','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51048,'92010','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11916,'25521','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46464,'78681','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45706,'77534','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11122,'24134','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17735,'34221','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41907,'72017','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44711,'76181','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1943,'05472','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(43505,'74435','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22383,'42274','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21707,'40741','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8986,'20106','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10129,'22443','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37001,'63447','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43266,'74016','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31153,'55302','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(378,'01438','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9063,'20184','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26267,'47995','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24211,'45310','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15159,'30294','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53627,'97112','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29695,'53040','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11139,'24148','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10218,'22610','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23247,'43804','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25214,'46714','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25718,'47307','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44125,'75411','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47950,'81151','Conejos','8021','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6508,'15490','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5995,'14728','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33625,'58524','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33375,'58261','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15763,'31031','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46460,'78676','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54062,'97875','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26292,'48028','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11452,'24592','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22074,'41561','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39449,'67584','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27211,'49111','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20563,'38874','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22269,'42081','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24526,'45739','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37486,'64188','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50468,'90010','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3300,'08834','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21973,'41234','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10353,'22903','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15190,'30318','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38466,'65804','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44635,'76071','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11441,'24578','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16196,'31775','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11817,'25306','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43686,'74818','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49756,'87184','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2192,'06102','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35786,'61944','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15655,'30814','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34477,'60046','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37094,'63566','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52711,'95473','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5892,'14543','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18948,'36585','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53626,'97111','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(25145,'46550','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13066,'27812','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1253,'03842','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3338,'08886','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30691,'54721','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3319,'08862','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23809,'44667','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9764,'21623','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2871,'07834','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43491,'74423','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44499,'75931','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47838,'81009','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2982,'08035','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23924,'44843','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7735,'17601','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22992,'43434','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4027,'10977','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33033,'57567','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(927,'02827','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(10691,'23356','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2459,'06725','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5672,'14111','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20773,'39163','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17551,'33868','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15212,'30338','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53338,'96624','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53969,'97639','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12316,'26323','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24559,'45777','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19208,'37057','Trousdale','47169','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42792,'73069','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35730,'61876','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43390,'74127','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45004,'76544','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45326,'77040','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46893,'79311','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52577,'95322','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54949,'99576','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(35450,'61485','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16987,'32966','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22178,'41831','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49188,'85123','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34575,'60140','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33549,'58454','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32777,'57323','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19837,'37891','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42974,'73501','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53995,'97741','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5945,'14617','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31522,'55792','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25675,'47244','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15817,'31063','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20406,'38668','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22473,'42411','Crittenden','21055','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50323,'89170','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(7917,'17957','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10526,'23114','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15298,'30439','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15634,'30755','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17319,'33537','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21529,'40360','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23916,'44839','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13924,'28704','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3559,'09625','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(30797,'54814','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2080,'05847','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4255,'11717','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30561,'54546','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29045,'51563','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40527,'68981','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34245,'59545','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38704,'66507','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39963,'68376','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50377,'89434','Storey','32029','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51629,'93225','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13381,'28144','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27393,'49345','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10186,'22551','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18138,'35179','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11537,'24828','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44437,'75802','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47939,'81140','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54408,'98405','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35563,'61704','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36910,'63339','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3445,'09337','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35045,'60964','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13165,'27889','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31510,'55781','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30628,'54634','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27649,'49718','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26346,'48090','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17973,'34990','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5024,'13027','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43563,'74535','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45152,'76797','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47002,'79453','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52076,'94139','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12328,'26343','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20390,'38654','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17124,'33174','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41119,'70648','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41577,'71422','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41836,'71921','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43409,'74149','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43808,'74960','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44278,'75599','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(66,'00718','Naguabo','72103','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14418,'29487','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29648,'53008','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29255,'52218','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29176,'52133','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10192,'22556','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9615,'21144','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2421,'06532','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16965,'32937','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(525,'01851','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7115,'16434','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38521,'66040','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40457,'68937','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14903,'30091','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3914,'10541','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13041,'27712','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5787,'14435','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13224,'27962','Washington','37187','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41777,'71828','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44346,'75670','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48877,'84133','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11412,'24551','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36679,'62956','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9918,'21826','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9912,'21817','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27529,'49617','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25217,'46723','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21463,'40287','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53692,'97219','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54274,'98253','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34263,'59635','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19880,'38006','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24152,'45236','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37657,'64652','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19522,'37369','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48351,'83204','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47854,'81034','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47375,'80124','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18104,'35133','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35213,'61252','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50886,'91409','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21724,'40806','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19719,'37778','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14606,'29675','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27886,'50001','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30349,'54230','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27795,'49864','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22669,'43019','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40948,'70442','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43508,'74436','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54874,'99349','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36980,'63435','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52646,'95401','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47892,'81069','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38218,'65609','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37447,'64133','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24147,'45231','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30460,'54459','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30670,'54664','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36322,'62621','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6736,'15829','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44059,'75253','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48340,'83121','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(3513,'09554','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28032,'50118','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50365,'89422','Mineral','32021','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(42950,'73448','Love','40085','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24054,'45113','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21095,'39662','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9991,'22044','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14180,'29135','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11360,'24486','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11176,'24212','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10653,'23289','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42875,'73145','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44011,'75204','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48676,'83804','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49718,'87068','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52479,'95150','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6973,'16229','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8482,'19066','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52167,'94497','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4537,'12188','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19747,'37820','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6618,'15676','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1631,'04662','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(25753,'47342','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13781,'28583','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8137,'18403','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3560,'09626','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(17352,'33571','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46073,'78154','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46498,'78730','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49272,'85286','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(24220,'45317','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36081,'62357','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51902,'93665','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42310,'72466','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41929,'72028','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27218,'49119','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7585,'17262','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3811,'10257','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6325,'15230','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31489,'55753','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3617,'09750','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(15125,'30268','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43625,'74644','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8107,'18330','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36617,'62917','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39053,'67047','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38766,'66552','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28203,'50248','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23898,'44826','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1377,'04090','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12738,'27292','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13441,'28235','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(576,'01966','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13254,'28017','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7162,'16616','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1656,'04733','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4211,'11557','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40610,'69134','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28508,'50574','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2438,'06612','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(55002,'99643','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(45838,'77841','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39737,'68031','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9931,'21851','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27726,'49781','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29131,'52046','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34696,'60433','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8225,'18510','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11144,'24153','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6878,'16056','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10913,'23889','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11333,'24459','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27320,'49304','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20180,'38392','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35628,'61760','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21581,'40419','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6377,'15314','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1660,'04737','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22321,'42160','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24313,'45385','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24995,'46268','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26671,'48464','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23025,'43465','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20399,'38661','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5956,'14638','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18863,'36473','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34739,'60465','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51610,'93204','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41001,'70515','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13407,'28203','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53013,'95953','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48741,'83872','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45982,'78052','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42277,'72437','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39172,'67207','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16305,'32003','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15447,'30560','Union','13291','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2332,'06405','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9609,'21132','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31345,'55443','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32620,'57073','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12627,'27052','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36893,'63182','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3611,'09743','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(31329,'55428','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9039,'20155','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9859,'21757','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29094,'51648','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21129,'39737','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16961,'32932','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35422,'61471','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54907,'99514','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37581,'64490','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52506,'95206','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49234,'85226','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46654,'79012','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18031,'35053','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17746,'34232','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17253,'33438','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29474,'52572','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32020,'56295','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34001,'59106','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4539,'12190','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2776,'07640','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28853,'51232','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17461,'33743','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22110,'41649','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39356,'67511','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43209,'73848','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47772,'80866','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50240,'89048','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(8952,'20058','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12597,'27021','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(38788,'66617','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38345,'65708','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24698,'45886','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18398,'35654','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15898,'31203','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31604,'55953','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48426,'83321','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52464,'95127','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7921,'17963','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51478,'92781','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45064,'76634','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44228,'75490','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38311,'65669','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11938,'25557','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30438,'54447','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13492,'28306','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1685,'04772','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28660,'50674','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23887,'44817','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5311,'13460','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4124,'11249','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54455,'98507','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37728,'64740','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14767,'29933','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54668,'98933','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53436,'96776','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41391,'71172','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39313,'67466','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39045,'67038','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25441,'46959','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22048,'41524','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49779,'87319','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(55033,'99675','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1140,'03449','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(48829,'84083','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48316,'82943','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(23590,'44285','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24081,'45140','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7999,'18063','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14750,'29916','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32676,'57232','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37509,'64430','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32379,'56651','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2140,'06042','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22569,'42715','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45914,'77986','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48727,'83858','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36430,'62763','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51193,'92211','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48866,'84122','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(30162,'53952','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49968,'88039','Catron','35003','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(19472,'37337','Rhea','47143','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9436,'20790','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13735,'28542','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8783,'19562','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28653,'50671','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27868,'49955','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19705,'37764','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53838,'97408','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(37612,'64624','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19185,'37046','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46465,'78682','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19815,'37877','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17077,'33125','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4994,'12970','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40855,'70163','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7550,'17223','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2929,'07936','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48847,'84103','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(32464,'56748','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17731,'34217','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3032,'08086','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15575,'30678','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39826,'68139','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35419,'61469','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1329,'04024','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(46285,'78540','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52411,'95037','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40989,'70505','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50777,'91124','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50391,'89446','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(19376,'37190','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33752,'58654','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34094,'59324','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34274,'59647','Broadwater','30007','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13666,'28457','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37517,'64439','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5204,'13309','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35278,'61330','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33583,'58479','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30835,'54844','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48556,'83552','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47814,'80942','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45950,'78015','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45794,'77659','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42144,'72260','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24842,'46122','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25797,'47371','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35554,'61650','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53025,'95962','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45812,'77710','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25902,'47501','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22188,'41843','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10521,'23112','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18215,'35297','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6903,'16116','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13335,'28105','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19691,'37752','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49476,'85728','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48454,'83347','Lincoln','16063','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41994,'72078','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22566,'42712','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22584,'42721','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18002,'35022','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51942,'93744','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51128,'92121','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50117,'88511','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(43789,'74941','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4883,'12817','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38142,'65479','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40499,'68964','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41386,'71163','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14975,'30138','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3023,'08078','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41774,'71826','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36939,'63362','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44017,'75210','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1946,'05476','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11446,'24586','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23608,'44312','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39484,'67643','Decatur','20039','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40640,'69155','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9605,'21123','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13995,'28763','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4117,'11238','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9266,'20576','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30960,'54966','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21290,'40033','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(530,'01862','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33202,'58004','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27784,'49853','Luce','26095','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28441,'50529','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15017,'30170','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14490,'29581','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29627,'52778','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3675,'09865','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(5246,'13350','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23879,'44811','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23383,'44032','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45875,'77882','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1189,'03741','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27779,'49845','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45202,'76856','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20815,'39207','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12847,'27501','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30342,'54220','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7505,'17097','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(148,'00919','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14254,'29240','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2551,'06914','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44877,'76442','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50511,'90053','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34987,'60927','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29029,'51553','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42752,'73047','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5256,'13364','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26973,'48852','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2063,'05826','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19159,'37027','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1363,'04072','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23557,'44253','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5065,'13061','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12276,'26263','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43951,'75135','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33858,'58788','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52578,'95322','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52444,'95103','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(546,'01901','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(48312,'82938','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45484,'77327','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33904,'59008','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32011,'56289','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25922,'47527','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26399,'48145','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27355,'49326','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40505,'68969','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37779,'64784','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23218,'43768','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9698,'21278','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30643,'54643','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15530,'30641','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6983,'16238','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3655,'09832','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26418,'48167','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12989,'27610','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26415,'48165','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24683,'45876','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23421,'44073','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46646,'79005','Ochiltree','48357','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48832,'84086','Rich','49033','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53336,'96621','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1763,'04957','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(46075,'78155','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19767,'37845','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11039,'24053','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24400,'45621','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28821,'51055','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30092,'53817','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32638,'57109','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29283,'52237','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20129,'38352','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13077,'27821','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12711,'27260','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10656,'23292','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43068,'73642','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54527,'98592','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7430,'17033','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7394,'17009','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20040,'38229','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14835,'30034','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24762,'46047','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8440,'19020','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19669,'37726','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19038,'36767','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45148,'76712','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51246,'92283','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33283,'58068','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54429,'98439','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53198,'96155','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12334,'26347','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4225,'11576','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(612,'02062','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18581,'36027','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20304,'38577','Pickett','47137','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31300,'55402','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16557,'32336','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(319,'01242','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15308,'30446','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44751,'76240','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45569,'77410','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52405,'95031','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11720,'25139','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21837,'41031','Nicholas','21181','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23117,'43570','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26976,'48855','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29681,'53027','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17024,'33034','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4713,'12508','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43601,'74574','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51207,'92236','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37881,'65047','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3769,'10132','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50093,'88354','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45613,'77450','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42801,'73074','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28974,'51502','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29609,'52761','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3162,'08514','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12539,'26763','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26771,'48637','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49728,'87107','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50009,'88121','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51654,'93252','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3411,'09177','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49402,'85613','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48553,'83548','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42651,'72933','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25518,'47018','Ohio','18115','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28221,'50257','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5838,'14487','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8266,'18630','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15536,'30646','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40132,'68638','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11903,'25507','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32836,'57363','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32736,'57269','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24972,'46240','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3704,'10020','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5675,'14120','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54585,'98666','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30666,'54659','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9309,'20626','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39492,'67646','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12153,'26034','Hancock','54029','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5061,'13056','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20149,'38366','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2390,'06492','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19853,'37922','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40991,'70507','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44093,'75359','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45075,'76642','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38571,'66088','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21865,'41054','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48810,'84065','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48690,'83822','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42319,'72473','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28857,'51235','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30034,'53595','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15197,'30324','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30197,'54005','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34634,'60190','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52184,'94514','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43497,'74429','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22092,'41615','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20251,'38506','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17290,'33480','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36737,'63015','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1679,'04763','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44657,'76097','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44927,'76470','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48767,'84023','Daggett','49009','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(34818,'60532','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13943,'28720','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47768,'80862','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22340,'42206','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18509,'35957','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25583,'47126','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28120,'50170','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11245,'24316','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8132,'18360','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3316,'08858','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13016,'27658','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26163,'47921','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8215,'18473','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9815,'21673','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25435,'46952','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25205,'46705','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22085,'41603','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52319,'94806','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54838,'99224','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5498,'13787','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28065,'50139','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47783,'80911','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(21920,'41139','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21249,'39886','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9181,'20424','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(54457,'98509','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(194,'00979','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(40593,'69122','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23431,'44086','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2727,'07460','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35539,'61614','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49750,'87153','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(24508,'45717','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22545,'42602','Pickett','47137','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19002,'36736','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11321,'24441','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31631,'55972','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3043,'08094','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28413,'50484','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15905,'31210','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41955,'72045','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2342,'06416','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20226,'38476','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26198,'47948','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34375,'59853','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6750,'15848','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2870,'07833','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40334,'68823','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11320,'24440','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5855,'14512','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36705,'62976','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33235,'58038','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51244,'92281','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45596,'77435','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23539,'44231','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28069,'50141','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31686,'56027','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12069,'25846','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33645,'58549','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18473,'35812','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39240,'67360','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39791,'68104','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27566,'49644','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19439,'37318','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24058,'45118','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40273,'68771','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42217,'72377','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46286,'78541','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4547,'12201','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51126,'92119','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49744,'87123','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43094,'73661','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27682,'49745','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23876,'44811','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39125,'67120','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2631,'07076','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33818,'58758','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22179,'41832','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50894,'91436','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5737,'14228','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15033,'30179','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11348,'24479','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15632,'30753','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33474,'58374','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34431,'60004','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17440,'33708','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39136,'67133','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43958,'75143','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16164,'31743','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42275,'72436','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41679,'71647','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10501,'23089','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33901,'59004','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31792,'56116','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1896,'05359','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18132,'35175','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35721,'61870','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36661,'62943','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8284,'18655','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14823,'30025','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29411,'52501','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49459,'85710','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50431,'89704','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40106,'68627','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52328,'94913','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29857,'53208','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32324,'56580','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32339,'56590','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33166,'57763','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15835,'31072','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11365,'24502','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45967,'78028','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53030,'95966','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34266,'59639','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54967,'99605','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(44293,'75615','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25092,'46410','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23707,'44503','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28148,'50217','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20109,'38338','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11401,'24538','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32762,'57314','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37547,'64465','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38462,'65793','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17450,'33730','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16851,'32765','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32455,'56737','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11994,'25686','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19856,'37927','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27771,'49835','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24717,'45896','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54463,'98522','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38711,'66514','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32095,'56344','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(47509,'80403','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41870,'71959','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1165,'03580','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(574,'01961','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26258,'47989','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31861,'56165','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7035,'16334','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36987,'63439','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38211,'65605','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11862,'25403','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6806,'15946','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21059,'39630','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38199,'65588','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40239,'68748','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54725,'99032','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20252,'38506','White','47185','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37355,'64034','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3575,'09704','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(36591,'62899','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33720,'58640','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10871,'23845','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31657,'56001','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24711,'45894','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27551,'49633','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44344,'75669','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45156,'76801','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47861,'81040','Huerfano','8055','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48074,'81623','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51653,'93251','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51915,'93706','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54273,'98252','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41548,'71369','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33911,'59015','Musselshell','30065','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(54438,'98466','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49429,'85639','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(27810,'49879','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15235,'30358','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16505,'32245','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36788,'63061','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38815,'66720','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41264,'71001','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(393,'01471','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31402,'55581','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25186,'46615','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12086,'25873','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24306,'45381','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17603,'33935','Glades','12043','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51881,'93644','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45277,'76949','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27275,'49255','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11998,'25692','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37335,'64012','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39874,'68320','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5646,'14072','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33734,'58647','Hettinger','38041','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3188,'08543','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33522,'58429','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33353,'58238','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29955,'53536','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29641,'53003','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19736,'37811','Grainger','47057','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20942,'39429','Marion','28091','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29375,'52349','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26130,'47874','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48151,'82201','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5992,'14726','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29206,'52161','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9660,'21222','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12335,'26348','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36935,'63359','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37911,'65067','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41292,'71037','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41367,'71120','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33403,'58313','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29566,'52726','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27754,'49817','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51649,'93246','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7099,'16415','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4488,'12137','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47192,'79783','Martin','48317','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33261,'58053','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26580,'48390','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13507,'28320','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11037,'24043','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23078,'43532','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28901,'51350','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32822,'57353','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47554,'80467','Rio Blanco','8103','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(4750,'12546','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48433,'83330','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29639,'53002','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20975,'39465','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14965,'30127','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11550,'24846','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39680,'67878','Hamilton','20075','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24203,'45306','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7280,'16803','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29225,'52175','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51805,'93549','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45498,'77339','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44902,'76457','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42725,'73026','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14373,'29445','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7127,'16444','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12964,'27591','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12384,'26430','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54811,'99176','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39539,'67674','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7547,'17221','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50226,'89032','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(22451,'42370','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22908,'43318','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25622,'47164','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25782,'47359','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21358,'40111','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27132,'49050','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5811,'14468','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16403,'32127','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10820,'23693','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50312,'89157','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(16636,'32447','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39485,'67643','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32865,'57380','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33298,'58102','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33291,'58075','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53728,'97283','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46083,'78164','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12214,'26161','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13126,'27860','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13210,'27946','Chowan','37041','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35525,'61571','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35955,'62246','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18161,'35211','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18264,'35478','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1930,'05458','Grand Isle','50013','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(32258,'56525','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29104,'52001','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9992,'22044','Falls Church City','51610','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26681,'48472','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21302,'40047','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47433,'80221','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50796,'91210','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40805,'70085','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53423,'96762','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(9203,'20463','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30846,'54856','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38342,'65705','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10772,'23506','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39741,'68036','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12741,'27294','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20119,'38343','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30501,'54489','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42654,'72936','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51392,'92585','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51516,'92856','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3113,'08321','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11473,'24609','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24555,'45773','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26695,'48519','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15499,'30621','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31945,'56240','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32916,'57442','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18909,'36539','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39806,'68119','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7975,'18041','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25838,'47426','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8210,'18470','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9299,'20617','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24631,'45844','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23729,'44608','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34764,'60481','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19411,'37236','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37197,'63767','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38334,'65690','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39367,'67519','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4472,'12120','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34939,'60681','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53291,'96531','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(44465,'75852','Madison','48313','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12296,'26283','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2207,'06119','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2734,'07470','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14598,'29669','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4171,'11422','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1316,'04008','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33545,'58448','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16271,'31825','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17715,'34145','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34993,'60932','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18550,'35988','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29962,'53543','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28227,'50261','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8311,'18810','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8065,'18232','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42735,'73033','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43399,'74133','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48353,'83205','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36927,'63351','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50402,'89503','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(26566,'48370','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12324,'26337','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30315,'54177','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35809,'62014','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(214,'01011','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7205,'16659','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18495,'35907','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18782,'36322','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53807,'97373','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52933,'95824','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52720,'95488','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12093,'25882','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35778,'61938','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39163,'67156','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24460,'45678','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17495,'33802','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24361,'45441','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21288,'40032','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9291,'20609','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13162,'27888','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5462,'13740','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3144,'08362','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34686,'60424','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(55017,'99659','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(43500,'74432','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42420,'72611','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42210,'72372','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18533,'35975','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52834,'95648','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46750,'79079','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46103,'78220','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17452,'33732','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35623,'61754','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25735,'47331','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12905,'27540','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12425,'26534','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45288,'77002','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49680,'87026','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49707,'87051','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(39090,'67072','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6614,'15672','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55148,'99829','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53333,'96617','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52268,'94598','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3993,'10926','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13038,'27710','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52066,'94126','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24500,'45711','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23228,'43777','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22939,'43341','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30456,'54457','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38097,'65401','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20896,'39352','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53269,'96385','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(45434,'77251','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20603,'38930','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11618,'24981','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21683,'40601','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5059,'13053','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34020,'59215','McCone','30055','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15614,'30738','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42408,'72581','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48706,'83837','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53598,'97063','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4106,'11226','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10451,'23030','Charles City','51036','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49376,'85542','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(22003,'41332','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25796,'47370','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26544,'48334','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30138,'53935','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31472,'55736','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36540,'62869','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36869,'63141','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38267,'65637','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12604,'27028','Davie','37059','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(37122,'63630','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31334,'55432','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42140,'72225','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44376,'75705','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11307,'24426','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49249,'85256','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35271,'61323','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34212,'59485','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(39081,'67065','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19699,'37757','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15962,'31407','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18769,'36314','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41513,'71333','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20848,'39305','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21056,'39603','Lincoln','28085','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24268,'45346','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25944,'47550','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40671,'69169','Perkins','31135','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29781,'53120','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33098,'57652','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44468,'75853','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34704,'60439','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35218,'61258','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54714,'99023','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21186,'39813','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(650,'02136','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6847,'16033','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4395,'12025','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4285,'11754','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20328,'38603','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21501,'40336','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20714,'39095','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43125,'73722','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45227,'76874','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49161,'85068','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54595,'98682','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37407,'64084','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49129,'85028','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43413,'74155','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27656,'49723','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9666,'21225','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(901,'02771','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36922,'63348','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38000,'65260','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(330,'01258','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15924,'31302','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5900,'14549','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29575,'52733','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28476,'50554','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46317,'78576','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43242,'73950','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41157,'70725','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22685,'43032','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10806,'23662','Poquoson City','51735','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38183,'65564','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52991,'95932','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43866,'75048','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20372,'38641','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5717,'14208','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25304,'46792','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26506,'48272','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28426,'50518','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29736,'53075','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35254,'61310','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17564,'33885','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17675,'34092','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(39285,'67445','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3242,'08724','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23185,'43735','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22337,'42202','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5841,'14489','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44008,'75201','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11808,'25285','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50629,'90411','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49415,'85626','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(8806,'19710','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(37319,'63960','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38963,'66942','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5446,'13696','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41718,'71701','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1977,'05650','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(22775,'43113','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24770,'46051','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47955,'81155','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27242,'49232','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2240,'06183','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6532,'15544','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36158,'62440','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30766,'54765','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41007,'70518','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50403,'89504','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(9361,'20706','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36456,'62811','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50931,'91702','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47538,'80448','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45415,'77227','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23163,'43720','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28350,'50446','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36087,'62362','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36352,'62650','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10056,'22213','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13732,'28539','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9101,'20227','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35513,'61562','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19156,'37026','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21173,'39767','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24006,'45030','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53177,'96130','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44482,'75880','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12816,'27376','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51446,'92672','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7113,'16433','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32319,'56576','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32577,'57048','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7260,'16731','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37121,'63629','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5627,'14055','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3327,'08871','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1742,'04936','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9513,'20907','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33326,'58218','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24511,'45721','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17254,'33440','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44423,'75784','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45356,'77068','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53532,'97001','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50049,'88255','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48986,'84604','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11989,'25674','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6554,'15565','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6908,'16121','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1147,'03458','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(42845,'73117','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46477,'78712','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3978,'10912','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48436,'83333','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36973,'63430','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13378,'28138','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9269,'20579','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33989,'59086','Meagher','30059','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25614,'47150','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12031,'25727','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20907,'39361','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40067,'68505','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46292,'78549','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54801,'99164','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9031,'20146','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7321,'16860','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12547,'26808','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32530,'57021','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11538,'24828','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11506,'24714','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20676,'39061','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4923,'12862','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42528,'72738','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43932,'75114','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51210,'92241','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2573,'07015','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21993,'41301','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3083,'08234','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37418,'64098','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8797,'19611','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37817,'64859','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37287,'63934','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23606,'44310','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23598,'44302','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16490,'32232','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38171,'65556','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38772,'66605','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38826,'66736','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53634,'97119','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(28532,'50593','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3406,'09142','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6323,'15228','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39830,'68145','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45583,'77423','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50590,'90265','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30733,'54746','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14574,'29651','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13821,'28621','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26244,'47978','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8716,'19477','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2977,'08030','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13062,'27809','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5230,'13332','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6679,'15742','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43369,'74102','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17167,'33299','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21553,'40383','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40263,'68767','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49241,'85248','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54306,'98288','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54375,'98370','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13874,'28657','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6417,'15359','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41450,'71256','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41544,'71366','Tensas','22107','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43109,'73701','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35014,'60948','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20916,'39365','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21688,'40603','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39144,'67138','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49877,'87582','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(28160,'50226','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22306,'42140','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11527,'24813','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4648,'12438','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20017,'38182','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18151,'35201','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6805,'15946','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39070,'67058','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51821,'93584','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9713,'21402','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25859,'47443','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8996,'20112','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20265,'38549','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9852,'21747','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18991,'36703','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18691,'36131','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7198,'16652','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41922,'72025','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42169,'72332','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42576,'72821','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44241,'75496','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47689,'80733','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9396,'20745','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11409,'24550','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33002,'57537','Stanley','46117','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26296,'48033','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50421,'89555','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33563,'58463','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27590,'49665','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19653,'37714','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43321,'74054','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50251,'89081','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(28043,'50125','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25920,'47527','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3324,'08868','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22715,'43062','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4649,'12439','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15688,'30904','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28443,'50530','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37799,'64842','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8810,'19714','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(6698,'15764','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15983,'31510','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19309,'37140','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17582,'33910','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43868,'75050','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49418,'85629','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35308,'61354','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4726,'12523','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14008,'28776','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22523,'42519','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47713,'80757','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49258,'85266','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54835,'99219','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36872,'63144','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30067,'53788','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40030,'68448','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51582,'93066','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52391,'95012','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54333,'98327','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36688,'62961','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38484,'66007','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10195,'22560','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3122,'08332','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18879,'36502','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39603,'67801','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41989,'72074','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43577,'74553','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54553,'98621','Wahkiakum','53069','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11807,'25276','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37661,'64654','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29371,'52346','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4849,'12771','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1921,'05450','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(36773,'63044','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3250,'08736','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36249,'62531','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17052,'33072','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33646,'58552','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33612,'58503','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19100,'36867','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31718,'56052','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42103,'72168','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44868,'76436','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45235,'76882','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(390,'01468','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16767,'32655','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45031,'76570','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40436,'68926','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29483,'52580','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29487,'52584','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3726,'10043','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36198,'62463','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3088,'08244','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18919,'36550','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29460,'52563','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24649,'45856','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31463,'55731','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52372,'94975','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51700,'93313','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49616,'86431','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47144,'79730','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46740,'79068','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43072,'73646','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21716,'40763','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25562,'47115','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30647,'54646','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11062,'24070','Craig','51045','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11024,'24028','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40922,'70395','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52587,'95329','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14324,'29388','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50583,'90255','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48498,'83443','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43993,'75168','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43740,'74859','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41385,'71162','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9619,'21153','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24299,'45372','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8214,'18472','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(409,'01516','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19678,'37737','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3930,'10570','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44536,'75966','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47215,'79849','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51469,'92705','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21544,'40374','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54781,'99144','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53502,'96858','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(10687,'23345','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2233,'06155','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12022,'25718','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30682,'54701','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8808,'19712','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(12555,'26833','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2645,'07093','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9249,'20549','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(9783,'21644','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38331,'65689','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43388,'74126','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53373,'96706','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(55061,'99707','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(35877,'62078','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47240,'79922','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43654,'74735','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20030,'38220','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33397,'58282','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34856,'60561','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5605,'14033','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9505,'20901','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50965,'91755','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2483,'06784','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29324,'52314','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53962,'97633','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51780,'93518','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25522,'47022','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33294,'58078','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36542,'62869','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19595,'37620','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14121,'29070','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22060,'41542','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45994,'78060','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47920,'81122','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35636,'61772','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49623,'86438','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21710,'40744','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21937,'41164','Rowan','21205','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28161,'50226','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5135,'13140','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25807,'47382','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15239,'30361','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20220,'38474','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40516,'68977','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20715,'39095','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48957,'84511','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(19269,'37096','Perry','47135','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26108,'47855','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28174,'50233','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31217,'55342','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(310,'01226','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16956,'32924','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38552,'66067','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44604,'76049','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(725,'02341','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52573,'95319','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51205,'92234','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39062,'67052','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8054,'18218','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3518,'09566','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9122,'20265','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(34357,'59833','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25388,'46920','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3027,'08081','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18625,'36052','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20356,'38628','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54221,'98178','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51028,'91945','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50510,'90052','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40456,'68937','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23869,'44802','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20992,'39480','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33093,'57649','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54436,'98464','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53916,'97497','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51901,'93664','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26830,'48731','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29607,'52760','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29076,'51631','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5551,'13849','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20529,'38851','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27586,'49663','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40396,'68864','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8176,'18441','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13056,'27805','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53187,'96140','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11025,'24029','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16876,'32794','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12059,'25832','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25168,'46570','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34558,'60128','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(799,'02541','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9770,'21629','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(46684,'79035','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25049,'46360','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11687,'25086','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46152,'78266','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40252,'68758','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21825,'41014','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26185,'47933','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19046,'36782','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34244,'59544','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(18083,'35115','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33666,'58568','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27879,'49967','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50314,'89159','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(11160,'24177','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54389,'98383','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54095,'98005','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38095,'65360','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20330,'38606','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10356,'22905','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12104,'25913','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37383,'64067','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1116,'03287','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6116,'14861','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5898,'14547','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37900,'65061','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35210,'61250','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53917,'97498','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42647,'72930','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42015,'72099','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20096,'38328','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4241,'11697','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23353,'43981','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13653,'28448','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1753,'04947','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11157,'24175','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10136,'22463','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8371,'18925','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16144,'31719','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39050,'67042','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42621,'72858','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48385,'83244','Butte','16023','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(3599,'09730','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54344,'98337','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53254,'96365','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(13454,'28256','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18261,'35475','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21628,'40486','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43959,'75143','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53383,'96717','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(14908,'30094','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2210,'06126','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24712,'45895','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18438,'35760','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54582,'98663','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11377,'24515','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26079,'47833','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6344,'15253','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10427,'22989','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21063,'39633','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18444,'35764','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9797,'21657','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4583,'12244','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10839,'23805','Petersburg City','51730','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52308,'94708','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52912,'95758','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(750,'02381','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33165,'57762','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24567,'45786','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2334,'06409','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48736,'83868','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36774,'63045','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10156,'22507','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32558,'57037','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32040,'56312','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29074,'51630','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26505,'48269','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3631,'09805','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52552,'95267','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50246,'89061','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(24966,'46236','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44663,'76104','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46311,'78569','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2485,'06786','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37490,'64196','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2425,'06536','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5524,'13820','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20001,'38148','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21091,'39657','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26394,'48139','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21453,'40268','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45843,'77850','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6242,'15075','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12405,'26452','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22694,'43044','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21537,'40366','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17305,'33509','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46783,'79097','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33530,'58439','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7723,'17572','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22903,'43315','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21744,'40831','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39889,'68329','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43408,'74148','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53301,'96544','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53886,'97461','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10597,'23192','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37408,'64085','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36513,'62851','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11237,'24311','Smyth','51173','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23690,'44473','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49508,'85911','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42571,'72802','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20249,'38506','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14936,'30107','Pickens','13227','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13261,'28021','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50916,'91604','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52946,'95836','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53888,'97463','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34156,'59427','Glacier','30035','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30725,'54740','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2605,'07051','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27613,'49683','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19721,'37779','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27383,'49340','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22503,'42458','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23538,'44231','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23561,'44255','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39703,'68003','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42810,'73082','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8090,'18255','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14386,'29456','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33543,'58445','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11736,'25164','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19173,'37035','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26593,'48416','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29514,'52626','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28440,'50528','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4647,'12436','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21154,'39752','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50160,'88558','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(51917,'93708','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(386,'01462','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35152,'61080','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34427,'59936','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33948,'59052','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13460,'28265','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23475,'44127','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45412,'77224','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51380,'92561','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25802,'47374','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25009,'46295','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1033,'03084','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(23360,'43986','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20788,'39176','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36944,'63367','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46096,'78213','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40902,'70360','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38610,'66206','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36760,'63033','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10203,'22572','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49173,'85082','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51652,'93250','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14424,'29502','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8219,'18504','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15997,'31522','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38390,'65738','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44533,'75964','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48590,'83632','Washington','16087','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(28717,'50863','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9599,'21111','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32819,'57350','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2794,'07663','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28361,'50453','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7078,'16373','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51714,'93405','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54826,'99210','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3487,'09470','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(34729,'60457','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43973,'75154','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52524,'95228','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35816,'62019','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11777,'25244','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2902,'07876','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8111,'18334','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5612,'14038','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25552,'47106','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24121,'45203','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23748,'44621','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21896,'41094','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21711,'40744','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51835,'93606','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33797,'58740','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15332,'30461','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14792,'30006','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26793,'48657','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18619,'36049','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47123,'79706','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53154,'96107','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12350,'26376','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12374,'26416','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13026,'27701','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15900,'31205','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31336,'55434','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30758,'54759','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29508,'52621','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28829,'51061','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22112,'41651','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39187,'67223','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45150,'76715','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50347,'89404','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52572,'95318','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32844,'57367','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30904,'54923','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10448,'23024','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41237,'70817','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9831,'21713','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9339,'20676','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9235,'20534','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(27492,'49507','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38994,'66967','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48246,'82639','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54500,'98562','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24394,'45616','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41880,'71970','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41960,'72048','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43111,'73703','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54747,'99115','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(132,'00851','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(8542,'19127','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28475,'50552','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7774,'17747','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3570,'09648','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(42473,'72662','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52113,'94245','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35701,'61852','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3783,'10161','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11094,'24102','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40653,'69161','Thomas','31171','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44386,'75751','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44988,'76531','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48125,'82051','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(1461,'04330','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31320,'55421','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40262,'68766','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47864,'81043','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2897,'07869','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12663,'27199','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41793,'71840','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45823,'77807','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53393,'96729','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(31534,'55807','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11877,'25427','Morgan','54065','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27595,'49668','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6101,'14846','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5547,'13845','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5208,'13313','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16295,'31907','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19509,'37363','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42564,'72770','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42648,'72932','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1509,'04429','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10371,'22924','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7503,'17093','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2825,'07732','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24440,'45658','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22636,'42788','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40606,'69133','Kimball','31105','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51593,'93109','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31156,'55305','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2700,'07418','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22729,'43068','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17327,'33544','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4480,'12130','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37671,'64659','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41596,'71435','Caldwell','22021','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42944,'73446','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44064,'75263','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7037,'16340','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14591,'29662','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31514,'55784','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29291,'52245','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20939,'39426','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4796,'12603','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45770,'77619','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46812,'79120','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37071,'63547','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34543,'60116','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38839,'66749','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45103,'76666','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51055,'92021','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53880,'97455','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(13997,'28766','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10876,'23847','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(807,'02557','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33423,'58330','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32241,'56514','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21840,'41033','Pendleton','21191','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6184,'15014','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38027,'65284','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44291,'75607','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12838,'27427','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36701,'62972','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29856,'53207','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25055,'46368','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23878,'44811','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39051,'67045','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49380,'85546','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(16410,'32133','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19203,'37055','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31112,'55110','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20978,'39466','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40714,'69340','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44740,'76230','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45675,'77498','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50072,'88330','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52978,'95919','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29758,'53095','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26071,'47805','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38511,'66031','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44438,'75803','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48197,'82412','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51783,'93523','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36917,'63345','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4314,'11788','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31072,'55070','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3526,'09576','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12120,'25943','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16656,'32465','Gulf','12045','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49299,'85327','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36967,'63388','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33606,'58495','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26234,'47970','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20651,'39038','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(656,'02142','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12979,'27601','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9551,'21041','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2439,'06614','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30444,'54451','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(767,'02461','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17085,'33133','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23537,'44230','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19394,'37215','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43875,'75054','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30472,'54466','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11563,'24862','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16815,'32719','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30307,'54170','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41122,'70652','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47294,'80004','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37046,'63531','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5166,'13165','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32645,'57198','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17658,'34033','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(22229,'42040','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27512,'49555','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44667,'76108','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49441,'85653','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4977,'12949','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48665,'83729','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48980,'84540','Grand','49019','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(7479,'17072','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54224,'98188','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50901,'91502','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48273,'82729','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(52908,'95742','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1435,'04260','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2749,'07511','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52322,'94820','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52351,'94947','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(291,'01118','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5862,'14517','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30889,'54911','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14674,'29808','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20997,'39482','Lamar','28073','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8594,'19192','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19011,'36748','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5886,'14536','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37920,'65075','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35084,'61028','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30264,'54129','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39221,'67346','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45260,'76932','Reagan','48383','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1146,'03457','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(11467,'24604','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1875,'05262','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(33301,'58105','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10640,'23261','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7558,'17233','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29853,'53204','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39107,'67110','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41858,'71944','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49175,'85085','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51219,'92252','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9265,'20575','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35432,'61475','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28009,'50104','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23167,'43723','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22155,'41764','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19742,'37816','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40575,'69042','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31391,'55570','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46162,'78285','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51233,'92267','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35194,'61232','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35234,'61273','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22847,'43202','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41420,'71232','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43358,'74080','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51087,'92067','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54580,'98661','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32094,'56343','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25847,'47433','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25052,'46365','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24063,'45121','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42241,'72403','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13864,'28650','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9105,'20232','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(6329,'15234','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38648,'66407','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47368,'80120','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27646,'49716','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8148,'18416','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18343,'35584','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5012,'12992','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2265,'06250','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6435,'15401','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40339,'68823','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34646,'60203','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11376,'24514','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2983,'08036','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34865,'60572','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54571,'98643','Wahkiakum','53069','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7438,'17041','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47732,'80816','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47563,'80475','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46572,'78852','Maverick','48323','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45492,'77333','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8540,'19125','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13901,'28681','Alexander','37003','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28798,'51041','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16525,'32308','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40663,'69166','Thomas','31171','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1171,'03586','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(38088,'65351','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37150,'63655','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6787,'15926','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14596,'29667','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14402,'29472','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20858,'39325','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51058,'92024','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9289,'20607','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5703,'14168','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6121,'14867','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52252,'94580','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44349,'75672','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25224,'46730','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5391,'13639','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29885,'53263','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50069,'88323','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50370,'89427','Mineral','32021','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(21385,'40157','Meade','21163','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3807,'10213','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5428,'13677','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29690,'53036','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12355,'26384','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33213,'58016','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34651,'60301','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36073,'62352','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2662,'07112','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36845,'63123','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15515,'30629','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24037,'45069','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3881,'10505','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44682,'76122','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43558,'74530','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43175,'73762','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30045,'53707','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29865,'53216','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34806,'60521','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18354,'35602','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3421,'09237','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35688,'61845','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1459,'04292','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14282,'29332','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30310,'54173','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21565,'40391','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2810,'07716','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36040,'62316','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52125,'94261','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49627,'86442','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43626,'74646','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22895,'43306','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25357,'46869','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30574,'54557','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40536,'69001','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41697,'71663','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8399,'18957','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17925,'34762','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5779,'14428','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52618,'95366','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37026,'63464','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30837,'54846','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47483,'80266','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15883,'31136','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19088,'36859','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19954,'38075','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18995,'36721','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21791,'40958','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40719,'69343','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3689,'10004','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50748,'91023','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49335,'85363','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46035,'78117','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43942,'75124','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43459,'74352','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39275,'67437','Smith','20183','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(21661,'40526','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10552,'23140','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16172,'31750','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4292,'11763','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40978,'70464','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(15675,'30823','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9813,'21671','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14600,'29670','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13431,'28226','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12025,'25721','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51418,'92620','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31068,'55067','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26518,'48307','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33515,'58424','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36489,'62835','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39566,'67741','Sherman','20181','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40118,'68633','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19494,'37355','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43752,'74867','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23649,'44425','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22541,'42566','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(219,'01014','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32610,'57068','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13863,'28650','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16470,'32210','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41471,'71277','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39,'00670','Las Marias','72083','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(17189,'33322','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15660,'30816','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28700,'50851','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10971,'23959','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26705,'48556','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44335,'75662','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52339,'94929','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40966,'70453','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3243,'08724','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54405,'98402','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25577,'47124','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34918,'60651','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17595,'33922','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14131,'29079','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31321,'55421','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26084,'47836','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21487,'40322','Menifee','21165','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44597,'76041','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54925,'99549','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(715,'02330','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22115,'41659','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11132,'24141','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13198,'27929','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48774,'84031','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(8343,'18844','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48133,'82060','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(14345,'29418','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5181,'13212','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6510,'15501','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34202,'59469','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1582,'04571','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3959,'10610','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10705,'23408','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43738,'74859','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45014,'76557','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL);
INSERT INTO `ZipCodeMultiCounty` VALUES (45863,'77871','Madison','48313','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53364,'96682','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(42262,'72426','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43131,'73728','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23075,'43531','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6319,'15224','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26253,'47986','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31894,'56208','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36374,'62671','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16650,'32462','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18135,'35178','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40897,'70356','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35970,'62256','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32081,'56338','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2090,'05859','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27598,'49674','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25209,'46710','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42724,'73026','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47422,'80212','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20221,'38474','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27904,'50020','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19107,'36874','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6756,'15856','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21151,'39751','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6558,'15610','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6297,'15202','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15091,'30234','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2318,'06379','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44276,'75573','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48418,'83311','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48631,'83672','Washington','16087','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40717,'69341','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37140,'63648','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31995,'56279','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16870,'32789','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14861,'30055','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8776,'19551','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2732,'07463','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2556,'06926','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45783,'77639','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50086,'88347','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(18658,'36087','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40091,'68583','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34066,'59270','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34897,'60626','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47535,'80444','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43859,'75043','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23596,'44288','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21522,'40353','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6834,'16020','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(578,'01970','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14624,'29691','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7928,'17970','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39159,'67154','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39860,'68309','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16545,'32327','Wakulla','12129','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33729,'58645','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31577,'55933','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36305,'62573','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38495,'66016','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49453,'85704','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29061,'51576','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23484,'44136','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10757,'23466','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10231,'22637','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2142,'06043','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16142,'31714','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7091,'16407','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4714,'12510','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16749,'32626','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16541,'32322','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2783,'07647','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28872,'51246','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45719,'77546','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46920,'79339','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50379,'89435','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(39694,'67952','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36402,'62693','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27068,'49005','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29140,'52053','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22449,'42368','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30262,'54127','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31681,'56024','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8525,'19110','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1975,'05648','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14716,'29845','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31737,'56068','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(42871,'73141','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44256,'75556','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45905,'77977','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54207,'98154','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6924,'16134','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48713,'83845','Boundary','16021','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(5455,'13734','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3375,'09058','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9184,'20427','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(24113,'45171','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36685,'62959','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4819,'12740','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40876,'70190','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50921,'91609','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31148,'55172','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25231,'46733','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40158,'68658','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21986,'41265','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14757,'29923','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11055,'24064','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13882,'28665','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40581,'69045','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22509,'42462','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37344,'64020','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34159,'59432','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28553,'50604','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4927,'12866','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11345,'24474','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18319,'35570','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8206,'18465','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27650,'49719','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20250,'38506','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51500,'92831','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53973,'97702','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30883,'54903','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50001,'88115','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44691,'76132','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30735,'54747','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34776,'60503','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29490,'52585','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3580,'09709','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26369,'48113','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20551,'38868','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4024,'10974','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54810,'99174','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45559,'77389','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21419,'40216','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39017,'67020','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46273,'78516','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10396,'22952','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26911,'48815','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7301,'16839','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37491,'64197','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16281,'31831','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31144,'55166','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4674,'12465','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26795,'48658','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12165,'26056','Hancock','54029','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47145,'79731','Crane','48103','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40981,'70467','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47728,'80814','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22267,'42078','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38968,'66945','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12262,'26238','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18415,'35742','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11719,'25136','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35151,'61080','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22111,'41650','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6880,'16057','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46570,'78850','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45215,'76865','Runnels','48399','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1696,'04786','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21329,'40066','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30839,'54848','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19052,'36785','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35642,'61776','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30529,'54519','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40977,'70463','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46838,'79226','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42303,'72460','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28419,'50514','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28523,'50585','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35888,'62082','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37110,'63625','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37968,'65233','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12174,'26075','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19183,'37043','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40974,'70461','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11973,'25649','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2311,'06372','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43888,'75069','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46461,'78676','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46914,'79331','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49692,'87040','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53495,'96847','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(1903,'05403','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(51759,'93458','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47522,'80430','Jackson','8057','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42918,'73402','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30614,'54623','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35252,'61299','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(933,'02833','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(9416,'20769','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47408,'80166','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48332,'83114','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54241,'98221','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2183,'06090','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45787,'77643','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11829,'25323','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12876,'27519','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34506,'60081','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4083,'11203','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39435,'67575','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17219,'33404','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7375,'16941','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34228,'59526','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33425,'58330','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11351,'24483','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48330,'83112','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48569,'83610','Washington','16087','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52284,'94615','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49457,'85708','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(8331,'18830','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54122,'98033','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48251,'82646','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(27115,'49038','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23442,'44094','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35285,'61334','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13385,'28150','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41154,'70722','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31474,'55741','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29175,'52132','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(787,'02493','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(55140,'99811','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48025,'81413','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46144,'78258','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21158,'39754','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41606,'71447','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53631,'97116','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49395,'85607','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(966,'02886','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(26092,'47841','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26707,'48601','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14361,'29433','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33742,'58650','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37931,'65081','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41148,'70712','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7153,'16563','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41671,'71642','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18897,'36524','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14052,'29006','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10543,'23128','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11558,'24855','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51132,'92126','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38872,'66776','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16976,'32955','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49056,'84736','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27084,'49015','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27588,'49664','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24760,'46044','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38166,'65550','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6341,'15250','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40997,'70512','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(572,'01952','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32770,'57319','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5518,'13812','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10141,'22473','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47079,'79548','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41830,'71913','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16280,'31831','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53145,'96096','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51466,'92702','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47578,'80501','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44035,'75229','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5929,'14592','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6446,'15421','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23864,'44750','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24667,'45867','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13780,'28582','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34986,'60926','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41229,'70809','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7753,'17723','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1939,'05468','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(31636,'55974','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2053,'05776','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12561,'26847','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12931,'27562','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8932,'20037','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(41293,'71038','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38925,'66861','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14931,'30105','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34794,'60512','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41243,'70823','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(55144,'99824','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46896,'79313','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42492,'72685','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28085,'50150','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27284,'49264','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17569,'33897','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47019,'79510','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11831,'25325','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33621,'58523','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4517,'12167','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26040,'47713','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23954,'44864','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25028,'46324','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25078,'46391','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42858,'73128','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18214,'35296','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43063,'73628','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22009,'41348','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28490,'50562','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4736,'12533','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35415,'61466','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33573,'58472','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2671,'07195','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44566,'76010','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46834,'79225','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54738,'99105','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42194,'72354','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17734,'34220','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49759,'87190','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(24571,'45789','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27740,'49797','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28281,'50325','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31722,'56056','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11499,'24651','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15205,'30331','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38570,'66087','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31812,'56131','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43106,'73669','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46493,'78727','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49088,'84771','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49955,'88024','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(28205,'50249','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54754,'99121','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53353,'96669','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(45558,'77388','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44765,'76253','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44620,'76060','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20266,'38549','Pickett','47137','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36051,'62329','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37667,'64657','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41834,'71921','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19412,'37238','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5644,'14070','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22988,'43431','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20905,'39360','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54538,'98605','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16002,'31532','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30936,'54947','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31829,'56143','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35265,'61320','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35309,'61354','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29800,'53142','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4470,'12118','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20329,'38606','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25945,'47551','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46565,'78840','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52811,'95626','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19728,'37803','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50910,'91522','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46795,'79106','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42655,'72937','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9857,'21756','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5423,'13672','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17393,'33619','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35945,'62238','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6945,'16157','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46156,'78270','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51171,'92174','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39745,'68038','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53871,'97447','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45659,'77486','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44139,'75422','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43158,'73753','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33450,'58352','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24834,'46117','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24573,'45801','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17134,'33184','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41005,'70518','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8983,'20104','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6574,'15623','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16233,'31796','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26856,'48747','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31208,'55339','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10349,'22902','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45511,'77351','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24427,'45651','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15147,'30286','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7036,'16335','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18916,'36547','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3799,'10177','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30328,'54208','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28001,'50076','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24727,'46012','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46649,'79009','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40123,'68636','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4384,'12010','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53158,'96111','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50876,'91395','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50127,'88521','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(48819,'84072','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(44402,'75760','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43414,'74156','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12167,'26059','Ohio','54069','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27096,'49022','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19894,'38018','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7755,'17724','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25709,'47283','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18155,'35205','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17560,'33881','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43732,'74856','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50154,'88550','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(52386,'95007','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34181,'59453','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20117,'38342','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21012,'39530','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11485,'24630','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19386,'37209','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19118,'36908','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28061,'50137','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21654,'40515','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19782,'37853','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29109,'52031','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28328,'50430','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22162,'41776','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16050,'31566','Brantley','13025','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50562,'90213','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52820,'95633','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25870,'47452','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28107,'50161','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31825,'56140','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(55075,'99726','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25017,'46307','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(845,'02653','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37479,'64170','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7530,'17129','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17532,'33849','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22836,'43157','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27046,'48911','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8190,'18452','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37549,'64466','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46955,'79364','Garza','48169','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20944,'39437','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35134,'61068','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25183,'46601','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33204,'58006','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33004,'57540','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30041,'53703','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30169,'53956','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38655,'66412','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54211,'98161','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53273,'96389','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53170,'96123','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51422,'92626','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48554,'83548','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(35009,'60944','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31119,'55116','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30139,'53936','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7197,'16651','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18361,'35612','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20413,'38673','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34722,'60450','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31466,'55733','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36731,'63011','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53601,'97065','Sherman','41055','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53577,'97040','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51267,'92322','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46404,'78642','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29386,'52356','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17763,'34260','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17262,'33448','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15904,'31209','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43493,'74426','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38009,'65265','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2945,'07979','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(43080,'73651','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7621,'17327','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5727,'14218','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3864,'10466','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36665,'62947','Hardin','17069','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29527,'52640','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5390,'13638','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5932,'14604','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5415,'13664','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9712,'21401','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34516,'60089','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11757,'25205','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23254,'43821','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26323,'48064','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29184,'52140','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7615,'17321','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37692,'64679','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17644,'34002','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(7516,'17109','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7728,'17579','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45042,'76596','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40584,'69101','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6415,'15357','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44542,'75972','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17001,'33011','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18628,'36054','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12808,'27360','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20704,'39090','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14670,'29802','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14813,'30018','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12568,'26852','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34642,'60197','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1701,'04847','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29023,'51550','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13595,'28392','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49978,'88049','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(16935,'32887','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53679,'97208','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49295,'85323','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47986,'81243','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2040,'05763','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20746,'39140','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24895,'46162','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13603,'28401','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15303,'30442','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37809,'64850','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4662,'12454','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31061,'55057','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25080,'46393','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10822,'23696','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3053,'08104','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1473,'04348','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45695,'77520','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43714,'74843','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19281,'37110','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37850,'65020','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3836,'10302','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7098,'16413','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29543,'52650','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35577,'61725','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18734,'36269','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47506,'80402','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47264,'79944','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41853,'71942','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27077,'49011','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6085,'14836','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3432,'09306','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(705,'02301','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6812,'15953','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14155,'29114','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8354,'18901','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48252,'82648','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(41220,'70792','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40504,'68967','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24968,'46236','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36401,'62693','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(648,'02134','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29430,'52542','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(26355,'48097','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51391,'92584','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7799,'17772','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4866,'12788','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43893,'75076','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26670,'48464','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16124,'31703','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34831,'60543','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5692,'14140','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37727,'64740','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(844,'02652','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31250,'55370','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26278,'48006','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12982,'27603','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21369,'40129','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45948,'78015','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34257,'59631','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(53424,'96763','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(20660,'39045','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24132,'45215','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14080,'29037','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8599,'19197','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14580,'29654','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5981,'14716','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6090,'14838','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(193,'00978','Trujillo Alto','72139','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(32229,'56481','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14536,'29626','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25632,'47172','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20913,'39365','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49075,'84756','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37113,'63626','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45694,'77520','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20599,'38928','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24890,'46160','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25380,'46915','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18178,'35229','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23198,'43750','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10184,'22547','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53847,'97417','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54903,'99509','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(40821,'70117','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47309,'80018','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2364,'06456','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33109,'57702','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9579,'21082','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38451,'65785','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39523,'67661','Rooks','20163','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11856,'25387','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2714,'07438','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16583,'32395','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32450,'56734','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(1078,'03244','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(44636,'76071','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42712,'73017','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25906,'47513','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27576,'49654','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11342,'24472','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11849,'25358','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19331,'37151','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3050,'08101','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4094,'11214','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9956,'21913','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8168,'18434','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21359,'40115','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(753,'02421','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19178,'37037','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54850,'99323','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50147,'88543','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(23320,'43943','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32898,'57432','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35680,'61840','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37194,'63764','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38082,'65349','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7835,'17830','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34100,'59333','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(9021,'20136','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33040,'57576','Jones','46075','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16975,'32954','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21492,'40328','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14174,'29129','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14322,'29386','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15894,'31195','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18407,'35673','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44646,'76086','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49907,'87746','Harding','35021','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(15568,'30671','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9558,'21047','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27532,'49620','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11577,'24882','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26146,'47905','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18385,'35647','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46787,'79098','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48448,'83342','Cassia','16031','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53817,'97383','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36125,'62420','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36252,'62534','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8634,'19353','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11579,'24887','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28397,'50475','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28317,'50421','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48518,'83465','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29746,'53085','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21855,'41044','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6146,'14883','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12348,'26374','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5858,'14513','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45970,'78039','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48045,'81432','Ouray','8091','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52629,'95377','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(507,'01821','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1546,'04481','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27506,'49534','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21165,'39759','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19013,'36749','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44560,'76005','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52604,'95351','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34494,'60069','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31924,'56224','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20067,'38261','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49099,'84784','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52750,'95545','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54728,'99034','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13697,'28510','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35697,'61850','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28335,'50434','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24938,'46206','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16542,'32323','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39473,'67635','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53643,'97127','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53948,'97601','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(22042,'41514','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21548,'40379','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17469,'33760','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39113,'67114','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52657,'95416','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38423,'65765','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17754,'34240','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45748,'77581','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20210,'38464','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8736,'19507','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16491,'32233','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43762,'74873','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44090,'75356','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48540,'83537','Nez Perce','16069','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51707,'93387','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29241,'52209','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2411,'06516','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35055,'60974','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14558,'29642','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15272,'30417','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11266,'24343','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17750,'34236','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19716,'37774','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46095,'78212','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21835,'41031','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(106,'00780','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(999,'03032','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35718,'61865','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9520,'20914','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8779,'19554','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10394,'22949','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5571,'14001','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43137,'73731','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51268,'92323','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38747,'66540','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13626,'28430','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12962,'27589','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10769,'23503','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30745,'54755','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40930,'70421','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41398,'71211','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5723,'14214','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53564,'97031','Hood River','41027','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54358,'98353','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14013,'28781','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13622,'28424','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49238,'85244','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51882,'93645','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52611,'95358','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32977,'57521','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32817,'57349','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18561,'36009','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15971,'31416','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34915,'60646','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4791,'12592','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28546,'50601','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28442,'50530','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18867,'36475','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7204,'16657','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6186,'15017','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42685,'73002','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42760,'73051','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51015,'91915','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53786,'97352','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4428,'12061','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33834,'58770','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19481,'37343','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41725,'71722','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(55130,'99784','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53507,'96898','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(50869,'91385','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49621,'86436','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43848,'75032','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9802,'21660','Caroline','24011','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8204,'18464','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35440,'61479','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6731,'15825','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4862,'12784','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27781,'49848','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20605,'38935','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38904,'66846','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40489,'68957','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54271,'98251','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30673,'54665','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11168,'24202','Bristol City','51520','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8034,'18102','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27125,'49045','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24785,'46063','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12224,'26170','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28432,'50522','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41720,'71711','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52158,'94303','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31660,'56006','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14595,'29666','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17631,'33972','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21666,'40550','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29741,'53079','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26845,'48741','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(351,'01346','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52014,'94025','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26501,'48265','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38285,'65650','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35372,'61432','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32544,'57030','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32465,'56748','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6611,'15668','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22335,'42201','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29121,'52038','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28083,'50149','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41879,'71969','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42990,'73528','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15967,'31411','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30793,'54813','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50236,'89044','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50272,'89117','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53734,'97294','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14706,'29838','McCormick','45065','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22362,'42234','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46409,'78644','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55069,'99720','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30018,'53583','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26052,'47728','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39337,'67484','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39942,'68362','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41304,'71048','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49836,'87529','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(46658,'79014','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20622,'38953','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40576,'69043','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43660,'74741','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16187,'31768','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15987,'31515','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12509,'26690','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24004,'45015','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49771,'87305','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(3179,'08534','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45464,'77289','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44375,'75704','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43168,'73758','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34063,'59262','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30539,'54529','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54794,'99157','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33149,'57750','Bennett','46007','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22430,'42348','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34978,'60919','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33198,'57794','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16911,'32833','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6187,'15017','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25323,'46806','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21124,'39730','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20057,'38254','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17265,'33455','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4101,'11221','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12217,'26162','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32135,'56376','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28522,'50583','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15099,'30240','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11258,'24327','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30639,'54640','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16741,'32617','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18856,'36461','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39793,'68106','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47974,'81228','Lake','8065','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50101,'88417','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54602,'98802','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37216,'63785','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1488,'4402','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6384,'15322','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34721,'60450','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33748,'58653','Bowman','38011','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33021,'57560','Bennett','46007','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39528,'67665','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40060,'68466','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53466,'96809','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(15267,'30413','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6656,'15720','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15009,'30163','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5721,'14212','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54724,'99031','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(814,'02564','Nantucket','25019','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35391,'61448','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31412,'55591','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25946,'47552','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3193,'08554','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11117,'24129','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43941,'75123','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50207,'89013','Esmeralda','32009','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51555,'93013','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5581,'14009','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26615,'48429','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39262,'67427','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39832,'68147','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46863,'79245','Childress','48075','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4363,'11963','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13887,'28670','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37847,'65017','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31908,'56216','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47989,'81248','Saguache','8109','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49780,'87320','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(32145,'56382','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28115,'50167','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49642,'86514','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(12205,'26150','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10510,'23102','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40097,'68602','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18100,'35128','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16863,'32778','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6954,'16211','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16526,'32309','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26172,'47926','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23497,'44149','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22079,'41567','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38304,'65662','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38971,'66948','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41964,'72055','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43525,'74452','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45142,'76706','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46714,'79053','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50115,'88439','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51530,'92871','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53546,'97014','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53747,'97310','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6799,'15940','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6501,'15482','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23807,'44666','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19282,'37110','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42598,'72841','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43509,'74436','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46171,'78297','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13980,'28752','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22987,'43430','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50883,'91406','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27800,'49871','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27361,'49329','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1331,'04028','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24763,'46048','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40146,'68647','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46372,'78622','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46877,'79252','Cottle','48101','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6709,'15774','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45433,'77249','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45289,'77003','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44936,'76475','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42222,'72386','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4773,'12574','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33765,'58711','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(594,'02038','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42524,'72734','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46953,'79363','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47032,'79519','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45309,'77023','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13036,'27708','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12040,'25775','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32910,'57438','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26937,'48832','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20667,'39054','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5460,'13738','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40818,'70114','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48129,'82054','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37993,'65256','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5925,'14589','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29582,'52739','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24044,'45105','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9,'00610','Anasco','72011','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(36143,'62427','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30305,'54169','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4858,'12780','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21408,'40205','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45196,'76853','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47985,'81242','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52223,'94551','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38239,'65620','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39923,'68348','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47142,'79720','Sterling','48431','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51949,'93764','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22630,'42776','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1452,'04285','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20386,'38650','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35665,'61820','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34320,'59752','Jefferson','30043','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32008,'56288','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30711,'54734','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12189,'26137','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19932,'38054','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26457,'48204','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4738,'12534','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7141,'16514','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54213,'98165','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53044,'95977','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11922,'25526','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15999,'31524','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15949,'31324','Bryan','13029','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4332,'11854','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24474,'45686','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23798,'44657','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32019,'56294','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31453,'55720','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12137,'25979','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40000,'68423','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41917,'72023','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32126,'56367','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45138,'76702','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(809,'02559','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36278,'62550','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33181,'57780','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14808,'30015','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25144,'46550','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6671,'15733','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19676,'37733','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2026,'05745','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5226,'13329','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42161,'72326','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37897,'65058','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52923,'95814','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11468,'24605','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6400,'15338','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14893,'30082','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22968,'43402','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34840,'60549','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29611,'52765','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27510,'49546','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26928,'48827','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25378,'46914','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22355,'42220','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44394,'75756','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49782,'87321','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52863,'95677','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14864,'30056','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4197,'11530','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8177,'18443','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53733,'97293','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51353,'92513','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51275,'92329','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44609,'76050','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40644,'69156','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30524,'54514','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20333,'38610','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16750,'32627','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1456,'04289','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7418,'17023','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41687,'71657','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47859,'81039','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20034,'38223','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43170,'73759','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44301,'75638','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48670,'83799','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36404,'62694','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13010,'27634','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34683,'60423','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25178,'46580','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28259,'50306','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52852,'95667','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10244,'22650','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35001,'60939','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12098,'25904','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4462,'12095','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35504,'61554','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29148,'52064','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38160,'65543','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43619,'74637','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46226,'78383','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2516,'06851','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(13113,'27850','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8731,'19504','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16207,'31781','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37558,'64474','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31702,'56042','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31170,'55317','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26638,'48442','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20819,'39210','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17118,'33167','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46227,'78383','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46558,'78834','Dimmit','48127','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53498,'96850','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(14875,'30066','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32625,'57076','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2225,'06145','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24975,'46242','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33947,'59050','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3058,'08109','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1537,'04471','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(26068,'47803','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21119,'39702','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24891,'46160','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22546,'42602','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39208,'67335','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47316,'80021','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49679,'87026','Cibola','35006','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(6873,'16054','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27836,'49910','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38070,'65340','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33628,'58530','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15771,'31036','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20046,'38235','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18725,'36262','Cleburne','1029','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7736,'17602','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51612,'93206','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15769,'31035','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13045,'27715','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30945,'54956','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6335,'15240','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11234,'24292','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26142,'47901','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(344,'01338','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13771,'28578','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20646,'38966','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20300,'38574','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19773,'37847','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31002,'55007','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8283,'18654','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36934,'63359','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33873,'58802','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33228,'58033','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29478,'52574','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24404,'45623','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10608,'23224','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12997,'27617','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18596,'36034','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50216,'89022','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(12614,'27043','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(12180,'26106','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20305,'38578','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52017,'94028','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37398,'64078','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31271,'55384','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29235,'52207','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1550,'04489','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(27508,'49544','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20820,'39211','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21776,'40930','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9947,'21874','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35332,'61375','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10352,'22903','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27083,'49014','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23261,'43828','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20918,'39366','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3937,'10579','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42834,'73106','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44985,'76530','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48848,'84104','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(14103,'29055','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3942,'10588','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22806,'43142','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42739,'73038','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16946,'32907','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19502,'37359','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16360,'32079','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32667,'57224','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11825,'25317','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25114,'46524','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1702,'04848','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16386,'32110','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22393,'42288','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40591,'69122','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40635,'69151','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8453,'19034','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47884,'81059','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48878,'84134','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51354,'92514','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51403,'92602','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(738,'02358','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3896,'10519','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32784,'57328','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21343,'40076','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47494,'80301','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50432,'89705','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50447,'89822','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(38238,'65620','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22170,'41817','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49472,'85723','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54666,'98930','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32551,'57034','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:53',NULL,NULL),(573,'01960','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33225,'58031','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5860,'14515','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28013,'50106','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25731,'47327','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38189,'65567','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22610,'42748','Larue','21123','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46218,'78376','Duval','48131','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30908,'54927','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15781,'31038','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20254,'38541','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10100,'22401','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1489,'04406','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(32590,'57054','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45122,'76686','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10135,'22460','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35951,'62243','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24387,'45612','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24154,'45238','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24019,'45044','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23883,'44814','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15082,'30230','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14896,'30084','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3164,'08515','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23143,'43657','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2222,'06142','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2501,'06813','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52256,'94585','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9843,'21727','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7274,'16748','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39456,'67623','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41863,'71952','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14989,'30146','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2797,'07675','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18613,'36045','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18794,'36345','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5002,'12979','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4770,'12570','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3002,'08056','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20447,'38738','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40385,'68859','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1315,'04007','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15231,'30354','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36452,'62809','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34248,'59547','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31010,'55014','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27407,'49402','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27076,'49011','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5189,'13224','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32073,'56333','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26977,'48856','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46988,'79408','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47736,'80818','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52621,'95369','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36114,'62411','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6102,'14847','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50024,'88136','De Baca','35011','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(10068,'22241','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52597,'95343','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51375,'92553','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42339,'72517','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40870,'70183','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20202,'38460','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27828,'49895','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15618,'30740','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32614,'57070','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4544,'12196','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13364,'28127','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32029,'56304','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28986,'51527','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46418,'78652','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50909,'91521','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1193,'03748','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(49581,'86323','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48559,'83555','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(28606,'50641','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23988,'44904','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1960,'05492','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9290,'20608','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15861,'31091','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25148,'46552','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(520,'01842','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44949,'76487','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42033,'72112','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(31606,'55954','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48976,'84535','San Juan','49037','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47006,'79491','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38817,'66720','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5809,'14466','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7808,'17810','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9741,'21540','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27303,'49284','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28739,'51005','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31561,'55920','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34666,'60407','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14970,'30133','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14894,'30083','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38824,'66735','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45589,'77430','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50346,'89403','Storey','32029','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(10050,'22207','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4299,'11770','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36776,'63048','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10895,'23874','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1458,'04291','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28969,'51466','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25512,'47012','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8043,'18201','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2480,'06782','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50932,'91706','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44710,'76180','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41341,'71078','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10632,'23238','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54057,'97868','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43534,'74460','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42322,'72476','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26954,'48841','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36254,'62535','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5567,'13902','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8791,'19605','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27685,'49746','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21370,'40140','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9432,'20784','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1379,'04092','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17542,'33858','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14298,'29353','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53613,'97086','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42706,'73015','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21488,'40324','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17438,'33706','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6777,'15907','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1330,'04027','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3594,'09725','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(4525,'12174','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25444,'46960','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21545,'40374','Bourbon','21017','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18964,'36615','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18812,'36373','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43225,'73860','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44305,'75640','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53280,'96503','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(37655,'64650','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15001,'30154','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34847,'60554','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28768,'51023','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16921,'32857','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43382,'74116','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46964,'79370','Kent','48263','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14198,'29153','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32341,'56592','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(548,'01903','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(27533,'49620','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38746,'66539','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43666,'74748','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52140,'94284','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21885,'41081','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10121,'22436','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19662,'37722','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2614,'07061','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31055,'55053','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1844,'05088','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(44935,'76475','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47901,'81077','Otero','8089','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30356,'54241','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15693,'30909','Columbia','13073','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19700,'37760','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19332,'37152','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51303,'92368','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10377,'22937','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36280,'62553','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34091,'59319','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32624,'57076','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30916,'54931','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8323,'18824','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25402,'46929','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16751,'32628','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39767,'68058','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30642,'54642','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30249,'54115','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25447,'46962','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48583,'83627','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53395,'96731','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(9398,'20747','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35990,'62268','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13295,'28072','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28585,'50626','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12708,'27256','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22518,'42503','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22286,'42104','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18194,'35249','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17778,'34276','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16136,'31711','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12013,'25709','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(862,'02675','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40225,'68740','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43984,'75160','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13596,'28393','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8710,'19468','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10318,'22815','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2591,'07034','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25911,'47519','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22579,'42718','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38789,'66618','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39658,'67863','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45915,'77987','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47068,'79543','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55074,'99725','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(36463,'62818','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1216,'03784','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6063,'14814','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23651,'44427','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51496,'92821','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36468,'62821','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29181,'52136','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10811,'23666','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24047,'45107','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21722,'40801','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17500,'33807','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19765,'37841','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37888,'65051','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47459,'80239','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41821,'71865','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39621,'67839','Lane','20101','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9675,'21230','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4348,'11948','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12213,'26160','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34135,'59406','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7031,'16329','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15878,'31107','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22634,'42784','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(55001,'99641','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(33114,'57714','Bennett','46007','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23399,'44050','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9688,'21241','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19241,'37078','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7507,'17099','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50899,'91499','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54663,'98925','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14980,'30141','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34577,'60141','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14414,'29483','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13322,'28092','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27255,'49242','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23868,'44802','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10241,'22645','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20636,'38962','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7708,'17555','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12862,'27510','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35914,'62204','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16401,'32125','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18077,'35111','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24163,'45244','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47753,'80832','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1072,'03238','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30959,'54965','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34009,'59117','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11847,'25356','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2446,'06703','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50376,'89433','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(8052,'18216','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1692,'04780','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38403,'65747','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13531,'28341','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2971,'08023','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33796,'58740','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31491,'55756','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21078,'39648','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20589,'38924','Carroll','28015','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21899,'41095','Gallatin','21077','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9618,'21152','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14763,'29929','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54597,'98684','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1290,'03885','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(17661,'34036','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(35204,'61241','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5818,'14472','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10025,'22156','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47333,'80040','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49024,'84660','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49965,'88034','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50083,'88344','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50329,'89183','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(32080,'56338','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30677,'54667','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27556,'49638','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24728,'46012','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1699,'04843','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9800,'21658','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20508,'38838','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(851,'02662','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3461,'09366','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27797,'49866','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43440,'74337','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43824,'75009','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1902,'05402','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39441,'67579','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32155,'56395','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23400,'44052','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5657,'14092','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5576,'14004','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45147,'76711','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51041,'91987','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34030,'59225','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14343,'29417','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29646,'53006','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12054,'25823','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6972,'16229','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17729,'34215','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31145,'55168','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2394,'06498','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24329,'45410','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22914,'43322','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42199,'72360','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6522,'15534','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17193,'33326','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36180,'62450','Edwards','17047','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6158,'14892','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23505,'44194','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12487,'26636','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2314,'06375','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9799,'21657','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7912,'17949','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32876,'57385','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29428,'52540','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20912,'39364','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2526,'06870','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22199,'42001','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7209,'16662','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4850,'12771','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22165,'41804','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21951,'41180','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4399,'12028','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44405,'75763','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47944,'81144','Alamosa','8003','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53553,'97019','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43151,'73743','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42681,'72959','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19975,'38114','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22375,'42261','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44041,'75235','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44738,'76228','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27884,'49970','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26700,'48551','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50331,'89191','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51974,'93912','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30867,'54873','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(879,'02738','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45938,'78007','McMullen','48311','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50035,'88230','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(655,'02141','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17797,'34423','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8027,'18091','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26873,'48761','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25488,'46989','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21674,'40580','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1507,'04428','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17236,'33421','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42102,'72167','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33131,'57724','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13401,'28169','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4311,'11784','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5150,'13153','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47545,'80456','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50100,'88416','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50781,'91182','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36344,'62640','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34979,'60919','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7996,'18060','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26942,'48835','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13480,'28290','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54398,'98393','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29969,'53547','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28489,'50562','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27507,'49534','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27178,'49083','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11344,'24473','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23712,'44506','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14315,'29375','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51845,'93615','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35948,'62240','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24678,'45872','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6961,'16220','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15723,'31014','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7584,'17261','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50880,'91403','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41947,'72040','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3779,'10157','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29406,'52411','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27485,'49468','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16822,'32725','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21942,'41169','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11951,'25601','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7172,'16627','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7553,'17228','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20339,'38617','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32383,'56655','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15309,'30447','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43501,'74432','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17090,'33138','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13579,'28380','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26041,'47714','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51077,'92055','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39742,'68036','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6626,'15682','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50317,'89162','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53586,'97053','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(729,'02346','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2596,'07041','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42329,'72479','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40684,'69216','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12552,'26817','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38712,'66515','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22394,'42301','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9419,'20772','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9811,'21669','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13141,'27872','Bertie','37015','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21228,'39852','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25160,'46563','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26181,'47932','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31384,'55562','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44460,'75849','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45340,'77053','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4986,'12960','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45918,'77990','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20459,'38754','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43185,'73771','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19989,'38131','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38150,'65534','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37141,'63650','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26333,'48074','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33922,'59026','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33316,'58206','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51517,'92857','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52755,'95550','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17709,'34141','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3512,'09550','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19205,'37056','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18664,'36092','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54157,'98073','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16776,'32666','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13139,'27871','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45179,'76841','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35316,'61360','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25320,'46803','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11278,'24361','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45239,'76885','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38227,'65612','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45960,'78023','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33582,'58478','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34219,'59520','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4982,'12956','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7374,'16940','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19981,'38120','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6897,'16110','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2061,'05824','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(44914,'76463','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46939,'79353','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47327,'80033','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49495,'85747','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50741,'91010','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(231,'01034','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7876,'17877','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50030,'88210','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47583,'80504','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40028,'68448','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6582,'15632','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(916,'02813','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(36959,'63383','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10127,'22442','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33731,'58646','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48180,'82322','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49540,'86017','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(41314,'71060','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34040,'59243','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(53101,'96050','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23467,'44119','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28320,'50424','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13633,'28435','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28709,'50857','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36680,'62957','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31276,'55387','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13193,'27925','Tyrrell','37177','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36693,'62966','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23741,'44615','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52763,'95558','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51174,'92177','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45893,'77964','Lavaca','48285','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31194,'55332','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36684,'62958','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27418,'49409','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6099,'14845','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5414,'13662','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34658,'60401','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43826,'75010','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45981,'78052','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46006,'78070','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42193,'72354','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42396,'72569','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44931,'76472','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13012,'27636','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3632,'09806','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2507,'06825','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9025,'20139','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17757,'34242','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17760,'34250','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42186,'72348','Crittenden','5035','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18280,'35504','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19014,'36750','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31800,'56120','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25416,'46940','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24261,'45342','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14041,'28902','Clay','37043','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11889,'25442','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46937,'79351','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49353,'85383','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1240,'03825','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32688,'57238','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51611,'93205','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2654,'07104','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3828,'10279','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15846,'31081','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40079,'68522','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3056,'08107','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18876,'36482','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27321,'49305','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8839,'19885','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(10388,'22945','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10344,'22851','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23314,'43938','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6837,'16023','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44063,'75262','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41698,'71665','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49041,'84720','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47877,'81052','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44862,'76432','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27683,'49746','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21928,'41144','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4454,'12086','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23481,'44133','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28418,'50511','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33976,'59074','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31172,'55319','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43646,'74728','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53656,'97136','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(38709,'66512','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54618,'98827','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51056,'92022','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50433,'89706','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(13058,'27806','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9651,'21214','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40920,'70393','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34920,'60653','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31369,'55484','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13486,'28303','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49721,'87083','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41504,'71326','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39903,'68338','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48278,'82731','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46784,'79097','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25167,'46570','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28168,'50229','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30187,'53968','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14346,'29419','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18250,'35464','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(224,'01027','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25344,'46856','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12280,'26267','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53470,'96813','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53321,'96604','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(45473,'77303','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39907,'68340','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41545,'71367','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41878,'71968','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3508,'09534','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28742,'51006','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26210,'47955','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43090,'73659','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38960,'66940','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(55128,'99782','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54816,'99185','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53012,'95951','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44162,'75440','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28721,'50864','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28527,'50588','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28307,'50392','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22872,'43229','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37305,'63945','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15937,'31314','Bryan','13029','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39684,'67880','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1429,'04254','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16259,'31816','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37704,'64701','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22619,'42757','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32831,'57359','Jerauld','46073','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46586,'78883','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46872,'79250','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(745,'02367','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39349,'67501','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47637,'80610','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46536,'78765','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45302,'77016','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33820,'58758','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29779,'53119','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14616,'29684','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2028,'05747','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7748,'17702','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37206,'63776','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17876,'34677','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15629,'30751','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21393,'40170','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27540,'49627','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3470,'09380','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8217,'18502','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51584,'93094','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45157,'76801','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24940,'46208','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43150,'73742','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5040,'13037','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6828,'16001','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6243,'15076','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14021,'28788','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43665,'74748','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3278,'08812','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19093,'36862','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48728,'83860','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(33693,'58622','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41874,'71964','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6356,'15268','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17365,'33592','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16886,'32806','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12883,'27523','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30698,'54726','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24269,'45347','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3340,'08888','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8662,'19398','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44975,'76525','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(727,'02344','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15216,'30340','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3192,'08553','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35425,'61473','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40,'00674','Manati','72091','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28587,'50627','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1254,'03843','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15162,'30295','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24023,'45052','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51472,'92708','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42860,'73130','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(8655,'19381','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40932,'70422','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51538,'92883','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47655,'80642','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44313,'75645','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6259,'15095','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32178,'56440','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36387,'62682','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2538,'06896','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41493,'71316','Concordia','22029','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19671,'37729','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35715,'61862','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3414,'09201','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(1772,'04969','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15255,'30388','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32396,'56669','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(48176,'82301','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44549,'75976','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26529,'48318','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7486,'17077','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34520,'60093','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36501,'62841','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37341,'64018','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38576,'66092','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4562,'12223','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9424,'20777','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11800,'25268','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4346,'11946','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18531,'35974','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43720,'74849','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32234,'56484','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32793,'57331','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21612,'40464','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9600,'21113','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5598,'14029','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39910,'68341','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25997,'47616','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44829,'76373','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(360,'01366','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40648,'69157','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53812,'97377','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44837,'76380','Baylor','48023','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12582,'27011','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(13775,'28580','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14162,'29122','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16482,'32223','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23289,'43908','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9113,'20242','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(49341,'85371','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(7918,'17959','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20292,'38569','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54175,'98107','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29972,'53550','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14775,'29940','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39540,'67675','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47654,'80640','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37617,'64628','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37231,'63824','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36323,'62622','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34752,'60473','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42407,'72579','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39545,'67731','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52599,'95345','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44130,'75416','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28503,'50570','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21826,'41015','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10604,'23222','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36887,'63169','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38325,'65682','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7956,'18018','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17861,'34637','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38022,'65281','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35980,'62262','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10337,'22845','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32181,'56443','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11495,'24646','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50500,'90042','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32778,'57323','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43771,'74883','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26559,'48359','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28981,'51523','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31895,'56208','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5185,'13218','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19193,'37049','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6426,'15368','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12540,'26763','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15787,'31042','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15253,'30384','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40500,'68964','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48594,'83635','Valley','16085','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(21147,'39750','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21667,'40555','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24967,'46236','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25670,'47240','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6453,'15428','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29071,'51603','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36363,'62665','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14990,'30147','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6032,'14772','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17442,'33710','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16766,'32654','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44359,'75686','Camp','48063','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44753,'76244','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49084,'84765','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(55090,'99743','Denali','2068','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(6891,'16102','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12178,'26104','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48376,'83234','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(33479,'58379','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33648,'58554','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12481,'26624','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41350,'71104','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40867,'70179','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(30813,'54827','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23397,'44048','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43350,'74075','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3211,'08607','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37969,'65236','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50148,'88544','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(18951,'36601','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1278,'03868','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2968,'08020','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36429,'62762','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35107,'61048','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10120,'22435','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40943,'70436','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51186,'92197','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47758,'80833','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45597,'77436','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22705,'43054','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42550,'72756','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32211,'56467','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5187,'13220','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21364,'40119','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26450,'48193','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13983,'28754','Yancey','37199','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51420,'92624','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50390,'89445','Pershing','32027','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43617,'74633','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22784,'43123','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31421,'55601','Lake','27075','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32327,'56583','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(973,'02894','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(1823,'05060','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8786,'19567','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2289,'06330','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9311,'20628','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3869,'10471','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(984,'02908','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(24970,'46239','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5127,'13134','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54461,'98516','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47080,'79549','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46969,'79376','Terry','48445','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44238,'75495','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24179,'45262','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25528,'47031','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26045,'47720','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26384,'48128','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27082,'49014','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(609,'02059','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16578,'32359','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19864,'37934','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41310,'71055','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28,'00652','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19083,'36854','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2326,'06388','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6462,'15437','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28566,'50612','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46549,'78802','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47941,'81140','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40672,'69170','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43975,'75155','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8989,'20109','Manassas City','51683','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40267,'68768','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6112,'14858','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9442,'20799','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21391,'40165','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21871,'41061','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30816,'54829','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43653,'74734','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49428,'85638','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40378,'68854','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51101,'92085','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11704,'25118','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21992,'41301','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40861,'70172','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38427,'65767','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29594,'52752','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26304,'48041','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25054,'46366','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46206,'78363','Kleberg','48273','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50635,'90506','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41963,'72053','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42984,'73522','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25919,'47525','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23696,'44485','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20552,'38868','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14022,'28789','Jackson','37099','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40898,'70357','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3082,'08232','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37051,'63534','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30765,'54764','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24212,'45311','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23725,'44601','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52412,'95038','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49456,'85707','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43086,'73655','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35787,'61944','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51235,'92270','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10992,'24004','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14190,'29146','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3206,'08602','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40315,'68803','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18722,'36260','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34560,'60129','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8845,'19894','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(9833,'21715','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42196,'72355','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51181,'92191','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19330,'37150','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43700,'74831','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25058,'46372','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31273,'55385','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(200,'00984','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(36657,'62941','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37416,'64096','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32373,'56644','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(5601,'14030','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17000,'33010','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26435,'48178','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4042,'10993','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(618,'02072','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43395,'74131','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47622,'80543','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24835,'46118','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49192,'85131','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48335,'83116','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47114,'79697','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10977,'23963','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35549,'61637','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6210,'15043','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16603,'32422','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3865,'10467','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9603,'21120','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52582,'95326','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15110,'30256','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48217,'82443','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(13452,'28254','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(392,'01470','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26211,'47955','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45652,'77483','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54373,'98367','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32039,'56312','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54608,'98814','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51036,'91976','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45223,'76871','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42247,'72413','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12584,'27012','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(34719,'60449','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21345,'40076','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22497,'42452','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51537,'92882','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(919,'02816','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(1639,'04673','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54583,'98664','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52423,'95053','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44811,'76357','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22333,'42171','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23618,'44321','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27642,'49713','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28600,'50634','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10561,'23149','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32500,'56999','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(8494,'19081','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36569,'62887','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40778,'70055','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5177,'13208','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18804,'36352','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34587,'60146','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44288,'75605','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46452,'78669','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51338,'92412','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53584,'97050','Sherman','41055','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34905,'60636','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51018,'91921','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50222,'89028','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48224,'82515','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42851,'73123','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11194,'24230','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21878,'41071','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(997,'02940','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(35597,'61738','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38224,'65611','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24449,'45669','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9825,'21703','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(44512,'75941','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47207,'79839','Hudspeth','48229','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49878,'87583','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52644,'95391','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54078,'97907','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54671,'98936','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55110,'99763','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38688,'66440','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26530,'48320','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51607,'93201','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50599,'90280','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50356,'89412','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(1891,'05354','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9454,'20827','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5552,'13849','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5782,'14430','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24300,'45373','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35286,'61334','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5864,'14519','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2706,'07423','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11315,'24435','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42623,'72863','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48282,'82831','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(49306,'85334','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39598,'67762','Cheyenne','8017','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18811,'36371','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(55023,'99665','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53732,'97292','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(21602,'40447','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25317,'46799','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26102,'47850','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21161,'39755','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30687,'54703','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34467,'60037','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10713,'23417','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42188,'72348','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17498,'33805','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40877,'70195','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35634,'61770','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16613,'32430','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8970,'20077','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(44948,'76487','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49729,'87108','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52774,'95571','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(217,'01012','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14510,'29602','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27893,'50006','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28928,'51436','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32651,'57212','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6105,'14851','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16127,'31705','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31160,'55309','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28146,'50217','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11615,'24974','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2111,'06002','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1887,'05350','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(23967,'44878','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47822,'80951','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1650,'04686','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1177,'03595','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(53214,'96213','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(44909,'76462','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35643,'61777','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20152,'38368','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39124,'67120','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41082,'70592','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41379,'71151','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12234,'26201','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22910,'43319','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51381,'92562','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54137,'98050','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19781,'37853','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48313,'82939','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(13902,'28682','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25507,'47010','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15728,'31015','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5741,'14241','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33995,'59101','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17922,'34759','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18830,'36429','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4984,'12958','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26785,'48652','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16926,'32862','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14620,'29688','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13214,'27949','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(544,'01890','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53629,'97114','Yamhill','41071','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(162,'00934','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(16367,'32083','Union','12125','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39120,'67118','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36486,'62833','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35392,'61449','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16274,'31826','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29285,'52237','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29036,'51558','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13060,'27807','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19704,'37764','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14567,'29647','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31883,'56180','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48796,'84052','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(8879,'19954','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(13892,'28675','Alleghany','37005','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34641,'60196','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14494,'29584','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17574,'33902','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26166,'47922','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47112,'79607','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39068,'67057','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7833,'17829','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17749,'34235','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51929,'93721','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25868,'47449','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28622,'50651','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29412,'52501','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19875,'38001','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35150,'61079','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9366,'20710','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39077,'67062','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11257,'24326','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18172,'35221','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35358,'61420','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22949,'43345','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24921,'46176','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28362,'50454','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41657,'71603','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50457,'89835','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53296,'96538','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(36572,'62889','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27946,'50047','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11187,'24224','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22979,'43412','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22893,'43302','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49757,'87185','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(16953,'32920','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24527,'45740','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25414,'46939','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16400,'32124','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34368,'59845','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3248,'08734','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16853,'32767','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25407,'46932','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44091,'75357','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51458,'92690','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8918,'20018','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(45312,'77026','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47889,'81064','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54609,'98815','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33719,'58639','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9300,'20618','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35496,'61545','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33652,'58560','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33367,'58256','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32160,'56401','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32022,'56297','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39189,'67227','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27494,'49509','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19545,'37387','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3244,'08730','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1493,'04412','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2419,'06530','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33408,'58318','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26191,'47943','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30509,'54494','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33721,'58640','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49733,'87112','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44304,'75640','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9428,'20781','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13138,'27871','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26034,'47706','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19487,'37351','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8798,'19612','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2402,'06508','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40964,'70452','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34239,'59538','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(43246,'74002','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42205,'72367','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10414,'22969','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5133,'13138','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30047,'53711','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5028,'13030','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27527,'49616','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3005,'08060','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49514,'85925','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36554,'62878','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12531,'26743','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13628,'28432','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34966,'60911','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30690,'54721','Pepin','55091','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26400,'48146','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51543,'93001','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54657,'98908','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23686,'44460','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24419,'45644','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40950,'70443','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47043,'79528','Kent','48263','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15661,'30817','Lincoln','13181','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2218,'06137','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29172,'52101','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20163,'38376','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36915,'63344','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12686,'27230','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27015,'48884','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7860,'17857','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43513,'74439','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47060,'79536','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52441,'95076','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52977,'95918','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54996,'99636','Dillingham','2070','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1223,'03809','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2786,'07650','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22832,'43154','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49747,'87131','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50454,'89832','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(39347,'67491','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48349,'83202','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(325,'01253','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4377,'11980','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35243,'61279','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32543,'57029','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40151,'68652','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35536,'61611','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30890,'54912','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4775,'12577','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42402,'72576','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4518,'12167','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4450,'12083','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32557,'57037','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1521,'04449','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12912,'27544','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23125,'43607','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6605,'15663','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41088,'70605','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41634,'71468','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41918,'72023','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43041,'73566','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44454,'75845','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53446,'96786','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41389,'71166','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47330,'80036','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54700,'99011','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14012,'28781','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13896,'28677','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32310,'56571','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(3970,'10801','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21437,'40242','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22081,'41571','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46135,'78251','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17689,'34110','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43834,'75019','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48174,'82243','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37081,'63557','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47251,'79932','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49521,'85932','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4732,'12529','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39952,'68367','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8388,'18944','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17699,'34133','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24558,'45776','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29776,'53118','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37598,'64505','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14389,'29461','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16278,'31830','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14164,'29125','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7170,'16625','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7273,'16748','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19983,'38124','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19804,'37871','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10784,'23520','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52237,'94566','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6514,'15520','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16321,'32030','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13667,'28458','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19344,'37167','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53020,'95959','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(247,'01061','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51550,'93009','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3097,'08270','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7413,'17021','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37020,'63460','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7194,'16647','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18323,'35572','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23609,'44312','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26348,'48092','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28049,'50128','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46366,'78620','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47904,'81084','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48414,'83301','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(29965,'53544','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5346,'13501','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28759,'51019','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23012,'43450','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23196,'43749','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27123,'49043','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52590,'95334','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6389,'15327','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18560,'36009','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39729,'68025','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48490,'83436','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54126,'98037','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30017,'53583','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24463,'45679','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13236,'27976','Camden','37029','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43880,'75060','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49160,'85067','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52035,'94070','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21875,'41065','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16255,'31812','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15150,'30288','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(586,'02020','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8939,'20043','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(4592,'12256','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11308,'24426','Covington City','51580','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18549,'35987','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42368,'72539','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47679,'80723','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50195,'89001','Lincoln','32017','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53262,'96376','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(12740,'27293','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45193,'76852','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42480,'72672','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18986,'36693','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19355,'37180','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2801,'07701','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28267,'50314','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38619,'66215','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17377,'33603','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26145,'47904','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22210,'42025','Marshall','21157','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40443,'68930','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42691,'73006','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46149,'78264','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51946,'93755','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29869,'53219','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2651,'07101','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20927,'39403','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44379,'75708','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45853,'77863','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48599,'83638','Valley','16085','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10332,'22841','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52596,'95341','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54740,'99107','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(12656,'27127','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19535,'37379','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41676,'71644','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43146,'73739','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44995,'76539','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47062,'79538','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(858,'02670','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5959,'14643','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36161,'62441','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40625,'69146','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33466,'58368','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5969,'14694','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37409,'64086','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24958,'46229','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35650,'61802','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45789,'77651','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48146,'82083','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51248,'92285','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51816,'93560','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27231,'49220','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6568,'15619','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6492,'15472','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16915,'32837','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39486,'67644','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35865,'62069','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29288,'52242','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11576,'24881','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19918,'38042','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47072,'79545','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49646,'86538','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33380,'58266','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32386,'56659','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(14199,'29153','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24191,'45280','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47831,'81003','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50852,'91360','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51223,'92256','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53249,'96348','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54581,'98662','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8519,'19104','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15584,'30703','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36024,'62295','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38806,'66711','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46118,'78234','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45282,'76953','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43220,'73858','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17668,'34050','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(33081,'57641','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35184,'61115','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3903,'10527','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30575,'54558','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22133,'41723','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26780,'48649','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45899,'77971','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37332,'64002','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34598,'60155','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10462,'23043','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8520,'19105','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44453,'75844','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24193,'45298','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26936,'48831','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16865,'32780','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29457,'52562','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(290,'01116','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38661,'66417','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7103,'16420','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31438,'55703','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20272,'38554','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16222,'31790','Turner','13287','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34006,'59114','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33805,'58748','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24076,'45133','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12026,'25722','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21112,'39668','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49710,'87056','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(868,'02715','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16466,'32206','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38801,'66675','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35193,'61231','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1614,'04637','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7620,'17325','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31457,'55723','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13150,'27880','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22764,'43105','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1586,'04575','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(45965,'78026','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40104,'68626','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25818,'47390','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25930,'47535','Knox','18083','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29214,'52166','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22934,'43337','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37866,'65037','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37619,'64630','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13311,'28083','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17259,'33444','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16587,'32403','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35287,'61335','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10567,'23160','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32764,'57315','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31225,'55350','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31070,'55069','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24344,'45428','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44889,'76449','Jack','48237','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54984,'99624','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(55109,'99762','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37460,'64149','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47275,'79955','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9598,'21111','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9527,'21005','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29342,'52324','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(693,'02217','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(431,'01542','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4912,'12851','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15264,'30412','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22594,'42731','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22526,'42528','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20433,'38721','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43549,'74501','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45481,'77320','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46060,'78142','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47293,'80003','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48468,'83403','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53361,'96678','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(2656,'07106','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50561,'90212','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48297,'82901','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(31330,'55429','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13723,'28530','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36820,'63103','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1098,'03263','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26035,'47708','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26794,'48658','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44525,'75956','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49011,'84644','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54294,'98277','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29723,'53065','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13195,'27927','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11961,'25625','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8904,'20003','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19994,'38136','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7583,'17260','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35625,'61756','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38763,'66550','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9774,'21634','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23544,'44234','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46542,'78773','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49436,'85645','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34344,'59821','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1080,'03246','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5067,'13063','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45106,'76670','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49040,'84720','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(339,'01301','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14571,'29650','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5112,'13115','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29570,'52729','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28038,'50123','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24671,'45869','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18373,'35621','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38940,'66871','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48839,'84093','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(783,'02479','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18733,'36268','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27287,'49266','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33903,'59007','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(55040,'99682','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(5319,'13471','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19108,'36874','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45902,'77974','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(376,'01434','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30452,'54455','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53155,'96108','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33637,'58540','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54266,'98245','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54279,'98259','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29967,'53545','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14317,'29377','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28435,'50524','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9270,'20580','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33691,'58621','Wibaux','30109','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16796,'32696','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21307,'40050','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9729,'21523','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10334,'22843','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10261,'22701','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13199,'27930','Perquimans','37143','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1012,'03047','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(27139,'49055','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22777,'43113','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22411,'42330','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21743,'40830','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28424,'50516','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3582,'09711','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28017,'50107','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33870,'58795','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13490,'28306','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45539,'77373','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47391,'80135','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47982,'81239','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37600,'64506','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37202,'63771','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36118,'62414','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35173,'61107','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5848,'14507','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15848,'31082','Hancock','13141','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32361,'56633','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28438,'50526','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12197,'26143','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12520,'26716','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24549,'45767','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23301,'43925','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47120,'79704','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54960,'99589','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(15753,'31027','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27423,'49412','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21712,'40745','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(50343,'89319','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(61,'00707','Maunabo','72095','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(16444,'32177','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3786,'10164','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34347,'59824','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19971,'38109','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29046,'51563','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25438,'46953','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38956,'66938','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41043,'70546','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46764,'79084','Sherman','48421','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49656,'87006','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54494,'98557','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9482,'20871','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18543,'35981','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25097,'46504','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21372,'40142','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51804,'93546','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38122,'65456','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15713,'31008','Peach','13225','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13568,'28371','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30418,'54429','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17676,'34093','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(28366,'50457','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54926,'99550','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(34760,'60479','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24003,'45014','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20548,'38864','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36660,'62943','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35387,'61442','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34929,'60666','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7722,'17570','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29612,'52766','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25955,'47562','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43077,'73650','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41474,'71279','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40441,'68929','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28987,'51528','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23990,'44905','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30188,'53968','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11239,'24312','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9715,'21404','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32766,'57317','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30448,'54452','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10711,'23415','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14976,'30139','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10437,'23014','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36879,'63156','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34780,'60504','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34413,'59922','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17448,'33716','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24943,'46213','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25251,'46748','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47442,'80227','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50355,'89411','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(22723,'43065','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7535,'17202','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1396,'04112','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(30547,'54537','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36434,'62767','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38161,'65546','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14036,'28814','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9141,'20355','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(26223,'47964','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16974,'32953','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22324,'42166','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48442,'83338','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51970,'93905','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55078,'99730','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52680,'95441','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17606,'33936','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20392,'38655','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22086,'41604','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6287,'15140','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23971,'44880','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39109,'67110','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35294,'61342','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38298,'65657','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13033,'27706','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32030,'56304','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31743,'56071','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6584,'15634','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4357,'11957','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41373,'71136','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41480,'71284','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46645,'79005','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2957,'08008','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20983,'39475','Lamar','28073','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28154,'50220','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33577,'58474','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3422,'09245','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12282,'26267','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14363,'29435','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37472,'64163','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17245,'33431','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29569,'52728','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21464,'40289','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23195,'43749','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48137,'82070','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(41149,'70714','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29682,'53029','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15030,'30178','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7471,'17066','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12397,'26443','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18325,'35574','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46503,'78735','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12198,'26143','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37198,'63769','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2165,'06073','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18523,'35966','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32815,'57348','Beadle','46005','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29882,'53235','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18707,'36205','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25579,'47125','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45866,'77873','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48453,'83347','Jerome','16053','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53432,'96771','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(25725,'47325','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10542,'23128','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22854,'43210','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7544,'17217','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41248,'70833','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29998,'53571','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50067,'88321','Guadalupe','35019','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(9377,'20721','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37004,'63450','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15677,'30823','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14471,'29565','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42763,'73052','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47081,'79549','Kent','48263','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47914,'81092','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(55168,'99929','Wrangell','2275','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(13912,'28689','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16836,'32747','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20693,'39079','Holmes','28051','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30038,'53599','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37673,'64661','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36450,'62808','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43970,'75151','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(324,'01252','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2855,'07803','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(34803,'60519','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37271,'63873','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45438,'77255','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48987,'84605','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51893,'93654','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54508,'98570','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31837,'56147','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3374,'09055','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(27948,'50048','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5379,'13626','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15858,'31089','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50187,'88586','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(450,'01590','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14474,'29568','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2918,'07926','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36560,'62882','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34090,'59318','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33991,'59087','Garfield','30033','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32890,'57427','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8379,'18932','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53388,'96722','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53580,'97044','Hood River','41027','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54263,'98241','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34919,'60652','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3763,'10125','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29154,'52069','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7773,'17745','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7307,'16845','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17573,'33901','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17727,'34211','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18874,'36481','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46475,'78710','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(613,'02065','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15751,'31026','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34582,'60145','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17969,'34986','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18315,'35565','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24697,'45886','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20439,'38731','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38654,'66411','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43486,'74403','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47741,'80823','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48681,'83810','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(23802,'44661','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1770,'04966','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20856,'39323','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12465,'26588','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42707,'73016','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45717,'77546','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49159,'85066','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53881,'97456','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33113,'57709','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32917,'57442','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31723,'56057','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8673,'19420','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24863,'46140','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38443,'65777','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6285,'15137','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12666,'27203','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18871,'36477','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42151,'72313','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45212,'76861','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6549,'15560','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39069,'67058','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44340,'75667','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37587,'64494','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3920,'10548','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8817,'19725','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(5678,'14126','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27545,'49631','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22406,'42325','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21356,'40109','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16276,'31829','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39954,'68368','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45029,'76570','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10759,'23471','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10240,'22645','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3315,'08857','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2881,'07845','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16460,'32198','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52121,'94256','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25865,'47448','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52563,'95309','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8207,'18466','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34215,'59487','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31014,'55018','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25966,'47577','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2858,'07821','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4614,'12401','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7881,'17882','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21390,'40162','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41449,'71256','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51025,'91942','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24832,'46115','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24079,'45135','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17710,'34141','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10424,'22980','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28724,'50940','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5411,'13659','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10044,'22203','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36675,'62954','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13992,'28761','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13538,'28347','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13229,'27968','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12403,'26448','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8969,'20076','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2914,'07920','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(48101,'81645','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51010,'91910','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27842,'49916','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23020,'43460','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22625,'42764','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16428,'32158','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35956,'62247','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13153,'27882','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22975,'43410','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20809,'39201','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50746,'91020','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5023,'13026','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32348,'56619','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(13331,'28103','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15963,'31407','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45554,'77384','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52791,'95610','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38592,'66106','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37086,'63559','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37048,'63533','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35101,'61044','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12354,'26378','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16499,'32238','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23763,'44629','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22125,'41712','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6263,'15104','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53037,'95972','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35784,'61943','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52579,'95323','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44198,'75469','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10193,'22556','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35609,'61745','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34615,'60174','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9890,'21787','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30752,'54757','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29991,'53563','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27270,'49252','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20070,'38281','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18970,'36628','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40294,'68784','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49931,'87936','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(14825,'30025','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32979,'57522','Hughes','46065','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26600,'48418','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12458,'26582','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37819,'64861','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21449,'40258','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22248,'42056','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22853,'43209','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23263,'43830','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16334,'32046','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37824,'64863','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15031,'30179','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32574,'57046','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43763,'74875','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53065,'96008','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(346,'01340','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42401,'72575','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11098,'24112','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36797,'63070','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36085,'62361','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12289,'26276','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13115,'27850','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29360,'52336','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9533,'21014','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37471,'64162','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36940,'63363','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31628,'55971','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47823,'80960','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31011,'55016','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19026,'36758','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18686,'36121','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39620,'67839','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7315,'16853','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37934,'65083','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28140,'50213','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32494,'56944','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(47969,'81225','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7825,'17821','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6959,'16217','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24389,'45612','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45328,'77042','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53387,'96721','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(40321,'68814','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20922,'39401','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11753,'25202','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31318,'55419','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54419,'98418','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9415,'20768','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5033,'13033','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13513,'28327','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44592,'76035','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40944,'70437','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38851,'66758','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33062,'57630','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28788,'51034','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16165,'31744','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4916,'12855','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1584,'04573','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(49648,'86544','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40896,'70355','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5716,'14207','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5595,'14026','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6724,'15823','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35128,'61064','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21996,'41301','Wolfe','21237','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51636,'93237','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1229,'03814','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15615,'30738','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40413,'68876','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28235,'50266','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28336,'50434','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33913,'59015','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33336,'58225','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30288,'54155','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47820,'80949','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49602,'86401','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49615,'86430','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53173,'96126','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40726,'69348','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40507,'68971','Harlan','31083','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40356,'68835','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12835,'27419','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22663,'43016','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24339,'45423','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24856,'46131','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36170,'62446','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31950,'56243','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19688,'37748','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7903,'17935','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36292,'62558','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52776,'95585','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19904,'38029','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18217,'35401','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41934,'72031','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27356,'49326','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8744,'19519','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3385,'09086','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6969,'16225','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44286,'75604','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45928,'78002','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32333,'56586','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37585,'64492','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2522,'06857','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5139,'13143','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46888,'79258','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50239,'89047','Esmeralda','32009','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(15,'00617','Barceloneta','72017','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42117,'72190','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38370,'65726','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7952,'18015','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35601,'61740','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33246,'58046','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44652,'76093','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52491,'95164','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39150,'67146','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5178,'13209','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31266,'55381','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44926,'76470','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12755,'27306','Richmond','37153','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19763,'37840','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53339,'96628','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(4438,'12068','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(962,'02881','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(40739,'69357','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38694,'66451','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37252,'63850','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33133,'57730','Custer','46033','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20101,'38331','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18747,'36276','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51411,'92612','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35960,'62249','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1439,'04265','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14691,'29824','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31132,'55127','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10548,'23138','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24417,'45642','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40221,'68736','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10098,'22350','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8374,'18928','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35185,'61125','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10287,'22733','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8358,'18912','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28152,'50220','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13,'00614','Arecibo','72013','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(17185,'33318','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17080,'33128','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37991,'65255','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9094,'20219','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(6093,'14840','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34119,'59347','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14399,'29471','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54952,'99579','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(21314,'40055','Henry','21103','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15496,'30620','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36226,'62481','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32628,'57078','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29552,'52655','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26448,'48191','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23024,'43464','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22969,'43403','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50406,'89507','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51618,'93212','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54923,'99547','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(21030,'39565','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(36287,'62557','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27672,'49736','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10265,'22713','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53334,'96619','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54482,'98541','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(84,'00738','Fajardo','72053','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42582,'72827','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5966,'14652','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38769,'66601','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33118,'57717','Carter','30011','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30789,'54806','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25300,'46788','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47279,'79968','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47447,'80231','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53271,'96387','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(19915,'38040','Lauderdale','47097','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42289,'72450','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8721,'19484','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19828,'37885','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39627,'67843','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32225,'56478','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(47432,'80221','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(28603,'50636','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29819,'53158','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30191,'53969','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48255,'82701','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53762,'97327','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(38842,'66753','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6788,'15926','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51170,'92173','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43135,'73730','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9376,'20720','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19403,'37224','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41680,'71651','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18626,'36053','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35561,'61701','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13869,'28655','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34961,'60804','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33386,'58272','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26265,'47994','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11669,'25062','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9949,'21890','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49984,'88056','Hidalgo','35023','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54683,'98948','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29273,'52228','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47452,'80234','Broomfield','8014','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(13728,'28533','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6084,'14831','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5648,'14080','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34450,'60017','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34681,'60421','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37821,'64862','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39184,'67219','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7743,'17611','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4214,'11560','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21915,'41129','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13464,'28270','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1203,'03765','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(45735,'77566','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34210,'59483','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35534,'61610','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24973,'46240','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21833,'41030','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40664,'69167','Hooker','31091','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2565,'07007','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5500,'13790','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13960,'28736','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12337,'26351','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24288,'45365','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50557,'90202','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50573,'90240','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42508,'72715','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51455,'92684','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34863,'60567','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49458,'85709','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(20639,'38963','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6612,'15670','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11631,'25005','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32412,'56684','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(41602,'71441','Caldwell','22021','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28047,'50128','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4733,'12530','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27490,'49505','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7600,'17307','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45966,'78027','Kendall','48259','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44151,'75432','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26964,'48847','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37565,'64479','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51556,'93014','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49870,'87575','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(20471,'38768','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22611,'42749','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1959,'05491','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28579,'50623','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9061,'20182','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12210,'26155','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33553,'58455','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2016,'05735','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19754,'37826','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37294,'63937','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31574,'55931','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53736,'97298','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6913,'16125','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45154,'76799','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25685,'47260','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3601,'09732','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(446,'01583','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32759,'57312','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50004,'88118','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40777,'70054','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35458,'61491','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54770,'99134','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4448,'12078','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21764,'40902','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27206,'49102','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7384,'16950','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35851,'62054','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7789,'17763','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1375,'04087','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54858,'99335','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3225,'08640','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35008,'60942','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45168,'76825','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44116,'75398','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20326,'38602','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21719,'40769','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6976,'16230','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7052,'16351','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33830,'58765','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2747,'07509','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14822,'30024','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39342,'67487','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(685,'02203','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3522,'09570','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9665,'21225','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4879,'12812','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20523,'38849','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47760,'80834','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17226,'33411','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11812,'25301','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37515,'64437','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8686,'19437','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19806,'37872','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31418,'55597','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28119,'50169','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5464,'13744','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43083,'73654','Roger Mills','40129','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30821,'54835','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29531,'52641','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20705,'39090','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28302,'50368','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54515,'98580','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42766,'73054','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9027,'20141','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39147,'67143','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32480,'56760','Pennington','27113','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17911,'34745','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21615,'40468','Mercer','21167','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29117,'52035','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23507,'44197','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44418,'75779','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47138,'79720','Glasscock','48173','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51061,'92027','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17547,'33863','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34299,'59728','Powell','30077','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6900,'16113','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3437,'09311','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(52016,'94027','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33160,'57760','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29197,'52155','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21821,'41010','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21503,'40337','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20701,'39086','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4455,'12087','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47992,'81252','Custer','8027','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48541,'83539','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54270,'98250','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28917,'51366','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51360,'92521','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41791,'71838','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21208,'39837','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10575,'23173','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46076,'78156','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51350,'92507','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52272,'94603','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8646,'19367','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8590,'19187','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5330,'13482','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22196,'41859','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51222,'92255','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34811,'60526','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7500,'17089','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32699,'57247','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1019,'03055','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28982,'51523','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10748,'23459','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9274,'20588','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16686,'32536','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4079,'11109','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31888,'56186','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28294,'50340','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27688,'49748','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11691,'25102','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4483,'12133','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(355,'01351','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43228,'73931','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17521,'33837','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16354,'32067','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36160,'62441','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33609,'58497','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14316,'29376','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28656,'50672','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12849,'27501','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28132,'50207','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51406,'92605','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53370,'96703','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53576,'97039','Sherman','41055','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33592,'58484','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14078,'29036','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13453,'28255','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11540,'24830','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21705,'40740','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26624,'48435','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35681,'61841','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31634,'55973','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21839,'41033','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22408,'42327','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23134,'43616','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47813,'80941','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37201,'63771','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4781,'12583','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4267,'11731','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49577,'86315','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52051,'94110','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29318,'52309','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16434,'32163','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37125,'63632','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37649,'64646','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20081,'38313','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54769,'99133','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39777,'68065','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46672,'79024','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42415,'72601','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26893,'48787','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25845,'47432','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1250,'03839','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9315,'20634','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19859,'37930','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38266,'65637','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18529,'35972','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17238,'33424','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32975,'57501','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32925,'57450','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51425,'92629','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53114,'96062','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20366,'38635','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17062,'33090','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41074,'70584','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1784,'4983','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23190,'43740','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28341,'50436','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45379,'77088','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46728,'79062','Hansford','48195','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49007,'84639','Juab','49023','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51922,'93714','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20219,'38474','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17322,'33540','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37807,'64849','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46940,'79355','Yoakum','48501','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4033,'10983','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5146,'13148','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44190,'75456','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45700,'77523','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48407,'83278','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50294,'89139','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53206,'96201','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(20493,'38824','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19457,'37329','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34470,'60040','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3506,'09524','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(15429,'30548','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13613,'28410','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3026,'08081','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10572,'23168','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29539,'52647','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22712,'43060','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46782,'79096','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48943,'84401','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41924,'72025','Yell','5149','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3927,'10562','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3620,'09757','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2946,'07980','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45020,'76561','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8531,'19116','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19365,'37185','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13416,'28212','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4843,'12766','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48009,'81327','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48946,'84404','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(40709,'69336','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9446,'20813','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42037,'72114','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21321,'40059','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36818,'63101','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35611,'61747','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34843,'60552','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20795,'39182','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32962,'57473','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15982,'31510','Jeff Davis','13161','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29987,'53561','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15391,'30528','White','13311','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7344,'16882','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10902,'23881','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47199,'79831','Brewster','48043','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9525,'20997','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23552,'44241','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6109,'14855','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51928,'93720','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2930,'07938','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10001,'22082','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51063,'92028','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42320,'72474','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16323,'32034','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41073,'70583','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21505,'40340','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27530,'49618','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48513,'83460','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(9731,'21528','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11985,'25670','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13561,'28365','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33842,'58775','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45291,'77005','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52830,'95644','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33076,'57638','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17639,'33983','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8944,'20049','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(25816,'47388','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4014,'10963','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39890,'68329','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38450,'65784','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21170,'39766','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15843,'31079','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33075,'57638','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13237,'27978','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26010,'47637','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7948,'18012','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21901,'41097','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51194,'92220','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2985,'08037','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54591,'98673','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54808,'99171','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35801,'62006','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35369,'61428','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32154,'56393','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22999,'43441','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19760,'37830','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42190,'72351','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39700,'68001','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35521,'61569','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30084,'53808','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12951,'27581','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50879,'91402','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7161,'16613','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21227,'39851','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21048,'39577','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21000,'39483','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20736,'39117','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31724,'56058','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12733,'27285','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54910,'99517','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53761,'97326','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51365,'92536','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29228,'52203','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30207,'54013','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12401,'26448','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(691,'02212','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1167,'03582','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32726,'57264','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1579,'04565','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2481,'06783','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(46433,'78659','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43385,'74119','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20028,'38201','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41067,'70578','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13970,'28743','Madison','37115','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4723,'12520','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48310,'82936','Uinta','56041','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(10036,'22191','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41619,'71457','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38650,'66408','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13751,'28560','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32658,'57218','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30678,'54667','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24869,'46147','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6735,'15828','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48434,'83332','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(55107,'99760','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(43680,'74764','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7541,'17214','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34234,'59531','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33324,'58214','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16611,'32428','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23776,'44639','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31575,'55932','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18913,'36543','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45858,'77868','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46716,'79056','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45649,'77480','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45660,'77487','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54370,'98364','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5198,'13301','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42344,'72521','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40742,'69360','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8833,'19808','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(28795,'51038','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16817,'32720','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26886,'48767','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22418,'42339','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44412,'75772','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49769,'87301','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(8293,'18702','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42209,'72370','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11077,'24084','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14745,'29911','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41369,'71130','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22535,'42553','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27341,'49317','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20223,'38475','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26972,'48851','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24373,'45481','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12869,'27516','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10851,'23830','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8053,'18216','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53096,'96044','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28691,'50842','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35925,'62219','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19693,'37754','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48909,'84309','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51293,'92352','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39106,'67109','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17286,'33476','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44168,'75443','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30375,'54403','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39217,'67344','Chautauqua','20019','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7765,'17737','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41690,'71660','Bradley','5011','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5013,'12993','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41470,'71276','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34419,'59929','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30406,'54422','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8767,'19543','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39815,'68130','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50578,'90248','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46691,'79039','Carson','48065','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10732,'23438','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25132,'46539','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29747,'53086','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30114,'53920','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30309,'54171','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10101,'22402','Fredericksburg City','51630','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6239,'15071','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18035,'35056','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20757,'39150','Claiborne','28021','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1450,'04282','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18653,'36080','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11200,'24243','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48457,'83349','Lincoln','16063','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(35141,'61073','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53713,'97236','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5261,'13401','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29398,'52404','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6635,'15690','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32394,'56667','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33760,'58705','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36078,'62355','Calhoun','17013','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36423,'62726','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19144,'37018','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19958,'38079','Lake','47095','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19087,'36858','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19008,'36744','Hale','1065','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18786,'36323','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1038,'03103','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(31552,'55910','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29295,'52248','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52383,'95004','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1040,'03103','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4638,'12430','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4960,'12928','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53935,'97531','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26899,'48807','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31784,'56110','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25321,'46804','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37189,'63755','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15683,'30830','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9696,'21273','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5042,'13037','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41102,'70632','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33916,'59019','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11517,'24736','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11958,'25617','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22031,'41459','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27603,'49677','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45991,'78058','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52161,'94306','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42095,'72160','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23784,'44645','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15863,'31091','Pulaski','13235','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18933,'36568','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9351,'20692','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17776,'34274','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15172,'30305','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37258,'63857','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36575,'62890','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26162,'47920','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31559,'55918','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44551,'75978','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49897,'87732','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(47970,'81226','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46637,'78961','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36546,'62871','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50142,'88538','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(35414,'61466','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25004,'46282','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34132,'59404','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34015,'59213','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30268,'54131','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30695,'54724','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47595,'80516','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51631,'93227','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19611,'37657','Unicoi','47171','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53474,'96817','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41501,'71325','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16340,'32055','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8346,'18846','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41359,'71111','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14433,'29512','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35365,'61424','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25220,'46725','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50542,'90084','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52488,'95159','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(427,'01537','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45416,'77228','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23279,'43901','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21580,'40410','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13107,'27843','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6336,'15241','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37633,'64638','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36272,'62547','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32929,'57452','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21845,'41037','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24735,'46018','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47247,'79928','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19627,'37683','Johnson','47091','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49784,'87323','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36295,'62561','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38253,'65631','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42418,'72611','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4367,'11968','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10701,'23401','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3493,'09503','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8135,'18372','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12456,'26581','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11252,'24322','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42982,'73520','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34948,'60691','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22241,'42051','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24461,'45678','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29099,'51652','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34162,'59435','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34807,'60522','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45085,'76651','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47539,'80449','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53325,'96608','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(161,'00933','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13935,'28713','Swain','37173','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23043,'43511','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24626,'45843','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16668,'32509','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15018,'30170','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14382,'29453','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32584,'57051','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36864,'63137','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38485,'66008','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6257,'15090','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9065,'20186','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26844,'48741','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25568,'47118','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25555,'47108','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49753,'87174','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43038,'73564','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38054,'65327','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13866,'28652','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37842,'65013','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22374,'42259','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22591,'42728','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23579,'44275','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45499,'77339','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54502,'98564','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20573,'38901','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(37213,'63782','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33394,'58278','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33223,'58030','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32920,'57446','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28453,'50538','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27709,'49766','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21547,'40376','Powell','21197','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46163,'78288','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38821,'66732','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19115,'36901','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47698,'80741','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8515,'19099','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41400,'71213','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35968,'62255','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42139,'72223','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10485,'23069','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12321,'26330','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18246,'35462','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13156,'27883','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25275,'46773','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18528,'35972','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54879,'99353','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31938,'56235','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28740,'51005','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27645,'49716','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20909,'39362','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24874,'46148','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36735,'63014','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52884,'95694','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50797,'91214','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43643,'74726','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9479,'20866','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37674,'64664','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3919,'10547','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9075,'20196','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11611,'24963','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17736,'34222','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27617,'49684','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42522,'72733','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42659,'72943','Logan','5083','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43470,'74362','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45552,'77382','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14884,'30075','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30983,'54982','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3638,'09813','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43021,'73550','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39848,'68197','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29010,'51541','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16426,'32149','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11087,'24092','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(460,'01610','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35842,'62048','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23217,'43767','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25395,'46926','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53232,'96306','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54660,'98921','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(13648,'28445','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13433,'28227','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10404,'22963','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10804,'23651','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5442,'13692','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49520,'85931','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4494,'12143','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30907,'54926','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3730,'10060','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27689,'49749','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23337,'43964','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41358,'71110','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47550,'80463','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48945,'84403','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(7726,'17576','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47929,'81130','Mineral','8079','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(857,'02669','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46251,'78414','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30386,'54409','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3861,'10463','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18504,'35954','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19025,'36758','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29144,'52057','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22609,'42748','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42172,'72335','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53482,'96825','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53538,'97007','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19329,'37150','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22780,'43116','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26905,'48809','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26576,'48382','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32051,'56320','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21930,'41149','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16952,'32919','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16944,'32905','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4740,'12538','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1954,'05486','Grand Isle','50013','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9207,'20472','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1371,'04083','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(43229,'73932','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52432,'95065','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26999,'48875','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9749,'21557','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17010,'33020','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2547,'06910','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3265,'08759','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(736,'02356','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49990,'88072','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50840,'91345','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33525,'58433','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13428,'28222','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33523,'58430','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25589,'47133','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49954,'88023','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45286,'76958','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40389,'68860','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(21554,'40383','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13001,'27621','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28875,'51248','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28794,'51037','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20904,'39359','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24393,'45616','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47685,'80731','Phillips','8095','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50978,'91769','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8229,'18518','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36514,'62852','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31410,'55589','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27923,'50029','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27767,'49831','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45195,'76853','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45523,'77358','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51023,'91935','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10276,'22724','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8020,'18081','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37868,'65039','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2197,'06107','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(13265,'28026','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2416,'06521','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(21436,'40241','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26900,'48807','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51802,'93544','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53484,'96828','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(38242,'65623','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9856,'21755','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47000,'79430','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6,'00604','Aguadilla','72005','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(13986,'28756','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11816,'25305','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27344,'49318','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18904,'36532','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19121,'36913','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19242,'37078','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40722,'69346','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54820,'99204','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30762,'54762','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41565,'71411','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13884,'28667','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3295,'08829','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5016,'12997','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13855,'28644','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21893,'41092','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21653,'40515','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17674,'34091','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(11698,'25110','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8261,'18625','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12514,'26707','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16432,'32162','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19846,'37917','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20395,'38658','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25979,'47588','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53242,'96336','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49567,'86053','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42757,'73048','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50709,'90803','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52719,'95487','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30025,'53588','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4344,'11942','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18220,'35404','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44111,'75392','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28971,'51467','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25350,'46862','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47424,'80214','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53609,'97076','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34478,'60047','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30553,'54540','Gogebic','26053','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27306,'49285','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28446,'50532','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45947,'78014','La Salle','48283','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48502,'83445','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(10810,'23665','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3837,'10303','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13571,'28373','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17597,'33927','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48031,'81418','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50688,'90716','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52370,'94973','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53183,'96135','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53854,'97429','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34753,'60474','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23941,'44853','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20435,'38723','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18241,'35457','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43084,'73655','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36348,'62643','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(103,'00775','Culebra','72049','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3845,'10311','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31962,'56256','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31621,'55964','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5435,'13682','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26354,'48097','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50292,'89137','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36209,'62469','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3682,'09880','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(10520,'23111','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18081,'35114','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20586,'38922','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51752,'93452','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54347,'98340','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41339,'71075','Webster','22119','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39464,'67631','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10826,'23704','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8106,'18328','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21588,'40423','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4025,'10975','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35115,'61052','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4963,'12932','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2541,'06902','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7331,'16870','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42416,'72601','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44199,'75469','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52606,'95353','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53872,'97448','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53655,'97135','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51059,'92025','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13597,'28393','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37644,'64644','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12609,'27040','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(14800,'30012','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37874,'65041','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36169,'62445','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35668,'61824','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34322,'59755','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27304,'49284','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21346,'40076','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39350,'67502','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48431,'83327','Camas','16025','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52390,'95011','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1070,'03235','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8140,'18407','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28496,'50566','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1857,'05152','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(38962,'66942','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2262,'06248','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26132,'47875','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25082,'46401','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23717,'44512','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23107,'43557','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47266,'79946','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49021,'84655','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(26327,'48068','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23256,'43822','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32270,'56537','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12065,'25841','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15720,'31012','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38957,'66938','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18394,'35653','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18499,'35952','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46999,'79424','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48140,'82073','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(50513,'90055','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51280,'92335','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28131,'50207','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54042,'97844','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43912,'75091','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41954,'72045','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16721,'32579','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24438,'45657','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15733,'31016','Upson','13293','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37541,'64458','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36516,'62853','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30001,'53572','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20996,'39482','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46136,'78252','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51913,'93704','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52041,'94087','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49206,'85172','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21519,'40351','Rowan','21205','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20270,'38552','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17562,'33883','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22087,'41605','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24355,'45434','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15777,'31037','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15446,'30560','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5265,'13404','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37278,'63880','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13171,'27894','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36507,'62846','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9737,'21536','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(100,'00771','Las Piedras','72085','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(4166,'11417','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11110,'24124','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29486,'52583','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28143,'50214','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51873,'93637','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50927,'91616','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20903,'39358','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21521,'40353','Clark','21049','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14473,'29567','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29254,'52218','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30359,'54247','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(911,'02806','Bristol','44001','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(38591,'66105','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8601,'19255','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11384,'24522','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12344,'26372','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19054,'36786','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22006,'41339','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(519,'01841','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21480,'40311','Nicholas','21181','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29691,'53036','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36964,'63385','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38985,'66959','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16390,'32114','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27440,'49425','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28399,'50476','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40537,'69020','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42835,'73107','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43257,'74011','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44968,'76520','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52099,'94207','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6026,'14760','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45865,'77872','Madison','48313','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42574,'72820','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19436,'37315','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18859,'36467','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29887,'53268','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30592,'54568','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34568,'60135','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17195,'33328','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3116,'08324','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38895,'66839','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2762,'07604','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7468,'17064','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15532,'30642','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39536,'67672','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6610,'15668','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22447,'42367','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52731,'95518','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(371,'01420','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20879,'39337','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25565,'47117','Floyd','18043','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1814,'05051','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27552,'49634','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29680,'53027','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31169,'55317','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32834,'57362','Buffalo','46017','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3286,'08822','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(853,'02664','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(28190,'50240','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25517,'47018','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25062,'46374','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21155,'39752','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40444,'68932','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23456,'44108','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7797,'17771','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29101,'51653','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6220,'15053','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30490,'54480','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6573,'15622','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2754,'07524','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15810,'31060','Telfair','13271','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15050,'30204','Lamar','13171','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7407,'17019','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45576,'77418','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51035,'91963','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50833,'91335','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44666,'76107','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10502,'23089','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14531,'29621','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35937,'62234','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37961,'65217','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37345,'64020','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36409,'62703','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16898,'32819','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4442,'12072','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25158,'46562','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40792,'70070','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42251,'72416','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32175,'56437','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(50579,'90249','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44793,'76302','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21846,'41039','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20562,'38873','Tishomingo','28141','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13127,'27861','Martin','37117','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12445,'26563','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36920,'63348','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15083,'30230','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45678,'77503','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3133,'08346','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49970,'88041','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(41238,'70818','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25208,'46710','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10268,'22715','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9218,'20510','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36267,'62544','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35902,'62091','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31047,'55046','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46523,'78753','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50982,'91773','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10109,'22407','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39054,'67047','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12088,'25876','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10950,'23937','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10336,'22844','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6632,'15687','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2366,'06459','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50515,'90057','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53104,'96054','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47312,'80020','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45759,'77591','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21561,'40390','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5399,'13648','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37427,'64112','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8894,'19971','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(37155,'63663','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39758,'68047','Thurston','31173','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44479,'75862','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(327,'01255','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(48006,'81325','Dolores','8033','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(25215,'46721','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10987,'23974','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32021,'56296','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34693,'60431','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4634,'12424','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13462,'28269','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34533,'60105','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12177,'26103','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40815,'70097','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42265,'72429','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50213,'89019','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54966,'99604','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(5207,'13312','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49688,'87035','Torrance','35057','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44723,'76201','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28888,'51338','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(597,'02043','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13411,'28207','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32242,'56514','Wilkin','27167','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(24077,'45135','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22759,'43102','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22249,'42058','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11660,'25049','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11150,'24161','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7336,'16874','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10750,'23460','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4743,'12542','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48350,'83203','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45054,'76627','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5982,'14717','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20227,'38476','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28706,'50854','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40175,'68669','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47306,'80015','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49468,'85719','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53591,'97056','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53556,'97022','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44577,'76020','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44019,'75212','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36590,'62899','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37822,'64862','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14927,'30104','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31671,'56014','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27918,'50027','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27111,'49035','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24297,'45371','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6275,'15127','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6944,'16156','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11715,'25132','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8391,'18949','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39494,'67646','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22482,'42440','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30746,'54755','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13797,'28602','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13859,'28645','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10885,'23860','Hopewell City','51670','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38837,'66746','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23376,'44023','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23656,'44429','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24766,'46050','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23665,'44440','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45790,'77655','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51423,'92627','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52404,'95030','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53144,'96095','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54430,'98443','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44,'00680','Mayaguez','72097','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(1440,'04266','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10635,'23242','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17145,'33199','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11859,'25396','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11426,'24562','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40465,'68942','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43494,'74427','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43838,'75023','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44262,'75561','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46659,'79015','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54100,'98010','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37485,'64188','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9206,'20470','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2106,'05904','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9542,'21029','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36626,'62922','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4021,'10969','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39115,'67114','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39000,'67004','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1311,'04003','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37157,'63665','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6447,'15422','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35295,'61342','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27030,'48893','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17363,'33586','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39865,'68314','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40675,'69201','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49235,'85233','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34723,'60451','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24033,'45066','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27280,'49261','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28783,'51031','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4215,'11561','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36762,'63036','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6246,'15081','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17777,'34275','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52396,'95018','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49303,'85332','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42448,'72639','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41942,'72037','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28956,'51455','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11542,'24834','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13369,'28133','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13670,'28460','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6029,'14769','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1211,'03777','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(38005,'65263','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14764,'29931','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39522,'67661','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11328,'24450','Lexington City','51678','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12832,'27415','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37374,'64061','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19675,'37732','Scott','47151','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30147,'53942','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47162,'79754','Loving','48301','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47724,'80809','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8212,'18471','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1511,'04431','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17589,'33917','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30856,'54867','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18049,'35072','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43253,'74008','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48178,'82310','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54691,'99004','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29281,'52236','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16724,'32588','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35131,'61064','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2949,'08001','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9258,'20560','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(6928,'16141','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19935,'38058','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20681,'39069','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40228,'68742','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38900,'66843','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19397,'37218','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19370,'37187','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22357,'42221','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8298,'18707','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34784,'60505','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16175,'31757','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38550,'66064','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32347,'56601','Hubbard','27057','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10553,'23141','New Kent','51127','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26221,'47962','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23599,'44303','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17877,'34679','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39405,'67556','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41566,'71414','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40367,'68843','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7947,'18011','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18043,'35063','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8857,'19930','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(24184,'45269','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25133,'46539','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17214,'33388','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33681,'58581','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26064,'47801','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12041,'25776','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3661,'09838','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(17260,'33445','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29660,'53014','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11695,'25108','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5564,'13864','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8032,'18099','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5766,'14416','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47976,'81231','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18124,'35160','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41091,'70607','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44432,'75792','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47890,'81064','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49928,'87931','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(5078,'13073','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54958,'99587','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(23541,'44232','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38092,'65355','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(165,'00937','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(16048,'31564','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16540,'32321','Liberty','12077','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37256,'63855','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46695,'79040','Sherman','48421','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42306,'72462','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19607,'37650','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2199,'06109','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(39432,'67572','Trego','20195','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34934,'60674','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27087,'49017','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26088,'47838','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24563,'45780','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24529,'45741','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33005,'57541','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40773,'70050','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26276,'48005','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38032,'65287','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8577,'19171','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9410,'20759','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24371,'45475','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50685,'90713','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51397,'92591','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43462,'74354','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43173,'73761','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19452,'37327','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18687,'36123','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11108,'24121','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7900,'17932','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7795,'17768','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14684,'29819','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2158,'06066','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8290,'18661','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31553,'55912','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19433,'37312','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29801,'53143','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24282,'45359','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42510,'72717','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46603,'78941','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49150,'85051','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52927,'95818','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30845,'54855','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48327,'83101','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(46941,'79356','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42467,'72655','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20371,'38639','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25362,'46898','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16318,'32024','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11901,'25506','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11950,'25573','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14038,'28816','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13231,'27970','Washington','37187','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6324,'15229','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37628,'64635','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36958,'63382','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34653,'60303','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15757,'31030','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18206,'35287','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20545,'38863','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40279,'68776','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(54733,'99101','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5077,'13073','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30161,'53952','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42454,'72644','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28465,'50543','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31504,'55771','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33245,'58046','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23521,'44212','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35716,'61863','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12646,'27109','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(55009,'99651','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52661,'95420','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49036,'84715','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9614,'21140','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10654,'23290','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4015,'10963','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39751,'68044','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11492,'24639','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36933,'63359','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22102,'41636','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43366,'74085','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46353,'78612','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48496,'83442','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49475,'85726','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35762,'61928','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44991,'76534','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29090,'51646','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12680,'27215','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29279,'52233','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30369,'54313','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7608,'17315','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16408,'32131','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16502,'32241','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(229,'01032','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14300,'29355','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33378,'58265','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13470,'28277','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45628,'77464','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46786,'79098','Oldham','48359','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35375,'61434','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51682,'93283','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42065,'72132','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41966,'72057','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20743,'39121','Adams','28001','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21590,'40437','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4240,'11695','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14688,'29822','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29700,'53042','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42539,'72745','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45808,'77706','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47090,'79561','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37629,'64636','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48400,'83271','Power','16077','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6687,'15753','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12161,'26047','Hancock','54029','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35515,'61564','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32934,'57456','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31546,'55904','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7942,'18001','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27312,'49288','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11280,'24366','Bland','51021','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43236,'73945','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43184,'73770','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1572,'04554','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38124,'65457','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37976,'65243','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21432,'40231','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20068,'38261','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5136,'13141','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13247,'28006','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25959,'47567','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19437,'37316','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50994,'91792','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38944,'66901','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41423,'71233','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40582,'69045','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7178,'16633','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17842,'34489','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20104,'38333','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30316,'54180','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7055,'16353','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14476,'29570','Marlboro','45069','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11236,'24301','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7648,'17363','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46099,'78216','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53943,'97539','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(441,'01568','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42010,'72087','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26171,'47926','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28123,'50171','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(970,'02891','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(9150,'20389','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22874,'43231','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24786,'46064','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40883,'70339','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46283,'78538','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16035,'31554','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38540,'66056','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32889,'57426','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38548,'66063','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52019,'94035','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25446,'46962','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22605,'42746','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40292,'68784','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27253,'49240','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32280,'56545','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33591,'58484','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35428,'61474','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40392,'68863','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43373,'74106','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20958,'39452','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19795,'37867','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19621,'37665','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15790,'31044','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16651,'32462','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6011,'14743','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9073,'20194','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20100,'38330','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52458,'95121','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43887,'75068','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41781,'71833','Howard','5061','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32388,'56661','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(13848,'28641','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38813,'66717','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23516,'44203','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22303,'42134','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47841,'81012','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51462,'92694','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52995,'95937','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53236,'96321','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(40438,'68927','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42541,'72749','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20456,'38751','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35541,'61616','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18181,'35233','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1886,'05346','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(32956,'57470','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7971,'18039','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43570,'74545','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43512,'74438','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15348,'30499','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6603,'15661','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13800,'28604','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21751,'40849','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1447,'04276','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(19441,'37321','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17106,'33155','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29290,'52244','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44523,'75954','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46925,'79345','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48288,'82835','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(52696,'95459','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41765,'71770','Nevada','5099','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21527,'40359','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39696,'67953','Morton','20129','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15642,'30805','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28922,'51432','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14991,'30147','Polk','13233','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27073,'49009','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49537,'86011','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26110,'47858','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21516,'40350','Nicholas','21181','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25044,'46349','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6306,'15211','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54877,'99350','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38722,'66523','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4534,'12185','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40780,'70057','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39926,'68350','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34714,'60447','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23716,'44511','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18480,'35894','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13359,'28125','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45592,'77433','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4660,'12452','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17621,'33956','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11959,'25621','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22023,'41390','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49974,'88045','Hidalgo','35023','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(27421,'49411','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28213,'50252','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50456,'89834','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53878,'97453','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(713,'02325','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1662,'04739','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(43751,'74866','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17870,'34661','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4224,'11575','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31601,'55951','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21568,'40402','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36494,'62838','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16171,'31750','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12263,'26238','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3104,'08312','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35187,'61130','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11421,'24557','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30523,'54514','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47346,'80103','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52866,'95679','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35192,'61230','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1641,'04675','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6107,'14853','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6923,'16134','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13160,'27887','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29855,'53206','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48505,'83448','Madison','16065','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(20919,'39366','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40397,'68865','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28209,'50250','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10612,'23226','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48042,'81429','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3313,'08854','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42922,'73432','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21338,'40071','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2157,'06065','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11326,'24448','Alleghany','51005','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24703,'45888','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49227,'85212','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(52127,'94263','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41988,'72073','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36783,'63055','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35752,'61917','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15428,'30548','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34105,'59336','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33735,'58647','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(48090,'81637','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52271,'94602','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(249,'01063','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43729,'74854','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11760,'25209','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18646,'36075','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17380,'33606','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29163,'52076','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49891,'87723','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(40032,'68452','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12617,'27045','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(2372,'06470','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14843,'30040','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10673,'23315','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8070,'18237','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40923,'70397','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40268,'68769','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16984,'32963','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35326,'61370','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24137,'45220','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9042,'20159','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11335,'24463','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9758,'21613','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12968,'27592','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6322,'15227','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51688,'93292','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25152,'46554','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53428,'96767','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(4031,'10982','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1712,'04859','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24910,'46171','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24260,'45342','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42911,'73194','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(948,'02862','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(17449,'33729','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37393,'64075','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16157,'31733','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33117,'57717','Butte','46019','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28822,'51056','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26654,'48455','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20707,'39090','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20615,'38948','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(50138,'88533','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(12622,'27048','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43283,'74027','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42327,'72479','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14865,'30056','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48545,'83542','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(17477,'33769','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1029,'03076','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30594,'54602','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37886,'65050','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12551,'26815','Pendleton','54071','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36004,'62277','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41050,'70554','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52228,'94557','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41033,'70537','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10381,'22940','Albemarle','51003','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6848,'16034','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7216,'16668','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14360,'29432','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34608,'60168','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37462,'64151','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43640,'74722','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23051,'43516','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23529,'44217','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18087,'35118','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36384,'62681','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36983,'63437','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38597,'66112','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10557,'23148','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12330,'26346','Pleasants','54073','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(297,'01144','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(40915,'70380','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44381,'75710','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8627,'19345','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33292,'58076','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15891,'31169','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22195,'41858','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33683,'58601','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36694,'62967','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51967,'93888','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39769,'68061','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17066,'33101','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19222,'37064','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21531,'40361','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34755,'60475','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2075,'05841','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27941,'50044','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23200,'43754','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4177,'11428','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13944,'28721','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27126,'49045','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40701,'69334','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35976,'62259','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38736,'66534','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53535,'97004','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6181,'15012','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48952,'84412','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21539,'40370','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9177,'20420','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(33958,'59061','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23854,'44710','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8401,'18960','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4869,'12790','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11863,'25404','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44600,'76044','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9434,'20787','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18359,'35610','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43431,'74331','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37519,'64440','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32301,'56563','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8468,'19049','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42214,'72374','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40281,'68777','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15478,'30599','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23472,'44124','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23646,'44422','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25056,'46368','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43179,'73763','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16301,'31995','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42083,'72150','Grant','5053','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11394,'24530','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3210,'08606','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26382,'48126','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45862,'77871','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45881,'77905','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47526,'80435','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49154,'85061','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(19463,'37332','Rhea','47143','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21695,'40701','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24446,'45661','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12247,'26217','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1985,'05658','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(6609,'15666','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18005,'35031','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41837,'71922','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34280,'59710','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34133,'59405','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31599,'55950','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29620,'52773','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1859,'05154','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(53408,'96746','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53665,'97145','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(21060,'39631','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26938,'48833','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49147,'85046','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34816,'60531','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1236,'03821','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(29541,'52649','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21520,'40353','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14758,'29924','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45861,'77870','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53005,'95945','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32957,'57471','Edmunds','46045','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5989,'14724','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11053,'24063','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32950,'57467','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19278,'37110','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24651,'45856','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23719,'44514','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23138,'43623','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54400,'98395','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8021,'18083','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42009,'72086','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40208,'68729','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38670,'66425','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18987,'36695','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29137,'52052','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18350,'35593','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16263,'31821','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23844,'44699','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44790,'76273','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42040,'72117','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15517,'30630','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1401,'04210','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33914,'59016','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46938,'79353','Cochran','48079','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47324,'80030','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54771,'99135','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42250,'72416','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10315,'22812','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17828,'34474','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37255,'63853','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32546,'57031','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44367,'75691','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38165,'65550','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11639,'25022','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27854,'49931','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14431,'29510','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13063,'27809','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(47569,'80481','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47710,'80751','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38168,'65552','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4143,'11367','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21451,'40261','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20866,'39328','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18016,'35036','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17129,'33179','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32343,'56592','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22308,'42141','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22154,'41763','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35981,'62262','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21168,'39760','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34407,'59917','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23797,'44657','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6074,'14822','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46890,'79259','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11135,'24142','Radford City','51750','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6730,'15825','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1783,'04982','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9621,'21155','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43029,'73555','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14396,'29470','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8378,'18932','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53369,'96701','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54780,'99143','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(18169,'35218','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51386,'92571','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51998,'93962','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10671,'23313','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16173,'31753','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46837,'79226','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49746,'87125','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54097,'98007','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27618,'49685','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44715,'76191','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51849,'93619','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52169,'94502','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5367,'13616','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9915,'21822','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11469,'24606','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34496,'60071','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12991,'27612','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45432,'77248','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52700,'95463','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54755,'99122','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41418,'71229','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6493,'15473','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12511,'26691','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11477,'24619','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2369,'06467','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23118,'43571','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23750,'44622','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25621,'47164','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(497,'01776','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10690,'23354','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2536,'06889','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35845,'62051','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30739,'54749','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42973,'73491','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32493,'56935','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(31038,'55038','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45978,'78046','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3565,'09636','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20053,'38242','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15903,'31208','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(435,'01550','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38578,'66092','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32072,'56332','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32177,'56438','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31650,'55987','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6467,'15443','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27234,'49227','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44891,'76450','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1879,'05304','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(21685,'40601','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1916,'05445','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(33580,'58476','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(6310,'15215','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17790,'34290','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25779,'47358','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11191,'24228','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6097,'14843','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50162,'88560','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(55072,'99723','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(37767,'64776','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27026,'48891','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44527,'75959','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3761,'10123','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10616,'23229','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17044,'33064','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13905,'28684','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53299,'96542','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53852,'97424','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33953,'59057','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45598,'77437','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13802,'28605','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37958,'65212','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23513,'44202','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32172,'56435','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(46809,'79118','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35127,'61063','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19638,'37694','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3238,'08720','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49070,'84751','Beaver','49001','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52985,'95925','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20843,'39301','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33364,'58251','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29656,'53012','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26147,'47905','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49982,'88054','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51308,'92373','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3796,'10174','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34235,'59531','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33342,'58229','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3744,'10106','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32854,'57373','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16549,'32331','Jefferson','12065','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27647,'49717','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27387,'49343','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50393,'89448','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51796,'93536','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52170,'94503','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41051,'70555','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38052,'65326','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33832,'58768','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16599,'32417','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23968,'44878','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52759,'95553','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20349,'38622','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25556,'47108','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22336,'42202','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5323,'13475','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47906,'81087','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51834,'93605','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52375,'94978','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29721,'53063','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32437,'56725','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9093,'20218','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19746,'37820','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19200,'37051','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8306,'18766','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21713,'40755','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13299,'28075','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46085,'78202','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46476,'78711','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48293,'82840','Johnson','56019','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(52805,'95621','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20099,'38329','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43476,'74365','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37801,'64843','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(22029,'41426','Magoffin','21153','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46158,'78279','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51579,'93063','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52541,'95246','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7685,'17521','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16747,'32622','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30571,'54556','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47691,'80734','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42088,'72153','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37346,'64021','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37327,'63966','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30798,'54816','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13920,'28698','Watauga','37189','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2568,'07010','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10719,'23423','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20153,'38369','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9186,'20429','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17673,'34090','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(26708,'48601','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21555,'40384','Woodford','21239','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10103,'22404','Fredericksburg City','51630','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45607,'77447','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49832,'87524','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(18858,'36467','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3218,'08619','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47919,'81121','Archuleta','8007','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35487,'61537','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4286,'11755','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9149,'20388','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20421,'38683','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20176,'38389','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19903,'38028','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24094,'45154','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5288,'13431','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10277,'22725','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46910,'79329','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48155,'82212','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(53293,'96534','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(3806,'10212','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6506,'15488','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12772,'27325','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30732,'54745','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23374,'44022','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23045,'43512','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49138,'85037','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(35059,'61007','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41585,'71427','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3399,'09128','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(1273,'03862','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26314,'48050','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38256,'65632','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29135,'52050','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24907,'46167','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(542,'01888','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3948,'10595','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(673,'02180','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30205,'54010','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12678,'27214','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2807,'07711','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22045,'41519','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49986,'88061','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53021,'95960','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1591,'04606','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(36738,'63016','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18474,'35813','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17835,'34481','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32663,'57221','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4,'00602','Aguada','72003','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19292,'37122','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41877,'71966','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40128,'68637','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18569,'36016','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12612,'27042','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(16461,'32201','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27901,'50013','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50155,'88553','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(52238,'94567','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41328,'71069','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(19588,'37605','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29826,'53176','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28539,'50597','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8592,'19190','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43829,'75014','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24189,'45275','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15969,'31414','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7985,'18051','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7184,'16638','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(823,'02601','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50479,'90021','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22722,'43065','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23141,'43654','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17811,'34446','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40670,'69169','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37188,'63752','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31133,'55128','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8353,'18854','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24048,'45107','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51454,'92683','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42249,'72415','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17152,'33239','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25425,'46947','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39844,'68179','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47512,'80421','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52468,'95131','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54183,'98115','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2145,'06050','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20575,'38902','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43692,'74824','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17092,'33140','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34670,'60410','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38629,'66224','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5386,'13634','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46727,'79061','Wheeler','48483','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54470,'98531','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39968,'68379','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18051,'35072','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32714,'57258','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7911,'17948','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2510,'06830','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3893,'10516','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7807,'17801','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6758,'15860','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40242,'68752','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3731,'10065','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26663,'48460','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5635,'14061','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1282,'03872','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(23777,'44640','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22821,'43149','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17136,'33186','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44117,'75401','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24036,'45069','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19289,'37119','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39820,'68135','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16607,'32425','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11006,'24014','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51294,'92354','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9314,'20632','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42514,'72722','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38719,'66521','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7448,'17049','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35163,'61089','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28153,'50220','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21818,'41008','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13133,'27866','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12406,'26456','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7288,'16825','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49031,'84710','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51786,'93527','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26715,'48607','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19015,'36750','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6180,'15010','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21281,'40023','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43291,'74032','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49754,'87176','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(33069,'57633','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2057,'05820','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(41473,'71277','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39626,'67842','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7525,'17124','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12935,'27565','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12063,'25839','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48812,'84066','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(19876,'38002','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16582,'32362','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50282,'89127','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51379,'92557','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32547,'57031','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(639,'02125','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19823,'37880','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32291,'56554','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7089,'16405','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21236,'39862','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10780,'23515','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10683,'23328','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43836,'75021','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50708,'90802','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53782,'97350','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(17853,'34607','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17634,'33975','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33087,'57645','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29637,'52809','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25130,'46538','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4144,'11368','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50713,'90807','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9157,'20398','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42324,'72476','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(16726,'32601','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32456,'56738','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(13945,'28722','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3039,'08091','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44919,'76464','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45761,'77597','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49768,'87199','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(19324,'37148','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7603,'17310','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28687,'50840','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52944,'95835','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(592,'02032','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8365,'18918','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37863,'65035','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20168,'38380','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2837,'07748','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2703,'07421','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26285,'48017','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23380,'44028','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46420,'78653','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54861,'99338','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(17935,'34787','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8763,'19540','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16311,'32008','Lafayette','12067','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43648,'74729','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47521,'80429','Lake','8065','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(40962,'70450','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2520,'06855','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18869,'36476','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34044,'59250','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30951,'54961','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11770,'25235','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46613,'78946','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47103,'79601','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48401,'83272','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48629,'83670','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48649,'83712','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51679,'93279','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53465,'96808','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(5770,'14420','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28071,'50143','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15650,'30810','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15602,'30731','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25153,'46555','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45421,'77234','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45961,'78023','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54356,'98351','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5668,'14107','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6290,'15143','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40572,'69040','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38764,'66550','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44500,'75932','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40168,'68663','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17397,'33623','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39925,'68349','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5202,'13305','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35444,'61482','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52704,'95467','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1465,'04338','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22000,'41314','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34808,'60523','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26222,'47963','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48275,'82730','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48708,'83840','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54796,'99159','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40996,'70512','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35672,'61830','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18589,'36031','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16838,'32751','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15521,'30633','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34968,'60912','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48355,'83209','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(30556,'54542','Florence','55037','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33037,'57571','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41894,'72005','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40244,'68752','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11596,'24925','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48218,'82450','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51366,'92539','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51502,'92833','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9126,'20277','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7097,'16412','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50378,'89434','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51598,'93118','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40807,'70087','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7962,'18031','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40402,'68869','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36850,'63127','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53791,'97360','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36885,'63166','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26833,'48734','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48200,'82421','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(50913,'91601','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51370,'92546','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54431,'98444','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4216,'11563','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1888,'05351','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(38322,'65681','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19402,'37222','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2295,'06336','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25785,'47360','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22073,'41560','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21656,'40516','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14777,'29943','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12932,'27562','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45524,'77359','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45676,'77501','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(694,'02222','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4979,'12952','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34277,'59702','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34002,'59107','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(55022,'99664','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(41342,'71078','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43365,'74085','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42720,'73023','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1411,'04224','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10239,'22645','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16213,'31784','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32489,'56904','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(31857,'56162','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31624,'55967','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31310,'55412','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44912,'76462','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41147,'70711','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38777,'66610','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33237,'58040','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23274,'43843','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51712,'93402','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54896,'99502','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(29400,'52405','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42109,'72176','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4391,'12020','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2768,'07621','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6432,'15378','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33217,'58021','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45175,'76832','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45931,'78003','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46605,'78942','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48085,'81632','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39654,'67861','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36186,'62452','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16081,'31630','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17744,'34230','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6541,'15552','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37481,'64179','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50652,'90622','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37249,'63848','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37537,'64456','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29150,'52065','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17719,'34203','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39272,'67436','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39822,'68136','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10861,'23837','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42162,'72326','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7711,'17557','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10027,'22159','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5751,'14273','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24118,'45177','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3033,'08087','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5015,'12996','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8408,'18969','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27495,'49510','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41408,'71222','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54698,'99009','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45143,'76706','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4053,'11005','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13608,'28405','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28074,'50145','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6482,'15461','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42748,'73044','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42908,'73185','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42295,'72454','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24267,'45345','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22925,'43331','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22692,'43041','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54821,'99205','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35606,'61744','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19351,'37175','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33457,'58361','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12959,'27587','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31202,'55335','Sibley','27143','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30872,'54880','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20488,'38804','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31774,'56096','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39710,'68007','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41170,'70738','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45233,'76880','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21658,'40522','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22808,'43143','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49064,'84744','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9222,'20521','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(43357,'74080','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(668,'02163','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(653,'02139','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6115,'14860','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46602,'78941','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6092,'14840','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20403,'38665','Tate','28137','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41828,'71909','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51562,'93023','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11728,'25149','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16623,'32438','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19319,'37145','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23156,'43713','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24514,'45723','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28823,'51056','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44392,'75755','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50727,'90842','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48962,'84518','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51531,'92877','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7617,'17323','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(641,'02127','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31381,'55558','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26610,'48426','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16742,'32618','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18160,'35210','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54036,'97839','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45038,'76578','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43458,'74352','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41538,'71360','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3312,'08853','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12606,'27030','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(36027,'62298','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38419,'65761','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11007,'24015','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36192,'62460','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24616,'45835','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6477,'15455','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19896,'38021','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21021,'39553','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22537,'42558','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48013,'81330','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44326,'75656','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9798,'21657','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6118,'14864','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3439,'09313','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12737,'27291','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43511,'74437','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37548,'64465','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5983,'14718','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12052,'25818','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7406,'17019','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51765,'93475','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41049,'70552','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49809,'87501','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(7538,'17212','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44960,'76511','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14395,'29469','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37760,'64769','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32487,'56901','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(33141,'57741','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3569,'09647','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53670,'97201','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51853,'93621','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43002,'73536','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41424,'71234','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33253,'58049','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27528,'49616','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27332,'49311','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23405,'44057','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20949,'39440','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3589,'09719','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53332,'96616','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(21792,'40962','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11434,'24570','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50976,'91767','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33778,'58723','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25617,'47161','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10133,'22454','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17430,'33688','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8877,'19952','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(53545,'97014','Hood River','41027','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4104,'11224','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35344,'61412','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(149,'00920','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(48572,'83615','Valley','16085','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49251,'85258','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50002,'88116','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50539,'90081','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36577,'62890','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9331,'20660','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7047,'16345','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17826,'34472','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48029,'81416','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(15652,'30812','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8373,'18927','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25646,'47223','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46518,'78749','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51401,'92596','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11261,'24330','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13341,'28107','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22811,'43145','Fayette','39047','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47855,'81036','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49229,'85214','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50871,'91387','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2554,'06922','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41818,'71861','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27720,'49776','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16812,'32715','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15945,'31321','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4882,'12816','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13612,'28409','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24106,'45166','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30929,'54943','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31652,'55990','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38671,'66426','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50397,'89452','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(27734,'49792','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29813,'53152','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37321,'63961','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45901,'77974','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1179,'03598','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16270,'31825','Marion','13197','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12948,'27574','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52841,'95655','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50264,'89109','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(38215,'65608','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34167,'59442','Chouteau','30015','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11318,'24439','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2795,'07666','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(591,'02030','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10365,'22920','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3303,'08837','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6279,'15132','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23643,'44417','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2107,'05905','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12155,'26036','Marshall','54051','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24347,'45430','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37684,'64670','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10267,'22714','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4835,'12758','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16056,'31569','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36691,'62964','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37882,'65048','Osage','29151','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9708,'21289','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33758,'58703','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19514,'37366','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7714,'17563','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3619,'09752','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(5439,'13687','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29901,'53407','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54019,'97819','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50624,'90406','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50594,'90272','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25008,'46291','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37328,'63966','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12814,'27374','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30082,'53807','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27079,'49011','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27962,'50055','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48209,'82432','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(52400,'95023','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7666,'17408','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37003,'63448','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25558,'47111','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27792,'49861','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36727,'63005','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44027,'75221','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2310,'06371','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(43926,'75104','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38494,'66015','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48947,'84405','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53483,'96826','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(44026,'75220','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42879,'73149','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3304,'08840','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40913,'70377','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12557,'26838','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29161,'52074','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25248,'46747','Steuben','18151','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44941,'76483','Throckmorton','48447','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46721,'79058','Moore','48341','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3776,'10154','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20861,'39325','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40952,'70444','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38083,'65350','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35263,'61318','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33073,'57638','Adams','38001','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30893,'54914','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22699,'43046','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48853,'84109','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50791,'91205','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52317,'94804','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54489,'98550','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20002,'38150','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18953,'36603','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33965,'59065','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23226,'43777','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51250,'92301','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43715,'74844','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7314,'16852','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37474,'64164','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34018,'59214','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(24294,'45369','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30822,'54835','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28233,'50265','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48745,'83876','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50075,'88338','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(21852,'41043','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14242,'29219','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41071,'70582','Saint Martin','22099','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38696,'66502','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(28184,'50237','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30498,'54487','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33139,'57737','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34076,'59301','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14891,'30080','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16574,'32355','Wakulla','12129','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37750,'64759','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10111,'22408','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20914,'39365','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44252,'75554','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6784,'15924','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36817,'63099','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3349,'08933','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27003,'48877','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50396,'89451','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5935,'14607','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12975,'27597','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12476,'26617','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36497,'62838','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27307,'49285','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19769,'37846','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37763,'64771','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14731,'29860','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9465,'20847','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21203,'39829','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25886,'47460','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13172,'27895','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6136,'14877','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44587,'76033','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34246,'59545','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(32816,'57348','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12590,'27018','Yadkin','37197','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(14177,'29130','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14533,'29623','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35402,'61453','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53355,'96671','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(10623,'23232','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45182,'76842','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53172,'96125','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25128,'46536','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38144,'65484','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33006,'57543','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50493,'90035','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51343,'92427','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39927,'68351','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52810,'95626','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4970,'12941','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41824,'71901','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40865,'70177','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32595,'57058','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35186,'61126','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45112,'76673','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52612,'95360','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54876,'99350','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40471,'68945','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11893,'25446','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37810,'64853','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28114,'50166','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4853,'12776','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42212,'72373','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21429,'40228','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38317,'65674','Saint Clair','29185','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24663,'45865','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25107,'46511','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27958,'50054','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45986,'78056','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46997,'79423','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52635,'95382','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46709,'79046','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49705,'87048','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(33095,'57650','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45073,'76641','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44061,'75260','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37568,'64481','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9719,'21412','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17160,'33261','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45580,'77420','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45712,'77539','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51482,'92802','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35674,'61832','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18324,'35573','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34369,'59845','Sanders','30089','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49169,'85076','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(15690,'30906','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24346,'45430','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34743,'60467','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39076,'67061','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17821,'34461','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20350,'38623','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21689,'40604','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4832,'12754','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53427,'96766','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(870,'02718','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22976,'43410','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15060,'30215','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23468,'44120','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23672,'44444','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32867,'57381','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2624,'07069','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14335,'29410','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17205,'33339','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34697,'60434','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51526,'92867','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(678,'02188','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19702,'37763','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9350,'20690','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20653,'39040','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21677,'40583','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11745,'25180','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45688,'77514','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51792,'93531','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28035,'50122','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(533,'01865','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(29992,'53565','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33730,'58645','Golden Valley','38033','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53326,'96609','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(43996,'75169','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49296,'85324','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43259,'74013','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39403,'67556','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33518,'58426','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29622,'52774','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21261,'40008','Washington','21229','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49471,'85722','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46195,'78355','Brooks','48047','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25914,'47522','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49351,'85381','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49775,'87313','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52903,'95726','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54231,'98199','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14953,'30120','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27673,'49737','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1346,'04048','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(23192,'43747','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23888,'44818','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43591,'74565','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44642,'76082','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54160,'98077','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53985,'97732','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12665,'27202','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5651,'14081','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11597,'24927','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36261,'62539','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33148,'57748','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13580,'28382','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23487,'44139','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22291,'42124','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18413,'35740','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42374,'72544','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52497,'95192','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51321,'92393','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22649,'43009','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24669,'45868','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19833,'37888','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17638,'33982','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7863,'17860','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34311,'59745','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30250,'54115','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10181,'22546','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5895,'14545','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35238,'61276','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7531,'17130','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33924,'59028','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20555,'38869','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30120,'53924','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24687,'45879','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46815,'79124','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54834,'99218','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55,'00694','Vega Baja','72145','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(48486,'83434','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(47571,'80483','Routt','8107','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27245,'49234','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27119,'49040','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43093,'73661','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11710,'25124','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24830,'46113','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41561,'71406','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45501,'77341','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51782,'93522','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45450,'77269','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41930,'72029','Monroe','5095','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41572,'71418','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21534,'40361','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18891,'36515','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9950,'21901','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31761,'56084','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34033,'59230','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(7220,'16672','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39771,'68063','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26240,'47975','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45603,'77444','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46707,'79045','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49815,'87507','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50109,'88430','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(16232,'31796','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12043,'25778','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21058,'39629','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4425,'12058','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10843,'23822','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45185,'76844','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46683,'79034','Lipscomb','48295','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6204,'15034','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36806,'63080','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1090,'03257','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4469,'12117','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10194,'22558','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53677,'97206','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51307,'92373','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50546,'90089','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41078,'70589','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37726,'64739','Henry','29083','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30662,'54657','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10875,'23847','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30302,'54165','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41715,'71676','Chicot','5017','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50905,'91506','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54147,'98062','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42195,'72355','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21939,'41168','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20921,'39367','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11010,'24017','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1625,'04653','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10551,'23140','Charles City','51036','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20579,'38915','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(545,'01899','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37164,'63701','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5816,'14471','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11721,'25140','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45234,'76882','Coleman','48083','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46084,'78201','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50802,'91226','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46255,'78418','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18063,'35087','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(24749,'46038','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12304,'26293','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30076,'53803','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17761,'34251','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39246,'67402','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3854,'10456','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34394,'59875','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30525,'54514','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14083,'29038','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19567,'37409','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13763,'28572','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7619,'17324','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17506,'33812','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26227,'47967','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37496,'64420','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6236,'15068','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32790,'57330','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20222,'38474','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48081,'81626','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49320,'85348','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53394,'96730','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52164,'94402','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24089,'45147','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36628,'62923','Pulaski','17153','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13387,'28151','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18814,'36374','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13213,'27948','Dare','37055','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19039,'36768','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(55057,'99703','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47322,'80026','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(24976,'46244','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14445,'29532','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36005,'62278','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35977,'62260','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27578,'49655','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15643,'30806','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2900,'07874','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32256,'56523','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27622,'49688','Osceola','26133','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42928,'73436','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44087,'75342','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46922,'79343','Crosby','48107','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4382,'12010','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52614,'95361','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12008,'25704','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13366,'28128','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35121,'61060','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38807,'66712','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35879,'62079','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10985,'23970','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34025,'59221','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28945,'51450','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24226,'45321','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6104,'14850','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(716,'02331','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39651,'67859','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16902,'32824','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39805,'68118','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16199,'31778','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38306,'65664','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38167,'65552','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7764,'17735','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21353,'40107','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43304,'74041','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54187,'98119','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48870,'84126','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43981,'75158','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42392,'72566','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37370,'64056','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10480,'23065','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2666,'07188','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7576,'17252','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11986,'25670','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16995,'33001','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15563,'30668','Lincoln','13181','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30589,'54566','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27051,'48917','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13098,'27836','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50015,'88125','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50249,'89074','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(16277,'31829','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38776,'66609','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38319,'65676','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40213,'68733','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8572,'19155','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34387,'59867','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31113,'55110','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52602,'95348','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25234,'46738','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25199,'46701','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21407,'40204','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32665,'57223','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32507,'57004','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46143,'78257','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5484,'13762','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15360,'30511','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4325,'11801','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26392,'48137','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11483,'24627','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35590,'61732','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45035,'76577','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42165,'72329','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5000,'12977','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(711,'02324','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20118,'38343','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19686,'37745','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18632,'36062','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5912,'14563','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55143,'99821','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(39027,'67025','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9179,'20422','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10944,'23930','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52844,'95659','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50194,'88905','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(45362,'77074','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40313,'68802','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3851,'10453','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23976,'44883','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11255,'24324','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26931,'48829','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33376,'58262','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29403,'52408','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27610,'49682','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25098,'46504','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23836,'44691','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41402,'71218','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42130,'72211','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52836,'95650','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54359,'98354','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8770,'19544','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41156,'70723','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50048,'88254','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(54951,'99578','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(583,'01985','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16337,'32053','Hamilton','12047','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36487,'62834','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34053,'59257','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30440,'54449','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28998,'51532','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23416,'44065','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19477,'37339','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18460,'35776','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11253,'24323','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46386,'78631','Gillespie','48171','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51039,'91979','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39724,'68020','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11193,'24230','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5783,'14432','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33926,'59030','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36942,'63365','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1971,'05633','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(37229,'63823','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13765,'28573','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32578,'57048','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22947,'43344','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51927,'93720','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34754,'60475','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47167,'79758','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44245,'75501','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10730,'23436','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6416,'15358','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38145,'65486','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30500,'54488','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29633,'52805','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24408,'45629','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6712,'15777','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12094,'25888','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11982,'25666','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41100,'70630','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31401,'55580','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6459,'15434','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33785,'58733','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39273,'67436','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3977,'10911','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15682,'30828','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37909,'65066','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10338,'22846','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33052,'57601','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14243,'29220','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12038,'25773','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41850,'71937','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46427,'78656','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50337,'89311','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(55113,'99766','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51396,'92590','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33055,'57622','Ziebach','46137','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34530,'60103','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3125,'08342','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4436,'12067','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11086,'24091','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17456,'33737','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28241,'50271','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(41736,'71742','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5183,'13215','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50061,'88311','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46213,'78372','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41437,'71242','West Carroll','22123','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17546,'33862','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23372,'44022','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39788,'68101','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31641,'55976','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26521,'48310','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24218,'45316','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1737,'04929','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37675,'64664','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37446,'64132','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6190,'15020','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8574,'19161','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12610,'27041','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(43074,'73647','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43433,'74331','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52741,'95532','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40954,'70444','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:53',NULL,NULL),(50660,'90632','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22101,'41635','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32634,'57106','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3325,'08869','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13059,'27807','Nash','37127','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40066,'68504','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41967,'72058','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44698,'76147','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52000,'94005','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5370,'13619','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46321,'78580','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23848,'44704','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22735,'43073','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38480,'66002','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7391,'17005','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33576,'58474','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30180,'53964','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25599,'47138','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16016,'31543','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43581,'74556','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48041,'81428','Delta','8029','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50756,'91043','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53568,'97034','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50016,'88126','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(40912,'70377','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25669,'47240','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14344,'29418','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15077,'30224','Spalding','13255','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27131,'49048','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8029,'18092','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19619,'37663','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41333,'71072','Claiborne','22027','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(29233,'52206','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44307,'75642','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21625,'40484','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36781,'63052','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6055,'14807','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38117,'65449','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15071,'30223','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11869,'25419','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37804,'64847','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26442,'48186','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26720,'48610','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40157,'68658','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45263,'76934','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46070,'78151','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48306,'82932','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(2704,'07421','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54342,'98335','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49848,'87543','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(48467,'83402','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2579,'07021','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9168,'20411','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1668,'04745','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(923,'02823','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(17146,'33206','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32741,'57271','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31748,'56073','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27788,'49855','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21214,'39841','Baker','13007','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18469,'35808','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(50103,'88419','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50141,'88536','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(19049,'36784','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22573,'42716','Taylor','21217','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33822,'58759','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12393,'26440','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11732,'25159','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20489,'38820','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24126,'45208','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35645,'61778','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7513,'17106','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11338,'24467','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38662,'66418','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32575,'57047','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32462,'56744','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(26322,'48063','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48646,'83708','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52567,'95312','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(741,'02361','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46432,'78659','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29260,'52221','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23354,'43983','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19135,'37013','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9200,'20453','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35435,'61476','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39412,'67560','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16438,'32170','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34889,'60618','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32127,'56368','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(47299,'80010','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51553,'93012','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52613,'95361','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49354,'85385','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45342,'77054','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11101,'24113','Martinsville City','51690','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13201,'27935','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21469,'40293','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17436,'33704','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36924,'63349','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34276,'59701','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29629,'52801','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25533,'47036','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14518,'29610','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20360,'38631','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7508,'17101','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4907,'12846','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7086,'16403','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9066,'20186','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4246,'11705','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46878,'79252','Hardeman','48197','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1192,'03746','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4792,'12594','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5594,'14025','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22194,'41855','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33171,'57769','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33650,'58559','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39676,'67876','Ford','20057','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5867,'14521','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37853,'65023','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12333,'26347','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19667,'37725','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47898,'81076','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5695,'14143','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43261,'74014','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41142,'70704','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18937,'36574','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(906,'02790','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5647,'14075','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39900,'68336','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14258,'29292','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13552,'28359','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9953,'21904','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23415,'44064','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9356,'20701','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9902,'21797','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41854,'71943','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51374,'92552','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29868,'53218','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51050,'92013','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50934,'91709','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50201,'89007','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46298,'78558','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42947,'73447','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16614,'32431','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24875,'46149','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5505,'13801','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32932,'57454','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16185,'31765','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24052,'45112','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46496,'78729','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50940,'91716','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3184,'08540','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22082,'41572','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20022,'38188','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19497,'37357','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5151,'13154','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37518,'64439','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40651,'69160','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40490,'68957','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3138,'08352','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50301,'89146','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51306,'92372','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18806,'36353','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19069,'36804','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22608,'42746','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27573,'49650','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28669,'50701','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12994,'27614','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17159,'33257','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(302,'01202','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12489,'26638','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7916,'17954','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41622,'71460','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43141,'73735','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48159,'82217','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(50318,'89163','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51900,'93662','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45532,'77367','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13576,'28377','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14717,'29846','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1499,'04418','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20823,'39213','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43687,'74820','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2472,'06762','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8335,'18833','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18306,'35555','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42106,'72173','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54332,'98326','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37599,'64505','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4023,'10973','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37964,'65230','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37285,'63932','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33066,'57632','Campbell','46021','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45946,'78013','Kerr','48265','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46318,'78577','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48142,'82082','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51498,'92823','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18463,'35802','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10454,'23032','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47590,'80513','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27511,'49548','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37348,'64024','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28020,'50108','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(301,'01201','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16405,'32129','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(735,'02355','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25216,'46723','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23789,'44650','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14207,'29162','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1467,'04342','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10807,'23663','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46416,'78651','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34936,'60677','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50419,'89523','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43664,'74747','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42772,'73056','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27088,'49017','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30121,'53925','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29157,'52071','Jackson','19097','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20654,'39041','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22445,'42366','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47505,'80401','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47516,'80424','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49202,'85142','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50354,'89410','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48712,'83844','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(23255,'43822','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25364,'46901','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31091,'55084','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36049,'62326','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36177,'62449','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16314,'32009','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8645,'19366','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19507,'37362','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21574,'40403','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52620,'95368','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20762,'39154','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14191,'29146','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8280,'18644','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1694,'04783','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17358,'33578','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(522,'01844','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10250,'22655','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11549,'24846','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29676,'53023','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41365,'71118','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46985,'79406','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1104,'03273','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35669,'61825','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5767,'14416','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15906,'31210','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35079,'61021','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3644,'09821','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(26915,'48818','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42955,'73455','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54261,'98240','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48196,'82411','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(22978,'43412','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51166,'92169','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54474,'98535','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37480,'64171','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50819,'91319','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48740,'83871','Latah','16057','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48329,'83111','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(4135,'11359','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6199,'15028','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34141,'59416','Liberty','30051','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44177,'75451','Camp','48063','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46216,'78374','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46934,'79351','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32109,'56357','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28373,'50459','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27006,'48879','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45645,'77478','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42274,'72435','Greene','5055','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38748,'66540','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18433,'35757','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2299,'06349','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38997,'67001','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8199,'18461','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15117,'30259','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30355,'54241','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48598,'83638','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(5802,'14456','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49664,'87013','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49010,'84643','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43139,'73734','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31289,'55395','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21955,'41183','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12429,'26542','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12749,'27302','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16303,'31998','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7491,'17082','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13719,'28528','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35501,'61550','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12856,'27505','Lee','37105','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33102,'57658','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25173,'46573','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11231,'24283','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22643,'43005','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26101,'47849','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(871,'02719','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3527,'09577','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(11593,'24920','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9929,'21849','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(47152,'79740','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1076,'03243','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6733,'15828','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35987,'62265','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13886,'28669','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30763,'54763','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20687,'39074','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44764,'76252','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44687,'76127','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24219,'45317','Champaign','39021','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15342,'30474','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10273,'22720','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19744,'37818','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30445,'54451','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53579,'97042','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53616,'97089','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(186,'00969','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(50328,'89180','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44775,'76262','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42085,'72152','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25893,'47467','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4279,'11746','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2069,'05833','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34733,'60461','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15225,'30349','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39399,'67550','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13852,'28643','None','51999','VA','Virginia',0,'2013-07-03 15:17:52',NULL,NULL),(32716,'57259','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32660,'57220','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11402,'24539','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6464,'15439','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37263,'63863','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9259,'20565','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(26124,'47869','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45032,'76571','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(429,'01540','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50046,'88253','Chaves','35005','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(43537,'74462','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42998,'73533','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26008,'47634','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28355,'50449','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36520,'62855','Wabash','17185','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29753,'53091','Washington','55131','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4513,'12161','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4813,'12732','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11272,'24350','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23486,'44138','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10522,'23112','Powhatan','51145','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4533,'12184','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50935,'91709','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35463,'61517','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44908,'76461','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23970,'44880','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11813,'25302','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1049,'03109','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5731,'14222','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32038,'56311','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16458,'32195','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(629,'02115','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(35940,'62236','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4694,'12485','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48628,'83670','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48630,'83671','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49261,'85269','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9099,'20224','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(41215,'70787','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27902,'50014','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33201,'58002','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37610,'64624','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10790,'23601','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32329,'56584','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43615,'74631','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47317,'80022','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38651,'66409','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22149,'41754','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7057,'16353','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26093,'47842','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37,'00670','Anasco','72011','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(39987,'68416','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6719,'15801','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30415,'54427','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14334,'29409','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10385,'22942','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9421,'20774','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10107,'22407','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43227,'73931','Beaver','40007','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46402,'78641','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51140,'92135','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53328,'96611','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(22757,'43101','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18089,'35120','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29073,'51630','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:52',NULL,NULL),(5526,'13825','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32381,'56653','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(8209,'18469','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35580,'61727','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11456,'24595','Amherst','51009','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30502,'54490','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23215,'43766','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42016,'72101','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46391,'78633','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47586,'80510','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(6623,'15681','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49936,'87942','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(45374,'77084','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26657,'48456','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25064,'46376','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(658,'02144','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36794,'63069','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32805,'57340','Miner','46097','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29749,'53089','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30178,'53963','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7520,'17113','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2647,'07095','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15344,'30474','Toombs','13279','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36269,'62545','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28841,'51108','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42926,'73434','Stephens','40137','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47010,'79502','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48299,'82922','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48880,'84138','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51169,'92172','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37397,'64077','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12486,'26636','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4364,'11964','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18262,'35476','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5476,'13754','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3369,'09042','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35258,'61314','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32222,'56475','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20763,'39156','Warren','28149','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15294,'30436','Toombs','13279','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7741,'17607','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9735,'21532','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11388,'24527','Pittsylvania','51143','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47387,'80133','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5686,'14135','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47653,'80639','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(28010,'50104','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2345,'06419','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(11093,'24102','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3264,'08758','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39871,'68318','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2643,'07091','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8732,'19504','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33767,'58713','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32162,'56425','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28552,'50603','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14236,'29212','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22174,'41824','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1219,'03802','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2966,'08018','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4515,'12165','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50445,'89820','Lander','32015','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47881,'81058','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1191,'03745','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39699,'67954','Stevens','20189','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32525,'57017','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14829,'30028','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7259,'16730','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5687,'14136','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45456,'77275','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11993,'25685','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6569,'15620','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10112,'22412','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31750,'56075','Martin','27091','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6100,'14846','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14042,'28903','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4993,'12969','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12854,'27504','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5006,'12983','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15472,'30580','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24464,'45680','Lawrence','39087','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44743,'76233','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45345,'77057','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49963,'88032','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53664,'97144','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9622,'21155','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39633,'67846','Gray','20069','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34417,'59927','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15387,'30525','Towns','13281','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31314,'55416','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46189,'78347','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50449,'89825','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(1059,'03222','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19684,'37743','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7134,'16506','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16516,'32266','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1272,'03861','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39823,'68137','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28590,'50629','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29626,'52777','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46087,'78204','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46169,'78295','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49280,'85302','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49731,'87110','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52253,'94581','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13314,'28086','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41285,'71029','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3488,'09494','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(44491,'75915','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50785,'91189','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21507,'40342','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36166,'62444','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5617,'14042','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34967,'60912','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33959,'59062','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12057,'25827','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27574,'49651','Missaukee','26113','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23547,'44236','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26402,'48151','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50424,'89595','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51138,'92132','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51376,'92554','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6317,'15222','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24608,'45831','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44680,'76120','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17820,'34460','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15040,'30183','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44917,'76464','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50999,'91803','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53898,'97476','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44179,'75451','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(287,'01109','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10507,'23093','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35417,'61467','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4507,'12156','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26220,'47960','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24002,'45014','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9268,'20578','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(46903,'79323','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30540,'54530','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14859,'30054','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54327,'98321','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(2173,'06080','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(31232,'55355','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31025,'55027','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23611,'44314','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10489,'23072','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2377,'06475','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48463,'83401','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54998,'99638','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(41144,'70706','Saint Helena','22091','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7609,'17316','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39861,'68310','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29177,'52133','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48641,'83703','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14753,'29920','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40555,'69029','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33306,'58121','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27276,'49256','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48625,'83666','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(647,'02133','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(17447,'33715','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8187,'18448','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6670,'15732','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2932,'07940','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33547,'58451','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27271,'49252','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49125,'85024','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39643,'67853','Finney','20055','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37508,'64429','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43053,'73601','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45920,'77991','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51995,'93954','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54919,'99530','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(3960,'10701','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42704,'73015','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1841,'05084','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39454,'67622','Norton','20137','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48039,'81426','San Miguel','8113','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20426,'38701','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19308,'37138','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19280,'37110','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43324,'74056','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29438,'52551','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29402,'52407','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23158,'43716','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11105,'24120','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5276,'13415','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8929,'20033','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(46224,'78382','Aransas','48007','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48028,'81415','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48499,'83443','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51158,'92160','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51785,'93526','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39835,'68154','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5532,'13834','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45274,'76945','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50711,'90805','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50778,'91125','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40760,'70031','Saint Charles','22089','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44380,'75709','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40718,'69343','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39679,'67877','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37532,'64453','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35361,'61421','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20238,'38486','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49257,'85264','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53602,'97067','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(20281,'38562','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36360,'62662','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32188,'56448','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6358,'15272','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12743,'27298','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48211,'82434','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42447,'72638','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40873,'70186','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4855,'12778','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36837,'63118','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15151,'30288','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14732,'29860','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25381,'46916','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24912,'46172','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51742,'93443','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(633,'02119','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20556,'38870','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8394,'18951','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19822,'37880','Meigs','47121','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50253,'89085','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(35705,'61854','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5233,'13335','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44149,'75431','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39959,'68372','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19908,'38036','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46911,'79330','Garza','48169','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41336,'71075','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13469,'28275','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26485,'48232','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27226,'49130','Cass','26027','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27286,'49265','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31658,'56002','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45306,'77020','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49568,'86054','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17810,'34445','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20790,'39176','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38811,'66716','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37448,'64134','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36613,'62915','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12954,'27583','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16143,'31716','Mitchell','13205','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22927,'43332','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30331,'54211','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44878,'76443','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49355,'85387','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9821,'21679','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38208,'65604','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26553,'48348','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49372,'85539','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49485,'85738','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(19097,'36866','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25256,'46759','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21316,'40055','Trimble','21223','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49431,'85641','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4210,'11556','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41177,'70748','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17774,'34270','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30942,'54952','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(602,'02050','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23572,'44266','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47746,'80827','Teller','8119','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39961,'68376','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1598,'04616','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11493,'24640','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38474,'65817','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34191,'59462','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(28681,'50836','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4429,'12062','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48369,'83226','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(8062,'18229','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2147,'06052','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36415,'62711','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48263,'82717','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(19491,'37353','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9461,'20839','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37063,'63544','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36333,'62630','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27070,'49007','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28834,'51101','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50418,'89521','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51234,'92268','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51616,'93210','San Benito','6069','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9935,'21856','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9765,'21624','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4449,'12082','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10173,'22534','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26112,'47858','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20013,'38174','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19012,'36749','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17890,'34697','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24819,'46105','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2891,'07856','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45252,'76905','Coke','48081','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42224,'72387','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(257,'01074','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43506,'74435','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9851,'21746','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9441,'20797','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37526,'64445','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35097,'61042','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16393,'32117','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26540,'48330','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26134,'47878','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12298,'26287','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24321,'45390','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21854,'41044','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2874,'07838','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49074,'84755','Kane','49025','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49898,'87733','Harding','35021','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54066,'97880','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54677,'98942','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31648,'55983','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18139,'35180','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16999,'33009','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31430,'55612','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29745,'53083','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5808,'14466','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8820,'19731','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(12490,'26638','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41355,'71107','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20749,'39144','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33502,'58415','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7164,'16619','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16308,'32007','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30113,'53919','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(15177,'30308','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26528,'48317','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29,'00653','Guanica','72055','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(471,'01703','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20698,'39083','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16475,'32217','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17127,'33177','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41876,'71965','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10906,'23884','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39008,'67010','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11078,'24085','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30219,'54024','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28935,'51443','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54937,'99563','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(30385,'54409','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51747,'93448','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53735,'97296','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4633,'12423','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35890,'62083','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6701,'15767','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23488,'44140','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50524,'90066','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51185,'92196','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52517,'95221','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18320,'35570','Marion','1093','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40006,'68430','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37908,'65065','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5837,'14487','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34963,'60827','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14615,'29683','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13412,'28208','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43046,'73570','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30665,'54659','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46777,'79093','Ochiltree','48357','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40731,'69351','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40270,'68769','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7628,'17335','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16764,'32648','Dixie','12029','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39879,'68323','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6553,'15564','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30970,'54971','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11254,'24324','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5780,'14428','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45606,'77446','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(537,'01879','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50684,'90712','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9865,'21766','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17993,'35015','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39358,'67512','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13998,'28766','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29191,'52146','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28672,'50704','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25142,'46545','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2194,'06104','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1344,'04046','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(46511,'78741','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15204,'30329','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39112,'67112','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37954,'65202','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19521,'37369','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31218,'55343','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28423,'50516','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15046,'30187','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27378,'49337','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27267,'49251','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25263,'46764','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49144,'85043','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53660,'97140','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2108,'05906','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13918,'28697','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14678,'29812','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30884,'54904','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53788,'97357','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(532,'01864','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18601,'36037','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42494,'72685','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15887,'31145','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23464,'44116','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32945,'57465','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25061,'46374','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53964,'97635','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54038,'97841','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7380,'16946','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42799,'73073','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41064,'70577','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37820,'64861','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23506,'44195','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11971,'25646','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18732,'36267','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6232,'15064','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11897,'25504','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35880,'62080','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34672,'60411','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22702,'43050','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44189,'75455','Titus','48449','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15892,'31192','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27628,'49690','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27285,'49264','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5282,'13421','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10898,'23878','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52974,'95915','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10198,'22565','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36618,'62917','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30044,'53706','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29085,'51640','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8402,'18962','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46502,'78734','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39122,'67119','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38574,'66091','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52349,'94945','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54081,'97909','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(3916,'10543','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35407,'61459','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9138,'20330','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(4078,'11106','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19620,'37664','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17396,'33622','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3081,'08231','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7434,'17037','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33240,'58042','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46077,'78159','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49865,'87567','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(16958,'32926','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22325,'42166','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20274,'38556','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20011,'38168','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51137,'92131','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51950,'93765','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(151,'00922','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(8640,'19362','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15014,'30168','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28329,'50431','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52672,'95430','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6418,'15360','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50245,'89060','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(31313,'55415','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11226,'24279','Wise','51195','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3710,'10026','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46853,'79236','King','48269','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20091,'38320','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8511,'19095','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7842,'17837','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2750,'07512','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7604,'17311','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(377,'01436','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11723,'25141','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25445,'46961','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37482,'64180','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15522,'30633','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24202,'45306','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8079,'18246','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35371,'61431','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26310,'48046','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15583,'30701','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22384,'42274','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13022,'27695','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8182,'18445','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32194,'56453','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(53347,'96663','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49216,'85202','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43841,'75025','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41002,'70516','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14420,'29492','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21651,'40514','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25041,'46347','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26703,'48554','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40399,'68866','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43579,'74554','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53029,'95966','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4847,'12770','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35321,'61364','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33783,'58731','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30465,'54463','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26783,'48651','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14553,'29638','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42543,'72752','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3287,'08823','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21181,'39773','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33707,'58631','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54176,'98108','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23342,'43971','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15792,'31045','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37955,'65203','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48120,'82007','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(33711,'58636','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32779,'57323','Sanborn','46111','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29719,'53061','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13363,'28127','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16293,'31905','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25351,'46863','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40446,'68932','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47332,'80038','Broomfield','8014','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48337,'83119','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(15864,'31092','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(788,'02494','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10982,'23966','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11983,'25667','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52299,'94701','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50224,'89030','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46393,'78634','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36173,'62447','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25463,'46977','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9345,'20685','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22963,'43357','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18893,'36521','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17874,'34673','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4205,'11551','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32134,'56375','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(39075,'67061','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47613,'80536','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49608,'86409','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31471,'55736','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29744,'53082','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8832,'19807','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(16755,'32635','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5171,'13202','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26373,'48117','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31356,'55455','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39904,'68339','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50540,'90082','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11265,'24340','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53913,'97494','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(8490,'19076','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32804,'57340','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33089,'57645','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46090,'78207','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45563,'77399','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38479,'66002','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23068,'43526','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16575,'32356','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17836,'34482','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28580,'50624','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9342,'20680','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52775,'95573','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52359,'94955','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47641,'80614','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43380,'74114','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16465,'32205','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15866,'31093','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15353,'30506','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49182,'85119','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50558,'90209','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47242,'79923','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45949,'78015','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35088,'61031','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30565,'54550','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16823,'32726','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30645,'54644','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36266,'62544','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40485,'68956','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11296,'24402','Staunton City','51790','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46771,'79088','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6315,'15220','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19654,'37715','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5229,'13332','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4057,'11022','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52104,'94230','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49576,'86314','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21206,'39836','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25791,'47367','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32384,'56657','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6781,'15921','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50830,'91331','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47778,'80906','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(38941,'66872','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26774,'48641','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36946,'63369','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38106,'65438','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20419,'38680','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19339,'37162','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27763,'49825','Alger','26003','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9819,'21678','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(50352,'89408','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(36586,'62896','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36055,'62336','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29016,'51545','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28840,'51108','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46921,'79342','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2206,'06118','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(30215,'54021','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35911,'62201','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36470,'62823','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9019,'20135','Jefferson','54037','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8854,'19904','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(174,'00955','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(54584,'98665','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4432,'12064','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20131,'38355','Gibson','47053','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18872,'36477','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25356,'46868','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36840,'63120','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43533,'74459','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46453,'78670','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52309,'94708','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52729,'95511','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(59,'00704','Salinas','72123','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(29246,'52213','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7689,'17528','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2767,'07620','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19272,'37097','Perry','47135','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15372,'30517','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47222,'79901','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3736,'10087','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28137,'50211','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25466,'46978','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33311,'58201','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43814,'74964','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44085,'75336','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16094,'31636','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46538,'78767','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44328,'75657','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2518,'06853','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23667,'44441','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26782,'48650','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29376,'52351','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40658,'69165','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33352,'58237','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17015,'33025','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2099,'05872','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5167,'13166','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15975,'31421','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40350,'68833','Blaine','31009','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52914,'95762','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2866,'07830','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36088,'62363','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17938,'34789','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38660,'66416','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38836,'66746','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54331,'98325','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(30059,'53777','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6739,'15832','Cameron','42023','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42758,'73049','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1213,'03780','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(37563,'64476','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2250,'06235','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14695,'29828','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54309,'98292','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9317,'20636','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11047,'24059','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7752,'17721','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10271,'22718','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17942,'34947','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9685,'21239','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7111,'16430','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14419,'29488','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6411,'15350','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51823,'93590','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35260,'61315','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45562,'77396','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29797,'53139','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29734,'53075','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20652,'39039','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39877,'68322','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23835,'44690','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16484,'32225','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15089,'30233','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2110,'06001','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23015,'43456','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13099,'27837','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14000,'28770','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15966,'31410','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26753,'48626','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33647,'58554','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40027,'68447','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12732,'27284','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12083,'25868','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50014,'88124','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(44077,'75287','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20828,'39225','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40448,'68933','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34990,'60929','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11471,'24608','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25705,'47281','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18384,'35646','Colbert','1033','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17798,'34428','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(52650,'95405','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31867,'56169','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2502,'06814','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6511,'15501','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51419,'92623','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11478,'24620','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14776,'29941','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8116,'18341','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3938,'10579','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52492,'95170','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31795,'56118','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30453,'54455','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53989,'97736','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49601,'86351','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(38174,'65557','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5582,'14009','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28679,'50833','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2964,'08015','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14841,'30039','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(579,'01971','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(5536,'13838','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38252,'65630','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5125,'13131','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2013,'05732','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(598,'02044','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12866,'27514','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12777,'27330','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(998,'03031','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(14661,'29733','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15469,'30577','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19360,'37183','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41467,'71275','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20883,'39339','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25313,'46796','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11524,'24801','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8269,'18632','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12236,'26201','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11650,'25040','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30471,'54466','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21938,'41166','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4327,'11803','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53447,'96788','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(38438,'65774','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6113,'14859','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36521,'62856','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22389,'42280','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25461,'46975','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53464,'96807','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52893,'95709','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52187,'94516','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44704,'76163','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33816,'58757','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25034,'46341','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32292,'56554','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37802,'64843','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54420,'98419','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8158,'18424','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19884,'38008','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14667,'29744','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10798,'23607','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51914,'93705','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45217,'76869','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43262,'74015','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23568,'44260','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27468,'49451','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29451,'52556','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34346,'59823','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51448,'92674','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19080,'36852','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4945,'12912','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46881,'79255','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40601,'69129','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40776,'70053','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8899,'19977','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(25223,'46730','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40095,'68601','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40096,'68601','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8975,'20088','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(51289,'92345','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48960,'84515','Grand','49019','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43613,'74630','Kay','40071','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41277,'71019','Red River','22081','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39089,'67072','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41885,'71973','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42559,'72764','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11270,'24350','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43460,'74352','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23189,'43739','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21223,'39846','Calhoun','13037','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48765,'84021','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27022,'48889','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5284,'13425','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5253,'13361','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19534,'37379','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34715,'60447','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46188,'78344','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20278,'38559','White','47185','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17297,'33488','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30263,'54128','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49449,'85671','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5090,'13083','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54641,'98852','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21513,'40347','Scott','21209','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34032,'59226','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51732,'93432','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11346,'24476','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15121,'30263','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36332,'62629','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41796,'71842','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43343,'74071','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21972,'41232','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11022,'24026','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14641,'29710','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7416,'17022','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28371,'50458','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32615,'57071','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(44451,'75840','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13048,'27801','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2384,'06483','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45000,'76541','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42687,'73003','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19171,'37034','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30536,'54525','Iron','55051','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22677,'43027','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27402,'49351','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25225,'46731','Adams','18001','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51241,'92277','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53488,'96838','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(2232,'06154','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(9733,'21530','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42848,'73120','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15936,'31313','Long','13183','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5874,'14527','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35239,'61277','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12821,'27403','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26592,'48415','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46117,'78233','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18692,'36132','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37489,'64195','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6515,'15521','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34546,'60118','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28332,'50433','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54930,'99554','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(9453,'20825','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39776,'68065','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14868,'30058','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36010,'62281','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11738,'25165','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29114,'52033','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46271,'78504','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49860,'87560','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(4823,'12743','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42231,'72392','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20857,'39324','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14426,'29504','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15767,'31033','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40070,'68508','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22877,'43235','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32894,'57429','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(896,'02766','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2381,'06480','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(44531,'75962','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43189,'73801','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24345,'45429','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43927,'75104','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15013,'30165','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43169,'73758','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37650,'64647','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(938,'02839','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(12608,'27031','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(32993,'57533','Lyman','46085','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30204,'54009','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29647,'53007','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(47443,'80228','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51329,'92402','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(922,'02822','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(7843,'17839','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16712,'32567','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41831,'71913','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41629,'71465','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37840,'65011','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4953,'12920','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24338,'45422','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24772,'46052','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29821,'53167','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28260,'50307','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45683,'77508','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20521,'38848','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10868,'23842','Sussex','51183','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10629,'23235','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28207,'50249','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(55059,'99705','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(957,'02876','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(38181,'65560','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16055,'31568','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28248,'50275','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23490,'44141','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25872,'47452','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46580,'78877','Kinney','48271','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50922,'91610','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51587,'93102','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54804,'99167','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39909,'68341','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24096,'45155','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35336,'61377','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46800,'79109','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51667,'93265','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54361,'98355','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14977,'30139','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40306,'68791','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(25443,'46960','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38567,'66083','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25658,'47231','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30504,'54491','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34011,'59201','Valley','30105','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33685,'58602','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52973,'95914','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8861,'19936','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(7924,'17965','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14246,'29223','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12956,'27586','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39114,'67114','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7085,'16402','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30787,'54801','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35849,'62053','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45754,'77585','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52301,'94703','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44053,'75248','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11666,'25059','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17885,'34689','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14867,'30058','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23628,'44401','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52909,'95746','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41695,'71662','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43192,'73832','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12443,'26562','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38113,'65443','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15207,'30333','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13330,'28102','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3203,'08562','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10224,'22625','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42246,'72413','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41888,'72001','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22190,'41845','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28193,'50242','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26214,'47958','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48764,'84020','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51687,'93291','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5702,'14167','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48604,'83642','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(40994,'70510','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36707,'62979','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27755,'49817','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22139,'41731','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22273,'42083','Livingston','21139','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51434,'92652','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54124,'98035','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55117,'99770','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51490,'92811','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3344,'08901','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13987,'28757','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28692,'50843','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39845,'68180','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8756,'19533','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44950,'76490','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24878,'46150','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12536,'26755','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20733,'39116','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51939,'93737','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50881,'91404','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17504,'33810','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33643,'58549','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37453,'64141','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6010,'14742','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41288,'71031','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42070,'72135','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39649,'67857','Hamilton','20075','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5967,'14653','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31124,'55120','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25124,'46532','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23455,'44107','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40995,'70511','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43323,'74055','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14086,'29040','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14901,'30088','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21103,'39665','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9116,'20250','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(52874,'95687','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11072,'24079','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37641,'64642','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29366,'52340','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52374,'94977','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54101,'98011','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10533,'23120','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25506,'47006','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35921,'62216','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12389,'26436','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8033,'18101','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17720,'34204','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42750,'73045','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54067,'97882','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44707,'76177','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41440,'71247','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38294,'65656','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29947,'53532','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19127,'36922','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53617,'97101','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(614,'02066','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32674,'57231','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43683,'74801','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51644,'93243','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9144,'20373','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11548,'24845','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10775,'23509','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27577,'49655','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27439,'49424','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9838,'21719','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17680,'34101','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42317,'72472','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45376,'77085','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48104,'81648','Rio Blanco','8103','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54060,'97873','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(19373,'37189','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1097,'03262','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(38089,'65354','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6768,'15868','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30213,'54020','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25956,'47562','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11206,'24248','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19974,'38113','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(51133,'92127','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53002,'95942','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52384,'95005','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50198,'89004','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(22118,'41663','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29113,'52032','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(154,'00925','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28028,'50115','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17789,'34289','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11088,'24093','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(306,'01223','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52151,'94296','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49139,'85038','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1480,'04355','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14880,'30070','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13840,'28635','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26359,'48103','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10591,'23186','Williamsburg City','51830','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9734,'21531','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8550,'19134','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1368,'04078','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5308,'13459','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34354,'59830','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33232,'58035','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9110,'20239','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8625,'19344','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20496,'38825','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6875,'16055','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48408,'83281','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(20158,'38372','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4192,'11510','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40280,'68777','Boyd','31015','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35470,'61526','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14749,'29915','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22470,'42409','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22298,'42130','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18032,'35053','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53041,'95975','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53008,'95948','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25750,'47341','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10074,'22301','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(834,'02642','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(33517,'58425','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3396,'09114','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19078,'36851','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47984,'81241','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53133,'96085','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54822,'99206','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49636,'86506','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40008,'68433','Richardson','31147','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17722,'34206','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24362,'45448','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42219,'72383','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46043,'78123','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47172,'79762','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52157,'94303','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46628,'78956','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19070,'36830','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10966,'23954','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12240,'26205','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24244,'45333','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25968,'47578','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31383,'55560','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4675,'12466','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4764,'12566','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4277,'11742','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14520,'29611','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28467,'50544','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5659,'14095','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49983,'88055','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47594,'80516','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42343,'72520','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25495,'46994','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23972,'44881','Crawford','39033','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22153,'41762','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20578,'38914','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35647,'61791','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14268,'29316','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7353,'16920','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25361,'46897','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26107,'47854','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29458,'52563','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47634,'80602','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49761,'87192','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(41641,'71475','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20425,'38686','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7883,'17884','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12923,'27557','Franklin','37069','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1827,'05067','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(29589,'52747','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31976,'56264','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39665,'67867','Meade','20119','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39801,'68113','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6075,'14822','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17138,'33188','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2454,'06720','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16786,'32681','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2121,'06022','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26104,'47851','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52823,'95636','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54902,'99508','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(26324,'48065','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(55158,'99903','Ketchikan Gateway','2130','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(3782,'10160','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6556,'15605','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8882,'19958','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(26074,'47809','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26159,'47918','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2791,'07660','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17170,'33303','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1117,'03289','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2785,'07649','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21646,'40512','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48799,'84055','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50640,'90601','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52484,'95155','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6523,'15534','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54202,'98141','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8277,'18641','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1092,'03258','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(22033,'41465','Magoffin','21153','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14844,'30040','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37759,'64767','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17344,'33564','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13574,'28376','Hoke','37093','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30935,'54946','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27727,'49782','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9506,'20902','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(44464,'75852','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54764,'99129','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50242,'89052','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(21806,'40988','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20077,'38310','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14954,'30120','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28279,'50324','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1863,'05159','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16711,'32567','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13547,'28356','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20157,'38371','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47022,'79511','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47493,'80299','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54711,'99020','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45699,'77523','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19103,'36870','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17277,'33468','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27505,'49530','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39329,'67480','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35467,'61523','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11349,'24482','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15844,'31081','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41719,'71701','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43998,'75173','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47552,'80465','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46690,'79039','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46262,'78466','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24633,'45845','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32698,'57246','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36171,'62447','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36232,'62512','Dewitt','17039','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7488,'17078','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11479,'24622','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9829,'21710','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5232,'13334','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24546,'45766','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30140,'53937','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32423,'56710','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43610,'74604','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44009,'75202','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50338,'89314','White Pine','32033','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40237,'68748','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45146,'76710','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8629,'19347','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28920,'51431','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33059,'57626','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17307,'33511','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50084,'88345','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(14940,'30109','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22824,'43151','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3874,'10499','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5425,'13674','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39264,'67428','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36362,'62664','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32276,'56542','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30087,'53811','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14794,'30008','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41430,'71237','Madison','22065','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41817,'71861','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43562,'74534','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54054,'97865','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53614,'97086','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45842,'77845','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9654,'21216','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20979,'39470','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22168,'41812','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(498,'01778','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(39549,'67732','Sherman','20181','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(676,'02186','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(34997,'60935','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12885,'27524','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4629,'12419','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43375,'74107','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45567,'77406','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39568,'67743','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54357,'98352','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24584,'45810','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21125,'39735','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20737,'39119','Covington','28031','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29818,'53157','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30064,'53784','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16183,'31765','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26082,'47834','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(158,'00929','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(8006,'18070','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12241,'26206','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25747,'47339','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(356,'01354','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51316,'92385','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49722,'87101','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43873,'75052','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41873,'71962','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24849,'46127','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31676,'56019','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32115,'56360','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37450,'64137','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7444,'17045','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37373,'64060','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34819,'60534','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17196,'33329','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11722,'25141','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30080,'53805','Richland','55103','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22549,'42629','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23349,'43976','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45203,'76856','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48756,'84011','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47862,'81041','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1746,'04939','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15145,'30285','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15427,'30548','Barrow','13013','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33876,'58831','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18230,'35444','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39789,'68102','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38382,'65734','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32515,'57010','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32445,'56731','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43846,'75029','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44096,'75368','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(560,'01929','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47738,'80820','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20520,'38848','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9868,'21769','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(39439,'67578','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32197,'56456','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27523,'49613','Benzie','26019','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26752,'48625','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3910,'10537','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1983,'05656','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11717,'25134','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45136,'76693','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32708,'57255','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53682,'97210','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52832,'95645','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51515,'92850','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50896,'91482','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6388,'15325','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41704,'71667','Lincoln','5079','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37436,'64121','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33854,'58784','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23086,'43541','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45462,'77287','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52202,'94531','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6761,'15861','Cameron','42023','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54024,'97825','Wheeler','41069','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53476,'96819','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(41949,'72041','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9655,'21217','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9882,'21780','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35944,'62238','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6295,'15148','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32362,'56633','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6531,'15542','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6276,'15129','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28217,'50256','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43449,'74344','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52048,'94107','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48858,'84114','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(4340,'11937','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38329,'65686','Stone','29209','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18370,'35619','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36104,'62379','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16922,'32858','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30764,'54763','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23140,'43652','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2234,'06156','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5456,'13736','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51877,'93641','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55049,'99691','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49315,'85343','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9219,'20511','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10471,'23059','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24841,'46121','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2829,'07735','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11410,'24550','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11448,'24589','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12828,'27410','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17955,'34972','Okeechobee','12093','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48422,'83316','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51213,'92244','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52993,'95935','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17696,'34119','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32331,'56585','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(30156,'53948','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26988,'48866','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43330,'74060','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44612,'76052','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1292,'03887','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(24971,'46239','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26881,'48764','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40906,'70364','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45805,'77703','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50512,'90054','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(611,'02061','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51590,'93106','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27165,'49076','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16730,'32605','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12023,'25719','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31417,'55596','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14594,'29666','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16067,'31606','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1516,'04442','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21790,'40955','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23411,'44062','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26862,'48755','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30167,'53956','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30398,'54416','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5035,'13033','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37103,'63621','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31179,'55323','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15938,'31314','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2122,'06023','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2037,'05761','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7809,'17810','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12507,'26684','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28674,'50801','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12366,'26411','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19396,'37217','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19813,'37876','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44208,'75475','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23862,'44730','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26117,'47863','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8451,'19032','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26508,'48277','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8100,'18325','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7781,'17756','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38970,'66948','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2432,'06605','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3538,'09593','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(38333,'65689','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38293,'65655','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37363,'64048','Clinton','29049','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30542,'54530','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14807,'30014','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12654,'27120','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26545,'48335','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53525,'96943','Federated States of Micro','64003','FM','Federated States of Micronesia',0,'2013-07-03 15:17:54',NULL,NULL),(35531,'61605','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49683,'87028','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(27149,'49064','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2339,'06414','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28275,'50321','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43900,'75082','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50205,'89011','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(5047,'13042','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3096,'08260','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1667,'04744','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22150,'41754','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(45332,'77046','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48160,'82218','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51559,'93020','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39974,'68402','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46522,'78752','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40986,'70502','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6370,'15290','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9592,'21104','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12067,'25844','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14223,'29201','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39597,'67761','Wichita','20203','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20940,'39427','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10677,'23322','Chesapeake City','51550','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41714,'71676','Ashley','5003','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46551,'78828','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50140,'88535','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(36995,'63443','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18148,'35187','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16758,'32640','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30869,'54875','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24745,'46036','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23627,'44398','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1172,'03588','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(45663,'77489','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18848,'36455','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18558,'36006','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2405,'06511','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38086,'65351','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37387,'64070','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14634,'29703','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28698,'50848','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28567,'50613','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24562,'45779','Meigs','39105','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10016,'22122','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45025,'76567','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51352,'92509','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53117,'96065','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5740,'14240','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2178,'06084','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32760,'57313','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18458,'35775','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22733,'43071','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23153,'43701','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14992,'30148','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20089,'38318','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26539,'48329','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48437,'83334','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52352,'94948','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54394,'98388','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47260,'79940','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33129,'57722','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41897,'72010','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1118,'03290','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(10935,'23921','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6789,'15927','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5452,'13732','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3134,'08347','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45696,'77521','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51830,'93602','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17672,'34078','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(385,'01460','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11776,'25243','Roane','54087','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21240,'39867','Quitman','13239','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52616,'95364','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41957,'72046','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20740,'39119','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22680,'43029','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38073,'65345','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16139,'31712','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15305,'30445','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34988,'60928','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18009,'35033','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30424,'54435','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7659,'17401','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21960,'41214','Martin','21159','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21828,'41017','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20080,'38313','Chester','47023','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20669,'39057','Neshoba','28099','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45093,'76656','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49675,'87022','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(54139,'98052','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53077,'96022','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51069,'92038','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4003,'10949','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21905,'41101','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23817,'44676','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24388,'45612','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8647,'19369','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12479,'26623','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29026,'51552','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29654,'53011','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2409,'06514','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16745,'32621','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4541,'12193','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48825,'84079','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45564,'77401','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6349,'15259','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25835,'47420','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27012,'48883','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16703,'32561','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30737,'54748','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45927,'78001','La Salle','48283','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26492,'48238','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20175,'38388','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8785,'19565','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39226,'67351','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41337,'71075','Miller','5091','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15538,'30646','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15048,'30188','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13969,'28742','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5213,'13318','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31326,'55425','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27719,'49776','Alpena','26007','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29756,'53094','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37425,'64110','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51895,'93656','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50519,'90061','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48272,'82727','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47129,'79712','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44047,'75242','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9463,'20842','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10588,'23185','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27337,'49315','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33960,'59062','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1358,'04066','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47751,'80831','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22017,'41366','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22901,'43314','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33994,'59089','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36030,'62306','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30941,'54950','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54590,'98672','Klickitat','53039','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52543,'95248','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51715,'93406','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51215,'92248','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50890,'91413','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14410,'29481','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23822,'44680','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5674,'14113','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38517,'66036','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39842,'68176','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(839,'02647','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15839,'31077','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8083,'18250','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46776,'79092','Oldham','48359','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51944,'93747','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53356,'96672','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(52162,'94309','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50683,'90711','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48794,'84051','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47589,'80513','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1583,'04572','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15106,'30252','Butts','13035','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32603,'57063','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45904,'77976','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30347,'54228','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25679,'47247','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49153,'85060','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44624,'76063','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44360,'75686','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28344,'50440','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28705,'50853','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31956,'56249','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35216,'61256','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25851,'47436','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23722,'44601','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18758,'36303','Henry','1067','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39786,'68072','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36312,'62612','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15564,'30668','Wilkes','13317','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39250,'67416','Saline','20169','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8663,'19399','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28039,'50123','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40596,'69127','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12696,'27244','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31285,'55392','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17101,'33150','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17819,'34453','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42145,'72295','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23984,'44902','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25237,'46740','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16420,'32142','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36814,'63090','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5105,'13108','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26660,'48458','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4132,'11356','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14787,'30004','Forsyth','13117','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7551,'17224','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31455,'55721','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22207,'42024','Ballard','21007','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22817,'43147','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3882,'10506','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(38220,'65610','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(65,'00717','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(23948,'44857','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1820,'05056','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25399,'46928','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19492,'37354','McMinn','47107','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29001,'51534','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44806,'76310','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47711,'80754','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50827,'91328','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19956,'38076','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13776,'28580','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16797,'32697','Union','12125','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(881,'02740','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18012,'35034','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38486,'66010','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1162,'03576','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(26502,'48266','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43311,'74047','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52327,'94912','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41325,'71068','Red River','22081','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1821,'05058','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14892,'30081','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34700,'60437','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32036,'56309','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2042,'05765','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9185,'20428','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(49618,'86433','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49570,'86302','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48130,'82055','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(26294,'48032','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28186,'50238','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18882,'36502','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28934,'51443','Carroll','19027','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7267,'16740','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29777,'53118','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4142,'11366','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6331,'15236','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34055,'59258','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33307,'58122','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7895,'17923','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2463,'06751','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(21500,'40336','Estill','21065','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47087,'79556','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48270,'82725','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51369,'92545','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55031,'99672','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(761,'02455','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1417,'04231','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2071,'05837','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(25975,'47584','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30050,'53715','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3550,'09610','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(17992,'35014','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38916,'66855','Greenwood','20073','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6165,'14901','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35857,'62060','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10622,'23231','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41484,'71294','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43435,'74332','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46975,'79379','Cochran','48079','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47108,'79603','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48116,'82002','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54709,'99018','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5924,'14588','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40371,'68846','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17128,'33178','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34321,'59754','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(21714,'40759','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3737,'10090','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16532,'32314','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3995,'10928','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7591,'17268','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8093,'18302','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50137,'88532','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(20184,'38401','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16708,'32564','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30157,'53949','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18683,'36118','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8461,'19041','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16818,'32721','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26363,'48107','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(42462,'72650','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52857,'95671','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53344,'96660','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54026,'97827','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(39012,'67017','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53606,'97071','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48059,'81522','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44425,'75788','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22309,'42141','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27777,'49840','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27896,'50008','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28126,'50174','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4158,'11386','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36215,'62475','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23632,'44405','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8069,'18237','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51150,'92149','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49591,'86335','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4932,'12874','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36320,'62618','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24472,'45685','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12039,'25774','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21411,'40208','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48324,'83014','Teton','56039','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(10468,'23055','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11560,'24859','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33208,'58011','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11730,'25154','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30218,'54023','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25175,'46574','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20190,'38450','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41974,'72064','Prairie','5117','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51494,'92816','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(87,'00741','Humacao','72069','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(51857,'93623','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49132,'85031','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25651,'47227','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27815,'49883','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20597,'38927','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19677,'37737','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34741,'60466','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4856,'12779','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41253,'70874','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31393,'55572','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47486,'80274','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51372,'92549','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27309,'49285','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46705,'79044','Hartley','48205','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5254,'13362','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4857,'12780','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40323,'68815','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37553,'64469','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34490,'60064','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11765,'25231','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44354,'75683','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44554,'75980','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44569,'76013','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53174,'96127','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48653,'83716','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(15068,'30220','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14462,'29555','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12166,'26058','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8665,'19403','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20735,'39117','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24448,'45663','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32307,'56568','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40659,'69165','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9826,'21704','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34254,'59624','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23504,'44193','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26306,'48042','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52636,'95383','Tuolumne','6109','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54276,'98256','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7136,'16508','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45105,'76667','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28182,'50236','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24588,'45813','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23286,'43907','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40405,'68872','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5451,'13731','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3105,'08313','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2759,'07601','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7830,'17824','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35962,'62252','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30354,'54240','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(46157,'78278','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3071,'08217','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52100,'94208','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47659,'80644','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46469,'78702','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16736,'32611','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5908,'14560','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5152,'13155','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21540,'40371','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43593,'74569','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53095,'96041','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32562,'57040','Bon Homme','46009','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43384,'74117','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23780,'44643','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27396,'49347','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14318,'29378','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15459,'30568','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37290,'63935','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26601,'48419','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25815,'47387','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13277,'28036','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8305,'18765','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11805,'25275','Wirt','54105','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12124,'25962','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27526,'49615','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43475,'74365','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24782,'46060','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47457,'80237','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47501,'80308','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47511,'80420','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49120,'85019','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39940,'68360','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10165,'22520','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15890,'31156','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35129,'61064','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25337,'46845','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24621,'45839','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15826,'31068','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18694,'36134','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18174,'35223','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49643,'86515','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21679,'40591','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2319,'06380','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6747,'15845','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38258,'65633','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38029,'65285','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31925,'56225','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5280,'13420','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25035,'46341','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31697,'56036','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50450,'89826','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54161,'98077','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43504,'74434','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36511,'62851','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36398,'62692','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31677,'56020','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48062,'81525','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43507,'74436','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35490,'61540','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17619,'33955','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16015,'31543','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14427,'29505','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33016,'57552','Stanley','46117','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32722,'57262','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5475,'13754','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28105,'50161','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46742,'79070','Ochiltree','48357','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54978,'99615','Kodiak Island','2150','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(43,'00678','Quebradillas','72115','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(1342,'04042','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1764,'04958','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37538,'64456','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37000,'63446','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3713,'10029','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11599,'24934','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6820,'15959','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6208,'15042','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21706,'40741','Clay','21051','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42715,'73020','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20059,'38256','Henry','47079','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46622,'78952','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30903,'54922','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7132,'16504','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10309,'22802','Harrisonburg City','51660','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19562,'37405','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37658,'64652','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12658,'27150','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33440,'58345','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29096,'51649','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26397,'48143','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19306,'37137','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22420,'42339','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47615,'80537','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48882,'84141','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29916,'53510','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40064,'68502','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(702,'02293','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44712,'76182','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50227,'89033','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(42573,'72812','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41265,'71001','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26498,'48255','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26635,'48441','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33158,'57758','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52907,'95741','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54058,'97869','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43650,'74730','Bryan','40013','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9475,'20859','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7460,'17059','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24604,'45827','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31585,'55941','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1295,'03894','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(49558,'86039','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(13692,'28503','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13164,'27889','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41366,'71119','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10835,'23803','Petersburg City','51730','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9330,'20659','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6364,'15279','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16562,'32343','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3347,'08904','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46567,'78842','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13008,'27628','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12346,'26374','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8546,'19130','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19417,'37244','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36116,'62413','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49394,'85606','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42029,'72110','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34451,'60018','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26213,'47957','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14441,'29526','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11908,'25510','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23796,'44656','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4030,'10981','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29871,'53221','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17157,'33255','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5521,'13814','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37173,'63735','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7139,'16511','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51856,'93622','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37330,'63967','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36396,'62691','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35176,'61109','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12084,'25870','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15460,'30571','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19779,'37852','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53918,'97498','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54302,'98284','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46451,'78669','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28198,'50244','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25203,'46704','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17989,'35010','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13919,'28698','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38214,'65607','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42234,'72395','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:53',NULL,NULL),(46424,'78655','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10648,'23282','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26208,'47954','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26335,'48076','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7143,'16522','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13222,'27960','Hyde','37095','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37187,'63751','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51259,'92313','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8794,'19608','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7396,'17011','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16543,'32324','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38235,'65618','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42952,'73450','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52945,'95836','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35533,'61607','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8733,'19505','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7534,'17201','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12887,'27525','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17018,'33028','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19963,'38088','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24423,'45647','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30364,'54305','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33538,'58443','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43243,'73951','Texas','40139','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1922,'05451','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24391,'45613','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35654,'61810','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2989,'08041','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3212,'08608','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(30189,'53968','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29028,'51552','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42013,'72088','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44979,'76527','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15357,'30510','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49742,'87122','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51990,'93942','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49171,'85079','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31586,'55942','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39581,'67751','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43983,'75159','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22380,'42266','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4668,'12458','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24761,'46045','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30811,'54826','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4685,'12474','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10636,'23249','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(178,'00959','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28599,'50633','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26140,'47885','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32509,'57005','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:53',NULL,NULL),(34161,'59434','Glacier','30035','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47273,'79953','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48394,'83255','Butte','16023','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14117,'29067','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15716,'31010','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18120,'35150','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10305,'22748','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51070,'92039','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9199,'20451','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(4934,'12879','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18113,'35146','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17706,'34138','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49086,'84767','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51273,'92327','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52440,'95076','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9341,'20678','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14116,'29067','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5851,'14510','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46350,'78610','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49741,'87121','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49846,'87539','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(14638,'29707','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15335,'30470','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26413,'48162','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51683,'93285','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43673,'74754','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23204,'43757','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22831,'43154','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4133,'11357','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14374,'29446','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52,'00692','Vega Alta','72143','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19094,'36863','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35775,'61937','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43903,'75085','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49920,'87828','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(4331,'11853','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21265,'40010','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18850,'36456','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41,'00676','Moca','72099','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(31067,'55066','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10513,'23105','Amelia','51007','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23097,'43550','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10147,'22482','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13938,'28716','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3392,'09103','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28940,'51448','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52751,'95546','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53472,'96815','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(7940,'17985','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8738,'19510','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24831,'46115','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51408,'92607','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11212,'24258','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12669,'27207','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4762,'12565','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19715,'37774','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4707,'12501','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14443,'29528','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17565,'33888','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27711,'49769','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30994,'55003','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33653,'58560','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36020,'62293','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36896,'63197','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47490,'80293','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19560,'37403','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19165,'37031','Trousdale','47169','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52310,'94709','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52516,'95220','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13414,'28210','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20018,'38183','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16939,'32899','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15473,'30581','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(404,'01507','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13569,'28371','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41326,'71069','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39082,'67065','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35443,'61482','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11573,'24878','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21111,'39668','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19584,'37601','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18566,'36013','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37843,'65014','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40098,'68620','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44431,'75791','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47825,'80970','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49819,'87511','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50596,'90275','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51080,'92058','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32065,'56329','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17944,'34949','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15021,'30172','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8792,'19606','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21916,'41132','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10040,'22195','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27408,'49402','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48000,'81303','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49834,'87527','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50648,'90609','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(535,'01867','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16268,'31824','Marion','13197','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42602,'72843','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3571,'09649','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(28219,'50257','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30579,'54560','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41117,'70647','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21143,'39746','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19920,'38044','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6203,'15033','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15415,'30538','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30265,'54130','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50423,'89570','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(13091,'27830','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20286,'38567','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9908,'21810','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17739,'34224','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16252,'31808','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1034,'03086','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(37948,'65109','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44915,'76463','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47423,'80214','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11832,'25326','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21573,'40403','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8557,'19141','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46172,'78298','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31062,'55057','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25014,'46303','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8198,'18460','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20600,'38929','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20183,'38401','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50966,'91756','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50848,'91356','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43196,'73838','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41021,'70528','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1075,'03242','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(25501,'47001','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3007,'08062','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(558,'01922','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(10046,'22205','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11617,'24977','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26689,'48503','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43180,'73764','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50284,'89129','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(18452,'35771','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26206,'47952','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51190,'92202','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40652,'69161','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31672,'56016','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24769,'46050','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(17323,'33540','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39333,'67482','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48789,'84045','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52277,'94608','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43979,'75156','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(828,'02634','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30212,'54017','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41153,'70721','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20957,'39452','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28265,'50312','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34118,'59345','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35157,'61085','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1762,'04956','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31595,'55946','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54906,'99513','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54645,'98857','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48276,'82730','Weston','56045','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(32288,'56552','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10650,'23285','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28194,'50242','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52215,'94545','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52935,'95826','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6504,'15485','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10142,'22473','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(534,'01866','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4669,'12459','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17669,'34055','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(15669,'30820','Warren','13301','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15016,'30169','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52287,'94619','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36271,'62546','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3602,'09733','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20027,'38201','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6538,'15549','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31569,'55924','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34728,'60456','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45172,'76831','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46284,'78539','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13535,'28344','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12256,'26230','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3885,'10509','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16592,'32408','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18321,'35571','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29242,'52210','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48253,'82649','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51328,'92401','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26011,'47637','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47009,'79501','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50587,'90263','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52961,'95867','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1839,'05081','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(6313,'15218','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14064,'29018','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41662,'71630','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52648,'95403','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54561,'98631','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7039,'16341','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22565,'42712','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22184,'41837','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31173,'55320','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(37698,'64683','Grundy','29079','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39886,'68327','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(12788,'27342','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12300,'26288','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11963,'25630','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9433,'20785','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33714,'58638','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43120,'73718','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54297,'98280','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28494,'50565','Buena Vista','19021','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1249,'03838','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(20635,'38961','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43786,'74937','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43586,'74560','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38539,'66054','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8110,'18333','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16507,'32247','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19264,'37091','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10787,'23529','Norfolk City','51710','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20502,'38829','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1721,'04910','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28486,'50560','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29950,'53534','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54929,'99553','Aleutians East','2013','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50623,'90405','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50089,'88350','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48587,'83630','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(25340,'46852','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26535,'48325','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26969,'48849','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28280,'50324','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13643,'28443','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53086,'96031','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50182,'88581','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(39200,'67277','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23757,'44626','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23191,'43746','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25821,'47393','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31537,'55810','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8426,'19006','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17743,'34229','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24566,'45784','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24055,'45114','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53931,'97527','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44058,'75252','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11912,'25515','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1247,'03836','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6899,'16112','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18346,'35587','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25673,'47243','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28847,'51201','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30910,'54929','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31155,'55304','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32338,'56590','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32981,'57523','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35448,'61484','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36941,'63363','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1801,'05037','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14508,'29598','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19841,'37909','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32299,'56561','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33384,'58270','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18191,'35244','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37544,'64463','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39713,'68010','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50610,'90304','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51940,'93740','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30348,'54229','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26380,'48124','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22804,'43140','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21975,'41240','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27567,'49644','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13371,'28134','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32847,'57369','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29456,'52561','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29305,'52255','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23754,'44624','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27712,'49769','Emmet','26047','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1623,'04650','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18030,'35052','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33656,'58561','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46912,'79331','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50992,'91790','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19089,'36860','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15800,'31052','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28249,'50276','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43247,'74003','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(50816,'91311','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38953,'66937','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38525,'66044','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30919,'54934','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45086,'76652','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47339,'80046','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12525,'26720','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48934,'84333','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29078,'51632','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29767,'53105','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32998,'57536','Hughes','46065','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33595,'58487','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36979,'63435','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45601,'77442','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49131,'85030','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1790,'04989','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20672,'39058','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(20380,'38646','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(29872,'53222','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36743,'63020','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45320,'77034','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5923,'14586','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43764,'74878','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44640,'76078','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52717,'95485','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53014,'95954','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13747,'28555','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13283,'28041','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9854,'21750','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14833,'30032','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9736,'21532','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2417,'06524','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36311,'62612','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40534,'69001','Hayes','31085','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42736,'73034','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43530,'74457','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7322,'16860','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40164,'68662','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39281,'67443','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6682,'15746','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7693,'17534','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54792,'99156','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54662,'98923','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54328,'98322','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41030,'70535','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1651,'04691','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34471,'60041','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47774,'80902','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52212,'94542','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54990,'99630','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53521,'96939','Palau','70030','PW','Palau',0,'2013-07-03 15:17:54',NULL,NULL),(276,'01096','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25059,'46373','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19531,'37377','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12581,'27011','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(31587,'55943','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40071,'68509','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51416,'92618','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7388,'17002','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8036,'18104','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8943,'20047','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22991,'43433','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25901,'47471','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29007,'51540','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45502,'77342','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45390,'77099','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34420,'59930','Lincoln','30053','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23449,'44101','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23413,'44062','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22387,'42276','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19195,'37050','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16647,'32460','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29328,'52316','Keokuk','19107','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36571,'62888','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41193,'70763','Saint James','22093','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14259,'29301','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15829,'31069','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16317,'32024','Columbia','12023','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1722,'04911','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4624,'12413','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29166,'52077','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39851,'68301','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11857,'25389','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16177,'31760','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15492,'30609','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1184,'03605','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3343,'08899','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7306,'16844','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43103,'73668','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38037,'65302','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36616,'62916','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23824,'44681','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23071,'43527','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30245,'54113','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49538,'86015','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54684,'98950','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29789,'53128','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34736,'60464','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36748,'63024','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41925,'72026','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52023,'94040','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43788,'74940','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20069,'38271','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24844,'46124','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37729,'64741','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51064,'92029','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43818,'74966','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(12692,'27239','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3819,'10270','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20470,'38767','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21585,'40422','Boyle','21021','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46693,'79039','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48883,'84143','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(104,'00777','Juncos','72077','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3520,'09568','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(22345,'42211','Trigg','21221','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19835,'37890','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29883,'53237','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30672,'54665','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43492,'74425','Pittsburg','40121','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19897,'38023','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17454,'33734','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1601,'04622','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4564,'12225','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28865,'51240','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31638,'55975','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33821,'58759','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4170,'11421','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16878,'32796','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10853,'23831','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54534,'98601','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32481,'56761','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(45835,'77837','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31654,'55991','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30341,'54217','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8124,'18350','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16480,'32222','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47868,'81045','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48389,'83251','Custer','16037','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50747,'91021','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44308,'75643','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32161,'56401','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31084,'55079','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30010,'53578','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26934,'48831','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24692,'45883','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15157,'30293','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22782,'43119','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39618,'67838','Kearny','20093','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43387,'74121','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52969,'95912','Colusa','6011','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51898,'93660','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7045,'16343','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51074,'92051','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51364,'92532','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43312,'74047','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40782,'70059','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39782,'68069','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37262,'63863','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21361,'40118','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(55115,'99768','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(25218,'46723','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41110,'70639','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44572,'76016','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18369,'35619','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18599,'36036','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47686,'80731','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48924,'84323','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53967,'97637','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(34567,'60135','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24594,'45817','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44094,'75360','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52028,'94060','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53527,'96950','Northern Mariana Islands','69010','MP','Northern Mariana Islands',0,'2013-07-03 15:17:54',NULL,NULL),(39655,'67861','Wichita','20203','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37357,'64035','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30920,'54935','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29138,'52052','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28530,'50591','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27942,'50044','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13404,'28174','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4747,'12544','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44072,'75283','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47401,'80151','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(55089,'99742','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(12530,'26739','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47298,'80010','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44239,'75495','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14550,'29635','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8571,'19154','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47896,'81071','Kiowa','8061','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14654,'29726','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22228,'42040','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21564,'40391','Clark','21049','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37443,'64129','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40182,'68711','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45109,'76671','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23356,'43983','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13831,'28629','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46609,'78945','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12505,'26680','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42267,'72430','Clay','5021','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41274,'71018','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14765,'29932','Allendale','45005','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2993,'08046','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8419,'18991','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35768,'61932','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11173,'24209','Bristol City','51520','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47816,'80944','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39965,'68378','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38449,'65783','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7934,'17979','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23236,'43786','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24022,'45051','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26728,'48614','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54921,'99545','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54451,'98503','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(15238,'30360','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8178,'18444','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10095,'22332','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52625,'95374','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42403,'72577','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26901,'48807','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2076,'05842','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(321,'01244','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42855,'73127','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15186,'30316','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7082,'16388','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12087,'25875','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26798,'48661','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29196,'52154','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32064,'56329','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16906,'32828','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21457,'40272','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3884,'10507','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52013,'94024','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51187,'92198','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28458,'50540','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9050,'20169','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12461,'26585','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25921,'47527','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42741,'73040','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54239,'98213','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55062,'99708','Fairbanks North Star','2090','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(129,'00840','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(54151,'98068','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49030,'84701','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(23760,'44627','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2474,'06770','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(50784,'91188','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45848,'77857','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44294,'75630','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38406,'65752','Lawrence','29109','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32017,'56292','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19707,'37766','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18817,'36376','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23076,'43532','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28347,'50444','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6274,'15126','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8001,'18065','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20315,'38583','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18450,'35769','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1927,'05455','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(28359,'50451','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28950,'51453','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32153,'56389','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(6826,'15963','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13525,'28335','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(939,'02840','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(4935,'12883','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33444,'58346','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36740,'63019','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38582,'66095','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40257,'68763','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40903,'70361','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45476,'77306','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48686,'83814','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51916,'93707','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12480,'26623','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7788,'17762','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54449,'98502','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53882,'97456','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36510,'62850','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28640,'50662','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2118,'06019','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14866,'30058','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4514,'12164','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22078,'41566','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1711,'04858','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(42043,'72120','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30151,'53946','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4659,'12451','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6142,'14882','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11616,'24976','Monroe','54063','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13155,'27883','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22412,'42332','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31375,'55551','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36568,'62886','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39072,'67059','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53522,'96940','Palau','70030','PW','Palau',0,'2013-07-03 15:17:54',NULL,NULL),(44653,'76093','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44580,'76022','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22599,'42740','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42619,'72857','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(8649,'19372','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7432,'17035','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2029,'05748','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42326,'72478','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52762,'95556','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45127,'76689','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28607,'50642','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23689,'44471','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33026,'57563','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33695,'58623','Bowman','38011','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45115,'76679','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51154,'92154','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17006,'33016','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17413,'33661','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6122,'14867','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29136,'52050','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40566,'69037','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41721,'71720','Calhoun','5013','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47635,'80603','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8813,'19717','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(37851,'65020','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26284,'48015','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26713,'48605','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50523,'90065','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38391,'65739','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25877,'47456','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24293,'45368','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48475,'83420','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(17609,'33945','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54814,'99180','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(18994,'36720','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20264,'38548','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20839,'39288','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2086,'05853','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12571,'26865','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37177,'63739','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41069,'70581','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13080,'27822','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12830,'27412','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8420,'19001','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30784,'54773','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34782,'60504','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52740,'95531','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20343,'38619','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25645,'47223','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10627,'23234','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49410,'85621','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45113,'76676','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31968,'56260','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29397,'52404','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53222,'96266','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(19030,'36761','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7229,'16679','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17501,'33809','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24816,'46103','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41360,'71112','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51331,'92404','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11004,'24014','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32745,'57273','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43945,'75125','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23703,'44492','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14512,'29604','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16149,'31721','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22813,'43146','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45957,'78022','Live Oak','48297','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49814,'87506','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(9334,'20664','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7199,'16654','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16328,'32041','Nassau','12089','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31751,'56078','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38506,'66025','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29971,'53549','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48679,'83808','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2005,'05679','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8077,'18244','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6790,'15928','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34155,'59425','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(41160,'70728','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(13027,'27702','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16620,'32437','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8533,'19118','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41872,'71961','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48588,'83631','Boise','16015','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(53403,'96741','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(54532,'98599','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38691,'66441','Geary','20061','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48177,'82301','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(12715,'27262','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53952,'97620','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(40515,'68977','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24659,'45862','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30926,'54940','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34196,'59465','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(9777,'21638','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41098,'70629','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41085,'70598','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(35589,'61732','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53770,'97338','Polk','41053','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54579,'98660','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5562,'13863','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5653,'14083','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28602,'50635','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2584,'07027','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6893,'16105','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14383,'29455','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21512,'40347','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2766,'07608','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54767,'99133','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50722,'90832','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33727,'58643','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5244,'13346','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4905,'12844','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25736,'47331','Union','18161','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25783,'47359','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29188,'52144','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14552,'29638','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31192,'55331','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31626,'55969','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38261,'65634','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43148,'73742','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49113,'85012','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50679,'90704','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12265,'26241','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26014,'47639','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41741,'71748','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22570,'42715','Metcalfe','21169','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10845,'23824','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16206,'31780','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13838,'28634','Davie','37059','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43538,'74463','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43787,'74939','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54409,'98406','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6372,'15301','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25803,'47375','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14622,'29689','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5968,'14692','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11325,'24445','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12140,'25984','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1208,'03771','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(6036,'14778','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47956,'81157','Archuleta','8007','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37735,'64744','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24803,'46071','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12922,'27556','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3568,'09645','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2184,'06091','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5248,'13353','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5220,'13324','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36262,'62540','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41775,'71827','Lafayette','5073','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42870,'73140','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22487,'42444','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20191,'38451','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19435,'37314','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15834,'31072','Crisp','13081','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7588,'17265','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24583,'45810','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47191,'79782','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15199,'30326','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19389,'37211','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3022,'08077','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26462,'48209','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39425,'67567','Pawnee','20145','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11924,'25529','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31373,'55488','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31360,'55467','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26770,'48637','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7705,'17551','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9743,'21542','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14966,'30127','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7567,'17241','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50769,'91110','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30289,'54155','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32377,'56650','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36273,'62547','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37232,'63825','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40595,'69125','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47383,'80129','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41519,'71342','La Salle','22059','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(24619,'45837','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20718,'39096','Jefferson','28063','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26889,'48768','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7989,'18054','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31501,'55768','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32709,'57256','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15556,'30663','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51229,'92262','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48837,'84091','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(24405,'45624','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16229,'31794','Tift','13277','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38440,'65775','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17433,'33701','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14227,'29205','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37747,'64755','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34255,'59625','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15649,'30810','Jefferson','13163','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31287,'55394','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26637,'48442','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26564,'48366','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31115,'55112','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54237,'98207','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34169,'59443','Teton','30099','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4195,'11518','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35393,'61449','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6638,'15692','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6380,'15317','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26926,'48826','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(43273,'74020','Pawnee','40117','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54314,'98296','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4475,'12122','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50926,'91615','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3004,'08059','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20980,'39470','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(810,'02561','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2371,'06469','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35070,'61014','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36757,'63030','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37053,'63535','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5690,'14139','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12260,'26236','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22753,'43084','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37366,'64052','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1053,'03216','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(25748,'47340','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18881,'36502','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4412,'12046','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15132,'30273','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46592,'78932','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23843,'44699','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33935,'59038','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(11209,'24256','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6516,'15522','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52639,'95386','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46819,'79168','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45541,'77375','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44842,'76388','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17337,'33556','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39939,'68359','Seward','31159','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39324,'67475','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23635,'44408','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25424,'46947','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8514,'19098','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13584,'28384','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33589,'58483','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1079,'03245','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(54218,'98175','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22844,'43195','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20972,'39463','Pearl River','28109','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31943,'56239','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35512,'61561','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31959,'56252','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40335,'68823','Garfield','31071','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44930,'76471','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43215,'73852','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13794,'28601','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15916,'31220','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2500,'06812','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52196,'94525','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37696,'64681','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9071,'20191','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12175,'26101','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12436,'26554','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52055,'94115','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53836,'97406','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41646,'71483','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25181,'46590','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1860,'05155','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(32561,'57039','Turner','46125','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40959,'70448','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(114,'00792','Humacao','72069','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(46909,'79326','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26525,'48314','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17194,'33327','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16768,'32656','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28751,'51014','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1761,'04955','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(352,'01347','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37295,'63938','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51228,'92261','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43691,'74824','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21940,'41168','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26906,'48811','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5362,'13611','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50199,'89005','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47469,'80249','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35116,'61053','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28525,'50586','Calhoun','19025','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13495,'28309','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9620,'21154','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54652,'98901','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54184,'98116','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52879,'95690','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47183,'79772','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46381,'78627','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42087,'72153','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20398,'38659','Union','28145','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13985,'28756','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37183,'63746','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(260,'01077','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23884,'44815','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36667,'62947','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4613,'12345','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49923,'87831','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(42491,'72683','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22148,'41751','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54188,'98121','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21328,'40065','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13820,'28619','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8484,'19070','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29540,'52648','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1161,'03575','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4183,'11434','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45155,'76801','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25758,'47348','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31899,'56210','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9467,'20849','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36154,'62436','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37895,'65058','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12099,'25906','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45557,'77387','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42821,'73095','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30373,'54401','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4074,'11102','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16748,'32625','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12325,'26338','Lewis','54041','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32948,'57466','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(266,'01084','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54406,'98403','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26353,'48097','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2388,'06489','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3754,'10116','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19206,'37057','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48144,'82082','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(26494,'48240','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21620,'40476','Madison','21151','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28766,'51022','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28767,'51022','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31077,'55073','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36562,'62883','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14960,'30125','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23705,'44501','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54329,'98323','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43112,'73703','Grant','40053','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42442,'72633','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4383,'12010','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30153,'53946','Green Lake','55047','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32316,'56574','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36570,'62887','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39251,'67417','Cloud','20029','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5384,'13632','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5656,'14091','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28560,'50607','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2017,'05736','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(27419,'49410','Mason','26105','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53672,'97202','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47410,'80202','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19425,'37306','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26699,'48550','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14007,'28775','Macon','37113','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30812,'54826','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33879,'58835','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22293,'42127','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22474,'42411','Lyon','21143','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28641,'50664','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29596,'52754','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38392,'65739','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44153,'75433','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43426,'74193','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41912,'72020','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20811,'39203','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(40704,'69334','Scotts Bluff','31157','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22532,'42544','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18844,'36453','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2467,'06755','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28269,'50316','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29087,'51645','Mills','19129','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35306,'61350','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43595,'74570','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3842,'10308','Richmond','36085','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26591,'48415','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20618,'38950','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13020,'27676','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10794,'23604','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12190,'26138','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44736,'76227','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14176,'29130','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35040,'60961','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33938,'59039','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12412,'26504','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52449,'95111','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54087,'97914','Malheur','41045','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52994,'95936','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49765,'87196','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(23666,'44440','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29271,'52227','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16205,'31780','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40503,'68967','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40403,'68870','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37299,'63941','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12386,'26431','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2352,'06437','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14018,'28786','Haywood','37087','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2085,'05851','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(33747,'58652','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(465,'01615','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46266,'78472','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39074,'67060','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29244,'52211','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39645,'67854','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14230,'29208','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18290,'35546','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16043,'31560','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24412,'45634','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39042,'67036','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44755,'76246','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49185,'85120','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42519,'72729','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50937,'91711','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42968,'73481','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25120,'46530','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23073,'43529','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28401,'50478','Winnebago','19189','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19530,'37377','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10455,'23035','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33459,'58363','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14468,'29564','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18308,'35555','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33009,'57547','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(3049,'08099','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31570,'55925','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27216,'49116','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23243,'43802','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51669,'93267','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12049,'25812','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24746,'46036','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33254,'58051','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35112,'61051','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7228,'16678','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(777,'02472','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25230,'46733','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29022,'51549','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51160,'92163','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25334,'46819','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24840,'46121','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19033,'36763','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27367,'49331','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15242,'30364','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35755,'61920','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18839,'36444','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(42383,'72554','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11204,'24245','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2803,'07703','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3953,'10602','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40451,'68935','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(835,'02643','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30851,'54859','Washburn','55129','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23532,'44223','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45980,'78050','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53188,'96141','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37434,'64119','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44637,'76073','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21187,'39815','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21671,'40577','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24187,'45273','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31710,'56047','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35350,'61415','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16530,'32312','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9427,'20779','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(524,'01850','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38237,'65619','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52845,'95660','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51099,'92083','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19343,'37166','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11016,'24020','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12091,'25880','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38586,'66097','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41567,'71415','Caldwell','22021','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20778,'39168','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10134,'22456','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9517,'20912','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37160,'63673','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21137,'39744','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54962,'99591','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(48346,'83128','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(8934,'20039','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8743,'19518','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31413,'55592','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34566,'60134','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18831,'36432','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25213,'46714','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16896,'32817','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29773,'53114','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54954,'99581','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46763,'79084','Dallam','48111','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46328,'78589','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21609,'40460','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33012,'57552','Haakon','46055','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41659,'71611','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(13760,'28572','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6888,'16066','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13810,'28611','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30551,'54538','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31350,'55448','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31923,'56223','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10014,'22119','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10310,'22802','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1852,'05146','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1678,'04762','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54841,'99252','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(16166,'31747','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5589,'14013','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30269,'54135','Menominee','55078','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22695,'43044','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23070,'43527','Defiance','39039','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46454,'78671','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46474,'78709','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48820,'84073','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52139,'94283','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34925,'60659','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54016,'97814','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(20766,'39158','Madison','28089','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1091,'03257','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8654,'19380','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2560,'07002','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26,'00647','Guanica','72055','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(11906,'25510','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21887,'41085','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46899,'79313','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41120,'70650','Jefferson Davis','22053','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7440,'17043','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49481,'85734','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48667,'83732','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48570,'83611','Valley','16085','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(22886,'43271','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28505,'50570','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14069,'29030','Calhoun','45017','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34922,'60655','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38559,'66075','Linn','20107','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2477,'06778','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(46134,'78250','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21898,'41095','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26135,'47879','Sullivan','18153','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18443,'35763','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(580,'01982','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(747,'02370','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11015,'24019','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51191,'92203','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53319,'96602','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(50553,'90099','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47040,'79526','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24845,'46124','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14349,'29422','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1526,'04455','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(48001,'81320','Dolores','8033','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43712,'74840','Seminole','40133','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38004,'65263','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10340,'22848','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35662,'61817','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31610,'55956','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30409,'54424','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26416,'48166','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24934,'46202','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4038,'10988','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6658,'15722','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16479,'32221','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2100,'05873','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12356,'26384','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9389,'20737','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26461,'48208','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20623,'38953','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(24847,'46125','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4911,'12850','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35160,'61088','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33569,'58466','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29906,'53503','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10200,'22567','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10470,'23058','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24738,'46031','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54513,'98577','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54757,'99123','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49273,'85287','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48773,'84029','Tooele','49045','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27177,'49082','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15419,'30541','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35462,'61516','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11655,'25045','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3564,'09633','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(14851,'30047','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33374,'58261','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23209,'43760','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51227,'92260','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51596,'93116','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44160,'75438','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4967,'12936','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2586,'07029','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5852,'14511','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13674,'28464','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14095,'29047','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26787,'48653','Crawford','26039','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25900,'47471','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23282,'43903','Carroll','39019','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14700,'29834','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20564,'38875','Chickasaw','28017','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3196,'08557','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(37127,'63636','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34976,'60918','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40563,'69034','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9995,'22060','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(55118,'99771','Nome','2180','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54516,'98581','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48398,'83262','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(19557,'37398','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9869,'21770','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14819,'30023','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13430,'28224','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10232,'22639','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42030,'72111','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1882,'05342','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13519,'28333','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31213,'55341','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35056,'61001','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1950,'05481','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(7955,'18017','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22252,'42063','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47067,'79541','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51042,'92003','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32794,'57332','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53771,'97339','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45437,'77254','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43071,'73646','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26865,'48757','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29893,'53295','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40949,'70443','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(37210,'63781','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27069,'49006','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3968,'10709','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52899,'95720','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52045,'94103','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46904,'79323','Yoakum','48501','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18861,'36471','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21950,'41179','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38888,'66833','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32545,'57030','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28555,'50605','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4323,'11797','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9643,'21209','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29452,'52557','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28995,'51531','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51525,'92866','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54051,'97861','Gilliam','41021','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54701,'99012','Kootenai','16055','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(54995,'99635','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(3037,'08089','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1469,'04344','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40918,'70391','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(34937,'60678','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9343,'20682','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10761,'23480','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46021,'78107','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9131,'20306','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(38682,'66436','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19350,'37175','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43812,'74963','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54033,'97837','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53120,'96069','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50173,'88572','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(41742,'71749','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23355,'43983','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29311,'52302','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38568,'66085','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15814,'31061','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33406,'58317','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4297,'11768','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17257,'33442','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36371,'62670','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1251,'03840','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32943,'57461','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32675,'57232','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32586,'57053','McCook','46087','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29766,'53104','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9759,'21617','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49217,'85203','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54773,'99137','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38510,'66030','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43913,'75092','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41301,'71045','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27007,'48879','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28144,'50216','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18345,'35586','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37848,'65018','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17269,'33460','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14922,'30102','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33985,'59083','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(6354,'15265','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29662,'53015','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40951,'70443','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21380,'40150','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31199,'55334','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6475,'15451','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22134,'41723','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25459,'46975','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47971,'81226','Fremont','8043','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51461,'92693','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47104,'79601','Shackelford','48417','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44553,'75980','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26122,'47868','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3191,'08551','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6347,'15257','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34382,'59863','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13068,'27813','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8211,'18470','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3908,'10535','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40255,'68760','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(13897,'28677','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13076,'27820','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32768,'57319','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29129,'52044','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20402,'38665','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25616,'47160','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(36721,'62994','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9556,'21045','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(53858,'97434','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(4440,'12070','Montgomery','36057','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6720,'15801','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36006,'62278','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34027,'59222','Daniels','30019','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47224,'79903','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48153,'82210','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48315,'82942','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(48520,'83467','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49992,'88081','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(48334,'83115','Sublette','56035','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44032,'75226','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44002,'75182','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17403,'33631','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39029,'67026','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1016,'03052','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(37167,'63730','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32429,'56716','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29619,'52772','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40538,'69021','Dundy','31057','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15533,'30643','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34942,'60685','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34850,'60556','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50585,'90261','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26218,'47960','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10058,'22214','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44066,'75265','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49437,'85646','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6791,'15929','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42355,'72529','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45522,'77358','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52073,'94133','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22043,'41514','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13389,'28159','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14058,'29010','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22167,'41812','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11981,'25665','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41941,'72036','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51142,'92137','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52489,'95160','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42465,'72653','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10928,'23915','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12220,'26167','Wetzel','54103','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10792,'23603','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25734,'47331','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30885,'54904','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(17285,'33475','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17531,'33848','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36754,'63028','Saint Francois','29187','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26735,'48617','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(791,'02532','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37721,'64735','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32110,'56357','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16253,'31810','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21456,'40272','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19168,'37032','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13108,'27844','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43532,'74458','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51948,'93761','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4222,'11571','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55007,'99649','Lake and Peninsula','2164','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(47632,'80553','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37915,'65072','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37457,'64147','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8031,'18098','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30378,'54405','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32753,'57301','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39398,'67550','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38217,'65608','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5807,'14464','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12018,'25714','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19490,'37353','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32014,'56291','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51085,'92065','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49101,'84791','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48089,'81637','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44668,'76108','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3805,'10211','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20732,'39115','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(35602,'61741','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15725,'31014','Pulaski','13235','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33919,'59024','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27597,'49673','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22098,'41630','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48970,'84529','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53717,'97242','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(53927,'97524','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(27136,'49052','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17067,'33102','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3257,'08751','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31163,'55312','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(49445,'85658','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4070,'11054','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16131,'31707','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17967,'34984','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18717,'36256','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22001,'41314','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36949,'63376','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36859,'63134','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36224,'62479','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31715,'56051','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30663,'54658','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29984,'53559','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24112,'45171','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1486,'04364','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(12940,'27570','Warren','37185','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2261,'06247','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10458,'23038','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11120,'24132','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42284,'72444','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46561,'78838','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50908,'91510','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51083,'92061','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52466,'95129','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9234,'20533','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1299,'03902','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31152,'55301','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(6209,'15042','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(646,'02132','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(38362,'65721','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36711,'62985','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35829,'62032','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27426,'49415','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8955,'20061','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(45145,'76708','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53251,'96350','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(47771,'80864','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23321,'43943','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1557,'04497','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(37291,'63936','Stoddard','29207','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35327,'61370','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51910,'93701','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44734,'76225','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20640,'38963','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21929,'41146','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(278,'01098','Hampshire','25015','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26312,'48048','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17271,'33462','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15977,'31502','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46861,'79243','Dickens','48125','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47544,'80455','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54598,'98685','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51257,'92311','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47602,'80524','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45733,'77564','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15606,'30734','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24810,'46077','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40125,'68636','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(38301,'65661','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35230,'61266','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33559,'58460','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25497,'46996','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47460,'80241','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53956,'97624','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33,'00662','Isabela','72071','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(53822,'97388','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33463,'58366','Rolette','38079','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35676,'61834','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42062,'72131','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41705,'71670','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40603,'69130','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10154,'22504','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6930,'16142','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45976,'78044','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48921,'84320','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49818,'87510','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(50193,'88901','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51102,'92086','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7950,'18014','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52347,'94941','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11162,'24179','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3645,'09822','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(39386,'67544','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37884,'65049','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37009,'63452','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17465,'33756','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31419,'55598','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31249,'55369','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29236,'52208','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11939,'25559','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44206,'75474','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44786,'76271','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46132,'78248','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26073,'47808','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16617,'32433','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25716,'47305','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15985,'31513','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51767,'93501','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52853,'95668','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54688,'99001','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(34049,'59255','McCone','30055','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40073,'68512','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18665,'36093','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13379,'28139','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20491,'38824','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43027,'73554','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45829,'77833','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5572,'14001','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12107,'25917','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10054,'22211','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15456,'30566','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35086,'61030','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32131,'56373','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31247,'55368','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31159,'55308','Sherburne','27141','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25309,'46795','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19636,'37694','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44785,'76270','Wise','48497','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46778,'79094','Armstrong','48011','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44769,'76258','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43659,'74740','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22763,'43105','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7787,'17760','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33480,'58380','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38295,'65656','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2035,'05759','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(19444,'37322','Meigs','47121','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2937,'07961','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36919,'63347','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28128,'50206','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23232,'43780','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42890,'73159','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44089,'75355','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11439,'24576','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43813,'74964','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21246,'39885','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22443,'42364','Hancock','21091','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(32264,'56533','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(9596,'21106','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30652,'54651','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31840,'56151','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43394,'74130','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13194,'27926','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18485,'35899','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1089,'03256','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(49446,'85658','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47850,'81027','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26378,'48122','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15651,'30811','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41787,'71836','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45119,'76682','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13161,'27888','Greene','37079','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19921,'38044','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15721,'31012','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30488,'54479','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34559,'60129','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38323,'65682','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11329,'24450','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45331,'77045','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44221,'75486','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41235,'70815','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6785,'15924','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3557,'09623','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(5847,'14506','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20195,'38454','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29886,'53267','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50003,'88116','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(25672,'47243','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24668,'45867','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20923,'39401','Lamar','28073','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3540,'09595','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20764,'39156','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6472,'15448','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7377,'16943','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27890,'50003','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47303,'80013','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51958,'93778','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(359,'01364','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54052,'97862','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(6003,'14737','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17537,'33853','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49195,'85137','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(38964,'66943','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19275,'37101','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23543,'44234','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7967,'18036','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18003,'35022','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17996,'35016','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1497,'04416','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4838,'12760','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22656,'43013','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21398,'40176','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5113,'13116','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6162,'14897','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28308,'50393','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42710,'73017','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15275,'30420','Tattnall','13267','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53561,'97028','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52142,'94286','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44603,'76048','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3686,'10001','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8908,'20007','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35943,'62237','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40291,'68783','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41331,'71071','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53715,'97239','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(21484,'40316','Menifee','21165','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4394,'12024','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32215,'56470','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34458,'60025','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44122,'75409','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45762,'77598','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52214,'94544','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14987,'30145','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16501,'32240','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5148,'13152','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33884,'58845','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34866,'60585','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44916,'76463','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10138,'22471','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3891,'10514','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31661,'56007','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13306,'28080','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29070,'51601','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36255,'62536','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47905,'81084','Prowers','8099','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14087,'29041','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9070,'20190','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17177,'33310','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16569,'32348','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38557,'66072','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47304,'80014','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18147,'35186','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19086,'36856','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33465,'58367','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(52289,'94621','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10412,'22968','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41108,'70637','Beauregard','22011','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54852,'99326','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(20928,'39404','Forrest','28035','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(706,'02302','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2144,'06045','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3830,'10281','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3709,'10025','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1333,'04030','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4725,'12522','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4955,'12922','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37997,'65259','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36498,'62839','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28873,'51247','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25369,'46903','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22129,'41721','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1498,'04417','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(53923,'97504','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46612,'78946','Lee','48287','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35091,'61037','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34203,'59471','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(18310,'35560','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28902,'51350','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12232,'26184','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50598,'90278','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44535,'75966','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39497,'67647','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30975,'54978','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8848,'19897','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(28747,'51010','Monona','19133','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(120,'00804','Saint Thomas','78030','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(8684,'19435','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2288,'06330','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32267,'56535','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25591,'47135','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18892,'36518','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16897,'32818','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6683,'15747','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9678,'21234','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30208,'54014','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48849,'84105','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54789,'99153','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11671,'25063','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4145,'11369','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21665,'40546','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20430,'38720','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(425,'01535','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9914,'21822','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9017,'20134','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9054,'20175','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36713,'62987','Pope','17151','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8337,'18834','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48867,'84123','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(23447,'44099','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45551,'77382','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42332,'72501','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36610,'62912','Johnson','17087','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16492,'32234','Baker','12003','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(661,'02149','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22514,'42464','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14435,'29518','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22825,'43152','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1457,'04290','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6147,'14884','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49956,'88025','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(35567,'61720','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4116,'11237','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2712,'07435','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50643,'90604','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44006,'75189','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1799,'05035','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18471,'35810','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8614,'19320','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21696,'40701','Laurel','21125','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21101,'39664','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45120,'76684','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51930,'93722','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30743,'54754','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16225,'31792','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9697,'21275','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24119,'45201','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20498,'38826','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9471,'20853','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27870,'49958','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32430,'56716','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2187,'06094','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(41412,'71226','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43210,'73848','Ellis','40045','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46397,'78638','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50133,'88528','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(25365,'46901','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47256,'79936','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28405,'50480','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13955,'28732','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17483,'33775','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2534,'06883','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8728,'19496','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24757,'46041','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16811,'32714','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27140,'49056','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35310,'61354','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52340,'94930','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49168,'85075','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44906,'76459','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36597,'62902','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10593,'23188','James City','51095','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5222,'13325','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4724,'12521','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26751,'48624','Roscommon','26143','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54255,'98233','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1880,'05340','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(26955,'48841','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29314,'52306','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35740,'61910','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37309,'63952','Wayne','29223','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39802,'68114','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40713,'69340','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42867,'73137','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48601,'83641','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(51854,'93622','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5880,'14532','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41219,'70791','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43263,'74015','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(13334,'28104','Union','37179','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2443,'06699','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(48707,'83839','Shoshone','16079','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(36855,'63131','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45768,'77616','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(496,'01775','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24060,'45119','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22559,'42642','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35251,'61285','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35726,'61874','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1360,'04069','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(41574,'71418','Richland','22083','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40114,'68629','Stanton','31167','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35622,'61754','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39336,'67484','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51670,'93268','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2136,'06039','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54129,'98040','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50022,'88135','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6376,'15313','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23965,'44875','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30350,'54230','Manitowoc','55071','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28898,'51346','Osceola','19143','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5645,'14070','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25072,'46384','Porter','18127','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23721,'44555','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44244,'75497','Wood','48499','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34075,'59301','Powder River','30075','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29381,'52355','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22368,'42252','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43147,'73741','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44779,'76265','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19210,'37059','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23049,'43515','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21472,'40296','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28005,'50102','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25345,'46857','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23874,'44807','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12248,'26218','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42256,'72421','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34774,'60502','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11443,'24579','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54028,'97830','Wheeler','41069','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26827,'48729','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28222,'50258','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17216,'33401','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30633,'54637','Juneau','55057','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33741,'58649','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11242,'24314','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52098,'94206','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50427,'89701','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47025,'79512','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34778,'60503','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22181,'41834','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10672,'23314','Isle of Wight','51093','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17114,'33163','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9983,'22037','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12050,'25813','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28665,'50680','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33516,'58425','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21131,'39740','Lowndes','28087','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53657,'97137','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(16018,'31545','Wayne','13305','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3471,'09382','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(41034,'70538','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10182,'22546','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23856,'44714','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46992,'79412','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17233,'33418','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20501,'38829','Prentiss','28117','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21781,'40940','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23008,'43447','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8336,'18833','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26389,'48135','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10325,'22831','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54040,'97843','Gilliam','41021','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48112,'81656','Pitkin','8097','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46388,'78631','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46341,'78605','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34154,'59425','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31468,'55734','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27463,'49448','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(720,'02337','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13268,'28031','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14554,'29639','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38635,'66276','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34227,'59525','Hill','30041','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33706,'58631','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27250,'49238','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23828,'44685','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9417,'20770','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18490,'35904','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47340,'80047','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(42689,'73005','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32282,'56547','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15961,'31406','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21115,'39669','Wilkinson','28157','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12781,'27332','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20427,'38702','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5076,'13072','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15467,'30576','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43142,'73736','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18614,'36046','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17121,'33170','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7346,'16910','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42656,'72938','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(44193,'75459','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45998,'78064','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12810,'27370','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8768,'19543','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15350,'30502','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18095,'35125','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41868,'71958','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(428,'01538','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9474,'20857','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16486,'32227','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34858,'60564','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40453,'68936','Furnas','31065','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40246,'68755','Boyd','31015','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36021,'62293','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40115,'68631','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(24700,'45887','Auglaize','39011','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22460,'42378','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33849,'58782','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42132,'72214','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21260,'40008','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44107,'75382','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47321,'80025','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48096,'81641','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7872,'17870','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24941,'46209','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45977,'78045','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5817,'14472','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12578,'27007','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(14141,'29102','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7867,'17865','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30913,'54930','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33712,'58636','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35098,'61042','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36356,'62656','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46931,'79347','Lamb','48279','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45703,'77532','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42716,'73020','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42526,'72736','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6248,'15083','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5003,'12980','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33277,'58063','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51441,'92659','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49413,'85624','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44364,'75688','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42791,'73068','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37133,'63640','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23865,'44767','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22876,'43234','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22480,'42437','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8422,'19003','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52904,'95728','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31982,'56267','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35272,'61324','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40976,'70462','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52557,'95303','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17247,'33433','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40940,'70435','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7461,'17060','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1389,'04104','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34305,'59735','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(39073,'67059','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54950,'99577','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(8946,'20051','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42640,'72926','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40975,'70462','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19977,'38116','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37050,'63534','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5373,'13620','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27626,'49690','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40886,'70341','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42642,'72927','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47426,'80216','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11316,'24437','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36537,'62868','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1895,'05358','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13514,'28328','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49579,'86321','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47788,'80916','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29870,'53220','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26000,'47619','Warrick','18173','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10145,'22481','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24883,'46155','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5272,'13411','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7853,'17847','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(41708,'71671','Cleveland','5025','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39194,'67232','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27101,'49026','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13686,'28478','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20436,'38725','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4022,'10970','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17485,'33777','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15709,'31006','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37758,'64766','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39474,'67637','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7991,'18055','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40875,'70189','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44007,'75189','Rockwall','48397','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45229,'76875','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50058,'88301','Lincoln','35027','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(53511,'96915','Guam','66010','GU','Guam',0,'2013-07-03 15:17:54',NULL,NULL),(53537,'97006','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(55106,'99759','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(24851,'46128','Putnam','18133','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21886,'41083','Carroll','21041','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49450,'85701','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49673,'87020','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51335,'92408','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52191,'94520','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10742,'23454','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3031,'08085','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7192,'16646','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31967,'56258','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33574,'58472','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36407,'62701','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(55043,'99685','Aleutians West','2016','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(54291,'98274','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47106,'79602','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42770,'73055','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42279,'72438','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39730,'68026','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2632,'07077','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53835,'97405','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(30376,'54404','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(34316,'59750','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45219,'76869','San Saba','48411','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48836,'84090','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(16566,'32346','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49980,'88052','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(50628,'90410','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51710,'93390','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13279,'28037','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27241,'49230','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30459,'54459','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38992,'66964','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40345,'68828','Valley','31175','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4248,'11707','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47107,'79602','Taylor','48441','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41045,'70549','Cameron','22023','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18084,'35115','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33755,'58656','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34639,'60194','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43336,'74066','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53003,'95943','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52990,'95930','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45672,'77496','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4159,'11405','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14167,'29127','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11555,'24851','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17670,'34058','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(28727,'50980','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(51337,'92411','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53122,'96071','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10903,'23882','Dinwiddie','51053','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51318,'92389','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50808,'91305','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48220,'82510','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(47338,'80045','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47336,'80044','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34633,'60189','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5557,'13860','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2676,'07203','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9888,'21784','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27457,'49441','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36190,'62459','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38074,'65345','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48737,'83869','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50872,'91390','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33593,'58486','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1541,'04475','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(3702,'10018','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36358,'62660','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37609,'64623','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40533,'69001','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14384,'29456','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25932,'47537','Spencer','18147','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35770,'61933','Coles','17029','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39252,'67418','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3979,'10913','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21304,'40047','Spencer','21215','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16735,'32610','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16966,'32940','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32496,'56950','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(11976,'25651','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43914,'75093','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20756,'39149','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32068,'56330','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37662,'64655','Putnam','29171','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51359,'92519','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7465,'17062','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15203,'30329','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34769,'60487','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39155,'67150','Harper','20077','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11152,'24165','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19536,'37379','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27636,'49707','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31171,'55318','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48811,'84065','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(26750,'48624','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26488,'48235','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8595,'19193','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13028,'27703','Durham','37063','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8393,'18951','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40109,'68628','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33209,'58012','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31740,'56069','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29358,'52335','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29126,'52042','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23193,'43747','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24197,'45303','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29230,'52203','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30783,'54772','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37334,'64011','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40810,'70091','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54647,'98858','Douglas','53017','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39161,'67155','Comanche','20033','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19861,'37931','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22664,'43016','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24947,'46218','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31317,'55418','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36393,'62690','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53684,'97212','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7342,'16879','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17802,'34431','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28246,'50274','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29185,'52141','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35535,'61611','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50617,'90311','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38399,'65745','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40312,'68801','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40878,'70301','Assumption','22007','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49849,'87544','Los Alamos','35028','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(7844,'17840','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1819,'05055','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(2296,'06338','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32387,'56660','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12946,'27573','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34008,'59116','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34680,'60420','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37638,'64641','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38730,'66528','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40939,'70434','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41202,'70775','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41477,'71281','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19900,'38025','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25808,'47383','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41176,'70747','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46994,'79414','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48932,'84331','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49397,'85609','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50185,'88584','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(51361,'92522','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22953,'43347','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4698,'12490','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17333,'33548','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25656,'47230','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47491,'80294','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49013,'84646','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54466,'98527','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(649,'02135','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45098,'76664','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29481,'52577','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28862,'51239','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27182,'49087','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(45730,'77562','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46023,'78108','Comal','48091','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49215,'85201','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50241,'89049','Nye','32023','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(10221,'22622','Frederick','51069','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45308,'77022','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42607,'72847','Pope','5115','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40363,'68840','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39813,'68128','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39177,'67212','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38365,'65723','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36248,'62530','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31674,'56019','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10296,'22739','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25191,'46626','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31609,'55956','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35094,'61039','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44537,'75968','Sabine','48403','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12048,'25811','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24899,'46163','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16374,'32092','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23230,'43778','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33499,'58413','McIntosh','38051','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1484,'04360','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9282,'20601','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3683,'09890','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53855,'97430','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52963,'95894','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10503,'23090','York','51199','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10594,'23188','Williamsburg City','51830','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24759,'46041','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35489,'61539','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48061,'81524','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5398,'13647','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23267,'43836','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19063,'36801','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34459,'60026','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40791,'70069','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43258,'74012','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52124,'94259','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8543,'19128','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36435,'62769','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53748,'97311','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11075,'24083','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54774,'99138','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32402,'56676','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32754,'57301','Hanson','46061','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39505,'67651','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54784,'99148','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41856,'71943','Montgomery','5097','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26619,'48430','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27089,'49017','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4366,'11967','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43850,'75033','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38978,'66953','Washington','20201','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15416,'30539','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15358,'30510','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10662,'23301','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2760,'07602','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(20322,'38588','Macon','47111','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16858,'32774','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16210,'31783','Irwin','13155','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15520,'30631','Wilkes','13317','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25387,'46919','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4886,'12821','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43564,'74536','Latimer','40077','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40155,'68654','York','31185','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36223,'62479','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29209,'52162','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10828,'23707','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22268,'42079','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44884,'76445','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28031,'50117','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42300,'72459','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24411,'45633','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2765,'07607','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18496,'35950','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19926,'38049','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8681,'19429','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42079,'72143','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37682,'64670','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26773,'48640','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26193,'47944','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8011,'18073','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22489,'42445','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2300,'06350','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(25993,'47613','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38792,'66621','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47024,'79512','Mitchell','48335','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36639,'62931','Gallatin','17059','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42796,'73072','McClain','40087','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52849,'95664','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6466,'15442','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23811,'44670','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2497,'06807','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(18119,'35149','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15876,'31099','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26452,'48197','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5588,'14013','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(902,'02777','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(1715,'04862','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(54171,'98103','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45750,'77583','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34112,'59343','Custer','30017','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31224,'55349','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19750,'37822','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15058,'30214','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14796,'30010','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6563,'15613','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40813,'70094','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(47702,'80743','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9863,'21762','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32788,'57330','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40354,'68834','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22940,'43342','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41273,'71016','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39772,'68064','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17768,'34266','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34673,'60412','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7348,'16912','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1047,'03107','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12901,'27537','Vance','37181','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23418,'44068','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22577,'42718','Green','21087','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19951,'38070','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1014,'03049','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30624,'54629','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13361,'28127','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34489,'60062','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28962,'51461','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28776,'51027','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27581,'49657','Wexford','26165','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25719,'47308','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11990,'25674','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21220,'39845','Early','13099','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47414,'80206','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48527,'83524','Lewis','16061','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(2370,'06468','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6188,'15018','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15579,'30683','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6202,'15032','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6874,'16055','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2214,'06131','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23309,'43932','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23545,'44235','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43629,'74650','Osage','40113','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9585,'21088','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18535,'35976','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31449,'55716','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28813,'51050','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22160,'41774','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47794,'80922','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3741,'10103','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36442,'62796','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33733,'58646','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9020,'20135','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53841,'97411','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48793,'84050','Morgan','49029','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21718,'40769','McCreary','21147','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18992,'36703','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32984,'57528','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5756,'14303','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4782,'12583','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6405,'15344','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47662,'80648','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(47186,'79778','Upton','48461','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29269,'52225','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37798,'64841','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5342,'13492','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11545,'24843','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32556,'57037','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38737,'66534','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23551,'44240','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24808,'46076','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47800,'80927','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51745,'93446','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18943,'36580','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38375,'65729','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38014,'65274','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35935,'62232','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16114,'31649','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15509,'30625','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14416,'29485','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12965,'27592','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12688,'27233','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45005,'76547','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9349,'20689','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10508,'23093','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10699,'23398','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18047,'35070','Cullman','1043','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36368,'62667','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10361,'22910','Charlottesville City','51540','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27770,'49834','Dickinson','26043','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8878,'19953','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(44962,'76511','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48342,'83123','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5671,'14110','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39427,'67567','Stafford','20185','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34372,'59847','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(14260,'29302','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3127,'08343','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13624,'28428','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9392,'20741','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(9296,'20613','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(45885,'77954','De Witt','48123','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34313,'59747','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(19341,'37166','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9293,'20611','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8485,'19072','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10954,'23941','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41852,'71941','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42367,'72538','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(48758,'84014','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50915,'91603','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36891,'63179','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41271,'71008','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40150,'68652','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7492,'17083','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17278,'33469','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16903,'32825','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30295,'54161','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3657,'09834','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6962,'16221','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22034,'41472','Elliott','21063','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6030,'14770','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8874,'19951','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(42127,'72209','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(52122,'94257','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54154,'98071','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42812,'73083','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30773,'54768','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36681,'62957','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39733,'68029','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18285,'35541','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15687,'30903','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1836,'05076','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17492,'33785','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13250,'28009','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35245,'61281','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44695,'76136','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50577,'90247','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3635,'09810','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20671,'39057','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10275,'22723','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52129,'94268','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4699,'12491','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18931,'36564','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14994,'30149','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3140,'08360','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33019,'57559','Jones','46075','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30046,'53708','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22524,'42528','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2772,'07628','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40933,'70426','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44095,'75367','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40165,'68663','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9369,'20714','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30329,'54209','Door','55029','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42661,'72944','Scott','5127','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27987,'50070','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16066,'31606','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23094,'43548','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47125,'79707','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46301,'78561','Willacy','48489','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20208,'38464','Lawrence','47099','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4729,'12526','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37323,'63964','Madison','29123','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31637,'55974','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7012,'16311','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30613,'54622','Buffalo','55011','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(22479,'42436','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12874,'27519','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48064,'81527','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50444,'89815','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(52767,'95563','Trinity','6105','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(486,'01748','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52678,'95437','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49981,'88053','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(24216,'45314','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12789,'27343','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26022,'47660','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18008,'35032','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5209,'13314','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18235,'35448','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33623,'58524','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(873,'02721','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26966,'48848','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8941,'20045','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20986,'39476','Wayne','28153','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(45723,'77551','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50321,'89166','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(41302,'71046','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48192,'82401','Big Horn','56003','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(13753,'28561','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4742,'12541','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36907,'63334','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5762,'14414','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4005,'10952','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24116,'45176','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10884,'23857','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46261,'78465','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51798,'93539','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52314,'94801','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31150,'55187','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44037,'75231','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14728,'29853','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20832,'39269','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12673,'27209','Montgomery','37123','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19604,'37644','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14447,'29540','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33558,'58458','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15972,'31418','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(353,'01349','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12836,'27420','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17684,'34105','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17580,'33908','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14393,'29466','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40038,'68454','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22171,'41819','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22521,'42518','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(51033,'91951','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50834,'91337','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48950,'84408','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(19518,'37367','Bledsoe','47007','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46290,'78547','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46121,'78237','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19710,'37770','Morgan','47129','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20878,'39337','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21005,'39506','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26885,'48766','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28070,'50142','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6498,'15478','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35973,'62257','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39803,'68116','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45837,'77840','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45704,'77532','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30256,'54124','Menominee','55078','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9606,'21128','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(32677,'57233','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13386,'28150','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8926,'20029','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36047,'62324','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5784,'14432','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40439,'68928','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(28245,'50273','Madison','19121','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22880,'43240','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19858,'37929','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10155,'22504','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31423,'55602','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(95,'00757','Santa Isabel','72133','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(31613,'55960','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18491,'35905','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15798,'31050','Crawford','13079','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34623,'60180','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41744,'71751','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51428,'92646','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46595,'78934','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9895,'21791','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42419,'72611','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(32886,'57422','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21586,'40422','Garrard','21079','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4307,'11779','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6770,'15870','McKean','42083','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39593,'67758','Wallace','20199','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37844,'65014','Maries','29125','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(2740,'07502','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12829,'27411','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1577,'04563','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38493,'66015','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2775,'07632','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1732,'04924','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29860,'53211','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21640,'40509','Clark','21049','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23305,'43930','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(46061,'78143','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23251,'43812','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22121,'41669','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20946,'39439','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8661,'19397','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(898,'02768','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22945,'43343','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20466,'38761','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32238,'56510','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(7410,'17020','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45890,'77962','Jackson','48239','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52276,'94607','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47234,'79914','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9994,'22046','Falls Church City','51610','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28850,'51231','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1845,'05089','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34725,'60453','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17362,'33585','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7758,'17727','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19238,'37076','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44493,'75926','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20674,'39059','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25188,'46617','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39339,'67485','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18835,'36439','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14857,'30052','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6604,'15662','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(698,'02266','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(36506,'62846','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49389,'85602','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(34007,'59115','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(9923,'21837','Wicomico','24045','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(36816,'63091','Gasconade','29073','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38206,'65603','Dade','29057','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6642,'15697','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34286,'59715','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33379,'58266','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29130,'52045','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(50597,'90277','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(19899,'38024','Dyer','47045','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54497,'98559','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46246,'78409','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44900,'76457','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28903,'51351','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13815,'28615','Ashe','37009','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31185,'55328','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31490,'55756','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35727,'61875','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40676,'69201','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12851,'27502','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29004,'51535','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7439,'17042','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3137,'08350','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44106,'75381','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54162,'98082','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53223,'96267','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(42631,'72908','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4538,'12189','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8257,'18623','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27851,'49927','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28408,'50482','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19471,'37337','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23792,'44653','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8462,'19041','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22507,'42461','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10326,'22832','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6927,'16140','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50801,'91225','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46276,'78522','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44555,'75990','Tyler','48457','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44049,'75244','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24210,'45309','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7496,'17086','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39361,'67514','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(218,'01013','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47963,'81220','Gunnison','8051','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46368,'78621','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10882,'23856','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3160,'08512','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(53981,'97721','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12463,'26587','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12004,'25701','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10764,'23486','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21584,'40419','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24248,'45335','Clinton','39027','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24715,'45895','Shelby','39149','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24927,'46182','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5591,'14021','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54304,'98286','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51991,'93943','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51264,'92318','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47652,'80638','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(19146,'37020','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46840,'79227','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24964,'46235','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46313,'78572','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54063,'97876','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47168,'79758','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23348,'43974','Harrison','39067','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6166,'14902','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20173,'38387','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15540,'30648','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16008,'31537','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25293,'46784','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26297,'48034','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36080,'62356','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52078,'94141','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45062,'76633','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44524,'75956','Jasper','48241','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21127,'39735','Winston','28159','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31622,'55965','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32421,'56701','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35518,'61567','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37825,'64864','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19624,'37681','Greene','47059','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45605,'77445','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23978,'44888','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10123,'22437','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19175,'37036','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53229,'96283','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(53940,'97536','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52294,'94659','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46514,'78745','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22756,'43093','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21879,'41072','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21552,'40380','Powell','21197','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27759,'49820','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32535,'57025','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13372,'28135','Anson','37007','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18356,'35603','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36236,'62514','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37535,'64455','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16739,'32615','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33536,'58442','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16345,'32058','Union','12125','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14437,'29519','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20324,'38589','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20734,'39117','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47356,'80109','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51529,'92870','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53118,'96067','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53703,'97227','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9231,'20530','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19277,'37101','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29374,'52348','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20021,'38187','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22762,'43103','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24798,'46070','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25825,'47401','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52216,'94546','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36851,'63128','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5374,'13621','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14679,'29813','Barnwell','45011','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10302,'22743','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32880,'57401','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25296,'46787','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(51969,'93902','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46489,'78724','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25874,'47454','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23409,'44060','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30449,'54454','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42002,'72082','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33437,'58343','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31445,'55710','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20867,'39328','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16440,'32174','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15045,'30187','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22437,'42352','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43561,'74533','Atoka','40005','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47454,'80235','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51255,'92309','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47203,'79835','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23177,'43731','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23109,'43558','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15282,'30426','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31041,'55041','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32884,'57421','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18541,'35980','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38706,'66509','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(843,'02651','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21465,'40290','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28066,'50140','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23283,'43903','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42819,'73092','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46601,'78941','Bastrop','48021','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49390,'85602','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47911,'81091','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23438,'44090','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40862,'70174','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5550,'13848','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23786,'44646','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3045,'08096','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8288,'18660','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5490,'13778','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30090,'53813','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29200,'52157','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21093,'39661','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22868,'43224','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44850,'76424','Stephens','48429','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45814,'77720','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48138,'82071','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51932,'93724','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50302,'89147','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(47164,'79755','Reagan','48383','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44561,'76006','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22716,'43062','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31032,'55033','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40848,'70156','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1619,'04645','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8793,'19607','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39930,'68354','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30905,'54923','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29034,'51557','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:52',NULL,NULL),(45377,'77086','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53811,'97376','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5393,'13641','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53215,'96214','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(45578,'77420','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19076,'36850','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18590,'36032','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34734,'60462','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16001,'31527','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24854,'46130','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6502,'15483','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21245,'39877','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6281,'15134','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18209,'35291','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40655,'69163','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29657,'53013','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23316,'43940','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49533,'86002','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50097,'88411','Quay','35037','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(52970,'95912','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40256,'68761','Antelope','31003','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51766,'93483','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51703,'93383','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51125,'92118','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29632,'52804','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16577,'32358','Wakulla','12129','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29517,'52630','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6937,'16150','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45738,'77572','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45839,'77842','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17558,'33877','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16923,'32859','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31188,'55330','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29824,'53171','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(888,'02747','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30072,'53793','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37296,'63939','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6488,'15467','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2763,'07605','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33705,'58631','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13251,'28010','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26106,'47853','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54809,'99173','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(15919,'31295','Bibb','13021','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4137,'11361','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16343,'32058','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45237,'76883','Kimble','48267','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51583,'93067','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54707,'99017','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54674,'98939','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28984,'51526','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2368,'06461','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8532,'19118','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38825,'66736','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36135,'62424','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35679,'61840','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9581,'21084','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31125,'55121','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(12407,'26456','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21470,'40294','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53569,'97034','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2821,'07728','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5106,'13110','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27502,'49523','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3626,'09798','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(6542,'15553','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42597,'72840','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5511,'13807','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9940,'21864','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27097,'49022','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22678,'43028','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8795,'19609','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32978,'57521','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8319,'18820','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40649,'69157','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40375,'68850','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33137,'57735','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27357,'49327','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2774,'07631','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7749,'17703','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38724,'66524','Douglas','20045','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43703,'74832','Lincoln','40081','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39775,'68065','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51994,'93953','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46319,'78578','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4337,'11933','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25763,'47352','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37439,'64125','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26940,'48834','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3263,'08757','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40493,'68958','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19221,'37063','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23730,'44609','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20490,'38821','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11107,'24121','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11883,'25434','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(241,'01054','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52123,'94258','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(760,'02454','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(26419,'48167','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29684,'53031','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42818,'73092','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51757,'93456','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8536,'19121','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6827,'15963','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8782,'19560','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25371,'46910','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12949,'27576','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21765,'40903','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22318,'42157','Monroe','21171','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24977,'46247','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12766,'27317','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39969,'68380','Pawnee','31133','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18431,'35756','Limestone','1083','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19019,'36752','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21692,'40620','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42913,'73196','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34790,'60510','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11623,'24985','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33601,'58492','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18654,'36081','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3537,'09591','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(15334,'30467','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18238,'35453','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54446,'98498','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(27768,'49831','Marquette','26103','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25663,'47234','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10467,'23050','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9508,'20903','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(3489,'09496','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(41560,'71405','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10204,'22576','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22057,'41538','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36107,'62380','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36655,'62940','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23662,'44437','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22977,'43412','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11343,'24472','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35856,'62060','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19466,'37335','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40212,'68732','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18980,'36671','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4339,'11935','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2956,'08007','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13189,'27922','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29555,'52657','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27723,'49779','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52179,'94511','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37702,'64688','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38894,'66838','Morris','20127','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(7332,'16871','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39079,'67063','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39175,'67210','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53404,'96742','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(51953,'93773','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(31683,'56026','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18866,'36474','Covington','1039','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18347,'35592','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11818,'25309','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34785,'60506','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2854,'07802','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50373,'89430','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(3757,'10119','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5438,'13685','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49505,'85775','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(968,'02888','Kent','44003','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(26951,'48838','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31682,'56025','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35897,'62088','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50448,'89823','Elko','32007','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(44664,'76105','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42170,'72333','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(25857,'47439','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25630,'47170','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23144,'43659','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33106,'57661','Dewey','46041','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19796,'37868','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15351,'30503','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40131,'68638','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27055,'48922','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12648,'27111','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11035,'24040','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1558,'04497','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(24490,'45697','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13716,'28526','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41943,'72038','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15254,'30385','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46873,'79250','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22783,'43119','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26687,'48501','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6012,'14744','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29597,'52754','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14348,'29420','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1234,'03819','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52655,'95412','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50645,'90606','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49095,'84780','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47960,'81211','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10439,'23015','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7371,'16938','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22980,'43413','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26613,'48428','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28912,'51364','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37015,'63456','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39243,'67364','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(46908,'79325','Parmer','48369','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14025,'28791','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18833,'36435','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38101,'65409','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53988,'97735','Lake','41037','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51164,'92167','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18688,'36124','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53151,'96105','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53024,'95961','Yuba','6115','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48474,'83415','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(11488,'24635','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15871,'31096','Washington','13303','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7341,'16878','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18351,'35594','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29059,'51573','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30679,'54667','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28393,'50471','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44625,'76064','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44922,'76466','Eastland','48133','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51578,'93062','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51965,'93794','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51286,'92341','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24168,'45248','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5297,'13441','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27174,'49080','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30617,'54624','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18001,'35021','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36786,'63060','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21538,'40370','Harrison','21097','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38034,'65299','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23607,'44311','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23833,'44689','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25040,'46346','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2607,'07054','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32587,'57053','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7237,'16686','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38489,'66013','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40327,'68817','Sherman','31163','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42045,'72121','Cleburne','5023','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(802,'02552','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22323,'42164','Allen','21003','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21838,'41031','Robertson','21201','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14806,'30014','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18272,'35487','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4817,'12737','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6960,'16218','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15108,'30252','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11855,'25375','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45710,'77536','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42943,'73446','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27791,'49861','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35063,'61010','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4433,'12065','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32581,'57050','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(56,'00698','Yauco','72153','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(49840,'87532','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49536,'86005','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(27296,'49276','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35800,'62002','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37694,'64680','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14392,'29466','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1222,'03805','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(51243,'92280','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50695,'90733','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11298,'24412','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8535,'19120','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18440,'35760','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17266,'33458','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10707,'23410','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40561,'69033','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47543,'80454','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(22459,'42377','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24755,'46040','Madison','18095','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20448,'38739','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28744,'51007','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33497,'58405','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16472,'32212','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40191,'68717','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16885,'32805','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2087,'05855','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(42034,'72112','Woodruff','5147','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(631,'02117','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(14900,'30087','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15952,'31328','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40230,'68745','Cedar','31027','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37104,'63622','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36277,'62550','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44522,'75954','Panola','48365','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23813,'44672','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24568,'45786','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26904,'48809','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30659,'54655','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31796,'56119','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3982,'10916','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5914,'14564','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53711,'97232','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(26933,'48831','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14802,'30012','Walton','13297','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18233,'35447','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51313,'92378','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43115,'73716','Alfalfa','40003','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11900,'25505','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25221,'46725','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54110,'98022','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(46059,'78141','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39596,'67761','Wallace','20199','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39560,'67738','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25140,'46543','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21536,'40363','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20098,'38329','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(34606,'60164','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13521,'28334','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26768,'48636','Oscoda','26135','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53867,'97443','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48574,'83616','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44650,'76092','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38247,'65626','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1289,'03884','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9692,'21252','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(623,'02109','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(651,'02137','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51249,'92286','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44447,'75838','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39719,'68017','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(23009,'43449','Ottawa','39123','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52641,'95388','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35819,'62022','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7462,'17060','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15336,'30470','Treutlen','13283','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10207,'22578','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49309,'85337','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47161,'79752','Upton','48461','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44506,'75936','Polk','48373','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43036,'73561','Jefferson','40067','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41200,'70773','Pointe Coupee','22077','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18669,'36104','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12963,'27591','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13073,'27817','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8896,'19973','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(46105,'78222','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46065,'78147','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43033,'73559','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27906,'50020','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15857,'31088','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7732,'17583','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27466,'49449','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3913,'10541','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6865,'16049','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3670,'09852','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54934,'99558','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50105,'88422','Union','35059','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(33640,'58544','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28243,'50272','Lucas','19117','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5528,'13827','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7937,'17981','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11598,'24931','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10661,'23298','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50970,'91762','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45929,'78002','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34086,'59315','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25570,'47119','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27230,'49204','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14081,'29037','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6381,'15317','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1350,'04054','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(36996,'63443','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34197,'59466','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(20518,'38847','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27498,'49515','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2546,'06907','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(20525,'38850','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21028,'39563','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54940,'99566','Valdez Cordova','2261','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52406,'95032','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49725,'87104','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(38531,'66048','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(4678,'12469','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27039,'48906','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34656,'60399','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32673,'57227','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(21427,'40224','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24434,'45656','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(54349,'98343','Clallam','53009','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44483,'75882','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16932,'32878','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26195,'47946','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2128,'06029','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(16854,'32768','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26852,'48745','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30056,'53726','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32414,'56684','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(12987,'27608','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26819,'48726','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28078,'50147','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28663,'50677','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31931,'56228','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35626,'61758','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42665,'72947','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43553,'74523','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53899,'97477','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(10311,'22803','Harrisonburg City','51660','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15070,'30222','Troup','13285','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3185,'08540','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5138,'13142','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26882,'48765','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27666,'49730','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40506,'68970','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3616,'09749','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(15710,'31007','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36316,'62613','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12865,'27513','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8664,'19401','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9409,'20758','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35394,'61450','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40035,'68453','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41866,'71956','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42179,'72342','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7227,'16678','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43645,'74727','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33819,'58758','Sheridan','38083','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33445,'58348','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29846,'53191','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27442,'49425','Oceana','26127','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9018,'20135','Clarke','51043','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15173,'30306','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9000,'20117','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49163,'85070','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(30078,'53805','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29322,'52312','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6906,'16120','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24599,'45821','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26875,'48761','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37119,'63629','Dent','29065','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44015,'75208','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48919,'84318','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(2886,'07850','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38309,'65668','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38513,'66033','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54679,'98944','Benton','53005','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54786,'99150','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(21676,'40582','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19300,'37133','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15933,'31310','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14660,'29732','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52892,'95703','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10164,'22517','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12283,'26268','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33949,'59052','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47979,'81235','Hinsdale','8053','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8301,'18710','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23037,'43504','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2321,'06383','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26334,'48075','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32055,'56324','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40519,'68979','Clay','31035','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49317,'85345','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(1442,'04268','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34870,'60598','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24502,'45713','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22970,'43406','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21740,'40827','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7761,'17729','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6935,'16146','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12588,'27016','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(50400,'89501','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(54138,'98051','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(17844,'34492','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7454,'17054','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38728,'66526','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(49886,'87713','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(11570,'24872','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52057,'94117','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25548,'47102','Scott','18143','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7326,'16865','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11413,'24551','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4687,'12477','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4721,'12517','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27887,'50002','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36134,'62424','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41060,'70570','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53958,'97626','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(42711,'73017','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46708,'79046','Hemphill','48211','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19775,'37848','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18367,'35618','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8227,'18515','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26431,'48176','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11872,'25422','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33568,'58466','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36214,'62474','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36623,'62920','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38627,'66222','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40016,'68440','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51263,'92317','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22761,'43103','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5071,'13066','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26364,'48108','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48423,'83316','Twin Falls','16083','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(27539,'49626','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(39656,'67862','Morton','20129','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44833,'76374','Young','48503','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46722,'79058','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47684,'80731','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7957,'18018','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27430,'49418','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30227,'54102','Marinette','55075','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36259,'62539','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8711,'19470','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55124,'99777','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52039,'94085','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22617,'42754','Grayson','21085','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20444,'38736','Sunflower','28133','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5359,'13606','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28704,'50853','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40514,'68976','Gosper','31073','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(50845,'91353','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17316,'33527','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18873,'36480','Monroe','1099','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46747,'79073','Hale','48189','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51981,'93925','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9939,'21863','Worcester','24047','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10979,'23964','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3219,'08620','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28859,'51237','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29572,'52731','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32926,'57450','Walworth','46129','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36747,'63023','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39573,'67747','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51879,'93642','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13468,'28274','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52965,'95901','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39753,'68045','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39992,'68419','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4760,'12563','Putnam','36079','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5565,'13865','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23473,'44125','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21032,'39566','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14321,'29385','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42923,'73432','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25682,'47250','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23216,'43766','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21769,'40913','Bell','21013','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5603,'14032','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30709,'54732','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43774,'74901','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53239,'96326','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(9641,'21208','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23560,'44255','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4637,'12429','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7533,'17177','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38616,'66212','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41212,'70784','West Feliciana','22125','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41353,'71106','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52293,'94649','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14090,'29045','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6255,'15089','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4447,'12077','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17049,'33069','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12179,'26105','Wood','54107','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45187,'76844','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44809,'76352','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29373,'52347','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3161,'08512','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(389,'01467','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(21098,'39663','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7013,'16311','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35165,'61101','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45530,'77365','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53116,'96064','Siskiyou','6093','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1681,'04765','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(31625,'55968','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34242,'59542','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22848,'43203','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34192,'59462','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36405,'62694','Scott','17171','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46358,'78615','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51840,'93610','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(23785,'44645','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12693,'27239','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46259,'78460','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37914,'65069','Montgomery','29139','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42965,'73461','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4154,'11379','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(45629,'77465','Calhoun','48057','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5304,'13455','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11229,'24282','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9451,'20818','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18193,'35246','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32244,'56516','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(41760,'71764','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12020,'25716','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53889,'97464','Curry','41015','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44622,'76063','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42213,'72374','Lee','5077','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2091,'05860','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3431,'09304','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43138,'73733','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25190,'46624','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23740,'44614','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43982,'75159','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44836,'76380','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49176,'85086','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53758,'97324','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31560,'55919','Houston','27055','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30036,'53597','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9642,'21208','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17592,'33919','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4103,'11223','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25542,'47042','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11030,'24034','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20801,'39191','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3178,'08533','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4085,'11205','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53897,'97475','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48021,'81403','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39642,'67851','Scott','20171','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27936,'50040','Boone','19015','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3860,'10462','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18793,'36345','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15109,'30253','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2566,'07008','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7021,'16317','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54848,'99321','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41231,'70811','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27773,'49836','Schoolcraft','26153','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(550,'01905','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8012,'18073','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20968,'39459','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(17007,'33017','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20388,'38652','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30775,'54768','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31251,'55371','Benton','27009','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52840,'95654','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14295,'29348','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44634,'76070','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41648,'71486','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32271,'56538','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(19246,'37080','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18923,'36556','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17332,'33548','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54893,'99403','Asotin','53003','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37095,'63566','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9412,'20763','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(6526,'15537','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6167,'14903','Chemung','36015','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2970,'08022','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23744,'44618','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11472,'24609','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20550,'38866','Lee','28081','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15422,'30543','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44996,'76539','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46867,'79247','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47895,'81069','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50277,'89122','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53268,'96384','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(44628,'76066','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28409,'50482','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5279,'13418','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18690,'36130','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(28130,'50206','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36631,'62924','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49060,'84740','Piute','49031','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(13290,'28056','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25696,'47272','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11445,'24581','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32476,'56758','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34453,'60020','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44391,'75754','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8585,'19181','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9591,'21102','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(16478,'32220','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34796,'60514','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37018,'63459','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46624,'78953','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11199,'24239','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54251,'98229','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19503,'37360','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13520,'28334','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43702,'74831','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42006,'72084','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30160,'53951','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2000,'05675','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20612,'38945','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(14653,'29724','Chester','45023','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31316,'55418','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54025,'97826','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52325,'94903','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48302,'82929','Sweetwater','56037','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(37769,'64779','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5422,'13671','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10800,'23609','Newport News City','51700','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20234,'38483','Lewis','47101','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17879,'34681','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35817,'62021','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38653,'66409','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24255,'45338','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17601,'33931','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12791,'27344','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53534,'97002','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50911,'91523','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14375,'29447','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5569,'13904','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2023,'05742','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(46270,'78503','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43341,'74070','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(11064,'24070','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33932,'59036','Wheatland','30107','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12202,'26147','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19902,'38028','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15224,'30348','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14262,'29303','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50858,'91365','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47609,'80533','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53297,'96540','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(13070,'27815','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48210,'82433','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(33487,'58384','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28722,'50864','Taylor','19173','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25626,'47166','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11781,'25247','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14454,'29550','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39034,'67029','Comanche','20033','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41892,'72003','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46857,'79241','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52804,'95620','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51934,'93726','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25101,'46506','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8971,'20078','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7992,'18056','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47386,'80132','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(50720,'90822','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42417,'72602','Boone','5009','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33799,'58740','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30915,'54930','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28697,'50847','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32495,'56945','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(48597,'83638','Adams','16003','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49263,'85274','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(5746,'14265','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6021,'14754','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28569,'50613','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11946,'25569','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35069,'61014','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7747,'17701','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(294,'01129','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(15882,'31131','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16051,'31566','Camden','13039','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53108,'96056','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48750,'84004','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(27110,'49034','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35941,'62237','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13426,'28220','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31942,'56237','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39808,'68122','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16457,'32193','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48135,'82063','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(15191,'30319','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23669,'44443','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26872,'48760','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29731,'53072','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44467,'75853','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13218,'27956','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46304,'78563','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47097,'79566','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6577,'15626','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22701,'43048','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22602,'42742','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14588,'29659','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17618,'33954','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46092,'78209','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(366,'01375','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(45021,'76564','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44911,'76462','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24541,'45750','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4409,'12042','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1005,'03040','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(32861,'57376','Charles Mix','46023','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7347,'16911','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27675,'49738','Kalkaska','26079','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12996,'27616','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43059,'73626','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6017,'14750','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18670,'36105','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17896,'34714','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32594,'57057','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29829,'53178','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28835,'51102','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13966,'28740','Yancey','37199','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30334,'54213','Kewaunee','55061','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25885,'47460','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42311,'72467','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(49034,'84713','Beaver','49001','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49543,'86021','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51787,'93527','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50855,'91362','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45393,'77203','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34363,'59841','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31012,'55017','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28529,'50591','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21613,'40464','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15366,'30514','Union','13291','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38383,'65735','Benton','29015','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16100,'31639','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5978,'14712','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20093,'38324','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(32221,'56474','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(43904,'75086','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46913,'79331','Dawson','48115','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52569,'95315','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43929,'75106','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13152,'27881','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16564,'32344','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2517,'06852','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33365,'58254','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36790,'63065','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40329,'68818','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40311,'68801','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39419,'67564','Barton','20009','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8843,'19892','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(27172,'49080','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27053,'48918','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19665,'37725','Cocke','47029','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14203,'29160','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13315,'28088','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52861,'95675','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49417,'85628','Santa Cruz','4023','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(33596,'58488','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8017,'18078','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(73,'00727','Caguas','72025','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42253,'72419','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(12435,'26554','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28199,'50246','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16498,'32237','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15442,'30558','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50439,'89714','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51832,'93603','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11027,'24031','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13693,'28504','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30799,'54817','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(941,'02842','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(41773,'71825','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15562,'30667','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3932,'10573','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37444,'64130','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36221,'62478','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14314,'29374','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10175,'22538','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12162,'26050','Hancock','54029','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42318,'72472','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5689,'14138','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26959,'48845','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37890,'65053','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36350,'62644','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14499,'29590','Williamsburg','45089','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11269,'24348','Grayson','51077','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24266,'45344','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20938,'39425','Perry','28111','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42793,'73070','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43690,'74821','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45868,'77873','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47759,'80834','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53201,'96158','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50074,'88337','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(38845,'66755','Bourbon','20011','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26884,'48766','Arenac','26011','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13950,'28727','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16889,'32809','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32735,'57268','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20468,'38764','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44937,'76476','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52259,'94588','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42728,'73028','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14312,'29373','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36230,'62510','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8548,'19132','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6024,'14757','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43164,'73755','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2034,'05758','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(55082,'99734','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(29204,'52160','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9163,'20406','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(18854,'36460','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18532,'35975','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17105,'33154','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19889,'38014','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25394,'46926','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10657,'23293','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32630,'57103','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25794,'47369','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28512,'50577','Humboldt','19091','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(47999,'81302','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(340,'01302','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31157,'55306','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10519,'23111','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15019,'30171','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14719,'29847','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23272,'43842','Muskingum','39119','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50289,'89134','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(37795,'64835','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(3817,'10268','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30801,'54817','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49044,'84723','Piute','49031','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(50850,'91358','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55084,'99737','Southeast Fairbanks','2240','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38996,'66970','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33300,'58104','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25770,'47354','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7856,'17853','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40872,'70185','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17496,'33803','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16716,'32571','Santa Rosa','12113','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33527,'58436','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10201,'22570','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47011,'79503','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41472,'71277','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19548,'37388','Franklin','47051','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(11207,'24250','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23673,'44444','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22476,'42419','Henderson','21101','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22558,'42642','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47227,'79906','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11867,'25413','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40320,'68813','Loup','31115','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39660,'67863','Wichita','20203','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35657,'61813','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21734,'40819','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26044,'47719','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(54249,'98228','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54119,'98030','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11440,'24577','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35932,'62230','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7445,'17046','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24855,'46131','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46633,'78959','Caldwell','48055','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48510,'83452','Teton','16081','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50327,'89179','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(51871,'93635','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22005,'41339','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23772,'44637','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28818,'51053','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17244,'33430','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35142,'61073','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1002,'03036','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(173,'00954','Toa Alta','72135','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(42225,'72389','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38805,'66710','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35390,'61447','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34307,'59739','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30374,'54402','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16435,'32164','Flagler','12035','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15599,'30730','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14924,'30103','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27331,'49310','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21759,'40868','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7329,'16866','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48358,'83211','Power','16077','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44963,'76513','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20480,'38780','Washington','28151','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10617,'23229','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2249,'06234','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5290,'13433','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2933,'07945','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39186,'67221','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17866,'34654','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40261,'68765','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35297,'61344','Bureau','17011','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44869,'76436','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(55032,'99674','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(51270,'92324','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47893,'81069','Custer','8027','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(31944,'56240','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16914,'32836','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12747,'27299','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7411,'17021','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27225,'49129','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32208,'56466','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17424,'33681','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37862,'65034','Morgan','29141','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53587,'97054','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46524,'78754','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31436,'55701','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28929,'51439','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27049,'48915','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13729,'28537','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16123,'31702','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53131,'96080','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43320,'74053','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28403,'50479','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22356,'42220','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39756,'68046','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41737,'71743','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15263,'30411','Wheeler','13309','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54142,'98056','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53541,'97009','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49901,'87736','Mora','35033','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(27592,'49666','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31026,'55029','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10342,'22849','Rockingham','51165','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40827,'70124','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4164,'11415','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46530,'78759','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44702,'76161','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9786,'21648','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20029,'38201','Weakley','47183','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38001,'65261','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1215,'03782','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(50959,'91747','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46186,'78342','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26762,'48632','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29243,'52210','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14768,'29934','Hampton','45049','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16671,'32513','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14049,'29002','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4626,'12416','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15570,'30673','Wilkes','13317','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3701,'10017','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19912,'38039','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42688,'73004','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(28992,'51529','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33206,'58008','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37666,'64657','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38067,'65337','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41006,'70518','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(41320,'71065','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10281,'22728','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19887,'38011','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14040,'28902','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25406,'46932','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23308,'43932','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(48689,'83821','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49893,'87728','Colfax','35007','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(21308,'40051','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44120,'75404','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13922,'28701','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9728,'21522','Garrett','24023','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(23264,'43832','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26019,'47648','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27093,'49021','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19540,'37382','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39878,'68323','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39884,'68326','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(42025,'72105','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21067,'39641','Lawrence','28077','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8902,'20001','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(52757,'95552','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1055,'03218','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19515,'37366','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54286,'98267','Skagit','53057','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45520,'77357','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45068,'76637','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20658,'39044','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8263,'18627','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18097,'35126','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40211,'68731','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48550,'83546','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39071,'67059','Edwards','20047','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(893,'02762','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49407,'85618','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46706,'79045','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39327,'67478','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5188,'13221','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7763,'17731','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53551,'97018','Columbia','41009','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50675,'90680','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46855,'79239','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36256,'62537','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34185,'59456','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(27961,'50055','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20095,'38327','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24027,'45056','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21909,'41105','Boyd','21019','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3174,'08528','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47175,'79765','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54525,'98590','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25581,'47125','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13376,'28137','Stanly','37167','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40077,'68520','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1731,'04923','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(30770,'54767','Dunn','55033','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19964,'38101','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33420,'58327','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39352,'67504','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9013,'20130','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18785,'36323','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16179,'31763','Lee','13177','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31366,'55479','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25636,'47177','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13599,'28395','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5400,'13648','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44502,'75933','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37978,'65243','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44997,'76539','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51565,'93031','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46394,'78635','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29088,'51645','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24736,'46030','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14611,'29680','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19151,'37023','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20166,'38378','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44673,'76113','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23318,'43942','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13635,'28436','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10210,'22580','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4105,'11225','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34294,'59722','Deer Lodge','30023','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(18800,'36351','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35503,'61553','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54285,'98266','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53600,'97064','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47645,'80622','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46220,'78379','Kleberg','48273','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14401,'29472','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16376,'32094','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(746,'02368','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3220,'08620','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7959,'18025','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34371,'59847','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(16804,'32706','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16773,'32664','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22653,'43011','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5937,'14609','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(49432,'85643','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45228,'76874','Sutton','48435','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45012,'76556','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25790,'47366','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28250,'50276','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8324,'18825','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40370,'68845','Phelps','31137','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(7599,'17306','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9097,'20222','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11000,'24012','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33078,'57639','Corson','46031','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16847,'32759','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16905,'32827','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41065,'70578','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3466,'09372','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19476,'37338','Sequatchie','47153','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(683,'02199','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50672,'90662','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25787,'47361','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29964,'53544','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38281,'65648','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6132,'14873','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3011,'08066','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(90,'00745','Canovanas','72029','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(3381,'09069','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(41361,'71112','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18294,'35549','Fayette','1057','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(848,'02659','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42680,'72959','Franklin','5047','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26081,'47834','Parke','18121','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24814,'46085','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24234,'45326','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29393,'52401','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21053,'39601','Franklin','28037','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12895,'27531','Wayne','37191','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34098,'59330','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13639,'28441','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23907,'44833','Marion','39101','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33110,'57702','Pennington','46103','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35117,'61053','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(737,'02357','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52176,'94508','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44348,'75672','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30075,'53802','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33231,'58035','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22376,'42261','Logan','21141','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36406,'62695','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37632,'64637','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14915,'30098','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48955,'84501','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(2058,'05821','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(41194,'70764','Iberville','22047','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8516,'19101','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2994,'08048','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3271,'08804','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36436,'62776','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37510,'64431','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17491,'33784','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30405,'54422','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50305,'89150','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49184,'85120','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2499,'06811','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7840,'17835','Union','42119','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30953,'54962','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40984,'70471','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54317,'98304','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(50738,'91007','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50653,'90623','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27700,'49757','Mackinac','26097','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51628,'93224','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52329,'94914','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(28411,'50483','Kossuth','19109','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33194,'57792','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33769,'58716','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36796,'63069','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37372,'64058','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7282,'16805','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50809,'91306','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42900,'73170','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(25837,'47424','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32180,'56442','Crow Wing','27035','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(22315,'42154','Barren','21009','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33044,'57580','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17751,'34237','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17056,'33076','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37678,'64667','Sullivan','29211','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL);
INSERT INTO `ZipCodeMultiCounty` VALUES (48963,'84520','Carbon','49007','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47690,'80734','Phillips','8095','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45876,'77901','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43143,'73737','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1525,'04454','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29565,'52722','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31885,'56183','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40163,'68662','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6782,'15922','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51819,'93563','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50179,'88578','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(1267,'03856','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(9593,'21104','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17308,'33513','Sumter','12119','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(407,'01510','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52915,'95763','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49670,'87017','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(45406,'77218','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7076,'16372','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26952,'48840','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30946,'54956','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14248,'29225','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42765,'73053','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46755,'79081','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3725,'10041','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24039,'45071','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25804,'47380','Jay','18075','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3372,'09053','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(32071,'56331','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33817,'58757','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39520,'67659','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(878,'02726','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13106,'27843','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54887,'99362','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51114,'92107','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10628,'23235','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13463,'28269','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22021,'41385','Breathitt','21025','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33428,'58332','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5543,'13842','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37190,'63758','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50900,'91501','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(26820,'48726','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27322,'49305','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36281,'62553','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37156,'63664','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(274,'01094','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(49482,'85735','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46842,'79230','Childress','48075','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46122,'78238','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21216,'39841','Miller','13201','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23347,'43973','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15958,'31403','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29485,'52581','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23124,'43606','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51014,'91914','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44847,'76401','Erath','48143','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27616,'49684','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4380,'12009','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13398,'28168','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18298,'35552','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8949,'20055','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42331,'72501','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6798,'15938','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29219,'52171','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7450,'17051','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16346,'32059','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(36062,'62344','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29473,'52571','Monroe','19135','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17579,'33907','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53625,'97110','Clatsop','41007','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51309,'92374','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22097,'41630','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6214,'15046','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28109,'50162','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13748,'28555','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29169,'52079','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31100,'55092','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33998,'59103','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40100,'68622','Wheeler','31183','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3581,'09710','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(20327,'38603','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18816,'36375','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29315,'52306','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28169,'50230','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2686,'07306','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7412,'17021','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25032,'46341','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23302,'43926','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44504,'75935','San Augustine','48405','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45531,'77365','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20066,'38260','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5089,'13082','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18841,'36446','Clarke','1025','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36043,'62321','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37196,'63766','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(981,'02905','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(31092,'55085','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7846,'17841','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27370,'49333','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25464,'46978','Cass','18017','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44166,'75442','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50344,'89402','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(35916,'62206','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1087,'03254','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(52814,'95629','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50399,'89496','Churchill','32001','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(21866,'41055','Fleming','21069','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(7358,'16925','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26503,'48267','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30597,'54611','Jackson','55053','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5725,'14216','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11735,'25162','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3413,'09186','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16101,'31639','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34944,'60687','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31033,'55033','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5357,'13603','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25246,'46747','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3961,'10702','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6853,'16037','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39795,'68108','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52088,'94160','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14369,'29439','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25511,'47012','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29433,'52544','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7880,'17881','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19152,'37024','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42349,'72524','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4131,'11355','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5365,'13614','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15960,'31405','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17921,'34759','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16217,'31788','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17773,'34269','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20641,'38964','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54423,'98422','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52447,'95109','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50191,'88590','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(31777,'56097','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34751,'60472','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36634,'62926','Union','17181','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24111,'45169','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31902,'56212','Lac Qui Parle','27073','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11013,'24019','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(50351,'89408','Churchill','32001','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(43423,'74186','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42813,'73084','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23788,'44648','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8589,'19185','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19663,'37723','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39364,'67518','Lane','20101','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24699,'45887','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20662,'39047','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(25557,'47110','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33753,'58655','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10991,'24003','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15996,'31521','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40331,'68821','Blaine','31009','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(48219,'82501','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(20342,'38619','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30192,'54001','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33238,'58041','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38565,'66080','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39781,'68068','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17575,'33903','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27185,'49088','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7713,'17562','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26716,'48608','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(46450,'78669','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48181,'82323','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(50986,'91780','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45199,'76854','Menard','48327','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53963,'97634','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48179,'82321','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44630,'76067','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3047,'08098','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(26706,'48557','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28627,'50654','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1889,'05352','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(3928,'10566','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38583,'66095','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(8287,'18657','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22372,'42256','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(867,'02714','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11301,'24416','Buena Vista City','51530','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31270,'55383','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(54994,'99634','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(50538,'90080','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49381,'85547','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47797,'80925','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(25481,'46986','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9532,'21013','Harford','24025','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8308,'18769','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16424,'32147','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(42637,'72919','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18746,'36276','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53612,'97080','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52204,'94534','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49148,'85048','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(21009,'39522','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(33345,'58231','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9003,'20119','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38139,'65470','Wright','29229','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46089,'78206','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54782,'99146','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44742,'76233','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37805,'64848','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40482,'68952','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3041,'08093','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54712,'99021','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44285,'75604','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44240,'75496','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11953,'25607','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4888,'12823','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7766,'17737','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20375,'38643','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3583,'09713','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(12532,'26743','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37551,'64468','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44480,'75862','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27973,'50061','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25149,'46552','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24846,'46124','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24613,'45833','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13910,'28689','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2491,'06794','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34452,'60019','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(463,'01613','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12775,'27326','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(30860,'54870','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28564,'50609','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28118,'50169','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53126,'96076','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35482,'61533','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13325,'28093','Lincoln','37109','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4616,'12404','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(25255,'46755','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34526,'60099','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6339,'15243','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19164,'37031','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42486,'72679','Van Buren','5141','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10351,'22902','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12246,'26215','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46828,'79201','Hall','48191','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49874,'87579','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49597,'86340','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(11192,'24230','Dickenson','51051','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24630,'45844','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2723,'07452','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(33346,'58231','Walsh','38099','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(15128,'30270','Fayette','13113','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37740,'64748','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16093,'31636','Echols','13101','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17667,'34044','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(20994,'39481','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3944,'10590','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23098,'43551','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26481,'48228','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5237,'13339','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23613,'44316','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23616,'44320','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26522,'48311','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14842,'30039','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15142,'30281','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15266,'30413','Johnson','13167','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7490,'17081','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39126,'67122','Elk','20049','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9267,'20577','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(43160,'73754','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33566,'58464','Foster','38031','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26639,'48442','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38498,'66019','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53772,'97341','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50060,'88310','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46626,'78954','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46583,'78880','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20609,'38941','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11111,'24124','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26662,'48460','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9883,'21780','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18428,'35754','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(36400,'62693','Logan','17107','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19991,'38133','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53300,'96543','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(45382,'77091','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6557,'15606','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29558,'52659','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20411,'38671','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2959,'08010','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44815,'76363','Haskell','48207','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44545,'75974','Shelby','48419','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21278,'40020','Nelson','21179','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25182,'46595','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25631,'47172','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1838,'05079','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16659,'32466','Washington','12133','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41639,'71473','Winn','22127','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49443,'85654','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(47730,'80815','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1366,'04076','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40317,'68812','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2052,'05775','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(1998,'05673','Washington','50023','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24691,'45882','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41976,'72065','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46865,'79245','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22243,'42053','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(6409,'15348','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12682,'27217','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42807,'73079','Caddo','40015','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(17213,'33359','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8968,'20075','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(32306,'56568','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15875,'31098','Houston','13153','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6773,'15904','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4054,'11010','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22330,'42170','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(3815,'10261','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18759,'36303','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(45821,'77806','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23220,'43772','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28093,'50154','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6088,'14837','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40645,'69156','Cheyenne','31033','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41909,'72019','Saline','5125','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9086,'20211','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(2323,'06384','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14830,'30029','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12721,'27265','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4316,'11790','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54371,'98365','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19393,'37215','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49523,'85934','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43899,'75081','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(24284,'45361','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30731,'54745','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44575,'76019','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43928,'75105','Navarro','48349','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30473,'54467','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48105,'81649','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14143,'29104','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4636,'12428','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30168,'53956','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24466,'45682','Jackson','39079','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3572,'09701','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(50298,'89143','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40747,'69366','Grant','31075','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31820,'56137','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(18761,'36305','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7512,'17105','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9246,'20546','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(12981,'27603','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10919,'23894','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52748,'95543','Del Norte','6015','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7826,'17822','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14597,'29669','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31238,'55360','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50952,'91739','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35918,'62208','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37693,'64679','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48348,'83202','Bannock','16005','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48905,'84305','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39354,'67510','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39266,'67430','Mitchell','20123','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39138,'67134','Pratt','20151','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11739,'25168','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23920,'44841','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36921,'63348','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30112,'53919','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27199,'49097','Saint Joseph','26149','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19825,'37881','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17232,'33417','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27873,'49961','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8099,'18324','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8860,'19934','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(42156,'72321','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(26069,'47804','Vigo','18167','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10609,'23225','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15500,'30621','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22849,'43204','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16275,'31827','Talbot','13263','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6755,'15853','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1345,'04047','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34416,'59926','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35927,'62221','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42266,'72429','Poinsett','5111','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(36481,'62831','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20933,'39422','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11079,'24086','Giles','51071','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54098,'98008','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(32563,'57040','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(27536,'49623','Lake','26085','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(8435,'19015','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14497,'29588','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53256,'96368','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(42290,'72450','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(5641,'14067','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17036,'33052','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18010,'35033','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27640,'49712','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44928,'76471','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44583,'76028','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18237,'35452','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26387,'48133','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26896,'48804','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51201,'92230','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45635,'77469','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13843,'28637','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27104,'49029','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14126,'29075','Lexington','45063','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15487,'30606','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25161,'46563','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(19873,'37997','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16443,'32176','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7441,'17044','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46688,'79036','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20739,'39119','Simpson','28127','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22641,'43004','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4376,'11978','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16384,'32102','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30527,'54517','Ashland','55003','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(45307,'77021','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41018,'70526','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39270,'67432','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38196,'65584','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52407,'95033','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45063,'76633','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32997,'57534','Tripp','46123','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(11442,'24579','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21172,'39767','Montgomery','28097','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22212,'42027','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26554,'48350','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27460,'49444','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54454,'98506','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(31970,'56262','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(21087,'39656','Jefferson Davis','28065','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16392,'32116','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9695,'21270','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(51011,'91911','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25689,'47264','Lawrence','18093','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5764,'14415','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35781,'61942','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22938,'43340','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45731,'77563','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34984,'60922','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33745,'58651','Slope','38087','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33550,'58454','Logan','38047','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17031,'33042','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12239,'26203','Webster','54101','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23682,'44454','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23224,'43773','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5773,'14422','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19297,'37130','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35288,'61336','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35181,'61112','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33088,'57645','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29431,'52542','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17103,'33152','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17384,'33610','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19198,'37051','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4350,'11950','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23053,'43516','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11806,'25276','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19442,'37321','Rhea','47143','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15592,'30720','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8958,'20064','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22432,'42349','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(44350,'75680','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40694,'69301','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33635,'58535','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8811,'19715','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(29449,'52554','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44484,'75884','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37421,'64105','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24923,'46180','Morgan','18109','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23615,'44319','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28277,'50323','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(48621,'83660','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46736,'79065','Roberts','48393','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39532,'67669','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30339,'54217','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4161,'11412','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26167,'47923','Carroll','18015','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24887,'46158','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15386,'30525','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35445,'61483','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32032,'56308','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16626,'32439','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12818,'27379','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5274,'13413','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36547,'62872','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29587,'52747','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3182,'08536','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11529,'24816','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8476,'19058','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24933,'46201','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5444,'13694','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2478,'06779','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(5980,'14715','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54200,'98138','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(39170,'67205','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34611,'60171','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17664,'34039','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(20713,'39094','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11511,'24726','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26857,'48748','Iosco','26069','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15852,'31085','Jasper','13159','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54669,'98934','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52862,'95676','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37545,'64463','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37060,'63541','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17953,'34957','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14918,'30101','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14876,'30066','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21141,'39745','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38153,'65536','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33452,'58355','Cavalier','38019','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7569,'17243','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12270,'26254','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10970,'23958','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51038,'91978','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18202,'35270','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18745,'36276','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(39369,'67521','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37413,'64090','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34908,'60639','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29202,'52159','Allamakee','19005','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(40492,'68957','Webster','31181','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34045,'59252','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(42554,'72761','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39744,'68038','Burt','31021','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36175,'62448','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21897,'41094','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33551,'58454','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(24946,'46217','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23457,'44109','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28450,'50533','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28713,'50860','Ringgold','19159','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36379,'62675','Menard','17129','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38744,'66538','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40980,'70466','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42116,'72183','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10289,'22734','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35931,'62226','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21801,'40981','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4630,'12420','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46528,'78758','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46958,'79366','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13717,'28526','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12326,'26339','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5292,'13436','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46392,'78634','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36483,'62832','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15742,'31021','Wilkinson','13319','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16279,'31830','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10505,'23092','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22768,'43107','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33940,'59041','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40319,'68813','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40154,'68654','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22930,'43334','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17190,'33323','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39041,'67035','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10398,'22957','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44994,'76538','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43347,'74073','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3535,'09589','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(39388,'67546','Harvey','20079','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48233,'82609','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(21070,'39641','Walthall','28147','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15236,'30359','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18122,'35151','Coosa','1037','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17222,'33407','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14963,'30126','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4370,'11971','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30700,'54727','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39960,'68375','Thayer','31169','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51518,'92859','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25864,'47448','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1503,'04422','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(14156,'29114','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33417,'58325','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34409,'59919','Flathead','30029','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(1343,'04043','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(53663,'97143','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43657,'74737','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43031,'73557','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37604,'64601','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11103,'24115','Martinsville City','51690','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7598,'17304','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2164,'06072','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29325,'52314','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42027,'72107','Conway','5029','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(688,'02206','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(43559,'74531','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(26589,'48414','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12670,'27208','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24026,'45055','Butler','39017','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27724,'49780','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41798,'71846','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45107,'76670','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46401,'78640','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47729,'80815','Kit Carson','8063','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49207,'85173','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40301,'68787','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(4019,'10965','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6070,'14818','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33557,'58458','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22918,'43325','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9791,'21651','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1393,'04108','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11202,'24244','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19598,'37640','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28252,'50277','Guthrie','19077','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28652,'50670','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35397,'61451','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37451,'64138','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37933,'65082','Miller','29131','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25439,'46957','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24372,'45479','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8558,'19142','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7641,'17354','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3453,'09354','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(33867,'58794','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40621,'69145','Banner','31007','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47568,'80480','Jackson','8057','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48517,'83464','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(31701,'56041','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(29497,'52590','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26922,'48823','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2335,'06410','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28773,'51025','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32944,'57465','Faulk','46049','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34584,'60146','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34614,'60173','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36880,'63157','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54783,'99147','Lincoln','53043','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28572,'50616','Floyd','19067','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3358,'09010','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16385,'32105','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15761,'31031','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28524,'50585','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7389,'17003','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29343,'52324','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30437,'54447','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(41076,'70586','Evangeline','22039','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45614,'77451','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51997,'93960','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25479,'46985','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(11375,'24513','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7537,'17211','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31540,'55814','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15407,'30534','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3024,'08079','Salem','34033','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1885,'05345','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(8458,'19039','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40710,'69337','Dawes','31045','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35060,'61007','Stephenson','17177','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(22239,'42049','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11196,'24236','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16331,'32043','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17441,'33709','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(29798,'53140','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12079,'25864','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37788,'64804','Newton','29145','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38017,'65278','Randolph','29175','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43463,'74355','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43719,'74849','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43737,'74859','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45254,'76906','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46885,'79257','Briscoe','48045','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14206,'29162','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13163,'27888','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20348,'38621','Tunica','28143','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3448,'09343','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(40094,'68601','Colfax','31037','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40054,'68463','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31524,'55795','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30254,'54121','Florence','55037','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4303,'11775','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42315,'72471','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45625,'77460','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3648,'09825','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(139,'00910','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(25099,'46506','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24574,'45802','Allen','39003','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18098,'35127','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4072,'11096','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28592,'50629','Buchanan','19019','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38545,'66060','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39639,'67850','Scott','20171','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40779,'70056','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44655,'76095','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54839,'99228','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4365,'11965','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18200,'35261','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19790,'37863','Sevier','47155','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20889,'39347','Clarke','28023','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(23642,'44416','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8706,'19464','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26809,'48706','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(3924,'10552','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35167,'61102','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36455,'62810','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48014,'81331','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53045,'95978','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(37770,'64779','Vernon','29217','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4446,'12076','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5419,'13668','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15249,'30375','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12782,'27332','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34989,'60929','Ford','17053','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40089,'68542','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47990,'81251','Chaffee','8015','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8953,'20059','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(1653,'04694','Washington','23029','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15174,'30306','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2513,'06838','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36427,'62757','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48374,'83232','Franklin','16041','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(14815,'30019','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17047,'33067','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44754,'76245','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54912,'99519','Anchorage','2020','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(32719,'57260','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37635,'64639','Carroll','29033','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18446,'35765','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40411,'68875','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(11663,'25054','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1102,'03269','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(4826,'12747','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46024,'78108','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47618,'80540','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54777,'99140','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(9038,'20153','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36034,'62312','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14711,'29842','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22601,'42741','Russell','21207','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18153,'35203','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29610,'52765','Cedar','19031','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43371,'74104','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46425,'78655','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1734,'04926','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40222,'68738','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33424,'58330','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34926,'60660','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13720,'28529','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32502,'57001','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30368,'54311','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(55076,'99727','Northwest Arctic','2188','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(288,'01111','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31515,'55785','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52833,'95646','Alpine','6003','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50477,'90019','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47170,'79760','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7304,'16841','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14104,'29055','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16283,'31832','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18249,'35464','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38441,'65775','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30311,'54174','Menominee','55078','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16827,'32732','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26156,'47917','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22204,'42021','Hickman','21105','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14589,'29661','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38673,'66427','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54490,'98552','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43709,'74839','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30736,'54747','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38006,'65264','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1707,'04853','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8247,'18615','Wyoming','42131','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50019,'88133','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(25412,'46937','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30517,'54499','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52638,'95385','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47276,'79958','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12317,'26325','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3651,'09828','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2639,'07086','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(22564,'42702','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23100,'43553','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24704,'45889','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25070,'46382','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29106,'52003','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29263,'52222','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1186,'03608','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(20177,'38390','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38061,'65334','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30810,'54824','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24744,'46035','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9934,'21853','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7169,'16624','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46146,'78260','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52211,'94541','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17415,'33663','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21270,'40013','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22855,'43211','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15889,'31150','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38003,'65263','Audrain','29007','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39116,'67114','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2926,'07934','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13875,'28658','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44416,'75778','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45508,'77348','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18926,'36559','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(26871,'48760','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35403,'61454','Henderson','17071','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37445,'64131','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12867,'27515','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6979,'16233','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18074,'35097','Blount','1009','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10537,'23124','Hanover','51085','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13310,'28082','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14883,'30074','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44923,'76467','Hood','48221','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49083,'84764','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9466,'20848','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52422,'95052','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51046,'92008','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3150,'08406','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(13638,'28439','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14969,'30132','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15384,'30523','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(3853,'10455','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47518,'80426','Eagle','8037','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3176,'08530','Mercer','34021','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54034,'97838','Morrow','41049','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51918,'93709','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49297,'85325','La Paz','4012','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(13769,'28575','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17139,'33189','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37785,'64802','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8195,'18457','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39227,'67351','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41859,'71945','Polk','5113','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(793,'02535','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47075,'79546','Scurry','48415','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50132,'88527','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(52662,'95421','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53341,'96643','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(39157,'67151','Marion','20115','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38038,'65305','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47657,'80643','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30135,'53932','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29079,'51636','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24548,'45767','Monroe','39111','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14351,'29424','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4060,'11026','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20317,'38583','White','47185','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12619,'27046','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14872,'30063','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30699,'54727','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25722,'47322','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27641,'49712','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30397,'54415','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29447,'52554','Jefferson','19101','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45636,'77470','Colorado','48089','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47089,'79560','Jones','48253','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40660,'69165','Lincoln','31111','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49214,'85194','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45466,'77291','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25721,'47320','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10580,'23178','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36756,'63030','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(78,'00732','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(29636,'52808','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27919,'50027','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(23304,'43928','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42134,'72216','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(35867,'62071','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44118,'75402','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23902,'44828','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21919,'41135','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27808,'49878','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34661,'60404','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19854,'37923','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(10571,'23163','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14197,'29152','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34800,'60518','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27750,'49812','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(53859,'97435','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50671,'90661','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15808,'31059','Baldwin','13009','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19626,'37682','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37333,'64011','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5613,'14039','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17414,'33662','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4387,'12017','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43401,'74135','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33347,'58233','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32785,'57328','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31346,'55444','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27905,'50020','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19383,'37206','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29277,'52232','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26038,'47712','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44511,'75939','Trinity','48455','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17,'00623','Cabo Rojo','72023','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(20853,'39320','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(34150,'59421','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17745,'34231','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39911,'68342','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19122,'36915','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43747,'74864','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7369,'16936','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38614,'66210','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15932,'31309','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44608,'76050','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8213,'18472','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35964,'62253','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34902,'60632','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12697,'27244','Caswell','37033','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41882,'71971','Pike','5109','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2606,'07052','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18069,'35094','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35472,'61526','Stark','17175','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16639,'32452','Holmes','12059','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35570,'61721','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33874,'58830','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16800,'32702','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15281,'30425','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27067,'49004','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(23947,'44857','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52366,'94966','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(432,'01543','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23587,'44281','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51481,'92801','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46950,'79359','Yoakum','48501','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14748,'29914','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20574,'38901','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(10860,'23837','Southampton','51175','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24454,'45672','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28836,'51103','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37575,'64486','Worth','29227','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51103,'92088','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50962,'91750','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15851,'31084','Wilcox','13315','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4351,'11951','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41206,'70777','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53753,'97321','Linn','41043','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12649,'27113','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38778,'66610','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53007,'95947','Plumas','6063','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51327,'92399','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25767,'47354','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29696,'53040','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18427,'35754','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(33079,'57640','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7180,'16635','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7750,'17705','Lycoming','42081','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52568,'95313','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51975,'93915','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48803,'84059','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(20956,'39452','George','28039','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(15717,'31011','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(29934,'53521','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31874,'56174','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41500,'71324','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45024,'76566','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43177,'73763','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20596,'38927','Panola','28107','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28324,'50428','Cerro Gordo','19033','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36749,'63025','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12469,'26601','Braxton','54007','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47270,'79950','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32227,'56479','Wadena','27159','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37406,'64083','Cass','29037','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37264,'63866','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(26440,'48184','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37234,'63827','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30661,'54656','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29952,'53534','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28322,'50426','Mitchell','19131','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37300,'63941','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24944,'46214','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5163,'13163','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8275,'18640','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32852,'57371','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47367,'80118','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(43448,'74344','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(55081,'99733','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(52156,'94302','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47051,'79532','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45445,'77263','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15192,'30319','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15449,'30563','Habersham','13137','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15493,'30612','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34534,'60106','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36479,'62830','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(1805,'05041','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(18900,'36527','Baldwin','1003','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11263,'24333','Galax City','51640','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2737,'07481','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36890,'63178','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54759,'99125','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8004,'18068','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6925,'16136','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2050,'05773','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(22798,'43137','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22816,'43147','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24867,'46144','Shelby','18145','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9238,'20537','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10955,'23942','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13293,'28071','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35439,'61479','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16038,'31556','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16300,'31993','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19207,'37057','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49596,'86339','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44978,'76527','Bell','48027','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44422,'75784','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8602,'19301','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8973,'20081','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(27448,'49430','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(13654,'28449','New Hanover','37129','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36648,'62935','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17859,'34614','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41731,'71728','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46345,'78607','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23287,'43907','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21741,'40828','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34830,'60543','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8235,'18603','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3136,'08349','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23492,'44143','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26256,'47989','Montgomery','18107','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(35384,'61440','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4854,'12777','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51076,'92054','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46030,'78113','Karnes','48255','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37943,'65104','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39204,'67332','Labette','20099','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19695,'37754','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(44638,'76077','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19214,'37060','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18459,'35776','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(40528,'68981','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20527,'38850','Pontotoc','28115','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39214,'67340','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(318,'01240','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(50705,'90749','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46753,'79080','Hutchinson','48233','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45832,'77835','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14578,'29654','Abbeville','45001','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13877,'28660','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37921,'65076','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40794,'70072','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42413,'72587','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42627,'72903','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47127,'79710','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44390,'75752','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9998,'22067','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18123,'35151','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30279,'54149','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(52222,'94551','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51279,'92334','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(10163,'22514','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34871,'60599','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32533,'57022','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5876,'14530','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5480,'13758','Chenango','36017','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20993,'39480','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31903,'56214','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(20840,'39289','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(39322,'67474','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48291,'82838','Sheridan','56033','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(26823,'48727','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17399,'33625','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(37361,'64040','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4043,'10994','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50244,'89054','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(45297,'77011','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18642,'36069','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31353,'55449','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33732,'58646','Hettinger','38041','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8928,'20032','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(35050,'60968','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51806,'93550','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53130,'96079','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15913,'31217','Jones','13169','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34748,'60470','La Salle','17099','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29978,'53555','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24648,'45855','Paulding','39125','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10700,'23399','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6621,'15679','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47035,'79520','Stonewall','48433','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4420,'12054','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20379,'38645','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4664,'12455','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14451,'29545','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27028,'48892','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27128,'49047','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34440,'60010','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54743,'99110','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52343,'94937','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16231,'31795','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49519,'85930','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43322,'74055','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14952,'30119','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13567,'28370','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41419,'71230','Franklin','22041','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(10333,'22842','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39915,'68344','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22486,'42442','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35102,'61046','Carroll','17015','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47021,'79511','Borden','48033','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16629,'32440','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16178,'31763','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(7305,'16843','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9672,'21228','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18198,'35259','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1718,'04865','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38795,'66625','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18017,'35038','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44306,'75641','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13505,'28319','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4627,'12417','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14487,'29579','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24459,'45677','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15981,'31510','Bacon','13005','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26941,'48835','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33189,'57788','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36592,'62899','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18887,'36509','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8114,'18337','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9846,'21737','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(8341,'18843','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20103,'38332','McNairy','47109','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50508,'90050','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46178,'78333','Jim Wells','48249','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28211,'50251','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27238,'49229','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38668,'66423','Wabaunsee','20197','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38703,'66506','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19342,'37166','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(621,'02093','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31525,'55796','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13506,'28320','Bladen','37017','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24230,'45324','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50734,'90899','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55041,'99683','Matanuska Susitna','2170','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(38930,'66865','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11155,'24171','Patrick','51141','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46880,'79255','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43881,'75061','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43620,'74640','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10012,'22116','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15783,'31039','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1540,'04474','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5715,'14206','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22657,'43014','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18797,'36349','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29461,'52565','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18865,'36474','Conecuh','1035','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30912,'54929','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19794,'37866','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9632,'21201','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15290,'30434','Burke','13033','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13809,'28610','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12206,'26151','Calhoun','54013','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44476,'75860','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43318,'74051','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(54155,'98072','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54083,'97910','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(45271,'76941','Irion','48235','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31696,'56035','Freeborn','27047','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51818,'93562','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46256,'78419','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46091,'78208','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(19942,'38063','Haywood','47075','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16247,'31805','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16552,'32332','Gadsden','12039','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33418,'58325','Ramsey','38071','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9197,'20444','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(37343,'64020','Johnson','29101','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11562,'24861','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27325,'49307','Newaygo','26123','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26658,'48457','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(24326,'45405','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21559,'40387','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(33808,'58750','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19362,'37183','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(48719,'83851','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(21178,'39772','Choctaw','28019','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28208,'50250','Adair','19001','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16580,'32360','Liberty','12077','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30774,'54768','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40761,'70032','Saint Bernard','22087','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(1496,'04415','Piscataquis','23021','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(7065,'16362','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29363,'52338','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14148,'29111','Clarendon','45027','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1084,'03252','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35385,'61441','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(10535,'23123','Buckingham','51029','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3158,'08510','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1765,'04961','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22114,'41655','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22276,'42086','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27524,'49613','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18938,'36575','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8887,'19963','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(131,'00850','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(32609,'57067','Yankton','46135','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16503,'32244','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31975,'56264','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(1599,'04617','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(936,'02837','Newport','44005','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(45321,'77035','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41364,'71115','Red River','22081','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50021,'88134','Roosevelt','35041','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(11541,'24831','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2287,'06320','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(33772,'58718','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38509,'66027','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(20807,'39194','Humphreys','28053','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41146,'70710','West Baton Rouge','22121','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38401,'65746','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37522,'64442','Harrison','29081','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24131,'45214','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23728,'44608','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23700,'44491','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14263,'29304','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44818,'76364','Wilbarger','48487','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34945,'60688','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54800,'99163','Whitman','53075','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54761,'99128','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:54',NULL,NULL),(31685,'56026','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36343,'62639','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36843,'63122','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11649,'25039','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33708,'58632','Golden Valley','38033','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(23508,'44198','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28254,'50301','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2492,'06795','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40711,'69337','Sheridan','31161','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(51407,'92606','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47670,'80654','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30532,'54521','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31506,'55775','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10517,'23109','Mathews','51115','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8972,'20080','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17224,'33409','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(20289,'38568','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18244,'35460','Sumter','1119','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9957,'21914','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31921,'56222','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13475,'28284','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22536,'42553','Pulaski','21199','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36157,'62439','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44838,'76380','Knox','48275','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33939,'59041','Carbon','30009','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34503,'60077','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21757,'40863','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15508,'30624','Madison','13195','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10693,'23358','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12261,'26237','Upshur','54097','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(14885,'30075','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14275,'29323','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23127,'43609','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(49478,'85731','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53277,'96447','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(1914,'05444','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(10052,'22209','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51837,'93608','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8539,'19124','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22264,'42071','Graves','21083','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24661,'45863','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19475,'37338','Rhea','47143','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(20,'00631','Lares','72081','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(25854,'47438','Clay','18021','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6045,'14788','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1270,'03859','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(43978,'75156','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47832,'81004','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(27266,'49250','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41387,'71164','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(54511,'98575','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54388,'98382','Jefferson','53031','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49237,'85236','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29002,'51534','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31395,'55574','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25483,'46987','Grant','18053','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16272,'31825','Webster','13307','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35406,'61459','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39224,'67347','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39606,'67834','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18,'00624','Penuelas','72111','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(758,'02452','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(7523,'17122','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5911,'14561','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30521,'54512','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29897,'53403','Racine','55101','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30131,'53929','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48744,'83876','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(41728,'71725','Dallas','5039','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(10079,'22304','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24784,'46062','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(18375,'35622','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34247,'59546','Phillips','30071','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36536,'62867','White','17193','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41580,'71423','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4411,'12045','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4997,'12974','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23382,'44030','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11300,'24415','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10049,'22206','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9974,'22030','Fairfax City','51600','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9922,'21836','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4361,'11961','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13913,'28690','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14046,'28909','Clay','37043','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17636,'33980','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32721,'57261','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34626,'60184','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37238,'63833','New Madrid','29143','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11299,'24413','Highland','51091','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19186,'37046','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6667,'15730','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36936,'63359','Pike','29163','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(15658,'30815','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12903,'27539','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31451,'55718','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(23392,'44044','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5971,'14702','Chautauqua','36013','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(695,'02228','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(24868,'46146','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(118,'00802','Saint Thomas','78030','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(46471,'78704','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14710,'29841','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24638,'45848','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26302,'48039','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18779,'36320','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31086,'55079','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3357,'09009','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29319,'52309','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28464,'50542','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26289,'48025','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15743,'31022','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22481,'42437','Webster','21233','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39365,'67518','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13297,'28073','None','45999','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21403,'40178','Breckinridge','21027','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43292,'74033','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45959,'78023','Bandera','48019','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27133,'49051','Calhoun','26025','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29327,'52316','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(14486,'29578','Horry','45051','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16456,'32192','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34028,'59222','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(13787,'28586','Pitt','37147','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37542,'64459','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17903,'34736','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5251,'13357','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3660,'09837','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7300,'16838','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11763,'25213','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35920,'62215','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33529,'58438','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30528,'54517','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14555,'29640','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29033,'51556','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45870,'77876','Grimes','48185','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52888,'95697','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38667,'66422','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53887,'97462','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52462,'95125','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22354,'42220','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29270,'52227','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30476,'54470','Price','55099','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11048,'24059','Montgomery','51121','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38590,'66104','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33427,'58332','Benson','38005','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(47232,'79912','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49712,'87060','Valencia','35061','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(52109,'94237','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53939,'97535','Jackson','41029','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54417,'98416','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42264,'72428','Mississippi','5093','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7635,'17345','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48372,'83229','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(44591,'76035','Johnson','48251','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25494,'46992','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40137,'68641','Cuming','31039','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34763,'60481','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30493,'54484','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5510,'13806','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40841,'70146','Plaquemines','22075','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49850,'87545','Los Alamos','35028','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(32488,'56902','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(32672,'57227','Grant','46051','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(25664,'47235','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23574,'44270','Wayne','39169','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3143,'08361','Cumberland','34011','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3442,'09320','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(39451,'67601','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40124,'68636','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41232,'70812','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9858,'21757','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19866,'37938','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9612,'21136','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10313,'22810','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37243,'63840','Pemiscot','29155','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7517,'17110','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35232,'61270','Whiteside','17195','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6741,'15834','Cameron','42023','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33488,'58384','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33432,'58339','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32286,'56550','Norman','27107','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(23774,'44638','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(44230,'75491','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29171,'52099','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17183,'33316','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39570,'67744','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(9489,'20879','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14044,'28905','Cherokee','37039','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24625,'45843','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8588,'19184','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29904,'53502','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39986,'68415','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(9170,'20413','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(54749,'99116','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19668,'37726','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(24550,'45768','Washington','39167','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27040,'48906','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49005,'84637','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(8016,'18077','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1613,'04635','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(39584,'67752','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48455,'83347','Minidoka','16067','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(11017,'24022','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16729,'32604','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43300,'74037','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7892,'17921','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37391,'64074','Lafayette','29107','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32992,'57533','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16027,'31551','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14166,'29126','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40361,'68838','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26948,'48837','Ionia','26067','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25939,'47542','Pike','18125','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24062,'45120','Clermont','39025','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11400,'24538','Appomattox','51011','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19299,'37132','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49778,'87317','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49497,'85749','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4754,'12550','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8722,'19486','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4676,'12468','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36291,'62558','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13721,'28530','Craven','37049','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10295,'22738','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23892,'44822','Ashland','39005','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(45747,'77581','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54351,'98345','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40868,'70181','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38424,'65766','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(47038,'79526','Fisher','48151','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5186,'13219','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6223,'15056','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4964,'12933','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21607,'40456','Jackson','21109','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24352,'45433','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26756,'48628','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31382,'55559','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14957,'30123','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8883,'19960','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(21239,'39867','Clay','13061','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9083,'20207','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19154,'37025','Hickman','47081','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(36297,'62563','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(7644,'17358','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2724,'07456','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(47964,'81220','Montrose','8085','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(35917,'62207','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46074,'78154','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26320,'48062','Macomb','26099','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28285,'50329','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33709,'58634','Billings','38007','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8856,'19906','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(3789,'10167','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30466,'54463','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26513,'48302','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(44598,'76043','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49564,'86046','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(864,'02703','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(9262,'20571','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(51971,'93906','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39239,'67357','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43528,'74455','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39307,'67458','Clay','20027','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36325,'62624','Schuyler','17169','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20417,'38677','Lafayette','28071','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27138,'49055','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52067,'94127','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2511,'06831','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(6861,'16045','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3866,'10468','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8687,'19438','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53596,'97062','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(7079,'16373','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24969,'46237','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14795,'30009','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(53652,'97133','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51442,'92660','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49492,'85744','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49405,'85616','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32304,'56566','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31833,'56145','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2847,'07760','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1847,'05101','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13288,'28054','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6916,'16127','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13573,'28375','Robeson','37155','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37754,'64762','Barton','29011','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(50639,'90510','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2195,'06105','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(40956,'70445','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3447,'09340','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35220,'61259','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(109,'00784','Guayama','72057','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(52610,'95357','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52408,'95033','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49502,'85755','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48907,'84307','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(25652,'47227','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5321,'13473','Lewis','36049','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34927,'60661','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38950,'66935','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39977,'68405','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47621,'80542','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(54987,'99627','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(7997,'18062','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30211,'54017','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24181,'45264','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19369,'37187','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7819,'17820','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38177,'65559','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45587,'77429','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48506,'83449','Bonneville','16019','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(17153,'33242','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32700,'57248','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34449,'60016','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35772,'61936','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37469,'64158','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39395,'67548','Ellis','20051','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(45798,'77663','Hardin','48199','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52356,'94952','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7328,'16866','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8040,'18109','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21352,'40107','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34610,'60170','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30116,'53922','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28630,'50658','Bremer','19017','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5840,'14489','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4115,'11236','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7478,'17071','Perry','42099','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12148,'26030','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30404,'54421','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(42857,'73128','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53894,'97470','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54305,'98287','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23132,'43614','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17688,'34109','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5899,'14548','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37029,'63466','Clark','29045','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43799,'74949','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3770,'10133','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26410,'48160','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25105,'46511','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(252,'01069','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13791,'28594','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37165,'63702','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39023,'67023','Cowley','20035','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5132,'13137','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33468,'58368','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29764,'53102','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8144,'18413','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4949,'12916','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(499,'01784','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(22937,'43340','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22218,'42035','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41240,'70820','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(76,'00730','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(41145,'70707','Ascension','22005','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28159,'50225','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(667,'02156','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(51290,'92346','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4008,'10954','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33761,'58707','Ward','38101','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36482,'62831','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3079,'08226','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(21809,'41001','Campbell','21037','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17237,'33422','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7703,'17549','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17027,'33037','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43575,'74549','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42863,'73134','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37023,'63462','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(49314,'85342','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39035,'67029','Kiowa','20097','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30891,'54913','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3743,'10105','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26839,'48738','Alcona','26001','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(14771,'29936','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50345,'89403','Lyon','32019','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(32033,'56308','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19189,'37047','Lincoln','47103','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15519,'30631','Taliaferro','13265','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13383,'28146','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28514,'50578','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9849,'21741','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(54832,'99216','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53978,'97711','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14614,'29682','Pickens','45077','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27447,'49429','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30062,'53782','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30383,'54408','Shawano','55115','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37286,'63933','Dunklin','29069','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16883,'32803','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1067,'03231','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39331,'67481','Lincoln','20105','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(2743,'07505','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(17394,'33620','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35983,'62263','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46235,'78390','San Patricio','48409','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50537,'90079','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8576,'19170','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51831,'93602','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(894,'02763','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(13317,'28090','Burke','37023','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5904,'14556','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29542,'52649','Lee','19111','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(543,'01889','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42773,'73056','Kingfisher','40073','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7370,'16937','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53745,'97308','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54316,'98303','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(3282,'08817','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45346,'77058','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34747,'60470','Grundy','17063','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2392,'06494','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(28151,'50219','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15577,'30680','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15392,'30529','Banks','13011','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41754,'71763','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51100,'92084','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48525,'83522','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45718,'77546','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5137,'13141','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11146,'24153','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41413,'71227','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48229,'82601','Natrona','56025','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(4786,'12586','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43882,'75062','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53019,'95958','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51813,'93556','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27638,'49710','Chippewa','26033','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29418,'52534','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13822,'28621','Wilkes','37193','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21475,'40299','Bullitt','21029','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40633,'69149','Garden','31069','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31694,'56033','Faribault','27043','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46864,'79245','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(731,'02348','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(37195,'63766','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28941,'51448','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35118,'61054','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18355,'35603','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19251,'37085','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4353,'11953','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34959,'60714','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(971,'02892','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(10126,'22438','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4172,'11423','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19913,'38040','Crockett','47033','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52520,'95224','Calaveras','6009','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47003,'79457','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11638,'25021','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11672,'25063','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28127,'50201','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13767,'28574','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10983,'23967','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32813,'57345','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5883,'14534','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14603,'29672','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15313,'30450','Emanuel','13107','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17453,'33733','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35926,'62220','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19317,'37144','Marshall','47117','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(7487,'17078','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16062,'31603','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32469,'56751','Roseau','27135','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(11966,'25635','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22180,'41833','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46112,'78228','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26661,'48460','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30870,'54876','Sawyer','55113','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16774,'32666','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7580,'17256','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20146,'38363','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50616,'90310','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45697,'77521','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3019,'08074','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28206,'50249','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30446,'54452','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31214,'55342','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43828,'75013','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44298,'75636','Morris','48343','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2,'00544','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19798,'37869','Hancock','47067','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3446,'09339','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3350,'08989','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46069,'78151','Goliad','48175','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47661,'80646','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52431,'95064','Santa Cruz','6087','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(39840,'68172','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30370,'54313','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53547,'97015','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(49404,'85615','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(6636,'15690','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6495,'15475','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9627,'21161','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(35429,'61474','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44441,'75831','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48413,'83287','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52255,'94583','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38929,'66864','Lyon','20111','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13121,'27855','Hertford','37091','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24545,'45764','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19298,'37131','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(26173,'47926','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26965,'48848','Clinton','26037','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28097,'50155','Union','19175','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21889,'41086','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37870,'65040','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17122,'33172','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48083,'81630','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41409,'71222','Union','22111','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40647,'69157','Blaine','31009','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52181,'94513','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50867,'91383','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48912,'84312','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(12501,'26678','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27713,'49770','Charlevoix','26029','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15816,'31063','Dooly','13093','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32837,'57363','Davison','46035','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20620,'38951','Calhoun','28013','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32159,'56399','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28004,'50101','Wright','19197','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8753,'19529','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47559,'80470','Park','8093','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(52297,'94662','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51022,'91934','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32931,'57454','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26892,'48770','Ogemaw','26129','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16681,'32531','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43377,'74108','Wagoner','40145','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(405,'01508','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44473,'75858','Houston','48225','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11513,'24731','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33624,'58524','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54520,'98585','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44762,'76251','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3181,'08535','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54206,'98148','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52747,'95542','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51694,'93306','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50804,'91302','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48449,'83343','Minidoka','16067','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6076,'14823','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7977,'18042','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20776,'39167','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2255,'06242','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(13785,'28586','Beaufort','37013','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52083,'94146','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52932,'95823','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42517,'72727','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(30148,'53943','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27979,'50065','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31655,'55992','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32692,'57241','Hamlin','46057','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34597,'60154','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40894,'70353','Terrebonne','22109','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(30497,'54487','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24331,'45413','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26376,'48120','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5432,'13680','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41324,'71068','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48937,'84336','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(28304,'50380','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15630,'30752','Dade','13083','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(21234,'39861','Seminole','13253','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43675,'74756','Choctaw','40023','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(9239,'20538','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(20538,'38858','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(8460,'19040','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18317,'35565','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(38546,'66061','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47380,'80128','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23799,'44657','Stark','39151','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15625,'30747','Chattooga','13055','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14170,'29128','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50219,'89025','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53444,'96784','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52346,'94940','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7349,'16914','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27960,'50055','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13630,'28433','Columbus','37047','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32046,'56316','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32240,'56514','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(36413,'62707','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(3298,'08832','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39213,'67337','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40421,'68882','Howard','31093','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(449,'01588','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(48995,'84627','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(15959,'31404','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(991,'02916','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(54488,'98548','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44534,'75965','Nacogdoches','48347','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36458,'62814','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6050,'14804','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19615,'37660','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41439,'71245','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42363,'72534','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28756,'51018','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32265,'56534','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4829,'12750','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40103,'68624','Butler','31023','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39546,'67731','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(33562,'58461','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32435,'56724','Marshall','27089','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(4722,'12518','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44196,'75462','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11712,'25125','Clay','54015','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9945,'21871','Somerset','24039','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5979,'14714','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28231,'50264','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3679,'09873','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(4739,'12537','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24354,'45434','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30048,'53713','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30100,'53825','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(3739,'10101','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51658,'93254','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50837,'91342','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30651,'54651','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54289,'98272','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(24073,'45133','Adams','39001','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21523,'40355','Owen','21187','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34836,'60546','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14255,'29250','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11581,'24892','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45017,'76558','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52685,'95446','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47285,'79996','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28395,'50472','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31403,'55582','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22379,'42265','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12516,'26710','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39002,'67004','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12817,'27377','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38855,'66761','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(890,'02760','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(6135,'14877','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11480,'24622','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9836,'21718','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4278,'11743','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13736,'28543','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38881,'66781','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18554,'36005','Barbour','1005','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14968,'30132','Bartow','13015','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2182,'06089','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(27075,'49010','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(21080,'39652','Amite','28005','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49025,'84662','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49758,'87187','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53382,'96716','Kauai','15007','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(53487,'96837','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(1362,'04071','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(9047,'20166','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46942,'79356','Garza','48169','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32914,'57441','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36148,'62432','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4802,'12721','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41242,'70822','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28470,'50546','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18129,'35172','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9862,'21759','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(17246,'33432','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35875,'62076','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35796,'61957','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6037,'14779','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6065,'14815','Schuyler','36097','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16097,'31637','Cook','13075','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16316,'32013','Lafayette','12067','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17228,'33413','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7425,'17028','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3752,'10114','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19657,'37717','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4709,'12503','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5088,'13082','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27831,'49901','Keweenaw','26083','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27264,'49249','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12771,'27323','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43345,'74072','Nowata','40105','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49666,'87015','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(14293,'29342','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38448,'65781','Polk','29167','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7786,'17758','Sullivan','42113','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49421,'85632','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25042,'46348','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42842,'73114','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19725,'37801','Monroe','47123','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19407,'37230','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14372,'29442','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17030,'33041','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35777,'61938','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17519,'33835','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19262,'37091','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(43598,'74571','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43968,'75149','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22648,'43008','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22341,'42206','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10621,'23231','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43028,'73554','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19211,'37060','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(885,'02744','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18265,'35480','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34874,'60603','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4379,'12008','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7456,'17055','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10139,'22472','Richmond','51159','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49200,'85141','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45385,'77094','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32143,'56381','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(27422,'49412','Muskegon','26121','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25448,'46962','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(42211,'72372','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15140,'30281','Clayton','13063','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(40417,'68879','Loup','31115','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19315,'37144','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(38720,'66521','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(26960,'48845','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38191,'65571','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(54047,'97850','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51988,'93933','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(32146,'56384','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29706,'53048','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33393,'58277','Steele','38091','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33966,'59066','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(23113,'43567','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35522,'61570','Marshall','17123','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37855,'65025','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39377,'67525','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18144,'35184','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20290,'38568','Overton','47133','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9420,'20773','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(2525,'06860','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(29839,'53186','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50184,'88583','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(54682,'98947','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43286,'74029','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27190,'49092','Branch','26023','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(48993,'84624','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(46593,'78933','Austin','48015','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44632,'76068','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3171,'08525','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1455,'04288','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28164,'50228','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(18461,'35776','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4020,'10968','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15534,'30645','Morgan','13211','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(54471,'98531','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43614,'74630','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(24491,'45697','Highland','39071','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52922,'95813','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46585,'78881','Uvalde','48463','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17929,'34772','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25327,'46814','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8330,'18829','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40599,'69128','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(930,'02830','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(4628,'12418','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6700,'15767','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4901,'12839','Washington','36115','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48879,'84136','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54452,'98504','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(29578,'52737','Louisa','19115','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4617,'12405','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54517,'98582','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44112,'75393','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39169,'67204','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(53204,'96161','Placer','6061','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54676,'98941','Kittitas','53037','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(384,'01453','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19057,'36792','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51634,'93234','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36772,'63043','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31758,'56083','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38173,'65556','Pulaski','29169','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30023,'53587','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2715,'07438','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18072,'35096','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13093,'27832','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10854,'23832','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4930,'12872','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26032,'47704','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37676,'64667','Mercer','29129','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36792,'63068','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35954,'62246','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33869,'58795','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46236,'78391','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44099,'75372','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20731,'39114','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53138,'96090','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50687,'90715','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22986,'43430','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28384,'50466','Howard','19089','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2908,'07882','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36284,'62555','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20336,'38611','DeSoto','28033','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(38544,'66060','Atchison','20005','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39895,'68333','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37597,'64504','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(20465,'38761','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31398,'55577','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8605,'19311','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16146,'31720','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26561,'48361','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47351,'80106','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49067,'84747','Wayne','49055','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(49111,'85010','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49423,'85634','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(54611,'98817','Chelan','53007','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4238,'11693','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42980,'73507','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19092,'36861','Tallapoosa','1123','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34353,'59829','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17875,'34674','Pasco','12101','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3955,'10604','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12327,'26342','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21789,'40953','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21542,'40372','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(49285,'85307','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(12998,'27617','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27329,'49310','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17548,'33865','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43529,'74456','Okmulgee','40111','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42425,'72617','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20126,'38348','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39918,'68346','Otoe','31131','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17374,'33598','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8424,'19004','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23896,'44824','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12314,'26321','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13316,'28089','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50651,'90621','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1122,'03299','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(50712,'90806','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14720,'29847','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(18020,'35042','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6408,'15347','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30394,'54414','Langlade','55067','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43854,'75038','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12977,'27597','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(408,'01515','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19836,'37891','Hamblen','47063','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49549,'86029','Navajo','4017','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26422,'48168','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29892,'53293','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33680,'58580','Mercer','38057','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13318,'28090','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16474,'32216','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41502,'71325','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9022,'20137','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9272,'20585','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10829,'23708','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35065,'61011','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51558,'93016','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54000,'97753','Crook','41013','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(14803,'30013','Newton','13217','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12758,'27311','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(33710,'58634','McKenzie','38053','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(46370,'78621','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46247,'78410','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45529,'77364','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45283,'76955','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27978,'50064','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17728,'34212','Manatee','12081','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8173,'18438','Wayne','42127','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20690,'39078','Copiah','28029','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(52354,'94950','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33281,'58065','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(13417,'28213','Cabarrus','37025','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19254,'37086','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(45426,'77240','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21728,'40810','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(28037,'50123','Clarke','19039','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37311,'63953','Ripley','29181','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6145,'14883','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41799,'71846','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(9987,'22041','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40216,'68733','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6600,'15656','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27282,'49263','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47467,'80247','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(53555,'97021','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(29369,'52344','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11932,'25544','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3438,'09312','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2696,'07407','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(27360,'49328','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1231,'03816','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39567,'67741','Wallace','20199','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19590,'37615','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21420,'40217','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(313,'01230','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(18925,'36558','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3409,'09172','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(19797,'37869','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53402,'96740','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(22013,'41360','Powell','21197','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12139,'25981','Nicholas','54067','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23715,'44510','Mahoning','39099','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31721,'56055','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10060,'22216','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17707,'34139','Collier','12021','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16061,'31602','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15935,'31313','Liberty','13179','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36643,'62933','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45353,'77065','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22961,'43356','Morrow','39117','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51746,'93447','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54284,'98264','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42394,'72568','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(23173,'43728','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1807,'05043','Orange','50017','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(14430,'29510','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16258,'31815','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(9324,'20650','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21450,'40259','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20549,'38865','Alcorn','28003','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4423,'12057','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39708,'68005','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26543,'48333','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(54069,'97884','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(20627,'38954','Leflore','28083','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(46679,'79031','Castro','48069','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31307,'55409','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33570,'58466','Stutsman','38093','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(5940,'14612','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19979,'38118','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31551,'55910','Wabasha','27157','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14718,'29847','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48844,'84098','Summit','49043','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54070,'97885','Wallowa','41063','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(18551,'35989','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(49743,'87122','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(31312,'55414','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36036,'62313','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41131,'70658','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(5085,'13080','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41756,'71763','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41489,'71306','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(31729,'56062','Brown','27015','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14147,'29108','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42988,'73527','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(3775,'10153','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(51909,'93675','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50257,'89102','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49379,'85545','Gila','4007','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46824,'79189','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45726,'77554','Galveston','48167','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23982,'44890','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(35704,'61853','Piatt','17147','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37707,'64722','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(18787,'36330','Coffee','1031','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5602,'14031','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11629,'25003','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40308,'68791','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36086,'62361','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18187,'35242','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30451,'54454','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48716,'83848','Bonner','16017','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(24710,'45894','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9548,'21036','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(28689,'50841','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28238,'50268','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(11373,'24505','Lynchburg City','51680','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23880,'44813','Knox','39083','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24882,'46154','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7717,'17566','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51597,'93117','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48580,'83624','Owyhee','16073','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(45183,'76842','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16332,'32044','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14422,'29501','Darlington','45031','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11284,'24370','Washington','51191','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2229,'06151','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(42850,'73122','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40929,'70420','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18829,'36427','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(35745,'61912','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34332,'59772','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(25680,'47249','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21715,'40759','Whitley','21235','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(53893,'97469','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(41138,'70664','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(26649,'48453','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31896,'56208','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25699,'47273','Jennings','18079','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21426,'40223','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(17163,'33269','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(38725,'66524','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5412,'13660','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16772,'32663','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34938,'60680','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32728,'57265','Codington','46029','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(50885,'91408','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1468,'04343','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5754,'14301','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23082,'43535','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25866,'47449','Daviess','18027','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43126,'73724','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(15055,'30206','Pike','13231','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19105,'36871','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1556,'04496','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17119,'33168','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22826,'43152','Vinton','39163','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22510,'42462','Union','21225','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21608,'40456','Rockcastle','21203','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39825,'68138','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(15227,'30350','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52318,'94805','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25079,'46392','Jasper','18073','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34695,'60432','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37159,'63670','Sainte Genevieve','29186','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4328,'11804','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6984,'16239','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16977,'32956','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39768,'68059','Sarpy','31153','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30224,'54028','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23057,'43518','Williams','39171','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12117,'25936','Fayette','54019','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17488,'33780','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5882,'14533','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41581,'71424','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(3051,'08102','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(19768,'37846','Loudon','47105','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29946,'53531','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(18388,'35650','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(41772,'71823','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(21219,'39842','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(50119,'88513','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(45194,'76852','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36965,'63386','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28649,'50669','Grundy','19075','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25980,'47590','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(6594,'15644','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43372,'74105','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19986,'38127','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19230,'37071','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27821,'49887','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(37748,'64756','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36558,'62881','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(48861,'84117','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5403,'13651','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48775,'84032','Wasatch','49051','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21044,'39573','Stone','28131','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(6956,'16213','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14870,'30061','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51613,'93207','Tulare','6107','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18156,'35206','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53057,'95992','Sutter','6101','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3035,'08088','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28256,'50303','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34514,'60088','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8835,'19810','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(26056,'47733','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12168,'26060','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11085,'24091','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24365,'45458','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47804,'80931','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51367,'92543','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38799,'66647','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44992,'76537','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13712,'28524','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29453,'52560','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34894,'60623','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36299,'62567','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43098,'73663','Major','40093','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(6970,'16226','Armstrong','42005','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9679,'21234','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43303,'74039','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42692,'73007','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35782,'61942','Edgar','17045','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6711,'15776','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(35542,'61625','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15343,'30474','Montgomery','13209','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33513,'58423','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33077,'57638','Sioux','38085','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28358,'50450','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13714,'28525','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17012,'33022','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48864,'84120','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48117,'82003','Laramie','56021','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(6422,'15364','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(36314,'62612','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15734,'31017','Bleckley','13023','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38791,'66620','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37475,'64165','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31260,'55375','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26907,'48811','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49162,'85069','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(4098,'11218','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23685,'44460','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(39308,'67458','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32150,'56386','Mille Lacs','27095','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(28519,'50581','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(13772,'28578','Lenoir','37107','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32980,'57522','Sully','46119','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36861,'63136','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39797,'68110','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(19153,'37025','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25890,'47463','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24377,'45501','Clark','39023','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12769,'27320','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24120,'45202','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52323,'94850','Contra Costa','6013','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1397,'04116','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(17957,'34972','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22639,'43003','Delaware','39041','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32913,'57441','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33154,'57754','Lawrence','46081','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36193,'62461','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9842,'21723','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(37036,'63471','Marion','29127','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9136,'20318','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(17300,'33497','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44474,'75859','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44733,'76225','Montague','48337','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36997,'63443','Shelby','29205','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37414,'64092','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52461,'95124','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48067,'81610','Moffat','8081','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17656,'34031','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(21917,'41132','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(5481,'13760','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21834,'41030','Kenton','21117','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(41919,'72023','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43108,'73673','Greer','40055','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(2166,'06074','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24985,'46256','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15219,'30342','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19096,'36866','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19024,'36758','Autauga','1001','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(5440,'13690','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18080,'35112','Saint Clair','1115','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(54851,'99324','Walla Walla','53071','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(18981,'36675','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48002,'81321','Montezuma','8083','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(13672,'28462','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22230,'42041','Fulton','21075','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11361,'24487','Bath','51017','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40147,'68648','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20414,'38674','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41081,'70592','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44345,'75669','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25625,'47165','Washington','18175','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49896,'87731','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53410,'96748','Maui','15009','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(690,'02211','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46272,'78505','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33962,'59063','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36553,'62877','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11083,'24089','Henry','51089','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1398,'04122','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4194,'11516','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(24122,'45204','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34474,'60043','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5021,'13022','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42487,'72680','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41508,'71328','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(40277,'68773','Brown','31017','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34022,'59218','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16082,'31631','Charlton','13049','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8386,'18942','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37061,'63543','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16801,'32703','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41010,'70520','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(42532,'72740','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(15988,'31516','Pierce','13229','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25408,'46932','Miami','18103','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24914,'46173','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10132,'22451','King George','51099','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48356,'83210','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(49698,'87045','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(19542,'37384','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46484,'78719','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21994,'41301','Morgan','21175','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25504,'47006','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2344,'06418','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34983,'60922','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44003,'75185','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31709,'56046','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(47205,'79837','Hudspeth','48229','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50374,'89431','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(3991,'10925','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(41321,'71066','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(50065,'88317','Otero','35035','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(25550,'47106','Clark','18019','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24430,'45653','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28671,'50703','Black Hawk','19013','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12744,'27298','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12972,'27596','Granville','37077','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41214,'70786','Livingston','22063','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(19961,'38080','Obion','47131','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17221,'33406','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3412,'09180','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(29394,'52402','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10447,'23024','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4650,'12440','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19839,'37901','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(53076,'96021','Tehama','6103','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45392,'77202','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35456,'61490','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6068,'14817','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7016,'16314','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4526,'12175','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36525,'62859','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(5833,'14485','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34179,'59453','Fergus','30027','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51753,'93453','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40968,'70455','Tangipahoa','22105','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51272,'92326','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50258,'89103','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33265,'58056','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8463,'19043','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42493,'72685','Newton','5101','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(3895,'10518','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13903,'28683','Surry','37171','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13358,'28125','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38551,'66066','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27895,'50007','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36556,'62880','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14852,'30048','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31280,'55388','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(9586,'21090','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10167,'22523','Lancaster','51103','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28550,'50603','Chickasaw','19037','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7163,'16617','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7059,'16354','Venango','42121','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14502,'29592','Marion','45067','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6395,'15332','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44399,'75758','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32571,'57045','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53766,'97333','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(31244,'55365','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4520,'12168','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7291,'16828','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(562,'01931','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2059,'05822','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(45515,'77355','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45591,'77432','Wharton','48481','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50592,'90267','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43708,'74839','Hughes','40063','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18462,'35801','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(22674,'43023','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(4937,'12885','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9208,'20500','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(42742,'73040','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1817,'05053','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(20712,'39094','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32585,'57052','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45301,'77015','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52470,'95133','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4239,'11694','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7185,'16639','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17552,'33870','Highlands','12055','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14137,'29082','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8425,'19006','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8868,'19944','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(21681,'40601','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24041,'45101','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(30068,'53789','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30710,'54733','Barron','55005','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31846,'56157','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39219,'67344','Montgomery','20125','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(140,'00911','San Juan','72127','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(18481,'35895','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4381,'12010','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15471,'30577','Stephens','13257','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1042,'03104','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39468,'67632','Graham','20065','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12369,'26412','Gilmer','54021','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30533,'54521','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12978,'27599','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37386,'64070','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(17155,'33245','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7215,'16667','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34645,'60202','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47445,'80230','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(16198,'31776','Colquitt','13071','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32501,'57001','Lincoln','46083','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12021,'25717','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12770,'27320','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43761,'74872','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(21169,'39762','Oktibbeha','28105','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(27432,'49419','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35605,'61743','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20973,'39464','Jones','28067','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(43062,'73627','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49403,'85614','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26471,'48218','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16696,'32548','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25540,'47041','Dearborn','18029','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9976,'22031','Fairfax City','51600','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42511,'72718','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(54531,'98597','Thurston','53067','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(10933,'23920','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28360,'50452','Franklin','19069','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28812,'51050','Plymouth','19149','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29320,'52310','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7929,'17972','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16669,'32511','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(49140,'85039','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(2788,'07653','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(42094,'72160','Lonoke','5085','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53278,'96501','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(6795,'15935','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17202,'33336','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(35188,'61131','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(21577,'40409','Lincoln','21137','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40523,'68980','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8921,'20022','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(23245,'43804','Coshocton','39031','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22339,'42204','Todd','21219','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11233,'24290','Scott','51169','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43862,'75045','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18405,'35672','Lawrence','1079','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(53073,'96017','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49600,'86343','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26058,'47735','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13049,'27802','Edgecombe','37065','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13114,'27850','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38104,'65436','Texas','29215','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(1294,'03890','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(39748,'68041','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(16085,'31632','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(46701,'79042','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49388,'85601','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(11084,'24090','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(34390,'59871','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(130,'00841','Saint Croix','78010','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(51701,'93314','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9481,'20871','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49398,'85610','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(23206,'43758','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25331,'46818','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2011,'05730','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(40755,'70009','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(632,'02118','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(41822,'71866','Little River','5081','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38899,'66842','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(25892,'47465','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4749,'12546','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44121,'75407','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51043,'92004','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46719,'79057','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35072,'61016','Boone','17007','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39572,'67745','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48809,'84064','Rich','49033','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(20453,'38748','Sharkey','28125','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7073,'16369','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9963,'21920','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38732,'66532','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10523,'23113','Chesterfield','51041','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6009,'14741','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42785,'73063','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19800,'37870','Campbell','47013','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18648,'36078','Macon','1087','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(34531,'60103','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9123,'20266','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(13928,'28708','Transylvania','37175','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6901,'16114','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26975,'48854','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2873,'07837','Sussex','34037','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50440,'89721','Carson City','32510','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(33565,'58464','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34480,'60050','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41346,'71101','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6256,'15089','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19431,'37310','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18606,'36040','Lowndes','1085','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37054,'63536','Schuyler','29197','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(25654,'47229','Jackson','18071','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48696,'83827','Clearwater','16035','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52224,'94552','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(506,'01815','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(11490,'24639','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51052,'92018','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13410,'28206','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(4814,'12733','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31986,'56271','Swift','27151','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(40300,'68787','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20134,'38356','Hardeman','47069','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8392,'18950','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19232,'37072','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5994,'14727','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17135,'33185','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16511,'32256','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15744,'31022','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15304,'30442','Screven','13251','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(44823,'76369','Wichita','48485','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52937,'95828','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33812,'58755','Williams','38105','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36453,'62810','Hamilton','17065','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54750,'99116','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(54422,'98422','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(18195,'35253','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17479,'33771','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(7025,'16322','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2991,'08043','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15379,'30520','Hart','13147','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23688,'44470','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25333,'46819','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27379,'49338','Mecosta','26107','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19552,'37394','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(39038,'67031','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42847,'73119','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(172,'00953','Toa Alta','72135','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19240,'37077','Sumner','47165','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49716,'87064','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(36784,'63056','Franklin','29071','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32107,'56355','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(54509,'98571','Grays Harbor','53027','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48985,'84604','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48964,'84521','Emery','49015','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11411,'24551','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30422,'54433','Taylor','55119','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31272,'55385','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22007,'41339','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35010,'60945','Iroquois','17075','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31977,'56265','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30174,'53960','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48658,'83719','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6334,'15239','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16947,'32908','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(48051,'81502','Mesa','8077','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51828,'93601','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24601,'45822','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(27005,'48878','Isabella','26073','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7234,'16684','Blair','42013','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33138,'57735','Sioux','31165','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(6230,'15063','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22592,'42729','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(2281,'06277','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(8445,'19026','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16561,'32341','Madison','12079','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(50967,'91758','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21566,'40391','Montgomery','21173','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14355,'29429','Charleston','45019','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12081,'25865','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4546,'12198','Rensselaer','36083','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5720,'14211','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(38961,'66941','Jewell','20089','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42904,'73178','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16895,'32816','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34180,'59453','Golden Valley','30037','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40398,'68865','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1207,'03770','Sullivan','33019','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(21694,'40622','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(27265,'49249','Jackson','26075','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(15619,'30740','Whitfield','13313','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51499,'92825','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22050,'41527','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11569,'24871','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19917,'38042','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19020,'36753','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14014,'28782','Polk','37149','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43447,'74343','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18013,'35035','Bibb','1007','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14354,'29426','Dorchester','45035','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37525,'64444','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13186,'27919','Perquimans','37143','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20276,'38558','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18519,'35962','Marshall','1095','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15363,'30512','Union','13291','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36785,'63057','Jefferson','29099','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48613,'83651','Canyon','16027','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(54467,'98528','Mason','53045','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(6442,'15417','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33844,'58778','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33284,'58068','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19865,'37938','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5560,'13862','Cortland','36023','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29159,'52073','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(53287,'96520','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(41516,'71339','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38428,'65768','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13858,'28645','Caldwell','37027','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6633,'15688','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47536,'80446','Grand','8049','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10949,'23937','Charlotte','51037','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51072,'92046','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(16436,'32168','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24794,'46069','Boone','18011','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52080,'94143','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(40418,'68881','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39668,'67869','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15020,'30171','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48902,'84301','Box Elder','49003','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52074,'94134','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53675,'97205','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12277,'26263','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47672,'80701','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46482,'78717','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44137,'75421','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31023,'55026','Goodhue','27049','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30688,'54720','Eau Claire','55035','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7390,'17004','Mifflin','42087','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32358,'56630','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(40314,'68803','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40365,'68842','Greeley','31077','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46933,'79350','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51911,'93702','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49586,'86329','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(17666,'34042','None','0','AA','',0,'2013-07-03 15:17:52',NULL,NULL),(14009,'28777','Mitchell','37121','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23443,'44094','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24804,'46072','Hamilton','18057','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26231,'47969','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(47510,'80419','Jefferson','8059','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49048,'84728','Millard','49027','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(48162,'82221','Goshen','56015','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(20664,'39051','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7189,'16641','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12061,'25836','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27236,'49228','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30541,'54530','Rusk','55107','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32261,'56529','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(34491,'60065','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38759,'66548','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39685,'67880','Grant','20067','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(50991,'91789','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51520,'92861','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35483,'61534','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2426,'06537','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(39306,'67457','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43407,'74147','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(52360,'94956','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(5831,'14482','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(17095,'33143','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15512,'30627','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27984,'50068','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45375,'77085','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(18743,'36274','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(8145,'18414','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2126,'06027','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37498,'64422','DeKalb','29063','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29896,'53403','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29296,'52248','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5801,'14456','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22583,'42721','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29563,'52720','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(28142,'50214','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1085,'03253','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28573,'50619','Butler','19023','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38562,'66079','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(52261,'94590','Napa','6055','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(25180,'46582','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(12092,'25880','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29584,'52742','Clinton','19045','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16792,'32694','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18333,'35578','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(10583,'23181','King William','51101','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23343,'43972','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13710,'28522','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13813,'28612','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45919,'77990','Refugio','48391','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21660,'40524','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31847,'56158','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27575,'49653','Leelanau','26089','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33917,'59020','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(15388,'30527','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39373,'67523','Hodgeman','20083','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(16060,'31602','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2033,'05757','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(39912,'68342','Jefferson','31095','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36903,'63332','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(51954,'93774','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54003,'97758','Harney','41025','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(44477,'75861','Anderson','48001','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10216,'22604','Winchester City','51840','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47933,'81133','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(17256,'33441','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18180,'35232','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(27311,'49287','Lenawee','26091','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19248,'37082','Cheatham','47021','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19783,'37854','Cumberland','47035','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(33894,'58856','Divide','38023','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34717,'60447','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43221,'73859','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38141,'65479','Shannon','29203','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6470,'15446','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34835,'60545','Kendall','17093','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2600,'07044','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(41393,'71202','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(251,'01068','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31392,'55571','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25824,'47401','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15269,'30415','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(52306,'94707','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21911,'41121','Greenup','21089','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31824,'56139','Pipestone','27117','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15974,'31420','Chatham','13051','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37660,'64653','Linn','29115','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(944,'02858','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(19558,'37401','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4389,'12019','Saratoga','36091','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36210,'62471','Fayette','17051','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(13808,'28609','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12842,'27455','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(11431,'24569','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51226,'92259','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21872,'41062','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(46510,'78739','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14737,'29903','Beaufort','45013','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16064,'31605','Lanier','13173','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26980,'48858','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28597,'50632','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29118,'52036','Delaware','19055','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33182,'57782','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2123,'06024','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37579,'64489','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(45632,'77466','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47476,'80259','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10872,'23846','Surry','51181','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20638,'38963','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(47897,'81073','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(34873,'60602','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42468,'72657','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33905,'59008','Park','56029','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(9807,'21665','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(5537,'13838','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52401,'95023','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18660,'36089','Bullock','1011','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14888,'30077','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14277,'29325','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12906,'27541','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(40390,'68861','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(31399,'55578','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(52584,'95328','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30026,'53588','Sauk','55111','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(6410,'15349','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(37420,'64102','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5661,'14098','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(27811,'49880','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50938,'91714','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51648,'93245','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51739,'93440','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44721,'76198','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7667,'17415','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19005,'36741','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(44435,'75799','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4006,'10952','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10440,'23015','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28050,'50129','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(36318,'62617','Mason','17125','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42096,'72160','Stone','5137','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1210,'03774','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(45685,'77511','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48500,'83444','Jefferson','16051','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(26570,'48375','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(40065,'68503','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(47450,'80233','Adams','8001','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(10117,'22433','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20893,'39350','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44821,'76366','Archer','48009','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34539,'60111','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31905,'56215','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(7402,'17016','Lebanon','42075','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3966,'10707','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29714,'53058','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53137,'96089','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54862,'99341','Adams','53001','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(22424,'42344','Muhlenberg','21177','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4356,'11956','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13101,'27839','Halifax','37083','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13541,'28349','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34290,'59719','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(47714,'80758','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9196,'20442','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(30914,'54930','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35357,'61420','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53486,'96836','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(7610,'17316','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20418,'38679','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9509,'20904','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26573,'48380','Livingston','26093','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(51311,'92376','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53993,'97739','Klamath','41035','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(2938,'07962','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40145,'68644','Platte','31141','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(29286,'52240','Johnson','19103','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(19125,'36921','Choctaw','1023','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3199,'08559','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10459,'23039','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44283,'75603','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47673,'80701','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2828,'07735','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(31946,'56241','Chippewa','27023','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33768,'58716','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54382,'98377','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(79,'00733','Ponce','72113','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(18457,'35774','Jackson','1071','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3318,'08861','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10238,'22644','Shenandoah','51171','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12524,'26719','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(53305,'96550','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(50460,'90002','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38917,'66856','Coffey','20031','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32220,'56474','Cass','27021','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(21946,'41174','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20451,'38745','Issaquena','28055','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(41254,'70879','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(11104,'24120','Carroll','51035','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(644,'02130','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(3768,'10131','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(14364,'29436','Berkeley','45015','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25578,'47124','Harrison','18061','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30989,'54986','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37106,'63623','Reynolds','29179','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40217,'68734','Holt','31089','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40754,'70006','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53574,'97037','Wasco','41065','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(9430,'20783','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(26245,'47978','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(21439,'40245','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22919,'43326','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(29024,'51551','Fremont','19071','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31386,'55565','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33271,'58060','Ransom','38073','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34579,'60142','McHenry','17111','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41115,'70646','Calcasieu','22019','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43600,'74572','Coal','40029','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46004,'78069','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47953,'81152','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5169,'13167','Oswego','36075','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21787,'40949','Knox','21121','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(11604,'24944','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26004,'47631','Posey','18129','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(26196,'47946','Pulaski','18131','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41875,'71964','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14705,'29838','Edgefield','45037','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32668,'57225','Clark','46025','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35169,'61104','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49703,'87047','Santa Fe','35049','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(42903,'73173','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38162,'65548','Howell','29091','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(16204,'31779','Thomas','13275','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2135,'06037','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(36472,'62824','Wayne','17191','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53368,'96698','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(34142,'59416','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52808,'95625','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(4089,'11209','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7546,'17220','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19505,'37360','Moore','47127','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31930,'56228','Meeker','27093','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38594,'66109','Wyandotte','20209','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44318,'75651','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10071,'22244','Arlington','51013','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25159,'46562','Whitley','18183','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(22289,'42122','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18780,'36321','Houston','1069','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2528,'06876','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22094,'41619','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40542,'69022','Red Willow','31145','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5538,'13839','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53688,'97216','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47153,'79741','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46746,'79072','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33107,'57701','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41743,'71750','Union','5139','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6262,'15102','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43678,'74760','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(18766,'36311','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25419,'46941','Wabash','18169','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(45069,'76637','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(1108,'03276','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30836,'54845','Burnett','55013','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30671,'54664','Vernon','55123','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12786,'27341','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15993,'31519','Coffee','13069','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(39375,'67524','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15457,'30567','Hall','13139','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34601,'60159','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33097,'57651','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31193,'55332','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48478,'83423','Clark','16033','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42108,'72175','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37218,'63787','Bollinger','29017','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(52827,'95640','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45673,'77497','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45178,'76837','Concho','48095','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31705,'56044','Le Sueur','27079','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11503,'24658','Buchanan','51027','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37733,'64744','Cedar','29039','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(27684,'49746','Montmorency','26119','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7357,'16923','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54991,'99631','Kenai Peninsula','2122','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(3544,'09604','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(37815,'64857','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35638,'61774','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25110,'46514','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(37367,'64053','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9069,'20189','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42609,'72852','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43442,'74338','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(22197,'41861','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15015,'30168','Douglas','13097','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6725,'15823','Elk','42047','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23650,'44425','Trumbull','39155','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51236,'92273','Imperial','6025','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54644,'98856','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11587,'24910','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44896,'76453','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2563,'07005','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11347,'24477','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12380,'26425','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5234,'13337','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29051,'51566','Page','19145','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32857,'57375','Aurora','46003','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(20203,'38461','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(37560,'64475','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38435,'65772','McDonald','29119','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43013,'73544','Harmon','40057','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(5482,'13760','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13908,'28687','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51693,'93305','Kern','6029','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20633,'38961','Grenada','28043','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49339,'85367','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29334,'52321','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10540,'23126','King and Queen','51097','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(36803,'63074','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38840,'66751','Allen','20001','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40342,'68826','Merrick','31121','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(5669,'14108','Niagara','36063','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48223,'82514','Fremont','56013','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51775,'93514','Mono','6051','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3077,'08224','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6394,'15332','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25109,'46513','Marshall','18099','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25894,'47468','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20791,'39177','Issaquena','28055','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(30021,'53585','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(8384,'18938','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3870,'10472','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22203,'42021','Carlisle','21039','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(39556,'67736','Gove','20063','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5489,'13777','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30003,'53573','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(7783,'17756','Montour','42093','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17489,'33781','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15541,'30650','Greene','13133','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38213,'65606','Oregon','29149','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19064,'36802','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51773,'93513','Inyo','6027','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12129,'25971','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6337,'15241','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40023,'68444','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32839,'57364','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43541,'74465','Cherokee','40021','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46884,'79256','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48881,'84139','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(17280,'33470','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(43030,'73556','Jackson','40065','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14856,'30052','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(51344,'92501','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22284,'42103','Warren','21227','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13448,'28246','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13745,'28553','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24141,'45224','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(32328,'56584','Clay','27027','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2200,'06110','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47354,'80107','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36909,'63338','Saint Charles','29183','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33128,'57722','Fall River','46047','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(8674,'19421','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8039,'18109','Lehigh','42077','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(22781,'43117','Pickaway','39129','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31261,'55376','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39319,'67470','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(34213,'59486','Pondera','30073','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(22185,'41838','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(10226,'22627','Rappahannock','51157','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13225,'27964','Currituck','37053','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31136,'55133','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31248,'55368','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45806,'77704','Jefferson','48245','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47376,'80125','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(51240,'92276','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(2125,'06026','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(22022,'41386','Owsley','21189','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38683,'66436','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(5568,'13903','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6645,'15705','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24920,'46176','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31060,'55056','Isanti','27059','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(22353,'42219','Butler','21031','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(48576,'83617','Payette','16075','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(13959,'28735','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48150,'82201','Albany','56001','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(40425,'68901','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39922,'68348','Johnson','31097','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(36238,'62517','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27970,'50060','Wayne','19185','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15929,'31307','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19227,'37068','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15176,'30307','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23820,'44679','Tuscarawas','39157','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51855,'93622','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9837,'21719','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19751,'37824','Claiborne','47025','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16856,'32772','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(15552,'30662','Franklin','13119','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28808,'51048','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(39121,'67118','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41024,'70529','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(51983,'93927','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36576,'62890','Saline','17165','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36028,'62301','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32899,'57433','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(16039,'31557','Appling','13001','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5031,'13032','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3281,'08816','Middlesex','34023','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(54526,'98591','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(412,'01519','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42981,'73507','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(23891,'44820','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24893,'46161','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25738,'47334','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40673,'69171','Dawson','31047','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44251,'75551','Cass','48067','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48065,'81601','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(3356,'09008','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(48575,'83617','Gem','16045','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(22458,'42376','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(31495,'55763','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33119,'57717','Crook','56011','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(16086,'31632','Cook','13075','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43042,'73566','Tillman','40141','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(19043,'36775','Dallas','1047','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(6981,'16235','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(43043,'73567','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41283,'71027','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16129,'31706','Dougherty','13095','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11332,'24459','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27222,'49126','Berrien','26021','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(28292,'50336','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(49440,'85652','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9753,'21601','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(1491,'04410','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(49047,'84726','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(47740,'80822','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(23603,'44307','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26340,'48083','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29122,'52039','Dubuque','19061','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(15138,'30276','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35560,'61656','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16366,'32083','Bradford','12007','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12565,'26852','Grant','54023','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12467,'26591','Harrison','54033','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16464,'32204','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14438,'29520','Chesterfield','45025','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22917,'43324','Logan','39091','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(47254,'79934','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42288,'72449','Randolph','5121','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(17999,'35019','Morgan','1103','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52494,'95173','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47857,'81039','Crowley','8025','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(26262,'47992','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23026,'43466','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(38421,'65762','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38874,'66777','Wilson','20205','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(18544,'35983','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(18546,'35984','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47606,'80528','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(29954,'53536','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20798,'39189','Scott','28123','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(55167,'99928','Ketchikan Gateway','2130','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53433,'96772','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(52490,'95161','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45545,'77378','San Jacinto','48407','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22172,'41821','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(12136,'25979','Mercer','54055','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4334,'11930','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30486,'54479','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2018,'05737','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(4914,'12853','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(40373,'68848','Buffalo','31019','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39282,'67444','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29553,'52656','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29551,'52654','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27281,'49262','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22629,'42776','Hardin','21093','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(43769,'74881','Logan','40083','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42994,'73531','Cotton','40033','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46918,'79338','Hockley','48219','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33020,'57559','Mellette','46095','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33303,'58107','Cass','38017','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19609,'37656','Sullivan','47163','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21164,'39756','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3707,'10023','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20267,'38550','Warren','47177','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42925,'73434','Garvin','40049','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31989,'56274','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45094,'76657','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48558,'83554','Idaho','16049','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(32142,'56379','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(54658,'98909','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(5894,'14544','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(42718,'73021','Washita','40149','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(20332,'38609','Quitman','28119','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44042,'75236','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22,'00637','Sabana Grande','72121','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(21402,'40177','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(52671,'95429','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51557,'93015','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46854,'79237','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45424,'77237','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32971,'57481','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2208,'06120','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(2613,'07060','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40488,'68956','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(44370,'75693','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(338,'01270','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20806,'39193','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2735,'07474','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36097,'62373','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24401,'45622','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22456,'42376','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36445,'62801','Marion','17121','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20224,'38475','Wayne','47181','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13733,'28540','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16265,'31822','Meriwether','13199','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18578,'36026','Elmore','1051','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20155,'38370','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41463,'71270','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(20062,'38258','Carroll','47017','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(30580,'54561','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10282,'22729','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7776,'17749','Northumberland','42097','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23435,'44088','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12274,'26261','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7828,'17823','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1676,'04760','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(51131,'92124','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46900,'79314','Cochran','48079','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35292,'61340','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32648,'57212','Brookings','46011','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19761,'37831','Anderson','47001','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19209,'37058','Stewart','47161','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19000,'36728','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17908,'34742','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25531,'47034','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(44016,'75209','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34005,'59112','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38243,'65624','Barry','29009','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(53701,'97225','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54648,'98859','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(8075,'18241','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33321,'58212','Griggs','38039','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54863,'99343','Franklin','53021','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(53583,'97049','Clackamas','41005','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11884,'25434','Morgan','54065','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21010,'39525','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32738,'57270','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7223,'16674','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31972,'56263','Lyon','27083','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11626,'24991','Greenbrier','54025','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26646,'48450','Sanilac','26151','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(52485,'95156','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53646,'97130','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(3606,'09737','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(21454,'40269','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42142,'72231','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24056,'45115','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53286,'96517','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(2587,'07030','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15548,'30660','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2685,'07305','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5739,'14233','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10441,'23015','Spotsylvania','51177','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27853,'49930','Houghton','26061','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(41381,'71153','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(12705,'27252','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20000,'38147','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15405,'30534','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(45763,'77611','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46811,'79119','Randall','48381','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35241,'61278','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(29421,'52536','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27629,'49696','Grand Traverse','26055','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33689,'58621','Golden Valley','38033','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10473,'23059','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41245,'70826','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(7922,'17963','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47675,'80720','Washington','8121','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1048,'03108','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(16835,'32746','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33210,'58013','Sargent','38081','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10967,'23955','Nottoway','51135','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47128,'79711','Midland','48329','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(4995,'12972','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18959,'36609','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17818,'34452','Citrus','12017','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54045,'97848','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(24998,'46275','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39110,'67111','Kingman','20095','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22020,'41368','Lee','21129','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19448,'37324','Grundy','47061','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(2112,'06006','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(14291,'29340','Cherokee','45021','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48814,'84067','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(35543,'61629','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34444,'60013','Lake','17097','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28073,'50144','Decatur','19053','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27416,'49406','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16257,'31814','Stewart','13259','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11525,'24808','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30877,'54891','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5007,'12985','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12567,'26852','Hardy','54031','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23110,'43560','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10998,'24010','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52426,'95056','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52012,'94023','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38249,'65627','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19723,'37801','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46737,'79066','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39792,'68105','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(3020,'08075','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40510,'68973','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43820,'75002','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21959,'41204','Johnson','21115','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18684,'36119','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(11447,'24588','Campbell','51031','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51081,'92059','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49588,'86332','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(42007,'72085','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27922,'50029','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(22367,'42241','Christian','21047','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20269,'38551','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19224,'37065','Williamson','47187','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17771,'34268','DeSoto','12027','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16918,'32854','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27410,'49403','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32005,'56284','Renville','27129','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19852,'37921','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4136,'11360','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47453,'80235','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44440,'75831','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8618,'19335','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15980,'31503','Ware','13299','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37983,'65246','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42104,'72169','Jackson','5067','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(4741,'12540','Dutchess','36027','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(55153,'99836','Sitka','2220','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(53975,'97708','Deschutes','41017','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(43811,'74962','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48901,'84244','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(4126,'11252','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44752,'76241','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3963,'10704','Westchester','36119','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35420,'61470','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37322,'63962','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37594,'64501','Buchanan','29021','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37984,'65247','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(43186,'73772','Blaine','40011','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(30868,'54874','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24257,'45339','Miami','39109','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9338,'20675','Charles','24017','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(4385,'12015','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26575,'48381','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33053,'57620','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34556,'60126','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49365,'85531','Graham','4009','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(46442,'78664','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10619,'23230','Richmond City','51760','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51734,'93434','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46347,'78609','Llano','48299','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31231,'55354','McLeod','27085','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19826,'37881','Hawkins','47073','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(14304,'29364','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26249,'47981','Tippecanoe','18157','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15633,'30755','Catoosa','13047','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6689,'15756','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44128,'75414','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50200,'89006','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(53906,'97487','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(3163,'08514','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12415,'26507','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(44088,'75354','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29031,'51555','Harrison','19085','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43672,'74754','McCurtain','40089','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43154,'73746','Woods','40151','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(37399,'64079','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35052,'60969','Kankakee','17091','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(49201,'85142','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32148,'56385','Pope','27121','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(20816,'39208','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(1698,'04841','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(10300,'22741','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6868,'16050','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25227,'46732','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1759,'04954','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8607,'19312','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9766,'21625','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(52691,'95453','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48998,'84630','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(3153,'08501','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(44403,'75762','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(128,'00831','Saint John','78020','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(43284,'74028','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39592,'67757','Thomas','20193','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32318,'56575','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31689,'56028','Waseca','27161','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43352,'74077','Payne','40119','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47851,'81029','Baca','8009','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(11133,'24141','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4293,'11764','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12796,'27350','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(13413,'28209','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(127,'00830','Saint John','78020','VI','U.S. Virgin Islands',0,'2013-07-03 15:17:51',NULL,NULL),(40112,'68628','Polk','31143','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49322,'85350','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(36296,'62563','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8464,'19044','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8734,'19505','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6439,'15413','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53203,'96161','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8933,'20038','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(6333,'15238','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23993,'45001','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(40199,'68725','Garfield','31071','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41127,'70656','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52496,'95191','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8872,'19950','Kent','10001','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(42662,'72944','Sebastian','5131','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47280,'79976','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45099,'76664','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43885,'75067','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(14425,'29503','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(718,'02333','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(25538,'47039','Ripley','18137','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27345,'49319','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5842,'14489','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52280,'94611','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1568,'04548','Sagadahoc','23023','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15714,'31009','Dodge','13091','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8769,'19543','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28433,'50523','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(495,'01773','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(16893,'32814','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17931,'34777','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(41290,'71033','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(32082,'56339','Douglas','27041','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(29493,'52588','Davis','19051','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(17939,'34797','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(47061,'79537','Nolan','48353','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45221,'76871','Lampasas','48281','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45084,'76650','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17854,'34608','Hernando','12053','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6392,'15330','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48443,'83338','Jerome','16053','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(16777,'32666','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17889,'34695','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3748,'10110','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5704,'14169','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53674,'97204','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36654,'62939','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12967,'27592','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(12870,'27517','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20803,'39192','Attala','28007','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3290,'08826','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7252,'16720','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54225,'98189','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43296,'74036','Mayes','40097','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48666,'83731','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(42168,'72331','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40236,'68747','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2465,'06753','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(3613,'09745','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(7409,'17020','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49622,'86437','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(20703,'39088','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7062,'16361','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11952,'25606','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5688,'14138','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8541,'19126','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42978,'73505','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38099,'65401','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(11979,'25654','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12698,'27244','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52085,'94151','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49821,'87513','Taos','35055','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49151,'85053','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48182,'82324','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5738,'14231','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31482,'55748','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(2362,'06451','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(24304,'45380','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14799,'30012','DeKalb','13089','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1739,'04932','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(34720,'60449','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37771,'64780','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46414,'78648','Guadalupe','48187','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10883,'23856','Greensville','51081','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26701,'48552','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(50034,'88221','Eddy','35015','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(41270,'71007','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(8529,'19114','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(33555,'58456','Lamoure','38045','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35506,'61558','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4566,'12227','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54029,'97833','Baker','41001','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(8383,'18936','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13890,'28673','Catawba','37035','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14061,'29015','Fairfield','45039','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50430,'89703','Washoe','32031','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(46182,'78338','Kenedy','48261','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52955,'95852','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38774,'66607','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(24285,'45362','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7557,'17232','Franklin','42055','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44310,'75644','Camp','48063','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21841,'41034','Bracken','21023','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13792,'28601','Alexander','37003','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26558,'48357','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31131,'55126','Ramsey','27123','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33984,'59082','Park','30067','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(41782,'71833','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45757,'77588','Brazoria','48039','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23477,'44129','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42811,'73082','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44856,'76429','Palo Pinto','48363','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25001,'46278','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(39734,'68029','Washington','31177','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(20147,'38365','Hardin','47071','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15495,'30619','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(20231,'38482','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16719,'32578','Okaloosa','12091','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30982,'54982','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35274,'61326','Putnam','17155','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(51075,'92052','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36022,'62294','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20462,'38759','Bolivar','28011','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(5698,'14145','Wyoming','36121','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32744,'57273','Day','46037','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45290,'77004','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50503,'90045','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55121,'99774','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(1226,'03812','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(15382,'30522','Fannin','13111','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(701,'02284','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31335,'55433','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31443,'55708','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(44763,'76252','Cooke','48097','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9954,'21911','Cecil','24015','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(43971,'75152','Ellis','48139','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31911,'56219','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(4208,'11554','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53622,'97107','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(51952,'93772','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17622,'33957','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26588,'48413','Huron','26063','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34223,'59523','Blaine','30005','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34334,'59802','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38697,'66502','Pottawatomie','20149','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42612,'72853','Perry','5105','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50527,'90069','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22386,'42275','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21299,'40046','Anderson','21005','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9652,'21215','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(24580,'45807','Putnam','39137','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24747,'46036','Tipton','18159','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28033,'50119','Marion','19125','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42569,'72776','Madison','5087','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45245,'76890','Mills','48333','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52009,'94020','San Mateo','6081','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7214,'16666','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40495,'68959','Kearney','31099','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35235,'61273','Rock Island','17161','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(20955,'39451','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2800,'07699','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16770,'32658','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24369,'45469','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(28422,'50515','Palo Alto','19147','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35575,'61724','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46248,'78411','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23328,'43948','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(15673,'30822','Jenkins','13165','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(27864,'49948','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31083,'55078','Washington','27163','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(43095,'73662','Beckham','40009','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(49711,'87059','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(53846,'97416','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(5223,'13326','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18956,'36606','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1941,'05470','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(17070,'33111','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(44611,'76051','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38822,'66733','Neosho','20133','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36113,'62411','Effingham','17049','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14032,'28805','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10603,'23222','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15423,'30543','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15137,'30276','Haralson','13143','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13522,'28334','Harnett','37085','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29805,'53147','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31128,'55124','Dakota','27037','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33931,'59035','Big Horn','30003','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35548,'61636','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36260,'62539','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38858,'66763','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(11046,'24059','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29027,'51552','Pottawattamie','19155','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8236,'18603','Luzerne','42079','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23157,'43713','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3549,'09609','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9490,'20880','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(29921,'53516','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(5519,'13813','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54315,'98297','San Juan','53055','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52746,'95540','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46385,'78630','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2493,'06796','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(17099,'33147','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25330,'46816','Allen','18003','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40033,'68452','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49592,'86336','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(53217,'96224','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(54299,'98282','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(23469,'44121','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(955,'02874','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(27475,'49456','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29560,'52660','Des Moines','19057','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30273,'54138','Oconto','55083','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38741,'66536','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47416,'80208','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49681,'87027','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(2272,'06260','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(23246,'43804','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(372,'01430','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12109,'25919','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41376,'71148','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(2711,'07435','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24232,'45325','Montgomery','39113','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24364,'45458','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25137,'46542','Kosciusko','18085','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28036,'50122','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(29505,'52620','Van Buren','19177','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30372,'54344','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21152,'39751','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(53202,'96160','Nevada','6057','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52919,'95799','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36622,'62920','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32973,'57481','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9354,'20697','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(13562,'28366','Johnston','37101','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31394,'55573','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(14066,'29020','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43576,'74552','Haskell','40061','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40545,'69024','Hitchcock','31087','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40186,'68714','Keya Paha','31103','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33803,'58746','Renville','38075','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30680,'54669','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(13472,'28280','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5228,'13331','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10941,'23924','Lunenburg','51111','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19950,'38069','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23576,'44273','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1956,'05488','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(13467,'28273','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20431,'38720','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(28843,'51109','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(46080,'78162','Bee','48025','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50494,'90036','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12395,'26440','Taylor','54091','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49072,'84753','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(41840,'71923','Hot Spring','5059','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(22989,'43431','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22586,'42722','Hart','21099','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21458,'40280','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25642,'47202','Bartholomew','18005','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8396,'18954','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2860,'07823','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(14146,'29107','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36037,'62314','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2374,'06472','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(51546,'93004','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34761,'60480','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32718,'57260','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26894,'48801','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18260,'35474','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2833,'07740','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(39709,'68007','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45999,'78064','Wilson','48493','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(2601,'07045','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(946,'02860','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(15042,'30184','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38752,'66543','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(48748,'84002','Duchesne','49013','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(13482,'28297','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35853,'62056','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44787,'76271','Grayson','48181','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44729,'76207','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3342,'08890','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50691,'90721','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11892,'25444','Hampshire','54027','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49762,'87193','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(26180,'47932','Vermillion','18165','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(16513,'32258','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8993,'20110','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8202,'18463','Pike','42103','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9543,'21030','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27699,'49756','Otsego','26137','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(38507,'66025','Leavenworth','20103','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40641,'69155','Keith','31101','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40689,'69218','Cherry','31031','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45535,'77371','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9381,'20725','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19712,'37771','Roane','47145','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1378,'04091','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29427,'52537','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(42547,'72753','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43250,'74005','Washington','40147','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45505,'77345','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(50358,'89414','Humboldt','32013','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(2572,'07014','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12827,'27409','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14289,'29336','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(8628,'19346','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8575,'19162','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42566,'72773','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(47225,'79904','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47480,'80263','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5333,'13484','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7238,'16686','Huntingdon','42061','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30965,'54968','Marquette','55077','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32994,'57533','Morrill','31123','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34726,'60454','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24924,'46181','Brown','18013','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(32966,'57475','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40299,'68786','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10422,'22974','Louisa','51109','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(40410,'68874','Loup','31115','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(17264,'33454','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27878,'49965','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(47834,'81006','Pueblo','8101','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(48863,'84119','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(11942,'25564','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2131,'06032','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(34071,'59275','Sheridan','30091','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(36745,'63022','Saint Louis','29189','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(6217,'15050','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54753,'99119','Pend Oreille','53051','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48885,'84147','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(6433,'15379','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23533,'44224','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26447,'48190','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26786,'48652','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(34051,'59255','Roosevelt','30085','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33578,'58475','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32523,'57016','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(4280,'11747','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33951,'59054','Musselshell','30065','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(49345,'85375','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9137,'20319','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(14225,'29203','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28289,'50333','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32346,'56601','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35627,'61759','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50104,'88421','San Miguel','35047','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(38357,'65717','Douglas','29067','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9640,'21207','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(31348,'55446','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(51872,'93636','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17712,'34142','Hendry','12051','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51797,'93536','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49611,'86413','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26517,'48306','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29049,'51565','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32641,'57118','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34361,'59837','Granite','30039','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(46379,'78624','Mason','48319','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32078,'56336','Todd','27153','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32583,'57051','Lake','46079','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37672,'64660','Chariton','29041','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41819,'71862','Hempstead','5057','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38909,'66850','Chase','20017','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(42348,'72523','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11750,'25187','Mason','54053','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(37463,'64152','Platte','29165','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30436,'54446','Clark','55019','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21648,'40513','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(26175,'47929','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25746,'47338','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15160,'30294','Henry','13151','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4852,'12776','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(46500,'78732','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(28092,'50153','Poweshiek','19157','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16635,'32446','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13374,'28136','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(824,'02630','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19755,'37826','Meigs','47121','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52145,'94289','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48929,'84328','Cache','49005','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(31332,'55431','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(16322,'32033','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4686,'12475','Ulster','36111','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32617,'57071','Moody','46101','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(199,'00983','Carolina','72031','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(19988,'38130','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(46785,'79098','Deaf Smith','48117','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34980,'60920','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44234,'75494','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(391,'01469','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(54536,'98603','Cowlitz','53015','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(33974,'59073','Musselshell','30065','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33826,'58762','Bottineau','38009','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22208,'42025','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9780,'21640','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10727,'23433','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41307,'71051','Bossier','22015','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36635,'62927','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28933,'51442','Crawford','19047','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(9030,'20144','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(742,'02362','Plymouth','25023','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(30744,'54755','Adams','55001','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32999,'57536','Hyde','46069','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39755,'68046','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(49529,'85940','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32510,'57005','Minnehaha','46099','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(9135,'20317','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(16546,'32328','Franklin','12037','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18475,'35814','Madison','1089','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(16705,'32563','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25491,'46991','Huntington','18069','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31493,'55758','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50977,'91768','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47588,'80512','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(589,'02026','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2348,'06422','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(10956,'23942','Prince Edward','51147','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33126,'57720','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38514,'66033','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47541,'80452','Clear Creek','8019','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46029,'78113','Atascosa','48013','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45082,'76649','Bosque','48035','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(7447,'17048','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24654,'45858','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42474,'72662','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(6613,'15671','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4306,'11778','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4978,'12950','Essex','36031','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7938,'17982','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(2816,'07722','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(45394,'77204','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(83,'00737','Cayey','72035','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(38132,'65462','Phelps','29161','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33092,'57648','Emmons','38029','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32883,'57421','Brown','46013','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(7670,'17502','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1043,'03104','Rockingham','33015','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(12387,'26434','Tyler','54095','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16839,'32751','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12460,'26585','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45458,'77279','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12271,'26257','Randolph','54083','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9545,'21032','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33313,'58203','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(37761,'64770','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40250,'68758','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41841,'71929','Clark','5019','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51220,'92253','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24422,'45646','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6355,'15267','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16576,'32357','Taylor','12123','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(6524,'15535','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52918,'95798','Yolo','6113','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3777,'10155','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(44357,'75684','Smith','48423','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26189,'47942','Newton','18111','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24243,'45332','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34199,'59468','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(38221,'65610','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(12790,'27343','Person','37145','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(17941,'34946','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23759,'44627','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13646,'28444','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(50877,'91396','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44287,'75605','Gregg','48183','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48462,'83355','Gooding','16047','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43870,'75051','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42886,'73154','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33716,'58638','Morton','38059','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32411,'56683','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(25830,'47404','Owen','18119','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(50614,'90308','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11594,'24924','Pocahontas','54075','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51464,'92698','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(605,'02053','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(19718,'37777','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25075,'46390','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10477,'23063','Goochland','51075','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7333,'16871','Clinton','42035','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17704,'34136','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4013,'10962','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19628,'37684','Washington','47179','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19576,'37421','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1728,'04921','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(38269,'65638','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(24420,'45644','Ross','39141','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31536,'55810','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50491,'90033','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1560,'04535','Lincoln','23015','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15122,'30264','Coweta','13077','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42461,'72650','Searcy','5129','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2722,'07451','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49548,'86028','Apache','4001','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40842,'70148','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21132,'39740','Monroe','28095','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(2320,'06382','New London','9011','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(37151,'63656','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30442,'54449','Wood','55141','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(43925,'75103','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21014,'39532','Harrison','28047','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18231,'35444','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51764,'93465','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51891,'93653','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7449,'17050','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(40526,'68980','Hamilton','31081','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(37069,'63546','Scotland','29199','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32985,'57529','Gregory','46053','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31333,'55432','Anoka','27003','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(11646,'25033','Putnam','54079','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(6430,'15377','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48154,'82210','Platte','56031','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44487,'75902','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16908,'32830','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23674,'44445','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23584,'44280','Lorain','39093','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20314,'38583','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(52474,'95138','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52674,'95432','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52867,'95680','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(55133,'99788','Yukon Koyukuk','2290','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(33704,'58631','Grant','38037','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32009,'56289','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3986,'10920','Rockland','36087','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2823,'07730','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(46948,'79359','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46001,'78066','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44781,'76266','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37056,'63537','Knox','29103','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(35348,'61414','Knox','17095','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17934,'34786','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18651,'36079','Pike','1109','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2672,'07198','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(49844,'87537','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(43217,'73853','Woodward','40153','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35345,'61412','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35140,'61072','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27052,'48917','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9547,'21035','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21015,'39532','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22758,'43102','Fairfield','39045','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2836,'07747','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(50889,'91412','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49038,'84718','Garfield','49017','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(5358,'13605','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1901,'05401','Chittenden','50007','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(45137,'76701','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5821,'14475','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(4413,'12046','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28075,'50146','Dallas','19049','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31015,'55018','Rice','27131','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(38030,'65285','Monroe','29137','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41152,'70719','West Baton Rouge','22121','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(53026,'95963','Glenn','6021','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21633,'40502','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(47473,'80252','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49972,'88043','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(47466,'80247','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46631,'78957','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37786,'64803','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(9771,'21631','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14629,'29695','Greenwood','45047','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14672,'29804','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(55141,'99812','Juneau','2110','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(33162,'57760','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30937,'54947','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12672,'27208','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48519,'83466','Lemhi','16059','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(6602,'15660','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39779,'68066','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(40298,'68786','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46532,'78761','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25126,'46534','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(7151,'16550','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54836,'99220','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47773,'80901','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46275,'78521','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17748,'34234','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(33535,'58441','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(14996,'30151','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1305,'03908','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(6550,'15561','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(49795,'87402','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(29761,'53098','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(40790,'70068','St John the Baptist','22095','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46639,'78962','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47347,'80104','Douglas','8035','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2683,'07303','Hudson','34017','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(175,'00956','Bayamon','72021','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(30052,'53717','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32063,'56328','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(15914,'31217','Twiggs','13289','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(24008,'45032','Warren','39165','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(41991,'72076','Faulkner','5045','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(11910,'25512','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(928,'02828','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(49677,'87024','Sandoval','35043','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(44184,'75453','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30906,'54923','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12805,'27358','Rockingham','37157','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22113,'41653','Floyd','21071','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(38446,'65779','Hickory','29085','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36136,'62424','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35447,'61484','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9455,'20830','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(388,'01464','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(31372,'55487','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50320,'89165','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(40820,'70116','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39673,'67871','Logan','20109','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14493,'29583','Florence','45041','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(974,'02895','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(20708,'39092','Newton','28101','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(883,'02742','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53737,'97301','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46365,'78619','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45351,'77063','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35894,'62086','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11991,'25676','Mingo','54059','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24156,'45240','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2430,'06602','Fairfield','9001','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(1567,'04547','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16089,'31635','Atkinson','13003','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18719,'36258','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3064,'08205','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(11544,'24839','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52509,'95209','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45728,'77560','Chambers','48071','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26611,'48426','Tuscola','26157','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10113,'22427','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19510,'37364','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(184,'00966','Guaynabo','72061','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(34360,'59835','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(4273,'11738','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22390,'42285','Edmonson','21061','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(54703,'99013','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(42404,'72577','Sharp','5135','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41054,'70558','Lafayette','22055','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(17772,'34269','Charlotte','12015','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(9801,'21659','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25482,'46986','Howard','18067','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38236,'65619','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39892,'68331','Gage','31067','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(8799,'19701','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(53309,'96554','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(26723,'48612','Gladwin','26051','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1716,'04863','Knox','23013','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(47757,'80833','Elbert','8039','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45780,'77631','Orange','48361','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13287,'28053','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16483,'32224','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18505,'35956','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(21541,'40371','Menifee','21165','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15202,'30328','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14804,'30013','Rockdale','13247','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22688,'43036','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52231,'94560','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49573,'86305','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(39143,'67138','Barber','20007','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37118,'63628','Washington','29221','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(29827,'53177','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(23445,'44096','Lake','39085','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31814,'56131','Murray','27101','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(89,'00744','Naguabo','72103','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(54690,'99004','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49419,'85630','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(48186,'82329','Carbon','56007','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(45882,'77905','Victoria','48469','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43039,'73564','Kiowa','40075','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31390,'55569','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28802,'51046','Cherokee','19035','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7239,'16689','Fulton','42057','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3398,'09126','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(2213,'06129','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54194,'98129','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(35342,'61410','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(24636,'45846','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10083,'22308','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20357,'38629','Benton','28009','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12592,'27019','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:51',NULL,NULL),(16080,'31630','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(11761,'25209','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22788,'43127','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9769,'21628','Queen Annes','24035','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(7001,'16256','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(55169,'99950','Ketchikan Gateway','2130','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(5760,'14411','Orleans','36073','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(47883,'81059','Las Animas','8071','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(20244,'38501','Putnam','47141','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3066,'08212','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(36563,'62883','Perry','17145','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28325,'50430','Hancock','19081','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27850,'49925','Ontonagon','26131','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1782,'04981','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(52292,'94624','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38958,'66939','Republic','20157','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37651,'64648','Daviess','29061','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31406,'55585','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(25305,'46792','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(285,'01107','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53135,'96087','Shasta','6089','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43113,'73705','Garfield','40047','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(38240,'65622','Dallas','29059','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10586,'23184','Gloucester','51073','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26456,'48203','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36307,'62601','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37879,'65046','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40409,'68874','Hall','31079','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39059,'67050','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37057,'63538','Macon','29121','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28053,'50131','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45452,'77271','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42047,'72122','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(7676,'17508','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20358,'38629','Tippah','28139','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(54401,'98396','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(37546,'64463','Gentry','29075','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30771,'54767','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26541,'48331','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22201,'42003','McCracken','21145','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16533,'32315','Leon','12073','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4157,'11385','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1793,'05009','Windsor','50027','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(15925,'31302','Effingham','13103','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30216,'54022','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(54017,'97817','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(36827,'63109','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38187,'65566','Iron','29093','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4609,'12309','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(37994,'65257','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37477,'64167','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10527,'23115','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9156,'20395','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(29806,'53148','Walworth','55127','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53480,'96823','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(16364,'32082','Putnam','12107','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13739,'28546','Onslow','37133','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(27584,'49660','Manistee','26101','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(29435,'52549','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(31259,'55374','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(31597,'55947','Winona','27169','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(39385,'67543','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40934,'70427','Saint Tammany','22103','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(52371,'94974','Marin','6041','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9439,'20794','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(38555,'66072','Anderson','20003','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37561,'64475','Nodaway','29147','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(31730,'56062','Watonwan','27165','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(5465,'13745','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(23335,'43962','Columbiana','39029','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19922,'38045','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27467,'49450','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35304,'61349','Cass','17017','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37312,'63954','Butler','29023','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4618,'12406','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(11451,'24590','Fluvanna','51065','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(45386,'77095','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(25711,'47302','Delaware','18035','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(10836,'23803','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2030,'05750','Rutland','50021','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(43977,'75156','Henderson','48213','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11861,'25402','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(43827,'75011','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41247,'70831','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39100,'67106','Sumner','20191','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36440,'62791','Sangamon','17167','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34757,'60477','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26021,'47654','Gibson','18051','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3641,'09817','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54336,'98329','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52619,'95367','Stanislaus','6099','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45028,'76569','Milam','48331','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9662,'21223','Baltimore City','24510','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(34797,'60515','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34000,'59105','Yellowstone','30111','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(12195,'26143','Jackson','54035','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20311,'38582','DeKalb','47041','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(16105,'31642','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(14111,'29061','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34974,'60917','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(55155,'99841','Hoonah-Angoon','2105','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(42732,'73030','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35686,'61843','McLean','17113','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2456,'06722','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(54056,'97867','Union','41061','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(12831,'27413','Guilford','37081','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14943,'30111','Cobb','13067','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13375,'28137','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35883,'62081','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19102,'36869','Russell','1113','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9404,'20753','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(11217,'24266','Russell','51167','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3268,'08802','Hunterdon','34019','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(38609,'66205','Johnson','20091','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(1449,'04281','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2103,'05901','Essex','50009','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11070,'24079','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11898,'25504','Wayne','54099','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23373,'44022','Darke','39037','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(7935,'17980','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13209,'27944','Perquimans','37143','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(9864,'21765','Howard','24027','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(33426,'58331','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(49079,'84760','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51874,'93638','Madera','6039','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53163,'96116','Modoc','6049','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45467,'77292','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41266,'71002','Natchitoches','22069','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38690,'66441','Dickinson','20041','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(3756,'10118','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52681,'95442','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(6441,'15416','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(39297,'67450','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38432,'65770','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39448,'67584','Ness','20135','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(47464,'80246','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(5087,'13081','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33443,'58346','Pierce','38069','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19410,'37235','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(8455,'19036','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23591,'44286','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(1145,'03456','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2269,'06256','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(35062,'61008','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47811,'80938','El Paso','8041','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45833,'77836','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45443,'77261','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49498,'85750','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(24915,'46173','Franklin','18047','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(982,'02906','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(25814,'47387','Fayette','18041','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(38216,'65608','Ozark','29153','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38710,'66512','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41757,'71764','Columbia','5027','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1727,'04920','Somerset','23025','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2618,'07063','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4155,'11380','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21209,'39837','Decatur','13087','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(35492,'61542','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30888,'54909','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1877,'05302','Windham','50025','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(24136,'45219','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(50620,'90402','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1673,'04756','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44356,'75684','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(27142,'49057','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(4028,'10979','Orange','36071','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9064,'20185','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17203,'33337','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(1931,'05459','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(5352,'13505','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(28288,'50332','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34709,'60442','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36023,'62294','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(41598,'71438','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44271,'75569','Bowie','48037','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44541,'75972','San Augustine','48405','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38042,'65322','Cooper','29053','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37876,'65042','Moniteau','29135','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(30170,'53957','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1548,'04487','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11681,'25081','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1640,'04674','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11216,'24265','Lee','51105','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9359,'20705','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(14798,'30011','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38679,'66432','Nemaha','20131','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(13257,'28020','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52713,'95476','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(12371,'26415','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(1809,'05046','Caledonia','50005','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34137,'59411','Glacier','30035','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(26565,'48367','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22875,'43232','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(5570,'13905','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1224,'03810','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(5217,'13322','Herkimer','36043','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6126,'14870','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16590,'32406','Bay','12005','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(3693,'10008','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(13145,'27876','Northampton','37131','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22870,'43227','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42071,'72136','White','5145','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18978,'36663','Mobile','1097','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14480,'29574','Dillon','45033','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48281,'82831','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(5030,'13031','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12624,'27050','Forsyth','37067','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(21819,'41010','Grant','21081','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(16024,'31550','Clinch','13065','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49930,'87935','Sierra','35051','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(6148,'14885','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52972,'95914','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18705,'36203','Talladega','1121','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9134,'20314','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3855,'10457','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48046,'81433','San Juan','8111','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(9809,'21667','Kent','24029','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15270,'30417','Bulloch','13031','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26426,'48170','Washtenaw','26161','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35947,'62240','Monroe','17133','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(6518,'15531','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52207,'94537','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42308,'72465','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45111,'76673','Limestone','48293','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46870,'79248','Foard','48155','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17046,'33066','Broward','12011','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8469,'19050','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(24015,'45041','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43599,'74571','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(47187,'79780','Reeves','48389','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9385,'20733','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(30081,'53806','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30697,'54726','Chippewa','55017','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(48899,'84199','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(31887,'56185','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(36970,'63390','Warren','29219','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46508,'78738','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48611,'83648','Elmore','16039','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(26318,'48060','Saint Clair','26147','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30420,'54432','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(35938,'62234','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11140,'24149','Floyd','51063','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48242,'82637','Converse','56009','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(42828,'73099','Canadian','40017','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(4568,'12229','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19526,'37374','Marion','47115','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(50638,'90509','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9325,'20653','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(726,'02343','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44671,'76111','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41759,'71764','Ouachita','5103','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(41444,'71251','Jackson','22049','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28034,'50120','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4565,'12226','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(15561,'30666','Oconee','13219','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23794,'44654','Holmes','39075','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25250,'46748','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30194,'54003','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9164,'20407','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(36063,'62345','Pike','17149','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36179,'62449','Jasper','17079','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46887,'79257','Swisher','48437','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47865,'81044','Bent','8011','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49412,'85623','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(51973,'93908','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52448,'95110','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8518,'19103','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42124,'72206','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42512,'72719','Benton','5007','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(50824,'91325','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18245,'35461','Pickens','1107','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4236,'11691','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29272,'52228','Benton','19011','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(6308,'15213','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44986,'76531','Comanche','48093','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23894,'44822','Richland','39139','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24767,'46050','Clinton','18023','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28501,'50568','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2365,'06457','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19143,'37018','Bedford','47003','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17893,'34711','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(14285,'29334','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10177,'22542','Orange','51137','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51079,'92057','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48461,'83354','Blaine','16013','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48108,'81652','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(14659,'29731','York','45091','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(24431,'45654','Hocking','39073','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(31301,'55403','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32031,'56307','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33969,'59069','Stillwater','30095','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(40271,'68770','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41780,'71832','Sevier','5133','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(20161,'38374','Henderson','47077','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(4958,'12926','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2934,'07946','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25226,'46731','Wells','18179','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(52075,'94137','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50726,'90840','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14559,'29643','Anderson','45007','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6987,'16240','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(48336,'83118','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(54716,'99025','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(28953,'51455','Audubon','19009','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1113,'03282','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(3424,'09261','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(8086,'18252','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7832,'17827','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10116,'22432','Northumberland','51133','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17240,'33426','Palm Beach','12099','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31615,'55961','Mower','27099','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46982,'79402','Lubbock','48303','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51480,'92799','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(3850,'10452','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20616,'38948','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11899,'25505','Lincoln','54043','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(191,'00976','Trujillo Alto','72139','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(14967,'30129','Floyd','13115','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(451,'01601','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(42675,'72955','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43023,'73552','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42157,'72322','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(33766,'58712','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26888,'48768','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(35352,'61416','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54600,'98687','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(45325,'77039','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37280,'63882','Mississippi','29133','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(13618,'28421','Pender','37141','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32669,'57225','Deuel','46039','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33970,'59069','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(35998,'62273','Bond','17005','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(14171,'29128','Sumter','45085','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(35279,'61330','Lee','17103','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42833,'73105','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45668,'77493','Waller','48473','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45995,'78061','Frio','48163','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5050,'13045','Cayuga','36011','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(52592,'95336','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47604,'80526','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(18681,'36116','Montgomery','1101','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13017,'27661','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25768,'47354','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(29372,'52347','Iowa','19095','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(43874,'75053','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46723,'79059','Gray','48179','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11967,'25637','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54395,'98390','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(11474,'24612','Tazewell','51185','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18211,'35293','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(32707,'57255','Richland','38077','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(51400,'92595','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51084,'92064','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(46858,'79241','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46803,'79111','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26060,'47737','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33060,'57626','Perkins','46105','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34084,'59314','Campbell','56005','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(10827,'23705','Portsmouth City','51740','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2931,'07939','Somerset','34035','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(16009,'31537','Charlton','13049','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28018,'50107','Greene','19073','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5474,'13753','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36656,'62941','Massac','17127','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50948,'91733','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45457,'77277','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(3534,'09588','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(42816,'73089','Grady','40051','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(10587,'23185','Charles City','51036','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54478,'98538','Lewis','53041','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(1327,'04021','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(36695,'62967','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30655,'54653','La Crosse','55063','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37016,'63457','Lewis','29111','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14189,'29145','Newberry','45071','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(16087,'31632','Lowndes','13185','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8446,'19027','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(3419,'09227','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(47576,'80498','Summit','8117','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(13953,'28730','Buncombe','37021','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29064,'51577','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(4276,'11741','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50960,'91748','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54802,'99166','Ferry','53019','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(43432,'74331','Delaware','40041','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35825,'62028','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35802,'62009','Macoupin','17117','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(18278,'35503','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3021,'08076','Burlington','34005','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(32350,'56621','Polk','27119','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(16763,'32644','Levy','12075','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17158,'33256','Miami-Dade','12086','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(54269,'98249','Island','53029','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47665,'80650','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41262,'70898','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(30855,'54865','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(30173,'53960','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53725,'97280','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(45310,'77024','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43765,'74878','Pottawatomie','40125','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(36717,'62990','Alexander','17003','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4948,'12915','Franklin','36033','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22871,'43228','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42107,'72175','Arkansas','5001','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40623,'69145','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(36598,'62902','Williamson','17199','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16634,'32445','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(24879,'46151','Johnson','18081','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(13774,'28579','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5418,'13667','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7652,'17368','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32263,'56531','Otter Tail','27111','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(52869,'95682','El Dorado','6017','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(14914,'30097','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16251,'31808','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(4271,'11735','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48170,'82229','Converse','56009','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(44488,'75903','Angelina','48005','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6881,'16057','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(38884,'66783','Woodson','20207','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12420,'26524','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21413,'40210','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(36555,'62879','Clay','17025','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35833,'62035','Madison','17119','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26629,'48438','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(2779,'07643','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(2674,'07201','Union','34039','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(52736,'95526','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8289,'18661','Carbon','42025','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6402,'15340','Washington','42125','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53302,'96546','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(11240,'24313','Wythe','51197','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15676,'30823','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(32559,'57038','Union','46127','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35882,'62080','Shelby','17173','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(53938,'97534','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52481,'95152','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44303,'75640','Harrison','48203','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37987,'65250','Howard','29089','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(37631,'64637','Caldwell','29025','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(10034,'22183','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38861,'66770','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(35591,'61733','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(45503,'77343','Walker','48471','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20279,'38560','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(1173,'03589','Coos','33007','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(1724,'04915','Waldo','23027','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(16417,'32140','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(5245,'13348','Otsego','36077','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10975,'23962','Halifax','51083','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24827,'46112','Hendricks','18063','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(28349,'50444','Worth','19195','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30074,'53801','Grant','55043','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32895,'57430','Marshall','46091','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(45822,'77807','Brazos','48041','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(6933,'16143','Mercer','42085','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9313,'20630','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49469,'85720','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(8804,'19708','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(18752,'36280','Randolph','1111','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15873,'31097','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(38420,'65761','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44805,'76310','Clay','48077','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(34377,'59855','Lake','30047','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(16108,'31645','Berrien','13019','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13485,'28302','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(42365,'72537','Baxter','5005','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(1868,'05252','Bennington','50003','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(9724,'21505','Allegany','24001','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(22596,'42733','Adair','21001','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4465,'12108','Hamilton','36041','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10581,'23180','Middlesex','51119','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48984,'84603','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53793,'97361','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(11340,'24469','Augusta','51015','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23145,'43660','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8360,'18914','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(13445,'28242','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14854,'30052','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13581,'28382','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25805,'47380','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(30962,'54966','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(44518,'75946','Rusk','48401','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44686,'76126','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42823,'73096','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(14613,'29681','Laurens','45059','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(31268,'55382','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(50650,'90620','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(36222,'62478','Crawford','17033','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15804,'31057','Macon','13193','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5402,'13650','Jefferson','36045','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9335,'20667','Saint Marys','24037','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10731,'23437','Suffolk City','51800','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11381,'24521','Nelson','51125','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47616,'80538','Larimer','8069','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(37787,'64804','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(19352,'37178','Houston','47083','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27258,'49245','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32144,'56382','Morrison','27097','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(17345,'33565','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(32752,'57279','Roberts','46109','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17834,'34480','Marion','12083','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22410,'42328','Ohio','21183','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(37175,'63737','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40241,'68751','Dixon','31051','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(10253,'22657','Warren','51187','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26855,'48747','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18736,'36271','Etowah','1055','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(1320,'04013','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(1015,'03051','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(37947,'65108','Cole','29051','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(39682,'67879','Greeley','20071','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(41371,'71134','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14772,'29936','Jasper','45053','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41667,'71638','Drew','5043','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(53607,'97071','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(3519,'09567','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(35364,'61423','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34644,'60201','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(19612,'37658','Carter','47019','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(41499,'71323','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28887,'51338','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8549,'19133','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26914,'48817','Shiawassee','26155','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6048,'14803','Allegany','36003','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5563,'13864','Tioga','36107','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9004,'20119','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4404,'12035','Schoharie','36095','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54298,'98281','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(19877,'38002','Shelby','47157','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(3068,'08214','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3291,'08827','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(28507,'50573','Pocahontas','19151','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(54190,'98124','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(40460,'68939','Franklin','31061','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(34837,'60548','DeKalb','17037','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16238,'31801','Marion','13197','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(23448,'44099','Geauga','39055','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(37576,'64487','Holt','29087','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(28002,'50078','Marshall','19127','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25833,'47407','Monroe','18105','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(27145,'49060','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1911,'05441','Franklin','50011','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(11876,'25427','Berkeley','54003','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11057,'24065','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2948,'07999','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(6681,'15745','Indiana','42063','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16023,'31549','Wheeler','13309','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13587,'28385','Sampson','37163','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32398,'56670','Beltrami','27007','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31822,'56137','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46396,'78638','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36204,'62467','Cumberland','17035','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(25887,'47462','Greene','18055','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5662,'14101','Cattaraugus','36009','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16894,'32815','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(4322,'11796','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(91,'00745','Humacao','72069','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(28301,'50367','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3676,'09866','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49801,'87417','San Juan','35045','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(49319,'85347','Yuma','4027','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(32792,'57331','Douglas','46043','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19191,'37048','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(47681,'80727','Yuma','8125','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39479,'67639','Phillips','20147','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(23739,'44614','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(33814,'58756','Mountrail','38061','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28172,'50231','Hamilton','19079','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5965,'14651','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(21051,'39581','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(51373,'92551','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29313,'52305','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37423,'64108','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36083,'62359','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35409,'61460','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33086,'57644','Ziebach','46137','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1188,'03740','Grafton','33009','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(19286,'37118','Cannon','47015','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(13002,'27622','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(25452,'46968','Starke','18149','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(31934,'56229','Yellow Medicine','27173','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10039,'22194','Prince William','51153','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49032,'84711','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(42412,'72587','Fulton','5049','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40727,'69350','Arthur','31005','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(33776,'58723','McHenry','38049','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(54167,'98092','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47305,'80014','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30952,'54961','Waupaca','55135','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(24775,'46056','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23160,'43717','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20598,'38927','Yalobusha','28161','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(7277,'16801','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50968,'91759','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7589,'17266','Cumberland','42041','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19274,'37101','Dickson','47043','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(12767,'27317','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(26007,'47633','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(40003,'68428','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(43953,'75138','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(52025,'94042','Santa Clara','6085','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35090,'61036','Jo Daviess','17085','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52144,'94288','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9228,'20527','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(3719,'10035','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35794,'61956','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40264,'68767','Wayne','31179','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1353,'04057','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(40919,'70392','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(33438,'58344','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31500,'55767','Pine','27115','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33391,'58275','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39784,'68070','Saunders','31155','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(22359,'42223','Montgomery','47125','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(9993,'22046','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(26714,'48606','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9124,'20268','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19257,'37087','Wilson','47189','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29529,'52641','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(52220,'94550','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48088,'81636','Garfield','8045','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8940,'20044','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(10717,'23421','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54009,'97760','Jefferson','41031','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50387,'89444','Douglas','32005','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(50218,'89024','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(28558,'50606','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(12746,'27298','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(45087,'76653','Falls','48145','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35468,'61524','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32016,'56292','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(28675,'50801','Adams','19003','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26484,'48231','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(17966,'34983','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28803,'51046','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3543,'09603','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(54205,'98146','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(49942,'88005','Dona Ana','35013','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(46491,'78726','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(16994,'32978','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(53926,'97523','Josephine','41033','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(33881,'58838','Richland','30083','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(5501,'13794','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(3086,'08242','Cape May','34009','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(51130,'92123','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27166,'49076','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9573,'21074','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(20656,'39042','Smith','28129','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16950,'32911','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16493,'32234','Clay','12019','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(39591,'67757','Sheridan','20179','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40900,'70359','Lafourche','22057','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(46351,'78611','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51763,'93464','Santa Barbara','6083','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49918,'87825','Socorro','35053','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(21933,'41160','Lawrence','21127','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14563,'29645','Greenville','45045','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(2824,'07731','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(5072,'13068','Tompkins','36109','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(36162,'62442','Clark','17023','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44588,'76033','Somervell','48425','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41503,'71326','Catahoula','22025','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(45159,'76803','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10684,'23336','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(29257,'52218','Linn','19113','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(8565,'19149','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8809,'19713','New Castle','10003','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(21163,'39756','Clay','28025','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(26241,'47977','Benton','18007','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(53318,'96601','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(51642,'93242','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(49059,'84739','Sevier','49041','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(22691,'43040','Union','39159','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(2694,'07403','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(1228,'03813','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(30514,'54499','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9165,'20408','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(8865,'19940','Sussex','10005','DE','Delaware',0,'2013-07-03 15:17:51',NULL,NULL),(28693,'50843','Cass','19029','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(341,'01330','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53752,'97321','Benton','41003','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52732,'95519','Humboldt','6023','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50131,'88526','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(11464,'24602','McDowell','54047','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(11960,'25624','Logan','54045','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(22135,'41725','Knott','21119','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(365,'01373','Franklin','25011','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(53304,'96549','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(23108,'43558','Fulton','39051','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21117,'39701','Noxubee','28103','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(16256,'31812','Taylor','13269','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28654,'50671','Fayette','19065','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33018,'57555','Todd','46121','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42216,'72376','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(43890,'75071','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(51633,'93232','Kings','6031','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(29044,'51562','Shelby','19165','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(1121,'03298','Belknap','33001','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(2138,'06040','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(12196,'26143','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51440,'92658','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35012,'60946','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(27437,'49423','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9007,'20121','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21441,'40245','Shelby','21211','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29050,'51566','Montgomery','19137','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33540,'58444','Burleigh','38015','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53566,'97032','Marion','41047','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47499,'80306','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(45100,'76664','McLennan','48309','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36828,'63110','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(615,'02067','Norfolk','25021','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(8653,'19376','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28851,'51232','Lyon','19119','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26968,'48849','Eaton','26045','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6527,'15538','Somerset','42111','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45979,'78049','Webb','48479','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43704,'74833','Okfuskee','40107','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(43544,'74469','Muskogee','40101','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42438,'72632','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(37288,'63935','Carter','29035','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(23911,'44836','Seneca','39147','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23325,'43945','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(18773,'36317','Dale','1045','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51214,'92247','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45022,'76565','Hamilton','48193','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29628,'52778','Muscatine','19139','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10674,'23316','Northampton','51131','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(18254,'35469','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(15168,'30301','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1013,'03048','Hillsborough','33011','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(51322,'92394','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41826,'71903','Garland','5051','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(24192,'45296','Hamilton','39061','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21153,'39751','Webster','28155','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22548,'42603','Wayne','21231','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4484,'12134','Fulton','36035','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(43985,'75160','Kaufman','48257','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5944,'14616','Monroe','36055','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(797,'02539','Dukes','25007','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46789,'79101','Potter','48375','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(5711,'14202','Erie','36029','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(30136,'53933','Dodge','55027','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37067,'63546','Adair','29001','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46314,'78573','Hidalgo','48215','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46589,'78886','Medina','48325','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30489,'54480','Marathon','55073','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(50467,'90009','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43406,'74146','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(29832,'53181','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26924,'48824','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(9879,'21777','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18108,'35137','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(25254,'46755','DeKalb','18033','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(49142,'85041','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(45133,'76692','Hill','48217','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(8715,'19475','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(11914,'25520','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15679,'30824','McDuffie','13189','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(15749,'31024','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(18266,'35480','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(23549,'44237','Summit','39153','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13671,'28461','Brunswick','37019','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(28942,'51448','Sac','19161','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(21504,'40339','Jessamine','21113','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(35225,'61262','Mercer','17131','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(17932,'34778','Orange','12095','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(46407,'78643','Blanco','48031','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15252,'30380','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19259,'37089','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22522,'42518','Wayne','21231','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(42351,'72526','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40288,'68781','Boone','31011','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(2279,'06268','Tolland','9013','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(32330,'56585','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(2451,'06710','New Haven','9009','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(45751,'77583','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(26460,'48207','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19256,'37087','Trousdale','47169','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(23500,'44188','Cuyahoga','39035','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(17965,'34982','Saint Lucie','12111','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11045,'24058','Pulaski','51155','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5825,'14478','Yates','36123','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(703,'02297','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46330,'78591','Starr','48427','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40139,'68642','Madison','31119','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39255,'67422','Ottawa','20143','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(36050,'62326','McDonough','17109','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12066,'25843','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33588,'58483','Kidder','38043','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(29763,'53101','Kenosha','55059','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(25756,'47346','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2880,'07844','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(40863,'70175','Orleans','22071','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(18307,'35555','Tuscaloosa','1125','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12299,'26287','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(33207,'58009','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53623,'97108','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(52664,'95423','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41028,'70533','Vermilion','22113','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25163,'46565','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23210,'43760','Perry','39127','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36614,'62916','Jackson','17077','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35146,'61077','Winnebago','17201','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(23188,'43739','Licking','39089','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8506,'19090','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(42398,'72572','Independence','5063','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42131,'72212','Pulaski','5119','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(40763,'70036','Jefferson','22051','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(4523,'12172','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(26237,'47971','Warren','18171','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(34314,'59748','Silver Bow','30093','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(31798,'56120','Cottonwood','27033','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46254,'78417','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38154,'65536','Laclede','29105','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34297,'59725','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3751,'10113','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(2658,'07108','Essex','34013','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(7630,'17339','York','42133','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(52984,'95925','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48692,'83824','Benewah','16009','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(43310,'74046','Creek','40037','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45871,'77878','Burleson','48051','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48607,'83645','Washington','16087','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(50459,'90001','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52378,'94999','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52959,'95865','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45303,'77017','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44409,'75766','Cherokee','48073','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(37184,'63747','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33853,'58784','Burke','38013','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12713,'27260','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(19009,'36744','Perry','1105','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(52851,'95666','Amador','6005','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44861,'76432','Brown','48049','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41636,'71469','Sabine','22085','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(16264,'31822','Harris','13145','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(25534,'47037','Decatur','18031','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9090,'20215','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(22971,'43406','Wood','39173','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52598,'95344','Merced','6047','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34519,'60091','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12625,'27050','Stokes','37169','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(48752,'84006','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(39345,'67490','Russell','20167','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(19047,'36783','Marengo','1091','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14192,'29147','Richland','45079','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38116,'65449','Crawford','29055','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(46406,'78642','Williamson','48491','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43495,'74428','McIntosh','40091','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(35551,'61639','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31834,'56146','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(3262,'08756','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(15516,'30629','Oglethorpe','13221','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2588,'07031','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(24718,'45896','Hardin','39065','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23233,'43780','Noble','39121','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(21890,'41091','Boone','21015','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14644,'29715','Lancaster','45057','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(53156,'96109','Lassen','6035','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(52128,'94267','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(17914,'34747','Osceola','12097','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(51801,'93543','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(42286,'72445','Lawrence','5075','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42232,'72394','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(27155,'49067','Van Buren','26159','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(16676,'32522','Escambia','12033','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25069,'46382','La Porte','18091','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2827,'07734','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(10179,'22545','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19520,'37367','Van Buren','47175','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(42430,'72624','Carroll','5015','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28754,'51016','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26246,'47978','White','18181','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(3722,'10038','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(19271,'37097','Humphreys','47085','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18274,'35491','Greene','1063','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(17458,'33740','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30668,'54661','Trempealeau','55121','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1404,'04216','Oxford','23017','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(8226,'18512','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(20407,'38669','Coahoma','28027','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(49604,'86403','Mohave','4015','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(44705,'76164','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35114,'61052','Ogle','17141','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34127,'59354','Fallon','30025','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(33746,'58652','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33331,'58223','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(18792,'36344','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(903,'02779','Bristol','25005','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(4092,'11212','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(31900,'56211','Big Stone','27011','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(32454,'56736','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(37957,'65211','Boone','29019','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41660,'71612','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(51570,'93036','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27756,'49818','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33594,'58486','Wells','38103','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(36829,'63111','Saint Louis City','29510','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40450,'68934','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53856,'97431','Lane','41039','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(47678,'80723','Morgan','8087','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(2015,'05734','Addison','50001','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(16441,'32174','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(26412,'48161','Monroe','26115','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30603,'54615','Monroe','55081','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31578,'55934','Olmsted','27109','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(53654,'97134','Tillamook','41057','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(48651,'83714','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(12433,'26546','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12341,'26362','Ritchie','54085','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21895,'41093','Lewis','21135','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(13384,'28147','Rowan','37159','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3246,'08732','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(9221,'20520','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(43750,'74865','Pontotoc','40123','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(40108,'68627','Nance','31125','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(18127,'35171','Chilton','1021','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30222,'54026','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(10382,'22940','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5025,'13027','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18609,'36042','Butler','1013','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29534,'52644','Henry','19087','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(34306,'59736','Beaverhead','30001','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45241,'76887','McCulloch','48307','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53385,'96719','Hawaii','15001','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(4961,'12929','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(35725,'61873','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38059,'65333','Pettis','29159','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38775,'66608','Shawnee','20177','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(43592,'74567','Pushmataha','40127','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(44210,'75477','Lamar','48277','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54586,'98668','Clark','53011','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(4550,'12204','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20192,'38451','Maury','47119','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19952,'38071','Tipton','47167','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(29830,'53178','Waukesha','55133','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33599,'58492','Barnes','38003','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(32137,'56377','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(35021,'60952','Livingston','17105','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44033,'75227','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13842,'28636','Iredell','37097','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10615,'23228','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(46936,'79351','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(49000,'84632','Sanpete','49039','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(7623,'17331','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6710,'15775','Cambria','42021','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17405,'33634','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(31920,'56221','Traverse','27155','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(45677,'77502','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(20145,'38363','Decatur','47039','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(49557,'86038','Coconino','4005','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(9059,'20181','Fauquier','51061','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5147,'13148','Wayne','36117','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(39799,'68112','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39811,'68124','Douglas','31055','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(26754,'48626','Saginaw','26145','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49864,'87566','Rio Arriba','35039','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(51278,'92333','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(51947,'93760','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(35953,'62245','Clinton','17027','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(9327,'20657','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(12700,'27248','Randolph','37151','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(20984,'39476','Greene','28041','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(21250,'39897','Grady','13131','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(6652,'15715','Jefferson','42065','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(34564,'60133','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2156,'06064','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(52695,'95458','Lake','6033','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41563,'71409','Rapides','22079','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(22304,'42134','Simpson','21213','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(40428,'68902','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39078,'67062','McPherson','20113','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30805,'54820','Bayfield','55007','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(4717,'12513','Columbia','36021','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(54182,'98114','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(47156,'79744','Pecos','48371','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(46856,'79240','Donley','48129','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44355,'75683','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21317,'40056','Oldham','21185','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(4601,'12303','Schenectady','36093','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(48406,'83277','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46569,'78847','Val Verde','48465','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39876,'68322','Fillmore','31059','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(27451,'49435','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(27833,'49903','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7129,'16501','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54412,'98409','Pierce','53053','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(48459,'83352','Lincoln','16063','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39256,'67423','Ellsworth','20053','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(17602,'33932','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18176,'35226','Jefferson','1073','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(13601,'28398','Duplin','37061','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(7067,'16364','Forest','42053','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27397,'49347','Montcalm','26117','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12724,'27278','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(43935,'75117','Van Zandt','48467','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41013,'70523','Saint Mary','22101','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(9380,'20724','Anne Arundel','24003','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40481,'68950','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(1451,'04284','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(21678,'40588','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24403,'45623','Gallia','39053','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9839,'21720','Washington','24043','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(41613,'71454','Grant','22043','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(14068,'29021','Kershaw','45055','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(37019,'63459','Ralls','29173','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(14459,'29554','Georgetown','45043','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32783,'57326','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34331,'59771','Gallatin','30031','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(37454,'64144','Clay','29047','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(32395,'56668','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31555,'55917','Dodge','27039','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19133,'37012','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15256,'30392','Fulton','13121','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(47582,'80504','Boulder','8013','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39450,'67585','Reno','20155','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(15400,'30533','Dawson','13085','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17738,'34223','Sarasota','12115','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17978,'34995','Martin','12085','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(30586,'54564','Oneida','55085','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(11752,'25201','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(23310,'43933','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(12071,'25849','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3856,'10458','Bronx','36005','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(18292,'35546','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(14209,'29164','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(44925,'76469','Callahan','48059','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33358,'58241','Pembina','38067','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12390,'26437','Marion','54049','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(2861,'07825','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(18497,'35951','DeKalb','1049','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(48164,'82222','Niobrara','56027','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(35471,'61526','Peoria','17143','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(34308,'59740','Madison','30057','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(10695,'23389','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10205,'22577','Westmoreland','51193','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(836,'02644','Barnstable','25001','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52536,'95237','San Joaquin','6077','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(47952,'81151','Rio Grande','8105','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(30997,'55006','Chisago','27025','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30843,'54853','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(55008,'99650','Wade Hampton','2270','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(46556,'78833','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30432,'54442','Lincoln','55069','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(2120,'06021','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(7118,'16435','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(16076,'31626','Brooks','13027','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17464,'33755','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(18790,'36340','Geneva','1061','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(7308,'16845','Clearfield','42033','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4985,'12959','Clinton','36019','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(305,'01222','Berkshire','25003','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(44159,'75437','Hopkins','48223','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42218,'72379','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(28839,'51106','Woodbury','19193','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(10942,'23924','Mecklenburg','51117','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(12459,'26582','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54687,'98953','Yakima','53077','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(7443,'17045','Juniata','42067','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47660,'80645','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(44977,'76526','Coryell','48099','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40579,'69045','Chase','31029','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(39646,'67855','Grant','20067','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37493,'64199','Jackson','29095','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36044,'62323','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30581,'54562','Forest','55041','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(770,'02465','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(47421,'80212','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(7355,'16921','Tioga','42117','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(25771,'47355','Randolph','18135','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23126,'43608','Lucas','39095','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(10425,'22980','Waynesboro City','51820','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(28303,'50369','Polk','19153','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35889,'62083','Christian','17021','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(46316,'78575','Cameron','48061','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47630,'80550','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(13689,'28501','Jones','37103','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(46717,'79057','Collingsworth','48087','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9276,'20591','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(19925,'38048','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(980,'02904','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(6049,'14803','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(258,'01075','Hampden','25013','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(52779,'95589','Mendocino','6045','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50325,'89177','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(16831,'32738','Volusia','12127','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(45268,'76937','Tom Green','48451','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9613,'21139','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(15463,'30572','Union','13291','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(33717,'58638','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12199,'26146','Pleasants','54073','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(54268,'98248','Whatcom','53073','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(44255,'75555','Marion','48315','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43790,'74941','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(41649,'71496','Vernon','22115','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28650,'50669','Tama','19171','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26985,'48862','Gratiot','26057','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(20391,'38654','Marshall','28093','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(11090,'24101','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27445,'49427','Ottawa','26139','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(31793,'56117','Nobles','27105','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34388,'59868','Missoula','30063','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(41017,'70526','Acadia','22001','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(44494,'75928','Newton','48351','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48633,'83677','Valley','16085','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(52686,'95448','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(21752,'40854','Harlan','21095','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20952,'39443','Jasper','28061','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(4130,'11354','Queens','36081','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(5116,'13119','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7354,'16921','Potter','42105','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26734,'48617','Clare','26035','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32337,'56589','Mahnomen','27087','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(32518,'57014','Clay','46027','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(39728,'68025','Dodge','31053','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(14172,'29129','Aiken','45003','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(22138,'41731','Letcher','21133','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19247,'37080','Robertson','47147','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5630,'14058','Genesee','36037','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32037,'56310','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35485,'61535','Tazewell','17179','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(35708,'61856','Champaign','17019','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38453,'65786','Camden','29029','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(41329,'71070','Bienville','22013','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49096,'84781','Washington','49053','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(51421,'92625','Orange','6059','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(8510,'19094','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4347,'11947','Suffolk','36103','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(53915,'97496','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(54477,'98537','Pacific','53049','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25302,'46789','Lagrange','18087','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20838,'39286','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18595,'36034','Crenshaw','1041','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(29993,'53565','Lafayette','55065','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(51842,'93612','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13319,'28090','Cleveland','37045','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(23034,'43502','Henry','39069','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(19430,'37309','Polk','47139','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6240,'15072','Westmoreland','42129','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(14153,'29113','Orangeburg','45075','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(32542,'57029','Hutchinson','46067','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(1403,'04212','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(18060,'35082','Clay','1027','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(47938,'81138','Costilla','8023','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(1302,'03905','York','23031','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(28876,'51248','Obrien','19141','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(33243,'58045','Traill','38097','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(41121,'70651','Allen','22003','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36324,'62624','Fulton','17057','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33332,'58224','Nelson','38063','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(2979,'08032','Gloucester','34015','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(35885,'62082','Greene','17061','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50304,'89149','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49959,'88028','Grant','35017','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(29139,'52053','Clayton','19043','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(3272,'08804','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(25261,'46763','Noble','18113','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(8121,'18347','Monroe','42089','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(12414,'26506','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(38508,'66026','Miami','20121','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(31952,'56244','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(27499,'49516','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25789,'47362','Wayne','18177','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(46977,'79381','Lynn','48305','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43289,'74032','Noble','40103','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(34251,'59604','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3750,'10112','New York','36061','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(8698,'19454','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50297,'89142','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(48384,'83243','Oneida','16071','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(46183,'78339','Nueces','48355','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(39760,'68048','Cass','31025','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(32088,'56342','Aitkin','27001','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(10652,'23288','Henrico','51087','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30365,'54306','Brown','55009','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31240,'55362','Wright','27171','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(48378,'83236','Bingham','16011','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(13009,'27629','Wake','37183','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(38581,'66094','Doniphan','20043','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(29733,'53074','Ozaukee','55089','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(19868,'37939','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(17398,'33624','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(513,'01831','Essex','25009','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(46850,'79235','Floyd','48153','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(36185,'62452','Richland','17159','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(26157,'47918','Fountain','18045','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15037,'30182','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(13789,'28589','Carteret','37031','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(52565,'95311','Mariposa','6043','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48860,'84116','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(10125,'22438','Caroline','51033','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(41534,'71358','Saint Landry','22097','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43032,'73558','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46223,'78381','Aransas','48007','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(40274,'68771','Pierce','31139','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(35876,'62077','Montgomery','17135','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(12513,'26705','Preston','54077','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(15588,'30708','Murray','13213','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(2102,'05875','Orleans','50019','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(34056,'59259','Dawson','30021','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(17895,'34713','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(23161,'43718','Belmont','39013','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(16239,'31801','Muscogee','13215','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(36202,'62466','Lawrence','17101','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(40435,'68925','Adams','31001','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(501,'01803','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32057,'56325','Stearns','27145','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(31893,'56207','Stevens','27149','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(19082,'36854','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(30583,'54562','Vilas','55125','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27491,'49506','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(12807,'27360','Davidson','37057','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10263,'22711','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8218,'18503','Lackawanna','42069','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(54971,'99609','Bethel','2050','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(49137,'85036','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(43733,'74856','Murray','40099','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42244,'72411','Craighead','5031','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34877,'60606','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(31623,'55967','Fillmore','27045','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(24495,'45710','Athens','39009','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24444,'45660','Pike','39131','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(14618,'29686','Oconee','45073','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(3552,'09617','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(49141,'85040','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(37349,'64024','Livingston','29117','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33908,'59012','Rosebud','30087','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29492,'52586','Mahaska','19123','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(26784,'48652','Bay','26017','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18283,'35540','Winston','1133','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(9623,'21156','Baltimore','24005','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(49334,'85362','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(40353,'68834','Custer','31041','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(30849,'54858','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(20531,'38855','Itawamba','28057','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(22238,'42049','Calloway','21035','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(25774,'47356','Henry','18065','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(48982,'84601','Utah','49049','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(9435,'20788','Prince Georges','24033','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(42501,'72703','Washington','5143','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(38856,'66762','Cherokee','20021','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(51163,'92166','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(34250,'59602','Lewis and Clark','30049','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(3625,'09780','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(9153,'20392','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(11059,'24067','Franklin','51067','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(51615,'93210','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(20629,'38957','Tallahatchie','28135','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(48838,'84092','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(45729,'77561','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(38274,'65644','Webster','29225','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38846,'66756','Crawford','20037','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(40304,'68789','Knox','31107','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41059,'70569','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(21483,'40313','Rowan','21205','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(19061,'36801','Chambers','1017','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(51199,'92226','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(38007,'65264','Callaway','29027','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48944,'84402','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29941,'53526','Iowa','55049','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16964,'32936','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(25030,'46327','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(5421,'13670','Saint Lawrence','36089','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(22829,'43153','Greene','39057','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(52132,'94273','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44629,'76066','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42177,'72340','Saint Francis','5123','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34957,'60707','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(33485,'58381','Eddy','38027','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(31987,'56273','Kandiyohi','27067','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(30726,'54740','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(27251,'49239','Hillsdale','26059','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11319,'24439','Rockbridge','51163','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(32336,'56589','Becker','27005','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33500,'58413','McPherson','46089','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35269,'61321','Woodford','17203','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38043,'65322','Saline','29195','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(38584,'66095','Franklin','20059','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22720,'43064','Madison','39097','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(13788,'28587','Pamlico','37137','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(41466,'71273','Lincoln','22061','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(6247,'15082','Allegheny','42003','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21944,'41173','Carter','21043','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(22483,'42441','Hopkins','21107','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(23701,'44491','Portage','39133','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6832,'16017','Butler','42019','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(18397,'35654','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(418,'01525','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(20303,'38577','Fentress','47049','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(35658,'61814','Vermilion','17183','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(32376,'56649','Koochiching','27071','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(50606,'90296','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(11109,'24122','Bedford','51019','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47628,'80549','Weld','8123','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(8318,'18818','Susquehanna','42115','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(8507,'19091','Delaware','42045','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(26920,'48821','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36321,'62621','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(47195,'79788','Ward','48475','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47143,'79721','Howard','48227','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(30963,'54967','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(39875,'68321','Nemaha','31127','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41207,'70777','East Feliciana','22037','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43073,'73646','Dewey','40043','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(53171,'96124','Sierra','6091','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(22223,'42038','Lyon','21143','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21081,'39652','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(9827,'21705','Frederick','24021','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(18735,'36271','Calhoun','1015','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(37179,'63742','Scott','29201','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(40546,'69025','Frontier','31063','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(53730,'97290','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(46564,'78840','Edwards','48137','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(33642,'58545','Oliver','38065','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(53363,'96681','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(40518,'68978','Nuckolls','31129','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(41673,'71643','Desha','5041','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(46088,'78205','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(12382,'26426','Doddridge','54017','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3621,'09759','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(16504,'32244','Duval','12031','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40087,'68531','Lancaster','31109','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(46119,'78235','Bexar','48029','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41965,'72055','Jefferson','5069','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(34108,'59338','Prairie','30079','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(30616,'54624','Crawford','55023','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(438,'01562','Worcester','25027','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(12024,'25720','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4571,'12232','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(29630,'52802','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35455,'61490','Henry','17073','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(54638,'98849','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(36492,'62836','Jefferson','17081','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(11634,'25009','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7463,'17061','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30103,'53901','Columbia','55021','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(38373,'65728','Christian','29043','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(48344,'83126','Lincoln','56023','WY','Wyoming',0,'2013-07-03 15:17:53',NULL,NULL),(51104,'92091','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1384,'04097','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(4631,'12421','Delaware','36025','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(33416,'58324','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40295,'68785','Dakota','31043','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(540,'01886','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(23885,'44816','Erie','39043','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(6520,'15533','Bedford','42009','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(28468,'50544','Webster','19187','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(30270,'54136','Outagamie','55087','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(31378,'55554','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(46591,'78932','Fayette','48149','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(43317,'74050','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(39628,'67844','Clark','20025','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(22398,'42303','Daviess','21059','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(1057,'03220','Merrimack','33013','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(35763,'61929','Moultrie','17139','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(8449,'19030','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(44953,'76491','Throckmorton','48447','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31763,'56085','Redwood','27127','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(10122,'22436','Essex','51057','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(20808,'39194','Yazoo','28163','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(12523,'26717','Mineral','54057','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24520,'45732','Morgan','39115','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(24885,'46156','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23886,'44817','Hancock','39063','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(43105,'73669','Custer','40039','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(16215,'31787','Sumter','13261','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(10840,'23805','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8643,'19363','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(19399,'37220','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(31864,'56167','Jackson','27063','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(13499,'28312','Cumberland','37051','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(51984,'93928','Monterey','6053','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50525,'90067','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(24949,'46220','Marion','18097','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1246,'03835','Strafford','33017','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(28880,'51250','Sioux','19167','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(37793,'64833','Jasper','29097','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(5334,'13485','Madison','36053','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7871,'17870','Snyder','42109','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(5553,'13850','Broome','36007','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50786,'91199','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(43803,'74955','Sequoyah','40135','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(33401,'58310','Towner','38095','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30973,'54977','Portage','55097','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36369,'62668','Morgan','17137','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44227,'75490','Fannin','48147','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45537,'77372','Liberty','48291','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(22916,'43323','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3477,'09403','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(53896,'97473','Douglas','41019','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(24853,'46130','Hancock','18059','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25065,'46377','Lake','18089','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14812,'30017','Gwinnett','13135','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(16978,'32957','Indian River','12061','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(12080,'25864','Raleigh','54081','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(945,'02859','Providence','44007','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(31541,'55815','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34745,'60468','Will','17197','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(36451,'62808','Washington','17189','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(43444,'74339','Ottawa','40115','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(7028,'16327','Crawford','42039','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(6894,'16107','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21024,'39558','Hancock','28045','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(13860,'28646','Avery','37011','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1747,'04940','Franklin','23007','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(15998,'31523','Glynn','13127','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(30033,'53594','Jefferson','55055','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(26993,'48872','Ingham','26065','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10908,'23887','Brunswick','51025','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(17471,'33762','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(17381,'33607','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(16860,'32776','Lake','12069','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(34138,'59412','Cascade','30013','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(45257,'76930','Crockett','48105','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53354,'96670','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(39148,'67144','Butler','20015','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14132,'29080','Lee','45061','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10026,'22158','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(13988,'28758','Henderson','37089','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(36092,'62367','Hancock','17067','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(30850,'54859','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(9108,'20237','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(7359,'16926','Bradford','42015','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(27520,'49611','Antrim','26009','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(18337,'35579','Walker','1127','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(3062,'08203','Atlantic','34001','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23166,'43722','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(26560,'48360','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7015,'16313','Warren','42123','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(53230,'96284','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(49572,'86304','Yavapai','4025','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(31446,'55711','Saint Louis','27137','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26421,'48168','Oakland','26125','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(19733,'37807','Union','47173','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(5827,'14480','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(7121,'16438','Erie','42049','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29673,'53021','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(37205,'63775','Perry','29157','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(44289,'75605','Upshur','48459','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(11589,'24910','Summers','54089','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(25693,'47270','Jefferson','18077','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(20852,'39320','Kemper','28069','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(3450,'09348','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(43411,'74152','Tulsa','40143','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(32431,'56720','Kittson','27069','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(54640,'98851','Grant','53025','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(52172,'94505','Alameda','6001','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(45623,'77458','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(29226,'52201','Washington','19183','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(24858,'46133','Rush','18139','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(24200,'45304','Preble','39135','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11014,'24019','Roanoke','51161','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49420,'85631','Pinal','4021','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(29912,'53507','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(36968,'63389','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(7638,'17350','Adams','42001','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15696,'30914','Richmond','13245','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(19749,'37821','Jefferson','47089','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19759,'37830','Knox','47093','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(15824,'31066','Monroe','13207','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1260,'03849','Carroll','33003','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(30071,'53792','Dane','55025','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(53891,'97466','Coos','41011','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(50702,'90746','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(41397,'71210','Ouachita','22073','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(36469,'62822','Franklin','17055','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16312,'32008','Suwannee','12121','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22531,'42544','Casey','21045','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(30008,'53576','Rock','55105','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33156,'57756','Shannon','46113','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(33531,'58439','Dickey','38021','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(34211,'59484','Toole','30101','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(34341,'59820','Mineral','30061','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(52947,'95837','Sacramento','6067','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(30740,'54750','Pierce','55093','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(21090,'39657','Pike','28113','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(42938,'73443','Carter','40019','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42866,'73136','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(1690,'04777','Penobscot','23019','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(33369,'58258','Grand Forks','38035','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(40056,'68464','Saline','31151','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(45830,'77833','Washington','48477','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(21842,'41034','Mason','21161','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(9173,'20416','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:51',NULL,NULL),(26664,'48461','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6073,'14821','Steuben','36101','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10017,'22124','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(4207,'11553','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(32701,'57248','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(43994,'75169','Hunt','48231','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54127,'98038','King','53033','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(41233,'70813','East Baton Rouge','22033','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(28884,'51333','Dickinson','19059','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(27680,'49743','Presque Isle','26141','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(7529,'17128','Dauphin','42043','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(29441,'52552','Wapello','19179','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(35661,'61816','Douglas','17041','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2408,'06514','Middlesex','9007','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(26454,'48201','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26567,'48371','Lapeer','26087','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(33155,'57755','Harding','46063','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(17527,'33844','Polk','12105','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13151,'27880','Wilson','37195','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(49052,'84732','Piute','49031','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(37583,'64491','Atchison','29005','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(33929,'59033','Sweet Grass','30097','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(29500,'52594','Appanoose','19007','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20135,'38356','Madison','47113','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22623,'42759','Cumberland','21057','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24637,'45846','Mercer','39107','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(8693,'19444','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(45631,'77465','Matagorda','48321','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(44470,'75855','Leon','48289','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41348,'71103','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38723,'66523','Osage','20139','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32781,'57325','Brule','46015','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(28090,'50153','Jasper','19099','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(5193,'13250','Onondaga','36067','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(1424,'04241','Androscoggin','23001','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(622,'02108','Suffolk','25025','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(2172,'06079','Litchfield','9005','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19113,'36879','Lee','1081','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(19445,'37323','Bradley','47011','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(40188,'68714','Rock','31149','NE','Nebraska',0,'2013-07-03 15:17:53',NULL,NULL),(52333,'94923','Sonoma','6097','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(27832,'49902','Iron','26071','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25896,'47469','Martin','18101','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(1463,'04333','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(5828,'14481','Livingston','36051','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10298,'22740','Madison','51113','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16855,'32771','Seminole','12117','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(13260,'28021','Gaston','37071','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(39506,'67651','Osborne','20141','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44641,'76082','Parker','48367','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(32933,'57455','Potter','46107','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(26950,'48838','Kent','26081','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(5350,'13503','Oneida','36065','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(12751,'27302','Orange','37135','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(5,'00603','Aguadilla','72005','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(44165,'75441','Delta','48119','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31427,'55606','Cook','27031','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(26803,'48670','Midland','26111','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(6198,'15027','Beaver','42007','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(1982,'05655','Lamoille','50015','VT','Vermont',0,'2013-07-03 15:17:51',NULL,NULL),(12759,'27312','Alamance','37001','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(14699,'29832','Saluda','45081','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(54325,'98315','Kitsap','53035','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(25136,'46542','Elkhart','18039','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(23498,'44149','Medina','39103','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(34435,'60007','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(50038,'88240','Gaines','48165','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(34886,'60615','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(28896,'51346','Clay','19041','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(2702,'07420','Passaic','34031','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3168,'08520','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(23340,'43970','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(11848,'25357','Kanawha','54039','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39691,'67905','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(27874,'49962','Baraga','26013','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(1370,'04082','Cumberland','23005','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(44557,'76002','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(41506,'71327','Avoyelles','22009','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(27974,'50061','Warren','19181','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(16631,'32442','Jackson','12063','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19565,'37407','Hamilton','47065','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(22966,'43359','Wyandot','39175','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22769,'43109','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(53500,'96854','Honolulu','15003','HI','Hawaii',0,'2013-07-03 15:17:54',NULL,NULL),(39653,'67861','Greeley','20071','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37705,'64720','Bates','29013','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(34581,'60144','Kane','17089','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(15489,'30607','Clarke','13059','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(22457,'42376','McLean','21149','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(15827,'31068','Schley','13249','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(43816,'74965','Adair','40001','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(42768,'73054','Oklahoma','40109','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31492,'55757','Carlton','27017','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(17869,'34660','Pinellas','12103','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(2273,'06262','Windham','9015','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(47360,'80111','Denver','8031','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(12036,'25771','Cabell','54011','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(19892,'38017','Fayette','47047','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21435,'40241','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(24471,'45684','Scioto','39145','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23179,'43732','Guernsey','39059','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(3664,'09841','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(3251,'08738','Ocean','34029','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(4684,'12473','Greene','36039','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(9877,'21776','Carroll','24013','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(10294,'22737','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10736,'23442','Accomack','51001','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(21241,'39867','Randolph','13243','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(37502,'64427','Andrew','29003','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(36229,'62501','Macon','17115','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(2878,'07842','Morris','34027','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(12169,'26060','Ohio','54069','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(5863,'14518','Ontario','36069','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16190,'31772','Worth','13321','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(42385,'72556','Izard','5065','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(2817,'07723','Monmouth','34025','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29604,'52758','Scott','19163','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(25909,'47515','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(33664,'58565','McLean','38055','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35950,'62242','Randolph','17157','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(37208,'63780','Cape Girardeau','29031','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(42490,'72682','Marion','5089','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(14220,'29178','Union','45087','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1508,'04429','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(2865,'07829','Warren','34041','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(3521,'09569','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(13204,'27938','Gates','37073','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(29663,'53015','Sheboygan','55117','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(12416,'26508','Monongalia','54061','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(30981,'54981','Waushara','55137','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16759,'32641','Alachua','12001','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(21664,'40544','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(8624,'19343','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(17359,'33579','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(27786,'49854','Delta','26041','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(32269,'56537','Grant','27051','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(49701,'87047','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(27175,'49081','Kalamazoo','26077','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(25745,'47338','Blackford','18009','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(43839,'75024','Collin','48085','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48012,'81329','La Plata','8067','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(46049,'78130','Hays','48209','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(45666,'77493','Fort Bend','48157','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(17703,'34135','Lee','12071','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(40998,'70513','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(48887,'84150','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(53702,'97225','Washington','41067','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(17367,'33594','Hillsborough','12057','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(8356,'18910','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(9057,'20178','Loudoun','51107','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(35805,'62012','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(4839,'12762','Sullivan','36105','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(6461,'15436','Fayette','42051','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50156,'88554','El Paso','48141','TX','Texas',0,'2013-07-03 15:17:54',NULL,NULL),(25934,'47541','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(9469,'20851','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(21662,'40533','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21027,'39562','Jackson','28059','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(44469,'75855','Freestone','48161','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(10809,'23665','Hampton City','51650','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10013,'22118','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(16306,'32004','Saint Johns','12109','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(10866,'23842','Prince George','51149','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(9297,'20615','Calvert','24009','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(40935,'70427','Washington','22117','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(49484,'85737','Pima','4019','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(25635,'47175','Orange','18117','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4018,'10965','Bergen','34003','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(8395,'18953','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7687,'17527','Chester','42029','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15430,'30548','Jackson','13157','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(12927,'27559','Chatham','37037','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1655,'04732','Aroostook','23003','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(22972,'43407','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(42208,'72369','Phillips','5107','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(45561,'77393','Montgomery','48339','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47705,'80745','Logan','8075','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(49997,'88112','Curry','35009','NM','New Mexico',0,'2013-07-03 15:17:54',NULL,NULL),(51945,'93750','Fresno','6019','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(54818,'99202','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(26590,'48415','Genesee','26049','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(22056,'41537','Pike','21195','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20797,'39189','Leake','28079','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(32428,'56715','Red Lake','27125','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(51252,'92305','San Bernardino','6071','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(18059,'35080','Shelby','1117','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(20188,'38449','Giles','47055','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19727,'37803','Blount','47009','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(54699,'99009','Spokane','53063','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(51385,'92570','Riverside','6065','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(33723,'58641','Stark','38089','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(19485,'37349','Coffee','47031','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(19040,'36769','Wilcox','1131','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(31309,'55411','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(8064,'18231','Schuylkill','42107','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(32589,'57054','Kingsbury','46077','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(42962,'73460','Johnston','40069','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(45305,'77019','Harris','48201','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(9816,'21675','Dorchester','24019','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(27741,'49799','Cheboygan','26031','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(36074,'62353','Brown','17009','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44832,'76374','Throckmorton','48447','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(48846,'84102','Salt Lake','49035','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(52084,'94147','San Francisco','6075','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(1141,'03450','Cheshire','33005','NH','New Hampshire',0,'2013-07-03 15:17:51',NULL,NULL),(8723,'19490','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7480,'17073','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(7022,'16319','Clarion','42031','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46340,'78604','Gonzales','48177','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54625,'98833','Okanogan','53047','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(55134,'99789','North Slope','2185','AK','Alaska',0,'2013-07-03 15:17:54',NULL,NULL),(43429,'74330','Craig','40035','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(51731,'93430','San Luis Obispo','6079','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(13458,'28262','Mecklenburg','37119','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(6397,'15334','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(21452,'40266','Jefferson','21111','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29740,'53079','Fond du Lac','55039','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(29748,'53088','Calumet','55015','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32499,'56972','District of Columbia','11001','DC','District of Columbia',0,'2013-07-03 15:17:53',NULL,NULL),(54035,'97838','Umatilla','41059','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(16602,'32421','Calhoun','12013','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(22142,'41739','Perry','21193','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21650,'40514','Fayette','21067','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(20685,'39072','Hinds','28049','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(19943,'38063','Lauderdale','47097','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(28914,'51365','Emmet','19063','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(45825,'77808','Robertson','48395','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53828,'97394','Lincoln','41041','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(18524,'35967','Cherokee','1019','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(4938,'12886','Warren','36113','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(16150,'31721','Terrell','13273','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(17032,'33043','Monroe','12087','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(28170,'50230','Hardin','19083','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(7851,'17846','Columbia','42037','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(47739,'80821','Lincoln','8073','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(41458,'71266','West Carroll','22123','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(39173,'67208','Sedgwick','20173','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(32903,'57434','Spink','46115','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(30886,'54906','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(14404,'29475','Colleton','45029','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(1767,'04963','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(20686,'39073','Rankin','28121','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(31725,'56058','Nicollet','27103','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(33022,'57560','Jackson','46071','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(12362,'26405','Barbour','54001','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(47446,'80231','Arapahoe','8005','CO','Colorado',0,'2013-07-03 15:17:53',NULL,NULL),(39411,'67559','Rush','20165','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(30791,'54810','Polk','55095','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(1538,'04472','Hancock','23009','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(11904,'25508','Boone','54005','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(52260,'94589','Solano','6095','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(7325,'16864','Centre','42027','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(51136,'92130','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(48798,'84054','Davis','49011','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(43272,'74019','Rogers','40131','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(27483,'49464','Allegan','26005','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(11118,'24130','Botetourt','51023','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(8714,'19474','Montgomery','42091','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(4109,'11230','Kings','36047','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(10077,'22303','Fairfax','51059','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(49785,'87325','McKinley','35031','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(8757,'19534','Berks','42011','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(15452,'30564','Lumpkin','13187','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(41388,'71165','Caddo','22017','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(43726,'74852','Cleveland','40027','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(31370,'55485','Hennepin','27053','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(41020,'70528','Iberia','22045','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(25908,'47514','Perry','18123','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(14310,'29372','Spartanburg','45083','SC','South Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(34638,'60193','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(42586,'72832','Johnson','5071','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(42769,'73055','Comanche','40031','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(46862,'79244','Motley','48345','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(15036,'30180','Paulding','13223','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(1477,'04352','Kennebec','23011','ME','Maine',0,'2013-07-03 15:17:51',NULL,NULL),(29877,'53226','Milwaukee','55079','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(32967,'57476','Hand','46059','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(10259,'22701','Culpeper','51047','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10752,'23462','Virginia Beach City','51810','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(3515,'09557','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(36966,'63387','Lincoln','29113','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(8561,'19145','Philadelphia','42101','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(46535,'78764','Travis','48453','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(23877,'44811','Huron','39077','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(22163,'41777','Leslie','21131','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(29333,'52320','Jones','19105','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(44745,'76234','Denton','48121','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(47171,'79761','Ector','48135','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(54718,'99026','Stevens','53065','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(38398,'65744','Taney','29213','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(4556,'12210','Albany','36001','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(20851,'39309','Lauderdale','28075','MS','Mississippi',0,'2013-07-03 15:17:52',NULL,NULL),(18947,'36584','Washington','1129','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(2980,'08033','Camden','34007','NJ','New Jersey',0,'2013-07-03 15:17:51',NULL,NULL),(29215,'52168','Winneshiek','19191','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(38948,'66933','Riley','20161','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(44211,'75478','Franklin','48159','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(13263,'28024','Rutherford','37161','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(15782,'31038','Putnam','13237','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(8003,'18067','Northampton','42095','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(31387,'55566','Carver','27019','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(34362,'59840','Ravalli','30081','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(51004,'91902','San Diego','6073','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(15066,'30219','Heard','13149','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(72,'00726','Caguas','72025','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(11559,'24857','Wyoming','54109','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(10115,'22430','Stafford','51179','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(27173,'49080','Barry','26015','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(30897,'54915','Winnebago','55139','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(33197,'57793','Meade','46093','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(22884,'43268','Franklin','39049','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(51544,'93002','Ventura','6111','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(50316,'89161','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(49392,'85603','Cochise','4003','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(26496,'48243','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(26401,'48150','Wayne','26163','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(10093,'22320','Alexandria City','51510','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(964,'02883','Washington','44009','RI','Rhode Island',0,'2013-07-03 15:17:51',NULL,NULL),(48380,'83238','Bear Lake','16007','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48918,'84317','Weber','49057','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(21528,'40360','Bath','21011','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(18330,'35576','Lamar','1075','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(46422,'78654','Burnet','48053','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(31769,'56090','Blue Earth','27013','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15432,'30552','Rabun','13241','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(31064,'55060','Steele','27147','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(15784,'31040','Laurens','13175','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(5890,'14541','Seneca','36099','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(34609,'60169','Cook','17031','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38729,'66527','Brown','20013','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(39671,'67870','Seward','20175','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(10524,'23113','Powhatan','51145','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(7725,'17575','Lancaster','42071','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(30832,'54842','Douglas','55031','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(49220,'85206','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(49271,'85285','Maricopa','4013','AZ','Arizona',0,'2013-07-03 15:17:53',NULL,NULL),(50293,'89138','Clark','32003','NV','Nevada',0,'2013-07-03 15:17:54',NULL,NULL),(12290,'26276','Tucker','54093','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(48695,'83826','Boundary','16021','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(48642,'83704','Ada','16001','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(39551,'67733','Sherman','20181','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(37378,'64062','Ray','29177','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(764,'02458','Middlesex','25017','MA','Massachusetts',0,'2013-07-03 15:17:51',NULL,NULL),(32990,'57532','Stanley','46117','SD','South Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(35946,'62239','Saint Clair','17163','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(52987,'95927','Butte','6007','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(53719,'97258','Multnomah','41051','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(171,'00952','Toa Baja','72137','PR','Puerto Rico',0,'2013-07-03 15:17:51',NULL,NULL),(24107,'45167','Brown','39015','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(20262,'38547','Smith','47159','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(18339,'35581','Franklin','1059','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(43800,'74951','Le Flore','40079','OK','Oklahoma',0,'2013-07-03 15:17:53',NULL,NULL),(48831,'84085','Uintah','49047','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(54288,'98271','Snohomish','53061','WA','Washington',0,'2013-07-03 15:17:54',NULL,NULL),(14926,'30103','Gordon','13129','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(34857,'60563','Du Page','17043','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(16951,'32912','Brevard','12009','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(11019,'24023','Roanoke City','51770','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(31444,'55709','Itasca','27061','MN','Minnesota',0,'2013-07-03 15:17:52',NULL,NULL),(35426,'61473','Warren','17187','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(38717,'66518','Marshall','20117','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(54023,'97825','Grant','41023','OR','Oregon',0,'2013-07-03 15:17:54',NULL,NULL),(15365,'30513','Gilmer','13123','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(49089,'84772','Iron','49021','UT','Utah',0,'2013-07-03 15:17:53',NULL,NULL),(29935,'53522','Green','55045','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(16649,'32461','Walton','12131','FL','Florida',0,'2013-07-03 15:17:52',NULL,NULL),(19287,'37118','Rutherford','47149','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(25999,'47618','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(41306,'71050','De Soto','22031','LA','Louisiana',0,'2013-07-03 15:17:53',NULL,NULL),(38787,'66617','Jefferson','20087','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(38478,'65899','Greene','29077','MO','Missouri',0,'2013-07-03 15:17:53',NULL,NULL),(21682,'40601','Franklin','21073','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(21558,'40387','Menifee','21165','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(14941,'30110','Carroll','13045','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(28763,'51020','Ida','19093','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(32611,'57068','Rock','27133','MN','Minnesota',0,'2013-07-03 15:17:53',NULL,NULL),(33728,'58644','Dunn','38025','ND','North Dakota',0,'2013-07-03 15:17:53',NULL,NULL),(38687,'66439','Jackson','20085','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(14947,'30114','Cherokee','13057','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(26042,'47715','Vanderburgh','18163','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(25473,'46982','Fulton','18049','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(15628,'30750','Walker','13295','GA','Georgia',0,'2013-07-03 15:17:52',NULL,NULL),(48508,'83451','Fremont','16043','ID','Idaho',0,'2013-07-03 15:17:53',NULL,NULL),(30772,'54767','Saint Croix','55109','WI','Wisconsin',0,'2013-07-03 15:17:52',NULL,NULL),(28094,'50154','Story','19169','IA','Iowa',0,'2013-07-03 15:17:52',NULL,NULL),(20172,'38387','Benton','47005','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(21292,'40037','Marion','21155','KY','Kentucky',0,'2013-07-03 15:17:52',NULL,NULL),(34158,'59430','Judith Basin','30045','MT','Montana',0,'2013-07-03 15:17:53',NULL,NULL),(44684,'76124','Tarrant','48439','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(53267,'96382','None','0','AP','',0,'2013-07-03 15:17:54',NULL,NULL),(8376,'18930','Bucks','42017','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(10217,'22610','Page','51139','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(42235,'72396','Cross','5037','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(39571,'67745','Cheyenne','20023','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(12145,'26003','Brooke','54009','WV','West Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(24615,'45833','Van Wert','39161','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(9470,'20852','Montgomery','24031','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(19162,'37030','Jackson','47087','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(6390,'15329','Greene','42059','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(50571,'90233','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(44250,'75550','Red River','48387','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(42674,'72952','Crawford','5033','AR','Arkansas',0,'2013-07-03 15:17:53',NULL,NULL),(18883,'36503','Escambia','1053','AL','Alabama',0,'2013-07-03 15:17:52',NULL,NULL),(12694,'27242','Moore','37125','NC','North Carolina',0,'2013-07-03 15:17:52',NULL,NULL),(10369,'22923','Greene','51079','VA','Virginia',0,'2013-07-03 15:17:51',NULL,NULL),(39379,'67526','Rice','20159','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL),(6949,'16160','Lawrence','42073','PA','Pennsylvania',0,'2013-07-03 15:17:51',NULL,NULL),(23333,'43953','Jefferson','39081','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(23367,'44010','Ashtabula','39007','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(25143,'46546','St Joseph','18141','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(4213,'11559','Nassau','36059','NY','New York',0,'2013-07-03 15:17:51',NULL,NULL),(50582,'90254','Los Angeles','6037','CA','California',0,'2013-07-03 15:17:54',NULL,NULL),(9757,'21612','Talbot','24041','MD','Maryland',0,'2013-07-03 15:17:51',NULL,NULL),(25927,'47532','Dubois','18037','IN','Indiana',0,'2013-07-03 15:17:52',NULL,NULL),(2216,'06133','Hartford','9003','CT','Connecticut',0,'2013-07-03 15:17:51',NULL,NULL),(19387,'37209','Davidson','47037','TN','Tennessee',0,'2013-07-03 15:17:52',NULL,NULL),(27820,'49886','Menominee','26109','MI','Michigan',0,'2013-07-03 15:17:52',NULL,NULL),(49760,'87191','Bernalillo','35001','NM','New Mexico',0,'2013-07-03 15:17:53',NULL,NULL),(3539,'09594','None','0','AE','',0,'2013-07-03 15:17:51',NULL,NULL),(23030,'43469','Sandusky','39143','OH','Ohio',0,'2013-07-03 15:17:52',NULL,NULL),(36490,'62836','Adams','17001','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(44074,'75285','Dallas','48113','TX','Texas',0,'2013-07-03 15:17:53',NULL,NULL),(35860,'62063','Jersey','17083','IL','Illinois',0,'2013-07-03 15:17:53',NULL,NULL),(39552,'67734','Rawlins','20153','KS','Kansas',0,'2013-07-03 15:17:53',NULL,NULL);
/*!40000 ALTER TABLE `ZipCodeMultiCounty` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2014-03-11  9:29:26
